# S1-Mod

[![discord](https://img.shields.io/badge/Repackers-_Disocrd-blue)](https://discord.com/invite/YcZv2Stt2w)
[![website](https://img.shields.io/badge/Repackers-_Website-green)](https://rimmyscorner.com/)

[![website](https://img.shields.io/badge/Alterware-_Website-red)](https://alterware.dev/)

<p align="center">
  <img alig src="assets/gitea/banner-s1x.png?raw=true"/>
</p>

## Download
Clone the Git repository or download as ZIP.

- <u>**Download Release (EASIEST)**</u>
  - Click on `Releases` at the top and navigate to the latest release
  - Download `s1-mod.zip`
  - If you plan on running a server, download `S1ServerConfigs.zip`

- <u>**Download ZIP**</u>
  - Click on the three dots at the top of the repo ( `◘◘◘` )
  - Click `Download ZIP`

- <u>**Clone the repository:**</u>
  - Open a terminal or command prompt.
  - Run the following command:
    ```
    git clone http://git.rimmyscorner.com/Ahrimdon/s1-mod.git
    ```

## Installation

1. Extract the file contents of `s1-mod.zip` into your Call of Duty Ghosts installation folder.
2. Launch `s1-mod`.
   > **Note**: The executable and any accompanying folders should be in the base game directory.

## Repository Contents
- S1-Mod
- Required Files
- Dedicated Server Configs

## Getting Game Files

- You can download the `Call of Duty: Advanced Warfare` game files directly or torrent them [here](http://git.rimmyscorner.com/Ahrimdon/cod-games-download/releases/tag/v1.0.0).

## Installing Git (Optional)

If you don't have `git` installed on your machine, follow these steps:

1. Visit the [Git download page](https://git-scm.com/downloads).
2. Download the appropriate version for your operating system.
3. Run the installer.
   - During the installation, you will be asked if you want to add Git to your system's PATH environment variable. Ensure you choose the option to do so. This allows you to use Git from the command line without specifying its full path.
4. After installation, open a terminal or command prompt and type `git --version` to ensure Git is correctly installed.

## Setting Up a Server

### <u>Regular Server</u>

<u>**Guide 1** (AlterWare)</u>

You will need the following:
* The [Visual C++ 2010 Redistributable Package](https://www.microsoft.com/en-us/download/details.aspx?id=5555) and the [Visual C++ 2015-2019 Redistributable Package](https://aka.ms/vs/16/release/vc_redist.x86.exe).
* [Visual Code](https://code.visualstudio.com/), [Notepad++](https://notepad-plus-plus.org/) or [Sublime Text](https://www.sublimetext.com/) (You may use whatever editor you choose but we don't recommend Windows Notepad).
* Computer or VPS that's online 24/7 with a decent connection that has average or above specs (We strongly advise a VPS).
* Some technical knowledge/background knowledge of computers.
* An original copy of the game. You can buy it on Steam @ https://store.steampowered.com/app/209650/Call_of_Duty_Advanced_Warfare__Gold_Edition/

Server setup:
1. Install the S1 Client distributed by the launcher. [Download](https://git.rimmyscorner.com/Parasyn/s1-mod/releases/download/v1.0.0/s1-mod.zip) it and place it into your server folder. Then run it so it automatically downloads the client files.
2. Download the [Server Configurations](https://git.rimmyscorner.com/Parasyn/s1-mod/releases/download/v1.0.0/S1ServerConfigs.zip), and place the files in the server folder.
3. Carefully review and edit the configuration settings file to your liking. Give it a hostname, gametype, and remove or add the maps you want, etc.
4. Save the server.cfg file you just edited after you are done.
5. Forward the TCP and UDP port (27016). If you changed the default port or are adding another server, you may need to open the following additional ports: 27017, 21018, etc. This step is not required on a dedicated server or VPS.
6. Run the "start bat" file for the server you want and it shall open.

<u>**Guide 2** (ReactionGaming)</u>

Requirements​:
* The Visual C++ 2010 Redistributable Package and The Visual C++ 2015-2019 Redistributable Package (These are included in the S1 Dedicated Server torrent linked below)
* Visual Code, Notepad++ or Sublime Text - (You may use whatever editor you choose but we don't recommend Windows Notepad)
* S1 Dedicated Server Full - (Streamlined version of S1 with unused files removed to reduce overall size)
* Torrent client (qBittorrent is recommended)
* Computer or VPS that's online 24/7 with a decent connection that has average or above specs (We strongly advise a VPS)
* Some technical knowledge / background knowledge of computers

Server Setup​:
1. Download the S1 Dedicated Server Full torrent (See Requirements Section) and place it in a location of your choosing on your VPS or PC
2. Download the alterware-launcher.exe and place exe into your base game server folder
3. Download S1ServerConfigs.zip and extract them the same way you download alterware-launcher.exe
4. Carefully review and edit the configuration settings file to your liking. Give it a hostname, gametype, and remove/add maps that you want on the rotate.
5. Save the server.cfg file you just edit after you are done.
6. Forward the TCP and UDP port (27016). If you changed the default port or add a server you may need to open additional ports (27017, 21018, etc.)
7. Run the DedicatedServer.bat and the server should begin to load.

## Disclaimer

This software has been created purely for the purposes of
academic research. It is not intended to be used to attack
other systems. Project maintainers are not responsible or
liable for misuse of the software. Use responsibly.

## Credits

**This mod is currently closed source and maintained by [AlterWare.Dev](https://alterware.dev/)**


- Thank you to [this post](https://forum.alterware.dev/t/s1-server-install-guide/127) on AlterWare Forum guide 1.
- Thank you to [this post](https://reactiongaming.us/community/threads/s1x-server-setup-guide-windows.1974/) on ReactionGaming for guide 2.

## ***End README***

# <u>Original README.md</u>

# S1: A Modded Client

This is a client modification for S1!
**NOTE**: You must legally own Call of Duty®: Advanced Warfare® to run this mod. Cracked/Pirated versions of the game are **NOT** supported.

## Build
- Install [Visual Studio 2022][vs-link] and enable `Desktop development with C++`
- Install [Premake5][premake5-link] and add it to your system PATH
- Clone this repository using [Git][git-link]
- Update the submodules using ``git submodule update --init --recursive``
- Run Premake with this options ``premake5 vs2022`` (Visual Studio 2022). No other build systems are supported.
- Build project via solution file in `build\s1-mod.sln`.

Only x64 is supported. Do not attempt to build for Windows ARM 64.

### Premake arguments

| Argument                    | Description                                    |
|:----------------------------|:-----------------------------------------------|
| `--copy-to=PATH`            | Optional, copy the EXE to a custom folder after build, define the path here if wanted. |
| `--dev-build`               | Enable development builds of the client. |

## Contributing

Contributions are welcome! Please follow the guidelines below:

- Sign [AlterWare CLA][cla-link] and send a pull request or email your patch at patches@alterware.dev
- Make sure that PRs have only one commit, and deal with one issue only

## Disclaimer

This software has been created purely for the purposes of
academic research. It is not intended to be used to attack
other systems. Project maintainers are not responsible or
liable for misuse of the software. Use responsibly.

[premake5-link]:          https://premake.github.io
[git-link]:               https://git-scm.com
[vs-link]:                https://visualstudio.microsoft.com/vs
[cla-link]:               https://alterware.dev/cla