// Copyright 2024 xensik. All rights reserved.
//
// Use of this source code is governed by a GNU GPLv3 license
// that can be found in the LICENSE file.

#include "xsk/gsc/engine/h2.hpp"

namespace xsk::gsc::h2
{

extern std::array<std::pair<u16, char const*>, meth_count> const meth_list
{{
    { 0x8000, "thermaldrawdisable" },
    { 0x8001, "playerforcedeathanim" },
    { 0x8002, "_meth_8002" },
    { 0x8003, "_meth_8003" },
    { 0x8004, "_meth_8004" },
    { 0x8005, "_meth_8005" },
    { 0x8006, "_meth_8006" },
    { 0x8007, "_meth_8007" },
    { 0x8008, "_meth_8008" },
    { 0x8009, "_meth_8009" },
    { 0x800A, "_meth_800A" },
    { 0x800B, "_meth_800B" },
    { 0x800C, "_meth_800C" },
    { 0x800D, "_meth_800D" },
    { 0x800E, "_meth_800E" },
    { 0x800F, "_meth_800F" },
    { 0x8010, "_meth_8010" },
    { 0x8011, "_meth_8011" },
    { 0x8012, "_meth_8012" },
    { 0x8013, "_meth_8013" },
    { 0x8014, "_meth_8014" },
    { 0x8015, "_meth_8015" },
    { 0x8016, "_meth_8016" },
    { 0x8017, "_meth_8017" },
    { 0x8018, "_meth_8018" },
    { 0x8019, "_meth_8019" },
    { 0x801A, "isonladder" },
    { 0x801B, "_meth_801B" },
    { 0x801C, "_meth_801C" },
    { 0x801D, "attach" },
    { 0x801E, "getlightfovinner" },
    { 0x801F, "getlightfovouter" },
    { 0x8020, "setlightfovrange" },
    { 0x8021, "getlightexponent" },
    { 0x8022, "setlightexponent" },
    { 0x8023, "startragdoll" },
    { 0x8024, "startragdollfromimpact" },
    { 0x8025, "_meth_8025" },
    { 0x8026, "_meth_8026" },
    { 0x8027, "_meth_8027" },
    { 0x8028, "_meth_8028" },
    { 0x8029, "thermaldrawenable" },
    { 0x802A, "detach" },
    { 0x802B, "detachall" },
    { 0x802C, "getattachsize" },
    { 0x802D, "getattachmodelname" },
    { 0x802E, "getattachtagname" },
    { 0x802F, "setturretcanaidetach" },
    { 0x8030, "setturretfov" },
    { 0x8031, "setturretfov2" },
    { 0x8032, "lerpfov" },
    { 0x8033, "lerpfovscale" },
    { 0x8034, "getvalidcoverpeekouts" },
    { 0x8035, "gethighestnodestance" },
    { 0x8036, "doesnodeallowstance" },
    { 0x8037, "_meth_8037" },
    { 0x8038, "getgunangles" },
    { 0x8039, "magicgrenade" },
    { 0x803A, "magicgrenademanual" },
    { 0x803B, "getentnum" },
    { 0x803C, "launch" },
    { 0x803D, "setsoundblend" },
    { 0x803E, "makefakeai" },
    { 0x803F, "spawndrone" },
    { 0x8040, "setcorpseremovetimer" },
    { 0x8041, "setlookattext" },
    { 0x8042, "setspawnerteam" },
    { 0x8043, "addaieventlistener" },
    { 0x8044, "removeaieventlistener" },
    { 0x8045, "getlightcolor" },
    { 0x8046, "setlightcolor" },
    { 0x8047, "_meth_8047" },
    { 0x8048, "_meth_8048" },
    { 0x8049, "_meth_8049" },
    { 0x804A, "_meth_804A" },
    { 0x804B, "getlightradius" },
    { 0x804C, "setlightradius" },
    { 0x804D, "getattachignorecollision" },
    { 0x804E, "hidepart" },
    { 0x804F, "hidepartallinstances" },
    { 0x8050, "hideallparts" },
    { 0x8051, "showpart" },
    { 0x8052, "showallparts" },
    { 0x8053, "linkto" },
    { 0x8054, "linktoblendtotag" },
    { 0x8055, "unlink" },
    { 0x8056, "setnormalhealth" },
    { 0x8057, "dodamage" },
    { 0x8058, "kill" },
    { 0x8059, "show" },
    { 0x805A, "hide" },
    { 0x805B, "_meth_805B" },
    { 0x805C, "laserforceon" },
    { 0x805D, "laserforceoff" },
    { 0x805E, "disconnectpaths" },
    { 0x805F, "connectpaths" },
    { 0x8060, "disconnectnode" },
    { 0x8061, "connectnode" },
    { 0x8062, "startusingheroonlylighting" },
    { 0x8063, "stopusingheroonlylighting" },
    { 0x8064, "startusinglessfrequentlighting" },
    { 0x8065, "stopusinglessfrequentlighting" },
    { 0x8066, "setmovingplatformplayerturnrate" },
    { 0x8067, "setthermalfog" },
    { 0x8068, "setnightvisionfog" },
    { 0x8069, "clearthermalfog" },
    { 0x806A, "clearnightvisionfog" },
    { 0x806B, "_meth_806B" },
    { 0x806C, "setmode" },
    { 0x806D, "getmode" },
    { 0x806E, "setturretignoregoals" },
    { 0x806F, "islinked" },
    { 0x8070, "enablelinkto" },
    { 0x8071, "playsoundatviewheight" },
    { 0x8072, "_meth_8072" },
    { 0x8073, "prefetchsound" },
    { 0x8074, "setpitch" },
    { 0x8075, "scalepitch" },
    { 0x8076, "setvolume" },
    { 0x8077, "scalevolume" },
    { 0x8078, "setspeakermapmonotostereo" },
    { 0x8079, "setspeakermapmonoto51" },
    { 0x807A, "setdistributed2dsound" },
    { 0x807B, "playsoundasmaster" },
    { 0x807C, "playloopsound" },
    { 0x807D, "eqon" },
    { 0x807E, "eqoff" },
    { 0x807F, "haseq" },
    { 0x8080, "iswaitingonsound" },
    { 0x8081, "foley" },
    { 0x8082, "getnormalhealth" },
    { 0x8083, "playerlinkto" },
    { 0x8084, "playerlinktodelta" },
    { 0x8085, "playerlinkweaponviewtodelta" },
    { 0x8086, "playerlinktoabsolute" },
    { 0x8087, "playerlinktoblend" },
    { 0x8088, "playerlinkedoffsetenable" },
    { 0x8089, "setwaypointedgestyle_secondaryarrow" },
    { 0x808A, "setwaypointiconoffscreenonly" },
    { 0x808B, "fadeovertime" },
    { 0x808C, "scaleovertime" },
    { 0x808D, "moveovertime" },
    { 0x808E, "reset" },
    { 0x808F, "destroy" },
    { 0x8090, "setpulsefx" },
    { 0x8091, "setplayernamestring" },
    { 0x8092, "changefontscaleovertime" },
    { 0x8093, "startignoringspotlight" },
    { 0x8094, "stopignoringspotlight" },
    { 0x8095, "dontcastshadows" },
    { 0x8096, "castshadows" },
    { 0x8097, "setstablemissile" },
    { 0x8098, "playersetgroundreferenceent" },
    { 0x8099, "dontinterpolate" },
    { 0x809A, "dospawn" },
    { 0x809B, "stalingradspawn" },
    { 0x809C, "getorigin" },
    { 0x809D, "getcentroid" },
    { 0x809E, "getshootatpos" },
    { 0x809F, "getdebugeye" },
    { 0x80A0, "useby" },
    { 0x80A1, "playsound" },
    { 0x80A2, "_meth_80A2" },
    { 0x80A3, "_meth_80A3" },
    { 0x80A4, "_meth_80A4" },
    { 0x80A5, "_meth_80A5" },
    { 0x80A6, "playerlinkedoffsetdisable" },
    { 0x80A7, "playerlinkedsetviewznear" },
    { 0x80A8, "playerlinkedsetusebaseangleforviewclamp" },
    { 0x80A9, "lerpviewangleclamp" },
    { 0x80AA, "setviewangleresistance" },
    { 0x80AB, "springcamenabled" },
    { 0x80AC, "springcamdisabled" },
    { 0x80AD, "linktoplayerview" },
    { 0x80AE, "unlinkfromplayerview" },
    { 0x80AF, "geteye" },
    { 0x80B0, "istouching" },
    { 0x80B1, "stoploopsound" },
    { 0x80B2, "stopsounds" },
    { 0x80B3, "playrumbleonentity" },
    { 0x80B4, "playrumblelooponentity" },
    { 0x80B5, "_meth_80B5" },
    { 0x80B6, "_meth_80B6" },
    { 0x80B7, "delete" },
    { 0x80B8, "setmodel" },
    { 0x80B9, "laseron" },
    { 0x80BA, "laseroff" },
    { 0x80BB, "_meth_80BB" },
    { 0x80BC, "_meth_80BC" },
    { 0x80BD, "laseraltviewon" },
    { 0x80BE, "laseraltviewoff" },
    { 0x80BF, "thermalvisionon" },
    { 0x80C0, "thermalvisiononshadowoff" },
    { 0x80C1, "_meth_80C1" },
    { 0x80C2, "_meth_80C2" },
    { 0x80C3, "_meth_80C3" },
    { 0x80C4, "_meth_80C4" },
    { 0x80C5, "setcontents" },
    { 0x80C6, "makeusable" },
    { 0x80C7, "makeunusable" },
    { 0x80C8, "_meth_80C8" },
    { 0x80C9, "_meth_80C9" },
    { 0x80CA, "setwhizbyprobabilities" },
    { 0x80CB, "visionsetnakedforplayer_lerp" },
    { 0x80CC, "setwaitnode" },
    { 0x80CD, "returnplayercontrol" },
    { 0x80CE, "vehphys_starttrack" },
    { 0x80CF, "vehphys_clearautodisable" },
    { 0x80D0, "vehicleusealtblendedaudio" },
    { 0x80D1, "settext" },
    { 0x80D2, "clearalltextafterhudelem" },
    { 0x80D3, "setshader" },
    { 0x80D4, "settargetent" },
    { 0x80D5, "cleartargetent" },
    { 0x80D6, "settimer" },
    { 0x80D7, "settimerup" },
    { 0x80D8, "settimerstatic" },
    { 0x80D9, "settenthstimer" },
    { 0x80DA, "settenthstimerup" },
    { 0x80DB, "settenthstimerstatic" },
    { 0x80DC, "setclock" },
    { 0x80DD, "setclockup" },
    { 0x80DE, "setvalue" },
    { 0x80DF, "setwaypoint" },
    { 0x80E0, "setwaypointedgestyle_rotatingicon" },
    { 0x80E1, "setcursorhint" },
    { 0x80E2, "sethintstring" },
    { 0x80E3, "_meth_80E3" },
    { 0x80E4, "forceusehinton" },
    { 0x80E5, "forceusehintoff" },
    { 0x80E6, "makesoft" },
    { 0x80E7, "makehard" },
    { 0x80E8, "willneverchange" },
    { 0x80E9, "startfiring" },
    { 0x80EA, "stopfiring" },
    { 0x80EB, "isfiringturret" },
    { 0x80EC, "startbarrelspin" },
    { 0x80ED, "stopbarrelspin" },
    { 0x80EE, "getbarrelspinrate" },
    { 0x80EF, "_meth_80EF" },
    { 0x80F0, "_meth_80F0" },
    { 0x80F1, "shootturret" },
    { 0x80F2, "getturretowner" },
    { 0x80F3, "enabledeathshield" },
    { 0x80F4, "nightvisiongogglesforceon" },
    { 0x80F5, "nightvisiongogglesforceoff" },
    { 0x80F6, "enableinvulnerability" },
    { 0x80F7, "disableinvulnerability" },
    { 0x80F8, "forceviewmodelanimation" },
    { 0x80F9, "_meth_80F9" },
    { 0x80FA, "_meth_80FA" },
    { 0x80FB, "disableturretdismount" },
    { 0x80FC, "enableturretdismount" },
    { 0x80FD, "uploadscore" },
    { 0x80FE, "uploadtime" },
    { 0x80FF, "uploadleaderboards" },
    { 0x8100, "giveachievement" },
    { 0x8101, "hidehud" },
    { 0x8102, "showhud" },
    { 0x8103, "mountvehicle" },
    { 0x8104, "dismountvehicle" },
    { 0x8105, "enableslowaim" },
    { 0x8106, "disableslowaim" },
    { 0x8107, "_meth_8107" },
    { 0x8108, "_meth_8108" },
    { 0x8109, "_meth_8109" },
    { 0x810A, "vehicleattackbuttonpressed" },
    { 0x810B, "setwhizbyoffset" },
    { 0x810C, "setsentryowner" },
    { 0x810D, "setsentrycarrier" },
    { 0x810E, "setturretminimapvisible" },
    { 0x810F, "settargetentity" },
    { 0x8110, "snaptotargetentity" },
    { 0x8111, "cleartargetentity" },
    { 0x8112, "getturrettarget" },
    { 0x8113, "setplayerspread" },
    { 0x8114, "setaispread" },
    { 0x8115, "setsuppressiontime" },
    { 0x8116, "setflaggedanimknobrestart" },
    { 0x8117, "setflaggedanimknoblimitedrestart" },
    { 0x8118, "setflaggedanimknoball" },
    { 0x8119, "setflaggedanimknoballrestart" },
    { 0x811A, "setflaggedanim" },
    { 0x811B, "setflaggedanimlimited" },
    { 0x811C, "setflaggedanimrestart" },
    { 0x811D, "setflaggedanimlimitedrestart" },
    { 0x811E, "useanimtree" },
    { 0x811F, "stopuseanimtree" },
    { 0x8120, "setanimtime" },
    { 0x8121, "allowstand" },
    { 0x8122, "allowcrouch" },
    { 0x8123, "allowprone" },
    { 0x8124, "allowlean" },
    { 0x8125, "allowswim" },
    { 0x8126, "setocclusion" },
    { 0x8127, "_meth_8127" },
    { 0x8128, "deactivateocclusion" },
    { 0x8129, "deactivateallocclusion" },
    { 0x812A, "isocclusionenabled" },
    { 0x812B, "_meth_812B" },
    { 0x812C, "_meth_812C" },
    { 0x812D, "_meth_812D" },
    { 0x812E, "_meth_812E" },
    { 0x812F, "iseqenabled" },
    { 0x8130, "seteq" },
    { 0x8131, "seteqbands" },
    { 0x8132, "deactivateeq" },
    { 0x8133, "seteqlerp" },
    { 0x8134, "islookingat" },
    { 0x8135, "isthrowinggrenade" },
    { 0x8136, "isfiring" },
    { 0x8137, "ismeleeing" },
    { 0x8138, "setautopickup" },
    { 0x8139, "allowmelee" },
    { 0x813A, "allowfire" },
    { 0x813B, "enablehealthshield" },
    { 0x813C, "setconvergencetime" },
    { 0x813D, "setconvergenceheightpercent" },
    { 0x813E, "setturretteam" },
    { 0x813F, "maketurretsolid" },
    { 0x8140, "_meth_8140" },
    { 0x8141, "maketurretoperable" },
    { 0x8142, "maketurretinoperable" },
    { 0x8143, "makeentitysentient" },
    { 0x8144, "freeentitysentient" },
    { 0x8145, "isindoor" },
    { 0x8146, "getdroptofloorposition" },
    { 0x8147, "isbadguy" },
    { 0x8148, "animscripted" },
    { 0x8149, "_meth_8149" },
    { 0x814A, "animrelative" },
    { 0x814B, "stopanimscripted" },
    { 0x814C, "clearanim" },
    { 0x814D, "setanimknob" },
    { 0x814E, "setanimknoblimited" },
    { 0x814F, "setanimknobrestart" },
    { 0x8150, "setanimknoblimitedrestart" },
    { 0x8151, "setanimknoball" },
    { 0x8152, "setanimknoballlimited" },
    { 0x8153, "setanimknoballrestart" },
    { 0x8154, "setanimknoballlimitedrestart" },
    { 0x8155, "setanim" },
    { 0x8156, "setanimlimited" },
    { 0x8157, "setanimrestart" },
    { 0x8158, "setanimlimitedrestart" },
    { 0x8159, "getanimtime" },
    { 0x815A, "getanimweight" },
    { 0x815B, "getanimassettype" },
    { 0x815C, "setflaggedanimknob" },
    { 0x815D, "setflaggedanimknoblimited" },
    { 0x815E, "setturretaccuracy" },
    { 0x815F, "setrightarc" },
    { 0x8160, "setleftarc" },
    { 0x8161, "settoparc" },
    { 0x8162, "setbottomarc" },
    { 0x8163, "setautorotationdelay" },
    { 0x8164, "setdefaultdroppitch" },
    { 0x8165, "restoredefaultdroppitch" },
    { 0x8166, "turretfiredisable" },
    { 0x8167, "getfixednodesafevolume" },
    { 0x8168, "clearfixednodesafevolume" },
    { 0x8169, "isingoal" },
    { 0x816A, "setruntopos" },
    { 0x816B, "nearnode" },
    { 0x816C, "nearclaimnode" },
    { 0x816D, "nearclaimnodeandangle" },
    { 0x816E, "atdangerousnode" },
    { 0x816F, "_meth_816F" },
    { 0x8170, "_meth_8170" },
    { 0x8171, "getenemyinfo" },
    { 0x8172, "clearenemy" },
    { 0x8173, "setentitytarget" },
    { 0x8174, "clearentitytarget" },
    { 0x8175, "setpotentialthreat" },
    { 0x8176, "clearpotentialthreat" },
    { 0x8177, "setflashbanged" },
    { 0x8178, "setengagementmindist" },
    { 0x8179, "setengagementmaxdist" },
    { 0x817A, "isknownenemyinradius" },
    { 0x817B, "isknownenemyinvolume" },
    { 0x817C, "settalktospecies" },
    { 0x817D, "invisiblenotsolid" },
    { 0x817E, "visiblesolid" },
    { 0x817F, "setdefaultaimlimits" },
    { 0x8180, "initriotshieldhealth" },
    { 0x8181, "getenemysqdist" },
    { 0x8182, "getclosestenemysqdist" },
    { 0x8183, "setthreatbiasgroup" },
    { 0x8184, "getthreatbiasgroup" },
    { 0x8185, "turretfireenable" },
    { 0x8186, "setturretmodechangewait" },
    { 0x8187, "usetriggerrequirelookat" },
    { 0x8188, "getstance" },
    { 0x8189, "setstance" },
    { 0x818A, "itemweaponsetammo" },
    { 0x818B, "getammocount" },
    { 0x818C, "gettagorigin" },
    { 0x818D, "gettagangles" },
    { 0x818E, "shellshock" },
    { 0x818F, "stunplayer" },
    { 0x8190, "stopshellshock" },
    { 0x8191, "fadeoutshellshock" },
    { 0x8192, "setdepthoffield" },
    { 0x8193, "setviewmodeldepthoffield" },
    { 0x8194, "setmotionblurmovescale" },
    { 0x8195, "pickupgrenade" },
    { 0x8196, "useturret" },
    { 0x8197, "stopuseturret" },
    { 0x8198, "canuseturret" },
    { 0x8199, "traversemode" },
    { 0x819A, "animmode" },
    { 0x819B, "orientmode" },
    { 0x819C, "getmotionangle" },
    { 0x819D, "shouldfacemotion" },
    { 0x819E, "getanglestolikelyenemypath" },
    { 0x819F, "setturretanim" },
    { 0x81A0, "getturret" },
    { 0x81A1, "getgroundenttype" },
    { 0x81A2, "_meth_81A2" },
    { 0x81A3, "_meth_81A3" },
    { 0x81A4, "_meth_81A4" },
    { 0x81A5, "_meth_81A5" },
    { 0x81A6, "animcustom" },
    { 0x81A7, "isinscriptedstate" },
    { 0x81A8, "canattackenemynode" },
    { 0x81A9, "getnegotiationstartnode" },
    { 0x81AA, "getnegotiationendnode" },
    { 0x81AB, "getnegotiationnextnode" },
    { 0x81AC, "getdoorpathnode" },
    { 0x81AD, "comparenodedirtopathdir" },
    { 0x81AE, "checkprone" },
    { 0x81AF, "pushplayer" },
    { 0x81B0, "checkgrenadethrowpos" },
    { 0x81B1, "setgoalnode" },
    { 0x81B2, "setgoalpos" },
    { 0x81B3, "setgoalentity" },
    { 0x81B4, "setgoalvolume" },
    { 0x81B5, "setgoalvolumeauto" },
    { 0x81B6, "getgoalvolume" },
    { 0x81B7, "cleargoalvolume" },
    { 0x81B8, "setfixednodesafevolume" },
    { 0x81B9, "setmotionblurturnscale" },
    { 0x81BA, "setmotionblurzoomscale" },
    { 0x81BB, "viewkick" },
    { 0x81BC, "localtoworldcoords" },
    { 0x81BD, "getentitynumber" },
    { 0x81BE, "getentityvelocity" },
    { 0x81BF, "enablegrenadetouchdamage" },
    { 0x81C0, "disablegrenadetouchdamage" },
    { 0x81C1, "enableaimassist" },
    { 0x81C2, "setlookatyawlimits" },
    { 0x81C3, "stoplookat" },
    { 0x81C4, "getmuzzlepos" },
    { 0x81C5, "getmuzzleangle" },
    { 0x81C6, "getmuzzlesideoffsetpos" },
    { 0x81C7, "getaimangle" },
    { 0x81C8, "canshoot" },
    { 0x81C9, "canshootenemy" },
    { 0x81CA, "cansee" },
    { 0x81CB, "seerecently" },
    { 0x81CC, "lastknowntime" },
    { 0x81CD, "lastknownpos" },
    { 0x81CE, "dropweapon" },
    { 0x81CF, "maymovetopoint" },
    { 0x81D0, "maymovefrompointtopoint" },
    { 0x81D1, "teleport" },
    { 0x81D2, "forceteleport" },
    { 0x81D3, "safeteleport" },
    { 0x81D4, "withinapproxpathdist" },
    { 0x81D5, "ispathdirect" },
    { 0x81D6, "allowedstances" },
    { 0x81D7, "isstanceallowed" },
    { 0x81D8, "issuppressionwaiting" },
    { 0x81D9, "issuppressed" },
    { 0x81DA, "ismovesuppressed" },
    { 0x81DB, "isgrenadepossafe" },
    { 0x81DC, "checkgrenadethrow" },
    { 0x81DD, "checkgrenadelaunch" },
    { 0x81DE, "checkgrenadelaunchpos" },
    { 0x81DF, "throwgrenade" },
    { 0x81E0, "disableaimassist" },
    { 0x81E1, "radiusdamage" },
    { 0x81E2, "detonate" },
    { 0x81E3, "damageconetrace" },
    { 0x81E4, "sightconetrace" },
    { 0x81E5, "missile_settargetent" },
    { 0x81E6, "missile_settargetpos" },
    { 0x81E7, "missile_cleartarget" },
    { 0x81E8, "missile_setflightmodedirect" },
    { 0x81E9, "missile_setflightmodetop" },
    { 0x81EA, "getlightintensity" },
    { 0x81EB, "setlightintensity" },
    { 0x81EC, "_meth_81EC" },
    { 0x81ED, "_meth_81ED" },
    { 0x81EE, "_meth_81EE" },
    { 0x81EF, "_meth_81EF" },
    { 0x81F0, "isragdoll" },
    { 0x81F1, "setmovespeedscale" },
    { 0x81F2, "cameralinkto" },
    { 0x81F3, "cameraunlink" },
    { 0x81F4, "startcoverarrival" },
    { 0x81F5, "starttraversearrival" },
    { 0x81F6, "checkcoverexitposwithpath" },
    { 0x81F7, "shoot" },
    { 0x81F8, "shootblank" },
    { 0x81F9, "melee" },
    { 0x81FA, "updateplayersightaccuracy" },
    { 0x81FB, "findshufflecovernode" },
    { 0x81FC, "findnearbycovernode" },
    { 0x81FD, "findcovernode" },
    { 0x81FE, "findbestcovernode" },
    { 0x81FF, "getcovernode" },
    { 0x8200, "usecovernode" },
    { 0x8201, "iscovervalidagainstenemy" },
    { 0x8202, "reacquirestep" },
    { 0x8203, "findreacquiredirectpath" },
    { 0x8204, "trimpathtoattack" },
    { 0x8205, "reacquiremove" },
    { 0x8206, "findreacquireproximatepath" },
    { 0x8207, "flagenemyunattackable" },
    { 0x8208, "enterprone" },
    { 0x8209, "exitprone" },
    { 0x820A, "setproneanimnodes" },
    { 0x820B, "updateprone" },
    { 0x820C, "clearpitchorient" },
    { 0x820D, "setlookatanimnodes" },
    { 0x820E, "setlookat" },
    { 0x820F, "setlookatentity" },
    { 0x8210, "controlslinkto" },
    { 0x8211, "controlsunlink" },
    { 0x8212, "makevehiclesolidcapsule" },
    { 0x8213, "_meth_8213" },
    { 0x8214, "teleportentityrelative" },
    { 0x8215, "_meth_8215" },
    { 0x8216, "_meth_8216" },
    { 0x8217, "_meth_8217" },
    { 0x8218, "_meth_8218" },
    { 0x8219, "_meth_8219" },
    { 0x821A, "_meth_821A" },
    { 0x821B, "_meth_821B" },
    { 0x821C, "drivevehicleandcontrolturret" },
    { 0x821D, "drivevehicleandcontrolturretoff" },
    { 0x821E, "getplayersetting" },
    { 0x821F, "getlocalplayerprofiledata" },
    { 0x8220, "setlocalplayerprofiledata" },
    { 0x8221, "remotecamerasoundscapeon" },
    { 0x8222, "remotecamerasoundscapeoff" },
    { 0x8223, "setmotiontrackervisible" },
    { 0x8224, "getmotiontrackervisible" },
    { 0x8225, "worldpointinreticle_circle" },
    { 0x8226, "worldpointinreticle_rect" },
    { 0x8227, "getpointinbounds" },
    { 0x8228, "transfermarkstonewscriptmodel" },
    { 0x8229, "setwatersheeting" },
    { 0x822A, "_meth_822A" },
    { 0x822B, "_meth_822B" },
    { 0x822C, "setweaponhudiconoverride" },
    { 0x822D, "getweaponhudiconoverride" },
    { 0x822E, "setempjammed" },
    { 0x822F, "playersetexpfogext" },
    { 0x8230, "playersetexpfog" },
    { 0x8231, "playersetatmosfog" },
    { 0x8232, "isitemunlocked" },
    { 0x8233, "getplayerdata" },
    { 0x8234, "vehicleturretcontroloff" },
    { 0x8235, "isturretready" },
    { 0x8236, "vehicledriveto" },
    { 0x8237, "vehicle_dospawn" },
    { 0x8238, "vehicle_isphysveh" },
    { 0x8239, "vehphys_crash" },
    { 0x823A, "_meth_823A" },
    { 0x823B, "vehphys_launch" },
    { 0x823C, "vehphys_disablecrashing" },
    { 0x823D, "vehphys_enablecrashing" },
    { 0x823E, "vehphys_setspeed" },
    { 0x823F, "vehphys_setconveyorbelt" },
    { 0x8240, "_meth_8240" },
    { 0x8241, "playerlinkedturretanglesenable" },
    { 0x8242, "playerlinkedturretanglesdisable" },
    { 0x8243, "_meth_8243" },
    { 0x8244, "_meth_8244" },
    { 0x8245, "playersetstreamorigin" },
    { 0x8246, "playerclearstreamorigin" },
    { 0x8247, "nightvisionviewon" },
    { 0x8248, "nightvisionviewoff" },
    { 0x8249, "painvisionon" },
    { 0x824A, "painvisionoff" },
    { 0x824B, "getplayerintelisfound" },
    { 0x824C, "setplayerintelfound" },
    { 0x824D, "_meth_824D" },
    { 0x824E, "sethuddynlight" },
    { 0x824F, "startscriptedanim" },
    { 0x8250, "startcoverbehavior" },
    { 0x8251, "setplayerdata" },
    { 0x8252, "getcacplayerdata" },
    { 0x8253, "setcacplayerdata" },
    { 0x8254, "trackerupdate" },
    { 0x8255, "_meth_8255" },
    { 0x8256, "buttonpressed" },
    { 0x8257, "_meth_8257" },
    { 0x8258, "_meth_8258" },
    { 0x8259, "_meth_8259" },
    { 0x825A, "dropitem" },
    { 0x825B, "_meth_825B" },
    { 0x825C, "setjitterparams" },
    { 0x825D, "sethoverparams" },
    { 0x825E, "joltbody" },
    { 0x825F, "freevehicle" },
    { 0x8260, "getwheelsurface" },
    { 0x8261, "getvehicleowner" },
    { 0x8262, "setvehiclelookattext" },
    { 0x8263, "setvehicleteam" },
    { 0x8264, "neargoalnotifydist" },
    { 0x8265, "setvehgoalpos" },
    { 0x8266, "setgoalyaw" },
    { 0x8267, "cleargoalyaw" },
    { 0x8268, "settargetyaw" },
    { 0x8269, "cleartargetyaw" },
    { 0x826A, "vehicle_helisetai" },
    { 0x826B, "setturrettargetvec" },
    { 0x826C, "setturrettargetent" },
    { 0x826D, "clearturrettargetent" },
    { 0x826E, "vehicle_canturrettargetpoint" },
    { 0x826F, "setlookatent" },
    { 0x8270, "clearlookatent" },
    { 0x8271, "setvehweapon" },
    { 0x8272, "fireweapon" },
    { 0x8273, "vehicleturretcontrolon" },
    { 0x8274, "_meth_8274" },
    { 0x8275, "_meth_8275" },
    { 0x8276, "_meth_8276" },
    { 0x8277, "_meth_8277" },
    { 0x8278, "_meth_8278" },
    { 0x8279, "_meth_8279" },
    { 0x827A, "_meth_827A" },
    { 0x827B, "_meth_827B" },
    { 0x827C, "_meth_827C" },
    { 0x827D, "_meth_827D" },
    { 0x827E, "_meth_827E" },
    { 0x827F, "_meth_827F" },
    { 0x8280, "physicslaunchserver" },
    { 0x8281, "physicslaunchserveritem" },
    { 0x8282, "clonebrushmodeltoscriptmodel" },
    { 0x8283, "_meth_8283" },
    { 0x8284, "_meth_8284" },
    { 0x8285, "_meth_8285" },
    { 0x8286, "vehicle_teleport" },
    { 0x8287, "attachpath" },
    { 0x8288, "getattachpos" },
    { 0x8289, "startpath" },
    { 0x828A, "setswitchnode" },
    { 0x828B, "setwaitspeed" },
    { 0x828C, "_meth_828C" },
    { 0x828D, "vehicle_setspeed" },
    { 0x828E, "vehicle_setspeedimmediate" },
    { 0x828F, "vehicle_rotateyaw" },
    { 0x8290, "vehicle_getspeed" },
    { 0x8291, "vehicle_getvelocity" },
    { 0x8292, "vehicle_getbodyvelocity" },
    { 0x8293, "vehicle_getsteering" },
    { 0x8294, "vehicle_getthrottle" },
    { 0x8295, "vehicle_turnengineoff" },
    { 0x8296, "vehicle_turnengineon" },
    { 0x8297, "vehicle_orientto" },
    { 0x8298, "getgoalspeedmph" },
    { 0x8299, "setacceleration" },
    { 0x829A, "setdeceleration" },
    { 0x829B, "resumespeed" },
    { 0x829C, "setyawspeed" },
    { 0x829D, "setyawspeedbyname" },
    { 0x829E, "setmaxpitchroll" },
    { 0x829F, "setairresitance" },
    { 0x82A0, "setturningability" },
    { 0x82A1, "_meth_82A1" },
    { 0x82A2, "_meth_82A2" },
    { 0x82A3, "_meth_82A3" },
    { 0x82A4, "_meth_82A4" },
    { 0x82A5, "_meth_82A5" },
    { 0x82A6, "_meth_82A6" },
    { 0x82A7, "_meth_82A7" },
    { 0x82A8, "_meth_82A8" },
    { 0x82A9, "_meth_82A9" },
    { 0x82AA, "_meth_82AA" },
    { 0x82AB, "_meth_82AB" },
    { 0x82AC, "_meth_82AC" },
    { 0x82AD, "weaponlocknoclearance" },
    { 0x82AE, "_meth_82AE" },
    { 0x82AF, "showhudsplash" },
    { 0x82B0, "setperk" },
    { 0x82B1, "hasperk" },
    { 0x82B2, "clearperks" },
    { 0x82B3, "unsetperk" },
    { 0x82B4, "_meth_82B4" },
    { 0x82B5, "_meth_82B5" },
    { 0x82B6, "noclip" },
    { 0x82B7, "ufo" },
    { 0x82B8, "moveto" },
    { 0x82B9, "movex" },
    { 0x82BA, "movey" },
    { 0x82BB, "movez" },
    { 0x82BC, "movegravity" },
    { 0x82BD, "moveslide" },
    { 0x82BE, "stopmoveslide" },
    { 0x82BF, "rotateto" },
    { 0x82C0, "rotatepitch" },
    { 0x82C1, "rotateyaw" },
    { 0x82C2, "rotateroll" },
    { 0x82C3, "addpitch" },
    { 0x82C4, "addyaw" },
    { 0x82C5, "addroll" },
    { 0x82C6, "vibrate" },
    { 0x82C7, "rotatevelocity" },
    { 0x82C8, "solid" },
    { 0x82C9, "notsolid" },
    { 0x82CA, "setcandamage" },
    { 0x82CB, "setcanradiusdamage" },
    { 0x82CC, "physicslaunchclient" },
    { 0x82CD, "_meth_82CD" },
    { 0x82CE, "_meth_82CE" },
    { 0x82CF, "_meth_82CF" },
    { 0x82D0, "_meth_82D0" },
    { 0x82D1, "_meth_82D1" },
    { 0x82D2, "_meth_82D2" },
    { 0x82D3, "_meth_82D3" },
    { 0x82D4, "_meth_82D4" },
    { 0x82D5, "disableweaponpickup" },
    { 0x82D6, "enableweaponpickup" },
    { 0x82D7, "issplitscreenplayer" },
    { 0x82D8, "_meth_82D8" },
    { 0x82D9, "getweaponslistoffhands" },
    { 0x82DA, "getweaponslistitems" },
    { 0x82DB, "getweaponslistexclusives" },
    { 0x82DC, "getweaponslist" },
    { 0x82DD, "canplayerplacesentry" },
    { 0x82DE, "canplayerplacetank" },
    { 0x82DF, "_meth_82DF" },
    { 0x82E0, "visionsetnakedforplayer" },
    { 0x82E1, "visionsetnightforplayer" },
    { 0x82E2, "visionsetmissilecamforplayer" },
    { 0x82E3, "visionsetthermalforplayer" },
    { 0x82E4, "setblurforplayer" },
    { 0x82E5, "getplayerweaponmodel" },
    { 0x82E6, "getplayerknifemodel" },
    { 0x82E7, "updateplayermodelwithweapons" },
    { 0x82E8, "notifyonplayercommand" },
    { 0x82E9, "canmantle" },
    { 0x82EA, "forcemantle" },
    { 0x82EB, "ismantling" },
    { 0x82EC, "playfx" },
    { 0x82ED, "player_recoilscaleon" },
    { 0x82EE, "player_recoilscaleoff" },
    { 0x82EF, "weaponlockstart" },
    { 0x82F0, "weaponlockfinalize" },
    { 0x82F1, "weaponlockfree" },
    { 0x82F2, "weaponlocktargettooclose" },
    { 0x82F3, "_meth_82F3" },
    { 0x82F4, "_meth_82F4" },
    { 0x82F5, "_meth_82F5" },
    { 0x82F6, "_meth_82F6" },
    { 0x82F7, "_meth_82F7" },
    { 0x82F8, "getviewmodel" },
    { 0x82F9, "fragbuttonpressed" },
    { 0x82FA, "secondaryoffhandbuttonpressed" },
    { 0x82FB, "getcurrentweaponclipammo" },
    { 0x82FC, "setvelocity" },
    { 0x82FD, "getplayerviewheight" },
    { 0x82FE, "getnormalizedmovement" },
    { 0x82FF, "playlocalsound" },
    { 0x8300, "stoplocalsound" },
    { 0x8301, "setweaponammoclip" },
    { 0x8302, "setweaponammostock" },
    { 0x8303, "getweaponammoclip" },
    { 0x8304, "getweaponammostock" },
    { 0x8305, "hasreloadmultipleanim" },
    { 0x8306, "regweaponforfxremoval" },
    { 0x8307, "setclientdvar" },
    { 0x8308, "setclientdvars" },
    { 0x8309, "_meth_8309" },
    { 0x830A, "_meth_830A" },
    { 0x830B, "allowads" },
    { 0x830C, "allowjump" },
    { 0x830D, "allowsprint" },
    { 0x830E, "_meth_830E" },
    { 0x830F, "_meth_830F" },
    { 0x8310, "setspreadoverride" },
    { 0x8311, "resetspreadoverride" },
    { 0x8312, "setaimspreadmovementscale" },
    { 0x8313, "setactionslot" },
    { 0x8314, "setviewkickscale" },
    { 0x8315, "getviewkickscale" },
    { 0x8316, "getweaponslistall" },
    { 0x8317, "getweaponslistprimaries" },
    { 0x8318, "getnormalizedcameramovement" },
    { 0x8319, "giveweapon" },
    { 0x831A, "takeweapon" },
    { 0x831B, "takeallweapons" },
    { 0x831C, "getcurrentweapon" },
    { 0x831D, "getcurrentprimaryweapon" },
    { 0x831E, "getcurrentoffhand" },
    { 0x831F, "hasweapon" },
    { 0x8320, "switchtoweapon" },
    { 0x8321, "switchtoweaponimmediate" },
    { 0x8322, "_meth_8322" },
    { 0x8323, "switchtooffhand" },
    { 0x8324, "setoffhandsecondaryclass" },
    { 0x8325, "getoffhandsecondaryclass" },
    { 0x8326, "beginlocationselection" },
    { 0x8327, "endlocationselection" },
    { 0x8328, "disableweapons" },
    { 0x8329, "enableweapons" },
    { 0x832A, "disableoffhandweapons" },
    { 0x832B, "enableoffhandweapons" },
    { 0x832C, "disableweaponswitch" },
    { 0x832D, "enableweaponswitch" },
    { 0x832E, "openpopupmenu" },
    { 0x832F, "openpopupmenunomouse" },
    { 0x8330, "closepopupmenu" },
    { 0x8331, "openmenu" },
    { 0x8332, "closemenu" },
    { 0x8333, "_meth_8333" },
    { 0x8334, "freezecontrols" },
    { 0x8335, "disableusability" },
    { 0x8336, "enableusability" },
    { 0x8337, "setwhizbyspreads" },
    { 0x8338, "setwhizbyradii" },
    { 0x8339, "setreverb" },
    { 0x833A, "deactivatereverb" },
    { 0x833B, "setvolmod" },
    { 0x833C, "givestartammo" },
    { 0x833D, "givemaxammo" },
    { 0x833E, "getfractionstartammo" },
    { 0x833F, "getfractionmaxammo" },
    { 0x8340, "isdualwielding" },
    { 0x8341, "isreloading" },
    { 0x8342, "isswitchingweapon" },
    { 0x8343, "setorigin" },
    { 0x8344, "getvelocity" },
    { 0x8345, "setplayerangles" },
    { 0x8346, "getplayerangles" },
    { 0x8347, "usebuttonpressed" },
    { 0x8348, "attackbuttonpressed" },
    { 0x8349, "adsbuttonpressed" },
    { 0x834A, "meleebuttonpressed" },
    { 0x834B, "playerads" },
    { 0x834C, "isonground" },
    { 0x834D, "isusingturret" },
    { 0x834E, "setviewmodel" },
    { 0x834F, "setoffhandprimaryclass" },
    { 0x8350, "getoffhandprimaryclass" },
    { 0x8351, "enablefocus" },
    { 0x8352, "disablefocus" },
    { 0x8353, "enablezoom" },
    { 0x8354, "disablezoom" },
    { 0x8355, "_meth_8355" },
    { 0x8356, "_meth_8356" },
    { 0x8357, "_meth_8357" },
    { 0x8358, "_meth_8358" },
    { 0x8359, "_meth_8359" },
    { 0x835A, "_meth_835A" },
    { 0x835B, "_meth_835B" },
    { 0x835C, "_meth_835C" },
    { 0x835D, "_meth_835D" },
    { 0x835E, "_meth_835E" },
    { 0x835F, "_meth_835F" },
    { 0x8360, "_meth_8360" },
    { 0x8361, "_meth_8361" },
    { 0x8362, "_meth_8362" },
    { 0x8363, "_meth_8363" },
    { 0x8364, "_meth_8364" },
    { 0x8365, "_meth_8365" },
    { 0x8366, "_meth_8366" },
    { 0x8367, "_meth_8367" },
    { 0x8368, "_meth_8368" },
    { 0x8369, "_meth_8369" },
    { 0x836A, "_meth_836A" },
    { 0x836B, "_meth_836B" },
    { 0x836C, "_meth_836C" },
    { 0x836D, "_meth_836D" },
    { 0x836E, "_meth_836E" },
    { 0x836F, "_meth_836F" },
    { 0x8370, "_meth_8370" },
    { 0x8371, "_meth_8371" },
    { 0x8372, "_meth_8372" },
    { 0x8373, "_meth_8373" },
    { 0x8374, "_meth_8374" },
    { 0x8375, "_meth_8375" },
    { 0x8376, "_meth_8376" },
    { 0x8377, "_meth_8377" },
    { 0x8378, "_meth_8378" },
    { 0x8379, "_meth_8379" },
    { 0x837A, "_meth_837A" },
    { 0x837B, "_meth_837B" },
    { 0x837C, "_meth_837C" },
    { 0x837D, "_meth_837D" },
    { 0x837E, "_meth_837E" },
    { 0x837F, "_meth_837F" },
    { 0x8380, "_meth_8380" },
    { 0x8381, "_meth_8381" },
    { 0x8382, "_meth_8382" },
    { 0x8383, "_meth_8383" },
    { 0x8384, "_meth_8384" },
    { 0x8385, "_meth_8385" },
    { 0x8386, "_meth_8386" },
    { 0x8387, "_meth_8387" },
    { 0x8388, "_meth_8388" },
    { 0x8389, "_meth_8389" },
    { 0x838A, "_meth_838A" },
    { 0x838B, "_meth_838B" },
    { 0x838C, "_meth_838C" },
    { 0x838D, "_meth_838D" },
    { 0x838E, "_meth_838E" },
    { 0x838F, "_meth_838F" },
    { 0x8390, "_meth_8390" },
    { 0x8391, "_meth_8391" },
    { 0x8392, "_meth_8392" },
    { 0x8393, "_meth_8393" },
    { 0x8394, "_meth_8394" },
    { 0x8395, "_meth_8395" },
    { 0x8396, "_meth_8396" },
    { 0x8397, "_meth_8397" },
    { 0x8398, "_meth_8398" },
    { 0x8399, "_meth_8399" },
    { 0x839A, "_meth_839A" },
    { 0x839B, "_meth_839B" },
    { 0x839C, "_meth_839C" },
    { 0x839D, "_meth_839D" },
    { 0x839E, "_meth_839E" },
    { 0x839F, "_meth_839F" },
    { 0x83A0, "_meth_83A0" },
    { 0x83A1, "_meth_83A1" },
    { 0x83A2, "_meth_83A2" },
    { 0x83A3, "_meth_83A3" },
    { 0x83A4, "_meth_83A4" },
    { 0x83A5, "_meth_83A5" },
    { 0x83A6, "_meth_83A6" },
    { 0x83A7, "_meth_83A7" },
    { 0x83A8, "_meth_83A8" },
    { 0x83A9, "_meth_83A9" },
    { 0x83AA, "_meth_83AA" },
    { 0x83AB, "_meth_83AB" },
    { 0x83AC, "_meth_83AC" },
    { 0x83AD, "_meth_83AD" },
    { 0x83AE, "_meth_83AE" },
    { 0x83AF, "_meth_83AF" },
    { 0x83B0, "_meth_83B0" },
    { 0x83B1, "_meth_83B1" },
    { 0x83B2, "_meth_83B2" },
    { 0x83B3, "_meth_83B3" },
    { 0x83B4, "_meth_83B4" },
    { 0x83B5, "_meth_83B5" },
    { 0x83B6, "_meth_83B6" },
    { 0x83B7, "_meth_83B7" },
    { 0x83B8, "_meth_83B8" },
    { 0x83B9, "_meth_83B9" },
    { 0x83BA, "_meth_83BA" },
    { 0x83BB, "_meth_83BB" },
    { 0x83BC, "_meth_83BC" },
    { 0x83BD, "_meth_83BD" },
    { 0x83BE, "_meth_83BE" },
    { 0x83BF, "_meth_83BF" },
    { 0x83C0, "_meth_83C0" },
    { 0x83C1, "_meth_83C1" },
    { 0x83C2, "_meth_83C2" },
    { 0x83C3, "_meth_83C3" },
    { 0x83C4, "_meth_83C4" },
    { 0x83C5, "_meth_83C5" },
    { 0x83C6, "_meth_83C6" },
    { 0x83C7, "_meth_83C7" },
    { 0x83C8, "_meth_83C8" },
    { 0x83C9, "_meth_83C9" },
    { 0x83CA, "_meth_83CA" },
    { 0x83CB, "_meth_83CB" },
    { 0x83CC, "_meth_83CC" },
    { 0x83CD, "lightset" },
    { 0x83CE, "lightset2" },
    { 0x83CF, "lightset3" },
    { 0x83D0, "_meth_83D0" },
    { 0x83D1, "_meth_83D1" },
    { 0x83D2, "_meth_83D2" },
    { 0x83D3, "_meth_83D3" },
    { 0x83D4, "_meth_83D4" },
    { 0x83D5, "setdoghandler" },
    { 0x83D6, "setdogcommand" },
    { 0x83D7, "setdogattackradius" },
    { 0x83D8, "isdogfollowinghandler" },
    { 0x83D9, "setdogmaxdrivespeed" },
    { 0x83DA, "isdogbeingdriven" },
    { 0x83DB, "setdogautoattackwhendriven" },
    { 0x83DC, "getdogattackbeginnode" },
    { 0x83DD, "_meth_83DD" },
    { 0x83DE, "_meth_83DE" },
    { 0x83DF, "_meth_83DF" },
    { 0x83E0, "_meth_83E0" },
    { 0x83E1, "_meth_83E1" },
    { 0x83E2, "_meth_83E2" },
    { 0x83E3, "_meth_83E3" },
    { 0x83E4, "pushplayervector" },
    { 0x83E5, "issprinting" },
    { 0x83E6, "playerlinkeduselinkedvelocity" },
    { 0x83E7, "shootstopsound" },
    { 0x83E8, "setclothtype" },
    { 0x83E9, "getclothmovesound" },
    { 0x83EA, "getequipmovesound" },
    { 0x83EB, "jumpbuttonpressed" },
    { 0x83EC, "rotateby" },
    { 0x83ED, "_meth_83ED" },
    { 0x83EE, "_meth_83EE" },
    { 0x83EF, "_meth_83EF" },
    { 0x83F0, "_meth_83F0" },
    { 0x83F1, "setsurfacetype" },
    { 0x83F2, "aiphysicstrace" },
    { 0x83F3, "aiphysicstracepassed" },
    { 0x83F4, "setdevtext" },
    { 0x83F5, "forcemovingplatformentity" },
    { 0x83F6, "setmovingplatformtrigger" },
    { 0x83F7, "visionsetstage" },
    { 0x83F8, "linkwaypointtotargetwithoffset" },
    { 0x83F9, "getlinkedparent" },
    { 0x83FA, "getmovingplatformparent" },
    { 0x83FB, "_meth_83FB" },
    { 0x83FC, "retargetscriptmodellighting" },
    { 0x83FD, "_meth_83FD" },
    { 0x83FE, "clearclienttriggeraudiozone" },
    { 0x83FF, "setclienttriggeraudiozone" },
    { 0x8400, "makevehiclenotcollidewithplayers" },
    { 0x8401, "getbobrate" },
    { 0x8402, "setbobrate" },
    { 0x8403, "setscriptablepartstate" },
    { 0x8404, "stopsliding" },
    { 0x8405, "cancelrocketcorpse" },
    { 0x8406, "setdronegoalpos" },
    { 0x8407, "hudoutlineenable" },
    { 0x8408, "hudoutlinedisable" },
    { 0x8409, "motionblurhqenable" },
    { 0x840A, "motionblurhqdisable" },
    { 0x840B, "screenshakeonentity" },
    { 0x840C, "_meth_840C" },
    { 0x840D, "_meth_840D" },
    { 0x840E, "worldpointtoscreenpos" },
    { 0x840F, "_meth_840F" },
    { 0x8410, "shouldplaymeleedeathanim" },
    { 0x8411, "_meth_8411" },
    { 0x8412, "visionsetwaterforplayer" },
    { 0x8413, "setwatersurfacetransitionfx" },
    { 0x8414, "linktoplayerviewfollowwatersurface" },
    { 0x8415, "linktoplayerviewattachwatersurfacetransitioneffects" },
    { 0x8416, "playersetwaterfog" },
    { 0x8417, "_meth_8417" },
    { 0x8418, "enableforceviewmodeldof" },
    { 0x8419, "disableforceviewmodeldof" },
    { 0x841A, "_meth_841A" },
    { 0x841B, "isenemyaware" },
    { 0x841C, "hasenemybeenseen" },
    { 0x841D, "physicssetmaxlinvel" },
    { 0x841E, "physicssetmaxangvel" },
    { 0x841F, "physicsgetlinvel" },
    { 0x8420, "physicsgetlinspeed" },
    { 0x8421, "physicsgetangvel" },
    { 0x8422, "physicsgetangspeed" },
    { 0x8423, "_meth_8423" },
    { 0x8424, "_meth_8424" },
    { 0x8425, "_meth_8425" },
    { 0x8426, "_meth_8426" },
    { 0x8427, "_meth_8427" },
    { 0x8428, "_meth_8428" },
    { 0x8429, "_meth_8429" },
    { 0x842A, "disablemissileboosting" },
    { 0x842B, "enablemissileboosting" },
    { 0x842C, "canspawntestclient" },
    { 0x842D, "spawntestclient" },
    { 0x842E, "turretsetbarrelspinenabled" },
    { 0x842F, "_meth_842F" },
    { 0x8430, "_meth_8430" },
    { 0x8431, "setclienttriggeraudiozonelerp" },
    { 0x8432, "setclienttriggeraudiozonepartial" },
    { 0x8433, "_meth_8433" },
    { 0x8434, "rotatetolinked" },
    { 0x8435, "rotatebylinked" },
    { 0x8436, "setlinkedangles" },
    { 0x8437, "_meth_8437" },
    { 0x8438, "_meth_8438" },
    { 0x8439, "_meth_8439" },
    { 0x843A, "_meth_843A" },
    { 0x843B, "_meth_843B" },
    { 0x843C, "_meth_843C" },
    { 0x843D, "_meth_843D" },
    { 0x843E, "disableautoreload" },
    { 0x843F, "enableautoreload" },
    { 0x8440, "_meth_8440" },
    { 0x8441, "_meth_8441" },
    { 0x8442, "getlinkedchildren" },
    { 0x8443, "_meth_8443" },
    { 0x8444, "_meth_8444" },
    { 0x8445, "cancelmantle" },
    { 0x8446, "_meth_8446" },
    { 0x8447, "_meth_8447" },
    { 0x8448, "setscriptabledamageowner" },
    { 0x8449, "_meth_8449" },
    { 0x844A, "_meth_844A" },
    { 0x844B, "_meth_844B" },
    { 0x844C, "_meth_844C" },
    { 0x844D, "_meth_844D" },
    { 0x844E, "_meth_844E" },
    { 0x844F, "_meth_844F" },
    { 0x8450, "_meth_8450" },
    { 0x8451, "_meth_8451" },
    { 0x8452, "_meth_8452" },
    { 0x8453, "_meth_8453" },
    { 0x8454, "_meth_8454" },
    { 0x8455, "_meth_8455" },
    { 0x8456, "_meth_8456" },
    { 0x8457, "_meth_8457" },
    { 0x8458, "_meth_8458" },
    { 0x8459, "_meth_8459" },
    { 0x845A, "_meth_845A" },
    { 0x845B, "_meth_845B" },
    { 0x845C, "_meth_845C" },
    { 0x845D, "_meth_845D" },
    { 0x845E, "_meth_845E" },
    { 0x845F, "_meth_845F" },
    { 0x8460, "_meth_8460" },
    { 0x8461, "_meth_8461" },
    { 0x8462, "_meth_8462" },
    { 0x8463, "_meth_8463" },
    { 0x8464, "_meth_8464" },
    { 0x8465, "_meth_8465" },
    { 0x8466, "_meth_8466" },
    { 0x8467, "_meth_8467" },
    { 0x8468, "_meth_8468" },
    { 0x8469, "_meth_8469" },
    { 0x846A, "_meth_846A" },
    { 0x846B, "_meth_846B" },
    { 0x846C, "_meth_846C" },
    { 0x846D, "_meth_846D" },
    { 0x846E, "_meth_846E" },
    { 0x846F, "_meth_846F" },
    { 0x8470, "_meth_8470" },
    { 0x8471, "_meth_8471" },
    { 0x8472, "_meth_8472" },
    { 0x8473, "_meth_8473" },
    { 0x8474, "_meth_8474" },
    { 0x8475, "_meth_8475" },
    { 0x8476, "_meth_8476" },
    { 0x8477, "_meth_8477" },
    { 0x8478, "_meth_8478" },
    { 0x8479, "_meth_8479" },
    { 0x847A, "_meth_847A" },
    { 0x847B, "_meth_847B" },
    { 0x847C, "_meth_847C" },
    { 0x847D, "_meth_847D" },
    { 0x847E, "_meth_847E" },
    { 0x847F, "_meth_847F" },
    { 0x8480, "_meth_8480" },
    { 0x8481, "_meth_8481" },
    { 0x8482, "_meth_8482" },
    { 0x8483, "_meth_8483" },
    { 0x8484, "_meth_8484" },
    { 0x8485, "_meth_8485" },
    { 0x8486, "_meth_8486" },
    { 0x8487, "_meth_8487" },
    { 0x8488, "_meth_8488" },
    { 0x8489, "_meth_8489" },
    { 0x848A, "_meth_848A" },
    { 0x848B, "_meth_848B" },
    { 0x848C, "_meth_848C" },
    { 0x848D, "_meth_848D" },
    { 0x848E, "_meth_848E" },
    { 0x848F, "_meth_848F" },
    { 0x8490, "_meth_8490" },
    { 0x8491, "_meth_8491" },
    { 0x8492, "_meth_8492" },
    { 0x8493, "_meth_8493" },
    { 0x8494, "_meth_8494" },
    { 0x8495, "_meth_8495" },
    { 0x8496, "_meth_8496" },
    { 0x8497, "_meth_8497" },
    { 0x8498, "_meth_8498" },
    { 0x8499, "_meth_8499" },
    { 0x849A, "_meth_849A" },
    { 0x849B, "_meth_849B" },
    { 0x849C, "_meth_849C" },
    { 0x849D, "_meth_849D" },
    { 0x849E, "_meth_849E" },
    { 0x849F, "_meth_849F" },
    { 0x84A0, "_meth_84A0" },
    { 0x84A1, "_meth_84A1" },
    { 0x84A2, "_meth_84A2" },
    { 0x84A3, "_meth_84A3" },
    { 0x84A4, "_meth_84A4" },
    { 0x84A5, "_meth_84A5" },
    { 0x84A6, "_meth_84A6" },
    { 0x84A7, "_meth_84A7" },
    { 0x84A8, "_meth_84A8" },
    { 0x84A9, "_meth_84A9" },
    { 0x84AA, "_meth_84AA" },
    { 0x84AB, "_meth_84AB" },
    { 0x84AC, "_meth_84AC" },
    { 0x84AD, "_meth_84AD" },
    { 0x84AE, "_meth_84AE" },
    { 0x84AF, "_meth_84AF" },
    { 0x84B0, "_meth_84B0" },
    { 0x84B1, "_meth_84B1" },
    { 0x84B2, "_meth_84B2" },
    { 0x84B3, "_meth_84B3" },
    { 0x84B4, "_meth_84B4" },
    { 0x84B5, "_meth_84B5" },
    { 0x84B6, "_meth_84B6" },
    { 0x84B7, "_meth_84B7" },
    { 0x84B8, "_meth_84B8" },
    { 0x84B9, "_meth_84B9" },
    { 0x84BA, "_meth_84BA" },
    { 0x84BB, "_meth_84BB" },
    { 0x84BC, "_meth_84BC" },
    { 0x84BD, "_meth_84BD" },
    { 0x84BE, "_meth_84BE" },
    { 0x84BF, "_meth_84BF" },
    { 0x84C0, "_meth_84C0" },
    { 0x84C1, "_meth_84C1" },
    { 0x84C2, "_meth_84C2" },
    { 0x84C3, "_meth_84C3" },
    { 0x84C4, "_meth_84C4" },
    { 0x84C5, "_meth_84C5" },
    { 0x84C6, "_meth_84C6" },
    { 0x84C7, "_meth_84C7" },
    { 0x84C8, "_meth_84C8" },
    { 0x84C9, "_meth_84C9" },
    { 0x84CA, "_meth_84CA" },
    { 0x84CB, "_meth_84CB" },
    { 0x84CC, "_meth_84CC" },
    { 0x84CD, "_meth_84CD" },
    { 0x84CE, "_meth_84CE" },
    { 0x84CF, "_meth_84CF" },
    { 0x84D0, "_meth_84D0" },
    { 0x84D1, "_meth_84D1" },
    { 0x84D2, "_meth_84D2" },
    { 0x84D3, "_meth_84D3" },
    { 0x84D4, "_meth_84D4" },
    { 0x84D5, "_meth_84D5" },
    { 0x84D6, "_meth_84D6" },
    { 0x84D7, "_meth_84D7" },
    { 0x84D8, "_meth_84D8" },
    { 0x84D9, "_meth_84D9" },
    { 0x84DA, "_meth_84DA" },
    { 0x84DB, "_meth_84DB" },
    { 0x84DC, "_meth_84DC" },
    { 0x84DD, "_meth_84DD" },
    { 0x84DE, "_meth_84DE" },
    { 0x84DF, "_meth_84DF" },
    { 0x84E0, "_meth_84E0" },
    { 0x84E1, "_meth_84E1" },
    { 0x84E2, "_meth_84E2" },
    { 0x84E3, "_meth_84E3" },
    { 0x84E4, "_meth_84E4" },
    { 0x84E5, "_meth_84E5" },
    { 0x84E6, "_meth_84E6" },
    { 0x84E7, "_meth_84E7" },
    { 0x84E8, "_meth_84E8" },
    { 0x84E9, "_meth_84E9" },
    { 0x84EA, "_meth_84EA" },
    { 0x84EB, "_meth_84EB" },
    { 0x84EC, "_meth_84EC" },
    { 0x84ED, "_meth_84ED" },
    { 0x84EE, "_meth_84EE" },
    { 0x84EF, "_meth_84EF" },
    { 0x84F0, "_meth_84F0" },
    { 0x84F1, "_meth_84F1" },
    { 0x84F2, "_meth_84F2" },
    { 0x84F3, "_meth_84F3" },
    { 0x84F4, "_meth_84F4" },
    { 0x84F5, "_meth_84F5" },
    { 0x84F6, "_meth_84F6" },
    { 0x84F7, "_meth_84F7" },
    { 0x84F8, "_meth_84F8" },
    { 0x84F9, "_meth_84F9" },
    { 0x84FA, "_meth_84FA" },
    { 0x84FB, "_meth_84FB" },
    { 0x84FC, "_meth_84FC" },
    { 0x84FD, "_meth_84FD" },
    { 0x84FE, "_meth_84FE" },
    { 0x84FF, "hidepartvm" },
    { 0x8500, "openluimenu" },
    { 0x8501, "_meth_8501" },
    { 0x8502, "_meth_8502" },
    { 0x8503, "_meth_8503" },
    { 0x8504, "_meth_8504" },
    { 0x8505, "_meth_8505" },
    { 0x8506, "_meth_8506" },
    { 0x8507, "_meth_8507" },
    { 0x8508, "_meth_8508" },
    { 0x8509, "_meth_8509" },
    { 0x850A, "_meth_850A" },
    { 0x850B, "_meth_850B" },
    { 0x850C, "_meth_850C" },
    { 0x850D, "_meth_850D" },
    { 0x850E, "_meth_850E" },
    { 0x850F, "_meth_850F" },
    { 0x8510, "_meth_8510" },
    { 0x8511, "_meth_8511" },
    { 0x8512, "_meth_8512" },
    { 0x8513, "_meth_8513" },
    { 0x8514, "_meth_8514" },
    { 0x8515, "_meth_8515" },
    { 0x8516, "_meth_8516" },
    { 0x8517, "_meth_8517" },
    { 0x8518, "_meth_8518" },
    { 0x8519, "_meth_8519" },
    { 0x851A, "_meth_851A" },
    { 0x851B, "_meth_851B" },
    { 0x851C, "_meth_851C" },
    { 0x851D, "_meth_851D" },
    { 0x851E, "_meth_851E" },
    { 0x851F, "_meth_851F" },
    { 0x8520, "_meth_8520" },
    { 0x8521, "_meth_8521" },
    { 0x8522, "_meth_8522" },
    { 0x8523, "_meth_8523" },
    { 0x8524, "_meth_8524" },
    { 0x8525, "_meth_8525" },
    { 0x8526, "_meth_8526" },
    { 0x8527, "_meth_8527" },
    { 0x8528, "_meth_8528" },
    { 0x8529, "_meth_8529" },
    { 0x852A, "_meth_852A" },
    { 0x852B, "_meth_852B" },
    { 0x852C, "_meth_852C" },
    { 0x852D, "_meth_852D" },
    { 0x852E, "_meth_852E" },
    { 0x852F, "_meth_852F" },
    { 0x8530, "_meth_8530" },
    { 0x8531, "_meth_8531" },
    { 0x8532, "_meth_8532" },
    { 0x8533, "_meth_8533" },
    { 0x8534, "_meth_8534" },
    { 0x8535, "_meth_8535" },
    { 0x8536, "_meth_8536" },
    { 0x8537, "_meth_8537" },
    { 0x8538, "_meth_8538" },
    { 0x8539, "_meth_8539" },
    { 0x853A, "_meth_853A" },
    { 0x853B, "_meth_853B" },
    { 0x853C, "_meth_853C" },
    { 0x853D, "_meth_853D" },
    { 0x853E, "_meth_853E" },
    { 0x853F, "_meth_853F" },
    { 0x8540, "_meth_8540" },
    { 0x8541, "_meth_8541" },
    { 0x8542, "_meth_8542" },
    { 0x8543, "_meth_8543" },
    { 0x8544, "_meth_8544" },
    { 0x8545, "_meth_8545" },
    { 0x8546, "_meth_8546" },
    { 0x8547, "_meth_8547" },
    { 0x8548, "_meth_8548" },
    { 0x8549, "_meth_8549" },
    { 0x854A, "_meth_854A" },
    { 0x854B, "_meth_854B" },
    { 0x854C, "_meth_854C" },
    { 0x854D, "_meth_854D" },
    { 0x854E, "_meth_854E" },
    { 0x854F, "_meth_854F" },
    { 0x8550, "_meth_8550" },
    { 0x8551, "_meth_8551" },
    { 0x8552, "_meth_8552" },
    { 0x8553, "_meth_8553" },
    { 0x8554, "_meth_8554" },
    { 0x8555, "_meth_8555" },
    { 0x8556, "_meth_8556" },
    { 0x8557, "_meth_8557" },
    { 0x8558, "_meth_8558" },
    { 0x8559, "_meth_8559" },
    { 0x855A, "_meth_855A" },
    { 0x855B, "_meth_855B" },
    { 0x855C, "_meth_855C" },
    { 0x855D, "_meth_855D" },
    { 0x855E, "_meth_855E" },
    { 0x855F, "_meth_855F" },
    { 0x8560, "_meth_8560" },
    { 0x8561, "_meth_8561" },
    { 0x8562, "_meth_8562" },
    { 0x8563, "_meth_8563" },
    { 0x8564, "_meth_8564" },
    { 0x8565, "_meth_8565" },
    { 0x8566, "_meth_8566" },
    { 0x8567, "_meth_8567" },
    { 0x8568, "_meth_8568" },
    { 0x8569, "_meth_8569" },
    { 0x856A, "_meth_856A" },
    { 0x856B, "_meth_856B" },
    { 0x856C, "_meth_856C" },
    { 0x856D, "_meth_856D" },
    { 0x856E, "_meth_856E" },
    { 0x856F, "_meth_856F" },
    { 0x8570, "_meth_8570" },
    { 0x8571, "_meth_8571" },
    { 0x8572, "_meth_8572" },
    { 0x8573, "_meth_8573" },
    { 0x8574, "_meth_8574" },
    { 0x8575, "_meth_8575" },
    { 0x8576, "_meth_8576" },
    { 0x8577, "_meth_8577" },
    { 0x8578, "_meth_8578" },
    { 0x8579, "_meth_8579" },
    { 0x857A, "_meth_857A" },
    { 0x857B, "_meth_857B" },
    { 0x857C, "_meth_857C" },
    { 0x857D, "_meth_857D" },
    { 0x857E, "_meth_857E" },
    { 0x857F, "_meth_857F" },
    { 0x8580, "_meth_8580" },
    { 0x8581, "_meth_8581" },
    { 0x8582, "_meth_8582" },
    { 0x8583, "_meth_8583" },
    { 0x8584, "_meth_8584" },
    { 0x8585, "_meth_8585" },
    { 0x8586, "_meth_8586" },
    { 0x8587, "_meth_8587" },
    { 0x8588, "_meth_8588" },
    { 0x8589, "_meth_8589" },
    { 0x858A, "_meth_858A" },
    { 0x858B, "_meth_858B" },
    { 0x858C, "_meth_858C" },
    { 0x858D, "_meth_858D" },
    { 0x858E, "_meth_858E" },
    { 0x858F, "_meth_858F" },
    { 0x8590, "_meth_8590" },
    { 0x8591, "_meth_8591" },
    { 0x8592, "_meth_8592" },
    { 0x8593, "_meth_8593" },
    { 0x8594, "_meth_8594" },
    { 0x8595, "_meth_8595" },
    { 0x8596, "_meth_8596" },
    { 0x8597, "_meth_8597" },
    { 0x8598, "_meth_8598" },
    { 0x8599, "_meth_8599" },
    { 0x859A, "_meth_859A" },
    { 0x859B, "_meth_859B" },
    { 0x859C, "_meth_859C" },
    { 0x859D, "_meth_859D" },
    { 0x859E, "_meth_859E" },
    { 0x859F, "_meth_859F" },
    { 0x85A0, "_meth_85A0" },
    { 0x85A1, "_meth_85A1" },
    { 0x85A2, "_meth_85A2" },
    { 0x85A3, "_meth_85A3" },
    { 0x85A4, "_meth_85A4" },
    { 0x85A5, "_meth_85A5" },
    { 0x85A6, "_meth_85A6" },
    { 0x85A7, "_meth_85A7" },
    { 0x85A8, "_meth_85A8" },
    { 0x85A9, "_meth_85A9" },
    { 0x85AA, "_meth_85AA" },
    { 0x85AB, "_meth_85AB" },
    { 0x85AC, "_meth_85AC" },
    { 0x85AD, "_meth_85AD" },
    { 0x85AE, "_meth_85AE" },
    { 0x85AF, "_meth_85AF" },
    { 0x85B0, "_meth_85B0" },
    { 0x85B1, "_meth_85B1" },
    { 0x85B2, "_meth_85B2" },
    { 0x85B3, "_meth_85B3" },
    { 0x85B4, "_meth_85B4" },
    { 0x85B5, "_meth_85B5" },
    { 0x85B6, "_meth_85B6" },
    { 0x85B7, "_meth_85B7" },
    { 0x85B8, "_meth_85B8" },
    { 0x85B9, "_meth_85B9" },
    { 0x85BA, "_meth_85BA" },
    { 0x85BB, "_meth_85BB" },
    { 0x85BC, "_meth_85BC" },
    { 0x85BD, "_meth_85BD" },
    { 0x85BE, "_meth_85BE" },
    { 0x85BF, "_meth_85BF" },
    { 0x85C0, "_meth_85C0" },
    { 0x85C1, "_meth_85C1" },
    { 0x85C2, "_meth_85C2" },
    { 0x85C3, "_meth_85C3" },
    { 0x85C4, "_meth_85C4" },
    { 0x85C5, "_meth_85C5" },
    { 0x85C6, "_meth_85C6" },
    { 0x85C7, "_meth_85C7" },
    { 0x85C8, "_meth_85C8" },
    { 0x85C9, "_meth_85C9" },
    { 0x85CA, "_meth_85CA" },
    { 0x85CB, "_meth_85CB" },
    { 0x85CC, "_meth_85CC" },
    { 0x85CD, "_meth_85CD" },
    { 0x85CE, "_meth_85CE" },
    { 0x85CF, "_meth_85CF" },
    { 0x85D0, "_meth_85D0" },
    { 0x85D1, "_meth_85D1" },
    { 0x85D2, "_meth_85D2" },
}};

} // namespace xsk::gsc::h2
