// Copyright 2024 xensik. All rights reserved.
//
// Use of this source code is governed by a GNU GPLv3 license
// that can be found in the LICENSE file.

#include "xsk/gsc/engine/iw6_pc.hpp"

namespace xsk::gsc::iw6_pc
{

extern std::array<std::pair<u16, char const*>, func_count> const func_list
{{
    { 0x001, "precacheturret" },
    { 0x002, "getweaponarray" },
    { 0x003, "createprintchannel" },
    { 0x004, "updategamerprofileall" },
    { 0x005, "clearlocalizedstrings" },
    { 0x006, "setphysicsgravitydir" },
    { 0x007, "gettimescale" },
    { 0x008, "settimescale" },
    { 0x009, "setslowmotionview" },
    { 0x00A, "teleportscene" },
    { 0x00B, "forcesharedammo" },
    { 0x00C, "refreshhudcompass" },
    { 0x00D, "refreshhudammocounter" },
    { 0x00E, "notifyoncommand" },
    { 0x00F, "setprintchannel" },
    { 0x010, "print" },
    { 0x011, "println" },
    { 0x012, "print3d" },
    { 0x013, "line" },
    { 0x014, "box" },
    { 0x015, "orientedbox" },
    { 0x016, "sphere" },
    { 0x017, "cylinder" },
    { 0x018, "spawnturret" },
    { 0x019, "canspawnturret" },
    { 0x01A, "assert" },
    { 0x01B, "pausecinematicingame" },
    { 0x01C, "drawcompassfriendlies" },
    { 0x01D, "bulletspread" },
    { 0x01E, "bullettracer" },
    { 0x01F, "badplace_delete" },
    { 0x020, "badplace_cylinder" },
    { 0x021, "badplace_arc" },
    { 0x022, "badplace_brush" },
    { 0x023, "clearallcorpses" },
    { 0x024, "setturretnode" },
    { 0x025, "unsetturretnode" },
    { 0x026, "setnodepriority" },
    { 0x027, "isnodeoccupied" },
    { 0x028, "setdebugorigin" },
    { 0x029, "setdebugangles" },
    { 0x02A, "updategamerprofile" },
    { 0x02B, "assertex" },
    { 0x02C, "assertmsg" },
    { 0x02D, "isdefined" },
    { 0x02E, "isvalidmissile" },
    { 0x02F, "isstring" },
    { 0x030, "setomnvar" },
    { 0x031, "getomnvar" },
    { 0x032, "setdvar" },
    { 0x033, "setdynamicdvar" },
    { 0x034, "setdvarifuninitialized" },
    { 0x035, "setdevdvar" },
    { 0x036, "setdevdvarifuninitialized" },
    { 0x037, "getdvar" },
    { 0x038, "getdvarint" },
    { 0x039, "getdvarfloat" },
    { 0x03A, "getdvarvector" },
    { 0x03B, "gettime" },
    { 0x03C, "getentbynum" },
    { 0x03D, "getweaponmodel" },
    { 0x03E, "getculldist" },
    { 0x03F, "sethalfresparticles" },
    { 0x040, "getmapsunlight" },
    { 0x041, "setsunlight" },
    { 0x042, "resetsunlight" },
    { 0x043, "getmapsundirection" },
    { 0x044, "getmapsunangles" },
    { 0x045, "setsundirection" },
    { 0x046, "lerpsundirection" },
    { 0x047, "lerpsunangles" },
    { 0x048, "resetsundirection" },
    { 0x049, "enableforcedsunshadows" },
    { 0x04A, "enableforcednosunshadows" },
    { 0x04B, "disableforcedsunshadows" },
    { 0x04C, "enableouterspacemodellighting" },
    { 0x04D, "disableouterspacemodellighting" },
    { 0x04E, "remapstage" },
    { 0x04F, "changelevel" },
    { 0x050, "missionsuccess" },
    { 0x051, "missionfailed" },
    { 0x052, "cinematic" },
    { 0x053, "cinematicingame" },
    { 0x054, "cinematicingamesync" },
    { 0x055, "cinematicingameloop" },
    { 0x056, "cinematicingameloopresident" },
    { 0x057, "iscinematicplaying" },
    { 0x058, "stopcinematicingame" },
    { 0x059, "getweapondisplayname" },
    { 0x05A, "getweaponbasename" },
    { 0x05B, "getweaponattachments" },
    { 0x05C, "getweaponattachmentdisplaynames" },
    { 0x05D, "getweaponcamoname" },
    { 0x05E, "getweaponreticlename" },
    { 0x05F, "getweaponhidetags" },
    { 0x060, "getanimlength" },
    { 0x061, "animhasnotetrack" },
    { 0x062, "getnotetracktimes" },
    { 0x063, "spawn" },
    { 0x064, "spawnloopsound" },
    { 0x065, "spawnloopingsound" },
    { 0x066, "bullettrace" },
    { 0x067, "target_setmaxsize" },
    { 0x068, "target_setcolor" },
    { 0x069, "target_setdelay" },
    { 0x06A, "getstartorigin" },
    { 0x06B, "getstartangles" },
    { 0x06C, "getcycleoriginoffset" },
    { 0x06D, "magicgrenade" },
    { 0x06E, "magicgrenademanual" },
    { 0x06F, "setblur" },
    { 0x070, "musicplay" },
    { 0x071, "musicstop" },
    { 0x072, "soundfade" },
    { 0x073, "soundsettimescalefactor" },
    { 0x074, "soundresettimescale" },
    { 0x075, "setocclusionpreset" },
    { 0x076, "levelsoundfade" },
    { 0x077, "precachenightvisioncodeassets" },
    { 0x078, "precachedigitaldistortcodeassets" },
    { 0x079, "precacheminimapsentrycodeassets" },
    { 0x07A, "savegame" },
    { 0x07B, "issavesuccessful" },
    { 0x07C, "issaverecentlyloaded" },
    { 0x07D, "savegamenocommit" },
    { 0x07E, "commitsave" },
    { 0x07F, "commitwouldbevalid" },
    { 0x080, "getfxvisibility" },
    { 0x081, "setculldist" },
    { 0x082, "bullettracepassed" },
    { 0x083, "sighttracepassed" },
    { 0x084, "physicstrace" },
    { 0x085, "playerphysicstrace" },
    { 0x086, "getgroundposition" },
    { 0x087, "getmovedelta" },
    { 0x088, "getangledelta" },
    { 0x089, "getnorthyaw" },
    { 0x08A, "getcommandfromkey" },
    { 0x08B, "getsticksconfig" },
    { 0x08C, "weaponfightdist" },
    { 0x08D, "weaponmaxdist" },
    { 0x08E, "isturretactive" },
    { 0x08F, "target_alloc" },
    { 0x090, "target_flush" },
    { 0x091, "target_set" },
    { 0x092, "target_remove" },
    { 0x093, "target_setshader" },
    { 0x094, "target_setoffscreenshader" },
    { 0x095, "target_isinrect" },
    { 0x096, "target_isincircle" },
    { 0x097, "target_startreticlelockon" },
    { 0x098, "target_clearreticlelockon" },
    { 0x099, "target_getarray" },
    { 0x09A, "target_istarget" },
    { 0x09B, "target_setattackmode" },
    { 0x09C, "target_setjavelinonly" },
    { 0x09D, "target_hidefromplayer" },
    { 0x09E, "target_showtoplayer" },
    { 0x09F, "target_setscaledrendermode" },
    { 0x0A0, "target_drawcornersonly" },
    { 0x0A1, "target_drawsquare" },
    { 0x0A2, "target_drawsingle" },
    { 0x0A3, "target_setminsize" },
    { 0x0A4, "setnorthyaw" },
    { 0x0A5, "setslowmotion" },
    { 0x0A6, "randomint" },
    { 0x0A7, "randomfloat" },
    { 0x0A8, "randomintrange" },
    { 0x0A9, "randomfloatrange" },
    { 0x0AA, "sin" },
    { 0x0AB, "cos" },
    { 0x0AC, "tan" },
    { 0x0AD, "asin" },
    { 0x0AE, "acos" },
    { 0x0AF, "atan" },
    { 0x0B0, "int" },
    { 0x0B1, "float" },
    { 0x0B2, "abs" },
    { 0x0B3, "min" },
    { 0x0B4, "objective_additionalcurrent" },
    { 0x0B5, "objective_ring" },
    { 0x0B6, "objective_setpointertextoverride" },
    { 0x0B7, "getnode" },
    { 0x0B8, "getnodearray" },
    { 0x0B9, "getallnodes" },
    { 0x0BA, "getnodesinradius" },
    { 0x0BB, "getnodesinradiussorted" },
    { 0x0BC, "getclosestnodeinsight" },
    { 0x0BD, "getreflectionlocs" },
    { 0x0BE, "getreflectionreferencelocs" },
    { 0x0BF, "getvehicletracksegment" },
    { 0x0C0, "getvehicletracksegmentarray" },
    { 0x0C1, "getallvehicletracksegments" },
    { 0x0C2, "isarray" },
    { 0x0C3, "isai" },
    { 0x0C4, "getindexforluincstring" },
    { 0x0C5, "issentient" },
    { 0x0C6, "isgodmode" },
    { 0x0C7, "getdebugdvar" },
    { 0x0C8, "getdebugdvarint" },
    { 0x0C9, "getdebugdvarfloat" },
    { 0x0CA, "setsaveddvar" },
    { 0x0CB, "getfreeaicount" },
    { 0x0CC, "getaicount" },
    { 0x0CD, "getaiarray" },
    { 0x0CE, "getaispeciesarray" },
    { 0x0CF, "getspawnerarray" },
    { 0x0D0, "getcorpsearray" },
    { 0x0D1, "getspawnerteamarray" },
    { 0x0D2, "getweaponclipmodel" },
    { 0x0D3, "getbrushmodelcenter" },
    { 0x0D4, "getkeybinding" },
    { 0x0D5, "max" },
    { 0x0D6, "floor" },
    { 0x0D7, "ceil" },
    { 0x0D8, "exp" },
    { 0x0D9, "log" },
    { 0x0DA, "sqrt" },
    { 0x0DB, "squared" },
    { 0x0DC, "clamp" },
    { 0x0DD, "angleclamp" },
    { 0x0DE, "angleclamp180" },
    { 0x0DF, "vectorfromlinetopoint" },
    { 0x0E0, "pointonsegmentnearesttopoint" },
    { 0x0E1, "distance" },
    { 0x0E2, "distance2d" },
    { 0x0E3, "distancesquared" },
    { 0x0E4, "length" },
    { 0x0E5, "length2d" },
    { 0x0E6, "lengthsquared" },
    { 0x0E7, "length2dsquared" },
    { 0x0E8, "closer" },
    { 0x0E9, "vectordot" },
    { 0x0EA, "vectorcross" },
    { 0x0EB, "axistoangles" },
    { 0x0EC, "visionsetthermal" },
    { 0x0ED, "visionsetpain" },
    { 0x0EE, "endlobby" },
    { 0x0EF, "setac130ambience" },
    { 0x0F0, "getmapcustom" },
    { 0x0F1, "spawnsighttrace" },
    { 0x0F2, "incrementcounter" },
    { 0x0F3, "getcountertotal" },
    { 0x0F4, "getlevelticks" },
    { 0x0F5, "perlinnoise2d" },
    { 0x0F6, "calcrockingangles" },
    { 0x0F7, "reconevent" },
    { 0x0F8, "reconspatialevent" },
    { 0x0F9, "setsunflareposition" },
    { 0x0FA, "createthreatbiasgroup" },
    { 0x0FB, "threatbiasgroupexists" },
    { 0x0FC, "getthreatbias" },
    { 0x0FD, "setthreatbias" },
    { 0x0FE, "setthreatbiasagainstall" },
    { 0x0FF, "setignoremegroup" },
    { 0x100, "isenemyteam" },
    { 0x101, "objective_additionalentity" },
    { 0x102, "objective_state_nomessage" },
    { 0x103, "objective_string" },
    { 0x104, "objective_string_nomessage" },
    { 0x105, "objective_additionalposition" },
    { 0x106, "objective_current_nomessage" },
    { 0x107, "vectornormalize" },
    { 0x108, "vectortoangles" },
    { 0x109, "vectortoyaw" },
    { 0x10A, "vectorlerp" },
    { 0x10B, "anglestoup" },
    { 0x10C, "anglestoright" },
    { 0x10D, "anglestoforward" },
    { 0x10E, "anglesdelta" },
    { 0x10F, "combineangles" },
    { 0x110, "transformmove" },
    { 0x111, "rotatevector" },
    { 0x112, "rotatepointaroundvector" },
    { 0x113, "issubstr" },
    { 0x114, "isendstr" },
    { 0x115, "getsubstr" },
    { 0x116, "tolower" },
    { 0x117, "strtok" },
    { 0x118, "stricmp" },
    { 0x119, "ambientplay" },
    { 0x11A, "getuavstrengthmax" },
    { 0x11B, "getuavstrengthlevelneutral" },
    { 0x11C, "getuavstrengthlevelshowenemyfastsweep" },
    { 0x11D, "getuavstrengthlevelshowenemydirectional" },
    { 0x11E, "blockteamradar" },
    { 0x11F, "unblockteamradar" },
    { 0x120, "isteamradarblocked" },
    { 0x121, "getassignedteam" },
    { 0x122, "setmatchdata" },
    { 0x123, "getmatchdata" },
    { 0x124, "sendmatchdata" },
    { 0x125, "clearmatchdata" },
    { 0x126, "setmatchdatadef" },
    { 0x127, "setmatchclientip" },
    { 0x128, "setmatchdataid" },
    { 0x129, "setclientmatchdata" },
    { 0x12A, "getclientmatchdata" },
    { 0x12B, "setclientmatchdatadef" },
    { 0x12C, "sendclientmatchdata" },
    { 0x12D, "getbuildversion" },
    { 0x12E, "getbuildnumber" },
    { 0x12F, "getsystemtime" },
    { 0x130, "getmatchrulesdata" },
    { 0x131, "isusingmatchrulesdata" },
    { 0x132, "kick" },
    { 0x133, "issplitscreen" },
    { 0x134, "setmapcenter" },
    { 0x135, "setgameendtime" },
    { 0x136, "visionsetnaked" },
    { 0x137, "visionsetnight" },
    { 0x138, "visionsetmissilecam" },
    { 0x139, "ambientstop" },
    { 0x13A, "precachemodel" },
    { 0x13B, "precacheshellshock" },
    { 0x13C, "precacheitem" },
    { 0x13D, "precacheshader" },
    { 0x13E, "precachestring" },
    { 0x13F, "precachemenu" },
    { 0x140, "precacherumble" },
    { 0x141, "precachelocationselector" },
    { 0x142, "precacheleaderboards" },
    { 0x143, "loadfx" },
    { 0x144, "playfx" },
    { 0x145, "playfxontag" },
    { 0x146, "stopfxontag" },
    { 0x147, "killfxontag" },
    { 0x148, "playloopedfx" },
    { 0x149, "spawnfx" },
    { 0x14A, "triggerfx" },
    { 0x14B, "playfxontagforclients" },
    { 0x14C, "setwinningteam" },
    { 0x14D, "announcement" },
    { 0x14E, "clientannouncement" },
    { 0x14F, "setteammode" },
    { 0x150, "getteamscore" },
    { 0x151, "setteamscore" },
    { 0x152, "setclientnamemode" },
    { 0x153, "updateclientnames" },
    { 0x154, "getteamplayersalive" },
    { 0x155, "logprint" },
    { 0x156, "worldentnumber" },
    { 0x157, "obituary" },
    { 0x158, "positionwouldtelefrag" },
    { 0x159, "canspawn" },
    { 0x15A, "getstarttime" },
    { 0x15B, "precachestatusicon" },
    { 0x15C, "precacheheadicon" },
    { 0x15D, "precacheminimapicon" },
    { 0x15E, "precachempanim" },
    { 0x15F, "map_restart" },
    { 0x160, "exitlevel" },
    { 0x161, "addtestclient" },
    { 0x162, "addagent" },
    { 0x163, "setarchive" },
    { 0x164, "allclientsprint" },
    { 0x165, "clientprint" },
    { 0x166, "mapexists" },
    { 0x167, "isvalidgametype" },
    { 0x168, "matchend" },
    { 0x169, "setplayerteamrank" },
    { 0x16A, "endparty" },
    { 0x16B, "setteamradar" },
    { 0x16C, "getteamradar" },
    { 0x16D, "setteamradarstrength" },
    { 0x16E, "getteamradarstrength" },
    { 0x16F, "getuavstrengthmin" },
    { 0x170, "physicsexplosionsphere" },
    { 0x171, "physicsexplosioncylinder" },
    { 0x172, "physicsjolt" },
    { 0x173, "physicsjitter" },
    { 0x174, "setexpfog" },
    { 0x175, "isexplosivedamagemod" },
    { 0x176, "radiusdamage" },
    { 0x177, "setplayerignoreradiusdamage" },
    { 0x178, "glassradiusdamage" },
    { 0x179, "earthquake" },
    { 0x17A, "getnumparts" },
    { 0x17B, "objective_onentity" },
    { 0x17C, "objective_onentitywithrotation" },
    { 0x17D, "objective_team" },
    { 0x17E, "objective_player" },
    { 0x17F, "objective_playerteam" },
    { 0x180, "objective_playerenemyteam" },
    { 0x181, "objective_playermask_hidefromall" },
    { 0x182, "objective_playermask_hidefrom" },
    { 0x183, "objective_playermask_showtoall" },
    { 0x184, "objective_playermask_showto" },
    { 0x185, "iprintln" },
    { 0x186, "iprintlnbold" },
    { 0x187, "logstring" },
    { 0x188, "getent" },
    { 0x189, "getentarray" },
    { 0x18A, "getspawnarray" },
    { 0x18B, "spawnplane" },
    { 0x18C, "spawnstruct" },
    { 0x18D, "spawnhelicopter" },
    { 0x18E, "isalive" },
    { 0x18F, "isspawner" },
    { 0x190, "missile_createattractorent" },
    { 0x191, "missile_createattractororigin" },
    { 0x192, "missile_createrepulsorent" },
    { 0x193, "missile_createrepulsororigin" },
    { 0x194, "missile_deleteattractor" },
    { 0x195, "playsoundatpos" },
    { 0x196, "newhudelem" },
    { 0x197, "newclienthudelem" },
    { 0x198, "newteamhudelem" },
    { 0x199, "resettimeout" },
    { 0x19A, "isplayer" },
    { 0x19B, "isplayernumber" },
    { 0x19C, "getpartname" },
    { 0x19D, "weaponfiretime" },
    { 0x19E, "weaponclipsize" },
    { 0x19F, "weaponisauto" },
    { 0x1A0, "weaponissemiauto" },
    { 0x1A1, "weaponisboltaction" },
    { 0x1A2, "weaponinheritsperks" },
    { 0x1A3, "weaponburstcount" },
    { 0x1A4, "weapontype" },
    { 0x1A5, "weaponclass" },
    { 0x1A6, "getnextarraykey" },
    { 0x1A7, "sortbydistance" },
    { 0x1A8, "tablelookup" },
    { 0x1A9, "tablelookupbyrow" },
    { 0x1AA, "tablelookupistring" },
    { 0x1AB, "tablelookupistringbyrow" },
    { 0x1AC, "tablelookuprownum" },
    { 0x1AD, "tableexists" },
    { 0x1AE, "getmissileowner" },
    { 0x1AF, "magicbullet" },
    { 0x1B0, "getweaponflashtagname" },
    { 0x1B1, "averagepoint" },
    { 0x1B2, "averagenormal" },
    { 0x1B3, "vehicle_getspawnerarray" },
    { 0x1B4, "playrumbleonposition" },
    { 0x1B5, "playrumblelooponposition" },
    { 0x1B6, "stopallrumbles" },
    { 0x1B7, "soundexists" },
    { 0x1B8, "openfile" },
    { 0x1B9, "closefile" },
    { 0x1BA, "fprintln" },
    { 0x1BB, "fprintfields" },
    { 0x1BC, "freadln" },
    { 0x1BD, "fgetarg" },
    { 0x1BE, "setminimap" },
    { 0x1BF, "setthermalbodymaterial" },
    { 0x1C0, "getarraykeys" },
    { 0x1C1, "getfirstarraykey" },
    { 0x1C2, "getglass" },
    { 0x1C3, "getglassarray" },
    { 0x1C4, "getglassorigin" },
    { 0x1C5, "isglassdestroyed" },
    { 0x1C6, "destroyglass" },
    { 0x1C7, "deleteglass" },
    { 0x1C8, "getentchannelscount" },
    { 0x1C9, "getentchannelname" },
    { 0x1CA, "objective_add" },
    { 0x1CB, "objective_delete" },
    { 0x1CC, "objective_state" },
    { 0x1CD, "objective_icon" },
    { 0x1CE, "objective_position" },
    { 0x1CF, "objective_current" },
    { 0x1D0, "weaponinventorytype" },
    { 0x1D1, "weaponstartammo" },
    { 0x1D2, "weaponmaxammo" },
    { 0x1D3, "weaponaltweaponname" },
    { 0x1D4, "isweaponcliponly" },
    { 0x1D5, "isweapondetonationtimed" },
    { 0x1D6, "weaponhasthermalscope" },
    { 0x1D7, "getvehiclenode" },
    { 0x1D8, "getvehiclenodearray" },
    { 0x1D9, "getallvehiclenodes" },
    { 0x1DA, "getnumvehicles" },
    { 0x1DB, "precachevehicle" },
    { 0x1DC, "spawnvehicle" },
    { 0x1DD, "vehicle_getarray" },
    { 0x1DE, "pow" },
    { 0x1DF, "botgetmemoryevents" },
    { 0x1E0, "botautoconnectenabled" },
    { 0x1E1, "botzonegetcount" },
    { 0x1E2, "botzonesetteam" },
    { 0x1E3, "botzonenearestcount" },
    { 0x1E4, "botmemoryflags" },
    { 0x1E5, "botflagmemoryevents" },
    { 0x1E6, "botzonegetindoorpercent" },
    { 0x1E7, "botsentientswap" },
    { 0x1E8, "isbot" },
    { 0x1E9, "isagent" },
    { 0x1EA, "getmaxagents" },
    { 0x1EB, "botdebugdrawtrigger" },
    { 0x1EC, "botgetclosestnavigablepoint" },
    { 0x1ED, "gettnodesintrigger" },
    { 0x1EE, "nodesvisible" },
    { 0x1EF, "getnodesonpath" },
    { 0x1F0, "getzonecount" },
    { 0x1F1, "getzonenearest" },
    { 0x1F2, "getzonenodes" },
    { 0x1F3, "getzonepath" },
    { 0x1F4, "getzoneorigin" },
    { 0x1F5, "getnodezone" },
    { 0x1F6, "getzonenodesbydist" },
    { 0x1F7, "getzonenodeforindex" },
    { 0x1F8, "getweaponexplosionradius" },
    { 0x1F9, "markdangerousnodes" },
    { 0x1FA, "markdangerousnodesintrigger" },
    { 0x1FB, "nodeexposedtosky" },
    { 0x1FC, "findentrances" },
    { 0x1FD, "badplace_global" },
    { 0x1FE, "getpathdist" },
    { 0x1FF, "getlinkednodes" },
    { 0x200, "disconnectnodepair" },
    { 0x201, "connectnodepair" },
    { 0x202, "drawsoundshape" },
    { 0x203, "gettimesincelastpaused" },
    { 0x204, "setlasermaterial" },
    { 0x205, "precachefxontag" },
    { 0x206, "precachetag" },
    { 0x207, "precachesound" },
    { 0x208, "devsetminimapdvarsettings" },
    { 0x209, "loadtransient" },
    { 0x20A, "unloadtransient" },
    { 0x20B, "unloadalltransients" },
    { 0x20C, "synctransients" },
    { 0x20D, "istransientqueued" },
    { 0x20E, "istransientloaded" },
    { 0x20F, "loadstartpointtransient" },
    { 0x210, "distance2dsquared" },
    { 0x211, "getangledelta3d" },
    { 0x212, "activateclientexploder" },
    { 0x213, "trajectorycalculateinitialvelocity" },
    { 0x214, "trajectorycalculateminimumvelocity" },
    { 0x215, "trajectorycalculateexitangle" },
    { 0x216, "trajectoryestimatedesiredinairtime" },
    { 0x217, "trajectorycomputedeltaheightattime" },
    { 0x218, "trajectorycanattemptaccuratejump" },
    { 0x219, "adddebugcommand" },
    { 0x21A, "ispointinvolume" },
    { 0x21B, "cinematicgettimeinmsec" },
    { 0x21C, "cinematicgetframe" },
    { 0x21D, "iscinematicloaded" },
    { 0x21E, "bbprint" },
    { 0x21F, "getenemysquaddata" },
    { 0x220, "lookupsoundlength" },
    { 0x221, "getscriptablearray" },
    { 0x222, "clearfog" },
    { 0x223, "setleveldopplerpreset" },
    { 0x224, "screenshake" },
    { 0x225, "anglestoaxis" },
    { 0x226, "visionsetwater" },
    { 0x227, "sendscriptusageanalysisdata" },
    { 0x228, "resetscriptusageanalysisdata" },
    { 0x229, "instantlylogusageanalysisdata" },
    { 0x22A, "invertangles" },
    { 0x22B, "rotatevectorinverted" },
    { 0x22C, "calculatestartorientation" },
    { 0x22D, "getcsplinecount" },
    { 0x22E, "getcsplinepointcount" },
    { 0x22F, "getcsplinelength" },
    { 0x230, "getcsplinepointid" },
    { 0x231, "getcsplinepointlabel" },
    { 0x232, "getcsplinepointtension" },
    { 0x233, "getcsplinepointposition" },
    { 0x234, "getcsplinepointcorridordims" },
    { 0x235, "getcsplinepointtangent" },
    { 0x236, "getcsplinepointdisttonextpoint" },
    { 0x237, "calccsplineposition" },
    { 0x238, "calccsplinetangent" },
    { 0x239, "calccsplinecorridor" },
    { 0x23A, "setnojipscore" },
    { 0x23B, "setnojiptime" },
    { 0x23C, "getpredictedentityposition" },
    { 0x23D, "gamedvrprohibitrecording" },
    { 0x23E, "gamedvrstartrecording" },
    { 0x23F, "gamedvrstoprecording" },
    { 0x240, "gamedvrsetvideometadata" },
    { 0x241, "gamedvrprohibitscreenshots" },
    { 0x242, "gamedvrsetscreenshotmetadata" },
    { 0x243, "queuedialog" },
    { 0x244, "speechenablegrammar" },
    { 0x245, "speechenable" },
    { 0x246, "livestreamingenable" },
    { 0x247, "livestreamingsetbitrate" },
    { 0x248, "triggerportableradarping" },
    { 0x249, "setglaregrimematerial" },
    { 0x24A, "botgetteamlimit" },
    { 0x24B, "spawnfxforclient" },
    { 0x24C, "botgetteamdifficulty" },
    { 0x24D, "getsquadassaultelo" },
    { 0x24E, "loadluifile" },
    { 0x24F, "isdedicatedserver" },
    { 0x250, "getplaylistversion" },
    { 0x251, "getplaylistid" },
    { 0x252, "getactiveclientcount" },
    { 0x253, "issquadsmode" },
    { 0x254, "getsquadassaultsquadindex" },
    { 0x255, "visionsetpostapply" },
    { 0x256, "addbot" },
    { 0x257, "ishairrunning" },
    { 0x258, "getsquadassaultenemyprestige" },
    { 0x259, "playcinematicforall" },
    { 0x25A, "preloadcinematicforall" },
    { 0x25B, "stopcinematicforall" },
    { 0x25C, "getenemysquaddogtype" },
    { 0x25D, "capsuletracepassed" },
}};

} // namespace xsk::gsc::iw6_pc
