// Copyright 2024 xensik. All rights reserved.
//
// Use of this source code is governed by a GNU GPLv3 license
// that can be found in the LICENSE file.

#include "xsk/gsc/engine/iw8.hpp"

namespace xsk::gsc::iw8
{

extern std::array<std::pair<u16, char const*>, func_count> const func_list
{{
    { 0x001, "abs" },
    { 0x002, "acos" },
    { 0x003, "activateclientexploder" },
    { 0x004, "addagent" },
    { 0x005, "addbot" },
    { 0x006, "addtestclient" },
    { 0x007, "allclientsprint" },
    { 0x008, "ambientplay" },
    { 0x009, "ambientstop" },
    { 0x00A, "angleclamp" },
    { 0x00B, "angleclamp180" },
    { 0x00C, "anglesdelta" },
    { 0x00D, "anglestoaxis" },
    { 0x00E, "anglestoforward" },
    { 0x00F, "anglestoright" },
    { 0x010, "anglestoup" },
    { 0x011, "animhasnotetrack" },
    { 0x012, "announcement" },
    { 0x013, "asin" },
    { 0x014, "atan" },
    { 0x015, "averagenormal" },
    { 0x016, "averagepoint" },
    { 0x017, "axistoangles" },
    { 0x018, "badplace_cylinder" },
    { 0x019, "badplace_delete" },
    { 0x01A, "badplace_global" },
    { 0x01B, "bbprint" },
    { 0x01C, "blockteamradar" },
    { 0x01D, "botsystemstatus" },
    { 0x01E, "botdebugdrawtrigger" },
    { 0x01F, "botflagmemoryevents" },
    { 0x020, "botgetclosestnavigablepoint" },
    { 0x021, "botgetmemoryevents" },
    { 0x022, "botgetteamdifficulty" },
    { 0x023, "botgetteamlimit" },
    { 0x024, "botmemoryflags" },
    { 0x025, "botsentientswap" },
    { 0x026, "botzonegetcount" },
    { 0x027, "botzonegetindoorpercent" },
    { 0x028, "botzonenearestcount" },
    { 0x029, "botzonesetteam" },
    { 0x02A, "bulletspread" },
    { 0x02B, "bullettracer" },
    { 0x02C, "calccsplinecorridor" },
    { 0x02D, "calccsplineposition" },
    { 0x02E, "calccsplinetangent" },
    { 0x02F, "calcrockingangles" },
    { 0x030, "calculatestartorientation" },
    { 0x031, "canspawn" },
    { 0x032, "canspawnturret" },
    { 0x033, "capsuletracepassed" },
    { 0x034, "ceil" },
    { 0x035, "changelevel" },
    { 0x036, "cinematic" },
    { 0x037, "cinematicgetframe" },
    { 0x038, "cinematicgettimeinmsec" },
    { 0x039, "cinematicingame" },
    { 0x03A, "cinematicingameloop" },
    { 0x03B, "cinematicingameloopresident" },
    { 0x03C, "cinematicingamesync" },
    { 0x03D, "clamp" },
    { 0x03E, "clearallcorpses" },
    { 0x03F, "clearlocalizedstrings" },
    { 0x040, "clearmatchdata" },
    { 0x041, "clientannouncement" },
    { 0x042, "clientprint" },
    { 0x043, "closer" },
    { 0x044, "combineangles" },
    { 0x045, "commitsave" },
    { 0x046, "commitwouldbevalid" },
    { 0x047, "connectnodepair" },
    { 0x048, "cos" },
    { 0x049, "createnavlink" },
    { 0x04A, "createthreatbiasgroup" },
    { 0x04B, "deleteglass" },
    { 0x04C, "destroyglass" },
    { 0x04D, "destroynavlink" },
    { 0x04E, "devsetminimapdvarsettings" },
    { 0x04F, "disableaudiotrigger" },
    { 0x050, "disableforcedsunshadows" },
    { 0x051, "disableouterspacemodellighting" },
    { 0x052, "disablepaspeaker" },
    { 0x053, "disconnectnodepair" },
    { 0x054, "distance" },
    { 0x055, "distance2d" },
    { 0x056, "distance2dsquared" },
    { 0x057, "distancesquared" },
    { 0x058, "drawcompassfriendlies" },
    { 0x059, "earthquake" },
    { 0x05A, "enableaudiotrigger" },
    { 0x05B, "enableforcednosunshadows" },
    { 0x05C, "enableforcedsunshadows" },
    { 0x05D, "enableouterspacemodellighting" },
    { 0x05E, "enablepaspeaker" },
    { 0x05F, "endlobby" },
    { 0x060, "endparty" },
    { 0x061, "exitlevel" },
    { 0x062, "exp" },
    { 0x063, "findentrances" },
    { 0x064, "float" },
    { 0x065, "floor" },
    { 0x066, "gamedvrprohibitrecording" },
    { 0x067, "gamedvrprohibitscreenshots" },
    { 0x068, "gamedvrsetscreenshotmetadata" },
    { 0x069, "gamedvrsetvideometadata" },
    { 0x06A, "gamedvrstartrecording" },
    { 0x06B, "gamedvrstoprecording" },
    { 0x06C, "getactiveclientcount" },
    { 0x06D, "getaiarray" },
    { 0x06E, "getaiarrayinradius" },
    { 0x06F, "getaicount" },
    { 0x070, "getaispeciesarray" },
    { 0x071, "getaiunittypearray" },
    { 0x072, "getallnodes" },
    { 0x073, "getallvehiclenodes" },
    { 0x074, "getangledelta" },
    { 0x075, "getangledelta3d" },
    { 0x076, "getanimlength" },
    { 0x077, "getarraykeys" },
    { 0x078, "getassignedteam" },
    { 0x079, "getbrushmodelcenter" },
    { 0x07A, "getbuildnumber" },
    { 0x07B, "getbuildversion" },
    { 0x07C, "getclientmatchdata" },
    { 0x07D, "getclosestnodeinsight" },
    { 0x07E, "getcorpsearray" },
    { 0x07F, "getcorpsearrayinradius" },
    { 0x080, "getcountertotal" },
    { 0x081, "getcsplinecount" },
    { 0x082, "getcsplinelength" },
    { 0x083, "getcsplinepointcorridordims" },
    { 0x084, "getcsplinepointcount" },
    { 0x085, "getcsplinepointdisttonextpoint" },
    { 0x086, "getcsplinepointid" },
    { 0x087, "getcsplinepointlabel" },
    { 0x088, "getcsplinepointposition" },
    { 0x089, "getcsplinepointtangent" },
    { 0x08A, "getcsplinepointtension" },
    { 0x08B, "getculldist" },
    { 0x08C, "getcycleoriginoffset" },
    { 0x08D, "getdvar" },
    { 0x08E, "getdvarfloat" },
    { 0x08F, "getdvarint" },
    { 0x090, "getgamebattlematchreportstate" },
    { 0x091, "getdvarvector" },
    { 0x092, "getenemysquaddata" },
    { 0x093, "getenemysquaddogtype" },
    { 0x094, "getent" },
    { 0x095, "getentarray" },
    { 0x096, "getentarrayinradius" },
    { 0x097, "getentchannelname" },
    { 0x098, "getentchannelscount" },
    { 0x099, "getfirstarraykey" },
    { 0x09A, "getfreeaicount" },
    { 0x09B, "getfxvisibility" },
    { 0x09C, "getgametypeindex" },
    { 0x09D, "getglass" },
    { 0x09E, "getglassarray" },
    { 0x09F, "getglassorigin" },
    { 0x0A0, "getgroundposition" },
    { 0x0A1, "getindexforluincstring" },
    { 0x0A2, "getkeybinding" },
    { 0x0A3, "getlastarraykey" },
    { 0x0A4, "getlinkednodes" },
    { 0x0A5, "getmapsunangles" },
    { 0x0A6, "getmapsundirection" },
    { 0x0A7, "getmapsunlight" },
    { 0x0A8, "getmapsuncolorraw" },
    { 0x0A9, "getmapsuncolorandintensity" },
    { 0x0AA, "getmatchdata" },
    { 0x0AB, "getmatchrulesdata" },
    { 0x0AC, "getmaxagents" },
    { 0x0AD, "getmissileowner" },
    { 0x0AE, "getmovedelta" },
    { 0x0AF, "getnextarraykey" },
    { 0x0B0, "getnode" },
    { 0x0B1, "getnodearray" },
    { 0x0B2, "getnodesinradius" },
    { 0x0B3, "getnodesinradiussorted" },
    { 0x0B4, "getnodesintrigger" },
    { 0x0B5, "getnodesonpath" },
    { 0x0B6, "getnodezone" },
    { 0x0B7, "getnorthyaw" },
    { 0x0B8, "getnotetracktimes" },
    { 0x0B9, "getnumparts" },
    { 0x0BA, "getnumvehicles" },
    { 0x0BB, "getomnvar" },
    { 0x0BC, "getpartname" },
    { 0x0BD, "getanimname" },
    { 0x0BE, "getpathdist" },
    { 0x0BF, "getplaylistid" },
    { 0x0C0, "getplaylistversion" },
    { 0x0C1, "getpredictedentityposition" },
    { 0x0C2, "getprevarraykey" },
    { 0x0C3, "getscriptablearray" },
    { 0x0C4, "getscriptablearrayinradius" },
    { 0x0C5, "getspawnarray" },
    { 0x0C6, "getspawner" },
    { 0x0C7, "getspawnerarray" },
    { 0x0C8, "getspawnerteamarray" },
    { 0x0C9, "getsquadassaultelo" },
    { 0x0CA, "getsquadassaultenemyprestige" },
    { 0x0CB, "getsquadassaultsquadindex" },
    { 0x0CC, "getstartangles" },
    { 0x0CD, "getstartorigin" },
    { 0x0CE, "getstarttime" },
    { 0x0CF, "getsticksconfig" },
    { 0x0D0, "getsubstr" },
    { 0x0D1, "getsystemtime" },
    { 0x0D2, "getteamplayersalive" },
    { 0x0D3, "getteamradar" },
    { 0x0D4, "getteamradarstrength" },
    { 0x0D5, "getteamscore" },
    { 0x0D6, "getthreatbias" },
    { 0x0D7, "gettime" },
    { 0x0D8, "gettimescale" },
    { 0x0D9, "gettimesincelastpaused" },
    { 0x0DA, "getuavstrengthlevelneutral" },
    { 0x0DB, "getuavstrengthlevelshowenemydirectional" },
    { 0x0DC, "getuavstrengthlevelshowenemyfastsweep" },
    { 0x0DD, "getuavstrengthmax" },
    { 0x0DE, "getuavstrengthmin" },
    { 0x0DF, "getvehiclenode" },
    { 0x0E0, "getvehiclenodearray" },
    { 0x0E1, "getweaponammopoolname" },
    { 0x0E2, "getweaponarray" },
    { 0x0E3, "getweaponarrayinradius" },
    { 0x0E4, "getweaponattachments" },
    { 0x0E5, "getweaponattachmentworldmodels" },
    { 0x0E6, "getweaponbasename" },
    { 0x0E7, "getweaponcamoname" },
    { 0x0E8, "getweaponclipmodel" },
    { 0x0E9, "getweaponexplosionradius" },
    { 0x0EA, "getweaponflashtagname" },
    { 0x0EB, "getweaponhidetags" },
    { 0x0EC, "getweaponmodel" },
    { 0x0ED, "getweaponreticlename" },
    { 0x0EE, "getzonecount" },
    { 0x0EF, "getzonenearest" },
    { 0x0F0, "getzonenodeforindex" },
    { 0x0F1, "getzonenodes" },
    { 0x0F2, "getzonenodesbydist" },
    { 0x0F3, "getzoneorigin" },
    { 0x0F4, "getzonepath" },
    { 0x0F5, "glassradiusdamage" },
    { 0x0F6, "hidemayhem" },
    { 0x0F7, "incrementcounter" },
    { 0x0F8, "instantlylogusageanalysisdata" },
    { 0x0F9, "int" },
    { 0x0FA, "invertangles" },
    { 0x0FB, "iprintln" },
    { 0x0FC, "iprintlnbold" },
    { 0x0FD, "isagent" },
    { 0x0FE, "isscriptedagent" },
    { 0x0FF, "isai" },
    { 0x100, "isalive" },
    { 0x101, "isarray" },
    { 0x102, "isbot" },
    { 0x103, "iscinematicloaded" },
    { 0x104, "iscinematicplaying" },
    { 0x105, "isdedicatedserver" },
    { 0x106, "isendstr" },
    { 0x107, "isstartstr" },
    { 0x108, "isenemyteam" },
    { 0x109, "isexplosivedamagemod" },
    { 0x10A, "isfloat" },
    { 0x10B, "isglassdestroyed" },
    { 0x10C, "isgodmode" },
    { 0x10D, "ishairrunning" },
    { 0x10E, "isint" },
    { 0x10F, "isistring" },
    { 0x110, "ismayhem" },
    { 0x111, "isnodeoccupied" },
    { 0x112, "isplayer" },
    { 0x113, "isplayernumber" },
    { 0x114, "ispointinvolume" },
    { 0x115, "issaverecentlyloaded" },
    { 0x116, "issavesuccessful" },
    { 0x117, "issentient" },
    { 0x118, "isspawner" },
    { 0x119, "issplitscreen" },
    { 0x11A, "issquadsmode" },
    { 0x11B, "isstring" },
    { 0x11C, "issubstr" },
    { 0x11D, "isteamradarblocked" },
    { 0x11E, "istransientloaded" },
    { 0x11F, "istransientqueued" },
    { 0x120, "isturretactive" },
    { 0x121, "isusingmatchrulesdata" },
    { 0x122, "isvalidmissile" },
    { 0x123, "isweaponcliponly" },
    { 0x124, "isweapondetonationtimed" },
    { 0x125, "kick" },
    { 0x126, "killfxontag" },
    { 0x127, "killmayhem" },
    { 0x128, "length" },
    { 0x129, "length2d" },
    { 0x12A, "length2dsquared" },
    { 0x12B, "lengthsquared" },
    { 0x12C, "lerpsunangles" },
    { 0x12D, "lerpsundirection" },
    { 0x12E, "levelsoundfade" },
    { 0x12F, "livestreamingenable" },
    { 0x130, "livestreamingsetbitrate" },
    { 0x131, "loadfx" },
    { 0x132, "loadluifile" },
    { 0x133, "loadstartpointtransients" },
    { 0x134, "loadtransient" },
    { 0x135, "log" },
    { 0x136, "logprint" },
    { 0x137, "logstring" },
    { 0x138, "lookupsoundlength" },
    { 0x139, "magicbullet" },
    { 0x13A, "magicgrenade" },
    { 0x13B, "magicgrenademanual" },
    { 0x13C, "map_restart" },
    { 0x13D, "mapexists" },
    { 0x13E, "matchend" },
    { 0x13F, "max" },
    { 0x140, "min" },
    { 0x141, "missile_createattractorent" },
    { 0x142, "missile_createattractororigin" },
    { 0x143, "missile_createrepulsorent" },
    { 0x144, "missile_createrepulsororigin" },
    { 0x145, "missile_deleteattractor" },
    { 0x146, "missionfailed" },
    { 0x147, "missionsuccess" },
    { 0x148, "musicplay" },
    { 0x149, "musicstop" },
    { 0x14A, "newclienthudelem" },
    { 0x14B, "newhudelem" },
    { 0x14C, "newteamhudelem" },
    { 0x14D, "nodeexposedtosky" },
    { 0x14E, "nodesvisible" },
    { 0x14F, "notifyoncommand" },
    { 0x150, "obituary" },
    { 0x151, "objective_current" },
    { 0x152, "objective_delete" },
    { 0x153, "objective_icon" },
    { 0x154, "objective_onentity" },
    { 0x155, "objective_setzoffset" },
    { 0x156, "objective_position" },
    { 0x157, "objective_setlocation" },
    { 0x158, "objective_unsetlocation" },
    { 0x159, "objective_setlabel" },
    { 0x15A, "objective_setfriendlylabel" },
    { 0x15B, "objective_setenemylabel" },
    { 0x15C, "objective_setneutrallabel" },
    { 0x15D, "objective_state" },
    { 0x15E, "objective_setpinned" },
    { 0x15F, "objective_pinforclient" },
    { 0x160, "objective_unpinforclient" },
    { 0x161, "objective_pinforteam" },
    { 0x162, "objective_unpinforteam" },
    { 0x163, "objective_setdescription" },
    { 0x164, "objective_setplayintro" },
    { 0x165, "objective_setplayoutro" },
    { 0x166, "objective_sethot" },
    { 0x167, "objective_setpulsate" },
    { 0x168, "objective_setshowdistance" },
    { 0x169, "objective_setrotateonminimap" },
    { 0x16A, "objective_setshowoncompass" },
    { 0x16B, "objective_setminimapiconsize" },
    { 0x16C, "objective_setbackground" },
    { 0x16D, "objective_setshowprogress" },
    { 0x16E, "objective_showprogressforclient" },
    { 0x16F, "objective_hideprogressforclient" },
    { 0x170, "objective_showprogressforteam" },
    { 0x171, "objective_hideprogressforteam" },
    { 0x172, "objective_setprogress" },
    { 0x173, "objective_setownerclient" },
    { 0x174, "objective_setownerteam" },
    { 0x175, "objective_setprogressclient" },
    { 0x176, "objective_setprogressteam" },
    { 0x177, "objective_addclienttomask" },
    { 0x178, "objective_addteamtomask" },
    { 0x179, "objective_addalltomask" },
    { 0x17A, "objective_removeclientfrommask" },
    { 0x17B, "objective_removeteamfrommask" },
    { 0x17C, "objective_removeallfrommask" },
    { 0x17D, "objective_showtoplayersinmask" },
    { 0x17E, "objective_hidefromplayersinmask" },
    { 0x17F, "objective_setfadedisabled" },
    { 0x180, "objective_ping" },
    { 0x181, "objective_setpings" },
    { 0x182, "objective_setpingsforteam" },
    { 0x183, "pausecinematicingame" },
    { 0x184, "pausemayhem" },
    { 0x185, "perlinnoise2d" },
    { 0x186, "physicsexplosionsphere" },
    { 0x187, "physicsjitter" },
    { 0x188, "physicsjolt" },
    { 0x189, "physicstrace" },
    { 0x18A, "playcinematicforall" },
    { 0x18B, "playerphysicstrace" },
    { 0x18C, "playfx" },
    { 0x18D, "playfxontag" },
    { 0x18E, "playfxontagforclients" },
    { 0x18F, "playloopedfx" },
    { 0x190, "playmayhem" },
    { 0x191, "playrumblelooponposition" },
    { 0x192, "playrumbleonposition" },
    { 0x193, "playsoundatpos" },
    { 0x194, "playworldsound" },
    { 0x195, "pointonsegmentnearesttopoint" },
    { 0x196, "positionwouldtelefrag" },
    { 0x197, "pow" },
    { 0x198, "precachedigitaldistortcodeassets" },
    { 0x199, "precachefxontag" },
    { 0x19A, "precacheitem" },
    { 0x19B, "precacheleaderboards" },
    { 0x19C, "precacheminimapicon" },
    { 0x19D, "precacheminimapsentrycodeassets" },
    { 0x19E, "precachemodel" },
    { 0x19F, "precachecompositemodel" },
    { 0x1A0, "precachempanim" },
    { 0x1A1, "precachenightvisioncodeassets" },
    { 0x1A2, "precacherumble" },
    { 0x1A3, "precacheshader" },
    { 0x1A4, "precachestatusicon" },
    { 0x1A5, "precachestring" },
    { 0x1A6, "precachetag" },
    { 0x1A7, "precacheturret" },
    { 0x1A8, "precachevehicle" },
    { 0x1A9, "preloadcinematicforall" },
    { 0x1AA, "queuedialog" },
    { 0x1AB, "radiusdamage" },
    { 0x1AC, "randomfloat" },
    { 0x1AD, "randomfloatrange" },
    { 0x1AE, "randomint" },
    { 0x1AF, "randomintrange" },
    { 0x1B0, "reconevent" },
    { 0x1B1, "reconspatialevent" },
    { 0x1B2, "remapstage" },
    { 0x1B3, "resetscriptusageanalysisdata" },
    { 0x1B4, "resetsundirection" },
    { 0x1B5, "resetsunlight" },
    { 0x1B6, "resettimeout" },
    { 0x1B7, "rotatepointaroundvector" },
    { 0x1B8, "rotatevector" },
    { 0x1B9, "rotatevectorinverted" },
    { 0x1BA, "savegame" },
    { 0x1BB, "savegamenocommit" },
    { 0x1BC, "screenshake" },
    { 0x1BD, "sendclientmatchdata" },
    { 0x1BE, "sendmatchdata" },
    { 0x1BF, "sendscriptusageanalysisdata" },
    { 0x1C0, "setac130ambience" },
    { 0x1C1, "setblur" },
    { 0x1C2, "setclientmatchdata" },
    { 0x1C3, "setclientmatchdatadef" },
    { 0x1C4, "setclientnamemode" },
    { 0x1C5, "setculldist" },
    { 0x1C6, "setdvar" },
    { 0x1C7, "setdvarifuninitialized" },
    { 0x1C8, "setdynamicdvar" },
    { 0x1C9, "setgameendtime" },
    { 0x1CA, "setglaregrimematerial" },
    { 0x1CB, "sethalfresparticles" },
    { 0x1CC, "setignoremegroup" },
    { 0x1CD, "setlasermaterial" },
    { 0x1CE, "setmapcenter" },
    { 0x1CF, "setmatchclientip" },
    { 0x1D0, "setmatchdata" },
    { 0x1D1, "setmatchdatadef" },
    { 0x1D2, "setmatchdataid" },
    { 0x1D3, "setminimap" },
    { 0x1D4, "setmusicstate" },
    { 0x1D5, "setnodepriority" },
    { 0x1D6, "setnojipscore" },
    { 0x1D7, "setnojiptime" },
    { 0x1D8, "setocclusionpreset" },
    { 0x1D9, "setomnvar" },
    { 0x1DA, "setomnvarforallclients" },
    { 0x1DB, "setomnvarbit" },
    { 0x1DC, "setplayerignoreradiusdamage" },
    { 0x1DD, "setplayerteamrank" },
    { 0x1DE, "doentitiessharehierarchy" },
    { 0x1DF, "setsaveddvar" },
    { 0x1E0, "setslowmotion" },
    { 0x1E1, "setslowmotionview" },
    { 0x1E2, "setsundirection" },
    { 0x1E3, "setsunflareposition" },
    { 0x1E4, "setsuncolorandintensity" },
    { 0x1E5, "setteammode" },
    { 0x1E6, "setteamradar" },
    { 0x1E7, "setteamradarstrength" },
    { 0x1E8, "setteamscore" },
    { 0x1E9, "setthermalbodymaterial" },
    { 0x1EA, "setthreatbias" },
    { 0x1EB, "setthreatbiasagainstall" },
    { 0x1EC, "settimescale" },
    { 0x1ED, "setturretnode" },
    { 0x1EE, "setumbraportalstate" },
    { 0x1EF, "setwinningteam" },
    { 0x1F0, "showmayhem" },
    { 0x1F1, "sighttracepassed" },
    { 0x1F2, "sin" },
    { 0x1F3, "sortbydistance" },
    { 0x1F4, "soundexists" },
    { 0x1F5, "soundfade" },
    { 0x1F6, "soundislooping" },
    { 0x1F7, "soundresettimescale" },
    { 0x1F8, "soundsettimescalefactor" },
    { 0x1F9, "spawn" },
    { 0x1FA, "spawnbrcircle" },
    { 0x1FB, "spawnfx" },
    { 0x1FC, "spawnfxforclient" },
    { 0x1FD, "spawnhelicopter" },
    { 0x1FE, "spawnloopingsound" },
    { 0x1FF, "spawnmayhem" },
    { 0x200, "spawnplane" },
    { 0x201, "spawnragdollconstraint" },
    { 0x202, "spawnsighttrace" },
    { 0x203, "spawnstruct" },
    { 0x204, "spawnturret" },
    { 0x205, "spawnvehicle" },
    { 0x206, "speechenable" },
    { 0x207, "speechenablegrammar" },
    { 0x208, "sqrt" },
    { 0x209, "squared" },
    { 0x20A, "stopallrumbles" },
    { 0x20B, "stopcinematicforall" },
    { 0x20C, "stopcinematicingame" },
    { 0x20D, "stopfxontag" },
    { 0x20E, "stricmp" },
    { 0x20F, "strtok" },
    { 0x210, "synctransients" },
    { 0x211, "tableexists" },
    { 0x212, "tablelookup" },
    { 0x213, "tablelookupbyrow" },
    { 0x214, "tablelookupgetnumrows" },
    { 0x215, "tablelookupgetnumcols" },
    { 0x216, "tablelookupistring" },
    { 0x217, "tablelookupistringbyrow" },
    { 0x218, "tablelookuprownum_startfromrow" },
    { 0x219, "tablelookuprownum_reversefromrow" },
    { 0x21A, "tablelookuprownum" },
    { 0x21B, "tan" },
    { 0x21C, "target_alloc" },
    { 0x21D, "target_clearreticlelockon" },
    { 0x21E, "target_drawcornersonly" },
    { 0x21F, "target_drawsingle" },
    { 0x220, "target_drawsquare" },
    { 0x221, "target_flush" },
    { 0x222, "target_getarray" },
    { 0x223, "target_gettargetatindex" },
    { 0x224, "target_getindexoftarget" },
    { 0x225, "target_hidefromplayer" },
    { 0x226, "target_isincircle" },
    { 0x227, "target_isinrect" },
    { 0x228, "target_istarget" },
    { 0x229, "target_remove" },
    { 0x22A, "target_set" },
    { 0x22B, "target_setattackmode" },
    { 0x22C, "target_setcolor" },
    { 0x22D, "target_setdelay" },
    { 0x22E, "target_setjavelinonly" },
    { 0x22F, "target_setmaxsize" },
    { 0x230, "target_setminsize" },
    { 0x231, "target_setoffscreenshader" },
    { 0x232, "target_setscaledrendermode" },
    { 0x233, "target_setshader" },
    { 0x234, "target_showtoplayer" },
    { 0x235, "target_startreticlelockon" },
    { 0x236, "teleportscene" },
    { 0x237, "threatbiasgroupexists" },
    { 0x238, "tolower" },
    { 0x239, "trajectorycalculateexitangle" },
    { 0x23A, "trajectorycalculateinitialvelocity" },
    { 0x23B, "trajectorycalculateminimumvelocity" },
    { 0x23C, "trajectorycanattemptaccuratejump" },
    { 0x23D, "trajectorycomputedeltaheightattime" },
    { 0x23E, "trajectoryestimatedesiredinairtime" },
    { 0x23F, "transformmove" },
    { 0x240, "triggerfx" },
    { 0x241, "triggerportableradarping" },
    { 0x242, "pinglocationenemyteams" },
    { 0x243, "triggeroneoffradarsweep" },
    { 0x244, "unblockteamradar" },
    { 0x245, "unloadalltransients" },
    { 0x246, "unloadtransient" },
    { 0x247, "unsetturretnode" },
    { 0x248, "updateclientnames" },
    { 0x249, "updategamerprofile" },
    { 0x24A, "updategamerprofileall" },
    { 0x24B, "vectorcross" },
    { 0x24C, "vectordot" },
    { 0x24D, "vectorfromlinetopoint" },
    { 0x24E, "vectorlerp" },
    { 0x24F, "vectornormalize" },
    { 0x250, "vectortoangles" },
    { 0x251, "vectortoyaw" },
    { 0x252, "vehicle_getarray" },
    { 0x253, "vehicle_getspawnerarray" },
    { 0x254, "vehicle_allowplayeruse" },
    { 0x255, "visionsetalternate" },
    { 0x256, "visionsetfadetoblack" },
    { 0x257, "visionsetmissilecam" },
    { 0x258, "visionsetnaked" },
    { 0x259, "visionsetnight" },
    { 0x25A, "visionsetpain" },
    { 0x25B, "visionsetthermal" },
    { 0x25C, "weaponaltweaponname" },
    { 0x25D, "weaponburstcount" },
    { 0x25E, "weaponclass" },
    { 0x25F, "weaponoffhandclass" },
    { 0x260, "weaponclipsize" },
    { 0x261, "weaponfightdist" },
    { 0x262, "weaponfiretime" },
    { 0x263, "weaponhasthermalscope" },
    { 0x264, "weaponcandrop" },
    { 0x265, "weaponinheritsperks" },
    { 0x266, "weaponinventorytype" },
    { 0x267, "weaponisauto" },
    { 0x268, "weaponisboltaction" },
    { 0x269, "weaponisimpaling" },
    { 0x26A, "weaponissemiauto" },
    { 0x26B, "weaponmaxammo" },
    { 0x26C, "weaponmaxdist" },
    { 0x26D, "weaponstartammo" },
    { 0x26E, "weapontype" },
    { 0x26F, "worldentnumber" },
    { 0x270, "adddebugcommand" },
    { 0x271, "assert" },
    { 0x272, "assertex" },
    { 0x273, "assertmsg" },
    { 0x274, "box" },
    { 0x275, "closefile" },
    { 0x276, "createprintchannel" },
    { 0x277, "cylinder" },
    { 0x278, "drawsoundshape" },
    { 0x279, "fgetarg" },
    { 0x27A, "fprintfields" },
    { 0x27B, "fprintln" },
    { 0x27C, "freadln" },
    { 0x27D, "getentbynum" },
    { 0x27E, "getreflectionlocs" },
    { 0x27F, "getsystemtimeinmicroseconds" },
    { 0x280, "getunarchiveddebugdvar" },
    { 0x281, "line" },
    { 0x282, "openfile" },
    { 0x283, "debugstar" },
    { 0x284, "orientedbox" },
    { 0x285, "debugaxis" },
    { 0x286, "print" },
    { 0x287, "print3d" },
    { 0x288, "println" },
    { 0x289, "printtoscreen2d" },
    { 0x28A, "setdebugangles" },
    { 0x28B, "setdebugorigin" },
    { 0x28C, "setdevdvar" },
    { 0x28D, "setdevdvarifuninitialized" },
    { 0x28E, "setprintchannel" },
    { 0x28F, "sphere" },
    { 0x290, "sysprint" },
    { 0x291, "physics_getbodylinvel" },
    { 0x292, "physics_getbodyangvel" },
    { 0x293, "physics_getbodylinangvel" },
    { 0x294, "findpathcustom" },
    { 0x295, "findpath3d" },
    { 0x296, "navtrace" },
    { 0x297, "navtrace3d" },
    { 0x298, "navisstraightlinereachable" },
    { 0x299, "getrandomnavpoint" },
    { 0x29A, "getrandomnavpoints" },
    { 0x29B, "getclosestpointonnavmesh" },
    { 0x29C, "createnavrepulsor" },
    { 0x29D, "destroynavrepulsor" },
    { 0x29E, "ispointonnavmesh" },
    { 0x29F, "createnavobstaclebybounds" },
    { 0x2A0, "createnavobstaclebyent" },
    { 0x2A1, "destroynavobstacle" },
    { 0x2A2, "createnavbadplacebybounds" },
    { 0x2A3, "createnavbadplacebyent" },
    { 0x2A4, "createnavobstaclebyboundsforlayer" },
    { 0x2A5, "createnavobstaclebyentforlayer" },
    { 0x2A6, "createnavmodifier" },
    { 0x2A7, "isnumber" },
    { 0x2A8, "preloadzones" },
    { 0x2A9, "physics_setgravity" },
    { 0x2AA, "isbotmatchmakingenabled" },
    { 0x2AB, "addmpbottoteam" },
    { 0x2AC, "ispreloadzonescomplete" },
    { 0x2AD, "physics_getbulletmissilecontents" },
    { 0x2AE, "assertdemo" },
    { 0x2AF, "physics_aabbbroadphasequery" },
    { 0x2B0, "physics_aabbquery" },
    { 0x2B1, "physics_raycast" },
    { 0x2B2, "physics_spherecast" },
    { 0x2B3, "physics_capsulecast" },
    { 0x2B4, "physics_shapecast" },
    { 0x2B5, "physics_querypoint" },
    { 0x2B6, "physics_getclosestpointtosphere" },
    { 0x2B7, "physics_getclosestpointtocapsule" },
    { 0x2B8, "physics_getclosestpoint" },
    { 0x2B9, "physics_createcontents" },
    { 0x2BA, "physics_getsurfacetypefromflags" },
    { 0x2BB, "pathsighttestfast" },
    { 0x2BC, "nodetoentitysighttest" },
    { 0x2BD, "weapongetdamagemax" },
    { 0x2BE, "weapongetdamagemin" },
    { 0x2BF, "precomputedlosdatatest" },
    { 0x2C0, "getislosdatafileloaded" },
    { 0x2C1, "stopfxontagforclients" },
    { 0x2C2, "physics_charactercast" },
    { 0x2C3, "physics_getclosestpointtocharacter" },
    { 0x2C4, "playfxontagforteam" },
    { 0x2C5, "physics_getbodymass" },
    { 0x2C6, "physics_getbodydynamicmass" },
    { 0x2C7, "physics_getbodycenterofmass" },
    { 0x2C8, "physics_setbodycenterofmassnormal" },
    { 0x2C9, "physics_getbodyaabb" },
    { 0x2CA, "cachespawnpathnodesincode" },
    { 0x2CB, "getaccuracyfraction" },
    { 0x2CC, "triggerportableradarpingteam" },
    { 0x2CD, "isvfxfile" },
    { 0x2CE, "isstruct" },
    { 0x2CF, "isvector" },
    { 0x2D0, "isent" },
    { 0x2D1, "isnode" },
    { 0x2D2, "isnonentspawner" },
    { 0x2D3, "setglobalsoundcontext" },
    { 0x2D4, "setaudiotriggerstate" },
    { 0x2D5, "finishplayerdeath" },
    { 0x2D6, "precachesuit" },
    { 0x2D7, "getcsplineid" },
    { 0x2D8, "spawnimpulsefield" },
    { 0x2D9, "clearstartpointtransients" },
    { 0x2DA, "isloadingsavegame" },
    { 0x2DB, "getsavegametransients" },
    { 0x2DC, "getclosestpointonnavmesh3d" },
    { 0x2DD, "ispointonnavmesh3d" },
    { 0x2DE, "waspreloadzonesstarted" },
    { 0x2DF, "getcsplinepointstring" },
    { 0x2E0, "calccsplineclosestpoint" },
    { 0x2E1, "weaponisbeam" },
    { 0x2E2, "navisstraightlinereachable3d" },
    { 0x2E3, "getcsplinepointtargetname" },
    { 0x2E4, "getcsplinepointtarget" },
    { 0x2E5, "getcsplinetargetname" },
    { 0x2E6, "getweaponloottable" },
    { 0x2E7, "getweaponvariantindex" },
    { 0x2E8, "areanynavvolumesloaded" },
    { 0x2E9, "projectileintercept" },
    { 0x2EA, "getgrenadefusetime" },
    { 0x2EB, "getgrenadefusetimeai" },
    { 0x2EC, "getgrenadedamageradius" },
    { 0x2ED, "getcsplineidarray" },
    { 0x2EE, "spawncovernode" },
    { 0x2EF, "despawncovernode" },
    { 0x2F0, "spawnscriptitem" },
    { 0x2F1, "areworldweaponsloaded" },
    { 0x2F2, "getmaxclients" },
    { 0x2F3, "settransientvisibility" },
    { 0x2F4, "vectortopitch" },
    { 0x2F5, "getserverhostname" },
    { 0x2F6, "anglestoleft" },
    { 0x2F7, "weaponusesenergybullets" },
    { 0x2F8, "testbrushedgesforgrapple" },
    { 0x2F9, "spawncoverwall" },
    { 0x2FA, "generateaxisanglesfromforwardvector" },
    { 0x2FB, "btregistertree" },
    { 0x2FC, "isenumvaluevalid" },
    { 0x2FD, "switchtransientset" },
    { 0x2FE, "loadstartpointtransientset" },
    { 0x2FF, "physics_setgravityragdollscalar" },
    { 0x300, "physics_setgravitydynentscalar" },
    { 0x301, "physics_setgravityparticlescalar" },
    { 0x302, "playfxontagsbetweenclients" },
    { 0x303, "playfxbetweenpoints" },
    { 0x304, "physics_volumecreate" },
    { 0x305, "issound3d" },
    { 0x306, "generateaxisanglesfromupvector" },
    { 0x307, "anglelerpquat" },
    { 0x308, "loadworldweapons" },
    { 0x309, "clearworldweapons" },
    { 0x30A, "anglelerpquatfrac" },
    { 0x30B, "archetypeassetloaded" },
    { 0x30C, "archetypegetalias" },
    { 0x30D, "archetypegetrandomalias" },
    { 0x30E, "archetypegetaliases" },
    { 0x30F, "archetypehasstate" },
    { 0x310, "computeweaponclientloadout" },
    { 0x311, "target_drawonradar" },
    { 0x312, "target_setradarcenter" },
    { 0x313, "target_offsetlocalspace" },
    { 0x314, "target_drawrotated" },
    { 0x315, "getangleindices" },
    { 0x316, "getangleindex" },
    { 0x317, "hasroomtoplaypeekout" },
    { 0x318, "getdobjcount" },
    { 0x319, "frontendscenecamerafade" },
    { 0x31A, "frontendscenecamerafov" },
    { 0x31B, "frontendscenegetactivesection" },
    { 0x31C, "frontendscenecameracharacters" },
    { 0x31D, "isspleveltransient" },
    { 0x31E, "isgamebattlematch" },
    { 0x31F, "physics_setgravityitemscalar" },
    { 0x320, "setsettletime" },
    { 0x321, "bbreportspawnfactors" },
    { 0x322, "bbreportspawntypes" },
    { 0x323, "bbreportspawnplayerdetails" },
    { 0x324, "setstreamsynconnextlevel" },
    { 0x325, "setpreloadimageprimeset" },
    { 0x326, "animisleaf" },
    { 0x327, "getweaponviewmodel" },
    { 0x328, "startpodium" },
    { 0x329, "playcinematicforalllooping" },
    { 0x32A, "frontendscenecameracinematic" },
    { 0x32B, "setcodcasterclientmatchdata" },
    { 0x32C, "getcodcasterclientmatchdata" },
    { 0x32D, "sendcodcasterclientmatchdata" },
    { 0x32E, "waitforalltransients" },
    { 0x32F, "waitfortransient" },
    { 0x330, "isloadinganytransients" },
    { 0x331, "getmlgsettings" },
    { 0x332, "setintrocameraactive" },
    { 0x333, "removeallcorpses" },
    { 0x334, "asmregistergenerichandler" },
    { 0x335, "asmdevgetallnotetrackaimstates" },
    { 0x336, "stopspectateplayer" },
    { 0x337, "weaponispreferreddrop" },
    { 0x338, "physics_setbodylinvel" },
    { 0x339, "physics_setbodyangvel" },
    { 0x33A, "physics_setbodylinangvel" },
    { 0x33B, "findclosestlospointwithinvolume" },
    { 0x33C, "findclosestpointbyapproxpathdist" },
    { 0x33D, "findclosestnonlospointwithinvolume" },
    { 0x33E, "findclosestnonlospointwithinradius" },
    { 0x33F, "findclosestlospointwithinradius" },
    { 0x340, "findopenlookdir" },
    { 0x341, "makeweapon" },
    { 0x342, "getcompleteweaponname" },
    { 0x343, "createheadicon" },
    { 0x344, "deleteheadicon" },
    { 0x345, "setheadiconimage" },
    { 0x346, "setheadiconfriendlyimage" },
    { 0x347, "setheadiconenemyimage" },
    { 0x348, "setheadiconneutralimage" },
    { 0x349, "setheadiconnaturaldistance" },
    { 0x34A, "setheadiconmaxdistance" },
    { 0x34B, "setheadiconsnaptoedges" },
    { 0x34C, "setheadicondrawthroughgeo" },
    { 0x34D, "setheadiconzoffset" },
    { 0x34E, "addclienttoheadiconmask" },
    { 0x34F, "addteamtoheadiconmask" },
    { 0x350, "removeclientfromheadiconmask" },
    { 0x351, "removeteamfromheadiconmask" },
    { 0x352, "showheadicontoplayersinmask" },
    { 0x353, "hideheadiconfromplayersinmask" },
    { 0x354, "setheadiconteam" },
    { 0x355, "setheadiconowner" },
    { 0x356, "createtargetmarkergroup" },
    { 0x357, "deletetargetmarkergroup" },
    { 0x358, "targetmarkergroupaddentity" },
    { 0x359, "targetmarkergroupremoveentity" },
    { 0x35A, "targetmarkergroupsetentitystate" },
    { 0x35B, "targetmarkergroupsetextrastate" },
    { 0x35C, "addclienttotargetmarkergroupmask" },
    { 0x35D, "addteamtotargetmarkergroupmask" },
    { 0x35E, "removeclientfromtargetmarkergroupmask" },
    { 0x35F, "removeteamfromtargetmarkergroupmask" },
    { 0x360, "showtargetmarkergrouptoplayersinmask" },
    { 0x361, "hidetargetmarkergroupfromplayersinmask" },
    { 0x362, "isweapon" },
    { 0x363, "issameweapon" },
    { 0x364, "isnullweapon" },
    { 0x365, "nullweapon" },
    { 0x366, "isundefinedweapon" },
    { 0x367, "getqueuedspleveltransients" },
    { 0x368, "getloadedspleveltransients" },
    { 0x369, "getallspleveltransients" },
    { 0x36A, "gettransientsinset" },
    { 0x36B, "gettransientsetnames" },
    { 0x36C, "makealtweapon" },
    { 0x36D, "makeweaponfromstring" },
    { 0x36E, "asmdevgetallstates" },
    { 0x36F, "getplayerspawnarray" },
    { 0x370, "disablespawnpoints" },
    { 0x371, "disablespawnpointsbyclassname" },
    { 0x372, "disablespawnpointbyindex" },
    { 0x373, "enablespawnpoints" },
    { 0x374, "enablespawnpointsbyclassname" },
    { 0x375, "enablespawnpointbyindex" },
    { 0x376, "registerspawnfactor" },
    { 0x377, "enablefrontlinecriticalfactor" },
    { 0x378, "registerspawnteamsmode" },
    { 0x379, "createspawninfluencepoint" },
    { 0x37A, "destroyspawninfluencepoint" },
    { 0x37B, "animsetgetanimfromindex" },
    { 0x37C, "animsetgetallanimindicesforalias" },
    { 0x37D, "analyticsstreamerlogfileendstream" },
    { 0x37E, "analyticsstreamerlogfilestartstream" },
    { 0x37F, "analyticsstreamerlogfilewritetobuffer" },
    { 0x380, "analyticsstreamerlogfiletagplayer" },
    { 0x381, "analyticsstreamerislogfilestreamingenabled" },
    { 0x382, "drawentitybounds" },
    { 0x383, "getscriptbundle" },
    { 0x384, "isintournament" },
    { 0x385, "dotournamentendgame" },
    { 0x386, "logtournamentdeath" },
    { 0x387, "updatetournamentroundtime" },
    { 0x388, "physics_raycastents" },
    { 0x389, "savepotgdata" },
    { 0x38A, "getpotgstarttime" },
    { 0x38B, "getpotgduration" },
    { 0x38C, "completescenetransition" },
    { 0x38D, "stopclientexploder" },
    { 0x38E, "loadinfiltransient" },
    { 0x38F, "unloadinfiltransient" },
    { 0x390, "unloadallinfilintrotransients" },
    { 0x391, "setspeedthreshold" },
    { 0x392, "animspeedthresholdsexist" },
    { 0x393, "hasanimspeedthresholdstring" },
    { 0x394, "getanimspeedthreshold" },
    { 0x395, "getnearestspeedthresholdname" },
    { 0x396, "getnextlowestspeedthresholdstring" },
    { 0x397, "getanimspeedbetweenthresholds" },
    { 0x398, "getcoveranglelimits" },
    { 0x399, "get3dcoveranglelimits" },
    { 0x39A, "getcovercrouchanglelimits" },
    { 0x39B, "isfunction" },
    { 0x39C, "isbuiltinfunction" },
    { 0x39D, "isbuiltinmethod" },
    { 0x39E, "isanimation" },
    { 0x39F, "dospawnaitype" },
    { 0x3A0, "havemapentseffects" },
    { 0x3A1, "isplatformconsole" },
    { 0x3A2, "isplatformpc" },
    { 0x3A3, "isplatformps4" },
    { 0x3A4, "isplatformxb3" },
    { 0x3A5, "spawninfluencepointlinkto" },
    { 0x3A6, "spawninfluencepointislinked" },
    { 0x3A7, "spawninfluencepointsetposition" },
    { 0x3A8, "dlog_recordevent" },
    { 0x3A9, "getentitylessscriptablearray" },
    { 0x3AA, "getentitylessscriptablearrayinradius" },
    { 0x3AB, "getlootscriptablearray" },
    { 0x3AC, "getlootscriptablearrayinradius" },
    { 0x3AD, "canceljoins" },
    { 0x3AE, "spawnscriptable" },
    { 0x3AF, "easepower" },
    { 0x3B0, "easeexponential" },
    { 0x3B1, "easelogarithmic" },
    { 0x3B2, "easesine" },
    { 0x3B3, "easeback" },
    { 0x3B4, "easeelastic" },
    { 0x3B5, "easebounce" },
    { 0x3B6, "spawnsound" },
    { 0x3B7, "getplayerrateofgamerevenue" },
    { 0x3B8, "botnodeavailabletoteam" },
    { 0x3B9, "getnodeowner" },
    { 0x3BA, "showcinematicletterboxing" },
    { 0x3BB, "hidecinematicletterboxing" },
    { 0x3BC, "getrandomnodedestination" },
    { 0x3BD, "getfakeaiarray" },
    { 0x3BE, "getfakeaiarrayinradius" },
    { 0x3BF, "onmatchbegin" },
    { 0x3C0, "onmatchend" },
    { 0x3C1, "isalliedsentient" },
    { 0x3C2, "istestclient" },
    { 0x3C3, "initmaxspeedforpathlengthtable" },
    { 0x3C4, "isnavmeshloaded" },
    { 0x3C5, "isscriptabledefined" },
    { 0x3C6, "visionsetkillcamthirdpersonnight" },
    { 0x3C7, "getnodeindex" },
    { 0x3C8, "getnodebyindex" },
    { 0x3C9, "nvidiahighlightsrequestpermissions" },
    { 0x3CA, "nvidiahighlightsisenabled" },
    { 0x3CB, "nvidiahighlightsbegingroup" },
    { 0x3CC, "nvidiahighlightsendgroup" },
    { 0x3CD, "nvidiahighlightsscreenshot" },
    { 0x3CE, "nvidiahighlightsvideo" },
    { 0x3CF, "nvidiahighlightsgetcount" },
    { 0x3D0, "nvidiahighlightssummary" },
    { 0x3D1, "nvidiahighlightscleanup" },
    { 0x3D2, "getscriptableinstancefromindex" },
    { 0x3D3, "calcscriptablepayloadgravityarc" },
    { 0x3D4, "getscriptablereservedremaining" },
    { 0x3D5, "enabledismembermenttag" },
    { 0x3D6, "disabledismembermenttag" },
    { 0x3D7, "spawnmapcircle" },
    { 0x3D8, "getmaxobjectivecount" },
    { 0x3D9, "spawncustomweaponscriptable" },
    { 0x3DA, "getnodecount" },
    { 0x3DB, "getsentientcounts" },
    { 0x3DC, "getsentientlimits" },
    { 0x3DD, "nvidiaanselisenabled" },
    { 0x3DE, "computedropbagpositions" },
    { 0x3DF, "getunusedlootcachepoints" },
    { 0x3E0, "getlootspawnpoint" },
    { 0x3E1, "getquestpoints" },
    { 0x3E2, "disablelootspawnpoint" },
    { 0x3E3, "getlootspawnpointcount" },
    { 0x3E4, "getlootspawnscriptableindexfirst" },
    { 0x3E5, "getdatetime" },
    { 0x3E6, "analyticsreset" },
    { 0x3E7, "analyticsaddevent" },
    { 0x3E8, "analyticswritecsv" },
    { 0x3E9, "objective_setspecialobjectivedisplay" },
    { 0x3EA, "hastacvis" },
    { 0x3EB, "enablegroundwarspawnlogic" },
    { 0x3EC, "getscriptablelootspawnedcountbyname" },
    { 0x3ED, "getscriptablelootspawnedcountbyrarity" },
    { 0x3EE, "getscriptablelootspawnedcountbytype" },
    { 0x3EF, "getscriptablelootcachecontents" },
    { 0x3F0, "pickscriptablelootitem" },
    { 0x3F1, "registerscriptedspawnpoints" },
    { 0x3F2, "getoriginforanimtime" },
    { 0x3F3, "getanglesforanimtime" },
    { 0x3F4, "getbnetigrplayerxpmultiplier" },
    { 0x3F5, "getbnetigrweaponxpmultiplier" },
    { 0x3F6, "sortbydistancecullbyradius" },
    { 0x3F7, "incrementpersistentstat" },
    { 0x3F8, "objective_sethideformlgspectator" },
    { 0x3F9, "objective_setshowformlgspectator" },
    { 0x3FA, "getdediserverguid" },
    { 0x3FB, "isdismembermentenabled" },
    { 0x3FC, "objective_mlgicon" },
    { 0x3FD, "objective_reset_mlgicon" },
    { 0x3FE, "resetglass" },
    { 0x3FF, "objective_setmlgbackground" },
    { 0x400, "weaponisrestricted" },
    { 0x401, "attachmentisrestricted" },
    { 0x402, "perkisrestricted" },
    { 0x403, "equipmentisrestricted" },
    { 0x404, "killstreakisrestricted" },
    { 0x405, "superisrestricted" },
    { 0x406, "setgamebattleplayerstats" },
    { 0x407, "setgamebattlematchstats" },
    { 0x408, "requestgamelobbyremainintact" },
    { 0x409, "createnavobstaclebyshape" },
    { 0x40A, "createnavbadplacebyshape" },
    { 0x40B, "createnavobstaclebyshapeforlayer" },
    { 0x40C, "setminimapcpraidmaze" },
    { 0x40D, "brmatchstarted" },
    { 0x40E, "vehicle_getarrayinradius" },
    { 0x40F, "tablesort" },
    { 0x410, "setteamplacement" },
    { 0x411, "soundsettimescalefactorfromtable" },
    { 0x412, "createheadiconatorigin" },
    { 0x413, "setheadicondrawinmap" },
    { 0x414, "objective_sethideelevation" },
    { 0x415, "playencryptedcinematicforall" },
    { 0x416, "getbnetigrbattlepassxpmultiplier" },
    { 0x417, "getscriptcachecontents" },
    { 0x418, "getweaponindex" },
    { 0x419, "radiusdamagestepped" },
    { 0x41A, "verifybunkercode" },
    { 0x41B, "getaltbunkerindexforname" },
    { 0x41C, "getplaylistname" },
    { 0x41D, "stopmusicstate" },
    { 0x41E, "_func_41E" },
    { 0x41F, "_func_41F" },
    { 0x420, "_func_420" },
    { 0x421, "_func_421" },
    { 0x422, "_func_422" },
    { 0x423, "_func_423" },
    { 0x424, "_func_424" },
    { 0x425, "_func_425" },
    { 0x426, "_func_426" },
    { 0x427, "_func_427" },
    { 0x428, "_func_428" },
    { 0x429, "_func_429" },
}};

} // namespace xsk::gsc::iw8
