// Copyright 2024 xensik. All rights reserved.
//
// Use of this source code is governed by a GNU GPLv3 license
// that can be found in the LICENSE file.

#include "xsk/gsc/engine/iw9.hpp"

namespace xsk::gsc::iw9
{

extern std::array<std::pair<u64, char const*>, path_count> const path_list
{{
    { 0x32B7CDEED77D057E, "aiasm/civilian_cp_mp.gsc" },
    { 0x35A8E19B6286841E, "aiasm/civilian_mp.gsc" },
    { 0x7BAFE83F61723E58, "aiasm/civilian_sp.gsc" },
    { 0x2127A642689029E9, "aiasm/corner_cover_lean_shoot_cp_mp.gsc" },
    { 0x333F6EDE791A319F, "aiasm/corner_cover_lean_shoot_lw_mp.gsc" },
    { 0x419E457945C8652F, "aiasm/corner_cover_lean_shoot_mp.gsc" },
    { 0x7EDFAEDD76BA2A51, "aiasm/corner_cover_lean_shoot_sp.gsc" },
    { 0x6E56118DF645BCA9, "aiasm/dog_sp.gsc" },
    { 0x16788B23F7813A68, "aiasm/gesture_cp_mp.gsc" },
    { 0x0ED276256A336066, "aiasm/gesture_lw_mp.gsc" },
    { 0x2795CA2381AA1844, "aiasm/gesture_mp.gsc" },
    { 0x2373D48CF1D539B2, "aiasm/gesture_sp.gsc" },
    { 0x43217414BF8D7DBD, "aiasm/playerasm_mp.gsc" },
    { 0x478A5FF3300717F3, "aiasm/playerasm_sp.gsc" },
    { 0x09AC75F6223F719E, "aiasm/playerasm_sub_mp.gsc" },
    { 0x4FB37C9A212B2BD8, "aiasm/playerasm_sub_sp.gsc" },
    { 0x0FFC1613209C0E58, "aiasm/playerasm_void_mp.gsc" },
    { 0x49F50F6F21B0541E, "aiasm/playerasm_void_sp.gsc" },
    { 0x5432728299F31554, "aiasm/shoot_cp_mp.gsc" },
    { 0x286144B1799A88A2, "aiasm/shoot_lw_mp.gsc" },
    { 0x10267C55A210F0F0, "aiasm/shoot_mp.gsc" },
    { 0x05CAC6B43278B186, "aiasm/shoot_sp.gsc" },
    { 0x328B3030A65A8DB9, "aiasm/soldier_cp_mp.gsc" },
    { 0x18EE7AE10A52C8AF, "aiasm/soldier_lw_mp.gsc" },
    { 0x7255A31B670CE75F, "aiasm/soldier_mp.gsc" },
    { 0x172F5F8FC2C75DE1, "aiasm/soldier_sp.gsc" },
    { 0x37C1B87B79431128, "aiasm/suicidebomber_cp_mp.gsc" },
    { 0x2C40FE6A0EC96C04, "aiasm/suicidebomber_mp.gsc" },
    { 0x550008D869D66172, "aiasm/suicidebomber_sp.gsc" },
    { 0x68EC7E7BF5163661, "behaviortree/civilian.gsc" },
    { 0x4656969CDA1E5CEF, "behaviortree/civilian_agent.gsc" },
    { 0x53D6FE189C685458, "behaviortree/dog.gsc" },
    { 0x24F62F137306493C, "behaviortree/enemy_combatant.gsc" },
    { 0x001A2DFEDF315CD4, "behaviortree/juggernaut.gsc" },
    { 0x3545F03861FF9002, "behaviortree/juggernaut_agent.gsc" },
    { 0x6EE5DEE1A5469C09, "behaviortree/riotshield_cp.gsc" },
    { 0x4A89B79CBA6C453A, "behaviortree/soldier_agent.gsc" },
    { 0x3913DFDA05BB57B4, "behaviortree/soldier_agent_lw.gsc" },
    { 0x14B00477671C5A35, "behaviortree/suicidebomber.gsc" },
    { 0x015FB07B24C5AB0B, "behaviortree/suicidebomber_agent.gsc" },
    { 0x47D04779AE171058, "character/alq_syrkistan_female_scarf_purple.gsc" },
    { 0x6C3519078B1737B3, "character/alq_syrkistan_female_scarf_red.gsc" },
    { 0x7D70597F5DB87585, "character/character_al_qatala_desert_ar.gsc" },
    { 0x3BCFDED5E8FA3F50, "character/character_al_qatala_desert_ar_2.gsc" },
    { 0x7F0555B36D1B08E7, "character/character_al_qatala_desert_ar_3.gsc" },
    { 0x091151E289AFEC2E, "character/character_al_qatala_desert_ar_4.gsc" },
    { 0x66ACAC5596212D71, "character/character_al_qatala_desert_cqc.gsc" },
    { 0x33D66FE7D0A6C65C, "character/character_al_qatala_desert_lmg.gsc" },
    { 0x693C29D64B83755B, "character/character_al_qatala_trials.gsc" },
    { 0x28D27A7FACD64502, "character/character_al_qatala_urban_a6_variant.gsc" },
    { 0x200DABCFA3F18E26, "character/character_al_qatala_urban_ar_variant.gsc" },
    { 0x67D8AE51DA6C4EFC, "character/character_al_qatala_urban_bomber.gsc" },
    { 0x41A511B8916C1089, "character/character_al_qatala_urban_civ_1.gsc" },
    { 0x409CCDA81170F930, "character/character_al_qatala_urban_civ_2.gsc" },
    { 0x273D48B5958B8D47, "character/character_al_qatala_urban_civ_3.gsc" },
    { 0x0B3544DFCD06A18E, "character/character_al_qatala_urban_civ_4.gsc" },
    { 0x52D13DDA867630AD, "character/character_al_qatala_urban_civ_5.gsc" },
    { 0x1DEA48BDB7A13064, "character/character_al_qatala_urban_civ_6.gsc" },
    { 0x3C2731B3892A740B, "character/character_al_qatala_urban_civ_7.gsc" },
    { 0x6A96208943F72722, "character/character_al_qatala_urban_civ_8.gsc" },
    { 0x7F65697EC7FCE331, "character/character_al_qatala_urban_civ_9.gsc" },
    { 0x627139B9D8490BEF, "character/character_al_qatala_urban_cqb_variant.gsc" },
    { 0x6230AB696721E119, "character/character_al_qatala_urban_lmg_variant.gsc" },
    { 0x77613AB13516E118, "character/character_ally_so15_1.gsc" },
    { 0x76E53FCC7B105391, "character/character_ally_so15_2.gsc" },
    { 0x389AF6D20F0BEC82, "character/character_ally_so15_3.gsc" },
    { 0x0EBB6067A2162225, "character/character_barkov_captive.gsc" },
    { 0x1D36C5707B65CDAE, "character/character_civ_male_rus_clerical_1.gsc" },
    { 0x2203B66A6A693DAB, "character/character_civ_male_rus_clerical_2.gsc" },
    { 0x03C7CD7498E1AD04, "character/character_civ_male_rus_clerical_3.gsc" },
    { 0x116EB4D7BA1A9325, "character/character_civ_russian_police_officer.gsc" },
    { 0x4189709E138E122A, "character/character_civilian_me_female.gsc" },
    { 0x337298E549E7BD86, "character/character_civilian_me_female_cp.gsc" },
    { 0x51269A20A066B219, "character/character_civilian_me_female_embassy.gsc" },
    { 0x20161DEE5F3AE149, "character/character_civilian_me_female_embassy_mom.gsc" },
    { 0x791B25003E6B5145, "character/character_civilian_me_female_veil.gsc" },
    { 0x23F85B6079106E91, "character/character_civilian_me_female_wrap.gsc" },
    { 0x6D0E56A9475AD25F, "character/character_civilian_me_male.gsc" },
    { 0x37143DC2FAC56392, "character/character_civilian_me_male_cinderblock_a.gsc" },
    { 0x09E8BCA98403E59F, "character/character_civilian_me_male_cinderblock_b.gsc" },
    { 0x1DA485C7183FFCA8, "character/character_civilian_me_male_cinderblock_c.gsc" },
    { 0x09D771CD39D94225, "character/character_civilian_me_male_cinderblock_d.gsc" },
    { 0x70B7DCC7D8389289, "character/character_civilian_me_male_cp.gsc" },
    { 0x22ECAB79EA596F7A, "character/character_civilian_me_male_dist.gsc" },
    { 0x2B6D95B6438D19A0, "character/character_civilian_me_male_embassy.gsc" },
    { 0x137DC0CB6B7460A6, "character/character_civilian_me_male_embassy_dad.gsc" },
    { 0x76CA634F874C672A, "character/character_civilian_me_male_veil.gsc" },
    { 0x610B43115246DE2E, "character/character_civilian_syrkistan_boy_1_1.gsc" },
    { 0x5D21AD9A400E70D7, "character/character_civilian_syrkistan_boy_2_1.gsc" },
    { 0x4CF99888FC3EC7F8, "character/character_civilian_syrkistan_boy_3_1.gsc" },
    { 0x6137D6C723640951, "character/character_civilian_syrkistan_boy_4_1.gsc" },
    { 0x36F017124778241A, "character/character_civilian_syrkistan_boy_5_1.gsc" },
    { 0x1C344EAD431AF8E3, "character/character_civilian_syrkistan_boy_6_1.gsc" },
    { 0x0087DF9778DA2043, "character/character_cp_al_qatala_desert_9_rpg.gsc" },
    { 0x5018FC9098084EB5, "character/character_cp_al_qatala_desert_ar.gsc" },
    { 0x3B90ACE942FE6100, "character/character_cp_al_qatala_desert_ar_2.gsc" },
    { 0x79F725E3AF1B9457, "character/character_cp_al_qatala_desert_ar_3.gsc" },
    { 0x31DCE20CAB248FDE, "character/character_cp_al_qatala_desert_ar_4.gsc" },
    { 0x5663E69D507E036A, "character/character_cp_al_qatala_desert_ar_tmtyl.gsc" },
    { 0x69D669F2F0DDF801, "character/character_cp_al_qatala_desert_cqc.gsc" },
    { 0x2F829372490537B7, "character/character_cp_al_qatala_desert_dmr.gsc" },
    { 0x78168B35E6EA884C, "character/character_cp_al_qatala_desert_lmg.gsc" },
    { 0x26E76D730B28C81B, "character/character_cp_bombvest_hostage.gsc" },
    { 0x596130FFA3E43EA5, "character/character_cp_hero_hadir_urban.gsc" },
    { 0x2DAE60132549BD8A, "character/character_cp_usmc_basic_ar_1.gsc" },
    { 0x2A41200200874537, "character/character_cp_usmc_basic_ar_2.gsc" },
    { 0x1555A70C7C68BCE0, "character/character_cp_usmc_basic_ar_3.gsc" },
    { 0x0188D3129E026F1D, "character/character_cp_usmc_basic_ar_4.gsc" },
    { 0x0EA4C80B05AD5611, "character/character_cp_usmc_basic_lmg.gsc" },
    { 0x4C9E5A90FD6E6856, "character/character_eastern_yegor_1_1.gsc" },
    { 0x5B6F2B7F6E1A7D74, "character/character_hero_alex_desert.gsc" },
    { 0x085E4BF0387DCC41, "character/character_hero_alex_urban.gsc" },
    { 0x453D6608C94C2B9E, "character/character_hero_farah_disguised.gsc" },
    { 0x47777F0FBD33FF73, "character/character_hero_farah_disguised_soldier.gsc" },
    { 0x005C0E9023E37121, "character/character_hero_griggs_desert.gsc" },
    { 0x6A23AC3A138CE399, "character/character_hero_hadir_prisoner.gsc" },
    { 0x69AABD445950F51C, "character/character_hero_hadir_pw.gsc" },
    { 0x1CBC9F5D1D540B75, "character/character_hero_hadir_urban.gsc" },
    { 0x52B3F7DE0CC8C5F1, "character/character_hero_hadir_young.gsc" },
    { 0x40F23A56192060C5, "character/character_hero_kyle_desert.gsc" },
    { 0x7B684CCC1B07C05C, "character/character_hero_kyle_so15.gsc" },
    { 0x08C34A575093B8A9, "character/character_hero_kyle_undercover.gsc" },
    { 0x1B79AB3405B3751A, "character/character_hero_kyle_urban.gsc" },
    { 0x451AEEDC4CA9161C, "character/character_hero_kyle_woodland.gsc" },
    { 0x426913BC4E3F4DC6, "character/character_hero_kyle_woodland_nvg.gsc" },
    { 0x2723CCC9E0A03B2B, "character/character_hero_nikolai_lab.gsc" },
    { 0x7CC80E4CE0545179, "character/character_hero_nikolai_st_petersburg.gsc" },
    { 0x2CC7174D35C83369, "character/character_hero_price_desert.gsc" },
    { 0x6B9A34CAFADA0815, "character/character_hero_price_undercover.gsc" },
    { 0x57636F9B14953B96, "character/character_hero_price_urban.gsc" },
    { 0x6BADEA8BBC8ECFF0, "character/character_hero_price_urban_nvg.gsc" },
    { 0x7E82081490932D78, "character/character_hero_price_woodland.gsc" },
    { 0x012F75E2C60E0D42, "character/character_hero_price_woodland_nvg.gsc" },
    { 0x6E1433B72452308E, "character/character_hero_price_young.gsc" },
    { 0x5461025BF55F9847, "character/character_hero_tarik.gsc" },
    { 0x7E99F8DD3615036E, "character/character_iw8_al_qatala_desert_1.gsc" },
    { 0x2CE1E9DC0D171E6B, "character/character_iw8_al_qatala_desert_2.gsc" },
    { 0x3524015605241B87, "character/character_iw8_al_qatala_desert_2_rpg_helmet.gsc" },
    { 0x0EA500E63B8DDAC4, "character/character_iw8_al_qatala_desert_3.gsc" },
    { 0x3509C5B5FA7A7269, "character/character_iw8_al_qatala_desert_4.gsc" },
    { 0x20A67CC076CFD53A, "character/character_iw8_al_qatala_desert_5.gsc" },
    { 0x1AA1FCB2FE99EF27, "character/character_iw8_al_qatala_desert_6.gsc" },
    { 0x315785D0955DA390, "character/character_iw8_al_qatala_desert_7.gsc" },
    { 0x2D444CB8578641D5, "character/character_iw8_al_qatala_desert_8.gsc" },
    { 0x3A0751AA833475F6, "character/character_iw8_al_qatala_desert_9.gsc" },
    { 0x00EE231B82F51E36, "character/character_iw8_al_qatala_desert_9_rpg.gsc" },
    { 0x17795A290BA768B1, "character/character_iw8_al_qatala_urban_01.gsc" },
    { 0x11E65938DDAAC8B8, "character/character_iw8_al_qatala_urban_02.gsc" },
    { 0x2663D22E616ACC2F, "character/character_iw8_al_qatala_urban_03.gsc" },
    { 0x08318E5C45CF4496, "character/character_iw8_al_qatala_urban_04.gsc" },
    { 0x549D853A17441CF5, "character/character_iw8_al_qatala_urban_05.gsc" },
    { 0x7045D5559D4B15CC, "character/character_iw8_al_qatala_urban_06.gsc" },
    { 0x64577D431C7881F3, "character/character_iw8_al_qatala_urban_07.gsc" },
    { 0x395ACEA1275F0CC0, "character/character_iw8_al_qatala_urban_08_long_jacket.gsc" },
    { 0x2F6FB39CC102F8C0, "character/character_iw8_al_qatala_urban_bombvest.gsc" },
    { 0x27230CF4F02F517E, "character/character_iw8_al_qatala_urban_female_01.gsc" },
    { 0x2C617BDCFFC30A3B, "character/character_iw8_al_qatala_urban_female_02.gsc" },
    { 0x628490D413593CD4, "character/character_iw8_al_qatala_urban_female_03.gsc" },
    { 0x31F2D7BA99B436B9, "character/character_iw8_al_qatala_urban_female_04.gsc" },
    { 0x492F90D830EA234A, "character/character_iw8_al_qatala_urban_female_05.gsc" },
    { 0x6F3D50CBF42655F7, "character/character_iw8_al_qatala_urban_female_06.gsc" },
    { 0x57D35D134766141E, "character/character_iw8_cp_al_qatala_urban_bombvest.gsc" },
    { 0x082467C472E9E5ED, "character/character_iw8_russian_army_1.gsc" },
    { 0x69527A4B7BDE4891, "character/character_iw8_russian_army_1_safehouse.gsc" },
    { 0x6E95E4E953B03E57, "character/character_iw8_russian_army_1_safehouse_finale.gsc" },
    { 0x64ED3F563E509B56, "character/character_iw8_russian_army_1_trial.gsc" },
    { 0x79148E17CC8D265D, "character/character_iw8_russian_army_2_hood.gsc" },
    { 0x089F00BB868D0981, "character/character_iw8_russian_army_2_hood_safehouse.gsc" },
    { 0x2EC5BC25F6CEA447, "character/character_iw8_russian_army_2_hood_safehouse_finale.gsc" },
    { 0x438EEB058B821551, "character/character_iw8_russian_army_ar_1_balaclava.gsc" },
    { 0x627FDF1F24DC8CA9, "character/character_iw8_russian_army_ar_1_gasmask.gsc" },
    { 0x1CA9792A92FA0EBE, "character/character_iw8_russian_army_ar_1_gasmask_only.gsc" },
    { 0x55A0AA5A5407B600, "character/character_iw8_russian_army_ar_2_balaclava.gsc" },
    { 0x03906ED8412FD030, "character/character_iw8_russian_army_ar_2_gasmask.gsc" },
    { 0x29849111779F2715, "character/character_iw8_russian_army_ar_2_gasmask_only.gsc" },
    { 0x276F3934A343126C, "character/character_iw8_russian_army_ar_3_gasmask_only.gsc" },
    { 0x38D665C0206BB9C6, "character/character_iw8_russian_army_ar_4_gasmask.gsc" },
    { 0x30F56F4478BA814B, "character/character_iw8_russian_army_ar_4_gasmask_only.gsc" },
    { 0x4960FD2F0E080DFD, "character/character_iw8_russian_army_ar_5_gasmask.gsc" },
    { 0x08237C8CDAB9C00A, "character/character_iw8_russian_army_ar_5_gasmask_only.gsc" },
    { 0x31896C80BB6B4EE1, "character/character_iw8_russian_army_ar_6_gasmask_only.gsc" },
    { 0x1F4B1E0349126906, "character/character_iw8_russian_weapon_smugglers_1.gsc" },
    { 0x4D254F021FB66BE3, "character/character_iw8_russian_weapon_smugglers_2.gsc" },
    { 0x2D026713651899FC, "character/character_iw8_russian_weapon_smugglers_3.gsc" },
    { 0x28822DFB26E46661, "character/character_iw8_russian_weapon_smugglers_4.gsc" },
    { 0x41FDA2EDA2E231D2, "character/character_iw8_russian_weapon_smugglers_5.gsc" },
    { 0x74CA2CA435FC7DD5, "character/character_iw8_russian_weapon_smugglers_burned_1.gsc" },
    { 0x5634362338C36664, "character/character_iw8_sla_rebel_female_1_1.gsc" },
    { 0x32AF76B779B47F01, "character/character_iw8_sla_rebel_female_2_1.gsc" },
    { 0x4F315F4967FD0C4A, "character/character_iw8_sla_rebel_female_3_1.gsc" },
    { 0x21F0CD280B29DF07, "character/character_iw8_sla_rebel_female_4_1.gsc" },
    { 0x61452D7E0EA76EA8, "character/character_iw8_sla_rebel_female_5_1.gsc" },
    { 0x56409BEE34A7B4E5, "character/character_iw8_sla_rebel_female_6_1.gsc" },
    { 0x66CCB84CD932427A, "character/character_iw8_sla_rebels_female_prisoner_1.gsc" },
    { 0x642F383F63E13867, "character/character_iw8_sla_rebels_female_prisoner_2.gsc" },
    { 0x20F9C161DFC06ED0, "character/character_iw8_sla_rebels_female_prisoner_3.gsc" },
    { 0x0FC32D6454CBDBCD, "character/character_iw8_sla_rebels_female_prisoner_4.gsc" },
    { 0x6E3B346E80761BAE, "character/character_iw8_sla_rebels_female_prisoner_5.gsc" },
    { 0x1489A8B1F1D0EE4A, "character/character_london_police_hivis.gsc" },
    { 0x15E911C2E47193B4, "character/character_opforce_juggernaut.gsc" },
    { 0x2DD3DAD0CA9F5E5B, "character/character_opforce_juggernaut_br.gsc" },
    { 0x5944FEB3C51E74C4, "character/character_opforce_juggernaut_cp.gsc" },
    { 0x6C9A166E5B3334AB, "character/character_opforce_juggernaut_trial.gsc" },
    { 0x4AC1BF8FC81ADD26, "character/character_rus_pilot_helicopter.gsc" },
    { 0x76D28628026B250C, "character/character_russian_boss_hometown.gsc" },
    { 0x7E5A5D8646CDA55C, "character/character_russian_boss_hometown_cp.gsc" },
    { 0x1BED238A56A2DA97, "character/character_russian_suits.gsc" },
    { 0x7736F327E4B23BC7, "character/character_sas_pilot_helicopter.gsc" },
    { 0x50F17E68CDF54D91, "character/character_sas_pilot_helicopter_cp.gsc" },
    { 0x3A6FF6FC7439D36B, "character/character_sas_urban_ar.gsc" },
    { 0x06F81DAC10AC2D33, "character/character_sas_urban_ar_1.gsc" },
    { 0x2AD32EC53A04A2D6, "character/character_sas_urban_ar_2.gsc" },
    { 0x20BA25A7F3782635, "character/character_sas_urban_ar_3.gsc" },
    { 0x3486F9A1D1DE73F8, "character/character_sas_urban_ar_4.gsc" },
    { 0x4E42483143ACD6A7, "character/character_sas_urban_cqc.gsc" },
    { 0x5A5FB221017E5599, "character/character_sas_urban_dmr.gsc" },
    { 0x0E00A175CD3C099D, "character/character_sas_urban_nvg_ar.gsc" },
    { 0x539E2577B90A987F, "character/character_sas_urban_nvg_dmr.gsc" },
    { 0x094687C777BF3F17, "character/character_sas_woodland_nvg.gsc" },
    { 0x313F5ABF4B84D0CF, "character/character_sla_rebels_male_ar.gsc" },
    { 0x4D837508859FFBA6, "character/character_sla_rebels_male_ar_2_1.gsc" },
    { 0x35FDB6D23CDEB3EC, "character/character_sla_rebels_male_cqb.gsc" },
    { 0x7A59C84A65618589, "character/character_sla_rebels_male_cqb_2_1.gsc" },
    { 0x22DD6113102F3365, "character/character_sla_rebels_male_dmr.gsc" },
    { 0x69480EEFB6BA5468, "character/character_sla_rebels_male_dmr_2_1.gsc" },
    { 0x2B128BB7F062073A, "character/character_sla_rebels_male_lmg.gsc" },
    { 0x6418EDAF39CA3043, "character/character_sla_rebels_male_lmg_2_1.gsc" },
    { 0x4219B6C7F817F165, "character/character_spetsnaz_ar.gsc" },
    { 0x641E66EDABFEBB7B, "character/character_spetsnaz_ar_cp.gsc" },
    { 0x17DA0A253C54B0FB, "character/character_spetsnaz_ar_nvg.gsc" },
    { 0x3E42514A2682BEB5, "character/character_spetsnaz_ar_nvg_cp.gsc" },
    { 0x56ADD4E7B00011F2, "character/character_spetsnaz_ar_nvg_fixed.gsc" },
    { 0x6BB8F6CAED380A0E, "character/character_spetsnaz_ar_nvg_fixed_cp.gsc" },
    { 0x30E7C7F43DEAD23E, "character/character_spetsnaz_ar_trial.gsc" },
    { 0x70F0EC4DAEB4AE51, "character/character_spetsnaz_cqc.gsc" },
    { 0x170918A4881CC5B7, "character/character_spetsnaz_cqc_cp.gsc" },
    { 0x7889943617BE8CD7, "character/character_spetsnaz_cqc_nvg.gsc" },
    { 0x13C1AA5F4765A401, "character/character_spetsnaz_cqc_nvg_cp.gsc" },
    { 0x47E0A378DA1A8E12, "character/character_spetsnaz_cqc_trial.gsc" },
    { 0x7CE85BA6ABEDEA11, "character/character_spetsnaz_dmr_cp.gsc" },
    { 0x7C85DC1BDE3E9B97, "character/character_spetsnaz_dmr_cp_nvg.gsc" },
    { 0x4525678513A55130, "character/character_spetsnaz_dmr_trial.gsc" },
    { 0x30655A40A32B3E87, "character/character_spetsnaz_gasmask_ar.gsc" },
    { 0x5C98EFE42BA9CD51, "character/character_spetsnaz_gasmask_ar_cp.gsc" },
    { 0x3829F9EFD28EF970, "character/character_spetsnaz_gasmask_ar_trial.gsc" },
    { 0x13E562E39A0560DB, "character/character_spetsnaz_gasmask_cqc.gsc" },
    { 0x324C128AB55ECFD5, "character/character_spetsnaz_gasmask_cqc_cp.gsc" },
    { 0x37350F9E6ED949DC, "character/character_spetsnaz_gasmask_cqc_trial.gsc" },
    { 0x1B9F8D5B8D8BD522, "character/character_spetsnaz_gasmask_lmg.gsc" },
    { 0x38D41A1CB0C0EA5E, "character/character_spetsnaz_gasmask_lmg_cp.gsc" },
    { 0x166B11563999BC01, "character/character_spetsnaz_gasmask_lmg_trial.gsc" },
    { 0x4000F1C13DF8C3FE, "character/character_spetsnaz_gasmask_nohelmet_ar.gsc" },
    { 0x4C03E444E5AE90BA, "character/character_spetsnaz_gasmask_nohelmet_ar_cp.gsc" },
    { 0x101352BEA05224CC, "character/character_spetsnaz_gasmask_nohelmet_cqc.gsc" },
    { 0x5729CA7C3938D91C, "character/character_spetsnaz_gasmask_nohelmet_cqc_cp.gsc" },
    { 0x183764699C0BCD81, "character/character_spetsnaz_gasmask_nohelmet_lmg.gsc" },
    { 0x78ED867ED4FA07C7, "character/character_spetsnaz_gasmask_nohelmet_lmg_cp.gsc" },
    { 0x27B67CF1F7740E3C, "character/character_spetsnaz_lmg.gsc" },
    { 0x290155ACC542FD2C, "character/character_spetsnaz_lmg_cp.gsc" },
    { 0x0EAB76E4D130A0D6, "character/character_spetsnaz_lmg_cp_nvg.gsc" },
    { 0x3C73067B384FE983, "character/character_spetsnaz_lmg_trial.gsc" },
    { 0x12AC8E46F9F1B1D7, "character/character_spetsnaz_riotshield_cp.gsc" },
    { 0x49F5485BC147C97D, "character/character_usmc_ar.gsc" },
    { 0x6F04D7795F35B4BA, "character/character_usmc_basic_ar_1.gsc" },
    { 0x5BF02C47B4E9291D, "character/character_usmc_basic_ar_1_tape.gsc" },
    { 0x6900576BE6FFCEA7, "character/character_usmc_basic_ar_2.gsc" },
    { 0x7FB5E0897DC38310, "character/character_usmc_basic_ar_3.gsc" },
    { 0x4E462338C5E5027B, "character/character_usmc_basic_ar_3_tape.gsc" },
    { 0x6B194C8BEFEBC70D, "character/character_usmc_basic_ar_4.gsc" },
    { 0x75C35CB1CA43C8A8, "character/character_usmc_basic_ar_4_tape.gsc" },
    { 0x0BDEF97EF9E75B41, "character/character_usmc_basic_lmg.gsc" },
    { 0x41CD176219AD0F88, "character/character_usmc_raiders_ar_1.gsc" },
    { 0x18475A669837B301, "character/character_usmc_raiders_ar_2.gsc" },
    { 0x5892D3891710BEF2, "character/character_usmc_raiders_ar_3.gsc" },
    { 0x3CEA7B6D9109B883, "character/character_usmc_raiders_ar_4.gsc" },
    { 0x1CC7937ED66BE69C, "character/character_usmc_raiders_ar_5.gsc" },
    { 0x33F310BE3CF9124E, "character/character_villain_barkov_old.gsc" },
    { 0x4194584749801B49, "character/character_villain_enforcer_st_petersburg.gsc" },
    { 0x08F8C84C5C288DCF, "character/character_villain_wolf.gsc" },
    { 0x0BAA1424E598BDD0, "character/character_villain_wolf_bombvest.gsc" },
    { 0x58DD4308ADBF221F, "character/civ_al_qatala_urban_civ_female.gsc" },
    { 0x2F833547C8153977, "character/civ_al_qatala_urban_civ_female_bluetop.gsc" },
    { 0x02AE0175D9620C61, "character/civ_al_qatala_urban_civ_female_turquoise.gsc" },
    { 0x68D553ABF58DA9BE, "character/civ_al_qatala_urban_civ_female_whitetop.gsc" },
    { 0x6692AC662B0566F4, "character/civ_child_interrogation.gsc" },
    { 0x09112FF428E6966B, "character/civ_embassy_ambassador_assistant.gsc" },
    { 0x0D5AC5FBC289F77D, "character/civ_embassy_office_worker_female_1_1.gsc" },
    { 0x5A986F95EA1207FB, "character/civ_embassy_office_worker_female_1_1_smallhead.gsc" },
    { 0x52D552F82C405F74, "character/civ_embassy_office_worker_female_1_2.gsc" },
    { 0x17A313607EC7D300, "character/civ_embassy_office_worker_female_2_1.gsc" },
    { 0x197A1774AE32A599, "character/civ_embassy_office_worker_female_2_2.gsc" },
    { 0x548626A53E42A848, "character/civ_embassy_office_worker_male_1_1.gsc" },
    { 0x2E6669A9BFB074C1, "character/civ_embassy_office_worker_male_1_2.gsc" },
    { 0x41D0E2C753A7ACB2, "character/civ_embassy_office_worker_male_1_3.gsc" },
    { 0x7F0C7FC98922F685, "character/civ_embassy_office_worker_male_2_1.gsc" },
    { 0x707E0BB5096A3F9C, "character/civ_embassy_office_worker_male_2_2.gsc" },
    { 0x10A0F3A3C4081183, "character/civ_embassy_office_worker_male_2_3.gsc" },
    { 0x2C494BBF4A0F17F2, "character/civ_embassy_office_worker_male_2_4.gsc" },
    { 0x22C2C5FE4B6B3368, "character/civ_female_interrogation.gsc" },
    { 0x3362BFAC36550623, "character/civ_london_female_02_skintone_dark.gsc" },
    { 0x4D39F545494121FB, "character/civ_london_female_02_skintone_light.gsc" },
    { 0x55603631F9C1D6E1, "character/civ_london_female_02_skintone_med.gsc" },
    { 0x2A243841281837A0, "character/civ_london_female_03_skintone_dark.gsc" },
    { 0x392556CBACA7C63A, "character/civ_london_female_03_skintone_light.gsc" },
    { 0x03C8FCB79090D614, "character/civ_london_female_03_skintone_med.gsc" },
    { 0x626D10F8763CC956, "character/civ_london_female_skintone_light.gsc" },
    { 0x112B6172A8E03232, "character/civ_london_female_skintone_light_anim_safe.gsc" },
    { 0x4D4ED05775D54B60, "character/civ_london_female_skintone_med.gsc" },
    { 0x3581B5A8CD365E20, "character/civ_london_female_skintone_med_anim_safe.gsc" },
    { 0x76B402B54F12A90D, "character/civ_london_male_embassy_adam.gsc" },
    { 0x6C5F37B73038304F, "character/civ_london_male_embassy_ambassador.gsc" },
    { 0x31B4AF71A67FDEA5, "character/civ_london_male_skintone_light.gsc" },
    { 0x539ED76185B302CF, "character/civ_london_male_skintone_med.gsc" },
    { 0x546EEEEBDC1E25F2, "character/civ_russian_female.gsc" },
    { 0x2703F00D7AFD0CA7, "character/civ_russian_male.gsc" },
    { 0x5401B4AF4E767031, "character/civ_russian_male_cp.gsc" },
    { 0x0CC64E08F07608B4, "character/civ_syrkistan_female_nurse_mask.gsc" },
    { 0x32CF52C0A4B4C8B7, "character/civ_syrkistan_female_nurse_nomask.gsc" },
    { 0x2BBFC1556DA4EF40, "character/civ_syrkistan_female_scarf_dress_blue.gsc" },
    { 0x0345FA4A960C66DE, "character/civ_syrkistan_female_scarf_dress_orange.gsc" },
    { 0x2A37A70872AA63E0, "character/civ_syrkistan_female_scarf_dress_pink.gsc" },
    { 0x426EF33A261B7799, "character/civ_syrkistan_female_scarf_green.gsc" },
    { 0x466E1F43A0586C85, "character/civ_syrkistan_female_scarf_long_blue.gsc" },
    { 0x7C4DE9361E63B59D, "character/civ_syrkistan_female_scarf_long_brown.gsc" },
    { 0x1F527F885BA419F1, "character/civ_syrkistan_girl_1_1.gsc" },
    { 0x18081CF8B9A9DA94, "character/civ_syrkistan_girl_2_1.gsc" },
    { 0x4E107BA6CC8AA783, "character/civ_syrkistan_girl_3_1.gsc" },
    { 0x67AF09749E4A06CE, "character/civ_syrkistan_girl_4_1.gsc" },
    { 0x69399199AA50AF95, "character/civ_syrkistan_girl_5_1.gsc" },
    { 0x2BB5C587708E9798, "character/civ_syrkistan_girl_6_1.gsc" },
    { 0x672A73FD8EF30F77, "character/civ_syrkistan_girl_7_1.gsc" },
    { 0x23AE83E6F81BD759, "character/civ_syrkistan_male_doctor_mask.gsc" },
    { 0x5BB195F5D6C021FA, "character/civ_syrkistan_male_doctor_nomask.gsc" },
    { 0x2FB06984712C831F, "character/civ_tugofwar_male_cp.gsc" },
    { 0x14D32184C28E8194, "character/civ_uk_female_coat_blue.gsc" },
    { 0x79800D0D98A1EA7C, "character/civ_western_cold_boy.gsc" },
    { 0x32EE021D62E7D89A, "character/civ_western_cold_girl.gsc" },
    { 0x67D1396D2B710E12, "character/hero_xo_farah_variant.gsc" },
    { 0x71D8FA6A424DD963, "character/test_character_alq_embassy.gsc" },
    { 0x25B99F89A4C9696E, "character/test_character_civ_female_rus_clerical.gsc" },
    { 0x626E03DD36BDC6CF, "character/test_character_civ_male_london_01.gsc" },
    { 0x5B7D895F06BC7241, "character/test_character_civ_male_rus_clerical.gsc" },
    { 0x1BE7F0EB0E52CA40, "character/test_character_cp_crew_male_vest_picc_01.gsc" },
    { 0x1955C748B00BEC22, "character/test_character_crew_male_vest_picc_01.gsc" },
    { 0x78E39294A33F71EA, "character/test_character_dog.gsc" },
    { 0x15AE8137379807E9, "character/test_character_farah_father.gsc" },
    { 0x06915CAA9316909E, "scripts/aitypes/alert.gsc" },
    { 0x027FF5BAFD325163, "scripts/aitypes/assets.gsc" },
    { 0x0974236B390FBD2A, "scripts/aitypes/bt_action_api.gsc" },
    { 0x088804CFE1C28645, "scripts/aitypes/bt_state_api.gsc" },
    { 0x68089CE1EA270B3B, "scripts/aitypes/bt_util.gsc" },
    { 0x69FDEC9FC8CCFB18, "scripts/aitypes/c12api.gsc" },
    { 0x015EDFA8E2BDACE2, "scripts/aitypes/combat.gsc" },
    { 0x6C59B261C6CF53C8, "scripts/aitypes/combat_mp.gsc" },
    { 0x3C36BCB5F2B1856E, "scripts/aitypes/combat_sp.gsc" },
    { 0x6ADCC148F9B3971B, "scripts/aitypes/common.gsc" },
    { 0x0FC0E00E7CF9B73B, "scripts/aitypes/cover.gsc" },
    { 0x5D8472F0F6851F3A, "scripts/aitypes/dismember.gsc" },
    { 0x1B1733A424733305, "scripts/aitypes/dog/combat.gsc" },
    { 0x61EF79F49C19C9AA, "scripts/aitypes/grenade_response.gsc" },
    { 0x7A383E1E6C824150, "scripts/aitypes/human/civilian_logic.gsc" },
    { 0x40E26106E37768BA, "scripts/aitypes/juggernaut/behaviors.gsc" },
    { 0x09F3D607A2667EBC, "scripts/aitypes/melee.gsc" },
    { 0x2B92E11988DD75FC, "scripts/aitypes/melee_sp.gsc" },
    { 0x3FECCEEDD2675490, "scripts/aitypes/patrol.gsc" },
    { 0x201E1A94F1554A07, "scripts/aitypes/riotshield/riotshield.gsc" },
    { 0x2E9D38C750386509, "scripts/aitypes/robot_dismember.gsc" },
    { 0x544C874800E20BAA, "scripts/aitypes/soldier/agent_setup.gsc" },
    { 0x7997E75E8C58A096, "scripts/aitypes/squad.gsc" },
    { 0x4B3E96950DE06E8C, "scripts/aitypes/squad_movement.gsc" },
    { 0x25EC558982515BD3, "scripts/aitypes/stealth.gsc" },
    { 0x74CB2F5C7F07F60A, "scripts/aitypes/suicidebomber/combat.gsc" },
    { 0x11F8482D601A0E8B, "scripts/aitypes/suicidebomber/setup_agent.gsc" },
    { 0x412F6C016572E634, "scripts/aitypes/throwgrenade.gsc" },
    { 0x009260F116382760, "scripts/aitypes/vehicle.gsc" },
    { 0x1ADB4918CECB4F6A, "scripts/aitypes/weapon.gsc" },
    { 0x0C7FA313D48D792B, "scripts/asm/asm.gsc" },
    { 0x2161B5FA22FA7E26, "scripts/asm/asm_bb.gsc" },
    { 0x547B73EF8F00503B, "scripts/asm/asm_mp.gsc" },
    { 0x1CD62A16E0D5DD95, "scripts/asm/asm_sp.gsc" },
    { 0x5BEE3EC20D14B069, "scripts/asm/civilian/script_funcs.gsc" },
    { 0x49410A43C4B33594, "scripts/asm/dog/move.gsc" },
    { 0x22A56195290EDD97, "scripts/asm/gesture.gsc" },
    { 0x55BE6492B84E43C1, "scripts/asm/gesture/script_funcs.gsc" },
    { 0x260BE52CAB2E0891, "scripts/asm/juggernaut/juggernaut.gsc" },
    { 0x53615BFEFEAE0BC2, "scripts/asm/seeker/melee.gsc" },
    { 0x669A259AF13C5E60, "scripts/asm/shared/mp/utility.gsc" },
    { 0x23366F933E3CF3A6, "scripts/asm/shared/sp/utility.gsc" },
    { 0x48E99BBFB1C38498, "scripts/asm/shared/utility.gsc" },
    { 0x6815796065987415, "scripts/asm/shoot/script_funcs.gsc" },
    { 0x48CFCAC846FDE7EC, "scripts/asm/soldier/arrival.gsc" },
    { 0x15C58B3443C8F5AA, "scripts/asm/soldier/cover.gsc" },
    { 0x4FA7F12CF0B115EA, "scripts/asm/soldier/cp.gsc" },
    { 0x15911D67A81B41FA, "scripts/asm/soldier/custom.gsc" },
    { 0x498A94B2B971C46B, "scripts/asm/soldier/death.gsc" },
    { 0x4482EF346D9A8971, "scripts/asm/soldier/grenade_response.gsc" },
    { 0x15F86984DA58CDA7, "scripts/asm/soldier/ground_turret.gsc" },
    { 0x7C21424B9BAF1D83, "scripts/asm/soldier/interactable.gsc" },
    { 0x793ED8A24E515D55, "scripts/asm/soldier/lmg.gsc" },
    { 0x1C26AA437F78EC66, "scripts/asm/soldier/long_death.gsc" },
    { 0x473FB7B284CF9EDD, "scripts/asm/soldier/melee.gsc" },
    { 0x7430CC4DC955D54C, "scripts/asm/soldier/move.gsc" },
    { 0x349C0B9D73BC7BEC, "scripts/asm/soldier/mp/gesture_script_funcs.gsc" },
    { 0x2E42A30B207A31F7, "scripts/asm/soldier/mp/melee.gsc" },
    { 0x0F5F3AF38B9CE328, "scripts/asm/soldier/mp/script_funcs.gsc" },
    { 0x3D342FD57D1AB889, "scripts/asm/soldier/pain.gsc" },
    { 0x0D61CBBD5CF60E27, "scripts/asm/soldier/patrol.gsc" },
    { 0x48BE9A3E6E3CB250, "scripts/asm/soldier/patrol_idle.gsc" },
    { 0x7DCD7FACEB87E0DA, "scripts/asm/soldier/script_funcs.gsc" },
    { 0x2FC5F0C2A4C01B47, "scripts/asm/soldier/smartobject.gsc" },
    { 0x51A1C4EE4E4055E9, "scripts/asm/soldier/sp/melee.gsc" },
    { 0x3ECDB4A40E3CC60E, "scripts/asm/soldier/sp/script_funcs.gsc" },
    { 0x01D019CB9DAA869F, "scripts/asm/soldier/throwgrenade.gsc" },
    { 0x55C37F8D19CC80E7, "scripts/asm/soldier/traverse.gsc" },
    { 0x41AD1F1424DD3CC9, "scripts/asm/soldier/vehicle.gsc" },
    { 0x1BADAF71B53D50F3, "scripts/asm/suicidebomber/suicidebomber.gsc" },
    { 0x401F827F9CA276D7, "scripts/asm/track.gsc" },
    { 0x2AE0C65FFBA71F3C, "scripts/asm/traverse.gsc" },
    { 0x6F81AE0370D9FD4C, "scripts/code/ai.gsc" },
    { 0x01299D55C0D48CC2, "scripts/code/ai_shooting.gsc" },
    { 0x3B7877BFCEC26473, "scripts/code/character.gsc" },
    { 0x2B0D7E2A0F096CD1, "scripts/code/delete.gsc" },
    { 0x34A720E17D0E697B, "scripts/code/struct.gsc" },
    { 0x659C5B2112E17034, "scripts/common/ai.gsc" },
    { 0x7C0FA206E882CECB, "scripts/common/anim.gsc" },
    { 0x7A6DBD11DBD96EDB, "scripts/common/basic_wind.gsc" },
    { 0x59BAC1035C67173C, "scripts/common/bcs_location_trigs.gsc" },
    { 0x2FFC9CC854107314, "scripts/common/create_cover_nodes.gsc" },
    { 0x75152F52D4583A69, "scripts/common/create_script_utility.gsc" },
    { 0x21486AC5E51045AC, "scripts/common/createfx.gsc" },
    { 0x3B7AF1FD5F2FBB0B, "scripts/common/createfxmenu.gsc" },
    { 0x25660DC6A1A4925F, "scripts/common/csplines.gsc" },
    { 0x30C42DCABD30A39B, "scripts/common/debug_graycard.gsc" },
    { 0x7BABF1485CAE49AB, "scripts/common/debug_reflection.gsc" },
    { 0x3A68A1BDABCACFF8, "scripts/common/elevator.gsc" },
    { 0x0BF3584572AA2FEB, "scripts/common/exploder.gsc" },
    { 0x547435A3732A58C4, "scripts/common/fx.gsc" },
    { 0x22DA8B656744450B, "scripts/common/gameskill.gsc" },
    { 0x200FD802F1105446, "scripts/common/input_allow.gsc" },
    { 0x6318547A70575AE4, "scripts/common/interactive.gsc" },
    { 0x69C2C8AD1C1A4602, "scripts/common/lbravo_ai_infil.gsc" },
    { 0x16448E4E69E35554, "scripts/common/mocap_ar.gsc" },
    { 0x7B165416C1291173, "scripts/common/notetrack.gsc" },
    { 0x4DA9FC5BA0EF1B33, "scripts/common/painter.gsc" },
    { 0x3510835C04D231DF, "scripts/common/rockable_vehicles.gsc" },
    { 0x3B96C3C24CBD640D, "scripts/common/screens.gsc" },
    { 0x70A710E9C0B2022D, "scripts/common/scriptable.gsc" },
    { 0x2C127AAC33157CB4, "scripts/common/turret.gsc" },
    { 0x569B10679FE8CF60, "scripts/common/ui.gsc" },
    { 0x692B19B8E5F8F9E8, "scripts/common/utility.gsc" },
    { 0x4A975D4EC578D9B0, "scripts/common/vehicle.gsc" },
    { 0x1DA5EE063934C32C, "scripts/common/vehicle_aianim.gsc" },
    { 0x7B28CBA57F879E5B, "scripts/common/vehicle_build.gsc" },
    { 0x6D7498659E4F29AE, "scripts/common/vehicle_code.gsc" },
    { 0x1DAFAEBC95981B6E, "scripts/common/vehicle_lights.gsc" },
    { 0x52E0904904AD8537, "scripts/common/vehicle_paths.gsc" },
    { 0x2F491F1DD7B13125, "scripts/common/vehicle_treadfx.gsc" },
    { 0x405C84A849DDC4FB, "scripts/cp/agents/agents.gsc" },
    { 0x10122B3722577A77, "scripts/cp/agents/gametype_cp_specops.gsc" },
    { 0x65E1DFAB60102E56, "scripts/cp/agents/gametype_cp_strike.gsc" },
    { 0x06956673F919E9E6, "scripts/cp/agents/gametype_cp_survival.gsc" },
    { 0x5F75DE291FA2FE7A, "scripts/cp/agents/gametype_cp_wave_survival.gsc" },
    { 0x6E861200387556E9, "scripts/cp/agents/gametype_cp_wave_sv.gsc" },
    { 0x5754FAA22F6AAA4F, "scripts/cp/agents/soldier_agent_spec.gsc" },
    { 0x056F189DC0896467, "scripts/cp/animation_suite.gsc" },
    { 0x05E7E74A6FD92E01, "scripts/cp/astar.gsc" },
    { 0x6D5BA21672C0B8C5, "scripts/cp/bomb_defusal/coop_bomb_defusal.gsc" },
    { 0x604E0C0070C6DCA0, "scripts/cp/calloutmarkerping_cp.gsc" },
    { 0x35EA29F9BD5D2F7E, "scripts/cp/challenges_cp.gsc" },
    { 0x023A633AC3893869, "scripts/cp/classes/cp_class_progression.gsc" },
    { 0x7C4C41D3546BB30A, "scripts/cp/compass.gsc" },
    { 0x41DD26B3A399A786, "scripts/cp/coop_createfx.gsc" },
    { 0x0A7B6C06E6FAEFEB, "scripts/cp/coop_escape.gsc" },
    { 0x68B37C1D85B7E9E0, "scripts/cp/coop_escort.gsc" },
    { 0x7D5265119FD77B8E, "scripts/cp/coop_fx.gsc" },
    { 0x21CE68A1EC9DC5BD, "scripts/cp/coop_personal_ents.gsc" },
    { 0x62E660BE1C9E00D0, "scripts/cp/coop_priority_queue.gsc" },
    { 0x3847B28F27EF1719, "scripts/cp/coop_stealth.gsc" },
    { 0x62E168CCD910BE81, "scripts/cp/coop_super.gsc" },
    { 0x50952380C88E8FAE, "scripts/cp/cp_accessories.gsc" },
    { 0x36B30489B2EC202B, "scripts/cp/cp_achievement.gsc" },
    { 0x289A9D58A559EC35, "scripts/cp/cp_adrenaline_crate.gsc" },
    { 0x0EE49FBD69A66DBD, "scripts/cp/cp_agent_damage.gsc" },
    { 0x5BA9955F5F7C5E56, "scripts/cp/cp_agent_patrol.gsc" },
    { 0x55ACBC2CDAEAA753, "scripts/cp/cp_agent_utils.gsc" },
    { 0x5D1BDBB0E8564315, "scripts/cp/cp_ai_spawn_anim_skits.gsc" },
    { 0x2F6B6BF9F9432559, "scripts/cp/cp_aiparachute.gsc" },
    { 0x0F377DF950536F95, "scripts/cp/cp_aitype_structs_ally_usmc.gsc" },
    { 0x54A590FCE0C11C95, "scripts/cp/cp_aitype_structs_enemy_alq.gsc" },
    { 0x448DD552F3B44DE4, "scripts/cp/cp_ammo_crate.gsc" },
    { 0x0C0338520796EBF4, "scripts/cp/cp_analytics.gsc" },
    { 0x11CC830B10EC9E27, "scripts/cp/cp_anim.gsc" },
    { 0x3AAFE0ECAC1FDE8F, "scripts/cp/cp_armor.gsc" },
    { 0x46BB2A6790B9851B, "scripts/cp/cp_armor_crate.gsc" },
    { 0x160BC2B853762904, "scripts/cp/cp_awards.gsc" },
    { 0x5C9273E0753F93F7, "scripts/cp/cp_battlechatter.gsc" },
    { 0x083851F1CB94F27C, "scripts/cp/cp_battlechatter_ai.gsc" },
    { 0x1CD928C73A3C7AED, "scripts/cp/cp_breach_c4.gsc" },
    { 0x26E61A39B49A2D61, "scripts/cp/cp_c4.gsc" },
    { 0x0D3AF535878CE6A1, "scripts/cp/cp_challenge.gsc" },
    { 0x77CEB810FB262D44, "scripts/cp/cp_checkpoint.gsc" },
    { 0x274B3B919A446B08, "scripts/cp/cp_circuit_breaker.gsc" },
    { 0x66B6D782FB63652E, "scripts/cp/cp_claymore.gsc" },
    { 0x0AE604151E11DB2C, "scripts/cp/cp_compass.gsc" },
    { 0x3B12F328DD1C03E3, "scripts/cp/cp_computerscreen.gsc" },
    { 0x79B0E7CC995DD9D8, "scripts/cp/cp_convoy_manager.gsc" },
    { 0x2E1125AF53E52D26, "scripts/cp/cp_convoy_manager_code.gsc" },
    { 0x2C415637F5D843BE, "scripts/cp/cp_core_gamescore.gsc" },
    { 0x65DD81F3017F5CAD, "scripts/cp/cp_create_script_utility.gsc" },
    { 0x2BD44F94DBFDD1BF, "scripts/cp/cp_damage.gsc" },
    { 0x79678F455E1BAE9C, "scripts/cp/cp_damagefeedback.gsc" },
    { 0x0B39A8DB9AB23587, "scripts/cp/cp_debug.gsc" },
    { 0x19D8325A65696BEC, "scripts/cp/cp_deployablebox.gsc" },
    { 0x6BB1B234318E600C, "scripts/cp/cp_destruction.gsc" },
    { 0x1E66FFA1ABB2E499, "scripts/cp/cp_dev_hud.gsc" },
    { 0x4BD2BA471F17FD24, "scripts/cp/cp_dialogue.gsc" },
    { 0x19CB693D3542F849, "scripts/cp/cp_disguise.gsc" },
    { 0x75A639502844BC46, "scripts/cp/cp_door.gsc" },
    { 0x4CFB447F698AF057, "scripts/cp/cp_drone_strike.gsc" },
    { 0x4C07635B8E253F91, "scripts/cp/cp_electricswitch.gsc" },
    { 0x73F12CC9B65A9264, "scripts/cp/cp_elevator.gsc" },
    { 0x729BFF892DF4D9FF, "scripts/cp/cp_endgame.gsc" },
    { 0x24BD5A7A5FC72606, "scripts/cp/cp_enemy_drone_turret.gsc" },
    { 0x3C605EEE483F1C75, "scripts/cp/cp_enemy_sentry_turret.gsc" },
    { 0x68818DD6020A3887, "scripts/cp/cp_enemy_tank.gsc" },
    { 0x7FA8962E0706F150, "scripts/cp/cp_equipment.gsc" },
    { 0x6394291F25436853, "scripts/cp/cp_escalation.gsc" },
    { 0x20055BA1138A8A43, "scripts/cp/cp_events.gsc" },
    { 0x499369DA3F41F053, "scripts/cp/cp_flares.gsc" },
    { 0x49F97D6E0D4F141C, "scripts/cp/cp_gamescore.gsc" },
    { 0x4C8018F9FF5EE237, "scripts/cp/cp_gameskill.gsc" },
    { 0x72C3C07972988B3A, "scripts/cp/cp_gastrap.gsc" },
    { 0x1DADE61B2677915B, "scripts/cp/cp_globallogic.gsc" },
    { 0x3FAD8171AC52C26D, "scripts/cp/cp_globalthreat.gsc" },
    { 0x4AD2AE2940C76DEA, "scripts/cp/cp_grenade_crate.gsc" },
    { 0x3CE6569E07B2E327, "scripts/cp/cp_hacking.gsc" },
    { 0x3E40218F8932A799, "scripts/cp/cp_hostage.gsc" },
    { 0x595F86A2BB6ADE56, "scripts/cp/cp_hostmigration.gsc" },
    { 0x543CB32E96D20FF9, "scripts/cp/cp_hud_message.gsc" },
    { 0x151D81BF634AAD5C, "scripts/cp/cp_hud_util.gsc" },
    { 0x013C7C6E617BFDA4, "scripts/cp/cp_infilexfil.gsc" },
    { 0x36D208603073D4AC, "scripts/cp/cp_interaction.gsc" },
    { 0x62F044B0BDE21572, "scripts/cp/cp_juggernaut.gsc" },
    { 0x1EEB362406E2139A, "scripts/cp/cp_kidnapper.gsc" },
    { 0x4073C1DE36946D4E, "scripts/cp/cp_ladder.gsc" },
    { 0x132D62A694A66E00, "scripts/cp/cp_laststand.gsc" },
    { 0x41F8DCD8474CD588, "scripts/cp/cp_loadout.gsc" },
    { 0x6721E69491B4F122, "scripts/cp/cp_manned_turret.gsc" },
    { 0x78589419EEF19156, "scripts/cp/cp_mapselect.gsc" },
    { 0x46707B4CCAE70331, "scripts/cp/cp_matchdata.gsc" },
    { 0x314A4197D2CF4C94, "scripts/cp/cp_merits.gsc" },
    { 0x6D71D59B1E04DAD4, "scripts/cp/cp_missilelauncher.gsc" },
    { 0x23D156EB33881960, "scripts/cp/cp_modular_spawning.gsc" },
    { 0x394726D755FA7F04, "scripts/cp/cp_movers.gsc" },
    { 0x436617F5ADA283AE, "scripts/cp/cp_munitions.gsc" },
    { 0x4105B921C7A84DF8, "scripts/cp/cp_music_and_dialog.gsc" },
    { 0x09DD76076AFA2AA3, "scripts/cp/cp_objective_mechanics.gsc" },
    { 0x7A2F1D02E511EC5A, "scripts/cp/cp_objectives.gsc" },
    { 0x2C5E6CC8E8B7747C, "scripts/cp/cp_objectives_events.gsc" },
    { 0x735FDF50A470071A, "scripts/cp/cp_outline.gsc" },
    { 0x3E212ACF2CC9EA85, "scripts/cp/cp_outline_utility.gsc" },
    { 0x73E73FCA13CCD95C, "scripts/cp/cp_outofbounds.gsc" },
    { 0x1287EAC158212373, "scripts/cp/cp_persistence.gsc" },
    { 0x42FC6259D39D4FE4, "scripts/cp/cp_pickup_hostage.gsc" },
    { 0x721F5F6C6EABDD5B, "scripts/cp/cp_player_battlechatter.gsc" },
    { 0x79F7187B2F8EC442, "scripts/cp/cp_playerchatter.gsc" },
    { 0x7CA04657035BFE5D, "scripts/cp/cp_points.gsc" },
    { 0x7F3615DDBB6372C8, "scripts/cp/cp_powers.gsc" },
    { 0x08DC23A8D8BAD4C3, "scripts/cp/cp_puzzles_core.gsc" },
    { 0x483CDEC62A993616, "scripts/cp/cp_quest.gsc" },
    { 0x2720F2C0EEF1847C, "scripts/cp/cp_rank.gsc" },
    { 0x1E349F6532636F4A, "scripts/cp/cp_relics.gsc" },
    { 0x60ABB2EDB1338747, "scripts/cp/cp_remote_tank.gsc" },
    { 0x00ECDC0601E07F09, "scripts/cp/cp_reward.gsc" },
    { 0x126F12D0A469E47E, "scripts/cp/cp_scriptable_states.gsc" },
    { 0x4A93F3F847237123, "scripts/cp/cp_scriptmover_util.gsc" },
    { 0x25ED60BD2F4EA1F8, "scripts/cp/cp_skits.gsc" },
    { 0x3F387D484A0707C4, "scripts/cp/cp_smg_prototype.gsc" },
    { 0x6B4715003EA60CAD, "scripts/cp/cp_snakecam.gsc" },
    { 0x5AB40AA9E7FBD159, "scripts/cp/cp_spawn_factor.gsc" },
    { 0x28B2968BED25CDBE, "scripts/cp/cp_spawner_scoring.gsc" },
    { 0x293B992A2249F427, "scripts/cp/cp_spawning.gsc" },
    { 0x6C4EFA38D9C4B14E, "scripts/cp/cp_spawning_util.gsc" },
    { 0x48A22E190B3C937B, "scripts/cp/cp_squadmanager.gsc" },
    { 0x2FE06DE324077B78, "scripts/cp/cp_stealth_zombie.gsc" },
    { 0x2BB0F43E94BDC558, "scripts/cp/cp_strike_debug.gsc" },
    { 0x277ACFFF23CDF23D, "scripts/cp/cp_traversalassist.gsc" },
    { 0x2132AFACF8AF45A8, "scripts/cp/cp_trigger_spawn.gsc" },
    { 0x2A5E5A422CE4E9D0, "scripts/cp/cp_turret.gsc" },
    { 0x55E7B7B36A41E879, "scripts/cp/cp_vehicle_structs.gsc" },
    { 0x4D8013A60BD4C8FB, "scripts/cp/cp_vehicle_turretdrone.gsc" },
    { 0x705070321815B6C3, "scripts/cp/cp_vehicles.gsc" },
    { 0x27F63F0BE922A0D3, "scripts/cp/cp_vip.gsc" },
    { 0x059F5880FFCCAAF7, "scripts/cp/cp_visionsets.gsc" },
    { 0x2B69DBD597BCE765, "scripts/cp/cp_vo.gsc" },
    { 0x1C546092D05D8344, "scripts/cp/cp_wall_buys.gsc" },
    { 0x418552E46A3464DB, "scripts/cp/cp_wave_spawning.gsc" },
    { 0x0B27F513235A49F6, "scripts/cp/cp_weapon.gsc" },
    { 0x4159CAEE51B2FA49, "scripts/cp/cp_weapon_autosentry.gsc" },
    { 0x37A60B7D589FEEFD, "scripts/cp/cp_weapon_upgrade.gsc" },
    { 0x1F22B3E6E26E904C, "scripts/cp/cp_weaponrank.gsc" },
    { 0x51668D1005BA4945, "scripts/cp/cp_weapons.gsc" },
    { 0x089B97E3AB1D86BC, "scripts/cp/crafting_system.gsc" },
    { 0x5A4ADAD6D823A135, "scripts/cp/crate_drops/cp_crate_drops.gsc" },
    { 0x50B2A6EDDE41AA2E, "scripts/cp/crate_drops/cp_crate_drops_cs.gsc" },
    { 0x234683D1B1309737, "scripts/cp/dedicated.gsc" },
    { 0x2992CA5600A39A84, "scripts/cp/drone/emp_drone.gsc" },
    { 0x6563DD1C0DB7EEB8, "scripts/cp/drone/scout_drone.gsc" },
    { 0x0F63DE2324CD0A73, "scripts/cp/drone/utility.gsc" },
    { 0x6F1A8D1455F4B483, "scripts/cp/emp_debuff_cp.gsc" },
    { 0x7034768B987DCC5A, "scripts/cp/equipment/cp_adrenaline.gsc" },
    { 0x3DEA9FE4B123C89C, "scripts/cp/equipment/cp_at_mine.gsc" },
    { 0x7F8C3E1308318968, "scripts/cp/equipment/cp_decoy_grenade.gsc" },
    { 0x2DD9AE325464900D, "scripts/cp/equipment/cp_gas_grenade.gsc" },
    { 0x79411BE27480A61B, "scripts/cp/equipment/cp_incendiarylauncher.gsc" },
    { 0x3AA23057F7A1DA26, "scripts/cp/equipment/cp_javelin.gsc" },
    { 0x4A1F5B8DBD8EE120, "scripts/cp/equipment/cp_snapshot_grenade.gsc" },
    { 0x55FCDDC3879C791B, "scripts/cp/equipment/cp_stinger.gsc" },
    { 0x5FDF216092548A5F, "scripts/cp/equipment/cp_thermite.gsc" },
    { 0x6E157D31BFA255A7, "scripts/cp/equipment/cp_trophy_system.gsc" },
    { 0x024D396DBAC5EACC, "scripts/cp/equipment/nvg.gsc" },
    { 0x2971096D244C08A9, "scripts/cp/equipment/throwing_knife_cp.gsc" },
    { 0x13D36FE5666830E0, "scripts/cp/execution.gsc" },
    { 0x4F7F576DE1DCE67B, "scripts/cp/extraction/cp_extraction.gsc" },
    { 0x0DA52CED873B216E, "scripts/cp/factions/faction_progression.gsc" },
    { 0x1D156FFAA6303170, "scripts/cp/gestures_cp.gsc" },
    { 0x182955D3F35EB8F1, "scripts/cp/helicopter/chopper_boss.gsc" },
    { 0x11845DB74B81359F, "scripts/cp/helicopter/cp_helicopter.gsc" },
    { 0x72046D774C498C82, "scripts/cp/helicopter/utility.gsc" },
    { 0x37200B0B79C2EF45, "scripts/cp/infilexfil/blima_exfil.gsc" },
    { 0x78A156FE8BE93D79, "scripts/cp/infilexfil/cp_fulton.gsc" },
    { 0x19EE9AE3BB56EEDF, "scripts/cp/infilexfil/infilexfil.gsc" },
    { 0x15BE0F50D6E10D48, "scripts/cp/infilexfil/lbravo_infil_cp.gsc" },
    { 0x59861361D1C462C0, "scripts/cp/init_cp_mp.gsc" },
    { 0x762FABC1B3DB8E09, "scripts/cp/intel/cp_intel.gsc" },
    { 0x66B95516D39196A1, "scripts/cp/inventory/cp_ac130.gsc" },
    { 0x1D3630F1A437E071, "scripts/cp/inventory/cp_target_marker.gsc" },
    { 0x5D8F456289A1D209, "scripts/cp/killstreaks/airdrop_cp.gsc" },
    { 0x2D0318BFB4B92462, "scripts/cp/killstreaks/airdrop_multiple_cp.gsc" },
    { 0x41487CD704154DB4, "scripts/cp/killstreaks/airstrike_cp.gsc" },
    { 0x07615068E3C982AD, "scripts/cp/killstreaks/chopper_gunner_cp.gsc" },
    { 0x24414BB83B2F2627, "scripts/cp/killstreaks/chopper_support_cp.gsc" },
    { 0x75EF61B8FA1851D7, "scripts/cp/killstreaks/cruise_predator_cp.gsc" },
    { 0x5C331B181262E30F, "scripts/cp/killstreaks/emp_drone_cp.gsc" },
    { 0x38D20730D37456E8, "scripts/cp/killstreaks/emp_drone_targeted_cp.gsc" },
    { 0x2B368CB92B87ABCA, "scripts/cp/killstreaks/gunship_cp.gsc" },
    { 0x66BFF03F5F3A9627, "scripts/cp/killstreaks/helper_drone_cp.gsc" },
    { 0x20E2F9F4FDAFF8BE, "scripts/cp/killstreaks/init_cp.gsc" },
    { 0x62761DCD7830BB44, "scripts/cp/killstreaks/juggernaut_cp.gsc" },
    { 0x379BB8C3760185C1, "scripts/cp/killstreaks/manual_turret_cp.gsc" },
    { 0x617CD7DACAE8B0AF, "scripts/cp/killstreaks/nuke_cp.gsc" },
    { 0x3FDC0D8E4813F83E, "scripts/cp/killstreaks/sentry_gun_cp.gsc" },
    { 0x48C42FBBA757D4C0, "scripts/cp/killstreaks/toma_strike_cp.gsc" },
    { 0x6E23C318CA220FA2, "scripts/cp/killstreaks/uav_cp.gsc" },
    { 0x616AC24964989CC7, "scripts/cp/killstreaks/white_phosphorus_cp.gsc" },
    { 0x555547ED1870372D, "scripts/cp/laser_traps/cp_laser_traps.gsc" },
    { 0x6A0B0E660F7EDB04, "scripts/cp/loot_system.gsc" },
    { 0x7E9D90E98B1AE85B, "scripts/cp/perks/cp_perk_utility.gsc" },
    { 0x37F000531EFB9D03, "scripts/cp/perks/cp_perks.gsc" },
    { 0x63407818698EE089, "scripts/cp/perks/cp_prestige.gsc" },
    { 0x057EC8322297A84E, "scripts/cp/pingcallout_cp.gsc" },
    { 0x502187EE15ADB8B1, "scripts/cp/powers/coop_molotov.gsc" },
    { 0x44A1A202E6133294, "scripts/cp/powers/cp_tactical_cover.gsc" },
    { 0x2D28088944F7766D, "scripts/cp/pvpe/pvpe.gsc" },
    { 0x0E4F3E49398FDBE5, "scripts/cp/pvpve/pvpve.gsc" },
    { 0x2837C33EF529314B, "scripts/cp/radio_tower/cp_radio_tower.gsc" },
    { 0x66FFCF39AE863223, "scripts/cp/raid_utility.gsc" },
    { 0x3BFD40AADA1034F6, "scripts/cp/respawn/cp_ac130_respawn.gsc" },
    { 0x28290868030F4DAD, "scripts/cp/respawn/cp_respawn.gsc" },
    { 0x537196C25A85B8A3, "scripts/cp/scriptable.gsc" },
    { 0x267AE50D73BFF6EE, "scripts/cp/so_globallogic.gsc" },
    { 0x494B527121EA82C5, "scripts/cp/so_laststand.gsc" },
    { 0x4CAE33BC187465E1, "scripts/cp/so_trigger.gsc" },
    { 0x5EF6C5C3AFDBA79D, "scripts/cp/so_utility.gsc" },
    { 0x62B2946CC63C0E99, "scripts/cp/so_utility_code.gsc" },
    { 0x48A12E277630CD65, "scripts/cp/stealth/manager.gsc" },
    { 0x15CAA49E8AB60CD8, "scripts/cp/survival/survival_loadout.gsc" },
    { 0x18E0E81A33DEC69E, "scripts/cp/tripwire_cp.gsc" },
    { 0x704D66AFC508AC3A, "scripts/cp/utility.gsc" },
    { 0x0AC80AB8D0901385, "scripts/cp/utility/auto_ascender_ai.gsc" },
    { 0x22598C6DFF6DBD60, "scripts/cp/utility/cp_controlled_callbacks.gsc" },
    { 0x10D8EB6F75795C29, "scripts/cp/utility/cp_safehouse_util.gsc" },
    { 0x428ADA98EB353632, "scripts/cp/utility/disconnect_event_aggregator.gsc" },
    { 0x2E7F32867417B1F6, "scripts/cp/utility/entity.gsc" },
    { 0x137A641CADC5DF20, "scripts/cp/utility/game_utility_cp.gsc" },
    { 0x71E60CC0B80CD0C5, "scripts/cp/utility/join_team_aggregator.gsc" },
    { 0x541F624691B67877, "scripts/cp/utility/lui_game_event_aggregator.gsc" },
    { 0x0B32BD37527ED5D0, "scripts/cp/utility/player.gsc" },
    { 0x667E082B97EDF486, "scripts/cp/utility/player_frame_update_aggregator.gsc" },
    { 0x4C9CFAABC41E2549, "scripts/cp/utility/player_utility_cp.gsc" },
    { 0x406B1E63095AC90E, "scripts/cp/utility/script.gsc" },
    { 0x1D00ED5404824759, "scripts/cp/utility/spawn_event_aggregator.gsc" },
    { 0x1A988F4238CC134A, "scripts/cp/vehicle.gsc" },
    { 0x3D3EEA27753FAC8D, "scripts/cp/vehicle_push/coop_vehicle_push.gsc" },
    { 0x0C8738F5E61AA3AD, "scripts/cp/vehicle_race/coop_vehicle_race.gsc" },
    { 0x1314F8CA41250C97, "scripts/cp/vehicles/apc_rus_cp.gsc" },
    { 0x7C1DC9B75012D20D, "scripts/cp/vehicles/atv_cp.gsc" },
    { 0x7E563E37F833241C, "scripts/cp/vehicles/big_bird_cp.gsc" },
    { 0x2D7CCD517FA86B5E, "scripts/cp/vehicles/cargo_truck_cp.gsc" },
    { 0x7E1F90B8FCC90D4B, "scripts/cp/vehicles/cargo_truck_mg_cp.gsc" },
    { 0x7F25952EB846B8E7, "scripts/cp/vehicles/cop_car_cp.gsc" },
    { 0x2587FE3CA828F536, "scripts/cp/vehicles/cp_heli_trip.gsc" },
    { 0x5D1664FAC671C656, "scripts/cp/vehicles/cp_helicopter_mi8.gsc" },
    { 0x30D9B647A58A56EF, "scripts/cp/vehicles/damage_cp.gsc" },
    { 0x1B2D7444824E829F, "scripts/cp/vehicles/hoopty_cp.gsc" },
    { 0x414B805680AEA797, "scripts/cp/vehicles/hoopty_truck_cp.gsc" },
    { 0x7917E328F45F245C, "scripts/cp/vehicles/jeep_cp.gsc" },
    { 0x4BFB17F9785E3B09, "scripts/cp/vehicles/large_transport_cp.gsc" },
    { 0x74469C864FA3300F, "scripts/cp/vehicles/light_tank_cp.gsc" },
    { 0x15E9979C98CB018C, "scripts/cp/vehicles/little_bird_cp.gsc" },
    { 0x2755B9F0595CAD15, "scripts/cp/vehicles/little_bird_mg_cp.gsc" },
    { 0x714C6548AB77A9D2, "scripts/cp/vehicles/med_transport_cp.gsc" },
    { 0x48462C9702C7F928, "scripts/cp/vehicles/pickup_truck_cp.gsc" },
    { 0x14993A596C0F22BB, "scripts/cp/vehicles/tac_rover_cp.gsc" },
    { 0x2D9DAB3C26B8A7AF, "scripts/cp/vehicles/technical_cp.gsc" },
    { 0x6EDB5C8081558415, "scripts/cp/vehicles/van_cp.gsc" },
    { 0x2B561C2CA275B62F, "scripts/cp/vehicles/vehicle_compass_cp.gsc" },
    { 0x09601F6FC1B3CDDA, "scripts/cp/vehicles/vehicle_cp.gsc" },
    { 0x4FBCA012BFA97E70, "scripts/cp/vehicles/vehicle_damage_cp.gsc" },
    { 0x394EEDA98D15D2C9, "scripts/cp/vehicles/vehicle_interact_cp.gsc" },
    { 0x1A436D415B296844, "scripts/cp/vehicles/vehicle_occupancy_cp.gsc" },
    { 0x08EA223C76EADE2B, "scripts/cp/vehicles/vehicle_oob_cp.gsc" },
    { 0x4510C91C8E5B6F12, "scripts/cp/vehicles/vehicle_spawn_cp.gsc" },
    { 0x6E2D0AB181B939D5, "scripts/cp/whizby.gsc" },
    { 0x5E5302BED1C9AB54, "scripts/cp/zombies/cp_consumables.gsc" },
    { 0x2AA3F2FD74992588, "scripts/cp/zombies/zombieclientmatchdata.gsc" },
    { 0x2B531F520DE8BE5D, "scripts/cp_mp/agents/agent_init.gsc" },
    { 0x21497CDFD058C796, "scripts/cp_mp/anim_scene.gsc" },
    { 0x057ECDF06AE2850F, "scripts/cp_mp/auto_ascender.gsc" },
    { 0x22C673C32C214B45, "scripts/cp_mp/auto_ascender_solo.gsc" },
    { 0x42B73095B90A5E40, "scripts/cp_mp/calloutmarkerping.gsc" },
    { 0x0EAACDDDEB82E2A2, "scripts/cp_mp/challenges.gsc" },
    { 0x610D10F06693A54C, "scripts/cp_mp/crossbow.gsc" },
    { 0x327F500C1192BBCC, "scripts/cp_mp/dragonsbreath.gsc" },
    { 0x310453FFD4B826CD, "scripts/cp_mp/emp_debuff.gsc" },
    { 0x34E0212BD6EB0B7B, "scripts/cp_mp/ent_manager.gsc" },
    { 0x58FDF2A4B13652E7, "scripts/cp_mp/entityheadicons.gsc" },
    { 0x59CAA65F7660D01F, "scripts/cp_mp/equipment/throwing_knife.gsc" },
    { 0x5CD95D34030AEF00, "scripts/cp_mp/execution.gsc" },
    { 0x0394B0216927D91B, "scripts/cp_mp/frontendutils.gsc" },
    { 0x79872B5D956B01EF, "scripts/cp_mp/gasmask.gsc" },
    { 0x068220E8E0090A70, "scripts/cp_mp/gestures.gsc" },
    { 0x4D92F0BDF2AE519C, "scripts/cp_mp/hostmigration.gsc" },
    { 0x3CBDD179351907FF, "scripts/cp_mp/killstreaks/airdrop.gsc" },
    { 0x29B9E1ED7F863326, "scripts/cp_mp/killstreaks/airdrop_multiple.gsc" },
    { 0x7EC888EDE02276A4, "scripts/cp_mp/killstreaks/airstrike.gsc" },
    { 0x3AFD0B936DD113D3, "scripts/cp_mp/killstreaks/chopper_gunner.gsc" },
    { 0x1A6122CD2AABBB81, "scripts/cp_mp/killstreaks/chopper_support.gsc" },
    { 0x493C15D9C046FE11, "scripts/cp_mp/killstreaks/cruise_predator.gsc" },
    { 0x12D33BE994A1E409, "scripts/cp_mp/killstreaks/emp_drone.gsc" },
    { 0x3D32F0014AE692A8, "scripts/cp_mp/killstreaks/emp_drone_targeted.gsc" },
    { 0x7B63B2C4EFF07F0E, "scripts/cp_mp/killstreaks/gunship.gsc" },
    { 0x796277B7D8384901, "scripts/cp_mp/killstreaks/helper_drone.gsc" },
    { 0x5D15FEFDE0156662, "scripts/cp_mp/killstreaks/init.gsc" },
    { 0x77A457A5D8F67854, "scripts/cp_mp/killstreaks/juggernaut.gsc" },
    { 0x5B79F7D46D6479DD, "scripts/cp_mp/killstreaks/killstreakdeploy.gsc" },
    { 0x37A6DF148102BC77, "scripts/cp_mp/killstreaks/manual_turret.gsc" },
    { 0x099B9AE87B9F00A9, "scripts/cp_mp/killstreaks/nuke.gsc" },
    { 0x319B26E5DA0E9AA2, "scripts/cp_mp/killstreaks/sentry_gun.gsc" },
    { 0x531984808E0A74E0, "scripts/cp_mp/killstreaks/toma_strike.gsc" },
    { 0x599E12F80C250C26, "scripts/cp_mp/killstreaks/uav.gsc" },
    { 0x4FA625E08B5F76E1, "scripts/cp_mp/killstreaks/white_phosphorus.gsc" },
    { 0x358A4C8214A89870, "scripts/cp_mp/mortar_launcher.gsc" },
    { 0x13D7519ECADA5FEA, "scripts/cp_mp/outofrange.gsc" },
    { 0x49863B206F5403F9, "scripts/cp_mp/parachute.gsc" },
    { 0x1762D7B022D62EC7, "scripts/cp_mp/pet_watch.gsc" },
    { 0x11C55E2B1FDB5952, "scripts/cp_mp/pingcallout.gsc" },
    { 0x67867A1F12BFFE59, "scripts/cp_mp/powershud.gsc" },
    { 0x3252C18D08B50FA7, "scripts/cp_mp/targetmarkergroups.gsc" },
    { 0x4F3E271314233182, "scripts/cp_mp/tripwire.gsc" },
    { 0x3E80883B1C2C99EA, "scripts/cp_mp/utility/callback_group.gsc" },
    { 0x530723981CD177B3, "scripts/cp_mp/utility/damage_utility.gsc" },
    { 0x725B0F2DCBE6355D, "scripts/cp_mp/utility/debug_utility.gsc" },
    { 0x2A1F65FFEC5045C2, "scripts/cp_mp/utility/dialog_utility.gsc" },
    { 0x6867234FFDC3D080, "scripts/cp_mp/utility/game_utility.gsc" },
    { 0x6067C167A3F99BBE, "scripts/cp_mp/utility/inventory_utility.gsc" },
    { 0x28B34FF40BDC5650, "scripts/cp_mp/utility/killstreak_utility.gsc" },
    { 0x2E16EF26A0FFD44D, "scripts/cp_mp/utility/omnvar_utility.gsc" },
    { 0x211923DEDCAFA6FF, "scripts/cp_mp/utility/player_utility.gsc" },
    { 0x629BF3BE88C38481, "scripts/cp_mp/utility/script_utility.gsc" },
    { 0x4ADB0DFC58C787C2, "scripts/cp_mp/utility/scriptable_door_utility.gsc" },
    { 0x4F467DF70D327452, "scripts/cp_mp/utility/shellshock_utility.gsc" },
    { 0x0AA432172D0E22B0, "scripts/cp_mp/utility/train_utility.gsc" },
    { 0x4B8FA1B777292D0C, "scripts/cp_mp/utility/vehicle_omnvar_utility.gsc" },
    { 0x1D0CF33B53E307AE, "scripts/cp_mp/utility/weapon_utility.gsc" },
    { 0x76C93B759C20A1D1, "scripts/cp_mp/vehicles/apc_rus.gsc" },
    { 0x75D95066D2C8F9B3, "scripts/cp_mp/vehicles/atv.gsc" },
    { 0x79BF3825A29C802C, "scripts/cp_mp/vehicles/big_bird.gsc" },
    { 0x36FD1BA91582B102, "scripts/cp_mp/vehicles/cargo_truck.gsc" },
    { 0x22B1DE31D2721635, "scripts/cp_mp/vehicles/cargo_truck_mg.gsc" },
    { 0x38D5E2DD897D3241, "scripts/cp_mp/vehicles/cop_car.gsc" },
    { 0x2E1B586227A20CEF, "scripts/cp_mp/vehicles/customization/battle_tracks.gsc" },
    { 0x22F5232830940339, "scripts/cp_mp/vehicles/hoopty.gsc" },
    { 0x3D00154BABB8D851, "scripts/cp_mp/vehicles/hoopty_truck.gsc" },
    { 0x67953482877E2F2C, "scripts/cp_mp/vehicles/jeep.gsc" },
    { 0x622D09A3F1D899BF, "scripts/cp_mp/vehicles/large_transport.gsc" },
    { 0x67E6850B771B9C89, "scripts/cp_mp/vehicles/light_tank.gsc" },
    { 0x4C822A64AB8A0BBC, "scripts/cp_mp/vehicles/little_bird.gsc" },
    { 0x664C60C6B4325FBB, "scripts/cp_mp/vehicles/little_bird_mg.gsc" },
    { 0x2C1C5D4D18A61876, "scripts/cp_mp/vehicles/med_transport.gsc" },
    { 0x1E06CF212F559628, "scripts/cp_mp/vehicles/pickup_truck.gsc" },
    { 0x4DA9787D96781405, "scripts/cp_mp/vehicles/tac_rover.gsc" },
    { 0x27C4FFEF9D1A1E29, "scripts/cp_mp/vehicles/technical.gsc" },
    { 0x7405E9F971AEA03B, "scripts/cp_mp/vehicles/van.gsc" },
    { 0x7584507A08593DFE, "scripts/cp_mp/vehicles/vehicle.gsc" },
    { 0x0873A961AAF63D09, "scripts/cp_mp/vehicles/vehicle_collision.gsc" },
    { 0x53DAF50CB5B28A69, "scripts/cp_mp/vehicles/vehicle_compass.gsc" },
    { 0x1971B0AC5B8846B0, "scripts/cp_mp/vehicles/vehicle_damage.gsc" },
    { 0x5457C66E69E57487, "scripts/cp_mp/vehicles/vehicle_dlog.gsc" },
    { 0x6AFAA0F7EB512CFF, "scripts/cp_mp/vehicles/vehicle_interact.gsc" },
    { 0x6695768C8D8C0AC9, "scripts/cp_mp/vehicles/vehicle_mines.gsc" },
    { 0x1C66378FB8B32394, "scripts/cp_mp/vehicles/vehicle_occupancy.gsc" },
    { 0x715D43F039E876B6, "scripts/cp_mp/vehicles/vehicle_spawn.gsc" },
    { 0x0A7D1715B70FF548, "scripts/cp_mp/vehicles/vehicle_tracking.gsc" },
    { 0x052407859F1EE32A, "scripts/cp_mp/xmike109.gsc" },
    { 0x26AEEAA01EAA6490, "scripts/engine/dev.gsc" },
    { 0x0EF47F6B12175664, "scripts/engine/flags.gsc" },
    { 0x00A3E73C9CCEAFB1, "scripts/engine/math.gsc" },
    { 0x1685AE0605A93B68, "scripts/engine/scriptable.gsc" },
    { 0x68C270174E9CD90F, "scripts/engine/scriptable_door.gsc" },
    { 0x43CD7D39C04B0B1B, "scripts/engine/sp/objectives.gsc" },
    { 0x63847839C2EB90CF, "scripts/engine/sp/utility.gsc" },
    { 0x1F8967BAF0600893, "scripts/engine/sp/utility_code.gsc" },
    { 0x062CEB051D758BFE, "scripts/engine/trace.gsc" },
    { 0x4A55403D502E794F, "scripts/engine/utility.gsc" },
    { 0x09E8FC39CD2F6663, "scripts/game/sp/door.gsc" },
    { 0x5E0DDEE0791E26CF, "scripts/game/sp/load.gsc" },
    { 0x700102F2560F3709, "scripts/game/sp/outline.gsc" },
    { 0x5EA18269586EF376, "scripts/game/sp/player.gsc" },
    { 0x0D957B719A00CC94, "scripts/game/sp/stealth/manager.gsc" },
    { 0x5B685ED8CE43EEC7, "scripts/game/sp/trigger.gsc" },
    { 0x36DAF6000B4D77F8, "scripts/models/interactive_utility.gsc" },
    { 0x64EACF6046BF3D0E, "scripts/mp/accessories.gsc" },
    { 0x13D14023C67003BF, "scripts/mp/accolades.gsc" },
    { 0x39F58EA1AAEC2704, "scripts/mp/agents/agent_common.gsc" },
    { 0x2DF9D011999F18C5, "scripts/mp/agents/agent_utility.gsc" },
    { 0x069E2E8BEBE24A71, "scripts/mp/agents/agents.gsc" },
    { 0x1BBD73F73D2EF1B9, "scripts/mp/agents/alien/agents.gsc" },
    { 0x4CB10753200A48D0, "scripts/mp/agents/juggernaut/juggernaut_agent.gsc" },
    { 0x76A7F3AEE85CD833, "scripts/mp/agents/scriptedagents.gsc" },
    { 0x203A40177CB16AD2, "scripts/mp/agents/soldier/soldier_agent.gsc" },
    { 0x099823E985D28A2A, "scripts/mp/agents/suicidebomber/suicidebomber_agent.gsc" },
    { 0x774A3800757E6127, "scripts/mp/ammorestock.gsc" },
    { 0x6451646090824DA0, "scripts/mp/analyticslog.gsc" },
    { 0x73B60289C107FA07, "scripts/mp/anim.gsc" },
    { 0x5C483C780DB0B4AD, "scripts/mp/animatedmodels.gsc" },
    { 0x036E9988C3BE2565, "scripts/mp/animation_suite.gsc" },
    { 0x5FED28AD3185123C, "scripts/mp/arbitrary_up.gsc" },
    { 0x69A005BA63022C32, "scripts/mp/archetypes/archassault.gsc" },
    { 0x344756288E55ECDC, "scripts/mp/archetypes/archcommon.gsc" },
    { 0x46CF841695574F2A, "scripts/mp/areas.gsc" },
    { 0x1582197658C00E0F, "scripts/mp/arm_objectives/arm_obj_capture.gsc" },
    { 0x0BB3B3FCF1E71C68, "scripts/mp/arm_objectives/arm_obj_nuke.gsc" },
    { 0x31FCFD26E002B5AD, "scripts/mp/art.gsc" },
    { 0x2CC9B45597129EE2, "scripts/mp/audio.gsc" },
    { 0x699319EBB3058664, "scripts/mp/awards.gsc" },
    { 0x09002E3F894F958F, "scripts/mp/battlechatter_mp.gsc" },
    { 0x2AE8954A31D1803F, "scripts/mp/battlechatter_trigs.gsc" },
    { 0x266C7A1B794E081D, "scripts/mp/bots/bots.gsc" },
    { 0x347C8A067853B721, "scripts/mp/bots/bots_killstreaks.gsc" },
    { 0x6D3FF989D9009D95, "scripts/mp/bots/bots_killstreaks_remote_vehicle.gsc" },
    { 0x715B1AE771EA5B66, "scripts/mp/bots/bots_loadout.gsc" },
    { 0x1AAA79412E7BC206, "scripts/mp/bots/bots_personality.gsc" },
    { 0x60842FAF6B334477, "scripts/mp/bots/bots_sentry.gsc" },
    { 0x4145A7B3D8867DC9, "scripts/mp/bots/bots_strategy.gsc" },
    { 0x6A4DD5B41C09D1DC, "scripts/mp/bots/bots_util.gsc" },
    { 0x2205C1B16EDB84F5, "scripts/mp/bounty.gsc" },
    { 0x6748E0ED34B820E0, "scripts/mp/brclientmatchdata.gsc" },
    { 0x4D6081907AE68B01, "scripts/mp/brmatchdata.gsc" },
    { 0x47E0A020EF1BD449, "scripts/mp/broshot.gsc" },
    { 0x78985E1693DBFC76, "scripts/mp/broshot_utilities.gsc" },
    { 0x22FC1806B758E28C, "scripts/mp/callbacksetup.gsc" },
    { 0x235CCFCBDDE6F11C, "scripts/mp/calloutmarkerping_mp.gsc" },
    { 0x7001F79CFE5FF18F, "scripts/mp/callouts.gsc" },
    { 0x2FC321D925A41E8F, "scripts/mp/carriable.gsc" },
    { 0x5035FF3B2CDC2C78, "scripts/mp/challengefunctions.gsc" },
    { 0x1576A58623076050, "scripts/mp/challenges.gsc" },
    { 0x403A175F4355A4D6, "scripts/mp/challenges_mp.gsc" },
    { 0x366CA3A566B6972B, "scripts/mp/cinematic_replays/cinematic_replays.gsc" },
    { 0x062B082B02843BE8, "scripts/mp/class.gsc" },
    { 0x6256D4509C1489D0, "scripts/mp/clientmatchdata.gsc" },
    { 0x5BBC3347BA096E70, "scripts/mp/codcasterclientmatchdata.gsc" },
    { 0x054823A29593228C, "scripts/mp/compass.gsc" },
    { 0x6CA75CE7FE1AAC52, "scripts/mp/cranked.gsc" },
    { 0x515715367B555558, "scripts/mp/createfx.gsc" },
    { 0x4C9F3A24FEABDE1F, "scripts/mp/damage.gsc" },
    { 0x0AB66257F363A87C, "scripts/mp/damagefeedback.gsc" },
    { 0x706E421915FE0EC2, "scripts/mp/deathicons.gsc" },
    { 0x08B0AE017A7B271D, "scripts/mp/dedicated.gsc" },
    { 0x7AD2C20674B3130B, "scripts/mp/destructables.gsc" },
    { 0x2DCD44765B157D94, "scripts/mp/destructible.gsc" },
    { 0x7262B27DE233448F, "scripts/mp/dev.gsc" },
    { 0x578FB8CED8601826, "scripts/mp/door.gsc" },
    { 0x0091857B22BC390B, "scripts/mp/emp_debuff_mp.gsc" },
    { 0x6B0663A111030B30, "scripts/mp/equipment.gsc" },
    { 0x5195DCD5F2C7BAA0, "scripts/mp/equipment/adrenaline.gsc" },
    { 0x6220E12CD13C3ED3, "scripts/mp/equipment/advanced_supply_drop.gsc" },
    { 0x34501F9ECF90E137, "scripts/mp/equipment/ammo_box.gsc" },
    { 0x45459AD0B3175243, "scripts/mp/equipment/armor_plate.gsc" },
    { 0x55FA19D619695CBA, "scripts/mp/equipment/at_mine.gsc" },
    { 0x7A2AF52457AE0749, "scripts/mp/equipment/bandage.gsc" },
    { 0x7D848B7984C32341, "scripts/mp/equipment/binoculars.gsc" },
    { 0x107FE0BE820063D4, "scripts/mp/equipment/c4.gsc" },
    { 0x2C9121F81520D673, "scripts/mp/equipment/claymore.gsc" },
    { 0x51568199B1AF4A56, "scripts/mp/equipment/concussion_grenade.gsc" },
    { 0x1D31961E095E6EF6, "scripts/mp/equipment/decoy_grenade.gsc" },
    { 0x40B914EACAA3AA0C, "scripts/mp/equipment/emp_grenade.gsc" },
    { 0x1EDC017AA10C8CBC, "scripts/mp/equipment/flash_grenade.gsc" },
    { 0x5E747F703EDB679F, "scripts/mp/equipment/fulton.gsc" },
    { 0x7373E282602728FB, "scripts/mp/equipment/gas_grenade.gsc" },
    { 0x17E1C85F6522B03E, "scripts/mp/equipment/hb_sensor.gsc" },
    { 0x36BC9A97851A00C1, "scripts/mp/equipment/molotov.gsc" },
    { 0x356D29B50E0D748A, "scripts/mp/equipment/nvg.gsc" },
    { 0x1975B2A6D9277F52, "scripts/mp/equipment/snapshot_grenade.gsc" },
    { 0x6BD6931761011BDE, "scripts/mp/equipment/support_box.gsc" },
    { 0x62E0B7188E7534AB, "scripts/mp/equipment/tac_insert.gsc" },
    { 0x0E6F637D07D400CA, "scripts/mp/equipment/tactical_cover.gsc" },
    { 0x7624ADA505D2A7AD, "scripts/mp/equipment/thermite.gsc" },
    { 0x4FFAF2388B3485F9, "scripts/mp/equipment/throwing_knife_mp.gsc" },
    { 0x384F37134A7FC089, "scripts/mp/equipment/trophy_system.gsc" },
    { 0x72525C7AD16B9DBF, "scripts/mp/equipment/weapon_drop.gsc" },
    { 0x08BAE979BBAB4744, "scripts/mp/equipment/wristrocket.gsc" },
    { 0x58D07AF23A255EDD, "scripts/mp/equipment_interact.gsc" },
    { 0x66CF1FB5A503DC23, "scripts/mp/events.gsc" },
    { 0x70E69A9871881054, "scripts/mp/execution_mp.gsc" },
    { 0x6C56BE85DC248D98, "scripts/mp/final_killcam.gsc" },
    { 0x778027EDF01BD587, "scripts/mp/flags.gsc" },
    { 0x2652A8D02E4D8616, "scripts/mp/flashpoint.gsc" },
    { 0x4B4D37F69AE2EE32, "scripts/mp/friendicons.gsc" },
    { 0x706C46647D245B88, "scripts/mp/fx.gsc" },
    { 0x184C00AF74E45F30, "scripts/mp/gamelogic.gsc" },
    { 0x08EB711E37ED0AFA, "scripts/mp/gameobjects.gsc" },
    { 0x267A69C97E3C6C7C, "scripts/mp/gamescore.gsc" },
    { 0x6A8018994EBC5564, "scripts/mp/gestures_mp.gsc" },
    { 0x5411D5BC326E2B16, "scripts/mp/global_fx.gsc" },
    { 0x650FA6593ACFEE24, "scripts/mp/global_fx_code.gsc" },
    { 0x60BE114DF57C78E6, "scripts/mp/globalentities.gsc" },
    { 0x3FA219AD83E2CEBB, "scripts/mp/globallogic.gsc" },
    { 0x6FC56E06DD73EFE6, "scripts/mp/healthoverlay.gsc" },
    { 0x5242C074CD388A30, "scripts/mp/heavyarmor.gsc" },
    { 0x35B1921537324436, "scripts/mp/hostmigration.gsc" },
    { 0x026F0756F77CFCFD, "scripts/mp/hud.gsc" },
    { 0x52A6D55588CB0819, "scripts/mp/hud_message.gsc" },
    { 0x64AFAE76CCB166FC, "scripts/mp/hud_util.gsc" },
    { 0x462BDA75FFA6B33D, "scripts/mp/infilexfil/infilexfil.gsc" },
    { 0x42BAB28F5AE5F14E, "scripts/mp/infilexfil/lbravo_infil.gsc" },
    { 0x734ED556D535A69C, "scripts/mp/infilexfil/mi8_infil.gsc" },
    { 0x6B0802F0AC29060A, "scripts/mp/infilexfil/rappel_hackney_infil.gsc" },
    { 0x21333AE88F67B6A6, "scripts/mp/infilexfil/tango72_infil.gsc" },
    { 0x4CEDFC60057078BB, "scripts/mp/infilexfil/umike_infil.gsc" },
    { 0x6EE7F325AE4106A3, "scripts/mp/infilexfil/van_hackney_infil.gsc" },
    { 0x062B0889104A0D53, "scripts/mp/infilexfil/vindia_infil.gsc" },
    { 0x116CEABE045DE636, "scripts/mp/init_cp_mp.gsc" },
    { 0x61785096CD84035F, "scripts/mp/javelin.gsc" },
    { 0x1B31527B4E9781D2, "scripts/mp/juggernaut.gsc" },
    { 0x5732201DEF3A65C7, "scripts/mp/killcam.gsc" },
    { 0x32F367E853EFE0D6, "scripts/mp/killstreaks/agent_killstreak.gsc" },
    { 0x731DAAA368B23D4D, "scripts/mp/killstreaks/airdrop_mp.gsc" },
    { 0x1966DFCBD2D268D2, "scripts/mp/killstreaks/airdrop_multiple_mp.gsc" },
    { 0x5EB2D51A1D6C552C, "scripts/mp/killstreaks/airstrike_mp.gsc" },
    { 0x6FF86FEE6AED42AE, "scripts/mp/killstreaks/autosentry.gsc" },
    { 0x6D49F8837731F254, "scripts/mp/killstreaks/chill_common.gsc" },
    { 0x418B7A968E4F7C79, "scripts/mp/killstreaks/chopper_gunner_mp.gsc" },
    { 0x6B4907D1FFFDCE37, "scripts/mp/killstreaks/chopper_support_mp.gsc" },
    { 0x34FF41F4B3FA424F, "scripts/mp/killstreaks/cruise_predator_mp.gsc" },
    { 0x53BB6FF768A47B95, "scripts/mp/killstreaks/death_switch.gsc" },
    { 0x08AFBBC16473D488, "scripts/mp/killstreaks/deployablebox.gsc" },
    { 0x31463F34A13101FD, "scripts/mp/killstreaks/deployablebox_vest.gsc" },
    { 0x37BB89B7C584D340, "scripts/mp/killstreaks/dronehive.gsc" },
    { 0x10662A1ACF0EBE7E, "scripts/mp/killstreaks/emp.gsc" },
    { 0x2F7C1B498F830663, "scripts/mp/killstreaks/emp_drone_mp.gsc" },
    { 0x64C3321543BBEFD8, "scripts/mp/killstreaks/emp_drone_targeted_mp.gsc" },
    { 0x2FF254B9E27B9387, "scripts/mp/killstreaks/flares.gsc" },
    { 0x465B9DE35EFC49F2, "scripts/mp/killstreaks/gunship_mp.gsc" },
    { 0x300A0A4C67DA0BBB, "scripts/mp/killstreaks/helicopter.gsc" },
    { 0x44C9AA44134DB592, "scripts/mp/killstreaks/helicopter_pilot.gsc" },
    { 0x250950A7F930FE33, "scripts/mp/killstreaks/helper_drone.gsc" },
    { 0x7D681FCF8E7487F3, "scripts/mp/killstreaks/helper_drone_mp.gsc" },
    { 0x7D5D18083C3669C2, "scripts/mp/killstreaks/hover_jet.gsc" },
    { 0x54B4BE63F861801A, "scripts/mp/killstreaks/init_mp.gsc" },
    { 0x3406DC94C9535A80, "scripts/mp/killstreaks/jackal.gsc" },
    { 0x41D9F3E9C0FED124, "scripts/mp/killstreaks/juggernaut_mp.gsc" },
    { 0x380B66B9CD34D48B, "scripts/mp/killstreaks/killstreaks.gsc" },
    { 0x1272B945C902B191, "scripts/mp/killstreaks/manual_turret_mp.gsc" },
    { 0x0DABA2E9A8350242, "scripts/mp/killstreaks/mapselect.gsc" },
    { 0x0C4EEB121BA27B97, "scripts/mp/killstreaks/nuke.gsc" },
    { 0x6737E57A4723484F, "scripts/mp/killstreaks/nuke_mp.gsc" },
    { 0x1636BB4817605A4F, "scripts/mp/killstreaks/placeable.gsc" },
    { 0x693AF273776F420A, "scripts/mp/killstreaks/plane.gsc" },
    { 0x56F2DCFF53F2245F, "scripts/mp/killstreaks/proxyagent.gsc" },
    { 0x3DA7B46BA89E263E, "scripts/mp/killstreaks/remotemissile.gsc" },
    { 0x5174EF0A925C8314, "scripts/mp/killstreaks/remotetank.gsc" },
    { 0x3D9FB1EE60CBAD42, "scripts/mp/killstreaks/remoteturret.gsc" },
    { 0x21B311364005EBAA, "scripts/mp/killstreaks/remoteuav.gsc" },
    { 0x57AB0F132F2DA29E, "scripts/mp/killstreaks/sentry_gun_mp.gsc" },
    { 0x2458F30EAB0498D8, "scripts/mp/killstreaks/target_marker.gsc" },
    { 0x04A9FF33C9C66EC4, "scripts/mp/killstreaks/throwback_marker.gsc" },
    { 0x3D049B8395ABB6E4, "scripts/mp/killstreaks/toma_strike_mp.gsc" },
    { 0x19EC0FE0C3415CA2, "scripts/mp/killstreaks/uav_mp.gsc" },
    { 0x3DCF889324D28903, "scripts/mp/killstreaks/white_phosphorus_mp.gsc" },
    { 0x08C8E132AF264960, "scripts/mp/laststand.gsc" },
    { 0x7F22DB280E8CC6C9, "scripts/mp/launcher_target_lead.gsc" },
    { 0x3C56D7D289AAAF81, "scripts/mp/lightarmor.gsc" },
    { 0x21F4499C4ABFF7BF, "scripts/mp/lightbar.gsc" },
    { 0x7D419D1DFD062946, "scripts/mp/load.gsc" },
    { 0x5CEFBBF3A6A9A8B0, "scripts/mp/loot.gsc" },
    { 0x6FEFACA85CCC3691, "scripts/mp/matchdata.gsc" },
    { 0x59A28AA393C6BB32, "scripts/mp/matchrecording.gsc" },
    { 0x3AFE00DA9A5BB422, "scripts/mp/matchstats.gsc" },
    { 0x498B9015FC4A2548, "scripts/mp/menus.gsc" },
    { 0x16B87C6B95574BD0, "scripts/mp/minefields.gsc" },
    { 0x3317E070395BD534, "scripts/mp/missilelauncher.gsc" },
    { 0x3931ECB959834BBD, "scripts/mp/motiondetectors.gsc" },
    { 0x5A11116778A6D864, "scripts/mp/movers.gsc" },
    { 0x4DB5D44A376C1C35, "scripts/mp/mp_agent.gsc" },
    { 0x7AF5DD2BC2CC926D, "scripts/mp/mp_agent_damage.gsc" },
    { 0x37397E0B9CA7C1D8, "scripts/mp/music_and_dialog.gsc" },
    { 0x5C0063AB6B81303F, "scripts/mp/objidpoolmanager.gsc" },
    { 0x73B96343B87E992A, "scripts/mp/objpoints.gsc" },
    { 0x66D1063967FA26FA, "scripts/mp/outline.gsc" },
    { 0x125E1DE662C614BC, "scripts/mp/outofbounds.gsc" },
    { 0x6F3C39F8B9544B50, "scripts/mp/passives.gsc" },
    { 0x7B33D78CAC102B89, "scripts/mp/perks/headgear.gsc" },
    { 0x65682009E2287F13, "scripts/mp/perks/perk_equipmentping.gsc" },
    { 0x4B3976A0DF8B09A3, "scripts/mp/perks/perk_mark_targets.gsc" },
    { 0x594C46BDBBC57CA3, "scripts/mp/perks/perkfunctions.gsc" },
    { 0x4F61C97BBA28F546, "scripts/mp/perks/perkpackage.gsc" },
    { 0x52B5F3FAED29F517, "scripts/mp/perks/perks.gsc" },
    { 0x1FC5765DB46366C6, "scripts/mp/perks/weaponpassives.gsc" },
    { 0x7283136DAF802C53, "scripts/mp/persistence.gsc" },
    { 0x10E7A93D981318CA, "scripts/mp/pingcallout_mp.gsc" },
    { 0x1C8476F56CBCD27C, "scripts/mp/playeractions.gsc" },
    { 0x6F294F32B60C71F4, "scripts/mp/playercards.gsc" },
    { 0x344020C171EC72D5, "scripts/mp/playerlogic.gsc" },
    { 0x35E7732D85CF4FB4, "scripts/mp/playerstats.gsc" },
    { 0x28264B40CEFBE224, "scripts/mp/playerstats_interface.gsc" },
    { 0x71CDF59D18E9F382, "scripts/mp/potg.gsc" },
    { 0x22085D5A2D267F34, "scripts/mp/potg_events.gsc" },
    { 0x5CCC4374F6C041E3, "scripts/mp/radiation.gsc" },
    { 0x1BF41126054F4E1D, "scripts/mp/rally_point.gsc" },
    { 0x5B79F5CE7E653825, "scripts/mp/rangefinder.gsc" },
    { 0x5CD1439734C434DC, "scripts/mp/rank.gsc" },
    { 0x0C5ABF1CDB1BB1A5, "scripts/mp/riotshield.gsc" },
    { 0x16617DE231BF5280, "scripts/mp/scoreboard.gsc" },
    { 0x6ECD08699CCB09B5, "scripts/mp/screenshotcity.gsc" },
    { 0x525CD9B94F8850C1, "scripts/mp/scriptable.gsc" },
    { 0x36B0C9C343A37CC3, "scripts/mp/secrethunt.gsc" },
    { 0x7911684723811DF3, "scripts/mp/sentientpoolmanager.gsc" },
    { 0x12971CEBDD7FFF70, "scripts/mp/serversettings.gsc" },
    { 0x374464F426BC84E2, "scripts/mp/shellshock.gsc" },
    { 0x27C5D22C922F2128, "scripts/mp/spawncamera.gsc" },
    { 0x4590A825A33E1804, "scripts/mp/spawnfactor.gsc" },
    { 0x6024AD55E5032489, "scripts/mp/spawnlogic.gsc" },
    { 0x0C46589F289D961A, "scripts/mp/spawnscoring.gsc" },
    { 0x08F3CB4DBABAE3A5, "scripts/mp/spawnselection.gsc" },
    { 0x10107DC25F5BD62E, "scripts/mp/spectating.gsc" },
    { 0x2F2F0B2412213D7A, "scripts/mp/subway/fast_travel_subway_car.gsc" },
    { 0x037052EFEC602BD0, "scripts/mp/subway/fast_travel_subway_station.gsc" },
    { 0x4FCA32F463C5E4FA, "scripts/mp/supers.gsc" },
    { 0x57886B1B2348AA4E, "scripts/mp/supers/laststand_heal.gsc" },
    { 0x648662AC64713336, "scripts/mp/supers/spawnbeacon.gsc" },
    { 0x1E5E1BFD8FA7E030, "scripts/mp/supers/super_deadsilence.gsc" },
    { 0x09711BB6E8ABDC00, "scripts/mp/supers/super_stoppingpower.gsc" },
    { 0x0BB2B63F19A7FA8E, "scripts/mp/tac_ops/hostage_utility.gsc" },
    { 0x4EAAC25F24AF4921, "scripts/mp/tac_ops/hvt_utility.gsc" },
    { 0x3DADDE2C4C9D2D5C, "scripts/mp/tac_ops/radio_utility.gsc" },
    { 0x3321FCDA17B126B6, "scripts/mp/tac_ops/roles_utility.gsc" },
    { 0x78DE14F10227476E, "scripts/mp/tac_ops_map.gsc" },
    { 0x57D62CB7DDC6066A, "scripts/mp/teamrevive.gsc" },
    { 0x18A132AEEE23136E, "scripts/mp/teams.gsc" },
    { 0x5AE66D06F20630A9, "scripts/mp/trials/mp_cave_am_create_script.gsc" },
    { 0x28FDBC01EA4D3110, "scripts/mp/trials/mp_emporium_create_script_floorislava.gsc" },
    { 0x1CB7E984BFB2488C, "scripts/mp/trials/mp_euphrates_create_script.gsc" },
    { 0x146CF05CA89271EB, "scripts/mp/trials/mp_euphrates_create_script_gunnonlinear.gsc" },
    { 0x16D75E0530ECE1EE, "scripts/mp/trials/mp_harbor_floorislava_create_script.gsc" },
    { 0x6977064AFBA29D1A, "scripts/mp/trials/mp_m_cornfield_floor_is_lava_create_script.gsc" },
    { 0x5AF91DAD24C6122C, "scripts/mp/trials/mp_m_king_create_script.gsc" },
    { 0x4CF1D51227BEDB38, "scripts/mp/trials/mp_m_trench_create_script_gunnonlinear.gsc" },
    { 0x2A4BF9C81FFB99CD, "scripts/mp/trials/mp_oilrig_create_script.gsc" },
    { 0x0A19E4D5955D28E9, "scripts/mp/trials/mp_t_reflex_create_script_quadrace.gsc" },
    { 0x560D4B5E8DCB4FBB, "scripts/mp/trials/mp_trial_helicopter_port_create_a_script.gsc" },
    { 0x758374748F03BA22, "scripts/mp/trials/mp_trials_patches.gsc" },
    { 0x01A0AEA59EE8415F, "scripts/mp/trials/mp_trials_patches_petrograd.gsc" },
    { 0x32F57BF21B863A72, "scripts/mp/trials/mp_trl_boneyard_gw_race.gsc" },
    { 0x7CEF55681AF4328D, "scripts/mp/trials/mp_trl_cleararea.gsc" },
    { 0x7BD04BF9AB7DA819, "scripts/mp/trials/mp_trl_create_a_script_race_euphrates.gsc" },
    { 0x70150D6A872B30AB, "scripts/mp/trials/mp_trl_destroy.gsc" },
    { 0x701C8CAC53E33D3D, "scripts/mp/trials/mp_trl_floorislava.gsc" },
    { 0x48DCA902ACA6E531, "scripts/mp/trials/mp_trl_gunslinger.gsc" },
    { 0x4BAFEADA1AF601F4, "scripts/mp/trials/mp_trl_gunslinger_crash_create_script.gsc" },
    { 0x6AE1A60E4389B2B2, "scripts/mp/trials/mp_trl_gunslinger_knife_create_script.gsc" },
    { 0x1F5F365E79A4CB06, "scripts/mp/trials/mp_trl_gunslinger_memory_create_script.gsc" },
    { 0x2A458B918FBEE4BD, "scripts/mp/trials/mp_trl_quarry_raceislava_trial_create_a_script.gsc" },
    { 0x1B7097EC3A830F81, "scripts/mp/trials/trial_arm_course.gsc" },
    { 0x755511650CD06136, "scripts/mp/trials/trial_enemy_sentry_turret.gsc" },
    { 0x52EF15C2A99B4FA5, "scripts/mp/trials/trial_gun_course.gsc" },
    { 0x555A14CE795197B8, "scripts/mp/trials/trial_jugg.gsc" },
    { 0x7F0B6B5CE716473A, "scripts/mp/trials/trial_pitcher.gsc" },
    { 0x2BBBC965F1309702, "scripts/mp/trials/trial_race.gsc" },
    { 0x18B92FCB75257F1C, "scripts/mp/trials/trial_sniper.gsc" },
    { 0x69E30AD84737C849, "scripts/mp/trials/trial_target_utility.gsc" },
    { 0x1806953AC216FC93, "scripts/mp/trials/trial_utility.gsc" },
    { 0x6595ED698585F630, "scripts/mp/turret.gsc" },
    { 0x546166D9A45E52AB, "scripts/mp/tweakables.gsc" },
    { 0x726F9C562FDFEA72, "scripts/mp/utility/damage.gsc" },
    { 0x68765C58AD964CD8, "scripts/mp/utility/debug.gsc" },
    { 0x5102C8E257A6D97F, "scripts/mp/utility/dialog.gsc" },
    { 0x65C8E60DC93B7808, "scripts/mp/utility/disconnect_event_aggregator.gsc" },
    { 0x53682FA3E19AB419, "scripts/mp/utility/dvars.gsc" },
    { 0x6CC9E656B7F35004, "scripts/mp/utility/entity.gsc" },
    { 0x2CE6AE9812D8AF5F, "scripts/mp/utility/equipment.gsc" },
    { 0x22A6A30CD2CAED85, "scripts/mp/utility/game.gsc" },
    { 0x5CCABDBD8A103980, "scripts/mp/utility/game_utility_mp.gsc" },
    { 0x346A8591FB832D05, "scripts/mp/utility/infilexfil.gsc" },
    { 0x5278688E19C483F3, "scripts/mp/utility/inventory.gsc" },
    { 0x5F5A6BED6ACC0B64, "scripts/mp/utility/join_squad_aggregator.gsc" },
    { 0x65D0191B88E1EAB3, "scripts/mp/utility/join_team_aggregator.gsc" },
    { 0x34BFC6AB4B788F91, "scripts/mp/utility/killstreak.gsc" },
    { 0x6D5439C109277E9A, "scripts/mp/utility/lower_message.gsc" },
    { 0x59D70D752E63BE95, "scripts/mp/utility/lui_game_event_aggregator.gsc" },
    { 0x382545849986FBC1, "scripts/mp/utility/outline.gsc" },
    { 0x749DAD28EFF4EEDB, "scripts/mp/utility/perk.gsc" },
    { 0x06849A875AF56E3E, "scripts/mp/utility/player.gsc" },
    { 0x2968631C69B98F88, "scripts/mp/utility/player_frame_update_aggregator.gsc" },
    { 0x655F3CC5D8227E98, "scripts/mp/utility/points.gsc" },
    { 0x443F13D5D348E548, "scripts/mp/utility/print.gsc" },
    { 0x0158CC290FA3E45C, "scripts/mp/utility/script.gsc" },
    { 0x5B1C34DC6525743C, "scripts/mp/utility/sound.gsc" },
    { 0x5A7FFCF1A1689317, "scripts/mp/utility/spawn_event_aggregator.gsc" },
    { 0x76CDBC7F46DC44F4, "scripts/mp/utility/stats.gsc" },
    { 0x0C388E97BB998325, "scripts/mp/utility/teams.gsc" },
    { 0x49F522925767314F, "scripts/mp/utility/trigger.gsc" },
    { 0x317DCAEF347397FD, "scripts/mp/utility/usability.gsc" },
    { 0x23EF6C1E2FC0A20F, "scripts/mp/utility/weapon.gsc" },
    { 0x57753F84D1563669, "scripts/mp/validation.gsc" },
    { 0x2AD5131D424A1D6F, "scripts/mp/vehicles/apc_rus_mp.gsc" },
    { 0x700290C5E608CF6D, "scripts/mp/vehicles/atv_mp.gsc" },
    { 0x5DD46724A68EA9E0, "scripts/mp/vehicles/big_bird_mp.gsc" },
    { 0x226CFA6284FF8DEF, "scripts/mp/vehicles/cargo_truck_mg_mp.gsc" },
    { 0x735ED6DE3271380E, "scripts/mp/vehicles/cargo_truck_mp.gsc" },
    { 0x40BB647A723C2CBB, "scripts/mp/vehicles/cop_car_mp.gsc" },
    { 0x67554F1A4F439EB7, "scripts/mp/vehicles/damage.gsc" },
    { 0x77520AD4056E9E6B, "scripts/mp/vehicles/hoopty_mp.gsc" },
    { 0x00F06430868A2143, "scripts/mp/vehicles/hoopty_truck_mp.gsc" },
    { 0x340B7EAF5002BD58, "scripts/mp/vehicles/jeep_mp.gsc" },
    { 0x5746D1CDFF1769B5, "scripts/mp/vehicles/large_transport_mp.gsc" },
    { 0x515CCBB057ACEED3, "scripts/mp/vehicles/light_tank_mp.gsc" },
    { 0x35C97E2C73946069, "scripts/mp/vehicles/little_bird_mg_mp.gsc" },
    { 0x4DCC21A5E61A448C, "scripts/mp/vehicles/little_bird_mp.gsc" },
    { 0x175B69D8F2B89D12, "scripts/mp/vehicles/med_transport_mp.gsc" },
    { 0x683AE4F9A5D01CA8, "scripts/mp/vehicles/pickup_truck_mp.gsc" },
    { 0x3C247B48F5F99B73, "scripts/mp/vehicles/tac_rover_mp.gsc" },
    { 0x1CE08BF2C58FB9BB, "scripts/mp/vehicles/technical_mp.gsc" },
    { 0x185E0BB2EA68BF11, "scripts/mp/vehicles/van_mp.gsc" },
    { 0x631F011549331C7B, "scripts/mp/vehicles/vehicle_compass_mp.gsc" },
    { 0x47DDC686CD783C08, "scripts/mp/vehicles/vehicle_damage_mp.gsc" },
    { 0x4D5CC7E7083AE661, "scripts/mp/vehicles/vehicle_interact_mp.gsc" },
    { 0x45161D316AB714FB, "scripts/mp/vehicles/vehicle_mines_mp.gsc" },
    { 0x19A564D17590E1BA, "scripts/mp/vehicles/vehicle_mp.gsc" },
    { 0x1222322394E3DDE0, "scripts/mp/vehicles/vehicle_occupancy_mp.gsc" },
    { 0x5D65FF68246F4EBB, "scripts/mp/vehicles/vehicle_oob_mp.gsc" },
    { 0x36B297F0D12A223A, "scripts/mp/vehicles/vehicle_spawn_mp.gsc" },
    { 0x0A1ACDAA4ABD9DAC, "scripts/mp/weaponrank.gsc" },
    { 0x64D6DB6054238125, "scripts/mp/weapons.gsc" },
    { 0x7CCBD586E3BAFF77, "scripts/mp/whizby.gsc" },
    { 0x5E0F9B34A9395449, "scripts/smartobjects/stealth_exposed_fire_up.gsc" },
    { 0x150FC9212F421DE4, "scripts/smartobjects/stealth_knock_off_30.gsc" },
    { 0x24674926856260DA, "scripts/smartobjects/stealth_knock_off_36.gsc" },
    { 0x4D3CEACA4AAD6CDD, "scripts/smartobjects/stealth_lean_table_30.gsc" },
    { 0x22D637BE981416F7, "scripts/smartobjects/stealth_lean_table_36.gsc" },
    { 0x71F7FA98864D18D8, "scripts/smartobjects/stealth_lean_table_l_30.gsc" },
    { 0x68442FBBEE7347B6, "scripts/smartobjects/stealth_lean_table_l_36.gsc" },
    { 0x51B544802610585A, "scripts/smartobjects/stealth_lean_table_r_30.gsc" },
    { 0x425DC47ACFF01564, "scripts/smartobjects/stealth_lean_table_r_36.gsc" },
    { 0x4E41300518E961AC, "scripts/smartobjects/stealth_lean_wall_l.gsc" },
    { 0x5D0EE174FC0B8A2A, "scripts/smartobjects/stealth_lean_wall_r.gsc" },
    { 0x659CA7FD38DEAF8F, "scripts/smartobjects/stealth_look_around.gsc" },
    { 0x5878CA794EDCBED6, "scripts/smartobjects/stealth_look_down.gsc" },
    { 0x4ED712F46A19B58E, "scripts/smartobjects/stealth_look_high.gsc" },
    { 0x53104E0B5F742530, "scripts/smartobjects/stealth_look_over.gsc" },
    { 0x1B332AFF743D3690, "scripts/smartobjects/stealth_look_under_10.gsc" },
    { 0x5DA43BCDA90B41E2, "scripts/smartobjects/stealth_look_under_30.gsc" },
    { 0x4F20BE7ABA0F15CF, "scripts/smartobjects/stealth_look_up.gsc" },
    { 0x6ADFF4313BF0028A, "scripts/smartobjects/stealth_rage_bash.gsc" },
    { 0x7020B6FE2D960C61, "scripts/smartobjects/stealth_rage_bash_l.gsc" },
    { 0x25A42FC67218C38B, "scripts/smartobjects/stealth_rage_bash_r.gsc" },
    { 0x715A1A96449870AA, "scripts/smartobjects/stealth_rage_kick.gsc" },
    { 0x25D9F453DA2E67C1, "scripts/smartobjects/stealth_rage_kick_l.gsc" },
    { 0x58B37147398F676B, "scripts/smartobjects/stealth_rage_kick_r.gsc" },
    { 0x27E688562D2DD6EE, "scripts/smartobjects/stealth_rage_punch.gsc" },
    { 0x321A4C86508CC1C2, "scripts/smartobjects/utility.gsc" },
    { 0x378FC85E571E7186, "scripts/sp/analytics.gsc" },
    { 0x58937D0256A1E2AD, "scripts/sp/anim.gsc" },
    { 0x302B310CF5F281F9, "scripts/sp/anim_notetrack.gsc" },
    { 0x4E6F0300DC3EF45F, "scripts/sp/art.gsc" },
    { 0x4207755BFDB48B74, "scripts/sp/audio.gsc" },
    { 0x1DA1788C3403A19E, "scripts/sp/autosave.gsc" },
    { 0x4A81C087EFED4B9C, "scripts/sp/colors.gsc" },
    { 0x3039452DFDE7FBBA, "scripts/sp/compass.gsc" },
    { 0x5893ADB02CDAE4F6, "scripts/sp/createfx.gsc" },
    { 0x5CB72CC7E5761F50, "scripts/sp/credits.gsc" },
    { 0x53013CFCD4DE3AB2, "scripts/sp/damagefeedback.gsc" },
    { 0x40B3883467EEF7A5, "scripts/sp/debug.gsc" },
    { 0x7F2603B0C235A0CF, "scripts/sp/debug_menu.gsc" },
    { 0x7F3BDDB3EA2462AB, "scripts/sp/debug_spawnai.gsc" },
    { 0x3E507F6E5BDBCD0E, "scripts/sp/destructibles/barrel_common.gsc" },
    { 0x26A4001904D98E21, "scripts/sp/destructibles/destructible_vehicle.gsc" },
    { 0x188209D7A6D9661D, "scripts/sp/destructibles/oil_barrel.gsc" },
    { 0x46E2E6E6321E4530, "scripts/sp/destructibles/red_barrel.gsc" },
    { 0x317FD45510A25464, "scripts/sp/destructibles/water_barrel.gsc" },
    { 0x17F2C690F3A59C64, "scripts/sp/door.gsc" },
    { 0x63DE70BAA2A6268D, "scripts/sp/door_ai.gsc" },
    { 0x5329AD582F86465A, "scripts/sp/door_internal.gsc" },
    { 0x5B32CC4BCFF6BF34, "scripts/sp/door_scriptable.gsc" },
    { 0x4B4058A03BDDE3FC, "scripts/sp/drone.gsc" },
    { 0x6DCA794AEA1C9BF5, "scripts/sp/drone_ai.gsc" },
    { 0x084AF360809289A2, "scripts/sp/drone_base.gsc" },
    { 0x279E1925F3241F5E, "scripts/sp/drone_civilian.gsc" },
    { 0x7372F05154F7CF79, "scripts/sp/endmission.gsc" },
    { 0x1E4C74716BDBF1AA, "scripts/sp/equipment/c4.gsc" },
    { 0x60C7BC918A3C2D17, "scripts/sp/equipment/flash.gsc" },
    { 0x581014825671F061, "scripts/sp/equipment/frag.gsc" },
    { 0x046CA9E7416BA3B6, "scripts/sp/equipment/green_beam.gsc" },
    { 0x6549CFD94ABD4097, "scripts/sp/equipment/ied.gsc" },
    { 0x7B7988D739347D8F, "scripts/sp/equipment/incendiarylauncher.gsc" },
    { 0x1E74C44DA9B867E7, "scripts/sp/equipment/molotov.gsc" },
    { 0x760766D73663E89B, "scripts/sp/equipment/noisemaker.gsc" },
    { 0x629495DD20A7676C, "scripts/sp/equipment/offhands.gsc" },
    { 0x3506CF049DCDF381, "scripts/sp/equipment/pipebomb.gsc" },
    { 0x7920811A39B75195, "scripts/sp/equipment/semtex.gsc" },
    { 0x036FD89CA842AEF9, "scripts/sp/equipment/signal.gsc" },
    { 0x783B35AF6737F35C, "scripts/sp/equipment/smoke.gsc" },
    { 0x5170F99B18418184, "scripts/sp/equipment/teargas.gsc" },
    { 0x5B1A0AE8FBC8C294, "scripts/sp/equipment/throwingknife.gsc" },
    { 0x3D29B911D6B3719B, "scripts/sp/equipment/tripwire.gsc" },
    { 0x293F278F9CF34658, "scripts/sp/fakeactor.gsc" },
    { 0x4A91B05009A9DBC7, "scripts/sp/fakeactor_node.gsc" },
    { 0x159A6C716E66F4B9, "scripts/sp/flags.gsc" },
    { 0x0497F620360B162D, "scripts/sp/footsteps.gsc" },
    { 0x68D2819FB2878D27, "scripts/sp/friendlyfire.gsc" },
    { 0x2A5B848A0353F970, "scripts/sp/gamer_profile.gsc" },
    { 0x7F5F30902DFFCF79, "scripts/sp/gameskill.gsc" },
    { 0x05B1415C1B5D0F61, "scripts/sp/geo_mover.gsc" },
    { 0x1ED0C34577F0DA0E, "scripts/sp/gibbing.gsc" },
    { 0x2D4CE59734F5DAE6, "scripts/sp/glass.gsc" },
    { 0x13C0801E30856000, "scripts/sp/global_fx.gsc" },
    { 0x09487322CAC9297E, "scripts/sp/global_fx_code.gsc" },
    { 0x07C250FED32DCA82, "scripts/sp/helicopter_ai.gsc" },
    { 0x3643E7DC7F2606AA, "scripts/sp/helicopter_globals.gsc" },
    { 0x7F3FFC10F2BFB1FB, "scripts/sp/hud.gsc" },
    { 0x73A1E31545226A6A, "scripts/sp/hud_util.gsc" },
    { 0x737B1C2C8C9472DD, "scripts/sp/idles.gsc" },
    { 0x0D7ECC9DA600EC47, "scripts/sp/intelligence.gsc" },
    { 0x08E4D21CA0DE77C2, "scripts/sp/interactables/dynolight.gsc" },
    { 0x773AB997A5729886, "scripts/sp/interaction.gsc" },
    { 0x1A108372A314490E, "scripts/sp/interaction_manager.gsc" },
    { 0x72DCB1863F7ED720, "scripts/sp/introscreen.gsc" },
    { 0x31BE5B920616DCB1, "scripts/sp/lights.gsc" },
    { 0x0524E8E6BEEE6F64, "scripts/sp/load.gsc" },
    { 0x2B649E446E1D813A, "scripts/sp/load_code.gsc" },
    { 0x501C1DB481E23452, "scripts/sp/loot.gsc" },
    { 0x5F7F27440541EF2A, "scripts/sp/mg_penetration.gsc" },
    { 0x72BB98237AE73D8A, "scripts/sp/mgturret.gsc" },
    { 0x09A98F653FFF265A, "scripts/sp/names.gsc" },
    { 0x172D002C28F413E6, "scripts/sp/nvg/nvg_ai.gsc" },
    { 0x587C769EC1C5F759, "scripts/sp/nvg/nvg_player.gsc" },
    { 0x0DD7835B9CBE1CA8, "scripts/sp/outline.gsc" },
    { 0x4A778814F1B1E996, "scripts/sp/patrol.gsc" },
    { 0x700CDF1663CF9DA7, "scripts/sp/pausemenu.gsc" },
    { 0x01DD8C2481AC6E8A, "scripts/sp/pip_util.gsc" },
    { 0x6A4190022C745CFD, "scripts/sp/player.gsc" },
    { 0x3A83E235D70BD495, "scripts/sp/player/ally_equipment.gsc" },
    { 0x167428C4C368615C, "scripts/sp/player/ballistics.gsc" },
    { 0x4F44B6686CAC35FC, "scripts/sp/player/bullet_feedback.gsc" },
    { 0x5354D3AB606FAD12, "scripts/sp/player/context_melee.gsc" },
    { 0x52AD10B20F9C9A8C, "scripts/sp/player/cursor_hint.gsc" },
    { 0x1A06A2EE09C533BA, "scripts/sp/player/flare.gsc" },
    { 0x446F9DA3A686E968, "scripts/sp/player/gestures.gsc" },
    { 0x3739A09FCC88DEAC, "scripts/sp/player/offhand_box.gsc" },
    { 0x379C2358A1B97624, "scripts/sp/player/playerchatter.gsc" },
    { 0x7DD293F8DDCDE64D, "scripts/sp/player/teenagefarah.gsc" },
    { 0x10587A0683D82922, "scripts/sp/player/youngfarrah.gsc" },
    { 0x4540A3F6BEB7E5D0, "scripts/sp/player_death.gsc" },
    { 0x19E020D7B19C133C, "scripts/sp/player_rig.gsc" },
    { 0x19AA72688C1A1921, "scripts/sp/player_stats.gsc" },
    { 0x22627F7B6B1A1FEC, "scripts/sp/script_items.gsc" },
    { 0x0918A19212085653, "scripts/sp/scriptable.gsc" },
    { 0x4C2ADCF8B7083295, "scripts/sp/scripted_weapon_assignment.gsc" },
    { 0x5C82DC488283308D, "scripts/sp/scriptedsniper.gsc" },
    { 0x0A945DBD6C5969C6, "scripts/sp/slowmo_init.gsc" },
    { 0x031396CE3A2ABBBA, "scripts/sp/spawner.gsc" },
    { 0x430A633BAE3FC6A9, "scripts/sp/stairtrain.gsc" },
    { 0x456556E2BFEC9461, "scripts/sp/starts.gsc" },
    { 0x74398FB8AB8E9EDA, "scripts/sp/statemachine.gsc" },
    { 0x21E827F136E28A04, "scripts/sp/stayahead.gsc" },
    { 0x4B47D1A240B4C54D, "scripts/sp/stealth/idle_sitting.gsc" },
    { 0x04FD7AE7467577B5, "scripts/sp/stealth/manager.gsc" },
    { 0x4ECE1947BC018ED1, "scripts/sp/stealth/player.gsc" },
    { 0x42FBC16A2A3CDB0D, "scripts/sp/stealth/tagging.gsc" },
    { 0x03E816B921D0B226, "scripts/sp/stealth/utility.gsc" },
    { 0x59525EDBC77F3C84, "scripts/sp/stinger.gsc" },
    { 0x5E58E8E8D674E067, "scripts/sp/traffic_system.gsc" },
    { 0x1974079C607A332C, "scripts/sp/treadfx.gsc" },
    { 0x73438D963E182E4E, "scripts/sp/trigger.gsc" },
    { 0x24DB68BD2DAEE08A, "scripts/sp/utility.gsc" },
    { 0x4748BF91627A1C3A, "scripts/sp/vehicle.gsc" },
    { 0x635B93BA2B90F882, "scripts/sp/vehicle_aianim.gsc" },
    { 0x1F4F2DB8287A420D, "scripts/sp/vehicle_build.gsc" },
    { 0x351975F16D321880, "scripts/sp/vehicle_code.gsc" },
    { 0x6D8AAD7D0495CD99, "scripts/sp/vehicle_heavy_destruction.gsc" },
    { 0x52DA195F1171EFEB, "scripts/sp/vehicle_interact.gsc" },
    { 0x2D0432F65B1FD9B0, "scripts/sp/vehicle_lights.gsc" },
    { 0x653022EEAAC72479, "scripts/sp/vehicle_paths.gsc" },
    { 0x07EE8BAD86C952E4, "scripts/sp/vehicle_treads.gsc" },
    { 0x4B1E5F62D78F9304, "scripts/sp/vision.gsc" },
    { 0x0645528CB1B1EF14, "scripts/stealth/callbacks.gsc" },
    { 0x21FB20A3C1CA8CCF, "scripts/stealth/clear_regions.gsc" },
    { 0x146A17616F44667A, "scripts/stealth/corpse.gsc" },
    { 0x191339F5C1A6195B, "scripts/stealth/debug.gsc" },
    { 0x1CA4F62D92DD5210, "scripts/stealth/enemy.gsc" },
    { 0x20B2DF6CB9AFF8F0, "scripts/stealth/event.gsc" },
    { 0x3175B03723124101, "scripts/stealth/friendly.gsc" },
    { 0x331896EDB4223103, "scripts/stealth/group.gsc" },
    { 0x0CEA8F165A816A0C, "scripts/stealth/init.gsc" },
    { 0x70530A265A9F5903, "scripts/stealth/manager.gsc" },
    { 0x2D4E31A32FB4EADB, "scripts/stealth/neutral.gsc" },
    { 0x211D04EFBA6BDD8B, "scripts/stealth/player.gsc" },
    { 0x163386F8246EA03C, "scripts/stealth/threat_sight.gsc" },
    { 0x7EB69E8C5218D5D0, "scripts/stealth/utility.gsc" },
    { 0x09D0561FF8DED2FB, "scripts/unittest/call.gsc" },
    { 0x33374ABA53CCEFA3, "scripts/unittest/cond.gsc" },
    { 0x60C3BF3F97AAD8A1, "scripts/unittest/error.gsc" },
    { 0x7D417D07A4E5621D, "scripts/unittest/loop.gsc" },
    { 0x7A3248CECDABBB87, "scripts/unittest/ops.gsc" },
    { 0x4484932699BA0155, "scripts/unittest/patch.gsc" },
    { 0x46E026730332CC63, "scripts/unittest/patch_far.gsc" },
    { 0x3FB3888869A3BBAC, "scripts/unittest/patch_new.gsc" },
    { 0x1C177F8B59EA24BF, "scripts/unittest/switch.gsc" },
    { 0x2ACE7209907A93EA, "scripts/unittest/threads.gsc" },
    { 0x508F2C4AFE4464DD, "scripts/unittest/unittest.gsc" },
    { 0x78A054D0158094FB, "scripts/unittest/util.gsc" },
    { 0x6E8449CF88F1EADA, "scripts/unittest/variables.gsc" },
    { 0x2001A12EABCEA3F5, "scripts/vehicle/apache.gsc" },
    { 0x39C5ABE7337EC7C2, "scripts/vehicle/asierra.gsc" },
    { 0x6043CCF093C23E56, "scripts/vehicle/attack_heli.gsc" },
    { 0x199A1F4363AFB888, "scripts/vehicle/blima.gsc" },
    { 0x481D6433B953BE14, "scripts/vehicle/blima_ground.gsc" },
    { 0x42ADD57A1535B9C3, "scripts/vehicle/bromeo.gsc" },
    { 0x1AA8D9019B401C0E, "scripts/vehicle/decho.gsc" },
    { 0x1FA661E0EC7A2E34, "scripts/vehicle/drone_improvised.gsc" },
    { 0x203A417B3F26B482, "scripts/vehicle/empty.gsc" },
    { 0x15A70AD2B561D11D, "scripts/vehicle/empty_heli.gsc" },
    { 0x304FB8A7A53594F4, "scripts/vehicle/empty_nocollision.gsc" },
    { 0x4ECFC469719C5667, "scripts/vehicle/empty_turret.gsc" },
    { 0x639687EEE6B8EDBF, "scripts/vehicle/lbravo.gsc" },
    { 0x5B6F151AAEED75B4, "scripts/vehicle/london_cab.gsc" },
    { 0x4E826AB3BA315311, "scripts/vehicle/mindia8.gsc" },
    { 0x711704083FA820D7, "scripts/vehicle/mindia8_jugg.gsc" },
    { 0x497045F94EA799B2, "scripts/vehicle/mkilo23.gsc" },
    { 0x623A55B1697311EA, "scripts/vehicle/mkilo23_ai_infil.gsc" },
    { 0x707BAFC0054976B7, "scripts/vehicle/palfa.gsc" },
    { 0x05F006A1931E24DC, "scripts/vehicle/pindia.gsc" },
    { 0x0E4A4BCD834BD23D, "scripts/vehicle/ralfa.gsc" },
    { 0x08BC8E8C7995D6CF, "scripts/vehicle/secho.gsc" },
    { 0x7D931927C317D34B, "scripts/vehicle/skilo.gsc" },
    { 0x242DE32B27BC25C1, "scripts/vehicle/stango.gsc" },
    { 0x583BF3991C6D6325, "scripts/vehicle/suniform25.gsc" },
    { 0x5E6D5DE83F5DAE1E, "scripts/vehicle/techo.gsc" },
    { 0x39329602384C75ED, "scripts/vehicle/tromeo.gsc" },
    { 0x073D801F600ADD92, "scripts/vehicle/umike.gsc" },
    { 0x1E0A39FECFB8CD77, "scripts/vehicle/vehicle_common.gsc" },
    { 0x6A9EA1E319F74B9C, "scripts/vehicle/victor40.gsc" },
    { 0x7B40C4E7C4800A3A, "scripts/vehicle/vindia.gsc" },
    { 0x4D6149376990F3A2, "scripts/vehicle/walfa.gsc" },
    { 0x09D2D9B2FB9B5D8D, "scripts/vehicle/zuniform.gsc" },
    { 0x1968DF0F374CD0BC, "xmodelalias/alias_hero_stpetersburg_nikilai_body.gsc" },
    { 0x63CFE7F1AAFAD8CA, "xmodelalias/bodies_al_qatala_desert_01.gsc" },
    { 0x09DDA7E56E370B77, "xmodelalias/bodies_al_qatala_desert_02.gsc" },
    { 0x74F32EEFEA1A3620, "xmodelalias/bodies_al_qatala_desert_03.gsc" },
    { 0x7D24E7ED8D69F254, "xmodelalias/bodies_al_qatala_desert_07.gsc" },
    { 0x20557FB431C0D152, "xmodelalias/bodies_al_qatala_desert_09.gsc" },
    { 0x4792B9C474781B03, "xmodelalias/bodies_al_qatala_urban_a6_variant.gsc" },
    { 0x7C2D12F859DD5799, "xmodelalias/bodies_al_qatala_urban_ar.gsc" },
    { 0x2A6CEE3395C1645F, "xmodelalias/bodies_al_qatala_urban_ar_variant.gsc" },
    { 0x500291E60F31CCD5, "xmodelalias/bodies_al_qatala_urban_bomber.gsc" },
    { 0x351EAF226C7BE860, "xmodelalias/bodies_al_qatala_urban_cqb_variant.gsc" },
    { 0x6B7FA02503D72E1A, "xmodelalias/bodies_al_qatala_urban_lmg_variant.gsc" },
    { 0x750BAC0C2857D581, "xmodelalias/bodies_civ_al_qatala_urban_female.gsc" },
    { 0x3638CC05A9A86A8C, "xmodelalias/bodies_civ_russian_police_officer.gsc" },
    { 0x46F20AF39225ADD9, "xmodelalias/bodies_civ_western_cold_boy.gsc" },
    { 0x27C72E88CD6F7171, "xmodelalias/bodies_civ_western_cold_girl.gsc" },
    { 0x7AA00C4824C2C01E, "xmodelalias/bodies_sas_urban_ar.gsc" },
    { 0x0EBC709082B1546C, "xmodelalias/bodies_sas_urban_cqc.gsc" },
    { 0x32C415EC9D5EDD7E, "xmodelalias/bodies_sas_urban_dmr.gsc" },
    { 0x7E19D609E22641A4, "xmodelalias/bodies_sas_woodland_ar.gsc" },
    { 0x6CF15480414136F6, "xmodelalias/bodies_spetsnaz_ar.gsc" },
    { 0x2D88ACD05A29DB4E, "xmodelalias/civ_russian_male_body_1.gsc" },
    { 0x7406BAE08EB204D0, "xmodelalias/civ_russian_male_head_1.gsc" },
    { 0x15EF279651DCFDCF, "xmodelalias/civilian_london_female_body_02_skintone_dark.gsc" },
    { 0x60394823A2363E1F, "xmodelalias/civilian_london_female_body_02_skintone_light.gsc" },
    { 0x3C8C0E8AD64EEBB5, "xmodelalias/civilian_london_female_body_02_skintone_med.gsc" },
    { 0x18C1E36AE92D394F, "xmodelalias/civilian_london_female_body_skintone_01.gsc" },
    { 0x223DAC67D524C31B, "xmodelalias/civilian_london_female_body_skintone_01_anim_safe.gsc" },
    { 0x2FBE796151B2A1B4, "xmodelalias/civilian_london_female_body_skintone_med.gsc" },
    { 0x0F679FD605A69D24, "xmodelalias/civilian_london_female_body_skintone_med_anim_safe.gsc" },
    { 0x115281D4522A1404, "xmodelalias/civilian_london_female_head_skintone_light.gsc" },
    { 0x31C04A026E139B02, "xmodelalias/civilian_london_female_head_skintone_med.gsc" },
    { 0x1673C08D3BE4AE9F, "xmodelalias/civilian_london_female_heads_skintone_dark.gsc" },
    { 0x1E066541EEB7D69D, "xmodelalias/civilian_london_female_heads_skintone_dark_nohair.gsc" },
    { 0x5B8E6FDFE0E1B94F, "xmodelalias/civilian_london_female_heads_skintone_light.gsc" },
    { 0x01ABEE48E066BEAD, "xmodelalias/civilian_london_female_heads_skintone_light_nohair.gsc" },
    { 0x5F3139A12D66CEC5, "xmodelalias/civilian_london_female_heads_skintone_med.gsc" },
    { 0x3FAE036CBDCF1B37, "xmodelalias/civilian_london_female_heads_skintone_med_nohair.gsc" },
    { 0x52C13E4168F72DB3, "xmodelalias/civilian_london_male_body_skintone_light.gsc" },
    { 0x016E06A0BBAAA959, "xmodelalias/civilian_london_male_body_skintone_med.gsc" },
    { 0x34726B0BFF780D69, "xmodelalias/civilian_me_female_bodies.gsc" },
    { 0x04B40D1EA1126B1C, "xmodelalias/civilian_me_female_embassy_bodies.gsc" },
    { 0x2B41AE39A79A7022, "xmodelalias/civilian_me_female_heads.gsc" },
    { 0x67F0EF4494C59910, "xmodelalias/civilian_me_female_veil_bodies.gsc" },
    { 0x123898B3EB05C744, "xmodelalias/civilian_me_female_wrap_bodies.gsc" },
    { 0x21A9A4608C8EC98D, "xmodelalias/civilian_me_female_wrap_heads.gsc" },
    { 0x2B46F5F29E39E461, "xmodelalias/civilian_me_male_veil_bodies.gsc" },
    { 0x5E41D667569898DA, "xmodelalias/civilian_me_male_veil_heads.gsc" },
    { 0x3FCB0B609850C8AA, "xmodelalias/civilian_russian_female_body.gsc" },
    { 0x269E9459BF0FB3C8, "xmodelalias/civilian_russian_female_head.gsc" },
    { 0x431A591A41AF76DB, "xmodelalias/civilian_syrkistan_female_head.gsc" },
    { 0x0CB6FAE1D89AB8AC, "xmodelalias/civilian_syrkistan_female_head_no_hair.gsc" },
    { 0x756CBE2A2DEFE576, "xmodelalias/civilian_syrkistan_male_body.gsc" },
    { 0x3A97C88651C9ADB9, "xmodelalias/civilian_syrkistan_male_body_dist.gsc" },
    { 0x655BAFD7450B7EBD, "xmodelalias/civilian_syrkistan_male_body_embassy.gsc" },
    { 0x5C1F2FF15EF59F24, "xmodelalias/civilian_syrkistan_male_head.gsc" },
    { 0x291A99C3C1D2520E, "xmodelalias/civilian_uk_male_heads_skintone_light.gsc" },
    { 0x53BE65E259C850F8, "xmodelalias/civilian_uk_male_heads_skintone_med.gsc" },
    { 0x1A770865F3E0213E, "xmodelalias/hats_civ_russian_police_officer.gsc" },
    { 0x29FC815BDE49F867, "xmodelalias/heads_al_qatala_desert.gsc" },
    { 0x2420665E75332A77, "xmodelalias/heads_al_qatala_desert_03.gsc" },
    { 0x3A983E2D38BCF052, "xmodelalias/heads_al_qatala_desert_08.gsc" },
    { 0x0AB8D3A2D44320F1, "xmodelalias/heads_al_qatala_desert_bomber.gsc" },
    { 0x0EA4FAD5C0FB4A2C, "xmodelalias/heads_al_qatala_tmtyl.gsc" },
    { 0x1B561F178FEF18E3, "xmodelalias/heads_al_qatala_urban_04.gsc" },
    { 0x7B333728D55146FC, "xmodelalias/heads_al_qatala_urban_05.gsc" },
    { 0x5F8AA70D4F49E165, "xmodelalias/heads_al_qatala_urban_06.gsc" },
    { 0x30B2046800230E0E, "xmodelalias/heads_al_qatala_urban_ar_variant.gsc" },
    { 0x42ED7DFB5FA7E710, "xmodelalias/heads_civ_al_qatala_urban_female.gsc" },
    { 0x7F3538979A978A6D, "xmodelalias/heads_civ_russian_police_officer.gsc" },
    { 0x5CD359CBCE951B70, "xmodelalias/heads_civ_western_cold_boy.gsc" },
    { 0x76B841822EB4767E, "xmodelalias/heads_civ_western_cold_girl.gsc" },
    { 0x6AA2552F6B9D4DBE, "xmodelalias/heads_london_police.gsc" },
    { 0x348FD0E2DD0D7729, "xmodelalias/heads_sas_urban.gsc" },
    { 0x248084AD2A220B0F, "xmodelalias/heads_sas_urban_nvg.gsc" },
    { 0x0997082582A6C9BF, "xmodelalias/heads_sas_woodland_nvg.gsc" },
    { 0x2635EC9C3FB164AF, "xmodelalias/heads_usmc_male.gsc" },
    { 0x7BEA7A236E989767, "xmodelalias/russian_army_ar_1_hats_gasmask.gsc" },
    { 0x2E3CDC890B1F4BA8, "xmodelalias/russian_army_ar_2_hats_gasmask.gsc" },
    { 0x47FB9EDA20E0AF12, "xmodelalias/russian_army_ar_4_hats_gasmask.gsc" },
    { 0x453DF43B64B4A9F3, "xmodelalias/russian_army_ar_5_hats_gasmask.gsc" },
    { 0x5951E4088AA9334B, "xmodelalias/russian_army_bodies_1.gsc" },
    { 0x4A830263D4CAED70, "xmodelalias/russian_army_bodies_1_light.gsc" },
    { 0x24FAF734CBA3EACE, "xmodelalias/russian_army_bodies_2.gsc" },
    { 0x0424D7DEDA010305, "xmodelalias/russian_army_bodies_2_light.gsc" },
    { 0x50AE8A53F7025665, "xmodelalias/russian_army_hats.gsc" },
    { 0x4B829CC774F72F19, "xmodelalias/russian_army_hats_safehouse.gsc" },
    { 0x08DD7BF5DE21FB78, "xmodelalias/russian_army_heads.gsc" },
    { 0x1F37ACCFC04F4186, "xmodelalias/russian_army_heads_gasmask.gsc" },
    { 0x5F5F33C65239A5E8, "xmodelalias/russian_army_heads_safehouse.gsc" },
    { 0x63487AB57AA2A5CB, "xmodelalias/test_alias_civ_london_male_1_body.gsc" },
    { 0x60B785787652FD92, "xmodelalias/test_enemy_picc_heads.gsc" },
 }};

} // namespace xsk::gsc::iw9
