// Copyright 2024 xensik. All rights reserved.
//
// Use of this source code is governed by a GNU GPLv3 license
// that can be found in the LICENSE file.

#include "xsk/arc/engine/t6.hpp"

namespace xsk::arc::t6
{

extern std::array<std::pair<u32, char const*>, hash_count> const hash_list
{{
    { 0x146F2C73, "ClickToContinue" },
    { 0x209FFF3B, "FriendXuidToJoinOnBoot" },
    { 0x586EB87C, "TestIntervalJitter" },
    { 0xFAD9A35D, "WADTimestampUpdateInterval" },
    { 0x58C836DC, "YouTube_ErrorRecordEvent" },
    { 0x66E9F57E, "YouTube_apiUrl" },
    { 0x3798B20F, "YouTube_category" },
    { 0x096AD5EC, "YouTube_highRefreshRate" },
    { 0x8349682B, "YouTube_listing" },
    { 0xCC83BACC, "YouTube_liveLifeCycleRefreshRate" },
    { 0xC353EAA0, "YouTube_liveStreamLeague" },
    { 0xBF5D22FE, "YouTube_lowRefreshRate" },
    { 0x2496CD92, "YouTube_maxViewersForHighRefresh" },
    { 0xEB88D950, "YouTube_minViewersForHighRefresh" },
    { 0x1F01CF57, "YouTube_minViewersToStartStream" },
    { 0xD82B2509, "YouTube_minViewersToStream" },
    { 0xFD8399D8, "YouTube_miscRefreshRate" },
    { 0x53165CA0, "YouTube_slateImageUrl" },
    { 0x05935EAF, "YouTube_slateText" },
    { 0xB0BC3DB8, "YouTube_stateChange" },
    { 0xF0A26483, "YouTube_stopStreamForPublicGame" },
    { 0x7D078A30, "YouTube_timeToRecoverFromLowStreamViewers" },
    { 0xF0464319, "YouTube_verifyUrl" },
    { 0x72C9C8B2, "actionSlotsHide" },
    { 0x02266E96, "activeFriendsMaxBackoffLevel" },
    { 0xF884F64B, "activeFriendsNumDayBuckets" },
    { 0x370CA343, "activeFriendsNumPlayBuckets" },
    { 0xCECE492A, "activeFriendsRefreshDelay" },
    { 0x78A5AE00, "activeFriendsSecondsPerBucket" },
    { 0x1412EE9C, "adsZeroSpread" },
    { 0x94FB1C9F, "ai_ShowCanshootChecks" },
    { 0x3027A78D, "ai_angularYawAccelRate" },
    { 0x54D41565, "ai_angularYawDecelFactor" },
    { 0x3EA7D554, "ai_angularYawEnabled" },
    { 0x4EED8183, "ai_corpseCount" },
    { 0x1DF154F7, "ai_debugAnimDeltas" },
    { 0xFFC390BD, "ai_debugClaimedNodes" },
    { 0xEB5DBD81, "ai_debugCoverEntityNum" },
    { 0xC8569254, "ai_debugEntIndex" },
    { 0x255CD703, "ai_debugFindPath" },
    { 0xBB40F71E, "ai_debugFindPathDirect" },
    { 0xA663BECC, "ai_debugFindPathLock" },
    { 0x739F6163, "ai_debugFindPathWidth" },
    { 0x7E794ED3, "ai_debugMayMove" },
    { 0xE9FDD26E, "ai_debugMeleeAttackSpots" },
    { 0xE5058323, "ai_debugThreatSelection" },
    { 0xDD8D070B, "ai_disableSpawn" },
    { 0x4566DB30, "ai_eventDistBadPlace" },
    { 0x2539E74C, "ai_eventDistBullet" },
    { 0xD61A7FAD, "ai_eventDistBulletRunning" },
    { 0x2FC7A90A, "ai_eventDistDeath" },
    { 0x1C482E85, "ai_eventDistExplosion" },
    { 0x4612C9F8, "ai_eventDistFootstep" },
    { 0x46140CE6, "ai_eventDistFootstepLite" },
    { 0xBFBE25E8, "ai_eventDistGrenadePing" },
    { 0x4D8214CC, "ai_eventDistGunShot" },
    { 0xB7F1EA4C, "ai_eventDistNewEnemy" },
    { 0x474AA0EC, "ai_eventDistPain" },
    { 0x82395A7D, "ai_eventDistProjImpact" },
    { 0x66DD092D, "ai_eventDistProjPing" },
    { 0x30C4FDF3, "ai_eventDistReact" },
    { 0x081CB369, "ai_eventDistSilencedShot" },
    { 0x40FEB037, "ai_foliageSeeThroughDist" },
    { 0x8975D816, "ai_friendlySuppression" },
    { 0x826896EA, "ai_friendlySuppressionDist" },
    { 0xA5E2522C, "ai_maxAttackerCount" },
    { 0x423A0415, "ai_meleeDamage" },
    { 0x4BD4F0CF, "ai_meleeHeight" },
    { 0xBD2DA9C3, "ai_meleeRange" },
    { 0xBD8C5E76, "ai_meleeWidth" },
    { 0x76283E5B, "ai_moveOrientMode" },
    { 0x4EEA15EE, "ai_noDodge" },
    { 0xD861EEC8, "ai_pathChokePointCost" },
    { 0x50EF676D, "ai_pathMomentum" },
    { 0x38109CEE, "ai_pathNegotiationOverlapCost" },
    { 0x5432652D, "ai_pathRandomPercent" },
    { 0x0A0070DF, "ai_playerFarAccuracy" },
    { 0x89250B01, "ai_playerFarRange" },
    { 0x5C6B36AC, "ai_playerNearAccuracy" },
    { 0xE73FDBEE, "ai_playerNearRange" },
    { 0xCD2B294E, "ai_showBadPlaces" },
    { 0xE3D6FA12, "ai_showDodge" },
    { 0x5C855B14, "ai_showFailedPaths" },
    { 0xA0898D67, "ai_showNearestNode" },
    { 0xA4402525, "ai_showNodeDrawType" },
    { 0xE48BEEE8, "ai_showNodes" },
    { 0x1571C6BC, "ai_showNodesDist" },
    { 0xD637FF76, "ai_showPathFindNodes" },
    { 0xE4A8B70F, "ai_showPaths" },
    { 0xD22E4E66, "ai_showPotentialThreatDir" },
    { 0x9224E11B, "ai_showVisData" },
    { 0xEDCE9A6F, "ai_showVisDataDist" },
    { 0x88B7B7A7, "ai_showVolume" },
    { 0x11931F7B, "ai_slowdownMaxYawDiff" },
    { 0x221321FB, "ai_slowdownMinRate" },
    { 0x7AE456B9, "ai_slowdownMinYawDiff" },
    { 0x6BFBDEDB, "ai_slowdownRateBlendFactor" },
    { 0x666C859E, "ai_threatUpdateInterval" },
    { 0xF7D93FD4, "ai_trim_path_zigzags" },
    { 0xA432F3E3, "ai_turnRate" },
    { 0x73027829, "ai_useBetterLookahead" },
    { 0xB42168D2, "ai_useFacingTranslation" },
    { 0x24833BA3, "ai_useLeanRunAnimations" },
    { 0x81DDB107, "airburstAdjustDistance" },
    { 0x395EFFA8, "allClientDvarsEnabled" },
    { 0x2C56E9E2, "allEmblemsPurchased" },
    { 0x1989CDF8, "allEmblemsUnlocked" },
    { 0x78730CDF, "allItemsPurchased" },
    { 0xB6FF0555, "allItemsUnlocked" },
    { 0xB4A24A06, "all_players_are_connected" },
    { 0x6F80BC60, "allowAllNAT" },
    { 0x27B9838C, "allowHost_matchesHostedRatio" },
    { 0x2295C417, "allowHost_matchesHostedStreak" },
    { 0xB308B084, "allowHost_matchesPlayedRatio" },
    { 0x17CA900F, "allowHost_matchesPlayedStreak" },
    { 0xA0694A69, "ammoCounterHide" },
    { 0x8FE7B89C, "band_12players" },
    { 0x1972B5E2, "band_18players" },
    { 0x4D1A884B, "band_2players" },
    { 0x259E320D, "band_4players" },
    { 0xFE21DBCF, "band_6players" },
    { 0xD6A58591, "band_8players" },
    { 0x332C97B0, "band_dedicated" },
    { 0xDBF20043, "band_demosystem" },
    { 0x5CABA193, "bandwidth_retry_interval" },
    { 0x5FA8E90F, "barebones_class_mode" },
    { 0x892CBC63, "bcmp_ally_kill_probability" },
    { 0x53964768, "bcmp_breathing_delay" },
    { 0x4BFE2A7A, "bcmp_breathing_probability" },
    { 0xBD9F1B3D, "bcmp_enemy_contact_delay" },
    { 0x59E10794, "bcmp_enemy_contact_level_delay" },
    { 0x5FF173AF, "bcmp_incoming_grenade_probability" },
    { 0xC151033C, "bcmp_kill_inform_probability" },
    { 0xB7B1EDCF, "bcmp_killstreak_incoming_probability" },
    { 0x6E5D54C1, "bcmp_last_stand_delay" },
    { 0x7EDC44DC, "bcmp_pain_delay" },
    { 0xF328DB66, "bcmp_pain_small_probability" },
    { 0x57E10FF3, "bcmp_perk_call_probability" },
    { 0x1D6F5AA2, "bcmp_sniper_kill_probability" },
    { 0x1E154CA4, "bcmp_toss_grenade_probability" },
    { 0x471D69D4, "bcmp_toss_trophy_probability" },
    { 0x9315A47E, "bcmp_weapon_delay" },
    { 0xD8DD31D5, "bcmp_weapon_fire_probability" },
    { 0x50C7E57C, "bcmp_weapon_fire_threat_probability" },
    { 0x3BC46746, "bcmp_weapon_reload_probability" },
    { 0xF3F63045, "bg_ads" },
    { 0x7FC5A238, "bg_aimSpreadMoveSpeedThreshold" },
    { 0xF3F631F2, "bg_aqs" },
    { 0x675FE823, "bg_aqsStyle" },
    { 0xFD4EE5C1, "bg_blendTimeOverride" },
    { 0x15C2C686, "bg_bobMax" },
    { 0x7974AB07, "bg_chargeShotAutoDischargeDelay" },
    { 0xD8F3EEC3, "bg_chargeShotAutoFireDelay" },
    { 0x7E8E1783, "bg_chargeShotCenterSpeedReductionPerBullet" },
    { 0xF58CF0ED, "bg_chargeShotDamageIncreasePerBullet" },
    { 0xA05E31F7, "bg_chargeShotDischargeWhenQueueReachesMax" },
    { 0xA1B45A53, "bg_chargeShotFireWhenQueueReachesMax" },
    { 0x9DAF83A7, "bg_chargeShotMaxBulletQueueOnEMP" },
    { 0xF7A39B72, "bg_chargeShotMaxBulletsInQueue" },
    { 0x3F0A87B8, "bg_chargeShotMaxViewKick" },
    { 0xDC82772B, "bg_chargeShotMinCenterSpeed" },
    { 0x93CFDD45, "bg_chargeShotPenetrationMultiplier" },
    { 0xE624A709, "bg_chargeShotQueueTime" },
    { 0xE898933C, "bg_chargeShotUseOneAmmoForMultipleBullets" },
    { 0x7862794B, "bg_chargeShotViewKickIncreasePerBullet" },
    { 0x5B58D602, "bg_disableWeaponPlantingInWater" },
    { 0x5C55D810, "bg_dog_swim_enabled" },
    { 0xB88FB6ED, "bg_dog_swim_water_max" },
    { 0xB88FB7EB, "bg_dog_swim_water_min" },
    { 0x5C1C978A, "bg_fallDamageMaxHeight" },
    { 0xBC64DF08, "bg_fallDamageMinHeight" },
    { 0x7BDE587B, "bg_foliagesnd_fastinterval" },
    { 0x3E20C29F, "bg_foliagesnd_maxspeed" },
    { 0x8E9F125D, "bg_foliagesnd_minspeed" },
    { 0xEF8F5E50, "bg_foliagesnd_resetinterval" },
    { 0x0080EEB2, "bg_foliagesnd_slowinterval" },
    { 0x78F5DAC0, "bg_forceAnimOverrideTimerCheck" },
    { 0xA94483C2, "bg_forceDurationOverride" },
    { 0x452AD916, "bg_forceExplosiveBullets" },
    { 0x55F139D3, "bg_gravity" },
    { 0x7FC11116, "bg_gunXOffset" },
    { 0xAA00CA5D, "bg_ladder_yawcap" },
    { 0x98DE6157, "bg_legYawCrouchTolerance" },
    { 0xB8379857, "bg_legYawProneTolerance" },
    { 0x84A9ABB3, "bg_legYawTolerance" },
    { 0x116B50A5, "bg_lowGravity" },
    { 0x33CD2F17, "bg_maxGrenadeIndicatorSpeed" },
    { 0x6D8D6A6C, "bg_moonGravity" },
    { 0x3265DAA2, "bg_movingPlatformPitchScale" },
    { 0xE2D868DB, "bg_plantInWaterDepth" },
    { 0x9702B8B1, "bg_playerAnimStanceAllowMovementInteruptTime" },
    { 0xEC7975EA, "bg_proneSwingSpeed" },
    { 0xE99BF295, "bg_prone_yawcap" },
    { 0x6A39E0E9, "bg_serverDelayDamageKickForPing" },
    { 0x10ECE375, "bg_shieldHitEncodeHeightVM" },
    { 0xF63B4FDA, "bg_shieldHitEncodeHeightWorld" },
    { 0xE1837A7C, "bg_shieldHitEncodeWidthVM" },
    { 0x59E25D81, "bg_shieldHitEncodeWidthWorld" },
    { 0x612125C4, "bg_shock_animation" },
    { 0x5E17047A, "bg_shock_lookControl" },
    { 0xB72766B8, "bg_shock_lookControl_fadeTime" },
    { 0xD94C8E28, "bg_shock_lookControl_maxpitchspeed" },
    { 0x910B02E1, "bg_shock_lookControl_maxyawspeed" },
    { 0x7965C475, "bg_shock_lookControl_mousesensitivityscale" },
    { 0xD61FAB6F, "bg_shock_movement" },
    { 0x3C60E89D, "bg_shock_screenBlurBlendFadeTime" },
    { 0x0369B90D, "bg_shock_screenBlurBlendTime" },
    { 0x103D9ECF, "bg_shock_screenFlashShotFadeTime" },
    { 0x73C0C0B2, "bg_shock_screenFlashWhiteFadeTime" },
    { 0xBC181046, "bg_shock_screenType" },
    { 0x5374900D, "bg_shock_sound" },
    { 0x24987314, "bg_shock_soundDryLevel" },
    { 0x5DF36D24, "bg_shock_soundEnd" },
    { 0xAB2C30FC, "bg_shock_soundEndAbort" },
    { 0x84E12363, "bg_shock_soundFadeInTime" },
    { 0xFF3D1144, "bg_shock_soundFadeOutTime" },
    { 0x1C64EE67, "bg_shock_soundLoop" },
    { 0x0992290D, "bg_shock_soundLoopEndDelay" },
    { 0x0D392F06, "bg_shock_soundLoopFadeTime" },
    { 0x88782216, "bg_shock_soundLoopSilent" },
    { 0x678E4FF3, "bg_shock_soundModEndDelay" },
    { 0x120A2B2C, "bg_shock_soundRoomType" },
    { 0x90DEFF3D, "bg_shock_soundSnapshot" },
    { 0xB91C5ED5, "bg_shock_soundWetLevel" },
    { 0x1298F2A0, "bg_shock_viewKickFadeTime" },
    { 0x8CB9B6A4, "bg_shock_viewKickPeriod" },
    { 0x9113F969, "bg_shock_viewKickRadius" },
    { 0x3B36D2AD, "bg_shock_visionset_inTime" },
    { 0x44B4FF28, "bg_shock_visionset_name" },
    { 0x8048A9CE, "bg_shock_visionset_outTime" },
    { 0xA5536AEE, "bg_slopeFrames" },
    { 0xE8707266, "bg_swingSpeed" },
    { 0x72156156, "bg_teleportAlignTime" },
    { 0x6C5FF9FA, "bg_useClientDamageKick" },
    { 0x08C21A72, "bg_vehicle_gravity" },
    { 0x09E56F28, "bg_vehicle_ground_max_normal" },
    { 0x7336A666, "bg_vehicle_ground_min_normal" },
    { 0x4C14E7B6, "bg_vehicle_max_body_pitch" },
    { 0x024F66D7, "bg_vehicle_max_body_roll" },
    { 0x018B6C29, "bg_vehicle_max_pitch" },
    { 0xC1FDA8EA, "bg_vehicle_max_roll" },
    { 0xC005D550, "bg_vehicle_overclip" },
    { 0xA279FF78, "bg_vehicle_pitch_track" },
    { 0x54B94999, "bg_vehicle_roll_track" },
    { 0xE69201E8, "bg_vehicle_slide_min_normal" },
    { 0x640C513C, "bg_vehicle_sphere_bounds_offset_z" },
    { 0xD6FD39C3, "bg_vehicle_stepsize" },
    { 0xDAD788C6, "bg_vehicle_tangential_clip_max_scale" },
    { 0x0883FC47, "bg_vehicle_tangential_clip_vel_scale" },
    { 0x47BB8FA1, "bg_vehicle_trace_offset" },
    { 0x0F2EDBE8, "bg_viewBobAmplitudeDtp" },
    { 0x6110FF10, "bg_viewBobAmplitudeDucked" },
    { 0x12EF0F08, "bg_viewBobAmplitudeDuckedAds" },
    { 0x972D8D84, "bg_viewBobAmplitudeProne" },
    { 0xF511F0D9, "bg_viewBobAmplitudeRoll" },
    { 0xC79B899E, "bg_viewBobAmplitudeSprinting" },
    { 0x6FB9CF38, "bg_viewBobAmplitudeStanding" },
    { 0xF2BBCE30, "bg_viewBobAmplitudeStandingAds" },
    { 0x6944A16B, "bg_viewBobAmplitudeSwimming" },
    { 0xE60D3190, "bg_viewKickMax" },
    { 0xE60D328E, "bg_viewKickMin" },
    { 0x6DC08F0B, "bg_viewKickRandom" },
    { 0x9E8D2DD2, "bg_viewKickScale" },
    { 0x1899DD7B, "bg_vsmode_hud" },
    { 0x33E4EE41, "bg_weaponBobAmplitudeBaseLaser" },
    { 0xAF62EC17, "bg_weaponBobAmplitudeDtp" },
    { 0x8DA4D4DF, "bg_weaponBobAmplitudeDucked" },
    { 0x14A66573, "bg_weaponBobAmplitudeProne" },
    { 0xAD746CAC, "bg_weaponBobAmplitudeRiding" },
    { 0x9BC806E8, "bg_weaponBobAmplitudeRoll" },
    { 0x5CC215BF, "bg_weaponBobAmplitudeRollLaser" },
    { 0x848CC10D, "bg_weaponBobAmplitudeSprinting" },
    { 0x109A54C7, "bg_weaponBobAmplitudeStanding" },
    { 0x0A2526FA, "bg_weaponBobAmplitudeSwimming" },
    { 0x93F6FEC7, "bg_weaponBobFrequencySwimming" },
    { 0x44C11D47, "bg_weaponBobHeavyWeaponScalar" },
    { 0xB37A711E, "bg_weaponBobLag" },
    { 0xB37A7570, "bg_weaponBobMax" },
    { 0x5038F351, "bg_weaponOffscreenReloadScale" },
    { 0xBB02FAE4, "blackboxHighVolumeProbability" },
    { 0x7FB1F9A2, "blurpain" },
    { 0x1F9C84D1, "bot_AllowGrenades" },
    { 0xE9443BF3, "bot_AllowMovement" },
    { 0xD55E5EAA, "bot_CloseDistance" },
    { 0x91E6A838, "bot_CrouchDistance" },
    { 0xC0935AD0, "bot_Debug" },
    { 0xF20E8150, "bot_DebugPaths" },
    { 0x3DB0D1F8, "bot_DebugThreat" },
    { 0xDD1B2972, "bot_ForceStand" },
    { 0x86E07034, "bot_Fov" },
    { 0x02976E74, "bot_GoalRadius" },
    { 0x0D3EB879, "bot_IgnoreHumans" },
    { 0x87D87056, "bot_MaxAdsTime" },
    { 0xCAF86AA2, "bot_MaxCrouchTime" },
    { 0xBFC69DC4, "bot_MaxDeathTime" },
    { 0x9DB433A4, "bot_MaxFireTime" },
    { 0x987CC4B4, "bot_MaxGrenadeTime" },
    { 0x758E0CF6, "bot_MaxPitchTime" },
    { 0x0C0502D3, "bot_MaxReactionTime" },
    { 0xBC9C4EA3, "bot_MaxStrafeTime" },
    { 0x324C8425, "bot_MeleeDist" },
    { 0xF129A794, "bot_MinAdsTime" },
    { 0x1CF44120, "bot_MinCrouchTime" },
    { 0xC2429C82, "bot_MinDeathTime" },
    { 0x312C52A2, "bot_MinFireTime" },
    { 0x29F36AF2, "bot_MinGrenadeTime" },
    { 0x780A0BB4, "bot_MinPitchTime" },
    { 0xCC5070D1, "bot_MinReactionTime" },
    { 0x0E982521, "bot_MinStrafeTime" },
    { 0xA42722F9, "bot_PitchDown" },
    { 0x2A1B30B2, "bot_PitchSpeed" },
    { 0xD2F0756A, "bot_PitchSpeedAds" },
    { 0xD920B866, "bot_PitchUp" },
    { 0x98E33992, "bot_PressAttackBtn" },
    { 0x351B21A2, "bot_PressMeleeBtn" },
    { 0x9BF750D4, "bot_SprintDistance" },
    { 0x4E204610, "bot_StrafeChance" },
    { 0x04953EC5, "bot_TargetLeadBias" },
    { 0x4CAF78A2, "bot_UseFriendNames" },
    { 0xEBDB7AEB, "bot_YawSpeed" },
    { 0x6563C103, "bot_YawSpeedAds" },
    { 0xF627F35C, "bot_difficulty" },
    { 0x94FFF5AF, "bot_enemies" },
    { 0xEB92E914, "bot_friends" },
    { 0x2EE36340, "bullet_penetrationEnabled" },
    { 0x6EC6096B, "bullet_penetrationMinFxDist" },
    { 0xF4D2861A, "bullet_ricochetBaseChance" },
    { 0x1797571A, "bulletrange" },
    { 0x82990C67, "cameraShakeRemoteHelo_Angles" },
    { 0xE54A01AE, "cameraShakeRemoteHelo_Freqs" },
    { 0x43B27C6B, "cameraShakeRemoteHelo_SpeedRange" },
    { 0x5B333635, "cameraShakeRemoteMissile_Angles" },
    { 0x7F3F29BC, "cameraShakeRemoteMissile_Freqs" },
    { 0xCDC8DD39, "cameraShakeRemoteMissile_SpeedRange" },
    { 0x8C45D37F, "cg_BallisticArc_BeginWidth" },
    { 0x2F190277, "cg_BallisticArc_DrawDelay" },
    { 0x923CD0B1, "cg_BallisticArc_EndWidth" },
    { 0x77F3E14B, "cg_BallisticArc_ForceHitIndicator" },
    { 0x7E8374EF, "cg_BallisticArc_MaxBounces" },
    { 0xE7D4AC2D, "cg_BallisticArc_MinBounces" },
    { 0x9EC641A1, "cg_BallisticArc_Offset" },
    { 0x8E0E827F, "cg_EnableAdaptiveSkinLodScale" },
    { 0x5BA78D50, "cg_InfraredFadeoutTime" },
    { 0x173D0052, "cg_ScoresPing_BgColor" },
    { 0x90DE9BE9, "cg_ScoresPing_HighColor" },
    { 0xB677A9EF, "cg_ScoresPing_Interval" },
    { 0xCF10E05B, "cg_ScoresPing_LowColor" },
    { 0x8D3A51BF, "cg_ScoresPing_MedColor" },
    { 0x5D8D22A2, "cg_VelocityArrow_MaxSegmentLength" },
    { 0x27465060, "cg_VelocityArrow_MinSegmentLength" },
    { 0x9094E76E, "cg_VelocityArrow_RateOfChange" },
    { 0xD1D2B02E, "cg_adsZScaleMax" },
    { 0x8D986C19, "cg_airburstCameraRestriction" },
    { 0x6F62E69C, "cg_airburstLaseFlashTime" },
    { 0x8516A00E, "cg_airburstLaseTime" },
    { 0xF1E59D95, "cg_airburstStrafeRestriction" },
    { 0x695315B6, "cg_allPlayerNamesVisible" },
    { 0x77731F9A, "cg_allow_mature" },
    { 0xB55AD017, "cg_altDofTrace" },
    { 0x506A31EC, "cg_alt_mode_killstreak_fix_tu6" },
    { 0x3AA00C48, "cg_artilleryKillCamBackDist" },
    { 0x2D5743CE, "cg_artilleryKillCamFov" },
    { 0x6C33C217, "cg_artilleryKillCamGroundBackDist" },
    { 0xB46AB82B, "cg_artilleryKillCamGroundUpDist" },
    { 0x0A2CC21C, "cg_artilleryKillCamUpDist" },
    { 0x1D6257BF, "cg_artilleryKillCamWallOutDist" },
    { 0xB9B6706C, "cg_artilleryKillCamWallSideDist" },
    { 0x18F1B650, "cg_cameraSpikeEnemyColor" },
    { 0xC1BA9B84, "cg_cameraSpikeHighlightBrightness" },
    { 0xFC2F4423, "cg_cameraVehicleExitTweenTime" },
    { 0x2D612F42, "cg_cameraWaterClip" },
    { 0xC9418B10, "cg_canSeeFriendlyFrustumExpand" },
    { 0x90DB18BF, "cg_canSeeFriendlyFrustumMinDistance" },
    { 0xDE436578, "cg_canSeeFriendlyFrustumUpdateInterval" },
    { 0x2CD2E67E, "cg_centertime" },
    { 0x90FE9427, "cg_chatHeight" },
    { 0xA4FF89CE, "cg_cinematicFullscreen" },
    { 0x1AADEF4F, "cg_colorHue" },
    { 0x3E193017, "cg_colorSaturation" },
    { 0x7EA42B15, "cg_colorScale" },
    { 0x70722B23, "cg_colorTemp" },
    { 0xFCA4C2E1, "cg_constantSizeHeadIcons" },
    { 0xD10FAC11, "cg_corpseHighlightFadeTime" },
    { 0x729B5E82, "cg_crosshairAlpha" },
    { 0x648FC4E6, "cg_crosshairAlphaMin" },
    { 0x8C0706C1, "cg_crosshairDynamic" },
    { 0x5210F199, "cg_crosshairEnemyColor" },
    { 0x9557A5ED, "cg_cullBulletAngle" },
    { 0xDC52C459, "cg_cullBullets" },
    { 0xEE75F792, "cg_cursorHints" },
    { 0xED717C95, "cg_debug_overlay_viewport" },
    { 0x3EBC63CA, "cg_debugevents" },
    { 0x0BAE9D2A, "cg_debugposition" },
    { 0xD2836A90, "cg_destructibleKillCamCloseXYDist" },
    { 0x44895A39, "cg_destructibleKillCamCloseZDist" },
    { 0xE14FD483, "cg_destructibleKillCamFarBlur" },
    { 0xF69501D7, "cg_destructibleKillCamFarBlurDist" },
    { 0xCA4A6811, "cg_destructibleKillCamFarBlurStart" },
    { 0xD2BF3740, "cg_destructibleKillCamFov" },
    { 0x7AB63310, "cg_destructibleKillCamNearBlur" },
    { 0x22F7D547, "cg_destructibleKillCamNearBlurEnd" },
    { 0xC142E6BE, "cg_destructibleKillCamNearBlurStart" },
    { 0x91CDB080, "cg_destructibleKillCamRegularHeight" },
    { 0xBF2E45D9, "cg_destructibleKillCamZIncrease" },
    { 0x2C2658D1, "cg_development" },
    { 0xD8E34B43, "cg_disableplayernames" },
    { 0xE12B7443, "cg_dogKillCamDistFromEyes" },
    { 0x3E36FC4E, "cg_dogKillCamForwardDist" },
    { 0x92B1C8B0, "cg_dogKillCamFov" },
    { 0x1A748CFE, "cg_dogKillCamSideDist" },
    { 0xF224B3BE, "cg_dogKillCamUpDist" },
    { 0xBC9F1287, "cg_dogKillMinDistFromTarget" },
    { 0x8F1F6A52, "cg_draw2D" },
    { 0xFB1C97D7, "cg_drawBigFPS" },
    { 0xAC843485, "cg_drawBreathHint" },
    { 0x1202EB8A, "cg_drawCrosshair" },
    { 0x1973471E, "cg_drawCrosshairNames" },
    { 0xA21CF808, "cg_drawCrosshairNamesPosX" },
    { 0xA21CF809, "cg_drawCrosshairNamesPosY" },
    { 0x730D93C5, "cg_drawFPS" },
    { 0xA3CAAEA7, "cg_drawFPSOnly" },
    { 0xFB2AD76D, "cg_drawFriendlyNames" },
    { 0x730D98A6, "cg_drawGun" },
    { 0x08CFF952, "cg_drawHealth" },
    { 0x85EE4D2C, "cg_drawHoldBreathHint" },
    { 0x11E61C0B, "cg_drawMaterial" },
    { 0x6A81DB2F, "cg_drawMaterialImageName" },
    { 0xCCECAC1E, "cg_drawMaterialImageNum" },
    { 0x6A2EE182, "cg_drawModelAxis" },
    { 0xA139EA8C, "cg_drawShellshock" },
    { 0xD4C77968, "cg_drawTalk" },
    { 0x4D762D60, "cg_drawThroughWalls" },
    { 0x59B5BFE2, "cg_drawVersion" },
    { 0x086F513C, "cg_drawlagometer" },
    { 0x1B3BEFBE, "cg_drawpaused" },
    { 0x6977E268, "cg_droneKillCamBackDist" },
    { 0x5ED8903C, "cg_droneKillCamUpDist" },
    { 0xBC9224FC, "cg_dumpAnims" },
    { 0xF4B3B1A8, "cg_enableHelicopterNoCullLodOut" },
    { 0xEBC49634, "cg_enemyNameFadeIn" },
    { 0x64577795, "cg_enemyNameFadeOut" },
    { 0x9A04D72F, "cg_explosiveKillCamBackDist" },
    { 0xB054DE3E, "cg_explosiveKillCamGroundBackDist" },
    { 0x7D789E92, "cg_explosiveKillCamGroundUpDist" },
    { 0x0F650A41, "cg_explosiveKillCamStopDecelDist" },
    { 0x1D4EDE84, "cg_explosiveKillCamStopDist" },
    { 0x8843A743, "cg_explosiveKillCamUpDist" },
    { 0x61898D46, "cg_explosiveKillCamWallOutDist" },
    { 0x82C456D3, "cg_explosiveKillCamWallSideDist" },
    { 0xD5BFE442, "cg_fakefireWizbyChance" },
    { 0x8F29FD50, "cg_firstPersonTracerChance" },
    { 0xB7537F55, "cg_fixupSmodelCullDists" },
    { 0x3EE1EDD2, "cg_flareVisionSetFadeDuration" },
    { 0xCBB3A5C6, "cg_footprints" },
    { 0xCBEAD68D, "cg_footprintsDebug" },
    { 0xCF3F0AB2, "cg_footprintsDistortWater" },
    { 0xC0921875, "cg_footsteps" },
    { 0xD7810AE8, "cg_forceInfrared" },
    { 0xF64B6F99, "cg_fov" },
    { 0x06CBA50E, "cg_fovExtraCam" },
    { 0x939ED29D, "cg_fovMin" },
    { 0xF7070DA1, "cg_fovScale" },
    { 0x55DDAF3D, "cg_fov_default" },
    { 0x41DEFE0E, "cg_fov_default_thirdperson" },
    { 0x1CCE9773, "cg_friendlyNameFadeIn" },
    { 0xB6A1A0B4, "cg_friendlyNameFadeOut" },
    { 0xD1AAECA1, "cg_fuelHudVersion" },
    { 0x46B140B3, "cg_gun_move_f" },
    { 0x6E387342, "cg_gun_move_minspeed" },
    { 0x46B140BF, "cg_gun_move_r" },
    { 0xB893A859, "cg_gun_move_rate" },
    { 0x46B140C2, "cg_gun_move_u" },
    { 0x40531EC4, "cg_gun_ofs_f" },
    { 0x40531ED0, "cg_gun_ofs_r" },
    { 0x40531ED3, "cg_gun_ofs_u" },
    { 0x36DABCC0, "cg_gun_rot_minspeed" },
    { 0x408E5BFB, "cg_gun_rot_p" },
    { 0x408E5BFD, "cg_gun_rot_r" },
    { 0x5040E2D7, "cg_gun_rot_rate" },
    { 0x408E5C04, "cg_gun_rot_y" },
    { 0xB6FB074F, "cg_gun_x" },
    { 0xB6FB0750, "cg_gun_y" },
    { 0xB6FB0751, "cg_gun_z" },
    { 0xBB9BC3F5, "cg_headIconMinScreenRadius" },
    { 0x611BB4FB, "cg_heliKillCamFarBlur" },
    { 0x41CC5E4F, "cg_heliKillCamFarBlurDist" },
    { 0x7C6D5389, "cg_heliKillCamFarBlurStart" },
    { 0x097D9BB8, "cg_heliKillCamFov" },
    { 0xF3FE2288, "cg_heliKillCamNearBlur" },
    { 0x6E2F31BF, "cg_heliKillCamNearBlurEnd" },
    { 0xB7C34136, "cg_heliKillCamNearBlurStart" },
    { 0x01D0AA87, "cg_hudGrenadeIconHeight" },
    { 0x1E9D4EEF, "cg_hudGrenadeIconMaxRangeFlash" },
    { 0xB35A3321, "cg_hudGrenadeIconMaxRangeFrag" },
    { 0x12356CF5, "cg_hudGrenadeIconOffset" },
    { 0xF19BC12E, "cg_hudGrenadeIconWidth" },
    { 0x50E3DE7F, "cg_hudGrenadePointerHeight" },
    { 0x601DF698, "cg_hudGrenadePointerPivot" },
    { 0x609C5626, "cg_hudGrenadePointerWidth" },
    { 0x4011BFCB, "cg_hudMapBorderWidth" },
    { 0x1A3135A3, "cg_hudMapFriendlyHeight" },
    { 0xB44958CA, "cg_hudMapFriendlyWidth" },
    { 0x85C11A33, "cg_hudMapPlayerHeight" },
    { 0x2426EB5A, "cg_hudMapPlayerWidth" },
    { 0xB6A5BA0B, "cg_hudMapRadarLineThickness" },
    { 0xA56A982E, "cg_infraredBlur" },
    { 0x0C78683D, "cg_infraredBlurTime" },
    { 0xCD23697E, "cg_infraredFriendlies" },
    { 0x6ABEE0DA, "cg_infraredUseDefaultMaterial" },
    { 0x9866E9F2, "cg_killcamdebug" },
    { 0x60FE90F5, "cg_laserSightMaxDistance" },
    { 0xF855AB32, "cg_lastSpectatorSelectedThirdPerson" },
    { 0xE5145D3B, "cg_maxPlayerHighlightTargetSize" },
    { 0x9D951536, "cg_microwaveTurretKillCamBackOffset" },
    { 0xD79E7969, "cg_microwaveTurretKillCamFov" },
    { 0x12F8AC21, "cg_microwaveTurretKillCamHeightIncrease" },
    { 0xC8A20BDE, "cg_minCullBulletDist" },
    { 0x8BFA674E, "cg_missile_FOV" },
    { 0xE0B09C34, "cg_opticAttachmentViewmodelSwitch" },
    { 0x683363A0, "cg_overheadIconSize" },
    { 0xFDF2B51D, "cg_overheadNamesFarDist" },
    { 0xBD5530D1, "cg_overheadNamesFarScale" },
    { 0x2D962929, "cg_overheadNamesGlow" },
    { 0x1936F16A, "cg_overheadNamesMaxDist" },
    { 0x2B93AF0A, "cg_overheadNamesNearDist" },
    { 0x2D9CB24B, "cg_overheadNamesSize" },
    { 0x710EA954, "cg_overheadNamesTagUpdateInterval" },
    { 0x1A03F3E3, "cg_overheadRankSize" },
    { 0xF15851A5, "cg_playerFrustumHalfHeight" },
    { 0x135CF852, "cg_playerHighlightBlinkTime" },
    { 0x1812238C, "cg_playerHighlightBrightness" },
    { 0x958AE7B0, "cg_playerHighlightEnemyColor" },
    { 0xA16FFF27, "cg_playerHighlightMinFade" },
    { 0xEBE0A895, "cg_playerHighlightTargetSize" },
    { 0x936B18F7, "cg_proneFeetCollisionHull" },
    { 0x98BCDEEE, "cg_rangeFinderActiveColor" },
    { 0xBB4BCAC8, "cg_rangeFinderActiveHeight" },
    { 0x9A235D4F, "cg_rangeFinderActiveWidth" },
    { 0xC6DAC0F7, "cg_rangeFinderDefaultColor" },
    { 0x615D4A4C, "cg_rangeFinderDiamondIndicator" },
    { 0x471858EA, "cg_rangeFinderDiamondSize" },
    { 0x38585241, "cg_rangeFinderMinEnemySpottingDist" },
    { 0xEEBB3EA2, "cg_rangeFinderPlayerTargetSize" },
    { 0x07D92EB6, "cg_retrieveHintTime" },
    { 0xD5B36D40, "cg_retrieveHintTimeStuck" },
    { 0x65234398, "cg_rocketKillCamBackDist" },
    { 0xD4D9E56C, "cg_rocketKillCamUpDist" },
    { 0x741276B7, "cg_scoreboardMyColor" },
    { 0xAFE38B44, "cg_scriptedKillCamCloseXYDist" },
    { 0x894E346D, "cg_scriptedKillCamCloseZDist" },
    { 0x9673BB37, "cg_scriptedKillCamFarBlur" },
    { 0xD3F5228B, "cg_scriptedKillCamFarBlurDist" },
    { 0x53AE9F45, "cg_scriptedKillCamFarBlurStart" },
    { 0x78B3E3F4, "cg_scriptedKillCamFov" },
    { 0xD456F044, "cg_scriptedKillCamNearBlur" },
    { 0x0057F5FB, "cg_scriptedKillCamNearBlurEnd" },
    { 0x772E0472, "cg_scriptedKillCamNearBlurStart" },
    { 0x3A613689, "cg_showZombieControls" },
    { 0x26F0CAEF, "cg_sonarAttachmentBlur" },
    { 0x4593B4A0, "cg_sonarAttachmentCounterColorMultiplier" },
    { 0x05C8EE71, "cg_sonarAttachmentCounterMaxSpeed" },
    { 0xB3631E04, "cg_sonarAttachmentDistanceFactor" },
    { 0x591C124C, "cg_sonarAttachmentEmpFade" },
    { 0x82D0128F, "cg_sonarAttachmentFadeFriendlies" },
    { 0x7448D1D9, "cg_sonarAttachmentHideFriendlies" },
    { 0xA57FE014, "cg_sonarAttachmentMaxDist" },
    { 0x568EEBB1, "cg_sonarAttachmentMaxSpeed" },
    { 0x7A7421A8, "cg_sonarAttachmentPulseInterval" },
    { 0x5E8CBC12, "cg_sonarAttachmentPulseTime" },
    { 0x46E0B17A, "cg_sonarAttachmentSpeedDelay" },
    { 0x9146A1F9, "cg_sonarAttachmentSpeedTimeRatio" },
    { 0x11FB2E52, "cg_sonarAttachmentZmTurnedFadeTime" },
    { 0x899A0E04, "cg_sonarAttachmentZmTurnedGraceTime" },
    { 0x9B5CC287, "cg_sonarAttachmentZmTurnedMinFade" },
    { 0x87092272, "cg_streamLowDetailCamos" },
    { 0xF32641EB, "cg_subtitleWidthStandard" },
    { 0x97AAD223, "cg_subtitleWidthWidescreen" },
    { 0x3CD6A140, "cg_thirdPerson" },
    { 0xDD86C847, "cg_thirdPersonAngle" },
    { 0x6DAB1334, "cg_thirdPersonFocusDist" },
    { 0x1E02EC05, "cg_thirdPersonMode" },
    { 0xDEB3650D, "cg_thirdPersonRange" },
    { 0xA67367E6, "cg_timedDamageDuration" },
    { 0x543B603C, "cg_treadmarks" },
    { 0x0A283289, "cg_turretBipodOffset" },
    { 0xE9B7D6C9, "cg_turretKillCamBackOffset" },
    { 0xD3EDB9AC, "cg_turretKillCamCloseXYDist" },
    { 0x541835D5, "cg_turretKillCamCloseZDist" },
    { 0x8016F59F, "cg_turretKillCamFarBlur" },
    { 0xF7FF50F3, "cg_turretKillCamFarBlurDist" },
    { 0xF8FE9AAD, "cg_turretKillCamFarBlurStart" },
    { 0x0D4A2A5C, "cg_turretKillCamFov" },
    { 0x4EF7FF34, "cg_turretKillCamHeightIncrease" },
    { 0xF26177AC, "cg_turretKillCamNearBlur" },
    { 0x24622463, "cg_turretKillCamNearBlurEnd" },
    { 0xC67D6CDA, "cg_turretKillCamNearBlurStart" },
    { 0xF0B36A5D, "cg_turretKillCamSideOffset" },
    { 0xA556CEB1, "cg_ufo_scaler" },
    { 0x40F45CDC, "cg_usNewEventQueueScheme" },
    { 0x995C3D1B, "cg_useColorControl" },
    { 0x0E69B471, "cg_useFovSensitivity" },
    { 0x4DB643C0, "cg_useSafeSpectatorCam" },
    { 0x3449CD2F, "cg_useWeaponBasedVariableZoom" },
    { 0x3B3D07F4, "cg_useWeaponSwitchReloadCancel" },
    { 0x18959080, "cg_use_colored_smoke" },
    { 0x8831409B, "cg_usingClientScripts" },
    { 0x53E4E931, "cg_viewVehicleInfluenceGunner" },
    { 0x21AFD770, "cg_viewVehicleInfluenceGunnerFiring" },
    { 0xEF5A4521, "cg_viewZSmoothingMax" },
    { 0xEF5A461F, "cg_viewZSmoothingMin" },
    { 0xDAA6E0EA, "cg_viewZSmoothingTime" },
    { 0x8F2F3E39, "cg_visionSetLerpMaxDecreasePerFrame" },
    { 0x89BBD767, "cg_visionSetLerpMaxIncreasePerFrame" },
    { 0xD6209E28, "cg_watersheeting" },
    { 0x616A07DA, "cg_weaponHeat" },
    { 0x5B826836, "cg_weaponHintsCoD1Style" },
    { 0x0FEBC1DA, "cg_weaponSimulateFireAnims" },
    { 0xA3DC03E9, "challengeResponseResendBackoffInterval" },
    { 0x8948C3DD, "challengeResponseResendInterval" },
    { 0x014A13E8, "checkEmblemForRank" },
    { 0xE9F47676, "cl_bspmismatchFatal" },
    { 0x3A3D3B24, "cl_connectTimeout" },
    { 0xDD633055, "cl_connectionAttempts" },
    { 0xBEDF0D7E, "cl_deathMessageWidth" },
    { 0xC98ABB2A, "cl_freelook" },
    { 0x37CCF024, "cl_ingame" },
    { 0xE1C32BA0, "cl_leanCountMin" },
    { 0x403FE6BF, "cl_maxppf" },
    { 0xE62451BA, "cl_migrationPingTime" },
    { 0xB18C511E, "cl_motdString" },
    { 0xFE6F5694, "cl_mouseAccel" },
    { 0xB46F331A, "cl_nodelta" },
    { 0x473DC6D5, "cl_paused" },
    { 0x1431E885, "cl_profileWriteLimiter" },
    { 0x659FD911, "cl_splitscreenGamestateHack" },
    { 0x74F0955A, "cl_timeout" },
    { 0x38EA4789, "cl_voice" },
    { 0x60CBB715, "cl_yawspeed" },
    { 0x9C12E867, "clancard_clanid" },
    { 0x6A4569EA, "classVersionNumber" },
    { 0xC5740DFC, "client_notify" },
    { 0x8A04A058, "com_desiredMenu" },
    { 0x2995DDA4, "com_freemoveScale" },
    { 0x3F44BDAE, "com_introPlayed" },
    { 0x1851C25B, "com_maxclients" },
    { 0x75FE5192, "com_maxfps" },
    { 0xE7D5D4B2, "com_recommendedSet" },
    { 0x98B9403A, "com_report_syserrors" },
    { 0x2E5F6129, "com_statmon" },
    { 0x0A87E7DA, "com_timescale" },
    { 0xC630125F, "com_voip_resume_time" },
    { 0xD3653F1B, "compass" },
    { 0x04007424, "compassClampIcons" },
    { 0x688126B3, "compassEnableColorBlindPlayerIcons" },
    { 0x77595958, "compassEnemyFootstepEnabled" },
    { 0x12A06300, "compassEnemyFootstepMaxRange" },
    { 0x64D8C62D, "compassEnemyFootstepMaxZ" },
    { 0x6338DE62, "compassEnemyFootstepMinSpeed" },
    { 0x2A3EB400, "compassForcePlayerIcon" },
    { 0x123AC94C, "compassGridAlign" },
    { 0xA3774B12, "compassGridCols" },
    { 0xC412138C, "compassGridEnabled" },
    { 0xA37F862C, "compassGridRows" },
    { 0xF82D8378, "compassLocalRadarRadius" },
    { 0x0639D542, "compassLocalRadarUpdateTime" },
    { 0x345DDA4E, "compassMaxRange" },
    { 0x205BFAC7, "compassMinRadius" },
    { 0x84DC2A0C, "compassMinRange" },
    { 0x564817BD, "compassObjectiveDetailDist" },
    { 0xD8569B2F, "compassObjectiveHeight" },
    { 0x6FD98C95, "compassObjectiveMaxHeight" },
    { 0x5CA729DB, "compassObjectiveMinDistRange" },
    { 0xD021D413, "compassObjectiveMinHeight" },
    { 0x0304214B, "compassObjectiveNearbyDist" },
    { 0xD1523CD6, "compassObjectiveWidth" },
    { 0xBB1AB999, "compassRadarLineThickness" },
    { 0xC7497752, "compassRadarPingFadeTime" },
    { 0xB74756C5, "compassRadarUpdateFastTime" },
    { 0x363F5137, "compassRadarUpdateTime" },
    { 0xAA7968CF, "compassSatellitePingFadeTime" },
    { 0x9DC99DB6, "compassSatelliteScanTime" },
    { 0x31E32C4C, "compassSatelliteStaticImageFadeTime" },
    { 0x201CB782, "compassShowEnemies" },
    { 0x87DA1D91, "compassSoundPingFadeTime" },
    { 0x55464298, "compassStaticImageUpdateTime" },
    { 0xC265F283, "con_gameMsgWindow0FadeInTime" },
    { 0xED5BC464, "con_gameMsgWindow0FadeOutTime" },
    { 0xF52755D3, "con_gameMsgWindow0Filter" },
    { 0x9894D13E, "con_gameMsgWindow0LineCount" },
    { 0xCBE2E603, "con_gameMsgWindow0MsgTime" },
    { 0xD4237FEB, "con_gameMsgWindow0ScrollTime" },
    { 0xA2D37E61, "con_gameMsgWindow0SplitscreenScale" },
    { 0x47C2A7C4, "con_gameMsgWindow1FadeInTime" },
    { 0x1E4F21C5, "con_gameMsgWindow1FadeOutTime" },
    { 0x42219294, "con_gameMsgWindow1Filter" },
    { 0x9C9F625F, "con_gameMsgWindow1LineCount" },
    { 0xB824BAE4, "con_gameMsgWindow1MsgTime" },
    { 0x5980352C, "con_gameMsgWindow1ScrollTime" },
    { 0x35AD6062, "con_gameMsgWindow1SplitscreenScale" },
    { 0xCD1F5D05, "con_gameMsgWindow2FadeInTime" },
    { 0x4F427F26, "con_gameMsgWindow2FadeOutTime" },
    { 0x8F1BCF55, "con_gameMsgWindow2Filter" },
    { 0xA0A9F380, "con_gameMsgWindow2LineCount" },
    { 0xA4668FC5, "con_gameMsgWindow2MsgTime" },
    { 0xDEDCEA6D, "con_gameMsgWindow2ScrollTime" },
    { 0xC8874263, "con_gameMsgWindow2SplitscreenScale" },
    { 0x527C1246, "con_gameMsgWindow3FadeInTime" },
    { 0x8035DC87, "con_gameMsgWindow3FadeOutTime" },
    { 0xDC160C16, "con_gameMsgWindow3Filter" },
    { 0xA4B484A1, "con_gameMsgWindow3LineCount" },
    { 0x90A864A6, "con_gameMsgWindow3MsgTime" },
    { 0x64399FAE, "con_gameMsgWindow3ScrollTime" },
    { 0x5B612464, "con_gameMsgWindow3SplitscreenScale" },
    { 0x37DDF0DF, "con_hintBoxColor" },
    { 0x3340AC3C, "con_inputBoxColor" },
    { 0x56E6DB07, "con_inputCmdColor" },
    { 0x3D385B73, "con_inputColor" },
    { 0x31C64660, "con_inputDvarColor" },
    { 0xC08BCD89, "con_outputBarColor" },
    { 0x503D91B7, "con_outputSliderColor" },
    { 0xAD6F130C, "con_outputWindowColor" },
    { 0x195C44BD, "con_typewriterColorBase" },
    { 0xC9E14689, "con_versionColor" },
    { 0xC8253727, "content_trialcontentpackbits" },
    { 0x5AA5C862, "counterDownloadInterval" },
    { 0xD03DE84F, "counterUploadInterval" },
    { 0x134D5297, "createfx" },
    { 0x6AC13DAC, "createfx_autosave_time" },
    { 0x94DE57D9, "createfx_drawaxis" },
    { 0x74012625, "createfx_drawaxis_range" },
    { 0x94DFBE78, "createfx_drawdist" },
    { 0xC888BAB4, "createfx_map" },
    { 0xA6DCBA49, "createfx_oneshot_max_delay" },
    { 0x072501C7, "createfx_oneshot_min_delay" },
    { 0x5A7DE640, "createfx_print_frames" },
    { 0xD0C4376B, "createfx_scaleid" },
    { 0xF75FC86A, "creditsScrollScale" },
    { 0x7547FDB7, "currentTUVersion" },
    { 0x4083079F, "customGameMode" },
    { 0x78A08DA5, "custom_killstreak_1" },
    { 0xC6C534A3, "custom_killstreak_1_kills" },
    { 0x78A08DA6, "custom_killstreak_2" },
    { 0x13BF7164, "custom_killstreak_2_kills" },
    { 0x78A08DA7, "custom_killstreak_3" },
    { 0x60B9AE25, "custom_killstreak_3_kills" },
    { 0x2F851AB2, "custom_perks_allow_pro" },
    { 0xD7997EA3, "debugRenderCollisionDistance" },
    { 0x7706D878, "debugRenderMask" },
    { 0xC450CB50, "debug_color_pallete" },
    { 0x36FAE5DF, "debug_dynamic_ai_spawning" },
    { 0x99BAF398, "debug_engage_dists" },
    { 0xC394DFE1, "debug_killstreak" },
    { 0xBC8CA09D, "debug_protocol" },
    { 0x628768B6, "debug_reflection" },
    { 0x33E24970, "debug_reflection_matte" },
    { 0x1BE0BEF8, "debug_show_viewpos" },
    { 0xB695B6BC, "dedicated" },
    { 0x6BB51720, "dedicatedPingLog_DoTestChance" },
    { 0x18733050, "dedicatedPingLog_Interval" },
    { 0xDE7133E0, "dedicatedPingLog_MaxTestTime" },
    { 0x5109875B, "dedicatedPingLog_ServerLocation" },
    { 0x02C22CBE, "dedicatedPingLog_TimesToPing" },
    { 0xE08DB901, "dedicatedPingLog_WaitBeforePing" },
    { 0x3818BA6F, "defaultDamageDuration" },
    { 0xBF7C098E, "defaultDamageInterval" },
    { 0x1EC4674E, "defaultHitDamage" },
    { 0x22712C30, "demoRenderDuration" },
    { 0x8A05C09D, "demoRenderSizeX" },
    { 0x8A05C09E, "demoRenderSizeY" },
    { 0xC447A05D, "demo_bookmarkEventThresholdTime" },
    { 0x3954E759, "demo_bytesPerSecondMax" },
    { 0x3954E857, "demo_bytesPerSecondMin" },
    { 0x24FC2AA8, "demo_client" },
    { 0xA4C08C31, "demo_currentDemo" },
    { 0xD9EA7236, "demo_dollycamHighlightThreshholdDistance" },
    { 0x9F36FEB3, "demo_dollycamMarkerInformationFarDist" },
    { 0x8722AD27, "demo_dollycamMarkerInformationFarScale" },
    { 0xF5612B60, "demo_dollycamMarkerInformationNearDist" },
    { 0xE406EEC6, "demo_dollycamMarkerInformationThreshholdDistance" },
    { 0xA835DCDC, "demo_dollycamMarkerTimeScaleMode" },
    { 0xAF8CCC14, "demo_dollycamMarkerTimeScaleValue" },
    { 0x0A6AF093, "demo_dollycamTrackWidth" },
    { 0xB0706CF6, "demo_downloadStreamDataBlockRequestSize" },
    { 0x0ACFAC77, "demo_downloadStreamDataBlockThrottleTime" },
    { 0xC5FFA847, "demo_downloadStreamMaxRetryAttemps" },
    { 0x26DD2407, "demo_downloadStreamRetryWaitTime" },
    { 0xC5B0EC92, "demo_downloadStreamThrottleTime" },
    { 0x81790759, "demo_enableClipRecordEvent" },
    { 0x0D6912A5, "demo_enableDollyCam" },
    { 0x7218C783, "demo_enableSvBandwidthLimitThrottle" },
    { 0x628DD734, "demo_enabled" },
    { 0x41A474B8, "demo_errormessage" },
    { 0x63881475, "demo_errortitle" },
    { 0x938D4002, "demo_extraNetworkProfileData" },
    { 0x6A5638C8, "demo_fileLimit" },
    { 0xB7479483, "demo_filesizeLimit" },
    { 0x43D0DF12, "demo_freeCameraLockOnHighlightThreshholdDistance" },
    { 0xD85282C2, "demo_freeCameraLockOnOrbitRadius" },
    { 0xD6DD200D, "demo_freeCameraShowLockableObjectsAlways" },
    { 0x4D7B0788, "demo_highlightReelGameResultFilter" },
    { 0x7B760BB8, "demo_highlightReelMinimumStarsFilter" },
    { 0xD207F94D, "demo_highlightReelNumberOfSegments" },
    { 0xDCA2CBFC, "demo_highlightReelPlayerFilter" },
    { 0x5E08A8F3, "demo_highlightReelStylesFilter" },
    { 0x92C4695A, "demo_highlightReelTransitionFilter" },
    { 0x2E6C10B6, "demo_inGameThrottleBandwitdhPercent" },
    { 0x0BF93314, "demo_inLobbyThrottleBandwitdhPercent" },
    { 0x1B7DF9C9, "demo_keyframerate" },
    { 0xC7D17E59, "demo_matchRecordEventOnPlaylists" },
    { 0xFE6BB0E6, "demo_maxTimeScale" },
    { 0x7ADE0A5D, "demo_packetsPerSecondMax" },
    { 0x7ADE0B5B, "demo_packetsPerSecondMin" },
    { 0x9D2B1EE7, "demo_pause" },
    { 0xBF7049D3, "demo_pauseOnNextSnapshot" },
    { 0xAC28EE30, "demo_recordPrivateMatch" },
    { 0x7B442595, "demo_recordStaticEntityPositions" },
    { 0x0A5AEBB2, "demo_recordingrate" },
    { 0x5118F161, "demo_refreshDollyCamFxEveryFrame" },
    { 0xE8590727, "demo_save_smp" },
    { 0xD2AA909D, "demo_selectedSegmentIndex" },
    { 0x81FF4482, "demo_streamUploadKeepAliveFrequency" },
    { 0xDA350331, "demo_streamingAdjustmentFactor" },
    { 0xF1442485, "demo_streamingSendSocketBuffSizeForOtherUploads" },
    { 0x2D418E08, "demo_streamingSendSocketBuffSizeForRecording" },
    { 0x5F5FBA7A, "demo_svBandwidthLimitThrottleMaxBytesPercent" },
    { 0x6BB613C3, "demo_svBandwidthLimitThrottleTimeout" },
    { 0xEF5D6150, "demo_useCinematicsBuffer" },
    { 0x2A7D534B, "demoname" },
    { 0x1783D2AB, "developer" },
    { 0x9B1A5ADF, "developer_script" },
    { 0xB67B1D0D, "devgui_bot" },
    { 0x605D81B6, "devgui_bot_weapon" },
    { 0x0CA7B9CD, "devgui_dev_cac" },
    { 0xB67B2582, "devgui_dog" },
    { 0x9488D1C1, "devgui_notify" },
    { 0x85E86196, "devgui_tank" },
    { 0xE84C2013, "disableAllTheEliteThings" },
    { 0x95D03C81, "disableHost_matchesHostedRatio" },
    { 0x53839BAC, "disableHost_matchesHostedStreak" },
    { 0x211F6979, "disableHost_matchesPlayedRatio" },
    { 0x48B867A4, "disableHost_matchesPlayedStreak" },
    { 0x54BE814E, "disableLookAtEntityLogic" },
    { 0xFBF5426E, "disable_rope" },
    { 0xFFE0B464, "disable_vcs" },
    { 0x3413A22F, "disable_vcs_viewmodel" },
    { 0x320BAF1F, "disconnected_ctrls" },
    { 0x18CB2AC6, "dlc3_zm_ai_lookAheadAllowBackTrack" },
    { 0x29D5A864, "dlc3_zm_ai_lookAheadAllowRestore" },
    { 0x35A52FE5, "dog_MeleeDamage" },
    { 0x91E9B846, "dog_turn180_angle" },
    { 0x83BC2B16, "dog_turn90_angle" },
    { 0xC1F1399F, "dog_turn_min_goal_dist" },
    { 0x8A6CA03B, "door_breach_weapondrop" },
    { 0xD95E2BA0, "doublescreen" },
    { 0xE54E61D2, "doublesided_raycasts" },
    { 0x0B886BAD, "dtp" },
    { 0xC3C2374B, "dtp_exhaustion_window" },
    { 0xDC52E706, "dtp_fall_damage_max_height" },
    { 0x45A41E44, "dtp_fall_damage_min_height" },
    { 0xB49AFCE4, "dtp_max_apex_duration" },
    { 0xBACD664D, "dtp_max_slide_addition" },
    { 0xBC486287, "dtp_max_slide_duration" },
    { 0xEE594700, "dtp_min_speed" },
    { 0xE905783C, "dtp_new_trajectory" },
    { 0xA5B9CC42, "dtp_new_trajectory_multiplier" },
    { 0xCAAFEDA5, "dtp_post_move_pause" },
    { 0x482810ED, "dtp_startup_delay" },
    { 0x0BCF9209, "dwFileFetchTryIntervalBase" },
    { 0xD9921BF4, "dwFileFetchTryIntervalMax" },
    { 0x70F928A1, "dwFileFetchTryMaxAttempts" },
    { 0xB0C7FD5B, "dwStreamingSendSocketBuffSize" },
    { 0xD0446110, "dwVerboseQosLogging" },
    { 0xBFB4785B, "dw_active" },
    { 0xC4FF0914, "dw_connectafterlogin" },
    { 0xB1224DDF, "dw_defaultDTLSAssociationTimeout" },
    { 0xA3684515, "dw_dupe_key" },
    { 0x88DDE577, "dw_logging_frequency" },
    { 0x8F5FBE36, "dw_logging_last_match_logged" },
    { 0x2EE6E45E, "dw_logging_level_chance" },
    { 0x0D5C32CA, "dw_party_active" },
    { 0x738045D3, "dw_popup" },
    { 0xD6D286C8, "dynEntPieces_angularVelocity" },
    { 0x3A7BBA9C, "dynEntPieces_impactForce" },
    { 0x021F38BE, "dynEntPieces_velocity" },
    { 0x34A1EF0D, "dynEnt_bulletForce" },
    { 0x111B02A5, "dynEnt_damageRadiusScale" },
    { 0x63EF6776, "dynEnt_explodeForce" },
    { 0x18046EE7, "dynEnt_explodeMaxEnts" },
    { 0x6923363A, "dynEnt_explodeMinForce" },
    { 0x5047AC09, "dynEnt_explodeSpinScale" },
    { 0x04E3238B, "dynEnt_explodeUpbias" },
    { 0xA5386AED, "dynEnt_shouldCullEntitiesForSplitscreen" },
    { 0x09DFA667, "dynEnt_spawnedLimit" },
    { 0x57577B9F, "emblemImageUpload" },
    { 0x4624D9D6, "enableERegErrorRecording" },
    { 0xEF943586, "enableJapaneseElite" },
    { 0x849E4E4F, "enableUCDErrorRecording" },
    { 0x8006F08D, "enable_global_wind" },
    { 0x2872A47C, "enable_grass_wind" },
    { 0x00520CBA, "enable_moving_paths" },
    { 0x5FADFED5, "enable_new_prone_check" },
    { 0x129C6F77, "excellentPing" },
    { 0xA3556655, "exp_softclip" },
    { 0x33495B58, "fbEnabled" },
    { 0x6A6328D8, "fixNegativeLosses" },
    { 0x4AEA5EC4, "fixedtime" },
    { 0x095C56F9, "fixedtime_float" },
    { 0xD6D2E02E, "flame_config_valid" },
    { 0x5FC2CC8F, "flame_debug_render" },
    { 0x80A0B5D1, "flame_kick_offset" },
    { 0x289C8C90, "flame_kick_recover_speed" },
    { 0x70CED57B, "flame_kick_speed" },
    { 0x15D6DF09, "flame_render" },
    { 0x90430D58, "flame_system_enabled" },
    { 0xF643E92E, "flame_team_damage" },
    { 0x34725E89, "flame_test" },
    { 0x50EE3C95, "flame_use_dvars" },
    { 0x0E7511C3, "flareDisableEffects" },
    { 0x3BA5817A, "footstep_sounds_cutoff" },
    { 0xE18BB6E3, "friction" },
    { 0xC8EAB592, "fs_basegame" },
    { 0xC8EFA5E5, "fs_basepath" },
    { 0xFC601CD1, "fs_cdpath" },
    { 0x8E023A2B, "fs_copyfiles" },
    { 0x173C1F24, "fs_debug" },
    { 0xC2A65097, "fs_game" },
    { 0x7A2B01F3, "fs_homepath" },
    { 0x1DF81DF8, "fs_ignoreLocalized" },
    { 0xC2068F2D, "fs_restrict" },
    { 0xF0017528, "fs_usedevdir" },
    { 0x6DB4EBAE, "fs_userDocuments" },
    { 0x37132DB9, "fs_usermapdir" },
    { 0xFF0D665C, "fshCustomGameName" },
    { 0x2C509999, "fshElite" },
    { 0x5D5C384D, "fshEnableRender" },
    { 0x2394FF6D, "fshFileDebug" },
    { 0xFE64B1A0, "fshMtxName" },
    { 0x9A9A2054, "fshRecentsXUID" },
    { 0x6FBEB5F2, "fshRenderSuccessURL" },
    { 0x978D15D8, "fshRenderWriteTimeout" },
    { 0x70716EAB, "fshRetryDelay" },
    { 0xDB860EDE, "fshSearchTaskDelay" },
    { 0x5957B9EC, "fshSkipFileStats" },
    { 0xE87E59F4, "fshStaffXuid" },
    { 0xB42A1723, "fshSummaryDelay" },
    { 0xCCE68E67, "fshThrottleEnabled" },
    { 0x53D071D0, "fshThrottleKBytesPerSec" },
    { 0x005977E3, "fx" },
    { 0x9F005509, "fx_enable" },
    { 0x168C2040, "fxfrustumCutoff" },
    { 0x0928994F, "g_FactionName_" },
    { 0x80D3D909, "g_FactionName_Allies" },
    { 0x3399E604, "g_FactionName_Axis" },
    { 0x4114B8B8, "g_ScoresColor_" },
    { 0xD9BE2332, "g_ScoresColor_Allies" },
    { 0xB9E991ED, "g_ScoresColor_Axis" },
    { 0x16A945FD, "g_ScoresColor_EnemyTeam" },
    { 0xB9EC35BA, "g_ScoresColor_Free" },
    { 0xF6AB9AC5, "g_ScoresColor_MyTeam" },
    { 0x3642E36D, "g_ScoresColor_Spectator" },
    { 0x8C58EFD0, "g_TeamColor_" },
    { 0x82854C4A, "g_TeamColor_Allies" },
    { 0xEC239505, "g_TeamColor_Axis" },
    { 0xF498F815, "g_TeamColor_EnemyTeam" },
    { 0x55A326F6, "g_TeamColor_EnemyTeamAlt" },
    { 0xEC2638D2, "g_TeamColor_Free" },
    { 0x9F72C3DD, "g_TeamColor_MyTeam" },
    { 0x2D9ABDBE, "g_TeamColor_MyTeamAlt" },
    { 0x3F69858D, "g_TeamColor_MyTeamAlt_Party" },
    { 0x71992F60, "g_TeamColor_Party" },
    { 0x14329585, "g_TeamColor_Spectator" },
    { 0x204F6C54, "g_TeamIcon_Allies" },
    { 0x5BF22A8F, "g_TeamIcon_Axis" },
    { 0x5BF4CE5C, "g_TeamIcon_Free" },
    { 0x674E314F, "g_TeamIcon_Spectator" },
    { 0x430FA872, "g_TeamName_" },
    { 0x7BC0766C, "g_TeamName_Allies" },
    { 0x1AE9CEA7, "g_TeamName_Axis" },
    { 0x7972D3EA, "g_TeamName_Three" },
    { 0xE8684F57, "g_actorAndVehicleAntilag" },
    { 0x832D22BE, "g_actorAndVehicleAntilagDebug" },
    { 0x7C972B95, "g_ai" },
    { 0xFA2C162D, "g_aiEventDump" },
    { 0x67B97008, "g_allowVote" },
    { 0x942E58E9, "g_avoidEnabled" },
    { 0x06BF71E8, "g_banIPs" },
    { 0xB764C692, "g_broadcastLocalSound" },
    { 0x2C1277E8, "g_compassShowEnemies" },
    { 0xF44B1795, "g_connectpaths" },
    { 0x8D1F0A47, "g_customTeamName_Allies" },
    { 0x4C4BAFC2, "g_customTeamName_Axis" },
    { 0xD710D865, "g_customTeamName_Three" },
    { 0xDEAF3421, "g_customTeamNames" },
    { 0x7C23A76D, "g_debugBullets" },
    { 0xB1AE74B1, "g_debugDamage" },
    { 0x4F3AC40F, "g_debugLocDamage" },
    { 0x5F884C4C, "g_debugLocDamageEntity" },
    { 0xC54FB315, "g_debugLocHit" },
    { 0x7DAE9EA4, "g_debugLocHitTime" },
    { 0xC3BDC4F5, "g_disableDemonwareSubscriptionRefresh" },
    { 0xEE047C4E, "g_disableEliteButton" },
    { 0x08BAEC9C, "g_disableEliteEmblemUploads" },
    { 0x69ED03A1, "g_disableEliteRegistrationPopup" },
    { 0x0898E724, "g_disablePlatformAutofill" },
    { 0x613C0BD9, "g_dumpAnims" },
    { 0xB7B64D0B, "g_dumpAnimsCommands" },
    { 0xE45BFE9E, "g_entinfo" },
    { 0xACA1F7EC, "g_entinfo_AItext" },
    { 0xCA3A1F97, "g_entinfo_maxdist" },
    { 0x2D470745, "g_entinfo_scale" },
    { 0xCB1296BF, "g_entinfo_type" },
    { 0xE7906176, "g_erroronpathsnotconnected" },
    { 0x74682944, "g_fogColorReadOnly" },
    { 0xE1FDE974, "g_fogHalfDistReadOnly" },
    { 0xF7F46A27, "g_fogStartDistReadOnly" },
    { 0x7204F1FD, "g_friendlyNameDist" },
    { 0x8371FC22, "g_friendlyfireDist" },
    { 0x302C4A05, "g_gameEnded" },
    { 0x4F118387, "g_gametype" },
    { 0x240A82FB, "g_ignoreVisData" },
    { 0x9DBECF2F, "g_inactivity" },
    { 0x9725F732, "g_knockback" },
    { 0x78782059, "g_lagged_damage_threshold" },
    { 0x7AB99713, "g_loadScripts" },
    { 0x0F7CCE2D, "g_log" },
    { 0x00A33D8A, "g_logSync" },
    { 0x672A7AE7, "g_logTimeStampInSeconds" },
    { 0xE524BDE0, "g_mantleBlockTimeBuffer" },
    { 0x33FE555C, "g_maxDroppedWeapons" },
    { 0xC377046A, "g_maxERegPopupsShown" },
    { 0xB42D06A6, "g_maxElapsedTime_Before_ERegPopup" },
    { 0x23E0B0A4, "g_minElapsedTime_Before_ERegPopup" },
    { 0xFE302BA9, "g_minElapsedTime_Before_RefreshUCDAccountStatus" },
    { 0x222107B5, "g_minGrenadeDamageSpeed" },
    { 0xC0B1CE53, "g_minNumLogins_Before_ERegPopup" },
    { 0xFF17223F, "g_motd" },
    { 0x4AFC3D2C, "g_no_script_spam" },
    { 0xAC5FC51E, "g_password" },
    { 0x14960A70, "g_quadrotorFlyHeight" },
    { 0x18BB172D, "g_randomSeed" },
    { 0x908BDBA7, "g_redCrosshairs" },
    { 0xFEFF67DF, "g_removeRedundantLinks" },
    { 0x1D657D7E, "g_spawnai" },
    { 0xE2684A3C, "g_speed" },
    { 0x04242108, "g_synchronousClients" },
    { 0xA4C5A666, "g_turretBipodOffset" },
    { 0xC4485CC6, "g_turretServerPitchMax" },
    { 0xC4485DC4, "g_turretServerPitchMin" },
    { 0x11CFCD17, "g_useholdspawndelay" },
    { 0xBA822D92, "g_vehicleDebug" },
    { 0xC2C9D5E6, "g_vehicleDrawPath" },
    { 0x38D19597, "g_vehicleDrawSplines" },
    { 0x52A0EDCF, "g_vehiclePlaneCurveTime" },
    { 0xBA9F6EFD, "gamedate" },
    { 0xBAA4E9E0, "gamename" },
    { 0x5B9D43EF, "geographicalMatchmakingOverride" },
    { 0xF4EDB01C, "goodPing" },
    { 0x5B55E465, "gpad_button_deadzone" },
    { 0x11401BA0, "gpad_button_lstick_deflect_max" },
    { 0xA5C4E866, "gpad_button_rstick_deflect_max" },
    { 0x5BD5EC05, "gpad_buttonsConfig" },
    { 0x47F5D167, "gpad_debug" },
    { 0x7E8C108B, "gpad_enabled" },
    { 0xA2CE9BCC, "gpad_stick_deadzone_max" },
    { 0xA2CE9CCA, "gpad_stick_deadzone_min" },
    { 0x021230D3, "gpad_stick_pressed" },
    { 0x74453BE5, "gpad_stick_pressed_hysteresis" },
    { 0xBE4E7AC7, "gpad_sticksConfig" },
    { 0xE6A14BE7, "grenadeBounceRestitutionMax" },
    { 0xBDDF009D, "grenadeBumpFreq" },
    { 0xA8A9C644, "grenadeBumpMag" },
    { 0xA8A9C655, "grenadeBumpMax" },
    { 0xB6369186, "grenadeCurveMax" },
    { 0x27D8FD59, "grenadeFrictionHigh" },
    { 0x3F44B4AB, "grenadeFrictionLow" },
    { 0xEC2FEFCD, "grenadeFrictionMaxThresh" },
    { 0xBFD92C26, "grenadeRestThreshold" },
    { 0xAE9A851D, "grenadeRollingEnabled" },
    { 0xFC25B8A4, "grenadeWobbleFreq" },
    { 0x9CD05BAC, "grenadeWobbleFwdMag" },
    { 0xDB6F499D, "grenadeWobbleSideDamp" },
    { 0xFEE47DD0, "grenadeWobbleSideMag" },
    { 0x8B93B594, "grenade_indicators_enabled" },
    { 0x6CB34FEF, "groupDownloadInterval" },
    { 0x723A289C, "groupUploadInterval" },
    { 0xFEAB2827, "gts_validation_enabled" },
    { 0x3DE7CA11, "gump_name3" },
    { 0x62147B0A, "gumpgump_name3" },
    { 0x3EB30083, "gumpgumpgump_name3" },
    { 0xA9999A7C, "gumpgumpgumpgump_name3" },
    { 0xDEEB1657, "gunXPGroups" },
    { 0xC12DB9ED, "hatch_mantle_fwd" },
    { 0x3C282E51, "hatch_mantle_up" },
    { 0x0F943F25, "hiDef" },
    { 0xC6C655D4, "highlightedPlayerName" },
    { 0xD5C71324, "hudElemPausedBrightness" },
    { 0xBE391294, "ik_ai_hand_get_data" },
    { 0xE12DF95F, "ik_ai_hand_offset_vec" },
    { 0xDD5BF928, "ik_ai_hand_rotation_vec" },
    { 0x44C2A150, "ik_ai_hand_tuning" },
    { 0x53189835, "ik_ai_pool_size" },
    { 0xF8357753, "ik_ai_range_max" },
    { 0x742FB7BF, "ik_debug" },
    { 0x2AF71E41, "ik_dvar_ai_aim_tracking_rate" },
    { 0xA03BBD67, "ik_dvar_lookatentity_eyes_scale" },
    { 0x5A1B39FE, "ik_dvar_lookatentity_notorso" },
    { 0xF3254B88, "ik_dvar_lookatentity_tracking_rate" },
    { 0x770E773C, "ik_dvar_lookatpos_eyes_scale" },
    { 0x07DB3BF3, "ik_dvar_lookatpos_notorso" },
    { 0x969E313D, "ik_dvar_lookatpos_tracking_rate" },
    { 0xFD1DD89F, "ik_enable" },
    { 0xF5DE80C2, "ik_enable_ai_hand" },
    { 0x7D1A16FC, "ik_enable_ai_terrain" },
    { 0x81D93685, "ik_enable_player_hand" },
    { 0xA27F99DF, "ik_enable_player_terrain" },
    { 0xFA4F340F, "ik_foot_test" },
    { 0x8561AAF2, "ik_hand_test" },
    { 0x9BE9BA0E, "ik_left_hand_lerp_test" },
    { 0x0F741997, "ik_lookatentity_head_scale" },
    { 0x4097CFEC, "ik_lookatpos_head_scale" },
    { 0x477FE38A, "ik_paranoid_matrix_checks" },
    { 0x5235338A, "ik_pelvis_test" },
    { 0x0D42FCD3, "ik_pitch_limit_max" },
    { 0xB9766A7B, "ik_pitch_limit_thresh" },
    { 0xCB1BCDC1, "ik_right_hand_lerp_test" },
    { 0x6A36B5F4, "ik_roll_limit_max" },
    { 0x3B0D9BFC, "ik_roll_limit_thresh" },
    { 0x58D0DAEC, "ik_yaw_limit_max" },
    { 0xEFAD3DF4, "ik_yaw_limit_thresh" },
    { 0x5BC716E4, "in_mouse" },
    { 0x7A726C79, "inviteText" },
    { 0x1F48DCEB, "invite_waitPeriod" },
    { 0x7D3E7879, "jump_height" },
    { 0x55EDBF33, "jump_ladderPushVel" },
    { 0xF5012724, "jump_slowdownEnable" },
    { 0x7656DC68, "jump_spreadAdd" },
    { 0x67905337, "jump_stepSize" },
    { 0x99DBAF6D, "killOnlyTrailFX" },
    { 0x14D0C551, "laggedDamageTagThreshold" },
    { 0x82622996, "lagometer_pos" },
    { 0x0B5B56B2, "lanChallengeResponse" },
    { 0x5A6B41C9, "language" },
    { 0x9E9B0782, "laserAlpha" },
    { 0x9ECD4083, "laserDebug" },
    { 0x1B9A097A, "laserEndOffset" },
    { 0x17DAA304, "laserFadeADS" },
    { 0x5BDDC76D, "laserFlarePct" },
    { 0x1B5378ED, "laserFlarePct_alt" },
    { 0x9CBB1F40, "laserLightBeginOffset" },
    { 0x02D509BE, "laserLightBodyTweak" },
    { 0x5BAE8432, "laserLightEndOffset" },
    { 0x33A5C55C, "laserLightRadius" },
    { 0x71B6D65C, "laserLightRadius_alt" },
    { 0x8732908E, "laserLightRangePlayer" },
    { 0x0DB4EA5A, "laserLightWithoutNightvision" },
    { 0x98D60FA4, "laserRadius" },
    { 0x2F1304A4, "laserRadius_alt" },
    { 0x9FC89749, "laserRange" },
    { 0xF01487D6, "laserRangePlayer" },
    { 0xF59AD6C9, "laserRange_alt" },
    { 0x9D32BEB5, "lbTaskDelay" },
    { 0x7694AD24, "leagueLoserBonus" },
    { 0x2F7BA092, "leagueWinnerBonus" },
    { 0xFFA732BB, "league_defaultPlaylistID" },
    { 0x0B6B62B6, "league_forcePreSeason" },
    { 0xC59F2092, "league_friendsRefetchTime" },
    { 0x21A4F525, "league_historyInfoRefetchTime" },
    { 0x22A97BCB, "league_kickForBadHash" },
    { 0x497FE67C, "league_leaderboardRefetchTime" },
    { 0x2540D00D, "league_teamLeagueInfoRefetchTime" },
    { 0xB42CFE95, "level_notify" },
    { 0xFFCF5728, "liveVideoURLEnv" },
    { 0x318DDC02, "liveVideoURLExpiration" },
    { 0x31C1A9B0, "liveVideoURLParam" },
    { 0xF9C1B153, "liveVideoURLSalt" },
    { 0x713F1456, "liveVideoURLServer" },
    { 0x2CB67789, "liveVoteErrorBackoff" },
    { 0xC858C795, "liveVoteTaskDelay" },
    { 0x3BF95D4E, "live_dedicatedUnparkPingExcellent" },
    { 0x7D3751D0, "live_dedicatedUnparkPingMax" },
    { 0x377DA78C, "live_maxMatchMakingPing" },
    { 0xE8102CBC, "live_maxMostAwesomePing" },
    { 0x54393CCA, "live_minMatchMakingPing" },
    { 0xDA7AD083, "live_readPublisherStorageLocally" },
    { 0xB90DB765, "live_service" },
    { 0x2125DC05, "live_startmatchDeadline" },
    { 0x100B34F0, "live_statscaching" },
    { 0xDB14681B, "live_steamid" },
    { 0xF10FD431, "live_testValue" },
    { 0x49133E68, "live_useActiveFriends" },
    { 0x1B8D3234, "live_useTwitch" },
    { 0x8D33C114, "live_useTwitter" },
    { 0xFC46D5AE, "live_useYouTube" },
    { 0xBEC6A9EA, "livestreamcontrollerneeded" },
    { 0xD8184D7B, "loc_forceEnglish" },
    { 0x7B7CC786, "loc_language" },
    { 0xAC1DDE0B, "loc_warnings" },
    { 0x71B8087C, "loc_warningsAsErrors" },
    { 0xF5DF8EDE, "log_append" },
    { 0x87BF7427, "logfile" },
    { 0x77F155B8, "long_blocking_call" },
    { 0xF30152E7, "lowAmmoWarningColor1" },
    { 0xF30152E8, "lowAmmoWarningColor2" },
    { 0x08618D6E, "lowAmmoWarningNoAmmoColor1" },
    { 0x08618D6F, "lowAmmoWarningNoAmmoColor2" },
    { 0x7BEEB1DB, "lowAmmoWarningNoReloadColor1" },
    { 0x7BEEB1DC, "lowAmmoWarningNoReloadColor2" },
    { 0xD059CC1B, "ls_demoauthor" },
    { 0x0D9C670E, "ls_demoduration" },
    { 0xF05BB80A, "ls_demotitle" },
    { 0x7868B11F, "ls_gametype" },
    { 0x1EBC5F5A, "ls_maplocation" },
    { 0x9B70D482, "ls_mapname" },
    { 0xDDB6EC47, "ls_status" },
    { 0xC2BE7ACB, "lui_checksum_enabled" },
    { 0x80C0A572, "lui_devmode" },
    { 0xE8C278D6, "lui_disable_blur" },
    { 0x1EEB6793, "lui_error_report" },
    { 0x2A326AA1, "lui_error_report_delay" },
    { 0xE52098A5, "lui_timescale" },
    { 0x9A2EEA57, "m_filter" },
    { 0xEE795086, "m_forward" },
    { 0xB00BD629, "m_pitch" },
    { 0x0D1944B6, "m_side" },
    { 0x0FE996C2, "m_yaw" },
    { 0x39A6CD41, "magic_chest_movable" },
    { 0x5B1C0FAC, "mantle_adjustment_tu" },
    { 0xB2BB0509, "mantle_check_angle" },
    { 0x7EF6A72B, "mantle_check_glass_extra_range" },
    { 0x30D66AEA, "mantle_check_radius" },
    { 0xB3E7A1CF, "mantle_check_range" },
    { 0xD743260B, "mantle_check_range_mp" },
    { 0x2CB444EC, "mantle_debug" },
    { 0xC6340B6C, "mantle_enable" },
    { 0xB2BBCFE4, "mantle_view_yawcap" },
    { 0x9C7AC26B, "mantle_weapon_anim_height" },
    { 0x0EEDAB07, "mantle_weapon_height" },
    { 0x0D3BB8DB, "mapcrc" },
    { 0xB4B895C4, "mapname" },
    { 0xFC04EAAF, "matchmaking_debug" },
    { 0x38893B81, "maxLossesValue" },
    { 0xBF1BEDC3, "maxMetPlayerListCount" },
    { 0xB1D02FB5, "maxStatsBackupInterval" },
    { 0xD3DD6600, "maxreservedslots" },
    { 0xEA2590B3, "melee_debug" },
    { 0x99730541, "metPlayerListCleanupInterval" },
    { 0xB79D7BFC, "metPlayerListUpdateInterval" },
    { 0xC9051A1E, "metPlayerListUploadInterval" },
    { 0x238570FF, "mgTurret" },
    { 0x35375A55, "microwave_turret_placement_trace_maxs" },
    { 0x35377B13, "microwave_turret_placement_trace_mins" },
    { 0xBA715225, "microwave_turretplacement_traceOffset" },
    { 0x3DC4221E, "migration_blocksperframe" },
    { 0x0941B7DB, "migration_forceHost" },
    { 0xB50106CD, "migration_limit" },
    { 0xB40EFE3A, "migration_minclientcount" },
    { 0x1F27E31C, "migration_msgtimeout" },
    { 0x89610DDC, "migration_soak" },
    { 0x37E55BA7, "migration_timeBetween" },
    { 0xBF47B3A7, "minDelayForOtherPlayerStatsFetch" },
    { 0xF95FF250, "miniscoreboardhide" },
    { 0x82C26CF2, "missileDroneAccelClimb" },
    { 0x7A672661, "missileDroneAccelDescend" },
    { 0x2D55E2FC, "missileDroneClimbAngleDirect" },
    { 0xA6E860F4, "missileDroneClimbAngleTop" },
    { 0x1D7B92B0, "missileDroneClimbCeilingDirect" },
    { 0xD3A10D28, "missileDroneClimbCeilingTop" },
    { 0xC84228CE, "missileDroneClimbHeightDirect" },
    { 0xF38C2806, "missileDroneClimbHeightTop" },
    { 0xB9F37754, "missileDroneClimbMaxDist" },
    { 0xF4DAFB88, "missileDroneClimbToOwner" },
    { 0x1309AA14, "missileDroneDistSqTargetAvoidanceDisabled" },
    { 0xAC8BE0C8, "missileDroneDistanceAvoidance" },
    { 0xDFEF8263, "missileDroneDistanceAvoidanceSec" },
    { 0x1408E4CA, "missileDroneSpeedLimitClimb" },
    { 0x772AF439, "missileDroneSpeedLimitDescend" },
    { 0x607F07C8, "missileDroneSpeedMin" },
    { 0x7FD4A059, "missileDroneTurnDecel" },
    { 0x74789EEE, "missileDroneTurnMaxRate" },
    { 0x7478D97B, "missileDroneTurnMaxRoll" },
    { 0xF6B286C1, "missileDroneTurnMaxRollChange" },
    { 0x93055786, "missileDroneTurnRateAscent" },
    { 0x09FAECD2, "missileDroneTurnRateAvoidance" },
    { 0x99077A5B, "missileDroneTurnRateDecent" },
    { 0x1770DD53, "missileDroneTurnRateSmallAdjustments" },
    { 0x1E554299, "missileDroneflattenRollRatio" },
    { 0x370075AF, "missileHellfireMaxSlope" },
    { 0xE7E81A43, "missileHellfireUpAccel" },
    { 0x81ED14FB, "missileJavAccelClimb" },
    { 0xEEDBF4AA, "missileJavAccelDescend" },
    { 0x50AAADC5, "missileJavClimbAngleDirect" },
    { 0xA9F6F85D, "missileJavClimbAngleTop" },
    { 0x692E33B9, "missileJavClimbCeilingDirect" },
    { 0xD4B322D1, "missileJavClimbCeilingTop" },
    { 0x56304CB7, "missileJavClimbHeightDirect" },
    { 0x586DAC8F, "missileJavClimbHeightTop" },
    { 0x694FC9D1, "missileJavClimbToOwner" },
    { 0x151AFA73, "missileJavSpeedLimitClimb" },
    { 0x05191822, "missileJavSpeedLimitDescend" },
    { 0x9ED5EB42, "missileJavTurnDecel" },
    { 0xFE39992C, "missileJavTurnRateDirect" },
    { 0xD98C4524, "missileJavTurnRateTop" },
    { 0xA865C45A, "missileMolotovBlobNum" },
    { 0xB5216739, "missileMolotovBlobTime" },
    { 0xB983FBE9, "missilePlantableSize" },
    { 0xB471B19E, "missileTVGuidedBoost" },
    { 0x12BF9927, "missileTVGuidedBoostSpeedDown" },
    { 0x2129CB14, "missileTVGuidedBoostSpeedUp" },
    { 0x963739D4, "missileTVGuidedFlatteningRollAccel" },
    { 0xC3FE1B1A, "missileTVGuidedMPSpecific" },
    { 0xDEB6B29D, "missileTVGuidedMaxRollAngle" },
    { 0xD7477DDF, "missileTVGuidedStickDeadzone" },
    { 0xFD5AABCC, "missileTVGuidedTurnRate" },
    { 0x5A0C59EF, "missileTVGuidedTurningRollAccel" },
    { 0x8531AF79, "missileWaterMaxDepth" },
    { 0x063C6800, "missingCommandWillError" },
    { 0x5BBF66CA, "mortarStrikesLeft" },
    { 0xCD962908, "motdDelay" },
    { 0x536DAE02, "net_broadcast_port" },
    { 0x2911A290, "net_emu_client" },
    { 0x3935BC43, "net_emu_jitter" },
    { 0xE7306441, "net_emu_latency" },
    { 0x69572129, "net_emu_packet_loss" },
    { 0x4DEAB7A8, "net_emu_server" },
    { 0x0FDB62E4, "net_ip" },
    { 0xFC911591, "net_noudp" },
    { 0x74438D70, "net_port" },
    { 0x4DC488D9, "net_socksEnabled" },
    { 0x6FAB64A1, "net_socksPassword" },
    { 0x50F31D33, "net_socksPort" },
    { 0x6079D0C5, "net_socksServer" },
    { 0x55CD55AE, "net_socksUsername" },
    { 0x608C818B, "nextarena" },
    { 0x0B9BB4E2, "nextmap" },
    { 0x2BD6864B, "nightVisionDisableEffects" },
    { 0xFC98B985, "nightVisionFadeInOutTime" },
    { 0x44BAA890, "nightVisionPowerOnTime" },
    { 0x10873CCA, "noclip" },
    { 0x762F1309, "notarget" },
    { 0x4A195B44, "onlinegame" },
    { 0x1273AD6A, "overrideNVGModelWithKnife" },
    { 0x2F9F59D7, "partyMigrate_NomineeRecalcInterval" },
    { 0x6F592102, "partyMigrate_TestInterval" },
    { 0xF44C064F, "partyMigrate_debugEnabled" },
    { 0x529E1EB5, "partyMigrate_disabled" },
    { 0x3FC76E47, "partyMigrate_maxBWPackets" },
    { 0x268AC20E, "party_allowguests" },
    { 0x950A8887, "party_autoteams" },
    { 0x00BFE457, "party_challengeResponseGraceTime" },
    { 0xA29241CB, "party_challengeResponseInterval" },
    { 0xA61D66A5, "party_chanceToFailConnection" },
    { 0x3BE354E3, "party_chooseLowestPingSlot" },
    { 0x7D5F337A, "party_clientTimeout" },
    { 0x21BA7F45, "party_connectTimeout" },
    { 0x2C9D7AB6, "party_connectToOthers" },
    { 0x6BA1D774, "party_connect_dedicated" },
    { 0xE1BA33C4, "party_considerStreamingForHostMigration" },
    { 0x7A5FF17B, "party_debugShowSkill" },
    { 0x41E080BF, "party_dedicatedMergeMinPlayers" },
    { 0x5743B92D, "party_dedicatedOnly" },
    { 0x0BEDF208, "party_disableLockin" },
    { 0x0E8B353D, "party_disconnectPlayerOnJoinFailed" },
    { 0x8FEFF79E, "party_disconnectPlayerOnRemoval" },
    { 0xF57A7969, "party_editingsettings" },
    { 0x96C1504E, "party_firstSubpartyIndex" },
    { 0x3ED325C2, "party_forceMemberUpdateOnVoiceConnectivityBits" },
    { 0x0CC48B26, "party_forceMigrateAfterRound" },
    { 0x8B3F65C5, "party_forceMigrateOnMatchStartRegression" },
    { 0x604CA7DF, "party_gameStartTimerLength" },
    { 0x111850BA, "party_gameStartTimerLengthPrivate" },
    { 0xA8048A29, "party_gamesize" },
    { 0xA8055950, "party_gametype" },
    { 0xD9013353, "party_hostname" },
    { 0x22EE7029, "party_iamhost" },
    { 0x2E821F4D, "party_isPreviousMapVoted" },
    { 0x41331858, "party_joinInProgressAllowed" },
    { 0x0F273337, "party_keepPartyAliveWhileMatchmaking" },
    { 0x3E26FEBB, "party_kickplayerquestion" },
    { 0x36230A8F, "party_leagueValidityGrace" },
    { 0x50EADE5D, "party_linearMapCycle" },
    { 0xE106DA7E, "party_linearMapCycleRandom" },
    { 0x0A2730F8, "party_lobbyExtensionTime" },
    { 0x2BF675A6, "party_localTeamTest" },
    { 0x5710BA93, "party_mapname" },
    { 0x394C14A4, "party_mappacks" },
    { 0x256D4120, "party_matchedPlayerCount" },
    { 0x62583455, "party_maxChangeListDiff" },
    { 0x97ADF730, "party_maxDesperateMigrationTime" },
    { 0xB5C7EEFA, "party_maxMemberUpdateInterval" },
    { 0x3DC0DE73, "party_maxMigrationTime" },
    { 0x7AB48FE5, "party_maxlocalplayers" },
    { 0x9823CDC4, "party_maxlocalplayers_leaguematch" },
    { 0x97638EBA, "party_maxlocalplayers_local_splitscreen" },
    { 0xB9D656E1, "party_maxlocalplayers_mainlobby" },
    { 0xB530D69E, "party_maxlocalplayers_playermatch" },
    { 0x156A03CC, "party_maxlocalplayers_privatematch" },
    { 0xF0883A57, "party_maxlocalplayers_systemlink" },
    { 0x2CE983D1, "party_maxlocalplayers_theater" },
    { 0x9D959247, "party_maxlocalplayers_wagermatch" },
    { 0x383E837A, "party_maxplayers" },
    { 0x5382C8D9, "party_maxplayers_leaguematch" },
    { 0x8B59C58F, "party_maxplayers_local_splitscreen" },
    { 0x50442061, "party_maxplayers_partylobby" },
    { 0x708FD1B3, "party_maxplayers_playermatch" },
    { 0x3CA86181, "party_maxplayers_privatematch" },
    { 0x05B9A6CC, "party_maxplayers_systemlink" },
    { 0x4F243C66, "party_maxplayers_theater" },
    { 0xB2C6FEBC, "party_maxplayers_wagermatch" },
    { 0x13223BD7, "party_maxplayers_wagerpartylobby" },
    { 0x8623E887, "party_memberUpdateBackoffRate" },
    { 0xA9C00C96, "party_membersMissingMapPack" },
    { 0x111B9328, "party_mergingEnabled" },
    { 0x422C51CF, "party_mergingJitter" },
    { 0x4D220AAA, "party_migrateRestTime" },
    { 0x4FFB805F, "party_minLobbyTime" },
    { 0x20A87AF8, "party_minMemberUpdateInterval" },
    { 0xBAEBB6E9, "party_minResumeMs" },
    { 0xA18FBAB8, "party_minplayers" },
    { 0xD046D605, "party_neverJoinRecent" },
    { 0xDF031A6A, "party_playerCount" },
    { 0x549FBE4F, "party_playervisible" },
    { 0xA0092066, "party_pregameStartTimerLength" },
    { 0x37D50B61, "party_pregameStartTimerLengthPrivate" },
    { 0x5D5477F5, "party_readyAllowOnlyLocalPlayers" },
    { 0x8A67EAB3, "party_readyButtonVisible" },
    { 0x2D136C7B, "party_readyPercentRequired" },
    { 0xBA8E9E9B, "party_reconnectToClientOnTimeout" },
    { 0xF6B8859A, "party_reconnectToHostOnTimeout" },
    { 0x1BC1FCAF, "party_requestMigrateDuringAutoStartIfStreaming" },
    { 0x3B83D87E, "party_restartMatchmakingTimer" },
    { 0xB7E588EF, "party_searchInterval" },
    { 0xD77122C9, "party_sequentialPreviousMapVotingAllowed" },
    { 0xE318377B, "party_simulateLongQoS" },
    { 0x3452EC2C, "party_skillAllowancePerSecond" },
    { 0xCE14BB4F, "party_skillBaseDifferenceAllowance" },
    { 0xA586B699, "party_subSearchInterval" },
    { 0x686D095C, "party_teamSwitchDelay" },
    { 0x1D3BB0C3, "party_theaterTimeoutWhenLoaded" },
    { 0xC4B1DBD8, "party_theaterTimeoutWhenLoading" },
    { 0x78EB86DC, "party_vetoButtonVisible" },
    { 0x0FD90650, "party_vetoDelayTime" },
    { 0x39DF6372, "party_vetoPassed" },
    { 0xCAEEB6E4, "party_vetoPercentRequired" },
    { 0x9CA3B333, "partyend_reason" },
    { 0x247FD890, "partymigrate_HostWaitMS" },
    { 0x8D7A9CFF, "partymigrate_MaxPacketWaitTime" },
    { 0x64302BF6, "partymigrate_MinScoreDiff" },
    { 0xB95AC71D, "partymigrate_NomineeWaitMS" },
    { 0x8B54E51C, "partyprober_chanceToFailAssociation" },
    { 0xC98AEE69, "partyprober_chanceToFailSend" },
    { 0x17F6DC38, "password" },
    { 0xAF7AE8C8, "pc_newversionavailable" },
    { 0x1D605895, "pclive_updateFriends" },
    { 0x779B8FF7, "penetrationCount" },
    { 0xAFA96030, "penetrationCount_allies" },
    { 0x4945776B, "penetrationCount_axis" },
    { 0x4ED23E88, "perk_armorPiercing" },
    { 0xE394558E, "perk_blackbirdShowsGpsJammer" },
    { 0x738E704E, "perk_bulletPenetrationMultiplier" },
    { 0xDA125E04, "perk_damageKickReduction" },
    { 0x25E82970, "perk_deathStreakCountRequired" },
    { 0xAACD4273, "perk_delayExplosiveTime" },
    { 0x773B1EE4, "perk_disarmExplosiveTime" },
    { 0x813107E0, "perk_dogsAttackGhost" },
    { 0xD1CABD70, "perk_extraBreath" },
    { 0x9298991E, "perk_fastLadderClimbMultiplier" },
    { 0xDED1B162, "perk_fireproof" },
    { 0x24C240A6, "perk_flakJacket" },
    { 0x5317A62D, "perk_flakJacket_hardcore" },
    { 0x71C54201, "perk_gpsjammer_alpha" },
    { 0xF3A54EF9, "perk_gpsjammer_fade_time" },
    { 0x1C81E2F3, "perk_gpsjammer_graceperiods" },
    { 0x0E39D2C9, "perk_gpsjammer_min_distance" },
    { 0x7A4A1F4F, "perk_gpsjammer_min_speed" },
    { 0xEC6135EC, "perk_gpsjammer_time_period" },
    { 0xB9DDD532, "perk_grenadeDeath" },
    { 0x5DF05B07, "perk_grenadeTossBackTimer" },
    { 0xC55B3BC4, "perk_healthRegenMultiplier" },
    { 0x7104C528, "perk_interactSpeedMultiplier" },
    { 0x0AB51496, "perk_killstreakDeathPenaltyMultiplier" },
    { 0x37067E05, "perk_killstreakMomentumMultiplier" },
    { 0x9159E179, "perk_killstreakReduction" },
    { 0x083502A4, "perk_mantleReduction" },
    { 0xB081EAF6, "perk_marksmanEnemyNameFadeIn" },
    { 0xC0BF6497, "perk_marksmanEnemyNameFadeOut" },
    { 0xDC453540, "perk_nottargetedbyai_graceperiod" },
    { 0x38B8120F, "perk_nottargetedbyai_min_speed" },
    { 0x7665A2A1, "perk_scavenger_clip_multiplier" },
    { 0xE1ED1600, "perk_scavenger_lethal_proc" },
    { 0x02E81D2B, "perk_scavenger_tactical_proc" },
    { 0x4E723AB3, "perk_shellShockReduction" },
    { 0x2948EA4E, "perk_speedMultiplier" },
    { 0xF5E3419D, "perk_sprintMultiplier" },
    { 0x2928426C, "perk_sprintRecoveryMultiplier" },
    { 0xBBEF7FFF, "perk_throwbackInnerRadius" },
    { 0x1C43F3E2, "perk_weapAdsMultiplier" },
    { 0xA76EAC6F, "perk_weapEquipmentUseMultiplier" },
    { 0x8162B4B2, "perk_weapMeleeMultiplier" },
    { 0x80AA3A76, "perk_weapRateMultiplier" },
    { 0x651CF261, "perk_weapReloadMultiplier" },
    { 0xBF2ECA49, "perk_weapSpreadMultiplier" },
    { 0x3ECBE23C, "perk_weapSwitchMultiplier" },
    { 0x687BBEF3, "perk_weapTossMultiplier" },
    { 0xC86EC0F2, "phys_buoyancy" },
    { 0x3C493F44, "phys_buoyancyDistanceCutoff" },
    { 0xE9A47F08, "phys_buoyancyFloatHeightOffset" },
    { 0x05E74F9A, "phys_disableEntsAndDynEntsCollision" },
    { 0xE3D0F1EE, "phys_gravity" },
    { 0x65EA084C, "phys_gravity_dir" },
    { 0x90BC2F76, "phys_impact_distance_cutoff" },
    { 0xB8C52523, "phys_impact_fx" },
    { 0x8E9BCAAA, "phys_impact_intensity_limit" },
    { 0x904E7AD3, "phys_maxFloatTime" },
    { 0xEF7F85DC, "phys_piecesSpawnDistanceCutoff" },
    { 0x0B55A136, "phys_ragdoll_buoyancy" },
    { 0xBF9F7ADE, "phys_vehicleDamageFroceScale" },
    { 0x34BF14F5, "phys_vehicleGravityMultiplier" },
    { 0xD4BF00A6, "phys_vehicleWheelEntityCollision" },
    { 0x6B585811, "pickupPrints" },
    { 0xF4AE66C6, "playerPushAmount" },
    { 0x630648DA, "player_MGUseRadius" },
    { 0x81D3E7B2, "player_adsExitDelay" },
    { 0xAC07B120, "player_animRunThreshhold" },
    { 0x9698F3FA, "player_animWalkThreshhold" },
    { 0x33016B9B, "player_backSpeedScale" },
    { 0x0959566A, "player_bayonetLaunchDebugging" },
    { 0x882C4124, "player_bayonetLaunchProof" },
    { 0x232D5B2C, "player_bayonetLaunchZCap" },
    { 0x5A4CE110, "player_bayonetRange" },
    { 0x695C3F1E, "player_bayonetTargetDist" },
    { 0x7A80B5BA, "player_breath_fire_delay" },
    { 0x5DC3BAA3, "player_breath_gasp_lerp" },
    { 0x16B85958, "player_breath_gasp_scale" },
    { 0x5DC82DFF, "player_breath_gasp_time" },
    { 0x87043F1F, "player_breath_hold_lerp" },
    { 0x8708B27B, "player_breath_hold_time" },
    { 0x28F65399, "player_breath_snd_delay" },
    { 0xABECD2FD, "player_breath_snd_lerp" },
    { 0x02679ADB, "player_clipSizeMultiplier" },
    { 0x60DDBAAE, "player_debugHealth" },
    { 0x7B56CC18, "player_debugSprint" },
    { 0x8920799F, "player_disableWeaponsOnVehicle" },
    { 0x32FC2BCC, "player_dmgtimer_flinchTime" },
    { 0x72B4329E, "player_dmgtimer_maxTime" },
    { 0x19A34195, "player_dmgtimer_minScale" },
    { 0xBD6FC894, "player_dmgtimer_stumbleTime" },
    { 0x0BF841A9, "player_dmgtimer_timePerPoint" },
    { 0x63315A9D, "player_enableShuffleAnims" },
    { 0xCC0FE69F, "player_enduranceSpeedScale" },
    { 0x36022BAD, "player_footstepsThreshhold" },
    { 0x3404D3A9, "player_forceRedCrosshair" },
    { 0xBABB8D64, "player_knockbackMoveThreshhold" },
    { 0x661A27E2, "player_lastStandBleedoutTime" },
    { 0xA148FFD0, "player_lastStandBleedoutTimeNoRevive" },
    { 0x30BB6D26, "player_lastStandHealthOverlayTime" },
    { 0x51BB033F, "player_lean_rotate" },
    { 0x1B260EA2, "player_lean_rotate_crouch" },
    { 0x7EA7234E, "player_lean_shift" },
    { 0x1909A7D1, "player_lean_shift_crouch" },
    { 0x24C8C560, "player_lookAtEntityAllowChildren" },
    { 0x94141FF8, "player_meleeCalcSpeedFromTarget" },
    { 0x28BDB281, "player_meleeChargeFriction" },
    { 0xA609217A, "player_meleeChargeMaxSpeed" },
    { 0x3FEF08B2, "player_meleeHeight" },
    { 0x1CB54BC2, "player_meleeInterruptFrac" },
    { 0x02A2D146, "player_meleeRange" },
    { 0x030185F9, "player_meleeWidth" },
    { 0x19923F1D, "player_moveThreshhold" },
    { 0x5B284F38, "player_move_factor_on_torso" },
    { 0x364DE272, "player_name" },
    { 0x101A31CA, "player_revivePlayerListCycleTime" },
    { 0x327BA51E, "player_reviveTriggerRadius" },
    { 0x8AAA39DB, "player_runThreshhold" },
    { 0xA89BB4A8, "player_runbkThreshhold" },
    { 0x33021F61, "player_scopeExitOnDamage" },
    { 0xFEFF847E, "player_slick_accel" },
    { 0x3968A6A4, "player_slick_invspeed" },
    { 0x27A75DD2, "player_slick_wishspeed" },
    { 0xF72C9158, "player_sliding_friction" },
    { 0x1B029E5C, "player_sliding_velocity_cap" },
    { 0x58137F06, "player_sliding_wishspeed" },
    { 0xFBAC4900, "player_slopeAnimAngle" },
    { 0x1C321603, "player_spectateSpeedScale" },
    { 0x98E9126D, "player_sprintCameraBob" },
    { 0xBA5486E2, "player_sprintForwardMinimum" },
    { 0xB2A6B6C4, "player_sprintMinTime" },
    { 0xD295E7F0, "player_sprintRechargePause" },
    { 0x488E3CEA, "player_sprintSpeedScale" },
    { 0xF683C80F, "player_sprintStrafeSpeedScale" },
    { 0xCA4662C6, "player_sprintThreshhold" },
    { 0xEEDBF8C0, "player_sprintTime" },
    { 0x85056D7C, "player_sprintUnlimited" },
    { 0x357C3ABD, "player_standingViewHeight" },
    { 0x930AA0C7, "player_strafeAnimCosAngle" },
    { 0x02AA1E0F, "player_strafeSpeedScale" },
    { 0x7711B3C2, "player_sustainAmmo" },
    { 0xEB2C2590, "player_swimDamage" },
    { 0xF982BF27, "player_swimDamagerInterval" },
    { 0xC8C5B700, "player_swimTime" },
    { 0xC4FA62BA, "player_throwbackInnerRadius" },
    { 0xBC5B402D, "player_throwbackOuterRadius" },
    { 0x45AD9153, "player_throwbackOuterRadius_zm" },
    { 0x33418672, "player_turnAnims" },
    { 0xEFD45FA6, "player_useRadius" },
    { 0x03C8AA2C, "player_useRadius_zm" },
    { 0x989E32FC, "player_viewLockEnt" },
    { 0x17DE0520, "player_viewRateScale" },
    { 0xF0911DBA, "player_view_pitch_down" },
    { 0x1D9B0EE7, "player_view_pitch_up" },
    { 0xCAE178ED, "player_waterSpeedScale" },
    { 0x2E121A78, "player_zombieMeleeHeight" },
    { 0x4027C24C, "player_zombieMeleeRange" },
    { 0x408676FF, "player_zombieMeleeWidth" },
    { 0xE1B103F0, "player_zombieSpeedScale" },
    { 0xFA215A70, "player_zombieSprintSpeedScale" },
    { 0xFB5A0D45, "playlist_allowdevmaps" },
    { 0xF4162161, "playlist_enabled" },
    { 0x6D1108E8, "playlist_entry" },
    { 0x10397B3C, "playlist_excludeGametype" },
    { 0x952E5E5A, "playlist_excludeGametypeMap" },
    { 0x12B8E33E, "playlist_excludeMap" },
    { 0xF3CF0035, "playlist_next" },
    { 0x2E8668E8, "popInLetterFXTime" },
    { 0xD58724EF, "probation_league_enabled" },
    { 0x2BFC883F, "probation_league_forgiveCount" },
    { 0x1FD3A269, "probation_league_kickcalar" },
    { 0x506F5A7B, "probation_league_matchHistoryWindow" },
    { 0xAE92735F, "probation_league_probationThreshold" },
    { 0x87400001, "probation_league_probationTime" },
    { 0x0C24A25D, "probation_league_quitScalar" },
    { 0xAFE7FAC1, "probation_league_timeoutScalar" },
    { 0xA08F2E47, "probation_league_warningThreshold" },
    { 0x6AC3DB9B, "probation_public_enabled" },
    { 0x82D24A6B, "probation_public_forgiveCount" },
    { 0xFFA016A8, "probation_public_kickScalar" },
    { 0x90110DA7, "probation_public_matchHistoryWindow" },
    { 0xEE34268B, "probation_public_probationThreshold" },
    { 0xB8CE07AD, "probation_public_probationTime" },
    { 0xCC0BE989, "probation_public_quitScalar" },
    { 0xE176026D, "probation_public_timeoutScalar" },
    { 0x13922673, "probation_public_warningThreshold" },
    { 0x7ED35038, "probation_version" },
    { 0x2737A487, "profileDirtyInterval" },
    { 0xBAA3771C, "prone_bipod_enable" },
    { 0x2B4DC497, "protocol" },
    { 0xC15079F5, "ps3Game" },
    { 0xB9D5B614, "qosMaxAllowedPing" },
    { 0xAF9305E5, "qosPreferredPing" },
    { 0x0035DC6D, "quit_on_error" },
    { 0xF55836AD, "r_aaSamples" },
    { 0x34553033, "r_aaSamplesMax" },
    { 0x47E6823A, "r_alphaMap" },
    { 0x3033F08E, "r_anaglyphFX_enable" },
    { 0x50898175, "r_aspectRatio" },
    { 0x3783FECD, "r_aspectRatioWindow" },
    { 0xB77B2116, "r_autoLodScale" },
    { 0x5ADAF0D1, "r_autopriority" },
    { 0x040B36A6, "r_blinkCullNone" },
    { 0x2C878E96, "r_blinkLayers" },
    { 0x6C53817D, "r_blinkLitQuasiOpaque" },
    { 0x4F86874E, "r_blinkTrans" },
    { 0x00E4F489, "r_bloomHiQuality" },
    { 0x81D4D99E, "r_bloomTweaks" },
    { 0x18B9CC6B, "r_blur" },
    { 0xE897EA4F, "r_brightness" },
    { 0x96D55CB9, "r_brushLimit" },
    { 0xC8F3B4BC, "r_clearColor" },
    { 0xE76A4C6E, "r_clearColor2" },
    { 0x25A69CBC, "r_clipCodec" },
    { 0x4652B747, "r_clipFPS" },
    { 0x10B0A499, "r_clipSize" },
    { 0x87111DA0, "r_cmdbuf_worker" },
    { 0xFE8C3DB3, "r_colorMap" },
    { 0x0390D8C4, "r_contrast" },
    { 0xA7041A45, "r_convergence" },
    { 0x738EBD94, "r_cubicUpsampleParam" },
    { 0xA9D8DF01, "r_currentMonitor" },
    { 0x7D344216, "r_customMode" },
    { 0xE0AE7105, "r_debugMetalStorm" },
    { 0x1EF61AAF, "r_debugPerformance" },
    { 0x3E396234, "r_debugShader" },
    { 0x6BBD9273, "r_debugShowCoronas" },
    { 0xDCE826CE, "r_debugShowDynamicLights" },
    { 0x4A60B6ED, "r_debugShowPrimaryLights" },
    { 0xC141A400, "r_defaultMode" },
    { 0xE1092E29, "r_desaturation" },
    { 0xE9D9108D, "r_disableGenericFilter" },
    { 0xEDED1E11, "r_dlightLimit" },
    { 0x36B1A874, "r_dobjLimit" },
    { 0x3336D70D, "r_dofHDR" },
    { 0xDBA4BFAD, "r_dof_bias" },
    { 0x5F2D1955, "r_dof_enable" },
    { 0x74AB139C, "r_dof_farBlur" },
    { 0x60A062DE, "r_dof_farEnd" },
    { 0x0B453615, "r_dof_farStart" },
    { 0x79795549, "r_dof_nearBlur" },
    { 0xE4A6A2EB, "r_dof_nearEnd" },
    { 0xA9DBAD62, "r_dof_nearStart" },
    { 0xF550DA16, "r_dof_showdebug" },
    { 0x518A2ACA, "r_dof_tweak" },
    { 0x6E57EB31, "r_dof_viewModelEnd" },
    { 0x65001F28, "r_dof_viewModelStart" },
    { 0xB9CA4325, "r_dpvs_useCellForceInvisibleBits" },
    { 0xC1D9AB4B, "r_drawDebugFogParams" },
    { 0xFBDCB497, "r_drawLightmapDrawlists" },
    { 0xE31F8D0A, "r_drawLitDrawlists" },
    { 0xCD92C247, "r_drawWater" },
    { 0xB9ADA04E, "r_dualPlayActive" },
    { 0xC3BEC619, "r_dualPlayEnable" },
    { 0x97929F1B, "r_dualPlayTestCount" },
    { 0x6EB3AB6A, "r_enableCubicUpsample" },
    { 0xCB838423, "r_enableFlashlight" },
    { 0x98D0F001, "r_enableOccluders" },
    { 0x7F5AF570, "r_enablePlayerShadow" },
    { 0x30FB6E0D, "r_exposureTweak" },
    { 0x3113AF0E, "r_exposureValue" },
    { 0x73612A63, "r_extracam_custom_aspectratio" },
    { 0xB97D3050, "r_extracam_lod_scale" },
    { 0x2676B233, "r_filmLut" },
    { 0xE64F5AD3, "r_filmTweakBrightness" },
    { 0x2A5ECFAD, "r_filmTweakDesaturation" },
    { 0xFCA2DF41, "r_filmTweakEnable" },
    { 0x06031352, "r_filmTweakInvert" },
    { 0x2D8A998F, "r_filmTweakLut" },
    { 0xCF79E67A, "r_filmUseTweaks" },
    { 0xDAB558F6, "r_finalShiftX" },
    { 0xDAB558F7, "r_finalShiftY" },
    { 0xD78A9C21, "r_flameFX_FPS" },
    { 0xB760648E, "r_flameFX_distortionScaleFactor" },
    { 0x59BFFCEE, "r_flameFX_fadeDuration" },
    { 0x046752B6, "r_flameFX_magnitude" },
    { 0xF462DA95, "r_flameScaler" },
    { 0xA3191622, "r_flame_allowed" },
    { 0x433F7FA3, "r_flashLightBobAmount" },
    { 0x8F065CBB, "r_flashLightBobRate" },
    { 0x40FBB875, "r_flashLightBrightness" },
    { 0x9501CF9B, "r_flashLightColor" },
    { 0x752FC99B, "r_flashLightEndRadius" },
    { 0xFF9FF7B0, "r_flashLightFlickerAmount" },
    { 0x70DF6D88, "r_flashLightFlickerRate" },
    { 0x2BF09A59, "r_flashLightFovInnerFraction" },
    { 0x50939383, "r_flashLightOffset" },
    { 0x96099949, "r_flashLightRange" },
    { 0x9B36BF55, "r_flashLightShadows" },
    { 0xC3E6A2E3, "r_flashLightSpecularScale" },
    { 0x5CC52352, "r_flashLightStartRadius" },
    { 0x1043C232, "r_fog" },
    { 0x60D5E681, "r_fogBaseDist" },
    { 0xF6F02606, "r_fogBaseHeight" },
    { 0xB6CD2391, "r_fogColor" },
    { 0xDA1EDFE1, "r_fogHalfDist" },
    { 0xE65CF766, "r_fogHalfHeight" },
    { 0x3BE6948B, "r_fogOpacity" },
    { 0x08F9E0C7, "r_fogSunColor" },
    { 0x0965EEA4, "r_fogSunInner" },
    { 0xCC377741, "r_fogSunOpacity" },
    { 0x09D671D7, "r_fogSunOuter" },
    { 0x09E1F580, "r_fogSunPitch" },
    { 0xB631F459, "r_fogSunYaw" },
    { 0xB805078E, "r_fogTweak" },
    { 0x6CA71B05, "r_fog_disable" },
    { 0x89AC5D21, "r_fontResolution" },
    { 0x0DA54081, "r_forceCameraHdg" },
    { 0xC250C9B4, "r_forceCameraNode" },
    { 0xA249616D, "r_forceCamerarecord" },
    { 0xD07066A4, "r_forceLod" },
    { 0x7A70AC47, "r_fullPrepass" },
    { 0x8DBA54A9, "r_fullbright" },
    { 0xB4577E49, "r_fullscreen" },
    { 0x18BC2E56, "r_fxaa" },
    { 0xC9E32424, "r_genericSceneVector0" },
    { 0xC9E32425, "r_genericSceneVector1" },
    { 0xC9E32426, "r_genericSceneVector2" },
    { 0xC9E32427, "r_genericSceneVector3" },
    { 0x3260753A, "r_genericSceneVector_debug" },
    { 0xCFED433C, "r_glossMap" },
    { 0x3157F17D, "r_grassEnable" },
    { 0xE2EC341E, "r_grassWindForceEnable" },
    { 0xADB4B524, "r_heroLightScale" },
    { 0xE8A6ACFA, "r_heroLighting" },
    { 0x2234C8C9, "r_highLodDist" },
    { 0x123A877C, "r_ignorehwgamma" },
    { 0x8C662FD3, "r_lightConflicts" },
    { 0x04CC2FA2, "r_lightGridContrast" },
    { 0x0D225A6A, "r_lightGridEnableTweaks" },
    { 0x179C52DB, "r_lightGridIntensity" },
    { 0x42123026, "r_lightMapFilterDisable" },
    { 0x7D96A674, "r_lightMapSecondary" },
    { 0xD717740A, "r_lightTweakAmbient" },
    { 0x9271BC69, "r_lightTweakAmbientColor" },
    { 0xDA0F9ABF, "r_lightTweakSunColor" },
    { 0x1E89EEE5, "r_lightTweakSunDiffuseColor" },
    { 0xDA7A2601, "r_lightTweakSunDirection" },
    { 0xDAAF16D8, "r_lightTweakSunLight" },
    { 0x296FBFA6, "r_lightmapOnlyBspSurfs" },
    { 0x76A6B108, "r_lightmapOnlyEntSurfs" },
    { 0x6A02A845, "r_lightmapOnlySModelSurfs" },
    { 0x87E608D4, "r_loadForRenderer" },
    { 0x752B8F54, "r_loadingScreen" },
    { 0x01AF2E58, "r_lockPvs" },
    { 0xB2CAF0CA, "r_lockPvsInCode" },
    { 0xAF42F0C3, "r_lodBiasRigid" },
    { 0xDD8DE260, "r_lodBiasSkinned" },
    { 0xE8E33AAC, "r_lodScaleRigid" },
    { 0x00684A89, "r_lodScaleSkinned" },
    { 0x3A736B3D, "r_lodscale" },
    { 0x2F36403B, "r_lowLodDist" },
    { 0x7D2E26A7, "r_lowestLodDist" },
    { 0x81E8DB50, "r_materialXYZ" },
    { 0x80806AEA, "r_mediumLodDist" },
    { 0x57474CD7, "r_missile_cam_debug_display" },
    { 0x18BFDF1B, "r_mode" },
    { 0x30BBC2AC, "r_mode1" },
    { 0x30BBC2AD, "r_mode2" },
    { 0x891A7326, "r_modelLimit" },
    { 0x1F37B307, "r_modelVertColor" },
    { 0x4F6F6FFE, "r_monitor" },
    { 0x91297707, "r_monitorCount" },
    { 0x07516E8D, "r_multiGpu" },
    { 0xB46FD69B, "r_multi_extracam_debug" },
    { 0x4A8C3418, "r_noipak" },
    { 0x87204F02, "r_norefresh" },
    { 0x996BEEFD, "r_normalMap" },
    { 0x23140C58, "r_num_viewports" },
    { 0xEFBD9983, "r_occlusionMap" },
    { 0x7EBF2447, "r_open_automate" },
    { 0x05EE08D3, "r_outdoorAwayBias" },
    { 0x956C11B9, "r_outdoorDownBias" },
    { 0x19022C01, "r_outdoorFeather" },
    { 0x4EC69C58, "r_picmip" },
    { 0x337CE88B, "r_picmip_bump" },
    { 0x1E98BAB5, "r_picmip_manual" },
    { 0x338624A2, "r_picmip_spec" },
    { 0xE2319926, "r_poisonFX_blurMax" },
    { 0xE2319A24, "r_poisonFX_blurMin" },
    { 0xABF38118, "r_poisonFX_debug_enable" },
    { 0xE6C1015F, "r_poisonFX_dvisionX" },
    { 0x0318BD34, "r_poisonFX_pulse" },
    { 0x312CCC5A, "r_portalMinRecurseDepth" },
    { 0x6D141C16, "r_portalWalkLimit" },
    { 0xE43FEB66, "r_previousFullscreen" },
    { 0x29DB0183, "r_primaryLightTweakDiffuseStrength" },
    { 0x0B25E37C, "r_primaryLightTweakSpecularStrength" },
    { 0x86138A2E, "r_primaryLightUseTweaks" },
    { 0x0EFA34CF, "r_qrcode_debug_display" },
    { 0xB14E8469, "r_qrcode_debug_display_size" },
    { 0xF7B30924, "r_reflectionProbeGenerate" },
    { 0x70620FE0, "r_remotescreen_renderlastframe" },
    { 0xC812E1FD, "r_resampleScene" },
    { 0xEABD8BEA, "r_resolution" },
    { 0xA9A7634B, "r_reviveFX_debug" },
    { 0xBED8002D, "r_reviveFX_edgeAmount" },
    { 0x3CC9ACEE, "r_reviveFX_edgeColorTemp" },
    { 0x44EB9187, "r_reviveFX_edgeContrast" },
    { 0xB8B84D10, "r_reviveFX_edgeMaskAdjust" },
    { 0xDEFC9460, "r_reviveFX_edgeOffset" },
    { 0xE67699A3, "r_reviveFX_edgeSaturation" },
    { 0x0ECA6D21, "r_reviveFX_edgeScale" },
    { 0x3B81A865, "r_rimIntensity" },
    { 0x93BE58EB, "r_rimIntensity_debug" },
    { 0x80831B9E, "r_scaleViewport" },
    { 0x3CF504F4, "r_seethru_decal_enable" },
    { 0x84E53235, "r_shaderDebugA" },
    { 0x84E53236, "r_shaderDebugB" },
    { 0x84E53237, "r_shaderDebugC" },
    { 0xCFE68842, "r_shaderWarming" },
    { 0x46ECCE34, "r_shaderWarmingPerFrame" },
    { 0xCB593133, "r_shader_constant_set_debug_range" },
    { 0x6A53E647, "r_shader_constant_set_enable" },
    { 0x6932CCC2, "r_showForcedInvisibleCells" },
    { 0x89A92F15, "r_showLightGrid" },
    { 0x640A2888, "r_showLightingOrigins" },
    { 0xF264B36F, "r_showMissingLightGrid" },
    { 0x98404922, "r_showOutdoorVolumeDebug" },
    { 0x2116BBC0, "r_showPenetration" },
    { 0xA258F580, "r_showReflectionProbeSelection" },
    { 0x14985435, "r_showSunDirectionDebug" },
    { 0xBA73E6B8, "r_singleCell" },
    { 0xC68B7557, "r_skinnedCacheOverflowLodMaxScale" },
    { 0x48916EF7, "r_skinnedCacheOverflowLodScaleDecay" },
    { 0x13A18606, "r_skipPvs" },
    { 0x88CEF962, "r_skyColorTemp" },
    { 0x4302F51D, "r_skyRotation" },
    { 0xD29EFD78, "r_skyTransition" },
    { 0xF815F309, "r_sky_intensity_angle0" },
    { 0xF815F30A, "r_sky_intensity_angle1" },
    { 0x5D20A801, "r_sky_intensity_factor0" },
    { 0x5D20A802, "r_sky_intensity_factor1" },
    { 0x237F0D10, "r_sky_intensity_showDebugDisplay" },
    { 0x177D74BF, "r_smp_worker" },
    { 0x193BC186, "r_smp_worker_thread0" },
    { 0x193BC187, "r_smp_worker_thread1" },
    { 0x193BC188, "r_smp_worker_thread2" },
    { 0x193BC189, "r_smp_worker_thread3" },
    { 0x193BC18A, "r_smp_worker_thread4" },
    { 0x193BC18B, "r_smp_worker_thread5" },
    { 0x193BC1C9, "r_smp_worker_threads" },
    { 0x416B48FB, "r_sortBackToFront" },
    { 0x1665AE24, "r_sortDrawSurfsBsp" },
    { 0x3CF4A8B8, "r_sortDrawSurfsStaticModel" },
    { 0x20D69B73, "r_specularMap" },
    { 0xA160548A, "r_spotLightEntityShadows" },
    { 0x45F8ADD1, "r_spotLightSModelShadows" },
    { 0x5ED10B2D, "r_spotLightShadows" },
    { 0x18C33A0C, "r_ssao" },
    { 0xDCE0E8CB, "r_ssaoBias" },
    { 0x79200693, "r_ssaoDebug" },
    { 0x59DB0DB3, "r_ssaoIntensity" },
    { 0xBD8197B4, "r_ssaoRadius" },
    { 0x7A2E57F4, "r_ssaoScale" },
    { 0x7D7B97C0, "r_stereo3DAvailable" },
    { 0xF4A656B8, "r_stereo3DEyeSeparation" },
    { 0xD0E24492, "r_stereo3DEyeSeparationScaler" },
    { 0x3CEFE35C, "r_stereo3DIPD" },
    { 0xDAEE7C84, "r_stereo3DMode" },
    { 0xAC8364BC, "r_stereo3DOn" },
    { 0xF50495DD, "r_stereoFocusDepth" },
    { 0x6D1CCED0, "r_stereoGunShift" },
    { 0xF809BF2C, "r_stereoTurretShift" },
    { 0x7B03E923, "r_streamDumpDistance" },
    { 0xE1FD5615, "r_sunFlareTint" },
    { 0xC6E00DDE, "r_sun_from_dvars" },
    { 0x29DFD2BD, "r_sun_fx_position" },
    { 0x71EBD5DB, "r_sunblind_fadein" },
    { 0xAF66AC1C, "r_sunblind_fadeout" },
    { 0x47B5AEC0, "r_sunblind_max_angle" },
    { 0x4485C66E, "r_sunblind_max_darken" },
    { 0xA7FDF63E, "r_sunblind_min_angle" },
    { 0xD3985B3C, "r_sunflare_fadein" },
    { 0x46A3DD9D, "r_sunflare_fadeout" },
    { 0xA3045180, "r_sunflare_max_alpha" },
    { 0xA3054481, "r_sunflare_max_angle" },
    { 0xBF28FC95, "r_sunflare_max_size" },
    { 0x034D8BFF, "r_sunflare_min_angle" },
    { 0x0FA74C53, "r_sunflare_min_size" },
    { 0xF2686D0C, "r_sunflare_shader" },
    { 0x048BB89D, "r_sunglare_fadein" },
    { 0x9602E71E, "r_sunglare_fadeout" },
    { 0x464CB242, "r_sunglare_max_angle" },
    { 0x4F5737A6, "r_sunglare_max_lighten" },
    { 0xA694F9C0, "r_sunglare_min_angle" },
    { 0x354E8BD9, "r_sunsprite_shader" },
    { 0xF977855D, "r_sunsprite_size" },
    { 0xCF76B5BD, "r_superFlareDraw" },
    { 0x97B9F058, "r_superflare_drawlist" },
    { 0xF7AB0B95, "r_swrk_override_characterCharredAmount" },
    { 0x671C0E30, "r_swrk_override_characterDissolveColor" },
    { 0xB19289A4, "r_swrk_override_wetness" },
    { 0x12CF79BC, "r_tension_enable" },
    { 0x7FD1FE8D, "r_texFilterAnisoMax" },
    { 0x7FD1FF8B, "r_texFilterAnisoMin" },
    { 0xA1BFD961, "r_texFilterDisable" },
    { 0x56565B72, "r_texFilterMipBias" },
    { 0x565C7D78, "r_texFilterMipMode" },
    { 0xA53344B6, "r_texFilterQuality" },
    { 0xDD9F3B0C, "r_textureMode" },
    { 0x18C3DBA4, "r_txaa" },
    { 0xB1F1F5EA, "r_txaaDepth1" },
    { 0xB1F1F5EB, "r_txaaDepth2" },
    { 0x490EB869, "r_txaaMode" },
    { 0xBC92EBEB, "r_txaaMotion1" },
    { 0xBC92EBEC, "r_txaaMotion2" },
    { 0x4DE1BB4A, "r_txaaSupported" },
    { 0x401C9206, "r_ui3d_debug_display" },
    { 0x5A55EDB2, "r_ui3d_h" },
    { 0x6A60BEEC, "r_ui3d_use_debug_values" },
    { 0x5A55EDC1, "r_ui3d_w" },
    { 0x5A55EDC2, "r_ui3d_x" },
    { 0x5A55EDC3, "r_ui3d_y" },
    { 0x077BF7B7, "r_vc_compile" },
    { 0x3D91D684, "r_viewportBackingColor" },
    { 0x31612B69, "r_vsync" },
    { 0xBBBCC6B6, "r_vsyncThreshold" },
    { 0x7B3E1437, "r_warmShaders" },
    { 0xE1E26C15, "r_waterFogTest" },
    { 0xBCCC5715, "r_waterSheetingFX_allowed" },
    { 0x7FEAEFE3, "r_waterSheetingFX_distortionScaleFactor" },
    { 0x7BC65734, "r_waterSheetingFX_enable" },
    { 0xEC12768B, "r_waterSheetingFX_magnitude" },
    { 0x992FECF5, "r_waterSheetingFX_radius" },
    { 0xC5902371, "r_waterWaveAmplitude" },
    { 0x14388713, "r_waterWaveAngle" },
    { 0xBACBBF87, "r_waterWaveBase" },
    { 0x928BE5FD, "r_waterWaveNormalScale" },
    { 0x154493BD, "r_waterWavePhase" },
    { 0xD764A0C8, "r_waterWaveScriptShader0" },
    { 0xD764A0C9, "r_waterWaveScriptShader1" },
    { 0x157F4F7D, "r_waterWaveSpeed" },
    { 0x0D834E26, "r_waterWaveSteepness" },
    { 0xCF475521, "r_waterWaveWavelength" },
    { 0xA0E464EC, "r_watersim_enabled" },
    { 0x1950EE71, "r_zbufferDebug" },
    { 0xA6F298DE, "r_zbufferDebugRange" },
    { 0x227099C1, "r_zebrastripe" },
    { 0x18C6D969, "r_zfar" },
    { 0x31A678D6, "r_znear" },
    { 0x74957FD7, "r_zombieDarkness" },
    { 0x4DFCD7D1, "r_zombieDisableEarthEffect" },
    { 0x0217006E, "r_zombieDisableSlideEffect" },
    { 0x53380D37, "r_zombieNameAllowDevList" },
    { 0x5B8EC763, "r_zombieNameAllowFriendsList" },
    { 0x10D5D4D1, "radius_damage_debug" },
    { 0xCA089EC5, "ragdoll_baselerp_time" },
    { 0xE0781B7F, "ragdoll_bullet_force" },
    { 0x128258B4, "ragdoll_bullet_upbias" },
    { 0x1A22B8F0, "ragdoll_debug" },
    { 0x6170FFF0, "ragdoll_enable" },
    { 0x0B89BF68, "ragdoll_explode_force" },
    { 0x9FC879BD, "ragdoll_explode_upbias" },
    { 0x62C1C672, "ragdoll_fps" },
    { 0x52E281E2, "ragdoll_jitter_scale" },
    { 0x139B75CE, "ragdoll_jointlerp_time" },
    { 0x307AC8AE, "ragdoll_max_life" },
    { 0x2BBBB858, "ragdoll_reactivation_cutoff" },
    { 0x15C521EC, "ragdoll_rotvel_scale" },
    { 0x7ABB0625, "ragdoll_self_collision_scale" },
    { 0x7C9D3EB1, "rate" },
    { 0x19992209, "rcon_password" },
    { 0x549215EB, "recordPointsSpent" },
    { 0x458DF103, "redactionDisplayTime" },
    { 0x802DE914, "redactionFadeDuration" },
    { 0x55A53653, "redactionStartStrokeTime" },
    { 0x23CEEC65, "redactionStrokeTime" },
    { 0xD72B5155, "reliableResendTime" },
    { 0x91366CFB, "reliableTimeoutTime" },
    { 0xA15185C5, "reportUserInterval" },
    { 0xDE68EE01, "restore_gump_name" },
    { 0x19519796, "revive_time_taken" },
    { 0xB7C82BA0, "riotshield_assist_time" },
    { 0xBB6F1DE8, "riotshield_bullet_damage_scale" },
    { 0x08B73F7A, "riotshield_damage_score_max" },
    { 0x8576E701, "riotshield_damage_score_threshold" },
    { 0xC320348D, "riotshield_deploy_limit_radius" },
    { 0x2DB5E224, "riotshield_deploy_pitch_max" },
    { 0xB4C054A5, "riotshield_deploy_roll_max" },
    { 0xD563D05F, "riotshield_deploy_zdiff_max" },
    { 0xAA9B5326, "riotshield_deployed_health" },
    { 0x0217C6C3, "riotshield_destroyed_cleanup_time" },
    { 0x88D773FF, "riotshield_explosive_damage_scale" },
    { 0x23526A28, "riotshield_melee_damage_scale" },
    { 0x19FAA051, "riotshield_projectile_damage_scale" },
    { 0xDD7F5246, "safeArea_horizontal" },
    { 0x149CE636, "safeArea_vertical" },
    { 0x010BB950, "saved_gameskill" },
    { 0x9ED10890, "scavenger_clip_multiplier" },
    { 0x7C9DD34C, "scr_" },
    { 0x8BA2CC7B, "scr_HeldKillstreak_Penalty" },
    { 0xDA835401, "scr_QRDroneFlyTime" },
    { 0x33CF364A, "scr_RequiredMapAspectratio" },
    { 0xF549D4C5, "scr_ai_tank_no_timeout" },
    { 0xC2DDDCC6, "scr_allies" },
    { 0x2417B16D, "scr_allow_killstreak_building" },
    { 0xD1996D68, "scr_art_dump" },
    { 0x9EF57A6C, "scr_art_sun_fog_dir_set" },
    { 0x05E997AE, "scr_art_tweak" },
    { 0xFE68F88A, "scr_art_visionfile" },
    { 0x72E5D681, "scr_axis" },
    { 0x959D90CA, "scr_bomb_explode_delay" },
    { 0x487CD523, "scr_bot_follow" },
    { 0x1D5FB2EC, "scr_botsAllowKillstreaks" },
    { 0x8330ABEF, "scr_botsGrenadesOnly" },
    { 0x98F33417, "scr_botsHasPlayerWeapon" },
    { 0xFC880A10, "scr_botsSpecialGrenadesOnly" },
    { 0xD81AD9C1, "scr_cam_move_time" },
    { 0x69E20811, "scr_cinematic_autofocus" },
    { 0x8D448453, "scr_codPointsCap" },
    { 0x9D07FE34, "scr_codpointsmatchscale" },
    { 0x4B61B909, "scr_codpointsperchallenge" },
    { 0x5DB7110F, "scr_codpointsxpscale" },
    { 0x0D6F71B0, "scr_crane_arm_y_move_time" },
    { 0x92CC26F1, "scr_crane_arm_z_move_time" },
    { 0xC39D2ABF, "scr_crane_claw_drop_speed" },
    { 0xF60036C0, "scr_crane_claw_drop_time_min" },
    { 0x33ED9F5F, "scr_crane_claw_move_time" },
    { 0xCFA0F999, "scr_crane_crate_lower_time" },
    { 0xB4D4D064, "scr_crane_crate_raise_time" },
    { 0xC8077F47, "scr_csmode" },
    { 0xF6F112EA, "scr_ctf_spawnPointFacingAngle" },
    { 0x651F4AD8, "scr_custom_score_assist" },
    { 0xC371F046, "scr_debug_render_snapshotmode" },
    { 0x42308B33, "scr_debug_render_spawn_data" },
    { 0x423962DE, "scr_debug_render_spawn_text" },
    { 0x62ACF3A7, "scr_debug_spawn_player" },
    { 0x2CCCDCB5, "scr_debugheli" },
    { 0x8E9CA497, "scr_deleteexplosivesonspawn" },
    { 0xC0DBB722, "scr_devHeliPathsDebugDraw" },
    { 0xAD911707, "scr_devStrafeRunPathDebugDraw" },
    { 0x1F70E0F8, "scr_devgui_spawn" },
    { 0x6086CCA2, "scr_dial_rotate_time" },
    { 0x8D5C0C16, "scr_disableChallenges" },
    { 0x3B63ABAC, "scr_disableSetDStat" },
    { 0x742CBFAF, "scr_disableStatTracking" },
    { 0x68ECFF24, "scr_disable_air_death_ragdoll" },
    { 0x732A4726, "scr_disable_cac" },
    { 0x5661F47E, "scr_disable_weapondrop" },
    { 0x70B3C3B7, "scr_do_notify" },
    { 0x628ADECB, "scr_dof_enable" },
    { 0xE3C187D2, "scr_dof_farBlur" },
    { 0x63FE2854, "scr_dof_farEnd" },
    { 0x5D2A310B, "scr_dof_farStart" },
    { 0xCB5E503F, "scr_dof_nearBlur" },
    { 0x53BD1721, "scr_dof_nearEnd" },
    { 0x38600718, "scr_dof_nearStart" },
    { 0x9CB86F60, "scr_draw_triggers" },
    { 0x5CCEB632, "scr_drawfriend" },
    { 0xBAC14FFE, "scr_dynamic_source_loading" },
    { 0xD04570F2, "scr_emp_damage_debug" },
    { 0xC2F42DBB, "scr_emp_jammed" },
    { 0x35E553D4, "scr_emp_timeout" },
    { 0xEB32B46C, "scr_env_destroy_delay" },
    { 0x829C0FDB, "scr_fog_baseheight" },
    { 0x699F914F, "scr_fog_blue" },
    { 0x9DA55446, "scr_fog_color" },
    { 0x93B3FAED, "scr_fog_color_scale" },
    { 0x54D01B47, "scr_fog_exp_halfheight" },
    { 0xB59305FE, "scr_fog_exp_halfplane" },
    { 0xB6F06C9D, "scr_fog_fraction" },
    { 0x9DEF3C58, "scr_fog_green" },
    { 0x81EA8425, "scr_fog_max_opacity" },
    { 0x5C40223D, "scr_fog_nearplane" },
    { 0xA61C5EC2, "scr_fog_red" },
    { 0x9003F201, "scr_force_finalkillcam" },
    { 0xA0259FFF, "scr_force_roundkillcam" },
    { 0xB107A31D, "scr_forceevent" },
    { 0xA21C71D1, "scr_forcegrenade" },
    { 0x760BFF29, "scr_forcelaststand" },
    { 0x5A4675BD, "scr_forcerankedmatch" },
    { 0x4C560F97, "scr_freelock" },
    { 0xF35973DA, "scr_game_arcadescoring" },
    { 0x77F933CC, "scr_game_bulletdamage" },
    { 0x883B0EB8, "scr_game_difficulty" },
    { 0x9C756AF7, "scr_game_friendlyFireDelay" },
    { 0x273F6466, "scr_game_medalsenabled" },
    { 0xFBBF61E4, "scr_game_pinups" },
    { 0xDFD7387C, "scr_game_rankenabled" },
    { 0x62447114, "scr_gamemodeslideout" },
    { 0xA0215B8E, "scr_give_equipment" },
    { 0x227BB8EC, "scr_give_grenade" },
    { 0xADB1B0DE, "scr_give_player_score" },
    { 0x46AB9A04, "scr_giveaitankdrop" },
    { 0x00EBCD76, "scr_giveautoturret" },
    { 0x049A620B, "scr_giveautoturretdrop" },
    { 0xEC3C6603, "scr_givecounteruav" },
    { 0xAB6F11E4, "scr_givedogs" },
    { 0xE62A2B59, "scr_giveemp" },
    { 0xA3D942D2, "scr_givehelicopter_comlink" },
    { 0xB0D450A0, "scr_givehelicopter_player_gunner" },
    { 0xB1DB4779, "scr_givehelicopterguard" },
    { 0xD58518BD, "scr_givem32_drop" },
    { 0x2904A24A, "scr_givemicrowaveturret" },
    { 0x83F980DF, "scr_givemicrowaveturretdrop" },
    { 0x18F60E02, "scr_giveminigun_drop" },
    { 0xC92281E5, "scr_givemissiledrone" },
    { 0x0D2EA699, "scr_givemissileremote" },
    { 0xCA347457, "scr_givemissileswarm" },
    { 0xE3F1D258, "scr_givemortarremote" },
    { 0xAB757D49, "scr_giveperk" },
    { 0xA36DE8DC, "scr_giveplanemortar" },
    { 0xA25E17F2, "scr_giveqrdrone" },
    { 0x1A46E981, "scr_giveradar" },
    { 0x52559802, "scr_giveradardirection" },
    { 0x63476D2C, "scr_givercbomb" },
    { 0x812082F1, "scr_givestraferun" },
    { 0xD3345BF9, "scr_givesupplydrop" },
    { 0x78762059, "scr_givetestsupplydrop" },
    { 0xD0ABF43F, "scr_givexp" },
    { 0x2A181C06, "scr_gunxpscale" },
    { 0x2677BAB4, "scr_hardcore" },
    { 0x6290D591, "scr_hardpoint_allowauto_turret" },
    { 0x5D6984FF, "scr_hardpoint_allowcounteruav" },
    { 0x85DFA3E0, "scr_hardpoint_allowdogs" },
    { 0x31C39DCE, "scr_hardpoint_allowhelicopter_comlink" },
    { 0x42C9BAFD, "scr_hardpoint_allowradar" },
    { 0xC2B1D4FE, "scr_hardpoint_allowradardirection" },
    { 0x9C246E28, "scr_hardpoint_allowrcbomb" },
    { 0x1392B05F, "scr_hardpoint_allowuav" },
    { 0x9A7D1E68, "scr_health_debug" },
    { 0x6249656E, "scr_heli_armor" },
    { 0xE2B966D4, "scr_heli_armor_bulletdamage" },
    { 0xC6B2F352, "scr_heli_armored_maxhealth" },
    { 0x3D5BBF4C, "scr_heli_attract_range" },
    { 0x186C896E, "scr_heli_attract_strength" },
    { 0x62785FF4, "scr_heli_debug" },
    { 0x7C5F43A4, "scr_heli_debug_crash" },
    { 0xC0CA41D1, "scr_heli_dest_wait" },
    { 0x2CF8CBA6, "scr_heli_guard_debug" },
    { 0xC2866782, "scr_heli_guard_no_timeout" },
    { 0x281134C6, "scr_heli_guard_timeout" },
    { 0xB396CECE, "scr_heli_health_degrade" },
    { 0x621E506D, "scr_heli_loopmax" },
    { 0x8D68E269, "scr_heli_maxhealth" },
    { 0xC54F1A5A, "scr_heli_missile_friendlycare" },
    { 0xD8ED3F08, "scr_heli_missile_max" },
    { 0xC9937EAF, "scr_heli_missile_range" },
    { 0x1DD06B01, "scr_heli_missile_regen_time" },
    { 0x7A5CFC47, "scr_heli_missile_reload_time" },
    { 0xD8ED5609, "scr_heli_missile_rof" },
    { 0x26FA658D, "scr_heli_missile_target_cone" },
    { 0x752B7B9C, "scr_heli_missile_valid_target_cone" },
    { 0x7F88878D, "scr_heli_protect_pos_time" },
    { 0xE8F66195, "scr_heli_protect_radius" },
    { 0x5B31A6BC, "scr_heli_protect_time" },
    { 0x83687D34, "scr_heli_target_recognition" },
    { 0x488F0063, "scr_heli_target_spawnprotection" },
    { 0xDF26D040, "scr_heli_targeting_delay" },
    { 0x2CE7C256, "scr_heli_turretClipSize" },
    { 0x6089DAF9, "scr_heli_turretReloadTime" },
    { 0xCC3095FB, "scr_heli_turret_angle_tan" },
    { 0x0D444BDF, "scr_heli_turret_spinup_delay" },
    { 0xDF9746BD, "scr_heli_turret_target_cone" },
    { 0x2960222D, "scr_heli_visual_range" },
    { 0x3D82DFAD, "scr_heli_warning_distance" },
    { 0xA0E858EE, "scr_helicopterTurretMaxAngle" },
    { 0xF4485188, "scr_help_dist" },
    { 0x1F8C9394, "scr_hostmigrationtest" },
    { 0x1CC516F5, "scr_hydro_water_rush" },
    { 0x45A06390, "scr_killbots" },
    { 0x1F9534FE, "scr_killbottimer" },
    { 0x1961F5E9, "scr_killcam" },
    { 0xE449EBB3, "scr_lbguard_timeout" },
    { 0xA0F97FC5, "scr_mapsize" },
    { 0xD16D59FD, "scr_max_rank" },
    { 0x4EBE2CF2, "scr_min_prestige" },
    { 0x6B3B5DAF, "scr_minimap_height" },
    { 0xA8BC3161, "scr_missileDudDeleteDelay" },
    { 0x0BC0001B, "scr_missile_swarm_cam" },
    { 0x4FEEA279, "scr_missile_swarm_lifetime" },
    { 0x72EC4620, "scr_motd" },
    { 0xA879D65F, "scr_numLives" },
    { 0x875C8507, "scr_obj" },
    { 0x38F47B13, "scr_oldschool" },
    { 0x2DB97368, "scr_player_allowrevive" },
    { 0xA990D882, "scr_player_ammo" },
    { 0xEC01172A, "scr_player_momentum" },
    { 0x4E90EDE7, "scr_player_sprinttime" },
    { 0xB3003261, "scr_player_zero_ammo" },
    { 0x6A09CB73, "scr_playerwarp" },
    { 0xD2451F63, "scr_popupchallenge" },
    { 0x3437A4DA, "scr_popupcontractfail" },
    { 0x343D21F5, "scr_popupcontractpass" },
    { 0xBAC602EA, "scr_popupgun" },
    { 0x84B614C3, "scr_popupmedal" },
    { 0x138C13AC, "scr_popuprank" },
    { 0x9CAAE1C4, "scr_pregame_abort" },
    { 0xB1153665, "scr_proximityGrenadeMaxInstances" },
    { 0x0E9EC149, "scr_qrdrone_no_timeout" },
    { 0x855FF558, "scr_rampagebonusscale" },
    { 0x6032F3B4, "scr_rankXpCap" },
    { 0x08660C30, "scr_rcbomb_car_size" },
    { 0xB2F33084, "scr_rcbomb_notimeout" },
    { 0x96EBB72E, "scr_recordspawndata" },
    { 0xF9AB897A, "scr_remote_mortar_lifetime" },
    { 0x6C3088CA, "scr_round_end" },
    { 0x3B362771, "scr_round_pause" },
    { 0x469616C5, "scr_scorestreaks" },
    { 0x181EB11E, "scr_scorestreaks_maxstacking" },
    { 0xB0C0D38F, "scr_screecher_ignore_player" },
    { 0xE7EF8EB7, "scr_screecher_poison" },
    { 0x84C6D64D, "scr_script_based_influencer_system" },
    { 0x41CA5EC2, "scr_selecting_location" },
    { 0x36B7604F, "scr_set_level" },
    { 0xF8E39F40, "scr_show_hq_spawns" },
    { 0xBB4CAD78, "scr_showperksonspawn" },
    { 0xE0FC7E63, "scr_showspawnid" },
    { 0x16553A29, "scr_showspawns" },
    { 0x472D7677, "scr_showstartspawns" },
    { 0x55AE206D, "scr_sideBetTimer" },
    { 0x32A4AA9D, "scr_spawn_aitank_influencer_radius" },
    { 0xEA566E11, "scr_spawn_aitank_influencer_score" },
    { 0x5A6AA155, "scr_spawn_aitank_influencer_score_curve" },
    { 0x70D13C3D, "scr_spawn_artillery_influencer_radius" },
    { 0xA6674BB1, "scr_spawn_artillery_influencer_score" },
    { 0x055336F5, "scr_spawn_artillery_influencer_score_curve" },
    { 0xD2C811B8, "scr_spawn_auto_turret_influencer_close_radius" },
    { 0x5BCBDDCC, "scr_spawn_auto_turret_influencer_close_score" },
    { 0x0AC1B150, "scr_spawn_auto_turret_influencer_close_score_curve" },
    { 0x2277A463, "scr_spawn_auto_turret_influencer_radius" },
    { 0x3F2E4717, "scr_spawn_auto_turret_influencer_score" },
    { 0x9FDEA6DB, "scr_spawn_auto_turret_influencer_score_curve" },
    { 0x9D27D281, "scr_spawn_claymore_influencer_radius" },
    { 0x33622975, "scr_spawn_claymore_influencer_score" },
    { 0xDBD657B9, "scr_spawn_claymore_influencer_score_curve" },
    { 0xC1950ECF, "scr_spawn_ctf_dropped_influencer_radius" },
    { 0x89D21403, "scr_spawn_ctf_dropped_influencer_score" },
    { 0x77DB74C7, "scr_spawn_ctf_dropped_influencer_score_curve" },
    { 0xCE7F4C59, "scr_spawn_ctf_enemy_base_influencer_radius" },
    { 0xC845C84D, "scr_spawn_ctf_enemy_base_influencer_score" },
    { 0xB39BB891, "scr_spawn_ctf_enemy_base_influencer_score_curve" },
    { 0xD43685E6, "scr_spawn_ctf_enemy_carrier_influencer_radius" },
    { 0x1605843A, "scr_spawn_ctf_enemy_carrier_influencer_score" },
    { 0x22A5F23E, "scr_spawn_ctf_enemy_carrier_influencer_score_curve" },
    { 0x730E18B8, "scr_spawn_ctf_friendly_base_influencer_radius" },
    { 0x77ED04CC, "scr_spawn_ctf_friendly_base_influencer_score" },
    { 0x1AE41850, "scr_spawn_ctf_friendly_base_influencer_score_curve" },
    { 0x4615E9E5, "scr_spawn_ctf_friendly_carrier_influencer_radius" },
    { 0x1978E459, "scr_spawn_ctf_friendly_carrier_influencer_score" },
    { 0xD96EAD9D, "scr_spawn_ctf_friendly_carrier_influencer_score_curve" },
    { 0x7D9CD88B, "scr_spawn_dead_friend_influencer_count" },
    { 0x532E8D2A, "scr_spawn_dead_friend_influencer_radius" },
    { 0x7EB7B2FE, "scr_spawn_dead_friend_influencer_score" },
    { 0xAF592402, "scr_spawn_dead_friend_influencer_score_curve" },
    { 0x4DAE2717, "scr_spawn_dead_friend_influencer_timeout_seconds" },
    { 0x67876952, "scr_spawn_dem_enemy_base_influencer_radius" },
    { 0x6FD1AA26, "scr_spawn_dem_enemy_base_influencer_score" },
    { 0xC6E9D92A, "scr_spawn_dem_enemy_base_influencer_score_curve" },
    { 0xC4211E9F, "scr_spawn_dog_influencer_radius" },
    { 0xC03369D3, "scr_spawn_dog_influencer_score" },
    { 0xD479E697, "scr_spawn_dog_influencer_score_curve" },
    { 0x21B805BB, "scr_spawn_dom_enemy_flag_A_influencer_radius" },
    { 0x8CBBDD6F, "scr_spawn_dom_enemy_flag_A_influencer_score" },
    { 0xD2926BFC, "scr_spawn_dom_enemy_flag_B_influencer_radius" },
    { 0x7AD1FF90, "scr_spawn_dom_enemy_flag_B_influencer_score" },
    { 0x836CD23D, "scr_spawn_dom_enemy_flag_C_influencer_radius" },
    { 0x68E821B1, "scr_spawn_dom_enemy_flag_C_influencer_score" },
    { 0xD49B2413, "scr_spawn_dom_enemy_flag_influencer_score_curve" },
    { 0xC68B703A, "scr_spawn_dom_owned_flag_A_influencer_radius" },
    { 0x997C740E, "scr_spawn_dom_owned_flag_A_influencer_score" },
    { 0x7765D67B, "scr_spawn_dom_owned_flag_B_influencer_radius" },
    { 0x8792962F, "scr_spawn_dom_owned_flag_B_influencer_score" },
    { 0x28403CBC, "scr_spawn_dom_owned_flag_C_influencer_radius" },
    { 0x75A8B850, "scr_spawn_dom_owned_flag_C_influencer_score" },
    { 0xE6F3F232, "scr_spawn_dom_owned_flag_influencer_score_curve" },
    { 0x61B4001D, "scr_spawn_dom_unowned_flag_influencer_radius" },
    { 0x22111391, "scr_spawn_dom_unowned_flag_influencer_score" },
    { 0xBBEB66D5, "scr_spawn_dom_unowned_flag_influencer_score_curve" },
    { 0x6983B543, "scr_spawn_enemy_influencer_radius" },
    { 0x1A8BBBF7, "scr_spawn_enemy_influencer_score" },
    { 0x8B7843BB, "scr_spawn_enemy_influencer_score_curve" },
    { 0x94B66574, "scr_spawn_enemy_spawned_influencer_radius" },
    { 0x3320AA08, "scr_spawn_enemy_spawned_influencer_score" },
    { 0x8425BA8C, "scr_spawn_enemy_spawned_influencer_score_curve" },
    { 0x4C96F2A1, "scr_spawn_enemy_spawned_influencer_timeout_seconds" },
    { 0x2778D919, "scr_spawn_enemyavoiddist" },
    { 0x1517800D, "scr_spawn_enemyavoidweight" },
    { 0x0BD11226, "scr_spawn_force_unified" },
    { 0xC54475E4, "scr_spawn_friend_weak_influencer_radius" },
    { 0xA8F66C78, "scr_spawn_friend_weak_influencer_score" },
    { 0x953F90FC, "scr_spawn_friend_weak_influencer_score_curve" },
    { 0xE627E85B, "scr_spawn_grenade_endpoint_influencer_radius" },
    { 0x7B69EC0F, "scr_spawn_grenade_endpoint_influencer_score" },
    { 0xBDB025D3, "scr_spawn_grenade_endpoint_influencer_score_curve" },
    { 0xAD51D75B, "scr_spawn_grenade_influencer_radius" },
    { 0xFD91FB0F, "scr_spawn_grenade_influencer_score" },
    { 0xE76774D3, "scr_spawn_grenade_influencer_score_curve" },
    { 0xB5B47D0E, "scr_spawn_helicopter_influencer_length" },
    { 0xC3659BB4, "scr_spawn_helicopter_influencer_radius" },
    { 0x91A21848, "scr_spawn_helicopter_influencer_score" },
    { 0xC410D8CC, "scr_spawn_helicopter_influencer_score_curve" },
    { 0x2094EB22, "scr_spawn_hq_initial_spawns_influencer_radius" },
    { 0xF94E31F6, "scr_spawn_hq_initial_spawns_influencer_score" },
    { 0xFEC0FCFA, "scr_spawn_hq_initial_spawns_influencer_score_curve" },
    { 0x95AB0AD3, "scr_spawn_hq_objective_influencer_inner_radius" },
    { 0xED569F87, "scr_spawn_hq_objective_influencer_inner_score" },
    { 0xF7F772CC, "scr_spawn_hq_objective_influencer_score" },
    { 0x80890650, "scr_spawn_hq_objective_influencer_score_curve" },
    { 0x0D5441FF, "scr_spawn_koth_initial_spawns_influencer_radius" },
    { 0x93DFA133, "scr_spawn_koth_initial_spawns_influencer_score" },
    { 0x5A0A25F7, "scr_spawn_koth_initial_spawns_influencer_score_curve" },
    { 0x4CAF9F75, "scr_spawn_koth_objective_influencer_radius" },
    { 0x11EA27E9, "scr_spawn_koth_objective_influencer_score" },
    { 0x6D485D2D, "scr_spawn_koth_objective_influencer_score_curve" },
    { 0x7188033E, "scr_spawn_napalm_influencer_radius" },
    { 0xB5F0B692, "scr_spawn_napalm_influencer_score" },
    { 0x1CB38696, "scr_spawn_napalm_influencer_score_curve" },
    { 0x44DFDDDC, "scr_spawn_objective_facing_bonus" },
    { 0xE372755D, "scr_spawn_pegasus_influencer_radius" },
    { 0xFF35E0D1, "scr_spawn_pegasus_influencer_score" },
    { 0x85452415, "scr_spawn_pegasus_influencer_score_curve" },
    { 0x24A61F21, "scr_spawn_point_test_mode" },
    { 0x09200D73, "scr_spawn_qrdrone_cylinder_influencer_length" },
    { 0x16D12C19, "scr_spawn_qrdrone_cylinder_influencer_radius" },
    { 0xD9FAB00D, "scr_spawn_qrdrone_cylinder_influencer_score" },
    { 0xC4CF7051, "scr_spawn_qrdrone_cylinder_influencer_score_curve" },
    { 0xD0FE2400, "scr_spawn_qrdrone_influencer_radius" },
    { 0xF6E4C714, "scr_spawn_qrdrone_influencer_score" },
    { 0xFF867098, "scr_spawn_qrdrone_influencer_score_curve" },
    { 0x6486379A, "scr_spawn_randomly" },
    { 0xE3E17B1A, "scr_spawn_randomness_range" },
    { 0x99A7841A, "scr_spawn_rcbomb_influencer_radius" },
    { 0xED758BEE, "scr_spawn_rcbomb_influencer_score" },
    { 0xC5B1F0F2, "scr_spawn_rcbomb_influencer_score_curve" },
    { 0x9E85FAFC, "scr_spawn_showbad" },
    { 0x2363973F, "scr_spawn_tvmissile_influencer_length" },
    { 0x3114B5E5, "scr_spawn_tvmissile_influencer_radius" },
    { 0xF9CE3059, "scr_spawn_tvmissile_influencer_score" },
    { 0x2F8CF99D, "scr_spawn_tvmissile_influencer_score_curve" },
    { 0x367873A1, "scr_spawn_vehicle_influencer_lead_seconds" },
    { 0xD46C6C99, "scr_spawn_vehicle_influencer_score" },
    { 0xED7765DD, "scr_spawn_vehicle_influencer_score_curve" },
    { 0xA1755E55, "scr_spawnenemyheli" },
    { 0x23E1517A, "scr_spawnenemyu2" },
    { 0x4058B332, "scr_spawnidcycle" },
    { 0x632110E6, "scr_spawnpointdebug" },
    { 0x7CA769A6, "scr_spawnprofile" },
    { 0x292A749F, "scr_spawnsimple" },
    { 0x66A189BB, "scr_sun_fog_color" },
    { 0xFA1301D9, "scr_sun_fog_end_angle" },
    { 0xECC36390, "scr_sun_fog_start_angle" },
    { 0x38F6C211, "scr_supply_drop_gui" },
    { 0xBB77CC24, "scr_switch_team" },
    { 0x12AE1013, "scr_takeoff_rocket" },
    { 0x2952A7C3, "scr_takeperk" },
    { 0xA651B120, "scr_team_fftype" },
    { 0xA77CF4BC, "scr_team_teamkillerplaylistbanpenalty" },
    { 0x18E5C00A, "scr_team_teamkillerplaylistbanquantum" },
    { 0x81F89399, "scr_teambalance" },
    { 0xB95CDBBC, "scr_teamslideout" },
    { 0x316B7BEF, "scr_testScriptRuntimeError" },
    { 0x8EF43DBE, "scr_testclients" },
    { 0xC97483EC, "scr_testclientsremove" },
    { 0x70EE00F9, "scr_testdvar" },
    { 0x3478842E, "scr_timeplayedcap" },
    { 0xD3B62F34, "scr_turret_no_timeout" },
    { 0x31F91106, "scr_usedogs" },
    { 0xB7538EFB, "scr_veh_alive_cleanuptimemax" },
    { 0xB7538FF9, "scr_veh_alive_cleanuptimemin" },
    { 0x8D2EFFB2, "scr_veh_cleanupabandoned" },
    { 0xAAD1512A, "scr_veh_cleanupdebugprint" },
    { 0xA7D9B018, "scr_veh_cleanupdrifted" },
    { 0x69770092, "scr_veh_cleanupmaxspeedmph" },
    { 0x098C9729, "scr_veh_cleanupmindistancefeet" },
    { 0xED378BD8, "scr_veh_cleanuptime_dmgfactor_deadtread" },
    { 0xD92137A0, "scr_veh_cleanuptime_dmgfactor_max" },
    { 0xD921389E, "scr_veh_cleanuptime_dmgfactor_min" },
    { 0xEF99099A, "scr_veh_cleanuptime_dmgfraction_curve_begin" },
    { 0x7CCFC4CC, "scr_veh_cleanuptime_dmgfraction_curve_end" },
    { 0x6C2FBBF8, "scr_veh_dead_cleanuptimemax" },
    { 0x6C2FBCF6, "scr_veh_dead_cleanuptimemin" },
    { 0x63AF17E6, "scr_veh_disableoverturndamage" },
    { 0x4AAF6102, "scr_veh_disablerespawn" },
    { 0xEB58349F, "scr_veh_disappear_maxpreventdistancefeet" },
    { 0xF3A863DC, "scr_veh_disappear_maxpreventvisibilityfeet" },
    { 0x33313A70, "scr_veh_disappear_maxwaittime" },
    { 0x8AB44691, "scr_veh_driversarehidden" },
    { 0x027D6F6C, "scr_veh_driversareinvulnerable" },
    { 0xA0CE2AC2, "scr_veh_explode_on_cleanup" },
    { 0x1A397FE8, "scr_veh_explosion_doradiusdamage" },
    { 0xF0E3D76A, "scr_veh_explosion_husk_forcepointvariance" },
    { 0xF7AEC6C3, "scr_veh_explosion_husk_horzvelocityvariance" },
    { 0xB8C043DE, "scr_veh_explosion_husk_vertvelocitymax" },
    { 0xB8C044DC, "scr_veh_explosion_husk_vertvelocitymin" },
    { 0xDDBCFBD3, "scr_veh_explosion_maxdamage" },
    { 0x3E054351, "scr_veh_explosion_mindamage" },
    { 0x2CC23AB6, "scr_veh_explosion_radius" },
    { 0x34D27475, "scr_veh_explosion_spawnfx" },
    { 0x20DC0967, "scr_veh_health_jeep" },
    { 0x20E17551, "scr_veh_health_tank" },
    { 0x16B521FF, "scr_veh_ondeath_createhusk" },
    { 0xA770BB2C, "scr_veh_ondeath_usevehicleashusk" },
    { 0xA85448C3, "scr_veh_respawnafterhuskcleanup" },
    { 0x099A7783, "scr_veh_respawntimemax" },
    { 0x099A7881, "scr_veh_respawntimemin" },
    { 0xB75883F5, "scr_veh_respawnwait_iterationwaitseconds" },
    { 0xC775AA8A, "scr_veh_respawnwait_maxiterations" },
    { 0x49F6FDB6, "scr_veh_waittillstoppedandmindist_maxtime" },
    { 0xDC2C41B5, "scr_veh_waittillstoppedandmindist_maxtimeenabledistfeet" },
    { 0x23853F1F, "scr_vehicle_damage_scalar" },
    { 0xE4C48E3D, "scr_wagerBet" },
    { 0x7D5E2D7C, "scr_wagerPool" },
    { 0xD9B598A2, "scr_wagerSideBet" },
    { 0x7D604436, "scr_wagerTier" },
    { 0x37DA5242, "scr_wager_defaultScore" },
    { 0x09190F6B, "scr_wager_firstPayout" },
    { 0x09D31C56, "scr_wager_firstPlayer" },
    { 0x809E429F, "scr_wager_secondPayout" },
    { 0x81584F8A, "scr_wager_secondPlayer" },
    { 0x7BDACDDE, "scr_wager_thirdPayout" },
    { 0x7C94DAC9, "scr_wager_thirdPlayer" },
    { 0x7B0C173C, "scr_weapon_allowbetty" },
    { 0x8D41C02B, "scr_weapon_allowc4" },
    { 0x7B57FEE2, "scr_weapon_allowflash" },
    { 0x7B5B47A7, "scr_weapon_allowfrags" },
    { 0x7BD53AD0, "scr_weapon_allowmines" },
    { 0xE4BBBD90, "scr_weapon_allowrpgs" },
    { 0x81AEAF38, "scr_weapon_allowsatchel" },
    { 0x7C440453, "scr_weapon_allowsmoke" },
    { 0xD65C9A98, "scr_weaponobject_coneangle" },
    { 0x38868733, "scr_weaponobject_debug" },
    { 0x771D3F71, "scr_weaponobject_graceperiod" },
    { 0x3335D0A4, "scr_weaponobject_mindist" },
    { 0x69B82C54, "scr_weaponobject_radius" },
    { 0x7AEF62D7, "scr_writeConfigStrings" },
    { 0x5625D4BA, "scr_x_kills_y" },
    { 0x12E4DD1C, "scr_xpscale" },
    { 0x92FC9AA3, "scr_xpzmscale" },
    { 0xB0FB65D0, "scr_zm_enable_bots" },
    { 0xD3E0C36D, "sd_can_switch_device" },
    { 0xDF2D597D, "sd_xa2_device_guid" },
    { 0xDF30DB95, "sd_xa2_device_name" },
    { 0x511E7257, "sd_xa2_num_devices" },
    { 0x442C2675, "searchSessionDedicatedGeoMin" },
    { 0x8EDE412A, "searchSessionDedicatedMaxPing" },
    { 0xD00E4013, "searchSessionGeo1Weight" },
    { 0x1D087CD4, "searchSessionGeo2Weight" },
    { 0x6A02B995, "searchSessionGeo3Weight" },
    { 0xB6FCF656, "searchSessionGeo4Weight" },
    { 0xD334DA3E, "searchSessionGeoMin" },
    { 0xC0D1F8B3, "searchSessionIgnoreMapPacks" },
    { 0xF3B7FE4A, "searchSessionIsEmpty" },
    { 0xE887AEC9, "searchSessionMapPackFlags" },
    { 0xD8074419, "searchSessionMaxIntervalTime" },
    { 0x3F39397D, "searchSessionMaxIntervalTimeBeforeUnpark" },
    { 0x875FE0E0, "searchSessionNextTaskDelay" },
    { 0x63CAE1AF, "searchSessionRandom_0" },
    { 0x63CAE1B0, "searchSessionRandom_1" },
    { 0xBDA48286, "searchSessionSkillWeight" },
    { 0xB7B193BE, "selectedFriendIndex" },
    { 0xE68BCA47, "selectedFriendName" },
    { 0x48C9FC53, "selectedGroupIndex" },
    { 0x3CEBBBEA, "selectedMenuItemIndex" },
    { 0xE18DA155, "selectedPlayerXuid" },
    { 0x442D8970, "sensitivity" },
    { 0xF50F3E57, "sessionSearchMaxAttempts" },
    { 0xF1798E1F, "sessionTaskFailDebug" },
    { 0x074599BC, "session_nonblocking" },
    { 0xB937350C, "shieldBlastDamageProtection_120" },
    { 0xB93735D2, "shieldBlastDamageProtection_180" },
    { 0x6A76099C, "shieldBlastDamageProtection_30" },
    { 0x6A7609FF, "shieldBlastDamageProtection_60" },
    { 0xE753123D, "shieldDeployShakeDuration" },
    { 0xB3ADE5FF, "shieldDeployShakeScale" },
    { 0xD527A516, "shieldImpactBulletShakeDuration" },
    { 0x92C2BF78, "shieldImpactBulletShakeScale" },
    { 0xE9C64C2F, "shieldImpactExplosionHighShakeDuration" },
    { 0x15801531, "shieldImpactExplosionHighShakeScale" },
    { 0x15A9E841, "shieldImpactExplosionLowShakeDuration" },
    { 0x7330DA83, "shieldImpactExplosionLowShakeScale" },
    { 0x89E2526A, "shieldImpactExplosionThreshold" },
    { 0xC8F3B7A4, "shieldImpactMissileShakeDuration" },
    { 0xF81F2CC6, "shieldImpactMissileShakeScale" },
    { 0x3C7C8479, "shieldPlayerBulletProtectionDegrees" },
    { 0xA0B3DE1B, "shortversion" },
    { 0xE51B23E3, "shoutcastHighlightedClient" },
    { 0x3DD517CB, "shoutcastSelectedClient" },
    { 0x6A2BE3DD, "showVisionSetDebugInfo" },
    { 0x77ADBB5B, "sidebet_made" },
    { 0xD0E5DEBB, "skill_scoreBeta" },
    { 0xEEC0F44C, "skill_scoreRange" },
    { 0x73487FA6, "skill_teamBeta" },
    { 0xDD77B297, "skill_teamRange" },
    { 0x627DEC6B, "sm_enable" },
    { 0x1AC3422E, "sm_fastSunShadow" },
    { 0xD52875D5, "sm_maxLights" },
    { 0xBBE14732, "sm_polygonOffsetBias" },
    { 0x393A833B, "sm_polygonOffsetScale" },
    { 0x766885B1, "sm_spotEnable" },
    { 0xEF8DA2B3, "sm_spotQuality" },
    { 0x75BE6E0F, "sm_spotShadowFadeTime" },
    { 0x1C141D6B, "sm_spotShadowLargeRadiusScale" },
    { 0xBA22D76D, "sm_strictCull" },
    { 0xAA14AFEF, "sm_sunAlwaysCastsShadow" },
    { 0xF3745721, "sm_sunEnable" },
    { 0x0E13A223, "sm_sunQuality" },
    { 0x1A3C7D9D, "sm_sunSampleSizeNear" },
    { 0x44259BA1, "sm_sunShadowCenter" },
    { 0x9E57A848, "sm_sunShadowScale" },
    { 0x9E5D2419, "sm_sunShadowSmall" },
    { 0xD8AE81C0, "sm_sunShadowSmallEnable" },
    { 0x01D23A8B, "snd_autoSim" },
    { 0x61A81562, "snd_autosim_window" },
    { 0xCDEA72FF, "snd_boat_current_rpm" },
    { 0x179B7ABE, "snd_boat_engine_off" },
    { 0xC23A924F, "snd_boat_lerp_rpm" },
    { 0x2545C36A, "snd_boat_pitch_high_max" },
    { 0x2545C468, "snd_boat_pitch_high_min" },
    { 0x9C17EA28, "snd_boat_pitch_idle_max" },
    { 0x9C17EB26, "snd_boat_pitch_idle_min" },
    { 0xC044E63C, "snd_boat_pitch_low_max" },
    { 0xC044E73A, "snd_boat_pitch_low_min" },
    { 0xF493BB20, "snd_boat_pitch_med_max" },
    { 0xF493BC1E, "snd_boat_pitch_med_min" },
    { 0x195E1E2E, "snd_boat_rpm_high_fin_end" },
    { 0x9D0E8A89, "snd_boat_rpm_high_start" },
    { 0xB2343110, "snd_boat_rpm_idle_end" },
    { 0xFDD66904, "snd_boat_rpm_idle_fout_start" },
    { 0xD8361E44, "snd_boat_rpm_low_end" },
    { 0x691EDB20, "snd_boat_rpm_low_fin_end" },
    { 0x282AF3B8, "snd_boat_rpm_low_fout_start" },
    { 0xBF3762FB, "snd_boat_rpm_low_start" },
    { 0x0C84F328, "snd_boat_rpm_med_end" },
    { 0x20D58204, "snd_boat_rpm_med_fin_end" },
    { 0xA7A4E01C, "snd_boat_rpm_med_fout_start" },
    { 0x428F00DF, "snd_boat_rpm_med_start" },
    { 0xC868FEB2, "snd_boat_rpm_scalar" },
    { 0x9B1172B4, "snd_boat_using_lerp_rpm" },
    { 0x58B39F61, "snd_boat_water_fast_min" },
    { 0xF3044753, "snd_boat_water_idle_max" },
    { 0x840065AD, "snd_boat_water_pitch_max" },
    { 0x9DADB11A, "snd_boat_water_slow_max" },
    { 0x9DADB218, "snd_boat_water_slow_min" },
    { 0xE0034D4E, "snd_draw3D" },
    { 0xEE29AD63, "snd_drawInfo" },
    { 0xEE2F2EFF, "snd_drawSort" },
    { 0xA100EC92, "snd_futz" },
    { 0x69E7605C, "snd_jetgun_loop_start" },
    { 0xF4959003, "snd_jetgun_pitch_end" },
    { 0x713A407A, "snd_jetgun_pitch_start" },
    { 0xEEF7E8A6, "snd_losOcclusion" },
    { 0xDED49143, "snd_max_ram_voice" },
    { 0x82A08E2F, "snd_max_stream_voice" },
    { 0xB5FE1126, "snd_minigun_loop_start" },
    { 0xB8D44F8D, "snd_minigun_pitch_end" },
    { 0x40270A84, "snd_minigun_pitch_start" },
    { 0x7D7035D6, "snd_ps3_vol_occlusion_attenuation_dry" },
    { 0x7D7084F7, "snd_ps3_vol_occlusion_attenuation_wet" },
    { 0xAF00532C, "snd_speakerConfiguration" },
    { 0xA63612C6, "snd_throttle_reduce_vol" },
    { 0xF6620000, "snd_throttle_time_held_down" },
    { 0xED9B95E3, "snd_trace_master" },
    { 0xF98F29FD, "snd_trace_reverb" },
    { 0x9380886D, "snd_trace_voice" },
    { 0x23594A7E, "spawnsystem_allow_culling" },
    { 0x962F067C, "spawnsystem_allow_non_team_spawns" },
    { 0x3CB0EBA1, "spawnsystem_badspawn_aggression_delay" },
    { 0x8740906E, "spawnsystem_badspawn_damage_delay" },
    { 0xB768E8AE, "spawnsystem_badspawn_force_record" },
    { 0x3DD40F51, "spawnsystem_danger_time" },
    { 0xCACE8639, "spawnsystem_debug" },
    { 0xB40F1B1A, "spawnsystem_debug_archive" },
    { 0xAAD69222, "spawnsystem_debug_best_points" },
    { 0x030681EB, "spawnsystem_debug_influencer_pulse" },
    { 0x035124B7, "spawnsystem_debug_influencer_types" },
    { 0xAC212D56, "spawnsystem_debug_influencers" },
    { 0xD413BE8E, "spawnsystem_debug_liveedit" },
    { 0x851C1585, "spawnsystem_debug_player" },
    { 0xE98AFCFC, "spawnsystem_debug_point_weights" },
    { 0x85569535, "spawnsystem_debug_points" },
    { 0xAF17956B, "spawnsystem_debug_showclients" },
    { 0xCE19E6D8, "spawnsystem_debug_sideswitched" },
    { 0xDAC0C03F, "spawnsystem_debug_team" },
    { 0xB8E74020, "spawnsystem_debug_visibility" },
    { 0xFD0CD50E, "spawnsystem_debug_visibility_time" },
    { 0x4875FFD0, "spawnsystem_demo_enable_parsing" },
    { 0x903501C8, "spawnsystem_demo_max_written" },
    { 0x79FF75AD, "spawnsystem_enemy_influencer_stacking" },
    { 0xE355341E, "spawnsystem_enemy_spawned_influencer_stacking" },
    { 0xB8053DC7, "spawnsystem_friend_influencer_stacking" },
    { 0x2A39BDED, "spawnsystem_old_vis_mask" },
    { 0x9B16B75C, "spawnsystem_score_cull_min_points" },
    { 0xC17771CD, "spawnsystem_score_cull_percent" },
    { 0xC9CD0750, "spawnsystem_score_cull_time_max" },
    { 0xC9CD084E, "spawnsystem_score_cull_time_min" },
    { 0x8AFE7F9D, "spawnsystem_sight_check_max_distance" },
    { 0xD3530F8F, "spawnsystem_sight_height_offset" },
    { 0xBE5CA5AA, "spawnsystem_weapon_influencer_min_length" },
    { 0x3DFB7EC5, "spawnsystem_weapon_influencer_push_through" },
    { 0x22133061, "spawnsystem_weapon_influencer_sight_check" },
    { 0x0E697DCC, "spawnsystem_weapon_influencer_update_interval" },
    { 0x99132F31, "splitscreen" },
    { 0xD45F3B5E, "splitscreen_lobbyPlayerCount" },
    { 0x5FFE1776, "splitscreen_partyPlayerCount" },
    { 0xE6FF85E6, "splitscreen_playerCount" },
    { 0x477105CD, "splitscreen_playerNum" },
    { 0x1C48A84D, "spmode" },
    { 0x300AD8E6, "stat_version" },
    { 0x000EDFD5, "statsLocationFatal" },
    { 0x540EF316, "stats_version_check" },
    { 0xC1FA099C, "stopspeed" },
    { 0xA197286D, "storeMapPackMaskToStats" },
    { 0x7DDC1B7F, "sv_FFCheckSums" },
    { 0x05D7216D, "sv_FFNames" },
    { 0xB21396CF, "sv_FakeRemoteClient" },
    { 0xACABA59A, "sv_allowAimAssist" },
    { 0x02A5BA35, "sv_allowAnonymous" },
    { 0xEDA81065, "sv_allowDof" },
    { 0x500363B1, "sv_assistWorkers" },
    { 0xF0F8D0A5, "sv_authenticating" },
    { 0xAB0EF6CA, "sv_badLoadoutAction" },
    { 0x0A7DE6FE, "sv_badRankAction" },
    { 0x2592DAA3, "sv_bitfieldTracking" },
    { 0xABB9B265, "sv_cheats" },
    { 0x27323074, "sv_clientFpsLimit" },
    { 0xA4DCD66C, "sv_clientSideBullets" },
    { 0xDC6C5144, "sv_clientSideVehicles" },
    { 0x259C67B1, "sv_clientside" },
    { 0xE1EED5FE, "sv_connectTimeout" },
    { 0x6852EE80, "sv_connectionLogProbability" },
    { 0x42C6E4B7, "sv_connectionLogSamplesPerSecond" },
    { 0x6F794DD3, "sv_disableClientConsole" },
    { 0x1410B478, "sv_dwlsgerror" },
    { 0xC45E58C3, "sv_enableBounces" },
    { 0xC8DB9DCC, "sv_endGameIfISuck" },
    { 0xA2A8EFB9, "sv_expensive_bullet_time" },
    { 0x208A1E8C, "sv_externalEventLoop" },
    { 0xD367D3FB, "sv_fakeServerLoad" },
    { 0x2B1787E0, "sv_fakeServerLoadRand" },
    { 0xC5EFFAC2, "sv_floodprotect" },
    { 0x59EA1BF4, "sv_forceunranked" },
    { 0x5B0D334C, "sv_hostname" },
    { 0x8BB00AE5, "sv_iwdNames" },
    { 0xB25C5584, "sv_iwds" },
    { 0x2C426345, "sv_keywords" },
    { 0x5CCDBF3B, "sv_mapRotation" },
    { 0xC32D27FE, "sv_mapRotationCurrent" },
    { 0x27BE48D2, "sv_maxPhysExplosionSpheres" },
    { 0x15C21E61, "sv_maxPing" },
    { 0x851B42E5, "sv_maxclients" },
    { 0x27B66E5F, "sv_minPing" },
    { 0x755EF890, "sv_momentumPercent" },
    { 0x15341B00, "sv_networkRateSolution" },
    { 0x5D8EB89F, "sv_network_fps" },
    { 0xC5E60B4B, "sv_noname" },
    { 0xB960A666, "sv_onlineHostSnapshotRateThrottled" },
    { 0xC99727AF, "sv_paused" },
    { 0xBF2D1F2E, "sv_playlistFetchInterval" },
    { 0xC6CA84DA, "sv_privateClients" },
    { 0xC5857133, "sv_privateClientsForClients" },
    { 0x69081AFB, "sv_privatePassword" },
    { 0xB2602569, "sv_pure" },
    { 0x597F84CC, "sv_rateBoostingAllowUnackDeltas" },
    { 0x040BB9F6, "sv_rateBoostingDebugForceSuspend" },
    { 0x76BE2F89, "sv_rateBoostingEnabled" },
    { 0xDB3BB67E, "sv_rateBoostingMaxUploadUsage" },
    { 0x6C85664F, "sv_rateBoostingMinUploadScale" },
    { 0x8E98B743, "sv_rateBoostingRecoverTime" },
    { 0xE435F8AD, "sv_rateBoostingSuspendBadFramesCPU" },
    { 0x6616C07A, "sv_rateBoostingSuspendBadFramesCPUThreshold" },
    { 0xC38ABE74, "sv_rateBoostingSuspendBadFramesCPUTimeout" },
    { 0x87494249, "sv_rateBoostingSuspendedMaxUploadUsage" },
    { 0xF6BACA8D, "sv_reconnectlimit" },
    { 0xF9608092, "sv_referencedFFCheckSums" },
    { 0x45C5F500, "sv_referencedFFNames" },
    { 0xC97950D8, "sv_referencedIwdNames" },
    { 0x768299F7, "sv_referencedIwds" },
    { 0xC9EB8E36, "sv_restrictedTempEnts" },
    { 0xC4966CEE, "sv_running" },
    { 0x53432D26, "sv_serverLogClientPings" },
    { 0x42761174, "sv_timeout" },
    { 0xFECDF523, "sv_voice" },
    { 0x1661226C, "sv_voiceQuality" },
    { 0x4960F978, "sv_writeConfigStrings" },
    { 0x9D64B4C2, "sv_zombietime" },
    { 0x260AD10E, "sys_configSum" },
    { 0x58DE470E, "sys_configureGHz" },
    { 0xB6C90254, "sys_cpuGHz" },
    { 0x8FED046C, "sys_cpuName" },
    { 0xBABFFB2F, "sys_gpu" },
    { 0x6B899E51, "sys_sysMB" },
    { 0x0BBF1FB8, "systemlink" },
    { 0x5297D838, "teamsplitter_verbose" },
    { 0x32B722EC, "terriblePing" },
    { 0xDB9886D4, "throwback_enabled" },
    { 0xAD15CC70, "tickerHeaderWidth" },
    { 0x5BFDEB7C, "timescale" },
    { 0x41121C2D, "tree_bend" },
    { 0xB90AB786, "tree_frequency" },
    { 0xF3141235, "tree_random" },
    { 0x1C57763F, "tu10_demo_oldposInsteadOfMapCenter" },
    { 0xF8CC24E9, "tu10_demo_skipBuildingDemoSnapshotDuringCinematicPlayback" },
    { 0x9FA398EC, "tu10_eliteMarketingOptInPopupEnabled" },
    { 0x246E0A60, "tu10_noProfileWriteSleep" },
    { 0xAD44CD2C, "tu10_reconnectToClientOnDTLSTimeout" },
    { 0xD95DEBFC, "tu10_searchSessionIgnoreMapPacks" },
    { 0x1F00DC1E, "tu10_statsCheckIW6promo" },
    { 0x5BD9699F, "tu10_updateLobbyMapPackFlagsOnClientJoin" },
    { 0xC3C4280D, "tu11_AddMapPackFlagsUserInfo" },
    { 0x574561EA, "tu11_cg_killstreak_target_diamond_when_emped" },
    { 0xE46013C4, "tu11_deleteSessionIfNotHost" },
    { 0xDE1190A5, "tu11_demoSendEventOnFailure" },
    { 0x71F6B9EA, "tu11_gateInGameMenusOnInitialPlayersConnectedRespondedTo" },
    { 0x0AD089CC, "tu11_handleLowmipReadErrors" },
    { 0xE506EC19, "tu11_luiCompleteAnimationFix" },
    { 0x572040AF, "tu11_partymigrate_WirelessLatencyIncrease" },
    { 0x7E163044, "tu11_partymigrate_allowPrivatePartyClientsToHost" },
    { 0xD1AB9ADE, "tu11_partymigrate_useStdDev" },
    { 0x64B6C9E9, "tu11_player_keepZVelocity" },
    { 0x8141CCF5, "tu11_resetGameModesOnCablePull" },
    { 0x067159DD, "tu11_returnChangedInUpdateClientInfoWhenRemovingAttachModel" },
    { 0xC06B792D, "tu11_sendVoteToFBEnabled" },
    { 0x662C36B7, "tu11_showGeoInfo" },
    { 0xFC5EF3DC, "tu11_statsSetConnectionType" },
    { 0x2CF97355, "tu11_useMissileKnockbackHeldWeaponsOnly" },
    { 0x6430CBB5, "tu11_use_animscripted_blends" },
    { 0xC11D15FC, "tu11_waitOnContent" },
    { 0x93FFECE3, "tu11_waitOnContentTimeout" },
    { 0xB3416C1D, "tu11_zombie_turret_placement_ignores_bodies" },
    { 0x23C59279, "tu12_always_switch_away_from_briefcase" },
    { 0x7298DE7A, "tu12_cg_vehicleCamAboveWater" },
    { 0xC8CECDC1, "tu12_destructible_entity_radius_damage_fix" },
    { 0x6F4D2CFA, "tu12_mtxLostVoteChecks" },
    { 0x03F066BE, "tu12_searchSessionOverrideGeoLocation" },
    { 0x79E55BD0, "tu12_updatePCacheOfAllLocalPlayers" },
    { 0xB146C45E, "tu12_validate_bonus_cards_on_server" },
    { 0x5A0C823E, "tu12_zm_force_center_cg_cursorhint" },
    { 0x731FEB37, "tu12_zm_stack_fire_fix" },
    { 0x2B397BB1, "tu12_zm_stop_firing_when_overheated" },
    { 0xD9DEE937, "tu12_zombie_allow_switch_to_detonator_only" },
    { 0x1F0A2129, "tu12_zombies_allow_hint_weapon_from_script" },
    { 0xED6F8D8E, "tu13_allow_no_player_melee_blood" },
    { 0x363D476E, "tu13_bg_enableBulletWeaponBounce" },
    { 0x99A2BD37, "tu13_filterdedicatedserverresults" },
    { 0xD05C478C, "tu13_recordContentAvailable" },
    { 0x5B6D0EE6, "tu13_zm_check_traversal_max_z" },
    { 0xC66CB275, "tu14_aiAllowForceNoCullCheck" },
    { 0xCBEDA0DC, "tu14_bg_chargeShotExponentialAmmoPerChargeLevel" },
    { 0x0F942F44, "tu14_demo_enableHeliHeightLockExcludeFromDemo" },
    { 0xC70C177F, "tu14_initialize_groundEntityNum" },
    { 0x99F9C902, "tu14_preventStartingChargeShotWhileFiring" },
    { 0x529E1858, "tu14_reloadCustomGameTypesAfterFFOTD" },
    { 0x311CEF9C, "tu14_resumeLobbyCountdown" },
    { 0x9756E586, "tu15_quadrotorPathingFix" },
    { 0xDF1D9C6E, "tu15_zombie_local_player_test_honors_client_server_divide" },
    { 0x6D7FE587, "tu16_waitOnGhostLBRetrieval" },
    { 0xC102720E, "tu16_waitOnGhostLBRetrievalTimeout" },
    { 0x43EC441B, "tu2_delayComErrorForPlaylistRules" },
    { 0x5FA17DEB, "tu2_luiHacksDisabled" },
    { 0x7FD62C69, "tu2_partyCheckRulesAlways" },
    { 0xB4AF1846, "tu2_partyCheckRulesOnSetup" },
    { 0x120DD899, "tu2_stopPartyForPlaylistRules" },
    { 0x62A6693E, "tu3_canSetDvars" },
    { 0xFAC387AA, "tu3_disableDWGuests" },
    { 0x0F5159FE, "tu3_resetStatsOnFailedValidate" },
    { 0xFA520861, "tu4_checkStatsCheckSum" },
    { 0x5E0E5480, "tu4_checkXUIDBeforeStatsUpload" },
    { 0x922D4C28, "tu4_copyGamertagOnStatsDownload" },
    { 0xD450E494, "tu4_removeClientsFromInactivePartyToNotify" },
    { 0x73C3068E, "tu4_removeUsingXuidClientFromPartyToNotify" },
    { 0x82ABFB69, "tu4_statsParity" },
    { 0xB0F3FB62, "tu4_useRealXUIDForStats" },
    { 0x2BE7E5DB, "tu5_check_unique_attachments_enabled" },
    { 0x386F8B2B, "tu5_uav_ads_fix" },
    { 0xB73F9A6A, "tu6_CaCImportVerifyDLCWeapons" },
    { 0xA0D067E5, "tu6_cg_destructible_radius_damage_enabled" },
    { 0xEBCB0280, "tu6_checkNonPrimaryXUIDPS3" },
    { 0x5527FA83, "tu6_clearFileShareOnSignOut" },
    { 0xAFB7475A, "tu6_conflictingAttachmentCheck" },
    { 0x7F93BBC6, "tu6_dynEnt_disable_rb_collision" },
    { 0xA321E96B, "tu6_dynEnt_small_cylinder_dimension" },
    { 0xA78DEA72, "tu6_dynEnt_small_cylinder_max_avel" },
    { 0xBA3E5E4C, "tu6_emblemVoting" },
    { 0x97A055DA, "tu6_enableDLCWeapons" },
    { 0x2A61B3BD, "tu6_execffotdlua" },
    { 0xF4F65946, "tu6_hideDLCImages" },
    { 0x23D7A354, "tu6_ignoreOtherModesDLC" },
    { 0x9A54ED27, "tu6_ignoreSeasonPass" },
    { 0xB3E588CF, "tu6_marketingOptIn" },
    { 0x7806AA54, "tu6_perkBonusCardCheck" },
    { 0xF0556873, "tu6_player_jump_blocks_tac_insert" },
    { 0x1C65C685, "tu6_player_shallowWaterHeight" },
    { 0x4A609F88, "tu6_verifyUnusedAttachmentSlotsCheck" },
    { 0x230B08DC, "tu6_writeStatsXUIDOnGameStart" },
    { 0x1DDCA0B0, "tu7_3rdPersonSpecateFix" },
    { 0xE7AEF324, "tu7_additionalGrenadeChecks" },
    { 0x460A4EF4, "tu7_botsCountAsPartyMembers" },
    { 0xA3C6CD74, "tu7_cg_deathCamAboveWater" },
    { 0x47556581, "tu7_clampMeleeChargeHorzLaunch" },
    { 0x7F77093D, "tu7_clampMeleeChargeJumping" },
    { 0xE1534BE4, "tu7_clampMeleeChargeJumpingMaxZVel" },
    { 0xE68FD88D, "tu7_fileshareRetry" },
    { 0xFA97D3A0, "tu7_fileshareShowFailure" },
    { 0x80EBAA1E, "tu7_itemOptionLocked" },
    { 0xBC8648FC, "tu7_itemOptionLockedByChallenge" },
    { 0xC1C0E83B, "tu7_itemOptionLockedByChallengeResult" },
    { 0x88271ADD, "tu7_itemOptionLockedResult" },
    { 0x027EB3EF, "tu7_mapbased_killstreaks_fix" },
    { 0x033F5A5C, "tu7_partyDoublePartyCloseFix" },
    { 0xB08EDADD, "tu7_restoreBlur" },
    { 0x0E18A546, "tu7_scoreboardPingAsNumbers" },
    { 0xD945CF3A, "tu7_setGuestStatsFetched" },
    { 0x0FE6FE05, "tu7_skipStableStats" },
    { 0xA13C6EAA, "tu7_statsCheckGroupMask" },
    { 0x872E1511, "tu7_statsCheckSeasonPass" },
    { 0x6E4C0B33, "tu7_statsErrorBackup" },
    { 0x8B4F8966, "tu7_statsErrorNormal" },
    { 0x4DCE15AC, "tu7_statsErrorOtherPlayer" },
    { 0x974A4F38, "tu7_statsErrorStable" },
    { 0x36F9810E, "tu7_ui_multiteam_compass_fix" },
    { 0x57B97AE8, "tu7_usePCmatchmaking" },
    { 0xA5847FE2, "tu7_usePingSlider" },
    { 0xC7310023, "tu7_verifyStableStats" },
    { 0xD5BB0CA8, "tu8_additionalMTXChecks" },
    { 0xEB8D9519, "tu8_autoRestartSteamServerFailed" },
    { 0x00285083, "tu8_cancelMatchStartReturnValue" },
    { 0x376064C4, "tu8_comerrorSteamServerFailed" },
    { 0xB8C8E3B5, "tu8_defaultClassSetCount" },
    { 0x7B613368, "tu8_mtx_enabled" },
    { 0x9DC360C9, "tu8_nullStatsBuffer" },
    { 0x3ED9677B, "tu8_partyDisconnectExtraPacket" },
    { 0x6B51874F, "tu8_purchasedClassSetCount" },
    { 0x9981246D, "tu8_script_mover_workaround" },
    { 0x681164DF, "tu8_storeContentInfoInStats" },
    { 0xA5CD2445, "tu8_trackStatsAccessError" },
    { 0x273AE627, "tu8_useClassSets" },
    { 0xCC76743A, "tu9_checkForValidGameMode" },
    { 0xEE832447, "tu9_clearedMapPackFlagsFix" },
    { 0x535769D5, "tu9_deletePresenceSessionInGraveYardFix" },
    { 0x50A5FE0F, "tu9_ingnoreValidateWeaponOnDeath" },
    { 0x33CBF4E2, "tu9_keepSwappedPlayersInPartyToNotify" },
    { 0xB10C81B8, "tu9_offlinehostdisconnectfix" },
    { 0xB506A213, "tu9_partyErrorOnInGameMigrateFail" },
    { 0x4C8B50DB, "tu9_projectile_dobj_fix" },
    { 0x5530B40A, "tu9_rerunPlaylistRulesOnHost" },
    { 0x18782B97, "tu9_steamCheckMTX" },
    { 0x25084001, "tu9_steamRetryServerInit" },
    { 0xC6273984, "tu9_tank_minimap_fix" },
    { 0x1D09EE8D, "tu9_testMissingContentPacks" },
    { 0x03ABD421, "tu9_turret_mark_rate" },
    { 0x7BE3EF65, "tu9_validateStatsOnSignout" },
    { 0x8C1FD923, "tu_10_matchRatingSampleChance" },
    { 0x57D0D476, "tu_allowDLCWeaponsByOwnership" },
    { 0x25700162, "tu_cleanUpTurretOnDisconnect" },
    { 0x661CB3B3, "tu_deferScriptMissileDetonation" },
    { 0xC5132A50, "tu_dontDropKillstreakOnDeath" },
    { 0xC431A7E7, "tu_enforceRechamberOnSwitch" },
    { 0x38BE3FAB, "tu_isolateDamageFlash" },
    { 0x7F632D53, "tu_limitGrenadeImpacts" },
    { 0x86553053, "turretPlayerAvoidScale" },
    { 0x570F64D6, "turret_KillstreakTargetTime" },
    { 0xBD86B505, "turret_SentryTargetTime" },
    { 0xF3552066, "turret_TargetLeadBias" },
    { 0xE0314C49, "turret_placement_trace_maxs" },
    { 0xE0316D07, "turret_placement_trace_mins" },
    { 0x656B4419, "turretplacement_traceOffset" },
    { 0xFB2A7006, "turretplacement_useTraceOffset" },
    { 0xF37DFFDB, "twEnabled" },
    { 0x1A3EA143, "twitchEnabled" },
    { 0x2BF952EE, "typeWriterCod7LetterFXTime" },
    { 0x08C50955, "ui_DSPPromotionInterval" },
    { 0x8FA86671, "ui_MOTDScrollRate" },
    { 0xC41DC514, "ui_SPReminderPopupInterval" },
    { 0x53E50C7C, "ui_allow_classchange" },
    { 0x6F46785A, "ui_allow_controlschange" },
    { 0x5B4BD50D, "ui_allow_teamchange" },
    { 0x3EE5847F, "ui_allowvote" },
    { 0xD16B85EE, "ui_ammo_stock_width" },
    { 0xE614BF60, "ui_animSpeedScale" },
    { 0x97B631E0, "ui_autoContinue" },
    { 0xF635298B, "ui_bigFont" },
    { 0x39BC5FF2, "ui_borderLowLightScale" },
    { 0x84A6B616, "ui_busyBlockIngameMenu" },
    { 0xDA1B5727, "ui_choice_noaction" },
    { 0x76CF99CA, "ui_combatCurrScrollBarPos" },
    { 0x81F9E3E3, "ui_currentMap" },
    { 0xEAF115CA, "ui_currentNetMap" },
    { 0x0C71C601, "ui_customModeDesc" },
    { 0x655713A7, "ui_customModeEditDesc" },
    { 0x655C7DA9, "ui_customModeEditName" },
    { 0x0C773003, "ui_customModeName" },
    { 0x0C2C3BBD, "ui_custom_name" },
    { 0xBDB78ABE, "ui_deadquote" },
    { 0xAF47D0D9, "ui_dedicated" },
    { 0x70161DC8, "ui_demoname" },
    { 0x034B18F8, "ui_detailedMM" },
    { 0xAEE4740B, "ui_display_aar" },
    { 0x647AEFC9, "ui_drawBuildNumber" },
    { 0xE9380F0D, "ui_drawOldUI" },
    { 0xD4A553C1, "ui_drawSpinnerAfterMovie" },
    { 0x8C1F4E8F, "ui_email_address" },
    { 0x9FEA6F17, "ui_enableDSPPromotion" },
    { 0x9B2FEFB7, "ui_enableGhostUpsellPopup" },
    { 0x5D4F4676, "ui_enableSPReminderPopup" },
    { 0xEC342191, "ui_errorMessage" },
    { 0x00776938, "ui_errorMessageDebug" },
    { 0x6464B70E, "ui_errorTitle" },
    { 0xF32020AB, "ui_ethernetLinkActive" },
    { 0x7B3FAF2F, "ui_extraBigFont" },
    { 0x685C42E8, "ui_favoriteAddress" },
    { 0x403E1463, "ui_favoriteName" },
    { 0x529BB9A6, "ui_favorite_message" },
    { 0x105C85DF, "ui_friendMessage" },
    { 0x538E16E5, "ui_friendNameNew" },
    { 0xCBEA4E83, "ui_friendPendingSelectedInd" },
    { 0x12860E5E, "ui_friendSelectedInd" },
    { 0x16D23665, "ui_friendlyfire" },
    { 0xC9E3031B, "ui_friendsListOpen" },
    { 0xE46A2696, "ui_fxFontColor" },
    { 0xC99B0AEF, "ui_fxFontGlowColor" },
    { 0xA3D6D096, "ui_fxFontOutlineColor" },
    { 0x92C7F93C, "ui_fxFontShadowColor" },
    { 0x0041651E, "ui_gametype" },
    { 0x36DBB942, "ui_gametype_text" },
    { 0xA13E7816, "ui_generic_status_bar" },
    { 0x7D9C8E75, "ui_ghostUpsellPopupInterval" },
    { 0x06017B9C, "ui_guncycle" },
    { 0x7B0E0CB5, "ui_gv_reloadSpeedModifier" },
    { 0x9A94CB01, "ui_heatMapColor" },
    { 0x54DE7BD5, "ui_heatMapColorForPlayer" },
    { 0x47B785A4, "ui_hideLeaderboards" },
    { 0x1DD561B1, "ui_hideMiniLeaderboards" },
    { 0x291AA767, "ui_hideminimap" },
    { 0x313D3F21, "ui_hostname" },
    { 0xD5B7474A, "ui_hud_hardcore" },
    { 0x5BBF9D99, "ui_hud_obituaries" },
    { 0x5490B5FA, "ui_hud_showobjicons" },
    { 0x8534E790, "ui_hud_visible" },
    { 0x1A122D61, "ui_ignoreMousePos" },
    { 0x9475988E, "ui_inGameStoreVisible" },
    { 0x80065971, "ui_inviteScreen" },
    { 0xDF0E2C95, "ui_inviteSelectedInd" },
    { 0x498E39F4, "ui_isClanMember" },
    { 0x09D9DD90, "ui_isDLCPopupEnabled" },
    { 0x1B98F491, "ui_isDLCRequiredPopupEnabled" },
    { 0x07212C6E, "ui_joinGametype" },
    { 0x4C35DF64, "ui_keyboard_dvar_edit" },
    { 0xBC7DE768, "ui_keyboard_dvar_new" },
    { 0x98D97FD5, "ui_keyboardtitle" },
    { 0xA0040C46, "ui_language" },
    { 0x61F61FB0, "ui_languagechanged" },
    { 0xE9C5526B, "ui_lastServerRefresh_0" },
    { 0xE9C5526C, "ui_lastServerRefresh_1" },
    { 0xE9C5526D, "ui_lastServerRefresh_2" },
    { 0xE9C5526E, "ui_lastServerRefresh_3" },
    { 0xE9C5526F, "ui_lastServerRefresh_4" },
    { 0xE66D3652, "ui_levelEra" },
    { 0xDE839F1F, "ui_listboxIndex" },
    { 0xF7030439, "ui_load_index" },
    { 0x028177A9, "ui_loadscreenTimeout" },
    { 0x8675ECEE, "ui_lobbypopup" },
    { 0x90A4DC29, "ui_mapCount" },
    { 0x509D4169, "ui_mapPackChanged" },
    { 0x32F384A1, "ui_mapname" },
    { 0x167739DE, "ui_menuLvlNotify" },
    { 0x2DFFD056, "ui_motd" },
    { 0x0156EB63, "ui_mousePitch" },
    { 0x24A48AB7, "ui_mpTheaterEnabled" },
    { 0x1EF6AE8D, "ui_mpWagerMatchEnabled" },
    { 0xEDFCAB08, "ui_mtxid" },
    { 0x4C6AC95A, "ui_multiplayer" },
    { 0xD6561D86, "ui_netGametypeName" },
    { 0x23FFB21A, "ui_netSource" },
    { 0xBF97F3FF, "ui_options_open" },
    { 0xC4FEB905, "ui_partyFull" },
    { 0x17406EBB, "ui_party_download_bar_color" },
    { 0x0A415435, "ui_party_download_bar_height" },
    { 0xF608A59D, "ui_playerListOpen" },
    { 0x3C6F92FB, "ui_playercardOpen" },
    { 0x8E6B5CFD, "ui_playlistPopulationRefreshTime" },
    { 0x0A1F88FF, "ui_prevTextEntryBox" },
    { 0x40C76424, "ui_preview" },
    { 0x609ACAC1, "ui_preview_map" },
    { 0x79220E1B, "ui_readingSaveDevice" },
    { 0x562CD2C8, "ui_right_ammo_width" },
    { 0x02F8B8DA, "ui_safearea" },
    { 0xCCF34D1D, "ui_scorelimit" },
    { 0xA4D4DC66, "ui_scrollBarWidth" },
    { 0x1E6C7D84, "ui_scrollByRow" },
    { 0x9CF16803, "ui_scrollEmptySpaceHeightPercentage" },
    { 0xC2C77D50, "ui_scrollFontScale" },
    { 0x99AB4D74, "ui_scrollMOTDDelay" },
    { 0x19252B65, "ui_scrollMOTDYOffset" },
    { 0x136572F7, "ui_scrollMOTDYOffsetResetDelay" },
    { 0x2D7A20BD, "ui_scrollMinUpdateInterval" },
    { 0x1F9AF602, "ui_scrollSpeed" },
    { 0xE7BB90C5, "ui_scrollTextDelay" },
    { 0xA36D3811, "ui_scrollTextScrollRate" },
    { 0x2C5386F6, "ui_scrollTextYOffset" },
    { 0xF60437C8, "ui_scrollTextYOffsetResetDelay" },
    { 0x5C65ACE4, "ui_serverStatusTimeOut" },
    { 0xC6D82D8A, "ui_serverinfomessage" },
    { 0x39BB4229, "ui_serverinfomessagehostname" },
    { 0x110ED559, "ui_showBryceMagic" },
    { 0xCF73FCE7, "ui_showDLCMaps" },
    { 0x618612E1, "ui_showNewestLeaderboards" },
    { 0x11181601, "ui_showmap" },
    { 0x055760F2, "ui_smallFont" },
    { 0x230178DF, "ui_specops" },
    { 0x86B4448E, "ui_splitscreen" },
    { 0x70D6EFC1, "ui_storeButtonPressed" },
    { 0xD42141C5, "ui_text_endreason" },
    { 0x5434D710, "ui_timelimit" },
    { 0x8445C81E, "ui_totalDLCReleased" },
    { 0xF2772EAC, "ui_useCustomClassInfo" },
    { 0x41A6C572, "ui_weapon_tiers" },
    { 0xA4E1C392, "ui_xpscale" },
    { 0x6B64B9B4, "ui_zm_gamemodegroup" },
    { 0xC955B4CD, "ui_zm_mapstartlocation" },
    { 0x2FA084D6, "unsubscriptionCooloffTimer" },
    { 0x19548C15, "useMapPreloading" },
    { 0xAE1FF67E, "useSvMapPreloading" },
    { 0xFE18CD45, "username" },
    { 0xB8F26DBF, "using_original" },
    { 0x22550FD2, "vc_FBM" },
    { 0x22551077, "vc_FGM" },
    { 0x22551203, "vc_FSM" },
    { 0x225519B4, "vc_HMB" },
    { 0x225519B9, "vc_HMG" },
    { 0x225519C4, "vc_HMR" },
    { 0x22552A34, "vc_LIB" },
    { 0x22552A39, "vc_LIG" },
    { 0x22552A49, "vc_LIW" },
    { 0x22552AFA, "vc_LOB" },
    { 0x22552B0F, "vc_LOW" },
    { 0x22552BD2, "vc_LUT" },
    { 0x22552EF9, "vc_MMB" },
    { 0x22552EFE, "vc_MMG" },
    { 0x22552F09, "vc_MMR" },
    { 0x108E3854, "vc_RE" },
    { 0x6CFDB2E0, "vc_RGBH" },
    { 0x6CFDB2E4, "vc_RGBL" },
    { 0x108E3862, "vc_RS" },
    { 0x2255487F, "vc_SMB" },
    { 0x22554884, "vc_SMG" },
    { 0x2255488F, "vc_SMR" },
    { 0x6CFE5CEF, "vc_SNAP" },
    { 0x108E393E, "vc_YH" },
    { 0x108E3942, "vc_YL" },
    { 0x13FF0109, "vcs_WindowState" },
    { 0xC2DE4CDE, "vcs_timelimit" },
    { 0xAD6996C1, "vehGunnerSplashDamage" },
    { 0x1B673854, "vehHelicopterDefaultPitch" },
    { 0xE812A98E, "vehHelicopterFreeLook" },
    { 0xBAF177F9, "vehHelicopterHoverSpeedThreshold" },
    { 0x7864000C, "vehHelicopterInvertUpDown" },
    { 0x54B2C6EE, "vehHelicopterLookaheadTime" },
    { 0xAA4E2EE6, "vehHelicopterMaxHeightLockOffset" },
    { 0x5E7C6BE4, "vehHelicopterMinHeightLockOffset" },
    { 0xEF1AB05E, "vehHelicopterPathTransitionTime" },
    { 0xA8F24A9D, "vehHelicopterRightStickDeadzone" },
    { 0x37212BC9, "vehHelicopterRotDecel" },
    { 0x8FE822AA, "vehHelicopterScaleMovement" },
    { 0x8922B372, "vehHelicopterSoftCollisions" },
    { 0x6A326686, "vehHelicopterStrafeDeadzone" },
    { 0xB7A5BCFD, "vehHelicopterTiltFromViewangles" },
    { 0x03DD6498, "vehHelicopterYawAltitudeControls" },
    { 0xDFCE882E, "vehHelicopterYawOnLeftStick" },
    { 0x7CC8F2E6, "vehHelicopterboundMapHeight" },
    { 0x1B9C174C, "vehHelicopterboundMapLowerRightX" },
    { 0x1B9C174D, "vehHelicopterboundMapLowerRightY" },
    { 0xF4EA7E1C, "vehHelicopterboundMapUpperLeftX" },
    { 0xF4EA7E1D, "vehHelicopterboundMapUpperLeftY" },
    { 0x760DB45F, "vehHelicopterboundsOn" },
    { 0x393E622D, "vehLocationalVehicleSeatEntry" },
    { 0xB57111A2, "vehLockTurretToPlayerView" },
    { 0x316F29E6, "vehNPCThrottleMultiplier" },
    { 0xD60C8B21, "vehPlaneAssistedFlying" },
    { 0x8B66B306, "vehPlaneConventionalFlight" },
    { 0xB5AADC4D, "vehPlaneFakeLiftForce" },
    { 0x8195002D, "vehPlaneGravityForce" },
    { 0xF54E00F6, "vehPlaneLiftForce" },
    { 0x9FD008BB, "vehPlaneLowSpeed" },
    { 0x81D8C0A8, "vehPlanePitchAccel" },
    { 0x2867604F, "vehPlanePlayerAvoidance" },
    { 0xF4967D29, "vehPlaneRollAccel" },
    { 0x537EFAFB, "vehPlaneRollDeadZone" },
    { 0x458375AA, "vehPlaneSpeedControl" },
    { 0x96B01DCA, "vehPlaneTurnAssistDecayRate" },
    { 0x184193BE, "vehPlaneYawFromRollScale" },
    { 0x6978859A, "vehPlaneYawSpeed" },
    { 0xA861A373, "vehanim_debug" },
    { 0xB78D3AD3, "vehanim_enable" },
    { 0x80CFAA4C, "vehicleMouseExtraTurnSpeed" },
    { 0x521A778E, "vehicle_collision_prediction_time" },
    { 0xF27A42BE, "vehicle_damage_bouncing_betty" },
    { 0x8F401D8A, "vehicle_damage_bullet" },
    { 0xF0A9DF38, "vehicle_damage_grenade" },
    { 0x2B8A9B5E, "vehicle_damage_max_shielding" },
    { 0x4AC53CD3, "vehicle_damage_projectile" },
    { 0xAA48E5CF, "vehicle_damage_satchel_charge" },
    { 0x2502256E, "vehicle_damage_sticky_grenade" },
    { 0x9ACAE746, "vehicle_damage_zone_front" },
    { 0x42C6B007, "vehicle_damage_zone_rear" },
    { 0x42C74DC2, "vehicle_damage_zone_side" },
    { 0x9BD7F55B, "vehicle_damage_zone_under" },
    { 0x55FD9D67, "vehicle_destructible_damage_bouncing_betty" },
    { 0x274433CE, "vehicle_destructible_damage_bouncing_betty_radius" },
    { 0xC74DD601, "vehicle_destructible_damage_grenade" },
    { 0x84BF7B28, "vehicle_destructible_damage_grenade_radius" },
    { 0x2F8287C3, "vehicle_destructible_damage_projectile_radius" },
    { 0x0DCC4078, "vehicle_destructible_damage_satchel_charge" },
    { 0xE63C99BF, "vehicle_destructible_damage_satchel_charge_radius" },
    { 0x88858017, "vehicle_destructible_damage_sticky_grenade" },
    { 0xE71C307E, "vehicle_destructible_damage_sticky_grenade_radius" },
    { 0x29D4A545, "vehicle_piece_damagesfx_threshold" },
    { 0x0671C64C, "vehicle_push_during_mantle" },
    { 0xCF5FAD41, "vehicle_riding" },
    { 0xF04B1FFA, "vehicle_selfCollision" },
    { 0xD30DB9E6, "vehicle_sounds_cutoff" },
    { 0x4A24E650, "vehicle_switch_seat_delay" },
    { 0xDF156A59, "vehicle_useRadius" },
    { 0x73006C4B, "version" },
    { 0xE4ED0451, "vid_xpos" },
    { 0xE4ED90B2, "vid_ypos" },
    { 0xC9AFDAFE, "visionstore_glowTweakBloomCutoff" },
    { 0x808EE92A, "visionstore_glowTweakBloomDesaturation" },
    { 0x7EE32ECE, "visionstore_glowTweakBloomIntensity0" },
    { 0x7EE32ECF, "visionstore_glowTweakBloomIntensity1" },
    { 0xC6230C45, "visionstore_glowTweakEnable" },
    { 0x5520E2F6, "visionstore_glowTweakRadius0" },
    { 0x5520E2F7, "visionstore_glowTweakRadius1" },
    { 0xF0E19088, "visionstore_glowTweakSkyBleedIntensity0" },
    { 0xF0E19089, "visionstore_glowTweakSkyBleedIntensity1" },
    { 0x34E3FC6D, "waitOnStatsTimeout" },
    { 0x35CF496B, "wallmount_turret_placement_trace_maxs" },
    { 0x35CF6A29, "wallmount_turret_placement_trace_mins" },
    { 0x109F866F, "war_a" },
    { 0x109F8670, "war_b" },
    { 0x109F8671, "war_c" },
    { 0x109F8672, "war_d" },
    { 0x109F8673, "war_e" },
    { 0x24905703, "war_sb" },
    { 0xDC170968, "waterbrush_entity" },
    { 0x66018204, "waypointDistFade" },
    { 0x783F0BAF, "waypointDistScaleRangeMax" },
    { 0x783F0CAD, "waypointDistScaleRangeMin" },
    { 0xE246DAE1, "waypointDistScaleSmallest" },
    { 0xCBC50A22, "waypointIconHeight" },
    { 0xA2651969, "waypointIconWidth" },
    { 0x28FF1CE8, "waypointMaxDrawDist" },
    { 0x16CDE0CC, "waypointOffscreenCornerRadius" },
    { 0xF3E9A099, "waypointOffscreenDistanceThresholdAlpha" },
    { 0x000D9745, "waypointOffscreenPadBottom" },
    { 0x8CD521BB, "waypointOffscreenPadLeft" },
    { 0x27E820CE, "waypointOffscreenPadRight" },
    { 0xFC82B7C3, "waypointOffscreenPadTop" },
    { 0xB4026927, "waypointOffscreenPointerDistance" },
    { 0x2C73DE95, "waypointOffscreenPointerHeight" },
    { 0x5F81AB7C, "waypointOffscreenPointerWidth" },
    { 0xE7ACDBC8, "waypointOffscreenRoundedCorners" },
    { 0x999911A5, "waypointOffscreenScaleLength" },
    { 0x23C5D0E8, "waypointOffscreenScaleSmallest" },
    { 0x9B954958, "waypointPlayerOffsetCrouch" },
    { 0x89832898, "waypointPlayerOffsetProne" },
    { 0xBDAB1245, "waypointPlayerOffsetRevive" },
    { 0x89BA4F4E, "waypointPlayerOffsetStand" },
    { 0x924DE8D4, "waypointSplitscreenScale" },
    { 0x1B106CBF, "waypointTimeFade" },
    { 0x2A5EEDB5, "waypointTweakY" },
    { 0x43939D56, "webmDwReadDelay" },
    { 0x4FFCE86E, "webmDwReadTimeout" },
    { 0xE87FB385, "webmDwWriteDelay" },
    { 0xE047465D, "webmDwWriteTimeout" },
    { 0x3A3B67E5, "webm_arnr_maxframes" },
    { 0x71DD9D70, "webm_arnr_strength" },
    { 0x6A30E023, "webm_arnr_type" },
    { 0xCCFA8C58, "webm_auto_kf" },
    { 0xFDF8905A, "webm_bitrate" },
    { 0xEB1DE6AE, "webm_buffer_high_timeout" },
    { 0x53F3C154, "webm_buffer_high_water_mark" },
    { 0xEA513B86, "webm_buffer_low_water_mark" },
    { 0xE4C5E351, "webm_drop_thresh" },
    { 0x5ADA29AD, "webm_enableautoaltref" },
    { 0x4AA2CACD, "webm_encAllowCamera" },
    { 0x259198F9, "webm_encEliteRequired" },
    { 0x1CA76AF3, "webm_encIdentityVerificationRequired" },
    { 0xF2E2398A, "webm_encRetryTime" },
    { 0x2D636DF0, "webm_encSendBufferTimeout" },
    { 0x40215FC9, "webm_encStatus" },
    { 0x005AA6DC, "webm_encStreamEnabled" },
    { 0xBA9FA3C3, "webm_encTwitchEnabled" },
    { 0x73A48F0E, "webm_encUiEnabled" },
    { 0x8BB81689, "webm_encUiEnabledCustom" },
    { 0xAA01B16D, "webm_encUiEnabledPublic" },
    { 0x9A33A4E9, "webm_encUiSigningIn" },
    { 0x51502929, "webm_highactivitythreshold" },
    { 0x1E29D67C, "webm_hq_bandwidth" },
    { 0xC21CE3FA, "webm_httpAuthLogin" },
    { 0xA1092E06, "webm_httpAuthMode" },
    { 0xA10A9998, "webm_httpAuthPass" },
    { 0xC2ADB882, "webm_httpAuthToken" },
    { 0xE641ED07, "webm_httpUploadUrl" },
    { 0xAF52B19A, "webm_httpUploadUrlTwitch" },
    { 0x08BC41D4, "webm_httpUploadUrlYouTube" },
    { 0x1EAFB424, "webm_kf_interval" },
    { 0x998B23A3, "webm_lag" },
    { 0xE1F74C00, "webm_lq_bandwidth" },
    { 0x28B9A19C, "webm_max_intra_bitrate" },
    { 0xCAF05FF4, "webm_mode" },
    { 0x48456280, "webm_profile" },
    { 0x293C20A5, "webm_q_max" },
    { 0x293C21A3, "webm_q_min" },
    { 0x882D09F5, "webm_rc_buf_initial_sz" },
    { 0x6ACD7EA1, "webm_rc_buf_optimal_sz" },
    { 0xA822CE4C, "webm_rc_buf_sz" },
    { 0x95715817, "webm_render_auto_kf" },
    { 0xC66F5C19, "webm_render_bitrate" },
    { 0x10B8A479, "webm_render_dont_connect_upfront" },
    { 0xE2CBD057, "webm_render_fps" },
    { 0x10BC2E3F, "webm_render_profile" },
    { 0xC5BEF0A4, "webm_render_q_max" },
    { 0xC5BEF1A2, "webm_render_q_min" },
    { 0xB4F48008, "webm_render_realtime_scale" },
    { 0xD23E0550, "webm_render_send_audio_first" },
    { 0x2D872519, "webm_render_threads" },
    { 0x99D9C754, "webm_render_uv_step" },
    { 0xB109695E, "webm_target_fps" },
    { 0x5399ADA0, "webm_twitchLasterror" },
    { 0xFAFBA5DB, "webm_twitchTransferChunkSize" },
    { 0x559AC81E, "webm_twitch_summaryRefresh" },
    { 0xD7207082, "webm_twitch_summaryUrl" },
    { 0x3551C1CB, "webm_usersStreaming" },
    { 0x679A1643, "webm_usersWaitingToStream" },
    { 0xEC0E8DF9, "webm_vol_game" },
    { 0xBC9F1ADD, "webm_vol_headset" },
    { 0x55062C5A, "webm_youtube_max_posts_per_second" },
    { 0xD40BCEFF, "welcome_shown" },
    { 0x9993C78E, "wideScreen" },
    { 0xDE5D2CDD, "wiiuGame" },
    { 0xDEC75842, "wiiuIkEnabled" },
    { 0x1AE3D292, "wind_debug_display" },
    { 0x48BD59F2, "wind_global_hi_altitude" },
    { 0x46A26833, "wind_global_low_altitude" },
    { 0x48713FB6, "wind_global_low_strength_percent" },
    { 0xB96DA139, "wind_global_vector" },
    { 0x349F0182, "wind_grass_gust_distance" },
    { 0x5BD124BF, "wind_grass_gust_radius" },
    { 0x40F220A8, "wind_grass_gust_speed" },
    { 0x57DD8426, "wind_grass_gust_strength" },
    { 0x0908289D, "wind_grass_gustinterval" },
    { 0x37EB947D, "wind_grass_scale" },
    { 0x33B66AB5, "wind_grass_tension" },
    { 0x44256435, "wind_leaf_scale" },
    { 0xE09AC8CD, "xPGroups" },
    { 0x41BC55F2, "xblive_clanListChanged" },
    { 0x1E0679B9, "xblive_clanmatch" },
    { 0x0AAC47C0, "xblive_ec_firstupdatems" },
    { 0x1FF43A8C, "xblive_ec_lastupdatems" },
    { 0x7D0A9288, "xblive_ec_maxprobewait" },
    { 0x222EE1AA, "xblive_ec_minpercent" },
    { 0x4F8627A4, "xblive_ec_minprobes" },
    { 0xB03F35F7, "xblive_loggedin" },
    { 0x7C70CCFE, "xblive_mappacks" },
    { 0x8C800EEF, "xblive_matchEndingSoon" },
    { 0xCCF798F6, "xblive_privatematch" },
    { 0x21C07C90, "xblive_rankedmatch" },
    { 0xE850B6BB, "xblive_theater" },
    { 0x0F87D4F1, "xblive_wagermatch" },
    { 0xE0DDE627, "xenonGame" },
    { 0x3354CA95, "xenon_maxVoicePacketsPerSec" },
    { 0x17B355F3, "xenon_maxVoicePacketsPerSecForServer" },
    { 0x130BAFAC, "ytAuthCooloff" },
    { 0x0BB50EBB, "ytAuthCooloffTime" },
    { 0x26DDBBBC, "ytForcePrivate" },
    { 0x59145A10, "zero_stats_check" },
    { 0x5D1D04D4, "zm_rand_mode" },
    { 0xD446AE4D, "zm_rand_loc" },
    { 0xFA91EA91, "zombie_debug" },
    { 0x4CD9FAEE, "zombie_devgui" },
    { 0x27D7087D, "zombie_double_wide_checks" },
    { 0x2ECA0C0E, "zombie_unlock_all" },
    { 0xDEB90F93, "zombie_useOldPathFallback" },
    { 0x4DECF257, "zombiemode_path_minz_bias" },
}};

} // namespace xsk::arc::t6
