// Copyright 2024 xensik. All rights reserved.
//
// Use of this source code is governed by a GNU GPLv3 license
// that can be found in the LICENSE file.

#include "xsk/arc/engine/t7.hpp"

namespace xsk::arc::t7
{

extern std::array<std::pair<u32, char const*>, hash_count> const hash_list
{{
    { 0x05C00BF0, "_" },
    { 0x5D7A7160, "_0" },
    { 0x6D3AFA7F, "_1h_rappel_start" },
    { 0x2C98FB0D, "_3d_print" },
    { 0x1B86D56D, "_5" },
    { 0x41894FD6, "_6" },
    { 0x8D8E44A8, "_8" },
    { 0xBDB38D71, "_80s_hatch1" },
    { 0x9CECBB8C, "_80s_sedan1" },
    { 0xAB7F6633, "_80s_wagon1" },
    { 0x56B1B627, "__" },
    { 0x1F1D7092, "___" },
    { 0x098E4910, "___archetypeonanimscriptedcallback" },
    { 0x764E48CC, "___archetypeonbehavecallback" },
    { 0xEEC9CA4E, "___do_last_step___" },
    { 0xDCB385F5, "___time_length___" },
    { 0x08526F31, "___y__" },
    { 0xBBAD2C5C, "__a" },
    { 0xF424F1BA, "__action_just_made" },
    { 0x9CA8AB73, "__ai_blackboard" },
    { 0x7D8F883A, "__ai_debuginterface" },
    { 0xFAB8548C, "__ai_forcegibs" },
    { 0x57954701, "__ai_interface" },
    { 0x99D92A8B, "__angles" },
    { 0x9975299A, "__array" },
    { 0x56D2C5B2, "__auto_delete__" },
    { 0x2DB49B97, "__b" },
    { 0x6D40F69C, "__blackboard" },
    { 0x56E4DEE1, "__bloody_death" },
    { 0xEFC5EFF6, "__bsms" },
    { 0x9E8B905B, "__chance" },
    { 0x0780CE43, "__clientfacialanimationslist" },
    { 0xD4F49BA0, "__clientfacialanimationsthinkstarted" },
    { 0x9B385CA5, "__constructor" },
    { 0xF5A9BA65, "__create_client_hud_elem" },
    { 0xC3E36C3C, "__def" },
    { 0x2633B922, "__default" },
    { 0xCB96917F, "__default1" },
    { 0x598F2244, "__default2" },
    { 0xD31F0F7B, "__delta" },
    { 0x5FBA2032, "__destructor" },
    { 0x2AD2861E, "__do_last_step__" },
    { 0x23A342B8, "__e" },
    { 0x23D5C676, "__ent" },
    { 0xE74A1BC6, "__entity" },
    { 0x95AAB1F3, "__f" },
    { 0x2917FBDA, "__facialanimationslist" },
    { 0x16ED8627, "__follow_spotlight_path__" },
    { 0xFC3895CF, "__force_stand_up" },
    { 0xF8BA67AD, "__forceaiflipmelee" },
    { 0xEEA99F32, "__forceaiwrestlemelee" },
    { 0x695070FD, "__func" },
    { 0xBD24456F, "__func_init_postload" },
    { 0x82270B24, "__func_init_preload" },
    { 0xE098FCED, "__function__" },
    { 0x6FA8378A, "__g" },
    { 0x8C87D8EB, "__init__" },
    { 0x2DC19561, "__init__sytem__" },
    { 0x321EC1C8, "__interface" },
    { 0x14C23F9A, "__item" },
    { 0x27CFBE7C, "__key" },
    { 0xC8ACDF63, "__last_dynamic_avoidance_action" },
    { 0x756BD1CB, "__levelonehealth" },
    { 0x3D4CD1CF, "__levelthreehealth" },
    { 0x41752731, "__leveltwohealth" },
    { 0x5B6B9132, "__main__" },
    { 0x726B25D3, "__max" },
    { 0x5CA637B4, "__message" },
    { 0xF55667DD, "__min" },
    { 0xB03CDC2E, "__msg" },
    { 0x1AB8D2BA, "__name" },
    { 0x7E9F3BAB, "__new" },
    { 0x6874D67F, "__node" },
    { 0x26DB2A86, "__obj" },
    { 0x771AF423, "__org" },
    { 0xD60EE3A5, "__origin" },
    { 0x670811ED, "__plane_weapons" },
    { 0x9E4AB048, "__player" },
    { 0xCD8CF507, "__r" },
    { 0xC34C7BC8, "__reqs" },
    { 0xF2A50A89, "__runpercent" },
    { 0xA78A7A9E, "__s" },
    { 0x7FDB7FB1, "__scene" },
    { 0x2A54F4CD, "__self" },
    { 0xE8FAAE25, "__shitloc" },
    { 0x710C3994, "__skiptoname" },
    { 0x543D0286, "__sprintpercent" },
    { 0x1FE124E3, "__src" },
    { 0xFAEC63A3, "__starting" },
    { 0xC3E259DA, "__state" },
    { 0x78E3BBEA, "__sys" },
    { 0xE97E1691, "__t" },
    { 0x98F0EE00, "__target" },
    { 0xD31DBC4D, "__terrorist_teamswitch_spawnfunc__" },
    { 0x449E5BD3, "__thin_out_for_recruit_kill_count" },
    { 0x624D4A14, "__thin_out_for_recruit_spawn_count" },
    { 0x21062A34, "__time" },
    { 0x584746B6, "__time__" },
    { 0xDC86CEF9, "__time_frac__" },
    { 0x56730E1E, "__time_left__" },
    { 0x50EE9C8D, "__time_length__" },
    { 0xE5D30892, "__time_stamp__" },
    { 0xCC64B7FA, "__time_stamp_prev__" },
    { 0xB9E49AEF, "__time_stamp_start__" },
    { 0xBCBC5D83, "__time_step__" },
    { 0x9B8C9FAE, "__time_this_step__" },
    { 0x98C8F20A, "__time_update__" },
    { 0xFA3B44E0, "__timeout" },
    { 0x5DE19486, "__value" },
    { 0x05B58592, "__var" },
    { 0xB684A6D1, "__vtable" },
    { 0x10A1F03B, "__walkpercent" },
    { 0x51742CED, "__x" },
    { 0x0FFB0ED7, "__x__" },
    { 0x2B71B284, "__y" },
    { 0x6305F819, "_a" },
    { 0x4EB66AD6, "_a10" },
    { 0x1F51D572, "_a100" },
    { 0xE049F626, "_a1000" },
    { 0x94450154, "_a1002" },
    { 0xBA477BBD, "_a1003" },
    { 0x48400C82, "_a1004" },
    { 0x223D9219, "_a1007" },
    { 0x105DC96E, "_a1008" },
    { 0x366043D7, "_a1009" },
    { 0x45544FDB, "_a101" },
    { 0x5EE15C51, "_a1010" },
    { 0x38DEE1E8, "_a1011" },
    { 0xAAE65123, "_a1012" },
    { 0x84E3D6BA, "_a1013" },
    { 0xD0E8CB8C, "_a1015" },
    { 0x1CEDC05E, "_a1017" },
    { 0x2ECD8909, "_a1018" },
    { 0x08CB0EA0, "_a1019" },
    { 0xD34CE0A0, "_a102" },
    { 0xE1DDF550, "_a1020" },
    { 0x07E06FB9, "_a1021" },
    { 0x2DE2EA22, "_a1022" },
    { 0x53E5648B, "_a1023" },
    { 0x79E7DEF4, "_a1024" },
    { 0xEBEF4E2F, "_a1027" },
    { 0x11F1C898, "_a1028" },
    { 0x37F44301, "_a1029" },
    { 0xF94F5B09, "_a103" },
    { 0x3A72E112, "_a1031" },
    { 0x147066A9, "_a1032" },
    { 0xF87F451F, "_a1034" },
    { 0xD27CCAB6, "_a1035" },
    { 0xAC7A504D, "_a1036" },
    { 0x8677D5E4, "_a1037" },
    { 0x90892EC3, "_a1038" },
    { 0x6A86B45A, "_a1039" },
    { 0xB75BBF16, "_a104" },
    { 0x1B957632, "_a1040" },
    { 0x4197F09B, "_a1041" },
    { 0xCF908160, "_a1042" },
    { 0xF592FBC9, "_a1043" },
    { 0xB39F5FD6, "_a1044" },
    { 0x5021D223, "_a10449" },
    { 0xD9A1DA3F, "_a1045" },
    { 0x679A6B04, "_a1046" },
    { 0x8D9CE56D, "_a1047" },
    { 0x4BA9497A, "_a1048" },
    { 0xDD5E397F, "_a105" },
    { 0x9A2CDC5D, "_a1050" },
    { 0x742A61F4, "_a1051" },
    { 0xE631D12F, "_a1052" },
    { 0xC02F56C6, "_a1053" },
    { 0x0222F2B9, "_a1054" },
    { 0xDC207850, "_a1055" },
    { 0x4E27E78B, "_a1056" },
    { 0x28256D22, "_a1057" },
    { 0xCA40AFA5, "_a1058" },
    { 0x6B56CA44, "_a106" },
    { 0xDD78C27C, "_a1060" },
    { 0x037B3CE5, "_a1061" },
    { 0x297DB74E, "_a1062" },
    { 0x4F8031B7, "_a1063" },
    { 0x456ED8D8, "_a1064" },
    { 0x6B715341, "_a1065" },
    { 0x9173CDAA, "_a1066" },
    { 0xB7764813, "_a1067" },
    { 0xD367699D, "_a1069" },
    { 0x915944AD, "_a107" },
    { 0x5C1028A7, "_a1070" },
    { 0x360DAE3E, "_a1071" },
    { 0x100B33D5, "_a1072" },
    { 0xEA08B96C, "_a1073" },
    { 0xC4063F03, "_a1074" },
    { 0x9E03C49A, "_a1075" },
    { 0x51FECFC8, "_a1077" },
    { 0x05F9DAF6, "_a1079" },
    { 0x4F65A8BA, "_a108" },
    { 0x3D32BDC7, "_a1081" },
    { 0xCB2B4E8C, "_a1082" },
    { 0xF12DC8F5, "_a1083" },
    { 0x7F2659BA, "_a1084" },
    { 0x332164E8, "_a1086" },
    { 0x5923DF51, "_a1087" },
    { 0xE71C7016, "_a1088" },
    { 0x0D1EEA7F, "_a1089" },
    { 0x75682323, "_a109" },
    { 0xD5785C69, "_a1090" },
    { 0xAF75E200, "_a1091" },
    { 0x217D513B, "_a1092" },
    { 0x6D82460D, "_a1094" },
    { 0x477FCBA4, "_a1095" },
    { 0xB9873ADF, "_a1096" },
    { 0x9384C076, "_a1097" },
    { 0x058C2FB1, "_a1098" },
    { 0x74B8E53F, "_a11" },
    { 0x9DE93B9D, "_a110" },
    { 0x539FCBD7, "_a1100" },
    { 0x2D9D516E, "_a1101" },
    { 0x079AD705, "_a1102" },
    { 0xE1985C9C, "_a1103" },
    { 0xBB95E233, "_a1104" },
    { 0x498E72F8, "_a1107" },
    { 0x238BF88F, "_a1108" },
    { 0xFD897E26, "_a1109" },
    { 0x77E6C134, "_a111" },
    { 0xD3CB312C, "_a1110" },
    { 0xF9CDAB95, "_a1111" },
    { 0x45D2A067, "_a1113" },
    { 0x3BC14788, "_a1114" },
    { 0x61C3C1F1, "_a1115" },
    { 0x87C63C5A, "_a1116" },
    { 0xADC8B6C3, "_a1117" },
    { 0xA3B75DE4, "_a1118" },
    { 0xE9EE306F, "_a112" },
    { 0x6A7CD0A4, "_a1121" },
    { 0xDC843FDF, "_a1122" },
    { 0xB681C576, "_a1123" },
    { 0xF8756169, "_a1124" },
    { 0xD272E700, "_a1125" },
    { 0x1E77DBD2, "_a1127" },
    { 0xC0931E55, "_a1128" },
    { 0x9A90A3EC, "_a1129" },
    { 0xC3EBB606, "_a113" },
    { 0x11E7E4E2, "_a1130" },
    { 0x37EA5F4B, "_a1131" },
    { 0xC5E2F010, "_a1132" },
    { 0xA9F1CE86, "_a1134" },
    { 0xCFF448EF, "_a1135" },
    { 0x5DECD9B4, "_a1136" },
    { 0x83EF541D, "_a1137" },
    { 0x41FBB82A, "_a1138" },
    { 0x05DF51F9, "_a114" },
    { 0x32028442, "_a1141" },
    { 0x0C0009D9, "_a1142" },
    { 0xE5FD8F70, "_a1143" },
    { 0xCA0C6DE6, "_a1145" },
    { 0xA409F37D, "_a1146" },
    { 0x7E077914, "_a1147" },
    { 0x8818D1F3, "_a1148" },
    { 0xDFDCD790, "_a115" },
    { 0xFE32DE69, "_a1151" },
    { 0x4A37D33B, "_a1153" },
    { 0x963CC80D, "_a1155" },
    { 0xE241BCDF, "_a1157" },
    { 0x08443748, "_a1158" },
    { 0x51E446CB, "_a116" },
    { 0x2F315098, "_a1161" },
    { 0x7B36456A, "_a1163" },
    { 0xC73B3A3C, "_a1165" },
    { 0x3942A977, "_a1166" },
    { 0x13402F0E, "_a1167" },
    { 0x251FF7B9, "_a1168" },
    { 0x2BE1CC62, "_a117" },
    { 0xD69C64D6, "_a1170" },
    { 0xFC9EDF3F, "_a1171" },
    { 0x8A977004, "_a1172" },
    { 0x3E927B32, "_a1174" },
    { 0x6494F59B, "_a1175" },
    { 0xF28D8660, "_a1176" },
    { 0x189000C9, "_a1177" },
    { 0x2CB2B287, "_a1179" },
    { 0xCDFD0EE5, "_a118" },
    { 0x322CE24B, "_a1184" },
    { 0x0C2A67E2, "_a1185" },
    { 0xC0257310, "_a1187" },
    { 0xFA4A9F37, "_a1188" },
    { 0xD44824CE, "_a1189" },
    { 0xA7FA947C, "_a119" },
    { 0x4B9F65C4, "_a1190" },
    { 0x97A45A96, "_a1192" },
    { 0xBDA6D4FF, "_a1193" },
    { 0xD997F689, "_a1195" },
    { 0xFF9A70F2, "_a1196" },
    { 0x259CEB5B, "_a1197" },
    { 0x7BB3390C, "_a1198" },
    { 0xA1B5B375, "_a1199" },
    { 0xE13521BC, "_a120" },
    { 0xC8CE3BED, "_a1201" },
    { 0xEED0B656, "_a1202" },
    { 0x14D330BF, "_a1203" },
    { 0x30C45249, "_a1205" },
    { 0x56C6CCB2, "_a1206" },
    { 0xD2DF94CC, "_a1208" },
    { 0x07379C25, "_a121" },
    { 0x216327AF, "_a1210" },
    { 0xFB60AD46, "_a1211" },
    { 0xD55E32DD, "_a1212" },
    { 0xAF5BB874, "_a1213" },
    { 0x89593E0B, "_a1214" },
    { 0x3D544939, "_a1216" },
    { 0x1751CED0, "_a1217" },
    { 0x2D3A168E, "_a122" },
    { 0x9FFA8DDA, "_a1220" },
    { 0xC5FD0843, "_a1221" },
    { 0x79F81371, "_a1223" },
    { 0x5E06F1E7, "_a1225" },
    { 0xEBFF82AC, "_a1226" },
    { 0x1201FD15, "_a1227" },
    { 0x6FE6BA92, "_a1228" },
    { 0x95E934FB, "_a1229" },
    { 0x533C90F7, "_a123" },
    { 0x1FCF2885, "_a1230" },
    { 0x6BD41D57, "_a1232" },
    { 0x45D1A2EE, "_a1233" },
    { 0x87C53EE1, "_a1234" },
    { 0x61C2C478, "_a1235" },
    { 0xD3CA33B3, "_a1236" },
    { 0xADC7B94A, "_a1237" },
    { 0xEFBB553D, "_a1238" },
    { 0x492B3818, "_a124" },
    { 0x67804178, "_a1240" },
    { 0x8D82BBE1, "_a1241" },
    { 0xB385364A, "_a1242" },
    { 0xFF8A2B1C, "_a1244" },
    { 0x258CA585, "_a1245" },
    { 0x4B8F1FEE, "_a1246" },
    { 0x71919A57, "_a1247" },
    { 0x6F2DB281, "_a125" },
    { 0xE617A7A3, "_a1250" },
    { 0xC0152D3A, "_a1251" },
    { 0x74103868, "_a1253" },
    { 0x581F16DE, "_a1255" },
    { 0xB603D45B, "_a1258" },
    { 0x900159F2, "_a1259" },
    { 0x95302CEA, "_a126" },
    { 0x8AB18837, "_a1261" },
    { 0x3EAC9365, "_a1263" },
    { 0xCCA5242A, "_a1264" },
    { 0xF2A79E93, "_a1265" },
    { 0x80A02F58, "_a1266" },
    { 0x349B3A86, "_a1268" },
    { 0x5A9DB4EF, "_a1269" },
    { 0xBB32A753, "_a127" },
    { 0xFE31E0F0, "_a1271" },
    { 0x4A36D5C2, "_a1273" },
    { 0xBC3E44FD, "_a1274" },
    { 0x084339CF, "_a1276" },
    { 0x54482EA1, "_a1278" },
    { 0x2E45B438, "_a1279" },
    { 0xA581B4B9, "_a12799" },
    { 0xB1214E74, "_a128" },
    { 0x2AF78CEC, "_a1280" },
    { 0x50FA0755, "_a1281" },
    { 0x9CFEFC27, "_a1283" },
    { 0x6089A323, "_a12836" },
    { 0x92EDA348, "_a1284" },
    { 0xDEF2981A, "_a1286" },
    { 0xFAE3B9A4, "_a1288" },
    { 0xD723C8DD, "_a129" },
    { 0xAACC2797, "_a1290" },
    { 0x5EC732C5, "_a1292" },
    { 0x38C4B85C, "_a1293" },
    { 0xA0BACEB8, "_a1297" },
    { 0x54B5D9E6, "_a1299" },
    { 0x5FCC87E7, "_a130" },
    { 0x16219735, "_a1300" },
    { 0xF01F1CCC, "_a1301" },
    { 0x7E17AD91, "_a1304" },
    { 0xCA1CA263, "_a1306" },
    { 0xA41A27FA, "_a1307" },
    { 0x39CA0D7E, "_a131" },
    { 0x978A310A, "_a1310" },
    { 0x7187B6A1, "_a1313" },
    { 0x2F941AAE, "_a1314" },
    { 0xE38F25DC, "_a1316" },
    { 0x67765DC2, "_a1318" },
    { 0x8D78D82B, "_a1319" },
    { 0x13C79315, "_a132" },
    { 0x17B5965F, "_a1320" },
    { 0xF1B31BF6, "_a1321" },
    { 0xCBB0A18D, "_a1322" },
    { 0x7FABACBB, "_a1324" },
    { 0x33A6B7E9, "_a1326" },
    { 0x47C969A7, "_a1328" },
    { 0x21C6EF3E, "_a1329" },
    { 0xEDC518AC, "_a133" },
    { 0x991E3034, "_a1330" },
    { 0xBF20AA9D, "_a1331" },
    { 0xE5232506, "_a1332" },
    { 0x01144690, "_a1334" },
    { 0x2716C0F9, "_a1335" },
    { 0x4D193B62, "_a1336" },
    { 0x731BB5CB, "_a1337" },
    { 0xC7C29E43, "_a134" },
    { 0xF4844FA0, "_a1341" },
    { 0x668BBEDB, "_a1342" },
    { 0x40894472, "_a1343" },
    { 0x8C8E3944, "_a1345" },
    { 0xFE95A87F, "_a1346" },
    { 0x249822E8, "_a1349" },
    { 0xA1C023DA, "_a135" },
    { 0x5B017C7E, "_a1350" },
    { 0xC2F792DA, "_a1354" },
    { 0xE8FA0D43, "_a1355" },
    { 0x76F29E08, "_a1356" },
    { 0x9CF51871, "_a1357" },
    { 0x2AEDA936, "_a1358" },
    { 0x7BBDA971, "_a136" },
    { 0xDC6A1653, "_a1360" },
    { 0xB6679BEA, "_a1361" },
    { 0x90652181, "_a1362" },
    { 0x39FF123D, "_a13648" },
    { 0x4E71858E, "_a1365" },
    { 0x286F0B25, "_a1366" },
    { 0x026C90BC, "_a1367" },
    { 0x55BB2F08, "_a137" },
    { 0x5DD2B028, "_a1370" },
    { 0x83D52A91, "_a1371" },
    { 0xA9D7A4FA, "_a1372" },
    { 0xF5DC99CC, "_a1374" },
    { 0x1BDF1435, "_a1375" },
    { 0x41E18E9E, "_a1376" },
    { 0x53C15749, "_a1379" },
    { 0x2FB8B49F, "_a138" },
    { 0x2B403ECF, "_a1382" },
    { 0x053DC466, "_a1383" },
    { 0x6D33DAC2, "_a1387" },
    { 0x09B63A36, "_a139" },
    { 0x856929BB, "_a1391" },
    { 0x1361BA80, "_a1392" },
    { 0xAB6BA424, "_a1396" },
    { 0x8F7A829A, "_a1398" },
    { 0xB57CFD03, "_a1399" },
    { 0xB6AC8132, "_a14" },
    { 0xE4065566, "_a140" },
    { 0xA271DDAB, "_a1401" },
    { 0x566CE8D9, "_a1403" },
    { 0x14794CE6, "_a1404" },
    { 0x3A7BC74F, "_a1405" },
    { 0xC8745814, "_a1406" },
    { 0xAC83368A, "_a1408" },
    { 0xD285B0F3, "_a1409" },
    { 0x0A08CFCF, "_a141" },
    { 0x470BBE3F, "_a1412" },
    { 0x210943D6, "_a1413" },
    { 0x88FF5A32, "_a1417" },
    { 0x2B1A9CB5, "_a1418" },
    { 0x98016094, "_a142" },
    { 0x3E52AF8C, "_a1420" },
    { 0x645529F5, "_a1421" },
    { 0x8A57A45E, "_a1422" },
    { 0xCC4B4051, "_a1425" },
    { 0x344156AD, "_a1429" },
    { 0xBE03DAFD, "_a143" },
    { 0xBCEA15B7, "_a1430" },
    { 0x96E79B4E, "_a1431" },
    { 0x4AE2A67C, "_a1433" },
    { 0x24E02C13, "_a1434" },
    { 0xB2D8BCD8, "_a1437" },
    { 0x66D3C806, "_a1439" },
    { 0x4BFC6BC2, "_a144" },
    { 0x65E9291F, "_a1441" },
    { 0xA7DCC512, "_a1444" },
    { 0xCDDF3F7B, "_a1445" },
    { 0xBFD0236D, "_a14476" },
    { 0x6FFA81FE, "_a1448" },
    { 0x71FEE62B, "_a145" },
    { 0xBFBB4961, "_a1450" },
    { 0x99B8CEF8, "_a1451" },
    { 0xE5BDC3CA, "_a1453" },
    { 0x57C53305, "_a1454" },
    { 0x31C2B89C, "_a1455" },
    { 0x7DC7AD6E, "_a1457" },
    { 0x8FA77619, "_a1458" },
    { 0x69A4FBB0, "_a1459" },
    { 0xFFF776F0, "_a146" },
    { 0xB4BF519B, "_a1463" },
    { 0xDAC1CC04, "_a1464" },
    { 0x26C6C0D6, "_a1466" },
    { 0x72CBB5A8, "_a1468" },
    { 0x98CE3011, "_a1469" },
    { 0x25F9F159, "_a147" },
    { 0x9B4CCE22, "_a1471" },
    { 0x754A53B9, "_a1472" },
    { 0x4F47D950, "_a1473" },
    { 0x5959322F, "_a1474" },
    { 0x0D543D5D, "_a1476" },
    { 0xE751C2F4, "_a1477" },
    { 0x6B4661A7, "_a14773" },
    { 0x141A28AE, "_a148" },
    { 0xB355B07A, "_a1480" },
    { 0x1FFB1DBF, "_a14809" },
    { 0x6750BBA8, "_a1482" },
    { 0x8D533611, "_a1483" },
    { 0x8B5A7113, "_a14841" },
    { 0x71621487, "_a1485" },
    { 0xD01F40B0, "_a14864" },
    { 0x255D1FB5, "_a1487" },
    { 0x8341DD32, "_a1488" },
    { 0x2339FCAE, "_a14888" },
    { 0x3A1CA317, "_a149" },
    { 0x31ED16A5, "_a1490" },
    { 0xDD12FF2F, "_a14900" },
    { 0xAA808DD6, "_a14912" },
    { 0x99E32D01, "_a1494" },
    { 0x73E0B298, "_a1495" },
    { 0xE5E821D3, "_a1496" },
    { 0x629DBB91, "_a150" },
    { 0xEFC538F3, "_a1500" },
    { 0xA3C04421, "_a1502" },
    { 0x7DBDC9B8, "_a1503" },
    { 0x61CCA82E, "_a1505" },
    { 0x835466FA, "_a15050" },
    { 0x3BCA2DC5, "_a1506" },
    { 0x3C9B4128, "_a151" },
    { 0x6FF09E48, "_a1510" },
    { 0x95F318B1, "_a1511" },
    { 0xE1F80D83, "_a1513" },
    { 0x53FF7CBE, "_a1516" },
    { 0x7A01F727, "_a1517" },
    { 0x2CA4B829, "_a1520" },
    { 0x52A73292, "_a1523" },
    { 0x88A035FA, "_a153" },
    { 0x6E5C9F1E, "_a1530" },
    { 0x945F1987, "_a1531" },
    { 0xFAA7A535, "_a154" },
    { 0x2B10B8FF, "_a1540" },
    { 0x050E3E96, "_a1541" },
    { 0xDF0BC42D, "_a1542" },
    { 0x6D0454F2, "_a1545" },
    { 0x5B248C47, "_a1548" },
    { 0xD4A52ACC, "_a155" },
    { 0x146F6930, "_a1554" },
    { 0x3A71E399, "_a1555" },
    { 0x60745E02, "_a1556" },
    { 0x8676D86B, "_a1557" },
    { 0xDC8D261C, "_a1558" },
    { 0x028FA085, "_a1559" },
    { 0x46AC9A07, "_a156" },
    { 0x283F8555, "_a1560" },
    { 0x023D0AEC, "_a1561" },
    { 0x74447A27, "_a1562" },
    { 0x90359BB1, "_a1564" },
    { 0x6A332148, "_a1565" },
    { 0xB638161A, "_a1567" },
    { 0xF82BB20D, "_a1568" },
    { 0x20AA1F9E, "_a157" },
    { 0xA9A81F2A, "_a1570" },
    { 0xCFAA9993, "_a1571" },
    { 0x83A5A4C1, "_a1573" },
    { 0x41B208CE, "_a1574" },
    { 0x67B48337, "_a1575" },
    { 0x1BAF8E65, "_a1577" },
    { 0x9F96C64B, "_a1579" },
    { 0x3289E849, "_a158" },
    { 0xB7A1B73B, "_a1580" },
    { 0x919F3CD2, "_a1581" },
    { 0x6B9CC269, "_a1582" },
    { 0x4FABA0DF, "_a1584" },
    { 0x03A6AC0D, "_a1586" },
    { 0xDDA431A4, "_a1587" },
    { 0xC1B3101A, "_a1589" },
    { 0x0C876DE0, "_a159" },
    { 0x850F45E2, "_a1592" },
    { 0xAB11C04B, "_a1593" },
    { 0xD1143AB4, "_a1594" },
    { 0xF716B51D, "_a1595" },
    { 0x1D192F86, "_a1596" },
    { 0x431BA9EF, "_a1597" },
    { 0x691E2458, "_a1598" },
    { 0x8F209EC1, "_a1599" },
    { 0x6AA78C60, "_a16" },
    { 0xE59A5490, "_a160" },
    { 0x077EA569, "_a1601" },
    { 0x53839A3B, "_a1603" },
    { 0x118FFE48, "_a1608" },
    { 0x379278B1, "_a1609" },
    { 0x0B9CCEF9, "_a161" },
    { 0x3B4E4B42, "_a1611" },
    { 0x154BD0D9, "_a1612" },
    { 0xF95AAF4F, "_a1614" },
    { 0x6B621E8A, "_a1619" },
    { 0x319F4962, "_a162" },
    { 0x05EAA63F, "_a1621" },
    { 0xB9E5B16D, "_a1623" },
    { 0x47DE4232, "_a1624" },
    { 0x6DE0BC9B, "_a1625" },
    { 0x0FFBFF1E, "_a1628" },
    { 0x35FE7987, "_a1629" },
    { 0x5E7F9201, "_a1630" },
    { 0x387D1798, "_a1631" },
    { 0xAA8486D3, "_a1632" },
    { 0xF6897BA5, "_a1634" },
    { 0x08694450, "_a1639" },
    { 0x7DA43E34, "_a164" },
    { 0x291BECFE, "_a1642" },
    { 0x4F1E6767, "_a1643" },
    { 0xD3059F4D, "_a1649" },
    { 0xA3A6B89D, "_a165" },
    { 0x5CEB92D7, "_a1650" },
    { 0xEAE4239C, "_a1653" },
    { 0xC4E1A933, "_a1654" },
    { 0x78DCB461, "_a1656" },
    { 0x06D54526, "_a1659" },
    { 0xC9A93306, "_a166" },
    { 0x1B33ABE2, "_a1660" },
    { 0x4136264B, "_a1661" },
    { 0xB33D9586, "_a1664" },
    { 0xD9400FEF, "_a1665" },
    { 0x8D3B1B1D, "_a1667" },
    { 0x7149F993, "_a1669" },
    { 0xEFABAD6F, "_a167" },
    { 0x99CB120D, "_a1670" },
    { 0x73C897A4, "_a1671" },
    { 0xE5D006DF, "_a1672" },
    { 0xBFCD8C76, "_a1673" },
    { 0x01C12869, "_a1674" },
    { 0x4DC61D3B, "_a1676" },
    { 0x27C3A2D2, "_a1677" },
    { 0xA3DC6AEC, "_a1679" },
    { 0x15AE27D8, "_a168" },
    { 0x199FACB8, "_a1680" },
    { 0xD7AC10C5, "_a1685" },
    { 0x3BB0A241, "_a169" },
    { 0x983712E3, "_a1690" },
    { 0x7234987A, "_a1691" },
    { 0x4C321E11, "_a1692" },
    { 0x262FA3A8, "_a1693" },
    { 0x3040FC87, "_a1694" },
    { 0x0A3E821E, "_a1695" },
    { 0xBE398D4C, "_a1697" },
    { 0x4220C532, "_a1699" },
    { 0x6431BABB, "_a170" },
    { 0xA0D6F583, "_a1702" },
    { 0xECDBEA55, "_a1704" },
    { 0xC6D96FEC, "_a1705" },
    { 0x38E0DF27, "_a1706" },
    { 0x12DE64BE, "_a1707" },
    { 0xFEBBB300, "_a1709" },
    { 0x3E2F4052, "_a171" },
    { 0x8A35A5B4, "_a1712" },
    { 0x3E30B0E2, "_a1714" },
    { 0x64332B4B, "_a1715" },
    { 0x064E6DCE, "_a1718" },
    { 0x2C50E837, "_a1719" },
    { 0x182CC5E9, "_a172" },
    { 0x57A3345B, "_a1720" },
    { 0x0B9E3F89, "_a1722" },
    { 0xC9AAA396, "_a1725" },
    { 0xA3A8292D, "_a1726" },
    { 0x87B707A3, "_a1728" },
    { 0xF22A4B80, "_a173" },
    { 0x2510C302, "_a1732" },
    { 0x4B133D6B, "_a1733" },
    { 0xBD1AACA6, "_a1736" },
    { 0xE31D270F, "_a1737" },
    { 0x2F221BE1, "_a1739" },
    { 0xFC3BA45F, "_a174" },
    { 0xDD5FAA0F, "_a1742" },
    { 0xB75D2FA6, "_a1743" },
    { 0x4555C06B, "_a1746" },
    { 0xC16E8885, "_a1748" },
    { 0xD63929F6, "_a175" },
    { 0x11861A92, "_a1750" },
    { 0x378894FB, "_a1751" },
    { 0xC58125C0, "_a1752" },
    { 0xEB83A029, "_a1753" },
    { 0xA9900436, "_a1754" },
    { 0xCF927E9F, "_a1755" },
    { 0x5D8B0F64, "_a1756" },
    { 0x838D89CD, "_a1757" },
    { 0x679C6843, "_a1759" },
    { 0xB036AF8D, "_a176" },
    { 0x533E0187, "_a1760" },
    { 0x07390CB5, "_a1762" },
    { 0xE136924C, "_a1763" },
    { 0xBB3417E3, "_a1764" },
    { 0x6F2F2311, "_a1766" },
    { 0x232A2E3F, "_a1768" },
    { 0x8A343524, "_a177" },
    { 0xFAA915C5, "_a1771" },
    { 0x629F2C21, "_a1775" },
    { 0x88A1A68A, "_a1776" },
    { 0xAEA420F3, "_a1777" },
    { 0x94458E03, "_a178" },
    { 0xA6A3BAE0, "_a1781" },
    { 0xB0B513BF, "_a1786" },
    { 0x8AB29956, "_a1787" },
    { 0xFCBA0891, "_a1788" },
    { 0x6E43139A, "_a179" },
    { 0x0D20E7BE, "_a1790" },
    { 0x33236227, "_a1791" },
    { 0xC11BF2EC, "_a1792" },
    { 0xE71E6D55, "_a1793" },
    { 0x9B197883, "_a1795" },
    { 0x29120948, "_a1796" },
    { 0x030F8EDF, "_a1799" },
    { 0x7ECA3E1E, "_a18" },
    { 0x563822AA, "_a180" },
    { 0x0436EB0E, "_a1800" },
    { 0x6C2D016A, "_a1804" },
    { 0x922F7BD3, "_a1805" },
    { 0x462A8701, "_a1807" },
    { 0xD42317C6, "_a1808" },
    { 0xFA25922F, "_a1809" },
    { 0x7C3A9D13, "_a181" },
    { 0xE9BEB302, "_a1813" },
    { 0x5BC6223D, "_a1814" },
    { 0x35C3A7D4, "_a1815" },
    { 0xA7CB170F, "_a1816" },
    { 0x81C89CA6, "_a1817" },
    { 0xF3D00BE1, "_a1818" },
    { 0xCDCD9178, "_a1819" },
    { 0x0A332DD8, "_a182" },
    { 0x530D138A, "_a1822" },
    { 0x9F12085C, "_a1824" },
    { 0xEB16FD2E, "_a1826" },
    { 0x11197797, "_a1827" },
    { 0x3035A841, "_a183" },
    { 0x1DA96E87, "_a1834" },
    { 0xF7A6F41E, "_a1835" },
    { 0xD1A479B5, "_a1836" },
    { 0x2F893732, "_a1839" },
    { 0xEE420C4E, "_a184" },
    { 0x3F826B1A, "_a1840" },
    { 0xB189DA55, "_a1847" },
    { 0x3571123B, "_a1849" },
    { 0x144486B7, "_a185" },
    { 0xBF5705C5, "_a1850" },
    { 0xE559802E, "_a1853" },
    { 0x274D1C21, "_a1854" },
    { 0x014AA1B8, "_a1855" },
    { 0x8F43327D, "_a1858" },
    { 0xA23D177C, "_a186" },
    { 0x42539EC4, "_a1860" },
    { 0x6856192D, "_a1861" },
    { 0xB45B0DFF, "_a1863" },
    { 0xAA49B520, "_a1864" },
    { 0x7267720C, "_a1868" },
    { 0x9869EC75, "_a1869" },
    { 0xC83F91E5, "_a187" },
    { 0x4EE395B4, "_a1873" },
    { 0x28E11B4B, "_a1874" },
    { 0xF0FED837, "_a1878" },
    { 0xCAFC5DCE, "_a1879" },
    { 0x26244F62, "_a188" },
    { 0x814BA904, "_a1882" },
    { 0xA74E236D, "_a1883" },
    { 0x5B492E9B, "_a1885" },
    { 0xE941BF60, "_a1886" },
    { 0xFD64711E, "_a1888" },
    { 0x4C26C9CB, "_a189" },
    { 0x71EA7E6A, "_a1893" },
    { 0xE3F1EDA5, "_a1894" },
    { 0x2FF6E277, "_a1896" },
    { 0x09F4680E, "_a1897" },
    { 0xD4CF88D5, "_a190" },
    { 0x6B387ECD, "_a1902" },
    { 0xD32E9529, "_a1906" },
    { 0xAD2C1AC0, "_a1907" },
    { 0xE75146E7, "_a1908" },
    { 0x5EA887DD, "_a1911" },
    { 0x84AB0246, "_a1912" },
    { 0x12A3930B, "_a1917" },
    { 0x20D47DA7, "_a192" },
    { 0xB5A97475, "_a1920" },
    { 0x8FA6FA0C, "_a1921" },
    { 0xDBABEEDE, "_a1923" },
    { 0x69A47FA3, "_a1926" },
    { 0x43A2053A, "_a1927" },
    { 0x8595A12D, "_a1928" },
    { 0x5F9326C4, "_a1929" },
    { 0xFAD2033E, "_a193" },
    { 0x37120E4A, "_a1930" },
    { 0x06FE3B02, "_a1938" },
    { 0x2D00B56B, "_a1939" },
    { 0x3CC59F31, "_a194" },
    { 0x09EA8458, "_a1943" },
    { 0x13FBDD37, "_a1944" },
    { 0xEDF962CE, "_a1945" },
    { 0xC7F6E865, "_a1946" },
    { 0x4BDE204B, "_a1948" },
    { 0x16C324C8, "_a195" },
    { 0xFD5A8D68, "_a1950" },
    { 0x235D07D1, "_a1951" },
    { 0x495F823A, "_a1952" },
    { 0xCD46BA20, "_a1958" },
    { 0x88CA9403, "_a196" },
    { 0x06139C1B, "_a1962" },
    { 0xE01121B2, "_a1963" },
    { 0x521890ED, "_a1964" },
    { 0x9E1D85BF, "_a1966" },
    { 0xC4200028, "_a1969" },
    { 0x62C8199A, "_a197" },
    { 0xFA8959BE, "_a1970" },
    { 0xAE8464EC, "_a1972" },
    { 0x167A7B48, "_a1976" },
    { 0x3C7CF5B1, "_a1977" },
    { 0xCA758676, "_a1978" },
    { 0xF07800DF, "_a1979" },
    { 0xA4BBB58D, "_a198" },
    { 0xCE9F044C, "_a1983" },
    { 0xA89C89E3, "_a1984" },
    { 0x829A0F7A, "_a1985" },
    { 0x5C979511, "_a1986" },
    { 0x36951AA8, "_a1987" },
    { 0xEA9025D6, "_a1989" },
    { 0x7EB93B24, "_a199" },
    { 0xC20F0D5C, "_a1990" },
    { 0xE81187C5, "_a1991" },
    { 0x2A0523B8, "_a1994" },
    { 0x50079E21, "_a1995" },
    { 0xD01F04AB, "_a20" },
    { 0x6C4B4CE1, "_a200" },
    { 0x3B131283, "_a2000" },
    { 0xAD1A81BE, "_a2005" },
    { 0x87180755, "_a2006" },
    { 0x61158CEC, "_a2007" },
    { 0x0AFF3F3B, "_a2008" },
    { 0x4648D278, "_a201" },
    { 0xBC7BAC58, "_a2010" },
    { 0x0880A12A, "_a2012" },
    { 0x548595FC, "_a2014" },
    { 0x8C67D910, "_a2018" },
    { 0xB85041B3, "_a202" },
    { 0x792FC639, "_a2020" },
    { 0x532D4BD0, "_a2021" },
    { 0xEB373574, "_a2025" },
    { 0x924DC74A, "_a203" },
    { 0xFCDB4921, "_a2037" },
    { 0x04553685, "_a204" },
    { 0x779BC70F, "_a2040" },
    { 0x51994CA6, "_a2041" },
    { 0x2B96D23D, "_a2042" },
    { 0xDF91DD6B, "_a2044" },
    { 0xB98F6302, "_a2045" },
    { 0x938CE899, "_a2046" },
    { 0x6D8A6E30, "_a2047" },
    { 0xA7AF9A57, "_a2048" },
    { 0xDE52BC1C, "_a205" },
    { 0xABC23792, "_a2056" },
    { 0x505A2B57, "_a206" },
    { 0xC0CF8837, "_a2062" },
    { 0xDCC0A9C1, "_a2064" },
    { 0x44B6C01D, "_a2068" },
    { 0x1EB445B4, "_a2069" },
    { 0x2A57B0EE, "_a207" },
    { 0xD030B2D1, "_a2073" },
    { 0xB43F9147, "_a2075" },
    { 0x683A9C75, "_a2077" },
    { 0x3C377999, "_a208" },
    { 0xDE2A4AE2, "_a2081" },
    { 0xB827D079, "_a2082" },
    { 0x85955F20, "_a2090" },
    { 0xD19A53F2, "_a2092" },
    { 0x43A1C32D, "_a2095" },
    { 0xB5A93268, "_a2098" },
    { 0xAA1C8A42, "_a21" },
    { 0xEC76B236, "_a210" },
    { 0x7A6611BB, "_a2101" },
    { 0x126FFB5F, "_a2105" },
    { 0xC66B068D, "_a2107" },
    { 0xAA79E503, "_a2109" },
    { 0x12792C9F, "_a211" },
    { 0x3C2E4859, "_a2114" },
    { 0x88333D2B, "_a2116" },
    { 0xA071BD64, "_a212" },
    { 0x63890CEE, "_a2122" },
    { 0x898B8757, "_a2123" },
    { 0xA57CA8E1, "_a2125" },
    { 0xCB7F234A, "_a2126" },
    { 0xE77044D4, "_a2128" },
    { 0x0D72BF3D, "_a2129" },
    { 0xC67437CD, "_a213" },
    { 0x701903DE, "_a2131" },
    { 0x4A168975, "_a2132" },
    { 0xFE1194A3, "_a2134" },
    { 0x6607AAFF, "_a2138" },
    { 0x546CC892, "_a214" },
    { 0xF3159CDD, "_a2143" },
    { 0x5B0BB339, "_a2147" },
    { 0x7A6F42FB, "_a215" },
    { 0x09B6ECAC, "_a2155" },
    { 0x0867D3C0, "_a216" },
    { 0x67EE3FC2, "_a2162" },
    { 0xFFF82966, "_a2166" },
    { 0x2E6A4E29, "_a217" },
    { 0x287941E0, "_a2173" },
    { 0xC0832B84, "_a2177" },
    { 0x1C8A857E, "_a218" },
    { 0x4A937D17, "_a2185" },
    { 0xFE8E8845, "_a2187" },
    { 0x428CFFE7, "_a219" },
    { 0x0B1E7F35, "_a2190" },
    { 0xB5083184, "_a2199" },
    { 0x841A0FD9, "_a22" },
    { 0x6DDF4C0B, "_a220" },
    { 0x3966F865, "_a2204" },
    { 0x13647DFC, "_a2205" },
    { 0x5F6972CE, "_a2207" },
    { 0x4B46C110, "_a2209" },
    { 0x47DCD1A2, "_a221" },
    { 0x22C5A896, "_a2210" },
    { 0x64B94489, "_a2217" },
    { 0x78DBF647, "_a2219" },
    { 0x21DA5739, "_a222" },
    { 0x1635B1A6, "_a2225" },
    { 0xD44215B3, "_a2228" },
    { 0xFBD7DCD0, "_a223" },
    { 0x2459A7C0, "_a2230" },
    { 0x4A5C2229, "_a2231" },
    { 0xE2660BCD, "_a2235" },
    { 0x05E935AF, "_a224" },
    { 0xB6A61464, "_a2241" },
    { 0x449EA529, "_a2244" },
    { 0x1E9C2AC0, "_a2245" },
    { 0x90A399FB, "_a2246" },
    { 0xDFE6BB46, "_a225" },
    { 0xAA161D74, "_a2256" },
    { 0x8E24FBEA, "_a2258" },
    { 0xB4277653, "_a2259" },
    { 0xB9E440DD, "_a226" },
    { 0x53C41AC5, "_a2262" },
    { 0xBBBA3121, "_a2266" },
    { 0x95B7B6B8, "_a2267" },
    { 0x6FB53C4F, "_a2268" },
    { 0x49B2C1E6, "_a2269" },
    { 0x93E1C674, "_a227" },
    { 0x1FF474EC, "_a2270" },
    { 0x6BF969BE, "_a2272" },
    { 0xD3EF801A, "_a2276" },
    { 0xEFE0A1A4, "_a2278" },
    { 0x15E31C0D, "_a2279" },
    { 0x9DF31F53, "_a228" },
    { 0x19314359, "_a2280" },
    { 0x6536382B, "_a2282" },
    { 0x3F33BDC2, "_a2283" },
    { 0x494516A1, "_a2288" },
    { 0x23429C38, "_a2289" },
    { 0x77F0A4EA, "_a229" },
    { 0x59ABF5CE, "_a2290" },
    { 0xC1A20C2A, "_a2294" },
    { 0xE7A48693, "_a2295" },
    { 0x759D1758, "_a2296" },
    { 0x29982286, "_a2298" },
    { 0x4F9A9CEF, "_a2299" },
    { 0x5E179570, "_a23" },
    { 0xEF47E5E0, "_a230" },
    { 0xC61122B4, "_a2304" },
    { 0x5E1B0C58, "_a2308" },
    { 0x841D86C1, "_a2309" },
    { 0x154A6049, "_a231" },
    { 0x3A973000, "_a2313" },
    { 0x1EA60E76, "_a2315" },
    { 0xD2A119A4, "_a2317" },
    { 0xB6AFF81A, "_a2319" },
    { 0x3B4CDAB2, "_a232" },
    { 0x2C7339E6, "_a2320" },
    { 0x5275B44F, "_a2321" },
    { 0x0670BF7D, "_a2323" },
    { 0xBA6BCAAB, "_a2325" },
    { 0x6E66D5D9, "_a2327" },
    { 0x5C870D2E, "_a2328" },
    { 0x614F551B, "_a233" },
    { 0xAB0AA011, "_a2330" },
    { 0x850825A8, "_a2331" },
    { 0xF70F94E3, "_a2332" },
    { 0x431489B5, "_a2334" },
    { 0x1D120F4C, "_a2335" },
    { 0x6917041E, "_a2337" },
    { 0x8751CF84, "_a234" },
    { 0x9BA97577, "_a2343" },
    { 0x91981C98, "_a2344" },
    { 0x1F90AD5D, "_a2349" },
    { 0xAD5449ED, "_a235" },
    { 0x102F82C3, "_a2354" },
    { 0xEA2D085A, "_a2355" },
    { 0xD356C456, "_a236" },
    { 0xFFC8A396, "_a2364" },
    { 0x97D28D3A, "_a2368" },
    { 0x4E4C3679, "_a2374" },
    { 0x9A512B4B, "_a2376" },
    { 0xF06778FC, "_a2379" },
    { 0x1F5BB928, "_a238" },
    { 0xFCF76FEC, "_a2384" },
    { 0x22F9EA55, "_a2385" },
    { 0x6EFEDF27, "_a2387" },
    { 0x34D9B300, "_a2388" },
    { 0x455E3391, "_a239" },
    { 0xE4C220F3, "_a2390" },
    { 0x98BD2C21, "_a2392" },
    { 0x72BAB1B8, "_a2393" },
    { 0x56C9902E, "_a2395" },
    { 0x0AC49B5C, "_a2397" },
    { 0x8EABD342, "_a2399" },
    { 0x6828EE4F, "_a24" },
    { 0xA796CCED, "_a240" },
    { 0x9EEDA567, "_a2400" },
    { 0x52E8B095, "_a2402" },
    { 0x06E3BBC3, "_a2404" },
    { 0xE0E1415A, "_a2405" },
    { 0x81945284, "_a241" },
    { 0x884C5598, "_a2414" },
    { 0xAE4ED001, "_a2415" },
    { 0xD4514A6A, "_a2416" },
    { 0xFA53C4D3, "_a2417" },
    { 0xF39BC1BF, "_a242" },
    { 0x030CD386, "_a2423" },
    { 0x6B02E9E2, "_a2427" },
    { 0xCD994756, "_a243" },
    { 0x38707889, "_a2433" },
    { 0xD07A622D, "_a2437" },
    { 0x0F8CE349, "_a244" },
    { 0x3B5CC1DF, "_a2444" },
    { 0x155A4776, "_a2445" },
    { 0xC95552A4, "_a2447" },
    { 0xE98A68E0, "_a245" },
    { 0x24BB7210, "_a2450" },
    { 0x96C2E14B, "_a2453" },
    { 0xBCC55BB4, "_a2454" },
    { 0x5B91D81B, "_a246" },
    { 0x13C6484C, "_a2465" },
    { 0x85CDB787, "_a2466" },
    { 0x358F5DB2, "_a247" },
    { 0xFD24F87D, "_a2473" },
    { 0xB12003AB, "_a2475" },
    { 0x793DC097, "_a2479" },
    { 0xD7AAA035, "_a248" },
    { 0x32B2FB89, "_a2486" },
    { 0x0CB08120, "_a2487" },
    { 0xB1A825CC, "_a249" },
    { 0x00208A30, "_a2494" },
    { 0x26230499, "_a2495" },
    { 0x7227F96B, "_a2497" },
    { 0xEE40C185, "_a2499" },
    { 0x422673E6, "_a25" },
    { 0x28FF66C2, "_a250" },
    { 0xB990607B, "_a2505" },
    { 0x4788F140, "_a2506" },
    { 0x4F01E12B, "_a251" },
    { 0xAB6C6A61, "_a2510" },
    { 0xD16EE4CA, "_a2513" },
    { 0x55561CB0, "_a2519" },
    { 0xDCFA71F0, "_a252" },
    { 0x2E690360, "_a2520" },
    { 0x7A6DF832, "_a2522" },
    { 0xA070729B, "_a2523" },
    { 0x1277E1D6, "_a2526" },
    { 0x02FCEC59, "_a253" },
    { 0x450A532F, "_a2534" },
    { 0xC1095066, "_a254" },
    { 0x68208442, "_a2540" },
    { 0x16CBBDB5, "_a2558" },
    { 0x75045B94, "_a256" },
    { 0x2A03D08C, "_a2560" },
    { 0x50064AF5, "_a2561" },
    { 0x1FF277AD, "_a2569" },
    { 0x9B06D5FD, "_a257" },
    { 0x9E89DDD8, "_a2577" },
    { 0x59133A0A, "_a258" },
    { 0x17B65C9C, "_a2582" },
    { 0x3DB8D705, "_a2583" },
    { 0xCBB167CA, "_a2584" },
    { 0xA5AEED61, "_a2587" },
    { 0x7F15B473, "_a259" },
    { 0xFC00F010, "_a2591" },
    { 0x4805E4E2, "_a2593" },
    { 0x52173DC1, "_a2598" },
    { 0x1C23F97D, "_a26" },
    { 0x697A1937, "_a260" },
    { 0x62ACA545, "_a2600" },
    { 0x16A7B073, "_a2606" },
    { 0x0C965794, "_a2609" },
    { 0x43779ECE, "_a261" },
    { 0x54DF79D5, "_a2617" },
    { 0x3E3E2A06, "_a2621" },
    { 0x5A2F4B90, "_a2627" },
    { 0xF772A9FC, "_a263" },
    { 0x73A1CF09, "_a2635" },
    { 0x99A44972, "_a2636" },
    { 0xD1702F93, "_a264" },
    { 0xB316CCEB, "_a2642" },
    { 0x4B20B68F, "_a2646" },
    { 0xAB6DB52A, "_a265" },
    { 0x0F82A0EA, "_a2654" },
    { 0x35851B53, "_a2655" },
    { 0x9D7B31AF, "_a2659" },
    { 0x856B3AC1, "_a266" },
    { 0x5F68C058, "_a267" },
    { 0xD06038A1, "_a2671" },
    { 0x1C652D73, "_a2673" },
    { 0x396645EF, "_a268" },
    { 0xB881B452, "_a2687" },
    { 0x5A9CF6D5, "_a2688" },
    { 0x1363CB86, "_a269" },
    { 0x5FECC890, "_a2692" },
    { 0x69FE216F, "_a2695" },
    { 0xF6217F14, "_a27" },
    { 0xEAE2B30C, "_a270" },
    { 0x7D4F6059, "_a2705" },
    { 0xC954552B, "_a2707" },
    { 0x1F6AA2DC, "_a2708" },
    { 0x10E52D75, "_a271" },
    { 0xD5E44C1B, "_a2714" },
    { 0xAFE1D1B2, "_a2715" },
    { 0x63DCDCE0, "_a2717" },
    { 0x36E7A7DE, "_a272" },
    { 0xC6832181, "_a2723" },
    { 0x5CEA2247, "_a273" },
    { 0x6B1D0215, "_a2730" },
    { 0x52D8C968, "_a274" },
    { 0xFED30FDA, "_a2742" },
    { 0x24D58A43, "_a2743" },
    { 0x4AD804AC, "_a2744" },
    { 0x96DCF97E, "_a2746" },
    { 0x78DB43D1, "_a275" },
    { 0x0CA03B4A, "_a2751" },
    { 0xE69DC0E1, "_a2752" },
    { 0x9EDDBE3A, "_a276" },
    { 0xD73C9647, "_a2761" },
    { 0x6535270C, "_a2762" },
    { 0xC4E038A3, "_a277" },
    { 0x6F8234E9, "_a2770" },
    { 0x078C1E8D, "_a2774" },
    { 0xE189A424, "_a2775" },
    { 0xBACEDFC4, "_a278" },
    { 0x77829AFC, "_a2780" },
    { 0x476EC7B4, "_a2788" },
    { 0xE0D15A2D, "_a279" },
    { 0xAA150C55, "_a2792" },
    { 0x841291EC, "_a2793" },
    { 0x5E101783, "_a2794" },
    { 0x380D9D1A, "_a2795" },
    { 0x120B22B1, "_a2796" },
    { 0x0032D7F3, "_a28" },
    { 0xE2E24CF9, "_a280" },
    { 0xDBC0094F, "_a2804" },
    { 0x73C9F2F3, "_a2808" },
    { 0xBCDFD290, "_a281" },
    { 0xE9E3FF69, "_a2811" },
    { 0x0FE679D2, "_a2812" },
    { 0x5BEB6EA4, "_a2814" },
    { 0x81EDE90D, "_a2815" },
    { 0x19F7D2B1, "_a2819" },
    { 0x2EE741CB, "_a282" },
    { 0xD8EED5A5, "_a2824" },
    { 0x08E4C762, "_a283" },
    { 0x76489104, "_a2832" },
    { 0x5046169B, "_a2835" },
    { 0x7AEC369D, "_a284" },
    { 0x814488CA, "_a2845" },
    { 0x5B420E61, "_a2846" },
    { 0xE93A9F26, "_a2849" },
    { 0x54E9BC34, "_a285" },
    { 0xBF7C522C, "_a2850" },
    { 0xE57ECC95, "_a2851" },
    { 0x8F687EE4, "_a2858" },
    { 0xB56AF94D, "_a2859" },
    { 0xC6F12B6F, "_a286" },
    { 0x7C306C0D, "_a2860" },
    { 0xE4268269, "_a2864" },
    { 0xBE240800, "_a2865" },
    { 0x302B773B, "_a2866" },
    { 0x0A28FCD2, "_a2867" },
    { 0xA0EEB106, "_a287" },
    { 0xD7968B79, "_a2873" },
    { 0x12F62041, "_a288" },
    { 0xC6A161B5, "_a2886" },
    { 0xA09EE74C, "_a2887" },
    { 0xECF3A5D8, "_a289" },
    { 0x940EF05C, "_a2894" },
    { 0xDA305D8A, "_a29" },
    { 0x249A33EE, "_a290" },
    { 0x38EC5B0C, "_a2906" },
    { 0x5EEED575, "_a2907" },
    { 0x4A9CAE57, "_a291" },
    { 0x1F79D793, "_a2916" },
    { 0xF9775D2A, "_a2917" },
    { 0xD8953F1C, "_a292" },
    { 0x147DDFCD, "_a2921" },
    { 0x56717BC0, "_a2924" },
    { 0xFE97B985, "_a293" },
    { 0x224B0B3D, "_a2932" },
    { 0xB0439C02, "_a2935" },
    { 0x8C904A4A, "_a294" },
    { 0x6596F15C, "_a2942" },
    { 0xCD8D07B8, "_a2946" },
    { 0xB292C4B3, "_a295" },
    { 0x9FF7D281, "_a2958" },
    { 0x408B5578, "_a296" },
    { 0xFF34DA2A, "_a2962" },
    { 0x668DCFE1, "_a297" },
    { 0x57C9C5EC, "_a2977" },
    { 0xF48660A6, "_a298" },
    { 0xE614EC4A, "_a2988" },
    { 0x1A88DB0F, "_a299" },
    { 0x34987F2D, "_a2990" },
    { 0x29367990, "_a3" },
    { 0x504A6A00, "_a30" },
    { 0x859BD1B0, "_a300" },
    { 0x6472BEA0, "_a3000" },
    { 0xAB9E4C19, "_a301" },
    { 0xBD07AA62, "_a3011" },
    { 0x090C9F34, "_a3017" },
    { 0xD1A0C682, "_a302" },
    { 0x61A18AF6, "_a3020" },
    { 0x159C9624, "_a3022" },
    { 0xF7A340EB, "_a303" },
    { 0x43A835BD, "_a305" },
    { 0xAE911EAF, "_a3058" },
    { 0x69AAB026, "_a306" },
    { 0x36342926, "_a3064" },
    { 0x8FAD2A8F, "_a307" },
    { 0xF6BF2B44, "_a3071" },
    { 0x84B7BC09, "_a3074" },
    { 0xB5AFA4F8, "_a308" },
    { 0xDBB21F61, "_a309" },
    { 0x764CE469, "_a31" },
    { 0x043337DB, "_a310" },
    { 0xDE30BD72, "_a311" },
    { 0x9B24CA19, "_a3117" },
    { 0xB82E4309, "_a312" },
    { 0x8D579EA9, "_a3122" },
    { 0x922BC8A0, "_a313" },
    { 0xCCCC9C8B, "_a3133" },
    { 0x18D1915D, "_a3135" },
    { 0x9C3D217F, "_a314" },
    { 0xED1199F4, "_a3141" },
    { 0x7B0A2AB9, "_a3144" },
    { 0x1D256D3C, "_a3149" },
    { 0x763AA716, "_a315" },
    { 0x50382CAD, "_a316" },
    { 0xAEF4E63E, "_a3161" },
    { 0x16EAFC9A, "_a3165" },
    { 0xCAE607C8, "_a3167" },
    { 0x2A35B244, "_a317" },
    { 0x34470B23, "_a318" },
    { 0xE6697E0D, "_a3184" },
    { 0xC06703A4, "_a3185" },
    { 0x0E4490BA, "_a319" },
    { 0x90177B5E, "_a3190" },
    { 0x6A1500F5, "_a3193" },
    { 0x1E100C23, "_a3195" },
    { 0xD20B1751, "_a3197" },
    { 0x9C4F5ED2, "_a32" },
    { 0x82CA9E06, "_a320" },
    { 0x8ACF1CE2, "_a3200" },
    { 0xA8CD186F, "_a321" },
    { 0xBD618E3B, "_a3216" },
    { 0x36C5A934, "_a322" },
    { 0xBEB9D867, "_a3223" },
    { 0xDAAAF9F1, "_a3225" },
    { 0x1C9E95E4, "_a3228" },
    { 0x5CC8239D, "_a323" },
    { 0xEAC0B462, "_a324" },
    { 0x037EA804, "_a3242" },
    { 0x2981226D, "_a3243" },
    { 0x6B74BE60, "_a3246" },
    { 0x10C32ECB, "_a325" },
    { 0xA8188898, "_a3251" },
    { 0xF41D7D6A, "_a3253" },
    { 0x9EBBBF90, "_a326" },
    { 0x51179C00, "_a3260" },
    { 0xE92185A4, "_a3264" },
    { 0xC4BE39F9, "_a327" },
    { 0x1CF12B7D, "_a3276" },
    { 0xB2DE714E, "_a328" },
    { 0x33BCD955, "_a3287" },
    { 0xD8E0EBB7, "_a329" },
    { 0xC251D93B, "_a33" },
    { 0x01620431, "_a330" },
    { 0x8C1D8358, "_a3303" },
    { 0xCE111F4B, "_a3308" },
    { 0xA80EA4E2, "_a3309" },
    { 0xDB5F89C8, "_a331" },
    { 0xA59006D1, "_a3311" },
    { 0xF194FBA3, "_a3313" },
    { 0x4D66F903, "_a332" },
    { 0x624420B2, "_a3323" },
    { 0xAE491584, "_a3325" },
    { 0x27647E9A, "_a333" },
    { 0x98AD7A48, "_a3336" },
    { 0x4CA88576, "_a3338" },
    { 0x136DF836, "_a3341" },
    { 0x7369736C, "_a335" },
    { 0x2CE07BAF, "_a3353" },
    { 0x22CF22D0, "_a3354" },
    { 0xE570E2A7, "_a336" },
    { 0x5DDEEDDE, "_a3363" },
    { 0xBF6E683E, "_a337" },
    { 0x6D401878, "_a3372" },
    { 0x89313A02, "_a3378" },
    { 0xD14E30E9, "_a338" },
    { 0xF75278A3, "_a3388" },
    { 0xAB4BB680, "_a339" },
    { 0xE85453A4, "_a34" },
    { 0x81369EDC, "_a340" },
    { 0x968C8FDF, "_a3403" },
    { 0xA7391945, "_a341" },
    { 0x7E5740E6, "_a3411" },
    { 0x0C4FD1AB, "_a3414" },
    { 0xD46D8E97, "_a3418" },
    { 0xCD3B93AE, "_a342" },
    { 0x48F39BE3, "_a3421" },
    { 0xBAFB0B1E, "_a3424" },
    { 0x6EF6164C, "_a3426" },
    { 0xF33E0E17, "_a343" },
    { 0xED8D7C77, "_a3432" },
    { 0xE92CB538, "_a344" },
    { 0x0F3C1B01, "_a3441" },
    { 0x5B410FD3, "_a3443" },
    { 0xF34AF977, "_a3447" },
    { 0xB925CD50, "_a3448" },
    { 0x0F2F2FA1, "_a345" },
    { 0x3531AA0A, "_a346" },
    { 0xDD94488F, "_a3469" },
    { 0x5B342473, "_a347" },
    { 0x17F529B4, "_a3475" },
    { 0x5122CB94, "_a348" },
    { 0x87EBA623, "_a3487" },
    { 0x772545FD, "_a349" },
    { 0xFFCE0507, "_a350" },
    { 0xBDDD70BE, "_a3503" },
    { 0xD9CB8A9E, "_a351" },
    { 0xB3C91035, "_a352" },
    { 0x74A9AF96, "_a3521" },
    { 0x02A2405B, "_a3524" },
    { 0x8DC695CC, "_a353" },
    { 0xAA0D5499, "_a3535" },
    { 0x67C41B63, "_a354" },
    { 0x763DAEC0, "_a3541" },
    { 0x344A12CD, "_a3544" },
    { 0x41C1A0FA, "_a355" },
    { 0xDDF8101E, "_a3550" },
    { 0x1BBF2691, "_a356" },
    { 0x5F60A9F3, "_a3560" },
    { 0xF76A9397, "_a3564" },
    { 0xD168192E, "_a3565" },
    { 0x2F4CD6AB, "_a3568" },
    { 0xF5BCAC28, "_a357" },
    { 0xAF783C00, "_a3578" },
    { 0xCFBA31BF, "_a358" },
    { 0x86F72386, "_a3583" },
    { 0x91087C65, "_a3588" },
    { 0xA9B7B756, "_a359" },
    { 0x96584E20, "_a3592" },
    { 0x1271163A, "_a3598" },
    { 0x34594876, "_a36" },
    { 0xBE161E12, "_a360" },
    { 0xEEA9AFC6, "_a3600" },
    { 0xC8A7355D, "_a3603" },
    { 0x569FC622, "_a3604" },
    { 0x7CA2408B, "_a3605" },
    { 0xE418987B, "_a361" },
    { 0x3D2D42A9, "_a3618" },
    { 0x3D7FD842, "_a3622" },
    { 0xFB8C3C4F, "_a3627" },
    { 0x9813A3A9, "_a363" },
    { 0x240D54C9, "_a3632" },
    { 0xFE0ADA60, "_a3633" },
    { 0x562007B6, "_a364" },
    { 0x29F52FD2, "_a3640" },
    { 0x7C22821F, "_a365" },
    { 0x11BFE0D9, "_a3654" },
    { 0xD9DD9DC5, "_a3658" },
    { 0xB3DB235C, "_a3659" },
    { 0x0A1B12E4, "_a366" },
    { 0x391AA56E, "_a3662" },
    { 0x301D8D4D, "_a367" },
    { 0x619BBDE8, "_a3677" },
    { 0xEE29F15A, "_a368" },
    { 0x142C6BC3, "_a369" },
    { 0x311A3F5B, "_a3692" },
    { 0x3DEAB8BD, "_a370" },
    { 0xD5592AF7, "_a3700" },
    { 0x17E83E54, "_a371" },
    { 0x89EFAD8F, "_a372" },
    { 0x7B6BF509, "_a3724" },
    { 0x63ED3326, "_a373" },
    { 0xBAE0F2EB, "_a3731" },
    { 0x48D983B0, "_a3732" },
    { 0xEAF4C633, "_a3739" },
    { 0xA5E0CF19, "_a374" },
    { 0x7FDE54B0, "_a375" },
    { 0xF1E5C3EB, "_a376" },
    { 0xCBE34982, "_a377" },
    { 0x47FC119C, "_a379" },
    { 0x805E3D48, "_a38" },
    { 0xBC821EE8, "_a380" },
    { 0xE2849951, "_a381" },
    { 0xE231D3CA, "_a3811" },
    { 0x088713BA, "_a382" },
    { 0x548C088C, "_a384" },
    { 0x7A8E82F5, "_a385" },
    { 0x396E7560, "_a3857" },
    { 0xA090FD5E, "_a386" },
    { 0x8C6E4BA0, "_a388" },
    { 0xB270C609, "_a389" },
    { 0xAA0E5212, "_a3891" },
    { 0xF61346E4, "_a3897" },
    { 0xA660B7B1, "_a39" },
    { 0x3B198513, "_a390" },
    { 0x15170AAA, "_a391" },
    { 0x31192E3C, "_a3912" },
    { 0x4D0A4FC6, "_a3918" },
    { 0xEF149041, "_a392" },
    { 0xC91215D8, "_a393" },
    { 0xE227F014, "_a3949" },
    { 0xAD20F44E, "_a395" },
    { 0x8855CFD2, "_a3958" },
    { 0x871E79E5, "_a396" },
    { 0x611BFF7C, "_a397" },
    { 0xE13D512D, "_a3971" },
    { 0x0B05B1CB, "_a398" },
    { 0x9ECCC198, "_a3981" },
    { 0xEAD1B66A, "_a3983" },
    { 0x36D6AB3C, "_a3985" },
    { 0xE5033762, "_a399" },
    { 0xFA32E104, "_a3992" },
    { 0x6228F760, "_a3996" },
    { 0x764BA91E, "_a3998" },
    { 0x0899510D, "_a40" },
    { 0x4195A627, "_a4002" },
    { 0x37844D48, "_a4005" },
    { 0xD07FC39E, "_a401" },
    { 0x46E577E2, "_a4018" },
    { 0xAA7D4935, "_a402" },
    { 0x6057FB5B, "_a4024" },
    { 0x847ACECC, "_a403" },
    { 0xE1C09530, "_a4034" },
    { 0x319C723F, "_a4059" },
    { 0x12735F91, "_a406" },
    { 0x71117021, "_a4062" },
    { 0xEC70E528, "_a407" },
    { 0xD54BB3EC, "_a4074" },
    { 0xC66E6ABF, "_a408" },
    { 0x26A07A79, "_a4084" },
    { 0xA06BF056, "_a409" },
    { 0x8C17F2C4, "_a4096" },
    { 0xB21A6D2D, "_a4097" },
    { 0xE296D6A4, "_a41" },
    { 0x77EAD7DC, "_a410" },
    { 0xB24EAEEC, "_a4108" },
    { 0x9DED5245, "_a411" },
    { 0xB60A817D, "_a4112" },
    { 0xC3EFCCAE, "_a412" },
    { 0xA6A956E3, "_a4121" },
    { 0xE9F24717, "_a413" },
    { 0x4131DE98, "_a4135" },
    { 0xB3394DD3, "_a4136" },
    { 0x8D36D36A, "_a4137" },
    { 0xDFE0EE38, "_a414" },
    { 0x05E368A1, "_a415" },
    { 0x378E30FE, "_a4155" },
    { 0x6F707412, "_a4159" },
    { 0x2BE5E30A, "_a416" },
    { 0x51E85D73, "_a417" },
    { 0xDDA0FB10, "_a4171" },
    { 0x47D70494, "_a418" },
    { 0x6DD97EFD, "_a419" },
    { 0x1833D27C, "_a4193" },
    { 0x5A276E6F, "_a4198" },
    { 0x549E45DF, "_a42" },
    { 0x80A3E68F, "_a422" },
    { 0x5AA16C26, "_a423" },
    { 0x9C950819, "_a424" },
    { 0x76928DB0, "_a425" },
    { 0x9CEB9116, "_a4256" },
    { 0xE899FCEB, "_a426" },
    { 0x35E019A1, "_a4260" },
    { 0x81E50E73, "_a4262" },
    { 0xC2978282, "_a427" },
    { 0x0C21CCA7, "_a4279" },
    { 0x64B2C505, "_a428" },
    { 0x38DBAB54, "_a4283" },
    { 0xC6D43C19, "_a4286" },
    { 0xDAF6EDD7, "_a4288" },
    { 0x3EB04A9C, "_a429" },
    { 0x2E9BCB76, "_a43" },
    { 0xB4CA5712, "_a430" },
    { 0x4C5F6AC6, "_a4300" },
    { 0x68508C50, "_a4306" },
    { 0xDACCD17B, "_a431" },
    { 0x16FBC5C3, "_a4312" },
    { 0x9AE2FDA9, "_a4318" },
    { 0x68C56240, "_a432" },
    { 0x753318D9, "_a4321" },
    { 0x8EC7DCA9, "_a433" },
    { 0xCDC8049B, "_a4330" },
    { 0x3FCF73D6, "_a4335" },
    { 0xD7D95D7A, "_a4339" },
    { 0x4CD440B6, "_a434" },
    { 0xB7BEBE1A, "_a4348" },
    { 0xDDC13883, "_a4349" },
    { 0x72D6BB1F, "_a435" },
    { 0x95781642, "_a4357" },
    { 0x00CF4BE4, "_a436" },
    { 0xFEC676CA, "_a4366" },
    { 0x26D1C64D, "_a437" },
    { 0x0B566DBA, "_a4375" },
    { 0xE4DE2A5A, "_a438" },
    { 0xEB3BCE5A, "_a4384" },
    { 0x79345F1F, "_a4389" },
    { 0x0AE0A4C3, "_a439" },
    { 0x68CD7FF2, "_a4393" },
    { 0x72DED8D1, "_a4398" },
    { 0x708F6769, "_a44" },
    { 0xFAE770DB, "_a440" },
    { 0xF38AB35E, "_a4407" },
    { 0xD4E4F672, "_a441" },
    { 0xD2D80AB0, "_a4416" },
    { 0xAEE27C09, "_a442" },
    { 0xA919BDB6, "_a4425" },
    { 0x88E001A0, "_a443" },
    { 0xB87AE850, "_a4430" },
    { 0x5084D1F4, "_a4434" },
    { 0x92F15A7F, "_a444" },
    { 0x96CC49C6, "_a4443" },
    { 0x6CEEE016, "_a445" },
    { 0xA62D7460, "_a4452" },
    { 0x46EC65AD, "_a446" },
    { 0x0CAAA13E, "_a4461" },
    { 0x20E9EB44, "_a447" },
    { 0xB415B57C, "_a4470" },
    { 0x2AFB4423, "_a448" },
    { 0xAC154F69, "_a4480" },
    { 0x6A21B376, "_a4487" },
    { 0x04F8C9BA, "_a449" },
    { 0x09BE57E8, "_a4496" },
    { 0x4A8CED00, "_a45" },
    { 0x7C500AB0, "_a450" },
    { 0xCC39D27F, "_a4507" },
    { 0xA2528519, "_a451" },
    { 0x40BFDFCB, "_a4510" },
    { 0xD8C9C96F, "_a4514" },
    { 0xC854FF82, "_a452" },
    { 0xE559C05F, "_a4521" },
    { 0x73525124, "_a4522" },
    { 0xEF6B193E, "_a4528" },
    { 0xEE5779EB, "_a453" },
    { 0x233ABF17, "_a4536" },
    { 0xFD3844AE, "_a4537" },
    { 0x1459F454, "_a454" },
    { 0xE3C5C135, "_a4541" },
    { 0x71BE51FA, "_a4546" },
    { 0x3A5C6EBD, "_a455" },
    { 0x1658328E, "_a4551" },
    { 0xCA533DBC, "_a4553" },
    { 0x32495418, "_a4557" },
    { 0x605EE926, "_a456" },
    { 0x6DE769BD, "_a4567" },
    { 0x8488B98C, "_a4579" },
    { 0xAC63DDF8, "_a458" },
    { 0xF90EC6D8, "_a4580" },
    { 0x4513BBAA, "_a4582" },
    { 0xD2665861, "_a459" },
    { 0xC3AB21D5, "_a4596" },
    { 0x479259BB, "_a4598" },
    { 0xBC945C3B, "_a46" },
    { 0xD213C2C8, "_a461" },
    { 0x441B3203, "_a462" },
    { 0x1E18B79A, "_a463" },
    { 0x686AA483, "_a4635" },
    { 0x902026D5, "_a464" },
    { 0x6A1DAC6C, "_a465" },
    { 0x3E9141DD, "_a4651" },
    { 0x8A9636AF, "_a4653" },
    { 0xDC251BA7, "_a466" },
    { 0x238ABF3A, "_a4667" },
    { 0xB622A13E, "_a467" },
    { 0xC80269E9, "_a468" },
    { 0xA1FFEF80, "_a469" },
    { 0xF261EF02, "_a4692" },
    { 0x3E66E3D4, "_a4694" },
    { 0x9691E1D2, "_a47" },
    { 0x797ED706, "_a470" },
    { 0x5A8C471D, "_a4707" },
    { 0x9F81516F, "_a471" },
    { 0x4119C3A4, "_a4711" },
    { 0x2D79E234, "_a472" },
    { 0x7A5450E4, "_a4728" },
    { 0x537C5C9D, "_a473" },
    { 0xE174ED62, "_a474" },
    { 0x077767CB, "_a475" },
    { 0x956FF890, "_a476" },
    { 0x6CD9BB0D, "_a4765" },
    { 0xBB7272F9, "_a477" },
    { 0xA0A960E6, "_a4775" },
    { 0xA992AA4E, "_a478" },
    { 0xCF9524B7, "_a479" },
    { 0x38AD2455, "_a48" },
    { 0x6D193E1F, "_a480" },
    { 0x4716C3B6, "_a481" },
    { 0x2114494D, "_a482" },
    { 0xFB11CEE4, "_a483" },
    { 0xD50F547B, "_a484" },
    { 0xC1AB09F1, "_a4840" },
    { 0xAF0CDA12, "_a485" },
    { 0x890A5FA9, "_a486" },
    { 0x9D2D1167, "_a488" },
    { 0x772A96FE, "_a489" },
    { 0x12AAA9EC, "_a49" },
    { 0xEE81D7F4, "_a490" },
    { 0x31BAB273, "_a4914" },
    { 0x99B0C8CF, "_a4918" },
    { 0x3A86CCC6, "_a492" },
    { 0xFA14245D, "_a4927" },
    { 0x6089472F, "_a493" },
    { 0x5677EE50, "_a494" },
    { 0x7C7A68B9, "_a495" },
    { 0xA27CE322, "_a496" },
    { 0xC87F5D8B, "_a497" },
    { 0x8964FF4E, "_a4977" },
    { 0x1E95AB3C, "_a498" },
    { 0xF456A75D, "_a4992" },
    { 0x0D455806, "_a5" },
    { 0x8A01EAE2, "_a50" },
    { 0x0F0D6B89, "_a5003" },
    { 0xCD19CF96, "_a5004" },
    { 0xA92EE2BF, "_a501" },
    { 0xB3A74C1D, "_a5010" },
    { 0x37277384, "_a502" },
    { 0x84EBC301, "_a5025" },
    { 0x5D29EDED, "_a503" },
    { 0x1F744AB6, "_a5039" },
    { 0xEB227EB2, "_a504" },
    { 0xF9C465E6, "_a5040" },
    { 0x1124F91B, "_a505" },
    { 0xEA633B4C, "_a5055" },
    { 0x6D5FD44B, "_a5063" },
    { 0xC5200449, "_a507" },
    { 0x79EFCB3B, "_a5070" },
    { 0xB3403B9E, "_a508" },
    { 0xB7FB27FC, "_a5086" },
    { 0xB004654B, "_a51" },
    { 0x365E4C68, "_a5103" },
    { 0xDBC15418, "_a511" },
    { 0xF9BA8230, "_a5118" },
    { 0x4DC8C353, "_a512" },
    { 0x27C648EA, "_a513" },
    { 0x00FAA765, "_a5133" },
    { 0x99CDB825, "_a514" },
    { 0x13C50EF7, "_a5148" },
    { 0x73CB3DBC, "_a515" },
    { 0xE5D2ACF7, "_a516" },
    { 0x2E223157, "_a5162" },
    { 0xBFD0328E, "_a517" },
    { 0x6248A1DA, "_a5170" },
    { 0xD1AFFB39, "_a518" },
    { 0x9781E8D4, "_a5187" },
    { 0xABAD80D0, "_a519" },
    { 0x3DFCF610, "_a52" },
    { 0x84C06780, "_a520" },
    { 0xD0C55C52, "_a522" },
    { 0xF6C7D6BB, "_a523" },
    { 0xF11D9A48, "_a5231" },
    { 0x1CCA5124, "_a524" },
    { 0x42CCCB8D, "_a525" },
    { 0x68CF45F6, "_a526" },
    { 0x6A4A190C, "_a5284" },
    { 0xDAD6B531, "_a529" },
    { 0x63FF7079, "_a53" },
    { 0x0495022B, "_a530" },
    { 0xDE9287C2, "_a531" },
    { 0xB8900D59, "_a532" },
    { 0xB3B12FD3, "_a5328" },
    { 0x9C9EEBCF, "_a534" },
    { 0x769C7166, "_a535" },
    { 0x18BAFCD9, "_a5353" },
    { 0x6ED14A8A, "_a5358" },
    { 0xF68F6AAD, "_a5379" },
    { 0x0EA65B0A, "_a539" },
    { 0x220BD486, "_a54" },
    { 0xBE77E862, "_a540" },
    { 0xC8FE4C1E, "_a5408" },
    { 0xE47A62CB, "_a541" },
    { 0x7272F390, "_a542" },
    { 0x98756DF9, "_a543" },
    { 0x7C844C6F, "_a545" },
    { 0x0A7CDD34, "_a546" },
    { 0x307F579D, "_a547" },
    { 0xEE8BBBAA, "_a548" },
    { 0x148E3613, "_a549" },
    { 0x480E4EEF, "_a55" },
    { 0x3D0F4E8D, "_a550" },
    { 0x170CD424, "_a551" },
    { 0x8914435F, "_a552" },
    { 0x6311C8F6, "_a553" },
    { 0xA50564E9, "_a554" },
    { 0xF10A59BB, "_a556" },
    { 0xCB07DF52, "_a557" },
    { 0x6D2321D5, "_a558" },
    { 0x4720A76C, "_a559" },
    { 0xB83AF3A2, "_a5596" },
    { 0xD606DFB4, "_a56" },
    { 0x805B34AC, "_a560" },
    { 0x5B6C4434, "_a5600" },
    { 0xA65DAF15, "_a561" },
    { 0xCC60297E, "_a562" },
    { 0xF262A3E7, "_a563" },
    { 0xE8514B08, "_a564" },
    { 0x0E53C571, "_a565" },
    { 0x34563FDA, "_a566" },
    { 0x5A58BA43, "_a567" },
    { 0x7649DBCD, "_a569" },
    { 0xFC095A1D, "_a57" },
    { 0xAA11D5C1, "_a5704" },
    { 0xB42ADA85, "_a572" },
    { 0x8E28601C, "_a573" },
    { 0x6825E5B3, "_a574" },
    { 0x42236B4A, "_a575" },
    { 0x1C20F0E1, "_a576" },
    { 0xF61E7678, "_a577" },
    { 0xD01BFC0F, "_a578" },
    { 0xAA1981A6, "_a579" },
    { 0xBA15BE2A, "_a58" },
    { 0xBA12B58E, "_a580" },
    { 0x6E0DC0BC, "_a582" },
    { 0x94103B25, "_a583" },
    { 0x2208CBEA, "_a584" },
    { 0x480B4653, "_a585" },
    { 0xD603D718, "_a586" },
    { 0xFC065181, "_a587" },
    { 0xB0015CAF, "_a589" },
    { 0xE0183893, "_a59" },
    { 0x79980319, "_a590" },
    { 0x539588B0, "_a591" },
    { 0xC59CF7EB, "_a592" },
    { 0x9F9A7D82, "_a593" },
    { 0x09B2B652, "_a5934" },
    { 0x11A1ECBD, "_a594" },
    { 0xEB9F7254, "_a595" },
    { 0xA9ABD661, "_a598" },
    { 0xCBB9D1D7, "_a60" },
    { 0x2C5DAEE5, "_a600" },
    { 0xC448C24B, "_a6004" },
    { 0x065B347C, "_a601" },
    { 0x7862A3B7, "_a602" },
    { 0x5260294E, "_a603" },
    { 0x9453C541, "_a604" },
    { 0xB9111587, "_a6044" },
    { 0x930E9B1E, "_a6045" },
    { 0x6E514AD8, "_a605" },
    { 0xE058BA13, "_a606" },
    { 0xBA563FAA, "_a607" },
    { 0xFC49DB9D, "_a608" },
    { 0xD6476134, "_a609" },
    { 0xA5B7576E, "_a61" },
    { 0xADC648BA, "_a610" },
    { 0xD3C8C323, "_a611" },
    { 0x61C153E8, "_a612" },
    { 0x87C3CE51, "_a613" },
    { 0x45D0325E, "_a614" },
    { 0x1FCDB7F5, "_a617" },
    { 0xCDF6539B, "_a6174" },
    { 0xA3B4EFDB, "_a619" },
    { 0x7FB4DD05, "_a62" },
    { 0x2F2EE28F, "_a620" },
    { 0x092C6826, "_a621" },
    { 0x4F68D126, "_a6214" },
    { 0xE329EDBD, "_a622" },
    { 0xBD277354, "_a623" },
    { 0x9724F8EB, "_a624" },
    { 0x71227E82, "_a625" },
    { 0x4B200419, "_a626" },
    { 0x15B15044, "_a6274" },
    { 0x5F42B5D7, "_a628" },
    { 0x39403B6E, "_a629" },
    { 0x59B2629C, "_a63" },
    { 0xAF5A47E4, "_a630" },
    { 0xD55CC24D, "_a631" },
    { 0x682B0B5E, "_a6311" },
    { 0xFB5F3CB6, "_a632" },
    { 0x2161B71F, "_a633" },
    { 0x17505E40, "_a634" },
    { 0x3D52D8A9, "_a635" },
    { 0x8957CD7B, "_a637" },
    { 0x05709595, "_a639" },
    { 0x33AFE833, "_a64" },
    { 0x0AC06750, "_a641" },
    { 0x7CC7D68B, "_a642" },
    { 0x56C55C22, "_a643" },
    { 0xC8CCCB5D, "_a644" },
    { 0xA2CA50F4, "_a645" },
    { 0x14D1C02F, "_a646" },
    { 0xEECF45C6, "_a647" },
    { 0x60D6B501, "_a648" },
    { 0x3AD43A98, "_a649" },
    { 0x7A91AB61, "_a6491" },
    { 0x0DAD6DCA, "_a65" },
    { 0x727AC8AE, "_a650" },
    { 0x3B60379B, "_a6509" },
    { 0x987D4317, "_a651" },
    { 0x4C784E45, "_a653" },
    { 0xDA70DF0A, "_a654" },
    { 0x00735973, "_a655" },
    { 0x8E6BEA38, "_a656" },
    { 0xB46E64A1, "_a657" },
    { 0x68696FCF, "_a659" },
    { 0xE7AAF361, "_a66" },
    { 0xF2A62E03, "_a660" },
    { 0xCCA3B39A, "_a661" },
    { 0x952B6EDF, "_a6619" },
    { 0x8AB017A7, "_a664" },
    { 0x64AD9D3E, "_a665" },
    { 0x18A8A86C, "_a667" },
    { 0xC2925ABB, "_a668" },
    { 0xC1A878F8, "_a67" },
    { 0x740EC7D8, "_a670" },
    { 0x9A114241, "_a671" },
    { 0x0C18B17C, "_a674" },
    { 0x321B2BE5, "_a675" },
    { 0x581DA64E, "_a676" },
    { 0x43FAF490, "_a678" },
    { 0x69FD6EF9, "_a679" },
    { 0x9BA5FE8F, "_a68" },
    { 0xF57761AD, "_a680" },
    { 0xCF74E744, "_a681" },
    { 0x1B79DC16, "_a683" },
    { 0x5D6D7809, "_a684" },
    { 0xEF4D0B8B, "_a6853" },
    { 0xA9726CDB, "_a686" },
    { 0x836FF272, "_a687" },
    { 0xA1B4178F, "_a6871" },
    { 0x258B34F5, "_a688" },
    { 0xFF88BA8C, "_a689" },
    { 0x58AAB470, "_a6894" },
    { 0x75A38426, "_a69" },
    { 0x76DFFB82, "_a690" },
    { 0x9CE275EB, "_a691" },
    { 0x03F694A1, "_a6910" },
    { 0x2ADB06B0, "_a692" },
    { 0x0EE9E526, "_a694" },
    { 0xC2E4F054, "_a696" },
    { 0xE8E76ABD, "_a697" },
    { 0xA6F3CECA, "_a698" },
    { 0x4BE5372C, "_a70" },
    { 0x45AE33B4, "_a700" },
    { 0x6BB0AE1D, "_a701" },
    { 0x91B32886, "_a702" },
    { 0xB7B5A2EF, "_a703" },
    { 0xADA44A10, "_a704" },
    { 0xD3A6C479, "_a705" },
    { 0x1FABB94B, "_a707" },
    { 0x75C206FC, "_a708" },
    { 0x9BC48165, "_a709" },
    { 0x71E7B195, "_a71" },
    { 0x9E431F76, "_a711" },
    { 0x7840A50D, "_a712" },
    { 0x523E2AA4, "_a713" },
    { 0x2C3BB03B, "_a714" },
    { 0x063935D2, "_a715" },
    { 0xE036BB69, "_a716" },
    { 0xBA344100, "_a717" },
    { 0xF4596D27, "_a718" },
    { 0xCE56F2BE, "_a719" },
    { 0x97EA2BFE, "_a72" },
    { 0x6A1CAEF3, "_a721" },
    { 0xF8153FB8, "_a722" },
    { 0xDC241E2E, "_a724" },
    { 0x02269897, "_a725" },
    { 0x901F295C, "_a726" },
    { 0xB621A3C5, "_a727" },
    { 0x14066142, "_a728" },
    { 0xBDECA667, "_a73" },
    { 0xC2B19AB5, "_a730" },
    { 0x0EB68F87, "_a732" },
    { 0xE8B4151E, "_a733" },
    { 0x2AA7B111, "_a734" },
    { 0x04A536A8, "_a735" },
    { 0x76ACA5E3, "_a736" },
    { 0x50AA2B7A, "_a737" },
    { 0x929DC76D, "_a738" },
    { 0x6C9B4D04, "_a739" },
    { 0xB3DB4D88, "_a74" },
    { 0x0A62B3A8, "_a740" },
    { 0x5667A87A, "_a742" },
    { 0x7C6A22E3, "_a743" },
    { 0xA26C9D4C, "_a744" },
    { 0xC86F17B5, "_a745" },
    { 0xEE71921E, "_a746" },
    { 0x14740C87, "_a747" },
    { 0xDA4EE060, "_a748" },
    { 0x00515AC9, "_a749" },
    { 0xD9DDC7F1, "_a75" },
    { 0x88FA19D3, "_a750" },
    { 0x62F79F6A, "_a751" },
    { 0x16F2AA98, "_a753" },
    { 0xFB01890E, "_a755" },
    { 0xAEFC943C, "_a757" },
    { 0x32E3CC22, "_a759" },
    { 0xFFE0425A, "_a76" },
    { 0x07917FFE, "_a760" },
    { 0x2D93FA67, "_a761" },
    { 0xBB8C8B2C, "_a762" },
    { 0xE18F0595, "_a763" },
    { 0x6F87965A, "_a764" },
    { 0x958A10C3, "_a765" },
    { 0x2382A188, "_a766" },
    { 0x49851BF1, "_a767" },
    { 0xFD80271F, "_a769" },
    { 0x25E2BCC3, "_a77" },
    { 0xC716CD89, "_a770" },
    { 0x131BC25B, "_a772" },
    { 0xED1947F2, "_a773" },
    { 0x391E3CC4, "_a775" },
    { 0xAB25ABFF, "_a776" },
    { 0xF72AA0D1, "_a778" },
    { 0xD1282668, "_a779" },
    { 0xCF17339C, "_a780" },
    { 0x1B1C286E, "_a782" },
    { 0x411EA2D7, "_a783" },
    { 0x370D49F8, "_a784" },
    { 0x5D0FC461, "_a785" },
    { 0x83123ECA, "_a786" },
    { 0xF42AD6DC, "_a7862" },
    { 0xC505DABD, "_a789" },
    { 0x41D3DE4D, "_a79" },
    { 0x4DAE99C7, "_a790" },
    { 0x27AC1F5E, "_a791" },
    { 0x01A9A4F5, "_a792" },
    { 0xB5A4B023, "_a794" },
    { 0x699FBB51, "_a796" },
    { 0x439D40E8, "_a797" },
    { 0xF7984C16, "_a799" },
    { 0xCB51BC13, "_a8" },
    { 0x45220599, "_a80" },
    { 0x0D67294B, "_a800" },
    { 0xE764AEE2, "_a801" },
    { 0xC1623479, "_a802" },
    { 0x9B5FBA10, "_a803" },
    { 0x596C1E1D, "_a806" },
    { 0x3369A3B4, "_a807" },
    { 0x3D7AFC93, "_a808" },
    { 0x1778822A, "_a809" },
    { 0x1F1F8B30, "_a81" },
    { 0x8ECFC320, "_a810" },
    { 0xB4D23D89, "_a811" },
    { 0xDAD4B7F2, "_a812" },
    { 0x00D7325B, "_a813" },
    { 0x26D9ACC4, "_a814" },
    { 0x4CDC272D, "_a815" },
    { 0x72DEA196, "_a816" },
    { 0x98E11BFF, "_a817" },
    { 0xBEE39668, "_a818" },
    { 0xE4E610D1, "_a819" },
    { 0x9126FA6B, "_a82" },
    { 0x0BD32A21, "_a820" },
    { 0xE5D0AFB8, "_a821" },
    { 0x57D81EF3, "_a822" },
    { 0xA3DD13C5, "_a824" },
    { 0x4273292B, "_a8244" },
    { 0x7DDA995C, "_a825" },
    { 0xEFE20897, "_a826" },
    { 0xC9DF8E2E, "_a827" },
    { 0xDBBF56D9, "_a828" },
    { 0xB5BCDC70, "_a829" },
    { 0x6B248002, "_a83" },
    { 0x8BFE8F76, "_a830" },
    { 0xB20109DF, "_a831" },
    { 0x65FC150D, "_a833" },
    { 0xF3F4A5D2, "_a834" },
    { 0x19F7203B, "_a835" },
    { 0xA7EFB100, "_a836" },
    { 0xBC1262BE, "_a838" },
    { 0xE214DD27, "_a839" },
    { 0xDD2BEF3D, "_a84" },
    { 0x96FA873C, "_a843" },
    { 0x70F80CD3, "_a844" },
    { 0x4AF5926A, "_a845" },
    { 0x24F31801, "_a846" },
    { 0xD8EE232F, "_a848" },
    { 0xB2EBA8C6, "_a849" },
    { 0xB72974D4, "_a85" },
    { 0x8A6A904C, "_a850" },
    { 0xD66F851E, "_a852" },
    { 0xF260A6A8, "_a854" },
    { 0x18632111, "_a855" },
    { 0x3E659B7A, "_a856" },
    { 0x646815E3, "_a857" },
    { 0x5A56BD04, "_a858" },
    { 0x8059376D, "_a859" },
    { 0x2930E40F, "_a86" },
    { 0x471EAA2D, "_a860" },
    { 0x6D212496, "_a863" },
    { 0xAF14C089, "_a864" },
    { 0xD5173AF2, "_a867" },
    { 0x5130030C, "_a869" },
    { 0x032E69A6, "_a87" },
    { 0xEE89BE6B, "_a871" },
    { 0x60912DA6, "_a874" },
    { 0x8693A80F, "_a875" },
    { 0x3A8EB33D, "_a877" },
    { 0xF89B174A, "_a878" },
    { 0x1E9D91B3, "_a879" },
    { 0x7535D8E1, "_a88" },
    { 0x444D7683, "_a880" },
    { 0x1E4AFC1A, "_a881" },
    { 0xD2460748, "_a883" },
    { 0xDC576027, "_a884" },
    { 0xB654E5BE, "_a885" },
    { 0x90526B55, "_a886" },
    { 0x6A4FF0EC, "_a887" },
    { 0x1439A33B, "_a888" },
    { 0x4F335E78, "_a89" },
    { 0xC5B61058, "_a890" },
    { 0xEBB88AC1, "_a891" },
    { 0x11BB052A, "_a892" },
    { 0x37BD7F93, "_a893" },
    { 0x5DBFF9FC, "_a894" },
    { 0x83C27465, "_a895" },
    { 0xBBA4B779, "_a899" },
    { 0xA54F41AA, "_a9" },
    { 0x859CB80E, "_a90" },
    { 0x433ECA5A, "_a900" },
    { 0x694144C3, "_a901" },
    { 0x1D3C4FF1, "_a903" },
    { 0xDB48B3FE, "_a904" },
    { 0x014B2E67, "_a905" },
    { 0x8F43BF2C, "_a906" },
    { 0xB5463995, "_a907" },
    { 0x392D717B, "_a909" },
    { 0xAB9F3277, "_a91" },
    { 0xC3136505, "_a910" },
    { 0x9D10EA9C, "_a911" },
    { 0x0F1859D7, "_a912" },
    { 0xE915DF6E, "_a913" },
    { 0x050700F8, "_a915" },
    { 0x510BF5CA, "_a917" },
    { 0x92FF91BD, "_a918" },
    { 0x3997C33C, "_a92" },
    { 0x460FFE04, "_a920" },
    { 0x6C12786D, "_a921" },
    { 0x9214F2D6, "_a922" },
    { 0xB8176D3F, "_a923" },
    { 0xAE061460, "_a924" },
    { 0xD4088EC9, "_a925" },
    { 0x200D839B, "_a927" },
    { 0x7623D14C, "_a928" },
    { 0x9C264BB5, "_a929" },
    { 0x5F9A3DA5, "_a93" },
    { 0xC4A7642F, "_a930" },
    { 0x9EA4E9C6, "_a931" },
    { 0x78A26F5D, "_a932" },
    { 0x529FF4F4, "_a933" },
    { 0x069B0022, "_a935" },
    { 0xE09885B9, "_a936" },
    { 0xBA960B50, "_a937" },
    { 0xF4BB3777, "_a938" },
    { 0xCEB8BD0E, "_a939" },
    { 0xED92CE6A, "_a94" },
    { 0x2DF5C4B7, "_a941" },
    { 0xBBEE557C, "_a942" },
    { 0xE1F0CFE5, "_a943" },
    { 0x95EBDB13, "_a945" },
    { 0x23E46BD8, "_a946" },
    { 0x49E6E641, "_a947" },
    { 0xD7DF7706, "_a948" },
    { 0xFDE1F16F, "_a949" },
    { 0x139548D3, "_a95" },
    { 0xC77897D9, "_a950" },
    { 0xA1761D70, "_a951" },
    { 0x137D8CAB, "_a952" },
    { 0xED7B1242, "_a953" },
    { 0x39800714, "_a955" },
    { 0x8584FBE6, "_a957" },
    { 0xF78C6B21, "_a958" },
    { 0xA18DD998, "_a96" },
    { 0x0AC47DF8, "_a960" },
    { 0x56C972CA, "_a962" },
    { 0x7CCBED33, "_a963" },
    { 0xC8D0E205, "_a965" },
    { 0xEED35C6E, "_a966" },
    { 0x14D5D6D7, "_a967" },
    { 0xDAB0AAB0, "_a968" },
    { 0x00B32519, "_a969" },
    { 0xC7905401, "_a97" },
    { 0xA1C212F1, "_a9744" },
    { 0xD560D8F5, "_a976" },
    { 0xAF5E5E8C, "_a977" },
    { 0x594810DB, "_a978" },
    { 0x33459672, "_a979" },
    { 0x5588E4C6, "_a98" },
    { 0x0C587D22, "_a980" },
    { 0xE65602B9, "_a983" },
    { 0xCA64E12F, "_a985" },
    { 0x7E5FEC5D, "_a987" },
    { 0x626ECAD3, "_a989" },
    { 0x7B8B5F2F, "_a99" },
    { 0x8AEFE34D, "_a990" },
    { 0x64ED68E4, "_a991" },
    { 0xD6F4D81F, "_a992" },
    { 0xB0F25DB6, "_a993" },
    { 0xF2E5F9A9, "_a994" },
    { 0x3EEAEE7B, "_a996" },
    { 0x18E87412, "_a997" },
    { 0xBB03B695, "_a998" },
    { 0x32421DDC, "_a_" },
    { 0x32C46E6E, "_a_fire_direction_shooters" },
    { 0xC42A3070, "_a_objects" },
    { 0xF0919D60, "_ability_gadgets" },
    { 0x19EEA72E, "_ability_player" },
    { 0x132366B4, "_ability_power" },
    { 0x3BDB9FF6, "_ability_turn_off" },
    { 0x867392E8, "_ability_turn_on" },
    { 0x8CF78D3D, "_ability_util" },
    { 0x0D9491C0, "_ac130" },
    { 0x650B9611, "_ac130_amb" },
    { 0x4CD13D93, "_ac130_clear_enemies" },
    { 0xB63AC633, "_ac130_vibration" },
    { 0x2DD7B233, "_ack_lines" },
    { 0x4B0E0A77, "_acousticsensor" },
    { 0x7FB8ABCC, "_action_overrides" },
    { 0x30FBE5A3, "_activate" },
    { 0x6309EF6E, "_active" },
    { 0x8B36B632, "_active_glow_green" },
    { 0xBDB0106A, "_active_perm_list" },
    { 0xBE16EA09, "_active_sq_radio" },
    { 0x69D1C4B0, "_active_tanks" },
    { 0x35AF5A6A, "_active_wallbuys" },
    { 0xFB9129A6, "_actor_client_flag_blackhole" },
    { 0xBF076152, "_add_anim_to_current_scene" },
    { 0x9E71E427, "_add_cheap_actor_model_anim" },
    { 0xE9EE0DB7, "_add_entities_in_range" },
    { 0x955C593A, "_add_notetrack_func" },
    { 0x76632B5B, "_add_to_spoken_dialog" },
    { 0xD346EB70, "_addadjusttocover" },
    { 0x6104DDD0, "_additional_carpenter_nodes" },
    { 0x83283928, "_additional_wallbuy_weapons" },
    { 0x952561DA, "_ads_button_pressed" },
    { 0x2A7CCC30, "_ads_button_think_threaded" },
    { 0x29370805, "_afghanstinger" },
    { 0xDE66C938, "_afghanstinger_airburst_button_check" },
    { 0x26B47733, "_afghanstinger_detonate_function" },
    { 0xE98451B9, "_afghanstinger_fire_watcher" },
    { 0x9846BCC7, "_afghanstinger_fireballs_think" },
    { 0xADC29E83, "_afghanstinger_impact_check" },
    { 0x61967139, "_afghanstinger_missile_think" },
    { 0xE733346C, "_ai_chair_anim" },
    { 0xAF4A4F3F, "_ai_class" },
    { 0x4C5DE150, "_ai_delete" },
    { 0x07CD387E, "_ai_group" },
    { 0xD7B6739F, "_ai_health" },
    { 0xD4DDBFDC, "_ai_melee_animname" },
    { 0x37C14D7D, "_ai_melee_animtype" },
    { 0x756101CD, "_ai_melee_attachedknife" },
    { 0xC46BA7C5, "_ai_melee_attacker_loser" },
    { 0xCD1514DD, "_ai_melee_initiator" },
    { 0xFFE33694, "_ai_melee_markeddead" },
    { 0x49D31D69, "_ai_melee_opponent" },
    { 0x3542B6D2, "_ai_rain_thread" },
    { 0xD788379D, "_ai_rappel" },
    { 0xA8D8656B, "_ai_supplements" },
    { 0x0DF50E15, "_ai_tank" },
    { 0x0A0F1D52, "_ai_tank_fx" },
    { 0x4ADF0BA3, "_ai_use_turret" },
    { 0x7EDC5D45, "_aiarray" },
    { 0x02E1AB63, "_aigroup_name" },
    { 0x8D8603C2, "_aim_spotlight" },
    { 0x4885A2EA, "_air_ambience_think" },
    { 0xBEDBB0CA, "_aircraft" },
    { 0xA88282B6, "_aircraft_launcher_logic" },
    { 0xAD59C6CA, "_airstrike" },
    { 0xCCE18EB1, "_airsupport" },
    { 0x151EE41A, "_aitype" },
    { 0xE5939CAB, "_aivsai_meleebundles" },
    { 0x086F3144, "_ak_impacts" },
    { 0xDF96E76A, "_alert" },
    { 0x15A486B0, "_all_locations" },
    { 0x3B46D82C, "_all_pieces_found" },
    { 0x538F4C7E, "_all_previous_done" },
    { 0x2CAD96C3, "_alley" },
    { 0xBD6C6354, "_allow_ads" },
    { 0x64E767EA, "_allow_lean" },
    { 0xF06EB43E, "_allow_melee" },
    { 0xC5B11914, "_allow_melee_weapon_switching" },
    { 0xFEDA01F0, "_allow_prone" },
    { 0x53D5F646, "_allow_sprint" },
    { 0x55EBD91F, "_allowpainrestore" },
    { 0xF4C47860, "_alt_weapon" },
    { 0x33233A00, "_ambient" },
    { 0xA6A20D9C, "_ambient_civilian_group_1_react" },
    { 0x3613A550, "_ambientpackage" },
    { 0x7EB1BB9A, "_ammo" },
    { 0xE0C5AFDA, "_ammo_attachment" },
    { 0x531E2456, "_ammo_icon" },
    { 0x574A592D, "_ammo_refill" },
    { 0x8A1C0006, "_ammo_refill_horse_think" },
    { 0x2F6EAAD8, "_ammo_refill_think" },
    { 0x4FD5C4A4, "_ammo_refill_think_alt" },
    { 0x60F31252, "_ammo_refill_think_old" },
    { 0x4E23815F, "_ammo_ring" },
    { 0x944EB8C8, "_ammo_ring_clip" },
    { 0xA2475760, "_ammo_ring_trig" },
    { 0xDF217A4C, "_ammo_toss_cooldown" },
    { 0xBA1AAAA6, "_amtank" },
    { 0x9874C614, "_amws" },
    { 0x23F80AD0, "_ang" },
    { 0x16B732D9, "_angle" },
    { 0x2D217CEF, "_anim" },
    { 0x5F3B0BA9, "_anim_blend_in_time" },
    { 0xC77156AA, "_anim_blend_out_time" },
    { 0xAD7733B8, "_anim_idle" },
    { 0x47D0D903, "_anim_intro_done" },
    { 0xC5324794, "_anim_notify_" },
    { 0xF7DCA18E, "_anim_old_disablearrivals" },
    { 0x884BA3A6, "_anim_old_fixednode" },
    { 0xCF12B408, "_anim_playing" },
    { 0x74DE2623, "_anim_playonce" },
    { 0xE59BE094, "_anim_rate" },
    { 0xEAF8625F, "_anim_reach" },
    { 0x77C6280F, "_anim_solo_queue" },
    { 0x4D3D48F9, "_anim_stopped" },
    { 0x4D517A17, "_anim_stopped_notify" },
    { 0xEF705A0D, "_animactive" },
    { 0xA38F4498, "_animate_asset" },
    { 0xC85F1E54, "_animate_fire" },
    { 0x128FD0D0, "_animate_fire_for_time" },
    { 0x0FFFCA6E, "_animate_idle" },
    { 0xB5E3D825, "_animatedmodels" },
    { 0x45DC32A2, "_animationmocomps" },
    { 0xFCFA9550, "_anime" },
    { 0x624A1226, "_animmode" },
    { 0x296635E2, "_animname" },
    { 0x53A9F207, "_animnode" },
    { 0x3D65C833, "_animnotetrackhandlers" },
    { 0x86A73B61, "_animnotifyfuncs" },
    { 0x80E1CD36, "_anims" },
    { 0x3B47CBEA, "_animscripts_init" },
    { 0xF607A427, "_annihilate" },
    { 0x8B7C44EF, "_annihilatecorpse" },
    { 0xCD7411DA, "_apc" },
    { 0x1A392D75, "_apc_buffel" },
    { 0xFBF223AF, "_apc_cougar_ride" },
    { 0x28C02FC3, "_ape_zombie_stumpy_melee" },
    { 0xF6B3F9C2, "_append_name" },
    { 0xCFD78E39, "_ar" },
    { 0x43D1DE19, "_arcademode" },
    { 0x28D5FA3F, "_are_all_players_in_time_bomb_volume" },
    { 0x24C2EDDD, "_arena" },
    { 0x9B47E6E8, "_argus" },
    { 0x914F171C, "_armblade" },
    { 0xEB6316B5, "_armor" },
    { 0xA9F82FF9, "_armor_doing_transition" },
    { 0x45F4F0F7, "_array" },
    { 0x93520A29, "_array_flag_wait_any_calls" },
    { 0xB2E1EBC1, "_array_wait" },
    { 0xBC043E89, "_array_wait_count" },
    { 0xFFAAE2AF, "_arrival" },
    { 0xA2745B4F, "_art" },
    { 0x1A5034F2, "_artillery" },
    { 0xF11031A3, "_assemble_already_exist_model" },
    { 0x4B10B730, "_assemble_assets" },
    { 0x3A28C0AB, "_assemble_multiple_ais" },
    { 0x5CC3B341, "_assemble_non_existent_model" },
    { 0x1E717D38, "_assemble_single_ai" },
    { 0x3CA0BA12, "_assign_ents_by_name" },
    { 0x139BA537, "_assign_ents_by_type" },
    { 0x2BEF6297, "_assign_unique_name" },
    { 0x38EAD194, "_assignable_attachments" },
    { 0x05ABCC19, "_assignable_camos" },
    { 0x6F9C68D0, "_assignable_camos_index" },
    { 0xECDA08FA, "_assignable_level_camos" },
    { 0x8D5579B1, "_assignable_weapons" },
    { 0x38B81452, "_assigned_num_attachments" },
    { 0xA06100DB, "_assignphalanxstance" },
    { 0x020D26FD, "_astevaluatorscriptfunctions" },
    { 0xE6ACFF89, "_attach_jetpack_fx" },
    { 0xDCEBE9B0, "_attachment_forced_banned" },
    { 0x9F2F6EE2, "_attachment_percentage" },
    { 0x9D68F2B3, "_attachments_compatible" },
    { 0x93AFFFBA, "_attack_button_think_threaded" },
    { 0x188A54F7, "_attack_drone" },
    { 0x2E6507AE, "_attackers_chasing_player" },
    { 0x432380AC, "_attackers_killed_by_player" },
    { 0x7D997CCA, "_attribute_callback" },
    { 0xDAC66378, "_attribute_default_value" },
    { 0xD1969B79, "_attribute_max_value" },
    { 0x469730F3, "_attribute_min_value" },
    { 0x8268F16F, "_attribute_type" },
    { 0x378BECF9, "_attribute_values" },
    { 0x91D3729E, "_audio" },
    { 0xCD1D7949, "_audio_alarm_active" },
    { 0x75D6586E, "_audio_alias_override" },
    { 0xC987904C, "_audio_custom_player_playvox" },
    { 0x952917EF, "_audio_custom_response_line" },
    { 0xC5154E4A, "_audio_custom_weapon_check" },
    { 0xF0B837C3, "_audio_director_vox" },
    { 0x145D8DBC, "_audio_director_vox_play" },
    { 0x906B69CD, "_audio_func_pointer" },
    { 0xDABF4114, "_audio_spiderbot_override" },
    { 0x9E400E00, "_audio_zbv_shared_ent_list" },
    { 0xDEFAB3C6, "_audio_zombie_gasmask_func" },
    { 0xBA6BFCE3, "_audioswim_dryland" },
    { 0x735EE98D, "_auditorium" },
    { 0xCD0105D2, "_auto_init_misc_turret" },
    { 0x743FA916, "_auto_turret" },
    { 0x7C1856C6, "_autosave" },
    { 0xECFD1DE2, "_autosave_after_bink" },
    { 0x7061C422, "_autosave_game_now" },
    { 0xCBF4D385, "_av_out_of_world" },
    { 0x248D51F2, "_avenger" },
    { 0x9D57C8D2, "_awards" },
    { 0x89087282, "_b" },
    { 0xCCCAA591, "_b_" },
    { 0x47030A77, "_b_set_goal" },
    { 0x0BD19BCB, "_b_spawnonce_used" },
    { 0x53405011, "_back_on_track_wait" },
    { 0x412B0B46, "_balcony_collapse_internal" },
    { 0x94DAABA1, "_ball_glow" },
    { 0x8F7368CB, "_ballistic_knife" },
    { 0x1111C851, "_banzai" },
    { 0xAA7614B8, "_barrier_jump_failsafe" },
    { 0xA6F84BCA, "_base_weapon" },
    { 0xA761B47A, "_basic_actor_setup" },
    { 0x78E42B49, "_basic_mov_actor_setup" },
    { 0x05F25D94, "_basic_prop_setup" },
    { 0x4AEDAA9A, "_bathroom" },
    { 0x4A2477B0, "_baton_guard" },
    { 0x9AD1A1B5, "_battlechatter" },
    { 0xEC413D37, "_battlechatter_mp" },
    { 0x933E928C, "_bayonet" },
    { 0xAE969AF4, "_bb" },
    { 0x4C9E802C, "_bbdata" },
    { 0x8894208B, "_be" },
    { 0x08731D8B, "_be_complete" },
    { 0xE3302A4D, "_be_model" },
    { 0xA6915140, "_be_org_anim" },
    { 0x065DCDCC, "_be_origin_animate" },
    { 0xD39257A8, "_be_pos" },
    { 0x8CCD5FAE, "_be_start" },
    { 0xAFF8CADA, "_be_vehicle" },
    { 0x9E8EB0CE, "_behavior" },
    { 0xEF9C367B, "_behavior_tracker" },
    { 0x5E7DEBA7, "_behaviortreeactions" },
    { 0xD59A4E7A, "_behaviortreescriptfunctions" },
    { 0x34905696, "_being_flung" },
    { 0xEBC8273B, "_being_shellshocked" },
    { 0xEB762610, "_betty" },
    { 0xB58CDC60, "_bhb_change_anim_notified" },
    { 0x939D50A0, "_bhb_ent_flag_init" },
    { 0x393A4067, "_bhb_horizon_death" },
    { 0x83CB27EA, "_bhb_pull" },
    { 0x778A482A, "_bhb_pulled_in_fx" },
    { 0xE11A619C, "_bhb_run_attract" },
    { 0x8929B5E2, "_bhb_walk_attract" },
    { 0x9CD74034, "_bigdog" },
    { 0x7661A222, "_bink_timeout" },
    { 0x1F0F2CBD, "_biodome_tempt_arrays" },
    { 0x87BD727F, "_black_hole_active" },
    { 0x2995D73F, "_black_hole_attract_override" },
    { 0x06045C56, "_black_hole_attract_run" },
    { 0x9C825768, "_black_hole_attract_walk" },
    { 0xB12946B9, "_black_hole_bomb" },
    { 0x80CAA4DD, "_black_hole_bomb_being_pulled_in_fx" },
    { 0x026C642A, "_black_hole_bomb_collapse_death" },
    { 0x9177E56B, "_black_hole_bomb_player" },
    { 0x0E6D722F, "_black_hole_bomb_poi_override" },
    { 0x90684368, "_black_hole_bomb_tosser" },
    { 0x1D1DEC86, "_black_hole_bomb_zombies_anim_change" },
    { 0x563D5383, "_black_hole_teleport_override" },
    { 0xBC97DBEA, "_blackboard_update_rate" },
    { 0x6418267E, "_blackhawk" },
    { 0x605BA2DA, "_blackhole_bomb_valid_area_check" },
    { 0xE330B289, "_blackjack_challenges" },
    { 0xCCDBAACC, "_blast_off_sequence" },
    { 0x05B02D40, "_blend_out" },
    { 0x352CDD13, "_blocker_choke" },
    { 0xDF9B8B63, "_blocker_locations" },
    { 0x3F9B852F, "_blocker_pool" },
    { 0xCB8FE4A3, "_blocker_pool_num_free" },
    { 0xFC050351, "_blows_up" },
    { 0x1FADBC91, "_blundersplat_target_acid_stun_anim" },
    { 0x443F0D78, "_bm21" },
    { 0x2E4CBA50, "_bm21_troops" },
    { 0x233D2E99, "_bmp" },
    { 0xC10B3E8A, "_boat" },
    { 0x22FC32B5, "_boat_death" },
    { 0x19F9A0B5, "_boat_hp_regen_per_frame" },
    { 0xC63E863B, "_boat_pbr" },
    { 0xCCFCEE97, "_boat_soct_ride" },
    { 0xA5C3BD9F, "_bolt_on_back" },
    { 0xC04DF3D3, "_bonuscard" },
    { 0x7E679907, "_bot" },
    { 0x33CE675E, "_bot_combat" },
    { 0x58271C3C, "_bot_conf" },
    { 0x59044DCF, "_bot_ctf" },
    { 0xAC25D454, "_bot_dem" },
    { 0x258E0816, "_bot_dom" },
    { 0x06AF26A5, "_bot_hack" },
    { 0x9CA44213, "_bot_hq" },
    { 0xD547A49C, "_bot_koth" },
    { 0x50E6023E, "_bot_loadout" },
    { 0x36BF1E83, "_bot_sd" },
    { 0x280E7CB7, "_bottle_acquired" },
    { 0x68F41FB4, "_bounce_off_ent" },
    { 0x8518D310, "_bouncing_betties" },
    { 0x870C3433, "_bouncingbetty" },
    { 0x4382CA27, "_bouncingbettywatchfortrigger" },
    { 0x7014CAEE, "_bowie_zm_equipped" },
    { 0x8D14FAC5, "_box_indicator" },
    { 0x21469639, "_box_indicator_flash_lights_fire_sale" },
    { 0x1307911F, "_box_indicator_flash_lights_moving" },
    { 0x240FB647, "_box_indicator_no_lights" },
    { 0xCCDB256C, "_box_initialized" },
    { 0xBEA700D2, "_box_locations" },
    { 0x143A018E, "_box_open" },
    { 0x447341D0, "_box_opened_by_fire_sale" },
    { 0x26EAD289, "_box_weapons" },
    { 0xE124D647, "_breach" },
    { 0x38850E81, "_breach_explosive_left" },
    { 0x599D3D1B, "_breach_flash_right" },
    { 0xCB1F0B0E, "_breach_hinges_left" },
    { 0x2DC1CA03, "_breach_hinges_left_armada" },
    { 0x7C323D41, "_breakable_utility_maxnum" },
    { 0x0B0F8805, "_breakable_utility_modelarray" },
    { 0xDDC61786, "_breakable_utility_modelindex" },
    { 0x15FDD9A1, "_bridge_launcher_logic" },
    { 0x91EF9BDD, "_bringing_back_teammate" },
    { 0xE8454311, "_brock_corpse_locations" },
    { 0x3A44365B, "_brock_naglines" },
    { 0xF73DE653, "_brute_force_perk" },
    { 0x52A8F61A, "_bsmscriptfunctions" },
    { 0x32121D34, "_btr" },
    { 0x5969E073, "_buffalo" },
    { 0x5A859934, "_building_unlocked" },
    { 0x47945320, "_built" },
    { 0x669FAFCD, "_bulletcam" },
    { 0x43BBA372, "_bulletcam_alternatetag" },
    { 0x57B28987, "_burnbody" },
    { 0x763312BF, "_burncorpse" },
    { 0x983FBED8, "_burnplayer" },
    { 0x4DB16E9F, "_burnstage" },
    { 0x5297D191, "_burntag" },
    { 0x8EAF61A3, "_burntagson" },
    { 0x7C4633B4, "_burntagswatchclear" },
    { 0xEEF01AC0, "_burntagswatchend" },
    { 0x1C457365, "_burst_fire" },
    { 0x22B0F29A, "_bus" },
    { 0x2479DCBD, "_bus_dam_button_push_poll" },
    { 0xA58ED7C3, "_bus_dam_warp_harper_in_front_of_player" },
    { 0xF56C78D6, "_bus_pieces_deleted" },
    { 0x7AB07635, "_bus_smash_internal" },
    { 0x96C43FC5, "_buscanzombieattach" },
    { 0x2E0DBFA8, "_busfindclosesttag" },
    { 0xF1A02A61, "_busgetjumptagfrombindtag" },
    { 0x59DC43B3, "_busgetroofjointfrombindtag" },
    { 0xDC062CD6, "_busing" },
    { 0x8B033577, "_businittags" },
    { 0xC7BB36C8, "_button_funcs" },
    { 0x029F8917, "_button_press_counts" },
    { 0xBD89AC92, "_button_press_per_sec" },
    { 0x305D1F14, "_buttons_can_reset" },
    { 0x31B3D345, "_c4" },
    { 0xB76865B0, "_cagedchickens" },
    { 0x8335360E, "_calculateprojectedguardposition" },
    { 0xDBE9B2F0, "_calculaterobotspawnposition" },
    { 0x3F41BD4E, "_calculatewallrundirection" },
    { 0x18BF033A, "_call_state_funcs" },
    { 0x73C28391, "_callback" },
    { 0xC2931910, "_callbackglobal" },
    { 0xFA060778, "_callbacks" },
    { 0x2E1CC334, "_callbacksetup" },
    { 0xBD252D14, "_cam_constraints" },
    { 0x14DB1A31, "_cam_height" },
    { 0xEEED802D, "_camera" },
    { 0x6A651271, "_cameraspike" },
    { 0x3C9C8D7C, "_camo_crumb" },
    { 0x88CDF9E8, "_camo_suit" },
    { 0x4DF36054, "_camo_suit_perk_init" },
    { 0x880D8064, "_camsys" },
    { 0x6D7C073D, "_can_bullet_hit_target" },
    { 0x663B2FDD, "_can_heli_shoot" },
    { 0x0907CDFD, "_can_hit_target_safely" },
    { 0x528161C1, "_can_score" },
    { 0x006AC20A, "_can_spawn_monkey" },
    { 0xF8539DDA, "_can_spawn_napalm" },
    { 0x16D2F3BF, "_can_spawn_sonic" },
    { 0x7865872B, "_can_spotlight_see_position" },
    { 0x1B8D8614, "_cancel_connections" },
    { 0x2A676F74, "_cangrabpowerup" },
    { 0x7291563B, "_captured_flag" },
    { 0xB9BEAC35, "_car_smash_internal" },
    { 0x1859A4E3, "_car_smashes_into_market" },
    { 0xA5A78B8C, "_carpetedhallway" },
    { 0x44C763D4, "_case" },
    { 0x4EBDA707, "_cave" },
    { 0x26291911, "_centrifuge_fx_setup" },
    { 0x38890519, "_centrifuge_light_mdls_" },
    { 0x4C8FB5AD, "_centrifuge_lights_" },
    { 0x919D0D6E, "_centrifuge_sparks_" },
    { 0x8B0DC099, "_centrifuge_steams_" },
    { 0xD5D9614C, "_cf_actor_client_flag_ctt" },
    { 0x1BFFDDD2, "_cf_actor_client_flag_spikemore" },
    { 0x8F3A7119, "_cf_actor_do_not_use" },
    { 0x13320EC5, "_cf_actor_is_napalm_zombie" },
    { 0x68924EB6, "_cf_actor_is_sonic_zombie" },
    { 0x9A6FD28A, "_cf_actor_napalm_zombie_explode" },
    { 0x5E5C462D, "_cf_actor_napalm_zombie_wet" },
    { 0x7C63BC25, "_cf_actor_ragdoll_impact_gib" },
    { 0xE513A8C6, "_cf_player_electrified" },
    { 0x16F2B3D2, "_cf_player_flinger_fake_player_setup_prone" },
    { 0xD7C70A48, "_cf_player_flinger_fake_player_setup_stand" },
    { 0x173566AE, "_cf_player_gasmask_overlay" },
    { 0x971B26D9, "_cf_player_gasmask_overlay_remove" },
    { 0xEF526680, "_cf_player_geyser_fake_player_setup_prone" },
    { 0xD9ACC0D2, "_cf_player_geyser_fake_player_setup_stand" },
    { 0x932A3B96, "_cf_player_maze_floor_rumble" },
    { 0xDE9BBDC1, "_cf_player_water_freeze" },
    { 0xD5222AEE, "_cf_player_water_frost" },
    { 0x48F8B419, "_cf_player_water_frost_remove" },
    { 0xD39363D9, "_cf_player_zipline_fake_player_setup" },
    { 0x1691F00F, "_cf_player_zipline_rumble_quake" },
    { 0x42932E5F, "_cf_scriptmover_client_flag_hotsauce_start" },
    { 0xB76E144C, "_cf_scriptmover_client_flag_maze_wall" },
    { 0xEF10ED6B, "_cf_scriptmover_client_flag_sauce_end" },
    { 0x7F77597D, "_cf_scriptmover_client_flag_spikemore" },
    { 0xE25C2C85, "_cf_scriptmover_client_flag_spikes" },
    { 0xAB5D5B7C, "_cf_scriptmover_client_flag_water_trail" },
    { 0x9418FC40, "_cf_scriptmover_client_flag_weaksauce_start" },
    { 0xC2CBC8CB, "_challenge_complete" },
    { 0x8DBFF56C, "_challenge_lookup" },
    { 0x0B1E8D19, "_challenge_target" },
    { 0xFA29392A, "_challenges" },
    { 0x52B57460, "_challenges_complete" },
    { 0xE54A2796, "_challenges_coop" },
    { 0xF7B50C80, "_challenges_sp" },
    { 0x2CA22873, "_change_claw_moveplaybackrate" },
    { 0x8DA6EE53, "_character_customization" },
    { 0x74081E99, "_charge_flag" },
    { 0x7D620166, "_charge_sound_ent" },
    { 0x9ED8B2A2, "_charge_stages" },
    { 0xCEDDF497, "_charge_terminal" },
    { 0x60E6E955, "_cheat" },
    { 0x7136A639, "_cheat_player_press_slowmo" },
    { 0xACB5494D, "_check_extra_slots" },
    { 0x3538FB69, "_check_for_paused" },
    { 0x6AB8C7F0, "_check_player_available" },
    { 0x33EF777E, "_check_rappel_brake_button" },
    { 0x9AB153AA, "_check_rappel_button" },
    { 0x94A7C4F8, "_checking_for_save" },
    { 0x5C0EF367, "_checkplayer" },
    { 0x5CB3D795, "_checkprerequisites" },
    { 0x25CB7DBC, "_checkregistrationprerequisites" },
    { 0x33460EDB, "_checkvalue" },
    { 0xBE3EE8C5, "_chinook" },
    { 0xAE40491F, "_chooseweapon" },
    { 0xC7C97D21, "_chopper_support" },
    { 0xD0A13446, "_chopperboss" },
    { 0x6BAD6797, "_chopperstrike_section" },
    { 0x9932C511, "_chugabud_post_respawn_override_func" },
    { 0xB38947EE, "_chugabud_reject_node_override_func" },
    { 0x6100DA61, "_chugabug_reject_corpse_override_func" },
    { 0x661A3012, "_chute_inc" },
    { 0x7362E9D5, "_chute_pull_started" },
    { 0x27F2C47C, "_chute_pulled" },
    { 0xC3CFEA36, "_chute_speed_down" },
    { 0x9252833E, "_chute_speed_left_right" },
    { 0x9370B035, "_chute_speed_up" },
    { 0xCDD29B74, "_cic_turret" },
    { 0x82437F0D, "_city" },
    { 0x5E8AC175, "_civ_pickup" },
    { 0x4CBBD612, "_civ_pickup_big" },
    { 0xA08FF317, "_civ_vehicle" },
    { 0x3DD851D7, "_civilian" },
    { 0x9EFEE440, "_civilian_idle" },
    { 0x66FE6E19, "_civilian_move" },
    { 0x7902438E, "_civilians" },
    { 0x8B289E32, "_civilians_anim" },
    { 0x28DB7C98, "_class" },
    { 0x3F72007B, "_classic_setup_func" },
    { 0x9F995231, "_classname" },
    { 0xD9A672D5, "_claw" },
    { 0x423516A3, "_claw_attacks_player_target" },
    { 0x333F679C, "_claw_door_target_move" },
    { 0xDF2CDA40, "_claw_fire_direction_grenades" },
    { 0x15FE0A57, "_claw_fire_guns_at_targets_in_range" },
    { 0x5B119132, "_claw_grenade" },
    { 0xD2A5FADC, "_claw_grenade_launch_internal" },
    { 0x5345A50E, "_claw_launches_grenade_at_guy" },
    { 0x3FD6F022, "_claw_scripted_fire_turret_at_target" },
    { 0x5CE55F98, "_claw_scripted_set_turret_target" },
    { 0xCE01AE16, "_claw_scripted_stop_turret" },
    { 0x7DF5BE44, "_claymore" },
    { 0x2CCF8024, "_cleanup" },
    { 0xD975D303, "_cleanuprobotcorpses" },
    { 0x44DB3DC7, "_clear" },
    { 0x08DD4B18, "_clear_anim_first_frame" },
    { 0x1F1438AF, "_clear_animations" },
    { 0xC5A10C8C, "_cleared" },
    { 0xA49C4B80, "_client_exploder_ids" },
    { 0x66724066, "_client_exploders" },
    { 0x24A5B6BB, "_client_flag_callbacks" },
    { 0x12DF1B32, "_client_flagasval_callbacks" },
    { 0x6512A37D, "_clientfaceanim" },
    { 0x1E468F4F, "_clientfaceanim_mp" },
    { 0x70E457AB, "_clientfaceanim_zm" },
    { 0x2EA7CEC5, "_clientfaceanimonplayerspawned" },
    { 0xC725EF9B, "_clientflag_player_gasp_rumble" },
    { 0x0459F551, "_clientflag_player_holding_meat" },
    { 0x55C61213, "_clientflag_player_sky_transition" },
    { 0x34336901, "_clientflag_player_soul_swap" },
    { 0x30CC253B, "_clientflag_player_turned_visionset" },
    { 0x28A95631, "_clientflag_scriptmover_digger_arm_fx" },
    { 0xCDF6CB5B, "_clientflag_scriptmover_digger_digging_earthquake_rumble" },
    { 0x43D659E0, "_clientflag_scriptmover_digger_moving_earthquake_rumble" },
    { 0x5C3A4F9D, "_clientflag_scriptmover_dome_malfunction_pad" },
    { 0x7022092F, "_clientflag_vehicle_bus_brake_lights" },
    { 0x6BB531B2, "_clientflag_vehicle_bus_flashing_lights" },
    { 0xAA7AA09E, "_clientflag_vehicle_bus_head_lights" },
    { 0x52255410, "_clientflag_vehicle_bus_interior_lights" },
    { 0x1E7DC7FC, "_clientflag_vehicle_bus_turn_signal_left_lights" },
    { 0x75F510F1, "_clientflag_vehicle_bus_turn_signal_right_lights" },
    { 0x264BAAC2, "_clientflags" },
    { 0x0F0558C9, "_clientids" },
    { 0x17284A14, "_clientsys" },
    { 0x344BEC77, "_clone" },
    { 0xB19A766B, "_clone_goal" },
    { 0xCA5D5F6F, "_clone_goal_max_dist" },
    { 0x8783F9E4, "_clonebreakglass" },
    { 0xD935B10C, "_clonebuilditemlist" },
    { 0xD0FE4D5E, "_clonecopyplayerlook" },
    { 0xFAA3553C, "_clonedamaged" },
    { 0xBDB5EC20, "_clonefakefire" },
    { 0x530BD30F, "_clonegibdata" },
    { 0xC030222C, "_cloneorbfx" },
    { 0x4CB878D3, "_cloneselectweapon" },
    { 0xF8BA2C36, "_clonewatchdeath" },
    { 0x9CE27DA7, "_clonewatchownerdisconnect" },
    { 0x92432CCE, "_clonewatchshutdown" },
    { 0x8CDDC83E, "_close_magic_box" },
    { 0x7FB3FB30, "_closed" },
    { 0x2C14DD23, "_closing_in_lines_said" },
    { 0x2792AFF8, "_coast_fog_blizzard" },
    { 0xB544FBFF, "_cobra" },
    { 0xBD471893, "_cobrapilot" },
    { 0xB0542CEB, "_collapse_building_on_missile_hit" },
    { 0x478FA095, "_collectibles" },
    { 0x2A3C4FDE, "_collectibles_game" },
    { 0xBC8B8E25, "_color" },
    { 0xD0928C35, "_color_manager" },
    { 0xA1E31434, "_colors" },
    { 0x09632A7E, "_colors_go_line" },
    { 0xD44BC175, "_combat_robot" },
    { 0x71B44C60, "_compass" },
    { 0xD97B7765, "_complete" },
    { 0xB0B31693, "_concerthall" },
    { 0x027C360B, "_configureclone" },
    { 0xFB6B3C68, "_configurecloneteam" },
    { 0x3CE9BD07, "_configurerobotteam" },
    { 0x422FE99A, "_confirm_prone_order" },
    { 0x7DB15E8F, "_constants" },
    { 0x65804136, "_cont_spots" },
    { 0xDC096876, "_contextual_grab_lerp_time" },
    { 0xB41D84C4, "_contextual_melee" },
    { 0x480FE7A4, "_contextual_melee_align_obj" },
    { 0xCAB2128C, "_contextual_melee_allow_fire_button" },
    { 0x9C1ED197, "_contextual_melee_dist" },
    { 0x1953BB1E, "_contextual_melee_dist_sq" },
    { 0x06AF24E4, "_contextual_melee_hack" },
    { 0x4086CF93, "_contextual_melee_hide" },
    { 0x2FEDE520, "_contextual_melee_lerp_time" },
    { 0xC96A813F, "_contextual_melee_print_hintstring" },
    { 0x32F223E7, "_contextual_melee_thread" },
    { 0x42403B39, "_contracts" },
    { 0x29CE6155, "_conveyer_vector" },
    { 0x92D24137, "_convoy_nag_end" },
    { 0x5CEDF051, "_convoy_vehicle_think_stop" },
    { 0xBB15092B, "_coop_weaponswap" },
    { 0x80A4C993, "_cooplogic" },
    { 0xF19C9972, "_copy_kvps_to_target" },
    { 0xC377C78D, "_copycat" },
    { 0x673C03BD, "_corner_sign_swap" },
    { 0x3299568D, "_cornerlinethread" },
    { 0xB218F4C1, "_cornerlinethread_height" },
    { 0xF7133A61, "_corpse_loc_array" },
    { 0x7E45FE53, "_corpse_sci_loc_array" },
    { 0x369D3494, "_corpsewatcher" },
    { 0xEC7721EB, "_cosmodrome_black_hole_bombs" },
    { 0x8F49E1F3, "_cosmodrome_fire_sale" },
    { 0x89CC7A20, "_cosmodrome_no_power" },
    { 0x3DD7FB20, "_counteruav" },
    { 0x3ED6F199, "_crafted" },
    { 0xEA0372A2, "_crane_building_helicopter" },
    { 0x9B05EBE2, "_create_and_link_jetpack" },
    { 0xB44D8020, "_create_debug_drones_count_hud" },
    { 0x82D5FC82, "_create_fake_vehicle_and_go_path" },
    { 0x5AF19DF6, "_create_influencer" },
    { 0x4A50F7EC, "_create_radiusaxis_influencer" },
    { 0xFE57DF3B, "_create_white_screen_hud_elem" },
    { 0xB16FECAB, "_createart" },
    { 0xFC824879, "_createcam" },
    { 0xCEF6DA67, "_createdynents" },
    { 0x5D27A31E, "_createfx" },
    { 0x5D1DF2A5, "_createfx_start_time" },
    { 0x5180385A, "_createfx_time_saved" },
    { 0x2DEE8EB1, "_createfxforwardandupset" },
    { 0xFDB8BE97, "_createfxmenu" },
    { 0x6F2207A8, "_createfxundo" },
    { 0x1AAB11C1, "_createguardmarker" },
    { 0x4AF6DF51, "_createmenu" },
    { 0xC1AB47AA, "_createphalanxtier" },
    { 0x24FCDED6, "_credits" },
    { 0x5C940024, "_crystal_bounce_paths" },
    { 0x783AC250, "_crystal_sauce_end" },
    { 0x74E2D6E3, "_crystal_sauce_start" },
    { 0xAC3F0659, "_crystal_shrink_logic_running" },
    { 0x2647CBC9, "_ctf" },
    { 0x79FDCA05, "_ctt_num_players" },
    { 0x5ECA9AE1, "_ctt_pause_flag" },
    { 0xD224BBF0, "_ctt_targets" },
    { 0x8D1B3EC7, "_ctvg_pos" },
    { 0x541E1D93, "_cur_perm" },
    { 0xCA733EED, "_cur_stage_name" },
    { 0xF240C558, "_curr_black_hole_dist" },
    { 0xE40C35B4, "_current_black_hole_bomb_origin" },
    { 0xB328AC02, "_current_black_hole_bombs" },
    { 0xBBB7CAED, "_current_cont_spot" },
    { 0xD3262446, "_current_turned_match" },
    { 0x88C6E52A, "_current_weapon" },
    { 0xA2A6A193, "_currentfaceanim" },
    { 0x2F42C483, "_currentfacestate" },
    { 0x19DA4F45, "_currentroguerobot" },
    { 0x7EF05B23, "_custom_anim" },
    { 0x0E4C44C0, "_custom_box_monitor" },
    { 0x64050F98, "_custom_intro_vox" },
    { 0xDDE9E253, "_custom_perks" },
    { 0x5CB31B8B, "_custom_powerups" },
    { 0x48F10070, "_custom_strafe_function" },
    { 0x67329214, "_custom_traps" },
    { 0xF6BCB70C, "_custom_turn_packapunch_on" },
    { 0x6C613045, "_custom_weapon_cb_func" },
    { 0x7C036325, "_custom_weapon_damage_func" },
    { 0x2D0A7C7A, "_custom_zombie_audio_func" },
    { 0x80259410, "_custom_zombie_oh_shit_vox_func" },
    { 0x45CE9961, "_customactorcbfunc" },
    { 0x85B39973, "_customclasses" },
    { 0x97C71395, "_customplayerconnectfuncs" },
    { 0xD92DB589, "_customrotorfx" },
    { 0x7F5A7ACC, "_customvehiclecb" },
    { 0x1CDEC9F6, "_customvehiclecbfunc" },
    { 0xDCC31013, "_damage" },
    { 0xB0B23AED, "_damage_mod_to_damage_type" },
    { 0xB5D23105, "_damage_source" },
    { 0xAD22CD8F, "_damage_zombie_network_safe_internal" },
    { 0x3BC0364A, "_damagefeedback" },
    { 0x796D1E2B, "_dampenexplosivedamage" },
    { 0xD1D772D3, "_dart" },
    { 0xC67295D3, "_dds" },
    { 0x8D96FCD2, "_deactivate" },
    { 0x09EC3A85, "_deactivate_lerp_thread" },
    { 0xC7CD7BDA, "_dead" },
    { 0xD87CF056, "_deadbody" },
    { 0x95E9D94A, "_death_anim" },
    { 0x83567AAC, "_deathicons" },
    { 0xC834FA95, "_debug" },
    { 0xF1D8FE46, "_debug_astro_health_watch" },
    { 0x9C51DCDD, "_debug_astro_print" },
    { 0x17AF88E5, "_debug_damage_direction" },
    { 0x359109D9, "_debug_damage_intensity" },
    { 0xCA555A63, "_debug_damage_location" },
    { 0xEE8E452C, "_debug_damage_pain_location" },
    { 0x79FB6C34, "_debug_driver_run" },
    { 0xB98CDC5E, "_debug_drone" },
    { 0x33A22290, "_debug_hud_elem_func" },
    { 0xD5C720A5, "_debug_hud_elem_should_show" },
    { 0x5EDC0D3C, "_debug_pers" },
    { 0x0315640E, "_debug_print3d_msg" },
    { 0xCE21991B, "_debug_show_location" },
    { 0xC8AF98FC, "_debug_show_zone" },
    { 0xF4F9B4B2, "_debug_ss" },
    { 0xFDBCE913, "_debug_tags" },
    { 0x569DDFF3, "_debug_turret_think" },
    { 0xE9471EC5, "_debug_zones" },
    { 0x630AB33C, "_decoy" },
    { 0xD2806C07, "_decrement_network_slots_after_time" },
    { 0xCC0D4E38, "_decrement_plane_count" },
    { 0xF0FBE2BF, "_default_door_custom_logic" },
    { 0xAC91A781, "_default_player_height" },
    { 0xAC0DAFBB, "_defend_phase_length" },
    { 0xB49D3493, "_deferredinitlist" },
    { 0x1028C88D, "_delay" },
    { 0xFB6814EB, "_delay_network_frames" },
    { 0xF97EADCB, "_delay_notify" },
    { 0x5377428A, "_delay_notify_proc" },
    { 0xCC5BB1F0, "_delay_set" },
    { 0xBA4FD3EB, "_delay_thread_proc" },
    { 0x1B2CE496, "_delay_thread_watch_host_migrate_proc" },
    { 0x07B57ECA, "_delayed_delete_scene_looped_anims" },
    { 0x617FB503, "_delayedragdoll" },
    { 0xB2AC8B91, "_delete" },
    { 0xC15950E1, "_delete_ais" },
    { 0xB6AEB22C, "_delete_all_locations" },
    { 0x73B6F0BB, "_delete_at_frame_end" },
    { 0xAE45D625, "_delete_entity" },
    { 0x4E819B81, "_delete_location" },
    { 0xE81ADF4A, "_delete_models" },
    { 0x75E05EC7, "_delete_progress_bar" },
    { 0x7EB8C0BD, "_delete_pushed_horse" },
    { 0x9254927C, "_delete_scene" },
    { 0x01AAE5C3, "_delete_scene_" },
    { 0xC93F000A, "_delete_scene_ai_spawner_array" },
    { 0x6C2D293A, "_delete_scene_script_model_array" },
    { 0x3D2A51A6, "_delete_unitrigger" },
    { 0xD3393A11, "_delete_vulture_ent" },
    { 0xAE5A51C7, "_deleted" },
    { 0x051AA655, "_demo" },
    { 0x3BEC60EA, "_deploy_turret" },
    { 0x50EAED4F, "_deployable_weapons" },
    { 0x6961D899, "_deploying_chute" },
    { 0xF859BDE1, "_descent_control_active" },
    { 0x577AAE36, "_dest_aft" },
    { 0x7321B7FD, "_dest_bow" },
    { 0x7E6A2F9E, "_destroy" },
    { 0x3CA7ADD2, "_destroy_debug_drones_count_hud" },
    { 0xCB4FEBAA, "_destroy_debug_zones" },
    { 0x63D5271A, "_destroy_error_on_screen" },
    { 0x8CDB9AAF, "_destroy_maze_fountain" },
    { 0x31C66E58, "_destroy_warning_on_screen" },
    { 0x067986E1, "_destroyed" },
    { 0x08BA2A33, "_destroyguardmarker" },
    { 0x5BA78C6D, "_destructables" },
    { 0x90885D0A, "_destructible" },
    { 0x21D49B72, "_destructible_mercedesw136" },
    { 0x7DE9F497, "_destructible_opel_blitz" },
    { 0x6E6455CB, "_destructible_type94truck" },
    { 0xB18BC1E7, "_destructible_type94truckcamo" },
    { 0xED0C1C08, "_destructible_types" },
    { 0x0BBD8A45, "_destructibles" },
    { 0x937630F2, "_detect_touched" },
    { 0x6CC9771D, "_determinejumpfromorigin" },
    { 0xD0FFABB1, "_detonate_missile_near_chaff" },
    { 0xACDF855D, "_detonategrenades" },
    { 0xE965C998, "_detonator_think_done" },
    { 0x1F078195, "_dev" },
    { 0xBB58D110, "_dev_class" },
    { 0x60E90004, "_development_dvars" },
    { 0x4C2BC326, "_devgui" },
    { 0xA829667D, "_dgroup" },
    { 0x7A21FDA0, "_dialog" },
    { 0x1A1C36F2, "_dialog_array_to_string" },
    { 0x5E9EEC18, "_dialog_queue_id" },
    { 0x58FBF6F3, "_dialogue_spoken" },
    { 0xA62DE9C9, "_dials" },
    { 0x54283014, "_did_drone_hit_building_wrap" },
    { 0x510E9AC4, "_did_turret_lose_target" },
    { 0xB4D7B2D8, "_digbats" },
    { 0x7D473CAF, "_digger_fx" },
    { 0x350C06D5, "_digger_hacked" },
    { 0xB4A5674F, "_director_zombie_stumpy_melee" },
    { 0x9168FCC5, "_disable_all_long_deaths" },
    { 0x656A05FD, "_disable_drowning" },
    { 0x5631F488, "_disable_invulnerability" },
    { 0x9C16BD83, "_disable_proximity_alarms" },
    { 0xADA1252A, "_disable_reinforcement" },
    { 0x04F67820, "_disable_turret_when_user_is_done" },
    { 0x66D2D21F, "_disable_weapon" },
    { 0xB384A7A9, "_disableinvulnerability" },
    { 0xFD1B00CA, "_disableusability" },
    { 0xF9E9F0F0, "_disableweapon" },
    { 0xD334C4EC, "_disconnect_paths_when_stopped" },
    { 0xA0524078, "_disconnected_clients" },
    { 0x51EDAF0E, "_display_box_weapons" },
    { 0xA4D79BE0, "_dist" },
    { 0xA8C1E5F8, "_distance_to_black_hole" },
    { 0xECAD9D3B, "_distance_to_jetgun_owner" },
    { 0x5C0383C6, "_dizzy" },
    { 0x9BA6F3E8, "_do_death_anim" },
    { 0xC71571C2, "_do_player_or_npc_playvox_override" },
    { 0x897CCD85, "_do_trigger_function" },
    { 0xEB9D9016, "_do_vulture_death" },
    { 0x2E1F78DA, "_documents" },
    { 0x7A2DE202, "_dogfight_ally_speed_monitor" },
    { 0x9523D56A, "_dogfight_drone_attack_missile_fire" },
    { 0xA0CD28E3, "_dogfight_fire_on_command" },
    { 0x2BF485E1, "_dogfight_follow_ally" },
    { 0x30B15416, "_dogfight_spawner_determine_type" },
    { 0xC58B0727, "_dogfight_speed_monitor" },
    { 0x5599A518, "_dogfight_track_kills_for_vo" },
    { 0x558C6ECF, "_dogfights_failure_distance_check" },
    { 0xAB04733A, "_dogfights_setup_wave_parameters" },
    { 0x76B9544D, "_dogfights_warning_distance_check" },
    { 0x777143C1, "_dogs" },
    { 0x9C1EFD89, "_dogtags" },
    { 0x2F081323, "_dome_malfunction_pads" },
    { 0xC6F0CC80, "_done" },
    { 0x01392A71, "_dont_face_nextspot" },
    { 0x87542885, "_dont_look_at_player" },
    { 0x820E0702, "_dont_reconnect_paths" },
    { 0x54B80118, "_dont_unhide_quickervive_on_hotjoin" },
    { 0x26EEA729, "_dontinitnotifymessage" },
    { 0xAAB63A39, "_door1" },
    { 0xD0B8B4A2, "_door2" },
    { 0x2E1363D0, "_door_breach" },
    { 0x2C3D6F31, "_door_num" },
    { 0x3B2B1E23, "_door_open" },
    { 0x1B9AC2DA, "_door_open_rumble_func" },
    { 0xA6FE56FD, "_door_switch_trig1" },
    { 0xCD00D166, "_door_switch_trig2" },
    { 0x157C838A, "_dpad_asset" },
    { 0xF905E4B6, "_dpad_right_button_think_threaded" },
    { 0x8F05BCCC, "_dragon_ignoreme" },
    { 0x0DADDDDB, "_draw_target_fx" },
    { 0xA763F87E, "_driving_fx" },
    { 0x062046B6, "_drone" },
    { 0x84535A8E, "_drone_animnames" },
    { 0x82F98E85, "_drone_anims" },
    { 0x1D4DDA61, "_drone_death" },
    { 0xABD4B3D2, "_drone_dot_to_player" },
    { 0x0F151787, "_drone_strike" },
    { 0x6AF1BEEC, "_drone_throws_molotov_proc" },
    { 0x94F47CA9, "_drones" },
    { 0x70854733, "_drones_aipath" },
    { 0x9ED7E41C, "_drones_mg_target" },
    { 0x00F98339, "_drones_sounds_disable" },
    { 0x51F6077E, "_drop_machete_on_death" },
    { 0x89A05A00, "_drop_turret" },
    { 0x590CC02A, "_drop_zombie_stink" },
    { 0x287EE18E, "_drugged" },
    { 0xABC92C08, "_dte_done" },
    { 0x69E18BD1, "_dte_vision_set" },
    { 0xC00C188C, "_dte_vision_set_priority" },
    { 0x08DE97FD, "_dynamic_nodes" },
    { 0xFB0FE1BD, "_e" },
    { 0x7CC669E7, "_e_align" },
    { 0x4D94FE7D, "_e_align_array" },
    { 0x0F2056B7, "_e_array" },
    { 0x0B49DAC9, "_e_group" },
    { 0x6DCD59D8, "_e_root" },
    { 0xE33CE95C, "_earth" },
    { 0xC161532F, "_earthquake" },
    { 0x1A847D27, "_east" },
    { 0xC1AA5253, "_effect" },
    { 0x653AEAD2, "_effect_keys" },
    { 0xF7FA6C82, "_effects" },
    { 0x47C4B0AB, "_effecttype" },
    { 0xF5F77A66, "_elevator" },
    { 0xA2328E70, "_eliminated" },
    { 0xB4CE4546, "_emp" },
    { 0xE4AE0A58, "_empgrenade" },
    { 0x431FDB3A, "_enable_drowning" },
    { 0x8C849CA3, "_enabled" },
    { 0x7EF34152, "_enableinvulnerability" },
    { 0x248798C8, "_enablelastvalidposition" },
    { 0x72861401, "_enablepain" },
    { 0x0ED09A01, "_enableusability" },
    { 0xEE182F5D, "_enableweapon" },
    { 0xB7B5B5C2, "_encounters_round_num" },
    { 0x4718FA45, "_encounters_score_1" },
    { 0x6D1B74AE, "_encounters_score_2" },
    { 0xC60F11A2, "_encounters_team" },
    { 0x2E686F4F, "_end" },
    { 0xA8796079, "_end_door_intro" },
    { 0x3E17AEA3, "_end_game_flow" },
    { 0x498FFE5A, "_end_scene" },
    { 0xF44E7ADD, "_end_string" },
    { 0x7BF29932, "_ender" },
    { 0xB4963C8B, "_endmission" },
    { 0xB8C6EC69, "_endstreamerhint" },
    { 0x0C6A563A, "_ent_getnextflushtarget" },
    { 0xF65A45EC, "_ent_getzone" },
    { 0xB9D071CD, "_ent_getzonename" },
    { 0xCDE20F89, "_ent_waits_for_trigger" },
    { 0x9FBCB287, "_entityheadicons" },
    { 0x0BAD6F0E, "_entityshutdowncbfunc" },
    { 0xE83C7100, "_entityspawned_override" },
    { 0x1E0FBF78, "_equalizer" },
    { 0x064F3A8D, "_equip_activated_callbacks" },
    { 0x0FED2D2D, "_equipment_activated_fx" },
    { 0x05174ECB, "_equipment_disappear_fx" },
    { 0x4B3AF911, "_equipment_emp_destroy_fx" },
    { 0x14DAC587, "_equipment_explode_fx" },
    { 0x758A4821, "_equipment_explode_fx_lg" },
    { 0xC683B1AC, "_equipment_fizzleout_fx" },
    { 0x98AD569B, "_equipment_spark_fx" },
    { 0xFDCDFF00, "_escort" },
    { 0x7741A32B, "_escort_drone" },
    { 0x7D656B43, "_events" },
    { 0xCDF9B22C, "_exclusive_area" },
    { 0x9C19ADAA, "_explodable_target" },
    { 0x5FA3A765, "_explodable_targets" },
    { 0xAFB6A616, "_explodable_volumes" },
    { 0x2BDA0A7F, "_explode" },
    { 0x51D5EF78, "_explode_near_target" },
    { 0xF27D39EF, "_exploder" },
    { 0x35D3D1D9, "_exploder_id" },
    { 0x42A5A890, "_exploder_ids" },
    { 0x39F8E7ED, "_exploderobot" },
    { 0xB74AA20C, "_explosion_barrage_delay" },
    { 0xC2950023, "_explosion_barrage_max_delay" },
    { 0x2DE17E41, "_explosion_barrage_min_delay" },
    { 0x91FB3CFF, "_explosion_blast_radius" },
    { 0xE86282C5, "_explosion_delay" },
    { 0xA6917AA6, "_explosion_dust_name" },
    { 0x48293BC2, "_explosion_dust_range" },
    { 0xF45D41CC, "_explosion_fquakepower" },
    { 0x7C0D6C83, "_explosion_iblastradius" },
    { 0xA7A9B0AC, "_explosion_idamagemax" },
    { 0xE50DBBC2, "_explosion_idamagemin" },
    { 0xDF80B310, "_explosion_imaxrange" },
    { 0x81637056, "_explosion_iminrange" },
    { 0x17C0036E, "_explosion_iquakeradius" },
    { 0x4005BEDF, "_explosion_iquaketime" },
    { 0x5439D33B, "_explosion_last_incoming" },
    { 0x35ACAA8C, "_explosion_last_sound" },
    { 0x65C1EB64, "_explosion_launch_choke" },
    { 0x19B5A9CE, "_explosion_max_damage" },
    { 0x3549CD4E, "_explosion_max_delay" },
    { 0x6059B350, "_explosion_max_range" },
    { 0x716FCD64, "_explosion_min_damage" },
    { 0x5DF7527C, "_explosion_min_delay" },
    { 0x6FF2A72A, "_explosion_min_range" },
    { 0xA8B0EDE1, "_explosion_quake_power" },
    { 0xEDA7A6B8, "_explosion_quake_radius" },
    { 0xDEAA8C71, "_explosion_quake_time" },
    { 0x86A99E48, "_explosion_start_notify" },
    { 0x077A86D1, "_explosion_stop_barrage" },
    { 0xC3AEC79B, "_explosion_stopnotify" },
    { 0xF7050BBE, "_explosion_view_chance" },
    { 0x4AFD5E17, "_explosition_launch_choke" },
    { 0x3532F4B7, "_explosive_barrels" },
    { 0x3D2DE961, "_explosive_bolt" },
    { 0xCCAC066B, "_explosive_dart" },
    { 0x39AA63E2, "_extra" },
    { 0x42AFEA9B, "_extra_cam_active" },
    { 0xA587209E, "_extracam_replacement" },
    { 0xBF10A952, "_eyearray" },
    { 0x8CB6D100, "_eyeglow_fx_override" },
    { 0xC7DF3EB0, "_eyeglow_tag_override" },
    { 0x4AF89B06, "_f35" },
    { 0xCAE1DD46, "_f35_collision_feedback_watcher" },
    { 0x81AEAFE3, "_f35_collision_magnitude_test" },
    { 0x0EB279C1, "_f35_conventional_flight_mode_throttle" },
    { 0x1C9F75FD, "_f35_flying_upwards" },
    { 0x7B0FF651, "_f35_set_conventional_flight_mode" },
    { 0x3BF13454, "_f35_set_vtol_fast_mode" },
    { 0xB662A399, "_f35_set_vtol_mode" },
    { 0x14930874, "_f35_set_vtol_mode_v2" },
    { 0x24FED4FE, "_f35_should_be_flying" },
    { 0xB9DCADC5, "_f35_stop_from_collision" },
    { 0x058B2BC8, "_face_generichuman" },
    { 0xE9CA1ECA, "_face_utility" },
    { 0x42FC462A, "_face_utility_mp" },
    { 0x9669B2ED, "_faceanimcbfunc" },
    { 0x3E67A9CB, "_facecbfunc_generichuman" },
    { 0xC586EF20, "_fake_createfx_struct" },
    { 0xBD894397, "_fake_meat" },
    { 0x3B51A04E, "_fake_meats" },
    { 0x47F07922, "_fall_down_anchor" },
    { 0xE9103C6E, "_fall_inc" },
    { 0x756F1082, "_fall_speed_down" },
    { 0xE9DDAC82, "_fall_speed_left_right" },
    { 0x1C9D6019, "_fall_speed_up" },
    { 0x7719A128, "_fall_z" },
    { 0xADB5D823, "_far" },
    { 0xE2719F4C, "_ffotd_mmddyy_ver" },
    { 0xDC4373F9, "_fight_get_to_my_node" },
    { 0x153D7247, "_fight_node_cooldown" },
    { 0x0F31B24F, "_fight_think" },
    { 0x84D32C8B, "_fight_think_debug" },
    { 0x1FC6154F, "_fight_vignette" },
    { 0x3BBD1176, "_fight_vignette_think" },
    { 0x31692B1F, "_filename" },
    { 0xE75526C6, "_filter" },
    { 0x6009C106, "_filter_classname" },
    { 0x6ABCB5E3, "_filter_dead" },
    { 0x1A9805BF, "_filter_undefined" },
    { 0x5DAE2913, "_find_chunk" },
    { 0x64E243ED, "_find_ents_to_flush" },
    { 0xE624C64D, "_find_float_angles_offset" },
    { 0x6B628702, "_findclosest" },
    { 0xFC54390F, "_finish_player" },
    { 0x924F213C, "_fire" },
    { 0x48029160, "_fire_before_goal" },
    { 0xDF38B56E, "_fire_control" },
    { 0xD01A08F2, "_fire_direction" },
    { 0xA1E02027, "_fire_direction_cleanup" },
    { 0x488550B7, "_fire_direction_disable" },
    { 0x1DAD16EC, "_fire_direction_enable" },
    { 0x07F61BC1, "_fire_direction_kill" },
    { 0xD141F643, "_fire_direction_remove_hint" },
    { 0x499B6FA7, "_fire_direction_remove_weapons" },
    { 0x8B3ADF78, "_fire_direction_shooter_death" },
    { 0x1EE8EC6D, "_fire_direction_targeted" },
    { 0xBEA0ADFD, "_fire_noplayer" },
    { 0x6BB7A89A, "_fire_ordered_notitifes" },
    { 0xA9460E07, "_fire_outro_magic_bullet_at_bridge" },
    { 0xCAA1EC16, "_fire_rod" },
    { 0x0D396E2C, "_fire_stun_zombie_internal" },
    { 0x8FE1DF99, "_fire_turret" },
    { 0x53A43BE8, "_fire_turret_at_targets_untill_dead" },
    { 0x9EC60867, "_fire_turret_for_time" },
    { 0xB61CDBBB, "_fireball_do_damage" },
    { 0x0C7765E5, "_fireball_drop" },
    { 0x54FEEA3B, "_first_airstrike_called" },
    { 0xEE67B470, "_first_frame_anim" },
    { 0xF1BD5161, "_first_frame_exert_id_recieved" },
    { 0xC6143DA4, "_first_person_claw_flamethrower_fire_watch" },
    { 0xFEC05DF1, "_first_wave_through_smoke_guys" },
    { 0x72559466, "_flag" },
    { 0xC7E09D15, "_flag_wait_then_func" },
    { 0x90F23DC7, "_flag_wait_trigger" },
    { 0xDC8E7B99, "_flags" },
    { 0x5FE640CA, "_flak88" },
    { 0x73864AED, "_flak_drone" },
    { 0xBB68ED8B, "_flakignoretanks" },
    { 0x520D6B2C, "_flakvierling" },
    { 0xD4C214BF, "_flamed" },
    { 0x22A25201, "_flamethrower_plight" },
    { 0x6951701C, "_flare" },
    { 0x222B5266, "_flare_frame" },
    { 0xCD4D83DF, "_flare_monitor" },
    { 0x92DD4428, "_flareweapon" },
    { 0x06C2F21B, "_flashgrenades" },
    { 0xAA8C37E7, "_flush_compare_func" },
    { 0x8A8C62C2, "_flyover_audio" },
    { 0xD6051A2B, "_flyover_audio_radius" },
    { 0x368E2577, "_flyover_audio_table" },
    { 0xCD058286, "_flyover_audio_time" },
    { 0xAF88FF92, "_fog_settings_default" },
    { 0x8FDFD0D9, "_fog_settings_default_priority" },
    { 0xD7806689, "_fog_settings_lander" },
    { 0x5C490DE4, "_fog_settings_lander_priority" },
    { 0x42FF24E0, "_fog_settings_monkey" },
    { 0x895FBC43, "_fog_settings_monkey_priority" },
    { 0x44F5172D, "_foliage_cover" },
    { 0xD787BB82, "_foliage_risers" },
    { 0x2D161332, "_footstep" },
    { 0x725D6FF6, "_footstepcbfuncs" },
    { 0xF9C227E1, "_footstepoverrideeffect" },
    { 0xA59616BD, "_footsteps" },
    { 0x9D50AD8D, "_force_goal" },
    { 0xF7830A77, "_forcechoke" },
    { 0x39BC2D65, "_forced_target_ent_array" },
    { 0xC834AB0B, "_forest" },
    { 0x2F0A13B2, "_forfeited" },
    { 0xED378FE3, "_fountain_transporter" },
    { 0x4ED9064E, "_freq" },
    { 0x2947343A, "_friendicons" },
    { 0x9987E8E1, "_friendlyfire" },
    { 0x32F58AD8, "_frogger_fx_play_on_object" },
    { 0x49486970, "_from_nml" },
    { 0xD525E255, "_front" },
    { 0x24FE60C8, "_ft_pilot_light" },
    { 0x6210E287, "_ft_pilot_on" },
    { 0x2C93C547, "_full_screen_static" },
    { 0xA8159FC3, "_func_humangun_check" },
    { 0x443967D2, "_func_on_notify" },
    { 0x4388F392, "_fuse_acquired" },
    { 0x76903D98, "_fv2vs_default_trans_in" },
    { 0xBC3B1EB4, "_fv2vs_default_visionset" },
    { 0xEEBBF139, "_fv2vs_force_instant_transition" },
    { 0x72316885, "_fv2vs_infos" },
    { 0x9533CB5F, "_fv2vs_inited" },
    { 0x0AE6D477, "_fv2vs_prev_visionsets" },
    { 0x3CDF4091, "_fv2vs_suffix" },
    { 0xCA9A6D4C, "_fv2vs_unset_visionset" },
    { 0x0710710A, "_fx" },
    { 0x56B1BC3F, "_fx_wait_set" },
    { 0x8F5B99F5, "_fxanim" },
    { 0x4366471E, "_fxanim_add_attached_model" },
    { 0x628A02DD, "_fxanim_animate" },
    { 0xCDC7DFB4, "_fxanim_can_attach_model" },
    { 0x85437608, "_fxanim_change_anim" },
    { 0x8431CA43, "_fxanim_check_cheap_entity_flag" },
    { 0x6E880DF2, "_fxanim_copy_kvps" },
    { 0x96A44000, "_fxanim_get_anim_count" },
    { 0xB4BC5EE1, "_fxanim_get_parent_model_name" },
    { 0xFEBB3F83, "_fxanim_get_parent_object" },
    { 0x812A1769, "_fxanim_get_scene_name" },
    { 0x999E6D28, "_fxanim_hide" },
    { 0xCB0F67AF, "_fxanim_hide_tag_modifier" },
    { 0x8A3F0A57, "_fxanim_is_anim_looping" },
    { 0x7A31C119, "_fxanim_link_child_model" },
    { 0x412EF4B2, "_fxanim_model_link" },
    { 0xD45FB433, "_fxanim_modifier" },
    { 0x3148CA04, "_fxanim_parents_initialized" },
    { 0xF4B869EE, "_fxanim_play_anim_sequence" },
    { 0xEA6FFFDB, "_fxanim_play_fx" },
    { 0x16DC0812, "_fxanim_prep_if_looping" },
    { 0x4702ACDA, "_fxanim_setup_parent" },
    { 0x893D4C90, "_fxanim_think" },
    { 0x434B41AB, "_fxanim_wait" },
    { 0xC396DE49, "_fxanim_wait_for_anim_to_end" },
    { 0x897C340C, "_gadget_active_camo" },
    { 0x53AA1388, "_gadget_armor" },
    { 0x5F5848A3, "_gadget_armor_slot" },
    { 0x6B474702, "_gadget_armor_state" },
    { 0xF3BAD013, "_gadget_armor_weapon" },
    { 0x30401485, "_gadget_cacophany" },
    { 0x411F3E3F, "_gadget_camo" },
    { 0x5646AD69, "_gadget_camo_oldignoreme" },
    { 0xF0278666, "_gadget_camo_render" },
    { 0x3BEA8B4A, "_gadget_camo_reveal_status" },
    { 0x6B73D11E, "_gadget_cleanse" },
    { 0xB3CF5DF2, "_gadget_clone" },
    { 0xD9D5F65D, "_gadget_clone_render" },
    { 0xA9B52691, "_gadget_combat_efficiency" },
    { 0x0F810B35, "_gadget_combat_efficiency_success" },
    { 0x618F1205, "_gadget_concussive_wave" },
    { 0xF2401394, "_gadget_es_strike" },
    { 0x32DDFACB, "_gadget_exo_breakdown" },
    { 0xEA627BD3, "_gadget_firefly_swarm" },
    { 0xF040981E, "_gadget_flashback" },
    { 0x5FCEFDEF, "_gadget_forced_malfunction" },
    { 0x13773ACE, "_gadget_has_hacker" },
    { 0x7BF8FA03, "_gadget_has_shield" },
    { 0xA31481E3, "_gadget_heat_wave" },
    { 0x9470BBAA, "_gadget_hero_weapon" },
    { 0x20D60703, "_gadget_iff_override" },
    { 0x10AB61BA, "_gadget_immolation" },
    { 0xC9E3B6B7, "_gadget_is_hacking" },
    { 0xDE31E0B7, "_gadget_misdirection" },
    { 0xE73AD280, "_gadget_mrpukey" },
    { 0x3ABF9297, "_gadget_multirocket_flicker_timeout" },
    { 0x95F8D803, "_gadget_other" },
    { 0x0509B4EB, "_gadget_overdrive" },
    { 0x1095539C, "_gadget_rapid_strike" },
    { 0x33ED1C33, "_gadget_ravage_core" },
    { 0x755D6E1C, "_gadget_resurrect" },
    { 0x304BCDD7, "_gadget_roulette" },
    { 0x5846E657, "_gadget_security_breach" },
    { 0xA0549DB3, "_gadget_sensory_overload" },
    { 0xE965786F, "_gadget_servo_shortout" },
    { 0xE4808642, "_gadget_shield_snd_ent" },
    { 0xEB45CC76, "_gadget_shock_field" },
    { 0x93EED24A, "_gadget_smokescreen" },
    { 0x8DC900D7, "_gadget_speed_burst" },
    { 0x6880F16F, "_gadget_surge" },
    { 0x07E9069D, "_gadget_system_overload" },
    { 0xD2CE11CD, "_gadget_thief" },
    { 0x11C3C67A, "_gadget_unstoppable_force" },
    { 0x7B9F2AA5, "_gadget_vision_pulse" },
    { 0xCAA80C84, "_gadgets_level" },
    { 0x9ED137F5, "_gadgets_player" },
    { 0x3A9DA0AA, "_game_mode_location" },
    { 0x8317FADE, "_game_mode_mode" },
    { 0xD84B255B, "_game_mode_powerup_zombie_grab" },
    { 0xA0610262, "_game_mode_spawned_objects" },
    { 0xDC487A28, "_game_mode_start_classic" },
    { 0x51B9F8F2, "_game_mode_start_turned" },
    { 0x220ACBDF, "_game_module_custom_spawn_init_func" },
    { 0xD74F517D, "_game_module_game_end_check" },
    { 0x32E927C1, "_game_module_player_damage_callback" },
    { 0x93F36481, "_game_module_player_damage_grief_callback" },
    { 0xC7048FC8, "_game_module_player_laststand_callback" },
    { 0x4D28B18C, "_game_module_point_adjustment" },
    { 0xB43DE6C7, "_game_module_stat_update_func" },
    { 0x7765DEEE, "_game_module_state_update_func" },
    { 0xB04F0280, "_game_modules" },
    { 0x1862D8F5, "_gameadvertisement" },
    { 0xDD2AAFDB, "_gamemode" },
    { 0xA0F569D0, "_gamemode_initcallbacks" },
    { 0x8ABBC4A7, "_gamemode_norandomdogs" },
    { 0x7D0CE6ED, "_gamemode_playerconnect" },
    { 0x59F3FABD, "_gamemode_precache" },
    { 0xF1AE2D0B, "_gameobject" },
    { 0xC6AA566A, "_gameobjects" },
    { 0x45728827, "_gamerep" },
    { 0x39569CE9, "_gameskill" },
    { 0xEF425510, "_gametype_default" },
    { 0xBB070513, "_gametype_variants" },
    { 0x294C6873, "_gas_fire_watcher" },
    { 0x43716185, "_gas_grenade_think" },
    { 0x31395873, "_gasmask" },
    { 0x157366BD, "_gasmask_button_pressed" },
    { 0x961FF315, "_gasmask_off" },
    { 0x58EF87ED, "_gasmask_on_cracked_1" },
    { 0x7EF20256, "_gasmask_on_cracked_2" },
    { 0xA4F47CBF, "_gasmask_on_cracked_3" },
    { 0xAFB486A4, "_gasmask_on_pristine" },
    { 0xDFB062B4, "_gasmask_stop_watching_buttons" },
    { 0x338404B4, "_gates" },
    { 0x76789E00, "_generated_current_weapon" },
    { 0xDFD8C1E1, "_generated_weapons" },
    { 0xADF865E7, "_generic" },
    { 0x68A75F8D, "_generic_questions" },
    { 0xBC43B8B8, "_gentle_shake" },
    { 0xE81E5DA0, "_geometry" },
    { 0xFD457564, "_get_aim_model" },
    { 0x274969E4, "_get_aim_position" },
    { 0x3D1DDF13, "_get_aim_postion" },
    { 0xBDD3D4AC, "_get_align_ent" },
    { 0x847086AC, "_get_align_object" },
    { 0x910A9E45, "_get_align_pos" },
    { 0x65B9E46C, "_get_all_super_kill_actors" },
    { 0x39C73F69, "_get_animname_for_notetrack" },
    { 0xD163AEFD, "_get_any_priority_targets" },
    { 0xDABA0699, "_get_avenger_death_model_2x_array" },
    { 0x3D2E53F0, "_get_avenger_death_model_array" },
    { 0xF577C4F0, "_get_avenger_death_model_fx_tag_array" },
    { 0xB6E8A5D9, "_get_avenger_death_model_tag_array" },
    { 0x6D7E20DA, "_get_beam" },
    { 0x62C932A1, "_get_best_frogger_pain_anim" },
    { 0xB6ECA136, "_get_best_target_bullet" },
    { 0x0091EF09, "_get_best_target_from_potential" },
    { 0x40D1F6F5, "_get_best_target_gas" },
    { 0xD0F7A33C, "_get_best_target_grenade" },
    { 0x2276A7B7, "_get_best_target_projectile" },
    { 0x01870AF4, "_get_best_target_quadtank_side_turret" },
    { 0x2AD74A3A, "_get_burst_fire_time" },
    { 0xD07B64F7, "_get_burst_wait_time" },
    { 0x05D73924, "_get_closest_ammo_trigger" },
    { 0x6D3A0A5A, "_get_closest_unit_to_fire" },
    { 0x40BA441A, "_get_custom_wait" },
    { 0x13389C54, "_get_default_target_offset" },
    { 0x114F394A, "_get_disease_meter_fraction" },
    { 0x93B9AFC0, "_get_f35_death_model_array" },
    { 0x37E58C20, "_get_f35_death_model_fx_tag_array" },
    { 0x7990DEE9, "_get_f35_death_model_tag_array" },
    { 0x330ED718, "_get_fake_target" },
    { 0x8ADB1AA6, "_get_fight_node" },
    { 0xA028FDC7, "_get_friendly_array_anthem_approach" },
    { 0x8E89F417, "_get_friendly_array_market" },
    { 0xD3B57680, "_get_frogger_movement_direction_angles" },
    { 0xEA9D69CE, "_get_from_weapon" },
    { 0xD925B1EF, "_get_game_module_players" },
    { 0x8CDB70C5, "_get_gunner_tag_for_turret_index" },
    { 0x44E033A3, "_get_high_rage_settings" },
    { 0x0A8455B7, "_get_horse_push_strength" },
    { 0x0D5933CF, "_get_low_rage_settings" },
    { 0x500494EC, "_get_models_from_radiant" },
    { 0x3A46CA2F, "_get_models_from_radiant_internals" },
    { 0xD5D87C4A, "_get_non_visible_barriers" },
    { 0x64CB842C, "_get_non_visible_spawn_point" },
    { 0xDD4F5C68, "_get_number_of_steps" },
    { 0xDA0B7F0F, "_get_pegasus_death_model_2x_array" },
    { 0xCDDB0612, "_get_pegasus_death_model_array" },
    { 0x91E891B6, "_get_pegasus_death_model_fx_tag_array" },
    { 0xC7732A3B, "_get_pegasus_death_model_tag_array" },
    { 0x7DAC1E54, "_get_player_look_position" },
    { 0x5798A268, "_get_potential_targets" },
    { 0xF7D7806E, "_get_random_element_player_can_see" },
    { 0xF8D0B8AE, "_get_random_element_player_cant_see" },
    { 0x205D9CFD, "_get_random_encounter_func" },
    { 0x327CCAE5, "_get_scene_name_for_notetrack" },
    { 0x8A5DFE09, "_get_spawner" },
    { 0x12D810B4, "_get_spawnpoint_array" },
    { 0x73E59307, "_get_special_spawn_point" },
    { 0x83BF534A, "_get_target_position" },
    { 0xF06EBB3D, "_get_time_bomb_round_type" },
    { 0xA8912F6A, "_get_time_bomb_zombie_spawn_location" },
    { 0xEA0BFF67, "_get_timescale_kill_slow" },
    { 0x1EBB50BC, "_get_turret_data" },
    { 0x69CED6D1, "_get_turret_index_for_tag" },
    { 0xE61157E3, "_get_type_count" },
    { 0xF16CC9EA, "_get_user_target" },
    { 0x8AAC802C, "_get_valid_targets" },
    { 0xEEC899E8, "_get_wait_time" },
    { 0x9DC9F38F, "_get_zombie_exit_point" },
    { 0x2EB65475, "_getadjusttocoverrotation" },
    { 0x5528D813, "_getbusattackposition" },
    { 0x23F5C009, "_getconnectedzonenames" },
    { 0x8FF0FB6B, "_geteye" },
    { 0x0116161C, "_getgibbedlegmodel" },
    { 0x8CA0B4C2, "_getgibbedstate" },
    { 0x8AACCA23, "_getgibbedtorsomodel" },
    { 0xE2149F4F, "_getgibdef" },
    { 0xDF5AE433, "_getgibextramodel" },
    { 0x77758DE3, "_getnumplayersclinging" },
    { 0xFDEBEDFA, "_getphalanxpositions" },
    { 0x526F738A, "_getphalanxspawner" },
    { 0xACC5DA4B, "_getplayerscore" },
    { 0xE5529287, "_getsideofbusopeningison" },
    { 0x74DCCA4F, "_getstrikepathstartandend" },
    { 0x1DCC90B7, "_getteamscore" },
    { 0x58108BC6, "_gib" },
    { 0xBE2B2162, "_gib_def" },
    { 0x91196B04, "_gib_overload_func" },
    { 0x7B0C734E, "_gib_vel" },
    { 0xB648F837, "_gibbing_actor_models" },
    { 0x2EB49C4F, "_gibcallback" },
    { 0xDADD9716, "_gibcallbacks" },
    { 0xC218C7B1, "_gibcliententityinternal" },
    { 0xBC754C68, "_gibclientextrainternal" },
    { 0xB06A42B3, "_gibentity" },
    { 0xC7CDC42C, "_gibentityinternal" },
    { 0x018ED107, "_gibeventcbfunc" },
    { 0x4E5FC280, "_gibextra" },
    { 0x1E1CFCF3, "_gibextrainternal" },
    { 0xBDB8D7BE, "_gibhandler" },
    { 0x4F4550A4, "_gibpiece" },
    { 0x99660E6C, "_gibpiecetag" },
    { 0x35CD9201, "_give_back_weapons" },
    { 0x0FE874E7, "_give_player_rocket_launcher" },
    { 0x3EB97C14, "_give_player_sniper_weapon" },
    { 0x0BDC649D, "_give_revive_points" },
    { 0x5A8FC52F, "_given" },
    { 0x34409A81, "_giveplayerkillstreakinternal" },
    { 0x4225C54C, "_glaive" },
    { 0x7D75BFBB, "_glaive_ignoreme" },
    { 0x4DFC2454, "_glaive_linktotag" },
    { 0x789824EB, "_glaive_must_return_to_owner" },
    { 0x7CC7E526, "_glaive_settings_lifetime" },
    { 0x7DFE4A93, "_glass_info" },
    { 0x60438928, "_glasses" },
    { 0x5F203C72, "_global_fx" },
    { 0x46C3E883, "_global_fx_ents" },
    { 0xEF733461, "_globallogic" },
    { 0x88FE9DFF, "_globallogic_actor" },
    { 0x65603842, "_globallogic_audio" },
    { 0xE37E6582, "_globallogic_defaults" },
    { 0x360FE173, "_globallogic_player" },
    { 0x737B8F82, "_globallogic_score" },
    { 0xD04F4AF9, "_globallogic_spawn" },
    { 0x9D6A8902, "_globallogic_ui" },
    { 0xC28E467B, "_globallogic_utils" },
    { 0x6F015CFC, "_globallogic_vehicle" },
    { 0x06F95003, "_glow" },
    { 0x7672CBA8, "_goal_center_point" },
    { 0x67A3275D, "_goal_offset" },
    { 0x11A61C30, "_god_rod" },
    { 0xB1F9C3DA, "_god_rod_allow_hint" },
    { 0x99740721, "_god_rod_cleanup" },
    { 0x3238B931, "_god_rod_disable" },
    { 0xE50A7DF2, "_god_rod_enable" },
    { 0xF3212043, "_god_rod_kill" },
    { 0x3D4D61EF, "_god_rod_remove" },
    { 0x5CBBE1E1, "_god_rod_remove_hint" },
    { 0x18E7E4FD, "_going_prone" },
    { 0x94BBB988, "_goliath" },
    { 0x18A00BE6, "_gong_watcher_running" },
    { 0xBBBC422E, "_grab_minigun" },
    { 0x120F4737, "_grab_powerup" },
    { 0x0B59F32C, "_gravity_spikes" },
    { 0x25164804, "_grenade_toss" },
    { 0x411110E5, "_grief_reset_message" },
    { 0xD25C601C, "_ground_targets_end" },
    { 0xA0662C6D, "_ground_targets_failure" },
    { 0x36A3578E, "_ground_targets_success" },
    { 0x3FA40C09, "_group" },
    { 0x3F2B935B, "_guard_points" },
    { 0x8DD17CEE, "_guardposition" },
    { 0x75ADA1D9, "_gump_functions" },
    { 0xD593309D, "_gunner_time_of_death_window" },
    { 0x22226253, "_guy_array" },
    { 0xC67082D4, "_guys_rappeled" },
    { 0x7817DBEB, "_gv_actions" },
    { 0x67F708A8, "_hack_callback_func" },
    { 0xE9EC1678, "_hack_perks_override" },
    { 0x73DFC737, "_hack_qualifier_func" },
    { 0xE2E32B2E, "_hack_screen_message" },
    { 0xC919FDCA, "_hackable_objects" },
    { 0x4567DFBA, "_hacked_callback" },
    { 0xEA3A2497, "_hacker_pool" },
    { 0x826A0C5C, "_hacker_pooled" },
    { 0x0B656803, "_hacker_tool" },
    { 0x14B13709, "_had_legs" },
    { 0xD6C9D3B0, "_halftrack" },
    { 0xA4B435E6, "_hallway" },
    { 0x5DFC4EA1, "_haltadvance" },
    { 0xE222BF3D, "_haltfire" },
    { 0x74EEC247, "_handle_find_flesh" },
    { 0xADA3FC72, "_handle_shader" },
    { 0xA894115D, "_handle_zombie_stink" },
    { 0xCB14462B, "_handlegibannihilate" },
    { 0xC2C1BA4C, "_handlegibcallbacks" },
    { 0x9E5707F2, "_handlegibhead" },
    { 0xA610129F, "_handlegibleftarm" },
    { 0x1B479C25, "_handlegibleftleg" },
    { 0xD51C6B90, "_handlegibrightarm" },
    { 0x6A83E90E, "_handlegibrightleg" },
    { 0x4AA21FC1, "_hangar" },
    { 0x242D455A, "_hardpoints" },
    { 0xA504A5A3, "_harper_fires_at_targets" },
    { 0x054680CA, "_has_anti115" },
    { 0xE8BE7A79, "_has_device" },
    { 0xD1C274EB, "_has_different_generic_anims" },
    { 0xF0F58F0B, "_has_init_state" },
    { 0x459A83F3, "_has_log" },
    { 0x388BA7A6, "_has_meat" },
    { 0x24408E3C, "_has_meat_hud" },
    { 0x8A4498BB, "_has_nearby_player_enemy" },
    { 0xDBA852EB, "_has_reel" },
    { 0x5D0D3544, "_has_target_flags" },
    { 0xDE56B798, "_has_wire" },
    { 0xD1B23D23, "_hasgibdef" },
    { 0xF9F1BB6F, "_hasgibpieces" },
    { 0xC7A7B414, "_hasperk" },
    { 0xDF43CDD4, "_hasweapon" },
    { 0x7A4F6882, "_health" },
    { 0x90F9D92B, "_health_overlay" },
    { 0x1442540E, "_health_queue" },
    { 0xE043B075, "_health_queue_max" },
    { 0x1A841747, "_health_queue_num" },
    { 0x1FED63FA, "_healthoverlay" },
    { 0x87DDF012, "_heat_wave_damaged_time" },
    { 0x80628960, "_heat_wave_stuned_end" },
    { 0xD79F18F6, "_heat_wave_stunned_by" },
    { 0x79C7C546, "_heatseekingmissile" },
    { 0x4CD81554, "_height_dist" },
    { 0xCADA8068, "_heli" },
    { 0x712E034C, "_heli_crash_sanity_check" },
    { 0x32EF3335, "_heli_pilot_ent" },
    { 0xE470DB9B, "_helicopter" },
    { 0xC0E68700, "_helicopter_ai" },
    { 0x71A5388E, "_helicopter_globals" },
    { 0xEDC53461, "_helicopter_guard" },
    { 0x3086DAA7, "_helicopter_gunner" },
    { 0xAE68C2F1, "_helicopter_player" },
    { 0x623206BA, "_helicopter_sounds" },
    { 0x795DF34D, "_hero_catch_up_teleport_" },
    { 0xE1CAC31A, "_hero_weapons" },
    { 0x4D5B3B7C, "_hidden" },
    { 0x91589476, "_hide_hud_count" },
    { 0xD3BC1C9F, "_hidepart" },
    { 0xC24D5ECC, "_hiding_door" },
    { 0xED0ED40B, "_hiding_model" },
    { 0x213B9515, "_high_value_targets" },
    { 0x55B0297B, "_high_value_targets_killed" },
    { 0x27A4DE9B, "_hind" },
    { 0x427BB3F1, "_hind_player" },
    { 0x75B18D43, "_hint_height" },
    { 0xBD4FB8EF, "_hint_print" },
    { 0x5F1A1049, "_hint_print_wait" },
    { 0x5F32CC2B, "_hint_text" },
    { 0xA0C699EF, "_hint_text_timeout" },
    { 0x5126F45B, "_hip" },
    { 0x7B78CE7E, "_hit_already" },
    { 0xDC07C05D, "_hive_gun" },
    { 0x9C5D35C6, "_hm_should_pause_spawning" },
    { 0xA8D61110, "_holding_button" },
    { 0x77E8AC4F, "_horse" },
    { 0x21E349A5, "_horse_player" },
    { 0xBA2CE22C, "_horse_ride" },
    { 0xAD23F3C6, "_horse_rider" },
    { 0xDCC318FD, "_horse_rider_get_anim_speed" },
    { 0x9A4C58E8, "_host_migration_link_entity" },
    { 0x27E0C8D1, "_host_migration_link_helper" },
    { 0x56DDD356, "_hostmigration" },
    { 0x79E1B33B, "_hud" },
    { 0xCEB175BC, "_hud_dvars" },
    { 0xD9F8106F, "_hud_elem" },
    { 0x7EEF1A9B, "_hud_message" },
    { 0xDBC53D82, "_hud_util" },
    { 0x405EB4E9, "_hud_weapons" },
    { 0x498126F1, "_hudson_int_anim" },
    { 0x50F3B3F7, "_huey" },
    { 0x612108AD, "_huey_player" },
    { 0x9AC2457A, "_humangun_escape_override" },
    { 0xC74DCAB2, "_humvee" },
    { 0xCF8A985A, "_hunter" },
    { 0x180EE7B2, "_icicle_get_spread" },
    { 0x14E3BEBA, "_icicle_locate_target" },
    { 0x8DE92A4E, "_ied" },
    { 0x58DEE866, "_ignore" },
    { 0x31617797, "_ignore_player_handler" },
    { 0x3620CA05, "_ignoreunattackableenemy" },
    { 0xBB8958A7, "_in_cave" },
    { 0x850A0653, "_in_cloud" },
    { 0x633F2E46, "_in_coast_water" },
    { 0xE7418723, "_in_eclipse" },
    { 0x0412B077, "_in_geo" },
    { 0x0D31201D, "_inbound_east" },
    { 0x2EE109D3, "_inbound_front" },
    { 0x6E378439, "_inbound_left" },
    { 0x26668363, "_inbound_north" },
    { 0x5B34825C, "_inbound_rear" },
    { 0x413AC464, "_inbound_right" },
    { 0x2789B971, "_inbound_south" },
    { 0x280DAC1F, "_inbound_west" },
    { 0xEB117BAA, "_incendiary" },
    { 0x7059582D, "_included_equipment" },
    { 0x8368A92A, "_included_weapons" },
    { 0x01D72FF4, "_incomingmissile" },
    { 0xA8BD8510, "_incomingmissiletracker" },
    { 0x43AD9E0C, "_increment_plane_count" },
    { 0x12D22264, "_index" },
    { 0x79E5D411, "_ingamemenus" },
    { 0x884BE5A5, "_init_aerial_vehicles" },
    { 0x5B6B0CEC, "_init_animations" },
    { 0x6FF67CA7, "_init_cougar_turret" },
    { 0x52A1C352, "_init_debug_zones" },
    { 0x8C835A17, "_init_drone_spotlight_detection_parameters" },
    { 0x333C1734, "_init_fighter" },
    { 0x811BA2BA, "_init_husk" },
    { 0x09A2369F, "_init_indicators" },
    { 0x31558CCC, "_init_instance" },
    { 0x204811F8, "_init_magic_box" },
    { 0x041591CA, "_init_misc_turret" },
    { 0xFF327069, "_init_pap_indicators" },
    { 0x2462B329, "_init_pap_spinners" },
    { 0xCE794BFF, "_init_rider" },
    { 0x13BB7EB3, "_init_turret" },
    { 0x0864AD62, "_init_turrets" },
    { 0x60F7E160, "_init_vehicle_turret" },
    { 0x658B7B19, "_init_wounded" },
    { 0x36CB835A, "_init_wounded_anims" },
    { 0x4AA8FA4D, "_initializeblackboard" },
    { 0x81190B75, "_initializelevelinterface" },
    { 0x8B82ABEE, "_initializerobot" },
    { 0xC91B6004, "_initializesentient" },
    { 0xD5F22A43, "_input_both_triggers_pulled" },
    { 0xD8BC2B9F, "_input_button" },
    { 0xFDAFA2DA, "_input_left_trigger_pulled" },
    { 0xB1ECB4C9, "_input_stick" },
    { 0xD914AD26, "_insidecylinder" },
    { 0x07B9D38F, "_insidenoflyzonebyindex" },
    { 0x1DD21CDD, "_intelligence" },
    { 0xE0216D3D, "_interactive_objects" },
    { 0x6E151542, "_interface_match_type" },
    { 0xFE061460, "_interface_numeric_type" },
    { 0x6C0057D4, "_interface_vector_type" },
    { 0xE56002E0, "_interior" },
    { 0x4953A4C8, "_interior_elevator_connect_nodes" },
    { 0x13CEBECC, "_interior_elevator_disconnect_nodes" },
    { 0x99D54C70, "_intro_claw_fire_turret" },
    { 0xA71C5FB5, "_intro_claw_grenades_fire" },
    { 0xFCB2BC93, "_intro_claw_turret_control" },
    { 0x1F9624B0, "_intro_claw_turret_fire" },
    { 0x8C1AF5D4, "_intro_claw_turret_spin" },
    { 0x81BD2EE1, "_intro_extra_cam" },
    { 0xDD1D1904, "_intro_fake_gunshots" },
    { 0x3B01A02A, "_introscreen" },
    { 0x66734EFC, "_inventory" },
    { 0x72F8C2EC, "_invul_off" },
    { 0x82217596, "_invul_on" },
    { 0xC0069C2C, "_ir_strobe_logic" },
    { 0x0B502383, "_ir_strobe_queue" },
    { 0x6B8734AC, "_is_2h_rappel" },
    { 0xF9E7588F, "_is_a_charger" },
    { 0x01E9F63E, "_is_above_threshold" },
    { 0x57E40211, "_is_banned_refill_weapon" },
    { 0x0F227BDD, "_is_drinking" },
    { 0x0237284E, "_is_encounter" },
    { 0x6FCE3BE4, "_is_ent_actor" },
    { 0x68F42C3A, "_is_ent_player" },
    { 0x125FBDFF, "_is_ent_vehicle" },
    { 0x875DA84B, "_is_flickering" },
    { 0xE8CAE5FA, "_is_freefalling" },
    { 0x53E6BEDE, "_is_in_place" },
    { 0xE9CE51B2, "_is_moving_or_attacking" },
    { 0x8D282ACD, "_is_player_in_zombie_stink" },
    { 0x7F5C673D, "_is_point_above_ground" },
    { 0xC45165C7, "_is_pressing_brake_button" },
    { 0x72816636, "_is_pressing_rappel_button" },
    { 0x4135A1C4, "_is_primed" },
    { 0x6D6CF471, "_is_sprinting" },
    { 0xD44A2EE7, "_is_target_area_valid" },
    { 0xD50DA31C, "_is_target_within_range" },
    { 0x2E2A9356, "_is_traversing_over_barrier_from_outside_playable_space" },
    { 0x1F8F0D23, "_is_valid" },
    { 0x73E50955, "_is_valid_trigger_type" },
    { 0xF67AF34E, "_isalerting" },
    { 0xC0E95D8F, "_isclone" },
    { 0x5EB8A046, "_isdefaultplayergib" },
    { 0xB787BA08, "_isopeningdoor" },
    { 0x0B3C6B6E, "_isspeaking" },
    { 0x672E0D90, "_isvalidneighbor" },
    { 0x49592C39, "_isvalidplayer" },
    { 0x098D0CD1, "_isvalidrusher" },
    { 0x825DE41D, "_javelin" },
    { 0x3C62309A, "_jaw" },
    { 0xA3363AAC, "_jeep" },
    { 0x7A2F9AAB, "_jetpack_ai" },
    { 0xD4ABAC22, "_jetpack_ai_kill" },
    { 0x6C2373E5, "_jetpack_death_watch" },
    { 0xEF82DD9E, "_jetpack_deploy_chute" },
    { 0xE3FF44DD, "_jetpack_destroy" },
    { 0xDD34AFF4, "_jetpack_set_altitude" },
    { 0x268507C8, "_jetpack_set_grounded" },
    { 0x235BDB70, "_jetwing" },
    { 0xE4106635, "_jolie_greet_array" },
    { 0x1C4B6A9C, "_juggernaut" },
    { 0x3E12A527, "_jump_pad_activate_flag" },
    { 0xCB7E8B11, "_jump_pad_anim_change" },
    { 0x08C31F52, "_jump_pad_level_behavior" },
    { 0xAF95EE91, "_jump_pad_override" },
    { 0x1F557FE3, "_jump_pad_override_array" },
    { 0x9738BA68, "_jump_pad_poi_end_override" },
    { 0x0FB37135, "_jump_pad_poi_start_override" },
    { 0x56A5A173, "_jump_pad_velocity_override" },
    { 0xF74C6D4F, "_jumpto" },
    { 0xEFD24740, "_k10" },
    { 0xE87D1D70, "_k100" },
    { 0xCD1CFDE0, "_k1000" },
    { 0x1921F2B2, "_k1002" },
    { 0x3F246D1B, "_k1003" },
    { 0x6526E784, "_k1004" },
    { 0xD72E56BF, "_k1007" },
    { 0xFD30D128, "_k1008" },
    { 0x23334B91, "_k1009" },
    { 0x0E7F97D9, "_k101" },
    { 0x4BB4640B, "_k1010" },
    { 0x25B1E9A2, "_k1011" },
    { 0xFFAF6F39, "_k1012" },
    { 0xD9ACF4D0, "_k1013" },
    { 0xBDBBD346, "_k1015" },
    { 0x71B6DE74, "_k1017" },
    { 0x7BC83753, "_k1018" },
    { 0x55C5BCEA, "_k1019" },
    { 0x34821242, "_k102" },
    { 0xCA4BCA36, "_k1020" },
    { 0xF04E449F, "_k1021" },
    { 0x7E46D564, "_k1022" },
    { 0xA4494FCD, "_k1023" },
    { 0x3241E092, "_k1024" },
    { 0x0C3F6629, "_k1027" },
    { 0xFA5F9D7E, "_k1028" },
    { 0x206217E7, "_k1029" },
    { 0x5A848CAB, "_k103" },
    { 0x241DEA78, "_k1031" },
    { 0x962559B3, "_k1032" },
    { 0xE22A4E85, "_k1034" },
    { 0xBC27D41C, "_k1035" },
    { 0x2E2F4357, "_k1036" },
    { 0x082CC8EE, "_k1037" },
    { 0x1A0C9199, "_k1038" },
    { 0xF40A1730, "_k1039" },
    { 0x80870714, "_k104" },
    { 0xC8B7CB0C, "_k1040" },
    { 0xEEBA4575, "_k1041" },
    { 0x14BCBFDE, "_k1042" },
    { 0x3ABF3A47, "_k1043" },
    { 0x30ADE168, "_k1044" },
    { 0xDF318A29, "_k10449" },
    { 0x56B05BD1, "_k1045" },
    { 0x7CB2D63A, "_k1046" },
    { 0xA2B550A3, "_k1047" },
    { 0x98A3F7C4, "_k1048" },
    { 0xA689817D, "_k105" },
    { 0x474F3137, "_k1050" },
    { 0x214CB6CE, "_k1051" },
    { 0xFB4A3C65, "_k1052" },
    { 0xD547C1FC, "_k1053" },
    { 0xAF454793, "_k1054" },
    { 0x8942CD2A, "_k1055" },
    { 0x634052C1, "_k1056" },
    { 0x3D3DD858, "_k1057" },
    { 0x173B5DEF, "_k1058" },
    { 0xCC8BFBE6, "_k106" },
    { 0x06D47EC2, "_k1060" },
    { 0x2CD6F92B, "_k1061" },
    { 0xBACF89F0, "_k1062" },
    { 0xE0D20459, "_k1063" },
    { 0x9EDE6866, "_k1064" },
    { 0xC4E0E2CF, "_k1065" },
    { 0x52D97394, "_k1066" },
    { 0x78DBEDFD, "_k1067" },
    { 0x5CEACC73, "_k1069" },
    { 0xF28E764F, "_k107" },
    { 0x856BE4ED, "_k1070" },
    { 0x5F696A84, "_k1071" },
    { 0xD170D9BF, "_k1072" },
    { 0xAB6E5F56, "_k1073" },
    { 0xED61FB49, "_k1074" },
    { 0xC75F80E0, "_k1075" },
    { 0x8F7D3DCC, "_k1079" },
    { 0x1890F0B8, "_k108" },
    { 0x2A05C581, "_k1081" },
    { 0x50083FEA, "_k1082" },
    { 0x760ABA53, "_k1083" },
    { 0x9C0D34BC, "_k1084" },
    { 0xE812298E, "_k1086" },
    { 0x0E14A3F7, "_k1087" },
    { 0xD3EF77D0, "_k1088" },
    { 0xF9F1F239, "_k1089" },
    { 0x3E936B21, "_k109" },
    { 0x829AB143, "_k1090" },
    { 0x5C9836DA, "_k1091" },
    { 0x3695BC71, "_k1092" },
    { 0x1AA49AE7, "_k1094" },
    { 0xF4A2207E, "_k1095" },
    { 0xCE9FA615, "_k1096" },
    { 0xA89D2BAC, "_k1097" },
    { 0x5286DDFB, "_k1098" },
    { 0x15D4C1A9, "_k11" },
    { 0x6714839B, "_k110" },
    { 0x4072D391, "_k1100" },
    { 0x1A705928, "_k1101" },
    { 0x8C77C863, "_k1102" },
    { 0x66754DFA, "_k1103" },
    { 0xD87CBD35, "_k1104" },
    { 0xFE7F379E, "_k1107" },
    { 0x105F0049, "_k1108" },
    { 0xEA5C85E0, "_k1109" },
    { 0x41120932, "_k111" },
    { 0xC1DB6D66, "_k1110" },
    { 0xE7DDE7CF, "_k1111" },
    { 0x9BD8F2FD, "_k1113" },
    { 0x29D183C2, "_k1114" },
    { 0x4FD3FE2B, "_k1115" },
    { 0xDDCC8EF0, "_k1116" },
    { 0x03CF0959, "_k1117" },
    { 0xF1EF40AE, "_k1118" },
    { 0x1B0F8EC9, "_k112" },
    { 0x1C045852, "_k1121" },
    { 0xF601DDE9, "_k1122" },
    { 0xCFFF6380, "_k1123" },
    { 0xDA10BC5F, "_k1124" },
    { 0xB40E41F6, "_k1125" },
    { 0x68094D24, "_k1127" },
    { 0x721AA603, "_k1128" },
    { 0x4C182B9A, "_k1129" },
    { 0xF50D1460, "_k113" },
    { 0xC36F6C90, "_k1130" },
    { 0xE971E6F9, "_k1131" },
    { 0x0F746162, "_k1132" },
    { 0x5B795634, "_k1134" },
    { 0x817BD09D, "_k1135" },
    { 0xCD80C56F, "_k1137" },
    { 0xF3833FD8, "_k1138" },
    { 0xFF1E6D3F, "_k114" },
    { 0x55BBD934, "_k1141" },
    { 0xC7C3486F, "_k1142" },
    { 0xA1C0CE06, "_k1143" },
    { 0xBDB1EF90, "_k1145" },
    { 0x2FB95ECB, "_k1146" },
    { 0x09B6E462, "_k1147" },
    { 0xABD226E5, "_k1148" },
    { 0xD91BF2D6, "_k115" },
    { 0x232967DB, "_k1151" },
    { 0xD7247309, "_k1153" },
    { 0xBB33517F, "_k1155" },
    { 0x6F2E5CAD, "_k1157" },
    { 0x2D3AC0BA, "_k1158" },
    { 0xB319786D, "_k116" },
    { 0x179F257E, "_k1161" },
    { 0xCB9A30AC, "_k1163" },
    { 0x7F953BDA, "_k1165" },
    { 0x5992C171, "_k1166" },
    { 0x33904708, "_k1167" },
    { 0x0D8DCC9F, "_k1168" },
    { 0x8D16FE04, "_k117" },
    { 0xBF0A39BC, "_k1170" },
    { 0xE50CB425, "_k1171" },
    { 0x0B0F2E8E, "_k1172" },
    { 0x27005018, "_k1174" },
    { 0x4D02CA81, "_k1175" },
    { 0x730544EA, "_k1176" },
    { 0x9907BF53, "_k1177" },
    { 0xB4F8E0DD, "_k1179" },
    { 0x4F13BD4D, "_k1184" },
    { 0x291142E4, "_k1185" },
    { 0x751637B6, "_k1187" },
    { 0xE71DA6F1, "_k1188" },
    { 0xC11B2C88, "_k1189" },
    { 0x7125DC7A, "_k119" },
    { 0xF8C1BA9E, "_k1190" },
    { 0xACBCC5CC, "_k1192" },
    { 0xD2BF4035, "_k1193" },
    { 0x86BA4B63, "_k1195" },
    { 0x14B2DC28, "_k1196" },
    { 0x3AB55691, "_k1197" },
    { 0xC8ADE756, "_k1198" },
    { 0xEEB061BF, "_k1199" },
    { 0xE5ABE9C6, "_k120" },
    { 0x197BD68B, "_k1201" },
    { 0xA7746750, "_k1202" },
    { 0xCD76E1B9, "_k1203" },
    { 0xB185C02F, "_k1205" },
    { 0x3F7E50F4, "_k1206" },
    { 0x238D2F6A, "_k1208" },
    { 0x0BAE642F, "_k121" },
    { 0x7210C24D, "_k1210" },
    { 0x4C0E47E4, "_k1211" },
    { 0xBE15B71F, "_k1212" },
    { 0x98133CB6, "_k1213" },
    { 0xDA06D8A9, "_k1214" },
    { 0x260BCD7B, "_k1216" },
    { 0x00095312, "_k1217" },
    { 0x99A6F4F4, "_k122" },
    { 0xB55CA86C, "_k1220" },
    { 0xDB5F22D5, "_k1221" },
    { 0x276417A7, "_k1223" },
    { 0x43553931, "_k1225" },
    { 0x8F5A2E03, "_k1227" },
    { 0x8548D524, "_k1228" },
    { 0xAB4B4F8D, "_k1229" },
    { 0xBFA96F5D, "_k123" },
    { 0x35314317, "_k1230" },
    { 0xE92C4E45, "_k1232" },
    { 0xC329D3DC, "_k1233" },
    { 0x9D275973, "_k1234" },
    { 0x7724DF0A, "_k1235" },
    { 0x512264A1, "_k1236" },
    { 0x2B1FEA38, "_k1237" },
    { 0x051D6FCF, "_k1238" },
    { 0x4DA20022, "_k124" },
    { 0xB82DDC16, "_k1240" },
    { 0xDE30567F, "_k1241" },
    { 0x6C28E744, "_k1242" },
    { 0x2023F272, "_k1244" },
    { 0x46266CDB, "_k1245" },
    { 0xD41EFDA0, "_k1246" },
    { 0xFA217809, "_k1247" },
    { 0x73A47A8B, "_k125" },
    { 0x36C54241, "_k1250" },
    { 0x10C2C7D8, "_k1251" },
    { 0x5CC7BCAA, "_k1253" },
    { 0xA8CCB17C, "_k1255" },
    { 0x06B16EF9, "_k1258" },
    { 0xE0AEF490, "_k1259" },
    { 0x019D0B50, "_k126" },
    { 0xDFC455A9, "_k1261" },
    { 0x2BC94A7B, "_k1263" },
    { 0x51CBC4E4, "_k1264" },
    { 0x77CE3F4D, "_k1265" },
    { 0x9DD0B9B6, "_k1266" },
    { 0xE9D5AE88, "_k1268" },
    { 0x0FD828F1, "_k1269" },
    { 0x279F85B9, "_k127" },
    { 0x1393FB82, "_k1271" },
    { 0xC78F06B0, "_k1273" },
    { 0xD1A05F8F, "_k1274" },
    { 0x859B6ABD, "_k1276" },
    { 0x69AA4933, "_k1278" },
    { 0x43A7CECA, "_k1279" },
    { 0x619022CF, "_k12799" },
    { 0x15BFBD0E, "_k128" },
    { 0x2A5FA95A, "_k1280" },
    { 0x506223C3, "_k1281" },
    { 0x045D2EF1, "_k1283" },
    { 0xBB8E33A5, "_k12836" },
    { 0xC26992FE, "_k1284" },
    { 0x76649E2C, "_k1286" },
    { 0xFA4BD612, "_k1288" },
    { 0x3BC23777, "_k129" },
    { 0xAA344405, "_k1290" },
    { 0xF63938D7, "_k1292" },
    { 0xD036BE6E, "_k1293" },
    { 0x382CD4CA, "_k1297" },
    { 0x541DF654, "_k1299" },
    { 0x64434FF1, "_k130" },
    { 0x66CF31D3, "_k1300" },
    { 0x40CCB76A, "_k1301" },
    { 0xFED91B77, "_k1304" },
    { 0xB2D426A5, "_k1306" },
    { 0x8CD1AC3C, "_k1307" },
    { 0x3E40D588, "_k131" },
    { 0xE837CBA8, "_k1310" },
    { 0x5A3F3AE3, "_k1313" },
    { 0x8041B54C, "_k1314" },
    { 0xCC46AA1E, "_k1316" },
    { 0xB823F860, "_k1318" },
    { 0xDE2672C9, "_k1319" },
    { 0xB04844C3, "_k132" },
    { 0xA4EBE589, "_k1320" },
    { 0x7EE96B20, "_k1321" },
    { 0xF0F0DA5B, "_k1322" },
    { 0x3CF5CF2D, "_k1324" },
    { 0x88FAC3FF, "_k1326" },
    { 0xD4FFB8D1, "_k1328" },
    { 0xAEFD3E68, "_k1329" },
    { 0x8A45CA5A, "_k133" },
    { 0xE56697FE, "_k1330" },
    { 0x0B691267, "_k1331" },
    { 0x9961A32C, "_k1332" },
    { 0x735F28C3, "_k1335" },
    { 0x0157B988, "_k1336" },
    { 0x275A33F1, "_k1337" },
    { 0xFC4D3995, "_k134" },
    { 0x7C183776, "_k1341" },
    { 0x5615BD0D, "_k1342" },
    { 0x301342A4, "_k1343" },
    { 0xE40E4DD2, "_k1345" },
    { 0xBE0BD369, "_k1346" },
    { 0xAC2C0ABE, "_k1349" },
    { 0xD64ABF2C, "_k135" },
    { 0x23834BB4, "_k1350" },
    { 0x8B796210, "_k1354" },
    { 0xB17BDC79, "_k1355" },
    { 0xD77E56E2, "_k1356" },
    { 0xFD80D14B, "_k1357" },
    { 0x53971EFC, "_k1358" },
    { 0x48522E67, "_k136" },
    { 0xA086B2B5, "_k1360" },
    { 0x7A84384C, "_k1361" },
    { 0xEC8BA787, "_k1362" },
    { 0x5DD3A62B, "_k13648" },
    { 0xE27A4EA8, "_k1365" },
    { 0x5481BDE3, "_k1366" },
    { 0x2E7F437A, "_k1367" },
    { 0x224FB3FE, "_k137" },
    { 0x21EF4C8A, "_k1370" },
    { 0x47F1C6F3, "_k1371" },
    { 0xD5EA57B8, "_k1372" },
    { 0xB9F9362E, "_k1374" },
    { 0xDFFBB097, "_k1375" },
    { 0x6DF4415C, "_k1376" },
    { 0x17DDF3AB, "_k1379" },
    { 0x342F7CA9, "_k138" },
    { 0xE3E3EFC9, "_k1382" },
    { 0xBDE17560, "_k1383" },
    { 0x55EB5F04, "_k1387" },
    { 0x0E2D0240, "_k139" },
    { 0xD753F8D9, "_k1391" },
    { 0xFD567342, "_k1392" },
    { 0x95605CE6, "_k1396" },
    { 0xE16551B8, "_k1398" },
    { 0x0767CC21, "_k1399" },
    { 0x87DC30E4, "_k14" },
    { 0xE417EA9C, "_k140" },
    { 0xB331DA4D, "_k1401" },
    { 0xFF36CF1F, "_k1403" },
    { 0xF5257640, "_k1404" },
    { 0x1B27F0A9, "_k1405" },
    { 0x412A6B12, "_k1406" },
    { 0xBD43332C, "_k1408" },
    { 0xE345AD95, "_k1409" },
    { 0x0A1A6505, "_k141" },
    { 0xC0FF05BD, "_k1412" },
    { 0x9AFC8B54, "_k1413" },
    { 0x02F2A1B0, "_k1417" },
    { 0x3D17CDD7, "_k1418" },
    { 0x301CDF6E, "_k142" },
    { 0x8B9B60BA, "_k1420" },
    { 0xB19DDB23, "_k1421" },
    { 0x3F966BE8, "_k1422" },
    { 0x49A7C4C7, "_k1425" },
    { 0x818A07DB, "_k1429" },
    { 0x561F59D7, "_k143" },
    { 0x0A32C6E5, "_k1430" },
    { 0xE4304C7C, "_k1431" },
    { 0x3035414E, "_k1433" },
    { 0x7228DD41, "_k1434" },
    { 0x982B57AA, "_k1437" },
    { 0xB41C7934, "_k1439" },
    { 0x4C0E00F8, "_k144" },
    { 0x77E65A41, "_k1441" },
    { 0xE9EDC97C, "_k1444" },
    { 0x0FF043E5, "_k1445" },
    { 0x4E7A46F3, "_k14476" },
    { 0x21D00C90, "_k1448" },
    { 0x72107B61, "_k145" },
    { 0xD07B4603, "_k1450" },
    { 0xAA78CB9A, "_k1451" },
    { 0x5E73D6C8, "_k1453" },
    { 0x68852FA7, "_k1454" },
    { 0x4282B53E, "_k1455" },
    { 0xF67DC06C, "_k1457" },
    { 0xA06772BB, "_k1458" },
    { 0x7A64F852, "_k1459" },
    { 0x9812F5CA, "_k146" },
    { 0x2A4D6645, "_k1463" },
    { 0xB845F70A, "_k1464" },
    { 0x6C410238, "_k1466" },
    { 0x203C0D66, "_k1468" },
    { 0x463E87CF, "_k1469" },
    { 0xBE157033, "_k147" },
    { 0xE8957F50, "_k1471" },
    { 0x5A9CEE8B, "_k1472" },
    { 0x349A7422, "_k1473" },
    { 0xA6A1E35D, "_k1474" },
    { 0xF2A6D82F, "_k1476" },
    { 0xCCA45DC6, "_k1477" },
    { 0x66957DB9, "_k14773" },
    { 0xB4041754, "_k148" },
    { 0x16985FCC, "_k1480" },
    { 0xD46C0F85, "_k14809" },
    { 0x629D549E, "_k1482" },
    { 0x889FCF07, "_k1483" },
    { 0x67CF87B1, "_k14841" },
    { 0xA490F091, "_k1485" },
    { 0xA82F247A, "_k14864" },
    { 0xF095E563, "_k1487" },
    { 0xE6848C84, "_k1488" },
    { 0xD66DB9F4, "_k14888" },
    { 0xDA0691BD, "_k149" },
    { 0x952FC5F7, "_k1490" },
    { 0xF1AB9785, "_k14900" },
    { 0x25D20808, "_k14912" },
    { 0xFD25DC53, "_k1494" },
    { 0xD72361EA, "_k1495" },
    { 0xB120E781, "_k1496" },
    { 0x62AF50C7, "_k150" },
    { 0x00853595, "_k1500" },
    { 0x4C8A2A67, "_k1502" },
    { 0x2687AFFE, "_k1503" },
    { 0x4278D188, "_k1505" },
    { 0x8C597FA8, "_k15050" },
    { 0xB48040C3, "_k1506" },
    { 0x3CACD65E, "_k151" },
    { 0x81EDCF6A, "_k1510" },
    { 0xA7F049D3, "_k1511" },
    { 0x5BEB5501, "_k1513" },
    { 0xF3F53EA5, "_k1517" },
    { 0x0356693F, "_k1520" },
    { 0x914EFA04, "_k1523" },
    { 0xF0A7E18C, "_k153" },
    { 0x84BF0314, "_k1530" },
    { 0xAAC17D7D, "_k1531" },
    { 0xCAA56723, "_k154" },
    { 0x04EA6869, "_k1540" },
    { 0xDEE7EE00, "_k1541" },
    { 0x50EF5D3B, "_k1542" },
    { 0x76F1D7A4, "_k1545" },
    { 0x34FE3BB1, "_k1548" },
    { 0xA4A2ECBA, "_k155" },
    { 0xAE9865BA, "_k1554" },
    { 0xD49AE023, "_k1555" },
    { 0x629370E8, "_k1556" },
    { 0x8895EB51, "_k1557" },
    { 0x168E7C16, "_k1558" },
    { 0x3C90F67F, "_k1559" },
    { 0x7EA07251, "_k156" },
    { 0xC80AE933, "_k1560" },
    { 0xA2086ECA, "_k1561" },
    { 0x7C05F461, "_k1562" },
    { 0x6014D2D7, "_k1564" },
    { 0x3A12586E, "_k1565" },
    { 0xEE0D639C, "_k1567" },
    { 0x97F715EB, "_k1568" },
    { 0x589DF7E8, "_k157" },
    { 0x48364E88, "_k1570" },
    { 0x6E38C8F1, "_k1571" },
    { 0xBA3DBDC3, "_k1573" },
    { 0xE040382C, "_k1574" },
    { 0x0642B295, "_k1575" },
    { 0x5247A767, "_k1577" },
    { 0x3E24F5A9, "_k1579" },
    { 0x329B7D7F, "_k158" },
    { 0xC99EE85D, "_k1580" },
    { 0xA39C6DF4, "_k1581" },
    { 0x15A3DD2F, "_k1582" },
    { 0x3194FEB9, "_k1584" },
    { 0x7D99F38B, "_k1586" },
    { 0x57977922, "_k1587" },
    { 0xD3B0413C, "_k1589" },
    { 0x0C990316, "_k159" },
    { 0xFF028D60, "_k1592" },
    { 0x250507C9, "_k1593" },
    { 0xE3116BD6, "_k1594" },
    { 0x0913E63F, "_k1595" },
    { 0x970C7704, "_k1596" },
    { 0xBD0EF16D, "_k1597" },
    { 0x7B1B557A, "_k1598" },
    { 0xA11DCFE3, "_k1599" },
    { 0xD3E125B6, "_k16" },
    { 0x20F769D2, "_k160" },
    { 0x7D56696F, "_k1601" },
    { 0x3151749D, "_k1603" },
    { 0x8767C24E, "_k1608" },
    { 0xAD6A3CB7, "_k1609" },
    { 0x46F9E43B, "_k161" },
    { 0xAFE8DAC8, "_k1611" },
    { 0x21F04A03, "_k1612" },
    { 0x6DF53ED5, "_k1614" },
    { 0x7FD50780, "_k1619" },
    { 0xD4F27500, "_k162" },
    { 0x80279D19, "_k1621" },
    { 0xCC2C91EB, "_k1623" },
    { 0xF22F0C54, "_k1624" },
    { 0x183186BD, "_k1625" },
    { 0x8A38F5F8, "_k1628" },
    { 0xB03B7061, "_k1629" },
    { 0xD8BC88DB, "_k1630" },
    { 0xB2BA0E72, "_k1631" },
    { 0x8CB79409, "_k1632" },
    { 0x70C6727F, "_k1634" },
    { 0xE2CDE1BA, "_k1639" },
    { 0xB9015376, "_k164" },
    { 0x469A7A40, "_k1642" },
    { 0x6C9CF4A9, "_k1643" },
    { 0xE8B5BCC3, "_k1649" },
    { 0xDF03CDDF, "_k165" },
    { 0x127409BD, "_k1650" },
    { 0x38768426, "_k1653" },
    { 0x7A6A2019, "_k1654" },
    { 0xC66F14EB, "_k1656" },
    { 0x1C85629C, "_k1659" },
    { 0x6CFC5EA4, "_k166" },
    { 0x55BFEFDC, "_k1660" },
    { 0x7BC26A45, "_k1661" },
    { 0xBDB60638, "_k1664" },
    { 0xE3B880A1, "_k1665" },
    { 0x2FBD7573, "_k1667" },
    { 0x4BAE96FD, "_k1669" },
    { 0x92FED90D, "_k167" },
    { 0xD4575607, "_k1670" },
    { 0xAE54DB9E, "_k1671" },
    { 0x88526135, "_k1672" },
    { 0x624FE6CC, "_k1673" },
    { 0x3C4D6C63, "_k1674" },
    { 0xF0487791, "_k1676" },
    { 0xCA45FD28, "_k1677" },
    { 0x7E410856, "_k1679" },
    { 0x510B3D1A, "_k168" },
    { 0x8E3A3C3E, "_k1680" },
    { 0x1C32CD03, "_k1685" },
    { 0x770DB783, "_k169" },
    { 0x4DBF89C9, "_k1690" },
    { 0x27BD0F60, "_k1691" },
    { 0x99C47E9B, "_k1692" },
    { 0x73C20432, "_k1693" },
    { 0xE5C9736D, "_k1694" },
    { 0xBFC6F904, "_k1695" },
    { 0x0BCBEDD6, "_k1697" },
    { 0x57D0E2A8, "_k1699" },
    { 0xA0CC047D, "_k170" },
    { 0xF1FE7565, "_k1702" },
    { 0xA5F98093, "_k1704" },
    { 0x7FF7062A, "_k1705" },
    { 0x59F48BC1, "_k1706" },
    { 0x33F21158, "_k1707" },
    { 0xE7ED1C86, "_k1709" },
    { 0x7AC98A14, "_k171" },
    { 0x0B70F8DE, "_k1712" },
    { 0x27621A68, "_k1714" },
    { 0x4D6494D1, "_k1715" },
    { 0x8F5830C4, "_k1718" },
    { 0xB55AAB2D, "_k1719" },
    { 0xECD0F94F, "_k172" },
    { 0x7C201DED, "_k1720" },
    { 0xC82512BF, "_k1722" },
    { 0xBE13B9E0, "_k1725" },
    { 0x301B291B, "_k1726" },
    { 0xAC33F135, "_k1728" },
    { 0xC6CE7EE6, "_k173" },
    { 0xB183C2F0, "_k1732" },
    { 0xD7863D59, "_k1733" },
    { 0x498DAC94, "_k1736" },
    { 0x6F9026FD, "_k1737" },
    { 0x539F0573, "_k1739" },
    { 0x08C21AD9, "_k174" },
    { 0xF663A839, "_k1742" },
    { 0xD0612DD0, "_k1743" },
    { 0x8E6D91DD, "_k1746" },
    { 0x727C7053, "_k1748" },
    { 0xE2BFA070, "_k175" },
    { 0xC3D136E0, "_k1750" },
    { 0xE9D3B149, "_k1751" },
    { 0x0FD62BB2, "_k1752" },
    { 0x35D8A61B, "_k1753" },
    { 0x5BDB2084, "_k1754" },
    { 0x81DD9AED, "_k1755" },
    { 0xA7E01556, "_k1756" },
    { 0xCDE28FBF, "_k1757" },
    { 0x19E78491, "_k1759" },
    { 0x54C70FAB, "_k176" },
    { 0x40D49DE1, "_k1760" },
    { 0x8CD992B3, "_k1762" },
    { 0x66D7184A, "_k1763" },
    { 0xD8DE8785, "_k1764" },
    { 0x24E37C57, "_k1766" },
    { 0x10C0CA99, "_k1768" },
    { 0x2EC49542, "_k177" },
    { 0xE7027D9F, "_k1771" },
    { 0x4EF893FB, "_k1775" },
    { 0xDCF124C0, "_k1776" },
    { 0x02F39F29, "_k1777" },
    { 0xD0DFD7C5, "_k178" },
    { 0x8FD52466, "_k1781" },
    { 0xD1C8C059, "_k1786" },
    { 0xABC645F0, "_k1787" },
    { 0xE5EB7217, "_k1788" },
    { 0xAADD5D5C, "_k179" },
    { 0x36030424, "_k1790" },
    { 0x5C057E8D, "_k1791" },
    { 0x8207F8F6, "_k1792" },
    { 0xA80A735F, "_k1793" },
    { 0xC3FB94E9, "_k1795" },
    { 0xE9FE0F52, "_k1796" },
    { 0x8C1951D5, "_k1799" },
    { 0x1FE61A88, "_k18" },
    { 0x1F636AA8, "_k180" },
    { 0xF109F2C8, "_k1800" },
    { 0x8913DC6C, "_k1804" },
    { 0xAF1656D5, "_k1805" },
    { 0xC0F61F80, "_k1808" },
    { 0xE6F899E9, "_k1809" },
    { 0x4565E511, "_k181" },
    { 0xFED71E38, "_k1813" },
    { 0x08E87717, "_k1814" },
    { 0xE2E5FCAE, "_k1815" },
    { 0xBCE38245, "_k1816" },
    { 0x96E107DC, "_k1817" },
    { 0x40CABA2B, "_k1818" },
    { 0x1AC83FC2, "_k1819" },
    { 0x6B685F7A, "_k182" },
    { 0xA370FECC, "_k1822" },
    { 0x576C09FA, "_k1824" },
    { 0x0B671528, "_k1826" },
    { 0x31698F91, "_k1827" },
    { 0x916AD9E3, "_k183" },
    { 0x45C7F64D, "_k1834" },
    { 0x1FC57BE4, "_k1835" },
    { 0x91CCEB1F, "_k1836" },
    { 0xB7CF6588, "_k1839" },
    { 0xB76D544C, "_k184" },
    { 0x2D92A754, "_k1840" },
    { 0x07902CEB, "_k1847" },
    { 0x83A8F505, "_k1849" },
    { 0xDD6FCEB5, "_k185" },
    { 0xAC2A0D7F, "_k1850" },
    { 0x3A229E44, "_k1853" },
    { 0x142023DB, "_k1854" },
    { 0xEE1DA972, "_k1855" },
    { 0xDC3DE0C7, "_k1858" },
    { 0x0372491E, "_k186" },
    { 0x2AC173AA, "_k1860" },
    { 0x50C3EE13, "_k1861" },
    { 0x04BEF941, "_k1863" },
    { 0xC2CB5D4E, "_k1864" },
    { 0xFAADA062, "_k1868" },
    { 0x20B01ACB, "_k1869" },
    { 0x2974C387, "_k187" },
    { 0xCF5B543E, "_k1873" },
    { 0x114EF031, "_k1874" },
    { 0x7945068D, "_k1878" },
    { 0x53428C24, "_k1879" },
    { 0xEF4F9760, "_k188" },
    { 0x06289A62, "_k1882" },
    { 0x2C2B14CB, "_k1883" },
    { 0x7830099D, "_k1885" },
    { 0x9E328406, "_k1886" },
    { 0xEA3778D8, "_k1888" },
    { 0x155211C9, "_k189" },
    { 0xC6B39C80, "_k1893" },
    { 0xD0C4F55F, "_k1894" },
    { 0x84C0008D, "_k1896" },
    { 0x5EBD8624, "_k1897" },
    { 0x9DFAD0D3, "_k190" },
    { 0xF152A4AB, "_k1902" },
    { 0x895C8E4F, "_k1906" },
    { 0x635A13E6, "_k1907" },
    { 0xD5618321, "_k1908" },
    { 0x0BCADCB7, "_k1911" },
    { 0x99C36D7C, "_k1912" },
    { 0x27BBFE41, "_k1917" },
    { 0x51F5DC01, "_k192" },
    { 0x6730FC23, "_k1920" },
    { 0x412E81BA, "_k1921" },
    { 0xF5298CE8, "_k1923" },
    { 0xB335F0F5, "_k1926" },
    { 0x8D33768C, "_k1927" },
    { 0x371D28DB, "_k1928" },
    { 0x111AAE72, "_k1929" },
    { 0x2BF36198, "_k193" },
    { 0xE89995F8, "_k1930" },
    { 0xB885C2B0, "_k1938" },
    { 0xDE883D19, "_k1939" },
    { 0x3604BA77, "_k194" },
    { 0xC6EAF76E, "_k1943" },
    { 0x08DE9361, "_k1944" },
    { 0xE2DC18F8, "_k1945" },
    { 0x54E38833, "_k1946" },
    { 0x70D4A9BD, "_k1948" },
    { 0x1002400E, "_k195" },
    { 0x2113E25A, "_k1950" },
    { 0x47165CC3, "_k1951" },
    { 0xD50EED88, "_k1952" },
    { 0xF1000F12, "_k1958" },
    { 0xE9FFC5A5, "_k196" },
    { 0x5677875D, "_k1962" },
    { 0x30750CF4, "_k1963" },
    { 0x0A72928B, "_k1964" },
    { 0xBE6D9DB9, "_k1966" },
    { 0xAC8DD50E, "_k1969" },
    { 0xC3FD4B3C, "_k197" },
    { 0x23E51604, "_k1970" },
    { 0x6FEA0AD6, "_k1972" },
    { 0xD7E02132, "_k1976" },
    { 0xFDE29B9B, "_k1977" },
    { 0x53F8E94C, "_k1978" },
    { 0x79FB63B5, "_k1979" },
    { 0x6DE6FD8B, "_k198" },
    { 0x537BF5AA, "_k1983" },
    { 0xC58364E5, "_k1984" },
    { 0x9F80EA7C, "_k1985" },
    { 0x118859B7, "_k1986" },
    { 0xEB85DF4E, "_k1987" },
    { 0xD7632D90, "_k1989" },
    { 0x47E48322, "_k199" },
    { 0xAEE21516, "_k1990" },
    { 0xD4E48F7F, "_k1991" },
    { 0x16D82B72, "_k1994" },
    { 0x3CDAA5DB, "_k1995" },
    { 0xF588F6E3, "_k200" },
    { 0x4925B3A9, "_k2000" },
    { 0xBB2D22E4, "_k2005" },
    { 0x2D34921F, "_k2006" },
    { 0x073217B6, "_k2007" },
    { 0x793986F1, "_k2008" },
    { 0xCF867C7A, "_k201" },
    { 0x8ADD9A9E, "_k2010" },
    { 0x3ED8A5CC, "_k2012" },
    { 0xF2D3B0FA, "_k2014" },
    { 0x5AC9C756, "_k2018" },
    { 0xA9840211, "_k202" },
    { 0x0C463473, "_k2020" },
    { 0xE643BA0A, "_k2021" },
    { 0x7E4DA3AE, "_k2025" },
    { 0x838187A8, "_k203" },
    { 0x9682F2A7, "_k2037" },
    { 0x8D92E087, "_k204" },
    { 0x44C080D5, "_k2040" },
    { 0x1EBE066C, "_k2041" },
    { 0x90C575A7, "_k2042" },
    { 0xACB69731, "_k2044" },
    { 0x86B41CC8, "_k2045" },
    { 0xF8BB8C03, "_k2046" },
    { 0xD2B9119A, "_k2047" },
    { 0x14ACAD8D, "_k2048" },
    { 0x6790661E, "_k205" },
    { 0x122E0F7C, "_k2056" },
    { 0x418DEBB5, "_k206" },
    { 0xFB8CBFAD, "_k2062" },
    { 0xAF87CADB, "_k2064" },
    { 0x77A587C7, "_k2068" },
    { 0x51A30D5E, "_k2069" },
    { 0x1B8B714C, "_k207" },
    { 0x3B01BD8F, "_k2073" },
    { 0x56F2DF19, "_k2075" },
    { 0xA2F7D3EB, "_k2077" },
    { 0xC575239B, "_k208" },
    { 0xAC8C3928, "_k2081" },
    { 0x1E93A863, "_k2082" },
    { 0x53F74D66, "_k2090" },
    { 0x07F25894, "_k2092" },
    { 0xE1EFDE2B, "_k2095" },
    { 0x840B20AE, "_k2098" },
    { 0x46D333D8, "_k21" },
    { 0x76F190B8, "_k210" },
    { 0xBC21A581, "_k2101" },
    { 0x542B8F25, "_k2105" },
    { 0xA03083F7, "_k2107" },
    { 0x8C0DD239, "_k2109" },
    { 0x9CF40B21, "_k211" },
    { 0xACC07AE7, "_k2114" },
    { 0x60BB8615, "_k2116" },
    { 0xC2F6858A, "_k212" },
    { 0x4886371C, "_k2122" },
    { 0x6E88B185, "_k2123" },
    { 0x2283BCB3, "_k2125" },
    { 0xB07C4D78, "_k2126" },
    { 0x647758A6, "_k2128" },
    { 0x8A79D30F, "_k2129" },
    { 0xE8F8FFF3, "_k213" },
    { 0x9ED839CB, "_k2132" },
    { 0xEADD2E9D, "_k2134" },
    { 0x82E71841, "_k2138" },
    { 0x0EFB7A5C, "_k214" },
    { 0x43721A5F, "_k2143" },
    { 0xAB6830BB, "_k2147" },
    { 0x34FDF4C5, "_k215" },
    { 0x9332E1C2, "_k2155" },
    { 0x5B006F2E, "_k216" },
    { 0x83D1B728, "_k2162" },
    { 0x1BDBA0CC, "_k2166" },
    { 0x8102E997, "_k217" },
    { 0x74708C8E, "_k2173" },
    { 0xDC66A2EA, "_k2177" },
    { 0x46DDBD70, "_k218" },
    { 0x1D4541ED, "_k2185" },
    { 0x694A36BF, "_k2187" },
    { 0x6CE037D9, "_k219" },
    { 0xDDD0440B, "_k2190" },
    { 0xE7E19CEA, "_k2199" },
    { 0xB8DAA313, "_k22" },
    { 0x33A5AA99, "_k220" },
    { 0x1EADD1EF, "_k2204" },
    { 0xF8AB5786, "_k2205" },
    { 0xACA662B4, "_k2207" },
    { 0x90B5412A, "_k2209" },
    { 0x0DA33030, "_k221" },
    { 0x080C8220, "_k2210" },
    { 0x121DDAFF, "_k2217" },
    { 0x5E22CFD1, "_k2219" },
    { 0x7FAA9F6B, "_k222" },
    { 0xF717585C, "_k2225" },
    { 0x54FC15D9, "_k2228" },
    { 0x59A82502, "_k223" },
    { 0x053B4E76, "_k2230" },
    { 0x9333DF3B, "_k2235" },
    { 0xCBAF943D, "_k224" },
    { 0x5C3C3B0E, "_k2241" },
    { 0xEA34CBD3, "_k2244" },
    { 0xC432516A, "_k2245" },
    { 0x9E2FD701, "_k2246" },
    { 0xA5AD19D4, "_k225" },
    { 0xB7A25A7A, "_k2256" },
    { 0xD3937C04, "_k2258" },
    { 0xF995F66D, "_k2259" },
    { 0x17B4890F, "_k226" },
    { 0x0C605DFF, "_k2262" },
    { 0x7456745B, "_k2266" },
    { 0x4E53F9F2, "_k2267" },
    { 0xF06F3C75, "_k2268" },
    { 0xCA6CC20C, "_k2269" },
    { 0xF1B20EA6, "_k227" },
    { 0x41C40302, "_k2270" },
    { 0xF5BF0E30, "_k2272" },
    { 0x8DC8F7D4, "_k2276" },
    { 0x71D7D64A, "_k2278" },
    { 0x97DA50B3, "_k2279" },
    { 0x63B97DE1, "_k228" },
    { 0xBD8A3583, "_k2280" },
    { 0x718540B1, "_k2282" },
    { 0x4B82C648, "_k2283" },
    { 0x8D76623B, "_k2288" },
    { 0x6773E7D2, "_k2289" },
    { 0x3DB70378, "_k229" },
    { 0x3EF2CF58, "_k2290" },
    { 0xD6FCB8FC, "_k2294" },
    { 0xFCFF3365, "_k2295" },
    { 0x2301ADCE, "_k2296" },
    { 0x0EDEFC10, "_k2298" },
    { 0x34E17679, "_k2299" },
    { 0x92D828AA, "_k23" },
    { 0x74205D0E, "_k230" },
    { 0x548572FE, "_k2304" },
    { 0x8C67B612, "_k2308" },
    { 0xB26A307B, "_k2309" },
    { 0x9A22D777, "_k231" },
    { 0x62529E6E, "_k2313" },
    { 0x7E43BFF8, "_k2315" },
    { 0xCA48B4CA, "_k2317" },
    { 0xE639D654, "_k2319" },
    { 0x281B683C, "_k232" },
    { 0xBF4CBD04, "_k2320" },
    { 0xE54F376D, "_k2321" },
    { 0x31542C3F, "_k2323" },
    { 0x4D454DC9, "_k2325" },
    { 0x994A429B, "_k2327" },
    { 0xEF60904C, "_k2328" },
    { 0x4E1DE2A5, "_k233" },
    { 0x3DE4232F, "_k2330" },
    { 0x17E1A8C6, "_k2331" },
    { 0xF1DF2E5D, "_k2332" },
    { 0xA5DA398B, "_k2334" },
    { 0x7FD7BF22, "_k2335" },
    { 0x33D2CA50, "_k2337" },
    { 0xDC16736A, "_k234" },
    { 0x5B2D8EE5, "_k2343" },
    { 0xE9261FAA, "_k2344" },
    { 0x0218EDD3, "_k235" },
    { 0xD8BF407D, "_k2354" },
    { 0xB2BCC614, "_k2355" },
    { 0x90117E98, "_k236" },
    { 0x1C0B269C, "_k2364" },
    { 0x53ED69B0, "_k2368" },
    { 0x9AA28CC7, "_k2374" },
    { 0x4E9D97F5, "_k2376" },
    { 0xAC825572, "_k2379" },
    { 0x440C89C6, "_k238" },
    { 0x1D9F25C6, "_k2384" },
    { 0x43A1A02F, "_k2385" },
    { 0xF79CAB5D, "_k2387" },
    { 0xB5A90F6A, "_k2388" },
    { 0x6A0F042F, "_k239" },
    { 0x042CA24D, "_k2390" },
    { 0x5031971F, "_k2392" },
    { 0x2A2F1CB6, "_k2393" },
    { 0x46203E40, "_k2395" },
    { 0x92253312, "_k2397" },
    { 0x0E3DFB2C, "_k2399" },
    { 0x04DF97E5, "_k24" },
    { 0x30D476EF, "_k240" },
    { 0xAD00468D, "_k2400" },
    { 0xF9053B5F, "_k2402" },
    { 0x14F65CE9, "_k2404" },
    { 0xEEF3E280, "_k2405" },
    { 0x0AD1FC86, "_k241" },
    { 0xC672CA06, "_k2414" },
    { 0xEC75446F, "_k2415" },
    { 0x7A6DD534, "_k2416" },
    { 0xA0704F9D, "_k2417" },
    { 0xE4CF821D, "_k242" },
    { 0xFE19581C, "_k2423" },
    { 0x660F6E78, "_k2427" },
    { 0xBECD07B4, "_k243" },
    { 0x62539BE7, "_k2433" },
    { 0xCA49B243, "_k2437" },
    { 0x98CA8D4B, "_k244" },
    { 0x09BEB025, "_k2444" },
    { 0xE3BC35BC, "_k2445" },
    { 0x2FC12A8E, "_k2447" },
    { 0x72C812E2, "_k245" },
    { 0xF31D6056, "_k2450" },
    { 0xCD1AE5ED, "_k2453" },
    { 0x5B1376B2, "_k2454" },
    { 0x4CC59879, "_k246" },
    { 0xE68D6966, "_k2465" },
    { 0xC08AEEFD, "_k2466" },
    { 0x26C31E10, "_k247" },
    { 0x66B8CEBB, "_k2473" },
    { 0xB2BDC38D, "_k2475" },
    { 0x4AC7AD31, "_k2479" },
    { 0x60E84A37, "_k248" },
    { 0x991ED373, "_k2486" },
    { 0x731C590A, "_k2487" },
    { 0x3AE5CFCE, "_k249" },
    { 0xFD59173E, "_k2494" },
    { 0x235B91A7, "_k2495" },
    { 0xD7569CD5, "_k2497" },
    { 0x5B3DD4BB, "_k2499" },
    { 0xDEDD1D7C, "_k25" },
    { 0xB23D10C4, "_k250" },
    { 0x87F24EC1, "_k2505" },
    { 0xADF4C92A, "_k2506" },
    { 0xD83F8B2D, "_k251" },
    { 0x78912427, "_k2510" },
    { 0x0689B4EC, "_k2513" },
    { 0x227AD676, "_k2519" },
    { 0xFE420596, "_k252" },
    { 0x381671B2, "_k2520" },
    { 0xEC117CE0, "_k2522" },
    { 0x1213F749, "_k2523" },
    { 0x841B6684, "_k2526" },
    { 0x24447FFF, "_k253" },
    { 0x1EA3EE39, "_k2534" },
    { 0x1A332720, "_k254" },
    { 0xFE5EF0D0, "_k2540" },
    { 0xAD0A2A43, "_k2558" },
    { 0x66381BF2, "_k256" },
    { 0xFCCAF1A6, "_k2560" },
    { 0x22CD6C0F, "_k2561" },
    { 0x52E13F57, "_k2569" },
    { 0x8C3A965B, "_k257" },
    { 0x396EBBDE, "_k2577" },
    { 0xE250E40C, "_k258" },
    { 0xBDD2E766, "_k2582" },
    { 0xE3D561CF, "_k2583" },
    { 0xD9C408F0, "_k2584" },
    { 0x4BCB782B, "_k2587" },
    { 0x08535E75, "_k259" },
    { 0xCA62DE56, "_k2591" },
    { 0x7E5DE984, "_k2593" },
    { 0x20792C07, "_k2598" },
    { 0x50E48CB7, "_k26" },
    { 0x2F4077C5, "_k260" },
    { 0x47F37ECF, "_k2600" },
    { 0x63E4A059, "_k2606" },
    { 0x5204D7AE, "_k2609" },
    { 0x093DFD5C, "_k261" },
    { 0xA21C69BB, "_k2617" },
    { 0x1F1FD0BC, "_k2621" },
    { 0xD31ADBEA, "_k2627" },
    { 0x5542F22E, "_k263" },
    { 0x84974907, "_k2635" },
    { 0x128FD9CC, "_k2636" },
    { 0x97368E21, "_k264" },
    { 0xBF65D571, "_k2642" },
    { 0x576FBF15, "_k2646" },
    { 0x713413B8, "_k265" },
    { 0x24DD4DBC, "_k2654" },
    { 0x4ADFC825, "_k2655" },
    { 0x82C20B39, "_k2659" },
    { 0xE33B82F3, "_k266" },
    { 0xBD39088A, "_k267" },
    { 0xB141DF57, "_k2671" },
    { 0x653CEA85, "_k2673" },
    { 0xFF2CA47D, "_k268" },
    { 0xC60DF158, "_k2687" },
    { 0xA00B76EF, "_k2688" },
    { 0xD92A2A14, "_k269" },
    { 0x9D8CD8DE, "_k2692" },
    { 0xDF8074D1, "_k2695" },
    { 0x2AE2124E, "_k27" },
    { 0xAF6BDD1A, "_k270" },
    { 0x6249B831, "_k2707" },
    { 0xF04248F6, "_k2708" },
    { 0xD56E5783, "_k271" },
    { 0x77E5536D, "_k2714" },
    { 0x51E2D904, "_k2715" },
    { 0x9DE7CDD6, "_k2717" },
    { 0x6366E848, "_k272" },
    { 0x952EBF23, "_k2723" },
    { 0x896962B1, "_k273" },
    { 0xA1BEB613, "_k2730" },
    { 0x4775C6BE, "_k274" },
    { 0x10D9DBF8, "_k2742" },
    { 0x36DC5661, "_k2743" },
    { 0xF4E8BA6E, "_k2744" },
    { 0xA8E3C59C, "_k2746" },
    { 0x6D784127, "_k275" },
    { 0xB573BC8C, "_k2751" },
    { 0x277B2BC7, "_k2752" },
    { 0xFB70D1EC, "_k276" },
    { 0x84754A5D, "_k2761" },
    { 0xAA77C4C6, "_k2762" },
    { 0x21734C55, "_k277" },
    { 0xDD0A361F, "_k2770" },
    { 0x45004C7B, "_k2774" },
    { 0x1EFDD212, "_k2775" },
    { 0xE96FCF06, "_k2780" },
    { 0x1983A24E, "_k2788" },
    { 0xA55A843B, "_k279" },
    { 0x8E09AF9A, "_k2793" },
    { 0x00111ED5, "_k2794" },
    { 0xDA0EA46C, "_k2795" },
    { 0x3CC1DAF9, "_k28" },
    { 0xBEA2A9AB, "_k280" },
    { 0x7D91F585, "_k2804" },
    { 0xB5743899, "_k2808" },
    { 0x98A02F42, "_k281" },
    { 0x8BB5EB9F, "_k2811" },
    { 0x19AE7C64, "_k2812" },
    { 0xCDA98792, "_k2814" },
    { 0xF3AC01FB, "_k2815" },
    { 0xBBC9BEE7, "_k2819" },
    { 0x729DB4D9, "_k282" },
    { 0x7F25F4AF, "_k2824" },
    { 0x4C9B3A70, "_k283" },
    { 0xB48999B2, "_k2832" },
    { 0x269108ED, "_k2835" },
    { 0x56AC934F, "_k284" },
    { 0x62C727E0, "_k2845" },
    { 0xD4CE971B, "_k2846" },
    { 0x2AE4E4CC, "_k2849" },
    { 0x30AA18E6, "_k285" },
    { 0xA23C25C2, "_k2850" },
    { 0xC83EA02B, "_k2851" },
    { 0xD24FF90A, "_k2858" },
    { 0xF8527373, "_k2859" },
    { 0x0AA79E7D, "_k286" },
    { 0xE2B6D837, "_k2860" },
    { 0x4AACEE93, "_k2864" },
    { 0x24AA742A, "_k2865" },
    { 0xFEA7F9C1, "_k2866" },
    { 0xD8A57F58, "_k2867" },
    { 0xE4A52414, "_k287" },
    { 0xD626E147, "_k2873" },
    { 0xEEB67CF3, "_k288" },
    { 0x402DEA6F, "_k2886" },
    { 0x1A2B7006, "_k2887" },
    { 0xC8B4028A, "_k289" },
    { 0x05CD094A, "_k2894" },
    { 0x16BF6090, "_k29" },
    { 0x3ECE0F00, "_k290" },
    { 0xE2E76F26, "_k2906" },
    { 0x08E9E98F, "_k2907" },
    { 0x64D08969, "_k291" },
    { 0xC974EBAD, "_k2916" },
    { 0xA3727144, "_k2917" },
    { 0x8AD303D2, "_k292" },
    { 0x2209D76F, "_k2921" },
    { 0x63FD7362, "_k2924" },
    { 0xB0D57E3B, "_k293" },
    { 0xC6A3B803, "_k2932" },
    { 0xECA6326C, "_k2935" },
    { 0xD6D7F8A4, "_k294" },
    { 0x467852AE, "_k2942" },
    { 0xAE6E690A, "_k2946" },
    { 0xFCDA730D, "_k295" },
    { 0x48F6F0BF, "_k2958" },
    { 0x22DCED76, "_k296" },
    { 0xEB4DE840, "_k2962" },
    { 0x48DF67DF, "_k297" },
    { 0x6EE1E248, "_k298" },
    { 0x05AB0AA0, "_k2988" },
    { 0x94E45CB1, "_k299" },
    { 0xB4564413, "_k2990" },
    { 0x36436422, "_k3" },
    { 0xEE3E4816, "_k30" },
    { 0x82332132, "_k300" },
    { 0x48F43566, "_k3000" },
    { 0xA8359B9B, "_k301" },
    { 0xA1892128, "_k3011" },
    { 0x8597FF9E, "_k3017" },
    { 0x362E2C60, "_k302" },
    { 0x4A883490, "_k3020" },
    { 0x968D2962, "_k3022" },
    { 0x5C30A6C9, "_k303" },
    { 0x403F853F, "_k305" },
    { 0x32EAEEE5, "_k3058" },
    { 0xCE381604, "_k306" },
    { 0xAE191818, "_k3064" },
    { 0xF43A906D, "_k307" },
    { 0x9EB7ED7E, "_k3071" },
    { 0x2CB07E43, "_k3074" },
    { 0xB246F47A, "_k308" },
    { 0xD8496EE3, "_k309" },
    { 0x1440C27F, "_k31" },
    { 0x00CA875D, "_k310" },
    { 0xDAC80CF4, "_k311" },
    { 0x1672F603, "_k3117" },
    { 0x4CCF7C2F, "_k312" },
    { 0x452E7F1F, "_k3122" },
    { 0x26CD01C6, "_k313" },
    { 0x548FA9B9, "_k3133" },
    { 0x389E882F, "_k3135" },
    { 0x68C09DB9, "_k314" },
    { 0x9AACC382, "_k3141" },
    { 0x58B9278F, "_k3144" },
    { 0xCAC096CA, "_k3149" },
    { 0x42BE2350, "_k315" },
    { 0xB4C5928B, "_k316" },
    { 0x97DB8FD8, "_k3161" },
    { 0x2FE5797C, "_k3165" },
    { 0x7BEA6E4E, "_k3167" },
    { 0x8EC31822, "_k317" },
    { 0x30DE5AA5, "_k318" },
    { 0x9AD7218B, "_k3184" },
    { 0x74D4A722, "_k3185" },
    { 0x0ADBE03C, "_k319" },
    { 0xB449A504, "_k3190" },
    { 0x2651143F, "_k3193" },
    { 0x424235C9, "_k3195" },
    { 0x8E472A9B, "_k3197" },
    { 0xA2395344, "_k32" },
    { 0x44166D7C, "_k320" },
    { 0x0B7600C4, "_k3200" },
    { 0x6A18E7E5, "_k321" },
    { 0xA5FE8879, "_k3216" },
    { 0x901B624E, "_k322" },
    { 0xE2A252B1, "_k3223" },
    { 0xC6B13127, "_k3225" },
    { 0xD890F9D2, "_k3228" },
    { 0xB61DDCB7, "_k323" },
    { 0xAC0C83D8, "_k324" },
    { 0x1C2F758A, "_k3242" },
    { 0x4231EFF3, "_k3243" },
    { 0xB4395F2E, "_k3246" },
    { 0xD20EFE41, "_k325" },
    { 0x28BF6C7A, "_k3251" },
    { 0xDCBA77A8, "_k3253" },
    { 0xF81178AA, "_k326" },
    { 0xCD594D0E, "_k3260" },
    { 0x354F636A, "_k3264" },
    { 0x1E13F313, "_k327" },
    { 0x70ED790F, "_k3276" },
    { 0x14029A34, "_k328" },
    { 0x6D9F51C3, "_k3287" },
    { 0x3A05149D, "_k329" },
    { 0xC83BCDAD, "_k33" },
    { 0xC2ADD3A7, "_k330" },
    { 0xA4CE50DE, "_k3303" },
    { 0x4EB8032D, "_k3308" },
    { 0x28B588C4, "_k3309" },
    { 0x9CAB593E, "_k331" },
    { 0x2636EAB3, "_k3311" },
    { 0xDA31F5E1, "_k3313" },
    { 0x76A8DED5, "_k332" },
    { 0x0E586664, "_k3323" },
    { 0xC2537192, "_k3325" },
    { 0x50A6646C, "_k333" },
    { 0xB5C37AA2, "_k3336" },
    { 0x31DC42BC, "_k3338" },
    { 0x5D2E8EE0, "_k3341" },
    { 0x04A16F9A, "_k335" },
    { 0x9DA94155, "_k3353" },
    { 0x2BA1D21A, "_k3354" },
    { 0xDE9EF531, "_k336" },
    { 0xD30CE658, "_k3363" },
    { 0xB89C7AC8, "_k337" },
    { 0x1281E43A, "_k3372" },
    { 0x96691C20, "_k3378" },
    { 0x929A005F, "_k338" },
    { 0x77F95C85, "_k3388" },
    { 0x6C9785F6, "_k339" },
    { 0x56345E72, "_k34" },
    { 0x46E7A126, "_k340" },
    { 0xBF172819, "_k3403" },
    { 0x6CEA1B8F, "_k341" },
    { 0x3DAE8E44, "_k3411" },
    { 0xCBA71F09, "_k3414" },
    { 0x93C4DBF5, "_k3418" },
    { 0xFAE2AC54, "_k342" },
    { 0xCCFF6935, "_k3421" },
    { 0x0EF30528, "_k3424" },
    { 0x5AF7F9FA, "_k3426" },
    { 0x20E526BD, "_k343" },
    { 0xD98F6025, "_k3432" },
    { 0xAEDDB782, "_k344" },
    { 0xCE93685F, "_k3441" },
    { 0x828E738D, "_k3443" },
    { 0xEA8489E9, "_k3447" },
    { 0xD8A4C13E, "_k3448" },
    { 0xD4E031EB, "_k345" },
    { 0x62D8C2B0, "_k346" },
    { 0x01786F51, "_k3469" },
    { 0x88DB3D19, "_k347" },
    { 0x9C00F706, "_k3475" },
    { 0x76FB746E, "_k348" },
    { 0x8E075EF5, "_k3487" },
    { 0x9CFDEED7, "_k349" },
    { 0xC57F0751, "_k350" },
    { 0xE66808F8, "_k3503" },
    { 0x9F7C8CE8, "_k351" },
    { 0x1183FC23, "_k352" },
    { 0x6F4C7D00, "_k3521" },
    { 0x2D58E10D, "_k3524" },
    { 0xEB8181BA, "_k353" },
    { 0x64FF6F23, "_k3535" },
    { 0x5D88F0F5, "_k354" },
    { 0x6DB87DD6, "_k3541" },
    { 0xFBB10E9B, "_k3544" },
    { 0x3786768C, "_k355" },
    { 0x15239214, "_k3550" },
    { 0xA98DE5C7, "_k356" },
    { 0x90E9C495, "_k3560" },
    { 0xF8DFDAF1, "_k3564" },
    { 0xD2DD6088, "_k3565" },
    { 0x60D5F14D, "_k3568" },
    { 0x838B6B5E, "_k357" },
    { 0xE23E8B22, "_k3578" },
    { 0x956B3409, "_k358" },
    { 0xAE448740, "_k3583" },
    { 0x6F68B9A0, "_k359" },
    { 0xEDB98522, "_k3592" },
    { 0xD1C86398, "_k3598" },
    { 0x0A2F69A0, "_k36" },
    { 0x487BA050, "_k360" },
    { 0x4A266A40, "_k3600" },
    { 0xBC2DD97B, "_k3603" },
    { 0xE23053E4, "_k3604" },
    { 0x0832CE4D, "_k3605" },
    { 0x6E7E1AB9, "_k361" },
    { 0xFA0ED833, "_k3618" },
    { 0xFC8D7644, "_k3622" },
    { 0x8A860709, "_k3627" },
    { 0xBA830F8B, "_k363" },
    { 0x132EC613, "_k3632" },
    { 0xED2C4BAA, "_k3633" },
    { 0xE08589F4, "_k364" },
    { 0x45C1376C, "_k3640" },
    { 0x0688045D, "_k365" },
    { 0x2D8BE873, "_k3654" },
    { 0x9581FECF, "_k3658" },
    { 0x6F7F8466, "_k3659" },
    { 0x2C8A7EC6, "_k366" },
    { 0x528CF92F, "_k367" },
    { 0x906DE212, "_k3677" },
    { 0x788F7398, "_k368" },
    { 0x9E91EE01, "_k369" },
    { 0xB4DC5D51, "_k3692" },
    { 0xC713067B, "_k370" },
    { 0xBD7C3FF1, "_k3700" },
    { 0xA1108C12, "_k371" },
    { 0x7B0E11A9, "_k372" },
    { 0x58575D3F, "_k3724" },
    { 0x550B9740, "_k373" },
    { 0x67B887D9, "_k3731" },
    { 0x8DBB0242, "_k3732" },
    { 0x97CC5B21, "_k3739" },
    { 0x5F1CF01F, "_k374" },
    { 0x391A75B6, "_k375" },
    { 0x1317FB4D, "_k376" },
    { 0xED1580E4, "_k377" },
    { 0xD1245F5A, "_k379" },
    { 0x1E521B5E, "_k38" },
    { 0xB9196E6A, "_k380" },
    { 0xDF1BE8D3, "_k381" },
    { 0x0663FD70, "_k3811" },
    { 0x6D147998, "_k382" },
    { 0x5123580E, "_k384" },
    { 0x7725D277, "_k385" },
    { 0xB5F9D5CA, "_k3857" },
    { 0x051E633C, "_k386" },
    { 0x89059B22, "_k388" },
    { 0xAF08158B, "_k389" },
    { 0x8E8FC8D8, "_k3891" },
    { 0x729EA74E, "_k3897" },
    { 0x445495C7, "_k39" },
    { 0x37B0D495, "_k390" },
    { 0x11AE5A2C, "_k391" },
    { 0xED554186, "_k3912" },
    { 0xD1641FFC, "_k3918" },
    { 0x83B5C967, "_k392" },
    { 0x5DB34EFE, "_k393" },
    { 0x79A47088, "_k395" },
    { 0x35F0F960, "_k3958" },
    { 0xEBABDFC3, "_k396" },
    { 0xC5A9655A, "_k397" },
    { 0x89361367, "_k3971" },
    { 0x079D014D, "_k398" },
    { 0x834E385E, "_k3981" },
    { 0x3749438C, "_k3983" },
    { 0xEB444EBA, "_k3985" },
    { 0xE19A86E4, "_k399" },
    { 0x76BE416E, "_k3992" },
    { 0xDEB457CA, "_k3996" },
    { 0xFAA57954, "_k3998" },
    { 0x6B41AF17, "_k40" },
    { 0x78F7F65D, "_k4002" },
    { 0x06F08722, "_k4005" },
    { 0x693C803C, "_k401" },
    { 0x7679584C, "_k4018" },
    { 0xDB43EF77, "_k402" },
    { 0x2B5F0261, "_k4024" },
    { 0xB541750E, "_k403" },
    { 0xDB9E3AFE, "_k4034" },
    { 0x0108AC19, "_k4059" },
    { 0x433A05D3, "_k406" },
    { 0x13D313AB, "_k4062" },
    { 0x1D378B6A, "_k407" },
    { 0x703EE7AA, "_k4074" },
    { 0x5F2B275D, "_k408" },
    { 0xB65C0173, "_k4084" },
    { 0x3928ACF4, "_k409" },
    { 0x828C5B9A, "_k4096" },
    { 0xA88ED603, "_k4097" },
    { 0x453F34AE, "_k41" },
    { 0x10A7947A, "_k410" },
    { 0xE1E28F56, "_k4108" },
    { 0x36AA0EE3, "_k411" },
    { 0x1C43707B, "_k4112" },
    { 0xC4A29FA8, "_k412" },
    { 0x398CDC31, "_k4121" },
    { 0xEAA51A11, "_k413" },
    { 0x05666BAE, "_k4135" },
    { 0xDF63F145, "_k4136" },
    { 0xB96176DC, "_k4137" },
    { 0xA8B17E1E, "_k414" },
    { 0xCEB3F887, "_k415" },
    { 0x0DCCE4C8, "_k4155" },
    { 0x75C2FB24, "_k4159" },
    { 0x5CAC894C, "_k416" },
    { 0x82AF03B5, "_k417" },
    { 0xA8A80216, "_k4171" },
    { 0xE093C132, "_k418" },
    { 0x06963B9B, "_k419" },
    { 0x2993A849, "_k4198" },
    { 0x1F3CBA45, "_k42" },
    { 0x460B397D, "_k422" },
    { 0x2008BF14, "_k423" },
    { 0xFA0644AB, "_k424" },
    { 0xD403CA42, "_k425" },
    { 0xFF7193C0, "_k4256" },
    { 0xAE014FD9, "_k426" },
    { 0x64E90C0B, "_k4260" },
    { 0x18E41739, "_k4262" },
    { 0x87FED570, "_k427" },
    { 0x3C67F391, "_k4279" },
    { 0xC2240197, "_k428" },
    { 0xFB89548E, "_k4283" },
    { 0x8981E553, "_k4286" },
    { 0xA57306DD, "_k4288" },
    { 0x9C21872E, "_k429" },
    { 0xF93A3FDC, "_k43" },
    { 0x123B93A4, "_k430" },
    { 0x78405EDC, "_k4300" },
    { 0x2C3B6A0A, "_k4306" },
    { 0x383E0E0D, "_k431" },
    { 0xAAD2D035, "_k4312" },
    { 0xC6C3F1BF, "_k4318" },
    { 0x5E408876, "_k432" },
    { 0xDB22587B, "_k4321" },
    { 0x844302DF, "_k433" },
    { 0x34F478BD, "_k4330" },
    { 0x76E814B0, "_k4335" },
    { 0x3F05D19C, "_k4339" },
    { 0x7A31AA00, "_k434" },
    { 0xACB964F8, "_k4348" },
    { 0xD2BBDF61, "_k4349" },
    { 0xA0342469, "_k435" },
    { 0x213F7244, "_k4357" },
    { 0xC6369ED2, "_k436" },
    { 0x95C57F90, "_k4366" },
    { 0xEC39193B, "_k437" },
    { 0x6A73336C, "_k4375" },
    { 0x424F66EC, "_k438" },
    { 0x56CD7550, "_k4384" },
    { 0x44EDACA5, "_k4389" },
    { 0x6851E155, "_k439" },
    { 0xFB6755E4, "_k4393" },
    { 0x9D829867, "_k4398" },
    { 0xD337C573, "_k44" },
    { 0x93A42D79, "_k440" },
    { 0x2AED0394, "_k4407" },
    { 0x6DA1B310, "_k441" },
    { 0x6924CCF6, "_k4416" },
    { 0xDFA9224B, "_k442" },
    { 0x7420C4BC, "_k4425" },
    { 0xB9A6A7E2, "_k443" },
    { 0x8381EF56, "_k4430" },
    { 0xEB7805B2, "_k4434" },
    { 0x2BAE171D, "_k444" },
    { 0x8E7DE71C, "_k4443" },
    { 0x05AB9CB4, "_k445" },
    { 0xCCB5B07E, "_k4452" },
    { 0x77B30BEF, "_k446" },
    { 0x17625B24, "_k4461" },
    { 0x51B09186, "_k447" },
    { 0xBECD6F62, "_k4470" },
    { 0xC3B800C1, "_k448" },
    { 0x3BD0D663, "_k4480" },
    { 0x9DB58658, "_k449" },
    { 0xA1484EAE, "_k4496" },
    { 0xAD354B0A, "_k45" },
    { 0xD55C146E, "_k450" },
    { 0x20233EF5, "_k4507" },
    { 0xFB5E8ED7, "_k451" },
    { 0x2CB335E5, "_k4510" },
    { 0x94A94C41, "_k4514" },
    { 0x89571F9C, "_k452" },
    { 0xD5B2494D, "_k4521" },
    { 0xFBB4C3B6, "_k4522" },
    { 0xDFC3A22C, "_k4528" },
    { 0xAF599A05, "_k453" },
    { 0x4B758B19, "_k4536" },
    { 0x257310B0, "_k4537" },
    { 0x3D522ACA, "_k454" },
    { 0x98D2CA17, "_k4541" },
    { 0x8EC17138, "_k4546" },
    { 0x6354A533, "_k455" },
    { 0x0B15EE50, "_k4551" },
    { 0x571AE322, "_k4553" },
    { 0xEF24CCC6, "_k4557" },
    { 0xF14D35F8, "_k456" },
    { 0x7E75A7B7, "_k4567" },
    { 0x9CE56752, "_k4579" },
    { 0xA5484126, "_k458" },
    { 0x77358282, "_k4580" },
    { 0x2B308DB0, "_k4582" },
    { 0xCB4ABB8F, "_k459" },
    { 0xA9C7F3DB, "_k4596" },
    { 0x25E0BBF5, "_k4598" },
    { 0x8732D0A1, "_k46" },
    { 0x2F84FF5A, "_k461" },
    { 0x098284F1, "_k462" },
    { 0xE3800A88, "_k463" },
    { 0xC8C49EB5, "_k4635" },
    { 0xED916367, "_k464" },
    { 0xC78EE8FE, "_k465" },
    { 0x1E6D4121, "_k4653" },
    { 0xA18C6E95, "_k466" },
    { 0xBA89C800, "_k4667" },
    { 0x7B89F42C, "_k467" },
    { 0x2573A67B, "_k468" },
    { 0xFF712C12, "_k469" },
    { 0x38F6D022, "_k4694" },
    { 0x61305638, "_k47" },
    { 0xD6F01398, "_k470" },
    { 0x1E7724D7, "_k4707" },
    { 0xFCF28E01, "_k471" },
    { 0x6CFAB7BA, "_k4711" },
    { 0x22F5086A, "_k472" },
    { 0xE180C506, "_k4728" },
    { 0x48F782D3, "_k473" },
    { 0x6EF9FD3C, "_k474" },
    { 0x94FC77A5, "_k475" },
    { 0xBAFEF20E, "_k476" },
    { 0x0AEC7C67, "_k4765" },
    { 0xE1016C77, "_k477" },
    { 0x0EA84EF8, "_k4775" },
    { 0xA6DC4050, "_k478" },
    { 0xCCDEBAB9, "_k479" },
    { 0x3B2DDBCF, "_k48" },
    { 0x5858AD6D, "_k480" },
    { 0x32563304, "_k481" },
    { 0xA45DA23F, "_k482" },
    { 0x7E5B27D6, "_k483" },
    { 0xC04EC3C9, "_k484" },
    { 0x648741BB, "_k4840" },
    { 0x9A4C4960, "_k485" },
    { 0x0C53B89B, "_k486" },
    { 0x886C80B5, "_k488" },
    { 0x626A064C, "_k489" },
    { 0x152B6166, "_k49" },
    { 0xD9C14742, "_k490" },
    { 0x04AABD85, "_k4914" },
    { 0x3C8D0099, "_k4918" },
    { 0x8DBC5270, "_k492" },
    { 0xF9AEC5BF, "_k4927" },
    { 0xB3BECCD9, "_k493" },
    { 0x71CB30E6, "_k494" },
    { 0x97CDAB4F, "_k495" },
    { 0x25C63C14, "_k496" },
    { 0x4BC8B67D, "_k497" },
    { 0x5FBE4758, "_k4977" },
    { 0x09D51A8A, "_k498" },
    { 0x2F3CC8CB, "_k4992" },
    { 0x824858F4, "_k5" },
    { 0xEB6D146C, "_k50" },
    { 0x1F761F27, "_k5003" },
    { 0x1564C648, "_k5004" },
    { 0xCE91F9DD, "_k501" },
    { 0x2D434A97, "_k5010" },
    { 0xF4947446, "_k502" },
    { 0xA997C7AF, "_k5025" },
    { 0x1A96EEAF, "_k503" },
    { 0x743422AC, "_k5039" },
    { 0x108595D0, "_k504" },
    { 0xB1D3E2C0, "_k5040" },
    { 0x36881039, "_k505" },
    { 0xA3AFECA6, "_k5055" },
    { 0x8A3D692D, "_k5063" },
    { 0x828D050B, "_k507" },
    { 0x2ED749C1, "_k5070" },
    { 0xD8A352BC, "_k508" },
    { 0xD93DEFB2, "_k5086" },
    { 0x116F8ED5, "_k51" },
    { 0x87B4E766, "_k5103" },
    { 0x01246B36, "_k511" },
    { 0x11F1A59A, "_k5118" },
    { 0xDB21F0CD, "_k512" },
    { 0xB51F7664, "_k513" },
    { 0x1705C257, "_k5133" },
    { 0x8F1CFBFB, "_k514" },
    { 0xF515E529, "_k5148" },
    { 0x691A8192, "_k515" },
    { 0x43180729, "_k516" },
    { 0xDBF5F749, "_k5162" },
    { 0x1D158CC0, "_k517" },
    { 0xA96385F0, "_k5170" },
    { 0x573AB8E7, "_k518" },
    { 0x26914AFA, "_k5187" },
    { 0x31383E7E, "_k519" },
    { 0x3772093E, "_k52" },
    { 0xA6FB804A, "_k520" },
    { 0x5AF68B78, "_k522" },
    { 0x80F905E1, "_k523" },
    { 0xA28AD31A, "_k5231" },
    { 0x3F0569EE, "_k524" },
    { 0x6507E457, "_k525" },
    { 0xF300751C, "_k526" },
    { 0x78347CD2, "_k5284" },
    { 0x9CEA276B, "_k529" },
    { 0x5D7483A7, "_k53" },
    { 0x2592E675, "_k530" },
    { 0xFF906C0C, "_k531" },
    { 0x7197DB47, "_k532" },
    { 0xC88369CD, "_k5328" },
    { 0x8D88FCD1, "_k534" },
    { 0x67868268, "_k535" },
    { 0xB24FC543, "_k5353" },
    { 0x103482C0, "_k5358" },
    { 0x34A2FDFF, "_k5379" },
    { 0xCF7C98C4, "_k539" },
    { 0x53632AC8, "_k54" },
    { 0x6D43FF68, "_k540" },
    { 0x198049C0, "_k5408" },
    { 0x934679D1, "_k541" },
    { 0xB948F43A, "_k542" },
    { 0xDF4B6EA3, "_k543" },
    { 0x2B506375, "_k545" },
    { 0x5152DDDE, "_k546" },
    { 0x77555847, "_k547" },
    { 0x3D302C20, "_k548" },
    { 0x6332A689, "_k549" },
    { 0x7965A531, "_k55" },
    { 0xEBDB6593, "_k550" },
    { 0xC5D8EB2A, "_k551" },
    { 0x9FD670C1, "_k552" },
    { 0x79D3F658, "_k553" },
    { 0x83E54F37, "_k554" },
    { 0x37E05A65, "_k556" },
    { 0x11DDDFFC, "_k557" },
    { 0xBBC7924B, "_k558" },
    { 0x95C517E2, "_k559" },
    { 0x235D60E0, "_k5596" },
    { 0x9F681F9A, "_k56" },
    { 0x6A72CBBE, "_k560" },
    { 0x712DAFCA, "_k5600" },
    { 0x90754627, "_k561" },
    { 0x1E6DD6EC, "_k562" },
    { 0x44705155, "_k563" },
    { 0xD268E21A, "_k564" },
    { 0xF86B5C83, "_k565" },
    { 0x8663ED48, "_k566" },
    { 0xAC6667B1, "_k567" },
    { 0x606172DF, "_k569" },
    { 0xC56A9A03, "_k57" },
    { 0xD222C3DF, "_k5704" },
    { 0x75FD0E1B, "_k572" },
    { 0x4FFA93B2, "_k573" },
    { 0xC20202ED, "_k574" },
    { 0x9BFF8884, "_k575" },
    { 0x0E06F7BF, "_k576" },
    { 0xE8047D56, "_k577" },
    { 0x5A0BEC91, "_k578" },
    { 0x34097228, "_k579" },
    { 0xBB594124, "_k58" },
    { 0x31F87F5C, "_k580" },
    { 0x7DFD742E, "_k582" },
    { 0xA3FFEE97, "_k583" },
    { 0x99EE95B8, "_k584" },
    { 0xBFF11021, "_k585" },
    { 0xE5F38A8A, "_k586" },
    { 0x0BF604F3, "_k587" },
    { 0x27E7267D, "_k589" },
    { 0xE15BBB8D, "_k59" },
    { 0xB08FE587, "_k590" },
    { 0x8A8D6B1E, "_k591" },
    { 0x648AF0B5, "_k592" },
    { 0x3E88764C, "_k593" },
    { 0x453F43B0, "_k5934" },
    { 0x1885FBE3, "_k594" },
    { 0xF283817A, "_k595" },
    { 0x807C123F, "_k598" },
    { 0xA8212E4D, "_k60" },
    { 0x596389C7, "_k600" },
    { 0xC63106F1, "_k6004" },
    { 0x33610F5E, "_k601" },
    { 0x0D5E94F5, "_k602" },
    { 0xE75C1A8C, "_k603" },
    { 0xC159A023, "_k604" },
    { 0xFAAA0D0D, "_k6044" },
    { 0xD4A792A4, "_k6045" },
    { 0x9B5725BA, "_k605" },
    { 0x7554AB51, "_k606" },
    { 0x4F5230E8, "_k607" },
    { 0x294FB67F, "_k608" },
    { 0x034D3C16, "_k609" },
    { 0x821EB3E4, "_k61" },
    { 0xDACC239C, "_k610" },
    { 0x00CE9E05, "_k611" },
    { 0x26D1186E, "_k612" },
    { 0x4CD392D7, "_k613" },
    { 0x42C239F8, "_k614" },
    { 0xB4C9A933, "_k617" },
    { 0x04579E5D, "_k6174" },
    { 0xD0BACABD, "_k619" },
    { 0xF426231F, "_k62" },
    { 0x97803D7D, "_k620" },
    { 0x717DC314, "_k621" },
    { 0x8517D568, "_k6214" },
    { 0xE385324F, "_k622" },
    { 0xBD82B7E6, "_k623" },
    { 0xFF7653D9, "_k624" },
    { 0xD973D970, "_k625" },
    { 0x4B7B48AB, "_k626" },
    { 0x86ABD492, "_k6274" },
    { 0xC79410C5, "_k628" },
    { 0xA191965C, "_k629" },
    { 0xCE23A8B6, "_k63" },
    { 0x17ABA2D2, "_k630" },
    { 0x3DAE1D3B, "_k631" },
    { 0x0D9E95C8, "_k6311" },
    { 0xCBA6AE00, "_k632" },
    { 0xF1A92869, "_k633" },
    { 0xAFB58C76, "_k634" },
    { 0xD5B806DF, "_k635" },
    { 0x89B3120D, "_k637" },
    { 0x6DC1F083, "_k639" },
    { 0x101744A9, "_k64" },
    { 0x37C64232, "_k641" },
    { 0x11C3C7C9, "_k642" },
    { 0xEBC14D60, "_k643" },
    { 0xF5D2A63F, "_k644" },
    { 0xCFD02BD6, "_k645" },
    { 0xA9CDB16D, "_k646" },
    { 0x83CB3704, "_k647" },
    { 0x8DDC8FE3, "_k648" },
    { 0x67DA157A, "_k649" },
    { 0x7C79F007, "_k6491" },
    { 0xEA14CA40, "_k65" },
    { 0xDF315670, "_k650" },
    { 0x80E90691, "_k6509" },
    { 0x0533D0D9, "_k651" },
    { 0x5138C5AB, "_k653" },
    { 0x773B4014, "_k654" },
    { 0x9D3DBA7D, "_k655" },
    { 0xC34034E6, "_k656" },
    { 0xE942AF4F, "_k657" },
    { 0x3547A421, "_k659" },
    { 0x5C1C397B, "_k66" },
    { 0x5AF788F1, "_k660" },
    { 0x34F50E88, "_k661" },
    { 0x3BDC2DC9, "_k6619" },
    { 0xF3017295, "_k664" },
    { 0xCCFEF82C, "_k665" },
    { 0x1903ECFE, "_k667" },
    { 0x2AE3B5A9, "_k668" },
    { 0x3619BF12, "_k67" },
    { 0xDC6022C6, "_k670" },
    { 0x02629D2F, "_k671" },
    { 0x44563922, "_k674" },
    { 0x6A58B38B, "_k675" },
    { 0xF8514450, "_k676" },
    { 0x0C73F60E, "_k678" },
    { 0x32767077, "_k679" },
    { 0xD8350195, "_k68" },
    { 0xCFFA89DF, "_k680" },
    { 0xA9F80F76, "_k681" },
    { 0x5DF31AA4, "_k683" },
    { 0x37F0A03B, "_k684" },
    { 0x85BB689D, "_k6853" },
    { 0xEBEBAB69, "_k686" },
    { 0xC5E93100, "_k687" },
    { 0xD4919119, "_k6871" },
    { 0x000E5D27, "_k688" },
    { 0xDA0BE2BE, "_k689" },
    { 0xB736CE6E, "_k6894" },
    { 0xB232872C, "_k69" },
    { 0x516323B4, "_k690" },
    { 0x77659E1D, "_k691" },
    { 0x326EDB57, "_k6910" },
    { 0x9D681886, "_k692" },
    { 0xB9593A10, "_k694" },
    { 0x055E2EE2, "_k696" },
    { 0x2B60A94B, "_k697" },
    { 0x8176F6FC, "_k698" },
    { 0x2989C822, "_k70" },
    { 0xE60DB416, "_k700" },
    { 0x0C102E7F, "_k701" },
    { 0x9A08BF44, "_k702" },
    { 0xC00B39AD, "_k703" },
    { 0x4E03CA72, "_k704" },
    { 0x740644DB, "_k705" },
    { 0x28015009, "_k707" },
    { 0x1621875E, "_k708" },
    { 0x3C2401C7, "_k709" },
    { 0x4F8C428B, "_k71" },
    { 0x3EA29FD8, "_k711" },
    { 0xB0AA0F13, "_k712" },
    { 0x8AA794AA, "_k713" },
    { 0xFCAF03E5, "_k714" },
    { 0xD6AC897C, "_k715" },
    { 0x48B3F8B7, "_k716" },
    { 0x22B17E4E, "_k717" },
    { 0x349146F9, "_k718" },
    { 0x0E8ECC90, "_k719" },
    { 0xDD84D350, "_k72" },
    { 0x0DA42DA9, "_k721" },
    { 0x33A6A812, "_k722" },
    { 0x7FAB9CE4, "_k724" },
    { 0xA5AE174D, "_k725" },
    { 0xCBB091B6, "_k726" },
    { 0xF1B30C1F, "_k727" },
    { 0x17B58688, "_k728" },
    { 0x03874DB9, "_k73" },
    { 0x67764DEB, "_k730" },
    { 0x1B715919, "_k732" },
    { 0xF56EDEB0, "_k733" },
    { 0xFF80378F, "_k734" },
    { 0xD97DBD26, "_k735" },
    { 0xB37B42BD, "_k736" },
    { 0x8D78C854, "_k737" },
    { 0x978A2133, "_k738" },
    { 0x7187A6CA, "_k739" },
    { 0xC193B1C6, "_k74" },
    { 0x21593422, "_k740" },
    { 0xD5543F50, "_k742" },
    { 0xFB56B9B9, "_k743" },
    { 0xB9631DC6, "_k744" },
    { 0xDF65982F, "_k745" },
    { 0x6D5E28F4, "_k746" },
    { 0x9360A35D, "_k747" },
    { 0x516D076A, "_k748" },
    { 0x776F81D3, "_k749" },
    { 0x9FF09A4D, "_k750" },
    { 0x79EE1FE4, "_k751" },
    { 0xC5F314B6, "_k753" },
    { 0xE1E43640, "_k755" },
    { 0x2DE92B12, "_k757" },
    { 0xAA01F32C, "_k759" },
    { 0x758EBCF4, "_k76" },
    { 0xE33C806C, "_k760" },
    { 0x093EFAD5, "_k761" },
    { 0x2F41753E, "_k762" },
    { 0x5543EFA7, "_k763" },
    { 0x4B3296C8, "_k764" },
    { 0x71351131, "_k765" },
    { 0x97378B9A, "_k766" },
    { 0xBD3A0603, "_k767" },
    { 0xD92B278D, "_k769" },
    { 0x9B91375D, "_k77" },
    { 0x63111B17, "_k770" },
    { 0x170C2645, "_k772" },
    { 0xF109ABDC, "_k773" },
    { 0xA504B70A, "_k775" },
    { 0x7F023CA1, "_k776" },
    { 0x32FD47CF, "_k778" },
    { 0x0CFACD66, "_k779" },
    { 0x1CF4014E, "_k780" },
    { 0xD0EF0C7C, "_k782" },
    { 0xF6F186E5, "_k783" },
    { 0x84EA17AA, "_k784" },
    { 0xAAEC9213, "_k785" },
    { 0x38E522D8, "_k786" },
    { 0xD531C28A, "_k7862" },
    { 0x12E2A86F, "_k789" },
    { 0x7FA015D3, "_k79" },
    { 0xDC794ED9, "_k790" },
    { 0xB676D470, "_k791" },
    { 0x287E43AB, "_k792" },
    { 0x7483387D, "_k794" },
    { 0xC0882D4F, "_k796" },
    { 0x9A85B2E6, "_k797" },
    { 0xE68AA7B8, "_k799" },
    { 0x4054BD01, "_k8" },
    { 0xA68D2F23, "_k80" },
    { 0x32CA4069, "_k800" },
    { 0x0CC7C600, "_k801" },
    { 0x7ECF353B, "_k802" },
    { 0x58CCBAD2, "_k803" },
    { 0x16D91EDF, "_k806" },
    { 0xF0D6A476, "_k807" },
    { 0x62DE13B1, "_k808" },
    { 0x3CDB9948, "_k809" },
    { 0x808AB4BA, "_k81" },
    { 0x7482275E, "_k810" },
    { 0x9A84A1C7, "_k811" },
    { 0x287D328C, "_k812" },
    { 0x4E7FACF5, "_k813" },
    { 0xDC783DBA, "_k814" },
    { 0x027AB823, "_k815" },
    { 0x907348E8, "_k816" },
    { 0xB675C351, "_k817" },
    { 0x446E5416, "_k818" },
    { 0x6A70CE7F, "_k819" },
    { 0x5A883A51, "_k82" },
    { 0xF5EAC133, "_k820" },
    { 0xCFE846CA, "_k821" },
    { 0xA9E5CC61, "_k822" },
    { 0x8DF4AAD7, "_k824" },
    { 0x56F76041, "_k8244" },
    { 0x67F2306E, "_k825" },
    { 0x41EFB605, "_k826" },
    { 0x1BED3B9C, "_k827" },
    { 0xC5D6EDEB, "_k828" },
    { 0x9FD47382, "_k829" },
    { 0x3485BFE8, "_k83" },
    { 0x76162688, "_k830" },
    { 0x9C18A0F1, "_k831" },
    { 0xE81D95C3, "_k833" },
    { 0x0E20102C, "_k834" },
    { 0x34228A95, "_k835" },
    { 0x5A2504FE, "_k836" },
    { 0x46025340, "_k838" },
    { 0x6C04CDA9, "_k839" },
    { 0x3E9718C7, "_k84" },
    { 0x546787FE, "_k843" },
    { 0x965B23F1, "_k844" },
    { 0x7058A988, "_k845" },
    { 0xE26018C3, "_k846" },
    { 0xFE513A4D, "_k848" },
    { 0xD84EBFE4, "_k849" },
    { 0x18949E5E, "_k85" },
    { 0xAFCDA76A, "_k850" },
    { 0x63C8B298, "_k852" },
    { 0x47D7910E, "_k854" },
    { 0x6DDA0B77, "_k855" },
    { 0xFBD29C3C, "_k856" },
    { 0x21D516A5, "_k857" },
    { 0x7FB9D422, "_k858" },
    { 0xA5BC4E8B, "_k859" },
    { 0xF29223F5, "_k86" },
    { 0x3136413F, "_k860" },
    { 0xBF2ED204, "_k863" },
    { 0x992C579B, "_k864" },
    { 0x2724E860, "_k867" },
    { 0x3B479A1E, "_k869" },
    { 0xCC8FA98C, "_k87" },
    { 0xD8A1557D, "_k871" },
    { 0x1A94F170, "_k874" },
    { 0x40976BD9, "_k875" },
    { 0x8C9C60AB, "_k877" },
    { 0xE2B2AE5C, "_k878" },
    { 0x08B528C5, "_k879" },
    { 0x76795BDB, "_k88" },
    { 0xBC334051, "_k880" },
    { 0x9630C5E8, "_k881" },
    { 0xE235BABA, "_k883" },
    { 0x543D29F5, "_k884" },
    { 0x2E3AAF8C, "_k885" },
    { 0xA0421EC7, "_k886" },
    { 0x7A3FA45E, "_k887" },
    { 0x8C1F6D09, "_k888" },
    { 0x5076E172, "_k89" },
    { 0x3D9BDA26, "_k890" },
    { 0x639E548F, "_k891" },
    { 0xF196E554, "_k892" },
    { 0x17995FBD, "_k893" },
    { 0xA591F082, "_k894" },
    { 0xCB946AEB, "_k895" },
    { 0x93B227D7, "_k899" },
    { 0x1A524298, "_k9" },
    { 0x27F5C8F8, "_k90" },
    { 0x7FC3B7D8, "_k900" },
    { 0xA5C63241, "_k901" },
    { 0xF1CB2713, "_k903" },
    { 0x17CDA17C, "_k904" },
    { 0x3DD01BE5, "_k905" },
    { 0x63D2964E, "_k906" },
    { 0x89D510B7, "_k907" },
    { 0x75B25EF9, "_k909" },
    { 0x4DF84361, "_k91" },
    { 0xFE5B1E03, "_k910" },
    { 0xD858A39A, "_k911" },
    { 0xB2562931, "_k912" },
    { 0x8C53AEC8, "_k913" },
    { 0x70628D3E, "_k915" },
    { 0x245D986C, "_k917" },
    { 0xCE474ABB, "_k918" },
    { 0x73FABDCA, "_k92" },
    { 0x7E2FB8AE, "_k920" },
    { 0xA4323317, "_k921" },
    { 0x322AC3DC, "_k922" },
    { 0x582D3E45, "_k923" },
    { 0xE625CF0A, "_k924" },
    { 0x0C284973, "_k925" },
    { 0xC02354A1, "_k927" },
    { 0x4E1BE566, "_k928" },
    { 0x741E5FCF, "_k929" },
    { 0x99FD3833, "_k93" },
    { 0x3C77D1B9, "_k930" },
    { 0x16755750, "_k931" },
    { 0x887CC68B, "_k932" },
    { 0x627A4C22, "_k933" },
    { 0xAE7F40F4, "_k935" },
    { 0x2086B02F, "_k936" },
    { 0xFA8435C6, "_k937" },
    { 0x6C8BA501, "_k938" },
    { 0x46892A98, "_k939" },
    { 0xBFFFB29C, "_k94" },
    { 0xE111B24D, "_k941" },
    { 0x07142CB6, "_k942" },
    { 0x2D16A71F, "_k943" },
    { 0x4907C8A9, "_k945" },
    { 0x6F0A4312, "_k946" },
    { 0x950CBD7B, "_k947" },
    { 0xEB230B2C, "_k948" },
    { 0x11258595, "_k949" },
    { 0xE6022D05, "_k95" },
    { 0x3AE3D28F, "_k950" },
    { 0x14E15826, "_k951" },
    { 0xEEDEDDBD, "_k952" },
    { 0xC8DC6354, "_k953" },
    { 0x7CD76E82, "_k955" },
    { 0x30D279B0, "_k957" },
    { 0x6AF7A5D7, "_k958" },
    { 0x0C04A76E, "_k96" },
    { 0xB97B38BA, "_k960" },
    { 0x6D7643E8, "_k962" },
    { 0x9378BE51, "_k963" },
    { 0x77879CC7, "_k965" },
    { 0x05802D8C, "_k966" },
    { 0x2B82A7F5, "_k967" },
    { 0x89676572, "_k968" },
    { 0xAF69DFDB, "_k969" },
    { 0x320721D7, "_k97" },
    { 0x26E6E587, "_k9744" },
    { 0xEC0DAA13, "_k976" },
    { 0xC60B2FAA, "_k977" },
    { 0x07FECB9D, "_k978" },
    { 0xE1FC5134, "_k979" },
    { 0xF7E1F5B0, "_k98" },
    { 0x48DD6AA0, "_k980" },
    { 0xBAE4D9DB, "_k983" },
    { 0x06E9CEAD, "_k985" },
    { 0x52EEC37F, "_k987" },
    { 0x9EF3B851, "_k989" },
    { 0x1DE47019, "_k99" },
    { 0xC774D0CB, "_k990" },
    { 0xA1725662, "_k991" },
    { 0x7B6FDBF9, "_k992" },
    { 0x556D6190, "_k993" },
    { 0x5F7EBA6F, "_k994" },
    { 0x1379C59D, "_k996" },
    { 0xED774B34, "_k997" },
    { 0xF788A413, "_k998" },
    { 0x5C3780B5, "_karma_utility" },
    { 0x9D8FE8CC, "_katyusha" },
    { 0x4C8644C9, "_kicked_meat" },
    { 0x6B15CE04, "_kicking_meat" },
    { 0x1A8EA470, "_kill" },
    { 0x742A9D25, "_kill_ai" },
    { 0xD77DF0E3, "_kill_all_queued_dialog" },
    { 0x4170886C, "_kill_detonator_watcher" },
    { 0xDD6BB2C3, "_kill_dist" },
    { 0x88C9D07E, "_kill_drones_after_convoy_passes" },
    { 0xF350A538, "_kill_end_of_round_monitor" },
    { 0xB05318AB, "_kill_goal_line" },
    { 0x9F11D3CC, "_kill_guard_stealth_vo" },
    { 0x4AC06829, "_kill_on_ent_death" },
    { 0x06285D24, "_kill_progress_bar" },
    { 0xD1C24146, "_kill_time_bomb_enemy" },
    { 0x88E39F67, "_kill_water_fx_actor" },
    { 0xA9A32203, "_kill_water_fx_model" },
    { 0xF0759766, "_kill_zombie_network_safe_internal" },
    { 0x7DAEE49D, "_killcam" },
    { 0x4C721803, "_killed" },
    { 0xADF9E703, "_killing_squad" },
    { 0x327170FC, "_killstreak_bundles" },
    { 0xF57F0740, "_killstreak_detect" },
    { 0x474C3AB2, "_killstreak_hacking" },
    { 0x48C68914, "_killstreak_weapons" },
    { 0x33EEA36F, "_killstreakrules" },
    { 0x01D94E19, "_killstreaks" },
    { 0x3CE9CA5F, "_lander_endarray" },
    { 0x9B458898, "_last_black_hole_dist" },
    { 0xDF63FA83, "_last_collision_time" },
    { 0x4E7766B0, "_last_draw_target_fx" },
    { 0xC53BBE96, "_last_fire_tag" },
    { 0x57321185, "_last_person_to_throw_meat" },
    { 0x40510AD3, "_last_person_to_throw_meat_time" },
    { 0x9D8034D5, "_last_side_warning_in_seconds" },
    { 0xE68FF12D, "_last_stage_started" },
    { 0xFFD623F5, "_last_visionset" },
    { 0xAC494ECC, "_lastanimtime" },
    { 0xB31653FC, "_lastmusicstate" },
    { 0x682D2753, "_lastplayed_drone_taunt" },
    { 0x8F9CC7D0, "_laststand" },
    { 0x24E07636, "_launch_ai" },
    { 0xBD4AE3EA, "_launch_drone" },
    { 0xF9030226, "_launched" },
    { 0x5B04FFB5, "_leak" },
    { 0xEF4379EA, "_leak_methods" },
    { 0x6F45F828, "_leapfrog" },
    { 0x94D79643, "_left" },
    { 0xED5687BF, "_leftstrap" },
    { 0x10623FBF, "_lerp_shader_constant_" },
    { 0x59E2F241, "_level_attach_banned" },
    { 0xF5C14B66, "_levelspecificambient" },
    { 0x0BB599E6, "_lid_close_sound" },
    { 0x3A3D9A6C, "_light" },
    { 0x21BF807F, "_light_accept" },
    { 0x57A3D42B, "_light_spot" },
    { 0x31B990EA, "_light_types" },
    { 0x62433DFA, "_lighthouse_owned" },
    { 0xD0A4315B, "_lighting_exploders" },
    { 0x310A0656, "_lightning" },
    { 0x23AB19C0, "_lightninggun" },
    { 0xAC3B466F, "_lights" },
    { 0xDE750BFB, "_limited_equipment" },
    { 0x799328BE, "_line" },
    { 0xCC2D4362, "_lines_being_spoken" },
    { 0x7791E57E, "_link_node_list" },
    { 0xCD0D68E2, "_link_to_player_model" },
    { 0x164EF7B5, "_linked_ent" },
    { 0xC841BC06, "_linked_ent_moves" },
    { 0xA9E09831, "_linked_ent_offset" },
    { 0x05C108D5, "_linker" },
    { 0x8D37A6AB, "_linkto" },
    { 0x36AB7E4B, "_listen_for_damage_on_actor" },
    { 0x8AF86ECD, "_littlebird" },
    { 0xCFFA081E, "_livingroom" },
    { 0xFD731264, "_load" },
    { 0xA9C838B0, "_load_common" },
    { 0xA8BEDDCF, "_load_done" },
    { 0x93AB204A, "_load_female_scene" },
    { 0xACB4A9B0, "_loadout" },
    { 0x31868693, "_loadstarted" },
    { 0xD2BD0484, "_localclientnum" },
    { 0x0F005BEB, "_location_indicator" },
    { 0x3550CE38, "_lockonmissileturret" },
    { 0xBCBDE749, "_log_dialog" },
    { 0xA6E5ADD8, "_log_dialog_colors" },
    { 0x5E2AA960, "_log_dialog_get_color" },
    { 0x362E9D6A, "_loop" },
    { 0x58E3D169, "_loop_fake_fire" },
    { 0x4FE8E0CC, "_loop_text" },
    { 0xB33703D4, "_luxurysedan" },
    { 0x3B353728, "_m1a1" },
    { 0xEE31D7A5, "_magic_box_used_vo" },
    { 0x15563DDD, "_make_aware" },
    { 0x150898B8, "_make_random_character" },
    { 0x7B6D6B0B, "_mannequin_unfreeze_ragdoll" },
    { 0x8AD7149E, "_mannequin_update_freeze" },
    { 0x9B5D7667, "_margwa_damage_cb" },
    { 0x4EEEA431, "_market_clear_logic" },
    { 0x3D426B79, "_market_exit_internal" },
    { 0x26314159, "_market_sm_func_fallback" },
    { 0x4CCBD928, "_market_sm_func_rusher" },
    { 0xAAB6C507, "_mason_ai" },
    { 0x7B29E878, "_mason_lookspot" },
    { 0xCE3CC39C, "_master_patroller" },
    { 0xAEEBF1B3, "_matchdata" },
    { 0x0CC91920, "_max_enemy_targets" },
    { 0x224CF4F9, "_max_script_health" },
    { 0xD3CDDB25, "_maze" },
    { 0x785E41AB, "_maze_achievement_think_done" },
    { 0xE38C796C, "_mbs" },
    { 0x66C1DE52, "_meat_callback_initialized" },
    { 0xBE0DDE3E, "_meat_fx" },
    { 0x11362FFD, "_meat_hint_shown" },
    { 0x3EFA07EF, "_meat_icon" },
    { 0x5FCDEC99, "_meat_location" },
    { 0x45A3FDD6, "_meat_moving" },
    { 0xB63ECE5D, "_meat_on_team" },
    { 0x21667133, "_meat_player_tracker_origin" },
    { 0x942B038D, "_meat_splitter_activated" },
    { 0x1FBDC2A3, "_meat_start_point" },
    { 0xD5F7308F, "_meat_team" },
    { 0x2F7755E8, "_meat_team_1_volume" },
    { 0x603406DE, "_meat_team_1_zombie_spawn_points" },
    { 0x37251711, "_meat_team_2_volume" },
    { 0x7278D319, "_meat_team_2_zombie_spawn_points" },
    { 0x797A2617, "_meat_zombie_spawn_health" },
    { 0x3C671D10, "_meat_zombie_spawn_timer" },
    { 0xADE9D46E, "_meat_zombie_spawning" },
    { 0xB70A153E, "_meatshield" },
    { 0x615BCFCA, "_meatshield_bulletcam" },
    { 0x52322F87, "_meatshield_clamp_d" },
    { 0x221E5C3F, "_meatshield_clamp_l" },
    { 0xCE4AF7A1, "_meatshield_clamp_r" },
    { 0x8C575BAE, "_meatshield_clamp_u" },
    { 0xBFD464C4, "_meatshield_enable_ear_blood" },
    { 0xDE0A96C7, "_meatshield_flag_funcs" },
    { 0xA5CEBF75, "_meatshield_gun_offset" },
    { 0x4114B58F, "_meatshield_kill_player" },
    { 0x548F5A57, "_meatshield_no_weapon_management" },
    { 0xDC2F5589, "_meatshield_targets" },
    { 0xBC53B5EC, "_meatshield_timer" },
    { 0xE0BE9855, "_meatshield_viewmodel" },
    { 0x18EF915D, "_meatshield_weapon" },
    { 0x237560DC, "_meatshiled" },
    { 0xADD93F1D, "_mechz_face" },
    { 0xE11ABFD8, "_medals" },
    { 0xB88CBB64, "_melee" },
    { 0xE480BC3E, "_melee_dist_sq" },
    { 0xD2A2B6AC, "_melee_ignore_angle_override" },
    { 0x70894886, "_melee_weapons" },
    { 0xB12EC5D5, "_menu" },
    { 0xAE847124, "_menus" },
    { 0x74B5A79F, "_metal_storm" },
    { 0x2C28B2DE, "_mg_penetration" },
    { 0xC66A511F, "_mganim" },
    { 0xE9C6BA8E, "_mgturret" },
    { 0xE452BDA6, "_mi17" },
    { 0xAEC7A3AE, "_mi17_noai" },
    { 0x397E6C70, "_mi28" },
    { 0x34D6CC74, "_mi28_bulletdamage" },
    { 0xE82F5628, "_microwave_turret" },
    { 0x0F5376CE, "_microwaveable_objects" },
    { 0x7DC68FFA, "_microwavegun_hit_response_fx" },
    { 0xFE89E94D, "_mig17" },
    { 0x78241356, "_mig29" },
    { 0x395931F7, "_min_dist" },
    { 0x14098C96, "_minefields" },
    { 0xF1EB1CB7, "_minigun_icon" },
    { 0x14E2E4C2, "_minigun_ring" },
    { 0x6AF44B57, "_minigun_ring_clip" },
    { 0x54A3E0C3, "_minigun_ring_trig" },
    { 0xAAF26A12, "_minigun_time_override" },
    { 0x832E4337, "_minigun_toss_cooldown" },
    { 0x02A78B93, "_missile_drone" },
    { 0xB5FE5EDD, "_missile_swarm" },
    { 0xEFFBFE10, "_missiledetonate" },
    { 0x4078D293, "_missing_dialog" },
    { 0xD86BE27A, "_mission" },
    { 0x13CA10D3, "_mission_accomplished" },
    { 0xE55C17F5, "_missions" },
    { 0x4E44D667, "_model" },
    { 0x2387A51E, "_model3" },
    { 0x4ACDDC3C, "_model_is_exempt" },
    { 0x3FB3632D, "_module_connect_hud" },
    { 0xC2474B17, "_module_round_hud" },
    { 0xCD7E005C, "_money" },
    { 0x2126A4F7, "_monitor_tracker" },
    { 0x9E0586F5, "_monitor_zombie_total_init" },
    { 0xAAEACE69, "_monkey_add_time" },
    { 0x71FFAC8D, "_monkey_bindpowerup" },
    { 0xCFCF9D1F, "_monkey_checkplayablearea" },
    { 0x82D978BF, "_monkey_destroyboards" },
    { 0xCA8890F0, "_monkey_dropstolenpowerup" },
    { 0x52F2C4CF, "_monkey_escape" },
    { 0xBBA2E43A, "_monkey_getspawnlocation" },
    { 0xF6EABEA0, "_monkey_gib" },
    { 0x94555914, "_monkey_gotoboards" },
    { 0x4155FDF4, "_monkey_grabpowerup" },
    { 0x5933FD4D, "_monkey_grap_powerup_wait" },
    { 0xF559AE39, "_monkey_lander_fx" },
    { 0xED197E19, "_monkey_pathcheck" },
    { 0x4E62C5F7, "_monkey_play_stolen_loop" },
    { 0x038519F2, "_monkey_remove" },
    { 0x9BB734C9, "_monkey_stealpowerup" },
    { 0x00FD20EB, "_monkey_temple_dragons_breath_flame_death_fx" },
    { 0x96FB0DDD, "_monkey_templefling" },
    { 0x5E58815D, "_monkey_templesliding" },
    { 0xADE5BBF8, "_monkey_templethinkinternal" },
    { 0xE686E2AF, "_monkey_timeout" },
    { 0x750F7248, "_monkey_watch_for_death" },
    { 0xB0B5EA7A, "_monkey_zombie_grenade_watcher" },
    { 0x25701B8E, "_monkey_zombietempledeathcallback" },
    { 0x7B7753A1, "_monkey_zombietempleescapedeathcallback" },
    { 0x03EF0FF7, "_montitor_loadout" },
    { 0xF06E1F89, "_moon_biodome_vision_set" },
    { 0x58AFA8E4, "_moon_biodome_vision_set_priority" },
    { 0xD37755FE, "_moon_exterior_vision_set" },
    { 0x069A45F5, "_moon_exterior_vision_set_priority" },
    { 0xC51DF432, "_moon_hanger18_vision_set" },
    { 0x137963B9, "_moon_hanger18_vision_set_priority" },
    { 0x93108045, "_moon_hellearth_vision_set" },
    { 0xF724AD20, "_moon_hellearth_vision_set_priority" },
    { 0xAD0C78FC, "_moon_interior_vision_set" },
    { 0x1BE1DECF, "_moon_interior_vision_set_priority" },
    { 0x0D88A7E9, "_moon_jumps" },
    { 0x2392220B, "_moon_tunnels_vision_set" },
    { 0x7A51B582, "_moon_tunnels_vision_set_priority" },
    { 0x80CB5297, "_mortar" },
    { 0xAA7A396A, "_mortar_enemies_called" },
    { 0xECB5732C, "_mortarteam" },
    { 0x77C805A7, "_motorcycle" },
    { 0x62BFC000, "_motorcycle_audio" },
    { 0xA777075B, "_motorcycle_lapd" },
    { 0x71EB10B4, "_motorcycle_ride" },
    { 0x08686C77, "_motorcycle_ride_audio" },
    { 0xD92F6478, "_mountains" },
    { 0xE5F52317, "_move_all_stairs_down" },
    { 0xAA9A7F48, "_move_all_stairs_up" },
    { 0x5A597A6A, "_move_down" },
    { 0x2E46AC53, "_move_pap_mover" },
    { 0x80F65F2D, "_move_pap_mover_wait" },
    { 0x69B857A1, "_move_up" },
    { 0x6D09330C, "_move_visual_timer" },
    { 0x758DCC7B, "_movephalanxtier" },
    { 0x8111FADB, "_mover_get_origin" },
    { 0x8F4B84CF, "_mp" },
    { 0x762CFF58, "_mpla_unita" },
    { 0x0358E5C9, "_multi_extracam" },
    { 0x80231E49, "_music" },
    { 0xC7F50017, "_musicalias" },
    { 0x0ECFEC19, "_musicaliasloop" },
    { 0x538DB95C, "_my_last_weapon" },
    { 0x5FEE242F, "_my_pulsing_hud" },
    { 0xD70145A3, "_my_spawn_origin" },
    { 0x92A9A44E, "_my_speed" },
    { 0xB81CA681, "_my_vehicle_flag_handler" },
    { 0x339AA0C1, "_my_wave_node" },
    { 0x8D91AE2B, "_mytextdisplay" },
    { 0x54274182, "_n_array_flag_wait_any_calls" },
    { 0x49FDFB70, "_n_clientnum" },
    { 0x8CEC9E34, "_n_object_id" },
    { 0x51963144, "_n_request_time" },
    { 0xCDE53B4C, "_n_rockets" },
    { 0x663200AD, "_n_streamer_req" },
    { 0xEF79CA3F, "_nag_line" },
    { 0xF9F9B029, "_name" },
    { 0x1A91EDA0, "_names" },
    { 0xF64B6409, "_names_index" },
    { 0xC5F27CAB, "_napalm" },
    { 0x993A7C00, "_network_intruder" },
    { 0xF2C9D08C, "_network_safe_play_fx" },
    { 0x72DAA21D, "_network_safe_play_fx_on_tag" },
    { 0xDF58B72A, "_network_safe_spawn" },
    { 0xA06B4F7E, "_network_safe_stalingrad_spawn" },
    { 0xA9E8D754, "_new_beam" },
    { 0x3A8FD71E, "_new_ground_trace" },
    { 0x777F30DA, "_next_light_id" },
    { 0xA26BB201, "_nextcoverprint" },
    { 0xD5D6564F, "_nextmission" },
    { 0xE9D9064A, "_nightvision" },
    { 0x65A369F2, "_no_equipment_activated_clientfield" },
    { 0xF8683AFC, "_no_navcards" },
    { 0x4B56B872, "_no_static_unitriggers" },
    { 0xA6D8228C, "_no_vending_machine_auto_collision" },
    { 0x34932470, "_no_vending_machine_bump_trigs" },
    { 0x4EF145AE, "_no_water_risers" },
    { 0x0D774A5B, "_noai" },
    { 0xCE192D14, "_node" },
    { 0xD86FA687, "_nodes" },
    { 0x57D8F7A6, "_none" },
    { 0x4D88C921, "_normal_run_blend_time" },
    { 0x7B3E308F, "_normal_speed_control" },
    { 0x41322217, "_normals_killed_during_mortars" },
    { 0xC0D28069, "_north" },
    { 0x497358BA, "_northeast" },
    { 0x1F1EAADC, "_northwest" },
    { 0x791DCD40, "_not_moving" },
    { 0x3EE2B779, "_notetrack" },
    { 0xC506BD68, "_notetrack_handler" },
    { 0xAF7F855A, "_notify_death_when_sea_cowbell_stops" },
    { 0x0F27CEBE, "_notify_target_died" },
    { 0xD6E5EE96, "_notify_target_lost" },
    { 0x43877390, "_notsolid" },
    { 0xE8406403, "_nukepoint" },
    { 0x4BF06607, "_null" },
    { 0xE2E87DD0, "_num" },
    { 0xBA2F6E85, "_num_attack_vox" },
    { 0xC5DEFB4B, "_num_gongs" },
    { 0x1E242BB2, "_num_launches" },
    { 0x0EBD7662, "_num_lit_destructibles" },
    { 0x7BE017B3, "_num_local_players" },
    { 0x771F29C4, "_num_overriden_models" },
    { 0x8D10CA46, "_num_registered_game_modules" },
    { 0x9C3EC150, "_num_wetness" },
    { 0x5508EEB3, "_number" },
    { 0x794710DB, "_numrockets" },
    { 0x411653A6, "_numtriggerspawned" },
    { 0x96898770, "_numzmbaivox" },
    { 0xC2EC2A2F, "_numzombeyeglows" },
    { 0x190B1EA2, "_o_bundle" },
    { 0x53B3F102, "_o_scene" },
    { 0xACFB32D5, "_objective_perk_volume" },
    { 0x61EF7A5A, "_objective_set3d_prethink_flash" },
    { 0x68631E8A, "_objective_set_position" },
    { 0x826DFBD0, "_objectives" },
    { 0x7F320782, "_objpoints" },
    { 0xF85BA49C, "_oed" },
    { 0x0251E7CF, "_off" },
    { 0x25BC96D4, "_off_ground_max" },
    { 0x2ABF7729, "_og_angles" },
    { 0xC3E876C7, "_og_origin" },
    { 0xB02864D8, "_old_drawdist" },
    { 0x9617BC7B, "_oldschool" },
    { 0xB039E27B, "_on" },
    { 0x208F989E, "_on_alert_run_scene_thread" },
    { 0x5D2FEC30, "_on_connect" },
    { 0x6BFE1AC1, "_on_damage_run_scene_thread" },
    { 0xA5418E00, "_on_death" },
    { 0x8D01EFB6, "_on_flicker" },
    { 0xBDB47551, "_on_give" },
    { 0x665C78F1, "_on_kill_pending_dialog" },
    { 0x39EA6A1B, "_on_take" },
    { 0xAE1C7AD1, "_one_screen_fade_per_network_frame" },
    { 0x1A45F824, "_oob" },
    { 0xFAC5A509, "_opponent_death_watcher" },
    { 0x79B7D925, "_optionalextranumber" },
    { 0x719A8C10, "_optionalstepeffects" },
    { 0x4CB72BE4, "_order_new_squad" },
    { 0x96419BFA, "_org" },
    { 0xDAF7C236, "_origin" },
    { 0x8EDFEED9, "_original_fov" },
    { 0xC506DBD7, "_original_model" },
    { 0x5A64F9F6, "_original_pap_spot" },
    { 0x86124304, "_osc_cap" },
    { 0x8ED491D3, "_osc_cap_spot" },
    { 0x360652CC, "_osc_check" },
    { 0xE2B442ED, "_osc_flags" },
    { 0xBA7E78BD, "_osc_max_dist" },
    { 0x41340ED3, "_osc_min_dist" },
    { 0xB2ABB2A6, "_osc_rb_jolie_spots" },
    { 0xD744A793, "_osc_rbs" },
    { 0x433ABE28, "_osc_rbs_dist_range" },
    { 0x8448824B, "_osc_rbs_totalrot" },
    { 0x1FF9ED33, "_osc_release" },
    { 0x3F13C601, "_osc_st" },
    { 0x297FF327, "_osc_struct" },
    { 0x9C56830D, "_osc_terms" },
    { 0x182729E4, "_osc_trial_time" },
    { 0x6FC238BA, "_osprey" },
    { 0xE608F920, "_override_blackhole_destination_logic" },
    { 0xCAF242C3, "_override_eye_fx" },
    { 0xE62301A4, "_override_juke" },
    { 0x0ED2470A, "_override_name_funcs" },
    { 0xE3BA1B2B, "_override_num_chars_connected" },
    { 0x2EF8C407, "_override_parasite_combat_speed" },
    { 0x552A9606, "_override_quad_explosion" },
    { 0x08DF7552, "_override_rank_func" },
    { 0x3B4FC99E, "_override_raps_combat_speed" },
    { 0x6ADA1CC0, "_override_shader" },
    { 0x488A6CFF, "_overwrite" },
    { 0x0F7B412E, "_p51" },
    { 0x879BFF77, "_pack_a_punch_sequence_ends" },
    { 0x3F840CB7, "_pack_a_punch_timer_sounds" },
    { 0x9D3A4338, "_pack_a_punch_warning_fx" },
    { 0x515D4AF7, "_pack_hack_struct" },
    { 0x2D6A4D20, "_pad_chase" },
    { 0x76DB4F51, "_pad_follow" },
    { 0x7C70AC67, "_pad_poi_ignore" },
    { 0xDB96EA8E, "_pad_powerup" },
    { 0xEB1A9BC6, "_padded" },
    { 0x47DE71F6, "_paddedcell" },
    { 0xDA96B0D0, "_panther" },
    { 0xC3B592C1, "_panzeriv" },
    { 0xCE7AEB18, "_pap_brush_connect_paths" },
    { 0x5E3BBE0E, "_pap_brush_disconnect_paths" },
    { 0xCC18E1B9, "_pap_clean_up_corpses" },
    { 0x5F2B4242, "_pap_fx_timer" },
    { 0x96A5220E, "_pap_hidden" },
    { 0x87897A6E, "_pap_pressure_plate_move" },
    { 0x907C2F2C, "_pap_pressure_plate_move_enabled" },
    { 0x96DA68EF, "_pap_pressure_plate_think" },
    { 0x3817481A, "_pap_ramp" },
    { 0x75EC8039, "_pap_remove_corpse" },
    { 0x328DC42A, "_pap_think" },
    { 0x8338A9DF, "_parasite" },
    { 0x32CE450D, "_parkinglot" },
    { 0x18923552, "_patrol" },
    { 0x3777473F, "_patrol_boat_runner_frequency" },
    { 0x3A11F577, "_patrol_boat_runners" },
    { 0x605FCE5D, "_patrol_boat_runners_time" },
    { 0x64BE00D3, "_patrol_gunner_runner_ent" },
    { 0x84D4667F, "_patrol_init" },
    { 0x5E40E8B0, "_patroller_death" },
    { 0x6FFCDC7C, "_pavelow" },
    { 0x84ACA574, "_pbr" },
    { 0xFF2D2F3B, "_pc" },
    { 0x65B68F05, "_peekstop" },
    { 0x68EF8214, "_pegasus" },
    { 0xCDC01B2F, "_pentagon_fire_sale" },
    { 0x474171AC, "_pentagon_no_power" },
    { 0x76C01B75, "_percent_life_at_checkpoint" },
    { 0xB5614C87, "_perk_done" },
    { 0x841401C9, "_perkmachinenetworkchoke" },
    { 0x268C4DDF, "_perks" },
    { 0xA82D57EF, "_perks_sp" },
    { 0x51A2E505, "_perms" },
    { 0xB1B1E7A2, "_perplayer" },
    { 0x21A0BE3D, "_persistence" },
    { 0xE3F0B673, "_phalanx_cannon_think" },
    { 0x32B3DE9E, "_phalanx_cannon_think_hacked" },
    { 0xCB2FCEE3, "_photosource" },
    { 0x2088D2A4, "_pickup" },
    { 0x9C9F5FEA, "_pickup_from_table" },
    { 0x2FCFDEB9, "_pickup_items" },
    { 0x4D3FA5AA, "_piece_placed" },
    { 0x445617C2, "_pillar_of_salt_watcher" },
    { 0x266F19FA, "_pilot" },
    { 0x131DB8E1, "_pineapple_gun" },
    { 0x199FC8E7, "_pipe_methods" },
    { 0x64831B94, "_pipebomb" },
    { 0x35D8AC77, "_pipes" },
    { 0x5AD8638A, "_place_player_loadout" },
    { 0x14BCA46C, "_placeables" },
    { 0x78CF2E4C, "_plain" },
    { 0xB39DBAB6, "_plane" },
    { 0xEC413001, "_plane_drive_highway_internal" },
    { 0x3B81EC11, "_plane_move_to_point" },
    { 0x02CC4644, "_plane_respect_path_width" },
    { 0x97B86F24, "_plane_weapons" },
    { 0x00B29651, "_planemortar" },
    { 0x79F4C3C9, "_planeweapons" },
    { 0x177886B0, "_plant_flamethrower_dongle" },
    { 0x1E1DD74F, "_plate_move_down" },
    { 0xBA049CA0, "_plate_move_up" },
    { 0x80BF3FC3, "_plate_onmove" },
    { 0x30493584, "_plate_onstop" },
    { 0xE9BFE310, "_plate_playlockedsound" },
    { 0x6905D9AF, "_plate_playmovesound" },
    { 0x1D972325, "_plate_stopmovesound" },
    { 0x55E4EA96, "_play" },
    { 0x9A460F6A, "_play_anim" },
    { 0x897D87FB, "_play_bigrig_trailer_anim" },
    { 0x3BB36890, "_play_camera_anim_on_player" },
    { 0x3C2DBB6A, "_play_camera_anim_on_player_callback" },
    { 0x0E302AFB, "_play_camera_anims" },
    { 0x0DB4C202, "_play_extracam_on_player" },
    { 0xF238DBC0, "_play_flush_sounds" },
    { 0xA2F5BD7F, "_play_fx_delete" },
    { 0xFED373B1, "_play_geyser_fx" },
    { 0x0C99E74C, "_play_instance" },
    { 0xEEC93DE6, "_play_landing_anim" },
    { 0xCD18A3A1, "_play_looped_fx_on_tag_origin_update" },
    { 0x42F28535, "_play_movie_for_player" },
    { 0xADC333E0, "_play_movie_for_player_with_timeout" },
    { 0xD1E0BAFA, "_play_shared_player_anim" },
    { 0x576F538E, "_play_shared_player_anim_for_player" },
    { 0xE6027917, "_play_sound_in_space" },
    { 0x53811A4B, "_play_sound_to_player_with_notify" },
    { 0x49DE937C, "_play_vulture_drop_pickup_fx" },
    { 0x2FFDB3FD, "_play_water_fx_actor" },
    { 0x6369F7E9, "_play_water_fx_model" },
    { 0xD3A63808, "_playdematerialization" },
    { 0xF652003F, "_player" },
    { 0x710DA4CC, "_player_aircraft" },
    { 0x7FA497DC, "_player_attacked_terrorists_" },
    { 0xE4A19B3A, "_player_attacked_yemeni_" },
    { 0x70D95291, "_player_boat_health" },
    { 0x674BDBC8, "_player_breadcrumbs" },
    { 0xE3859EBF, "_player_chair_anim" },
    { 0x293767EB, "_player_corsair" },
    { 0xBC9D4D57, "_player_cover_blown_" },
    { 0x204B58DB, "_player_entnum" },
    { 0x5AD6DEA0, "_player_flush" },
    { 0x0068F954, "_player_flush_fx_done" },
    { 0xF084C06A, "_player_flushed_out" },
    { 0x183833F4, "_player_killed_terrorists_" },
    { 0x3737534A, "_player_nearby_watcher" },
    { 0xF64BC419, "_player_on_ground" },
    { 0x05AB33DA, "_player_rappel" },
    { 0x88858D28, "_player_shock_fx_quadtank_melee" },
    { 0x9EF05213, "_player_snow" },
    { 0x355C87A5, "_player_speed_modifier" },
    { 0xC3B038EF, "_player_stats" },
    { 0x88E193E6, "_player_titus_tutorial_watch" },
    { 0xC490F60C, "_player_wakes_up_remove_weapons" },
    { 0x1FC93399, "_player_walk_speed_reset" },
    { 0x200DC0E8, "_player_who_pressed_the_switch" },
    { 0x2A2D3F32, "_playercbfunc" },
    { 0x1B7993AB, "_playergetorigin" },
    { 0x488FD146, "_players" },
    { 0xA315CDBE, "_players_connected" },
    { 0x7223579E, "_playerspawned_override" },
    { 0x5A8ACF2A, "_playgibfx" },
    { 0x0840ED6D, "_playgibsound" },
    { 0xC6E9F3B0, "_playlocalsound" },
    { 0x1FB5970D, "_playloopsound" },
    { 0x99E74E68, "_playloopsound_proc" },
    { 0x23C332DF, "_playweapondamageeffectscallbacks" },
    { 0x0D7E75BA, "_playweapondeatheffectscallbacks" },
    { 0x269DBE79, "_pmc_force_goal_then_loop" },
    { 0x67A73ECB, "_poi_override" },
    { 0xE70940C5, "_poi_pack_set" },
    { 0x69726C68, "_policecar" },
    { 0xF623598A, "_pooled_hackable_objects" },
    { 0x457DD631, "_pop_objective" },
    { 0x8FBB7900, "_populate_boat_models" },
    { 0x90B00D59, "_popups" },
    { 0x03E903B6, "_pose_corpse" },
    { 0x2A87939B, "_post_carpenter_callback" },
    { 0x8CAD8B15, "_post_host_migration_thread" },
    { 0xA6ED6D07, "_power_global" },
    { 0x842FC221, "_power_on" },
    { 0x1D1EB128, "_power_thread_end" },
    { 0x96AD01A9, "_powerup_drop_think" },
    { 0x352C26BC, "_powerup_grab_check" },
    { 0x20EC5C50, "_powerup_randomize" },
    { 0xF1E9E5AA, "_powerup_timeout_custom_time" },
    { 0xF4711323, "_powerup_timeout_override" },
    { 0x21AC9BA3, "_pre_pad_run" },
    { 0x0F9C1901, "_pre_round_score" },
    { 0xC2A961DB, "_precache" },
    { 0x6AA63519, "_prefabs" },
    { 0x5A4EDDF9, "_pregame" },
    { 0xD0458499, "_prepare" },
    { 0x5DC76F0B, "_prepare_player" },
    { 0x2B28EE15, "_preprocess_fov_notetracks" },
    { 0xC7F7C4C1, "_preprocess_notetracks" },
    { 0x7429D842, "_previous_vision" },
    { 0xBCE38A7A, "_print_goal_line" },
    { 0x911B2DA4, "_priority_dialog_playing" },
    { 0xD8860315, "_prisoner_names" },
    { 0x77925DDC, "_prisoner_names_index" },
    { 0x62B87F7B, "_prisoners" },
    { 0xC409E8B1, "_prisoners_anim" },
    { 0x10FE0B02, "_process_notetracks" },
    { 0x40DBD0B0, "_process_structs" },
    { 0xE115496E, "_progress_fx" },
    { 0x7AEBD072, "_prompt" },
    { 0xC7AB2254, "_prompt2" },
    { 0xF39D1420, "_properks" },
    { 0x174316B2, "_props" },
    { 0x2AAFE7BB, "_proximity_alarm_snd_ent" },
    { 0x55DC0408, "_proximity_grenade" },
    { 0x6FE7F8F8, "_proximityweaponobjectdetonation_override" },
    { 0x3BAF5B9A, "_prunedead" },
    { 0x737F3C68, "_psychotic" },
    { 0x88FA00DF, "_ptt_jets" },
    { 0xE8AD61CF, "_ptt_num_lit" },
    { 0x9D0931DA, "_ptt_sound_choking_ent" },
    { 0xF9EFF852, "_ptt_sound_ent" },
    { 0x892B3555, "_ptt_sound_ent_trash" },
    { 0xB85F7D55, "_pulse_ent" },
    { 0x29459FC4, "_pulse_hud_circle" },
    { 0xB7C1339F, "_pushed" },
    { 0x8A35B33E, "_qrcode" },
    { 0x3484BA9D, "_qrdrone" },
    { 0xF9A715B2, "_quad50_damage" },
    { 0xBE1CA443, "_quadrotor" },
    { 0xBFD9126D, "_quadrotor_attacks_player_target" },
    { 0xA6BA0398, "_quadrotor_update_enemy" },
    { 0xF1D847A4, "_quadrotors_register_player_kills" },
    { 0xB5E5C470, "_quarry" },
    { 0xBD1A53BE, "_query_ents_by_substring_helper" },
    { 0xFBA7FB50, "_queue_dialog_add_talker" },
    { 0x483175C1, "_queue_dialog_init" },
    { 0x27932A71, "_queue_dialog_on_cancel" },
    { 0xD33C05E7, "_queue_dialog_on_death" },
    { 0x13E475A9, "_queue_dialog_on_finished" },
    { 0x61A4E8FE, "_queue_dialog_wait_turn" },
    { 0x619142ED, "_quickmessages" },
    { 0x8BD26EAF, "_quotes" },
    { 0xAEAA35B0, "_race_arrows" },
    { 0xCE918009, "_race_doors" },
    { 0x87E11FB5, "_race_team" },
    { 0xF06CAE8B, "_race_team_double_points" },
    { 0x3954C4E4, "_radar" },
    { 0xA27A18C7, "_radiant_ent" },
    { 0xAA2589FA, "_radiant_live_update" },
    { 0x3C71F2CD, "_radiation" },
    { 0x4F66AF90, "_radiation_poisoning" },
    { 0x5E5169F1, "_radio_queue" },
    { 0xFD3A0C76, "_radio_structs" },
    { 0xD4A1868E, "_rage_high_gameplay_end_cleanup" },
    { 0x50AA98E2, "_rage_high_gameplay_start_setup" },
    { 0xE21CCD81, "_rain_drops" },
    { 0x178CE5F5, "_rain_lightning" },
    { 0x04236221, "_rain_thread" },
    { 0x15EA76E6, "_raised_crystals" },
    { 0xCF3E8E34, "_ramp_down_stink_overlay" },
    { 0x5870CBFF, "_ramp_up_stink_overlay" },
    { 0x069B6F8E, "_random_death" },
    { 0xC659D0BD, "_random_location" },
    { 0xB40DDC60, "_random_perk_machine_perk_list" },
    { 0x3CA6E6AF, "_random_zombie_perk_cost" },
    { 0xADE37183, "_randomize_pressure_plates" },
    { 0x316B79FF, "_range" },
    { 0x4DE8AD8A, "_rank" },
    { 0xD5D1A254, "_rappel" },
    { 0xD6314419, "_rappel_anim_loaded_check" },
    { 0x516248EC, "_rappel_brake" },
    { 0x3AE433C7, "_rappel_brake_then_idle" },
    { 0x6C1FD170, "_rappel_charge_loop_starter" },
    { 0x5B56FA5D, "_rappel_cleanup" },
    { 0xFD6530C7, "_rappel_control_start" },
    { 0xEBAF31F5, "_rappel_controls_print_brake" },
    { 0x0671F5FB, "_rappel_descend" },
    { 0xFD3E82E7, "_rappel_do_falling_death" },
    { 0x6B2A58FF, "_rappel_done" },
    { 0x58B48DD3, "_rappel_enable_weapons_if_allowed" },
    { 0x1D403774, "_rappel_fall" },
    { 0x485EE163, "_rappel_falling_death" },
    { 0xCD92C08A, "_rappel_get_depth_of_field_old" },
    { 0x6017E97F, "_rappel_get_distance_to_ground" },
    { 0x63392F2A, "_rappel_get_frames_to_threshold" },
    { 0xB4DBB687, "_rappel_get_ground_trace_position" },
    { 0x53FD5856, "_rappel_get_wall_normal" },
    { 0x7538D366, "_rappel_get_wall_vector" },
    { 0x1751E462, "_rappel_hook_up" },
    { 0x8523057E, "_rappel_init_anims" },
    { 0x0BD99C7E, "_rappel_init_controls" },
    { 0x98ED1D2C, "_rappel_init_depth_of_field" },
    { 0xAD1D6A0B, "_rappel_init_difficulty" },
    { 0x6B7C4B47, "_rappel_init_movement" },
    { 0xFBD44A3E, "_rappel_init_status" },
    { 0xB1873BB2, "_rappel_init_strings" },
    { 0xFE404642, "_rappel_init_viewcone" },
    { 0x093D5443, "_rappel_jump" },
    { 0xED0515F6, "_rappel_jump_start" },
    { 0x58A91CB0, "_rappel_landing" },
    { 0xF12A380F, "_rappel_player_link" },
    { 0xF0E38D13, "_rappel_print_controls_full" },
    { 0xEEDC43F7, "_rappel_rotate_origin" },
    { 0x90CA2010, "_rappel_safe_landing" },
    { 0x3C02C024, "_rappel_set_depth_of_field" },
    { 0x179A0489, "_rappel_setup_default_anims_1h" },
    { 0xBC4AC5B8, "_rappel_setup_default_anims_2h" },
    { 0xF33D4FE1, "_rappel_start_charge_loop" },
    { 0x7CC15BF9, "_rappel_stop_movement" },
    { 0xBE45A9CD, "_rappel_switch_to_sidearm" },
    { 0x0DD63802, "_rappel_vector_remove_z" },
    { 0x9026C958, "_rappelers" },
    { 0x59B8639C, "_raps" },
    { 0xC71FF3B9, "_rat" },
    { 0x14A72821, "_raz_taunts" },
    { 0x79BDC5D5, "_rcbomb" },
    { 0x165347A1, "_reach" },
    { 0x5AC581A5, "_ready" },
    { 0x70B3AAEA, "_rear" },
    { 0x5BF2DA66, "_refund_oldest_ballistic_knife" },
    { 0x6F97DE69, "_register_undefined_perk" },
    { 0x6E665DC3, "_register_undefined_powerup" },
    { 0xAF5584C4, "_register_undefined_trap" },
    { 0xD49E69A4, "_registered_meat_matches" },
    { 0x43B11E9B, "_registered_races" },
    { 0x92BC6333, "_registered_turned_matches" },
    { 0x406D853E, "_release_dist" },
    { 0x9FE26B75, "_release_fighter" },
    { 0xE28DB46F, "_release_object" },
    { 0xBF9A0E55, "_releaserobot" },
    { 0xE16792A4, "_releaserobots" },
    { 0xA019EBD5, "_releasesentient" },
    { 0xCAB14324, "_releasesentients" },
    { 0x7F571278, "_remote_weapons" },
    { 0x62198F66, "_remotemissile" },
    { 0x21AE3F7F, "_remotemissile_utility" },
    { 0x1DE113D5, "_remotemortar" },
    { 0xA237555D, "_remove_non_riders_from_array" },
    { 0x7B7463BA, "_renderoptions" },
    { 0xE55E8214, "_reset_player_after_anim" },
    { 0x0B71E119, "_resetzombieboxweapons" },
    { 0x90EC7F1C, "_respawn_ghost_failsafe" },
    { 0xCB9E38F3, "_respawned_meat" },
    { 0x621A07D2, "_restore_f35_health" },
    { 0x32443EEB, "_restore_f35_hud" },
    { 0xA67903BD, "_restore_ghost_data" },
    { 0xED185CB0, "_restore_player_perks_and_weapons" },
    { 0xF8177CF2, "_restore_zombie_data" },
    { 0x9EE462BD, "_resumefire" },
    { 0x5E497966, "_resumefirerobots" },
    { 0x795682A6, "_resumefiresentients" },
    { 0x7FCEABE1, "_retain_perks" },
    { 0xBFA19C73, "_retain_perks_array" },
    { 0x87E0DE7E, "_retreated_to" },
    { 0x46D3CD32, "_reverse" },
    { 0x2FD8EF53, "_revive" },
    { 0x9BE0A6A3, "_rewindobjects" },
    { 0xA4280C36, "_right" },
    { 0x16039EAC, "_rightstrap" },
    { 0x5591B8F8, "_ring_triggered" },
    { 0xC147FC11, "_riotshield" },
    { 0x60AF7F51, "_riotshield_dissapear_fx" },
    { 0x19558182, "_rise_spot" },
    { 0x2648F69B, "_robot_attacked_player_" },
    { 0xC25BC6A0, "_robotcoverposition" },
    { 0x92AECD01, "_robotescortposition" },
    { 0xEEE2A916, "_robotguardposition" },
    { 0xF7A368D1, "_robotoutsidemovementrange" },
    { 0x7DBF6F86, "_robotrusherposition" },
    { 0x635B5E3A, "_rocket_hud" },
    { 0x74FBF723, "_rocket_hud_ammo" },
    { 0xD49CA1CF, "_rocket_pods" },
    { 0xD0E2C1F1, "_rod_add_entities_in_range" },
    { 0xA7876F6E, "_rod_fire" },
    { 0x1B639024, "_rod_impact" },
    { 0x2652C481, "_rod_is_target_area_valid" },
    { 0x8A0D13A9, "_room" },
    { 0xEA636D01, "_rotatevec" },
    { 0xC1788BCE, "_rotating_object" },
    { 0x0846E482, "_rotation" },
    { 0x1FE46E2B, "_round_changing_sides" },
    { 0x218EBB72, "_round_start_func" },
    { 0x6CF1F433, "_rumble_loop_stop" },
    { 0x50918121, "_run_anim_first_frame_on_asset" },
    { 0x83747D77, "_run_anim_loop_on_asset" },
    { 0x2E96A616, "_run_anim_reach_on_asset" },
    { 0x2A69B505, "_run_anim_single_on_asset" },
    { 0xEFD6F15D, "_run_from_bus" },
    { 0x9499F160, "_runners_died_trying" },
    { 0xDEE324FF, "_rusher" },
    { 0x1A1CAE93, "_russian_diary" },
    { 0x4EE3465B, "_s" },
    { 0x6C219D9A, "_safe_forced_saves" },
    { 0xD559DFBD, "_safe_moveup_dist_threshold" },
    { 0x449FE45B, "_said_sequential_savedgame_questions" },
    { 0x5E1C6B8D, "_sam" },
    { 0x7F7C1C8A, "_sampan" },
    { 0xA62C96B9, "_satchel_charge" },
    { 0xA1244C93, "_satellite" },
    { 0x6E5FDA54, "_save_pos" },
    { 0xE0130F83, "_save_time_bomb_weapon_after_switch" },
    { 0xC7F7332E, "_save_trig_ent" },
    { 0x0B4C3BE6, "_saved_by_throw" },
    { 0x947BF0B1, "_savedgame_questions" },
    { 0xF4400BE8, "_scene" },
    { 0x744C8277, "_scene_deleting" },
    { 0xBC29C0D6, "_scene_first_link" },
    { 0x58ECDFE9, "_scene_init" },
    { 0x6742822B, "_scene_link" },
    { 0x5C57FBF5, "_scene_linking" },
    { 0xBF4780E6, "_scene_old_draw_friendly_names" },
    { 0x3AD97924, "_scene_old_gun_removed" },
    { 0x1CD8D860, "_scene_old_player_height" },
    { 0x9D5136EB, "_scene_old_takedamage" },
    { 0x58E2208C, "_scene_rumble_heavy" },
    { 0xBA47B521, "_scene_rumble_light" },
    { 0xFD90C67F, "_scene_rumble_med" },
    { 0xE424804D, "_scene_set_goal" },
    { 0x7ED8102A, "_scene_stopped" },
    { 0x663928B6, "_scene_subs" },
    { 0xD008DA9C, "_scene_time_scale_fast" },
    { 0x0C35B120, "_scene_time_scale_med" },
    { 0x9BDB9221, "_scene_time_scale_off" },
    { 0x87887845, "_scene_time_scale_slow" },
    { 0x98727050, "_scoped_attachment" },
    { 0xF9538586, "_scoreboard" },
    { 0xA3216A9F, "_scoredebug" },
    { 0xE902A795, "_scoreevents" },
    { 0xE29EB898, "_scr_sound" },
    { 0x5CDB30D5, "_scrambler" },
    { 0x2811B925, "_screen_close_menu" },
    { 0x3DAD5D35, "_screen_fade" },
    { 0x93632888, "_screen_fade_" },
    { 0x703085A4, "_screen_message_1" },
    { 0xE237F4DF, "_screen_message_2" },
    { 0xBC357A76, "_screen_message_3" },
    { 0xCC3CBF8A, "_screen_timer" },
    { 0x22960732, "_script_exploders" },
    { 0xE5DE384A, "_script_gen" },
    { 0x77BF10B6, "_scripted_spawn" },
    { 0x9769E457, "_scripted_spawn_go" },
    { 0x247760F1, "_scriptedanim" },
    { 0x5A4ADEDD, "_scriptgen" },
    { 0x2522EC4D, "_scriptmover_client_flag_blackhole" },
    { 0x6E46150B, "_scriptmover_cosmodrome_client_flag_centrifuge_lights" },
    { 0x069EF6B3, "_scriptmover_cosmodrome_client_flag_centrifuge_rumble" },
    { 0xF3F27D96, "_scriptmover_cosmodrome_client_flag_monkey_lander_fx" },
    { 0x4950598C, "_sdk" },
    { 0xF2FE56DD, "_sea" },
    { 0xC13A58C1, "_sea_bob" },
    { 0x806FE900, "_sea_dist" },
    { 0x43832D20, "_sea_link" },
    { 0x5CFB939A, "_sea_org" },
    { 0xD83F9176, "_sea_scale" },
    { 0xEA295CA0, "_sea_viewbob" },
    { 0x3CF6BB56, "_seaknight" },
    { 0x39DBE688, "_seaknight_airlift" },
    { 0xF9494D02, "_seaknight_village_defend" },
    { 0xBD690186, "_see2_flak88" },
    { 0xECAE8E60, "_see2_ot34" },
    { 0xECDAA66C, "_see2_panther" },
    { 0xE73433D5, "_see2_panzeriv" },
    { 0xBD8F7FB3, "_see2_physics_t34" },
    { 0xD2CD0D05, "_see2_t34" },
    { 0x9FB6E4A9, "_see2_tiger" },
    { 0x45139D9E, "_self" },
    { 0xC1BC8C25, "_send_zombie_to_barricade" },
    { 0x7CAECB59, "_sensor_grenade" },
    { 0x720392D0, "_sentinel" },
    { 0xC1265ED9, "_sentinel_attack_taunts" },
    { 0x51668CFB, "_sentinel_drone" },
    { 0x0DA3F186, "_sentinel_enemy_detected_taunts" },
    { 0x5FC16234, "_sentinel_system_critical_taunts" },
    { 0xB25EB511, "_serenade" },
    { 0x8992094F, "_sergei" },
    { 0x044ECCD1, "_server_safe_ground_trace" },
    { 0xA5D42C26, "_server_safe_ground_trace_ignore_water" },
    { 0x4A787FB1, "_serverfaceanim" },
    { 0x880D6ECB, "_serverfaceanim_mp" },
    { 0x14DB6292, "_serversettings" },
    { 0x3918A67B, "_set_debug_drone_count" },
    { 0x410B8534, "_set_direction_on_nodes" },
    { 0x32C6DDF0, "_set_flag_when_func_true" },
    { 0x73AAB0DB, "_set_flag_when_trigger_hit" },
    { 0xC051C7DA, "_set_goal" },
    { 0x4FB3FDE4, "_set_num_plates_active" },
    { 0x455A41FB, "_set_num_visible_spinners" },
    { 0x0196E16F, "_set_objective_on_plane" },
    { 0x37313DBA, "_set_straffing_drones_thread" },
    { 0x61C630AC, "_set_strafing_run_objective_on_plane" },
    { 0xE45082CC, "_set_team" },
    { 0x02083F63, "_set_turret_needs_user" },
    { 0x756ACCD9, "_set_turret_user" },
    { 0xDFFD6817, "_set_vtol_turret_target" },
    { 0xEAE283FF, "_setanim" },
    { 0x3DC74A48, "_setanimknoball" },
    { 0x05322E2B, "_setblackboardattributefunc" },
    { 0x3317ED7B, "_setblur" },
    { 0x7CA8B162, "_setflaggedanimknoball" },
    { 0xBFFED523, "_setgibbed" },
    { 0x4096B21F, "_setlightintensity" },
    { 0xD2E5E7F1, "_setmissiondvar" },
    { 0x580D042D, "_setplayermomentum" },
    { 0xFFFDA5BF, "_setplayerscore" },
    { 0xE1F88522, "_setsaveddvar" },
    { 0xA5D0ACB3, "_setteamscore" },
    { 0x8CAECC87, "_settings" },
    { 0xEF842362, "_setup_" },
    { 0x8F05A36D, "_setup_ai_for_scene" },
    { 0xAF11D807, "_setup_ammo_cache" },
    { 0x174B47CF, "_setup_asset_for_scene" },
    { 0x373B7E0B, "_setup_configure_team_callbacks" },
    { 0x81AF6163, "_setup_corpse_pose_from_struct" },
    { 0x4A124A26, "_setup_deathblossom_offsets" },
    { 0xFEEBD5CE, "_setup_fake_vehicle_model" },
    { 0xC6E2288C, "_setup_hanging_model" },
    { 0xCDA1BC07, "_setup_location" },
    { 0x6E4D1C5C, "_setup_model_for_scene" },
    { 0x10E95862, "_setup_pap_blocker" },
    { 0xD72E5036, "_setup_pap_fx" },
    { 0x0F34F1D1, "_setup_pap_path" },
    { 0xCAEA2097, "_setup_pap_timer" },
    { 0x3E680485, "_setup_plane_firing_by_type" },
    { 0x13FF7708, "_setup_player_for_scene" },
    { 0x6318EA2D, "_setup_pressure_plate_bodies" },
    { 0x9059562B, "_setup_shrimp_path" },
    { 0x7B8D91ED, "_setup_simultaneous_pap_triggers" },
    { 0xE9EE2212, "_setup_spawner" },
    { 0x115C8877, "_setup_vehicle_for_scene" },
    { 0x4F280C4F, "_setup_view_model" },
    { 0x2B0D49BD, "_setup_weapon_cache" },
    { 0xAD96BB7F, "_setup_zone_info" },
    { 0x720647AE, "_setupnumattachtable" },
    { 0xBEA4B462, "_sewerpipe" },
    { 0xCC7DF3B1, "_shake_in_jetwash" },
    { 0x73860C25, "_shatter_market_window" },
    { 0xB0C6CAB0, "_shellshock" },
    { 0x0604058C, "_sherman" },
    { 0xFCC78C83, "_shoot_at_drones" },
    { 0xEF8DFA96, "_shoot_turret_at_target" },
    { 0x3DABB8CC, "_shoot_vtol_turret" },
    { 0xE7221030, "_shoreline_mg_damage" },
    { 0x4BB989C6, "_short" },
    { 0x8B0595FB, "_shotgun_kills_timeout_" },
    { 0x3772A9BB, "_should_skip_anim" },
    { 0x682B419D, "_should_skip_entity" },
    { 0xFADB2359, "_should_skip_ignore_player_logic" },
    { 0xC037DCDF, "_shouldignorenoflyzone" },
    { 0x8A83BE1A, "_shouldignorestartgoalnoflyzone" },
    { 0xF18AA28B, "_shoutcaster" },
    { 0x6E8F41CB, "_show" },
    { 0xA3F81B10, "_show_activated_fx" },
    { 0x4768ABBF, "_show_debug_location" },
    { 0xF1577DB3, "_show_location" },
    { 0x7FE16EB9, "_show_solo_hud" },
    { 0x080337EF, "_show_tutorial_hint_with_vo" },
    { 0x48232648, "_shrimps" },
    { 0x9BB1AE8F, "_shutter" },
    { 0xEC8DB8DF, "_sickle_zm_equipped" },
    { 0xB169A849, "_sidequest_firsttime" },
    { 0x5549BC37, "_sidequest_icons_base_x" },
    { 0xED3AA324, "_siegebot" },
    { 0xA7E48F6C, "_since_auth_been_said" },
    { 0x1090FC73, "_singleton" },
    { 0x34DDBCC8, "_skip_pathing_first_delay" },
    { 0xE09D2590, "_skip_scene" },
    { 0xF37ED156, "_skipto" },
    { 0xAF86283E, "_skipto_turn_off_roadblock_triggers" },
    { 0xC1597081, "_skydemon_trail" },
    { 0x831F6C80, "_sliding_doors" },
    { 0xFE3E8D49, "_sloth_ai" },
    { 0xECFCEE97, "_small_hatchback" },
    { 0xF3B8F2CC, "_small_wagon" },
    { 0xB80EDEC3, "_smokegrenade" },
    { 0x819D3852, "_smoldercorpse" },
    { 0xAE4030BF, "_sndactivesnapshot" },
    { 0x54FB3EDB, "_sndambientstatecallback" },
    { 0x4DE7763D, "_snddone" },
    { 0x0DE70EA2, "_sndnextsnapshot" },
    { 0xE505ACD7, "_snowcat" },
    { 0x1F361762, "_so_rts" },
    { 0xEADFDD6F, "_so_rts_ai" },
    { 0xC625DED2, "_so_rts_catalog" },
    { 0x740FADCF, "_so_rts_challenges" },
    { 0x05F4BD03, "_so_rts_enemy" },
    { 0x8B33A5DB, "_so_rts_event" },
    { 0x541AE828, "_so_rts_fxanim" },
    { 0xB1A89ADE, "_so_rts_main" },
    { 0x08F92CAE, "_so_rts_player" },
    { 0xD90D5A3B, "_so_rts_poi" },
    { 0x804913FA, "_so_rts_precache" },
    { 0xAAD3E3F6, "_so_rts_rules" },
    { 0x9EABB01D, "_so_rts_squad" },
    { 0x602795E2, "_so_rts_support" },
    { 0x783C4FB7, "_so_rts_tutorial" },
    { 0x2F598019, "_so_war" },
    { 0x7CF97116, "_so_war_ai" },
    { 0xF64523BB, "_so_war_anim" },
    { 0xDE6AFC8A, "_so_war_armory" },
    { 0x0FB4AC4A, "_so_war_audio" },
    { 0x28D1BA48, "_so_war_classes" },
    { 0x5DCA9B55, "_so_war_gametypes" },
    { 0xE5FBC06F, "_so_war_hud" },
    { 0x920FA89A, "_so_war_loot" },
    { 0x182587D7, "_so_war_precache" },
    { 0xF91A8781, "_so_war_support" },
    { 0xB1BFC920, "_so_war_switch" },
    { 0x41D365DF, "_soct" },
    { 0xD1834AD6, "_solo_revive_machine_expire_func" },
    { 0x9DFAC374, "_sort_by_distance2d" },
    { 0xD8BD4DD3, "_sort_by_distance_compare_func" },
    { 0xB5209717, "_sort_by_num_boards" },
    { 0xD1B42EE9, "_sort_by_script_int_compare_func" },
    { 0x4F5118CB, "_sort_by_value_compare_func" },
    { 0x542F13CD, "_sound" },
    { 0x15C9FED0, "_sound_done" },
    { 0xADFAD527, "_source_damaged" },
    { 0x88CAC7D3, "_south" },
    { 0x9E98F886, "_southwest" },
    { 0x6B8E0211, "_sp" },
    { 0x3AD6B82D, "_spawn" },
    { 0xABD0B127, "_spawn_array" },
    { 0xFE3AD775, "_spawn_explosion" },
    { 0xB69791B9, "_spawn_group" },
    { 0x66148C1F, "_spawn_husk" },
    { 0x68B05C4D, "_spawn_manager" },
    { 0x47B86C9B, "_spawn_time" },
    { 0x559D2800, "_spawn_vehicle_for_anim" },
    { 0xCDFE0C73, "_spawn_wounded_trigger" },
    { 0x1445E1F3, "_spawn_wounded_trigger_spawn" },
    { 0xB58B4E1A, "_spawned_path_nodes" },
    { 0xE557AB96, "_spawned_wallbuys" },
    { 0x0AF7E43C, "_spawner" },
    { 0xA5C17408, "_spawner_mg42_think" },
    { 0xA8519F9B, "_spawnfx" },
    { 0x69A679BB, "_spawning" },
    { 0xCBCE24A7, "_spawning_meat" },
    { 0x86706699, "_spawnlogic" },
    { 0xC9271E19, "_special_blackhole_bomb_structs" },
    { 0xC7773C6D, "_special_solo_pistol_swap" },
    { 0xED91877F, "_specialops" },
    { 0xD744BFE8, "_spectating" },
    { 0x47BAA121, "_speed_test1" },
    { 0x6DBD1B8A, "_speed_test2" },
    { 0xD0064376, "_spiderbot" },
    { 0xBDCCFAEF, "_spiderbot_ride" },
    { 0x1ACDC77D, "_spiderhole" },
    { 0xCEDF7940, "_spike_charge_siegebot" },
    { 0xB2DFCB6F, "_splash_screens" },
    { 0xE9340217, "_spline_debug" },
    { 0xF58E72F2, "_splitter_ring" },
    { 0xED7782D0, "_splitter_ring_trig1" },
    { 0x5F7EF20B, "_splitter_ring_trig2" },
    { 0x74DE8281, "_spoken_dialog" },
    { 0x8DD25454, "_spotlight" },
    { 0x2385B618, "_spyplane" },
    { 0xCC82FA93, "_sq_m_possessed_zombie_vo" },
    { 0x93582A5D, "_sq_perk_array" },
    { 0x561C8F96, "_sq_skel" },
    { 0x91DA34FC, "_sq_std_array" },
    { 0xD2F7DBB3, "_sq_std_status" },
    { 0x09581AF6, "_squad" },
    { 0x6B6C8FEB, "_squad_enemies" },
    { 0xF531B3FA, "_squad_manager" },
    { 0xE49A68E9, "_squads" },
    { 0xDB4F7A28, "_ss_buttons" },
    { 0x7A69970D, "_ss_hacks" },
    { 0x6B872973, "_ss_sequence_matched" },
    { 0xACD4746D, "_ss_stage" },
    { 0x58F48A6C, "_ss_user_seq" },
    { 0xC4FE1519, "_stables_attack_woman_idle" },
    { 0x17714997, "_stage_active" },
    { 0x81C694B1, "_stairs_move_down" },
    { 0x01667EFE, "_stairs_move_up" },
    { 0xCC4D8661, "_stairs_onmove" },
    { 0x096C6FB2, "_stairs_onstop" },
    { 0x02F05FDA, "_stairs_playlockedsound" },
    { 0xE8408225, "_stairs_playmovesound" },
    { 0x7DB62CAB, "_stairs_stopmovesound" },
    { 0x9B9E9231, "_stairsendnode" },
    { 0xB59CF44E, "_stairsstartnode" },
    { 0x39B19EFE, "_stance_button_think_threaded" },
    { 0xAEF29384, "_start" },
    { 0xA41BA608, "_start_scene_" },
    { 0xD873A2B8, "_start_scroll" },
    { 0x5E95A341, "_start_vo_nag_group" },
    { 0x86C0563B, "_starting_round_number" },
    { 0x6F686119, "_stat_track_results" },
    { 0x5EB7D3CA, "_statemachine" },
    { 0x2A9DB059, "_stats" },
    { 0xB7D0BADB, "_stats_output" },
    { 0xC8EF1D9F, "_statstable" },
    { 0xEE305696, "_status" },
    { 0x128B14E2, "_status_current_hud" },
    { 0xCBF91EF4, "_status_export_thread_started" },
    { 0x2110773E, "_status_y" },
    { 0x14CD6EDD, "_stealth" },
    { 0xC2408E0A, "_stealth_alert" },
    { 0x638B73D6, "_stealth_anims" },
    { 0x782C47EE, "_stealth_behavior" },
    { 0x6C02D72C, "_stealth_behavior_reaction_anim" },
    { 0xABA4F1D9, "_stealth_corpse_behavior_taken" },
    { 0x8C838CA9, "_stealth_detection_level_change" },
    { 0x7CD9F253, "_stealth_enemy_alert_level_change" },
    { 0x37A2588B, "_stealth_found_corpse" },
    { 0xEB66D332, "_stealth_logic" },
    { 0xC8A00B2E, "_stealth_move_detection_cap" },
    { 0xAB738942, "_stealth_no_corpse_announce" },
    { 0x20910DAA, "_stealth_running_to_corpse" },
    { 0x0D3D1C46, "_stealth_saw_corpse" },
    { 0xE4161C5F, "_stealth_spotted" },
    { 0x9D95F2FD, "_stealth_stance_dont_change" },
    { 0x2C290827, "_stealth_stance_down" },
    { 0x5BBE1061, "_stealth_stance_handler" },
    { 0xB764FA0C, "_stealth_stay_still" },
    { 0xBE726BDC, "_stealth_stop_corpse_logic" },
    { 0x5B306719, "_stealth_stop_stealth_behavior" },
    { 0xF81CC5AF, "_stealth_stop_stealth_logic" },
    { 0x39712A58, "_stealth_visibility_system" },
    { 0xE381FC9E, "_sticky_grenade" },
    { 0xE646E6EE, "_stinger" },
    { 0xFEAB60CA, "_stock" },
    { 0x4F170F65, "_stonecorridor" },
    { 0x157C55BE, "_stoneroom" },
    { 0x89B19DD8, "_stop" },
    { 0xB5D0A5AA, "_stop_anim_threads" },
    { 0x87107C5A, "_stop_camera_anim_on_player" },
    { 0xCAEB8BB1, "_stop_camera_anims" },
    { 0xE43026D6, "_stop_de" },
    { 0x6C974C0A, "_stop_follow_path" },
    { 0x4058F466, "_stop_instance" },
    { 0x526A8079, "_stop_magic_bullet_shield_debug" },
    { 0x93F26BD1, "_stop_rl" },
    { 0xA8151D8F, "_stop_rr" },
    { 0x230A1CBC, "_stop_scene_" },
    { 0xBC087705, "_stop_turret" },
    { 0xB61E6B88, "_stop_turret_when_user_changes" },
    { 0x78F01691, "_stopburning" },
    { 0xF67A63E2, "_stopfx" },
    { 0x7B560634, "_stopsounds" },
    { 0x2B1650FA, "_str_death_anim" },
    { 0x8B281B93, "_str_death_anim_loop" },
    { 0x142A3109, "_str_mode" },
    { 0x7BE00E59, "_str_name" },
    { 0xDBE9704B, "_str_notify_name" },
    { 0x6BF813AF, "_str_state" },
    { 0x08C078E6, "_strafe_player_" },
    { 0x0500618C, "_straferun" },
    { 0xFDCA935E, "_strength_test" },
    { 0xBB12C84B, "_struct" },
    { 0x41FBE210, "_struct_add_to_level_array_internal" },
    { 0x87B14A8C, "_struct_models" },
    { 0x421E806B, "_struct_name" },
    { 0x540CCD26, "_stuka" },
    { 0x2CE3B37C, "_subclass_dualwield" },
    { 0x826E5A26, "_subclass_elite" },
    { 0xA1B500D2, "_subclass_main" },
    { 0xE28F745C, "_subclass_militia" },
    { 0x8558D0C3, "_subwoofer_choke" },
    { 0xC2F86F2B, "_successful_airstrike_calls" },
    { 0x7C58C5E1, "_summon_hack_struct" },
    { 0xAD272545, "_sundial_active" },
    { 0xCFCFDA61, "_sundial_buttons_pressed" },
    { 0x55E54CF8, "_supply_drop_explosion_fx" },
    { 0x47EC523E, "_supply_drop_smoke_fx" },
    { 0x07DDB33E, "_supplydrop" },
    { 0x8565773D, "_supress_survived_screen" },
    { 0xD1B32813, "_swap_flametank_model" },
    { 0xEB473DD2, "_sway_attach_vines" },
    { 0x246DAAE9, "_sway_fx" },
    { 0xC3C695CE, "_sway_model" },
    { 0x04C6A661, "_sway_think" },
    { 0xD87DA456, "_sway_tree_think" },
    { 0x54CFA8B9, "_swift_death_enable_blood" },
    { 0x86F554F2, "_swift_death_flag_handler" },
    { 0x817FD70F, "_swimming" },
    { 0xDE1B52EB, "_swimming_arms" },
    { 0xD64A5FFB, "_switch_disabled" },
    { 0x9F36B172, "_switch_node_think" },
    { 0xD6462477, "_switch_pos" },
    { 0xB4058C23, "_switch_to_delta" },
    { 0xDD377203, "_switch_to_weapon" },
    { 0x2E9C2D99, "_systemstates" },
    { 0x605767A1, "_t34" },
    { 0x1D81D92A, "_t6" },
    { 0x48CB78EB, "_t72" },
    { 0x32C2F920, "_tabun" },
    { 0xB59EFD62, "_tacticalinsertion" },
    { 0x0D954643, "_tacticalmask" },
    { 0xD259A1E6, "_tag_entity" },
    { 0x4DB840DA, "_tag_name" },
    { 0x2F7993E8, "_take_weapon" },
    { 0x31D70948, "_takedamage_old" },
    { 0x0434F895, "_taken" },
    { 0x410F1324, "_talon" },
    { 0xBA3580A6, "_tank_attack_if_attacked_waittill" },
    { 0xEC0305AA, "_tank_attack_if_whizby_or_close" },
    { 0x50774671, "_tank_blocks" },
    { 0xDB55C903, "_tank_spawned" },
    { 0x06395597, "_tank_stop" },
    { 0x03CC2DB0, "_tank_targetting_a_player" },
    { 0x41874B26, "_tank_zsu23" },
    { 0xD4318265, "_tanker" },
    { 0x40D1CC09, "_tankmantle" },
    { 0xB3DB4AA5, "_targeting" },
    { 0xD0F27496, "_targetname" },
    { 0xF34C915A, "_targets" },
    { 0xA83F5223, "_task_milestone_date" },
    { 0xF5CCBF85, "_task_start_date" },
    { 0x714DA125, "_task_types" },
    { 0x7FACA6C6, "_tasks" },
    { 0x260B137C, "_tazer_zm_equipped" },
    { 0xEAFDC58B, "_team" },
    { 0x48CA35F4, "_team_1_current_door" },
    { 0xD692241D, "_team_2_current_door" },
    { 0x7105EF1D, "_team_hud" },
    { 0x01BD38AA, "_team_loadout" },
    { 0xD8E994AB, "_team_name" },
    { 0x05FED7FA, "_team_winer_score" },
    { 0x0FC61B36, "_team_winner_round" },
    { 0x6B00AF1D, "_teamops" },
    { 0xBEF767EA, "_teams" },
    { 0x5FC59CED, "_teamset" },
    { 0x5D42FF52, "_teamset_allies" },
    { 0xD58DBE33, "_teamset_axis" },
    { 0xD3CF1424, "_teamset_cdc" },
    { 0x16E2DB26, "_teamset_cubans" },
    { 0x946EECC0, "_teamset_junglemarines" },
    { 0x71C9C04A, "_teamset_seals" },
    { 0x38CF1CBB, "_teamset_urbanspecops" },
    { 0xE17AF98E, "_teamset_winterspecops" },
    { 0x5BD7FC09, "_teargrenades" },
    { 0xC57AE029, "_technical" },
    { 0xB5ED7955, "_temp_dialog" },
    { 0xD1D70E6B, "_temp_dialogue_lines" },
    { 0x5D02A0FC, "_temp_introscreen_fixhud" },
    { 0xD37E3E94, "_temple_caves_eclipse_vision_set" },
    { 0x2E19FBE7, "_temple_caves_eclipse_vision_set_priority" },
    { 0x0DC92592, "_temple_caves_vision_set" },
    { 0xD343E2D9, "_temple_caves_vision_set_priority" },
    { 0xB147D899, "_temple_eclipse_vision_set" },
    { 0xCC2B2A14, "_temple_eclipse_vision_set_priority" },
    { 0xFD2EA5BF, "_temple_vision_set" },
    { 0x8F3E0996, "_temple_vision_set_priority" },
    { 0x27AC88FB, "_temple_water_vision_set" },
    { 0x5EA846E9, "_terrorist_attacked_player_" },
    { 0x69729890, "_test_failed" },
    { 0x9BA0EBC3, "_test_mode_loop" },
    { 0x3669E052, "_test_succeeded" },
    { 0x202D546C, "_testing" },
    { 0x3898B1BF, "_testplayerweapon" },
    { 0x437B6835, "_threat_detector" },
    { 0x4D582FF9, "_threshold" },
    { 0x8EBDA1A4, "_throttle_bullet_trace_think" },
    { 0x761FBDE0, "_throwstowedweapon" },
    { 0xF22900C1, "_tiara" },
    { 0x2BFDB98D, "_tiger" },
    { 0x135978CB, "_time" },
    { 0x66CAFE95, "_time_before_regen" },
    { 0xBEE52EC2, "_time_bomb" },
    { 0xBCBEB11C, "_time_bomb_hide_overlay" },
    { 0xE0D5C529, "_time_bomb_inventory_think_done" },
    { 0x0DCD7D5B, "_time_bomb_kill_all_active_enemies" },
    { 0x68CBB730, "_time_bomb_kill_tactical_grenade_watch" },
    { 0xF2283FAC, "_time_bomb_kill_thread" },
    { 0x70D71BF2, "_time_bomb_resets_all_barrier_attack_spots_taken" },
    { 0x263DC254, "_time_bomb_restores_door_states" },
    { 0xDB107811, "_time_bomb_restores_enemies" },
    { 0x6FDAD371, "_time_bomb_restores_player_data_internal" },
    { 0x76AB89DE, "_time_bomb_save_internal" },
    { 0xD91A8548, "_time_bomb_saves_data" },
    { 0x094B0265, "_time_bomb_saves_door_states" },
    { 0xC1E90FA3, "_time_bomb_saves_enemy_info" },
    { 0x2FC7D143, "_time_bomb_show_overlay" },
    { 0xF083841E, "_time_bomb_spawns_zombie" },
    { 0x160F9336, "_time_of_death_patrol_boat_gunner" },
    { 0x2E3EED65, "_time_of_last_runner" },
    { 0x48F1FDE3, "_time_since_last_gunner" },
    { 0xA945B508, "_time_since_last_runner" },
    { 0xC48AE3EB, "_timed_events" },
    { 0xA890A4D9, "_timeout" },
    { 0xFA125AAA, "_timer_kill" },
    { 0xAC8035D7, "_titus" },
    { 0x2284C89D, "_titus_check_for_target_death" },
    { 0x701A8F63, "_titus_fire_watcher" },
    { 0xD2EF7398, "_titus_get_spread" },
    { 0x2A64C3A0, "_titus_grenade_detonate_on_target_death" },
    { 0xB7451EE0, "_titus_locate_target" },
    { 0x964421B2, "_titus_marked" },
    { 0x9DF6C0D0, "_titus_reset_grenade_fuse" },
    { 0x35D0E8B4, "_titus_target_animate_and_die" },
    { 0x8128D9D4, "_titus_target_check_for_grenade_hits" },
    { 0xFB517681, "_titus_target_timeout" },
    { 0x0E334204, "_tosser" },
    { 0xC36D5441, "_total_attachments" },
    { 0x08CAAFA4, "_total_button_press_counts" },
    { 0x0A351E9C, "_track_0_gunnerturret" },
    { 0xF79B4451, "_track_goal" },
    { 0x83B4105F, "_track_target_position" },
    { 0x16333623, "_transformer_array" },
    { 0xF2A3CDD8, "_trap_activate_func" },
    { 0x41BA2C2D, "_trap_cooldown_time" },
    { 0x58ACF3B0, "_trap_cooling_down" },
    { 0xD561FEF4, "_trap_duration" },
    { 0xD316D185, "_trap_fx_structs" },
    { 0x7E9039D5, "_trap_in_use" },
    { 0xE9ECA7C2, "_trap_light_model_green" },
    { 0xB431FDC4, "_trap_light_model_off" },
    { 0x38F9A2A2, "_trap_light_model_red" },
    { 0x28B00554, "_trap_lightes" },
    { 0x6E010C63, "_trap_lights" },
    { 0x7D0E8F6A, "_trap_movers" },
    { 0x7FA9E522, "_trap_piece" },
    { 0x842844A6, "_trap_switch_model" },
    { 0xBA25534C, "_trap_switches" },
    { 0xEDA4DA54, "_trap_type" },
    { 0x6B570282, "_trap_use_func" },
    { 0x50A70EB1, "_trap_use_trigs" },
    { 0xB998B47E, "_travel_path" },
    { 0x2375CE01, "_travel_path_reverse" },
    { 0xE7C0BC9A, "_treadfx" },
    { 0x3D9553E2, "_tree_sniper" },
    { 0x8D999EAD, "_tree_snipers" },
    { 0x9677A1B3, "_treefall" },
    { 0xA0BE3D10, "_trenchrun_update_goal_pos" },
    { 0x562C18A4, "_trigger" },
    { 0xBE441B7E, "_trigger_dist_sq" },
    { 0x9A2EAE85, "_trigger_fallback" },
    { 0x2E2692D5, "_trigger_init" },
    { 0xB72E5F66, "_trigger_name" },
    { 0x6E162FED, "_trigger_play" },
    { 0x96AC1D9B, "_trigger_stop" },
    { 0x0F62FEEC, "_trigger_wait" },
    { 0x63E2D41D, "_trigger_wait_think" },
    { 0x24899107, "_triggered" },
    { 0xA0DE5919, "_triggered_flinger" },
    { 0x5D4A92D7, "_triggers" },
    { 0xFE49912B, "_triple25" },
    { 0xA9EACEC2, "_trophy_system" },
    { 0x4346D908, "_trophy_system_ammo1" },
    { 0xB54E4843, "_trophy_system_ammo2" },
    { 0xB8940599, "_truck" },
    { 0x5E2A0781, "_truck_bashes_gate_aftermath" },
    { 0x5A384E5B, "_truck_gaz63" },
    { 0xCC3FBD96, "_truck_gaz66" },
    { 0xF52AAD4C, "_truck_gaztigr" },
    { 0x4F49EC0A, "_truck_handle_gunner_jumpoff" },
    { 0xB03EF0C5, "_try_spawn_monkey" },
    { 0xA002C2FD, "_try_spawn_napalm" },
    { 0x2CE55AB6, "_try_spawn_sonic" },
    { 0x1BCD2D70, "_try_spawn_zombie" },
    { 0x2FF664B7, "_trygibbinghead" },
    { 0x5CDE4A52, "_trygibbinglegs" },
    { 0x9A8871D5, "_trygibbinglimb" },
    { 0x781DF901, "_tu" },
    { 0xD12655E8, "_turbine_disappear_fx" },
    { 0xC9AC7046, "_turned_powerup_spawnpoints" },
    { 0xCE9928FF, "_turned_zombie_respawnpoints" },
    { 0x63919591, "_turned_zombie_spawners" },
    { 0xA28CC25E, "_turned_zombie_spawnpoints" },
    { 0x84F620D9, "_turningaimingoff" },
    { 0x48E7266D, "_turningaimingon" },
    { 0x657F041A, "_turnplayer" },
    { 0xEACB153E, "_turret" },
    { 0x10E54F2C, "_turret_disable_fx" },
    { 0x38D1EB28, "_turret_exit_watcher" },
    { 0x2E122851, "_turret_explode_fx" },
    { 0x2E1CF6DC, "_turret_gunners_targets" },
    { 0x76BBAF1B, "_turret_killstreak" },
    { 0xB5DD89EC, "_turret_new_user_think" },
    { 0x4C122E28, "_turret_node_think" },
    { 0x2F8A88FC, "_turret_reveal_firing" },
    { 0xE9136B0A, "_turret_stay_on" },
    { 0x598C06AB, "_turret_think" },
    { 0x50F8F315, "_turret_user_think" },
    { 0x56C58421, "_turrets" },
    { 0x1B1D6166, "_tutorial" },
    { 0x6853B180, "_tutorial_mode" },
    { 0xDEFC5B96, "_tvguidedmissile" },
    { 0x517A27B7, "_tweakables" },
    { 0x781E5388, "_type" },
    { 0xCAF6E724, "_type97" },
    { 0x5FB8B89F, "_typing_time" },
    { 0xA2ACD46C, "_uav" },
    { 0xDA8F1780, "_uaz" },
    { 0xD34994B5, "_uaz_ac130" },
    { 0x77761EDB, "_unbuilt" },
    { 0x86BCB302, "_unclaim_position_on_death" },
    { 0xE30C9A72, "_uncrafted" },
    { 0xB63444C3, "_underwater" },
    { 0x0BF6A877, "_unit_blocks" },
    { 0x7D86B384, "_unit_hud_east" },
    { 0x8E26B8FC, "_unit_hud_north" },
    { 0x86315F1A, "_unit_hud_west" },
    { 0xA66B8EB1, "_unit_type" },
    { 0x6ECA207D, "_unitriggers" },
    { 0xC4D21CA7, "_unlink_node_list" },
    { 0xECF92919, "_unload" },
    { 0xCA519D34, "_update_dr_filters" },
    { 0xD12DB580, "_update_health" },
    { 0x6D0C8C3B, "_update_monkey_variables" },
    { 0xBC57D2E3, "_update_napalm_variables" },
    { 0x60C85FB0, "_update_sonic_variables" },
    { 0xEF683E1C, "_update_stairs" },
    { 0x2117D0CC, "_update_turret_arcs" },
    { 0xF78D9549, "_updateclonepathing" },
    { 0xA51A9278, "_updateevents" },
    { 0x39F3D453, "_updatephalanx" },
    { 0xE94649DF, "_updatephalanxthread" },
    { 0xA75436CB, "_updatethrottle" },
    { 0xD2C9A107, "_updatethrottlethread" },
    { 0x4E956B57, "_use_button_think_threaded" },
    { 0xB03FBBF2, "_use_choke_blockers" },
    { 0x75C740F0, "_use_choke_weapon_hints" },
    { 0xED9DD73F, "_use_extra_blackhole_anims" },
    { 0xF8B279A0, "_use_faceanim" },
    { 0xEF48E497, "_use_trigger_on_group_clear_think" },
    { 0xA2F6D151, "_use_trigger_on_group_count_think" },
    { 0x384414AA, "_use_turret" },
    { 0xAC722BA4, "_user_check" },
    { 0x575997FB, "_uses_crossbow" },
    { 0xCB6F1778, "_uses_default_wallbuy_fx" },
    { 0x476E815C, "_uses_jump_pads" },
    { 0x9B04009A, "_uses_retrievable_ballisitic_knives" },
    { 0xBFE97F24, "_uses_sticky_grenades" },
    { 0x109EA9E1, "_uses_taser_knuckles" },
    { 0x0BC51424, "_util" },
    { 0xB7147828, "_utility" },
    { 0xFB02B03C, "_utility_code" },
    { 0xC0EAB596, "_v" },
    { 0xFFB5FE7F, "_van" },
    { 0x014EF059, "_van_watch_for_notify" },
    { 0x25FE4B20, "_vehicle" },
    { 0x8D689215, "_vehicle_ai" },
    { 0x3B97F8AA, "_vehicle_aianim" },
    { 0x884104BC, "_vehicle_bad_place" },
    { 0xD721248F, "_vehicle_death" },
    { 0x43C349B8, "_vehicle_dials" },
    { 0xA3082174, "_vehicle_effect" },
    { 0x89F37465, "_vehicle_life" },
    { 0x6C179495, "_vehicle_load_assets" },
    { 0xA391C3FC, "_vehicle_load_fx" },
    { 0x9E8EF845, "_vehicle_load_lights" },
    { 0xF71237AC, "_vehicle_load_sirens" },
    { 0xBA74602D, "_vehicle_lvt4" },
    { 0xEC913E01, "_vehicle_missile" },
    { 0x10EAE434, "_vehicle_on_spline" },
    { 0xAF70B4E0, "_vehicle_spawn" },
    { 0xC55E986A, "_vehicle_turret_ai" },
    { 0x98E35BEB, "_vehicle_turret_clear_user" },
    { 0x93AEE59E, "_vehicle_turret_set_user" },
    { 0x7D341345, "_vehicle_use_interior_lights" },
    { 0xA4415575, "_vehicle_utility" },
    { 0x8C1C5548, "_vehicledrive" },
    { 0x6E080CE2, "_vehicledump" },
    { 0x13925E10, "_vehiclenames" },
    { 0x809171CB, "_vehicles" },
    { 0xFB6954D8, "_vehicletype" },
    { 0xB0B058B3, "_vehicletypes" },
    { 0x3470433F, "_ver" },
    { 0x53900014, "_version" },
    { 0x1C547B7B, "_view_restore_angles" },
    { 0xFEC65330, "_viewhands_anim_done" },
    { 0xD41F6FCD, "_viewmodel_delay_hide" },
    { 0xFF11AE70, "_visionset_black_hole_bomb" },
    { 0x4C04CEF3, "_visionset_black_hole_bomb_priority" },
    { 0xD0675B40, "_visionset_black_hole_bomb_transition_time_in" },
    { 0xF5D32C5F, "_visionset_black_hole_bomb_transition_time_out" },
    { 0xAC7CB78D, "_visionset_map_begin" },
    { 0x5398A7BD, "_visionset_map_monkey" },
    { 0x76F73DE1, "_visionset_map_monkeylandon" },
    { 0xEBAB5CCE, "_visionset_map_nopower" },
    { 0x984E4E82, "_visionset_map_poweron" },
    { 0x2AD71389, "_visionset_map_sudden_power" },
    { 0x7FB26AD7, "_visionset_mgr" },
    { 0xC780D1C8, "_visionset_monkey_transition_time_off" },
    { 0x7684F162, "_visionset_monkey_transition_time_on" },
    { 0x169C6DA6, "_visionset_priority_map_begin" },
    { 0x8FB017F4, "_visionset_priority_map_monkey" },
    { 0x09D1E51C, "_visionset_priority_map_monkeylandon" },
    { 0x6E57009D, "_visionset_priority_map_nopower" },
    { 0x67E19079, "_visionset_priority_map_poweron" },
    { 0xB206C064, "_visionset_priority_map_sudden_power" },
    { 0x2E44B821, "_visionset_think_running" },
    { 0x955930D1, "_visionset_zombie_sudden_power_transition_time" },
    { 0x8208F26F, "_visionset_zombie_transition_time" },
    { 0xAA3DED30, "_vox_timer_stop" },
    { 0xB9779287, "_vulture_drop_model" },
    { 0xA082D626, "_vulture_drop_model_thread" },
    { 0x481546A2, "_vulture_model_blink_timeout" },
    { 0xF02EA527, "_vulture_perk_think" },
    { 0x6EB7799C, "_vulture_spawn_fx" },
    { 0x3558208C, "_waco_paco_array" },
    { 0xCF04BD7E, "_wager" },
    { 0x335AE3C3, "_wait" },
    { 0xECEA9713, "_wait_count" },
    { 0x654EECD4, "_wait_for_all_stairs" },
    { 0x9EEE1F8B, "_wait_for_all_stairs_down" },
    { 0xE863F374, "_wait_for_all_stairs_up" },
    { 0xEFE3B5D8, "_wait_for_camera_animation" },
    { 0xBBFB7D7F, "_wait_for_current_user_to_finish" },
    { 0x466EC1DF, "_wait_for_ordered_notify" },
    { 0xAC31277D, "_wait_for_pap_enable" },
    { 0xFE154BFD, "_wait_for_pap_reset" },
    { 0xA2BA9E8D, "_wait_server_time" },
    { 0x9EDF9099, "_wait_string" },
    { 0x5FA09767, "_waitlogic" },
    { 0x9CFAF287, "_waitlogic2" },
    { 0x7120F73C, "_waitlogic_death" },
    { 0x962F9B3D, "_waitlogic_match" },
    { 0xA0A56516, "_waittill" },
    { 0xB8C9ED45, "_waittill_triggered_by_convoy" },
    { 0xE6184097, "_waittill_turret_on_target" },
    { 0x2386A753, "_waittill_user_change" },
    { 0x83095CE9, "_waittillmatch" },
    { 0x81ACA749, "_wallbuy_override_num_bits" },
    { 0x9B66E9BC, "_warlordhuntenemy" },
    { 0x5C91C9C7, "_warp_player_to_maze_fountain" },
    { 0xEF225025, "_wasp" },
    { 0x45145796, "_wasp_death_cb" },
    { 0xDC4A549D, "_watch_for_boost" },
    { 0xA68FB91B, "_watch_for_detonation" },
    { 0xEDC5A52F, "_watch_for_fall" },
    { 0x3E22ED75, "_watch_for_hijacked_vehicles" },
    { 0x0EBC4FD1, "_watch_for_player_switch_to_time_bomb" },
    { 0xC6478283, "_watch_for_powerups" },
    { 0x7750FB8C, "_watch_for_stop_anim" },
    { 0xE88A4280, "_watch_toggle_suit" },
    { 0x122E3E3D, "_watchmodeswap" },
    { 0x2EAA9DF1, "_wave_guys_spawned" },
    { 0x91D0DABD, "_wave_hits_ai" },
    { 0xFE1E2DDE, "_wave_hits_debris" },
    { 0x2361BDD0, "_wave_hits_player" },
    { 0xAE2674AB, "_wavelength" },
    { 0xCAF987F1, "_waves_exploders" },
    { 0x9E922533, "_waw" },
    { 0xC01FD319, "_waw_anim" },
    { 0xCCA512B8, "_waw_destructible" },
    { 0x95F8D765, "_waw_destructible_opel_blitz" },
    { 0xDE53EACC, "_waw_mg_penetration" },
    { 0x8FA6C1F0, "_waw_mgturret" },
    { 0x737B0D6E, "_waw_spawner" },
    { 0x3F3B183A, "_waw_utility" },
    { 0xA5828791, "_waw_zombiemode" },
    { 0xEE4F2820, "_waw_zombiemode_ai_japanese" },
    { 0xB4D7FD72, "_waw_zombiemode_audio" },
    { 0x398BDB45, "_waw_zombiemode_radio" },
    { 0xC8B1C734, "_wawmp" },
    { 0x0A6F5114, "_wc51" },
    { 0xA8C3A8A5, "_weapon_show_hint_choke" },
    { 0x8E536BDE, "_weapon_utils" },
    { 0xAE769520, "_weaponobjects" },
    { 0x891BFD36, "_weaponobjects_on_player_connect_override" },
    { 0xAE42E42F, "_weapons" },
    { 0x5E4977E4, "_weather" },
    { 0x97B7986A, "_weaver_int_anim" },
    { 0x3A737D45, "_west" },
    { 0x7B57BB5A, "_wetness_monitor" },
    { 0x8ACB86FC, "_whirlwind_attract_anim" },
    { 0x514B6900, "_white_models" },
    { 0xA7A4DF4C, "_whoswho_reject_node_override_func" },
    { 0xF537C556, "_wiiu_audio_optimizations" },
    { 0x46E615EC, "_willys" },
    { 0xBF12D79A, "_win" },
    { 0x801FCFDB, "_win_round" },
    { 0x6B7A8E8D, "_wind_shake" },
    { 0x9C7A2141, "_wingsuit_ally_direct_vo" },
    { 0x945EAABC, "_world_state_stored_for_minigame" },
    { 0xDAFD84D6, "_wounded_animnames" },
    { 0xBE4F47CD, "_wounded_anims" },
    { 0x08446BA1, "_wounded_auto_delete_thread" },
    { 0x0CEFAA68, "_x" },
    { 0x32F224D1, "_y" },
    { 0x8AA02C4F, "_yemeni_attacked_player" },
    { 0x666BE39A, "_yemeni_attacked_player_" },
    { 0x58F49F3A, "_z" },
    { 0xB2D1749F, "_zbv_vox_last_update_time" },
    { 0x2380489A, "_zcleansed_weapon_progression" },
    { 0xE1E94D2B, "_zm" },
    { 0x24197962, "_zm_aat_blast_furnace" },
    { 0xB88AE563, "_zm_aat_dead_wire" },
    { 0xA5FCA650, "_zm_aat_fire_works" },
    { 0xFE043E22, "_zm_aat_thunder_wall" },
    { 0xFF4DF48D, "_zm_aat_turned" },
    { 0x2B5F597E, "_zm_afterlife" },
    { 0x39E1BB6C, "_zm_ai_astro" },
    { 0x0F2FB6D6, "_zm_ai_avogadro" },
    { 0xB61C832F, "_zm_ai_basic" },
    { 0x24C905A0, "_zm_ai_brutus" },
    { 0xE60180E2, "_zm_ai_dogs" },
    { 0x1064B17D, "_zm_ai_faller" },
    { 0xF91A6908, "_zm_ai_ghost" },
    { 0x08D55A02, "_zm_ai_ghost_ffotd" },
    { 0xC9206DC8, "_zm_ai_leaper" },
    { 0x102AA26E, "_zm_ai_mechz" },
    { 0x0E5BE35F, "_zm_ai_mechz_booster" },
    { 0x1BFB961C, "_zm_ai_mechz_claw" },
    { 0x7850AF8A, "_zm_ai_mechz_dev" },
    { 0xCF8DAAA0, "_zm_ai_mechz_ffotd" },
    { 0xAA627C27, "_zm_ai_mechz_ft" },
    { 0xEB8FC932, "_zm_ai_quad" },
    { 0xEB9EC75A, "_zm_ai_quadrotor" },
    { 0xF2AACB17, "_zm_ai_raps" },
    { 0xDA90E583, "_zm_ai_screecher" },
    { 0xAD40A409, "_zm_ai_sloth" },
    { 0xC573D7D7, "_zm_ai_sloth_buildables" },
    { 0xBFFF6394, "_zm_ai_sloth_crawler" },
    { 0xCF13B787, "_zm_ai_sloth_ffotd" },
    { 0x171F43F0, "_zm_ai_sloth_magicbox" },
    { 0xA26F603C, "_zm_ai_sloth_utility" },
    { 0xC8851CBA, "_zm_ai_wasp" },
    { 0x3F274759, "_zm_attackables" },
    { 0x75D12A04, "_zm_audio" },
    { 0x8D7FA4DC, "_zm_audio_announcer" },
    { 0xFD8CD69C, "_zm_banking" },
    { 0x36AF30BC, "_zm_behavior" },
    { 0xF9776F19, "_zm_behavior_utility" },
    { 0x08668B1F, "_zm_bgb" },
    { 0xA248C2B5, "_zm_bgb_machine" },
    { 0x7607E3C1, "_zm_bgb_token" },
    { 0x7D8387A0, "_zm_blocker_trigger_think_return_override" },
    { 0xDAA8C0C7, "_zm_blockers" },
    { 0xBB65A071, "_zm_bot" },
    { 0x29D862D9, "_zm_build_trigger_from_unitrigger_stub_override" },
    { 0x25CDB4D5, "_zm_buildables" },
    { 0xB0322B85, "_zm_buildables_pooled" },
    { 0x7505D560, "_zm_challenges" },
    { 0x73C03815, "_zm_chugabud" },
    { 0x8E365F05, "_zm_clone" },
    { 0x2A1A0FE2, "_zm_containment" },
    { 0xECD9B864, "_zm_craft_shield" },
    { 0x73740A1F, "_zm_craftables" },
    { 0x6744DA12, "_zm_daily_challenges" },
    { 0x4019EAAA, "_zm_deathcard" },
    { 0x98A305BF, "_zm_demo" },
    { 0xB7C0C654, "_zm_devgui" },
    { 0xFB9DDAEB, "_zm_dogs" },
    { 0xDB9F014D, "_zm_electric_cherry" },
    { 0x1ED465ED, "_zm_equip_electrictrap" },
    { 0x59A2EF88, "_zm_equip_gasmask" },
    { 0x248404D7, "_zm_equip_hacker" },
    { 0x77F4F530, "_zm_equip_headchopper" },
    { 0x714A2B1D, "_zm_equip_springpad" },
    { 0x94ACBFA9, "_zm_equip_subwoofer" },
    { 0xDA96487A, "_zm_equip_turbine" },
    { 0x96AC6CA3, "_zm_equip_turret" },
    { 0x379AFB96, "_zm_equipment" },
    { 0xF6AC89B9, "_zm_ffotd" },
    { 0xBFB381F7, "_zm_game_mode_objects" },
    { 0xC50C0A9F, "_zm_game_module" },
    { 0xFEE3B57B, "_zm_game_module_cleansed" },
    { 0x3A813F27, "_zm_game_module_grief" },
    { 0xCBC84993, "_zm_game_module_meat" },
    { 0x8870E85A, "_zm_game_module_meat_utility" },
    { 0xDFD3D673, "_zm_game_module_nml" },
    { 0x4C76AB00, "_zm_game_module_pitted" },
    { 0xA1FF9FA9, "_zm_game_module_race" },
    { 0x5C23EFCD, "_zm_game_module_standard" },
    { 0x0EFA4DC4, "_zm_game_module_turned" },
    { 0x8D58900E, "_zm_game_module_utility" },
    { 0x29A9A648, "_zm_gametype" },
    { 0x07C64021, "_zm_gump" },
    { 0xCC725BEC, "_zm_hackables_boards" },
    { 0x662BB29A, "_zm_hackables_box" },
    { 0x2419F23E, "_zm_hackables_doors" },
    { 0x390816CB, "_zm_hackables_packapunch" },
    { 0x635744A2, "_zm_hackables_perks" },
    { 0x848D971C, "_zm_hackables_powerups" },
    { 0xEE679A3C, "_zm_hackables_wallbuys" },
    { 0xCA76B875, "_zm_hero_weapon" },
    { 0x904468F0, "_zm_jump_pad" },
    { 0x5F62C06E, "_zm_laststand" },
    { 0x078DB6AA, "_zm_lightning_chain" },
    { 0x572B2502, "_zm_magicbox" },
    { 0xFE5CD56C, "_zm_magicbox_lock" },
    { 0xBD3C4E5C, "_zm_magicbox_prison" },
    { 0xC60CE06B, "_zm_magicbox_tomb" },
    { 0xCBD1277D, "_zm_melee_weapon" },
    { 0xCE42AE18, "_zm_mgturret" },
    { 0x0D9AC6AE, "_zm_mgturret_firing" },
    { 0x94EBEF3F, "_zm_net" },
    { 0xD0AD3850, "_zm_pack_a_punch" },
    { 0x32945EF3, "_zm_pack_a_punch_util" },
    { 0x3F267758, "_zm_perk_additionalprimaryweapon" },
    { 0x3306894F, "_zm_perk_deadshot" },
    { 0x45520E67, "_zm_perk_divetonuke" },
    { 0x2F959E3D, "_zm_perk_doubletap2" },
    { 0xD9BB95B0, "_zm_perk_electric_cherry" },
    { 0x7ADBB35F, "_zm_perk_flopper" },
    { 0x101E514D, "_zm_perk_juggernaut" },
    { 0xE51964E6, "_zm_perk_quick_revive" },
    { 0x354D89FC, "_zm_perk_random" },
    { 0x75DAF0A5, "_zm_perk_sleight_of_hand" },
    { 0xD5DECB2C, "_zm_perk_staminup" },
    { 0x6E052084, "_zm_perk_vulture" },
    { 0x3501FC50, "_zm_perk_widows_wine" },
    { 0x79EB0095, "_zm_perks" },
    { 0xEBE01952, "_zm_pers_upgrades" },
    { 0x655483E8, "_zm_pers_upgrades_functions" },
    { 0xD3ED2A46, "_zm_pers_upgrades_system" },
    { 0x4EFACC5F, "_zm_placeable_mine" },
    { 0x1D5122A1, "_zm_player" },
    { 0x58630507, "_zm_playerhealth" },
    { 0xB11A7B89, "_zm_power" },
    { 0xA4397543, "_zm_powerup_carpenter" },
    { 0x6167DE30, "_zm_powerup_double_points" },
    { 0xFE39F9F9, "_zm_powerup_fire_sale" },
    { 0x48983212, "_zm_powerup_free_perk" },
    { 0xD459F6AB, "_zm_powerup_full_ammo" },
    { 0x7C94586D, "_zm_powerup_insta_kill" },
    { 0xE72EF9AA, "_zm_powerup_nuke" },
    { 0x938EC945, "_zm_powerup_shield_charge" },
    { 0x15C03305, "_zm_powerup_weapon_minigun" },
    { 0x6A1C4F38, "_zm_powerup_ww_grenade" },
    { 0xC970334E, "_zm_powerup_zombie_blood" },
    { 0xE4E82A5D, "_zm_powerups" },
    { 0x68BF0E78, "_zm_puppet" },
    { 0x0057D358, "_zm_race_utility" },
    { 0x31FAF553, "_zm_riotshield" },
    { 0x7FC1414F, "_zm_riotshield_prison" },
    { 0x764BBB14, "_zm_riotshield_tomb" },
    { 0xB093ED81, "_zm_scob_math_utility" },
    { 0xF0C94A67, "_zm_scob_perk_utility" },
    { 0xDC7D83B6, "_zm_scob_utility" },
    { 0xD06AA098, "_zm_score" },
    { 0x50B80CF6, "_zm_server_throttle" },
    { 0x67EA815A, "_zm_sidequests" },
    { 0x6E3BA9E6, "_zm_spawner" },
    { 0x9E6167C3, "_zm_stats" },
    { 0xE54AA859, "_zm_timer" },
    { 0xE742E0C3, "_zm_tombstone" },
    { 0xAFD31F87, "_zm_trap_electric" },
    { 0x65E2024A, "_zm_traps" },
    { 0x6078CDD8, "_zm_turned" },
    { 0x00A99ABB, "_zm_unitgrigger" },
    { 0x7BEFBC3C, "_zm_unitrigger" },
    { 0x7F5097E2, "_zm_utility" },
    { 0x017B875D, "_zm_vulture" },
    { 0xFD39407D, "_zm_weap_annihilator" },
    { 0xD5FBA823, "_zm_weap_ballistic_knife" },
    { 0xBA8619AC, "_zm_weap_beacon" },
    { 0x1DDA1281, "_zm_weap_black_hole_bomb" },
    { 0x07237348, "_zm_weap_blundersplat" },
    { 0x128A4BDB, "_zm_weap_bouncingbetty" },
    { 0xF492499A, "_zm_weap_bowie" },
    { 0xE815346C, "_zm_weap_claymore" },
    { 0x6318AF6C, "_zm_weap_crossbow" },
    { 0x570C8452, "_zm_weap_cymbal_monkey" },
    { 0x86252295, "_zm_weap_emp_bomb" },
    { 0x1110500D, "_zm_weap_freezegun" },
    { 0xB6BA8F1B, "_zm_weap_gravityspikes" },
    { 0x09EC4B2F, "_zm_weap_idgun" },
    { 0x3B0F0699, "_zm_weap_jetgun" },
    { 0xC9231197, "_zm_weap_microwavegun" },
    { 0xCCB5D78D, "_zm_weap_octobomb" },
    { 0xC70BEA9A, "_zm_weap_one_inch_punch" },
    { 0xEE14C046, "_zm_weap_quantum_bomb" },
    { 0xE34D2245, "_zm_weap_raygun_mark3" },
    { 0xE3B844E9, "_zm_weap_riotshield" },
    { 0xD4E5F015, "_zm_weap_riotshield_prison" },
    { 0x2CE63D52, "_zm_weap_riotshield_tomb" },
    { 0xBBF70183, "_zm_weap_rocketshield" },
    { 0xE9A3CBC4, "_zm_weap_slipgun" },
    { 0x157D2477, "_zm_weap_slowgun" },
    { 0xE4D85DEF, "_zm_weap_staff_air" },
    { 0xF2D5D5B5, "_zm_weap_staff_fire" },
    { 0x6C21B75D, "_zm_weap_staff_lightning" },
    { 0x84C21D76, "_zm_weap_staff_revive" },
    { 0x4777D31E, "_zm_weap_staff_water" },
    { 0xB41A9019, "_zm_weap_tazer_knuckles" },
    { 0x40B4687D, "_zm_weap_tesla" },
    { 0x4DE902A0, "_zm_weap_thundergun" },
    { 0xD157CB6A, "_zm_weap_time_bomb" },
    { 0xEA3A962A, "_zm_weap_tomahawk" },
    { 0x737E7A45, "_zm_weapon_locker" },
    { 0x99061B99, "_zm_weapons" },
    { 0xEBC2E8DE, "_zm_zdraw" },
    { 0xC37879A8, "_zm_zone_manager" },
    { 0xAEF92DAE, "_zm_zonemgr" },
    { 0x6BDA12F0, "_zmbaivox_specialtype" },
    { 0xC1934A9E, "_zmbl_ignore" },
    { 0xAEEF9FB0, "_zmbvoxgametypespecific" },
    { 0x47D318B8, "_zmbvoxlevelspecific" },
    { 0x6BBC5E4B, "_zombie_actor_flag_director_death" },
    { 0x00D78AA1, "_zombie_actor_flag_director_light" },
    { 0x1D4C8887, "_zombie_actor_flag_directors_steps" },
    { 0xF45213BA, "_zombie_actor_flag_electrified" },
    { 0x5A3D9424, "_zombie_actor_flag_freezegun_extremity_damage_fx" },
    { 0xA9FFB4BC, "_zombie_actor_flag_freezegun_torso_damage_fx" },
    { 0x6AC4A70D, "_zombie_actor_flag_humangun_hit_response" },
    { 0x59F7668E, "_zombie_actor_flag_humangun_upgraded_hit_response" },
    { 0x635B8979, "_zombie_actor_flag_launch_ragdoll" },
    { 0x88DFC711, "_zombie_actor_flag_low_gravity" },
    { 0xCCD473D0, "_zombie_actor_flag_microwavegun_expand_response" },
    { 0x622B3AA6, "_zombie_actor_flag_microwavegun_initial_hit_response" },
    { 0xE553E8BC, "_zombie_actor_zombie_riser_fx" },
    { 0x6B4F1354, "_zombie_actor_zombie_riser_fx_water" },
    { 0xE80B9B10, "_zombie_actor_zombie_riser_lowg_fx" },
    { 0x180FECEA, "_zombie_blood_achievement_think" },
    { 0x89CBBE56, "_zombie_board_taunt" },
    { 0xB23D592E, "_zombie_board_tearing" },
    { 0x237B30E2, "_zombie_custom_add_weapons" },
    { 0x530F92DF, "_zombie_custom_spawn_logic" },
    { 0x3B0D75E8, "_zombie_deaths" },
    { 0x547FD927, "_zombie_director_death_torso_fx" },
    { 0xF9EE96FB, "_zombie_director_impact_humangun_fx" },
    { 0x120CDE49, "_zombie_director_light_fx" },
    { 0x7125D0B9, "_zombie_fall_anims" },
    { 0xF844E501, "_zombie_flush" },
    { 0xB23121EA, "_zombie_fog_list" },
    { 0xAEE0AB31, "_zombie_freezegun_death" },
    { 0xCABFB398, "_zombie_freezegun_death_missing_legs" },
    { 0x58A9B574, "_zombie_game_over" },
    { 0x105A7C79, "_zombie_gamemodemain" },
    { 0xDD6783D5, "_zombie_gamemodeprecache" },
    { 0xFD22CC2F, "_zombie_getups" },
    { 0xD9ECD56B, "_zombie_gib_piece_index_all" },
    { 0xAFF70DC5, "_zombie_gib_piece_index_guts" },
    { 0x16CD7091, "_zombie_gib_piece_index_hat" },
    { 0x4674B214, "_zombie_gib_piece_index_head" },
    { 0xCD79FA6E, "_zombie_gib_piece_index_left_arm" },
    { 0xAD17D674, "_zombie_gib_piece_index_left_leg" },
    { 0x91BDBBB7, "_zombie_gib_piece_index_right_arm" },
    { 0x45A6FFDD, "_zombie_gib_piece_index_right_leg" },
    { 0xDE42E7BF, "_zombie_grabbable_poi_distance_override" },
    { 0x22135E51, "_zombie_gun_before_minigun" },
    { 0xA7101ED5, "_zombie_gun_before_tesla" },
    { 0xB9554289, "_zombie_hacker_trigger_pool_size" },
    { 0x35F13766, "_zombie_human_array" },
    { 0xE1245152, "_zombie_knockdowns" },
    { 0x40284F1B, "_zombie_melee" },
    { 0x720C62C7, "_zombie_melee_crawl" },
    { 0x640F61CF, "_zombie_microwavegun_sizzle_crawl_death" },
    { 0x3E69C017, "_zombie_microwavegun_sizzle_death" },
    { 0x1B717099, "_zombie_microwavegun_zap_crawl_death" },
    { 0x8084C1A1, "_zombie_microwavegun_zap_death" },
    { 0xBBAE3754, "_zombie_minigun_powerup_last_stand_func" },
    { 0x70D1FCF0, "_zombie_mode" },
    { 0x68BB3A1D, "_zombie_path_timer_override" },
    { 0x383F1169, "_zombie_player_flag_cloak_weapon" },
    { 0xED31DDCB, "_zombie_player_flag_deadshot_perk" },
    { 0x5AC40040, "_zombie_player_flag_dive2nuke_vision" },
    { 0x42E71CCE, "_zombie_radio_clientflag" },
    { 0xF2460785, "_zombie_rise_anims" },
    { 0xA637D982, "_zombie_rise_death_anims" },
    { 0x45B1EF59, "_zombie_run_melee" },
    { 0xDC8F8121, "_zombie_run_taunt" },
    { 0xE0D424A5, "_zombie_scriptmover_flag_board_horizontal_fx" },
    { 0x1C12AB17, "_zombie_scriptmover_flag_board_vertical_fx" },
    { 0x1E5E04B8, "_zombie_scriptmover_flag_box_random" },
    { 0xA7441CE5, "_zombie_scriptmover_flag_rock_fx" },
    { 0xD24533C5, "_zombie_sidequests" },
    { 0xCE2121AA, "_zombie_spawning" },
    { 0x273FFD9E, "_zombie_stumpy_melee" },
    { 0x1E2CBC57, "_zombie_taunt" },
    { 0x2A98BE55, "_zombie_tesla_crawl_death" },
    { 0xC58BB885, "_zombie_tesla_death" },
    { 0xAF019814, "_zombie_tesla_deaths" },
    { 0xF3C750A8, "_zombie_tesla_powerup_last_stand_func" },
    { 0x6FA0AC6D, "_zombie_using_humangun" },
    { 0x9E3F5D0F, "_zombie_utility" },
    { 0xEED07962, "_zombie_visionset_list" },
    { 0xF46A7BDB, "_zombie_walk_melee" },
    { 0xFEBEB728, "_zombie_weapon_before_powerup" },
    { 0x99BC115B, "_zombiecbfunc" },
    { 0x756C5441, "_zombiekmode_deathcard" },
    { 0x8D20B93B, "_zombiemode" },
    { 0x790E34C8, "_zombiemode_ability" },
    { 0x5395C30B, "_zombiemode_achievement" },
    { 0x1A2D6841, "_zombiemode_ai_ape" },
    { 0x3A0F4DFC, "_zombiemode_ai_astro" },
    { 0x4A7BECCB, "_zombiemode_ai_director" },
    { 0xB46BF052, "_zombiemode_ai_dogs" },
    { 0xC04E156D, "_zombiemode_ai_faller" },
    { 0x93F9BBC0, "_zombiemode_ai_monkey" },
    { 0x7447BAE8, "_zombiemode_ai_napalm" },
    { 0xA61D51C2, "_zombiemode_ai_quad" },
    { 0x70CB8255, "_zombiemode_ai_sonic" },
    { 0xDAF7ED61, "_zombiemode_ai_thief" },
    { 0xB1B7A7C6, "_zombiemode_animated_intro" },
    { 0xED3454FF, "_zombiemode_asylum" },
    { 0x92EBF2D4, "_zombiemode_audio" },
    { 0x7EE19080, "_zombiemode_auto_turret" },
    { 0xCF761DC6, "_zombiemode_betty" },
    { 0x0F38AED9, "_zombiemode_blocker_trigger_extra_thread" },
    { 0x23714997, "_zombiemode_blockers" },
    { 0x16A286E0, "_zombiemode_blockers_new" },
    { 0x538CA020, "_zombiemode_bowie" },
    { 0xA1BADC10, "_zombiemode_challenges" },
    { 0x52B65FB5, "_zombiemode_check_firesale_loc_valid_func" },
    { 0xD4C6B234, "_zombiemode_chest_joker_chance_mutator_func" },
    { 0x3E719D28, "_zombiemode_chest_joker_chance_override_func" },
    { 0x0EC1AE06, "_zombiemode_claymore" },
    { 0x5C8F3FBC, "_zombiemode_custom_box_move_logic" },
    { 0x51C28F6C, "_zombiemode_cymbal_monkey" },
    { 0x51433E1A, "_zombiemode_deathcard" },
    { 0xE3BF0924, "_zombiemode_devgui" },
    { 0x4277562B, "_zombiemode_dissolve" },
    { 0xA945471B, "_zombiemode_dogs" },
    { 0x50265CB8, "_zombiemode_equip_gasmask" },
    { 0xA076AE07, "_zombiemode_equip_hacker" },
    { 0xD4E85146, "_zombiemode_equipment" },
    { 0xB97EF409, "_zombiemode_ffotd" },
    { 0x67867C3C, "_zombiemode_hackables_boards" },
    { 0x5B2366AA, "_zombiemode_hackables_box" },
    { 0x33FA09EE, "_zombiemode_hackables_doors" },
    { 0xC88B34BB, "_zombiemode_hackables_packapunch" },
    { 0x1B52D772, "_zombiemode_hackables_perks" },
    { 0x1F14F62C, "_zombiemode_hackables_powerups" },
    { 0x7E7C3E8C, "_zombiemode_hackables_wallbuys" },
    { 0xE468FB40, "_zombiemode_jump_pad" },
    { 0x21A1161E, "_zombiemode_load" },
    { 0x3686642E, "_zombiemode_money" },
    { 0xA9E1534F, "_zombiemode_net" },
    { 0x181FA765, "_zombiemode_perks" },
    { 0xC241280B, "_zombiemode_player_zipline" },
    { 0xCC57EE35, "_zombiemode_post_respawn_callback" },
    { 0xB771D48D, "_zombiemode_powercell" },
    { 0x775A2693, "_zombiemode_powerup_grab" },
    { 0x58269B30, "_zombiemode_powerup_zombie_grab" },
    { 0x0B277A6D, "_zombiemode_powerups" },
    { 0x9C6E4425, "_zombiemode_protips" },
    { 0x93934450, "_zombiemode_prototype" },
    { 0xF14220D3, "_zombiemode_radio" },
    { 0x59B8ED4C, "_zombiemode_rank" },
    { 0xB2443D08, "_zombiemode_score" },
    { 0x21827946, "_zombiemode_server_throttle" },
    { 0x83D456E9, "_zombiemode_sidequest_icon_offset" },
    { 0xEDF21E2A, "_zombiemode_sidequests" },
    { 0x43AC811F, "_zombiemode_solo" },
    { 0x02D0DED6, "_zombiemode_spawner" },
    { 0x54209A84, "_zombiemode_spawner_asylum" },
    { 0x32D88051, "_zombiemode_spawner_prototype" },
    { 0x3FDD7E2F, "_zombiemode_special_drop_setup" },
    { 0xAF0A6E6F, "_zombiemode_spikemore" },
    { 0x1023E8F3, "_zombiemode_tesla" },
    { 0x910B3B09, "_zombiemode_timer" },
    { 0x65A75979, "_zombiemode_trap_activate_funcs" },
    { 0xF76F2513, "_zombiemode_trap_use_funcs" },
    { 0x838CE8FA, "_zombiemode_traps" },
    { 0x4501B8CF, "_zombiemode_user" },
    { 0x992E92D2, "_zombiemode_utility" },
    { 0xF5AB27D1, "_zombiemode_utility_raven" },
    { 0x17158831, "_zombiemode_weap_black_hole_bomb" },
    { 0xF8C17CBC, "_zombiemode_weap_crossbow" },
    { 0x934E54E2, "_zombiemode_weap_cymbal_monkey" },
    { 0x0E4BBC1D, "_zombiemode_weap_freezegun" },
    { 0x7EB14A23, "_zombiemode_weap_humangun" },
    { 0xB61AF3E7, "_zombiemode_weap_microwavegun" },
    { 0xD8691655, "_zombiemode_weap_nesting_dolls" },
    { 0x11B75876, "_zombiemode_weap_quantum_bomb" },
    { 0x1B55A92A, "_zombiemode_weap_shrink_ray" },
    { 0x059CB1FB, "_zombiemode_weap_sickle" },
    { 0x29A2F3A1, "_zombiemode_weap_sniper_explosive" },
    { 0x38CF5AED, "_zombiemode_weap_tesla" },
    { 0x55280B70, "_zombiemode_weap_thundergun" },
    { 0x65548638, "_zombiemode_weapon_box" },
    { 0x64B87AE9, "_zombiemode_weapons" },
    { 0x024AE3FB, "_zombiemode_weapons_sumpf" },
    { 0x9534E1D8, "_zombiemode_zone_manager" },
    { 0x9504E174, "_zombies_go_back_into_ai_when_time_bomb_is_done" },
    { 0x5B0881C3, "_zombies_ignoring_all" },
    { 0x5B756D4B, "_zombies_reacquire_player_after_leaving_stink" },
    { 0x31D3E83C, "_zombies_round_spawn_failsafe" },
    { 0xB870DA6B, "_zombietron" },
    { 0xE7907A71, "_zombietron_ai_ape" },
    { 0xF68778F6, "_zombietron_ai_buffalo" },
    { 0x6D253F73, "_zombietron_ai_dog" },
    { 0xCBBC6B40, "_zombietron_ai_engineer" },
    { 0x8E302F72, "_zombietron_ai_quad" },
    { 0xDE7D90A0, "_zombietron_challenges" },
    { 0x64676F9C, "_zombietron_fate" },
    { 0xC69D964E, "_zombietron_load" },
    { 0x04D77571, "_zombietron_main" },
    { 0xDAC8EB1D, "_zombietron_pickups" },
    { 0x969F36E9, "_zombietron_scenes" },
    { 0x1F45D2D8, "_zombietron_score" },
    { 0x5346AF26, "_zombietron_spawner" },
    { 0x11790B22, "_zombietron_utility" },
    { 0xC7D1ACA6, "_zombietron_weapon" },
    { 0x1BAAF9FF, "_zombiezigzagdistancemax" },
    { 0x6E8268C1, "_zombiezigzagdistancemin" },
    { 0xD25E7669, "_zombiezigzagtimemax" },
    { 0xEFCE0B17, "_zombiezigzagtimemin" },
    { 0x146D3164, "_zombimode" },
    { 0x7B46C2AD, "_zones" },
    { 0x714651F7, "_zpu" },
    { 0xCCE25722, "_zpu_antiair" },
    { 0x93EB4E19, "_zt_actor_cf_blood" },
    { 0x8224C57E, "_zt_actor_cf_gib_death_p1" },
    { 0x5C224B15, "_zt_actor_cf_gib_death_p2" },
    { 0x361FD0AC, "_zt_actor_cf_gib_death_p3" },
    { 0x101D5643, "_zt_actor_cf_gib_death_p4" },
    { 0xF4CAAC87, "_zt_actor_cf_killed_by_heli" },
    { 0x9D3D0A20, "_zt_actor_cf_launch_and_burn" },
    { 0x639D87AE, "_zt_player_cf_heli_pilot" },
    { 0x6A3B1755, "_zt_player_cf_lightning" },
    { 0xE729D904, "_zt_player_cf_show_scores" },
    { 0x3A8C87C0, "_zt_player_cf_start_smart_bomb" },
    { 0xD85E0A5D, "_zt_player_cf_updateprofile" },
    { 0xA50C8467, "_zt_scriptmover_cf_elec_trap" },
    { 0x5CF753A4, "_zt_scriptmover_cf_powerup" },
    { 0x9508DBE3, "_zt_scriptmover_cf_powerup_pickup" },
    { 0xEE67C4D8, "_zt_scriptmover_cf_sacred_cow" },
    { 0xF96BC9FE, "a" },
    { 0xE92868F3, "a1" },
    { 0x9D758FF9, "a10" },
    { 0x55F66D4D, "a1d" },
    { 0xF8F788B9, "a1d_01b" },
    { 0x99A68A5C, "a1d_01b_render" },
    { 0x23EF3732, "a1d_02" },
    { 0x88E0C19D, "a1d_02_render" },
    { 0x6007C62C, "a1m" },
    { 0x90728642, "a1m_01" },
    { 0xD736D46D, "a1m_01_render" },
    { 0xDA6FCA69, "a1m_02b" },
    { 0x7847238C, "a1m_02b_render" },
    { 0x8E2F2099, "a1m_03a" },
    { 0x58A9DAFC, "a1m_03a_render" },
    { 0xB4319B02, "a1m_03b" },
    { 0x4567F82D, "a1m_03b_render" },
    { 0xDA34156B, "a1m_03c" },
    { 0x5EA1C992, "a1m_03c_render" },
    { 0x00368FD4, "a1m_03d" },
    { 0x2C34D533, "a1m_03d_render" },
    { 0x4E7EEA4F, "a1m_04" },
    { 0xCA140476, "a1m_04_render" },
    { 0x7720F9B8, "a2" },
    { 0x2AB371D2, "a2j_01b" },
    { 0x409F56FD, "a2j_01b_render" },
    { 0x50B5EC3B, "a2j_01c" },
    { 0x5D93ACA2, "a2j_01c_render" },
    { 0x2AE1B55B, "a2j_02" },
    { 0x5CA61102, "a2j_02_render" },
    { 0x04DF3AF2, "a2j_03" },
    { 0x68CFA55D, "a2j_03_render" },
    { 0x1A49AA2C, "a2s_02" },
    { 0x2864BCDB, "a2s_02_render" },
    { 0x404C2495, "a2s_03" },
    { 0xD11E6CE8, "a2s_03_render" },
    { 0xCE44B55A, "a2s_04" },
    { 0xA7316875, "a2s_04_render" },
    { 0x9D237421, "a3" },
    { 0x2F4508FB, "a38" },
    { 0x1A184798, "a3a_01" },
    { 0xB9EFD807, "a3a_01_render" },
    { 0x8C1FB6D3, "a3a_02" },
    { 0x3630264A, "a3a_02_render" },
    { 0x829B06A0, "a3a_02a" },
    { 0x210DA89F, "a3a_02a_render" },
    { 0xF4A275DB, "a3a_02b" },
    { 0x5C50CE82, "a3a_02b_render" },
    { 0x04DFD7DB, "a3d_01" },
    { 0xE1B7E482, "a3d_01_render" },
    { 0x85B75420, "a_a_locs" },
    { 0xBEE460B2, "a_active_anim_models" },
    { 0xB16853E0, "a_active_anims" },
    { 0x8C4A2BBB, "a_active_grenades" },
    { 0xEBC2DAB6, "a_active_instances" },
    { 0xC7B83171, "a_active_scenes" },
    { 0xB9A2175A, "a_active_vorticies" },
    { 0xE4FCF5FF, "a_active_zones" },
    { 0x8060FF07, "a_actors" },
    { 0xA50B18B1, "a_adjacencies" },
    { 0x56C4B0EB, "a_adjacent_zones" },
    { 0x14040696, "a_afterlife_door_interacts" },
    { 0x753ED758, "a_afterlife_interact" },
    { 0xFBCCC833, "a_afterlife_interacts" },
    { 0x99729F54, "a_afterlife_props" },
    { 0x9D77BE25, "a_afterlife_triggers" },
    { 0x8C8EC6F4, "a_aggressive_guys" },
    { 0xE3B635FB, "a_ai" },
    { 0x0AC9C19B, "a_ai_1" },
    { 0x98C25260, "a_ai_2" },
    { 0x933BBC2C, "a_ai_allies" },
    { 0xD564D598, "a_ai_anims" },
    { 0x7B3A5649, "a_ai_array" },
    { 0xC1470355, "a_ai_axis" },
    { 0x84F1697A, "a_ai_balcony" },
    { 0x3C2F63D3, "a_ai_balcony_allies" },
    { 0x6825A6DC, "a_ai_balcony_cartel" },
    { 0x84396F78, "a_ai_bpguys" },
    { 0x966A7A63, "a_ai_breachers" },
    { 0x45D03BF9, "a_ai_bridge" },
    { 0x93E10F96, "a_ai_bridge_allies" },
    { 0xAAD5B545, "a_ai_building_guys" },
    { 0x2260972C, "a_ai_by_vehicle" },
    { 0x713BE6EE, "a_ai_camo" },
    { 0x4067D2C8, "a_ai_cart" },
    { 0xE3581D23, "a_ai_cartel" },
    { 0x7F96D948, "a_ai_civ" },
    { 0x5D45C2DA, "a_ai_claws" },
    { 0x0EEAEAEC, "a_ai_club_terrorists" },
    { 0xA1FD7E25, "a_ai_corpses" },
    { 0xD3C292C6, "a_ai_courtyard_guys" },
    { 0x7A46D1A3, "a_ai_crossover_guys" },
    { 0x81170B2A, "a_ai_defenders" },
    { 0x24BBF032, "a_ai_enemies" },
    { 0x1F6E1FDA, "a_ai_enemy" },
    { 0xA27B5EC2, "a_ai_explosives_workers" },
    { 0xDC2FA395, "a_ai_farm_guys" },
    { 0xCAC29130, "a_ai_flankers" },
    { 0xC94C30CE, "a_ai_flashbangers" },
    { 0x9C18A018, "a_ai_foreshadow" },
    { 0xBD4F461E, "a_ai_friendlys" },
    { 0xB2C486EA, "a_ai_frogger" },
    { 0xF8712C8B, "a_ai_gauntlet_guys" },
    { 0x70AE6B28, "a_ai_guards" },
    { 0x997800BE, "a_ai_gunners" },
    { 0xE2D5CFEF, "a_ai_guy" },
    { 0x8BC07636, "a_ai_guys" },
    { 0x9886BA1C, "a_ai_hangar_seals" },
    { 0xCCEA10A6, "a_ai_heroes" },
    { 0x687C18BA, "a_ai_initial" },
    { 0x41B0911C, "a_ai_initial_cartel" },
    { 0x6AD5F217, "a_ai_intro_guys" },
    { 0xBDE61857, "a_ai_isi" },
    { 0x44712EDF, "a_ai_jetpack_guys" },
    { 0xE90764EA, "a_ai_kill_zombies" },
    { 0x49427B9F, "a_ai_leftover" },
    { 0xE4078A49, "a_ai_living" },
    { 0x3439C532, "a_ai_lower_porch" },
    { 0xCB9C476E, "a_ai_market" },
    { 0x072B8A82, "a_ai_morals_runners" },
    { 0xFBBC3D82, "a_ai_morals_shooters" },
    { 0xBFA08EB2, "a_ai_muj" },
    { 0x473024D2, "a_ai_navy" },
    { 0xE8DBD771, "a_ai_paperburners" },
    { 0x9C474FB4, "a_ai_parasites" },
    { 0x16949739, "a_ai_passengers" },
    { 0xCE117E2E, "a_ai_path_guys" },
    { 0xB38886A0, "a_ai_pdf" },
    { 0xCB3F02E7, "a_ai_pdf_right" },
    { 0x81C0AA12, "a_ai_player_squad" },
    { 0xC9A2CBAD, "a_ai_pmcs" },
    { 0x7DAAF60F, "a_ai_potential_targets" },
    { 0xF866260E, "a_ai_rappellers" },
    { 0x6620E50F, "a_ai_rearbunker" },
    { 0x56E1781A, "a_ai_rescue_seals" },
    { 0x039352A5, "a_ai_riders" },
    { 0xEF9F6BD3, "a_ai_roof_guys" },
    { 0x19CA916E, "a_ai_seal1" },
    { 0xF3C81705, "a_ai_seal2" },
    { 0x4E6436DC, "a_ai_seals" },
    { 0x8D9EEACB, "a_ai_seals_b" },
    { 0x5A1A1D94, "a_ai_security" },
    { 0x1B4DF657, "a_ai_security_single" },
    { 0xFC32493D, "a_ai_slam_zombies" },
    { 0x5E764D1A, "a_ai_snipers" },
    { 0x0ECAB80F, "a_ai_soct_riders" },
    { 0x04096B99, "a_ai_sorted" },
    { 0xEE3A705F, "a_ai_soviets" },
    { 0x81183AB0, "a_ai_spawned" },
    { 0x2DA7F409, "a_ai_spawners" },
    { 0xBD6AC2AE, "a_ai_standoff_seals" },
    { 0x2AB7A378, "a_ai_talkers" },
    { 0x64647720, "a_ai_targets" },
    { 0x38AE7603, "a_ai_terrorists" },
    { 0xD3A8BEA1, "a_ai_theater" },
    { 0x5D263F41, "a_ai_touching" },
    { 0x1118A269, "a_ai_troops" },
    { 0x3346855C, "a_ai_unloaded" },
    { 0xFCCDB7A5, "a_ai_valid_enemies" },
    { 0xAD56B05B, "a_ai_zombies" },
    { 0xD9FC584D, "a_ai_zombies_extended" },
    { 0x5849AC59, "a_ai_zombies_extended_filtered" },
    { 0xF693CD55, "a_aigroup_names" },
    { 0x8EB6B315, "a_air_to_air_offsets" },
    { 0xF7C3E69A, "a_ais" },
    { 0x4B35A33F, "a_align_structs" },
    { 0x5C92BE6C, "a_all_ai_in_level" },
    { 0xBE5507DA, "a_all_decorations" },
    { 0x99CCB8B4, "a_all_entities" },
    { 0x0E6C85C7, "a_all_ents" },
    { 0x5E2FCF2C, "a_all_path_starts" },
    { 0xA0561C95, "a_all_players" },
    { 0xCCDA370E, "a_all_spawners" },
    { 0x0C8EC9B9, "a_all_targets" },
    { 0x3FB1342E, "a_all_vehicle_pathnodes" },
    { 0x3DDCFE66, "a_all_vehicles" },
    { 0x27AB7926, "a_all_zombies" },
    { 0x3CED446F, "a_allies" },
    { 0x87DA21CB, "a_alt_locations" },
    { 0x5B25E412, "a_ambient_arena_trucks" },
    { 0xA5F2E059, "a_ambient_spawners" },
    { 0x301CFF54, "a_ammo_cache" },
    { 0x63366CC7, "a_ammo_caches" },
    { 0x346386CE, "a_ammo_crates" },
    { 0xBB5D617D, "a_ammo_triggers" },
    { 0xF711BC6A, "a_amp_structs" },
    { 0xF3D1D981, "a_amplifiers" },
    { 0x24FD4335, "a_angle_strings" },
    { 0x8C87DE6D, "a_angola_escape_triggers" },
    { 0x8BAAD0BD, "a_anim_info" },
    { 0x5AD51729, "a_anim_keys" },
    { 0xD52C1B14, "a_animations" },
    { 0x7EF7C12D, "a_anims" },
    { 0x30E274A5, "a_antenna_jets" },
    { 0x8544A4A5, "a_apc_alley_army" },
    { 0x62476EA6, "a_apc_alley_digbats" },
    { 0x45144296, "a_approach_ents" },
    { 0x7F8F3907, "a_approach_ents_index" },
    { 0xE5655C16, "a_arena_hind_playerattack" },
    { 0x9F11AA39, "a_arena_hinds" },
    { 0x1D534D47, "a_arena_horses" },
    { 0x6A01D314, "a_arena_tanks" },
    { 0xC68A9264, "a_array" },
    { 0x5CA05BEE, "a_array2" },
    { 0xA493704E, "a_asds" },
    { 0x728B123B, "a_atd2_icons" },
    { 0x1955A231, "a_atd2_lit_icons" },
    { 0x05AF592A, "a_attached_models" },
    { 0x7429D7C7, "a_attackers" },
    { 0x8021C048, "a_audience_structs" },
    { 0x91D77491, "a_audio" },
    { 0x98EED881, "a_audiolog" },
    { 0xFF96FE00, "a_audiolog_to_play" },
    { 0xAFBDA4A8, "a_audiologs" },
    { 0x9DE378E8, "a_av_allies_spawner_targetnames" },
    { 0x203FD0A1, "a_av_axis_spawner_targetnames" },
    { 0xD3582862, "a_avoid_linker" },
    { 0xADDF374E, "a_axis" },
    { 0xF0675A8B, "a_axis_ai" },
    { 0xE2E2AE34, "a_axis_array" },
    { 0x55469AA6, "a_axis_vehicles" },
    { 0xA6058410, "a_b_player_rewarded" },
    { 0x488EBBC9, "a_bad_guys" },
    { 0x6B4AF464, "a_bad_nodes" },
    { 0x21FFD156, "a_bad_zones" },
    { 0xEFCEAC3C, "a_balcony_ai" },
    { 0xA2F0C519, "a_balcony_nodes" },
    { 0xE2C42F3B, "a_balcony_runners" },
    { 0x205EF9E9, "a_balls" },
    { 0x950789E2, "a_barge_attacker" },
    { 0x5AAAF29F, "a_barge_model_names" },
    { 0xFE4BA9BC, "a_barrels" },
    { 0x363D86F1, "a_barriers_filtered" },
    { 0xEAEC933F, "a_base_attackers" },
    { 0x6D535669, "a_base_being_attacked_come_back_vo" },
    { 0xFFD1F6F7, "a_base_being_attacked_helo_vo" },
    { 0xDD426F10, "a_base_being_attacked_mortar_vo" },
    { 0x3C13998D, "a_base_being_attacked_tank_vo" },
    { 0x09350350, "a_base_being_attacked_vo" },
    { 0xA1DF3B81, "a_base_grid" },
    { 0x00610DCD, "a_base_tower_clip" },
    { 0xA8B9B9B2, "a_battleship_structs" },
    { 0xC2B55555, "a_beach_grass_fxanim" },
    { 0x10BD1FC2, "a_beach_grass_static" },
    { 0xB0E08320, "a_beach_intro_trucks" },
    { 0x6C3ADFC4, "a_beartrap_test_enemies" },
    { 0x32E72959, "a_beartraps" },
    { 0x2AC2010B, "a_behind_nodes" },
    { 0xC79582B3, "a_bg_characters" },
    { 0x5BDEB963, "a_big_rig_ents" },
    { 0xFF4FB9EE, "a_blast_door_nodes" },
    { 0x87208D5B, "a_blockades" },
    { 0x5EBFBED2, "a_blocked_barrier_list" },
    { 0xD5CA9084, "a_blockers" },
    { 0x78745942, "a_blocking_points" },
    { 0x7E0F94A9, "a_bm_door_clips" },
    { 0xC0FD0DD0, "a_bm_doors" },
    { 0x91904B90, "a_boat_models" },
    { 0x3E18F651, "a_boat_vehicles" },
    { 0x17E194AE, "a_boats" },
    { 0xB6B9582D, "a_bodies" },
    { 0xCFDF0148, "a_bomb_was_diffused" },
    { 0x22C38D30, "a_bottom" },
    { 0xC30D4BC6, "a_bottom_nodes" },
    { 0x004BAE9C, "a_boxes" },
    { 0x27469E5D, "a_boxes_in_inverted_building" },
    { 0x167541DD, "a_bp2_helis" },
    { 0xE77F5356, "a_bridge_brutuses" },
    { 0x5A0F638D, "a_bridge_guys" },
    { 0xABDD4570, "a_briggs_anims" },
    { 0x7041AF8C, "a_buffel_cracked_windshields" },
    { 0x7B0FBBB6, "a_buildable_piece_pickedup_vox_cooldown" },
    { 0xDD024F86, "a_bullet_trace_info" },
    { 0x80B92F9A, "a_button_structs" },
    { 0xFC05A0CC, "a_buttons" },
    { 0x3817E530, "a_c4" },
    { 0x4EAA8AD3, "a_c4_pos" },
    { 0x3B9996EC, "a_cabinet_nag" },
    { 0xCB82AB70, "a_caches" },
    { 0x9E49B892, "a_cagelights" },
    { 0x54477B4F, "a_call_boxes" },
    { 0xD0DCE2F2, "a_callouts" },
    { 0xA423DB8A, "a_cam_scene_keys" },
    { 0xFED525C0, "a_camera_movement" },
    { 0x948E59AB, "a_cameras" },
    { 0xF000AFCB, "a_candidates" },
    { 0xAB450F4B, "a_capture_vtol" },
    { 0xD2B61AA4, "a_cars" },
    { 0x17FA9853, "a_cartels" },
    { 0xDE988972, "a_ceiling_rings" },
    { 0x13AE57C8, "a_ceiling_tile_brushes" },
    { 0x63E83ADF, "a_celerium_door_nag" },
    { 0x2CAEC2B6, "a_cell_structs" },
    { 0xCAE9210B, "a_challenges" },
    { 0x07C39493, "a_change_per_frame" },
    { 0xBFC344C1, "a_changer" },
    { 0x5F2C396E, "a_char_anims" },
    { 0x56D6268D, "a_characters" },
    { 0x122F0A9F, "a_charmodels" },
    { 0x8908303C, "a_chatter" },
    { 0x2B240F1D, "a_chatter_conditional" },
    { 0xA5EB9204, "a_chatter_conditional_enemy" },
    { 0xD5B9E73D, "a_chatter_conditional_friendly" },
    { 0x30909B32, "a_chatter_conditional_temp" },
    { 0x9495F52A, "a_chatter_generic" },
    { 0xC3AEFFEB, "a_chatter_generic_enemy" },
    { 0x1E0CFF28, "a_chatter_generic_friendly" },
    { 0xF56F43EF, "a_chatter_generic_temp" },
    { 0xF970D7D9, "a_chicken_death" },
    { 0x4BC7349D, "a_chicken_death_a" },
    { 0x0B7C3CD7, "a_chicken_idle" },
    { 0x27E4506F, "a_chicken_idle_a" },
    { 0x2DE58CB1, "a_chicken_idle_peck" },
    { 0x4318C0D1, "a_chickens" },
    { 0x5F6F4C74, "a_child_fxanims" },
    { 0x9204B76F, "a_chord_notes" },
    { 0x732B5F80, "a_chord_order" },
    { 0xA3517334, "a_chords" },
    { 0x7303E997, "a_civ_types" },
    { 0x1FF1A9AE, "a_civ_types_keys" },
    { 0x2D41B8A5, "a_civ_wander_anim_points" },
    { 0x193413A5, "a_civilians" },
    { 0x86C0F2C0, "a_civs" },
    { 0xD0737B87, "a_classes" },
    { 0xB20889A7, "a_classic_clips" },
    { 0x5D573F54, "a_claymores" },
    { 0xD72A85AD, "a_clean_room_nag" },
    { 0x7F7944FB, "a_cleanup" },
    { 0x5A398A12, "a_clear_street" },
    { 0x4D2A5192, "a_cliff_nag" },
    { 0x9EB0BCAB, "a_clip" },
    { 0xD9EC4B26, "a_clip_brushes" },
    { 0xACDA3526, "a_clip_brushes_full" },
    { 0x0E6AC9EF, "a_close" },
    { 0xC6987265, "a_close_array" },
    { 0xEF0A1CF3, "a_close_drones" },
    { 0xCF490CDB, "a_close_points" },
    { 0xDF323CD9, "a_close_vehicles" },
    { 0x016A3136, "a_closest" },
    { 0xE04D4BD8, "a_closest_drones" },
    { 0x3B8FE275, "a_codes" },
    { 0x63B788DC, "a_collectibles" },
    { 0xBB2D52B5, "a_colors" },
    { 0xE96D223F, "a_combat_axes" },
    { 0xEC9A84A8, "a_combine" },
    { 0x1CE1CDA8, "a_common_weapons" },
    { 0x7627CDF6, "a_conditional_enemy" },
    { 0x1FDCE1A3, "a_conditional_friendly" },
    { 0x95F3C5B8, "a_congrats_vo" },
    { 0x5F60BB7F, "a_connection_nodes" },
    { 0x7C8A51E1, "a_containers" },
    { 0x9B68D0E8, "a_contested_zones" },
    { 0x88BBC03E, "a_convo" },
    { 0x4F9F0A15, "a_convoy_nodes" },
    { 0x69F39B6F, "a_convoy_planes" },
    { 0x48EF0F0D, "a_convoy_strafe_nodes" },
    { 0x15A8FAC2, "a_convoy_trailers" },
    { 0x2F81927A, "a_copy" },
    { 0xE30AB519, "a_corpse_guy" },
    { 0x2ADD71E6, "a_corpse_models" },
    { 0xAF0711F2, "a_corpse_structs" },
    { 0xD7188244, "a_corpses" },
    { 0xA09772AA, "a_courtyard_cartel_vo" },
    { 0x4A52793F, "a_courtyard_enemies" },
    { 0xDD338E78, "a_courtyard_spots" },
    { 0x8C19C622, "a_cover" },
    { 0x668BD8C8, "a_cover_nodes" },
    { 0x3FC557E4, "a_cower_anims" },
    { 0x4025E302, "a_crane_building_guys" },
    { 0x537F2846, "a_crash_zones" },
    { 0x5AC6BEF2, "a_crew1_dest" },
    { 0x21480463, "a_crew2_dest" },
    { 0x5E9E46FC, "a_crew3_dest" },
    { 0x8191FDF6, "a_current_perks" },
    { 0x9A43980A, "a_current_weapons" },
    { 0xDF4801A9, "a_daily_challenges" },
    { 0x7C7407AB, "a_dancer_structs" },
    { 0xEA659473, "a_data_streams" },
    { 0xC9CB85C6, "a_death_blossom_offsets" },
    { 0x7C429270, "a_debris_buys" },
    { 0x3E91B40A, "a_decorations" },
    { 0x777F3513, "a_defend_asds" },
    { 0x7B7F1B33, "a_defend_crash_show" },
    { 0x7B2D33DC, "a_defend_pillar_show" },
    { 0xD5BEBE0A, "a_delay" },
    { 0x00583D45, "a_delays" },
    { 0xA192D911, "a_dest" },
    { 0x4F68CBCA, "a_destroyed_lobby_asd" },
    { 0xBCF73AB6, "a_destructibles" },
    { 0x0C406EC1, "a_dialog" },
    { 0xAA00B64D, "a_dig_spots" },
    { 0xEC9B321B, "a_digbats" },
    { 0x6B73B3CA, "a_dir" },
    { 0x8CBB315D, "a_discs" },
    { 0xD23791B8, "a_distant" },
    { 0x71DB455F, "a_dmg_trigs" },
    { 0xCEDB5E2D, "a_docks_frontgate_pdf" },
    { 0xF9D8EE9B, "a_docks_gate_runners" },
    { 0x1B60C2CC, "a_dog_locations" },
    { 0x6F8BC70F, "a_dog_triggers" },
    { 0x1634B6CF, "a_dogfight_nodes" },
    { 0x6F2C7FC6, "a_dogfight_nodes_player_can_see" },
    { 0xC8F6B13C, "a_dogfight_valid_nodes" },
    { 0x898822B4, "a_dogs" },
    { 0x289AA124, "a_door_and_clip" },
    { 0xA116F323, "a_door_buys" },
    { 0x78667A9F, "a_door_main" },
    { 0x547A4D96, "a_door_models" },
    { 0x5704D018, "a_door_names" },
    { 0x63937FA2, "a_door_structs" },
    { 0xDB8E4D94, "a_doors" },
    { 0x737E9E4B, "a_doors_and_gates" },
    { 0x55770095, "a_doors_gates" },
    { 0x1E390F66, "a_dpad_movement" },
    { 0x634CA82B, "a_dragon_icons" },
    { 0x2B4921EA, "a_drone_pos" },
    { 0x3CF04A23, "a_drone_spawners" },
    { 0x90CE4A16, "a_drone_structs" },
    { 0xC359C80E, "a_drone_targets" },
    { 0x5D1DB573, "a_drone_triggers" },
    { 0x0092FA34, "a_drone_triggers_allies" },
    { 0x53C1CFF7, "a_drone_vehicles" },
    { 0x2CCDEC60, "a_drones" },
    { 0x9C82A708, "a_drop_nodes" },
    { 0x0618B3C3, "a_dropped_weapons" },
    { 0x153DBB34, "a_dryer_spawns" },
    { 0xC517228A, "a_dynamic_nodes" },
    { 0xB972EC5F, "a_e_afterlife_interacts" },
    { 0x8921EEF5, "a_e_areas" },
    { 0x6B92D80E, "a_e_blasted_zombies" },
    { 0xFE769174, "a_e_caches" },
    { 0x04F9142F, "a_e_check" },
    { 0x3E7A933D, "a_e_chickens" },
    { 0x4CA5DD1F, "a_e_cleanup" },
    { 0x8748AF2F, "a_e_coke" },
    { 0x012A2DC9, "a_e_crates" },
    { 0xE04866B8, "a_e_dynents" },
    { 0x5A796B3C, "a_e_entrance_clip" },
    { 0x643B9D1B, "a_e_ents" },
    { 0xA78D745A, "a_e_goalvolume" },
    { 0x9603546F, "a_e_gondola_doors" },
    { 0x5F9E7468, "a_e_gondola_gates" },
    { 0x0C16D973, "a_e_gondola_landing_doors" },
    { 0x36C18FDC, "a_e_gondola_landing_gates" },
    { 0x18E39A8B, "a_e_gondola_lights" },
    { 0xAB0A8969, "a_e_kill" },
    { 0xE498E5FE, "a_e_lights" },
    { 0xDEB1E2EE, "a_e_market_ents" },
    { 0xDF7FDF88, "a_e_phalanx_cannon_targets" },
    { 0x9BE07199, "a_e_players" },
    { 0x9BB299FE, "a_e_rod_victims" },
    { 0x97392B41, "a_e_slow_areas" },
    { 0xF4F18733, "a_e_spawnpoints" },
    { 0x5DB32B5B, "a_e_speakers" },
    { 0x3A585602, "a_e_target" },
    { 0x1534914D, "a_e_targets" },
    { 0x7B45393E, "a_e_triggers" },
    { 0xCA64FE2A, "a_e_units" },
    { 0x8772EFAD, "a_e_wunderfizzes" },
    { 0xA94B0EF5, "a_eject_drone_starts" },
    { 0xA1B1AE43, "a_elec_sparks" },
    { 0x1220BBB0, "a_electric_cherry_perk_machines" },
    { 0x5069A5F6, "a_electroball_grenades" },
    { 0x26FCD3C8, "a_element_enums" },
    { 0xB0D8F1FE, "a_elemental_staffs" },
    { 0x66561721, "a_elemental_staffs_upgraded" },
    { 0xE2CE8E32, "a_elements" },
    { 0x176A3443, "a_elevator_flags" },
    { 0x2276E81C, "a_elevator_mason" },
    { 0x35208090, "a_elevator_models" },
    { 0x9AD28980, "a_elevator_squad" },
    { 0x19C00CCD, "a_elevator_vtol" },
    { 0x1A62B1AE, "a_elevators" },
    { 0x30485495, "a_eligible_players" },
    { 0x88A795B2, "a_emblems" },
    { 0x10DF2340, "a_emblems_lit" },
    { 0x2D4C37EA, "a_emergence_hole_structs" },
    { 0x212B73FC, "a_emergence_holes" },
    { 0xB7A3679C, "a_emergency_light_trigger" },
    { 0x8B5F3BDD, "a_enabled_zone_entities" },
    { 0x7A954B93, "a_end_node" },
    { 0x1DB07703, "a_end_scene_vehicles" },
    { 0x948BFBA7, "a_end_structs" },
    { 0x35FA268E, "a_ending_friendlies" },
    { 0xF3E6ABDC, "a_enemeies" },
    { 0x56DD1913, "a_enemies" },
    { 0x11160E4D, "a_enemies_and_drones" },
    { 0x279F4421, "a_enemies_in_range" },
    { 0xB44365B5, "a_enemies_near_pool" },
    { 0x9FC9C7B7, "a_enemy" },
    { 0xDA0978DC, "a_enemy_ai" },
    { 0xEB18581F, "a_enemy_ais" },
    { 0x2BFAB605, "a_enemy_generic" },
    { 0x46B1D853, "a_enemy_planes" },
    { 0xFB8FBCCB, "a_enemy_react" },
    { 0xC5921274, "a_enemy_socts" },
    { 0xBF4BE29D, "a_enemy_spawners" },
    { 0xF3653F91, "a_enemy_vehicles" },
    { 0xE18761A7, "a_enemy_vo" },
    { 0x078038EE, "a_enemys" },
    { 0x38FA6E84, "a_ent" },
    { 0x6772C5B9, "a_ent_names" },
    { 0xA1749B84, "a_entities" },
    { 0x70CBE108, "a_entity" },
    { 0x30E67710, "a_entrance_models" },
    { 0xE8D00C79, "a_entrance_nodes" },
    { 0xC77D2837, "a_ents" },
    { 0x4CA1EA50, "a_ents_models" },
    { 0x61A119CB, "a_ents_origins" },
    { 0x5F6C99CD, "a_escape_pod_ents" },
    { 0x37E3FED9, "a_escape_rpg_enemies" },
    { 0x5383EDD0, "a_escape_trigs" },
    { 0x09792C59, "a_exclude" },
    { 0xA5C57D91, "a_execution_civs" },
    { 0x93D093C7, "a_executioners" },
    { 0x3CF1FFD6, "a_exit_blood_01" },
    { 0x16EF856D, "a_exit_blood_02" },
    { 0xD2DED4BD, "a_exit_points" },
    { 0x69F3F6DC, "a_exits" },
    { 0x15C4E352, "a_exploder_id" },
    { 0x3996EA2D, "a_exploders" },
    { 0x7528A5E8, "a_explored_sidepaths" },
    { 0xBE971A69, "a_explosion_structs" },
    { 0x111E074D, "a_explosions" },
    { 0xDC40570E, "a_exterior_goals" },
    { 0x05A927B2, "a_extra_models" },
    { 0x7C336283, "a_factory_walkway_2" },
    { 0x6DCEB550, "a_fail_beach_enemies" },
    { 0x60C4CFF3, "a_fail_before_log_enemies" },
    { 0x54847054, "a_fail_valley_enemies" },
    { 0xAD5930BF, "a_failure_triggers" },
    { 0x8B759DCC, "a_fake_physics_vehicles" },
    { 0x31F9286D, "a_fake_targets" },
    { 0x9363E739, "a_fallback_nodes" },
    { 0x53BF9BEE, "a_fallbacks" },
    { 0xD596FADB, "a_fans" },
    { 0xF98FCE6E, "a_fighter_name" },
    { 0xABBAB1D4, "a_filtered_zombies" },
    { 0x86FCA33F, "a_fire_building_civilians" },
    { 0x7DC9B5D3, "a_fire_nodes" },
    { 0xB64DBA59, "a_fire_points" },
    { 0xDF309362, "a_fire_pos" },
    { 0x06887DAF, "a_first_magic_box_seen_convo" },
    { 0xADC17F12, "a_flags" },
    { 0x2F9DC07A, "a_flashlights" },
    { 0x11357CB8, "a_flight_structs" },
    { 0x1DAE0486, "a_floor_numbers" },
    { 0x291E750A, "a_flyby_index" },
    { 0x3E9294B6, "a_foliage_crash_1" },
    { 0xB825C478, "a_follow_up_player_vo" },
    { 0xEBEFCC0C, "a_follow_up_vo" },
    { 0x4367FA05, "a_follow_up_woods_vo" },
    { 0x1EA38608, "a_force_goal_guy" },
    { 0x4D0C972E, "a_forward_trace" },
    { 0x2D4A0AC3, "a_found" },
    { 0xFCBEEAEA, "a_fov" },
    { 0x1B6DC6F5, "a_freed_obj_id" },
    { 0xFD338BF6, "a_freeway_collapse" },
    { 0xAC8EA4F8, "a_friendlies" },
    { 0xEA644274, "a_friendly" },
    { 0x634D0729, "a_friendly_ai" },
    { 0x9FB4ED52, "a_friendly_generic" },
    { 0x96A95EB2, "a_fuel_tanks_dmg_left" },
    { 0x5B7009A1, "a_fuel_tanks_dmg_right" },
    { 0xE19110A1, "a_fuel_tanks_left" },
    { 0x0DDD910C, "a_fuel_tanks_right" },
    { 0x6B339307, "a_func_equipment_slot_watcher_override" },
    { 0x6F87C778, "a_func_hero_power_update" },
    { 0xC957F5A8, "a_func_score_events" },
    { 0xEDB09811, "a_func_vehicle_damage_override" },
    { 0x62BB476B, "a_fx" },
    { 0xE709B4FD, "a_fx_id" },
    { 0xC99E732A, "a_fx_names" },
    { 0x42BE3322, "a_fx_result_origin" },
    { 0x13179E49, "a_fx_spots" },
    { 0xA2F1BAB1, "a_fx_tags" },
    { 0x2BF9E304, "a_fxanim_child_models" },
    { 0x4B631AA6, "a_fxanim_drones" },
    { 0xC8F176FD, "a_fxanim_ents" },
    { 0x2754E81B, "a_fxanim_grass" },
    { 0x9C68992D, "a_fxanim_grass_end" },
    { 0xA1EB6146, "a_fxanim_grass_house" },
    { 0x50E62DF5, "a_fxanim_grass_middle" },
    { 0xC2272B3D, "a_fxanim_models" },
    { 0x5ED6C39F, "a_fxanims" },
    { 0x98BD7322, "a_game_start_convo" },
    { 0x807D33E4, "a_game_start_solo_convo" },
    { 0x167DD54E, "a_gametypes" },
    { 0x7188EE90, "a_garage_door_guys" },
    { 0xC264BB8C, "a_garage_nodes" },
    { 0x60D12B3E, "a_gawk3" },
    { 0xA2C4C731, "a_gawk4" },
    { 0x6BAD1BC9, "a_gaz_tigr_guys" },
    { 0x30A2B43F, "a_general_vo" },
    { 0xA75BC907, "a_generators" },
    { 0xE74533E5, "a_generic_ai" },
    { 0xE5C63B19, "a_generic_enemy" },
    { 0xAB3631A2, "a_generic_friendly" },
    { 0xA242EE9E, "a_ghost" },
    { 0x5E131473, "a_ghost_spawn_locations" },
    { 0xCCD4B2FE, "a_ghost_spawners" },
    { 0x32A019A2, "a_ghoul_spots" },
    { 0x64F7BE48, "a_giant_robots" },
    { 0x8C74D8BB, "a_gib_ref" },
    { 0x53B7819E, "a_girls" },
    { 0x41844549, "a_goal_ents" },
    { 0x7D86316F, "a_goal_groups" },
    { 0x4FF43D79, "a_goal_index" },
    { 0x13D45BE4, "a_goal_volumes" },
    { 0x0DA1BCFB, "a_goals" },
    { 0xCEC11C8B, "a_gondola_doors" },
    { 0xF53BB37E, "a_gondola_doors_gates" },
    { 0xD1EE6D74, "a_gondola_gates" },
    { 0x929119EF, "a_gondola_landing_doors" },
    { 0x5C2C39E8, "a_gondola_landing_gates" },
    { 0xEDEEFCF0, "a_good_nodes" },
    { 0x697A7C19, "a_gr_head_triggers" },
    { 0xD9DF6911, "a_grass" },
    { 0x8AEBB9CE, "a_grass_structs" },
    { 0xA2665C6C, "a_grass_users" },
    { 0xB1869952, "a_gravityspikes_prev_ammo_clip" },
    { 0xECB339BC, "a_grenades" },
    { 0x5AD27522, "a_grief_clips" },
    { 0x5DDBDC32, "a_ground_trace" },
    { 0x53491BE4, "a_ground_vehicles" },
    { 0xB46CDF98, "a_group_of_dudes" },
    { 0x0CE41667, "a_guards" },
    { 0x8D6C09ED, "a_gun_crate" },
    { 0xB5F23D8F, "a_gun_spots" },
    { 0xCA31B8A8, "a_guns" },
    { 0xD56969C9, "a_guy_ragdoll_death" },
    { 0x215F11E1, "a_guys" },
    { 0x61131A25, "a_guys_1" },
    { 0x58976250, "a_guys_close" },
    { 0x13A680FD, "a_guys_in_room" },
    { 0xB7DA23E3, "a_guys_within_range" },
    { 0x659FBED5, "a_h_drop_bad" },
    { 0x3D58D2F5, "a_hallway_bad" },
    { 0xF6B72BA3, "a_hangar_pdf" },
    { 0x733C6FF3, "a_hangar_redshirts" },
    { 0x76BF2EFF, "a_hangar_seals" },
    { 0x70BAAA18, "a_harper_nag" },
    { 0x2C2BD276, "a_has_powerup" },
    { 0x25F91FDD, "a_headers" },
    { 0x3BE11336, "a_heli_1_drop_guys" },
    { 0x2B391768, "a_heli_3_drop_guys" },
    { 0x880D3AA2, "a_helo_base_structs" },
    { 0xDCBF1275, "a_helo_killed_vo" },
    { 0x6BB986CE, "a_helo_nag_vo" },
    { 0xA8BFA593, "a_helo_wave_end_vo" },
    { 0xB55CEB82, "a_help_vo" },
    { 0x5CEA3801, "a_hero" },
    { 0x673CAED4, "a_hero_names" },
    { 0x5D815A51, "a_heroes" },
    { 0x3C3CF1AD, "a_hide" },
    { 0xBA5C97AB, "a_hide_tags" },
    { 0x5FDC3491, "a_high_rage_perks" },
    { 0x7BF9C602, "a_holders" },
    { 0x144A0580, "a_horse_eat_idle" },
    { 0x888AA687, "a_horse_eat_idle_b" },
    { 0xF0FC610B, "a_horse_eat_idle_b_to_eat_idle" },
    { 0xF48126C3, "a_horse_eat_idle_to_eat_idle_b" },
    { 0x97D31997, "a_horse_get_off_combat_leftside" },
    { 0x4EDC7F9B, "a_horse_get_on_combat_leftside" },
    { 0x1452B71C, "a_horse_get_on_leftside" },
    { 0xA6B3A9F1, "a_horse_get_on_rightside" },
    { 0x7194A9BE, "a_horses_trapped" },
    { 0x725D93B7, "a_hotel_lights" },
    { 0x548EBD29, "a_house_triggers" },
    { 0x4CE2C1E5, "a_house_vehicles" },
    { 0x9013FD72, "a_ice_staff_parts" },
    { 0x36E5DD29, "a_ice_ternary_digit_brushes" },
    { 0x9F46AA1E, "a_idles" },
    { 0xE862C397, "a_ignore_target_array" },
    { 0x9C05B8FF, "a_images" },
    { 0x38B0D0D8, "a_impact_loc" },
    { 0xE86DA93E, "a_important_codes" },
    { 0x4210CEDD, "a_index_string" },
    { 0x4AB2C2D9, "a_indicies" },
    { 0x242FD1A1, "a_info" },
    { 0x06553D54, "a_initial_targets" },
    { 0x8D7A9717, "a_instances" },
    { 0x225B67E9, "a_interference_trigger_stack" },
    { 0x14ADF18B, "a_intro_building_jets" },
    { 0x9EAFCB05, "a_intro_civ_truck_guys" },
    { 0x96EEDA44, "a_intro_claw_guys" },
    { 0x2D232332, "a_intro_courtyard_convoy" },
    { 0x8A47167C, "a_intro_guys" },
    { 0x4D602FC9, "a_intro_vo" },
    { 0xA583BBDB, "a_intro_zodiacs" },
    { 0xE7773B09, "a_invalid_object_indexes" },
    { 0x00F0D803, "a_item_list" },
    { 0xE15110D3, "a_items" },
    { 0x5BDBB6FA, "a_jetwing_groups" },
    { 0xD12B160D, "a_jiffy_window_after" },
    { 0x4D513D70, "a_jiffy_window_before" },
    { 0xC6F14E26, "a_josefina_vo" },
    { 0x0124DC03, "a_jumpers" },
    { 0xA15D7EED, "a_keys" },
    { 0xE9595B3E, "a_keys_col" },
    { 0xDECC7252, "a_keys_error" },
    { 0x5AA6B9AC, "a_keys_row" },
    { 0xDBC1A6B3, "a_killbrushes" },
    { 0x238B5D9E, "a_kvps_ingnore" },
    { 0xBC28D45F, "a_kvps_match" },
    { 0x713F2CDA, "a_lab_color_triggers" },
    { 0xA88B779F, "a_lab_defend_spawners" },
    { 0x77FD5F58, "a_lab_lens_flare" },
    { 0x26B645A9, "a_lab_scientist" },
    { 0x50B88EAA, "a_lab_trigs" },
    { 0x8F7EA1F6, "a_lanes" },
    { 0xB7816E07, "a_lasertripwires" },
    { 0xAA55AB69, "a_last_stand_enemies" },
    { 0x44098391, "a_last_strafed_nodes" },
    { 0x949911B4, "a_launchers" },
    { 0x8A4CD24F, "a_leaper_collision" },
    { 0x424C3640, "a_leaper_spawn_points" },
    { 0x2C3BAFB0, "a_leaper_traversals" },
    { 0x5ECD0CA7, "a_learjet_back_door_kick_pdf" },
    { 0x7AF25D94, "a_learjet_back_left" },
    { 0x5122D0CB, "a_learjet_back_right" },
    { 0x497E4727, "a_learjet_enemies" },
    { 0x5472A612, "a_learjet_intro_pdf" },
    { 0xFBB2B31D, "a_learjet_intro_pdfs" },
    { 0xA039C1B3, "a_learjet_pdf_frontline" },
    { 0x2897740D, "a_learjet_rpg_seals" },
    { 0x954D3F16, "a_learjet_runway_pdf" },
    { 0xACEA3A69, "a_learjet_truck_pdf" },
    { 0x003C7D0E, "a_learjet_wave_1" },
    { 0x6E27D772, "a_learjet_wave_1_rpg" },
    { 0xDA3A02A5, "a_learjet_wave_2" },
    { 0xB437883C, "a_learjet_wave_3" },
    { 0x795F49C0, "a_ledge_clips" },
    { 0xB1BD748E, "a_ledge_soldiers" },
    { 0x8EC229E8, "a_left_doors" },
    { 0xB74227D8, "a_left_nodes" },
    { 0xE66D4F83, "a_left_path_heroes" },
    { 0x41D802BF, "a_leg_trigs" },
    { 0x37687D5C, "a_lever_structs" },
    { 0xD0A8B9F2, "a_levers" },
    { 0xAEA6A642, "a_library_destroyed" },
    { 0x152C817D, "a_library_pristine" },
    { 0x1B940E41, "a_lift_nag" },
    { 0x12923E67, "a_light_entities" },
    { 0x72A4F5D4, "a_light_fx" },
    { 0xEC736C2C, "a_light_models" },
    { 0x72EB55A3, "a_light_room" },
    { 0x60902370, "a_light_targets" },
    { 0x6E0D5939, "a_light_triggers" },
    { 0x4DE1954D, "a_lightfx" },
    { 0xD5E2D630, "a_lightfx_names" },
    { 0x99450F8A, "a_lights" },
    { 0x6FF7C80E, "a_lines" },
    { 0x276D3F94, "a_linked_nodes" },
    { 0xDE3584F9, "a_lion_spots" },
    { 0x29D61B07, "a_living_ai" },
    { 0x92A8B9FF, "a_living_enemies" },
    { 0xCB717F97, "a_loc_types" },
    { 0x4B6F7753, "a_locations" },
    { 0x5B99A4C0, "a_locs" },
    { 0x3846FBB1, "a_lookat_triggers" },
    { 0xA1192265, "a_low_rage_perks" },
    { 0x95F94578, "a_lower_lab_color_triggers" },
    { 0xC72BA9D7, "a_m_ambient" },
    { 0x50AF8AE0, "a_m_big_screen" },
    { 0xED7CD24F, "a_m_blood" },
    { 0x101C0BF9, "a_m_bodies" },
    { 0xA1797C4D, "a_m_bridge_destroyed_parts" },
    { 0xCC8FA079, "a_m_bridge_whole_parts" },
    { 0xA1607741, "a_m_building_destroyed" },
    { 0x3B230651, "a_m_building_whole" },
    { 0xFD30587E, "a_m_cagelights" },
    { 0xB833F944, "a_m_camera" },
    { 0xCECFAD4C, "a_m_challenge_boards" },
    { 0xEA241462, "a_m_challenge_boxes" },
    { 0x4B2787AB, "a_m_checklist" },
    { 0x062389AC, "a_m_civs" },
    { 0x9144CD70, "a_m_clean" },
    { 0xC160029E, "a_m_clips" },
    { 0xA6A7C167, "a_m_collision" },
    { 0xC754C07D, "a_m_converts" },
    { 0x5862B560, "a_m_corpses" },
    { 0xF995D0A6, "a_m_destroyed" },
    { 0x76959CB8, "a_m_destroyed_dome" },
    { 0x690FEA54, "a_m_dome" },
    { 0xF40ABCA8, "a_m_doors" },
    { 0x24DB1B74, "a_m_drones" },
    { 0xEDBD6D77, "a_m_each_fxanim_with_name" },
    { 0x908A821F, "a_m_fans" },
    { 0x3A339870, "a_m_fx_models" },
    { 0x96BD7F33, "a_m_fxanims" },
    { 0x51CD4BFA, "a_m_gate_01" },
    { 0x7A945412, "a_m_generator_core" },
    { 0xD731EA13, "a_m_glass" },
    { 0x9012F60B, "a_m_globes" },
    { 0xF8D9DBA3, "a_m_gondola_lights" },
    { 0x0AE98565, "a_m_grass" },
    { 0xBDCE29FB, "a_m_group_dancers" },
    { 0xD4166249, "a_m_groups" },
    { 0xC1CFABF5, "a_m_guys" },
    { 0xDE17FFE3, "a_m_hazard_lights" },
    { 0xE5305486, "a_m_lights" },
    { 0x4CC315CD, "a_m_link" },
    { 0x96CF0854, "a_m_linkspots" },
    { 0x97B7B94C, "a_m_metal_storm" },
    { 0xB7B0C348, "a_m_middle_doors" },
    { 0xE3BD2143, "a_m_models" },
    { 0x2D59C5A5, "a_m_oneoffs" },
    { 0x860BCA59, "a_m_outermost_doors" },
    { 0x235EA1B9, "a_m_parent_fxanim" },
    { 0x2792C099, "a_m_persistent_bodies" },
    { 0xA55BE47A, "a_m_right_oneoffs" },
    { 0x5ECB9D75, "a_m_script_models" },
    { 0x820A4DF3, "a_m_shelves" },
    { 0x309E58D2, "a_m_ships" },
    { 0xDA8E9E95, "a_m_targets" },
    { 0xEF70A488, "a_m_to_delete" },
    { 0xA02C1527, "a_machines" },
    { 0x8B0624C4, "a_magic_rpg_orgs" },
    { 0x69F84EBA, "a_max_signs" },
    { 0xF84FCB94, "a_mdl_gravity_traps" },
    { 0x64BA8680, "a_mechz_tags" },
    { 0xD38E7883, "a_melee_vo" },
    { 0x5E2CCB74, "a_menendez_hill_ents" },
    { 0x4A0A8E65, "a_menu_items" },
    { 0x7E766757, "a_mh_ents" },
    { 0x93A07121, "a_mh_intro" },
    { 0x888C05D4, "a_mh_vo" },
    { 0xD694125C, "a_mid_positions" },
    { 0x2464341F, "a_model_anims" },
    { 0x243A2339, "a_model_names" },
    { 0x2655B394, "a_model_scene_keys" },
    { 0x0A27153C, "a_model_tags" },
    { 0x398FFCB7, "a_models" },
    { 0x1F3ABF5C, "a_models_mason" },
    { 0x2B51E30D, "a_models_vtol" },
    { 0xCADD3882, "a_morals_actors" },
    { 0xE2742E3C, "a_mortar_vo" },
    { 0x70161E29, "a_mortars" },
    { 0xA9D3336E, "a_mortars_cleared_vo" },
    { 0x1A6A0BFE, "a_motel_path_runners" },
    { 0x498F1BA1, "a_mountain_ents" },
    { 0xDA2F6EF2, "a_movement" },
    { 0x69FF74A9, "a_movement_perp_inverse_trace" },
    { 0x00B79E58, "a_movement_perp_trace" },
    { 0x93DA361E, "a_moveto_structs" },
    { 0xBA3E5556, "a_muj_guys" },
    { 0x23B39260, "a_n_layer_transparency" },
    { 0x8135D8CB, "a_n_nodes" },
    { 0xED46D163, "a_n_piece_index" },
    { 0x406AA268, "a_n_piece_indices" },
    { 0x5D4DCC5B, "a_n_sequence" },
    { 0x7311CCB3, "a_n_slowdown_rates" },
    { 0x86C6FA8E, "a_n_slowdown_timeouts" },
    { 0x4ABFDFA2, "a_n_step" },
    { 0xD47F59D7, "a_n_target_val" },
    { 0x7F69C7A8, "a_nag_fire" },
    { 0xF6EA8AB4, "a_nag_general" },
    { 0xFF1886A7, "a_nag_offscreen" },
    { 0x05883D71, "a_nag_vo" },
    { 0x8D4CCA97, "a_names" },
    { 0x5F355738, "a_nav_triggers" },
    { 0xFEFC736A, "a_navcard_stats" },
    { 0xE4A6CDD7, "a_nd_archway" },
    { 0xB105B4BE, "a_nd_building" },
    { 0x31271683, "a_nd_engage" },
    { 0xAC318B32, "a_nd_goals" },
    { 0x589A9B20, "a_nd_horses" },
    { 0x8823E4E0, "a_nd_initial_locs" },
    { 0xD0AA3BA1, "a_nd_nodes" },
    { 0xA0C8C17E, "a_nd_pathnodes" },
    { 0x84300CEA, "a_nd_patrol_locs" },
    { 0x6B28BD0B, "a_nd_random" },
    { 0xDA5D2C27, "a_nd_ready" },
    { 0xA2651952, "a_nd_salazar" },
    { 0x2FBBF922, "a_nd_savannah_base" },
    { 0x8134A7CB, "a_nd_spawn_locs" },
    { 0xE091E4AE, "a_nd_squadmates" },
    { 0x9C1A565F, "a_nd_staging_area" },
    { 0x6878C911, "a_nd_startnodes" },
    { 0xA2258AA5, "a_nd_starts" },
    { 0xDE40FEFE, "a_nd_starts_intro" },
    { 0x6FBA2E3B, "a_nd_table1" },
    { 0x23B53969, "a_nd_table3" },
    { 0x407F861D, "a_nd_target" },
    { 0xD4CE3E5C, "a_nd_targets" },
    { 0xB90BAB1D, "a_near_nodes" },
    { 0xB9083233, "a_near_zombies" },
    { 0xBDC67A79, "a_nearby_enemies" },
    { 0x57889DD9, "a_nearest_friendly" },
    { 0x66DBF59D, "a_new" },
    { 0xFD7B4C96, "a_new_anims" },
    { 0x3E18CD0A, "a_new_structs" },
    { 0xA514BBBA, "a_new_targets" },
    { 0x3C1945D1, "a_nixie_tube" },
    { 0xAD7CDD1B, "a_nixie_tube_code" },
    { 0x4ABDDAF1, "a_nixie_tube_solution" },
    { 0x1EB3AC7B, "a_nml_teleport_targets" },
    { 0x7D0C3D3B, "a_node_path_connections" },
    { 0x3AF498BC, "a_nodes" },
    { 0xA46A64F8, "a_nodes_edge" },
    { 0x7AF9223B, "a_nodes_interior" },
    { 0x660A3316, "a_nodes_too_close" },
    { 0x90798CE7, "a_nodes_unavailable" },
    { 0x50801905, "a_nodes_warehouse_roof" },
    { 0x2DF8CDE1, "a_nodes_warehouse_roof_1" },
    { 0x5F404F67, "a_nodes_warehouse_roof_edge" },
    { 0x09DEBF6F, "a_nodes_warehouse_roof_edge_1" },
    { 0x47A71462, "a_nodes_warehouse_street" },
    { 0xA5F06AE2, "a_normalized_movement" },
    { 0x4FFD1853, "a_normalized_rotation" },
    { 0x104AE6EE, "a_notifies" },
    { 0x372E59C5, "a_numbers" },
    { 0xE9A8CBEC, "a_obj" },
    { 0x36944BE7, "a_obj_addstate" },
    { 0x71816E83, "a_obj_defs" },
    { 0xBAF2C66F, "a_obj_structs" },
    { 0xBCBA46B9, "a_objective_ids" },
    { 0xDAEE5141, "a_objectives" },
    { 0x6B2E5977, "a_objects" },
    { 0x6A765DC0, "a_objects_of_type" },
    { 0x51FA32EF, "a_objs" },
    { 0x343CEDBD, "a_occupied_zones" },
    { 0xA6604BFF, "a_offsets" },
    { 0xE31C1192, "a_old_align" },
    { 0x02901A25, "a_one_time_piece_pickup_vo" },
    { 0x36690113, "a_origin" },
    { 0xB188E69D, "a_original_positions" },
    { 0x3D58A6CE, "a_original_tiles" },
    { 0xACCAFDC2, "a_other_ents" },
    { 0x7E37AED9, "a_outputarray" },
    { 0x717108CE, "a_owner" },
    { 0xFAA59833, "a_panel_tags" },
    { 0xAA281805, "a_parameters" },
    { 0xB4E2C327, "a_params" },
    { 0x33DDD9F8, "a_parking_lot_backup" },
    { 0x5F6483BA, "a_parking_lot_guys" },
    { 0xD6C1D192, "a_parkling_lot_bored" },
    { 0x53C7F37F, "a_parkling_lot_smoker" },
    { 0xD0380EF9, "a_parts" },
    { 0xB221C398, "a_path" },
    { 0x71F0EF4C, "a_path_origins" },
    { 0x4B52E6EE, "a_path_spots" },
    { 0x2886E6BB, "a_path_structs" },
    { 0x44A6ED58, "a_path_trigs" },
    { 0x43C8BE1F, "a_pathnodes" },
    { 0x1643E573, "a_paths" },
    { 0x67DAC022, "a_pathstructs" },
    { 0x1B75E095, "a_pdf" },
    { 0xB27BC342, "a_pdf_ai" },
    { 0xD3B7C61B, "a_pdf_hangar_assaulters" },
    { 0xEB962339, "a_pdf_lines" },
    { 0x90CD8B56, "a_pdf_runner" },
    { 0xC793DFA5, "a_pdf_stealth" },
    { 0xAB6E437C, "a_perks" },
    { 0x4446253B, "a_piano_keys" },
    { 0x84ED0374, "a_piano_keys_playing" },
    { 0x3F47EE34, "a_pieces" },
    { 0xD1B90939, "a_piecespawns" },
    { 0x7A5F63BC, "a_piecestubs" },
    { 0xC6E97592, "a_place_ball_trigs" },
    { 0xA188E044, "a_planes" },
    { 0xCC0E642A, "a_player" },
    { 0x15F4FFFF, "a_player_clip" },
    { 0x4E3C2AF6, "a_player_hint" },
    { 0x1921B640, "a_player_nodes" },
    { 0xEF6F76DD, "a_player_targets" },
    { 0xD6F3D41E, "a_player_team" },
    { 0xF0A7391E, "a_player_volumes" },
    { 0x183857E0, "a_player_weapons" },
    { 0x296B1FAA, "a_player_zones" },
    { 0x5DDEF2E5, "a_players" },
    { 0xB3786E17, "a_players_in_capture_zone" },
    { 0x6017705A, "a_players_in_zone" },
    { 0x819A8C40, "a_players_on_gondola" },
    { 0xAA1B6986, "a_players_on_tank" },
    { 0x1AB6445E, "a_players_to_check" },
    { 0xDB45AD17, "a_plaza_left_color" },
    { 0x646F7082, "a_plaza_right_color" },
    { 0x70A38794, "a_points" },
    { 0x729BE784, "a_police_ground_ents" },
    { 0x0449B35F, "a_pool" },
    { 0xA550D08B, "a_portal_exit_frames" },
    { 0xF39893FC, "a_portal_frames" },
    { 0x514730DD, "a_pos" },
    { 0x1A4E90B7, "a_positions" },
    { 0x83BD7E8F, "a_possible_enemies_to_delete" },
    { 0xD5B49DCC, "a_possible_powerups" },
    { 0x6861F5D0, "a_potential_soct_to_ram" },
    { 0x1E67B8D0, "a_potential_target_structs" },
    { 0xC83ADACE, "a_potential_targets" },
    { 0x4D8961B4, "a_potential_users" },
    { 0x320B1A0E, "a_powerups" },
    { 0xAA2CEAB4, "a_press_drones" },
    { 0x113C7B62, "a_priority_targets" },
    { 0x478BEED7, "a_promises" },
    { 0x690F9666, "a_prop" },
    { 0xC98F24E8, "a_prop_links" },
    { 0x816906BE, "a_proximity_grenades" },
    { 0xF1BC44C3, "a_pulses" },
    { 0xCCB09AFE, "a_push_allies" },
    { 0x324109AB, "a_push_triggers" },
    { 0x8EBE3CD3, "a_pushers" },
    { 0xF1D31861, "a_puzzle_flags" },
    { 0x0363B309, "a_puzzle_trigs" },
    { 0x07A61A69, "a_qrotors" },
    { 0xD8F64583, "a_qrs" },
    { 0x91CC1F27, "a_quadrotors" },
    { 0xF447C65B, "a_quads" },
    { 0xFD2A4B9A, "a_rage_settings" },
    { 0x7DC967AC, "a_railturret_structs" },
    { 0xC4237462, "a_railturrets" },
    { 0x6D4BBA07, "a_ram_vo" },
    { 0x0B33B534, "a_random_perk_machines" },
    { 0xFF5371A6, "a_randomized" },
    { 0xB48AC10C, "a_randomized_craftables" },
    { 0x256B9383, "a_rappel_glass_structs" },
    { 0xC261B7A3, "a_rappel_nodes" },
    { 0x5B8972C7, "a_rare_powerups" },
    { 0xD3EED0BF, "a_rare_weapons" },
    { 0x50788BE3, "a_registered_fields" },
    { 0xB723C85C, "a_registered_traps" },
    { 0x3B7DF74D, "a_respawn_triggers" },
    { 0xE3701CDA, "a_respond_vo" },
    { 0x5311B72F, "a_restricted_solutions" },
    { 0xF29AE442, "a_ret" },
    { 0xB403F9E6, "a_revive_success_perk_func" },
    { 0xD88BE03E, "a_ric_signs" },
    { 0x8CFCE75B, "a_richtofen_lines" },
    { 0x24D7985E, "a_riders" },
    { 0xCF01EC89, "a_riders_to_remove" },
    { 0xA88988F0, "a_rig_and_woods" },
    { 0xC1002A5F, "a_right_doors" },
    { 0x75152993, "a_right_nodes" },
    { 0x8AC7305D, "a_right_path_runners" },
    { 0x77A885A4, "a_rigs" },
    { 0xECD2B2A3, "a_river_corpses" },
    { 0xF63431F6, "a_robot_index" },
    { 0x61A19DC6, "a_robots" },
    { 0xF0F42126, "a_rolling_door_guys" },
    { 0x28BD0035, "a_roof_nodes" },
    { 0xD58CE1AF, "a_rooftop_pdf" },
    { 0x64B28313, "a_rooftop_rpg_squad" },
    { 0x9FC42BD5, "a_rooftops_end" },
    { 0xFDDAE64E, "a_rooftops_guys" },
    { 0x10E81212, "a_room_models_after" },
    { 0x07F7C173, "a_rooms" },
    { 0x5059CDE0, "a_round_one_end_convo" },
    { 0x88752DC6, "a_round_one_end_solo_convo" },
    { 0x26BA444C, "a_round_two_end_solo_convo" },
    { 0xB598F272, "a_round_type" },
    { 0xCBF33EA7, "a_row" },
    { 0x582020E5, "a_rpg_guys" },
    { 0x48D9F68D, "a_rpgs" },
    { 0x8BD151A9, "a_rumbled_players" },
    { 0xF4F2C586, "a_runners" },
    { 0x87B9B3A4, "a_runway_cessnas" },
    { 0xC0892C89, "a_runway_hangar_cessna" },
    { 0x8FEDE9E6, "a_rush_enemies" },
    { 0xD9267B3D, "a_rush_goal_nodes" },
    { 0x02BEFB3D, "a_rushers" },
    { 0x10A70C90, "a_russ_drone_pathid" },
    { 0x52E30A44, "a_s_align_spots" },
    { 0x579A357A, "a_s_arena_delete" },
    { 0x6F0189E1, "a_s_arena_start" },
    { 0xA628E13C, "a_s_ashtrays" },
    { 0xE1B96F4D, "a_s_bar_targets" },
    { 0xA6045D43, "a_s_barriers_rebuilt" },
    { 0x25DEF0CE, "a_s_bullets" },
    { 0x967E82CF, "a_s_candles" },
    { 0x1E21EA18, "a_s_cannon" },
    { 0xE54187A0, "a_s_center" },
    { 0x5E7C1D4B, "a_s_debris_start" },
    { 0xDEA90034, "a_s_delete2" },
    { 0x4A4E6CA6, "a_s_drones" },
    { 0xB1DF5406, "a_s_explos" },
    { 0x308414D4, "a_s_explosion" },
    { 0x0B7DFC7E, "a_s_explosion_in_view" },
    { 0x857D4547, "a_s_explosions" },
    { 0x2F4A7507, "a_s_flyovers" },
    { 0x36611C78, "a_s_footprint" },
    { 0x9864435C, "a_s_footprint_all" },
    { 0xA55E33D3, "a_s_footprints" },
    { 0x7B4A8F72, "a_s_generator" },
    { 0x9B5C20BE, "a_s_goal" },
    { 0xD7E2CBE9, "a_s_grenade_spots" },
    { 0x76BF1F5F, "a_s_gunfire" },
    { 0xAAC75E16, "a_s_guns_left" },
    { 0xE83FD4ED, "a_s_guns_right" },
    { 0x346CB525, "a_s_hero_catch_up" },
    { 0xA9050BF9, "a_s_hitpts" },
    { 0xAD96E175, "a_s_horse_spawnpts" },
    { 0x7A05BF0E, "a_s_inst_list" },
    { 0x99D41F00, "a_s_jetwings" },
    { 0x9765C8A8, "a_s_landing" },
    { 0x1972E584, "a_s_landing_group" },
    { 0x06CF3E67, "a_s_landing_spot" },
    { 0x8B3FA214, "a_s_left" },
    { 0x0C6D3DA8, "a_s_lights" },
    { 0x682EFEE2, "a_s_locs" },
    { 0xEA5E5362, "a_s_market_exit" },
    { 0x5EC5E856, "a_s_mcguffin" },
    { 0xC22FCF18, "a_s_medal_tags" },
    { 0x20120B60, "a_s_mig_base" },
    { 0xBEBB0986, "a_s_mig_delete" },
    { 0x0B18F395, "a_s_mig_start" },
    { 0x84FB67CB, "a_s_migs" },
    { 0x5207B5E3, "a_s_mortarspots" },
    { 0xB8659A0E, "a_s_orgs" },
    { 0xABF9AD30, "a_s_origins" },
    { 0xE61C66BB, "a_s_parent_fxanim" },
    { 0x7EC95B4A, "a_s_part_teleport" },
    { 0xA7730D40, "a_s_player_zones" },
    { 0x1674322E, "a_s_points" },
    { 0x0763521F, "a_s_pos" },
    { 0x5FE3B92D, "a_s_positions" },
    { 0x01EE7893, "a_s_radios" },
    { 0x589AE881, "a_s_random_perk_locs" },
    { 0x1578CB2A, "a_s_revive_overrides" },
    { 0x7AC5A64B, "a_s_right" },
    { 0x3A503899, "a_s_scan_locations" },
    { 0x60822BD2, "a_s_scts" },
    { 0x22A50848, "a_s_shooters" },
    { 0xF7007373, "a_s_slowdowns" },
    { 0x8272A926, "a_s_spawn_points" },
    { 0x2A384327, "a_s_spawn_pos" },
    { 0xECB7F3C1, "a_s_spawner" },
    { 0x4A27984B, "a_s_spawnpts" },
    { 0x4FDBB65A, "a_s_spots" },
    { 0xB0A40267, "a_s_squad_spawn" },
    { 0x4E54C6DD, "a_s_stage_left" },
    { 0x9B8387C0, "a_s_stage_right" },
    { 0xE84FDFA7, "a_s_start_spots" },
    { 0x7F4EB795, "a_s_static_locs" },
    { 0x243BB102, "a_s_stcts" },
    { 0x5E77C9E2, "a_s_stingers_left" },
    { 0x0327CBD1, "a_s_stingers_right" },
    { 0x032075FF, "a_s_structs" },
    { 0x695D7F0C, "a_s_support" },
    { 0x84DAF52C, "a_s_target" },
    { 0xE32E572F, "a_s_targets" },
    { 0xB360941E, "a_s_teleporters" },
    { 0x71CB2E29, "a_s_temp_points" },
    { 0x31457CEB, "a_s_tp_locs" },
    { 0x76A72775, "a_s_trigger" },
    { 0xABA4BA44, "a_s_triggers" },
    { 0x0FABADCF, "a_safe_text_display" },
    { 0x058E8F54, "a_salazar_nag" },
    { 0x37207E8C, "a_saved_perks" },
    { 0xB9E39295, "a_saved_primaries" },
    { 0x53B6D197, "a_saved_primaries_weapons" },
    { 0x899A515C, "a_scene_ai" },
    { 0x586AD9E8, "a_scene_ai_spawners" },
    { 0x0D39AF5D, "a_scene_and_balcony_ai" },
    { 0xCD9C6D30, "a_scene_ents" },
    { 0xCB0D0636, "a_scene_names" },
    { 0xA7BD9CAF, "a_scenedefs" },
    { 0x575A3D6E, "a_scenes" },
    { 0x66FEBBF1, "a_script_models" },
    { 0x1C518D27, "a_script_models_time" },
    { 0x4EBDD53C, "a_script_origins" },
    { 0xB397EF4E, "a_seal_group_1" },
    { 0x8D9574E5, "a_seal_group_2" },
    { 0x6E3735EC, "a_secsystem_structs" },
    { 0x119F9FDA, "a_securityblockers" },
    { 0xCC315C5C, "a_securitycrushers" },
    { 0x5C69BB06, "a_securitydoors" },
    { 0x54930C90, "a_securitylights" },
    { 0x69842182, "a_securitynodes" },
    { 0x2B723ABA, "a_securitypanels" },
    { 0x0B068002, "a_securityreversepanels" },
    { 0x7CD16912, "a_selected_scenes" },
    { 0xAF6F405B, "a_semi_caches" },
    { 0x979A2615, "a_sentinel_drones" },
    { 0x531D5AC4, "a_shockboxes" },
    { 0x48693EAE, "a_shooters" },
    { 0x5B8BDB58, "a_shooting_vo" },
    { 0x8413E7FF, "a_shovel_pos" },
    { 0x97B40F81, "a_shovel_zone" },
    { 0x31E80186, "a_show" },
    { 0x1D92861D, "a_shutdown_triggers" },
    { 0x6C76654D, "a_sign_keys" },
    { 0x85A4E224, "a_sign_spots" },
    { 0x5E928101, "a_signs" },
    { 0xB07B9BDA, "a_signs_active" },
    { 0x40021C00, "a_skipto_structs" },
    { 0x52AC7AB2, "a_skyline_1" },
    { 0x2CAA0049, "a_skyline_2" },
    { 0x6278A7C2, "a_sloth_barriers" },
    { 0xAF78E13F, "a_slums_left_narrow" },
    { 0x691DD0DE, "a_slums_mg_nest_allies" },
    { 0xB8F23E8C, "a_slums_pre_mgnest_axis" },
    { 0xEA4DFCFC, "a_sm_guys" },
    { 0x4F9C4DAB, "a_sm_spawners" },
    { 0xF66C6353, "a_smoke_pos" },
    { 0x32529F71, "a_sniper_guards" },
    { 0x61CB7F56, "a_sniper_rifle_names" },
    { 0x76DB9169, "a_sniper_tree_triggers" },
    { 0x34C1B22F, "a_snipers" },
    { 0x94190FC2, "a_soct" },
    { 0x76AEA59B, "a_soct_behind_the_player" },
    { 0x87269D9E, "a_socts_to_ram" },
    { 0xF91FFBC4, "a_soldiers" },
    { 0xBB54A372, "a_sorted" },
    { 0xFA891E16, "a_soviets" },
    { 0xFE3DB664, "a_sp" },
    { 0x6205C2ED, "a_sp_actors" },
    { 0x313E1BF1, "a_sp_allies" },
    { 0xE4F90B1A, "a_sp_civs" },
    { 0x4A6C9B8D, "a_sp_enemies" },
    { 0x94F3A345, "a_sp_enemy" },
    { 0xEE5AEFD4, "a_sp_enemys" },
    { 0x5EB78A95, "a_sp_ents" },
    { 0x6D69B9BF, "a_sp_female" },
    { 0x7B8D2403, "a_sp_friend" },
    { 0x6B34182E, "a_sp_friendly" },
    { 0xAA88A251, "a_sp_friendlys" },
    { 0x45C0A6E0, "a_sp_group" },
    { 0x41467FE7, "a_sp_guys" },
    { 0xD90E8510, "a_sp_harpers" },
    { 0x2F6D94A0, "a_sp_isi" },
    { 0x00B08783, "a_sp_jetpack" },
    { 0xAE88ACE4, "a_sp_male" },
    { 0x24E3E1FF, "a_sp_midguys" },
    { 0x751847A5, "a_sp_morals_shooters" },
    { 0xC36EEDF9, "a_sp_muj" },
    { 0x2882CCC0, "a_sp_pdf_reinforcements" },
    { 0x198B5C4F, "a_sp_player_squad" },
    { 0x93B64E8C, "a_sp_rusher" },
    { 0x75CC789D, "a_sp_shotgunners" },
    { 0x9E819D0C, "a_sp_spawn" },
    { 0x8786C160, "a_sp_spawners" },
    { 0x7EFD3DF9, "a_sp_spawners1" },
    { 0xA4FFB862, "a_sp_spawners2" },
    { 0xA1DADAD4, "a_sp_support" },
    { 0x7934082E, "a_sp_terrorists" },
    { 0xDE7D63CB, "a_sparky_tags" },
    { 0x0ED2BD53, "a_spawn_locations" },
    { 0x2B309D3D, "a_spawn_managers" },
    { 0x8D090F42, "a_spawn_origins" },
    { 0x8BFB9994, "a_spawn_points" },
    { 0xDFED8D3E, "a_spawn_points_in_view" },
    { 0x80737C44, "a_spawn_spots" },
    { 0xB306AA65, "a_spawn_structs" },
    { 0x73548C15, "a_spawn_times" },
    { 0x3D912AF2, "a_spawn_triggers" },
    { 0xC8C0B141, "a_spawned" },
    { 0xA3D3560D, "a_spawned_drones" },
    { 0x34408DEF, "a_spawner_holes" },
    { 0x1EE9EEA0, "a_spawner_numbers" },
    { 0xED6191C0, "a_spawner_structs" },
    { 0xDA1CC39E, "a_spawners" },
    { 0xCA4494D3, "a_spawns_outside_mansion" },
    { 0x562C146F, "a_speakers" },
    { 0xEBF8A63F, "a_special_items" },
    { 0x7B0B37E4, "a_speech_structs" },
    { 0x9655B170, "a_spiderbots" },
    { 0x32D93A45, "a_spotlight_broke" },
    { 0x0089899B, "a_spotlight_path" },
    { 0x95589644, "a_spots" },
    { 0xE293A2D1, "a_sprint_vo" },
    { 0x2B8CA2B9, "a_ssa_brute_force" },
    { 0x29C37378, "a_st_scaffolding_left_0" },
    { 0x2CA4CC91, "a_staff" },
    { 0xE88C9EAD, "a_staff_convo" },
    { 0xDC2F4915, "a_staff_pieces" },
    { 0x8239193F, "a_staff_spots" },
    { 0x857107E8, "a_stages" },
    { 0x62D93C42, "a_stages_ordered" },
    { 0x994713EE, "a_stargate_gramophones" },
    { 0x36B473AB, "a_start_flags" },
    { 0x3F133313, "a_start_funcs" },
    { 0xFA37B4C3, "a_start_in" },
    { 0xC564D90E, "a_start_node" },
    { 0x04A9A8B1, "a_start_nodes" },
    { 0x1C47027C, "a_start_pos" },
    { 0x4AD00888, "a_start_structs" },
    { 0xB288E39E, "a_starting_structs" },
    { 0x0D57205F, "a_stat" },
    { 0xB9BB7B0D, "a_stat_nav" },
    { 0x2FAFC2BD, "a_stat_nav_held" },
    { 0xCD341143, "a_static_locs" },
    { 0x263FFDE6, "a_stats" },
    { 0x7B30DF5C, "a_stinger_items" },
    { 0xD7CE1FBA, "a_stinger_structs" },
    { 0xF3DB01DD, "a_stone_positions" },
    { 0x8F68A082, "a_str" },
    { 0xD662F463, "a_str_ai_group" },
    { 0xDDCE1BDB, "a_str_aliases" },
    { 0x4B50BF1E, "a_str_anim_sets" },
    { 0x62DBBFEA, "a_str_animnames" },
    { 0x9568C65B, "a_str_behind_bus_names" },
    { 0xDD8A3F9F, "a_str_bus_dam_names" },
    { 0x5E05BDF2, "a_str_civ_props" },
    { 0x40651590, "a_str_corpses" },
    { 0xD252E085, "a_str_dialog" },
    { 0x121630E2, "a_str_frogger_names" },
    { 0x86125947, "a_str_fx" },
    { 0x853DEB5D, "a_str_fxanim_names" },
    { 0x29242CEA, "a_str_hit_locs" },
    { 0x5F9C7E70, "a_str_jetwing_waves" },
    { 0x2179E509, "a_str_keys" },
    { 0x7F819867, "a_str_menus" },
    { 0x78B01D9B, "a_str_mod" },
    { 0x7E0CE2E9, "a_str_more_models_to_delete" },
    { 0xAB765ABB, "a_str_names" },
    { 0xA689A468, "a_str_nodes" },
    { 0x3E77EEE6, "a_str_partnames" },
    { 0x5AD64C90, "a_str_perks" },
    { 0x1D003899, "a_str_rpgs" },
    { 0x077AECC1, "a_str_rumbles" },
    { 0x53D1DF2A, "a_str_scenes" },
    { 0xDAE80FA8, "a_str_sewer_names" },
    { 0x2AB6654C, "a_str_sms" },
    { 0x698782E9, "a_str_structs" },
    { 0x4F85A01A, "a_str_tags" },
    { 0x879C7CF2, "a_str_trigs" },
    { 0xEABE08A9, "a_str_type" },
    { 0x9FA93F20, "a_str_types" },
    { 0x6733360B, "a_str_vars" },
    { 0xF878C15E, "a_str_veh" },
    { 0x8729B5C6, "a_str_vh_names" },
    { 0x58BE95A8, "a_str_weapon_keys" },
    { 0xA4A64D88, "a_str_weapons" },
    { 0x2A4E7042, "a_str_zones" },
    { 0xAC1B8954, "a_street_ais" },
    { 0x71DE0AEF, "a_street_ambush_outside" },
    { 0x7F9A6CBE, "a_street_back" },
    { 0x5C48591B, "a_street_courtyard_squad" },
    { 0xC33370BD, "a_street_cross_1" },
    { 0x438953E0, "a_street_cross_inside" },
    { 0x979DFCEF, "a_street_inside" },
    { 0xBC75EC4A, "a_street_train_inside" },
    { 0xC712A323, "a_street_truck_guys" },
    { 0x9A7F3325, "a_string_list" },
    { 0x889D169F, "a_string_tokens" },
    { 0x1E806CAA, "a_struct" },
    { 0xB0EDF7B4, "a_struct_links" },
    { 0xA7625465, "a_structs" },
    { 0x88F14841, "a_structs_far_deck" },
    { 0x0B14BFDE, "a_structs_mid_deck" },
    { 0xD19A5CEF, "a_stuff_to_delete" },
    { 0x6FB77BDA, "a_stuff_to_kill" },
    { 0x30CA4735, "a_switches" },
    { 0xDA2018FC, "a_t_audio" },
    { 0x379F589A, "a_t_call" },
    { 0x21B3CE57, "a_t_color" },
    { 0x130D2BE3, "a_t_crash_trigs" },
    { 0x7F40F9F6, "a_t_door_triggers" },
    { 0x1AA633CD, "a_t_doors" },
    { 0x13AAE94C, "a_t_dustructible_area" },
    { 0x5DDECEBD, "a_t_firetriggers" },
    { 0x68673548, "a_t_gondola_triggers" },
    { 0x01253CE4, "a_t_hurtriggers" },
    { 0xC42D1E6A, "a_t_market_triggers" },
    { 0xDDECBD55, "a_t_move" },
    { 0x57E139A7, "a_t_spawn_trigs" },
    { 0x51863ABE, "a_t_travel_triggers" },
    { 0xD9B4AB34, "a_t_trig" },
    { 0xE3A5E871, "a_t_triggers" },
    { 0xBC5B6427, "a_t_trigs" },
    { 0xDA8380B3, "a_table" },
    { 0x613BFBDC, "a_tablets" },
    { 0x81A89886, "a_tags" },
    { 0xB2C5AA85, "a_talkers" },
    { 0x5E3D6849, "a_tank01_entrance" },
    { 0x7D2FAB3D, "a_tank_jump_down_spots" },
    { 0x6992AF5F, "a_tank_killed_vo" },
    { 0x0F44FFD0, "a_tank_nag_vo" },
    { 0x418465B7, "a_tank_spots" },
    { 0x6E2951F7, "a_tank_tags" },
    { 0xE0972651, "a_tank_wave_end_vo" },
    { 0x64F0663F, "a_target_ents" },
    { 0xDA0DFDB5, "a_target_pos" },
    { 0x332B9016, "a_target_pos1" },
    { 0x0D2915AD, "a_target_pos2" },
    { 0x8F596DFC, "a_target_spots" },
    { 0xA04706CD, "a_target_structs" },
    { 0x05E7BE99, "a_targeted" },
    { 0xD0F7943A, "a_targetnames" },
    { 0xD3F6BE49, "a_targets" },
    { 0x0A7A050D, "a_targets_all" },
    { 0xF05B1F62, "a_targets_valid" },
    { 0xD7A7A23D, "a_tarp_pdf" },
    { 0xA61085A9, "a_tarps" },
    { 0x299705C5, "a_teams" },
    { 0xABFC3FFD, "a_teleport_exit_triggers" },
    { 0x2CC80BB6, "a_teleport_exits" },
    { 0x3722C981, "a_teleport_models" },
    { 0x3AF84491, "a_teleport_positions" },
    { 0xE4660BFB, "a_temp" },
    { 0xDBBB7C49, "a_temp_array" },
    { 0x09D8A3CA, "a_temp_vehicle" },
    { 0x9C6204C6, "a_ternary" },
    { 0x527FFD43, "a_terrorist_spawners" },
    { 0xE9069940, "a_terrorists" },
    { 0x354B60AF, "a_text_display" },
    { 0xEC1B780E, "a_things" },
    { 0x2382AB88, "a_tiles" },
    { 0x49D10B1A, "a_time" },
    { 0x8EE8FAF7, "a_time_remaining" },
    { 0x9D27E124, "a_to_delete" },
    { 0x5B610375, "a_to_die" },
    { 0x7155BEFE, "a_to_spawn" },
    { 0x800DD8AF, "a_tokens" },
    { 0x9D4FA000, "a_toks" },
    { 0xDD432B6A, "a_tomahawk_pickup_funcs" },
    { 0x0E37F802, "a_top_deck" },
    { 0x07C29220, "a_top_nodes" },
    { 0xD4D7F66E, "a_top_stairs_guys" },
    { 0x1DC34E75, "a_top_stairs_guys_2" },
    { 0xFFDECB62, "a_torch_pos" },
    { 0x8740DC71, "a_torches" },
    { 0x485691B7, "a_touching_ents" },
    { 0xE4A8C6A4, "a_trace" },
    { 0x55532FE7, "a_trailer_ai" },
    { 0xD961D183, "a_traps" },
    { 0x4EFB9BC7, "a_trig_targetnames" },
    { 0xCA1D4710, "a_trigger_strings" },
    { 0xE9DDC8F2, "a_triggers" },
    { 0x73044D06, "a_trigs" },
    { 0x7EB78D51, "a_trucks" },
    { 0x482E79DE, "a_tunnel_claw_rpgs" },
    { 0xB888D69A, "a_turrets" },
    { 0xA0E23061, "a_unused_tiles" },
    { 0xBB65A987, "a_users" },
    { 0xFB520990, "a_utm_params" },
    { 0xB578830D, "a_uts_challenge_boxes" },
    { 0x5C007ED5, "a_uts_craftables" },
    { 0x2314709E, "a_uts_open_craftables_available" },
    { 0x6357A0D6, "a_v_land_offsets" },
    { 0x33A39FB9, "a_v_land_spots" },
    { 0x71526995, "a_v_offset" },
    { 0xE1D73DDD, "a_v_parasite_attractors" },
    { 0xE987F01A, "a_v_spawn_pos" },
    { 0x7438D76F, "a_v_spots" },
    { 0x14202479, "a_v_start_offsets" },
    { 0x5A8F2256, "a_v_start_spots" },
    { 0x1B572B82, "a_valid_attack_points" },
    { 0x93F7AC8C, "a_valid_attackers" },
    { 0xE85CC5BC, "a_valid_enemies" },
    { 0xAFCE831C, "a_valid_guys" },
    { 0x04BE8F13, "a_valid_nodes" },
    { 0xAFA8AD22, "a_valid_players" },
    { 0xCA3E8299, "a_valid_points" },
    { 0xBCD93E61, "a_valid_spawn_points" },
    { 0x61120BCB, "a_valid_spawners" },
    { 0x2287AF7E, "a_valid_structs" },
    { 0x18343FB6, "a_valid_targets" },
    { 0x2176E2AF, "a_values" },
    { 0xC981BC2B, "a_vans" },
    { 0x76A28522, "a_veh" },
    { 0xD998CF8C, "a_veh_buffels" },
    { 0xA0219CA0, "a_veh_elands" },
    { 0xB5AD64EA, "a_veh_lapd_offramp" },
    { 0xFC4861DA, "a_veh_spawners" },
    { 0x3114FF3C, "a_veh_tanks" },
    { 0x6FF1558E, "a_vehicle_hijack_targetnames" },
    { 0xDA95289E, "a_vehicle_names" },
    { 0x0BC9EF01, "a_vehicle_path_nodes" },
    { 0x53B498F7, "a_vehicle_targetnames" },
    { 0x261C8FBC, "a_vehicle_targets" },
    { 0x28554355, "a_vehicle_types" },
    { 0x838BD816, "a_vehicles" },
    { 0xACC3DF03, "a_vehicles_on_roof" },
    { 0x70603B4B, "a_vh" },
    { 0xA8407A06, "a_vh_base_horses" },
    { 0x8A17C171, "a_vh_bridge_player_quad_spawners" },
    { 0xC98761A7, "a_vh_bridge_robots" },
    { 0x550333E1, "a_vh_btrs" },
    { 0xD3E70B0A, "a_vh_claws" },
    { 0x9C07F48E, "a_vh_cleanup" },
    { 0x8DC8ED1C, "a_vh_cougars" },
    { 0x2BE5500F, "a_vh_drones" },
    { 0x5033E5E6, "a_vh_extrahorses" },
    { 0xFB461AE1, "a_vh_extralefthorses" },
    { 0x17E4B54E, "a_vh_heli" },
    { 0x130C80FF, "a_vh_hijacked_robots" },
    { 0x46BE266C, "a_vh_hips" },
    { 0xDC7E787C, "a_vh_horses" },
    { 0xF0005C0D, "a_vh_krav_horses" },
    { 0xFDD78C08, "a_vh_lasthorses" },
    { 0x80ACAC1E, "a_vh_morals_rail_quadrotors" },
    { 0xE476F83E, "a_vh_morals_rail_vtols" },
    { 0xDAFF077A, "a_vh_newhorses" },
    { 0x5D27E673, "a_vh_qr" },
    { 0xF92D0534, "a_vh_qr_allies" },
    { 0x850D8BCD, "a_vh_qr_axis" },
    { 0x70862225, "a_vh_qr_old" },
    { 0xA944AC0C, "a_vh_quadrotors" },
    { 0xEF96BF66, "a_vh_quadrotors2" },
    { 0x60394012, "a_vh_quads" },
    { 0x8307A78C, "a_vh_supphorses" },
    { 0x51FF6D50, "a_vh_targets" },
    { 0x7E50327B, "a_vh_tigrs" },
    { 0x11E46F4E, "a_vh_trucks" },
    { 0xFF4AE495, "a_vh_vehicles" },
    { 0x1D9B0EE8, "a_vh_vtols" },
    { 0x5356AB6D, "a_vh_walkin_horses" },
    { 0xCC44D64F, "a_vh_wingsuits" },
    { 0x1F1EB09C, "a_victims" },
    { 0xFFB7583B, "a_village_complete" },
    { 0x159CE318, "a_vnd_splines" },
    { 0x9662B5B4, "a_vo" },
    { 0x5FB0EBC4, "a_vo_callouts" },
    { 0x7B4F8F1F, "a_vo_goto_bp" },
    { 0x1A7DFED0, "a_vo_lines" },
    { 0x54831323, "a_vo_note" },
    { 0x5EE04B87, "a_vol_areas" },
    { 0x38BD789E, "a_vol_caches" },
    { 0x6C61D3C0, "a_vol_convert" },
    { 0x391B0DCB, "a_volume" },
    { 0xF5D2F02A, "a_volumes" },
    { 0x03E5D35A, "a_volumes_infantry" },
    { 0x832D549B, "a_vorticies" },
    { 0x85549DAA, "a_vtol" },
    { 0x6CA31946, "a_vulture_death_fall_loop_a" },
    { 0xFAC6A857, "a_vulture_death_from_flight_a" },
    { 0x6EF8D247, "a_vulture_death_from_idle" },
    { 0x51C0BB3F, "a_vulture_death_from_idle_a" },
    { 0xDFB94C04, "a_vulture_death_from_idle_b" },
    { 0x05BBC66D, "a_vulture_death_from_idle_c" },
    { 0x6A2BF4AC, "a_vulture_death_hitground_a" },
    { 0xDF1FF2DE, "a_vulture_fly" },
    { 0x31E9FFB1, "a_vulture_idle" },
    { 0xB5569B91, "a_vulture_idle_twitch" },
    { 0xB60D70C4, "a_vulture_perk_machines" },
    { 0xD1E175B7, "a_wait_locations" },
    { 0x082538F1, "a_wall_climbers" },
    { 0xE61279CD, "a_wall_peices" },
    { 0xE2A3D3D5, "a_wall_pieces" },
    { 0x373DC638, "a_walls" },
    { 0x01BACE8C, "a_walltop_dudes" },
    { 0xF34584F9, "a_warning_triggers" },
    { 0xA91B1DFC, "a_warp_structs" },
    { 0x95315B60, "a_wasp_priority_targets" },
    { 0x614BB8D2, "a_wave" },
    { 0xB430D2A8, "a_weapon_crates" },
    { 0x743ECD5C, "a_weapon_keys" },
    { 0x69A83368, "a_weapon_list" },
    { 0xB4F1C4E7, "a_weapon_mount" },
    { 0x4DA6A075, "a_weaponlist" },
    { 0x87A9E25C, "a_weapons" },
    { 0x4F64EE67, "a_weapons_list" },
    { 0x95FCBBBE, "a_wind_order" },
    { 0x59BDB37B, "a_window_tags" },
    { 0x5003C17A, "a_winds" },
    { 0x342364F2, "a_wolf_structs" },
    { 0x35175F25, "a_woodbridge" },
    { 0x3BC56A9E, "a_woods_anims" },
    { 0x994AB39E, "a_woods_nag" },
    { 0x20F831D0, "a_words" },
    { 0xE204D971, "a_wounded" },
    { 0xF6AABF7C, "a_wounded_crawler" },
    { 0x271CB76E, "a_wounded_structs" },
    { 0x1F82E2AA, "a_wpn_exp" },
    { 0x5EB3814F, "a_x" },
    { 0xDA698D8F, "a_xcam_players" },
    { 0x38B106E6, "a_y" },
    { 0x91394AB2, "a_yemeni" },
    { 0x509A72FE, "a_yemeni_callouts" },
    { 0xF5B0E4F3, "a_z_spots" },
    { 0xD63136A8, "a_zhao_nag" },
    { 0x8A8C8D22, "a_zodiac_littlebird_armada" },
    { 0x27520DD8, "a_zombie_blood_entities" },
    { 0x9BBF44E2, "a_zombie_only_traversals" },
    { 0x5A487977, "a_zombie_respawn_health" },
    { 0x22060A89, "a_zombie_respawn_type" },
    { 0xEBE90536, "a_zombies" },
    { 0xFAFE0095, "a_zombies_in_shower" },
    { 0x7AA21F35, "a_zombies_to_kill" },
    { 0x6782A127, "a_zone" },
    { 0x6EC5504C, "a_zone_ai" },
    { 0x3369E2A3, "a_zone_is_active" },
    { 0x23EEB587, "a_zone_is_spawning_allowed" },
    { 0x206C6B9E, "a_zones" },
    { 0x424FC4A3, "a_zones_active" },
    { 0xCF51A60D, "a_zones_occupied" },
    { 0x31E3635B, "a_zones_temp" },
    { 0x5A3469CD, "a_zones_with_extra_stink_locations" },
    { 0x08622823, "aa" },
    { 0x9A223AC5, "aa_1_obj" },
    { 0x09EF007E, "aa_2_obj" },
    { 0xD13CBA43, "aa_3_obj" },
    { 0xE78A9A12, "aa_add_event" },
    { 0x575F24DD, "aa_add_event_float" },
    { 0x03750EBA, "aa_ai_functions" },
    { 0xAEBD4DD5, "aa_ambient_fire" },
    { 0xBCDD3C8B, "aa_approach_init" },
    { 0xB6137902, "aa_area_shake" },
    { 0x2FD00B31, "aa_array" },
    { 0x47C80063, "aa_basic_fire" },
    { 0x573BA422, "aa_breach_init" },
    { 0xA67BCE60, "aa_cobraflight_init" },
    { 0xA68C2464, "aa_cobrastreets_init" },
    { 0x8FF83BB5, "aa_crew" },
    { 0x7F152596, "aa_crew_active" },
    { 0x483977E5, "aa_crew_half_shield" },
    { 0x6BFB57CB, "aa_crew_playerseek" },
    { 0x8DCCD9EC, "aa_damage_trigger" },
    { 0xF0263D68, "aa_door_functions" },
    { 0xAA04510A, "aa_fire" },
    { 0x640C6216, "aa_fire_manager" },
    { 0x3AFADDA1, "aa_fire_max_delay" },
    { 0x96835303, "aa_fire_min_delay" },
    { 0x8E7C223F, "aa_firecontrolthink" },
    { 0x01A7BF62, "aa_fireloop_end" },
    { 0x9FAB83B8, "aa_freefall_init" },
    { 0xF64D2F9C, "aa_gate_init" },
    { 0x1752C1C8, "aa_gun" },
    { 0x026A836B, "aa_gun2_friendly_drones_start" },
    { 0x1026ED57, "aa_gun_1_targets" },
    { 0x2DB19E4F, "aa_gun_2" },
    { 0x134216BC, "aa_gun_2_targets" },
    { 0x07AF23E6, "aa_gun_3" },
    { 0xC1679EE1, "aa_gun_3_targets" },
    { 0xAE20A9DB, "aa_gun_audio" },
    { 0xC98FD2F8, "aa_gun_available_to_use" },
    { 0x994343C8, "aa_gun_clips" },
    { 0x1B01DAD9, "aa_gun_continuous_fire" },
    { 0x4AA2C862, "aa_gun_crew_setup" },
    { 0xCBA4BCD2, "aa_gun_death_watcher" },
    { 0x1F8376A4, "aa_gun_destroyed" },
    { 0x158BEEB7, "aa_gun_destroys_friendly_drones_start" },
    { 0x3B1700F9, "aa_gun_destruction" },
    { 0xB1258F0E, "aa_gun_encounter" },
    { 0x3B210212, "aa_gun_explosive_hit" },
    { 0x22965998, "aa_gun_fall_anim" },
    { 0xB497FA47, "aa_gun_fire_at_ent" },
    { 0x3F63435B, "aa_gun_guys" },
    { 0x3FE7A809, "aa_gun_init" },
    { 0xB8C51357, "aa_gun_obj_taken_out" },
    { 0xDFE2FA28, "aa_gun_objective" },
    { 0x4013262A, "aa_gun_objective_boat_skipto" },
    { 0xE5F0E482, "aa_gun_objective_old" },
    { 0x88D98F22, "aa_gun_objective_player_boat_skipto" },
    { 0x8206991F, "aa_gun_read" },
    { 0xC9D02C33, "aa_gun_targets" },
    { 0xA5968B41, "aa_gun_think" },
    { 0x87304C26, "aa_gun_tower_1" },
    { 0xF4E998A5, "aa_gun_tower_1_pos" },
    { 0x612DD1BD, "aa_gun_tower_2" },
    { 0x13B3EE5E, "aa_gun_tower_2_pos" },
    { 0x150DEE18, "aa_gun_wall_audio" },
    { 0x86E6B8EE, "aa_gunner_detect_shot" },
    { 0x1D89EA62, "aa_gunner_shot" },
    { 0xD214BDE3, "aa_guns" },
    { 0x802E9BF6, "aa_guns_cleared" },
    { 0x32127E7B, "aa_guns_obj_update" },
    { 0x35524C8C, "aa_init_stats" },
    { 0x6C218F7D, "aa_intro_init" },
    { 0xF0671EBB, "aa_manually_add_crew" },
    { 0xC7FA0443, "aa_move_target" },
    { 0x39738936, "aa_nuke_init" },
    { 0xCA34A2D2, "aa_player_ads_tracking" },
    { 0xD4A80EDA, "aa_player_attacks_enemy_with_ads" },
    { 0x705CAC2E, "aa_player_health_tracking" },
    { 0xF0BEE822, "aa_player_init_stats" },
    { 0xC94F9B1E, "aa_player_trig_left" },
    { 0x2C5D78D5, "aa_player_trig_right" },
    { 0xB982244D, "aa_plaza_init" },
    { 0x54C244AE, "aa_print_vals" },
    { 0x41F75B57, "aa_should_start_fresh" },
    { 0xC40825F6, "aa_smoketown_init" },
    { 0x26DB41A3, "aa_spawning_functions" },
    { 0x44993974, "aa_stop_moving_turret" },
    { 0x54485B7D, "aa_struct" },
    { 0xA2B659D1, "aa_target" },
    { 0xEF9B43C5, "aa_tarmac_init" },
    { 0x83A9727F, "aa_time_tracking" },
    { 0x4BBEBDD3, "aa_town_init" },
    { 0xDAD349BA, "aa_tracer_loop" },
    { 0xA0AA57E5, "aa_update_flags" },
    { 0x5B3BC2CA, "aa_utility" },
    { 0xCFE755BD, "aa_vehicles" },
    { 0x061C1217, "aa_vents_init" },
    { 0x8AE174AC, "aa_vip_init" },
    { 0xEFD201D0, "aaa" },
    { 0x678A4C12, "aaa_begin" },
    { 0xCAAB1F7D, "aaaaaand" },
    { 0xD4E4AD6E, "aaaaaargh" },
    { 0xDE4BA7F7, "aaaaarrgh" },
    { 0x21E26883, "aaaack" },
    { 0x3C8B6F04, "aaaargh" },
    { 0xB9C14DB3, "aaargh" },
    { 0x5B6B2896, "aaarrgghh" },
    { 0x5D5E3F3B, "aaarrrrrgh" },
    { 0x2BA8D617, "aagggghhhh" },
    { 0x555965D8, "aagroup" },
    { 0x279793C1, "aagroup_soldierthink" },
    { 0x6D70FD53, "aagun" },
    { 0x74B87883, "aagun_1" },
    { 0x7658D155, "aagun_1_crew" },
    { 0x02B10948, "aagun_2" },
    { 0x7ABD8668, "aagun_2_crew" },
    { 0x28B383B1, "aagun_3" },
    { 0x44178727, "aagun_3_crew" },
    { 0xE6BFE7BE, "aagun_4" },
    { 0x7FBEDC22, "aagun_4_crew" },
    { 0xF7195E17, "aagun_bldg" },
    { 0xF8C2A862, "aagun_bldg_start" },
    { 0xB8CE4944, "aagun_blown" },
    { 0x7284B8DD, "aagun_fall" },
    { 0x5A3A254D, "aagun_gun_target_2_random_move" },
    { 0x8BB52DDF, "aagun_owner" },
    { 0x7D6B937B, "aagun_target_move" },
    { 0x97B00273, "aagun_target_random_move" },
    { 0x61B99D82, "aaguns" },
    { 0x1FE5D518, "aai" },
    { 0xABB055D2, "aai_to_delete" },
    { 0x888A14E4, "aallies" },
    { 0x47375C89, "aanim2" },
    { 0x01B1CA7B, "aar" },
    { 0xD95682B5, "aarea_ambush_init" },
    { 0x88008637, "aarea_apartment_init" },
    { 0x9F1A8CAC, "aarea_morpheus_init" },
    { 0x6023E710, "aarea_takeover_init" },
    { 0x1CEF2931, "aarea_village_init" },
    { 0x779A68A2, "aargh" },
    { 0x2C9169AC, "aaron" },
    { 0x37942882, "aarrrgh" },
    { 0xC422F588, "aasamples" },
    { 0x63EF5D9F, "aassist" },
    { 0x4DB6BF4D, "aat" },
    { 0x4AE3CDA3, "aat_clientfield_name" },
    { 0x2DB29D00, "aat_cooldown_init" },
    { 0x22304EF6, "aat_cooldown_start" },
    { 0xEBE0C72F, "aat_cost" },
    { 0xBED6680E, "aat_default_info_icon" },
    { 0xA85DCCD0, "aat_default_info_name" },
    { 0xB1043184, "aat_exemptions" },
    { 0xEF7F4C58, "aat_fire_works_fx" },
    { 0x4BD5555B, "aat_hud_manager" },
    { 0x75116C39, "aat_in_use" },
    { 0x13A89743, "aat_initializing" },
    { 0x9892A34E, "aat_reroll" },
    { 0xD627048E, "aat_reserved_name" },
    { 0x0C3C7F2D, "aat_response" },
    { 0x047ED7A7, "aat_shared" },
    { 0xC5D2F74A, "aat_turned" },
    { 0x7B9272CB, "aat_vehicle_damage_monitor" },
    { 0x8B5C405B, "aat_zm" },
    { 0x87AFF21D, "aathash" },
    { 0x91FA70E1, "aaticonmodel" },
    { 0x1BDAB396, "aatid" },
    { 0x64BC32D4, "aatmodel" },
    { 0xB4CFFFBC, "aatobj" },
    { 0xF1A4526E, "aatonweapon" },
    { 0x126DF7CC, "aats" },
    { 0xDAD296E3, "aattackpoints" },
    { 0x036A8FBE, "aattackpointshigher" },
    { 0x29743E4A, "aattackpointslower" },
    { 0x523F145D, "aaxis" },
    { 0x965AB8E8, "ab" },
    { 0x2FFE7614, "ab_battlechatter" },
    { 0x9090898F, "ab_nag_vo" },
    { 0x4CACD4BD, "abalanon" },
    { 0xFF769C14, "abandon" },
    { 0xAF1AB0B7, "abandoned" },
    { 0x8A276B54, "abandoning" },
    { 0xB76D4FE0, "abandonment" },
    { 0x49AC7E58, "abandonmentthink" },
    { 0x8E856387, "abandons" },
    { 0xCDDBCE8A, "abanglecutoff" },
    { 0xE77518B2, "abbreviated" },
    { 0x9109AA99, "abbreviation" },
    { 0xC9EA9D13, "abc" },
    { 0xBCC45B86, "abigail" },
    { 0x9D01AA69, "abilities" },
    { 0x28189C49, "ability" },
    { 0x8469C70B, "ability_gadgets" },
    { 0x767ACA76, "ability_lost" },
    { 0x9101DB2D, "ability_name" },
    { 0x54F2129B, "ability_player" },
    { 0xFCCED877, "ability_power" },
    { 0x2BD142F8, "ability_util" },
    { 0xA5B9D889, "abilityfrontendfrozenmomentaligntarget" },
    { 0xB46F15B8, "abilityfrontendfrozenmomentexploder" },
    { 0x631E94BF, "abilityfrontendfrozenmomentweaponleftanim" },
    { 0xB59CA217, "abilityfrontendfrozenmomentweaponleftmodel" },
    { 0x02E64080, "abilityfrontendfrozenmomentweaponrightanim" },
    { 0xBB57939E, "abilityfrontendfrozenmomentweaponrightmodel" },
    { 0x7EECB64E, "abilityfrontendfrozenmomentxanim" },
    { 0x538075FE, "abilityfrontendfrozenmomentxcam" },
    { 0x502195E1, "abilityfrontendfrozenmomentxcamframe" },
    { 0x0F621FCD, "abilityfrontendfrozenmomentxcamsubxcam" },
    { 0x0029CC6A, "abilitytocheck" },
    { 0x2580C97A, "abject" },
    { 0x83537652, "ablaze" },
    { 0x84110741, "able" },
    { 0x1FCE2586, "ablood" },
    { 0x903B7193, "abm21targetnames" },
    { 0xF6F53A62, "abnormal_status" },
    { 0xCB54095E, "aboard" },
    { 0xBC27A54D, "abomb_targets" },
    { 0xB4B62264, "abomination" },
    { 0xDF918999, "abort" },
    { 0x577494DC, "abort forfeit" },
    { 0x8A6D95B8, "abort_approach" },
    { 0xB02DC2C7, "abort_chain" },
    { 0xBF23185E, "abort_death_watch" },
    { 0xD95F35A9, "abort_ghost_wait_show" },
    { 0xB751AB6F, "abort_ghost_wait_show_to_others" },
    { 0xF723D82D, "abort_ghost_wait_show_to_player" },
    { 0x76CC3F8E, "abort_hints" },
    { 0x2EA093C9, "abort_killcam" },
    { 0x07668ABE, "abort_level" },
    { 0x42404032, "abort_navigation" },
    { 0xDEFCA383, "abort_rechamber" },
    { 0x52523A1B, "abort_reload" },
    { 0x57830464, "abort_scene" },
    { 0x8883E0C4, "abort_schoolcircle" },
    { 0x7D35284B, "abort_sequence" },
    { 0x6ABBFA8A, "abort_tutorial" },
    { 0xC95A13C6, "aborted" },
    { 0xA40044B1, "aborted_tank" },
    { 0xB8BB2BFC, "abortedforprogression" },
    { 0xEA4C822F, "aborting" },
    { 0xA3D5EFFC, "abortkillwhilecontesting" },
    { 0x6F540609, "abortlevel" },
    { 0xE8614265, "abortreloadwhencanshoot" },
    { 0x11F5737B, "abortsupplydropmarkerwaiter" },
    { 0x2ECF4B3E, "abound" },
    { 0x575675D4, "about" },
    { 0x311D5773, "about_to_die" },
    { 0xB9A2E2CB, "about_to_fire" },
    { 0xF892DEC0, "about_to_shoot" },
    { 0xB87057A8, "aboutotlaunch" },
    { 0x47D871AC, "abouttobebreached" },
    { 0xFB37AE27, "abouttobleedout" },
    { 0xA5F3A234, "abouttobleedouttime" },
    { 0x0D41D47C, "above" },
    { 0x2242F014, "above_couches_death" },
    { 0x89292294, "above_player" },
    { 0x85D1AEA2, "above_roof_death" },
    { 0x70C5C333, "above_water_fail" },
    { 0xD914064A, "above_water_fire_vision" },
    { 0x22353E72, "abovehead" },
    { 0x26D2CF39, "abovewater" },
    { 0x88852F0B, "abrams" },
    { 0x117AB6B8, "abrams_aimat_t72" },
    { 0x8BE38002, "abrams_gets_drawing" },
    { 0x5996AAE0, "abrams_moveto_t72" },
    { 0x89E55A2B, "abrams_setup_t72" },
    { 0xC1B343EB, "abrams_shot_explodergroup" },
    { 0x0AD01435, "abrams_stop_slewing_turret" },
    { 0x43D88A65, "abranchnodes" },
    { 0x9E54DC0B, "abreachers" },
    { 0xC3229EF1, "abrupt_end" },
    { 0xA0DC53C2, "abruptly" },
    { 0x69C2F683, "abs" },
    { 0x79900B33, "abs_1" },
    { 0xC452C924, "abs_directness" },
    { 0x1DBF2D26, "abs_num" },
    { 0x3F8482F7, "abs_speed" },
    { 0x348548E9, "abs_turning_speed" },
    { 0x89A42B0A, "absangleclamp180" },
    { 0x64DBCBF2, "absangleclamp360" },
    { 0x5EB69C91, "absanglediff" },
    { 0x467F26BA, "absence" },
    { 0x910BA608, "absheighttoend" },
    { 0xA4416E07, "abslengthtoend" },
    { 0x5640AE96, "absmaxs" },
    { 0x4C3469D8, "absmins" },
    { 0x59FEBE46, "absolute" },
    { 0x09D68CC2, "absolute_code_move_time" },
    { 0x21B1FD57, "absolute_stat_path" },
    { 0xDEDC72AC, "absolute_stat_path_col" },
    { 0x43C91DD4, "absolute_value" },
    { 0x2406C72B, "absolutely" },
    { 0xEB3CCCF9, "absolutes" },
    { 0xC58405EA, "absorb" },
    { 0xAEE6117D, "absorbed" },
    { 0x42F9C570, "absorbtion" },
    { 0x548DF039, "absrelyaw" },
    { 0xADAACCC6, "abstracts" },
    { 0xA5B051A3, "abstruct" },
    { 0x0A91C24E, "absurd" },
    { 0x8C843AB9, "absyawdiff" },
    { 0x7541209B, "absyawtoangles" },
    { 0xBB72D5C9, "absyawtoenemy" },
    { 0xAD7645CF, "absyawtoenemy2d" },
    { 0x1525F775, "absyawtoorigin" },
    { 0xD5D6C0D1, "abuse" },
    { 0x2712B084, "abusing" },
    { 0xF6960BE5, "abval" },
    { 0xBC5D3351, "ac" },
    { 0x77E71E4F, "ac130" },
    { 0xA96B8998, "ac130_allies" },
    { 0x77009AF5, "ac130_almost_at_destination" },
    { 0xF8768E16, "ac130_ambience" },
    { 0x075630C5, "ac130_anim" },
    { 0xBCCC2EF2, "ac130_attachplayer" },
    { 0xF2C37DE2, "ac130_barrage" },
    { 0x8F0989B9, "ac130_code" },
    { 0x4984F6B0, "ac130_credits" },
    { 0x8C546B94, "ac130_credits_code" },
    { 0x1FD8C454, "ac130_dazed_guy" },
    { 0x8AEBB13C, "ac130_defend_gasstation" },
    { 0x7C7C4450, "ac130_devastation" },
    { 0x56B2673E, "ac130_enemy_vehicles" },
    { 0xB369C6F7, "ac130_fake_move" },
    { 0x0F828026, "ac130_fire" },
    { 0x2C615CFC, "ac130_gas_station" },
    { 0x716ED148, "ac130_intro" },
    { 0xCF2E672A, "ac130_irstrobe_kills" },
    { 0x928A8C72, "ac130_kill_player" },
    { 0x4B990F49, "ac130_move_in" },
    { 0xE20D8D60, "ac130_move_out" },
    { 0x81D2BAFE, "ac130_moving_in" },
    { 0x5B5832B9, "ac130_moving_out" },
    { 0xDC28B3E3, "ac130_nofire" },
    { 0x18D0C552, "ac130_overlay" },
    { 0xEBBED780, "ac130_reposition" },
    { 0xA029CF3D, "ac130_rotationspeed" },
    { 0xA81E4D17, "ac130_shoot" },
    { 0xEF93C117, "ac130_snd" },
    { 0x06016A33, "ac130_speed" },
    { 0xA7CA433F, "ac130_target_player" },
    { 0x76FF407D, "ac130_vehicle_die" },
    { 0x16A774EA, "ac130_weapon" },
    { 0xB6D7286D, "ac130origin" },
    { 0xA85EA4D0, "ac130player" },
    { 0xF1CE2677, "ac130shellshock" },
    { 0x9F918D98, "ac4_plants" },
    { 0x175017A9, "ac_slot1" },
    { 0x3D529212, "ac_slot2" },
    { 0xB39E8866, "ac_unit" },
    { 0xF2A3357A, "aca" },
    { 0xCCA0BB11, "acb" },
    { 0xA69E40A8, "acc" },
    { 0xA17C8103, "accel" },
    { 0x7E1210F1, "accel_time" },
    { 0xAEF7CEEA, "accelerate" },
    { 0x82601DDA, "accelerated" },
    { 0x548F33A5, "accelerates" },
    { 0x6CF1C8BB, "accelerating" },
    { 0x1DDFEB41, "acceleration" },
    { 0x33A52B83, "acceleration_per_frame" },
    { 0x7CC11022, "acceleration_vec" },
    { 0x53B1028D, "accelfraction" },
    { 0x41CD8785, "accell" },
    { 0xB72275EB, "accelleration" },
    { 0x37C73CDA, "accelpercent" },
    { 0xAA4E0E59, "accelrate" },
    { 0x87C3A04A, "accelsec" },
    { 0xA6D70538, "acceltime" },
    { 0x74B28E77, "accent" },
    { 0xF4ED3C29, "accept" },
    { 0x7D5EB81D, "acceptable" },
    { 0xC135B4AE, "acceptablepassedtime" },
    { 0x0CDB9B3A, "acceptabletargetnames" },
    { 0xB540FB31, "acceptably" },
    { 0xCB20B856, "accepted" },
    { 0x7A7416BB, "acceptexposedtosky" },
    { 0x44C45C5F, "accepting" },
    { 0xBF5E69B7, "acceptskyexposure" },
    { 0x4AAB26B8, "accepttestclient" },
    { 0x410D46A7, "access" },
    { 0x24344287, "accessable" },
    { 0x8487ECE8, "accessallperk" },
    { 0x0C894E6C, "accessed" },
    { 0xC54B66BF, "accessible" },
    { 0xA4E3D679, "accessing" },
    { 0x4EEA95A4, "accessor" },
    { 0xB4BF49A5, "accessories" },
    { 0xE984CBCE, "accident" },
    { 0x5FBF4FF5, "accidental" },
    { 0xB78C0958, "accidentally" },
    { 0x92BF6C93, "accidently" },
    { 0x4EFA992C, "accommodate" },
    { 0x8DB28A7B, "accomodate" },
    { 0xE22C01E5, "accomodated" },
    { 0x14C91229, "accompanied" },
    { 0x6969FC0A, "accompanying" },
    { 0xA1C72A6C, "accomplish" },
    { 0x2780594F, "accomplished" },
    { 0x6C4A4854, "accordance" },
    { 0xA65EE65C, "accordigly" },
    { 0xD252BD7F, "according" },
    { 0x36B47622, "accordingly" },
    { 0x48F6688E, "account" },
    { 0x0FC6B80C, "account_deposit_expected" },
    { 0x81E80C2C, "account_increment" },
    { 0x37448CF5, "account_max" },
    { 0xA3772722, "account_val" },
    { 0xCBE5509C, "account_value" },
    { 0x77A86132, "accounting" },
    { 0xA2CE8F31, "accounts" },
    { 0x1BE6361B, "accross" },
    { 0xE345B943, "acctime" },
    { 0x8E4C066A, "accum" },
    { 0x06C8D7A0, "accumdam" },
    { 0xB8E72E65, "accumtime" },
    { 0x226DDE7F, "accumturn" },
    { 0xA37377FF, "accumulate" },
    { 0x74CE1569, "accumulated" },
    { 0x5AB231AD, "accumulator" },
    { 0x2B04BF92, "accuracy" },
    { 0xE28CA2DA, "accuracy_bonus" },
    { 0xBC280431, "accuracy_buildup_before_fire" },
    { 0x305CDC5C, "accuracy_buildup_over_time_init" },
    { 0x0B6FA536, "accuracy_increase_over_time" },
    { 0xE13F574B, "accuracy_mod" },
    { 0x21EDDAF2, "accuracy_timeout" },
    { 0xA82BEAFE, "accuracybuilduptime" },
    { 0x021679C3, "accuracygrowthmax" },
    { 0x88F758BA, "accuracygrowthmultiplier" },
    { 0x137ED27D, "accuracygrowthrate" },
    { 0xC880E74C, "accuracyradius" },
    { 0x3C20C28C, "accuracystationarymod" },
    { 0xEA282F27, "accurate" },
    { 0x6495F073, "accuratefire" },
    { 0x263FD9AA, "accurately" },
    { 0x83C2CF4F, "acension" },
    { 0xE891DC9B, "ach" },
    { 0x67DADE85, "achain" },
    { 0x6FADB0A6, "acheivement" },
    { 0x0716EFAE, "achieve" },
    { 0xB9A627AE, "achieve_car_killed_one" },
    { 0x209FEDCE, "achieve_carkilled_by_player" },
    { 0xCC4A92E8, "achieve_check_loop" },
    { 0xB8A2E256, "achieve_enemy_killed_by_flash_banged" },
    { 0xB3B16BC8, "achieve_four_of_kind" },
    { 0x89F5843E, "achieve_three_of_kind" },
    { 0x1E9055A6, "achieve_tvs" },
    { 0x5E8200B0, "achieve_tvs_hook" },
    { 0xAED5EB6E, "achieved" },
    { 0xB021F848, "achieved_lock" },
    { 0x92DCE71E, "achievement" },
    { 0x774FDFCE, "achievement_a_burst_of_flavor" },
    { 0x29CEA7BC, "achievement_acid_drip" },
    { 0x9463C8DC, "achievement_all_your_base" },
    { 0x329D94E9, "achievement_awaken_the_gazebo" },
    { 0xA301CC9E, "achievement_buried_sidequest" },
    { 0xD2FEBD55, "achievement_candygram" },
    { 0xD84C6BAE, "achievement_checker" },
    { 0xEF01146D, "achievement_dance_on_my_grave" },
    { 0x5B3813CA, "achievement_death_from_below" },
    { 0x469F942B, "achievement_destroy_notify" },
    { 0xC2EC6D92, "achievement_dont_fire_until_you_see" },
    { 0xBCF78685, "achievement_ectoplasmic_residue" },
    { 0x0D50DEDF, "achievement_eggs" },
    { 0x0A111A3F, "achievement_facing_the_dragon" },
    { 0x8F051D9D, "achievement_feed_the_beast" },
    { 0xB8C6240E, "achievement_fsirt_against_the_wall" },
    { 0x1FDDC80D, "achievement_fuel_efficient" },
    { 0xDB8D7DBC, "achievement_full_lockdown" },
    { 0xB8ED20BF, "achievement_fully_armed" },
    { 0x951115CD, "achievement_gg_bridge" },
    { 0x7DF3CEAF, "achievement_give_on_counter" },
    { 0x7622007A, "achievement_give_on_notify" },
    { 0x42B8C382, "achievement_ground_control" },
    { 0x79B7FA76, "achievement_highrise_sidequest" },
    { 0x6B21F112, "achievement_i_dont_think_they_exist" },
    { 0x3C3FBEEA, "achievement_i_hate_monkeys" },
    { 0xB7426A17, "achievement_i_see_live_people" },
    { 0x99B76A65, "achievement_im_my_own_best_friend" },
    { 0x814989CC, "achievement_im_on_a_tank" },
    { 0x0A780D7C, "achievement_im_your_huckleberry" },
    { 0xE337BCB3, "achievement_kung_fu_grip" },
    { 0x70138D4C, "achievement_lower" },
    { 0x0CFE238A, "achievement_mad_without_power" },
    { 0xBA7BD46A, "achievement_making_the_rounds" },
    { 0x7C095399, "achievement_martian_weapons" },
    { 0x8D8C3A31, "achievement_master_of_disguise" },
    { 0xC883541B, "achievement_master_wizard" },
    { 0x744F5E6C, "achievement_mazed_and_confused" },
    { 0x9ACA36E2, "achievement_monitor_func" },
    { 0x1FA8A86A, "achievement_monkey_see_monkey_doom" },
    { 0x655A4C66, "achievement_moon_sidequest" },
    { 0x043E4662, "achievement_name_lower" },
    { 0x3BF71066, "achievement_no_one_escapes_alive" },
    { 0xF624535A, "achievement_not_a_gold_digger" },
    { 0xFD543F5E, "achievement_notify" },
    { 0x149D10B7, "achievement_notify_func" },
    { 0x0885001E, "achievement_one_giant_leap" },
    { 0xF22B525D, "achievement_one_small_hack" },
    { 0xB69AB1E6, "achievement_overachiever" },
    { 0x17BF944C, "achievement_paranormal_progress" },
    { 0xFBB1F08F, "achievement_perkholic_anon" },
    { 0x6D544BC9, "achievement_perks_in_space" },
    { 0x2E3A89F1, "achievement_player_started_round_in_maze" },
    { 0xA300E3B6, "achievement_player_stayed_in_maze_for_entire_round" },
    { 0x494FA6DE, "achievement_playing_with_power" },
    { 0xEF88D695, "achievement_polyarmory" },
    { 0x763DDCD9, "achievement_pop_goes_the_weasel" },
    { 0x75462FEC, "achievement_quiet_on_the_set" },
    { 0x5F9A3491, "achievement_record_monkey_death" },
    { 0xD89D4636, "achievement_revisionist_historian" },
    { 0x6373ACE7, "achievement_saving_the_day_all_day" },
    { 0xE0FADBFC, "achievement_set_interim_sidequest_stat_for_all_players" },
    { 0x8DEE3B1C, "achievement_shafted" },
    { 0xE3AA8AE4, "achievement_shooting_on_location" },
    { 0x1DFEC7AC, "achievement_slippery_when_undead" },
    { 0x6B8F2B53, "achievement_sound_func" },
    { 0xC675A9D4, "achievement_standard_equipment_may_vary" },
    { 0x22D7E754, "achievement_stop_brutality" },
    { 0x7004FD41, "achievement_stop_brutality_success_check" },
    { 0xB7D83DBD, "achievement_stuntman" },
    { 0x5243FF74, "achievement_the_lights_of_their_eyes" },
    { 0xC0E30C1F, "achievement_tomb_sidequest" },
    { 0x2BA5664E, "achievement_transit_sidequest" },
    { 0xA5116CED, "achievement_trapped_in_time" },
    { 0x4A352FC4, "achievement_undead_mans_party_bus" },
    { 0x27DCE7C5, "achievement_unlock" },
    { 0x34EA1676, "achievement_vertigoner" },
    { 0xAFD8D4A3, "achievement_watcher" },
    { 0x1D444253, "achievement_watcher_lsat_upgrade" },
    { 0x5FAADCF9, "achievement_watcher_tanks" },
    { 0x958AA44F, "achievement_when_the_revolution_comes" },
    { 0x8E52E6EB, "achievement_you_have_no_power_over_me" },
    { 0x25D9B9CE, "achievement_zm_happy_hour" },
    { 0x7AFD1CE2, "achievement_zm_island_thrasher_rescue" },
    { 0x4A344D81, "achievements" },
    { 0x90A1E0D1, "achieves" },
    { 0x4835EAAD, "achievment" },
    { 0x6E31A5C3, "achivement_checker" },
    { 0x6B7710D0, "acid_array" },
    { 0x3F4B8CA6, "acid_taken" },
    { 0x1E5B8612, "acid_timeout" },
    { 0x42D7286C, "acid_trap_damage" },
    { 0x2934C355, "acid_trap_finished" },
    { 0x3ABC376D, "acid_trap_fx" },
    { 0xA217AE30, "acid_trap_fx_done" },
    { 0x614F8E83, "acid_trap_host_migration_listener" },
    { 0xCCDF8D5F, "acid_trap_hostmigration" },
    { 0x691E9393, "acid_trap_move_switch" },
    { 0x9B0F2D25, "acid_trap_think" },
    { 0xDDAAA3D7, "acid_traps" },
    { 0x768A6D60, "ack" },
    { 0xA07BE431, "ack_blue_flr2_trig" },
    { 0x4605B4CC, "ack_lines" },
    { 0x71E283F3, "acked" },
    { 0x06122EF8, "acking" },
    { 0x138A7FB3, "acknowledge" },
    { 0xCD23090D, "acknowledged" },
    { 0xE110FD6B, "acknowledgement" },
    { 0x7E99C34A, "acknowledgements" },
    { 0x90949983, "acog" },
    { 0x48E02D07, "acog_objective" },
    { 0x0680BB7C, "acog_rifle" },
    { 0x67FE406D, "acole" },
    { 0xC21CC010, "acolornodetriggers" },
    { 0x76A701C3, "acompany" },
    { 0x88C629B7, "acos" },
    { 0x5182D234, "acoustic" },
    { 0x98FC3E37, "acousticflatorigin" },
    { 0xEFC40536, "acousticsensor" },
    { 0x46660DCE, "acousticsensordetonate" },
    { 0xE19EE9A4, "acousticsensorhandle" },
    { 0xBF6D5680, "acousticsensorradius" },
    { 0xE1B96029, "acousticsensors" },
    { 0x88E4AC43, "acquierd" },
    { 0x2AC07CF3, "acquire" },
    { 0xEBDB3162, "acquire_crossbow" },
    { 0x22526A89, "acquire_weapon_toggle" },
    { 0x985DE94D, "acquired" },
    { 0x867E20A2, "acquires" },
    { 0x79542D88, "acquiretime" },
    { 0x5C7A222C, "acquireupperheight" },
    { 0x29645876, "acquiring" },
    { 0x11AE2F66, "acquisition" },
    { 0x028C8946, "acrobatics_end" },
    { 0xEC5F319E, "across" },
    { 0x10D74017, "act" },
    { 0x6EF553DC, "acted" },
    { 0x5E7D387C, "actice_events" },
    { 0xE66C16C9, "acting" },
    { 0xB3F0D41A, "acting_squad_leader" },
    { 0x975A394F, "action" },
    { 0xCC2D6384, "action1" },
    { 0x3E34D2BF, "action2" },
    { 0x18325856, "action3" },
    { 0x5A25F449, "action4" },
    { 0x8580C1C5, "action_anim" },
    { 0x1C81F354, "action_anims" },
    { 0x60B39EF3, "action_animscripted" },
    { 0xBD24DB1A, "action_arg" },
    { 0xEFB2B71E, "action_attack_checker" },
    { 0xC1B955AC, "action_berserk" },
    { 0xCB111A4F, "action_debug_color" },
    { 0xA96011C2, "action_gunshop_candy" },
    { 0x34C08936, "action_gunshop_run" },
    { 0xCD5D357E, "action_headbang" },
    { 0xC4BB2E17, "action_jail_close" },
    { 0xD03FD0D7, "action_jail_cower" },
    { 0x78419ADF, "action_jail_idle" },
    { 0x045366C1, "action_jail_open" },
    { 0x5A35FB30, "action_jail_run" },
    { 0x95D3A0AA, "action_jail_wait" },
    { 0x1F97BC18, "action_music_playing" },
    { 0x7235593D, "action_navigate_mansion" },
    { 0xD33F219E, "action_node" },
    { 0x1731906B, "action_notetrack" },
    { 0x66A25A28, "action_notify_attack" },
    { 0x8CAA0F88, "action_notify_melee" },
    { 0x13E0DBE6, "action_notify_use_doubletap" },
    { 0xB7FFCFDB, "action_player_ask" },
    { 0x3CD665FF, "action_player_follow" },
    { 0x618AFF4E, "action_player_idle" },
    { 0xBDF83B3A, "action_roam_point" },
    { 0xD522574E, "action_slot" },
    { 0xA23F75A3, "action_smell" },
    { 0xFB7D8715, "action_smoke" },
    { 0xCFF788DD, "action_string" },
    { 0xF018C549, "action_table_eat" },
    { 0xFBFB8761, "action_teleport_to_courtyard" },
    { 0x436336DA, "actionbind" },
    { 0x281750D5, "actionbinds" },
    { 0xFFC3E8F3, "actionbutton" },
    { 0x0415C223, "actionbutton_count" },
    { 0xE28A09BB, "actionbutton_height" },
    { 0xFB3CAC2B, "actionbutton_icon_size" },
    { 0x27F7BD7D, "actionbutton_offscreen_y" },
    { 0xCB05A231, "actionbutton_pad" },
    { 0xBDC15B7C, "actionbutton_sep_location" },
    { 0xA2D65F46, "actionbutton_sep_size" },
    { 0x2A2F4ED2, "actionbutton_width" },
    { 0xD78B2F5B, "actionbutton_y" },
    { 0x0563D704, "actionbuttonbrackets" },
    { 0xFC162F76, "actionbuttonframe" },
    { 0xB63032C1, "actionbuttoninfocard" },
    { 0xF85E1606, "actionbuttonslottimer" },
    { 0xE8597A37, "actionbuttonvisible" },
    { 0xE321E59E, "actionchainthink" },
    { 0x89994704, "actionmusicset" },
    { 0x8806EA42, "actionname" },
    { 0xAFD03D67, "actionnode" },
    { 0x0686F899, "actionnodethink" },
    { 0x9793BE16, "actions" },
    { 0x72EFEAD3, "actionslot" },
    { 0x7DB80007, "actionslotfourbuttonpressed" },
    { 0x8BA29281, "actionslotonebuttonpressed" },
    { 0x511313E9, "actionslotorder" },
    { 0x49FC8CD3, "actionslotpressed" },
    { 0xE57835F5, "actionslotthreebuttonpressed" },
    { 0x40657223, "actionslottwobuttonpressed" },
    { 0x7855E45E, "actionstateindex" },
    { 0x25294CFE, "activate" },
    { 0xCD81E984, "activate_acid_trap" },
    { 0xADB4263B, "activate_ai_on_end_path" },
    { 0xB335C25E, "activate_all_in_array" },
    { 0x91F29143, "activate_all_paths" },
    { 0xAD075BF7, "activate_barrier_goals" },
    { 0xE4C8CEB1, "activate_building_zones" },
    { 0xAC430C95, "activate_camera_light" },
    { 0xBF7495FA, "activate_capture_zone" },
    { 0x54B08AF4, "activate_chugabud_effects_and_audio" },
    { 0xB8457087, "activate_color_trigger" },
    { 0x7930FC06, "activate_color_trigger_from_sr71" },
    { 0xA9E56EA1, "activate_color_trigger_internal" },
    { 0x1FBD770B, "activate_consequences" },
    { 0xEA7709E1, "activate_door_flags" },
    { 0x442E049B, "activate_drone_control" },
    { 0xA759729A, "activate_electric_trap" },
    { 0xD1DBE46C, "activate_enemy_color_trig" },
    { 0x2F9C3D1C, "activate_enemy_motion" },
    { 0xC1952896, "activate_enemy_motion_pincer" },
    { 0x6DDD91A0, "activate_event5_triggers" },
    { 0xA9236362, "activate_exploder" },
    { 0xA3AA7B07, "activate_exploder_on_clients" },
    { 0x7189F668, "activate_extra_slot" },
    { 0x71DF3EC1, "activate_f35_room" },
    { 0x48D7B486, "activate_fake_friendly_dds" },
    { 0xC1C60F8E, "activate_fan_trap" },
    { 0x34641F6E, "activate_farmhouse_defenders" },
    { 0x696CF5B4, "activate_fire_link" },
    { 0xA149DCFA, "activate_flashlight_ambush_spawners" },
    { 0x0E08FDEC, "activate_foxhole1_waves" },
    { 0x266309C3, "activate_foxhole2_waves" },
    { 0x1DB2D24A, "activate_foxhole3_waves" },
    { 0x5C7825F8, "activate_friendlies" },
    { 0xF54AACD3, "activate_goals_when_door_opened" },
    { 0xDAB81D02, "activate_heavy_resistance" },
    { 0x0086A719, "activate_heli_guy" },
    { 0xAF9BF148, "activate_heli_guy_trigger" },
    { 0xCF8F9518, "activate_hero_gadget" },
    { 0x13C89134, "activate_hud" },
    { 0x0FB07DA4, "activate_individual_exploder" },
    { 0x3B8AC5D4, "activate_kill_trigger" },
    { 0xC1F96B46, "activate_lander_poi" },
    { 0x8A235FEB, "activate_millibar" },
    { 0x09468036, "activate_mortar" },
    { 0x87D3B877, "activate_move_handle" },
    { 0xA0A4C52A, "activate_next" },
    { 0x734C5F7E, "activate_notify" },
    { 0x4F0B3956, "activate_numbers_audio" },
    { 0xAC114BC3, "activate_outdoor_zones" },
    { 0xF2855845, "activate_packapunch" },
    { 0x0313D466, "activate_per_player" },
    { 0x3861D068, "activate_pers_flopper_effect" },
    { 0xB1AAFE8A, "activate_player_health_visionset" },
    { 0xD3B09922, "activate_radiant_exploder" },
    { 0x33F03BAC, "activate_radio_egg" },
    { 0xA203F4E4, "activate_radio_vo" },
    { 0x220D09B5, "activate_steiner_objective" },
    { 0x25E62CFC, "activate_tank_wait_with_no_cost" },
    { 0x05E061AE, "activate_the_wrong_exit_from_village_trigger" },
    { 0x24CAAC3A, "activate_tower_trap" },
    { 0xAC71101A, "activate_track" },
    { 0x9A687FFF, "activate_trig" },
    { 0xD92C1F83, "activate_trigger" },
    { 0x88EDCA03, "activate_trigger_name" },
    { 0xBAA5B4C4, "activate_trigger_with_noteworthy" },
    { 0xB3093EB7, "activate_trigger_with_targetname" },
    { 0x690121F2, "activate_triggers" },
    { 0x3568ABEB, "activate_tutorial_mode" },
    { 0x23107C07, "activate_upon_notify" },
    { 0xE91F62F2, "activate_vending_machine" },
    { 0x697BD67D, "activate_vending_machines" },
    { 0x4E7B2C34, "activate_weapon_toggle" },
    { 0x02F58A11, "activate_zombie_point_of_interest" },
    { 0xD50FF000, "activate_zombieland_poi_positions" },
    { 0xFF1B8EFB, "activate_zone_nml" },
    { 0xFE91B738, "activate_zone_trig" },
    { 0x6F7B3A72, "activateambient" },
    { 0x84294CD2, "activateambientpackage" },
    { 0x09F07517, "activateambientroom" },
    { 0x546ECD1D, "activatecamerastatic" },
    { 0xDE3F25B3, "activatecamerastaticwaiter" },
    { 0xC6F841C8, "activateclientexploder" },
    { 0x71287D97, "activateclientradiantexploder" },
    { 0x337618CE, "activatecombatrobot" },
    { 0x44963352, "activatecounteruav" },
    { 0xA1037F66, "activatecrosshair" },
    { 0x55BED05E, "activated" },
    { 0x40B37F6A, "activated_by_player" },
    { 0x91DDD667, "activated_color_trigger" },
    { 0x47647466, "activated_entity_distance" },
    { 0x7FAF8988, "activated_flinger" },
    { 0x4DD152D7, "activated_station" },
    { 0xEDFD5135, "activatedart" },
    { 0xA8BDE492, "activatedronestrike" },
    { 0x32E017C6, "activateelectrictrap" },
    { 0x9765D140, "activateemp" },
    { 0xAB80CA1C, "activatefx" },
    { 0xFFE59D16, "activateliquid" },
    { 0x98FF96B0, "activatemaingunner" },
    { 0xA6EC3693, "activatemicrowaveturret" },
    { 0x812B6D79, "activatemixer" },
    { 0x9BA5E7D3, "activatenextkillstreak" },
    { 0xAC46B2F7, "activatepen" },
    { 0xF2A8EC59, "activateprop" },
    { 0x63FFDEF8, "activateradius" },
    { 0xF537309B, "activateradiussquared" },
    { 0x5460B070, "activaterapskillstreak" },
    { 0x582A777B, "activateratio" },
    { 0x67F918A7, "activatercbomb" },
    { 0xF7DA12E1, "activates" },
    { 0x861DA8B9, "activatesatellite" },
    { 0x95A79A4A, "activatesentinel" },
    { 0x3F1D2F33, "activatesound" },
    { 0x99239C12, "activatesupportgunner" },
    { 0x53FB4D3B, "activatetrack" },
    { 0xE2032C1C, "activateturret" },
    { 0x749E27A2, "activateuav" },
    { 0x7B2EBC83, "activatezip" },
    { 0xAAD41617, "activating" },
    { 0x07A2EBCD, "activatingkillstreak" },
    { 0x7AFBF7CD, "activation" },
    { 0x17286223, "activation_damage" },
    { 0x5F40514C, "activation_electricity_finished" },
    { 0x435DF4AE, "activation_flash" },
    { 0xF002BCBA, "activationdelay" },
    { 0xD665E94C, "activations" },
    { 0xF61BB5AE, "activator" },
    { 0x16D4A623, "active" },
    { 0x9F308938, "active_ai" },
    { 0x550F5FDE, "active_arty" },
    { 0xC3624ED5, "active_assets" },
    { 0xB3E5E758, "active_autofill_wallbuys" },
    { 0x6367FA4E, "active_beams" },
    { 0xFDE4ADA0, "active_beartraps" },
    { 0x1611B636, "active_camo" },
    { 0x90BD4F2F, "active_camo_changed" },
    { 0x4341FD62, "active_camo_damage" },
    { 0x27ED1685, "active_camo_disabled" },
    { 0x899F741F, "active_camo_flicker" },
    { 0x5B40C260, "active_camo_normal" },
    { 0x1EC1401E, "active_camo_reveal" },
    { 0x9ACF8720, "active_camo_sound_ent" },
    { 0x5148F2B9, "active_camo_supported" },
    { 0x1026A3B3, "active_count" },
    { 0xC974B6B2, "active_event" },
    { 0x2813BA92, "active_event_stats" },
    { 0x003727F2, "active_event_stats_axis" },
    { 0x4E91793D, "active_events" },
    { 0x3703EB43, "active_events_axis" },
    { 0xC5CAAB14, "active_func" },
    { 0xDAC7B016, "active_heli" },
    { 0x69CF0939, "active_links" },
    { 0x744EB752, "active_managers" },
    { 0x70E62F7C, "active_monkeys" },
    { 0xF458BBE7, "active_objective" },
    { 0x123B1DD6, "active_on_ai" },
    { 0x8BA53B54, "active_patrolwalk_pause" },
    { 0x43EC22ED, "active_patrolwalk_v1" },
    { 0x69EE9D56, "active_patrolwalk_v2" },
    { 0x8FF117BF, "active_patrolwalk_v3" },
    { 0x85DFBEE0, "active_patrolwalk_v4" },
    { 0xABE23949, "active_patrolwalk_v5" },
    { 0x3F744212, "active_pegasus" },
    { 0xE7EBC02A, "active_powerup" },
    { 0x3B56C6E5, "active_powerups" },
    { 0xFEC4F818, "active_reasses_time" },
    { 0xF942B787, "active_satchels" },
    { 0xA7D91711, "active_scenes" },
    { 0x451A400C, "active_stage" },
    { 0x863112D1, "active_time" },
    { 0x65513821, "active_timer" },
    { 0xD140CCDB, "active_track" },
    { 0xD514EFBD, "active_vehicles" },
    { 0xD36F2C6D, "active_wait_spread" },
    { 0x10CEB7ED, "active_zombie_locations" },
    { 0xF14FF6DC, "active_zone" },
    { 0x8D3FD481, "active_zone_names" },
    { 0x8F10B21F, "active_zones" },
    { 0xE5C2EEC1, "activeai" },
    { 0x5AE045C2, "activeairstrikes" },
    { 0x4196824F, "activeambientpackage" },
    { 0xBB860A08, "activeambientroom" },
    { 0x5E9C59E1, "activeambientroomname" },
    { 0xB3DFD50E, "activebouncingbetties" },
    { 0xFFB234A2, "activebusstate" },
    { 0xAC881F4E, "activeclassselected" },
    { 0x5680684F, "activecontractindex" },
    { 0xCF0D7064, "activecontractindices" },
    { 0xAC1CFCD8, "activecount" },
    { 0x47DB6562, "activecounteruavs" },
    { 0x78AD930E, "activecuav" },
    { 0xDDF807AB, "activeemp" },
    { 0x34714CA0, "activeempowner" },
    { 0xDF8C1A8A, "activeemps" },
    { 0xCA13F17D, "activeendtime" },
    { 0x5A2F25E1, "activeenemyemp" },
    { 0xA02F9840, "activeenemylocs" },
    { 0x7E761CF1, "activeenemysquad" },
    { 0xB221DF58, "activeenemysquads" },
    { 0x64FC0F30, "activeeventname" },
    { 0x3B349FCD, "activefree" },
    { 0xA3C36C0B, "activefriendlyspawn" },
    { 0x17E7B4D5, "activefx" },
    { 0xFF8B61EA, "activegrenades" },
    { 0x4CB12C02, "activegrenadetimer" },
    { 0xA67D5407, "activehorselocs" },
    { 0x2F82C5A0, "activekillstreaks" },
    { 0xD9602727, "activelist" },
    { 0x2B9CBB4E, "actively" },
    { 0x482A11CB, "activemanagers" },
    { 0x937A8687, "activemusicstate" },
    { 0xB7026EBA, "activenodes" },
    { 0x0C07570B, "activenote" },
    { 0x2D9455F9, "activeplayercount" },
    { 0x8D7AC87F, "activeplayercounteruavs" },
    { 0x80AE09CD, "activeplayeremps" },
    { 0x9B1393E7, "activeplayers" },
    { 0x9BFF7D86, "activeplayersatellites" },
    { 0xB094C223, "activeplayeruavs" },
    { 0x54C17BEE, "activepoints" },
    { 0xA078D13F, "activeproximitygrenades" },
    { 0x74C14ACF, "activeremotecontroltriggers" },
    { 0x2F793699, "activerpglocs" },
    { 0x84FBD6A5, "activesatellites" },
    { 0xC68D4EEF, "activesatellitesanduavs" },
    { 0x667E58EB, "activeselect" },
    { 0xBDA200C4, "activespawnangles" },
    { 0x8C06EC31, "activespawnlocation" },
    { 0xA73ED5E6, "activespawnpoint" },
    { 0x700C95EF, "activesquad" },
    { 0xD8FA2836, "activesquads" },
    { 0x895C5CDD, "activestreak" },
    { 0x5FB39FA1, "activetargetcount" },
    { 0xEF73F80D, "activeteamcount" },
    { 0xB7663294, "activeteamops" },
    { 0x71071558, "activetime" },
    { 0xB05F45D8, "activetrack" },
    { 0x337010CC, "activetrackindex" },
    { 0xE3532549, "activeuav" },
    { 0x1303E940, "activeuavs" },
    { 0xBEA0044D, "activeuavsandsatellites" },
    { 0x60DF1591, "activeuavvictim" },
    { 0xC1636098, "activeunits" },
    { 0x608AEBF1, "activevisionset" },
    { 0x5F0F1BD7, "activeweapon" },
    { 0x1E446FE1, "activezone" },
    { 0x74DC5688, "activezones" },
    { 0x192C7080, "activie" },
    { 0xF830B3CA, "activity" },
    { 0xEB076B5E, "activity1_ambient" },
    { 0xD2698AF7, "activity1_heli1" },
    { 0x937C4902, "activity1_heli1_start" },
    { 0x60621BBC, "activity1_heli2" },
    { 0xEFA93D99, "activity1_heli2_start" },
    { 0x86649625, "activity1_heli3" },
    { 0xC23A81FC, "activity1_heli3_start" },
    { 0x05C5FBE5, "activity1_helis" },
    { 0xE92690CB, "activity1_truck_1" },
    { 0x3FAFE4EE, "activity1_truck_1_start" },
    { 0x771F2190, "activity1_truck_2" },
    { 0x9D219BF9, "activity1_truck_3" },
    { 0x6E96C172, "activity1_truck_3a" },
    { 0x5B2E0006, "activity1_truck_4" },
    { 0xB162ED97, "activity1_truck_4_start" },
    { 0x81307A6F, "activity1_truck_5" },
    { 0x0F290B34, "activity1_truck_6" },
    { 0xCAD254E1, "activity1_truck_6_start" },
    { 0x352B859D, "activity1_truck_7" },
    { 0x228DAF70, "activity1_truck_go" },
    { 0x1ED463ED, "activity2_ambient" },
    { 0xF56EA94B, "activity2_migs" },
    { 0xBAEDB875, "activity2_truck_4" },
    { 0x94EB3E0C, "activity2_truck_5" },
    { 0x331341E1, "activity2_truck_start" },
    { 0x70DCD55F, "activity_vignette" },
    { 0xF1074DF4, "actor" },
    { 0x8E0DB83E, "actor2" },
    { 0x4A585342, "actor_ac130_damage_override" },
    { 0xEBDD6CFF, "actor_ally_ac130_ar_m16basic" },
    { 0xDF252C0C, "actor_ally_ac130_ar_m4grunt" },
    { 0x721E396B, "actor_ally_ac130_lmg_saw" },
    { 0x927CC12C, "actor_ally_afghan_muj_assault_base" },
    { 0x21BAAB15, "actor_ally_afghan_muj_launcher_base" },
    { 0x8B18EA3F, "actor_ally_afghan_muj_lmg_base" },
    { 0x4576137A, "actor_ally_afghan_muj_smg_base" },
    { 0x19E46792, "actor_ally_afghan_muj_sniper_base" },
    { 0xE569943D, "actor_ally_afghan_muj_stinger_base" },
    { 0xA4107285, "actor_ally_afghan_muj_zhaos_men" },
    { 0x05271335, "actor_ally_afghan_nomad" },
    { 0x4884C79C, "actor_ally_blackkit_ar_m4grenadier" },
    { 0xE28A78F9, "actor_ally_blackkit_shtgn_winchester" },
    { 0x99A4C770, "actor_ally_blackkit_smg_mp5" },
    { 0x84EB79C5, "actor_ally_blackkit_smg_mp5sd" },
    { 0xE454D0EB, "actor_ally_cartel_assault_base" },
    { 0x264CFB92, "actor_ally_cartel_shotgun_base" },
    { 0x9EC9B209, "actor_ally_cartel_smg_base" },
    { 0x736416B8, "actor_ally_dog_sp" },
    { 0x185EC96C, "actor_ally_hero_gaz_sas_woodland" },
    { 0x45FA1482, "actor_ally_hero_gaz_sas_woodland_silencer" },
    { 0x1A981910, "actor_ally_hero_kamarov_russian" },
    { 0x73B703D4, "actor_ally_hero_mark_blackkit" },
    { 0xE9156500, "actor_ally_hero_mark_desert" },
    { 0x3C68C52A, "actor_ally_hero_mark_desert_nvg" },
    { 0x91340652, "actor_ally_hero_mark_no_helmet" },
    { 0xE49CF2BB, "actor_ally_hero_mark_woodland" },
    { 0x3194C68F, "actor_ally_hero_mark_woodland_silencer" },
    { 0x72C81B3A, "actor_ally_hero_price_blackkit" },
    { 0x5B2CEDB6, "actor_ally_hero_price_blackkit_maskup" },
    { 0x698547F6, "actor_ally_hero_price_desert" },
    { 0x02D271CF, "actor_ally_hero_price_ghillie" },
    { 0xB384289F, "actor_ally_hero_price_ghillie_sniper" },
    { 0x724FA10A, "actor_ally_hero_price_sas_nvg" },
    { 0x80E4B3CF, "actor_ally_hero_price_sas_woodland" },
    { 0x86A01FC1, "actor_ally_hero_price_woodland" },
    { 0x76D50F55, "actor_ally_hero_price_woodland_silencer" },
    { 0x8991631C, "actor_ally_hero_vasquez_desert" },
    { 0x4F8AD162, "actor_ally_infantry_panama_assault_base" },
    { 0x71C06B60, "actor_ally_infantry_panama_smg_base" },
    { 0x6D8E9087, "actor_ally_lapd_assault_base" },
    { 0xB6D28B09, "actor_ally_lapd_bike_pistol_base" },
    { 0x7D4783CE, "actor_ally_lapd_drone" },
    { 0x32D74F1E, "actor_ally_lapd_drone_rigid" },
    { 0x95469E3E, "actor_ally_lapd_medic_base" },
    { 0x2878B09F, "actor_ally_lapd_pistol_base" },
    { 0xC3A380BE, "actor_ally_lapd_shotgun_base" },
    { 0xE7292B55, "actor_ally_marine_ar_m16basic" },
    { 0x0930DD98, "actor_ally_marine_ar_m16grenadier" },
    { 0x8FBAEA33, "actor_ally_marine_ar_m4grenadier" },
    { 0xDE80C57A, "actor_ally_marine_ar_m4grunt" },
    { 0xD9C5F829, "actor_ally_marine_ar_m4shotgun_combo" },
    { 0x1AEFFE09, "actor_ally_marine_lmg_saw" },
    { 0xA1C7466E, "actor_ally_marine_shtgn_winchester" },
    { 0xB28A6846, "actor_ally_marine_woodland_ar_m4grenadier" },
    { 0xF3FD6AF3, "actor_ally_marine_woodland_ar_m4grunt" },
    { 0x5407669A, "actor_ally_marine_woodland_lmg_saw" },
    { 0x9A97DB12, "actor_ally_marine_woodland_smg_mp5" },
    { 0x9C0190A4, "actor_ally_navy_blackout_assault_base" },
    { 0x73EA6EF8, "actor_ally_navy_blackout_cinematicrig" },
    { 0x397B341A, "actor_ally_navy_blackout_pistol_base" },
    { 0xE13DAA21, "actor_ally_navy_blackout_shotgun_base" },
    { 0x948FF3D2, "actor_ally_navy_blackout_smg_base" },
    { 0x7FB2BCCA, "actor_ally_navy_blackout_sniper_base" },
    { 0x4D7BF73F, "actor_ally_navy_blackout_torch_guy" },
    { 0x2C15EE53, "actor_ally_navy_blackout_wounded" },
    { 0xB5053D74, "actor_ally_navy_blackout_wounded_woman" },
    { 0x34B3EFD9, "actor_ally_nvg_marine_ar_m4grenadier" },
    { 0xEB71C384, "actor_ally_nvg_marine_ar_m4grunt" },
    { 0x8D6B7D8B, "actor_ally_nvg_marine_ar_m4shotgun_combo" },
    { 0xAFF645B3, "actor_ally_nvg_marine_lmg_saw" },
    { 0x7BDFEBC9, "actor_ally_nvg_marine_snpr_m14scoped" },
    { 0xF793FB76, "actor_ally_pdf_assault_base" },
    { 0x18C9D50F, "actor_ally_pdf_launcher_base" },
    { 0x24199A6D, "actor_ally_pdf_lmg_base" },
    { 0x2760CE5C, "actor_ally_pdf_smg_base" },
    { 0x15B3C5AC, "actor_ally_pdf_sniper_base" },
    { 0x40EB3DF6, "actor_ally_pilot_velinda_desert" },
    { 0x62AE05C1, "actor_ally_pilot_velinda_woodland" },
    { 0x2E3E2609, "actor_ally_pilot_zach_desert" },
    { 0xB62637F2, "actor_ally_pilot_zach_woodland" },
    { 0xABDBD61D, "actor_ally_rus_commissar_pistol" },
    { 0xC296F381, "actor_ally_rus_commissar_ppsh" },
    { 0xF496BD7A, "actor_ally_rus_hero1" },
    { 0xBB84EFED, "actor_ally_rus_reg_bazooka" },
    { 0x542C4361, "actor_ally_rus_reg_moisin" },
    { 0x97124821, "actor_ally_rus_reg_moisinmolotov" },
    { 0xDDE8399D, "actor_ally_rus_reg_moisinscoped" },
    { 0x0CCCFEEF, "actor_ally_rus_reg_portabledp28" },
    { 0x355051C5, "actor_ally_rus_reg_ppsh" },
    { 0x00D3E024, "actor_ally_rus_reg_ppsh_forsniper" },
    { 0x7DAB8791, "actor_ally_rus_reg_svt40" },
    { 0xCF331032, "actor_ally_rus_reg_wet_moisin" },
    { 0x20B07A5A, "actor_ally_rus_reg_wet_ppsh" },
    { 0x9681E98D, "actor_ally_rus_sarge" },
    { 0x60C5B0B4, "actor_ally_rus_sarge_nocoat" },
    { 0xAC29564B, "actor_ally_rus_wet_hero1" },
    { 0x7DC18C14, "actor_ally_rus_wet_sarge" },
    { 0x29024179, "actor_ally_russian_ar_ak47" },
    { 0x2B80E490, "actor_ally_russian_ar_ak74u" },
    { 0x86C3EF3D, "actor_ally_russian_ar_g36c" },
    { 0x67BF61A8, "actor_ally_russian_at_rpg7" },
    { 0xED1B675A, "actor_ally_russian_dead_ar_ak47" },
    { 0x7AAAABF5, "actor_ally_russian_lmg_rpd" },
    { 0x5B152F73, "actor_ally_russian_smg_skorpion" },
    { 0x14ACC7F2, "actor_ally_russian_snpr_dragunov" },
    { 0xB468396B, "actor_ally_sas_woodland_ar_m4grenadier" },
    { 0x8B269D42, "actor_ally_sas_woodland_ar_m4grunt" },
    { 0xDF662EC1, "actor_ally_sas_woodland_lmg_saw" },
    { 0xF44325E6, "actor_ally_sas_woodland_shtgn_winchester" },
    { 0x3ED3AED1, "actor_ally_sas_woodland_smg_mp5" },
    { 0x291AA6EC, "actor_ally_sas_woodland_smg_mp5sd" },
    { 0x59C664DD, "actor_ally_sas_woodland_stinger" },
    { 0x1491F6E5, "actor_ally_sco_haiti_assault_base" },
    { 0x312EF396, "actor_ally_sco_haiti_launcher_base" },
    { 0xA3822B96, "actor_ally_sco_haiti_lmg_base" },
    { 0xC9096BE3, "actor_ally_seal_blackout_assault_base" },
    { 0x0156F76F, "actor_ally_seal_haiti_assault_base" },
    { 0x2280A404, "actor_ally_seal_haiti_bigdog" },
    { 0x939F2E0A, "actor_ally_seal_haiti_boobytrap" },
    { 0x58FA9906, "actor_ally_seal_haiti_drone" },
    { 0x075DA5E6, "actor_ally_seal_haiti_drone_rigid" },
    { 0xB14A2910, "actor_ally_seal_haiti_launcher_base" },
    { 0x3C489CC4, "actor_ally_seal_haiti_lmg_base" },
    { 0x2197EC25, "actor_ally_seal_haiti_smg_base" },
    { 0x3302EDCE, "actor_ally_seal_haiti_wingsuit" },
    { 0xB577AC17, "actor_ally_seal_monsoon_assault_base" },
    { 0x560395ED, "actor_ally_seal_pakistan_assault_base" },
    { 0xE67EE20E, "actor_ally_seal_pakistan_bigdog" },
    { 0x60301D32, "actor_ally_seal_panama_assault_base" },
    { 0x43811609, "actor_ally_seal_panama_assault_covered" },
    { 0x3FE192CB, "actor_ally_seal_panama_launcher_base" },
    { 0xD37F5B90, "actor_ally_seal_panama_smg_base" },
    { 0x00CA62EC, "actor_ally_seal_yemen_assault_base" },
    { 0xD7BE823A, "actor_ally_seal_yemen_smg_base" },
    { 0x82515E52, "actor_ally_seal_yemen_sniper_base" },
    { 0xF674BF4D, "actor_ally_security_karma_assault_base" },
    { 0xDDB08A38, "actor_ally_security_karma_checkin_2" },
    { 0x03B304A1, "actor_ally_security_karma_checkin_3" },
    { 0xA750F231, "actor_ally_security_karma_pistol_base" },
    { 0xC62CFF5E, "actor_ally_security_karma_scanner_guard" },
    { 0xD91FA084, "actor_ally_security_karma_shotgun_base" },
    { 0x0654FD6B, "actor_ally_security_karma_smg_base" },
    { 0x5AF36E7F, "actor_ally_sssuit_pistol_base" },
    { 0x28977977, "actor_ally_sstactical_assault_base" },
    { 0x6C503F72, "actor_ally_sstactical_driver" },
    { 0x69C91E68, "actor_ally_sstactical_driver_smg_base" },
    { 0x5B8C5E97, "actor_ally_sstactical_heavy_assault_base" },
    { 0x6100C6C6, "actor_ally_sstactical_light_smg_base" },
    { 0xE7EC972D, "actor_ally_sstactical_smg_base" },
    { 0x10BFCB1B, "actor_ally_swat_assault_base" },
    { 0x2BC4FB9A, "actor_ally_swat_assault_intro" },
    { 0xF509B326, "actor_ally_swat_assault_intro_la2" },
    { 0x92AD03E3, "actor_ally_terrorist_yemen_assault_base" },
    { 0xD3F96721, "actor_ally_terrorist_yemen_smg_base" },
    { 0x6D2B4E90, "actor_ally_unita_angola_assault_base" },
    { 0xEF4743F1, "actor_ally_unita_angola_burned_base" },
    { 0x4F79E9B1, "actor_ally_unita_angola_drone_base" },
    { 0x163326EC, "actor_ally_us_navy_gunner_unarmed" },
    { 0x41B3BED7, "actor_ally_us_navy_officer_unarmed" },
    { 0x9A04A59F, "actor_ally_us_navy_reg_unarmed" },
    { 0x722A2AD9, "actor_ally_us_navy_wet_sailor" },
    { 0x8A165FAB, "actor_ally_us_navy_wounded_unarmed" },
    { 0xB3344C57, "actor_ally_us_pby_copilot" },
    { 0x2914371E, "actor_ally_us_pby_engineer" },
    { 0x45C5EBAC, "actor_ally_us_pby_gunner" },
    { 0x70C1D351, "actor_ally_us_pby_pilot" },
    { 0xEC8C4597, "actor_ally_us_pby_radioop" },
    { 0xB2D12F13, "actor_ally_us_raid_gunny" },
    { 0x4D62F643, "actor_ally_us_raid_hero1" },
    { 0xDB5B8708, "actor_ally_us_raid_hero2" },
    { 0xE583E184, "actor_ally_us_raid_makin_mitch" },
    { 0xBE79510E, "actor_ally_us_raid_makin_mitch2" },
    { 0x348F2F5D, "actor_ally_us_raid_makin_pow" },
    { 0x45750F82, "actor_ally_us_raid_player1" },
    { 0x11225326, "actor_ally_us_raid_reg_bar" },
    { 0xC4545C71, "actor_ally_us_raid_reg_camo_bar" },
    { 0x1F7F2E46, "actor_ally_us_raid_reg_camo_portable30cal" },
    { 0x82C835C3, "actor_ally_us_raid_reg_camo_sniper" },
    { 0x653A892D, "actor_ally_us_raid_reg_m1carbine" },
    { 0x5E9AEA48, "actor_ally_us_raid_reg_m1garand" },
    { 0x30F8D5A9, "actor_ally_us_raid_reg_portable30cal" },
    { 0x37BF5CD4, "actor_ally_us_raid_reg_radio" },
    { 0x335DB1CA, "actor_ally_us_raid_reg_sniper" },
    { 0xAFB756E8, "actor_ally_us_raid_reg_springfield" },
    { 0xFECA6B6F, "actor_ally_us_raid_reg_thompson" },
    { 0xB0BF495C, "actor_ally_us_raid_wounded_camo_unarmed" },
    { 0x582CEB7F, "actor_ally_us_usmc_gunny" },
    { 0x0CA33FEF, "actor_ally_us_usmc_hero1" },
    { 0x1C936F31, "actor_ally_us_usmc_nopack_reg_m1garand" },
    { 0xE37BA3F3, "actor_ally_us_usmc_nopack_wet_m1garand" },
    { 0xB26E2584, "actor_ally_us_usmc_officer" },
    { 0x3A7BE6D3, "actor_ally_us_usmc_polonsky" },
    { 0x9AB7C42A, "actor_ally_us_usmc_reg_bar" },
    { 0x82C62BB4, "actor_ally_us_usmc_reg_bazooka" },
    { 0xF9CDA64E, "actor_ally_us_usmc_reg_corpsman" },
    { 0x0BC21761, "actor_ally_us_usmc_reg_flamethrower" },
    { 0xCDC22736, "actor_ally_us_usmc_reg_gibhead_post" },
    { 0xBC469853, "actor_ally_us_usmc_reg_gibhead_pre" },
    { 0x54755919, "actor_ally_us_usmc_reg_m1carbine" },
    { 0x687DC934, "actor_ally_us_usmc_reg_m1garand" },
    { 0x4B840335, "actor_ally_us_usmc_reg_m1garandgl" },
    { 0x86D2BFC9, "actor_ally_us_usmc_reg_oki3_special" },
    { 0x45109075, "actor_ally_us_usmc_reg_portable30cal" },
    { 0x0ED25B68, "actor_ally_us_usmc_reg_radio" },
    { 0xED8F2C73, "actor_ally_us_usmc_reg_soft_helmet_m1garand" },
    { 0xEB7E6DF3, "actor_ally_us_usmc_reg_thompson" },
    { 0xEBD54623, "actor_ally_us_usmc_reg_wet_bar" },
    { 0x9AA4151D, "actor_ally_us_usmc_reg_wet_bazooka" },
    { 0x56CF035E, "actor_ally_us_usmc_reg_wet_flamethrower" },
    { 0x8D07E1FD, "actor_ally_us_usmc_reg_wet_gibhead_post" },
    { 0xE39D892A, "actor_ally_us_usmc_reg_wet_gibhead_pre" },
    { 0xD6213BEC, "actor_ally_us_usmc_reg_wet_m1carbine" },
    { 0x8A8A6E6F, "actor_ally_us_usmc_reg_wet_m1garand" },
    { 0x1B60520A, "actor_ally_us_usmc_reg_wet_m1garandgl" },
    { 0x7711E59C, "actor_ally_us_usmc_reg_wet_portable30cal" },
    { 0x8AF62E6D, "actor_ally_us_usmc_reg_wet_sniper" },
    { 0xAFD30EC4, "actor_ally_us_usmc_reg_wet_thompson" },
    { 0xC2FFE631, "actor_ally_us_usmc_roebuck" },
    { 0x7102F14B, "actor_ally_us_usmc_roebuck_bar" },
    { 0x6741DCD3, "actor_ally_us_usmc_wet_comoff" },
    { 0x706E5FEC, "actor_ally_us_usmc_wet_corpsman" },
    { 0xB054C92E, "actor_ally_us_usmc_wet_gunny" },
    { 0x6A60B772, "actor_ally_us_usmc_wet_hero1" },
    { 0xB88999E1, "actor_ally_us_usmc_wet_officer" },
    { 0xD7CCD964, "actor_ally_us_usmc_wet_polonsky" },
    { 0xEA8C0E66, "actor_ally_us_usmc_wet_radio" },
    { 0x8F7EBF44, "actor_ally_us_usmc_wet_roebuck" },
    { 0x7D0AAFB3, "actor_ally_us_usmc_wet_woundedsimple" },
    { 0xD9AF6B9F, "actor_ally_us_usmc_wounded_unarmed" },
    { 0x05B91FC6, "actor_ally_us_usmc_wounded_wet_unarmed" },
    { 0x2B9926DD, "actor_ally_vip" },
    { 0x6EBFF250, "actor_ally_vip_president" },
    { 0xF98502ED, "actor_ally_yemeni_assault_base" },
    { 0x2D81CBEE, "actor_ally_yemeni_lmg_base" },
    { 0xB228080B, "actor_ally_yemeni_smg_base" },
    { 0x60148606, "actor_array" },
    { 0xD57E73D6, "actor_axis_ger_ber_sselite_officer_pistol" },
    { 0x7A0726B1, "actor_axis_ger_ber_sselite_reg_flamethrower" },
    { 0x0DAFF0A6, "actor_axis_ger_ber_sselite_reg_gewehr43" },
    { 0xC2DFF30F, "actor_axis_ger_ber_sselite_reg_kar98k" },
    { 0xBE118157, "actor_axis_ger_ber_sselite_reg_kar98kscoped" },
    { 0x89242110, "actor_axis_ger_ber_sselite_reg_mg42portable" },
    { 0xBDC569B8, "actor_axis_ger_ber_sselite_reg_mp40" },
    { 0x9B6058D3, "actor_axis_ger_ber_sselite_reg_panzerschrek" },
    { 0x1C0112E9, "actor_axis_ger_ber_sselite_reg_stg44" },
    { 0xE82B016F, "actor_axis_ger_ber_sselite_wounded_unarmed" },
    { 0x81804E97, "actor_axis_ger_ber_sshonor_officer_mp40" },
    { 0x04F7AD59, "actor_axis_ger_ber_sshonor_officer_pistol" },
    { 0xD3C8ED0E, "actor_axis_ger_ber_sshonor_reg_flamethrower" },
    { 0x5FE33B09, "actor_axis_ger_ber_sshonor_reg_gewehr43" },
    { 0xB3770BB7, "actor_axis_ger_ber_sshonor_reg_mp40" },
    { 0xE063E344, "actor_axis_ger_ber_sshonor_reg_panzerschrek" },
    { 0x730B08EC, "actor_axis_ger_ber_sshonor_reg_stg44" },
    { 0x50722514, "actor_axis_ger_ber_volk_reg_kar98k" },
    { 0x87EE279B, "actor_axis_ger_ber_volk_reg_mp40" },
    { 0x9B4E2216, "actor_axis_ger_ber_volk_wounded_unarmed" },
    { 0x9740545B, "actor_axis_ger_ber_wehr_farfacial_kar98k" },
    { 0x8A2434D4, "actor_axis_ger_ber_wehr_farfacial_mp40" },
    { 0x7519E56F, "actor_axis_ger_ber_wehr_officer_ansel" },
    { 0x665E7005, "actor_axis_ger_ber_wehr_officer_pistol" },
    { 0x08092832, "actor_axis_ger_ber_wehr_officer_rifle" },
    { 0x832F7702, "actor_axis_ger_ber_wehr_reg_flamethrower" },
    { 0x603DF8E5, "actor_axis_ger_ber_wehr_reg_gewehr43" },
    { 0x35320964, "actor_axis_ger_ber_wehr_reg_kar98k" },
    { 0xDC5F6430, "actor_axis_ger_ber_wehr_reg_kar98k_type1" },
    { 0x4E66D36B, "actor_axis_ger_ber_wehr_reg_kar98k_type2" },
    { 0x28645902, "actor_axis_ger_ber_wehr_reg_kar98k_type3" },
    { 0x2E99066C, "actor_axis_ger_ber_wehr_reg_kar98kscoped" },
    { 0x14BFDD5F, "actor_axis_ger_ber_wehr_reg_mg42portable" },
    { 0x723FD8EB, "actor_axis_ger_ber_wehr_reg_mp40" },
    { 0x8F93A6FB, "actor_axis_ger_ber_wehr_reg_mp40_type1" },
    { 0x1D8C37C0, "actor_axis_ger_ber_wehr_reg_mp40_type2" },
    { 0x438EB229, "actor_axis_ger_ber_wehr_reg_mp40_type3" },
    { 0x9F040A30, "actor_axis_ger_ber_wehr_reg_panzerschrek" },
    { 0x7C069EE2, "actor_axis_ger_ber_wehr_reg_static_type1" },
    { 0x56042479, "actor_axis_ger_ber_wehr_reg_static_type2" },
    { 0x3001AA10, "actor_axis_ger_ber_wehr_reg_static_type3" },
    { 0x4B505888, "actor_axis_ger_ber_wehr_reg_stg44" },
    { 0x9DC3C3D7, "actor_axis_ger_ber_wehr_reg_wet_kar98k" },
    { 0x6BBD8AD0, "actor_axis_ger_ber_wehr_reg_wet_mp40" },
    { 0xCB77F2DB, "actor_axis_ger_ber_wehr_reg_wet_panzerschrek" },
    { 0xD5296DC6, "actor_axis_ger_ber_wehr_wet_officer_pistol" },
    { 0x5531F89F, "actor_axis_ger_ber_wehr_wet_officer_rifle" },
    { 0x71C46D46, "actor_axis_ger_ber_wehr_wounded_unarmed" },
    { 0x4F6597F0, "actor_axis_ger_hol_fall_officer_pistol" },
    { 0x0F6BB226, "actor_axis_ger_hol_fall_reg_fg42" },
    { 0x838A51C2, "actor_axis_ger_hol_fall_reg_fg42scoped" },
    { 0xE7D5A8EB, "actor_axis_ger_hol_fall_reg_flamethrower" },
    { 0xA3FCC534, "actor_axis_ger_hol_fall_reg_gewehr43" },
    { 0x65EF8BD9, "actor_axis_ger_hol_fall_reg_kar98k" },
    { 0xE1E719A5, "actor_axis_ger_hol_fall_reg_kar98kscoped" },
    { 0xF52A3BE2, "actor_axis_ger_hol_fall_reg_mg42portable" },
    { 0xAB255FDE, "actor_axis_ger_hol_fall_reg_mp40" },
    { 0xADABF55D, "actor_axis_ger_hol_fall_reg_panzerschrek" },
    { 0x3F0CFBF5, "actor_axis_ger_hol_fall_wounded_unarmed" },
    { 0x0D1AAAD9, "actor_axis_ger_rhi_ss_officer_pistol" },
    { 0x1DB3E55A, "actor_axis_ger_rhi_ss_officer_wet_pistol" },
    { 0xD1F1E68E, "actor_axis_ger_rhi_ss_reg_flamethrower" },
    { 0xC9C79C89, "actor_axis_ger_rhi_ss_reg_gewehr43" },
    { 0xFE2AEB20, "actor_axis_ger_rhi_ss_reg_kar98k" },
    { 0x1E87D3E0, "actor_axis_ger_rhi_ss_reg_kar98kscoped" },
    { 0x49908723, "actor_axis_ger_rhi_ss_reg_mg42portable" },
    { 0xAEB05537, "actor_axis_ger_rhi_ss_reg_mp40" },
    { 0xDE8CDCC4, "actor_axis_ger_rhi_ss_reg_panzerschrek" },
    { 0x6E39BD6C, "actor_axis_ger_rhi_ss_reg_stg44" },
    { 0x0ACD5765, "actor_axis_ger_rhi_ss_reg_wet_flamethrower" },
    { 0x16D94902, "actor_axis_ger_rhi_ss_reg_wet_gewehr43" },
    { 0xA109CF23, "actor_axis_ger_rhi_ss_reg_wet_kar98k" },
    { 0x0675E573, "actor_axis_ger_rhi_ss_reg_wet_kar98kscoped" },
    { 0x06E641FC, "actor_axis_ger_rhi_ss_reg_wet_mg42portable" },
    { 0x1599444C, "actor_axis_ger_rhi_ss_reg_wet_mp40" },
    { 0x79B0EA3F, "actor_axis_ger_rhi_ss_reg_wet_panzerschrek" },
    { 0x3ECEA985, "actor_axis_ger_rhi_ss_reg_wet_stg44" },
    { 0xEF385E0A, "actor_axis_ger_rhi_ss_wounded_unarmed" },
    { 0x41D31427, "actor_axis_ger_rhi_ss_wounded_wet_unarmed" },
    { 0x84CCAF19, "actor_axis_ger_rhi_wehr_officer_pistol" },
    { 0xF4D5BC9A, "actor_axis_ger_rhi_wehr_officer_wet_pistol" },
    { 0x1DDF58CE, "actor_axis_ger_rhi_wehr_reg_flamethrower" },
    { 0xF8955EC9, "actor_axis_ger_rhi_wehr_reg_gewehr43" },
    { 0x6D9D3E60, "actor_axis_ger_rhi_wehr_reg_kar98k" },
    { 0xEE9DC320, "actor_axis_ger_rhi_wehr_reg_kar98kscoped" },
    { 0xE32B9763, "actor_axis_ger_rhi_wehr_reg_mg42portable" },
    { 0xBF4ECB77, "actor_axis_ger_rhi_wehr_reg_mp40" },
    { 0x520C3504, "actor_axis_ger_rhi_wehr_reg_panzerschrek" },
    { 0xEDCD6CAC, "actor_axis_ger_rhi_wehr_reg_stg44" },
    { 0x161D9BA5, "actor_axis_ger_rhi_wehr_reg_wet_flamethrower" },
    { 0x4B3BDE42, "actor_axis_ger_rhi_wehr_reg_wet_gewehr43" },
    { 0x1BD8D763, "actor_axis_ger_rhi_wehr_reg_wet_kar98k" },
    { 0xC145A9B3, "actor_axis_ger_rhi_wehr_reg_wet_kar98kscoped" },
    { 0xB7C7DC3C, "actor_axis_ger_rhi_wehr_reg_wet_mg42portable" },
    { 0xA5C6278C, "actor_axis_ger_rhi_wehr_reg_wet_mp40" },
    { 0xEF3F117F, "actor_axis_ger_rhi_wehr_reg_wet_panzerschrek" },
    { 0x5F58DEC5, "actor_axis_ger_rhi_wehr_reg_wet_stg44" },
    { 0x4488294A, "actor_axis_ger_rhi_wehr_wounded_unarmed" },
    { 0x3D1B1867, "actor_axis_ger_rhi_wehr_wounded_wet_unarmed" },
    { 0x80046FEE, "actor_axis_jap_elite_camo_type100smg" },
    { 0x77B31D5C, "actor_axis_jap_elite_camo_type99lmg" },
    { 0x21BDFEC2, "actor_axis_jap_elite_camo_type99rifle" },
    { 0x85BFEA86, "actor_axis_jap_elite_camo_type99riflebayonet" },
    { 0x18158B86, "actor_axis_jap_elite_camo_type99riflescoped" },
    { 0x027FE09F, "actor_axis_jap_elite_type100smg" },
    { 0x306E4C6B, "actor_axis_jap_elite_type99lmg" },
    { 0xC5A18F5D, "actor_axis_jap_elite_type99rifle" },
    { 0xCDBCCB37, "actor_axis_jap_elite_type99riflebayonet" },
    { 0x3DE57051, "actor_axis_jap_elite_type99riflescoped" },
    { 0xC6B8E15C, "actor_axis_jap_guard_camo_type100smg" },
    { 0x3F4F43E2, "actor_axis_jap_guard_camo_type99lmg" },
    { 0x2501B5A4, "actor_axis_jap_guard_camo_type99rifle" },
    { 0x48069018, "actor_axis_jap_guard_camo_type99riflebayonet" },
    { 0x50B605AC, "actor_axis_jap_guard_camo_type99riflescoped" },
    { 0x8FC51BED, "actor_axis_jap_guard_type100smg" },
    { 0xC3915AB1, "actor_axis_jap_guard_type99lmg" },
    { 0x2B8BBC57, "actor_axis_jap_guard_type99rifle" },
    { 0x085E3AC9, "actor_axis_jap_guard_type99riflebayonet" },
    { 0xB412B56F, "actor_axis_jap_guard_type99riflescoped" },
    { 0xB1355B22, "actor_axis_jap_makin_interrogator" },
    { 0x988BABCE, "actor_axis_jap_makin_officer" },
    { 0xCCBAE834, "actor_axis_jap_makin_type100smg" },
    { 0x0AB1F23C, "actor_axis_jap_makin_type99rifle" },
    { 0xB16F64F0, "actor_axis_jap_makin_type99riflebayonet" },
    { 0xD8E59C74, "actor_axis_jap_makin_type99riflescoped" },
    { 0x203BDFB0, "actor_axis_jap_makinintro_type99rifle" },
    { 0xECB5CF4C, "actor_axis_jap_officer_katana" },
    { 0x1B229C2B, "actor_axis_jap_officer_wet_katana" },
    { 0x507918FC, "actor_axis_jap_pilot_unarmed" },
    { 0x4093074D, "actor_axis_jap_reg_camo_type100smg" },
    { 0x3FFE3C91, "actor_axis_jap_reg_camo_type99lmg" },
    { 0xB50EA337, "actor_axis_jap_reg_camo_type99rifle" },
    { 0x99F4AD29, "actor_axis_jap_reg_camo_type99riflebayonet" },
    { 0x27F7684F, "actor_axis_jap_reg_camo_type99riflescoped" },
    { 0x628AFDCE, "actor_axis_jap_reg_camo_wet_type100smg" },
    { 0x1DB7073C, "actor_axis_jap_reg_camo_wet_type99lmg" },
    { 0x1C814FA2, "actor_axis_jap_reg_camo_wet_type99rifle" },
    { 0x75D6F429, "actor_axis_jap_reg_camo_wet_type99riflebayon" },
    { 0x1E1EB056, "actor_axis_jap_reg_camo_wet_type99riflescope" },
    { 0x08FEF70E, "actor_axis_jap_reg_type100smg" },
    { 0x27B6E9FC, "actor_axis_jap_reg_type99lmg" },
    { 0xF96DF662, "actor_axis_jap_reg_type99rifle" },
    { 0x3A804AA6, "actor_axis_jap_reg_type99riflebayonet" },
    { 0x500C1426, "actor_axis_jap_reg_type99riflescoped" },
    { 0xA8F2D9B9, "actor_axis_jap_reg_wet_type100smg" },
    { 0xDB151C9D, "actor_axis_jap_reg_wet_type99lmg" },
    { 0xD184C703, "actor_axis_jap_reg_wet_type99rifle" },
    { 0xDC8FB853, "actor_axis_jap_reg_wet_type99riflescoped" },
    { 0xFB3419A3, "actor_axis_zombie_ger_ber_sshonor" },
    { 0xED57FC12, "actor_axis_zombie_ger_engineer" },
    { 0xFFCEF964, "actor_axis_zombie_ger_quad" },
    { 0x583AFCE7, "actor_axis_zombie_jp_swamp" },
    { 0x1B340F73, "actor_bleeding" },
    { 0xAE9D06CD, "actor_bookmark_kill_times" },
    { 0x90EAF6DD, "actor_bookmark_kill_times_count" },
    { 0xA865B31D, "actor_bookmark_kill_times_delay" },
    { 0xC9411548, "actor_bookmark_kill_times_msec" },
    { 0x81DA132E, "actor_bowman_creek" },
    { 0xD127D389, "actor_bowman_cuba" },
    { 0x2C991033, "actor_bowman_cuba_bar" },
    { 0xFDDD0FFA, "actor_bowman_flashpoint" },
    { 0x425B5ED0, "actor_bowman_pow_nobackpack" },
    { 0x041A189D, "actor_bowman_quagmire" },
    { 0x0C33FE9B, "actor_british_e_winter_sten" },
    { 0xB3DFAE46, "actor_brooks_flashpoint" },
    { 0xC5EB4A65, "actor_carlos_cuba" },
    { 0x58D0F797, "actor_carlos_cuba_bar" },
    { 0xD94191D4, "actor_castro_cuba_faux" },
    { 0x34D7FB3E, "actor_castro_cuba_jacket" },
    { 0xDEDCED58, "actor_castro_woman" },
    { 0xDB35E0B3, "actor_char" },
    { 0x2FFE0415, "actor_charring" },
    { 0x46DEF9CE, "actor_charring_client_flag" },
    { 0x18FA6814, "actor_cia_a_hazmat_enfield" },
    { 0x6B74A093, "actor_cia_a_hazmat_lmg" },
    { 0x326CDE49, "actor_civilian_arab_a_male" },
    { 0x30D134DC, "actor_civilian_arab_b_male" },
    { 0x3534BFFF, "actor_civilian_arab_c_male" },
    { 0xA9AE68D2, "actor_civilian_arab_d_male" },
    { 0x00701992, "actor_civilian_arab_e_female" },
    { 0x42FEBB2B, "actor_civilian_arab_f_female" },
    { 0xE9198570, "actor_civilian_club_bouncer" },
    { 0xB180C10C, "actor_civilian_club_bouncer_1" },
    { 0x23883047, "actor_civilian_club_bouncer_2" },
    { 0xFD85B5DE, "actor_civilian_club_bouncer_3" },
    { 0x4BEED982, "actor_civilian_club_female_1" },
    { 0x25EC5F19, "actor_civilian_club_female_2" },
    { 0xFFE9E4B0, "actor_civilian_club_female_3" },
    { 0x3C5E17DF, "actor_civilian_club_female_light_1" },
    { 0xCA56A8A4, "actor_civilian_club_female_light_2" },
    { 0xF059230D, "actor_civilian_club_female_light_3" },
    { 0x7E51B3D2, "actor_civilian_club_female_light_4" },
    { 0x65F73C99, "actor_civilian_club_female_shot" },
    { 0x357D14B1, "actor_civilian_club_male_1" },
    { 0x5B7F8F1A, "actor_civilian_club_male_2" },
    { 0x81820983, "actor_civilian_club_male_3" },
    { 0xA78483EC, "actor_civilian_club_male_4" },
    { 0xCD86FE55, "actor_civilian_club_male_5" },
    { 0xF38978BE, "actor_civilian_club_male_6" },
    { 0x9896586E, "actor_civilian_club_male_head_1" },
    { 0xE58D8075, "actor_civilian_club_male_head_1_2" },
    { 0x7293DE05, "actor_civilian_club_male_head_2" },
    { 0x43F9154A, "actor_civilian_club_male_head_2_2" },
    { 0x4C91639C, "actor_civilian_club_male_head_3" },
    { 0xDC1713BB, "actor_civilian_club_male_head_3_2" },
    { 0x268EE933, "actor_civilian_club_male_head_4" },
    { 0xCABE2268, "actor_civilian_club_male_head_4_2" },
    { 0x008C6ECA, "actor_civilian_club_male_head_5" },
    { 0xD772FAD9, "actor_civilian_club_male_head_5_2" },
    { 0xDA89F461, "actor_civilian_club_male_head_6" },
    { 0xAE9D7B0E, "actor_civilian_club_male_head_6_2" },
    { 0x527A7258, "actor_civilian_club_male_light_1" },
    { 0xC481E193, "actor_civilian_club_male_light_2" },
    { 0x9E7F672A, "actor_civilian_club_male_light_3" },
    { 0x1086D665, "actor_civilian_club_male_light_4" },
    { 0xD74B5748, "actor_civilian_club_male_shot" },
    { 0xFB4E13B8, "actor_civilian_club_shadow_dancer" },
    { 0x9EB75650, "actor_civilian_cuba" },
    { 0xDACF6355, "actor_civilian_haiti_boy" },
    { 0x53FD1B93, "actor_civilian_haiti_girl" },
    { 0x371301FD, "actor_civilian_it_manager_karma" },
    { 0xAAD9FBA8, "actor_civilian_kowloon" },
    { 0x04C4E3F5, "actor_civilian_la_random_dead" },
    { 0xE47A1E12, "actor_civilian_la_random_female_light" },
    { 0x99BA558D, "actor_civilian_la_random_light" },
    { 0xB0A41AD5, "actor_civilian_la_random_male_light" },
    { 0x3EAD0C35, "actor_civilian_monsoon_scientist" },
    { 0x4C162617, "actor_civilian_nicaragua_cokeworker" },
    { 0xC404EA7E, "actor_civilian_nicaragua_cokeworker_female" },
    { 0xE216837A, "actor_civilian_nicaragua_josefina" },
    { 0xF25285A8, "actor_civilian_nicaragua_villager_female" },
    { 0xBC15304F, "actor_civilian_nicaragua_villager_male" },
    { 0x9133FDFA, "actor_civilian_pakistan" },
    { 0xDED8E614, "actor_civilian_panama_doctor1" },
    { 0x50E0554F, "actor_civilian_panama_doctor2" },
    { 0x2ACF457A, "actor_civilian_panama_female" },
    { 0x7833DBC5, "actor_civilian_panama_male" },
    { 0x791741ED, "actor_civilian_panama_nurse" },
    { 0x3B60DA99, "actor_civilian_pent_worker_female_security" },
    { 0x94D96F73, "actor_civilian_pentagon_cia" },
    { 0xCD6AAD8F, "actor_civilian_pentagon_cia_chopper" },
    { 0xBAF1091D, "actor_civilian_pentagon_cia_ele_guard1" },
    { 0xE0F38386, "actor_civilian_pentagon_cia_ele_guard2" },
    { 0xCB223EB0, "actor_civilian_pentagon_cia_first_desk" },
    { 0xE9576502, "actor_civilian_pentagon_cia_inn_guard1" },
    { 0xC354EA99, "actor_civilian_pentagon_cia_inn_guard2" },
    { 0x4D46436A, "actor_civilian_pentagon_cia_second_desk" },
    { 0x5FF8789A, "actor_civilian_pentagon_general_1" },
    { 0x39F5FE31, "actor_civilian_pentagon_general_2" },
    { 0x13F383C8, "actor_civilian_pentagon_general_3" },
    { 0x8219A9EB, "actor_civilian_pentagon_hudson" },
    { 0x48E7261D, "actor_civilian_pentagon_jfk" },
    { 0x06A75FE4, "actor_civilian_pentagon_mason" },
    { 0xF798F408, "actor_civilian_pentagon_mcnamara" },
    { 0xE228D093, "actor_civilian_pentagon_militarypolice_guard" },
    { 0xFA9D7FE7, "actor_civilian_pentagon_militarypolice_moto" },
    { 0x91ECE39C, "actor_civilian_pentagon_politician" },
    { 0x37262A0D, "actor_civilian_pentagon_politician_security" },
    { 0xF72DAA2C, "actor_civilian_pentagon_secretary" },
    { 0xE8BFD55D, "actor_civilian_pentagon_warroom" },
    { 0x2E800132, "actor_civilian_pentagon_warroom_security" },
    { 0x96B80203, "actor_civilian_pentagon_worker_female" },
    { 0x69C41D18, "actor_civilian_pentagon_worker_male" },
    { 0xF6C91527, "actor_civilian_pilot" },
    { 0xDE0F00AF, "actor_civilian_pilot_1" },
    { 0x6C079174, "actor_civilian_pilot_2" },
    { 0x6F6A2FF9, "actor_civilian_rich" },
    { 0x0ACE3EA4, "actor_civilian_rich_female" },
    { 0x0631CC98, "actor_civilian_rich_female_1" },
    { 0x78393BD3, "actor_civilian_rich_female_2" },
    { 0x5236C16A, "actor_civilian_rich_female_3" },
    { 0xC43E30A5, "actor_civilian_rich_female_4" },
    { 0x9E3BB63C, "actor_civilian_rich_female_5" },
    { 0x3A8BBA8B, "actor_civilian_rich_female_shot" },
    { 0x989843C0, "actor_civilian_rich_female_soot" },
    { 0x85B6777B, "actor_civilian_rich_male" },
    { 0x1F1B9F1B, "actor_civilian_rich_male_1" },
    { 0xAD142FE0, "actor_civilian_rich_male_2" },
    { 0xD316AA49, "actor_civilian_rich_male_3" },
    { 0x91230E56, "actor_civilian_rich_male_4" },
    { 0xB72588BF, "actor_civilian_rich_male_5" },
    { 0x451E1984, "actor_civilian_rich_male_6" },
    { 0xA3FE840E, "actor_civilian_rich_male_shot" },
    { 0x7AC28F5D, "actor_civilian_rich_male_soot" },
    { 0x0BB242AE, "actor_civilian_russian_engineer_hatchet" },
    { 0xED0B925F, "actor_civilian_russian_engineer_orange" },
    { 0xBE0ED095, "actor_civilian_russian_engineer_orange_gas" },
    { 0x2E0A2C38, "actor_civilian_russian_engineer_rebirth_blue" },
    { 0xF55ACE68, "actor_civilian_russian_farmer" },
    { 0x54CEDE7C, "actor_civilian_russian_flashpoint_dom" },
    { 0xDEE1CB52, "actor_civilian_russian_flashpoint_scientist" },
    { 0x9A0162CE, "actor_civilian_russian_rebirth_scientist" },
    { 0x9080F305, "actor_civilian_russian_scientist" },
    { 0x1F7A632F, "actor_civilian_viet_macv" },
    { 0x7424C83A, "actor_civilian_viet_macv_khesanh" },
    { 0x4A3AB8DE, "actor_civilian_viet_urban" },
    { 0x26B4AF26, "actor_civilian_viet_village" },
    { 0x9AC75483, "actor_civilian_worker_construction" },
    { 0xC4491AA4, "actor_civilian_worker_controller" },
    { 0xD7BFA5A4, "actor_civilian_worker_office" },
    { 0xEE4B0B98, "actor_civilian_worker_office_1" },
    { 0x60527AD3, "actor_civilian_worker_office_2" },
    { 0x3A50006A, "actor_civilian_worker_office_3" },
    { 0x833E1CE5, "actor_civilian_worker_receptionist" },
    { 0x52E28A81, "actor_civilian_worker_receptionist_1" },
    { 0x78E504EA, "actor_civilian_worker_receptionist_2" },
    { 0xB1FB325A, "actor_civilian_worker_tarmac" },
    { 0x24FFD316, "actor_clark_kowloon" },
    { 0xC67510F3, "actor_corpse" },
    { 0x91EB05E0, "actor_count" },
    { 0xE2CC9AEF, "actor_cu_a_fnfal" },
    { 0x5CB5033C, "actor_cu_a_fnfal_rpg_straight" },
    { 0xA0A5AAAB, "actor_cu_a_rpk" },
    { 0x147D7089, "actor_cu_a_skorpion" },
    { 0x00836DF7, "actor_cu_dancer" },
    { 0xD5C3843E, "actor_cu_e_barleader" },
    { 0xA1BF673B, "actor_cu_e_fnfal" },
    { 0x79BB4A20, "actor_cu_e_fnfal_rpg_straight" },
    { 0x222B9048, "actor_cu_e_police_fnfal" },
    { 0xA8090A96, "actor_cu_e_police_pistol" },
    { 0x9D0563D8, "actor_cu_e_police_rpk" },
    { 0xBBB328AB, "actor_cu_e_police_shotgun" },
    { 0x9320A0F7, "actor_cu_e_rpk" },
    { 0x9EE7F954, "actor_cu_e_shotgun" },
    { 0xFD9DA315, "actor_cu_e_skorpion" },
    { 0x79578629, "actor_damage_callbacks" },
    { 0x8BFB9E51, "actor_damage_func" },
    { 0x33CECF53, "actor_damage_override" },
    { 0x15417BC7, "actor_damage_override_wrapper" },
    { 0xC814E230, "actor_damaged" },
    { 0x05CB5DE6, "actor_death_override" },
    { 0x678BCE44, "actor_deathwatch" },
    { 0x6CADC180, "actor_died_fail" },
    { 0xA9A99CEA, "actor_dragovich_cuba" },
    { 0x7DFF0C34, "actor_dragovich_full_ahead" },
    { 0xC923812E, "actor_dragovich_underwater_base" },
    { 0x15E716C2, "actor_end_bubbles" },
    { 0x634BC1EB, "actor_end_idle" },
    { 0xD98578B2, "actor_enemy_ac130_ar_ak47" },
    { 0xCA073B33, "actor_enemy_ac130_ar_g3" },
    { 0x2BBAF487, "actor_enemy_ac130_at_rpg7" },
    { 0x6B9B6CB6, "actor_enemy_arab_ar_ak47" },
    { 0x95B76A61, "actor_enemy_arab_ar_ak47grenadier" },
    { 0x997301F9, "actor_enemy_arab_ar_ak74u" },
    { 0x803872FF, "actor_enemy_arab_ar_g3" },
    { 0x1BA06BF3, "actor_enemy_arab_at_rpg7" },
    { 0x89BB4487, "actor_enemy_arab_lmg_m60" },
    { 0x69AD5A0A, "actor_enemy_arab_lmg_rpd" },
    { 0x00048ECB, "actor_enemy_arab_lmg_saw" },
    { 0xBEF286D8, "actor_enemy_arab_shtgn_winchester" },
    { 0x0D6DE2E5, "actor_enemy_arab_snpr_dragunov" },
    { 0xFF621E0C, "actor_enemy_bigdog" },
    { 0x156ADB5F, "actor_enemy_cartel_assault_base" },
    { 0xB390B9E0, "actor_enemy_cartel_launcher_base" },
    { 0xAAC21074, "actor_enemy_cartel_lmg_base" },
    { 0x0172F416, "actor_enemy_cartel_shotgun_base" },
    { 0x80B494F5, "actor_enemy_cartel_smg_base" },
    { 0xBA2CB53B, "actor_enemy_cartel_sniper_base" },
    { 0xF392B757, "actor_enemy_chinese_pakistan_assault_base" },
    { 0x0660CCA2, "actor_enemy_coup_driver" },
    { 0x89EEC120, "actor_enemy_coup_escort_left" },
    { 0x7390B10F, "actor_enemy_coup_escort_right" },
    { 0x7FC83310, "actor_enemy_coup_passenger" },
    { 0x8CF3C414, "actor_enemy_cuban_angola_assault_base" },
    { 0x19C641ED, "actor_enemy_cuban_angola_launcher_base" },
    { 0x7B7F58F7, "actor_enemy_cuban_angola_lmg_base" },
    { 0xCED29A62, "actor_enemy_cuban_angola_smg_base" },
    { 0x68326CBA, "actor_enemy_cuban_angola_sniper_base" },
    { 0xFE8709BE, "actor_enemy_cubanboat_angola_assault_base" },
    { 0xBC5F47AA, "actor_enemy_cubanboat_angola_assault_fnfal" },
    { 0x71FD12C3, "actor_enemy_cubanboat_angola_launcher_barge" },
    { 0xDF371A67, "actor_enemy_cubanboat_angola_launcher_base" },
    { 0x408B0025, "actor_enemy_cubanboat_angola_lmg_base" },
    { 0x5B3BB0C4, "actor_enemy_cubanboat_angola_smg_base" },
    { 0xDB4FFAE3, "actor_enemy_digbat_assault_base" },
    { 0x924139F4, "actor_enemy_digbat_assault_tackler" },
    { 0xE34AEE21, "actor_enemy_digbat_smg_base" },
    { 0x0FD90B36, "actor_enemy_dog" },
    { 0xFC7077AE, "actor_enemy_dog_mp" },
    { 0x12C1407C, "actor_enemy_dog_sp" },
    { 0x07AB71F7, "actor_enemy_isi_pakistan_assault_base" },
    { 0xEA4AFD33, "actor_enemy_isi_pakistan_assault_nobackpack" },
    { 0xF54C0229, "actor_enemy_isi_pakistan_juggernaut_lmg" },
    { 0xAC594BA8, "actor_enemy_isi_pakistan_launcher_base" },
    { 0xEBF8DFEB, "actor_enemy_isi_pakistan_leader" },
    { 0xBAE2B028, "actor_enemy_isi_pakistan_leader_millibar" },
    { 0x168C579C, "actor_enemy_isi_pakistan_lmg_base" },
    { 0xD848E25A, "actor_enemy_isi_pakistan_millibar" },
    { 0xBE157D0E, "actor_enemy_isi_pakistan_shotgun_base" },
    { 0x897A07AD, "actor_enemy_isi_pakistan_smg_base" },
    { 0x931813F3, "actor_enemy_isi_pakistan_sniper_base" },
    { 0x469DEE35, "actor_enemy_let_pakistan_assault_base" },
    { 0x1F02DCED, "actor_enemy_let_pakistan_assault_militia" },
    { 0xBFC56506, "actor_enemy_let_pakistan_launcher_base" },
    { 0xC3D0B7F1, "actor_enemy_let_pakistan_leader" },
    { 0x59EFB526, "actor_enemy_let_pakistan_lmg_base" },
    { 0x9F9C34EC, "actor_enemy_let_pakistan_shotgun_base" },
    { 0x1F54A28C, "actor_enemy_manticore_blackout_assault_base" },
    { 0x8F4095B3, "actor_enemy_manticore_blackout_drone" },
    { 0xD14AEAF5, "actor_enemy_manticore_blackout_launcher_base" },
    { 0x81FF421F, "actor_enemy_manticore_blackout_lmg_base" },
    { 0x8207FDA9, "actor_enemy_manticore_blackout_shotgun_base" },
    { 0xA628F1DA, "actor_enemy_manticore_blackout_smg_base" },
    { 0x8250C227, "actor_enemy_manticore_karma_assault_base" },
    { 0x909823F8, "actor_enemy_manticore_karma_launcher_base" },
    { 0xAE284D8C, "actor_enemy_manticore_karma_lmg_base" },
    { 0xFC831CBF, "actor_enemy_manticore_karma_pistol_base" },
    { 0x82D3CDDE, "actor_enemy_manticore_karma_shotgun_base" },
    { 0xF25A263D, "actor_enemy_manticore_karma_smg_base" },
    { 0x5AFDB023, "actor_enemy_manticore_karma_sniper_base" },
    { 0xB86DB0D7, "actor_enemy_manticore_karma_spiderbot_smash" },
    { 0x035FAF68, "actor_enemy_manticore_la2_assault_base" },
    { 0x4E37A032, "actor_enemy_manticore_la_assault_base" },
    { 0xE604C109, "actor_enemy_manticore_la_bigdog" },
    { 0xBE94D0FD, "actor_enemy_manticore_la_drone" },
    { 0x6CA5E505, "actor_enemy_manticore_la_drone_la2" },
    { 0xF5B4CBCB, "actor_enemy_manticore_la_launcher_base" },
    { 0xAF21D949, "actor_enemy_manticore_la_launcher_mb" },
    { 0x3F4B9F89, "actor_enemy_manticore_la_lmg_base" },
    { 0x3ABAA88A, "actor_enemy_manticore_la_pistol_dualwield" },
    { 0x912E72BF, "actor_enemy_manticore_la_shotgun_base" },
    { 0x09C4AE90, "actor_enemy_manticore_la_smg_base" },
    { 0xE6F2CD56, "actor_enemy_manticore_la_smg_dualwield" },
    { 0xE30CF9D8, "actor_enemy_manticore_la_sniper_base" },
    { 0x35842555, "actor_enemy_merc_ar_ak47" },
    { 0xF9A3367C, "actor_enemy_merc_ar_ak74u" },
    { 0xE0AE9FA0, "actor_enemy_merc_ar_g3" },
    { 0x82FE55E9, "actor_enemy_merc_ar_g36c" },
    { 0x80D9123C, "actor_enemy_merc_at_rpg7" },
    { 0x9CE68CF1, "actor_enemy_merc_at_rpg7_jeepride" },
    { 0xC31F1108, "actor_enemy_merc_lmg_m60" },
    { 0xE0087B51, "actor_enemy_merc_lmg_rpd" },
    { 0x770D0821, "actor_enemy_merc_pstl_beretta" },
    { 0x11AAAE22, "actor_enemy_merc_shtgn_m1014" },
    { 0x9B6C3E5D, "actor_enemy_merc_shtgn_winchester" },
    { 0x276BF0F5, "actor_enemy_merc_smg_deserteagle" },
    { 0xAC25FED1, "actor_enemy_merc_smg_miniuzi" },
    { 0x596F82CC, "actor_enemy_merc_smg_mp5" },
    { 0xD882353F, "actor_enemy_merc_smg_p90" },
    { 0xA24A1D23, "actor_enemy_merc_smg_p90_silencer" },
    { 0x0C3A512F, "actor_enemy_merc_smg_skorpion" },
    { 0x81689736, "actor_enemy_merc_snpr_dragunov" },
    { 0x838287DA, "actor_enemy_mpla_assault_base" },
    { 0xA39E404C, "actor_enemy_mpla_assault_base_angola1" },
    { 0x67C3E6D3, "actor_enemy_mpla_child_base" },
    { 0xC88F5487, "actor_enemy_mpla_drone_base" },
    { 0xD0F6BFE2, "actor_enemy_mpla_drone_base_high" },
    { 0x69E4AA34, "actor_enemy_mpla_drone_base_low" },
    { 0xE5D3FD03, "actor_enemy_mpla_launcher_base" },
    { 0x9FFC390D, "actor_enemy_mpla_launcher_base_angola1" },
    { 0xE4090C0B, "actor_enemy_mpla_lmg_base_angola1" },
    { 0x0C879D18, "actor_enemy_mpla_smg_base" },
    { 0xA142891A, "actor_enemy_mpla_smg_base_angola1" },
    { 0xDF3A9B07, "actor_enemy_mplachild_angola_assault_base" },
    { 0x6EA70FD8, "actor_enemy_mplachild_angola_launcher_base" },
    { 0x3750D46C, "actor_enemy_mplachild_angola_lmg_base" },
    { 0x970A509D, "actor_enemy_mplachild_angola_smg_base" },
    { 0x9AC18424, "actor_enemy_opforce_ar_ak47" },
    { 0x601C8813, "actor_enemy_opforce_ar_ak47grenadier" },
    { 0x5BB4023B, "actor_enemy_opforce_ar_ak74u" },
    { 0xF3B60BCD, "actor_enemy_opforce_ar_g3" },
    { 0x80CE0228, "actor_enemy_opforce_ar_g36c" },
    { 0x621DA079, "actor_enemy_opforce_at_rpg7" },
    { 0x0FFFD2FC, "actor_enemy_opforce_lmg_rpd" },
    { 0x76A9A9B3, "actor_enemy_opforce_shtgn_m1014" },
    { 0xA6F49BB6, "actor_enemy_opforce_shtgn_winchester" },
    { 0x48656700, "actor_enemy_opforce_smg_miniuzi" },
    { 0x24C169E1, "actor_enemy_opforce_smg_mp5" },
    { 0xDFD25F3E, "actor_enemy_opforce_smg_p90" },
    { 0xFB0A158C, "actor_enemy_opforce_smg_p90_silencer" },
    { 0x8A72ABFC, "actor_enemy_opforce_smg_skorpion" },
    { 0xE2C4CBBF, "actor_enemy_opforce_snpr_dragunov" },
    { 0xAE8DD13A, "actor_enemy_pdf_assault_base" },
    { 0x91BD60F9, "actor_enemy_pdf_assaultgl_base" },
    { 0x8638DF63, "actor_enemy_pdf_launcher_base" },
    { 0x09B485E1, "actor_enemy_pdf_lmg_base" },
    { 0x22B5217E, "actor_enemy_pdf_nicaragua_assault_base" },
    { 0x6031FD49, "actor_enemy_pdf_nicaragua_assault_intro2" },
    { 0x3A2F82E0, "actor_enemy_pdf_nicaragua_assault_intro3" },
    { 0x4440DBBF, "actor_enemy_pdf_nicaragua_assault_intro4" },
    { 0x79BF0616, "actor_enemy_pdf_nicaragua_assault_leader" },
    { 0x687E3A27, "actor_enemy_pdf_nicaragua_launcher_base" },
    { 0xB16FA5E5, "actor_enemy_pdf_nicaragua_lmg_base" },
    { 0x05EF8C2B, "actor_enemy_pdf_nicaragua_shotgun_base" },
    { 0xFAD9D084, "actor_enemy_pdf_nicaragua_smg_base" },
    { 0x5F7762D4, "actor_enemy_pdf_nicaragua_sniper_base" },
    { 0xD5142427, "actor_enemy_pdf_shotgun_base" },
    { 0xD93AD778, "actor_enemy_pdf_smg_base" },
    { 0xF25BB8E0, "actor_enemy_pdf_sniper_base" },
    { 0x207840A2, "actor_enemy_pmc_haiti_assault_base" },
    { 0xEBBB6DF9, "actor_enemy_pmc_haiti_bigdog" },
    { 0x0B7FBE74, "actor_enemy_pmc_haiti_camo_lmg_base" },
    { 0x03DD8216, "actor_enemy_pmc_haiti_camo_shotgun_base" },
    { 0xE17242F5, "actor_enemy_pmc_haiti_camo_smg_base" },
    { 0x6C2C376D, "actor_enemy_pmc_haiti_drone" },
    { 0xDB3CF7B9, "actor_enemy_pmc_haiti_drone_rigid" },
    { 0xA4DB065B, "actor_enemy_pmc_haiti_launcher_base" },
    { 0xB06689B9, "actor_enemy_pmc_haiti_lmg_base" },
    { 0xB9C7F7CF, "actor_enemy_pmc_haiti_shotgun_base" },
    { 0xC693E6A0, "actor_enemy_pmc_haiti_smg_base" },
    { 0x1EE10348, "actor_enemy_pmc_haiti_sniper_base" },
    { 0xE37DE613, "actor_enemy_pmc_karma_assault_base" },
    { 0x8ADDCF44, "actor_enemy_pmc_karma_launcher_base" },
    { 0xCC544428, "actor_enemy_pmc_karma_lmg_base" },
    { 0x92A894DA, "actor_enemy_pmc_karma_shotgun_base" },
    { 0xA7C337F1, "actor_enemy_pmc_karma_smg_base" },
    { 0xDC58598F, "actor_enemy_pmc_karma_sniper_base" },
    { 0x7D6B32CE, "actor_enemy_pmc_monsoon_assault_base" },
    { 0x66633948, "actor_enemy_pmc_monsoon_assault_base_w" },
    { 0x3DD7B613, "actor_enemy_pmc_monsoon_assault_camo_base" },
    { 0x1325BF55, "actor_enemy_pmc_monsoon_assault_camo_base_w" },
    { 0xDF8EB9BB, "actor_enemy_pmc_monsoon_camo_base" },
    { 0x51203E15, "actor_enemy_pmc_monsoon_launcher_assault" },
    { 0x3DB67E57, "actor_enemy_pmc_monsoon_launcher_base" },
    { 0x820D3AF5, "actor_enemy_pmc_monsoon_lmg_base" },
    { 0xFB163607, "actor_enemy_pmc_monsoon_lmg_base_w" },
    { 0xF0F86FFE, "actor_enemy_pmc_monsoon_lmg_camo_base" },
    { 0x608211B8, "actor_enemy_pmc_monsoon_lmg_camo_base_w" },
    { 0x3322FA1B, "actor_enemy_pmc_monsoon_shotgun_base" },
    { 0x06E5330D, "actor_enemy_pmc_monsoon_shotgun_base_w" },
    { 0xB907F88C, "actor_enemy_pmc_monsoon_shotgun_camo_base" },
    { 0xAC1AB674, "actor_enemy_pmc_monsoon_smg_base" },
    { 0x298ADE5E, "actor_enemy_pmc_monsoon_smg_base_w" },
    { 0x9667A989, "actor_enemy_pmc_monsoon_smg_camo_base" },
    { 0xC83BF86B, "actor_enemy_pmc_monsoon_smg_camo_base_w" },
    { 0x0EC2F18E, "actor_enemy_pmc_monsoon_sniper_base_w" },
    { 0x080958B9, "actor_enemy_pmc_monsoon_sniper_camo_base" },
    { 0x7F4A74DB, "actor_enemy_pmc_monsoon_sniper_camo_base_w" },
    { 0xF4C502F0, "actor_enemy_soviet_afghan_assault_base" },
    { 0xAB356369, "actor_enemy_soviet_afghan_launcher_base" },
    { 0xCE4B28A3, "actor_enemy_soviet_afghan_lmg_base" },
    { 0x36FC0336, "actor_enemy_soviet_afghan_smg_base" },
    { 0xA7F95AB6, "actor_enemy_soviet_afghan_sniper_base" },
    { 0x9413DD77, "actor_enemy_spetsnaz_karma_assault_base" },
    { 0xAF23816F, "actor_enemy_spetsnaz_karma_assault_lod0" },
    { 0xBA606FCF, "actor_enemy_spetsnaz_karma_pistol_base" },
    { 0x4A7DE88E, "actor_enemy_spetsnaz_karma_shotgun_base" },
    { 0x0CAABB2D, "actor_enemy_spetsnaz_karma_smg_base" },
    { 0xE3461227, "actor_enemy_spetsnaz_karma_spiderbot_smash" },
    { 0x23E6159F, "actor_enemy_terrorist_yemen_assault_base" },
    { 0xEA7EC021, "actor_enemy_terrorist_yemen_assault_elite" },
    { 0xE5D8B950, "actor_enemy_terrorist_yemen_assault_hug" },
    { 0x29785720, "actor_enemy_terrorist_yemen_launcher_base" },
    { 0x10EB26E0, "actor_enemy_terrorist_yemen_launcher_rpg" },
    { 0x08505ED3, "actor_enemy_terrorist_yemen_launcher_stinger" },
    { 0x0E54AE35, "actor_enemy_terrorist_yemen_smg_base" },
    { 0xC5650963, "actor_enemy_terrorist_yemen_smg_elite" },
    { 0x2595C03B, "actor_enemy_villain_sonofzakhaev" },
    { 0x108AE7ED, "actor_enemy_villian_al_asad" },
    { 0x8162E3B4, "actor_enemy_villian_al_asad_dmg" },
    { 0xC57CDD66, "actor_enemy_villian_zakhaev" },
    { 0xD7C56BB2, "actor_enemy_villian_zakhaev_gimp" },
    { 0xA4709587, "actor_facial_anim_flag_handler" },
    { 0x46109388, "actor_fire_fx" },
    { 0x9679C702, "actor_fire_fx_state" },
    { 0xE10D57F5, "actor_flag_bleeding_handler" },
    { 0x158EF545, "actor_flag_change_handler" },
    { 0xE9075E5B, "actor_flag_charring_handler" },
    { 0x10D75654, "actor_flag_clark_bloody_face_handler" },
    { 0x53AD7C20, "actor_flag_juggernaut_footstep_handler" },
    { 0x8719FDF0, "actor_flag_meatshield_earblood_handler" },
    { 0x76DCE7EE, "actor_flag_nova6_death_handler" },
    { 0x05A9A389, "actor_flag_sergei_footstep_handler" },
    { 0x7C919649, "actor_flag_soulpull_handler" },
    { 0x99D25DC1, "actor_flag_wet_handler" },
    { 0xD3D8A890, "actor_force_walk" },
    { 0x33E307A5, "actor_full_damage_func" },
    { 0x330AE119, "actor_german_e_winter_mp40" },
    { 0x18A52440, "actor_german_e_winter_mp40_char" },
    { 0xC5366537, "actor_german_e_winter_panzershrek" },
    { 0xB81B68AA, "actor_german_e_winter_stg44" },
    { 0x617CD788, "actor_glasses_change" },
    { 0xD664EB1D, "actor_glasses_change_bink" },
    { 0xDECC5762, "actor_hero_anderson_la" },
    { 0x1D01EDCD, "actor_hero_bill_la" },
    { 0x63A6FF14, "actor_hero_briggs_blackout" },
    { 0x5CB84E26, "actor_hero_briggs_monsoon" },
    { 0xAC1015CA, "actor_hero_crosby_monsoon" },
    { 0xC3918F6E, "actor_hero_crosby_pakistan" },
    { 0x409931CE, "actor_hero_defalco_blackout" },
    { 0xDE8AC878, "actor_hero_defalco_haiti" },
    { 0x9EA901AF, "actor_hero_defalco_karma" },
    { 0xC4558050, "actor_hero_defalco_pakistan" },
    { 0x39BACE51, "actor_hero_defalco_yemen" },
    { 0x1B9ECBAA, "actor_hero_farid_blackout" },
    { 0xDEE2E2BB, "actor_hero_farid_karma" },
    { 0xAE84E8A5, "actor_hero_farid_yemen" },
    { 0x9132E366, "actor_hero_han_karma" },
    { 0x701889E8, "actor_hero_harper_blackout" },
    { 0x931BE176, "actor_hero_harper_haiti" },
    { 0x9105A493, "actor_hero_harper_haiti_scarred" },
    { 0x3C0D5695, "actor_hero_harper_karma" },
    { 0xFD9BD79A, "actor_hero_harper_karma_2" },
    { 0x42CA404A, "actor_hero_harper_la" },
    { 0xC8065D12, "actor_hero_harper_monsoon" },
    { 0xC4E43696, "actor_hero_harper_pakistan" },
    { 0x89268A4D, "actor_hero_harper_pakistan_noelite" },
    { 0xC79273FB, "actor_hero_harper_yemen" },
    { 0x96951C6F, "actor_hero_hillary_la" },
    { 0x1E423907, "actor_hero_hudson_afghan" },
    { 0x8ED03109, "actor_hero_hudson_afghan_beatup" },
    { 0xE9AB41BC, "actor_hero_hudson_angola" },
    { 0xB7337A07, "actor_hero_hudson_nicaragua" },
    { 0x2B25EA1E, "actor_hero_hudson_panama" },
    { 0x731A8A59, "actor_hero_isaac_monsoon" },
    { 0x5D104E4A, "actor_hero_jane_panama_silhouette" },
    { 0x69F001B7, "actor_hero_johnson_la" },
    { 0xD6CAB62B, "actor_hero_jones_la" },
    { 0x860405B6, "actor_hero_karma_blackout" },
    { 0xDE173A77, "actor_hero_karma_karma" },
    { 0x9BCEAC29, "actor_hero_karma_karma_scan" },
    { 0x01199E62, "actor_hero_kravcenko_afghan" },
    { 0xC4F736DB, "actor_hero_kravcenko_afghan_cut" },
    { 0x2E0AA60C, "actor_hero_mason_blackout" },
    { 0x99AF5B46, "actor_hero_mason_la" },
    { 0xC87BC15C, "actor_hero_mason_nicaragua" },
    { 0xDB594004, "actor_hero_mason_panama_captured" },
    { 0xFE3F1B19, "actor_hero_mason_panama_casual" },
    { 0x55EDD3FA, "actor_hero_mason_panama_combat" },
    { 0x6FA546B7, "actor_hero_mason_yemen" },
    { 0x82FCA401, "actor_hero_menendez_angola" },
    { 0xCDD63A88, "actor_hero_menendez_blackout" },
    { 0x96092896, "actor_hero_menendez_haiti" },
    { 0x43384DB8, "actor_hero_menendez_nicaragua" },
    { 0xD9ECB119, "actor_hero_menendez_nicaragua_flipped" },
    { 0x67AB74B4, "actor_hero_menendez_nicaragua_rage" },
    { 0x1FE1A336, "actor_hero_menendez_pakistan" },
    { 0x2FD2BE37, "actor_hero_menendez_panama" },
    { 0x9E40AA1B, "actor_hero_menendez_yemen" },
    { 0x792A2345, "actor_hero_noriega_nicaragua" },
    { 0x1726DC74, "actor_hero_noriega_panama" },
    { 0x0CE03755, "actor_hero_noriega_panama_cap" },
    { 0x5DCBA8C9, "actor_hero_noriega_panama_sack" },
    { 0x3593F280, "actor_hero_rebel_leader_afghan" },
    { 0x2BC1EC9B, "actor_hero_redshirt1_karma" },
    { 0x4BE8CF64, "actor_hero_redshirt2_karma" },
    { 0xF3A8EFE8, "actor_hero_reznov_afghan" },
    { 0xFAE3702A, "actor_hero_salazar_blackout" },
    { 0x3F05803B, "actor_hero_salazar_karma" },
    { 0x5D83EC20, "actor_hero_salazar_karma_2" },
    { 0xFE4355BB, "actor_hero_salazar_karma_pistol" },
    { 0x5448E5F8, "actor_hero_salazar_monsoon" },
    { 0xBFECD88C, "actor_hero_salazar_pakistan" },
    { 0x124E615F, "actor_hero_salazar_pakistan_noelite" },
    { 0x0EA78625, "actor_hero_salazar_yemen" },
    { 0x1D9EAB5A, "actor_hero_savimbi_angola" },
    { 0x7142961E, "actor_hero_secretary_la" },
    { 0x487B9221, "actor_hero_skinner_panama_casual" },
    { 0xA923CFA2, "actor_hero_woods_afghan" },
    { 0xA150DE5E, "actor_hero_woods_afghan_beatup" },
    { 0xD941D9E5, "actor_hero_woods_angola" },
    { 0xC1A48DCC, "actor_hero_woods_nicaragua" },
    { 0x5836077E, "actor_hero_zhao_afghan" },
    { 0xEC3A13F2, "actor_hero_zhao_afghan_beatup" },
    { 0x8363B5AE, "actor_hero_zhao_pakistan" },
    { 0x6520A23E, "actor_hudson_int_escape" },
    { 0x1ECE30A0, "actor_hudson_int_silhoutte" },
    { 0xC5353433, "actor_hudson_khesanh" },
    { 0x4085F3E1, "actor_hudson_underwaterbase" },
    { 0xF2D8A97A, "actor_hudson_underwaterbase_dive" },
    { 0x0576FE2D, "actor_hudson_underwaterbase_escape" },
    { 0xF01BD963, "actor_hudson_underwaterbase_post_dive" },
    { 0x4461E3BD, "actor_idle" },
    { 0x23A4DED3, "actor_killed_override" },
    { 0xB38E8B8D, "actor_kravchenko_cuba" },
    { 0x374F937E, "actor_kravchenko_flashpoint" },
    { 0xE315368B, "actor_kravchenko_full_ahead" },
    { 0x5958B9F0, "actor_kravchenko_pow" },
    { 0x06840179, "actor_lase_points_behavior" },
    { 0xD7925CD8, "actor_lase_points_player_track" },
    { 0x782962C5, "actor_lase_stop" },
    { 0xAFE236F9, "actor_mason_int_escape" },
    { 0x8C655EB2, "actor_mason_prisoner_int_escape" },
    { 0xEB70D048, "actor_mason_rebirth" },
    { 0xAE579842, "actor_min_goal_radius" },
    { 0xE1DA345D, "actor_mov_civilian_panama_m_runner" },
    { 0x6C18C6A4, "actor_move_group" },
    { 0xD0288923, "actor_moveto" },
    { 0x39C8E0E9, "actor_names" },
    { 0x12DC1865, "actor_navigation" },
    { 0xEA6A5995, "actor_nevski_full_ahead" },
    { 0xD6D2E87F, "actor_new" },
    { 0x6AB30B2C, "actor_nva_e_ak47" },
    { 0x52E41E2C, "actor_nva_e_ak47_burn" },
    { 0xC1E28599, "actor_nva_e_ak47_ft" },
    { 0xAE84A2A3, "actor_nva_e_ak47_ft_burn" },
    { 0x80D1B14C, "actor_nva_e_fal" },
    { 0xD5CC9053, "actor_nva_e_fal_nogear" },
    { 0x685D8DFB, "actor_nva_e_fal_shotgun_spas" },
    { 0x6DEDC575, "actor_nva_e_lmg" },
    { 0x88E6051F, "actor_nva_e_lmg_burn" },
    { 0x3DED894C, "actor_nva_e_rpg_ak47" },
    { 0x28FEF56C, "actor_nva_e_rpg_fal" },
    { 0x277AE4BD, "actor_nva_e_rpg_only" },
    { 0xBDA1F917, "actor_nva_e_rpg_only_burn" },
    { 0x5FE30ADF, "actor_nva_e_shotgun_spas" },
    { 0x77A4808C, "actor_old_hero_hudson_khesanh" },
    { 0x86CD96EF, "actor_patrenko_full_ahead" },
    { 0x38E87E6F, "actor_play_anim" },
    { 0x2EF54678, "actor_play_slomo" },
    { 0x9F065779, "actor_player_damage_only" },
    { 0x73FE2205, "actor_prisoner_ak47" },
    { 0xD96D27D4, "actor_prisoner_shotgun" },
    { 0x03690EAA, "actor_prisoner_shotgun_hook" },
    { 0x9FCEBCFA, "actor_reznov_creek" },
    { 0x321F0464, "actor_reznov_creek_pistol" },
    { 0xBF96DEE8, "actor_reznov_pow" },
    { 0x8ACBD7F8, "actor_reznov_rebirth" },
    { 0x1999B8EA, "actor_reznov_vorkuta" },
    { 0x0705503E, "actor_ru_a_winter_elite_mosin_scope" },
    { 0xD9E3EABA, "actor_ru_a_winter_elite_ppsh" },
    { 0x06D49485, "actor_ru_a_winter_soldier_mosin_scope" },
    { 0xC446495B, "actor_ru_a_winter_soldier_ppsh" },
    { 0x695B1528, "actor_ru_e_ak47" },
    { 0x6AFF791F, "actor_ru_e_ak74u" },
    { 0x47538D29, "actor_ru_e_char_ak47" },
    { 0x49DAEFA2, "actor_ru_e_char_ak47_ft" },
    { 0xDD7BDB7E, "actor_ru_e_char_ak47_rottweil" },
    { 0x40B20855, "actor_ru_e_char_galil" },
    { 0xA41897E4, "actor_ru_e_char_rottweil" },
    { 0x059069CD, "actor_ru_e_char_rpg_ak47" },
    { 0xEA969B13, "actor_ru_e_char_rpk" },
    { 0x1A799404, "actor_ru_e_char_uzi" },
    { 0x923A0E5E, "actor_ru_e_galil" },
    { 0xC9C3F7F2, "actor_ru_e_guard_ak47" },
    { 0xAE4F7298, "actor_ru_e_guard_ak47_gl" },
    { 0x2EFBC631, "actor_ru_e_guard_baton" },
    { 0x65568471, "actor_ru_e_guard_intro" },
    { 0x6CC1D620, "actor_ru_e_guard_pistol" },
    { 0x045505D6, "actor_ru_e_guard_rpg_ak47" },
    { 0xA9370BD1, "actor_ru_e_guard_shotgun" },
    { 0xFACFBB19, "actor_ru_e_hazmat_ak74u" },
    { 0xED5297BE, "actor_ru_e_hazmat_kiparis" },
    { 0x5CBDDF92, "actor_ru_e_hazmat_ks23" },
    { 0x957704DA, "actor_ru_e_hazmat_rpk" },
    { 0xFF34E580, "actor_ru_e_heavy_rpk" },
    { 0x557E3473, "actor_ru_e_heavy_shotgun" },
    { 0x1D0EC49E, "actor_ru_e_mac11" },
    { 0x2229802E, "actor_ru_e_rpg_galil" },
    { 0x35C337D1, "actor_ru_e_rpg_galil_uwb" },
    { 0x2DDB1170, "actor_ru_e_rpk" },
    { 0xC8CEB17C, "actor_ru_e_scientist_shotgun" },
    { 0xFE6D7559, "actor_ru_e_tow_galil" },
    { 0x351A45F1, "actor_ru_e_winter_famas" },
    { 0xA34F009B, "actor_ru_e_winter_hk21" },
    { 0x5E100C2F, "actor_ru_e_winter_shotgun" },
    { 0xFBA11060, "actor_ru_e_winter_skorpion" },
    { 0xD74DA334, "actor_sergei" },
    { 0xA946F557, "actor_shouldfacemotion" },
    { 0x36DD98BE, "actor_so_ally_assault" },
    { 0x847F4CF6, "actor_so_ally_assault_base" },
    { 0xCD33CAE1, "actor_so_ally_assault_smaw" },
    { 0x085CE46E, "actor_so_ally_heavy" },
    { 0x5EF89786, "actor_so_ally_heavy_base" },
    { 0xC19EE079, "actor_so_ally_heavy_base_smaw" },
    { 0xECEA82C5, "actor_so_ally_pistol_base_karma" },
    { 0x783F3E14, "actor_so_ally_sniper" },
    { 0x13D41E2C, "actor_so_ally_sniper_base" },
    { 0xC9443483, "actor_so_cd_assault_base" },
    { 0x68446ED8, "actor_so_cd_lmg_base" },
    { 0x35DC1A63, "actor_so_cd_rpg_base" },
    { 0x451C77AA, "actor_so_cd_shotgun_base" },
    { 0x90173941, "actor_so_cd_smg_base" },
    { 0xFD53AF2D, "actor_so_cd_smg_qcw" },
    { 0xAAEA18B7, "actor_so_chinese_assault_base" },
    { 0x97B6965C, "actor_so_chinese_lmg_base" },
    { 0xC393A5A7, "actor_so_chinese_rpg_base" },
    { 0x946F626D, "actor_so_chinese_smg_base" },
    { 0xD4B4056D, "actor_so_chinese_smg_pdw57" },
    { 0xAF413D54, "actor_so_chinese_smg_qcw05" },
    { 0xC82DB607, "actor_so_enemy_bigdog" },
    { 0x3479B67B, "actor_so_enemy_easy_assault_base" },
    { 0x62068CF2, "actor_so_enemy_hardened_assault_base" },
    { 0x6E9EDC75, "actor_so_enemy_juggernaut_assault_base" },
    { 0xAB1D60E7, "actor_so_enemy_regular_assault_base" },
    { 0xE0E0C0AA, "actor_so_enemy_sniper_assault_base" },
    { 0x8C0E56B5, "actor_so_enemy_spetsnaz_assault_base" },
    { 0x856B7CF4, "actor_so_muj_assault_base" },
    { 0x12E43FC0, "actor_so_muj_rpg_base" },
    { 0x91194E1A, "actor_so_muj_sniper_base" },
    { 0xBA3B2D84, "actor_so_pmc_assault_base" },
    { 0x39723927, "actor_so_pmc_lmg_base" },
    { 0x73743C32, "actor_so_pmc_smg_base" },
    { 0x5EF04B5D, "actor_spetsnaz_e_ak47" },
    { 0x926E89ED, "actor_spetsnaz_e_ak47_assault" },
    { 0xB824323A, "actor_spetsnaz_e_char_ak47" },
    { 0x2EB6AC7B, "actor_spetsnaz_e_char_ak47_rottweil" },
    { 0xF2BB65A0, "actor_spetsnaz_e_char_galil" },
    { 0x546849D5, "actor_spetsnaz_e_char_galil_rottweil" },
    { 0x98DA4115, "actor_spetsnaz_e_char_uzi" },
    { 0xDE05BE1E, "actor_spetsnaz_e_civ_cz75_auto" },
    { 0x16EEEA93, "actor_spetsnaz_e_civ_dragunov_ir" },
    { 0x7C847750, "actor_spetsnaz_e_civ_kiparis" },
    { 0x27E6027C, "actor_spetsnaz_e_civ_rpg" },
    { 0x7EC10CDF, "actor_spetsnaz_e_civ_wet_cz75_auto" },
    { 0x3C45DE06, "actor_spetsnaz_e_civ_wet_dragunov_ir" },
    { 0x4BCF9441, "actor_spetsnaz_e_civ_wet_kiparis" },
    { 0x081B9209, "actor_spetsnaz_e_civ_wet_rpg" },
    { 0x02585BC1, "actor_spetsnaz_e_civ_wet_spas" },
    { 0x5B7469FE, "actor_spetsnaz_e_dragunov_ak47" },
    { 0x91DCDD05, "actor_spetsnaz_e_elite_ak47" },
    { 0x5F6B36C7, "actor_spetsnaz_e_gasmask_ak47" },
    { 0x23884253, "actor_spetsnaz_e_guard_ak47" },
    { 0x7C62C287, "actor_spetsnaz_e_guard_makarov" },
    { 0x901745BA, "actor_spetsnaz_e_pm63" },
    { 0x107CF752, "actor_spetsnaz_e_pm63_onemodel" },
    { 0x3133B605, "actor_spetsnaz_e_pow_supervisor" },
    { 0x66880F4B, "actor_spetsnaz_e_rebirth_ak74u" },
    { 0x8FEB4EA5, "actor_spetsnaz_e_rebirth_ak74u_ks23" },
    { 0x98D4A2E4, "actor_spetsnaz_e_rebirth_kiparis" },
    { 0xD0695C92, "actor_spetsnaz_e_rebirth_kiparis_gas" },
    { 0x1D048F38, "actor_spetsnaz_e_rebirth_ks23" },
    { 0xD05DE51B, "actor_spetsnaz_e_rebirth_rpg_ak74u" },
    { 0x5329EF9F, "actor_spetsnaz_e_rebirth_rpg_shotgun" },
    { 0xE2666E34, "actor_spetsnaz_e_rebirth_rpk" },
    { 0x935AF0C8, "actor_spetsnaz_e_rottweil" },
    { 0x27815DBC, "actor_spetsnaz_e_shotgun" },
    { 0x677FC043, "actor_spetsnaz_e_uwb_ak74u" },
    { 0x2AD7E89A, "actor_spetsnaz_e_uwb_cz75_auto" },
    { 0xC0B44672, "actor_spetsnaz_e_uwb_galil" },
    { 0xBE35742C, "actor_spetsnaz_e_uwb_rpk" },
    { 0x23306A83, "actor_spetsnaz_e_winter_cz75" },
    { 0x311CA1B8, "actor_spetsnaz_e_winter_famas" },
    { 0x4FE34EA6, "actor_spetsnaz_e_winter_famas_spikes" },
    { 0x80FE1138, "actor_spetsnaz_e_winter_lmg" },
    { 0x523430C8, "actor_spetsnaz_e_winter_rpg_famas" },
    { 0x9974778A, "actor_spetsnaz_e_winter_shotgun" },
    { 0x42E8EFB7, "actor_spetsnaz_e_winter_skorpion" },
    { 0x6E4A0223, "actor_steiner_full_ahead" },
    { 0xBA724FA9, "actor_steiner_int_escape" },
    { 0xAD78D278, "actor_steiner_rebirth" },
    { 0x4E18E461, "actor_swift_creek" },
    { 0xB2A13E73, "actor_tool_enemy_dog" },
    { 0xC42C4CF2, "actor_turret_damage_override" },
    { 0x9F275642, "actor_unlink" },
    { 0x2AC16678, "actor_usblackops_a_urban_spectre" },
    { 0x483E14A2, "actor_usblackops_a_winter_aug_silencer" },
    { 0xD75E56C1, "actor_usblackops_a_winter_halo_aug_silencer" },
    { 0x93F86F29, "actor_usblackops_a_winter_halo_mask_aug_sil" },
    { 0xC614C2DA, "actor_usmarines_a_barechest" },
    { 0xDF6D6FC5, "actor_usmarines_a_commando" },
    { 0x2E9F8175, "actor_usmarines_a_headblown" },
    { 0xF3617B98, "actor_usmarines_a_huey_pilot1" },
    { 0x6568EAD3, "actor_usmarines_a_huey_pilot2" },
    { 0x9F27D074, "actor_usmarines_a_ithaca_khesanh" },
    { 0x69C000F2, "actor_usmarines_a_m14_khesanh" },
    { 0x2FCF8245, "actor_usmarines_a_m16" },
    { 0xC049B42F, "actor_usmarines_a_m16_burn" },
    { 0xD666DEA0, "actor_usmarines_a_m16_khesanh" },
    { 0xBF9642BE, "actor_usmarines_a_m60_burn" },
    { 0x57EFBD73, "actor_usmarines_a_m60_khesanh" },
    { 0x653FF32B, "actor_usmarines_a_medic" },
    { 0x0A512E4D, "actor_usmarines_a_pow_ak47" },
    { 0x687B8C66, "actor_usmarines_a_sergeant" },
    { 0x6EC57F06, "actor_usmarines_a_tanker" },
    { 0xC73E6060, "actor_usmarines_a_wet_m16_creekset1" },
    { 0x13435532, "actor_usmarines_a_wet_m16_creekset3" },
    { 0x854AC46D, "actor_usmarines_a_wet_m16_creekset4" },
    { 0x5F484A04, "actor_usmarines_a_wet_m16_creekset5" },
    { 0x27155F88, "actor_usmarines_a_wet_m16_creeksetfull" },
    { 0x4E05E781, "actor_uwb_a_dive_famas" },
    { 0xBC233A0D, "actor_uwb_a_dive_lmg" },
    { 0x9894AA5A, "actor_uwb_a_dive_smg" },
    { 0xB2E04C96, "actor_uwb_a_famas" },
    { 0x048215DA, "actor_uwb_a_lmg" },
    { 0x2810A58D, "actor_uwb_a_smg" },
    { 0x17E9C1FE, "actor_vc_e_ak47" },
    { 0x37A40093, "actor_vc_e_ak47_tunnel" },
    { 0x78D30011, "actor_vc_e_ak74u" },
    { 0xA393FD24, "actor_vc_e_creek_meatshield" },
    { 0x1D389AF2, "actor_vc_e_creek_model1" },
    { 0xF7362089, "actor_vc_e_creek_model2" },
    { 0xE33F952B, "actor_vc_e_creek_sleeper1" },
    { 0x713825F0, "actor_vc_e_creek_sleeper2" },
    { 0x2F7037C8, "actor_vc_e_creek_throatcut" },
    { 0x6F3E52CF, "actor_vc_e_lmg" },
    { 0xA0FA127A, "actor_vc_e_pow_baton" },
    { 0x1FD5DC09, "actor_vc_e_pow_bookie" },
    { 0x5B855C54, "actor_vc_e_pow_guard1" },
    { 0xCD8CCB8F, "actor_vc_e_pow_guard2" },
    { 0x9C2AE36A, "actor_vc_e_pow_guy1" },
    { 0x76286901, "actor_vc_e_pow_guy2" },
    { 0x989103BC, "actor_vc_e_pow_rpg_lmg" },
    { 0x28109E9E, "actor_vc_e_river_rpg_ak74u" },
    { 0xC607A2AB, "actor_vc_e_rottweil" },
    { 0x463B8C42, "actor_vc_e_rpg_ak47" },
    { 0x80D5B325, "actor_vc_e_rpg_ak74u" },
    { 0xB1A4D37D, "actor_vc_e_shotgun" },
    { 0xD46AA8C0, "actor_vc_e_smg" },
    { 0x04B8BB20, "actor_vc_e_tree_sniper_dragunov" },
    { 0xDBEEA7F2, "actor_weaver_flashpoint" },
    { 0x4E10D48B, "actor_weaver_kowloon" },
    { 0xD03E5C34, "actor_weaver_rebirth" },
    { 0xE84F9E92, "actor_weaver_underwaterbase" },
    { 0x6745D84A, "actor_weaver_wmd" },
    { 0x5B7D6432, "actor_woods_creek" },
    { 0xB3E006FD, "actor_woods_cuba" },
    { 0xA90B11DF, "actor_woods_cuba_bar" },
    { 0xC359F82E, "actor_woods_flashpoint" },
    { 0x86BE9440, "actor_woods_flashpoint_disguise" },
    { 0xCD142B22, "actor_woods_khesanh" },
    { 0xF9C606E0, "actor_woods_pow" },
    { 0x46300AE9, "actor_woods_quagmire" },
    { 0x0F71E6CE, "actor_zm_transit_avogadro" },
    { 0x98EF47EB, "actor_zm_transit_basic_01" },
    { 0x26E7D8B0, "actor_zm_transit_basic_02" },
    { 0x4CEA5319, "actor_zm_transit_basic_03" },
    { 0xCA19CD5B, "actor_zm_transit_screecher" },
    { 0x88B2F951, "actor_zm_zombie_cosmo_cosmonaut" },
    { 0x6B0A92F6, "actor_zm_zombie_cosmo_scientist" },
    { 0x8C4DDB7F, "actor_zm_zombie_cosmo_spetznaz" },
    { 0xAE1EE3E6, "actor_zm_zombie_cosmo_worker" },
    { 0xEDCF70CA, "actor_zm_zombie_transit_screecher" },
    { 0xFF96BFB0, "actor_zombie_ape" },
    { 0xD3BFBE72, "actor_zombie_dog" },
    { 0x0EED781B, "actor_zombie_electrician" },
    { 0xBB8C4AD3, "actor_zombie_engineer" },
    { 0xB27FFFBF, "actor_zombie_ger_zombie" },
    { 0xD9C1741A, "actor_zombie_ger_zombietron" },
    { 0xE83F64DF, "actor_zombie_moon_quad" },
    { 0x23A1F8D0, "actor_zombie_moon_zombie_astronaut" },
    { 0x841F81A0, "actor_zombie_moon_zombie_militarypolice" },
    { 0xDA4D25ED, "actor_zombie_moon_zombie_technician" },
    { 0xA26D7576, "actor_zombie_moss" },
    { 0x7CF81D1D, "actor_zombie_moss_big" },
    { 0x085DDCA9, "actor_zombie_quad" },
    { 0x1D376FFB, "actor_zombie_sergei" },
    { 0x0EE2E992, "actor_zombie_usa_zombie_militarypolice" },
    { 0x47297BE7, "actor_zombie_usa_zombie_officeworker" },
    { 0xFBDDD941, "actor_zombie_usa_zombie_scientist" },
    { 0x4E9640B1, "actor_zombie_usa_zombietron_militarypolice" },
    { 0xA018FADC, "actorbookmarkparamsinitialized" },
    { 0xA9FCE8FB, "actorcharrampto" },
    { 0xD37EF0A7, "actordamage" },
    { 0x9468A9D3, "actorent" },
    { 0xC354617D, "actorentnum" },
    { 0x2326214A, "actorgetpredictedyawtoenemy" },
    { 0x34AECCE7, "actors" },
    { 0x1051BBCC, "actors1" },
    { 0x82592B07, "actors2" },
    { 0x57762C9F, "actors_a" },
    { 0xE56EBD64, "actors_b" },
    { 0x0B7137CD, "actors_c" },
    { 0x9969C892, "actors_d" },
    { 0xBF6C42FB, "actors_e" },
    { 0x4D64D3C0, "actors_f" },
    { 0x63949C1D, "actorsonly" },
    { 0xFDDEC3F7, "actorspawnerarray" },
    { 0xDF161DCE, "acts" },
    { 0x03CD32BF, "actual" },
    { 0x78B409D6, "actual_dist" },
    { 0xB74A49C6, "actual_door" },
    { 0xB6D29D9D, "actual_increment" },
    { 0x0AA273A3, "actual_multiplier" },
    { 0xAA2BE123, "actual_num_positions" },
    { 0x024B1CC1, "actual_range" },
    { 0x74E4CC2D, "actual_rangebytime" },
    { 0x1E404668, "actual_stage" },
    { 0xB5211FE8, "actualangle" },
    { 0x6C681900, "actualcaptureteam" },
    { 0x435F4560, "actualdamage" },
    { 0x4D649C97, "actualdistsq" },
    { 0x13601971, "actuall" },
    { 0xBA6B7E62, "actually" },
    { 0x024CB9B1, "actualpoi" },
    { 0xEC9F84A0, "actualspeed" },
    { 0xE58F2F3C, "actualy" },
    { 0x73FEAC4C, "acv_index" },
    { 0x5A183CC0, "acv_indexes" },
    { 0xCF4497DB, "acv_param" },
    { 0x65CE895E, "acvi" },
    { 0x7A69975E, "ad" },
    { 0x345D4E1C, "adam" },
    { 0x89FD700A, "adaptation" },
    { 0xF8273BE4, "adapted" },
    { 0x8D83265A, "adcasts" },
    { 0x69554B3E, "add" },
    { 0x393B42C0, "add_active_stat" },
    { 0x5218202C, "add_actor_anim" },
    { 0xCCC3F622, "add_actor_bookmark_kill_time" },
    { 0x09B8745E, "add_actor_model_anim" },
    { 0xB8871BF9, "add_actor_spawner" },
    { 0x0D78F912, "add_additional_stink_locations_for_zone" },
    { 0x8CBCC300, "add_adjacent_zone" },
    { 0x9FCDD8A7, "add_afterlife" },
    { 0x54BBE472, "add_ai_spawn_function" },
    { 0x5A24ECE6, "add_ai_supplements" },
    { 0x3ABC881E, "add_ai_to_gaz" },
    { 0x1741FA6A, "add_ai_to_lvt" },
    { 0xEF0C9E34, "add_ambient_turret_target" },
    { 0xC41C60FF, "add_and_select_entity" },
    { 0xE5641452, "add_angle" },
    { 0x74A1E33D, "add_angle_limits" },
    { 0x6900765D, "add_angles" },
    { 0xE56D47EE, "add_anim_queue" },
    { 0xCA4B6E57, "add_animated_dial" },
    { 0x940CDAC5, "add_animation" },
    { 0x88AC125F, "add_animsound" },
    { 0xC523A148, "add_ar_target" },
    { 0x906BDB6D, "add_archetype_spawn_function" },
    { 0xCCD0892F, "add_area_dog_spawners" },
    { 0x2876C876, "add_argus_info" },
    { 0x2A781C6A, "add_argus_on_flag" },
    { 0xCB8127DD, "add_asset_properties" },
    { 0x4DA0ABA1, "add_assignable_camo" },
    { 0x7BBD391E, "add_attachment" },
    { 0xE3556381, "add_attachments" },
    { 0x5809C189, "add_attack_points_from_anchor_origin" },
    { 0x4AC25BE3, "add_balanced_bot" },
    { 0x10ECF402, "add_ball_return_trigger" },
    { 0xA811FC4A, "add_banzai_attacker" },
    { 0x8C4130CF, "add_beacon_effect" },
    { 0x8052FCCF, "add_beartrap_into_full_array" },
    { 0xE9C17332, "add_boat_to_attack_array" },
    { 0x72890E3C, "add_bot" },
    { 0x9FDA6F90, "add_bot_at_eye_trace" },
    { 0xDB51E3FF, "add_bots" },
    { 0x8585BD30, "add_buildable_piece" },
    { 0x1758439E, "add_buildable_to_pool" },
    { 0x08A43D7A, "add_buried_powerups" },
    { 0x9AB8AC8D, "add_button" },
    { 0xDE460788, "add_callback" },
    { 0x4A2EE0BF, "add_category_to_ai_in_scene" },
    { 0x9E3CEDD6, "add_cellphone_notetracks" },
    { 0x22FB8D17, "add_channel_to_filter" },
    { 0xD5F6D0E6, "add_cheap_actor_model_anim" },
    { 0xB4147445, "add_cleansed_powerup" },
    { 0x253EF81D, "add_cleanup_ent" },
    { 0x1BF0E5A5, "add_cleanup_msg" },
    { 0xC0D4402D, "add_client_stat" },
    { 0x4A256CE5, "add_connection" },
    { 0x9C347E8A, "add_connection_by_type" },
    { 0x42BA7E3E, "add_context_sensative_dialog" },
    { 0x813B2F97, "add_context_sensative_timeout" },
    { 0x8E1FC5B5, "add_contract_to_queue" },
    { 0xDDDBA961, "add_cover_node" },
    { 0xE70D8888, "add_cp_to_target" },
    { 0xE3809FE4, "add_cp_to_track" },
    { 0x6442C1BD, "add_craftable_cheat" },
    { 0xB0DEB4E6, "add_craftable_piece" },
    { 0x7085C9CA, "add_credit" },
    { 0x60FAB53D, "add_current_run_to_high_scores" },
    { 0xBCA4E2EA, "add_cusom_zombie_spawn_logic" },
    { 0x463212D4, "add_custom_exposed_approach" },
    { 0xA1547300, "add_custom_exposed_exit" },
    { 0xFA087ACB, "add_custom_limited_weapon_check" },
    { 0xF532F99E, "add_custom_zombie_spawn_logic" },
    { 0x24110617, "add_damage_owner_recorder" },
    { 0x05BFA497, "add_dds_category" },
    { 0xEDD891F1, "add_dds_category_axis" },
    { 0xF0957150, "add_dds_countryid" },
    { 0x8684A7C4, "add_death_function" },
    { 0xDBA815F6, "add_dial_vehicle" },
    { 0x174A2001, "add_dialog" },
    { 0x278B5644, "add_dialogue_line" },
    { 0xE16E3953, "add_dialogue_queue" },
    { 0xA218C761, "add_dirtmodel" },
    { 0xB5290298, "add_dog_dialog" },
    { 0x4FFCD84B, "add_drone_anim" },
    { 0xFB558902, "add_dyn_ent_model" },
    { 0xDF69E20D, "add_dynamic_wallbuy" },
    { 0x1301AD8E, "add_earthquake" },
    { 0xE001C93E, "add_effect" },
    { 0xD03DC705, "add_effect_to_ent_when_stops_falling" },
    { 0x70B869D1, "add_eligable_pooled_items" },
    { 0x5D31857F, "add_endon" },
    { 0x9D13ABDD, "add_engagement_func" },
    { 0xFB855D21, "add_engine_power" },
    { 0xCCFB227F, "add_engine_power_take_off" },
    { 0x1F95C8F2, "add_entity_callback" },
    { 0xF1DDFCD6, "add_equip_activated_callback_override" },
    { 0x36EAF27E, "add_event_listener" },
    { 0xAAC64A60, "add_event_to_trigger" },
    { 0x4A678EE8, "add_extra_starting_guy" },
    { 0x6D8BC3D1, "add_f" },
    { 0x58EBCB36, "add_faction_to_weapon_array" },
    { 0x49F85935, "add_fake_jetwing_hud" },
    { 0xC78A2EE2, "add_fallback_spawnpoints" },
    { 0x56CF7C70, "add_fire_direction_func" },
    { 0xE24392B2, "add_fire_direction_shooter" },
    { 0x182E85A9, "add_fire_direction_valid_area_check" },
    { 0xB322B6BA, "add_flag_function" },
    { 0xCD68E981, "add_flag_to_chernov" },
    { 0x99675252, "add_flags" },
    { 0x5264A3B4, "add_flyover_audio_entry" },
    { 0xD61BE6D2, "add_forced_banned_attachement_to_class_and_faction" },
    { 0x15038DEC, "add_fractional_data_point" },
    { 0xBCFD5AD7, "add_func" },
    { 0x98BE67BD, "add_function" },
    { 0x11CFAE60, "add_game_mode_group_stat" },
    { 0x2747421C, "add_game_mode_stat" },
    { 0x6EE79347, "add_gameloc" },
    { 0x3BF39ED7, "add_gametype" },
    { 0x593A9ABE, "add_generic_ai_to_scene" },
    { 0xD1A32FA5, "add_generic_prop_to_scene" },
    { 0x191312DE, "add_global_drone_spawn_function" },
    { 0xED9DF341, "add_global_notetrack_handler" },
    { 0xEF554CF7, "add_global_spawn_function" },
    { 0x80331B09, "add_global_stat" },
    { 0x606AA4DC, "add_god_rod_func" },
    { 0x287D129E, "add_god_rod_shooter" },
    { 0xB0DA8875, "add_god_rod_valid_area_check" },
    { 0xB5A77DBF, "add_ground_vehicle_damage_callback" },
    { 0x33CC02D0, "add_group_name" },
    { 0x9BE74ECD, "add_gump_function" },
    { 0x116BC640, "add_hackable_object" },
    { 0x0658C311, "add_heading" },
    { 0x92975A5C, "add_highlighted" },
    { 0x619EE2B3, "add_highrise_response_chance" },
    { 0xA379AC50, "add_hijack_function" },
    { 0x8C292DFD, "add_hint_background" },
    { 0xA3857CA2, "add_hint_string" },
    { 0x723F59C8, "add_horse_anim" },
    { 0x2662D538, "add_html_bar" },
    { 0xDE35307F, "add_html_line" },
    { 0x0053B28A, "add_html_table_row" },
    { 0x7FBB23D9, "add_hud_line" },
    { 0x105A9902, "add_hudelm_position_internal" },
    { 0xF45D157C, "add_image" },
    { 0x4347BDE1, "add_info" },
    { 0x02605B15, "add_interrupt_connection" },
    { 0xCA22A5F8, "add_jav_glow" },
    { 0x9AEC0CFF, "add_jet_fx" },
    { 0xDBB472CD, "add_kb_button" },
    { 0xF1D818B8, "add_later_round_spawners" },
    { 0x88EE0FE6, "add_leap_node" },
    { 0x438AE0DD, "add_level" },
    { 0x9077CD5F, "add_level_banned_attachments" },
    { 0x70A89DE3, "add_level_boss" },
    { 0x7D6F20EB, "add_light" },
    { 0xDDE5C4A2, "add_light_thread" },
    { 0xFF8437CA, "add_limited_tesla_gun" },
    { 0x2FED8360, "add_limited_weapon" },
    { 0x733BF333, "add_listen_thread" },
    { 0x80767625, "add_listen_thread_internal" },
    { 0x8B085A3C, "add_local_power" },
    { 0xF78FDB44, "add_localized_string" },
    { 0xCB3DF6C6, "add_location_gametype_stat" },
    { 0xB317340D, "add_low_ammo_dialog" },
    { 0xF1491320, "add_lui_vehicle_icon" },
    { 0x50322F94, "add_machines_in_zone" },
    { 0xCB767064, "add_main_callback" },
    { 0xCA7BC015, "add_map_buildable_stat" },
    { 0x78F5A223, "add_map_craftable_stat" },
    { 0x8FF5437B, "add_map_gamemode" },
    { 0x87817043, "add_map_location_gamemode" },
    { 0x9964EDC6, "add_map_stat" },
    { 0xD9F055C5, "add_map_weaponlocker_stat" },
    { 0x2354A0D6, "add_match_history_stat" },
    { 0x848433B2, "add_me_to_death_queue" },
    { 0x1E83F9CE, "add_me_to_the_death_queue" },
    { 0xC0755351, "add_meat_event" },
    { 0xC5CB691E, "add_meatshield_angle_limits" },
    { 0x83AB4E9D, "add_meatshield_target" },
    { 0x4B412A47, "add_melee_callback" },
    { 0x9205E36B, "add_melee_prop_anim" },
    { 0x7EEFDAA9, "add_melee_sequence" },
    { 0x5D59D34E, "add_melee_weapon" },
    { 0x573980E0, "add_menu" },
    { 0xC85AEEFF, "add_menu_child" },
    { 0x2A240D1A, "add_menuoptions" },
    { 0xD4224082, "add_microwaveable_object" },
    { 0x9DE368CB, "add_mine_type" },
    { 0xF97DBF2B, "add_misc_model" },
    { 0xCA40B90C, "add_missile_turret_target" },
    { 0x21868F44, "add_model" },
    { 0x4A65C1C4, "add_model_to_group" },
    { 0x72175423, "add_mortar_light" },
    { 0x5CDD06C5, "add_mov_model_anim" },
    { 0xB9BF1768, "add_multiple_generic_actors" },
    { 0xC1450B0B, "add_multiple_generic_props_from_radiant" },
    { 0x6E4B96D2, "add_music_track" },
    { 0x5669FCA4, "add_name" },
    { 0xBD2395A4, "add_nationality_names" },
    { 0x61908445, "add_new_breadcrumb_ent" },
    { 0xF03FA946, "add_new_zombie_spawners" },
    { 0x7F3F8B0C, "add_no_ammo_dialog" },
    { 0x7D092F8C, "add_node_to_global_arrays" },
    { 0xC6CDE38A, "add_nodes_mins_maxs" },
    { 0x1438BFCD, "add_note" },
    { 0x3AB2006A, "add_notetrack_attach" },
    { 0x7073AF93, "add_notetrack_custom_function" },
    { 0xF8237784, "add_notetrack_detach" },
    { 0xFB2C2936, "add_notetrack_exploder" },
    { 0x0DB98A77, "add_notetrack_flag" },
    { 0x609A9896, "add_notetrack_fov" },
    { 0x46EEECB5, "add_notetrack_fov_new" },
    { 0x7FAF432B, "add_notetrack_func" },
    { 0x5E440D48, "add_notetrack_fx_on_tag" },
    { 0x0CEB82E7, "add_notetrack_level_notify" },
    { 0x2E25B5C6, "add_notetrack_sound" },
    { 0x85F4B59B, "add_notetrack_stop_exploder" },
    { 0x0AA84004, "add_object" },
    { 0xADD53061, "add_objective_building" },
    { 0x54A5DE81, "add_objectives" },
    { 0xF40F2318, "add_option_to_selected_entities" },
    { 0x1782E761, "add_optional_actor_anim" },
    { 0x8E6B9A66, "add_override_name_func" },
    { 0x43394667, "add_part_to_vehicle" },
    { 0x6FE74C07, "add_path_node" },
    { 0x8211B4FD, "add_perk" },
    { 0xF17B9229, "add_pers_upgrade_stat" },
    { 0x4126A79B, "add_phrase_to_history" },
    { 0x7BAFB2DB, "add_placeable_equipment" },
    { 0x4F6BE030, "add_plane_type" },
    { 0x1ABCAFC3, "add_planted_callback" },
    { 0xF2B4747E, "add_player_anim" },
    { 0xFBDD9E37, "add_player_equipment" },
    { 0x9E5B8CDB, "add_player_linked_scene" },
    { 0xBAFD0FA8, "add_player_spawnpoint" },
    { 0xB95B6735, "add_player_threat_boost" },
    { 0xFFEA59D7, "add_player_threat_damage" },
    { 0x0515C60D, "add_player_to_lvt" },
    { 0x392971A7, "add_poi" },
    { 0x4FD5C1CE, "add_poi_attractor" },
    { 0x676CEF81, "add_poi_to_ignore_list" },
    { 0xD71D946E, "add_point_score" },
    { 0x49E74578, "add_posed_corpses" },
    { 0xD9CFDCE3, "add_powered_item" },
    { 0x3A002997, "add_powerup" },
    { 0x46B6369C, "add_powerups_after_round_1" },
    { 0x61DDEDF3, "add_priority_target" },
    { 0x68B0F996, "add_proccess_trigger" },
    { 0x7066133A, "add_prop_anim" },
    { 0x446B06B3, "add_puzzle_completion_line" },
    { 0xDA831334, "add_radio_tower_objective" },
    { 0xD00F21AB, "add_radio_tower_objective_alternate" },
    { 0x818A139E, "add_ragdoll" },
    { 0xF4D7EC24, "add_rampage_bookmark_kill_time" },
    { 0x7BB6EBAE, "add_raps_drop_locations" },
    { 0xC9AA825E, "add_raps_omit_locations" },
    { 0x3128E1EF, "add_recent_earnings_to_stat" },
    { 0xFC306EA1, "add_recent_stat" },
    { 0x124423A4, "add_remove_list" },
    { 0x94719BA3, "add_retrievable_knife_init_name" },
    { 0xC450A78C, "add_ricochet_protection" },
    { 0x6A8D3CC1, "add_rocket_pod" },
    { 0x0CCB5381, "add_round_score_event" },
    { 0xA25A37D2, "add_rumble_for_notify" },
    { 0x9DF83BD3, "add_running_traverse" },
    { 0x8021AF77, "add_scene" },
    { 0x8A9F70FE, "add_scene_custom_function" },
    { 0x8F9F34E0, "add_scene_func" },
    { 0x770D6794, "add_scene_line" },
    { 0x7F4BBCC4, "add_scene_loop" },
    { 0x2B43C3F9, "add_scene_ordered_notetrack" },
    { 0x1E49DD19, "add_scene_properties" },
    { 0x01813164, "add_score_event" },
    { 0x17FF4042, "add_script_modelnames" },
    { 0x00E9B44F, "add_scripted_damage_state" },
    { 0x7654B70E, "add_scripted_melee" },
    { 0x47206A9E, "add_shader" },
    { 0x8AF9F046, "add_shared_ammo_weapon" },
    { 0x0CA75B28, "add_shot_type" },
    { 0x80738220, "add_shrinkable_object" },
    { 0xF72F765E, "add_sidequest_icon" },
    { 0x62EA5B06, "add_skip_text" },
    { 0x1BC2DEA7, "add_skipto" },
    { 0x7C4FF1D4, "add_skipto_assert" },
    { 0x68987D6D, "add_skipto_construct" },
    { 0x064AC1B4, "add_slippery_spot" },
    { 0xAAEFCD5C, "add_smoking_notetracks" },
    { 0x1214CFEA, "add_song" },
    { 0x9CA56CB2, "add_sorted" },
    { 0xFA5642CC, "add_sorted_name_key" },
    { 0x09258289, "add_sorted_priority_key" },
    { 0x1A06A362, "add_sound" },
    { 0xF3598F61, "add_space" },
    { 0x02ED5569, "add_space_small" },
    { 0x9BC8E6A1, "add_spammodel" },
    { 0x994832BD, "add_spawn_function" },
    { 0xC6FFD13E, "add_spawn_function_ai_group" },
    { 0x7EA92662, "add_spawn_function_by_type" },
    { 0x2B37A3C9, "add_spawn_function_group" },
    { 0x873FAB05, "add_spawn_function_veh" },
    { 0x442733AA, "add_spawn_function_veh_by_type" },
    { 0xCAA2D299, "add_spawn_point_classname" },
    { 0x4F996EB3, "add_spawn_point_team_classname" },
    { 0x74317BD4, "add_spawn_points" },
    { 0x69178C74, "add_spawn_points_internal" },
    { 0x42D23167, "add_spawner" },
    { 0xA2EDFC7F, "add_start" },
    { 0x159CC09F, "add_stat" },
    { 0x26678920, "add_state" },
    { 0xBA456FEA, "add_struct" },
    { 0x6062641B, "add_struct_to_level_array" },
    { 0x7BBB8A95, "add_stub" },
    { 0x932B39CB, "add_supplemental_object" },
    { 0x7FD524BC, "add_support_spawn_functions" },
    { 0x233F7360, "add_survival_stat" },
    { 0x65FCB129, "add_tank" },
    { 0x56036D16, "add_target" },
    { 0x0DF8287F, "add_target_and_remove_when_dead" },
    { 0xFF991BF5, "add_teampot_icon" },
    { 0x4BE0CE3F, "add_temp_dialog_line" },
    { 0x515BCDB9, "add_temp_dialog_line_internal" },
    { 0xEFCE4460, "add_temp_powered_item" },
    { 0xA2930E2B, "add_temp_vo_lines" },
    { 0xFEE20195, "add_tesla_gun" },
    { 0xE27B547B, "add_time_bomb_to_mystery_box" },
    { 0xE5C60443, "add_timed_event" },
    { 0xA6953BEC, "add_timer" },
    { 0x304658A5, "add_title" },
    { 0xD41B4B67, "add_to_all_objects" },
    { 0x4CCB045F, "add_to_animsound" },
    { 0x602A18A4, "add_to_array" },
    { 0xBC796D91, "add_to_credit_list" },
    { 0x7430A948, "add_to_dyn_ent_group" },
    { 0x489CB879, "add_to_dynent_group" },
    { 0xB0528FC4, "add_to_ent" },
    { 0xA32DF695, "add_to_equipment_trigger_list" },
    { 0x88250682, "add_to_group" },
    { 0xBC8511FB, "add_to_killstreak_count" },
    { 0x01704CB2, "add_to_max_aisupplements" },
    { 0x151B8340, "add_to_notification_queue" },
    { 0xAC7F2DA8, "add_to_place_count_on_goal" },
    { 0x7A85F73B, "add_to_player_classes" },
    { 0x5110A7AD, "add_to_player_score" },
    { 0x92FB7AF0, "add_to_player_score_override" },
    { 0xE9EF53F2, "add_to_queue" },
    { 0x8AA409E7, "add_to_ragdoll_bucket" },
    { 0xDB26A0DE, "add_to_retreat_group" },
    { 0xA5F2C9B6, "add_to_rotate_highlighted" },
    { 0x1F57296C, "add_to_save_highlighted" },
    { 0x32CD0CE1, "add_to_selection" },
    { 0x59496EEA, "add_to_spawn_array_and_wait" },
    { 0x7C209CFF, "add_to_spectate_list" },
    { 0xE8C4E69F, "add_to_stat" },
    { 0x24A6D083, "add_to_sync_list" },
    { 0x7921B21A, "add_to_target_group" },
    { 0xEB01A3CD, "add_to_team_score" },
    { 0x1EB42055, "add_to_total" },
    { 0x463E9972, "add_to_trigger_list" },
    { 0x080F5E04, "add_tokens_to_trigger_flags" },
    { 0x75B70855, "add_track_player_results" },
    { 0x79DBB5AA, "add_transit_powerups" },
    { 0x328BB22B, "add_transit_response_chance" },
    { 0x3374805B, "add_trap_dialog" },
    { 0xEF65075A, "add_trigger_function" },
    { 0xA977F8D4, "add_trigger_to_debounce_list" },
    { 0x3763B8BF, "add_trigger_to_ent" },
    { 0xF9F8E23A, "add_turret_priority_target" },
    { 0x08B8ED93, "add_universal_button" },
    { 0xBCA567C6, "add_utility_connection" },
    { 0x4CA4FD41, "add_vec" },
    { 0xE7295005, "add_vehicle_anim" },
    { 0x4BB9D0E7, "add_vehicle_to_convoy_target_pool" },
    { 0x74ADAEFB, "add_vehicletype_callback" },
    { 0x065CF424, "add_visor_text" },
    { 0x465F9BC0, "add_visor_timer" },
    { 0xE8AE6AF4, "add_vo" },
    { 0xDB5B6113, "add_vo_to_nag_group" },
    { 0xBE75150E, "add_volume_to_global_arrays" },
    { 0x93789785, "add_vox_response_chance" },
    { 0x92F25722, "add_wait" },
    { 0x06676939, "add_wait_for_streamer_hint_scene" },
    { 0x6DC07BA2, "add_waiters" },
    { 0xDE15835D, "add_weapon" },
    { 0x92B2988F, "add_weapon_anim" },
    { 0xA7AB8E45, "add_weapon_assignable_attachments_weapon_array" },
    { 0x3A4C046C, "add_weapon_attachment_percentages_to_weapon_array" },
    { 0xD2AEEE8D, "add_weapon_class_to_weapon_array" },
    { 0x36B54EB3, "add_weapon_damage" },
    { 0x43861C2B, "add_weapon_locker_mapping" },
    { 0x13609725, "add_weapon_object" },
    { 0xB91FB889, "add_weapon_to_class_and_faction" },
    { 0x28EFC591, "add_weapon_to_content" },
    { 0xB23C504F, "add_weapon_to_guy" },
    { 0x8AC8F882, "add_weapon_to_mine_slot" },
    { 0x48F809A9, "add_weapon_to_sound_array" },
    { 0xDDAF6F28, "add_weapon_type" },
    { 0x367A33A8, "add_weapon_watcher" },
    { 0xE2D643D2, "add_weapons_to_class_and_faction" },
    { 0xF2167381, "add_weighted_down" },
    { 0x003DDC5E, "add_zombie_buildable" },
    { 0xDF4281C2, "add_zombie_buildable_piece_vox_category" },
    { 0xF043555F, "add_zombie_buildable_vox_category" },
    { 0x8421D708, "add_zombie_craftable" },
    { 0xB2CAEF35, "add_zombie_craftable_vox_category" },
    { 0x8E7DEABB, "add_zombie_eye_glow" },
    { 0x5C609DB3, "add_zombie_gib_weapon_callback" },
    { 0xB7A48E21, "add_zombie_hint" },
    { 0x1BE071AE, "add_zombie_powerup" },
    { 0xEE3C0641, "add_zombie_special_drop" },
    { 0xA3DBB9C6, "add_zombie_special_powerup" },
    { 0x2D9F5F8A, "add_zombie_weapon" },
    { 0x0BCCDBB4, "add_zombie_weapon_prison" },
    { 0x6FC84167, "add_zone" },
    { 0x0FAF6173, "add_zone_flags" },
    { 0xBB05D439, "addacousticsensor" },
    { 0x790508DC, "addactivecounteruav" },
    { 0xE4C6D41F, "addactivesatellite" },
    { 0xEA2DE1A8, "addactiveuav" },
    { 0xE519FA76, "addadditionaltarget" },
    { 0xA7D9D538, "addaieventlistener" },
    { 0x154E2E1E, "addaioverridedamagecallback" },
    { 0xE97A0F7E, "addaioverridekilledcallback" },
    { 0x7F0D749F, "addaitosquad" },
    { 0x79EFF212, "addalias" },
    { 0x074C669A, "addaliasareaex" },
    { 0xE38C82F5, "addaliaslandmarkex" },
    { 0x5FFE1D20, "addaliaslocationex" },
    { 0xF138A45A, "addambientelement" },
    { 0x9B8512F8, "addanimtofacestate" },
    { 0x51124D7E, "addanimtolist" },
    { 0x217B25EB, "addareaalias" },
    { 0x80BB8A1E, "addargus" },
    { 0xDF56DB92, "addasspeakernpc" },
    { 0x07A4AEBB, "addblackboardevent" },
    { 0x14744597, "addbonuscardstat" },
    { 0x0C2668B7, "addcallback" },
    { 0xA76EB32B, "addcameraspike" },
    { 0xDCB18B03, "addcenterdual" },
    { 0xE0E67CE1, "addcenterheading" },
    { 0x1E14A64C, "addcenterimage" },
    { 0x18086914, "addcentername" },
    { 0x8CC3A443, "addcenternamedouble" },
    { 0x03ED0FC9, "addcentertriple" },
    { 0xABB44133, "addcheat" },
    { 0x0317ED10, "addchild" },
    { 0x1E92E0F0, "addclassstatkill" },
    { 0x175DB54B, "addclassstattime" },
    { 0x6A715E0B, "addconditionaltorule" },
    { 0xBC6BE94A, "addconnection" },
    { 0x885FF714, "addcontracttoqueue" },
    { 0x695A9FD6, "addcooldowntime" },
    { 0x26C79825, "addcredit" },
    { 0x9294F959, "addcylinderinfluencer" },
    { 0x996C556B, "adddeathicon" },
    { 0xB3C0448E, "adddebugcommand" },
    { 0xE20F5403, "adddemobookmark" },
    { 0x32AC599F, "adddestructpiececallback" },
    { 0x5F9266E0, "adddirecthitweapon" },
    { 0x1C27E16B, "adddirectionalias" },
    { 0x9CB44736, "adddirectioncompassaliasex" },
    { 0xBD2F2CB4, "adddirectionflankaliasex" },
    { 0x8F98FC4F, "adddirectionsidealiasex" },
    { 0x8CE2C8B8, "adddroplocation" },
    { 0xAB8716A0, "adddstat" },
    { 0xE82057DE, "addduplicaterenderoption" },
    { 0x9CD899BA, "adddupmaterial" },
    { 0x9D9D8881, "added" },
    { 0x8BB4B1FA, "added_behavior" },
    { 0x639D8432, "added_initial_streamer_blackscreen" },
    { 0x54D63F9C, "added_list" },
    { 0x7F06A5DE, "added_poi_value" },
    { 0xEB9C96C7, "addedenemies" },
    { 0x903C444D, "addedtowave" },
    { 0x43D8AD0A, "addenemyheli" },
    { 0xD2C4D023, "addenemyu2" },
    { 0xD372200E, "addentityinfluencer" },
    { 0xFBAA23E6, "addentry" },
    { 0xACCC076B, "addentryplaybackonly" },
    { 0x6C468939, "addepicscenefunc" },
    { 0x98F8BA0C, "addfatguy" },
    { 0x50B3DECB, "addflyswatterstat" },
    { 0xEBEEBF7C, "addfriendlyscrambler" },
    { 0x73BC9991, "addfxandtagtolists" },
    { 0x05157482, "addgametypeeventrule" },
    { 0xA5077F76, "addgametypestat" },
    { 0x24CC8BB7, "addgenericalias" },
    { 0xEB673900, "addgenericaliasex" },
    { 0x0FD0CBC9, "addgibcallback" },
    { 0xCEF3C19F, "addgoal" },
    { 0x00F0931E, "addgridlink" },
    { 0x4525884A, "addgridnode" },
    { 0x5002E287, "addgroup" },
    { 0x270E670F, "addgroupdialogtoplayer" },
    { 0xAE129F9C, "addguntoprogression" },
    { 0xCDBC8740, "addhealth" },
    { 0xEA145655, "addiitional" },
    { 0x76337B8F, "addin" },
    { 0xDA5E9997, "addinfluencer" },
    { 0xF45C99D3, "addinformalias" },
    { 0xB1307674, "addinformaliasex" },
    { 0xBBAE056F, "addinformevent" },
    { 0x70F1FA42, "adding" },
    { 0x47D4ED8D, "addings" },
    { 0x7A672453, "additem" },
    { 0xDE992215, "additemsetting" },
    { 0x8C686BA3, "additinal" },
    { 0x75069E16, "additioal" },
    { 0xB64790A9, "addition" },
    { 0x5238F96A, "additional" },
    { 0xACB45791, "additional_ai_initializers" },
    { 0xAEE3C65E, "additional_ais" },
    { 0x0B9589A1, "additional_bomb" },
    { 0x521E287C, "additional_fires" },
    { 0xF1418F56, "additional_guys_chime_in" },
    { 0xEBB861E6, "additional_icon" },
    { 0xA577D3A8, "additional_number_of_effects_per_circle" },
    { 0x0F1E4CA0, "additional_primary_weapon_client_field_func" },
    { 0xF81F57DF, "additional_primary_weapon_code_callback_func" },
    { 0x172FB3D9, "additional_primary_weapon_machine_active_model" },
    { 0x75AD11E3, "additional_primary_weapon_machine_disabled_model" },
    { 0xDAE5FB47, "additional_primary_weapon_machine_fx_file_machine_light" },
    { 0x21F09FC8, "additional_primary_weapon_machine_light_fx" },
    { 0x41757A79, "additional_primary_weapon_perk_bottle_weapon" },
    { 0x27AB2755, "additional_primary_weapon_perk_cost" },
    { 0x5D7931E7, "additional_primary_weapon_perk_machine_setup" },
    { 0x788460CC, "additional_primary_weapon_precache" },
    { 0x796AEAB4, "additional_primary_weapon_precache_override_func" },
    { 0x2B2694F4, "additional_primary_weapon_radiant_machine_name" },
    { 0x4B4ACDD6, "additional_primary_weapon_register_clientfield" },
    { 0x97ED1467, "additional_primary_weapon_set_clientfield" },
    { 0x99F5F961, "additional_reznov_vo" },
    { 0xA7EF7139, "additional_shot" },
    { 0x751CA5B4, "additional_sprint_gap" },
    { 0x4D7D7080, "additional_targetselection" },
    { 0xC244D714, "additional_walkin_horses" },
    { 0xEE64DF37, "additionally" },
    { 0x7EFEF04D, "additionalpositionindex" },
    { 0xF087D53C, "additionalprimaryweapon" },
    { 0xA2505A30, "additionalprimaryweapon_limit" },
    { 0x3C6DC322, "additionalprimaryweapon_off" },
    { 0x62EE2B14, "additionalprimaryweapon_on" },
    { 0x34B09F8D, "additionalstring" },
    { 0x7E877A39, "additionalwait" },
    { 0x092A5720, "additions" },
    { 0x9D03AB8D, "additiontargets" },
    { 0xA2E51FC9, "additive" },
    { 0x820A2E24, "additive_pain" },
    { 0x2B6CA3A5, "additive_pain_think" },
    { 0x2A4BBA65, "additivepain" },
    { 0x25D140C0, "additives" },
    { 0x315A7433, "additiveturretfire" },
    { 0x9883EF11, "additiveturretidle" },
    { 0x9C83EE73, "addkillcamskiptext" },
    { 0x5A3E94AE, "addkillcamtimer" },
    { 0x46AD1C22, "addkilllink" },
    { 0x7BCDAF3D, "addkilllinkbyhash" },
    { 0x7E90B490, "addkillstreaktoqueue" },
    { 0xD46FFAD1, "addkillstreaktorule" },
    { 0x66DEB5C6, "addlandmarkalias" },
    { 0xB61D5894, "addleftimage" },
    { 0x957ED14C, "addleftname" },
    { 0x5AA1D51D, "addlefttitle" },
    { 0x7F192B18, "addlevel" },
    { 0x8BD9A327, "addlightningexploder" },
    { 0x242B4E2C, "addlimitedweapon" },
    { 0x63D27EE5, "addlinkrunningtraverse" },
    { 0x7D886DF0, "addlinktraverse" },
    { 0x1E66693A, "addlinktraversedelayed" },
    { 0x38BD2871, "addlocationalias" },
    { 0x58FB6F75, "addmatchhistorystat" },
    { 0x6554817D, "addmedaltoqueue" },
    { 0xAD22F2BF, "addmenuexploders" },
    { 0x27E6204A, "addmetalhat" },
    { 0xD4759B83, "addname" },
    { 0x3A3D3AE9, "addnamealias" },
    { 0x4025B64A, "addnamealiasex" },
    { 0x4BBFCC2E, "addnodetocurve" },
    { 0x09BEBAF8, "addnodeusetime" },
    { 0x8C762302, "addnohat" },
    { 0x087F78CF, "addnohatclassname" },
    { 0x2BC888A2, "addnote" },
    { 0x0B0DA34C, "addnotetrack_animfxontag" },
    { 0x1606C04A, "addnotetrack_animsound" },
    { 0xA7490935, "addnotetrack_attach" },
    { 0x717ECC7F, "addnotetrack_custom" },
    { 0x1534F04B, "addnotetrack_customfunction" },
    { 0xC1DF991B, "addnotetrack_detach" },
    { 0xF2315A34, "addnotetrack_dialogue" },
    { 0x517496E9, "addnotetrack_exploder" },
    { 0xCB42CFE0, "addnotetrack_flag" },
    { 0x6FED091B, "addnotetrack_fov" },
    { 0x0C9127B4, "addnotetrack_fov_new" },
    { 0xFDC8963D, "addnotetrack_fxontag" },
    { 0x2DEEE4F0, "addnotetrack_level_notify" },
    { 0x25F1EEB7, "addnotetrack_sound" },
    { 0xE56D5E0E, "addnotetrack_stop_exploder" },
    { 0x7D51C68F, "addnoturrettrigger" },
    { 0x2D155915, "addobj" },
    { 0x74882A7F, "addofficertosquad" },
    { 0x3D4BDB47, "addoffsetontopoint" },
    { 0xAB448AF9, "addon" },
    { 0x5CF18922, "addon_attachments" },
    { 0x051219FB, "addonindex" },
    { 0x230C8CB5, "addonmask" },
    { 0x9E05F256, "addonstart_animsound" },
    { 0xC94CF02D, "addoption" },
    { 0x6980A206, "addorder" },
    { 0x291D6A0A, "addorderalias" },
    { 0x9A7AA9B1, "addorderaliasex" },
    { 0xB0C9DC7A, "addorderevent" },
    { 0x0333B943, "addpage" },
    { 0x0227C882, "addpassengerevent" },
    { 0xAE3E254B, "addpersonaldirectionalias" },
    { 0x9CDFA23E, "addphrasetohistory" },
    { 0x47CFD062, "addphysweapon" },
    { 0xEA8A9FDC, "addpiece" },
    { 0x92AE477C, "addplaneevent" },
    { 0xDA835EC6, "addplayerangle" },
    { 0xAA67C13B, "addplayerstat" },
    { 0x1BA616A5, "addplayerstatwithgametype" },
    { 0xAE5493C1, "addplayertochain" },
    { 0xF4D96DF8, "addplayertosquad" },
    { 0x694959BE, "addplayweapondamageeffectscallback" },
    { 0x6057D0F5, "addplayweapondeatheffectscallback" },
    { 0x67DD93CA, "addpowerup" },
    { 0xDA308A83, "addpreferedpoint" },
    { 0x348240BB, "addprereq" },
    { 0xA0ADD75A, "addrandomattachmenttoweaponname" },
    { 0xC4A44A78, "addrankalias" },
    { 0xFF631EE7, "addrankaliasex" },
    { 0x37B6567C, "addrankxp" },
    { 0xDDE1AC37, "addrankxpvalue" },
    { 0x0CF9B19D, "addreactionalias" },
    { 0x0F25DCC5, "addreactionevent" },
    { 0x82A30CE7, "addrecentearningstostat" },
    { 0xC4A07819, "addrecentstat" },
    { 0xB5BFE79B, "addrelativedirectionalias" },
    { 0x62C3C30D, "addresponsealias" },
    { 0x99C5CEA6, "addresponsealiasex" },
    { 0x54F42195, "addresponseevent" },
    { 0xF739E9D7, "address" },
    { 0x37EEE49C, "addressed" },
    { 0xB1C4C3A3, "addresses" },
    { 0x7877F192, "addrewindableeventtowatcher" },
    { 0x82719101, "addrightname" },
    { 0x25532CFA, "addrighttitle" },
    { 0x8A588621, "adds" },
    { 0x6F1D9E42, "addsafetyhealth" },
    { 0x312FF1CD, "addsensorgrenadearea" },
    { 0xB331E48E, "addsessstat" },
    { 0xB557A2F8, "addshutters" },
    { 0x53BA8ACE, "addsidedirectionalias" },
    { 0x263373FB, "addsituationalcombatorder" },
    { 0xB3B03F8D, "addsituationalidleorder" },
    { 0x4BAF0D83, "addsituationalorder" },
    { 0x1DD82D4C, "addspace" },
    { 0xFB07C191, "addspacesmall" },
    { 0xA597CC11, "addspawnfunc" },
    { 0x0745EA4C, "addspawnpointclassname" },
    { 0x159B2A8E, "addspawnpoints" },
    { 0x7A232BC5, "addspawnpointsinternal" },
    { 0x7C1D2265, "addspawnpointteamclassname" },
    { 0x84888D29, "addspeaker" },
    { 0x10110AAF, "addspecialiststat" },
    { 0x99029C8B, "addspecialistusedstatonconnect" },
    { 0xD1A88A64, "addsphereinfluencer" },
    { 0xC485543E, "addsquadbreadcrumbs" },
    { 0x38F5A6AD, "addstate" },
    { 0xF23BD42E, "addstraferunkill" },
    { 0xC02747D9, "addstring" },
    { 0x80256D06, "addsubleftname" },
    { 0x2976319F, "addsublefttitle" },
    { 0x8BBAA5AD, "addsubmenu" },
    { 0x7D1F8D82, "addsurfacenotetrackfxhandler" },
    { 0x653682BB, "addtagname" },
    { 0xB6ED86A6, "addtauntalias" },
    { 0xCD0896A3, "addtestcarepackage" },
    { 0x478B766B, "addtestclient" },
    { 0xD1663E4A, "addtestclients" },
    { 0x5E6430BE, "addthreatalias" },
    { 0x0CE719CD, "addthreataliasex" },
    { 0xAFEBB27E, "addthreatevent" },
    { 0x6C7BEB53, "addtimedfunction" },
    { 0x9D41C29B, "addtional" },
    { 0xD860E3A4, "addtire" },
    { 0xB10EC871, "addtoclosedlist" },
    { 0xD46E8CF7, "addtocompass" },
    { 0x4EDE0101, "addtodamageindicator" },
    { 0x309A80D2, "addtofront" },
    { 0x462F0040, "addtokillstreakcount" },
    { 0xCDAFAF10, "addtolittlebirdlist" },
    { 0xD8D637B2, "addtomissiles" },
    { 0xF19394C3, "addtonodehistory" },
    { 0x23FD3101, "addtoopenlist" },
    { 0xDE22B410, "addtoplacedturretlist" },
    { 0x15723752, "addtoplayerclasses" },
    { 0xA5F2DB52, "addtoqueue" },
    { 0xEC804F11, "addtosquad" },
    { 0x9CB290CA, "addtosystem" },
    { 0x61D3FF02, "addtowavespawner" },
    { 0x45223A5C, "addturret" },
    { 0xC00A4260, "addvec" },
    { 0x265FE1C3, "addvehicletocompass" },
    { 0xE1F7B631, "addweaponammotoclip" },
    { 0xB5084D53, "addweaponobject" },
    { 0xF061F358, "addweaponobjecttowatcher" },
    { 0x1F4288C0, "addweaponstat" },
    { 0x0ACA2747, "addzombieboxweapon" },
    { 0x7C0D5547, "adebug" },
    { 0xE7FB0679, "adelina" },
    { 0x07EB9D76, "adequately" },
    { 0xCECDCBF8, "adets" },
    { 0x362CD547, "adheres" },
    { 0x960A9F88, "adhoc_delay" },
    { 0x55329980, "adj" },
    { 0x08E3E09C, "adj_flags" },
    { 0xB0C7C70D, "adj_zone" },
    { 0x1E3EF9B9, "adj_zone_name" },
    { 0x85313CF0, "adj_zone_names" },
    { 0x3251B611, "adjacencies" },
    { 0x77BFE031, "adjacency" },
    { 0x4C80161F, "adjacent" },
    { 0x071793E0, "adjacent_zone" },
    { 0x9C9C2C8B, "adjacent_zones" },
    { 0x86CFC1F4, "adjacentgoalpos" },
    { 0xE1FDD2A3, "adjacentsquad" },
    { 0x3F6CE1D2, "adjdescs" },
    { 0x56A2AAF6, "adjflag" },
    { 0x90FB18E9, "adjflags" },
    { 0x4DC814C0, "adjsut" },
    { 0x3A6CF220, "adjust" },
    { 0x7C4C86AC, "adjust_accuracy_for_difficulty" },
    { 0x2B6C7DF0, "adjust_angle" },
    { 0xF5430B67, "adjust_angles_to_player" },
    { 0x2F151074, "adjust_bullet_cam_based_on_notetracks" },
    { 0x57AB3C9D, "adjust_damage_for_player_health" },
    { 0xDE75E0A1, "adjust_earth_height" },
    { 0xA891B4C1, "adjust_enemyoverride" },
    { 0xB9B31FDE, "adjust_enemyoverride_func" },
    { 0x5AC3FBD7, "adjust_fov_for_mature" },
    { 0xBBF297FA, "adjust_hallway_playerspeed" },
    { 0x508A4B02, "adjust_hit_vs_in" },
    { 0x904126CF, "adjust_melee_damage" },
    { 0x0E5F27CA, "adjust_placed_weapons" },
    { 0xAB1504AC, "adjust_player_horse_speed_based_on_closeness_to_goal" },
    { 0xC2449130, "adjust_player_speed" },
    { 0xB33A7AE2, "adjust_recent_stats" },
    { 0x93FFCBF3, "adjust_remaining_packicons" },
    { 0x8DB2F8E6, "adjust_side_death_dir_if_trace_fail" },
    { 0x4B31A4D2, "adjust_trigger_origin" },
    { 0x5D88E50D, "adjust_uber_prize_for_tank" },
    { 0x7C0EF2D0, "adjust_view" },
    { 0x5AF892DD, "adjust_x" },
    { 0x34F61874, "adjust_y" },
    { 0xC9CDCAE5, "adjustanimrate" },
    { 0x64B5C058, "adjustcameradirection" },
    { 0x814C5240, "adjustduration" },
    { 0xD1F79CB3, "adjusted" },
    { 0xC3ADBF52, "adjusted_duration" },
    { 0x288C3450, "adjusted_health" },
    { 0xC9E83A9E, "adjusted_t" },
    { 0x29FAC20E, "adjustedgoal" },
    { 0x258C79F0, "adjustedgoalpos" },
    { 0x0484A6E9, "adjustedhealth" },
    { 0xEB7C1767, "adjustedmaxpitchdeltachange" },
    { 0x710D35CE, "adjustedmaxyawdeltachange" },
    { 0x50917D29, "adjustedorigin" },
    { 0xA16B6EE0, "adjustible" },
    { 0xEF38A4B8, "adjusting" },
    { 0xC8891D96, "adjusting_dof_in_steiner_office" },
    { 0x1E18A8BC, "adjustment" },
    { 0x6E621B7F, "adjustments" },
    { 0x9C7826EB, "adjustments_for_solo" },
    { 0xDF6B75BB, "adjustmentstarted" },
    { 0x36614D1F, "adjustmineorigin" },
    { 0x4D4EB004, "adjustnode" },
    { 0x7BD4A659, "adjustposition" },
    { 0xA4703ADB, "adjustrecenthitlocstats" },
    { 0xBBB40CB4, "adjustrecentscores" },
    { 0xC017AE02, "adjustrecentstats" },
    { 0xAAC256CB, "adjusts" },
    { 0x52324A65, "adjustst" },
    { 0xB3144D36, "adjuststancetofaceenemyinitialize" },
    { 0xACC2A229, "adjuststancetofaceenemyterminate" },
    { 0x7018BEE3, "adjustteambotcount" },
    { 0x4550AB5B, "adjusttime" },
    { 0x27FB4E6C, "adjusttocover" },
    { 0xF0C67D32, "adjusttriggerorigin" },
    { 0x7B1275D2, "adjzone" },
    { 0x5F43F25F, "adm" },
    { 0xE6EC97FA, "admin" },
    { 0x9E7E0673, "admin_ai_pen" },
    { 0x51ED2BB0, "admin_ai_pen_strat" },
    { 0x26A3D314, "admin_back" },
    { 0x8376B3E5, "admin_bazooka_strat" },
    { 0x53E9CA4A, "admin_extra_middle_spawner" },
    { 0x889C260C, "admin_heroes_initial_cover" },
    { 0x42A103FD, "admin_heroes_initial_cover_think" },
    { 0x1AF30800, "admin_mg_guys" },
    { 0xF0FDF697, "admin_mg_guys_strat" },
    { 0xF254FA66, "admin_mg_left_threat_group" },
    { 0x4140643E, "admin_powerhouse_puzzle_door" },
    { 0xB8CBB3EB, "admin_powerhouse_puzzle_door_clip" },
    { 0x66615C9B, "admin_script_exploders" },
    { 0xEDD9D961, "admin_staircase_run_cycle" },
    { 0xCF9A2829, "admin_truck_victim" },
    { 0x7BA15630, "admin_weapons" },
    { 0x9072B5FD, "admiral" },
    { 0x7100BCFF, "admire" },
    { 0x5F644F78, "adrian" },
    { 0x0B708DC1, "ads" },
    { 0x51D2CD9A, "ads_active" },
    { 0x78EC3D6A, "ads_button_held" },
    { 0xE6062C2F, "ads_button_pressed" },
    { 0xC95788D8, "ads_changed" },
    { 0x7BED6E72, "ads_fraction" },
    { 0x2A7FEB76, "ads_loop" },
    { 0xEF70DF5B, "ads_loop_reallow_aim_assist" },
    { 0xEF2995A3, "ads_remind_text" },
    { 0x95929524, "ads_shoot_dialog" },
    { 0xFF591E05, "ads_success" },
    { 0x910A5F17, "ads_time" },
    { 0xE2630D8E, "ads_time_allowed" },
    { 0xD5926537, "ads_timer" },
    { 0x62CBDB8B, "adsbuttonaccumulate" },
    { 0xB9A85331, "adsbuttonpressed" },
    { 0x65968400, "adsdof" },
    { 0x058E87D1, "adsfrac" },
    { 0xF50A7107, "adsing" },
    { 0x7F3B063E, "adssound" },
    { 0xF8F9A565, "adssound_nexttime" },
    { 0x2882A5DD, "adssound_waittime" },
    { 0xD5DC1A01, "adudes" },
    { 0x9A4F5B51, "adudio" },
    { 0x1E91235F, "adult" },
    { 0x703E6ECF, "adult_lines" },
    { 0x0A26B7D8, "adummytargets" },
    { 0xE57838FD, "advance" },
    { 0xAF6ACB05, "advance_at_num_guys" },
    { 0x7B89FCDA, "advance_drowning_phase" },
    { 0xB92012DC, "advance_fail" },
    { 0x7C5C614D, "advance_grave_state" },
    { 0x3CE02387, "advance_nodes" },
    { 0x03ECD14D, "advance_on_notify" },
    { 0x671D7E18, "advance_pod_index" },
    { 0x0DF32BD1, "advance_retreat" },
    { 0xB5A27CCA, "advance_retreat_behavior" },
    { 0x6141357B, "advance_string" },
    { 0xFA4FFB65, "advance_then_retreat_multiple_paths" },
    { 0x53C2C01A, "advance_then_retreat_one_path" },
    { 0x1BBA8528, "advance_then_stop" },
    { 0x05E5FAAA, "advance_to_door" },
    { 0xBFA631D7, "advance_triggers" },
    { 0xBBDB61B1, "advancealleyfriendliestoend" },
    { 0x618719C3, "advanced" },
    { 0xCE670156, "advancedfinalizecratecategory" },
    { 0x5B7C9095, "advancedtraverse" },
    { 0x2D9BB20D, "advancedtraverse2" },
    { 0x2F8DE415, "advancedwindowtraverse" },
    { 0x11B586E9, "advancement" },
    { 0x1868DAF9, "advancenotifystring" },
    { 0xDA0BE359, "advanceonhidingenemy" },
    { 0x0DB3B525, "advancer" },
    { 0x171EB77F, "advancer_array" },
    { 0xE7B13ABC, "advances" },
    { 0xAE4F559F, "advances_to_node" },
    { 0xD1140CA8, "advancing" },
    { 0x01F14474, "advantage" },
    { 0x2CAB2EA0, "advertise" },
    { 0xEB1E2D3C, "advertisement" },
    { 0xAE11B0FF, "advertisements" },
    { 0x605DE20C, "advertisepercentagetimeleft" },
    { 0x32E7D4B7, "advertisment" },
    { 0xFF2324E1, "advise" },
    { 0xDDAC44F7, "advised" },
    { 0xEC6329D8, "advisory" },
    { 0x9385830D, "advnces" },
    { 0xA06C11C7, "ae" },
    { 0x0AA68E2C, "ae1" },
    { 0xBEEBE74B, "aecollection" },
    { 0x220BD753, "aeexplosions" },
    { 0x8AC971A2, "aenemy" },
    { 0x890A565D, "aenemyspawners" },
    { 0x64DFD1E7, "aerial_explosion" },
    { 0xF92CA1DF, "aerial_explosion_manager" },
    { 0x6D4D81BD, "aerial_vehicles" },
    { 0x9C1360FB, "aerial_vehicles_no_target" },
    { 0x882EE01C, "aexclude" },
    { 0x4C0630E9, "aexcluders" },
    { 0x6A37E5B5, "aexploder_trigs_mark19" },
    { 0xA16D6D31, "afaik" },
    { 0xCC0D53E7, "afap" },
    { 0x66F336BF, "afert" },
    { 0xB0795A4A, "affect" },
    { 0xAC69D804, "affect_friendlies" },
    { 0xA62FFFDD, "affected" },
    { 0xBCE93BE6, "affected_players" },
    { 0xC579B5FE, "affectedbyflare" },
    { 0x420FA4A6, "affecting" },
    { 0x92DF0185, "affects" },
    { 0xDCC6673D, "affiliation" },
    { 0xB620AB2D, "affinity" },
    { 0xC676AC30, "affirm" },
    { 0xE8F52F1B, "affirmative" },
    { 0x3DBE7FCD, "affix" },
    { 0x13C4B677, "afford" },
    { 0x283D72E8, "afg1" },
    { 0xDBD2322E, "afg1_01" },
    { 0x016A23A9, "afg1_01_render" },
    { 0x9A44E223, "afg2" },
    { 0xF3B95F77, "afg2_01" },
    { 0x7F1D6AAE, "afg2_01_render" },
    { 0x757DF210, "afg_06" },
    { 0x64403FCF, "afg_06_render" },
    { 0x334EFF88, "afghan" },
    { 0x63D9F0DB, "afghan_aigrenadeget" },
    { 0xC863B739, "afghan_autokillondist" },
    { 0x256D9ACC, "afghan_battle_start" },
    { 0x389C8016, "afghan_c4" },
    { 0x79EFB718, "afghan_fade_out" },
    { 0x78E6403B, "afghan_horse_ride" },
    { 0xA4B257FA, "afghan_ied_detonate" },
    { 0x87AF5F11, "afghan_iedthink" },
    { 0xA99EAA4F, "afghan_iedtriggerthink" },
    { 0x3708A2F9, "afghan_iedwarningradiusthink" },
    { 0xF9E9F2A9, "afghan_infantry_think" },
    { 0x4F9DC6DD, "afghan_names" },
    { 0x53B6D3E4, "afghan_outro_riders" },
    { 0x66182FC7, "afghan_outro_turret_run" },
    { 0x3407C9F8, "afghan_plant_ieds" },
    { 0x5B99AC37, "afghan_setup_devgui" },
    { 0x94F6FD20, "afghan_up" },
    { 0xCACC86ED, "afghan_watch_devgui" },
    { 0x9B2FA938, "afghan_wave2_part2" },
    { 0x0F21D8C6, "afghan_wave3_part1" },
    { 0xE81BB442, "afghani_models" },
    { 0xF52D8961, "afghanistan" },
    { 0x204CE99B, "afghanistan_allied_vehicle_death" },
    { 0x931E16EC, "afghanistan_amb" },
    { 0xB3EB7353, "afghanistan_anim" },
    { 0x1951A498, "afghanistan_ant_spawnwatch" },
    { 0xB40CE241, "afghanistan_arena_manager" },
    { 0x3EA360A3, "afghanistan_art" },
    { 0x3B4C9D8D, "afghanistan_base_threats" },
    { 0xE47C68E4, "afghanistan_blocking_done" },
    { 0xA36CC41C, "afghanistan_bp2" },
    { 0xDF95EA46, "afghanistan_convoy" },
    { 0x3B0B3583, "afghanistan_convoy_leaddeath" },
    { 0xBB9D5AC8, "afghanistan_convoy_leadupdate" },
    { 0x1524700B, "afghanistan_convoy_speedcap_trigger" },
    { 0x99D5CF6A, "afghanistan_convoy_speedcap_triggers" },
    { 0x35FA4E19, "afghanistan_convoy_stop_1" },
    { 0x5BFCC882, "afghanistan_convoy_stop_2" },
    { 0x81FF42EB, "afghanistan_convoy_stop_3" },
    { 0x76A48988, "afghanistan_convoy_vehicledamage" },
    { 0xB898B1EA, "afghanistan_convoy_watch_speed" },
    { 0xDB95F972, "afghanistan_convoydamagewatch" },
    { 0x1FF81AB9, "afghanistan_convoytriggers" },
    { 0xB03CA86B, "afghanistan_convoywatch" },
    { 0x7325F062, "afghanistan_custom_introscreen" },
    { 0xF7F7527C, "afghanistan_deserted" },
    { 0xB2439FAE, "afghanistan_enemy_vehicle_death" },
    { 0x1BC8CBDF, "afghanistan_firehorse" },
    { 0x89655CB6, "afghanistan_fx" },
    { 0x1FEA0B6D, "afghanistan_geo_changes" },
    { 0x25E51261, "afghanistan_getspawnloc" },
    { 0xA6CD1F65, "afghanistan_getspawnlocationforenemyhorses" },
    { 0x55FD07A8, "afghanistan_getspawnlocationforenemyinfantry" },
    { 0x6E3ACB70, "afghanistan_getspawnlocationforenemyrpg" },
    { 0xDA737FB1, "afghanistan_handofnodwatcher" },
    { 0x8917088E, "afghanistan_heli_path" },
    { 0xED6E811C, "afghanistan_hind_damage_watcher" },
    { 0x9A810463, "afghanistan_hind_fire_barrage" },
    { 0x7A2EFEB2, "afghanistan_hind_fire_update" },
    { 0x33EF77CD, "afghanistan_hind_movement" },
    { 0x7E36C99A, "afghanistan_hind_spawner" },
    { 0x79888869, "afghanistan_hind_spawning" },
    { 0x3DDA2926, "afghanistan_hind_think" },
    { 0x7B0EDF46, "afghanistan_horse_charge" },
    { 0x241EAC28, "afghanistan_horse_init" },
    { 0x2FEA6BF4, "afghanistan_horse_intro" },
    { 0xC25B6058, "afghanistan_horse_onoff" },
    { 0xE43E08E3, "afghanistan_horse_path" },
    { 0xA0DCB5F1, "afghanistan_ied_onoff" },
    { 0xF06B0EC7, "afghanistan_ied_warning_watch" },
    { 0xEBE880FA, "afghanistan_intro" },
    { 0x44C3B80D, "afghanistan_intro_rebel_base" },
    { 0x61A6C067, "afghanistan_krav_captured" },
    { 0x74BF34C4, "afghanistan_level_player_startfps" },
    { 0xDB64019E, "afghanistan_level_precache" },
    { 0xABF6D2C2, "afghanistan_level_scenario_one" },
    { 0x2F45EA31, "afghanistan_level_scenario_one_registerevents" },
    { 0x14363878, "afghanistan_level_setup" },
    { 0xDCB74C05, "afghanistan_missileplatform" },
    { 0x38D968BD, "afghanistan_missileplatformattack" },
    { 0x7E96CD07, "afghanistan_mission_complete_s1" },
    { 0x95B041F1, "afghanistan_outro" },
    { 0x4023011A, "afghanistan_prop_scene" },
    { 0x6A5A5D8D, "afghanistan_removespawnloc" },
    { 0x98746D4E, "afghanistan_rpg_onoff" },
    { 0x2B40C0B8, "afghanistan_setstart" },
    { 0x5758E08D, "afghanistan_setupspawnvolumes" },
    { 0x14A6C78B, "afghanistan_spawnlocthink" },
    { 0xF9472F55, "afghanistan_t72_convoy_unit" },
    { 0xAC5C9D5F, "afghanistan_t72_convoy_unit_move" },
    { 0x2E6E6E09, "afghanistan_t72_damage" },
    { 0xE7BD094C, "afghanistan_t72_death" },
    { 0xF6648855, "afghanistan_t72_vehicledamage" },
    { 0x81392475, "afghanistan_t72_waittill_turret_on_target" },
    { 0xC1B3060E, "afghanistan_t72_weapon_update" },
    { 0x7011934E, "afghanistan_truckdeathwatch" },
    { 0x05648F51, "afghanistan_truckstall" },
    { 0x12091464, "afghanistan_utility" },
    { 0x3AA4264B, "afghanistan_vehicle_ied_watch" },
    { 0x644F6551, "afghanistan_vehicle_takeoverwatch" },
    { 0x759FDDAD, "afghanistan_vehicle_think" },
    { 0x2BB97837, "afghanistan_wave_1" },
    { 0xB9B208FC, "afghanistan_wave_2" },
    { 0xDFB48365, "afghanistan_wave_3" },
    { 0x2B41EA46, "afghanistancodespawner" },
    { 0x2F85E036, "afghanstinger" },
    { 0x28BBC234, "afghanstinger_alt_name" },
    { 0x65EC7252, "afinalguys" },
    { 0x1F527C27, "afireorgs" },
    { 0x7637D7C7, "afk" },
    { 0x7881CAC1, "aflight_flag_origins" },
    { 0xE2D005D5, "afloods" },
    { 0xD2625214, "afraid" },
    { 0x9BD5D50F, "africa" },
    { 0x402C99CB, "afriendlies" },
    { 0xBA7E0D2D, "afriendlieslz" },
    { 0xA2E5FD1F, "afriendlieslzdummies" },
    { 0x390795F7, "afriendliesseaknight" },
    { 0x43BEE3D7, "afriendliesseaknightother" },
    { 0x4086E88A, "afriendliesseaknightwingman" },
    { 0x20005D17, "afriendly_support" },
    { 0x9C3A5230, "aft" },
    { 0x12990B5A, "aft_crane" },
    { 0x7E1A5BF3, "aft_crane01" },
    { 0x0C12ECB8, "aft_crane02" },
    { 0x88977A60, "aft_destructibles" },
    { 0x58F33218, "aft_explosion" },
    { 0x6A7C71F0, "aft_gun_origin" },
    { 0xCC0ED005, "aft_light" },
    { 0x2C960417, "aft_light_broken" },
    { 0x8C361563, "aft_light_target" },
    { 0x4E93D85A, "aft_radio_tower" },
    { 0xFAD58E67, "aft_radio_tower_flag" },
    { 0xA354BD93, "aft_radio_tower_start" },
    { 0xB8A4347D, "aft_railing" },
    { 0x0CDFB0DE, "aft_wire_tower" },
    { 0xF2A65A5F, "aft_wire_tower_start" },
    { 0xEA1C2F52, "aftdeck_enemies" },
    { 0x48ED5125, "after" },
    { 0x13AB737F, "after_array" },
    { 0x81514E35, "after_attack_explosion_launch_drone_1" },
    { 0x1FCFFC68, "after_burner_off" },
    { 0xCF45DB82, "after_burner_on" },
    { 0xD01D4BE5, "after_button_mash_scene" },
    { 0x39862C8C, "after_clean_room_ents" },
    { 0x6649BF1D, "after_cleaning" },
    { 0x20D2FA54, "after_gl_todo" },
    { 0x2D9DC632, "after_grass_stealth_settings" },
    { 0x94AB4808, "after_house_stealth_settings" },
    { 0x51BEDA74, "after_lerp_func" },
    { 0xCD91F46B, "after_meatshield_dof_change" },
    { 0x9FBA158E, "after_meeting_mason_driveby" },
    { 0xB22E110F, "after_russian_vo" },
    { 0x3E851E20, "after_the_attack" },
    { 0xEA6D73B6, "after_tower_think" },
    { 0xC4406FC5, "after_tower_trigger_behind" },
    { 0x9600324D, "after_tower_trigger_infront" },
    { 0x1B8D7D1E, "after_tutorial" },
    { 0x1EEFAD6E, "afterbunker" },
    { 0x493AE04B, "afterburner" },
    { 0x2ECAD25C, "afterdamagelevel" },
    { 0xF23D8E87, "afterdamageratio" },
    { 0xAC196226, "aftereffect" },
    { 0x8D089559, "aftereffects" },
    { 0xDCA23FC7, "afterlife" },
    { 0xB6EFD10F, "afterlife_add" },
    { 0xB5EBE130, "afterlife_add_fx" },
    { 0xFB6A1426, "afterlife_bleedout" },
    { 0x8F3CB77C, "afterlife_can_revive" },
    { 0x825E07FD, "afterlife_cell_door_1" },
    { 0xA8608266, "afterlife_cell_door_2" },
    { 0x6A6ECE02, "afterlife_clean_up_on_disconnect" },
    { 0x7EDCD303, "afterlife_corpse_cleanup" },
    { 0x6A85F9A4, "afterlife_corpse_create_poi" },
    { 0x66C7C5D7, "afterlife_corpse_create_pois" },
    { 0x8B5F2A01, "afterlife_corpse_get_array_poi_positions" },
    { 0xDD81F863, "afterlife_corpse_remove_pois" },
    { 0xBD0D3E3E, "afterlife_create_mana_bar" },
    { 0x771808A6, "afterlife_damage_func" },
    { 0x84E1973A, "afterlife_door_open_sesame" },
    { 0xC0486D60, "afterlife_doors_close" },
    { 0x88ACE634, "afterlife_doors_open" },
    { 0x1EF99090, "afterlife_enter" },
    { 0x67662B6E, "afterlife_fake_death" },
    { 0x1E9097FB, "afterlife_fake_revive" },
    { 0x58B1DBCF, "afterlife_gameover_cleanup" },
    { 0xF90C8A5C, "afterlife_get_spawnpoint" },
    { 0x8E61D288, "afterlife_give_loadout" },
    { 0x8C8ABFC7, "afterlife_give_loadout_override" },
    { 0x219005EC, "afterlife_hostmigration" },
    { 0xCDED34C0, "afterlife_infinite_mana" },
    { 0x734FDE56, "afterlife_interact_complete" },
    { 0x03D878BB, "afterlife_interact_dist" },
    { 0x7956AC50, "afterlife_interact_hint_trigger_create" },
    { 0x1DBBBC6C, "afterlife_interact_hint_trigger_think" },
    { 0xB1696859, "afterlife_interact_object_fx_cooldown" },
    { 0xA5CABE8B, "afterlife_interact_object_think" },
    { 0x8E238370, "afterlife_interact_reset" },
    { 0x9BFBC823, "afterlife_intro_door" },
    { 0x012E73E6, "afterlife_jump_watch" },
    { 0xB9AF9DDA, "afterlife_laststand" },
    { 0x4908C23F, "afterlife_laststand_cleanup" },
    { 0xA8204E41, "afterlife_laststand_override" },
    { 0x2019DFFF, "afterlife_leave" },
    { 0xCB79D15F, "afterlife_leave_freeze" },
    { 0xC3525D6C, "afterlife_lightning_watch" },
    { 0xB965AEF7, "afterlife_load_fx" },
    { 0x0C3A3073, "afterlife_mana_watch" },
    { 0x50A79567, "afterlife_player_damage_callback" },
    { 0xCC4C3996, "afterlife_player_damage_override" },
    { 0x80C77ED4, "afterlife_player_refill_watch" },
    { 0xCB6FC999, "afterlife_powerups" },
    { 0x7709911A, "afterlife_reduce_mana" },
    { 0xEF89AFA6, "afterlife_remove" },
    { 0x3537A1E9, "afterlife_revive_do_revive" },
    { 0xF10A849E, "afterlife_revive_hud_create" },
    { 0x1C71686F, "afterlife_revive_invincible" },
    { 0x66B315BA, "afterlife_revive_tool" },
    { 0x9115B6D8, "afterlife_revive_trigger_spawn" },
    { 0x09749FD1, "afterlife_revive_trigger_think" },
    { 0x07D9FE0F, "afterlife_revived" },
    { 0x2CB199B4, "afterlife_save_loadout" },
    { 0x8A1E7FDB, "afterlife_save_perks" },
    { 0x8FBE23BE, "afterlife_spawn_corpse" },
    { 0x43587A70, "afterlife_start_zombie_logic" },
    { 0xF795EA29, "afterlife_trigger_create" },
    { 0xC28E1CBF, "afterlife_trigger_think" },
    { 0xF0B1066C, "afterlife_trigger_used_vo" },
    { 0xC6BCEB45, "afterlife_trigger_visibility" },
    { 0x26839B78, "afterlife_trigger_visible_in_afterlife" },
    { 0x5EE2B6E0, "afterlife_tutorial" },
    { 0xEB384CE7, "afterlife_tutorial_attack_watch" },
    { 0x5D7FAE67, "afterlife_tutorial_jump_watch" },
    { 0xF05D1272, "afterlife_visionset" },
    { 0xC94DEFE7, "afterlife_weapon_limit_check" },
    { 0xA4FC0C12, "afterlife_zapped" },
    { 0x589E6BB7, "afterlife_zapped_fx" },
    { 0x59B18AEC, "afterlife_zombie_damage" },
    { 0xAEE5D686, "afterlifedeaths" },
    { 0xB7D0386F, "afterlifemedaltime" },
    { 0x9EE2E979, "afterliferound" },
    { 0x845776CB, "aftermath" },
    { 0xBD18A4FA, "aftermath_ai_setup" },
    { 0xECBD2FEE, "aftermath_amb" },
    { 0x231CCACD, "aftermath_art" },
    { 0xEA0A9D5F, "aftermath_cinematic_setup" },
    { 0xDCB7BCB4, "aftermath_fx" },
    { 0x2BB2DBB2, "aftermath_guard_walk_to_idle" },
    { 0xA4FAF275, "aftermath_huey2" },
    { 0x7EF8780C, "aftermath_huey3" },
    { 0x69E124DE, "aftermath_hueys_arrive" },
    { 0xB4ED3BA4, "aftermath_intro" },
    { 0xFF538F01, "aftermath_player" },
    { 0x57B7A096, "aftermath_scene" },
    { 0x262B09F8, "aftermath_vo1" },
    { 0x98327933, "aftermath_vo2" },
    { 0xF80EFA0F, "afternoon" },
    { 0x70F319A1, "aftersoundwaitmax" },
    { 0x1BA141DF, "aftersoundwaitmin" },
    { 0x722E48DF, "afterward" },
    { 0x64F4BF66, "afterwards" },
    { 0x72ED8A18, "afterwords" },
    { 0x0D77C1D6, "ag1" },
    { 0x77B2FDB7, "again" },
    { 0x540CEF1E, "against" },
    { 0x405DFE05, "againstent" },
    { 0x570BC6E7, "againstgroup" },
    { 0x54F6E482, "age" },
    { 0x6AEF1C22, "aged" },
    { 0x8D6074B4, "agenericfriendlies" },
    { 0x2AF0F4DC, "agent" },
    { 0x7DF1081D, "agent_init" },
    { 0x45E8E281, "agent_names" },
    { 0x47808C1F, "agents" },
    { 0xB56BD885, "agggh" },
    { 0x165CBCF5, "aggregates" },
    { 0xAAEC7951, "aggresive_navvolume_recover" },
    { 0x05776A15, "aggresivemode" },
    { 0xA05AE475, "aggress" },
    { 0x833109F3, "aggressing" },
    { 0x5358EBA9, "aggression" },
    { 0x3FF67AC9, "aggressive" },
    { 0x2BE64906, "aggressive_ai" },
    { 0xDAF32C9B, "aggressive_boost_time" },
    { 0xDB4AE405, "aggressive_mode" },
    { 0x084578EA, "aggressive_runner" },
    { 0xA130801A, "aggressive_squad_leader" },
    { 0x28965BAD, "aggressivecull" },
    { 0x98D43794, "aggressively" },
    { 0xDAC7C134, "aggressivemode" },
    { 0xCBFB9803, "aggro_anim" },
    { 0x7A456265, "aggro_distance" },
    { 0xF1E627FF, "agile" },
    { 0x3905C2F8, "ago" },
    { 0x9BA30B9B, "agr_time" },
    { 0x262DFA7D, "agreed" },
    { 0xFFC4791B, "agreement" },
    { 0xDF3551CE, "agressive" },
    { 0x9E76AB53, "agressivemode" },
    { 0x4108DA3C, "agrkills" },
    { 0xB61DFA1F, "aground" },
    { 0xA0757F47, "agroup" },
    { 0x9D47AB72, "agrouptobewarped" },
    { 0x4EDFE8C7, "aguystouchingvolume" },
    { 0xB24BDA72, "ah" },
    { 0x8111B8AC, "ahead" },
    { 0xB719E89F, "aheadteam" },
    { 0xA570EB8E, "ahero" },
    { 0x906A9C1E, "ahh" },
    { 0x060F3D12, "ahhh" },
    { 0xA68B4AD8, "ahits" },
    { 0x48C6DE74, "ahmad" },
    { 0x6D48FDD4, "ahostages" },
    { 0x288F21A4, "ahostilemovementtriggers" },
    { 0x2DE656A7, "ahostiles" },
    { 0x53BB2B68, "ahving" },
    { 0xD84E54DB, "ai" },
    { 0x9874C0E8, "ai1" },
    { 0x0A7C3023, "ai2" },
    { 0xE479B5BA, "ai3" },
    { 0x568124F5, "ai4" },
    { 0x4C6036BB, "ai_1" },
    { 0xDA58C780, "ai_2" },
    { 0x0F6AD359, "ai_2nd_floor" },
    { 0x005B41E9, "ai_3" },
    { 0xBE67A5F6, "ai_4" },
    { 0xE927658D, "ai_accuracydistscale" },
    { 0x3A90B959, "ai_actor" },
    { 0xF3FF48CE, "ai_aggressive" },
    { 0x9CB1F953, "ai_alerted" },
    { 0xC93DE2E1, "ai_alive" },
    { 0x1B823AB8, "ai_alley_apc_gunner" },
    { 0x9A8C714C, "ai_allies" },
    { 0xBE7F8E3D, "ai_allies_think" },
    { 0xE4463170, "ai_ally" },
    { 0xCA8EC086, "ai_ally_attack_think" },
    { 0x35C2B90B, "ai_ammo_throttle" },
    { 0x58D48955, "ai_ammoguy" },
    { 0x24323BB3, "ai_angle" },
    { 0x7D8D960F, "ai_angola_rescue_swim_backstroke" },
    { 0xE9B1C87A, "ai_angola_rescue_swim_tread" },
    { 0x6F222F51, "ai_anim" },
    { 0x130565B3, "ai_anim_hit" },
    { 0xE1A718CD, "ai_anim_mode" },
    { 0x29F5737D, "ai_anim_move_code" },
    { 0x01C55225, "ai_anim_move_code_nogravity" },
    { 0x7B7F9739, "ai_anim_nogravity" },
    { 0xF40C5C90, "ai_anim_nophysics" },
    { 0x217AD285, "ai_anim_point_relative" },
    { 0x5A78B003, "ai_anim_pretraversal" },
    { 0xF96EFE03, "ai_anim_slide" },
    { 0xC77BA97A, "ai_anim_unknown" },
    { 0x43435831, "ai_anim_use_angle_deltas" },
    { 0x464B38A7, "ai_anim_use_angle_deltas_noclip" },
    { 0x3101AA95, "ai_anim_use_both_deltas" },
    { 0x94DF2D63, "ai_anim_use_both_deltas_noclip" },
    { 0x4D79A04D, "ai_anim_use_both_deltas_nogravity" },
    { 0x17C66FCE, "ai_anim_use_both_deltas_zonly_physics" },
    { 0x0037250C, "ai_anim_use_pos_deltas" },
    { 0x895288F7, "ai_animate_props_on_death" },
    { 0xD887F8A0, "ai_animation" },
    { 0x0F4D924B, "ai_animations" },
    { 0x2D04FC7B, "ai_animnames" },
    { 0x72DE9B38, "ai_anims" },
    { 0xA48FE5CC, "ai_apartment_flank_blocker" },
    { 0x08E30858, "ai_arena_squad" },
    { 0x21A9A3C5, "ai_around" },
    { 0x1639B2E9, "ai_array" },
    { 0xCA0E592B, "ai_asd_idle" },
    { 0x94CADC23, "ai_asd_idle_twitch_a" },
    { 0x22C36CE8, "ai_asd_idle_twitch_b" },
    { 0x48C5E751, "ai_asd_idle_twitch_c" },
    { 0x43F73D1D, "ai_astro_explode" },
    { 0xD792C3D7, "ai_at_lvt1" },
    { 0x658B549C, "ai_at_lvt2" },
    { 0x288D79DA, "ai_attack" },
    { 0xF7B00B2B, "ai_attacker" },
    { 0x2EFEB67C, "ai_auto_death" },
    { 0x841C262D, "ai_awareness" },
    { 0xBFFFC675, "ai_axis" },
    { 0xCC14BD8E, "ai_axis_death" },
    { 0x284BAA67, "ai_axis_player_distance" },
    { 0x509D1DF8, "ai_axis_sniper_fodder" },
    { 0x065C1510, "ai_axis_think" },
    { 0x63FED003, "ai_back" },
    { 0x330F8005, "ai_back_left" },
    { 0x19CBC2E2, "ai_balcony_guy" },
    { 0x530AF381, "ai_base_runners" },
    { 0x3D5FA83E, "ai_bdog" },
    { 0x159A2981, "ai_beartrap" },
    { 0xA5A67582, "ai_beartrap_explosive_death" },
    { 0x8A0D4E3E, "ai_beartrap_explosive_radius" },
    { 0x51B99733, "ai_behavior_change" },
    { 0xBB17722A, "ai_behind" },
    { 0xF6F90FC3, "ai_billboard" },
    { 0x9D32ED19, "ai_blackboard" },
    { 0x715574C2, "ai_body" },
    { 0x267903AE, "ai_bodyguard1" },
    { 0x00768945, "ai_bodyguard2" },
    { 0x0BDD4641, "ai_bosses" },
    { 0x17A330E0, "ai_bouncer" },
    { 0x279B6C0B, "ai_breach_kick_fx" },
    { 0xD7437D64, "ai_break_holding_node_timer" },
    { 0x40591924, "ai_briggs_redshirt" },
    { 0x4621FD72, "ai_brute_force" },
    { 0x8E826EAD, "ai_brutus" },
    { 0x3D71663B, "ai_buddies_enter_bunker" },
    { 0x399EB480, "ai_buffel_gunner" },
    { 0x24ABDB74, "ai_buffer" },
    { 0x5690B3EE, "ai_buildable_trigger_think" },
    { 0x2524E4AE, "ai_burned_guy" },
    { 0x67BCA4A4, "ai_cache_guard2" },
    { 0x1ED7A46B, "ai_calculate_health" },
    { 0x52D319BF, "ai_callback" },
    { 0x6FF4AA0E, "ai_camo" },
    { 0xF8C36EE1, "ai_can_patrol" },
    { 0x20020EA7, "ai_can_plantintruder" },
    { 0x931D9ED8, "ai_can_see_player" },
    { 0x9C8D612D, "ai_captor" },
    { 0x9A753074, "ai_cart_1" },
    { 0x0C7C9FAF, "ai_cart_2" },
    { 0x03F58743, "ai_cartel" },
    { 0x8E6D5495, "ai_cartel_frantic" },
    { 0xAF648379, "ai_cartel_guard" },
    { 0xD9047EE7, "ai_caught_dead" },
    { 0xC4E8CE6C, "ai_caught_in_beartrap" },
    { 0x6515DB6E, "ai_ce_cop_2" },
    { 0x2B3A7DCE, "ai_chain_and_seek" },
    { 0x592DC1D9, "ai_change_ai_functions" },
    { 0x7D830B5E, "ai_change_behavior_function" },
    { 0x2DDF6EF9, "ai_check_other" },
    { 0x6A070CCF, "ai_chinese" },
    { 0x9FA53195, "ai_chute" },
    { 0xA5BBF619, "ai_chute_height" },
    { 0x14C918E8, "ai_civ" },
    { 0x0D3EA5B8, "ai_civ_f_idle_stand_phone1_00" },
    { 0x3B5F6303, "ai_civ_m_idle_crouch_cower_01" },
    { 0x56A1F205, "ai_civ_m_idle_stand_cower_01" },
    { 0xAA5B8C71, "ai_civ_m_idle_stand_phone1_00" },
    { 0x84C063FF, "ai_civ_m_walk_00" },
    { 0x5EBDE996, "ai_civ_m_walk_01" },
    { 0x12B8F4C4, "ai_civ_m_walk_03" },
    { 0x1157CB71, "ai_civilian" },
    { 0x3AD694E4, "ai_civilian_think" },
    { 0x71841683, "ai_civs" },
    { 0x34CDD406, "ai_class" },
    { 0x66A2F76C, "ai_classname_in_level" },
    { 0x54FC8B53, "ai_classname_in_level_keys" },
    { 0xCD8F8A5B, "ai_claw" },
    { 0x629E283B, "ai_claw_1" },
    { 0xF096B900, "ai_claw_2" },
    { 0xDEE0F472, "ai_claw_enemy_1" },
    { 0xB8DE7A09, "ai_claw_enemy_2" },
    { 0x92DBFFA0, "ai_claw_enemy_3" },
    { 0x9CED587F, "ai_claw_enemy_4" },
    { 0xD6BF201B, "ai_claw_mk2_walk_f" },
    { 0x009ABE8A, "ai_claw_mk2_warmode_touchdown" },
    { 0x0EBC2673, "ai_claw_walk_rumble" },
    { 0x352D3C0E, "ai_claymore_abortwatch" },
    { 0xFDA6049E, "ai_claymore_handle_notetracks" },
    { 0x14198A34, "ai_claymore_plant" },
    { 0xACEFC97D, "ai_claymore_plant_cleanup" },
    { 0xBB41BDD7, "ai_claymore_planted" },
    { 0xCCC19FFD, "ai_claymore_plantwatch" },
    { 0xEC3FF418, "ai_clear_custom_animation_reaction" },
    { 0x576E5A73, "ai_clear_custom_animation_reaction_and_idle" },
    { 0x264F90C4, "ai_clear_dialog" },
    { 0xA65F2EEF, "ai_clear_dialog_done" },
    { 0xAD977637, "ai_clear_dialog_last" },
    { 0xA4AD514F, "ai_clear_dialog_logic" },
    { 0x54DAB6CA, "ai_clear_dialog_logic_check" },
    { 0x7CF3340B, "ai_clear_dialog_logic_guy" },
    { 0x9A92CDC9, "ai_climb" },
    { 0x3A997F10, "ai_climber" },
    { 0x469BB0AA, "ai_close" },
    { 0x66CEC90B, "ai_closest" },
    { 0xD1E14113, "ai_closest_squadmate" },
    { 0x2904138C, "ai_collision_ent" },
    { 0x51F0E11F, "ai_comms_floor1_blue_idle" },
    { 0x78059669, "ai_comms_floor1_blue_idle_2_inspect" },
    { 0x67E7D049, "ai_comms_floor1_blue_inspect_2_idle" },
    { 0xA5C80964, "ai_comms_floor1_blue_inspect_idle" },
    { 0x3030F40D, "ai_comms_floor1_orange_idle" },
    { 0x2560AF41, "ai_computer_guy" },
    { 0xA025501D, "ai_construction_spawner_think" },
    { 0xD4C94D87, "ai_context" },
    { 0x212D7D25, "ai_contextual_guard" },
    { 0x7027EAC6, "ai_contextual_melee_comms_floor4_orange_deathpose" },
    { 0x21A16FD8, "ai_contextual_melee_garrotesit_idle" },
    { 0xE8A92A90, "ai_contextual_melee_neckstab_quick" },
    { 0x60FE1572, "ai_contextual_melee_pakistan_neckstab" },
    { 0x3831DF94, "ai_cop" },
    { 0xC9D99F8A, "ai_corpse" },
    { 0xE08A34DC, "ai_corpses_cleanup" },
    { 0x3D04CBBB, "ai_count" },
    { 0x6E9D3216, "ai_counter" },
    { 0x8BC45DCB, "ai_courtyard" },
    { 0x6F282682, "ai_cqb_walk_f_water_light" },
    { 0x63BFF342, "ai_crawl_dude" },
    { 0x5D72CFD9, "ai_crawling" },
    { 0xD35789DE, "ai_create_behavior_function" },
    { 0x0E1AFF1E, "ai_crew_buffel_driver_idle" },
    { 0x6E99BF44, "ai_crew_motorcycle_ride" },
    { 0x037CE201, "ai_crew_pickup_truck_driver_death_shot" },
    { 0x62ED6311, "ai_crew_pickup_truck_passenger_crash" },
    { 0x0213C592, "ai_crew_pickup_truck_passenger_crash_idle" },
    { 0xB410244B, "ai_crew_semi_truck_claw_1_exit" },
    { 0x084B8BA2, "ai_crew_semi_truck_claw_2_exit" },
    { 0x67B47092, "ai_crew_vtol_pilot1_idle" },
    { 0xB4DEAE6C, "ai_crosby" },
    { 0x7F8EE67F, "ai_cross_0" },
    { 0x1FCE6E45, "ai_current_user" },
    { 0xF65CE753, "ai_damage_cb" },
    { 0x3A62A856, "ai_damagearea" },
    { 0xA7924602, "ai_damagewatch" },
    { 0x76BDFD20, "ai_death" },
    { 0xD51D7814, "ai_death_collapse_in_place" },
    { 0x20D1082F, "ai_death_deadfallknee" },
    { 0x37741784, "ai_death_time" },
    { 0x198EF696, "ai_deathflag" },
    { 0x3684DE22, "ai_deathmonitor" },
    { 0x8AD41157, "ai_deathpose" },
    { 0x2EA03B31, "ai_deathwatch" },
    { 0xC4642387, "ai_debug_end_of_path" },
    { 0xCCF78722, "ai_defalco" },
    { 0x49BD72B2, "ai_defalco_escort1" },
    { 0x23BAF849, "ai_defalco_escort2" },
    { 0xDDE8E89A, "ai_defend" },
    { 0xBC9468EB, "ai_defender" },
    { 0x9F4CE144, "ai_delete_when_offscreen" },
    { 0x6F6A2143, "ai_delete_when_out_of_sight" },
    { 0xD55F33E8, "ai_detonateradius" },
    { 0x4BB87101, "ai_die_in_chamber" },
    { 0x4D2E18F8, "ai_died" },
    { 0x05736792, "ai_digbat_exposed_grenadethrowc" },
    { 0x7D107F74, "ai_digbat_run_2_stand_b" },
    { 0xE50695D0, "ai_digbat_run_2_stand_f" },
    { 0x611F5DEA, "ai_digbat_run_2_stand_l" },
    { 0x1CE8D8E4, "ai_digbat_run_2_stand_r" },
    { 0xA81DA936, "ai_director" },
    { 0xCC85B69B, "ai_disintegrate" },
    { 0x7D39A287, "ai_dismount_horse" },
    { 0x74D5E980, "ai_dive" },
    { 0x3BE93144, "ai_dive_over_40" },
    { 0xFE6340C8, "ai_dj" },
    { 0xBE0392FF, "ai_doctor" },
    { 0x2DC13B10, "ai_dog" },
    { 0xB86C3A66, "ai_dontturn" },
    { 0xE1C252F5, "ai_door_death" },
    { 0xF919C5F8, "ai_door_kick_pdf" },
    { 0x7A93857A, "ai_doorbreach_kick" },
    { 0xAD037E3C, "ai_downstairs" },
    { 0x44762FA4, "ai_driver" },
    { 0x351795BB, "ai_drone_ent_num" },
    { 0x553933A1, "ai_drone_paths" },
    { 0xECFBF3BF, "ai_drone_ready_" },
    { 0x8558320D, "ai_drone_think" },
    { 0xD75BEEC9, "ai_drop_riotshield" },
    { 0x5ABD5986, "ai_duct" },
    { 0x1BED86D6, "ai_dude" },
    { 0x531563DB, "ai_dude1" },
    { 0x87AF0949, "ai_dudes" },
    { 0xB7B4FD19, "ai_e1_base_muj_drum_burner" },
    { 0x8118807A, "ai_e1_base_muj_herder" },
    { 0x49B49843, "ai_e1_ride_vig_bridge1" },
    { 0x65371E70, "ai_e1_ride_vig_bridge1a" },
    { 0xD7AD2908, "ai_e1_ride_vig_bridge2" },
    { 0x194D3F4A, "ai_e1_ride_vig_bridge2b" },
    { 0x7618FC98, "ai_e1_ride_vig_cache_stand" },
    { 0x3B11F536, "ai_e1_ride_vig_lookout_crouch1" },
    { 0x150F7ACD, "ai_e1_ride_vig_lookout_crouch2" },
    { 0x539B332D, "ai_e1_ride_vig_lookout_stand" },
    { 0x27E8EBAC, "ai_e1_ride_vig_tank_lookout1" },
    { 0x99F05AE7, "ai_e1_ride_vig_tank_lookout2" },
    { 0x667AE6A5, "ai_e2_rooftop_extras" },
    { 0x3E78F070, "ai_e2_stairs" },
    { 0x3823C0C2, "ai_e4_roof_drop" },
    { 0xAC13DAE9, "ai_e4_roof_drop_single" },
    { 0x3070B321, "ai_e4_roof_mid" },
    { 0xFC1C1593, "ai_e5_cache_guy" },
    { 0xD186F36B, "ai_e5_cache_rpg" },
    { 0xA8824589, "ai_e5_tank_room_stair_guy" },
    { 0xCD53214D, "ai_e7_civ" },
    { 0xC225EF01, "ai_e7_civ_back" },
    { 0xE6B82F97, "ai_e7_jump_spot_guy_node" },
    { 0x3BCE7D28, "ai_elevator" },
    { 0x3B8BA92E, "ai_end_pos" },
    { 0x4A4884D2, "ai_enemies" },
    { 0x2EECD77A, "ai_enemy" },
    { 0x38D3D52A, "ai_enemy_closest" },
    { 0x97F6B165, "ai_enemy_rpd" },
    { 0xD4130247, "ai_engager" },
    { 0xEE6A3BD7, "ai_entnum" },
    { 0xD310F4A4, "ai_eq" },
    { 0xD7422935, "ai_escape_stair_guy" },
    { 0xEBC5C64B, "ai_evacuee_think" },
    { 0x8823E9CA, "ai_event" },
    { 0x95E8118F, "ai_eventdistexplosion" },
    { 0x37A61B37, "ai_exist" },
    { 0xFA09CAC9, "ai_exit_node_1" },
    { 0xDE18A93F, "ai_exit_node_7" },
    { 0xB27AE228, "ai_explosive_death" },
    { 0xBB39F556, "ai_fake_mason" },
    { 0xC344A549, "ai_fake_shoot" },
    { 0xD78D30A4, "ai_fall_from_chinook" },
    { 0x979B4905, "ai_fallback_reengage" },
    { 0x15F5E966, "ai_farid" },
    { 0x5B23F9B5, "ai_fastrope_and_die" },
    { 0x5AF8200E, "ai_fights_allowed" },
    { 0x0C09396C, "ai_firing_soldier" },
    { 0x8DF29A67, "ai_flagbearer_gunshots" },
    { 0x1CAE7566, "ai_flank_route" },
    { 0xA11291B6, "ai_flare_guy" },
    { 0xF8C30666, "ai_floodspawn_think" },
    { 0xFFF4D6D0, "ai_follow_the_leader_behavior" },
    { 0x10F83FDE, "ai_for_jeep" },
    { 0xD4F14B7F, "ai_for_truck" },
    { 0xD92A8AF2, "ai_force_fire_at_target" },
    { 0x77B99B38, "ai_foreshadow" },
    { 0x0543B3BA, "ai_found" },
    { 0x412A98C7, "ai_friendly" },
    { 0x889C8267, "ai_friendly2" },
    { 0x629A07FE, "ai_friendly3" },
    { 0xBB0A5E5D, "ai_friendly_reinforcements_think" },
    { 0x90BA857B, "ai_friendly_waittill_death" },
    { 0xB492574E, "ai_friendlyfireblockduration" },
    { 0x7A9735D5, "ai_friends" },
    { 0xD770428A, "ai_frogger" },
    { 0x75E91E4F, "ai_front" },
    { 0x77C8DCBF, "ai_front_claw" },
    { 0x5DB40F1D, "ai_functions" },
    { 0x76E68A05, "ai_g20_ss1" },
    { 0x0E049AD2, "ai_gas_death_a" },
    { 0xC1FFA600, "ai_gas_death_c" },
    { 0x5A098FA4, "ai_gas_death_g" },
    { 0x641AE883, "ai_gas_death_h" },
    { 0xEB560775, "ai_gas_room" },
    { 0x02A73172, "ai_gasguy_1" },
    { 0xDCA4B709, "ai_gasguy_2" },
    { 0xDF2EF21C, "ai_gave_up_post" },
    { 0x8ADA5A1D, "ai_generator" },
    { 0x17E0E2D1, "ai_generic" },
    { 0xC872F14B, "ai_generic_main" },
    { 0x330DFEC6, "ai_getclassification" },
    { 0x3755BB84, "ai_getgrenadetype" },
    { 0x4A9E1C47, "ai_gets_too_close_to_vulture" },
    { 0x562A8B24, "ai_giant_robot" },
    { 0x25167D6C, "ai_girl" },
    { 0x3187F984, "ai_global_init" },
    { 0xB75B4D97, "ai_goal" },
    { 0x69D05B20, "ai_goto_lvt" },
    { 0x04D8A6D0, "ai_goto_trap_radius" },
    { 0xE45DC5BF, "ai_gotopoint" },
    { 0x8AD00D27, "ai_gravity_throttle" },
    { 0xB5CCD623, "ai_grenades" },
    { 0x5D9E4A9F, "ai_group" },
    { 0x39D51777, "ai_group_1" },
    { 0xC7CDA83C, "ai_group_2" },
    { 0x4F0FF8D7, "ai_group_count" },
    { 0xBDDBE3F4, "ai_group_died" },
    { 0x79848D41, "ai_group_get_num_killed" },
    { 0x0E4EF337, "ai_group_name" },
    { 0x8C3782A1, "ai_guard" },
    { 0x47BB3365, "ai_guard_1" },
    { 0x6DBDADCE, "ai_guard_2" },
    { 0x661E1F76, "ai_gulliver" },
    { 0xDFB53DE7, "ai_gunner" },
    { 0x4B759ECC, "ai_gunner1" },
    { 0xBD7D0E07, "ai_gunner2" },
    { 0xFF5AEFD4, "ai_gunner_deathfunction" },
    { 0x63E0CA3E, "ai_gunner_think" },
    { 0x78080F8F, "ai_guy" },
    { 0xE3D824AD, "ai_guy0" },
    { 0xBDD5AA44, "ai_guy1" },
    { 0x2FDD197F, "ai_guy2" },
    { 0x09DA9F16, "ai_guy3" },
    { 0x4BCE3B09, "ai_guy4" },
    { 0x25CBC0A0, "ai_guy5" },
    { 0x97D32FDB, "ai_guy6" },
    { 0x8A793956, "ai_guys" },
    { 0xE272E91C, "ai_hack_stand" },
    { 0xC5976C01, "ai_hallway_coughing" },
    { 0x8F3C1C68, "ai_hallway_surgeon" },
    { 0x91AEBFBB, "ai_hallway_victim_killer" },
    { 0x7B6006EB, "ai_han" },
    { 0x9D9317C0, "ai_hangar_pdf" },
    { 0xDDCF1C3D, "ai_hangar_seal" },
    { 0xFFA0FC44, "ai_harper" },
    { 0x87FD99C0, "ai_hasprimaryweapon" },
    { 0xF0DD3768, "ai_hassecondaryweapon" },
    { 0x7B8A83CB, "ai_hassidearm" },
    { 0xBA63D897, "ai_heat_highlighted_constant_size" },
    { 0x27E203A6, "ai_hero" },
    { 0x7F007866, "ai_horse_death_launch_vector" },
    { 0xFCFD0635, "ai_horse_killer" },
    { 0x0664533E, "ai_horse_ride" },
    { 0x8FACA2AA, "ai_horse_rider_aim_f_2" },
    { 0xDBB1977C, "ai_horse_rider_aim_f_4" },
    { 0x01B411E5, "ai_horse_rider_aim_f_5" },
    { 0x27B68C4E, "ai_horse_rider_aim_f_6" },
    { 0x1393DA90, "ai_horse_rider_aim_f_8" },
    { 0x984873B4, "ai_horse_rider_aim_f_fire" },
    { 0xF5ACEF8C, "ai_horse_rider_aim_l_2" },
    { 0xA9A7FABA, "ai_horse_rider_aim_l_4" },
    { 0xCFAA7523, "ai_horse_rider_aim_l_5" },
    { 0x5DA305E8, "ai_horse_rider_aim_l_6" },
    { 0x119E1116, "ai_horse_rider_aim_l_8" },
    { 0x196E5D46, "ai_horse_rider_aim_l_fire" },
    { 0x1551681E, "ai_horse_rider_aim_r_2" },
    { 0x314289A8, "ai_horse_rider_aim_r_4" },
    { 0x57450411, "ai_horse_rider_aim_r_5" },
    { 0x7D477E7A, "ai_horse_rider_aim_r_6" },
    { 0x9938A004, "ai_horse_rider_aim_r_8" },
    { 0x40DA93D0, "ai_horse_rider_aim_r_fire" },
    { 0x0F047EF2, "ai_horse_rider_canter_aim_f_2" },
    { 0x5B0973C4, "ai_horse_rider_canter_aim_f_4" },
    { 0x810BEE2D, "ai_horse_rider_canter_aim_f_5" },
    { 0xA70E6896, "ai_horse_rider_canter_aim_f_6" },
    { 0xF3135D68, "ai_horse_rider_canter_aim_f_8" },
    { 0xCCBC6B7C, "ai_horse_rider_canter_aim_f_fire" },
    { 0x870AE464, "ai_horse_rider_canter_aim_l_2" },
    { 0x3B05EF92, "ai_horse_rider_canter_aim_l_4" },
    { 0x610869FB, "ai_horse_rider_canter_aim_l_5" },
    { 0xEF00FAC0, "ai_horse_rider_canter_aim_l_6" },
    { 0x0323AC7E, "ai_horse_rider_canter_aim_l_8" },
    { 0xF0D91E5E, "ai_horse_rider_canter_aim_l_fire" },
    { 0x94A94466, "ai_horse_rider_canter_aim_r_2" },
    { 0xB09A65F0, "ai_horse_rider_canter_aim_r_4" },
    { 0xD69CE059, "ai_horse_rider_canter_aim_r_5" },
    { 0xFC9F5AC2, "ai_horse_rider_canter_aim_r_6" },
    { 0x78B822DC, "ai_horse_rider_canter_aim_r_8" },
    { 0xB12D97F8, "ai_horse_rider_canter_aim_r_fire" },
    { 0xC0872D13, "ai_horse_rider_canter_f" },
    { 0x161AAAE8, "ai_horse_rider_canter_left" },
    { 0x36E282B7, "ai_horse_rider_canter_right" },
    { 0x02D192CD, "ai_horse_rider_death_galloping" },
    { 0xD31209CA, "ai_horse_rider_death_galloping_faceplant" },
    { 0xB0E41A6F, "ai_horse_rider_death_standing_fast" },
    { 0xD5502F5E, "ai_horse_rider_death_standing_slow" },
    { 0x1AAA71F8, "ai_horse_rider_eat_idle" },
    { 0xD30FEA8F, "ai_horse_rider_eat_idle_b" },
    { 0xCF081013, "ai_horse_rider_eat_idle_b_to_eat_idle" },
    { 0xF0566B85, "ai_horse_rider_eat_idle_b_to_stand_idle" },
    { 0xE9E27CA7, "ai_horse_rider_eat_idle_b_twitch_a" },
    { 0x77DB0D6C, "ai_horse_rider_eat_idle_b_twitch_b" },
    { 0x9DDD87D5, "ai_horse_rider_eat_idle_b_twitch_c" },
    { 0x97A9882B, "ai_horse_rider_eat_idle_to_eat_idle_b" },
    { 0x9E26C836, "ai_horse_rider_eat_idle_to_stand_idle" },
    { 0x9C0DFA1B, "ai_horse_rider_eat_idle_to_wide_idle" },
    { 0x77EB3E4E, "ai_horse_rider_eat_idle_twitch_a" },
    { 0x51E8C3E5, "ai_horse_rider_eat_idle_twitch_b" },
    { 0xF3F80107, "ai_horse_rider_forward_idle" },
    { 0x5682B38B, "ai_horse_rider_forward_idle_to_eat_idle" },
    { 0x54087753, "ai_horse_rider_forward_idle_to_right_idle" },
    { 0x1852E5ED, "ai_horse_rider_forward_idle_to_stand_idle" },
    { 0xBFCC5D78, "ai_horse_rider_frisky_idle" },
    { 0xE31EAC9B, "ai_horse_rider_frisky_idle_to_wide_idle" },
    { 0x63BDC8CE, "ai_horse_rider_frisky_idle_twitch_a" },
    { 0x3DBB4E65, "ai_horse_rider_frisky_idle_twitch_b" },
    { 0x17B8D3FC, "ai_horse_rider_frisky_idle_twitch_c" },
    { 0x1F04F02F, "ai_horse_rider_get_off_combat_leftside" },
    { 0xDCE49C70, "ai_horse_rider_get_off_combat_rightside" },
    { 0x79E27798, "ai_horse_rider_get_off_leftside" },
    { 0x9B0CCF15, "ai_horse_rider_get_off_rightside" },
    { 0x77149F93, "ai_horse_rider_get_on_combat_leftside" },
    { 0x4373F4AC, "ai_horse_rider_get_on_combat_rightside" },
    { 0x42AE2AB4, "ai_horse_rider_get_on_leftside" },
    { 0x11591389, "ai_horse_rider_get_on_rightside" },
    { 0x452A86D6, "ai_horse_rider_hitwall" },
    { 0x212BA4F0, "ai_horse_rider_idle_turn_l" },
    { 0xD526B01E, "ai_horse_rider_idle_turn_r" },
    { 0x9BD77FB4, "ai_horse_rider_jump_init" },
    { 0xBCDB6BBE, "ai_horse_rider_jump_land_from_above" },
    { 0xAC8510F0, "ai_horse_rider_jump_midair" },
    { 0xB52B4A41, "ai_horse_rider_rearback_nofall" },
    { 0x1108D018, "ai_horse_rider_right_idle" },
    { 0x53CE48EB, "ai_horse_rider_right_idle_to_forward_idle" },
    { 0x0EC35916, "ai_horse_rider_right_idle_to_stand_idle" },
    { 0x923292A1, "ai_horse_rider_sprint_aim_f_2" },
    { 0x76417117, "ai_horse_rider_sprint_aim_f_4" },
    { 0x503EF6AE, "ai_horse_rider_sprint_aim_f_5" },
    { 0x2A3C7C45, "ai_horse_rider_sprint_aim_f_6" },
    { 0xAE23B42B, "ai_horse_rider_sprint_aim_f_8" },
    { 0xC6A863A5, "ai_horse_rider_sprint_aim_f_fire" },
    { 0x2C3245BF, "ai_horse_rider_sprint_aim_l_2" },
    { 0x48236749, "ai_horse_rider_sprint_aim_l_4" },
    { 0x2220ECE0, "ai_horse_rider_sprint_aim_l_5" },
    { 0x94285C1B, "ai_horse_rider_sprint_aim_l_6" },
    { 0x10412435, "ai_horse_rider_sprint_aim_l_8" },
    { 0x7766F16B, "ai_horse_rider_sprint_aim_l_fire" },
    { 0x130DAB4D, "ai_horse_rider_sprint_aim_r_2" },
    { 0xC708B67B, "ai_horse_rider_sprint_aim_r_4" },
    { 0xA1063C12, "ai_horse_rider_sprint_aim_r_5" },
    { 0x7B03C1A9, "ai_horse_rider_sprint_aim_r_6" },
    { 0x8F267367, "ai_horse_rider_sprint_aim_r_8" },
    { 0x7BDA6349, "ai_horse_rider_sprint_aim_r_fire" },
    { 0xC9A69EF0, "ai_horse_rider_sprint_explosive_death_fly_back_a" },
    { 0x3BAE0E2B, "ai_horse_rider_sprint_explosive_death_fly_back_b" },
    { 0x2853618C, "ai_horse_rider_sprint_explosive_death_fly_forward_a" },
    { 0x9A5AD0C7, "ai_horse_rider_sprint_explosive_death_fly_forward_b" },
    { 0x7458565E, "ai_horse_rider_sprint_explosive_death_fly_forward_c" },
    { 0xB64BF251, "ai_horse_rider_sprint_explosive_death_fly_forward_d" },
    { 0x904977E8, "ai_horse_rider_sprint_explosive_death_fly_forward_e" },
    { 0x0250E723, "ai_horse_rider_sprint_explosive_death_fly_forward_f" },
    { 0x8567A9F6, "ai_horse_rider_sprint_explosive_death_fly_left_a" },
    { 0x0D97A459, "ai_horse_rider_sprint_explosive_death_fly_right_a" },
    { 0x0EACD2A8, "ai_horse_rider_sprint_f" },
    { 0xDCA07021, "ai_horse_rider_sprint_f_rally_a" },
    { 0x02A2EA8A, "ai_horse_rider_sprint_f_rally_b" },
    { 0x28A564F3, "ai_horse_rider_sprint_f_rally_c" },
    { 0x100026C1, "ai_horse_rider_sprint_left" },
    { 0x81D039AC, "ai_horse_rider_sprint_right" },
    { 0x343CC5CA, "ai_horse_rider_stand_idle" },
    { 0xFF6AF72E, "ai_horse_rider_stand_idle_to_eat_idle" },
    { 0xFC9F24D9, "ai_horse_rider_stand_idle_to_forward_idle" },
    { 0xD43CB2AE, "ai_horse_rider_stand_idle_to_right_idle" },
    { 0x2F5FE69D, "ai_horse_rider_stand_idle_to_wide_idle" },
    { 0x473D509C, "ai_horse_rider_stand_idle_twitch_a" },
    { 0xD96795A2, "ai_horse_rider_trot_aim_f_2" },
    { 0x256C8A74, "ai_horse_rider_trot_aim_f_4" },
    { 0x4B6F04DD, "ai_horse_rider_trot_aim_f_5" },
    { 0x71717F46, "ai_horse_rider_trot_aim_f_6" },
    { 0xBD767418, "ai_horse_rider_trot_aim_f_8" },
    { 0x47838DCC, "ai_horse_rider_trot_aim_f_fire" },
    { 0x52AB2F94, "ai_horse_rider_trot_aim_l_2" },
    { 0x06A63AC2, "ai_horse_rider_trot_aim_l_4" },
    { 0x2CA8B52B, "ai_horse_rider_trot_aim_l_5" },
    { 0xBAA145F0, "ai_horse_rider_trot_aim_l_6" },
    { 0xCEC3F7AE, "ai_horse_rider_trot_aim_l_8" },
    { 0x13DFFFAE, "ai_horse_rider_trot_aim_l_fire" },
    { 0x9DA275B6, "ai_horse_rider_trot_aim_r_2" },
    { 0xB9939740, "ai_horse_rider_trot_aim_r_4" },
    { 0xDF9611A9, "ai_horse_rider_trot_aim_r_5" },
    { 0x05988C12, "ai_horse_rider_trot_aim_r_6" },
    { 0x81B1542C, "ai_horse_rider_trot_aim_r_8" },
    { 0xDA670828, "ai_horse_rider_trot_aim_r_fire" },
    { 0x816D0F63, "ai_horse_rider_trot_f" },
    { 0x1C4426F8, "ai_horse_rider_trot_left" },
    { 0xB74E6007, "ai_horse_rider_trot_right" },
    { 0x729C05E2, "ai_horse_rider_walk_aim_f_2" },
    { 0xBEA0FAB4, "ai_horse_rider_walk_aim_f_4" },
    { 0xE4A3751D, "ai_horse_rider_walk_aim_f_5" },
    { 0x0AA5EF86, "ai_horse_rider_walk_aim_f_6" },
    { 0x56AAE458, "ai_horse_rider_walk_aim_f_8" },
    { 0x2309C08C, "ai_horse_rider_walk_aim_f_fire" },
    { 0x052C54D4, "ai_horse_rider_walk_aim_l_2" },
    { 0xB9276002, "ai_horse_rider_walk_aim_l_4" },
    { 0xDF29DA6B, "ai_horse_rider_walk_aim_l_5" },
    { 0x6D226B30, "ai_horse_rider_walk_aim_l_6" },
    { 0x81451CEE, "ai_horse_rider_walk_aim_l_8" },
    { 0x996E396E, "ai_horse_rider_walk_aim_l_fire" },
    { 0x36D6E5F6, "ai_horse_rider_walk_aim_r_2" },
    { 0x52C80780, "ai_horse_rider_walk_aim_r_4" },
    { 0x78CA81E9, "ai_horse_rider_walk_aim_r_5" },
    { 0x9ECCFC52, "ai_horse_rider_walk_aim_r_6" },
    { 0x1AE5C46C, "ai_horse_rider_walk_aim_r_8" },
    { 0xB5ED3AE8, "ai_horse_rider_walk_aim_r_fire" },
    { 0x5AB04DC7, "ai_horse_rider_walk_b" },
    { 0xC2A66423, "ai_horse_rider_walk_f" },
    { 0x51498CB8, "ai_horse_rider_walk_left" },
    { 0xAE24D0C7, "ai_horse_rider_walk_right" },
    { 0x5578A197, "ai_horse_rider_wide_idle" },
    { 0x3A3DA924, "ai_horse_rider_wide_idle_to_forward_idle" },
    { 0x8340DA75, "ai_horse_rider_wide_idle_to_frisky_idle" },
    { 0x1C3220E3, "ai_horse_rider_wide_idle_to_right_idle" },
    { 0x6B9A2D7F, "ai_horse_rider_wide_idle_twitch_a" },
    { 0xA49F5987, "ai_hostile_knife_kill_abort_think" },
    { 0x91A7C3A3, "ai_hostile_knife_kill_finish_anim" },
    { 0x747C6544, "ai_hostile_knife_kill_think" },
    { 0x0E83D60D, "ai_hostile_think" },
    { 0x94F05121, "ai_hostiles_bmp_bridge" },
    { 0x18BD0197, "ai_hudson" },
    { 0x5959DC32, "ai_huey_pilot1_idle_loop1" },
    { 0xDAC5D616, "ai_human_shield_think" },
    { 0xBD7D4D2C, "ai_idle" },
    { 0x90095E44, "ai_ied_handle_notetracks" },
    { 0x307A6B96, "ai_ied_plant" },
    { 0xE6875143, "ai_ied_plant_cleanup" },
    { 0x5E6D961C, "ai_ied_plant_post_func" },
    { 0xA6FCF87D, "ai_ignore_housemg_guy" },
    { 0x671BD50B, "ai_ignoreme_think" },
    { 0x47ADAE93, "ai_ignoreme_think2" },
    { 0x3005A1B5, "ai_in_boundry" },
    { 0xC5549079, "ai_in_elevator_damage_check" },
    { 0x0A93A028, "ai_in_ruin" },
    { 0x7E345932, "ai_in_scene" },
    { 0x24E1D7CF, "ai_in_scene1" },
    { 0x79C1DFDD, "ai_in_volume_chase_player" },
    { 0x9D1154B2, "ai_index" },
    { 0xDD98819E, "ai_info" },
    { 0xBD1C0448, "ai_init" },
    { 0x50442C7A, "ai_initalize_equipment" },
    { 0x6C2F3BF8, "ai_initialize" },
    { 0xD040CAB2, "ai_inside" },
    { 0x1BBB25AB, "ai_interface" },
    { 0x9D757CB3, "ai_intro_pdf" },
    { 0x0AA31123, "ai_intro_pdf_1" },
    { 0xC080B33B, "ai_intro_pdf_retreat" },
    { 0x34661507, "ai_intruder_handle_notetracks" },
    { 0x996F65A1, "ai_intruder_plant" },
    { 0x11C38D0F, "ai_intruder_plant_attempt" },
    { 0x4B586360, "ai_intruder_plant_cleanup" },
    { 0x71B202E7, "ai_invulnerable" },
    { 0xE2E43FE9, "ai_is_near_teammates" },
    { 0xE3236A37, "ai_isaac" },
    { 0x531857F7, "ai_isi" },
    { 0x724D3746, "ai_isselectable" },
    { 0xDD583334, "ai_istakeoverpossible" },
    { 0x0373111D, "ai_it_manager" },
    { 0x534DAD4C, "ai_jetpack" },
    { 0x4FCAC199, "ai_jetpack_ally_attack_think" },
    { 0x8264CBCF, "ai_jetpacks" },
    { 0x932C3B53, "ai_jetwing_avoid_fire" },
    { 0x100CB2CD, "ai_jetwing_damage_override" },
    { 0xD95AB62D, "ai_jetwing_death" },
    { 0x38DD7D5A, "ai_jetwing_follow" },
    { 0x37B29567, "ai_jetwing_think" },
    { 0x3A3B068A, "ai_karma" },
    { 0x628B807B, "ai_keep_distancefromconvoy" },
    { 0xAF6B04CE, "ai_ladder" },
    { 0xB202FE0B, "ai_ladder_entry" },
    { 0xA8E85281, "ai_land" },
    { 0xF48F436E, "ai_landed" },
    { 0x127CE10E, "ai_landing_jetwing_speed" },
    { 0x4B49149B, "ai_landing_jetwing_think" },
    { 0xCB380B63, "ai_landing_jetwing_think2" },
    { 0x04379152, "ai_last" },
    { 0x08341B29, "ai_laststand_on_death" },
    { 0x6B11ED02, "ai_launcher" },
    { 0xF6817271, "ai_leaper" },
    { 0x7C8118BE, "ai_learjet_rpg_seal_2" },
    { 0x950EC810, "ai_left_lobby_guy" },
    { 0x8D63A103, "ai_lift_guard" },
    { 0x161E6DAA, "ai_list" },
    { 0x3D5F6460, "ai_logic" },
    { 0x96D2AB7C, "ai_low_engage_dist_think" },
    { 0x5CCAC710, "ai_lvt" },
    { 0x25CF9599, "ai_magicbulletshield_think" },
    { 0x729BE479, "ai_magicbulletshield_think2" },
    { 0x1E0046B5, "ai_mantle_on_56" },
    { 0x5479EBB1, "ai_mantle_over_36_down_90" },
    { 0xEDA48710, "ai_mantle_window_36_run" },
    { 0xF1184C5D, "ai_mantle_window_dive_36" },
    { 0xEFF8A313, "ai_mantler" },
    { 0xD2ECFC8E, "ai_market" },
    { 0x0C11D320, "ai_mason" },
    { 0x84419214, "ai_mason_casual" },
    { 0xF68FB3C9, "ai_mason_kill_guard" },
    { 0x0AAA01B2, "ai_maximus" },
    { 0xEA18545B, "ai_meatshield_angola_hostage_back" },
    { 0xEE431ADE, "ai_meatshield_angola_hostage_back_to_backleft" },
    { 0xC0348B95, "ai_meatshield_angola_hostage_back_to_backright" },
    { 0x78C3431C, "ai_meatshield_angola_hostage_backleft" },
    { 0x54348F1E, "ai_meatshield_angola_hostage_backleft_to_back" },
    { 0xE3AC9E73, "ai_meatshield_angola_hostage_backright" },
    { 0xC1F1E241, "ai_meatshield_angola_hostage_backright_to_back" },
    { 0x99C3DD59, "ai_mechz" },
    { 0xCE74110C, "ai_melee_r_attack" },
    { 0xB8926D84, "ai_melee_r_defend" },
    { 0x4B7DB2C4, "ai_menendez" },
    { 0x200F17CE, "ai_message_handler" },
    { 0xC217F7C6, "ai_mh_intro" },
    { 0x025FA37B, "ai_mine" },
    { 0x36CD8F22, "ai_mine_dist" },
    { 0x15BAC61B, "ai_mode" },
    { 0x23432318, "ai_molotov" },
    { 0x34753960, "ai_molotov_guy" },
    { 0xB6FDD89A, "ai_motorcycle_death_launch_vector" },
    { 0x73627923, "ai_mount_horse" },
    { 0xF1C50613, "ai_mount_immediate" },
    { 0xD67675C7, "ai_move_down_tether" },
    { 0x0F2F0EDD, "ai_move_in" },
    { 0x4D0161D0, "ai_mpla" },
    { 0xA3EFF7BA, "ai_mpla_array" },
    { 0x52586552, "ai_muj" },
    { 0x7D50A07B, "ai_name" },
    { 0x45D98E1A, "ai_names" },
    { 0x48C62AC2, "ai_naviage_thru_hallway" },
    { 0x5F359CF2, "ai_navy" },
    { 0xEFAAF29D, "ai_near_pool" },
    { 0xA84D2833, "ai_need_teleported" },
    { 0x114559C7, "ai_neutral" },
    { 0x50F92F3F, "ai_no_dodge" },
    { 0xE59E3100, "ai_node_user" },
    { 0xF2620BE5, "ai_nodebeforecolor_think" },
    { 0x948695D1, "ai_noriega" },
    { 0x64D7187B, "ai_noriega_run" },
    { 0x3CDCD6F1, "ai_not_planting" },
    { 0xCA120297, "ai_noteworthy" },
    { 0x702254ED, "ai_notify" },
    { 0xBB3176D5, "ai_notify_complete" },
    { 0x159B20CE, "ai_num" },
    { 0xF46C12ED, "ai_number" },
    { 0xC49F4360, "ai_occupier" },
    { 0x6479D26D, "ai_on_flashed" },
    { 0xFE4EF4DD, "ai_on_ground" },
    { 0x4E1268B9, "ai_on_long_death" },
    { 0x2A811135, "ai_open_door" },
    { 0x93F67B7D, "ai_optimization" },
    { 0x432E5957, "ai_owner" },
    { 0x3304F47A, "ai_pain" },
    { 0xA1FC8492, "ai_pain_falling" },
    { 0x706AC93D, "ai_paper_burner_1" },
    { 0x966D43A6, "ai_paper_burner_2" },
    { 0x1FAF0EC5, "ai_parasite" },
    { 0xF3831826, "ai_passenger" },
    { 0x40F5FD68, "ai_patrol" },
    { 0x909A0FE1, "ai_patrol_arraycompact" },
    { 0x2216C957, "ai_patrol_enter" },
    { 0x7B08AFBF, "ai_patrol_exit" },
    { 0xC6AE1DAA, "ai_patrol_return_to_combat" },
    { 0xD2B51451, "ai_patroller" },
    { 0xE2B3518E, "ai_patroller_b" },
    { 0x73D4E943, "ai_patroller_b1" },
    { 0x01CD7A08, "ai_patroller_b2" },
    { 0xE7C93F7D, "ai_patrolwalk_angola_gunup_idle" },
    { 0x09FA3661, "ai_patrolwalk_angola_gunup_start" },
    { 0x106A0D4B, "ai_patrolwalk_angola_gunup_stop" },
    { 0x0F51981F, "ai_patrolwalk_angola_gunup_twitcha" },
    { 0xE0F283BD, "ai_pby_gunner_sort_targets_by_angle" },
    { 0xFDD8384C, "ai_pby_gunner_sort_targets_by_dist" },
    { 0xC2165051, "ai_pby_gunner_target_strip_pbys" },
    { 0x5A8C03EE, "ai_pby_gunners_acquire_targets" },
    { 0xCD0A98E1, "ai_pby_gunners_think" },
    { 0x532973E7, "ai_pby_sort_targets" },
    { 0x62077B40, "ai_pdf" },
    { 0xA8FDFAA1, "ai_pdf_4" },
    { 0x23A9D994, "ai_pdf_guy_1" },
    { 0x95B148CF, "ai_pdf_guy_2" },
    { 0x4E1408A2, "ai_pdf_hangar" },
    { 0xAB0C06EC, "ai_pdf_redshirt" },
    { 0xB40E3255, "ai_picks_destination" },
    { 0x239BE310, "ai_pilot" },
    { 0x5A6273A6, "ai_pilot_prethink" },
    { 0xA865E0B9, "ai_pilot_think" },
    { 0xCDC74E4A, "ai_pilots_think" },
    { 0xC912BA53, "ai_plant_attempt" },
    { 0x5B5DAFBC, "ai_plant_claymore" },
    { 0xB03ADA18, "ai_plant_network_intruder" },
    { 0x223CD85C, "ai_player_seek" },
    { 0x64676037, "ai_player_squad_think" },
    { 0x21968782, "ai_pmc" },
    { 0x2E43C16F, "ai_poi_near_watch" },
    { 0xEE88753C, "ai_pool_1" },
    { 0x608FE477, "ai_pool_2" },
    { 0x5A68FCB4, "ai_pool_guy_1" },
    { 0xCC706BEF, "ai_pool_guy_2" },
    { 0xF492D42E, "ai_postinitialize" },
    { 0x4B95721C, "ai_potential" },
    { 0xA99362FB, "ai_potential_climber" },
    { 0x78E0362D, "ai_pov_claw" },
    { 0xA63F10A3, "ai_preinitialize" },
    { 0xB0788181, "ai_preload" },
    { 0xEBDC4F9F, "ai_print" },
    { 0x2AC758E7, "ai_ptboat_lead_target" },
    { 0x198C9A8C, "ai_ptboat_spotlight_think" },
    { 0x0F0459AC, "ai_ptboat_turret_think" },
    { 0x0F3409C5, "ai_pull_chute" },
    { 0x08AD0988, "ai_puppet" },
    { 0xF2DD2384, "ai_puppet_cursor_tracker" },
    { 0x8FF36683, "ai_puppet_highlighting" },
    { 0xD945ECE4, "ai_puppet_manager" },
    { 0xDFB7841A, "ai_puppet_release" },
    { 0x39AB2879, "ai_puppet_set" },
    { 0x3693A618, "ai_puppet_target" },
    { 0x990DFBC6, "ai_puppet_target_normal" },
    { 0x43B65C54, "ai_puppeteer" },
    { 0x4593BB21, "ai_puppeteer_active" },
    { 0x129E7DBD, "ai_puppeteer_create_hud" },
    { 0xBC039EF5, "ai_puppeteer_destroy_hud" },
    { 0x4EAB9D66, "ai_puppeteer_highlight_ai" },
    { 0x8B606100, "ai_puppeteer_highlight_node" },
    { 0xC735BDCE, "ai_puppeteer_highlight_point" },
    { 0x44C88588, "ai_puppeteer_render_ai" },
    { 0x2FA9FE42, "ai_puppeteer_render_node" },
    { 0x7B8254E4, "ai_puppeteer_render_point" },
    { 0x54D4B3F8, "ai_puppeteer_shared" },
    { 0x7411F79B, "ai_push_player_on_double_stairs" },
    { 0x54CCE059, "ai_quadrotor_goal" },
    { 0x42C1D71F, "ai_ragdoll" },
    { 0xF1AA17AD, "ai_rage_behaviour" },
    { 0x003FA6E7, "ai_random" },
    { 0xD763525B, "ai_rappel_karma_01" },
    { 0x655BE320, "ai_rappel_karma_02" },
    { 0x6D203BD9, "ai_rappel_run_away" },
    { 0x1F16EC34, "ai_rappel_run_to_target" },
    { 0x098AFCF7, "ai_rappeller" },
    { 0x18359BB7, "ai_reached_trap_radius" },
    { 0xE6F91059, "ai_reacquire_player" },
    { 0x1406F8BA, "ai_rebel_leader" },
    { 0xEC580042, "ai_redirect" },
    { 0x7AA01FFD, "ai_redshirt" },
    { 0x80E83A4E, "ai_redshirt1" },
    { 0x5AE5BFE5, "ai_redshirt2" },
    { 0xB1781D81, "ai_ref" },
    { 0x9B5C44DA, "ai_remote_missile_fof_outline" },
    { 0xC6890D7A, "ai_rescue_seals" },
    { 0x2BB617F3, "ai_retreat" },
    { 0x7DA4A6AE, "ai_retreater" },
    { 0x230FD772, "ai_ride_and_shoot" },
    { 0xA426ED29, "ai_ride_and_shoot_aim_idle" },
    { 0x93777FAC, "ai_ride_and_shoot_aim_time" },
    { 0x885447F8, "ai_ride_and_shoot_aiming_on" },
    { 0xF910743D, "ai_ride_and_shoot_damage_override" },
    { 0xB5AE947D, "ai_ride_and_shoot_death" },
    { 0xEBFE04CC, "ai_ride_and_shoot_exit_vehicle" },
    { 0xAE7B9D19, "ai_ride_and_shoot_gun_blindfire" },
    { 0xAB36FFBB, "ai_ride_and_shoot_gun_pullout" },
    { 0x10DABA35, "ai_ride_and_shoot_gun_putaway" },
    { 0x6B742E35, "ai_ride_and_shoot_gun_shoot" },
    { 0x3F0D87A3, "ai_ride_and_shoot_idle" },
    { 0x2E08D375, "ai_ride_and_shoot_jump" },
    { 0x7F5C9C55, "ai_ride_and_shoot_lean" },
    { 0x6E967DC6, "ai_ride_and_shoot_linkto_bike" },
    { 0x45E48440, "ai_ride_and_shoot_linkto_horse" },
    { 0xECC48B02, "ai_ride_and_shoot_noncombat" },
    { 0xC46366FD, "ai_ride_and_shoot_pain" },
    { 0x524C240D, "ai_ride_and_shoot_ragdoll_death" },
    { 0x2AE45CC8, "ai_ride_and_shoot_set_death_anim" },
    { 0x9AC033C9, "ai_ride_and_shoot_stop" },
    { 0xCF89A411, "ai_ride_and_shoot_watch_jump" },
    { 0x325E027B, "ai_ride_and_shoot_weapon_drop" },
    { 0x039FD18B, "ai_ride_play_anim" },
    { 0x870C5F29, "ai_ride_stop_horse" },
    { 0x25124B75, "ai_ride_stop_riding" },
    { 0x6BBEE656, "ai_ride_transition" },
    { 0x402C598A, "ai_rider" },
    { 0xD64A6257, "ai_rider1" },
    { 0x6442F31C, "ai_rider2" },
    { 0x5A134E3F, "ai_rider_think" },
    { 0x5E2FC58D, "ai_right_lobby_guy" },
    { 0x3103C756, "ai_rocket" },
    { 0xC0CC1F61, "ai_rocket_deathfunction" },
    { 0xCDA507CF, "ai_rocketman_think" },
    { 0x949AFDC9, "ai_ronnie" },
    { 0xB0979730, "ai_roof" },
    { 0x348213A9, "ai_rooftop_claw" },
    { 0x6118D73D, "ai_rooftop_runners" },
    { 0xECE10CD8, "ai_rooftops" },
    { 0xD420A34F, "ai_rpg" },
    { 0x044DA26E, "ai_rpg_muj" },
    { 0x43EC9C16, "ai_rpgs" },
    { 0x56203BD8, "ai_run_along_node_array" },
    { 0x486B2D29, "ai_run_into_yard" },
    { 0xCF3B8B15, "ai_run_to_goal_wait_kill_flag" },
    { 0x3615F341, "ai_runanimupdatefrequency" },
    { 0x67440414, "ai_runner" },
    { 0xB923529D, "ai_runto_lvt" },
    { 0x2F2B04F4, "ai_rush_cooldown" },
    { 0xD3DDE68C, "ai_rush_death_func" },
    { 0x806A12C9, "ai_rush_spawn_func" },
    { 0xEC924583, "ai_rush_stop" },
    { 0x720A50D9, "ai_rusher" },
    { 0x9E79A729, "ai_safe_until_trigger" },
    { 0xB5DC0316, "ai_sailor" },
    { 0x0454F0EA, "ai_sal" },
    { 0x01D3E6EE, "ai_salazar" },
    { 0xE791B909, "ai_sanity_check" },
    { 0xD3E88020, "ai_savimbi_enemy" },
    { 0x9B1C7E43, "ai_scared_think" },
    { 0xA107BEBD, "ai_seal" },
    { 0xB607228E, "ai_seal1" },
    { 0x9004A825, "ai_seal2" },
    { 0x34B78FD9, "ai_seal_a" },
    { 0x90E9F381, "ai_seal_hangar" },
    { 0xB37B22A5, "ai_seal_rescue_guy_3" },
    { 0xE83B7137, "ai_seal_standoff_1" },
    { 0x763401FC, "ai_seal_standoff_2" },
    { 0x9C367C65, "ai_seal_standoff_3" },
    { 0x2A2F0D2A, "ai_seal_standoff_4" },
    { 0x50318793, "ai_seal_standoff_5" },
    { 0xDE2A1858, "ai_seal_standoff_6" },
    { 0x042C92C1, "ai_seal_standoff_7" },
    { 0x92252386, "ai_seal_standoff_8" },
    { 0x3296ABB4, "ai_security" },
    { 0x00A8E235, "ai_set_allow_friendly_fire" },
    { 0xB790D6DF, "ai_set_custom_animation_reaction" },
    { 0x50165376, "ai_set_enemy_fight_distance" },
    { 0x9EBE18B9, "ai_set_enemy_rage_behaviour" },
    { 0x05E7E240, "ai_set_new_retreat_node" },
    { 0x39FDF657, "ai_set_node_approach_anims" },
    { 0x0E79C9FE, "ai_set_target" },
    { 0x9B98AA05, "ai_setforcecolor_think" },
    { 0xCAC5A4BD, "ai_setforcecolor_think2" },
    { 0x4C957F63, "ai_setforcegoal_think" },
    { 0x1DE589FB, "ai_setforcegoal_think2" },
    { 0x5BD2364D, "ai_sets_goal" },
    { 0xD3E2E9E8, "ai_sets_goal_with_delay" },
    { 0xD4F2B5D5, "ai_setspecialnodebynodename" },
    { 0xA94863D5, "ai_shared" },
    { 0xBDBFDCEB, "ai_shoot_wildly" },
    { 0x190535DE, "ai_shooter" },
    { 0xB1911C36, "ai_shooter_742" },
    { 0xD793969F, "ai_shooter_743" },
    { 0x887CF2D8, "ai_shotgun" },
    { 0x6743BC8A, "ai_should_be_added" },
    { 0xB437DEDC, "ai_skinner_casual" },
    { 0x6945BE17, "ai_skipto_spot" },
    { 0x1FB9AFF4, "ai_slide_across_car" },
    { 0xE6858189, "ai_slide_guy2" },
    { 0xC3C5DC1D, "ai_slide_guy_1" },
    { 0xAC52BEE1, "ai_slow_vortex_fx" },
    { 0x2FC76277, "ai_smasher" },
    { 0x7244FA9B, "ai_sniper" },
    { 0xB7BBAE28, "ai_sniper1" },
    { 0x29C31D63, "ai_sniper2" },
    { 0x03C0A2FA, "ai_sniper3" },
    { 0x75C81235, "ai_sniper4" },
    { 0x31B01108, "ai_sniper_guards" },
    { 0x4C270895, "ai_sniper_shared" },
    { 0xF813B4D5, "ai_sniper_stair" },
    { 0xA8047EE4, "ai_soldier" },
    { 0xB528E33C, "ai_soviet" },
    { 0xF187D86D, "ai_soviet1" },
    { 0x178A52D6, "ai_soviet2" },
    { 0x956FD9D4, "ai_soviet_arena" },
    { 0xBCEE32FF, "ai_soviets" },
    { 0xAAF4F170, "ai_spawn_and_attack" },
    { 0xFC2099F7, "ai_spawn_control_set_create" },
    { 0xF2681D1D, "ai_spawn_functions" },
    { 0xFE7C3350, "ai_spawned" },
    { 0x82636B36, "ai_spawner" },
    { 0xB2A6F229, "ai_spawners" },
    { 0x6D1BBF79, "ai_spawnflag" },
    { 0xACB6F721, "ai_spawnprocessor" },
    { 0x3A4607C6, "ai_special_parameters" },
    { 0xFDBD975B, "ai_specialty_panama_bruteforce_deadguy" },
    { 0x34AE49C9, "ai_spets_patrolstand_idle" },
    { 0x74214C85, "ai_spikes_chop_throttle" },
    { 0xE93030EB, "ai_spot1" },
    { 0x7728C1B0, "ai_spot2" },
    { 0x9D2B3C19, "ai_spot3" },
    { 0x1DC9D659, "ai_spots" },
    { 0xA4685AEF, "ai_spotter" },
    { 0xFC945F3D, "ai_squad_member" },
    { 0xB5D9976C, "ai_squadmanager_todo" },
    { 0x54644B43, "ai_squadmate" },
    { 0xD772B092, "ai_squadmember" },
    { 0x125342FF, "ai_squads" },
    { 0x9FD731A0, "ai_ss" },
    { 0xF9D9A6E7, "ai_stacker_1" },
    { 0x87D237AC, "ai_stacker_2" },
    { 0xADD4B215, "ai_stacker_3" },
    { 0x539BAC19, "ai_stair_sniper" },
    { 0x372412A3, "ai_staircase_run_down_8x16_2" },
    { 0x7E91CC35, "ai_stand_exposed_grenade_throwa_nic_01" },
    { 0xA494469E, "ai_stand_exposed_grenade_throwa_nic_02" },
    { 0xF102030E, "ai_standoff_seals" },
    { 0x377FD71E, "ai_start" },
    { 0xFC3ABBBD, "ai_start_charge" },
    { 0xFEC18695, "ai_start_fights_allowed" },
    { 0x76463118, "ai_start_freefall" },
    { 0x12D276EE, "ai_start_tandem_freefall" },
    { 0x532BD479, "ai_start_tandem_freefall_brooks" },
    { 0x76B41D81, "ai_starts" },
    { 0xC3A32A15, "ai_state" },
    { 0x636017A1, "ai_stay_in_front_of_player" },
    { 0xC8175BE8, "ai_stinger" },
    { 0x63CCCC33, "ai_stingers_1" },
    { 0xF1C55CF8, "ai_stingers_2" },
    { 0x0594B5E8, "ai_stomper" },
    { 0x251A343F, "ai_stop_stairs" },
    { 0x9B172573, "ai_street" },
    { 0x52B61A24, "ai_stuff" },
    { 0x6337CB0E, "ai_stun" },
    { 0x45922158, "ai_subclass" },
    { 0x163D118E, "ai_suicide" },
    { 0x0E3E5E4A, "ai_supplement_tracker" },
    { 0x0554F3EA, "ai_supplement_type" },
    { 0x23E5C72E, "ai_supplements_settings" },
    { 0x17D61123, "ai_supplements_think" },
    { 0x4D8CCD43, "ai_support" },
    { 0x5391F95A, "ai_sweepers" },
    { 0x63E7D60C, "ai_table_watch_01" },
    { 0xD5EF4547, "ai_table_watch_02" },
    { 0xAFECCADE, "ai_table_watch_03" },
    { 0x09D5DC64, "ai_tagger" },
    { 0xE4C2B65E, "ai_tank" },
    { 0xBB9CFED9, "ai_tank_agr_name" },
    { 0x816D4DD0, "ai_tank_bar" },
    { 0x8E63A029, "ai_tank_bullet_mitigation" },
    { 0xFE82121D, "ai_tank_crate_explode_fx" },
    { 0x17431A0F, "ai_tank_damage_fx" },
    { 0x31BA6DF1, "ai_tank_explode_fx" },
    { 0x7E40A9BC, "ai_tank_explosive_mitigation" },
    { 0xBB4C5D8A, "ai_tank_fov" },
    { 0xD3A75E47, "ai_tank_furthest_from_navmesh_allowed" },
    { 0x8F7A7462, "ai_tank_gun_turret" },
    { 0x042DC044, "ai_tank_gunner_aim_offset" },
    { 0xF9BE3A27, "ai_tank_gunner_aim_tag" },
    { 0x99644CD2, "ai_tank_gunner_flash_tag" },
    { 0xBEF9249E, "ai_tank_guy" },
    { 0xBCFD7BAB, "ai_tank_health" },
    { 0x523795BB, "ai_tank_in_water_futz_fraction" },
    { 0x3732C634, "ai_tank_in_water_ref_distance" },
    { 0x847527A8, "ai_tank_in_water_trace_distance" },
    { 0xDC72B084, "ai_tank_in_water_trace_end" },
    { 0x8AC55DEB, "ai_tank_in_water_trace_fraction" },
    { 0xB4D909A1, "ai_tank_in_water_trace_mask" },
    { 0x90E78204, "ai_tank_in_water_trace_maxs" },
    { 0xF0FD5C1A, "ai_tank_in_water_trace_mins" },
    { 0x82F9CDB0, "ai_tank_in_water_trace_ref" },
    { 0x2F4B39EF, "ai_tank_in_water_trace_start" },
    { 0x51516272, "ai_tank_in_water_trace_wait" },
    { 0x995EFFEB, "ai_tank_init" },
    { 0xB74A2F7E, "ai_tank_killstreak_start" },
    { 0x45C00CEC, "ai_tank_lifetime" },
    { 0xA8C647EF, "ai_tank_max_reaction_time" },
    { 0x22B94A15, "ai_tank_min_reaction_time" },
    { 0xD52BCA11, "ai_tank_minigun_flash_3p" },
    { 0x10AF4001, "ai_tank_missile_flash_tag" },
    { 0x0E31539C, "ai_tank_missile_turret" },
    { 0xE570A191, "ai_tank_missle_count_after_reload" },
    { 0xB70E2F64, "ai_tank_nav_mesh_valid_location_boundary" },
    { 0x960DDCCB, "ai_tank_nav_mesh_valid_location_tolerance" },
    { 0xB4D8A288, "ai_tank_path_timeout" },
    { 0xA2C31962, "ai_tank_remote_weapon" },
    { 0x26356884, "ai_tank_stun_duration" },
    { 0xDA945842, "ai_tank_stun_duration_proximity" },
    { 0x2317B9AE, "ai_tank_stun_fx" },
    { 0xA8366348, "ai_tank_text" },
    { 0xA351FCDF, "ai_tank_think_debug" },
    { 0x1D34332D, "ai_tank_time_to_wait_for_lost_target" },
    { 0x466BC1B3, "ai_tank_turret_fire_rate" },
    { 0x551D9A16, "ai_tank_turret_weapon" },
    { 0x93819778, "ai_tank_valid_locations" },
    { 0xA15B0C4A, "ai_tank_visionset_alias" },
    { 0xD42B3EAC, "ai_tank_visionset_file" },
    { 0xFAE5AE69, "ai_tank_weapon_name" },
    { 0x75BC5AC1, "ai_tanks" },
    { 0xEA49A5C9, "ai_target" },
    { 0xC0A29DA6, "ai_target_2" },
    { 0x50C28768, "ai_targetname" },
    { 0x783095F9, "ai_team" },
    { 0x94F734F8, "ai_teleport_and_run_to_node" },
    { 0xF6ACE678, "ai_temp" },
    { 0x1ADD62DF, "ai_ter" },
    { 0x64965B08, "ai_terrorist" },
    { 0x708B7599, "ai_terrorist_4" },
    { 0x4A88FB30, "ai_terrorist_5" },
    { 0xF5DA1141, "ai_theater" },
    { 0x33EC51EA, "ai_think" },
    { 0xAF5975C0, "ai_think_machine" },
    { 0x8D1F4FB3, "ai_third_person" },
    { 0x8BF057D8, "ai_thresh" },
    { 0xF1BE4AAC, "ai_through_door" },
    { 0xF3A8608F, "ai_thrower" },
    { 0x8E4FD736, "ai_thug_1" },
    { 0x684D5CCD, "ai_thug_2" },
    { 0x424AE264, "ai_thug_3" },
    { 0x1C4867FB, "ai_thug_4" },
    { 0xC049D14E, "ai_to_elevator" },
    { 0xB84EA7E7, "ai_to_player" },
    { 0x6A4D731A, "ai_to_stay_close_to" },
    { 0xCDD6FE46, "ai_todo" },
    { 0x4F7111A1, "ai_top_ladder_pdf" },
    { 0xBEC97C7C, "ai_torch_guy" },
    { 0xC54583B2, "ai_toss_flashbang" },
    { 0x9910C8C4, "ai_touched_eq_trigger" },
    { 0x8FC5DC47, "ai_touching_area" },
    { 0x82F7985A, "ai_tracer_burst" },
    { 0x52036519, "ai_traversal1" },
    { 0xC1D16616, "ai_troop" },
    { 0x1EDCF041, "ai_trytousebetterweapon" },
    { 0xDB3C274F, "ai_turn_of_hold_node_after_time" },
    { 0x94C56393, "ai_turn_off_hold_node_after_time" },
    { 0xB4D74716, "ai_turnanimanglethreshold" },
    { 0x2ABEFC09, "ai_turnrate" },
    { 0x6C3FBD15, "ai_turret_think" },
    { 0x48FF7E46, "ai_type" },
    { 0x8ACE990B, "ai_type_populate" },
    { 0x59FC2992, "ai_type_struct" },
    { 0x296B0CF9, "ai_types" },
    { 0xF64A1A93, "ai_unit_individual_think" },
    { 0x0F70DCDD, "ai_unita" },
    { 0x57AC7F52, "ai_unload_watcher" },
    { 0x3D2501DF, "ai_upstairs" },
    { 0x6BCECCAF, "ai_user" },
    { 0xBF9AF4D6, "ai_uses_minigun" },
    { 0x761D6D67, "ai_usingsidearm" },
    { 0x9F982C0A, "ai_vehicle_support" },
    { 0xAFBB3610, "ai_vehicle_support_vehicle_dead" },
    { 0x446EC2F6, "ai_victim" },
    { 0xA60B220C, "ai_viet_run" },
    { 0xE758AEA2, "ai_wait_go" },
    { 0x74B4D6A0, "ai_walk_trigger" },
    { 0xE2A3D85E, "ai_warp_to_horse" },
    { 0x227A020D, "ai_weapon_throttle" },
    { 0x3C226B49, "ai_weapons" },
    { 0x46889843, "ai_weaponselectwatch" },
    { 0x46F2F03E, "ai_wetness_change" },
    { 0xB4B1A834, "ai_wetness_change_spawnfunc" },
    { 0xAA5F4E7B, "ai_window_dive" },
    { 0x59DE41CC, "ai_window_jumper" },
    { 0x4885EBCD, "ai_wingsuit_think" },
    { 0x3C950658, "ai_woods" },
    { 0x064FAFA4, "ai_worker" },
    { 0xD9EAED45, "ai_worker1" },
    { 0xFFED67AE, "ai_worker2" },
    { 0x47CE4447, "ai_wounded_lefthand_a" },
    { 0x3E3DA748, "ai_wounded_righthand_a" },
    { 0x3FC1350B, "ai_xp_init" },
    { 0xCAB17DC5, "ai_yemeni" },
    { 0x59B2EB27, "ai_zhao_proximitywatch" },
    { 0x4E607510, "ai_zombie" },
    { 0x924C5B15, "ai_zombie_health" },
    { 0x532F6C0A, "aiareintheroom" },
    { 0xC89DE9C6, "aiarray" },
    { 0x0AD61B5A, "aibattlechatterloop" },
    { 0x1508405B, "aiblocker" },
    { 0x1CF75425, "aicorpsecleanup" },
    { 0xCB80D4A0, "aicount" },
    { 0x374765C5, "aid" },
    { 0x4660515D, "aideathenemy" },
    { 0x640D7FD9, "aideatheventthread" },
    { 0xAA6B48E6, "aideathfriendly" },
    { 0x24031EDF, "aideathlistener" },
    { 0x7060201F, "aideletedistance" },
    { 0x6774C6DA, "aidisablegrenadethrows" },
    { 0xE45407B4, "aidisplacewaiter" },
    { 0x162F9467, "aidrone" },
    { 0xE5AA6A8A, "aidudes" },
    { 0xE38469DD, "aienemies" },
    { 0xCD9BB5C9, "aienemyvec" },
    { 0x92F0CC22, "aieye" },
    { 0xF27FE286, "aifar" },
    { 0xD10E198B, "aifirechance" },
    { 0xA8DEE60C, "aiflankerorderwaiter" },
    { 0x6D25EED4, "aiflankerwaiter" },
    { 0x2BC6AECA, "aifolloworderwaiter" },
    { 0xFDC5C42C, "aiforwardvec" },
    { 0xBCF6D597, "aifusetime" },
    { 0x3BDE57B9, "aigoalchooser" },
    { 0x3BE2D963, "aigoalentity" },
    { 0x728859EC, "aigrenadedangerwaiter" },
    { 0x6E4D5930, "aigroup" },
    { 0x9ED9B96F, "aigroup_create" },
    { 0x8410CA21, "aigroup_init" },
    { 0x22A38BFA, "aigroup_name" },
    { 0xBFBB928E, "aigroup_soldier_think" },
    { 0xE6F7DD69, "aigroup_soldierthink" },
    { 0xEA73533E, "aigroup_spawner_death" },
    { 0x4FD44891, "aigroup_spawnerdeath" },
    { 0x6A9D069C, "aigroup_spawnerempty" },
    { 0x6A89EBC3, "aigroup_spawnerthink" },
    { 0xC9EA9399, "aigroup_think" },
    { 0xC14C1069, "aigroupname" },
    { 0xDA5A8E10, "aigroupnum" },
    { 0xD01A87EE, "aihasonlypistol" },
    { 0x21B66144, "aihasonlypistolorsmg" },
    { 0xD12F363D, "aihasprimaryweapon" },
    { 0xCF9D6061, "aihassecondaryweapon" },
    { 0xE0D94A1A, "aihassidearm" },
    { 0x22DD3CDD, "aihasweapon" },
    { 0x4B7E8587, "aihero" },
    { 0x784D08C4, "aiidx" },
    { 0xA9753703, "aiisaboveground" },
    { 0x2CBFD77B, "aikeys" },
    { 0x8EC152A5, "aikilleventthread" },
    { 0x68E8737F, "ailist" },
    { 0xE1311814, "aim" },
    { 0x1A730875, "aim1" },
    { 0x407582DE, "aim2" },
    { 0xF5A892E8, "aim2alert" },
    { 0x5C66A468, "aim4" },
    { 0xA86B993A, "aim6" },
    { 0xC45CBAC4, "aim8" },
    { 0xAB77B9C3, "aim_2" },
    { 0xDD9C452E, "aim_2_hide" },
    { 0xF77CAE95, "aim_4" },
    { 0x4381A367, "aim_6" },
    { 0x2F5EF1A9, "aim_8" },
    { 0xB2F328E9, "aim_and_fire_hull" },
    { 0x5595A05F, "aim_and_fire_rocket_launcher" },
    { 0x77FD61FF, "aim_angles" },
    { 0x1368586C, "aim_anim" },
    { 0x1311543E, "aim_assist" },
    { 0x519C4016, "aim_assist_target" },
    { 0x91F58709, "aim_at_best_shoot_location" },
    { 0x90435539, "aim_at_closest_cqb_target" },
    { 0x2A1292EE, "aim_at_harper_fail_timer" },
    { 0xA7306393, "aim_at_overlook_fight" },
    { 0xDD29F7EC, "aim_at_target" },
    { 0x8DF51334, "aim_barricade" },
    { 0x74614C8C, "aim_blend" },
    { 0x277CBAC0, "aim_count" },
    { 0x250F4B7A, "aim_delay_off" },
    { 0x492D7EF8, "aim_dir" },
    { 0xE5D49ACB, "aim_down" },
    { 0x2F5BCB19, "aim_down_target" },
    { 0x28FF9F0A, "aim_ent" },
    { 0x68433A8A, "aim_entity" },
    { 0x230AAFB7, "aim_f" },
    { 0xE30E47E3, "aim_grenade" },
    { 0xA6F1E79D, "aim_l" },
    { 0x0CDC4D3C, "aim_left" },
    { 0xDDEB27F8, "aim_limit" },
    { 0x5648B734, "aim_limit_table_entry_cover" },
    { 0xD75F0616, "aim_limit_table_entry_cover_concealed_over" },
    { 0xE6B79A23, "aim_limit_table_entry_cover_left_lean" },
    { 0xA82D9071, "aim_limit_table_entry_cover_over" },
    { 0xF8BBEFB2, "aim_limit_table_entry_cover_right_lean" },
    { 0xAB7BF283, "aim_limit_table_entry_cover_vantage" },
    { 0x4E9DDEF6, "aim_limit_table_entry_default" },
    { 0x05DAAD70, "aim_limit_table_entry_locomotion" },
    { 0xAE1E150C, "aim_limit_table_entry_pillar_left_lean" },
    { 0xD8F9F8AB, "aim_limit_table_entry_pillar_right_lean" },
    { 0x00FB6C26, "aim_location" },
    { 0x7CD99493, "aim_node" },
    { 0x6D1DF9EF, "aim_only_no_shooting" },
    { 0x4596B96F, "aim_org" },
    { 0xC66B3071, "aim_origin" },
    { 0x6C994D57, "aim_path_start" },
    { 0x9F7D8C8F, "aim_point" },
    { 0x54645C17, "aim_pos" },
    { 0x2AD91F83, "aim_r" },
    { 0x5BE261B2, "aim_range" },
    { 0xA53BC013, "aim_right" },
    { 0x31380CEF, "aim_set_by_shoot_at_target" },
    { 0xD53950C3, "aim_spot" },
    { 0x27A01961, "aim_spotlight" },
    { 0x842A56B4, "aim_struct" },
    { 0xBA5DA5CD, "aim_tag" },
    { 0x73A35724, "aim_target" },
    { 0x4001F657, "aim_targets" },
    { 0x376B7B10, "aim_time" },
    { 0x16EF1733, "aim_time_max" },
    { 0x99DA593D, "aim_time_min" },
    { 0x25265988, "aim_tracer" },
    { 0x2A7883D8, "aim_trigger_think" },
    { 0xC094CC2C, "aim_triggers" },
    { 0x739F9C90, "aim_turnrate_pitch_ads" },
    { 0xA6F25917, "aim_turnrate_yaw_ads" },
    { 0x6ABB6DAD, "aim_turret_at_ambush_point_or_visible_enemy" },
    { 0x7819307E, "aim_turret_loc" },
    { 0x54ED0DB4, "aim_up" },
    { 0x96AF2984, "aim_up_target" },
    { 0xD3F3765C, "aim_updated" },
    { 0x8AE49A83, "aim_vec" },
    { 0xA2686524, "aim_yaw_threshold" },
    { 0x1C420C74, "aimangleoffset" },
    { 0x2AF657A3, "aimanim" },
    { 0x6F2819DE, "aimanimname" },
    { 0x09FA25DF, "aimanimprefix" },
    { 0x5E92E467, "aimatpos" },
    { 0x815515B4, "aimattarget" },
    { 0xF9F6022C, "aimattargetthread" },
    { 0xB2C1BD14, "aimawareanimscript" },
    { 0x901A8457, "aimax" },
    { 0x739788B3, "aimaxdist" },
    { 0x9163C2ED, "aimaxsprintrate" },
    { 0xD0C835FA, "aimblendtime" },
    { 0x4A4F6560, "aimcovermode" },
    { 0xE2D09E81, "aimdelay" },
    { 0x2F7CE4FE, "aimdelta" },
    { 0x434ACE58, "aimdown" },
    { 0x5AFBD1E7, "aimdownanim" },
    { 0x1BAF8CB7, "aimed" },
    { 0x74C02F4F, "aimedatshootentorpos" },
    { 0x2943EFBE, "aimedsomewhatatenemy" },
    { 0xD77907B1, "aimer" },
    { 0xFACEE39E, "aimerror" },
    { 0xB8A6C7F6, "aimerrormaxpitch" },
    { 0x97C3DA75, "aimerrormaxyaw" },
    { 0x4060ED34, "aimerrorminpitch" },
    { 0xBE38A373, "aimerrorminyaw" },
    { 0x57AB5DB7, "aimface" },
    { 0xCC5BFF88, "aimforwardtime" },
    { 0x65A776CD, "aimguy" },
    { 0xD7830547, "aimguymortarsuntildeath" },
    { 0x6C4C0D77, "aimguyspawner" },
    { 0xE331D8E6, "aimidlethread" },
    { 0x3FC7BF19, "aimindist" },
    { 0x787DBF54, "aiming" },
    { 0x8383ABC3, "aiming_vec" },
    { 0x9D1BA4E6, "aiminganimschanged" },
    { 0x18805483, "aimingcatchupfactor" },
    { 0xAF9F9E13, "aimingoff" },
    { 0x3022887F, "aimingon" },
    { 0xCB5013E9, "aiminjograte" },
    { 0x6469E8B8, "aimleftanim" },
    { 0x52237CAD, "aimlimit" },
    { 0xE8FD7BAC, "aimlimits" },
    { 0x6C695E66, "aimlimitsforcover" },
    { 0xEF0FE88A, "aimlimitsfordirectionright" },
    { 0xD68901A5, "aimoffset" },
    { 0x97A3BEB2, "aimorigin" },
    { 0xFD1AEAFC, "aimorigins_close" },
    { 0x89E7D1C5, "aimpeak" },
    { 0xD8D77996, "aimpoint" },
    { 0xAABAF909, "aimpoints" },
    { 0xA8C2CED2, "aimpos" },
    { 0x94B8BE4D, "aimrightanim" },
    { 0xE7169787, "aims" },
    { 0xAC7C4EDC, "aimspot" },
    { 0x35DF3A1F, "aimspots" },
    { 0x25F33DA7, "aimspotsets" },
    { 0x7EF73AAB, "aimstarttime" },
    { 0x3898C950, "aimtable" },
    { 0x3976CA3B, "aimtables" },
    { 0x55125BDF, "aimtarget" },
    { 0x920469D1, "aimthresholdpitch" },
    { 0xCFF05D4E, "aimthresholdyaw" },
    { 0x03639D67, "aimtime" },
    { 0x7600AF33, "aimup" },
    { 0xE11B4EB4, "aimupanim" },
    { 0xECB4F787, "aimviewatent" },
    { 0xDF658BA4, "aimweight" },
    { 0x4324196A, "aimweight_end" },
    { 0x8A1F0C71, "aimweight_start" },
    { 0x2A602B65, "aimweight_t" },
    { 0x775E5DC5, "aimweight_transframes" },
    { 0xA0932C15, "aimyaw" },
    { 0xE7085EB6, "ainame" },
    { 0x7062BC79, "ainameandrankwaiter" },
    { 0xAD5F7D79, "ainear" },
    { 0x8FA7D911, "ainotinunit" },
    { 0x987C2409, "aint" },
    { 0x08AC0E0C, "ainumber" },
    { 0x18744894, "aiofficerorders" },
    { 0xF25F0DCC, "aioverridedamage" },
    { 0xEC5EC80C, "aioverridekilled" },
    { 0x02D471B0, "aiowner" },
    { 0xB288FE72, "aipathingtest" },
    { 0x3EC6CA18, "aiperfectsense" },
    { 0x0A126A91, "aiphys_default_height" },
    { 0xEA1EB390, "aiphys_radius" },
    { 0x23BD8C83, "aiphys_stepsize" },
    { 0x75F81DD9, "aiphysicstrace" },
    { 0x042F55BC, "aipop" },
    { 0xA885DF51, "aipopcount" },
    { 0x7636C4F7, "aipos" },
    { 0x639F0F8C, "aipostreturnwatch" },
    { 0xACD10A2D, "aipostswapwatch" },
    { 0xAE313757, "aipostthink" },
    { 0x53A8EBCC, "aiprofile_beginentry" },
    { 0x41A10930, "aiprofile_endentry" },
    { 0x174AE126, "aiprofile_scopedsampler_t" },
    { 0x8B1ACA63, "air" },
    { 0xC3FF2CFA, "air_ambience" },
    { 0xC018E56C, "air_battle_manager" },
    { 0x73E5331E, "air_escort" },
    { 0x4B65ED78, "air_escort_path" },
    { 0x04447DDA, "air_node_mesh" },
    { 0x19DB306F, "air_projectile_delete" },
    { 0xC489B40F, "air_puzzle_1_cleanup" },
    { 0x204D5D80, "air_puzzle_1_complete" },
    { 0x97F0D6A7, "air_puzzle_1_init" },
    { 0xFD44E0AC, "air_puzzle_1_run" },
    { 0x7415F899, "air_puzzle_2_complete" },
    { 0x4D617B5A, "air_puzzle_2_init" },
    { 0xDF52FCAB, "air_puzzle_2_run" },
    { 0x4BCFFB18, "air_puzzle_run_smoke_direction" },
    { 0x146BD1A4, "air_puzzle_smoke" },
    { 0xE9869EC8, "air_puzzle_smoke_solved" },
    { 0x89CDEC18, "air_raid_alarm" },
    { 0xA5DF37F5, "air_raid_audio" },
    { 0x04E351FC, "air_raid_siren" },
    { 0x6E21A978, "air_raid_siren_count" },
    { 0x00A7BFBF, "air_raid_sirens" },
    { 0x93B196FE, "air_raid_sound" },
    { 0xE56AF7A4, "air_start_nodes" },
    { 0xE4324896, "air_stop" },
    { 0xBD5DF7B2, "air_strike_begin" },
    { 0xCFDF409E, "air_strike_user_notify" },
    { 0xBDA1792E, "air_support_buttoncheck" },
    { 0x192B2C65, "air_support_called" },
    { 0xBAADAB63, "air_support_canceled" },
    { 0x2843E8A1, "air_support_deleted" },
    { 0x9067979E, "air_support_fire_watch" },
    { 0x38CEE238, "air_support_fx_red" },
    { 0x5F8239FF, "air_support_fx_yellow" },
    { 0x6E672C91, "air_support_hint_delete" },
    { 0x232CFEAB, "air_support_hint_print_activate" },
    { 0x929D4B08, "air_support_hint_print_call" },
    { 0xC78C4FF8, "air_support_hint_print_dialog_next" },
    { 0x76B86E78, "air_support_nag" },
    { 0x268EEAEF, "air_support_objective" },
    { 0xAB338F30, "air_support_over" },
    { 0xF5B14384, "air_support_reminder" },
    { 0xEA5E9878, "air_support_switch_back" },
    { 0x4C54D4EB, "air_support_watch" },
    { 0xA0FAA0F9, "airank" },
    { 0xED65D21E, "airborn" },
    { 0x53A57667, "airborne" },
    { 0xFBF396BE, "airborne_enemies" },
    { 0xA3CC131F, "airburst" },
    { 0xFDCD634F, "aircraft" },
    { 0xBA44042B, "aircraft_crash" },
    { 0xD5F802ED, "aircraft_crash_move" },
    { 0x0B4F0C34, "aircraft_dust_kickup" },
    { 0xC0362D70, "aircraft_dustkick" },
    { 0xB83BCBC6, "aircraft_keys" },
    { 0xB58E9D7E, "aircraft_list" },
    { 0x75755200, "aircraft_wait_node" },
    { 0x695B6AA5, "aircraft_weapons" },
    { 0xDEDEDC16, "aircrafts" },
    { 0xCFA46A29, "aircrystalbiplanecallback_vehicledamage" },
    { 0x5EA857F1, "airduct_fan_large" },
    { 0x02773E29, "airduct_fan_medium" },
    { 0x5CC401B9, "airduct_fan_small" },
    { 0x1F5B35C0, "airedale" },
    { 0x97067A92, "airedalert" },
    { 0xAC56E21F, "airfied" },
    { 0x0AA25A61, "airfield" },
    { 0xECF72D14, "airfield_ambience" },
    { 0x4DC7A882, "airfield_anims" },
    { 0xEEEED407, "airfield_axis" },
    { 0xF714B73C, "airfield_axis_logic" },
    { 0x7EC4C4A6, "airfield_dlg_done" },
    { 0x28775104, "airfield_enemy_spawners" },
    { 0x02FCBA71, "airfield_first_read" },
    { 0x9BA125A5, "airfield_gump_vehicles" },
    { 0x127FB325, "airfield_initial_chains" },
    { 0x3180D2BB, "airfield_initial_spawns" },
    { 0xBCEF04F9, "airfield_last_trench" },
    { 0xD2423586, "airfield_littlebird_logic" },
    { 0x85EAF102, "airfield_mortars" },
    { 0xF0B7BB8C, "airfield_objectives" },
    { 0x54A2E11D, "airfield_plane_fire" },
    { 0xBB4701C0, "airfield_rebel_spawners" },
    { 0x457845FE, "airfield_rush_mid_strat" },
    { 0x38026AEA, "airfield_spawnfuncs" },
    { 0x202664BF, "airfield_strafe_victims_2_strat" },
    { 0xC47CEAA0, "airfield_strafe_victims_strat" },
    { 0x63F16A88, "airfield_strafe_victims_strat_damage" },
    { 0x6866B8A5, "airfield_stunned" },
    { 0x43FB92E3, "airfield_temp_kill_axis" },
    { 0x3056F5B8, "airfield_truck_done" },
    { 0x85CD50E7, "airfield_truck_guys_strat" },
    { 0x9D78ED4D, "airfield_vision_trig" },
    { 0xD60ADA69, "airfield_vo" },
    { 0x39CB579B, "airfield_weapons" },
    { 0xDAD28F31, "airfirled" },
    { 0xC6C558F0, "airforce" },
    { 0x1B704C5C, "airless" },
    { 0x1450DBEE, "airless_vox_in_progess" },
    { 0xCBABAABF, "airless_vox_without_repeat" },
    { 0x3E394A30, "airlift" },
    { 0xA0704761, "airlift_amb" },
    { 0x00B3A028, "airlift_anim" },
    { 0xF8999676, "airlift_art" },
    { 0x405593C1, "airlift_fx" },
    { 0x93322F4B, "airlift_intro" },
    { 0x8FDB0F0C, "airlift_intro_dvars" },
    { 0x80846DC3, "airlifted" },
    { 0x392AF933, "airliftmortardist" },
    { 0xA970799A, "airlock" },
    { 0x79DF424A, "airlock_activate" },
    { 0x3A7C5EB3, "airlock_buy" },
    { 0x61FD55D0, "airlock_buy_init" },
    { 0xE5518DB2, "airlock_buy_think" },
    { 0x0A054D62, "airlock_buys" },
    { 0x42DF992C, "airlock_connect_paths" },
    { 0xC7BBEDC0, "airlock_doors" },
    { 0x95CB438F, "airlock_fx" },
    { 0x2F56CBEC, "airlock_fx_init" },
    { 0x9063BA2F, "airlock_hack_init" },
    { 0x849E716D, "airlock_hacks" },
    { 0x2A9AF717, "airlock_init" },
    { 0x563A9B4F, "airlock_think" },
    { 0x90349995, "airlocks" },
    { 0x63ADD5D7, "airmada_heli" },
    { 0x0A707367, "airmada_heli_path" },
    { 0xA75EAB8A, "airmada_heli_path_exit" },
    { 0xF9CD6C5E, "airmada_phantom" },
    { 0x850E71B8, "airmada_phantom_path" },
    { 0x00DE90CE, "airmada_phantom_shoot" },
    { 0xC3090F48, "airmada_strafing_logic" },
    { 0xAE49488E, "airmasks" },
    { 0xB57D57D3, "airplane" },
    { 0xFDD20616, "airplane_amb" },
    { 0x4784A0F9, "airplane_anim" },
    { 0x624D8885, "airplane_art" },
    { 0xC4A7598B, "airplane_crows_start" },
    { 0xB0208A22, "airplane_destabilize" },
    { 0x4F2E4F5A, "airplane_flyby" },
    { 0x45E7540C, "airplane_fx" },
    { 0xD3A8DAA1, "airplane_hole_overlay" },
    { 0x7443868D, "airplane_seatbelt_done" },
    { 0x829E64CC, "airplane_takeoff_reverb_change" },
    { 0x2DF29901, "airplane_takeoff_snapshot" },
    { 0x8BB4C631, "airplane_timer" },
    { 0xFBCF2143, "airspace" },
    { 0xFD0A50E1, "airstrike" },
    { 0xF98A1C46, "airstrike_ammo" },
    { 0xC640C9B4, "airstrike_ammo_giver" },
    { 0xDA8DEAC6, "airstrike_ammo_taker" },
    { 0xB6EE4567, "airstrike_called" },
    { 0xA3F173FF, "airstrike_command" },
    { 0x1F18374B, "airstrike_completion_check" },
    { 0x871818E3, "airstrike_frequency_check" },
    { 0xC0C5B185, "airstrike_hint_console" },
    { 0x8DAAEA51, "airstrike_hint_pc" },
    { 0x800C09C3, "airstrike_hit" },
    { 0x489C2A7E, "airstrike_hudmsg" },
    { 0xD49A5D9A, "airstrike_init" },
    { 0xD0E35B10, "airstrike_player_init" },
    { 0xB1339D02, "airstrike_radio_dialogue" },
    { 0x8902A704, "airstrike_ready_done" },
    { 0xEABA8E09, "airstrike_support" },
    { 0xD0DAF2EF, "airstrike_support_activate" },
    { 0xB4F6DDB3, "airstrike_support_deactive" },
    { 0xFB86239D, "airstrike_support_launch" },
    { 0x9109B047, "airstrike_support_mark" },
    { 0xD060A2E8, "airstrike_support_paint_target" },
    { 0xFD5968DB, "airstrike_triggers" },
    { 0x390C8C7B, "airstrike_used" },
    { 0xB4676C88, "airstrikeattackarrow" },
    { 0x9BA9D556, "airstrikebombcount" },
    { 0x9B169ABE, "airstrikecalledrecently" },
    { 0x6F8CF07A, "airstrikecooldown" },
    { 0xF3B84D04, "airstrikedamagedents" },
    { 0x04B3BAE9, "airstrikedamagedentscount" },
    { 0x5DE3A2D8, "airstrikedamagedentsindex" },
    { 0x4F3CB63C, "airstrikedamageentsthread" },
    { 0xA6605548, "airstrikedanger" },
    { 0x36E264E7, "airstrikedangerforwardpush" },
    { 0x319EEA1C, "airstrikedangermaxradius" },
    { 0xC4D01A14, "airstrikedangermaxradiussq" },
    { 0xCEE006FE, "airstrikedangerminradius" },
    { 0x681E7ED2, "airstrikedangerovalscale" },
    { 0x6579C8B7, "airstrikefx" },
    { 0x0DEC57AA, "airstrikeheightscale" },
    { 0x42D3E2E1, "airstrikeinprogress" },
    { 0x47FE9263, "airstrikeline" },
    { 0x5A4105F0, "airstrikelosradiusdamage" },
    { 0x4318F360, "airstrikemaprange" },
    { 0x379B9348, "airstrikemodel" },
    { 0x4C6003F1, "airstriker" },
    { 0xAF04DF00, "airstrikerewindwatcher" },
    { 0x265D8988, "airstrikes" },
    { 0xFB0ED6C9, "airstrikeselectorsize" },
    { 0xA041408F, "airstrikesupportcallsremaining" },
    { 0x35CA8F47, "airstrip" },
    { 0xB6A9D556, "airstsrike" },
    { 0x56E5590C, "airsupport" },
    { 0xCEDAC144, "airsupport_debug" },
    { 0x622FD537, "airsupport_done" },
    { 0x3B109B72, "airsupport_height" },
    { 0xE837C7FD, "airsupport_heights" },
    { 0x37A036EF, "airsupport_pos" },
    { 0x9F83FE9A, "airsupport_rotator" },
    { 0x3910A66E, "airsupport_stern_enemies" },
    { 0xB28CDF74, "airsupport_stern_enemies_death_watcher" },
    { 0x3A8EAF6D, "airsupport_stern_wave" },
    { 0xBC07103F, "airsupportbombtimer" },
    { 0x1E695611, "airsupportfxtimer" },
    { 0xAC0AA655, "airsupportheightscale" },
    { 0xF517EE04, "airtargetspot" },
    { 0xB26EAD98, "airtime" },
    { 0x65184FFA, "ais" },
    { 0x24E1754C, "ais_alive" },
    { 0x22CBD834, "ais_behave" },
    { 0x6FE32256, "ais_count" },
    { 0xE5FD4096, "ais_in_room" },
    { 0xF827DC36, "ais_need_teleported" },
    { 0xF5347CC0, "ais_possesion_mode" },
    { 0xC9A5C468, "ais_print_3d" },
    { 0xF3B23ABF, "ais_scripted" },
    { 0x99B2F679, "ais_wetness_change" },
    { 0xE6C3171D, "aiset" },
    { 0x47AAFE8B, "aisle" },
    { 0x79669809, "aisneak_enemy_dialogue" },
    { 0x7D4C70CB, "aisneak_friends_reset" },
    { 0x2BFFD8A9, "aisneak_friends_setup" },
    { 0x5E3CA631, "aisneak_mapreader_setup" },
    { 0xBBF11555, "aisneak_mapreaders_anims" },
    { 0x1B2EE506, "aisneak_rifleman_anim" },
    { 0x988707F4, "aisneak_rifleman_setup" },
    { 0x98BA28BB, "aisneak_setup_enemies_apt1" },
    { 0x024FFA4C, "aisneak_setup_mapreaders" },
    { 0x66723314, "aisneak_setup_riflemen" },
    { 0xDA050517, "aisneak_setup_telegrapher" },
    { 0x55B8B746, "aisneak_telegrapher_anims" },
    { 0x302EA1E7, "aisneak_telegrapher_setup" },
    { 0x9EA5D3D6, "aispread" },
    { 0x354338EE, "aisquads" },
    { 0xA13E2438, "aisuppressai" },
    { 0xD71FBF35, "ait" },
    { 0xBAA18F48, "aitank_hide_compass_on_remote_control" },
    { 0x58BE6488, "aitank_influencer_radius" },
    { 0xBE60D3A0, "aitank_influencer_score" },
    { 0xFD7D33E4, "aitank_influencer_score_curve" },
    { 0xC872B00D, "aitankhackertoolradius" },
    { 0x3323991C, "aitankhackertooltimems" },
    { 0xE528E395, "aitankkillstreakbundle" },
    { 0x3432F284, "aitarget" },
    { 0x4174F437, "aitargets" },
    { 0x3311B218, "aiteam" },
    { 0x513ADCB5, "aithink" },
    { 0xCA772E57, "aithread" },
    { 0xF2DF21E6, "aithreadthreader" },
    { 0xC6AF242D, "aithreatwaiter" },
    { 0xD5494404, "aitodeleteareatargetname" },
    { 0x3CA7BAA8, "aitouchers" },
    { 0xFFFF4C8F, "aitriggerspawnflags" },
    { 0x2D912ED9, "aiturnnotifies" },
    { 0x312FFE43, "aitype" },
    { 0x31B27CC2, "aitype_bigdog" },
    { 0xFB529893, "aitype_pistol" },
    { 0xB855FEB2, "aitypes" },
    { 0xD494868D, "aitypes_charactersettings" },
    { 0x20022EC6, "aitypevariant" },
    { 0xACF483EA, "aiupdateanimstate" },
    { 0x722249B8, "aiupdatecombat" },
    { 0xCCBD8C9C, "aiupdatemessages" },
    { 0x315E697E, "aiupdatesuppressed" },
    { 0x90D31901, "aiutility" },
    { 0xE54CC318, "aivsai" },
    { 0xA96B0152, "aivsaianimcustom" },
    { 0x120944FC, "aivsaimelee" },
    { 0xF27E1082, "aivsaimeleeaction" },
    { 0xF77426DB, "aivsaimeleeanim" },
    { 0x7EC7A8BC, "aivsaimeleebundleexists" },
    { 0xC58B6AA0, "aivsaimeleecharge" },
    { 0xBCDA1AD4, "aivsaimeleecombat" },
    { 0x6E8328CE, "aivsaimeleeinitialize" },
    { 0x32BC8627, "aivsaimeleerangesq" },
    { 0x20B9DF71, "aivsaimeleewinner" },
    { 0x4495F04F, "aiweapon" },
    { 0xFD2120AE, "ajoining" },
    { 0x8C496009, "ak" },
    { 0x76B76142, "ak47" },
    { 0xDADE0B47, "ak47gl" },
    { 0xD3C60225, "ak74u" },
    { 0x5FB8CCCB, "ak_fx_lookup" },
    { 0x7991CC62, "aka" },
    { 0x84E14402, "akeys" },
    { 0x9ECEEBA7, "akia" },
    { 0x08BAAECD, "akillspawners_gate" },
    { 0x0C57DF2B, "akillspawnertrigs" },
    { 0x5D7C795D, "akilltriggers" },
    { 0xAFE4A23B, "akilltrigs" },
    { 0x14CBA5FC, "akilltrigsdirectory" },
    { 0xFA2C335F, "akilltrigspawners" },
    { 0xB1740F76, "aku" },
    { 0x4A55C416, "al" },
    { 0x3783D8F8, "al_all_setup" },
    { 0xC46C6412, "al_asad_recording" },
    { 0x80B6DBEB, "ala" },
    { 0x07F2A8CB, "alais" },
    { 0x7A33BE6C, "alarm" },
    { 0x914F97DD, "alarm1" },
    { 0xB7521246, "alarm2" },
    { 0xDD548CAF, "alarm3" },
    { 0xB3B3BA50, "alarm_1" },
    { 0x25BB298B, "alarm_2" },
    { 0xFFB8AF22, "alarm_3" },
    { 0x71C01E5D, "alarm_4" },
    { 0x4BBDA3F4, "alarm_5" },
    { 0xBDC5132F, "alarm_6" },
    { 0x97C298C6, "alarm_7" },
    { 0x6B44CAD9, "alarm_altitude" },
    { 0x1D37EB2E, "alarm_caution" },
    { 0xEF9D7FDF, "alarm_cobra_altitude" },
    { 0x67640404, "alarm_cobra_caution" },
    { 0x33A231A3, "alarm_cobra_pullup" },
    { 0x9C418F1F, "alarm_cobra_warning" },
    { 0x7F30F760, "alarm_echo" },
    { 0x9A310BC2, "alarm_ent" },
    { 0xEB93C5F4, "alarm_ent_decon" },
    { 0xE411465C, "alarm_guy" },
    { 0xDA16F89D, "alarm_loop" },
    { 0xB52D2C2F, "alarm_mg_guy" },
    { 0x0DF2DDB2, "alarm_off" },
    { 0x59531B84, "alarm_on" },
    { 0x9188A5A9, "alarm_origin" },
    { 0x6AA0C7BF, "alarm_prelaunch" },
    { 0xCF91DC3D, "alarm_pullup" },
    { 0xADD90502, "alarm_snd_ent" },
    { 0xD7135488, "alarm_sound" },
    { 0x609508A3, "alarm_sound_thread" },
    { 0xFBB5A06A, "alarm_sound_threshhold" },
    { 0x296FDFE9, "alarm_start" },
    { 0xA25D0433, "alarm_stop" },
    { 0x0D39DDEC, "alarm_struct" },
    { 0x892F9F7A, "alarm_timer" },
    { 0xB43AD6C2, "alarm_timer_post_rocket" },
    { 0xD87F7289, "alarm_warning" },
    { 0xD2910D4F, "alarmed" },
    { 0x5CB5F26F, "alarms" },
    { 0x300390D9, "alarms_computer" },
    { 0x49AD98EF, "alarms_lab" },
    { 0x5E521F06, "alarms_lab_out" },
    { 0x0572A23C, "alarms_lab_out_off" },
    { 0xD3E3D41A, "alarms_office" },
    { 0x11E69086, "alarms_out" },
    { 0xD4A42CA3, "alarms_outside" },
    { 0xEFBB2946, "alarms_spotlight" },
    { 0xF037E02A, "alarmstatus" },
    { 0x915D02B1, "alarmstatusold" },
    { 0xD6E4DC86, "alarmtimes" },
    { 0xA46CC60F, "alarmz_trig" },
    { 0xE6FA85C1, "alasad" },
    { 0x035CD1E7, "alasad_area" },
    { 0xB30F00D6, "alasad_cell_phone_ring" },
    { 0x880C17E4, "alasad_cell_phone_sounds" },
    { 0x9A7ABF7F, "alasad_deletable_hide" },
    { 0x132EA0DC, "alasad_deletable_show" },
    { 0x1C8AD53C, "alasad_execution_notes" },
    { 0x1813DC24, "alasad_flashbang" },
    { 0xC0477256, "alasad_flashbang_location" },
    { 0xF7446F30, "alasad_guard1" },
    { 0x694BDE6B, "alasad_guard2" },
    { 0xC8D48648, "alasad_kill_axis" },
    { 0x645F71AC, "alasad_notetracks" },
    { 0xB1549EE5, "alasad_objective_location" },
    { 0xB40A629C, "alasad_possible_objective_locations" },
    { 0x237F75BD, "alasad_possible_objective_locations_remaining" },
    { 0x1DB29AFB, "alasad_sequence_canceled" },
    { 0xBE6720C0, "alasad_sequence_init" },
    { 0x6D746943, "alasad_sequence_ready" },
    { 0xAF98EAB6, "alasad_sequence_start" },
    { 0xFD5F1979, "alasad_sequence_started" },
    { 0x352A569D, "alasad_sequence_wait" },
    { 0x852B2079, "alasadfirstshotspawnertargetname" },
    { 0x7F61F0AD, "alasadsecondshotspawnertargetname" },
    { 0x869E1ED5, "alasadspawnertargetname" },
    { 0xE53C288E, "alaska" },
    { 0x7EDA2FE4, "alavi" },
    { 0xD7F86579, "alavi_looked" },
    { 0x28BEC295, "alcatraz" },
    { 0x917BF018, "alcatraz_add_player_dialogue" },
    { 0x2112754A, "alcatraz_afterlife_doors" },
    { 0x7EB73147, "alcatraz_audio_custom_response_line" },
    { 0xBBD7D022, "alcatraz_audio_custom_weapon_check" },
    { 0x14ACC37C, "alcatraz_audio_get_mod_type_override" },
    { 0x0B1EB36E, "alcatraz_craftable_trigger_think" },
    { 0xFE00FE3F, "alcatraz_custom_crawler_spawned_vo" },
    { 0x0673B86F, "alcatraz_custom_zombie_oh_shit_vox" },
    { 0xCFC6A5DD, "alcatraz_final_battle" },
    { 0x0F17F880, "alcatraz_first_magic_box_seen_vo" },
    { 0x9D379455, "alcatraz_give_shield" },
    { 0x2BBD05D5, "alcatraz_grief_laststand_weapon_save" },
    { 0x73279138, "alcatraz_round_spawn_failsafe" },
    { 0x4BC9EE4B, "alcatraz_setup_unitrigger_craftable" },
    { 0x9BE4457D, "alcatraz_setup_unitrigger_craftable_internal" },
    { 0xC15753F7, "alcatraz_shield_zm_given" },
    { 0xB515A23D, "alcatraz_shield_zm_taken" },
    { 0x769BF8AB, "alcove" },
    { 0x18DB88CC, "alcove_redshirts" },
    { 0x99EDB3E9, "alcove_redshirts_meet_squad" },
    { 0xC9FB1E99, "alcove_spawners" },
    { 0xBE56E161, "alcove_traverse_fx" },
    { 0xEF8BD6C3, "alden" },
    { 0x029B9A33, "alejandro" },
    { 0x8FD3E2F7, "alereted" },
    { 0x78A7A5B9, "alert" },
    { 0xBECE8524, "alert2look_cornerl" },
    { 0x114597C9, "alert_all_drones" },
    { 0xA7CC984B, "alert_all_on_stealth_break" },
    { 0xA1709E4B, "alert_array" },
    { 0xA1D891DC, "alert_choppers" },
    { 0x04A56B83, "alert_compound" },
    { 0xD7CA7299, "alert_delay" },
    { 0x6DB8039A, "alert_dog" },
    { 0x6F7DAFDF, "alert_dog_handler" },
    { 0x71400290, "alert_event_notify" },
    { 0xE727F5F9, "alert_funcs" },
    { 0xA29CAB47, "alert_functions" },
    { 0x2308613C, "alert_installation" },
    { 0x177A0E9E, "alert_level" },
    { 0xEF457981, "alert_light_fx_handles" },
    { 0x114087D5, "alert_mggunner" },
    { 0x666F16E3, "alert_nearby_for_30_seconds" },
    { 0x6E3A0E92, "alert_none" },
    { 0xCEF03463, "alert_notify_wrapper" },
    { 0x9259E1F2, "alert_other_chopper" },
    { 0x8A469C7B, "alert_outside_guys_on_death" },
    { 0x987CA2BD, "alert_scanning" },
    { 0xD1710842, "alert_security_system" },
    { 0x370CF3ED, "alert_see" },
    { 0xD9FA71EC, "alert_snipers" },
    { 0x37E55731, "alert_sound" },
    { 0xA81D6005, "alert_station_guards" },
    { 0x81CBF51A, "alert_to_exposed_anim" },
    { 0x7FFEBDE5, "alert_trigger_check" },
    { 0x32BD1D43, "alert_triggers" },
    { 0x3F8A2F22, "alert_tunnel_guy" },
    { 0xE34BF8ED, "alert_tunnel_guys" },
    { 0x7210E941, "alert_walking_villagers" },
    { 0x4AF3E7AC, "alertatoneandtwominutes" },
    { 0xAFA26C69, "alertdist" },
    { 0xEE8BEFF4, "alertdistance" },
    { 0x4F5E49E6, "alerted" },
    { 0x03EBD2FD, "alerted_by_gunfire" },
    { 0xEC1A5CF0, "alerted_by_others" },
    { 0x29DCF728, "alerted_terrorists" },
    { 0x6B2D3D82, "alerted_time" },
    { 0xDA68890E, "alerted_timeout" },
    { 0x8CE1282E, "alertface" },
    { 0x7785F285, "alertfriendsaboutenemies" },
    { 0x838C50CF, "alerting" },
    { 0x5A31CECA, "alertlightfx1" },
    { 0xFB61230C, "alertness" },
    { 0x8187E31A, "alertnotify" },
    { 0xD7F800F0, "alerts" },
    { 0x3150FEC2, "alertsource" },
    { 0x1AC2E83C, "alery" },
    { 0x97511435, "alex" },
    { 0x38894794, "alexc" },
    { 0x429AA073, "alexl" },
    { 0x4A69103F, "alexp" },
    { 0x9A76A756, "alexp_mod" },
    { 0xBEEF48DB, "alexp_print" },
    { 0x8FA79AAA, "alexp_todo" },
    { 0x4ECB0FCD, "alfeche" },
    { 0x02AFE664, "algorithm" },
    { 0xCCA06F91, "aliai" },
    { 0x48B937AB, "alias" },
    { 0x21071B78, "alias1" },
    { 0x930E8AB3, "alias2" },
    { 0x6D0C104A, "alias3" },
    { 0xDF137F85, "alias4" },
    { 0x7F0B410B, "alias_name" },
    { 0x399F6CEE, "alias_override" },
    { 0x6AC79F92, "alias_prefix" },
    { 0xDAEABE55, "alias_suffix" },
    { 0xE48B50AE, "alias_to_play" },
    { 0x9CFAC1C4, "alias_to_rival" },
    { 0xAFCBD6D3, "alias_to_team" },
    { 0xE00AAEB6, "alias_type" },
    { 0x553C1E22, "aliasanimations" },
    { 0xEFDF0596, "aliasarray" },
    { 0x9658D63A, "aliasent" },
    { 0x5029A64F, "aliases" },
    { 0x261C0846, "aliasname" },
    { 0xEC0375E5, "aliasnum" },
    { 0x744692C7, "aliasprefix" },
    { 0xCF29ABAC, "aliasstring" },
    { 0xEA2F4EFC, "align" },
    { 0xCEC8E246, "align_aim" },
    { 0xBD91F667, "align_angles" },
    { 0xD1E7951B, "align_beg" },
    { 0x385CC4E9, "align_camera_beg" },
    { 0x76543104, "align_camera_end" },
    { 0xD5CC0A3D, "align_changed" },
    { 0xFC797B62, "align_end" },
    { 0x9C51D4D2, "align_ent" },
    { 0xD8E06488, "align_face" },
    { 0xD62833F6, "align_friendlies" },
    { 0xE7B57222, "align_hologram" },
    { 0x725412C5, "align_holotable" },
    { 0x823767D5, "align_hudson_beg" },
    { 0x0E6F9E28, "align_hudson_end" },
    { 0x79B74B73, "align_huey_beg" },
    { 0xD90793AA, "align_huey_end" },
    { 0x7482C6EC, "align_mason_beg" },
    { 0xDF7C4419, "align_mason_end" },
    { 0xA91F6CD4, "align_masonjr_beg" },
    { 0x0146EA31, "align_masonjr_end" },
    { 0x2D7613BB, "align_node" },
    { 0x0567A148, "align_node1" },
    { 0x776F1083, "align_node2" },
    { 0x85FAF158, "align_node_apc" },
    { 0xDB426FDF, "align_node_nva" },
    { 0xDCA439D1, "align_node_player" },
    { 0x53BE5F08, "align_node_targetname" },
    { 0xD20B305A, "align_nodes" },
    { 0x1FE66057, "align_north_beg" },
    { 0xB9FBEBC6, "align_north_end" },
    { 0xAB5525EA, "align_object" },
    { 0x92E260EA, "align_offset" },
    { 0x55BFF4B7, "align_org" },
    { 0x391D2857, "align_point" },
    { 0x0B4B1048, "align_ready" },
    { 0xD34F311C, "align_struct" },
    { 0xF7E8E317, "align_swim_to_anim" },
    { 0x5E462C25, "align_tag" },
    { 0xC887A10C, "align_target" },
    { 0x791FC185, "align_test_struct" },
    { 0x109FA590, "align_to" },
    { 0x2B2F0601, "align_to_tag" },
    { 0x336E1691, "align_x" },
    { 0x0D6B9C28, "align_y" },
    { 0xCFEEA1DF, "aligned" },
    { 0x7B3BFBD5, "aligned_anim" },
    { 0x988B94CC, "aligning" },
    { 0x705C9C08, "alignment" },
    { 0x300D9077, "alignment_type" },
    { 0x835A3810, "alignnode" },
    { 0x312B5059, "alignobject" },
    { 0xFD115AD4, "aligntag" },
    { 0x5E95BD47, "aligntarget" },
    { 0xF3E9EFC1, "aligntargettag" },
    { 0x0F4A0E4F, "aligntogoalangle" },
    { 0x2C51CF03, "aligntonodeangles" },
    { 0xB5536ACC, "alignx" },
    { 0xDB55E535, "aligny" },
    { 0x5FFF3E2B, "alinked_nodes" },
    { 0xC74E06E2, "alis" },
    { 0x1352FBB4, "aliu" },
    { 0xDE993F50, "alive" },
    { 0x54232FFC, "alive_a" },
    { 0x0668BEC5, "alive_ai" },
    { 0x52DCE93A, "alive_array" },
    { 0x80F3FA34, "alive_count" },
    { 0x840FECE2, "alive_dogs" },
    { 0xCE1F05AC, "alive_group" },
    { 0xA81BC713, "alive_guys" },
    { 0x7402DF33, "alive_nearby_ai" },
    { 0xF5ED5502, "alive_tanks" },
    { 0x415FB3C7, "alive_team_players" },
    { 0xB08A0054, "alive_time" },
    { 0xC2F0038D, "alivecount" },
    { 0xBBD67D26, "aliveplayers" },
    { 0x9114F7EB, "aliveteam" },
    { 0x2832FF3E, "alivetimecurrentindex" },
    { 0xECE27994, "alivetimemaxcount" },
    { 0x98E9B70A, "alivetimes" },
    { 0x531A067F, "alivetimesaverage" },
    { 0x22D21E6E, "all" },
    { 0xEA93D4E7, "all_actors_resume_speed" },
    { 0x1E544EEB, "all_ai" },
    { 0xEED56DAC, "all_ai_unloaded" },
    { 0xD44DF73F, "all_allies" },
    { 0xF47E314B, "all_allies_targetme" },
    { 0xAE44580B, "all_ally" },
    { 0x1DDFD6FE, "all_axis" },
    { 0x26051A9E, "all_axis_spawners" },
    { 0x65E72E2C, "all_barrels" },
    { 0x96839334, "all_blockers" },
    { 0xFF10DF05, "all_boards_repaired" },
    { 0x747B98BB, "all_boats_dead" },
    { 0x9C276E4D, "all_bombs_set" },
    { 0xB9DD231B, "all_challenges_complete" },
    { 0xC3FD10F4, "all_challenges_in_game_achievement" },
    { 0x36EF0D1C, "all_challenges_in_level_achievement" },
    { 0x8A5CB9D3, "all_chunks_destroyed" },
    { 0x6CB3E237, "all_chunks_intact" },
    { 0x7EF958C4, "all_complete" },
    { 0x17DF5B5D, "all_crates" },
    { 0xF528AD2B, "all_dead" },
    { 0x1D66AC50, "all_drones" },
    { 0x3E32F715, "all_dynamite_planted" },
    { 0x8D8F9DAD, "all_end_scene_guys_dead" },
    { 0x112437EE, "all_entities_exist_by_name" },
    { 0x7D28F860, "all_explosives_set" },
    { 0xABCB2BFC, "all_far" },
    { 0x2B5938E8, "all_friendlies" },
    { 0xECFD1391, "all_friendlies_turn_blue" },
    { 0x6B69FCB0, "all_friends" },
    { 0xF680B743, "all_friends_hold_fire" },
    { 0x39050949, "all_friends_resume_fire" },
    { 0xB5CE6E97, "all_funcs_ended" },
    { 0x314E2049, "all_god" },
    { 0xD160BD94, "all_guns_destroyed" },
    { 0xEC5A4C31, "all_guys" },
    { 0xE16FB4B2, "all_in_position" },
    { 0x0DE8014B, "all_intel_achievement" },
    { 0x1A80EACA, "all_killed" },
    { 0xD0A6D13C, "all_knowing" },
    { 0x7075A490, "all_locs" },
    { 0xE35D4275, "all_macguffins_acquired" },
    { 0x48C47AC7, "all_models" },
    { 0x988C4674, "all_modes_active" },
    { 0x03E7806C, "all_nodes" },
    { 0xE1DE0302, "all_obj_locs" },
    { 0x34BC9347, "all_objects" },
    { 0x743227C6, "all_opened" },
    { 0x1959B1A5, "all_out_bunker" },
    { 0xB21D0ED6, "all_path_vc_killed" },
    { 0x67AE69B5, "all_players" },
    { 0xF7B001BD, "all_players_connected" },
    { 0xEA71D2B2, "all_players_dead" },
    { 0x49D54636, "all_players_flung" },
    { 0x405C1391, "all_players_in_position" },
    { 0x6BE7ACFC, "all_players_play_viewhands" },
    { 0xC1660872, "all_players_spawned" },
    { 0xC4C102F6, "all_players_still_touching" },
    { 0xD61FBD4B, "all_players_touching" },
    { 0x0DCFE3A8, "all_players_trapped" },
    { 0x7B686635, "all_prone" },
    { 0x50B6BC5C, "all_ready_msg" },
    { 0xA087998C, "all_reels" },
    { 0x31C00A4C, "all_rockets" },
    { 0x5F9183EE, "all_safe" },
    { 0x9E317790, "all_scientists_are_dead" },
    { 0xDD8494A9, "all_scientists_dead" },
    { 0xF5231B74, "all_screens_black" },
    { 0x9D4CD769, "all_sentinel_arms_destroyed" },
    { 0xE2061F0C, "all_smoke_solved" },
    { 0xFDE2B9D9, "all_snipers_killed" },
    { 0x1D91E794, "all_sp" },
    { 0xDCAC6750, "all_spawn_locs" },
    { 0x3D7A3AAE, "all_spawners" },
    { 0xC38C3307, "all_squads_attack" },
    { 0xABC4CE3C, "all_squads_move" },
    { 0x7CBA94D6, "all_staffs_crafted_vo" },
    { 0xF8BA2E08, "all_staffs_inserted_in_puzzle_room" },
    { 0xBEC0C458, "all_stats_fetched" },
    { 0x83BEF641, "all_story_boats_dead" },
    { 0xC8063DB5, "all_structs" },
    { 0x4614313C, "all_tanks_destroyed" },
    { 0xAED6F3BC, "all_tanks_full" },
    { 0xD74258D9, "all_targets" },
    { 0x652C7116, "all_tb_groups" },
    { 0x3B9E6F71, "all_trash" },
    { 0x5F2EC1D0, "all_trees" },
    { 0xBEFF8F73, "all_trigger" },
    { 0x302C97B6, "all_trigs" },
    { 0x387AB8AD, "all_vcs_killed" },
    { 0x2A1CD906, "all_veh_destroyed" },
    { 0x56A59E06, "all_vehicles" },
    { 0x110CD396, "all_watch_triggers" },
    { 0x74AD1B6A, "all_waves_spawned" },
    { 0x3A74BC97, "all_yours" },
    { 0xB1C936E4, "all_yours_vignette" },
    { 0xAB4DFA63, "all_zombies_dead" },
    { 0xF55E76EE, "all_zones" },
    { 0xAAB28721, "all_zones_captured_none_lost" },
    { 0x8285C0CB, "all_zones_captured_vo" },
    { 0x9B557C88, "allai" },
    { 0xF83A3569, "allalive" },
    { 0xA98289A4, "allammo" },
    { 0x8B5E1B47, "allcargoholdfx" },
    { 0x5EEF69BC, "allcarsdamagedbyplayer" },
    { 0x8B3B9240, "alldead" },
    { 0x389381C0, "alldeadteamcount" },
    { 0xF75940CF, "alldominated" },
    { 0x25EBF159, "alldudes_2_come" },
    { 0x0F88F43B, "allen" },
    { 0x2688908A, "allenemies" },
    { 0xF8733885, "allenemyaliveplayers" },
    { 0x262C8364, "allents" },
    { 0x375DBA98, "alleviate" },
    { 0xD3A9BA73, "alleviates" },
    { 0x95B31534, "alley" },
    { 0x000D6B94, "alley_aa_gun_setup" },
    { 0x6D8CA607, "alley_balcony_fall" },
    { 0x44227D4D, "alley_balcony_guy" },
    { 0xCE8BAA16, "alley_balcony_guys_setup" },
    { 0x4C624CDB, "alley_blocker" },
    { 0xC9388736, "alley_bullets" },
    { 0x0E0F856B, "alley_car_explosion" },
    { 0x136E8CBC, "alley_civ_1_react_then_idle" },
    { 0xACE2F6C7, "alley_civ_2_react_then_idle" },
    { 0x35503469, "alley_civ_mourning" },
    { 0x338FEC4F, "alley_civilians" },
    { 0xFC6E7BE6, "alley_clean_up" },
    { 0xECEE93AD, "alley_clean_up_civilians" },
    { 0x074FB47D, "alley_cleanup" },
    { 0x789F4ABD, "alley_cleared" },
    { 0x989404F6, "alley_close_smg_engagementdistance" },
    { 0x94AC78A7, "alley_close_smgguys" },
    { 0x18E749DD, "alley_cross_chopper_shootdown" },
    { 0x3E5672AA, "alley_cross_chopper_shootdown_go" },
    { 0xC0126E1F, "alley_door" },
    { 0x8DF3026A, "alley_door_breached" },
    { 0x8A2013E9, "alley_door_guy1_idle" },
    { 0x5CA28518, "alley_door_kick" },
    { 0xD14113FF, "alley_door_remove_player_clip" },
    { 0xD9F8476A, "alley_door_scene" },
    { 0x8449D9AB, "alley_door_scripted_node" },
    { 0x5CC5E96B, "alley_dooropen" },
    { 0x782CC730, "alley_dudes1_2_flamer_setup" },
    { 0xC7A68FFE, "alley_dudes1_2_setup" },
    { 0x50767727, "alley_dudes1_3_setup" },
    { 0xB1EC06F9, "alley_dudes1_setup" },
    { 0x7F85BF06, "alley_dudes2_setup" },
    { 0x260540A3, "alley_dumpster_sequence" },
    { 0x6C8ED093, "alley_flamer_fire_control" },
    { 0x76F521CD, "alley_flank_ai_behavior" },
    { 0x08C7F857, "alley_force_death" },
    { 0x9EFE2AE9, "alley_gas_attack" },
    { 0x9EC2365B, "alley_kicker_inplace" },
    { 0x6377159B, "alley_player_jump" },
    { 0x83B05D41, "alley_playerseeker" },
    { 0xABB9067A, "alley_prisoner_choke" },
    { 0xB9E58904, "alley_prisoner_gas_attack" },
    { 0xB0024EB1, "alley_rat_start" },
    { 0x3E1C8AAD, "alley_roof_guy" },
    { 0x620E85AC, "alley_roof_guys" },
    { 0xA71CBC0F, "alley_rooftop_guards" },
    { 0x01BE65A0, "alley_seperation_clip" },
    { 0x5685B366, "alley_set_underwater_fog" },
    { 0xB9EFE3AE, "alley_setup" },
    { 0x6975BE31, "alley_smg_engagementdistance" },
    { 0xC664C913, "alley_smg_playerseeker" },
    { 0xB93C56AE, "alley_smgguys" },
    { 0x44778831, "alley_sniper_engagementdistance" },
    { 0x6CA88FC1, "alley_snipers" },
    { 0x7C1DE136, "alley_spawn_functions" },
    { 0x71D67D0F, "alley_tank_fire_loop" },
    { 0x5DB78C49, "alley_tank_setup" },
    { 0x6BBA3E20, "alley_truck_destroyed" },
    { 0x288FD929, "alley_volume" },
    { 0xD6A81DFC, "alley_wait" },
    { 0x96E53632, "alley_window_blowout" },
    { 0xF1F5D1BF, "alley_window_explosion" },
    { 0x62731CD3, "alleydudes4_setup" },
    { 0x5DE1737F, "alleyfriends" },
    { 0xBEFFD1C1, "alleyguys_dead" },
    { 0x2099E70E, "alleyguysdead" },
    { 0xADDC4227, "alleys" },
    { 0xDC253BCB, "alleytank_doorblast" },
    { 0x3B4A58A0, "alleytrigger" },
    { 0x6F9A2D91, "alleyway" },
    { 0x2FA17906, "alleyway_fx" },
    { 0x7B0D0F5E, "alleyway_to_checkpoint_vo" },
    { 0xF91B96E8, "allfated" },
    { 0x2988B45C, "allfunctionsstarted" },
    { 0x897BB45E, "allguys" },
    { 0xF52714E0, "allied" },
    { 0x27759BD5, "allied_ai" },
    { 0x1158B720, "allied_base" },
    { 0xFF5BD574, "allied_center" },
    { 0x92F8884B, "allied_drone_behaviour" },
    { 0xA027968F, "allied_drone_spawn_wrapper" },
    { 0xD0A9857D, "allied_flag" },
    { 0x432F39B7, "allied_grenade_safe_dist_sq" },
    { 0xE38D136C, "allied_quadrotor_control" },
    { 0x6045BB26, "allied_quadrotor_count" },
    { 0xB348B283, "allied_quadrotors_move_ahead_and_delete" },
    { 0x1F2F8D75, "allied_spawner" },
    { 0x4FECEFB5, "allied_team_bow_support" },
    { 0xDE2A698C, "allied_team_deck_support" },
    { 0xA55438B5, "allieddistanceweight" },
    { 0x160D2296, "alliedplayers" },
    { 0x75A6F436, "alliedscore" },
    { 0x5F60144F, "allies" },
    { 0x09F16C84, "allies_ai" },
    { 0x6636A5EE, "allies_asd" },
    { 0x2B41FBC5, "allies_captured_flag" },
    { 0x3CEF1ABE, "allies_classnames" },
    { 0xC5A03EBF, "allies_claw" },
    { 0xA5901127, "allies_count" },
    { 0xC652098C, "allies_crouch" },
    { 0x3680D335, "allies_crouch_near_chopper" },
    { 0x60F029D0, "allies_delay_crouch" },
    { 0xE2BDDD93, "allies_drones" },
    { 0x1FDC6DC4, "allies_helo" },
    { 0xBF2D20CC, "allies_hold_fire" },
    { 0x3C561BD3, "allies_move_up" },
    { 0x219D3248, "allies_moveup_chatter" },
    { 0xFA3B134B, "allies_needs_revive" },
    { 0x0FD56801, "allies_nodes" },
    { 0x1F32BE82, "allies_num" },
    { 0x658D8198, "allies_only" },
    { 0x49D652B4, "allies_overfence_dialogue" },
    { 0xD0E3D751, "allies_plane_init" },
    { 0x85A6D721, "allies_plaza_assaulters_think" },
    { 0x85BEE8C7, "allies_pop_adjust" },
    { 0x6B2AC30E, "allies_quads" },
    { 0x0A257F38, "allies_structs" },
    { 0x8CF1C215, "allies_team" },
    { 0xBECBF21D, "allies_triggers" },
    { 0x54F3F08B, "alliesaccuracycontrol" },
    { 0x5B14B3B5, "alliesblitzkriegcountdown" },
    { 0x50818301, "alliescharset" },
    { 0xBE495A7A, "alliesflagcount" },
    { 0x11495AFB, "allieshigh_spawnfunction" },
    { 0x39728B78, "alliesobjective" },
    { 0x49154777, "alliesofficer_spawnfunction" },
    { 0x089A814E, "alliesplanemodel" },
    { 0xC7F086BB, "alliesplayers" },
    { 0xC81A7D05, "alliesroundscore" },
    { 0xB179DB83, "alliesroundstartscore" },
    { 0xDA50DF08, "alliesroundswon" },
    { 0x5345355F, "alliesscore" },
    { 0x3D6BCAD8, "alliesshadesmodel" },
    { 0x68454892, "alliesteamscore" },
    { 0xEBF9C791, "alliestrig" },
    { 0xE7A9E4E6, "alll" },
    { 0xCFB8C49E, "allmissionscompleted" },
    { 0x5984968D, "allnodes" },
    { 0x6242E558, "allocated" },
    { 0xE163811C, "allocatemixerlights" },
    { 0x3BF4650F, "allocatesoundrandoms" },
    { 0x50F4FAFB, "allocatetransport" },
    { 0x6181E983, "allocation" },
    { 0x35D85094, "allocation_max" },
    { 0x2E85FD2E, "allocation_remaining" },
    { 0xA5DCA82D, "allocationfree" },
    { 0xEF61592D, "allocationspent" },
    { 0x4BFD9434, "allocvoxid" },
    { 0x07E98255, "alloff" },
    { 0x9E1B81A2, "allofit" },
    { 0x2A8600AC, "alloted_time" },
    { 0x9A87B38B, "allotment" },
    { 0x26BCDCEA, "allotted" },
    { 0x6DF23D98, "allow" },
    { 0x4AAA4B4B, "allow_ai_vs_ai_melee" },
    { 0xC532D79B, "allow_all_teams" },
    { 0x2CF41C8D, "allow_all_teams_except" },
    { 0x60F5BFD5, "allow_assists" },
    { 0xEAFFAB54, "allow_beacons_to_be_targeted_by_giant_robot" },
    { 0x8F2B25AF, "allow_brutus_powerup_spawning" },
    { 0xC635BA1D, "allow_bullet_damage" },
    { 0x25BD1F60, "allow_carry" },
    { 0xE2ED4612, "allow_crawl_control" },
    { 0x4778D0B6, "allow_cycling" },
    { 0xB98D8A20, "allow_divetoprone" },
    { 0x72840DC1, "allow_dom_object_placement" },
    { 0xC1283B2A, "allow_dupes" },
    { 0x3234D3F0, "allow_fall" },
    { 0x821DF72D, "allow_horse_sprint" },
    { 0xA3AD3ACD, "allow_map_vehicles" },
    { 0xA135B518, "allow_mashing" },
    { 0xC7470613, "allow_move_in_laststand" },
    { 0xC2FC9418, "allow_movement" },
    { 0x7AF1D4D9, "allow_oob" },
    { 0x74110B91, "allow_pain_old" },
    { 0x8BFE941D, "allow_player_drive_early" },
    { 0xE3E25599, "allow_player_input" },
    { 0xBC6FE330, "allow_player_movement" },
    { 0x296020DB, "allow_players_purchase" },
    { 0xD99BD22F, "allow_prone" },
    { 0x7442A216, "allow_purchase" },
    { 0xF436CE70, "allow_ragdoll_getout_death" },
    { 0xC0CA436F, "allow_rumbles" },
    { 0xF93ADFEE, "allow_run" },
    { 0x15F94536, "allow_sampans_to_attack_earlier" },
    { 0x7B4A8EE8, "allow_save" },
    { 0xDD11D490, "allow_shoot_chernov" },
    { 0xE4A57FD8, "allow_shooting" },
    { 0x418B6E8A, "allow_showcase_weapons" },
    { 0x8824B4D0, "allow_sidearm" },
    { 0x61F6EA0E, "allow_spectator" },
    { 0xC9F1C83E, "allow_stance_change" },
    { 0x18FA7D35, "allow_stance_time" },
    { 0x12F4CBF8, "allow_stand_after_chain" },
    { 0xE3C7E564, "allow_teamchange" },
    { 0xFABACC63, "allow_to_catch_on_fire" },
    { 0xBBE0E9C1, "allow_top_leg_to_break_off" },
    { 0x1E5CB2CC, "allow_use" },
    { 0xA5427F76, "allow_vehicle_challenge_check" },
    { 0x86D40796, "allow_weapon_switch" },
    { 0xB11ECD12, "allow_weapons" },
    { 0x23F90BA6, "allow_zombie_to_target_ai" },
    { 0xBD0BA7C0, "allowable" },
    { 0xFA3BA49E, "allowactionslotinput" },
    { 0xC20E893E, "allowads" },
    { 0x17988839, "allowaitoattack" },
    { 0x952F929C, "allowallstances" },
    { 0xCCFAE699, "allowance" },
    { 0x8BF9AFD1, "allowannouncer" },
    { 0x081919AC, "allowassists" },
    { 0xF996BD5C, "allowattack" },
    { 0x0CA3202D, "allowbattlechatter" },
    { 0xD656F2BC, "allowbottargetting" },
    { 0xF74A7905, "allowbreak" },
    { 0x4EAEE18D, "allowcarry" },
    { 0x08B71928, "allowcontinuedlockonafterinvis" },
    { 0x1C75A89A, "allowcrouch" },
    { 0xBAB9655E, "allowdeath" },
    { 0x586DDF95, "allowdeathshortcircuit" },
    { 0xCE78E15C, "allowdirectdamage" },
    { 0x0ECE6DAB, "allowed" },
    { 0x76DAB1AC, "allowed_attachments" },
    { 0x9E56380D, "allowed_depth_in_water_for_crawl" },
    { 0x2D0820E1, "allowed_game_modes" },
    { 0x053D31F7, "allowed_killstreaks" },
    { 0xA0B0F5A1, "allowed_shots" },
    { 0x4809B4F5, "allowed_stances" },
    { 0x44EE63AE, "allowedassistweapon" },
    { 0x1C32EB97, "alloweddist" },
    { 0x334F63C3, "alloweddistsq" },
    { 0xEE1BD2B7, "allowederror" },
    { 0xCD731B63, "allowedgameobjects" },
    { 0x69EAA481, "allowedkillstreak" },
    { 0x157C38A9, "allowedpartialreloadontheruntime" },
    { 0x9FFABE4A, "allowedperks" },
    { 0x9E1C25C2, "allowedstances" },
    { 0x6ABA0F7B, "allowedstancesstr" },
    { 0xCD743A99, "allowenemyspectate" },
    { 0xD4A94184, "allowes" },
    { 0x005555B6, "allowevasivemovement" },
    { 0xDE6B5588, "allowexit" },
    { 0xE3D9D7BC, "allowexposedaigrenadethrow" },
    { 0x01169CAA, "allowflagpickup" },
    { 0xCEBBADFE, "allowfoginnoclip" },
    { 0xF31E08A7, "allowfreespectate" },
    { 0xF28C5916, "allowfriendlyfiredamage" },
    { 0xB883A79E, "allowfriendlyfiredamageoverride" },
    { 0x556A176D, "allowgrenades" },
    { 0x5DFE8BA8, "allowhacked" },
    { 0x49550E27, "allowhackingaftercloak" },
    { 0x717F4A38, "allowhero" },
    { 0x065B4BD7, "allowherogadgets" },
    { 0xEFAF4D6C, "allowhitmarkers" },
    { 0xA3D56A80, "allowing" },
    { 0x043DD93C, "allowinitialholddelay" },
    { 0xED04153C, "allowjump" },
    { 0x0CAFE666, "allowkillstreakassists" },
    { 0x06302121, "allowkillstreaks" },
    { 0x1FD0E3BE, "allowkillstreakweapon" },
    { 0x4EE997A1, "allowkillstreakweapons" },
    { 0xAC3F0290, "allowlean" },
    { 0x715674CF, "allowlongrunningpain" },
    { 0x2B572C4B, "allowmainturretlockon" },
    { 0x0DD18A9B, "allowmanualdeactivation" },
    { 0x39D36B37, "allowmedrunningpain" },
    { 0xF68F147C, "allowmelee" },
    { 0xB575B604, "allowmultiple" },
    { 0xDAF3A648, "allowpain" },
    { 0x020455C7, "allowperks" },
    { 0x94AB7453, "allowpickupweapons" },
    { 0x3309EFEF, "allowpitchangle" },
    { 0x1F5366F6, "allowplayeroffset" },
    { 0x33DA1DF7, "allowplayerscore" },
    { 0x0205A447, "allowplayerteampip" },
    { 0xF5BA63F2, "allowprone" },
    { 0x5E774679, "allowproneblock" },
    { 0xE44890D6, "allowpushactors" },
    { 0xBB033C66, "allowqueuespawn" },
    { 0xA7170CA5, "allowreact" },
    { 0x22B9FF6A, "allowremotestart" },
    { 0x0B776ACB, "allowrevive" },
    { 0x0A2A981A, "allowroundanimation" },
    { 0xBF73F373, "allows" },
    { 0x17DCF452, "allows_multiple" },
    { 0xA8DF81CE, "allowscoreboard" },
    { 0x40A15CD3, "allowshortrunningpain" },
    { 0x4886BD2F, "allowspawndatareading" },
    { 0xD4ED9B67, "allowspecialistdialog" },
    { 0x927B3980, "allowspectateallteams" },
    { 0xAFEE73F0, "allowspectateallteamsexceptteam" },
    { 0x30FFFFE2, "allowspectateteam" },
    { 0x6FA6B424, "allowsprint" },
    { 0xA3624368, "allowstand" },
    { 0x0AECFE9B, "allowstepback" },
    { 0xCBDFFB4A, "allowtacticalinsertion" },
    { 0x7B0C24F7, "allowtint" },
    { 0x7FEF3417, "allowunloadifattacked" },
    { 0x845C1B61, "allowuse" },
    { 0x0A56F784, "allowvote" },
    { 0xB5852BBF, "allowweaponcyclingduringhold" },
    { 0x20B62787, "allowweapons" },
    { 0x61BF17AC, "allowzmbannouncer" },
    { 0xED0219C0, "allplayers" },
    { 0x93BFC6EE, "allplayers_s" },
    { 0xD8202611, "allspawners" },
    { 0xA22A6AAC, "allspears" },
    { 0xE514F3B7, "allsquads" },
    { 0x5881CFB8, "allteamshaveexisted" },
    { 0xA021EE79, "allteamsnearscorelimit" },
    { 0xA78C417D, "allteamsunderscorelimit" },
    { 0x2E2FFFF6, "alltheweapons" },
    { 0x98051B18, "alltopsidefx" },
    { 0x05D211E7, "alltrigs" },
    { 0xCF7CA78D, "allvehicles" },
    { 0xE3DFA2B5, "allvehiclesprespawn" },
    { 0xD5EE1562, "allways" },
    { 0xE2D8581B, "allweaponattachmentsunlocked" },
    { 0x6D7BD911, "allweapons" },
    { 0x157ACF1B, "ally" },
    { 0xD9135D80, "ally_ai" },
    { 0xF9186229, "ally_array" },
    { 0xFEED98A1, "ally_battle_think" },
    { 0xB6761645, "ally_bias" },
    { 0x3BE25A5C, "ally_blindfire_wait_time_max" },
    { 0xB67CAF52, "ally_blindfire_wait_time_min" },
    { 0x54D109B4, "ally_cam_active" },
    { 0x9F7675C5, "ally_cam_ent" },
    { 0x10DD34FE, "ally_cleanup" },
    { 0xC1CA195F, "ally_console_activate_watch" },
    { 0xFBC7CA44, "ally_console_do_anims" },
    { 0x28180D89, "ally_console_idle_anims" },
    { 0x99993A9C, "ally_console_watch_input" },
    { 0xD4A55E60, "ally_death" },
    { 0x87CD7C38, "ally_died" },
    { 0x205BF508, "ally_dmg_reducerfps" },
    { 0xE8B21330, "ally_dmg_reducerrts" },
    { 0x9A013023, "ally_drop_hud" },
    { 0xEB5E1C6C, "ally_dropdown_think" },
    { 0x11E1345C, "ally_drops_updated" },
    { 0x011F38AB, "ally_farm_spawner" },
    { 0x1A4EAC1A, "ally_find_status_by_ent" },
    { 0xA4E626F0, "ally_forced_farm_spawners" },
    { 0xAD3452F8, "ally_getbestnode" },
    { 0x2FCD9384, "ally_getcovernodeinradius" },
    { 0x105970A8, "ally_health_debug" },
    { 0x5372B04E, "ally_health_regen" },
    { 0xAC970443, "ally_health_scale" },
    { 0xC24F381D, "ally_hud_class_died" },
    { 0xE0C6E297, "ally_hud_getnumalive" },
    { 0xD5753AF0, "ally_hud_highlight" },
    { 0x56D814D3, "ally_hud_update" },
    { 0x24BD5DF2, "ally_index" },
    { 0x0F4C490B, "ally_init_hudelem" },
    { 0x821E9312, "ally_kill" },
    { 0x727189FD, "ally_killed_quad" },
    { 0xBA5A91C9, "ally_manifest" },
    { 0xF691F60F, "ally_missile_watcher" },
    { 0xC25250BD, "ally_move" },
    { 0x1FE60DD3, "ally_move_request_complete" },
    { 0x37F4F9ED, "ally_move_request_death_watcher" },
    { 0x4827ADE5, "ally_move_requested_already" },
    { 0xF61CF854, "ally_ok_to_move" },
    { 0x7C9B2E07, "ally_on_damage" },
    { 0x5443B15A, "ally_on_death" },
    { 0x46EEEB03, "ally_orgs" },
    { 0xC4002F98, "ally_perfect_aimtime" },
    { 0xD553306F, "ally_position_manager" },
    { 0x3F53CEB1, "ally_position_snaked_monitor" },
    { 0xC84DB92F, "ally_quadrotors_fly_away" },
    { 0xC7A21C09, "ally_rappels" },
    { 0xBEDB02C1, "ally_ref" },
    { 0xDDCD2EB7, "ally_remove_bullet_shield" },
    { 0x24EA756D, "ally_request_to_move" },
    { 0x02169ADB, "ally_screaming" },
    { 0xCDFE48A0, "ally_selection_update" },
    { 0x9034AD2D, "ally_setup" },
    { 0xCD107BC8, "ally_showdown_spawner" },
    { 0x188BF476, "ally_spawner" },
    { 0x5339CD69, "ally_spawners" },
    { 0x18391785, "ally_spawning" },
    { 0x6048DD77, "ally_special_node_origin" },
    { 0x649AE063, "ally_special_node_radius" },
    { 0x85ACE72F, "ally_special_node_radiussq" },
    { 0x886DDF40, "ally_squad_manager" },
    { 0xC756BC8C, "ally_squad_setposition" },
    { 0x1327B1E0, "ally_squad_size" },
    { 0x4E39D53A, "ally_squadmember_setposition" },
    { 0x494978C1, "ally_starts" },
    { 0x0E7AAD89, "ally_switch_abort" },
    { 0xBABAD29D, "ally_switch_button" },
    { 0xC8CCFE57, "ally_switch_input" },
    { 0xFDF19E59, "ally_switch_on_death" },
    { 0x2B50F65B, "ally_switch_think" },
    { 0x0C6FBD9E, "ally_tank" },
    { 0x8690E839, "ally_team" },
    { 0xBFC825B3, "ally_team_setup" },
    { 0x78C83920, "ally_turret_sound" },
    { 0x95854B7B, "ally_us_seals_assault_ak47" },
    { 0x00378C14, "allycost" },
    { 0x3D616940, "allydistsum" },
    { 0xA7CFA085, "allying" },
    { 0xFE79589D, "allymaterialname" },
    { 0x00E4AA45, "allyradius" },
    { 0x43E4F075, "allyradiussq" },
    { 0x0FB792FC, "allyrevive" },
    { 0x5EAF89D3, "allyscore" },
    { 0xE922932E, "allysquads" },
    { 0x86FAB7C2, "allzpuflags" },
    { 0x15FF31F3, "almost" },
    { 0x312DF47E, "almost_all_guys" },
    { 0x73C4CE80, "almost_dead" },
    { 0x07F6C713, "almost_ready" },
    { 0x5E04FBFE, "alogn" },
    { 0x71676CDE, "alone" },
    { 0x2562780C, "along" },
    { 0x22CDC09D, "alongside" },
    { 0x08EAD82B, "alot" },
    { 0x3A10D310, "alouette_jumped" },
    { 0xAABE9F43, "alpha" },
    { 0xEABFDC18, "alpha_channel_flag" },
    { 0xFE0D2FCF, "alpha_channel_for_entity" },
    { 0xF5EF4C77, "alpha_dif" },
    { 0x3C254855, "alpha_end" },
    { 0x12F50760, "alpha_fade_time" },
    { 0x750D16D0, "alpha_mask_entity" },
    { 0x1FFDAC8B, "alpha_mask_flag" },
    { 0xB8CD5A00, "alpha_mask_for_entity" },
    { 0x4052433D, "alpha_masked_entity" },
    { 0x4B7A3AC3, "alpha_mode" },
    { 0xA1C2C595, "alpha_range" },
    { 0xAA2408F6, "alpha_start" },
    { 0x2402589B, "alpha_val" },
    { 0xAC99A070, "alphabet" },
    { 0x48624614, "alphabet_compare" },
    { 0x932B937F, "alphabet_vals" },
    { 0x10FBA27F, "alphabetical" },
    { 0x37F6FC26, "alphabetize" },
    { 0xEB483AFA, "alphadissolve" },
    { 0x96793A26, "alphadissolveamount" },
    { 0x28CFB768, "alphadissolvemaskcompression" },
    { 0x65F2DCF9, "alphainc" },
    { 0x2BB28823, "alraedy" },
    { 0x0F8FB4AE, "alread" },
    { 0x02B1215B, "already" },
    { 0xB47B4A58, "already_advanced" },
    { 0x996F5220, "already_assigned_height" },
    { 0x9C621079, "already_broken" },
    { 0xC55FCF13, "already_damaged" },
    { 0x767C99FF, "already_distance_monitored" },
    { 0x1552790D, "already_dying" },
    { 0xB96B547C, "already_existed" },
    { 0xA012601D, "already_in_array" },
    { 0xEB6BC4EE, "already_landed" },
    { 0x75E2EB70, "already_ran_function" },
    { 0xA08331B5, "already_said_are_you_drunk" },
    { 0xD42D8902, "already_said_closer" },
    { 0x53E54EA3, "already_showing" },
    { 0x0A4F154C, "already_shutdown" },
    { 0x23AD51B1, "already_switched" },
    { 0x94430D28, "alreadyattacked" },
    { 0x95ECF2DD, "alreadychosen" },
    { 0xF13ED9A9, "alreadydead" },
    { 0x08D97C22, "alreadygivenflipthisframe" },
    { 0xB37C6FC3, "alreadyignoreme" },
    { 0x26A72804, "alreadyinsquad" },
    { 0x6B35E678, "alreadyknown" },
    { 0x7D8FA639, "alreadylaunched" },
    { 0x2AF9E54C, "alreadyplayedneardeathfx" },
    { 0xBFB020AB, "alreadyprone" },
    { 0xC2835A4D, "alreadysetspawnweapononce" },
    { 0x2D6159F6, "alreadysmartstance" },
    { 0xB562DA7F, "alreadyspawned" },
    { 0xA32EE1D8, "alredy" },
    { 0xBD99D3D0, "alright" },
    { 0x33CBFDFC, "also" },
    { 0x2151862C, "also_has_upgrade" },
    { 0x7B681887, "alsodamageparent" },
    { 0x9296A496, "alt" },
    { 0x84AD8721, "alt_ammo_hud" },
    { 0x5387C542, "alt_bridge" },
    { 0x8763164A, "alt_bridge_breadcrumb" },
    { 0x9D70BE63, "alt_clip" },
    { 0x1A071F19, "alt_detonate" },
    { 0x38A6926A, "alt_fair_trigger" },
    { 0xCD4B7AC9, "alt_fire" },
    { 0x412A2A0B, "alt_flag_name" },
    { 0xAA27E05C, "alt_name" },
    { 0x12392F20, "alt_path" },
    { 0xE07BFF8F, "alt_poi" },
    { 0x64633775, "alt_pos" },
    { 0xD2CDDBDD, "alt_render_mode" },
    { 0xA19CB8E1, "alt_stock" },
    { 0x347D41CE, "alt_target" },
    { 0xFCFEE68D, "alt_title" },
    { 0x23835F5A, "alt_weap" },
    { 0x3A9623F5, "alt_weapon" },
    { 0x9256BF9C, "altammo" },
    { 0x91844522, "altbody" },
    { 0x4575234E, "altbutton" },
    { 0x4CA01B2E, "altdetonate" },
    { 0x01DB4A3F, "alter" },
    { 0xACE0FF44, "altered" },
    { 0x64C4BAC1, "altering" },
    { 0x458A8A71, "alternate" },
    { 0xB8C8F523, "alternate_end" },
    { 0x52F1E50D, "alternate_functionality" },
    { 0x42E422B0, "alternate_geysers" },
    { 0x53BD7C86, "alternate_goal_pos" },
    { 0xA81D4912, "alternate_node_name" },
    { 0xD3448F21, "alternate_path" },
    { 0xF27EC717, "alternate_seat" },
    { 0x788256D3, "alternate_sun_light" },
    { 0x55F962A1, "alternate_text" },
    { 0x974A3FD8, "alternates" },
    { 0x30F7A724, "alternating" },
    { 0x51B9696E, "alternating_fog_values" },
    { 0xC98A93D2, "alternating_vision_set" },
    { 0x06659BDE, "alternative" },
    { 0x5A937083, "alternatively" },
    { 0x280FB922, "altfireweapon" },
    { 0x4E2A5ABD, "altforward" },
    { 0x029478D2, "altfxdef1" },
    { 0xDC91FE69, "altfxdef2" },
    { 0xB68F8400, "altfxdef3" },
    { 0xC0A0DCDF, "altfxdef4" },
    { 0x9A9E6276, "altfxdef5" },
    { 0xD2FC333F, "although" },
    { 0x7D5C9352, "altimeter_shader" },
    { 0x170D8834, "altimeter_text" },
    { 0xAB1C0F92, "altindex" },
    { 0x17EC71B3, "altitude" },
    { 0x0447632D, "altitude_ui_data_model" },
    { 0xD9784F9D, "altmodel" },
    { 0x57F3AADB, "altname" },
    { 0xDAD74028, "altogether" },
    { 0x12ABAA09, "alts" },
    { 0x252BCCE1, "altshader" },
    { 0xB0D00A2C, "alttrig" },
    { 0x8ECFAE36, "altweapon" },
    { 0x41146B29, "altweapons" },
    { 0x4A28FF5F, "altyaw" },
    { 0x319C3E5A, "always" },
    { 0x4499389C, "always_allow" },
    { 0x9CFFEF01, "always_allow_ride" },
    { 0xDA7F60D3, "always_draw" },
    { 0x12950B77, "always_face_enemy" },
    { 0x3C756289, "always_kill" },
    { 0xA3920725, "always_pain" },
    { 0xCDE18787, "always_stand" },
    { 0xAAFA8A08, "alwaysperformgain" },
    { 0x7DD43ECC, "alwaysrunforward" },
    { 0x746DC9F5, "alwaysusestartspawns" },
    { 0x70583E7F, "am" },
    { 0xB487D521, "am_i_at_a_correctish_node" },
    { 0x82E61960, "am_i_valid" },
    { 0x994F563A, "amanualdets" },
    { 0x665C673A, "amazing" },
    { 0x65016F5F, "amb" },
    { 0xA8BA0539, "amb_alley" },
    { 0x7F1ABC58, "amb_alley_katyusha" },
    { 0x142DEB1D, "amb_alley_planes" },
    { 0xA3B8E934, "amb_civ_female_loop" },
    { 0xCD8068A9, "amb_civ_female_scream" },
    { 0xEBBEF3D3, "amb_civ_female_w_dog_loop" },
    { 0x6F1294FD, "amb_civ_male_loop" },
    { 0xE32264CC, "amb_dog_damage" },
    { 0x400E4245, "amb_dog_loop" },
    { 0x332FA807, "amb_fireplace" },
    { 0x3578BB11, "amb_friends" },
    { 0x980EB03B, "amb_ground_battle_loopers" },
    { 0xAE190209, "amb_hud" },
    { 0x069BBE61, "amb_marchers_goto" },
    { 0x6A8DBA01, "amb_radio_chatter" },
    { 0x06548ABE, "amb_surv_group_1" },
    { 0xA455F912, "amb_surv_spawners" },
    { 0xCB3F35AD, "amb_target" },
    { 0x603010BF, "amb_tension_laugh_trig" },
    { 0x2D3919AD, "amb_triggers" },
    { 0x47F19DF5, "amb_vtol" },
    { 0xBEB92D56, "ambanzaiattacking" },
    { 0xB37E048D, "ambiance" },
    { 0x20E30582, "ambiance_point" },
    { 0x873DBFF0, "ambiance_point_far" },
    { 0xE3A06F87, "ambiance_pulse_points" },
    { 0xE2A7C40F, "ambiant" },
    { 0x3199A845, "ambiant_bomb_exploders" },
    { 0x3F05C30C, "ambiant_effect_think" },
    { 0x54892A94, "ambiant_effect_thread" },
    { 0x3AC0AAC1, "ambiant_nodes" },
    { 0xB278CAEB, "ambiant_planes" },
    { 0x57E07AB5, "ambiant_planes_compound" },
    { 0xB3CF41CE, "ambiant_unused_nodes" },
    { 0xCA044BD1, "ambience" },
    { 0xDA375F5E, "ambience_alley_fire" },
    { 0x0389F527, "ambience_hud" },
    { 0x5D646419, "ambience_manager" },
    { 0x1D63D7A0, "ambience_randoms" },
    { 0x5A047848, "ambience_right_alley_truck" },
    { 0xECED015A, "ambience_sensitive_room" },
    { 0x17C63E53, "ambiencts" },
    { 0x4A3ECECB, "ambient" },
    { 0xED596F26, "ambient_aaa_fx" },
    { 0xFCCD886C, "ambient_aaa_fx_rotate" },
    { 0x7C182F2F, "ambient_activitiy_stop_warehouse_st_left" },
    { 0xC34661AF, "ambient_activity_crane_street" },
    { 0x9A2DA750, "ambient_activity_hotel_street" },
    { 0xF4BAD2E6, "ambient_activity_hotel_street_turn" },
    { 0x523BAB54, "ambient_activity_hotel_street_vehicles" },
    { 0xC428CAC8, "ambient_activity_park" },
    { 0x44699CEA, "ambient_activity_parking_structure" },
    { 0x15F54F29, "ambient_activity_warehouse_street" },
    { 0x52FC43B3, "ambient_air_allies_weapon_think" },
    { 0x39FDCBFC, "ambient_aircraft_flightpath" },
    { 0xE29EC582, "ambient_airfield_aa_fire" },
    { 0x10D3010D, "ambient_airstrikes_vo_player" },
    { 0xC0C177B9, "ambient_airstrikes_vo_setup" },
    { 0x8177268D, "ambient_alarm" },
    { 0x7E22F196, "ambient_alley_dog" },
    { 0x6166B8C2, "ambient_alley_dog_retreat" },
    { 0x659084F7, "ambient_alley_fire_burst" },
    { 0x9D47DFA5, "ambient_alley_fire_think" },
    { 0x9C3F522B, "ambient_alley_scenes" },
    { 0x7B44E9BB, "ambient_allies_weapons_think" },
    { 0x7098FC68, "ambient_anim_toggle" },
    { 0xCB979760, "ambient_asad_handler" },
    { 0xE74DF1B4, "ambient_asad_recordings" },
    { 0x91975193, "ambient_bomber" },
    { 0xCF38D0FE, "ambient_cloudburst_fx" },
    { 0x43D03C8B, "ambient_count" },
    { 0xBABD51DA, "ambient_crates" },
    { 0x7235E2E8, "ambient_drone_count" },
    { 0x9D71D19F, "ambient_drone_die" },
    { 0xF30A1910, "ambient_drone_manager" },
    { 0x1517C104, "ambient_drone_punish" },
    { 0x961EC5A5, "ambient_drone_searchlight" },
    { 0x365822DF, "ambient_drone_spawn_done" },
    { 0x6D6DCF49, "ambient_drone_start" },
    { 0x20BDDA72, "ambient_drone_target_delete" },
    { 0xBFA1EE8F, "ambient_drones" },
    { 0x9A785C12, "ambient_drones_kill_trig_watcher" },
    { 0x752D46BC, "ambient_effects" },
    { 0x878E66A5, "ambient_end_trigger_think" },
    { 0xBB240DED, "ambient_ent" },
    { 0x72092BF4, "ambient_eq" },
    { 0xE4572587, "ambient_explos" },
    { 0xA9B9DB3D, "ambient_fakefire" },
    { 0xAB42B928, "ambient_fakefire_think" },
    { 0x99F2ABBA, "ambient_fire_on_deck" },
    { 0x4A83AEDB, "ambient_flak_flash" },
    { 0x1A8F066E, "ambient_flak_rotate" },
    { 0xDDC46811, "ambient_flak_think" },
    { 0xACF9E43A, "ambient_flight_path" },
    { 0x6B25AAFD, "ambient_flybys" },
    { 0xF5B0608D, "ambient_group1_anim1" },
    { 0x1BB2DAF6, "ambient_group1_anim2" },
    { 0x41B5555F, "ambient_group1_anim3" },
    { 0x37A3FC80, "ambient_group1_anim4" },
    { 0xB1877E48, "ambient_group1_numslots" },
    { 0x85A82197, "ambient_group1_off1" },
    { 0x13A0B25C, "ambient_group1_off2" },
    { 0x39A32CC5, "ambient_group1_off3" },
    { 0xC79BBD8A, "ambient_group1_off4" },
    { 0xF3309856, "ambient_group2_anim1" },
    { 0xCD2E1DED, "ambient_group2_anim2" },
    { 0xA72BA384, "ambient_group2_anim3" },
    { 0x8129291B, "ambient_group2_anim4" },
    { 0xA3C2E6F9, "ambient_group2_numslots" },
    { 0x6EE2DACA, "ambient_group2_off1" },
    { 0x48E06061, "ambient_group2_off2" },
    { 0x22DDE5F8, "ambient_group2_off3" },
    { 0x2CEF3ED7, "ambient_group2_off4" },
    { 0x526A4DF7, "ambient_group3_anim1" },
    { 0xE062DEBC, "ambient_group3_anim2" },
    { 0x06655925, "ambient_group3_anim3" },
    { 0x945DE9EA, "ambient_group3_anim4" },
    { 0x920893D2, "ambient_group3_numslots" },
    { 0x952FD29D, "ambient_group3_off1" },
    { 0xBB324D06, "ambient_group3_off2" },
    { 0xE134C76F, "ambient_group3_off3" },
    { 0xD7236E90, "ambient_group3_off4" },
    { 0xE10D81F8, "ambient_group4_anim1" },
    { 0x5314F133, "ambient_group4_anim2" },
    { 0x2D1276CA, "ambient_group4_anim3" },
    { 0x9F19E605, "ambient_group4_anim4" },
    { 0xB699F713, "ambient_group4_numslots" },
    { 0x7FC7A258, "ambient_group4_off1" },
    { 0xF1CF1193, "ambient_group4_off2" },
    { 0xCBCC972A, "ambient_group4_off3" },
    { 0x3DD40665, "ambient_group4_off4" },
    { 0x3EEEFFA4, "ambient_guard_think" },
    { 0x7E353298, "ambient_guards" },
    { 0xFFD78FCE, "ambient_heli" },
    { 0x63209D41, "ambient_helicopter_flyby_init" },
    { 0xE92AC639, "ambient_helicopter_flyby_think" },
    { 0xBA6B63B7, "ambient_helicopter_patrol_init" },
    { 0xD979CC6F, "ambient_helicopter_patrol_think" },
    { 0x7132E635, "ambient_helicopter_spawn" },
    { 0xA80FC076, "ambient_high_bomber_path" },
    { 0x8A0527F7, "ambient_high_bombers" },
    { 0xB16ECF29, "ambient_hip1_death" },
    { 0xDF1EF0EE, "ambient_hip2_death" },
    { 0x700278C6, "ambient_hip_arena_death" },
    { 0xC474A7F9, "ambient_jeeps" },
    { 0x0318ADDF, "ambient_jetwing_init" },
    { 0x1168B49E, "ambient_left_battle" },
    { 0x8806E052, "ambient_littlebirds" },
    { 0x2797F0F7, "ambient_model_move" },
    { 0x950A2144, "ambient_model_move_loop" },
    { 0x627CCB6D, "ambient_modifier" },
    { 0xDAD020FC, "ambient_monkey_locations" },
    { 0x87F8B6B9, "ambient_monkey_next_sound_time" },
    { 0x2C1FE419, "ambient_mortar_explosion" },
    { 0x58AF1A48, "ambient_mortars" },
    { 0x525D317A, "ambient_neighborhood_vehicles" },
    { 0x5E543CC0, "ambient_phantoms" },
    { 0xFC78334F, "ambient_planes" },
    { 0x8E53B127, "ambient_planes_1" },
    { 0x1C4C41EC, "ambient_planes_2" },
    { 0x424EBC55, "ambient_planes_3" },
    { 0xEEF43D5C, "ambient_poi_zoom" },
    { 0x8625959C, "ambient_radio_noise" },
    { 0xD9B31526, "ambient_rappel" },
    { 0x4B77953F, "ambient_rattle_sounds" },
    { 0xEDED306A, "ambient_reverb" },
    { 0x02C389BD, "ambient_river_boats_init" },
    { 0xD5B97FF9, "ambient_rockets" },
    { 0x43A43896, "ambient_scene" },
    { 0xFE15ECED, "ambient_scene_list" },
    { 0x5D9CFB1F, "ambient_setter" },
    { 0x9BFF6B5F, "ambient_slums_dog" },
    { 0x07F6DA5C, "ambient_slums_dog_init" },
    { 0x39A3E29E, "ambient_spin" },
    { 0xAE42C5AF, "ambient_support_respawner" },
    { 0x19D2B752, "ambient_support_think" },
    { 0x30C984E3, "ambient_track" },
    { 0x434D71E6, "ambient_trigger" },
    { 0x00C87DD9, "ambient_trigger_sets_ambience_levels" },
    { 0xA5A10DCE, "ambient_trucks" },
    { 0xDEA399AA, "ambient_turret_end" },
    { 0x2DFEEE65, "ambient_turret_think" },
    { 0x0ACA543A, "ambient_veh_convoy_vo" },
    { 0x86D56773, "ambient_vehicle_loop" },
    { 0x08A7C4E4, "ambient_vehicle_patrol_factory" },
    { 0xD5047332, "ambient_vehicle_patrols" },
    { 0xDDEDC7D5, "ambient_vehicles_enable" },
    { 0x649EC9B2, "ambient_woosh" },
    { 0x54047627, "ambient_zones" },
    { 0x9E04B461, "ambientcarexterior" },
    { 0x77FDCF5F, "ambientcarinterior" },
    { 0xBF69117B, "ambientcontexts" },
    { 0x78C7ECA4, "ambientdelay" },
    { 0x97611F79, "ambientelementthread" },
    { 0x8D52A69D, "ambienteq" },
    { 0x4B4E25F9, "ambientevent" },
    { 0x6A323600, "ambienteventent" },
    { 0xDD580423, "ambienteventstart" },
    { 0xB57CF46D, "ambientfx" },
    { 0xB2B1C0BA, "ambientnummissedsounds" },
    { 0x63BC13AD, "ambientnumseqmissedsounds" },
    { 0xF74914A5, "ambientpackage" },
    { 0x4253F499, "ambientpackagecmdhandler" },
    { 0x9A3DCFB4, "ambientpackages" },
    { 0x152CABB0, "ambientpackagescriptoriginpool" },
    { 0xBCBFCC4B, "ambientpackagetrigger" },
    { 0xB22AD3AA, "ambientpackagetriggers" },
    { 0x31C5D5ED, "ambientplay" },
    { 0x8E0DD5F3, "ambientreverb" },
    { 0xEEF54642, "ambientroom" },
    { 0xDFD77E62, "ambientroomcmdhandler" },
    { 0xA705918D, "ambientrooms" },
    { 0xAA9D6F32, "ambientroomtoneoriginpool" },
    { 0x57150BDE, "ambientroomtoneoriginpoolindex" },
    { 0xF11BC32A, "ambients" },
    { 0x5A5BC39B, "ambientstop" },
    { 0xC9D75219, "ambientvolume" },
    { 0x2614D8E7, "ambientweight" },
    { 0xFC362358, "ambitious" },
    { 0x4B8E213F, "ambjeep" },
    { 0x5BB4D81D, "ambulance" },
    { 0xBA0F30CD, "ambulance_player_engaged" },
    { 0xF4DD0056, "ambulance_staff_killed" },
    { 0xA6C5335F, "ambulance_van" },
    { 0x45FC0E61, "ambulence" },
    { 0x1AE553B6, "ambulence_fx" },
    { 0x02D7B968, "ambulence_light_struct" },
    { 0x2E6FF9D9, "ambush" },
    { 0xD419DABD, "ambush_aborted" },
    { 0x0097C90A, "ambush_ahead_dialog" },
    { 0xF37ED16D, "ambush_allied_axis_spawnfunc" },
    { 0xFFB193F3, "ambush_allied_spawnfunc" },
    { 0x39C887C4, "ambush_amb" },
    { 0x787EA57B, "ambush_anim" },
    { 0xF040226B, "ambush_art" },
    { 0x856EB279, "ambush_asd_think" },
    { 0x2692A782, "ambush_badguy_passanger_spawn_function" },
    { 0xD80A2CA5, "ambush_badguy_spawn_function" },
    { 0x5C4C30DA, "ambush_beat_2_guys" },
    { 0x2130484F, "ambush_behaviour_setup" },
    { 0x1561B88C, "ambush_bmp_attack" },
    { 0x9E519D12, "ambush_caravan" },
    { 0x3919370E, "ambush_chase_music" },
    { 0x8129406B, "ambush_damage_checker" },
    { 0x16C8D2F9, "ambush_delay" },
    { 0x3D1A52D6, "ambush_delay_dialogue" },
    { 0xB2E6BF10, "ambush_drivebys_delete" },
    { 0x165952E6, "ambush_duex" },
    { 0xF66E22B0, "ambush_early_start" },
    { 0x9828B7F4, "ambush_enemies" },
    { 0x34D2F698, "ambush_fail" },
    { 0x896AFA35, "ambush_first_wave_guys" },
    { 0x6A75BDE5, "ambush_flags" },
    { 0x40364838, "ambush_flare" },
    { 0x922CBFB3, "ambush_friendly_movement" },
    { 0xB2058EDE, "ambush_fx" },
    { 0xF71A0F6B, "ambush_guy_head_init" },
    { 0xA37199D0, "ambush_guy_think" },
    { 0xB94EB604, "ambush_guys" },
    { 0x7488361F, "ambush_guys_restore_targetnames" },
    { 0xD705828F, "ambush_helicopter" },
    { 0x4E79FE92, "ambush_intro" },
    { 0x6B9AD7CD, "ambush_intro_dvars" },
    { 0xD0D6D4B7, "ambush_mark" },
    { 0x2D1D85D9, "ambush_mission_fail" },
    { 0xC93828AB, "ambush_movement" },
    { 0x6A77A325, "ambush_objective" },
    { 0x1A620CDB, "ambush_plane_dialogue" },
    { 0xCE7B55FF, "ambush_player_interrupt" },
    { 0x62403B9E, "ambush_point" },
    { 0x0CB8EF33, "ambush_price" },
    { 0x2D668EDF, "ambush_price_leadup" },
    { 0x024B35B0, "ambush_recover" },
    { 0xAA76E454, "ambush_rocket" },
    { 0xFEB9EBC7, "ambush_rockets" },
    { 0xCD6614EC, "ambush_round" },
    { 0x29940F8D, "ambush_round_fail_safe" },
    { 0xBCAF5C0D, "ambush_ruined" },
    { 0x38DEF837, "ambush_second_wave_guys" },
    { 0xAA4C70F9, "ambush_second_wave_spawner" },
    { 0x13CFCF93, "ambush_setup" },
    { 0x123E45DB, "ambush_setup_enemy_allies" },
    { 0x89D5CBF6, "ambush_somber_music" },
    { 0x771A8558, "ambush_spawner" },
    { 0xAC7F63E4, "ambush_spawner_death_count_reached" },
    { 0xFC2214D2, "ambush_spawner_old" },
    { 0xED230AD8, "ambush_squad_walk_to_chain" },
    { 0x69656EB3, "ambush_standoff_music" },
    { 0xDFCBF908, "ambush_start" },
    { 0x27F6091B, "ambush_started" },
    { 0xA7A98323, "ambush_starts" },
    { 0xD1733A51, "ambush_steve" },
    { 0xB42A890E, "ambush_steve_fight" },
    { 0xDCE68DE7, "ambush_streetlight" },
    { 0x5D3BB47A, "ambush_stuff" },
    { 0xD682EBED, "ambush_success" },
    { 0x3D24C4A5, "ambush_tower_blackout" },
    { 0x918F6E55, "ambush_tower_fall" },
    { 0x8803A2CF, "ambush_tower_swap" },
    { 0x6C369EBA, "ambush_trig" },
    { 0x46268908, "ambush_trigger" },
    { 0xA786F5F8, "ambush_trucks_music" },
    { 0x12B04F68, "ambush_vehicles_inplace" },
    { 0x52B7A396, "ambush_zone" },
    { 0x869D1709, "ambush_zones" },
    { 0x4E6C79FF, "ambushdoghealthincrease" },
    { 0x0FFDC406, "ambushed" },
    { 0x8D03B7E6, "ambushed_guy4" },
    { 0x11E71CB8, "ambushendround" },
    { 0x5DE1E3CB, "ambushendtime" },
    { 0xCBC73F00, "ambusher" },
    { 0xD2CFE3A4, "ambusher_spawners" },
    { 0xDDC52A2B, "ambushers" },
    { 0x22658293, "ambushers_and_spawners" },
    { 0x7764C15D, "ambushers_ready_to_be_ambushed" },
    { 0xF1C9B969, "ambushes" },
    { 0x43710D6F, "ambushing" },
    { 0x0F73B546, "ambushlightningeffect" },
    { 0xD5082309, "ambushnode" },
    { 0x51B22A00, "ambushnodes" },
    { 0x0161977E, "ambushpercentageperround" },
    { 0x86DA7506, "ambushpercentageperstop" },
    { 0x31222146, "ambushpointfailsafe" },
    { 0x08FF0785, "ambushroundaftermath" },
    { 0x3D38698B, "ambushroundeffects" },
    { 0xE2D3B7C1, "ambushroundkeeper" },
    { 0xFDE0599F, "ambushroundspawnfailsafe" },
    { 0xBFDDACBC, "ambushroundspawning" },
    { 0x2A777FE5, "ambushroundthink" },
    { 0x4C43A8F9, "ambushroundtimelimit" },
    { 0x1145B5CD, "ambushstartround" },
    { 0xE32CFE8A, "ambushwaitfunction" },
    { 0x7C146183, "america" },
    { 0x2AE8E5D7, "american" },
    { 0x6221505C, "american_anims" },
    { 0xA3AFB2E1, "american_forces_move_into_nva_base" },
    { 0xA226FF16, "american_names" },
    { 0x0D8939D0, "american_soldiertype" },
    { 0xAA1B3F8E, "americans" },
    { 0x15C5A695, "amfighting" },
    { 0xBA1472CF, "ammo" },
    { 0x90A5AC67, "ammo4evah" },
    { 0xBD370A08, "ammo_alt_clip" },
    { 0xB596FBA8, "ammo_alt_stock" },
    { 0xCF0EBFD4, "ammo_cache_used" },
    { 0xD9828B4F, "ammo_cache_waittill_notify" },
    { 0x29AAFDBA, "ammo_charge" },
    { 0xC887C807, "ammo_charge_trigger" },
    { 0xB58EAE98, "ammo_clip" },
    { 0x24DAFD0D, "ammo_cost" },
    { 0x46AD7BA7, "ammo_count" },
    { 0xCAEA04E5, "ammo_crate_80s" },
    { 0xD67F7A37, "ammo_crate_future" },
    { 0xA19B0F88, "ammo_dialog_timer" },
    { 0x97B14D0E, "ammo_frac" },
    { 0xCDC08914, "ammo_fraction_required" },
    { 0x5BA37D5E, "ammo_get" },
    { 0xAE95DDED, "ammo_give" },
    { 0x6DDBC2F9, "ammo_given" },
    { 0x9C671556, "ammo_guy_scene" },
    { 0x5B0350B9, "ammo_hud" },
    { 0x8D758064, "ammo_in_clip" },
    { 0xE05A3D12, "ammo_in_reserve" },
    { 0x090992F4, "ammo_in_stock" },
    { 0x7871E7F1, "ammo_left" },
    { 0x88FC06A6, "ammo_out" },
    { 0x13E373FE, "ammo_pickup" },
    { 0xF5BAC92C, "ammo_pos" },
    { 0x79283A3E, "ammo_pouch_think" },
    { 0x496CAF9E, "ammo_prize" },
    { 0x63686DE9, "ammo_purchased" },
    { 0x67BD8B46, "ammo_refill" },
    { 0x06E0AB2B, "ammo_refill_trigger" },
    { 0x8C17456C, "ammo_refill_vo" },
    { 0xA88BBDC9, "ammo_refilled" },
    { 0x6CC24949, "ammo_reload" },
    { 0xC3F83EB8, "ammo_reload_station" },
    { 0x517768C9, "ammo_reload_station_add_ammo" },
    { 0xB2DAC994, "ammo_reload_station_autoland_hintprint" },
    { 0xE91AF0AE, "ammo_reload_station_cinematic_reload" },
    { 0xF604AF37, "ammo_reload_station_get_viewing_ent" },
    { 0x8D0B6464, "ammo_reload_station_notify" },
    { 0x708F4E86, "ammo_reserve" },
    { 0x06B5AE23, "ammo_reset" },
    { 0xD1071080, "ammo_respawned_in_round" },
    { 0xD219BC86, "ammo_scavenger" },
    { 0xBFAAC67A, "ammo_show_caches_when_ooa" },
    { 0x045A58C7, "ammo_spawn" },
    { 0xF9D374F8, "ammo_stock" },
    { 0x48497AB6, "ammo_switch_vo_played" },
    { 0x4CAB4C74, "ammo_to_check" },
    { 0x1DDE7B49, "ammo_toss_cooldown" },
    { 0x7C497992, "ammo_trigger" },
    { 0x4B1C0511, "ammo_ui_data_model" },
    { 0x2C68ED45, "ammo_weapon_hacked" },
    { 0x11FACDB1, "ammo_weapon_pickup" },
    { 0x970B6FB1, "ammoclip" },
    { 0xF6D7A6EC, "ammocount" },
    { 0xE49F5E0C, "ammocountequipment" },
    { 0x12BCF3EF, "ammocounts" },
    { 0xB552E614, "ammodrop" },
    { 0x0C054461, "ammoindex" },
    { 0xCB509AEE, "ammoitemangles" },
    { 0xAD6580A2, "ammoitemclass" },
    { 0x8FE17FA0, "ammoitemorigin" },
    { 0x56629E88, "ammoleftequipment" },
    { 0xA4240D78, "ammolowcount" },
    { 0x81CF8A6E, "ammoout_dialog_timer" },
    { 0xF952EEC2, "ammooutcount" },
    { 0x95FCE52B, "ammopickupdelay_max" },
    { 0x68F070E5, "ammopickupdelay_min" },
    { 0x49F5254A, "ammopickupincrement" },
    { 0x73578789, "ammopool" },
    { 0x1C8E2E7C, "ammopouch" },
    { 0xBBC7B20B, "ammorespawnthink" },
    { 0x924F5AAE, "ammount" },
    { 0x884AB6C5, "ammoving" },
    { 0xBD0C6BB8, "ammunition" },
    { 0x437D8AC0, "ammys" },
    { 0xD37015AD, "amnt" },
    { 0xB685F29F, "amntx" },
    { 0x90837836, "amnty" },
    { 0x6A80FDCD, "amntz" },
    { 0x6B9FBEC5, "amodel" },
    { 0x3B48BDEF, "among" },
    { 0x16BB4536, "amongst" },
    { 0x3733A486, "amortize" },
    { 0x1E2AF8C1, "amount" },
    { 0xB5B15795, "amount_angle" },
    { 0xB7EF6B30, "amount_behind" },
    { 0x84769195, "amount_distance" },
    { 0x67FF4BB7, "amount_killed" },
    { 0xDB17888F, "amount_of_cover" },
    { 0x6DD78192, "amount_per_step" },
    { 0xE0C2ACB7, "amount_to_add" },
    { 0x6C71C8B6, "amount_to_kill" },
    { 0x876C6CAD, "amountchange" },
    { 0x7EEC8D3C, "amountdistance" },
    { 0x6F69DECA, "amountdistancescale" },
    { 0xA26716E2, "amountdvar" },
    { 0x6D89B136, "amountoflaststandpistolammoinclip" },
    { 0xAE8129DE, "amountoflaststandpistolammoinstock" },
    { 0x7F68CE8B, "amountover" },
    { 0xE90F9FC1, "amountpersec" },
    { 0xAC2734E8, "amounts" },
    { 0xA214385D, "amountunder" },
    { 0x7924211D, "amp" },
    { 0x7B7BEBCA, "amped" },
    { 0xF09ECCEE, "amphibious" },
    { 0xB01A9F95, "amplifier_filled" },
    { 0x7599CA60, "amplifier_state" },
    { 0x4E886208, "amplitude" },
    { 0x2EDC7391, "amplitude1" },
    { 0x82776509, "amplitude_width_ratio" },
    { 0xAA7590B1, "amsel_is_dead" },
    { 0x31377883, "amsel_is_doomed" },
    { 0xE11A3779, "amt" },
    { 0x3D5EB16A, "amtanks" },
    { 0x8A647F08, "amusement" },
    { 0xCDB298AD, "amws" },
    { 0xA6FF42FC, "amws_acceleration" },
    { 0x581B4541, "amws_away_from_character" },
    { 0x2E026D86, "amws_change_position_toattack_target_delay" },
    { 0x5F82A673, "amws_end_interrupt_watch" },
    { 0xD226AFAD, "amws_enemy_too_close_dist" },
    { 0xA154CD41, "amws_evade_dist_max" },
    { 0x4E7D5E7F, "amws_evade_dist_min" },
    { 0x7F627D79, "amws_evade_half_height" },
    { 0x62003ED0, "amws_evade_point_spacing_factor" },
    { 0x75A8CDB2, "amws_initialize" },
    { 0x0D2DEE37, "amws_max_time_at_same_position" },
    { 0x002806A5, "amws_move_dist_max" },
    { 0xEB095F0B, "amws_move_dist_min" },
    { 0xDF679904, "amws_repath_range" },
    { 0xFE50CF44, "an" },
    { 0x6A265933, "an94" },
    { 0xBC806B98, "an_enemy_shot" },
    { 0x8DD2D755, "analog" },
    { 0x7A997A03, "analysis" },
    { 0xAF67D6B5, "analyzed" },
    { 0x78415E8E, "analyzing" },
    { 0xEF37C743, "aname" },
    { 0x7C5EE775, "anarchy" },
    { 0x6F1739C2, "anchor" },
    { 0x84623EA0, "anchor_delete_failsafe" },
    { 0xE575D0D5, "anchored" },
    { 0x875DB75B, "anchorelem" },
    { 0x131B8065, "anchortarget" },
    { 0x928C2BB3, "ancient" },
    { 0x0A6DCFB6, "ancle" },
    { 0xC57BAB88, "and" },
    { 0x3163E797, "and_other_ais" },
    { 0x3E8FE14D, "and_out" },
    { 0xA9525C30, "and_reveal" },
    { 0x54C26D27, "anderson" },
    { 0xBA5A0FC3, "anderson_f35_exit" },
    { 0xC5EB886C, "anemometer" },
    { 0x4E5B08BF, "anemometer_thread" },
    { 0x8F08F06F, "anemometers" },
    { 0xEDD1F3FC, "anew" },
    { 0x1180A05A, "anf" },
    { 0x37831AC3, "ang" },
    { 0x60884D20, "ang1" },
    { 0x6687C81F, "ang1_render" },
    { 0xD28FBC5B, "ang2" },
    { 0x60974357, "ang_01" },
    { 0xB9DC414E, "ang_01_render" },
    { 0xEE8FD41C, "ang_02" },
    { 0xDECDCDCB, "ang_02_render" },
    { 0x14924E85, "ang_03" },
    { 0x9ABCD918, "ang_03_render" },
    { 0x9810487B, "ang_animate" },
    { 0xE35FFFF7, "ang_dif" },
    { 0xDC08E463, "ang_diff" },
    { 0xA24FE74D, "ang_fall" },
    { 0xD1E89267, "ang_offset" },
    { 0xD6501E4F, "ang_to_end" },
    { 0x340D13BB, "ang_to_target" },
    { 0xA4D68447, "ang_vel" },
    { 0x7A1C95DF, "ang_vel_pct" },
    { 0x9A180F4C, "ang_vel_scale" },
    { 0xD3CA2702, "ang_x" },
    { 0xF9CCA16B, "ang_y" },
    { 0x87C53230, "ang_z" },
    { 0x190E9EEA, "angdiff" },
    { 0x28E19CFC, "angeles" },
    { 0xE70F739E, "anger" },
    { 0x7204DA72, "angle" },
    { 0x361D4F8F, "angle1" },
    { 0x685F0683, "angle3d" },
    { 0xDAE3734A, "angle_add" },
    { 0xC14B8636, "angle_between_vectors" },
    { 0x9C91B96D, "angle_change" },
    { 0x3CA9B87A, "angle_checker" },
    { 0x7D9B9C85, "angle_curr" },
    { 0x082814D3, "angle_delta_array" },
    { 0x503DAABA, "angle_dif" },
    { 0x67F2CBB8, "angle_diff" },
    { 0x67319022, "angle_dot" },
    { 0x4B035292, "angle_limit" },
    { 0x6A65F649, "angle_max" },
    { 0x855B21F7, "angle_min" },
    { 0xCD19906F, "angle_normalize180" },
    { 0x33E68CA2, "angle_normalize_180" },
    { 0xBEF8F428, "angle_offset" },
    { 0x9C1770C3, "angle_offsets" },
    { 0x4404E7DF, "angle_range_attack" },
    { 0x277DCB0B, "angle_rotate_degree" },
    { 0xF5F289AC, "angle_rotate_time" },
    { 0xC9FF9857, "angle_spawn_facing" },
    { 0x396BE2C3, "angle_to_enemy" },
    { 0xE25FD3B6, "angle_to_left" },
    { 0x60A1CC6E, "angle_to_player" },
    { 0x8B65310D, "angle_to_right" },
    { 0x441558CE, "angle_to_rotate_to_side" },
    { 0xCA7A7B9B, "angle_x" },
    { 0x0519F5FB, "angle_x_1" },
    { 0x931286C0, "angle_x_2" },
    { 0xA4780132, "angle_y" },
    { 0x3FC5F97A, "angle_y_1" },
    { 0x19C37F11, "angle_y_2" },
    { 0x7E7586C9, "angle_z" },
    { 0x278525E3, "angleadjustingstart" },
    { 0x41A6D21D, "anglearray" },
    { 0x4D7CF277, "angleclamp" },
    { 0x3DFA27B4, "angleclamp180" },
    { 0x04000CD2, "anglecounter" },
    { 0x9887DF32, "angled" },
    { 0xF54D2849, "angledataobj" },
    { 0x9DE80420, "angledelta" },
    { 0xF1BD26E7, "angledeltaarray" },
    { 0x307CD23F, "anglediff" },
    { 0xE96B6D0F, "angledifference" },
    { 0x93798797, "angledot" },
    { 0xED59E808, "angleepsilon" },
    { 0xFC294B50, "angleerror" },
    { 0xAA3D3826, "anglefrac" },
    { 0x72AF2465, "anglefromcenter" },
    { 0xE8CA7D79, "anglefromtarget" },
    { 0x83BE93DF, "anglefudge" },
    { 0x6AFA8C21, "angleleeway" },
    { 0x7EE89459, "angleleft" },
    { 0x87E716C1, "anglelerp" },
    { 0x19E771F3, "anglelerprate" },
    { 0x06DC2188, "anglemax" },
    { 0x61820016, "anglemin" },
    { 0x5275BC04, "anglenormalize180" },
    { 0xB2743EE4, "anglenormalize360" },
    { 0xA7ADE6E1, "anglerangethread" },
    { 0x6AB6F4FD, "angles" },
    { 0x9ADC03B7, "angles0" },
    { 0x74D9894E, "angles1" },
    { 0x4ED70EE5, "angles2" },
    { 0x5D5E356F, "angles_base" },
    { 0x21E16F34, "angles_body" },
    { 0xB96CC431, "angles_dif" },
    { 0xFB701FE7, "angles_forward" },
    { 0x110FA452, "angles_func" },
    { 0x65EE7E33, "angles_hand" },
    { 0x23BA4A65, "angles_normalize_180" },
    { 0x007D9BC9, "angles_offset" },
    { 0x344D508C, "angles_save_restore" },
    { 0x82F6E9BB, "angles_target" },
    { 0x8802DEFB, "angles_to" },
    { 0x020D80DA, "angles_to_enemy" },
    { 0xA3DEA3A9, "angles_to_target" },
    { 0xD198B796, "angles_toside" },
    { 0xBCD83967, "angles_up" },
    { 0x295A15BF, "angles_variation" },
    { 0x1BD3323B, "angles_x_max" },
    { 0x30F1D9D5, "angles_x_min" },
    { 0x6FC6926E, "angles_y_max" },
    { 0xC29E0130, "angles_y_min" },
    { 0x04BBE0F3, "anglescheck" },
    { 0x1BBE0ADF, "angleside" },
    { 0x96C16A1C, "anglesoffset" },
    { 0xB1A43DC8, "anglesondeath" },
    { 0x3493843A, "anglesonkill" },
    { 0xE10C584D, "anglesoverride" },
    { 0x48B6C955, "anglesspot" },
    { 0xE6C34D6A, "anglesstablizeincrement" },
    { 0xD824EA51, "anglesstablizeinitialscale" },
    { 0x3A5DE8D3, "anglesstablizescale" },
    { 0xA173B435, "anglestoend" },
    { 0x6D5AB502, "anglestoenemy" },
    { 0xAA348CEC, "anglestofacing" },
    { 0xBC7CE905, "anglestoforward" },
    { 0x08774A01, "anglestolookorigin" },
    { 0x30F7F067, "anglestolookpos" },
    { 0x77F13274, "anglestopoint" },
    { 0x3F2FA14D, "anglestoreference" },
    { 0x298B8148, "anglestoright" },
    { 0x8D96EAA7, "anglestoshootpos" },
    { 0xC64AF691, "anglestotarget" },
    { 0xABA60185, "anglestoup" },
    { 0x29492CEB, "anglestr" },
    { 0x3A2A9A93, "anglethreshold" },
    { 0x386813E3, "angletodestination" },
    { 0x59216F38, "angletoend" },
    { 0xA1DC11D3, "angletoenemy" },
    { 0xE18D945E, "angletoenemylook" },
    { 0x69C3A3B1, "angletoexit" },
    { 0x8A078609, "angletollerance" },
    { 0x5D434EB1, "angletonode" },
    { 0x82FA3AA3, "angletop" },
    { 0x60359EDE, "angletoplayer" },
    { 0x5B2FC861, "angletrace" },
    { 0x1E4BD1A1, "angleup" },
    { 0x879D92EC, "anglevec" },
    { 0x3BDDCB17, "anglevector" },
    { 0xD09C1C6A, "angoffset" },
    { 0xE5A7359B, "angola" },
    { 0x5B5E8F28, "angola1" },
    { 0xF43E3C82, "angola2_finale_dof1" },
    { 0xCE3BC219, "angola2_finale_dof2" },
    { 0xA83947B0, "angola2_finale_dof3" },
    { 0x817F162B, "angola2_finale_hudson_ground" },
    { 0xD9202ED0, "angola2_skipto" },
    { 0xEF163FFB, "angola_1" },
    { 0x7D0ED0C0, "angola_2" },
    { 0xB5AAC511, "angola_2_amb" },
    { 0xD4371A78, "angola_2_anim" },
    { 0x93DC6C44, "angola_2_beartrap" },
    { 0x19A20933, "angola_2_dof_enter_hut" },
    { 0x797E88A4, "angola_2_dof_gun_to_head" },
    { 0x83E4899C, "angola_2_dof_jump_out" },
    { 0x1C20C521, "angola_2_finale_dof_enemy" },
    { 0x935D0768, "angola_2_finale_dof_hind" },
    { 0xEBB0F0F1, "angola_2_fx" },
    { 0xE9A255FD, "angola_2_skipto" },
    { 0x33DAECE3, "angola_2_util" },
    { 0x1EF8F3DE, "angola_amb" },
    { 0x3D421511, "angola_anim" },
    { 0x731CDF7D, "angola_art" },
    { 0x88DCB251, "angola_barge" },
    { 0x00169C95, "angola_challenge_actor_killed_callback" },
    { 0x9EAD4288, "angola_custom_introscreen" },
    { 0xFD826C24, "angola_fx" },
    { 0x7FF3E1B1, "angola_init_rusher_distances" },
    { 0xD45373FD, "angola_jungle_animations" },
    { 0x93991C09, "angola_jungle_ending" },
    { 0x625EFBC4, "angola_jungle_ending_objectives" },
    { 0x572513B1, "angola_jungle_escape" },
    { 0x65E27928, "angola_jungle_objectives" },
    { 0x5A4BC8B5, "angola_jungle_stealth" },
    { 0xB26C9DBD, "angola_jungle_stealth_carry" },
    { 0x5C978224, "angola_jungle_stealth_house" },
    { 0xB4E446E1, "angola_jungle_stealth_log_objectives" },
    { 0xE5A1C795, "angola_jungle_wave_spawning" },
    { 0x7BF3224E, "angola_mortar_clip" },
    { 0xAF286BCA, "angola_mortar_impact" },
    { 0xBBF5A4E4, "angola_mortar_obtained" },
    { 0xE6AF5AA6, "angola_mortar_stock" },
    { 0xE4D19881, "angola_mortor_move" },
    { 0xFE46D446, "angola_objectives" },
    { 0x06E33AD4, "angola_river" },
    { 0xAC09FFB1, "angola_riverbed" },
    { 0x87E13086, "angola_savannah" },
    { 0xF46B9C3F, "angola_savannah_battle" },
    { 0xEEE967F8, "angola_skipto" },
    { 0xD61EA10B, "angola_stealth" },
    { 0x87007109, "angola_stealth_house_objectives" },
    { 0x60B46856, "angola_stealth_objectives" },
    { 0x8496CEA6, "angola_temp_vo" },
    { 0x1AFB83F2, "angola_utility" },
    { 0xF6ECA8B2, "angola_village" },
    { 0x14E5210F, "angolan" },
    { 0x476B605E, "angolan_names" },
    { 0x166514A0, "angry" },
    { 0x3F8DEEC8, "angry_fire_wait_x" },
    { 0x65906931, "angry_fire_wait_y" },
    { 0x5977DD08, "angry_shoot" },
    { 0x1108EC9C, "angstruct" },
    { 0x7BED0E29, "angular" },
    { 0xD6A4E64B, "angular_amplitude" },
    { 0x97D1332D, "angular_vel" },
    { 0xE5EF23ED, "angular_velocity" },
    { 0x530E088D, "angularscalar" },
    { 0x780950EC, "angularvelocity" },
    { 0xAB74D23A, "angularvelstablizeparams" },
    { 0x373D3511, "angx" },
    { 0x113ABAA8, "angy" },
    { 0x834229E3, "angz" },
    { 0x2D71C1E4, "anh" },
    { 0x40AF6AF6, "anhilation" },
    { 0x25292DFA, "aniamation" },
    { 0xA70A3F05, "aniamtion" },
    { 0x292F5394, "aniamtions" },
    { 0x502600A1, "aniated" },
    { 0xFFC89D42, "anim" },
    { 0xF05B159F, "anim1" },
    { 0x7E53A664, "anim2" },
    { 0xA45620CD, "anim3" },
    { 0x324EB192, "anim4" },
    { 0x7C10BD51, "anim_" },
    { 0xB2C7C031, "anim_addmodel" },
    { 0x800389CF, "anim_ang" },
    { 0xF9FAB1B1, "anim_angles" },
    { 0x8FD84D8B, "anim_animationendnotify" },
    { 0xDDF776D0, "anim_apply_delta" },
    { 0x9EC4E820, "anim_array" },
    { 0x1718FFD7, "anim_array_cache" },
    { 0x798F79C4, "anim_at_entity" },
    { 0x3EEF1547, "anim_at_self" },
    { 0xEAF11CBC, "anim_autofire" },
    { 0x53FA1161, "anim_barn_door_kick_open" },
    { 0x24DED158, "anim_barn_door_kick_setup" },
    { 0xAE30C97A, "anim_barn_door_rattle" },
    { 0x93EE5806, "anim_barn_door_tank_setup" },
    { 0xA29CF147, "anim_best" },
    { 0xDDA29A50, "anim_boltfire" },
    { 0x77281CD7, "anim_briggs" },
    { 0xCE24D5AD, "anim_bump" },
    { 0xC5D0DDCC, "anim_chair" },
    { 0x53205C87, "anim_check" },
    { 0xCB762545, "anim_chickens" },
    { 0xCB17785E, "anim_color" },
    { 0x48E76841, "anim_combat" },
    { 0xE4C21108, "anim_complete" },
    { 0xBF61C78B, "anim_curr_and_max_frame_think" },
    { 0x224A2F9C, "anim_current" },
    { 0x679B10A8, "anim_custom" },
    { 0x0A7C4AB9, "anim_custom_animmode" },
    { 0x0D807CE3, "anim_custom_animmode_on_guy" },
    { 0x35D1BFA1, "anim_custom_animmode_solo" },
    { 0xE2D9D4D1, "anim_custommode" },
    { 0xCE81124D, "anim_death" },
    { 0xAC517D6E, "anim_deathnotify" },
    { 0x79DFA64C, "anim_debug_name" },
    { 0xC63E3B19, "anim_debug_text_alpha" },
    { 0xE934427B, "anim_debug_text_scale" },
    { 0xDB66105C, "anim_debug_text_small" },
    { 0xDAA76B1E, "anim_def" },
    { 0x408BD67B, "anim_defalco" },
    { 0x99B9F7A7, "anim_defalco_react" },
    { 0x99B69A61, "anim_dialogueendnotify" },
    { 0xC416659D, "anim_disablelongdeath" },
    { 0x69756F97, "anim_disablepain" },
    { 0xF58FA551, "anim_dist" },
    { 0x6BCCC190, "anim_dogs" },
    { 0x4BA9465F, "anim_dontpushplayer" },
    { 0xC8B58931, "anim_door" },
    { 0xCBC91FC7, "anim_dumpster" },
    { 0x8661127D, "anim_duration" },
    { 0xB575F823, "anim_durration" },
    { 0x491B9552, "anim_dvar_funcs" },
    { 0x8C0ED937, "anim_dvar_think" },
    { 0x1B3B41F0, "anim_dvar_types" },
    { 0x27DDB8FD, "anim_dvars" },
    { 0x4062A93B, "anim_early_out" },
    { 0x65C66D09, "anim_end_ang" },
    { 0x77C773B4, "anim_end_early" },
    { 0x39FF243B, "anim_end_org" },
    { 0x47C8391D, "anim_ender" },
    { 0x0C0ADC42, "anim_endons" },
    { 0x2FA35738, "anim_ent" },
    { 0x21FF9B6A, "anim_ent2" },
    { 0xC7637B93, "anim_ents" },
    { 0xE11770EB, "anim_ents2" },
    { 0x34CFC4E7, "anim_ents_solo" },
    { 0xC01FDEBB, "anim_explosion_tree_setup" },
    { 0xFD39B278, "anim_explosion_truck_setup" },
    { 0x3FB834FA, "anim_f35_get_in" },
    { 0xBBA6FB74, "anim_f35_mode_switch" },
    { 0x2376D8E5, "anim_f35_on_deck" },
    { 0xCDEF3937, "anim_f35_startup" },
    { 0x3DAC5CD9, "anim_facial" },
    { 0xF65AFFFE, "anim_facialanim" },
    { 0xAB7C167B, "anim_facialendnotify" },
    { 0x6EDC4FDF, "anim_facialfiller" },
    { 0x37BF0F41, "anim_finished_notify" },
    { 0xD0226AF7, "anim_first_frame" },
    { 0x5DAE6D10, "anim_first_frame_delayed" },
    { 0xB92316E1, "anim_first_frame_on_guy" },
    { 0x8E077AB3, "anim_first_frame_solo" },
    { 0x08D0BBFA, "anim_for_client_script" },
    { 0x20249CF4, "anim_frame_count" },
    { 0x16584523, "anim_gen_human" },
    { 0x3D7F070C, "anim_generic" },
    { 0xCBDB2B11, "anim_generic_aligned" },
    { 0x339CA5B7, "anim_generic_custom_animmode" },
    { 0x848AE4DD, "anim_generic_first_frame" },
    { 0x84C7C57D, "anim_generic_loop" },
    { 0x205DDF6C, "anim_generic_loop_aligned" },
    { 0x553201DC, "anim_generic_reach" },
    { 0xBEFC8BC1, "anim_generic_reach_aligned" },
    { 0x26B670DC, "anim_generic_reach_and_arrive" },
    { 0x98DB2871, "anim_get_dvar" },
    { 0x65EE983F, "anim_get_dvar_int" },
    { 0xEC4BD493, "anim_grate_index" },
    { 0x83F50B0A, "anim_gunhand" },
    { 0xFE6FF0E7, "anim_guninhand" },
    { 0xE210CE6B, "anim_guy_to_shed" },
    { 0x2746B0E5, "anim_guys" },
    { 0xA3ED8879, "anim_hands" },
    { 0x76D06153, "anim_horse_push" },
    { 0x5EF2F978, "anim_horse_push_loop" },
    { 0x20290E4B, "anim_huds" },
    { 0x2BBE2F30, "anim_human" },
    { 0x777D74A2, "anim_hut4_pieces" },
    { 0x8A31A032, "anim_i" },
    { 0x65C5F7F2, "anim_id" },
    { 0x60AA627C, "anim_id_back" },
    { 0x20683E8E, "anim_id_front" },
    { 0x52075333, "anim_idle" },
    { 0x2282E673, "anim_idle_name" },
    { 0x49D4D668, "anim_in" },
    { 0x9DEB9313, "anim_index" },
    { 0xB871615D, "anim_info" },
    { 0xDA4FE517, "anim_info_array" },
    { 0x3F98D7F3, "anim_info_render_align_nodes_thread" },
    { 0xB7573CAB, "anim_info_render_thread" },
    { 0xBC59A08F, "anim_init" },
    { 0x7486EBC2, "anim_interrupt" },
    { 0x95A2B601, "anim_intro_name" },
    { 0xD15490BB, "anim_intro_shed_light" },
    { 0x1A6AE162, "anim_intro_then_loop" },
    { 0xF8FDB2D7, "anim_joint" },
    { 0x6E4EF2C9, "anim_keys" },
    { 0xAA6B6CC9, "anim_kill_complete" },
    { 0x17EB4EC1, "anim_last" },
    { 0x8145572F, "anim_legnth" },
    { 0x881C115E, "anim_len" },
    { 0xCE712339, "anim_length" },
    { 0xE4B7ACDC, "anim_light_molotov" },
    { 0x8FB54F1D, "anim_link" },
    { 0xD20E035C, "anim_load_ambient_scenes" },
    { 0xD305D04A, "anim_load_frontend_global" },
    { 0x50F1ABB7, "anim_load_strikeforce" },
    { 0xCFA1BA5A, "anim_load_strikeforce_responses" },
    { 0x1F474F3E, "anim_load_vtol_ambient_scenes" },
    { 0x5B4D6118, "anim_loader" },
    { 0xEE20988D, "anim_loader_items" },
    { 0x65A528E8, "anim_look" },
    { 0xA92D7814, "anim_lookanimationright" },
    { 0x07C06B6B, "anim_loop" },
    { 0x60C60556, "anim_loop_aligned" },
    { 0xE10C2EFB, "anim_loop_blend" },
    { 0x030307FF, "anim_loop_debug" },
    { 0xD263FFCC, "anim_loop_ender" },
    { 0xF405CACB, "anim_loop_name" },
    { 0x43A63F4E, "anim_loop_packet" },
    { 0x85E6B7A8, "anim_loop_packet_solo" },
    { 0x5C4FFFAF, "anim_loop_solo" },
    { 0xE68CD32B, "anim_loop_solo_debug" },
    { 0xF2971835, "anim_looping" },
    { 0x265CFEEF, "anim_magic_bullet_shield" },
    { 0xE8B2D67E, "anim_main" },
    { 0x6AEA7E18, "anim_model" },
    { 0x3B836D06, "anim_movement" },
    { 0xCCD2DA90, "anim_name" },
    { 0xD21D267B, "anim_names" },
    { 0x6FF87801, "anim_node" },
    { 0x59479B51, "anim_node2" },
    { 0x334520E8, "anim_node3" },
    { 0xC587D785, "anim_node_1" },
    { 0xEB8A51EE, "anim_node_2" },
    { 0x118CCC57, "anim_node_3" },
    { 0x2127D3C0, "anim_node_gap" },
    { 0x7947BF01, "anim_node_gather" },
    { 0x77FB37C7, "anim_node_hut" },
    { 0x8158D8E3, "anim_node_island" },
    { 0x57F90845, "anim_node_name" },
    { 0x14BAF8FA, "anim_node_plant_bomb" },
    { 0x62375B3C, "anim_node_reznov" },
    { 0x4EE76428, "anim_node_swim" },
    { 0xB3E3BB28, "anim_nodes" },
    { 0xDEFC623C, "anim_notetrack_functions" },
    { 0x458D4CF2, "anim_notify" },
    { 0x99F6D0C6, "anim_notify_str" },
    { 0x505F5F0B, "anim_num" },
    { 0x6E630A16, "anim_off_last_spot" },
    { 0x4330970C, "anim_on_goal" },
    { 0x9A67EADE, "anim_on_tag_done" },
    { 0x06053DDA, "anim_open_barn_door" },
    { 0x5A6974FA, "anim_open_hatch" },
    { 0xA97B2225, "anim_org" },
    { 0x91AF19AF, "anim_org0" },
    { 0x6BAC9F46, "anim_org1" },
    { 0xFB2F707E, "anim_orig" },
    { 0x96D0D1CF, "anim_origin" },
    { 0xFF13FEF6, "anim_origin_render" },
    { 0x20604589, "anim_override" },
    { 0xF2CC1FB6, "anim_override_func" },
    { 0x8A4F76ED, "anim_pain" },
    { 0x3F86CF56, "anim_percent_completed" },
    { 0xF9A98093, "anim_play" },
    { 0x418A7D8D, "anim_play_one_spot" },
    { 0xBF67D44E, "anim_player" },
    { 0xA2DEC128, "anim_player_opening_curtain" },
    { 0x7D331E21, "anim_player_push" },
    { 0x3ED85B96, "anim_player_push_loop" },
    { 0xB4743649, "anim_playerview" },
    { 0xC5942289, "anim_point" },
    { 0x5DCC1461, "anim_pos" },
    { 0x42ECCBC5, "anim_pos_from_tag" },
    { 0x3B9AD10E, "anim_pose" },
    { 0x90130EF8, "anim_position" },
    { 0xF75319ED, "anim_prefix" },
    { 0x0F9C310C, "anim_prone_change" },
    { 0x97D6B363, "anim_prop_models" },
    { 0x406B09BD, "anim_prop_models_animtree" },
    { 0xFA06CB1D, "anim_props" },
    { 0x5AA5BF7B, "anim_props_animated" },
    { 0x5617AB4A, "anim_pushplayer" },
    { 0x38F93CCE, "anim_queue" },
    { 0x7F0534EE, "anim_rappel_2_fall" },
    { 0xC0D41131, "anim_rappel_brake" },
    { 0x67E23586, "anim_rappel_brake_loop" },
    { 0xF88B89F0, "anim_rappel_brake_succeed" },
    { 0xD287DEFC, "anim_rappel_compress" },
    { 0x45275ECD, "anim_rappel_compress_loop" },
    { 0xC1666CF8, "anim_rappel_fall_loop" },
    { 0x0ECB6E9E, "anim_rappel_idle" },
    { 0x7D73F129, "anim_rappel_kickoff" },
    { 0x39B71C72, "anim_rappel_loop" },
    { 0xDA144683, "anim_rate" },
    { 0xB60A4C9E, "anim_reach" },
    { 0xE398A65F, "anim_reach_aligned" },
    { 0xC7D285BF, "anim_reach_all_nest" },
    { 0x8666D17B, "anim_reach_and_approach" },
    { 0xC3E7C45F, "anim_reach_and_approach_solo" },
    { 0x90785B1F, "anim_reach_and_approach_solo_set_flag" },
    { 0xC81338A9, "anim_reach_and_idle" },
    { 0x5CF65331, "anim_reach_and_idle_solo" },
    { 0x73A9D516, "anim_reach_and_plant" },
    { 0xA6722DB4, "anim_reach_complete" },
    { 0xF5E72E61, "anim_reach_done" },
    { 0xE7E79D1E, "anim_reach_for_all" },
    { 0x9BE19C07, "anim_reach_idle" },
    { 0x5160DD5D, "anim_reach_node" },
    { 0x79D10758, "anim_reach_solo" },
    { 0xEAA79525, "anim_reach_then_loop" },
    { 0xADE37815, "anim_reach_with_funcs" },
    { 0x36D76590, "anim_react_name" },
    { 0x7A515B28, "anim_reaction" },
    { 0x679552BC, "anim_ref" },
    { 0xAAD6CA90, "anim_reference" },
    { 0x4E6EBB7C, "anim_removemodel" },
    { 0x2531208B, "anim_ride" },
    { 0x6E98B857, "anim_scripted" },
    { 0x5B956BCF, "anim_scripted_name" },
    { 0x21F1D686, "anim_sea" },
    { 0xD62A1B29, "anim_seaknight" },
    { 0x4404EEE2, "anim_seals_on_zodiac" },
    { 0x293E9E86, "anim_self_set_time" },
    { 0x63087CFE, "anim_semiautofire" },
    { 0x4FC2C0BB, "anim_set" },
    { 0x94DD6CBD, "anim_set_blend_in_time" },
    { 0x0DA4DDE6, "anim_set_blend_out_time" },
    { 0xC3848422, "anim_set_next_move_to_new_cover" },
    { 0x09F12480, "anim_set_rate" },
    { 0x52C4C958, "anim_set_rate_internal" },
    { 0x98EC4F13, "anim_set_rate_single" },
    { 0xEBF7A7A9, "anim_set_time" },
    { 0x50EB32B2, "anim_setup_complete" },
    { 0xE0760C69, "anim_single" },
    { 0x5762FF98, "anim_single_aligned" },
    { 0x84A6CD99, "anim_single_debug" },
    { 0x41EEBD6C, "anim_single_done" },
    { 0x789617D7, "anim_single_earlyout" },
    { 0xCFD15A3F, "anim_single_failsafe" },
    { 0x009DBE21, "anim_single_failsafeonguy" },
    { 0x5F5ED011, "anim_single_queue" },
    { 0xBFF4E6AC, "anim_single_queue_thread" },
    { 0xF19BC2F1, "anim_single_solo" },
    { 0x05BA299E, "anim_single_solo_animname" },
    { 0x7942A751, "anim_single_solo_debug" },
    { 0x81D6CE2E, "anim_single_solo_delayed" },
    { 0x4AE2F0EF, "anim_single_solo_earlyout" },
    { 0x25D21404, "anim_single_stack" },
    { 0x64E71A47, "anim_single_stack_proc" },
    { 0xCC773E02, "anim_single_then_flag" },
    { 0x6D98BFEE, "anim_single_then_patrol" },
    { 0x20B6FF34, "anim_single_thread" },
    { 0xB1D28D44, "anim_solo" },
    { 0x658EA1AE, "anim_sound" },
    { 0x95123300, "anim_sound_was_opened" },
    { 0x7B027D0F, "anim_spawner_teleport" },
    { 0xB6ECA8D6, "anim_special" },
    { 0xA87812F9, "anim_spot" },
    { 0x69140294, "anim_spot_finder" },
    { 0x255AB767, "anim_stack" },
    { 0x9094F0C2, "anim_start_ang" },
    { 0x1D581FD8, "anim_start_org" },
    { 0xA813D58C, "anim_start_origin" },
    { 0x629C7568, "anim_start_pos" },
    { 0x617363DE, "anim_start_pos_solo" },
    { 0x242CCB44, "anim_state" },
    { 0xB6B8CE48, "anim_stopanimscripted" },
    { 0xFA2692F3, "anim_stopscene" },
    { 0x6531EF56, "anim_str" },
    { 0x6881994A, "anim_string" },
    { 0x1DDDDDB6, "anim_struct" },
    { 0x74652A16, "anim_struct_1" },
    { 0x328E1633, "anim_struct_targetname" },
    { 0xF46931A9, "anim_structs" },
    { 0xBFB8C1B4, "anim_sub_index" },
    { 0xD9BF5C3B, "anim_tag" },
    { 0x5A93F9AC, "anim_teleport" },
    { 0x24BFEF6A, "anim_teleport_solo" },
    { 0xDAA3BC82, "anim_temp_hide" },
    { 0xF3B7A10D, "anim_test" },
    { 0xF79F9206, "anim_time" },
    { 0x75EACCCB, "anim_time_check" },
    { 0x76C61B62, "anim_timeout" },
    { 0x9A7D22E3, "anim_to_play" },
    { 0x55023B01, "anim_trashcan" },
    { 0x31B76165, "anim_tree" },
    { 0xE550276F, "anim_trigger" },
    { 0x3802B70A, "anim_truck" },
    { 0x1C6BFF3D, "anim_turn_rate" },
    { 0x22265169, "anim_type" },
    { 0x2D64C44F, "anim_under_hut_collapse" },
    { 0x85B638DA, "anim_update_time" },
    { 0x31D19F9A, "anim_vehicles" },
    { 0x8F4BDB25, "anim_weight" },
    { 0xCFE421EF, "anima" },
    { 0xA55D0940, "animactive" },
    { 0x8B7AA201, "animal" },
    { 0xF299298C, "animal_type" },
    { 0xA5BE3035, "animalignnode" },
    { 0x01CBD928, "animals" },
    { 0x3AEE2AE2, "animaname" },
    { 0x5597F909, "animanme" },
    { 0x3B3D1B6D, "animarray" },
    { 0xEABA2DE2, "animarrayanyexist" },
    { 0x789E3457, "animarrayarg" },
    { 0xB2B9E302, "animarrayexist" },
    { 0x41C330BE, "animarrayfuncs" },
    { 0xC11EA480, "animarraygeneric" },
    { 0x0A7B3A02, "animarrayinternal" },
    { 0xD4444127, "animarraypickrandom" },
    { 0x31EBE6B3, "animarrivalsplittimes" },
    { 0xFB3F2829, "animat" },
    { 0xA1E3641D, "animatable" },
    { 0x5F245AA6, "animate" },
    { 0x30EF6BB5, "animate_at_node" },
    { 0x27D7F6D1, "animate_barnes_headset" },
    { 0x4F11FF84, "animate_barnes_headset_exit" },
    { 0x1F7831E1, "animate_barnes_into_hind" },
    { 0x14AFB646, "animate_barnes_into_hind_and_takeoff" },
    { 0xF83899CD, "animate_barnes_takeoff_hind" },
    { 0xFB60771F, "animate_beat_3_roof_rpg_door" },
    { 0xD7E5CEDC, "animate_boat_props" },
    { 0x36B3F5DD, "animate_bowman" },
    { 0x153EE1C0, "animate_bowman_exit" },
    { 0x89DBBB16, "animate_bowman_intro" },
    { 0x0FCB2D29, "animate_brainwash_anims" },
    { 0x92516881, "animate_camera_wobble_idle" },
    { 0x6197C229, "animate_carlos" },
    { 0xB7F65072, "animate_chinook_and_delete" },
    { 0x8C880455, "animate_crack" },
    { 0x0E19EE96, "animate_crow_fly" },
    { 0xBF6F703B, "animate_data_glove_hologram" },
    { 0x91EDD320, "animate_drive_idle" },
    { 0x17546C8F, "animate_drive_idle_death" },
    { 0xB9B811E1, "animate_drone" },
    { 0x503B3F29, "animate_grass" },
    { 0xE89A0740, "animate_grass_single" },
    { 0xB77A75FE, "animate_hatchet_to_target" },
    { 0x5F2CFF7E, "animate_heli_grass" },
    { 0x49AD3BB5, "animate_leader_exit" },
    { 0x59351A79, "animate_leader_intro" },
    { 0xEBC072F7, "animate_loop" },
    { 0x727722C5, "animate_map" },
    { 0xCC72DB34, "animate_meat" },
    { 0x7F3E686A, "animate_nodedrone_at_node" },
    { 0xA74E7F10, "animate_octobomb" },
    { 0x3182A2A9, "animate_player_hands" },
    { 0x057A2625, "animate_player_headset" },
    { 0xA7D97EE8, "animate_player_headset_exit" },
    { 0x589922A8, "animate_player_open_door" },
    { 0x5633BB60, "animate_police_car_guy" },
    { 0x93F5961E, "animate_prop" },
    { 0x5D78A118, "animate_ridge_roof_awning" },
    { 0x3BD39B9C, "animate_river_snake" },
    { 0xE01BF3C6, "animate_rolling_door_open" },
    { 0xEF234546, "animate_sign" },
    { 0xD609E699, "animate_swift_death" },
    { 0x074C903D, "animate_swift_getting_killed" },
    { 0xF369385F, "animate_the_bear_trap" },
    { 0x2787BCF7, "animate_then_rag" },
    { 0xD6C5FA45, "animate_weapon" },
    { 0x321A177D, "animate_woods" },
    { 0xD28CB920, "animate_woods_exit" },
    { 0x97C55E77, "animate_woods_huey" },
    { 0x6AC72CF6, "animate_woods_intro" },
    { 0x8F1EDE4D, "animatecameramenus" },
    { 0x45328456, "animated" },
    { 0x7EE38C83, "animated_ai" },
    { 0xA8A8733E, "animated_crash" },
    { 0x45A4311A, "animated_crashtracks" },
    { 0x5F28A5C4, "animated_damage_state" },
    { 0x82FDF9BF, "animated_ents" },
    { 0xD4191A09, "animated_guys" },
    { 0x11309F9C, "animated_model" },
    { 0xD2124D5D, "animated_model_clip" },
    { 0xCA5C5706, "animated_model_setup" },
    { 0x7C7D23DF, "animated_models" },
    { 0xE7881FE8, "animated_mowdown" },
    { 0x11C2E05C, "animated_object" },
    { 0x16B6D7DD, "animated_panel" },
    { 0xCCA6BB1C, "animated_panels" },
    { 0x7C2F96D1, "animated_props" },
    { 0xCA9686D5, "animated_switch" },
    { 0xF3AA85C0, "animateddeath" },
    { 0x6476D57E, "animatedtank" },
    { 0xF42A118D, "animatemodel" },
    { 0x3E76648C, "animatemoveintoplace" },
    { 0xE74DC6D9, "animates" },
    { 0xBB9A471C, "animateui" },
    { 0x00CC3FE5, "animatible" },
    { 0x8183B8F5, "animatic" },
    { 0x936381A0, "animatin" },
    { 0x6EC8805F, "animating" },
    { 0x90374A9A, "animating_guys" },
    { 0x7A8ECFE1, "animating_helicopter" },
    { 0x1FB6A2E5, "animation" },
    { 0x4B584D86, "animation1" },
    { 0x2555D31D, "animation2" },
    { 0xC4A30AA7, "animation_debug_shared" },
    { 0x510C41FB, "animation_direction" },
    { 0xE1BB8348, "animation_duration" },
    { 0x6463DED8, "animation_exists" },
    { 0xE104524F, "animation_legs" },
    { 0x71F08E50, "animation_list" },
    { 0xB811B451, "animation_name" },
    { 0x54172102, "animation_playing" },
    { 0xDCA568EE, "animation_selector_table" },
    { 0xAD906E7F, "animation_selector_table_evaluators" },
    { 0x29C731AF, "animation_shared" },
    { 0x2F795199, "animation_side" },
    { 0x0739447D, "animation_state_machine" },
    { 0x3EAEA1FD, "animation_state_machine_mocomp" },
    { 0x14D82330, "animation_state_machine_notetracks" },
    { 0x5770B8A8, "animation_state_machine_utility" },
    { 0x1F22C5F3, "animation_time" },
    { 0xC2E280CB, "animation_update" },
    { 0xF62488B9, "animationadjustmentinfoxy" },
    { 0x7D30A04A, "animationadjustmentinfoz" },
    { 0x31FE535C, "animationadjustmentinfoz2" },
    { 0xB64187A0, "animationentity" },
    { 0xEAE01F9D, "animationes" },
    { 0xBC33DEDE, "animationid" },
    { 0x865FEEA0, "animationmocomp" },
    { 0xFEA6D191, "animationmocompemptyfunc" },
    { 0x98000F3B, "animationmocompresult" },
    { 0xF94A402C, "animationname" },
    { 0xBE841C75, "animationresults" },
    { 0x7FF1F2F4, "animations" },
    { 0x226C2E96, "animationselectortable" },
    { 0xE8BC7C95, "animationstartorigin" },
    { 0x3923DB8A, "animationstatenetwork" },
    { 0x54AAC76E, "animationstatenetworkutility" },
    { 0x88C3DE2A, "animaton" },
    { 0x90924DF6, "animator" },
    { 0x92BE3181, "animbase" },
    { 0xF4475422, "animbundle" },
    { 0xCE10994A, "animcategory" },
    { 0x1FFF36AE, "animcategorychanged" },
    { 0x1868D95A, "animcategorywatcher" },
    { 0x26B63D72, "animcmd" },
    { 0x3EDDC291, "animcompletioncount" },
    { 0x1FB5A457, "animcustom" },
    { 0x8D975B3B, "animdelay" },
    { 0xA88A6070, "animdelta" },
    { 0x3628A9BE, "animdist" },
    { 0x1D85CBA7, "animdistance" },
    { 0x9DFDE01A, "animdistsq" },
    { 0x391506BA, "animdone" },
    { 0x122D5EC5, "animdownarray" },
    { 0xFA563C4C, "animdropheight" },
    { 0x37DA384B, "anime" },
    { 0x42EB870D, "anime_base" },
    { 0x86C3031C, "anime_idle" },
    { 0x1066FBA0, "anime_loop" },
    { 0x79D78996, "anime_playerplantflag" },
    { 0x56B0B2E1, "anime_playershot" },
    { 0x6AF10FFF, "anime_queue" },
    { 0x3265CFA2, "anime_sargeidle" },
    { 0xC8FC69FD, "anime_sign" },
    { 0xA32686E6, "animename" },
    { 0xBB5B1476, "animendangle" },
    { 0xE0F285E9, "animendingvec_forward" },
    { 0xAF32828C, "animendingvec_right" },
    { 0xA82E4819, "animendingvec_up" },
    { 0xCC0F839E, "animendtime" },
    { 0x6EA5D659, "animent" },
    { 0xD7261E8F, "animepacket" },
    { 0x7CC2D7AA, "animes" },
    { 0xBA62F848, "animflag" },
    { 0xA02ACCA3, "animflagnameindex" },
    { 0xF533C9C4, "animfraction" },
    { 0xDCE4AB9C, "animfudgetime" },
    { 0x8BF59C47, "animgetchildat" },
    { 0x2CD1E6C0, "animgoaltime" },
    { 0x1C86622B, "animgroup" },
    { 0x11A35822, "animguys" },
    { 0x73E74270, "animhandle" },
    { 0x968045EB, "animhasimportantnotifies" },
    { 0x4A177CF3, "animhasnotetrack" },
    { 0x2DFECCD7, "animhop" },
    { 0xD1FDCED1, "animid" },
    { 0xCDEC25AE, "animindex" },
    { 0xA2A48B6F, "animitem" },
    { 0x3ABF7D6E, "animkeys" },
    { 0xABBC9CD7, "animlen" },
    { 0x51CBA8C6, "animlength" },
    { 0x5E0B77CF, "animlimit" },
    { 0x5829ECA6, "animlist" },
    { 0xFA0DC2E2, "animload" },
    { 0xA8303B64, "animloop" },
    { 0x84BA6A5C, "animmappingsearch" },
    { 0xDDEC54C7, "animmode" },
    { 0xF5E69C58, "animn" },
    { 0xB691B9CF, "animname" },
    { 0xB21C0C5A, "animname_override" },
    { 0x86A233B2, "animname_set" },
    { 0x3BF30796, "animnames" },
    { 0xDC1481E6, "animnode" },
    { 0xD41E5C19, "animnodes" },
    { 0xF96641F9, "animnotify" },
    { 0x09D3B27A, "animnum" },
    { 0xC6E3D81F, "animontag" },
    { 0x316C7F18, "animontag_ragdoll_death" },
    { 0xD79846F8, "animontag_ragdoll_death_watch_for_damage" },
    { 0x55259626, "animontag_ragdoll_death_watch_for_damage_notdone" },
    { 0x40F7048E, "animontag_thread" },
    { 0x38D2BE82, "animoverride" },
    { 0x90506778, "animplay" },
    { 0xE2A3385B, "animplaybackrate" },
    { 0xDA3BD33E, "animplaybacktime" },
    { 0x33819D74, "animpos" },
    { 0x458C9266, "animpos_override_standattack" },
    { 0xD752BB81, "animpose" },
    { 0x1BDA05D9, "animpostfix" },
    { 0xB0CB7A7E, "animprefix" },
    { 0xC29D02DC, "animrate" },
    { 0xC4251AB8, "animratemod" },
    { 0xA2F3A698, "animrateroundscalar" },
    { 0xBABB7BB5, "animref" },
    { 0x18E28F84, "animrefs" },
    { 0x754A502A, "animrelative" },
    { 0xE86BC698, "animrig" },
    { 0xF87442DD, "animrun" },
    { 0x23B7868D, "anims" },
    { 0x4DB71A42, "anims_func" },
    { 0x704A54AC, "anims_table" },
    { 0x5BDAE473, "anims_table_" },
    { 0xF1BD35DB, "anims_table_bigdog" },
    { 0xC7043854, "anims_table_civilian" },
    { 0x090665AF, "anims_table_cqb" },
    { 0xDB480AE9, "anims_table_digbats" },
    { 0xC85EAE72, "anims_table_dualwield" },
    { 0x80FE89E8, "anims_table_elite" },
    { 0x8C9B1955, "anims_table_fem" },
    { 0x9B30BC33, "anims_table_juggernaut" },
    { 0xFCAC2106, "anims_table_militia" },
    { 0xE104EE79, "anims_table_mpla" },
    { 0x01B6635E, "anims_table_pistol" },
    { 0xDE30C844, "anims_table_rusher" },
    { 0x93537E43, "anims_table_shotgun" },
    { 0xB807D6B6, "anims_table_smg" },
    { 0x889D1B63, "anims_table_spetsnaz" },
    { 0x58B8C325, "anims_table_traverse" },
    { 0x024AE606, "anims_table_vc" },
    { 0xB350B6FF, "anims_table_wounded" },
    { 0xECFBF2C8, "animsapplied" },
    { 0x909E866F, "animscript" },
    { 0x10306AE2, "animscript_shot" },
    { 0xF91A3D5C, "animscriptdonotetracksthread" },
    { 0x5D64F4B4, "animscripted" },
    { 0x8ADF18A7, "animscripteds" },
    { 0xCD48184E, "animscriptedskiprestart" },
    { 0x9EB7C1B6, "animscripts" },
    { 0x1A7279CA, "animsctipted" },
    { 0x35CFCA31, "animsdone" },
    { 0x07F5E7CA, "animset" },
    { 0xCBF1C205, "animsets" },
    { 0x301CF87F, "animsound" },
    { 0x86D1772E, "animsound_aliases" },
    { 0xB739CC23, "animsound_color" },
    { 0xCDA233E2, "animsound_exists" },
    { 0xEA2CEA69, "animsound_hud" },
    { 0x71FAAEA0, "animsound_hud_alias" },
    { 0x98457B2C, "animsound_hud_anime" },
    { 0xA6AF2926, "animsound_hud_animname" },
    { 0x5554117B, "animsound_hud_extralines" },
    { 0x235F707E, "animsound_hud_locked" },
    { 0xF6C2C62F, "animsound_hud_timer" },
    { 0x20EDC3AA, "animsound_hudlimit" },
    { 0x5A4ACE76, "animsound_input" },
    { 0xCDFD9380, "animsound_locked" },
    { 0xEB308447, "animsound_locked_pressed" },
    { 0xC2B2B1F5, "animsound_selected" },
    { 0x8CA8A11F, "animsound_start_tracker" },
    { 0x946B3C1C, "animsound_start_tracker_loop" },
    { 0x0C9080DE, "animsound_tagged" },
    { 0xC7099C8A, "animsound_tracker" },
    { 0x81D76986, "animsounds" },
    { 0xF16332A4, "animsounds_thisframe" },
    { 0xDE082C6B, "animspeed" },
    { 0xC74D6172, "animspot" },
    { 0x05426554, "animspot2" },
    { 0xACD0E330, "animspot_clean" },
    { 0xF9C8CA25, "animspot_cleaner" },
    { 0xABE379FD, "animspots" },
    { 0x97E52858, "animstanceisok" },
    { 0x5B80EF96, "animstartingvec_forward" },
    { 0x2E1E6F17, "animstartingvec_right" },
    { 0xC3BB8108, "animstartingvec_up" },
    { 0xE68CE054, "animstartpos" },
    { 0xD3F0A75D, "animstarttime" },
    { 0x895A8E81, "animstarttonode" },
    { 0x593F51D1, "animstate" },
    { 0x6A0DEDC2, "animstatebase" },
    { 0xA4226C9E, "animstatedef" },
    { 0x7EBBEAB8, "animstates" },
    { 0xC1CC26E5, "animstring" },
    { 0x40EDE8EB, "animsubstate" },
    { 0x6635DE89, "animsuffix" },
    { 0x550BC7E1, "animtables" },
    { 0x106104F2, "animtag" },
    { 0x068A37B9, "animtest_spawn_char" },
    { 0x78C549B8, "animtest_spawn_model" },
    { 0xD3340A76, "animthread" },
    { 0xC6140BFD, "animtime" },
    { 0x0CA8E27B, "animtime_notify" },
    { 0xE37BC7FA, "animtimebeforevisisible" },
    { 0x3FBA8B92, "animtimefudge" },
    { 0x96D2A2F0, "animtimegoal" },
    { 0xA300DE25, "animtimer" },
    { 0x513B6918, "animtion" },
    { 0x5DC7C6B3, "animtoplay" },
    { 0x28FE4257, "animtranslationscale" },
    { 0x399C262E, "animtree" },
    { 0x789CF5FD, "animtree_override" },
    { 0x9856AC51, "animtrees" },
    { 0xDEFDF572, "animtype" },
    { 0x245DEC50, "animtype_array" },
    { 0x1EED4F1E, "animtypeindex" },
    { 0xC2DB3D1E, "animtypekeys" },
    { 0x6F641440, "animuparray" },
    { 0x61A44312, "animweapon" },
    { 0x936A6E2C, "animweaponanims" },
    { 0x7EB274E0, "animweightmax" },
    { 0x2BDB061E, "animweightmin" },
    { 0x37992BD5, "animweights" },
    { 0xF5B74463, "anit" },
    { 0x98E732AB, "anlges" },
    { 0xD8926258, "anmation" },
    { 0xA49DC577, "anml_run_triggers" },
    { 0x36F2A235, "anml_run_triggers_activate" },
    { 0xE16CCD12, "ann" },
    { 0xC4FE8CE5, "annhilator" },
    { 0xB274875A, "annihilate" },
    { 0x96D3770A, "annihilate_effect_cb" },
    { 0x7468387E, "annihilate_push_scale" },
    { 0x773621E1, "annihilate_uppush_scale" },
    { 0x6E7941AA, "annihilated" },
    { 0x80590A55, "annihilates" },
    { 0x4FD70E6B, "annihilating" },
    { 0x802696B1, "annihilation" },
    { 0x60E9D898, "annihilatorgunactorkilleffect" },
    { 0xC1F78754, "annihilatorgunplayerkilleffect" },
    { 0x328AAEAE, "annilhation" },
    { 0xB3CA74E8, "announce" },
    { 0x0D0C86B0, "announce_backblast" },
    { 0xC42EC33D, "announce_game_winner" },
    { 0xF17BBC69, "announce_round_winner" },
    { 0xD2725DE6, "announce_team_is_winning" },
    { 0x007AF914, "announcegamemoderules" },
    { 0x0019C083, "announcegamewinner" },
    { 0xC45D2D56, "announcehelicopterinbound" },
    { 0xE627FD9E, "announcematchwinner" },
    { 0xB37C7904, "announcement" },
    { 0x2233AFB7, "announcements" },
    { 0x0FCEA09D, "announcemessage" },
    { 0x9AA5701A, "announcer" },
    { 0xE384A54D, "announcer_dialog" },
    { 0xEE284131, "announcer_dialog_available" },
    { 0x64A5E110, "announcer_ent" },
    { 0x511E50BA, "announcercontroller" },
    { 0xA6EFDBF5, "announceroundwinner" },
    { 0xA069D2B5, "announceteamiswinning" },
    { 0xBBB8A3E9, "announcing" },
    { 0x3EC69BF6, "announcments" },
    { 0x114EF27B, "annoyance" },
    { 0x02BA5E0E, "annoying" },
    { 0x4D056992, "anode" },
    { 0xCABC759D, "anodes" },
    { 0x5505C66E, "anodes_unsorted" },
    { 0xBCFD1D28, "anomaly" },
    { 0xCFEE8D1A, "another" },
    { 0x38524E12, "another_chicken" },
    { 0x4DC00271, "another_enemy_awareness_reaction" },
    { 0x31691D4D, "another_visionset_triggered" },
    { 0xFF350C85, "anotherwave" },
    { 0xBF2F21AA, "anpopulate" },
    { 0x2FB4AAF7, "ans" },
    { 0x60F82EBB, "answer" },
    { 0x6CB79530, "answered" },
    { 0xC5036FF8, "ant2_01" },
    { 0x7A72EB27, "ant2_01_render" },
    { 0x370ADF33, "ant2_02" },
    { 0xA7DDD86A, "ant2_02_render" },
    { 0x110864CA, "ant2_03" },
    { 0xBEC1BFA5, "ant2_03_render" },
    { 0x830FD405, "ant2_04" },
    { 0x5F48BD98, "ant2_04_render" },
    { 0xD51A0759, "antechamber" },
    { 0xE91BCD1E, "antenna" },
    { 0x9B99B5F9, "antenna_explo" },
    { 0xEA1D7E9F, "antenna_start" },
    { 0x79B39726, "anteup" },
    { 0xAE0A893E, "anteup_bonus" },
    { 0x7110D154, "antfarm" },
    { 0xC42B1CC2, "anthem" },
    { 0xBF220BD9, "anthem_approach" },
    { 0x1F38C472, "anthem_approach_saves" },
    { 0xF54F0400, "anthem_clocktower_toll" },
    { 0x72174561, "anthem_facial_recognition_complete" },
    { 0xBDAFBE8E, "anthem_harper_stand" },
    { 0x8C6CF759, "anthem_harper_vo_surveillance" },
    { 0x03A2EBFD, "anthem_objectives" },
    { 0x8AE2AF64, "anthem_player_grapple_started" },
    { 0xAB8D2AFA, "anthem_random_pa" },
    { 0x3988B3AC, "anthem_random_yells" },
    { 0xB01EEAE7, "anthem_randoms" },
    { 0x380630DD, "anthem_saves" },
    { 0xF818F074, "anthem_setup" },
    { 0xE7713C6F, "anthem_stealth_middle_left_corpse_spot_spawned" },
    { 0x7D0DE56C, "anthem_surveillance_complete" },
    { 0x93770A78, "anthing" },
    { 0x8EF6CA49, "anti" },
    { 0xF6D46300, "anti115" },
    { 0xAF7583CA, "anti_grav_move" },
    { 0xEE46FE7D, "anti_progress" },
    { 0xCA8E2F37, "antiair" },
    { 0x2AE0B4ED, "antiair_challenge" },
    { 0xD0CB0B87, "antiboostdistance" },
    { 0x38A974E6, "anticheat" },
    { 0xFD4AEB9F, "anticheatleaderboard" },
    { 0x183C4151, "anticipate" },
    { 0x50D2A387, "anticipated" },
    { 0xC2F16504, "anticipating" },
    { 0xF04F1A4E, "anticipation" },
    { 0x8EF0E611, "antigravity" },
    { 0x920C55A7, "antigravitybydistance" },
    { 0x7E526CF9, "antigravityscale" },
    { 0x570DCF42, "antigravityscaleup" },
    { 0x71CF3D9E, "antinov" },
    { 0x2E0B945A, "antinov_damage" },
    { 0xE3852248, "antinov_damage_feedback" },
    { 0x455413CB, "antinov_died" },
    { 0x9FCA9E5D, "antinov_warn" },
    { 0xEE5711DF, "antinov_warn_player" },
    { 0x319301A4, "antipersonnel_guidance" },
    { 0x6ED4BC89, "antipersonnelguidance" },
    { 0x5C3966EC, "antique" },
    { 0xAB4B1651, "antithreat" },
    { 0x43400C84, "antoher" },
    { 0x6B3738F3, "ants" },
    { 0xB39BE2DD, "any" },
    { 0xBED5938E, "any_active" },
    { 0x602B6193, "any_alive" },
    { 0x4F066BC2, "any_button_hit" },
    { 0xE6CF2113, "any_button_pressed" },
    { 0x1CDF50AA, "any_class_have_killstreak" },
    { 0xBD319D65, "any_flags_false" },
    { 0x85D9BBDC, "any_flags_true" },
    { 0xB32B10CF, "any_good" },
    { 0xACAC2FC2, "any_hackers_active" },
    { 0x572D5C70, "any_okay" },
    { 0xB2CFF0BA, "any_other_team_touching" },
    { 0xF5ECF909, "any_pending_gpr" },
    { 0x3ABA1432, "any_player_can_see_grenaders" },
    { 0x2A2B24AC, "any_player_in_ghost_zone" },
    { 0xC1239315, "any_player_in_noclip" },
    { 0x547D86DC, "any_player_in_zone" },
    { 0xF08B9BE6, "any_player_is_touching" },
    { 0x7865BAD1, "any_player_istouching" },
    { 0x7340F39F, "any_player_looking_at_plinth" },
    { 0xB0A1441D, "any_player_touching" },
    { 0xE14976DE, "any_player_touching_any" },
    { 0x1100B8BF, "any_player_within_distance" },
    { 0x354506EB, "any_power" },
    { 0x4CFE3930, "any_still_alive" },
    { 0x86E61FAB, "any_team" },
    { 0x882B0E43, "any_team_hit_round_score_limit" },
    { 0x62044C3A, "any_team_hit_score_limit" },
    { 0xC8542448, "any_team_reach_score" },
    { 0x61063B53, "any_var" },
    { 0x556FE27B, "any_wheel_colliding" },
    { 0x3E9F8545, "any_zombie_touching_any" },
    { 0x98589EB0, "anyalive" },
    { 0xC1C08944, "anyammoforweaponmodes" },
    { 0x4D23D80E, "anyaxis" },
    { 0x8F95C0A5, "anybody" },
    { 0xBFCC4C29, "anybody_nearby" },
    { 0xD99CA98D, "anyclosegroundflameents" },
    { 0xB3FD5B0E, "anymore" },
    { 0xD3737B7E, "anyobjectsinworld" },
    { 0x17CF4707, "anyone" },
    { 0xE2190C6B, "anyore" },
    { 0x33C47250, "anyplayercanretrieve" },
    { 0xE7E97128, "anyplayerleftinlaststand" },
    { 0xE6C95267, "anyscientistsleft" },
    { 0x746CE18B, "anysplitscreen" },
    { 0x292D2B12, "anystub_get_unitrigger_origin" },
    { 0xF6B6C76E, "anystub_on_spawn_trigger" },
    { 0x13EEE6C0, "anystub_update_prompt" },
    { 0xE6C2880A, "anyteamhasqrdrones" },
    { 0x37EF23B2, "anyteamhaswavedelay" },
    { 0x6501DF9D, "anyteamhitroundlimitwithdraws" },
    { 0x8571DC50, "anyteamhitroundwinlimit" },
    { 0x8982C55A, "anyteamhitscorelimit" },
    { 0xDDDF2417, "anything" },
    { 0xF7835A8F, "anythinhg" },
    { 0xCFC8F6DA, "anytime" },
    { 0xA7C0E162, "anyway" },
    { 0x30295F2D, "anyways" },
    { 0x69FF9CA2, "anywhere" },
    { 0x245349AD, "ao" },
    { 0xA85DEDFF, "aoe_fx" },
    { 0xC6DE1063, "aoe_radius" },
    { 0x839ED3C4, "aorigin" },
    { 0xBE8A0308, "aother" },
    { 0xBB776EF4, "aound" },
    { 0xE332BFE7, "aounds" },
    { 0x4287544A, "ap" },
    { 0x46E96624, "ap_lock" },
    { 0xC29795B3, "ap_mod" },
    { 0x4DD843E0, "ap_off" },
    { 0x92648B93, "ap_outline_material" },
    { 0xC4BB62BF, "ap_target_locked" },
    { 0x6F8D502C, "ap_target_locking" },
    { 0x881CE9EB, "ap_target_lost" },
    { 0x6E68A257, "ap_target_regain" },
    { 0xC288EC6B, "ap_target_suspend" },
    { 0x8B561319, "ap_todo" },
    { 0xBB4CFE2B, "apache" },
    { 0xC57398E0, "apache_damage_override" },
    { 0x1BCFC107, "apache_jump_event" },
    { 0x55A7C22B, "apache_player_damage_callback" },
    { 0xF9DA1072, "apache_player_kill_timer" },
    { 0xDBCAE01D, "apache_setup" },
    { 0xBF2C2AFA, "apache_showed_up" },
    { 0xBBF00154, "apache_target_stop" },
    { 0xB7E882BA, "apache_think" },
    { 0x50511991, "apart" },
    { 0x1D2DA8DD, "apartment" },
    { 0xC6046752, "apartment_badguy" },
    { 0xA15CC013, "apartment_badguy_3rd_flr" },
    { 0x4AC80E1A, "apartment_dialogue" },
    { 0xB864A840, "apartment_door" },
    { 0x435BB0FD, "apartment_exploit" },
    { 0xA4E5E2A5, "apartment_explosion" },
    { 0x70CB7E39, "apartment_flags" },
    { 0xE50D66E5, "apartment_friendlies" },
    { 0xC65AA3BB, "apartment_helicopter" },
    { 0xF879A317, "apartment_helicopter_ambient_turret" },
    { 0xDAAC733F, "apartment_helicopter_ambient_turret_track" },
    { 0x33A3D0F4, "apartment_helicopter_turret" },
    { 0x23B914E4, "apartment_helicopter_turret_guy" },
    { 0xC56D00CC, "apartment_helicopter_turret_mg_nest" },
    { 0xFA4D3AF5, "apartment_hunters" },
    { 0x8D6FCEEC, "apartment_mg_destroyed" },
    { 0x625C7953, "apartment_mg_kill" },
    { 0xD8250C31, "apartment_mg_killzone" },
    { 0xB00EE4D9, "apartment_mg_nest" },
    { 0xE545F7B6, "apartment_mg_nest_2" },
    { 0xA4079BEA, "apartment_mg_nest_2_explosion" },
    { 0x88FDBC94, "apartment_mg_nest_heli" },
    { 0x59676A5D, "apartment_mg_nest_player_damage" },
    { 0x80A64DB0, "apartment_mg_nest_sandbag" },
    { 0x5A7C3168, "apartment_price_waits_for_dog_death" },
    { 0x1EF7CC2E, "apartment_rubble_helicopter" },
    { 0xD834C7DB, "apartment_second_floor" },
    { 0xDF9D247F, "apartment_slowdown" },
    { 0xE4905534, "apartment_suicide" },
    { 0x67A7181D, "apartment_suicide_badguy" },
    { 0x728A196A, "apartment_suicide_badguy_fx" },
    { 0x901F21F9, "apartment_suicide_badguy_interrupt" },
    { 0x4F6720B5, "apartment_suicide_badguy_timed" },
    { 0x9B861055, "apartment_suicide_dialogue" },
    { 0x4C2246DA, "apartment_suicide_price" },
    { 0xF9B1BE1C, "apartments" },
    { 0x1EB7E8F5, "apc" },
    { 0x485CB5AB, "apc_actor" },
    { 0xF224D205, "apc_alley_army" },
    { 0xB04D80A8, "apc_angles" },
    { 0x31AFEF1C, "apc_announcements" },
    { 0xFBDB7D86, "apc_audio" },
    { 0x1FE072C8, "apc_brush" },
    { 0x0258A16C, "apc_cleanup" },
    { 0xCE9AC5E6, "apc_column" },
    { 0xECFB2955, "apc_crush" },
    { 0x377B95CE, "apc_crush_fake_rpgs" },
    { 0x1D4380E9, "apc_destroyed" },
    { 0x771D93ED, "apc_in_place_tank_go" },
    { 0x1F94194E, "apc_origin" },
    { 0x318B3EBB, "apc_owned" },
    { 0xFE9B11EB, "apc_start_spot" },
    { 0x4E9957B6, "apc_turret_guy" },
    { 0xBE0556C4, "apcs" },
    { 0xD2B2F423, "ape" },
    { 0x1B6CA007, "ape_activated" },
    { 0xAF994117, "ape_actor_damage" },
    { 0x928B7EB9, "ape_adjust_max_ammo" },
    { 0xDB8F0905, "ape_custom_damage" },
    { 0xEEE960D0, "ape_damage_event" },
    { 0xDA222588, "ape_death" },
    { 0xF6965D3D, "ape_death_ammo" },
    { 0x058FF70D, "ape_death_event" },
    { 0x2C419707, "ape_death_total" },
    { 0xBB488D90, "ape_dog_damage" },
    { 0xF9703B89, "ape_exited" },
    { 0xACAA4598, "ape_find_flesh" },
    { 0xFAA311F6, "ape_fire_damage" },
    { 0x4BD9414A, "ape_ground_attack_delay" },
    { 0xE75863DD, "ape_health_reduce" },
    { 0x29E2D350, "ape_health_watch" },
    { 0x384402C2, "ape_idle_nodes" },
    { 0xAEFE3E7A, "ape_intermission" },
    { 0x22DF0C23, "ape_intro_exit" },
    { 0xDBF7F070, "ape_killonproximity" },
    { 0x94776596, "ape_knockdown_time" },
    { 0xDC7AF94D, "ape_move_to_drop" },
    { 0x8CFE91D7, "ape_non_attacker" },
    { 0xDA061D33, "ape_nuke_damage" },
    { 0xE353A105, "ape_pathing" },
    { 0x73E190C8, "ape_powerup_array" },
    { 0xE7F0719B, "ape_powerup_index" },
    { 0x1E781132, "ape_prespawn" },
    { 0xF83AC274, "ape_respawn_timer" },
    { 0x4B27453B, "ape_round_aftermath" },
    { 0x34452032, "ape_round_spawning" },
    { 0x31D6CFAF, "ape_round_start" },
    { 0x8E80AC05, "ape_round_stop" },
    { 0xAC18843B, "ape_round_tracker" },
    { 0x2D89E732, "ape_round_wait" },
    { 0xAAA167EA, "ape_save_spawn_func" },
    { 0x234AD4EC, "ape_save_wait_func" },
    { 0x35314EB7, "ape_set_airstrike_damage" },
    { 0xE27F5BA4, "ape_shielder" },
    { 0x06A1D231, "ape_stop_being_greedy" },
    { 0xB6EC0E1B, "ape_stop_fog" },
    { 0xAB50BC4A, "ape_taunt_deleter" },
    { 0xCCF5FFF3, "ape_taunt_go" },
    { 0x45B34DBE, "ape_taunt_player" },
    { 0x9701E1ED, "ape_tesla_damage" },
    { 0x0BEF17E2, "ape_think" },
    { 0xADC01D8A, "ape_thundergun_damage" },
    { 0x3363DE7C, "ape_thundergun_disintegrate" },
    { 0x67036257, "ape_trap_reaction" },
    { 0x62A9F974, "ape_you_greedy_mf" },
    { 0xF76D34F8, "ape_zombie" },
    { 0x25F342F7, "ape_zombie_activation" },
    { 0x64B1739F, "ape_zombie_anim_override" },
    { 0x95A67DD8, "ape_zombie_check_for_activation" },
    { 0x8347E4B8, "ape_zombie_check_laststand" },
    { 0x2F9EF729, "ape_zombie_check_player_proximity" },
    { 0x0CD4BC86, "ape_zombie_choose_run" },
    { 0xD32123EF, "ape_zombie_custom_think" },
    { 0x56808DF8, "ape_zombie_damage_during_activate" },
    { 0x7A356F41, "ape_zombie_damage_fx" },
    { 0x6B5438E5, "ape_zombie_damage_mult" },
    { 0x849079E4, "ape_zombie_death_pos" },
    { 0xE9F51EEA, "ape_zombie_default_enter_level" },
    { 0xF98DC6A0, "ape_zombie_default_pathfind_heuristic" },
    { 0xA5B3690B, "ape_zombie_default_spawn_heuristic" },
    { 0x527FCD13, "ape_zombie_die" },
    { 0x2E3CE23C, "ape_zombie_enter_level" },
    { 0x9226B49C, "ape_zombie_ground_hit" },
    { 0x9323508D, "ape_zombie_ground_hit_think" },
    { 0x3CE99333, "ape_zombie_groundhit_damage" },
    { 0x94D30408, "ape_zombie_groundhit_damage_radius" },
    { 0x04F944F5, "ape_zombie_groundhit_trigger_radius" },
    { 0x09EC7E0D, "ape_zombie_health_manager" },
    { 0x634B061A, "ape_zombie_health_mult" },
    { 0x371CA553, "ape_zombie_idle_setup" },
    { 0x4FCD6153, "ape_zombie_is_activated" },
    { 0x214ED321, "ape_zombie_knockdown" },
    { 0x9F24A214, "ape_zombie_manager" },
    { 0x22588CBA, "ape_zombie_min_health" },
    { 0x5B2BB88E, "ape_zombie_pathfind_heuristic" },
    { 0xF394C614, "ape_zombie_pick_best_spawner" },
    { 0xB060CC1E, "ape_zombie_pick_idle_point" },
    { 0x4AB233EF, "ape_zombie_play_activate" },
    { 0x847D41FB, "ape_zombie_powerup_drop" },
    { 0xCD133F15, "ape_zombie_proximity_wake" },
    { 0x5ED642A7, "ape_zombie_push_zombies" },
    { 0x9B18AEB3, "ape_zombie_scream_a_chance" },
    { 0x85CF9FA9, "ape_zombie_scream_a_radius" },
    { 0xD2C8B264, "ape_zombie_scream_a_radius_sq" },
    { 0xF4F421F6, "ape_zombie_scream_b_chance" },
    { 0x6E98A018, "ape_zombie_scream_b_radius" },
    { 0xC0C4543B, "ape_zombie_scream_b_radius_sq" },
    { 0x4D21C938, "ape_zombie_spawn" },
    { 0x8A6BA889, "ape_zombie_spawn_heuristic" },
    { 0x7BF3760C, "ape_zombie_spawners" },
    { 0xEE73B949, "ape_zombie_switch_player" },
    { 0xC3064931, "ape_zombie_think" },
    { 0xB499FF79, "ape_zombie_update_proximity_wake" },
    { 0xB435109D, "ape_zombie_wait_for_respawn" },
    { 0x641E5F13, "ape_zombie_wait_for_switch" },
    { 0x58E07412, "apes" },
    { 0xEA20BC7B, "apespot" },
    { 0x62F1CCF1, "apex" },
    { 0xA6CF5AA6, "apextime" },
    { 0xC0677EBD, "apfirednotify" },
    { 0x3AA90A7F, "api" },
    { 0x91D985A2, "apilot_drones" },
    { 0x1C57BF86, "apis" },
    { 0x6D47FC67, "aplayersinzone" },
    { 0xB1837BCF, "aplockfinalized" },
    { 0x09648995, "aplocking" },
    { 0x601D4865, "aplockloop" },
    { 0xE13BE3A0, "aplockpending" },
    { 0x787B3FA6, "aplockstarttime" },
    { 0x6B5E2892, "aplostsightlinetime" },
    { 0x641A8332, "apologies" },
    { 0x9B961B69, "apossibleendnodes" },
    { 0x5C367A8C, "apossiblenumberthree" },
    { 0x66AFCCA2, "apothicon" },
    { 0x59F30845, "apothiconbamfin" },
    { 0x97E56CCE, "apothiconbamfinit" },
    { 0xEAC19177, "apothiconbamfland" },
    { 0xADCCDB14, "apothiconbamflandeffect" },
    { 0x76192844, "apothiconbamfout" },
    { 0x6FAF5C02, "apothiconcanbamf" },
    { 0xDFB1E4F7, "apothiconcanbamfafterjuke" },
    { 0xD0F50CB1, "apothiconcanbamfinternal" },
    { 0xD56A72A7, "apothiconcanjuke" },
    { 0xE28D10BC, "apothiconcanmeleeattack" },
    { 0xB68605E4, "apothicondamagecallback" },
    { 0xF4720F1B, "apothicondamageclientfieldupdate" },
    { 0x1FF8E5B1, "apothicondeathdissolve" },
    { 0x5E2ACC67, "apothicondeathdissolved" },
    { 0xDBC8BB18, "apothicondeathstart" },
    { 0x3640F9C1, "apothicondeathterminate" },
    { 0xF47EEEE6, "apothiconfiredamageeffect" },
    { 0x9EAE5B23, "apothiconfuriousmodeeffect" },
    { 0xEE6717E6, "apothiconfuriousmodeinit" },
    { 0x1B17E4FE, "apothiconfury" },
    { 0x53429EE4, "apothiconfurybehavior" },
    { 0x01BE547D, "apothiconfurybehaviorinterface" },
    { 0xCC9EAA0F, "apothiconfuryblackboardinit" },
    { 0x858A92E8, "apothiconfurydeath" },
    { 0x55E12B83, "apothiconfuryinterface" },
    { 0xE4AF4799, "apothiconfuryonanimscriptedcallback" },
    { 0x1E735AE1, "apothiconfurys" },
    { 0xAE84BD66, "apothiconfuryspawnsetup" },
    { 0xA8ED402B, "apothiconjukeactive" },
    { 0x5D6A8BF3, "apothiconjukeinit" },
    { 0x556629B3, "apothiconknockdownservice" },
    { 0x6A78FF68, "apothiconknockdownzombie" },
    { 0x29C4B423, "apothiconmovestart" },
    { 0xF9D34DC6, "apothiconmoveupdate" },
    { 0x9BED87A9, "apothiconondeath" },
    { 0xE88ACFF0, "apothiconpreemptivejuke" },
    { 0x6CA3D080, "apothiconpreemptivejukedone" },
    { 0x741EEAA1, "apothiconpreemptivejukepending" },
    { 0x9148E6D9, "apothiconpreemptivejukeservice" },
    { 0x846947D8, "apothiconshouldmeleecondition" },
    { 0xFCA24CA2, "apothiconshouldswitchtofuriousmode" },
    { 0x3926EE39, "apothiconshouldtauntatplayer" },
    { 0x300930B2, "apothiconspawnsetup" },
    { 0x249CFCC8, "apothiconspawnshader" },
    { 0x862752B6, "apothiconstartloopingeffects" },
    { 0x8795F93E, "apothiconstoploopingeffects" },
    { 0xF5222BFE, "apothicontauntatplayerevent" },
    { 0x9BABB92C, "apothiconzombieeligibleforknockdown" },
    { 0x6DFA0C8D, "appaerntly" },
    { 0x539B509A, "apparent" },
    { 0xED340387, "apparently" },
    { 0x2247F906, "appear" },
    { 0xAD93B85F, "appearance" },
    { 0xB8DAF41A, "appearing" },
    { 0xF7C17DB9, "appears" },
    { 0x3E76A0D0, "appease" },
    { 0xD9462E25, "append" },
    { 0x9855687F, "append_array" },
    { 0xE8993B21, "append_array_struct" },
    { 0x5897160B, "append_hunched" },
    { 0xFDB39A48, "append_missing_legs_suffix" },
    { 0xEA25CD91, "append_name" },
    { 0xC1513612, "appended" },
    { 0x59F3047F, "apple" },
    { 0x0F096ECE, "applicable" },
    { 0x056A2EC5, "application" },
    { 0x78F88A54, "applications" },
    { 0x9A504118, "applied" },
    { 0x4439F367, "applies" },
    { 0x522494B3, "apply" },
    { 0x17971A89, "apply_burn" },
    { 0xE6CE9593, "apply_damage_to_armor" },
    { 0xC79EA724, "apply_delta" },
    { 0x7F4C26F4, "apply_difficulty_frac_with_func" },
    { 0x994BBEC2, "apply_difficulty_step_with_func" },
    { 0x40E90163, "apply_difficulty_var_with_func" },
    { 0x30B05818, "apply_end_fog" },
    { 0x63EDB3BC, "apply_filter" },
    { 0x0F0DB8AE, "apply_fire_sale_to_chest" },
    { 0x8EBDA916, "apply_fog" },
    { 0x90E5C701, "apply_ghettotag" },
    { 0xB16F7C76, "apply_option_to_selected_fx" },
    { 0xFDCABF0D, "apply_physics_explosion_to_part" },
    { 0x61248DFA, "apply_powerup" },
    { 0x603134D8, "apply_state_change" },
    { 0x2A22A275, "apply_threat_bias_to_all_players" },
    { 0x5A8662D1, "apply_truckjunk" },
    { 0x4906D55E, "apply_truckjunk_loc" },
    { 0xF3529750, "apply_vertical_blend" },
    { 0xF0D5DE4B, "apply_vortex_fx" },
    { 0x23D5A254, "applyblend" },
    { 0x05EE9654, "applycustomclassmodifiers" },
    { 0x9F12506C, "applydeathanim" },
    { 0x459A24BB, "applyemp" },
    { 0x3AF70B81, "applyflagcarrierclass" },
    { 0x117DB197, "applyflash" },
    { 0x828EC42D, "applying" },
    { 0xFA95F494, "applyknockback" },
    { 0xA1A8B1CB, "applynewfaceanim" },
    { 0x0288FCAD, "applypowerup" },
    { 0x9F113AA8, "applyroundstartdelay" },
    { 0xA5E56008, "applyvisionsets" },
    { 0x2D816215, "appologize" },
    { 0x1CADA8AD, "approach" },
    { 0xF11F5FA9, "approach_angle" },
    { 0xB4DC439F, "approach_anim" },
    { 0xF97233E0, "approach_choppers" },
    { 0x04A9B755, "approach_dir" },
    { 0xF5D813F7, "approach_facility" },
    { 0xBEEF0835, "approach_goal_radius_max" },
    { 0x281F4067, "approach_goal_spacing" },
    { 0x1B1A0F98, "approach_goal_trigger" },
    { 0xA98E9C24, "approach_jump" },
    { 0xF42F2457, "approach_main" },
    { 0x8C37E5E2, "approach_point" },
    { 0xED7E0D1F, "approach_point_claim" },
    { 0x076D1BA6, "approach_point_debug" },
    { 0xBE5C0840, "approach_point_unclaim" },
    { 0x8AA4B0F1, "approach_speed" },
    { 0xFFB77773, "approach_types" },
    { 0x5262E332, "approachanim" },
    { 0x4EF5D765, "approachdata" },
    { 0x907E2C1A, "approachdir" },
    { 0x4F90ED5A, "approached" },
    { 0xE694C778, "approachendnode" },
    { 0x21C00325, "approaches" },
    { 0x5319B9D8, "approachfinalyaw" },
    { 0xF0C86F3B, "approaching" },
    { 0x8C52C4E3, "approaching_hotel_cleanup_notify" },
    { 0xE3B11054, "approaching_rocket_hall" },
    { 0x476ABAB6, "approachisgood" },
    { 0xA1535F2C, "approachle" },
    { 0x0A133CAE, "approachnodeyaw" },
    { 0xADA5EB1A, "approachnumber" },
    { 0xB05A3375, "approachpoint" },
    { 0x2612BEB3, "approachradiussq" },
    { 0x7AF027C7, "approachstartnode" },
    { 0x2CCFDE05, "approachtype" },
    { 0xBF48A094, "approachtypes" },
    { 0xF6A06841, "approachwaittillclose" },
    { 0x70B58F8E, "approachyaw" },
    { 0xAF92EB02, "appropiate" },
    { 0x5FB9154A, "appropraite" },
    { 0x63C169BA, "appropriate" },
    { 0xDEDE95A7, "appropriately" },
    { 0x6EAC5EE7, "approprite" },
    { 0xD52107B0, "approved" },
    { 0xA31A5504, "approved_move" },
    { 0x85678555, "approx" },
    { 0xC82884E8, "approx_dist" },
    { 0xF1053645, "approximate" },
    { 0x4D285A90, "approximate_path_dist" },
    { 0x8A878788, "approximately" },
    { 0x8231381A, "approximation" },
    { 0x58DD151C, "apr" },
    { 0x18E748C3, "april" },
    { 0xA9001E80, "aprocents" },
    { 0x3118FB85, "aprocentscontainer" },
    { 0x10A8A88D, "aprocspawners" },
    { 0xC401E7E8, "apsoundid" },
    { 0xC8B44297, "apt1" },
    { 0x0C67A88D, "aptarget" },
    { 0x08D1EDE4, "aptoggleloop" },
    { 0x4F07713B, "aqb" },
    { 0xEFB5B249, "aqua_door_dialogue" },
    { 0x798A6E1D, "aqua_explosion" },
    { 0x44711484, "aqua_explosion_trigger" },
    { 0xBE1299FB, "aquad" },
    { 0x93A5F9C8, "aquarium" },
    { 0x318848D8, "aquifer" },
    { 0x58702A72, "aquire" },
    { 0x5376CF32, "aquired" },
    { 0x25A5E4FD, "aquires" },
    { 0xF6825F78, "ar" },
    { 0x50BA0E92, "ar_garand" },
    { 0x0B679813, "ar_garand_for_diamond" },
    { 0x1051BC18, "ar_goal_nodes" },
    { 0x2C36E3A2, "ar_kill_index" },
    { 0x1687B83B, "ar_standard_upgraded_object" },
    { 0xFD231440, "ar_target_id" },
    { 0x59032361, "ar_target_think" },
    { 0x0730B48D, "arabic" },
    { 0x0EADA3DF, "aral" },
    { 0xF00451F2, "arary" },
    { 0xB0C8E662, "aray" },
    { 0x92DC9962, "arbitary_radius" },
    { 0xF685DBF0, "arbitrarily" },
    { 0x6B7F405D, "arbitrary" },
    { 0x39A30040, "arbitrary_tiny_value" },
    { 0xB9930643, "arc" },
    { 0x5580F201, "arc_angle_degrees" },
    { 0x1D3419BA, "arc_change" },
    { 0x2D086DA5, "arc_damage" },
    { 0xEA09CE07, "arc_damage_ent" },
    { 0x330D3A36, "arc_done" },
    { 0x52663458, "arc_fx_sound" },
    { 0x032C285A, "arc_limits" },
    { 0x058BABE6, "arc_num" },
    { 0xB1B78C95, "arc_source" },
    { 0x5FD575AE, "arc_source_origin" },
    { 0x26394CD6, "arc_source_pos" },
    { 0x6A093D31, "arc_target" },
    { 0x2C5E5AD2, "arc_target_pos" },
    { 0xCEBAECCE, "arc_travel_time" },
    { 0xB27EBD61, "arcade" },
    { 0x5BA091EC, "arcademode" },
    { 0x08C9FCB9, "arcademode_2x" },
    { 0xEA5A3D1E, "arcademode_3x" },
    { 0x05F8C90F, "arcademode_4x" },
    { 0x876162E4, "arcademode_5x" },
    { 0xA2FFEED5, "arcademode_6x" },
    { 0x246888AA, "arcademode_7x" },
    { 0x42817D9B, "arcademode_8x" },
    { 0x2D60005B, "arcademode_add_kill" },
    { 0x47A2F168, "arcademode_add_kill_streak" },
    { 0x680F6E4C, "arcademode_add_kill_streak_time" },
    { 0x1B03B58D, "arcademode_add_life" },
    { 0xE0517BFA, "arcademode_add_point_towards_extra_life" },
    { 0x85DA8132, "arcademode_add_points" },
    { 0xB28AA377, "arcademode_add_points_for_individual_kill" },
    { 0x3CC47F23, "arcademode_add_points_for_mod" },
    { 0x79367C50, "arcademode_airstrike_score" },
    { 0xFF6D4B45, "arcademode_assignpoints" },
    { 0x930A6884, "arcademode_assignpoints_toplayer" },
    { 0xA1326B30, "arcademode_bonus" },
    { 0x359455A6, "arcademode_car_kill" },
    { 0x21463E51, "arcademode_checkpoint" },
    { 0x0CC7702A, "arcademode_checkpoint_dvars" },
    { 0x084D902F, "arcademode_checkpoint_getid" },
    { 0x65C96AEE, "arcademode_checkpoint_max" },
    { 0xEBE5CB01, "arcademode_checkpoint_print" },
    { 0xCEF45B92, "arcademode_checkpoint_restore" },
    { 0xC966DD7B, "arcademode_checkpoint_save" },
    { 0x325E486D, "arcademode_combined_score" },
    { 0x7FBA155A, "arcademode_complete" },
    { 0xE82A7CBF, "arcademode_convert_extra_lives" },
    { 0x0E4EA0A4, "arcademode_damage" },
    { 0x6376C41B, "arcademode_damagebase" },
    { 0xE2ECDA7B, "arcademode_death" },
    { 0x3AAA0E27, "arcademode_death_detection" },
    { 0xB67622D2, "arcademode_deathtypes" },
    { 0x0A643492, "arcademode_decrement_kill_streak" },
    { 0x8481661F, "arcademode_define_damage_multipliers" },
    { 0x829414FB, "arcademode_difficultytimerscale" },
    { 0x6D19C7A0, "arcademode_draw_mult_sizzle" },
    { 0x64D8CF85, "arcademode_draw_multiplier" },
    { 0xAFB7AE18, "arcademode_draw_multiplier_kill" },
    { 0x6E9216AD, "arcademode_dvar_init" },
    { 0x3C8F9BEA, "arcademode_end_boost" },
    { 0xE5ADC73D, "arcademode_ends" },
    { 0x5F2D5BAF, "arcademode_extra_lives" },
    { 0xB8FF8EF9, "arcademode_extra_lives_base" },
    { 0x9B9595F1, "arcademode_extra_lives_range" },
    { 0x782F4ED8, "arcademode_failurestring" },
    { 0x3A577ACA, "arcademode_get_level_time" },
    { 0x6BC0F733, "arcademode_hud_digits" },
    { 0xE5319489, "arcademode_hud_score" },
    { 0x42EFD680, "arcademode_hud_scores" },
    { 0xFB79A535, "arcademode_hud_sort" },
    { 0xAEB9F19B, "arcademode_hud_streak" },
    { 0x4D51055C, "arcademode_hud_timer" },
    { 0x7430E71E, "arcademode_hud_timer_minutes_ones" },
    { 0x2C32709D, "arcademode_hud_timer_minutes_tens" },
    { 0x4C27D3B2, "arcademode_hud_timer_seconds_ones" },
    { 0x749BD9C1, "arcademode_hud_timer_seconds_tens" },
    { 0xBC1C0F11, "arcademode_hud_total_scores" },
    { 0x664D9BF0, "arcademode_init_kill_streak_colors" },
    { 0x812E038F, "arcademode_kill" },
    { 0x614C314B, "arcademode_kill_staber" },
    { 0x1DD20176, "arcademode_kill_streak_current_count" },
    { 0x663A1958, "arcademode_kill_streak_current_multiplier" },
    { 0xAF49CD9D, "arcademode_kill_streak_ends" },
    { 0x182F518A, "arcademode_kill_streak_multiplier_count" },
    { 0x72AD1704, "arcademode_kill_streak_reset" },
    { 0x72211A09, "arcademode_kill_zero_x_location" },
    { 0xDC4FF558, "arcademode_killbase" },
    { 0xFEB43F93, "arcademode_killcolors" },
    { 0xF1385556, "arcademode_kills" },
    { 0xDD862BEC, "arcademode_kills_hud" },
    { 0xF73F8513, "arcademode_kills_until_next_extra_life" },
    { 0x166AE696, "arcademode_killstreak_complete_display" },
    { 0x62C2E815, "arcademode_ks" },
    { 0xB33EF6CF, "arcademode_ks_current_count" },
    { 0x5CE705DE, "arcademode_ks_ends" },
    { 0x2439DE36, "arcademode_ks_max_streaks" },
    { 0xB3FEF8E6, "arcademode_ks_max_time" },
    { 0xFCF627C3, "arcademode_ks_time" },
    { 0x42422E6C, "arcademode_last_multi_kill_sound" },
    { 0x0FCFD0E8, "arcademode_last_streak_time" },
    { 0x420BC9A0, "arcademode_lives" },
    { 0x6EB9BD4A, "arcademode_lives_hud" },
    { 0x23779EB3, "arcademode_locationkillbonus" },
    { 0x88F5439C, "arcademode_maxlives" },
    { 0x65599542, "arcademode_minimumallowedpoints" },
    { 0x1D35808D, "arcademode_minimumallowedwarning" },
    { 0xA5A8D1A1, "arcademode_multikills" },
    { 0x077972FA, "arcademode_multiplier_maxed" },
    { 0xE8C55C0E, "arcademode_new_kill" },
    { 0xFA60B9DB, "arcademode_new_kill_streak" },
    { 0x8E6EE81A, "arcademode_new_kill_streak_allowed" },
    { 0x07172909, "arcademode_new_kill_streak_time" },
    { 0xA44E2194, "arcademode_next_extra_life" },
    { 0x919134D1, "arcademode_player_laststand" },
    { 0xA4DD994C, "arcademode_player_revive" },
    { 0xA31E02B7, "arcademode_playerkilled" },
    { 0xE5F3DAC4, "arcademode_playthrough" },
    { 0x2C965D08, "arcademode_progress2nextbonus" },
    { 0x38DEB84A, "arcademode_ramping_score" },
    { 0x375C7148, "arcademode_redraw_kills" },
    { 0x2964C84B, "arcademode_redraw_life" },
    { 0x3258EAFA, "arcademode_redraw_lives" },
    { 0xA3B1DA55, "arcademode_redraw_score" },
    { 0xBBD61F73, "arcademode_redraw_streak_progress" },
    { 0x1F44C9C0, "arcademode_remove_life" },
    { 0x98DF61E1, "arcademode_remove_timer" },
    { 0xD44142D4, "arcademode_reset_kill_streak" },
    { 0x1532C80A, "arcademode_reset_kill_streak_art" },
    { 0xC8EFB4E9, "arcademode_rewarded_lives" },
    { 0xFBFEDE9C, "arcademode_save" },
    { 0x8A796D61, "arcademode_score_firstplace" },
    { 0x51CDBB3D, "arcademode_set_origin_in_radius" },
    { 0x03E25AC7, "arcademode_skillmultiplier" },
    { 0xDD33E1C7, "arcademode_stop_kill_streak" },
    { 0xC672E769, "arcademode_stop_kill_streak_art" },
    { 0xDCF99A51, "arcademode_stop_timer" },
    { 0xF886C348, "arcademode_stoptime" },
    { 0x62CEA8B5, "arcademode_streak_color" },
    { 0xA78B8AB3, "arcademode_streak_glow" },
    { 0x3B55028B, "arcademode_streak_hud" },
    { 0x95A6636E, "arcademode_streak_hud_shadow" },
    { 0xD79E160C, "arcademode_success" },
    { 0xB1971048, "arcademode_time" },
    { 0x316ACBE2, "arcademode_update_kills" },
    { 0x0DBB7964, "arcademode_update_lives" },
    { 0x9BAE55A7, "arcademode_update_score" },
    { 0x623B5035, "arcademode_update_streak_progress" },
    { 0xBC0B074E, "arcademode_update_timer" },
    { 0xAC081D16, "arcademode_updateminustotal" },
    { 0x4DA5526E, "arcademode_updateplustotal" },
    { 0x103D1447, "arcademode_upload_highscore" },
    { 0xDE31C488, "arcademode_warningshown" },
    { 0x9307F894, "arcademode_water_tower_give_points" },
    { 0x05D8E6AC, "arcademode_water_tower_setup" },
    { 0xAADE1957, "arcademode_weaponadded" },
    { 0x2BAE6CC4, "arcademode_weaponbonus" },
    { 0x5B4F914A, "arcademode_weaponmultiplier" },
    { 0x87416AF7, "arcademodepointsrewarded" },
    { 0x51181C82, "arccosine" },
    { 0xC6800595, "arcdemode_starttime" },
    { 0xD6749621, "arch" },
    { 0x0D381819, "arch_collapse" },
    { 0x7721AADD, "arch_destroyed" },
    { 0x14A95F49, "arch_impacts_ground" },
    { 0x13471A2F, "arch_target" },
    { 0x8FC0E50E, "archetype" },
    { 0x79A1284C, "archetype_aivsaimelee" },
    { 0x2F1FB29D, "archetype_amws" },
    { 0x2C95E57D, "archetype_apothicon_fury" },
    { 0x941F0189, "archetype_apothicon_fury_interface" },
    { 0x7EE92DEE, "archetype_astronaut" },
    { 0x7CA3C39A, "archetype_civilian" },
    { 0xC4A2D4F4, "archetype_clone" },
    { 0xF514F253, "archetype_cover_utility" },
    { 0x74AA10FD, "archetype_damage_effects" },
    { 0x430E181F, "archetype_direwolf" },
    { 0x970923A9, "archetype_glaive" },
    { 0xF8C5BE8C, "archetype_human" },
    { 0x91877540, "archetype_human_blackboard" },
    { 0x36248DE2, "archetype_human_clone" },
    { 0x030C1F14, "archetype_human_cover" },
    { 0x508E2B85, "archetype_human_exposed" },
    { 0x1BB57B44, "archetype_human_interface" },
    { 0x0DF462D0, "archetype_human_locomotion" },
    { 0xA0BEB106, "archetype_human_riotshield" },
    { 0xC3564762, "archetype_human_riotshield_interface" },
    { 0x7C02B67C, "archetype_human_rpg" },
    { 0xA1CB87D4, "archetype_human_rpg_interface" },
    { 0xF232A157, "archetype_hunter" },
    { 0x9A30B68B, "archetype_keeper" },
    { 0x13387D9C, "archetype_keeper_companion" },
    { 0xDAA5CEDB, "archetype_locomotion_utility" },
    { 0xFBE6A8AF, "archetype_mannequin" },
    { 0x1D2C8BAF, "archetype_mannequin_interface" },
    { 0xA02C24B2, "archetype_margwa" },
    { 0xDBF034B8, "archetype_mechz" },
    { 0xDCFBB6AA, "archetype_mocomps_utility" },
    { 0x8F8B7BA2, "archetype_monkey" },
    { 0x9B744635, "archetype_notetracks" },
    { 0x8A2C21F6, "archetype_parasite" },
    { 0x81465520, "archetype_quadtank" },
    { 0x1AFC202D, "archetype_raps" },
    { 0x50AE9AD8, "archetype_raz" },
    { 0xA814BAAF, "archetype_robot" },
    { 0xF1302DAF, "archetype_robot_interface" },
    { 0x4BD7770D, "archetype_scout" },
    { 0x2C4A0F21, "archetype_secondary_animations" },
    { 0xC88DC86A, "archetype_sentinel_drone" },
    { 0x4A9CE062, "archetype_shared" },
    { 0x0B4CFE21, "archetype_siegebot" },
    { 0x7A94FE48, "archetype_skeleton" },
    { 0x070B807E, "archetype_spider" },
    { 0x88AA1B1A, "archetype_thrasher" },
    { 0x3DC76C26, "archetype_thrasher_interface" },
    { 0xAECD192B, "archetype_turret" },
    { 0x0DD664B7, "archetype_utility" },
    { 0xC75D22EE, "archetype_vehicle_raps" },
    { 0x1581EBA0, "archetype_warlord" },
    { 0xD4985FD8, "archetype_warlord_interface" },
    { 0x4ED20FE8, "archetype_wasp" },
    { 0x0100841B, "archetype_zod_companion" },
    { 0x1D87A69F, "archetype_zombie" },
    { 0x8E053184, "archetype_zombie_dog" },
    { 0x9424C5AC, "archetype_zombie_dog_interface" },
    { 0x440DB5FF, "archetype_zombie_interface" },
    { 0xF86B2AA7, "archetype_zombie_quad" },
    { 0xAF0272D9, "archetypecivilian" },
    { 0xF0D98B47, "archetypecivilianinit" },
    { 0x41B5516C, "archetypecloneblackboardinit" },
    { 0x3BE187C2, "archetypecloneonanimscriptedcallback" },
    { 0x46DE4034, "archetypedirewolf" },
    { 0xD8065358, "archetypehumanblackboardinit" },
    { 0xBBCC300F, "archetypehumaninit" },
    { 0x906674EE, "archetypehumanonanimscriptedcallback" },
    { 0x31E69B9A, "archetypehumanonbehavecallback" },
    { 0xBD56FC7D, "archetypehumanriotshieldblackboardinit" },
    { 0xB589481B, "archetypehumanriotshieldonanimscriptedcallback" },
    { 0xF1C0FE37, "archetypehumanrpgblackboardinit" },
    { 0xB99D0AB1, "archetypehumanrpgonanimscriptedcallback" },
    { 0x6C01C950, "archetypemargwablackboardinit" },
    { 0x4BC01A36, "archetypemargwaonanimscriptedcallback" },
    { 0x4B03BA18, "archetypemechzblackboardinit" },
    { 0x68C7B0AE, "archetypemechzonanimscriptedcallback" },
    { 0xC218D593, "archetypename" },
    { 0xDEBA043E, "archetypequadblackboardinit" },
    { 0x7FCB8A90, "archetypequadonanimscriptedcallback" },
    { 0x4E80E2D0, "archetyperazblackboardinit" },
    { 0xD218E3B6, "archetyperazonanimscriptedcallback" },
    { 0xF03F3EC3, "archetyperobotblackboardinit" },
    { 0x16DDD18D, "archetyperobotonanimscriptedcallback" },
    { 0x93908CB1, "archetypes" },
    { 0x203C170E, "archetypeskeletonblackboardinit" },
    { 0x89736DE0, "archetypeskeletononanimscriptedcallback" },
    { 0x66DDD4B8, "archetypethrasherblackboardinit" },
    { 0x5215214E, "archetypethrasheronanimscriptedcallback" },
    { 0xAD72C974, "archetypewarlordblackboardinit" },
    { 0x0327511A, "archetypewarlordonanimscriptedcallback" },
    { 0x5C76FF5D, "archetypezombieblackboardinit" },
    { 0xA54E5E08, "archetypezombiedeathoverrideinit" },
    { 0x271468A7, "archetypezombiedogblackboardinit" },
    { 0xF212AF61, "archetypezombiedogonanimscriptedcallback" },
    { 0x3F5ECBFB, "archetypezombieonanimscriptedcallback" },
    { 0xD6456C08, "archetypezombiespecialeffectscallback" },
    { 0xBD40768B, "archetypezombiespecialeffectsinit" },
    { 0x8F15DB8D, "archive" },
    { 0x740F6833, "archived" },
    { 0x654F262A, "archivetime" },
    { 0xA76DEC16, "archway" },
    { 0x70291134, "archway_fxanim" },
    { 0x61913889, "archways" },
    { 0x643BF39D, "arcing" },
    { 0x5FCBD9E1, "arclight" },
    { 0xD2BB32A9, "arclight_finale" },
    { 0x6C3B96B2, "arcs" },
    { 0x0597FB15, "are" },
    { 0xDDDF20F4, "are_all_flipped" },
    { 0xE2FE4E7A, "are_all_targets_invalid" },
    { 0x60AC8F87, "are_any_players_in_adjacent_zone" },
    { 0x4BB31C47, "are_any_players_watching" },
    { 0xBA7FBE17, "are_vig_guys_alive" },
    { 0x7D8D14C6, "area" },
    { 0x30F2878B, "area1" },
    { 0x3FACFC80, "area1_flankers" },
    { 0xDF459C01, "area1_flankers_counter" },
    { 0x0FEAE46B, "area1_trigger1" },
    { 0x9DE37530, "area1_trigger2" },
    { 0xC3E5EF99, "area1_trigger3" },
    { 0xBEEB1850, "area2" },
    { 0xCAF49C9E, "area2_preattackers" },
    { 0x9A0AD911, "area2_trigger2" },
    { 0x74085EA8, "area2_trigger3" },
    { 0x7E19B787, "area2_trigger4" },
    { 0xE4ED92B9, "area3" },
    { 0xA2F9F6C6, "area4" },
    { 0xF0E954B0, "area_a_vc" },
    { 0xACDF3574, "area_ac130_init" },
    { 0xC35C580E, "area_alerted" },
    { 0xEAA83723, "area_barn_init" },
    { 0x9F16FEFB, "area_basement_init" },
    { 0x37824188, "area_clear" },
    { 0x9F32D8D6, "area_clear_vo" },
    { 0x22A6273B, "area_crash_init" },
    { 0x7E0A8B58, "area_creek_init" },
    { 0x7932F565, "area_dirt_path_init" },
    { 0xB67E8B7A, "area_explosion" },
    { 0x9B5E28D2, "area_farm_init" },
    { 0xAEDE9AC8, "area_field_init" },
    { 0x4992CD34, "area_flight_init" },
    { 0x860C0ADC, "area_forward" },
    { 0xC9118617, "area_greenhouse_init" },
    { 0x57540173, "area_is_clear" },
    { 0xB2E30110, "area_location" },
    { 0x2E1CB30C, "area_road_init" },
    { 0x7427E4AB, "area_trigger" },
    { 0x4CE5018A, "area_triggers" },
    { 0xA0F2E18D, "areadescentpoints" },
    { 0x0FABCC49, "areadetail" },
    { 0x92E4E88D, "areaent" },
    { 0xEB9BA618, "arealhits" },
    { 0x5A25914E, "areallmissionsatscore" },
    { 0x339428BA, "areallteamsdead" },
    { 0x439FF20B, "areaname" },
    { 0xC3A40615, "areanodes" },
    { 0x99E22C5E, "areanum" },
    { 0xE5991A2C, "areanyplayerswatchingthekillcam" },
    { 0x644EF879, "areas" },
    { 0xF419611C, "areatrig" },
    { 0x7A29B386, "areatrigger" },
    { 0x30E5C05F, "areatrigs" },
    { 0xB36AFDFE, "aregametypeeventruleconditionalsmet" },
    { 0xEEDC6F68, "aremainingtargets" },
    { 0x42B73A8A, "arena" },
    { 0x5C6944E0, "arena_ai_behavior" },
    { 0x68C8D962, "arena_ai_cleanup" },
    { 0xC8241452, "arena_center" },
    { 0xA6B47AAA, "arena_chopper_crash" },
    { 0xBE0CC36B, "arena_chopper_trail" },
    { 0x8CC8E4E9, "arena_crosser_logic" },
    { 0xC449120C, "arena_drone_kill_closest" },
    { 0xCC9E52AC, "arena_drone_throttle" },
    { 0x128EC76C, "arena_drones" },
    { 0xEA7BD240, "arena_exits" },
    { 0xA7A0AC2B, "arena_explosion_fx" },
    { 0x12B3C9A1, "arena_explosions" },
    { 0x21DB21D6, "arena_findindexbyname" },
    { 0xB87D23F2, "arena_guy" },
    { 0x6D5E2F2D, "arena_guy_logic" },
    { 0xAE73E370, "arena_hide_drone_delete" },
    { 0x1313F6C4, "arena_hip_land" },
    { 0x4C1E874F, "arena_hip_land_logic" },
    { 0xB86345FD, "arena_horses_alive" },
    { 0x0C49994B, "arena_initialize" },
    { 0xE47E7177, "arena_laps" },
    { 0xBA26CE33, "arena_manager_init" },
    { 0x7DBE3435, "arena_mig1_bombs" },
    { 0x069C4696, "arena_random_drones" },
    { 0xFA198357, "arena_random_drones_controlled" },
    { 0x99D98306, "arena_rock_crash" },
    { 0x0458C27D, "arena_round_number" },
    { 0x2104BFA5, "arena_sniper_behavior" },
    { 0xC7FA8516, "arena_squad_behavior" },
    { 0xEB1ACC09, "arena_wins_index" },
    { 0x0CFCB46C, "arenabeginmatch" },
    { 0x7D8D2EE4, "arenaendmatch" },
    { 0xFFF618BA, "arenagetslot" },
    { 0xF4986D4B, "arenaleaderboard" },
    { 0xD5AB2D45, "arenamatch" },
    { 0xC5E1624F, "arenamode" },
    { 0xB7F2EB8B, "arenapoints" },
    { 0x0B843AC5, "arenas" },
    { 0x987DF0BE, "arenaslot" },
    { 0xBBC477E0, "arenearbyspeakersactive" },
    { 0xA09BF807, "arent" },
    { 0xE525BDA4, "areteamarraysequal" },
    { 0x09141F82, "aretexturesloaded" },
    { 0x519CEFE7, "arg" },
    { 0x9B32D4CC, "arg1" },
    { 0x3D7BF0D4, "arg10" },
    { 0x0D3A4407, "arg2" },
    { 0xE737C99E, "arg3" },
    { 0x292B6591, "arg4" },
    { 0x0328EB28, "arg5" },
    { 0x75305A63, "arg6" },
    { 0x4F2DDFFA, "arg7" },
    { 0x91217BED, "arg8" },
    { 0x6B1F0184, "arg9" },
    { 0x70AA883D, "argh" },
    { 0x4467D6C1, "argnum" },
    { 0x66992F5E, "args" },
    { 0xEB2BE37E, "argsasdict" },
    { 0xC7960671, "arguement" },
    { 0x61867DB0, "arguing" },
    { 0x755E1504, "argument" },
    { 0x8AB31F2F, "argument_done" },
    { 0x585C43B7, "arguments" },
    { 0x38AF3E83, "argus" },
    { 0x3FC1D447, "argus_build_ui" },
    { 0x7DF6A1D6, "argus_disable" },
    { 0xF8AF6B1B, "argus_enable" },
    { 0x5C4F43AC, "argus_large_image_h" },
    { 0x66609C8B, "argus_large_image_w" },
    { 0xBC76EA3C, "argus_large_image_x" },
    { 0xE27964A5, "argus_large_image_y" },
    { 0x5FF3447D, "argus_large_pad" },
    { 0x001B2BF1, "argus_large_text1_h" },
    { 0x3A405818, "argus_large_text1_y" },
    { 0x34373EFE, "argus_large_text2_h" },
    { 0xBA615FF7, "argus_large_text2_y" },
    { 0x725385D9, "argus_large_text_w" },
    { 0x6073BD2E, "argus_large_text_x" },
    { 0x62780570, "argus_small_image_h" },
    { 0x3C758B07, "argus_small_image_w" },
    { 0x02505EE0, "argus_small_image_x" },
    { 0x2852D949, "argus_small_image_y" },
    { 0x72514509, "argus_small_pad" },
    { 0x791C074A, "argus_small_text_h" },
    { 0x5AE7FCAD, "argus_small_text_w" },
    { 0x18F460BA, "argus_small_text_x" },
    { 0x3EF6DB23, "argus_small_text_y" },
    { 0x8949F383, "argus_toggle_think" },
    { 0xF9CA2186, "argus_ui_large_height" },
    { 0x873D574E, "argus_ui_small_height" },
    { 0x8D081679, "argus_ui_width" },
    { 0x70DCDF3F, "argus_zones" },
    { 0x189F061F, "argusbuildui" },
    { 0x8417713E, "argusforcedrawbracket" },
    { 0x9347A857, "argusgetorigin" },
    { 0xE682C62C, "argusid" },
    { 0x8D329A58, "argusimageandtext2ui" },
    { 0xDFE4BAAE, "argusimageandtextui" },
    { 0xADF64BCB, "argussetbracket" },
    { 0x115FD070, "argussetdistance" },
    { 0x16FFFB44, "argussetoffset" },
    { 0x89AABA5A, "argustextonlyui" },
    { 0x47B122EA, "arial" },
    { 0xD6682DAD, "aribrary" },
    { 0x9C83A57D, "ariders" },
    { 0x6605CCD9, "aries" },
    { 0x003DCD8D, "arise" },
    { 0x5BCC320C, "arises" },
    { 0x2575B44F, "arleady" },
    { 0xF9BE51B6, "arlington_is_present" },
    { 0xD58427CD, "arm" },
    { 0x95C06DC0, "arm_ang" },
    { 0x76F46DDF, "arm_base" },
    { 0xE300F890, "arm_delaying_action" },
    { 0x178C0E55, "arm_detach" },
    { 0xBEB12F4C, "arm_explosives_reminder_thread" },
    { 0x0EEEE776, "arm_gib" },
    { 0x06449040, "arm_goes_flying" },
    { 0x4BBBB773, "arm_left" },
    { 0xAADE995F, "arm_lower" },
    { 0x2B7D2064, "arm_lowered" },
    { 0x178A0357, "arm_model" },
    { 0x8C7EB10B, "arm_move_speed" },
    { 0xAAD1A032, "arm_moving" },
    { 0xD5136DD9, "arm_offset" },
    { 0x3EDE5DCE, "arm_pos" },
    { 0xFB40C966, "arm_right" },
    { 0x00E1BE4B, "arm_rockets" },
    { 0x0172CB43, "arm_single_rocket" },
    { 0x8D383B60, "arm_tag" },
    { 0x39EA378C, "arm_test" },
    { 0xD5FCB17B, "arm_time" },
    { 0x5D71C8E1, "arm_y" },
    { 0x905D74E4, "arm_y_dist" },
    { 0x8374434A, "arm_z" },
    { 0xA40EBA29, "arm_z_dist" },
    { 0x9DD87407, "arm_z_start_offset" },
    { 0xA3DA2CF3, "armada" },
    { 0x5A37BD76, "armada_amb" },
    { 0x843366D9, "armada_anim" },
    { 0xBEB33FE5, "armada_art" },
    { 0x6446CAFC, "armada_audio" },
    { 0x5A5F87B5, "armada_code" },
    { 0x1AB33FEC, "armada_fx" },
    { 0x318C0FA8, "armada_go" },
    { 0x753E0345, "armada_initializations" },
    { 0xF2785F13, "armada_resume_speed" },
    { 0xEDA2F664, "armada_unloaded" },
    { 0x6BE3DEFF, "armada_wait_for_player" },
    { 0x3BE41697, "armade" },
    { 0xD6C95C1E, "armament" },
    { 0x5CE91FD1, "armas" },
    { 0xA4323DC1, "armblade" },
    { 0x5A11ECEA, "armblade_loop_sound" },
    { 0x1A8E90D4, "armblade_sound_thread" },
    { 0xA998D3E8, "armblades" },
    { 0x50ABBE7A, "armed" },
    { 0x3B264A5E, "armed_detonation_wait" },
    { 0x8C8FEF28, "armed_rockets" },
    { 0x9AD36995, "armery" },
    { 0x4E9E3EDB, "arming" },
    { 0x11FC1896, "armless" },
    { 0xEFA0AFEC, "armoffset" },
    { 0x5E52C0F2, "armor" },
    { 0x8FA2D009, "armor_bullet_multiplier" },
    { 0xCF02A025, "armor_color_b" },
    { 0x10F63C18, "armor_color_g" },
    { 0x6EDAF995, "armor_color_r" },
    { 0x04C3DFEE, "armor_damage" },
    { 0xDB3CCBCE, "armor_damage_mod_allowed" },
    { 0x46EC01FD, "armor_damage_type_multiplier" },
    { 0x475154AE, "armor_damaged" },
    { 0x8C452B84, "armor_expansion" },
    { 0x8055FE74, "armor_explosive_multiplier" },
    { 0xEF548F12, "armor_full" },
    { 0x19075B3D, "armor_get_shader_color" },
    { 0x4BEC3E50, "armor_hud" },
    { 0x807EFD15, "armor_index_end" },
    { 0x29E1C2B6, "armor_index_start" },
    { 0x9AB2C25F, "armor_init" },
    { 0x9F08A633, "armor_is_local_player" },
    { 0x99FA6AEB, "armor_jitter" },
    { 0x3FB57A06, "armor_material" },
    { 0xE54BC4C9, "armor_max" },
    { 0x7A08C7BB, "armor_melee_multiplier" },
    { 0x79D485D5, "armor_misc_multiplier" },
    { 0xF8F6F7EC, "armor_overlay_transition_fx" },
    { 0xD6E5F53C, "armor_per_frame" },
    { 0x37346B5A, "armor_player_damage" },
    { 0x52228E50, "armor_points" },
    { 0x35FB6271, "armor_pos" },
    { 0xAD5C2EB2, "armor_projectile_multiplier" },
    { 0xAB183B16, "armor_shield_on" },
    { 0x599F988A, "armor_shield_size" },
    { 0x4A835AFE, "armor_should_take_damage" },
    { 0x74E66334, "armor_state" },
    { 0x83956309, "armor_status_critical" },
    { 0x7CD9B15F, "armor_status_danger" },
    { 0x5C633BED, "armor_status_full" },
    { 0xC2AA8EDD, "armor_status_good" },
    { 0xB31309C9, "armor_status_off" },
    { 0xC67B8BB0, "armor_status_ok" },
    { 0xB465810A, "armor_update_fx_event" },
    { 0x43F40987, "armor_update_shader_event" },
    { 0x50C54C17, "armor_view_kick_multiplier" },
    { 0xA347061B, "armor_x" },
    { 0x7D448BB2, "armor_y" },
    { 0xC6EE7229, "armordamagehints" },
    { 0x3F523605, "armored" },
    { 0x26C5A9E3, "armored_car_line" },
    { 0xD452FCDC, "armored_window" },
    { 0xB00C83F9, "armored_window_start" },
    { 0x2665364C, "armorhudback" },
    { 0x690D6518, "armorhudelem" },
    { 0x3CA1A1AD, "armoron" },
    { 0x36B3C8C2, "armorpiercing_data" },
    { 0x57594972, "armorstatusnew" },
    { 0x1B1BA3E0, "armorvest" },
    { 0x9D541D77, "armorvest_data" },
    { 0x65719897, "armory" },
    { 0xF7DB0AFE, "armory_all_items" },
    { 0xBDA76B35, "armory_control_room" },
    { 0x1AECEC04, "armory_entrance" },
    { 0x147E261D, "armory_exit_gaz_gunner_1" },
    { 0x3A80A086, "armory_exit_gaz_gunner_2" },
    { 0x18D0EE39, "armory_exit_gaz_gunner_radius_death" },
    { 0x092B00AC, "armory_exit_gaz_gunner_think" },
    { 0xBE6AD753, "armory_exit_gaz_reinforcement" },
    { 0xA93A5AC5, "armory_exit_monitor_gunner" },
    { 0xE6C31ED4, "armory_exit_under_fire" },
    { 0xF2421ECD, "armory_garage" },
    { 0xCFDCB3CD, "armory_main" },
    { 0xFECBC70C, "armory_on_save_restore" },
    { 0x3FD6ADBC, "armory_postload" },
    { 0x26099DB9, "armory_setup" },
    { 0xD80EB3B2, "armory_walkway" },
    { 0x3668C9AF, "armory_wall1" },
    { 0xC4615A74, "armory_wall2" },
    { 0xEA63D4DD, "armory_wall3" },
    { 0x785C65A2, "armory_wall4" },
    { 0x5AC9794C, "arms" },
    { 0x1011D41D, "arms_close" },
    { 0xA91DCD28, "arms_count" },
    { 0xA2E85163, "arms_down" },
    { 0x8C8A6AF4, "arms_notifies" },
    { 0x6644C457, "arms_open" },
    { 0xE9CB9869, "arms_order" },
    { 0x20689072, "arms_position" },
    { 0xC7FA0D8C, "arms_up" },
    { 0x855998F8, "arms_y" },
    { 0xF7610833, "arms_z" },
    { 0xF4E67C91, "armtest" },
    { 0x76BA9AD6, "army" },
    { 0x6DF88847, "army_street_push" },
    { 0x609D1D44, "arnie" },
    { 0x58A20D3D, "arnold" },
    { 0xC10295CD, "arollers" },
    { 0x8CA331EF, "aroster" },
    { 0xAE5A8BC2, "aroudn" },
    { 0x364309EE, "around" },
    { 0x06EAD188, "aroutenodes" },
    { 0x717E0498, "aroutes" },
    { 0xE795C38B, "arpgsources" },
    { 0x1AEA290B, "arpgtargets" },
    { 0xF3B8326A, "arr" },
    { 0x59B068A2, "arr_ai_type" },
    { 0x26EBE737, "arr_dmg_adjust" },
    { 0xF7C11EB3, "arr_dmg_factor" },
    { 0x136F459A, "arr_endons" },
    { 0xBB7E3712, "arr_notifies" },
    { 0x1CF2EA27, "arrange" },
    { 0x624A9921, "arranged" },
    { 0x07B5E33F, "arrangement" },
    { 0x84970CC4, "array" },
    { 0x43A3EC65, "array1" },
    { 0x69A666CE, "array2" },
    { 0x8FA8E137, "array3" },
    { 0xEDB60B79, "array_2d_add" },
    { 0x5DCE796E, "array_2dadd" },
    { 0x44C46330, "array_add" },
    { 0xB065C439, "array_ai" },
    { 0xC17BADE7, "array_ai_types" },
    { 0x28DF0C2C, "array_average" },
    { 0x54BD6C4B, "array_blown" },
    { 0x7EFFB381, "array_check" },
    { 0x26044093, "array_check_for_dupes" },
    { 0x5DED5C8E, "array_check_for_dupes_using_compare" },
    { 0x8300D08E, "array_choice" },
    { 0x866AF648, "array_closest" },
    { 0x89A12BAE, "array_closest_ent" },
    { 0x71C73D82, "array_combine" },
    { 0x38167C09, "array_combine_keys" },
    { 0xA2E449A1, "array_contains_element" },
    { 0x0E8A3A50, "array_copy" },
    { 0x8EBBEEC8, "array_copy_if_array" },
    { 0xF4A8D310, "array_count" },
    { 0x2D0EB86A, "array_delete" },
    { 0xB9505DE0, "array_delete_ai_from_noteworthy" },
    { 0x0C23B1E2, "array_delete_veh_from_targetname" },
    { 0xEC4003C0, "array_drop" },
    { 0x8CA58641, "array_ent_thread" },
    { 0x038617B5, "array_ents" },
    { 0xA6E1586C, "array_equal_to_zero" },
    { 0x77402787, "array_exclude" },
    { 0x29D3F960, "array_flag_wait_any" },
    { 0x97834A6B, "array_flag_wait_any_thread" },
    { 0x2421C5C9, "array_func" },
    { 0xFBA565B4, "array_greater_than_zero" },
    { 0x173FACCC, "array_insert" },
    { 0x804CE75A, "array_insert_at_end" },
    { 0xD4C858E0, "array_key" },
    { 0x69E24B8B, "array_keys" },
    { 0xF131DFDC, "array_left_side_nodes" },
    { 0x2444AF3F, "array_levelthread" },
    { 0x65998068, "array_limit" },
    { 0xBC677DDD, "array_limiter" },
    { 0x5080D7B9, "array_merge" },
    { 0x87051C46, "array_name" },
    { 0x70E2C490, "array_notify" },
    { 0x039395DC, "array_number" },
    { 0x4CE3121F, "array_numbers_1_to_10" },
    { 0xB72BAA99, "array_of_arrays" },
    { 0x25801A89, "array_of_items" },
    { 0xBA041996, "array_players_on_gondola" },
    { 0x27B4E26C, "array_pop" },
    { 0x0E5045BF, "array_pristine" },
    { 0x7F8B879F, "array_props" },
    { 0xF7B57B10, "array_randomize" },
    { 0xEE9F00C5, "array_randomize_knuth" },
    { 0x5B09F0F4, "array_randomized" },
    { 0xE54B650D, "array_reel_triggers" },
    { 0xDC02061B, "array_remove" },
    { 0x8FA9D868, "array_remove_first" },
    { 0xF752DCF2, "array_remove_index" },
    { 0xBCA90293, "array_remove_nokeys" },
    { 0x63B956EC, "array_remove_without_model" },
    { 0xE6CE1769, "array_removedead" },
    { 0x144708B7, "array_removedead_keepkeys" },
    { 0xD56BF8DD, "array_removeundefined" },
    { 0x46BE0E93, "array_reverse" },
    { 0x7566E3F6, "array_set_visible_to_all" },
    { 0xCE856628, "array_shared" },
    { 0x1D3E32EF, "array_shift_left" },
    { 0x9DAB97A8, "array_size" },
    { 0xC99515AC, "array_spawn" },
    { 0xBCF85E1E, "array_std_deviation" },
    { 0xCFB18788, "array_struct_closest" },
    { 0xF8FBB1B7, "array_structs" },
    { 0xC771B44E, "array_swap" },
    { 0x23673615, "array_targetname" },
    { 0x6EFA7BE7, "array_thread" },
    { 0x636EC991, "array_thread4" },
    { 0x3D6C4F28, "array_thread5" },
    { 0x734C7333, "array_type" },
    { 0x24EB8575, "array_validate" },
    { 0x84CFCD42, "array_value" },
    { 0xAE22074E, "array_vox_ad" },
    { 0xF8D2B2D6, "array_vox_remind" },
    { 0xFB00D9CC, "array_wait" },
    { 0x2DFBB3AB, "array_wait_any" },
    { 0xF2012473, "array_waitlogic1" },
    { 0x7FF9B538, "array_waitlogic2" },
    { 0xA5FC2FA1, "array_waitlogic3" },
    { 0x94EBB044, "array_woods_grab" },
    { 0xC48B032A, "array_zombies_allowed_to_switch" },
    { 0x525AE497, "arraycombine" },
    { 0x41F575C3, "arraycopy" },
    { 0x37293CA9, "arraycount" },
    { 0x3A7BCB12, "arrayents" },
    { 0x8C9339B2, "arrayexclude" },
    { 0xE7BDC1A1, "arraygetclosest" },
    { 0xE0E45C59, "arrayin" },
    { 0xF2152198, "arrayindex" },
    { 0x1C2BEB2B, "arrayinsert" },
    { 0x6F8792EB, "arrayintersect" },
    { 0x44A16C68, "arraykeys" },
    { 0x3C72057C, "arraylist" },
    { 0xBF0F8BBB, "arraymainkeys" },
    { 0x8F63DFA5, "arrayname" },
    { 0x6D103979, "arrayofmodels" },
    { 0xF96A2134, "arrayremove" },
    { 0x6C668988, "arrayremoveindex" },
    { 0x81403B2F, "arrayremovevalue" },
    { 0x10477B77, "arrays" },
    { 0xA6C28A77, "arrays_of_colorcoded_ai" },
    { 0xC220FFD0, "arrays_of_colorcoded_nodes" },
    { 0x030787C2, "arrays_of_colorcoded_spawners" },
    { 0x7785FB5B, "arrays_of_colorforced_ai" },
    { 0x1B14459F, "arraysize" },
    { 0xF926D8E8, "arraysort" },
    { 0x057EFBE1, "arraysortclosest" },
    { 0x212B9AC6, "arraysubkeys" },
    { 0x265E302E, "arraytemp" },
    { 0xC819CAE8, "arraytospawn" },
    { 0x7BB59F48, "arraytostring" },
    { 0xC0213195, "arrested" },
    { 0x9C601434, "arrival" },
    { 0x36E68ACF, "arrival_anims" },
    { 0xA1FF1C6F, "arrival_attract_func" },
    { 0xB53D937D, "arrival_cleanup" },
    { 0x2F967371, "arrival_cover_split_notetrack" },
    { 0x2A3CB0E5, "arrival_disable" },
    { 0x00FED0AE, "arrival_height_tolerance" },
    { 0x5C89C59B, "arrival_precache_anims" },
    { 0xF28187C3, "arrival_stance" },
    { 0xF64910C3, "arrival_type" },
    { 0x8AACC745, "arrivalangle" },
    { 0xDFD309C3, "arrivalanim" },
    { 0xAE4E4225, "arrivaldistance" },
    { 0x471D7C8B, "arrivaldvar" },
    { 0x911A649A, "arrivalfinalpos" },
    { 0xB34C89D9, "arrivalfromfront" },
    { 0xB492DB98, "arrivalkeys" },
    { 0xB5D9CA36, "arrivalpoint" },
    { 0xD0F9E172, "arrivalpos" },
    { 0x3031AF27, "arrivals" },
    { 0x9E7C42A3, "arrivalsandexits_enabled" },
    { 0x6067C460, "arrivalstartdist" },
    { 0xB8A0577C, "arrivaltype" },
    { 0xAF7D89B5, "arrivalyaw" },
    { 0x4344928C, "arrive" },
    { 0x128699AE, "arrive_at_cover_asm_state" },
    { 0x37DC4116, "arrive_at_goal" },
    { 0x0D6622F6, "arrive_at_plane_trigger" },
    { 0x090DDB17, "arrive_door" },
    { 0x2318BB3E, "arrive_points" },
    { 0x18997BA0, "arrived" },
    { 0xC9FA4DAA, "arrived_at_end_node_func" },
    { 0x82D27B0F, "arrives" },
    { 0xFD0BC735, "arriving" },
    { 0x5D66C657, "arrogant" },
    { 0x901206C4, "arrow" },
    { 0xBF6BF2F3, "arrow_bounce" },
    { 0xFBB5E942, "arrow_forward" },
    { 0x959FC946, "arrow_hud" },
    { 0x30DD8EF8, "arrow_spin_func" },
    { 0xDE068966, "arrow_vectorlength" },
    { 0x0BC6333C, "arrow_vectorscale" },
    { 0x7E24F0C5, "arrowback" },
    { 0x14EB9EE3, "arrowforward" },
    { 0x34A4F6B8, "arrowhead_forward" },
    { 0x56C2F745, "arrowhead_right" },
    { 0x57320387, "arrowleft" },
    { 0xF32EC920, "arrowlength" },
    { 0xC255B902, "arrowright" },
    { 0x22DF0977, "arrows" },
    { 0x7C8D8BB7, "arrowtime" },
    { 0xBC99F386, "arrray" },
    { 0x4689A16B, "arrrg" },
    { 0x06D2F4DF, "arrrrgh" },
    { 0x2A4C72E5, "arrrrrrggggghhhhhhhhhh" },
    { 0x05963244, "arse" },
    { 0x4054B99A, "arsehole" },
    { 0xA1EF83F7, "arses" },
    { 0x3FBD273C, "art" },
    { 0x3EF15ED6, "art2" },
    { 0x3EBDA12E, "art_ent_optimization" },
    { 0x30C3B76E, "art_jet_mode_settings" },
    { 0xE376F430, "art_move" },
    { 0xC674583C, "art_on_left" },
    { 0xCF951113, "art_on_right" },
    { 0x60086937, "art_review" },
    { 0xDAE97C7D, "art_settings_for_heavy_rain" },
    { 0xF92E911E, "art_settings_for_light_rain" },
    { 0x8A1AB6D9, "art_settings_for_meatshield" },
    { 0x0656DC2D, "art_settings_for_tunnel_crawl" },
    { 0x97FD673E, "art_settings_for_village_intro" },
    { 0x4E5A528C, "art_settings_inside_crashed_huey" },
    { 0x8589A729, "art_transition_thread" },
    { 0xF5769321, "art_tweak" },
    { 0xC36AFB5E, "art_vtol_mode_settings" },
    { 0x3AEF23E5, "artfxprintln" },
    { 0xC395AFD3, "artifact" },
    { 0x4B073A24, "artifact_dim" },
    { 0xE45312B5, "artifact_glow" },
    { 0x394CE4BC, "artifact_glow_setting" },
    { 0x54D0A079, "artifact_pulse_baseline" },
    { 0xED05A1FB, "artifact_pulse_timescale" },
    { 0x824B9C63, "artifically" },
    { 0x99455AB5, "artificial" },
    { 0x3ABCCC18, "artificially" },
    { 0x3261BBF5, "artilleries" },
    { 0xE966560D, "artillery" },
    { 0x8FB06E7F, "artillery_barrage_logic" },
    { 0xC6BF617F, "artillery_earthquake" },
    { 0x029381F5, "artillery_fx_logic" },
    { 0x9234F6F2, "artillery_fx_logic_ee" },
    { 0xCE597ECA, "artillery_influencer_radius" },
    { 0xD595BC9E, "artillery_influencer_score" },
    { 0x81D7D57A, "artillery_influencer_score_curve" },
    { 0x3874BE80, "artillery_origin_struct_name" },
    { 0x1B215859, "artillery_status_change" },
    { 0xC0C3FAF7, "artillerycanoncount" },
    { 0x3218041D, "artillerycanonshellcount" },
    { 0x430350D8, "artillerydamagedents" },
    { 0x71A65945, "artillerydamagedentscount" },
    { 0x927171CC, "artillerydamagedentsindex" },
    { 0xFF578F88, "artillerydamageentsthread" },
    { 0xC49A67A6, "artillerydangercenters" },
    { 0x36BF9613, "artillerydangerforwardpush" },
    { 0x432A5538, "artillerydangermaxradius" },
    { 0x4318C9F0, "artillerydangermaxradiussq" },
    { 0x6E3FC672, "artillerydangerminradius" },
    { 0x147C149E, "artillerydangerovalscale" },
    { 0xF3EAB37B, "artilleryfx" },
    { 0x13D1455F, "artilleryiconlocation" },
    { 0x371C281F, "artilleryimpacteffects" },
    { 0xE36522D7, "artilleryinprogess" },
    { 0x88E7B1FD, "artilleryinprogress" },
    { 0x1B7FCE19, "artillerykillcammodelcounts" },
    { 0x85C3AE9C, "artillerymaprange" },
    { 0x7E50604B, "artillerymomentum" },
    { 0xC467A071, "artilleryshellshock" },
    { 0x8E6F7D13, "artilleryshellsinair" },
    { 0x07E0FA43, "artillerywaiter" },
    { 0x93BE7628, "artist" },
    { 0xF9835DD9, "artist_mod" },
    { 0x8F0316C3, "artists" },
    { 0xF38A8142, "artpiece" },
    { 0xC8641D75, "arty" },
    { 0x24BF8B56, "arty1" },
    { 0xFEBD10ED, "arty2" },
    { 0x11BA354E, "arty_anims" },
    { 0xFF389211, "arty_anims_gun" },
    { 0xCBF6EBCF, "arty_array" },
    { 0x4517B176, "arty_behavior" },
    { 0x4E8D6B8B, "arty_crew" },
    { 0xB2C1B4F9, "arty_crew_death_think" },
    { 0x495C0695, "arty_crew_dismount" },
    { 0xF2E915CE, "arty_crew_info" },
    { 0x1497B458, "arty_crew_init" },
    { 0x83D0031C, "arty_crew_play_anim" },
    { 0xB4EB5889, "arty_custom_targeting" },
    { 0xAC9268AC, "arty_dismount_trig" },
    { 0x4702012A, "arty_fake_fire_impacts" },
    { 0x6F9E1324, "arty_fire" },
    { 0xFD92B958, "arty_fire_impacts" },
    { 0x15D93A65, "arty_fire_loop" },
    { 0x4677BB1F, "arty_fire_without_move" },
    { 0x70AF6271, "arty_firstshake_dialogue" },
    { 0xAE98F438, "arty_flaps" },
    { 0xDED9E781, "arty_flickerlights_on" },
    { 0x863F2D33, "arty_gun_init" },
    { 0xF8C01369, "arty_isemitting" },
    { 0xB750B141, "arty_launch" },
    { 0x46E5E9BF, "arty_move" },
    { 0x2AF41C52, "arty_normalshake_friendly_dialogue" },
    { 0x063E589D, "arty_soundspot" },
    { 0x66515A07, "arty_spawners" },
    { 0xA3766476, "arty_strike" },
    { 0x33C1ADAD, "arty_strike_on_players" },
    { 0x38D51D32, "arty_strike_rumble" },
    { 0x5EFC0F33, "arty_target" },
    { 0xFF0826E2, "arty_targets" },
    { 0x4E1E3864, "artycrew_animation_think" },
    { 0xFED93C63, "artygun_animation_think" },
    { 0x17F1C698, "aruments" },
    { 0x1C84D9E1, "as" },
    { 0xB9A4EDCA, "as_death" },
    { 0x7E4A6241, "as_debug" },
    { 0x4F2EDA74, "as_dryland" },
    { 0x12E906E3, "as_off" },
    { 0xFC2B102F, "as_on" },
    { 0x2E98A456, "as_rocket_exploded" },
    { 0x1820EEB5, "as_surface" },
    { 0xB2DC2D5F, "as_underwater" },
    { 0x18AAA497, "as_wetland" },
    { 0x606FCFEA, "asa" },
    { 0xE249B0DA, "asad" },
    { 0xDA7B410E, "asap" },
    { 0x95AAAB81, "asawnodes01" },
    { 0xBBAD25EA, "asawnodes02" },
    { 0xE1AFA053, "asawnodes03" },
    { 0x66F17EB7, "ascend" },
    { 0xD3AFD00D, "ascend_starts" },
    { 0xC08717E9, "ascending" },
    { 0xF7D8979A, "ascension" },
    { 0xB9643C0C, "ascii_logo" },
    { 0x1E7C33F7, "asd" },
    { 0x27602677, "asd_battle_dialog" },
    { 0x7D85322D, "asd_battle_enemy_vo" },
    { 0xB58B00F2, "asd_cleanup" },
    { 0x087D0366, "asd_defend_1" },
    { 0xE27A88FD, "asd_defend_2" },
    { 0xE5F67938, "asd_fall_back_think" },
    { 0x537E64E6, "asd_fire_on_lift" },
    { 0x88540D81, "asd_freezed" },
    { 0x4FF6D286, "asd_frozen_challenge" },
    { 0x5CE72E37, "asd_gib_chance" },
    { 0x1AEE6AE4, "asd_god_mode_off" },
    { 0xFF9159DD, "asd_grenade_defense" },
    { 0xE766ABC3, "asd_hallway_gunfire" },
    { 0x35B48C1E, "asd_hallway_vo" },
    { 0x643A9594, "asd_health_watch" },
    { 0xF5D160F0, "asd_intro" },
    { 0xE90FA483, "asd_intro_anims" },
    { 0x7B05CCA1, "asd_intro_destruction" },
    { 0x9BF7B8A7, "asd_intro_guard_think" },
    { 0x105A97ED, "asd_lobby_guys" },
    { 0x199E180F, "asd_lobby_think" },
    { 0x8AA097AF, "asd_name" },
    { 0x6E74EFF2, "asd_nitrogen_challenge_watch" },
    { 0x067176DD, "asd_perk_death_visor_text" },
    { 0x82C20781, "asd_perk_dialog" },
    { 0x754BD3A4, "asd_perk_visor_text" },
    { 0xFA3D5E58, "asd_player_think" },
    { 0x2084C127, "asd_rundown_kills" },
    { 0x7F714458, "asd_rundown_kills_total" },
    { 0x72BB4A31, "asd_state" },
    { 0x135A692B, "asd_tutorial_intro" },
    { 0x477B8C00, "asd_tutorial_timeout" },
    { 0xAF7CE7D1, "asd_up" },
    { 0xC7A15065, "asd_use_double_wide" },
    { 0x4875C207, "asd_visor_text" },
    { 0x57733052, "asd_wall_crash" },
    { 0xE96EC063, "asdf" },
    { 0xF33DB2C6, "asdfaskdjfaksjdflisjdflkjl" },
    { 0xA21D4DD6, "asdlocs" },
    { 0xBB9DD62E, "asds" },
    { 0xF5F8F9AB, "asdsquad" },
    { 0x4EAEB8C1, "asec" },
    { 0x60DEA8EA, "ashtrays" },
    { 0x9956EACB, "aside" },
    { 0x48906ED5, "asign" },
    { 0xEA5B0402, "asigned" },
    { 0x4FC18F38, "asin" },
    { 0xE45707D0, "ask" },
    { 0x4A664503, "ask_redo" },
    { 0x5DED9663, "asked" },
    { 0x015F8648, "asked_for_macmillan" },
    { 0x448E6DC8, "asking" },
    { 0xC865E646, "asm" },
    { 0x0BCA5382, "asm_alias_attribute" },
    { 0x6F82574C, "asm_complete" },
    { 0x1A8B762F, "asm_death_notify" },
    { 0x9C192458, "asm_faller_deathout_notetrack" },
    { 0x55A1B5F2, "asm_faller_melee_notetrack" },
    { 0x65976712, "asm_margwa_bodyfall_notetrack" },
    { 0x8AF4AC20, "asm_margwa_pain_melee_notetrack" },
    { 0x30CEEB2E, "asm_margwa_smash_attack_notetrack" },
    { 0x8A6EB86B, "asm_mechz_grenade_notetrack" },
    { 0xA501E9A5, "asm_mechz_melee_notetrack" },
    { 0x017F9C4A, "asm_mocomp_name" },
    { 0x4564ECF5, "asm_mocomp_start" },
    { 0x3F264A04, "asm_mocomp_terminate" },
    { 0xADFF27D4, "asm_mocomp_update" },
    { 0x21B7788A, "asm_notetrack_handler_stop_notify" },
    { 0x0FB01F33, "asm_register_blackboard_notetrack_handler" },
    { 0xF4AD6738, "asm_register_mocomp" },
    { 0x0E241B2F, "asm_register_notetrack_handler" },
    { 0x57502535, "asm_skeleton_melee_notetrack" },
    { 0x6A90F0B6, "asm_state_complete" },
    { 0x15F78158, "asm_state_inactive" },
    { 0xDFE92409, "asm_state_invalid_index" },
    { 0x1951F8D4, "asm_state_running" },
    { 0x007ED8D0, "asm_state_terminated" },
    { 0x86C8881C, "asm_state_transition_complete" },
    { 0x1AE8BD76, "asm_terminated" },
    { 0x4DA9AAE3, "asm_thrasher_melee_notetrack" },
    { 0xBDCCC6EB, "asm_zombie_crush_notetrack" },
    { 0x9B4512F1, "asm_zombie_dog_melee_notetrack" },
    { 0xB0CA4F86, "asm_zombie_melee_notetrack" },
    { 0xE777B5AF, "asmchangeanimmappingtable" },
    { 0x5A40C933, "asmentity" },
    { 0x81845A05, "asmgetcurrentdeltaanimation" },
    { 0x2E1D7498, "asmgetcurrentstate" },
    { 0xDE6C2CF0, "asmgetstatus" },
    { 0xF3314152, "asmisaimlayeractive" },
    { 0xAB271430, "asmisshootlayeractive" },
    { 0x78807650, "asmissubstatepending" },
    { 0x0DE3B506, "asmisterminating" },
    { 0xAE9F93AD, "asmistransdecrunning" },
    { 0x90BB33BC, "asmistransitionrunning" },
    { 0x6833B810, "asmokes" },
    { 0x72A98D9C, "asmrequestsubstate" },
    { 0x22BEDFA6, "asmsetanimationrate" },
    { 0x085F5125, "asmstate" },
    { 0x30445F6C, "asmstatename" },
    { 0x52C1BFE4, "asmstatus" },
    { 0xD374FADB, "asniper_orgs" },
    { 0xB4E671EA, "asof" },
    { 0x264AA3C3, "asp" },
    { 0x0A46EDAE, "aspawnarray" },
    { 0x3374DF5E, "aspawner" },
    { 0x5832E5C1, "aspawners" },
    { 0xBFAD00F6, "aspawnprocs" },
    { 0x72412160, "aspeakers" },
    { 0xE9B6E4C3, "aspeakertalk" },
    { 0x9F14E241, "aspect" },
    { 0x44B3DE05, "aspect_ratio" },
    { 0x5860EEB1, "aspectratioguess" },
    { 0x4BFA8959, "asplode" },
    { 0x36446B14, "asquad" },
    { 0xB4433488, "ass" },
    { 0x4A1065C6, "assasin_anim_node" },
    { 0x56219435, "assasin_damaged_by_player" },
    { 0x72D537F5, "assasin_door_guards" },
    { 0x0FA75BF8, "assasin_fast_timescale" },
    { 0xA20D5D95, "assasin_lowready_off" },
    { 0xFE062DAD, "assasin_slow_timescale" },
    { 0xFD0BAE1F, "assasinate" },
    { 0xD73D08A2, "assasinate_trigger" },
    { 0x2009E409, "assasinated" },
    { 0xB5905854, "assasination" },
    { 0x68847207, "assasination_alert" },
    { 0x17F3F8A6, "assasination_alert_thread" },
    { 0x2C005BD3, "assasination_ambience" },
    { 0x8AD1F6FA, "assasination_arrival" },
    { 0x7FA5CC44, "assasination_assasinated_idle" },
    { 0xDBD7CC0F, "assasination_castro" },
    { 0x952E07B5, "assasination_dialogue" },
    { 0xBF98CEA4, "assasination_door_guards" },
    { 0xAA5709C7, "assasination_executioner_idle" },
    { 0x7189005A, "assasination_kill_trigger" },
    { 0xE184EC82, "assasination_last_weapon" },
    { 0x7A5EC504, "assasination_main" },
    { 0x2CCD0106, "assasination_open_door" },
    { 0x6D9FB00C, "assasination_player" },
    { 0xC907C4C8, "assasination_player_fov" },
    { 0xABCFAE04, "assasination_player_reset" },
    { 0x49234556, "assasination_player_setup" },
    { 0x8CCB9083, "assasination_ragdoll_death" },
    { 0x6F941015, "assasination_think" },
    { 0x6D4C434B, "assasination_time_scale" },
    { 0x05F1EA6C, "assasination_triggers" },
    { 0x16FD665C, "assasination_wait" },
    { 0x1A27C9B3, "assasination_woman" },
    { 0xB6AF3D27, "assasination_woods" },
    { 0x6C5FFFB7, "assasination_woods_door_dialogue" },
    { 0x5E27F737, "assasinationstruct" },
    { 0xE1D78656, "assassin" },
    { 0xC547EF72, "assassinate" },
    { 0xE8A7FC98, "assassinatehudelem" },
    { 0x1A1DC319, "assassination" },
    { 0x0DECB216, "assault" },
    { 0xCEB80727, "assault_bp1_logic" },
    { 0x2F2306A2, "assault_endgame_1" },
    { 0x09208C39, "assault_endgame_2" },
    { 0xE31E11D0, "assault_endgame_3" },
    { 0xCA646E88, "assault_endgame_array" },
    { 0x9B9A340F, "assault_lobby" },
    { 0x3D997EE1, "assault_player_if_close" },
    { 0x04475CC2, "assault_second_waves" },
    { 0x722A073C, "assault_soviet_logic" },
    { 0xBCF75026, "assault_spawners" },
    { 0x8FD011CB, "assault_training" },
    { 0x31AE9BD9, "assaulted" },
    { 0x5DA8EE0A, "assaulting" },
    { 0xDA0E9C75, "assemble" },
    { 0xCE242115, "assemble_attachments_for_weapon" },
    { 0x3BCD4699, "assemble_bg_character" },
    { 0x5A10CCFD, "assemble_vtol_explode2" },
    { 0x61A7156B, "assembled" },
    { 0xA28920AC, "assemblers" },
    { 0x2781E944, "assembles" },
    { 0xD022B240, "assembling" },
    { 0x72188619, "assembly" },
    { 0xE1D86CD2, "assembly_line" },
    { 0x898F5ECE, "assembly_seals" },
    { 0x0A7EE953, "assert" },
    { 0x18B4C0D6, "assert_existance_of_anim" },
    { 0x46A11E8B, "assert_if_identical_origins" },
    { 0x4F530B1D, "assert_msg" },
    { 0xBE2611F4, "assertex" },
    { 0xD499554D, "asserting" },
    { 0xF22B74CA, "assertisvalidleftsplitdelta" },
    { 0x811BBE41, "assertisvalidrightsplitdelta" },
    { 0x94739542, "assertmsg" },
    { 0x36F2A476, "assertproperplacement" },
    { 0x9EA42182, "asserts" },
    { 0xB69AC58B, "assertteamvariables" },
    { 0x1C629194, "asses" },
    { 0xAADEC86B, "assess_and_apply_visibility" },
    { 0x8BE78328, "assest" },
    { 0x37A28DC3, "assests" },
    { 0xF660172B, "asset" },
    { 0xD9A3FF8B, "asset_name" },
    { 0x8D2AB5DC, "assetex" },
    { 0xCB5C810A, "assets" },
    { 0xEC71C9E6, "asshole" },
    { 0x96F6B419, "assholes" },
    { 0x99701C32, "assign" },
    { 0x54AFF8BC, "assign_allies_to_threatbiasgroup" },
    { 0x945D6A6A, "assign_animtree" },
    { 0xFA32FCCE, "assign_camo_init" },
    { 0x8C216696, "assign_civ_drone_spawners" },
    { 0x85C8D4ED, "assign_civ_drone_spawners_by_type" },
    { 0xE1199A8F, "assign_civ_spawners" },
    { 0xB5A59DEB, "assign_club_spawners" },
    { 0x9ACF8C3F, "assign_default_weapon" },
    { 0x5B001C43, "assign_ents" },
    { 0x2B7AEF11, "assign_lowest_unused_character_index" },
    { 0xEEB99430, "assign_meat_to_team" },
    { 0xD66C4B28, "assign_model" },
    { 0x726C447B, "assign_random_body" },
    { 0x8E444C9C, "assign_random_retreat_anim" },
    { 0x16D9F8E6, "assign_random_run_anim" },
    { 0xCCEC1FDF, "assign_random_weapon" },
    { 0x7019803D, "assign_scripted_team" },
    { 0xB5BA9BFE, "assign_spotlight_to_end_scene" },
    { 0xFA51372C, "assign_wander_anim_points" },
    { 0x50750E11, "assign_weapon" },
    { 0xCD2EEF14, "assign_weapon_allow_random_attachments" },
    { 0xBB1FD5EA, "assign_weapon_init" },
    { 0x0563B665, "assign_zombie_point_of_interest" },
    { 0x854F7FDE, "assignable" },
    { 0x18BC40B3, "assignable_camo_index_col" },
    { 0x9CCCB80D, "assignable_camo_lookup_col" },
    { 0x7D4EF706, "assignable_camo_name_col" },
    { 0xA8EC0928, "assignable_camos" },
    { 0xC725262D, "assignaitopost" },
    { 0x09D5642B, "assigneable" },
    { 0x403CB245, "assigned" },
    { 0x2CEA7FEB, "assigned_fly_height" },
    { 0xC4649962, "assigned_new_leader" },
    { 0x38685C78, "assigned_to_boat" },
    { 0x82A4CBA8, "assignfirstavailableoffsetindex" },
    { 0x0619CDBE, "assigning" },
    { 0x72F1FAB2, "assignment" },
    { 0x1EC3853D, "assignments" },
    { 0x0EC4EF42, "assignprimarytargets" },
    { 0xB78CAF83, "assignrandombody" },
    { 0x88B126FD, "assignremotecontroltrigger" },
    { 0x375241BD, "assigns" },
    { 0x84232192, "assignsecondarytargets" },
    { 0x0D46B684, "assigntargets" },
    { 0x3AF90B97, "assimilate" },
    { 0xBE5FC024, "assist" },
    { 0xE69863D3, "assist_level" },
    { 0xBBF7C0B9, "assist_level_value" },
    { 0x386F236B, "assist_xp" },
    { 0x44671C23, "assistaircrafttakedown" },
    { 0xA68024B5, "assistance" },
    { 0xF58B60E7, "assistant" },
    { 0x76F5125E, "assistants" },
    { 0xCE8C4487, "assisted" },
    { 0x3A662EDE, "assisted_kill" },
    { 0x1F60A0B5, "assistedsuicide" },
    { 0x4AA50CA1, "assister" },
    { 0x0FB5E448, "assisters" },
    { 0xAE29D804, "assisting" },
    { 0xE69B4157, "assists" },
    { 0xD74A26A7, "assistteam" },
    { 0x8103F604, "assman" },
    { 0xE4CC3027, "assocaited" },
    { 0xFC7119D1, "associate" },
    { 0x10037507, "associated" },
    { 0x5EF50C85, "associatedai" },
    { 0x6A28E6CE, "association" },
    { 0x26888271, "associations" },
    { 0xBD42C9D1, "associativearray" },
    { 0x75C4BEE6, "assorted" },
    { 0xD8C9DA23, "asssets" },
    { 0xCA588444, "assult_course_to_goal_node" },
    { 0xE0BEA0AC, "assult_course_to_goal_node_and_delete" },
    { 0x25B3D823, "assume" },
    { 0xD57675DD, "assumed" },
    { 0xAD95F501, "assumed_ceiling_height" },
    { 0x03476012, "assumes" },
    { 0xADFB66A6, "assuming" },
    { 0x7FEDD2AC, "assumption" },
    { 0x3160C86A, "assure" },
    { 0x4DA0E25A, "assured" },
    { 0xBE548D67, "ast" },
    { 0x37947D21, "ast_awareness" },
    { 0xF0F2B5B3, "ast_awareness_previous" },
    { 0xDF935BEC, "ast_definitions" },
    { 0x1B20AA80, "ast_register_api" },
    { 0xDC042336, "astartingangles" },
    { 0x99DC5B11, "asterisk" },
    { 0x95AF0766, "astragglers" },
    { 0x50080815, "astriketeamthree" },
    { 0xE886C650, "astrings" },
    { 0x9061B3E2, "astro" },
    { 0xDAAA8EE8, "astro_actor_damage" },
    { 0x5B578B80, "astro_custom_damage" },
    { 0x3D0B0628, "astro_damage_callback" },
    { 0xDF565004, "astro_delay_delete" },
    { 0x2CB6F804, "astro_explode_blast_radius" },
    { 0x87AD894D, "astro_explode_pulse_max" },
    { 0x04C24743, "astro_explode_pulse_min" },
    { 0xBD4DF085, "astro_explode_radius" },
    { 0xE3C9F05C, "astro_headbutt_damage" },
    { 0xCE54F4D4, "astro_headbutt_delay" },
    { 0xA781F972, "astro_headbutt_radius_sqr" },
    { 0xFD43D0B7, "astro_locations" },
    { 0x702D3CF4, "astro_manager_end" },
    { 0x30B174F4, "astro_microwavegun_sizzle" },
    { 0x6CEB10C6, "astro_nuke_damage" },
    { 0x750F1C85, "astro_org" },
    { 0x703AC718, "astro_player_pulse" },
    { 0x3BA0E201, "astro_prespawn" },
    { 0xC2E771FF, "astro_restore_move_speed" },
    { 0xADBB5666, "astro_round_start" },
    { 0x272E2696, "astro_struct" },
    { 0xC08DF578, "astro_turn_player" },
    { 0x0EC52CEB, "astro_watch_controls" },
    { 0xE44E9DDB, "astro_zombie" },
    { 0x232D1E6C, "astro_zombie_anim_override" },
    { 0x44110CDA, "astro_zombie_attack" },
    { 0xF36D9328, "astro_zombie_can_spawn" },
    { 0xDC9BC60A, "astro_zombie_custom_think" },
    { 0xBB91C981, "astro_zombie_default_enter_level" },
    { 0x16A70FD4, "astro_zombie_die" },
    { 0x43C494EB, "astro_zombie_enter_level" },
    { 0xC9AED258, "astro_zombie_headbutt_release_watcher" },
    { 0x26A9618E, "astro_zombie_headbutt_think" },
    { 0x39216A52, "astro_zombie_headbutt_watcher" },
    { 0x59FCA61D, "astro_zombie_health_mult" },
    { 0xE85EEDB6, "astro_zombie_idle_setup" },
    { 0x542C312B, "astro_zombie_manager" },
    { 0x396473DB, "astro_zombie_spawn" },
    { 0xD5AC3D29, "astro_zombie_spawners" },
    { 0x14E2EC4F, "astro_zombie_teleport" },
    { 0x94FCD3B6, "astro_zombie_teleport_enemy" },
    { 0x63A252EA, "astro_zombie_think" },
    { 0xB4471748, "astro_zombie_total_update" },
    { 0x4780EAFE, "astronaut" },
    { 0xA7C533E3, "astsearch" },
    { 0x8C8967DC, "asylum" },
    { 0x8F051381, "asylum_balcony_vo" },
    { 0xBF583A79, "asylum_chair_mature" },
    { 0x8CFB3A42, "asylum_controlroom_light" },
    { 0xD246E387, "asylum_controlroom_light_think" },
    { 0xAE397E95, "asylum_entry_vo" },
    { 0x3AEA31C3, "asylum_exit" },
    { 0xEA9D2CD8, "asylum_exit_level" },
    { 0x53AA103E, "asylum_find_exit_point" },
    { 0x30D200AC, "asylum_grounds_gate_open" },
    { 0x66FB3774, "asylum_light_think" },
    { 0x66663128, "asylum_lights" },
    { 0x5AC6B0CB, "asylum_mg_vo" },
    { 0xFE56AAA1, "asylum_stairs_vo" },
    { 0xE53796F9, "asylum_start" },
    { 0xFB9C1C5A, "asylum_zone_init" },
    { 0xE7379C81, "asynchronous" },
    { 0xDA913DEE, "at" },
    { 0xF8D60DDE, "at4" },
    { 0xA8D79D25, "at47" },
    { 0x9D9EB134, "at47s" },
    { 0x199E4140, "at4_detach" },
    { 0x202EDE1B, "at74" },
    { 0x65E92072, "at_aagun_jets" },
    { 0x3D8B3F53, "at_aagun_jets_go" },
    { 0xBAE2B94E, "at_barge_back" },
    { 0xCFD78F30, "at_barge_front" },
    { 0x501FCE4A, "at_bottom_of_zipline" },
    { 0x071411F6, "at_bunker" },
    { 0xAD5268C7, "at_bunker_trig" },
    { 0x348311E6, "at_camp" },
    { 0x06925D64, "at_certain_spot" },
    { 0x090807F8, "at_church" },
    { 0x9A39F4AB, "at_cinch_point" },
    { 0x5CAD770E, "at_correctish_node" },
    { 0xC8AC54CD, "at_defend_objective" },
    { 0x156FF5F1, "at_done" },
    { 0xA9DDD40E, "at_edge" },
    { 0x787FB480, "at_end_of_wave" },
    { 0x9127975C, "at_end_place_count" },
    { 0x4E5F4781, "at_entrance_tear_spot" },
    { 0xA2696ACD, "at_exit" },
    { 0x419C0165, "at_foyer_entrance" },
    { 0x1F76C700, "at_goal" },
    { 0xD81310CF, "at_ground_floor" },
    { 0xA3036471, "at_gun" },
    { 0xD7C7C784, "at_last_node" },
    { 0xAF639C6A, "at_orig" },
    { 0x9AD276E5, "at_plane" },
    { 0x1667ED6D, "at_pos" },
    { 0x2BDE1C23, "at_rest" },
    { 0x7CDA2D22, "at_roullete_table" },
    { 0xE20864CF, "at_start" },
    { 0x5FD33DC4, "at_this_station" },
    { 0x3226678E, "at_trap_find_player_wait" },
    { 0x56CDC0E7, "atan" },
    { 0xEB1E0455, "atankattackspawners" },
    { 0x04C26FF0, "atargetname" },
    { 0x9E978718, "atargets" },
    { 0x0BAA5489, "atbrinkofdeath" },
    { 0xD97EA7F5, "atconcealmentnode" },
    { 0xCDF5DC6B, "atcover" },
    { 0x60EFD0CA, "atdangerousnode" },
    { 0x27D7FDB1, "ateam" },
    { 0xE9815C12, "atenemy" },
    { 0x8D9759DC, "atf" },
    { 0x342A0C8F, "atgoal" },
    { 0xC3327F18, "atgun" },
    { 0x916B7E86, "atgun_blow_wall" },
    { 0x9361638C, "atgun_move_barricade" },
    { 0xD752005B, "atgun_tank_skip" },
    { 0x3AC5326A, "atgun_tank_think" },
    { 0x0A8016D4, "atgun_tank_turret" },
    { 0x7043C401, "atleast" },
    { 0xF4B1618B, "atleastoneplayeroneachteam" },
    { 0x3FFB6CE1, "atleasttwoteams" },
    { 0x03035BE3, "atltitude" },
    { 0xCF8AF5CF, "atm" },
    { 0x71A2E4C2, "atnode" },
    { 0x296A81F7, "atop" },
    { 0x9013AC92, "atpillarnode" },
    { 0xD6553064, "atpoint" },
    { 0x008357F2, "atpoint_back" },
    { 0x115E42A2, "atpoint_forward" },
    { 0x8D421A1B, "atpoint_high" },
    { 0x17B63B2C, "atpoint_left" },
    { 0xF195BF7F, "atpoint_low" },
    { 0x26918FC3, "atpoint_right" },
    { 0xEAE6DFB3, "atpreferedpoint" },
    { 0x9565C9A8, "atr" },
    { 0x8D97665D, "atrees" },
    { 0xD7A1AA04, "atrig" },
    { 0x2F4D1073, "atrigarray" },
    { 0xBCA79478, "atrigger_cobra_retreat" },
    { 0x874B9D9C, "atrigger_player_location" },
    { 0x64A0FDC1, "atriggers" },
    { 0x08BFD2B7, "atrigs" },
    { 0x776D2F5C, "atrigs1" },
    { 0xE9749E97, "atrigs2" },
    { 0x118829C7, "atrium" },
    { 0xEAFD3F58, "atrium_alarms" },
    { 0x8BDD9B09, "atrium_chain" },
    { 0x9BF90D4D, "atrium_color_chain" },
    { 0x38800E8A, "atrium_crow_damage_trig" },
    { 0x13D5600E, "atrium_crows" },
    { 0xAF1D8C4E, "atrium_door" },
    { 0xA9CC6572, "atrium_mger_done" },
    { 0xA43CFE26, "atrium_mgspawner" },
    { 0x05C0D409, "atrium_nodes" },
    { 0x8B3EEDE2, "atrium_path_start" },
    { 0x9ADF3E26, "atrocities" },
    { 0x29409976, "atrucks" },
    { 0x7974A81E, "att" },
    { 0xF1B80746, "att_id" },
    { 0x8FF2374E, "attach" },
    { 0x645E2F1A, "attach_all_origin_to_boat" },
    { 0x2CA9737F, "attach_ammo" },
    { 0x8294EF82, "attach_angle" },
    { 0x33C6D5B2, "attach_arrival_ropes" },
    { 0xCA1ABCDD, "attach_banned" },
    { 0xD6CCB057, "attach_boat_destructibles" },
    { 0xCB9F7D3A, "attach_boat_equipment" },
    { 0x0A5DBEA4, "attach_bombs" },
    { 0x63E72E37, "attach_briefcase" },
    { 0x090ABCA0, "attach_c4" },
    { 0xEB556C20, "attach_cig" },
    { 0xF693D31D, "attach_cig_self" },
    { 0xE7DAFA3C, "attach_compatibility_init" },
    { 0xE786DA73, "attach_compatible" },
    { 0xFCC522AB, "attach_data_glove" },
    { 0xB3B9502F, "attach_data_glove_texture" },
    { 0xF351B3BE, "attach_data_pads" },
    { 0xD2109B2B, "attach_device_to_player" },
    { 0x7CD4CECF, "attach_driver" },
    { 0x5F552D6B, "attach_flashlight" },
    { 0x25F3BE5E, "attach_forced" },
    { 0xBE46C008, "attach_hat" },
    { 0x608EA21C, "attach_headlights" },
    { 0xB512A6A8, "attach_headlights_to_struct" },
    { 0x23677A16, "attach_masons_hat" },
    { 0x60BE6ABA, "attach_menendez_phone" },
    { 0xFE22F274, "attach_model" },
    { 0xEC190EEB, "attach_model_override" },
    { 0x5732C267, "attach_models" },
    { 0x34613C6D, "attach_molotov" },
    { 0xEDB2B6B4, "attach_name" },
    { 0xB1FC2F0D, "attach_node" },
    { 0xECEAEAA7, "attach_phone" },
    { 0x5CCDB4B8, "attach_player_clip_to_pbr" },
    { 0x9D0C5335, "attach_point" },
    { 0x69290750, "attach_rope_during_dropoff" },
    { 0x803D36E9, "attach_shell" },
    { 0x455A504B, "attach_snowcat_props" },
    { 0xEB0B2C10, "attach_steering_wheel" },
    { 0x52428981, "attach_table_col_compatible" },
    { 0xDCFBDECA, "attach_table_col_name" },
    { 0xEF9DF880, "attach_table_col_numbering" },
    { 0x43566926, "attach_table_col_weaponname" },
    { 0xC5687BCF, "attach_tag" },
    { 0x34643319, "attach_tank" },
    { 0x011E5FCD, "attach_to_bus" },
    { 0xD555ED25, "attach_to_heli" },
    { 0x869C3B51, "attach_torch" },
    { 0xAE24C5AB, "attach_torch_to_character" },
    { 0xFFB952AF, "attach_trigger_gaz_victim" },
    { 0xAEF1CDE2, "attach_truck_bed" },
    { 0x277C8E11, "attach_truck_bed_low" },
    { 0xA4DE146A, "attach_update" },
    { 0xD7D6EFAD, "attach_weapon" },
    { 0x19C45CC1, "attach_weapon_during_lvt_ride" },
    { 0x1D53A214, "attachbone" },
    { 0x3B8BC291, "attached" },
    { 0x14726A6D, "attached_entities" },
    { 0x95B46BEC, "attached_guys" },
    { 0xDFDA706B, "attached_model" },
    { 0xB6087788, "attached_model_anims" },
    { 0x95B9CC4A, "attached_models" },
    { 0x7392217D, "attached_to_backup_path_but_not_moving" },
    { 0x16903A25, "attachedguys" },
    { 0xB13031C5, "attachedmodelcount" },
    { 0x9C7D5D33, "attachedmodels" },
    { 0xE0408B14, "attachedpath" },
    { 0x69156B8E, "attachedplayer" },
    { 0xA276831A, "attachedtags" },
    { 0xE9A51466, "attachedtiremodel" },
    { 0x1641FD25, "attachedusemodel" },
    { 0x0EF011EF, "attachement" },
    { 0xF9165C36, "attachements" },
    { 0xC5F62A6E, "attachemnt" },
    { 0x4C2E0C75, "attachent" },
    { 0x59BFCD2E, "attaches" },
    { 0xAA4C2FEC, "attachflag" },
    { 0x8C2C31EC, "attachflamethrowertank" },
    { 0xD52CF8E5, "attachfromarray" },
    { 0xBDAA8C77, "attachgrenademodel" },
    { 0xCBE1EC66, "attachinfo" },
    { 0x1DBA2CF2, "attaching" },
    { 0x503CC25C, "attachkillcamtorocket" },
    { 0xF7A69BF1, "attachmends" },
    { 0xB000B0BE, "attachment" },
    { 0x158FA933, "attachment1" },
    { 0xA38839F8, "attachment2" },
    { 0xC98AB461, "attachment3" },
    { 0xE2AAC279, "attachment_abbreviation" },
    { 0x57E9502F, "attachment_action" },
    { 0x2439964C, "attachment_array_string" },
    { 0xCF577C59, "attachment_categories" },
    { 0x3575C92C, "attachment_compatibility_init" },
    { 0xA5FDBDE2, "attachment_cost" },
    { 0x539AFC18, "attachment_count_for_loaded_weapon_kill" },
    { 0xAC376924, "attachment_indices" },
    { 0x8DDCB857, "attachment_names" },
    { 0xCC3928B7, "attachment_num" },
    { 0x1E1994AE, "attachment_string" },
    { 0x09CCE873, "attachment_table" },
    { 0x0837E050, "attachment_table_col_bot_prob" },
    { 0x09BB822C, "attachment_table_col_group" },
    { 0x6B82445A, "attachment_table_col_name" },
    { 0x36E06670, "attachment_table_col_numbering" },
    { 0x0B7B3F4F, "attachment_table_col_type" },
    { 0xFCE41C86, "attachment_table_num_rows" },
    { 0xF4EABD6F, "attachment_tokens" },
    { 0xF287C451, "attachmentarray" },
    { 0xD711534B, "attachmentbottom" },
    { 0x1F3791D3, "attachmentcount" },
    { 0xE476B301, "attachmentexclusions" },
    { 0x5E3ECD9A, "attachmentindex" },
    { 0x8A61C0EC, "attachmentindex2" },
    { 0x9853D5DD, "attachmentindices" },
    { 0x6E165ED6, "attachmentinfo" },
    { 0xE8E23195, "attachmentkills" },
    { 0xBDA57B56, "attachmentkillsthisspawn" },
    { 0x355ACF32, "attachmentlist" },
    { 0xD42E114D, "attachmentmuzzle" },
    { 0x25D1D903, "attachmentname" },
    { 0x91E42672, "attachmentnames" },
    { 0x26E2FB26, "attachmentnum" },
    { 0x4A294EA1, "attachments" },
    { 0x67F17324, "attachments_num" },
    { 0xB65167F1, "attachmentsdisabled" },
    { 0x8F4B8159, "attachmentstring" },
    { 0x3CD0C1BA, "attachmenttable" },
    { 0xB1ACBF50, "attachmenttablelookup" },
    { 0x366B0AB7, "attachmenttop" },
    { 0x4F403D1E, "attachmenttrigger" },
    { 0x61813F1A, "attachmentvariantstring" },
    { 0xB0BD0C3E, "attachmentweapon" },
    { 0xDD5BC23D, "attachmissiles" },
    { 0xF0C56089, "attachmortar" },
    { 0x034404D3, "attachname" },
    { 0x5C0457E0, "attachorg" },
    { 0x5C586B0B, "attachpath" },
    { 0x4AA4D1A9, "attachplayer" },
    { 0xDAD02080, "attachplayertobus" },
    { 0xB404EF44, "attachpoint" },
    { 0x85104230, "attachpos" },
    { 0x3E9A625E, "attachreconmodel" },
    { 0xA47D30CB, "attachriotshield" },
    { 0x22723BF1, "attachs" },
    { 0x1B6A8799, "attachscriptorigin" },
    { 0xDDAE69EC, "attachshieldmodel" },
    { 0x7C077A3B, "attachside" },
    { 0x60144A19, "attachsize" },
    { 0xA2CE918E, "attachspot" },
    { 0x1C7259A9, "attachtableid" },
    { 0x4096A646, "attachtag" },
    { 0x1EAB8FB1, "attachtodec20terminal" },
    { 0x1EB44C0F, "attachtotag" },
    { 0x1EC0B805, "attachtotrain" },
    { 0x69BBC5D6, "attachusemodel" },
    { 0x17DE2ACE, "attachweapon" },
    { 0x69EFBCE5, "attack" },
    { 0x58397A47, "attack_anim" },
    { 0xCA72965F, "attack_barge_back_front" },
    { 0xB322252E, "attack_button_held" },
    { 0x6AC220CB, "attack_button_pressed" },
    { 0x88EB8ACE, "attack_button_released" },
    { 0xA5831466, "attack_buttonpressed" },
    { 0xFD639FDB, "attack_cache_btr" },
    { 0x26133931, "attack_cache_tank" },
    { 0x1E53AB62, "attack_circle_range" },
    { 0x70A9A56A, "attack_convoy" },
    { 0x4CC3A2E7, "attack_convoy_leader_ai" },
    { 0xE036E148, "attack_convoy_leader_claw" },
    { 0x1CBC2DD7, "attack_convoy_random_explosions" },
    { 0x7D75F3E5, "attack_delay" },
    { 0xFCEDC2D7, "attack_delay_base" },
    { 0x1BA4D5E1, "attack_delay_offset" },
    { 0x009B8778, "attack_dist" },
    { 0xF6B9CC79, "attack_distance" },
    { 0x5BA5DCAE, "attack_drone" },
    { 0x7A610B48, "attack_drone_activetime" },
    { 0x5D76B67D, "attack_drone_activetime_variety" },
    { 0x23D64020, "attack_drone_attack_distance_attached" },
    { 0xEF51F39A, "attack_drone_fake_dot" },
    { 0x56AD952F, "attack_drone_offsets" },
    { 0x5CD9677E, "attack_dummy_path" },
    { 0x796F3148, "attack_duration" },
    { 0x6E3485DF, "attack_forgetonnotify" },
    { 0x33045AD7, "attack_friendly_spawners" },
    { 0xE72F4B84, "attack_group_think" },
    { 0xFB429E09, "attack_height" },
    { 0xAABEBD00, "attack_heli" },
    { 0x25F42264, "attack_helidummy" },
    { 0x26FBD496, "attack_him" },
    { 0x8EF38075, "attack_item" },
    { 0xDA1541C1, "attack_item_interrupt" },
    { 0xC1E3C560, "attack_item_stop" },
    { 0x5E2157F5, "attack_javelin" },
    { 0x62BE288D, "attack_location" },
    { 0x42FA8354, "attack_minigun_sweep" },
    { 0x673AB4D0, "attack_move_frequency" },
    { 0x3BDCCBBF, "attack_nodes" },
    { 0xE71B799D, "attack_origin_condition_threadd" },
    { 0x6CBF2FAE, "attack_origin_with_targetname" },
    { 0x4F291527, "attack_player" },
    { 0x6B679174, "attack_player_2" },
    { 0x0DF76D0A, "attack_player_after_unload" },
    { 0xE7A54C4C, "attack_player_ai" },
    { 0x08AD944E, "attack_player_dist" },
    { 0x5B444BA0, "attack_player_if_located" },
    { 0xD7FF7BED, "attack_player_spawners" },
    { 0x2DF0BC15, "attack_player_thru_boards_range" },
    { 0x9F0613CC, "attack_player_timout" },
    { 0x70F2F863, "attack_player_when_close" },
    { 0xE1AE22DA, "attack_point" },
    { 0x5808D4D5, "attack_points" },
    { 0x10E4A259, "attack_potus" },
    { 0xEC3C6CA2, "attack_primary" },
    { 0xF036F770, "attack_priority_target" },
    { 0x7EE3D6B2, "attack_priority_until_dead" },
    { 0x30738767, "attack_range" },
    { 0xFBDA5A68, "attack_range_max" },
    { 0x568038F6, "attack_range_min" },
    { 0x4BDB1F7C, "attack_right_range" },
    { 0xB04EE378, "attack_rocket" },
    { 0x6822667E, "attack_secondary" },
    { 0x5699D220, "attack_sequence_finished" },
    { 0xB0E7C303, "attack_shield" },
    { 0x1775F676, "attack_shield_stop" },
    { 0x20339F00, "attack_snipers" },
    { 0xF0053BD7, "attack_special_target" },
    { 0x6909A1A4, "attack_spike_minefield" },
    { 0xFF41BAFB, "attack_spots" },
    { 0x8DB5DB0F, "attack_spots_taken" },
    { 0x2C0FECBC, "attack_start" },
    { 0xE5E0AC93, "attack_struct" },
    { 0xE92ABF03, "attack_target" },
    { 0x16D63872, "attack_targets" },
    { 0x040E2C23, "attack_the_mortars_reminder" },
    { 0x0A189FB0, "attack_this_group" },
    { 0xDBCEB747, "attack_this_tank" },
    { 0xA7242558, "attack_thread" },
    { 0x57C5370F, "attack_thread_gun" },
    { 0x3A94FDA4, "attack_thread_machinegun" },
    { 0xE2183396, "attack_thread_mainturret" },
    { 0x76333D5F, "attack_thread_rocket" },
    { 0x74D793F3, "attack_time" },
    { 0x459D7B84, "attack_trigger_wait" },
    { 0xB86907E3, "attack_troops" },
    { 0x5000CF0F, "attack_vox" },
    { 0x282951A9, "attack_vox_network_choke" },
    { 0x4B533FBD, "attack_wave_screen_shake" },
    { 0x2E689E59, "attackable" },
    { 0xA22CB8ED, "attackable_callback" },
    { 0x0F81EBE9, "attackable_damaged" },
    { 0x9EC5063E, "attackable_deactivated" },
    { 0xFAADFA92, "attackable_goal_radius" },
    { 0xBDE85418, "attackable_slot" },
    { 0x7B18F4F4, "attackablecallback" },
    { 0x14E39610, "attackables" },
    { 0x005BC3EA, "attackangle" },
    { 0xD1832A7A, "attackanim" },
    { 0x45ACCBD9, "attackanimstate" },
    { 0x72CA4261, "attackbehind" },
    { 0x91E6054C, "attackble" },
    { 0xF4E773D6, "attackbutton_hold_think" },
    { 0xBE4A4B0D, "attackbuttonpressed" },
    { 0x7A726D92, "attackdir" },
    { 0xA3700F4E, "attackdirx" },
    { 0xC97289B7, "attackdiry" },
    { 0xF480B3D2, "attacked" },
    { 0x57A4AFA9, "attacked_by_dog" },
    { 0x6DB4B9B7, "attackedbanzai" },
    { 0x16F8A6F7, "attackedbyasd" },
    { 0xC36FECD6, "attackedbyhumanai" },
    { 0x64196E51, "attackedbyotherbigdog" },
    { 0x80A4930A, "attackedbyplayer" },
    { 0x81C1FD9E, "attackedbyplayerusingbigdogvehicle" },
    { 0xFB010E4A, "attackedrecently" },
    { 0xB35DAFF4, "attackenemywhenflashed" },
    { 0xA0AD4F34, "attacker" },
    { 0x2A5F3595, "attacker1" },
    { 0x5061AFFE, "attacker2" },
    { 0xAE6A9710, "attacker_archetype" },
    { 0xB1BF67C1, "attacker_defender_kills_index" },
    { 0x491563EC, "attacker_dot" },
    { 0xF4B4B342, "attacker_doublejump_begin" },
    { 0x3E129F16, "attacker_doublejump_end" },
    { 0xCE77FB52, "attacker_entnum" },
    { 0xA36EEA9E, "attacker_is_on_my_team" },
    { 0x956876B1, "attacker_is_player" },
    { 0xECEAEE76, "attacker_is_thief" },
    { 0x0DA254AD, "attacker_isonmyteam" },
    { 0xD23CF74D, "attacker_jump_begin" },
    { 0xC1D34935, "attacker_jump_end" },
    { 0x5D3276FF, "attacker_list" },
    { 0x60258EAC, "attacker_player" },
    { 0x669A2894, "attacker_seat" },
    { 0xCE146F10, "attacker_slide_begin" },
    { 0x07A885B4, "attacker_slide_end" },
    { 0x63B8B085, "attacker_sprint_begin" },
    { 0xED0531BD, "attacker_sprint_end" },
    { 0x64781A9E, "attacker_swimming_begin" },
    { 0x894B0192, "attacker_swimming_end" },
    { 0xA827243F, "attacker_troop_is_on_my_team" },
    { 0x815C196A, "attacker_troop_isonmyteam" },
    { 0xBE94A58E, "attacker_variant" },
    { 0xB041219E, "attacker_wallrantwooppositewallsnoground" },
    { 0x519C883C, "attacker_wallrun_begin" },
    { 0x80924500, "attacker_wallrun_end" },
    { 0xF7F92F13, "attacker_was_drowning" },
    { 0xA1829D49, "attacker_wave01" },
    { 0xFDE7F239, "attacker_wave01b" },
    { 0xC78517B2, "attacker_wave02" },
    { 0xED87921B, "attacker_wave03" },
    { 0x138A0C84, "attacker_wave04" },
    { 0x2A48F7AB, "attackeraccuracy" },
    { 0xCF695128, "attackeralternatefrontanim" },
    { 0xEF86C576, "attackerammo" },
    { 0x4E78F4C3, "attackeranim" },
    { 0xA27B3C91, "attackerarchetype" },
    { 0x4DCAAACA, "attackerbackanim" },
    { 0x0B1F562C, "attackerclass" },
    { 0x599FBFE2, "attackerclientid" },
    { 0x928C5739, "attackercount" },
    { 0x002A6EC9, "attackercountthreatscale" },
    { 0xCA1AB1E7, "attackerdamage" },
    { 0xF9D53F6C, "attackerdata" },
    { 0x4027DD25, "attackerdistance" },
    { 0x3828B415, "attackerdoublejumping" },
    { 0xDC7E5B14, "attackerflashbacktime" },
    { 0xEC6C5D93, "attackerforward" },
    { 0x43179786, "attackerfrontanim" },
    { 0x28F33AAE, "attackerheroability" },
    { 0xDFB0C984, "attackerheroabilityactive" },
    { 0xEFAFCFFA, "attackerinchopper" },
    { 0xCFFDB920, "attackerinfo" },
    { 0xD4DC2687, "attackerinlaststand" },
    { 0x7CB22418, "attackerinvehiclearchetype" },
    { 0x2A3AE8D1, "attackerishittingself" },
    { 0xD2E71A2F, "attackerishittingteammate" },
    { 0xE7EFBF8B, "attackerisplayer" },
    { 0xA7754C34, "attackerisroulette" },
    { 0xC2F18654, "attackeristhief" },
    { 0x0C3DC647, "attackeristhieforroulette" },
    { 0xCE2FDF61, "attackerkcstarttime" },
    { 0x2600AD5A, "attackerlastfastreloadtime" },
    { 0xC97AEA9E, "attackerlastflashedby" },
    { 0xC329CD56, "attackerlaststunnedby" },
    { 0x020B4E02, "attackerlaststunnedtime" },
    { 0x54CA17D8, "attackerleftanim" },
    { 0x18EA9547, "attackerloseralternatefrontanim" },
    { 0x21505C59, "attackerloserbackanim" },
    { 0xDC32C18F, "attackerloserfrontanim" },
    { 0xC8737307, "attackerloserleftanim" },
    { 0xC56C9A48, "attackerloserrightanim" },
    { 0xEAEE1ACD, "attackermicrowavedvictim" },
    { 0x08A68755, "attackername" },
    { 0x33FBECA8, "attackernode" },
    { 0xCA793E94, "attackernum" },
    { 0x732CBF9A, "attackeronground" },
    { 0xEA783ED2, "attackerorigin" },
    { 0x6CA1A9D2, "attackerright" },
    { 0x2ABC95ED, "attackerrightanim" },
    { 0xF5C59027, "attackers" },
    { 0x7D0A379A, "attackersarray" },
    { 0x889C603D, "attackerscaptureprogresshud" },
    { 0xF0223DB5, "attackersclass" },
    { 0x4F3D523C, "attackershotvictim" },
    { 0x07DCA146, "attackersliding" },
    { 0xB182EB19, "attackerspeedburst" },
    { 0x704CCEDC, "attackersplace" },
    { 0xC1A0028C, "attackerstance" },
    { 0xA915731C, "attackersthisspawn" },
    { 0xB718EFA7, "attackerstring" },
    { 0x8C11E17B, "attackersucceeds" },
    { 0xDEAC3957, "attackerteam" },
    { 0x4EF72A1E, "attackertodefender" },
    { 0x667C8A17, "attackertraversing" },
    { 0x1FC4DFE7, "attackervariant" },
    { 0xC87D6553, "attackervisionpulseactivatetime" },
    { 0x9862E46A, "attackervisionpulsearray" },
    { 0x5DA33615, "attackervisionpulseorigin" },
    { 0x807FDCDC, "attackervisionpulseoriginarray" },
    { 0xE4763E35, "attackerwallrunning" },
    { 0xF22FDE58, "attackerwasconcussed" },
    { 0x5745BA14, "attackerwasflashed" },
    { 0xC58DE723, "attackerwasheatwavestunned" },
    { 0x524537B5, "attackerwasonground" },
    { 0xCE78D937, "attackerwassliding" },
    { 0xA3F33815, "attackerwassprinting" },
    { 0x838E53DC, "attackerwasunderwater" },
    { 0xD3F29427, "attackerweaponpickedup" },
    { 0x48F2646A, "attackgroup" },
    { 0x938BAF5F, "attackgroup_think" },
    { 0xD6CFDBE8, "attackheight" },
    { 0x50DA4743, "attacking" },
    { 0x6A2D277D, "attacking_drone_fire_weapons" },
    { 0x1E6EA595, "attacking_drone_think" },
    { 0xA72C0410, "attacking_enemy_dof" },
    { 0x4803C452, "attacking_new_generator" },
    { 0x2DB87112, "attacking_node" },
    { 0xD2C16839, "attacking_player" },
    { 0xE56A0FA0, "attacking_player_on_turret" },
    { 0x767C8094, "attacking_point" },
    { 0xA0AE6D5E, "attacking_spot" },
    { 0x408F5EA0, "attacking_spot1a" },
    { 0x78FAAEEF, "attacking_spot_index" },
    { 0x60E0200E, "attacking_spot_string" },
    { 0xB7864E5D, "attacking_vietnamese_dof" },
    { 0x03D3BE3D, "attackingenemy" },
    { 0x7A89D872, "attackmessage" },
    { 0xDE4C6A29, "attackmiss" },
    { 0x8F1EEB01, "attackmisstracktargetthread" },
    { 0xEE91AB90, "attacknothingtodo" },
    { 0xA6F29233, "attacknow" },
    { 0x85C7EC39, "attackorderwatcher" },
    { 0x144C7D05, "attackpattern" },
    { 0xD69AD172, "attackplayer" },
    { 0xC2CAC9FD, "attackplayers" },
    { 0x7B8FD265, "attackpos" },
    { 0xDC50D30F, "attackradius" },
    { 0x673E32F4, "attackrange" },
    { 0x30F92FE2, "attackrangebuffer" },
    { 0x57D5E0F4, "attacks" },
    { 0xA96331F4, "attackside" },
    { 0xF79092BA, "attacksound" },
    { 0x58DE3FD1, "attacksound_nexttime" },
    { 0x3B1313F1, "attacksound_waittime" },
    { 0x908FCB08, "attackspecificenemywhenflashed" },
    { 0x99CD1ED6, "attackspeed" },
    { 0x8BE4EF6D, "attackspot" },
    { 0xD36ABCAE, "attackstartvector" },
    { 0x6F84CD6C, "attacksuppressableenemy" },
    { 0x03DEE710, "attackteleportthread" },
    { 0x2D855F09, "attacktimeend" },
    { 0x271EE8A3, "attackvisibleenemy" },
    { 0x17156BE6, "attackyaw" },
    { 0x5A213BBB, "attch" },
    { 0x48BFEA30, "attched" },
    { 0x502876A4, "attckers" },
    { 0xECEF5F40, "attemmpts" },
    { 0x8A45B9F4, "attempt" },
    { 0xB2295104, "attempt_brutus_spawn" },
    { 0x9639AD97, "attempted" },
    { 0xD89D9AB4, "attempting" },
    { 0x054472F9, "attempting_return" },
    { 0x71F2D0E7, "attempts" },
    { 0xF5F459D9, "attention" },
    { 0x68B62D61, "attention_getter" },
    { 0x09C3D604, "attention_guys" },
    { 0x71F35FB1, "attention_guys_action" },
    { 0xA9EA8835, "attention_guys_scene" },
    { 0x999E8C64, "attenuate" },
    { 0xCBA7E273, "attenuation" },
    { 0x36CF55AA, "attic" },
    { 0x1DEEC4BB, "attitude" },
    { 0x43D86C21, "attitude_shader" },
    { 0x1C54DADB, "attitude_text" },
    { 0x2516A618, "attr" },
    { 0x7B832EEC, "attract" },
    { 0xF336FD6F, "attract_dist" },
    { 0xDCB46B6F, "attract_dist_custom" },
    { 0xD82C00F7, "attract_dist_diff" },
    { 0xD4BB16B6, "attract_dists" },
    { 0x8705772D, "attract_radius" },
    { 0xE25A766A, "attract_range" },
    { 0x8F2BA92C, "attract_strength" },
    { 0xDD53C975, "attract_to_origin" },
    { 0xCA293B4D, "attractchopper" },
    { 0x02425831, "attractchopperdialog" },
    { 0x18C331CF, "attracted" },
    { 0xCDEC2D05, "attracted_array" },
    { 0x4739AC1C, "attracting" },
    { 0x964B8996, "attraction" },
    { 0xE05C62DB, "attractor" },
    { 0x216750E9, "attractor_array" },
    { 0xA5A4394C, "attractor_point" },
    { 0x52E66618, "attractor_pos" },
    { 0x500590F7, "attractor_position" },
    { 0xB6DB3D2E, "attractor_positions" },
    { 0xC242108C, "attractor_positions_generated" },
    { 0x8F77664A, "attractor_width" },
    { 0x0EBA21EA, "attractorent" },
    { 0x8AF5B956, "attractorent_delete_on_vehicle_death" },
    { 0xF81F30E5, "attractorent_link" },
    { 0xBF203B94, "attractorrpg" },
    { 0x133859FA, "attractors" },
    { 0x8475AC13, "attractors_generated_listener" },
    { 0xECC40BEF, "attracts" },
    { 0x30203D39, "attrib" },
    { 0xAD64145D, "attrib_name" },
    { 0x8381033F, "attribute" },
    { 0x6B5D7FA9, "attributed" },
    { 0xCF33FB32, "attributename" },
    { 0x89918A46, "attributes" },
    { 0xD41C5B8F, "attributes_func" },
    { 0x552661A7, "attributes_set" },
    { 0x15BFF19E, "attributevalue" },
    { 0x9F772287, "atu" },
    { 0x1902E402, "atwindow" },
    { 0xA0620A86, "atypical" },
    { 0x84C2DCC5, "aud_occ" },
    { 0x996F254D, "audible" },
    { 0x125F49DF, "audience" },
    { 0x4FE3EEF1, "audio" },
    { 0x0722BBF0, "audio_activated_trigger" },
    { 0xC0166FFB, "audio_additional" },
    { 0x5D71EFD7, "audio_alias_override" },
    { 0xEBBBBD2D, "audio_barrel_impact" },
    { 0x99246394, "audio_begin_director_vox" },
    { 0x66A66EFD, "audio_clientnotify_cheer1" },
    { 0x8CA8E966, "audio_clientnotify_cheer2" },
    { 0xB2AB63CF, "audio_clientnotify_cheer3" },
    { 0xA89A0AF0, "audio_clientnotify_cheer4" },
    { 0xD59A5D81, "audio_crowd_vox_1" },
    { 0xFB9CD7EA, "audio_crowd_vox_2" },
    { 0xBD80EF26, "audio_crush_loop" },
    { 0xA644B720, "audio_crush_trigger" },
    { 0x6F23B5BF, "audio_current_character" },
    { 0x15EB593D, "audio_door_finished" },
    { 0x00DBFCF3, "audio_drowning_counter" },
    { 0x2B07512D, "audio_drowning_loopers" },
    { 0xC3687984, "audio_drowning_vox" },
    { 0x37EA1E58, "audio_engine_off" },
    { 0xF65C8C92, "audio_engine_on" },
    { 0x0E9BC833, "audio_ent" },
    { 0x21EA927F, "audio_ent_delete" },
    { 0xAF9701BD, "audio_ent_fakelink" },
    { 0xA6B4DD51, "audio_ent_fakelink_delete" },
    { 0xAABE3965, "audio_ent_loopsound" },
    { 0x94765834, "audio_event1_cleanup" },
    { 0x4520B353, "audio_event1_door_open" },
    { 0xA8A97FEE, "audio_fade" },
    { 0xCDD49D24, "audio_get_mod_type" },
    { 0x76D45698, "audio_gun_ent" },
    { 0xFD6090A8, "audio_idle_ent" },
    { 0x2ACF810F, "audio_incomming_played" },
    { 0xC201518A, "audio_init" },
    { 0x3BA48BAA, "audio_intro" },
    { 0x76AC503C, "audio_is_targeting" },
    { 0x3BE80615, "audio_last_d" },
    { 0x3C373E1C, "audio_light_buzz" },
    { 0xB04D6255, "audio_loader" },
    { 0x25FF6B15, "audio_logs" },
    { 0x1ECEBB6C, "audio_loop_ent" },
    { 0x2FB91184, "audio_mask" },
    { 0x665F55F2, "audio_material_trigger" },
    { 0x8E1754D0, "audio_node_left" },
    { 0xBD8154FE, "audio_node_nose" },
    { 0xA5CE4503, "audio_node_nose3p" },
    { 0x78F33EF1, "audio_node_prop1" },
    { 0x9A6FE734, "audio_node_propl" },
    { 0x6BFDAD6F, "audio_node_propl_ramp" },
    { 0x1E571F1A, "audio_node_propr" },
    { 0x6A55DC99, "audio_node_propr_ramp" },
    { 0x121A116E, "audio_node_propzero" },
    { 0xE1F262B8, "audio_node_propzerob" },
    { 0x031368FF, "audio_node_right" },
    { 0x6182E58B, "audio_node_ventral" },
    { 0x5860EA47, "audio_one_down" },
    { 0xF2B1CC72, "audio_origin" },
    { 0xE7B15107, "audio_plane_kill_prop" },
    { 0x12A88BA6, "audio_plane_landing" },
    { 0xB2531DCD, "audio_plane_starting" },
    { 0x5EA00BE1, "audio_plane_stop" },
    { 0x18DF0C79, "audio_play_closer_roars" },
    { 0xBC773434, "audio_play_debris" },
    { 0xF36B21AB, "audio_play_distant_roar" },
    { 0x66428464, "audio_play_wind_howling" },
    { 0x252FB514, "audio_player_breathing" },
    { 0xF163657A, "audio_player_breathing_end" },
    { 0x188DD378, "audio_player_connect" },
    { 0xF01A42E4, "audio_player_origin" },
    { 0x85BB1056, "audio_point" },
    { 0x963E7DC9, "audio_points" },
    { 0x82C597F5, "audio_random_redshirt_vox" },
    { 0x0FEE2212, "audio_roof_fall" },
    { 0xFBA708A8, "audio_roof_ground" },
    { 0xDC750DAB, "audio_shared" },
    { 0x76DCD968, "audio_skit_listener" },
    { 0x5CE60287, "audio_snapshot_override" },
    { 0x57947306, "audio_start_idle_loop" },
    { 0x16B4BF17, "audio_step_trigger" },
    { 0x2A1F9FD5, "audio_stop_alarms" },
    { 0xDCD1E082, "audio_stop_idle_loop" },
    { 0x772D3FE7, "audio_stop_single_gust" },
    { 0x3BF24E19, "audio_stylized_start" },
    { 0x9BCF8236, "audio_swimming_counter" },
    { 0xBDFDE3C9, "audio_tank1_impact_ground1" },
    { 0xE4005E32, "audio_tank1_impact_ground2" },
    { 0x2E1CEA01, "audio_tank1_impact_wall" },
    { 0x8B2E19D0, "audio_tank2_impact_ground1" },
    { 0xFD35890B, "audio_tank2_impact_ground2" },
    { 0xD7330EA2, "audio_tank2_impact_ground3" },
    { 0x159869DA, "audio_tank2_impact_wall" },
    { 0xC6EFDFD3, "audio_test_laufer_amb" },
    { 0xC7A3594D, "audio_test_tuey_amb" },
    { 0x04FC05FF, "audio_trgger_damage" },
    { 0x582B1EF5, "audio_trigger_start" },
    { 0xD1C78C54, "audio_tuco_begins" },
    { 0x6E73AE8B, "audio_turn_off_wind_loopers" },
    { 0x5BE6D71C, "audio_type" },
    { 0x002D6BA5, "audio_vc_alerted" },
    { 0x8EA500A5, "audio_wall_impact" },
    { 0x90E037DA, "audio_water_impact" },
    { 0x778C3308, "audio_zones_breached" },
    { 0x952B61C0, "audiocutsound" },
    { 0x36BD053E, "audiomaterialoverride" },
    { 0x74F3FDCD, "audiosharedswimming" },
    { 0xE0BD04C9, "audiosharedunderwater" },
    { 0x8DD30EDA, "aug" },
    { 0x0C286F5A, "augment" },
    { 0xBCE42CC2, "august" },
    { 0xB848589E, "aunloadedai" },
    { 0x569EA386, "auomatically" },
    { 0x21625EA0, "ausetrigs" },
    { 0xC85ADB0F, "austin" },
    { 0x65A71860, "author" },
    { 0x8422A6F3, "authored" },
    { 0x389A2F54, "authority" },
    { 0xE2B39128, "authorization" },
    { 0x5F931050, "authorization_operation_said_timer" },
    { 0x2FF27796, "authorize" },
    { 0xE86CDDA6, "authorized" },
    { 0x03A17114, "auto" },
    { 0x514F2375, "auto1" },
    { 0x2AC2D116, "auto367" },
    { 0x72193C69, "auto_adjust_difficulty_frac" },
    { 0x66A3C11F, "auto_adjust_difficulty_player_movement_check" },
    { 0x269C5409, "auto_adjust_difficulty_player_positioner" },
    { 0x039C5EDD, "auto_adjust_difficulty_track_player_death" },
    { 0x33A50FE8, "auto_adjust_difficulty_track_player_shots" },
    { 0x61612B38, "auto_adjust_enemy_death_detection" },
    { 0x4231785C, "auto_adjust_enemy_died" },
    { 0xD50BF4F2, "auto_adjust_flags" },
    { 0x6EBEF462, "auto_adjust_new_zone" },
    { 0x5E18048D, "auto_adjust_results" },
    { 0xF5410582, "auto_adjust_threatbias" },
    { 0xCB8550C1, "auto_adust_zone_complete" },
    { 0xF9482309, "auto_ai" },
    { 0x97EC61D8, "auto_ai_cleanup" },
    { 0xD6BC824E, "auto_aim" },
    { 0x120086AA, "auto_center_camera" },
    { 0xF6E4F19A, "auto_delete" },
    { 0x3C07F8E7, "auto_delete_anim_func" },
    { 0x907E6C86, "auto_delete_delay" },
    { 0xBD791209, "auto_delete_distsq" },
    { 0x35E586E3, "auto_delete_with_ref" },
    { 0xD6F8B1AB, "auto_deleting" },
    { 0x88075CD7, "auto_kill" },
    { 0x89EDA4BC, "auto_kill_ai" },
    { 0xB1D2DC33, "auto_kill_position" },
    { 0x160807C3, "auto_mg42_target" },
    { 0xEB63F849, "auto_mgturret" },
    { 0xC4E05E77, "auto_mgturret_target" },
    { 0xDAEDA115, "auto_mgturretlink" },
    { 0xADB1ED58, "auto_mutex_triggers" },
    { 0x33E3CEC4, "auto_objective" },
    { 0xE8EACF1F, "auto_objective_multiple" },
    { 0xA0B2D027, "auto_objective_single" },
    { 0xBBCD9CBF, "auto_open" },
    { 0x857AD6E5, "auto_order_bg" },
    { 0xCBB9EC90, "auto_order_bg_x" },
    { 0xF1BC66F9, "auto_order_bg_y" },
    { 0x91F13E41, "auto_order_text" },
    { 0xD397BC5C, "auto_revive" },
    { 0x5CF8632C, "auto_save_print" },
    { 0x7218BCE5, "auto_save_think" },
    { 0x74A5B32D, "auto_trigger" },
    { 0xF33A2CA9, "auto_turn_off_trigger" },
    { 0x7BCFF1B1, "auto_turret" },
    { 0x7B9AEA27, "auto_turret_activate" },
    { 0xC261C043, "auto_turret_array" },
    { 0x64C3A5B3, "auto_turret_cost" },
    { 0xEA0DBE46, "auto_turret_deactivate" },
    { 0x59AE99E1, "auto_turret_influencer_close_radius" },
    { 0xF5CC84D7, "auto_turret_influencer_close_score" },
    { 0x5E814FBB, "auto_turret_influencer_close_score_curve" },
    { 0x8E30E916, "auto_turret_influencer_radius" },
    { 0x302F00E2, "auto_turret_influencer_score" },
    { 0xF20B333E, "auto_turret_influencer_score_curve" },
    { 0x69BCDBDA, "auto_turret_parts" },
    { 0x4D4A37B3, "auto_turret_settings" },
    { 0x88738224, "auto_turret_think" },
    { 0xB3E61155, "auto_turret_timeout" },
    { 0x2EB14263, "auto_turret_update_timeout" },
    { 0xBC07B322, "autoadjust_playerspots" },
    { 0xEB9C295F, "autoaim" },
    { 0xD3D54A87, "autoassign" },
    { 0x10F00DA4, "autocraft_staffs" },
    { 0x0946958F, "autoexec" },
    { 0x2FE62B56, "autoexecs" },
    { 0x9E8DCCBE, "autofill_wallbuys_init" },
    { 0xC2DF6E10, "autofire" },
    { 0xFE1A7943, "autofireface" },
    { 0x8A2F93C7, "autogenerated" },
    { 0x376974D8, "autokill_glaive_active" },
    { 0x359C65C3, "automagically" },
    { 0x5B50A5AB, "automate" },
    { 0x43EC9D35, "automated" },
    { 0x42D9C6BE, "automatic" },
    { 0x40E9A12D, "automatic_contextual_melee" },
    { 0xCB2D4428, "automatically" },
    { 0xC74A0D63, "automaticly" },
    { 0xC545DA0E, "automating" },
    { 0xBF603A1D, "automaton" },
    { 0x740A5D7F, "automaton_attack_choke_timer" },
    { 0x5B04C1BA, "automaton_attack_reset_timer" },
    { 0xDC43C39A, "automaton_threshold_reached" },
    { 0xF3CA0B12, "automatonanimationsspeaking" },
    { 0x6B339E73, "automatondamagecallback" },
    { 0x24B3F461, "automatonemp" },
    { 0x2C663990, "automatonsetup" },
    { 0x1791C67D, "automatonspeak" },
    { 0xC059F8AA, "autoreactivaterapskillstreak" },
    { 0x462338E8, "autorecover" },
    { 0x3A80C673, "autoreload" },
    { 0x370BEC46, "autoresettime" },
    { 0xCB6BC91B, "autosave" },
    { 0xA0690E75, "autosave_after_balcony" },
    { 0xBC0510D8, "autosave_after_delay" },
    { 0xD2431929, "autosave_ammo_check" },
    { 0x78F215F5, "autosave_by_name" },
    { 0x558B9F68, "autosave_by_name_thread" },
    { 0xE6347F21, "autosave_by_name_wraper" },
    { 0xC75B8456, "autosave_check" },
    { 0x5FA98789, "autosave_check_not_picky" },
    { 0xA1F06B97, "autosave_check_simple" },
    { 0x3895DEDB, "autosave_complete" },
    { 0x18DC7BAC, "autosave_description" },
    { 0x51307CDD, "autosave_game_now" },
    { 0x9B08F025, "autosave_health_check" },
    { 0x5C946487, "autosave_light_check" },
    { 0x2EE6870A, "autosave_name_think" },
    { 0x63E5DF5A, "autosave_names" },
    { 0x8E195D51, "autosave_near_stairs" },
    { 0x5F8606C6, "autosave_now" },
    { 0xAE352201, "autosave_now_loc" },
    { 0xA90D16AB, "autosave_now_trigger" },
    { 0xB856B03A, "autosave_on_good_claymore_placement" },
    { 0xCA4858F9, "autosave_or_timeout" },
    { 0xD5E3045C, "autosave_player_check" },
    { 0x62AAB12A, "autosave_think" },
    { 0xBA2A66A7, "autosave_threat_check" },
    { 0xAADC1BDF, "autosave_timeout" },
    { 0xD2A26F86, "autosave_when_trigger_cleared" },
    { 0x453AF257, "autosaveammocheck" },
    { 0x7C72C351, "autosavecheck" },
    { 0x2FA0B78E, "autosavecheck_not_picky" },
    { 0x2D683205, "autosaved" },
    { 0x7F2FDF99, "autosavefriendlycountcheck" },
    { 0xD057A5D7, "autosavehealthcheck" },
    { 0xB4876DAA, "autosavenamethink" },
    { 0x57899984, "autosaveplayercheck" },
    { 0xED92003C, "autosaveprint" },
    { 0x5B391C3A, "autosaves" },
    { 0x57BBA24B, "autosaves_return_trip" },
    { 0x280E2A1F, "autosaves_safety" },
    { 0x51BE08AF, "autosaves_think" },
    { 0x6012767D, "autosavethreatcheck" },
    { 0x0984687E, "autosaving" },
    { 0x183D690A, "autosetvisibletoall" },
    { 0xAC5B8F30, "autoshootanimrate" },
    { 0xC0362FF9, "autoshootanims" },
    { 0xF7787B49, "autospawn" },
    { 0xDF71494E, "autospot_is_close_to_player" },
    { 0xC1827191, "autostopsound" },
    { 0xC737ECDF, "autotarget" },
    { 0x205BF80B, "autotimercountdowninternal" },
    { 0x31ADA252, "autoturret" },
    { 0x1F47D6A1, "autoturretcloseanim" },
    { 0x9CBCEA6D, "autoturretopenanim" },
    { 0x2FEE515D, "aux" },
    { 0xC70FF803, "aux_ai_initializer" },
    { 0x688F2D0C, "aux_melee_damage" },
    { 0x10D1F7D8, "auxilary_weapon_pos" },
    { 0x1870A95F, "auxiliary" },
    { 0x8E8C491C, "av" },
    { 0x3C5DA8FB, "av7" },
    { 0xFEA632CF, "av7_01" },
    { 0xB12619F6, "av7_01_render" },
    { 0x8C9EC394, "av7_02" },
    { 0x09D029F3, "av7_02_render" },
    { 0xB2A13DFD, "av7_03" },
    { 0xAFC2B800, "av7_03_render" },
    { 0x4099CEC2, "av7_04" },
    { 0xBE48E9ED, "av7_04_render" },
    { 0x669C492B, "av7_05" },
    { 0x637B9D52, "av7_05_render" },
    { 0xF494D9F0, "av7_06" },
    { 0x1F427DEF, "av7_06_render" },
    { 0x1742DF51, "av7_attach" },
    { 0x68C7241B, "av7bosworth_01" },
    { 0xB9E4BAC2, "av7bosworth_01_render" },
    { 0xA52B5CF9, "av7briggs_01" },
    { 0x509F4A9C, "av7briggs_01_render" },
    { 0xCFD2F3A8, "av7chloe_01" },
    { 0x5069B817, "av7chloe_01_render" },
    { 0x09752455, "av7harper_01" },
    { 0x26B841A8, "av7harper_01_render" },
    { 0xBD1342C3, "av7mason_01" },
    { 0x2E8624FA, "av7mason_01_render" },
    { 0x38925A6E, "av7section_01" },
    { 0x858860E9, "av7section_01_render" },
    { 0xC2F68E4C, "ava_wall" },
    { 0x6DF7BD89, "ava_wall_start" },
    { 0xFA672AAE, "avail" },
    { 0x09330EA3, "avail_paths" },
    { 0x8C7483DC, "avail_pickups" },
    { 0x52D85AB0, "availability" },
    { 0x1EA1B9BA, "available" },
    { 0x1FABFF30, "available_compatible_attachments" },
    { 0x2B846541, "available_list" },
    { 0xF9CE43AB, "available_offsets" },
    { 0xB09A9BB0, "available_pkgs" },
    { 0x6111F92A, "available_ragdoll" },
    { 0xC24F702C, "available_wave_types" },
    { 0xE122BD42, "availabledistsq" },
    { 0x2611CBDA, "availablepositions" },
    { 0xAC1C039C, "availalble" },
    { 0x3DE1534B, "availenemylocs" },
    { 0x8CF9CF7B, "availiable" },
    { 0x6243DA52, "availible" },
    { 0x733FC7FD, "availtransport" },
    { 0x90619163, "avalanch" },
    { 0xFD37DF72, "avalanch_snapshot" },
    { 0x4A57DB13, "avalanch_sound" },
    { 0xDDB166B4, "avalanche" },
    { 0x22B92755, "avalanche_brush" },
    { 0x659B4052, "avalanche_close_vnode" },
    { 0x0D6928A0, "avalanche_moving_node" },
    { 0x985D00F3, "avalanche_path_accelerate_0" },
    { 0x725A868A, "avalanche_path_accelerate_1" },
    { 0xB47F7C77, "avalanche_path_start" },
    { 0x1F4BBD80, "avalanche_path_truck_overtaken" },
    { 0x62D7B627, "avalanche_play_building_exploders" },
    { 0xFDAFF1EE, "avalanche_shake_controller" },
    { 0x809285FD, "avalanche_spline_start" },
    { 0x5F936C39, "avalanche_squad_nodes" },
    { 0xADBDD8EC, "avalanche_truck" },
    { 0x7FA4F7A1, "avalanche_vehicle" },
    { 0x7A100305, "avalanche_wall_clean" },
    { 0x6EA0B69B, "avalanche_wall_fxanim" },
    { 0x1C16A221, "avalidsnipertargets" },
    { 0x71369D5C, "avangles" },
    { 0x3631C2B0, "avehicle_array" },
    { 0x9EB9C829, "avehiclenodes" },
    { 0x5BA75DD5, "avehicles_bmp_targetnames" },
    { 0xC1306E47, "avel" },
    { 0x81758DFD, "avenge" },
    { 0x9D808425, "avenger" },
    { 0xAB6671E5, "avenger_count" },
    { 0xC0B69C1B, "aventnodes01" },
    { 0x4EAF2CE0, "aventnodes02" },
    { 0x74B1A749, "aventnodes03" },
    { 0xE0C3EC9B, "avenue" },
    { 0xE0B0C066, "average" },
    { 0xC6AE239B, "average_origin" },
    { 0x84B72A79, "average_pitch" },
    { 0x448FF55E, "average_player_spawn_time" },
    { 0xCBF1DDE5, "average_pos" },
    { 0x63A2B0DC, "average_position" },
    { 0x874B801F, "average_positions" },
    { 0x495B0102, "average_time" },
    { 0x74EB71B2, "averageangles" },
    { 0xAEA8FFCC, "averageorigin" },
    { 0x9614BF99, "averages" },
    { 0x4C459798, "averagevec" },
    { 0x1BE6B54B, "avg" },
    { 0xB6C3798B, "avg_distance" },
    { 0xC9696DED, "avg_fwd" },
    { 0xCD8E4568, "avg_pos" },
    { 0x13CEA8C7, "avg_position" },
    { 0x9B51D63E, "avgdistfromideal" },
    { 0x788FAF8E, "avgkilldistance" },
    { 0xA666B3E6, "avglifetime" },
    { 0x375403C7, "avgpos" },
    { 0x886B5201, "avgrate" },
    { 0x297CA61A, "avgspeedofplayerwhenmoving" },
    { 0x588E7F65, "avgtimebetwenrevivesequnces" },
    { 0xD08FB8CE, "avgusepos" },
    { 0x1E46897A, "avgvelocity" },
    { 0x265550F9, "avgx" },
    { 0x0052D690, "avgy" },
    { 0x672D73E1, "aviary" },
    { 0x28BB2EA4, "aviation" },
    { 0x05CE499C, "aviod" },
    { 0xF9690310, "avogadro" },
    { 0x059F26BE, "avogadro_at_tower" },
    { 0x125E0A2E, "avogadro_bus_watcher" },
    { 0x827F0755, "avogadro_damage_func" },
    { 0xEE66E568, "avogadro_damage_taken" },
    { 0x8373BBB4, "avogadro_debug_axis" },
    { 0xFB3DECD5, "avogadro_defeated" },
    { 0xEA847067, "avogadro_exit" },
    { 0xB4D784AF, "avogadro_far_from_tower" },
    { 0xD54A75FE, "avogadro_is_near_tower" },
    { 0x8AB3C125, "avogadro_locations" },
    { 0xCD0CE16F, "avogadro_melee_time" },
    { 0xC0890CDF, "avogadro_near_tower" },
    { 0x837DDD46, "avogadro_non_attacker" },
    { 0xA6AB60D7, "avogadro_pain" },
    { 0x743D9AB2, "avogadro_pain_watcher" },
    { 0xE19F4330, "avogadro_phase" },
    { 0xAE188C3A, "avogadro_player_damage_callback" },
    { 0xFCBCAAB7, "avogadro_prespawn" },
    { 0x0FF42EB0, "avogadro_print" },
    { 0xDF761468, "avogadro_reveal" },
    { 0x15F0A5D6, "avogadro_show_vox" },
    { 0x92A697D4, "avogadro_spawners" },
    { 0x397FAA43, "avogadro_spawning_logic" },
    { 0xFE8055DB, "avogadro_stab_watch" },
    { 0x10E5A048, "avogadro_stabbed" },
    { 0x8454BE3F, "avogadro_stay_attached" },
    { 0xCE5DE1E8, "avogadro_storm_vox" },
    { 0x1901E972, "avogadro_stunned_vo" },
    { 0xCB624322, "avogadro_teleport" },
    { 0x26CA00B9, "avogadro_think" },
    { 0x5DFB88B1, "avogadro_update_health" },
    { 0x7CA05AE6, "avogadro_update_health_fx" },
    { 0x2E660039, "avogadroreleasefromchamberevent" },
    { 0x19296C3C, "avoid" },
    { 0x8C6D779B, "avoid_2" },
    { 0x2477613F, "avoid_6" },
    { 0x655D7A95, "avoid_actors" },
    { 0xCFDEF6BF, "avoid_combat" },
    { 0x936E8B00, "avoid_dir" },
    { 0x69F58A76, "avoid_drone_fire" },
    { 0x41DA66D2, "avoid_drone_spawn_offsets" },
    { 0x3FD51C30, "avoid_drone_think2" },
    { 0x0DF8FFC6, "avoid_drones" },
    { 0x7340AB12, "avoid_ent" },
    { 0x7A04921D, "avoid_ents" },
    { 0x9EE0CAAD, "avoid_f38_fire" },
    { 0x150898EF, "avoid_f38_think" },
    { 0x4A4CFE9A, "avoid_flames_dialog" },
    { 0x8F6D3C0A, "avoid_gl_message" },
    { 0xE5B3B28F, "avoid_guys" },
    { 0x8B4A5673, "avoid_jeep" },
    { 0xD64B3BD3, "avoid_loc" },
    { 0xA66A5661, "avoid_locations" },
    { 0xF14A0102, "avoid_locs" },
    { 0xBF0BEB3C, "avoid_missiles" },
    { 0x2507FC06, "avoid_missiles_challenge" },
    { 0x7C87F51A, "avoid_missiles_vo" },
    { 0xE25543EA, "avoid_pieces" },
    { 0xED911797, "avoid_point" },
    { 0xE2182DDD, "avoid_radius" },
    { 0xAD490295, "avoid_same_spawn" },
    { 0x1F4588C0, "avoid_shooting_owner" },
    { 0x8539EA2F, "avoid_shooting_owner_ref_tag" },
    { 0x147EBDA5, "avoid_spawn_reuse" },
    { 0xF66D420D, "avoid_synchronization" },
    { 0xAB118DBE, "avoid_visible_enemies" },
    { 0x43744597, "avoid_vtol_death" },
    { 0x5E8EDBA6, "avoid_vtol_piece_think" },
    { 0x518E0FA1, "avoid_vtol_think" },
    { 0x9726B1F1, "avoid_vtol_think2" },
    { 0xAB0B0683, "avoid_vtols" },
    { 0x37027D53, "avoid_vtols_vo" },
    { 0x03ED62C9, "avoid_weapon_damage" },
    { 0x0DFA633D, "avoidance" },
    { 0xCE355621, "avoidcqbpointsofinterests" },
    { 0x41692990, "avoiddangerousspawns" },
    { 0xA5DEA619, "avoide" },
    { 0xC0A73714, "avoidenemies" },
    { 0xB2A828E5, "avoidentities" },
    { 0x60C49A20, "avoidentitiesdistance" },
    { 0x0AF17839, "avoider" },
    { 0xA22E6070, "avoiders" },
    { 0x051AAACA, "avoidflag" },
    { 0x61C2CF0C, "avoiding" },
    { 0x15E1BEBE, "avoidpoint" },
    { 0xC64F8EEC, "avoidradiussqr" },
    { 0x29C5DDFF, "avoids" },
    { 0xA948BAEB, "avoidsamespawn" },
    { 0x5A521D07, "avoidspawnreuse" },
    { 0x0262F74E, "avoidvisibleenemies" },
    { 0xD9F5F53B, "avoidweapondamage" },
    { 0x9673C8AC, "avoidweight" },
    { 0xC3F16267, "avolumes" },
    { 0xB48EC385, "aw" },
    { 0xE1CBDEA2, "aw_shit" },
    { 0xDD93155D, "await" },
    { 0xD3BB654B, "awaiting" },
    { 0xD85E594E, "awake" },
    { 0x860F813B, "awake_axis_quads" },
    { 0x317B1867, "awakens" },
    { 0xDB1685E4, "award" },
    { 0x84C79E8A, "award_blackjack_contract" },
    { 0x65E813FE, "award_challenge" },
    { 0x8020225B, "award_daily_contract" },
    { 0x027979D6, "award_grenades_for_survivors" },
    { 0xB8D8C9BE, "award_grenades_for_team" },
    { 0xD27143CC, "award_loot_xp" },
    { 0x7F3B8F93, "award_loot_xp_due" },
    { 0x9B74431C, "award_melee_weapon" },
    { 0x954597BB, "award_round_end_bonus" },
    { 0x85B07493, "award_type" },
    { 0x0AD00E83, "award_weekly_contract" },
    { 0x03DA5C48, "awardassists" },
    { 0x3F43857B, "awardcapturepoints" },
    { 0x77044290, "awardcapturepointsrunning" },
    { 0x2D5D5147, "awarded" },
    { 0x319549E8, "awarded_cymbal_monkey" },
    { 0x3C220336, "awarded_kill_blindeye_ghost_aircraft" },
    { 0x22BCB206, "awarded_kill_enemy_that_blinded_you" },
    { 0x4EE45B0C, "awardhqpoints" },
    { 0x04891279, "awardhqpointsrunning" },
    { 0xB003B5C4, "awarding" },
    { 0xCBD5605A, "awardlootxp" },
    { 0xDB2DD5C9, "awardlootxptoplayers" },
    { 0x9AE59632, "awardmostpointsmedalgameend" },
    { 0xB6DB40F0, "awardotherlootxp" },
    { 0x0A514BA3, "awardotherlootxpfunctions" },
    { 0xDB91C317, "awards" },
    { 0x07DBDB88, "awardsafezonepoints" },
    { 0x4C95F445, "awardsafezonepointsrunning" },
    { 0x6374DE66, "awardscoreevent" },
    { 0x0119004D, "aware" },
    { 0xCB0C18A8, "awareded" },
    { 0x8363B8E0, "awareness" },
    { 0xE8221ECA, "awareness_array" },
    { 0xC901018C, "awareness_funcs" },
    { 0x811B44B2, "awareness_functions" },
    { 0xB068FA72, "awareness_level_increase" },
    { 0x730C572D, "awarenesslevelcurrent" },
    { 0xB50EDC61, "awarenesslevelprevious" },
    { 0xEB3EAAE3, "away" },
    { 0x483CF17B, "away_from_tv" },
    { 0xEAA8DDB5, "awayalpha" },
    { 0x640C59E0, "awaydir" },
    { 0x3EF7A6F8, "awayfromball" },
    { 0xB5BC0507, "awayfromenterpos" },
    { 0x8FB7A6DC, "awayfromplayer" },
    { 0xB7CA3184, "awereness" },
    { 0x941BB4C2, "awesome" },
    { 0xFD1C6977, "awesomeness" },
    { 0xFB21CB8E, "awful" },
    { 0x9988071D, "awhile" },
    { 0x0CBD0A9E, "awi" },
    { 0x8EDAF5AA, "awkward" },
    { 0x5E195E77, "awning" },
    { 0xB60E11BD, "awning02" },
    { 0x89AAA944, "awning02_start" },
    { 0x04E89682, "awning_ripped" },
    { 0xC3BDEBC3, "awning_tear_start" },
    { 0x586F7B93, "awninganims" },
    { 0xF6EF7D04, "awningwander" },
    { 0x58C1FF70, "aww" },
    { 0x9AABA844, "awwarded" },
    { 0x12FF827F, "awww" },
    { 0x12738102, "ax" },
    { 0x5C1BF40B, "axe" },
    { 0x19372F6F, "axe_blood_splat" },
    { 0x2936304E, "axe_cleanup" },
    { 0x1D7B2AD7, "axe_max_spawned" },
    { 0xE8DD61CD, "axe_model" },
    { 0x12BBE7D6, "axe_scene" },
    { 0x0A01BF6B, "axe_vo" },
    { 0x2439B0F7, "axi" },
    { 0x9681A528, "axial" },
    { 0xC4E99D2E, "axis" },
    { 0xAFEC9063, "axis1" },
    { 0x3DE52128, "axis2" },
    { 0xE11AB7AB, "axis_ai" },
    { 0x9AF43CD4, "axis_array" },
    { 0x6AC6BDC7, "axis_asd" },
    { 0x7D967B54, "axis_captured_flag" },
    { 0x95FCC5B1, "axis_classnames" },
    { 0xCD63FEDC, "axis_claw" },
    { 0x18DEA44B, "axis_cleanup" },
    { 0xE227A2D2, "axis_count" },
    { 0xC6C4A7DB, "axis_died" },
    { 0xD0082B2B, "axis_drone_array" },
    { 0x82BCB911, "axis_drone_spawn" },
    { 0x93BBEF10, "axis_drones" },
    { 0x28A91413, "axis_flag" },
    { 0x5FCDF875, "axis_flood_graveyard" },
    { 0x3D0A51F1, "axis_guys" },
    { 0xA000BAF8, "axis_health_scale" },
    { 0x71B5CA93, "axis_helo" },
    { 0x7DC0745B, "axis_in_building" },
    { 0xD2558D7D, "axis_length" },
    { 0xE6DADB49, "axis_midpoint" },
    { 0x7CB98114, "axis_model" },
    { 0xEF2F14C8, "axis_needs_revive" },
    { 0x4CC3A127, "axis_num" },
    { 0x405F3663, "axis_origin" },
    { 0x140261BD, "axis_origin_struct" },
    { 0xB6C5FB1D, "axis_parent" },
    { 0xBBE0658E, "axis_plane_init" },
    { 0x55623868, "axis_pop_adjust" },
    { 0x6974BE4B, "axis_quads" },
    { 0x29381444, "axis_retreat_from_wasps" },
    { 0x86DD6BAA, "axis_rush_house" },
    { 0x92DDA8B6, "axis_settings" },
    { 0x2C1F6531, "axis_spawned" },
    { 0x3C61E30D, "axis_spawner_array" },
    { 0xDF6D5075, "axis_structs" },
    { 0xBCB5C739, "axis_tank" },
    { 0x506BED71, "axis_tank_fire_loop" },
    { 0x05E9D69A, "axis_team" },
    { 0x31889DE2, "axis_triggers" },
    { 0x25936E4D, "axis_turret_model" },
    { 0xF7773608, "axisaccuracycontrol" },
    { 0xD4EA8BDE, "axisblitzkriegcountdown" },
    { 0x2926F4D2, "axischarset" },
    { 0xA07A1BD1, "axiscost" },
    { 0xCB39E90E, "axises" },
    { 0x55D31C01, "axisflagcount" },
    { 0x2E9B951E, "axisguys" },
    { 0x60CB9E4C, "axisinway" },
    { 0xACDBFB99, "axiskilledbyplayer" },
    { 0x76EE8D84, "axismax" },
    { 0x564186B3, "axismode" },
    { 0xA62376D7, "axisobjective" },
    { 0x6EBD94DB, "axisplanemodel" },
    { 0xA587E080, "axisplayers" },
    { 0x8464F7D0, "axisroundscore" },
    { 0xBAD019E8, "axisroundstartscore" },
    { 0x56BFA3D7, "axisroundswon" },
    { 0x74F93360, "axisscore" },
    { 0x34331DB7, "axisshadesmodel" },
    { 0xE1237A75, "axisteamscore" },
    { 0x3875FB6B, "ay" },
    { 0xCAF099D9, "ayers" },
    { 0xC66E8C30, "az" },
    { 0x1630D089, "az1" },
    { 0x1ADE2915, "az4a" },
    { 0x40E0A37E, "az4b" },
    { 0x9A29E536, "azerbaijan" },
    { 0xFC596ED3, "azerbaijani" },
    { 0x8B4B08F3, "azimuth" },
    { 0x731DCB3C, "azkeys" },
    { 0xEB8879BC, "azone" },
    { 0xD3694F95, "b" },
    { 0x435153DF, "b0" },
    { 0x143C4B37, "b0node" },
    { 0x1D4ED976, "b1" },
    { 0xD63D1B46, "b1_spawners" },
    { 0x7E34E7CB, "b1a" },
    { 0xC7E9FEA4, "b1a_02" },
    { 0xAB7A71C3, "b1a_02_render" },
    { 0xEDEC790D, "b1a_03" },
    { 0x59EB1010, "b1a_03_render" },
    { 0x7AF6790A, "b1node" },
    { 0xF74C5F0D, "b2" },
    { 0xCC24D4E9, "b2_actions_complete" },
    { 0x466DC321, "b2_epilogue_anim_set_1" },
    { 0x6C703D8A, "b2_epilogue_anim_set_2" },
    { 0x9272B7F3, "b2_epilogue_anim_set_3" },
    { 0xB875325C, "b2_epilogue_anim_set_4" },
    { 0xDE77ACC5, "b2_epilogue_anim_set_5" },
    { 0xF4CA3EB7, "b2_falling_guy_hit_water" },
    { 0x410FF2BD, "b2_hut_kills" },
    { 0x42DC656D, "b2_hut_kills_vc_reach" },
    { 0xF3E89D72, "b2_patrol_standing_idle" },
    { 0x528FA58F, "b2_patrol_standing_smoke" },
    { 0x5CB8821B, "b2_redshirt" },
    { 0x2F444AB3, "b2_rice_allow_achievement_late_kill" },
    { 0x93AA98F4, "b2_rice_drop_bowl" },
    { 0x901D896B, "b2_rice_grab_gun" },
    { 0x2F997EA3, "b2_rice_surprise" },
    { 0xE85F6C56, "b2_rushers" },
    { 0x781FD50D, "b2_rushers_2" },
    { 0x4B64E583, "b2_sleeping_vc" },
    { 0x83356BB5, "b2_talking_chef" },
    { 0x51AC436D, "b2_talking_chef_attach_smoke" },
    { 0xB68A3763, "b2_talking_chef_hack" },
    { 0x317BA8F8, "b2_village_animate_patrol_single" },
    { 0xE13851D8, "b2_village_animate_patrols" },
    { 0xBAADB28C, "b2d_02" },
    { 0x0EAE417B, "b2d_02_render" },
    { 0xA1B26AAD, "b2node" },
    { 0xD149E4A4, "b3" },
    { 0x2AD140D8, "b3node" },
    { 0x09997715, "b3r_00" },
    { 0x5E145068, "b3r_00_render" },
    { 0xE396FCAC, "b3r_01" },
    { 0xB55AA05B, "b3r_01_render" },
    { 0xAB476A3B, "b4" },
    { 0xE463F39B, "b4_gate_kick_done" },
    { 0x94D307FB, "b4_peek_vc" },
    { 0x55A10A6F, "b4_player_near_tunnel" },
    { 0xD024F73D, "b4_reznov_blinded" },
    { 0xB57C036E, "b4_reznov_drowns_vc" },
    { 0x8504A4F8, "b4_tunnel_door_kick" },
    { 0xA6878E0F, "b4_tunnel_entrance_anim" },
    { 0x9E588FED, "b4_tunnel_grenade_explode" },
    { 0x938275E3, "b4_tunnel_grenade_spawn" },
    { 0xCFF5D3BF, "b4_tunnel_open" },
    { 0x04AE8D20, "b4_tunnel_player_drop_anim" },
    { 0xCFAADF6E, "b4_tunnel_reznov_drown_splash" },
    { 0xBCA56854, "b4_tunnel_reznov_drown_stab1" },
    { 0x2EACD78F, "b4_tunnel_reznov_drown_stab2" },
    { 0xC8B8D637, "b4_tunnel_reznov_drown_swipe" },
    { 0x7F329968, "b4_tunnel_reznov_drown_wall1" },
    { 0xF13A08A3, "b4_tunnel_reznov_drown_wall2" },
    { 0x84B5CD9B, "b4_tunnel_reznov_landing" },
    { 0x4652D016, "b4_tunnel_room_1_barrier" },
    { 0xB4A5D296, "b4_tunnel_slash_player" },
    { 0x882B8683, "b4_tunnel_splash_left_step" },
    { 0x287F8B42, "b4_tunnel_splash_right_step" },
    { 0x00BDEE61, "b4_use_crouch_death_anim" },
    { 0x2613F7D7, "b4_use_stab_death_anim" },
    { 0x76C0C8F7, "b4_vc_ambush_idle" },
    { 0x23E9ADB0, "b4_vc_ambush_slash" },
    { 0x8544EFD2, "b5" },
    { 0xF158EC34, "b52" },
    { 0x5F427569, "b6" },
    { 0xF620205D, "b_2_f" },
    { 0x5BA6BDEA, "b_2d" },
    { 0x50B052DD, "b_aat_fire_works_weapon" },
    { 0x14E5BFD6, "b_able_to_path" },
    { 0x86068C24, "b_abort_from_vehicle" },
    { 0x614E7398, "b_accept_negative_height" },
    { 0xB16FC475, "b_activated" },
    { 0xCE32BE36, "b_active" },
    { 0xC80F1410, "b_add_to_total" },
    { 0x7705B8C3, "b_ads_check" },
    { 0xDC25DA4E, "b_after_hack" },
    { 0x5C6CDE97, "b_afterlife_death" },
    { 0xD8750988, "b_aggressive" },
    { 0x0EF60116, "b_aggressive_mode" },
    { 0xBC7395FB, "b_alive" },
    { 0x8CBD55FF, "b_all_boarded" },
    { 0x7F71B6A6, "b_all_dead" },
    { 0xD9A738C8, "b_all_in_valid_position" },
    { 0x792A3493, "b_all_nodes" },
    { 0xF90E8E91, "b_all_players_in_afterlife" },
    { 0x1BBDBAB3, "b_all_points_used" },
    { 0xDF0F80C3, "b_allow" },
    { 0x24621D3B, "b_allow_grenades" },
    { 0xD4271D0F, "b_allow_idgun_pap" },
    { 0x785333DE, "b_allow_sprint" },
    { 0x9D77BBB7, "b_allow_use" },
    { 0x5BFBF565, "b_allows_multiple" },
    { 0x385D8759, "b_ally_priority" },
    { 0x962C6B60, "b_already_damage_by_player" },
    { 0xD9CB04F7, "b_already_on_tank" },
    { 0xB64BA0D0, "b_already_said" },
    { 0x54D1A8F4, "b_alt_visionset" },
    { 0x1AE3CA08, "b_angles" },
    { 0x6D7E21F6, "b_animate_origin" },
    { 0xA2B9417F, "b_any_scene" },
    { 0x54DFBE0E, "b_any_volumes_unfinished" },
    { 0xF8655093, "b_anyone_near" },
    { 0xEB32CC7F, "b_area_updated" },
    { 0xCF5F846C, "b_armed_for_combat" },
    { 0x58BD1248, "b_assemble" },
    { 0x73C05D0E, "b_assert" },
    { 0x4EA21791, "b_assert_if_missing" },
    { 0xA8E7533B, "b_at_left_edge" },
    { 0xA013A720, "b_at_right_edge" },
    { 0xFA367997, "b_at_risk" },
    { 0xFFAB6A26, "b_attracted_to_octobomb" },
    { 0xE06115AB, "b_auto_center" },
    { 0x2D41AB1C, "b_auto_close" },
    { 0x140AF654, "b_auto_delete_on_death" },
    { 0x788DB7BA, "b_avoidance" },
    { 0x3B73B37F, "b_base_info_only" },
    { 0x2D53D106, "b_beartraps" },
    { 0x676E5D07, "b_been_frozen" },
    { 0x0529B62C, "b_behind" },
    { 0x95AA64B6, "b_big_explosion" },
    { 0xDFD13974, "b_blacken" },
    { 0xF2030F35, "b_blah" },
    { 0x7095180B, "b_blend_exposure" },
    { 0x70D8BA05, "b_blockade_destroyed" },
    { 0x9636CF89, "b_bonuszm_streamer_fallback" },
    { 0x8E3CF85F, "b_both_legs" },
    { 0xBDC25288, "b_bulletpassed" },
    { 0xB3A978E7, "b_busy" },
    { 0x8D075D84, "b_button_pressed_this_frame" },
    { 0xB38BE96A, "b_call_box_used" },
    { 0x6F241DF7, "b_callback_result" },
    { 0xFFFD924A, "b_camera_shake" },
    { 0xF46DA7AE, "b_can_attach" },
    { 0x7DA21A91, "b_can_clientside" },
    { 0x2540D664, "b_can_delete" },
    { 0x662FFF21, "b_can_fail" },
    { 0xB9553F06, "b_can_fire_safely" },
    { 0x7981BF77, "b_can_free" },
    { 0x4F79B324, "b_can_hit_leader" },
    { 0xF6D9A8E0, "b_can_hit_target" },
    { 0x1B22C709, "b_can_open" },
    { 0xE87AA1D8, "b_can_path" },
    { 0x69BDC2F6, "b_can_pick_up" },
    { 0x524806E7, "b_can_play" },
    { 0xB2482DA1, "b_can_player_see_corpse" },
    { 0x6B2BAD21, "b_can_player_see_point" },
    { 0xA3F04FE5, "b_can_prone" },
    { 0x1DC684F1, "b_can_push" },
    { 0xAB2C3DDC, "b_can_respawn_zombie" },
    { 0xC34ED620, "b_can_restore_data_on_player" },
    { 0x4C7D3716, "b_can_see" },
    { 0xBC42B2E2, "b_can_see_hint" },
    { 0xFAB4E54E, "b_can_see_target" },
    { 0x3E7C37C6, "b_can_show" },
    { 0xCB82C545, "b_can_skip_player_scene" },
    { 0x40E25380, "b_can_spawn_richtofen_zombie" },
    { 0x574692B2, "b_can_toggle_ads" },
    { 0x61DBC211, "b_can_use_chaff" },
    { 0x7749D1F6, "b_cancel" },
    { 0xA9E31E10, "b_cancel_on_triggered" },
    { 0x0F8601B9, "b_canceled" },
    { 0x17B47277, "b_cansee" },
    { 0x4B9F948B, "b_canshoot" },
    { 0xF6109DBE, "b_capture_zombies_needed" },
    { 0x5797CD6B, "b_center_camera" },
    { 0xAB36A906, "b_challenge_exists" },
    { 0xECAC3330, "b_challenge_helos_spawned" },
    { 0x5859F91A, "b_changes_x" },
    { 0x7E5C7383, "b_changes_y" },
    { 0x0C550448, "b_changes_z" },
    { 0x444CE0BC, "b_charge_at_player" },
    { 0xF61C1380, "b_check" },
    { 0xD45B831D, "b_check_attackers" },
    { 0x52B18A9C, "b_check_flags" },
    { 0x6812FC7E, "b_check_for_target_existance_only" },
    { 0x048EF9F9, "b_check_linked_scene" },
    { 0xA0B6BF2D, "b_claw_has_flamethrower" },
    { 0xCB2F822D, "b_clean_vehicles" },
    { 0x97F6FBC8, "b_cleaned" },
    { 0x4020424C, "b_cleanup" },
    { 0x9107F0FC, "b_cleanup_more" },
    { 0xB1FD5A81, "b_cleanup_vars" },
    { 0x84FDA8DF, "b_clear" },
    { 0x219F50D5, "b_clear_anim" },
    { 0xE3B5962D, "b_clear_target" },
    { 0x0DD06DAF, "b_client_dvar" },
    { 0x27EA7DA4, "b_climbing_tank" },
    { 0x1AC106EA, "b_clockwise" },
    { 0xD90879C4, "b_close" },
    { 0x14BD482F, "b_collected_vulture" },
    { 0x008FC61E, "b_collision_imminent" },
    { 0x05261497, "b_compact" },
    { 0x2C6E8D75, "b_conditions_met" },
    { 0xD6AD2DEF, "b_connect_paths" },
    { 0xACB5DBE8, "b_consistent_shooting" },
    { 0xD987D94B, "b_continue" },
    { 0xB85E4DEC, "b_continue_mission" },
    { 0x381BEFC0, "b_control_active" },
    { 0x73EE72EA, "b_convert_numbers" },
    { 0x547BAD85, "b_convoy_in_volume" },
    { 0xA94344DA, "b_cool_rage_death" },
    { 0x7FEB4BAE, "b_cooldown_done" },
    { 0x9380FF2C, "b_cooldown_ok" },
    { 0x4E67737D, "b_cooldown_up" },
    { 0xD5E08A83, "b_copy_noteworthy" },
    { 0xEBCF87F7, "b_corpse_alley_scene_ready" },
    { 0xF159B021, "b_corpse_out_of_range" },
    { 0x1F95EAAD, "b_correct_stance" },
    { 0xCCA3173D, "b_correct_torch" },
    { 0x71B379ED, "b_could_hit_friendly" },
    { 0xC75A07F7, "b_count_as_death" },
    { 0x4E77FF61, "b_crash" },
    { 0xFC8E8C2A, "b_create_upgraded_crossbow_watchers" },
    { 0x12A22F48, "b_crossbow_bolt_destroy_on_impact" },
    { 0x883C408C, "b_crusher_is_active" },
    { 0x7F30CDD5, "b_current_target" },
    { 0xCBE90126, "b_currently_on_detour" },
    { 0x4D576A83, "b_custom_deathmodel_setup" },
    { 0x3BC96147, "b_damage_from_underneath" },
    { 0xF2663572, "b_dc_rebuild_timer_active" },
    { 0xC57F0B0D, "b_deferred_deactivation" },
    { 0xB017DB99, "b_delete" },
    { 0x13175925, "b_delete_barrier" },
    { 0x09C2FBC2, "b_delete_models" },
    { 0x10AC3ABB, "b_delete_on_goal" },
    { 0xFA4AB440, "b_delete_when_not_looking_at" },
    { 0xF9AA8824, "b_demo_jump" },
    { 0xB8E32595, "b_designated_target_exists" },
    { 0x47046546, "b_destroy" },
    { 0xD150E4B3, "b_destroy_actual_pieces" },
    { 0xB47F27C9, "b_destroyed" },
    { 0x56BCDF06, "b_dialog_played" },
    { 0xC21CE200, "b_did_capture" },
    { 0x16FCA5AC, "b_disable" },
    { 0x0011F52D, "b_disable_arrivals" },
    { 0xEBBCD0B7, "b_disable_charge" },
    { 0x33B5F16D, "b_disable_gibbing" },
    { 0x4C93C47F, "b_disable_leapers" },
    { 0xEB8973BB, "b_disable_scavenger_icon" },
    { 0xFDFAB13B, "b_disable_throttle" },
    { 0x2BADA33B, "b_disable_timekeep" },
    { 0x908F25C5, "b_disable_trigger" },
    { 0xB25355A9, "b_disconnect_paths_after_scene" },
    { 0x53B01890, "b_disintegrating" },
    { 0xCF2AF0AB, "b_display_tag" },
    { 0x5F2DC260, "b_displaying_menu" },
    { 0x9E954FF0, "b_distance_from_last_ok" },
    { 0x54D643AC, "b_distance_passed" },
    { 0xCE5BEBD2, "b_distance_to_next_ok" },
    { 0xB8D30214, "b_divert" },
    { 0xA8B8D115, "b_do_damage" },
    { 0xD525567F, "b_do_delete" },
    { 0xC464EAA4, "b_do_delta" },
    { 0x1E73C493, "b_do_freeze" },
    { 0xD4D0B459, "b_do_generic" },
    { 0x8A72FD56, "b_do_health_hit" },
    { 0xD51BBC18, "b_do_loop" },
    { 0xF3402EEF, "b_do_not_align" },
    { 0x618A6813, "b_do_not_chase_enemy" },
    { 0x87A87B59, "b_do_not_randomize_lines" },
    { 0x78264A46, "b_do_open" },
    { 0xEB8C82A3, "b_do_reach" },
    { 0x9BD58D85, "b_do_rumble" },
    { 0x8ACBD061, "b_do_switch_nag" },
    { 0x5C3305E5, "b_do_trace" },
    { 0x3384FC0B, "b_donag" },
    { 0x1CB55AEB, "b_done_shuffling" },
    { 0x72B38455, "b_dont_auto_delete" },
    { 0x571EC929, "b_dont_clear_anim" },
    { 0x11B95767, "b_door_death" },
    { 0x53B49865, "b_door_nagged" },
    { 0x55BD8AFB, "b_door_open" },
    { 0xFAF5574C, "b_double_points_active" },
    { 0x8C66513C, "b_down_25" },
    { 0x98F6482C, "b_down_50" },
    { 0x5676895E, "b_drone" },
    { 0x73D183C1, "b_drones" },
    { 0x2836FD87, "b_earthquake" },
    { 0x99333052, "b_ee" },
    { 0x623FBFA7, "b_electric_chair" },
    { 0x864A3D55, "b_enable" },
    { 0xC2723CAC, "b_enable_node" },
    { 0xE2E6BBCB, "b_enabled" },
    { 0xF2486E4D, "b_enemy_close" },
    { 0x4CC6CC5C, "b_enemy_is_talking" },
    { 0x99FBABAE, "b_engine" },
    { 0x3A8C4F80, "b_ent_new" },
    { 0xC779A229, "b_ents_are_available" },
    { 0x649292EA, "b_event_state" },
    { 0x83987691, "b_everyone_alive" },
    { 0x5EE348E6, "b_everyone_is_ready" },
    { 0xBFC9D652, "b_exclude_quick_revive" },
    { 0x0162428E, "b_exhaust" },
    { 0x415C95A8, "b_expensive_fx" },
    { 0x949DC20D, "b_explosion" },
    { 0x926DDADB, "b_face" },
    { 0xBCAF0329, "b_facing_drone" },
    { 0xA1219866, "b_fade_before_hiding" },
    { 0x3D9556FA, "b_fading_to_low_damage" },
    { 0x932DFB9C, "b_fail_watch" },
    { 0xED65F508, "b_fake_ai" },
    { 0x57B7BA95, "b_fake_ent" },
    { 0x4B605288, "b_fake_flight" },
    { 0xA1CF56B1, "b_false" },
    { 0xD9E9C44B, "b_farid_shot" },
    { 0x97A5BBE3, "b_fast_grab" },
    { 0x59469166, "b_fast_reload" },
    { 0x2199C3C8, "b_female" },
    { 0x4ABA2572, "b_finished" },
    { 0x844B6D72, "b_finished_achievement" },
    { 0x16AA4EC1, "b_fire_check" },
    { 0x238333B4, "b_fire_forever" },
    { 0x33B122BF, "b_fired_chaff" },
    { 0x7EB65BD2, "b_first" },
    { 0x42D1F660, "b_first_frame" },
    { 0x5DCE57AD, "b_first_link" },
    { 0xC1F204DB, "b_first_loop" },
    { 0x7D9D1C3E, "b_first_player" },
    { 0x4A4DE7B4, "b_first_run" },
    { 0x67682801, "b_first_shot" },
    { 0xBE66CCF6, "b_first_time" },
    { 0xF75905CE, "b_flag" },
    { 0x8C707BCB, "b_flag_captured" },
    { 0xB490A23F, "b_flag_set" },
    { 0xEAE3833E, "b_flamethrower_unlocked" },
    { 0x35BCF6D4, "b_flare" },
    { 0x712EE4D5, "b_flat" },
    { 0x7E740424, "b_flip_to_tile_side" },
    { 0xA1C73F09, "b_flyin_done" },
    { 0x20C62681, "b_follow_obj" },
    { 0x014C7388, "b_for_high_rage" },
    { 0x168AE9F1, "b_force" },
    { 0x9B53DAA6, "b_force_close_menu" },
    { 0xEF81B034, "b_force_first_frame" },
    { 0x22982A30, "b_force_no_cull" },
    { 0xE7710851, "b_force_reset" },
    { 0xED63ACA7, "b_force_update" },
    { 0x49CB9EDB, "b_foreground" },
    { 0xEF8776E4, "b_found" },
    { 0x43E16A91, "b_found_element" },
    { 0xAB8D7325, "b_found_entry" },
    { 0xD51CF01C, "b_found_fallback_node" },
    { 0x4D7CB886, "b_found_goal" },
    { 0xE8697546, "b_found_item" },
    { 0x151AB8E8, "b_found_leader" },
    { 0xBD1CA416, "b_found_match" },
    { 0x257B3AE3, "b_found_node" },
    { 0xF996DD64, "b_found_struct" },
    { 0x0FEDB7B7, "b_found_weapon_object" },
    { 0xAACC71A8, "b_found_zombies" },
    { 0x4C9B6EA6, "b_fraction" },
    { 0x31BBADD0, "b_from_player" },
    { 0x8B836F16, "b_frozen" },
    { 0xD53D0760, "b_g20_saved_1st" },
    { 0xF5E34B60, "b_g20_saved_2nd" },
    { 0x6108A7CB, "b_gameskillset" },
    { 0xFE8833C6, "b_gave_weapon" },
    { 0x28621FBB, "b_gibbed" },
    { 0xA2B651F9, "b_giveback_weapon" },
    { 0x672BAF5A, "b_global_save_exists" },
    { 0x4E7C813A, "b_gods_pleased" },
    { 0xAAE1555B, "b_got_input" },
    { 0x485DB0B3, "b_got_powerup" },
    { 0x30583201, "b_grapple_success" },
    { 0xD8F8DAAD, "b_gravity_trap_fx" },
    { 0x94E3FE6B, "b_gravity_trap_fx_on" },
    { 0x3D5C0232, "b_gravity_trap_spikes_in_ground" },
    { 0x350533F8, "b_hacked" },
    { 0xC4F54106, "b_harper_door_nag" },
    { 0xF38A18A3, "b_harper_speaking" },
    { 0x107240B5, "b_has_ammo" },
    { 0xB03FC567, "b_has_callback_already" },
    { 0x55048748, "b_has_clear_path" },
    { 0x7CD43586, "b_has_electric_cherry" },
    { 0xE18A540D, "b_has_fired" },
    { 0xA21BCC31, "b_has_gas_mask" },
    { 0x21B6734A, "b_has_goal" },
    { 0x8795A16E, "b_has_gravityspikes" },
    { 0x2CC303A7, "b_has_gun" },
    { 0x1F19848B, "b_has_hatch" },
    { 0xB4ECAA03, "b_has_init_state" },
    { 0x5AD1F3BB, "b_has_launcher" },
    { 0x9A937579, "b_has_line_played" },
    { 0x75BF71FF, "b_has_mortars" },
    { 0xA6CE9088, "b_has_player" },
    { 0x9FDC4DB9, "b_has_removed" },
    { 0xCFCD210A, "b_has_setup_objective" },
    { 0xEFEF82C3, "b_has_spawned" },
    { 0xA140BE3B, "b_has_staff" },
    { 0xB1E10140, "b_has_target" },
    { 0xDA840791, "b_has_unloaded" },
    { 0xFA288D25, "b_has_upgraded_shield" },
    { 0x27FEA7DE, "b_has_user" },
    { 0x09144E3B, "b_has_weapon" },
    { 0x8A0C92E2, "b_health_at_full" },
    { 0xB49E0088, "b_hide" },
    { 0xFDCE9327, "b_hide_child" },
    { 0xA5DF29DE, "b_hide_console" },
    { 0xC448BB72, "b_hide_hud" },
    { 0x48B63D90, "b_hide_icon" },
    { 0x5D102F13, "b_hide_weapon" },
    { 0x64604583, "b_hind" },
    { 0x37D45A06, "b_hint_done" },
    { 0x1C0D5BEE, "b_hint_set" },
    { 0x330AC303, "b_hint_vo" },
    { 0x59D11CCD, "b_hit_building_wrap" },
    { 0x8E5D1015, "b_hit_chest" },
    { 0x868A1CC9, "b_hit_ent" },
    { 0xD8B24596, "b_hit_glass" },
    { 0x38AEBB90, "b_hit_head" },
    { 0x50B4997D, "b_hit_l_shoulder_armor" },
    { 0xCD90F54F, "b_hit_l_thigh_armor" },
    { 0xD749CA37, "b_hit_location" },
    { 0x9EF21F51, "b_hit_r_thigh_armor" },
    { 0xB58C2791, "b_hit_shoulder_weakpoint" },
    { 0x857BBA9F, "b_hit_surface" },
    { 0xD1208CF5, "b_hit_target" },
    { 0xA5C1B5DA, "b_hold_open" },
    { 0x6D019C61, "b_hold_spawning_when_leapers_are_all_dead" },
    { 0xC7D5CFE8, "b_host_migration_force_player_respawn" },
    { 0x6F8EBE90, "b_igc_active" },
    { 0xAA7B6EEE, "b_ignore" },
    { 0x7D635A0B, "b_ignore_cleanup" },
    { 0x1EC2EE0C, "b_ignore_elemental" },
    { 0x472B5AF7, "b_ignore_glass" },
    { 0x4C5FEA73, "b_ignore_line_of_sight" },
    { 0x0D9730C9, "b_ignore_mark3_pulse_damage" },
    { 0x7D822B45, "b_ignore_pdf" },
    { 0x2391A42E, "b_ignore_spawners" },
    { 0x7C7991DC, "b_ignore_streamer" },
    { 0xBF7B390A, "b_ignore_water" },
    { 0xE6C781ED, "b_ignore_z" },
    { 0x4CCD5CB0, "b_ignoreme" },
    { 0xEEDA4487, "b_immediate" },
    { 0xBBAF0640, "b_impact_catastrophic" },
    { 0x00C45D04, "b_impact_major" },
    { 0x22677CEE, "b_in_a_e_speakers" },
    { 0x83B5960F, "b_in_active_zone" },
    { 0x524F2519, "b_in_courtyard" },
    { 0x66DF1E07, "b_in_igc" },
    { 0x140F26DC, "b_in_low_range" },
    { 0x82941561, "b_in_memory" },
    { 0xC5022671, "b_in_position" },
    { 0x54D96A53, "b_in_stink_last_check" },
    { 0xF52922BB, "b_in_tactical_position" },
    { 0x78FC8AD9, "b_in_tunnels" },
    { 0xD8A448EA, "b_in_zone" },
    { 0x37A16A1F, "b_include_players" },
    { 0x78FDD7E4, "b_index_string" },
    { 0x9A5DF58C, "b_indicator_active" },
    { 0xB22DF958, "b_infinite" },
    { 0x2D350984, "b_initial" },
    { 0xB7963BB6, "b_initial_move_back" },
    { 0x406AD39B, "b_initial_snap" },
    { 0xD53813A4, "b_input" },
    { 0x47C1FC3D, "b_inside_trigger" },
    { 0xB11F1DFA, "b_instant_change" },
    { 0x49585D45, "b_instructions_given" },
    { 0x533FD975, "b_invulnerable" },
    { 0x12544734, "b_is_2h_rappel" },
    { 0x325E5C35, "b_is_a_player_on_the_roof" },
    { 0xE39140A8, "b_is_above_ground" },
    { 0xC6728F76, "b_is_above_threshold" },
    { 0x266BDCA5, "b_is_ai" },
    { 0x4C56A80A, "b_is_alive" },
    { 0x7FE1BB9D, "b_is_ally" },
    { 0x4E1C6579, "b_is_ambient" },
    { 0xA7E88950, "b_is_available" },
    { 0xBA8EF133, "b_is_avenger" },
    { 0x0ED0DFE4, "b_is_axis" },
    { 0x58EDC3B8, "b_is_back_hiding" },
    { 0x5ABECC23, "b_is_behind" },
    { 0x841740B4, "b_is_bp3" },
    { 0x419E1319, "b_is_braking" },
    { 0x1835A948, "b_is_breakable" },
    { 0xB0A92F58, "b_is_broken" },
    { 0xF71E979E, "b_is_bullet_type" },
    { 0x9B23422B, "b_is_claw_exposed" },
    { 0xC3591C4C, "b_is_convoy_vehicle" },
    { 0x2E2B760B, "b_is_cqb" },
    { 0x3FAD0660, "b_is_crafted" },
    { 0x448E20E0, "b_is_currently_ignored" },
    { 0xE7C97471, "b_is_custom_weapon" },
    { 0x0F7A3649, "b_is_damage_trigger" },
    { 0x890700AD, "b_is_dead" },
    { 0xA6913927, "b_is_designated_target" },
    { 0xE6504FDB, "b_is_drone" },
    { 0x41C779D9, "b_is_enemy" },
    { 0xB1145AE5, "b_is_enough_damage" },
    { 0xFA617AC3, "b_is_explosive_type" },
    { 0x95B26CA4, "b_is_first_generator_attack" },
    { 0x89B6D549, "b_is_first_time" },
    { 0x4D1E6852, "b_is_freefalling" },
    { 0x3A16776A, "b_is_fuel_weapon" },
    { 0xD48EDCB0, "b_is_fully_charged" },
    { 0x78C8B3F6, "b_is_gametype_active" },
    { 0x9A2C96FB, "b_is_goal_inside_fallback_volume" },
    { 0x9CBC2FD9, "b_is_greenlight_build" },
    { 0x78261EFF, "b_is_high" },
    { 0x0F02B881, "b_is_in_inverted_building" },
    { 0xDFF2832D, "b_is_in_level_memory" },
    { 0xA5D96BFC, "b_is_in_playable_space" },
    { 0x07EAF799, "b_is_in_safe_spot" },
    { 0x5AA15060, "b_is_in_stink" },
    { 0x782A992F, "b_is_in_volume" },
    { 0x87F3140C, "b_is_inside_playable_area" },
    { 0x6DE242F8, "b_is_invis" },
    { 0x3AB0C475, "b_is_level_initializing" },
    { 0x23D518CB, "b_is_lifetime_over" },
    { 0xB5E42399, "b_is_looking_right" },
    { 0x79992A56, "b_is_model_in_memory" },
    { 0x295E883F, "b_is_new_guy" },
    { 0x9C26BA1D, "b_is_outdoor" },
    { 0x5B9EE368, "b_is_overheating_weapon" },
    { 0x8851F292, "b_is_perk_bottle" },
    { 0x91F4E745, "b_is_point_above_ground" },
    { 0x6C170B09, "b_is_point_below_threshold" },
    { 0x531A298C, "b_is_pressing_brake" },
    { 0xBAF21E77, "b_is_pressing_button" },
    { 0x480E556D, "b_is_primary_or_secondary_grenade" },
    { 0xAAF9682F, "b_is_rappelling" },
    { 0x66B7FECE, "b_is_restricted_solution" },
    { 0xB9432AA6, "b_is_rotator" },
    { 0x452DFBEA, "b_is_short_stop" },
    { 0xC2E5855B, "b_is_simple_prop" },
    { 0xE1CDEBE5, "b_is_spawner" },
    { 0x47C2A810, "b_is_standard_spawn" },
    { 0x48B4B24F, "b_is_stink_zombie" },
    { 0xDA974928, "b_is_struct" },
    { 0x319E7D65, "b_is_time_to_bring_back" },
    { 0x5C9B7E1B, "b_is_time_to_despawn" },
    { 0x6C23B4AC, "b_is_traversing_into_playspace" },
    { 0x0261CFA1, "b_is_trigger" },
    { 0x67C8A9ED, "b_is_updating" },
    { 0xA3B28E89, "b_is_using_look" },
    { 0x315DC0A7, "b_is_using_move" },
    { 0x61AD9CD5, "b_is_valid_area" },
    { 0xDB4D2F89, "b_is_valid_target" },
    { 0x8282625C, "b_is_vtol" },
    { 0x42A9FC8A, "b_is_vtol_mode" },
    { 0x15C3E182, "b_is_wall_rappel" },
    { 0x6D8B9523, "b_is_within_volume" },
    { 0xBA23C995, "b_is_zombie" },
    { 0x3A9C2A21, "b_jet_mode_ready" },
    { 0x6F95E2CF, "b_josefina_vo_on" },
    { 0xDF254A22, "b_just_once" },
    { 0xE949A23A, "b_karma_alive_and_not_captured_in_karma" },
    { 0xEC2E0D4D, "b_karma_captured" },
    { 0x13E52068, "b_karma_captured_but_retrieved_in_socotra" },
    { 0x5B862066, "b_keep_colors" },
    { 0xEC434B96, "b_keep_empty_arrays" },
    { 0xEE145EFA, "b_keep_keys" },
    { 0x0BEA5E9E, "b_keep_link" },
    { 0x30073108, "b_keep_radiant_ents" },
    { 0xFC760B49, "b_keep_weapons" },
    { 0xD50BB129, "b_keep_when_turned_off" },
    { 0x6DC4BEE0, "b_kill_player" },
    { 0x3DC25C2D, "b_lane_occupied" },
    { 0x042A1169, "b_laser_can_reactivate" },
    { 0x240674E9, "b_last_scene" },
    { 0xA603B50E, "b_launched" },
    { 0xB6A051AD, "b_leaper_has_been_alive_long_enough" },
    { 0xED4381D6, "b_leaper_has_been_out_of_playable_space_long_enough_to_delete" },
    { 0x3312BD1F, "b_leaper_is_in_scripted_state" },
    { 0xAB2A7B23, "b_left_side" },
    { 0x3D666A99, "b_less_full" },
    { 0xBD2FAE53, "b_less_than" },
    { 0xCB5B562C, "b_light_damage" },
    { 0xC6D5E93E, "b_lightning" },
    { 0x0661787D, "b_lights_on" },
    { 0xF139AF58, "b_link" },
    { 0x2F2A89D1, "b_link_to_self" },
    { 0xE23ABB6B, "b_linked" },
    { 0xC36BADF6, "b_linked_scene" },
    { 0xB9AD7892, "b_load_josefina_gump" },
    { 0x09759D25, "b_load_mason_gump" },
    { 0xC49BA33B, "b_lockingdown" },
    { 0x0BB9E181, "b_look" },
    { 0xB01DE8C7, "b_looking" },
    { 0xA180E212, "b_loop" },
    { 0x44EFBBD2, "b_loop_forever" },
    { 0x5C668EDE, "b_loop_sound" },
    { 0xC871E91E, "b_looping" },
    { 0xC5C27E7F, "b_los_check" },
    { 0x7E9083D1, "b_lowest_first" },
    { 0x65E59C68, "b_machine_valid" },
    { 0x187BAF5F, "b_make_fake_ai" },
    { 0x54103613, "b_manual_close" },
    { 0x948C275B, "b_match_all" },
    { 0x73B60DEA, "b_match_substrings" },
    { 0x5089A89A, "b_max_corpse_time_elapsed" },
    { 0xF3176F17, "b_max_scanyaw" },
    { 0xDA353FA7, "b_mechz_true_ignore" },
    { 0x7D8CC9FC, "b_medal_awarded" },
    { 0x04A8E50F, "b_melee_kill" },
    { 0xB2776F07, "b_message_up" },
    { 0xDCCC9715, "b_min_scanyaw" },
    { 0x99B6022B, "b_missiles" },
    { 0x0201EBC6, "b_missing_vo" },
    { 0xBFD99FC0, "b_missles" },
    { 0x3F9DAC75, "b_model_broken" },
    { 0xCCB91A22, "b_model_exists" },
    { 0x2F25DE2F, "b_mortar_vo" },
    { 0xE76CE576, "b_mortars" },
    { 0xCB70D29F, "b_move" },
    { 0x2FEDCECC, "b_move_fast" },
    { 0x9C3E735F, "b_move_path" },
    { 0x0628D126, "b_multi_target_turret" },
    { 0x21A36154, "b_need_to_tween" },
    { 0x2E75FDEB, "b_needs_user" },
    { 0x736A4E64, "b_network_slots_available" },
    { 0xF16ED138, "b_new_ent" },
    { 0xA2BE7D72, "b_next_point_above_threshold" },
    { 0xB4562D4E, "b_no_assert" },
    { 0x2C441A07, "b_no_cost" },
    { 0xB3A3C39C, "b_no_cull" },
    { 0xCB7910A3, "b_no_current_valid_targets" },
    { 0xCC28B22E, "b_no_death" },
    { 0xE0C00EF0, "b_no_guide" },
    { 0x2A98BFC7, "b_no_speed_match" },
    { 0x5ED00147, "b_no_trap_damage" },
    { 0xD2FCEF75, "b_no_unused_structs" },
    { 0xFA5EE466, "b_no_viewlook" },
    { 0xCE44D9D6, "b_node_claimed" },
    { 0x19074CAF, "b_node_occupied" },
    { 0xEAF405C2, "b_nodes_and_structs" },
    { 0x0A4CF614, "b_nolook" },
    { 0xEFFEECC4, "b_non_round" },
    { 0x303C56A9, "b_normalize" },
    { 0x60473415, "b_not_part_of_rage" },
    { 0x7BD067CE, "b_notarget" },
    { 0xE987C31C, "b_octobomb_infected" },
    { 0x9071DF3C, "b_old_allow_pain" },
    { 0xE27B9E78, "b_old_avoidance" },
    { 0xC1E63F13, "b_on" },
    { 0x326BF116, "b_on_tank" },
    { 0xE485F62B, "b_on_threader" },
    { 0xF36883DE, "b_one_time_vo" },
    { 0x2EEC2E7E, "b_only_once" },
    { 0x64F676DB, "b_only_turret" },
    { 0xC20D98A0, "b_open" },
    { 0x5B298609, "b_open_all_gramophone_doors" },
    { 0x5CC99B23, "b_open_craftable_checking_input" },
    { 0x1DDEC747, "b_open_craftables_remaining" },
    { 0xB78734A9, "b_open_sesame" },
    { 0xAC915C1C, "b_optional" },
    { 0x0A33A6AE, "b_origin" },
    { 0x4888840A, "b_other_in_range" },
    { 0x87B830C2, "b_out_of_range" },
    { 0x51B88394, "b_outcome" },
    { 0x0176E802, "b_outgoing" },
    { 0xCECFAAE7, "b_outline_active" },
    { 0x1D2EBCD1, "b_outside_play_space" },
    { 0x0C6731DA, "b_outside_playable_area" },
    { 0xE7F47F24, "b_outside_playable_last_check" },
    { 0xA1419DA6, "b_outside_playable_space_this_frame" },
    { 0x3C93A8F6, "b_over_magnitude_b" },
    { 0xDF8F5904, "b_overheating" },
    { 0xC85BCB45, "b_override_explosive_damage_cap" },
    { 0x6CEBE04A, "b_pain_enabled" },
    { 0x77BB0C1E, "b_parasite_attracted" },
    { 0x45678CA1, "b_parent_is_model" },
    { 0xDD261077, "b_passed_override" },
    { 0x8250256A, "b_passed_roll" },
    { 0x6833B1F8, "b_passed_threshold" },
    { 0x8972488E, "b_pause" },
    { 0x440439CE, "b_paused" },
    { 0x5C5BF862, "b_per_zone" },
    { 0xAFA84F9D, "b_physics_trace" },
    { 0x5B8385D9, "b_picked_rage_fake_rush" },
    { 0xCAD2DF96, "b_piece_crafted" },
    { 0x2751EA43, "b_pip_5_played" },
    { 0xF9FF2B8A, "b_pip_6_played" },
    { 0xEE75D2D9, "b_pip_7_played" },
    { 0xC524B8BD, "b_plane_weapon" },
    { 0x41E98838, "b_plant_stairs" },
    { 0x047C1273, "b_play_cheap_light" },
    { 0xB494A56B, "b_play_dead" },
    { 0xFB0FF47B, "b_play_fx" },
    { 0x97B50107, "b_play_line" },
    { 0xCB85B74E, "b_play_screen_shake" },
    { 0x136D7B04, "b_play_vo" },
    { 0xCC27AD6B, "b_played_bus_fx" },
    { 0x213E63BA, "b_played_fx_anim" },
    { 0xDCFA147F, "b_played_pip" },
    { 0xCD482734, "b_player_controlled" },
    { 0x8B915EBA, "b_player_downed_here" },
    { 0xD1153DF1, "b_player_failed_brainwash" },
    { 0xB6F6557A, "b_player_has_dieseldrone_weapon" },
    { 0x841B0878, "b_player_has_packapunch_weapon" },
    { 0xC6A6ED2C, "b_player_hit_trigger" },
    { 0x281D8BA2, "b_player_in_grenade_path" },
    { 0x936B8E4D, "b_player_in_range" },
    { 0xA4EF4CDE, "b_player_in_zombie_stink" },
    { 0x320E7AFE, "b_player_input" },
    { 0xFB9F4F9F, "b_player_inside_radius" },
    { 0xD7CE3EB8, "b_player_is_in_elevator_shaft" },
    { 0x152024B7, "b_player_is_jumping" },
    { 0xAB709E7F, "b_player_is_sprinting" },
    { 0xBC88EF6C, "b_player_moving" },
    { 0xC32AAC70, "b_player_near_courtyard" },
    { 0x99487B6C, "b_player_pushing_forward" },
    { 0xCF52645C, "b_player_save_exists" },
    { 0x6FED10E2, "b_player_scene" },
    { 0x195D5D8A, "b_player_specific" },
    { 0x9EE9EB53, "b_player_using_turret" },
    { 0x3F007349, "b_player_within_range" },
    { 0xA33CF37E, "b_players_in_adjacent_zone" },
    { 0x332218CA, "b_players_ready" },
    { 0x7B94ECD2, "b_playing" },
    { 0x6B749B79, "b_playing_expensive_light" },
    { 0x02E0A07F, "b_point_found" },
    { 0x1BA57CC8, "b_poster_knocked_down" },
    { 0xB63D6A29, "b_potus" },
    { 0x6FD7AAE2, "b_powerfull_weapons" },
    { 0xB027731A, "b_pressed" },
    { 0xAB3FB771, "b_pressed_attack" },
    { 0x18CA76F3, "b_pressed_last_frame" },
    { 0x6E66A53D, "b_pressing_forward" },
    { 0x9C189876, "b_prevent_pick_up" },
    { 0x766DE250, "b_priority" },
    { 0x2B60345E, "b_progress_bar_done" },
    { 0xAA07F091, "b_promise_cooldown" },
    { 0x21412003, "b_punch_upgraded" },
    { 0x594C5673, "b_quake" },
    { 0xD06BEE50, "b_rage_fire_vo" },
    { 0x0677F6E4, "b_rage_sprint_vo" },
    { 0xD8267E72, "b_rage_sprinting" },
    { 0xA0938425, "b_randomize" },
    { 0xC5726F47, "b_rappel_done" },
    { 0x4B641A80, "b_rappelling" },
    { 0x8DFE7B93, "b_raps_count_at_max" },
    { 0x7297DB97, "b_raps_count_per_player_at_max" },
    { 0x4C5A7C47, "b_raz_ignore_mangler_cooldown" },
    { 0xAE55D5F9, "b_reach" },
    { 0x164BEC55, "b_react" },
    { 0xD8548537, "b_record" },
    { 0x6D93E370, "b_refilled_ammo" },
    { 0x6BBC432C, "b_reloaded" },
    { 0xB17BB40C, "b_remove_in_proximity" },
    { 0x23DE1E4A, "b_remove_weapons" },
    { 0x8869A249, "b_require_input_for_grab" },
    { 0x20B6F81A, "b_require_push_forward" },
    { 0xF5CDD1C7, "b_reset_control" },
    { 0x853F1949, "b_reset_entity" },
    { 0x0AE7F78B, "b_restore_loadout" },
    { 0xDEB8D133, "b_result" },
    { 0x3A5EE738, "b_retrieved" },
    { 0xA3ED4587, "b_return_ai" },
    { 0xB8D101EA, "b_reversed" },
    { 0x1E9FD898, "b_revive_successful" },
    { 0x7D27BDE5, "b_revived" },
    { 0xC404F0E7, "b_reward_claimed" },
    { 0x0A436D6B, "b_richtofen_first" },
    { 0x1AE46FA6, "b_richtofen_zombie_active" },
    { 0xA8165ADA, "b_roll_engine" },
    { 0x423FD39C, "b_roll_passed" },
    { 0x32A2CEC1, "b_roof_pristine" },
    { 0xE433B3BD, "b_run_immediate" },
    { 0x469845DC, "b_run_next_scene" },
    { 0x81C6C482, "b_run_scene" },
    { 0xF8B95BA7, "b_rusher_cooldown_up" },
    { 0x79736BA2, "b_rushing" },
    { 0xCD5338BF, "b_safe" },
    { 0x56933B41, "b_sam_success" },
    { 0x4722A1AA, "b_same_arms_attacker" },
    { 0x2041F57E, "b_saved_anderson" },
    { 0x4824E6D3, "b_saved_dvar" },
    { 0x5423E21B, "b_saw_jump_scare" },
    { 0xB1A3FF6D, "b_saw_the_wth" },
    { 0x004B94F7, "b_scandir_right" },
    { 0xB11F9619, "b_scanning" },
    { 0x473F0C60, "b_scene" },
    { 0x4EF624A6, "b_scene_menu" },
    { 0xF4C1A6B3, "b_scene_spawned" },
    { 0x863A54A0, "b_screamed" },
    { 0xC3175C06, "b_secsystem_can_reactivate" },
    { 0x274A7B9D, "b_seen" },
    { 0x4DF8853E, "b_seeplayer" },
    { 0x464839C7, "b_self_is_struct" },
    { 0xD1995212, "b_selfremove" },
    { 0x6B34DDBF, "b_sequence" },
    { 0x47710BA8, "b_set" },
    { 0x8EF544C6, "b_set_color_to_white" },
    { 0x818B04F5, "b_set_hint_string_now" },
    { 0xE78F451F, "b_set_max_speed" },
    { 0x338DF934, "b_set_ready_when_spawned" },
    { 0x334D64A0, "b_set_speed" },
    { 0xCE0C77D5, "b_shared_player" },
    { 0x7AEF94AA, "b_shared_scene" },
    { 0x713444E5, "b_shoot" },
    { 0x2412FA23, "b_shoot_bullets" },
    { 0xBED6987A, "b_shoot_burst" },
    { 0x383A6D27, "b_shoot_player" },
    { 0x305CFF09, "b_shoot_retreat" },
    { 0x4662BF59, "b_short_death" },
    { 0x9BF69C4B, "b_should_aim_at_player" },
    { 0xD403D23E, "b_should_attack_generator" },
    { 0x8D46527E, "b_should_blink" },
    { 0xBF283238, "b_should_change_fog_setting" },
    { 0xC4794150, "b_should_charge" },
    { 0x3137B026, "b_should_clear_data" },
    { 0xB30D2648, "b_should_close" },
    { 0x4A56C64F, "b_should_create_rope" },
    { 0x9CD652EF, "b_should_damage" },
    { 0xCB054124, "b_should_delete_rope" },
    { 0x043B40C3, "b_should_drop" },
    { 0x7D827168, "b_should_exceed_speed" },
    { 0xF906027A, "b_should_find_flesh" },
    { 0x8F027878, "b_should_fire" },
    { 0xFEC1E9AE, "b_should_fire_grenades" },
    { 0x43DFDF28, "b_should_fire_rpg" },
    { 0x5BE9436D, "b_should_flip" },
    { 0x5FA3F2F4, "b_should_have_stink" },
    { 0x172F9175, "b_should_hide_tag" },
    { 0xE6B760E7, "b_should_hint" },
    { 0xB55E9B7E, "b_should_ignore_player" },
    { 0x3DF6570E, "b_should_loop" },
    { 0x4027C73B, "b_should_match_speed" },
    { 0xB419CF03, "b_should_move" },
    { 0xCFA9771A, "b_should_nag" },
    { 0x90B98DBE, "b_should_play_anim" },
    { 0xBCBB3A44, "b_should_play_wall_jump_anim" },
    { 0x6DB964ED, "b_should_reject" },
    { 0x730FB161, "b_should_rush_from_distance" },
    { 0x672B17F9, "b_should_rush_from_group" },
    { 0xEEB05973, "b_should_show_debug" },
    { 0x83A7BC96, "b_should_spawn_avenger" },
    { 0xF1B8F322, "b_should_spawn_origin" },
    { 0xB1462508, "b_should_sprint" },
    { 0x54ADC56D, "b_should_target_player" },
    { 0xBF72E450, "b_should_warn" },
    { 0x605B944D, "b_shouldfire" },
    { 0x78B18D86, "b_shouldhint" },
    { 0xED6B2F03, "b_show" },
    { 0x3885A3ED, "b_show_ads_prompt" },
    { 0xE331857B, "b_show_death_blossom_prompt" },
    { 0x97DEEA71, "b_show_emergence_holes" },
    { 0x60DD615C, "b_show_fx" },
    { 0xFB17D2E5, "b_show_hover_prompt" },
    { 0x0C8D6A65, "b_show_icon" },
    { 0x5408EE83, "b_show_message" },
    { 0x1802A4BA, "b_show_move_prompt" },
    { 0x112B2E87, "b_show_objective" },
    { 0x64CBDF3F, "b_show_objective_message" },
    { 0xB1B5EC1E, "b_show_overlay" },
    { 0xFB735A04, "b_show_player_firstperson_weapon" },
    { 0xDB8F999D, "b_show_single_intermission" },
    { 0x35A4909C, "b_show_speed_boost_prompt" },
    { 0x90D0647F, "b_show_weapon_prompt" },
    { 0x570ED0C6, "b_showing_stat" },
    { 0x3D523245, "b_sight_trace" },
    { 0xAEA8FBBF, "b_sightpassed" },
    { 0x522CE25D, "b_skip" },
    { 0x06D42FFA, "b_skip_ai" },
    { 0xAC598D03, "b_skip_fading" },
    { 0x951B3FDC, "b_skip_precache_models" },
    { 0x272AB608, "b_skip_scene" },
    { 0x9ACB2C8A, "b_soct_has_boost" },
    { 0xDB3BC500, "b_spawn_collision" },
    { 0x619289AD, "b_spawn_ready" },
    { 0x4320F277, "b_spawn_zombies_before_nuke" },
    { 0xB17F41F4, "b_spawner" },
    { 0x20265429, "b_spawner_only" },
    { 0x4005B2A9, "b_special_octobomb" },
    { 0xBAF7E424, "b_specific_ais" },
    { 0xD6CCD359, "b_specific_ents" },
    { 0x9D29C7D9, "b_specific_models" },
    { 0xC0815CC0, "b_spin" },
    { 0x401295B7, "b_spinup" },
    { 0xFB18C5EF, "b_spoon_in_tub" },
    { 0xA499BA8F, "b_spoon_shocked" },
    { 0xE0CD6234, "b_sprint" },
    { 0x14F7F6F4, "b_sprinting" },
    { 0xD2B3E3B2, "b_staff_equipped" },
    { 0x3FC001BC, "b_staff_in_use" },
    { 0xC522C1D5, "b_stagger" },
    { 0xDC216CDE, "b_start_empty" },
    { 0xAFCEE605, "b_start_scanyaw" },
    { 0xCE07CC74, "b_start_spawn" },
    { 0x0C9265D7, "b_start_visible" },
    { 0x4D43ACEF, "b_started" },
    { 0xC98F4013, "b_starting_machine_found" },
    { 0xCA4B1DC7, "b_state" },
    { 0xB48B1D86, "b_state_changed" },
    { 0x408CCB7B, "b_stay" },
    { 0x34A54E7B, "b_stay_forever" },
    { 0x5BB65291, "b_stay_on" },
    { 0x49A7DC50, "b_steered" },
    { 0x6536A83D, "b_still_enemy_in_pos_check" },
    { 0x308B7345, "b_stink_ent_available" },
    { 0xDA005640, "b_stop" },
    { 0x91599CFB, "b_stop_immediately" },
    { 0x3EC22813, "b_streamer_wait" },
    { 0xCAF16E31, "b_success" },
    { 0x5938824D, "b_succession" },
    { 0x1288555E, "b_super_soct_exists" },
    { 0xEDB2490F, "b_supercharged" },
    { 0x9ABCC43E, "b_suppress_doors_close" },
    { 0x20757AE2, "b_supress_assert" },
    { 0x420916F7, "b_swarm_spawned" },
    { 0x051C8389, "b_switch_back_weapon" },
    { 0x217A210B, "b_switch_to_weapon" },
    { 0xA6263B07, "b_switch_weapon" },
    { 0xAA53271A, "b_sync_audio" },
    { 0xB09FABE3, "b_tank_warn" },
    { 0x7566E142, "b_target_found" },
    { 0xA060FD9D, "b_target_in_view" },
    { 0x20DE07B0, "b_target_out_of_range" },
    { 0x2FA4BCD3, "b_team" },
    { 0x18290DDE, "b_team_hint_added" },
    { 0xB98C3119, "b_teleport" },
    { 0x004C1451, "b_teleport_invulnerability" },
    { 0x86DA14AF, "b_teleporting" },
    { 0x221B4CF2, "b_test_run" },
    { 0xC16493F4, "b_testing" },
    { 0xEB6E1B70, "b_think" },
    { 0xAD621BEE, "b_thrasher_custom_spore_fx" },
    { 0xBA462582, "b_thrasher_temp_invulnerable" },
    { 0x9C6247C4, "b_throttle" },
    { 0x305B5573, "b_time_bomb_in_valid_location" },
    { 0xFE201011, "b_time_to_delete" },
    { 0x83701BB1, "b_timeout" },
    { 0x7F38E953, "b_timeout_hit" },
    { 0x2013BC2C, "b_toggle" },
    { 0xDE42E29F, "b_too_close" },
    { 0xAE0F1E83, "b_took_weapons" },
    { 0x71952EC9, "b_top" },
    { 0xBEC72E2A, "b_touched" },
    { 0x3A825BEB, "b_touching" },
    { 0x6F7DF37F, "b_tower" },
    { 0x8703EDC3, "b_trace" },
    { 0x04C210B6, "b_trace_done" },
    { 0x90DB7DA1, "b_trace_pass" },
    { 0x63B1558E, "b_trace_passed" },
    { 0xA2F50F4D, "b_track" },
    { 0x52067C49, "b_track_objective" },
    { 0x905E36C9, "b_track_stats" },
    { 0x911246D2, "b_track_while_attacking" },
    { 0x00F4E276, "b_trans" },
    { 0x37A94097, "b_transitioning" },
    { 0x671111F8, "b_trap_start_custom_vo" },
    { 0xFDFD7D26, "b_trig" },
    { 0x8E0E347C, "b_trigger_used" },
    { 0x9F5A7060, "b_turn_off_sheeting_already_running" },
    { 0xE8639F6B, "b_turret_active" },
    { 0xEFFCB818, "b_turret_alive" },
    { 0x1D08F968, "b_tutorial_mode" },
    { 0x0CDFCB59, "b_unaware" },
    { 0xF7107291, "b_under_attack" },
    { 0x23C1A4BA, "b_under_tarp" },
    { 0x646AB842, "b_underneath" },
    { 0x16C33008, "b_unlink_after_completed" },
    { 0x50D5759C, "b_unlock" },
    { 0xD03C895B, "b_use_absolute" },
    { 0xDA249FA1, "b_use_camera_tween" },
    { 0x0DC9A94A, "b_use_center_pillar" },
    { 0x316EC36E, "b_use_cheap_flag" },
    { 0x542F804A, "b_use_custom_health" },
    { 0x849612A5, "b_use_distance" },
    { 0x2FCE86A9, "b_use_drivepath" },
    { 0xE3BB8E1D, "b_use_drones" },
    { 0x9786D59B, "b_use_eye" },
    { 0xCB2BC269, "b_use_force_protection_vo" },
    { 0x0FE4428D, "b_use_guns" },
    { 0x4FDF508F, "b_use_headlook" },
    { 0xD45C7342, "b_use_left_pillar" },
    { 0xC31534DF, "b_use_linkto" },
    { 0xBBBEB83E, "b_use_low_ready" },
    { 0x3E876BBE, "b_use_manual" },
    { 0x1016C445, "b_use_offset" },
    { 0x0BF311DB, "b_use_path_finding" },
    { 0x7BC007B8, "b_use_pegasus" },
    { 0xDCF7FA65, "b_use_player_damage" },
    { 0xBDE6919F, "b_use_pos_origin" },
    { 0x7C1AD980, "b_use_revive_tool" },
    { 0xF7A4B809, "b_use_right_pillar" },
    { 0xA409F7E7, "b_use_tag_angles" },
    { 0x7DC57AAA, "b_use_tag_eye" },
    { 0x5B1EC2C2, "b_use_trig" },
    { 0x0003FD08, "b_used_chaff" },
    { 0x1FADB50B, "b_used_spikes" },
    { 0x10B18BFF, "b_user_required" },
    { 0x8646F3FF, "b_using_ads" },
    { 0x37CEEF82, "b_using_low_fog" },
    { 0x56E7AA63, "b_using_throttle" },
    { 0xEE46CFB3, "b_using_thumbstick" },
    { 0x4EF38551, "b_using_valid_area" },
    { 0x867F6FA5, "b_val" },
    { 0xD80AB647, "b_valid_poi" },
    { 0x7B98A82F, "b_valid_vehicle" },
    { 0x9A2BAF7D, "b_valid_weapon" },
    { 0x1F9D4A0E, "b_visible" },
    { 0x35CE537D, "b_visible_laser_exists" },
    { 0xC65F4E49, "b_vo_played" },
    { 0x857D049F, "b_vo_said" },
    { 0x009DF1F7, "b_vortex_fx_applied" },
    { 0xADDBD602, "b_vortex_repositioned" },
    { 0x5E4AD50B, "b_wait" },
    { 0xB002CE42, "b_wait_fire" },
    { 0x355EC048, "b_wait_for_loop" },
    { 0xE933C020, "b_wait_for_nearby_speakers" },
    { 0x0C841241, "b_wait_if_busy" },
    { 0x260C8BCC, "b_wait_one_frame" },
    { 0xF4BA5B59, "b_wait_time" },
    { 0xA8E97EFE, "b_wandering_in_chamber" },
    { 0x0FFBB7DC, "b_was_time_jump" },
    { 0xDB6FFD10, "b_wasp_count_at_max" },
    { 0xEDF34246, "b_wasp_count_per_player_at_max" },
    { 0x013B5379, "b_weaken" },
    { 0x093A2D1A, "b_weapon_is_overheating" },
    { 0xE5551438, "b_weapon_supports_aat" },
    { 0x1A6D4DAA, "b_weapons_disabled" },
    { 0x51F0A83D, "b_widows_wine_cocoon" },
    { 0xB6CCBFE2, "b_widows_wine_no_powerup" },
    { 0xD3A5E141, "b_widows_wine_slow" },
    { 0x1C37A330, "b_will_hit_friendly" },
    { 0xFEA53B7E, "b_will_hit_player" },
    { 0x829CF66F, "b_will_hit_self" },
    { 0xAFDE3305, "b_within_dot" },
    { 0x6576A551, "b_woods_on_right" },
    { 0x861EAEE4, "b_world" },
    { 0xEAC947E3, "b_zombie_blood" },
    { 0x5B62506E, "b_zombie_blood_damage_only" },
    { 0x98C173C9, "b_zoom" },
    { 0xFE151A46, "ba" },
    { 0x85FC594D, "baack" },
    { 0x24175341, "babies" },
    { 0xC0945BA1, "baby" },
    { 0x7DFF0747, "bachelor" },
    { 0x07497EB8, "back" },
    { 0x6F44A23E, "back_ambush_guys" },
    { 0x0424EED8, "back_angle" },
    { 0xE5979A38, "back_angle_threshold" },
    { 0x8E40B677, "back_attack" },
    { 0xF1901657, "back_bathroom_chain" },
    { 0x03F945B0, "back_bathroom_cleared" },
    { 0x402CA921, "back_board" },
    { 0x991232FB, "back_dist" },
    { 0x0F221EDB, "back_door" },
    { 0x014940C4, "back_door_blocker" },
    { 0xC353E2AC, "back_door_clip" },
    { 0x01BB8E4F, "back_door_inside1" },
    { 0x8FB41F14, "back_door_inside2" },
    { 0x4DD6DBDF, "back_down" },
    { 0x99CE7DC4, "back_face" },
    { 0x351EBF78, "back_hallway_battle" },
    { 0xB1B9B328, "back_hallway_breachers_ai" },
    { 0x8A2B046A, "back_in" },
    { 0x88BAC021, "back_in_plane" },
    { 0x662A71D0, "back_left_threshold" },
    { 0x541BB75B, "back_occupied" },
    { 0x593795DD, "back_option_num" },
    { 0x75DC0BDD, "back_out" },
    { 0x7AEC9D8B, "back_right_threshold" },
    { 0x258A5C54, "back_to_base" },
    { 0xE0953904, "back_to_base_objective" },
    { 0xADAD389C, "back_to_near_owner_check" },
    { 0x11952F05, "back_to_owner_check" },
    { 0x262FE732, "back_to_the_eclipse" },
    { 0x00701BCA, "back_to_the_future" },
    { 0x4462EA87, "back_type" },
    { 0x25083050, "back_up" },
    { 0x6E122E9F, "back_up_node" },
    { 0x54535147, "backanim" },
    { 0xE1A23B2D, "backarmor" },
    { 0xC0F80655, "backarmorhudelem" },
    { 0xE2641BA5, "backbreak" },
    { 0x48F33AF4, "backbreaker" },
    { 0x828DE8E2, "backbreaker_vo" },
    { 0xFCB55E78, "backdist" },
    { 0x7FD2F8A8, "backdoor" },
    { 0xF8FF751F, "backdrop" },
    { 0xDF0033A6, "backdrops" },
    { 0x1BFF1CCB, "backed" },
    { 0xF7612422, "backendcore" },
    { 0x0BFBEC59, "background" },
    { 0xBE5706D7, "background_block" },
    { 0x93805B59, "background_flak_fire" },
    { 0xF13D1350, "background_rappel" },
    { 0x96B24313, "background_rappel_guys" },
    { 0x8A3194D0, "background_rappel_left_guy" },
    { 0x86E87ACE, "background_rappel_left_sync" },
    { 0xD8F36113, "background_rappel_right_guy" },
    { 0xF83CE30F, "background_rappel_right_sync" },
    { 0x45C8ECA1, "background_rappellers_cleanup" },
    { 0x48EF93D6, "background_soldier_anims_alert_timeout" },
    { 0xF24A564C, "background_trucks" },
    { 0xC819107F, "backgroundalpha" },
    { 0x4B0F33E3, "backhalf" },
    { 0x0B15E35A, "backhalf_manual_mg_fire" },
    { 0x4AC45C32, "backhalf_mg_setmode" },
    { 0xB6B18D0A, "backhalfmgs" },
    { 0xEECAFF20, "backing" },
    { 0xB8BDA8B8, "backing_up" },
    { 0xA096EB17, "backingup" },
    { 0xA759049B, "backleft" },
    { 0x27FEB63B, "backlinked" },
    { 0x352897B9, "backlocal" },
    { 0xB2F7485F, "backoff_count" },
    { 0xC11D9293, "backoff_timeout" },
    { 0xC06CBD4D, "backout_halftrack" },
    { 0x85ECCF92, "backout_kubel2" },
    { 0xE3FBFC3D, "backout_lane2_truck2" },
    { 0xBDF981D4, "backout_lane2_truck3" },
    { 0xBD198316, "backout_truck2" },
    { 0xEC20AD8B, "backpack" },
    { 0x5FB8B2B4, "backpedal" },
    { 0x8930F9BF, "backpedalrangesq" },
    { 0x34B332A7, "backpedals" },
    { 0x0B1E2F86, "backpos" },
    { 0x8B5EE3CE, "backright" },
    { 0x7ADD3581, "backroom" },
    { 0xC1F3AA13, "backs" },
    { 0x1EA17518, "backshot" },
    { 0x32C33103, "backstabs" },
    { 0x1DF71F02, "backstage" },
    { 0x3F0C2E64, "backstroke_swim_fx" },
    { 0x8FAB328F, "backtocombat" },
    { 0x865A91BB, "backtohide" },
    { 0xC10026BD, "backtrack" },
    { 0xC17F399C, "backtrack_fail" },
    { 0x4C4A6EFE, "backtrack_trig" },
    { 0x910298E1, "backtrack_trigs" },
    { 0xEE409C6A, "backtracked" },
    { 0x5134D42B, "backtracking" },
    { 0x3D6F4B7C, "backtracks" },
    { 0x03D9162F, "backup" },
    { 0x5812FB74, "backup_anims" },
    { 0x5F72C95F, "backup_distance" },
    { 0xB6AED183, "backup_group" },
    { 0xE50EAB46, "backup_hit_stuff" },
    { 0xEFC2BCD9, "backup_leader" },
    { 0xE9F6393E, "backup_node" },
    { 0xF57CBB18, "backup_parkour" },
    { 0x25A7F0EF, "backup_path" },
    { 0x51277238, "backup_shake" },
    { 0x0F136B99, "backup_slider" },
    { 0xE277A7EA, "backup_spawner" },
    { 0x66D1CEA5, "backup_spawners" },
    { 0xAAA5DFA3, "backup_truck" },
    { 0xB1972CFA, "backup_truck_spawn_function" },
    { 0x35A5F161, "backup_truck_spawners" },
    { 0xBAC0FA60, "backup_volume" },
    { 0xA48F13F8, "backup_volume_struct" },
    { 0xAF12C08A, "backupandclearwinstreaks" },
    { 0x40F0D89E, "backvec" },
    { 0xC6A31D56, "backward" },
    { 0x62CD1A17, "backwardposition" },
    { 0xDAD5658B, "backwardpositionvalid" },
    { 0xC38AF4C9, "backwards" },
    { 0xC766E990, "backwards_keys" },
    { 0x277DD9B5, "backwardsvec" },
    { 0x9A165F38, "backweight" },
    { 0x04FC54D4, "backworld" },
    { 0x312835B8, "backyard" },
    { 0x2C4D0601, "backyard_1_check" },
    { 0x1F58649A, "backyard_2_check" },
    { 0x98545E76, "bad" },
    { 0xFE7913CE, "bad_area_fixes" },
    { 0x6E71A45D, "bad_crumbs" },
    { 0xC3FFB8BD, "bad_dog" },
    { 0xA75712E9, "bad_guys" },
    { 0x30ACE227, "bad_index" },
    { 0x7F8C30E8, "bad_moveup_trigger" },
    { 0xFD76B6DD, "bad_mystery_wallbuy" },
    { 0x543D1204, "bad_nodes" },
    { 0x880142F1, "bad_org" },
    { 0x5458F5C0, "bad_path" },
    { 0x4F4949C4, "bad_path_count" },
    { 0xA9291518, "bad_path_failsafe" },
    { 0xB5A1D5AA, "bad_player_bad" },
    { 0xC7E29595, "bad_pos" },
    { 0x19BA61E7, "bad_spawn_zone_name" },
    { 0xF8AA820E, "bad_turret_spot" },
    { 0x087785F6, "bad_zones" },
    { 0x268DB6CD, "badaccuracy" },
    { 0xE062B7E5, "badass" },
    { 0xED9C07CC, "badass_enemy_kicking_woods" },
    { 0x4AD73E87, "badboys" },
    { 0x161EA587, "baddies" },
    { 0x5EE6CA02, "baddist" },
    { 0x2CF30FED, "baddistteam" },
    { 0xD2266ACF, "badguy" },
    { 0xE31E3924, "badguy_died" },
    { 0xF9BBDD94, "badguy_health_shield" },
    { 0x6EDFD0BA, "badguy_jeep" },
    { 0x023A25E4, "badguy_proximity_kill" },
    { 0x016EA88E, "badguy_spawn_function" },
    { 0xA705AA96, "badguys" },
    { 0xA2EE737B, "badly" },
    { 0xCE6511FB, "badness" },
    { 0xDE0F4E0A, "badnode" },
    { 0xAC03227F, "badpathpos" },
    { 0xFA1DA7A7, "badplace" },
    { 0xC71F37A6, "badplace_arc" },
    { 0x0BEB2C49, "badplace_box" },
    { 0xE7F480F2, "badplace_brush" },
    { 0x48A41DF0, "badplace_cylinder" },
    { 0x0BAA5973, "badplace_delete" },
    { 0xD1DDD353, "badplace_entnum" },
    { 0xFE55FC9F, "badplace_manager" },
    { 0x5B225C9F, "badplace_name" },
    { 0x24FCE7FE, "badplace_think" },
    { 0xA5621C59, "badplace_untilnotify" },
    { 0x08211261, "badplace_volume_think" },
    { 0x59C69F27, "badplace_when_near" },
    { 0x48DEB832, "badplaceawareness" },
    { 0xBD762B2F, "badplaceduration" },
    { 0x5D179086, "badplacehill" },
    { 0x3C5E1552, "badplaceint" },
    { 0x62303D98, "badplacemodifier" },
    { 0x07525C3A, "badplacename" },
    { 0x907A2187, "badplacer" },
    { 0xE9468521, "badplaceradius" },
    { 0x6A77A71E, "badplaces" },
    { 0x68F6117B, "badplacesenable" },
    { 0x57C3D09C, "badplaceteam" },
    { 0xCE54A759, "badspawnline" },
    { 0x08172399, "badspots" },
    { 0xAD2DAB0C, "badtrig" },
    { 0xD78FFBB3, "badval" },
    { 0x1514A61B, "badveh" },
    { 0x7251E40D, "bag" },
    { 0xE0AAB7E0, "bagging" },
    { 0x1CFE6D01, "bagofbarrels" },
    { 0x8415402B, "bagofbarrelsexpsound" },
    { 0xC659939A, "bagofcrates" },
    { 0xF9BDB478, "bagofcratesexpsound" },
    { 0x716B9D8C, "bags" },
    { 0x03C8A269, "baicontrolled" },
    { 0x769ED404, "baikonur" },
    { 0x8520A405, "bail" },
    { 0xD0137A17, "baircraftwaitforstart" },
    { 0xF4E52A2D, "bait" },
    { 0xEB81E9CD, "baitnode" },
    { 0x5254D75E, "baked" },
    { 0x5E0A459B, "balaclavas" },
    { 0xD635D3A7, "balance" },
    { 0xB6CCAE95, "balancedeadplayers" },
    { 0x94B13D36, "balancemodulus" },
    { 0x266B9913, "balancemostrecent" },
    { 0xA4D0CADF, "balanceteams" },
    { 0xDE401CE2, "balancing" },
    { 0xBC9B1413, "balconies" },
    { 0xBE4A8AB7, "balcony" },
    { 0x40CCD75C, "balcony1" },
    { 0x8BD9CEF9, "balcony_blocker_away" },
    { 0x115532B0, "balcony_blood_hud" },
    { 0x0D392F77, "balcony_blood_hud_destroy" },
    { 0xFECA4D5E, "balcony_blowup_effects" },
    { 0xDF7F6827, "balcony_breachers" },
    { 0x654B60E0, "balcony_breadcrumbs" },
    { 0x28168852, "balcony_btr_1" },
    { 0x4773B2AD, "balcony_collapse_rumble" },
    { 0xD168C633, "balcony_crash" },
    { 0xE8E0C926, "balcony_crashing_plane" },
    { 0xFFC3A98C, "balcony_death" },
    { 0x79579D29, "balcony_door_open" },
    { 0x4542958E, "balcony_enemies" },
    { 0xEF9766B3, "balcony_engagement" },
    { 0x498EC7E8, "balcony_event1_player_blink_eye" },
    { 0x7E47500F, "balcony_fallout" },
    { 0x1A7E8650, "balcony_ground_targets" },
    { 0x20DD5C93, "balcony_guy" },
    { 0x1690C3C2, "balcony_guys" },
    { 0xB5294364, "balcony_init" },
    { 0xE3FF5F91, "balcony_lights" },
    { 0x249B7876, "balcony_mgspawner" },
    { 0xC53ACF86, "balcony_node" },
    { 0xF5213FCC, "balcony_node_types" },
    { 0xFC092939, "balcony_nodes" },
    { 0x511461EE, "balcony_on_left_dialog" },
    { 0x9004C90A, "balcony_physics_structs" },
    { 0x41D7EBDA, "balcony_plane_gone" },
    { 0x7F7EA505, "balcony_playerhints" },
    { 0x73895B12, "balcony_roof_aa_gun" },
    { 0x45B870DD, "balcony_roof_aa_guy" },
    { 0x0C368747, "balcony_roof_targets" },
    { 0x5A888378, "balcony_runner_alerted" },
    { 0x7E0E3B26, "balcony_sounds" },
    { 0x7EC68B92, "balcony_spawner" },
    { 0xA4D3C9C2, "balcony_start" },
    { 0x6E53F88E, "balcony_think" },
    { 0x05EC3A22, "balcony_throw" },
    { 0xE7F6C613, "balcony_throw_destruction" },
    { 0xAC4C1308, "balcony_trig" },
    { 0xC4A2AFCB, "balcony_truck" },
    { 0x4A64E0B8, "balcony_vo_trig" },
    { 0xECA339E8, "balconydamage" },
    { 0x85A086EF, "balconydeath" },
    { 0x781FEA69, "balconydeathcounter" },
    { 0xC39D269D, "balconyflag" },
    { 0x9EA36C4B, "balconyglobalsinit" },
    { 0x8D625B2D, "balconymetal1" },
    { 0xB364D596, "balconymetal2" },
    { 0xD9674FFF, "balconymetal3" },
    { 0xCF55F720, "balconymetal4" },
    { 0x03243207, "balconynodetype" },
    { 0x795F9DB8, "balconypositionorg" },
    { 0xE2EA4BD6, "ball" },
    { 0x8E435183, "ball_goals" },
    { 0x2F505CD1, "ball_pickup_waittill_change" },
    { 0x665382A2, "ball_return_trigger" },
    { 0xB4CAF8B5, "ball_wins_index" },
    { 0xE0DEBFCE, "ballistic" },
    { 0x0A474294, "ballistic_knife" },
    { 0x2547BA72, "ballistic_knife_autorecover" },
    { 0x3FF07157, "ballistic_knife_kill" },
    { 0x2C9C7CD9, "ballistic_knife_stationary" },
    { 0xFFB428B1, "ballistic_knives_pickedup" },
    { 0x499DA020, "ballistic_upgraded_weapon" },
    { 0x92998C6A, "ballistic_upgraded_weapon_name" },
    { 0x0BEEEC9B, "ballistic_was_primary" },
    { 0x834EC52D, "ballistic_weapon" },
    { 0xAE3C4699, "ballistic_weapon_name" },
    { 0x8DCEFDB0, "ballisticknifekills" },
    { 0x06CD1D71, "ballistics" },
    { 0xC7992849, "balls" },
    { 0xC3F31916, "ballsitic" },
    { 0xE9536A5A, "ballsy" },
    { 0x2316B476, "ballweapon" },
    { 0xA31AD34F, "balocny" },
    { 0x93CEEBBD, "bamboo_01" },
    { 0xAE94B344, "bamboo_01_start" },
    { 0xB9D16626, "bamboo_02" },
    { 0xF60E1377, "bamboo_02_start" },
    { 0xDFD3E08F, "bamboo_03" },
    { 0xA74AC98A, "bamboo_03_start" },
    { 0x6DD5F3F3, "bamf" },
    { 0x9F9B11EC, "bamfafterjuke" },
    { 0x5CA2836D, "bamfing" },
    { 0x7C633CEC, "ban" },
    { 0x7AACCA0A, "banallowance" },
    { 0xE3411680, "band" },
    { 0x1895F781, "bandage" },
    { 0x0E0C7117, "bandaged" },
    { 0x6BFBB0DA, "bandaid" },
    { 0x997A0576, "bandana" },
    { 0x8FF24C98, "banding" },
    { 0x529368AB, "bands" },
    { 0xE4895984, "bandwidth" },
    { 0x554885BB, "bang" },
    { 0x99214430, "banged" },
    { 0xD1DEDDCE, "bangin" },
    { 0x622DE7A5, "banging" },
    { 0x6D5A3715, "banging_on_door_audio" },
    { 0x142F9372, "bangladesh" },
    { 0x8254A65A, "bangs" },
    { 0xF51A07CD, "banister" },
    { 0x1D6642A7, "bank" },
    { 0x2920190C, "bank1" },
    { 0x9B278847, "bank2" },
    { 0xB16BF711, "bank_account_increment" },
    { 0x8335035C, "bank_account_max" },
    { 0x58A1CE53, "bank_account_value_end" },
    { 0xA2C87E80, "bank_account_value_start" },
    { 0x6B806F9D, "bank_collapse_rumble" },
    { 0xEE8CD244, "bank_collapse_shake" },
    { 0xDF6B02E6, "bank_deposit_box" },
    { 0x9AC59F83, "bank_deposit_box_think" },
    { 0xB6882E02, "bank_deposit_ddl_increment_amount" },
    { 0x65F6AA2A, "bank_deposit_max_amount" },
    { 0xEB6AF9CD, "bank_deposit_unitrigger" },
    { 0x5F1A08A7, "bank_drone_death_watch" },
    { 0x6A4F36FF, "bank_pap_hint" },
    { 0x1FE6F2F4, "bank_teller_dmg_trig" },
    { 0x1E058C9B, "bank_teller_give_money" },
    { 0x59CD6D83, "bank_teller_init" },
    { 0xAB12F791, "bank_teller_logic" },
    { 0xEC6D2D8A, "bank_teller_powerup_spot" },
    { 0x651670AD, "bank_teller_transfer_trig" },
    { 0xD79E503A, "bank_teller_used" },
    { 0x7BEA9A57, "bank_transfer" },
    { 0x7AF9AB38, "bank_unitrigger" },
    { 0x62EB98B9, "bank_withdraw_unitrigger" },
    { 0x8F9B64D3, "bank_withdrawal" },
    { 0x44D7DD9C, "bank_withdrawal_total" },
    { 0xD329AA79, "banking" },
    { 0x031CD2FB, "banking_and_weapon_locker_main" },
    { 0x8B4CDBCE, "banking_map" },
    { 0x46C355C1, "banking_update_enabled" },
    { 0xF5C3A81E, "banks" },
    { 0x81029D2D, "banned" },
    { 0x332818A7, "banned_attachment" },
    { 0x95254EEB, "banner" },
    { 0x7A960FCA, "banners" },
    { 0xC68750D6, "banning" },
    { 0xEF928F5D, "bansai" },
    { 0xAE88999C, "bansais" },
    { 0x3219C6E8, "banzai" },
    { 0x96099C16, "banzai_ai_anim_index" },
    { 0x112A1A9B, "banzai_ai_attacker_unlink_on_interrupt" },
    { 0xDD9D3A1D, "banzai_ai_attacker_unlink_on_time" },
    { 0x061A27F6, "banzai_ai_attacker_unlinked_on_interrupt" },
    { 0x53CD1FF2, "banzai_ai_attacker_unlinked_on_time" },
    { 0x2844D8FC, "banzai_ai_defender_link" },
    { 0x12A5B1D3, "banzai_ai_defender_unlink_on_interrupt" },
    { 0x97B40D25, "banzai_ai_defender_unlink_on_time" },
    { 0x47E69DCE, "banzai_ai_defender_unlinked_on_interrupt" },
    { 0x5CB09F1A, "banzai_ai_defender_unlinked_on_time" },
    { 0x8B977A77, "banzai_announce_ended" },
    { 0xEB4B0FD7, "banzai_announcing" },
    { 0x297FA727, "banzai_attack" },
    { 0xD7CDE17D, "banzai_attack_player" },
    { 0x20BFE8C0, "banzai_attacked_by" },
    { 0xB618C68A, "banzai_attacks_player" },
    { 0xBD424CC3, "banzai_charge" },
    { 0xEA3D9F34, "banzai_charge_yell" },
    { 0x907D5686, "banzai_complete" },
    { 0x0C273CB6, "banzai_death_thread" },
    { 0xF02FF80D, "banzai_deathquote" },
    { 0x5A836EA8, "banzai_debug" },
    { 0x50E79C89, "banzai_dialogue" },
    { 0x525BBC61, "banzai_easy" },
    { 0xBFEEA3FC, "banzai_enemy_set" },
    { 0xA57355CE, "banzai_exposed_monitor" },
    { 0xFBC1242C, "banzai_force" },
    { 0x3A836455, "banzai_grenadesuicide" },
    { 0xD51EEC3B, "banzai_guys" },
    { 0x78DF18F8, "banzai_ignoreme_monitor" },
    { 0xF7F75F6A, "banzai_init_anims" },
    { 0xA1E23818, "banzai_init_player_anims" },
    { 0x1F663D48, "banzai_interrupted_death" },
    { 0x9AE7A7D2, "banzai_last_stand" },
    { 0x9DCDD0AB, "banzai_link_distance" },
    { 0x711C56B9, "banzai_link_time" },
    { 0x2708A7D2, "banzai_melee_ai_seq" },
    { 0x2F5CD274, "banzai_melee_ended_on_time" },
    { 0x74AEA7CA, "banzai_melee_interrupted" },
    { 0xAD744DD3, "banzai_meleeseq_ai_attacker" },
    { 0x7C0B3258, "banzai_meleeseq_ai_death" },
    { 0xBF6B2033, "banzai_meleeseq_ai_defender" },
    { 0xBC8D6CB6, "banzai_meleeseq_ai_stab" },
    { 0xC8F5E452, "banzai_meleeseq_player" },
    { 0x354371C0, "banzai_meleeseq_player_attacker" },
    { 0xC0268942, "banzai_new_enemy" },
    { 0x72940C52, "banzai_no_wait" },
    { 0x1A961378, "banzai_print" },
    { 0xDA4BE851, "banzai_pump" },
    { 0x8C028893, "banzai_pump_up" },
    { 0x9ADD7A5E, "banzai_run" },
    { 0xA4D9EB34, "banzai_run_anim_setup" },
    { 0x21DEE6C1, "banzai_runs" },
    { 0xA1598AB8, "banzai_set_enemy" },
    { 0x0347FFC3, "banzai_thread" },
    { 0x303D3132, "banzai_unlink_time" },
    { 0x23495DC0, "banzai_wait" },
    { 0x934C7C8D, "banzai_wave_think" },
    { 0xB5235BA0, "banzai_yell_ended" },
    { 0x3EECA3EF, "banzai_yelling" },
    { 0x0EA7C1C0, "banzaiattackchance" },
    { 0x16A9D950, "banzaiattackedtooearly" },
    { 0x11A135DF, "banzaiattackedtoolate" },
    { 0x82ADA400, "banzaiattackers" },
    { 0x89452E75, "banzaideathhint" },
    { 0x49E09DCB, "banzaidecidewhatandhowtoshoot" },
    { 0x2D8B8BF8, "banzaidefenseweapon" },
    { 0x5239DDA2, "banzaihintelem" },
    { 0x7B94DEF9, "banzaii" },
    { 0x0C8F904E, "banzaiinterrupted" },
    { 0xF6B56E55, "banzaiinterruptedbydeath" },
    { 0x85786633, "banzaiinterruptedbykillanimscript" },
    { 0xB35D1BD5, "banzaiinterruptedbypain" },
    { 0x3E4EED3B, "banzaikilled" },
    { 0xE1DDF616, "banzaipos" },
    { 0xD560679A, "banzaishootwhilemoving" },
    { 0x71A4A8E1, "banzaivsplayerfovbuffer" },
    { 0x54BD628B, "banzi" },
    { 0x146D2690, "bar" },
    { 0xF39297F4, "bar_align_orgs" },
    { 0xC2F8BB01, "bar_amb" },
    { 0x56B18AFA, "bar_bend_left" },
    { 0x15E78CC9, "bar_bend_right" },
    { 0x4ECD944F, "bar_cardoor" },
    { 0x8F639A97, "bar_couch" },
    { 0xC2C541B4, "bar_couch_pos" },
    { 0x1A5D4BDA, "bar_couch_trigger" },
    { 0xDCE89A1F, "bar_difference_x" },
    { 0xB6E61FB6, "bar_difference_y" },
    { 0x5D1D8D73, "bar_door" },
    { 0xEB8A9472, "bar_door_think" },
    { 0xCD03FAE7, "bar_exit" },
    { 0xDAF3D01D, "bar_exploder1" },
    { 0x00F64A86, "bar_exploder2" },
    { 0x26F8C4EF, "bar_exploder3" },
    { 0xBD024321, "bar_fans" },
    { 0x75D5D85B, "bar_fight_cover_spawn" },
    { 0x82CC998C, "bar_fight_headshot" },
    { 0x7760FFBB, "bar_fight_spawn_back" },
    { 0x9E242496, "bar_fight_spawn_cover_guys" },
    { 0xCE7838BC, "bar_fight_spawn_fore" },
    { 0x80380140, "bar_fight_spawn_mid" },
    { 0xBDB06FF1, "bar_fight_spawn_wave" },
    { 0xA7111191, "bar_fight_waves_think" },
    { 0xBFA8E6D1, "bar_glass_visibility_think" },
    { 0x1E568BBE, "bar_height" },
    { 0xA232D227, "bar_length" },
    { 0x772C276B, "bar_map" },
    { 0xBBCA6906, "bar_repair_bend_left" },
    { 0xCA8C041D, "bar_repair_bend_right" },
    { 0x862AAF18, "bar_reset" },
    { 0x9BCE220B, "bar_scene_main" },
    { 0x150AC670, "bar_shader" },
    { 0x1B39F1A9, "bar_spawner_fix" },
    { 0xCE344A54, "bar_spawners" },
    { 0x6E46967E, "bar_start_xpos" },
    { 0xA4061749, "bar_start_ypos" },
    { 0xE3DBD70C, "bar_walla" },
    { 0xB565B605, "bar_width" },
    { 0x2BF84FB5, "barbed" },
    { 0xD3826030, "barbed_wire_clip" },
    { 0xCCFBD572, "barbed_wire_dialog" },
    { 0xC2C067F2, "barbed_wire_guys" },
    { 0x3C985B90, "barbed_wire_long" },
    { 0x4F73AFA1, "barbed_wire_scrunched" },
    { 0x8A5522DB, "barbeddets" },
    { 0x3041C2C0, "bardoor" },
    { 0x39543903, "bardoor_open" },
    { 0xB1184807, "bardoor_stop" },
    { 0x362F65DD, "bare" },
    { 0xE0F1F677, "barebones_amb" },
    { 0xC853508A, "barebones_anim" },
    { 0x1076C853, "barebones_fx" },
    { 0x2E868E94, "barechest" },
    { 0xE855FFE5, "barechest_guy1" },
    { 0x0E587A4E, "barechest_guy2" },
    { 0x18A28F01, "barelem" },
    { 0xD49F89FC, "barelembg" },
    { 0x85973C40, "barelemframe" },
    { 0x24BF3BE0, "barely" },
    { 0x91C907E0, "barfrac" },
    { 0x4E70E4E7, "barframe" },
    { 0x192E1B49, "bargain" },
    { 0xBBE44BFF, "bargaining" },
    { 0xA8707610, "barge" },
    { 0x0D57869D, "barge_angular_acc" },
    { 0xCBC38723, "barge_angular_velocity" },
    { 0xB5B494B3, "barge_audio" },
    { 0x38948B98, "barge_barrel_anims" },
    { 0x4DDB24F4, "barge_barrel_topple_watch" },
    { 0xF9327B1A, "barge_chase_boat_delete" },
    { 0x54B3AFB7, "barge_chase_boat_fire" },
    { 0x645A2B55, "barge_chase_boat_think" },
    { 0xBD85E807, "barge_chase_boats" },
    { 0x244C2866, "barge_clear_the_deck" },
    { 0x3FAAFA13, "barge_crates" },
    { 0x9671BF27, "barge_defend_attack_boats_think" },
    { 0xB3D4FC7E, "barge_defend_done" },
    { 0xF4E035F1, "barge_defend_main" },
    { 0x0ADCA6DD, "barge_defend_setup" },
    { 0x7E7E8DCE, "barge_defend_start" },
    { 0x575A7277, "barge_defend_wait_for_ai_dead" },
    { 0x3D8B5FD7, "barge_destroyed_anims" },
    { 0x21985AAF, "barge_fight_hudson" },
    { 0x71E02C79, "barge_intro_ai_fallback" },
    { 0x473EB539, "barge_intro_ai_think" },
    { 0x1DBEB28C, "barge_intruder_box" },
    { 0x396D1A85, "barge_intruder_box_cleanup" },
    { 0xA0E880A0, "barge_intruder_hide_marker_in_container" },
    { 0x4B056C12, "barge_knockoff_clear" },
    { 0x07C2C844, "barge_knockoff_watch" },
    { 0x5949AEC8, "barge_knockoff_watch_boat_ram" },
    { 0xCEB156D5, "barge_link_model" },
    { 0x36758973, "barge_origin_struct" },
    { 0xE0E5F59C, "barge_panel_anims" },
    { 0x8516EF2F, "barge_play_exhaust_fx" },
    { 0x4C5039C1, "barge_rear" },
    { 0x24DB62EE, "barge_sink" },
    { 0xB4DC2BEE, "barge_sink_sfx" },
    { 0x6E35193D, "barge_sound_cleanup" },
    { 0xA4F8C0D4, "barge_spawners" },
    { 0x33B78B50, "barge_water_left" },
    { 0x3E49347F, "barge_water_right" },
    { 0x8EBEFCEA, "barge_wave_amplitude" },
    { 0xC6247FDF, "barge_wave_frequency" },
    { 0xDF3B43C4, "barge_wheelhouse_destroyed" },
    { 0x0B38F0FB, "barges" },
    { 0x60932087, "barkchance" },
    { 0x0049FE4D, "barking" },
    { 0x8F4C6F5E, "barline" },
    { 0x8C45B38E, "barn" },
    { 0x80207ADE, "barn_abort_actors" },
    { 0xA85FFD74, "barn_array" },
    { 0x6CFD2FDE, "barn_axis" },
    { 0x79DFEA7F, "barn_close_rear_door" },
    { 0x83E8CA72, "barn_count" },
    { 0xA691BF62, "barn_door_kick" },
    { 0x9B10344A, "barn_door_kick_spawn" },
    { 0xC75FEE53, "barn_door_opened" },
    { 0x81CA0968, "barn_door_tank" },
    { 0xE3B30B28, "barn_door_tank_spawn" },
    { 0x48727560, "barn_early_interruption" },
    { 0xE1D638B6, "barn_early_interruption_price" },
    { 0x0034E247, "barn_fallback" },
    { 0xD74355E8, "barn_farmer" },
    { 0x295E5050, "barn_farmer_interrupt" },
    { 0x08B8F511, "barn_front_door" },
    { 0xBCC61245, "barn_hay_push_trigger" },
    { 0xD9AE5A1A, "barn_helidrop" },
    { 0x3A3694AA, "barn_interrogation" },
    { 0x2E9C85BE, "barn_interrogation_anim" },
    { 0x96B77800, "barn_interrogation_interruption" },
    { 0x07DC4D2E, "barn_interrogation_wait" },
    { 0xE016843D, "barn_kick_exit_done" },
    { 0x83215CE1, "barn_mark_moveup" },
    { 0x98ACBA89, "barn_price_dialogue" },
    { 0xE03615D3, "barn_price_move_to_door" },
    { 0xC8DB7EDB, "barn_price_moveup" },
    { 0x8E78DF9A, "barn_price_open_door" },
    { 0x21090953, "barn_price_wait_at_door" },
    { 0xA9947144, "barn_price_wait_at_door_idle" },
    { 0x9A0A9FCD, "barn_rail_push_trigger" },
    { 0xE46F91CA, "barn_rear_open" },
    { 0x7126FA86, "barn_russian_joke" },
    { 0xDCD82537, "barne" },
    { 0xA51D696E, "barnes" },
    { 0x624F0ECC, "barnes_attack_node" },
    { 0x5AB2995A, "barnes_change_behavior" },
    { 0x0578685F, "barnes_clear_all_anims" },
    { 0x18B45BD2, "barnes_enters_hut" },
    { 0x460DA4D7, "barnes_flinch" },
    { 0xFE9B776B, "barnes_follows_player" },
    { 0x629F1EDA, "barnes_get_in_out_water" },
    { 0xCB1676BC, "barnes_heli_node" },
    { 0x644D76A3, "barnes_hut_regroup_walk" },
    { 0xBD620322, "barnes_in_position_for_plunger" },
    { 0xC9746178, "barnes_intro_swim" },
    { 0x6A99486E, "barnes_kill_hut_vcs" },
    { 0x27CB65BE, "barnes_lines" },
    { 0xB8706C54, "barnes_model" },
    { 0x12D38415, "barnes_model_think" },
    { 0xF58BE358, "barnes_point_at_trig" },
    { 0x826B50ED, "barnes_pos" },
    { 0x2CA1F762, "barnes_reaching_for_plunger_anim" },
    { 0x3A35F1FD, "barnes_set_off_clearing" },
    { 0x2646C8A2, "barnes_shim_over_window" },
    { 0x2F28B877, "barnes_spawner" },
    { 0xB9B62CBA, "barnes_starts_swimming_early" },
    { 0x823499E5, "barnes_starts_window" },
    { 0x44EA8274, "barnes_swim_sampan_to_dock" },
    { 0x60DB6F5A, "barnes_swim_to_dock_done" },
    { 0xFEB588E3, "barnes_tells_player_to_ready_plunger" },
    { 0x490D9A9B, "barnes_water_idle" },
    { 0x58D38A69, "barnes_whizby_badass" },
    { 0x37D8F767, "barnhelidroptrig" },
    { 0x5FD210D3, "barnspawn" },
    { 0xC717E67D, "barpoints" },
    { 0x7F372948, "barracks" },
    { 0x49DEB506, "barracks_clear" },
    { 0x16BAB629, "barracks_dialogue" },
    { 0x0930D8FA, "barracks_response" },
    { 0xEA1AA0E0, "barracks_struct" },
    { 0xB74D09DB, "barrage" },
    { 0xC05AA8FA, "barrage_amount" },
    { 0x9B6F0B02, "barrage_charge_time" },
    { 0x66A96A6C, "barrage_max_delay" },
    { 0x16A4C20E, "barrage_min_delay" },
    { 0x700F3EFA, "barrages" },
    { 0x86BC9718, "barragesize" },
    { 0xAEAC9D3E, "barraging" },
    { 0x4B7B78DD, "barrel" },
    { 0xAAD3BD2E, "barrel1" },
    { 0xB11217AB, "barrel1_ai" },
    { 0x4A2F5C12, "barrel1_attach_left" },
    { 0xD6BF4D81, "barrel1_attach_right" },
    { 0xC8311FC8, "barrel1_detach_left" },
    { 0xF2184E17, "barrel1_detach_right" },
    { 0x81DBE042, "barrel1_left" },
    { 0xDEA430B1, "barrel1_right" },
    { 0x84D142C5, "barrel2" },
    { 0x82C49E32, "barrel2_ai" },
    { 0xE42974C9, "barrel2_attach_left" },
    { 0x7A362FF4, "barrel2_attach_right" },
    { 0x18181FC3, "barrel2_detach_left" },
    { 0xC2C080B6, "barrel2_detach_right" },
    { 0x214CB8BB, "barrel2_left" },
    { 0x0D55576E, "barrel2_right" },
    { 0x21D23F01, "barrel3_ai" },
    { 0x4F913A99, "barrel_01" },
    { 0x51EC7AC8, "barrel_01_start" },
    { 0x7593B502, "barrel_02" },
    { 0x9B962F6B, "barrel_03" },
    { 0xC198A9D4, "barrel_04" },
    { 0xE79B243D, "barrel_05" },
    { 0x54F3190F, "barrel_anim" },
    { 0x1A862B65, "barrel_blow_think" },
    { 0x490932E9, "barrel_bomb_think" },
    { 0x695ED562, "barrel_burst" },
    { 0x05B89E4C, "barrel_challenge_monitor" },
    { 0xB17DCEC4, "barrel_cleanup" },
    { 0x9D2CF55C, "barrel_counter" },
    { 0xEF9F17FA, "barrel_dead" },
    { 0xE00613AB, "barrel_destroy_think" },
    { 0xE521D435, "barrel_diff" },
    { 0x26D29FE4, "barrel_dropper" },
    { 0xE521BC4F, "barrel_earthquake" },
    { 0xF64E3A1F, "barrel_explode" },
    { 0x8DE1AC5C, "barrel_fire" },
    { 0x7CD42D63, "barrel_fwd" },
    { 0x5D4616CB, "barrel_instruction_done" },
    { 0xE4D6FA23, "barrel_killed" },
    { 0x0FF5A8CB, "barrel_linkto" },
    { 0x9F9BB556, "barrel_origin" },
    { 0x7E21F659, "barrel_pile1" },
    { 0xA42470C2, "barrel_pile2" },
    { 0x3321B63E, "barrel_pos" },
    { 0x86AF2837, "barrel_rolling" },
    { 0x1ABC77B3, "barrel_rolling_crash" },
    { 0x8BF2CC5E, "barrel_trig" },
    { 0x21781B39, "barrel_truck" },
    { 0x434B9723, "barrelang" },
    { 0xC64F53DD, "barrelangles" },
    { 0x0C82FCC2, "barrelburn" },
    { 0xAF673CD1, "barrelbuytrigger" },
    { 0xBBAF8AE8, "barrelexplodingthisframe" },
    { 0xF3FBF98F, "barrelexpsound" },
    { 0x5F92D9E1, "barrelfire" },
    { 0x24245E4B, "barrelhealth" },
    { 0xB08747D0, "barrelingsound" },
    { 0x9CF33E45, "barrelling" },
    { 0xCDC0E4D3, "barrelorigin" },
    { 0xAE9CF89D, "barrelpos" },
    { 0xDE302E1C, "barrels" },
    { 0x6778CB9D, "barrels_to_check" },
    { 0x975A4A04, "barrels_with_health" },
    { 0x7F8ECEA1, "barrelspawns" },
    { 0x27C60D8B, "barrelspin_end" },
    { 0x01A94E1E, "barrelspin_loop" },
    { 0x036724A8, "barrelspin_start" },
    { 0xA1AAA92B, "barrelthink" },
    { 0x67CF34EB, "barreltippeddown" },
    { 0x9E91EDD4, "barreltippedup" },
    { 0x8147667B, "barrett" },
    { 0x77385EAD, "barrett_hint" },
    { 0x8F570374, "barrett_intro" },
    { 0xFF887A56, "barrett_trigger" },
    { 0x9FBB23CA, "barricade" },
    { 0x8412C517, "barricade1" },
    { 0x5C21C8EF, "barricade_advance_chain" },
    { 0x79E12DA8, "barricade_assist" },
    { 0x1F11F192, "barricade_center" },
    { 0x84E0C09F, "barricade_collision" },
    { 0x49CF3BA9, "barricade_dist" },
    { 0x1608F1D5, "barricade_enter" },
    { 0xB496652B, "barricade_ents" },
    { 0x49DA5B49, "barricade_fight" },
    { 0x9B5CB922, "barricade_glitch_fix" },
    { 0x23272E8A, "barricade_id" },
    { 0x82F13363, "barricade_mg_l_death" },
    { 0xB5576FD7, "barricade_mg_l_monitor" },
    { 0x85631617, "barricade_mg_l_occupied" },
    { 0xDCC7A63D, "barricade_mg_owner" },
    { 0x1BC20B05, "barricade_mg_r_death" },
    { 0xD4128889, "barricade_mg_r_monitor" },
    { 0x4D597609, "barricade_mg_r_occupied" },
    { 0x5086E506, "barricade_mg_strat" },
    { 0x7727B477, "barricade_mortar1" },
    { 0x0520453C, "barricade_mortar2" },
    { 0x2B22BFA5, "barricade_mortar3" },
    { 0x5454DBAB, "barricade_nodes_thread" },
    { 0x23615AC3, "barricade_nosight" },
    { 0x3D8B149F, "barricade_right_array" },
    { 0x8A052935, "barricade_send_troops" },
    { 0xAB9CCB7F, "barricade_think" },
    { 0xDC083867, "barricade_troop_delete" },
    { 0xE540203A, "barricaded" },
    { 0x3995D9BE, "barricadeentermocompnozstart" },
    { 0x1E68F1DF, "barricadeentermocompnozterminate" },
    { 0x3EB7D151, "barricadeentermocompnozupdate" },
    { 0x6BBA3507, "barricadeentermocompstart" },
    { 0x3EC1DCD6, "barricadeentermocompterminate" },
    { 0x1EDE7552, "barricadeentermocompupdate" },
    { 0xB76F3605, "barricades" },
    { 0x37EBF120, "barricadetn" },
    { 0x58770C2A, "barrier" },
    { 0x3342F9F7, "barrier1" },
    { 0xC13B8ABC, "barrier2" },
    { 0xE6560F1B, "barrier_chunks" },
    { 0x1CDA9EB8, "barrier_name" },
    { 0xA99CF737, "barrier_origin" },
    { 0xEFD55A29, "barrier_pos" },
    { 0x285F98C3, "barrier_start" },
    { 0x0C912FD5, "barrier_test" },
    { 0x669F6AE5, "barriers" },
    { 0x4AB45BBA, "barriersearchoverride" },
    { 0x0CA249C0, "barriervalid" },
    { 0xB1B1231E, "barring" },
    { 0xD0CDE35B, "barrow_guy_death" },
    { 0xF3CE1937, "barry" },
    { 0xCA4C856E, "barrys" },
    { 0x32429BCA, "barryw" },
    { 0x8A02CA7B, "bars" },
    { 0x53C94AD2, "barsize_x" },
    { 0x79CBC53B, "barsize_y" },
    { 0x1271A30E, "bartender" },
    { 0xBE71C1B4, "barwidth" },
    { 0x480F2E88, "barx" },
    { 0x6E11A8F1, "bary" },
    { 0x3A6FA0F9, "bas" },
    { 0xA8728A16, "base" },
    { 0x7E9769D5, "base2_start" },
    { 0x4341D827, "base2_start_spawners" },
    { 0xA6153D3E, "base_1_gref_x" },
    { 0xCC17B7A7, "base_1_gref_y" },
    { 0x5A10486C, "base_1_gref_z" },
    { 0x7FDC9C68, "base_1_limpspeed" },
    { 0x28132403, "base_1_limpspeedsettime" },
    { 0x302C8E64, "base_1_limptime" },
    { 0x27CEC21D, "base_1_limptime_accel" },
    { 0x2A2AAE57, "base_1_limptime_deccel" },
    { 0x63CC2445, "base_1_waittime" },
    { 0x96B77757, "base_2_gref_x" },
    { 0x70B4FCEE, "base_2_gref_y" },
    { 0x4AB28285, "base_2_gref_z" },
    { 0x651C9087, "base_2_limpspeed" },
    { 0x28D3C6E6, "base_2_limpspeedsettime" },
    { 0x30790C41, "base_2_limptime" },
    { 0x32D2BF54, "base_2_limptime_accel" },
    { 0xCF4C3E04, "base_2_limptime_deccel" },
    { 0x2699B8BA, "base_2_waitttime" },
    { 0xFB2E260C, "base_3_gref_x" },
    { 0x2130A075, "base_3_gref_y" },
    { 0x47331ADE, "base_3_gref_z" },
    { 0x1A511526, "base_3_limpspeed" },
    { 0xC05FF2C9, "base_3_limpspeedsettime" },
    { 0x84EA6192, "base_3_limptime" },
    { 0x514996CF, "base_3_limptime_accel" },
    { 0xB3C3BA3D, "base_3_limptime_deccel" },
    { 0x7458462B, "base_3_waitttime" },
    { 0x7D7761E4, "base_3d_icon_update" },
    { 0x735705A9, "base_activity_anims" },
    { 0x9364EE87, "base_actual" },
    { 0x00FF86B4, "base_alarm" },
    { 0xFF3A89DA, "base_alarm_off" },
    { 0xF416ABA2, "base_alarm_vo" },
    { 0x1732EEA7, "base_alarms" },
    { 0x160D8011, "base_alert" },
    { 0x37AD53BE, "base_alerted" },
    { 0x29C78457, "base_amb" },
    { 0x5C4076F5, "base_angles" },
    { 0xCFE30DEA, "base_anim" },
    { 0x10E21477, "base_animname" },
    { 0xB9345EFB, "base_area_music_trigger" },
    { 0xB9D80188, "base_attack_air_wave" },
    { 0x98E988AF, "base_attack_btr_logic" },
    { 0x8F28363F, "base_attack_ground_wave" },
    { 0xFD410B90, "base_attack_hind_logic" },
    { 0x1178DE6D, "base_attack_manager" },
    { 0x91608189, "base_attack_objective" },
    { 0x6924C7C8, "base_attack_screen_message" },
    { 0xCDF3A774, "base_attack_spawn_btr" },
    { 0xCA744CDB, "base_attack_spawn_hind" },
    { 0x98773EB0, "base_attack_spawn_tank" },
    { 0xF236F9DB, "base_attack_tank_logic" },
    { 0x6AEC2B3A, "base_attacked" },
    { 0x6B8D575B, "base_attacker_label" },
    { 0x5A7EC2A8, "base_bg" },
    { 0x01FA3CAD, "base_circle" },
    { 0x85D27DA1, "base_cleaner" },
    { 0x7F54BFC3, "base_cleanup" },
    { 0x4F3B87A4, "base_console" },
    { 0x11E155AA, "base_cost" },
    { 0x25E92BF6, "base_cutoff" },
    { 0x2BB41482, "base_damage" },
    { 0xBF961BEA, "base_directory" },
    { 0x62899B66, "base_dmg_thresholds" },
    { 0xEE57E2A0, "base_drone_trigger" },
    { 0x408E89E6, "base_dub" },
    { 0x32B76126, "base_dvar" },
    { 0x0F791AB7, "base_end_angles" },
    { 0xD2F6CEF9, "base_enemy_accuracy" },
    { 0xC40A296F, "base_entrance" },
    { 0x1C922DA3, "base_entry" },
    { 0xA70FB6E2, "base_entry_lander_doors" },
    { 0x9AEFE3BF, "base_entry_lander_doors_only" },
    { 0x07D323B2, "base_exposure" },
    { 0xEC15271E, "base_field_chain_hookup" },
    { 0xF99DE7E5, "base_fight" },
    { 0x3F6D0FD9, "base_fight_dogs" },
    { 0x5EE9AD7A, "base_fillers" },
    { 0xB28CB9AF, "base_fire_damage" },
    { 0x85C33B40, "base_fires" },
    { 0x6DCAD26E, "base_flankers01" },
    { 0x719B39DB, "base_fog" },
    { 0x01BC3135, "base_fog_settings" },
    { 0x052F0C46, "base_force" },
    { 0x39329F2C, "base_forward" },
    { 0xABC06602, "base_fov" },
    { 0x95F5C00D, "base_frac" },
    { 0xF7F393B3, "base_fx" },
    { 0x5B428B5A, "base_fx_light" },
    { 0x13962629, "base_fx_on" },
    { 0xBF8530CD, "base_gravity" },
    { 0x80D2FF92, "base_guard_01" },
    { 0x5AD08529, "base_guard_02" },
    { 0xDA3E22F9, "base_guard_a01" },
    { 0x00409D62, "base_guard_a02" },
    { 0x264317CB, "base_guard_a03" },
    { 0x4C459234, "base_guard_a04" },
    { 0x72480C9D, "base_guard_a05" },
    { 0x984A8706, "base_guard_a06" },
    { 0xBE4D016F, "base_guard_a07" },
    { 0xE44F7BD8, "base_guard_a08" },
    { 0x0A51F641, "base_guard_a09" },
    { 0x32D30EBB, "base_guard_a10" },
    { 0x0CD09452, "base_guard_a11" },
    { 0xE6CE19E9, "base_guard_a12" },
    { 0xC0CB9F80, "base_guard_a13" },
    { 0x988AE14A, "base_guard_alerted_turn_1" },
    { 0x728866E1, "base_guard_alerted_turn_2" },
    { 0xF38B0784, "base_guard_anim" },
    { 0x27CC9F9A, "base_guard_anim_firstframe" },
    { 0x70341A8E, "base_guard_anim_playonce" },
    { 0x66EA4757, "base_guard_anim_reach_then_loop" },
    { 0x0455281C, "base_guard_anim_reach_then_playonce" },
    { 0x15EDE9B0, "base_guard_anim_single_then_loop" },
    { 0xC9AD3161, "base_guard_comms_door_1" },
    { 0xEFAFABCA, "base_guard_comms_door_2" },
    { 0x06A9C965, "base_guard_crate_idle" },
    { 0xE835C7E9, "base_guard_distraction_1" },
    { 0x0E384252, "base_guard_distraction_2" },
    { 0x96416D22, "base_guard_encounter" },
    { 0x9244D2D9, "base_guard_encounter_bowman" },
    { 0x10B76101, "base_guard_encounter_guard1" },
    { 0x36B9DB6A, "base_guard_encounter_guard2" },
    { 0x3CC64920, "base_guard_encounter_started" },
    { 0x25C39241, "base_guard_encounter_woods" },
    { 0xC56EBC59, "base_guard_idle_gate_1" },
    { 0xEB7136C2, "base_guard_idle_gate_2" },
    { 0x1173B12B, "base_guard_idle_gate_3" },
    { 0x42B3B636, "base_guard_idle_left_comm" },
    { 0x2D01F321, "base_guard_jeep_follow_1" },
    { 0x6E1EE0C1, "base_guard_jeep_follow_1b" },
    { 0x53046D8A, "base_guard_jeep_follow_2" },
    { 0x2EE162CC, "base_guard_jeep_follow_2b" },
    { 0x7906E7F3, "base_guard_jeep_follow_3" },
    { 0x8533657B, "base_guard_jeep_follow_3b" },
    { 0x9F09625C, "base_guard_jeep_follow_4" },
    { 0xC41A18C6, "base_guard_jeep_follow_4b" },
    { 0xC50BDCC5, "base_guard_jeep_follow_5" },
    { 0xEA58482D, "base_guard_jeep_follow_5b" },
    { 0xEB0E572E, "base_guard_jeep_follow_6" },
    { 0x293EFB78, "base_guard_jeep_follow_6b" },
    { 0xEA36C2FE, "base_guard_jeep_getout_1" },
    { 0xC4344895, "base_guard_jeep_getout_2" },
    { 0x1D3728F9, "base_guard_redirector_leftside_1" },
    { 0x4339A362, "base_guard_redirector_leftside_2" },
    { 0xACF1A085, "base_guard_run_left_comm_1" },
    { 0xD2F41AEE, "base_guard_run_left_comm_2" },
    { 0xF8F69557, "base_guard_run_left_comm_3" },
    { 0x24A8B8F8, "base_guard_run_rightside_1" },
    { 0x96B02833, "base_guard_run_rightside_2" },
    { 0x62178656, "base_guy" },
    { 0x290B6EDF, "base_guy_spawner" },
    { 0x5C6A4463, "base_handler" },
    { 0xCE3ACB38, "base_height" },
    { 0x95429DEE, "base_height_offset" },
    { 0xBD7DE859, "base_heli_01" },
    { 0xA5F67388, "base_heli_01_start" },
    { 0xE38062C2, "base_heli_02" },
    { 0xD83F7ECB, "base_heli_02_start" },
    { 0x0982DD2B, "base_heli_03" },
    { 0x7C68730E, "base_heli_03_start" },
    { 0x2F855794, "base_heli_04" },
    { 0xDB4BD201, "base_heli_04_start" },
    { 0x5587D1FD, "base_heli_05" },
    { 0xEC2DE184, "base_heli_05_start" },
    { 0x7B8A4C66, "base_heli_06" },
    { 0xEC3C10B7, "base_heli_06_start" },
    { 0xA18CC6CF, "base_heli_07" },
    { 0xB6C57BCA, "base_heli_07_start" },
    { 0xD1BE6A0A, "base_heli_onpad" },
    { 0x20DB31CD, "base_helicopters" },
    { 0xAA18DC61, "base_helicopters_in_distance" },
    { 0x1D347126, "base_helis_started" },
    { 0x4FB9A143, "base_horse_rideout" },
    { 0xA7EC829D, "base_if_not_upgraded" },
    { 0xEBB9C9A7, "base_impact" },
    { 0xC3412D1E, "base_impacts" },
    { 0x59E8227C, "base_intensity" },
    { 0x1119FF3D, "base_jeep_01" },
    { 0x75EB2AC4, "base_jeep_01_start" },
    { 0x371C79A6, "base_jeep_02" },
    { 0xBD648AF7, "base_jeep_02_start" },
    { 0x18DBFED8, "base_jeeps" },
    { 0xBAD48039, "base_jump" },
    { 0xB3BDB5FB, "base_jump_heartbeat_stop" },
    { 0xCC28F8D0, "base_jump_save_restore" },
    { 0x0D907B00, "base_jump_snapshot" },
    { 0x93A43F5F, "base_jump_timer" },
    { 0xB47FA4E8, "base_jumpto_avalanche" },
    { 0x774B0FE7, "base_jumpto_init" },
    { 0xC599E1BD, "base_jumpto_remove_harris" },
    { 0x585939FA, "base_jumpto_warehouse" },
    { 0x863B26B9, "base_last_bldg" },
    { 0x6B260305, "base_level" },
    { 0x517DC9B1, "base_level_name" },
    { 0x0799E7F2, "base_lights" },
    { 0xE2C50742, "base_main" },
    { 0xA939B5DB, "base_melee" },
    { 0x2952DDC0, "base_mig_01" },
    { 0x60537CF5, "base_mig_01_start" },
    { 0x9B5A4CFB, "base_mig_02" },
    { 0x5A10817E, "base_mig_02_start" },
    { 0x8FCC023D, "base_migs" },
    { 0xDBABA727, "base_migs_started" },
    { 0x0FA2B100, "base_nearest_node" },
    { 0x12DC1CC5, "base_neg" },
    { 0x903FB7ED, "base_number_of_effects" },
    { 0x71753A98, "base_objectives_cleanup" },
    { 0x7E7A64CC, "base_objectives_think" },
    { 0x0AF671DC, "base_occluder" },
    { 0xF621EA24, "base_offset" },
    { 0x40E35751, "base_org" },
    { 0x518DE66B, "base_origin" },
    { 0x4361569C, "base_points" },
    { 0x6777F4F5, "base_pos" },
    { 0x80DE12E8, "base_ref" },
    { 0x0D22F08C, "base_reinforcement" },
    { 0xAA788EE7, "base_reset_fog" },
    { 0xEAFBA607, "base_reset_patrol_flags" },
    { 0xEF7BDD5A, "base_reset_squad_ai" },
    { 0x4D5DD8A9, "base_right" },
    { 0xE81870F1, "base_score" },
    { 0xA7C88B8A, "base_secure" },
    { 0x1D63D4CF, "base_shake_icon" },
    { 0x4FB32785, "base_skipto_avalanche" },
    { 0x68F5E1F7, "base_skipto_warehouse" },
    { 0x8AD54C7C, "base_sounds_upper" },
    { 0xB2588226, "base_speed" },
    { 0x63A3C9C7, "base_squad_behave_at_landing" },
    { 0x88A122C7, "base_start" },
    { 0x355F389E, "base_start_angles" },
    { 0x178A131C, "base_start_idle_a" },
    { 0x89918257, "base_start_idle_b" },
    { 0x77206C4D, "base_start_spawners" },
    { 0x0FA066EF, "base_stat_name" },
    { 0xA3D32535, "base_stinger" },
    { 0x5A042AB3, "base_streak" },
    { 0x8E7B8BC2, "base_struct" },
    { 0x89BBB25E, "base_tag_angles" },
    { 0xDD11464E, "base_target" },
    { 0x4A19D30D, "base_target_pos" },
    { 0x4DFBB8D2, "base_team" },
    { 0xF65D6092, "base_time" },
    { 0xA4183BDA, "base_time_bonus" },
    { 0x2B32BAFE, "base_tint" },
    { 0x2FAF7DC3, "base_to_second_squad_handler" },
    { 0x895B0B62, "base_total_health" },
    { 0x9ADF4136, "base_tower_explode" },
    { 0x6614F27F, "base_tower_guys" },
    { 0xEF7A94E7, "base_track_health" },
    { 0x7D043BF5, "base_track_mortar_fire" },
    { 0x2914BCA4, "base_truck_01" },
    { 0x9B1C2BDF, "base_truck_02" },
    { 0x7519B176, "base_truck_03" },
    { 0xB70D4D69, "base_truck_04" },
    { 0x9108BE00, "base_under_attack" },
    { 0x98F9D946, "base_up" },
    { 0x9A99CA5E, "base_update_icon" },
    { 0xD71E5473, "base_visionset" },
    { 0x72DA7D7F, "base_visionset_in" },
    { 0xEC862AAA, "base_visionset_out" },
    { 0xDC24389F, "base_visionset_triggerin" },
    { 0x4C36584A, "base_visionset_triggerout" },
    { 0x20DBEC98, "base_vol" },
    { 0xB83E5BD6, "base_walk" },
    { 0x25890702, "base_wall_destroy" },
    { 0xB5348C2A, "base_wall_hide_destroyed_state" },
    { 0x6DEC36A5, "base_walla_audio" },
    { 0xB2C2D57B, "base_watcher" },
    { 0xE08344C7, "base_wave_cleared" },
    { 0xAE1F4067, "base_weapname" },
    { 0xE32A2875, "base_weapon" },
    { 0x8A0CB720, "base_weapon_check" },
    { 0xFC8A08AB, "base_weapon_param" },
    { 0xB811740B, "base_weapon_param_name" },
    { 0x6B28638C, "base_weapon_slot" },
    { 0xC1A4F1FC, "base_weaponname" },
    { 0xFF6E11B0, "base_white" },
    { 0x9FC51127, "base_x" },
    { 0xD8CC1A6D, "baseaccuracy" },
    { 0x75BDB5BE, "basealpha" },
    { 0x10EB0CD2, "baseang" },
    { 0x69992842, "baseangles" },
    { 0x6626AC31, "baseanim" },
    { 0xDA2B2B3A, "basecleaned" },
    { 0x1A09FD26, "based" },
    { 0x81B61A97, "basedeathmodel" },
    { 0x7A67EA0B, "basediff" },
    { 0xD9A114AA, "baseduration" },
    { 0xE3FEB88D, "baseeffect" },
    { 0xAA609D64, "baseeffectforward" },
    { 0x422676AD, "baseeffectpos" },
    { 0xF56C5AB1, "baseeffectright" },
    { 0x5E4EF843, "baseendremotecontrolweaponuse" },
    { 0x2F590A6B, "baseentry_status" },
    { 0xC7CB68C2, "basefield" },
    { 0xA6A7D824, "baseflag" },
    { 0xB9376D81, "basefontscale" },
    { 0xDFA4F357, "basefov" },
    { 0x6B87A20F, "basegain" },
    { 0xF16B8FEF, "baseguy" },
    { 0x66E87833, "baseheight" },
    { 0x8933F36C, "baseheight_new" },
    { 0x7862BEC2, "baseindoors" },
    { 0xEDE2DE7E, "basejump" },
    { 0xF884846C, "basejump_branch_breaks" },
    { 0xFBE3544D, "basejump_force_player_landing_spot" },
    { 0xB63773BC, "basejump_functions" },
    { 0x71B7589A, "basejump_main" },
    { 0xC1D81E20, "basejump_stylized_start" },
    { 0x6295D209, "basejump_toolate" },
    { 0x9D838F0A, "basejustlost" },
    { 0x70A7A5C0, "baseline" },
    { 0x562564FF, "baseloss" },
    { 0x101A9066, "basement" },
    { 0x199B7507, "basement_allies" },
    { 0x54DF30BD, "basement_door_sound" },
    { 0x5CD147E5, "basement_flash" },
    { 0x67C9CD32, "basement_helicopter" },
    { 0xA035B4C0, "basement_price" },
    { 0x322A34B7, "basement_start" },
    { 0xAA93599D, "basement_start_spawners" },
    { 0x0C9967E1, "basement_to_house1_handler" },
    { 0x0F7422D4, "basement_trim_field" },
    { 0x5B08685B, "basename" },
    { 0x9AC3DD0F, "baseoffset" },
    { 0xFD9DA888, "baseorg" },
    { 0xF5CC4B9C, "baseorigin" },
    { 0x9D9B6351, "baseoutdoors" },
    { 0xE79C0D56, "baseperkindex" },
    { 0x425F56AE, "baseplate" },
    { 0x9059E715, "basepose" },
    { 0x9AE7B0D7, "baseposition" },
    { 0x2ADB9DE1, "baseref" },
    { 0xFBD5F289, "bases" },
    { 0x84704BEE, "baseshaderconstindex" },
    { 0xAB1CBF9F, "basespeed" },
    { 0x1A59605A, "basespeed_tweak" },
    { 0x502E4D63, "basespeedscale" },
    { 0x0D15B6E9, "basetime" },
    { 0x2FA067B6, "baseweapon" },
    { 0xE0F5A032, "baseweaponindex" },
    { 0x1B4DA44D, "baseweaponitemindex" },
    { 0xBE9856FB, "baseweaponname" },
    { 0xF284C119, "baseweaponparam" },
    { 0x77EEBAA3, "basey" },
    { 0x9C85EBD9, "basezheight" },
    { 0x667EEE23, "bash" },
    { 0x1CD1FEB1, "bash_door_pdf" },
    { 0xEBFB80FE, "bash_spot" },
    { 0xF37C9D23, "bashable" },
    { 0x57A24118, "bashed" },
    { 0xDDE2E5F3, "basher1" },
    { 0x6BDB76B8, "basher2" },
    { 0xDC238505, "bashtrig" },
    { 0x58D59AC5, "basic" },
    { 0x19BF4894, "basic_fire" },
    { 0xFE5263BC, "basic_player_connect" },
    { 0xE3E4E18C, "basic_training_auto_assign" },
    { 0x5EB9E904, "basic_zombie_thundergun_knockdown" },
    { 0xD2F3AAB3, "basically" },
    { 0xCB138E54, "basics" },
    { 0x6AB56370, "basin" },
    { 0x80C6214D, "basin_battle" },
    { 0x7573A7A5, "basin_friendly_strat" },
    { 0x3875C424, "basin_tank_chains" },
    { 0x25D000C2, "basin_tank_chains_skip" },
    { 0xB54D950F, "basing" },
    { 0xF8ADF435, "basis" },
    { 0xEE4B42C8, "basketball_courtmg" },
    { 0x248B5230, "bass" },
    { 0xC3A5A67E, "bastard" },
    { 0xF59AF761, "bastards" },
    { 0xF87C0506, "bat" },
    { 0x010327B3, "batch" },
    { 0xD21C844F, "bathroom" },
    { 0xF8C2A776, "bathroom_ambush" },
    { 0x0EEF31A1, "bathroom_door_open" },
    { 0x4C26C090, "bathroom_flush" },
    { 0xAA29EC7E, "bathroom_mg" },
    { 0x17154229, "bathroom_mg_exploder_200" },
    { 0x90634B01, "baton" },
    { 0x3B7B0253, "baton_guard" },
    { 0xCCE5DCF5, "baton_guard_drop_baton_on_death" },
    { 0x0B48016F, "baton_guard_get_closer_if_melee_blocked" },
    { 0xAD2A1AFB, "baton_guard_hunt_immediately_behavior" },
    { 0x06C90648, "baton_guard_spawned" },
    { 0x114C19E8, "batonmodel" },
    { 0x63429599, "batphones" },
    { 0x2BB061B9, "bats" },
    { 0x5804CAB0, "batteries" },
    { 0x8917348C, "battery" },
    { 0x1F80F107, "battle" },
    { 0x8CBCECBF, "battle1_start_time" },
    { 0xA60F5A91, "battle2_wave1_dialog" },
    { 0x9C479E6D, "battle_advancer_high" },
    { 0xE2A494D9, "battle_advancer_low" },
    { 0x2B64C5FE, "battle_cry" },
    { 0x2215ADB8, "battle_cry2" },
    { 0xB50E6359, "battle_field_effects" },
    { 0x54162316, "battle_flow" },
    { 0x24E87562, "battle_high" },
    { 0x2AC9E035, "battle_line_ambient_sound" },
    { 0x8B738EB4, "battle_low" },
    { 0x74BA58ED, "battle_on" },
    { 0x745B8797, "battle_radio" },
    { 0xA0496540, "battle_radio_origin" },
    { 0x23B997A8, "battle_radio_trig" },
    { 0xFF0CA17B, "battle_sam_context" },
    { 0x92640DF1, "battle_silent_context" },
    { 0xCBB31F3E, "battle_smoke_heavy_pos" },
    { 0xDC42E42E, "battle_smoke_pos" },
    { 0xEA3F60B2, "battle_start" },
    { 0x3F94D8AC, "battle_think_claw" },
    { 0xED3907B6, "battle_through_heat_area" },
    { 0x953AB14D, "battle_time" },
    { 0x9EF6076C, "battle_walla_loop" },
    { 0x76D95162, "battlechatter" },
    { 0xD53FDB6F, "battlechatter_ai" },
    { 0x3C68F922, "battlechatter_canprint" },
    { 0x486DDDEF, "battlechatter_init" },
    { 0x04A6C278, "battlechatter_off" },
    { 0x6BAC0732, "battlechatter_on" },
    { 0xB5DF40AE, "battlechatter_print" },
    { 0x3755EC4C, "battlechatter_println" },
    { 0x2E5D2C35, "battlechatter_trigger_on" },
    { 0xC50D32FD, "battlefield" },
    { 0x728F7049, "battlehere" },
    { 0x25258EFE, "battles" },
    { 0xC70DD415, "battleship" },
    { 0x7240B30D, "battleship_artillery_fire" },
    { 0xE5E56556, "battleship_firing_states" },
    { 0x5DE51464, "battleships" },
    { 0x3674EC01, "battletrigger" },
    { 0xFCFDE542, "battling" },
    { 0x1CBC91C7, "batttle" },
    { 0xB6886913, "bay" },
    { 0xFB980257, "bayonet" },
    { 0x06C34B6D, "bayonet_array" },
    { 0xADC51D0E, "bayonets" },
    { 0xEFB8B901, "bayonett" },
    { 0xFFE4DCCC, "bayonette_killer" },
    { 0xFFAE4351, "bayonettes" },
    { 0x32D57142, "bays" },
    { 0xE04A685E, "bazooka" },
    { 0x35316039, "bazooka_lookat_touching" },
    { 0x2CF72CDF, "bazooka_respawn" },
    { 0x78FF51A2, "bazooka_respawner" },
    { 0xE493744B, "bazooka_spawn_think" },
    { 0xA23B3DC7, "bazooka_spawner" },
    { 0x91FDF31A, "bazooka_special" },
    { 0xB566932D, "bazooka_special_strat" },
    { 0x3BF34109, "bazooka_strat" },
    { 0xB2DB11AA, "bazooka_team" },
    { 0xBC6A3B07, "bazooka_team_init" },
    { 0x6C5990C1, "bazookas" },
    { 0x016FE730, "bazookateam_fire" },
    { 0x73290AA0, "bazookateam_foyer_damage_done" },
    { 0xD8129FDD, "bb" },
    { 0xCE1B8053, "bb_actorgetdamagelocation" },
    { 0x1A57D1C4, "bb_actorgetenemyyaw" },
    { 0x3469DAC7, "bb_actorgetfataldamagelocation" },
    { 0x71B48599, "bb_actorgetperfectenemyyaw" },
    { 0x5EC90363, "bb_actorgetreactyaw" },
    { 0x0A15D018, "bb_actorgettrackingturnyaw" },
    { 0x47E1034F, "bb_actorhasenemy" },
    { 0x79E8207B, "bb_actorispatroling" },
    { 0x4E59E46B, "bb_doors" },
    { 0x7D1A42CF, "bb_escape_ison" },
    { 0x136BC7F4, "bb_getarmsposition" },
    { 0x626C1913, "bb_getarrivalstance" },
    { 0xECB757B3, "bb_getarrivaltype" },
    { 0x829967CB, "bb_getawareness" },
    { 0xD70B98E4, "bb_getawarenessprevious" },
    { 0xF0CE7AA3, "bb_getcoverconcealed" },
    { 0x029705F9, "bb_getcoverflankability" },
    { 0xD8F8F2F8, "bb_getcurrentcovernodetype" },
    { 0x64AD80C5, "bb_getcurrentexposedtype" },
    { 0x0A4ECEF3, "bb_getcurrentlocationcovernodetype" },
    { 0xE03ACC06, "bb_getdamagedirection" },
    { 0x9BB9EA41, "bb_getdamagemod" },
    { 0xEB376700, "bb_getdamagetaken" },
    { 0x21BD4F2B, "bb_getdamageweapon" },
    { 0x5B9C35E9, "bb_getdamageweaponclass" },
    { 0xFBF2A4B9, "bb_gethaslegsstatus" },
    { 0xF9336D60, "bb_gethigheststance" },
    { 0xAC5063AB, "bb_getlocomotionarrivaldistance" },
    { 0x79F0992F, "bb_getlocomotionarrivalyaw" },
    { 0x6F6AC468, "bb_getlocomotionexityaw" },
    { 0x21AF5578, "bb_getlocomotionfaceenemyquadrant" },
    { 0xB5F4E1D7, "bb_getlocomotionfaceenemyquadrantprevious" },
    { 0xDC84237A, "bb_getlocomotionmotionangle" },
    { 0x2275B620, "bb_getlocomotionmovementtype" },
    { 0x4FA36CD7, "bb_getlocomotionpaintype" },
    { 0xF8AE4008, "bb_getlocomotionspeedtype" },
    { 0x2F50FCA7, "bb_getlocomotionturnyaw" },
    { 0xE0139BA5, "bb_getlookaheadangle" },
    { 0xCC844A2F, "bb_getlowgravityvariant" },
    { 0xE0BE6CD5, "bb_getpanic" },
    { 0x16D1EC70, "bb_getpreviouscovernodetype" },
    { 0x0B361725, "bb_getshouldhowlstatus" },
    { 0xFFCA9C96, "bb_getshouldrunstatus" },
    { 0x6DA8B16C, "bb_getshouldturn" },
    { 0xCCCE3B25, "bb_getspeed" },
    { 0x74E86F38, "bb_getstairsnumskipsteps" },
    { 0x19576889, "bb_gettacticalarrivalfacingyaw" },
    { 0x40FF213F, "bb_getvarianttype" },
    { 0x0D4A6CB8, "bb_getweaponclass" },
    { 0xA9E1EEEB, "bb_getyawtocovernode" },
    { 0x0D0D3DD9, "bb_idgungetdamagedirection" },
    { 0x8CC2CCEF, "bb_jumpout_spot" },
    { 0x7EC2FB13, "bb_opendoors" },
    { 0x7DDFC91A, "bb_register_attribute" },
    { 0x7269B618, "bb_sdk_own_wall" },
    { 0x35947F44, "bb_sequence_over" },
    { 0x70E7E7B7, "bb_shared" },
    { 0x5AB7F621, "bb_stairtop_scare" },
    { 0xA5BCC6A7, "bb_street_setup" },
    { 0xD3F5783E, "bb_vehgetenemyyaw" },
    { 0xE2DCF6DF, "bbaddtostat" },
    { 0x0D9A8ED6, "bbarnes" },
    { 0x28DB576F, "bbc_voice" },
    { 0xEBD715F6, "bbclasschoice" },
    { 0x42C17516, "bbeam_nodes" },
    { 0x4A73BFBD, "bbgameover" },
    { 0x79E49EDB, "bbl" },
    { 0x0EE01B9C, "bbplayermatchend" },
    { 0x91E6C614, "bbpostdemostreamstatsforround" },
    { 0x3AEDD0A2, "bbprint" },
    { 0x56250D85, "bbr" },
    { 0xAF22D967, "bbraking" },
    { 0x9CDEB396, "bbvi0" },
    { 0xB2102574, "bc" },
    { 0xAA07164C, "bc_interrupt" },
    { 0xCA1547B3, "bcallykillprobability" },
    { 0x1E47348D, "bcansprint" },
    { 0x455AE9DB, "bcanstartsprint" },
    { 0x74879A79, "bccallcount" },
    { 0x4A9F2634, "bccalling" },
    { 0x62ED305B, "bccallouttime" },
    { 0xDA8B59F3, "bccansay" },
    { 0x5B289066, "bccycle" },
    { 0x06FC701E, "bcdrawobjects" },
    { 0x1C628BBD, "bcfrienddeathtime" },
    { 0x8C57E787, "bcgetclaimednode" },
    { 0x1DF0A831, "bcgetname" },
    { 0x8378DCFA, "bcglobalprobability" },
    { 0xB643C970, "bcharging" },
    { 0x930222A9, "bchistorycount" },
    { 0x4DEE0798, "bchistoryindex" },
    { 0x153FF4F2, "bchistoryphrases" },
    { 0xFB843CEE, "bchistorytimes" },
    { 0x6682F2EB, "bcincominggrenadeprobability" },
    { 0x7346964D, "bcissniper" },
    { 0xC3790318, "bckillinformprobability" },
    { 0x26B4C703, "bckillstreakincomingprobability" },
    { 0x57D2BF97, "bckilltime" },
    { 0xB2D19AF1, "bclaststanddelay" },
    { 0xA4DE7227, "bclearanim" },
    { 0xA49D87CB, "bcmain" },
    { 0x7671D1CC, "bcmp_breathing_delay" },
    { 0xDFAA49D8, "bcmp_breathing_probability" },
    { 0xB6432BC3, "bcmp_enemy_contact_delay" },
    { 0x9E176EF4, "bcmp_enemy_contact_level_delay" },
    { 0x4D977A95, "bcname" },
    { 0x89F4DC63, "bcnoticetime" },
    { 0x1000C5C3, "bconfirelastsaytime" },
    { 0x8900388F, "bconfireorg" },
    { 0xF71D34B0, "bconfiretime" },
    { 0x8AF9E8BF, "bcordermodifier" },
    { 0x3FEBE82F, "bcordertime" },
    { 0x89145D74, "bcordertype" },
    { 0x859C6FE9, "bcpaindelay" },
    { 0x5BECCAC2, "bcpainsmallprobability" },
    { 0x09CA938D, "bcperkcallprobability" },
    { 0x6C282589, "bcplayphrase" },
    { 0x42F23756, "bcrank" },
    { 0x8836E568, "bcreloadtime" },
    { 0x959A0B67, "bcs" },
    { 0x6992B17C, "bcs_disabler" },
    { 0xB49D5D32, "bcs_minpriority" },
    { 0x8CEEF766, "bcs_portable_turret_setup" },
    { 0xD06B762E, "bcsdebugwaiter" },
    { 0xAFC685B2, "bcsenabled" },
    { 0xF5569D66, "bcsniperkillprobability" },
    { 0xDB18D4F0, "bcsounds" },
    { 0x4980B8CF, "bcsurpressedtime" },
    { 0xB22CD158, "bcsvgened" },
    { 0xC62DDEEC, "bcthread" },
    { 0xA8CCF32B, "bcthreatplayer" },
    { 0xB7BB944B, "bcthrewgrenadetime" },
    { 0x3BAF8B8A, "bctossgrenadeprobability" },
    { 0x28CBCF5C, "bctosstrophyprobability" },
    { 0xC9AFD7E0, "bctrigger" },
    { 0x273D3E89, "bcvoicenumber" },
    { 0x6A18D73D, "bcweapondelay" },
    { 0xE8EEF181, "bcweaponfireprobability" },
    { 0xF79D56D9, "bcweaponfirethreatprobability" },
    { 0x98D7BE54, "bcweaponreloadprobability" },
    { 0x8C0DAB0B, "bd" },
    { 0x44795B53, "bd01_spawner" },
    { 0x1ED11508, "bda" },
    { 0xAB62897B, "bda_dialog" },
    { 0xD1771528, "bdadialog" },
    { 0x1A1A27C1, "bdeath" },
    { 0x39B970F9, "bdestinfov" },
    { 0x0728576D, "bdodamage" },
    { 0x3FAD715D, "bdog" },
    { 0x94475AAE, "bdog_die_explosion" },
    { 0x4CB11274, "bdog_muzzle_flash" },
    { 0xC8DA5F9C, "bdogs" },
    { 0xCB45764E, "bdontlinkonmigrate" },
    { 0xC093FE79, "bdontunlinkonmigrate" },
    { 0x660B30A2, "be" },
    { 0xFCD3E3F2, "be2_tp_done" },
    { 0xBA1A1D8A, "be2_validation" },
    { 0x720887C8, "be_c" },
    { 0xD9FE9E24, "be_o" },
    { 0xF8879F31, "be_stage_one_over" },
    { 0x05A1A814, "be_stupid" },
    { 0xD9AA6F7A, "beach" },
    { 0xE5D504DA, "beach_contextual_guard" },
    { 0x861C93ED, "beach_dialog" },
    { 0x1B85DC1F, "beach_fail_condition" },
    { 0x0F2A9B21, "beach_kill_vo" },
    { 0x645CA366, "beach_main" },
    { 0x4A352EA2, "beach_vehicles" },
    { 0x4B16797E, "beach_vehicles_size" },
    { 0x9784CB50, "beach_walk_speed_adjustment" },
    { 0xC217AD73, "beachdrones" },
    { 0x388D5C0D, "beached" },
    { 0xF29BEA17, "beachstealth" },
    { 0x6AF47321, "beacon" },
    { 0x7F5C914E, "beacon_attract_dist" },
    { 0x39ECF97C, "beacon_attract_dist_diff" },
    { 0xB38DBB5E, "beacon_blown_up" },
    { 0x4B01A0E0, "beacon_cleanup" },
    { 0x9786FB0E, "beacon_clone_weapon" },
    { 0xC259064E, "beacon_dual_view" },
    { 0xD0A6C1D4, "beacon_exists" },
    { 0xF26B4518, "beacon_index" },
    { 0xB8437D8E, "beacon_missile_launch" },
    { 0xB2A41B5B, "beacon_placed" },
    { 0x6F30A518, "beacon_planted" },
    { 0x4249DA41, "beacon_ready" },
    { 0x6CB43FC8, "beacons" },
    { 0x54845354, "beaconusetrig" },
    { 0x1A18DF19, "bead" },
    { 0x242A37F8, "beam" },
    { 0xAC50EF41, "beam1" },
    { 0xD25369AA, "beam2" },
    { 0x749A4A8B, "beam_anims" },
    { 0xB803B724, "beam_damage_update" },
    { 0x18A4D3EC, "beam_dir" },
    { 0xF8BAD4E7, "beam_fire_start_models" },
    { 0xB75E6E79, "beam_fire_target" },
    { 0x5BA8564A, "beam_fx_audio" },
    { 0xEB4AE2C7, "beam_hide" },
    { 0x3678F090, "beam_id" },
    { 0x8159BF44, "beam_lift" },
    { 0x23C0DBE0, "beam_lift_time" },
    { 0x46BD1F9F, "beam_me_up" },
    { 0x2D03F621, "beam_me_up_to_the_chopper" },
    { 0x53DE0DAF, "beam_me_uppers" },
    { 0x2A383DF6, "beam_scale_down" },
    { 0x9A95A4F5, "beam_scale_up" },
    { 0xD603FDEC, "beam_shared" },
    { 0x37E1DEE9, "beam_start_position" },
    { 0x2AD5C4CF, "beam_stop" },
    { 0xAE9FCF28, "beam_target" },
    { 0xFA99DE69, "beam_target_fx" },
    { 0x61D1B6A5, "beam_to_enemy_dir" },
    { 0x07141264, "beam_to_enemy_length" },
    { 0xF9F04802, "beamfx" },
    { 0x2213E078, "beamkill" },
    { 0xD9571391, "beamlaunch" },
    { 0x78F47E53, "beams" },
    { 0x19673A76, "beams_down" },
    { 0xD776FBDD, "beams_fall" },
    { 0xF4E2E506, "beams_shot" },
    { 0x0EF02D75, "beams_up" },
    { 0x096B9CAE, "beamskipto" },
    { 0x9E0016FF, "bear" },
    { 0x4C1A7CBC, "bear_bedroom_reels" },
    { 0x1C6D8E97, "bear_can_angles" },
    { 0x2FC818C3, "bear_can_loc" },
    { 0x8768E028, "bear_origin" },
    { 0x358CE857, "bear_trap_closing_animations" },
    { 0xCAFAFD81, "bearing" },
    { 0x12A7C206, "beartrap" },
    { 0x7848E719, "beartrap_added" },
    { 0x60C78E78, "beartrap_ai_damage_override" },
    { 0x01AFD258, "beartrap_alert_ai_to_player_soon" },
    { 0xF3176CA1, "beartrap_catches_targes" },
    { 0xF5D2DFC6, "beartrap_deaths_vo" },
    { 0x02068B9A, "beartrap_exlposive" },
    { 0x19E6844F, "beartrap_explosive_think" },
    { 0x1FE14B09, "beartrap_helper_message" },
    { 0x23317CD4, "beartrap_looking_for_target" },
    { 0x91D3E0AD, "beartrap_mortar_plant_think" },
    { 0x91A1456A, "beartrap_pulling_in_target" },
    { 0xF53B23CC, "beartrap_refill_think" },
    { 0xD5BD0FC9, "beartrap_search_for_ai_victim" },
    { 0x0996C91A, "beartrap_stop_loop" },
    { 0x4B8D5A20, "beartrap_triggered" },
    { 0xAA6FE209, "beartrap_triggered_think" },
    { 0x471EC81A, "beartrap_watch" },
    { 0x5E8AE8B9, "beartraps" },
    { 0xF1D07616, "beast" },
    { 0x51DEA2B0, "beast_mode" },
    { 0x990FEEFB, "beastmode" },
    { 0x7AB07689, "beasts" },
    { 0xB9F13889, "beat" },
    { 0x5C7594F1, "beat2_4_19_press_demo_clean_up_riverwalk" },
    { 0x8C13F800, "beat2_4_19_press_demo_fade_cleaning" },
    { 0x8108FDFC, "beat2_4_19_press_demo_hit_important_triggers" },
    { 0x94CDDF6A, "beat2_4_19_press_demo_move_barnes_2_hey_charlie" },
    { 0x03127625, "beat2_4_19_press_demo_move_reznov_2_hey_charlie" },
    { 0xD5A65AFC, "beat2_attach_knife_to_woods_hand" },
    { 0xA6484DC8, "beat2_barnes_fight_ridge_1" },
    { 0xA3FB0ABE, "beat2_bowman_attach_c4" },
    { 0x04BF0156, "beat2_bowman_attach_knife" },
    { 0x77AD3372, "beat2_bowman_checks_in" },
    { 0xBB229EBC, "beat2_bowman_delete_c4" },
    { 0x93FECC98, "beat2_bowman_delete_knife" },
    { 0x326841C8, "beat2_bowman_put_down_weapon" },
    { 0xC9D1E24B, "beat2_bowman_take_back_weapon" },
    { 0xE8F9573C, "beat2_contextual_attack_message" },
    { 0x4F269F5E, "beat2_delay_reznov_before_river2_fight" },
    { 0x12DD6E4B, "beat2_detach_knife_from_woods_hand" },
    { 0xEB7520AD, "beat2_give_woods_back_a_gun" },
    { 0x43D45F2F, "beat2_hammock_vc_1_head_swap" },
    { 0x33E81B8C, "beat2_hammock_vc_2_head_swap" },
    { 0x681DEDB3, "beat2_hammock_vc_play_death_then_idle" },
    { 0xA46C94D5, "beat2_hey_charlie_backpack_animation" },
    { 0x1BB4D61A, "beat2_hey_charlie_disable_weapons" },
    { 0x14E2349E, "beat2_hey_charlie_loop" },
    { 0x85B2809D, "beat2_hudson_team_checks_in" },
    { 0x0EEECE05, "beat2_just_hey_charlie_for_the_squad" },
    { 0x64F0E764, "beat2_knife_memories_dialogue" },
    { 0x10BF0349, "beat2_move_woods_up_to_start" },
    { 0x87279DD8, "beat2_on_death_notify" },
    { 0xC1868DB5, "beat2_play_animation_in_sync" },
    { 0x30A98CF4, "beat2_play_rice_vc_prop_anim" },
    { 0x31E2CC09, "beat2_player_alerted_rice_vc" },
    { 0x22154154, "beat2_reach_node" },
    { 0x2007A0BF, "beat2_redshirt_blocks_exit" },
    { 0x74448688, "beat2_reznov_during_hey_charlie" },
    { 0x9BABDA64, "beat2_reznov_teleport_to_shore" },
    { 0xE150292C, "beat2_rice_vc_alert" },
    { 0xE5DA1EB5, "beat2_ridge1_fight" },
    { 0xEC59230D, "beat2_ridge1_vc1_actions" },
    { 0xC09E106A, "beat2_ridge1_vc2_actions" },
    { 0xF434928B, "beat2_river_walk_start" },
    { 0xD29F73EA, "beat2_riverwalk_dialogue" },
    { 0x32E0DCC3, "beat2_riverwalk_rain_dialogue" },
    { 0x8AE310C0, "beat2_section2_vc_drop_water_init" },
    { 0x47F805F4, "beat2_section2_vc_rice_init" },
    { 0x93723E7A, "beat2_section2_vc_snipe_init" },
    { 0x0EE4AADE, "beat2_shimy_window_ent_flag" },
    { 0x3BEC8208, "beat2_swap_vc_head_model" },
    { 0x370AA320, "beat2_vc_rice_attack_opportunity" },
    { 0x5CCD844D, "beat2_vc_rice_melee_fail" },
    { 0x9A91B7B9, "beat2_vc_rice_melee_kill" },
    { 0xE6852CA5, "beat2_vc_sampan_1_killed_by_woods" },
    { 0x7331562F, "beat2_vc_sampan_blood_in_the_water" },
    { 0x833477C2, "beat2_vc_sampan_search_anims" },
    { 0x8906EB6D, "beat2_woods_animates_hey_charlie" },
    { 0xF317AF1C, "beat_2_and_3_functions" },
    { 0xAF591719, "beat_2_critters" },
    { 0x206FECF9, "beat_2_objectives" },
    { 0x61F4D56E, "beat_2_starts" },
    { 0x15CDE18B, "beat_3_additional_ais_island" },
    { 0xF0C3786C, "beat_3_ambush_fill_left_side" },
    { 0xBE19C143, "beat_3_ariel_vc_deaths" },
    { 0x2C44E81F, "beat_3_attack_sampan" },
    { 0x5AE89AA3, "beat_3_attack_sampans_init" },
    { 0x85D66AF3, "beat_3_backup_hurdle_rusher" },
    { 0xB173DF5F, "beat_3_backup_parkour" },
    { 0x595B889C, "beat_3_backup_ridge_slider" },
    { 0xFDB81ADD, "beat_3_backup_ridge_slider_init" },
    { 0x7FAD9F05, "beat_3_backup_slider_init" },
    { 0xF564B4ED, "beat_3_barnes_kills_catwalk_vc" },
    { 0x3F4C244F, "beat_3_civ_idle_and_react" },
    { 0x0A3CF3A9, "beat_3_civ_idle_and_react_hut" },
    { 0x325E179B, "beat_3_civ_run_to_cower" },
    { 0x546BD506, "beat_3_civilian_init" },
    { 0xBD860F35, "beat_3_distraction_hut_destruction" },
    { 0xD3CC75D9, "beat_3_empty_line_4_failsafe" },
    { 0x539B35C1, "beat_3_failsafe_hut_explode" },
    { 0x90E113EF, "beat_3_give_player_plunger" },
    { 0x3066244B, "beat_3_go_to_left_node_and_stay" },
    { 0x2D861C04, "beat_3_grenade_explosion" },
    { 0x6891366E, "beat_3_helicopter_redshirts" },
    { 0x39D04644, "beat_3_hiding_door_progress" },
    { 0xE4393177, "beat_3_into_ambush_position" },
    { 0xCD786FDB, "beat_3_intro_anims" },
    { 0xD559729F, "beat_3_island_hut_damaged" },
    { 0x6AF9218A, "beat_3_keep_line_1_busy" },
    { 0x2CAD2DC8, "beat_3_line_2_window_shooter_looked_at" },
    { 0xAFEED5C0, "beat_3_line_3_window_shooter" },
    { 0xB49E7C2A, "beat_3_line_5_rathole" },
    { 0xE75D1481, "beat_3_line_6_failsafe" },
    { 0x88A0DB24, "beat_3_line_6_flavor_fighter" },
    { 0x19F377A6, "beat_3_m202_dropped" },
    { 0xDC78EC4D, "beat_3_mg_gunner_init" },
    { 0xF9508E22, "beat_3_objectives" },
    { 0x11452F2A, "beat_3_on_goal_reset_ignore" },
    { 0x8D49F576, "beat_3_pick_up_202" },
    { 0x37CD8E32, "beat_3_play_island_hut_explosion" },
    { 0x80BDEE8A, "beat_3_populate_line_6" },
    { 0xF401BEB6, "beat_3_push_foward" },
    { 0xFAAB1E2B, "beat_3_rathole_grenade_close" },
    { 0xD3F56BD4, "beat_3_rathole_hatch_opens" },
    { 0x5D57B6B7, "beat_3_reach_and_anim" },
    { 0xC51769A2, "beat_3_redshirt_setup_for_ambush" },
    { 0x53ADA56B, "beat_3_reinforcement_leader" },
    { 0xEC783C90, "beat_3_ridge_fight" },
    { 0xE0556174, "beat_3_ridge_mg_gunner" },
    { 0xE5B4F3E5, "beat_3_ridge_roof_awning" },
    { 0x806B4005, "beat_3_ridge_roof_death_failsafe" },
    { 0xA4ADD607, "beat_3_ridge_roof_roller" },
    { 0xE20EFA1E, "beat_3_ridge_vc_line_3" },
    { 0x9E0ED714, "beat_3_roof_door_init" },
    { 0xDD19C086, "beat_3_roof_rpg_vc" },
    { 0x81828E26, "beat_3_rpg_ammo_control" },
    { 0xD2FEC2A7, "beat_3_rpg_from_hut_window" },
    { 0x815B41E4, "beat_3_run_from_landed_sampan" },
    { 0xDE4B88AD, "beat_3_sampan_init" },
    { 0x610302B8, "beat_3_sampan_landing" },
    { 0x9CBA01A0, "beat_3_sampan_landing_anim" },
    { 0xE0FD8541, "beat_3_shore_hut_drop" },
    { 0x7C0A89CE, "beat_3_shore_hut_drop_chickencoop" },
    { 0x1933083A, "beat_3_shore_hut_drop_init" },
    { 0x48C73B76, "beat_3_shore_roof" },
    { 0xFB8A27B1, "beat_3_spawn_functions" },
    { 0x0296E721, "beat_3_squad_to_gate_door" },
    { 0xAC56007A, "beat_3_temp_end" },
    { 0x73E08A5F, "beat_3_temp_mg_vc" },
    { 0x5CCABD35, "beat_3_track_ai_line_1" },
    { 0x9EBE5928, "beat_3_track_ai_line_4" },
    { 0xA9E4396C, "beat_3_track_line_5" },
    { 0x1BEBA8A7, "beat_3_track_line_6" },
    { 0x2FD9D737, "beat_3_track_mg_ridge_ai" },
    { 0x3234C58B, "beat_3_tree_hugger" },
    { 0x9D074258, "beat_3_tree_hugger_init" },
    { 0xB869D4EC, "beat_3_vc_intro" },
    { 0x52BA5627, "beat_3_vc_jump_out_window_init" },
    { 0xEE033D9D, "beat_3_vc_rathole_1" },
    { 0xE549A538, "beat_3_vc_react_to_fail" },
    { 0x9E4C9951, "beat_3_village_redshirts" },
    { 0xC9A349F6, "beat_3_wait_for_door_area_clear" },
    { 0xD12611FD, "beat_3_waterhut_rpg_targets" },
    { 0x358846DF, "beat_3_window_shooter" },
    { 0x752448D5, "beat_3_wooden_island_init" },
    { 0xA79D6159, "beat_break" },
    { 0x4F79D96D, "beat_name" },
    { 0xCD2871FC, "beat_num" },
    { 0x5D60F1FD, "beatdown" },
    { 0xB6DD1581, "beatdown_attacker" },
    { 0x3C88717A, "beatdown_break_apart" },
    { 0x6D2C9B1A, "beatdown_hut_door" },
    { 0x628C6D2C, "beaten" },
    { 0xFA9656D0, "beater" },
    { 0x5C5FC361, "beater_animname" },
    { 0x7488C0AE, "beater_goalnode" },
    { 0x1B9C8ABB, "beaters" },
    { 0x81C5A43F, "beating" },
    { 0x2C9F0280, "beats" },
    { 0x9DF3B2CD, "beaucoup" },
    { 0xFC5D43E6, "beautiful" },
    { 0xD8788E80, "became" },
    { 0x62C5E4C7, "becasue" },
    { 0x2239C7B7, "because" },
    { 0x357F3BD6, "beckons" },
    { 0xE516EA82, "become" },
    { 0x54295ED9, "become_corpse" },
    { 0xA84FC0A6, "become_invulnerable_callback" },
    { 0x58938A5D, "become_vulnerable_callback" },
    { 0x0A9AE106, "becomecrawler" },
    { 0x5F3856CD, "becomes" },
    { 0xFD458D73, "becoming" },
    { 0xF7298052, "becoming_inert" },
    { 0x5458F55E, "becuas" },
    { 0xA328BFA7, "becuase" },
    { 0xEE818CC2, "bed" },
    { 0x1B357FC2, "bed_base" },
    { 0x4E91AAC7, "bed_dead" },
    { 0x70D88D0D, "beds" },
    { 0x4E85C8F2, "bedspot" },
    { 0x1484072B, "bee" },
    { 0x4FCF19B5, "beed" },
    { 0x56FE0B35, "beehive" },
    { 0x28BAFCB4, "beehive2_attack" },
    { 0xF911B153, "beehive2_door_open" },
    { 0xCCEE0DD4, "beehive2_enemy" },
    { 0xD32ABFD8, "beehive2_think" },
    { 0x89A81CF3, "beehive2_wait" },
    { 0x9D675DCC, "beehive_attack" },
    { 0x54BD92DC, "beehive_enemy" },
    { 0x9296D0CA, "beehive_enemy_second_door" },
    { 0xA3A6392A, "beehive_radius" },
    { 0xCC2FC905, "beehive_spawn" },
    { 0xF58548EB, "beehive_wait" },
    { 0x6BC03B3F, "been" },
    { 0x1921C0FB, "been_to_moon_before" },
    { 0x5E491970, "beenkilled" },
    { 0x17ECD6A1, "beep" },
    { 0x131AC65F, "beepalias" },
    { 0x0B98F96D, "beepduration" },
    { 0xF84D3967, "beeping" },
    { 0x63F1CB73, "beer" },
    { 0xAB1111C0, "beer_can" },
    { 0x43ABD214, "beer_can_notetrack" },
    { 0x4C722F6C, "beer_fx" },
    { 0x0F1CB422, "beers" },
    { 0x11554C48, "beffectlooping" },
    { 0x148CB1F7, "befor" },
    { 0xD35DAB28, "before" },
    { 0x8BFA6105, "before_balcony" },
    { 0x232929C2, "before_bike_clean_up" },
    { 0x09E909CD, "before_clean_room_ents" },
    { 0xCDF6B478, "before_clean_room_hudson_vo" },
    { 0x703890F6, "before_cleaning" },
    { 0x597B703E, "before_end" },
    { 0x37C08B65, "before_last_tunnel_guys_clear" },
    { 0x082062AE, "before_shrine" },
    { 0x204DE96B, "beforehand" },
    { 0x841B9467, "beforestairs_moveplaybackrate" },
    { 0xC87F1259, "beg" },
    { 0x5C794308, "began" },
    { 0xF197DF04, "begging" },
    { 0xAC2EE3CF, "beggining" },
    { 0xF38736D0, "begin" },
    { 0xDC534E6F, "begin_airstrike" },
    { 0xE0D4A98F, "begin_ambience" },
    { 0xD8FC86EB, "begin_ambush" },
    { 0x50C191D3, "begin_ambush_early" },
    { 0x198F4BA8, "begin_anim_reach" },
    { 0xA2975492, "begin_armor_regen" },
    { 0x92D3FDBB, "begin_artillery" },
    { 0x7177E0C2, "begin_attack_trigger" },
    { 0x8F4AC5A2, "begin_camera_wobble" },
    { 0x4062ECBB, "begin_capture_countdown" },
    { 0xCBB57658, "begin_carry" },
    { 0x4CFDCB3D, "begin_delaying_action" },
    { 0x9687FC19, "begin_delaying_action_timeout" },
    { 0x9C608E4C, "begin_donkeykong" },
    { 0xEACCBE76, "begin_event1" },
    { 0xF5D8E012, "begin_event10" },
    { 0x1BDB5A7B, "begin_event11" },
    { 0xA9D3EB40, "begin_event12" },
    { 0xCFD665A9, "begin_event13" },
    { 0xB3E5441F, "begin_event15" },
    { 0x41DDD4E4, "begin_event16" },
    { 0x67E04F4D, "begin_event17" },
    { 0xC4CA440D, "begin_event2" },
    { 0x9EC7C9A4, "begin_event3" },
    { 0x78C54F3B, "begin_event4" },
    { 0x52C2D4D2, "begin_event5" },
    { 0x2CC05A69, "begin_event6" },
    { 0x06BDE000, "begin_event7" },
    { 0x40E30C27, "begin_event8" },
    { 0x1AE091BE, "begin_event9" },
    { 0xA276E396, "begin_firing" },
    { 0xDF7B8ABD, "begin_game" },
    { 0x844D9054, "begin_game_introduction" },
    { 0x98AEDC26, "begin_game_tutorial" },
    { 0xDA05AB89, "begin_grenade_tracking" },
    { 0x4C1D2EA6, "begin_hill" },
    { 0xCFACD8CD, "begin_html_table" },
    { 0xD969D778, "begin_killcam" },
    { 0xF330C29E, "begin_lapd_convoy_escort" },
    { 0x5180FD69, "begin_mason_donkeykong" },
    { 0xFEF029F3, "begin_mason_intro_mortars" },
    { 0x40CEA9BE, "begin_mg_event" },
    { 0xC9FA0DFF, "begin_monitoring_stealth_house_failure" },
    { 0x2D43D640, "begin_mortar_tracking" },
    { 0x894C0078, "begin_napalm" },
    { 0xA7922CF8, "begin_other_grenade_tracking" },
    { 0x88AA9DF5, "begin_quad_introduction" },
    { 0x163E4A11, "begin_satchel_tracking" },
    { 0x361A418A, "begin_slide" },
    { 0x3A01AA97, "begin_smoke_grenade_tracking" },
    { 0x440FB388, "begin_split_up_climb_down" },
    { 0xE446403E, "begin_split_up_scene" },
    { 0x15F206D4, "begin_time" },
    { 0xDB70D1CB, "begin_track_results" },
    { 0xE65825E5, "begin_truck_event" },
    { 0xB66AB245, "begin_width" },
    { 0xF0A4734E, "beginc4tracking" },
    { 0x1FB4FEC9, "beginclasschoice" },
    { 0x404F26CD, "begincrouchrun" },
    { 0x71C3F44A, "begincrouchstop" },
    { 0xFC1AA9BD, "begincrouchwalk" },
    { 0x4F8DE03B, "begincustomevent" },
    { 0x5C3123E7, "beginespecialgrenadetracking" },
    { 0xF6FEBAEF, "beging" },
    { 0xF2512AC9, "begingrenadetracking" },
    { 0xA28932C8, "begining" },
    { 0xCD9D5225, "beginlocationairstrikeselection" },
    { 0xD1001189, "beginlocationartilleryselection" },
    { 0x53DF6C16, "beginlocationcomlinkselection" },
    { 0x42C61E54, "beginlocationmortarselection" },
    { 0x73739D48, "beginlocationnapalmselection" },
    { 0xC4D3EDC9, "beginlocationselection" },
    { 0x9F87854A, "beginloop" },
    { 0x20B511DC, "beginmortartracking" },
    { 0x3DA74672, "beginning" },
    { 0xB3A54C57, "beginning_alpha" },
    { 0x8522CF56, "beginningoflevelsave" },
    { 0x4A373C4B, "beginothergrenadetracking" },
    { 0xDB65F0F0, "beginparent" },
    { 0x0140641F, "beginprediction" },
    { 0xC257F3B5, "beginpronerun" },
    { 0x58212D22, "beginpronestop" },
    { 0x8272D845, "beginpronewalk" },
    { 0xFECD2ABB, "begins" },
    { 0xC14AE869, "beginsatcheltracking" },
    { 0x9F1CFD40, "beginsmokegrenadetracking" },
    { 0x64598E72, "beginspecialgrenadetracking" },
    { 0xE4AF57AF, "beginstandrun" },
    { 0xAF8CF1C8, "beginstandstop" },
    { 0x72D0F8F3, "beginstandwalk" },
    { 0x187D13D8, "begintacticalwalkpain" },
    { 0x52EDB8AB, "begintime" },
    { 0x932801D3, "begone" },
    { 0x7693182C, "begun" },
    { 0xB69F49AE, "beh" },
    { 0xE06A8B16, "behaind" },
    { 0x55BAB250, "behave" },
    { 0x453B97A8, "behave_after_fountain_transport" },
    { 0x15D8953B, "behaves" },
    { 0x065C427A, "behavioir" },
    { 0x6FF7694B, "behavior" },
    { 0xD8F2ACEC, "behavior_func" },
    { 0x3B57B0CD, "behavior_orient" },
    { 0x50B247D3, "behavior_snow_hideguy" },
    { 0xAE6279E3, "behavior_special_ai_claymore" },
    { 0x4C23C45E, "behavior_special_ai_mine_place" },
    { 0x3549F547, "behavior_state_machine" },
    { 0xF1CF42C4, "behavior_state_machine_db" },
    { 0x3AE1C2FC, "behavior_state_machine_planners_utility" },
    { 0x086D555A, "behavior_tree" },
    { 0x58A1894B, "behavior_tree_utility" },
    { 0x7D360223, "behavior_zombie_dog" },
    { 0x9CB7FC14, "behavioral" },
    { 0xD600332E, "behaviorcallback" },
    { 0xC9D72351, "behaviorcallbacks" },
    { 0x6131B29F, "behaviorconnection" },
    { 0xD2B6FAAA, "behaviors" },
    { 0xDB48A0A6, "behaviorstarttime" },
    { 0xA9F4E45E, "behaviorstate" },
    { 0xD12B5599, "behaviorstatemachine" },
    { 0x4AB87515, "behaviortracker" },
    { 0x27B3C0E9, "behaviortreeaction" },
    { 0x338B7752, "behaviortreeentity" },
    { 0xF55A5E73, "behaviortreenetwork" },
    { 0x3AAF60E9, "behaviortreenetworkutility" },
    { 0x34B6E60A, "behaviortreenodes" },
    { 0x6BB70B8A, "behaviortreescript" },
    { 0x70099350, "behaviorutilitydocbegin" },
    { 0xF6E2FDF4, "behaviorutilitydocend" },
    { 0x7750DB3E, "behaviour" },
    { 0x8D5C3621, "behaviours" },
    { 0x83528BEB, "behavour" },
    { 0xCD2A0369, "behind" },
    { 0x6DFFC59B, "behind_end" },
    { 0xB4748F74, "behind_guys" },
    { 0xF0BBED45, "behind_hotel_drone" },
    { 0x5FE6A8E4, "behind_mansion_zone" },
    { 0x865DD380, "behind_node" },
    { 0x1F69FC0D, "behind_us_vo_node" },
    { 0xC86F2DF9, "behind_zones" },
    { 0x956A006B, "behindindex" },
    { 0x10D77757, "behindme" },
    { 0xF32C7DD2, "behing" },
    { 0x803D3332, "behinghacked" },
    { 0x95A6A90B, "behvahior" },
    { 0xFACFD78E, "being" },
    { 0x92B50F42, "being_attacked" },
    { 0xF5AA6038, "being_deleted" },
    { 0x29EC352A, "being_destroyed" },
    { 0x843732E5, "being_dismounted" },
    { 0x748AF3D9, "being_hacked" },
    { 0x2906C910, "being_mantled" },
    { 0x672CB2FF, "being_removed" },
    { 0xE94879D2, "being_revived" },
    { 0x563161E4, "being_shot_down" },
    { 0xEFE9A758, "being_teargassed" },
    { 0xD67A8902, "being_used" },
    { 0x20305AC7, "beingartilleryshellshocked" },
    { 0xF5A0AF5C, "beingcaptured" },
    { 0x802202DF, "beingdestroyed" },
    { 0xA2D272FE, "beinghacked" },
    { 0xB0DF2DDB, "beingmicrowaved" },
    { 0x03F31C18, "beingmicrowavedby" },
    { 0x3EB3B42A, "beingmortarshellshocked" },
    { 0xAE15C5DB, "beingrevived" },
    { 0x59A6D499, "beingstraferunshellshocked" },
    { 0x848D9D60, "beingwarnedaboutleaving" },
    { 0xD6987064, "belay" },
    { 0xC1A04617, "beleive" },
    { 0xFB0FBABF, "believe" },
    { 0x21085E29, "believed" },
    { 0x3F3C68C6, "believes" },
    { 0xA7F65A32, "bell" },
    { 0x3653C5D8, "bell_alarm" },
    { 0x47A3D4B7, "bell_ring" },
    { 0x65CFE733, "bell_rung" },
    { 0x794010C6, "bell_struct" },
    { 0xABD5394E, "bell_watch" },
    { 0xC67D15D3, "bell_watch_ring" },
    { 0x14A5DBBD, "bells" },
    { 0x0461CAA9, "belltower" },
    { 0x90BEA3D7, "belly" },
    { 0x2218BD80, "belong" },
    { 0x3981A513, "belonged" },
    { 0xCCE53998, "belonging" },
    { 0x400F4DAB, "belongs" },
    { 0x62675B3C, "belongstoenemy" },
    { 0x0815E4CD, "belov" },
    { 0x99105A9F, "belov_door_node" },
    { 0xE2136A64, "below" },
    { 0xBCB07919, "below_ground_death" },
    { 0x7D07B478, "belowfeet" },
    { 0x146FCC2D, "belowground" },
    { 0x3831D40A, "belt" },
    { 0xECBA0DE1, "bench" },
    { 0x436A6B1A, "bench1" },
    { 0x1D67F0B1, "bench2" },
    { 0x5A8A47E5, "bench_name" },
    { 0xDD672418, "bench_sit" },
    { 0x17216631, "benches" },
    { 0x87AFE5D0, "benches_start" },
    { 0xEAE7458A, "benchmark" },
    { 0x0874CB6C, "bend" },
    { 0x9496235C, "bend_guy" },
    { 0x4D1D696F, "bends" },
    { 0xAB61D61A, "beneath" },
    { 0xB7A78B85, "beneficial" },
    { 0x689C71FC, "bent" },
    { 0x5447DD9F, "beome" },
    { 0xA0ACED9F, "ber1_achieve_kills" },
    { 0xD297C410, "ber1_amb" },
    { 0x75297087, "ber1_anim" },
    { 0x823CE4C7, "ber1_art" },
    { 0x56DD781D, "ber1_asylum" },
    { 0x0AEB192D, "ber1_bell_toll" },
    { 0xFF376277, "ber1_building_interrior" },
    { 0xB044CCC0, "ber1_callbacks" },
    { 0xFC7415C9, "ber1_clock_shot" },
    { 0x5E6FD2C9, "ber1_event1" },
    { 0x84724D32, "ber1_event2" },
    { 0xA6F8E202, "ber1_fx" },
    { 0xEA0F5BE0, "ber1_geo_fx" },
    { 0x2813F1D4, "ber1_kill_group" },
    { 0x4F03DF7F, "ber1_main" },
    { 0xC0CCA65C, "ber1_melee" },
    { 0x7E847E5F, "ber1_outdoors" },
    { 0xCDB20A3E, "ber1_status" },
    { 0xD1865C81, "ber1_stuka_audio" },
    { 0xE6D584C6, "ber1_tankride" },
    { 0x49BE65F7, "ber1_train_station" },
    { 0xBDA82DCC, "ber1_util" },
    { 0x167C0858, "ber1b_amb" },
    { 0x7217A93F, "ber1b_anim" },
    { 0xE592064D, "ber1b_cam" },
    { 0x27E20C7A, "ber1b_fx" },
    { 0x981DD4F7, "ber1b_main" },
    { 0x829CB2AC, "ber1b_spawner" },
    { 0x9F1AB706, "ber1b_status" },
    { 0xA9504C34, "ber1b_util" },
    { 0xB330158E, "ber2" },
    { 0xC8D51BAF, "ber2_amb" },
    { 0x8F4D9432, "ber2_anim" },
    { 0xD52EF09F, "ber2_anim_init" },
    { 0x85CC82CC, "ber2_art" },
    { 0x59108692, "ber2_building_interrior" },
    { 0xE79B072E, "ber2_dark_kill_got_cheeve" },
    { 0x5B957FF3, "ber2_dark_kills" },
    { 0xDAD16B9E, "ber2_earthquake" },
    { 0x23920E8C, "ber2_event1" },
    { 0x95997DC7, "ber2_event2" },
    { 0x90927801, "ber2_friendly_startup_thread" },
    { 0x552C4D1B, "ber2_fx" },
    { 0xCB955E68, "ber2_hallwaytimer" },
    { 0x08092747, "ber2_insmoke" },
    { 0x7DE8297E, "ber2_outdoors" },
    { 0x26386FCB, "ber2_speedadjust" },
    { 0x03C03F8B, "ber2_status" },
    { 0xFEC5F69E, "ber2_subway" },
    { 0x1F787DC1, "ber2_util" },
    { 0x15BF1258, "ber2b" },
    { 0x6B806E49, "ber2b_amb" },
    { 0x59357180, "ber2b_anim" },
    { 0x2206E53C, "ber2b_event3" },
    { 0xBAD1F8B9, "ber2b_fx" },
    { 0x80600CAD, "ber2b_status" },
    { 0xD9328FF7, "ber3" },
    { 0x244987DA, "ber3_amb" },
    { 0x8053EC7D, "ber3_anim" },
    { 0x71D33379, "ber3_art" },
    { 0x330AADC5, "ber3_building_interrior" },
    { 0xE971A4D6, "ber3_column_collapse" },
    { 0xF8783E66, "ber3_commisar_tank" },
    { 0x7AD06560, "ber3_event_atgun" },
    { 0x3E2A6509, "ber3_event_intro" },
    { 0xDAC036C5, "ber3_event_plaza" },
    { 0x74F6E256, "ber3_event_steps" },
    { 0xF246A2DA, "ber3_event_wave" },
    { 0xEF08C9E8, "ber3_fx" },
    { 0xE1BF4B11, "ber3_igd_030a_rezn" },
    { 0xBBE8724D, "ber3_outdoors" },
    { 0x2EB235B3, "ber3_plaza_statue" },
    { 0x8C395DC8, "ber3_stag_flag_anim" },
    { 0x4F9ED0E8, "ber3_status" },
    { 0x73863179, "ber3_subway" },
    { 0xF94EEB5C, "ber3_tank_trap" },
    { 0xEBD03A66, "ber3_util" },
    { 0x6E8B7E07, "ber3b" },
    { 0xB8708D8A, "ber3b_amb" },
    { 0xE923464D, "ber3b_anim" },
    { 0x9215EBC6, "ber3b_anim_init" },
    { 0xA31FEFA9, "ber3b_art" },
    { 0xD7430B03, "ber3b_eagle_slip_sound" },
    { 0xCCA8D021, "ber3b_earthquake" },
    { 0x6A847114, "ber3b_event_foyer" },
    { 0x8A31016C, "ber3b_event_parliament" },
    { 0x80B53643, "ber3b_event_roof" },
    { 0x0FCD749A, "ber3b_firelight" },
    { 0x306B223F, "ber3b_fireteam_reset_ais_customfunc" },
    { 0x405AC528, "ber3b_fireteams" },
    { 0x360BB129, "ber3b_fireteams_init" },
    { 0xD052ED8D, "ber3b_friendly_accuracy" },
    { 0xEA080478, "ber3b_friendly_startup_thread" },
    { 0x3C8761E1, "ber3b_friendly_suppression_wait" },
    { 0x67BAE3D8, "ber3b_fx" },
    { 0x82B04875, "ber3b_indoor_packages" },
    { 0x2F054F36, "ber3b_indoors" },
    { 0xF0167BDA, "ber3b_outdoor_packages" },
    { 0xF12A3C1D, "ber3b_outdoors" },
    { 0x5D347827, "ber3b_partial_room_packages" },
    { 0x29DD2B20, "ber3b_partial_rooms" },
    { 0xF0C1B30F, "ber3b_player_threatbias" },
    { 0x96E5FC04, "ber3b_superenemy_frac" },
    { 0x6CEC1E5A, "ber_art" },
    { 0x601CB92D, "berlin" },
    { 0x0DBB9955, "berlin2" },
    { 0x665F849D, "berlin2b" },
    { 0xE7B91EEC, "berlin3" },
    { 0xBF82BAF6, "berlin3b" },
    { 0xAA87EC8E, "berlin_runner_behaviour" },
    { 0x320E9B2F, "berlin_runner_trig" },
    { 0xE4499D69, "berm" },
    { 0x20917E90, "berm_ai_climb" },
    { 0x542FF51F, "berm_ai_climb_helper" },
    { 0xE50EF91F, "berm_pathing" },
    { 0xAD0CA4C6, "berm_pathing_think" },
    { 0x0F3B21A1, "berm_vo" },
    { 0x37A19DE0, "berms" },
    { 0x4944C95D, "berserk" },
    { 0x1BD6AE1A, "berserk_org" },
    { 0x4A3924BF, "berserk_start_org" },
    { 0xFDA39B6B, "berserk_time" },
    { 0xB1F797A7, "berserkendtime" },
    { 0xB3504B4C, "berserker" },
    { 0xF4ED669B, "berserker_death" },
    { 0xD89E89D2, "berserker_end" },
    { 0xF0112A61, "berserker_giveback_player_weapons" },
    { 0xB513086C, "berserker_kill_streak" },
    { 0x7783638D, "berserker_kill_timer" },
    { 0x2C2C7ECA, "berserker_lerp_fov_overtime" },
    { 0xE3A72AEC, "berserker_main" },
    { 0x9AFCD594, "berserker_player_has_rocketbarrage" },
    { 0xCC310118, "berserker_take_player_weapons" },
    { 0x2E54983D, "berserker_think" },
    { 0xE436F203, "berzerk_audio_off" },
    { 0x104E1ACF, "berzerk_audio_on" },
    { 0x26F1173D, "berzerk_thread" },
    { 0x46CE6E77, "berzerker" },
    { 0xC5D447AF, "beside" },
    { 0xA119C4F6, "besides" },
    { 0xCD1A0303, "best" },
    { 0xDA3A9511, "best_attack_pos" },
    { 0xC859CFC8, "best_boat" },
    { 0x4772031C, "best_boat_count" },
    { 0xE6D08F0B, "best_boat_dist" },
    { 0xFCC6E0AB, "best_choice" },
    { 0xDE206E0B, "best_choice_dot" },
    { 0xF5C11A4A, "best_connection" },
    { 0xE9D5AF5F, "best_crumb" },
    { 0x1FDB6A5A, "best_dist" },
    { 0xC930A363, "best_distance" },
    { 0x4FAF77E2, "best_enemy" },
    { 0xBDFD4FA5, "best_ent" },
    { 0xF368EFFA, "best_hunted_val" },
    { 0xCB83DA17, "best_idx" },
    { 0xB59DF81A, "best_index" },
    { 0x4A182713, "best_key" },
    { 0xE4310644, "best_loc" },
    { 0x2A59CDDD, "best_monkey" },
    { 0xFE3B81D2, "best_node" },
    { 0x701122D3, "best_object" },
    { 0x3EBC86EA, "best_poi" },
    { 0x018DB854, "best_point" },
    { 0x627C1840, "best_pos" },
    { 0xD0F3C1EB, "best_pos_dist2" },
    { 0x314201DA, "best_priority" },
    { 0x71B668D0, "best_score" },
    { 0x080495C3, "best_spawn" },
    { 0x38A2E79B, "best_spawn_entity" },
    { 0x40A670D5, "best_spawn_no_sight" },
    { 0x16C8E69E, "best_spawner" },
    { 0xC06A3EB9, "best_spawner_score" },
    { 0x8CF89C1E, "best_spot" },
    { 0x4DCEE627, "best_tag_index" },
    { 0x57CE6DF1, "best_target" },
    { 0xF0EB3F6E, "best_targetfov" },
    { 0x1090957A, "best_threat" },
    { 0x341A16F1, "best_time" },
    { 0x132FF0A3, "best_trap" },
    { 0xD489AB9E, "best_trigger" },
    { 0x324E9779, "best_vtol" },
    { 0xBB8CF3BE, "best_weapon" },
    { 0x0A269B8F, "bestambushnode" },
    { 0xBD9B6B34, "bestangle" },
    { 0xED200BAC, "bestanglefrac" },
    { 0x809BA427, "bestangles" },
    { 0xDB8C9404, "bestbarrier" },
    { 0x2634A909, "bestbots" },
    { 0xC00349F9, "bestcargospot" },
    { 0x702668A9, "bestclosescore" },
    { 0x36309177, "bestconnection" },
    { 0x16DA05FF, "bestdelta" },
    { 0x92853F3F, "bestdist" },
    { 0x77E260EA, "bestdistance" },
    { 0xCCE4DAD0, "bestdistancesqr" },
    { 0xC0AD81CB, "bestdistsq" },
    { 0xD7251ABD, "bestdompoint" },
    { 0xE3ACCF14, "bestdot" },
    { 0x16AD2892, "bestent" },
    { 0xFE72E30D, "bestentry" },
    { 0xC9E30E31, "bestflag" },
    { 0x6B3CCCA1, "bestflagdistsq" },
    { 0x49E5BA74, "bestfocalpoint" },
    { 0x4C0FE687, "bestfrac" },
    { 0xE0AFD4A6, "bestg" },
    { 0x2B240BE6, "bestground" },
    { 0x9930D5C5, "bestindex" },
    { 0x1720E41F, "bestkdratio" },
    { 0xA295B026, "bestkills" },
    { 0x30DA0509, "bestkillstreak" },
    { 0xD203E57B, "bestnode" },
    { 0x9C0F2D1A, "bestnodes" },
    { 0xAEE53F99, "bestorigin" },
    { 0x235F2133, "bestow_quest_rewards" },
    { 0x520C2CD4, "bestplayer" },
    { 0x6E8C8755, "bestplayermeansofdeath" },
    { 0x9B0723BB, "bestplayerrating" },
    { 0x6C275140, "bestplayerweapon" },
    { 0xA3DF9117, "bestpoint" },
    { 0x9F86E93F, "bestpos" },
    { 0xD5CF6C02, "bestposition" },
    { 0x1267878F, "bestpriority" },
    { 0xD0032D58, "bestradio" },
    { 0xB163C676, "bestsafezone" },
    { 0x14FA273B, "bestscore" },
    { 0xD9805264, "bestspawn" },
    { 0x01955D62, "bestspawnflag" },
    { 0x53CAFBC6, "bestspawnpoint" },
    { 0xA7C19D79, "bestspawnpoints" },
    { 0x35EC7E95, "bestsplit" },
    { 0x37DDC7CF, "bestsq" },
    { 0x6ACCA854, "besttaco" },
    { 0x45D4544C, "besttacodistsq" },
    { 0x8E0BB7CC, "besttarget" },
    { 0x3CC7953C, "besttargetdistancesquared" },
    { 0x681B7968, "besttracefraction" },
    { 0xD8912007, "besttraceposition" },
    { 0x5CCE65FA, "bestvalue" },
    { 0x8BBA51B7, "bestweapon" },
    { 0x4A709DE3, "bestweapon_find" },
    { 0x0FB8E236, "bestweapon_get" },
    { 0x027ED864, "bestweapon_init" },
    { 0x1146DD0E, "bestweapon_kill" },
    { 0x5BE8B6AF, "bestweapon_spawn" },
    { 0xA3A954FF, "bestweight" },
    { 0x520D98C1, "bestzone" },
    { 0x8E59E632, "bet" },
    { 0xAF388DFF, "beta" },
    { 0xC0E4D6AF, "beta2" },
    { 0xFFCA5F16, "beta2_door" },
    { 0x3A085C06, "beta_door" },
    { 0xF3536C7F, "betamaxes" },
    { 0xF99D2A35, "beteeen" },
    { 0x15748655, "betrayal" },
    { 0x78E85B0F, "betrayal_fade_out" },
    { 0x62A82B20, "betrayal_scene" },
    { 0x1329A64F, "betrayal_scene_label" },
    { 0x280495A5, "betrayal_speech_sal_started" },
    { 0xB224E171, "betrayed" },
    { 0x6BD26AFC, "betrayed_event" },
    { 0xC660B153, "better" },
    { 0x59751A21, "better_target" },
    { 0x03594E93, "betterkillcament" },
    { 0x5DE8730B, "betternode" },
    { 0x2666886A, "betternodes" },
    { 0x446BE743, "betties" },
    { 0xDFF24A21, "betties_triggered" },
    { 0x3F2F30E7, "betty" },
    { 0x48A24622, "betty_controller" },
    { 0x0DEC736D, "betty_death_think" },
    { 0xF9CF0BCA, "betty_destroyed_damage_max" },
    { 0x7CBA4DD4, "betty_destroyed_damage_min" },
    { 0x65C75892, "betty_destroyed_damage_radius" },
    { 0xA07968DE, "betty_loadout" },
    { 0xBDD51E2D, "betty_mine_hack" },
    { 0x9438FBE9, "betty_model" },
    { 0xCE05535F, "betty_pop" },
    { 0x8C10210C, "betty_radius" },
    { 0xDFFFA96F, "betty_rotate" },
    { 0xB266D250, "betty_rotate_fx" },
    { 0x28D5E158, "betty_setup_trigger" },
    { 0x622F6FA4, "betty_smoke_trail" },
    { 0x99F3253E, "betty_think" },
    { 0x03F1A22F, "betty_think_no_wires" },
    { 0x0EACEEF8, "betty_trig" },
    { 0xA4BA9353, "betty_trigs" },
    { 0x473D2D58, "bettyactivationdelay" },
    { 0xF12C5D5A, "bettyarray" },
    { 0xB80C6A97, "bettybombletcount" },
    { 0xC3E20BFE, "bettybombletspawndistance" },
    { 0x17A39558, "bettydamage" },
    { 0x143D49A9, "bettydamageheight" },
    { 0xA222FE52, "bettydamagemax" },
    { 0xB741A5EC, "bettydamagemin" },
    { 0xE48DF31A, "bettydamageradius" },
    { 0xC15013ED, "bettydeployanim" },
    { 0xC1C63C7E, "bettydestroyedfx" },
    { 0x545A87D2, "bettydetectionconeangle" },
    { 0xBBBC02EE, "bettydetectionradius" },
    { 0x1F408195, "bettydetonateradius" },
    { 0x60EEC3A8, "bettydetonation" },
    { 0x3F716EA5, "bettyexplodeanim" },
    { 0x5A8A0435, "bettyexplodethisframe" },
    { 0xA50B46A2, "bettyexplosionfx" },
    { 0x8D888022, "bettyfxid" },
    { 0x23F2251E, "bettyglintid" },
    { 0xD346745E, "bettygraceperiod" },
    { 0xE6C3062D, "bettyhackertoolradius" },
    { 0x61E0223C, "bettyhackertooltimems" },
    { 0xDF41B9E6, "bettyjumpheight" },
    { 0x80567B2E, "bettyjumpheightwall" },
    { 0x0E7C93DB, "bettyjumpheightwallangle" },
    { 0xEE53B040, "bettyjumpheightwallanglecos" },
    { 0x1635B0EC, "bettyjumptime" },
    { 0xC4FFFAC0, "bettylaunchfx" },
    { 0x9E77FE9D, "bettymindist" },
    { 0x67EFEBC4, "bettymodelcenteroffset" },
    { 0xEEF81461, "bettyradius" },
    { 0xE815A9FB, "bettyrotatevelocity" },
    { 0x63D5825E, "bettys" },
    { 0xBE20EF20, "bettystuntime" },
    { 0x57EEA549, "bettytimebeforedetonate" },
    { 0x834F7EB4, "bettytriggerdamagetraceenabled" },
    { 0x4E89AD3C, "bettytriggerloopwait" },
    { 0xC457BA11, "bettyupvelocity" },
    { 0xA9033493, "between" },
    { 0x7874D92F, "between_round_over" },
    { 0x65859FCB, "betweensetsbase" },
    { 0x65DC49EE, "betweensetsmax" },
    { 0xB8B3B8B0, "betweensetsmin" },
    { 0x7FE83833, "betweensetsrange" },
    { 0x6C02E0B8, "betweenshotsmax" },
    { 0x86F80C66, "betweenshotsmin" },
    { 0x1720B7E9, "bevaior" },
    { 0x86196299, "bewteen" },
    { 0x882135A8, "bexitifautomatedonly" },
    { 0x9CE3822C, "bexploded" },
    { 0x12C3DCEC, "beyond" },
    { 0x90CD4B24, "bezier" },
    { 0xC78146F7, "bfacade" },
    { 0xEAC55B3C, "bfadewait" },
    { 0x79769293, "bfast" },
    { 0xB543C14A, "bflags" },
    { 0x05739769, "bflatangle" },
    { 0x4AE51086, "bforce" },
    { 0x3BBA328D, "bforcedspam" },
    { 0x861A4793, "bforcelocation" },
    { 0x673019EB, "bforcespawn" },
    { 0x27932B05, "bfr_01" },
    { 0xC2530A98, "bfr_01_render" },
    { 0xCDDF30F8, "bfreeze" },
    { 0x8E1E3BA6, "bfullcharge" },
    { 0x1A063BD0, "bg" },
    { 0x89E6B36F, "bg1_shader_height" },
    { 0x860E2DAE, "bg1_shader_width" },
    { 0xBF98A40C, "bg2_shader_height" },
    { 0x564F8517, "bg2_shader_width" },
    { 0x90E276ED, "bg_common_db" },
    { 0x4B49B035, "bg_dog_getrunanimweights" },
    { 0x8C74CDA6, "bg_enttype" },
    { 0x1B998C90, "bg_fps" },
    { 0xFA698377, "bg_gravity" },
    { 0xFBC03F7A, "bg_hud" },
    { 0x99DBFB2A, "bg_pmove" },
    { 0xE56BB5C8, "bg_public" },
    { 0x01B3FB78, "bg_rts" },
    { 0xB0129E0C, "bgalpha" },
    { 0xAC4C5627, "bgame" },
    { 0xD2E735E2, "bgb" },
    { 0x58B9A463, "bgb_activations_remaining_cf_name" },
    { 0x7B76E14A, "bgb_always_run_add_to_player_score_override" },
    { 0x261B0B57, "bgb_always_run_lost_perk_override" },
    { 0xF8F31118, "bgb_blow_bubble_cf_name" },
    { 0x2F6F5653, "bgb_blow_bubble_fx" },
    { 0x7C4E05D3, "bgb_blow_bubble_fx_name" },
    { 0xE4E15C9A, "bgb_current_cf_name" },
    { 0x26B90C53, "bgb_display_cf_name" },
    { 0xA3D84497, "bgb_flavor_hexed_give_" },
    { 0xEBE6EB3D, "bgb_idle_eyes_active" },
    { 0x3F330E54, "bgb_in_plain_sight_active" },
    { 0x1D83009C, "bgb_in_use" },
    { 0x95EF91E4, "bgb_invalid_use_cf_name" },
    { 0x4E019399, "bgb_limit_type_activated" },
    { 0x1DC4BB14, "bgb_limit_type_event" },
    { 0x9A51919F, "bgb_limit_type_rounds" },
    { 0xC489217F, "bgb_limit_type_time" },
    { 0xC92F7448, "bgb_machine" },
    { 0xA39AD0F4, "bgb_one_shot_use_cf_name" },
    { 0x8D533D78, "bgb_rarity_classic_index" },
    { 0x969EB9EC, "bgb_rarity_classic_tag" },
    { 0xB118ADB8, "bgb_rarity_mega_index" },
    { 0xB653522C, "bgb_rarity_mega_tag" },
    { 0x61EB38E6, "bgb_rarity_rare_index" },
    { 0x9D0A079A, "bgb_rarity_rare_tag" },
    { 0xF8DFFCFB, "bgb_rarity_ultra_rare_index" },
    { 0xCD703DF3, "bgb_rarity_ultra_rare_tag" },
    { 0xE750E509, "bgb_rarity_whimsical_index" },
    { 0x87132391, "bgb_rarity_whimsical_tag" },
    { 0x8B963875, "bgb_reserved_name" },
    { 0x98CC3086, "bgb_revive" },
    { 0x38ABB96D, "bgb_skip_demo_bookmark" },
    { 0x50DA0B1E, "bgb_timer_cf_name" },
    { 0xA268C575, "bgb_timer_manual_lerp_period" },
    { 0x00C0E28B, "bgb_timer_manual_lerp_threshold" },
    { 0xADE8E118, "bgb_token" },
    { 0xE6DEC57E, "bgb_tone_death" },
    { 0xAE9023A9, "bgb_update_give_" },
    { 0x37224D3F, "bgbar" },
    { 0xA5DB58C6, "bgbignorefearinheadlights" },
    { 0xBE22AE54, "bgelm" },
    { 0x53AB6DA3, "bgicon" },
    { 0xB759750B, "bgoddriver" },
    { 0x2AC12885, "bgotogoal" },
    { 0x46C46C23, "bgshader" },
    { 0x987BF98D, "bhackbarth" },
    { 0x34DE56CF, "bharathwaj" },
    { 0x84DC6A55, "bhasgunwhileriding" },
    { 0x04478607, "bhb" },
    { 0xF57952CE, "bhb_bomb" },
    { 0x8365023C, "bhb_burst" },
    { 0x294F76FC, "bhb_org" },
    { 0x1BFAA4C3, "bhb_position" },
    { 0x1E3D1509, "bhb_teleport_loc_check" },
    { 0x49C21DFE, "bhbs" },
    { 0xF6C55878, "bheight" },
    { 0xC58E9518, "bheld" },
    { 0xA0C84BAA, "bhelicopterwaitforstart" },
    { 0xE838DB45, "bhide" },
    { 0x295761A3, "bhintprint" },
    { 0xB64936FE, "bhtn_action_notify" },
    { 0xCC9DD1BF, "bhtn_action_start" },
    { 0x5270341E, "bhtn_action_terminate" },
    { 0x91970ABA, "bhtn_action_update" },
    { 0xC55A1666, "bhtn_failure" },
    { 0x49C36381, "bhtn_invalid" },
    { 0xF857017D, "bhtn_running" },
    { 0x0DD362F6, "bhtn_status" },
    { 0xBC2572C9, "bhtn_success" },
    { 0xE306DBDD, "bhtn_terminate" },
    { 0xE872E623, "bhtn_terminated" },
    { 0xB2A981A4, "bhtn_update_frequency" },
    { 0x904A80A9, "bhutan" },
    { 0xCE969AC2, "bias" },
    { 0x5A6DCBFD, "bias_change" },
    { 0x87438459, "bias_max" },
    { 0xE1E962E7, "bias_min" },
    { 0x2447A0B9, "bias_scale" },
    { 0x86EE99D5, "biased" },
    { 0x3A2F0473, "bidletillunload" },
    { 0x69877E65, "big" },
    { 0xFF21D806, "big1" },
    { 0x374DBAB9, "big_battle_ambience" },
    { 0x9E0B7421, "big_battle_loop_id" },
    { 0xCD23436B, "big_computer" },
    { 0x22C7546B, "big_damage" },
    { 0x14BD0D9D, "big_explosion" },
    { 0x3BD8137C, "big_flood" },
    { 0xD2875C42, "big_flood_hudson" },
    { 0x387455D0, "big_flood_player_knock_out" },
    { 0x5EB74D42, "big_fx" },
    { 0x254EE98E, "big_impact_effect" },
    { 0x13E4B4DC, "big_jump" },
    { 0x33225E42, "big_jump1_water_sheeting_trigger" },
    { 0x8AA3B9AB, "big_jump2_water_sheeting_trigger" },
    { 0xFB9F4C98, "big_jump3_water_sheeting_trigger" },
    { 0xDD3EB481, "big_jump4_water_sheeting_trigger" },
    { 0x572B603D, "big_jump_check_1" },
    { 0x7D2DDAA6, "big_jump_check_2" },
    { 0x903312AA, "big_kills_index" },
    { 0x24B10545, "big_kills_killstreak_index" },
    { 0xF4743F95, "big_kills_specialist_weapon_index" },
    { 0xD75E07EA, "big_medals_specialist_abilities_index" },
    { 0x958EE310, "big_objective_wins_index" },
    { 0x9A9795CA, "big_room_ai_2_delayed_spawn" },
    { 0x8C9BA759, "big_room_ai_2_spawn_from_ai_group" },
    { 0x9A6675B8, "big_room_ambient_electric_pulse" },
    { 0x496EB9EA, "big_room_breach_ambience" },
    { 0x877F5A8E, "big_room_breach_ambient_internal" },
    { 0xFAD92868, "big_room_brech_enemies_think" },
    { 0x3273FF60, "big_room_brech_enemies_think_internal" },
    { 0x6A692843, "big_room_chandelier_pulse" },
    { 0xE060DB14, "big_room_door_breach" },
    { 0x48B52025, "big_room_door_breach_finished" },
    { 0xC22927CC, "big_room_door_breach_player" },
    { 0xA5335DE7, "big_room_door_breach_woods" },
    { 0x89144BC7, "big_room_dust_spill" },
    { 0x415A09AD, "big_room_electric_pulse_started" },
    { 0x79650CD8, "big_room_enemies_group" },
    { 0x0CC57001, "big_room_generic_pulse" },
    { 0x5EC91906, "big_room_guard_shot" },
    { 0xEFF6E039, "big_room_lowready_off" },
    { 0x586D8C2F, "big_room_open_door" },
    { 0xBC23BBFE, "big_room_plane_whizby" },
    { 0xCACF64A7, "big_room_player_reset" },
    { 0xA2593DD7, "big_room_player_screen_shake_rumble" },
    { 0xBEA16C55, "big_room_player_setup" },
    { 0xEDFE6318, "big_room_start_slowmo" },
    { 0xB5C0CE1B, "big_room_timescale" },
    { 0x9C692F9F, "big_score_index" },
    { 0x34227855, "big_total_wins_index" },
    { 0xB25CC359, "bigbits" },
    { 0xF11FB796, "bigcontainer" },
    { 0x0A06AACD, "bigcontainerend" },
    { 0x83B2EE93, "bigdodsetcantmove" },
    { 0x50C6F2CD, "bigdog" },
    { 0xC7FA0E7E, "bigdog_add_fx" },
    { 0x6B154A4F, "bigdog_body_damage_scale" },
    { 0xB0CA3E84, "bigdog_body_damage_scale_ai" },
    { 0xAC14D56E, "bigdog_body_damage_scale_bigdog" },
    { 0x4E92D353, "bigdog_boss" },
    { 0x46C523B1, "bigdog_bullet_hint_trigger" },
    { 0xB24F9D11, "bigdog_can_use_launcher" },
    { 0xACAE2D9D, "bigdog_cant_move_anymore_pain" },
    { 0xB173F458, "bigdog_charged_or_sniper_weapon_pain" },
    { 0x525D9F8C, "bigdog_chase_enemy_behavior" },
    { 0xF8E762B0, "bigdog_combat" },
    { 0x420F65AA, "bigdog_damage_body" },
    { 0xBBCF5CE2, "bigdog_damage_leg" },
    { 0xDBB030E6, "bigdog_damage_override" },
    { 0x16D85B48, "bigdog_disconnect_path_interval" },
    { 0x613BCD2A, "bigdog_emp_anim" },
    { 0x5737C5D9, "bigdog_emp_pain" },
    { 0xD14BE327, "bigdog_emp_stun_time" },
    { 0x86807542, "bigdog_emped_behavior" },
    { 0x365C10DC, "bigdog_emped_done" },
    { 0x5CA35920, "bigdog_emped_lights_blinking" },
    { 0xF6F78A3B, "bigdog_explosive_body_pain" },
    { 0xDF9E8544, "bigdog_feet" },
    { 0xE953AEE9, "bigdog_fire_turret" },
    { 0xD0E4E954, "bigdog_globals" },
    { 0xD3D186E6, "bigdog_guards" },
    { 0x0308A6B8, "bigdog_has_target" },
    { 0xB70B19DD, "bigdog_hunkered_pain" },
    { 0x7019D146, "bigdog_init" },
    { 0x7F68FC12, "bigdog_initialize" },
    { 0xA5C823DD, "bigdog_is_body_hit" },
    { 0x4D177F17, "bigdog_is_leg_hit" },
    { 0x3A7A4491, "bigdog_isemped" },
    { 0x6BF70EE0, "bigdog_kill_all_fx_on_death" },
    { 0xC13B7273, "bigdog_launcher_fire" },
    { 0x5905D724, "bigdog_leg_charged_damage_scale" },
    { 0x15200A9F, "bigdog_leg_damage_scale" },
    { 0xC076C294, "bigdog_leg_damage_scale_ai" },
    { 0x91C7817E, "bigdog_leg_damage_scale_bigdog" },
    { 0x40102F33, "bigdog_leg_pain" },
    { 0xF3A698D1, "bigdog_lights_off" },
    { 0x80E619A5, "bigdog_lights_on" },
    { 0x9F28EEF7, "bigdog_mount" },
    { 0x81D26650, "bigdog_override" },
    { 0x71F973D0, "bigdog_pain" },
    { 0xF59C32C0, "bigdog_pain_interval" },
    { 0xD4344B6B, "bigdog_play_pain_anim" },
    { 0x4B0B2DE7, "bigdog_previs" },
    { 0xDB9644A7, "bigdog_setup" },
    { 0xA97A287A, "bigdog_speak" },
    { 0x60A24186, "bigdog_targeting_audio" },
    { 0x19DB3BB2, "bigdog_try_launcher" },
    { 0x7FB784CA, "bigdog_try_pain" },
    { 0x26158358, "bigdog_utility" },
    { 0xE251F6A2, "bigdogfootstepcbfunc" },
    { 0x1F808D48, "bigdoghandledisconnectpathswhilemoving" },
    { 0x64EF0A4C, "bigdogs" },
    { 0xABC084C2, "bigdogsquadid" },
    { 0x162C9280, "bigdogusebiggerbadplace" },
    { 0x3123E268, "bigeye" },
    { 0x35FB1EE7, "bigflood" },
    { 0xF2F09815, "bigger" },
    { 0x562DE3E8, "biggest_dot" },
    { 0x594D20A9, "biggestlives" },
    { 0x8D5E0A1E, "biggie" },
    { 0xBAF14083, "bighealth" },
    { 0x1C9D9168, "bigheight" },
    { 0x8325B365, "bigiconsize" },
    { 0xD12C969B, "bigmoss" },
    { 0xA1206447, "bignorechangeonmigrate" },
    { 0x992411A6, "bignoreminigameflag" },
    { 0xDA8912C1, "bignorespawninglimit" },
    { 0xB38966BD, "bigrig" },
    { 0xB3E4A67D, "bigrig_add_trailer" },
    { 0xE7E1B9D3, "bigrig_death_fx" },
    { 0x2F530AE5, "bigrig_spawn_claw" },
    { 0x1DBB3DB1, "bigrig_trailer_ai_nag_vo" },
    { 0x6F21815A, "bigrig_trailer_doors_open" },
    { 0x0B7F0B7C, "bigrigs" },
    { 0x093485F0, "bigroom" },
    { 0x33BB7D74, "bigs" },
    { 0xDD06D225, "bigscale" },
    { 0x8ABB9CAB, "bigwidth" },
    { 0xA169C179, "bik" },
    { 0x4433B396, "bike" },
    { 0x6D669A86, "bike_achievement" },
    { 0xB25DD2D6, "bike_achievement_add" },
    { 0x1481C502, "bike_damage" },
    { 0xB3A844E4, "bike_disable_invulnerability_over_time" },
    { 0xFA155F16, "bike_flag_set" },
    { 0x5E12BC50, "bike_setup_player" },
    { 0x93130BC9, "bike_sirens_on" },
    { 0x3A0D1AC8, "bike_smoke" },
    { 0x63B5C01B, "bike_start_audio_plr" },
    { 0x8A9212DD, "bike_tag_array" },
    { 0xC73F132E, "bike_tarp" },
    { 0x9657E30F, "bike_tarp_start" },
    { 0x33EDF3D5, "bike_truck_dist" },
    { 0xEE1A203D, "bikerisaiming" },
    { 0xE135F749, "bikerisarmed" },
    { 0x55FACF65, "bikershouldjump" },
    { 0xF5448312, "bikershouldland" },
    { 0xACEA4709, "bikes" },
    { 0x18E163E6, "bilboard" },
    { 0xE4CA7F5E, "billboard" },
    { 0x4BEF3CFE, "billboard_1_lookat_trigger" },
    { 0x35929646, "billboard_appear" },
    { 0xD76DF03D, "billboard_death_1" },
    { 0xFD706AA6, "billboard_death_2" },
    { 0x1C9FAEF1, "billboard_fadeout" },
    { 0x6915EE6C, "billboard_kill_screen" },
    { 0x33630AFE, "billboard_ragdoll" },
    { 0xCE953E9F, "billboardblack" },
    { 0x1C7750A3, "billboardname" },
    { 0xCF0A0F29, "billboardsize" },
    { 0xD03FCC7E, "billboardtype" },
    { 0x3D57AEE5, "billboardwhite" },
    { 0x40B7CF0C, "billion" },
    { 0xFF3AB88F, "billions" },
    { 0xA1E88D89, "billow_fx" },
    { 0x09173650, "billowing" },
    { 0x07B9FCA6, "binary" },
    { 0x23763F9E, "binclude_blank_worldspawn" },
    { 0x7637DA58, "bind" },
    { 0xE4299BEE, "bind_in_place" },
    { 0x6640507F, "bind_stub" },
    { 0x5B37D59C, "bind_to" },
    { 0x160E415F, "bindarray" },
    { 0xE4F85E6B, "binded" },
    { 0xD818AE4C, "bindindex" },
    { 0x89189D40, "binding" },
    { 0x484590A8, "bindtag" },
    { 0xE48FDAED, "binfov" },
    { 0xE83F4993, "bing" },
    { 0x5DAEF11E, "bingo" },
    { 0x8D0DE8F7, "binitialsnap" },
    { 0x50355FEF, "bink" },
    { 0x9E3B2952, "bink_alpha" },
    { 0x61465117, "bink_double_size" },
    { 0x91FD2271, "bink_fullscreen" },
    { 0x2C6BDFDF, "bink_in_memory" },
    { 0xDD28A219, "bink_is_looping" },
    { 0xD13B59C1, "bink_monitor_handler" },
    { 0xD670A30C, "bink_monitor_randomize" },
    { 0xC84AB754, "bink_monitor_zombies" },
    { 0x691B25EB, "bink_monitors" },
    { 0x70BF3695, "bink_normal_size" },
    { 0x4C311E27, "bink_start_paused" },
    { 0x2B051757, "bink_stock_footage_select" },
    { 0xE91DC460, "bink_sync_audio" },
    { 0x2D62CBEB, "bink_timeout" },
    { 0x509E8BA3, "bink_zombie_footage_select" },
    { 0xB9302636, "binks" },
    { 0xADD8A7AD, "binktv" },
    { 0x1FE2985E, "binladen" },
    { 0x1C7FCB1A, "binoc" },
    { 0xDA9135F5, "binoc_change" },
    { 0x1850604B, "binoc_fade_in" },
    { 0x7539D95E, "binoc_fade_out" },
    { 0x80F45EBD, "binoc_krav_guards_behavior" },
    { 0x61816AD0, "binoc_off" },
    { 0xA68E964A, "binoc_on" },
    { 0xF3947BB1, "binoc_scene_time" },
    { 0xE341F292, "binoc_scientist_behavior" },
    { 0xBEFE7B55, "binoc_sniper_behavior" },
    { 0xCFCED653, "binoc_snipers_basewalk_behavior" },
    { 0x3293E466, "binoc_snipers_basewalk_spawners" },
    { 0x1C3065E2, "binoc_vehicle_snapshot" },
    { 0x3151E615, "binocs" },
    { 0x59F7CBA7, "binocs_attach" },
    { 0x51B96B19, "binocs_delete" },
    { 0x5DDCEFAD, "binocs_detach" },
    { 0x40E01DA0, "binocular" },
    { 0x7790A018, "binocular_anim" },
    { 0x392D5947, "binocular_anim_ambience" },
    { 0x14C4811B, "binocular_done" },
    { 0x79182038, "binocular_exposure" },
    { 0xCB13D38C, "binocular_fov" },
    { 0x50242AA0, "binocular_look_end" },
    { 0x69053E65, "binocular_scene_1" },
    { 0x257AF05D, "binocular_scene_1_vo" },
    { 0x441D1473, "binocular_scope_setup_complete" },
    { 0x717651CC, "binocular_zoom_in" },
    { 0x520FD14B, "binoculars" },
    { 0x96947781, "binoculars_anim" },
    { 0xB2544A8E, "binoculars_cleanup" },
    { 0xA302B90A, "binoculars_listener" },
    { 0x803AE85C, "binoculars_scene_complete" },
    { 0x47AC4466, "binoculars_trigger" },
    { 0xA8C61232, "binoculars_zoomed_in" },
    { 0x3973AB1D, "bio" },
    { 0xE718A459, "bio_breach_rumble" },
    { 0x47B3DB90, "biodome" },
    { 0xF6D8A091, "biodome_breach_fx" },
    { 0xF50C02D2, "biodome_clip1" },
    { 0xCF098869, "biodome_clip2" },
    { 0x90737D4B, "biodome_compromised" },
    { 0xF1CCDCE9, "biodome_pads" },
    { 0x4251B97B, "biodomes" },
    { 0xBA33B4A9, "biometric" },
    { 0x976DF632, "biosensors" },
    { 0xBE4D7D9C, "biplane_clue" },
    { 0xFF6127FB, "biplane_down" },
    { 0x66676ABF, "bipod" },
    { 0x3A4678C6, "bipods" },
    { 0x355714DC, "bird" },
    { 0x8D75D3E4, "bird_orig" },
    { 0x03BD9D0B, "bird_takeoff_struct" },
    { 0xC2507F81, "birdbath_trigger_thread" },
    { 0xA644EC1F, "birds" },
    { 0x7285558B, "birds_eye_view" },
    { 0x8344D65F, "birthtime" },
    { 0x58575295, "bisdrone" },
    { 0x6167B470, "bisgettin" },
    { 0xBE4FF288, "bisgunner" },
    { 0x038D0DEE, "bispose" },
    { 0x66A82196, "bisstruct" },
    { 0x503E20B0, "biswingman" },
    { 0x2F62523E, "bit" },
    { 0x56147E02, "bit_count" },
    { 0xAF806410, "bit_hit" },
    { 0x8A3AAFDB, "bitch" },
    { 0xB0FCEA9F, "bitches" },
    { 0x16AFD045, "bitching" },
    { 0xF8445914, "bitchm" },
    { 0xD4C1C307, "bite" },
    { 0x26B3F31F, "bitflags" },
    { 0xDCA80742, "biting" },
    { 0x3130B776, "bitmask" },
    { 0x06A8FFA7, "bitoffset" },
    { 0x50DA8B21, "bits" },
    { 0xF49E6596, "bitstream" },
    { 0xA7370577, "bitter" },
    { 0x1B3FA080, "biz" },
    { 0x76B1A20A, "bjoyal" },
    { 0x6727D90D, "bk_dialogue" },
    { 0x0D23CDE3, "bkeepguy" },
    { 0x4E7DC252, "bkilled" },
    { 0xA70F52FD, "bkillfreevehicle" },
    { 0x94FA47F2, "bkillplayer" },
    { 0x95B7573B, "bkup" },
    { 0x8D921CC5, "bkwd" },
    { 0xBC217E53, "bl" },
    { 0x88771DC7, "bl_left_shudder" },
    { 0xC6E5A00E, "bl_right_shudder" },
    { 0xA870BC22, "black" },
    { 0x01D22B15, "black_background" },
    { 0x39F0992C, "black_bg" },
    { 0x0CEE28FA, "black_box_end" },
    { 0x2DCC7301, "black_box_start" },
    { 0x25626F6C, "black_distance" },
    { 0x2AAC6F7B, "black_hole_activated" },
    { 0xB52C1C52, "black_hole_attract_dist_diff" },
    { 0x3E04DBDF, "black_hole_bomb_anim_init" },
    { 0x1170421F, "black_hole_bomb_arrival_attract_func" },
    { 0x227DE6FF, "black_hole_bomb_attract_dist" },
    { 0x9F3133BA, "black_hole_bomb_attract_run" },
    { 0xBC42BB34, "black_hole_bomb_attract_walk" },
    { 0xC6656A2C, "black_hole_bomb_being_pulled_fx" },
    { 0xE0CDE323, "black_hole_bomb_blown_up" },
    { 0x5C13772B, "black_hole_bomb_cleanup" },
    { 0x2F9D4E1E, "black_hole_bomb_corpse_collect" },
    { 0x00298289, "black_hole_bomb_corpse_delete" },
    { 0x8C64A718, "black_hole_bomb_corpse_hide" },
    { 0x587239F1, "black_hole_bomb_create_exit_portal" },
    { 0x1209E51B, "black_hole_bomb_death_anim" },
    { 0x0CB14A25, "black_hole_bomb_death_start_func" },
    { 0xAFD46232, "black_hole_bomb_death_while_attracted" },
    { 0xCFDAD941, "black_hole_bomb_escaped_zombie_reset" },
    { 0x11E82050, "black_hole_bomb_event_horizon_death" },
    { 0xC5B223CD, "black_hole_bomb_exists" },
    { 0x37AB29DD, "black_hole_bomb_exit_clean_up" },
    { 0x5217A62E, "black_hole_bomb_initial_attract_func" },
    { 0xC4AD343D, "black_hole_bomb_kill" },
    { 0x19AB2FFC, "black_hole_bomb_kill_counter" },
    { 0x5FC80AD9, "black_hole_bomb_loc_check_func" },
    { 0x51EC0E40, "black_hole_bomb_poi_arrival_attract_func" },
    { 0x6D2B3F89, "black_hole_bomb_poi_initial_attract_func" },
    { 0xAEDC4B92, "black_hole_bomb_pulled_in_fx_clean" },
    { 0x18844F2C, "black_hole_bomb_stolen_by_sam" },
    { 0x860175B0, "black_hole_bomb_store_movement_anim" },
    { 0xED095C69, "black_hole_bomb_teleport_init" },
    { 0x5061E719, "black_hole_bomb_throttle_anim_changes" },
    { 0x773EA274, "black_hole_bomb_trigger_monitor" },
    { 0xC528C7F1, "black_hole_center" },
    { 0x6AF08767, "black_hole_complete" },
    { 0x437A4164, "black_hole_deployed" },
    { 0x65616FBD, "black_hole_fx_start" },
    { 0xC0BD0A11, "black_hole_kills_achievement" },
    { 0xD26CE224, "black_hole_on_player_connect" },
    { 0x9A440DCC, "black_hole_on_player_spawned" },
    { 0x9C0B0E0B, "black_hole_teleport" },
    { 0xAE7DE6CC, "black_hole_teleport_add_trigger_to_ent" },
    { 0x12B91AF0, "black_hole_teleport_cancel" },
    { 0xA72303F3, "black_hole_teleport_ent_already_in_trigger" },
    { 0x4421F0A4, "black_hole_teleport_remove_trigger_from_ent" },
    { 0x3BC48314, "black_hole_teleport_structs" },
    { 0x21BC3F25, "black_hole_teleport_trigger_thread" },
    { 0xEF2AAE65, "black_hole_time_before_teleport" },
    { 0xFA8D8743, "black_hole_vision_set" },
    { 0x76A11D51, "black_hole_visionset_switch" },
    { 0x15D04F77, "black_hole_visionset_think" },
    { 0x13471301, "black_hole_zombie_being_pulled" },
    { 0x2547248B, "black_overlay" },
    { 0x031489D5, "black_screen" },
    { 0xB43C0F4B, "black_screen_wait" },
    { 0xE7409226, "black_time" },
    { 0x96515E2A, "blackboard" },
    { 0x5BEF5163, "blackboard_vehicle" },
    { 0xAFF35E73, "blackboardattributename" },
    { 0x8520A61D, "blackboardvalue" },
    { 0xB0C6B559, "blackbox" },
    { 0xB6413D32, "blackboxclasschoice" },
    { 0x28DE1E3E, "blackboxeventname" },
    { 0x22E172BF, "blacken" },
    { 0x3F047F71, "blackhawk" },
    { 0xED0002D2, "blackhawk_anims" },
    { 0xD61A17B9, "blackhawk_arrive" },
    { 0xAA55953C, "blackhawk_collision" },
    { 0x147C3D4F, "blackhawk_death_fx" },
    { 0x2BDE8EE7, "blackhawk_death_trigger" },
    { 0x60F78869, "blackhawk_explosion" },
    { 0x538FA74B, "blackhawk_land" },
    { 0xCF28A28B, "blackhawk_mp" },
    { 0x03C2BAC8, "blackhawk_node" },
    { 0x96F365CF, "blackhawk_overrides" },
    { 0xD5087B19, "blackhawk_sound" },
    { 0x0D7DA8E4, "blackhawk_think" },
    { 0x5246EED8, "blackhawks" },
    { 0xAA33FEBC, "blackhole" },
    { 0xA5A65454, "blackhole_bomb_area_check" },
    { 0x371653E5, "blackhole_bomb_in_invalid_area" },
    { 0x2A5EEC13, "blackholebomb_pull_fast" },
    { 0xC1F82BBA, "blackholebomb_pull_slow" },
    { 0x0C843B28, "blackholebomb_pull_state" },
    { 0xA83D0747, "blackjack" },
    { 0x145FE99F, "blackjack_body_index" },
    { 0x2AD2D09C, "blackjack_challenges" },
    { 0x7C1F0A50, "blackjack_specialist_index" },
    { 0x1392A7CF, "blackjack_specialist_kills" },
    { 0x5CA54D4B, "blackjack_unique_specialist_kills" },
    { 0x1DC6CB86, "blacklist" },
    { 0x402D27D7, "blackness" },
    { 0xF0D85D72, "blackops" },
    { 0xE120682E, "blackout" },
    { 0xCEF8120F, "blackout_amb" },
    { 0xFE6C1E12, "blackout_anim" },
    { 0x8BEF792C, "blackout_art" },
    { 0x0ED7C84A, "blackout_bridge" },
    { 0x67A337B5, "blackout_cctv_2_done" },
    { 0x44EDC8AA, "blackout_code" },
    { 0xBF503706, "blackout_deck" },
    { 0xF9E25061, "blackout_defend" },
    { 0xBB137655, "blackout_door" },
    { 0x497BF6EF, "blackout_fence_down" },
    { 0x0CCA89AA, "blackout_fence_swap" },
    { 0x0D692740, "blackout_fence_up" },
    { 0x0E0C6FEA, "blackout_first_price_node" },
    { 0xAE11A750, "blackout_flashlight_death" },
    { 0x6961F55F, "blackout_flashlight_guy" },
    { 0x199F9901, "blackout_flashlight_guy_attacks" },
    { 0xD8CF58CE, "blackout_flashlight_kill_player" },
    { 0x95CEF4FB, "blackout_fx" },
    { 0x8867C649, "blackout_guy_animates" },
    { 0x3FB92DCE, "blackout_guy_animates_loop" },
    { 0xCC1DF1A7, "blackout_guy_animates_once" },
    { 0x56366A5A, "blackout_guy_leaves_ignore" },
    { 0x18C94B94, "blackout_hangar" },
    { 0x2A6E0C2B, "blackout_house" },
    { 0x9773620A, "blackout_interrogation" },
    { 0x0540C8A0, "blackout_level_num" },
    { 0x3231D4E2, "blackout_lights_go_out" },
    { 0xD9B5481A, "blackout_menendez_start" },
    { 0x35367E55, "blackout_menendez_walk" },
    { 0x16F9AA86, "blackout_missionsuccess" },
    { 0x9168F186, "blackout_path_block" },
    { 0xC45E71A6, "blackout_rescue" },
    { 0x6E71A4EC, "blackout_rescue_complete" },
    { 0xBD40293E, "blackout_ru1_gogo" },
    { 0xF445E34B, "blackout_security" },
    { 0xCDF61535, "blackout_sensitive_geo" },
    { 0xB0680F0A, "blackout_server_room" },
    { 0x4A615BDA, "blackout_shield" },
    { 0x3B4FDDA9, "blackout_shield_max_turn" },
    { 0x3BBC5ED5, "blackout_spotlight_model" },
    { 0x74B6C7A2, "blackout_spotlights" },
    { 0xBD13D90A, "blackout_stealth_settings" },
    { 0xF1A2A62A, "blackout_time" },
    { 0x243D0E79, "blackout_upstairs_spotlight" },
    { 0xAA5E25A1, "blackout_util" },
    { 0x8D171B25, "blackout_vision_adjustment" },
    { 0x00D9FB12, "blackout_wait" },
    { 0x372A640D, "blackoutwait" },
    { 0x9C5124AE, "blackscreen" },
    { 0x16F9AD6E, "blackscreen1_dialog" },
    { 0x7CD415DB, "blackscreen2_dialog" },
    { 0x739B0286, "blackscreen_cb" },
    { 0x59394D9B, "blackscreen_finished" },
    { 0x09CA688D, "blackscreenwait" },
    { 0x5283CA2E, "blackstation" },
    { 0xFEC2BED1, "blade" },
    { 0xD806DC4A, "blade1" },
    { 0xB20461E1, "blade2" },
    { 0x8C01E778, "blade3" },
    { 0x96134057, "blade4" },
    { 0x7010C5EE, "blade5" },
    { 0x8D95170F, "blade_center" },
    { 0x007281D7, "blade_left" },
    { 0xF414B355, "blade_pieces" },
    { 0x4559DF92, "blade_right" },
    { 0xAB6ACE70, "blade_sounds" },
    { 0x707D5F0C, "blade_spin_speed" },
    { 0x659BA770, "blade_spin_up_time" },
    { 0x874AD011, "bladekill" },
    { 0x0CA081B8, "blades" },
    { 0x41FF2D48, "blah" },
    { 0xB2DE6951, "blah1" },
    { 0xD8E0E3BA, "blah2" },
    { 0x223B19D5, "blahblah" },
    { 0x5F579F61, "blahrg" },
    { 0x683B7D62, "blame" },
    { 0x3FCDDCE9, "blammo" },
    { 0x90F415C9, "blank" },
    { 0x6A85899B, "blank_array" },
    { 0x847E2985, "blank_shot_fx" },
    { 0xE75E82C0, "blanks" },
    { 0x05D8A9CA, "blares" },
    { 0xB2938FC3, "blargh" },
    { 0x76EDA500, "blased" },
    { 0x97E1A565, "blast" },
    { 0xFFA5A9D6, "blast_deflector" },
    { 0x45F8BB28, "blast_door" },
    { 0x56D1E141, "blast_door_clip" },
    { 0x2DC5EC79, "blast_door_player_clip" },
    { 0x59999862, "blast_doors_close" },
    { 0x6E8C313C, "blast_furnace_explosion" },
    { 0x2CCBCFCB, "blast_furnace_zombie_burn" },
    { 0xD1AB0CD7, "blast_off" },
    { 0xBE7E2188, "blast_off_fx" },
    { 0x66E724FA, "blast_radius" },
    { 0xD4BED1DE, "blast_volume" },
    { 0xF91E1BCD, "blastdoor" },
    { 0xA94A4A92, "blastdoor_clip" },
    { 0xF17BB1BF, "blastdoor_good" },
    { 0xE6861052, "blasted" },
    { 0x1D0F05AD, "blasted_wall" },
    { 0xCF4AE4C3, "blasting" },
    { 0x266F778F, "blastradius" },
    { 0x2BA6E274, "blasts" },
    { 0x076F845B, "blb" },
    { 0x4398B618, "bldg" },
    { 0xB327ABAF, "bldgid" },
    { 0x5BC8ADC0, "bldgtarget1" },
    { 0xCDD01CFB, "bldgtarget2" },
    { 0x50B5668B, "blead" },
    { 0x5A23D64A, "blead_on_death" },
    { 0x76B97208, "bled" },
    { 0x55838FCD, "bled_out" },
    { 0xA6A34374, "bledout" },
    { 0x83F13827, "bleed" },
    { 0xF0F1FB8E, "bleed_amount" },
    { 0x8B8EDD3E, "bleed_out" },
    { 0x001E5BEC, "bleeded" },
    { 0x14410DAA, "bleeder" },
    { 0x3B59F5FE, "bleeder_bleed_to_death" },
    { 0xFA243615, "bleeder_death" },
    { 0x822CE838, "bleeder_getup" },
    { 0x2EC87719, "bleederbleedouttimemax" },
    { 0x896E55A7, "bleederbleedouttimemin" },
    { 0xE4E02304, "bleederdebugprintthread" },
    { 0x18168C7A, "bleederdistancefromground" },
    { 0x9A71B12A, "bleedergetupanim" },
    { 0x988816F9, "bleeding" },
    { 0x8173C26E, "bleedloopanim" },
    { 0x8C38AE95, "bleedout" },
    { 0x472C0FA0, "bleedout_listener" },
    { 0xEE5B7607, "bleedout_respawn_listener" },
    { 0xB939DB43, "bleedout_time" },
    { 0x14579A95, "bleedout_time_default" },
    { 0x519AFAD2, "bleedouttime" },
    { 0x630FA974, "bleedrangemax" },
    { 0xAD2E63C1, "bleedrangemaxtext" },
    { 0x8DA1B4BA, "bleedrangemin" },
    { 0x2D7BFDC7, "bleedrangemintext" },
    { 0xE284209E, "bleeds" },
    { 0x8966E181, "bleeeds" },
    { 0xDEAF8864, "bleh" },
    { 0x9B8E7DD2, "blend" },
    { 0x07237634, "blend2" },
    { 0x682B0916, "blend_anim" },
    { 0xF790A2A3, "blend_desert_tunnel" },
    { 0x661C5635, "blend_exposure_over_time" },
    { 0xD8D342F8, "blend_in" },
    { 0x062E8164, "blend_melee_range_sq" },
    { 0x39108BB1, "blend_notetracks" },
    { 0xC2D23FF7, "blend_out" },
    { 0xD676B2F6, "blend_time" },
    { 0x688B76CE, "blendamount" },
    { 0x09DC7F33, "blenddelete" },
    { 0x544A00E5, "blended" },
    { 0x98446FAB, "blendinduration" },
    { 0x9E5E78DE, "blending" },
    { 0xD705D5A0, "blendintime" },
    { 0xFFC19625, "blendintocrouchrun" },
    { 0xA54570B5, "blendintocrouchwalk" },
    { 0xCDF95767, "blendintostandrun" },
    { 0x1EB31B2B, "blendintostandwalk" },
    { 0x1E3EF47E, "blendout" },
    { 0x7301BF82, "blendoutduration" },
    { 0x1E983331, "blendouttime" },
    { 0xADC48ADD, "blends" },
    { 0xE32B30ED, "blendtime" },
    { 0xF2D8F247, "blendval" },
    { 0x94C81CEA, "blendweight" },
    { 0x1B79FDA5, "blendweights" },
    { 0xE0F27177, "bles" },
    { 0x5BC0A6AE, "bless" },
    { 0x48E887D3, "blew" },
    { 0xF318A8F2, "blew_house_with_flak" },
    { 0x916C76B6, "blind" },
    { 0x4214A26F, "blind01" },
    { 0xD00D3334, "blind02" },
    { 0xF60FAD9D, "blind03" },
    { 0x84083E62, "blind04" },
    { 0xAA0AB8CB, "blind05" },
    { 0x38034990, "blind06" },
    { 0x5E05C3F9, "blind07" },
    { 0x56A91DD3, "blind_corner_spawner_sound" },
    { 0xE82D1942, "blind_guy_dies_soon" },
    { 0x73599936, "blind_guy_gets_flashed" },
    { 0x9A5E5506, "blind_guy_spawners" },
    { 0xE6A0B2D3, "blind_guy_think" },
    { 0x1D92F473, "blindaccuracymult" },
    { 0x441C4669, "blindeye" },
    { 0xEDE544B2, "blindfire" },
    { 0x4A0CCC5E, "blindfireaimexist" },
    { 0x12A9DCCD, "blindfireanim" },
    { 0x2E4F2477, "blindfiremode" },
    { 0x24AE6FAE, "blindfiremodes" },
    { 0xABC1033D, "blindfires" },
    { 0xEEA8F095, "blindfiretimemax" },
    { 0x193AFBDB, "blindfiretimemin" },
    { 0x0B969863, "blindfiring" },
    { 0xCDE572A6, "blindspot" },
    { 0xE637B219, "blindspottime" },
    { 0x0373E5F1, "blink" },
    { 0xDA48D96A, "blink1" },
    { 0xB4465F01, "blink2" },
    { 0xEB893DD9, "blink_color" },
    { 0xAC7ADC4B, "blink_crosshairs" },
    { 0x73AF758E, "blink_crosshairs_stop" },
    { 0x83AA3594, "blink_fx_and_sound" },
    { 0xED6ABD4B, "blink_hud_elem" },
    { 0xB68530C0, "blink_light" },
    { 0xD8666C51, "blink_lights_for_time" },
    { 0xA8795AFF, "blink_on" },
    { 0xA4A3CC6F, "blink_once" },
    { 0x07C3811A, "blink_primary_lights" },
    { 0xE957EADC, "blink_race_arrows" },
    { 0x384869D0, "blink_warning" },
    { 0x3728D89E, "blinked" },
    { 0x60C3D7CC, "blinkeye" },
    { 0xC381DE57, "blinking" },
    { 0x2D608820, "blinking_ambient_civs" },
    { 0x8C39AFFD, "blinking_time" },
    { 0x6BAA3AC0, "blinking_weapon_name_hud_elem" },
    { 0xA9D906FF, "blinkingduration" },
    { 0xD5CCBFF6, "blinklights" },
    { 0x70D8A7ED, "blinkout_time" },
    { 0x0DA54A58, "blinks" },
    { 0x538F1FC2, "blinkspeed" },
    { 0x28B2D9A5, "blinkstage" },
    { 0x5F651A20, "blinkstarttime" },
    { 0x29966BE2, "blinky" },
    { 0x0B4AF800, "blinky_effect_ent" },
    { 0x61B2D7A3, "blinky_emp_wait" },
    { 0xD5B14BEF, "blinky_light" },
    { 0xB700E5AC, "blinkylightfx" },
    { 0xA8F94DC8, "blip" },
    { 0xA73E89BC, "blister" },
    { 0x6B879FA1, "blister_light" },
    { 0x4692F38C, "blistering" },
    { 0x5F62C64E, "blitz" },
    { 0x3110742E, "blitzes" },
    { 0x04364616, "blitzkrieg" },
    { 0xA05932E9, "blitzkriegtime" },
    { 0xBB5C07FB, "blizzard" },
    { 0x239E4079, "blizzard_intensity" },
    { 0xE2CF0F5F, "blizzard_intensity_updater" },
    { 0x93C9265D, "blizzard_off" },
    { 0xAFAF158E, "blizzard_shot" },
    { 0x4E63CA2D, "bloat" },
    { 0x66EAB20E, "bloat_fraction" },
    { 0xF3B96237, "bloat_max_fraction" },
    { 0x36843348, "blob" },
    { 0x6CEA6A63, "blobs" },
    { 0x77377840, "block" },
    { 0xB480182A, "block_ai_from_street" },
    { 0x535C5821, "block_brush" },
    { 0x5556D233, "block_elev_doors" },
    { 0xFF382325, "block_elev_doors_internal" },
    { 0xC1B8A2FA, "block_intruder" },
    { 0x06F0DC0A, "block_path" },
    { 0x498DDDD5, "block_pbr" },
    { 0x8CBD1FB8, "block_player" },
    { 0xBD973A33, "block_player_damage_fortime" },
    { 0x1EEB9910, "block_save" },
    { 0xDF2280F4, "block_save_count" },
    { 0x141499D8, "blockable" },
    { 0xF1D3D1D0, "blockade" },
    { 0x1010A4D8, "blockade_destroyed_time" },
    { 0x3D566EDF, "blockade_scaffolding_damage_triggers" },
    { 0x7FE77841, "blockage" },
    { 0xDDFB97F5, "blockage_walkway_damage_trigger" },
    { 0x8A6CEE06, "blockalldamage" },
    { 0xB33B795B, "blockarea" },
    { 0x60BAD887, "blockarray" },
    { 0x4B7F4CD3, "blocked" },
    { 0x1EFDD96A, "blocked_enemies" },
    { 0x28FA3D36, "blocked_enemy_flags" },
    { 0xED68C76D, "blocked_nodes" },
    { 0x7A577AEA, "blockednodes" },
    { 0xA7A3AAD2, "blockedoff" },
    { 0xECD00C5A, "blockedsatellite" },
    { 0x3B0A8A34, "blockentsinarea" },
    { 0x375C9B15, "blocker" },
    { 0x6CC338E8, "blocker1_conversation" },
    { 0xD519AB60, "blocker_anim_func" },
    { 0x4783790A, "blocker_attack_spots" },
    { 0xD254C6E0, "blocker_choke" },
    { 0xD9A88D6F, "blocker_connect_paths" },
    { 0x97AA4776, "blocker_control_thread" },
    { 0x5DDDE12C, "blocker_disable" },
    { 0x374581AB, "blocker_disconnect_paths" },
    { 0xECA25B01, "blocker_doubler_hint" },
    { 0x067743D5, "blocker_enable" },
    { 0x927B527A, "blocker_func" },
    { 0xB5323A78, "blocker_hacked" },
    { 0xEEC1A2DE, "blocker_init" },
    { 0x906AEA5C, "blocker_locations" },
    { 0x3D7DA13F, "blocker_model" },
    { 0x86501956, "blocker_model_promote" },
    { 0xB6C7F8DE, "blocker_model_remove" },
    { 0x87803301, "blocker_name" },
    { 0x5799616C, "blocker_node" },
    { 0x408928DC, "blocker_node_target" },
    { 0xA868AC52, "blocker_rubble" },
    { 0x3D0B0AFC, "blocker_smash" },
    { 0xF26B0AF0, "blocker_think" },
    { 0xDAC07FA6, "blocker_trig" },
    { 0x45E813ED, "blocker_trigger_targetname" },
    { 0x9640BCAD, "blocker_trigger_think" },
    { 0x7AC909CF, "blocker_unitrigger_think" },
    { 0xABED6E57, "blocker_update_prompt_visibility" },
    { 0x7276A3A3, "blockerclip" },
    { 0x438669EC, "blockerend" },
    { 0x29E85964, "blockers" },
    { 0x287A189C, "blockers_ai_think" },
    { 0x1723B869, "blockers_lower_list" },
    { 0x225069E0, "blockers_raise_list" },
    { 0x6808CC87, "blockerstart" },
    { 0x89158E58, "blockerstub_update_prompt" },
    { 0x710F4B7B, "blockertrigger" },
    { 0x900E853E, "blockertrigger_update_prompt" },
    { 0xD99702DA, "blockfastdelivery" },
    { 0xDDF71858, "blocking" },
    { 0xBAC453EC, "blocking_bouncer_vo_and_wristband" },
    { 0xDF53C854, "blocking_club_bouncer" },
    { 0xB9F1E733, "blocking_done" },
    { 0x4D10FE92, "blocking_fence" },
    { 0xB0960F79, "blocking_fence_falls" },
    { 0x5644F8B3, "blocking_point" },
    { 0x68FBCFF5, "blocking_point_2_heli_shot_down" },
    { 0xE5C47FE1, "blocking_point_2_kill_helis" },
    { 0x93649A91, "blocking_point_chooser" },
    { 0x307FE490, "blocking_point_for_waves" },
    { 0xC6FC98D3, "blocking_pt_1" },
    { 0x54F52998, "blocking_pt_2" },
    { 0x7AF7A401, "blocking_pt_3" },
    { 0xF3337128, "blocking_tank1" },
    { 0x667AA308, "blockingpain" },
    { 0x663E1CFA, "blockingpoint" },
    { 0xA64503CC, "blockout" },
    { 0xC85500CE, "blockpos" },
    { 0xB5F48FA2, "blockprops" },
    { 0xFE32156B, "blocks" },
    { 0xF945839B, "blocksight" },
    { 0x949E4FEA, "blockstairs" },
    { 0xFCC6770B, "bloddy" },
    { 0xFC82FFD4, "blongwait" },
    { 0x050F69B3, "blood" },
    { 0x4DDE8EA5, "blood_decal" },
    { 0x5C169D03, "blood_drop_effect" },
    { 0x5D7BE315, "blood_enabled" },
    { 0x4207AE26, "blood_exploder_active" },
    { 0xA1F9EB68, "blood_eyes" },
    { 0xCDF3AAD1, "blood_fade_rate" },
    { 0xCE715C8F, "blood_frame_pass" },
    { 0xB3867C29, "blood_full" },
    { 0xD188A13F, "blood_guy_falling" },
    { 0x38DA9C25, "blood_hud" },
    { 0xB52F6A76, "blood_hud_destroy" },
    { 0x704EC8BF, "blood_in" },
    { 0x812DF055, "blood_off" },
    { 0x2BD5D4EA, "blood_out" },
    { 0x1BCC3334, "blood_overlay_model" },
    { 0x6CC0D980, "blood_patch" },
    { 0xEEDD8608, "blood_pool" },
    { 0x4647309A, "blood_shoulder" },
    { 0xF86213C6, "blood_splat" },
    { 0x615B8D96, "blood_splat_life_change" },
    { 0xFCFD2591, "blood_splat_logic" },
    { 0x1853A41C, "blood_splat_started" },
    { 0xF1716314, "blood_splats_overlay" },
    { 0xB0EDF9D4, "blood_splatter_enhancement" },
    { 0x9A69AB67, "blood_sprite_heavy_pass" },
    { 0x2B4A1FD0, "blood_sprite_light_pass" },
    { 0xE79B83D0, "blood_stage_1_threshold" },
    { 0xDDCD9C67, "blood_stage_2_threshold" },
    { 0xCAA4DD22, "blood_stage_3_threshold" },
    { 0xFC2A5BE6, "blood_tag" },
    { 0x56848A19, "blood_tags" },
    { 0x78A11C07, "blood_wetness" },
    { 0x70A8B9BC, "bloodbath" },
    { 0xD6DC1656, "bloodcloud" },
    { 0x9EEF4F68, "blooded" },
    { 0x85260145, "bloodfx" },
    { 0x75B4710B, "bloodfxhandle" },
    { 0x6C638239, "bloodimpact" },
    { 0x08B41E70, "bloodimpacts" },
    { 0xFCDA0DB3, "bloodlust" },
    { 0x46367C6D, "bloodmodels" },
    { 0x57728225, "bloodpool" },
    { 0xD384ED7A, "bloodspray" },
    { 0xF04F05C8, "bloodstage1" },
    { 0x62567503, "bloodstage2" },
    { 0x3C53FA9A, "bloodstage3" },
    { 0x10C3B7CC, "bloodthirsty" },
    { 0xD38E7CD8, "bloody" },
    { 0x8C969347, "bloody_death" },
    { 0x5AD5E8CC, "bloody_death_after_wait" },
    { 0x99CA831D, "bloody_death_array" },
    { 0xBC1ED5A0, "bloody_death_delayed" },
    { 0xEACD2F18, "bloody_death_fx" },
    { 0xF60782AB, "bloody_death_magicbullet" },
    { 0xD30E94EB, "bloody_kill" },
    { 0x1EB4C8CD, "bloody_knife_kill" },
    { 0xFA248035, "bloody_menendez" },
    { 0x36135489, "bloody_model_death" },
    { 0x2C23B9A7, "bloody_pendant" },
    { 0x8FD70E63, "bloody_tarp_blocker" },
    { 0xD3944F1D, "bloody_tarp_init" },
    { 0xB66F3D43, "bloody_woods" },
    { 0xAEF91C02, "bloom" },
    { 0xE725670C, "bloom_in_time" },
    { 0xE2B6094D, "bloom_out_time" },
    { 0xE64439FB, "bloom_tag" },
    { 0x2A650B67, "bloomy" },
    { 0xD75EF719, "blooping" },
    { 0x007E5E98, "blossom" },
    { 0x7BBD3C39, "blossom_radius" },
    { 0x54B83DE5, "blow" },
    { 0xA3CCE547, "blow_bridge" },
    { 0x76BC5BB2, "blow_car" },
    { 0x0609C5B5, "blow_defend_gates" },
    { 0x932704F2, "blow_gazebo" },
    { 0xBC5B116D, "blow_gravestones" },
    { 0xB2615508, "blow_gun_hit" },
    { 0xAD869743, "blow_hole_in_bunker_wall" },
    { 0x52B8FD75, "blow_hq_with_flak" },
    { 0x3EFD3CBF, "blow_it" },
    { 0x482867F8, "blow_tank" },
    { 0x91A08969, "blow_the_gate" },
    { 0x5F097CA0, "blow_the_wall" },
    { 0x82B71671, "blow_the_wall_dialogue" },
    { 0x8A1F8706, "blow_torch" },
    { 0xC7DFA22F, "blow_up" },
    { 0xA2EEAB62, "blow_up_at_end_node" },
    { 0x4CA5BA3E, "blow_up_building" },
    { 0x5A2DEEB7, "blow_up_hangar_1" },
    { 0xE8267F7C, "blow_up_hangar_2" },
    { 0x0E28F9E5, "blow_up_hangar_3" },
    { 0x9C218AAA, "blow_up_hangar_4" },
    { 0x4B00F318, "blow_up_hotel" },
    { 0x113CE811, "blow_up_msg" },
    { 0x37F8B7A1, "blow_up_remaining_deck_vtols" },
    { 0x82128991, "blow_up_tower" },
    { 0xF948AF78, "blow_up_vehicle_at_spline_end" },
    { 0xDF8F301D, "blow_up_waver" },
    { 0x8443CA6F, "blow_up_waver_old" },
    { 0xFB5789CE, "blow_whistle" },
    { 0x35503550, "blowback" },
    { 0x31CB1243, "blowing" },
    { 0x373E6C67, "blowing_barricade" },
    { 0xF4FEAECC, "blowmeup" },
    { 0x4F5DB171, "blown" },
    { 0xB0376BBB, "blown_bridge" },
    { 0xD1D2F28F, "blown_drums" },
    { 0x39B54C55, "blown_heads" },
    { 0x5312A512, "blown_targetname" },
    { 0xD1A35A5A, "blownup" },
    { 0xC372675B, "blowout" },
    { 0x945ED4BE, "blowout_goalradius_on_pathend" },
    { 0xF178F3F4, "blows" },
    { 0xA6F4806D, "blowspot" },
    { 0xF96CBD7E, "blowspot1" },
    { 0xD36A4315, "blowspot2" },
    { 0xAD67C8AC, "blowspot3" },
    { 0x52C19FD9, "blowtorch" },
    { 0xDEABA16E, "blowtrigs" },
    { 0x7860E356, "blowup" },
    { 0x5CB0015B, "blowup1" },
    { 0x78936BAB, "blowup_origin" },
    { 0x2CFB7146, "blowup_riders" },
    { 0xED58337A, "blowupdronestrike" },
    { 0x13DF154A, "blowuping" },
    { 0xAC170AA2, "blt_imp" },
    { 0x34380575, "blt_st" },
    { 0x0A8886E1, "blue" },
    { 0x9EC35148, "blue_background" },
    { 0x5A13C204, "blue_building" },
    { 0x338D359C, "blue_guys" },
    { 0x267FDABE, "blue_new" },
    { 0x7E7BCA27, "blue_schrek_strat" },
    { 0xE9F2E08A, "blue_shutters" },
    { 0x71357AFE, "blue_structs" },
    { 0xC6D60C32, "blueforce" },
    { 0xC001C383, "blueroombrick" },
    { 0x71F3629B, "blueroombrick2" },
    { 0x4BF0E832, "blueroombrick3" },
    { 0x640C8B88, "blues" },
    { 0xFAE2300D, "bluesquad" },
    { 0xB47CAE93, "bluetrig" },
    { 0x22936F1B, "blundergat_change_hintstring" },
    { 0x705C3595, "blundergat_upgrade_station" },
    { 0x82739783, "blundergat_upgrade_station_inject" },
    { 0x66FD2F36, "blundersplat_on_player_connect" },
    { 0x686D445E, "blur" },
    { 0x43257201, "blur_amount" },
    { 0x4966A988, "blur_barret_fired" },
    { 0x152D58B1, "blur_duration" },
    { 0x04A709FC, "blur_in" },
    { 0x61444F99, "blur_in_rate" },
    { 0xD16F78E4, "blur_intensity" },
    { 0x7233BE3D, "blur_level" },
    { 0xC748993A, "blur_level_max" },
    { 0x58F5EF4B, "blur_occur" },
    { 0xD74873D3, "blur_out" },
    { 0x68A871F8, "blur_out_rate" },
    { 0xDEF3F3CF, "blur_overlay" },
    { 0x013C5015, "blur_stable_rate" },
    { 0x9D67413A, "blur_time" },
    { 0x866A6E6B, "blurred" },
    { 0xAFA7CD40, "blurring" },
    { 0xD4036919, "blurry" },
    { 0x7D572B8D, "blurry_far_blur" },
    { 0xA2B64211, "blurry_far_end" },
    { 0xA08BE49A, "blurry_far_start" },
    { 0x6E80AC02, "blurry_near_blur" },
    { 0x3118F178, "blurry_near_end" },
    { 0x1AB5249B, "blurry_near_start" },
    { 0xBB39E4C1, "blurs" },
    { 0x1A1BECD9, "blurview" },
    { 0x84AFAF34, "blurview_stop" },
    { 0x385BA4AD, "bm21" },
    { 0xDD40A8E9, "bm21_01" },
    { 0x03432352, "bm21_02" },
    { 0x29459DBB, "bm21_03" },
    { 0x5FD80147, "bm21_artillery_think" },
    { 0x7C7EA00D, "bm21_fires_until_flagged" },
    { 0x460F2EA5, "bm21_setanims_override" },
    { 0x23288EFA, "bm21_spawn_and_think" },
    { 0xDA999A58, "bm21_think" },
    { 0x165A94AB, "bm21_troops" },
    { 0x8EEBB170, "bm21_unloader" },
    { 0x536473AC, "bm21s" },
    { 0xD6E3113F, "bm21s_fire" },
    { 0x3F404875, "bm_asd_garage_1" },
    { 0x6542C2DE, "bm_asd_garage_2" },
    { 0x35F03A8B, "bm_backdrop" },
    { 0x435F41D5, "bm_building" },
    { 0xD780B6E5, "bm_celerium_door_front_l" },
    { 0xFB40483B, "bm_celerium_door_front_r" },
    { 0x015DBFEC, "bm_celerium_door_rear_l" },
    { 0xE56C9E62, "bm_celerium_door_rear_r" },
    { 0xB53B6CBF, "bm_clip" },
    { 0x91BC271C, "bm_clip_2" },
    { 0x99A00B4D, "bm_clip_collapsed" },
    { 0x8ED07336, "bm_clip_pristine" },
    { 0x52059EC6, "bm_clips" },
    { 0xAAB3C58B, "bm_clips1" },
    { 0x38AC5650, "bm_clips2" },
    { 0x5EAED0B9, "bm_clips3" },
    { 0x1CBB34C6, "bm_clips4" },
    { 0x49D208FB, "bm_defend_door_01l_clip" },
    { 0x5CC89EF9, "bm_defend_door_01r_clip" },
    { 0x11477F3C, "bm_defend_door_02l_clip" },
    { 0xBC1987FA, "bm_defend_door_02r_clip" },
    { 0x8B1759B9, "bm_door" },
    { 0xBB266CED, "bm_door_1" },
    { 0xE128E756, "bm_door_2" },
    { 0xA77CE096, "bm_door_clip" },
    { 0xBCE4CDCF, "bm_door_left" },
    { 0x39BFF974, "bm_door_north_l" },
    { 0xBDA7315A, "bm_door_north_r" },
    { 0xA10FDEAA, "bm_door_right" },
    { 0x44DA1F82, "bm_door_south_l" },
    { 0x60CB410C, "bm_door_south_r" },
    { 0x62E4C21D, "bm_gate_clip" },
    { 0x8813AFA4, "bm_lab_door_left_clip" },
    { 0xF4AC1339, "bm_lab_door_left_rear_clip" },
    { 0x926A9DB3, "bm_lab_door_right_clip" },
    { 0x27D37460, "bm_lab_door_right_rear_clip" },
    { 0xA45F778D, "bm_left_2_1_door_clip" },
    { 0x06FA6F7B, "bm_left_lobby_door_clip" },
    { 0x1C4D8D27, "bm_left_lobby_top_door_clip" },
    { 0x0DDFAF20, "bm_left_turret_arm_1" },
    { 0x7FE71E5B, "bm_left_turret_arm_2" },
    { 0x0274CB9A, "bm_left_turret_tile_1" },
    { 0xDC725131, "bm_left_turret_tile_2" },
    { 0xB9C3240A, "bm_lift" },
    { 0xF3525A0E, "bm_lift_left" },
    { 0xCCC17D31, "bm_panel" },
    { 0x9B4CF236, "bm_player_asd_window" },
    { 0xD9B7182D, "bm_player_asd_window_2" },
    { 0x3C700403, "bm_player_clip" },
    { 0xDD68A08E, "bm_right_2_1_door_clip" },
    { 0x97352734, "bm_right_lobby_door_clip" },
    { 0x0A3CFF00, "bm_right_lobby_top_door_clip" },
    { 0xF6E22A5D, "bm_right_turret_tile_1" },
    { 0x1CE4A4C6, "bm_right_turret_tile_2" },
    { 0x67C13FB4, "bm_roof_clip_destroyed" },
    { 0x3A5E11BB, "bm_roof_clip_pristine" },
    { 0xD59F88E6, "bm_weapon_clip" },
    { 0x276CB2AC, "bmanualtargetset" },
    { 0x63718FBF, "bmaxammo" },
    { 0xC8117DCF, "bmeterempty" },
    { 0x314D8DA0, "bmfx" },
    { 0x5D4A1D0E, "bmp" },
    { 0x3D2D395B, "bmp_02_destroyed" },
    { 0xE2088641, "bmp_03_colornodes" },
    { 0xA527ABA0, "bmp_04_colornodes" },
    { 0x493227CE, "bmp_aims_at_targets" },
    { 0x6BF6A58A, "bmp_autosave_on_death" },
    { 0x510BFD37, "bmp_badplace" },
    { 0x70070BBE, "bmp_bypassed" },
    { 0x8664E28B, "bmp_dead" },
    { 0xA9FB8656, "bmp_death_dialogue" },
    { 0x17F918BE, "bmp_death_fx" },
    { 0x45F0D68F, "bmp_got_killed" },
    { 0xE633816C, "bmp_killer" },
    { 0x9E8BC0B1, "bmp_killer_spawner" },
    { 0x40D8D924, "bmp_killer_spawner_think" },
    { 0xD44CD309, "bmp_nag" },
    { 0x2AD33A00, "bmp_nags" },
    { 0x40842052, "bmp_pan_target" },
    { 0x28D9440A, "bmp_road_trigger" },
    { 0x31582BEB, "bmp_safety_distance" },
    { 0xFC605E1A, "bmp_targets_stuff" },
    { 0x9181AFC8, "bmpcannonrange" },
    { 0xF5353C69, "bmpcansee" },
    { 0x45034899, "bmpexcluders" },
    { 0x51BEFAF9, "bmpmgrange" },
    { 0xD89FF708, "bmpmgrangesquared" },
    { 0x2293B4B1, "bmps" },
    { 0xE9248D1C, "bname" },
    { 0x6BE4898B, "bnandakumar" },
    { 0xF2D568A1, "bnb" },
    { 0x703BF65C, "bnewent" },
    { 0xEB2CCCDB, "bnextsceneexist" },
    { 0xDC6568F2, "bnkr" },
    { 0x78BC5492, "bnoanimunload" },
    { 0x4A1A0F18, "bo" },
    { 0x057F30E1, "bo1" },
    { 0x2B81AB4A, "bo2" },
    { 0x518425B3, "bo3" },
    { 0x9AA4B4F7, "board" },
    { 0x62BD5A1C, "board1" },
    { 0xD4C4C957, "board2" },
    { 0xA357A86D, "board_attack_spot" },
    { 0x809C17E3, "board_bob" },
    { 0x87EC54CA, "board_buffel_time" },
    { 0x0C84B0DC, "board_completion" },
    { 0x8550D095, "board_hack" },
    { 0x79EBF8A4, "board_init" },
    { 0x7860D529, "board_left" },
    { 0xE8267079, "board_move" },
    { 0x5C288522, "board_qualifier" },
    { 0xF83FA901, "board_repair" },
    { 0x4C38E12B, "board_repair_distance_squared" },
    { 0x057C89D4, "board_right" },
    { 0xBCD32A9F, "board_rotate" },
    { 0x1F6C84AE, "board_vtol_audio" },
    { 0x14F638AD, "boardactionanimation" },
    { 0x25B4768F, "boardactionast" },
    { 0xC21C77AF, "boardattack" },
    { 0xB414E1BC, "boarded" },
    { 0xEE796834, "boarded_chopper" },
    { 0xD44AE03C, "boardfall_time" },
    { 0x1679D429, "boarding" },
    { 0x81790B1B, "boarding_boat_ai_animate" },
    { 0x7A7F17E2, "boarding_boat_ai_think" },
    { 0x54F977E1, "boarding_boat_death" },
    { 0x4932C0D8, "boarding_boat_setup" },
    { 0xC6D46C83, "boarding_boat_spawn_ai" },
    { 0x2EB7E3D7, "boarding_boat_wait_until_at_barge" },
    { 0xB95365E1, "boarding_boat_wait_until_at_front" },
    { 0xFD5D4233, "boarding_boat_watch_challenge_death" },
    { 0x4D8CA92C, "boarding_done" },
    { 0x9F6D0961, "boarding_vo" },
    { 0xDA6BEE8E, "boarding_vo_playing" },
    { 0x83E05588, "boarding_window" },
    { 0x2F60E92E, "boards" },
    { 0x97F934D6, "boards_falling" },
    { 0x0E2C5628, "boards_far_from_players" },
    { 0xDA1F58A0, "boards_near_players" },
    { 0x6B16C38C, "boardsdropped" },
    { 0x5C1DE956, "boardsnum" },
    { 0x5889416A, "boardtearmocompstart" },
    { 0xAF703B65, "boardtearmocompupdate" },
    { 0xBBE5A83C, "boast" },
    { 0x8B5DD357, "boat" },
    { 0x358990FC, "boat1" },
    { 0xA7910037, "boat2" },
    { 0x818E85CE, "boat3" },
    { 0x7B6F2E14, "boat3_ent" },
    { 0x6B59EA0B, "boat3_slows_down_to_fire" },
    { 0x854836DB, "boat_1_offset" },
    { 0x084E99B1, "boat_1_running_drones_aft" },
    { 0xBAA3AB22, "boat_2_offset" },
    { 0xF0D403D9, "boat_3_offset" },
    { 0x7C7CC009, "boat_adjusting" },
    { 0xAA3658D2, "boat_ads_control" },
    { 0x8B5CB7ED, "boat_alive" },
    { 0xF6725058, "boat_angle_max" },
    { 0x11677C06, "boat_angle_min" },
    { 0xC84FE34E, "boat_angles" },
    { 0x581C59B2, "boat_approach_hudson_vo" },
    { 0x1FD2946D, "boat_array" },
    { 0xD4C0F73B, "boat_arrive" },
    { 0x5865D88F, "boat_attacker" },
    { 0x14FE1FE1, "boat_binocular_look" },
    { 0x23817B14, "boat_board_barge" },
    { 0x129B6BAC, "boat_board_barge_and_unload" },
    { 0x3E8A3C4D, "boat_board_barge_spawn_additional_ai" },
    { 0x1CDEC3FB, "boat_board_fallback" },
    { 0x07285502, "boat_board_hudson_vo" },
    { 0x73CF2883, "boat_bob" },
    { 0x45FE3E4E, "boat_bow" },
    { 0x6FD89522, "boat_cage" },
    { 0xBA90D9FD, "boat_controls_reminder_prompts" },
    { 0x7F845CB8, "boat_convoy" },
    { 0xF7ABF785, "boat_convoy_section_finished" },
    { 0xA6DAFC52, "boat_convoy_setup" },
    { 0x3B999814, "boat_convoy_small" },
    { 0x4EA7EA13, "boat_crash" },
    { 0xD9E79774, "boat_crash_monitor" },
    { 0x23228B61, "boat_crash_movement" },
    { 0x52541AD9, "boat_crew" },
    { 0x90F03FE3, "boat_cut_start" },
    { 0x89332E32, "boat_damage_active" },
    { 0xDF9A8C44, "boat_damage_override" },
    { 0xFE7B44D9, "boat_deco" },
    { 0xC3461C44, "boat_direct_attack" },
    { 0xCEF97096, "boat_dist_to_target" },
    { 0x5FAD5CB6, "boat_dock_trigger" },
    { 0xE0912090, "boat_docked" },
    { 0x6900A9D0, "boat_drag" },
    { 0x3C847362, "boat_drag_beat_cleanup" },
    { 0x45B068A6, "boat_drag_fake_tag_origin" },
    { 0xD77CD92B, "boat_drag_fx_setup" },
    { 0x3CEB6693, "boat_drag_guys" },
    { 0xD19938AF, "boat_drag_human_anims_setup" },
    { 0x77145EF0, "boat_drag_objective" },
    { 0x3D2D9852, "boat_drag_play_rocket_barrage_fx" },
    { 0xD650545D, "boat_drag_play_wake_fx" },
    { 0xC7ACCDCC, "boat_drag_player_actions" },
    { 0x5E949D0D, "boat_drag_player_anims_setup" },
    { 0x9B60DD49, "boat_drag_restore_ai_positions" },
    { 0xFD7B219F, "boat_drag_rope_actions" },
    { 0x44AB1952, "boat_drag_rope_cut_success" },
    { 0x86AA2032, "boat_drag_tell_player_grab_rope" },
    { 0xF4CD0E30, "boat_drag_vehicle_anims_setup" },
    { 0x3533984F, "boat_drag_wake" },
    { 0x5689CD5E, "boat_drive" },
    { 0xC3D74545, "boat_drive_away_forward" },
    { 0x4A8180C7, "boat_drive_base_base_tower_guys" },
    { 0x1C52EB7A, "boat_drive_base_second_aa_gun_tower_guys" },
    { 0x881F0FBF, "boat_drive_base_tower_guys" },
    { 0xF0D2F421, "boat_drive_done" },
    { 0x6C231558, "boat_driver" },
    { 0xEE2FC979, "boat_driver_cleanup" },
    { 0x9CAA26B1, "boat_drop" },
    { 0xF3BECBC2, "boat_drop_vignette" },
    { 0x305029DE, "boat_drop_water_splash_on_pier" },
    { 0xDAFD487F, "boat_ending" },
    { 0x49B63F43, "boat_ending_explosion_1" },
    { 0xD7AED008, "boat_ending_explosion_2" },
    { 0xFDB14A71, "boat_ending_explosion_3" },
    { 0xB88AA32B, "boat_escape" },
    { 0x92A223D9, "boat_exit_node" },
    { 0xE725BF44, "boat_explosive_death" },
    { 0x18FA5954, "boat_failure" },
    { 0xDAC44681, "boat_forward" },
    { 0xB08C29A4, "boat_forward_angles" },
    { 0x6234B002, "boat_get_node_max_speed" },
    { 0xEC63AAA9, "boat_goal_sets" },
    { 0x9442156A, "boat_goals" },
    { 0x85574C5E, "boat_groaning_sounds" },
    { 0xA3ADE33B, "boat_group_a" },
    { 0x31A67400, "boat_group_b" },
    { 0xB2D0D98A, "boat_guard_sent" },
    { 0x21A02680, "boat_gunner_damage_override" },
    { 0x3EED652C, "boat_health" },
    { 0x37DA1D55, "boat_health_overlay" },
    { 0x8FCE3DE7, "boat_height" },
    { 0x9A216334, "boat_hit_counter" },
    { 0xF921F89A, "boat_hud_init" },
    { 0xD8E328B3, "boat_landing" },
    { 0x4635BC50, "boat_landing_anims" },
    { 0x78AFC76D, "boat_landing_helicopter" },
    { 0xE5D7D4F5, "boat_landing_pathing" },
    { 0xEBF42E43, "boat_landing_rail_start" },
    { 0x71C489F2, "boat_landing_sampan_engagement" },
    { 0x92EF2A05, "boat_landing_sampan_engagement_done" },
    { 0x858A5F73, "boat_landing_sampan_engagement_player_check" },
    { 0x0C9B77EA, "boat_landing_sampan_engagement_synch_shots" },
    { 0x33A8F57A, "boat_landing_sampan_guys_function" },
    { 0x33D853F0, "boat_landing_save_check" },
    { 0xCAC2C2DB, "boat_linker" },
    { 0x2ECE2FA6, "boat_list" },
    { 0x867AE6E7, "boat_location" },
    { 0xB809EB29, "boat_location_ent" },
    { 0xF51A9299, "boat_move" },
    { 0x78B5427F, "boat_occupant" },
    { 0x140053DF, "boat_part_model_name" },
    { 0x60E9CD10, "boat_patrol_nva" },
    { 0x9EC22E74, "boat_pos" },
    { 0x2BB22687, "boat_raid_event" },
    { 0x86C1AFD0, "boat_rammed" },
    { 0x28847267, "boat_ramming_anim" },
    { 0x7AB14485, "boat_realistic_tweaking" },
    { 0x25D37F6C, "boat_replace_when_boarding" },
    { 0xDD918045, "boat_rider_anim_done" },
    { 0xCE184B0C, "boat_river_bob" },
    { 0x6D5B24A0, "boat_river_bob_spline" },
    { 0xB0089AC4, "boat_rotation_target" },
    { 0x6A1713D2, "boat_run_ignore_player" },
    { 0xDABC4B34, "boat_sampan" },
    { 0x0D79447A, "boat_sampan_physics" },
    { 0x48430A49, "boat_save" },
    { 0x1CA59BFB, "boat_section" },
    { 0xCD6E4DA6, "boat_setup_patrol" },
    { 0x5B178838, "boat_setup_pbr" },
    { 0x7456A655, "boat_slow_near_node" },
    { 0xE32555FC, "boat_slows_down_to_fire" },
    { 0xC29DA56B, "boat_speed" },
    { 0xC0F88292, "boat_starts_moving" },
    { 0x62F588FE, "boat_swaying" },
    { 0xD77342E5, "boat_target" },
    { 0x6C4E925A, "boat_test" },
    { 0x9CB84EFD, "boat_time" },
    { 0xF7795F5F, "boat_toggle_speed_check" },
    { 0x70AEC3FA, "boat_tread" },
    { 0x5E4AEC20, "boat_unique_death_anim" },
    { 0x33E3B371, "boat_up_vector" },
    { 0x2F468DFF, "boat_wake_origin" },
    { 0x4067FCD2, "boat_wake_speed" },
    { 0x302777DD, "boat_wake_speeds" },
    { 0x978EBDB9, "boat_wave_1" },
    { 0xD5F5A5D2, "boat_wave_1_hudson_mg_vo" },
    { 0x71283A39, "boat_wave_1_hudson_vo" },
    { 0xE393B28B, "boat_wave_3" },
    { 0x09962CF4, "boat_wave_4" },
    { 0x4AC31F92, "boatanimrig" },
    { 0x89B4EFE4, "boatcount" },
    { 0x6A9C5B20, "boatdeck" },
    { 0x4366F535, "boaters" },
    { 0x2884DDE9, "boatjack_done" },
    { 0xEBB56F1D, "boatjack_rail" },
    { 0x5E46D42F, "boatjacker" },
    { 0xD9F1CC34, "boatjackers_on_shore" },
    { 0x37E5D33A, "boatjacking" },
    { 0xC456CBCB, "boatjacking_landing_check" },
    { 0x33290673, "boatram_off" },
    { 0x0E8D0C5F, "boatram_on" },
    { 0x0E8F9C88, "boatramsnapshotoff" },
    { 0x3753EA22, "boatramsnapshoton" },
    { 0xA299EB08, "boatramsnapshots" },
    { 0xDE22F4C2, "boatroll" },
    { 0x022D200E, "boats" },
    { 0xD4DFC0A0, "boats_already_spawned" },
    { 0x834000B2, "boats_resume_pathing" },
    { 0x822903F1, "boats_start_sinking" },
    { 0x18A78D0E, "boatsittags" },
    { 0xABFDDF8B, "boatsquad" },
    { 0xC57CC6D8, "boatsquad1" },
    { 0x37843613, "boatsquad2" },
    { 0x18542583, "boatswayslowdowntime" },
    { 0x599AE268, "boatswaytime" },
    { 0x4BF89EFA, "bob" },
    { 0x7B1C5175, "bob_amount" },
    { 0x346EA5D8, "bob_vg" },
    { 0x4C1180EC, "bobbing" },
    { 0xECAAC5CC, "bobbing_on_water" },
    { 0x12E61D48, "bobbing_time" },
    { 0xD124E6B6, "bobing" },
    { 0x4BE8D575, "bobs" },
    { 0x7DF9820D, "bodies" },
    { 0x075B85C5, "body" },
    { 0x54880E66, "body1" },
    { 0x2E8593FD, "body2" },
    { 0xF89B2ECE, "body_3rdperson" },
    { 0x4DA77767, "body_anim" },
    { 0x00ADC6AF, "body_burn_vo" },
    { 0x0F798671, "body_default_mp" },
    { 0xE6B6C38F, "body_model" },
    { 0x8006BD1F, "body_mover" },
    { 0xD3B4AE4F, "body_render_options" },
    { 0x507E0795, "body_splash" },
    { 0xFF897A87, "body_start_angles" },
    { 0x83FC4B1F, "body_start_pos" },
    { 0x6141A08F, "body_tarp" },
    { 0x8E20CCAB, "body_toss_german_fx" },
    { 0xDD8605A5, "body_turn" },
    { 0x860340F9, "body_turn_speed" },
    { 0xA86F93E5, "bodyaccentcolorcount" },
    { 0x347FCD65, "bodybag" },
    { 0x71D35EA0, "bodybag_guys" },
    { 0xB89FDA74, "bodybags" },
    { 0x190777ED, "bodycolors" },
    { 0x51D70D80, "bodydamagedmap" },
    { 0x4E96B6ED, "bodydamagetags" },
    { 0xFCD109C7, "bodyfall large" },
    { 0xB4036965, "bodyfallcb" },
    { 0x375AC166, "bodyguard_bezerk" },
    { 0x260A8649, "bodyguard_died" },
    { 0xE14D0457, "bodyguard_logic" },
    { 0xCE98FB16, "bodyguard_setup" },
    { 0x6F264C7F, "bodyguard_walk_anims" },
    { 0xF47C417C, "bodyguarding" },
    { 0x2B905C4F, "bodyguards" },
    { 0xD146D1CD, "bodyhealthmod" },
    { 0x0197E5F7, "bodyindex" },
    { 0x855AD0AC, "bodymodel" },
    { 0xC538938E, "bodypart" },
    { 0x6F30937D, "bodyrenderoptions" },
    { 0x5DEB51CD, "bodytype" },
    { 0xF99F1882, "bodytypefields" },
    { 0x0657FC16, "bodywork" },
    { 0x0A050307, "bog" },
    { 0x0C98AAFF, "bog_a" },
    { 0x2CB15622, "bog_a_amb" },
    { 0x757A19B5, "bog_a_anim" },
    { 0x2A32B811, "bog_a_art" },
    { 0xFE41D648, "bog_a_audio" },
    { 0x21DA6204, "bog_a_backhalf" },
    { 0x5D7B0ADC, "bog_a_backhalf_anim" },
    { 0x7A63A37C, "bog_a_backhalf_autosaves" },
    { 0x296C83A9, "bog_a_code" },
    { 0x348DCF80, "bog_a_fx" },
    { 0x6CB8677B, "bog_a_tank_dialogue" },
    { 0xA0D5C081, "bog_a_tank_dialogue_guyl" },
    { 0x5A359742, "bog_a_tank_dialogue_guyl_idle" },
    { 0xF4A9251F, "bog_a_tank_dialogue_guyr" },
    { 0x4A0C57A8, "bog_a_tank_dialogue_guyr_idle" },
    { 0x01AABE8C, "bog_a_tank_dialogue_idle" },
    { 0x366A7B9B, "bog_ambient_fighting" },
    { 0xFE0BC34E, "bog_ambient_spawners" },
    { 0x90BC590D, "bog_as1_letenter" },
    { 0x6ABCD9AA, "bog_as2_getready" },
    { 0x9A913BC4, "bog_b" },
    { 0xF3A88FF5, "bog_b_amb" },
    { 0xB38FB49C, "bog_b_anim" },
    { 0x12F3A61A, "bog_b_art" },
    { 0x7BB34F4D, "bog_b_fx" },
    { 0xFA7542FD, "bog_backhalf_init" },
    { 0x6A385327, "bog_backhalf_shell" },
    { 0xE4ABA1F2, "bog_dialog" },
    { 0xEE888D9A, "bog_enemies_retreat" },
    { 0x1213FB72, "bog_gm1_clearup" },
    { 0xB9221DF0, "bog_gm1_throwflash" },
    { 0xBCDBA2B9, "bog_gm2_getdown" },
    { 0xC2FC81CA, "bog_gm2_tangodown" },
    { 0x23B6E902, "bog_gm3_gogogo" },
    { 0xECA8A618, "bog_gm3_incoming" },
    { 0xD4FC4440, "bog_gm4_clear" },
    { 0x344C0464, "bog_intro_sound" },
    { 0x22D82D55, "bog_mortar" },
    { 0x5AD5B1CC, "bog_pri_anygoodnews" },
    { 0xBA1D643A, "bog_pri_firefrombus" },
    { 0x26931E38, "bog_pri_nowdoit" },
    { 0xCA85DBFC, "bog_radio_dialogue" },
    { 0xA001FDA3, "bog_style_mortar" },
    { 0x5DB02751, "bog_style_mortar_activate" },
    { 0xEE748FE1, "bog_style_mortar_cooldown" },
    { 0x008E88AD, "bog_style_mortar_explode" },
    { 0x1849CAE5, "bog_style_mortar_off" },
    { 0x890B6D59, "bog_style_mortar_on" },
    { 0x2779D562, "bog_style_mortar_think" },
    { 0xB910A57E, "bog_style_mortar_trigger" },
    { 0x6A28A18E, "bog_tcm_firealt" },
    { 0x19928AFC, "bog_tcm_lasthe" },
    { 0x330FE04B, "bog_tcm_lowammo" },
    { 0xD993E7F7, "bog_tcm_noworries" },
    { 0x485339EF, "bog_tcm_pinneddown" },
    { 0x66B9E57B, "bog_tcm_yougotit" },
    { 0x9BDEDA5B, "bog_tgn_targetacquired" },
    { 0xC95C4890, "bogeys" },
    { 0xE8FD0D7D, "bogged" },
    { 0x9DBA93A8, "bogies" },
    { 0x856BE7E2, "bogmusictrig" },
    { 0x9507C3A3, "bogus" },
    { 0xCD83095A, "boiler" },
    { 0x5C2888CF, "boiler_clip" },
    { 0x40023EC8, "bold" },
    { 0x76DC2C9A, "bold_text" },
    { 0x8EB742B0, "bollocks" },
    { 0xEC40C248, "bolster" },
    { 0xA029E558, "bolt" },
    { 0x01171E50, "bolt_damage" },
    { 0xDBB05F47, "bolt_impact_range" },
    { 0x17CB6F92, "bolt_shock_melee_time" },
    { 0x40F6C313, "bolt_shock_range_time" },
    { 0x04B8F33B, "bolt_source_pos" },
    { 0xBCF291D6, "boltaction" },
    { 0xC2E68AD0, "boltcheck" },
    { 0x65E2CCF7, "bolthit" },
    { 0x8BD3D233, "bolts" },
    { 0x62379571, "bolttrackingstart" },
    { 0xCAEDE6E5, "bomb" },
    { 0xD3585986, "bomb1" },
    { 0x70B84D45, "bomb1_pos" },
    { 0x0C463A6B, "bomb1_trigger" },
    { 0xAD55DF1D, "bomb2" },
    { 0x1EFF81AA, "bomb2_diffused" },
    { 0xB6E7737E, "bomb2_pos" },
    { 0x875364B4, "bomb3" },
    { 0x8C46D0F7, "bomb3_pos" },
    { 0xD4F9231B, "bomb_activate" },
    { 0x6597C0A5, "bomb_count" },
    { 0x6184DC92, "bomb_defused" },
    { 0xEC18BB94, "bomb_detonated" },
    { 0xC2259C1F, "bomb_drop" },
    { 0x881655F1, "bomb_drop_end" },
    { 0x8F780F1C, "bomb_drop_pos" },
    { 0x2DAD2105, "bomb_drop_pre" },
    { 0xAE5BC77A, "bomb_drop_start" },
    { 0xC2F2250B, "bomb_explode_delay" },
    { 0xA0A2DE21, "bomb_exploded" },
    { 0x1E8BA79E, "bomb_exploder_think" },
    { 0x5199FA1D, "bomb_explosion" },
    { 0xA2931B79, "bomb_fx_spot" },
    { 0xB21C8501, "bomb_goal" },
    { 0xFA973D4E, "bomb_init" },
    { 0x3D05E439, "bomb_is_arming" },
    { 0xA29D6D0A, "bomb_loc" },
    { 0x5462D4EF, "bomb_model" },
    { 0x5780A6A8, "bomb_num" },
    { 0xFB5B219E, "bomb_origin" },
    { 0x8520ACA0, "bomb_picked_up" },
    { 0x659F958A, "bomb_pitch" },
    { 0x5F82FEDF, "bomb_plant_ready" },
    { 0xCFD2E84C, "bomb_planted" },
    { 0x2C1AEBD7, "bomb_planter1" },
    { 0xBA137C9C, "bomb_planter2" },
    { 0xE015F705, "bomb_planter3" },
    { 0xCCE08423, "bomb_planter_group1" },
    { 0x5AD914E8, "bomb_planter_group2" },
    { 0xF49828F5, "bomb_reset" },
    { 0xAB6E777B, "bomb_set_single" },
    { 0x51F9D185, "bomb_sound" },
    { 0x41905AA9, "bomb_sound_delete" },
    { 0xF0348322, "bomb_sound_go" },
    { 0x5232CC03, "bomb_string" },
    { 0xE6A75D43, "bomb_struct_1" },
    { 0x5E6D8F88, "bomb_tag" },
    { 0x4C1E6A33, "bomb_trace" },
    { 0x24C4B4E1, "bomb_velocity" },
    { 0x9BD3F0E9, "bomb_watcher1" },
    { 0xC1D66B52, "bomb_watcher2" },
    { 0xE7D8E5BB, "bomb_watcher3" },
    { 0x0DDB6024, "bomb_watcher4" },
    { 0x33DDDA8D, "bomb_watcher5" },
    { 0x9CC69AA7, "bomb_wiggle" },
    { 0x3D8B7C90, "bomb_x" },
    { 0xB6B41D3A, "bomb_zone" },
    { 0x65255849, "bomb_zone_fixup" },
    { 0x3CBCA0E7, "bomb_zone_origin" },
    { 0xC8E55787, "bomb_zone_trigger" },
    { 0xF8A6BCA5, "bombangles" },
    { 0xBAF05922, "bombaplanted" },
    { 0x019AC970, "bombardment" },
    { 0x5A20D54F, "bombbplanted" },
    { 0x9B04CAED, "bombdefused" },
    { 0x2261FD35, "bombdefusetrig" },
    { 0x4778016A, "bombdetectiontrigger" },
    { 0xEA7066EE, "bombdetectiontrigger_wait" },
    { 0x5846BB92, "bombdir" },
    { 0xC1EA627A, "bombdrop" },
    { 0xF7A7D097, "bombdropbotevent" },
    { 0x30C3EDD2, "bombed" },
    { 0xDCF08934, "bomber" },
    { 0x23828E38, "bomber_black" },
    { 0x191BD5FC, "bomber_crash" },
    { 0x1E4D53B5, "bomber_crash_end_done" },
    { 0xAEDF5D8D, "bomber_crash_treefx" },
    { 0xF38C5DDA, "bomber_crash_vo" },
    { 0x81224118, "bomber_grain" },
    { 0x079B0794, "bomber_nodes_setup" },
    { 0x94EAB29D, "bomber_overlay" },
    { 0x89DB723A, "bomber_planes" },
    { 0x3AABBF7E, "bomber_quake" },
    { 0x9342D758, "bomber_rumble" },
    { 0x408F4E19, "bomber_sound_flyby" },
    { 0x91EA082B, "bomber_sounds" },
    { 0xB618FCF0, "bomber_track" },
    { 0x0264AECD, "bomber_trig" },
    { 0xE58EB70B, "bomber_wave_come" },
    { 0x2F1C00BE, "bomber_wind_shake" },
    { 0x094A93E3, "bomberdamagedents" },
    { 0xCE848F98, "bomberdamagedentscount" },
    { 0x8E857B25, "bomberdamagedentsindex" },
    { 0x521023C6, "bomberdropbombs" },
    { 0xD399DE27, "bombers" },
    { 0xCF78C366, "bombers_bomb_target" },
    { 0x2323496D, "bombers_continue" },
    { 0x7968F7C2, "bombers_passed" },
    { 0xAEFE2E3B, "bombeventslpm" },
    { 0x291A393C, "bombexploded" },
    { 0xDA71EB23, "bombfx" },
    { 0x9D6EAA06, "bombguy" },
    { 0x5A8CB5E8, "bombheight" },
    { 0x2EAE9543, "bombing" },
    { 0xCC634113, "bombing_complete" },
    { 0x630632CD, "bomblabel" },
    { 0x960F4FA8, "bomblet" },
    { 0x06DC2B37, "bomblet_camera_waiter" },
    { 0xF5D79B12, "bomblet_exploded" },
    { 0x6390EE7D, "bomblet_explostion_waiter" },
    { 0xB4497B43, "bomblets" },
    { 0x7A051420, "bomblets_deployed" },
    { 0xA95ABE4C, "bombmodel" },
    { 0xDAA71F1B, "bomborigin" },
    { 0x610B5106, "bombowner" },
    { 0x7532EDDC, "bombpickupbotevent" },
    { 0xD615CBD7, "bombplanted" },
    { 0x97D99FC4, "bombplantedby" },
    { 0x292E5C71, "bombplantedmusicdelay" },
    { 0xC35DCB8D, "bombpoint" },
    { 0x59642065, "bombpos" },
    { 0x339CD85C, "bombposition" },
    { 0x005E0DA7, "bombreleasewait" },
    { 0xCD724D52, "bombreset" },
    { 0xFEDED6E8, "bombrun_killcam" },
    { 0x07F1FEF4, "bombs" },
    { 0xC46C545D, "bombs_set" },
    { 0xCBC7FC24, "bombsite" },
    { 0x7A23E8E4, "bombsiteallowuse" },
    { 0x24380C14, "bombsiteteamowner" },
    { 0x93A54358, "bombspeedscale" },
    { 0x17FB8D56, "bombsquadicon" },
    { 0xD1C344C9, "bombsquadicons" },
    { 0x7D22ED55, "bombsquadids" },
    { 0x7E936002, "bombstopwatch" },
    { 0x8DD1B717, "bombstrike" },
    { 0x7439B082, "bombtime" },
    { 0x8CF38E64, "bombtimer" },
    { 0xEFB02D17, "bombtimerwait" },
    { 0x055E728B, "bombtrigger" },
    { 0x4527BEEA, "bombtriggers" },
    { 0xF98E9BFA, "bombwait" },
    { 0x5B091032, "bombwaitpretime" },
    { 0x7D739C95, "bombwaittime" },
    { 0x824B587F, "bombzone" },
    { 0x2F83E72C, "bombzone_dem" },
    { 0xE0D88986, "bombzones" },
    { 0x90259F7D, "bombzonesleft" },
    { 0x758B0FBC, "bomsite" },
    { 0x6BEF9080, "bonaventure" },
    { 0x6FBF4766, "bond" },
    { 0x95C1C1CF, "bone" },
    { 0xFC423403, "bone_fxaxis" },
    { 0xA84127CF, "bone_location" },
    { 0xFAF17161, "boneindex" },
    { 0xDB4ECB27, "bonekeys" },
    { 0xC2353B93, "bonemap" },
    { 0x3CCEDD80, "bonemodifier" },
    { 0x5D7E7AC2, "bonename" },
    { 0xF5A6C61F, "bonename1" },
    { 0xFDC0AFED, "boneorigin" },
    { 0xE26DD0FB, "boneprefix" },
    { 0x948F9F96, "bones" },
    { 0xF6278652, "bonfire" },
    { 0x8E08197F, "bonfire_init" },
    { 0x1E4668F8, "bonfire_init_func" },
    { 0x4F0A8DE6, "bonfire_sale_off" },
    { 0xE7125246, "bonus" },
    { 0x9A694232, "bonus_damage" },
    { 0x17D2D6F1, "bonus_drop_ent_pool" },
    { 0x2761B4B3, "bonus_fraction" },
    { 0x28CE5E1A, "bonus_msg_hud" },
    { 0x8EDF7FE5, "bonus_points_player_powerup" },
    { 0x32FC3830, "bonus_points_powerup_override" },
    { 0xDA671A0C, "bonus_points_team_pickedup" },
    { 0xB01369D9, "bonus_points_team_powerup" },
    { 0x559AC9CD, "bonus_price_line" },
    { 0x8D6F60A2, "bonus_time" },
    { 0xA855C41B, "bonuscard_danger_close" },
    { 0x11AED58D, "bonuscard_overkill" },
    { 0xF71937E1, "bonuscard_perk_1_greed" },
    { 0xA70721B2, "bonuscard_perk_2_greed" },
    { 0x4B440493, "bonuscard_perk_3_greed" },
    { 0x72DAEC1B, "bonuscard_primary_gunfighter" },
    { 0x793DAB40, "bonuscard_primary_gunfighter_2" },
    { 0x9F4025A9, "bonuscard_primary_gunfighter_3" },
    { 0x21E8CEB3, "bonuscard_secondary_gunfighter" },
    { 0xD6D1DB2C, "bonuscard_two_tacticals" },
    { 0xEF86A9FB, "bonuscardactivecount" },
    { 0x09A774AE, "bonuscards_t" },
    { 0xF55B6766, "bonuses" },
    { 0x8A4FA0EF, "bonusypos" },
    { 0xD7179762, "bonuszm_aquifer_dlg1" },
    { 0xC007BCAA, "bonuszm_aquifer_dlg1_1" },
    { 0x9A054241, "bonuszm_aquifer_dlg1_2" },
    { 0x7402C7D8, "bonuszm_aquifer_dlg1_3" },
    { 0x7E1420B7, "bonuszm_aquifer_dlg1_4" },
    { 0xC0456FBF, "bonuszm_aquifer_dlg1_4_1" },
    { 0x5811A64E, "bonuszm_aquifer_dlg1_5" },
    { 0x320F2BE5, "bonuszm_aquifer_dlg1_6" },
    { 0x0C0CB17C, "bonuszm_aquifer_dlg1_7" },
    { 0xB1151CF9, "bonuszm_aquifer_dlg2" },
    { 0xD26E5CAD, "bonuszm_aquifer_dlg2_1" },
    { 0x8B12A290, "bonuszm_aquifer_dlg3" },
    { 0xC589FE6C, "bonuszm_aquifer_dlg3_1" },
    { 0x9523FB6F, "bonuszm_aquifer_dlg4" },
    { 0x4E604607, "bonuszm_aquifer_dlg4_1" },
    { 0x6F218106, "bonuszm_aquifer_dlg5" },
    { 0x491F069D, "bonuszm_aquifer_dlg6" },
    { 0x231C8C34, "bonuszm_aquifer_dlg7" },
    { 0x2DDF2068, "bonuszm_aquifer_dlg7_1" },
    { 0x67A74025, "bonuszm_bio_dlg1" },
    { 0x8DA9BA8E, "bonuszm_bio_dlg2" },
    { 0x378BBFD5, "bonuszm_bio_dlg2_2" },
    { 0x1189456C, "bonuszm_bio_dlg2_3" },
    { 0xEB86CB03, "bonuszm_bio_dlg2_4" },
    { 0xB3AC34F7, "bonuszm_bio_dlg3" },
    { 0xA99ADC18, "bonuszm_bio_dlg4" },
    { 0xCF9D5681, "bonuszm_bio_dlg5" },
    { 0x4F301A05, "bonuszm_bio_dlg5_1" },
    { 0x7532946E, "bonuszm_bio_dlg5_2" },
    { 0x9B350ED7, "bonuszm_bio_dlg5_3" },
    { 0x9123B5F8, "bonuszm_bio_dlg5_4" },
    { 0xF59FD0EA, "bonuszm_bio_dlg6" },
    { 0x66DA0E26, "bonuszm_blackstation_dlg1" },
    { 0x40D793BD, "bonuszm_blackstation_dlg2" },
    { 0x1AD51954, "bonuszm_blackstation_dlg3" },
    { 0x1573A848, "bonuszm_blackstation_dlg3_1" },
    { 0x877B1783, "bonuszm_blackstation_dlg3_2" },
    { 0x61789D1A, "bonuszm_blackstation_dlg3_3" },
    { 0xD3800C55, "bonuszm_blackstation_dlg3_4" },
    { 0xAD7D91EC, "bonuszm_blackstation_dlg3_5" },
    { 0xF4D29EEB, "bonuszm_blackstation_dlg4" },
    { 0x27DA484B, "bonuszm_blackstation_dlg4_1" },
    { 0xB5D2D910, "bonuszm_blackstation_dlg4_2" },
    { 0xDBD55379, "bonuszm_blackstation_dlg4_3" },
    { 0xCED02482, "bonuszm_blackstation_dlg5" },
    { 0xBD165379, "bonuszm_change_loadout" },
    { 0x3C513B83, "bonuszm_cleanup_magicbox" },
    { 0x7D5640E0, "bonuszm_cybercom_on_callback" },
    { 0x903E80EC, "bonuszm_data_override_health" },
    { 0x940B830D, "bonuszm_data_override_locomotion" },
    { 0xA4EF81B9, "bonuszm_data_override_suicide_chance" },
    { 0xA743DBF2, "bonuszm_endon_scene_sequence_ended" },
    { 0x2ACCA953, "bonuszm_force_ai_cleanup" },
    { 0xBBFB16A3, "bonuszm_hide_magicboxes" },
    { 0x792CB762, "bonuszm_infection_dlg1" },
    { 0x838C55D6, "bonuszm_infection_dlg10" },
    { 0xA98ED03F, "bonuszm_infection_dlg11" },
    { 0x37876104, "bonuszm_infection_dlg12" },
    { 0x5D89DB6D, "bonuszm_infection_dlg13" },
    { 0xEB826C32, "bonuszm_infection_dlg14" },
    { 0x1184E69B, "bonuszm_infection_dlg15" },
    { 0x9F7D7760, "bonuszm_infection_dlg16" },
    { 0xC57FF1C9, "bonuszm_infection_dlg17" },
    { 0xB3A0291E, "bonuszm_infection_dlg18" },
    { 0xD9A2A387, "bonuszm_infection_dlg19" },
    { 0x532A3CF9, "bonuszm_infection_dlg2" },
    { 0x04F4EFAB, "bonuszm_infection_dlg20" },
    { 0xDEF27542, "bonuszm_infection_dlg21" },
    { 0xB8EFFAD9, "bonuszm_infection_dlg22" },
    { 0x92ED8070, "bonuszm_infection_dlg23" },
    { 0x2D27C290, "bonuszm_infection_dlg3" },
    { 0x91741E6C, "bonuszm_infection_dlg3_1" },
    { 0x37391B6F, "bonuszm_infection_dlg4" },
    { 0x1136A106, "bonuszm_infection_dlg5" },
    { 0xEB34269D, "bonuszm_infection_dlg6" },
    { 0xC531AC34, "bonuszm_infection_dlg7" },
    { 0xCF430513, "bonuszm_infection_dlg8" },
    { 0xAE68CBC3, "bonuszm_infection_dlg8_1" },
    { 0xA9408AAA, "bonuszm_infection_dlg9" },
    { 0x3042F24C, "bonuszm_lotus_dlg1" },
    { 0x65DA6154, "bonuszm_lotus_dlg10" },
    { 0x8BDCDBBD, "bonuszm_lotus_dlg11" },
    { 0xB1DF5626, "bonuszm_lotus_dlg12" },
    { 0xD7E1D08F, "bonuszm_lotus_dlg13" },
    { 0xCDD077B0, "bonuszm_lotus_dlg14" },
    { 0xA24A6187, "bonuszm_lotus_dlg2" },
    { 0x2DDBAE4F, "bonuszm_lotus_dlg2_1" },
    { 0xBBD43F14, "bonuszm_lotus_dlg2_2" },
    { 0xE1D6B97D, "bonuszm_lotus_dlg2_3" },
    { 0x6FCF4A42, "bonuszm_lotus_dlg2_4" },
    { 0x7C47E71E, "bonuszm_lotus_dlg3" },
    { 0x414802E5, "bonuszm_lotus_dlg3_2" },
    { 0xBE3B8311, "bonuszm_lotus_dlg4" },
    { 0x70FBDD95, "bonuszm_lotus_dlg4_1" },
    { 0x96FE57FE, "bonuszm_lotus_dlg4_2" },
    { 0x0A4077E3, "bonuszm_lotus_dlg6" },
    { 0xE43DFD7A, "bonuszm_lotus_dlg7" },
    { 0x9F8324F2, "bonuszm_lotus_dlg7_1" },
    { 0x2631996D, "bonuszm_lotus_dlg8" },
    { 0x002F1F04, "bonuszm_lotus_dlg9" },
    { 0xEFFDA531, "bonuszm_musicoverride" },
    { 0x8B0A8041, "bonuszm_newworld_dlg1" },
    { 0x82AF8CE3, "bonuszm_newworld_dlg10" },
    { 0x5CAD127A, "bonuszm_newworld_dlg11" },
    { 0x36AA9811, "bonuszm_newworld_dlg12" },
    { 0xB10CFAAA, "bonuszm_newworld_dlg2" },
    { 0x55F67F79, "bonuszm_newworld_dlg2_2" },
    { 0x2FF40510, "bonuszm_newworld_dlg2_3" },
    { 0x3A055DEF, "bonuszm_newworld_dlg2_4" },
    { 0xD70F7513, "bonuszm_newworld_dlg3" },
    { 0xFD11EF7C, "bonuszm_newworld_dlg4" },
    { 0x231469E5, "bonuszm_newworld_dlg5" },
    { 0x4916E44E, "bonuszm_newworld_dlg6" },
    { 0x6F195EB7, "bonuszm_newworld_dlg7" },
    { 0x34F43290, "bonuszm_newworld_dlg8" },
    { 0x5AF6ACF9, "bonuszm_newworld_dlg9" },
    { 0x2F5E035A, "bonuszm_prologue_dlg1" },
    { 0x095B88F1, "bonuszm_prologue_dlg2" },
    { 0x5049A0B5, "bonuszm_prologue_dlg2_1" },
    { 0xE3590E88, "bonuszm_prologue_dlg3" },
    { 0xED6A6767, "bonuszm_prologue_dlg4" },
    { 0xC767ECFE, "bonuszm_prologue_dlg5" },
    { 0xD33E9AEE, "bonuszm_prologue_dlg5_1" },
    { 0xAD3C2085, "bonuszm_prologue_dlg5_2" },
    { 0x8739A61C, "bonuszm_prologue_dlg5_3" },
    { 0xA1657295, "bonuszm_prologue_dlg6" },
    { 0x9E14D931, "bonuszm_prologue_dlg6_1" },
    { 0xC417539A, "bonuszm_prologue_dlg6_2" },
    { 0x7B62F82C, "bonuszm_prologue_dlg7" },
    { 0x254CAA7B, "bonuszm_prologue_dlg8" },
    { 0x36ADAAAA, "bonuszm_ramses_dlg1" },
    { 0x10AB3041, "bonuszm_ramses_dlg2" },
    { 0xEAA8B5D8, "bonuszm_ramses_dlg3" },
    { 0xD0E9C624, "bonuszm_ramses_dlg3_1" },
    { 0x42F1355F, "bonuszm_ramses_dlg3_2" },
    { 0xCEB7944E, "bonuszm_ramses_dlg5" },
    { 0x4CDBAF7E, "bonuszm_ramses_dlg5_1" },
    { 0xA8B519E5, "bonuszm_ramses_dlg6" },
    { 0x82B29F7C, "bonuszm_ramses_dlg7" },
    { 0x1FF23320, "bonuszm_ramses_dlg7_1" },
    { 0x2C9C51CB, "bonuszm_ramses_dlg8" },
    { 0xCBD1B4E5, "bonuszm_scene_sequence_ended_callback" },
    { 0xC2947A26, "bonuszm_sgen_dlg1" },
    { 0xFF3FD046, "bonuszm_sgen_dlg1_1" },
    { 0xD93D55DD, "bonuszm_sgen_dlg1_2" },
    { 0xB33ADB74, "bonuszm_sgen_dlg1_3" },
    { 0x5605FF14, "bonuszm_sgen_dlg1_3_waittill_done" },
    { 0x9C91FFBD, "bonuszm_sgen_dlg2" },
    { 0xE49FF809, "bonuszm_sgen_dlg2_1" },
    { 0x768F8554, "bonuszm_sgen_dlg3" },
    { 0x508D0AEB, "bonuszm_sgen_dlg4" },
    { 0x76C8944B, "bonuszm_sgen_dlg4_1" },
    { 0x2A8A9082, "bonuszm_sgen_dlg5" },
    { 0x04881619, "bonuszm_sgen_dlg6" },
    { 0xDE859BB0, "bonuszm_sgen_dlg7" },
    { 0x18AAC7D7, "bonuszm_sgen_dlg8" },
    { 0xF4B0471F, "bonuszm_sgen_dlg8_1" },
    { 0x82A8D7E4, "bonuszm_sgen_dlg8_2" },
    { 0xF2A84D6E, "bonuszm_sgen_dlg9" },
    { 0x3F850844, "bonuszm_start_objective" },
    { 0x456F819D, "bonuszm_vengeance_dlg1" },
    { 0x6B71FC06, "bonuszm_vengeance_dlg2" },
    { 0x965D6F66, "bonuszm_vengeance_dlg2_1" },
    { 0x9174766F, "bonuszm_vengeance_dlg3" },
    { 0x1C00B907, "bonuszm_vengeance_dlg3_1" },
    { 0x87631D90, "bonuszm_vengeance_dlg4" },
    { 0xAD6597F9, "bonuszm_vengeance_dlg5" },
    { 0xD3681262, "bonuszm_vengeance_dlg6" },
    { 0x8DA82FAA, "bonuszm_vengeance_dlg6_1" },
    { 0x67A5B541, "bonuszm_vengeance_dlg6_2" },
    { 0xF96A8CCB, "bonuszm_vengeance_dlg7" },
    { 0x0DE6336B, "bonuszm_vengeance_dlg7_1" },
    { 0x4F80DA7C, "bonuszm_vengeance_dlg8" },
    { 0x758354E5, "bonuszm_vengeance_dlg9" },
    { 0xDE6B6734, "bonuszm_wait_for_objective_completion" },
    { 0xF71A45D3, "bonuszm_wait_for_streamer_timeout" },
    { 0x4DB28826, "bonuszm_waittill_ai_cleared" },
    { 0xC82F8758, "bonuszm_zurich_dlg1" },
    { 0x9B490338, "bonuszm_zurich_dlg10" },
    { 0xC14B7DA1, "bonuszm_zurich_dlg11" },
    { 0xE74DF80A, "bonuszm_zurich_dlg12" },
    { 0x0D507273, "bonuszm_zurich_dlg13" },
    { 0x3352ECDC, "bonuszm_zurich_dlg14" },
    { 0x59556745, "bonuszm_zurich_dlg15" },
    { 0x7F57E1AE, "bonuszm_zurich_dlg16" },
    { 0xA55A5C17, "bonuszm_zurich_dlg17" },
    { 0x6B352FF0, "bonuszm_zurich_dlg18" },
    { 0x9137AA59, "bonuszm_zurich_dlg19" },
    { 0x900CB3A4, "bonuszm_zurich_dlg1_1" },
    { 0x021422DF, "bonuszm_zurich_dlg1_2" },
    { 0xDC11A876, "bonuszm_zurich_dlg1_3" },
    { 0x1E054469, "bonuszm_zurich_dlg1_4" },
    { 0x3A36F693, "bonuszm_zurich_dlg2" },
    { 0x57FD1D19, "bonuszm_zurich_dlg20" },
    { 0x31FAA2B0, "bonuszm_zurich_dlg21" },
    { 0xA40211EB, "bonuszm_zurich_dlg22" },
    { 0x7DFF9782, "bonuszm_zurich_dlg23" },
    { 0xF00706BD, "bonuszm_zurich_dlg24" },
    { 0xCA048C54, "bonuszm_zurich_dlg25" },
    { 0x14347C2A, "bonuszm_zurich_dlg3" },
    { 0x863BEB65, "bonuszm_zurich_dlg4" },
    { 0x1E653D01, "bonuszm_zurich_dlg4_1" },
    { 0x603970FC, "bonuszm_zurich_dlg5" },
    { 0xD240E037, "bonuszm_zurich_dlg6" },
    { 0xAC3E65CE, "bonuszm_zurich_dlg7" },
    { 0xBE1E2E79, "bonuszm_zurich_dlg8" },
    { 0x981BB410, "bonuszm_zurich_dlg9" },
    { 0xE2026B9F, "boob" },
    { 0x12B91D9C, "booby" },
    { 0x56301614, "booby_trap_explode" },
    { 0xEC13C47E, "book" },
    { 0xF782BA13, "book_counter" },
    { 0xFB74D757, "book_h8r_setup" },
    { 0x93B9082A, "book_struct" },
    { 0xD4E89491, "book_toss_l" },
    { 0xE90B464F, "book_toss_r" },
    { 0x1AA6067F, "book_trig" },
    { 0xF3641EBB, "book_useage" },
    { 0xCCAA3302, "bookcase" },
    { 0xEA9560E2, "bookcase_clip_brush" },
    { 0xE86EFBF1, "bookcase_door" },
    { 0xD9ADB83F, "bookcase_entering_callback" },
    { 0xBDF28FA5, "bookcase_fire" },
    { 0x138686A8, "bookcase_fun" },
    { 0xF0B7C4C7, "bookcase_fx" },
    { 0xF21517FD, "bookcase_push" },
    { 0xE336BC3F, "bookcase_push_attach" },
    { 0x0CE1FE25, "bookcase_push_detach" },
    { 0x837C5003, "bookcase_trig" },
    { 0xFF424E76, "bookcase_triggers" },
    { 0x6C13784D, "bookcases" },
    { 0x9A8BA9DC, "bookie" },
    { 0xF6A5EA3D, "bookkeep" },
    { 0x20EA24D9, "bookmark" },
    { 0xA6B3F98F, "bookmark_string" },
    { 0x9AF43161, "books" },
    { 0x1B15DC21, "books_gone" },
    { 0xC0F647EE, "bookshelf" },
    { 0x604B03AC, "bookshelf_align_struct" },
    { 0x360558EE, "bookshelf_fall_anim" },
    { 0x3D50D68B, "bookshelf_guy_dead" },
    { 0x3B583F3C, "bookshelfguy_death" },
    { 0x2E076071, "bool" },
    { 0xAD2A49CB, "bool_monkey_bolt" },
    { 0xCF087E4C, "bool_override" },
    { 0x30AA14B7, "boolean" },
    { 0x18996FEE, "booleans" },
    { 0x9B8AE1B1, "boolkill" },
    { 0x36A3D7D3, "boolprintmessage" },
    { 0x93CF21D8, "bools" },
    { 0x0804E608, "boom" },
    { 0xA60B6BA0, "boom_struct" },
    { 0xCF979586, "boost" },
    { 0xA0A95316, "boost_blur" },
    { 0xB3B23275, "boost_chance" },
    { 0x8294E79B, "boost_effect_active" },
    { 0x3D787FAC, "boost_ent" },
    { 0x4BA988E2, "boost_fx_interrupt_handler" },
    { 0xAB9EADC8, "boost_fx_loop" },
    { 0x7F9030DD, "boost_fx_on_velocity" },
    { 0x59C8D610, "boost_lfe" },
    { 0xDDA4A736, "boost_min_start_speed" },
    { 0x0FBF765C, "boost_response" },
    { 0x517E6282, "boost_rumble" },
    { 0x6ED3D717, "boost_start" },
    { 0x8F366363, "boost_think" },
    { 0x63AD4887, "boost_up_trig" },
    { 0x2F348F90, "boost_up_trig_origin" },
    { 0xA6AE3C9C, "boost_vector" },
    { 0xA4A3A420, "boost_velocity" },
    { 0xB1F2ECDE, "boost_while_in_soct" },
    { 0x3078E309, "boosted" },
    { 0x9702FC95, "booster_fx_watcher" },
    { 0x37366651, "booster_model" },
    { 0x240DEF56, "booster_speed_override" },
    { 0xC5E98AD6, "boosters" },
    { 0xC49B4D9A, "boosting" },
    { 0x4A26A3FD, "boostnumber" },
    { 0x9694ED46, "boostresponseentnum" },
    { 0x13B03E7F, "booststartentnum" },
    { 0xACBAB597, "booststartresponse" },
    { 0x5E1B33B9, "boot" },
    { 0x094C7531, "boot_sound" },
    { 0xF0C6007B, "boot_up_claw" },
    { 0x4ED426E3, "booth" },
    { 0xEF79035A, "booth_corsair_dialog" },
    { 0xDF7CA6ED, "bootlog_speed" },
    { 0x0CE08AF0, "boots" },
    { 0x4EBB4502, "bootup" },
    { 0x22D6A410, "bootup_timer" },
    { 0xD151BDA8, "booze" },
    { 0xD2DC53F0, "booze_builds" },
    { 0x4C6AA6CE, "booze_model" },
    { 0xC8C3027F, "booze_piece" },
    { 0xB69C95A0, "booze_player" },
    { 0x1B97C6A0, "booze_start_angles" },
    { 0xD2890DC6, "booze_start_origin" },
    { 0x87C21E80, "booze_wait" },
    { 0x8308BB80, "boozebuildable" },
    { 0x48B8DDE0, "bopenclaw" },
    { 0xAC20458A, "bor" },
    { 0x85AAB84B, "border" },
    { 0x08926936, "border_inner" },
    { 0xC6DD0DD3, "border_outer" },
    { 0xFBFC57AA, "borders" },
    { 0xEA8A27E6, "borderwall_method1" },
    { 0x325F6E1D, "bored" },
    { 0x4420D04A, "bored_alert" },
    { 0x8C5B19E1, "bored_guy" },
    { 0xC289F488, "bored_guys" },
    { 0xE3463B15, "boredom" },
    { 0x33E4568A, "borienttoplayeryrot" },
    { 0x26220CC6, "boris" },
    { 0xAD98ADE0, "born" },
    { 0xE0B42429, "borrowed" },
    { 0xCCC164D9, "borrows" },
    { 0x062D99A2, "boss" },
    { 0x7F734CEB, "boss_battle" },
    { 0x37BBA7A9, "boss_battle_challenge" },
    { 0x0A95519B, "boss_boat" },
    { 0xC617BBFB, "boss_boat_1" },
    { 0x70171900, "boss_boat_ai" },
    { 0xA1E21542, "boss_boat_check_damage" },
    { 0x9D1E3B18, "boss_boat_check_for_missile_impact" },
    { 0x23D7CCE0, "boss_boat_death" },
    { 0xC82B5BD7, "boss_boat_destroyed" },
    { 0x609A1607, "boss_boat_dies" },
    { 0x26BDC51D, "boss_boat_encounter" },
    { 0xB8DAF224, "boss_boat_fight" },
    { 0x6CF9B28E, "boss_boat_fire_update" },
    { 0xF44ABAA5, "boss_boat_killed" },
    { 0xF679E9EA, "boss_boat_missile" },
    { 0x86947D7D, "boss_boat_obj" },
    { 0xDB784E73, "boss_boat_throw_ai" },
    { 0x1073906C, "boss_boat_throw_ai_fx" },
    { 0x22C4168E, "boss_drop_target" },
    { 0x41395258, "boss_ent" },
    { 0xF432E9E6, "boss_jug_bigdog_guard" },
    { 0xA74871B5, "boss_jug_explosive" },
    { 0xE640C66E, "boss_jug_headshot" },
    { 0x5BCEC017, "boss_jug_helmet_pop" },
    { 0x8BB65F54, "boss_jug_regular" },
    { 0xD2A6DD91, "boss_jug_riotshield" },
    { 0xF6CB75EC, "boss_launch" },
    { 0xBEA7B994, "boss_msg" },
    { 0x6235BF5E, "boss_msg2" },
    { 0x883839C7, "boss_msg3" },
    { 0x033F1330, "boss_name" },
    { 0x7BA5B6DC, "boss_ref" },
    { 0x662BACE6, "boss_spawning" },
    { 0xD0B712C3, "boss_takes_damage_time" },
    { 0x9F6151C2, "boss_tesla_damage" },
    { 0xF3148C76, "boss_zombie_idle_setup" },
    { 0xA25B329C, "bossai" },
    { 0xA4E97A1B, "bossdelay" },
    { 0x2416620A, "bosses" },
    { 0xE5297D01, "bossnonai" },
    { 0x73B0FEB9, "bossstruct" },
    { 0x9B4DBD81, "bosworth" },
    { 0xF8253A5C, "bot" },
    { 0x7AEBB5A8, "bot_ads_dot_easy" },
    { 0x16C28EAD, "bot_ads_dot_fu" },
    { 0xA52F39D5, "bot_ads_dot_hard" },
    { 0xC38400C7, "bot_ads_dot_medium" },
    { 0xAB633584, "bot_aim_converge_rate_easy" },
    { 0xDD73DB71, "bot_aim_converge_rate_fu" },
    { 0x4CEF6EC1, "bot_aim_converge_rate_hard" },
    { 0xE412C813, "bot_aim_converge_rate_medium" },
    { 0x487695A0, "bot_aim_converge_secs_easy" },
    { 0x19FEC4B5, "bot_aim_converge_secs_fu" },
    { 0x3CE938ED, "bot_aim_converge_secs_hard" },
    { 0x7646433F, "bot_aim_converge_secs_medium" },
    { 0xCB0FCBE1, "bot_aim_error_dist_easy" },
    { 0x9286A02C, "bot_aim_error_dist_fu" },
    { 0x1CF11DB4, "bot_aim_error_dist_hard" },
    { 0x8E120522, "bot_aim_error_dist_medium" },
    { 0x3223B626, "bot_allocation_max" },
    { 0xC081F393, "bot_allocation_unlock_max" },
    { 0x898F98F0, "bot_ball" },
    { 0xAEC3D3B3, "bot_banned_killstreaks" },
    { 0x52939BC8, "bot_best_enemy" },
    { 0x8439F6F6, "bot_build_claimed_list" },
    { 0xE9465124, "bot_build_classes" },
    { 0x24739178, "bot_build_item_list" },
    { 0x843CA56A, "bot_build_weapon_options_list" },
    { 0x1AAF5AED, "bot_button_activate" },
    { 0xB644E0DE, "bot_button_attack" },
    { 0x34BB7ADC, "bot_button_crouch" },
    { 0x6AA3F9DD, "bot_button_doublejump" },
    { 0xF6DFEFD4, "bot_button_flash" },
    { 0xB1DD9BDA, "bot_button_frag" },
    { 0x07021B62, "bot_button_jump" },
    { 0xDD759422, "bot_button_melee" },
    { 0xBAB38466, "bot_button_offhand" },
    { 0xB86A2252, "bot_button_offhand_special" },
    { 0xCBF086B9, "bot_button_reload" },
    { 0xA20A2A3A, "bot_button_sprint" },
    { 0xAC0BA9C9, "bot_button_swim_down" },
    { 0x3BCE3116, "bot_button_swim_up" },
    { 0x580AD6DA, "bot_button_throw" },
    { 0x341AC533, "bot_button_walking" },
    { 0x11E1EB26, "bot_buttons" },
    { 0x74FE2180, "bot_can_do_combat" },
    { 0xC2CB500D, "bot_can_reload" },
    { 0x1999F5EA, "bot_can_see_feet" },
    { 0x9F77FDF0, "bot_can_see_head" },
    { 0xEFDFBD4D, "bot_can_see_nothing" },
    { 0xED3244BF, "bot_can_see_torso" },
    { 0xC940C868, "bot_capture_flag" },
    { 0xF39E5ACB, "bot_capture_hill" },
    { 0x69061963, "bot_capture_hq" },
    { 0x9F8CBA71, "bot_choose_class" },
    { 0xEDE97528, "bot_choose_comp_stomp_team" },
    { 0x2866B688, "bot_choose_primary_attachments" },
    { 0xC2FF7888, "bot_choose_secondary_attachments" },
    { 0xA601A187, "bot_choose_weapon" },
    { 0x45673891, "bot_choose_weapon_option" },
    { 0x5B2F65E2, "bot_chose_action" },
    { 0x0F0DE2F1, "bot_classes" },
    { 0x934C83CE, "bot_clean" },
    { 0x4DBA6F33, "bot_clear_enemy" },
    { 0xE011E1F7, "bot_clone_loadout" },
    { 0x5CD60C9F, "bot_combat" },
    { 0x1EDE11A4, "bot_combat_dead" },
    { 0x1CF52E28, "bot_combat_idle" },
    { 0xAFE11E25, "bot_combat_main" },
    { 0x42882922, "bot_combat_melee" },
    { 0x42B09423, "bot_combat_tactical_insertion" },
    { 0x3F789CED, "bot_combat_target" },
    { 0xBAFF1C46, "bot_combat_think" },
    { 0x993564F5, "bot_combat_throw_emp" },
    { 0x475CA76B, "bot_combat_throw_lethal" },
    { 0xAFCD0524, "bot_combat_throw_proximity" },
    { 0x35BD843C, "bot_combat_throw_smoke" },
    { 0x1F40C2C6, "bot_combat_throw_tactical" },
    { 0xE7B0E5A8, "bot_combat_toss_flash" },
    { 0x5514E2D6, "bot_combat_toss_frag" },
    { 0xB96566EB, "bot_comp_stomp_remove" },
    { 0x4D736495, "bot_comp_stomp_think" },
    { 0x1068E784, "bot_conf_think" },
    { 0xBA959FEF, "bot_construct_class" },
    { 0x0A67A86F, "bot_construct_loadout" },
    { 0xF486669C, "bot_corner" },
    { 0x4C6A3025, "bot_count_bots" },
    { 0x72F30A12, "bot_count_enemy_bots" },
    { 0x3A4711C1, "bot_count_humans" },
    { 0x97B3FA23, "bot_crate_landed" },
    { 0xECC3602D, "bot_crate_think" },
    { 0xF2F5746D, "bot_crate_touch_think" },
    { 0xE15E48A7, "bot_crosshair_follow" },
    { 0xA3D57A7B, "bot_crouch_update" },
    { 0x893DB809, "bot_cry_for_help" },
    { 0x6F2D2560, "bot_ctf" },
    { 0xC4E97366, "bot_ctf_add_goal" },
    { 0x2E2273FB, "bot_ctf_capture" },
    { 0xA23B277B, "bot_ctf_defend" },
    { 0x8D8B5550, "bot_ctf_random_visible_node" },
    { 0x1E09F949, "bot_ctf_think" },
    { 0xDCE81D1E, "bot_damage_callback" },
    { 0xBDAF61D5, "bot_damage_think" },
    { 0x26FE5822, "bot_debug_box" },
    { 0x41D750E7, "bot_debug_circle" },
    { 0x112A2D45, "bot_debug_patrol" },
    { 0x32B9D5D7, "bot_debug_star" },
    { 0xF27C23B9, "bot_default_goal_radius" },
    { 0x27A5EE2A, "bot_defend_chance" },
    { 0x22BA039C, "bot_defend_radius" },
    { 0xCAF1712A, "bot_dem_attack" },
    { 0xA6590B1F, "bot_dem_attack_think" },
    { 0x842DB55F, "bot_dem_defend_think" },
    { 0x786ABAC0, "bot_dem_defuse" },
    { 0xE782B305, "bot_dem_enemy_interacting" },
    { 0xD9CCEBFC, "bot_dem_enemy_nearby" },
    { 0xF5341885, "bot_dem_friend_interacting" },
    { 0xBAD65811, "bot_dem_guard" },
    { 0x91AD147A, "bot_dem_think" },
    { 0x58FF286C, "bot_devgui_think" },
    { 0x46B15B34, "bot_difficulty" },
    { 0xDFB28326, "bot_dive_radius" },
    { 0xC5E35894, "bot_dive_to_prone" },
    { 0xA042D9C3, "bot_dogs_think" },
    { 0x5F1D8415, "bot_dom" },
    { 0xF3108E49, "bot_dom_flag_near_dist_sq" },
    { 0x1ADCABF0, "bot_dom_think" },
    { 0x2B27FED8, "bot_dot_product" },
    { 0x6A3A2DC7, "bot_dpad_stop" },
    { 0x7C01E4C4, "bot_dpad_terminate" },
    { 0x7F9E1229, "bot_dpad_think" },
    { 0xDAB2C0C5, "bot_enemies" },
    { 0x92E9C6DD, "bot_enemy" },
    { 0x3033DF74, "bot_equip_items" },
    { 0x6B527FB5, "bot_equipment_kill_think" },
    { 0x153EB254, "bot_equipment_think" },
    { 0xA5C347EE, "bot_expected_enemies" },
    { 0x909AF839, "bot_expected_friends" },
    { 0xC94B5424, "bot_failsafe_node_valid" },
    { 0xC7A29698, "bot_find_attacker" },
    { 0xCF60F797, "bot_first_spawn" },
    { 0xEAA175BE, "bot_flag_grenade" },
    { 0xBDC7C218, "bot_fov" },
    { 0x75BB8851, "bot_fov_easy" },
    { 0xB264A6FC, "bot_fov_fu" },
    { 0xB66068C4, "bot_fov_hard" },
    { 0x7E275232, "bot_fov_medium" },
    { 0x2692FBA0, "bot_friend_goal_in_radius" },
    { 0xE1BEA74C, "bot_friend_in_radius" },
    { 0x80BE881A, "bot_friends" },
    { 0x10DEBD79, "bot_gametype" },
    { 0x85891BF4, "bot_gametype_allowed" },
    { 0xD3589360, "bot_get_aim_error" },
    { 0x8340EA84, "bot_get_closest_enemy" },
    { 0x44674BE8, "bot_get_cod_points" },
    { 0xAC488F30, "bot_get_converge_rate" },
    { 0x6C1D77B9, "bot_get_converge_time" },
    { 0x4C29AFDF, "bot_get_difficulty" },
    { 0x038DEFB4, "bot_get_enemies" },
    { 0x187271D5, "bot_get_fov" },
    { 0x5E68C6D7, "bot_get_friends" },
    { 0x41648087, "bot_get_loadout_primary" },
    { 0x6F6E738F, "bot_get_look_at" },
    { 0x046DF5E4, "bot_get_mantle_start" },
    { 0xBA6770FD, "bot_get_melee_range_sq" },
    { 0x0693BDEA, "bot_get_vehicle_entity" },
    { 0xBF4DBB6E, "bot_give_body_perk" },
    { 0x7889DEEC, "bot_give_killstreaks" },
    { 0x487D43B1, "bot_give_loadout" },
    { 0xB56055E2, "bot_give_random_armor" },
    { 0x11C2856E, "bot_give_random_attachment" },
    { 0xF04A69C8, "bot_give_random_item" },
    { 0xF66DF62D, "bot_give_random_perk" },
    { 0xC97E83CD, "bot_give_random_weapon" },
    { 0x58F47349, "bot_givekillstreaks" },
    { 0x041455C8, "bot_glass_think" },
    { 0xB7BE1AD5, "bot_goal_is_enemy_flag" },
    { 0x65A12DBD, "bot_goal_reached" },
    { 0x2EAD4BA1, "bot_goals" },
    { 0x918D5046, "bot_hack_at_goal" },
    { 0x0C2C2E1E, "bot_hack_goal_pregame" },
    { 0x8A4BBD21, "bot_hack_has_goal" },
    { 0x7EF6EC25, "bot_hack_tank_get_goal_origin" },
    { 0xB8B1488D, "bot_hack_think" },
    { 0x86E3668C, "bot_has_crossbow" },
    { 0x0944A9EC, "bot_has_enemy" },
    { 0xF7AF7390, "bot_has_flag_goal" },
    { 0x50E3C245, "bot_has_hill_goal" },
    { 0x5E1EC4AD, "bot_has_hq_goal" },
    { 0x0E954D55, "bot_has_item" },
    { 0x577CF3F8, "bot_has_launcher" },
    { 0x2A1AC714, "bot_has_lmg" },
    { 0x8936BB77, "bot_has_melee_weapon" },
    { 0x7006AE99, "bot_has_minigun" },
    { 0x362BDD21, "bot_has_no_goal" },
    { 0xA96C9A54, "bot_has_perk" },
    { 0x5DF125CD, "bot_has_pistol" },
    { 0x9B73D05C, "bot_has_radar" },
    { 0x46C55F86, "bot_has_shotgun" },
    { 0xA0F254E9, "bot_has_sniper" },
    { 0xAB0D8159, "bot_has_weapon_class" },
    { 0xE04052D4, "bot_health_frac" },
    { 0xD94923E2, "bot_height" },
    { 0x952D7971, "bot_hill_grenade" },
    { 0x5E5B4718, "bot_hill_tactical_insertion" },
    { 0x5BCC6911, "bot_hinge_think" },
    { 0x6918D9BA, "bot_hit_target" },
    { 0x0F662599, "bot_hq_grenade" },
    { 0xD1827700, "bot_hq_tactical_insertion" },
    { 0x77336A2F, "bot_hq_think" },
    { 0x0EEB4665, "bot_idle" },
    { 0x975133A0, "bot_ignore_threat" },
    { 0xB70561A5, "bot_index" },
    { 0x357E4644, "bot_index_changed" },
    { 0xE3EFA649, "bot_is_at_hill" },
    { 0xB73E23BA, "bot_is_capturing_flag" },
    { 0xE999641D, "bot_is_capturing_hq" },
    { 0x83E6C6E4, "bot_is_idle" },
    { 0x025A4299, "bot_is_traversing" },
    { 0xF0E8A918, "bot_item_is_banned" },
    { 0xAB7C54CB, "bot_item_is_claimed" },
    { 0x0F600351, "bot_jump_align_dot" },
    { 0x753E14D4, "bot_kick_think" },
    { 0x0410FF0E, "bot_kicked" },
    { 0x62E378A5, "bot_killcam_think" },
    { 0x98192A15, "bot_killstreak_dangerous_think" },
    { 0xACF75B93, "bot_killstreak_level_is_used" },
    { 0xDCD911E9, "bot_killstreak_location" },
    { 0x85E7892C, "bot_killstreak_think" },
    { 0x366CF615, "bot_koth" },
    { 0x08208DF0, "bot_koth_think" },
    { 0x2490D905, "bot_loadout" },
    { 0x0C98E924, "bot_loadout_items" },
    { 0x786F9C35, "bot_local_enemies" },
    { 0xE049106A, "bot_local_friends" },
    { 0xEC9BFCBD, "bot_local_think" },
    { 0x99E3DC11, "bot_lookat_entity" },
    { 0x9662813C, "bot_main" },
    { 0xB8E7C615, "bot_make_choice" },
    { 0x2246F1EC, "bot_max_stuck_cycles" },
    { 0xA4EDCF1E, "bot_melee_range_sq" },
    { 0xADC14C9B, "bot_melee_range_sq_easy" },
    { 0x641785CE, "bot_melee_range_sq_fu" },
    { 0xBD7D5BCE, "bot_melee_range_sq_hard" },
    { 0x51B2B780, "bot_melee_range_sq_medium" },
    { 0x2DD3344C, "bot_min_jump_jet" },
    { 0x1DD225A9, "bot_move_to_flag" },
    { 0x82895EBA, "bot_move_to_hill" },
    { 0xD5F2CFB2, "bot_move_to_hq" },
    { 0x0C0C3F56, "bot_nearest_node" },
    { 0x8ABB41B2, "bot_need_to_defuse" },
    { 0x8D8666B4, "bot_num_enemy" },
    { 0x7FA4E12D, "bot_num_friendly" },
    { 0x390C7774, "bot_offline" },
    { 0x205D2BC4, "bot_on_target" },
    { 0x391EBC05, "bot_overlay" },
    { 0x7E05F110, "bot_overlay_stop" },
    { 0xFDFD1B20, "bot_overlay_think" },
    { 0x0F1D22FE, "bot_path" },
    { 0xC63730CE, "bot_path_failed" },
    { 0xAAB0CFD5, "bot_path_stop" },
    { 0x194DEF6B, "bot_path_think" },
    { 0xCFAD34B6, "bot_patrol_flag" },
    { 0x749DA6B1, "bot_patrol_hq" },
    { 0x0EA1470F, "bot_patrol_near_enemy" },
    { 0x670FB3F4, "bot_perk_from_reference_full" },
    { 0x959CE7AD, "bot_position_history_size" },
    { 0x0B5EDA34, "bot_post_combat" },
    { 0x9FD498FD, "bot_pre_combat" },
    { 0x7604D1BD, "bot_prediction_frames" },
    { 0xE303BEAB, "bot_primaries" },
    { 0x739DC7F5, "bot_radiation_think" },
    { 0x429617BD, "bot_radius" },
    { 0x92615676, "bot_rank_all_options_available" },
    { 0x90378424, "bot_rank_options_multiplier" },
    { 0x54938072, "bot_ranked_count" },
    { 0xD45B7E79, "bot_ranked_remove" },
    { 0xCF934CFB, "bot_ranked_think" },
    { 0x43ACF348, "bot_ranks" },
    { 0x935AECE3, "bot_rccar_kill" },
    { 0x834DADB9, "bot_rccar_think" },
    { 0x91E9C3FC, "bot_reconnect_bot" },
    { 0x9C0F5BD5, "bot_revive_think" },
    { 0x68B6365E, "bot_riotshield_dangerous_think" },
    { 0x80FC5613, "bot_riotshield_think" },
    { 0x8D1D9F92, "bot_sd" },
    { 0xD22A3C00, "bot_sd_attacker" },
    { 0x3783A014, "bot_sd_defender" },
    { 0x6A3AA1D5, "bot_sd_defender_think" },
    { 0x23C4B871, "bot_sd_grenade" },
    { 0xE335F497, "bot_sd_think" },
    { 0x5F34E866, "bot_select_weapon" },
    { 0xEB5EFA1B, "bot_set_difficulty" },
    { 0x9885D599, "bot_set_player_model" },
    { 0x46099302, "bot_set_rank" },
    { 0x3F64AAD2, "bot_setkillstreaks" },
    { 0x37B55672, "bot_shotgun_think" },
    { 0x8D422B91, "bot_should_clone_loadout" },
    { 0x40995003, "bot_should_hip_fire" },
    { 0xE3C0A114, "bot_should_patrol_flag" },
    { 0xFAF3A1E7, "bot_should_patrol_hq" },
    { 0x19339CE6, "bot_sniper_fire_delay_easy" },
    { 0xA6E533FB, "bot_sniper_fire_delay_fu" },
    { 0xF763F5DB, "bot_sniper_fire_delay_hard" },
    { 0xEFC74061, "bot_sniper_fire_delay_medium" },
    { 0x10A19344, "bot_spawn" },
    { 0x6E966135, "bot_spawn_init" },
    { 0x7EDB3605, "bot_spawn_think" },
    { 0xA4E3CBBF, "bot_spawner_once" },
    { 0x9D589034, "bot_spawner_think" },
    { 0xA2E25EAE, "bot_speed2d" },
    { 0x5102DF21, "bot_stuck_distance" },
    { 0xA50C88D4, "bot_stuck_resolution_s" },
    { 0x5462CB94, "bot_swim_height_max" },
    { 0x7EF4D6DA, "bot_swim_height_min" },
    { 0x98E79130, "bot_system_devgui_think" },
    { 0x4C3E11AA, "bot_tactical_insertion" },
    { 0xD349ED94, "bot_talon_think" },
    { 0xFA44AA4D, "bot_think" },
    { 0xAD42C609, "bot_think_interval_secs_easy" },
    { 0xB406C304, "bot_think_interval_secs_fu" },
    { 0x55F2287C, "bot_think_interval_secs_hard" },
    { 0x832BABAA, "bot_think_interval_secs_medium" },
    { 0x6EED3D1A, "bot_think_loop" },
    { 0xBBC3085F, "bot_threat" },
    { 0x0B4AA652, "bot_threat_stop" },
    { 0x97FD4406, "bot_threat_think" },
    { 0x92BDE486, "bot_traversals" },
    { 0x95E8F519, "bot_turret_location" },
    { 0x60FDD4B9, "bot_turret_nearest_node" },
    { 0x56F5BFFD, "bot_turret_set_dangerous" },
    { 0xB0F12DBC, "bot_turret_think" },
    { 0xC2CBCBA4, "bot_unhandled" },
    { 0x7EC247B0, "bot_update" },
    { 0x6C31685A, "bot_update_aim" },
    { 0x59F9691F, "bot_update_attack" },
    { 0x18506FDE, "bot_update_c4" },
    { 0x499FAD68, "bot_update_cover" },
    { 0xA0CD2118, "bot_update_crate" },
    { 0x7B5E5199, "bot_update_crouch" },
    { 0xC511CA68, "bot_update_failsafe" },
    { 0x6C36AAF9, "bot_update_glass" },
    { 0x0EFAF37D, "bot_update_killstreak" },
    { 0x8CE3913B, "bot_update_launcher" },
    { 0x50E82771, "bot_update_lookat" },
    { 0x6581F3CC, "bot_update_move_angle" },
    { 0xE93BBAE9, "bot_update_patrol" },
    { 0x3BA96F72, "bot_update_sight" },
    { 0x5A6E5507, "bot_update_threat_goal" },
    { 0xD0CB4E3D, "bot_update_toss_flash" },
    { 0xAE77FDC1, "bot_update_toss_frag" },
    { 0xDA99CBF4, "bot_update_wander" },
    { 0xF55E4FBB, "bot_update_weapon" },
    { 0xF49C2452, "bot_use_item" },
    { 0xE3D20C2E, "bot_use_supply_drop" },
    { 0x08222A8C, "bot_using_launcher" },
    { 0xB5ACC8F0, "bot_vehicle_attack" },
    { 0xA21AB48C, "bot_vehicle_think" },
    { 0x0DC78B18, "bot_vehicle_weapon" },
    { 0x91FA938D, "bot_vehicle_weapon_ammo" },
    { 0x3BF716D9, "bot_void" },
    { 0x8B80643E, "bot_wager_think" },
    { 0x858818CC, "bot_wait_for_activate" },
    { 0xEB77DAC9, "bot_wait_for_host" },
    { 0x5063EFB5, "bot_wakeup_think" },
    { 0x7AF85510, "bot_wander" },
    { 0xAFE8C353, "bot_weapon_ammo_frac" },
    { 0x3828BE9D, "bot_weapon_classified_unlocked" },
    { 0xC93A1318, "bot_weapon_dual_wield_unlocked" },
    { 0xBE1DE478, "bot_weapon_ids" },
    { 0x2A307D0F, "bot_weapon_reference_from_weapon" },
    { 0x4EABBDD2, "botched" },
    { 0x70A73CC9, "botched_throw_chain" },
    { 0x593A2A94, "botclass" },
    { 0x8F244E96, "botclassaddattachment" },
    { 0xE49EA360, "botclassadditem" },
    { 0xCD93C303, "botclasssetweaponoption" },
    { 0x66A90634, "botcombat" },
    { 0xC4BFB171, "botcount" },
    { 0xD7F6A4D8, "botcounts" },
    { 0xF61E96DA, "botdevguicmd" },
    { 0x69527BD1, "botdir" },
    { 0x16B3AB5E, "botdropclient" },
    { 0xDAA4261B, "botent" },
    { 0x1032C029, "botgetfov" },
    { 0x5BD0F250, "botgetgoalposition" },
    { 0x08154BA3, "botgetgoalradius" },
    { 0x423ACD9B, "botgetthreats" },
    { 0x4FE3BA2D, "botgoalreached" },
    { 0x2B2BD09F, "botgoalset" },
    { 0xEEFDFF3C, "both" },
    { 0x15D535AB, "both_halftracks_eliminated" },
    { 0xD1BDFBE5, "bothbombsdetonatewithintime" },
    { 0x332FC339, "bother" },
    { 0xD70D754F, "bothering" },
    { 0xCE074ABA, "botidle" },
    { 0xB27B0B06, "botignorethreat" },
    { 0x88BEC4FB, "botleavegame" },
    { 0xA2AFCC84, "botlookatpoint" },
    { 0x66D6EF34, "botlookforward" },
    { 0x9FA7F8A3, "botlooknone" },
    { 0x47854466, "botpostcombat" },
    { 0x110E31EB, "botprecombat" },
    { 0x5F945E29, "botpressbutton" },
    { 0x0B8C41C6, "botpressbuttonforgadget" },
    { 0xFC0C3727, "botreleasebutton" },
    { 0xF5038D9E, "botreleasebuttons" },
    { 0x7E603F78, "botreleasemanualcontrol" },
    { 0x5EE14ACA, "botrequestpath" },
    { 0xD0C9F49F, "bots" },
    { 0xF9A40463, "bots_alive_challenge" },
    { 0x636088F3, "bots_alive_challenge_complete" },
    { 0x61EF4D9C, "botscount" },
    { 0x38B39161, "botsetdefaultclass" },
    { 0x9DE0EADF, "botsetfailsafenode" },
    { 0xB4A0B3C5, "botsetgoal" },
    { 0x56740E95, "botsetlookangles" },
    { 0x546ECEE9, "botsetlookanglesfrompoint" },
    { 0xC14CC56C, "botsetmoveangle" },
    { 0x7B22F8C6, "botsetmoveanglefrompoint" },
    { 0x54FB22AB, "botsetmovemagnitude" },
    { 0xCF1F0ADD, "botsetrandomcharactercustomization" },
    { 0x93FFFA7B, "botsettings" },
    { 0x1F415F1A, "botsighttrace" },
    { 0xB2AAB34A, "botsighttracepassed" },
    { 0xBFCFDFF6, "botsoak" },
    { 0x3707A43F, "botswitchtoweapon" },
    { 0x3F50C356, "bottakemanualcontrol" },
    { 0x6CE1FA57, "bottapbutton" },
    { 0x894E090B, "bottel" },
    { 0xA4C843D6, "botthreatdead" },
    { 0xE3CF16D9, "botthreatengage" },
    { 0x0492758F, "botthreatisalive" },
    { 0x1A85A65E, "botthreatlost" },
    { 0x1714A389, "bottle" },
    { 0xC2022405, "bottle_collected" },
    { 0xD59C8698, "bottle_cycling_finished" },
    { 0x12DE9BE5, "bottle_dispense" },
    { 0x007D34FB, "bottle_end" },
    { 0x6B1C298A, "bottle_origin" },
    { 0x49E55229, "bottle_reject_sink" },
    { 0xCAE2E191, "bottle_spawn_location" },
    { 0x327952EE, "bottle_spawned" },
    { 0x5C7F3B20, "bottle_trigger_activate" },
    { 0x299E82AF, "bottle_trigger_visibility" },
    { 0x08CD9F54, "bottleneck" },
    { 0xCB607380, "bottles" },
    { 0xD7115B10, "bottom" },
    { 0x19104919, "bottom_arc" },
    { 0x98B69BBB, "bottom_door_bottom" },
    { 0xD37611C7, "bottom_door_top" },
    { 0xF2260B3F, "bottom_guard_sit_animate" },
    { 0x96DDE50F, "bottom_guard_stand_animate" },
    { 0xCDEEB9BC, "bottom_node_r" },
    { 0x85732C4F, "bottom_of_rope" },
    { 0x4DE9FFE9, "bottom_rocket_end" },
    { 0x4F925C3D, "bottom_rocket_piece_hits_ground" },
    { 0xD4090E12, "bottom_roll" },
    { 0x882CA56B, "bottom_stairs_vol" },
    { 0x27CC31A2, "bottom_tag_origin" },
    { 0x35163F01, "bottom_trigger" },
    { 0x167B71E4, "bottom_y" },
    { 0x7F01B280, "bottomarc" },
    { 0x13E97600, "bottomdist" },
    { 0x3730292A, "bottomfx" },
    { 0x3F46E249, "bottomname" },
    { 0xBC4EBADC, "bottomoftracklength" },
    { 0x2F80D33E, "bottompos" },
    { 0x5D4C8ED6, "bottomright" },
    { 0xD86ED37B, "bottomtrace" },
    { 0x56904E71, "bottomy" },
    { 0x89AB1F0B, "botundermanualcontrol" },
    { 0x0201EE8F, "botupdate" },
    { 0x1A99051E, "botupdatethreatgoal" },
    { 0x4A271A01, "botweaponoptionsid" },
    { 0x3E2E90A7, "botweaponoptionsprob" },
    { 0x8F4DB4D8, "bouces" },
    { 0x5ACAA1CC, "bought" },
    { 0xDDE369DE, "bought_all_perks" },
    { 0x947B1AC7, "bought_weapon" },
    { 0x09B813BE, "bought_weapons" },
    { 0x7151E34C, "boulder" },
    { 0xAB012425, "bounce" },
    { 0x07E211E5, "bounce_count" },
    { 0xF5C88BBF, "bounce_from_a_to_b" },
    { 0x2ECBB0CD, "bounce_path" },
    { 0xBBE1CABC, "bounce_player_after_water_sheeting" },
    { 0x0B0C03B6, "bounce_player_on_impact" },
    { 0x3E89CB6D, "bounce_player_on_impact_frac" },
    { 0x5FC622BE, "bounce_scale" },
    { 0xF738525C, "bounce_shrek_fired" },
    { 0x7ED4153B, "bounced" },
    { 0x33ED5D15, "bouncedist" },
    { 0x1E4DB7D0, "bouncedtime" },
    { 0x2B00B09D, "bouncer" },
    { 0xCF41D6BB, "bouncer_open_lounge_door_anims" },
    { 0x7E2425DC, "bouncers" },
    { 0x04FE3634, "bounces" },
    { 0x109212E5, "bouncescale" },
    { 0xA366F1C2, "bouncetime" },
    { 0xBCE0ECD0, "bounch" },
    { 0xF54B4BF0, "bouncing" },
    { 0x2FE61D51, "bouncing_betty" },
    { 0x73BD7FA3, "bouncing_betty_array" },
    { 0xA57DC03B, "bouncing_betty_setup" },
    { 0xE401E33D, "bouncing_betty_watch" },
    { 0x9DDFFD87, "bouncing_tomahawk_zm_aquired" },
    { 0xC147E610, "bouncingbetty" },
    { 0xFDCC807E, "bouncingbetty_deploying" },
    { 0xF63FC54E, "bouncingbetty_detonating" },
    { 0x48CEF1C1, "bouncingbetty_init" },
    { 0xA90633F1, "bouncingbetty_planted" },
    { 0xECC29C55, "bouncingbetty_state_change" },
    { 0xB6B5B533, "bouncingbettydamage" },
    { 0x77F8C581, "bouncingbettydestroyed" },
    { 0x4B635AA8, "bouncingbettydetonate" },
    { 0x385D31F4, "bouncingbettyidlefx" },
    { 0xAAEBD6A4, "bouncingbettyinfo" },
    { 0x002C27DA, "bouncingbettyjumpandexplode" },
    { 0x82BBC0A9, "bouncy" },
    { 0x6BE7D507, "bound" },
    { 0x5B94D41C, "bound_to_buildable" },
    { 0x3FAE5357, "boundaries" },
    { 0x6AB013A3, "boundary" },
    { 0xFC0D1E7E, "boundary_watcher" },
    { 0xBFC672DF, "boundarydist" },
    { 0xEBD7E459, "bounding" },
    { 0x87887B30, "bounding_sphere_radius" },
    { 0xF552D1EA, "bounding_sphere_radius_squared" },
    { 0x76307183, "bounding_sphere_rsquared" },
    { 0x67550FC4, "boundry" },
    { 0xE575162B, "boundrypadding" },
    { 0x6B1E7AFE, "bounds" },
    { 0x30072065, "bounds_max" },
    { 0x1AE878CB, "bounds_min" },
    { 0x8A1C8A42, "bounds_origins" },
    { 0xD8BFAC91, "boundswouldtelefrag" },
    { 0x455001EB, "bout" },
    { 0x4CF9551B, "bouyancy" },
    { 0xEFA242E5, "boverride" },
    { 0x6A2CA997, "bow" },
    { 0x8513342F, "bow_crows_nest" },
    { 0xCA546CA7, "bow_destructibles" },
    { 0xF6208657, "bow_gun_angles" },
    { 0xBE2A233C, "bow_gun_guy" },
    { 0x96769409, "bow_gun_origin" },
    { 0xB582D080, "bow_gun_redshirt" },
    { 0xF3222C8E, "bow_light" },
    { 0x85365AC2, "bow_light_broken" },
    { 0x82B73486, "bow_light_target" },
    { 0x65DE3B82, "bow_port_node" },
    { 0x93EB5245, "bow_railclimb_drones" },
    { 0xA8108B45, "bow_resistance" },
    { 0xAF756939, "bow_starboard_node" },
    { 0x60088C9A, "bowan" },
    { 0x935B3ED1, "bowie" },
    { 0x43353413, "bowie_cost" },
    { 0x91F15718, "bowie_flourish" },
    { 0xC925B3AA, "bowie_init" },
    { 0xBE67284F, "bowie_show" },
    { 0x1C09C004, "bowie_think" },
    { 0xD4970E0B, "bowie_triggers" },
    { 0xB2435469, "bowl" },
    { 0xC428999F, "bowling" },
    { 0x344F6EA5, "bowman" },
    { 0xC11B20A4, "bowman_ai_setup" },
    { 0x3AED2B0A, "bowman_backpack" },
    { 0x61DF6466, "bowman_behavior" },
    { 0xE0DEA9B0, "bowman_boat_firing" },
    { 0x3BD842FC, "bowman_break_window" },
    { 0x9EB9DA98, "bowman_brooks_cover_truck" },
    { 0xDB55844A, "bowman_brooks_move_fwd" },
    { 0xFF253C60, "bowman_brooks_rescued" },
    { 0x157D48AD, "bowman_c4" },
    { 0xA6CAFDD1, "bowman_c4_b_node" },
    { 0xB882D969, "bowman_cover" },
    { 0x0862D580, "bowman_cover_node" },
    { 0x5DDB9BE2, "bowman_entrance" },
    { 0xFBCEFAAB, "bowman_entrance_start" },
    { 0xFAA4B1E3, "bowman_execution_start" },
    { 0x2FC245E8, "bowman_garage_meetup" },
    { 0x627A67C1, "bowman_get_on_pbr" },
    { 0xC909B8C2, "bowman_head_bleed_start" },
    { 0x574E98C0, "bowman_heli" },
    { 0xBD66C382, "bowman_heli_swap" },
    { 0x22F6A976, "bowman_in_tunnel_start_node" },
    { 0xE2E86BEC, "bowman_index" },
    { 0xCD8A178B, "bowman_knife" },
    { 0x236C40E1, "bowman_mode" },
    { 0x374D37BC, "bowman_node" },
    { 0xE661A4D0, "bowman_num_missiles" },
    { 0x3D712441, "bowman_objective" },
    { 0xEDFC9DEA, "bowman_opens_door" },
    { 0x789BD209, "bowman_outsidetunnels_node" },
    { 0x81D2CB85, "bowman_pos_node" },
    { 0x540D382E, "bowman_post_entrance_node" },
    { 0x7840B6B3, "bowman_post_jeepmeetup" },
    { 0xD6DE3306, "bowman_repel_after_smallroom_clear" },
    { 0x7FB3EEDC, "bowman_rope" },
    { 0x875CD637, "bowman_secondary_objective_marker" },
    { 0x6FE7CC78, "bowman_shore_point" },
    { 0xECCA233B, "bowman_spit_func" },
    { 0xE61C8685, "bowman_sprint_down_alley" },
    { 0x486384A5, "bowman_takedown" },
    { 0xE27C1518, "bowman_victim" },
    { 0xAF7DA615, "bowman_walk_compound" },
    { 0xAB3D7DB4, "bowmans" },
    { 0x169CE7EF, "bownode" },
    { 0xDAF0C35B, "bowplayerkilleffect" },
    { 0x30077D70, "box" },
    { 0xAF85C9B8, "box_carry" },
    { 0x2E2CEE70, "box_carry_damage" },
    { 0xFFFFA18D, "box_carry_death_run" },
    { 0xBEAF6953, "box_carry_done" },
    { 0x177E0CD4, "box_carry_drop" },
    { 0xFC25E88F, "box_carry_stop" },
    { 0x8EDE4156, "box_current" },
    { 0xC247F4B2, "box_current_in_maze" },
    { 0xA469AEC6, "box_depth" },
    { 0xCD8B65FA, "box_detach_delay" },
    { 0x14A6411C, "box_encounter_vo" },
    { 0xD9C666C1, "box_finished" },
    { 0xDD713E62, "box_firesale_teddy_bear" },
    { 0x6B2CF8B5, "box_footprint_think" },
    { 0x4403DA96, "box_forward" },
    { 0x153B36B5, "box_get_ground_offset" },
    { 0x1689BCCD, "box_guy_health" },
    { 0xBB8E70DA, "box_hacked_rerespin" },
    { 0x835CB801, "box_hacked_respin" },
    { 0xF9062E0B, "box_hacks" },
    { 0xC04D44DE, "box_height" },
    { 0x902E3799, "box_index" },
    { 0xA4D8BA61, "box_init" },
    { 0xCEA54B45, "box_kick" },
    { 0xC8B5FBC8, "box_left" },
    { 0x1532C34F, "box_lock_action" },
    { 0xC56B0348, "box_lock_condition" },
    { 0xDA0DD161, "box_locked" },
    { 0xE8DDA966, "box_locs" },
    { 0xB35BDE3E, "box_mode" },
    { 0x4082D956, "box_model" },
    { 0x96E57445, "box_model_hide" },
    { 0xB256E1E1, "box_model_visible" },
    { 0x0D922623, "box_monitor" },
    { 0xA03313C4, "box_move" },
    { 0x96701A71, "box_move_action" },
    { 0xF4CDDFF0, "box_move_bear_flyaway_accel" },
    { 0x3E339CE9, "box_move_bear_flyaway_distance" },
    { 0x01A20B03, "box_move_bear_flyaway_time" },
    { 0x5C924A9E, "box_move_condition" },
    { 0xEE6E67E8, "box_move_in_maze" },
    { 0x20A115ED, "box_move_index" },
    { 0xB60AEEFC, "box_move_interrupt" },
    { 0x1CAD8108, "box_moved" },
    { 0xAA9D994D, "box_moving" },
    { 0x00051EB7, "box_notetracks" },
    { 0xA6652C25, "box_origin" },
    { 0x91325E6E, "box_panels" },
    { 0x1BA37F13, "box_pos" },
    { 0xCE473431, "box_prompt_and_visiblity" },
    { 0x701C6821, "box_radius" },
    { 0x8A955E53, "box_rerespun" },
    { 0xA624F359, "box_respin_respin_think" },
    { 0xDF3B7399, "box_respin_think" },
    { 0xC4744518, "box_spin_action" },
    { 0xFE4F1ACD, "box_spin_condition" },
    { 0xFD773656, "box_spin_done" },
    { 0xA6CDCE16, "box_spin_qualifier" },
    { 0x2ADE4AD9, "box_think" },
    { 0x8BACEA21, "box_trigger" },
    { 0x7A01626A, "box_truck_path" },
    { 0x94093A08, "box_up" },
    { 0xC3FFADA5, "box_width" },
    { 0x9BB6351A, "boxcar" },
    { 0xB7C19DE8, "boxcar_name" },
    { 0x646D1903, "boxed" },
    { 0x1099B465, "boxer" },
    { 0xEA9739FC, "boxes" },
    { 0x4C218FCA, "boxhalfheight" },
    { 0x096BD7E9, "boxhalfwidth" },
    { 0x869AF4E8, "boxing" },
    { 0xAC4E8164, "boxing_endgame_1" },
    { 0x1E55F09F, "boxing_endgame_2" },
    { 0xF8537636, "boxing_endgame_3" },
    { 0x7A0615A2, "boxing_endgame_array" },
    { 0xB6852671, "boxstub_update_prompt" },
    { 0x5EA78AD1, "boxtrigger_update_prompt" },
    { 0x5609F7D9, "boy" },
    { 0xD80B9C81, "boy_scream_off" },
    { 0xF7E37A90, "boys" },
    { 0xC3EFEE1F, "bp" },
    { 0x8C285414, "bp1" },
    { 0x6F652C5F, "bp1_crew_showoff" },
    { 0xB63FBF9C, "bp1_crew_spawn" },
    { 0xDBC31CB4, "bp1_entrance_explosions" },
    { 0xC8403DE8, "bp1_exit_battle" },
    { 0xBA80F12E, "bp1_exit_done" },
    { 0x8A79A2FE, "bp1_hip1_rappel" },
    { 0x27700DB5, "bp1_hip_circle" },
    { 0xE8DB76F4, "bp1_hips_flyby" },
    { 0xC64E6733, "bp1_horse_behavior" },
    { 0xDB434D6E, "bp1_horse_runaway" },
    { 0x576D8084, "bp1_mig2_bombrun" },
    { 0xE8D574B8, "bp1_mig2_bombs" },
    { 0xE10E4CC3, "bp1_mig_intro" },
    { 0x16043647, "bp1_muj_exit_logic" },
    { 0x43F29020, "bp1_rappel_logic" },
    { 0x38174ECB, "bp1_replenish_arena" },
    { 0x2EB069F1, "bp1_rooftop_logic" },
    { 0xACC8A4F8, "bp1_set_btr_spawn_flags" },
    { 0x91ECC049, "bp1_soviet_chain_p3" },
    { 0x879A17F8, "bp1_soviet_chain_p3_sm" },
    { 0x5864AB29, "bp1_spawn_hitch_horse" },
    { 0x3CAF4ECC, "bp1_tower_hit" },
    { 0x66CF28ED, "bp1_tower_impact_base" },
    { 0xF0740527, "bp1_tower_impact_ground" },
    { 0x22108407, "bp1_vehicle_chooser" },
    { 0xE11FD23D, "bp1_vehicle_destroyed" },
    { 0x590130CB, "bp1_wave3" },
    { 0x06C47E34, "bp1exit_guy" },
    { 0x61FF7483, "bp1wave1_monitor_soviets" },
    { 0xAAF255D4, "bp1wave3_boss_chooser" },
    { 0xDE6467B6, "bp1wave3_hind1_flyto_base" },
    { 0x27976DB3, "bp1wave3_hind2_flyto_base" },
    { 0x5778019E, "bp1wave3_hip1_behavior" },
    { 0x50CD8DF3, "bp1wave3_hip2_behavior" },
    { 0x32611048, "bp1wave3_muj_logic" },
    { 0x6A47CCF9, "bp1wave3_replenish_arena" },
    { 0xAA2555DC, "bp1wave3_soviet_logic" },
    { 0x205E0475, "bp1wave3_vehicle_chooser" },
    { 0xE4EE3B5B, "bp1wave3_vehicle_destroyed" },
    { 0x49FE6F55, "bp1wave4_boss_chooser" },
    { 0x52B61F42, "bp1wave4_btr1_behavior" },
    { 0xA95AFCC7, "bp1wave4_btr2_behavior" },
    { 0x834DEE1C, "bp1wave4_hind1_attackbase" },
    { 0xCB9D1201, "bp1wave4_hind1_behavior" },
    { 0x3756BA0D, "bp1wave4_hind2_attackbase" },
    { 0x1C814990, "bp1wave4_hind2_behavior" },
    { 0xBF902809, "bp1wave4_hip1_behavior" },
    { 0xCE9F185B, "bp1wave4_hip1_rappel" },
    { 0xE21CA75F, "bp1wave4_hip1_rappel_arena" },
    { 0xADE5E090, "bp1wave4_hip1_rappel_cache" },
    { 0xA80E0BE0, "bp1wave4_hip1_rappel_logic" },
    { 0xFBCF0D78, "bp1wave4_hip2_behavior" },
    { 0xB8CD49B8, "bp1wave4_start" },
    { 0xD66D75DD, "bp1wave4_start_event" },
    { 0x725350A9, "bp1wave4_start_trigger" },
    { 0xDC5AAFAC, "bp1wave4_start_vehicles" },
    { 0x479B17DE, "bp1wave4_tank1_behavior" },
    { 0xF82FB133, "bp1wave4_tank2_behavior" },
    { 0x182D278E, "bp1wave4_vehicle_chooser" },
    { 0xFE2FC34F, "bp2" },
    { 0x1513A412, "bp2_backup_horse" },
    { 0xAD308018, "bp2_clip" },
    { 0x6232DC39, "bp2_defenders_logic" },
    { 0xB240F0F1, "bp2_enemies_logic" },
    { 0x414E443B, "bp2_exit_battle" },
    { 0x5520565E, "bp2_exit_battle_horse_behavior" },
    { 0x3E593C0C, "bp2_exit_battle_horses" },
    { 0xDA5F3A7C, "bp2_exit_btr_logic" },
    { 0x05D5302C, "bp2_exit_muj_logic" },
    { 0xDA5C8D68, "bp2_exit_troop_logic" },
    { 0xB1BAF17C, "bp2_exit_truck1_logic" },
    { 0x98C3C397, "bp2_exit_truck2_logic" },
    { 0x3F70C668, "bp2_exit_uaz_logic" },
    { 0x4DECE388, "bp2_hind_attack" },
    { 0x25BE6F3F, "bp2_hind_attack_cache" },
    { 0x71E12ECA, "bp2_hind_attackpoint" },
    { 0xD47EB0ED, "bp2_hip1_troops_logic" },
    { 0x8ACA9EB4, "bp2_hip2_troops_logic" },
    { 0x0C22486A, "bp2_horse_lineup_behavior" },
    { 0x34B428F6, "bp2_mig_bombers" },
    { 0x53B2ED39, "bp2_mig_bombrun" },
    { 0xA7CEFF00, "bp2_replenish_arena" },
    { 0x121EEB8B, "bp2_soviet_logic" },
    { 0x0ABBF840, "bp2_vehicle_chooser" },
    { 0x732068F2, "bp2_vehicle_destroyed" },
    { 0x6091051D, "bp2wave2_hind_logic" },
    { 0x1E81B832, "bp2wave2_hip1_logic" },
    { 0xA96B3411, "bp2wave2_hip2_logic" },
    { 0xE67F793A, "bp2wave2_spawn_boss" },
    { 0x65AAFF92, "bp2wave3_done" },
    { 0x89DD6652, "bp2wave3_hind_aiattack" },
    { 0x4A3345A3, "bp2wave3_hind_baseattack" },
    { 0xB4261ECA, "bp2wave3_hind_behavior" },
    { 0xAA6D1675, "bp2wave3_spawn_boss" },
    { 0xA2504EA7, "bp2wave3_tank_behavior" },
    { 0x4A653586, "bp2wave4_boss_chooser" },
    { 0x2E512112, "bp2wave4_hind1_behavior" },
    { 0xD5B8EE97, "bp2wave4_hind2_behavior" },
    { 0xE1B85A28, "bp2wave4_hind_attackbase" },
    { 0x3806DCF8, "bp2wave4_hip1_behavior" },
    { 0x28F1A4CA, "bp2wave4_hip1_rappel" },
    { 0x0FA1CB9E, "bp2wave4_hip1_rappel_arena" },
    { 0x10BC4995, "bp2wave4_hip1_rappel_cache" },
    { 0x68F079E5, "bp2wave4_hip1_rappel_logic" },
    { 0xFBC7F789, "bp2wave4_hip2_behavior" },
    { 0x2414FFA5, "bp2wave4_start" },
    { 0x47B62970, "bp2wave4_start_event" },
    { 0xBA70808C, "bp2wave4_start_trigger" },
    { 0xCB566EE3, "bp2wave4_start_vehicles" },
    { 0x048FA6FB, "bp2wave4_vehicle_chooser" },
    { 0xD82D48E6, "bp3" },
    { 0xF7AB9ACC, "bp3_approach_explosions" },
    { 0x39858631, "bp3_backup_horse" },
    { 0x9A4EFFC3, "bp3_btr1_logic" },
    { 0xAE96FD08, "bp3_btr2_logic" },
    { 0xACDDA2A0, "bp3_enemies_logic" },
    { 0xF623C5E5, "bp3_event_continue" },
    { 0xA4E24515, "bp3_exit_battle_horse_behavior" },
    { 0xBE6A0656, "bp3_exit_battle_spawn" },
    { 0x5D54F9CA, "bp3_exit_chopper_behavior" },
    { 0xDEA13B3F, "bp3_exit_muj_logic" },
    { 0xA2A0475D, "bp3_exit_soviet_logic" },
    { 0x889FBFBB, "bp3_handle_player_horse" },
    { 0x1C2FA0F0, "bp3_heli_hip_logic" },
    { 0x971B115D, "bp3_hind1_attack_pattern" },
    { 0xB245E2D4, "bp3_hind1_logic" },
    { 0xFCFB8354, "bp3_hip1_rappel" },
    { 0x32A9CBC8, "bp3_hip_rappel_logic" },
    { 0x2BBE98C3, "bp3_horse_logic" },
    { 0x6BAEE93B, "bp3_horserider_logic" },
    { 0x8BB4AF2E, "bp3_infantry_attack_cache" },
    { 0x2EDEA6CF, "bp3_infantry_event" },
    { 0x361C8029, "bp3_replenish_arena" },
    { 0xEC9B7634, "bp3_sniper" },
    { 0x92E69FA2, "bp3_soviet_bridge_logic" },
    { 0x2AB7D878, "bp3_soviet_firstbridge_logic" },
    { 0x8C40A70C, "bp3_soviet_logic" },
    { 0x21C019FC, "bp3_uaz_logic" },
    { 0xDAAB95C5, "bp3_vehicle_chooser" },
    { 0x438C966B, "bp3_vehicle_destroyed" },
    { 0xE26E9B16, "bp3_watch_for_dismount" },
    { 0xF44C88A5, "bp3wave2_boss_chooser" },
    { 0x0EE72D75, "bp3wave2_hind_attack_pattern" },
    { 0xC8ACBE4A, "bp3wave2_hind_circle" },
    { 0xC4DADECE, "bp3wave2_hind_flyto_base" },
    { 0x17E4807C, "bp3wave2_hind_logic" },
    { 0x81F06C8F, "bp3wave2_hip1_logic" },
    { 0xCC79D694, "bp3wave2_hip2_logic" },
    { 0xD45CCBA6, "bp3wave3_boss_chooser" },
    { 0x595242AB, "bp3wave3_done" },
    { 0xC298AF7D, "bp3wave3_hind_behavior" },
    { 0x2A18CF14, "bp3wave3_tank_behavior" },
    { 0x070AFC83, "bp3wave4_boss_chooser" },
    { 0xC355D59F, "bp3wave4_hind1_behavior" },
    { 0xC251DFBA, "bp3wave4_hind2_behavior" },
    { 0x6CE28C17, "bp3wave4_hip1_behavior" },
    { 0xAB0753E5, "bp3wave4_hip1_rappel" },
    { 0x60D6CB85, "bp3wave4_hip1_rappel_arena" },
    { 0x4E136446, "bp3wave4_hip1_rappel_cache" },
    { 0xD1C15B3A, "bp3wave4_hip1_rappel_logic" },
    { 0xC57ABE92, "bp3wave4_hip2_behavior" },
    { 0x534DDAC8, "bp3wave4_hip_fire_support" },
    { 0xFD5B600A, "bp3wave4_start" },
    { 0xE7157063, "bp3wave4_start_event" },
    { 0xDD034657, "bp3wave4_start_trigger" },
    { 0xF8AC2472, "bp3wave4_start_vehicles" },
    { 0xE69D8600, "bp3wave4_vehicle_chooser" },
    { 0xB870E914, "bp_ai" },
    { 0x3E028211, "bp_angle_left" },
    { 0x478F0D3C, "bp_angle_right" },
    { 0x2E070E09, "bp_direction" },
    { 0x71BFBE46, "bp_duration" },
    { 0x9E34DBDF, "bp_height" },
    { 0x18EF0574, "bp_radius" },
    { 0xB0481B27, "bp_side" },
    { 0x909138E3, "bpgm" },
    { 0xD71A9A30, "bplaydefaultfx" },
    { 0x6F8ACBB3, "bplayerlock" },
    { 0x95F4F36A, "bplayersdamage" },
    { 0xBE9AA4DC, "bplaysound" },
    { 0x08650801, "bposedstyle" },
    { 0xBA95F033, "bpredictmore" },
    { 0xA3F9C916, "bpressingsprint" },
    { 0x2F96D895, "bpstub_set_custom_think_callback" },
    { 0x3FD5AE77, "bptrigger_think_one_time" },
    { 0xBC2E2299, "bptrigger_think_one_use_and_fly" },
    { 0xADB796BC, "bptrigger_think_persistent" },
    { 0x11B0A3BA, "bptrigger_think_unbuild" },
    { 0xB44848CD, "bptrigger_think_unbuild_no_return" },
    { 0x77EAF94D, "br" },
    { 0x740E1AC7, "br0" },
    { 0x4E0BA05E, "br1" },
    { 0xAC830E21, "br_left_shudder" },
    { 0x7E48DA08, "br_right_shudder" },
    { 0xE65AE78E, "brace" },
    { 0x68027C31, "braces" },
    { 0xFB5D1AF3, "bracket" },
    { 0x23D5FE57, "bracket_color" },
    { 0xCA86AD51, "bracket_frame" },
    { 0xED0ADAA2, "brackets" },
    { 0xF243AB91, "brackets_ll" },
    { 0x06665D4F, "brackets_lr" },
    { 0xE84B59C6, "brackets_ul" },
    { 0xD428A808, "brackets_ur" },
    { 0x72D345FC, "bradley" },
    { 0xF2025B02, "brah" },
    { 0x2E47B57F, "brain" },
    { 0x54A9DC8A, "brainwash" },
    { 0xDCB09010, "brainwash_aim" },
    { 0xC2EC973A, "brainwash_anims_init" },
    { 0xD26B4345, "brainwash_bump" },
    { 0xFA0F5F5B, "brainwash_bump_size" },
    { 0x7BD60A13, "brainwash_chains" },
    { 0x1D8FA9CE, "brainwash_fail_speed_fast" },
    { 0xD98F0E8B, "brainwash_fail_speed_slow" },
    { 0xC6B0FA23, "brainwash_hands_animator" },
    { 0xF11721B3, "brainwash_input" },
    { 0x0B9DBB3F, "brainwash_instant_fail" },
    { 0xCEFE8C60, "brainwash_model" },
    { 0x290B00F4, "brainwash_room_settings" },
    { 0x650D2119, "brainwash_sequence_done" },
    { 0x394F0D43, "brainwash_strength_test_update" },
    { 0xF81E85EC, "brainwash_weights" },
    { 0xECD328F2, "brainwash_weights_negative" },
    { 0x84A7775D, "brainwash_wires" },
    { 0x12C45D1D, "brainwashed" },
    { 0x578EEFE6, "brainwashing" },
    { 0xEF254D36, "brake" },
    { 0xB9CE6AA8, "brake_frames_max" },
    { 0x14744936, "brake_frames_min" },
    { 0x54DF73C2, "brake_hint" },
    { 0xC5CCCB67, "brake_loop" },
    { 0x027ED4A1, "brake_on_death" },
    { 0x2D831A5E, "brake_quick" },
    { 0xD4FCC1B8, "brake_van" },
    { 0x9DA8BF4D, "brakelights" },
    { 0xE7DDB829, "brakes" },
    { 0x7F74FF2F, "braking" },
    { 0x74CBF04D, "branch" },
    { 0x4CD77C5B, "branching" },
    { 0x12438C02, "branching_scene_debug" },
    { 0x84E3A1BA, "brandomrotation" },
    { 0xD4E40823, "brandon" },
    { 0x147931B9, "brappelling" },
    { 0x75E992E8, "brar" },
    { 0xF4A71538, "brass" },
    { 0x4FF65409, "brave" },
    { 0xD435F8D4, "bravely" },
    { 0x164283FA, "bravery" },
    { 0x25A3AE94, "bravest" },
    { 0xCC0F1C23, "bravo" },
    { 0x5E1F1702, "brawler_achievement_unlocked" },
    { 0x5AC7FCDA, "brawler_endgame_1" },
    { 0x34C58271, "brawler_endgame_2" },
    { 0x0EC30808, "brawler_endgame_3" },
    { 0xB0DB5870, "brawler_endgame_array" },
    { 0xFCC42EE7, "brawler_lobby" },
    { 0xB087A545, "breaach" },
    { 0xDC264AE2, "breach" },
    { 0x8E4EC392, "breach1_bmodel_door" },
    { 0x7684B9C6, "breach1_door" },
    { 0x7098BCA5, "breach_abort" },
    { 0x4716A892, "breach_aborted" },
    { 0x2EE84E83, "breach_ai_reset" },
    { 0xCDC842C3, "breach_alley_gate_vignette" },
    { 0xC094F3E6, "breach_anim" },
    { 0xE57EF848, "breach_anim_guard_at_wnd" },
    { 0x03D8C46D, "breach_anim_spot" },
    { 0xE8654CB8, "breach_anim_start_point" },
    { 0xE1D440FC, "breach_anim_started" },
    { 0x58B937B9, "breach_anim_weaver" },
    { 0x6977AA56, "breach_anim_weaver_res" },
    { 0x3DBA44D4, "breach_begin" },
    { 0x0FA3B942, "breach_bg_ent" },
    { 0x626D7337, "breach_cleanup" },
    { 0x8F618F0A, "breach_compartment_open" },
    { 0xBAB0A0F1, "breach_compartment_setup" },
    { 0x59B876E8, "breach_complete" },
    { 0xCE02F025, "breach_dialog" },
    { 0x4631CC0F, "breach_dont_fire" },
    { 0xB5E57111, "breach_door" },
    { 0xC8F71637, "breach_door_opened" },
    { 0xBC7E6F9B, "breach_enemies_stunned" },
    { 0x969FAD1E, "breach_enemy_trigger" },
    { 0xA26E63AA, "breach_fire_straight" },
    { 0xF1A9CC98, "breach_first_building" },
    { 0x79D8C2B0, "breach_gravity_shift" },
    { 0x52BF3782, "breach_guy_1" },
    { 0x2CBCBD19, "breach_guy_2" },
    { 0xFB29E3C5, "breach_guys" },
    { 0x50ED73A3, "breach_guys_leadin" },
    { 0x14C4219E, "breach_kill_ai" },
    { 0x49D4C789, "breach_kill_ai_logic" },
    { 0x4D92F4D4, "breach_labs_lower_fx" },
    { 0xA9BF6D81, "breach_labs_upper_fx" },
    { 0xAFF03013, "breach_leaks" },
    { 0x5ECA32EF, "breach_light" },
    { 0x7A8FA728, "breach_link_and_hide_player_weapons" },
    { 0x409DD9D3, "breach_models" },
    { 0x83DE63A6, "breach_org1" },
    { 0x5DDBE93D, "breach_org2" },
    { 0x6D215940, "breach_physics" },
    { 0xA7142E6C, "breach_play_fx" },
    { 0x87EA71CC, "breach_player_look" },
    { 0xA2A2A8B3, "breach_positions" },
    { 0x6E93B1A3, "breach_power_building" },
    { 0xF5F7E352, "breach_power_building_door" },
    { 0x8E2DE816, "breach_ready" },
    { 0x885EA84E, "breach_receiving_fx" },
    { 0xBE941BBF, "breach_reset_animname" },
    { 0x9E9920A0, "breach_reset_goaladius" },
    { 0xB59D2BFE, "breach_rumble" },
    { 0xABDD6D26, "breach_seat" },
    { 0x3A3A2CD0, "breach_set_animname" },
    { 0x80B6E851, "breach_set_goaladius" },
    { 0xDFC540A3, "breach_sh_door" },
    { 0xA9B4331A, "breach_slowmo" },
    { 0x493FC3BF, "breach_sound_go" },
    { 0xC0200085, "breach_sound_stop" },
    { 0x07F111E7, "breach_think" },
    { 0x13B80CB0, "breach_timer" },
    { 0xDFEF25CF, "breach_trigger" },
    { 0x1F17C6FA, "breach_trigger_cleanup" },
    { 0x3D199DF6, "breach_trigger_think" },
    { 0x597495C8, "breach_vo" },
    { 0x3AB812D9, "breach_window_break" },
    { 0xA8427A12, "breach_window_models" },
    { 0xFD9A2B0E, "breachable" },
    { 0x4FFE9B3D, "breachanim" },
    { 0xB4D04DD0, "breachdonotfire" },
    { 0xEB5883F5, "breached" },
    { 0xB8E5B06E, "breached_flag" },
    { 0x084CAF45, "breachedlastnode" },
    { 0x865C8DB1, "breachednexttolastnode" },
    { 0xFF7B35B3, "breacher" },
    { 0x5BCB67D0, "breacher1" },
    { 0xCDD2D70B, "breacher2" },
    { 0xA7D05CA2, "breacher3" },
    { 0x19D7CBDD, "breacher4" },
    { 0x6B0CD539, "breacher_inside_node" },
    { 0x2F25ADEE, "breacher_spawner" },
    { 0xC5A1ACB2, "breacher_think" },
    { 0x2731C262, "breachers" },
    { 0x549EAB58, "breachers_movement_control" },
    { 0x90C442AF, "breachersready" },
    { 0xD978BB4A, "breaches" },
    { 0xF99830CE, "breaching" },
    { 0x802F3DBA, "breachtrigger" },
    { 0x8CBF9E81, "bread" },
    { 0x8708CD84, "bread_crumbs" },
    { 0xCA6E28CC, "breadcrum" },
    { 0x045D1556, "breadcrumb" },
    { 0xC0AAE05D, "breadcrumb_and_flag" },
    { 0xBED5005C, "breadcrumb_array" },
    { 0xC11F5802, "breadcrumb_clean_room" },
    { 0x4CF73DD2, "breadcrumb_curr_index_array" },
    { 0xB99A7B27, "breadcrumb_delta_array" },
    { 0xE4907E6E, "breadcrumb_ent_array" },
    { 0xEA6608B4, "breadcrumb_escape_1" },
    { 0x70C52845, "breadcrumb_hide" },
    { 0x0565BC56, "breadcrumb_markers" },
    { 0x430F2EC3, "breadcrumb_nova6_1" },
    { 0xD107BF88, "breadcrumb_nova6_2" },
    { 0xF70A39F1, "breadcrumb_nova6_3" },
    { 0xDAA5EB27, "breadcrumb_point_clear" },
    { 0x38DC2C20, "breadcrumb_point_thread" },
    { 0x758DB14B, "breadcrumb_table" },
    { 0x7EB6DF20, "breadcrumbdata_interval_seconds" },
    { 0xEF4C5CC9, "breadcrumbs" },
    { 0x4240C48A, "breadof" },
    { 0x1AB82F46, "break" },
    { 0xE03255C5, "break_angles" },
    { 0x554D66BD, "break_attack" },
    { 0x10438551, "break_breach_window" },
    { 0x76403B84, "break_down_door" },
    { 0xFA19E3F9, "break_fence1" },
    { 0x201C5E62, "break_fence2" },
    { 0x2EBDCC45, "break_for_apartment" },
    { 0x20D93043, "break_fx" },
    { 0xEF82ABCF, "break_glass" },
    { 0xBD396747, "break_glass_interrogation" },
    { 0xD97AC5D1, "break_glass_struct" },
    { 0xA3A9A53E, "break_hold_time" },
    { 0x0EDBB126, "break_notify" },
    { 0x358655FB, "break_out" },
    { 0xC3397A6E, "break_pipe_walker_stealth" },
    { 0x7881B728, "break_rappel_glass" },
    { 0x76EDA309, "break_sensitive_windows" },
    { 0xB282625A, "break_sound" },
    { 0xFD412072, "break_stealth" },
    { 0x84CE656D, "break_stealth_but_player_canwin" },
    { 0x1475358E, "break_stealth_by_damage" },
    { 0x2064DF3F, "break_stealth_by_trigger" },
    { 0x82A56004, "break_timer" },
    { 0x6D7C5C5C, "break_vector" },
    { 0x7E202819, "break_wall" },
    { 0xAB4795A2, "break_window_after_delay" },
    { 0x5A8809D3, "break_zipline_window" },
    { 0x1F506982, "breakable" },
    { 0x248DCB17, "breakable_clip" },
    { 0x4CC2659D, "breakable_logic" },
    { 0xFCD7A9C7, "breakable_think" },
    { 0x96B0429D, "breakable_think_triggered" },
    { 0x552FB8EE, "breakable_wall_damage_watcher" },
    { 0x07BB43CD, "breakables" },
    { 0x7917C292, "breakables_clip" },
    { 0xC655FF3A, "breakables_fx" },
    { 0xC1AEAB05, "breakables_peicescollide" },
    { 0x4FFE3888, "breakafter" },
    { 0x41BC3208, "breakaway" },
    { 0xFD3E244E, "breakdown" },
    { 0x0FB786CF, "breaker" },
    { 0xF6BDD2CA, "breakers_sound" },
    { 0x7394B318, "breakfast" },
    { 0x6647CF0C, "breakfunc" },
    { 0x81B40FF2, "breakglass" },
    { 0x720B35D7, "breakin" },
    { 0x29381B2C, "breakin_fuse_picked_up" },
    { 0x54FC00F1, "breakin_wait_fuse_anim_finish" },
    { 0x8A366F62, "breakin_wait_fuse_pickup" },
    { 0xACED9F5A, "breaking" },
    { 0x39CBCB58, "breakingents" },
    { 0xDFE2F350, "breakingpoint" },
    { 0x1BA3F247, "breakingpoint_" },
    { 0x95CAC72D, "breakit" },
    { 0xFA7A1CBE, "breakladder" },
    { 0x84DC25C0, "breakloop" },
    { 0x9CB421B8, "breakme" },
    { 0xD84D13A1, "breakoff_distance" },
    { 0x3C3986AB, "breakoff_notify" },
    { 0x3433F3A2, "breakout" },
    { 0x20E9A142, "breakoutofshootingifwanttomoveup" },
    { 0x8DCFC37C, "breakpoint" },
    { 0x3702B4F2, "breakrope" },
    { 0x4F29AFF9, "breaks" },
    { 0x1BF18C61, "breaks_stealth" },
    { 0x712FDF4D, "breakup" },
    { 0xB33995BB, "breath" },
    { 0xE7AB2445, "breath_direction" },
    { 0x725CC504, "breath_fx" },
    { 0xD252754D, "breath_id" },
    { 0x588824B4, "breath_interator" },
    { 0xAD4D1D89, "breath_strength" },
    { 0x10FD71BC, "breathe" },
    { 0xA6880C16, "breather" },
    { 0x97906265, "breather_pause" },
    { 0xD5FD97A5, "breathing" },
    { 0x3A7E30C8, "breathing_done" },
    { 0xA5C52C56, "breathing_wait_counter" },
    { 0x8C9C2BB0, "breathing_waittime" },
    { 0xDE6100BE, "breathingbettervox" },
    { 0x6753B08C, "breathingent" },
    { 0xDC8BDE35, "breathinghurtvox" },
    { 0xD866D5CA, "breathingstoptime" },
    { 0x64D0D65A, "breaths" },
    { 0x57AE8F17, "brech" },
    { 0x08E1E9EE, "breech" },
    { 0xBFFB701D, "breed" },
    { 0xE18EF8FB, "breif" },
    { 0x1D35E93B, "breige" },
    { 0xCFDA7F81, "breighner" },
    { 0x6D7696F4, "brent" },
    { 0xFD6306C9, "breths" },
    { 0x5976CC7E, "breveal" },
    { 0xB29BDE3C, "brevity" },
    { 0xA5588BCF, "brian" },
    { 0xA519BE8F, "brianb" },
    { 0xAFC0AF58, "brick" },
    { 0x4ACD75A1, "brick1" },
    { 0x70CFF00A, "brick2" },
    { 0x96D26A73, "brick3" },
    { 0xBCD4E4DC, "brick4" },
    { 0xE2D75F45, "brick5" },
    { 0x08D9D9AE, "brick6" },
    { 0x2EDC5417, "brick7" },
    { 0xF4B727F0, "brick8" },
    { 0x1633D033, "bricks" },
    { 0x6AE0CA0F, "bride" },
    { 0xEB75D1CB, "bridege" },
    { 0xD216639A, "bridge" },
    { 0xF5120E33, "bridge01" },
    { 0xD1E4C786, "bridge01_start" },
    { 0x830A9EF8, "bridge02" },
    { 0xDC26F41D, "bridge02_start" },
    { 0x58CA5227, "bridge1" },
    { 0xFEC3E045, "bridge2_diffused" },
    { 0xA90CA586, "bridge3_active_truck" },
    { 0x7750BA5B, "bridge3_after_disarm" },
    { 0xA82790FC, "bridge3_cap_awake" },
    { 0x0A0F2582, "bridge3_commander_anim" },
    { 0x42B2AFA5, "bridge3_disarmed" },
    { 0xAEDAF488, "bridge3_engineer_arm" },
    { 0x0E99FED2, "bridge3_engineers_anim" },
    { 0x89A744DE, "bridge3_engineers_awake" },
    { 0xD0E262F4, "bridge3_fight_begin" },
    { 0xBD46CB46, "bridge3_infantry_cleared" },
    { 0x48F4AA91, "bridge3_objective" },
    { 0x91A6E60F, "bridge3_reinforcement_truck" },
    { 0x1F7541DC, "bridge3_reinforcement_truck_passively" },
    { 0x4B6C5AEA, "bridge4_objective" },
    { 0x51E6C6AC, "bridge_ai_death" },
    { 0x01F572A8, "bridge_area_name" },
    { 0x1EA5F04D, "bridge_audio" },
    { 0x98D0489A, "bridge_axis" },
    { 0xF40C9155, "bridge_blockade_cleared" },
    { 0x50F7A838, "bridge_blow_trigger" },
    { 0x71E52E90, "bridge_blower" },
    { 0xB7D7A630, "bridge_break_windows" },
    { 0xD12A5C55, "bridge_bump" },
    { 0x1389BBC4, "bridge_bumper" },
    { 0xA322F0FC, "bridge_catwalk_jetpack_ai" },
    { 0x9C17457B, "bridge_catwalk_jetpack_drones" },
    { 0x1CE96409, "bridge_chair_pulses" },
    { 0xF0CACE0F, "bridge_clip" },
    { 0x848DDB19, "bridge_combat" },
    { 0x369BE535, "bridge_combat_griggs" },
    { 0xD84A3E8B, "bridge_combat_player" },
    { 0x8F702873, "bridge_combat_price" },
    { 0x266E1445, "bridge_connect" },
    { 0x7F93C9AD, "bridge_crossing" },
    { 0xA31CA7AB, "bridge_damage_trigger" },
    { 0xCEF5D831, "bridge_death_launch" },
    { 0x94A31389, "bridge_defence_bounds" },
    { 0x81865310, "bridge_destroyed_by_helicopters_drones_start" },
    { 0x3636EE22, "bridge_destruction_kill" },
    { 0x080C25D9, "bridge_destruction_physics" },
    { 0xF5C8F186, "bridge_destruction_trigger" },
    { 0x18768E9B, "bridge_disconnect" },
    { 0x9EFAC1BB, "bridge_drone_spawning" },
    { 0xABCBA599, "bridge_drones_start" },
    { 0xAE8A541A, "bridge_east" },
    { 0x9EF67E20, "bridge_empty" },
    { 0xA60538DB, "bridge_enemy" },
    { 0x9A4C3A72, "bridge_entered" },
    { 0x638E41A0, "bridge_explode_onstart" },
    { 0x808523E9, "bridge_explode_start" },
    { 0x6B5D26E6, "bridge_extend_radius" },
    { 0x343F403D, "bridge_fake_collision_box" },
    { 0xD379AE4E, "bridge_fall" },
    { 0x3FFF39DF, "bridge_fog" },
    { 0x1EC5A3B3, "bridge_friendly_spawns" },
    { 0xE0AA7BA6, "bridge_go_trigger" },
    { 0x86F94B79, "bridge_groan_sound_loop" },
    { 0x45B43C6B, "bridge_guards" },
    { 0xDB062C2D, "bridge_guys" },
    { 0xBBC16DDF, "bridge_health" },
    { 0x04370955, "bridge_heli_1" },
    { 0x2A3983BE, "bridge_heli_2" },
    { 0x503BFE27, "bridge_heli_3" },
    { 0xFE89E175, "bridge_heroes" },
    { 0xF307E63F, "bridge_hint_dialogue" },
    { 0x7B7E6B97, "bridge_hopper" },
    { 0xCAE23517, "bridge_init" },
    { 0x1E08880D, "bridge_intro" },
    { 0xBD32418E, "bridge_intro_thunder" },
    { 0xFB13D461, "bridge_jumpto_done" },
    { 0x2FEAC2C9, "bridge_kill" },
    { 0x6F6DF126, "bridge_launcher_logic" },
    { 0xEB5CB54C, "bridge_location" },
    { 0x5D4B3901, "bridge_long_01_cacheside" },
    { 0x9828C914, "bridge_long_01_towerside" },
    { 0x6DF526E2, "bridge_long_02_cacheside" },
    { 0x13B8328B, "bridge_long_02_towerside" },
    { 0xB2AE9D46, "bridge_main" },
    { 0x7F0B2D8A, "bridge_minigun_notify" },
    { 0xD4D5A9AE, "bridge_over_uaz" },
    { 0xF10FE605, "bridge_parts" },
    { 0x5A113ACA, "bridge_react" },
    { 0x17AF6010, "bridge_repel_guy_spawner" },
    { 0x635F9C18, "bridge_repel_guys" },
    { 0xD03D945A, "bridge_rescue" },
    { 0xF1D09993, "bridge_rescue_start" },
    { 0x5866595F, "bridge_rocket_notify" },
    { 0x1FC481A0, "bridge_rotate" },
    { 0x2D8AC1CA, "bridge_save" },
    { 0x2596F11F, "bridge_save_check" },
    { 0xD2BE0C96, "bridge_secured" },
    { 0x5CC8ACFC, "bridge_send_rushers" },
    { 0x96461D46, "bridge_sequence" },
    { 0x6680087C, "bridge_setup" },
    { 0xD482C3E4, "bridge_setupguys" },
    { 0x202C1383, "bridge_short_01_cacheside" },
    { 0xAFDC88EA, "bridge_short_01_towerside" },
    { 0x6AE58498, "bridge_short_02_cacheside" },
    { 0xFAC86945, "bridge_short_02_towerside" },
    { 0xD627A553, "bridge_sniper_logic" },
    { 0x9B8DBCE2, "bridge_spawners" },
    { 0x527B0CE6, "bridge_standoff" },
    { 0x8A6741E3, "bridge_standoff_behavior" },
    { 0x6A1CA6C3, "bridge_standoff_behavior_earlydeath" },
    { 0x67E9BD08, "bridge_standoff_chair" },
    { 0xEA475E12, "bridge_standoff_damage" },
    { 0x55DA41A6, "bridge_standoff_mug" },
    { 0x1E66D8D3, "bridge_start" },
    { 0x7F5B02CB, "bridge_startspot" },
    { 0x47D8B434, "bridge_transition" },
    { 0xC2EDC827, "bridge_trigger" },
    { 0x0A1AD09E, "bridge_triggers" },
    { 0xC37623EA, "bridge_trigs" },
    { 0x83EBC9AD, "bridge_trucks" },
    { 0xE6EE87E7, "bridge_turret" },
    { 0xA9B5D863, "bridge_turret_bloodbath_setup" },
    { 0x197B63BC, "bridge_turret_death" },
    { 0x9FB3F6E0, "bridge_turret_fate" },
    { 0x8F62F91B, "bridge_turret_goal" },
    { 0xE6F44129, "bridge_turret_initial_fire" },
    { 0x1DEC5481, "bridge_turret_reveal" },
    { 0x405E20A6, "bridge_turret_spawns" },
    { 0x0709710F, "bridge_uaz_crash" },
    { 0x81BA63AB, "bridge_vehiclde_drone_unloader" },
    { 0x6A9D1857, "bridge_volume" },
    { 0x298A8BCF, "bridge_volume_name" },
    { 0x8A0F1E7C, "bridge_walla_on_off" },
    { 0xC99AF38F, "bridge_warning" },
    { 0x6B7D2956, "bridge_wave_spawner_think" },
    { 0xA17A9936, "bridge_wave_spawners" },
    { 0xB074B73C, "bridge_west" },
    { 0xD5F2CE5D, "bridge_zak" },
    { 0x4492EA5B, "bridge_zak_friendly_attack_heli" },
    { 0x57BCAB65, "bridge_zak_guys_dead" },
    { 0x57AB991A, "bridge_zak_slomo_script_timed" },
    { 0xE90A4851, "bridge_zak_slomo_script_timed_chaplincheat" },
    { 0x668D7AC5, "bridge_zakhaev" },
    { 0xBB32B16F, "bridge_zakhaev_setup" },
    { 0x18B69AC6, "bridge_zakhaev_shock" },
    { 0x67270341, "bridgeblockercomeback" },
    { 0xEDC3DFEC, "bridgeblockergoaway" },
    { 0x407B6098, "bridgeblown" },
    { 0x9FFF3FAB, "bridgebumper" },
    { 0x4E4A2E70, "bridgefx" },
    { 0xAF835CE1, "bridgeriser" },
    { 0xD237D247, "bridgerisersw" },
    { 0xC8906017, "bridgeriserthink" },
    { 0x8D63F795, "bridges" },
    { 0x647AD579, "bridgestate" },
    { 0x451D3A1D, "bridgetriggers" },
    { 0x72D65AC0, "bridgevolume" },
    { 0x1F178A3B, "brief" },
    { 0xCDC067E9, "brief_pacifist" },
    { 0x6FC0A627, "briefcase" },
    { 0x19863D2E, "briefcase_bomb" },
    { 0x102F1CB0, "briefed" },
    { 0x4CF9B925, "briefing" },
    { 0x0BC5FEC9, "briefing_ending" },
    { 0xA69EAFF2, "briefing_fade_up" },
    { 0x87506748, "briefing_fadeintime" },
    { 0xFABAEB39, "briefing_fadeouttime" },
    { 0xDB97DB15, "briefing_running" },
    { 0xC6F9A83A, "briefing_scene_name" },
    { 0x2AE1A2AE, "briefing_stat" },
    { 0x07C5A79C, "briefingend" },
    { 0xFF50C534, "briefings" },
    { 0xDE7E9D44, "briefingskip" },
    { 0x38BD3218, "briefinvulnerability" },
    { 0xF9FB7826, "briefly" },
    { 0x78937CD0, "brieftime" },
    { 0xD8AB3EF3, "briggs" },
    { 0xD2E00F1D, "briggs_alive_or_not" },
    { 0x8C30FA1D, "briggs_arrival_vo" },
    { 0xE706BAB7, "briggs_delete_watch" },
    { 0x53CB1FE1, "briggs_ending_dof" },
    { 0xBD3835CB, "briggs_height_nudge" },
    { 0x38DB5087, "briggs_is_playing_anim" },
    { 0xDAFC9649, "briggs_loop_aftermath" },
    { 0x02036A37, "briggs_nudge_speed" },
    { 0xDE54577E, "briggs_outro_scene" },
    { 0x2BECCDA9, "briggs_pip_playbackrate" },
    { 0xBFD7A41D, "briggs_rot_speed" },
    { 0x4373832E, "briggs_spawner" },
    { 0x056C9EE7, "briggs_wound" },
    { 0x9977279B, "briggs_wound_callback" },
    { 0x246D9ED0, "briggs_wound_talk" },
    { 0xA4EE52FF, "briggs_wound_watch" },
    { 0x3BCC2137, "briggs_yaw" },
    { 0x4D8816E9, "bright" },
    { 0xBB8F8ABB, "bright_per_frame" },
    { 0x7A8F408C, "brighten" },
    { 0x12992A30, "brighter" },
    { 0x030EB7BC, "brightness" },
    { 0x91BEF1B7, "brightness_decrease" },
    { 0x9B1084F5, "brightness_set" },
    { 0xC64ACC6E, "brilliant" },
    { 0x1900CB47, "brim" },
    { 0x8F47564F, "brim_ally_initial_spawners" },
    { 0x1B51CFB3, "brim_ally_initial_wait" },
    { 0x33A966F2, "brim_start" },
    { 0x9921D1D0, "brim_start_array" },
    { 0x003A1F5B, "bring" },
    { 0xBEA88283, "bring_back_dead_teammate" },
    { 0x8585EF2C, "bring_back_teammate_progress" },
    { 0x9572301B, "bring_bridge_brutuses_back" },
    { 0x6467F8C7, "bring_in_brainwash_fov" },
    { 0x63772FA2, "bring_in_heli_spawners" },
    { 0x345B1F98, "bring_out_knife" },
    { 0x222A8A15, "bring_out_mason" },
    { 0x8181F634, "bring_out_the_hounds" },
    { 0x69069F0A, "bring_perk" },
    { 0x8D6C1DA2, "bring_perk_landing_damage" },
    { 0x92C7B16E, "bring_random_perk" },
    { 0x707BFAC5, "bringing" },
    { 0xBD48177A, "brings" },
    { 0xC857DC47, "brink" },
    { 0x7BBDD594, "brinkofdeathkillstreak" },
    { 0x1454A5C6, "briquette" },
    { 0x5A89333F, "brite" },
    { 0x513C7BD4, "britfilter" },
    { 0x303C69FE, "british" },
    { 0x48986A97, "british_names" },
    { 0x856DBF1D, "british_soldiertype" },
    { 0x0430F4B2, "britishhigh_spawnfunction" },
    { 0xD6A1FB59, "brits" },
    { 0x40B1A9D9, "brn" },
    { 0x1AAF2F70, "bro" },
    { 0x35C76B4A, "broadcast" },
    { 0x644E0C12, "broadcast_center" },
    { 0x4673B0DB, "broadcast_destruction" },
    { 0x71B8E43D, "broadcast_dialog" },
    { 0x6627CA30, "broadcast_pipe01_a" },
    { 0xD82F396B, "broadcast_pipe01_b" },
    { 0x87E6244F, "broadcast_pipe02_a" },
    { 0x15DEB514, "broadcast_pipe02_b" },
    { 0x82E1A903, "broadcast_vo_category_to_team" },
    { 0x17911D1D, "broadcast_wires" },
    { 0x163818D4, "broadcastcenter_door" },
    { 0x2BD19FA6, "broadcasting" },
    { 0x6CC3C485, "broadcasts" },
    { 0x82D2DF72, "brock" },
    { 0x7582A7A4, "broke" },
    { 0xD96007E8, "broke_stealth" },
    { 0xA4B54E07, "broke_through_macv_window" },
    { 0x6445D1F2, "broken" },
    { 0xCD5BE9DD, "broken_building" },
    { 0xD084178E, "broken_glass_brushes" },
    { 0xF4F8A1AD, "broken_ledge_fx" },
    { 0xE76C0D22, "broken_notify" },
    { 0xBD98D5DA, "broken_radio" },
    { 0x088C948D, "broken_wall" },
    { 0x1B1C8329, "brokennotify" },
    { 0xFE54B9A8, "brokenpiece" },
    { 0x19DAB429, "brooks" },
    { 0x499F0DD9, "brooks_breachroom_after" },
    { 0xE8AD9E4A, "brooks_cliff_internal" },
    { 0xA7FD368F, "brooks_door_open" },
    { 0xCABB6FEB, "brooks_ent" },
    { 0xDF90F31A, "brooks_free_fall" },
    { 0x0FCF093C, "brooks_garage_meetup" },
    { 0xAC179145, "brooks_guardloop" },
    { 0xD22219CA, "brooks_in_tunnel_start_node" },
    { 0xD2A04F8B, "brooks_landing_struct" },
    { 0xCB503A40, "brooks_node" },
    { 0x8AA74DAE, "brooks_org" },
    { 0x5F5726E5, "brooks_outsidetunnels_node" },
    { 0xEF557B35, "brooks_position" },
    { 0xC8E0CA1F, "brooks_post_jeepmeetup" },
    { 0xC7103096, "brooks_prone" },
    { 0xDCF837EE, "brooks_provides_cover" },
    { 0x769B88CD, "brooks_teleport" },
    { 0xBBD05EB4, "brooks_truck_node" },
    { 0x94175769, "brooks_walk_compound" },
    { 0x9696D161, "brother" },
    { 0x5E8BD308, "brothers" },
    { 0x57965074, "brought" },
    { 0xFD841503, "brown" },
    { 0xE20659D3, "broznov" },
    { 0x769F63AE, "brunker" },
    { 0xF1E88F57, "brush" },
    { 0x2DAE939C, "brush_avalanche_path_start" },
    { 0x67CFFE50, "brush_avalanche_vehicle" },
    { 0x94ACBBA9, "brush_block" },
    { 0xE1209018, "brush_block_ladder" },
    { 0x0E87CBF0, "brush_blocker" },
    { 0x4271893D, "brush_building_flank" },
    { 0xADD8D7F2, "brush_building_flank_2" },
    { 0xE3A37743, "brush_delete" },
    { 0xB90DA87D, "brush_fire_pos" },
    { 0xAA1AE47A, "brush_guide" },
    { 0xC70730CF, "brush_name" },
    { 0xB898D3AB, "brush_pap_pathing_ramp_l" },
    { 0xD489F535, "brush_pap_pathing_ramp_r" },
    { 0xEF26C264, "brush_pap_side_l" },
    { 0x335D476A, "brush_pap_side_r" },
    { 0x24D33392, "brush_pap_traversal" },
    { 0x10208521, "brush_show" },
    { 0xE0387702, "brush_throw" },
    { 0x41C4E98D, "brushdoortargetname" },
    { 0x0945A523, "brushes" },
    { 0x2CA40809, "brushing" },
    { 0x5065FF66, "brushmodel" },
    { 0xECB642CD, "brushmodel_door" },
    { 0x7066EC99, "brushmodels" },
    { 0x59E0FDCF, "brutality" },
    { 0x15BAF882, "brutality_civ_ai_damage_override" },
    { 0x26994C5A, "brutality_done_by_pdf_death" },
    { 0xC543873E, "brutality_pdf_final_goal_pos" },
    { 0x33D018DA, "brutality_scene" },
    { 0xA37F16D5, "brutality_scenes" },
    { 0x74F49436, "brutalization_scene" },
    { 0x94566773, "brute" },
    { 0x6A98A1B3, "brute_force" },
    { 0x91D1B618, "brute_force_ai_take_position" },
    { 0xAED27087, "brute_force_arrive" },
    { 0x992B4DF2, "brute_force_bypass" },
    { 0x1AB50527, "brute_force_bypass_cleanup" },
    { 0x8C522062, "brute_force_bypass_has_perk" },
    { 0xAA4E0109, "brute_force_bypass_salazar_started" },
    { 0x609F2FDA, "brute_force_bypass_scenes" },
    { 0xAF560B05, "brute_force_bypassed" },
    { 0xE9C7783E, "brute_force_dialog" },
    { 0x23E72066, "brute_force_done" },
    { 0x9F20A456, "brute_force_exit" },
    { 0xCBB93BEE, "brute_force_fail" },
    { 0x84BCD63F, "brute_force_finish" },
    { 0x1B054464, "brute_force_idle" },
    { 0xA08A5960, "brute_force_kill_jetpacks" },
    { 0x38F493A5, "brute_force_obj" },
    { 0x1E0FD5D2, "brute_force_perk" },
    { 0x2F2E0A05, "brute_force_rumble" },
    { 0xC823B2F5, "brute_force_setup" },
    { 0xE365E3F2, "brute_force_unlock" },
    { 0x96CCB805, "brute_force_unlock_done" },
    { 0xE96EB424, "brute_force_unlock_player_started" },
    { 0x7F92E9C7, "brute_force_use" },
    { 0xC21BDD4A, "brute_kill" },
    { 0xA69A6540, "bruteforce" },
    { 0xA7CDB34B, "bruteforce_mortar_pickup" },
    { 0xEA0C8B0F, "bruteforce_perk" },
    { 0x0DA56E14, "bruteforce_perk_anims" },
    { 0x414BB0AE, "bruteforce_perk_asd" },
    { 0xCCD05019, "bruteforce_rumble_light" },
    { 0xAA6A2ED7, "bruteforce_rumble_med" },
    { 0x8D8691D2, "brutus" },
    { 0x016DCD07, "brutus_afterlife_teleport" },
    { 0xBF337C8B, "brutus_aggro_dist_sq" },
    { 0x6798867B, "brutus_aggro_earlyout" },
    { 0x80D48B43, "brutus_alarm_chance" },
    { 0x220AA1A9, "brutus_alarm_chance_increment" },
    { 0x296A09F0, "brutus_array" },
    { 0x339D0FF8, "brutus_blocker_pieces_req" },
    { 0xF2AC6D28, "brutus_check_zone" },
    { 0x3CDF2F01, "brutus_chest_flashlight" },
    { 0x1388DD47, "brutus_cleanup" },
    { 0x392B22DC, "brutus_cleanup_at_end_of_grief_round" },
    { 0x8DE515BE, "brutus_count" },
    { 0xA2884B8C, "brutus_custom_goalradius" },
    { 0x03CDDB1D, "brutus_damage_override" },
    { 0x588FB5FC, "brutus_damage_percent" },
    { 0xB2D6291D, "brutus_death" },
    { 0xDDD91DD6, "brutus_debug" },
    { 0x0C2058F5, "brutus_despawn_manager" },
    { 0x04C95556, "brutus_despawn_manager_custom_func" },
    { 0xA7E320B2, "brutus_do_prologue" },
    { 0x5C62706E, "brutus_expl_dmg_req" },
    { 0x6034C65A, "brutus_explosive_damage_for_helmet_pop" },
    { 0xFB72EB39, "brutus_explosive_damage_increase" },
    { 0x94F7F085, "brutus_failed_paths_to_teleport" },
    { 0xF01CD177, "brutus_find_flesh" },
    { 0x6F033AFC, "brutus_fire_teargas_when_possible" },
    { 0x4B4E8630, "brutus_get_closest_valid_player" },
    { 0x37B87E31, "brutus_goal_watcher" },
    { 0x093E4807, "brutus_health" },
    { 0x078A820A, "brutus_health_increase" },
    { 0x641DC945, "brutus_health_increases" },
    { 0x28D2620D, "brutus_helmet_pop_vo_watcher" },
    { 0xF30F7DF3, "brutus_helmet_removed" },
    { 0x226DF3A0, "brutus_helmet_shots" },
    { 0xE20988C8, "brutus_in_grief" },
    { 0x16723201, "brutus_instakill_override" },
    { 0x92A88C4E, "brutus_killed" },
    { 0xBBB4A889, "brutus_killed_vo_watcher" },
    { 0xFED8C1DC, "brutus_last_spawn_round" },
    { 0xE36615C7, "brutus_locations" },
    { 0xC4390185, "brutus_lockdown_client_effects" },
    { 0x6FCA76EA, "brutus_lockdown_state" },
    { 0x609EF317, "brutus_locked_object" },
    { 0x5D9CAA5E, "brutus_max_alarm_chance" },
    { 0xC7DE5EE1, "brutus_max_count" },
    { 0xBD692124, "brutus_max_round_fq" },
    { 0x94E017F1, "brutus_max_spawn_delay" },
    { 0x9CDB8818, "brutus_min_alarm_chance" },
    { 0xBB9BF04C, "brutus_min_pulls_between_box_spawns" },
    { 0xD6FE62BE, "brutus_min_round_fq" },
    { 0x36FCDAA3, "brutus_min_spawn_delay" },
    { 0x1833BDB3, "brutus_non_attacker_damage_override" },
    { 0xFD52DE71, "brutus_nuke_override" },
    { 0x31886AAE, "brutus_on_the_bridge" },
    { 0xC543E1A9, "brutus_on_the_bridge_custom_func" },
    { 0x92A2CA43, "brutus_player_points_for_death" },
    { 0x8914AEC8, "brutus_players_in_zone_spawn_point_cap" },
    { 0x74CC5770, "brutus_points_for_helmet" },
    { 0x186F8191, "brutus_pos" },
    { 0xAF5D5BD1, "brutus_prespawn" },
    { 0xC3F1BD0B, "brutus_reaction_vo_watcher" },
    { 0xC16BFCF7, "brutus_remove_helmet" },
    { 0x405EFE48, "brutus_reset_dist_sq" },
    { 0x1E229D13, "brutus_respawn_after_despawn" },
    { 0xAB029473, "brutus_round_count" },
    { 0x37CB90A5, "brutus_round_spawn_failsafe" },
    { 0xA18A8C24, "brutus_round_spawn_failsafe_respawn" },
    { 0x637883F6, "brutus_round_tracker" },
    { 0x44C77BA0, "brutus_rounds_enabled" },
    { 0xDC1A10C2, "brutus_shotgun_damage_mod" },
    { 0xB454427A, "brutus_spawn" },
    { 0x2BE887AD, "brutus_spawn_in_zone" },
    { 0x1EB7AB6B, "brutus_spawn_positions" },
    { 0xCB22A5CA, "brutus_spawn_prologue" },
    { 0xFFC12950, "brutus_spawn_vo_cooldown" },
    { 0xC740BFB5, "brutus_spawn_vo_watcher" },
    { 0xB7A1CD6C, "brutus_spawn_zone_locked" },
    { 0x7CC2E70D, "brutus_spawned" },
    { 0x29ABC12A, "brutus_spawners" },
    { 0xFD91E1A1, "brutus_spawning_logic" },
    { 0xCDFB4B29, "brutus_start_basic_find_flesh" },
    { 0x861D0223, "brutus_stop_basic_find_flesh" },
    { 0x651676B7, "brutus_stuck_teleport" },
    { 0x681780BE, "brutus_stuck_watcher" },
    { 0xC0C095F5, "brutus_targets" },
    { 0x06AEC1EB, "brutus_team_points_for_death" },
    { 0xC17A15F3, "brutus_teargas_duration" },
    { 0xE63E107D, "brutus_teargas_radius" },
    { 0x3656C00C, "brutus_teleporting" },
    { 0x4BE57E1C, "brutus_temp_despawn" },
    { 0x2BDD3A34, "brutus_valid_targets_arrived" },
    { 0x2D05A267, "brutus_watch_enemy" },
    { 0x5D63913D, "brutus_watch_for_gondola" },
    { 0x3B88EDC5, "brutus_watch_for_gondola_arrive" },
    { 0x59B4FAB1, "brutus_watch_for_new_valid_targets" },
    { 0x4A6306F8, "brutus_watch_for_non_afterlife_players" },
    { 0xFD5AD83E, "brutus_zombie_per_round" },
    { 0x56C3DCC3, "brutus_zone" },
    { 0x35734CFB, "brvolume" },
    { 0x94BFC592, "brvolumenw" },
    { 0x1703B5F1, "brvolumesw" },
    { 0xD4516EF6, "bryce" },
    { 0xF78A1A6C, "bryce_cake_light_update" },
    { 0x82CB3D8A, "bsc_squelched" },
    { 0x293C54F6, "bscriptadded" },
    { 0x7996F3F1, "bscriptgened" },
    { 0x2A2A93CE, "bsgenabled" },
    { 0x44603D79, "bshellshock" },
    { 0x911D5132, "bshield" },
    { 0xF59B4E86, "bshoot" },
    { 0xD8C47D91, "bshowbrakeprompt" },
    { 0x978C1DF3, "bsidedetonation" },
    { 0xDF40EE1C, "bsjsty" },
    { 0x73D265C9, "bsm" },
    { 0xE523D11B, "bsm_default" },
    { 0xA0AB9E2A, "bsm_failure" },
    { 0x2FF8E245, "bsm_invalid" },
    { 0xEC7014A6, "bsm_register_api" },
    { 0x638BC409, "bsm_register_condition" },
    { 0x6C952139, "bsm_running" },
    { 0x3C5B7279, "bsm_state_func_start" },
    { 0x90BC1188, "bsm_state_func_terminate" },
    { 0xC6476EB0, "bsm_state_func_update" },
    { 0x047F113D, "bsm_success" },
    { 0x1F718857, "bsm_unused1" },
    { 0xAD6A191C, "bsm_unused2" },
    { 0xA0C4F315, "bsmlocomotionhasvalidpaininterrupt" },
    { 0x5ABCCE4B, "bsouds" },
    { 0x406EBD4C, "bsoundlooping" },
    { 0x76154EDC, "bsp" },
    { 0x16ED525F, "bspawnhostiles" },
    { 0x990888C0, "bsplash" },
    { 0x95D55579, "bsquad" },
    { 0xDE0B6538, "bst" },
    { 0xDA8FAFAA, "bstalingrad" },
    { 0x6704D27D, "bstop" },
    { 0x57E6515B, "bstopbarrage" },
    { 0xE0644189, "bstopsoundondeath" },
    { 0x75F3CDE4, "bstrafe" },
    { 0x1A180AEA, "bswitchingnodes" },
    { 0x2BE6047B, "bt" },
    { 0x106D32AC, "bt_movement_perp_inverse_trace" },
    { 0x9B332BC5, "bt_movement_perp_trace" },
    { 0x07857A2A, "bt_register_action" },
    { 0x309EB983, "bt_register_action_simple" },
    { 0xF33CE63C, "bt_register_api" },
    { 0x47699C5E, "btargetsused" },
    { 0x150D74BF, "bteamready" },
    { 0xBD213C9D, "btl" },
    { 0x971EC234, "btm" },
    { 0x3BBF9D3E, "btm_rocket_jnt" },
    { 0x0926316F, "btn" },
    { 0x082A00BF, "btndown" },
    { 0x41087483, "btr" },
    { 0x00763F41, "btr1_bp1_logic" },
    { 0xFF04050C, "btr1_destroyed" },
    { 0x0B31FC6E, "btr2_bp1_logic" },
    { 0x0D39AFD7, "btr2_destroyed" },
    { 0x89F9C4E0, "btr60_grenade_gunner" },
    { 0x3ED2B5D2, "btr_attack" },
    { 0x6C46744D, "btr_attack_allied_drones_and_ai" },
    { 0x35F0BF1C, "btr_attack_if_anyone_is_attacked" },
    { 0x2408B8D0, "btr_can_see_player" },
    { 0x7C8C0204, "btr_chase" },
    { 0x3FEFF798, "btr_chase_attack_cache" },
    { 0xDEC0C379, "btr_chase_dead" },
    { 0x1CCC9299, "btr_chase_event" },
    { 0x034565A3, "btr_chase_fail" },
    { 0xCAF2888F, "btr_chase_logic" },
    { 0x6D8158E6, "btr_collided_limo" },
    { 0xF7FABF1B, "btr_collision_think" },
    { 0xB00E1413, "btr_controller_tutorial" },
    { 0x830ABA86, "btr_courtyard_wall" },
    { 0x878935AD, "btr_crash_anim" },
    { 0x97980487, "btr_crash_civs" },
    { 0x43FB3B11, "btr_dialog_done" },
    { 0x6C1D4C88, "btr_direct_fire_at_player" },
    { 0x5B844C1A, "btr_enemies" },
    { 0x274B850C, "btr_entrance_lights" },
    { 0x5B9BC83E, "btr_find_drag_gate" },
    { 0xCEFC7262, "btr_fire_at" },
    { 0xCAF143C1, "btr_force_death_trig" },
    { 0xCE69E18B, "btr_friendlies" },
    { 0xC62A8896, "btr_grenade_hit" },
    { 0x0887F00E, "btr_guys" },
    { 0x58E736D6, "btr_hijack" },
    { 0x3616D3C6, "btr_hits_gate" },
    { 0x2E02ACD0, "btr_open_gate" },
    { 0x2A8A9AE9, "btr_owned" },
    { 0x11E4B7C5, "btr_parking_lot_guys" },
    { 0xB13DD471, "btr_parking_lot_kill" },
    { 0xB71015C4, "btr_player_collision" },
    { 0x40D17CB1, "btr_rail_civ_deaths" },
    { 0xF3A41A33, "btr_rail_civ_vehicles" },
    { 0x875DC028, "btr_rail_civs_a" },
    { 0xF9652F63, "btr_rail_civs_b" },
    { 0x8EFB9D7F, "btr_rail_cleanup" },
    { 0x0190647A, "btr_rail_crash" },
    { 0x1F5D8810, "btr_rail_crash_heli_start" },
    { 0x4FC2BBC2, "btr_rail_destructibles" },
    { 0x8EE37A33, "btr_rail_dialogue" },
    { 0x8181D199, "btr_rail_enemy_veh_spawnfunc" },
    { 0xF57891A5, "btr_rail_enemy_vehicles" },
    { 0xC528895F, "btr_rail_fog" },
    { 0x7B6B5FD4, "btr_rail_friendlies" },
    { 0x0A7AC86A, "btr_rail_friendlies_c" },
    { 0x330C5486, "btr_rail_friendlies_spawnfunc" },
    { 0x92252F41, "btr_rail_friendlies_start" },
    { 0xFB0E52AD, "btr_rail_guys" },
    { 0x21AF3F29, "btr_rail_guys_a" },
    { 0x44031F49, "btr_rail_guys_a2" },
    { 0x47B1B992, "btr_rail_guys_b" },
    { 0x6DB433FB, "btr_rail_guys_c" },
    { 0xAD57399C, "btr_rail_hip_1_crash" },
    { 0xC878EF26, "btr_rail_hip_1_crash_explode" },
    { 0x5924B8E9, "btr_rail_hip_1_crash_impact" },
    { 0x045B784F, "btr_rail_hip_1_crash_rotor_hit" },
    { 0x04D5EEF9, "btr_rail_hip_1_crash_rotor_swap" },
    { 0xAFD8C3D5, "btr_rail_hip_1_think" },
    { 0xF59CEEE3, "btr_rail_hips" },
    { 0xC04F0751, "btr_rail_marine_explode" },
    { 0x3FA90B19, "btr_rail_molotov_player_spawnfunc" },
    { 0x418F30EB, "btr_rail_molotov_thrower_spawnfunc" },
    { 0xDCF0DE28, "btr_rail_molotov_throwers" },
    { 0x744E86A5, "btr_rail_objectives" },
    { 0x924B4913, "btr_rail_parking_lot" },
    { 0x70307872, "btr_rail_push_car" },
    { 0xF25DEE7A, "btr_rail_roof_rpg_moment" },
    { 0xE5634520, "btr_rail_spawnfunc" },
    { 0x206770EA, "btr_rail_start_enemies" },
    { 0xCAF63424, "btr_rail_turn_a" },
    { 0x3CFDA35F, "btr_rail_turn_b" },
    { 0x16FB28F6, "btr_rail_turn_c" },
    { 0x7C0CD269, "btr_rail_turn_c_guys" },
    { 0xB7771A83, "btr_rail_turn_c_guys_spawnfunc" },
    { 0x32EC4A80, "btr_rail_turn_e" },
    { 0x40F1D13D, "btr_riders" },
    { 0x69BA2487, "btr_roof_guy_right" },
    { 0xB6B686D3, "btr_rumble_based_on_speed" },
    { 0xA1F85EE3, "btr_runner_spawnerfunc" },
    { 0x81D944DF, "btr_runners" },
    { 0xB483538F, "btr_runners2" },
    { 0xECB6E787, "btr_scene_spawn_func" },
    { 0xFC8B37D6, "btr_set_target" },
    { 0x428287DE, "btr_slow_down_hit" },
    { 0xE155D8A7, "btr_spawn_timeout" },
    { 0x14873C6B, "btr_starting_enemy" },
    { 0x385FD265, "btr_stopped" },
    { 0x8F882A1D, "btr_struct" },
    { 0x6E7462BC, "btr_timeout_death" },
    { 0xD6217F9D, "btr_trig_start_group" },
    { 0x79A35F81, "btr_triggers" },
    { 0x01B9671A, "btr_turn_e_guys" },
    { 0x6461656C, "btr_turn_e_guys2" },
    { 0xC56DA1F6, "btr_turn_e_kill" },
    { 0xEC7EBCAC, "btr_turret_target" },
    { 0x5B06167E, "btr_wood_fx" },
    { 0xAF1664EA, "btreeorient" },
    { 0x599C0F4C, "btrig1" },
    { 0xCBA37E87, "btrig2" },
    { 0xE8E4C420, "btriggeronce" },
    { 0xE8DAF0F2, "btrs" },
    { 0x1B05FA1A, "bts" },
    { 0x44229E01, "bttp2_dial_handler" },
    { 0xFCE28D04, "btwn" },
    { 0x05E38A12, "bu" },
    { 0x37F62FEF, "bubble" },
    { 0x10D2BE67, "bubble_message" },
    { 0xEDDD08C3, "bubble_vel" },
    { 0xFD698954, "bubblegum" },
    { 0xC7554402, "bubblehud" },
    { 0x46AF953A, "bubblehudbackground" },
    { 0x46418BFF, "bubblehudtext" },
    { 0xB6993CEB, "bubblemax" },
    { 0x8C0731A5, "bubblemin" },
    { 0x8DB79636, "bubbles" },
    { 0x51E35F5F, "bubbles_ents" },
    { 0x619986CC, "bubbles_off" },
    { 0x737E5200, "bubblesort_players" },
    { 0x0B8907EC, "bubblesort_structs" },
    { 0xB6C9736A, "bubbling" },
    { 0xD5492465, "bubbling_amount" },
    { 0x6FD87303, "bubbly" },
    { 0x301920C1, "bubly" },
    { 0xE004DD67, "bucket" },
    { 0xB0972834, "bucket_init" },
    { 0x284C2A92, "bucket_qualifier" },
    { 0xF472180A, "bucket_test" },
    { 0x82106EA8, "buckling" },
    { 0x6C4BA113, "buddies" },
    { 0x970F1567, "buddiesbyid" },
    { 0x5696AA2D, "buddiesinit" },
    { 0x40A30FB7, "buddy" },
    { 0x47D8CBCD, "buddy_down_hatch" },
    { 0xE3D2AA46, "buddy_quads" },
    { 0x8C2DB70A, "buddy_tank" },
    { 0x971F5488, "buddyid" },
    { 0x166B252A, "bueno" },
    { 0xAF558B56, "buff" },
    { 0x97B95436, "buff_cooldown" },
    { 0xB25A3510, "buffalo" },
    { 0x8932CFFA, "buffalo_array" },
    { 0xA0C1AE15, "buffalo_damage_check" },
    { 0x0E4BFB8B, "buffalo_grazing" },
    { 0x68FFFEE3, "buffalo_kill_all" },
    { 0xF9D50F5B, "buffalo_stampede_monitor" },
    { 0x525D395D, "buffaloe" },
    { 0x01D4A819, "buffed" },
    { 0x31E87B61, "buffel" },
    { 0x857E5131, "buffel2" },
    { 0x2E62C1E0, "buffel_fire" },
    { 0xB299623D, "buffel_gunner" },
    { 0xCAEE0828, "buffel_gunner_think" },
    { 0x3CD72FF6, "buffel_helper_explode" },
    { 0x7E1AE6D3, "buffel_mortar" },
    { 0x4C9D2140, "buffel_riders_fight" },
    { 0xD783FEBB, "buffel_tip" },
    { 0xE01A7108, "buffels" },
    { 0x85BBDFFF, "buffer" },
    { 0xD97FA3C5, "buffer_time" },
    { 0xCAFDD806, "buffers" },
    { 0x146E1EC9, "buffs" },
    { 0x58380EE9, "bug" },
    { 0x4A70F4B9, "bug_zapper_dialog" },
    { 0x9319C8B5, "bug_zapper_disabled" },
    { 0x2AF7883C, "bug_zapper_done_dialog" },
    { 0xC615035A, "bugfix" },
    { 0x6FDE5337, "bugged" },
    { 0xC9541F29, "buggin" },
    { 0x987BB490, "bugginess" },
    { 0x7E203AD4, "bugging" },
    { 0x4609FEED, "buggy" },
    { 0x3CF3B9B8, "bugldaboutclipmodels" },
    { 0x609578BA, "buglines" },
    { 0x37FE4A60, "bugs" },
    { 0xCCC18626, "buhbye" },
    { 0xE2C144A1, "buid" },
    { 0xA4997C54, "buidables" },
    { 0xF0468A2E, "buiildable_name" },
    { 0x6A172F6C, "buiildable_struct" },
    { 0xB21F5CE3, "builable_built_custom_func" },
    { 0xF725715F, "build" },
    { 0xDDB12FAF, "build_ai_anims" },
    { 0xEA6A4ED2, "build_aianims" },
    { 0x02590CEB, "build_all_staffs_crafted_vo" },
    { 0x95D664EF, "build_anim_array" },
    { 0xE36B045F, "build_asset_from_struct" },
    { 0x51C2CC01, "build_assets" },
    { 0x4DA9BBA6, "build_attach_models" },
    { 0x12F286F5, "build_bomb_explosions" },
    { 0x38993C79, "build_bombs" },
    { 0x3E2A091F, "build_buildable_action" },
    { 0xCD2F8578, "build_buildable_condition" },
    { 0x02F80D5B, "build_buildable_fx" },
    { 0x4675D37E, "build_buildable_interrupt" },
    { 0x26EFDA7D, "build_bulletshield" },
    { 0x5D33213D, "build_charge_stage" },
    { 0x966B5B74, "build_claimed_list" },
    { 0x1E1FB4F2, "build_classes" },
    { 0x894AD2B4, "build_claw_anims" },
    { 0x54A3E191, "build_clientinit" },
    { 0xF19ACD5D, "build_compassicon" },
    { 0x0F5B68FA, "build_counter" },
    { 0x7013F302, "build_ctt_targets" },
    { 0x41A9BD53, "build_curve" },
    { 0x544EF80C, "build_custom_aircraft" },
    { 0xA7945B76, "build_custom_vehicle" },
    { 0x316A47D1, "build_damage_filter_list" },
    { 0x113A0272, "build_damage_states" },
    { 0x91710A05, "build_death_badplace" },
    { 0xCC2E91DD, "build_death_fx" },
    { 0xA453771E, "build_death_jolt" },
    { 0x11240746, "build_deathfx" },
    { 0xF77B59B5, "build_deathfx_override" },
    { 0x250A52AB, "build_deathmodel" },
    { 0x6CC72E67, "build_deathquake" },
    { 0x2AA87759, "build_deckdust" },
    { 0x9F1C2E7C, "build_destructible" },
    { 0xAC2E7D0E, "build_destructible_deathquake" },
    { 0x9616BBFA, "build_destructible_radiusdamage" },
    { 0xA52F3B66, "build_drive" },
    { 0x5F2CF70E, "build_enemy_vehicles" },
    { 0x194B4413, "build_ent_array" },
    { 0xFBC65588, "build_exhaust" },
    { 0xBC1D5285, "build_exit_stage" },
    { 0x55D1861D, "build_failed" },
    { 0x2F073B42, "build_first_magic_box_seen_vo" },
    { 0x1F560370, "build_fletcher_init" },
    { 0x789332F0, "build_frontarmor" },
    { 0x252C0320, "build_fx" },
    { 0x32EF90C5, "build_game_start_convo" },
    { 0x8DFAD40D, "build_game_start_solo_convo" },
    { 0x2F6608BB, "build_gear" },
    { 0xA445A7F9, "build_globe" },
    { 0xB150573A, "build_horse_anims" },
    { 0xEB976C5C, "build_init" },
    { 0x573D1306, "build_item_list" },
    { 0xEC8FC864, "build_life" },
    { 0xF8BF7F56, "build_light" },
    { 0x896766B9, "build_localinit" },
    { 0x40B52A2B, "build_logic_function_progression" },
    { 0xA38E4323, "build_mainturret" },
    { 0x25B66920, "build_need_part_vo_cooldown" },
    { 0x071DABD0, "build_plane" },
    { 0x48B57781, "build_player_planes" },
    { 0x4E1B8CE7, "build_predeathfx" },
    { 0x2B0F176A, "build_ptboat_gear" },
    { 0x474EA7AD, "build_quake" },
    { 0xD40A3C67, "build_radiusdamage" },
    { 0x7849ECBC, "build_retreat_generics" },
    { 0x05359641, "build_round_one_end_convo" },
    { 0x27890B31, "build_round_one_end_solo_convo" },
    { 0x7B775F1B, "build_round_two_end_solo_convo" },
    { 0xB221D931, "build_rumble" },
    { 0x874C53F0, "build_sam_stage" },
    { 0x2B4BA139, "build_shoot_rumble" },
    { 0x60B9F28C, "build_shoot_shock" },
    { 0x6E759952, "build_shot" },
    { 0xE0495F1F, "build_spiderbot_anims" },
    { 0xAC2DDEC3, "build_stage_logic" },
    { 0x29DC61FE, "build_start_time" },
    { 0x647BF435, "build_starts" },
    { 0x8659BE10, "build_status" },
    { 0x90001C98, "build_struct_targeted_origins" },
    { 0xA73B73E6, "build_stub" },
    { 0x5AA55E16, "build_succeed" },
    { 0xA00A19E8, "build_tank_mantle" },
    { 0x1AABF785, "build_team" },
    { 0xDBE8FE80, "build_template" },
    { 0x782A1540, "build_threatbias_groups" },
    { 0xB189B565, "build_time" },
    { 0x62D21A8D, "build_trap_array" },
    { 0x10ED4D0B, "build_traverse_data" },
    { 0xAAB286F8, "build_treadfx" },
    { 0x78512760, "build_trig" },
    { 0x98C83F61, "build_trigger_from_unitrigger_stub" },
    { 0x008A61F8, "build_turret" },
    { 0x354DC60E, "build_unload_groups" },
    { 0x9426FEF1, "build_vehiclewalk" },
    { 0xC9C9A84B, "build_visible_list" },
    { 0x2978EE2D, "build_weap_beacon_landing_offsets" },
    { 0x8752CC8A, "build_weap_beacon_landing_offsets_ee" },
    { 0x14E104A0, "build_weap_beacon_start_offsets" },
    { 0xA6461985, "build_weap_beacon_start_offsets_ee" },
    { 0xF8D9753A, "build_weapon" },
    { 0x188BC0D0, "build_weapon_options_list" },
    { 0x26CDCD25, "build_weight_array_by_faction" },
    { 0xFFC36EF3, "build_weight_arrays_by_ai_class" },
    { 0x40905161, "build_wrong_part_vo_cooldown" },
    { 0x2E6E1BCF, "buildable" },
    { 0x3568B4BA, "buildable_all_built" },
    { 0x1A357235, "buildable_build_custom_func" },
    { 0x1DC5BA85, "buildable_built_custom_func" },
    { 0x87F9ACC0, "buildable_claimed_locations" },
    { 0xAB311C61, "buildable_clear_piece_building" },
    { 0xFB6143BC, "buildable_clientfields" },
    { 0xE36FCB9F, "buildable_complete" },
    { 0x7AB04263, "buildable_crafted" },
    { 0x0D77A849, "buildable_has_piece" },
    { 0x243C2368, "buildable_is_piece_building" },
    { 0xAE37D260, "buildable_is_piece_built" },
    { 0xAD8E07E3, "buildable_is_piece_built_or_building" },
    { 0xCBC0A047, "buildable_item" },
    { 0x87D5F411, "buildable_model" },
    { 0x43F85DA7, "buildable_name" },
    { 0x82047130, "buildable_need_part_vo_cooldown" },
    { 0xB5F1E04F, "buildable_pickedup_timer" },
    { 0xB61FC52B, "buildable_pickup_vo_override" },
    { 0xAD3CC3F4, "buildable_piece_count" },
    { 0x7CD78EE7, "buildable_piece_counts" },
    { 0x07C36916, "buildable_piece_pickedup_vox_cooldown" },
    { 0xDBF2D93B, "buildable_piece_spawns" },
    { 0x44F77B28, "buildable_piece_triggers" },
    { 0x53B716C4, "buildable_piece_unitriggers" },
    { 0x224C8AFB, "buildable_pieces" },
    { 0x6308F2E4, "buildable_pieces_structs" },
    { 0x5D9009F2, "buildable_place_think" },
    { 0x08134706, "buildable_play_build_fx" },
    { 0x41000DFC, "buildable_pool" },
    { 0x05E24635, "buildable_progress_end" },
    { 0xBE4F302C, "buildable_set_force_spawn_location" },
    { 0x31D5EC44, "buildable_set_piece_building" },
    { 0xE47C3FF4, "buildable_set_piece_built" },
    { 0x5DE8D820, "buildable_set_unbuild_notify_delay" },
    { 0x26F33B30, "buildable_set_unbuild_time_delay" },
    { 0x2E995ECE, "buildable_slot" },
    { 0xDBD1E0B2, "buildable_slot_count" },
    { 0x8309F4F8, "buildable_slot_default" },
    { 0x0A42C45E, "buildable_spawn_think" },
    { 0x569195D1, "buildable_struct" },
    { 0x26E2B469, "buildable_stubs" },
    { 0xC2A30134, "buildable_tarps" },
    { 0xC3F0E3F6, "buildable_think" },
    { 0xD332EFED, "buildable_timer" },
    { 0x6A027F97, "buildable_trigger_think" },
    { 0x0FA22AAD, "buildable_trigger_think_array" },
    { 0x51DD4262, "buildable_use_cyclic_spawns" },
    { 0x978A0564, "buildable_use_hold_think" },
    { 0x38996384, "buildable_use_hold_think_internal" },
    { 0x30156746, "buildable_wallbuy_pickup_hints" },
    { 0x04B2570C, "buildable_wallbuy_weapon_angles" },
    { 0x69AA8F7E, "buildable_wallbuy_weapon_hints" },
    { 0xDA0F9E32, "buildable_wallbuy_weapon_models" },
    { 0x307BDD60, "buildable_wallbuy_weapons" },
    { 0x7F0D7911, "buildable_wrong_part_vo_cooldown" },
    { 0xC7A1C270, "buildable_zone" },
    { 0x6D72128B, "buildableaudio" },
    { 0x6A6E9BD7, "buildableelectrictrap" },
    { 0xE5018E1A, "buildableheadchopper" },
    { 0x631674C2, "buildablename" },
    { 0xD053BB2F, "buildablepickup" },
    { 0xA7BC9776, "buildablepickups" },
    { 0x03315B4F, "buildablepiece" },
    { 0xB1C3D891, "buildablepiecemodelarray" },
    { 0x5B3E4416, "buildablepieces" },
    { 0xC5D81A80, "buildablepools" },
    { 0xEBE14D96, "buildables" },
    { 0x7DE4FEB7, "buildables_built" },
    { 0x2D9A51F8, "buildables_setup" },
    { 0x148B0328, "buildables_watch_swipes" },
    { 0xA4C49565, "buildablesenabledlist" },
    { 0xAD5F4953, "buildablespringpad" },
    { 0x046E5CF0, "buildablestruct" },
    { 0x63DA785E, "buildablestub_finish_build" },
    { 0x3C6D4E80, "buildablestub_reject_func" },
    { 0x060F52BE, "buildablestub_remove" },
    { 0x464B806A, "buildablestub_update_prompt" },
    { 0x4D159DFB, "buildablesubwoofer" },
    { 0x81F08BE9, "buildabletrigger" },
    { 0xA86CFEFC, "buildabletrigger_update_prompt" },
    { 0xBEE96A6C, "buildableturbine" },
    { 0xF4F9C0E5, "buildableturret" },
    { 0xC5BB7515, "buildablezone" },
    { 0x01A6D406, "buildalertfaceanims" },
    { 0x2D42A17F, "buildandcachesoundalias" },
    { 0x116AD836, "buildandvalidatefacialanimationlist" },
    { 0x1E89F77A, "buildbcalias" },
    { 0xA321A54D, "buildbuildable" },
    { 0x89B609CC, "buildbuildables" },
    { 0xFE4505B2, "buildburstfirefaceanims" },
    { 0x7DE3F16B, "buildcasualfaceanims" },
    { 0xEE1EE5DC, "buildchallegeinfo" },
    { 0x4C67683E, "buildcqbfaceanims" },
    { 0x7D4CB3BC, "buildcurve" },
    { 0x5C1CC0EA, "builddeathfaceanims" },
    { 0x59D1DFFA, "builddynamicwallbuy" },
    { 0x18EA2875, "builddynamicwallbuys" },
    { 0xFB9E6A22, "builder" },
    { 0x3CB34918, "builder_microtask" },
    { 0xCD6DC982, "builder_subtask" },
    { 0x7C5857AE, "builder_task" },
    { 0xF724D9ED, "builders" },
    { 0xB2540A4C, "buildface_player" },
    { 0x06E1D913, "buildfacestate" },
    { 0x00AD4A8F, "buildign" },
    { 0x46F4C261, "building" },
    { 0xABB13B4A, "building01_keep_out_clip" },
    { 0x150C0769, "building01_roof_destroyed" },
    { 0x91BBF28D, "building01_roof_intact" },
    { 0xC0EC3945, "building02_keep_out_clip" },
    { 0xCDD4909A, "building1" },
    { 0x90713FBE, "building1_destroyed" },
    { 0x0446D082, "building_anims" },
    { 0xABE2FEF3, "building_array" },
    { 0xD5693D12, "building_axis_check" },
    { 0xD8FAEE52, "building_battle" },
    { 0xDC1F2358, "building_battle_vo" },
    { 0x97B31EDF, "building_battle_vo_2" },
    { 0x54696E50, "building_breach_anims" },
    { 0xF77E70DB, "building_burn" },
    { 0x6FFDE259, "building_collapse" },
    { 0x29B763C9, "building_collapse_debug" },
    { 0x7141EFAE, "building_collapse_destroy_opels" },
    { 0x4002E9D3, "building_collapse_exploder" },
    { 0x4BECDCC0, "building_collapse_fallout_done" },
    { 0x032A2C5E, "building_collapse_fx" },
    { 0x7E258A59, "building_collapse_hit1_fx" },
    { 0xEB141AD8, "building_collapse_kill_ais" },
    { 0xAE2A8CD0, "building_collapse_mgers" },
    { 0x2B530C5C, "building_collapse_monitor_victims" },
    { 0x90828855, "building_collapse_monitor_victims_safety_net" },
    { 0x6A272619, "building_collapse_oneshot_fx" },
    { 0x65356271, "building_collapse_oneshot_fx_randomchance" },
    { 0xFD00A9BD, "building_collapse_opel_destroy" },
    { 0x202FB13C, "building_collapse_planes_fire" },
    { 0x2F25C177, "building_collapse_planes_fly_in" },
    { 0xB9532BDD, "building_collapse_player_damage" },
    { 0x10A8E310, "building_collapse_player_shock" },
    { 0x9D445F41, "building_collapse_players_shock" },
    { 0xF4AA7413, "building_collapse_setup" },
    { 0x99673C8D, "building_collapse_setup_anim_pieces" },
    { 0x050A60D9, "building_collapse_street_executions" },
    { 0xE9B458DC, "building_collapse_think" },
    { 0xB1AC944C, "building_collapsing" },
    { 0xCA82BBC5, "building_critical_hit" },
    { 0x217D14C4, "building_dialog" },
    { 0xAEA05990, "building_fallover_now" },
    { 0x0C57325E, "building_flame_drone" },
    { 0x40CEDBC6, "building_flank_damage" },
    { 0xEDA77EA0, "building_hit1" },
    { 0x439798F3, "building_hit1_anim_done" },
    { 0x71AF4D14, "building_hit2_anim_done" },
    { 0x724AC069, "building_hit_anim" },
    { 0x65724224, "building_l_spawners" },
    { 0x76C01FE1, "building_large" },
    { 0x31AF73E4, "building_mg_attack_player_in_open" },
    { 0xA1468907, "building_mgs" },
    { 0x6BE6AD60, "building_missile_1" },
    { 0xDDEE1C9B, "building_missile_2" },
    { 0xC83DFA89, "building_player_breach" },
    { 0x06FFCB0E, "building_prompt" },
    { 0x199519BD, "building_script_noteworthy" },
    { 0x0216F069, "building_small" },
    { 0xAE05557B, "building_stairwell" },
    { 0x37B1BF47, "building_stairwell_flashlights" },
    { 0x70893C40, "building_stairwell_mason_movement" },
    { 0xC02A5B7B, "building_stairwell_player_fire_listener" },
    { 0x3AA2CCC7, "building_stairwell_soldier_fire" },
    { 0x6D0965EC, "building_street_1_spawners_strat" },
    { 0x94C08869, "building_street_2_spawners_strat" },
    { 0xA6BA9CFF, "building_towerfall_anim_done" },
    { 0x974810F0, "building_trigger" },
    { 0x5AA1C8DD, "building_trigs" },
    { 0xBE361A9C, "building_wrap_volumes" },
    { 0x2928ED13, "buildingclearnextaudio" },
    { 0x026E3608, "buildings" },
    { 0x0DF4F879, "buildings_remaining" },
    { 0x7ED70575, "buildins" },
    { 0x4B352698, "buildmeleefaceanims" },
    { 0x112A0EAE, "buildmovementsoundaliasname" },
    { 0x19D5E77B, "buildmpchallengeinfo" },
    { 0x67D4FAB2, "buildoffsetlist" },
    { 0x92A21802, "buildpainfaceanims" },
    { 0x1BE2E992, "buildreactanims" },
    { 0xEF78B962, "buildrunninganims" },
    { 0x360980E6, "builds" },
    { 0xDA539BDA, "buildsinglefirefaceanims" },
    { 0x3B32D8B2, "buildstatsmilestoneinfo" },
    { 0xC5226258, "buildsummaryarray" },
    { 0xD83DD7AD, "buildtalkanims" },
    { 0x94EEDC77, "buildtype" },
    { 0x5D16C2A0, "buildup" },
    { 0xBDAD3596, "buildup_spots" },
    { 0x5A348CF0, "buildupaccuracymodifier" },
    { 0x574D17EF, "built" },
    { 0x34425247, "built_comptuer" },
    { 0x070CA3F3, "built_in" },
    { 0xE6A29345, "built_wallbuys" },
    { 0xEEC998CA, "builtin" },
    { 0x73A61EBC, "bulb" },
    { 0x03323394, "bulb_on" },
    { 0x1C12DD7F, "bulbs" },
    { 0x900189C6, "bulding" },
    { 0xD4B18DB1, "bulgeblur" },
    { 0x6994C5DD, "bulk" },
    { 0x33B994AF, "bulkhead" },
    { 0xF78D56A2, "bull" },
    { 0xB0745645, "bullet" },
    { 0x144E1D8F, "bullet_anim_cam" },
    { 0x32576A32, "bullet_anim_spin" },
    { 0xB320521C, "bullet_attack" },
    { 0xBB17637B, "bullet_block" },
    { 0x7F3B1756, "bullet_block_trigger" },
    { 0x836D46C5, "bullet_count" },
    { 0xF33FC4BB, "bullet_count_left" },
    { 0x8EF13B6E, "bullet_count_right" },
    { 0x78C7D2AE, "bullet_count_tail" },
    { 0xEC0D9EAD, "bullet_dir" },
    { 0xA2BEDB67, "bullet_dist_from_camera" },
    { 0xDEED3CAF, "bullet_end_orgs" },
    { 0x106662E0, "bullet_end_origin" },
    { 0x26DE36D1, "bullet_escape" },
    { 0xBEDE8B61, "bullet_hint_timer" },
    { 0x03DC8F5E, "bullet_hit_mod" },
    { 0xC28D212E, "bullet_hits" },
    { 0x494DF27A, "bullet_hits_before_swap" },
    { 0x07F200FC, "bullet_hole_model" },
    { 0x4C3BBF0A, "bullet_hole_wait" },
    { 0xBAE27D69, "bullet_holes" },
    { 0xD3FC4621, "bullet_instakill" },
    { 0xB5DB0E39, "bullet_kill_fx" },
    { 0x7219ECD4, "bullet_kill_fx_v2" },
    { 0xC72DD281, "bullet_large_normal" },
    { 0xDB68218B, "bullet_last_org" },
    { 0x68C6AD92, "bullet_max_speed" },
    { 0x8B85100F, "bullet_model" },
    { 0xAA8DA083, "bullet_offset_forward" },
    { 0xCF9FF16D, "bullet_orgs" },
    { 0xE1F1413E, "bullet_origin" },
    { 0x3F590F37, "bullet_resistance" },
    { 0xF49E0C9E, "bullet_scale" },
    { 0xD00468A3, "bullet_shield" },
    { 0x2AA03B80, "bullet_shield_commissar" },
    { 0x30C27F98, "bullet_shielded" },
    { 0x0E135AA5, "bullet_sound" },
    { 0x4BA59CC4, "bullet_spawner" },
    { 0x3A874CB0, "bullet_spot" },
    { 0x91173ED7, "bullet_start_org" },
    { 0x4DD32AA3, "bullet_target" },
    { 0xD579B393, "bullet_time" },
    { 0xBE1913DA, "bullet_trace_throttled" },
    { 0xAD09F083, "bullet_traces_this_frame" },
    { 0xC7AAE970, "bullet_travel_time" },
    { 0xB2C86D17, "bullet_turret_index" },
    { 0x1282733C, "bullet_wait_max" },
    { 0x8F973132, "bullet_wait_min" },
    { 0x63E728BA, "bulletalphas" },
    { 0x4EBC5205, "bulletangles" },
    { 0x9A6CBEEA, "bulletcam" },
    { 0x393B589D, "bulletcam_audio" },
    { 0x71C76E55, "bulletcam_death" },
    { 0xDF70BBFD, "bulletcam_end_func" },
    { 0xD689D3E0, "bulletcam_fakedeath" },
    { 0x2EC7AEB7, "bulletcam_finaldist" },
    { 0xBA92BFD1, "bulletcam_impactptfx" },
    { 0xC3E7385B, "bulletcam_no_target_audio" },
    { 0x8E49F69E, "bulletcam_nodeath" },
    { 0x95241183, "bulletcam_start" },
    { 0xD028BFD1, "bulletcam_timeontargdeath" },
    { 0x6889658C, "bulletcam_timeontargetdeath" },
    { 0xE5AA3172, "bulletdamage" },
    { 0xDCCAC339, "bulletdamage_data" },
    { 0xF1088A81, "bulletdamagereduction" },
    { 0xEFB793DA, "bulletdamagescalar" },
    { 0x05D3502D, "bullethintshown" },
    { 0x871146A3, "bullethole" },
    { 0x60400A0A, "bulletimpactexplode" },
    { 0xB3579C9E, "bulletinclip" },
    { 0xBB26B2D5, "bulletkill" },
    { 0x17493914, "bulletoffset" },
    { 0x08D2A100, "bulletpenalty" },
    { 0x46020D17, "bulletpenaltymodel" },
    { 0x39F4B8D4, "bullets" },
    { 0x66B9D537, "bullets_max" },
    { 0x4BC4A989, "bullets_min" },
    { 0x11E244A6, "bullets_per_sec" },
    { 0x3E1C21F0, "bullets_sparks_on_bike_exit" },
    { 0xF79BC041, "bullets_start" },
    { 0x4F8205C2, "bulletshield" },
    { 0x6E7B7CD5, "bulletshielded" },
    { 0xF91B59C2, "bulletshielders" },
    { 0x4D2EC4AF, "bulletsinclip" },
    { 0x49FBBFA8, "bulletspread" },
    { 0xECD6EA17, "bulletstart" },
    { 0x867511A0, "bulletted" },
    { 0xE781313F, "bullettime_active" },
    { 0xE1DC201C, "bullettrace" },
    { 0x7178C13C, "bullettracepassed" },
    { 0x5475F2F6, "bullettracer" },
    { 0xB2799F42, "bulletwhizby" },
    { 0xD4D69820, "bullshit" },
    { 0xD450D703, "bum" },
    { 0x0DB2F919, "bummer" },
    { 0x1DCB8609, "bump" },
    { 0x5029DE73, "bump_animated_damage_state" },
    { 0xDDA5F7AA, "bump_trig" },
    { 0xF67072F8, "bump_trigger" },
    { 0x8B519348, "bump_trigger_hack" },
    { 0xD63171D3, "bump_trigger_listener" },
    { 0xBDBE281D, "bump_trigger_start" },
    { 0x8F7C2565, "bump_trigs" },
    { 0x16F65836, "bumped" },
    { 0x930F2050, "bumper" },
    { 0xA1C1BF3B, "bumpers" },
    { 0x07EAD8BF, "bumping" },
    { 0xDD470300, "bumps" },
    { 0x0EBB5771, "bunch" },
    { 0x68A8A8A1, "bunches" },
    { 0xFECC9ED7, "bunching" },
    { 0xF5766435, "bundle" },
    { 0x4743BD2B, "bundled" },
    { 0xCBD111BC, "bundlename" },
    { 0x0D1E9104, "bundles" },
    { 0xFFDEC177, "bunk1_post_anim" },
    { 0x408A6BBC, "bunk2_post_anim" },
    { 0x3477FAC6, "bunk_guys" },
    { 0x71CB8294, "bunk_guys_and_spawners" },
    { 0x1336B295, "bunk_nodes" },
    { 0x5BC320CE, "bunk_tag" },
    { 0x8CCE8366, "bunker" },
    { 0x26EBA59F, "bunker01" },
    { 0xEDA584FA, "bunker01_start" },
    { 0xB4E43664, "bunker02" },
    { 0x65A96B31, "bunker02_start" },
    { 0x559247AB, "bunker1" },
    { 0x86C09972, "bunker1_dialogue_begin" },
    { 0x5A4CEA73, "bunker1_friendlies" },
    { 0xE38AD870, "bunker2" },
    { 0x7F9CA39A, "bunker2_friendlies" },
    { 0xE8C00576, "bunker_03" },
    { 0x2AB3A169, "bunker_04" },
    { 0xA1D35E78, "bunker_1_47mm" },
    { 0x5178BE70, "bunker_1_axis_banzai" },
    { 0x79DFE3C8, "bunker_1_clear" },
    { 0xE0984F99, "bunker_1_guys" },
    { 0x3DCF6C48, "bunker_1_mgs" },
    { 0x87136E3E, "bunker_1_mgs_off" },
    { 0x46A99893, "bunker_1_pre_spawners_strat" },
    { 0xDB7E0052, "bunker_1_retreat" },
    { 0xAEB334CA, "bunker_1_retreat_strat_b" },
    { 0xBD15BEE6, "bunker_1stroom_alerted" },
    { 0x14C4529D, "bunker_1stroom_fight" },
    { 0x3D423A1A, "bunker_1stroom_retreat" },
    { 0x24DB829C, "bunker_1stroom_sidepassage" },
    { 0xBDF5C391, "bunker_1stroom_sidepassage_near" },
    { 0xB1365D31, "bunker_2_47mm" },
    { 0x412CF3E1, "bunker_2_ambient_friendlies_approach" },
    { 0xF882F87D, "bunker_2_ambient_friendlies_strat" },
    { 0x0BAF2096, "bunker_2ndroom_alert_paper_burners" },
    { 0x91467ABD, "bunker_2ndroom_fight" },
    { 0x9C062C77, "bunker_2ndroom_fire_failsafe" },
    { 0xDFEEF434, "bunker_2ndroom_vo" },
    { 0xCC9F9143, "bunker_4_47mm" },
    { 0x15157E38, "bunker_a_clear" },
    { 0xD4D59536, "bunker_achievement" },
    { 0x81D21E6E, "bunker_alerted" },
    { 0xBDF2EA80, "bunker_ambient_mortars" },
    { 0x717CF886, "bunker_ambient_trucks" },
    { 0x593A2857, "bunker_b_clear" },
    { 0xDB2A7650, "bunker_busted" },
    { 0xF7E67262, "bunker_cartel_frantic" },
    { 0x58CF03B8, "bunker_cartel_table_watch01" },
    { 0xCAD672F3, "bunker_cartel_table_watch02" },
    { 0xA4D3F88A, "bunker_cartel_table_watch03" },
    { 0xC537E7FA, "bunker_civilian_run_01" },
    { 0x9F356D91, "bunker_civilian_run_02" },
    { 0x7932F328, "bunker_civilian_run_03" },
    { 0x4A5BA3A6, "bunker_civilian_run_drops_cocaine" },
    { 0x2C188817, "bunker_civilian_runs" },
    { 0x749D21F3, "bunker_cleanup" },
    { 0x65ADFEFB, "bunker_cleared" },
    { 0xD0640D4A, "bunker_cleared_think" },
    { 0x2C80D293, "bunker_clip" },
    { 0x5A44256E, "bunker_cocaine_fog" },
    { 0x9BB97622, "bunker_coke_worker_vo" },
    { 0x525D1527, "bunker_coke_workers" },
    { 0xF3E2E084, "bunker_collapse" },
    { 0xE1911A17, "bunker_combat_started_vo" },
    { 0x71328D92, "bunker_damage" },
    { 0x98412076, "bunker_damage_calc" },
    { 0xBDA29354, "bunker_defender_spawners" },
    { 0x4F6358F0, "bunker_defenders_death_watch" },
    { 0x39691FFC, "bunker_defenders_reduce_count" },
    { 0x887AD4F1, "bunker_defenders_rhythm_stop" },
    { 0x11C5B8E8, "bunker_defenders_strat" },
    { 0x425A711F, "bunker_dialogue" },
    { 0xA7CAF436, "bunker_dialogue_clearbunker" },
    { 0xE60AB5D7, "bunker_dialogue_explosives_thrown" },
    { 0x2119DE27, "bunker_distract" },
    { 0xD8F40274, "bunker_distract_2" },
    { 0x89E4183D, "bunker_door_clean_up" },
    { 0xB837FB17, "bunker_enemy_alerted" },
    { 0x05AC2F56, "bunker_entered" },
    { 0x7EB6861D, "bunker_exit_vo" },
    { 0xDE179119, "bunker_exposure_scale" },
    { 0x236F191F, "bunker_fire_timer" },
    { 0x73A20293, "bunker_flamers" },
    { 0x1E6811BE, "bunker_footsteps" },
    { 0xA9EBA697, "bunker_friendlywave" },
    { 0x41D03D38, "bunker_goal" },
    { 0x3B8BFA39, "bunker_guys" },
    { 0x4F82CD9C, "bunker_guys_names" },
    { 0x23B54979, "bunker_hit_counter" },
    { 0x4ED871BB, "bunker_hit_max" },
    { 0x86AB2BEC, "bunker_intact" },
    { 0xDE74FE6C, "bunker_interior_fire" },
    { 0x9F68475C, "bunker_killed_but_not_flamed" },
    { 0x9D6A1463, "bunker_killed_with_barrels" },
    { 0x576B19A2, "bunker_last_ai" },
    { 0xB3F59F31, "bunker_last_ai_monitor" },
    { 0x636FE147, "bunker_last_spawners" },
    { 0xE3E55C96, "bunker_lightflares_off" },
    { 0xABF2E308, "bunker_lightflares_on" },
    { 0x4247D42B, "bunker_lights_flicker" },
    { 0x5AECEC3F, "bunker_lookat_physics_pulse" },
    { 0xD2710D28, "bunker_mg_damage_total" },
    { 0xF3B27A1E, "bunker_mg_killzone" },
    { 0x718E99BC, "bunker_midpoint_set" },
    { 0x8C72E856, "bunker_mortar_dust_fx" },
    { 0xBDEA4CA5, "bunker_mortar_swinging_lights" },
    { 0x65F49313, "bunker_music_watcher" },
    { 0x07939DAC, "bunker_name" },
    { 0xD3ED925C, "bunker_noneleft" },
    { 0x0AF1C952, "bunker_number" },
    { 0x25AA7DC4, "bunker_obj" },
    { 0x9EBD0CC6, "bunker_objective" },
    { 0x62751B70, "bunker_oneleft" },
    { 0x9E997771, "bunker_paper_burners" },
    { 0xDCAFA925, "bunker_patroller_play_table_kick" },
    { 0x1A6682D7, "bunker_player_near" },
    { 0x1D818870, "bunker_playerclip" },
    { 0xF35EB5FC, "bunker_post_flame_strat" },
    { 0xB9F33AAE, "bunker_prepare_flame" },
    { 0x9B922669, "bunker_radio_done" },
    { 0x7FB3749D, "bunker_scientist" },
    { 0xE12B4CD8, "bunker_scientist_takes_damage" },
    { 0xEC33F1E8, "bunker_setup" },
    { 0x2D8574C6, "bunker_spawn" },
    { 0xBF6F3000, "bunker_spawn_reward" },
    { 0x21774765, "bunker_spawnwers_triggered" },
    { 0xBAFFB783, "bunker_splitup_anims" },
    { 0x7DDD22A2, "bunker_stop_friendly_waves" },
    { 0x57BB2FFE, "bunker_suppressed_twice" },
    { 0x165FC1BB, "bunker_table_civilian_run_01_begin_anim" },
    { 0x26AA452A, "bunker_table_civilian_run_02_begin_anim" },
    { 0x360E3B5A, "bunker_table_civilian_run_03_attach_cocaine" },
    { 0x00A3E3A5, "bunker_table_civilian_run_03_begin_anim" },
    { 0xFEC20DF6, "bunker_table_clip_setup" },
    { 0xD35ECD14, "bunker_table_flipped_01" },
    { 0x1F63C1E6, "bunker_table_flipped_03" },
    { 0x7305B553, "bunker_table_kick_1_deathfunction" },
    { 0xEBF16A90, "bunker_table_kick_2_deathfunction" },
    { 0x8A6C6C09, "bunker_table_watchers" },
    { 0x329DAB0B, "bunker_trigger" },
    { 0x856FDC82, "bunker_trigger_thread" },
    { 0xF9640617, "bunker_ui" },
    { 0xBA7D52CC, "bunker_vo" },
    { 0x162430C8, "bunker_voices" },
    { 0xF126DFA5, "bunker_volume_death_check" },
    { 0x2C3F9969, "bunker_wait_for_explosives" },
    { 0xA8E0BE42, "bunker_wait_for_flame" },
    { 0x9CAFCB6A, "bunker_waitfor_cleared" },
    { 0xF597CDFE, "bunker_waittill_enemy_alerted" },
    { 0x768ECA1E, "bunker_waittill_player_near" },
    { 0xC98BF494, "bunker_weapons" },
    { 0x5D2CFAFB, "bunker_window_1_flamed" },
    { 0x860F931F, "bunker_window_1_flamed_delay" },
    { 0xD53E58DA, "bunkerdoor" },
    { 0x3C5A142D, "bunkerdoor_done" },
    { 0xA81C1A07, "bunkerdoorrotate" },
    { 0xDAD1C6E9, "bunkered" },
    { 0x88EEB899, "bunkers" },
    { 0x1ED6F6F6, "bunkers_2" },
    { 0xBEA88289, "bunkers_2_spawns" },
    { 0xBB293BAB, "bunkers_end" },
    { 0xEC446511, "bunkers_end_heroes_strat" },
    { 0xBC2E131C, "bunkers_end_heroes_vo" },
    { 0xCA9C8985, "bunkers_end_heros_in_place" },
    { 0x9D5B0FA6, "bunkers_flame_pre_explosions" },
    { 0xFCC3D80C, "bunkers_flame_pre_explosions_vo" },
    { 0x9B2FF063, "bunkers_flamed" },
    { 0x2A15E17C, "bunkers_flamed_fx" },
    { 0x719252B1, "bunkers_vo" },
    { 0xEE3AA50A, "bunks" },
    { 0x8AD5B922, "buoy" },
    { 0x026D2AF7, "buoyancy" },
    { 0x3B625F7C, "buoyancy_scale" },
    { 0x62355B9D, "buoyant" },
    { 0x6B3636ED, "buoys" },
    { 0x447E252A, "bureaucrats" },
    { 0xDE74C1CA, "buried" },
    { 0x6276DC07, "buried_add_player_dialogue" },
    { 0xC9DB612A, "buried_audio_custom_response_line" },
    { 0xE813EE8D, "buried_audio_custom_weapon_check" },
    { 0xB7D038BF, "buried_audio_get_mod_type_override" },
    { 0x28119168, "buried_custom_bank_deposit_vo" },
    { 0xBA9505FC, "buried_custom_bank_withdrawl_vo" },
    { 0x9C9A037E, "buried_custom_buildable_need_part_vo" },
    { 0x61A44A55, "buried_custom_buildable_wrong_part_vo" },
    { 0x4F478B51, "buried_custom_weapon_weights" },
    { 0x90E6301B, "buried_custom_zombie_gibbed_vo" },
    { 0xDC3BF3A0, "buried_custom_zombie_oh_shit_vox" },
    { 0x0F5492D2, "buried_fountain_transporter_used" },
    { 0xD057A172, "buried_ghost_drained_player" },
    { 0x8525D896, "buried_ghost_killed" },
    { 0x363F6BAC, "buried_ghost_perk_acquired" },
    { 0xB9620F24, "buried_ghost_zone_teleport_logic" },
    { 0x381E0557, "buried_lsat_purchased" },
    { 0x4901DAEC, "buried_paralyzer_check" },
    { 0xAA00D9EB, "buried_player_track_ammo_count" },
    { 0xC4552125, "buried_set_start_area_lighting" },
    { 0xE32840EC, "buried_set_underground_lighting" },
    { 0xABF939EE, "buried_sidequest_achieved" },
    { 0xBBB7B7A5, "buried_sloth_booze_break_barricade" },
    { 0x4759363F, "buried_sloth_booze_given" },
    { 0x6091822B, "buried_sloth_candy_box_lock" },
    { 0xB9452AC1, "buried_sloth_candy_box_move" },
    { 0xFD938B0A, "buried_sloth_candy_box_spin" },
    { 0x682932A9, "buried_sloth_candy_build_buildable" },
    { 0x98B1CA2C, "buried_sloth_candy_crawler" },
    { 0xDA5A7709, "buried_sloth_candy_dance" },
    { 0xA6167831, "buried_sloth_candy_fetch_buildable" },
    { 0x21B1951B, "buried_sloth_candy_given" },
    { 0xCEA522FB, "buried_sloth_candy_powerup_cycle" },
    { 0x20F80AB9, "buried_sloth_candy_protect" },
    { 0xE7065218, "buried_sloth_candy_wallbuy" },
    { 0xF22EB449, "buried_special_weapon_magicbox_check" },
    { 0x1922F328, "buried_sq_maxis_complete" },
    { 0x567B61F2, "buried_sq_richtofen_complete" },
    { 0x4785A0AB, "buried_sq_started" },
    { 0x10DBA7EF, "buried_validate_enemy_path_length" },
    { 0x3BDC781D, "buried_wallbuy_placed" },
    { 0xDB5C59A4, "buried_wallbuy_placed_870mcs_zm" },
    { 0x500917E2, "buried_wallbuy_placed_ak74u_zm" },
    { 0x0BEB7D82, "buried_wallbuy_placed_an94_zm" },
    { 0x85DB0D25, "buried_wallbuy_placed_pdw57_zm" },
    { 0xEE92B5A0, "buried_wallbuy_placed_svu_zm" },
    { 0x941D9517, "buried_wallbuy_placed_tazer_knuckles_zm" },
    { 0x2185E938, "buried_zone_init" },
    { 0xE7037274, "buring" },
    { 0xB75817E2, "burn" },
    { 0x7ADDC046, "burn_and_die_thread" },
    { 0xF8CA07A9, "burn_blocker" },
    { 0x138134E9, "burn_body" },
    { 0x1EA366BC, "burn_clear" },
    { 0xDE17C179, "burn_corpse" },
    { 0x62F39D95, "burn_drone" },
    { 0x3A25AEB5, "burn_drone_count" },
    { 0x76AFE39C, "burn_entity" },
    { 0xF31B459F, "burn_finished" },
    { 0x64AA2A8A, "burn_guy" },
    { 0x3424E7ED, "burn_harper_face" },
    { 0xE5551B62, "burn_harpers_face" },
    { 0xC4AD8E74, "burn_loop_sound_handle" },
    { 0x83EFA72F, "burn_me" },
    { 0x973E0378, "burn_model" },
    { 0x33CF40D1, "burn_model_cap" },
    { 0x211DD8D3, "burn_models" },
    { 0x9DEB70F8, "burn_off" },
    { 0x4C9BAEB2, "burn_on" },
    { 0x1A5DECB1, "burn_on_postfx" },
    { 0xD4A4FD1F, "burn_self" },
    { 0xFED016A5, "burn_smolder" },
    { 0x2A670A22, "burn_stage_finished" },
    { 0x7811102A, "burn_tags_on" },
    { 0x92D8B1E6, "burn_time" },
    { 0x095BC80E, "burnable" },
    { 0xE3BF5766, "burncorpse" },
    { 0x2907DF49, "burndamage" },
    { 0x9ABD278E, "burndamageinterval" },
    { 0x338FE898, "burndist2" },
    { 0x3B99942E, "burnduration" },
    { 0x287798F5, "burned" },
    { 0x319FDC6C, "burned_body" },
    { 0x03B21268, "burned_dialog" },
    { 0xA162499C, "burned_enemy" },
    { 0x39D3934F, "burnedenemy" },
    { 0xC3C5DBB2, "burnedkilled" },
    { 0x30E7E350, "burnedtodeath" },
    { 0x52491159, "burnedwithdragonsbreath" },
    { 0xC4881B4F, "burnedwithflamethrower" },
    { 0xA0BF566B, "burneffectradius" },
    { 0x3C9A4AB3, "burner" },
    { 0x5F1FD162, "burners" },
    { 0xC2C671C4, "burnincendiaryduration" },
    { 0x31863FCE, "burning" },
    { 0xAE3640B1, "burning_building" },
    { 0x4EF27BF5, "burning_building_shooters_setup" },
    { 0x2C180658, "burning_callback" },
    { 0xDE1B5149, "burning_corpse_callback" },
    { 0x85432739, "burning_death" },
    { 0x0B5C69B5, "burning_door" },
    { 0xD46B4E00, "burning_door_open" },
    { 0xDEC07712, "burning_door_org" },
    { 0x59FC65EE, "burning_effect" },
    { 0x3E8ECF2E, "burning_guy" },
    { 0xED5531F3, "burning_man" },
    { 0x8F907CEE, "burning_ragdoll" },
    { 0x34206B6E, "burning_section" },
    { 0x2D551304, "burning_sky" },
    { 0x727C9AB5, "burning_sky_contrast" },
    { 0xFCF3AE7C, "burning_sky_exposure" },
    { 0x79A0AA08, "burning_sound_ent" },
    { 0x0F2B259D, "burning_thread" },
    { 0x06D77130, "burning_trash_fire" },
    { 0x5FA1B0E6, "burning_zombies" },
    { 0x7FAB79B2, "burningduration" },
    { 0x0F581D99, "burninterval" },
    { 0x74ACCF1D, "burnnapalmduration" },
    { 0xB35DA9D4, "burnnapalmeffectradius" },
    { 0xC485AEF1, "burnnapalmeffectradiuslarge" },
    { 0xC2A158B9, "burnnapalmeffectradiussmall" },
    { 0x97B5406D, "burnplayer" },
    { 0x074B3839, "burnplayer_watchburntimer" },
    { 0x3B342AAD, "burns" },
    { 0x64B7AE95, "burnsec" },
    { 0x6435CF9F, "burnsound" },
    { 0xC92CBB72, "burnt" },
    { 0x737FC339, "burnt_blocker" },
    { 0x5D17AED3, "burnt_limo_stream" },
    { 0x2A01870A, "burnt_spawners" },
    { 0xB5B51A1D, "burntags" },
    { 0x45FB499D, "burntime" },
    { 0xE70C4123, "burntrigs" },
    { 0xD0BCCD9E, "burnville" },
    { 0x3BE6AD34, "burnville_paratrooper_hack" },
    { 0xFE6EA955, "burnville_paratrooper_hack_loop" },
    { 0xFA3A2E7C, "burnville_style_mortar" },
    { 0xD349396C, "burp" },
    { 0xBA998E7D, "burrow_active" },
    { 0x9ED51F63, "burrow_done" },
    { 0xFB3BA963, "burrows" },
    { 0x0DB5D611, "burst" },
    { 0x087686BF, "burst1_think" },
    { 0x5D5FE154, "burst2_think" },
    { 0x8D099A71, "burst3_think" },
    { 0xE0402A2E, "burst4_think" },
    { 0x431D13F0, "burst_amount" },
    { 0x73F7AB17, "burst_area" },
    { 0x935B3A39, "burst_count" },
    { 0xB0673B21, "burst_delay" },
    { 0x2B08CD30, "burst_fire" },
    { 0x34EF531F, "burst_fire_audio_delete" },
    { 0x46880C39, "burst_fire_kill_player" },
    { 0xE44B811D, "burst_fire_rebirthbtr" },
    { 0xA6EE2100, "burst_fire_settings" },
    { 0xC1255074, "burst_fire_time" },
    { 0xD8F74413, "burst_fire_unmanned" },
    { 0x3B8D5686, "burst_fx" },
    { 0x5940A697, "burst_intensity" },
    { 0xC8AAE3AE, "burst_max" },
    { 0x1B825270, "burst_min" },
    { 0x5E56A994, "burst_num" },
    { 0x7CC2C3D0, "burst_spacing_max" },
    { 0xEA3AA22E, "burst_spacing_min" },
    { 0xEC75AB87, "burst_time" },
    { 0x42AB50C8, "burst_time_max" },
    { 0x9FCB9856, "burst_time_min" },
    { 0x366E3324, "burst_tree" },
    { 0x328896A7, "burst_wait" },
    { 0xA03EE0F2, "burst_zombie" },
    { 0xA2C6714E, "burstcount" },
    { 0xF14E947E, "burstdelay" },
    { 0x2435DEA6, "burstfireaidelaymax" },
    { 0xC9900018, "burstfireaidelaymin" },
    { 0xC2B87CB8, "burstfiredelaymax" },
    { 0xDDADA866, "burstfiredelaymin" },
    { 0x55C40EA1, "burstfiredurationmax" },
    { 0x007236DF, "burstfiredurationmin" },
    { 0x938B2086, "burstfirenumshots" },
    { 0x400B82A8, "burstgrenadesfired" },
    { 0xA1D4C8F7, "bursting" },
    { 0xD5A94C99, "burstmax" },
    { 0x304F2B27, "burstmin" },
    { 0xD410E6F8, "bursts" },
    { 0xB801357F, "burstshootanimrate" },
    { 0xA2F79CB1, "burstshot" },
    { 0xBAB1279E, "burstsize" },
    { 0x748D1967, "burstsizestr" },
    { 0xA157F972, "burstsmax" },
    { 0xB676A10C, "burstsmin" },
    { 0xBCBFF7C6, "bursttime" },
    { 0x31C8E5C5, "bursttime_scale" },
    { 0xFA4F397C, "burstwaitmax" },
    { 0x7763F772, "burstwaitmin" },
    { 0xC937E08D, "bury" },
    { 0x396AF09B, "burying" },
    { 0x50699F1D, "bus" },
    { 0x2037F864, "bus_attack" },
    { 0x24AFD5E4, "bus_attack_struct" },
    { 0xC4446840, "bus_attack_time" },
    { 0xF8321710, "bus_audio_setup" },
    { 0xA63F81C3, "bus_audio_watcher" },
    { 0xC3F808B6, "bus_auto_turret" },
    { 0xF6D7FA9B, "bus_auto_turret_trigger" },
    { 0x44E589A3, "bus_brake_lights" },
    { 0xCBC2ADA8, "bus_break_balcony" },
    { 0x4178058C, "bus_break_wall" },
    { 0x9AA1A21E, "bus_bridge_speedcontrol" },
    { 0xFE3DBCDA, "bus_crash_audio" },
    { 0x85ED331A, "bus_crash_drone" },
    { 0x90658C4B, "bus_crash_rumble" },
    { 0xB97475DA, "bus_dam" },
    { 0xF8570B91, "bus_dam_anims" },
    { 0xF27B57CF, "bus_dam_button_mash" },
    { 0x94351D5C, "bus_dam_exit_done" },
    { 0x8C86A8DB, "bus_dam_exit_started" },
    { 0x025489AB, "bus_dam_fail_time" },
    { 0xADDF099F, "bus_dam_gate_push_setup_started" },
    { 0xEDD6D081, "bus_dam_gate_push_test_done" },
    { 0xDB93DEB6, "bus_dam_gate_success_started" },
    { 0x1CFFC55D, "bus_dam_idle_rumble" },
    { 0xBB1D5AD2, "bus_dam_reconstruct_ents" },
    { 0x282F15F6, "bus_dam_rumble" },
    { 0x2822B42D, "bus_dam_strength_test" },
    { 0xB9AB50FA, "bus_dam_timeout" },
    { 0x5FB59702, "bus_dam_wave_at_player" },
    { 0x3764282C, "bus_death_hud" },
    { 0x7EEF8C75, "bus_debug" },
    { 0x6EF10B24, "bus_disable" },
    { 0x1D3D90D0, "bus_disable_show" },
    { 0xED99C100, "bus_disable_time" },
    { 0x711B52E8, "bus_disabled" },
    { 0x4AB59B6B, "bus_disabled_by_emp" },
    { 0xFACAB563, "bus_dist_sq" },
    { 0xEBB5C244, "bus_driver_focused" },
    { 0x3208835B, "bus_driver_idle" },
    { 0x15A065E3, "bus_event_failure" },
    { 0x17621EFD, "bus_event_gate_failure" },
    { 0xEC0D49C2, "bus_event_setup" },
    { 0x3724C4F0, "bus_event_success" },
    { 0xC60E87AB, "bus_first_impact" },
    { 0x691B73D6, "bus_flashing_lights" },
    { 0x165AD4C7, "bus_forward" },
    { 0x8E5ADD35, "bus_front" },
    { 0xFC1BB66F, "bus_grenade_think" },
    { 0xB9B391D0, "bus_hatch_tearin_wait" },
    { 0x08A96186, "bus_hatch_wait" },
    { 0x2A7BE9B2, "bus_head_lights" },
    { 0x813A49DF, "bus_hit" },
    { 0x43A200A4, "bus_interior_lights" },
    { 0x488D3D0B, "bus_interior_loop_end" },
    { 0xC0BCA028, "bus_interior_loop_start" },
    { 0x12BB6E6F, "bus_ladder_dist" },
    { 0xC284809B, "bus_leave_hud" },
    { 0x75BEEB3D, "bus_loop_audio" },
    { 0x0B54DA00, "bus_loop_ent" },
    { 0x8F2A3867, "bus_nodes" },
    { 0x8F9F7FAD, "bus_power_off" },
    { 0x3FFC4441, "bus_power_on" },
    { 0x569F373B, "bus_random_horn" },
    { 0xE8260BDF, "bus_range" },
    { 0xD4DC494D, "bus_react" },
    { 0x35458F19, "bus_riders_alive" },
    { 0x212A2B2B, "bus_rock" },
    { 0x965998BA, "bus_roof" },
    { 0x32326B26, "bus_roof_damage" },
    { 0xCC8B8623, "bus_roof_damage_init" },
    { 0x595C516D, "bus_roof_max_interval_time" },
    { 0xDD2E2AE7, "bus_roof_min_interval_time" },
    { 0xE10591FA, "bus_roof_next_time" },
    { 0xB3A34E6D, "bus_roof_open" },
    { 0x0D5201DF, "bus_roof_tearing" },
    { 0x662B23F6, "bus_roof_watch" },
    { 0xFAC4EB7C, "bus_run_over" },
    { 0x484867DB, "bus_scare_dist" },
    { 0x6DE11431, "bus_second_impact" },
    { 0x824AF275, "bus_set_exit_triggers" },
    { 0x43643E76, "bus_set_nodes" },
    { 0xB57C971A, "bus_shock_time" },
    { 0xD6F9B038, "bus_skip_destination" },
    { 0x4C7E9BB4, "bus_smash" },
    { 0x0A73F104, "bus_smash_bus_impact" },
    { 0xEA69B235, "bus_smash_car_hit" },
    { 0xFC4A6A4E, "bus_smash_collateral_damage_started" },
    { 0xC02FC41F, "bus_smash_done" },
    { 0xDEF5983D, "bus_smash_go" },
    { 0x41417A23, "bus_smash_shelf_fall_1" },
    { 0xCF3A0AE8, "bus_smash_shelf_fall_2" },
    { 0xF53C8551, "bus_smash_shelf_fall_3" },
    { 0xB348E95E, "bus_smash_shelf_fall_4" },
    { 0x6FF369DC, "bus_smash_timeout" },
    { 0xE1056BBB, "bus_smash_wall_collision_think" },
    { 0x54292BEC, "bus_sound_oneshot" },
    { 0x644A70BA, "bus_spawned" },
    { 0x3067BD08, "bus_sq" },
    { 0xDED30F68, "bus_station_pa_vox" },
    { 0xD71A330D, "bus_street" },
    { 0xCD7502FF, "bus_street_decrease_enemy_accuracy" },
    { 0x6ADF8E28, "bus_street_initial_wave" },
    { 0x5C972673, "bus_street_wave" },
    { 0x4BEE5002, "bus_taser_blocker" },
    { 0xFA22CBF6, "bus_tearin_roof" },
    { 0x38EF642C, "bus_time_to_disable" },
    { 0xAD111205, "bus_turnal_signal_left_lights" },
    { 0x0A2122F2, "bus_turnal_signal_right_lights" },
    { 0xA17B143E, "bus_upgrade_vox" },
    { 0x373E6787, "bus_upgrades" },
    { 0x5221D008, "bus_wave_harper_cheat_struct" },
    { 0x3E1ABFB0, "bus_wave_hits_player" },
    { 0x477FA48B, "bus_wave_initial_start" },
    { 0xD0F98BB6, "bus_wave_start" },
    { 0xE8FC1BA9, "bus_wave_starts" },
    { 0x7EEB30B1, "bus_wedge_balcony" },
    { 0xEC625523, "bus_wedge_wall" },
    { 0xD17ACCDA, "bus_window_reachin_freq" },
    { 0xCBF5BB1C, "bus_zombie_danger" },
    { 0x39766423, "bus_zombie_on_roof" },
    { 0x952D170A, "busaddopening" },
    { 0x7A35521D, "busattachjumpent" },
    { 0x5FCB70E4, "busattachmodels" },
    { 0x5F7BDF91, "buscmdhandler" },
    { 0xC7EB5530, "busdeclarename" },
    { 0x46BF3001, "busdeferredinithatchmantle" },
    { 0xEA3C0B4B, "busdeferredinitladdermantle" },
    { 0x903F1A20, "busdoorsclose" },
    { 0xC3770DF4, "busdoorsopen" },
    { 0x6379B1DB, "busdoorssetup" },
    { 0xF0F627AE, "buseadslockon" },
    { 0xC4D92329, "busenableturrets" },
    { 0xF2E86275, "buses" },
    { 0xC4893BEB, "busexitthink" },
    { 0xAB6A3798, "busfadetime" },
    { 0x1B82F618, "busfueltanksetup" },
    { 0x87CEF7B1, "busgasadd" },
    { 0x707BCB9B, "busgasempty" },
    { 0x8A70CB60, "busgasremove" },
    { 0x6B300428, "busgetcurzonename" },
    { 0x8D49F60A, "busgetopeningfortag" },
    { 0xF9EF2B61, "bushatch" },
    { 0xAD7572D6, "bushatch_hatch" },
    { 0x1AE79663, "bushatchbuildable" },
    { 0x59AAC464, "bushatchsetup" },
    { 0xA6AB43EB, "bushes" },
    { 0x241E2C93, "busidledoor" },
    { 0x4032AD4B, "busindicatoratloc" },
    { 0xFA907D5D, "busindicatorattrigger" },
    { 0x5C2C4B33, "busindicatoratturretupgrade" },
    { 0x76C931DB, "business" },
    { 0x481D630B, "busing" },
    { 0x8D75C0CB, "businit" },
    { 0xA5CFF158, "businitbuyableweapons" },
    { 0xE9EFB731, "businithatchclip" },
    { 0x36671C36, "businitmantle" },
    { 0xD8D47E15, "businitrightandleft" },
    { 0xBC67CFC8, "businitturrets" },
    { 0x7683E37A, "businitweaponslocker" },
    { 0xCDADC9F3, "businitzappercounter" },
    { 0xBFFA7940, "busisin" },
    { 0x0BA45EE4, "busisonormovingbuildableupdateprompt" },
    { 0x57B2B5F9, "busispointinside" },
    { 0x4AFA0F95, "busladder" },
    { 0xA19C4374, "busladder_ladder" },
    { 0xA80D80C7, "busladderbuildable" },
    { 0xB270E4B3, "busladderthink" },
    { 0x7BB32B8A, "buslights" },
    { 0x31DC4CF1, "buslightssetup" },
    { 0x99794E9E, "buslpe" },
    { 0x159216B8, "buslps" },
    { 0x1873CC64, "busname" },
    { 0x910E3FB2, "busonautoturretplaced" },
    { 0xA5760214, "busonbarbedwirelplaced" },
    { 0x577E04BA, "busonbarbedwirerplaced" },
    { 0xEC7DDA2B, "busonblockerpickedup" },
    { 0x460E30D3, "busoncoolerplaced" },
    { 0x8C677BE9, "busoncoolerready" },
    { 0xB75E4C23, "busoncoolerused" },
    { 0x87CCEC94, "busonheadlightsplaced" },
    { 0xD6837CC5, "busonkeysplaced" },
    { 0xC2B5C54F, "busonkeysready" },
    { 0x9B674F2D, "busonkeysused" },
    { 0x5A60FCF1, "busonladderplaced" },
    { 0x9496660B, "busonladderready" },
    { 0xE4FDB059, "busonladderused" },
    { 0x08733999, "busonlfloodlightplaced" },
    { 0x2C0919DD, "busonmoneypickedup" },
    { 0x1EDA103E, "busonnoxplaced" },
    { 0x6D06AF2E, "busonpasspickedup" },
    { 0x95A78804, "busonplatformplaced" },
    { 0xE20F7783, "busonplowplaced" },
    { 0x74E3503C, "busonradioplaced" },
    { 0x4F9A4627, "busonrfloodlightplaced" },
    { 0x6F5C066C, "busonsonicboomplaced" },
    { 0x0E76B660, "busonsonicboomready" },
    { 0x4E70B274, "busonsonicboomused" },
    { 0x09722560, "busonteleportplaced" },
    { 0xEAB1639B, "busonturretpickedup" },
    { 0x003BF603, "busonturretplaced" },
    { 0xEC29BD6D, "busonweaponupgradepickedup" },
    { 0x3E3D4D67, "busonzapperplaced" },
    { 0xA554F1FD, "busonzapperready" },
    { 0x3886DE50, "busonzapperupgraded" },
    { 0x01C680C7, "busonzapperused" },
    { 0xE79B0591, "busopeningblockerthink" },
    { 0x7D464B7D, "busopeningbyname" },
    { 0xB837C008, "busopeningrebuildthink" },
    { 0xF2DBC1C9, "busopeningscene" },
    { 0x4BE30DC8, "busopeningsetenabled" },
    { 0xE7628BBB, "busopeningzombiethink" },
    { 0x5274847E, "buspathblockerdisable" },
    { 0xAC7384B3, "buspathblockerenable" },
    { 0xB3B9A04D, "buspathblockersetup" },
    { 0xF26AFBBE, "busplacementthreadwatcher" },
    { 0x0834DD65, "busplowkillzombie" },
    { 0x299C13CE, "busplowsetup" },
    { 0x781E24AB, "busprop1" },
    { 0xBC706DA9, "busroofjumpoffpositionssetup" },
    { 0x3F7136FD, "busroofrailssetup" },
    { 0x564A968C, "busrunupgrade" },
    { 0xAE5E07ED, "bussavewait" },
    { 0xD535CD0A, "busschedule" },
    { 0xD3146297, "busscheduleadd" },
    { 0x4224C8DE, "busschedulecreate" },
    { 0xF45DAC26, "busschedulethink" },
    { 0xD5482CF0, "busses" },
    { 0x2E7766E2, "bussetdoornodes" },
    { 0xD7CE0561, "bussetkeystriggerhittext" },
    { 0xFDF3B876, "bussetplayervisibilityforblockertriggers" },
    { 0xC923886C, "bussetplayervisibilityforupgradetriggers" },
    { 0x24912890, "bussetup" },
    { 0x3ABCE763, "bussetupbounds" },
    { 0x2C555F2C, "bussetupladder" },
    { 0xBB5DCD96, "bussetuproofopening" },
    { 0x896BF17B, "bussetzapperusetext" },
    { 0xD380D386, "bussideladderssetup" },
    { 0xDBFD0576, "busspeedleaving" },
    { 0x9CCD9585, "busstartmoving" },
    { 0xE7E0EE00, "busstartwait" },
    { 0x4A246CE0, "busstate" },
    { 0xC0A214F3, "busstateactivate" },
    { 0xF7FB9EE2, "busstatedeactivate" },
    { 0x29D5C78B, "busstates" },
    { 0xD426117B, "busstopmoving" },
    { 0xBC511EF3, "bust" },
    { 0x785A00A8, "busted" },
    { 0xBC9085AE, "buster" },
    { 0xBE0A526B, "busthink" },
    { 0x1BC91C6D, "busting" },
    { 0xB2775083, "bustrigger" },
    { 0xAD2D26A2, "busts" },
    { 0x0D21A1FB, "busturret" },
    { 0x44A597C9, "busupdatebuyableweapontriggers" },
    { 0x3F493C4D, "busupgradebuyableweapon" },
    { 0x6E6CA959, "bususeanimtree" },
    { 0x5E35584E, "bususedoor" },
    { 0x1B8929CB, "busvolume" },
    { 0x62BEE370, "busvolumeall" },
    { 0x6929042A, "busvolumes" },
    { 0x4C99C3A9, "busvolumesexcept" },
    { 0x00BD751A, "buswatchtriggervisibility" },
    { 0xFB004B6C, "buswatchtriggervisibility_spread" },
    { 0x41960A6B, "busweaponfx" },
    { 0x3058C5EB, "busweaponfx_count" },
    { 0xBFA5CA21, "busweaponupgraded" },
    { 0xFE44BAE6, "busy" },
    { 0xADFBD115, "buszapperbusfx" },
    { 0x185A0841, "buszappercounter" },
    { 0x22B8F352, "buszapperpausezombiespawning" },
    { 0x139CEE66, "buszapperreadyfx" },
    { 0xDE622FE2, "but" },
    { 0x3E108372, "butt" },
    { 0x4BAB6123, "butter" },
    { 0x4E052233, "butterfingers" },
    { 0xF527682D, "button" },
    { 0xD38F90BE, "button1" },
    { 0xAD8D1655, "button2" },
    { 0x88CE7E56, "button_ads" },
    { 0x215F5D8E, "button_ammo_turn_off" },
    { 0x9BC7A2B4, "button_attack" },
    { 0x87CD396B, "button_choice_made" },
    { 0x9C1FD67B, "button_console" },
    { 0xE16A4B13, "button_count_timer" },
    { 0x54068F44, "button_counts_permin" },
    { 0xEE2B6F24, "button_down" },
    { 0xE2712B78, "button_event" },
    { 0x558A42D0, "button_exit" },
    { 0x38E2C1B9, "button_group" },
    { 0xF40B679D, "button_held" },
    { 0x95CC1E48, "button_held_think" },
    { 0xB7D2A5AF, "button_hit" },
    { 0xAA1A86E3, "button_hold_threshhold" },
    { 0x0886E15A, "button_is_clicked" },
    { 0x6EC95AAA, "button_is_held" },
    { 0xC9D9F658, "button_is_kb" },
    { 0xD7431993, "button_left" },
    { 0x789A20BA, "button_loop" },
    { 0x23F5A4DC, "button_lstick" },
    { 0x529959D6, "button_mash_done" },
    { 0x8F76CA15, "button_message" },
    { 0x97B6A9F6, "button_pause" },
    { 0xA3659E23, "button_press_required" },
    { 0x4CC474C2, "button_pressed" },
    { 0x5EA43D6D, "button_presses" },
    { 0x6CAAC514, "button_prompt_text" },
    { 0xB4FD7787, "button_ref" },
    { 0x57F40BE1, "button_released" },
    { 0xF9F8AD06, "button_right" },
    { 0xA4922C08, "button_right_held" },
    { 0x142E68D8, "button_select" },
    { 0x1AA5BC30, "button_stance" },
    { 0x4CEBA8EF, "button_state" },
    { 0x6FEF9A23, "button_state_activated" },
    { 0x35544D72, "button_state_down" },
    { 0xC2E88350, "button_state_downlong" },
    { 0xCEDDDB3C, "button_state_pressed" },
    { 0x6A3E9829, "button_state_up" },
    { 0x377914E6, "button_to_check" },
    { 0x1259E947, "button_triggers" },
    { 0x177F9EC1, "button_unpressed" },
    { 0xDA209557, "button_up" },
    { 0x48A1A779, "button_use" },
    { 0xFCBED2F3, "button_wait" },
    { 0x65738A81, "button_y" },
    { 0xD3BF9CE3, "buttonbeingheld" },
    { 0x944549D1, "buttonbits" },
    { 0xE785E273, "buttonclick" },
    { 0xD9F07D71, "buttondown" },
    { 0x9DC378DA, "buttoned" },
    { 0xC4627B2D, "buttonholdtime" },
    { 0xCFC08CB4, "buttonisheld" },
    { 0x0CE2B5F5, "buttonpressed" },
    { 0x3A08856E, "buttonpressed_ads" },
    { 0xD25B828C, "buttonpressed_attack" },
    { 0x3BADE11B, "buttonpressed_internal" },
    { 0x8571C2B1, "buttonpressed_use" },
    { 0x0829362C, "buttons" },
    { 0x397DC3BD, "buttons_free" },
    { 0xB20EB3CA, "buttontime" },
    { 0xCC826737, "buy" },
    { 0x63E8B84E, "buy_bouncing_betties" },
    { 0x40F2FA2D, "buy_claymores" },
    { 0xC365F534, "buy_prompt" },
    { 0xE75217A6, "buy_random_wallbuy" },
    { 0x474E4DD9, "buy_random_wallbuys" },
    { 0x2DB80917, "buyable" },
    { 0xE02959A4, "buyable_weapon_visisble" },
    { 0x66B3486B, "buyableweapon" },
    { 0xDD15D44A, "buyableweapons" },
    { 0x74F36DA4, "buyableweaponsupgradelevel" },
    { 0x91CB05A2, "buyableweaponsupgradetrigger" },
    { 0x305E5992, "buyin" },
    { 0xB78CB569, "buying" },
    { 0xEE234F6E, "buys" },
    { 0xC8736A9E, "buzz" },
    { 0x8B318C02, "buzz_sound" },
    { 0xF1D15661, "buzzby_sound" },
    { 0xC447F1C7, "buzzer" },
    { 0x899A1A22, "buzzing" },
    { 0xF815407A, "buzzkill" },
    { 0x62428E47, "bventdrop" },
    { 0x60CB0EE1, "bvisible" },
    { 0x8CFDF5ED, "bwaitforstart" },
    { 0x0D9E660B, "bwars_drone_count" },
    { 0x3370843C, "bwars_flags" },
    { 0xDE5B2035, "bwars_get_spawnpoint" },
    { 0x5B67E08A, "bwars_hud" },
    { 0xC019F8D3, "bwars_icons" },
    { 0x939ABEF1, "bwars_init" },
    { 0xBE48CA16, "bwars_last_highest" },
    { 0x9E73B90F, "bwars_scoreboard_update" },
    { 0x4B7C2B41, "bwars_spawns_update" },
    { 0x91EBB105, "bwars_time_think" },
    { 0xF6F610C2, "bwars_update_scores" },
    { 0xF386ABC9, "bwasdemojump" },
    { 0xCAA68348, "bwasplayertarget" },
    { 0x67C49DC3, "bwastimejump" },
    { 0x8D2F7B38, "bweaponscarriedover" },
    { 0xB468903C, "bweaponsdisabled" },
    { 0xF875C729, "bwmode" },
    { 0xCE0146FE, "by" },
    { 0x9125466F, "by_cut" },
    { 0xF7BB73CD, "by_flak_too_long" },
    { 0x3761F4CA, "by_pass_wait" },
    { 0x748BF32A, "by_player" },
    { 0xCFB083FF, "by_tank_dude1_setup" },
    { 0xFBFF6B70, "by_tank_dude2_setup" },
    { 0x76197909, "by_tank_dude3_setup" },
    { 0x6C3C67A2, "by_tank_dude4_setup" },
    { 0x85B272DA, "by_tankdude_1_stoploop" },
    { 0x7F97C547, "by_tankdude_2_stoploop" },
    { 0x3BE1F13C, "by_tankdude_3_stoploop" },
    { 0x21DB2ED1, "by_tankdude_4_stoploop" },
    { 0xD5AFEF55, "by_type" },
    { 0xC1147887, "by_who" },
    { 0x3F81117E, "by_window_trig" },
    { 0xCB2CC956, "byonet" },
    { 0xA7716FA1, "bypass" },
    { 0x8857ABBF, "bypass_drums" },
    { 0x0085978E, "bypassed" },
    { 0xE2518CF1, "bypasses" },
    { 0x1084AAE1, "bypasssledgehammer" },
    { 0xA8FEA91D, "bypassvehiclescripts" },
    { 0xCAC1E9B9, "byplayer" },
    { 0xC3D8A0E1, "bys" },
    { 0x81E504EE, "byt" },
    { 0xDF6567CE, "bytes" },
    { 0xB7509077, "byzantine" },
    { 0xA3BDBC66, "bzm_aquiferdialogue1_1callback" },
    { 0xA0BE1689, "bzm_aquiferdialogue1_2callback" },
    { 0x9D3CD2AC, "bzm_aquiferdialogue1_3callback" },
    { 0x11177797, "bzm_aquiferdialogue1_4_1callback" },
    { 0xF52D0FA7, "bzm_aquiferdialogue1_4callback" },
    { 0x9510693A, "bzm_aquiferdialogue1_5callback" },
    { 0x125DE22D, "bzm_aquiferdialogue1_6callback" },
    { 0xE45BDC20, "bzm_aquiferdialogue1_7callback" },
    { 0x157B8EF6, "bzm_aquiferdialogue1callback" },
    { 0x24D74B55, "bzm_aquiferdialogue2_1callback" },
    { 0x0DCEFC59, "bzm_aquiferdialogue2callback" },
    { 0xD08C6690, "bzm_aquiferdialogue3_1callback" },
    { 0xA8EBF9FC, "bzm_aquiferdialogue3callback" },
    { 0x2570F267, "bzm_aquiferdialogue4_1callback" },
    { 0x51694477, "bzm_aquiferdialogue4callback" },
    { 0xFFDDDA4A, "bzm_aquiferdialogue5callback" },
    { 0x1FF0137D, "bzm_aquiferdialogue6callback" },
    { 0x736B3D3C, "bzm_aquiferdialogue7_1callback" },
    { 0x5BFE1C70, "bzm_aquiferdialogue7callback" },
    { 0x6253D0F1, "bzm_biodialogue1callback" },
    { 0x8B9B1711, "bzm_biodialogue2_2callback" },
    { 0x80A07074, "bzm_biodialogue2_3callback" },
    { 0xFD93406F, "bzm_biodialogue2_4callback" },
    { 0xE27AD46E, "bzm_biodialogue2callback" },
    { 0xD9CF116B, "bzm_biodialogue3callback" },
    { 0x4D395988, "bzm_biodialogue4callback" },
    { 0x46D46F79, "bzm_biodialogue5_1callback" },
    { 0x4AA51716, "bzm_biodialogue5_2callback" },
    { 0xE32D12F3, "bzm_biodialogue5_3callback" },
    { 0x9910C090, "bzm_biodialogue5_4callback" },
    { 0x21D18CF5, "bzm_biodialogue5callback" },
    { 0x167FA382, "bzm_biodialogue6callback" },
    { 0xFCE615E8, "bzm_blackstationdialogue1callback" },
    { 0x43858FAF, "bzm_blackstationdialogue2callback" },
    { 0xCEAE7ACA, "bzm_blackstationdialogue3_1callback" },
    { 0xEEC0B3FD, "bzm_blackstationdialogue3_2callback" },
    { 0x2ACEBCF0, "bzm_blackstationdialogue3_3callback" },
    { 0xCB28E353, "bzm_blackstationdialogue3_4callback" },
    { 0xE44C2F76, "bzm_blackstationdialogue3_5callback" },
    { 0x90895EE2, "bzm_blackstationdialogue3callback" },
    { 0x655A6F1D, "bzm_blackstationdialogue4_1callback" },
    { 0xBA246CEA, "bzm_blackstationdialogue4_2callback" },
    { 0x513B9D17, "bzm_blackstationdialogue4_3callback" },
    { 0xA2D3EC51, "bzm_blackstationdialogue4callback" },
    { 0x8B2530B4, "bzm_blackstationdialogue5callback" },
    { 0x380BC8B7, "bzm_cleanupmagicboxondeletioncallback" },
    { 0x3E0291D0, "bzm_forceaicleanup" },
    { 0xB2EA822F, "bzm_hideallmagicboxescallback" },
    { 0x5145B404, "bzm_infectiondialogue10callback" },
    { 0x27AD69E1, "bzm_infectiondialogue11callback" },
    { 0xD68AEA9E, "bzm_infectiondialogue12callback" },
    { 0xABDC59DB, "bzm_infectiondialogue13callback" },
    { 0xB82F6A38, "bzm_infectiondialogue14callback" },
    { 0x7635D765, "bzm_infectiondialogue15callback" },
    { 0xADC064F2, "bzm_infectiondialogue16callback" },
    { 0xB15C12BF, "bzm_infectiondialogue17callback" },
    { 0xE8717A7C, "bzm_infectiondialogue18callback" },
    { 0x4D547CD9, "bzm_infectiondialogue19callback" },
    { 0x09E37B96, "bzm_infectiondialogue1callback" },
    { 0x354A0919, "bzm_infectiondialogue20callback" },
    { 0xF31E5ABC, "bzm_infectiondialogue21callback" },
    { 0x44AB3893, "bzm_infectiondialogue22callback" },
    { 0xB74489B6, "bzm_infectiondialogue23callback" },
    { 0x0612D3F9, "bzm_infectiondialogue2callback" },
    { 0xA99E5DF0, "bzm_infectiondialogue3_1callback" },
    { 0x46584A9C, "bzm_infectiondialogue3callback" },
    { 0xAF6A0D17, "bzm_infectiondialogue4callback" },
    { 0x1852DCEA, "bzm_infectiondialogue5callback" },
    { 0xC388DF1D, "bzm_infectiondialogue6callback" },
    { 0x584F2510, "bzm_infectiondialogue7callback" },
    { 0xC30CA873, "bzm_infectiondialogue8_1callback" },
    { 0x90CE01FB, "bzm_infectiondialogue8callback" },
    { 0x3DF977BE, "bzm_infectiondialogue9callback" },
    { 0x7C5276B2, "bzm_lotusdialogue10callback" },
    { 0xC027307F, "bzm_lotusdialogue11callback" },
    { 0xDA26FEF8, "bzm_lotusdialogue12callback" },
    { 0xB3F48A25, "bzm_lotusdialogue13callback" },
    { 0xCF7CA25E, "bzm_lotusdialogue14callback" },
    { 0x19D8BBF0, "bzm_lotusdialogue1callback" },
    { 0x731F5DE7, "bzm_lotusdialogue2_1callback" },
    { 0x22E2A260, "bzm_lotusdialogue2_2callback" },
    { 0x235C126D, "bzm_lotusdialogue2_3callback" },
    { 0xB2DC81A6, "bzm_lotusdialogue2_4callback" },
    { 0x0F43E3F7, "bzm_lotusdialogue2callback" },
    { 0xFBEBFBB5, "bzm_lotusdialogue3_2callback" },
    { 0xBDB879CA, "bzm_lotusdialogue3callback" },
    { 0x7285B6D5, "bzm_lotusdialogue4_1callback" },
    { 0x0551BB62, "bzm_lotusdialogue4_2callback" },
    { 0xCBA99BD9, "bzm_lotusdialogue4callback" },
    { 0xBA32E253, "bzm_lotusdialogue6callback" },
    { 0xF16C27E6, "bzm_lotusdialogue7_1callback" },
    { 0xD3562E76, "bzm_lotusdialogue7callback" },
    { 0xF48AF665, "bzm_lotusdialogue8callback" },
    { 0x36848938, "bzm_lotusdialogue9callback" },
    { 0x0911783B, "bzm_newworlddialogue10callback" },
    { 0x700E70FE, "bzm_newworlddialogue11callback" },
    { 0xAACB4541, "bzm_newworlddialogue12callback" },
    { 0xF7D455DF, "bzm_newworlddialogue1callback" },
    { 0xDE05E4EB, "bzm_newworlddialogue2_2callback" },
    { 0xE6B1A7EE, "bzm_newworlddialogue2_3callback" },
    { 0x26086075, "bzm_newworlddialogue2_4callback" },
    { 0x1745DB58, "bzm_newworlddialogue2callback" },
    { 0x9FC39C85, "bzm_newworlddialogue3callback" },
    { 0xD7B589BE, "bzm_newworlddialogue4callback" },
    { 0x2A8A13FB, "bzm_newworlddialogue5callback" },
    { 0x6B7EE624, "bzm_newworlddialogue6callback" },
    { 0xC6980F01, "bzm_newworlddialogue7callback" },
    { 0xB20EEEEA, "bzm_newworlddialogue8callback" },
    { 0x49261F17, "bzm_newworlddialogue9callback" },
    { 0xFD2D1F37, "bzm_overridehealth" },
    { 0xE9D4A03E, "bzm_overridelocomotion" },
    { 0x27FB20E1, "bzm_overridesuicidalchance" },
    { 0xB16D5C40, "bzm_prologuedialogue1callback" },
    { 0x4D823EF7, "bzm_prologuedialogue2_1callback" },
    { 0xA8F1DAC7, "bzm_prologuedialogue2callback" },
    { 0x13EF3F5A, "bzm_prologuedialogue3callback" },
    { 0x57DE23A9, "bzm_prologuedialogue4callback" },
    { 0x8A46D9A0, "bzm_prologuedialogue5_1callback" },
    { 0x9B180D27, "bzm_prologuedialogue5_2callback" },
    { 0x3AFB66BA, "bzm_prologuedialogue5_3callback" },
    { 0xFBA4A2CC, "bzm_prologuedialogue5callback" },
    { 0x5E84772B, "bzm_prologuedialogue6_1callback" },
    { 0x853E9314, "bzm_prologuedialogue6_2callback" },
    { 0x88610BE3, "bzm_prologuedialogue6callback" },
    { 0xD36C1286, "bzm_prologuedialogue7callback" },
    { 0x08265C35, "bzm_prologuedialogue8callback" },
    { 0xAF94F480, "bzm_ramsesdialogue1callback" },
    { 0xD34CC407, "bzm_ramsesdialogue2callback" },
    { 0xA6E609D2, "bzm_ramsesdialogue3_1callback" },
    { 0x71D5E545, "bzm_ramsesdialogue3_2callback" },
    { 0xD2285E9A, "bzm_ramsesdialogue3callback" },
    { 0x4F474E60, "bzm_ramsesdialogue5_1callback" },
    { 0x12F2DB0C, "bzm_ramsesdialogue5callback" },
    { 0x01A96323, "bzm_ramsesdialogue6callback" },
    { 0x0A9B12B6, "bzm_ramsesdialogue7_1callback" },
    { 0x3211F2C6, "bzm_ramsesdialogue7callback" },
    { 0xD6CBAE75, "bzm_ramsesdialogue8callback" },
    { 0x4CB32F3C, "bzm_sceneseqended" },
    { 0xE032F90D, "bzm_sceneseqendedcallback" },
    { 0x18387790, "bzm_sgendialogue1_1callback" },
    { 0x6F535F97, "bzm_sgendialogue1_2callback" },
    { 0xD83C2F6A, "bzm_sgendialogue1_3callback" },
    { 0x9C89F6AE, "bzm_sgendialogue1_3callback_waittill_done" },
    { 0xFBCB62FC, "bzm_sgendialogue1callback" },
    { 0x9DE79DDB, "bzm_sgendialogue2_1callback" },
    { 0x4F37ABD3, "bzm_sgendialogue2callback" },
    { 0x685AF7F6, "bzm_sgendialogue3callback" },
    { 0xE6D6FE31, "bzm_sgendialogue4_1callback" },
    { 0x72CF7C7D, "bzm_sgendialogue4callback" },
    { 0xAEDD8570, "bzm_sgendialogue5callback" },
    { 0xA448AD77, "bzm_sgendialogue6callback" },
    { 0x52BD434A, "bzm_sgendialogue7callback" },
    { 0x847128AD, "bzm_sgendialogue8_1callback" },
    { 0x0723AFBA, "bzm_sgendialogue8_2callback" },
    { 0x3B075261, "bzm_sgendialogue8callback" },
    { 0x649F9C84, "bzm_sgendialogue9callback" },
    { 0x42ED4E79, "bzm_vengeancedialogue1callback" },
    { 0x72EC1FC6, "bzm_vengeancedialogue2_1callback" },
    { 0x46BDF616, "bzm_vengeancedialogue2callback" },
    { 0xA923DC3B, "bzm_vengeancedialogue3_1callback" },
    { 0xDF45F1F3, "bzm_vengeancedialogue3callback" },
    { 0x95299F90, "bzm_vengeancedialogue4callback" },
    { 0x0063599D, "bzm_vengeancedialogue5callback" },
    { 0x1E559CA2, "bzm_vengeancedialogue6_1callback" },
    { 0xC8E36315, "bzm_vengeancedialogue6_2callback" },
    { 0x552D576A, "bzm_vengeancedialogue6callback" },
    { 0x143AB0C7, "bzm_vengeancedialogue7_1callback" },
    { 0xEC448797, "bzm_vengeancedialogue7callback" },
    { 0x0E9D4EA4, "bzm_vengeancedialogue8callback" },
    { 0x69B67781, "bzm_vengeancedialogue9callback" },
    { 0x0203903E, "bzm_waitforstreamerortimeout" },
    { 0xBD7C1855, "bzm_worldpaused" },
    { 0x668CE878, "bzm_zurichdialogue10callback" },
    { 0x405A73A5, "bzm_zurichdialogue11callback" },
    { 0x08B86032, "bzm_zurichdialogue12callback" },
    { 0x4C8D19FF, "bzm_zurichdialogue13callback" },
    { 0xEFABE844, "bzm_zurichdialogue14callback" },
    { 0x1E860021, "bzm_zurichdialogue15callback" },
    { 0x5BE28BDE, "bzm_zurichdialogue16callback" },
    { 0xAEB7161B, "bzm_zurichdialogue17callback" },
    { 0xE564DA30, "bzm_zurichdialogue18callback" },
    { 0x4354053D, "bzm_zurichdialogue19callback" },
    { 0x851372EA, "bzm_zurichdialogue1_1callback" },
    { 0x3049751D, "bzm_zurichdialogue1_2callback" },
    { 0xC50FBB10, "bzm_zurichdialogue1_3callback" },
    { 0x0F2C0D73, "bzm_zurichdialogue1_4callback" },
    { 0x741DEFC2, "bzm_zurichdialogue1callback" },
    { 0x3B0E897D, "bzm_zurichdialogue20callback" },
    { 0x771C9270, "bzm_zurichdialogue21callback" },
    { 0x6C87BA77, "bzm_zurichdialogue22callback" },
    { 0x1AFC504A, "bzm_zurichdialogue23callback" },
    { 0x28ED7259, "bzm_zurichdialogue24callback" },
    { 0xC40A6FFC, "bzm_zurichdialogue25callback" },
    { 0x3A0A2835, "bzm_zurichdialogue2callback" },
    { 0xF3CAEAC8, "bzm_zurichdialogue3callback" },
    { 0x4D62C9E3, "bzm_zurichdialogue4_1callback" },
    { 0x9D5CA0AB, "bzm_zurichdialogue4callback" },
    { 0xAEAF47AE, "bzm_zurichdialogue5callback" },
    { 0x83EE1431, "bzm_zurichdialogue6callback" },
    { 0xC416BC94, "bzm_zurichdialogue7callback" },
    { 0xDAD5A6C7, "bzm_zurichdialogue8callback" },
    { 0x45D30B5A, "bzm_zurichdialogue9callback" },
    { 0x0F22C67B, "bzmloadoutchangecallback" },
    { 0x26432505, "bzmoncybercomoncallback" },
    { 0xDC323706, "bzmstartobjectivecallback" },
    { 0xC4DBA52C, "bzmutil_waitforallzombiestodie" },
    { 0xE8899224, "bzmwaitforobjectivecompletioncallback" },
    { 0xAD66D52C, "c" },
    { 0xC4B9EDB4, "c0" },
    { 0xEABC681D, "c1" },
    { 0x1D351664, "c130" },
    { 0x3C18760C, "c130_crash" },
    { 0xFA8F05A3, "c130_crash_parts" },
    { 0x62C002C3, "c130_dlight" },
    { 0x639ED360, "c130_landing" },
    { 0xD62FCE2D, "c130_propeller_impact" },
    { 0x5A555823, "c130_wing_impact" },
    { 0xC8D94924, "c1_blue" },
    { 0xAAF35302, "c1_blue_diff" },
    { 0xF809D919, "c1_green" },
    { 0x5300F349, "c1_green_diff" },
    { 0xDDD27DE5, "c1_red" },
    { 0xC679DD2D, "c1_red_diff" },
    { 0xBE83529E, "c1a" },
    { 0x1C38DC17, "c1a_02" },
    { 0x714C250E, "c1a_02_render" },
    { 0x55D83819, "c1a_render" },
    { 0x4C7BE363, "c1d" },
    { 0xB70F857C, "c1d_02" },
    { 0xB3CA526B, "c1d_02_render" },
    { 0x54F67D5A, "c1d_render" },
    { 0x10BEE286, "c2" },
    { 0x050F3C99, "c2_blue" },
    { 0xA5343DC9, "c2_blue_diff" },
    { 0x448FA9BA, "c2_green" },
    { 0x690157F0, "c2_green_diff" },
    { 0xB70EBEEA, "c2_red" },
    { 0x6A5B7820, "c2_red_diff" },
    { 0xC8D0607B, "c2a" },
    { 0xAF4F3C6B, "c2a_a" },
    { 0x05450692, "c2a_a_render" },
    { 0x3D47CD30, "c2a_b" },
    { 0xE03A842F, "c2a_b_render" },
    { 0x3AD7CFB6, "c2d" },
    { 0x8FD6F101, "c2d_render" },
    { 0x2CB00410, "c4" },
    { 0xF97254C7, "c4_acquired" },
    { 0xF25A9E37, "c4_ammo_glitch" },
    { 0xEEF99E7B, "c4_area_blocker" },
    { 0x2F883F10, "c4_building_anim_bowman" },
    { 0x40803898, "c4_building_anim_brooks" },
    { 0x33DD8F7C, "c4_building_anim_weaver" },
    { 0x35646F66, "c4_building_anim_woods" },
    { 0x9AC8BA28, "c4_bunker" },
    { 0x1CBEF0AD, "c4_bunker_start" },
    { 0xAD0B7A71, "c4_callback_thread" },
    { 0x6FF1DE3E, "c4_callback_thread_launchfacility" },
    { 0x55F75CA1, "c4_complete_dialog" },
    { 0x4D6B93F4, "c4_count" },
    { 0x414CCD81, "c4_d" },
    { 0xF93D7B75, "c4_detonated" },
    { 0xA81BACC8, "c4_detonation" },
    { 0xAD117AE8, "c4_earthquake" },
    { 0x54EF1C7E, "c4_equiped" },
    { 0xAEA658A8, "c4_equipped" },
    { 0x22714F00, "c4_hint" },
    { 0x831F9A88, "c4_icon_hint" },
    { 0xA66D6286, "c4_in_place" },
    { 0x1BD56E6A, "c4_location" },
    { 0xDA28D336, "c4_model" },
    { 0xDE69AA29, "c4_models" },
    { 0x9B5D681E, "c4_pickup_station" },
    { 0x7D920FDB, "c4_plant_think" },
    { 0x829411F1, "c4_planted" },
    { 0xEC6C1E09, "c4_prompt" },
    { 0x489C4B4C, "c4_react" },
    { 0xD616ADB1, "c4_set" },
    { 0x7D87C962, "c4_set_nag_lines" },
    { 0x8A119F6B, "c4_sound_override" },
    { 0x19A32725, "c4_start" },
    { 0x7F2C4FE0, "c4_target" },
    { 0x286AF25F, "c4_the_car" },
    { 0x29E92933, "c4_throw_hint" },
    { 0x2F25CCE1, "c4_thrown" },
    { 0xC864EA5D, "c4_training" },
    { 0x8BC6EA39, "c4_trig" },
    { 0xF3116055, "c4_underwater_fog" },
    { 0xD65F9CDB, "c4_weapon" },
    { 0xABA925C3, "c4activate" },
    { 0xC655A6B0, "c4angles" },
    { 0xF1DBE097, "c4array" },
    { 0x8ABC174D, "c4count" },
    { 0x99ECE333, "c4damage" },
    { 0xB946A756, "c4death" },
    { 0x788603BF, "c4detectiontrigger" },
    { 0xC62CFB16, "c4explodethisframe" },
    { 0x45E4F9C9, "c4fxid" },
    { 0xEADDACF6, "c4hackertoolradius" },
    { 0xADD7D1CB, "c4hackertooltimems" },
    { 0xEDC5F1DC, "c4holepiece" },
    { 0x8FDF9B7A, "c4holepieceorigin" },
    { 0x5979062F, "c4obj" },
    { 0xB8AE759A, "c4org" },
    { 0x52B27E79, "c5" },
    { 0x2046F9D8, "c5_approach" },
    { 0x1CA56F44, "c5_nose_crash_guys" },
    { 0x26FCD6D8, "c5_nose_knockdown" },
    { 0x36A782B3, "c5_nose_knockdown_done" },
    { 0x8DF647A9, "c5_spawner_trigger" },
    { 0xBA917BC8, "c_afg_muhaj_body1_als" },
    { 0x22A530C4, "c_afg_muhaj_body1_gear_als" },
    { 0xA5343B43, "c_afg_muhaj_body1_head_als" },
    { 0x19BF665F, "c_afg_muhaj_body2_als" },
    { 0x96A65D59, "c_afg_muhaj_body2_gear_als" },
    { 0x3A9D3D0E, "c_afg_muhaj_body2_head_als" },
    { 0x800DC2E9, "c_afg_mujadeen_1" },
    { 0xF7B8D3A6, "c_afg_mujadeen_1_1_gib" },
    { 0xBCB8D871, "c_afg_mujadeen_1_2_gib" },
    { 0x64524C14, "c_afg_mujadeen_1_3_gib" },
    { 0x1809AECD, "c_afg_mujadeen_1_a" },
    { 0x3E0C2936, "c_afg_mujadeen_1_b" },
    { 0x640EA39F, "c_afg_mujadeen_1_c" },
    { 0xA6103D52, "c_afg_mujadeen_2" },
    { 0x2B4EC7B5, "c_afg_mujadeen_2_1_gib" },
    { 0x1F2C748A, "c_afg_mujadeen_2_2_gib" },
    { 0x213EA7B7, "c_afg_mujadeen_2_3_gib" },
    { 0xB8164922, "c_afg_mullah_omar_cin" },
    { 0xC7E7E889, "c_afg_nomad" },
    { 0x9B1B09E7, "c_afr_childsoldier_1" },
    { 0x29139AAC, "c_afr_childsoldier_2" },
    { 0x4F161515, "c_afr_childsoldier_3" },
    { 0xD13C1DE9, "c_afr_mpla_1" },
    { 0xF73E9852, "c_afr_mpla_2" },
    { 0x8DFB6A52, "c_afr_mpla_body1_gear_als" },
    { 0x73192B63, "c_afr_mpla_body2_gear_als" },
    { 0xF4D19956, "c_afr_mpla_drone" },
    { 0xE6B8C4A1, "c_afr_mpla_drone_als" },
    { 0xE5FCAE01, "c_afr_mpla_drone_rigid_als" },
    { 0x1B4FB5D9, "c_afr_mpla_drone_rigid_wgun_als" },
    { 0xDA1AFEE1, "c_afr_mpla_head_als" },
    { 0xBD1BA068, "c_afr_mpla_headgear_als" },
    { 0xA3F67B1A, "c_afr_mpla_rigid_drone" },
    { 0x977FA0F2, "c_afr_mpla_rigid_drone_wgun" },
    { 0xC6432C22, "c_afr_savimbi" },
    { 0x2D921E45, "c_afr_unitas_1" },
    { 0x539498AE, "c_afr_unitas_2" },
    { 0xFA636185, "c_afr_unitas_2_burned" },
    { 0x137BF7BE, "c_afr_unitas_gear_als" },
    { 0xDB82A72C, "c_afr_unitas_hat_als" },
    { 0x373620D5, "c_afr_unitas_head_als" },
    { 0x8AADFF67, "c_anims" },
    { 0x64DB20CD, "c_brt_fullahead_drone" },
    { 0xFA0CE7B9, "c_brt_fullahead_soldier" },
    { 0x8370AEFB, "c_buried_player_reporter_dam" },
    { 0x186CA732, "c_chn_afghan_zhao_beatup_cin" },
    { 0x884B7D64, "c_chn_afghan_zhao_cin" },
    { 0x0DA6BF26, "c_chn_afghan_zhaosmen_1" },
    { 0xE7A444BD, "c_chn_afghan_zhaosmen_2" },
    { 0xC1A1CA54, "c_chn_afghan_zhaosmen_3" },
    { 0x22295E43, "c_chn_oldgeneral_zhao" },
    { 0x13792AB4, "c_chn_pla" },
    { 0x1C6385B0, "c_chn_pla_assault" },
    { 0x80215151, "c_chn_pla_gear_als" },
    { 0xD5D66956, "c_chn_pla_head_als" },
    { 0xF6BEECC4, "c_chn_pla_nogib" },
    { 0xFEE1B3EC, "c_container" },
    { 0x45FCCEEF, "c_cub_carlos_battle" },
    { 0x883AD342, "c_cub_carlos_casual" },
    { 0x9F5DEDC3, "c_cub_castro_jacket" },
    { 0xB812C563, "c_cub_castro_shirt" },
    { 0xA2968063, "c_cub_castro_zt" },
    { 0x40E72DA0, "c_cub_civilians" },
    { 0x0BCBBF32, "c_cub_civilians_hatalias" },
    { 0xFB2B553F, "c_cub_civilians_headalias" },
    { 0x7759ABDA, "c_cub_civilians_loweralias" },
    { 0x4D0736DB, "c_cub_civilians_upperalias" },
    { 0x0E06A267, "c_cub_dancer" },
    { 0xAE4C1944, "c_cub_police_1" },
    { 0x2053887F, "c_cub_police_2" },
    { 0xFA510E16, "c_cub_police_3" },
    { 0x67049367, "c_cub_prostitute" },
    { 0xC8A5EED9, "c_cub_rebels_1" },
    { 0xEEA86942, "c_cub_rebels_2" },
    { 0x14AAE3AB, "c_cub_rebels_3" },
    { 0xE683108D, "c_cub_rebels_hatalias" },
    { 0xB0FAB6D5, "c_cub_tropas_1" },
    { 0xD6FD313E, "c_cub_tropas_2" },
    { 0xFCFFABA7, "c_cub_tropas_3" },
    { 0xF2EE52C8, "c_cub_tropas_4" },
    { 0x18F0CD31, "c_cub_tropas_5" },
    { 0x2525BB52, "c_cub_tropas_drone" },
    { 0x2F8219FB, "c_cub_tropas_gearalias" },
    { 0x38BE1B03, "c_data" },
    { 0x7B6B132E, "c_data_00" },
    { 0x000EE677, "c_door" },
    { 0x12FC0F88, "c_flags" },
    { 0x580EC0B1, "c_ger_honorguard_zomb_bodyalias" },
    { 0x9E3230D6, "c_ger_honorguard_zomb_bodyalias_zt" },
    { 0x7383C743, "c_ger_honorguard_zomb_headalias" },
    { 0x6C0E3584, "c_ger_honorguard_zomb_headalias_zt" },
    { 0x5380B527, "c_ger_honorguard_zombietron" },
    { 0x457CB29E, "c_ger_honorguard_zt" },
    { 0x7EA6E6ED, "c_ger_infantry" },
    { 0x16B26154, "c_ger_infantry_char" },
    { 0x0E04A0BE, "c_ger_infantry_frozen" },
    { 0xC49D8AFE, "c_ger_infantry_frozen_head_alias" },
    { 0x9B1B73A3, "c_ger_infantry_head_alias" },
    { 0x6C8ED864, "c_ger_infantry_head_char_alias" },
    { 0xE077177C, "c_ger_infantry_hung" },
    { 0x98C29C70, "c_ger_infantry_nogear" },
    { 0x42066D8D, "c_ger_officer_frozen" },
    { 0xF374E4AC, "c_ger_richtofen_dlc4" },
    { 0x19775F15, "c_ger_richtofen_dlc5" },
    { 0xD160C226, "c_ger_richtofen_zm" },
    { 0xC74F6947, "c_ger_richtofen_zt" },
    { 0x0CBF7207, "c_ger_steiner_fullahead" },
    { 0x8B6BA1F4, "c_ger_steiner_interrogation" },
    { 0xBD93490B, "c_ger_steiner_rebirth" },
    { 0xEF120E44, "c_highrise_player_engineer" },
    { 0xE41A8BD1, "c_highrise_player_farmgirl" },
    { 0xD176E002, "c_highrise_player_oldman" },
    { 0x6EB5EAD4, "c_highrise_player_reporter" },
    { 0x021CE2F5, "c_index" },
    { 0x622422B9, "c_jap_takeo_dlc4" },
    { 0x3C21A850, "c_jap_takeo_dlc5" },
    { 0x3CEDA5EF, "c_jap_takeo_zm" },
    { 0xE6D7583E, "c_jap_takeo_zt" },
    { 0x0CECDDBA, "c_moss_zt" },
    { 0xAB903514, "c_mul_al_jinan_receptionist" },
    { 0xAE2DAF75, "c_mul_al_jinan_receptionist1" },
    { 0xD43029DE, "c_mul_al_jinan_receptionist2" },
    { 0x4E0182CF, "c_mul_cartel1_1_char" },
    { 0x7D1D2332, "c_mul_cartel1_2_char" },
    { 0x6728B0C9, "c_mul_cartel1_3_char" },
    { 0x23024545, "c_mul_cartel_gear_char_als" },
    { 0x52721400, "c_mul_cartel_head_char_als" },
    { 0xE4C9CBD0, "c_mul_civ_club_bra_pants" },
    { 0xB470D293, "c_mul_civ_club_bra_pants_als" },
    { 0x975000F4, "c_mul_civ_club_female_head_als" },
    { 0x0AB8CAE4, "c_mul_civ_club_female_light1" },
    { 0xE55E589C, "c_mul_civ_club_female_light10" },
    { 0x7CC03A1F, "c_mul_civ_club_female_light2" },
    { 0x56BDBFB6, "c_mul_civ_club_female_light3" },
    { 0xE4B6507B, "c_mul_civ_club_female_light6" },
    { 0xBEB3D612, "c_mul_civ_club_female_light7" },
    { 0xE0C03D61, "c_mul_civ_club_female_lt10_als" },
    { 0x879D9FED, "c_mul_civ_club_female_lt1_als" },
    { 0x0B91465A, "c_mul_civ_club_female_lt2_als" },
    { 0x09BA9B13, "c_mul_civ_club_female_lt3_als" },
    { 0x274D95FE, "c_mul_civ_club_female_lt6_als" },
    { 0x8B10C817, "c_mul_civ_club_female_lt7_als" },
    { 0xF5B5CF9D, "c_mul_civ_club_female_lt_head_als" },
    { 0xA7ABEA7D, "c_mul_civ_club_long_dress1" },
    { 0xDEEB425E, "c_mul_civ_club_long_dress1_als" },
    { 0xCDAE64E6, "c_mul_civ_club_long_dress2" },
    { 0x52AE59B1, "c_mul_civ_club_long_dress2_als" },
    { 0xF3B0DF4F, "c_mul_civ_club_long_dress3" },
    { 0xFBCC6C40, "c_mul_civ_club_long_dress3_als" },
    { 0xE99F8670, "c_mul_civ_club_long_dress4" },
    { 0x9C6DDFF3, "c_mul_civ_club_long_dress4_als" },
    { 0x4AA8A331, "c_mul_civ_club_male_head_als" },
    { 0x9EB57C80, "c_mul_civ_club_male_jckt_drsh" },
    { 0xF67CEC43, "c_mul_civ_club_male_jckt_drsh_als" },
    { 0x5978947E, "c_mul_civ_club_male_jckt_drsh_h1" },
    { 0x33761A15, "c_mul_civ_club_male_jckt_drsh_h2" },
    { 0x0D739FAC, "c_mul_civ_club_male_jckt_drsh_h3" },
    { 0xE7712543, "c_mul_civ_club_male_jckt_drsh_h4" },
    { 0xC16EAADA, "c_mul_civ_club_male_jckt_drsh_h5" },
    { 0x9B6C3071, "c_mul_civ_club_male_jckt_drsh_h6" },
    { 0xCD1BF4FD, "c_mul_civ_club_male_jckt_drsh_vst_als" },
    { 0x9B698766, "c_mul_civ_club_male_jckt_rld_drsh_als" },
    { 0x19DDBCA5, "c_mul_civ_club_male_jckt_rld_ts" },
    { 0xD77A1566, "c_mul_civ_club_male_jckt_rld_ts_als" },
    { 0x85164C59, "c_mul_civ_club_male_jckt_rld_ts_h1" },
    { 0xAB18C6C2, "c_mul_civ_club_male_jckt_rld_ts_h2" },
    { 0xD11B412B, "c_mul_civ_club_male_jckt_rld_ts_h3" },
    { 0xF71DBB94, "c_mul_civ_club_male_jckt_rld_ts_h4" },
    { 0x1D2035FD, "c_mul_civ_club_male_jckt_rld_ts_h5" },
    { 0x4322B066, "c_mul_civ_club_male_jckt_rld_ts_h6" },
    { 0x155C9598, "c_mul_civ_club_male_jckt_ts" },
    { 0x1FCD08FB, "c_mul_civ_club_male_jckt_ts_als" },
    { 0xCD78CF06, "c_mul_civ_club_male_jckt_ts_h1" },
    { 0xA776549D, "c_mul_civ_club_male_jckt_ts_h2" },
    { 0x8173DA34, "c_mul_civ_club_male_jckt_ts_h3" },
    { 0x5B715FCB, "c_mul_civ_club_male_jckt_ts_h4" },
    { 0x356EE562, "c_mul_civ_club_male_jckt_ts_h5" },
    { 0x0F6C6AF9, "c_mul_civ_club_male_jckt_ts_h6" },
    { 0x41443E45, "c_mul_civ_club_male_jckt_ts_vst_als" },
    { 0x07334D4D, "c_mul_civ_club_male_light1" },
    { 0x02EA56C7, "c_mul_civ_club_male_light10" },
    { 0xDCE7DC5E, "c_mul_civ_club_male_light11" },
    { 0xB6E561F5, "c_mul_civ_club_male_light12" },
    { 0x4926E940, "c_mul_civ_club_male_light4" },
    { 0xBB2E587B, "c_mul_civ_club_male_light7" },
    { 0x1144A62C, "c_mul_civ_club_male_light8" },
    { 0x37472095, "c_mul_civ_club_male_light9" },
    { 0x89579DAF, "c_mul_civ_club_male_ls" },
    { 0x0BE096E0, "c_mul_civ_club_male_ls_als" },
    { 0xF5F7252B, "c_mul_civ_club_male_ls_h1" },
    { 0x83EFB5F0, "c_mul_civ_club_male_ls_h2" },
    { 0xA9F23059, "c_mul_civ_club_male_ls_h3" },
    { 0x67FE9466, "c_mul_civ_club_male_ls_h4" },
    { 0x8E010ECF, "c_mul_civ_club_male_ls_h5" },
    { 0x1BF99F94, "c_mul_civ_club_male_ls_h6" },
    { 0x166B376D, "c_mul_civ_club_male_ls_vst" },
    { 0x4C8F55CE, "c_mul_civ_club_male_ls_vst_als" },
    { 0xE1898BD1, "c_mul_civ_club_male_ls_vst_h1" },
    { 0x078C063A, "c_mul_civ_club_male_ls_vst_h2" },
    { 0x2D8E80A3, "c_mul_civ_club_male_ls_vst_h3" },
    { 0x5390FB0C, "c_mul_civ_club_male_ls_vst_h4" },
    { 0x79937575, "c_mul_civ_club_male_ls_vst_h5" },
    { 0x9F95EFDE, "c_mul_civ_club_male_ls_vst_h6" },
    { 0x8D3CF40C, "c_mul_civ_club_male_lt10_als" },
    { 0x487B97FD, "c_mul_civ_club_male_lt11_als" },
    { 0x39C091AA, "c_mul_civ_club_male_lt12_als" },
    { 0x7CE7484A, "c_mul_civ_club_male_lt1_als" },
    { 0x090AD81D, "c_mul_civ_club_male_lt2_als" },
    { 0x50469D2C, "c_mul_civ_club_male_lt3_als" },
    { 0x9B654AC7, "c_mul_civ_club_male_lt4_als" },
    { 0x59380FEE, "c_mul_civ_club_male_lt5_als" },
    { 0x7BE81310, "c_mul_civ_club_male_lt7_als" },
    { 0xB52467AB, "c_mul_civ_club_male_lt8_als" },
    { 0xF5F23B52, "c_mul_civ_club_male_lt9_als" },
    { 0x56362352, "c_mul_civ_club_male_lt_head_als" },
    { 0x23E02564, "c_mul_civ_club_male_ms" },
    { 0xFF25E6C7, "c_mul_civ_club_male_ms_als" },
    { 0x68B35932, "c_mul_civ_club_male_ms_h1" },
    { 0x42B0DEC9, "c_mul_civ_club_male_ms_h2" },
    { 0x1CAE6460, "c_mul_civ_club_male_ms_h3" },
    { 0x26BFBD3F, "c_mul_civ_club_male_ms_h4" },
    { 0x00BD42D6, "c_mul_civ_club_male_ms_h5" },
    { 0xDABAC86D, "c_mul_civ_club_male_ms_h6" },
    { 0xF568665E, "c_mul_civ_club_male_ms_vst" },
    { 0x498E62C9, "c_mul_civ_club_male_ms_vst_als" },
    { 0x75304BD4, "c_mul_civ_club_male_ms_vst_h1" },
    { 0xE737BB0F, "c_mul_civ_club_male_ms_vst_h2" },
    { 0xC13540A6, "c_mul_civ_club_male_ms_vst_h3" },
    { 0x0328DC99, "c_mul_civ_club_male_ms_vst_h4" },
    { 0xDD266230, "c_mul_civ_club_male_ms_vst_h5" },
    { 0x4F2DD16B, "c_mul_civ_club_male_ms_vst_h6" },
    { 0xAFFE5BF4, "c_mul_civ_club_male_rld_ds_vst" },
    { 0xB8958E17, "c_mul_civ_club_male_rld_ds_vst_als" },
    { 0xFB900362, "c_mul_civ_club_male_rld_ds_vst_h1" },
    { 0xD58D88F9, "c_mul_civ_club_male_rld_ds_vst_h2" },
    { 0xAF8B0E90, "c_mul_civ_club_male_rld_ds_vst_h3" },
    { 0xB99C676F, "c_mul_civ_club_male_rld_ds_vst_h4" },
    { 0x9399ED06, "c_mul_civ_club_male_rld_ds_vst_h5" },
    { 0x6D97729D, "c_mul_civ_club_male_rld_ds_vst_h6" },
    { 0xC03DEAE7, "c_mul_civ_club_male_ts" },
    { 0x16AF93B8, "c_mul_civ_club_male_ts_als" },
    { 0x97A3B945, "c_mul_civ_club_short_dress1" },
    { 0xF7A355C6, "c_mul_civ_club_short_dress1_als" },
    { 0xBDA633AE, "c_mul_civ_club_short_dress2" },
    { 0x0A289999, "c_mul_civ_club_short_dress2_als" },
    { 0xE3A8AE17, "c_mul_civ_club_short_dress3" },
    { 0x9CBEFDE8, "c_mul_civ_club_short_dress3_als" },
    { 0xD9975538, "c_mul_civ_club_short_dress4" },
    { 0x064F6BDB, "c_mul_civ_club_short_dress4_als" },
    { 0x13EBED30, "c_mul_civ_club_skirt_pants" },
    { 0xAAB771B3, "c_mul_civ_club_skirt_pants_als" },
    { 0x6B197C87, "c_mul_civ_club_skirt_pants_sil_model" },
    { 0xF559D0F3, "c_mul_civ_cworker_female_1" },
    { 0x835261B8, "c_mul_civ_cworker_female_2" },
    { 0x08608D24, "c_mul_civ_cworker_male_1" },
    { 0x7A67FC5F, "c_mul_civ_cworker_male_2" },
    { 0x546581F6, "c_mul_civ_cworker_male_3" },
    { 0xC878C83A, "c_mul_civ_cwrkr_female_body1_als" },
    { 0x8A10E7CD, "c_mul_civ_cwrkr_female_body2_als" },
    { 0xA34D586D, "c_mul_civ_cwrkr_female_head_als" },
    { 0x5E5C9615, "c_mul_civ_cwrkr_male_body1_als" },
    { 0x8F15EE62, "c_mul_civ_cwrkr_male_body2_als" },
    { 0xD143293B, "c_mul_civ_cwrkr_male_body3_als" },
    { 0x13BE890C, "c_mul_civ_cwrkr_male_head_als" },
    { 0xA87234E9, "c_mul_civ_gen_female_body10_als" },
    { 0x61B816C5, "c_mul_civ_gen_female_body1_als" },
    { 0x255C7012, "c_mul_civ_gen_female_body2_als" },
    { 0x9C886D6B, "c_mul_civ_gen_female_body3_als" },
    { 0x19AB4A78, "c_mul_civ_gen_female_body4_als" },
    { 0xEBBC3A69, "c_mul_civ_gen_female_body5_als" },
    { 0x8B9B6756, "c_mul_civ_gen_female_body6_als" },
    { 0xD9DAB44F, "c_mul_civ_gen_female_body7_als" },
    { 0x63E9B3EC, "c_mul_civ_gen_female_body8_als" },
    { 0x0C35FBDD, "c_mul_civ_gen_female_body9_als" },
    { 0x94723BF8, "c_mul_civ_gen_male_upper10_als" },
    { 0x66832BE9, "c_mul_civ_gen_male_upper11_als" },
    { 0x066258D6, "c_mul_civ_gen_male_upper12_als" },
    { 0x248D298E, "c_mul_civ_gen_male_upper1_als" },
    { 0x30CDC6E1, "c_mul_civ_gen_male_upper2_als" },
    { 0x6089E1B0, "c_mul_civ_gen_male_upper3_als" },
    { 0x2CF49923, "c_mul_civ_gen_male_upper4_als" },
    { 0x483C61EA, "c_mul_civ_gen_male_upper5_als" },
    { 0x2803D33D, "c_mul_civ_gen_male_upper6_als" },
    { 0x6F3F984C, "c_mul_civ_gen_male_upper7_als" },
    { 0x0EF540AF, "c_mul_civ_gen_male_upper8_als" },
    { 0xC0B5F3B6, "c_mul_civ_gen_male_upper9_als" },
    { 0x3EAC9208, "c_mul_civ_generic_female_sil" },
    { 0xE27119E6, "c_mul_civ_generic_male_10" },
    { 0x0873944F, "c_mul_civ_generic_male_11" },
    { 0x966C2514, "c_mul_civ_generic_male_12" },
    { 0xA7886F84, "c_mul_civ_generic_male_7" },
    { 0xB199C863, "c_mul_civ_generic_male_8" },
    { 0x8B974DFA, "c_mul_civ_generic_male_9" },
    { 0xEF47DFDD, "c_mul_civ_haitian_boy1" },
    { 0xB452FB15, "c_mul_civ_haitian_girl1" },
    { 0x60020DB0, "c_mul_civ_rich_female_1" },
    { 0xD2097CEB, "c_mul_civ_rich_female_2" },
    { 0xAC070282, "c_mul_civ_rich_female_3" },
    { 0x1E0E71BD, "c_mul_civ_rich_female_4" },
    { 0xF80BF754, "c_mul_civ_rich_female_5" },
    { 0xCEE7DDFE, "c_mul_civ_rich_female_clothes_als" },
    { 0x9E703A23, "c_mul_civ_rich_female_shot_1" },
    { 0x2C68CAE8, "c_mul_civ_rich_female_shot_2" },
    { 0x526B4551, "c_mul_civ_rich_female_shot_3" },
    { 0x1077A95E, "c_mul_civ_rich_female_shot_4" },
    { 0x367A23C7, "c_mul_civ_rich_female_shot_5" },
    { 0xACA40D01, "c_mul_civ_rich_female_shot_clothes_als" },
    { 0x1A518674, "c_mul_civ_rich_female_soot_1" },
    { 0x8C58F5AF, "c_mul_civ_rich_female_soot_2" },
    { 0x66567B46, "c_mul_civ_rich_female_soot_3" },
    { 0xA84A1739, "c_mul_civ_rich_female_soot_4" },
    { 0x82479CD0, "c_mul_civ_rich_female_soot_5" },
    { 0xFD6BD242, "c_mul_civ_rich_female_soot_clothes_als" },
    { 0x773EB653, "c_mul_civ_rich_male_1" },
    { 0x843BEA48, "c_mul_civ_rich_male_1_2" },
    { 0x05374718, "c_mul_civ_rich_male_2" },
    { 0x2E7CEE1F, "c_mul_civ_rich_male_2_2" },
    { 0x2B39C181, "c_mul_civ_rich_male_3" },
    { 0x6958776E, "c_mul_civ_rich_male_3_2" },
    { 0xF9BA033E, "c_mul_civ_rich_male_asn_upper2_als" },
    { 0x0932FC26, "c_mul_civ_rich_male_asn_upper_als" },
    { 0x82FF8FA3, "c_mul_civ_rich_male_blk_upper2_als" },
    { 0xFDC63E21, "c_mul_civ_rich_male_blk_upper_als" },
    { 0x3F550C2F, "c_mul_civ_rich_male_head_als" },
    { 0x6977C2C6, "c_mul_civ_rich_male_lower_als" },
    { 0x44E8C6B6, "c_mul_civ_rich_male_shot_1" },
    { 0x56E640AD, "c_mul_civ_rich_male_shot_1_2" },
    { 0x1EE64C4D, "c_mul_civ_rich_male_shot_2" },
    { 0xFBA502C2, "c_mul_civ_rich_male_shot_2_2" },
    { 0xF8E3D1E4, "c_mul_civ_rich_male_shot_3" },
    { 0x8118C693, "c_mul_civ_rich_male_shot_3_2" },
    { 0xFC6DA7E0, "c_mul_civ_rich_male_shot_asn_up2_als" },
    { 0xF5425CB0, "c_mul_civ_rich_male_shot_asn_up_als" },
    { 0x5B280CEF, "c_mul_civ_rich_male_shot_blk_up2_als" },
    { 0x6AA6E0E5, "c_mul_civ_rich_male_shot_blk_up_als" },
    { 0x25B06FA8, "c_mul_civ_rich_male_shot_head_als" },
    { 0xA82D8817, "c_mul_civ_rich_male_shot_lower_als" },
    { 0xD6CBB593, "c_mul_civ_rich_male_shot_up2_als" },
    { 0xA7AFE051, "c_mul_civ_rich_male_shot_up_als" },
    { 0x06FADC61, "c_mul_civ_rich_male_soot_1" },
    { 0x877CA30E, "c_mul_civ_rich_male_soot_1_2" },
    { 0x2CFD56CA, "c_mul_civ_rich_male_soot_2" },
    { 0xB05222D9, "c_mul_civ_rich_male_soot_2_2" },
    { 0x52FFD133, "c_mul_civ_rich_male_soot_3" },
    { 0xA39D4A68, "c_mul_civ_rich_male_soot_3_2" },
    { 0x03E852B3, "c_mul_civ_rich_male_soot_asn_up2_als" },
    { 0x3F895771, "c_mul_civ_rich_male_soot_asn_up_als" },
    { 0xFFD23550, "c_mul_civ_rich_male_soot_blk_up2_als" },
    { 0x5D0AF9A0, "c_mul_civ_rich_male_soot_blk_up_als" },
    { 0xE091A278, "c_mul_civ_rich_male_soot_lower_als" },
    { 0xD4726BB0, "c_mul_civ_rich_male_soot_up2_als" },
    { 0x4C3B9E00, "c_mul_civ_rich_male_soot_up_als" },
    { 0xE1F9FB77, "c_mul_civ_rich_male_upper2_als" },
    { 0x14F1B67D, "c_mul_civ_rich_male_upper_als" },
    { 0x509BF0C3, "c_mul_cordis1_1" },
    { 0xDE948188, "c_mul_cordis1_2" },
    { 0x0496FBF1, "c_mul_cordis1_3" },
    { 0xC2A35FFE, "c_mul_cordis1_4" },
    { 0x301ACB24, "c_mul_cordis2_1" },
    { 0xA2223A5F, "c_mul_cordis2_2" },
    { 0x7C1FBFF6, "c_mul_cordis2_3" },
    { 0xBE135BE9, "c_mul_cordis2_4" },
    { 0xB6FB4945, "c_mul_cordis3_1" },
    { 0xE90F87C0, "c_mul_cordis_head_als" },
    { 0x37064FD8, "c_mul_cuban_forces_1" },
    { 0xA90DBF13, "c_mul_cuban_forces_2" },
    { 0x830B44AA, "c_mul_cuban_forces_3" },
    { 0x9B283221, "c_mul_cuban_forces_gear_als" },
    { 0xA1745B64, "c_mul_defalco_karma_cin" },
    { 0xBA5C0F28, "c_mul_defalco_seal6" },
    { 0x435F378B, "c_mul_farid_cc" },
    { 0x5DAD2965, "c_mul_farid_yemen" },
    { 0x8647B905, "c_mul_gangla_drone_heavy" },
    { 0x16A42186, "c_mul_gangla_drone_heavy_als" },
    { 0x5203F9D4, "c_mul_gangla_drone_light" },
    { 0xEE8C10B7, "c_mul_gangla_drone_light_als" },
    { 0xA6C499D4, "c_mul_gangla_heavy_head_als" },
    { 0xFCA6977B, "c_mul_gangla_light_head_als" },
    { 0x616827BD, "c_mul_jinan_baghandler" },
    { 0x6845FEC1, "c_mul_jinan_baghandler_head_als" },
    { 0xD61F622F, "c_mul_jinan_bouncer" },
    { 0x7F618617, "c_mul_jinan_bouncer_a" },
    { 0x0D5A16DC, "c_mul_jinan_bouncer_b" },
    { 0x335C9145, "c_mul_jinan_bouncer_c" },
    { 0xD31794CB, "c_mul_jinan_bouncer_head_als" },
    { 0x36C3EA19, "c_mul_jinan_captain" },
    { 0xEF2BF15D, "c_mul_jinan_captain_head_als" },
    { 0x54CD69AD, "c_mul_jinan_demoworker_bscatter_off" },
    { 0xC1987D5D, "c_mul_jinan_genworker" },
    { 0x478F6539, "c_mul_jinan_genworker_a" },
    { 0x6D91DFA2, "c_mul_jinan_genworker_b" },
    { 0x93945A0B, "c_mul_jinan_genworker_c" },
    { 0x52365E61, "c_mul_jinan_genworker_head_als" },
    { 0xC80D0452, "c_mul_jinan_guard" },
    { 0x6E5A1271, "c_mul_jinan_guard_2" },
    { 0x48579808, "c_mul_jinan_guard_3" },
    { 0x754D024F, "c_mul_jinan_guard_bscatter_off" },
    { 0x40A52C64, "c_mul_jinan_guard_head_als" },
    { 0xAD6BDFC3, "c_mul_jinan_it_highres" },
    { 0xBC99FA6F, "c_mul_jinan_neomarx_1" },
    { 0x21D9330B, "c_mul_jinan_neomarx_1_head_als" },
    { 0x4A928B34, "c_mul_jinan_neomarx_2" },
    { 0xCF4D02D6, "c_mul_jinan_neomarx_2_head_als" },
    { 0x92AD6055, "c_mul_jinan_neomarx_bot_crush" },
    { 0x810A406E, "c_mul_josefina_scrd" },
    { 0xF73E7F6B, "c_mul_menendez_drugged" },
    { 0xF82CD7DF, "c_mul_menendez_old_captured" },
    { 0x9EA326EC, "c_mul_menendez_old_seal6" },
    { 0x790F25D0, "c_mul_menendez_suit" },
    { 0x4C6C3449, "c_mul_menendez_young" },
    { 0x8270D323, "c_mul_menendez_young_scar" },
    { 0x18F0576E, "c_mul_menendez_young_scar_flipped" },
    { 0x575CF709, "c_mul_menendez_young_scar_rage" },
    { 0x1A6C86E2, "c_mul_neomarx_la_heavy" },
    { 0x03C9FFFF, "c_mul_neomarx_la_light" },
    { 0x2243A56C, "c_mul_neomarx_la_medium" },
    { 0x3911953E, "c_mul_pmc_1" },
    { 0xE80BD1B0, "c_mul_pmc_1_freeze" },
    { 0x950077EC, "c_mul_pmc_1_ol" },
    { 0xABF24EBC, "c_mul_pmc_1_wt" },
    { 0xB6247B54, "c_mul_pmc_assault_frst" },
    { 0xF975601B, "c_mul_pmc_body1_gear_als" },
    { 0xF50594E4, "c_mul_pmc_body1_gear_fr_als" },
    { 0x21CC51BD, "c_mul_pmc_body1_gear_ol_als" },
    { 0x313FA3CD, "c_mul_pmc_body1_gear_wt_als" },
    { 0xF9B5ED88, "c_mul_pmc_body1_head_als" },
    { 0xB8E36EBD, "c_mul_pmc_body1_head_fr_als" },
    { 0xD25EDD20, "c_mul_pmc_body1_head_ol_als" },
    { 0xA23D3A90, "c_mul_pmc_body1_head_wt_als" },
    { 0xE8544F1F, "c_mul_pmc_cloak" },
    { 0xB96AB147, "c_mul_pmc_cloak_wt" },
    { 0xA614DDAD, "c_mul_pmc_drone_1" },
    { 0x11B6AC42, "c_mul_pmc_head_1_" },
    { 0x4C0C30FD, "c_mul_pmc_rigid_drone_1" },
    { 0xEAB2A2C6, "c_mul_pmc_undercover_a" },
    { 0x12E82B7B, "c_mul_pmc_undercover_gear_als" },
    { 0xAF1CCCDD, "c_mul_pmc_undercover_gear_ol_als" },
    { 0x7537E640, "c_mul_pmc_undercover_head_ol_als" },
    { 0x63E7A204, "c_mul_pmc_undercover_ol" },
    { 0x2B539F46, "c_mul_redcross_doctor1" },
    { 0x055124DD, "c_mul_redcross_doctor2" },
    { 0xE0BA7D43, "c_mul_redcross_nurse" },
    { 0xD27C1163, "c_mul_redcross_nurse_wnded_body" },
    { 0x89E8E01A, "c_mul_scientist_issac" },
    { 0x0459A873, "c_mul_scientists_1" },
    { 0x92523938, "c_mul_scientists_2" },
    { 0xB854B3A1, "c_mul_scientists_3" },
    { 0x766117AE, "c_mul_scientists_4" },
    { 0x43C4BD9D, "c_mul_scientists_shirt_als" },
    { 0x71BF5212, "c_mul_scientists_shirt_asn_als" },
    { 0x58F78259, "c_mul_scientists_shirt_blk_als" },
    { 0x87DBBAA7, "c_mul_vtol_pilot1" },
    { 0x15D44B6C, "c_mul_vtol_pilot2" },
    { 0xB4AA75C9, "c_mul_yemen_defalco" },
    { 0x0D9A710C, "c_overseer" },
    { 0x70065E4E, "c_pak_civ_male_1" },
    { 0x4A03E3E5, "c_pak_civ_male_2" },
    { 0x7C93A331, "c_pak_civ_male_body1_als" },
    { 0x08D08BDE, "c_pak_civ_male_body2_als" },
    { 0x91A8ABE1, "c_pak_civ_male_heads_als" },
    { 0x1A9886E9, "c_pak_isi_1_char_wet" },
    { 0x9B13C876, "c_pak_isi_1_char_wet_millibar" },
    { 0x2B10F96C, "c_pak_isi_2_char_wet" },
    { 0x138771C1, "c_pak_isi_2_char_wet_millibar" },
    { 0xDBBF098B, "c_pak_isi_3_char_wet" },
    { 0xF3C82488, "c_pak_isi_3_char_wet_millibar" },
    { 0x0846390B, "c_pak_isi_head_char_wet_als" },
    { 0xA8FD732B, "c_pak_isi_head_char_wet_m_als" },
    { 0x37B9D237, "c_pak_isi_leader" },
    { 0x6C6C4FDC, "c_pak_isi_leader_millibar" },
    { 0xD81617F6, "c_pan_civ_female_1" },
    { 0xB2139D8D, "c_pan_civ_female_2" },
    { 0x5943FDB9, "c_pan_civ_female_body1_als" },
    { 0x46BEB9E6, "c_pan_civ_female_body2_als" },
    { 0xAF316A68, "c_pan_civ_female_head_als" },
    { 0x776517A5, "c_pan_civ_male_1" },
    { 0x35C7CA96, "c_pan_civ_male_1_mov" },
    { 0x9D67920E, "c_pan_civ_male_2" },
    { 0xC36A0C77, "c_pan_civ_male_3" },
    { 0xEC0D74A2, "c_pan_civ_male_body1_als" },
    { 0x6925333D, "c_pan_civ_male_body1_mov_als" },
    { 0x8C9AA255, "c_pan_civ_male_body2_als" },
    { 0x8AE47644, "c_pan_civ_male_body3_als" },
    { 0x7B766775, "c_pan_civ_male_head_als" },
    { 0x1C5A3251, "c_pan_civ_male_head_mov" },
    { 0xE658A583, "c_pan_dingbats_1" },
    { 0x74513648, "c_pan_dingbats_2" },
    { 0x0687B400, "c_pan_dingbats_gear_als" },
    { 0x3450EF9F, "c_pan_dingbats_head_als" },
    { 0x4F08427E, "c_pan_dingbats_hero" },
    { 0x22188AFA, "c_pan_noriega_casual" },
    { 0x48A1D58B, "c_pan_noriega_casual_cap" },
    { 0x009B7A73, "c_pan_noriega_casual_sack" },
    { 0x0A374A14, "c_pan_noriega_military" },
    { 0x76AD799C, "c_pan_pdf_gear_als" },
    { 0xFC2B320D, "c_pan_pdf_gear_char_als" },
    { 0xECA1E6EE, "c_pan_pdf_gear_panama_char_als" },
    { 0xD48DB54F, "c_pan_pdf_heavy" },
    { 0x2B688536, "c_pan_pdf_heavy_char" },
    { 0x59748901, "c_pan_pdf_heavy_panama_char" },
    { 0xF6FB8B8C, "c_pan_pdf_intro_leader" },
    { 0x85A67E66, "c_pan_pdf_light" },
    { 0x266F7E0D, "c_pan_pdf_light_char" },
    { 0x1876A028, "c_pan_pdf_light_panama_char" },
    { 0x01F8EF6F, "c_pan_pdf_medium" },
    { 0x94229716, "c_pan_pdf_medium_char" },
    { 0xF9FDEEA1, "c_pan_pdf_medium_panama_char" },
    { 0x0107C90A, "c_rus_afghan_kravchenko" },
    { 0x55220F33, "c_rus_afghan_kravchenko_cut" },
    { 0xCA188EB2, "c_rus_afghan_reznov" },
    { 0x919626F6, "c_rus_afghan_spetsnaz" },
    { 0x3707956D, "c_rus_afghan_spetsnaz_2" },
    { 0xBB3C8A93, "c_rus_afghan_spetsnaz_body1_gear_als" },
    { 0x532D5642, "c_rus_afghan_spetsnaz_body2_gear_als" },
    { 0xF64B8708, "c_rus_afghan_spetsnaz_head_als" },
    { 0x7E65757D, "c_rus_airplane_gassed_pilot" },
    { 0xFC41347B, "c_rus_airplane_gassed_worker" },
    { 0xE3FC616B, "c_rus_dragovich_old" },
    { 0x340E4ECC, "c_rus_dragovich_young" },
    { 0x619A0A05, "c_rus_engineer1_blue" },
    { 0x38C92B7F, "c_rus_engineer1_blue_gas" },
    { 0xEF4D5252, "c_rus_engineer1_grey_gas" },
    { 0x01EA41EA, "c_rus_engineer1_hatchet" },
    { 0xE95B597B, "c_rus_engineer1_orange" },
    { 0x73A3F121, "c_rus_engineer1_orange_gas" },
    { 0x1D66659D, "c_rus_engineer1_orange_nohelm_gas" },
    { 0xC84C397F, "c_rus_engineer1_yellow_gas" },
    { 0x583BEF07, "c_rus_engineer_head_alias" },
    { 0x29BC43A1, "c_rus_engineer_head_gas_alias" },
    { 0x27F838BA, "c_rus_engineer_headgear_alias" },
    { 0x078F31EE, "c_rus_fullahead_drones" },
    { 0x2BE6A96C, "c_rus_fullahead_head_alias" },
    { 0x32242B54, "c_rus_fullahead_officer1" },
    { 0xA42B9A8F, "c_rus_fullahead_officer2" },
    { 0x9E345773, "c_rus_fullahead_patrenko" },
    { 0x02E557C9, "c_rus_fullahead_patrenko_gas" },
    { 0x6FAA3E23, "c_rus_fullahead_soldier" },
    { 0x14F9D58E, "c_rus_fullahead_soldier1_gas" },
    { 0x4524377B, "c_rus_hazmat" },
    { 0xA53C98FF, "c_rus_heavy" },
    { 0xB4398D5E, "c_rus_helicopter_pilot" },
    { 0xE3C0E3E6, "c_rus_jungmar_pow_reznov" },
    { 0x62025F43, "c_rus_kravchenko_jacket" },
    { 0xC41DC7FE, "c_rus_kravchenko_jacket_bandolier" },
    { 0x0FF1F8E7, "c_rus_kravchenko_young" },
    { 0x1EB93134, "c_rus_military1" },
    { 0x71DB01F3, "c_rus_military1_char" },
    { 0x90C0A06F, "c_rus_military2" },
    { 0x2F556A16, "c_rus_military2_char" },
    { 0x6ABE2606, "c_rus_military3" },
    { 0x754E1B6D, "c_rus_military3_char" },
    { 0x80F60482, "c_rus_military_winter1" },
    { 0x5AF38A19, "c_rus_military_winter2" },
    { 0xC96A586B, "c_rus_nikolai_dlc4" },
    { 0xA367DE02, "c_rus_nikolai_dlc5" },
    { 0x022BAEC1, "c_rus_nikolai_zm" },
    { 0x4BEDBA80, "c_rus_nikolai_zt" },
    { 0x769C8E01, "c_rus_prison_guard" },
    { 0xA3130E91, "c_rus_prison_guard_hatalias" },
    { 0xD37343AE, "c_rus_prison_guard_headalias" },
    { 0x518D79BB, "c_rus_prison_guard_main" },
    { 0xEFF645BD, "c_rus_prison_guard_scarfalias" },
    { 0x5D46FB56, "c_rus_prisoner" },
    { 0x390B95EB, "c_rus_prisoner_bodyalias" },
    { 0x924D2751, "c_rus_prisoner_drone" },
    { 0x075BAFDD, "c_rus_prisoner_headalias" },
    { 0xBA37B566, "c_rus_prisoner_headwearalias" },
    { 0xBF099ABD, "c_rus_reznov_combat" },
    { 0xC3842520, "c_rus_reznov_combat_fb" },
    { 0xDFE3A335, "c_rus_reznov_fullahead" },
    { 0xB5536855, "c_rus_reznov_prisoner" },
    { 0x5B2A6151, "c_rus_reznov_rebirth" },
    { 0x98C1C959, "c_rus_scientist1" },
    { 0x49184528, "c_rus_scientist1_corpse" },
    { 0xBEC443C2, "c_rus_scientist2" },
    { 0x8905E219, "c_rus_scientist2_corpse" },
    { 0xF318C47A, "c_rus_scientist3_corpse" },
    { 0x0AC93894, "c_rus_scientist4" },
    { 0x726EDCEB, "c_rus_scientist_body_char_alias" },
    { 0xFFCF76AD, "c_rus_scientist_bodyalias" },
    { 0xD0773CE5, "c_rus_scientist_head_char_alias" },
    { 0xE58F0D1F, "c_rus_scientist_headalias" },
    { 0x642823EB, "c_rus_scientists" },
    { 0xF9827CC2, "c_rus_scientists_char" },
    { 0x0D0B382D, "c_rus_sergei" },
    { 0x8532BB05, "c_rus_simianaut" },
    { 0x158093CA, "c_rus_spetnaz_undercover1" },
    { 0x6ED3C7E7, "c_rus_spetnaz_undercover1_wet" },
    { 0x091BD447, "c_rus_spetnaz_undercover1a" },
    { 0xA277A4F6, "c_rus_spetnaz_undercover1a_wet" },
    { 0xEF7E1961, "c_rus_spetnaz_undercover2" },
    { 0x697C43D8, "c_rus_spetnaz_undercover2_wet" },
    { 0xD8CC4C01, "c_rus_spetnaz_undercover2b" },
    { 0xC3014938, "c_rus_spetnaz_undercover2b_wet" },
    { 0x9E0A4985, "c_rus_spetsnaz2_zt" },
    { 0xA7BAE4EB, "c_rus_spetsnaz_rebirth_head_alias" },
    { 0x2E8C1175, "c_rus_spetsnaz_rebirth_head_gas_alias" },
    { 0x63B77242, "c_rus_spetsnaz_undercover_head_alias" },
    { 0x8BFB61B9, "c_rus_spetznaz_1" },
    { 0x70F56D20, "c_rus_spetznaz_1_char" },
    { 0x88671BF7, "c_rus_spetznaz_1_gasmask" },
    { 0xB1FDDC22, "c_rus_spetznaz_2" },
    { 0x9AC1B8B9, "c_rus_spetznaz_2_char" },
    { 0x7335D51C, "c_rus_spetznaz_2_gasmask" },
    { 0x0273551D, "c_rus_spetznaz_assault" },
    { 0x73B786BB, "c_rus_spetznaz_mp_assault" },
    { 0xB0B0DFD0, "c_rus_spetznaz_mp_cqb" },
    { 0xBCB6ABA6, "c_rus_spetznaz_mp_lmg" },
    { 0xD6E2F59C, "c_rus_spetznaz_mp_shotgun" },
    { 0xB819BE01, "c_rus_spetznaz_mp_smg" },
    { 0xC0B9C90F, "c_rus_spetznaz_mp_sniper" },
    { 0x36C44476, "c_rus_spetznaz_rebirth_1" },
    { 0x9A69D17D, "c_rus_spetznaz_rebirth_1_corpse" },
    { 0xD4F1E210, "c_rus_spetznaz_rebirth_1_gas" },
    { 0x10C1CA0D, "c_rus_spetznaz_rebirth_2" },
    { 0x7C59246C, "c_rus_spetznaz_rebirth_2_corpse" },
    { 0x529A0F97, "c_rus_spetznaz_rebirth_2_gas" },
    { 0x6096E19B, "c_rus_spetznaz_winter_1" },
    { 0xEE8F7260, "c_rus_spetznaz_winter_2" },
    { 0x1491ECC9, "c_rus_spetznaz_winter_3" },
    { 0x35A8A900, "c_rus_supervisor" },
    { 0x8E564832, "c_stick_right_strength" },
    { 0x468B1BD2, "c_t6_claw_mk2" },
    { 0xAA428EB3, "c_t6_claw_mk2_enemy" },
    { 0x450B6A55, "c_teamgather" },
    { 0xC7AAD088, "c_transit_player_engineer" },
    { 0xAEC65FF5, "c_transit_player_farmgirl" },
    { 0x9D6F90DE, "c_transit_player_oldman" },
    { 0x75355F78, "c_transit_player_reporter" },
    { 0x2B9FD328, "c_usa_6thinf_1" },
    { 0x243DA607, "c_usa_7thinf_1" },
    { 0x7CF33B9C, "c_usa_7thinf_gear_als" },
    { 0x9425460B, "c_usa_7thinf_head_als" },
    { 0xD57F443C, "c_usa_afghan_hudson" },
    { 0x478E7E7C, "c_usa_afghan_hudson_beatup" },
    { 0x51905A1C, "c_usa_afghan_woods_beatup_cin" },
    { 0x678D2531, "c_usa_afghan_woods_fwrap_cin" },
    { 0xD21E328D, "c_usa_angola_hudson" },
    { 0xB17ACB5E, "c_usa_angola_woods" },
    { 0xA9FA04F3, "c_usa_blackops_body2" },
    { 0x83F78A8A, "c_usa_blackops_body3" },
    { 0xDA7DCBCB, "c_usa_blackops_bowman_disguise" },
    { 0xB815AFB3, "c_usa_blackops_weaver_disguise" },
    { 0x8BAA84B6, "c_usa_blackops_weaver_getwet" },
    { 0x43DCA6BC, "c_usa_blackops_winter_body1" },
    { 0x4C3DE1B1, "c_usa_blackops_winter_body1_halo" },
    { 0xB5E415F7, "c_usa_blackops_winter_body2" },
    { 0xF01C54D8, "c_usa_blackops_winter_body2_halo" },
    { 0x8FE19B8E, "c_usa_blackops_winter_body3" },
    { 0xE95B62A0, "c_usa_blackops_winter_weaver_halo" },
    { 0x22A2B4DA, "c_usa_captain_anderson" },
    { 0x95F9AF9B, "c_usa_captured_mason_dead" },
    { 0x34751567, "c_usa_captured_mason_sack" },
    { 0x7E1A503E, "c_usa_cc_briggs" },
    { 0x060D01D8, "c_usa_chloe_cc_cin" },
    { 0xCC597135, "c_usa_chloe_cin" },
    { 0xFDCFDFB0, "c_usa_chloe_lynch_organs" },
    { 0xC5B98BBF, "c_usa_chloe_strikef" },
    { 0x9178A3EB, "c_usa_cia2_zt" },
    { 0xFA9E62DF, "c_usa_cia_combat_harper_cin" },
    { 0x252BA411, "c_usa_cia_combat_harper_haiti_cin" },
    { 0x9C5FF36D, "c_usa_cia_combat_harper_scar_haiti_cin" },
    { 0xE0005C3D, "c_usa_cia_combat_harper_wt_cin" },
    { 0xD209BB50, "c_usa_cia_combat_masonjr" },
    { 0xD72AD732, "c_usa_cia_combat_salazar" },
    { 0xD49D70B0, "c_usa_cia_combat_salazar_wt" },
    { 0xDB8C4449, "c_usa_clark_getwet" },
    { 0xC53AB1E0, "c_usa_cubcasual_barnes" },
    { 0xE3938DD7, "c_usa_cubcasual_bowman" },
    { 0x653D44DB, "c_usa_cubrebel_barnes" },
    { 0xCBEF5AA4, "c_usa_cubrebel_bowman" },
    { 0x346ED9C8, "c_usa_dempsey_dlc4" },
    { 0x5A715431, "c_usa_dempsey_dlc5" },
    { 0x317243E2, "c_usa_dempsey_zm" },
    { 0x2760EB03, "c_usa_dempsey_zt" },
    { 0x8B5BA722, "c_usa_future_seal_1" },
    { 0x1C1A40C9, "c_usa_gov_presstaff1" },
    { 0x49191A3E, "c_usa_gov_tressec_cin" },
    { 0x78AD6D20, "c_usa_hillaryclinton_g20_cin" },
    { 0xF5047FB7, "c_usa_huey_pilot_1" },
    { 0x82FD107C, "c_usa_huey_pilot_2" },
    { 0xD4C2DA26, "c_usa_interrogation_hudson" },
    { 0x135A376B, "c_usa_interrogation_mason" },
    { 0x44585ABF, "c_usa_interrogation_sillhouette" },
    { 0xCCAC0313, "c_usa_jfk_zt" },
    { 0xF5246A17, "c_usa_jungmar_assault" },
    { 0x49253EEE, "c_usa_jungmar_assault_char" },
    { 0x92AF3700, "c_usa_jungmar_banres_khesanh" },
    { 0x5CD1E751, "c_usa_jungmar_barechest" },
    { 0xD14A42AD, "c_usa_jungmar_barnes" },
    { 0xEEEE1491, "c_usa_jungmar_barnes_disguise" },
    { 0x54F01136, "c_usa_jungmar_bowman" },
    { 0x5C5A51C6, "c_usa_jungmar_bowman_nobackpack" },
    { 0xD5B3962C, "c_usa_jungmar_chaplain" },
    { 0x1895D1F4, "c_usa_jungmar_cqb" },
    { 0x18209C64, "c_usa_jungmar_driver" },
    { 0x462E79DC, "c_usa_jungmar_drone" },
    { 0x3745C17E, "c_usa_jungmar_headblown" },
    { 0x3B3CCF57, "c_usa_jungmar_hudson" },
    { 0x51098E62, "c_usa_jungmar_lmg" },
    { 0x043E18C4, "c_usa_jungmar_medic" },
    { 0x177E8C75, "c_usa_jungmar_mp_assault" },
    { 0x657893B2, "c_usa_jungmar_mp_cqb" },
    { 0x87A89394, "c_usa_jungmar_mp_lmg" },
    { 0x88837406, "c_usa_jungmar_mp_shotgun" },
    { 0xCA2BBCFB, "c_usa_jungmar_mp_smg" },
    { 0xEA7ABE69, "c_usa_jungmar_mp_sniper" },
    { 0x83394820, "c_usa_jungmar_pow_1" },
    { 0xF540B75B, "c_usa_jungmar_pow_2" },
    { 0x09FFC19C, "c_usa_jungmar_pow_barnes" },
    { 0x93DD84F3, "c_usa_jungmar_pow_bowman" },
    { 0x807CD13E, "c_usa_jungmar_sarge2" },
    { 0x1A871898, "c_usa_jungmar_shotgun" },
    { 0xCAFE8305, "c_usa_jungmar_smg" },
    { 0x5E508E2A, "c_usa_jungmar_snip" },
    { 0x5E757947, "c_usa_jungmar_tanker" },
    { 0xA125B1A2, "c_usa_jungmar_wet_assault" },
    { 0x7737DCDA, "c_usa_jungmar_wet_barnes" },
    { 0x2EBC8811, "c_usa_jungmar_wet_bowman" },
    { 0xFF5D1DAF, "c_usa_jungmar_wet_lmg" },
    { 0xC395085D, "c_usa_jungmar_wet_shotgun" },
    { 0x02F4E8D8, "c_usa_jungmar_wet_shotgun_bleed" },
    { 0x00A4AE61, "c_usa_jungmar_wet_snip" },
    { 0x27372152, "c_usa_jungmar_wounded_knee" },
    { 0x632ED0D8, "c_usa_jungmar_wounded_torso" },
    { 0xA7058715, "c_usa_lapd_medic" },
    { 0xD813F764, "c_usa_lapd_motocop" },
    { 0xC7C84EAE, "c_usa_lapd_rigid_drone1" },
    { 0x14FF2B66, "c_usa_lapd_streetcop_1" },
    { 0xEEFCB0FD, "c_usa_lapd_streetcop_2" },
    { 0xC8FA3694, "c_usa_lapd_streetcop_3" },
    { 0x0B3B3381, "c_usa_lapd_streetcop_drone" },
    { 0xF048B79D, "c_usa_marine_michael_carter_player_zm" },
    { 0xD59D6DA4, "c_usa_masonjr_child" },
    { 0xE6821AEE, "c_usa_mcnamara_zt" },
    { 0x05291219, "c_usa_milcas_mason" },
    { 0x24A81831, "c_usa_milcas_mcknight_cin" },
    { 0x629B7C08, "c_usa_militarypolice" },
    { 0xAF59A930, "c_usa_militarypolice_head_alias" },
    { 0x65738CEC, "c_usa_militarypolice_zombietron" },
    { 0x1A99A2A7, "c_usa_moto_cop" },
    { 0x00E2512D, "c_usa_moto_cop_head_alias" },
    { 0x3C0B28AF, "c_usa_navy_1" },
    { 0xFC078B0E, "c_usa_navy_1_goggles" },
    { 0xCA03B974, "c_usa_navy_2" },
    { 0xF00633DD, "c_usa_navy_3" },
    { 0xFE984B5E, "c_usa_navy_3_cin" },
    { 0x7DFEC4A2, "c_usa_navy_4" },
    { 0x39CC235C, "c_usa_navy_wounded_1" },
    { 0xABD39297, "c_usa_navy_wounded_2" },
    { 0x85D1182E, "c_usa_navy_wounded_3" },
    { 0xC7C4B421, "c_usa_navy_wounded_4" },
    { 0x3C808CB2, "c_usa_nicaragua_hudson" },
    { 0x5F42E537, "c_usa_nicaragua_mason" },
    { 0xDA66608F, "c_usa_nicaragua_woods" },
    { 0x0D066788, "c_usa_nixon_zt" },
    { 0x6B8B9067, "c_usa_panama_hudson" },
    { 0xB71DB8DB, "c_usa_pent_ciaagent" },
    { 0x58EF2CE8, "c_usa_pent_ciaagent1" },
    { 0x72AA2322, "c_usa_pent_ciaagent10_noglasses" },
    { 0xCAF69C23, "c_usa_pent_ciaagent2" },
    { 0xA4F421BA, "c_usa_pent_ciaagent3" },
    { 0x16FB90F5, "c_usa_pent_ciaagent4" },
    { 0xF0F9168C, "c_usa_pent_ciaagent5" },
    { 0x630085C7, "c_usa_pent_ciaagent6" },
    { 0x3CFE0B5E, "c_usa_pent_ciaagent7" },
    { 0xAE0313AF, "c_usa_pent_ciaagent8_noglasses" },
    { 0x8AE25A7A, "c_usa_pent_ciaagent9_noglasses" },
    { 0xA892B091, "c_usa_pent_ciaagent_head_alias" },
    { 0x5CAFB08C, "c_usa_pent_female_head" },
    { 0x1E0FB900, "c_usa_pent_female_jewelry" },
    { 0x01915045, "c_usa_pent_female_lower" },
    { 0x09B6CB32, "c_usa_pent_female_upper" },
    { 0x2A10D66C, "c_usa_pent_female_worker" },
    { 0xD2527639, "c_usa_pent_female_worker5" },
    { 0x9ED156C9, "c_usa_pent_general" },
    { 0x600FB5E9, "c_usa_pent_general2" },
    { 0x3A0D3B80, "c_usa_pent_general3" },
    { 0xEC6FC096, "c_usa_pent_hudson" },
    { 0xDBA523F2, "c_usa_pent_jfk" },
    { 0x7F43CFC5, "c_usa_pent_male_worker" },
    { 0x167B035B, "c_usa_pent_mason" },
    { 0x6C07BF95, "c_usa_pent_mcnamara" },
    { 0x8209FCEF, "c_usa_pent_officeworker_head_alias" },
    { 0x5FD10B0D, "c_usa_pent_politician" },
    { 0xF7371735, "c_usa_pent_politician2" },
    { 0x812C6E43, "c_usa_pent_politician_head_alias" },
    { 0x0040197F, "c_usa_pent_secretary" },
    { 0xA1B6974F, "c_usa_pent_warroom_worker" },
    { 0x679A5256, "c_usa_pent_warroom_worker3" },
    { 0x1CBBFA8C, "c_usa_pent_warroomworker_head_alias" },
    { 0x65AA95CB, "c_usa_pent_zombie_militarypolice" },
    { 0x80D2CD22, "c_usa_pent_zombie_officeworker" },
    { 0x8F04D2C2, "c_usa_pent_zombie_scientist" },
    { 0x05FB13C3, "c_usa_rebirth_hazmat" },
    { 0xA53C3859, "c_usa_rebirth_hazmat_gas" },
    { 0x623BCADC, "c_usa_rebirth_mason" },
    { 0xE88CF6AA, "c_usa_rebirth_weaver" },
    { 0x473D8BEA, "c_usa_seal6" },
    { 0xD8A5D54F, "c_usa_seal6_assault_crosby_wt" },
    { 0x326BBA69, "c_usa_seal6_assault_haper_wt" },
    { 0x2E4A286B, "c_usa_seal6_assault_salazar_wt" },
    { 0x038B9B85, "c_usa_seal6_booby_trap_body" },
    { 0xF6F4B89E, "c_usa_seal6_drone1" },
    { 0x4E0BC0AF, "c_usa_seal6_gear_als" },
    { 0xFDF2D60C, "c_usa_seal6_head_als" },
    { 0x1D99C2D6, "c_usa_seal6_rigid_drone1" },
    { 0xF83DE856, "c_usa_seal6_wingsuit_helm" },
    { 0x7D4F928B, "c_usa_seal80s_head_als" },
    { 0x402650CF, "c_usa_seal80s_heavy" },
    { 0xF13F19E6, "c_usa_seal80s_light" },
    { 0x8AFCD694, "c_usa_seal80s_mason" },
    { 0xE335B9EF, "c_usa_seal80s_medium" },
    { 0x7FCF7D53, "c_usa_secserv_driver" },
    { 0x461CA6FA, "c_usa_secserv_heavy" },
    { 0x4A87DEEA, "c_usa_secserv_jones" },
    { 0xA1EC8FA7, "c_usa_secserv_light" },
    { 0x7D7E3384, "c_usa_secserv_medium" },
    { 0x6F724111, "c_usa_secserv_sam_cin" },
    { 0x66CE3D9C, "c_usa_secserv_swat_tactical" },
    { 0x0907CBAB, "c_usa_sog2_zt" },
    { 0xB69DA0CB, "c_usa_specop_assault" },
    { 0xA4309021, "c_usa_specop_barnes" },
    { 0xBA189FE6, "c_usa_specops_mp_assault" },
    { 0x1B9BCC65, "c_usa_specops_mp_cqb" },
    { 0x38AB3223, "c_usa_specops_mp_lmg" },
    { 0x554E3DD1, "c_usa_specops_mp_shotgun" },
    { 0x491C08AC, "c_usa_specops_mp_smg" },
    { 0x680A6B9C, "c_usa_specops_mp_sniper" },
    { 0xC98D2D08, "c_usa_tshirt_mason" },
    { 0x1037053A, "c_usa_ubase_combat" },
    { 0x448FD9E9, "c_usa_ubase_divegear" },
    { 0x7BF4AACF, "c_usa_ubase_hatalias" },
    { 0xAE857EB8, "c_usa_ubase_headalias" },
    { 0x2BFFD497, "c_usa_ubase_hudson" },
    { 0x4A6C808E, "c_usa_ubase_hudson_combat" },
    { 0x1CFEEAFD, "c_usa_ubase_hudson_divegear" },
    { 0x4CEF4B67, "c_usa_ubase_hudson_divegear_up" },
    { 0x9E18AE1E, "c_usa_ubase_weaver" },
    { 0xCF997830, "c_usa_unioninsp_han" },
    { 0xCD04A5B2, "c_usa_unioninsp_harper_cin" },
    { 0xFC0B0359, "c_usa_unioninsp_redshirt1" },
    { 0x220D7DC2, "c_usa_unioninsp_redshirt2" },
    { 0x455164BE, "c_usa_unioninsp_salazar_cin" },
    { 0xADE106CE, "c_viet_zombie_female_body" },
    { 0x8DDA9306, "c_viet_zombie_female_body_alt" },
    { 0x7C157529, "c_viet_zombie_nva1" },
    { 0x87B90285, "c_viet_zombie_nva1_alt" },
    { 0xF3D69E59, "c_viet_zombie_sonic" },
    { 0xC6A63206, "c_viet_zombie_vc" },
    { 0x9F5395AE, "c_vtn_civ_head_alias" },
    { 0x420F8C74, "c_vtn_civ_macv" },
    { 0xAE8FED11, "c_vtn_civ_macv_accoutrement" },
    { 0x04BBFDDB, "c_vtn_civ_macv_lowerbody_alias" },
    { 0x465D5568, "c_vtn_civ_macv_upperbody_alias" },
    { 0xF076FE3A, "c_vtn_civ_town_accoutrement" },
    { 0x519C7FFA, "c_vtn_civ_town_lowerbody_alias" },
    { 0x2E927091, "c_vtn_civ_town_upperbody_alias" },
    { 0xEDD1613F, "c_vtn_civ_urban" },
    { 0xDEE5552B, "c_vtn_civ_village" },
    { 0x89DF5DD0, "c_vtn_civ_village_accoutrement" },
    { 0x8D4A2A8C, "c_vtn_civ_village_lowerbody_alias" },
    { 0x25CBA9E3, "c_vtn_civ_village_upperbody_alias" },
    { 0x8C5FCB99, "c_vtn_mp_assault_player" },
    { 0x775E3840, "c_vtn_mp_cqb_player" },
    { 0x010B566A, "c_vtn_mp_lmg_player" },
    { 0x3844ECFC, "c_vtn_mp_shotgun_player" },
    { 0x9EDA501B, "c_vtn_mp_smg_player" },
    { 0xF9A5B98D, "c_vtn_mp_sniper_player" },
    { 0x86E17C76, "c_vtn_nva1" },
    { 0x406CEA7D, "c_vtn_nva1_char" },
    { 0x33244CB1, "c_vtn_nva1_drone" },
    { 0x934177CD, "c_vtn_nva1_nogear" },
    { 0x60DF020D, "c_vtn_nva2" },
    { 0x467E1BDC, "c_vtn_nva2_body_g_lowclean" },
    { 0x20EF8BB4, "c_vtn_nva2_char" },
    { 0xF3C713D0, "c_vtn_nva2_nogear" },
    { 0x90045F8A, "c_vtn_nva2_zt" },
    { 0x3ADC87A4, "c_vtn_nva3" },
    { 0xC513F243, "c_vtn_nva3_char" },
    { 0x605836AB, "c_vtn_nva3_nogear" },
    { 0x02E974DA, "c_vtn_vc1" },
    { 0xCFC76CEB, "c_vtn_vc1_meatshield" },
    { 0xDFD5B5F1, "c_vtn_vc1_nogear" },
    { 0xDCE6FA71, "c_vtn_vc2" },
    { 0x3C669332, "c_vtn_vc2_drone" },
    { 0x13A6A1D4, "c_vtn_vc2_nogear" },
    { 0x8466EAFC, "c_vtn_vc2_sleeper" },
    { 0xB6E48008, "c_vtn_vc3" },
    { 0x200D4D8F, "c_vtn_vc3_nogear" },
    { 0xB18CFC2D, "c_vtn_vc3_sleeper" },
    { 0xD011E5A4, "c_vtn_vc_pow_bookie" },
    { 0x9B6C493D, "c_vtn_vc_pow_guard1" },
    { 0xC16EC3A6, "c_vtn_vc_pow_guard2" },
    { 0x2870A1AB, "c_vtn_vc_pow_guy1" },
    { 0xB6693270, "c_vtn_vc_pow_guy2" },
    { 0xF668CF5E, "c_yem_civilian_male" },
    { 0xC1296386, "c_yem_civilian_male_body_als" },
    { 0x6C73D500, "c_yem_civilian_male_head_als" },
    { 0x65EFA8E3, "c_yem_houthis_heavy" },
    { 0x9FB987D3, "c_yem_houthis_medium" },
    { 0x20AC4F99, "c_yem_repguard_1" },
    { 0x46AECA02, "c_yem_repguard_2" },
    { 0x6CB1446B, "c_yem_repguard_3" },
    { 0x32510811, "c_yem_repguard_head_als" },
    { 0xADE648F5, "c_zom_ally_cdc" },
    { 0xA1C208D1, "c_zom_ally_farmgirl" },
    { 0x1E92ECCA, "c_zom_arlington" },
    { 0xA48057F7, "c_zom_avogadro" },
    { 0xD3301047, "c_zom_blue_guy_zt" },
    { 0x533392E4, "c_zom_buried_sloth" },
    { 0x4879D0CA, "c_zom_cellbreaker" },
    { 0x4CEF961A, "c_zom_chinese_zombie_head_als" },
    { 0x93151E24, "c_zom_chinese_zombie_head_helmet_als" },
    { 0x41EFC9FB, "c_zom_cosmo_cosmonaut" },
    { 0xCBEA5118, "c_zom_cosmo_cosmonaut_headalias" },
    { 0xDEE789A0, "c_zom_cosmo_headalias" },
    { 0x15A1762C, "c_zom_cosmo_scientist" },
    { 0x3C3F5F4B, "c_zom_cosmo_scientist_headalias" },
    { 0x51A92469, "c_zom_cosmo_spetznaz" },
    { 0xA735E48C, "c_zom_cosmo_worker" },
    { 0x228476B9, "c_zom_danny_trejo_player" },
    { 0x5FBE420E, "c_zom_deluca" },
    { 0x01F5D98E, "c_zom_dlc0_zom_head_als" },
    { 0x24E278C5, "c_zom_dlc0_zom_head_blueeyes_als" },
    { 0x0AE52562, "c_zom_dlc0_zombie_hazmat_1" },
    { 0x0398214F, "c_zom_dlc0_zombie_hazmat_1_beyes" },
    { 0xE4E2AAF9, "c_zom_dlc0_zombie_hazmat_2" },
    { 0x0AC23310, "c_zom_dlc0_zombie_hazmat_2_beyes" },
    { 0xD862EF23, "c_zom_dlc0_zombie_soldier_1" },
    { 0x470FD98E, "c_zom_dlc0_zombie_soldier_1_beyes" },
    { 0x1DC811FC, "c_zom_dlc0_zombie_soldier_civ_1" },
    { 0x7C35427D, "c_zom_dlc0_zombie_soldier_civ_1_beyes" },
    { 0x327B64EF, "c_zom_dlc_mech" },
    { 0xB92595C5, "c_zom_electrician" },
    { 0xD2815FC8, "c_zom_giant_robot" },
    { 0x1B17777D, "c_zom_giant_robot_0" },
    { 0xF514FD14, "c_zom_giant_robot_1" },
    { 0x671C6C4F, "c_zom_giant_robot_2" },
    { 0x02314D75, "c_zom_guard" },
    { 0x62E5779D, "c_zom_handsome" },
    { 0xC9EF98A5, "c_zom_inmate1" },
    { 0xEFF2130E, "c_zom_inmate2" },
    { 0x4B7BED8D, "c_zom_leaper" },
    { 0x6ADA4C5E, "c_zom_michael_rooker_player" },
    { 0x50C0012C, "c_zom_moon_heads_alias" },
    { 0xE35C8DE0, "c_zom_moon_pressure_suit_zombie" },
    { 0x8FF8AC79, "c_zom_moon_quad" },
    { 0xA0963A8C, "c_zom_moon_tech_caps1_alias" },
    { 0xE907B97B, "c_zom_moon_tech_caps2_alias" },
    { 0xBCFEB0B6, "c_zom_moon_tech_caps3_alias" },
    { 0xA35756F5, "c_zom_moon_tech_zombie_1" },
    { 0xED28B3BA, "c_zom_moon_tech_zombie_1_2" },
    { 0x132B2E23, "c_zom_moon_tech_zombie_1_3" },
    { 0xC959D15E, "c_zom_moon_tech_zombie_2" },
    { 0x4869F1A5, "c_zom_moon_tech_zombie_2_2" },
    { 0xEF5C4BC7, "c_zom_moon_tech_zombie_3" },
    { 0xC2F62DD4, "c_zom_moon_tech_zombie_3_2" },
    { 0xE8F8A83D, "c_zom_moon_tech_zombie_3_3" },
    { 0x030F4E02, "c_zom_moon_zombie_militarypolice" },
    { 0x95373AE2, "c_zom_oleary" },
    { 0xFA6CDECC, "c_zom_prison_guard_hat_als" },
    { 0x19F779F5, "c_zom_prison_guard_head_als" },
    { 0x3003FCF2, "c_zom_prison_inmate_head_als" },
    { 0xA008E7E7, "c_zom_quad" },
    { 0x05158A2C, "c_zom_red_guy_zt" },
    { 0xB8543D78, "c_zom_robert_englund_player" },
    { 0x3E4E09CD, "c_zom_sarah_michelle_gellar_player" },
    { 0xF39CE738, "c_zom_screecher" },
    { 0x1C5B242B, "c_zom_snow_camo_zt" },
    { 0xC80BB603, "c_zom_tomb_crusader_1a" },
    { 0x2FD63902, "c_zom_tomb_crusader_1a_nohat" },
    { 0x7C06C131, "c_zom_tomb_crusader_1c" },
    { 0x97BC2DBD, "c_zom_tomb_crusader_2b" },
    { 0x047EE358, "c_zom_tomb_crusader_2b_nohat" },
    { 0x71B9B354, "c_zom_tomb_crusader_2c" },
    { 0xB84946D0, "c_zom_tomb_crusader_head_als" },
    { 0xB392517C, "c_zom_tomb_crusader_zc" },
    { 0x94A4DC0E, "c_zom_tomb_german_1a" },
    { 0x03E5A183, "c_zom_tomb_german_1a_nohat" },
    { 0x2CEA7AB0, "c_zom_tomb_german_2b" },
    { 0x5FB47131, "c_zom_tomb_german_2b_nohat" },
    { 0x5D3A02F6, "c_zom_tomb_german_3c" },
    { 0x2A49FA4B, "c_zom_tomb_german_3c_nohat" },
    { 0x9BCE5234, "c_zom_tomb_german_bare" },
    { 0x2D89FB85, "c_zom_tomb_german_bare_nohat" },
    { 0xC80F613D, "c_zom_tomb_german_head_als" },
    { 0x7F235BC7, "c_zom_yellow_guy_zt" },
    { 0xB743BD69, "c_zom_zombie1_01" },
    { 0xDD4637D2, "c_zom_zombie1_02" },
    { 0x0348B23B, "c_zom_zombie1_03" },
    { 0x294B2CA4, "c_zom_zombie1_04" },
    { 0x4F4DA70D, "c_zom_zombie1_05" },
    { 0x75502176, "c_zom_zombie1_06" },
    { 0x245C6D94, "c_zom_zombie2_01" },
    { 0x9663DCCF, "c_zom_zombie2_02" },
    { 0x70616266, "c_zom_zombie2_03" },
    { 0xB254FE59, "c_zom_zombie2_04" },
    { 0x8C5283F0, "c_zom_zombie2_05" },
    { 0xFE59F32B, "c_zom_zombie2_06" },
    { 0xB1BB00E3, "c_zom_zombie3_01" },
    { 0x3FB391A8, "c_zom_zombie3_02" },
    { 0x65B60C11, "c_zom_zombie3_03" },
    { 0x23C2701E, "c_zom_zombie3_04" },
    { 0x49C4EA87, "c_zom_zombie3_05" },
    { 0xD7BD7B4C, "c_zom_zombie3_06" },
    { 0x44F86C75, "c_zom_zombie5_01" },
    { 0x6AFAE6DE, "c_zom_zombie5_02" },
    { 0x90FD6147, "c_zom_zombie5_03" },
    { 0xA703A3E2, "c_zom_zombie8_01" },
    { 0x81012979, "c_zom_zombie8_02" },
    { 0x5AFEAF10, "c_zom_zombie8_03" },
    { 0xB5F8CD71, "c_zom_zombie9_01" },
    { 0xDBFB47DA, "c_zom_zombie9_02" },
    { 0x01FDC243, "c_zom_zombie9_03" },
    { 0x0A64EC21, "c_zom_zombie_buried_civilian1" },
    { 0x3067668A, "c_zom_zombie_buried_civilian2" },
    { 0xEB47F69F, "c_zom_zombie_buried_civilian2_nohat" },
    { 0x5669E0F3, "c_zom_zombie_buried_civilian3" },
    { 0x425613F2, "c_zom_zombie_buried_civilian3_nohat" },
    { 0x7C6C5B5C, "c_zom_zombie_buried_civilian4" },
    { 0x2A5204ED, "c_zom_zombie_buried_civilian4_nohat" },
    { 0xA26ED5C5, "c_zom_zombie_buried_civilian5" },
    { 0x61109320, "c_zom_zombie_buried_civilian5_nohat" },
    { 0x3DF1322C, "c_zom_zombie_buried_civilian_hat1_als" },
    { 0x4F4A1483, "c_zom_zombie_buried_civilian_hat2_als" },
    { 0x6A91DD4A, "c_zom_zombie_buried_civilian_hat3_als" },
    { 0xD30634C1, "c_zom_zombie_buried_civilian_hat4_als" },
    { 0x6992A810, "c_zom_zombie_buried_civilian_hat5_als" },
    { 0x21F86818, "c_zom_zombie_buried_female_heads_als" },
    { 0xAF3BEEB7, "c_zom_zombie_buried_ghost_woman" },
    { 0x3EB8741B, "c_zom_zombie_buried_male_heads_als" },
    { 0xF4460D45, "c_zom_zombie_buried_miner1" },
    { 0x1A4887AE, "c_zom_zombie_buried_miner2" },
    { 0x649E38E3, "c_zom_zombie_buried_miner2_nohat" },
    { 0x404B0217, "c_zom_zombie_buried_miner3" },
    { 0xC58B9586, "c_zom_zombie_buried_miner3_nohat" },
    { 0xAC99F87E, "c_zom_zombie_buried_miner_hats_als" },
    { 0x1AEA39C6, "c_zom_zombie_buried_saloongirl1" },
    { 0xF4E7BF5D, "c_zom_zombie_buried_saloongirl2" },
    { 0xCEE544F4, "c_zom_zombie_buried_saloongirl3" },
    { 0x1CDF3A87, "c_zom_zombie_buried_saloongirl_mp" },
    { 0x84567A80, "c_zom_zombie_buried_sgirl_hair_als" },
    { 0xBB3C1E37, "c_zom_zombie_civ_shorts" },
    { 0x631F7917, "c_zom_zombie_civ_shorts2" },
    { 0x3D1CFEAE, "c_zom_zombie_civ_shorts3" },
    { 0x7F109AA1, "c_zom_zombie_civ_shorts4" },
    { 0x590E2038, "c_zom_zombie_civ_shorts5" },
    { 0xCB158F73, "c_zom_zombie_civ_shorts6" },
    { 0x75C6B423, "c_zom_zombie_female_head_als" },
    { 0x7FA8518E, "c_zom_zombie_head_als" },
    { 0x4E8F1C6F, "c_zom_zombie_scientist" },
    { 0xFB2A997B, "c_zom_zombie_soldier" },
    { 0x0B335BCD, "ca" },
    { 0x63C27645, "cab" },
    { 0x9440F6D1, "cab_door_l" },
    { 0xA863A88F, "cab_door_r" },
    { 0x9C11854D, "cab_travel_accel" },
    { 0x51A60652, "cab_travel_decel" },
    { 0xC79F0970, "cab_travel_time" },
    { 0x55875247, "cabana_fx_init" },
    { 0x1B3357DF, "cabana_fx_think" },
    { 0x78251C24, "cabin" },
    { 0x267EA717, "cabinet" },
    { 0x3890BD53, "cabinet_guard_pulse" },
    { 0xF59D42CE, "cabinets" },
    { 0x12C48474, "cable" },
    { 0xF4626D9A, "cable_off" },
    { 0x5AA1B1CC, "cable_on" },
    { 0x63AF7132, "cable_puzzle_gate_afterlife" },
    { 0x3B2B94E6, "cablecar" },
    { 0xF30CCB33, "cablecar_ai_watch" },
    { 0x357B57CF, "cablecar_move_think" },
    { 0x788846B2, "cablecardefaultangle" },
    { 0x3631139A, "cablecarkilltrigger" },
    { 0x635BCBCB, "cablecarlightsfx" },
    { 0xBB3D90F1, "cablecarnodestruct" },
    { 0x33F1F0F9, "cablecarrun" },
    { 0x85714519, "cablecars" },
    { 0x02F40D23, "cablecartrack" },
    { 0xBAA9939B, "cablecartracknode" },
    { 0xD18B9867, "cables" },
    { 0x3DBFFBDC, "cac" },
    { 0x25AF2E70, "cac_armorpiercing_data" },
    { 0x5A1F8245, "cac_armorvest_data" },
    { 0xFC9C8CFC, "cac_assets" },
    { 0x81DBC038, "cac_attributes" },
    { 0x55FE7D8E, "cac_body_type" },
    { 0x6DDC04BF, "cac_bulletdamage_data" },
    { 0xDC703EFF, "cac_ccount" },
    { 0xE02B6315, "cac_cdesc" },
    { 0x8144F1CB, "cac_cgroup" },
    { 0x50CC7941, "cac_cimage" },
    { 0xE5CD9B55, "cac_cint" },
    { 0xAB2F9E4D, "cac_cint2" },
    { 0x83D5378E, "cac_classified" },
    { 0xD06CA9EF, "cac_cname" },
    { 0x4F466D8C, "cac_cost" },
    { 0x3ABD2B98, "cac_count" },
    { 0xA76D8379, "cac_creference" },
    { 0x2176E8C4, "cac_cstat" },
    { 0x611A2505, "cac_cstring" },
    { 0x330E2AD6, "cac_cunlock" },
    { 0xFB51BE93, "cac_data" },
    { 0x1E03BBDB, "cac_debug_damage_type" },
    { 0xBC38E8E7, "cac_debug_final_damage" },
    { 0x44C033A6, "cac_debug_location" },
    { 0xD62F69DE, "cac_debug_original_damage" },
    { 0xA28C8832, "cac_debug_range" },
    { 0xC417FA6F, "cac_debug_weapon" },
    { 0x1D71822E, "cac_explosivedamage_data" },
    { 0x5F99CEDD, "cac_faction" },
    { 0xDD71DDE6, "cac_fireproof_data" },
    { 0x76314C4E, "cac_flakjacket_data" },
    { 0x8BFAAAAF, "cac_flakjacket_hardcore_data" },
    { 0xA7D878E7, "cac_flakjacketmaxdamage_data" },
    { 0xB9093276, "cac_functions" },
    { 0xBA350413, "cac_get_dvar" },
    { 0x6A7CA5D9, "cac_get_dvar_int" },
    { 0x2D9EF891, "cac_getdata" },
    { 0x532A4098, "cac_group" },
    { 0xA7439627, "cac_hasspecialty" },
    { 0x627B0B21, "cac_hat_type" },
    { 0x817D5178, "cac_head_type" },
    { 0xCD945D1D, "cac_init" },
    { 0x5884FD2B, "cac_initialized" },
    { 0x5CD24A85, "cac_loadout" },
    { 0xFFB9A1DC, "cac_locked_weapon" },
    { 0x81DA62E7, "cac_max_item" },
    { 0x923DA066, "cac_modified_damage" },
    { 0x4C74DE55, "cac_modified_vehicle_damage" },
    { 0x368C9881, "cac_momentum" },
    { 0xD361BFD4, "cac_numbering" },
    { 0x6AED7D4A, "cac_reference" },
    { 0x5D88BB60, "cac_selector" },
    { 0xE3FD0200, "cac_size" },
    { 0x066BD00F, "cac_slot" },
    { 0x33818A4E, "cac_weaponref" },
    { 0xF78B42DD, "caca" },
    { 0x41C397AC, "cacge" },
    { 0x13326C99, "cache" },
    { 0x6CF31C13, "cache4_destroyed" },
    { 0xCC5DB719, "cache5_dest" },
    { 0xC7235C73, "cache5_dmg" },
    { 0xFED3D055, "cache7_clip" },
    { 0x042449D3, "cache7_dest" },
    { 0x0564776D, "cache7_pris" },
    { 0x3D6216FF, "cache_area" },
    { 0x93061BE8, "cache_bp1_clip" },
    { 0xE15A7472, "cache_bp1_dest" },
    { 0xFD765DDE, "cache_bp1_dmg" },
    { 0x59EDB3E8, "cache_bp1_origin" },
    { 0xB4855630, "cache_bp1_pris" },
    { 0xA7DBB9E3, "cache_bp2_dest" },
    { 0xE531FC7C, "cache_bp3_dest" },
    { 0x29667236, "cache_clip" },
    { 0xCE22DF40, "cache_dest" },
    { 0x2B18D945, "cache_destroyed" },
    { 0xF207B313, "cache_destroyed_bp1" },
    { 0xCFCF88C0, "cache_dmg" },
    { 0x23D5BD94, "cache_door" },
    { 0xAC5B623F, "cache_door_open" },
    { 0x62A7EAC4, "cache_guys" },
    { 0xB4DF95E2, "cache_hallway" },
    { 0x5217724A, "cache_pris" },
    { 0xE9B4EFFD, "cache_room" },
    { 0xA94F85A3, "cache_run" },
    { 0xA0F53615, "cache_run_jumpto" },
    { 0x29BA2B9F, "cached" },
    { 0xC47E1F12, "cached_assists" },
    { 0xD664B80D, "cached_downs" },
    { 0x71AD1153, "cached_headshots" },
    { 0x899D68A9, "cached_kills" },
    { 0x6E14BD98, "cached_revives" },
    { 0xB94AD774, "cached_score" },
    { 0x44A4B5C0, "cached_summary_challenge" },
    { 0x76FD7B8D, "cached_summary_xp" },
    { 0xACCC7460, "cached_zone" },
    { 0x71770DAA, "cached_zone_name" },
    { 0x0976E6E5, "cached_zone_volume" },
    { 0x70C3435F, "cachedinfo" },
    { 0x22E0BE47, "cacheentry" },
    { 0x7B28032F, "cacheing" },
    { 0x7FD07950, "caches" },
    { 0x3346ED49, "caches_lost" },
    { 0xB2B8398C, "caching" },
    { 0x9F4348FA, "cacmenustatoffset" },
    { 0xE475D21B, "cacophany" },
    { 0x30C1E51B, "cacrange" },
    { 0x80AA19F4, "cacthes" },
    { 0xC8ADFF09, "caddycorner" },
    { 0x859EE94E, "cafe" },
    { 0xD8B2C556, "cafe_area" },
    { 0xB86776E4, "cafe_wall_crumble" },
    { 0x835C003B, "cafx" },
    { 0x92BD2AD5, "cage" },
    { 0xC7403B03, "cagelight" },
    { 0xC1AD7024, "cages" },
    { 0x7EACD74E, "cairo_fxanims" },
    { 0xDE38483C, "cajoling" },
    { 0xE7A9AE2B, "cal" },
    { 0xCCECBA9D, "calbacks" },
    { 0x420D8F7A, "calc" },
    { 0xBDEF9402, "calc_closest_player_using_paths" },
    { 0xE1FE0968, "calc_dof" },
    { 0x1A159D8B, "calc_drone_path_size" },
    { 0x941C86F9, "calc_frac" },
    { 0xE358BA6B, "calc_offsets" },
    { 0x53440B83, "calc_post_delay" },
    { 0x23746D4F, "calc_ramp_in_lerp" },
    { 0x56C2EDA2, "calc_remaining_duration_lerp" },
    { 0x9CB28217, "calc_speed_trigger" },
    { 0x0A8CA3BE, "calc_time" },
    { 0xCC220448, "calcanimlengthvariables" },
    { 0x38BC3313, "calcapproximatepathtoposition" },
    { 0xCA8E8BF9, "calcdists" },
    { 0xFF38019D, "calcdof" },
    { 0x8E298CEA, "calcedgotopos" },
    { 0xB99AA24B, "calcent2dscreen" },
    { 0x5AC8B5A8, "calckillcamtime" },
    { 0xBBB66C73, "calclockonlossradius" },
    { 0x4E41DE8E, "calclockonradius" },
    { 0x2D7D7EEC, "calclookaheadpos" },
    { 0xF9707BFF, "calcpathlength" },
    { 0x3DD01129, "calcplayeroptions" },
    { 0x65A8F04D, "calcpostdelay" },
    { 0xEA0F83C5, "calcskill" },
    { 0xE6FF8325, "calcspawnorigin" },
    { 0x13AF6A38, "calcuates" },
    { 0x7A5C026F, "calculate" },
    { 0x11CC25B9, "calculate_bonusforclient" },
    { 0x7D9C7D57, "calculate_capture_event_zombies_needed" },
    { 0x57C11787, "calculate_count" },
    { 0xB4C543F3, "calculate_foliage_cover" },
    { 0x0CA9D738, "calculate_free_for_all_payouts" },
    { 0xB970A246, "calculate_link_time" },
    { 0xF19C9E4C, "calculate_map_center" },
    { 0xFA2DFAA7, "calculate_offset_position" },
    { 0x2F8DD175, "calculate_places_based_on_score" },
    { 0x2517FDD5, "calculate_player_position_offset" },
    { 0xDDFE8D16, "calculate_skillbonusforclient" },
    { 0x608B77A3, "calculate_spawn_position" },
    { 0xD92072C1, "calculate_team_payouts" },
    { 0xD66BC2B8, "calculate_tomahawk_damage" },
    { 0xCE3C6D51, "calculate_unlink_time" },
    { 0xF4463183, "calculatecoverdirection" },
    { 0xC4469DB2, "calculatecubicbezier" },
    { 0x361D3839, "calculated" },
    { 0x924E5C38, "calculatedefaultjukedirection" },
    { 0xD963413A, "calculatedogs" },
    { 0xD12C768B, "calculatefalltime" },
    { 0x3C7D8088, "calculatefreeforallpayouts" },
    { 0x10A9E9CF, "calculatejukedirection" },
    { 0xE01B0078, "calculatejukeinfo" },
    { 0x76267BD2, "calculatelocationinfo" },
    { 0x779BB176, "calculatenodeoffset" },
    { 0x6BD00866, "calculatenodeoffsetfromanimationdelta" },
    { 0xE664E24A, "calculatenodetransitionangles" },
    { 0xCA00D252, "calculatepath" },
    { 0x86E6F631, "calculatepath_r" },
    { 0xDED411BF, "calculateplacesbasedonscore" },
    { 0xDB134FC5, "calculatereleasetime" },
    { 0x9401F5B6, "calculates" },
    { 0xCC23883E, "calculatespawnorigin" },
    { 0x45E5C47D, "calculateteampayouts" },
    { 0x1DDDC9EA, "calculating" },
    { 0x6CEFA764, "calculation" },
    { 0xF4617F97, "calculations" },
    { 0x07844B40, "calcweaponoptions" },
    { 0x9C0A4160, "caled" },
    { 0xDED0BC55, "calibrating" },
    { 0x2F97384B, "calibration" },
    { 0x84012B6D, "call" },
    { 0xFCF70B9A, "call_airstrike" },
    { 0x74DD5ACB, "call_box" },
    { 0x184A3719, "call_box_array" },
    { 0x12AE669A, "call_box_think" },
    { 0x78FA5BD9, "call_box_used" },
    { 0xFB17076F, "call_boxes" },
    { 0x9237F37A, "call_custom_add_state_callbacks" },
    { 0x0A2EC220, "call_destination" },
    { 0x6B51BDFF, "call_exploder" },
    { 0xF9D5B5E2, "call_func" },
    { 0x8584C2FA, "call_loop" },
    { 0x116022E7, "call_loopsound" },
    { 0xCF69A798, "call_notetrack_handler" },
    { 0xCB494CAC, "call_oneshot" },
    { 0x643436AC, "call_out" },
    { 0x97754DB0, "call_out_wrong_clear" },
    { 0xC8647196, "call_overloaded_func" },
    { 0x710E3EE3, "call_resnov" },
    { 0x1FC22C3A, "call_strafe_nag" },
    { 0x89A6689A, "call_strafing_run" },
    { 0x724F34B1, "callairstrike" },
    { 0xAA44830F, "callartillerystrike" },
    { 0xDABBE128, "callback" },
    { 0x7CDECF4C, "callback_activate_exploder" },
    { 0xFBA682D3, "callback_actorcloned" },
    { 0x58830695, "callback_actordamage" },
    { 0xD8B85C1D, "callback_actorkilled" },
    { 0x9D38208C, "callback_actorkilled_burn_death" },
    { 0x1ACCB5D8, "callback_actorkilled_check" },
    { 0x244270FE, "callback_actorkilled_headshotcheck" },
    { 0x57D44FE8, "callback_actorspawned" },
    { 0x9ACFB03D, "callback_botentereduseredge" },
    { 0x94D24537, "callback_curvenotify" },
    { 0x7C9C3023, "callback_deactivate_exploder" },
    { 0x5CD8688A, "callback_demoactordamage" },
    { 0x1581ABF5, "callback_dolevelnotify" },
    { 0x978D5CFF, "callback_emp" },
    { 0x7F647925, "callback_func" },
    { 0x8CF2168F, "callback_horse_blood" },
    { 0x33DD227E, "callback_horse_hit_ground" },
    { 0x4C77DA13, "callback_hostmigration" },
    { 0x0F06C3FC, "callback_hostmigrationsave" },
    { 0x2AFC986F, "callback_killstreakactorkilled" },
    { 0xECA33C15, "callback_player_damage_only" },
    { 0x4288E3C7, "callback_player_knocked_out" },
    { 0x3C0D2FC2, "callback_playerconnect" },
    { 0x6E816103, "callback_playerdamage" },
    { 0x3AC6A6AE, "callback_playerdisconnect" },
    { 0x4C629EF3, "callback_playerkilled" },
    { 0x1C3FE1BD, "callback_playerkilledzt" },
    { 0x568DDDE0, "callback_playerlaststand" },
    { 0x2D14C1F4, "callback_playermelee" },
    { 0x238AEDD1, "callback_playermigrated" },
    { 0xB3A4B5BC, "callback_playerspawngenerateinfluencers" },
    { 0xB19D3447, "callback_playerspawngeneratespawnpointentitybasescore" },
    { 0x1C4C1953, "callback_prehostmigrationsave" },
    { 0xE4510CC3, "callback_preventplayerdamage" },
    { 0x01A338A6, "callback_proximity" },
    { 0x1ABB683F, "callback_reviveplayer" },
    { 0x585A7F3E, "callback_saverestored" },
    { 0x1CA9EAD4, "callback_spectator_respawn_custom_score" },
    { 0xC2D22707, "callback_startgametype" },
    { 0x8AE1D4CC, "callback_stunned" },
    { 0xB218C24B, "callback_track_dead_npcs_by_type" },
    { 0x66EED27A, "callback_vehicledamage" },
    { 0xBA80775A, "callback_vehiclekilled" },
    { 0xD28F6408, "callback_vehicleradiusdamage" },
    { 0xAE5E80C1, "callback_vehiclespawned" },
    { 0x8F2E7DAD, "callback_void" },
    { 0xD801D455, "callback_weapon_damage" },
    { 0x025419CE, "callback_weapon_watcher" },
    { 0x2229AE8A, "callbackactorcloned" },
    { 0xB535A4AC, "callbackactordamage" },
    { 0x10F15BEC, "callbackactorkilled" },
    { 0xF045B46F, "callbackactorspawned" },
    { 0xA223FE29, "callbackairsupport" },
    { 0xE1A623B6, "callbackbotentereduseredge" },
    { 0xF549B96B, "callbackclientflag" },
    { 0x71EFE275, "callbackcreatingcorpse" },
    { 0xCC9A9E76, "callbackdecorationawarded" },
    { 0xD41C0980, "callbackdogsoundnotify" },
    { 0x3B36608E, "callbackendherospecialistemp" },
    { 0xF9D520DB, "callbackentityshutdown" },
    { 0xB4538945, "callbackentityspawned" },
    { 0xEBE862A0, "callbackfunction" },
    { 0x51603B0E, "callbackhostmigration" },
    { 0x227CFAC5, "callbackhostmigrationsave" },
    { 0x840039EE, "callbacklocalclientconnect" },
    { 0x82C2FCB8, "callbackonnotify" },
    { 0x0731F70A, "callbackplayaifootstep" },
    { 0xA8937413, "callbackplayerconnect" },
    { 0x637BAEA8, "callbackplayerdamage" },
    { 0xB1E166C9, "callbackplayerdisconnect" },
    { 0xF1F27D08, "callbackplayerkilled" },
    { 0xD06256AD, "callbackplayerlaststand" },
    { 0x14531849, "callbackplayermelee" },
    { 0x6910CE02, "callbackplayermigrated" },
    { 0x95DE49B8, "callbackplayerrevive" },
    { 0x81B28293, "callbackplayerspawned" },
    { 0x679C4B2F, "callbackplayerspawngenerateinfluencers" },
    { 0x39C5C140, "callbackplayerspawngeneratespawnpointentitybasescore" },
    { 0x7BF94C43, "callbackplaylightloopexploder" },
    { 0x49221879, "callbackprecachegametype" },
    { 0x213E0520, "callbackprehostmigrationsave" },
    { 0x4FF287C3, "callbacks" },
    { 0x0262A24D, "callbacks_shared" },
    { 0x8718BEED, "callbacksaverestored" },
    { 0x48BEE92A, "callbackstartgametype" },
    { 0xA1FE98EB, "callbackvehicledamage" },
    { 0xA34BB94B, "callbackvehiclekilled" },
    { 0x15220A31, "callbackvehicleradiusdamage" },
    { 0x899AD962, "callbackvehiclespawned" },
    { 0x6F93F6F6, "callbackvoid" },
    { 0x01E52120, "callbox" },
    { 0x83799932, "callcount" },
    { 0xD7424209, "callcounteruav" },
    { 0x8E0A341A, "called" },
    { 0xBFEFEEDC, "called_from_spawner" },
    { 0x643B7356, "called_in_the_dogs" },
    { 0xCEA57520, "calledincarepackage" },
    { 0x7370F1DF, "calledincomlinkchopper" },
    { 0x4794EDA6, "calledout" },
    { 0x3A36CF7C, "caller" },
    { 0xCBA0D492, "callinf" },
    { 0xF1A34EFB, "calling" },
    { 0x68236BA5, "calling_card_stat" },
    { 0x1F6B53A6, "calling_card_stat_col" },
    { 0x49E4067D, "calling_intro_barrage" },
    { 0xD360AC4C, "callingplayer" },
    { 0xA5D98B58, "callmortarstrike" },
    { 0x7689FAF4, "callnapalmstrike" },
    { 0xC671030E, "callon" },
    { 0x9FD5A5F6, "calloptionalbehaviorcallback" },
    { 0x961CA3E3, "callout" },
    { 0x59B19CCF, "callout_near_dist" },
    { 0xB702EAD2, "callouts" },
    { 0x27BA5F6C, "calls" },
    { 0xB3EBFC0C, "callsatellite" },
    { 0x1DF0E58E, "callsign" },
    { 0xD2EF14E4, "callsign_seelow_a" },
    { 0xE9215631, "callsigns" },
    { 0x8578C05F, "callsleft" },
    { 0x290DD9A5, "callspyplane" },
    { 0x0A763143, "callstack" },
    { 0xC677BD7E, "callstations" },
    { 0x83574E7F, "callstrike" },
    { 0xCE3A612B, "callstrike_artillerybombeffect" },
    { 0xB49A71A6, "callstrike_bomb" },
    { 0xFBDA6FFD, "callstrike_bombeffect" },
    { 0x44C9D7E9, "callstrike_flareeffect" },
    { 0xB35ADE96, "callstrike_mortarbombeffect" },
    { 0x4B2BDA0D, "callstrike_planesound" },
    { 0x5DFEB104, "calm" },
    { 0x2FAAA0A2, "calm_down_reznov" },
    { 0x69152B81, "calmer" },
    { 0xF80BD864, "calming" },
    { 0x8D31D7B7, "calms" },
    { 0x001EF4D3, "calvary" },
    { 0xA5392CAF, "calvary_chopper" },
    { 0x8F5495BE, "calvary_guys" },
    { 0x68F9F568, "calvary_huey5_soldiers" },
    { 0xA625DE17, "calvary_huey5_think" },
    { 0xF3D0FA61, "calvary_huey_sound_swoosh" },
    { 0x8E1FE470, "calvary_huey_sound_think" },
    { 0x7BBDDD30, "calvary_huey_think" },
    { 0x138768C9, "calvary_main" },
    { 0x4971435B, "calvary_marines" },
    { 0x33B86E69, "calvary_marines_ignoreall_false" },
    { 0x69708F59, "calvary_positions_after_chopper" },
    { 0x14268073, "calvary_real_aa" },
    { 0x8C66A92F, "calvary_rpg_attacker" },
    { 0xE04D321F, "calvary_scene_start" },
    { 0x13325DD5, "calvary_setup" },
    { 0xE11585BB, "calvary_shoot" },
    { 0xF2016DC1, "calvary_targets_think" },
    { 0x2284C184, "calvary_unloaded" },
    { 0xC1A733C2, "cam" },
    { 0x05CE4131, "cam_angles" },
    { 0x808D0B09, "cam_animation" },
    { 0x6725DED9, "cam_corona" },
    { 0xD215EF5E, "cam_curve" },
    { 0xD5FA6BFB, "cam_customization_acv" },
    { 0x2FBA0227, "cam_customization_closed" },
    { 0xE2615D91, "cam_customization_focus" },
    { 0x7EBD83D9, "cam_customization_wo" },
    { 0x8D4FD25D, "cam_cut_ent" },
    { 0x4CC0E1FE, "cam_cut_info" },
    { 0xCD2F3A05, "cam_cut_look_ent" },
    { 0x969C08EB, "cam_cut_target_ent" },
    { 0xEB237D1D, "cam_debug_old_scene_name" },
    { 0xB474D5B8, "cam_ent" },
    { 0xFD5F9782, "cam_ent_name" },
    { 0xAF68063C, "cam_entity" },
    { 0x5D2D9F13, "cam_ents" },
    { 0x36D779E9, "cam_fvec" },
    { 0xC1110B6C, "cam_height" },
    { 0x64BCEDAE, "cam_height_pcnt" },
    { 0xC708CF8F, "cam_height_pos" },
    { 0x9F956EEA, "cam_height_range" },
    { 0x8BBF54FF, "cam_height_scaler" },
    { 0x368ACBA0, "cam_high_type" },
    { 0xEB217593, "cam_index" },
    { 0x744D166C, "cam_linkobj" },
    { 0x59E6DE5C, "cam_low_type" },
    { 0x456C60C5, "cam_max_height" },
    { 0x171483D7, "cam_min_height" },
    { 0xB8206098, "cam_model" },
    { 0xAEA1ADB5, "cam_model_func" },
    { 0xE0364DE1, "cam_model_targetname" },
    { 0x86150C73, "cam_models" },
    { 0xCED748B5, "cam_move_scale" },
    { 0x6A32E872, "cam_move_time" },
    { 0x06AC4886, "cam_movement" },
    { 0xB50EEED6, "cam_movement_threshold" },
    { 0x629CFE10, "cam_name" },
    { 0xE29D92E1, "cam_pos" },
    { 0xB0B1CAEF, "cam_pos_target" },
    { 0xC58F600B, "cam_scene" },
    { 0xCA88EA48, "cam_scene_anim_keys" },
    { 0x4B553AC5, "cam_scene_attributes" },
    { 0x522D9F6A, "cam_scenes" },
    { 0xF462BA53, "cam_scenes_names" },
    { 0x5CCF0E71, "cam_shot" },
    { 0xA7A99003, "cam_shot_id" },
    { 0x53534928, "cam_shot_index" },
    { 0xB70551D1, "cam_shot_key" },
    { 0x38260BD8, "cam_shots" },
    { 0xC786619E, "cam_start_shot" },
    { 0xEAF670B3, "cam_struct_targetname" },
    { 0x64E7288A, "cam_target" },
    { 0x4FEFD94A, "cam_target_ent_name" },
    { 0xA88472A4, "cam_target_linkobj" },
    { 0xDCF7E4C5, "cam_targets" },
    { 0x1DDD3B39, "cam_times" },
    { 0x879D033E, "cam_track" },
    { 0x81DC7732, "cam_track_face" },
    { 0x353F2E21, "cam_tracks" },
    { 0x6E15256A, "cam_view_on" },
    { 0xB69E6E1C, "cam_zoom" },
    { 0x3E384ACE, "camangles" },
    { 0x8D0F083B, "camanimscripted" },
    { 0x8D70CC93, "camcorder" },
    { 0xE94123CB, "came" },
    { 0x10FD3860, "camera" },
    { 0x0A7D0D62, "camera2" },
    { 0x7AD68739, "camera_2_ent" },
    { 0x556F2054, "camera_3_ent" },
    { 0xA7431E43, "camera_4_ent" },
    { 0x38C375BE, "camera_5_ent" },
    { 0x43CC05F5, "camera_6_ent" },
    { 0x45CD89E0, "camera_7_ent" },
    { 0x6A0B0C78, "camera_activate" },
    { 0x9243BF66, "camera_aim_update" },
    { 0x19F751C9, "camera_angle_offsets" },
    { 0x8C0CEF2D, "camera_angle_x" },
    { 0x660A74C4, "camera_angle_y" },
    { 0xD811E3FF, "camera_angle_z" },
    { 0x7BFAAC9B, "camera_angles" },
    { 0x36BC43D8, "camera_anim" },
    { 0xAF54704F, "camera_animation" },
    { 0x143E95B3, "camera_anims" },
    { 0xB77C3194, "camera_attach" },
    { 0xE5BB3A42, "camera_awareness" },
    { 0x0892A3F4, "camera_center" },
    { 0xB1D5CD62, "camera_control" },
    { 0x96AF8387, "camera_cut4" },
    { 0xBEB0B243, "camera_cuts_done" },
    { 0xC55242EA, "camera_death_watcher" },
    { 0x573B5810, "camera_debug" },
    { 0xB1C3393E, "camera_detach" },
    { 0xC3078D64, "camera_drift" },
    { 0x096736A6, "camera_ent" },
    { 0xEE8E1AD9, "camera_ents" },
    { 0x88AF0CF5, "camera_facing" },
    { 0x774349D3, "camera_flash" },
    { 0xB38D66C3, "camera_function" },
    { 0xAA924851, "camera_fx" },
    { 0xF9003909, "camera_glass" },
    { 0x6B6B400A, "camera_hud" },
    { 0xEDA682A5, "camera_hud_toggle" },
    { 0xA9093C32, "camera_light_fx" },
    { 0x1CDBD711, "camera_locked" },
    { 0x148B7F3A, "camera_look" },
    { 0xDEE697C1, "camera_lookat" },
    { 0x317DD69C, "camera_loop_think" },
    { 0x183253AE, "camera_mode" },
    { 0x80C24B4C, "camera_mode_look" },
    { 0xDD4E55E3, "camera_mode_orbit" },
    { 0x5FE05160, "camera_movement" },
    { 0x09961285, "camera_offset_" },
    { 0x6D688897, "camera_offset_x" },
    { 0x47660E2E, "camera_offset_y" },
    { 0x216393C5, "camera_offset_z" },
    { 0x1BDF8375, "camera_origin" },
    { 0x64B8061F, "camera_override" },
    { 0x9F2A447B, "camera_point" },
    { 0xB9BDE2A3, "camera_pos" },
    { 0x4A4B13FD, "camera_pre_offset_x" },
    { 0x24489994, "camera_pre_offset_y" },
    { 0x965008CF, "camera_pre_offset_z" },
    { 0xF344EB64, "camera_prev_snapto" },
    { 0xC3642393, "camera_primary" },
    { 0x54CEA531, "camera_restraint_for_pop" },
    { 0x422FD2E0, "camera_scan" },
    { 0x1DCCC27B, "camera_secondary" },
    { 0x9842841C, "camera_snapto" },
    { 0x07294198, "camera_spotlight_controller" },
    { 0xCF995FD5, "camera_start" },
    { 0x61185E48, "camera_start_ang" },
    { 0x89EE099A, "camera_start_loc" },
    { 0x0C8E1B16, "camera_start_pos" },
    { 0xF4735E83, "camera_start_time" },
    { 0x94B11B67, "camera_stop" },
    { 0x6DE7DDF8, "camera_struct" },
    { 0x71A68051, "camera_tag" },
    { 0x294D5C10, "camera_target" },
    { 0x701D9217, "camera_target_cut4" },
    { 0x1EA67FAF, "camera_target_override" },
    { 0x92C17449, "camera_think" },
    { 0x349DE905, "camera_tweak" },
    { 0x22DEBFAC, "camera_tween" },
    { 0xDBB3DE5A, "camera_v_angles" },
    { 0x21FC0574, "camera_v_origin" },
    { 0x5E9654A4, "camera_zoom_hud" },
    { 0x7198D073, "cameraactivate" },
    { 0x4ED62DCA, "cameraambientfx" },
    { 0x0494D8A0, "cameraangles" },
    { 0x2A9C93F1, "cameradestroyed" },
    { 0xBA005F44, "cameradummy" },
    { 0x024131DF, "cameraend" },
    { 0x6268D86F, "cameraent" },
    { 0x14472597, "cameraforward" },
    { 0x0CB631C4, "cameraglass" },
    { 0xE83D47E6, "camerahead" },
    { 0x137BCE7B, "cameralinkto" },
    { 0xA8BC89C8, "cameralinktocurve" },
    { 0x06D8F00C, "cameraone" },
    { 0xD602906E, "camerapos" },
    { 0xB11E220B, "cameras" },
    { 0x0E8BA058, "camerascannerfx" },
    { 0xE3592CF2, "camerasetlookat" },
    { 0x9DF5CF69, "camerasetposition" },
    { 0x19BA6F12, "cameraspike" },
    { 0x0818CB10, "cameraspikeactive" },
    { 0xB4E643C8, "cameraspikecountprevious" },
    { 0x744218B2, "cameraspikedetonate" },
    { 0x4BC25349, "cameraspikeenabled" },
    { 0xD512E2C0, "cameraspikehandle" },
    { 0x8BB41E1D, "cameraspikes" },
    { 0xAE689E6A, "cameraspiketoggle" },
    { 0xA6DF4614, "camerastart" },
    { 0x3F4A999B, "camerastruct" },
    { 0x751C7781, "cameraswitcher" },
    { 0xE6CE6DF5, "cameraswitchergraphiccontents" },
    { 0x1450FF4B, "cameratarget" },
    { 0x4D56E41D, "cameratween" },
    { 0xCD949E33, "cameratweenout" },
    { 0xB8C75AD5, "cameraunlink" },
    { 0xE31E97D6, "cameravec" },
    { 0x50A6E05C, "camerawithenemy" },
    { 0x33507057, "camerawithplayer" },
    { 0xBD29D3C2, "camers" },
    { 0x22CF119E, "cammo" },
    { 0xC7BCFA4C, "cammo_erdl" },
    { 0xDDEC8A5A, "cammo_gunmetal" },
    { 0x08BBB43F, "cammo_gunplastic" },
    { 0x1E740F92, "cammo_red" },
    { 0x920C1B74, "cammo_tan_enfield" },
    { 0xC39A46AD, "cammo_wood_tile_red" },
    { 0xCD500241, "camo" },
    { 0x511DB4EF, "camo_active_mult" },
    { 0xDE8067AA, "camo_all_actors" },
    { 0xDB557FF2, "camo_atacs" },
    { 0xE180A8AB, "camo_attacker_acc" },
    { 0x50800892, "camo_backup_time" },
    { 0x611F202C, "camo_battle_cleanup_anims" },
    { 0x2EAB178C, "camo_battle_friendly_stealth" },
    { 0x7B7DB160, "camo_battle_friendly_stealth_move" },
    { 0x8E0E4A89, "camo_battle_fx_boxes" },
    { 0xECE7D84E, "camo_battle_fx_light" },
    { 0x5D274A11, "camo_battle_gaz_retreat" },
    { 0xBD6427F2, "camo_battle_lift" },
    { 0x16BF38EE, "camo_battle_main" },
    { 0xDC2DECC7, "camo_battle_move_up_final" },
    { 0x0264756C, "camo_battle_stealth_assist" },
    { 0x5267F05E, "camo_battle_stealth_settings" },
    { 0xA4FE7CB4, "camo_battle_stealth_success_vo" },
    { 0x4029EEAA, "camo_battle_stealth_watch" },
    { 0x31018EFC, "camo_bloodshot" },
    { 0xDA48EB60, "camo_blue_tiger" },
    { 0xF026EB72, "camo_bread_crumb" },
    { 0x6F5DB838, "camo_bread_crumb_delete" },
    { 0xF3C24946, "camo_bread_crumb_wait" },
    { 0x968C4EB3, "camo_brockhaurd" },
    { 0xE439817B, "camo_carbon" },
    { 0xD2743186, "camo_choco" },
    { 0xA60426CB, "camo_damage_callback" },
    { 0xCDC8B2EA, "camo_death" },
    { 0x2D3AA5AF, "camo_desert_nevada" },
    { 0xAA097E44, "camo_desert_sahara" },
    { 0x234E19E7, "camo_devgru" },
    { 0xB2E794FE, "camo_drop_chance" },
    { 0xD37267B7, "camo_emp_behavior" },
    { 0x1BA79F3D, "camo_emp_behavior_anim" },
    { 0xFFC220FC, "camo_emp_behavior_interruption_monitor" },
    { 0xBB4142A0, "camo_fail" },
    { 0xD8DBB3D8, "camo_flecktarn" },
    { 0x34D36AFA, "camo_flora" },
    { 0x3078D9EE, "camo_gadget_off" },
    { 0x700380C0, "camo_gadget_on" },
    { 0xE91200C9, "camo_ghostek" },
    { 0xD4337C36, "camo_gold" },
    { 0x21C54BF8, "camo_index" },
    { 0x3086536A, "camo_intro_camo_ai" },
    { 0x649E00BF, "camo_intro_harper" },
    { 0x8A75E10C, "camo_intro_landing_vo" },
    { 0xACC87846, "camo_intro_main" },
    { 0x18819FD4, "camo_intro_narrow_view" },
    { 0x207F8FA5, "camo_intro_squad" },
    { 0xF4892FF6, "camo_intro_stealth_settings" },
    { 0xCD60B04E, "camo_intro_threaded" },
    { 0x558BA1F7, "camo_is_flickering" },
    { 0x6B246A0F, "camo_is_inuse" },
    { 0x816516BB, "camo_jungle_erdl" },
    { 0xE5B7586B, "camo_jungle_tiger" },
    { 0xE8C7D5CC, "camo_kryptek" },
    { 0xD5F349F9, "camo_loop_audio" },
    { 0xE6F03EF4, "camo_mask" },
    { 0x1D6E5441, "camo_mighty_mason" },
    { 0x4BA750D6, "camo_mighty_mason_fx" },
    { 0x6B8B01BB, "camo_mp" },
    { 0x725B3285, "camo_name" },
    { 0x635F0299, "camo_nevada" },
    { 0x2770626A, "camo_none" },
    { 0x270A4384, "camo_num" },
    { 0xAF133C03, "camo_off" },
    { 0x7F56E8CF, "camo_on" },
    { 0x7AF2CDE4, "camo_on_connect" },
    { 0x3F5BF600, "camo_on_disconnect" },
    { 0x63B9579A, "camo_on_flicker" },
    { 0x58EFBFED, "camo_on_give" },
    { 0x2FD91EC7, "camo_on_spawn" },
    { 0x9DA1D50F, "camo_on_take" },
    { 0x7C48598E, "camo_patrol" },
    { 0x6ADCA138, "camo_removed" },
    { 0x562CA1E1, "camo_reveal_time" },
    { 0x9D758ECF, "camo_russia" },
    { 0xD0DFF166, "camo_sahara" },
    { 0xB3B649CB, "camo_sound_ent" },
    { 0x44998FE3, "camo_state" },
    { 0xB2836CD2, "camo_state_switch_time" },
    { 0x65AC859E, "camo_stealth_loop" },
    { 0x5DF441E0, "camo_stealth_positive_listener" },
    { 0x07201029, "camo_suit_equipped" },
    { 0x1CECFD6A, "camo_suit_flicker" },
    { 0xA8782D71, "camo_suit_off" },
    { 0x0F3F3669, "camo_suit_snd_ent" },
    { 0xBE123CC6, "camo_suit_think" },
    { 0xE4B1D75D, "camo_takedown_watch" },
    { 0x1FC332A6, "camo_temporary_dont_ignore" },
    { 0x5EC0C7BA, "camo_temporary_dont_ignore_wait" },
    { 0x3E5B8974, "camo_titus_replenish" },
    { 0x06FA3B83, "camo_transition_time" },
    { 0x2C2413C1, "camo_turnoff_model_render" },
    { 0x9BA9BECC, "camo_type" },
    { 0xC75A5F11, "camo_urban_german" },
    { 0xD104FC66, "camo_urban_warsaw" },
    { 0xB918F879, "camo_val" },
    { 0x39A21497, "camo_variant" },
    { 0x54637049, "camo_visible_dist" },
    { 0x222A48EB, "camo_visible_dist_monsoon" },
    { 0xEA613F62, "camo_visible_dist_yemen" },
    { 0x37EF46ED, "camo_vision_set_naked" },
    { 0xDA765750, "camo_weapon" },
    { 0x4F9F37DB, "camo_winter_siberia" },
    { 0xF4B89EE4, "camo_winter_yukon" },
    { 0x2CF6B9A0, "camo_woodland" },
    { 0xB6AD5FF7, "camo_woodland_flora" },
    { 0xBA3B682E, "camoed" },
    { 0x86BECE43, "camoindex" },
    { 0x184E431D, "camomelee_challenge" },
    { 0xA6AA84E8, "camooff" },
    { 0xE3752968, "camos" },
    { 0x60217209, "camoshaderoff" },
    { 0x66F2D7FD, "camoshaderon" },
    { 0x39F18D59, "camouflage" },
    { 0xFB20EC76, "camp" },
    { 0xB25B86EE, "camp_center" },
    { 0xD005956B, "camp_entered_trigger" },
    { 0x18F64E5B, "camp_patrollers" },
    { 0xC1619FBC, "camp_points" },
    { 0x5F5B5C0C, "camp_response" },
    { 0x2C0570E4, "camp_response_interval" },
    { 0x804FE4DF, "camp_sitters" },
    { 0xAA4811B2, "camp_time" },
    { 0x51EFDC50, "camp_unloaders" },
    { 0x249F8D43, "campaign" },
    { 0x307B0F99, "campaign_level_num" },
    { 0xD02B42ED, "campaign_state" },
    { 0xF0F41BB2, "campaigns" },
    { 0x3304C201, "campains" },
    { 0xDA60E039, "camped" },
    { 0xC8B37C0B, "camper_detection" },
    { 0x334E1CBB, "camper_guy" },
    { 0xCC4D89A7, "camper_trigger_think" },
    { 0xA1345D72, "campfire" },
    { 0xCCC11FFB, "campfire_fightstart" },
    { 0xF0F086B2, "campfire_guys_dead" },
    { 0x0225B87F, "campfire_guys_setup" },
    { 0xB45F41EA, "camping" },
    { 0x8AB0331D, "camping_loc" },
    { 0x9F6E955C, "camping_locs" },
    { 0xA5A5A0DF, "camping_think" },
    { 0xA313228E, "camping_time" },
    { 0xD9F334F4, "campos" },
    { 0x03BC3569, "camps" },
    { 0x498B6C37, "camptown_battle" },
    { 0xD51E720D, "cams" },
    { 0x76199F89, "camsys" },
    { 0xCE8A5AB2, "camsys_init" },
    { 0x4AE58A7D, "camtime" },
    { 0x9BA4B959, "can" },
    { 0xD725A622, "can1" },
    { 0xB1232BB9, "can2" },
    { 0x7C834677, "can_always_see" },
    { 0x877CE1C0, "can_attack" },
    { 0xF4B68860, "can_attacker_banzai_melee" },
    { 0x34875EEF, "can_attract" },
    { 0x2831911C, "can_banzai_melee" },
    { 0xBDDF8EEC, "can_be_deleted_from_area" },
    { 0xCEAF0408, "can_be_deleted_from_buried_special_zones" },
    { 0x604D7E0E, "can_be_deleted_from_maze_area" },
    { 0xE44FFFBB, "can_be_deleted_from_start_area" },
    { 0xE96D8C1D, "can_be_furious" },
    { 0x236794C2, "can_be_meleed" },
    { 0x847170DA, "can_be_paralyzed" },
    { 0xCD9C562F, "can_be_seen" },
    { 0x80836681, "can_become_rusher" },
    { 0xE2356A79, "can_buy_elevator" },
    { 0x90376C03, "can_buy_perk" },
    { 0xF4D54A27, "can_buy_weapon" },
    { 0x1F2C7B4E, "can_buy_weapon_extra_check_func" },
    { 0xD01E9DE3, "can_cannon" },
    { 0x94DA7708, "can_claim" },
    { 0xF7913309, "can_contest_claim" },
    { 0x49618A25, "can_craft_shared_piece" },
    { 0x68C2701E, "can_defuse" },
    { 0x05D349AD, "can_delete" },
    { 0x3BFCB22E, "can_die" },
    { 0xF2C0627E, "can_do_input" },
    { 0xCE6BFD08, "can_drain_points" },
    { 0xBC8DEDAA, "can_emp" },
    { 0x6450AF86, "can_end_ghost_round" },
    { 0xCD995C9F, "can_enter_func" },
    { 0x2E4E3A22, "can_enter_main" },
    { 0x0861B7A7, "can_equal_max" },
    { 0xADBBD919, "can_equal_min" },
    { 0x082207C1, "can_exit_func" },
    { 0x82BE070B, "can_explode" },
    { 0xF19D5518, "can_fail" },
    { 0x97C47BA8, "can_fire" },
    { 0xACB743B5, "can_fire_turret" },
    { 0xCBDF83DF, "can_fit_on_nav_mesh" },
    { 0xA230F9A3, "can_follow" },
    { 0x293281A2, "can_get_in" },
    { 0x92DEB76A, "can_gib_zombies" },
    { 0x6062C37F, "can_give" },
    { 0x80BCA777, "can_give_armor" },
    { 0x760823A2, "can_give_laststand" },
    { 0x99BFA577, "can_go_inert" },
    { 0xA5A73067, "can_hack" },
    { 0x7E92BE97, "can_hint" },
    { 0x7C974479, "can_hit_target" },
    { 0x26BCA6DC, "can_initiateaivsaimelee" },
    { 0x6A573565, "can_interact_with" },
    { 0xA4EE68A9, "can_intersect_player" },
    { 0x4D1B22BF, "can_juke" },
    { 0xB57EE460, "can_jump" },
    { 0xA4F97767, "can_jump_down" },
    { 0xD257637C, "can_jump_ground_to_ground" },
    { 0xD1C640F8, "can_jump_up" },
    { 0xB8671742, "can_leap" },
    { 0x603C6F5D, "can_look" },
    { 0xFAAE2B80, "can_melee" },
    { 0x3D7A6C73, "can_move" },
    { 0xED1050C4, "can_move_with_bolt" },
    { 0xBC35E7A3, "can_not_sing" },
    { 0x160C23CC, "can_num" },
    { 0xF06679FC, "can_open" },
    { 0x230466AA, "can_pack_weapon" },
    { 0x1A3730A6, "can_path_straight_up" },
    { 0x14BCB114, "can_pick_up_equipment" },
    { 0xD2134E5D, "can_pick_up_in_last_stand" },
    { 0x7A8B63B8, "can_pickup" },
    { 0xD19C6953, "can_pickup_staff" },
    { 0x48256F6B, "can_plant" },
    { 0x811527ED, "can_play_dialog" },
    { 0x726BC456, "can_player_banzai_melee" },
    { 0x1811368B, "can_player_purchase" },
    { 0x212A5CBA, "can_player_purchase_perk" },
    { 0xDC83068C, "can_player_see_me" },
    { 0x0028D3D4, "can_player_speak" },
    { 0xD19C937B, "can_player_takedown" },
    { 0x9417A75B, "can_process_contracts" },
    { 0xE2C37978, "can_rappel_brake" },
    { 0x883C1D0D, "can_rappel_now" },
    { 0x26115C14, "can_reach_enemy" },
    { 0xB6FBD63D, "can_recover_turret" },
    { 0xE719AA0C, "can_reuse" },
    { 0xE3C7472F, "can_revive" },
    { 0xAE6CED2B, "can_revive_game_module" },
    { 0x6571367A, "can_revive_override" },
    { 0xC04A7D54, "can_revive_use_depthinwater_test" },
    { 0x634AAF59, "can_revive_via_override" },
    { 0xF2C22B45, "can_roll" },
    { 0x3B6D64E5, "can_say_vo" },
    { 0x7EE3D9CD, "can_see" },
    { 0x9CF6BF5B, "can_see_a_player" },
    { 0x7E34E6E8, "can_see_buildings_on_zodiac" },
    { 0x7697E4B2, "can_see_convoy" },
    { 0xF35EBB55, "can_see_dot" },
    { 0x0C01B034, "can_see_enemy" },
    { 0xF7CCF51A, "can_see_from_array" },
    { 0x0D5237F4, "can_see_moveto" },
    { 0x3075A0D6, "can_see_other" },
    { 0xFDF8052F, "can_see_player" },
    { 0x3384B30E, "can_see_player_start_time" },
    { 0x1F16DAD5, "can_see_player_time" },
    { 0xD60C8C79, "can_see_position" },
    { 0xE96CB1D5, "can_see_projected_crosshair" },
    { 0xB8376586, "can_see_squad" },
    { 0xDECAD22B, "can_see_target" },
    { 0x983234DC, "can_see_trap_dist" },
    { 0xDE34C111, "can_see_trap_dot" },
    { 0xD1B7628A, "can_set_aar_stat" },
    { 0x575928D9, "can_shoot" },
    { 0x08C53111, "can_spawn" },
    { 0xDEBF3FB0, "can_spawn_pickup" },
    { 0x7019DDE9, "can_spawn_richtofen_zombie" },
    { 0x814E2972, "can_spawn_turret" },
    { 0x1085B097, "can_speed_up" },
    { 0x1F509D0C, "can_spike_meat" },
    { 0x843C94B0, "can_start_anim" },
    { 0xF146ACF8, "can_start_generator_power_up_anim" },
    { 0x636E4F99, "can_start_ghost_round" },
    { 0x8BF154F4, "can_start_ghost_round_presentation" },
    { 0x346B6743, "can_start_ghost_round_presentation_stage_1" },
    { 0xC263F808, "can_start_ghost_round_presentation_stage_2" },
    { 0xE8667271, "can_start_ghost_round_presentation_stage_3" },
    { 0x4FB4D3CC, "can_stop_anim" },
    { 0xAFFCED6E, "can_stop_turning" },
    { 0xD9F29410, "can_suicide" },
    { 0x21FF80CD, "can_swap" },
    { 0x53616D7E, "can_swap_attachments" },
    { 0xF25EEFB2, "can_take_part_in_banzai_attack" },
    { 0x64D3C6F9, "can_takedown" },
    { 0xBD815EF5, "can_throw_nade" },
    { 0x2DFAD5D8, "can_time_bomb_restore_data_on_player" },
    { 0x9360E9E5, "can_touch_meat" },
    { 0xEAD7EF56, "can_track_ammo" },
    { 0xB5387AFC, "can_turret_hit_target" },
    { 0xD52C4732, "can_turret_shoot_target" },
    { 0xE57EC1D3, "can_upgrade_weapon" },
    { 0x2D3C914D, "can_use" },
    { 0x13DA1096, "can_use_chaff" },
    { 0xD9404E68, "can_use_equipment" },
    { 0x507C1196, "can_use_filter" },
    { 0x0AC7B5A1, "can_use_mansion_back_flying_out_node" },
    { 0x4A07067B, "can_we_spawn_raps" },
    { 0xC9A93265, "can_zombie_path_to_any_player" },
    { 0x9DE8A8DB, "can_zombie_see_any_player" },
    { 0x8285B6DA, "canal" },
    { 0xDEDF982A, "canattach" },
    { 0xAD1A940B, "canattackenemynode" },
    { 0x698C2084, "canautobalance" },
    { 0x211C2593, "canbe_retaken" },
    { 0x467B618F, "canbeflanked" },
    { 0x3DC1E29C, "canbeflankedservice" },
    { 0xB48D7031, "canbeplaced" },
    { 0x8B624D70, "canbetargetedbyturnedzombies" },
    { 0x9704D4B3, "canbigdogturretshoottarget" },
    { 0x89CFDADB, "canbleed" },
    { 0x19A075AE, "canblindfire" },
    { 0xA1AE3CCB, "cancel" },
    { 0xAD4A3C97, "cancel speaking" },
    { 0x9A0A3264, "cancel_anim_reach_hudson_melee" },
    { 0xEAE92172, "cancel_button_press" },
    { 0xDDE283EB, "cancel_button_think" },
    { 0xC342A02F, "cancel_callback" },
    { 0x00443918, "cancel_carryqrdrone" },
    { 0x36096AAE, "cancel_enemy_radius_check" },
    { 0x3B3B045E, "cancel_facial_recognition" },
    { 0x0E8D3767, "cancel_flags" },
    { 0x89A66743, "cancel_generator_attack_if_player_gets_close_to_generator" },
    { 0xB56FA105, "cancel_kill_dialog" },
    { 0x4BFFBEB3, "cancel_location" },
    { 0xAA6F899D, "cancel_notify" },
    { 0xEBF3B725, "cancel_on_use" },
    { 0xDA9C53CB, "cancel_on_use_specific_button" },
    { 0x93223419, "cancel_promotion" },
    { 0x4D6872CC, "cancel_safe_spawn_button" },
    { 0x8AB32671, "cancel_safe_spawn_callback" },
    { 0x8DAE7FFC, "cancel_selection" },
    { 0xDA11BA42, "cancel_text_create" },
    { 0x0A0D2379, "cancel_timer_on_end" },
    { 0xE5BDBB5A, "cancel_use_button" },
    { 0xD1315CD1, "cancel_waittill_melee" },
    { 0xDD560A5B, "cancelable" },
    { 0x8642A7FE, "cancelaimove" },
    { 0x76326201, "cancelambushround" },
    { 0x423EBA00, "canceled" },
    { 0x01926278, "cancelgesture" },
    { 0x358B5B46, "cancelgoal" },
    { 0x5241A915, "canceling" },
    { 0xA706BFAC, "cancelkillcam" },
    { 0x587662FD, "cancelkillcamcallback" },
    { 0x582BCD24, "cancelkillcamonuse" },
    { 0x6E8C704B, "cancelkillcamonuse_specificbutton" },
    { 0x9D74CBD8, "cancelkillcamsafespawnbutton" },
    { 0x3BF8C5E5, "cancelkillcamsafespawncallback" },
    { 0x64C2686D, "cancelkillcamusebutton" },
    { 0x5681292C, "cancellation" },
    { 0x39F5FD3A, "cancelled" },
    { 0x86B1E461, "cancelongameend" },
    { 0x6D8D520D, "cancelonplayerdisconnect" },
    { 0x2E7FB506, "cancelrunningdeath" },
    { 0x9585ED2A, "cancels" },
    { 0xFF655EE3, "canceltackinsertionbutton" },
    { 0x7222354D, "canceltaunt" },
    { 0xBD9F5E55, "cancer" },
    { 0x40930F7A, "canchangestanceatcovercondition" },
    { 0xF8D71EE7, "canclaim" },
    { 0x86D8303F, "canclaimnode" },
    { 0x3CFB69AF, "cancled" },
    { 0x51F3D529, "cancontestclaim" },
    { 0x5A2C2923, "cancontinuetomelee" },
    { 0x603BF516, "cancreateflagatvictimorigin" },
    { 0x922500FB, "cancrouch" },
    { 0x67079016, "candamage" },
    { 0x04BAA226, "candeliverpkg" },
    { 0x1BB45080, "candidate" },
    { 0x93D32D2C, "candidate_goalpos" },
    { 0xBD3FBECB, "candidate_list" },
    { 0xA90CAF01, "candidatedistancesqr" },
    { 0x28A3FFB9, "candidateposition" },
    { 0x2FF7B6AB, "candidates" },
    { 0x5D8935FF, "candisable" },
    { 0x4EC1095E, "candle" },
    { 0xA5B09FAA, "candle_lights" },
    { 0xAEF18542, "candle_wiggle" },
    { 0x511903C1, "candles" },
    { 0x63A84BFA, "cando" },
    { 0x8FEADB0E, "candobalcony" },
    { 0xF80930E6, "candocombat" },
    { 0xBDF83899, "candocqbtransition" },
    { 0xCC229FBD, "candofiredamage" },
    { 0xB6A6A3EC, "candopronecombat" },
    { 0xA22433AB, "candorambo" },
    { 0x1E33EC71, "candropbuskey" },
    { 0xE45895AA, "candropsafekey" },
    { 0x0FD4E75C, "candy" },
    { 0x7C631D27, "candy_bench" },
    { 0xB92F471C, "candy_builds" },
    { 0x117193E8, "candy_context" },
    { 0x30FF14B2, "candy_model" },
    { 0x0F02CCEB, "candy_piece" },
    { 0x9D294B34, "candy_player" },
    { 0x7DB41D74, "candybuildable" },
    { 0x8E694EF6, "cane" },
    { 0x344AE40D, "canexecutemeleesequenceoverride" },
    { 0xFA073B05, "canexert" },
    { 0xC92986F0, "canfitprone" },
    { 0x10FA5CF1, "canflank" },
    { 0xD6F1845E, "canforwardstep" },
    { 0xF98B28A5, "cangib" },
    { 0x0DF87BE2, "cangiblegs" },
    { 0x5103002B, "cangoprone" },
    { 0x2DA5255D, "cangopronehere" },
    { 0x4C75B303, "canh" },
    { 0x75B84E32, "canhack" },
    { 0x493C321D, "canhitsuppressspot" },
    { 0x3F96250B, "canim" },
    { 0x498BC717, "caninteractwith" },
    { 0x6F180198, "caninteractwithplayer" },
    { 0xFBE8E4D6, "canister" },
    { 0xDA0C0C08, "canister2_burst1" },
    { 0xA91E9728, "canister2_burst10" },
    { 0xCF211191, "canister2_burst11" },
    { 0xF5238BFA, "canister2_burst12" },
    { 0x4C137B43, "canister2_burst2" },
    { 0x261100DA, "canister2_burst3" },
    { 0x98187015, "canister2_burst4" },
    { 0x7215F5AC, "canister2_burst5" },
    { 0xE41D64E7, "canister2_burst6" },
    { 0xBE1AEA7E, "canister2_burst7" },
    { 0xCFFAB329, "canister2_burst8" },
    { 0xA9F838C0, "canister2_burst9" },
    { 0xFF975D22, "canister_burst1" },
    { 0xDD6F4316, "canister_burst10" },
    { 0x0371BD7F, "canister_burst11" },
    { 0x916A4E44, "canister_burst12" },
    { 0xD994E2B9, "canister_burst2" },
    { 0xB3926850, "canister_burst3" },
    { 0xBDA3C12F, "canister_burst4" },
    { 0x97A146C6, "canister_burst5" },
    { 0x719ECC5D, "canister_burst6" },
    { 0x4B9C51F4, "canister_burst7" },
    { 0x55ADAAD3, "canister_burst8" },
    { 0x2FAB306A, "canister_burst9" },
    { 0x6C200A4D, "canister_col" },
    { 0x11D45487, "canister_start" },
    { 0xF8F186D2, "canisterindex" },
    { 0x20640349, "canisters" },
    { 0xE4C60DFE, "canjointeam" },
    { 0x91F32416, "canjuke" },
    { 0x080E7735, "canjukecondition" },
    { 0x6053FACD, "canlean" },
    { 0x961C882F, "canlockon" },
    { 0x2A0A66CF, "canmelee" },
    { 0xD16EEA5E, "canmeleeanyrange" },
    { 0xBB59C252, "canmeleedesperate" },
    { 0xB35B7D30, "canmeleeinternal" },
    { 0xC908E4FE, "canmove" },
    { 0xE6A91466, "canmoveclosetoenemycondition" },
    { 0x3149C942, "canmovetoenemycondition" },
    { 0xC2966502, "canned" },
    { 0x32A0D885, "canned_combat_1" },
    { 0x58A352EE, "canned_combat_2" },
    { 0x2F2E240D, "canned_death" },
    { 0x88038D96, "cannon" },
    { 0x28D05BF6, "cannon_effect" },
    { 0x5B08B673, "cannonaccuracyradiusmax" },
    { 0xDDF3F87D, "cannonaccuracyradiusmin" },
    { 0x486A1199, "cannonpower" },
    { 0x9140AC8D, "cannonrange" },
    { 0x14B06A4C, "cannonrangesquared" },
    { 0x6D1E7509, "cannons" },
    { 0xCC3A129C, "cannot" },
    { 0xD88F680F, "cannot_die" },
    { 0x712E5452, "cannotattachtobus" },
    { 0x52CF39D6, "canon_icon" },
    { 0x7B2D18F5, "canopies" },
    { 0x48892B0D, "canopy" },
    { 0xD6474B0C, "canopy_shut_end" },
    { 0x3E7F66A7, "canopy_shut_start" },
    { 0x2A8372CC, "canpath" },
    { 0xE2ACDF20, "canpickupobject" },
    { 0xFB7FC0CB, "canplaceriotshield" },
    { 0xAFFA5DFD, "canplayerplaceturret" },
    { 0x4B283825, "canplayerplacevehicle" },
    { 0xD53EBD4E, "canplayersuicide" },
    { 0x935463A2, "canprocesschallenges" },
    { 0x639FE576, "canrambo" },
    { 0xC7004F71, "canreacttonewenemyagain" },
    { 0x0E152C19, "canreacttoneweventagain" },
    { 0xA8D99E50, "canreadtext" },
    { 0xABA4B5B1, "canreturntocover" },
    { 0x2230805E, "canrevive" },
    { 0xE03BF683, "canreviveothers" },
    { 0xFD4FD35A, "cansave" },
    { 0xA35D190A, "cansay" },
    { 0xFD66D397, "cansayname" },
    { 0x75754E3A, "cansee" },
    { 0x752147E1, "cansee_override" },
    { 0x20C5F30C, "canseeandshootpoint" },
    { 0x227B7A40, "canseeany" },
    { 0x5699CBD6, "canseeenemy" },
    { 0x9DA987DB, "canseeenemycount" },
    { 0xA7EB93B6, "canseeenemyfromexposed" },
    { 0xF6581FB3, "canseeenemyfromposition" },
    { 0xF9D924FF, "canseeenemywrapper" },
    { 0x9F19E0D2, "canseepathgoal" },
    { 0x126931B0, "canseepoint" },
    { 0xAEA7CD90, "canseepointfromexposedatcorner" },
    { 0x6CB96917, "canseepointfromexposedatnode" },
    { 0x1795FDAA, "canseepointfromexposedatnodewithoffset" },
    { 0x843BB29D, "canseetarget" },
    { 0x3ADC4BD2, "canseeupgradetrigger" },
    { 0x5DBCD881, "canshock" },
    { 0x55D7881A, "canshoot" },
    { 0xFD3FF7A1, "canshootat" },
    { 0x88B4120C, "canshootcrouch" },
    { 0x7BEDE136, "canshootenemy" },
    { 0x1AAB61A2, "canshootenemyfrom" },
    { 0x138F17E1, "canshootenemyfrompose" },
    { 0xE5121018, "canshootenemypos" },
    { 0x5A7F36C8, "canshootfromprone" },
    { 0x47374C2C, "canshootpos" },
    { 0x60C27F74, "canshootprone" },
    { 0x4415ADA6, "canshootstand" },
    { 0x2975277D, "canshoottarget" },
    { 0x2FE57C36, "canshootwhilerunning" },
    { 0xA659D38D, "canshootwhilerunningbackward" },
    { 0x6A6F6BDD, "canshootwhilerunningforward" },
    { 0x8DE48F48, "canshootwhilerunningforward120" },
    { 0xCB6C575F, "canshuffletonode" },
    { 0x6C3E2E6E, "cansidestep" },
    { 0xDFB97E72, "canspawn" },
    { 0xF6E419EF, "canspawncount" },
    { 0x7F9A0C9B, "canspawngroup" },
    { 0x8EB92058, "canspawninoneframe" },
    { 0x78A10CDE, "canspawnthink" },
    { 0xCE584800, "canspawnturret" },
    { 0xFE529DB7, "canstand" },
    { 0xC020EDDC, "canstopcallback" },
    { 0xDF255DB8, "canstoppeeking" },
    { 0x5E8D2D60, "canstrafe" },
    { 0xC0840C6B, "canstrafebackward" },
    { 0x35785C97, "canstrafeforward" },
    { 0x15320D09, "canstumble" },
    { 0x894F701D, "canstun" },
    { 0x50FBDFF0, "cansuppressenemy" },
    { 0x67B08D60, "cansuppressenemyfromexposed" },
    { 0xE931AD73, "canswitchsides" },
    { 0x14936FEF, "cant" },
    { 0x91968D46, "cant_dismount_here" },
    { 0x55E54547, "cant_dismount_hint" },
    { 0x06753812, "cant_melee" },
    { 0x59BCDBF1, "cant_move" },
    { 0x03545867, "cant_move_cb" },
    { 0xBFF9FE84, "cant_see_any_player" },
    { 0x5E4491CB, "cant_see_count" },
    { 0x65801466, "cant_see_enemy_count" },
    { 0xF663699C, "cantacticaljukecondition" },
    { 0x47CB87EF, "cantakepaincondition" },
    { 0xCB4D748E, "cantanksee" },
    { 0x11314D12, "cantarget" },
    { 0xDF041F7F, "cantarget_turret" },
    { 0x05EBE4BD, "cantargetactor" },
    { 0x112467FE, "cantargetactor_turret" },
    { 0x17FBFB6D, "cantargetai_missile" },
    { 0x79364E09, "cantargetai_turret" },
    { 0x60BEFFCD, "cantargetdog_missile" },
    { 0x19B92BE9, "cantargetdog_turret" },
    { 0x4CB322CF, "cantargetentity" },
    { 0xF5D78EFD, "cantargetplayer" },
    { 0x4D4F7A98, "cantargetplayer_missile" },
    { 0xE6412E3E, "cantargetplayer_turret" },
    { 0xFDC93B37, "cantargetplayerwithspecialty" },
    { 0x585AB927, "cantargettank_turret" },
    { 0xD6A408C9, "canteen" },
    { 0x80ED1320, "cantfindanythingtodo" },
    { 0xDFEE2BD7, "canthrowgrenade" },
    { 0x9C152763, "canthrowgrenadepos" },
    { 0xCA327B47, "cantina" },
    { 0xFCC63433, "cantraceto" },
    { 0x8FDF0F49, "cantransferriotshield" },
    { 0x3F21AB5A, "cantseeenemybehavior" },
    { 0xB5465829, "cantseeenemycount" },
    { 0xBFE5B5F7, "cantseeenemywait" },
    { 0x972765B1, "cantseeentities" },
    { 0x518760F9, "canupdateweaponcontractstats" },
    { 0xFCD2D156, "canuse" },
    { 0xD62A5CD6, "canuseblindaiming" },
    { 0x9A6C8FB3, "canuselaser" },
    { 0x0006E822, "canuselauncher" },
    { 0xB23E8A6B, "canuseobject" },
    { 0x721F2F11, "canusesawapproach" },
    { 0xDD4EF274, "canuseturret" },
    { 0xF2FFE4C5, "canyon" },
    { 0x7BA60C54, "canyons" },
    { 0x203DA563, "canyonwind" },
    { 0xC83A74DA, "canzombieongoofall" },
    { 0x4F9FC487, "cap" },
    { 0x5119BB9C, "cap0_index" },
    { 0x9908F26C, "cap1" },
    { 0xC9018435, "cap1_index" },
    { 0x2934063E, "cap2_index" },
    { 0xDCF70B58, "cap_fx" },
    { 0xDCC5B8C9, "cap_model" },
    { 0x019A40A5, "cap_value" },
    { 0x60EB8E31, "cap_zombie_head_gibs" },
    { 0x6ED36E4F, "capabilities" },
    { 0xC2EEE767, "capable" },
    { 0xCC860ADF, "capacator" },
    { 0x2B6EE6A7, "capacitor" },
    { 0x7F5EBAA9, "capacitor_model" },
    { 0x447EB749, "capacitor_struct" },
    { 0x0D5DD41E, "capacitors" },
    { 0xCC477861, "capacity" },
    { 0x379D5AAF, "capital" },
    { 0xE47CDF08, "capitalism" },
    { 0x3A932CB9, "capitalist" },
    { 0x6A8261A1, "capitol" },
    { 0x9B7FD042, "capped" },
    { 0xBC838C13, "capping" },
    { 0x59E41820, "cappingteam" },
    { 0xB1D528E2, "capricorn" },
    { 0x65AC817E, "caps" },
    { 0xD9B2BAAF, "capsperminute" },
    { 0x28EBF05F, "capspot" },
    { 0x36E74E0F, "capspot2" },
    { 0x6D207826, "capsule" },
    { 0x48E93713, "captain" },
    { 0xF889047C, "capteam" },
    { 0xCA2C0594, "captime" },
    { 0xCED6AC1D, "captive" },
    { 0x33109005, "capture" },
    { 0xE870E61E, "capture_anims" },
    { 0x5B87256A, "capture_carnage_animation_manager" },
    { 0xC460691C, "capture_cleanup" },
    { 0xDCC5CBA3, "capture_condition_at_base" },
    { 0xFE9887B4, "capture_condition_none" },
    { 0x7ABB099E, "capture_controls" },
    { 0x7173F87A, "capture_controls_hide_fx" },
    { 0x17264A9E, "capture_delete_animation_loops" },
    { 0xFD21AD95, "capture_dialoge" },
    { 0x738B3E9A, "capture_dlg_done" },
    { 0xA7874CFF, "capture_dragovich" },
    { 0x124774A8, "capture_duration" },
    { 0x00E68FE6, "capture_event_end" },
    { 0xD773303E, "capture_event_handle_ai_limit" },
    { 0x775C5FA5, "capture_event_start" },
    { 0x83164D66, "capture_fadeout" },
    { 0xAEED5E02, "capture_fadeout_and_in" },
    { 0x0CDCFA80, "capture_fake_battle" },
    { 0x2A5BB0A0, "capture_freeroam_shot" },
    { 0xE5224F93, "capture_get_fade_hud" },
    { 0xA5428E5A, "capture_get_vector_dot" },
    { 0x8539B58C, "capture_guy_think" },
    { 0x68DDB81C, "capture_heartbeat_rumble" },
    { 0x8625F2CC, "capture_interactive" },
    { 0x5F4E1DE8, "capture_kravchenko" },
    { 0x8ACA0D8A, "capture_menendez" },
    { 0x34503D41, "capture_music" },
    { 0x06FEEEA7, "capture_not_fearless" },
    { 0x25AC9A87, "capture_player" },
    { 0x2FAEF634, "capture_progress_think" },
    { 0xFA7FBAA9, "capture_run_scene_then_loop" },
    { 0x40B3243C, "capture_screen_dirt" },
    { 0x7BC48FAF, "capture_setup" },
    { 0xA40CD057, "capture_setup_animations" },
    { 0xA310F078, "capture_shot" },
    { 0xC4388DDD, "capture_sitrep" },
    { 0x40C4ED80, "capture_skipto_setup" },
    { 0xCA85CDF2, "capture_sniper_active" },
    { 0xB06FD407, "capture_spawn_fake_qrotors_at_structs_and_move" },
    { 0x0531A1DB, "capture_start_animation_loops" },
    { 0x5C0F97CB, "capture_start_fadeout" },
    { 0xD359757F, "capture_started" },
    { 0x018F74DC, "capture_swap_vision_and_sky" },
    { 0x142ED5A3, "capture_team" },
    { 0xF560E653, "capture_time" },
    { 0x87AB8B0E, "capture_zombie_limit" },
    { 0x36AA72FB, "capture_zombie_rise_fx" },
    { 0x758DB58B, "capture_zombie_spawn_init" },
    { 0x3E26A2A1, "capture_zombies" },
    { 0x1FB89946, "capture_zombies_only_attack_nearby_players" },
    { 0x4A01E089, "capture_zone_init_end" },
    { 0x15112162, "capture_zone_init_start" },
    { 0x06797EF8, "captureaccelbonus" },
    { 0x53013388, "captureaccellimit" },
    { 0x5F100427, "captureaction" },
    { 0x752D7BC5, "captureangles" },
    { 0xF82A269E, "capturebonus" },
    { 0x8FD8911A, "capturecount" },
    { 0x74C981F9, "capturecratestate" },
    { 0x5E0ECDCB, "capturecratetotaltime" },
    { 0x10F6B59B, "captured" },
    { 0xB3EEB87B, "captured_griggs" },
    { 0xF7D2FACA, "captured_griggs_think" },
    { 0x6E9492DE, "captured_start" },
    { 0x2D84BADB, "capturedbfirstminute" },
    { 0xA77A37E4, "capturedcrate" },
    { 0x8C284F64, "capturedobjective" },
    { 0x11E7A67C, "capturedobjectivefunction" },
    { 0x3CB1746C, "captureent" },
    { 0xD58D1BC4, "captureframe" },
    { 0xE55360B5, "captureimagename" },
    { 0xA8417E3A, "captureislinked" },
    { 0x24A9EAE4, "captureobj" },
    { 0x933F6CC4, "captureobjnum" },
    { 0xAD6BB23B, "captureorigin" },
    { 0xE484542D, "capturepoint" },
    { 0xBD2350FD, "capturer" },
    { 0x9720D694, "captures" },
    { 0xE6D2EDA2, "capturetime" },
    { 0xFA7BDDD0, "capturing" },
    { 0xC890F696, "capturing_ent" },
    { 0x0EC78246, "capturingflag" },
    { 0x38CEC496, "capturinglastflag" },
    { 0x039ACFB5, "car" },
    { 0x9BDA2616, "car1" },
    { 0x44FE348D, "car_bumpy" },
    { 0x774DD897, "car_cig" },
    { 0x64A6C7DB, "car_corner_crash" },
    { 0x3BE92CEA, "car_corner_crash_think" },
    { 0xCB875515, "car_crash_corner_rumble" },
    { 0x0CFC0D23, "car_crash_rumble" },
    { 0xE325F231, "car_crush_arcademode" },
    { 0xC1F69FB0, "car_damage_owner_recorder" },
    { 0xC9CD84B2, "car_dead" },
    { 0x4682370E, "car_death_notify" },
    { 0x0761F73B, "car_death_think" },
    { 0xBA71BE01, "car_displacement_vector" },
    { 0xA6E329B2, "car_driver" },
    { 0x940B72ED, "car_explosion" },
    { 0xA381D4E5, "car_fire_think" },
    { 0x5465CBA9, "car_flip" },
    { 0x835089CE, "car_flip_car" },
    { 0x0CC022E4, "car_flip_guy01" },
    { 0x7EC7921F, "car_flip_guy02" },
    { 0x03268F1E, "car_fxanim_cigar" },
    { 0x0B7B32D7, "car_fxanim_model" },
    { 0x74B0EF12, "car_getaway" },
    { 0x12590392, "car_go" },
    { 0xDA4A46ED, "car_grenade_stuck_explode" },
    { 0x7BA851A2, "car_grenade_stuck_think" },
    { 0xFD485946, "car_hacked_c4" },
    { 0x630D2D0F, "car_headlight_left_tag" },
    { 0xF18B86A8, "car_headlight_right_tag" },
    { 0x881473FF, "car_move" },
    { 0xE9EC51A1, "car_normal" },
    { 0x64EF4F2B, "car_number" },
    { 0x15954CE0, "car_passenger" },
    { 0x892817B3, "car_police_driver" },
    { 0x05798C02, "car_police_pass" },
    { 0x9ABB490A, "car_props" },
    { 0xA7BEC2AF, "car_reverse_enemies" },
    { 0x1BF5C54B, "car_size" },
    { 0x02270267, "car_slide" },
    { 0xE141E35C, "car_smash" },
    { 0xFC84403F, "car_smash_car" },
    { 0x5F6E7E88, "car_smash_car_idle" },
    { 0xDCD95095, "car_smash_go" },
    { 0xA111DF82, "car_smooth" },
    { 0x52A9EF50, "car_sound_think" },
    { 0x51D95DEA, "car_static" },
    { 0xB31969A3, "car_stopped" },
    { 0xBE0E955C, "carabiner" },
    { 0xB198DDDE, "carbon" },
    { 0x4B7B7A47, "carcass" },
    { 0x3F049971, "carcleanupwaiter" },
    { 0x0A98F7AB, "card" },
    { 0x817566FC, "card_swiped" },
    { 0xACF63E38, "cardboardbox" },
    { 0x01A5F9AF, "cardeathwaiter" },
    { 0x80977BD7, "cardetonatewaiter" },
    { 0xAFC993A5, "cardinal" },
    { 0xE4967D42, "care" },
    { 0x60DA671D, "care_package_chopper_time" },
    { 0x57F63213, "career" },
    { 0x972C7F61, "career_time" },
    { 0x1ECD59F9, "career_value" },
    { 0xB5D93356, "career_weapon_stats" },
    { 0xD059EE00, "careerleaderboard" },
    { 0x041264FE, "careerweapons" },
    { 0x6713972B, "careful" },
    { 0x33359B10, "careful_logic" },
    { 0xD12611F6, "carefully" },
    { 0x0F1DBD69, "carepackagechopperhackertoolradius" },
    { 0xF14C5038, "carepackagechopperhackertooltimems" },
    { 0x03C40868, "carepackagefriendlyhackertooltimems" },
    { 0x421C707C, "carepackagehackertoolradius" },
    { 0x87633DBD, "carepackagehackertooltimems" },
    { 0xCE139708, "carepackageownerhackertooltimems" },
    { 0xEA158CA9, "careticon" },
    { 0x16EFA757, "cargo" },
    { 0xEA4BA74B, "cargo_attack1" },
    { 0x03715BAD, "cargo_attack1_commit" },
    { 0xA22A1E80, "cargo_attack2v2" },
    { 0xE6035191, "cargo_attack2v2_cleanup" },
    { 0x26131166, "cargo_attack_1" },
    { 0x7898FC7D, "cargo_attack_commit_fail" },
    { 0xC0C902AF, "cargo_container" },
    { 0x0A8483BC, "cargo_dialogue" },
    { 0xFFD45408, "cargo_dropped" },
    { 0x89B0662B, "cargo_enemies_dead" },
    { 0x0CE28099, "cargo_enemies_death" },
    { 0x592AED05, "cargo_enemy_attack" },
    { 0x87E4E697, "cargo_enemy_defend_moment_past" },
    { 0x29848810, "cargo_guy1" },
    { 0xDCDB5F04, "cargo_guy1_ready" },
    { 0x9B8BF74B, "cargo_guy2" },
    { 0x1AAE190B, "cargo_guy2_ready" },
    { 0x30CDF3C7, "cargo_guys_jump_anim" },
    { 0xE931EE85, "cargo_handle_defend1_flag" },
    { 0x537FA43A, "cargo_handle_patroller" },
    { 0x4D070787, "cargo_handle_patroller_flag" },
    { 0x1BB3348A, "cargo_handle_patroller_kill_trig" },
    { 0x139FB3FC, "cargo_insane" },
    { 0x412280B9, "cargo_insane_handle_use" },
    { 0xA1A44BCF, "cargo_leave" },
    { 0x0F613904, "cargo_leave_dialogue" },
    { 0x87A06BE1, "cargo_left_safezone" },
    { 0x77CD448D, "cargo_main" },
    { 0x584F5DE2, "cargo_moveup" },
    { 0xABD0AA41, "cargo_patrol_dead" },
    { 0x5C4C497B, "cargo_patrol_death" },
    { 0x4FB5F021, "cargo_patrol_defend1_dead" },
    { 0xBD9AAEDB, "cargo_patrol_defend1_death" },
    { 0x8F482112, "cargo_patrol_waitdead_or_flag_open" },
    { 0x9D06BE3A, "cargo_patrol_waitdead_or_flag_set" },
    { 0x104983C1, "cargo_ropes" },
    { 0xB350654C, "cargo_ropes_stop" },
    { 0x1C0AEA16, "cargo_sleeper" },
    { 0x7C55EA72, "cargo_sleeper_wait_wakeup" },
    { 0xBEAB7B87, "cargo_slipby" },
    { 0xCFB8D1BF, "cargo_slipby_kill_patrol" },
    { 0x1D5E61DE, "cargo_slipby_part1" },
    { 0xF75BE775, "cargo_slipby_part2" },
    { 0xD1596D0C, "cargo_slipby_part3" },
    { 0x6A5017C1, "cargo_sneakup" },
    { 0xEAC966CE, "cargo_sneakup_dialogue" },
    { 0xF1D11F53, "cargo_started_defend_moment" },
    { 0x21C5EAE6, "cargo_waitmove" },
    { 0xD2B6B68C, "cargobay_cleanup" },
    { 0xB3BEE94B, "cargobay_exit_hallway_spawn" },
    { 0xAA004D57, "cargobay_explosion_trigger_thread" },
    { 0x06EFC9B1, "cargobay_fastrope_guys" },
    { 0x2E63D1E3, "cargobay_reinforcement_spawn" },
    { 0x4BDD7628, "cargobay_rocket" },
    { 0xCC65F12D, "cargocheck" },
    { 0xADB5A169, "cargohanging_01" },
    { 0xD3B81BD2, "cargohanging_02" },
    { 0xF9BA963B, "cargohanging_03" },
    { 0x1FBD10A4, "cargohanging_04" },
    { 0x45BF8B0D, "cargohanging_05" },
    { 0xADBD6190, "cargohold" },
    { 0xDE74AFEB, "cargohold1_breach" },
    { 0x892CD773, "cargohold1_breach2" },
    { 0x27752EEB, "cargohold1_dialogue1" },
    { 0xB56DBFB0, "cargohold1_dialogue2" },
    { 0xDB703A19, "cargohold1_dialogue3" },
    { 0x97ADDFE0, "cargohold1_flashed_enemies" },
    { 0xE8FBC74F, "cargohold1_flashed_enemies_death" },
    { 0xC1875540, "cargohold1_pulp_fiction_guy" },
    { 0xD0067362, "cargohold1_pulp_fiction_guy_healthshield" },
    { 0x48E20481, "cargohold1_pulp_fiction_guy_ignore" },
    { 0xBFBD93F1, "cargohold1_pulp_fiction_think" },
    { 0x42E3564C, "cargohold2_enemies1" },
    { 0x2190199B, "cargohold2_enemies1_death" },
    { 0xB4EAC587, "cargohold2_enemies2" },
    { 0x96B3D49C, "cargohold2_enemies2_death" },
    { 0x52633995, "cargohold2_enemies_common" },
    { 0xC135CC0E, "cargohold2_main" },
    { 0xCE8C9574, "cargohold_1_light_sway" },
    { 0x43F48640, "cargohold_catwalk_shuffle" },
    { 0x5D004F4A, "cargohold_catwalk_shuffle_aim" },
    { 0xED5B6468, "cargohold_catwalk_shuffle_shoot" },
    { 0xA8A2B303, "cargohold_flash" },
    { 0x274C691B, "cargohold_flash2" },
    { 0xECEF9751, "cargohold_flashthrow" },
    { 0x81AAE670, "cargohold_main" },
    { 0x89241D81, "cargohold_main_alavi_reach_flash" },
    { 0x78FD23D1, "cargohold_main_alavi_reach_flash2" },
    { 0xE34FAB7B, "cargoholds" },
    { 0xDAC7F5C0, "cargoholds_1_cross2" },
    { 0x4306DEAC, "cargoholds_1_enter" },
    { 0x494C62F6, "cargoholds_1_part5" },
    { 0x8B564CA6, "cargoobject" },
    { 0x5E4C0AE7, "cargoownerteam" },
    { 0xE0D47B25, "cargoship" },
    { 0xF1CCA410, "cargoship_amb" },
    { 0x95661087, "cargoship_anim" },
    { 0xA171C4C7, "cargoship_art" },
    { 0xF04F2DF6, "cargoship_audio" },
    { 0xBB0738C1, "cargoship_breach2_setup" },
    { 0x38CFE297, "cargoship_code" },
    { 0xE5956B45, "cargoship_escape_music" },
    { 0x177C8202, "cargoship_fx" },
    { 0x91826686, "cargoship_hack_animreach" },
    { 0x7AF46B7E, "cargoship_intro" },
    { 0x8C8438F1, "cargoship_intro_dvars" },
    { 0x863C28F4, "cargoship_pri_report" },
    { 0xB3212A55, "cargoship_scriptgen" },
    { 0xB8033EFC, "cargoship_start" },
    { 0x0BEC4EB2, "cargoship_targets" },
    { 0xD9C561C2, "cargoship_training" },
    { 0xC9F470CF, "cargospot" },
    { 0xC0591C96, "cargospots" },
    { 0x816ADDA3, "cargotouched" },
    { 0x12FC2E5C, "carguard" },
    { 0xC5716433, "caring" },
    { 0x3CC35D69, "cariobarradio" },
    { 0xCD126108, "carjack" },
    { 0x83934C7D, "carjacker" },
    { 0xFF713014, "carkills" },
    { 0x99E06EE1, "carlos" },
    { 0xD75A8AA0, "carlos_break_window" },
    { 0xE5789520, "carlos_leaves" },
    { 0x0CEF3450, "carlos_nag_array" },
    { 0xCF424772, "carlos_nag_lines" },
    { 0x2A3C66A1, "carlos_sprint_down_alley" },
    { 0xA618E8FE, "carnage" },
    { 0x68EDB55D, "carnage_a_wounded_01" },
    { 0x0B98840A, "carnage_a_wounded_01_loop" },
    { 0xCF5C7C75, "carnode" },
    { 0xCF80C028, "carogship_shotgunpulla" },
    { 0x41882F63, "carogship_shotgunpullb" },
    { 0x75F8BC4F, "carousel" },
    { 0xB2F7846E, "carousel_crates" },
    { 0xC7E25990, "carousel_floor" },
    { 0x5AD63CAC, "carousel_init" },
    { 0xFDFEA661, "carp_ent" },
    { 0x3A5F8797, "carpenter" },
    { 0xF2B36700, "carpenter_extra_time" },
    { 0x467D3FA8, "carpenter_finished" },
    { 0x0A09A29B, "carpenter_finished_start_time" },
    { 0xC5AC517D, "carpenter_on" },
    { 0x9EF14191, "carpenter_pickedup" },
    { 0x865EAE0B, "carpenter_powerup_active" },
    { 0xB182E276, "carpenter_zombie_killed_check_finished" },
    { 0xA83F4A54, "carpet" },
    { 0xF6D837F7, "carpeted" },
    { 0xFD520889, "carried" },
    { 0xFB61D9CA, "carriedby" },
    { 0x978C7595, "carriedshieldmodel" },
    { 0x7C771A0D, "carriedtacos" },
    { 0x96105719, "carriedweapon" },
    { 0x41888D8F, "carrier" },
    { 0x94E24D46, "carrier_angles" },
    { 0xA242986A, "carrier_cleared" },
    { 0x676AB8AA, "carrier_guys" },
    { 0x9D1AC35B, "carrier_position" },
    { 0xDC7A0955, "carrierhascarryweaponinloadout" },
    { 0x82E1D097, "carrierkilledby" },
    { 0xFD0D343E, "carriermodel" },
    { 0xBFBF9356, "carriers" },
    { 0x54638D83, "carriervisible" },
    { 0x769C636A, "carrierweaponcurrent" },
    { 0x1B861326, "carries" },
    { 0x2A79927B, "carring" },
    { 0xF2043876, "carry" },
    { 0x71F00315, "carry_angles" },
    { 0x489C9CC4, "carry_crouch_buttonpressed" },
    { 0x9FF16FE5, "carry_dist" },
    { 0x8505C80A, "carry_drop" },
    { 0x666C1B63, "carry_finished" },
    { 0x474D470B, "carry_icon_x" },
    { 0x214ACCA2, "carry_icon_y" },
    { 0x9CF5C7A7, "carry_loop" },
    { 0xEAF966B9, "carry_movement_sounds" },
    { 0x079B8D35, "carry_node" },
    { 0x8B825B5D, "carry_object_prox_think" },
    { 0xCDF51461, "carry_object_use_think" },
    { 0xF284C144, "carry_offset" },
    { 0xFE66708F, "carry_sound_watcher" },
    { 0x4D9D1C1B, "carry_watcher" },
    { 0x6F0B5384, "carryflag" },
    { 0x4B1C056D, "carryicon" },
    { 0x3F1A85EA, "carrying" },
    { 0xCFDDC9EB, "carrying_crawler" },
    { 0x07E58CB6, "carrying_hint" },
    { 0xAEC2F5A3, "carrying_hint_cleanup" },
    { 0xBBA042D7, "carrying_turret" },
    { 0x0EE98678, "carryingturret" },
    { 0x755DD18B, "carryobject" },
    { 0x8B5F3004, "carryobjectproxthink" },
    { 0x52054778, "carryobjectusethink" },
    { 0x7795A187, "carryplaceable" },
    { 0x500F557F, "carryqrdrone" },
    { 0x88D80548, "carryqrdrone_handleexistence" },
    { 0x7F951504, "carryqrdrone_setcarried" },
    { 0x4A764094, "carryturret" },
    { 0x996F4416, "carryweapon" },
    { 0x6D75FA4A, "carryweaponthink" },
    { 0xD073CB84, "cars" },
    { 0x804DD72E, "carspot1" },
    { 0x5A4B5CC5, "carspot2" },
    { 0x3448E25C, "carspot3" },
    { 0xAA71511B, "cart" },
    { 0xAFB431B6, "cart_1_watcher" },
    { 0x81CC5425, "cart_2_watcher" },
    { 0x7D205EE8, "cart_col" },
    { 0x30074C49, "cart_death_think" },
    { 0xF5821137, "cart_fire_think" },
    { 0x66713996, "cart_guys" },
    { 0x33B8A18D, "cart_left" },
    { 0x7EFC2F90, "cart_left_pile" },
    { 0x622F4D28, "cart_props" },
    { 0xB0E8CAB0, "cart_right" },
    { 0x487722FF, "cart_right_pile" },
    { 0x1816942F, "cart_top" },
    { 0x3BFAAB67, "cartag" },
    { 0xC450D4D8, "cartel" },
    { 0xA6EDB1C1, "cartel_add_to_threatbiasgroup" },
    { 0x8D1D95E7, "cartel_react_to_menendez_arrival" },
    { 0x18243976, "carter" },
    { 0xDB40C9E7, "carter_carrier" },
    { 0x582C5B1C, "carter_mover" },
    { 0xA4E51314, "cartimer" },
    { 0xDFEE1018, "cartpush_hurry" },
    { 0x8F9442DD, "cartype" },
    { 0x1FEC0346, "carve" },
    { 0x59BDF190, "carver" },
    { 0xDD98554C, "cas" },
    { 0xF1B4BEC9, "case" },
    { 0xA0E18D2F, "cased" },
    { 0x18334C90, "casemodel" },
    { 0x36A88DC0, "cases" },
    { 0x93D0014C, "cash" },
    { 0x56B30D01, "cash_back_failed_prone" },
    { 0xEB301E4F, "cash_back_money_reward" },
    { 0xC7DBCEB7, "cash_back_player_drinks_perk" },
    { 0x7C2CB828, "cash_back_player_prone_check" },
    { 0x551834FC, "casing" },
    { 0xF19F5B02, "cassert" },
    { 0x6D02FF64, "cassimir" },
    { 0x2BD9EAF0, "cast" },
    { 0x7D179DE5, "caster" },
    { 0x7377FF1A, "caster_effects" },
    { 0xD0D18968, "casting" },
    { 0xAF3C63F9, "castle" },
    { 0x83901165, "castle_destroyed" },
    { 0xBCB61DDF, "castle_front_fall" },
    { 0x2B4D8B1F, "castle_mortars_think" },
    { 0xDE2A4893, "castle_spawners" },
    { 0x56A5440C, "castle_targeted" },
    { 0xF5D7D26B, "castle_targeted_2" },
    { 0x57DADFB9, "castle_wall_clip" },
    { 0x28F4812E, "castors" },
    { 0xB1B8DB91, "castro" },
    { 0x16A041A2, "castro_assassination" },
    { 0x315529C8, "castro_bed_feathers" },
    { 0x5BCA72EC, "castro_bullet_shield" },
    { 0xE2808B57, "castro_cigar_fx" },
    { 0xCF958F3C, "castro_kill_player" },
    { 0xC306259C, "castro_miss_player" },
    { 0xB2B0C4A0, "castro_nag_array" },
    { 0x8E0A1F8F, "castro_nag_loop_delay" },
    { 0x9704B0A3, "castro_reveal" },
    { 0xC5056C02, "castro_woman" },
    { 0x84D28F78, "castros" },
    { 0x1F5342DA, "casual" },
    { 0x577B3CF0, "casual_stand_idle" },
    { 0xF58F0FA3, "casual_stand_v2_idle" },
    { 0x67A3BDD5, "casual_stand_v2_twitch_shift" },
    { 0x5DF1C0ED, "casual_stand_v2_twitch_talk" },
    { 0x012313FB, "casualties" },
    { 0xB795DAE3, "cat" },
    { 0xDAFB0C6E, "cat_dest" },
    { 0xA6EF927E, "catacombs" },
    { 0x236AB0F8, "catacombs_east2" },
    { 0x73D26405, "catastrophe" },
    { 0xB4AAEA40, "catastrophic" },
    { 0x36B4F26E, "catch" },
    { 0xA239E5B3, "catch_first_player" },
    { 0x9D53A209, "catch_use_button" },
    { 0x881DDD53, "catchall" },
    { 0x20DF4BB7, "catcher" },
    { 0x0600A9BD, "catcher_being_used" },
    { 0xFADCD14E, "catches" },
    { 0x45B99092, "catching" },
    { 0x479D6991, "catchs" },
    { 0x275D0995, "catchup" },
    { 0x780B9579, "categories" },
    { 0x8F0309BF, "categories_axis" },
    { 0xD9A1B059, "category" },
    { 0x5DA0581A, "category_alias_name" },
    { 0xB66DE22B, "category_array" },
    { 0x52217E68, "category_backoff_limit" },
    { 0xFC377B10, "category_index" },
    { 0x5856D23D, "category_name" },
    { 0xB9BD6B2D, "category_response_name" },
    { 0x7FEF12DD, "category_timeout" },
    { 0xC9D6E8EE, "categorykey" },
    { 0x358B9195, "categorytypeweight" },
    { 0xF182FB3C, "catenary" },
    { 0x7FDEF160, "cathcing" },
    { 0x424C8F8C, "cattle" },
    { 0x2D80AA6A, "cattle_scatter_trigger" },
    { 0xF437AB08, "cattlecatcher" },
    { 0xCDC668DD, "cattlecatcher_plow" },
    { 0xFFA66460, "cattlecatcherbuildable" },
    { 0x63F66754, "catwalk" },
    { 0xF37761DC, "catwalk1_trigger" },
    { 0xEDE93626, "catwalk_collapse" },
    { 0xC62A7B25, "catwalk_collapse_thread" },
    { 0x85180ED6, "catwalk_collapsed" },
    { 0xF63DF257, "catwalk_dialog" },
    { 0xD387057F, "catwalk_door" },
    { 0x3851468A, "catwalk_door_collision" },
    { 0x91F14B53, "catwalk_door_group" },
    { 0x3E206A21, "catwalk_fall_start" },
    { 0xC296F057, "catwalk_glass_exploder" },
    { 0xD82DB6B7, "catwalk_guys" },
    { 0xA9AC49DF, "catwalk_kill_friendlies" },
    { 0x88523EEB, "catwalk_lander_doors" },
    { 0xB6C1F58C, "catwalk_lander_doors_only" },
    { 0x5672F910, "catwalk_random_rockets" },
    { 0x8A5271CE, "catwalk_random_shooting" },
    { 0x39DB958E, "catwalk_setup" },
    { 0x53C1585D, "catwalk_setup_thread" },
    { 0xF4580AA1, "catwalk_snipers" },
    { 0xC53EDC59, "catwalk_spawn_snipers" },
    { 0x631BFAC1, "catwalk_start" },
    { 0x3B8DD4A1, "catwalk_status" },
    { 0x9A147B35, "catwalk_stealth_trig_delete" },
    { 0x027524C7, "catwalks" },
    { 0x0B4B7A9B, "catwalks_destroyed_vo" },
    { 0xF3FB20A5, "caught" },
    { 0x01D2D300, "caught_by_tomahawk" },
    { 0x7BC88A16, "caughtup" },
    { 0x45DCB382, "cause" },
    { 0xA4B3F922, "caused" },
    { 0xC3BA906C, "causeflattires" },
    { 0x2D200809, "causerumble" },
    { 0xB693C1CD, "causes" },
    { 0x822EFE73, "causing" },
    { 0xB31FDFA0, "caution" },
    { 0x82BE2B62, "cautious" },
    { 0x3A08959A, "cautious_enemy_function" },
    { 0x6E2910BD, "cavalry" },
    { 0x17D24EDE, "cave" },
    { 0x30500C56, "cave2_clear" },
    { 0x3F0C377E, "cave_artillery_active" },
    { 0xBD904AFD, "cave_bolder" },
    { 0xC517262D, "cave_bolder_ceiling" },
    { 0x36063E14, "cave_bolder_ceiling_start" },
    { 0x762A9284, "cave_bolder_start" },
    { 0x54796FF0, "cave_debris" },
    { 0x22BFC5C5, "cave_debris_start" },
    { 0xFB23E927, "cave_dust_fx_loop" },
    { 0xE3E95B01, "cave_effects" },
    { 0x79525B8C, "cave_enter_scene" },
    { 0x4658BDDA, "cave_entrance_trigger" },
    { 0x4D7CA38C, "cave_entrance_wait_scene" },
    { 0x345703C7, "cave_exit_settings" },
    { 0xCCB382A2, "cave_fill" },
    { 0x0A2B6FA8, "cave_fill_complete" },
    { 0xC13D336B, "cave_fill_start" },
    { 0x5A4BAB25, "cave_flame_attack_animate" },
    { 0xCE4B2B5B, "cave_flamers" },
    { 0xE3B8C825, "cave_fog_off" },
    { 0x4382F999, "cave_fog_on" },
    { 0xEDD63D10, "cave_is_cleared" },
    { 0x3F00AE95, "cave_panel" },
    { 0x089D300C, "cave_panel_start" },
    { 0xCDD102DB, "cave_ref_point" },
    { 0x097485CC, "cave_rock_swap" },
    { 0xA5EF7EA9, "cave_slide_anim_init" },
    { 0xE4F82A6F, "cave_sprinkle" },
    { 0xCDBB30AA, "cave_sprinkle_start" },
    { 0xA52AE163, "cave_vision_off" },
    { 0xAE145BAF, "cave_vision_on" },
    { 0x7FF0B2E1, "cave_vision_trigger_init" },
    { 0x7C91CB80, "cave_vision_trigger_watch" },
    { 0x74D96D75, "cavedoor_org" },
    { 0x21B92286, "caveish" },
    { 0x57496C41, "caves" },
    { 0x4B89F13B, "caves1_zone" },
    { 0x970718BE, "cavetrigger" },
    { 0x63342BFD, "cawarenessscene" },
    { 0xC0992DA4, "cawarenesssceneobject" },
    { 0x3135D636, "cb" },
    { 0x8D494352, "cb0" },
    { 0x41444E80, "cb2" },
    { 0x6746C8E9, "cb3" },
    { 0x854E483F, "cb_audio_chatter" },
    { 0x46730DBA, "cb_chatter_off" },
    { 0x87E6A3F6, "cb_radio" },
    { 0x316E516A, "cb_radio_sound" },
    { 0x67C7131C, "cbfunc" },
    { 0x5738509F, "cc" },
    { 0x785C91FF, "ccb" },
    { 0xA177B407, "ccheng" },
    { 0x9B615544, "cclass" },
    { 0x6E63CD5E, "cclass_power" },
    { 0x10667BA3, "ccn" },
    { 0x4A129F22, "ccom_lock_being_targeted" },
    { 0x74810FD1, "ccontainer" },
    { 0xB281BE26, "ccs" },
    { 0x5A38BDDD, "cctv" },
    { 0x097CF5E8, "cctv_console_bink_play_cctv" },
    { 0xF257A68A, "cctv_console_bink_stop_cctv" },
    { 0xFD8D36C5, "cctv_console_bink_stop_playback" },
    { 0xC157011B, "cctv_console_bink_toggle" },
    { 0xD48C0384, "cctv_console_play_cctv_2" },
    { 0x5D1245F0, "cctv_door_fix" },
    { 0xCD0B6BFC, "cctv_futz_stop" },
    { 0x40EE2DC9, "cctv_room" },
    { 0x7087ECB3, "cctv_room_computer_guy" },
    { 0x0CACBB23, "cctv_room_door_opens_and_gates_player" },
    { 0x6B29B075, "cctv_room_guys_toggle_headlook" },
    { 0x0FE8F044, "cctv_trigger" },
    { 0xD4A166BC, "cctv_turn_on_left_screen" },
    { 0x3BC9928B, "cctv_turn_on_right_screen" },
    { 0x4D26F7C0, "cd" },
    { 0xE610255B, "cdc" },
    { 0x656D2F61, "cdc_alive" },
    { 0xE64CCC44, "cdoor" },
    { 0x4637CBEB, "cds" },
    { 0xE7060CED, "ce_blood_fx" },
    { 0x1A7E4A3B, "ce_explode" },
    { 0xC7EAA4D0, "ce_f35_fly" },
    { 0xC2D23F5C, "ce_f35_hit" },
    { 0x638BCC49, "ce_f35_hover" },
    { 0x33218A21, "ce_harper_grenade" },
    { 0x5EB49101, "ce_melee_fx" },
    { 0x0B56270B, "ce_tire_fx" },
    { 0x137F008A, "cease" },
    { 0xE3D1D6FA, "ceased" },
    { 0x49C4D072, "ceil" },
    { 0xE529BEFE, "ceiling" },
    { 0xA659CD93, "ceiling1_anim_setup" },
    { 0x921D863D, "ceiling1_fall" },
    { 0x6C33894A, "ceiling2_anim_setup" },
    { 0x455F02D0, "ceiling2_fall" },
    { 0x1BE8FCFC, "ceiling_01" },
    { 0x8DF06C37, "ceiling_02" },
    { 0x67EDF1CE, "ceiling_03" },
    { 0xA9E18DC1, "ceiling_04" },
    { 0x83DF1358, "ceiling_05" },
    { 0x66617C6C, "ceiling_collapse" },
    { 0x1A3FADE9, "ceiling_collapse_start" },
    { 0xF64E7FD9, "ceiling_fan_think" },
    { 0x72FA9348, "ceiling_fans_init" },
    { 0x59AF3D0E, "ceiling_garbage" },
    { 0xD864C07F, "ceiling_light_01" },
    { 0x665D5144, "ceiling_light_02" },
    { 0x36BE02D5, "ceiling_light_fall" },
    { 0xA0029E4C, "ceiling_light_fall_start" },
    { 0x2294FE53, "ceiling_rappelers" },
    { 0xED5A3C20, "ceiling_ring_init" },
    { 0xD9A378D7, "ceiling_ring_randomize" },
    { 0xE9A8F60B, "ceiling_ring_rotate" },
    { 0x4DD1FB51, "ceiling_ring_run" },
    { 0x4686B585, "ceiling_ring_update_position" },
    { 0x936DD5E5, "ceiling_tile_flip" },
    { 0x9E56BF95, "ceiling_tile_process_damage" },
    { 0x388D88E1, "ceilings" },
    { 0xA703BFEF, "cel_ent_c" },
    { 0x3C8D69DE, "cel_ent_lf" },
    { 0x04AB26CA, "cel_ent_lr" },
    { 0xB7AC4AB4, "cel_ent_rf" },
    { 0xBF7ABA80, "cel_ent_rr" },
    { 0xB514E7E4, "celebrate" },
    { 0x89539F97, "celebratingguards" },
    { 0x2BDE02D3, "celebrators" },
    { 0x9F3AB5D5, "celerium" },
    { 0xDCEC3B6D, "celerium_chamber_anims" },
    { 0xFA43D25A, "celerium_chamber_main" },
    { 0x9A163301, "celerium_chamber_vision" },
    { 0x045A19B2, "celerium_door_visor_text" },
    { 0xD6F1FDA0, "celerium_enemies" },
    { 0x0C467BC8, "celerium_entrance_doors" },
    { 0xE7DA927B, "celerium_event_done" },
    { 0x0F7D232C, "celerium_glass" },
    { 0x50E75084, "celerium_holograms" },
    { 0x891B9584, "celerium_lighting" },
    { 0x5325065D, "celerium_loops" },
    { 0x94E15B6F, "celerium_main" },
    { 0x8228375C, "celerium_retrieval" },
    { 0xE541CB4F, "celerium_vision_set_tracking" },
    { 0x99F14509, "celing" },
    { 0x04E4EB29, "cell" },
    { 0xFD40347C, "cell_1_powerup_activate" },
    { 0xE8BD514D, "cell_2_powerup_activate" },
    { 0x50B412A8, "cell_close" },
    { 0xC1040A84, "cell_door" },
    { 0x6B15ED19, "cell_door_key_prompt" },
    { 0xED8FDF47, "cell_grab_check" },
    { 0xA3A3E62C, "cell_open" },
    { 0x8C15DDE0, "cell_phone" },
    { 0x680DD8F6, "cell_phone_chloe" },
    { 0x54DD5FC3, "cell_phone_drain" },
    { 0x6C453ACF, "cell_phone_hide" },
    { 0x12B4A731, "cell_phone_kurtz" },
    { 0xF7676289, "cell_phone_kurtz_returned" },
    { 0xF17AD00D, "cell_phone_power_down" },
    { 0x4A88C9AB, "cell_phone_screen" },
    { 0xF4E32DEC, "cell_phone_show" },
    { 0x6DA1C6F8, "cell_powerup" },
    { 0x673C5770, "cell_screen" },
    { 0x5CE60798, "cellpadding" },
    { 0xC0DC1253, "cellphone" },
    { 0xB34BAC82, "cellphones" },
    { 0x4ADFCEA0, "cells" },
    { 0xB32357F8, "cellspacing" },
    { 0x0A4BFD95, "cement" },
    { 0x23D10ED1, "cement_01" },
    { 0x49D3893A, "cement_02" },
    { 0x6FD603A3, "cement_03" },
    { 0x95D87E0C, "cement_04" },
    { 0xBBDAF875, "cement_05" },
    { 0xC3770B29, "cemetery" },
    { 0xA5B978DD, "cenference" },
    { 0xC5C282E0, "ceng" },
    { 0x97F198AB, "cent" },
    { 0x4880F4E6, "center" },
    { 0x90918A21, "center_camera_for_idle" },
    { 0x2CC5ACCA, "center_camera_over_ai" },
    { 0x55E57D1E, "center_center" },
    { 0x9F203082, "center_death_trig" },
    { 0x22F479CC, "center_ent" },
    { 0x004E8923, "center_fx" },
    { 0x66571EEE, "center_handle_heli" },
    { 0x511533E8, "center_height" },
    { 0xD78D118B, "center_heli_quake" },
    { 0x26723C7C, "center_hud" },
    { 0x38A8F479, "center_info" },
    { 0x80675B43, "center_l" },
    { 0x457AB492, "center_main" },
    { 0x42B1B449, "center_moveup" },
    { 0xDA42E669, "center_moveup2" },
    { 0xB4406C00, "center_moveup3" },
    { 0xBE51C4DF, "center_moveup4" },
    { 0x984F4A76, "center_moveup5" },
    { 0xF0DAEC65, "center_node" },
    { 0xF1E5971B, "center_offset_z" },
    { 0xD12F9D1B, "center_origin" },
    { 0x9EB87999, "center_point_offset" },
    { 0x1F179BEF, "center_port_node" },
    { 0xF3B0DA65, "center_pos" },
    { 0x1F659A69, "center_pt" },
    { 0x65029ABB, "center_screen_debug_hudelem1" },
    { 0xF2FB2B80, "center_screen_debug_hudelem2" },
    { 0x8D3AA7CB, "center_screen_debug_hudelem_active" },
    { 0x0133BD2C, "center_spawn_points" },
    { 0x0B680562, "center_starboard_node" },
    { 0x59E9AA72, "center_struct" },
    { 0x9566B369, "center_test" },
    { 0x5086CE20, "center_text" },
    { 0x45EF2BC4, "center_text_add" },
    { 0x3CEA581E, "center_text_clear" },
    { 0xD1AFFA31, "center_text_init" },
    { 0x96144B12, "center_top" },
    { 0xC90EC136, "center_truck" },
    { 0x983FCA19, "center_weight" },
    { 0xBEF14F41, "centeranim" },
    { 0x51285B7E, "centerbulletglass" },
    { 0xC4195469, "centered" },
    { 0x4BA0683A, "centered_lr" },
    { 0x2F2685BF, "centered_ud" },
    { 0x49703962, "centerindex" },
    { 0x1D8C9990, "centerline" },
    { 0x06E194E0, "centerlinethread" },
    { 0x1D8893FC, "centeronnav" },
    { 0xF953904C, "centerorigin" },
    { 0xE5E5819C, "centerpoint" },
    { 0x2DD14D71, "centerref" },
    { 0x82D76519, "centers" },
    { 0x9063C29A, "centerselforigin" },
    { 0xEC3E899E, "centerweight" },
    { 0x5E9B868C, "central" },
    { 0x1167B5F8, "central_pdf_delete_volume" },
    { 0xFF2411A2, "centralized" },
    { 0xFFBAD333, "centric" },
    { 0x884B7E43, "centrifuge" },
    { 0xA8ECABD7, "centrifuge_clean_rumble" },
    { 0x5AEADC28, "centrifuge_fx_spot_init" },
    { 0xE0D31800, "centrifuge_init" },
    { 0x20B1E59E, "centrifuge_jumpdown_fix" },
    { 0x306ACA61, "centrifuge_jumpup_fix" },
    { 0x0B7B0682, "centrifuge_lander_doors" },
    { 0xC8F1C51F, "centrifuge_lander_doors_only" },
    { 0x732DBE95, "centrifuge_rumble" },
    { 0xB73A8CD7, "centrifuge_rumble_control" },
    { 0x418AF938, "centrifuge_rumble_done" },
    { 0x702C8DD1, "centrifuge_rumble_when_close" },
    { 0xC7265F3C, "centrifuge_status" },
    { 0x7164C703, "centrifuge_steam_warning" },
    { 0x222E9433, "centrifuge_warning_lights_init" },
    { 0xB09899EC, "centrifuge_warning_lights_off" },
    { 0x4B04A296, "centrifuge_warning_lights_on" },
    { 0x0B18C3C5, "centroid" },
    { 0x71472D24, "centurion" },
    { 0x88EBD857, "centurions" },
    { 0xB680490D, "cerelium_room_loops" },
    { 0x6BC4E499, "certain" },
    { 0xE0FE3C44, "certainly" },
    { 0x1C5CF57A, "certin" },
    { 0x1DDD3204, "cessna" },
    { 0x416178EB, "cessna_hangar_flyby" },
    { 0x992BEC92, "cf" },
    { 0x869FF598, "cf_c" },
    { 0x00A0DFEA, "cf_callback_zero_on_new_ent" },
    { 0xFC2A68D8, "cf_complete" },
    { 0x6829AF44, "cf_cracks_all" },
    { 0xEC91200F, "cf_cracks_blue" },
    { 0x6199BF9C, "cf_cracks_green" },
    { 0x40400B06, "cf_cracks_off" },
    { 0x6970A598, "cf_cracks_on" },
    { 0x4FE2010C, "cf_cracks_red" },
    { 0xC62850BF, "cf_field" },
    { 0x9B958417, "cf_field_name" },
    { 0x888D27A8, "cf_host_only" },
    { 0x6015AC5A, "cf_lerp_bit_count" },
    { 0x0C3DA6FE, "cf_lerp_cb" },
    { 0x05A1FC8C, "cf_lerp_name" },
    { 0xEE960BF4, "cf_o" },
    { 0xC45C925B, "cf_octobomb_explode_fx" },
    { 0x7B25498D, "cf_octobomb_fx" },
    { 0x95132BB4, "cf_octobomb_ug_fx" },
    { 0x3FC83FBE, "cf_player_underwater" },
    { 0x0BBB4D4E, "cf_server_sync" },
    { 0xD5F76081, "cf_slot_bit_count" },
    { 0x439EC74B, "cf_slot_cb" },
    { 0x307A87B1, "cf_slot_name" },
    { 0x545B98F8, "cf_toggle_lights_force_allies" },
    { 0xA1513A89, "cf_toggle_lights_force_axis" },
    { 0x4FF1C971, "cf_toggle_lights_off" },
    { 0xDCD6A5C5, "cf_toggle_lights_on" },
    { 0xFD30C89F, "cf_widows_wine_wrap" },
    { 0xD92D98D2, "cfd" },
    { 0xB32B1E69, "cfg" },
    { 0xC6B9C530, "cfx_center_text" },
    { 0x30554359, "cfx_center_text_index" },
    { 0x3E37FD13, "cfx_center_text_max" },
    { 0x51D64105, "cfx_client_backup" },
    { 0xA1029E8C, "cfx_client_exploder" },
    { 0xCD36B3C9, "cfx_client_loop" },
    { 0x26202416, "cfx_client_loopsound" },
    { 0x9F1E16B5, "cfx_client_oneshot" },
    { 0x246029C4, "cfx_client_output" },
    { 0x00318CBA, "cfx_client_path" },
    { 0xA0852A06, "cfx_client_scriptdata" },
    { 0x37CB9572, "cfx_client_scriptgendump" },
    { 0x90C48C94, "cfx_ent" },
    { 0xDC6C38E9, "cfx_exploder_after" },
    { 0x53C9944C, "cfx_exploder_before" },
    { 0x70F579BA, "cfx_func_create_looper" },
    { 0xA7539CE4, "cfx_func_create_loopsound" },
    { 0x5BABC4CD, "cfx_func_create_triggerfx" },
    { 0xC5413A46, "cfx_func_loopfx" },
    { 0xF0A11AF8, "cfx_func_oneshotfx" },
    { 0x838B6BE8, "cfx_func_run_gump_func" },
    { 0xA77A67E9, "cfx_func_script_gen_dump" },
    { 0xCC039F99, "cfx_func_soundfx" },
    { 0x85585B18, "cfx_func_stop_loopsound" },
    { 0x31E6B199, "cfx_global_backup" },
    { 0xAC101AA0, "cfx_global_exploder" },
    { 0xA128765D, "cfx_global_loop" },
    { 0xA1305862, "cfx_global_loopsound" },
    { 0xDDF06491, "cfx_global_oneshot" },
    { 0x24124B78, "cfx_global_output" },
    { 0xB4C67D8E, "cfx_global_path" },
    { 0x30AD918A, "cfx_global_scriptdata" },
    { 0x8B2D984E, "cfx_global_scriptgendump" },
    { 0xCCCE78B1, "cfx_is_in_sp_mode" },
    { 0xD9B31ECE, "cfx_last_action" },
    { 0xFBF0592A, "cfx_limbo_state" },
    { 0x475F301E, "cfx_max_states" },
    { 0x5153BFB0, "cfx_next_ent" },
    { 0x6C6FB0AC, "cfx_previous_ent" },
    { 0x345B2B12, "cfx_redo_states" },
    { 0xE79B9DCA, "cfx_selected_prop" },
    { 0x6B23EFB0, "cfx_server_exploder" },
    { 0xFD1557ED, "cfx_server_loop" },
    { 0x688DDE52, "cfx_server_loopsound" },
    { 0x53872361, "cfx_server_oneshot" },
    { 0x9A4174DA, "cfx_server_scriptdata" },
    { 0x4451C6DE, "cfx_server_scriptgendump" },
    { 0xCC2AABF2, "cfx_start_fog" },
    { 0x364A8514, "cfx_undo_states" },
    { 0x3F8DF763, "cfx_uniqueid" },
    { 0x9C9953F5, "cfxprintln" },
    { 0xE7E0C7C4, "cfxprintlns" },
    { 0xBE28BB08, "cg_aggressivecullradius" },
    { 0x3509D83E, "cg_blood" },
    { 0xCB969102, "cg_drawgun" },
    { 0xE22A4B28, "cg_executenewservercommands" },
    { 0x64197457, "cg_fov" },
    { 0x20B54828, "cg_init" },
    { 0x6FE64B65, "cg_maprestart" },
    { 0x8D30B882, "cg_mature" },
    { 0x9ACD5001, "cg_objectiveindicatorfardist" },
    { 0x75B26C78, "cg_objectiveindicatorneardist" },
    { 0x84B65346, "cg_objectiveindicatornearfadedist" },
    { 0x25394911, "cg_player" },
    { 0xA24AF094, "cg_setnextsnap_clients" },
    { 0x1A38D05C, "cgo_old_accuracy" },
    { 0xEB66D9C7, "cgo_old_baseaccuracy" },
    { 0x4EBF7F93, "cgocamera" },
    { 0xDC2F78AF, "cgogroup" },
    { 0x1544B4AC, "ch" },
    { 0xED033E9D, "ch1" },
    { 0x1305B906, "ch2" },
    { 0x3908336F, "ch3" },
    { 0x2EF6DA90, "ch4" },
    { 0x4231FB76, "ch46" },
    { 0x3BB6E691, "ch46wingman" },
    { 0x23246741, "ch_af_01_01_intro_horse_woods_start" },
    { 0x8CABBD3A, "ch_af_01_01_intro_horse_woods_waitidle" },
    { 0xD8EE5B57, "ch_af_01_01_intro_woods_start" },
    { 0xC9C58358, "ch_af_01_01_intro_woods_waitidle" },
    { 0x573C4D12, "ch_af_01_03_pulwar_deadguy" },
    { 0x9867233A, "ch_af_01_05_henchman1" },
    { 0xACC19CBA, "ch_af_01_05_henchman1_endloop" },
    { 0x7264A8D1, "ch_af_01_05_henchman2" },
    { 0xB2F547CD, "ch_af_01_05_henchman2_endloop" },
    { 0x4C622E68, "ch_af_01_05_henchman3" },
    { 0xF1082388, "ch_af_01_05_henchman3_endloop" },
    { 0x56738747, "ch_af_01_05_henchman4" },
    { 0x5997D4A3, "ch_af_01_05_henchman4_endloop" },
    { 0x4E8BA459, "ch_af_01_05_horse1" },
    { 0x7ECFE285, "ch_af_01_05_horse1_endloop" },
    { 0x748E1EC2, "ch_af_01_05_horse2" },
    { 0x6D23BE92, "ch_af_01_05_horse2_endloop" },
    { 0x9A90992B, "ch_af_01_05_horse3" },
    { 0x9E32F83F, "ch_af_01_05_horse3_endloop" },
    { 0xC0931394, "ch_af_01_05_horse4" },
    { 0xD532514C, "ch_af_01_05_horse4_endloop" },
    { 0xDF508D5B, "ch_af_01_05_horse_woods" },
    { 0xEEB4F3F7, "ch_af_01_05_zhaoapproach_spread_muj01" },
    { 0x00D23881, "ch_af_01_05_zhaoapproach_spread_muj01_horse" },
    { 0x7CAD84BC, "ch_af_01_05_zhaoapproach_spread_muj02" },
    { 0xCC54018E, "ch_af_01_05_zhaoapproach_spread_muj02_horse" },
    { 0xA2AFFF25, "ch_af_01_05_zhaoapproach_spread_muj03" },
    { 0x7D4399E7, "ch_af_01_05_zhaoapproach_spread_muj03_horse" },
    { 0x30A88FEA, "ch_af_01_05_zhaoapproach_spread_muj04" },
    { 0x99706194, "ch_af_01_05_zhaoapproach_spread_muj04_horse" },
    { 0xBE5CF628, "ch_af_01_05_zhaoapproach_spread_zhao" },
    { 0x953F37F2, "ch_af_01_05_zhaoapproach_spread_zhao_horse" },
    { 0x025E415A, "ch_af_01_05_zhaointro_horse_woods" },
    { 0xB4228C39, "ch_af_01_05_zhaointro_horse_woods_endidl" },
    { 0xE7BAF90A, "ch_af_01_05_zhaointro_horse_zhao" },
    { 0xD973AB29, "ch_af_01_05_zhaointro_horse_zhao_endidl" },
    { 0xE67378B4, "ch_af_01_05_zhaointro_woods" },
    { 0xB40D7407, "ch_af_01_05_zhaointro_woods_endidl" },
    { 0x4CCAA1B8, "ch_af_01_05_zhaointro_zhao" },
    { 0x84A584B3, "ch_af_01_05_zhaointro_zhao_endidl" },
    { 0xCA18C57D, "ch_af_02_01_ammoguy" },
    { 0x49514617, "ch_af_02_01_ammoguy02" },
    { 0x234ECBAE, "ch_af_02_01_ammoguy03" },
    { 0x654267A1, "ch_af_02_01_ammoguy04" },
    { 0x63FE7FA7, "ch_af_02_01_ammoguy_ammo1" },
    { 0xF1F7106C, "ch_af_02_01_ammoguy_ammo2" },
    { 0x17F98AD5, "ch_af_02_01_ammoguy_ammo3" },
    { 0x0C4DF908, "ch_af_02_01_cooking_muj1" },
    { 0x7E556843, "ch_af_02_01_cooking_muj2" },
    { 0x5852EDDA, "ch_af_02_01_cooking_muj3" },
    { 0x56BCB17A, "ch_af_02_01_enter_cave_hudson" },
    { 0x9A24870B, "ch_af_02_01_enter_cave_hudson_idle" },
    { 0x71E72A48, "ch_af_02_01_enter_cave_leader" },
    { 0x1EE2E4F7, "ch_af_02_01_enter_cave_woods" },
    { 0xAD8E92ED, "ch_af_02_01_enter_cave_woods_entrance_idle" },
    { 0x36234061, "ch_af_02_01_enter_cave_zhao" },
    { 0x128C993F, "ch_af_02_01_enter_cave_zhao_entrance_idle" },
    { 0x4AF1DE32, "ch_af_02_01_fire_drum_burner" },
    { 0x7FCB3A66, "ch_af_02_01_generatorguy" },
    { 0xD470F913, "ch_af_02_01_gun_stackers_muj1_carry" },
    { 0x88A8D9A6, "ch_af_02_01_gun_stackers_muj1_endidl" },
    { 0xCF672770, "ch_af_02_01_gun_stackers_muj2_carry" },
    { 0x6D4D4023, "ch_af_02_01_gun_stackers_muj2_endidl" },
    { 0x75F216F8, "ch_af_02_01_gun_stackers_muj2_main" },
    { 0x76B5F6D1, "ch_af_02_01_gun_stackers_muj3" },
    { 0x2D0D51D7, "ch_af_02_01_gunsmith_hammerguy" },
    { 0xDBBD3188, "ch_af_02_01_gunsmith_polishguy_no_grinder" },
    { 0xA298981A, "ch_af_02_01_map_room_conversation_hudson" },
    { 0xB31A0066, "ch_af_02_01_map_room_conversation_omar" },
    { 0x3AFDDC17, "ch_af_02_01_map_room_conversation_woods" },
    { 0x87DA0D01, "ch_af_02_01_map_room_conversation_zhao" },
    { 0xF4266AAB, "ch_af_02_01_map_room_leader_idle" },
    { 0xFFEC9ECA, "ch_af_02_01_map_room_woods_idle" },
    { 0x04B06EF3, "ch_af_02_01_map_room_woods_walktocave" },
    { 0x90449328, "ch_af_02_01_map_room_zhao_idle" },
    { 0x4ABF4DCD, "ch_af_02_01_map_room_zhao_walktocave" },
    { 0x544C07BE, "ch_af_02_01_ridge_lookout_guy1" },
    { 0x2E498D55, "ch_af_02_01_ridge_lookout_guy2" },
    { 0x5F01C8DE, "ch_af_02_01_rooftops_muj1" },
    { 0x38FF4E75, "ch_af_02_01_rooftops_muj2" },
    { 0x12FCD40C, "ch_af_02_01_rooftops_muj3" },
    { 0xECFA59A3, "ch_af_02_01_rooftops_muj4" },
    { 0xC6F7DF3A, "ch_af_02_01_rooftops_muj5" },
    { 0xA0F564D1, "ch_af_02_01_rooftops_muj6" },
    { 0x29B0CED9, "ch_af_02_01_runout_muj1_run" },
    { 0x78962993, "ch_af_02_01_runout_muj1_startidl" },
    { 0xB21B0726, "ch_af_02_01_runout_muj2_run" },
    { 0x2E12A6D6, "ch_af_02_01_runout_muj2_startidl" },
    { 0xED395F63, "ch_af_02_01_runout_muj3_run" },
    { 0xE8299F51, "ch_af_02_01_runout_muj3_startidl" },
    { 0x6B3DABA0, "ch_af_02_01_runout_muj4_run" },
    { 0xFE0E9D54, "ch_af_02_01_runout_muj4_startidl" },
    { 0xAE2A0235, "ch_af_02_01_runout_muj5_run" },
    { 0xC5A4F897, "ch_af_02_01_runout_muj5_startidl" },
    { 0xC44C5012, "ch_af_02_01_runout_muj6_run" },
    { 0x7328B24A, "ch_af_02_01_runout_muj6_startidl" },
    { 0xDECC88B2, "ch_af_02_01_smoker1" },
    { 0xB8CA0E49, "ch_af_02_01_smoker2" },
    { 0xE27F8D03, "ch_af_02_01_stingers_cart_endidl" },
    { 0x4127BBBC, "ch_af_02_01_stingers_cart_move" },
    { 0x320B04CA, "ch_af_02_01_stingers_muj1_endidl" },
    { 0xAF39C751, "ch_af_02_01_stingers_muj1_move" },
    { 0xBA16BA67, "ch_af_02_01_stingers_muj2_endidl" },
    { 0x4C32DE28, "ch_af_02_01_stingers_muj2_move" },
    { 0x6427F652, "ch_af_02_01_tank_ruin_muj1_endidl" },
    { 0x886FCA8F, "ch_af_02_01_tank_ruin_muj1_startidl" },
    { 0x00CDF5B1, "ch_af_02_01_tank_ruin_muj1_tracking" },
    { 0x60A91FAF, "ch_af_02_01_tank_ruin_muj2_endidl" },
    { 0xF596F9A2, "ch_af_02_01_tank_ruin_muj2_startidl" },
    { 0xCBD1E9F0, "ch_af_02_01_tank_ruin_muj2_tracking" },
    { 0xAD8792A3, "ch_af_02_01_tankguy_gesture" },
    { 0x472ACE42, "ch_af_02_01_tower_lookout_1_endidl" },
    { 0x86424BF9, "ch_af_02_01_tower_lookout_1_follow" },
    { 0xC8B0107F, "ch_af_02_01_tower_lookout_1_startidl" },
    { 0xC534281F, "ch_af_02_01_tower_lookout_2_endidl" },
    { 0x37B5B2B4, "ch_af_02_01_tower_lookout_2_follow" },
    { 0x0C79E9D2, "ch_af_02_01_tower_lookout_2_startidl" },
    { 0x51FEE2F1, "ch_af_02_01_walltop1_muj1_endidl" },
    { 0x9F1498D4, "ch_af_02_01_walltop1_muj1_lookout" },
    { 0x0ECFCE00, "ch_af_02_01_walltop1_muj1_startidl" },
    { 0x362CFB20, "ch_af_02_01_walltop1_muj2_endidl" },
    { 0xAD0A9CF3, "ch_af_02_01_walltop1_muj2_lookout" },
    { 0xBAD958D1, "ch_af_02_01_walltop1_muj2_startidl" },
    { 0x3451B6F6, "ch_af_02_01_walltop2_muj1_endidl" },
    { 0xD90AAAA9, "ch_af_02_01_walltop2_muj1_lookout" },
    { 0xA96ADABB, "ch_af_02_01_walltop2_muj1_startidl" },
    { 0xF70BD533, "ch_af_02_01_walltop2_muj2_endidl" },
    { 0xF0F858FE, "ch_af_02_01_walltop2_muj2_lookout" },
    { 0x78077B9E, "ch_af_02_01_walltop2_muj2_startidl" },
    { 0x0722E44C, "ch_af_02_01_window_lookout_follow" },
    { 0x4B3C46CA, "ch_af_02_01_window_lookout_startidl" },
    { 0x818BEC10, "ch_af_02_02_truck_offload_muj1" },
    { 0xF976B731, "ch_af_02_02_truck_offload_muj1_idle" },
    { 0xF3935B4B, "ch_af_02_02_truck_offload_muj2" },
    { 0xB27DAC1C, "ch_af_02_02_truck_offload_muj2_idle" },
    { 0xA1AFDF6A, "ch_af_03_01_base_leave_horse_onfire" },
    { 0xD91D2E88, "ch_af_03_01_base_leave_horse_woods_exit" },
    { 0x0FDADC41, "ch_af_03_01_base_leave_horse_woods_idl" },
    { 0xE3E3F826, "ch_af_03_01_base_leave_horse_woods_ride" },
    { 0x5A4AE2DE, "ch_af_03_01_base_leave_horse_zhao_exit" },
    { 0x23F13AEB, "ch_af_03_01_base_leave_horse_zhao_idl" },
    { 0xC6B4BFF8, "ch_af_03_01_base_leave_horse_zhao_ride" },
    { 0x666152B7, "ch_af_03_01_base_leave_leader_exit" },
    { 0xB4081CB4, "ch_af_03_01_base_leave_leader_idl" },
    { 0x69EB6B52, "ch_af_03_01_base_leave_woods_exit" },
    { 0x40007E67, "ch_af_03_01_base_leave_woods_idl" },
    { 0xC52C97CC, "ch_af_03_01_base_leave_woods_ride" },
    { 0xA7DA67EC, "ch_af_03_01_base_leave_zhao_exit" },
    { 0x39112EBD, "ch_af_03_01_base_leave_zhao_idl" },
    { 0xF551E2CA, "ch_af_03_01_base_leave_zhao_ride" },
    { 0x3406C4AE, "ch_af_04_01_return_base_left1_charge" },
    { 0x21DC87FC, "ch_af_04_01_return_base_left1_horse_charge" },
    { 0x4B026DD3, "ch_af_04_01_return_base_left2_charge" },
    { 0x6A901AD1, "ch_af_04_01_return_base_left2_horse_charge" },
    { 0x44923098, "ch_af_04_01_return_base_left3_charge" },
    { 0xB788D426, "ch_af_04_01_return_base_left3_horse_charge" },
    { 0x20425623, "ch_af_04_01_return_base_player_horse_charge" },
    { 0xD351B316, "ch_af_04_01_return_base_player_horse_lineup" },
    { 0x80FD5275, "ch_af_04_01_return_base_player_horse_speech" },
    { 0x5940E045, "ch_af_04_01_return_base_right1_charge" },
    { 0x58827933, "ch_af_04_01_return_base_right1_horse_charge" },
    { 0xEB3138C4, "ch_af_04_01_return_base_right2_charge" },
    { 0x4D31760A, "ch_af_04_01_return_base_right2_horse_charge" },
    { 0x2588ADBF, "ch_af_04_01_return_base_right3_charge" },
    { 0xE3402695, "ch_af_04_01_return_base_right3_horse_charge" },
    { 0x294D2730, "ch_af_04_01_return_base_woods_charge" },
    { 0x596ED28E, "ch_af_04_01_return_base_woods_horse_charge" },
    { 0x4AB7081F, "ch_af_04_01_return_base_woods_horse_lineup" },
    { 0x2A54E411, "ch_af_04_01_return_base_woods_lineup" },
    { 0x4FAB992A, "ch_af_04_01_return_base_zhao_charge" },
    { 0xE1465B20, "ch_af_04_01_return_base_zhao_horse_charge" },
    { 0x8EEA38A1, "ch_af_04_01_return_base_zhao_horse_lineup" },
    { 0x29F3F18B, "ch_af_04_01_return_base_zhao_lineup" },
    { 0xEAA654DD, "ch_af_04_03_through_binoculars_helper" },
    { 0xD2A4B0A5, "ch_af_04_03_through_binoculars_wounded" },
    { 0xF6E3E1FE, "ch_af_04_05_thown_horse_fall" },
    { 0xBDBA6BE7, "ch_af_04_05_thown_horse_pushloop" },
    { 0x97851A2B, "ch_af_04_05_thrown_horse_push" },
    { 0x2CFF9DF4, "ch_af_04_05_thrown_horse_success" },
    { 0xF5586976, "ch_af_04_06_reunion_guard_tankfight" },
    { 0xEC7CB713, "ch_af_04_06_reunion_horse_run2tank" },
    { 0xE9F355B2, "ch_af_04_06_reunion_horse_woods_run2tank" },
    { 0x8BD58BD9, "ch_af_04_06_reunion_horse_woods_tankfight" },
    { 0xDAC85ADF, "ch_af_04_06_reunion_krav_tankfight" },
    { 0x9E0402F0, "ch_af_04_06_reunion_woods_run2tank" },
    { 0xDE7F806F, "ch_af_04_06_reunion_woods_tankfight" },
    { 0x59C2EB6B, "ch_af_04_09_reunion_horse_strangle" },
    { 0x15448572, "ch_af_04_09_reunion_krav_strangle" },
    { 0xCE9418D8, "ch_af_04_09_reunion_woods_strangle" },
    { 0xBE2C2897, "ch_af_05_01_victory_crowd_1" },
    { 0x965C3F25, "ch_af_05_01_victory_crowd_10" },
    { 0x7059C4BC, "ch_af_05_01_victory_crowd_11" },
    { 0xE26133F7, "ch_af_05_01_victory_crowd_12" },
    { 0x4C24B95C, "ch_af_05_01_victory_crowd_2" },
    { 0x722733C5, "ch_af_05_01_victory_crowd_3" },
    { 0x001FC48A, "ch_af_05_01_victory_crowd_4" },
    { 0x26223EF3, "ch_af_05_01_victory_crowd_5" },
    { 0xB41ACFB8, "ch_af_05_01_victory_crowd_6" },
    { 0xDA1D4A21, "ch_af_05_01_victory_crowd_7" },
    { 0x6815DAE6, "ch_af_05_01_victory_crowd_8" },
    { 0x8E18554F, "ch_af_05_01_victory_crowd_9" },
    { 0xA4D46FA5, "ch_af_05_01_victory_crowd_follow_1" },
    { 0xF0D96477, "ch_af_05_01_victory_crowd_follow_3" },
    { 0xE6C80B98, "ch_af_05_01_victory_crowd_follow_4" },
    { 0x0CCA8601, "ch_af_05_01_victory_crowd_follow_5" },
    { 0x32CD006A, "ch_af_05_01_victory_crowd_follow_6" },
    { 0x49EA4687, "ch_af_05_01_victory_horse_cheering" },
    { 0xCB4E079F, "ch_af_05_01_victory_hudson_walk" },
    { 0x4B94298A, "ch_af_05_01_victory_krav_walk" },
    { 0x6EDADF4B, "ch_af_05_01_victory_muhaj_cheering" },
    { 0xD855919E, "ch_af_05_01_victory_rider_cheering" },
    { 0xEE3BB012, "ch_af_05_01_victory_woods_walk" },
    { 0x18D6EEC2, "ch_af_05_01_victory_zhao_walk" },
    { 0x1D37D0DD, "ch_af_05_02_interrog_fail_hudson" },
    { 0xFAB77C86, "ch_af_05_02_interrog_fail_krav" },
    { 0xEA86EC4E, "ch_af_05_02_interrog_fail_woods" },
    { 0x574F696F, "ch_af_05_02_interrog_first_intel_guard1" },
    { 0xE547FA34, "ch_af_05_02_interrog_first_intel_guard2" },
    { 0x4A147FA6, "ch_af_05_02_interrog_first_intel_hudson" },
    { 0xF6CE0FED, "ch_af_05_02_interrog_first_intel_krav" },
    { 0x5A65DE95, "ch_af_05_02_interrog_first_intel_muj2" },
    { 0x3463642C, "ch_af_05_02_interrog_first_intel_muj3" },
    { 0x27DE2312, "ch_af_05_02_interrog_first_intel_omar" },
    { 0xD3544D5B, "ch_af_05_02_interrog_first_intel_woods" },
    { 0xD367F005, "ch_af_05_02_interrog_first_intel_zhao" },
    { 0xBD003DAB, "ch_af_05_02_interrog_second_intel_guard1" },
    { 0x4AF8CE70, "ch_af_05_02_interrog_second_intel_guard2" },
    { 0x6E62C0AA, "ch_af_05_02_interrog_second_intel_hudson" },
    { 0xE947E609, "ch_af_05_02_interrog_second_intel_krav" },
    { 0x2BB9B8A9, "ch_af_05_02_interrog_second_intel_muj2" },
    { 0x05B73E40, "ch_af_05_02_interrog_second_intel_muj3" },
    { 0xBE273AD6, "ch_af_05_02_interrog_second_intel_omar" },
    { 0x06540F47, "ch_af_05_02_interrog_second_intel_woods" },
    { 0x63C3B2B1, "ch_af_05_02_interrog_second_intel_zhao" },
    { 0x04C5415A, "ch_af_05_02_interrog_start_guard1" },
    { 0xDEC2C6F1, "ch_af_05_02_interrog_start_guard2" },
    { 0x07990D97, "ch_af_05_02_interrog_start_hudson" },
    { 0xAC208E28, "ch_af_05_02_interrog_start_krav" },
    { 0xCBFD10B4, "ch_af_05_02_interrog_start_muj2" },
    { 0xF1FF8B1D, "ch_af_05_02_interrog_start_muj3" },
    { 0x610CE697, "ch_af_05_02_interrog_start_omar" },
    { 0x9F004A58, "ch_af_05_02_interrog_start_woods" },
    { 0x1037C86C, "ch_af_05_02_interrog_start_zhao" },
    { 0xD0DCF6BA, "ch_af_05_02_interrog_succeed_guard1" },
    { 0xAADA7C51, "ch_af_05_02_interrog_succeed_guard2" },
    { 0xA6347D77, "ch_af_05_02_interrog_succeed_hudson" },
    { 0xFABC2808, "ch_af_05_02_interrog_succeed_krav" },
    { 0x02892A14, "ch_af_05_02_interrog_succeed_muj2" },
    { 0x288BA47D, "ch_af_05_02_interrog_succeed_muj3" },
    { 0xDBE79177, "ch_af_05_02_interrog_succeed_omar" },
    { 0xBFCF54B8, "ch_af_05_02_interrog_succeed_woods" },
    { 0x614DCB4C, "ch_af_05_02_interrog_succeed_zhao" },
    { 0xE53AA860, "ch_af_05_02_interrog_test1_fail_guard1" },
    { 0x5742179B, "ch_af_05_02_interrog_test1_fail_guard2" },
    { 0x894B3719, "ch_af_05_02_interrog_test1_fail_hudson" },
    { 0xCB9BC06A, "ch_af_05_02_interrog_test1_fail_krav" },
    { 0xF118FD9A, "ch_af_05_02_interrog_test1_fail_muj2" },
    { 0x171B7803, "ch_af_05_02_interrog_test1_fail_muj3" },
    { 0x55F99432, "ch_af_05_02_interrog_test1_fail_woods" },
    { 0xDF66FD3B, "ch_af_05_02_interrog_test2_fail_guard1" },
    { 0x6D5F8E00, "ch_af_05_02_interrog_test2_fail_guard2" },
    { 0x063FBADA, "ch_af_05_02_interrog_test2_fail_hudson" },
    { 0x625B8379, "ch_af_05_02_interrog_test2_fail_krav" },
    { 0x79CB7999, "ch_af_05_02_interrog_test2_fail_muj2" },
    { 0x53C8FF30, "ch_af_05_02_interrog_test2_fail_muj3" },
    { 0x34B0A2D7, "ch_af_05_02_interrog_test2_fail_woods" },
    { 0x6930429A, "ch_af_05_02_interrog_test3_fail_guard1" },
    { 0x432DC831, "ch_af_05_02_interrog_test3_fail_guard2" },
    { 0xE88FD057, "ch_af_05_02_interrog_test3_fail_hudson" },
    { 0x607E2CE8, "ch_af_05_02_interrog_test3_fail_krav" },
    { 0x8197E3F4, "ch_af_05_02_interrog_test3_fail_muj2" },
    { 0xA79A5E5D, "ch_af_05_02_interrog_test3_fail_muj3" },
    { 0x4F9E6718, "ch_af_05_02_interrog_test3_fail_woods" },
    { 0xEA149358, "ch_af_05_02_interrog_third_intel_guard1" },
    { 0x5C1C0293, "ch_af_05_02_interrog_third_intel_guard2" },
    { 0xBFC3C561, "ch_af_05_02_interrog_third_intel_hudson" },
    { 0xF6BE38D2, "ch_af_05_02_interrog_third_intel_krav" },
    { 0x6FFB5D32, "ch_af_05_02_interrog_third_intel_muj2" },
    { 0x95FDD79B, "ch_af_05_02_interrog_third_intel_muj3" },
    { 0x4D0747A5, "ch_af_05_02_interrog_third_intel_omar" },
    { 0xED1331FA, "ch_af_05_02_interrog_third_intel_woods" },
    { 0x92385C2A, "ch_af_05_02_interrog_third_intel_zhao" },
    { 0x578638E8, "ch_af_05_02_interrog_threat_guard1" },
    { 0xC98DA823, "ch_af_05_02_interrog_threat_guard2" },
    { 0x4CE0DE11, "ch_af_05_02_interrog_threat_hudson" },
    { 0xB0067142, "ch_af_05_02_interrog_threat_krav" },
    { 0x4015E1A2, "ch_af_05_02_interrog_threat_muj2" },
    { 0x66185C0B, "ch_af_05_02_interrog_threat_muj3" },
    { 0xDD4E7CF5, "ch_af_05_02_interrog_threat_omar" },
    { 0x331238CA, "ch_af_05_02_interrog_threat_woods" },
    { 0x3119CEBA, "ch_af_05_02_interrog_threat_zhao" },
    { 0xA4919BE9, "ch_af_05_04_betrayal_guard1" },
    { 0xCA941652, "ch_af_05_04_betrayal_guard2" },
    { 0x5CCDF214, "ch_af_05_04_betrayal_hudson" },
    { 0xC5E87134, "ch_af_05_04_betrayal_muj1" },
    { 0x37EFE06F, "ch_af_05_04_betrayal_muj2" },
    { 0x11ED6606, "ch_af_05_04_betrayal_muj3" },
    { 0x53E101F9, "ch_af_05_04_betrayal_muj4" },
    { 0x22F8FCCC, "ch_af_05_04_betrayal_omar" },
    { 0x36F01A19, "ch_af_05_04_betrayal_woods" },
    { 0x556843E3, "ch_af_06_01_deserted_hudson_offtruck" },
    { 0xCC36BB1D, "ch_af_06_01_deserted_hudson_ontruck" },
    { 0x12C7AE89, "ch_af_06_01_deserted_leader_offtruck" },
    { 0x33312623, "ch_af_06_01_deserted_leader_ontruck" },
    { 0x399BC0C3, "ch_af_06_01_deserted_muj1_offtruck" },
    { 0x0456FE7D, "ch_af_06_01_deserted_muj1_ontruck" },
    { 0x52B6534C, "ch_af_06_01_deserted_woods_offtruck" },
    { 0x7CFF8E80, "ch_af_06_01_deserted_woods_ontruck" },
    { 0x293EAA3A, "ch_af_06_01_deserted_zhao_offtruck" },
    { 0xCB772F46, "ch_af_06_01_deserted_zhao_ontruck" },
    { 0x51F1D95C, "ch_af_06_02_deserted_hudson_view01" },
    { 0xC3F94897, "ch_af_06_02_deserted_hudson_view02" },
    { 0x9DF6CE2E, "ch_af_06_02_deserted_hudson_view03" },
    { 0x5A42D962, "ch_af_06_02_deserted_nomad_horse_view01" },
    { 0x34405EF9, "ch_af_06_02_deserted_nomad_horse_view02" },
    { 0x0E3DE490, "ch_af_06_02_deserted_nomad_horse_view03" },
    { 0x564C3B10, "ch_af_06_02_deserted_nomad_view01" },
    { 0xC853AA4B, "ch_af_06_02_deserted_nomad_view02" },
    { 0xA2512FE2, "ch_af_06_02_deserted_nomad_view03" },
    { 0x71940DD5, "ch_af_06_02_deserted_reznov_horse_view01" },
    { 0x9796883E, "ch_af_06_02_deserted_reznov_horse_view02" },
    { 0xBD9902A7, "ch_af_06_02_deserted_reznov_horse_view03" },
    { 0xE5EF6B6B, "ch_af_06_02_deserted_reznov_view01" },
    { 0x73E7FC30, "ch_af_06_02_deserted_reznov_view02" },
    { 0x99EA7699, "ch_af_06_02_deserted_reznov_view03" },
    { 0x532FB6C8, "ch_af_06_02_deserted_vulture_view03" },
    { 0x41F05899, "ch_af_06_02_deserted_woods_view01" },
    { 0x67F2D302, "ch_af_06_02_deserted_woods_view02" },
    { 0x8DF54D6B, "ch_af_06_02_deserted_woods_view03" },
    { 0x55913BD5, "ch_af_06_02_deserted_zhao_view01" },
    { 0xA19630A7, "ch_af_06_02_deserted_zhao_view03" },
    { 0x7F93805A, "ch_afghan_ied_planter" },
    { 0xFC0A22F2, "ch_afghan_intro_sniper1" },
    { 0xD607A889, "ch_afghan_intro_sniper2" },
    { 0x08AAD1BD, "ch_afghan_outro_horse1" },
    { 0x01C085F7, "ch_afghan_outro_horse10" },
    { 0xDBBE0B8E, "ch_afghan_outro_horse11" },
    { 0xB5BB9125, "ch_afghan_outro_horse12" },
    { 0x8FB916BC, "ch_afghan_outro_horse13" },
    { 0x69B69C53, "ch_afghan_outro_horse14" },
    { 0x2EAD4C26, "ch_afghan_outro_horse2" },
    { 0x54AFC68F, "ch_afghan_outro_horse3" },
    { 0x4A9E6DB0, "ch_afghan_outro_horse4" },
    { 0x70A0E819, "ch_afghan_outro_horse5" },
    { 0x96A36282, "ch_afghan_outro_horse6" },
    { 0xBCA5DCEB, "ch_afghan_outro_horse7" },
    { 0x12BC2A9C, "ch_afghan_outro_horse8" },
    { 0x38BEA505, "ch_afghan_outro_horse9" },
    { 0xC5E97760, "ch_afghan_outro_rider1" },
    { 0x8E5F4590, "ch_afghan_outro_rider10" },
    { 0xB461BFF9, "ch_afghan_outro_rider11" },
    { 0xDA643A62, "ch_afghan_outro_rider12" },
    { 0x0066B4CB, "ch_afghan_outro_rider13" },
    { 0x26692F34, "ch_afghan_outro_rider14" },
    { 0x37F0E69B, "ch_afghan_outro_rider2" },
    { 0x11EE6C32, "ch_afghan_outro_rider3" },
    { 0x83F5DB6D, "ch_afghan_outro_rider4" },
    { 0x5DF36104, "ch_afghan_outro_rider5" },
    { 0xCFFAD03F, "ch_afghan_outro_rider6" },
    { 0xA9F855D6, "ch_afghan_outro_rider7" },
    { 0x1BFFC511, "ch_afghan_outro_rider8" },
    { 0xF5FD4AA8, "ch_afghan_outro_rider9" },
    { 0x0367903B, "ch_ang_01_01_intro_burnguy" },
    { 0xF92D10CF, "ch_ang_01_01_intro_guy01" },
    { 0x8725A194, "ch_ang_01_01_intro_guy02" },
    { 0xAD281BFD, "ch_ang_01_01_intro_guy03" },
    { 0x3B20ACC2, "ch_ang_01_01_intro_guy04" },
    { 0x6123272B, "ch_ang_01_01_intro_guy05" },
    { 0xEF1BB7F0, "ch_ang_01_01_intro_guy06" },
    { 0x151E3259, "ch_ang_01_01_intro_guy07" },
    { 0xE17349C2, "ch_ang_01_01_intro_player" },
    { 0x29786D52, "ch_ang_01_01_intro_reflection_player" },
    { 0xC30A0928, "ch_ang_01_01_intro_savimbi" },
    { 0x35C674A9, "ch_ang_01_01_intro_savimbi_buffelidle" },
    { 0xABC8A26E, "ch_ang_01_01_intro_savimbi_part02" },
    { 0x1F905F75, "ch_ang_01_01_intro_savimbi_rally" },
    { 0x902C7C7C, "ch_ang_01_01_intro_savimbi_rally_charge" },
    { 0x019BDA94, "ch_ang_01_01_intro_savimbi_rally_charge_player" },
    { 0xC71C46F1, "ch_ang_01_01_pirates_01_guy01" },
    { 0xED1EC15A, "ch_ang_01_01_pirates_01_guy02" },
    { 0x13213BC3, "ch_ang_01_01_pirates_01_guy03" },
    { 0x3923B62C, "ch_ang_01_01_pirates_01_guy04" },
    { 0x5F263095, "ch_ang_01_01_pirates_01_guy05" },
    { 0x8528AAFE, "ch_ang_01_01_pirates_01_guy06" },
    { 0xAB2B2567, "ch_ang_01_01_pirates_01_guy07" },
    { 0x7105F940, "ch_ang_01_01_pirates_01_guy08" },
    { 0x970873A9, "ch_ang_01_01_pirates_01_guy09" },
    { 0x30B34014, "ch_ang_01_01_pirates_01_loop_guy01" },
    { 0xA2BAAF4F, "ch_ang_01_01_pirates_01_loop_guy02" },
    { 0x7CB834E6, "ch_ang_01_01_pirates_01_loop_guy03" },
    { 0xBEABD0D9, "ch_ang_01_01_pirates_01_loop_guy04" },
    { 0x98A95670, "ch_ang_01_01_pirates_01_loop_guy05" },
    { 0x0AB0C5AB, "ch_ang_01_01_pirates_01_loop_guy06" },
    { 0xE4AE4B42, "ch_ang_01_01_pirates_01_loop_guy07" },
    { 0x86C98DC5, "ch_ang_01_01_pirates_01_loop_guy08" },
    { 0x60C7135C, "ch_ang_01_01_pirates_01_loop_guy09" },
    { 0xF8C5E39E, "ch_ang_01_01_pirates_02_guy01" },
    { 0xD2C36935, "ch_ang_01_01_pirates_02_guy02" },
    { 0xACC0EECC, "ch_ang_01_01_pirates_02_guy03" },
    { 0x86BE7463, "ch_ang_01_01_pirates_02_guy04" },
    { 0x60BBF9FA, "ch_ang_01_01_pirates_02_guy05" },
    { 0x3AB97F91, "ch_ang_01_01_pirates_02_guy06" },
    { 0x14B70528, "ch_ang_01_01_pirates_02_guy07" },
    { 0xEEB48ABF, "ch_ang_01_01_pirates_02_guy08" },
    { 0x0289A201, "ch_ang_01_01_pirates_02_loop_guy01" },
    { 0x288C1C6A, "ch_ang_01_01_pirates_02_loop_guy02" },
    { 0x4E8E96D3, "ch_ang_01_01_pirates_02_loop_guy03" },
    { 0x7491113C, "ch_ang_01_01_pirates_02_loop_guy04" },
    { 0x9A938BA5, "ch_ang_01_01_pirates_02_loop_guy05" },
    { 0xC096060E, "ch_ang_01_01_pirates_02_loop_guy06" },
    { 0xE6988077, "ch_ang_01_01_pirates_02_loop_guy07" },
    { 0xAC735450, "ch_ang_01_01_pirates_02_loop_guy08" },
    { 0x85CEAB3D, "ch_ang_01_02_explosion_reaction_dead01_loop" },
    { 0xBE995732, "ch_ang_01_02_explosion_reaction_dead01_reaction" },
    { 0xD988EC34, "ch_ang_01_02_explosion_reaction_dead02_loop" },
    { 0x869F159B, "ch_ang_01_02_explosion_reaction_dead02_reaction" },
    { 0xD5CB7793, "ch_ang_01_02_explosion_reaction_schocked01_loop" },
    { 0xF9D24DF0, "ch_ang_01_02_explosion_reaction_schocked01_reaction" },
    { 0x7D5FEC26, "ch_ang_01_02_explosion_reaction_schocked02_loop" },
    { 0x91ED1605, "ch_ang_01_02_explosion_reaction_schocked02_reaction" },
    { 0x9816D947, "ch_ang_01_02_explosion_reaction_stunned02_loop" },
    { 0x0AA4A63A, "ch_ang_01_02_explosion_reaction_stunned_reaction" },
    { 0xE652FDD3, "ch_ang_01_02_explosion_reaction_stunned_reaction_loop" },
    { 0x5D38EAF8, "ch_ang_01_02_explosion_reaction_wounded_loop" },
    { 0x97B2BFA7, "ch_ang_01_02_explosion_reaction_wounded_reaction" },
    { 0xEFBF05DB, "ch_ang_01_02_explosion_reaction_wounded_second_loop" },
    { 0x5FD48DF3, "ch_ang_01_05_riverbed_corpses_buffel_corpse" },
    { 0x3FD8988E, "ch_ang_01_05_riverbed_corpses_driver" },
    { 0xDE85BB04, "ch_ang_01_05_riverbed_corpses_guy01" },
    { 0x508D2A3F, "ch_ang_01_05_riverbed_corpses_guy02" },
    { 0x2A8AAFD6, "ch_ang_01_05_riverbed_corpses_guy03" },
    { 0x6C7E4BC9, "ch_ang_01_05_riverbed_corpses_guy04" },
    { 0x467BD160, "ch_ang_01_05_riverbed_corpses_guy05" },
    { 0xB883409B, "ch_ang_01_05_riverbed_corpses_guy06" },
    { 0x9280C632, "ch_ang_01_05_riverbed_corpses_guy07" },
    { 0x349C08B5, "ch_ang_01_05_riverbed_corpses_guy08" },
    { 0x218D9CAA, "ch_ang_01_05_riverbed_vignettes_a_guy01" },
    { 0xFB8B2241, "ch_ang_01_05_riverbed_vignettes_a_guy02" },
    { 0xDF9A00B7, "ch_ang_01_05_riverbed_vignettes_a_guy04" },
    { 0xB997864E, "ch_ang_01_05_riverbed_vignettes_a_guy05" },
    { 0x93950BE5, "ch_ang_01_05_riverbed_vignettes_a_guy06" },
    { 0x6D92917C, "ch_ang_01_05_riverbed_vignettes_a_guy07" },
    { 0x177C43CB, "ch_ang_01_05_riverbed_vignettes_a_guy08" },
    { 0xF179C962, "ch_ang_01_05_riverbed_vignettes_a_guy09" },
    { 0x249AC904, "ch_ang_02_01_clash_fight_a_guy01" },
    { 0x96A2383F, "ch_ang_02_01_clash_fight_a_guy02" },
    { 0xC21FB9D3, "ch_ang_02_01_clash_fight_b_guy01" },
    { 0x50184A98, "ch_ang_02_01_clash_fight_b_guy02" },
    { 0xBD3D799B, "ch_ang_02_01_clash_fight_c_character_01_lives" },
    { 0xB3417212, "ch_ang_02_01_clash_fight_c_character_02_dies" },
    { 0x7B88344A, "ch_ang_02_01_clash_fight_d_character_01" },
    { 0x5585B9E1, "ch_ang_02_01_clash_fight_d_character_02" },
    { 0xDF6F066F, "ch_ang_02_01_pre_charge_l_buff_soldier1_startloop" },
    { 0x1C2DDBF0, "ch_ang_02_01_pre_charge_l_buff_soldier2_startloop" },
    { 0xAFABCC44, "ch_ang_02_01_pre_charge_r_buff_soldier1_jumprun" },
    { 0x8D48A3E1, "ch_ang_02_01_pre_charge_r_buff_soldier1_startloop" },
    { 0x6A7C9A63, "ch_ang_02_01_pre_charge_r_buff_soldier2_jumprun" },
    { 0x104397DE, "ch_ang_02_01_pre_charge_r_buff_soldier2_startloop" },
    { 0x03AC73CC, "ch_ang_02_01_savimbi_passengers_attack_loop_01" },
    { 0x75B3E307, "ch_ang_02_01_savimbi_passengers_attack_loop_02" },
    { 0x4FB1689E, "ch_ang_02_01_savimbi_passengers_attack_loop_03" },
    { 0x91A50491, "ch_ang_02_01_savimbi_passengers_attack_loop_04" },
    { 0x9F39F71E, "ch_ang_02_01_savimbi_passengers_idle_loop_01" },
    { 0x79377CB5, "ch_ang_02_01_savimbi_passengers_idle_loop_02" },
    { 0x5335024C, "ch_ang_02_01_savimbi_passengers_idle_loop_03" },
    { 0x2D3287E3, "ch_ang_02_01_savimbi_passengers_idle_loop_04" },
    { 0x40A453C2, "ch_ang_02_01_savimbi_passengers_transition_01" },
    { 0x1AA1D959, "ch_ang_02_01_savimbi_passengers_transition_02" },
    { 0xF49F5EF0, "ch_ang_02_01_savimbi_passengers_transition_03" },
    { 0xFEB0B7CF, "ch_ang_02_01_savimbi_passengers_transition_04" },
    { 0xA006056B, "ch_ang_02_01_savimbi_personel_engage_ally01" },
    { 0x2DFE9630, "ch_ang_02_01_savimbi_personel_engage_ally02" },
    { 0x54011099, "ch_ang_02_01_savimbi_personel_engage_ally03" },
    { 0x120D74A6, "ch_ang_02_01_savimbi_personel_engage_ally04" },
    { 0x380FEF0F, "ch_ang_02_01_savimbi_personel_engage_ally05" },
    { 0x4862AD45, "ch_ang_02_01_savimbi_personel_engage_enemy01" },
    { 0x6E6527AE, "ch_ang_02_01_savimbi_personel_engage_enemy02" },
    { 0x6405D153, "ch_ang_02_02_zulu_clash_guy01" },
    { 0x5D51DBE4, "ch_ang_02_02_zulu_clash_guy01_enter" },
    { 0x4398C944, "ch_ang_02_02_zulu_clash_guy01_idle" },
    { 0xF1FE6218, "ch_ang_02_02_zulu_clash_guy02" },
    { 0x1800DC81, "ch_ang_02_02_zulu_clash_guy03" },
    { 0xD60D408E, "ch_ang_02_02_zulu_clash_guy04" },
    { 0x44DFDD77, "ch_ang_02_02_zulu_clash_guy04_idle" },
    { 0xFC0FBAF7, "ch_ang_02_02_zulu_clash_guy05" },
    { 0xF7F122E0, "ch_ang_02_02_zulu_clash_guy05_enter" },
    { 0xED5678A0, "ch_ang_02_02_zulu_clash_guy05_idle" },
    { 0x8A084BBC, "ch_ang_02_02_zulu_clash_guy06" },
    { 0xB00AC625, "ch_ang_02_02_zulu_clash_guy07" },
    { 0x0DEF83A2, "ch_ang_02_02_zulu_clash_guy08" },
    { 0x0E027EAD, "ch_ang_02_02_zulu_clash_guy08_enter" },
    { 0xF85B7ED3, "ch_ang_02_02_zulu_clash_guy08_idle" },
    { 0x33F1FE0B, "ch_ang_02_02_zulu_clash_guy09" },
    { 0xBC9ABD15, "ch_ang_02_02_zulu_clash_guy10" },
    { 0x969842AC, "ch_ang_02_02_zulu_clash_guy11" },
    { 0x995D7375, "ch_ang_02_02_zulu_clash_guy11_idle" },
    { 0x089FB1E7, "ch_ang_02_02_zulu_clash_guy12" },
    { 0xE29D377E, "ch_ang_02_02_zulu_clash_guy13" },
    { 0x8ADEE681, "ch_ang_02_02_zulu_clash_guy13_enter" },
    { 0x88C56127, "ch_ang_02_02_zulu_clash_guy13_idle" },
    { 0x2490D371, "ch_ang_02_02_zulu_clash_guy14" },
    { 0x765912F8, "ch_ang_03_01_savimbi_fight_enemy1_left" },
    { 0x863DE407, "ch_ang_03_01_savimbi_fight_enemy1_right" },
    { 0xE846C26D, "ch_ang_03_01_savimbi_fight_enemy2_left" },
    { 0x6554A610, "ch_ang_03_01_savimbi_fight_enemy2_right" },
    { 0x6DABDB46, "ch_ang_03_01_savimbi_fight_enemy3_left" },
    { 0x11B0135D, "ch_ang_03_01_savimbi_fight_enemy3_right" },
    { 0x4E6B83E4, "ch_ang_03_01_savimbi_fight_savimbi_left" },
    { 0xC6DE5EDB, "ch_ang_03_01_savimbi_fight_savimbi_right" },
    { 0x9A422CF7, "ch_ang_03_01_savimbi_fires" },
    { 0xDE0E3F29, "ch_ang_03_01_savimbi_fires_end" },
    { 0x4759D544, "ch_ang_03_01_savimbi_fires_loop" },
    { 0xC37FDB02, "ch_ang_03_01_savimbi_fires_start" },
    { 0x3A17FCB2, "ch_ang_03_01_savimbi_joins_enemy" },
    { 0xF6B98CB9, "ch_ang_03_01_savimbi_joins_savimbi" },
    { 0x811A717A, "ch_ang_03_02_buffel_explosion_guy01" },
    { 0x5B17F711, "ch_ang_03_02_buffel_explosion_guy02" },
    { 0x35157CA8, "ch_ang_03_02_buffel_explosion_guy03" },
    { 0x2B22E842, "ch_ang_03_04_close_encounter_mlpa" },
    { 0x7DEFC917, "ch_ang_03_04_close_encounter_unita" },
    { 0x09F06BE3, "ch_ang_03_05_lead_vehicle_buffel_idle_player" },
    { 0x85D95B7E, "ch_ang_03_05_lead_vehicle_climb_enemy" },
    { 0x370A07FB, "ch_ang_03_05_lead_vehicle_climb_enemy_dead" },
    { 0xF10DCE4D, "ch_ang_03_05_lead_vehicle_climb_player" },
    { 0x4221D835, "ch_ang_03_05_lead_vehicle_climb_savimbi" },
    { 0xB5AFFD01, "ch_ang_03_05_lead_vehicle_command_savimbi" },
    { 0x8222F63D, "ch_ang_03_06_mpla_retreat_a" },
    { 0xA82570A6, "ch_ang_03_06_mpla_retreat_b" },
    { 0xCE27EB0F, "ch_ang_03_06_mpla_retreat_c" },
    { 0xC4169230, "ch_ang_03_06_mpla_retreat_d" },
    { 0xC8015CC0, "ch_ang_03_07_victory_shots_mpla01" },
    { 0x3A08CBFB, "ch_ang_03_07_victory_shots_mpla02" },
    { 0x7FC168EC, "ch_ang_03_07_victory_shots_player" },
    { 0x0F75E86E, "ch_ang_03_07_victory_shots_savimbi" },
    { 0x7B0939DB, "ch_ang_03_07_victory_shots_unita01" },
    { 0x0901CAA0, "ch_ang_03_07_victory_shots_unita02" },
    { 0x2F044509, "ch_ang_03_07_victory_shots_unita03" },
    { 0xED10A916, "ch_ang_03_07_victory_shots_unita04" },
    { 0x32600168, "ch_ang_04_01_hudson_landing" },
    { 0x3C9E6646, "ch_ang_04_01_landing_enemy01" },
    { 0x169BEBDD, "ch_ang_04_01_landing_enemy02" },
    { 0xF0997174, "ch_ang_04_01_landing_enemy03" },
    { 0xCA96F70B, "ch_ang_04_01_landing_enemy04" },
    { 0xA4947CA2, "ch_ang_04_01_landing_enemy05" },
    { 0x75423137, "ch_ang_04_01_landing_guy01" },
    { 0x033AC1FC, "ch_ang_04_01_landing_guy02" },
    { 0x293D3C65, "ch_ang_04_01_landing_guy03" },
    { 0xB735CD2A, "ch_ang_04_01_landing_guy04" },
    { 0xDD384793, "ch_ang_04_01_landing_guy05" },
    { 0x6B30D858, "ch_ang_04_01_landing_guy06" },
    { 0x913352C1, "ch_ang_04_01_landing_guy07" },
    { 0x1F2BE386, "ch_ang_04_01_landing_guy08" },
    { 0x452E5DEF, "ch_ang_04_01_landing_guy09" },
    { 0x0EC50459, "ch_ang_04_01_landing_guy10" },
    { 0xE8C289F0, "ch_ang_04_01_landing_guy11" },
    { 0x5AC9F92B, "ch_ang_04_01_landing_guy12" },
    { 0x34C77EC2, "ch_ang_04_01_landing_guy13" },
    { 0xA6CEEDFD, "ch_ang_04_01_landing_guy14" },
    { 0x2288A298, "ch_ang_04_01_savimbi_landing" },
    { 0xDA5F4D15, "ch_ang_04_01_soldier_landing" },
    { 0x1B7E171C, "ch_ang_05_01_rundown_intro_player" },
    { 0xD572F425, "ch_ang_05_01_rundown_intro_player_idle" },
    { 0x85E5D594, "ch_ang_05_01_rundown_player_hang_on" },
    { 0xE22EFB84, "ch_ang_05_04_boat_jump_player" },
    { 0x8539ADD2, "ch_ang_05_04_going_down_player" },
    { 0xBEF5BA67, "ch_ang_06_01_crate_push_guy" },
    { 0x6ADE452C, "ch_ang_06_01_enemy_boat_ram_left_a_guy01" },
    { 0xDCE5B467, "ch_ang_06_01_enemy_boat_ram_left_a_guy02" },
    { 0x85A08C5B, "ch_ang_06_01_enemy_boat_ram_left_b_guy01" },
    { 0x13991D20, "ch_ang_06_01_enemy_boat_ram_left_b_guy02" },
    { 0xEEF02647, "ch_ang_06_01_enemy_boat_ram_left_idle_guy01" },
    { 0x7CE8B70C, "ch_ang_06_01_enemy_boat_ram_left_idle_guy02" },
    { 0x6E2427BD, "ch_ang_06_01_enemy_boat_ram_right_a_guy01" },
    { 0x9426A226, "ch_ang_06_01_enemy_boat_ram_right_a_guy02" },
    { 0x5EB0B60A, "ch_ang_06_01_enemy_boat_ram_right_b_guy01" },
    { 0x38AE3BA1, "ch_ang_06_01_enemy_boat_ram_right_b_guy02" },
    { 0x81863C64, "ch_ang_06_01_enemy_boat_ram_right_idle_guy01" },
    { 0xF38DAB9F, "ch_ang_06_01_enemy_boat_ram_right_idle_guy02" },
    { 0x28B50FC3, "ch_ang_06_01_enemy_medium_boat_driver" },
    { 0x1188752B, "ch_ang_06_01_enemy_small_boat_driver" },
    { 0x00AE7F64, "ch_ang_06_01_gunboat_jump_player" },
    { 0x4469D2B8, "ch_ang_06_01_gunboat_ram_player" },
    { 0xA7A54A7B, "ch_ang_06_01_upper_deck_enemies_left_guy01" },
    { 0x359DDB40, "ch_ang_06_01_upper_deck_enemies_left_guy02" },
    { 0x5BD2ADC4, "ch_ang_06_01_upper_deck_enemies_right_guy01" },
    { 0xCDDA1CFF, "ch_ang_06_01_upper_deck_enemies_right_guy02" },
    { 0x92809AE5, "ch_ang_06_02_find_woods_part1_body01" },
    { 0xB883154E, "ch_ang_06_02_find_woods_part1_body02" },
    { 0x6019412D, "ch_ang_06_02_find_woods_part1_hudson" },
    { 0xD4470867, "ch_ang_06_02_find_woods_part1_player" },
    { 0x4E1DD27E, "ch_ang_06_02_find_woods_part1_woods" },
    { 0x52343154, "ch_ang_06_02_find_woods_part2_body01" },
    { 0xC43BA08F, "ch_ang_06_02_find_woods_part2_body02" },
    { 0x442F76A8, "ch_ang_06_02_find_woods_part2_hudson" },
    { 0x0360261A, "ch_ang_06_02_find_woods_part2_player" },
    { 0xF0E49EF5, "ch_ang_06_02_find_woods_part2_woods" },
    { 0xD4E16728, "ch_ang_06_02_get_strella_player" },
    { 0x776E1CB9, "ch_ang_06_02_wheelhouse_hit_player" },
    { 0x0C436A2E, "ch_ang_06_03_corpses_flung_guy01" },
    { 0xE640EFC5, "ch_ang_06_03_corpses_flung_guy02" },
    { 0xC03E755C, "ch_ang_06_03_corpses_flung_guy03" },
    { 0x9A3BFAF3, "ch_ang_06_03_corpses_flung_guy04" },
    { 0x24F18B30, "ch_ang_06_04_hind_aftermath_hudson" },
    { 0x4290FADD, "ch_ang_06_04_hind_aftermath_woods" },
    { 0x9862EC66, "ch_ang_06_04_hind_attacks_dive_player" },
    { 0xA8B11A73, "ch_ang_06_04_hind_attacks_player" },
    { 0x552FB107, "ch_ang_07_01_carry_woods_player_pickup" },
    { 0x86EC33D7, "ch_ang_07_01_charred_bodies_guy01" },
    { 0x14E4C49C, "ch_ang_07_01_charred_bodies_guy02" },
    { 0x3AE73F05, "ch_ang_07_01_charred_bodies_guy03" },
    { 0x2833C5CA, "ch_ang_07_01_river_bank_hudson_startloop" },
    { 0xFDB12062, "ch_ang_07_02_hiding_spot_hault_guy" },
    { 0x9785B5A4, "ch_ang_07_02_hiding_spot_hault_hudson" },
    { 0xE819ACA7, "ch_ang_07_02_hiding_spot_patrol01" },
    { 0x459ED41C, "ch_ang_07_02_hiding_spot_scene_guy" },
    { 0x9E125F64, "ch_ang_07_02_hiding_spot_scene_player" },
    { 0x72CDD933, "ch_ang_07_02_hiding_spot_wait_guy" },
    { 0x8C879E6C, "ch_ang_07_02_hudson_mantle_player" },
    { 0xA6B01E7F, "ch_ang_07_03_long_grass_patrol_a_guy01" },
    { 0x74B27E3C, "ch_ang_07_03_long_grass_patrol_a_guy01_loop" },
    { 0x8D3C7440, "ch_ang_07_03_long_grass_patrol_b_guy01" },
    { 0xD2D8637C, "ch_ang_07_03_village_ambienta_inspect_guy03" },
    { 0x96CC2AAA, "ch_ang_07_03_village_ambienta_patrol_guy01" },
    { 0xD669C133, "ch_ang_07_04_hudson_stealth_cover_point_01" },
    { 0x1B6B2E1C, "ch_ang_07_04_hudson_stealth_loop01" },
    { 0x8D729D57, "ch_ang_07_04_hudson_stealth_loop02" },
    { 0x7C85AF40, "ch_ang_08_01_hut_patroller_sentry" },
    { 0x1EED193E, "ch_ang_08_01_meatshield_ads_01_enemy01" },
    { 0xF8EA9ED5, "ch_ang_08_01_meatshield_ads_01_enemy02" },
    { 0x9994E427, "ch_ang_08_01_meatshield_ads_01_menendez" },
    { 0x3054F7E2, "ch_ang_08_01_meatshield_ads_01_player" },
    { 0x2F347F1D, "ch_ang_08_01_meatshield_ads_02_enemy01" },
    { 0x5536F986, "ch_ang_08_01_meatshield_ads_02_enemy02" },
    { 0x22411652, "ch_ang_08_01_meatshield_ads_02_menendez" },
    { 0x0FFF592F, "ch_ang_08_01_meatshield_ads_02_player" },
    { 0x565B988E, "ch_ang_08_01_meatshield_idle_01_enemy01" },
    { 0x15802FD7, "ch_ang_08_01_meatshield_idle_01_menendez" },
    { 0xD3DFB192, "ch_ang_08_01_meatshield_idle_01_player" },
    { 0x2BCBF3AD, "ch_ang_08_01_meatshield_idle_02_enemy01" },
    { 0x51CE6E16, "ch_ang_08_01_meatshield_idle_02_enemy02" },
    { 0x5A3EE802, "ch_ang_08_01_meatshield_idle_02_menendez" },
    { 0x9E1BD95F, "ch_ang_08_01_meatshield_idle_02_player" },
    { 0x19DDF818, "ch_ang_08_01_meatshield_idle_player" },
    { 0xAF5A4D98, "ch_ang_08_01_meatshield_intro_enemy01" },
    { 0xC858A76D, "ch_ang_08_01_meatshield_intro_menendez" },
    { 0xD966C288, "ch_ang_08_01_meatshield_intro_player" },
    { 0xDE4B630F, "ch_ang_08_01_meatshield_outro_enemy01" },
    { 0x6C43F3D4, "ch_ang_08_01_meatshield_outro_enemy02" },
    { 0x32AB5940, "ch_ang_08_01_meatshield_outro_menendez" },
    { 0x191B13C5, "ch_ang_08_01_meatshield_outro_player" },
    { 0x3A77C6E2, "ch_ang_08_01_radio_room_encounter_player" },
    { 0x72FC4335, "ch_ang_08_01_radio_room_enter_player" },
    { 0xF1495986, "ch_ang_08_01_radio_room_escape_player" },
    { 0xD2CAAB5A, "ch_ang_08_01_radio_room_menendez_loop" },
    { 0xD876E50A, "ch_ang_08_01_radio_room_part1_menendez" },
    { 0xFC8CC607, "ch_ang_08_01_radio_room_part1_player" },
    { 0x4CA3B77C, "ch_ang_08_01_radio_room_part2_child01" },
    { 0xBEAB26B7, "ch_ang_08_01_radio_room_part2_child02" },
    { 0x98A8AC4E, "ch_ang_08_01_radio_room_part2_child03" },
    { 0x0C7EC2D6, "ch_ang_08_01_radio_room_part2_enemy01" },
    { 0xE67C486D, "ch_ang_08_01_radio_room_part2_enemy02" },
    { 0xC079CE04, "ch_ang_08_01_radio_room_part2_enemy03" },
    { 0x040D373F, "ch_ang_08_01_radio_room_part2_menendez" },
    { 0x685127BA, "ch_ang_08_01_radio_room_part2_player" },
    { 0xAEF34257, "ch_ang_1_10_wave_to_savannah_guy01" },
    { 0x9A284079, "ch_assists" },
    { 0x9699DA55, "ch_av7_bosworth_part1" },
    { 0xBC9C54BE, "ch_av7_bosworth_part2" },
    { 0xE29ECF27, "ch_av7_bosworth_part3" },
    { 0xD88D7648, "ch_av7_bosworth_part4" },
    { 0xFE8FF0B1, "ch_av7_bosworth_part5" },
    { 0x24926B1A, "ch_av7_bosworth_part6" },
    { 0xCE5C6E8B, "ch_av7_briggs_part1" },
    { 0x5C54FF50, "ch_av7_briggs_part2" },
    { 0x825779B9, "ch_av7_briggs_part3" },
    { 0x4063DDC6, "ch_av7_briggs_part4" },
    { 0x6666582F, "ch_av7_briggs_part5" },
    { 0xF45EE8F4, "ch_av7_briggs_part6" },
    { 0xCBF0AA92, "ch_av7_chloe_part1" },
    { 0xA5EE3029, "ch_av7_chloe_part2" },
    { 0x7FEBB5C0, "ch_av7_chloe_part3" },
    { 0x89FD0E9F, "ch_av7_chloe_part4" },
    { 0x63FA9436, "ch_av7_chloe_part5" },
    { 0x3DF819CD, "ch_av7_chloe_part6" },
    { 0x22595AA9, "ch_av7_defalco_part1" },
    { 0x485BD512, "ch_av7_defalco_part2" },
    { 0x6E5E4F7B, "ch_av7_defalco_part3" },
    { 0x9460C9E4, "ch_av7_defalco_part4" },
    { 0xBA63444D, "ch_av7_defalco_part5" },
    { 0xE065BEB6, "ch_av7_defalco_part6" },
    { 0x9148F84B, "ch_av7_harper_part1" },
    { 0x1F418910, "ch_av7_harper_part2" },
    { 0x45440379, "ch_av7_harper_part3" },
    { 0x03506786, "ch_av7_harper_part4" },
    { 0x2952E1EF, "ch_av7_harper_part5" },
    { 0xB74B72B4, "ch_av7_harper_part6" },
    { 0x8A2F99A7, "ch_av7_mason_part1" },
    { 0x18282A6C, "ch_av7_mason_part2" },
    { 0x3E2AA4D5, "ch_av7_mason_part3" },
    { 0xCC23359A, "ch_av7_mason_part4" },
    { 0xF225B003, "ch_av7_mason_part5" },
    { 0x801E40C8, "ch_av7_mason_part6" },
    { 0xCE4337E6, "ch_av7_mv_christ_part1" },
    { 0xA840BD7D, "ch_av7_mv_christ_part2" },
    { 0x823E4314, "ch_av7_mv_christ_part3" },
    { 0x5C3BC8AB, "ch_av7_mv_christ_part4" },
    { 0x36394E42, "ch_av7_mv_christ_part5" },
    { 0x1036D3D9, "ch_av7_mv_christ_part6" },
    { 0x576AF5B2, "ch_av7_mv_gates_intro_part1" },
    { 0x31687B49, "ch_av7_mv_gates_intro_part2" },
    { 0xB6718015, "ch_av7_mv_gates_part1" },
    { 0xDC73FA7E, "ch_av7_mv_gates_part2" },
    { 0x027674E7, "ch_av7_mv_gates_part3" },
    { 0xF8651C08, "ch_av7_mv_gates_part4" },
    { 0x1E679671, "ch_av7_mv_gates_part5" },
    { 0x446A10DA, "ch_av7_mv_gates_part6" },
    { 0x6D2290E9, "ch_av7_mv_intro_sh001" },
    { 0x93250B52, "ch_av7_mv_intro_sh002" },
    { 0xB92785BB, "ch_av7_mv_intro_sh003" },
    { 0xDF2A0024, "ch_av7_mv_intro_sh004" },
    { 0x052C7A8D, "ch_av7_mv_intro_sh005" },
    { 0x2B2EF4F6, "ch_av7_mv_intro_sh006" },
    { 0x51316F5F, "ch_av7_mv_intro_sh007" },
    { 0x7733E9C8, "ch_av7_mv_intro_sh008" },
    { 0x9D366431, "ch_av7_mv_intro_sh009" },
    { 0xC6F4B12B, "ch_av7_mv_intro_sh010" },
    { 0x7F3FFFF4, "ch_av7_mv_intro_sh011_part2" },
    { 0x7AEFBC59, "ch_av7_mv_intro_sh012" },
    { 0x54ED41F0, "ch_av7_mv_intro_sh013" },
    { 0x5EFE9ACF, "ch_av7_mv_intro_sh014" },
    { 0x38FC2066, "ch_av7_mv_intro_sh015" },
    { 0x12F9A5FD, "ch_av7_mv_intro_sh016" },
    { 0xECF72B94, "ch_av7_mv_intro_sh017" },
    { 0xF7088473, "ch_av7_mv_intro_sh018" },
    { 0xD1060A0A, "ch_av7_mv_intro_sh019" },
    { 0x458C1756, "ch_av7_mv_intro_sh020" },
    { 0x6B8E91BF, "ch_av7_mv_intro_sh021" },
    { 0x3296E540, "ch_av7_mv_menendez_intro_part1" },
    { 0xA49E547B, "ch_av7_mv_menendez_intro_part2" },
    { 0x758FDFD3, "ch_av7_mv_menendez_part1" },
    { 0x03887098, "ch_av7_mv_menendez_part2" },
    { 0x298AEB01, "ch_av7_mv_menendez_part3" },
    { 0xE7974F0E, "ch_av7_mv_menendez_part4" },
    { 0x0D99C977, "ch_av7_mv_menendez_part5" },
    { 0x9B925A3C, "ch_av7_mv_menendez_part6" },
    { 0xC07B416E, "ch_av7_mv_sh001" },
    { 0x9A78C705, "ch_av7_mv_sh002" },
    { 0x74764C9C, "ch_av7_mv_sh003" },
    { 0x4E73D233, "ch_av7_mv_sh004" },
    { 0x287157CA, "ch_av7_mv_sh005" },
    { 0x026EDD61, "ch_av7_mv_sh006" },
    { 0xDC6C62F8, "ch_av7_mv_sh007" },
    { 0xB669E88F, "ch_av7_mv_sh008" },
    { 0x90676E26, "ch_av7_mv_sh009" },
    { 0x66A9212C, "ch_av7_mv_sh010" },
    { 0x8CAB9B95, "ch_av7_mv_sh011" },
    { 0xB2AE15FE, "ch_av7_mv_sh012" },
    { 0xD8B09067, "ch_av7_mv_sh013" },
    { 0xCE9F3788, "ch_av7_mv_sh014" },
    { 0xF4A1B1F1, "ch_av7_mv_sh015" },
    { 0x1AA42C5A, "ch_av7_mv_sh016" },
    { 0x40A6A6C3, "ch_av7_mv_sh017" },
    { 0x36954DE4, "ch_av7_mv_sh018" },
    { 0x5C97C84D, "ch_av7_mv_sh019" },
    { 0x235D3B0D, "ch_av7_mv_sh020" },
    { 0xFD5AC0A4, "ch_av7_mv_sh021" },
    { 0x6F622FDF, "ch_av7_mv_sh022" },
    { 0x495FB576, "ch_av7_mv_sh023" },
    { 0x8B535169, "ch_av7_mv_sh024" },
    { 0x6550D700, "ch_av7_mv_sh025" },
    { 0xD758463B, "ch_av7_mv_sh026" },
    { 0xB155CBD2, "ch_av7_mv_sh027" },
    { 0x53710E55, "ch_av7_mv_sh028" },
    { 0x2D6E93EC, "ch_av7_mv_sh029" },
    { 0xA4C5D4E2, "ch_av7_mv_sh030" },
    { 0xCAC84F4B, "ch_av7_mv_sh031" },
    { 0x58C0E010, "ch_av7_mv_sh032" },
    { 0x7EC35A79, "ch_av7_mv_sh033" },
    { 0x3CCFBE86, "ch_av7_mv_sh034" },
    { 0x62D238EF, "ch_av7_mv_sh035" },
    { 0xF0CAC9B4, "ch_av7_mv_sh036" },
    { 0x16CD441D, "ch_av7_mv_sh037" },
    { 0xD4D9A82A, "ch_av7_mv_sh038" },
    { 0xFADC2293, "ch_av7_mv_sh039" },
    { 0xEAE2EEAB, "ch_av7_mv_sh040" },
    { 0xC4E07442, "ch_av7_mv_sh041" },
    { 0x9EDDF9D9, "ch_av7_mv_sh042" },
    { 0x78DB7F70, "ch_av7_mv_sh043" },
    { 0x82ECD84F, "ch_av7_mv_sh044" },
    { 0x5CEA5DE6, "ch_av7_mv_sh045" },
    { 0x36E7E37D, "ch_av7_mv_sh046" },
    { 0x10E56914, "ch_av7_mv_sh047" },
    { 0x1AF6C1F3, "ch_av7_mv_sh048" },
    { 0xF4F4478A, "ch_av7_mv_sh049" },
    { 0x6B0E5400, "ch_av7_mv_sh050" },
    { 0x9110CE69, "ch_av7_mv_sh051" },
    { 0xB71348D2, "ch_av7_mv_sh052" },
    { 0xDD15C33B, "ch_av7_mv_sh053" },
    { 0x03183DA4, "ch_av7_mv_sh054" },
    { 0x291AB80D, "ch_av7_mv_sh055" },
    { 0x4F1D3276, "ch_av7_mv_sh056" },
    { 0x751FACDF, "ch_av7_mv_sh057" },
    { 0x9B222748, "ch_av7_mv_sh058" },
    { 0xC124A1B1, "ch_av7_mv_sh059" },
    { 0xE811BB01, "ch_av7_mv_sh060" },
    { 0xC20F4098, "ch_av7_mv_sh061" },
    { 0x3416AFD3, "ch_av7_mv_sh062" },
    { 0x0E14356A, "ch_av7_mv_sh063" },
    { 0x801BA4A5, "ch_av7_mv_sh064" },
    { 0x5A192A3C, "ch_av7_mv_sh065" },
    { 0xCC209977, "ch_av7_mv_sh066" },
    { 0xA61E1F0E, "ch_av7_mv_sh067" },
    { 0xB7FDE7B9, "ch_av7_mv_sh068" },
    { 0x91FB6D50, "ch_av7_mv_sh069" },
    { 0x697A54D6, "ch_av7_mv_sh070" },
    { 0x8F7CCF3F, "ch_av7_mv_sh071" },
    { 0x1D756004, "ch_av7_mv_sh072" },
    { 0x4377DA6D, "ch_av7_mv_sh073" },
    { 0xD1706B32, "ch_av7_mv_sh074" },
    { 0xF772E59B, "ch_av7_mv_sh075" },
    { 0x856B7660, "ch_av7_mv_sh076" },
    { 0xAB6DF0C9, "ch_av7_mv_sh077" },
    { 0x998E281E, "ch_av7_mv_sh078" },
    { 0xBF90A287, "ch_av7_mv_sh079" },
    { 0x5D14BBEF, "ch_av7_mv_sh080" },
    { 0x37124186, "ch_av7_mv_sh081" },
    { 0x110FC71D, "ch_av7_mv_sh082" },
    { 0xEB0D4CB4, "ch_av7_mv_sh083" },
    { 0xC50AD24B, "ch_av7_mv_sh084" },
    { 0x9F0857E2, "ch_av7_mv_sh085" },
    { 0x7905DD79, "ch_av7_mv_sh086" },
    { 0x53036310, "ch_av7_mv_sh087" },
    { 0x8D288F37, "ch_av7_mv_sh088" },
    { 0x672614CE, "ch_av7_mv_sh089" },
    { 0xDE7D55C4, "ch_av7_mv_sh090" },
    { 0x047FD02D, "ch_av7_mv_sh091" },
    { 0x2A824A96, "ch_av7_mv_sh092" },
    { 0x5084C4FF, "ch_av7_mv_sh093" },
    { 0x46736C20, "ch_av7_mv_sh094" },
    { 0x6C75E689, "ch_av7_mv_sh095" },
    { 0x927860F2, "ch_av7_mv_sh096" },
    { 0xB87ADB5B, "ch_av7_mv_sh097" },
    { 0x0E91290C, "ch_av7_mv_sh098" },
    { 0x3493A375, "ch_av7_mv_sh099" },
    { 0x7327E626, "ch_av7_mv_sh100" },
    { 0x992A608F, "ch_av7_mv_sh101" },
    { 0x2722F154, "ch_av7_mv_sh102" },
    { 0x4D256BBD, "ch_av7_mv_sh103" },
    { 0xDB1DFC82, "ch_av7_mv_sh104" },
    { 0x012076EB, "ch_av7_mv_sh105" },
    { 0x8F1907B0, "ch_av7_mv_sh106" },
    { 0xB51B8219, "ch_av7_mv_sh107" },
    { 0xA33BB96E, "ch_av7_mv_sh108" },
    { 0xC93E33D7, "ch_av7_mv_sh109" },
    { 0xF1BF4C51, "ch_av7_mv_sh110" },
    { 0xCBBCD1E8, "ch_av7_mv_sh111" },
    { 0x3DC44123, "ch_av7_mv_sh112" },
    { 0x17C1C6BA, "ch_av7_mv_sh113" },
    { 0x89C935F5, "ch_av7_mv_sh114" },
    { 0x63C6BB8C, "ch_av7_mv_sh115" },
    { 0xD5CE2AC7, "ch_av7_mv_sh116" },
    { 0xAFCBB05E, "ch_av7_mv_sh117" },
    { 0xC1AB7909, "ch_av7_mv_sh118" },
    { 0x9BA8FEA0, "ch_av7_mv_sh119" },
    { 0x74BBE550, "ch_av7_mv_sh120" },
    { 0x9ABE5FB9, "ch_av7_mv_sh121" },
    { 0xC0C0DA22, "ch_av7_mv_sh122" },
    { 0xE6C3548B, "ch_av7_mv_sh123" },
    { 0x0CC5CEF4, "ch_av7_mv_sh124" },
    { 0x32C8495D, "ch_av7_mv_sh125" },
    { 0x58CAC3C6, "ch_av7_mv_sh126" },
    { 0x7ECD3E2F, "ch_av7_mv_sh127" },
    { 0xA4CFB898, "ch_av7_mv_sh128" },
    { 0xCAD23301, "ch_av7_mv_sh129" },
    { 0xF3534B7B, "ch_av7_mv_sh130" },
    { 0xCD50D112, "ch_av7_mv_sh131" },
    { 0xA74E56A9, "ch_av7_mv_sh132" },
    { 0x814BDC40, "ch_av7_mv_sh133" },
    { 0x8B5D351F, "ch_av7_mv_sh134" },
    { 0x655ABAB6, "ch_av7_mv_sh135" },
    { 0x3F58404D, "ch_av7_mv_sh136" },
    { 0x1955C5E4, "ch_av7_mv_sh137" },
    { 0x23671EC3, "ch_av7_mv_sh138" },
    { 0xFD64A45A, "ch_av7_mv_sh139" },
    { 0xAE736632, "ch_av7_mv_sh140" },
    { 0xD475E09B, "ch_av7_mv_sh141" },
    { 0x626E7160, "ch_av7_mv_sh142" },
    { 0x8870EBC9, "ch_av7_mv_sh143" },
    { 0x467D4FD6, "ch_av7_mv_sh144" },
    { 0x6C7FCA3F, "ch_av7_mv_sh145" },
    { 0xFA785B04, "ch_av7_mv_sh146" },
    { 0x207AD56D, "ch_av7_mv_sh147" },
    { 0xDE87397A, "ch_av7_mv_sh148" },
    { 0x0489B3E3, "ch_av7_mv_sh149" },
    { 0x2D0ACC5D, "ch_av7_mv_sh150" },
    { 0x070851F4, "ch_av7_mv_sh151" },
    { 0x790FC12F, "ch_av7_mv_sh152" },
    { 0x530D46C6, "ch_av7_mv_sh153" },
    { 0xBAB8EE29, "ch_av7_mv_shadows_intro_part1" },
    { 0xE0BB6892, "ch_av7_mv_shadows_intro_part2" },
    { 0x22DD6A52, "ch_av7_mv_shadows_part1" },
    { 0xFCDAEFE9, "ch_av7_mv_shadows_part2" },
    { 0xD6D87580, "ch_av7_mv_shadows_part3" },
    { 0xE0E9CE5F, "ch_av7_mv_shadows_part4" },
    { 0xBAE753F6, "ch_av7_mv_shadows_part5" },
    { 0x94E4D98D, "ch_av7_mv_shadows_part6" },
    { 0xC8E73159, "ch_av7_mv_shot001_mason_reznov" },
    { 0x1FEBCD11, "ch_av7_mv_shot002_chloe_defalco" },
    { 0x3E407EB9, "ch_av7_mv_shot003_briggs_zhao" },
    { 0x00DD7CFD, "ch_av7_mv_shot004_harper" },
    { 0x1283E219, "ch_av7_mv_shot005_section" },
    { 0xB4335E45, "ch_av7_mv_shot006_bosworth" },
    { 0x1DC94516, "ch_av7_mv_vengence_part1" },
    { 0xF7C6CAAD, "ch_av7_mv_vengence_part2" },
    { 0xD1C45044, "ch_av7_mv_vengence_part3" },
    { 0xABC1D5DB, "ch_av7_mv_vengence_part4" },
    { 0x85BF5B72, "ch_av7_mv_vengence_part5" },
    { 0x5FBCE109, "ch_av7_mv_vengence_part6" },
    { 0xCD2CD094, "ch_av7_mv_woods_intro_part1" },
    { 0x3F343FCF, "ch_av7_mv_woods_intro_part2" },
    { 0x8AA7C8C7, "ch_av7_mv_woods_part1" },
    { 0x18A0598C, "ch_av7_mv_woods_part2" },
    { 0x3EA2D3F5, "ch_av7_mv_woods_part3" },
    { 0xCC9B64BA, "ch_av7_mv_woods_part4" },
    { 0xF29DDF23, "ch_av7_mv_woods_part5" },
    { 0x80966FE8, "ch_av7_mv_woods_part6" },
    { 0x471C0BFD, "ch_av7_reznov_part1" },
    { 0x6D1E8666, "ch_av7_reznov_part2" },
    { 0x932100CF, "ch_av7_reznov_part3" },
    { 0x890FA7F0, "ch_av7_reznov_part4" },
    { 0xAF122259, "ch_av7_reznov_part5" },
    { 0xD5149CC2, "ch_av7_reznov_part6" },
    { 0x3C62310C, "ch_av7_section_part1" },
    { 0xAE69A047, "ch_av7_section_part2" },
    { 0x886725DE, "ch_av7_section_part3" },
    { 0xCA5AC1D1, "ch_av7_section_part4" },
    { 0xA4584768, "ch_av7_section_part5" },
    { 0x165FB6A3, "ch_av7_section_part6" },
    { 0xDECF6C23, "ch_av7_zhao_part1" },
    { 0x6CC7FCE8, "ch_av7_zhao_part2" },
    { 0x92CA7751, "ch_av7_zhao_part3" },
    { 0x50D6DB5E, "ch_av7_zhao_part4" },
    { 0x76D955C7, "ch_av7_zhao_part5" },
    { 0x04D1E68C, "ch_av7_zhao_part6" },
    { 0x2AAD54F0, "ch_bbq" },
    { 0xEEDEE8B7, "ch_brasscollector" },
    { 0x07EA1804, "ch_brf_phase1_drone_briggs" },
    { 0x2AD72D1F, "ch_brf_phase1_drone_troop1" },
    { 0xB8CFBDE4, "ch_brf_phase1_drone_troop2" },
    { 0xDED2384D, "ch_brf_phase1_drone_troop3" },
    { 0x6CCAC912, "ch_brf_phase1_drone_troop4" },
    { 0x92CD437B, "ch_brf_phase1_drone_troop5" },
    { 0x767FB8EC, "ch_brf_phase1_intro_briggs" },
    { 0x7FF60A57, "ch_brf_phase1_intro_troop1" },
    { 0x0DEE9B1C, "ch_brf_phase1_intro_troop2" },
    { 0x33F11585, "ch_brf_phase1_intro_troop3" },
    { 0xC1E9A64A, "ch_brf_phase1_intro_troop4" },
    { 0xE7EC20B3, "ch_brf_phase1_intro_troop5" },
    { 0x5B06806E, "ch_brf_phase2_afghan_end_briggs" },
    { 0x3C90D5D9, "ch_brf_phase2_afghan_end_troop1" },
    { 0x62935042, "ch_brf_phase2_afghan_end_troop2" },
    { 0x8895CAAB, "ch_brf_phase2_afghan_end_troop3" },
    { 0xAE984514, "ch_brf_phase2_afghan_end_troop4" },
    { 0xD49ABF7D, "ch_brf_phase2_afghan_end_troop5" },
    { 0xFBE8D725, "ch_brf_phase2_afghanistan_briggs" },
    { 0xAF8B20BE, "ch_brf_phase2_afghanistan_troop1" },
    { 0x8988A655, "ch_brf_phase2_afghanistan_troop2" },
    { 0x63862BEC, "ch_brf_phase2_afghanistan_troop3" },
    { 0x3D83B183, "ch_brf_phase2_afghanistan_troop4" },
    { 0x1781371A, "ch_brf_phase2_afghanistan_troop5" },
    { 0x5DE2A23B, "ch_brf_phase2_iran_danger_india_danger_briggs" },
    { 0xAF2F479C, "ch_brf_phase2_iran_danger_india_danger_troop1" },
    { 0x2136B6D7, "ch_brf_phase2_iran_danger_india_danger_troop2" },
    { 0xFB343C6E, "ch_brf_phase2_iran_danger_india_danger_troop3" },
    { 0x3D27D861, "ch_brf_phase2_iran_danger_india_danger_troop4" },
    { 0x17255DF8, "ch_brf_phase2_iran_danger_india_danger_troop5" },
    { 0xB325DC4D, "ch_brf_phase2_iran_danger_india_safe_briggs" },
    { 0xAA66D6D6, "ch_brf_phase2_iran_danger_india_safe_troop1" },
    { 0x84645C6D, "ch_brf_phase2_iran_danger_india_safe_troop2" },
    { 0x5E61E204, "ch_brf_phase2_iran_danger_india_safe_troop3" },
    { 0x385F679B, "ch_brf_phase2_iran_danger_india_safe_troop4" },
    { 0x125CED32, "ch_brf_phase2_iran_danger_india_safe_troop5" },
    { 0x1A2B1225, "ch_brf_phase2_iran_safe_india_danger_briggs" },
    { 0xCDCD5BBE, "ch_brf_phase2_iran_safe_india_danger_troop1" },
    { 0xA7CAE155, "ch_brf_phase2_iran_safe_india_danger_troop2" },
    { 0x81C866EC, "ch_brf_phase2_iran_safe_india_danger_troop3" },
    { 0x5BC5EC83, "ch_brf_phase2_iran_safe_india_danger_troop4" },
    { 0x35C3721A, "ch_brf_phase2_iran_safe_india_danger_troop5" },
    { 0x4F1B1CAB, "ch_brf_phase2_iran_safe_india_safe_briggs" },
    { 0xBBBA664C, "ch_brf_phase2_iran_safe_india_safe_troop1" },
    { 0x2DC1D587, "ch_brf_phase2_iran_safe_india_safe_troop2" },
    { 0x07BF5B1E, "ch_brf_phase2_iran_safe_india_safe_troop3" },
    { 0x49B2F711, "ch_brf_phase2_iran_safe_india_safe_troop4" },
    { 0x23B07CA8, "ch_brf_phase2_iran_safe_india_safe_troop5" },
    { 0x980C4D09, "ch_brf_phase3_0_territory_briggs" },
    { 0x77BC7C6A, "ch_brf_phase3_0_territory_troop1" },
    { 0x51BA0201, "ch_brf_phase3_0_territory_troop2" },
    { 0x2BB78798, "ch_brf_phase3_0_territory_troop3" },
    { 0x35C8E077, "ch_brf_phase3_0_territory_troop4" },
    { 0x0FC6660E, "ch_brf_phase3_0_territory_troop5" },
    { 0x40F29DBE, "ch_brf_phase3_1_territory_briggs" },
    { 0x806C3329, "ch_brf_phase3_1_territory_troop1" },
    { 0xA66EAD92, "ch_brf_phase3_1_territory_troop2" },
    { 0xCC7127FB, "ch_brf_phase3_1_territory_troop3" },
    { 0xF273A264, "ch_brf_phase3_1_territory_troop4" },
    { 0x18761CCD, "ch_brf_phase3_1_territory_troop5" },
    { 0x8B9D16B7, "ch_brf_phase3_2_territory_briggs" },
    { 0x72B7BB30, "ch_brf_phase3_2_territory_troop1" },
    { 0xE4BF2A6B, "ch_brf_phase3_2_territory_troop2" },
    { 0xBEBCB002, "ch_brf_phase3_2_territory_troop3" },
    { 0x30C41F3D, "ch_brf_phase3_2_territory_troop4" },
    { 0x0AC1A4D4, "ch_brf_phase3_2_territory_troop5" },
    { 0x20D5842C, "ch_brf_phase3_3_territory_briggs" },
    { 0x290EA117, "ch_brf_phase3_3_territory_troop1" },
    { 0xB70731DC, "ch_brf_phase3_3_territory_troop2" },
    { 0xDD09AC45, "ch_brf_phase3_3_territory_troop3" },
    { 0x6B023D0A, "ch_brf_phase3_3_territory_troop4" },
    { 0x9104B773, "ch_brf_phase3_3_territory_troop5" },
    { 0x5F0EA305, "ch_brf_phase3_ending_briggs" },
    { 0xBB35E41E, "ch_brf_phase3_ending_troop1" },
    { 0x953369B5, "ch_brf_phase3_ending_troop2" },
    { 0x6F30EF4C, "ch_brf_phase3_ending_troop3" },
    { 0x492E74E3, "ch_brf_phase3_ending_troop4" },
    { 0x232BFA7A, "ch_brf_phase3_ending_troop5" },
    { 0x69993754, "ch_brf_phase3_socotra_briefing_briggs" },
    { 0x05C6DD2F, "ch_brf_phase3_socotra_briefing_troop1" },
    { 0x93BF6DF4, "ch_brf_phase3_socotra_briefing_troop2" },
    { 0xB9C1E85D, "ch_brf_phase3_socotra_briefing_troop3" },
    { 0x47BA7922, "ch_brf_phase3_socotra_briefing_troop4" },
    { 0x6DBCF38B, "ch_brf_phase3_socotra_briefing_troop5" },
    { 0x6A36D51C, "ch_brf_phase3_socotra_intro_briggs" },
    { 0xFE3EBF47, "ch_brf_phase3_socotra_intro_troop1" },
    { 0x8C37500C, "ch_brf_phase3_socotra_intro_troop2" },
    { 0xB239CA75, "ch_brf_phase3_socotra_intro_troop3" },
    { 0x40325B3A, "ch_brf_phase3_socotra_intro_troop4" },
    { 0x6634D5A3, "ch_brf_phase3_socotra_intro_troop5" },
    { 0xC280EF67, "ch_brf_phase4_intro_briggs" },
    { 0xEC4D4F20, "ch_brf_phase4_intro_troop1" },
    { 0x5E54BE5B, "ch_brf_phase4_intro_troop2" },
    { 0x385243F2, "ch_brf_phase4_intro_troop3" },
    { 0xAA59B32D, "ch_brf_phase4_intro_troop4" },
    { 0x845738C4, "ch_brf_phase4_intro_troop5" },
    { 0x214AB56C, "ch_brf_phase4_pak_briefing_briggs" },
    { 0x2AC106D7, "ch_brf_phase4_pak_briefing_troop1" },
    { 0xB8B9979C, "ch_brf_phase4_pak_briefing_troop2" },
    { 0xDEBC1205, "ch_brf_phase4_pak_briefing_troop3" },
    { 0x6CB4A2CA, "ch_brf_phase4_pak_briefing_troop4" },
    { 0x92B71D33, "ch_brf_phase4_pak_briefing_troop5" },
    { 0x3C2C32D7, "ch_brf_phase4_pak_end_briggs" },
    { 0xB2C4F4D0, "ch_brf_phase4_pak_end_troop1" },
    { 0x24CC640B, "ch_brf_phase4_pak_end_troop2" },
    { 0xFEC9E9A2, "ch_brf_phase4_pak_end_troop3" },
    { 0x70D158DD, "ch_brf_phase4_pak_end_troop4" },
    { 0x4ACEDE74, "ch_brf_phase4_pak_end_troop5" },
    { 0x16B7F422, "ch_brf_phase4_pak_intel_briggs" },
    { 0x1A5F4BA5, "ch_brf_phase4_pak_intel_troop1" },
    { 0x4061C60E, "ch_brf_phase4_pak_intel_troop2" },
    { 0x66644077, "ch_brf_phase4_pak_intel_troop3" },
    { 0x5C52E798, "ch_brf_phase4_pak_intel_troop4" },
    { 0x82556201, "ch_brf_phase4_pak_intel_troop5" },
    { 0xE2D8064A, "ch_brf_phase4_pakistan_no_intel_troop1" },
    { 0xBCD58BE1, "ch_brf_phase4_pakistan_no_intel_troop2" },
    { 0x96D31178, "ch_brf_phase4_pakistan_no_intel_troop3" },
    { 0xA0E46A57, "ch_brf_phase4_pakistan_no_intel_troop4" },
    { 0x7AE1EFEE, "ch_brf_phase4_pakistan_no_intel_troop5" },
    { 0x62957316, "ch_brf_wait_idle_player" },
    { 0x38CEE483, "ch_bulletdamagecommon" },
    { 0x9FFD59F8, "ch_bulletkillcommon" },
    { 0x3C38D6BE, "ch_checkpointloaded" },
    { 0x51D117B9, "ch_command_01_01_observation_cctv_briggs" },
    { 0x19DAEF4D, "ch_command_01_01_observation_cctv_menendez" },
    { 0x2E53A971, "ch_command_01_01_observation_cctv_salazar" },
    { 0x440B1B8C, "ch_command_01_03_returntointerrogation_briggs" },
    { 0xB749DB77, "ch_command_01_03_returntointerrogation_briggs_stepasideandleave" },
    { 0x2CBB2644, "ch_command_01_03_returntointerrogation_briggs_wait" },
    { 0xD9A82670, "ch_command_01_03_returntointerrogation_menendez" },
    { 0x49B513B8, "ch_command_01_03_returntointerrogation_menendez_wait" },
    { 0xA0E1B750, "ch_command_01_03_returntointerrogation_sailor_01_wait" },
    { 0x6EB58D4D, "ch_command_01_03_returntointerrogation_sailor_02_wait" },
    { 0x75B68662, "ch_command_01_03_returntointerrogation_salazar" },
    { 0xD45DDFF6, "ch_command_01_03_returntointerrogation_salazar_wait" },
    { 0x162B1144, "ch_command_01_03_theprestige_sailor_01" },
    { 0x52FCA317, "ch_command_01_05_monolouge_end_menendez" },
    { 0xFAAE5B57, "ch_command_01_05_monolouge_end_salazar" },
    { 0x468EDBAD, "ch_command_01_05_monolouge_menendez" },
    { 0xE33DE251, "ch_command_01_05_monolouge_salazar" },
    { 0x5CFEB416, "ch_command_01_05_theprestige_menendez" },
    { 0x5F8884CC, "ch_command_01_05_theprestige_salazar" },
    { 0xDC20D62F, "ch_command_02_01_wake_up_salazar_cautiousidle" },
    { 0x083EE4FA, "ch_command_02_01_wake_up_salazar_dooropen" },
    { 0x5AEEAA80, "ch_command_02_01_wake_up_salazar_helpaccepted" },
    { 0xBF150382, "ch_command_02_01_wake_up_salazar_helpdenied" },
    { 0x583FD75D, "ch_command_02_01_wake_up_salazar_reachingoutidle" },
    { 0x175550BE, "ch_command_02_01_wake_up_salazar_walktodoor" },
    { 0x18579F2E, "ch_command_02_01_wake_up_salazar_walktolocker" },
    { 0x6787C791, "ch_command_02_03_hallway_devastation_pmc01" },
    { 0x8D8A41FA, "ch_command_02_03_hallway_devastation_pmc02" },
    { 0xB38CBC63, "ch_command_02_03_hallway_devastation_pmc03" },
    { 0xD98F36CC, "ch_command_02_03_hallway_devastation_pmc04" },
    { 0x53D8737D, "ch_command_02_03_hallway_devastation_usnavy01" },
    { 0x79DAEDE6, "ch_command_02_03_hallway_devastation_usnavy02" },
    { 0x9FDD684F, "ch_command_02_03_hallway_devastation_usnavy03" },
    { 0x95CC0F70, "ch_command_02_03_hallway_devastation_usnavy04" },
    { 0x9AD99AB3, "ch_command_02_03_hallway_devastation_usnavy05_coughblood_loop" },
    { 0xE1D10442, "ch_command_02_03_hallway_devastation_usnavy06" },
    { 0x9651FA77, "ch_command_02_03_hallway_devastation_usnavy06_surgery_loop" },
    { 0x07D37EAB, "ch_command_02_03_hallway_devastation_usnavy07" },
    { 0x0FACB624, "ch_command_02_03_hallway_devastation_usnavy07_surgery_loop" },
    { 0x5DE9CC5C, "ch_command_02_03_hallway_devastation_usnavy08" },
    { 0x83EC46C5, "ch_command_02_03_hallway_devastation_usnavy09" },
    { 0xAC6D5F3F, "ch_command_02_03_hallway_devastation_usnavy10" },
    { 0x0EA049C0, "ch_command_02_03_hallway_devastation_usnavy10_surgery_loop" },
    { 0x866AE4D6, "ch_command_02_03_hallway_devastation_usnavy11" },
    { 0x60686A6D, "ch_command_02_03_hallway_devastation_usnavy12" },
    { 0xF3F3FF5C, "ch_command_02_04_up_the_staircase" },
    { 0x55D04887, "ch_command_02_07_salazar_exit_sala" },
    { 0x2C1B9DD4, "ch_command_03_01_pmc_entries_pmc01" },
    { 0x9E230D0F, "ch_command_03_01_pmc_entries_pmc02" },
    { 0x782092A6, "ch_command_03_01_pmc_entries_pmc03" },
    { 0x76D92BEC, "ch_command_03_02_turret_reveal_death_sailor_01" },
    { 0xE8E09B27, "ch_command_03_02_turret_reveal_death_sailor_02" },
    { 0x92336464, "ch_command_03_02_turret_reveal_injured_loop_sailor_01" },
    { 0x043AD39F, "ch_command_03_02_turret_reveal_injured_loop_sailor_02" },
    { 0x0B5D59EB, "ch_command_03_02_turret_reveal_sailor_01" },
    { 0x9955EAB0, "ch_command_03_02_turret_reveal_sailor_02" },
    { 0xBF586519, "ch_command_03_02_turret_reveal_sailor_03" },
    { 0xB1159C78, "ch_command_03_03_cic_hacker_hacker01_idle" },
    { 0xE4C11B53, "ch_command_03_03_cic_hacker_hacker01_react" },
    { 0x7911CE3D, "ch_command_03_03_cic_hacker_hacker02_idle" },
    { 0x53FC0BF8, "ch_command_03_03_cic_hacker_hacker02_react" },
    { 0xA8A86D24, "ch_command_03_05_down_the_stairs" },
    { 0x16D0655B, "ch_command_03_05_window_throw_pmc" },
    { 0x13142A50, "ch_command_03_05_window_throw_pmc_loop" },
    { 0x16B9CEE5, "ch_command_03_05_window_throw_sailor" },
    { 0x4DB9EB02, "ch_command_03_05_window_throw_sailor_loop" },
    { 0x5414E498, "ch_command_03_05_zip_tie_pmc_01" },
    { 0x570A0A61, "ch_command_03_05_zip_tie_pmc_01_loop" },
    { 0xC61C53D3, "ch_command_03_05_zip_tie_pmc_02" },
    { 0xA019D96A, "ch_command_03_05_zip_tie_pmc_03" },
    { 0xD978D32C, "ch_command_03_05_zip_tie_sailor_01" },
    { 0xA70D475D, "ch_command_03_05_zip_tie_sailor_01_loop" },
    { 0x4B804267, "ch_command_03_05_zip_tie_sailor_02" },
    { 0xA38C7AD4, "ch_command_03_05_zip_tie_sailor_02_loop" },
    { 0xE5246BF7, "ch_command_03_06_door_break_pmc_01" },
    { 0xB478B63E, "ch_command_03_06_door_break_pmc_03_death" },
    { 0xD9945150, "ch_command_03_08_cctv_menendez_defalco" },
    { 0x48AB7ACD, "ch_command_03_08_cctv_menendez_dez" },
    { 0xA48BF865, "ch_command_03_08_cctv_menendez_guy" },
    { 0x1B8D17AD, "ch_command_03_08_torch_wall_guy_01_in" },
    { 0x5F3140DA, "ch_command_03_08_torch_wall_guy_01_loop" },
    { 0x2809E938, "ch_command_03_08_torch_wall_guy_01_open" },
    { 0x8387F453, "ch_command_03_08_vent_redshirt_01" },
    { 0x11808518, "ch_command_03_08_vent_redshirt_02" },
    { 0xD6B0D51B, "ch_command_04_01_salazar_pip_briggs" },
    { 0x9D0D4E2D, "ch_command_04_01_salazar_pip_soldier" },
    { 0x001959C2, "ch_command_04_02_grab_defalco" },
    { 0x7805F2D9, "ch_command_04_02_grab_defalco_approach" },
    { 0xCE629EEA, "ch_command_04_02_grab_defalco_pilar_loop" },
    { 0xC6D51701, "ch_command_04_02_grabbed_briggs" },
    { 0x8A31FAC2, "ch_command_04_02_grabbed_briggs_idle" },
    { 0x72B2C709, "ch_command_04_02_worker_hit" },
    { 0xF0187D5C, "ch_command_04_02_worker_idle" },
    { 0x42603F85, "ch_command_04_04_alive_a_b_farid_idle" },
    { 0xA46C2162, "ch_command_04_04_alive_a_b_farid_reaction" },
    { 0xB25918CB, "ch_command_04_04_alive_a_b_farid_reaction_loop" },
    { 0xE2354BFF, "ch_command_04_04_alive_a_defalco" },
    { 0xDC182D6B, "ch_command_04_04_alive_a_defalco_deadpose" },
    { 0x3E77D579, "ch_command_04_04_alive_a_defalco_shooting" },
    { 0xBE601AB3, "ch_command_04_04_alive_a_farid" },
    { 0xC8D17C77, "ch_command_04_04_alive_a_farid_deadpose" },
    { 0x6E063F45, "ch_command_04_04_alive_a_farid_shooting" },
    { 0x00BEF575, "ch_command_04_04_alive_a_guard01" },
    { 0x26C16FDE, "ch_command_04_04_alive_a_guard02" },
    { 0x5E73C0A7, "ch_command_04_04_alive_a_karma" },
    { 0xF59AB2F1, "ch_command_04_04_alive_a_karma_shooting" },
    { 0xF32C8997, "ch_command_04_04_alive_a_salazar" },
    { 0x2E106561, "ch_command_04_04_alive_a_salazar_shooting" },
    { 0xEC4057B4, "ch_command_04_04_alive_b_defalco" },
    { 0x6F1B44B6, "ch_command_04_04_alive_b_defalco_deadpose" },
    { 0xF7BBF34C, "ch_command_04_04_alive_b_defalco_shooting" },
    { 0x8B4250EC, "ch_command_04_04_alive_b_farid" },
    { 0xD70E4EFE, "ch_command_04_04_alive_b_farid_deadpose" },
    { 0x1BF9B994, "ch_command_04_04_alive_b_farid_shooting" },
    { 0x4208283E, "ch_command_04_04_alive_b_guard01" },
    { 0x1C05ADD5, "ch_command_04_04_alive_b_guard02" },
    { 0xA4AF8790, "ch_command_04_04_alive_b_salazar" },
    { 0xE7B61F00, "ch_command_04_04_alive_b_salazar_shooting" },
    { 0x35A2536D, "ch_command_04_04_alive_c_defalco" },
    { 0x0E086DAB, "ch_command_04_04_alive_c_defalco_shooting" },
    { 0xF03AC05F, "ch_command_04_04_alive_c_guard01" },
    { 0x7E335124, "ch_command_04_04_alive_c_guard02" },
    { 0xF327B901, "ch_command_04_04_alive_c_karma" },
    { 0xE0473745, "ch_command_04_04_alive_c_karma_deadpose" },
    { 0x61DEC507, "ch_command_04_04_alive_c_karma_shooting" },
    { 0x0740E65D, "ch_command_04_04_alive_c_karma_shooting_dead_loop" },
    { 0xFDB3C275, "ch_command_04_04_alive_c_salazar" },
    { 0xD6252863, "ch_command_04_04_alive_c_salazar_shooting" },
    { 0xF8274DC0, "ch_command_04_04_backup_gaurd_01_idle" },
    { 0x0F7AC5B1, "ch_command_04_04_backup_gaurd_01_killed" },
    { 0x4C6D3306, "ch_command_04_04_backup_gaurd_01_killed_loop" },
    { 0x34DBF26B, "ch_command_04_04_backup_gaurd_01_reaction" },
    { 0x349CE025, "ch_command_04_04_backup_gaurd_02_idle" },
    { 0x70DBD5C4, "ch_command_04_04_backup_gaurd_02_killed" },
    { 0xC4CFE0C5, "ch_command_04_04_backup_gaurd_02_killed_loop" },
    { 0xA3091C02, "ch_command_04_04_backup_gaurd_02_reaction" },
    { 0x672F1565, "ch_command_04_04_backup_salazar_backstep_loop" },
    { 0xC74E67C5, "ch_command_04_04_backup_salazar_idle" },
    { 0xB13FC0A2, "ch_command_04_04_backup_salazar_reaction" },
    { 0xAC772A64, "ch_command_04_04_backup_salazar_shooting" },
    { 0x2EDE3B80, "ch_command_04_04_backup_salazar_shooting_alone" },
    { 0x51AC3B74, "ch_command_04_04_dead_a_farid" },
    { 0x17791F76, "ch_command_04_04_dead_a_farid_deadpose" },
    { 0x8E614C3D, "ch_command_04_04_dead_a_farid_idle" },
    { 0x1B084BAA, "ch_command_04_04_dead_a_farid_reaction" },
    { 0xD2DF387B, "ch_command_04_04_dead_a_farid_reaction_idle" },
    { 0xA019CE0C, "ch_command_04_04_dead_a_farid_shooting" },
    { 0xE63FBA36, "ch_command_04_04_dead_a_guard01" },
    { 0xC03D3FCD, "ch_command_04_04_dead_a_guard02" },
    { 0x3BC3D3B8, "ch_command_04_04_dead_a_karma" },
    { 0x53CE3F59, "ch_command_04_04_dead_a_karma_idle" },
    { 0x754BF78E, "ch_command_04_04_dead_a_karma_reaction" },
    { 0x57664277, "ch_command_04_04_dead_a_karma_reaction_idle" },
    { 0xC5BCCFB8, "ch_command_04_04_dead_a_karma_shooting" },
    { 0x1106D0C8, "ch_command_04_04_dead_a_salazar" },
    { 0x7EC1E848, "ch_command_04_04_dead_a_salazar_shooting" },
    { 0x5AD762BB, "ch_command_04_04_dead_b_farid" },
    { 0x5348E00F, "ch_command_04_04_dead_b_farid_deadpose" },
    { 0x6B0920CC, "ch_command_04_04_dead_b_farid_idle" },
    { 0x4A7E11FF, "ch_command_04_04_dead_b_farid_reaction" },
    { 0x319B78BC, "ch_command_04_04_dead_b_farid_reaction_loop" },
    { 0x48CB55FD, "ch_command_04_04_dead_b_farid_shooting" },
    { 0xD182520D, "ch_command_04_04_dead_b_guard01" },
    { 0xF784CC76, "ch_command_04_04_dead_b_guard02" },
    { 0x534B4A4F, "ch_command_04_04_dead_b_salazar" },
    { 0x5569A9C9, "ch_command_04_04_dead_b_salazar_shooting" },
    { 0x5F79339C, "ch_command_04_04_dead_c_guard01" },
    { 0xD180A2D7, "ch_command_04_04_dead_c_guard02" },
    { 0xA46B9186, "ch_command_04_04_dead_c_karma" },
    { 0x3BEB36CF, "ch_command_04_04_dead_c_karma_idle" },
    { 0x985CF3FC, "ch_command_04_04_dead_c_karma_reaction" },
    { 0xC2495DCD, "ch_command_04_04_dead_c_karma_reaction_loop" },
    { 0xCA6D6C8A, "ch_command_04_04_dead_c_karma_shooting" },
    { 0x0F584DCA, "ch_command_04_04_dead_c_salazar" },
    { 0x6D737DF6, "ch_command_04_04_dead_c_salazar_shooting" },
    { 0x177933B3, "ch_command_04_04_dead_d_guard01" },
    { 0xA571C478, "ch_command_04_04_dead_d_guard02" },
    { 0x5F93C309, "ch_command_04_04_dead_d_salazar" },
    { 0xD20F7D13, "ch_command_04_04_guard01_deadpose" },
    { 0x118F3FEE, "ch_command_04_04_guard02_deadpose" },
    { 0xBBADBDFD, "ch_command_04_06_kneecap_briggs_deadpose_01" },
    { 0x21A6F562, "ch_command_04_06_kneecap_briggs_deathpose_02" },
    { 0x59665F16, "ch_command_04_06_kneecap_briggs_headshot" },
    { 0x0AAC080C, "ch_command_04_06_kneecap_briggs_hit_first" },
    { 0x9BB39029, "ch_command_04_06_kneecap_briggs_hit_injured" },
    { 0x7317043E, "ch_command_04_06_kneecap_briggs_hit_kill" },
    { 0x43B3C3F1, "ch_command_04_06_kneecap_briggs_hit_wait" },
    { 0xAE0A7696, "ch_command_04_06_kneecap_briggs_ko" },
    { 0x175E5207, "ch_command_04_06_kneecap_briggs_ko_loop" },
    { 0xA72F5B81, "ch_command_04_06_kneecap_defalco_hit_wait" },
    { 0xFE274F79, "ch_command_04_06_kneecap_defalco_reaction" },
    { 0xE4F43CDE, "ch_command_04_06_kneecap_defalco_reaction_loop" },
    { 0xBC980ADD, "ch_command_04_06_kneecap_fight_briggs_loop" },
    { 0x629F5469, "ch_command_04_06_kneecap_fight_menendez_loop" },
    { 0xF6E53745, "ch_command_04_06_kneecap_letgo_briggs" },
    { 0xD3DEE2F5, "ch_command_04_06_kneecap_letgo_defalco" },
    { 0x212445DD, "ch_command_04_06_kneecap_letgo_salazar" },
    { 0x816ADD11, "ch_command_04_06_kneecap_salazar_chair_wait" },
    { 0xA7CB5F69, "ch_command_04_06_kneecap_salazar_hit_wait" },
    { 0x26DE1C4E, "ch_command_04_06_kneecap_salazar_ko" },
    { 0x02FB6BF4, "ch_command_04_06_kneecap_salazar_ko_reaction" },
    { 0x8932A215, "ch_command_04_06_kneecap_salazar_ko_reaction_loop" },
    { 0x5DC87140, "ch_command_04_06_kneecap_salazar_ko_reaction_no_vo" },
    { 0xDE3B9D97, "ch_command_04_06_kneecap_salazar_shot_reaction_loop" },
    { 0xE2964EC1, "ch_command_04_07_eyeball_rewind_menendez" },
    { 0x3B23DD95, "ch_command_06_03_aftermath_briggs" },
    { 0x1081BA33, "ch_command_06_03_aftermath_briggs_enter_loop" },
    { 0x173CBFF9, "ch_command_06_03_aftermath_briggs_wait_for_player" },
    { 0xF08B9377, "ch_command_06_03_aftermath_end_harper" },
    { 0x80F78294, "ch_command_06_03_aftermath_karma_computer_loop" },
    { 0x579F8C18, "ch_command_06_03_aftermath_karma_injured_loop" },
    { 0xB110EE72, "ch_command_06_03_aftermath_redshirt2" },
    { 0x8F572839, "ch_command_06_03_aftermath_redshirt_01_enter" },
    { 0x5E052809, "ch_command_06_03_aftermath_redshirt_01_sync_loop" },
    { 0xA3A5BD3F, "ch_command_06_03_aftermath_redshirt_02_brigs_dead_enter" },
    { 0xB7DF6DA9, "ch_command_06_03_aftermath_redshirt_02_brigs_dead_loop" },
    { 0xF7BD3252, "ch_command_06_03_aftermath_redshirt_02_enter" },
    { 0x1E27C421, "ch_command_06_03_aftermath_redshirt_02_wait_for_player" },
    { 0x3A8434FC, "ch_command_06_03_aftermath_start_karma" },
    { 0x21246448, "ch_command_06_04_cctv_access_seal_01" },
    { 0x6478D0DF, "ch_command_06_04_cctv_access_seal_01_exit" },
    { 0xF9D129EF, "ch_command_06_04_cctv_access_torch_seal" },
    { 0x07F09E5B, "ch_command_06_04_cctv_access_typing_loop_seal_01" },
    { 0x8C9ACA23, "ch_command_06_04_cctv_seal_02_enter" },
    { 0xA240E443, "ch_command_06_04_cctv_seal_02_exit" },
    { 0x9AA4D2ED, "ch_command_06_04_cctv_seal_02_loop" },
    { 0xF980D561, "ch_command_06_04_cctv_torch_seal_exit" },
    { 0xCDA7CCE3, "ch_command_06_06_betrayal_harper_shot" },
    { 0x083416FD, "ch_command_06_06_betrayal_redshirt_01_lives" },
    { 0x752A666A, "ch_command_06_06_betrayal_redshirt_01_lives_loop" },
    { 0x6385D8AF, "ch_command_06_06_betrayal_salazar_idle" },
    { 0x5D03BF6E, "ch_command_06_06_betrayal_salazar_lives" },
    { 0x7460B88F, "ch_command_06_06_betrayal_salazar_lives_loop" },
    { 0xB33C1765, "ch_command_06_06_betrayal_salazar_shot" },
    { 0xE1CFEE3F, "ch_command_06_06_betrayal_salazar_speach" },
    { 0xA9A24BDD, "ch_command_06_06_betrayal_salazar_surrender" },
    { 0x3B96A09E, "ch_command_07_03_general_drones_mobilize_general" },
    { 0x2B99A063, "ch_command_07_07_anderson_take_off_alt_crozby" },
    { 0x6208C720, "ch_command_07_07_anderson_take_off_alt_enemy" },
    { 0x1BE57597, "ch_command_07_07_anderson_take_off_crozby" },
    { 0x051B5DAC, "ch_command_07_07_anderson_take_off_crozby_death" },
    { 0x045BF300, "ch_command_07_07_anderson_take_off_crozby_idle" },
    { 0x23BC5234, "ch_command_07_07_anderson_take_off_enemy" },
    { 0xE6845DAE, "ch_command_07_07_anderson_take_off_harper" },
    { 0x209FAA35, "ch_defalco" },
    { 0x05A755DD, "ch_dialogue" },
    { 0xB8536F86, "ch_dies" },
    { 0xB013B5AB, "ch_doubleheader" },
    { 0x3E448D09, "ch_flash_b05_guard_runs_away" },
    { 0x35AE1434, "ch_flash_ev01_woods_wait_idle" },
    { 0x78C543C3, "ch_flash_ev01_woods_walk_to_wait" },
    { 0xCF01E170, "ch_flash_ev06_weaverrescue_guard_act" },
    { 0x9163F47A, "ch_flash_ev06_weaverrescue_guard_idle" },
    { 0x40CB0A4F, "ch_flash_ev06_weaverrescue_weaver_act" },
    { 0x742024EF, "ch_flash_ev06_weaverrescue_weaver_idle" },
    { 0xE7087DF4, "ch_frontend_ambient_bridge1_guy1" },
    { 0x590FED2F, "ch_frontend_ambient_bridge1_guy2" },
    { 0x330D72C6, "ch_frontend_ambient_bridge1_guy3" },
    { 0x75010EB9, "ch_frontend_ambient_bridge1_guy4" },
    { 0x4EFE9450, "ch_frontend_ambient_bridge1_guy5" },
    { 0x46BF0021, "ch_frontend_ambient_bridge2_guy1" },
    { 0x6CC17A8A, "ch_frontend_ambient_bridge2_guy2" },
    { 0x92C3F4F3, "ch_frontend_ambient_bridge2_guy3" },
    { 0xB8C66F5C, "ch_frontend_ambient_bridge2_guy4" },
    { 0xDEC8E9C5, "ch_frontend_ambient_bridge2_guy5" },
    { 0x8D58D956, "ch_frontend_ambient_bridge3_guy1" },
    { 0x67565EED, "ch_frontend_ambient_bridge3_guy2" },
    { 0x4153E484, "ch_frontend_ambient_bridge3_guy3" },
    { 0x1B516A1B, "ch_frontend_ambient_bridge3_guy4" },
    { 0xF54EEFB2, "ch_frontend_ambient_bridge3_guy5" },
    { 0xF188950B, "ch_frontend_ambient_bridge4_guy1" },
    { 0x7F8125D0, "ch_frontend_ambient_bridge4_guy2" },
    { 0xA583A039, "ch_frontend_ambient_bridge4_guy3" },
    { 0x63900446, "ch_frontend_ambient_bridge4_guy4" },
    { 0x89927EAF, "ch_frontend_ambient_bridge4_guy5" },
    { 0x40D89618, "ch_frontend_ambient_bridge5_guy1" },
    { 0xB2E00553, "ch_frontend_ambient_bridge5_guy2" },
    { 0x8CDD8AEA, "ch_frontend_ambient_bridge5_guy3" },
    { 0xFEE4FA25, "ch_frontend_ambient_bridge5_guy4" },
    { 0x47B80893, "ch_frontend_ambient_office1_guy1" },
    { 0xD5B09958, "ch_frontend_ambient_office1_guy2" },
    { 0xFBB313C1, "ch_frontend_ambient_office1_guy3" },
    { 0xB9BF77CE, "ch_frontend_ambient_office1_guy4" },
    { 0xDFC1F237, "ch_frontend_ambient_office1_guy5" },
    { 0x5499CFDC, "ch_frontend_ambient_office4_guy1" },
    { 0x2FDBB848, "ch_frontend_ambient_team_idle_guy1" },
    { 0xA1E32783, "ch_frontend_ambient_team_idle_guy2" },
    { 0x7BE0AD1A, "ch_frontend_ambient_team_idle_guy3" },
    { 0xEDE81C55, "ch_frontend_ambient_team_idle_guy4" },
    { 0xC7E5A1EC, "ch_frontend_ambient_team_idle_guy5" },
    { 0x3CB3E095, "ch_frontend_team_exit_guy1" },
    { 0x62B65AFE, "ch_frontend_team_exit_guy2" },
    { 0x88B8D567, "ch_frontend_team_exit_guy3" },
    { 0x7EA77C88, "ch_frontend_team_exit_guy4" },
    { 0xA4A9F6F1, "ch_frontend_team_exit_guy5" },
    { 0xAFC75CC8, "ch_frontend_vtol_cruise_copilot" },
    { 0x90ACBCA9, "ch_frontend_vtol_cruise_guy" },
    { 0xF8D44BC2, "ch_frontend_vtol_cruise_pilot" },
    { 0xE6097C72, "ch_gen_f_floor_onback_armstomach_legcurled_deathpose" },
    { 0x2618662C, "ch_gen_f_floor_onback_armup_legcurled_deathpose" },
    { 0x4B00C86A, "ch_gen_f_floor_onfront_armdown_legstraight_deathpose" },
    { 0x482AA2AA, "ch_gen_f_floor_onfront_armup_legcurled_deathpose" },
    { 0x20746BF9, "ch_gen_f_floor_onfront_armup_legstraight_deathpose" },
    { 0xC8AF2A9D, "ch_gen_f_floor_onleftside_armcurled_legcurled_deathpose" },
    { 0xAE0066F0, "ch_gen_f_floor_onleftside_armstretched_legcurled_deathpose" },
    { 0xC751D922, "ch_gen_f_floor_onrightside_armstomach_legcurled_deathpose" },
    { 0x9641D1AD, "ch_gen_f_floor_onrightside_armstretched_legcurled_deathpose" },
    { 0xAAAAD3E6, "ch_gen_f_wall_leanleft_armstomach_legstraight_deathpose" },
    { 0x366FCBF1, "ch_gen_m_armover_onrightside_deathpose" },
    { 0x3ACD1D28, "ch_gen_m_floor_armdown_legspread_onback_deathpose" },
    { 0x1B4D0DF4, "ch_gen_m_floor_armdown_onback_deathpose" },
    { 0xA49DC38A, "ch_gen_m_floor_armdown_onfront_deathpose" },
    { 0xA94E07EE, "ch_gen_m_floor_armover_onrightside_deathpose" },
    { 0xE1F4A24A, "ch_gen_m_floor_armrelaxed_onleftside_deathpose" },
    { 0xA5F9BD1F, "ch_gen_m_floor_armsopen_onback_deathpose" },
    { 0x59D00D5B, "ch_gen_m_floor_armspread_legaskew_onback_deathpose" },
    { 0xF75E3BD3, "ch_gen_m_floor_armspread_legspread_onback_deathpose" },
    { 0x37F4EFC4, "ch_gen_m_floor_armspreadwide_legspread_onback_deathpose" },
    { 0x3C541343, "ch_gen_m_floor_armstomach_onback_deathpose" },
    { 0x4BB0F075, "ch_gen_m_floor_armstomach_onrightside_deathpose" },
    { 0xFD74D6F1, "ch_gen_m_floor_armstretched_onleftside_deathpose" },
    { 0x783D3B2A, "ch_gen_m_floor_armstretched_onrightside_deathpose" },
    { 0xA00E8B80, "ch_gen_m_floor_armup_legaskew_onfront_faceleft_deathpose" },
    { 0x73D8EC47, "ch_gen_m_floor_armup_legaskew_onfront_faceright_deathpose" },
    { 0x4BF5108D, "ch_gen_m_floor_armup_onfront_deathpose" },
    { 0x4AF5EA51, "ch_gen_m_floor_back_wounded" },
    { 0x1159558D, "ch_gen_m_floor_chest_wounded" },
    { 0x6DC64FC5, "ch_gen_m_floor_dullpain_wounded" },
    { 0x3A8BA302, "ch_gen_m_floor_head_wounded" },
    { 0x29AD162F, "ch_gen_m_floor_leftleg_wounded" },
    { 0xE3024E18, "ch_gen_m_floor_shellshock_wounded" },
    { 0x54DFE29B, "ch_gen_m_ledge_armhanging_facedown_onfront_deathpose" },
    { 0x63BF9F1D, "ch_gen_m_ledge_armhanging_faceright_onfront_deathpose" },
    { 0xD725DFC3, "ch_gen_m_ledge_armspread_faceleft_onfront_deathpose" },
    { 0x1D99A990, "ch_gen_m_ledge_armspread_faceright_onfront_deathpose" },
    { 0x3A758812, "ch_gen_m_vehicle_armdown_leanright_deathpose" },
    { 0xCDCC63E5, "ch_gen_m_vehicle_armup_leanright_deathpose" },
    { 0x79174C16, "ch_gen_m_wall_armcraddle_leanleft_deathpose" },
    { 0xD7474C76, "ch_gen_m_wall_armopen_leanright_deathpose" },
    { 0xF7E306AB, "ch_gen_m_wall_headonly_leanleft_deathpose" },
    { 0xB544FD47, "ch_gen_m_wall_legin_armcraddle_hunchright_deathpose" },
    { 0x2170189F, "ch_gen_m_wall_legspread_armdown_leanleft_deathpose" },
    { 0xBC8B3DAE, "ch_gen_m_wall_legspread_armdown_leanright_deathpose" },
    { 0x8EFBC785, "ch_gen_m_wall_legspread_armonleg_leanright_deathpose" },
    { 0xD0D32CBF, "ch_gen_m_wall_low_armstomach_leanleft_deathpose" },
    { 0x12F6152C, "ch_gen_m_wall_rightleg_wounded" },
    { 0x29655091, "ch_gen_xplode_death_3" },
    { 0x577D32DB, "ch_gib" },
    { 0x0B72FF30, "ch_goooal" },
    { 0xD319CA0D, "ch_hardpoints" },
    { 0xE5D8C39A, "ch_hothands" },
    { 0xA60BCD7C, "ch_intro_wm_fastrope_guy1" },
    { 0x18133CB7, "ch_intro_wm_fastrope_guy2" },
    { 0xF210C24E, "ch_intro_wm_fastrope_guy3" },
    { 0x18897DDC, "ch_karma_10_3_defalco_dead_ending_defalco" },
    { 0x7DC20C66, "ch_karma_10_3_defalco_dead_ending_harper" },
    { 0xF72F20C8, "ch_karma_10_3_defalco_dead_ending_karma" },
    { 0x961BCB18, "ch_karma_10_3_defalco_dead_ending_salazar" },
    { 0xCEC41648, "ch_karma_10_3_escape_ending_arrival_harper" },
    { 0x0C2E87EA, "ch_karma_10_3_escape_ending_arrival_salazar" },
    { 0x9D6A46BC, "ch_karma_10_3_escape_ending_defalco" },
    { 0x9CB28225, "ch_karma_10_3_escape_ending_exit_harper" },
    { 0x494CB989, "ch_karma_10_3_escape_ending_exit_salazar" },
    { 0x80FE16C6, "ch_karma_10_3_escape_ending_harper" },
    { 0x3AF901A8, "ch_karma_10_3_escape_ending_karma" },
    { 0x2295DBC7, "ch_karma_10_3_escape_ending_loop_harper" },
    { 0x768AA293, "ch_karma_10_3_escape_ending_loop_salazar" },
    { 0xAC992855, "ch_karma_10_3_escape_ending_pmc01" },
    { 0x0E9D91F8, "ch_karma_10_3_escape_ending_salazar" },
    { 0xCD030501, "ch_karma_11_ending_defalco_reaction" },
    { 0xC34450D9, "ch_karma_11_ending_karma_cower_loop" },
    { 0x31A9A5A5, "ch_karma_11_ending_karma_reaction" },
    { 0xDFACF3DE, "ch_karma_11_ending_pmc01_reaction" },
    { 0xE9DAC597, "ch_karma_11_ending_pmc02_reaction" },
    { 0x8680C481, "ch_karma_2_1_tarmac_worker_03_idle" },
    { 0xA1EEF421, "ch_karma_2_1_tarmac_worker_idle_01" },
    { 0x4736D5CF, "ch_karma_2_cafe_window_girl01" },
    { 0xD52F6694, "ch_karma_2_cafe_window_girl02" },
    { 0xFB31E0FD, "ch_karma_2_cafe_window_girl03" },
    { 0x892A71C2, "ch_karma_2_cafe_window_girl04" },
    { 0xDD3B4E08, "ch_karma_2_cafe_window_guy01" },
    { 0x4F42BD43, "ch_karma_2_cafe_window_guy02" },
    { 0x294042DA, "ch_karma_2_cafe_window_guy03" },
    { 0x9B47B215, "ch_karma_2_cafe_window_guy04" },
    { 0x567B4523, "ch_karma_3_4_cividle_01" },
    { 0xE473D5E8, "ch_karma_3_4_cividle_02" },
    { 0xE6964D28, "ch_karma_3_4_eleveator_exit_harper" },
    { 0xEDB49D06, "ch_karma_3_4_eleveator_exit_karma" },
    { 0x04C9054A, "ch_karma_3_4_eleveator_exit_salazar" },
    { 0xEF9A68F1, "ch_karma_4_1_hotel_room_enter_harper" },
    { 0x8B4DBF39, "ch_karma_4_8_crc_manager_spiderbot" },
    { 0xD2B4643E, "ch_karma_4_8_spiderbotdrop_spiderbot" },
    { 0x833609FE, "ch_karma_5_1_breach_pmc" },
    { 0x268565FB, "ch_karma_5_1_breach_sala" },
    { 0x76BE1E17, "ch_karma_5_4_construction_intro_pmc01" },
    { 0x04B6AEDC, "ch_karma_5_4_construction_intro_pmc02" },
    { 0x8051C3BB, "ch_karma_5_4_construction_intro_sala" },
    { 0xF4B7E2B3, "ch_karma_5_6_door_kick_guy1" },
    { 0xEEBBF5C6, "ch_karma_5_6_radio_soldier_guy1" },
    { 0x2C06252D, "ch_karma_6_1_bench_left_civs_girl01" },
    { 0x52089F96, "ch_karma_6_1_bench_left_civs_girl02" },
    { 0x780B19FF, "ch_karma_6_1_bench_left_civs_girl03" },
    { 0x6DF9C120, "ch_karma_6_1_bench_left_civs_girl04" },
    { 0x2F491496, "ch_karma_6_1_bench_left_civs_guy01" },
    { 0x09469A2D, "ch_karma_6_1_bench_left_civs_guy02" },
    { 0xE3441FC4, "ch_karma_6_1_bench_left_civs_guy03" },
    { 0xBD41A55B, "ch_karma_6_1_bench_left_civs_guy04" },
    { 0x973F2AF2, "ch_karma_6_1_bench_left_civs_guy05" },
    { 0x713CB089, "ch_karma_6_1_bench_left_civs_guy06" },
    { 0x2FBBCC75, "ch_karma_6_1_club_ambient_generic_idles_female_01" },
    { 0x989268B8, "ch_karma_6_1_club_ambient_generic_idles_male_01" },
    { 0x0A99D7F3, "ch_karma_6_1_club_ambient_generic_idles_male_02" },
    { 0x8801C8B3, "ch_karma_6_1_club_rail_idles_female_01" },
    { 0x15FA5978, "ch_karma_6_1_club_rail_idles_female_02" },
    { 0xF9DE72E1, "ch_karma_6_1_club_rail_idles_male_02" },
    { 0xD3DBF878, "ch_karma_6_1_club_rail_idles_male_03" },
    { 0x64C1B174, "ch_karma_6_1_sick_girls_female_01" },
    { 0xD6C920AF, "ch_karma_6_1_sick_girls_female_02" },
    { 0x8001FF2A, "ch_karma_6_2_3peopleatbar_01" },
    { 0x59FF84C1, "ch_karma_6_2_3peopleatbar_02" },
    { 0x33FD0A58, "ch_karma_6_2_3peopleatbar_03" },
    { 0x1EE5CD3F, "ch_karma_6_2_ambient_club_seated_girl_01" },
    { 0xACDE5E04, "ch_karma_6_2_ambient_club_seated_girl_02" },
    { 0x12E37AF8, "ch_karma_6_2_ambient_club_seated_guy_01" },
    { 0x84EAEA33, "ch_karma_6_2_ambient_club_seated_guy_02" },
    { 0x5EE86FCA, "ch_karma_6_2_ambient_club_seated_guy_03" },
    { 0xD0EFDF05, "ch_karma_6_2_ambient_club_seated_guy_04" },
    { 0x80BC8F3E, "ch_karma_6_2_ambientclub_bench_idle_girl1" },
    { 0x5ABA14D5, "ch_karma_6_2_ambientclub_bench_idle_girl2" },
    { 0x34B79A6C, "ch_karma_6_2_ambientclub_bench_idle_girl3" },
    { 0xADF0D04D, "ch_karma_6_2_ambientclub_bench_idle_guy1" },
    { 0xD3F34AB6, "ch_karma_6_2_ambientclub_bench_idle_guy2" },
    { 0xF9F5C51F, "ch_karma_6_2_ambientclub_bench_idle_guy3" },
    { 0xEFE46C40, "ch_karma_6_2_ambientclub_bench_idle_guy4" },
    { 0x35CB8884, "ch_karma_6_2_bouncer_01" },
    { 0xA7D2F7BF, "ch_karma_6_2_bouncer_02" },
    { 0x7DF132D9, "ch_karma_6_2_gogo_watcher_couple_girl_1" },
    { 0xA3F3AD42, "ch_karma_6_2_gogo_watcher_couple_girl_2" },
    { 0x99616860, "ch_karma_6_2_gogo_watcher_couple_guy_1" },
    { 0x0B68D79B, "ch_karma_6_2_gogo_watcher_couple_guy_2" },
    { 0x34DAA0A5, "ch_karma_6_2_gogo_watcher_solo_guy_1" },
    { 0xDE6F5526, "ch_karma_6_2_group_dancing_01" },
    { 0xB86CDABD, "ch_karma_6_2_group_dancing_02" },
    { 0xCA1EB3AF, "ch_karma_6_2_outer_solar_bartender" },
    { 0xA4451EF8, "ch_karma_6_2_outersolar_wait_female_idle_1" },
    { 0x164C8E33, "ch_karma_6_2_outersolar_wait_female_idle_2" },
    { 0xB46CD17D, "ch_karma_6_2_outersolar_wait_male_idle_1" },
    { 0xDA6F4BE6, "ch_karma_6_2_outersolar_wait_male_idle_2" },
    { 0x0071C64F, "ch_karma_6_2_outersolar_wait_male_idle_3" },
    { 0x395883EC, "ch_karma_6_2_shadow_dancer_01" },
    { 0xAB5FF327, "ch_karma_6_2_shadow_dancer_02" },
    { 0x855D78BE, "ch_karma_6_2_shadow_dancer_03" },
    { 0xF0F8EDFD, "ch_karma_6_2_shadow_dancers_duo_girl_a" },
    { 0x16FB6866, "ch_karma_6_2_shadow_dancers_duo_girl_b" },
    { 0x4767F28A, "ch_karma_6_2_shadow_dancers_pole_girl01" },
    { 0x21657821, "ch_karma_6_2_shadow_dancers_pole_girl02" },
    { 0xE1FAB829, "ch_karma_6_2_shadow_dancers_solo" },
    { 0xC1AD4C58, "ch_karma_6_2_shadow_dancers_wall" },
    { 0xADD9DDA6, "ch_karma_6_3_clubsolar_clubdancer_female01" },
    { 0x87D7633D, "ch_karma_6_3_clubsolar_clubdancer_female02" },
    { 0x61D4E8D4, "ch_karma_6_3_clubsolar_clubdancer_female03" },
    { 0x3BD26E6B, "ch_karma_6_3_clubsolar_clubdancer_female04" },
    { 0x92FF6025, "ch_karma_6_3_clubsolar_clubdancer_male01" },
    { 0xB901DA8E, "ch_karma_6_3_clubsolar_clubdancer_male02" },
    { 0xDF0454F7, "ch_karma_6_3_clubsolar_clubdancer_male03" },
    { 0xD4F2FC18, "ch_karma_6_3_clubsolar_clubdancer_male04" },
    { 0xFAF57681, "ch_karma_6_3_clubsolar_clubdancer_male05" },
    { 0xC3BDDFF2, "ch_karma_6_3_cower_loop" },
    { 0x7F6FCE92, "ch_karma_6_7_shoot_out_harper" },
    { 0x13E6681F, "ch_karma_6_7_shoot_out_harper_part1" },
    { 0xA1DEF8E4, "ch_karma_6_7_shoot_out_harper_part2" },
    { 0xC7E1734D, "ch_karma_6_7_shoot_out_harper_part3" },
    { 0xEAC74C17, "ch_karma_cctv_shoot_guard_defalco" },
    { 0xCAB246C4, "ch_karma_cctv_shoot_guard_guard" },
    { 0xCF05919F, "ch_karma_cctv_shoot_guard_karma" },
    { 0x0B0BE93A, "ch_karma_cctv_shoot_guard_pmc01" },
    { 0xE3CCF7DE, "ch_khe_e3_nvaturretdive_choke_nva01" },
    { 0x60110FC1, "ch_khe_e3_nvaturretdive_choke_player" },
    { 0x249CE04F, "ch_khe_e3_nvaturretdive_nva01" },
    { 0x59695052, "ch_khe_e3_nvaturretdive_player" },
    { 0x220C9AB7, "ch_khe_e3_nvaturretdive_success_nva01" },
    { 0x1E1682FA, "ch_khe_e3_nvaturretdive_success_player" },
    { 0xF367F416, "ch_kills" },
    { 0x65555C8D, "ch_la_01_01_110_intro_bikecop1" },
    { 0x8B57D6F6, "ch_la_01_01_110_intro_bikecop2" },
    { 0xB15A515F, "ch_la_01_01_110_intro_bikecop3" },
    { 0xA748F880, "ch_la_01_01_110_intro_bikecop4" },
    { 0xCD4B72E9, "ch_la_01_01_110_intro_bikecop5" },
    { 0xB150B736, "ch_la_01_01_110_intro_bill" },
    { 0xC6DB36C2, "ch_la_01_01_110_intro_carcop1" },
    { 0x5EE52066, "ch_la_01_01_110_intro_carcop5" },
    { 0x14893297, "ch_la_01_01_110_intro_driver" },
    { 0x26224092, "ch_la_01_01_110_intro_harp" },
    { 0x83E14A9C, "ch_la_01_01_110_intro_hill" },
    { 0x6C101EE2, "ch_la_01_01_110_intro_johnson" },
    { 0x5E244156, "ch_la_01_01_110_intro_jones" },
    { 0xF5521C69, "ch_la_01_01_110_intro_mason" },
    { 0xBA61CBF8, "ch_la_01_01_110_intro_sec" },
    { 0x602EC1EC, "ch_la_01_01_110_intro_troop1" },
    { 0xD2363127, "ch_la_01_01_110_intro_troop2" },
    { 0xAC33B6BE, "ch_la_01_01_110_intro_troop3" },
    { 0x38D74E68, "ch_la_03_01_cougarcrawl_harperdead_sam" },
    { 0x00C94467, "ch_la_03_01_cougarcrawl_hilary" },
    { 0x29BD3BE5, "ch_la_03_01_cougarcrawl_jack" },
    { 0xDCC711AD, "ch_la_03_01_cougarcrawl_johnston" },
    { 0x2C6980FC, "ch_la_03_01_cougarcrawl_lapd01" },
    { 0x9E70F037, "ch_la_03_01_cougarcrawl_lapd02" },
    { 0x786E75CE, "ch_la_03_01_cougarcrawl_lapd03" },
    { 0xBA6211C1, "ch_la_03_01_cougarcrawl_lapd04" },
    { 0x5440649B, "ch_la_03_01_cougarcrawl_player" },
    { 0x9BC1B099, "ch_la_03_01_cougarcrawl_sam" },
    { 0x9A847CB2, "ch_la_03_01_cougarcrawl_secretary" },
    { 0xBC1ADF14, "ch_la_03_01_cougarcrawl_ss02" },
    { 0x27E1EB81, "ch_la_03_02_mountturret_player" },
    { 0xBB04835A, "ch_la_03_04_cougarfalls_f35intro_bill" },
    { 0x57A5CECF, "ch_la_03_04_cougarfalls_f35intro_harper" },
    { 0xB19013BA, "ch_la_03_04_cougarfalls_f35intro_hillary" },
    { 0xC115F016, "ch_la_03_04_cougarfalls_f35intro_player" },
    { 0x0FC93BF8, "ch_la_03_04_cougarfalls_f35intro_ssa" },
    { 0xD2C95A4B, "ch_la_03_05_lowroad_police01" },
    { 0x60C1EB10, "ch_la_03_05_lowroad_police02" },
    { 0x86C46579, "ch_la_03_05_lowroad_police03" },
    { 0x44D0C986, "ch_la_03_05_lowroad_police04" },
    { 0x097E9819, "ch_la_03_05_lowroad_policeidle01" },
    { 0x2F811282, "ch_la_03_05_lowroad_policeidle02" },
    { 0x7B860754, "ch_la_03_05_lowroad_policeidle04" },
    { 0xA982DD4D, "ch_la_03_05_lowroadbodies_body01" },
    { 0xCF8557B6, "ch_la_03_05_lowroadbodies_body02" },
    { 0xF587D21F, "ch_la_03_05_lowroadbodies_body03" },
    { 0xEB767940, "ch_la_03_05_lowroadbodies_body04" },
    { 0x1178F3A9, "ch_la_03_05_lowroadbodies_body05" },
    { 0x377B6E12, "ch_la_03_05_lowroadbodies_body06" },
    { 0x5D7DE87B, "ch_la_03_05_lowroadbodies_body07" },
    { 0xB394362C, "ch_la_03_05_lowroadbodies_body08" },
    { 0xD996B095, "ch_la_03_05_lowroadbodies_body09" },
    { 0x0354FD8F, "ch_la_03_05_lowroadbodies_body10" },
    { 0xDD528326, "ch_la_03_05_lowroadbodies_body11" },
    { 0xB75008BD, "ch_la_03_05_lowroadbodies_body12" },
    { 0x914D8E54, "ch_la_03_05_lowroadbodies_body13" },
    { 0x6B4B13EB, "ch_la_03_05_lowroadbodies_body14" },
    { 0x45489982, "ch_la_03_05_lowroadbodies_body15" },
    { 0x1F461F19, "ch_la_03_05_lowroadbodies_body16" },
    { 0xF943A4B0, "ch_la_03_05_lowroadbodies_body17" },
    { 0xF3CBC1B4, "ch_la_03_06_ai_rappel_left_guy01" },
    { 0x65D330EF, "ch_la_03_06_ai_rappel_left_guy02" },
    { 0x3FD0B686, "ch_la_03_06_ai_rappel_left_guy03" },
    { 0x81C45279, "ch_la_03_06_ai_rappel_left_guy04" },
    { 0x2B80FF08, "ch_la_03_08_ai_rappel_guy01" },
    { 0x7785F3DA, "ch_la_03_08_ai_rappel_guy03" },
    { 0xE98D6315, "ch_la_03_08_ai_rappel_guy04" },
    { 0xB18296EF, "ch_la_03_08_groupcover_approach_bill" },
    { 0x8CB3507B, "ch_la_03_08_groupcover_approach_hilary" },
    { 0xB60B01C1, "ch_la_03_08_groupcover_approach_jack" },
    { 0x3B3BB6E0, "ch_la_03_08_groupcover_approach_ss02" },
    { 0x59D2ED86, "ch_la_03_08_groupcover_bill" },
    { 0xD7FB1DDA, "ch_la_03_08_groupcover_hilary" },
    { 0x714EF488, "ch_la_03_08_groupcover_jack" },
    { 0x007323FD, "ch_la_03_08_groupcover_ss02" },
    { 0x74CD1DD8, "ch_la_03_08_groupcover_theygotrpgs_harper" },
    { 0x94452248, "ch_la_03_08_groupcover_whatsthecall_harper" },
    { 0x060D3ECF, "ch_la_03_09_bigrig_entries_driver" },
    { 0x217C4707, "ch_la_03_09_bigrig_entries_guy01" },
    { 0xAF74D7CC, "ch_la_03_09_bigrig_entries_guy02" },
    { 0xD5775235, "ch_la_03_09_bigrig_entries_guy03" },
    { 0x636FE2FA, "ch_la_03_09_bigrig_entries_guy04" },
    { 0xAE2313B2, "ch_la_03_09_exitsniper_player" },
    { 0xD1A46F6A, "ch_la_03_09_exitsniper_rpgdude" },
    { 0xC3AEC87C, "ch_la_03_09_exitsniper_rpgdude2" },
    { 0x302A7F66, "ch_la_03_10_grouprappel_bill" },
    { 0x88897267, "ch_la_03_10_grouprappel_driver" },
    { 0xFCD73EBA, "ch_la_03_10_grouprappel_hilary" },
    { 0x452C1D68, "ch_la_03_10_grouprappel_jack" },
    { 0xE8762AC2, "ch_la_03_10_grouprappel_player" },
    { 0x925DFEC0, "ch_la_03_10_grouprappel_sniper_bill" },
    { 0xD718D979, "ch_la_03_10_grouprappel_sniper_cougarguy" },
    { 0x65312211, "ch_la_03_10_grouprappel_sniper_driver" },
    { 0xCE28F20C, "ch_la_03_10_grouprappel_sniper_hilary" },
    { 0xF79FEB0A, "ch_la_03_10_grouprappel_sniper_jack" },
    { 0xB06A583F, "ch_la_03_10_grouprappel_sniper_ss02" },
    { 0x4618A3FD, "ch_la_03_10_grouprappel_sniper_ter01" },
    { 0x6C1B1E66, "ch_la_03_10_grouprappel_sniper_ter02" },
    { 0x921D98CF, "ch_la_03_10_grouprappel_sniper_ter03" },
    { 0x008F5DDD, "ch_la_03_10_grouprappel_ss02" },
    { 0xAC7DDF0F, "ch_la_03_10_grouprappel_ter01" },
    { 0x3A766FD4, "ch_la_03_10_grouprappel_ter02" },
    { 0x6078EA3D, "ch_la_03_10_grouprappel_ter03" },
    { 0xCD6B5EB4, "ch_la_03_11_busrpg_guy01" },
    { 0x7384F576, "ch_la_03_11_g20failure_guy01" },
    { 0x4D827B0D, "ch_la_03_11_g20failure_guy02" },
    { 0xC15CA3C4, "ch_la_03_11_sniperevent_guy01" },
    { 0x336412FF, "ch_la_03_11_sniperevent_guy02" },
    { 0x0D619896, "ch_la_03_11_sniperevent_guy03" },
    { 0x62323B00, "ch_la_03_12_entercougar_bill" },
    { 0x49C227F4, "ch_la_03_12_entercougar_hillary" },
    { 0x52C66B1C, "ch_la_03_12_entercougar_player" },
    { 0xE1E3127F, "ch_la_03_12_entercougar_ss02" },
    { 0x4ECB620D, "ch_la_03_12_meetconvoy_mike" },
    { 0x596C70DA, "ch_la_03_12_meetconvoy_mike_loop" },
    { 0x448EE87D, "ch_la_03_12_meetconvoy_ss04" },
    { 0x64F90117, "ch_la_04_01_drive_leftturn_player" },
    { 0x9E564048, "ch_la_04_01_fast_lane_dodging_guy_01" },
    { 0x105DAF83, "ch_la_04_01_fast_lane_dodging_guy_02" },
    { 0x260FF9D5, "ch_la_04_04_crash_harper" },
    { 0x0DAF1B7D, "ch_la_05_01_cougar_exit_bike_cop1" },
    { 0x33B195E6, "ch_la_05_01_cougar_exit_bike_cop2" },
    { 0x59B4104F, "ch_la_05_01_cougar_exit_bike_cop3" },
    { 0x0FEFC933, "ch_la_05_01_cougar_exit_cop1" },
    { 0x9DE859F8, "ch_la_05_01_cougar_exit_cop2" },
    { 0x70BCC07F, "ch_la_05_01_cougar_exit_harper1" },
    { 0x78A4C79B, "ch_la_05_01_cougar_exit_player" },
    { 0x1326FE86, "ch_la_05_01_cougar_exit_ter1" },
    { 0x46C23BC6, "ch_la_05_02_clearthestreet_ter1" },
    { 0x20BFC15D, "ch_la_05_02_clearthestreet_ter2" },
    { 0xFABD46F4, "ch_la_05_02_clearthestreet_ter3" },
    { 0xD4BACC8B, "ch_la_05_02_clearthestreet_ter4" },
    { 0xAEB85222, "ch_la_05_02_clearthestreet_ter5" },
    { 0x6D1AB9C4, "ch_la_05_02_entries_cartpush_guy01" },
    { 0xDF2228FF, "ch_la_05_02_entries_cartpush_guy02" },
    { 0x5C605386, "ch_la_05_02_entries_ladder_guy01" },
    { 0x365DD91D, "ch_la_05_02_entries_ladder_guy02" },
    { 0xD3E81256, "ch_la_05_02_entries_pipe_guy01" },
    { 0xADE597ED, "ch_la_05_02_entries_pipe_guy02" },
    { 0x65E0560A, "ch_la_05_03_bruteforce_player" },
    { 0xBFE370C5, "ch_la_05_03_bruteforce_ssa1" },
    { 0xE5E5EB2E, "ch_la_05_03_bruteforce_ssa2" },
    { 0x0BE86597, "ch_la_05_03_bruteforce_ssa3" },
    { 0x148D2866, "ch_la_05_03_deathposesforla_intersection_guy01" },
    { 0xEE8AADFD, "ch_la_05_03_deathposesforla_intersection_guy02" },
    { 0xC8883394, "ch_la_05_03_deathposesforla_intersection_guy03" },
    { 0xA285B92B, "ch_la_05_03_deathposesforla_intersection_guy04" },
    { 0x7C833EC2, "ch_la_05_03_deathposesforla_intersection_guy05" },
    { 0x5680C459, "ch_la_05_03_deathposesforla_intersection_guy06" },
    { 0x307E49F0, "ch_la_05_03_deathposesforla_intersection_guy07" },
    { 0x6AA37617, "ch_la_05_03_deathposesforla_intersection_guy08" },
    { 0x44A0FBAE, "ch_la_05_03_deathposesforla_intersection_guy09" },
    { 0xBABB0824, "ch_la_05_03_deathposesforla_intersection_guy10" },
    { 0xE0BD828D, "ch_la_05_03_deathposesforla_intersection_guy11" },
    { 0x06BFFCF6, "ch_la_05_03_deathposesforla_intersection_guy12" },
    { 0x2CC2775F, "ch_la_05_03_deathposesforla_intersection_guy13" },
    { 0x22B11E80, "ch_la_05_03_deathposesforla_intersection_guy14" },
    { 0x48B398E9, "ch_la_05_03_deathposesforla_intersection_guy15" },
    { 0x6EB61352, "ch_la_05_03_deathposesforla_intersection_guy16" },
    { 0x94B88DBB, "ch_la_05_03_deathposesforla_intersection_guy17" },
    { 0x1CF87D0E, "ch_la_05_03_deathposesforla_intersectionb_guy01" },
    { 0xF6F602A5, "ch_la_05_03_deathposesforla_intersectionb_guy02" },
    { 0xD0F3883C, "ch_la_05_03_deathposesforla_intersectionb_guy03" },
    { 0xAAF10DD3, "ch_la_05_03_deathposesforla_intersectionb_guy04" },
    { 0x84EE936A, "ch_la_05_03_deathposesforla_intersectionb_guy05" },
    { 0x5EEC1901, "ch_la_05_03_deathposesforla_intersectionb_guy06" },
    { 0x38E99E98, "ch_la_05_03_deathposesforla_intersectionb_guy07" },
    { 0x12E7242F, "ch_la_05_03_deathposesforla_intersectionb_guy08" },
    { 0xECE4A9C6, "ch_la_05_03_deathposesforla_intersectionb_guy09" },
    { 0x5FC41F8B, "ch_la_05_03_deathposesforla_plaza_guy01" },
    { 0xEDBCB050, "ch_la_05_03_deathposesforla_plaza_guy02" },
    { 0x13BF2AB9, "ch_la_05_03_deathposesforla_plaza_guy03" },
    { 0xD1CB8EC6, "ch_la_05_03_deathposesforla_plaza_guy04" },
    { 0xF7CE092F, "ch_la_05_03_deathposesforla_plaza_guy05" },
    { 0x85C699F4, "ch_la_05_03_deathposesforla_plaza_guy06" },
    { 0xABC9145D, "ch_la_05_03_deathposesforla_plaza_guy07" },
    { 0x69D5786A, "ch_la_05_03_deathposesforla_plaza_guy08" },
    { 0x8FD7F2D3, "ch_la_05_03_deathposesforla_plaza_guy09" },
    { 0xB8590B4D, "ch_la_05_03_deathposesforla_plaza_guy10" },
    { 0x925690E4, "ch_la_05_03_deathposesforla_plaza_guy11" },
    { 0x045E001F, "ch_la_05_03_deathposesforla_plaza_guy12" },
    { 0xDE5B85B6, "ch_la_05_03_deathposesforla_plaza_guy13" },
    { 0x204F21A9, "ch_la_05_03_deathposesforla_plaza_guy14" },
    { 0xFA4CA740, "ch_la_05_03_deathposesforla_plaza_guy15" },
    { 0x6C54167B, "ch_la_05_03_deathposesforla_plaza_guy16" },
    { 0x46519C12, "ch_la_05_03_deathposesforla_plaza_guy17" },
    { 0x6F2D8E21, "ch_la_05_03_deathposesforla_streets_guy01" },
    { 0x9530088A, "ch_la_05_03_deathposesforla_streets_guy02" },
    { 0xBB3282F3, "ch_la_05_03_deathposesforla_streets_guy03" },
    { 0xE134FD5C, "ch_la_05_03_deathposesforla_streets_guy04" },
    { 0x073777C5, "ch_la_05_03_deathposesforla_streets_guy05" },
    { 0x2D39F22E, "ch_la_05_03_deathposesforla_streets_guy06" },
    { 0x533C6C97, "ch_la_05_03_deathposesforla_streets_guy07" },
    { 0x19174070, "ch_la_05_03_deathposesforla_streets_guy08" },
    { 0x3F19BAD9, "ch_la_05_03_deathposesforla_streets_guy09" },
    { 0xC7C279E3, "ch_la_05_03_deathposesforla_streets_guy10" },
    { 0xA1BFFF7A, "ch_la_05_03_deathposesforla_streets_guy11" },
    { 0x7BBD8511, "ch_la_05_03_deathposesforla_streets_guy12" },
    { 0x55BB0AA8, "ch_la_05_03_deathposesforla_streets_guy13" },
    { 0x5FCC6387, "ch_la_05_03_deathposesforla_streets_guy14" },
    { 0x39C9E91E, "ch_la_05_03_deathposesforla_streets_guy15" },
    { 0x5660CCAE, "ch_la_06_02_plaza_foodguy01" },
    { 0xB1D6BD3E, "ch_la_06_02_plaza_grate01" },
    { 0x0B9EE8FF, "ch_la_06_02_plaza_grate01_loop" },
    { 0x8BD442D5, "ch_la_06_02_plaza_grate02" },
    { 0xE9D8AB52, "ch_la_06_02_plaza_grate02_loop" },
    { 0x9F558008, "ch_la_06_02_plaza_ledge01" },
    { 0x115CEF43, "ch_la_06_02_plaza_ledge02" },
    { 0x76CDFA26, "ch_la_06_02_plaza_planter_enemy1" },
    { 0x4BF758B2, "ch_la_06_02_plaza_police02" },
    { 0x71F9D31B, "ch_la_06_02_plaza_police03" },
    { 0xEF9C2DCA, "ch_la_06_02_plaza_shopguy01" },
    { 0xC999B361, "ch_la_06_02_plaza_shopguy02" },
    { 0xABE5AAA6, "ch_la_06_02_plaza_table_flip_guy_01" },
    { 0x85E3303D, "ch_la_06_02_plaza_table_flip_guy_02" },
    { 0x6BEEF86E, "ch_la_06_03_f35crash_deadpilot" },
    { 0xC4F521D9, "ch_la_06_04_interception_guy01_loop" },
    { 0x161F2601, "ch_la_07_01_sam_turret_in" },
    { 0xC5087C58, "ch_la_07_01_sam_turret_out" },
    { 0x478F68D7, "ch_la_07_01_sam_turret_thrown_out" },
    { 0x53D1A317, "ch_la_07_02_ssathanks_guy01" },
    { 0x8357B899, "ch_la_07_02_ssathanks_guy01_idle1" },
    { 0xE1CA33DC, "ch_la_07_02_ssathanks_guy02" },
    { 0xA7E8C120, "ch_la_07_09_building_collapse_playerreaction" },
    { 0x965D3659, "ch_la_08_01_save_anderson_anderson" },
    { 0xB3CA6A6F, "ch_la_08_01_save_anderson_anderson_fall" },
    { 0x065D4D7E, "ch_la_08_01_save_anderson_anderson_loop" },
    { 0x6CFC9A32, "ch_la_08_01_save_anderson_driver1" },
    { 0x46FA1FC9, "ch_la_08_01_save_anderson_driver2" },
    { 0x061A8851, "ch_la_08_01_save_anderson_harper" },
    { 0x40C619E6, "ch_la_08_01_save_anderson_harper_loop" },
    { 0x4E0FF3CC, "ch_la_08_01_standup_harper" },
    { 0xD1C56525, "ch_la_08_01_van_loop_anderson" },
    { 0xDA238A6D, "ch_la_08_01_van_loop_harper" },
    { 0x7EBAFB27, "ch_la_08_02_f35enter_player" },
    { 0x2084AA51, "ch_la_08_02_f35enter_startup_player" },
    { 0xBE3BA02D, "ch_la_09_01_harpershooting_harper" },
    { 0xBEABBB1F, "ch_la_09_05_flightmode_switch_player" },
    { 0x81C1FABA, "ch_la_10_01_f35eject_player" },
    { 0x9CC9AF25, "ch_la_10_01_f35eject_start_player" },
    { 0x134D9DC3, "ch_la_10_02_promnight_harper" },
    { 0x6A58E832, "ch_la_10_02_promnight_player" },
    { 0xDFFFD7B9, "ch_la_10_02_promnightsam_player" },
    { 0x480200FB, "ch_la_10_02_promnightsam_sam" },
    { 0x788D7F6A, "ch_la_3_11_streetfight_bus_react_hilary" },
    { 0x0D5C6B3A, "ch_la_3_11_streetfight_bus_react_sam" },
    { 0xC876224D, "ch_la_3_11_streetfight_bus_react_ss02" },
    { 0xD7033C37, "ch_la_3_11_streetfight_run2convoy_bill" },
    { 0xFF6A9F53, "ch_la_3_11_streetfight_run2convoy_hilary" },
    { 0x221C6FFA, "ch_la_3_11_streetfight_run2convoy_loop_bill" },
    { 0x03130BB6, "ch_la_3_11_streetfight_run2convoy_loop_hilary" },
    { 0x76A5B941, "ch_la_3_11_streetfight_run2convoy_loop_ss02" },
    { 0xC4D57718, "ch_la_3_11_streetfight_run2convoy_ss02" },
    { 0x7BDFADB9, "ch_la_3_11_streetfight_run2cover01_wait_bill" },
    { 0x5664156D, "ch_la_3_11_streetfight_run2cover01_wait_hilary" },
    { 0xED3CF65A, "ch_la_3_11_streetfight_run2cover01_wait_ss02" },
    { 0x0B941136, "ch_la_3_11_streetfight_run2cover02_bill" },
    { 0x8B66448A, "ch_la_3_11_streetfight_run2cover02_hilary" },
    { 0x3495646D, "ch_la_3_11_streetfight_run2cover02_ss02" },
    { 0xC2C015CA, "ch_la_3_11_streetfight_run2cover02_wait_bill" },
    { 0x284E8B06, "ch_la_3_11_streetfight_run2cover02_wait_hilary" },
    { 0x94E84251, "ch_la_3_11_streetfight_run2cover02_wait_ss02" },
    { 0x79FAFDA5, "ch_la_3_11_streetfight_run2cover03_bill" },
    { 0x666EAE41, "ch_la_3_11_streetfight_run2cover03_hilary" },
    { 0xBFC5C7F6, "ch_la_3_11_streetfight_run2cover03_ss02" },
    { 0x39DB7573, "ch_la_3_11_streetfight_run2cover03_wait_bill" },
    { 0x44406F87, "ch_la_3_11_streetfight_run2cover03_wait_hilary" },
    { 0xA3372A34, "ch_la_3_11_streetfight_run2cover03_wait_ss02" },
    { 0xC0875302, "ch_lapd" },
    { 0xDCAC524A, "ch_levelend" },
    { 0x664DD8BF, "ch_max" },
    { 0x2FFA0A2F, "ch_medic" },
    { 0x28807DB6, "ch_merc_01" },
    { 0x027E034D, "ch_merc_02" },
    { 0xDC7B88E4, "ch_merc_03" },
    { 0xAB19E537, "ch_mon_01_01_cliffintro_harper" },
    { 0x9654A65B, "ch_mon_01_01_cliffswing1_fail_harper" },
    { 0xFB91AE2C, "ch_mon_01_01_cliffswing1_harper" },
    { 0xDEA8DED9, "ch_mon_01_01_cliffswing1_idle_harper" },
    { 0xB0469918, "ch_mon_01_01_cliffswing2_fail_harper" },
    { 0xDFBEA345, "ch_mon_01_01_cliffswing2_harper" },
    { 0xA1244312, "ch_mon_01_01_cliffswing2_idle_harper" },
    { 0x32033C5D, "ch_mon_01_01_cliffswing3_fail_harper" },
    { 0x9A7F87EA, "ch_mon_01_01_cliffswing3_harper" },
    { 0xE530F6B7, "ch_mon_01_01_cliffswing3_idle_harper" },
    { 0x978E4BBA, "ch_mon_01_01_cliffswing4_fail_harper" },
    { 0xD03FFC5B, "ch_mon_01_01_cliffswing4_harper" },
    { 0x6163B408, "ch_mon_01_01_cliffswing4_idle_harper" },
    { 0x02DEA617, "ch_mon_01_01_cliffswing5_fail_harper" },
    { 0x34F87A48, "ch_mon_01_01_cliffswing5_harper" },
    { 0x008ACF1D, "ch_mon_01_01_cliffswing5_idle_harper" },
    { 0x0C5D29E1, "ch_mon_01_01_cliffswing6_harper" },
    { 0x256903F6, "ch_mon_01_01_cliffswing6_idle_harper" },
    { 0x4F2F49D0, "ch_mon_01_01_cliffswing6_redshirt" },
    { 0xAEB5D80D, "ch_mon_01_01_cliffswing6_salazar" },
    { 0xA8085430, "ch_mon_01_01_cliffswing_harper_flight" },
    { 0x5F32A024, "ch_mon_01_01_cliffswing_salazar_flight" },
    { 0x85C7B013, "ch_mon_01_01_intro_chief_pmc" },
    { 0x8B00AD2C, "ch_mon_01_01_intro_pmc01" },
    { 0xFD081C67, "ch_mon_01_01_intro_pmc02" },
    { 0x7F570DF8, "ch_mon_01_01_intro_turret_guy01" },
    { 0xF15E7D33, "ch_mon_01_01_intro_turret_guy02" },
    { 0xF8843D27, "ch_mon_01_01_squirrelsuitintro_harper" },
    { 0xABB6FEFC, "ch_mon_01_01_squirrelsuitintro_idle_harper" },
    { 0xBCC39DE5, "ch_mon_01_01_squirrelsuitintro_idle_redshirt" },
    { 0x87F153E6, "ch_mon_01_01_squirrelsuitintro_idle_salazar" },
    { 0x74773D12, "ch_mon_01_01_squirrelsuitintro_redshirt" },
    { 0xD8E3DA73, "ch_mon_01_01_squirrelsuitintro_salazar" },
    { 0xDAB261E3, "ch_mon_01_01_squirrelsuitintro_wait_harper" },
    { 0xE8021CD7, "ch_mon_01_01_squirrelsuitintro_wait_salazar" },
    { 0xF2D60381, "ch_mon_01_02_cliff_dive_harper" },
    { 0xF4F0042D, "ch_mon_01_02_cliff_dive_salazar" },
    { 0xED5826A9, "ch_mon_02_01_squirrelflight_fwd_idle" },
    { 0x85705013, "ch_mon_02_01_squirrelflight_slowdown_idle" },
    { 0xEE6660E6, "ch_mon_02_01_squirrelflight_speedup_idle" },
    { 0x8D9AF7F8, "ch_mon_02_01_squirrelflight_turnleft_idle" },
    { 0x1434C69B, "ch_mon_02_01_squirrelflight_turnright_idle" },
    { 0xF7149468, "ch_mon_02_04_landing_harper" },
    { 0x0D3F7ED4, "ch_mon_02_04_landing_invisible_patrol" },
    { 0xD308919F, "ch_mon_02_04_landing_jumper_01" },
    { 0x61012264, "ch_mon_02_04_landing_jumper_02" },
    { 0x4C4BB562, "ch_mon_02_04_landing_patrol_01" },
    { 0x26493AF9, "ch_mon_02_04_landing_patrol_02" },
    { 0x583FADF9, "ch_mon_04_02_salazar_shoots_helicopter_intro_harper" },
    { 0x842F2045, "ch_mon_04_02_salazar_shoots_helicopter_intro_salazar" },
    { 0xD0D217D9, "ch_mon_04_04_turret_react_soldier" },
    { 0x7BBEA92E, "ch_mon_04_06_riot_shield_plant" },
    { 0xA31DCF6A, "ch_mon_05_06_ammo_carry_left_guy01" },
    { 0x7D1B5501, "ch_mon_05_06_ammo_carry_left_guy02" },
    { 0xC1B9EEFB, "ch_mon_05_06_ammo_carry_right_guy01" },
    { 0x4FB27FC0, "ch_mon_05_06_ammo_carry_right_guy02" },
    { 0x1872397E, "ch_mon_05_06_turret_plant_guy01" },
    { 0xF26FBF15, "ch_mon_05_06_turret_plant_guy02" },
    { 0x456AAE7B, "ch_mon_05_07_mudslide_ai_tower_death" },
    { 0xE4CF9A50, "ch_mon_05_07_mudslide_ai_tower_death_right" },
    { 0x38D7B881, "ch_mon_05_08_main_doors_hudson_cycle" },
    { 0xCAFD2692, "ch_mon_05_08_main_doors_hudson_hudsonhasgun" },
    { 0x6087A9AD, "ch_mon_05_08_main_doors_hudson_intro" },
    { 0x061C8178, "ch_mon_05_08_main_doors_hudson_playerhasgun" },
    { 0xA20A1A08, "ch_mon_05_08_main_doors_redshirt_outro" },
    { 0xA8D3D6FD, "ch_mon_05_08_main_doors_salazar_outro" },
    { 0x387E2751, "ch_mon_06_03_lab_entry_harper_intro" },
    { 0x2B78CC7B, "ch_mon_06_03_lab_entry_salazar_intro" },
    { 0x95106248, "ch_mon_07_01_asd_intro_harper_interaction_with_player" },
    { 0x1C8A1B31, "ch_mon_07_01_asd_intro_salazar_intro" },
    { 0xCD32BAE7, "ch_mon_08_01_harper_flip_death_harper" },
    { 0xEB3797E1, "ch_mon_08_01_harper_flip_death_soldier" },
    { 0x2765CE56, "ch_mon_08_01_window_jump_entrance_soldier02" },
    { 0x9315E3BD, "ch_mon_08_02_elevator_regroup_crosby_exit" },
    { 0xA9BF0FC7, "ch_mon_08_02_elevator_regroup_crosby_idle" },
    { 0x509558A5, "ch_mon_08_02_elevator_regroup_harper_enter" },
    { 0xB505E5F9, "ch_mon_08_02_elevator_regroup_harper_exit" },
    { 0xA00AA12D, "ch_mon_08_02_elevator_regroup_harper_fire" },
    { 0xAD822F8B, "ch_mon_08_02_elevator_regroup_harper_idle" },
    { 0xF5F9AA70, "ch_mon_08_02_elevator_regroup_harper_idle_2" },
    { 0xB2A953DB, "ch_mon_08_02_elevator_regroup_salazar_enter" },
    { 0x1FF68C3B, "ch_mon_08_02_elevator_regroup_salazar_exit" },
    { 0xEE57C23D, "ch_mon_08_02_elevator_regroup_salazar_idle" },
    { 0x6DA60C4A, "ch_mon_09_01_defend_approach_crosby" },
    { 0xD9149D46, "ch_mon_09_01_defend_approach_harper" },
    { 0x3A134D78, "ch_mon_09_01_defend_approach_salazar" },
    { 0x2CBC2A7C, "ch_mon_09_01_defend_approach_wait_crosby" },
    { 0x6C89F0D4, "ch_mon_09_01_defend_approach_wait_harper" },
    { 0xA8C01D5E, "ch_mon_09_01_defend_approach_wait_salazar" },
    { 0xB2F3DD93, "ch_mon_09_01_defend_idle_isaac" },
    { 0xD9C84096, "ch_mon_09_01_defend_intro_crosby" },
    { 0x039D30E2, "ch_mon_09_01_defend_intro_harper" },
    { 0x045DF769, "ch_mon_09_01_defend_intro_isaac" },
    { 0xB5249CDC, "ch_mon_09_01_defend_intro_salazar" },
    { 0x54860F5A, "ch_mon_09_04_codes_harper" },
    { 0x9AAA3D46, "ch_mon_10_01_celerium_door_isaac_approach" },
    { 0xD534AF60, "ch_mon_10_01_celerium_door_isaac_loop" },
    { 0x5756FC9E, "ch_mon_10_01_celerium_door_isaac_open" },
    { 0x57A8069A, "ch_mon_10_02_celerium_chamber_crosby_approach" },
    { 0x6BB3B0AA, "ch_mon_10_02_celerium_chamber_harper_approach" },
    { 0x99C62FA9, "ch_mon_10_02_celerium_chamber_isaac_approach" },
    { 0x2C7B98F8, "ch_mon_10_02_celerium_chamber_isaac_end" },
    { 0x08E20923, "ch_mon_10_02_celerium_chamber_isaac_idle" },
    { 0xEFB13D4E, "ch_mon_10_02_celerium_chamber_salazar_approach" },
    { 0x023AC1A8, "ch_mon_10_03_celerium_battle_crosby" },
    { 0x9CA3FF10, "ch_mon_10_03_celerium_battle_harper" },
    { 0x95E2AF32, "ch_mon_10_03_celerium_battle_salazar" },
    { 0xB76C8F19, "ch_mon_10_03_celerium_battle_soldier1" },
    { 0xDD6F0982, "ch_mon_10_03_celerium_battle_soldier2" },
    { 0x037183EB, "ch_mon_10_03_celerium_battle_soldier3" },
    { 0xE20E9061, "ch_mon_11_01_ending_briggs" },
    { 0x232A55C0, "ch_mon_11_01_ending_briggs_entry" },
    { 0x03FAB9E2, "ch_mon_11_01_ending_briggs_idle" },
    { 0x6921485F, "ch_mon_11_01_ending_getting_shot_pdf" },
    { 0x9650C715, "ch_mon_11_01_ending_harper" },
    { 0x7080E5B0, "ch_mon_11_01_ending_hostage_01" },
    { 0xE28854EB, "ch_mon_11_01_ending_hostage_02" },
    { 0xD67F76A6, "ch_mon_11_01_ending_seal_01" },
    { 0x2A11609A, "ch_mon_11_01_ending_soldier05" },
    { 0xD87C0437, "ch_mon_11_01_ending_soldier05_entry" },
    { 0x49E6A6EB, "ch_mon_11_01_ending_soldier05_idle" },
    { 0x780E57AC, "ch_mon_11_01_ending_soldiers_soldier01" },
    { 0xC9227275, "ch_mon_11_01_ending_soldiers_soldier01_idle" },
    { 0xEA15C6E7, "ch_mon_11_01_ending_soldiers_soldier02" },
    { 0x7DB55E10, "ch_mon_11_01_ending_soldiers_soldier02_idle" },
    { 0xC4134C7E, "ch_mon_11_01_ending_soldiers_soldier03" },
    { 0xB88A6027, "ch_mon_11_01_ending_soldiers_soldier03_idle" },
    { 0x0606E871, "ch_mon_11_01_ending_soldiers_soldier04" },
    { 0x57100EB2, "ch_mon_11_01_ending_soldiers_soldier04_idle" },
    { 0xD8AB972B, "ch_mon_11_01_ending_standby_idle" },
    { 0x693E757B, "ch_mov_0_test_01_chloe" },
    { 0x343D9128, "ch_mov_0_test_harper_walk_01" },
    { 0x3140CE40, "ch_mov_0_test_hillary_exit_cougar" },
    { 0x20FC9AF9, "ch_mov_a1d_01b_defalco" },
    { 0xBC52C5D4, "ch_mov_a1d_02_defalco" },
    { 0xFCD470DA, "ch_mov_a1d_02_secguard" },
    { 0x02680E86, "ch_mov_a1d_02_woods" },
    { 0x5F6DE1FD, "ch_mov_a1m_02b_menendez" },
    { 0x1D3CCD59, "ch_mov_a1m_02b_secguard" },
    { 0x9372FF49, "ch_mov_a1m_03a_menendez" },
    { 0x4965C2A7, "ch_mov_a1m_03a_woods" },
    { 0x2F5368E0, "ch_mov_a1m_03b_menendez" },
    { 0x82F17714, "ch_mov_a1m_03b_woods" },
    { 0x9E8B6C77, "ch_mov_a1m_03c_menendez" },
    { 0x4325FB7D, "ch_mov_a1m_03c_woods" },
    { 0x88F98C36, "ch_mov_a1m_03d_menendez" },
    { 0xA43F1A6A, "ch_mov_a1m_03d_woods" },
    { 0x809BDAAD, "ch_mov_a1m_04_menendez" },
    { 0x4287A66B, "ch_mov_a1m_04_woods" },
    { 0xFC9D5A4C, "ch_mov_a2j_01b_masonjr" },
    { 0xB76C133B, "ch_mov_a2j_01b_receptionist" },
    { 0xC46942E0, "ch_mov_a2j_01b_secguard" },
    { 0xD934123D, "ch_mov_a2j_01c_masonjr" },
    { 0x894A3A33, "ch_mov_a2j_01c_secguard" },
    { 0x4C9D9603, "ch_mov_a2j_02_mason" },
    { 0x279140CB, "ch_mov_a2j_02_masonjr" },
    { 0x475DDB23, "ch_mov_a2j_02_woods" },
    { 0xFBC76B2E, "ch_mov_a2j_03_mason" },
    { 0xD32CAD32, "ch_mov_a2j_03_masonjr" },
    { 0x6A873322, "ch_mov_a2j_03_woods" },
    { 0x912ACF7C, "ch_mov_a2s_02_mason" },
    { 0x87F2FA6C, "ch_mov_a2s_02_woods" },
    { 0xE29BE071, "ch_mov_a2s_03_mason" },
    { 0x704B0F55, "ch_mov_a2s_03_woods" },
    { 0x04F2286E, "ch_mov_a2s_04_mason" },
    { 0xD308725E, "ch_mov_a2s_04_menendez" },
    { 0xA16234AE, "ch_mov_a2s_04_secguard" },
    { 0x686A475C, "ch_mov_a3a_01_mason" },
    { 0x787F274C, "ch_mov_a3a_01_woods" },
    { 0xEC9297DF, "ch_mov_a3a_02_masonjr" },
    { 0xB906B5BF, "ch_mov_a3a_02_woods" },
    { 0x1671E08E, "ch_mov_a3a_02a_masonjr" },
    { 0x05F0F446, "ch_mov_a3a_02a_woods" },
    { 0x89F39871, "ch_mov_a3a_02b_masonjr" },
    { 0xF0D1133D, "ch_mov_a3a_02b_woods" },
    { 0xDFBB5FA9, "ch_mov_a3d_01_caretaker" },
    { 0x346357B0, "ch_mov_afg1_01_harper" },
    { 0x3AE07470, "ch_mov_afg1_01_masonjr" },
    { 0x7266C4F4, "ch_mov_afg1_01_woods" },
    { 0x4386A7A3, "ch_mov_afg2_01_harper" },
    { 0x3A391A11, "ch_mov_afg2_01_masonjr" },
    { 0xD8A1AEDD, "ch_mov_afg2_01_woods" },
    { 0x20F86534, "ch_mov_afg_06_harper" },
    { 0xE2BC7E1C, "ch_mov_afg_06_masonjr" },
    { 0x89F65188, "ch_mov_afg_06_woods" },
    { 0xD7D7C33C, "ch_mov_ang1_01_woods" },
    { 0x10C3BBC2, "ch_mov_ang_01_hudson" },
    { 0xF778DF07, "ch_mov_ang_01_mason" },
    { 0x971DCA84, "ch_mov_ang_01_masonjr_child" },
    { 0x2FCC8EB0, "ch_mov_ang_01_north" },
    { 0xF2DEC7CC, "ch_mov_ang_02_woods" },
    { 0x80EE0C35, "ch_mov_ang_03_woods" },
    { 0x33B2EAD7, "ch_mov_ant_01_vault_woods_t4_02b" },
    { 0xA1A23331, "ch_mov_ant_01_vault_woods_t4_04b" },
    { 0x5798CFB2, "ch_mov_ant_01_vault_woods_t5_02b" },
    { 0x77DDCD1B, "ch_mov_ant_01_vault_woods_t5_05f" },
    { 0x7DE7616C, "ch_mov_ant_01_vault_woods_t7_02b" },
    { 0xAD063231, "ch_mov_b1a_02_chloe" },
    { 0xBC3724CD, "ch_mov_b1a_02_colonel_kurtz" },
    { 0x35BD5680, "ch_mov_b1a_03_chloe" },
    { 0x310C122C, "ch_mov_b1a_03_colonel_kurtz" },
    { 0x6C5FE72A, "ch_mov_b2d_02_cianerd" },
    { 0x7CBE4315, "ch_mov_b2d_02_colonel_kurtz" },
    { 0x9A5E2ED3, "ch_mov_b3r_00_menendez" },
    { 0x5B55E34C, "ch_mov_b3r_01_menendez" },
    { 0x6FA24ABA, "ch_mov_bfr_01_masonjr_child" },
    { 0x43B38A63, "ch_mov_bfr_01_menendez" },
    { 0xC2F579F0, "ch_mov_c1a_01_menendez" },
    { 0xB388C4D1, "ch_mov_c1a_02_karma" },
    { 0x7ED6FC1A, "ch_mov_c1a_02_kimmel" },
    { 0x303480F9, "ch_mov_c1d_01_menendez" },
    { 0x7D96E797, "ch_mov_c1d_01_secservice" },
    { 0xB2E5CDFB, "ch_mov_c1d_01_secservice_01" },
    { 0x40DE5EC0, "ch_mov_c1d_01_secservice_02" },
    { 0xC2ACCE9B, "ch_mov_c1d_02_kimmel" },
    { 0x4B9B8561, "ch_mov_c2a_01_menendez" },
    { 0xF912F1E1, "ch_mov_c2a_a_01_menendez" },
    { 0x8742C25E, "ch_mov_c2a_b_01_menendez" },
    { 0xB5CA3118, "ch_mov_c2d_01_menendez" },
    { 0x79DF9CB7, "ch_mov_com_01a_briggs" },
    { 0xF0E514E0, "ch_mov_com_01a_secdefense" },
    { 0xFF8FFE0A, "ch_mov_com_01b_briggs" },
    { 0x488D0A5D, "ch_mov_com_01b_secdefense" },
    { 0xFD223787, "ch_mov_com_02_briggs" },
    { 0x91210814, "ch_mov_com_02_crew_01" },
    { 0x0328774F, "ch_mov_com_02_crew_02" },
    { 0x0E9E0C1D, "ch_mov_com_02_masonjr" },
    { 0xD1CA2F2B, "ch_mov_com_02_menendez" },
    { 0x0871EC90, "ch_mov_com_02_navyseal_01" },
    { 0x7A795BCB, "ch_mov_com_02_navyseal_02" },
    { 0x5476E162, "ch_mov_com_02_navyseal_03" },
    { 0xC67E509D, "ch_mov_com_02_navyseal_04" },
    { 0xA07BD634, "ch_mov_com_02_navyseal_05" },
    { 0x1283456F, "ch_mov_com_02_navyseal_06" },
    { 0xEC80CB06, "ch_mov_com_02_navyseal_07" },
    { 0x5E883A41, "ch_mov_com_02_navyseal_08" },
    { 0x3885BFD8, "ch_mov_com_02_navyseal_09" },
    { 0x702C4DEE, "ch_mov_com_02_navyseal_10" },
    { 0x962EC857, "ch_mov_com_02_navyseal_11" },
    { 0x2427591C, "ch_mov_com_02_navyseal_12" },
    { 0x4A29D385, "ch_mov_com_02_navyseal_13" },
    { 0xD822644A, "ch_mov_com_02_navyseal_14" },
    { 0xFE24DEB3, "ch_mov_com_02_navyseal_15" },
    { 0x8C1D6F78, "ch_mov_com_02_navyseal_16" },
    { 0xB21FE9E1, "ch_mov_com_02_navyseal_17" },
    { 0x40187AA6, "ch_mov_com_02_navyseal_18" },
    { 0x661AF50F, "ch_mov_com_02_navyseal_19" },
    { 0xF057B343, "ch_mov_com_02_navyseal_20" },
    { 0xCA5538DA, "ch_mov_com_02_navyseal_21" },
    { 0xA452BE71, "ch_mov_com_02_navyseal_22" },
    { 0x7E504408, "ch_mov_com_02_navyseal_23" },
    { 0x88619CE7, "ch_mov_com_02_navyseal_24" },
    { 0x72F4002B, "ch_mov_com_02_newsanchor" },
    { 0x440DA633, "ch_mov_com_02_salazar" },
    { 0x0C53C9B0, "ch_mov_com_02_secdefense" },
    { 0x83CBB3AA, "ch_mov_hai1_01_menendez" },
    { 0xD7EDF4A7, "ch_mov_hai1_01a_menendez" },
    { 0x609A26D2, "ch_mov_hai1_01b_menendez" },
    { 0xB5D38EA8, "ch_mov_hai_01_petraeus" },
    { 0x6ADAB0C3, "ch_mov_hai_01_president" },
    { 0x482BC1DE, "ch_mov_hai_03_petraeus" },
    { 0xCAA19A69, "ch_mov_hai_03_president" },
    { 0xD777A207, "ch_mov_hai_civ_phone_calling" },
    { 0xED19D8F0, "ch_mov_hai_civ_pointing" },
    { 0x3834416D, "ch_mov_hai_civ_pointing_02" },
    { 0xD40FD49E, "ch_mov_hai_civ_terrified_metro" },
    { 0x748745BB, "ch_mov_kar_01_harper" },
    { 0xBF067669, "ch_mov_kar_01_masonjr" },
    { 0xE26D9ECF, "ch_mov_kar_01_salazar" },
    { 0x727540FE, "ch_mov_kar_02_woods" },
    { 0x4E61A7C1, "ch_mov_kar_03_harper" },
    { 0xA0E3DD9F, "ch_mov_kar_03_masonjr" },
    { 0x39B4146D, "ch_mov_kar_03_salazar" },
    { 0xF371B68A, "ch_mov_los_01a_chen" },
    { 0x9B76F626, "ch_mov_los_01a_president" },
    { 0xC275B397, "ch_mov_los_01b_chen" },
    { 0xCA74024D, "ch_mov_los_01b_president" },
    { 0x40959D56, "ch_mov_los_02_masonjr" },
    { 0xEC6D9015, "ch_mov_los_02_petraeus" },
    { 0x4EC4CDD8, "ch_mov_los_02_president" },
    { 0x335270D3, "ch_mov_los_02_secserv" },
    { 0x69D9E027, "ch_mov_los_02_secserv_01" },
    { 0xF7D270EC, "ch_mov_los_02_secserv_02" },
    { 0x1DD4EB55, "ch_mov_los_02_secserv_03" },
    { 0x772B717E, "ch_mov_los_02_treassec" },
    { 0xDD8F62B3, "ch_mov_los_03_terrorist_01" },
    { 0x6B87F378, "ch_mov_los_03_terrorist_02" },
    { 0x042183BF, "ch_mov_los_05_harper" },
    { 0x74281A75, "ch_mov_los_05_masonjr" },
    { 0x78F0E067, "ch_mov_los_05_president" },
    { 0x179FB2CB, "ch_mov_los_05_seal1" },
    { 0xA5984390, "ch_mov_los_05_seal2" },
    { 0xCB9ABDF9, "ch_mov_los_05_seal3" },
    { 0x89A72206, "ch_mov_los_05_seal4" },
    { 0xF5E19068, "ch_mov_los_05_secdefense" },
    { 0x45979D50, "ch_mov_mon_01a_masonjr" },
    { 0x5F027AD4, "ch_mov_mon_01a_woods" },
    { 0x453A2BA7, "ch_mov_mon_01b_masonjr" },
    { 0xCE9DF467, "ch_mov_mon_01b_woods" },
    { 0x1574D51E, "ch_mov_nic1_01_harper" },
    { 0x0FE0472E, "ch_mov_nic1_01_masonjr" },
    { 0xFA2835E6, "ch_mov_nic1_01_woods" },
    { 0x62A1FC1B, "ch_mov_nic2_01_masonjr" },
    { 0x061F2AB3, "ch_mov_nic2_01_woods" },
    { 0x5F436B7B, "ch_mov_nic_01_harper" },
    { 0x585DE029, "ch_mov_nic_01_masonjr" },
    { 0x7C0AE38F, "ch_mov_nic_01_salazar" },
    { 0xE4A7010C, "ch_mov_nic_01a_harper" },
    { 0xF1ADB314, "ch_mov_nic_01a_masonjr" },
    { 0x2FC0E6D6, "ch_mov_nic_01a_salazar" },
    { 0x72DBFD25, "ch_mov_nic_01b_harper" },
    { 0x8D07C0AB, "ch_mov_nic_01b_masonjr" },
    { 0x6C995A89, "ch_mov_nic_01b_salazar" },
    { 0xF5358FB6, "ch_mov_nic_02_harper" },
    { 0x4B307406, "ch_mov_nic_02_masonjr" },
    { 0xD4695008, "ch_mov_nic_02_salazar" },
    { 0x3B44ADCC, "ch_mov_nic_04_harper" },
    { 0xE4FBB9D4, "ch_mov_nic_04_masonjr" },
    { 0xEB69ADE0, "ch_mov_nic_04_woods" },
    { 0x92A9586F, "ch_mov_nic_05_harper" },
    { 0xE4500925, "ch_mov_nic_05_masonjr" },
    { 0xC0977879, "ch_mov_nic_05_woods" },
    { 0xAF2BA82A, "ch_mov_ntr_02a_josefina" },
    { 0x5666634E, "ch_mov_ntr_02a_menendez_child" },
    { 0xE739B4DF, "ch_mov_ntr_02b_josefina_burned1" },
    { 0xBF43C3B7, "ch_mov_ntr_02b_menendez_child" },
    { 0xE39DE8B8, "ch_mov_ntr_02c_josefina_burned1" },
    { 0x10000214, "ch_mov_ntr_02c_menendez_child" },
    { 0xA3ED2C95, "ch_mov_ntr_02d_josefina_burned1" },
    { 0xE73B21DD, "ch_mov_ntr_02d_menendez_child" },
    { 0xECA13168, "ch_mov_pak1_01_briggs" },
    { 0x504F6597, "ch_mov_pak2_01_briggs" },
    { 0x17AAA116, "ch_mov_pak_01_africanmerc" },
    { 0x50B0DE4F, "ch_mov_pak_01_africanmerc_02" },
    { 0x2AAE63E6, "ch_mov_pak_01_africanmerc_03" },
    { 0xE5FA0531, "ch_mov_pak_01_defalco" },
    { 0xCCFB4A3A, "ch_mov_pak_01_isisoldier" },
    { 0x5ABDAB85, "ch_mov_pak_01_menendez" },
    { 0xF5AAA83E, "ch_mov_pak_01c_farid" },
    { 0x63305059, "ch_mov_pak_02a_briggs" },
    { 0x36E5F12D, "ch_mov_pak_02a_harper" },
    { 0x812677B3, "ch_mov_pak_02a_masonjr" },
    { 0x3A0387D2, "ch_mov_pak_02a_navyseal_01" },
    { 0x14010D69, "ch_mov_pak_02a_navyseal_02" },
    { 0xEDFE9300, "ch_mov_pak_02a_navyseal_03" },
    { 0xF80FEBDF, "ch_mov_pak_02a_navyseal_04" },
    { 0xD20D7176, "ch_mov_pak_02a_navyseal_05" },
    { 0xF9C32F91, "ch_mov_pak_02a_salazar" },
    { 0x2D040F88, "ch_mov_pak_02b_briggs" },
    { 0x4813AF74, "ch_mov_pak_02b_harper" },
    { 0xB3EF955C, "ch_mov_pak_02b_masonjr" },
    { 0xB23CFA25, "ch_mov_pak_02b_navyseal_01" },
    { 0xD83F748E, "ch_mov_pak_02b_navyseal_02" },
    { 0xFE41EEF7, "ch_mov_pak_02b_navyseal_03" },
    { 0xF4309618, "ch_mov_pak_02b_navyseal_04" },
    { 0x1A331081, "ch_mov_pak_02b_navyseal_05" },
    { 0xB892C87E, "ch_mov_pak_02b_salazar" },
    { 0x0CC42E6D, "ch_mov_pan1_01_masonjr" },
    { 0x21F60C01, "ch_mov_pan1_01_woods" },
    { 0xC417AD5C, "ch_mov_pan2_01_masonjr" },
    { 0x7128D4C8, "ch_mov_pan2_01_woods" },
    { 0xDC1D61BF, "ch_mov_pan3_01_masonjr" },
    { 0xE127989F, "ch_mov_pan3_01_woods" },
    { 0x22AA572E, "ch_mov_pan4_01_masonjr" },
    { 0x64BFC5E6, "ch_mov_pan4_01_woods" },
    { 0x4F169CC9, "ch_mov_pan5_01_masonjr" },
    { 0xD5CED8D5, "ch_mov_pan5_01_woods" },
    { 0xFF4AB088, "ch_mov_pan6_01_masonjr" },
    { 0x0A85328C, "ch_mov_pan6_01_woods" },
    { 0xE193FFA1, "ch_mov_pan_01_a_guard" },
    { 0xDB5093AC, "ch_mov_pan_01_a_masonjr" },
    { 0x91F18358, "ch_mov_pan_01_a_woods" },
    { 0x3812ED03, "ch_mov_pan_01_b_masonjr" },
    { 0xDC9C857B, "ch_mov_pan_01_b_woods" },
    { 0x202B9DF1, "ch_mov_pan_02_hudsonwife" },
    { 0x86534900, "ch_mov_pan_02_masonjr_child" },
    { 0xEDC4718B, "ch_mov_pan_02_woods" },
    { 0xA928574C, "ch_mov_pro_01_harper" },
    { 0x625F8E54, "ch_mov_pro_01_masonjr" },
    { 0xD5128523, "ch_mov_pro_01_mrlamb" },
    { 0x6355C7A5, "ch_mov_pro_01_nurse" },
    { 0xBBE33DD0, "ch_mov_pro_01_secserv01" },
    { 0x2DEAAD0B, "ch_mov_pro_01_secserv02" },
    { 0x07E832A2, "ch_mov_pro_01_secserv03" },
    { 0x79EFA1DD, "ch_mov_pro_01_secserv04" },
    { 0x53ED2774, "ch_mov_pro_01_secserv05" },
    { 0xC5F496AF, "ch_mov_pro_01_secserv06" },
    { 0x9FF21C46, "ch_mov_pro_01_secserv07" },
    { 0x11F98B81, "ch_mov_pro_01_secserv08" },
    { 0xC4BF4D4A, "ch_mov_pro_01_secserv1" },
    { 0x239D9F2E, "ch_mov_pro_01_secserv10" },
    { 0x49A01997, "ch_mov_pro_01_secserv11" },
    { 0xD798AA5C, "ch_mov_pro_01_secserv12" },
    { 0xFD9B24C5, "ch_mov_pro_01_secserv13" },
    { 0x8B93B58A, "ch_mov_pro_01_secserv14" },
    { 0xB1962FF3, "ch_mov_pro_01_secserv15" },
    { 0x3F8EC0B8, "ch_mov_pro_01_secserv16" },
    { 0x65913B21, "ch_mov_pro_01_secserv17" },
    { 0xF389CBE6, "ch_mov_pro_01_secserv18" },
    { 0x198C464F, "ch_mov_pro_01_secserv19" },
    { 0x9EBCD2E1, "ch_mov_pro_01_secserv2" },
    { 0xA3C90483, "ch_mov_pro_01_secserv20" },
    { 0x7DC68A1A, "ch_mov_pro_01_secserv21" },
    { 0x57C40FB1, "ch_mov_pro_01_secserv22" },
    { 0x31C19548, "ch_mov_pro_01_secserv23" },
    { 0x3BD2EE27, "ch_mov_pro_01_secserv24" },
    { 0x15D073BE, "ch_mov_pro_01_secserv25" },
    { 0xEFCDF955, "ch_mov_pro_01_secserv26" },
    { 0xC9CB7EEC, "ch_mov_pro_01_secserv27" },
    { 0x73B5313B, "ch_mov_pro_01_secserv28" },
    { 0x4DB2B6D2, "ch_mov_pro_01_secserv29" },
    { 0x78BA5878, "ch_mov_pro_01_secserv3" },
    { 0x25319E58, "ch_mov_pro_01_secserv30" },
    { 0x4B3418C1, "ch_mov_pro_01_secserv31" },
    { 0x7136932A, "ch_mov_pro_01_secserv32" },
    { 0x97390D93, "ch_mov_pro_01_secserv33" },
    { 0xBD3B87FC, "ch_mov_pro_01_secserv34" },
    { 0xE33E0265, "ch_mov_pro_01_secserv35" },
    { 0x82CBB157, "ch_mov_pro_01_secserv4" },
    { 0x81990165, "ch_mov_pro_02_harper" },
    { 0x3B6882EB, "ch_mov_pro_02_masonjr" },
    { 0xA2EC7C7F, "ch_mov_pro_02_secserv01" },
    { 0x30E50D44, "ch_mov_pro_02_secserv02" },
    { 0x56E787AD, "ch_mov_pro_02_secserv03" },
    { 0xE4E01872, "ch_mov_pro_02_secserv04" },
    { 0x0AE292DB, "ch_mov_pro_02_secserv05" },
    { 0x98DB23A0, "ch_mov_pro_02_secserv06" },
    { 0xBEDD9E09, "ch_mov_pro_02_secserv07" },
    { 0xACFDD55E, "ch_mov_pro_02_secserv08" },
    { 0xD3004FC7, "ch_mov_pro_02_secserv09" },
    { 0xFB816841, "ch_mov_pro_02_secserv10" },
    { 0xD57EEDD8, "ch_mov_pro_02_secserv11" },
    { 0x47865D13, "ch_mov_pro_02_secserv12" },
    { 0x2183E2AA, "ch_mov_pro_02_secserv13" },
    { 0x2117901F, "ch_mov_pro_02b_harper" },
    { 0x783F0B55, "ch_mov_pro_02b_masonjr" },
    { 0x4FB69C29, "ch_mov_pro_02b_woods" },
    { 0x3C140B0A, "ch_mov_pro_03_harper" },
    { 0x62ED7A52, "ch_mov_pro_03_masonjr" },
    { 0x5D036D42, "ch_mov_pro_03_woods" },
    { 0x54E11C5B, "ch_mov_revealtrailer02_briggs_shot_01_briggs" },
    { 0x377FB083, "ch_mov_revealtrailer02_briggs_shot_02a_briggs" },
    { 0x6AA07556, "ch_mov_revealtrailer02_briggs_shot_02b_briggs" },
    { 0x9BD96D4D, "ch_mov_revealtrailer02_briggs_shot_03_briggs" },
    { 0x58FA2718, "ch_mov_revealtrailer02_briggs_shot_04_briggs" },
    { 0xBC7A4AB3, "ch_mov_revealtrailer02_vault_shot_01_menendez" },
    { 0x89F3F109, "ch_mov_revealtrailer02_vault_shot_01_woods" },
    { 0x4AD4170E, "ch_mov_revealtrailer02_vault_shot_02_menendez" },
    { 0x504523D2, "ch_mov_revealtrailer02_vault_shot_02_woods" },
    { 0x620ED0C5, "ch_mov_revealtrailer02_vault_shot_03_menendez" },
    { 0x4E09C6D3, "ch_mov_revealtrailer02_vault_shot_03_woods" },
    { 0xB6726E58, "ch_mov_revealtrailer02_vault_shot_04_menendez" },
    { 0xBA38D05C, "ch_mov_revealtrailer02_vault_shot_04_woods" },
    { 0x747CF5E5, "ch_mov_yem_02_masonjr" },
    { 0x3A7C54DB, "ch_mov_yem_02_salazar" },
    { 0xE25C5B36, "ch_mov_yem_03a_chloe" },
    { 0x6F4D1783, "ch_mov_yem_03a_masonjr" },
    { 0x8AD9ECC1, "ch_mov_yem_03a_salazar" },
    { 0x8AFAF6E6, "ch_mov_yem_03b_cianerd" },
    { 0x128ABE2C, "ch_mov_yem_03b_masonjr" },
    { 0x498F566E, "ch_mov_yem_03b_salazar" },
    { 0x811516CE, "ch_mov_yem_04a_masonjr" },
    { 0xCF35A4B0, "ch_mov_yem_04a_salazar" },
    { 0x5B0E83B1, "ch_mov_yem_04b_masonjr" },
    { 0x08DC9B37, "ch_mov_yem_04b_salazar" },
    { 0x799CC509, "ch_mov_yem_04bb_briggs" },
    { 0x9374E492, "ch_multiplierchanged" },
    { 0xC202563A, "ch_nic_01_01_intro_josafina" },
    { 0x4C6AFE40, "ch_nic_01_01_intro_player" },
    { 0x62C5696E, "ch_nic_01_01_intro_player_ref" },
    { 0x3EBB2B4B, "ch_nic_01_02_intro_josafina" },
    { 0x961F2815, "ch_nic_01_02_intro_player" },
    { 0x581DEA47, "ch_nic_02_01_noriega_arrives_player" },
    { 0xCB9CB2C8, "ch_nic_03_01_ambient_deaths_civ01" },
    { 0xAC0DAFD4, "ch_nic_03_01_ambient_deaths_pdf01" },
    { 0x44C79087, "ch_nic_03_01_pdf_brutality_civ_01_idle" },
    { 0x5633BA96, "ch_nic_03_01_pdf_brutality_civ_01_react" },
    { 0xC9A5E69E, "ch_nic_03_01_pdf_brutality_civ_02_idle" },
    { 0x62B84B35, "ch_nic_03_01_pdf_brutality_civ_02_react" },
    { 0x7320445F, "ch_nic_03_01_pdf_brutality_pdf_01_idle" },
    { 0x829AEA3E, "ch_nic_03_01_pdf_brutality_pdf_01_react" },
    { 0xC733C4B6, "ch_nic_03_01_pdf_brutality_pdf_02_idle" },
    { 0xCACC02FD, "ch_nic_03_01_pdf_brutality_pdf_02_react" },
    { 0x46D42595, "ch_nic_03_01_village_execution_civ01" },
    { 0xECDA80E1, "ch_nic_03_01_village_execution_civ01_escape" },
    { 0xC73BE412, "ch_nic_03_01_village_execution_civ01_loop" },
    { 0x6CD69FFE, "ch_nic_03_01_village_execution_civ02" },
    { 0x305757B0, "ch_nic_03_01_village_execution_civ02_escape" },
    { 0x66CB17BF, "ch_nic_03_01_village_execution_civ02_loop" },
    { 0x92D91A67, "ch_nic_03_01_village_execution_civ03" },
    { 0xFA2C51FB, "ch_nic_03_01_village_execution_civ03_escape" },
    { 0x882102D4, "ch_nic_03_01_village_execution_civ03_loop" },
    { 0x88C7C188, "ch_nic_03_01_village_execution_civ04" },
    { 0x0AD42232, "ch_nic_03_01_village_execution_civ04_escape" },
    { 0x9798A731, "ch_nic_03_01_village_execution_civ04_loop" },
    { 0xAECA3BF1, "ch_nic_03_01_village_execution_civ05" },
    { 0xA29353BD, "ch_nic_03_01_village_execution_civ05_escape" },
    { 0x78E33F46, "ch_nic_03_01_village_execution_civ05_loop" },
    { 0x1201C665, "ch_nic_03_01_village_execution_pdf01" },
    { 0x1FAFF182, "ch_nic_03_01_village_execution_pdf01_loop" },
    { 0x380440CE, "ch_nic_03_01_village_execution_pdf02" },
    { 0x4437E7AF, "ch_nic_03_01_village_execution_pdf02_loop" },
    { 0x5E06BB37, "ch_nic_03_01_village_execution_pdf03" },
    { 0x2E6A1884, "ch_nic_03_01_village_execution_pdf03_loop" },
    { 0x53F56258, "ch_nic_03_01_village_execution_pdf04" },
    { 0xBD885B21, "ch_nic_03_01_village_execution_pdf04_loop" },
    { 0x79F7DCC1, "ch_nic_03_01_village_execution_pdf05" },
    { 0x6B7A1876, "ch_nic_03_01_village_execution_pdf05_loop" },
    { 0x3ECE0ABD, "ch_nic_03_02_balcony_throw_civ" },
    { 0x55C4F361, "ch_nic_03_02_balcony_throw_pdf" },
    { 0xE0A6BBFB, "ch_nic_03_02_cartel_retreat_pdf_01" },
    { 0x6E9F4CC0, "ch_nic_03_02_cartel_retreat_pdf_02" },
    { 0x94A1C729, "ch_nic_03_02_cartel_retreat_pdf_03" },
    { 0x52AE2B36, "ch_nic_03_02_cartel_retreat_pdf_04" },
    { 0x78B0A59F, "ch_nic_03_02_cartel_retreat_pdf_05" },
    { 0x9763203A, "ch_nic_03_02_pdf_struggle_pdf" },
    { 0xF43726CB, "ch_nic_03_02_pdf_struggle_pdf_idle" },
    { 0x6827F22A, "ch_nic_03_02_pdf_struggle_pdf_react" },
    { 0x2995EC26, "ch_nic_03_02_pdf_struggle_woman" },
    { 0x85C28DAF, "ch_nic_03_02_pdf_struggle_woman_idle" },
    { 0x6CD2396E, "ch_nic_03_02_pdf_struggle_woman_react" },
    { 0xFD47A465, "ch_nic_03_02_pitchfork_impale_pdf" },
    { 0x3B1D17C9, "ch_nic_03_04_banister_jump_pdf" },
    { 0xC5C2D0E6, "ch_nic_03_1_axe_hack_axe_hack_pdf_01" },
    { 0x9FC0567D, "ch_nic_03_1_axe_hack_axe_hack_pdf_02" },
    { 0xE033293E, "ch_nic_03_1_execution_idle_pdf_01" },
    { 0xBA30AED5, "ch_nic_03_1_execution_idle_pdf_02" },
    { 0x942E346C, "ch_nic_03_1_execution_idle_pdf_03" },
    { 0x6E2BBA03, "ch_nic_03_1_execution_idle_pdf_04" },
    { 0x48293F9A, "ch_nic_03_1_execution_idle_pdf_05" },
    { 0x8577C2DD, "ch_nic_03_1_execution_react_pdf_01" },
    { 0xAB7A3D46, "ch_nic_03_1_execution_react_pdf_02" },
    { 0xD17CB7AF, "ch_nic_03_1_execution_react_pdf_03" },
    { 0xC76B5ED0, "ch_nic_03_1_execution_react_pdf_04" },
    { 0xED6DD939, "ch_nic_03_1_execution_react_pdf_05" },
    { 0x6016DCF1, "ch_nic_04_01_shattered2_hudson" },
    { 0xF8DC00F6, "ch_nic_04_01_shattered2_menendez" },
    { 0x75AFAC2A, "ch_nic_04_01_shattered2_woods" },
    { 0x3FA139FB, "ch_nic_04_01_shattered2_woods_idle" },
    { 0xCDD84E66, "ch_nic_04_01_shattered2_woods_runtoposition" },
    { 0x46D06551, "ch_nic_04_01_shattered_hudson" },
    { 0x36C83526, "ch_nic_04_01_shattered_mason" },
    { 0xD6FE340A, "ch_nic_04_01_shattered_woods" },
    { 0x211D078B, "ch_nic_05_01_recon_hudson" },
    { 0x8A47CAFD, "ch_nic_05_01_recon_noriega" },
    { 0x48345ED5, "ch_nic_05_01_recon_player" },
    { 0x682EC094, "ch_nic_05_01_recon_scope_guard" },
    { 0x2B5BC554, "ch_nic_05_01_recon_scope_josafina" },
    { 0x3E84357D, "ch_nic_05_01_recon_scope_mendendez" },
    { 0xD6F05AF6, "ch_nic_05_01_recon_scope_mendendez_intro" },
    { 0xB9E4F0F7, "ch_nic_05_01_recon_scope_mendendez_reflection" },
    { 0x9ADDB7F4, "ch_nic_05_01_recon_scope_pdf01" },
    { 0x0CE5272F, "ch_nic_05_01_recon_scope_pdf02" },
    { 0xE6E2ACC6, "ch_nic_05_01_recon_scope_pdf03" },
    { 0x28D648B9, "ch_nic_05_01_recon_scope_pdf04" },
    { 0xD7C77104, "ch_nic_05_01_recon_woods" },
    { 0x8CEC091D, "ch_nic_05_02_recon_go_hudson" },
    { 0x6C12811F, "ch_nic_05_02_recon_go_noriega" },
    { 0x2B5FE4B7, "ch_nic_05_02_recon_go_player" },
    { 0x5FA4688E, "ch_nic_05_02_recon_go_woods" },
    { 0xDFAB150D, "ch_nic_06_08_balcony_fence_strugle_hudson" },
    { 0x3422074A, "ch_nic_06_08_balcony_fence_strugle_menendez" },
    { 0xD7F1EEDE, "ch_nic_06_08_balcony_fence_strugle_woods" },
    { 0x3708D26D, "ch_nic_06_08_balcony_hudson_idle" },
    { 0x353E52CF, "ch_nic_06_08_balcony_hudson_intro" },
    { 0x298AB62A, "ch_nic_06_08_balcony_woods_idle" },
    { 0xA9D562A2, "ch_nic_06_08_balcony_woods_intro" },
    { 0x4E6327B3, "ch_nic_06_12_intruder_pdf_01" },
    { 0x33735664, "ch_nic_06_12_intruder_pdf_01_idle" },
    { 0xDC5BB878, "ch_nic_06_12_intruder_pdf_02" },
    { 0xB487C119, "ch_nic_06_12_intruder_pdf_02_idle" },
    { 0x012FFB2F, "ch_nic_06_14_bunker_enter_hudson" },
    { 0xF548E939, "ch_nic_06_14_bunker_enter_player" },
    { 0x88E9EFEB, "ch_nic_06_14_split_up_hudson" },
    { 0x681B30FC, "ch_nic_06_14_split_up_hudson_idle" },
    { 0xC5801880, "ch_nic_06_14_split_up_hudson_loop" },
    { 0xDBB18F72, "ch_nic_06_14_split_up_pdf_01" },
    { 0x661658BB, "ch_nic_06_14_split_up_pdf_01_loop" },
    { 0xB5AF1509, "ch_nic_06_14_split_up_pdf_02" },
    { 0xB0CB206A, "ch_nic_06_14_split_up_pdf_02_idle" },
    { 0x42F8DD8E, "ch_nic_06_14_split_up_pdf_02_loop" },
    { 0x8FAC9AA0, "ch_nic_06_14_split_up_pdf_03" },
    { 0xBF18C781, "ch_nic_06_14_split_up_pdf_03_idle" },
    { 0x7AA05A59, "ch_nic_06_14_split_up_pdf_03_loop" },
    { 0xC6644A8D, "ch_nic_06_14_split_up_pdf_climb_down" },
    { 0x1F9383E3, "ch_nic_06_14_split_up_pdf_enter" },
    { 0x8A237A9A, "ch_nic_06_14_split_up_pdf_start_idle" },
    { 0xF25EBCE4, "ch_nic_06_14_split_up_woods" },
    { 0xDC886635, "ch_nic_06_14_split_up_woods_climb_down" },
    { 0x864F176B, "ch_nic_06_14_split_up_woods_enter" },
    { 0x7C91BD25, "ch_nic_06_14_split_up_woods_loop" },
    { 0xF5AF15F2, "ch_nic_06_14_split_up_woods_start_idle" },
    { 0x1D857384, "ch_nic_06_16_bunker_cartel_cartel_01_react" },
    { 0x2A81026F, "ch_nic_06_16_bunker_cartel_cartel_02_react" },
    { 0x90D38CD2, "ch_nic_06_16_bunker_cartel_frantic" },
    { 0xAD201678, "ch_nic_06_16_bunker_cartel_frantic_reaction" },
    { 0x48C48428, "ch_nic_06_16_bunker_cartel_table_watch01" },
    { 0x9201423E, "ch_nic_06_16_bunker_cartel_table_watch01_reaction" },
    { 0xBACBF363, "ch_nic_06_16_bunker_cartel_table_watch02" },
    { 0x14708AF7, "ch_nic_06_16_bunker_cartel_table_watch02_reaction" },
    { 0x94C978FA, "ch_nic_06_16_bunker_cartel_table_watch03" },
    { 0xF46429F0, "ch_nic_06_16_bunker_cartel_table_watch03_reaction" },
    { 0xE61BE2EC, "ch_nic_06_16_bunker_cartel_worker01" },
    { 0xDFB58580, "ch_nic_06_16_bunker_cartel_worker01_react" },
    { 0x58235227, "ch_nic_06_16_bunker_cartel_worker02" },
    { 0xB9BBAFDB, "ch_nic_06_16_bunker_cartel_worker02_react" },
    { 0x3220D7BE, "ch_nic_06_16_bunker_cartel_worker03" },
    { 0xBA99A9F6, "ch_nic_06_16_bunker_cartel_worker03_react" },
    { 0x741473B1, "ch_nic_06_16_bunker_cartel_worker04" },
    { 0xD7F21829, "ch_nic_06_16_bunker_cartel_worker04_react" },
    { 0x4E11F948, "ch_nic_06_16_bunker_cartel_worker05" },
    { 0x7AFFE354, "ch_nic_06_16_bunker_cartel_worker05_react" },
    { 0xE07B043B, "ch_nic_06_16_bunker_cocaine_run_civ01" },
    { 0x6E739500, "ch_nic_06_16_bunker_cocaine_run_civ02" },
    { 0x94760F69, "ch_nic_06_16_bunker_cocaine_run_civ03" },
    { 0x2F1193F2, "ch_nic_06_16_evidence_cartel01_idle" },
    { 0x7D7B6C29, "ch_nic_06_16_evidence_cartel01_react" },
    { 0x5B55CB6B, "ch_nic_06_16_evidence_cartel02_idle" },
    { 0x0A42C54A, "ch_nic_06_16_evidence_cartel02_react" },
    { 0xFAD8B6B8, "ch_nic_06_18_backbreaker_cartel" },
    { 0x89655E45, "ch_nic_06_18_backbreaker_woods" },
    { 0xC69A5F2E, "ch_nic_06_18_backbreaker_woods_idle" },
    { 0xF5AF23E1, "ch_nic_06_18_bunker_exit_approach_woods" },
    { 0x9F219B0A, "ch_nic_06_18_bunker_exit_wait_woods" },
    { 0x500ED444, "ch_nic_06_18_bunker_exit_woods" },
    { 0x6885806F, "ch_nic_08_02_outro_hudson" },
    { 0x3BE67CFE, "ch_nic_08_02_outro_pdf_01" },
    { 0x15E40295, "ch_nic_08_02_outro_pdf_02" },
    { 0xC9DF0DC3, "ch_nic_08_02_outro_pdf_04" },
    { 0xA3DC935A, "ch_nic_08_02_outro_pdf_05" },
    { 0x7DDA18F1, "ch_nic_08_02_outro_pdf_06" },
    { 0x57D79E88, "ch_nic_08_02_outro_pdf_07" },
    { 0x31D5241F, "ch_nic_08_02_outro_pdf_08" },
    { 0x0BD2A9B6, "ch_nic_08_02_outro_pdf_09" },
    { 0xE351913C, "ch_nic_08_02_outro_pdf_10" },
    { 0xB2966779, "ch_nic_08_02_outro_player" },
    { 0x3EEA1770, "ch_nic_08_02_outro_woods" },
    { 0x046DC18C, "ch_pakistan_1_1_market_intro_enemy1" },
    { 0x767530C7, "ch_pakistan_1_1_market_intro_enemy2" },
    { 0x5072B65E, "ch_pakistan_1_1_market_intro_enemy3" },
    { 0x92665251, "ch_pakistan_1_1_market_intro_enemy4" },
    { 0x056A7BDB, "ch_pakistan_1_1_market_intro_harper" },
    { 0x828DF850, "ch_pakistan_1_1_market_intro_loop_harper" },
    { 0xF0D2E972, "ch_pakistan_1_1_market_intro_loop_salazar" },
    { 0x6C871C6F, "ch_pakistan_1_1_market_intro_salazar" },
    { 0x3FD6AEED, "ch_pakistan_1_5_bus_smash_guy01" },
    { 0x08CC470E, "ch_pakistan_1_5_car_smash_death_guy01" },
    { 0x72A337B5, "ch_pakistan_1_5_car_smash_guy01" },
    { 0x98A5B21E, "ch_pakistan_1_5_car_smash_guy02" },
    { 0x00599311, "ch_pakistan_1_5_grenade_launch_guy_01" },
    { 0xAFB9E237, "ch_pakistan_1_6_brute_force_arrive_salazar" },
    { 0x9B59305E, "ch_pakistan_1_6_brute_force_exit_salazar" },
    { 0x168C30C0, "ch_pakistan_1_6_brute_force_idle_salazar" },
    { 0xA06C06EF, "ch_pakistan_1_6_brute_force_noaccess_soldier" },
    { 0xEDBE1205, "ch_pakistan_1_6_brute_force_salazar" },
    { 0xA28AF46E, "ch_pakistan_2_3_bus_dam_arrival_harper" },
    { 0xFEF11183, "ch_pakistan_2_3_bus_dam_enemy01" },
    { 0x8CE9A248, "ch_pakistan_2_3_bus_dam_enemy02" },
    { 0xB2EC1CB1, "ch_pakistan_2_3_bus_dam_enemy03" },
    { 0x70F880BE, "ch_pakistan_2_3_bus_dam_enemy04" },
    { 0x96FAFB27, "ch_pakistan_2_3_bus_dam_enemy05" },
    { 0x24F38BEC, "ch_pakistan_2_3_bus_dam_enemy06" },
    { 0x4AF60655, "ch_pakistan_2_3_bus_dam_enemy07" },
    { 0xA8DAC3D2, "ch_pakistan_2_3_bus_dam_enemy08" },
    { 0xCEDD3E3B, "ch_pakistan_2_3_bus_dam_enemy09" },
    { 0x58C331C5, "ch_pakistan_2_3_bus_dam_enemy10" },
    { 0x032C36A2, "ch_pakistan_2_3_bus_dam_pushed_harper" },
    { 0xEBED456F, "ch_pakistan_2_3_bus_dam_pushed_idle_harper" },
    { 0x5CEC1BB6, "ch_pakistan_2_3_gate_push_failure_harper" },
    { 0xB6C9741B, "ch_pakistan_2_3_gate_push_harper" },
    { 0x89C94C3D, "ch_pakistan_2_3_gate_push_setup_harper" },
    { 0xFE056443, "ch_pakistan_2_3_gate_push_success_harper" },
    { 0x2FBF728B, "ch_pakistan_3_1_alley_harper" },
    { 0x2A3633A8, "ch_pakistan_3_1_ambient_civilians_civ01" },
    { 0xA189B911, "ch_pakistan_3_1_ambient_civilians_civ01_loop" },
    { 0x9C3DA2E3, "ch_pakistan_3_1_ambient_civilians_civ02" },
    { 0x27F251E8, "ch_pakistan_3_1_ambient_civilians_civ02_loop" },
    { 0x763B287A, "ch_pakistan_3_1_ambient_civilians_civ03" },
    { 0xE84297B5, "ch_pakistan_3_1_ambient_civilians_civ04" },
    { 0xC2401D4C, "ch_pakistan_3_1_ambient_civilians_civ05" },
    { 0x9237307F, "ch_pakistan_3_1_corpse_alley_civilian" },
    { 0x7F802785, "ch_pakistan_3_1_corpse_alley_exit_harper" },
    { 0x91C0C466, "ch_pakistan_3_1_corpse_alley_harper" },
    { 0x3BFBFB34, "ch_pakistan_3_1_corpse_alley_wait_harper" },
    { 0x274BD224, "ch_pakistan_3_1_slum_alley_dog01" },
    { 0x0751FBC2, "ch_pakistan_3_1_slum_alley_dog02_growl_loop" },
    { 0xC339FA05, "ch_pakistan_3_1_slum_alley_dog02_rummage_loop" },
    { 0xF0A3AE86, "ch_pakistan_3_1_slum_alley_dog02_run_away" },
    { 0x2BB9686F, "ch_pakistan_3_1_slum_alley_dog02_transition" },
    { 0x8A64260F, "ch_pakistan_3_1_slum_alley_rat01" },
    { 0x185CB6D4, "ch_pakistan_3_1_slum_alley_rat02" },
    { 0x3E5F313D, "ch_pakistan_3_1_slum_alley_rat03" },
    { 0xCC57C202, "ch_pakistan_3_1_slum_alley_rat04" },
    { 0xD7B37C82, "ch_pakistan_3_2_fallen_building_harper_climb" },
    { 0x9F4526DB, "ch_pakistan_3_2_fallen_building_harper_exit" },
    { 0x5AB400DD, "ch_pakistan_3_2_fallen_building_harper_idle" },
    { 0x831698F7, "ch_pakistan_3_2_fallen_building_harper_idle02" },
    { 0x4BB4BC28, "ch_pakistan_3_2_fallen_building_harper_move" },
    { 0x809B6DB9, "ch_pakistan_3_3_hand_signals_a_harper" },
    { 0x0487FC60, "ch_pakistan_3_3_hand_signals_b_harper" },
    { 0x384404D3, "ch_pakistan_3_3_hand_signals_c_harper" },
    { 0x23648CA2, "ch_pakistan_3_3_hand_signals_d_harper" },
    { 0x335FD8FD, "ch_pakistan_3_3_hand_signals_e_harper" },
    { 0x4E2AF8CB, "ch_pakistan_3_3_hand_signals_run_harper" },
    { 0x216B9623, "ch_pakistan_3_5_sewer_entry_harper" },
    { 0x27C46B1E, "ch_pakistan_3_5_sewer_slide_harper" },
    { 0x2C0915C2, "ch_pakistan_5_10_cross_bridge_harper" },
    { 0x19EC3DF8, "ch_pakistan_5_10_jump_roll_enemy" },
    { 0x19EADFD2, "ch_pakistan_5_10_jump_roll_harper" },
    { 0xD8FE45E3, "ch_pakistan_5_10_wait_harper" },
    { 0x2D1EA17E, "ch_pakistan_5_11_approach_door_harper" },
    { 0x29244CF2, "ch_pakistan_5_11_close_door_harper" },
    { 0x57CF44E2, "ch_pakistan_5_11_contextual_melee_approach_harper" },
    { 0x223A5E38, "ch_pakistan_5_11_contextual_melee_idle_guard01" },
    { 0x9441CD73, "ch_pakistan_5_11_contextual_melee_idle_guard02" },
    { 0x7922B65C, "ch_pakistan_5_11_contextual_melee_idle_harper" },
    { 0x6BD2A11A, "ch_pakistan_5_11_contextual_melee_signal_harper" },
    { 0x7888A7E8, "ch_pakistan_5_11_idle_door_harper" },
    { 0x2EC426ED, "ch_pakistan_5_11_jump_down_attack_enemy_h_idle" },
    { 0x84FFBEE7, "ch_pakistan_5_11_jump_down_attack_enemy_h_kill" },
    { 0xB18791C5, "ch_pakistan_5_11_jump_down_attack_enemy_p_idle" },
    { 0x8986415F, "ch_pakistan_5_11_jump_down_attack_enemy_p_kill" },
    { 0x48ADBCFC, "ch_pakistan_5_11_jump_down_attack_harper_approach" },
    { 0xD0BDE8AE, "ch_pakistan_5_11_jump_down_attack_harper_idle" },
    { 0x4EAC0458, "ch_pakistan_5_11_jump_down_attack_harper_kill" },
    { 0xAA0D3A24, "ch_pakistan_5_13_get_closer_arrival_harper" },
    { 0x296FC688, "ch_pakistan_5_13_get_closer_defalco" },
    { 0xDBA425B9, "ch_pakistan_5_13_get_closer_exit_harper" },
    { 0x81BF6487, "ch_pakistan_5_13_get_closer_idle_harper" },
    { 0x6DEC1DAE, "ch_pakistan_5_13_get_closer_menendez" },
    { 0x8294A5CA, "ch_pakistan_5_14_millibar_defalco" },
    { 0xDCAA515C, "ch_pakistan_5_14_millibar_menendez" },
    { 0x90DC0E9F, "ch_pakistan_5_14_millibar_swim_harper" },
    { 0x349CB4CB, "ch_pakistan_5_14_millibar_swim_wait_harper" },
    { 0xD2D54B08, "ch_pakistan_5_1_grapple_device_harper" },
    { 0x666F21A9, "ch_pakistan_5_1_grapple_device_harper_idle" },
    { 0x26A7EC42, "ch_pakistan_5_1_grapple_device_harper_setup" },
    { 0x316C5FAA, "ch_pakistan_5_1_grapple_device_salazar" },
    { 0x15E632A8, "ch_pakistan_5_3_activity_below_btr_carport_guy01" },
    { 0x87EDA1E3, "ch_pakistan_5_3_activity_below_btr_carport_guy02" },
    { 0x3195BECD, "ch_pakistan_5_3_activity_below_btr_gate_entrance_guy01" },
    { 0x57983936, "ch_pakistan_5_3_activity_below_btr_gate_entrance_guy02" },
    { 0x7D9AB39F, "ch_pakistan_5_3_activity_below_btr_gate_entrance_guy03" },
    { 0x73895AC0, "ch_pakistan_5_3_activity_below_btr_gate_entrance_guy04" },
    { 0x998BD529, "ch_pakistan_5_3_activity_below_btr_gate_entrance_guy05" },
    { 0x8AAB207B, "ch_pakistan_5_3_activity_below_btr_gate_entrance_idle_guy02" },
    { 0xFCF26A08, "ch_pakistan_5_3_activity_below_crates_guy01" },
    { 0x6EF9D943, "ch_pakistan_5_3_activity_below_crates_guy02" },
    { 0x48F75EDA, "ch_pakistan_5_3_activity_below_crates_guy03" },
    { 0xBAFECE15, "ch_pakistan_5_3_activity_below_crates_guy04" },
    { 0x275883DD, "ch_pakistan_5_3_activity_below_storage_guy01" },
    { 0x4D5AFE46, "ch_pakistan_5_3_activity_below_storage_guy02" },
    { 0x735D78AF, "ch_pakistan_5_3_activity_below_storage_guy03" },
    { 0x694C1FD0, "ch_pakistan_5_3_activity_below_storage_guy04" },
    { 0x22C50025, "ch_pakistan_5_3_activity_below_tower_guy01" },
    { 0x48C77A8E, "ch_pakistan_5_3_activity_below_tower_guy02" },
    { 0x4E1EB721, "ch_pakistan_5_4_balcony_climb_harper" },
    { 0x6763C7AF, "ch_pakistan_5_4_balcony_crawl_harper" },
    { 0x35690DC1, "ch_pakistan_5_4_balcony_crouch_idle_harper" },
    { 0x155E322A, "ch_pakistan_5_4_balcony_prone_harper" },
    { 0x3B49B3D7, "ch_pakistan_5_4_confirm_menendez_exit_harper" },
    { 0x60AF07C0, "ch_pakistan_5_4_confirm_menendez_harper" },
    { 0x0E774FD5, "ch_pakistan_5_4_confirm_menendez_idle_harper" },
    { 0x0C38C0CC, "ch_pakistan_5_4_confirm_menendez_idle_leader" },
    { 0xF84617E5, "ch_pakistan_5_4_confirm_menendez_idle_menendez" },
    { 0xC8EC96A9, "ch_pakistan_5_4_confirm_menendez_leader" },
    { 0x5DA374D0, "ch_pakistan_5_4_confirm_menendez_menendez" },
    { 0xF9A79A8D, "ch_pakistan_5_4_drop_down_stealth_harper" },
    { 0x64E9467B, "ch_pakistan_5_4_leader_walk" },
    { 0xA72B8D7C, "ch_pakistan_5_4_menendez_walk" },
    { 0x5438429A, "ch_pakistan_5_4_patrol_guard_kill_approach_guard" },
    { 0xC214EFEC, "ch_pakistan_5_4_patrol_guard_kill_approach_guard2" },
    { 0x89239B25, "ch_pakistan_5_4_patrol_guard_kill_approach_harper" },
    { 0x402EA440, "ch_pakistan_5_4_patrol_guard_kill_idle_guard" },
    { 0xB5E87942, "ch_pakistan_5_4_patrol_guard_kill_idle_guard2" },
    { 0xDD3D4ABF, "ch_pakistan_5_4_patrol_guard_kill_idle_harper" },
    { 0x845E3193, "ch_pakistan_5_4_patrol_guard_kill_react_guard" },
    { 0x5FC3F2EB, "ch_pakistan_5_4_patrol_guard_kill_react_guard2" },
    { 0x2B4FBE0A, "ch_pakistan_5_4_patrol_guard_kill_react_harper" },
    { 0x88AEC4CF, "ch_pakistan_5_4_patrol_guard_kill_success_guard2" },
    { 0x0E2D7BEE, "ch_pakistan_5_4_patrol_guard_kill_success_harper" },
    { 0x90311B17, "ch_pakistan_5_4_slide_to_balcony_harper" },
    { 0x8884640A, "ch_pakistan_5_4_station_approach_harper" },
    { 0xDFF66C84, "ch_pakistan_5_4_station_doorclose_harper" },
    { 0x8F891AC2, "ch_pakistan_5_4_station_exit_harper" },
    { 0x3F34D524, "ch_pakistan_5_4_station_idle_harper" },
    { 0x60EB5120, "ch_pakistan_5_4_station_react_guard" },
    { 0x4697369B, "ch_pakistan_5_4_station_wait_harper" },
    { 0x494C0D60, "ch_pakistan_5_5_menendez_path_3_letleader" },
    { 0xEC5FB04E, "ch_pakistan_5_5_menendez_path_3_menendez" },
    { 0x040E317F, "ch_pakistan_5_7_meeting_defalco" },
    { 0xA97CA5CA, "ch_pakistan_5_7_meeting_exit_soldier04" },
    { 0xCF7F2033, "ch_pakistan_5_7_meeting_exit_soldier05" },
    { 0xFB8CFE96, "ch_pakistan_5_7_meeting_idle_defalco" },
    { 0x63D4CEC9, "ch_pakistan_5_7_meeting_idle_soldier01" },
    { 0x89D74932, "ch_pakistan_5_7_meeting_idle_soldier02" },
    { 0xAFD9C39B, "ch_pakistan_5_7_meeting_idle_soldier03" },
    { 0xD5DC3E04, "ch_pakistan_5_7_meeting_idle_soldier04" },
    { 0xFBDEB86D, "ch_pakistan_5_7_meeting_idle_soldier05" },
    { 0x21E132D6, "ch_pakistan_5_7_meeting_idle_soldier06" },
    { 0x47E3AD3F, "ch_pakistan_5_7_meeting_idle_soldier07" },
    { 0x10990909, "ch_pakistan_5_7_meeting_idle_talking01" },
    { 0x369B8372, "ch_pakistan_5_7_meeting_idle_talking02" },
    { 0x5C9DFDDB, "ch_pakistan_5_7_meeting_idle_talking03" },
    { 0x1E4A9256, "ch_pakistan_5_7_meeting_leader" },
    { 0xFB3553D7, "ch_pakistan_5_7_meeting_menendez" },
    { 0x3E23E57C, "ch_pakistan_5_7_meeting_soldier01" },
    { 0x6BC96310, "ch_pakistan_5_7_meeting_talking01" },
    { 0xDDD0D24B, "ch_pakistan_5_7_meeting_talking02" },
    { 0xB7CE57E2, "ch_pakistan_5_7_meeting_talking03" },
    { 0xD6176672, "ch_pakistan_5_8_drone_hide_arrival_harper" },
    { 0xAD64F907, "ch_pakistan_5_8_drone_hide_exit_harper" },
    { 0x22246045, "ch_pakistan_5_8_drone_hide_idle_harper" },
    { 0xA5031B83, "ch_pakistan_6_11_dismount_soct_driver" },
    { 0x7DFE62D0, "ch_pakistan_6_11_dismount_soct_gunner" },
    { 0x0495AF91, "ch_pakistan_6_11_mount_soct_harper" },
    { 0xB9FD8B12, "ch_pakistan_6_11_mount_soct_harper_idle" },
    { 0x38BF3A9D, "ch_pakistan_6_11_mount_soct_salazar" },
    { 0xE8D95343, "ch_pakistan_6_1_grenades_b_harper" },
    { 0xBE1064C0, "ch_pakistan_6_1_grenades_defalco" },
    { 0xD46034F2, "ch_pakistan_6_1_grenades_harper" },
    { 0x44BFC448, "ch_pakistan_6_1_grenades_idle_soldier01" },
    { 0xB6C73383, "ch_pakistan_6_1_grenades_idle_soldier02" },
    { 0x90C4B91A, "ch_pakistan_6_1_grenades_idle_soldier03" },
    { 0x02CC2855, "ch_pakistan_6_1_grenades_idle_soldier04" },
    { 0x83541916, "ch_pakistan_6_1_grenades_menendez" },
    { 0x3CB8B533, "ch_pakistan_6_1_grenades_soldier01" },
    { 0xCAB145F8, "ch_pakistan_6_1_grenades_soldier02" },
    { 0xF0B3C061, "ch_pakistan_6_1_grenades_soldier03" },
    { 0xAEC0246E, "ch_pakistan_6_1_grenades_soldier04" },
    { 0xD4C29ED7, "ch_pakistan_6_1_grenades_soldier05" },
    { 0x62BB2F9C, "ch_pakistan_6_1_grenades_soldier06" },
    { 0xD0BA8D65, "ch_pakistan_6_5_defend_area_harper" },
    { 0x2E056A6A, "ch_pakistan_6_5_dormant_claw_guy01" },
    { 0x0802F001, "ch_pakistan_6_5_dormant_claw_guy02" },
    { 0xE2007598, "ch_pakistan_6_5_dormant_claw_guy03" },
    { 0xEC11CE77, "ch_pakistan_6_5_dormant_claw_guy04" },
    { 0xB1BBA07F, "ch_pakistan_6_9_climb_out_harper" },
    { 0x7CF6E1D1, "ch_pakistan_7_1_drone_tutorial_billboard_guy01" },
    { 0xA2F95C3A, "ch_pakistan_7_1_drone_tutorial_billboard_guy02" },
    { 0xC8FBD6A3, "ch_pakistan_7_1_drone_tutorial_billboard_guy03" },
    { 0x986A20A6, "ch_pakistan_7_1_drone_tutorial_glass_building_soldier01" },
    { 0x7267A63D, "ch_pakistan_7_1_drone_tutorial_glass_building_soldier02" },
    { 0xA863B9E0, "ch_pakistan_7_1_drone_tutorial_lower_scaffolding_guy01" },
    { 0x1A6B291B, "ch_pakistan_7_1_drone_tutorial_lower_scaffolding_guy02" },
    { 0xD6D645F7, "ch_pakistan_7_1_drone_tutorial_pipe_building_guy01" },
    { 0xE66E9426, "ch_pakistan_7_1_drone_tutorial_scafold_guy01" },
    { 0xC06C19BD, "ch_pakistan_7_1_drone_tutorial_scafold_guy02" },
    { 0x9A699F54, "ch_pakistan_7_1_drone_tutorial_scafold_guy03" },
    { 0x746724EB, "ch_pakistan_7_1_drone_tutorial_scafold_guy04" },
    { 0x4E64AA82, "ch_pakistan_7_1_drone_tutorial_scafold_guy05" },
    { 0x28623019, "ch_pakistan_7_1_drone_tutorial_scafold_guy06" },
    { 0x025FB5B0, "ch_pakistan_7_1_drone_tutorial_scafold_guy07" },
    { 0x3C84E1D7, "ch_pakistan_7_1_drone_tutorial_scafold_guy08" },
    { 0x34B3AA53, "ch_pakistan_7_3_land_to_water_harper" },
    { 0x6B30AB5E, "ch_pakistan_7_3_land_to_water_redshirt" },
    { 0xD3217C27, "ch_pakistan_7_3_land_to_water_salazar" },
    { 0xF50FA7B7, "ch_pakistan_7_4_helo_crash_guy01" },
    { 0x8308387C, "ch_pakistan_7_4_helo_crash_guy02" },
    { 0x4BB402AC, "ch_pakistan_8_3_hangar_event_burned_harper" },
    { 0x055B1E03, "ch_pakistan_8_3_hangar_event_enemydriver" },
    { 0xDE566550, "ch_pakistan_8_3_hangar_event_enemygunner" },
    { 0xE689895B, "ch_pakistan_8_3_hangar_event_notburned_harper" },
    { 0xFE01375C, "ch_pakistan_8_3_hangar_event_redshirt" },
    { 0xCDA04D51, "ch_pakistan_8_3_hangar_event_salazar" },
    { 0xF40CFBD9, "ch_pakistan_9_4_harper_burned_walk" },
    { 0x0E8DEE58, "ch_pakistan_9_4_standoff_approach_burned_harper" },
    { 0x56909728, "ch_pakistan_9_4_standoff_approach_redshirt" },
    { 0xCC1BA295, "ch_pakistan_9_4_standoff_approach_salazar" },
    { 0x94DF6039, "ch_pakistan_9_4_standoff_approach_success_harper" },
    { 0x721B8881, "ch_pakistan_9_4_standoff_burned_harper" },
    { 0x6F795ED6, "ch_pakistan_9_4_standoff_burned_idle_harper" },
    { 0xD2590248, "ch_pakistan_9_4_standoff_chinese01" },
    { 0x44607183, "ch_pakistan_9_4_standoff_chinese02" },
    { 0x90EF0BC3, "ch_pakistan_9_4_standoff_idle_harper" },
    { 0x63E3376E, "ch_pakistan_9_4_standoff_idle_redshirt" },
    { 0x61810137, "ch_pakistan_9_4_standoff_idle_salazar" },
    { 0x79AE26AB, "ch_pakistan_9_4_standoff_redshirt" },
    { 0xCA7A62D0, "ch_pakistan_9_4_standoff_salazar" },
    { 0x36701B4B, "ch_pakistan_9_4_standoff_soldier_idle_chin01" },
    { 0xC468AC10, "ch_pakistan_9_4_standoff_soldier_idle_chin02" },
    { 0xEA6B2679, "ch_pakistan_9_4_standoff_soldier_idle_chin03" },
    { 0x558F4C7B, "ch_pakistan_9_4_standoff_soldier_idle_us01" },
    { 0xE387DD40, "ch_pakistan_9_4_standoff_soldier_idle_us02" },
    { 0x098A57A9, "ch_pakistan_9_4_standoff_soldier_idle_us03" },
    { 0xC0203FE0, "ch_pakistan_9_4_standoff_soldier_react_chin01" },
    { 0x3227AF1B, "ch_pakistan_9_4_standoff_soldier_react_chin02" },
    { 0x0C2534B2, "ch_pakistan_9_4_standoff_soldier_react_chin03" },
    { 0xDE06B4C4, "ch_pakistan_9_4_standoff_soldier_react_us01" },
    { 0x500E23FF, "ch_pakistan_9_4_standoff_soldier_react_us02" },
    { 0x2A0BA996, "ch_pakistan_9_4_standoff_soldier_react_us03" },
    { 0x72DE894A, "ch_pakistan_9_4_standoff_soldier_settle_chin01" },
    { 0x4CDC0EE1, "ch_pakistan_9_4_standoff_soldier_settle_chin02" },
    { 0x26D99478, "ch_pakistan_9_4_standoff_soldier_settle_chin03" },
    { 0xB76BAFD2, "ch_pakistan_9_4_standoff_soldier_settle_us01" },
    { 0x91693569, "ch_pakistan_9_4_standoff_soldier_settle_us02" },
    { 0x6B66BB00, "ch_pakistan_9_4_standoff_soldier_settle_us03" },
    { 0xF8B279C6, "ch_pakistan_9_4_standoff_zhao" },
    { 0x1F223764, "ch_pan_01_01_intro_argue_idle_jane" },
    { 0xCC5950BA, "ch_pan_01_01_intro_argue_idle_skinner" },
    { 0x65D8EFBE, "ch_pan_01_01_intro_drinking_idle_mason" },
    { 0x428B7956, "ch_pan_01_01_intro_drinking_idle_skinner" },
    { 0xBF925E96, "ch_pan_01_01_intro_frontdoor_jane" },
    { 0x6AC0BFE4, "ch_pan_01_01_intro_frontdoor_skinner" },
    { 0x93D5103B, "ch_pan_01_01_intro_frontyard_idle_mason" },
    { 0x672E130C, "ch_pan_01_01_intro_frontyard_mason" },
    { 0x68F0D19D, "ch_pan_01_01_intro_frontyard_mcknight" },
    { 0xE3A641CE, "ch_pan_01_01_intro_gate_b_idle_mason" },
    { 0xAEE4A506, "ch_pan_01_01_intro_gate_b_idle_skinner" },
    { 0x575846E7, "ch_pan_01_01_intro_gate_idle_mason" },
    { 0x5DA4C382, "ch_pan_01_01_intro_get_bag_mason" },
    { 0x186DB87A, "ch_pan_01_01_intro_get_bag_skinner" },
    { 0x3E0C4608, "ch_pan_01_01_intro_out_of_hummer_mason" },
    { 0x5A07CE67, "ch_pan_01_01_intro_tobackyard_dog" },
    { 0x86BF3C0F, "ch_pan_01_01_intro_tobackyard_mason" },
    { 0x9D80176B, "ch_pan_01_01_intro_tobackyard_skinner" },
    { 0x1A448A54, "ch_pan_01_01_intro_truck_driver" },
    { 0x77170D94, "ch_pan_01_01_intro_truck_passenger_01" },
    { 0xE91E7CCF, "ch_pan_01_01_intro_truck_passenger_02" },
    { 0xDCF1AAF5, "ch_pan_01_02_intro_gate_wait_mason" },
    { 0xCAD80E5D, "ch_pan_01_03_intro_backyard_enter_mason" },
    { 0xEA6BEFC2, "ch_pan_01_03_intro_backyard_enter_mcknight" },
    { 0x58D6A50F, "ch_pan_01_04_intro_backyard_wait_mason" },
    { 0xECA90D3C, "ch_pan_01_04_intro_backyard_wait_mcknight" },
    { 0xE4C3DC7E, "ch_pan_01_05_intro_get_bag_mason" },
    { 0xA1D73267, "ch_pan_01_05_intro_get_bag_mcknight" },
    { 0x13C22323, "ch_pan_01_05_intro_get_bag_player" },
    { 0x901630C1, "ch_pan_01_05_intro_get_bag_player_reflection" },
    { 0xE80D6261, "ch_pan_01_06_intro_backyard_leave_mason" },
    { 0x04922AE6, "ch_pan_01_06_intro_backyard_leave_mcknight" },
    { 0x0BB98694, "ch_pan_01_07_gringos_backguy1" },
    { 0x7DC0F5CF, "ch_pan_01_07_gringos_backguy2" },
    { 0xCE6F77AD, "ch_pan_01_07_gringos_driver" },
    { 0xCD1BC1F3, "ch_pan_01_07_gringos_mason" },
    { 0xF32EA560, "ch_pan_01_07_gringos_mcknight" },
    { 0xA46E8549, "ch_pan_01_07_gringos_passenger" },
    { 0xC96079A0, "ch_pan_01_07_gringos_player" },
    { 0xD800AA51, "ch_pan_01_07_gringos_tagger" },
    { 0x2C90B4FC, "ch_pan_01_07_intro_backyard_leave_wait_mason" },
    { 0x0C55E86D, "ch_pan_01_07_intro_backyard_leave_wait_mcknight" },
    { 0x4D4457E7, "ch_pan_02_01_beach_approach_mason" },
    { 0x39B4A6E1, "ch_pan_02_01_beach_approach_mason_dismount" },
    { 0x60316013, "ch_pan_02_01_beach_approach_seal_1_cycle" },
    { 0x5578DCDE, "ch_pan_02_01_beach_approach_seal_1_turn" },
    { 0x556A040C, "ch_pan_02_01_beach_approach_seal_2_cycle" },
    { 0x80A9FBD1, "ch_pan_02_01_beach_approach_seal_3_cycle" },
    { 0x2FC34178, "ch_pan_02_01_beach_approach_seal_3_turn" },
    { 0xB8BA0935, "ch_pan_02_01_zodiac_crew_idle_1" },
    { 0xDEBC839E, "ch_pan_02_01_zodiac_crew_idle_2" },
    { 0x04BEFE07, "ch_pan_02_01_zodiac_crew_idle_3" },
    { 0xFAADA528, "ch_pan_02_01_zodiac_crew_idle_4" },
    { 0x20B01F91, "ch_pan_02_01_zodiac_crew_idle_5" },
    { 0x46B299FA, "ch_pan_02_01_zodiac_crew_idle_6" },
    { 0x340B7F05, "ch_pan_02_03_guards_arguing_guard01" },
    { 0x5A0DF96E, "ch_pan_02_03_guards_arguing_guard02" },
    { 0x3C99DBEA, "ch_pan_02_03_guards_flareguy_killed" },
    { 0x0C19FCAF, "ch_pan_02_03_guards_flareguy_loop" },
    { 0xC63A5B43, "ch_pan_02_03_guards_flareguy_notkilled" },
    { 0x2718B30A, "ch_pan_02_03_guards_flareguy_walkout" },
    { 0x80C4D6B1, "ch_pan_02_03_guards_gaurd_01_loop" },
    { 0x4E9324E7, "ch_pan_02_03_guards_gaurd_01_walkup" },
    { 0x5F9FD188, "ch_pan_02_03_guards_gaurd_02_loop" },
    { 0x66567296, "ch_pan_02_03_guards_gaurd_03_button_loop" },
    { 0xAB1EEC36, "ch_pan_02_03_guards_gaurd_03_killed" },
    { 0xA25AB6B2, "ch_pan_02_03_guards_gaurd_03_lives" },
    { 0xF9E68233, "ch_pan_02_03_guards_gaurd_03_loop" },
    { 0x989D7A00, "ch_pan_02_03_guards_gaurd_in" },
    { 0x510EAD5F, "ch_pan_02_03_guards_guard01_button_loop" },
    { 0x456E77E5, "ch_pan_02_03_guards_guard01_grabbed" },
    { 0x50BD7EDA, "ch_pan_02_03_guards_guard01_no_kill" },
    { 0x33BBC423, "ch_pan_02_03_guards_killed_guard01" },
    { 0xC1B454E8, "ch_pan_02_03_guards_killed_guard02" },
    { 0x0A42FBC9, "ch_pan_02_03_guards_mason_approach_sewer" },
    { 0xFF1E86FC, "ch_pan_02_03_guards_mason_approach_sewer_exit" },
    { 0xDC096E4E, "ch_pan_02_03_guards_mason_approach_sewer_loop" },
    { 0x18078401, "ch_pan_02_03_guards_mason_approach_sewer_walks2back" },
    { 0x19DC75CE, "ch_pan_02_03_guards_mason_crawls" },
    { 0x83B4AEF7, "ch_pan_02_03_guards_mason_in" },
    { 0x60126C0D, "ch_pan_02_03_guards_mason_kills" },
    { 0x47646FE0, "ch_pan_02_03_guards_mason_loop" },
    { 0xB2F885CE, "ch_pan_02_03_guards_mason_reacts" },
    { 0x1B1DFD35, "ch_pan_02_03_guards_reaction_guard01" },
    { 0x4120779E, "ch_pan_02_03_guards_reaction_guard02" },
    { 0x1150ABFB, "ch_pan_02_03_mantle_cliff_mason" },
    { 0x3141F858, "ch_pan_02_04_unloading_guy1_loop" },
    { 0x36F03107, "ch_pan_02_04_unloading_guy1_reaction" },
    { 0xBF1B3FC1, "ch_pan_02_04_unloading_guy2_loop" },
    { 0x1829BB0E, "ch_pan_02_04_unloading_guy2_reaction" },
    { 0xF1575A64, "ch_pan_02_07_bravo_assist_seal_injured_3" },
    { 0xEACC276E, "ch_pan_02_07_bravo_assist_seal_injured_3_dies" },
    { 0xA5526592, "ch_pan_02_07_bravo_assist_seal_injured_5" },
    { 0x93729CE7, "ch_pan_02_07_bravo_assist_seal_injured_8" },
    { 0x5478C413, "ch_pan_02_07_bravo_assist_seal_injured_8_dies" },
    { 0x292AFA90, "ch_pan_02_07_bravo_assist_seal_rescue_1" },
    { 0x1FACFDAA, "ch_pan_02_07_bravo_assist_seal_rescue_1_dies" },
    { 0x9B3269CB, "ch_pan_02_07_bravo_assist_seal_rescue_2" },
    { 0x9B2FE297, "ch_pan_02_07_bravo_assist_seal_rescue_2_dies" },
    { 0xE7375E9D, "ch_pan_02_07_bravo_assist_seal_rescue_4" },
    { 0x1C80EEBD, "ch_pan_02_07_fence_kick_mason" },
    { 0xC366A630, "ch_pan_02_07_golf_team_guy_01" },
    { 0x356E156B, "ch_pan_02_07_golf_team_guy_02" },
    { 0x0F6B9B02, "ch_pan_02_07_golf_team_guy_03" },
    { 0x81730A3D, "ch_pan_02_07_golf_team_guy_04" },
    { 0x5B708FD4, "ch_pan_02_07_golf_team_guy_05" },
    { 0xCD77FF0F, "ch_pan_02_07_golf_team_guy_06" },
    { 0x81ECE502, "ch_pan_02_07_hangar_ladder_enter_mason" },
    { 0x6C1A8976, "ch_pan_02_07_hangar_ladder_exit_mason" },
    { 0xE7F49588, "ch_pan_02_07_hangar_ladder_loop_mason" },
    { 0x02C7887E, "ch_pan_02_07_hangar_ladder_soldier_loop" },
    { 0xF3EC325D, "ch_pan_02_07_hangar_ladder_soldier_reaction" },
    { 0xD4508A20, "ch_pan_02_07_seal_encounter_mason" },
    { 0x27C29AB9, "ch_pan_02_07_seal_encounter_seal_01" },
    { 0x4DC51522, "ch_pan_02_07_seal_encounter_seal_02" },
    { 0xCBFF69C1, "ch_pan_02_07_standoff_seal_07" },
    { 0x59F7FA86, "ch_pan_02_07_standoff_seal_08" },
    { 0x4ECD578D, "ch_pan_02_08_rooftop_slide_guy01" },
    { 0x74CFD1F6, "ch_pan_02_08_rooftop_slide_guy02" },
    { 0x47F261A2, "ch_pan_02_08_skylight_approach_mason" },
    { 0xE4CFEBD8, "ch_pan_02_08_skylight_entry_mason" },
    { 0xDD13C0BC, "ch_pan_02_08_skylight_loop_mason" },
    { 0x6E826604, "ch_pan_02_09_door_kick_door" },
    { 0x40A17496, "ch_pan_02_09_door_kick_mason" },
    { 0x2B37444D, "ch_pan_02_09_hangar_door_reactions_1" },
    { 0x5139BEB6, "ch_pan_02_09_hangar_door_reactions_2" },
    { 0x773C391F, "ch_pan_02_09_hangar_door_reactions_3" },
    { 0xF19EA014, "ch_pan_02_10_shoulder_bash_mason" },
    { 0xC6C7F42A, "ch_pan_02_11_seal_hangar_entry_seal01" },
    { 0xA0C579C1, "ch_pan_02_11_seal_hangar_entry_seal02" },
    { 0x7AC2FF58, "ch_pan_02_11_seal_hangar_entry_seal03" },
    { 0x84D45837, "ch_pan_02_11_seal_hangar_entry_seal04" },
    { 0xBDFE1F88, "ch_pan_02_11_seals_breaching_guy01" },
    { 0x30058EC3, "ch_pan_02_11_seals_breaching_guy02" },
    { 0x73ED40DE, "ch_pan_02_12_door_bash_mason" },
    { 0x272C079A, "ch_pan_02_12_door_close_pdf" },
    { 0xC5E0ED01, "ch_pan_02_12_leerjet_battle_pdf" },
    { 0x1067CBDE, "ch_pan_02_12_leerjet_battle_seal" },
    { 0xB25B2A3D, "ch_pan_02_12_leerjet_battle_seal_rocket" },
    { 0xBFF87859, "ch_pan_02_12_pool_death_guy_1" },
    { 0xE5FAF2C2, "ch_pan_02_12_pool_death_guy_2" },
    { 0x2143C09A, "ch_pan_02_12_rolling_door_guy_1" },
    { 0xFB414631, "ch_pan_02_12_rolling_door_guy_2" },
    { 0x0D1322B5, "ch_pan_03_01_noriegas_room_approach_mason" },
    { 0x321D7172, "ch_pan_03_01_noriegas_room_approach_mason_loop" },
    { 0xAEB5A830, "ch_pan_03_01_noriegas_room_breach_guy01" },
    { 0x20BD176B, "ch_pan_03_01_noriegas_room_breach_guy02" },
    { 0xFABA9D02, "ch_pan_03_01_noriegas_room_breach_guy03" },
    { 0x8CD8D95A, "ch_pan_03_01_noriegas_room_breach_mason" },
    { 0x0C53FC37, "ch_pan_03_01_noriegas_room_breach_noriega" },
    { 0xAC2A716F, "ch_pan_03_01_noriegas_room_breach_player" },
    { 0x10AFDB34, "ch_pan_03_01_noriegas_room_mason" },
    { 0x6D0342AD, "ch_pan_03_01_noriegas_room_noriega" },
    { 0x0F1A3525, "ch_pan_03_01_noriegas_room_player" },
    { 0x97581837, "ch_pan_03_01_old_friends_guy_1_custom_death" },
    { 0x998E41B5, "ch_pan_03_01_old_friends_guy_1_intro" },
    { 0x98F4C7DF, "ch_pan_03_01_old_friends_guy_2_dead_loop" },
    { 0xF9323E32, "ch_pan_03_01_old_friends_guy_2_intro" },
    { 0x397CA69C, "ch_pan_03_01_old_friends_guy_2_shot" },
    { 0x954E76BC, "ch_pan_03_01_old_friends_guy_3_death_loop" },
    { 0x82CD72AB, "ch_pan_03_01_old_friends_guy_3_intro" },
    { 0xF22F835C, "ch_pan_03_01_old_friends_mason_approach" },
    { 0x470EB491, "ch_pan_03_01_old_friends_mason_door_loop" },
    { 0x2BCF38BE, "ch_pan_03_01_old_friends_mason_intro" },
    { 0xAD3CF267, "ch_pan_03_01_old_friends_noriega_intro" },
    { 0x3B168AD4, "ch_pan_03_01_old_friends_noriega_intro_loop" },
    { 0x3DE26F50, "ch_pan_03_01_old_friends_supprise_enemy_intro" },
    { 0x0661FF4A, "ch_pan_03_01_old_friends_supprise_enemy_shot" },
    { 0xE7B244C3, "ch_pan_03_01_old_friends_supprise_enemy_shot_loop" },
    { 0x14A80D83, "ch_pan_03_01_xcool_mason" },
    { 0x13C15A8E, "ch_pan_03_01_xcool_noriega" },
    { 0x7EFD33AB, "ch_pan_03_01_xcool_pizza_guy" },
    { 0xA337814E, "ch_pan_04_01_intro_civ_2_dead_loop" },
    { 0xC21C5E50, "ch_pan_04_01_intro_civ_fight" },
    { 0x82EFBB81, "ch_pan_04_01_intro_dig_bat_beatdown_loop" },
    { 0x372D21D2, "ch_pan_04_01_intro_dig_bat_fight" },
    { 0x1B24F746, "ch_pan_04_01_intro_mason_approach" },
    { 0x5C5EF2A5, "ch_pan_04_01_intro_mason_approach_cycle" },
    { 0x5A5849B1, "ch_pan_04_01_intro_noriaga_approach" },
    { 0xF58CB806, "ch_pan_04_01_intro_noriaga_approach_cycle" },
    { 0x3988878D, "ch_pan_04_02_amblulance_dead_civ_1" },
    { 0x5F8B01F6, "ch_pan_04_02_amblulance_dead_civ_2" },
    { 0xA6821578, "ch_pan_04_02_amblulance_digbat_1_beating" },
    { 0xBF4D8774, "ch_pan_04_02_amblulance_digbat_1_killing" },
    { 0xBBCDDCD5, "ch_pan_04_02_amblulance_digbat_1_reaction" },
    { 0xDB78BA13, "ch_pan_04_02_amblulance_digbat_2_beating" },
    { 0xF56EF34F, "ch_pan_04_02_amblulance_digbat_2_killing" },
    { 0x7068A9C0, "ch_pan_04_02_amblulance_digbat_2_reaction" },
    { 0x6C54619A, "ch_pan_04_02_amblulance_digbat_3_beating" },
    { 0x02A7F7A6, "ch_pan_04_02_amblulance_digbat_3_killing" },
    { 0x0B490907, "ch_pan_04_02_amblulance_digbat_3_reaction" },
    { 0x512A404C, "ch_pan_04_02_amblulance_doc_1_beaten" },
    { 0xD86AB429, "ch_pan_04_02_amblulance_doc_1_death" },
    { 0x7DA08EBF, "ch_pan_04_02_amblulance_doc_1_loop" },
    { 0xCDD7B44E, "ch_pan_04_02_amblulance_doc_1_saved" },
    { 0x48942E0D, "ch_pan_04_02_amblulance_doc_2_beaten" },
    { 0x061AD5EE, "ch_pan_04_02_amblulance_doc_2_death" },
    { 0xDE115B12, "ch_pan_04_02_amblulance_doc_2_loop" },
    { 0x833736D9, "ch_pan_04_02_amblulance_doc_2_saved" },
    { 0xEBA0E2E3, "ch_pan_04_02_amblulance_nurse_beaten" },
    { 0x66C828D8, "ch_pan_04_02_amblulance_nurse_death" },
    { 0x61A45F18, "ch_pan_04_02_amblulance_nurse_loop" },
    { 0x02D116BB, "ch_pan_04_02_amblulance_nurse_saved" },
    { 0x855FFA24, "ch_pan_04_02_civs_building_civ_01" },
    { 0xF767695F, "ch_pan_04_02_civs_building_civ_02" },
    { 0xD164EEF6, "ch_pan_04_02_civs_building_civ_03" },
    { 0x13588AE9, "ch_pan_04_02_civs_building_civ_04" },
    { 0xED561080, "ch_pan_04_02_civs_building_civ_05" },
    { 0x5F5D7FBB, "ch_pan_04_02_civs_building_civ_06" },
    { 0xC092E76D, "ch_pan_04_03_to_building_mason" },
    { 0x4C479C33, "ch_pan_04_03_to_building_mason_wait" },
    { 0x8C9AC344, "ch_pan_04_03_to_building_noriega" },
    { 0x2AF25D4C, "ch_pan_04_03_to_building_noriega_wait" },
    { 0x8894D76B, "ch_pan_05_01_into_noriega" },
    { 0xEF62EF00, "ch_pan_05_01_into_noriega_loop" },
    { 0xB37A35F8, "ch_pan_05_01_intro_mason" },
    { 0x5F95C881, "ch_pan_05_01_intro_mason_loop" },
    { 0xB469A20B, "ch_pan_05_01_noriega_pistol_mason" },
    { 0xB3F4D1F5, "ch_pan_05_01_noriega_pistol_mason_wait" },
    { 0xEEDE9016, "ch_pan_05_01_noriega_pistol_noriega" },
    { 0x533FE8EA, "ch_pan_05_01_noriega_pistol_noriega_wait" },
    { 0xFAA553C1, "ch_pan_05_15_dumpster_push_pdf01" },
    { 0x20A7CE2A, "ch_pan_05_15_dumpster_push_pdf02" },
    { 0x46AA4893, "ch_pan_05_15_dumpster_push_pdf03" },
    { 0x772E95B5, "ch_pan_05_19_molotov_throw_digbat" },
    { 0x27293045, "ch_pan_05_21_apt_rummage_loop_digbat01" },
    { 0x4D2BAAAE, "ch_pan_05_21_apt_rummage_loop_digbat02" },
    { 0x732E2517, "ch_pan_05_21_apt_rummage_loop_digbat03" },
    { 0xCBD0D934, "ch_pan_05_21_apt_rummage_reaction_digbat01" },
    { 0x3DD8486F, "ch_pan_05_21_apt_rummage_reaction_digbat02" },
    { 0x17D5CE06, "ch_pan_05_21_apt_rummage_reaction_digbat03" },
    { 0xE84EE840, "ch_pan_05_22_beaten_corpse" },
    { 0x337BE6D5, "ch_pan_05_22_beating_loop_digbat" },
    { 0x6EF705A8, "ch_pan_05_22_beating_reaction_digbat" },
    { 0xE94AA317, "ch_pan_05_23_parking_jump_digbat01" },
    { 0x774333DC, "ch_pan_05_23_parking_jump_digbat02" },
    { 0x650FF44A, "ch_pan_05_cover_barrel_mason" },
    { 0xE2F659E7, "ch_pan_05_cover_barrel_noriega" },
    { 0x3C371E3D, "ch_pan_05_cover_car_enter_mason" },
    { 0x99ACE814, "ch_pan_05_cover_car_enter_noriega" },
    { 0xEF3421A3, "ch_pan_05_cover_car_exit_mason" },
    { 0x19213EAE, "ch_pan_05_cover_car_exit_noriega" },
    { 0x70EE1081, "ch_pan_05_cover_car_idle_mason" },
    { 0x6FB5E9D0, "ch_pan_05_cover_car_idle_noriega" },
    { 0x449B5624, "ch_pan_05_cover_stairs_mason" },
    { 0x5078F71D, "ch_pan_05_cover_stairs_noriega" },
    { 0x557FCF9E, "ch_pan_05_cover_wall_mason" },
    { 0x2399E193, "ch_pan_05_cover_wall_noriega" },
    { 0xBA83134D, "ch_pan_06_02_clinic_walkthru_mason_door2_idl1" },
    { 0xC55801E6, "ch_pan_06_02_clinic_walkthru_mason_endidl_v1" },
    { 0xF46F682A, "ch_pan_06_02_clinic_walkthru_mason_entry" },
    { 0x50FFEA14, "ch_pan_06_02_clinic_walkthru_mason_idl1" },
    { 0xC307594F, "ch_pan_06_02_clinic_walkthru_mason_idl2" },
    { 0xE99E9C05, "ch_pan_06_02_clinic_walkthru_mason_move2_idl2" },
    { 0x2FEA1C49, "ch_pan_06_02_clinic_walkthru_mason_path_v1" },
    { 0x3B8D627F, "ch_pan_06_02_clinic_walkthru_mason_startidl" },
    { 0xD9389BDE, "ch_pan_06_02_clinic_walkthru_noriega_door2_idl1" },
    { 0x0B47D54F, "ch_pan_06_02_clinic_walkthru_noriega_endidl_v1" },
    { 0x0EDAF5B7, "ch_pan_06_02_clinic_walkthru_noriega_entry" },
    { 0xD009BCBF, "ch_pan_06_02_clinic_walkthru_noriega_idl1" },
    { 0x5E024D84, "ch_pan_06_02_clinic_walkthru_noriega_idl2" },
    { 0x560F0446, "ch_pan_06_02_clinic_walkthru_noriega_move2_idl2" },
    { 0x20781BB4, "ch_pan_06_02_clinic_walkthru_noriega_path_v1" },
    { 0x55B7AFB8, "ch_pan_06_02_clinic_walkthru_noriega_startidl" },
    { 0xEA98DA52, "ch_pan_06_03_crying_woman_woman" },
    { 0x22CD0BFB, "ch_pan_06_04_digbat_tackle_digbat" },
    { 0x4CE69FF4, "ch_pan_06_04_digbat_tackle_mason" },
    { 0xE072396D, "ch_pan_06_04_digbat_tackle_noriega" },
    { 0x46D65ADF, "ch_pan_06_05_digbat_defense_digbat01" },
    { 0xD4CEEBA4, "ch_pan_06_05_digbat_defense_digbat02" },
    { 0xFAD1660D, "ch_pan_06_05_digbat_defense_digbat03" },
    { 0x88C9F6D2, "ch_pan_06_05_digbat_defense_digbat04" },
    { 0xAECC713B, "ch_pan_06_05_digbat_defense_digbat05" },
    { 0x3CC50200, "ch_pan_06_05_digbat_defense_digbat06" },
    { 0x62C77C69, "ch_pan_06_05_digbat_defense_digbat07" },
    { 0x66729B49, "ch_pan_06_06_digbat_defend_recover_mason" },
    { 0x09E1A565, "ch_pan_06_06_digbat_defend_recover_woman" },
    { 0xDDB75A48, "ch_pan_06_08_stairwell_mason_climb_stairs" },
    { 0x78C850AC, "ch_pan_06_08_stairwell_mason_endidl" },
    { 0x0407A90C, "ch_pan_06_08_stairwell_mason_enter_normal" },
    { 0xDA310895, "ch_pan_06_08_stairwell_mason_under_fire" },
    { 0x1C51274A, "ch_pan_07_01_fight_mason" },
    { 0x850244E7, "ch_pan_07_01_fight_noriega" },
    { 0x7774B47B, "ch_pan_07_01_fight_soldier1" },
    { 0x056D4540, "ch_pan_07_01_fight_soldier2" },
    { 0x343F76A3, "ch_pan_07_01_help_noriega_guy01" },
    { 0x085798FD, "ch_pan_07_01_help_noriega_guy01_wait" },
    { 0xC2380768, "ch_pan_07_01_help_noriega_guy02" },
    { 0x23C81585, "ch_pan_07_01_help_noriega_mason" },
    { 0xDBCECD3B, "ch_pan_07_01_help_noriega_mason_wait" },
    { 0xBCDE63BC, "ch_pan_07_01_help_noriega_noriega" },
    { 0x44409005, "ch_pan_07_01_help_noriega_noriega_idle" },
    { 0x1F0BA734, "ch_pan_07_01_help_noriega_noriega_wait" },
    { 0x24B2BD2E, "ch_pan_07_01_help_noriega_player" },
    { 0x80CD8D45, "ch_pan_07_02_rescue_noriega_hangidl" },
    { 0x9E788D8C, "ch_pan_07_02_rescue_soldier1_deadloop" },
    { 0x26113D87, "ch_pan_07_03_apache_attack_mason" },
    { 0x46E2E4AA, "ch_pan_07_03_apache_attack_noriega" },
    { 0x7B006914, "ch_pan_07_03_wall_hug_guy_01" },
    { 0x74254075, "ch_pan_07_03_wall_hug_guy_01_loop" },
    { 0xED07D84F, "ch_pan_07_03_wall_hug_guy_02" },
    { 0x189754EC, "ch_pan_07_03_wall_hug_guy_02_loop" },
    { 0xA207DDF0, "ch_pan_07_04_jump_mason_jump" },
    { 0x08BFE2A7, "ch_pan_07_04_jump_noriega_jump" },
    { 0xA6DC0A98, "ch_pan_07_04_jump_noriega_run2door" },
    { 0xD862D38A, "ch_pan_07_09_checkpoint_gateb_guard1" },
    { 0xB2605921, "ch_pan_07_09_checkpoint_gateb_guard2" },
    { 0x8C5DDEB8, "ch_pan_07_09_checkpoint_gateb_guard3" },
    { 0xB146B746, "ch_pan_07_09_checkpoint_guard2_advance" },
    { 0x464F3D2C, "ch_pan_07_09_checkpoint_guard2_cleared" },
    { 0xEBFD7A5C, "ch_pan_07_09_checkpoint_guard2_endidl" },
    { 0xF926AF94, "ch_pan_07_09_checkpoint_husband_pleading" },
    { 0xA88F7E9D, "ch_pan_07_09_checkpoint_husband_pleading_idle" },
    { 0xB290FD5D, "ch_pan_07_09_checkpoint_lineup_girl1" },
    { 0x22F48BE9, "ch_pan_07_09_checkpoint_lineup_girl1_idl" },
    { 0xD89377C6, "ch_pan_07_09_checkpoint_lineup_girl2" },
    { 0xAE04AE96, "ch_pan_07_09_checkpoint_lineup_girl2_idl" },
    { 0xEE815FC4, "ch_pan_07_09_checkpoint_lineup_guy1" },
    { 0x8B884EE0, "ch_pan_07_09_checkpoint_lineup_guy1_idl" },
    { 0x6088CEFF, "ch_pan_07_09_checkpoint_lineup_guy2" },
    { 0xB9F17197, "ch_pan_07_09_checkpoint_lineup_guy2_idl" },
    { 0x589EBC85, "ch_pan_07_09_checkpoint_lineup_soldier1" },
    { 0x53A81A41, "ch_pan_07_09_checkpoint_lineup_soldier1_idl" },
    { 0xBD0AF90A, "ch_pan_07_09_checkpoint_mason_startidl" },
    { 0xA5AD2C38, "ch_pan_07_09_checkpoint_medical_guy1" },
    { 0x17B49B73, "ch_pan_07_09_checkpoint_medical_guy2" },
    { 0xF1B2210A, "ch_pan_07_09_checkpoint_medical_guy3" },
    { 0x63B99045, "ch_pan_07_09_checkpoint_medical_guy4" },
    { 0x0E9CA025, "ch_pan_07_09_checkpoint_noriega_startidl" },
    { 0x55D03D80, "ch_pan_07_09_checkpoint_patrol_soldier1" },
    { 0xC7D7ACBB, "ch_pan_07_09_checkpoint_patrol_soldier2" },
    { 0xA1D53252, "ch_pan_07_09_checkpoint_patrol_soldier3" },
    { 0x02A0EBEA, "ch_pan_07_09_checkpoint_patrol_soldier3_idl" },
    { 0x84CE37E1, "ch_pan_07_09_checkpoint_sitgroup_girl1" },
    { 0xAAD0B24A, "ch_pan_07_09_checkpoint_sitgroup_girl2" },
    { 0x959B04C0, "ch_pan_07_09_checkpoint_sitgroup_guy1" },
    { 0x07A273FB, "ch_pan_07_09_checkpoint_sitgroup_guy2" },
    { 0xE19FF992, "ch_pan_07_09_checkpoint_sitgroup_guy3" },
    { 0xB43FB9E1, "ch_pan_07_09_checkpoint_sitgroup_soldier1" },
    { 0xF07627BC, "ch_pan_07_09_checkpoint_soldiers_rest_1" },
    { 0x627D96F7, "ch_pan_07_09_checkpoint_soldiers_rest_2" },
    { 0x3C7B1C8E, "ch_pan_07_09_checkpoint_soldiers_rest_3" },
    { 0x7E6EB881, "ch_pan_07_09_checkpoint_soldiers_rest_4" },
    { 0x756A3F80, "ch_pan_07_09_checkpoint_tieup_guy1" },
    { 0x6991BC14, "ch_pan_07_09_checkpoint_tieup_guy1_idl" },
    { 0x48A697A1, "ch_pan_07_09_checkpoint_tieup_soldier1" },
    { 0x26DAEF15, "ch_pan_07_09_checkpoint_tieup_soldier1_idl" },
    { 0x6EA9120A, "ch_pan_07_09_checkpoint_tieup_soldier2" },
    { 0x8D198FF2, "ch_pan_07_09_checkpoint_tieup_soldier2_idl" },
    { 0x94AB8C73, "ch_pan_07_09_checkpoint_tieup_soldier3" },
    { 0x06676B6A, "ch_pan_07_09_checkpoint_wife_dead" },
    { 0x13F6BC3B, "ch_pan_07_09_checkpoint_wife_dead_idle" },
    { 0x7FE4F320, "ch_pan_07_09_slums_checkpoint_guard" },
    { 0xD19743D9, "ch_pan_07_09_slums_checkpoint_guard_loop" },
    { 0x9BA5961D, "ch_pan_07_09_slums_checkpoint_mason" },
    { 0xB149A2F4, "ch_pan_07_09_slums_checkpoint_noriega" },
    { 0x5EC9FE26, "ch_pan_07_09_slums_checkpoint_player" },
    { 0x4FC3C1C1, "ch_pan_08_01_jeepride_guy01" },
    { 0x15FE6996, "ch_pan_08_01_jeepride_guy01_cycle" },
    { 0x61179193, "ch_pan_08_01_jeepride_guy01_end" },
    { 0xC9AA055E, "ch_pan_08_06_elevator_approach_noriega" },
    { 0xC9082858, "ch_pan_08_06_elevator_enter_noriega" },
    { 0x7265FE2A, "ch_pan_08_06_elevator_exit_noriega" },
    { 0xA0D7A6A4, "ch_pan_08_06_elevator_idle_noriega" },
    { 0x91B057D8, "ch_pan_08_06_take_the_shot_guy01" },
    { 0x4801ECB9, "ch_pan_08_06_take_the_shot_guy01_idle" },
    { 0xE14DF03F, "ch_pan_08_06_take_the_shot_noriega" },
    { 0x0EF249FC, "ch_pan_08_06_take_the_shot_noriega_loop" },
    { 0xD90468D9, "ch_pan_08_06_take_the_shot_noriega_wait" },
    { 0x4FAC5257, "ch_pan_08_06_take_the_shot_player" },
    { 0x4C28A430, "ch_pan_08_07_sniper_guard1_injured_last_shot" },
    { 0x60DE59BD, "ch_pan_08_07_sniper_guard1_injured_shot" },
    { 0x442CFE54, "ch_pan_08_07_sniper_guard1_secondidl" },
    { 0xBF9F371F, "ch_pan_08_07_sniper_guard1_shot" },
    { 0x83FAC040, "ch_pan_08_07_sniper_guard1_walk" },
    { 0xBE2D8237, "ch_pan_08_07_sniper_guard2_injured_last_shot" },
    { 0x2BE59AC0, "ch_pan_08_07_sniper_guard2_injured_shot" },
    { 0x26019E0F, "ch_pan_08_07_sniper_guard2_secondidl" },
    { 0xB32FBAE6, "ch_pan_08_07_sniper_guard2_shot" },
    { 0x3CDAB9A9, "ch_pan_08_07_sniper_guard2_walk" },
    { 0xE0CB0EA5, "ch_pan_08_07_sniper_loop_guard1" },
    { 0x06CD890E, "ch_pan_08_07_sniper_loop_guard2" },
    { 0xB15FABF1, "ch_pan_08_07_sniper_loop_mason" },
    { 0xF79EFCCA, "ch_pan_08_07_sniper_mason_injured_last_shot" },
    { 0x2E36D4CB, "ch_pan_08_07_sniper_mason_injured_shot" },
    { 0x1A3D664E, "ch_pan_08_07_sniper_mason_secondidl" },
    { 0x606B4695, "ch_pan_08_07_sniper_mason_shot" },
    { 0x67975596, "ch_pan_08_07_sniper_mason_walk" },
    { 0xA07B6BA4, "ch_pan_09_01_betrayed_1_mason" },
    { 0xC45012F0, "ch_pan_09_01_betrayed_1_menendez" },
    { 0xF4A0C89D, "ch_pan_09_01_betrayed_1_noriega" },
    { 0xB4C3730F, "ch_pan_09_01_betrayed_2_mason" },
    { 0xDA620FD9, "ch_pan_09_01_betrayed_2_menendez" },
    { 0x81CBDED2, "ch_pan_09_01_betrayed_2_noriega" },
    { 0x146714EA, "ch_pan_10_01_end_1_hudson" },
    { 0x64841CC7, "ch_pan_10_01_end_1_masonjr" },
    { 0xC479CD10, "ch_pan_10_01_end_1_masonsr" },
    { 0xB82A85A9, "ch_pan_10_01_end_1_menendez" },
    { 0x07BED087, "ch_pan_10_01_end_1_woods" },
    { 0xFE5EB71B, "ch_pan_10_01_end_2_hudson" },
    { 0x64E18E70, "ch_pan_10_01_end_2_masonjr" },
    { 0x02717527, "ch_pan_10_01_end_2_masonsr" },
    { 0x50C0C340, "ch_pan_10_01_end_2_menendez" },
    { 0x58B7CEF4, "ch_pan_10_01_end_2_woods" },
    { 0x16BDDCB0, "ch_pan_10_01_end_3_hudson" },
    { 0x743B9291, "ch_pan_10_01_end_3_masonjr" },
    { 0xA6D01282, "ch_pan_10_01_end_3_masonsr" },
    { 0x32F592D7, "ch_pan_10_01_end_3_menendez" },
    { 0x18EC535D, "ch_pan_10_01_end_3_woods" },
    { 0x52A18C2A, "ch_pel1_crawling_loco_guy1" },
    { 0x68C694AD, "ch_pel1_crawling_natural_death_guy1" },
    { 0xD5D61B07, "ch_pel1_crawling_violent_death_guy1" },
    { 0x6E3F06D2, "ch_phase4_pakistan_no_intel_briggs" },
    { 0xA5F5707E, "ch_progress" },
    { 0xD8E8E392, "ch_ref" },
    { 0xA389485B, "ch_reset_alive_challenges" },
    { 0x6AD84A37, "ch_revives" },
    { 0x4D51B42C, "ch_roundplayed" },
    { 0x249A9185, "ch_roundwin" },
    { 0x81866895, "ch_sacotra_intro_cavalry1" },
    { 0xA788E2FE, "ch_sacotra_intro_cavalry2" },
    { 0xCD8B5D67, "ch_sacotra_intro_cavalry3" },
    { 0xE7CDCC96, "ch_sacotra_intro_chk_civ1" },
    { 0xC1CB522D, "ch_sacotra_intro_chk_civ2" },
    { 0x9BC8D7C4, "ch_sacotra_intro_chk_civ3" },
    { 0x75C65D5B, "ch_sacotra_intro_chk_civ4" },
    { 0x4FC3E2F2, "ch_sacotra_intro_chk_civ5" },
    { 0x29C16889, "ch_sacotra_intro_chk_civ6" },
    { 0x03BEEE20, "ch_sacotra_intro_chk_civ7" },
    { 0x6C927ABE, "ch_sacotra_intro_seal1" },
    { 0xC90E2CCA, "ch_sacotra_intro_seal10" },
    { 0xEF10A733, "ch_sacotra_intro_seal11" },
    { 0x46900055, "ch_sacotra_intro_seal2" },
    { 0x208D85EC, "ch_sacotra_intro_seal3" },
    { 0xFA8B0B83, "ch_sacotra_intro_seal4" },
    { 0xD488911A, "ch_sacotra_intro_seal5" },
    { 0xAE8616B1, "ch_sacotra_intro_seal6" },
    { 0x88839C48, "ch_sacotra_intro_seal7" },
    { 0x628121DF, "ch_sacotra_intro_seal8" },
    { 0x3C7EA776, "ch_sacotra_intro_seal9" },
    { 0x17D4B4FF, "ch_sacotra_intro_sqd1" },
    { 0xA5CD45C4, "ch_sacotra_intro_sqd2" },
    { 0xD9EBE21A, "ch_sacotra_karma_rescue_karma" },
    { 0x51C1CB6B, "ch_sacotra_karma_rescue_karma_idle" },
    { 0x2FB3531F, "ch_sacotra_outro_helper" },
    { 0x0B2192DD, "ch_sacotra_outro_karma" },
    { 0xDCEE1F0A, "ch_sacotra_outro_sniper" },
    { 0xEF96DB1E, "ch_sacotra_outro_sqd1" },
    { 0xC99460B5, "ch_sacotra_outro_sqd2" },
    { 0x441397D3, "ch_secservice_01" },
    { 0xD20C2898, "ch_secservice_02" },
    { 0x124303E4, "ch_singapore_1_intro_guy_1" },
    { 0x844A731F, "ch_singapore_1_intro_guy_2" },
    { 0x5E47F8B6, "ch_singapore_1_intro_guy_3" },
    { 0xAA45C54C, "ch_singapore_1_intro_overlord" },
    { 0x1B8E8F4D, "ch_singapore_brf_briggs" },
    { 0x12CF89D6, "ch_singapore_brf_troop1" },
    { 0xECCD0F6D, "ch_singapore_brf_troop2" },
    { 0xC6CA9504, "ch_singapore_brf_troop3" },
    { 0xA0C81A9B, "ch_singapore_brf_troop4" },
    { 0x7AC5A032, "ch_singapore_brf_troop5" },
    { 0x1D8B1DD4, "ch_sniper_resnov_cheer" },
    { 0x8AA4591C, "ch_street_light_02_on" },
    { 0x554B6F86, "ch_street_wall_light_01_on" },
    { 0xBA7DA02F, "ch_trapper" },
    { 0x16E4F4E7, "ch_under_b09_hudson_stumbling" },
    { 0x1639140F, "ch_vehicle_kills" },
    { 0x06CA7465, "ch_wagofthefinger" },
    { 0x640DDA34, "ch_war_drones_intro_seal_1" },
    { 0xD615496F, "ch_war_drones_intro_seal_2" },
    { 0xB012CF06, "ch_war_drones_intro_seal_3" },
    { 0xF2066AF9, "ch_war_drones_intro_seal_4" },
    { 0xCC03F090, "ch_war_drones_intro_seal_5" },
    { 0xD009E4DD, "ch_war_hub_a_idle_briggs" },
    { 0xD7DC57CA, "ch_war_pak_fail_zhao" },
    { 0xCB646F04, "ch_war_pak_intro_sc2_seal_1" },
    { 0x3D6BDE3F, "ch_war_pak_intro_sc2_seal_2" },
    { 0xC1A10021, "ch_war_pak_succeed_chinese_guard" },
    { 0x0648885D, "ch_war_pak_succeed_seal_1" },
    { 0x2C4B02C6, "ch_war_pak_succeed_seal_2" },
    { 0x5EA0BB20, "ch_war_pak_succeed_zhao" },
    { 0x4381958F, "ch_warhero" },
    { 0x1F6D5A35, "ch_yemen_01_02_menendez_intro_greet1" },
    { 0x1DB657E0, "ch_yemen_01_02_menendez_intro_greet1_defalco_alt" },
    { 0x3EA9DE29, "ch_yemen_01_02_menendez_intro_greet1_endloop" },
    { 0x085CCC3C, "ch_yemen_01_02_menendez_intro_greet1_endloop_defalco_alt" },
    { 0x39949C66, "ch_yemen_01_02_menendez_intro_greet2_endloop" },
    { 0x6CC9BE5B, "ch_yemen_01_02_menendez_intro_menendez" },
    { 0x56D3A5FA, "ch_yemen_01_02_menendez_intro_menendez_end_loop" },
    { 0xAA1A5B8C, "ch_yemen_01_02_menendez_intro_menendez_hallway_walk" },
    { 0x0D905949, "ch_yemen_01_02_menendez_intro_menendez_hallway_walk_defalco_alt" },
    { 0x8EF74E14, "ch_yemen_01_02_menendez_intro_menendez_nag_1" },
    { 0x00FEBD4F, "ch_yemen_01_02_menendez_intro_menendez_nag_2" },
    { 0xDAFC42E6, "ch_yemen_01_02_menendez_intro_menendez_nag_3" },
    { 0x0646A7EA, "ch_yemen_01_02_menendez_intro_salute1" },
    { 0xBA3BFC09, "ch_yemen_01_02_menendez_intro_salute1_end_loop" },
    { 0xE0442D81, "ch_yemen_01_02_menendez_intro_salute2" },
    { 0x76436C78, "ch_yemen_01_02_menendez_intro_salute2_end_loop" },
    { 0xBA41B318, "ch_yemen_01_02_menendez_intro_salute3" },
    { 0x830FC2AF, "ch_yemen_01_02_menendez_intro_salute3_end_loop" },
    { 0xDAAEE585, "ch_yemen_01_02_menendez_intro_salute_a" },
    { 0x0E4C4384, "ch_yemen_01_02_menendez_intro_salute_a_end_loop" },
    { 0xE13EBD56, "ch_yemen_01_02_menendez_intro_salute_aa" },
    { 0xB7B5749D, "ch_yemen_01_02_menendez_intro_salute_aa_end_loop" },
    { 0x00B15FEE, "ch_yemen_01_02_menendez_intro_salute_b" },
    { 0x596451A5, "ch_yemen_01_02_menendez_intro_salute_b_end_loop" },
    { 0xFA22F638, "ch_yemen_01_02_menendez_intro_salute_bb" },
    { 0x77CB054F, "ch_yemen_01_02_menendez_intro_salute_bb_end_loop" },
    { 0x26B3DA57, "ch_yemen_01_02_menendez_intro_salute_c" },
    { 0xAC07F82A, "ch_yemen_01_02_menendez_intro_salute_c_loop_end" },
    { 0x1CA28178, "ch_yemen_01_02_menendez_intro_salute_d" },
    { 0x75A7E88F, "ch_yemen_01_02_menendez_intro_salute_d_end_loop" },
    { 0xE42B06AC, "ch_yemen_01_02_menendez_intro_salute_dd" },
    { 0x9BB0CFBB, "ch_yemen_01_02_menendez_intro_salute_dd_end_loop" },
    { 0x42A4FBE1, "ch_yemen_01_02_menendez_intro_salute_e" },
    { 0xC693276C, "ch_yemen_01_02_menendez_intro_salute_e_loop_end" },
    { 0xFD0F3F8E, "ch_yemen_01_02_menendez_intro_salute_ee" },
    { 0xB8C55621, "ch_yemen_01_02_menendez_intro_salute_ee_loop_end" },
    { 0x68A7764A, "ch_yemen_01_02_menendez_intro_salute_f" },
    { 0x893DBAD5, "ch_yemen_01_02_menendez_intro_salute_f_loop_end" },
    { 0x65410AE8, "ch_yemen_01_02_menendez_intro_salute_ff" },
    { 0xFC9025C3, "ch_yemen_01_02_menendez_intro_salute_ff_loop_end" },
    { 0xC5A46676, "ch_yemen_01_02_menendez_intro_salute_gg" },
    { 0x17D63279, "ch_yemen_01_02_menendez_intro_salute_gg_loop_end" },
    { 0x849897D4, "ch_yemen_01_02_menendez_intro_salute_h" },
    { 0x577AEB47, "ch_yemen_01_02_menendez_intro_salute_h_loop_end" },
    { 0x9FD3E254, "ch_yemen_01_02_menendez_intro_salute_hh" },
    { 0x1CA2A2C7, "ch_yemen_01_02_menendez_intro_salute_hh_loop_end" },
    { 0xAA9B123D, "ch_yemen_01_02_menendez_intro_salute_i" },
    { 0x14A465B0, "ch_yemen_01_02_menendez_intro_salute_i_loop_end" },
    { 0x381980F6, "ch_yemen_01_02_menendez_intro_salute_ii" },
    { 0x84DE59F9, "ch_yemen_01_02_menendez_intro_salute_ii_loop_end" },
    { 0x43BB8D18, "ch_yemen_01_03_menendez_speech_crowd_idle_01" },
    { 0xB5C2FC53, "ch_yemen_01_03_menendez_speech_crowd_idle_02" },
    { 0x8D665FDD, "ch_yemen_01_03_menendez_speech_defalco_endidl" },
    { 0xCFE1E806, "ch_yemen_01_03_menendez_speech_defalco_walk" },
    { 0x5BDE7925, "ch_yemen_01_03_menendez_speech_menendez_talk" },
    { 0xBA9DB387, "ch_yemen_01_03_menendez_speech_menendez_walk_no_defalco" },
    { 0xAF167802, "ch_yemen_01_03_menendez_speech_menendez_walk_with_defalco" },
    { 0x2C644CE5, "ch_yemen_01_03_menendez_speech_terrorist1" },
    { 0xA888F530, "ch_yemen_01_03_menendez_speech_terrorist1_defalco_alt" },
    { 0x5266C74E, "ch_yemen_01_03_menendez_speech_terrorist2" },
    { 0x786941B7, "ch_yemen_01_03_menendez_speech_terrorist3" },
    { 0x6E57E8D8, "ch_yemen_01_03_menendez_speech_terrorist4" },
    { 0x90EC1395, "ch_yemen_01_03_menendez_speech_vtol_react" },
    { 0x043EE8C5, "ch_yemen_01_04_defalco_guardl_vtol_leave" },
    { 0x18B5579F, "ch_yemen_01_04_defalco_guardr_vtol_leave" },
    { 0x5BC300D9, "ch_yemen_01_04_defalco_vtol_leave" },
    { 0x50600199, "ch_yemen_01_04_menendez_intro_crowd_cheer_guy01" },
    { 0x76627C02, "ch_yemen_01_04_menendez_intro_crowd_cheer_guy02" },
    { 0x0BA89D50, "ch_yemen_01_04_menendez_intro_crowd_fistpump_guy01" },
    { 0x7DB00C8B, "ch_yemen_01_04_menendez_intro_crowd_fistpump_guy02" },
    { 0xDA1B3F2A, "ch_yemen_01_04_menendez_intro_crowd_idle_guy01" },
    { 0xB418C4C1, "ch_yemen_01_04_menendez_intro_crowd_idle_guy02" },
    { 0xFE9CE907, "ch_yemen_01_04_menendez_intro_crowd_runaway_guy01" },
    { 0x8C9579CC, "ch_yemen_01_04_menendez_intro_crowd_runaway_guy02" },
    { 0xF9D63149, "ch_yemen_01_04_menendez_shoot_drones_guard_01" },
    { 0x1381AECE, "ch_yemen_01_04_menendez_shoot_drones_guard_01_loop" },
    { 0x1FD8ABB2, "ch_yemen_01_04_menendez_shoot_drones_guard_02" },
    { 0x228D21FB, "ch_yemen_01_04_menendez_shoot_drones_guard_02_loop" },
    { 0x45DB261B, "ch_yemen_01_04_menendez_shoot_drones_guard_03" },
    { 0x43E30D10, "ch_yemen_01_04_menendez_shoot_drones_guard_03_loop" },
    { 0x06FEA771, "ch_yemen_02_02_car_flip_guy01" },
    { 0x2D0121DA, "ch_yemen_02_02_car_flip_guy02" },
    { 0xC1683F67, "ch_yemen_02_02_pushcart_guy01" },
    { 0x4F60D02C, "ch_yemen_02_02_pushcart_guy02" },
    { 0x0E8129EC, "ch_yemen_02_02_pushcart_right_guy01" },
    { 0x0C26DE38, "ch_yemen_02_02_roll_under_door_guy01" },
    { 0x7E2E4D73, "ch_yemen_02_02_roll_under_door_guy02" },
    { 0x1F700CE8, "ch_yemen_02_02_shooting_drones_ter1" },
    { 0x91777C23, "ch_yemen_02_02_shooting_drones_ter2" },
    { 0x6B7501BA, "ch_yemen_02_02_shooting_drones_ter3" },
    { 0xDD7C70F5, "ch_yemen_02_02_shooting_drones_ter4" },
    { 0xB779F68C, "ch_yemen_02_02_shooting_drones_ter5" },
    { 0x298165C7, "ch_yemen_02_02_shooting_drones_ter6" },
    { 0x2220590F, "ch_yemen_02_02_table_flip_guy01" },
    { 0x180982A1, "ch_yemen_02_02_wounded_crouch_shot_die" },
    { 0x5A172E11, "ch_yemen_02_02_wounded_terrorists_hold_belly" },
    { 0xE9457692, "ch_yemen_03_03_xm25_deaths_char_02" },
    { 0x0F47F0FB, "ch_yemen_03_03_xm25_deaths_char_03" },
    { 0x354A6B64, "ch_yemen_03_03_xm25_deaths_char_04" },
    { 0x814F6036, "ch_yemen_03_03_xm25_deaths_char_06" },
    { 0xA751DA9F, "ch_yemen_03_03_xm25_deaths_char_07" },
    { 0xCD545508, "ch_yemen_03_03_xm25_deaths_char_08" },
    { 0x933EDC24, "ch_yemen_03_03_xm25_hand_gun_char_01" },
    { 0xF9FA0E4B, "ch_yemen_03_03_xm25_intro_char_02" },
    { 0xD3F793E2, "ch_yemen_03_03_xm25_intro_char_03" },
    { 0x45FF031D, "ch_yemen_03_03_xm25_intro_char_04" },
    { 0x9203F7EF, "ch_yemen_03_03_xm25_intro_char_06" },
    { 0x6C017D86, "ch_yemen_03_03_xm25_intro_char_07" },
    { 0xDE08ECC1, "ch_yemen_03_03_xm25_intro_char_08" },
    { 0xC6DA6D55, "ch_yemen_03_03_xm25_reaction_to_drawing_gun_char_01" },
    { 0xECDCE7BE, "ch_yemen_03_03_xm25_reaction_to_drawing_gun_char_02" },
    { 0x12DF6227, "ch_yemen_03_03_xm25_reaction_to_drawing_gun_char_03" },
    { 0x08CE0948, "ch_yemen_03_03_xm25_reaction_to_drawing_gun_char_04" },
    { 0x54D2FE1A, "ch_yemen_03_03_xm25_reaction_to_drawing_gun_char_06" },
    { 0x7AD57883, "ch_yemen_03_03_xm25_reaction_to_drawing_gun_char_07" },
    { 0x70C41FA4, "ch_yemen_03_03_xm25_reaction_to_drawing_gun_char_08" },
    { 0x17DFB53F, "ch_yemen_04_01_xplode_death_guy1" },
    { 0xA5D84604, "ch_yemen_04_01_xplode_death_guy2" },
    { 0xCBDAC06D, "ch_yemen_04_01_xplode_death_guy3" },
    { 0x59D35132, "ch_yemen_04_01_xplode_death_guy4" },
    { 0x5BB38AE5, "ch_yemen_05_01_call_farid_idle_menendez" },
    { 0xB63C05D0, "ch_yemen_05_01_call_farid_menendez" },
    { 0x5CF6831E, "ch_yemen_05_01_shoot_vtol_menendez" },
    { 0x0E5033F4, "ch_yemen_05_01_waiting_menendez" },
    { 0x19D06DB8, "ch_yemen_05_03_capture_approach_defalco" },
    { 0xFB6DC02A, "ch_yemen_05_03_capture_approach_harper" },
    { 0x25ACADDE, "ch_yemen_05_03_capture_approach_menendez" },
    { 0x096E9D16, "ch_yemen_05_03_capture_approach_redshirt01" },
    { 0xE36C22AD, "ch_yemen_05_03_capture_approach_redshirt02" },
    { 0xCB0AD114, "ch_yemen_05_03_capture_approach_terr01" },
    { 0x3D12404F, "ch_yemen_05_03_capture_approach_terr02" },
    { 0x170FC5E6, "ch_yemen_05_03_capture_approach_terr03" },
    { 0x590361D9, "ch_yemen_05_03_capture_approach_terr04" },
    { 0x3300E770, "ch_yemen_05_03_capture_approach_terr05" },
    { 0xA50856AB, "ch_yemen_05_03_capture_approach_terr06" },
    { 0x7F05DC42, "ch_yemen_05_03_capture_approach_terr07" },
    { 0x21211EC5, "ch_yemen_05_03_capture_approach_terr08" },
    { 0xFB1EA45C, "ch_yemen_05_03_capture_approach_terr09" },
    { 0x7138B0D2, "ch_yemen_05_03_capture_approach_terr10" },
    { 0x973B2B3B, "ch_yemen_05_03_capture_approach_terr11" },
    { 0x2533BC00, "ch_yemen_05_03_capture_approach_terr12" },
    { 0x4B363669, "ch_yemen_05_03_capture_approach_terr13" },
    { 0x09429A76, "ch_yemen_05_03_capture_approach_terr14" },
    { 0x2F4514DF, "ch_yemen_05_03_capture_approach_terr15" },
    { 0xFDE54F73, "ch_yemen_05_03_capture_defalco" },
    { 0x30D483CF, "ch_yemen_05_03_capture_harper" },
    { 0xD66D4B43, "ch_yemen_05_03_capture_menendez" },
    { 0xF98E6FA3, "ch_yemen_05_03_capture_redshirt01" },
    { 0x87870068, "ch_yemen_05_03_capture_redshirt02" },
    { 0x8150107D, "ch_yemen_05_03_capture_terr01" },
    { 0xA7528AE6, "ch_yemen_05_03_capture_terr02" },
    { 0xCD55054F, "ch_yemen_05_03_capture_terr03" },
    { 0xC343AC70, "ch_yemen_05_03_capture_terr04" },
    { 0xE94626D9, "ch_yemen_05_03_capture_terr05" },
    { 0x0F48A142, "ch_yemen_05_03_capture_terr06" },
    { 0x354B1BAB, "ch_yemen_05_03_capture_terr07" },
    { 0x8B61695C, "ch_yemen_05_03_capture_terr08" },
    { 0xB163E3C5, "ch_yemen_05_03_capture_terr09" },
    { 0xD9E4FC3F, "ch_yemen_05_03_capture_terr10" },
    { 0xB3E281D6, "ch_yemen_05_03_capture_terr11" },
    { 0x8DE0076D, "ch_yemen_05_03_capture_terr12" },
    { 0x67DD8D04, "ch_yemen_05_03_capture_terr13" },
    { 0x41DB129B, "ch_yemen_05_03_capture_terr14" },
    { 0x1BD89832, "ch_yemen_05_03_capture_terr15" },
    { 0x2DB58230, "ch_yemen_05_03_execution_pilot01" },
    { 0x9FBCF16B, "ch_yemen_05_03_execution_pilot02" },
    { 0x79BA7702, "ch_yemen_05_03_execution_pilot03" },
    { 0xEBC1E63D, "ch_yemen_05_03_execution_pilot04" },
    { 0x4E524908, "ch_yemen_05_04_moral_pilot_killed_enemy_01" },
    { 0x1E2AF1FA, "ch_yemen_05_04_moral_pilot_killed_enemy_01_in" },
    { 0xC059B843, "ch_yemen_05_04_moral_pilot_killed_enemy_02" },
    { 0x56A07DCF, "ch_yemen_05_04_moral_pilot_killed_enemy_02_in" },
    { 0x9A573DDA, "ch_yemen_05_04_moral_pilot_killed_enemy_03" },
    { 0xAE4156F0, "ch_yemen_05_04_moral_pilot_killed_pilot" },
    { 0xC28E52C2, "ch_yemen_05_04_moral_pilot_killed_pilot_in" },
    { 0x82CB1542, "ch_yemen_05_04_shoot_harper_defalco" },
    { 0xEDBA50E4, "ch_yemen_05_04_shoot_harper_harper" },
    { 0x8DDB5740, "ch_yemen_05_04_shoot_harper_mason" },
    { 0xBA66E664, "ch_yemen_05_04_shoot_harper_menendez" },
    { 0xCDA1D07C, "ch_yemen_05_04_shoot_harper_redshirt01" },
    { 0x3FA93FB7, "ch_yemen_05_04_shoot_harper_redshirt02" },
    { 0xC65F9446, "ch_yemen_05_04_shoot_menendez_defalco" },
    { 0x21B82D80, "ch_yemen_05_04_shoot_menendez_harper" },
    { 0x1C389290, "ch_yemen_05_04_shoot_menendez_menendez" },
    { 0xBD093B78, "ch_yemen_05_04_shoot_menendez_redshirt01" },
    { 0x2F10AAB3, "ch_yemen_05_04_shoot_menendez_redshirt02" },
    { 0xEC9258B2, "ch_yemen_05_04_shoot_menendez_terr01" },
    { 0xC68FDE49, "ch_yemen_05_04_shoot_menendez_terr02" },
    { 0xA08D63E0, "ch_yemen_05_04_shoot_menendez_terr03" },
    { 0xAA9EBCBF, "ch_yemen_05_04_shoot_menendez_terr04" },
    { 0x849C4256, "ch_yemen_05_04_shoot_menendez_terr05" },
    { 0x5E99C7ED, "ch_yemen_05_04_shoot_menendez_terr06" },
    { 0x38974D84, "ch_yemen_05_04_shoot_menendez_terr07" },
    { 0x42A8A663, "ch_yemen_05_04_shoot_menendez_terr08" },
    { 0x1CA62BFA, "ch_yemen_05_04_shoot_menendez_terr09" },
    { 0x93FD6CF0, "ch_yemen_05_04_shoot_menendez_terr10" },
    { 0xB9FFE759, "ch_yemen_05_04_shoot_menendez_terr11" },
    { 0xE00261C2, "ch_yemen_05_04_shoot_menendez_terr12" },
    { 0x0604DC2B, "ch_yemen_05_04_shoot_menendez_terr13" },
    { 0x2C075694, "ch_yemen_05_04_shoot_menendez_terr14" },
    { 0x5209D0FD, "ch_yemen_05_04_shoot_menendez_terr15" },
    { 0xA0253D95, "ch_yemen_05_05_farid_alive_farid" },
    { 0x98FC42D1, "ch_yemen_05_05_farid_alive_harper" },
    { 0xC5603CF7, "ch_yemen_05_05_farid_alive_mason" },
    { 0x18113ADD, "ch_yemen_05_05_farid_alive_salazar" },
    { 0x3246E423, "ch_yemen_05_05_mason_intro_hpr_dies_harper" },
    { 0x357ABB28, "ch_yemen_05_05_mason_intro_hpr_dies_harper_loop" },
    { 0x69C45917, "ch_yemen_05_05_mason_intro_hpr_dies_salazar" },
    { 0xE0753324, "ch_yemen_05_05_mason_intro_hpr_dies_salazar_loop" },
    { 0x146CA1BD, "ch_yemen_05_05_mason_intro_hpr_lives_harper" },
    { 0x4027EA2A, "ch_yemen_05_05_mason_intro_hpr_lives_harper_loop" },
    { 0x7D1C2238, "ch_yemen_05_05_mason_intro_hpr_lives_medic_loop" },
    { 0xA17720C1, "ch_yemen_05_05_mason_intro_hpr_lives_salazar" },
    { 0x84841347, "ch_yemen_05_05_mason_intro_hpr_lives_soldier" },
    { 0xABFFFBCD, "ch_yemen_07_01_bridge_fall" },
    { 0x64CF169F, "ch_yemen_07_01_menendez_hack_menendez" },
    { 0x8354CB3B, "ch_yemen_08_01_carnage_a_wounded01_loop" },
    { 0xB31F67F2, "ch_yemen_08_01_carnage_a_wounded01_medic_loop" },
    { 0x6037500E, "ch_yemen_08_01_carnage_a_wounded02_loop" },
    { 0x151C7903, "ch_yemen_08_01_carnage_a_wounded02_medic_loop" },
    { 0x97DECCD9, "ch_yemen_08_01_carnage_a_wounded03_loop" },
    { 0x1F3F4D58, "ch_yemen_08_01_carnage_a_wounded04_drag" },
    { 0x7E8D2FBC, "ch_yemen_08_01_carnage_a_wounded04_loop" },
    { 0xA0B9FD89, "ch_yemen_08_01_carnage_a_wounded04_medic_drag" },
    { 0x30434701, "ch_yemen_08_01_carnage_a_wounded04_medic_loop" },
    { 0x83A32C07, "ch_yemen_08_01_carnage_a_wounded05_loop" },
    { 0x9AFBB6BA, "ch_yemen_08_01_carnage_a_wounded06_loop" },
    { 0xE32A7FBC, "ch_yemen_08_01_carnage_a_wounded07_endloop" },
    { 0x32DA11A2, "ch_yemen_08_01_carnage_a_wounded07_run" },
    { 0xDAC59FEB, "ch_yemen_08_01_carnage_a_wounded07_startloop" },
    { 0xF9299F3A, "ch_yemen_08_01_carnage_b_wounded01_loop" },
    { 0xBB26CA1F, "ch_yemen_08_01_carnage_b_wounded02_drag" },
    { 0xE1D11487, "ch_yemen_08_01_carnage_b_wounded02_loop" },
    { 0x776E8492, "ch_yemen_08_01_carnage_b_wounded02_medic_drag" },
    { 0x40B42DDE, "ch_yemen_08_01_carnage_b_wounded02_medic_loop" },
    { 0xDCBB183C, "ch_yemen_08_01_carnage_b_wounded03_loop" },
    { 0x009193B8, "ch_yemen_08_01_carnage_b_wounded04_crawl" },
    { 0xF60CB559, "ch_yemen_08_01_carnage_b_wounded04_loop" },
    { 0xBE65388E, "ch_yemen_08_01_carnage_b_wounded05_loop" },
    { 0xE182B3BB, "ch_yemen_08_01_carnage_b_wounded06_loop" },
    { 0xEC0652D0, "ch_yemen_08_01_carnage_b_wounded07_loop" },
    { 0x6E65F1FD, "ch_yemen_08_01_carnage_b_wounded08_loop" },
    { 0x90B351B2, "ch_yemen_08_01_carnage_b_wounded09_loop" },
    { 0xB64D4B47, "ch_yemen_08_01_pull_to_cover_american" },
    { 0xD47D7F74, "ch_yemen_08_01_pull_to_cover_american_loop" },
    { 0x495DF5A1, "ch_yemen_08_02_surrender_men" },
    { 0xFAA7E122, "ch_yemen_08_02_surrender_men_idle" },
    { 0xF18F8C99, "ch_yemen_08_02_surrender_seal01" },
    { 0x17920702, "ch_yemen_08_02_surrender_seal02" },
    { 0x28F9A882, "ch_youtalkintome" },
    { 0x2D412CF3, "chad" },
    { 0xBDE36965, "chaff" },
    { 0xEBCD2F25, "chaff_count" },
    { 0x7DEB740D, "chaff_dir" },
    { 0x7CF62642, "chaff_fx" },
    { 0xA0B10A61, "chaff_offset" },
    { 0x1192E083, "chaff_target" },
    { 0x7B74D0FA, "chaffcount" },
    { 0xB1E1BD0C, "chain" },
    { 0x1D3200F5, "chain01" },
    { 0x43347B5E, "chain02" },
    { 0x6936F5C7, "chain03" },
    { 0x87E05ED0, "chain_650" },
    { 0xF764F10C, "chain_after_vignette" },
    { 0xE985DD8C, "chain_and_home" },
    { 0x6BBA347E, "chain_anim_single_solo_aligned" },
    { 0xC9A691AE, "chain_backyard_1" },
    { 0xA3A41745, "chain_backyard_2" },
    { 0x9D3F154A, "chain_bunker_flame_back" },
    { 0xEF8DE4E3, "chain_bunkers_5" },
    { 0x6268AA5C, "chain_bunkers_entrance" },
    { 0xD85B8F23, "chain_bunkers_entrance_past" },
    { 0xBB589C42, "chain_closer_to_clock_tower" },
    { 0xA9D9519C, "chain_delay" },
    { 0xA2AC49F2, "chain_depth" },
    { 0x4642219D, "chain_ends" },
    { 0x19F2C573, "chain_letter" },
    { 0x3499770F, "chain_main_street_final" },
    { 0xDE95DFF1, "chain_near_asylum" },
    { 0x3C8E0612, "chain_off" },
    { 0x827E7264, "chain_on" },
    { 0xB26497C9, "chain_on_after_pit1clear" },
    { 0xB2321658, "chain_outro_1" },
    { 0x35DA2AB3, "chain_past_wing" },
    { 0xC5308537, "chain_players" },
    { 0xF974308D, "chain_radius" },
    { 0x39921C57, "chain_reaction_fx" },
    { 0xE22B1CB8, "chain_reaction_vo" },
    { 0x28A9A5CA, "chain_road_to_reichstag" },
    { 0x67E21CB9, "chain_startnode" },
    { 0x4FF3601A, "chain_street_left_1" },
    { 0x29F0E5B1, "chain_street_left_2" },
    { 0x84778A05, "chain_street_right_1" },
    { 0xAA7A046E, "chain_street_right_2" },
    { 0x8117694F, "chain_structs" },
    { 0x8BF17835, "chain_trig" },
    { 0xBDE232BE, "chain_up_to_hq" },
    { 0x9371E8DB, "chainarray" },
    { 0x8957C0EF, "chained" },
    { 0x557F2CAE, "chaineventmax" },
    { 0xEB2AF294, "chaineventnum" },
    { 0xAD108DC6, "chaineventradius" },
    { 0xF1BDA682, "chaineventradiussq" },
    { 0x9EA49687, "chaineventtime" },
    { 0x3C4ED9C6, "chainfallback" },
    { 0x0868E0BC, "chaining" },
    { 0x5168B1BA, "chainisactive" },
    { 0x3563F71C, "chainlink" },
    { 0x54E7BEE0, "chainnode" },
    { 0x83F1E65B, "chainplayer" },
    { 0x243C628F, "chains" },
    { 0x000BC6D6, "chains_off_till_fight" },
    { 0x9DF2C20F, "chainsaw_endgame_1" },
    { 0x2BEB52D4, "chainsaw_endgame_2" },
    { 0x51EDCD3D, "chainsaw_endgame_3" },
    { 0x5C00EC9D, "chainsaw_endgame_array" },
    { 0xF8EE9FEE, "chainsaw_lobby" },
    { 0x2CA657DF, "chainstring" },
    { 0x6AFEA7AA, "chaintrig" },
    { 0xDEBCC477, "chaintrig1" },
    { 0x6CB5553C, "chaintrig2" },
    { 0x49EBA6B0, "chair" },
    { 0xB61F3445, "chair1_guy" },
    { 0x1286489E, "chair1_post_anim" },
    { 0xA8E7E13A, "chair2_guy" },
    { 0x0A2217BD, "chair2_post_anim" },
    { 0x26E0C84B, "chair_angles" },
    { 0xB8B795A8, "chair_anim" },
    { 0x325DF470, "chair_break" },
    { 0x0171BBC9, "chair_break_go" },
    { 0xA70051DC, "chair_breakout" },
    { 0xE97BC3AF, "chair_corpse" },
    { 0xA219BCF1, "chair_counter" },
    { 0xA677BB36, "chair_delete" },
    { 0xB0EB8036, "chair_ent" },
    { 0x783534D8, "chair_guy" },
    { 0xE356A50D, "chair_guy_origin" },
    { 0x5286A732, "chair_guy_setup" },
    { 0xE4918085, "chair_light" },
    { 0x1112F9DB, "chair_modelname" },
    { 0xC0145CC8, "chair_number" },
    { 0xC5A871E7, "chair_offset_x" },
    { 0x9FA5F77E, "chair_offset_y" },
    { 0x79A37D15, "chair_offset_z" },
    { 0xDC58E453, "chair_pos" },
    { 0xD50C5B21, "chair_replace" },
    { 0xAE952DF2, "chair_rot_speed" },
    { 0xDBD3F578, "chair_speed" },
    { 0xCBD45BE8, "chair_struct" },
    { 0xF28964F9, "chair_targetname" },
    { 0x6DC01919, "chair_trig" },
    { 0x264C166B, "chair_trigger_setup" },
    { 0x9D5484CD, "chair_useage" },
    { 0x880F6A40, "chair_yaw" },
    { 0x035A3622, "chairclip" },
    { 0x595E6200, "chairkennedy" },
    { 0x929A1E1C, "chairman" },
    { 0x47B2E20A, "chairmason" },
    { 0xF9FBFA27, "chairmodel" },
    { 0x60C5171B, "chairs" },
    { 0x7040B6B2, "chalk" },
    { 0x78A07B5E, "chalk_angle" },
    { 0xCE689BEA, "chalk_buildable_pieces_hide" },
    { 0x739180B2, "chalk_builds" },
    { 0xEC2C7C8A, "chalk_host_migration" },
    { 0x82AD6CF1, "chalk_hostmigration" },
    { 0x4A0303E9, "chalk_hud1" },
    { 0x70057E52, "chalk_hud2" },
    { 0xA41A2C6D, "chalk_one_up" },
    { 0x03B18DD9, "chalk_override" },
    { 0x1FF315C8, "chalk_pieces" },
    { 0xE7753A5B, "chalk_prompt" },
    { 0x94EB72E5, "chalk_round_hint" },
    { 0xEA165EF8, "chalk_round_over" },
    { 0xFBC17C66, "chalk_triggers" },
    { 0x47965156, "chalkbuildable" },
    { 0xA336A977, "challanges" },
    { 0x5AEE7AC0, "challenge" },
    { 0xAE67D24B, "challenge_aitospawn" },
    { 0xFCD72B66, "challenge_anteup_earned" },
    { 0x729D4C13, "challenge_asd_rundown" },
    { 0xD4A82E59, "challenge_asd_rundown_increment" },
    { 0xEA672B1F, "challenge_asd_theater" },
    { 0xCB923E10, "challenge_asd_vs_tank" },
    { 0xEB16E24C, "challenge_assault_shield" },
    { 0x886CFCFD, "challenge_awarded" },
    { 0x43FB7CE9, "challenge_big_jumps" },
    { 0x70F4A8BA, "challenge_bloodbath" },
    { 0x219F21A0, "challenge_brutekills" },
    { 0x95A416C0, "challenge_callback_cp" },
    { 0x2C5F0065, "challenge_camo_kills" },
    { 0x151DC90E, "challenge_chloe_kills_increment" },
    { 0x2D44C4D2, "challenge_claw_burn" },
    { 0xAC26027C, "challenge_claw_kills" },
    { 0x27A51A06, "challenge_claw_kills_increment" },
    { 0x9EC2FC17, "challenge_claws_alive" },
    { 0xF34C3263, "challenge_close_hangar_doors" },
    { 0xF217F713, "challenge_combatrobotattackclientid" },
    { 0x98F21BD5, "challenge_convoy_all" },
    { 0x230AA6C4, "challenge_count" },
    { 0xB8209C68, "challenge_countdown" },
    { 0x9137300F, "challenge_defenderkillcount" },
    { 0x86DB2CCF, "challenge_destroy_learjet" },
    { 0xC21E3181, "challenge_destroy_zpu" },
    { 0xEA8D2228, "challenge_difficulty" },
    { 0xA3BAEAC1, "challenge_directed_quad_kills" },
    { 0x326FCB83, "challenge_directed_vtol_kills" },
    { 0xCC1A7A19, "challenge_docks_guards_speed_kill" },
    { 0x150F7CF6, "challenge_doublejump_begin" },
    { 0xFDD0883A, "challenge_doublejump_end" },
    { 0x13259E13, "challenge_download" },
    { 0xF21FD266, "challenge_electrocutions" },
    { 0x37F2BFD8, "challenge_emp_kills_asd" },
    { 0xD20D88E1, "challenge_emp_kills_sentry" },
    { 0x77FA7409, "challenge_enemies" },
    { 0xCA6D3E76, "challenge_enemiescount" },
    { 0x18886C1C, "challenge_enemiescountmax" },
    { 0xACA3660B, "challenge_escort_boat_destroy" },
    { 0xDB40117F, "challenge_exists" },
    { 0x67F41553, "challenge_explosive_car_kills_increment" },
    { 0xDDC0D2DE, "challenge_explosive_kills" },
    { 0xE68A429C, "challenge_explosive_kills_increment" },
    { 0x774B7A36, "challenge_extract_time_limit" },
    { 0xBEE7A237, "challenge_field_up" },
    { 0xC6117226, "challenge_find_weapon_cache" },
    { 0x811C8D7E, "challenge_freeze_asds" },
    { 0x9D4FBD56, "challenge_frogger_no_hits" },
    { 0x40203B24, "challenge_game_ended" },
    { 0x94EC2EAF, "challenge_godrod_think" },
    { 0x7C7B9348, "challenge_grenade_combo" },
    { 0xF1EECAAB, "challenge_hatchetkills" },
    { 0xC936511A, "challenge_hatchettosscount" },
    { 0xB6A9CD87, "challenge_headshot_kills" },
    { 0x55664FE8, "challenge_headshots" },
    { 0x3DD939FA, "challenge_headshots_increment" },
    { 0x7C5F004C, "challenge_heli_runs" },
    { 0x873AF083, "challenge_helikill" },
    { 0xCC0B5DC5, "challenge_hmg_boat_destroy" },
    { 0x336F67E9, "challenge_index" },
    { 0xD0A3EB3C, "challenge_ingame_time_tracking" },
    { 0xEF361F11, "challenge_init" },
    { 0x5DA14CE4, "challenge_irstrobe_kill" },
    { 0xC41FE781, "challenge_isscorestreak" },
    { 0x9B0C31D1, "challenge_jetpack_kills" },
    { 0x814DFAD9, "challenge_jump_begin" },
    { 0x9C8560A1, "challenge_jump_end" },
    { 0xFAAF8A11, "challenge_kill_ai_with_flak_jacket" },
    { 0xBAEFB1BD, "challenge_kill_asd_as_claw" },
    { 0x4852B48D, "challenge_kill_challenge_watch" },
    { 0x6F2F3B52, "challenge_kill_claws" },
    { 0xC0FE9DA8, "challenge_kill_claws_increment" },
    { 0x15BCAE22, "challenge_kill_ied_increment" },
    { 0x4B3B75A7, "challenge_kill_ied_planter" },
    { 0xF579A96A, "challenge_kill_quads" },
    { 0x85655BED, "challenge_kill_riders" },
    { 0xCB9105E7, "challenge_kill_riders_increment" },
    { 0x4B13BA68, "challenge_killcount" },
    { 0x6ADCF448, "challenge_killed" },
    { 0xA0AE56C2, "challenge_kills" },
    { 0xCD0B9B1D, "challenge_kills_as_claw" },
    { 0xFA00C64D, "challenge_kills_as_quad" },
    { 0x5052D3B5, "challenge_lastsurvivewithflakfrom" },
    { 0x3D1EAB56, "challenge_lastsurvivewithflaktime" },
    { 0xA280CF6A, "challenge_machete_gibs" },
    { 0xD313ADC1, "challenge_mason_find_clue" },
    { 0x8560603F, "challenge_mason_flip_truck" },
    { 0x0579D9ED, "challenge_mason_machete_kills" },
    { 0x6B0DF2BA, "challenge_mason_molotov_kills" },
    { 0x1929D0C7, "challenge_mason_mortar_kills" },
    { 0x306F217F, "challenge_melee_kills" },
    { 0x1F03A85D, "challenge_melee_kills_increment" },
    { 0x4CB445FE, "challenge_menendez_melee_kills" },
    { 0x0570DA6C, "challenge_menendez_shotgun_kills" },
    { 0x7B5916FD, "challenge_menendez_shotgun_kills_counter" },
    { 0x4651538B, "challenge_menendez_speed_run" },
    { 0xC799B498, "challenge_min_module" },
    { 0x37E6FC16, "challenge_mortar_kills" },
    { 0x4207277E, "challenge_multiple_asd_explosion" },
    { 0xCB44634A, "challenge_name" },
    { 0x6A282F18, "challenge_nextround" },
    { 0xBB799FA7, "challenge_nightingale" },
    { 0xA0DADEE6, "challenge_no_ied_convoy" },
    { 0xD1CBC9D0, "challenge_nodeath" },
    { 0xF4F68C4F, "challenge_notify_listener" },
    { 0x7E017C07, "challenge_objectivedefensive" },
    { 0x7D47DB98, "challenge_objectivedefensivekillcount" },
    { 0xF1643898, "challenge_objectivedefensivetriplekillmedalorbetterearned" },
    { 0x5448FDAD, "challenge_objectiveoffensive" },
    { 0x7ED95A22, "challenge_objectiveoffensivekillcount" },
    { 0xD1208C88, "challenge_offendercomlinkkillcount" },
    { 0x14097421, "challenge_offenderkillcount" },
    { 0x827DCD31, "challenge_offenderprojectilemultikillcount" },
    { 0x34A9C738, "challenge_offendersentryturretkillcount" },
    { 0x5B8FF940, "challenge_one_module" },
    { 0x3D350926, "challenge_pdf_turret_deaths" },
    { 0xA4CBE3DA, "challenge_playerhealth" },
    { 0x98F5CB73, "challenge_previousdestroycount" },
    { 0xFCC7AB5E, "challenge_previousdestroyweapon" },
    { 0x9F4D5F9D, "challenge_qrkills" },
    { 0x43E1CCD5, "challenge_qrkills_death_listener" },
    { 0x98DF3358, "challenge_quad_kills" },
    { 0xDDD6BF8A, "challenge_quad_kills_increment" },
    { 0xDC71B933, "challenge_quads_killed" },
    { 0x77FDEE5B, "challenge_rescue_soldier" },
    { 0xDA0A5A2E, "challenge_rescueagents" },
    { 0xC409C3C0, "challenge_rescuesecond" },
    { 0x3BA91A86, "challenge_resuppliednamekills" },
    { 0xC5D8CE5A, "challenge_rod_kill_helo" },
    { 0xAC692434, "challenge_rod_kill_tank" },
    { 0x3A4EFD38, "challenge_roofdrones" },
    { 0x2263E449, "challenge_round" },
    { 0x563FB330, "challenge_round_ended" },
    { 0x9CD0BBC9, "challenge_round_t1" },
    { 0xC2D33632, "challenge_round_t2" },
    { 0xD6D6139A, "challenge_save_f35s" },
    { 0x7A49BFB1, "challenge_save_player_asd" },
    { 0x7D46BC5A, "challenge_saveanderson" },
    { 0x7E5A3576, "challenge_savecougars" },
    { 0x5D33539C, "challenge_scavengedcount" },
    { 0x7BB8938B, "challenge_scorestreaksenabled" },
    { 0xFB3ACC63, "challenge_seals" },
    { 0x84A05B74, "challenge_sentry_kills" },
    { 0xEEB4C1CE, "challenge_sentry_kills_increment" },
    { 0xE861F947, "challenge_sentry_lost" },
    { 0x0D7078F9, "challenge_sentry_vs_asd" },
    { 0x0C26DC18, "challenge_sentryemp" },
    { 0xAE06C21C, "challenge_slide_begin" },
    { 0x3576CCE0, "challenge_slide_end" },
    { 0xCA5A0483, "challenge_snipekills" },
    { 0xB61EA1A3, "challenge_snipekills_death_listener" },
    { 0x10824B8C, "challenge_socttakedowns" },
    { 0xB624BE61, "challenge_sprint_begin" },
    { 0xC0104BB9, "challenge_sprint_end" },
    { 0xE62A31F5, "challenge_start" },
    { 0x55F4B922, "challenge_started" },
    { 0xA03AC8D9, "challenge_stat_name" },
    { 0xED6A572A, "challenge_state" },
    { 0x21B07007, "challenge_stop" },
    { 0x1BF65366, "challenge_stoppenalizedtime" },
    { 0xCFCDD71D, "challenge_stun_kills" },
    { 0xEA1641B7, "challenge_stun_kills_increment" },
    { 0x5BFF5F78, "challenge_success" },
    { 0x3C27DD9B, "challenge_survived_from_death" },
    { 0x8B909D82, "challenge_swimming_begin" },
    { 0x119C3956, "challenge_swimming_end" },
    { 0x296EF854, "challenge_tactical" },
    { 0x8103DEED, "challenge_takedowns" },
    { 0x00426DF5, "challenge_tank_kills" },
    { 0x9E234EE7, "challenge_thinkfast" },
    { 0x26215164, "challenge_time" },
    { 0xB8067180, "challenge_time_force_on" },
    { 0xD90942C8, "challenge_time_limit" },
    { 0xA4E88A49, "challenge_tituskills" },
    { 0x70E8924C, "challenge_tituskills_think" },
    { 0x0FD6C0E0, "challenge_turret_kill" },
    { 0x6190038B, "challenge_turret_kills" },
    { 0x501EFBAC, "challenge_turret_oneshot" },
    { 0x987CB6F1, "challenge_turret_stun_think" },
    { 0x9A4E76F0, "challenge_turretdrones" },
    { 0xE198427C, "challenge_turretkills" },
    { 0xD5B481F6, "challenge_value" },
    { 0x9DEA6496, "challenge_vtol_kills" },
    { 0x159B32E4, "challenge_vtol_kills_increment" },
    { 0xDA3759C8, "challenge_wallrun_begin" },
    { 0x77C2A8FC, "challenge_wallrun_end" },
    { 0x77191093, "challengeaiawaken" },
    { 0x766F269C, "challengeaispawned" },
    { 0x38534007, "challengearray" },
    { 0xBB8DED61, "challengeclassname" },
    { 0xFA53B458, "challengedata" },
    { 0x7AAEB323, "challengedesc" },
    { 0x95759433, "challengeevents" },
    { 0x28EF3ADD, "challengegameend" },
    { 0xA26E8066, "challengegameendmp" },
    { 0x171D52B4, "challengeindex" },
    { 0xCF460A54, "challengeinfo" },
    { 0x81051A8B, "challengeinfomp" },
    { 0x65115B2B, "challengekills" },
    { 0x17E47956, "challengekillstreak" },
    { 0xA68C281F, "challengempdata" },
    { 0x3EFAE7F9, "challengename" },
    { 0x4BCC1730, "challengenames" },
    { 0x134D588B, "challengenotify" },
    { 0x60541570, "challengenotifycount" },
    { 0x6D0FBBA0, "challengenum" },
    { 0x3FEF2467, "challengeroundend" },
    { 0xF74B04EB, "challenges" },
    { 0x355DFFB3, "challenges_add_stats" },
    { 0xC4B30F14, "challenges_devgui" },
    { 0x5DAB02F8, "challenges_init" },
    { 0x76795C88, "challenges_per_level" },
    { 0x31684125, "challenges_shared" },
    { 0xA05B7D71, "challengescallbacks" },
    { 0x7C454197, "challengeseason" },
    { 0x5C9E3B86, "challengesenabled" },
    { 0x45747F17, "challengesettings" },
    { 0x894F6A6D, "challengesoneventreceived" },
    { 0xCB296F6B, "challengestring" },
    { 0x36717B0C, "challengetest" },
    { 0x8F94632C, "challengetier" },
    { 0xB9C20078, "challengetype" },
    { 0xE70642B7, "challengeunlocked" },
    { 0x09318483, "challengevalue" },
    { 0x24532B51, "chamber" },
    { 0x89084792, "chamber_blocker" },
    { 0x8ACD1AB2, "chamber_canister_damage_trig" },
    { 0x6DC34C40, "chamber_canister_trig" },
    { 0xC24BC100, "chamber_capture_zombie_spawn_init" },
    { 0xEA272F42, "chamber_change_walls" },
    { 0x9BC87AD2, "chamber_devgui" },
    { 0xF73A5201, "chamber_disc_gem_has_clearance" },
    { 0x46D994BC, "chamber_disc_get_gem_position" },
    { 0x60DE7457, "chamber_disc_move_to_position" },
    { 0x31813267, "chamber_disc_puzzle_init" },
    { 0x93F3BA53, "chamber_disc_rotate" },
    { 0xAC2CC469, "chamber_disc_run" },
    { 0xBF093C24, "chamber_disc_switch_spark" },
    { 0x865B0A10, "chamber_disc_trigger_run" },
    { 0xC0617DFA, "chamber_discs" },
    { 0xDADEA124, "chamber_discs_move_all_to_position" },
    { 0x53089652, "chamber_discs_randomize" },
    { 0x1D1F5D0E, "chamber_dof_back_to_device" },
    { 0x02912700, "chamber_dof_chamber_center" },
    { 0x40BA7D08, "chamber_dof_erik_device" },
    { 0x597136D9, "chamber_dof_look_at_erik" },
    { 0x4F166E8E, "chamber_dof_look_at_harper" },
    { 0x5B0AF51B, "chamber_dof_look_back" },
    { 0x1EF65CCC, "chamber_dof_look_erik_2" },
    { 0x1C383970, "chamber_dof_project_wall" },
    { 0xC41CE8BC, "chamber_dof_take_device" },
    { 0xD12126F3, "chamber_dof_walk_up" },
    { 0x6461D1B9, "chamber_door_0" },
    { 0x3E5F5750, "chamber_door_1" },
    { 0x6A06C7D8, "chamber_wall" },
    { 0xAD70490E, "chamber_wall_change_randomly" },
    { 0x0F65CE2F, "chamber_wall_dust" },
    { 0xC9CF1178, "chamber_zombies_find_poi" },
    { 0x2DAE9719, "chambers_init" },
    { 0x9515BC6D, "chance" },
    { 0xD7BE317E, "chance1" },
    { 0xB1BBB715, "chance2" },
    { 0x8BB93CAC, "chance3" },
    { 0x65B6C243, "chance4" },
    { 0x1BB96989, "chance_for_arm_gib" },
    { 0x11C57D9F, "chance_of_joker" },
    { 0xABC44FB0, "chance_override" },
    { 0x43C97772, "chancekey" },
    { 0x806593BC, "chancepercent" },
    { 0x0B1AA26C, "chances" },
    { 0xDE4B7DCD, "chances_remaining" },
    { 0x1A6D96E7, "chancetodetect" },
    { 0x82220DA9, "chancetoflattentires" },
    { 0x12B2C3DF, "chand" },
    { 0x23812ACC, "chand_fall_check" },
    { 0x7872D584, "chandelier" },
    { 0xF423855C, "chandelier_anim" },
    { 0xFD119A84, "chandelier_boards" },
    { 0xF60D1224, "chandelier_fall" },
    { 0x7B498186, "chandelier_pulse" },
    { 0x097AA09C, "chandelier_rotate_random" },
    { 0x5FAADC91, "chandelier_start" },
    { 0xB2074D37, "chandeliers" },
    { 0x0FE54850, "chandeliers_shake" },
    { 0xDB65FC5A, "chandolier" },
    { 0x69A6D229, "chandolier2_anims_setup" },
    { 0x2FCCFF6E, "chandolier_2_shake" },
    { 0x2A52BDAB, "chandolier_anims2_setup" },
    { 0x40F8B3FB, "chandolier_anims_setup" },
    { 0x2FCECD0E, "chandolier_fall" },
    { 0x6990414E, "chandolier_fall_notify" },
    { 0x43E4A4B3, "chandolier_loop" },
    { 0x57289F6A, "chandolier_notify" },
    { 0x5F5F81D1, "change" },
    { 0x4E8700E7, "change_ai_animname_and_targetname_after_anim" },
    { 0x4A1C7B6B, "change_ai_group_goalradii" },
    { 0x62A90E51, "change_ai_stance" },
    { 0xE267E85A, "change_ambient_room" },
    { 0x5F4D7936, "change_ammo" },
    { 0x410872FE, "change_anim_set" },
    { 0x87A4EC25, "change_arrivals_anim_frac" },
    { 0x60AAEC02, "change_art_settings_2" },
    { 0x86AD666B, "change_art_settings_3" },
    { 0x715CA4AE, "change_art_settings_tunnel" },
    { 0x2B7FEAF0, "change_back_to_default_visionset" },
    { 0x966767CC, "change_bad_spawner" },
    { 0x366A1074, "change_club_lights" },
    { 0x201B6279, "change_cougar_team" },
    { 0x31413017, "change_difficulty" },
    { 0x4EE1A6C8, "change_dogfights_fog_based_on_height" },
    { 0x25CDA323, "change_dom_spawns" },
    { 0xF2B4656D, "change_door_models" },
    { 0xC4CC39CE, "change_dr_flags" },
    { 0x3AA2C563, "change_effect_to_exploder" },
    { 0x6001A00E, "change_effect_to_loop" },
    { 0x0B01ED48, "change_effect_to_oneshot" },
    { 0x88EA280E, "change_ent_type" },
    { 0xB9DFD1C0, "change_extraction_point" },
    { 0x12D1FC06, "change_fog_setting_for_village_dock" },
    { 0xC4D905CE, "change_func" },
    { 0x37C67885, "change_goal" },
    { 0x6EE5F22A, "change_heartbeat_timer" },
    { 0x75FD41E9, "change_heli_water_fog" },
    { 0xE0DA9E9A, "change_heros_colors" },
    { 0xFD6544FF, "change_ice_gem_value" },
    { 0x50F6D88C, "change_in_interval_b" },
    { 0xDEEF6951, "change_in_interval_g" },
    { 0xB11E7F1C, "change_in_interval_r" },
    { 0xAE8A32E6, "change_killstreak_quantity" },
    { 0x46F00AD7, "change_left" },
    { 0x26DBDAC1, "change_location" },
    { 0xE4B40793, "change_melee_weapon" },
    { 0x278623F2, "change_movemode" },
    { 0xF859C165, "change_music" },
    { 0x39E76F17, "change_music_state" },
    { 0xAA0009FB, "change_music_state_delay" },
    { 0xD8CED146, "change_music_state_from_dvar" },
    { 0xD47537DB, "change_music_wait" },
    { 0x121CEB64, "change_names" },
    { 0xF9A5FD38, "change_note" },
    { 0x9F6A8D70, "change_noteworthy_goalradii" },
    { 0x393A9A4F, "change_notify" },
    { 0x841BBFEB, "change_pentagon_vision" },
    { 0x3E8CD20A, "change_player_health_packets" },
    { 0xD1018B7F, "change_power" },
    { 0x6F2DE238, "change_power_in_radius" },
    { 0x8FAB2AE4, "change_room_for_dogfight" },
    { 0xCF118117, "change_round_max" },
    { 0xB18364BA, "change_route_frac" },
    { 0x67A18AB7, "change_seat" },
    { 0xBCB3809B, "change_shadow_sample_size" },
    { 0x09FCCA95, "change_speed" },
    { 0x5B119614, "change_spin" },
    { 0xD5BEB6F3, "change_state" },
    { 0xD64CD8A0, "change_threat_bias" },
    { 0x2AC529BB, "change_to_hudson" },
    { 0x17827AD8, "change_to_wounded" },
    { 0xB059AB3C, "change_type" },
    { 0x135C4CEE, "change_underwater_fog_at_hey_charlie" },
    { 0x129E9E24, "change_vision" },
    { 0x6B220E60, "change_weapon" },
    { 0xDEA8AD10, "change_weapon_cost" },
    { 0xFB3F4152, "change_zombie_music" },
    { 0xAC11B047, "change_zombie_run_cycle" },
    { 0x0168DC4E, "changeadvertisedstatus" },
    { 0x0D289D20, "changeaiming" },
    { 0x03F24BAD, "changeamount" },
    { 0xC895F52B, "changeclass_offline" },
    { 0x3EDBF1A3, "changeclassweight" },
    { 0x1A2A06FB, "changecovermode" },
    { 0xCD512D07, "changed" },
    { 0x9904E112, "changed_class" },
    { 0xBA9E3316, "changed_list" },
    { 0x6971BC15, "changedclass" },
    { 0x456D5152, "changedclient" },
    { 0xAF774793, "changedofvalue" },
    { 0x7D6B5402, "changedselectedents" },
    { 0xE3EAB219, "changefontscaleovertime" },
    { 0xBF246AF9, "changefrequency" },
    { 0x72ABD158, "changekillstreakquantity" },
    { 0x224504F1, "changelevel" },
    { 0x60D1D073, "changelightcolorto" },
    { 0x11C5A419, "changelightcolortoworkerthread" },
    { 0x597FDF0A, "changeowner" },
    { 0xA2078128, "changeperstep" },
    { 0xF15FE3FD, "changereason" },
    { 0x9FAFE5C8, "changers" },
    { 0x23677AB8, "changes" },
    { 0x805A61B0, "changeseatbuttonpressed" },
    { 0xAE161BB5, "changesecondarygrenadetype" },
    { 0xC08A0022, "changestanceforfuntime" },
    { 0x0534E269, "changestepoutpos" },
    { 0xAEFD5486, "changeteam" },
    { 0x8C9C5204, "changeteamwaiter" },
    { 0x38361E86, "changetime" },
    { 0x984B93EE, "changeval" },
    { 0xA3EEDBD7, "changeweaponafterkillstreak" },
    { 0x467B74C8, "changeweapons" },
    { 0xCABC4D5E, "changeweaponstandrun" },
    { 0x3E23D984, "changing" },
    { 0xC5AB3225, "changing_round" },
    { 0x607C6FF9, "changing_solidness" },
    { 0xFC0573B9, "changing_volume" },
    { 0x08853F75, "changingcoverpos" },
    { 0x408C1646, "chanidx" },
    { 0xA449666F, "chaning" },
    { 0x6627F6CA, "channel" },
    { 0x14BF5F05, "channels" },
    { 0x02E256DD, "chanse" },
    { 0x72DA6A6F, "chant" },
    { 0xCE4089DB, "chaos" },
    { 0x19B06A46, "chaotically" },
    { 0x7B80E882, "chaplin_grain_end" },
    { 0xEC6D150F, "chaplin_grain_proc" },
    { 0xBC624FF9, "chaplin_grain_start" },
    { 0x81E25E4B, "chaplin_proc" },
    { 0xB8D64809, "chaplin_titlecard" },
    { 0x0CE6D93F, "chaplin_titlecard_create_background" },
    { 0x1A0696F2, "chaplin_titlecard_create_text" },
    { 0x1AB197D9, "chaplinmode" },
    { 0x191E7B35, "char" },
    { 0x3361820B, "char_brt_infwint_r_enfield" },
    { 0x193BC03F, "char_clear" },
    { 0x25305007, "char_full" },
    { 0x988776E0, "char_ger_ansel" },
    { 0x0DEBDDDB, "char_ger_crawler_zombies" },
    { 0x6C1FF582, "char_ger_engineer_zombies" },
    { 0xEF3507EB, "char_ger_fallschirm_bodyalias" },
    { 0x573F860C, "char_ger_fallschirm_gearalias" },
    { 0xBD8521DD, "char_ger_fallschirm_headalias" },
    { 0xBF5B5547, "char_ger_fallschirm_helmalias" },
    { 0xA1DC883E, "char_ger_hnrgd_player_assault" },
    { 0x9651FA0D, "char_ger_hnrgd_player_cqb" },
    { 0x8D2989AF, "char_ger_hnrgd_player_hmg" },
    { 0xF4C0946B, "char_ger_hnrgd_player_lmg" },
    { 0x11B1175D, "char_ger_hnrgd_player_rifle" },
    { 0x71721FE4, "char_ger_hnrgd_player_smg" },
    { 0x24290A1F, "char_ger_hnrgrd_body1_2_g_larmoffalias" },
    { 0x47D8A3BA, "char_ger_hnrgrd_body1_2_g_legsoffalias" },
    { 0x9037D2A5, "char_ger_hnrgrd_body1_2_g_llegoffalias" },
    { 0xE59E6EBD, "char_ger_hnrgrd_body1_2_g_rarmoffalias" },
    { 0x80C5C1EB, "char_ger_hnrgrd_body1_2_g_rlegoffalias" },
    { 0x129CDE8F, "char_ger_hnrgrd_body1_2_g_torsoalias" },
    { 0x4D87AA96, "char_ger_hnrgrd_body1_g_larmoffalias" },
    { 0x41AC9797, "char_ger_hnrgrd_body1_g_legsoffalias" },
    { 0xA71FC714, "char_ger_hnrgrd_body1_g_llegoffalias" },
    { 0xC8497A28, "char_ger_hnrgrd_body1_g_rarmoffalias" },
    { 0x2F5DCF8E, "char_ger_hnrgrd_body1_g_rlegoffalias" },
    { 0x824E177A, "char_ger_hnrgrd_body1_g_torsoalias" },
    { 0x805B0936, "char_ger_hnrgrd_body1_m_g_larmoffalias" },
    { 0x5F6D9A37, "char_ger_hnrgrd_body1_m_g_legsoffalias" },
    { 0xD76533B4, "char_ger_hnrgrd_body1_m_g_llegoffalias" },
    { 0xCC4FD5C8, "char_ger_hnrgrd_body1_m_g_rarmoffalias" },
    { 0xF6C8F12E, "char_ger_hnrgrd_body1_m_g_rlegoffalias" },
    { 0xC69FAF1A, "char_ger_hnrgrd_body1_m_g_torsoalias" },
    { 0xE81199F7, "char_ger_hnrgrd_body2_m_g_larmoffalias" },
    { 0x2F41C922, "char_ger_hnrgrd_body2_m_g_legsoffalias" },
    { 0x0DE5D5DD, "char_ger_hnrgrd_body2_m_g_llegoffalias" },
    { 0x2EBE92C5, "char_ger_hnrgrd_body2_m_g_rarmoffalias" },
    { 0xCC48F0F3, "char_ger_hnrgrd_body2_m_g_rlegoffalias" },
    { 0x8A167C77, "char_ger_hnrgrd_body2_m_g_torsoalias" },
    { 0x6F79E48D, "char_ger_honorgd2_bodyalias" },
    { 0xF4862F35, "char_ger_honorgd2_bodyzalias" },
    { 0xC8E40BAB, "char_ger_honorgd_bodyalias" },
    { 0xD738130B, "char_ger_honorgd_bodyzalias" },
    { 0xDE7493CC, "char_ger_honorgd_gearalias" },
    { 0x2337BB9D, "char_ger_honorgd_headalias" },
    { 0xD1905F07, "char_ger_honorgd_helmalias" },
    { 0x59DC522F, "char_ger_honorgd_zombieheadalias" },
    { 0xC138B9CD, "char_ger_honorguard2_flamethrower" },
    { 0xA3989000, "char_ger_honorguard2_mp44" },
    { 0xC34D0F1C, "char_ger_honorguard2_zombies" },
    { 0x53F5D57F, "char_ger_honorguard_flamethrower" },
    { 0xCBB5BB26, "char_ger_honorguard_mp44" },
    { 0x4A0ACE74, "char_ger_honorguard_off" },
    { 0x557117B6, "char_ger_honorguard_zombies" },
    { 0xB8B02F47, "char_ger_pnz_body1_g_larmoffalias" },
    { 0xF6A7D9F2, "char_ger_pnz_body1_g_legsoffalias" },
    { 0xF2C2824D, "char_ger_pnz_body1_g_llegoffalias" },
    { 0x8ECA57F5, "char_ger_pnz_body1_g_rarmoffalias" },
    { 0x09331183, "char_ger_pnz_body1_g_rlegoffalias" },
    { 0xCF0F5147, "char_ger_pnz_body1_g_torsoalias" },
    { 0x0F17D180, "char_ger_pnzgren_bodyalias" },
    { 0x7569D7CF, "char_ger_pnzgren_gearalias" },
    { 0xAD30DF78, "char_ger_pnzgren_helmalias" },
    { 0x8BDC1288, "char_ger_pnzgren_k98" },
    { 0x729B2423, "char_ger_pnzgren_mp40" },
    { 0x0AA50DC7, "char_ger_pnzgren_mp44" },
    { 0xE4DEDFE7, "char_ger_pnzgren_off" },
    { 0x06CC1779, "char_ger_pnzgren_wound" },
    { 0x96E7D893, "char_ger_volks_bodyalias" },
    { 0x3CB8ABD5, "char_ger_volks_headalias" },
    { 0xAFB8D7FF, "char_ger_volks_k98" },
    { 0x95DB3E72, "char_ger_volks_mp40" },
    { 0xDE41E61E, "char_ger_volks_wound" },
    { 0xC262B7E7, "char_ger_volkswet_bodyalias" },
    { 0x29B6DDE6, "char_ger_waffen_body1_g_larmoffalias" },
    { 0x0EDD5AE7, "char_ger_waffen_body1_g_legsoffalias" },
    { 0xEDDEAB44, "char_ger_waffen_body1_g_llegoffalias" },
    { 0x1BC3EAD8, "char_ger_waffen_body1_g_rarmoffalias" },
    { 0x28D7625E, "char_ger_waffen_body1_g_rlegoffalias" },
    { 0x2321D24A, "char_ger_waffen_body1_g_torsoalias" },
    { 0x328BA4ED, "char_ger_waffen_bodyalias" },
    { 0x8926DF36, "char_ger_waffen_gearalias" },
    { 0xDD1AB25F, "char_ger_waffen_headalias" },
    { 0x778D1EA9, "char_ger_waffen_helmalias" },
    { 0xB3FC6CC8, "char_ger_wrmcht_body1_g_larmoffalias" },
    { 0xBF74D14D, "char_ger_wrmcht_body1_g_legsoffalias" },
    { 0xDE75882E, "char_ger_wrmcht_body1_g_llegoffalias" },
    { 0x6807A036, "char_ger_wrmcht_body1_g_rarmoffalias" },
    { 0xBF11CAB4, "char_ger_wrmcht_body1_g_rlegoffalias" },
    { 0xA95107DC, "char_ger_wrmcht_body1_g_torsoalias" },
    { 0xD37E56FF, "char_ger_wrmcht_bodyalias" },
    { 0xD06334EB, "char_ger_wrmcht_dronealias" },
    { 0xE5D3F50B, "char_ger_wrmcht_flamethrower" },
    { 0xF9FE9110, "char_ger_wrmcht_gearalias" },
    { 0x165E55F3, "char_ger_wrmcht_helmalias" },
    { 0x4D8EE253, "char_ger_wrmcht_k98" },
    { 0x4E6A09FE, "char_ger_wrmcht_mp40" },
    { 0xB660205A, "char_ger_wrmcht_mp44" },
    { 0x9F1A0A90, "char_ger_wrmcht_off" },
    { 0x6ACF6E7F, "char_ger_wrmcht_see1_1" },
    { 0xF8C7FF44, "char_ger_wrmcht_see1_2" },
    { 0x1ECA79AD, "char_ger_wrmcht_see1_3" },
    { 0x4FE6D6FE, "char_ger_wrmcht_special" },
    { 0xDD1CAA4A, "char_ger_wrmcht_wound" },
    { 0xC804FE73, "char_ger_wrmchtwet_bodyalias" },
    { 0x60B35274, "char_ger_wrmchtwet_gearalias" },
    { 0xCDFD5A3F, "char_ger_wrmchtwet_helmalias" },
    { 0x6C5A9C5F, "char_ger_wrmchtwet_k98" },
    { 0x51C53ED2, "char_ger_wrmchtwet_mp40" },
    { 0xE9CF2876, "char_ger_wrmchtwet_mp44" },
    { 0x6F9CC004, "char_ger_wrmchtwet_off" },
    { 0x75B52DFE, "char_ger_wrmchtwet_wound" },
    { 0x097CDB8D, "char_ger_wrmwet_body1_g_larmoffalias" },
    { 0xDFA13A5C, "char_ger_wrmwet_body1_g_legsoffalias" },
    { 0xBAECDA1B, "char_ger_wrmwet_body1_g_llegoffalias" },
    { 0x3F570FCF, "char_ger_wrmwet_body1_g_rarmoffalias" },
    { 0x1E377D35, "char_ger_wrmwet_body1_g_rlegoffalias" },
    { 0x5606E87D, "char_ger_wrmwet_body1_g_torsoalias" },
    { 0xAC268DE1, "char_group" },
    { 0x06827D8D, "char_is_playing_anim" },
    { 0xE75208F4, "char_jap_impinf2_headalias" },
    { 0x0B67DA92, "char_jap_impinf2_helmalias" },
    { 0x1E6C50AE, "char_jap_impinf2_zombieheadalias" },
    { 0xF199BD12, "char_jap_impinf_body2_m_g_larmoffalias" },
    { 0x3B3B42CB, "char_jap_impinf_body2_m_g_legsoffalias" },
    { 0xEAAB6D90, "char_jap_impinf_body2_m_g_llegoffalias" },
    { 0x2C97240C, "char_jap_impinf_body2_m_g_rarmoffalias" },
    { 0x6F4811F2, "char_jap_impinf_body2_m_g_rlegoffalias" },
    { 0xC9D555E6, "char_jap_impinf_body2_m_g_torsoalias" },
    { 0xDC8DE186, "char_jap_impinf_body4_c_g_larmoffalias" },
    { 0x08845CE4, "char_jap_impinf_body4_c_g_llegoffalias" },
    { 0xB2A04F78, "char_jap_impinf_body4_c_g_rarmoffalias" },
    { 0xC71DA1FE, "char_jap_impinf_body4_c_g_rlegoffalias" },
    { 0xAA735CEA, "char_jap_impinf_body4_c_g_torsoalias" },
    { 0xEB949FCC, "char_jap_impinf_body4_g_larmoffalias" },
    { 0x2C560769, "char_jap_impinf_body4_g_legsoffalias" },
    { 0xBD6DF1B2, "char_jap_impinf_body4_g_llegoffalias" },
    { 0x85EC57D2, "char_jap_impinf_body4_g_rarmoffalias" },
    { 0x26A61850, "char_jap_impinf_body4_g_rlegoffalias" },
    { 0x84038EC0, "char_jap_impinf_body4_g_torsoalias" },
    { 0xEAA1F7A0, "char_jap_impinf_body4_m_g_larmoffalias" },
    { 0x9B1D17D5, "char_jap_impinf_body4_m_g_legsoffalias" },
    { 0xD74735C6, "char_jap_impinf_body4_m_g_llegoffalias" },
    { 0x30E2847E, "char_jap_impinf_body4_m_g_rarmoffalias" },
    { 0x2EB48C1C, "char_jap_impinf_body4_m_g_rlegoffalias" },
    { 0x96B47FC4, "char_jap_impinf_body4_m_g_torsoalias" },
    { 0x1B785A72, "char_jap_impinf_body4alias" },
    { 0x93D38F1D, "char_jap_impinf_body5_c_g_larmoffalias" },
    { 0x6C54AD4B, "char_jap_impinf_body5_c_g_llegoffalias" },
    { 0x034EE37F, "char_jap_impinf_body5_c_g_rarmoffalias" },
    { 0x431E9B05, "char_jap_impinf_body5_c_g_rlegoffalias" },
    { 0xAFC9450D, "char_jap_impinf_body5_c_g_torsoalias" },
    { 0x9D93564B, "char_jap_impinf_body5_g_larmoffalias" },
    { 0x81B3E24E, "char_jap_impinf_body5_g_legsoffalias" },
    { 0xC0BA9851, "char_jap_impinf_body5_g_llegoffalias" },
    { 0x654499F1, "char_jap_impinf_body5_g_rarmoffalias" },
    { 0x55597B8F, "char_jap_impinf_body5_g_rlegoffalias" },
    { 0xC57ACFAB, "char_jap_impinf_body5_g_torsoalias" },
    { 0xE7610ACD, "char_jap_impinf_body5alias" },
    { 0x2DFC843B, "char_jap_impinf_gear4alias" },
    { 0x7BEC8C48, "char_jap_impinf_gear5alias" },
    { 0x5DE5B994, "char_jap_impinf_headalias" },
    { 0xFA3B0F08, "char_jap_impinf_helm3_alias" },
    { 0x93959205, "char_jap_impinf_helm_oki_alias" },
    { 0x78D5530E, "char_jap_impinf_mk_b5_c_g_larmoffalias" },
    { 0x0846804C, "char_jap_impinf_mk_b5_c_g_llegoffalias" },
    { 0xBD87A710, "char_jap_impinf_mk_b5_c_g_rarmoffalias" },
    { 0x9EB2F2D6, "char_jap_impinf_mk_b5_c_g_rlegoffalias" },
    { 0x54952CC2, "char_jap_impinf_mk_b5_c_g_torsoalias" },
    { 0x56D836D2, "char_jap_impinf_mk_b5z_g_larmoffalias" },
    { 0xC53C3B8B, "char_jap_impinf_mk_b5z_g_legsoffalias" },
    { 0xF791F750, "char_jap_impinf_mk_b5z_g_llegoffalias" },
    { 0xBC807ECC, "char_jap_impinf_mk_b5z_g_rarmoffalias" },
    { 0x8E59D0B2, "char_jap_impinf_mk_b5z_g_rlegoffalias" },
    { 0x0A78FAA6, "char_jap_impinf_mk_b5z_g_torsoalias" },
    { 0x3A017BD9, "char_jap_impinf_mk_bdy5_g_larmoffalias" },
    { 0x9BFF11D0, "char_jap_impinf_mk_bdy5_g_legsoffalias" },
    { 0xC6690E17, "char_jap_impinf_mk_bdy5_g_llegoffalias" },
    { 0xE1A2EB43, "char_jap_impinf_mk_bdy5_g_rarmoffalias" },
    { 0xEDAC5269, "char_jap_impinf_mk_bdy5_g_rlegoffalias" },
    { 0xB4C51E09, "char_jap_impinf_mk_bdy5_g_torsoalias" },
    { 0xF3523AC7, "char_jap_impinf_mk_bdy5alias" },
    { 0x5CB6DA0D, "char_jap_impinf_player_assault" },
    { 0x4D537B9A, "char_jap_impinf_player_cqb" },
    { 0x6F79EFF8, "char_jap_impinf_player_hmg" },
    { 0x4C0B33DC, "char_jap_impinf_player_lmg" },
    { 0x61983942, "char_jap_impinf_player_rifle" },
    { 0xFBC70E33, "char_jap_impinf_player_smg" },
    { 0xC1601323, "char_jap_impinf_zombiebody5alias" },
    { 0x76D40868, "char_jap_impinfwet2_helmalias" },
    { 0x7B257DDC, "char_jap_impinfwet_body4alias" },
    { 0x20107E8F, "char_jap_impinfwet_body5alias" },
    { 0xB9BA50C5, "char_jap_impinfwet_gear4alias" },
    { 0xADFE514A, "char_jap_impinfwet_gear5alias" },
    { 0x98907C27, "char_jap_impinfwet_helm_oki_alias" },
    { 0xAF128920, "char_jap_impnav_bodyalias" },
    { 0x000FBC1E, "char_jap_infwet_body4_c_g_larmoffalias" },
    { 0x3A8D07BC, "char_jap_infwet_body4_c_g_llegoffalias" },
    { 0x3CE1E440, "char_jap_infwet_body4_c_g_rarmoffalias" },
    { 0x38A2C166, "char_jap_infwet_body4_c_g_rlegoffalias" },
    { 0x2A6BCC12, "char_jap_infwet_body4_c_g_torsoalias" },
    { 0x7F1AA074, "char_jap_infwet_body4_g_larmoffalias" },
    { 0xEB1026C1, "char_jap_infwet_body4_g_legsoffalias" },
    { 0x7F306A1A, "char_jap_infwet_body4_g_llegoffalias" },
    { 0xD5A92EEA, "char_jap_infwet_body4_g_rarmoffalias" },
    { 0x255B04E8, "char_jap_infwet_body4_g_rlegoffalias" },
    { 0xC5D77678, "char_jap_infwet_body4_g_torsoalias" },
    { 0x366D3C75, "char_jap_infwet_body5_c_g_larmoffalias" },
    { 0xB0D5F603, "char_jap_infwet_body5_c_g_llegoffalias" },
    { 0x605313C7, "char_jap_infwet_body5_c_g_rarmoffalias" },
    { 0x9A6566CD, "char_jap_infwet_body5_c_g_rlegoffalias" },
    { 0x750934F5, "char_jap_infwet_body5_c_g_torsoalias" },
    { 0xA991B413, "char_jap_infwet_body5_g_larmoffalias" },
    { 0xD663B766, "char_jap_infwet_body5_g_legsoffalias" },
    { 0x16606599, "char_jap_infwet_body5_g_llegoffalias" },
    { 0x38C07C89, "char_jap_infwet_body5_g_rarmoffalias" },
    { 0x749BD0E7, "char_jap_infwet_body5_g_rlegoffalias" },
    { 0x3CD07AA3, "char_jap_infwet_body5_g_torsoalias" },
    { 0xC96608AD, "char_jap_makin_interrogator" },
    { 0x390B2E5B, "char_jap_makin_officer" },
    { 0xC5663FA8, "char_jap_makonly_rifle" },
    { 0x815B7F9B, "char_jap_makonly_rifle_camo" },
    { 0xFA72E4EB, "char_jap_makpel_rifle" },
    { 0x72E488DE, "char_jap_makpel_rifle_camo" },
    { 0xC85F9BDF, "char_jap_makpelwet_rifle" },
    { 0x13B6C0C2, "char_jap_makpelwet_rifle_camo" },
    { 0x667D26FF, "char_jap_off" },
    { 0x99C18D7C, "char_jap_oki_rifle" },
    { 0xF07529BF, "char_jap_oki_rifle_camo" },
    { 0x0E69857C, "char_jap_pel2_rifle" },
    { 0x2A2F11BF, "char_jap_pel2_rifle_camo" },
    { 0xCFC12D52, "char_jap_rifle" },
    { 0xD8F0371D, "char_jap_rifle3" },
    { 0xC79A7986, "char_jap_zombie" },
    { 0xA21CB464, "char_jap_zombie_nocap" },
    { 0xFC5A204D, "char_japwet_off" },
    { 0x39C2F18E, "char_percent_override" },
    { 0x47FB3A70, "char_ramp" },
    { 0x538015B4, "char_ramp_time" },
    { 0x36FE171F, "char_rus_guard2_bodyalias" },
    { 0x06F20108, "char_rus_guard2_g_larmoffalias" },
    { 0xD000ED8D, "char_rus_guard2_g_legsoffalias" },
    { 0xA31F2F76, "char_rus_guard2_g_rarmoffalias" },
    { 0x6A8D311C, "char_rus_guard2_g_torsoalias" },
    { 0xFBC25430, "char_rus_guard2_gearalias" },
    { 0x98F3F27C, "char_rus_guard2_m_g_larmoffalias" },
    { 0x59C070D9, "char_rus_guard2_m_g_legsoffalias" },
    { 0xB98294C2, "char_rus_guard2_m_g_llegoffalias" },
    { 0x99C94562, "char_rus_guard2_m_g_rarmoffalias" },
    { 0x3B898040, "char_rus_guard2_m_g_rlegoffalias" },
    { 0x69FE9B70, "char_rus_guard2_m_g_torsoalias" },
    { 0xFA643145, "char_rus_guard_bodyalias" },
    { 0x960B4E29, "char_rus_guard_dronealias" },
    { 0x925731D2, "char_rus_guard_g_larmoffalias" },
    { 0x00BB368B, "char_rus_guard_g_legsoffalias" },
    { 0x3310F250, "char_rus_guard_g_llegoffalias" },
    { 0xF7FF79CC, "char_rus_guard_g_rarmoffalias" },
    { 0xC9D8CBB2, "char_rus_guard_g_rlegoffalias" },
    { 0xCE92BDA6, "char_rus_guard_g_torsoalias" },
    { 0x8B84CEEE, "char_rus_guard_gearalias" },
    { 0x5A1D3507, "char_rus_guard_headalias" },
    { 0x0206CD51, "char_rus_guard_helmalias" },
    { 0x706644F2, "char_rus_guard_m_g_larmoffalias" },
    { 0x153A70AB, "char_rus_guard_m_g_legsoffalias" },
    { 0xBEF83770, "char_rus_guard_m_g_llegoffalias" },
    { 0x23106AEC, "char_rus_guard_m_g_rarmoffalias" },
    { 0x20E419D2, "char_rus_guard_m_g_rlegoffalias" },
    { 0x4FC4D0C6, "char_rus_guard_m_g_torsoalias" },
    { 0x723B011C, "char_rus_guard_player_assault" },
    { 0xA85EABDB, "char_rus_guard_player_cqb" },
    { 0xFA5C7319, "char_rus_guard_player_hmg" },
    { 0xC21B2465, "char_rus_guard_player_lmg" },
    { 0xF791A8CB, "char_rus_guard_player_rifle" },
    { 0x4AA098C2, "char_rus_guard_player_smg" },
    { 0x45C02C4B, "char_rus_guardwet2_bodyalias" },
    { 0x076A6D04, "char_rus_guardwet2_g_larmoffalias" },
    { 0xD5518F51, "char_rus_guardwet2_g_legsoffalias" },
    { 0xF9A3E65A, "char_rus_guardwet2_g_rarmoffalias" },
    { 0x137346C8, "char_rus_guardwet2_g_torsoalias" },
    { 0x5226DF6C, "char_rus_guardwet2_gearalias" },
    { 0xEF7FCE39, "char_rus_guardwet_bodyalias" },
    { 0xBE7E7ED6, "char_rus_guardwet_g_larmoffalias" },
    { 0x937382D7, "char_rus_guardwet_g_legsoffalias" },
    { 0x8E7DD154, "char_rus_guardwet_g_llegoffalias" },
    { 0x421EFD68, "char_rus_guardwet_g_rarmoffalias" },
    { 0x3147C0CE, "char_rus_guardwet_g_rlegoffalias" },
    { 0xA39F65BA, "char_rus_guardwet_g_torsoalias" },
    { 0xA29578E2, "char_rus_guardwet_gearalias" },
    { 0xCCAB688D, "char_rus_guardwet_helmalias" },
    { 0xA0C9FDF8, "char_rus_h_commissar" },
    { 0x38431972, "char_rus_h_reznov" },
    { 0x3535F058, "char_rus_h_reznov_coat" },
    { 0xD16F4174, "char_rus_p_chernova" },
    { 0xE971E2B3, "char_rus_player1" },
    { 0x776A7378, "char_rus_player2" },
    { 0x9D6CEDE1, "char_rus_player3" },
    { 0x5B7951EE, "char_rus_player4" },
    { 0x11E3A95D, "char_rus_r_ppsh" },
    { 0x7F905CBC, "char_rus_r_ppsh_forsniper" },
    { 0xCA217386, "char_rus_r_rifle" },
    { 0x08F59C0D, "char_rus_tanker_helmalias" },
    { 0xD0BE19C9, "char_rus_tankerwet_helmalias" },
    { 0xC8DF1E4D, "char_rus_wet_h_reznov_coat" },
    { 0xBD963E93, "char_rus_wet_p_chernova" },
    { 0xABF91256, "char_rus_wet_player1" },
    { 0x85F697ED, "char_rus_wet_player2" },
    { 0x5FF41D84, "char_rus_wet_player3" },
    { 0x39F1A31B, "char_rus_wet_player4" },
    { 0x04123D66, "char_rus_wet_r_ppsh" },
    { 0xC2CB4B47, "char_rus_wet_r_rifle" },
    { 0x7107B3B0, "char_type" },
    { 0x03BF2E71, "char_usa_marine2_r_bar" },
    { 0xD3AB5B29, "char_usa_marine2_r_baz" },
    { 0x9C3245A5, "char_usa_marine2_r_nb_rifle" },
    { 0xD2FA7C5C, "char_usa_marine2_r_rifle" },
    { 0xB437E7CE, "char_usa_marine2_r_thompson" },
    { 0x634C0B70, "char_usa_marine_body1_g_larmoffalias" },
    { 0xCC74B76E, "char_usa_marine_body1_g_rarmoffalias" },
    { 0x4D4C7FD4, "char_usa_marine_body1_g_torsoalias" },
    { 0xC8353064, "char_usa_marine_body1_m_g_larmoffalias" },
    { 0xFC250AB1, "char_usa_marine_body1_m_g_legsoffalias" },
    { 0x2110F86A, "char_usa_marine_body1_m_g_llegoffalias" },
    { 0x3DA2E4BA, "char_usa_marine_body1_m_g_rarmoffalias" },
    { 0x44C6F958, "char_usa_marine_body1_m_g_rlegoffalias" },
    { 0x97ED7C28, "char_usa_marine_body1_m_g_torsoalias" },
    { 0x941B2E70, "char_usa_marine_body2_g_legsoffalias" },
    { 0x8D0475B7, "char_usa_marine_body2_g_llegoffalias" },
    { 0xADCBEC09, "char_usa_marine_body2_g_rlegoffalias" },
    { 0xE8FE4FE1, "char_usa_marine_body2_m_g_larmoffalias" },
    { 0x02C55D88, "char_usa_marine_body2_m_g_legsoffalias" },
    { 0x812E3B1F, "char_usa_marine_body2_m_g_llegoffalias" },
    { 0xBD022ADB, "char_usa_marine_body2_m_g_rarmoffalias" },
    { 0xE2785001, "char_usa_marine_body2_m_g_rlegoffalias" },
    { 0x2534E281, "char_usa_marine_body2_m_g_torsoalias" },
    { 0x62BA80C8, "char_usa_marine_h_comoff" },
    { 0xFFFD673B, "char_usa_marine_h_gunny" },
    { 0x5065ABB9, "char_usa_marine_h_miller" },
    { 0x30377B77, "char_usa_marine_h_polonsky" },
    { 0x1390474C, "char_usa_marine_h_pow" },
    { 0x1E07FEC5, "char_usa_marine_h_pow_cut" },
    { 0x2F6EE162, "char_usa_marine_h_sullivan" },
    { 0x3D65F3D9, "char_usa_marine_headalias" },
    { 0x83FD69EB, "char_usa_marine_helmalias" },
    { 0x26B93DF3, "char_usa_marine_player1" },
    { 0xB4B1CEB8, "char_usa_marine_player2" },
    { 0xDAB44921, "char_usa_marine_player3" },
    { 0x98C0AD2E, "char_usa_marine_player4" },
    { 0x6BF5778C, "char_usa_marine_playerf" },
    { 0x091ABD8B, "char_usa_marine_r_bar" },
    { 0x392E90D3, "char_usa_marine_r_baz" },
    { 0xEF24D02D, "char_usa_marine_r_corpsman" },
    { 0x0B4EC405, "char_usa_marine_r_flame" },
    { 0x1899BC9A, "char_usa_marine_r_nb_hshot_after" },
    { 0x432C51DD, "char_usa_marine_r_nb_hshot_before" },
    { 0x7F4ECC2F, "char_usa_marine_r_nb_rifle" },
    { 0x64ED1E13, "char_usa_marine_r_off" },
    { 0xFB9F4465, "char_usa_marine_r_radio" },
    { 0xB3490846, "char_usa_marine_r_rifle" },
    { 0x2759F612, "char_usa_marine_r_rifle_nostraphelm" },
    { 0xFBEA938D, "char_usa_marine_r_special" },
    { 0x7E9BC16C, "char_usa_marine_r_thompson" },
    { 0x525B5FB5, "char_usa_marine_r_wound" },
    { 0x465DDB0A, "char_usa_marine_wet_helmalias" },
    { 0xF8C5EDFD, "char_usa_marinewet2_r_bar" },
    { 0x28D9C145, "char_usa_marinewet2_r_baz" },
    { 0xFB12FB81, "char_usa_marinewet2_r_nb_rifle" },
    { 0xA27B5450, "char_usa_marinewet2_r_rifle" },
    { 0xB584C5EA, "char_usa_marinewet2_r_thompson" },
    { 0x7E7D57F3, "char_usa_marinewet_h_polonsky" },
    { 0xF2BB49D1, "char_usa_marinewet_h_roebuck" },
    { 0xE6079366, "char_usa_marinewet_h_sullivan" },
    { 0x9416F75F, "char_usa_marinewet_player1" },
    { 0x220F8824, "char_usa_marinewet_player2" },
    { 0x4812028D, "char_usa_marinewet_player3" },
    { 0xD60A9352, "char_usa_marinewet_player4" },
    { 0x6ACBDF50, "char_usa_marinewet_playerf" },
    { 0x6EA3916F, "char_usa_marinewet_r_bar" },
    { 0x9EB764B7, "char_usa_marinewet_r_baz" },
    { 0xB3AC18E1, "char_usa_marinewet_r_corpsman" },
    { 0x620018E9, "char_usa_marinewet_r_flame" },
    { 0x5E962286, "char_usa_marinewet_r_nb_hshot_after" },
    { 0xBCDE3BD9, "char_usa_marinewet_r_nb_hshot_before" },
    { 0xC3631DA3, "char_usa_marinewet_r_nb_rifle" },
    { 0x365C5B7F, "char_usa_marinewet_r_off" },
    { 0xDF85D719, "char_usa_marinewet_r_radio" },
    { 0xDA52B5D2, "char_usa_marinewet_r_rifle" },
    { 0xB6A4C390, "char_usa_marinewet_r_thompson" },
    { 0xBC1F1BA1, "char_usa_marinewet_r_wound" },
    { 0x27F0744A, "char_usa_marwet_body1_g_larmoffalias" },
    { 0xF18B47D4, "char_usa_marwet_body1_g_rarmoffalias" },
    { 0x73A5A7AE, "char_usa_marwet_body1_g_torsoalias" },
    { 0x5850BD7A, "char_usa_marwet_body2_g_legsoffalias" },
    { 0x28B45065, "char_usa_marwet_body2_g_llegoffalias" },
    { 0xA06731AB, "char_usa_marwet_body2_g_rlegoffalias" },
    { 0xBB0BF74A, "char_usa_navy_cap1alias" },
    { 0xAA21400B, "char_usa_navy_cap2alias" },
    { 0x02BBD658, "char_usa_navy_cap3alias" },
    { 0x80A25ABF, "char_usa_navy_r_gunner" },
    { 0x5D92F195, "char_usa_navy_r_off" },
    { 0x8CAFDC3E, "char_usa_navy_r_sailor" },
    { 0x52314EE7, "char_usa_navy_r_wound" },
    { 0x4F6BE452, "char_usa_navy_wetsailor1" },
    { 0x296969E9, "char_usa_navy_wetsailor2" },
    { 0x0366EF80, "char_usa_navy_wetsailor3" },
    { 0x0D78485F, "char_usa_navy_wetsailor4" },
    { 0x5D4A6429, "char_usa_pbycrew_copilot" },
    { 0x5E5FF7B8, "char_usa_pbycrew_engineer" },
    { 0xD0C0BCEE, "char_usa_pbycrew_gunner" },
    { 0x7288D702, "char_usa_pbycrew_pel2_gunner" },
    { 0x7DE648E3, "char_usa_pbycrew_pilot" },
    { 0x39E4AD09, "char_usa_pbycrew_radioop" },
    { 0x5B2C5525, "char_usa_raider_body1_g_larmoffalias" },
    { 0x52A0D2C4, "char_usa_raider_body1_g_legsoffalias" },
    { 0x66B39E53, "char_usa_raider_body1_g_llegoffalias" },
    { 0xA36D9D57, "char_usa_raider_body1_g_rarmoffalias" },
    { 0xFCC76A3D, "char_usa_raider_body1_g_rlegoffalias" },
    { 0x2A611AE5, "char_usa_raider_body1_g_torsoalias" },
    { 0x218FE149, "char_usa_raider_body2_g_legsoffalias" },
    { 0xA3B5AD92, "char_usa_raider_body2_g_llegoffalias" },
    { 0x2C639830, "char_usa_raider_body2_g_rlegoffalias" },
    { 0x0058F398, "char_usa_raider_bodyalias" },
    { 0xEDAB4647, "char_usa_raider_gearalias" },
    { 0x5A05B56A, "char_usa_raider_gearalias_nb" },
    { 0x6109ADF8, "char_usa_raider_h_gunny" },
    { 0xF3AE3DFE, "char_usa_raider_h_roebuck" },
    { 0xA2862B93, "char_usa_raider_h_sullivan" },
    { 0x703B133A, "char_usa_raider_headalias" },
    { 0x79C3F500, "char_usa_raider_helmalias" },
    { 0x0E654BAA, "char_usa_raider_p_king" },
    { 0xB3834CB4, "char_usa_raider_player1" },
    { 0x258ABBEF, "char_usa_raider_player2" },
    { 0xFF884186, "char_usa_raider_player3" },
    { 0x417BDD79, "char_usa_raider_player4" },
    { 0x996A6D5B, "char_usa_raider_player_assault" },
    { 0x2CFD9A70, "char_usa_raider_player_cqb" },
    { 0xB2F29A9A, "char_usa_raider_player_hmg" },
    { 0x39036646, "char_usa_raider_player_lmg" },
    { 0x992BA7C8, "char_usa_raider_player_rifle" },
    { 0x346678A1, "char_usa_raider_player_smg" },
    { 0xADF7C5FB, "char_usa_raider_playerf" },
    { 0x7F70C6FC, "char_usa_raider_r_bar" },
    { 0xDEF3B8E4, "char_usa_raider_r_pows" },
    { 0xB9230A5A, "char_usa_raider_r_radio" },
    { 0xA4EEF6A9, "char_usa_raider_r_rifle" },
    { 0x1B979761, "char_usa_raider_r_thompson" },
    { 0x3EC01AB2, "char_usa_raider_r_wound" },
    { 0xAC27F46A, "char_usa_raider_wet_gearalias" },
    { 0xEFF8231D, "char_usa_raider_wet_gearalias_nb" },
    { 0xEE765E3D, "char_zomb_player_0" },
    { 0xC873E3D4, "char_zomb_player_1" },
    { 0x3A7B530F, "char_zomb_player_2" },
    { 0x1478D8A6, "char_zomb_player_3" },
    { 0xF2205AA2, "character" },
    { 0xF5C33D2E, "character_alpha_channel_test" },
    { 0x9FB75917, "character_arab_civilian_a" },
    { 0x2DAFE9DC, "character_arab_civilian_b" },
    { 0x53B26445, "character_arab_civilian_c" },
    { 0xE1AAF50A, "character_arab_civilian_d" },
    { 0x1CE000DE, "character_arab_civilian_e_fem" },
    { 0x901FD911, "character_arab_civilian_f_fem" },
    { 0xE60612BB, "character_comparison_controls" },
    { 0x15737250, "character_customization" },
    { 0xFFF1CE0D, "character_dead_russian_loyalist_a" },
    { 0x25F44876, "character_dead_russian_loyalist_b" },
    { 0x4BF6C2DF, "character_dead_russian_loyalist_c" },
    { 0xDBF1EB21, "character_fire_death_sm" },
    { 0x65D79FFE, "character_fire_death_torso" },
    { 0x5E843187, "character_fire_pain_sm" },
    { 0x99BE3680, "character_gets_gassed" },
    { 0x5088BF33, "character_index" },
    { 0x2DD71368, "character_index_cache" },
    { 0x6D0EC528, "character_mp_arab_regular_assault" },
    { 0xF99482AF, "character_mp_arab_regular_cqb" },
    { 0xE30F00FC, "character_mp_arab_regular_engineer" },
    { 0x46FE4E76, "character_mp_arab_regular_sniper" },
    { 0x78E9A93C, "character_mp_arab_regular_support" },
    { 0x75DDDC03, "character_mp_german_shepherd" },
    { 0x06EF9025, "character_mp_opforce_assault" },
    { 0x0B4F3542, "character_mp_opforce_cqb" },
    { 0xD903CA77, "character_mp_opforce_engineer" },
    { 0x68402B19, "character_mp_opforce_sniper" },
    { 0x445B10ED, "character_mp_opforce_support" },
    { 0x3437E9B8, "character_mp_opforce_urban_assault" },
    { 0x83244C1F, "character_mp_opforce_urban_cqb" },
    { 0x29C91C0C, "character_mp_opforce_urban_engineer" },
    { 0xA027EE86, "character_mp_opforce_urban_sniper" },
    { 0xFCE8B3CC, "character_mp_opforce_urban_support" },
    { 0x4D50A9D1, "character_mp_sas_urban_assault" },
    { 0xEC5EBFB9, "character_mp_sas_urban_recon" },
    { 0x6027FE55, "character_mp_sas_urban_sniper" },
    { 0xFD83B18B, "character_mp_sas_urban_specops" },
    { 0xE80BFD69, "character_mp_sas_urban_support" },
    { 0x015F03F9, "character_mp_usmc_assault" },
    { 0x9C182411, "character_mp_usmc_recon" },
    { 0x3464DDBD, "character_mp_usmc_sniper" },
    { 0xC5F9D6B3, "character_mp_usmc_specops" },
    { 0x8B936AB1, "character_mp_usmc_support" },
    { 0x484B6E84, "character_mp_usmc_woodland_assault" },
    { 0xAF1AB6BC, "character_mp_usmc_woodland_recon" },
    { 0x9A4F1F22, "character_mp_usmc_woodland_sniper" },
    { 0xB5A578AA, "character_mp_usmc_woodland_specops" },
    { 0x4C97CBD8, "character_mp_usmc_woodland_support" },
    { 0xF7AF1630, "character_name" },
    { 0x6B6D9D9B, "character_names" },
    { 0x8EA08A6F, "character_origin" },
    { 0x740F1348, "character_sp_al_asad" },
    { 0x3D5982A5, "character_sp_al_asad_dmg" },
    { 0xF0DA9436, "character_sp_arab_regular_asad" },
    { 0xDFE1FD37, "character_sp_arab_regular_coup_b" },
    { 0x9BCCEA55, "character_sp_arab_regular_sadiq" },
    { 0x608FB1D3, "character_sp_arab_regular_ski_mask" },
    { 0x41B0D7AB, "character_sp_arab_regular_ski_mask2" },
    { 0x65737850, "character_sp_arab_regular_suren" },
    { 0x4880CBC0, "character_sp_arab_regular_tariq" },
    { 0xCAB7A1CB, "character_sp_arab_regular_yasir" },
    { 0x66E8DCEA, "character_sp_german_sheperd_dog" },
    { 0x61D48133, "character_sp_opforce_a" },
    { 0xEFCD11F8, "character_sp_opforce_b" },
    { 0x15CF8C61, "character_sp_opforce_c" },
    { 0xE5DB0338, "character_sp_opforce_collins" },
    { 0xD3DBF06E, "character_sp_opforce_d" },
    { 0x4682541F, "character_sp_opforce_derik" },
    { 0xF9DE6AD7, "character_sp_opforce_e" },
    { 0x87D6FB9C, "character_sp_opforce_f" },
    { 0x61FB1A59, "character_sp_opforce_geoff" },
    { 0x80588A7F, "character_sp_opforce_vip" },
    { 0x03C62CED, "character_sp_pilot_velinda_desert" },
    { 0x8A4A15EE, "character_sp_pilot_velinda_woodland" },
    { 0x593E6ED1, "character_sp_pilot_zack_desert" },
    { 0xA155539A, "character_sp_pilot_zack_woodland" },
    { 0x38040574, "character_sp_russian_farmer" },
    { 0x5E9585D0, "character_sp_russian_loyalist_a" },
    { 0xD09CF50B, "character_sp_russian_loyalist_b" },
    { 0xAA9A7AA2, "character_sp_russian_loyalist_c" },
    { 0x1CA1E9DD, "character_sp_russian_loyalist_d" },
    { 0x9A6D9743, "character_sp_sas_ac130" },
    { 0xDAEADF3B, "character_sp_sas_ct_benjamin" },
    { 0x23D8E86D, "character_sp_sas_ct_charles" },
    { 0xE18B0719, "character_sp_sas_ct_mitchel" },
    { 0x5B8F0727, "character_sp_sas_ct_neal" },
    { 0x8BA711DA, "character_sp_sas_ct_price" },
    { 0x76D84D16, "character_sp_sas_ct_price_maskup" },
    { 0xA752003E, "character_sp_sas_ct_william" },
    { 0xC3BAFADA, "character_sp_sas_nvg_price" },
    { 0xA8C9DDCA, "character_sp_sas_woodland_gaz" },
    { 0x4465878C, "character_sp_sas_woodland_hugh" },
    { 0x921172CD, "character_sp_sas_woodland_mac" },
    { 0xF1F14762, "character_sp_sas_woodland_peter" },
    { 0xDCF85D2B, "character_sp_sas_woodland_price" },
    { 0x0062987F, "character_sp_sas_woodland_todd" },
    { 0x9CB031A8, "character_sp_sas_woodland_zied" },
    { 0x24DFA84E, "character_sp_spetsnaz_ac130" },
    { 0xD84B5E83, "character_sp_spetsnaz_boris" },
    { 0x19D81EA4, "character_sp_spetsnaz_collins" },
    { 0x9AABCB34, "character_sp_spetsnaz_demetry" },
    { 0xA6CC126B, "character_sp_spetsnaz_derik" },
    { 0xBF3AE09D, "character_sp_spetsnaz_geoff" },
    { 0x19961AD3, "character_sp_spetsnaz_vlad" },
    { 0x0C766AAF, "character_sp_spetsnaz_yuri" },
    { 0x7588948F, "character_sp_usmc_at4" },
    { 0xD312CF4F, "character_sp_usmc_force_a" },
    { 0x610B6014, "character_sp_usmc_force_b" },
    { 0x870DDA7D, "character_sp_usmc_force_c" },
    { 0x8A2C9325, "character_sp_usmc_force_mark" },
    { 0x25B453D7, "character_sp_usmc_force_mark_no_helmet" },
    { 0xB5596848, "character_sp_usmc_ghillie_price" },
    { 0xFDBB6ECA, "character_sp_usmc_james" },
    { 0x252E0D2C, "character_sp_usmc_james_nod" },
    { 0xF5BFE155, "character_sp_usmc_mark" },
    { 0x0F44190B, "character_sp_usmc_mark_nod" },
    { 0x807DBAF4, "character_sp_usmc_ryan" },
    { 0x72CFBEFA, "character_sp_usmc_ryan_nod" },
    { 0xC8A518EC, "character_sp_usmc_sami" },
    { 0x69E120E1, "character_sp_usmc_sami_goggles" },
    { 0x0753C0E2, "character_sp_usmc_sami_nod" },
    { 0x38BC4747, "character_sp_usmc_vasquez" },
    { 0xFE31A20C, "character_sp_usmc_zach" },
    { 0x7DA2B3C1, "character_sp_usmc_zach_goggles" },
    { 0xA64604C2, "character_sp_usmc_zach_nod" },
    { 0x84953793, "character_sp_zakhaev" },
    { 0x8FDAF51D, "character_sp_zakhaev_gimp" },
    { 0x4005CC5C, "character_sp_zakhaev_onearm" },
    { 0x6703A9E3, "character_sp_zakhaevs_son" },
    { 0x8C923783, "character_sp_zakhaevs_son_coup" },
    { 0x1EE931BE, "character_sp_zombie_dog" },
    { 0xC0398C14, "character_sp_zombie_dog_black_fur" },
    { 0x4D028D09, "character_type" },
    { 0x36540257, "character_vip_pres" },
    { 0x5BCF49F0, "character_wake_start" },
    { 0x0AB24E3C, "character_wake_stop" },
    { 0xA699977C, "charactercustomizationsetup" },
    { 0xBB21E55B, "characterdistancetomove" },
    { 0xF99B9C39, "characterent" },
    { 0x1DDE3AA8, "characterfacedirection" },
    { 0x0E47BA99, "characterid_count" },
    { 0xD733DE8E, "characterindex" },
    { 0xD1F52927, "charactermode" },
    { 0x24BFF2D9, "charactermodel" },
    { 0x3247F1A0, "characterrespawnpoint" },
    { 0x85B2736D, "characters" },
    { 0xDD6DEC91, "characters_in_nml" },
    { 0x3A4D24EE, "characterstartindex" },
    { 0x817FF204, "characterwithinplayersview" },
    { 0xD63E286A, "charage" },
    { 0x5224A674, "charcoal" },
    { 0xDB4CEF39, "chardesired" },
    { 0x1D045C88, "chargable" },
    { 0x849336BD, "charge" },
    { 0xEA950A8E, "charge1" },
    { 0xC4929025, "charge2" },
    { 0x8F7A80C3, "charge_ambient_explosions" },
    { 0x95222BEF, "charge_at_dir" },
    { 0x36A62785, "charge_at_player" },
    { 0xBB9E5514, "charge_at_players" },
    { 0xBE5CA9FB, "charge_at_position" },
    { 0xF21448E7, "charge_btrs" },
    { 0x0DCE4C40, "charge_done" },
    { 0x7632825F, "charge_exit_stage" },
    { 0xFCA67DD6, "charge_init" },
    { 0x93DE692A, "charge_loop" },
    { 0x701190B4, "charge_planted" },
    { 0x47D28C13, "charge_player_at_storefight" },
    { 0x7CD562F5, "charge_player_dudes" },
    { 0xCF882026, "charge_range_sq" },
    { 0xD20E0488, "charge_range_sq_vs_player" },
    { 0x1A3D5A65, "charge_ready" },
    { 0x64424705, "charge_stage_logic" },
    { 0x2CFE1FF7, "charge_starts" },
    { 0x7EBF9EFE, "charge_trig" },
    { 0x624AD164, "charge_trigger" },
    { 0x36CCDBBB, "charge_up_hill" },
    { 0x97C75A83, "charged" },
    { 0xB3ACE9FE, "charged_rocket" },
    { 0xCA97ABFF, "chargedbullethintshown" },
    { 0x1341006D, "chargedistsq" },
    { 0x4107E9BD, "chargelevel" },
    { 0x58B1068E, "chargelongrangesq" },
    { 0x4AD6D65A, "chargemeleedistance" },
    { 0x43F3F5E5, "charger" },
    { 0xA07D5684, "chargerangesq" },
    { 0x8C7B9BF4, "chargers" },
    { 0x1DF17B7C, "charges" },
    { 0x9A544EA2, "charges_received" },
    { 0xA7BF40BD, "chargeshotlevel" },
    { 0xDDB01168, "charging" },
    { 0x56D4F4CA, "charging_horse_spawners" },
    { 0xD0F90C57, "charinc" },
    { 0xDF132FE7, "charindex" },
    { 0xD3C5CB45, "charindex_cb" },
    { 0x50909A5A, "charindexarray" },
    { 0xBB011CCB, "charity" },
    { 0x17DD3185, "charlie" },
    { 0xEA6D67B1, "charlie_stop_idle" },
    { 0xEF12E1BC, "charmodel" },
    { 0x36D425C5, "charmodel_index" },
    { 0x6849D67F, "charmodels" },
    { 0xF730D11A, "charred" },
    { 0x796C75FB, "charring" },
    { 0xD7EA3D53, "charring_ai_over_time" },
    { 0x2EBAC604, "chars" },
    { 0x303E8B06, "charsteps" },
    { 0x4FFBB949, "chase" },
    { 0x4BBE7C32, "chase_after_target" },
    { 0x8D8ED22B, "chase_anim" },
    { 0xC9ECE20A, "chase_anims" },
    { 0x6E9A2363, "chase_boats_slots" },
    { 0x801E59C6, "chase_bus" },
    { 0xF117AD53, "chase_bus_entry" },
    { 0xF10A3562, "chase_bus_update" },
    { 0x6B775144, "chase_chopper_guys_land" },
    { 0x86D113AF, "chase_damage" },
    { 0xF520DB7C, "chase_dialog" },
    { 0xB3D690E9, "chase_downsquads" },
    { 0x956F91C4, "chase_escort_mig_1" },
    { 0x077700FF, "chase_escort_mig_2" },
    { 0x1F520951, "chase_friendlies" },
    { 0xAD11BCA0, "chase_guy_think" },
    { 0x0772DA1D, "chase_heli_armada" },
    { 0x20DE7911, "chase_jump_cleared" },
    { 0x4EF5EAF3, "chase_left_truck" },
    { 0xB69C02CA, "chase_left_uaz" },
    { 0x30E47C6D, "chase_logic_override" },
    { 0xB88D76BD, "chase_mig_1" },
    { 0xDE8FF126, "chase_mig_2" },
    { 0x29D99F20, "chase_node" },
    { 0x700FC904, "chase_objectives" },
    { 0xB00B819B, "chase_player" },
    { 0xE0F5CD8A, "chase_pos" },
    { 0xF004AABB, "chase_pos_index" },
    { 0xE7F37E6E, "chase_pos_time" },
    { 0xB8254828, "chase_sequence_fail_state" },
    { 0xA18DFD23, "chase_setup" },
    { 0x2322B744, "chase_threat" },
    { 0x7868C652, "chase_truck_logic" },
    { 0xF80DFC3C, "chase_uaz" },
    { 0xF2E4665F, "chase_update" },
    { 0x9D30EF17, "chase_vehicles" },
    { 0xA8F7F041, "chase_vo" },
    { 0x6B81324B, "chasecarrier" },
    { 0x8A9DE4AF, "chased" },
    { 0x46675FA9, "chaser" },
    { 0xB7E0C332, "chaser1" },
    { 0x91DE48C9, "chaser2" },
    { 0x0DF6C55D, "chaser_goal" },
    { 0xEB3D3420, "chasers" },
    { 0x2064E540, "chases" },
    { 0xC06C6206, "chasethreattime" },
    { 0xD038CB92, "chasewanderfwddot" },
    { 0xB755D2A0, "chasewandermax" },
    { 0x647E63DE, "chasewandermin" },
    { 0x6BAB2B39, "chasewanderspacing" },
    { 0xC895F37C, "chasing" },
    { 0xB62B0F05, "chastise" },
    { 0xF6BBDA78, "chastisements" },
    { 0x8B1C41BA, "chastiseused" },
    { 0xCD198663, "chat" },
    { 0x56E7284F, "chatattarget" },
    { 0x8BE8C718, "chatcount" },
    { 0x593DDA31, "chatevent" },
    { 0x0077BCAB, "chatinitialized" },
    { 0x11ACB862, "chatpad" },
    { 0x74C129F4, "chatphrase" },
    { 0xD88D67D4, "chatqueue" },
    { 0xC71B7A52, "chats" },
    { 0x1034779C, "chatter" },
    { 0xEF8A2BDF, "chatters" },
    { 0x7091939B, "chatting" },
    { 0x1DF0527E, "chattter" },
    { 0xCE4248E3, "chc_bls" },
    { 0x996AE136, "cheap" },
    { 0x64DD6BDF, "cheaper" },
    { 0x0160F792, "cheat" },
    { 0x4BBA45CC, "cheat_bw" },
    { 0xA3C58817, "cheat_callback_playerdamage" },
    { 0xED9FB3C7, "cheat_complete_stage" },
    { 0xB68FA2A8, "cheat_craftables" },
    { 0x00878B60, "cheat_enabled" },
    { 0xB104A3AA, "cheat_out_of_playable_area" },
    { 0xFBD78373, "cheat_reload_stinger_when_not_primary_and_on_horse" },
    { 0x39796A29, "cheat_too_friendly" },
    { 0x8A4A0A23, "cheat_too_many_weapons" },
    { 0xBAB3E191, "cheat_total" },
    { 0x9E8B16DF, "cheatammo_override" },
    { 0x5D235512, "cheatammoifnecessary" },
    { 0x47C26379, "cheatammoifrunningbackward" },
    { 0x833C0DD6, "cheatbobamporiginal" },
    { 0xE56C7CD0, "cheatdvars" },
    { 0xBADA6443, "cheater" },
    { 0x6FC4F372, "cheater_found" },
    { 0x6F9490B2, "cheaters" },
    { 0xD8E978B0, "cheatfunc" },
    { 0x7A56AD1B, "cheatfuncs" },
    { 0xA507E024, "cheatgrainlooper" },
    { 0xDF20B59E, "cheating" },
    { 0xB6DCFF9D, "cheats" },
    { 0xED598081, "cheatshowslowmohint" },
    { 0xD7AF4C88, "cheatstates" },
    { 0x34682035, "cheattirecount" },
    { 0x38C46B05, "cheatvalue" },
    { 0x9E7EFDF3, "check" },
    { 0xEEBFA490, "check1" },
    { 0x60C713CB, "check2" },
    { 0xCA49DEDA, "check_actor_damage_callbacks" },
    { 0x893930A5, "check_ai_existance" },
    { 0x856766D0, "check_ai_onboard" },
    { 0x43FB92ED, "check_alert_one" },
    { 0x7480CBA9, "check_alert_three" },
    { 0xC7CAAEBB, "check_alert_two" },
    { 0x83F3FF4B, "check_ally_in_sights" },
    { 0xD926050A, "check_ambience" },
    { 0x32E9586C, "check_and_build_trigger_from_unitrigger_stub" },
    { 0x1BFA9EB9, "check_and_create_node_lists" },
    { 0xEE13B467, "check_and_print_damage" },
    { 0x0C0D93BB, "check_and_set_interrogation_failure" },
    { 0xA02C6360, "check_ang_and_dist_to_node" },
    { 0x9AAD3B5B, "check_angle" },
    { 0x4AC019BC, "check_annihilator_death" },
    { 0x8489EC01, "check_array" },
    { 0x3B03B43A, "check_b_valid_poi" },
    { 0x23F7E822, "check_base_alert" },
    { 0x8416D88E, "check_base_death" },
    { 0xF5456EE4, "check_behind_mansion" },
    { 0x6A30C8F9, "check_binocular" },
    { 0x99C16780, "check_blackjack_challenge" },
    { 0x977485B4, "check_bolt_impact" },
    { 0xDFFB5E8F, "check_bombsquad_visibility" },
    { 0x52949700, "check_boost_start_conversation" },
    { 0xD0C6AF76, "check_breach_grenade" },
    { 0x0C1A26EB, "check_breach_reload" },
    { 0x2E2C838D, "check_breach_timeout" },
    { 0x6808D59F, "check_bunker_1st_room_enemies" },
    { 0x0C74865F, "check_bunker_clear" },
    { 0xD79BBA50, "check_bunker_near_clear" },
    { 0xB927D773, "check_bus_attack" },
    { 0x5007B2E1, "check_challenge" },
    { 0xDBBE36D6, "check_choppers" },
    { 0x19373475, "check_civ_status" },
    { 0xB21F03DB, "check_close_to_stuck_inf" },
    { 0x9DA2D4D3, "check_collector_achievement" },
    { 0xE5001CF3, "check_comms_clear" },
    { 0xF8C988D7, "check_comms_clear_from_ai" },
    { 0x97147E7D, "check_compound" },
    { 0x56C62FF7, "check_contextual_actions" },
    { 0xB526D623, "check_contract_expirations" },
    { 0x60DB27F9, "check_control_room" },
    { 0xD99C7A4A, "check_courtyard_almost_clear" },
    { 0xB48E428F, "check_courtyard_enemies_dead" },
    { 0x9E07E572, "check_craftable_table_valid" },
    { 0x5550A096, "check_crossbow_explosive" },
    { 0x8C149ED3, "check_damaged_by_player" },
    { 0x9B5E0138, "check_detonation_dist" },
    { 0xABE0C68A, "check_dist" },
    { 0x2EDAD3C8, "check_dist_squared" },
    { 0x0C3E6F2A, "check_dist_to_cave" },
    { 0xAED0B2E7, "check_distance_from_convoy" },
    { 0x4FB18AC2, "check_do_zombie_fall" },
    { 0x7B225277, "check_dog_death" },
    { 0xBBE83649, "check_dog_handler" },
    { 0x7AE65E23, "check_drone_throttle" },
    { 0x51BB7FE5, "check_end" },
    { 0xA04C8FE5, "check_end_game_intermission_delay" },
    { 0x4CF8BBBD, "check_end_solo_game_override" },
    { 0x0A0B1DE5, "check_enemy_in_sights" },
    { 0xF193D955, "check_ent" },
    { 0x1A6F8BFC, "check_explosion_radius" },
    { 0x169485A9, "check_explosive_tip" },
    { 0x9FA24522, "check_fastrope_que" },
    { 0x6B69834C, "check_flag" },
    { 0x569882F7, "check_flag_for_stat_tracking" },
    { 0x6D82E1EE, "check_for_abrupt_end" },
    { 0x5D048F8A, "check_for_accel" },
    { 0x5D342E3A, "check_for_achievements" },
    { 0xE5B2D7BD, "check_for_achievements_frontend" },
    { 0x9529EFB8, "check_for_ai_being_killed" },
    { 0x4CC24155, "check_for_alternate_poi" },
    { 0x06A3ED26, "check_for_approach" },
    { 0x29EFDE53, "check_for_arty_dead" },
    { 0x9BDF4782, "check_for_arty_destroyed" },
    { 0xD04FBE78, "check_for_avoid_poi" },
    { 0xCF510145, "check_for_being_in_help_area" },
    { 0x8FA1FA0F, "check_for_blood_splat" },
    { 0x01414492, "check_for_both_arty_destroyed" },
    { 0x7C1D854C, "check_for_break_attack_path" },
    { 0x100F5A3A, "check_for_buildable_jetgun_vox" },
    { 0xA781BC0C, "check_for_buildable_turbine_vox" },
    { 0xD9160FCF, "check_for_bullet_hole" },
    { 0xD2B03C06, "check_for_bump" },
    { 0x08AC7562, "check_for_change" },
    { 0x06432D23, "check_for_claw_damaged" },
    { 0xB1DE5F75, "check_for_claw_move_complete" },
    { 0x7233263A, "check_for_close" },
    { 0x45F31DD9, "check_for_close_players" },
    { 0xA3DAACFC, "check_for_convoy_success" },
    { 0xA9A1B7FD, "check_for_damage" },
    { 0x2E60867B, "check_for_damage_notify" },
    { 0x41E27C7D, "check_for_damage_on_rocket_piece" },
    { 0xA0204230, "check_for_death" },
    { 0x5F09DD7B, "check_for_death_on_gondola" },
    { 0xBB018E91, "check_for_decel" },
    { 0x45DD6DA1, "check_for_desirable_chest_location" },
    { 0x569D78CB, "check_for_disable_big_jump2_trigger" },
    { 0xD6260999, "check_for_donkeykong_house_cleared" },
    { 0xDF42BB0B, "check_for_door_close" },
    { 0x2F0AA9E4, "check_for_drops" },
    { 0x6C7B53D5, "check_for_dupes" },
    { 0xC3B5116F, "check_for_egg_damage" },
    { 0xBEF7D710, "check_for_either_arty_destroyed" },
    { 0xBF411BF0, "check_for_enemies_within_threshold" },
    { 0x683442CA, "check_for_enemy" },
    { 0x9AB5EEB2, "check_for_enemy_target" },
    { 0x4DBC52E6, "check_for_fail" },
    { 0x55607DDF, "check_for_failed_revive" },
    { 0x3B8CD838, "check_for_falling_death" },
    { 0xCF26EFEC, "check_for_fatal_damage" },
    { 0x9AE4300D, "check_for_final_push_enemies_dead" },
    { 0x2B4E5954, "check_for_flamethrower" },
    { 0x2C13F75D, "check_for_free_locations" },
    { 0xA1DF991E, "check_for_friendly_fire" },
    { 0x35177830, "check_for_friendly_fire_noriega" },
    { 0xC872AFD8, "check_for_grenade" },
    { 0xCEC03B17, "check_for_grenade_damage_on_window" },
    { 0xE22FDE8D, "check_for_grenade_throw" },
    { 0xE3761E35, "check_for_gunner_leaving_mg" },
    { 0x840D5E2C, "check_for_helath_state" },
    { 0x517AA3BC, "check_for_idle" },
    { 0x684D9FCD, "check_for_initial_mg_gunners_dead" },
    { 0x3308D17F, "check_for_instakill" },
    { 0x2A9FE92A, "check_for_instakill_override" },
    { 0x22D3FDA6, "check_for_jugg_perk" },
    { 0x2C566E2E, "check_for_jump" },
    { 0x6808DBF3, "check_for_killer" },
    { 0x999F15B7, "check_for_landing" },
    { 0xD04A365E, "check_for_launchpad_spawn_required" },
    { 0x248F94E5, "check_for_leaving_players" },
    { 0x4EB8D686, "check_for_level_end" },
    { 0x445F1C0C, "check_for_lookat_triggers" },
    { 0xC4CF74DC, "check_for_occupied_spots" },
    { 0xD45A92F8, "check_for_panzershreck_hit" },
    { 0x44130A23, "check_for_pers_headshot" },
    { 0x6D4C9B2E, "check_for_player_direct_attack" },
    { 0xCBC7EE6F, "check_for_player_proximity" },
    { 0xB7735297, "check_for_player_switch_or_time_jump" },
    { 0x020E9F6B, "check_for_players_mid_grapple" },
    { 0x09929EB9, "check_for_price" },
    { 0xFACEDDCC, "check_for_range_and_los" },
    { 0xD13BE111, "check_for_rare_drop_override" },
    { 0x97FF65BD, "check_for_reload_complete" },
    { 0xF38366A7, "check_for_richtofen_c_failure" },
    { 0x47B2D33C, "check_for_round_end" },
    { 0xE9F65331, "check_for_sacrifice" },
    { 0xBE733F1F, "check_for_selected_target" },
    { 0xBF793871, "check_for_similar_deaths" },
    { 0x4E7CB87C, "check_for_solo_game" },
    { 0x393EFF2A, "check_for_special_weapon_limit_exist" },
    { 0x0AAF9C3F, "check_for_sr71_triggers" },
    { 0x68419078, "check_for_successful_save" },
    { 0xCE5FC639, "check_for_target" },
    { 0x3E867A9C, "check_for_targethit" },
    { 0x94ED8080, "check_for_time_jump" },
    { 0xB61EBDC8, "check_for_time_out" },
    { 0x75E0A89D, "check_for_tow_being_fired" },
    { 0xD542DC38, "check_for_tow_manual_destruction" },
    { 0x4A6C9600, "check_for_tow_missing_rocket" },
    { 0x56AE621B, "check_for_tower_damage" },
    { 0x2D835063, "check_for_turn" },
    { 0xD234DD97, "check_for_valid_spawn_in_zone" },
    { 0x8D237445, "check_for_valid_spawn_near_position" },
    { 0xF31D4D6F, "check_for_valid_spawn_near_team" },
    { 0xAE831CF3, "check_for_valid_spawn_near_team_callback" },
    { 0x3046E030, "check_for_valid_spawn_within_range" },
    { 0xF3A8940C, "check_for_visible" },
    { 0xA60B1C79, "check_for_weapon_fire" },
    { 0xE02AE7CB, "check_for_weapon_fire_hit" },
    { 0x624DF642, "check_for_weaponfire" },
    { 0xB232DA0A, "check_for_weaver_damage" },
    { 0xD20C5641, "check_for_webm" },
    { 0xA660FD6F, "check_for_wind_override" },
    { 0x5D6FF2EF, "check_for_zombie_death" },
    { 0xFCFA274F, "check_for_zombie_in_wolf_area" },
    { 0x0E3D0C97, "check_force_color" },
    { 0x9221DEFC, "check_force_deploy_origin" },
    { 0x03E82F48, "check_force_deploy_z" },
    { 0xD90BDBA7, "check_force_gesture" },
    { 0x93DDF1A2, "check_force_taunt" },
    { 0x54F32014, "check_frequency" },
    { 0x0B6FE7E0, "check_friends_positions" },
    { 0x073AE307, "check_fueler" },
    { 0x479EADC4, "check_func" },
    { 0x5A99297B, "check_gaz_guys" },
    { 0x0CE82716, "check_glaive_playable_area_conditions" },
    { 0x1BE3A885, "check_graphic_intro" },
    { 0xE336E68D, "check_grapple_target" },
    { 0x3A0893C0, "check_grenade" },
    { 0x0690DC05, "check_guys_ready_for_campfire_attack" },
    { 0x1BAD2BB1, "check_handler_death" },
    { 0xC3230FB6, "check_hatchet_bounce" },
    { 0xE58F137F, "check_headchopper_in_bad_area" },
    { 0xC18D1026, "check_helicopter_death" },
    { 0x0F317015, "check_hitloc" },
    { 0xEA437F9D, "check_if_alive" },
    { 0x7DD43011, "check_if_empty_floors" },
    { 0x2548D3E4, "check_if_hatchet_will_hit" },
    { 0xBE87726C, "check_if_in_volume" },
    { 0x75EBC984, "check_if_newly_found" },
    { 0x1C1A3AC1, "check_if_player_jumps_in_copter_blades" },
    { 0x0A6F8462, "check_if_second_building_hit_by_molotov" },
    { 0x211844BA, "check_if_second_enemyattack_done" },
    { 0x46F44AA6, "check_if_sighted" },
    { 0x02981F09, "check_if_target_behind_me" },
    { 0xF3C36DAE, "check_in_arc" },
    { 0xAA921E4A, "check_in_interference" },
    { 0xAB09E69D, "check_interactive_hands" },
    { 0xB9959312, "check_item_found" },
    { 0x9E0C71B6, "check_kill_damage" },
    { 0x889E7A48, "check_kill_sniper" },
    { 0x3D984647, "check_kill_thread_every_frame" },
    { 0xD67CC4C0, "check_launch_space" },
    { 0x65519BDD, "check_leave_area" },
    { 0xC1D61355, "check_left" },
    { 0x1006C4ED, "check_localpower_list" },
    { 0x997812CE, "check_magic_box_valid" },
    { 0x994389C1, "check_maze_achievement_threads" },
    { 0xF1FDB796, "check_melee" },
    { 0xB901A820, "check_melee_path" },
    { 0x5706A2D5, "check_model" },
    { 0x8525C4E1, "check_mortar_count" },
    { 0xDA21FD71, "check_mortar_killcount" },
    { 0xC05ADD2D, "check_nva_alive" },
    { 0xCA9C42B2, "check_octobomb_on_train" },
    { 0xEFCBA13B, "check_other_haslevelveteranachievement" },
    { 0x063474AE, "check_other_veterancompletion" },
    { 0x74B19DAB, "check_out_poi_in_valley" },
    { 0x2502EDF0, "check_override_melee_wallbuy_purchase" },
    { 0x014BAFC3, "check_override_wallbuy_purchase" },
    { 0xA28BEFBF, "check_owner" },
    { 0xF8C0E7B4, "check_pass_end_point" },
    { 0xC488185C, "check_pass_safe_point" },
    { 0x2F92EC3C, "check_path_near_player" },
    { 0x5E95E16B, "check_pct" },
    { 0xA97AB2F3, "check_perk_machine_valid" },
    { 0x554BF15B, "check_pers_upgrade" },
    { 0x46D989F8, "check_pers_upgrade_stat" },
    { 0x31EAC533, "check_phase" },
    { 0xF0517BFA, "check_pickup" },
    { 0x0F3DFF5F, "check_plane_valid" },
    { 0x9CB560DC, "check_plankb" },
    { 0x40F94449, "check_plant_position" },
    { 0x09E6B20D, "check_play_flyby" },
    { 0x40FB4A3B, "check_play_vehicle_rumble" },
    { 0xBD9B45DA, "check_play_vehicle_rumble_binocs" },
    { 0x4F953F09, "check_player" },
    { 0x30B905E5, "check_player_available" },
    { 0xA195D574, "check_player_boat_buttons" },
    { 0x8E36F99F, "check_player_can_see_me" },
    { 0x18644EA2, "check_player_damage_callbacks" },
    { 0x60CA46F3, "check_player_dropdown" },
    { 0x6DDDD206, "check_player_gravity" },
    { 0x98F328C3, "check_player_has_perk" },
    { 0x2773125C, "check_player_has_rpg" },
    { 0xFD51E95C, "check_player_health_vo" },
    { 0xC92E5F55, "check_player_height" },
    { 0xF0F7EFAD, "check_player_is_ready_for_ammo" },
    { 0xFCA93E49, "check_player_location" },
    { 0x82DD2EF0, "check_player_not_leaving_woods_behind" },
    { 0x077B6C84, "check_player_on_aa_gun_still" },
    { 0x7E371206, "check_player_playing" },
    { 0xE15785D5, "check_player_position" },
    { 0xC5970C2C, "check_player_requirements" },
    { 0xE714524B, "check_player_spotted" },
    { 0x4217C473, "check_player_weapons" },
    { 0x3DD53E00, "check_players" },
    { 0x389F7242, "check_players_in_bunker" },
    { 0xDDBCAE03, "check_players_in_ghost_zone" },
    { 0xD1F14A0D, "check_players_in_nml_dogs_volume" },
    { 0xE78108DC, "check_point_in_active_zone" },
    { 0x5BB0D4C1, "check_point_in_enabled_zone" },
    { 0x0B2E2E19, "check_point_in_playable_area" },
    { 0x11295A10, "check_pos" },
    { 0x55536611, "check_precourtyard_balcony_guys_kill" },
    { 0xB9D19300, "check_precourtyard_enemies_dead" },
    { 0xB1B3CB7D, "check_prone_over" },
    { 0x54076542, "check_puzzle_solved" },
    { 0xFAFFDF64, "check_quickrevive_for_hotjoin" },
    { 0x3DBC348C, "check_quickrevive_hotjoin" },
    { 0x81F4F945, "check_range" },
    { 0x75D4231C, "check_range_attack" },
    { 0x5304FC0B, "check_revive_after_consumed" },
    { 0x9156BD64, "check_reznov_speech_over" },
    { 0xDC30DB6E, "check_rocket" },
    { 0xE05D9BD1, "check_roof_enemies_stage1_are_dead" },
    { 0xD6D981DC, "check_roof_enemies_stage2_are_dead" },
    { 0x53232244, "check_running_killstreak" },
    { 0x6746B944, "check_safe_house" },
    { 0xCCB2A205, "check_safe_to_move" },
    { 0xA66188E3, "check_same_floor" },
    { 0x7C8590D4, "check_scraper" },
    { 0x065ACD0E, "check_script_char_group_ratio" },
    { 0x907C4E52, "check_sending_away_zombie_followers" },
    { 0xC79988B6, "check_shot_at" },
    { 0x79FAF5BC, "check_should_gib" },
    { 0xF1779B3B, "check_should_save_player" },
    { 0xD42CC27A, "check_should_stop" },
    { 0xA1DECB6F, "check_shoveler1" },
    { 0x2FD75C34, "check_shoveler2" },
    { 0xF30DE27D, "check_sight" },
    { 0xD6FDE469, "check_smoke_grenades" },
    { 0x04AA5A70, "check_smoke_in_trigger" },
    { 0xDEA88B69, "check_smoker" },
    { 0x396BAF8B, "check_smoker_anim" },
    { 0xB05C08A4, "check_solo_game" },
    { 0x75DFE4D8, "check_solo_status" },
    { 0xAB9FED51, "check_sound_tag_dupe" },
    { 0xD11D7D71, "check_sound_tag_dupe_reset" },
    { 0xE3D14A24, "check_spawn_cymbal_monkey" },
    { 0xAD8FFC08, "check_spawnflags" },
    { 0x7D8D8A47, "check_speed" },
    { 0xA89B9296, "check_sq_bg_progress" },
    { 0x260B1B26, "check_squad_fail_trigger_persistent" },
    { 0xB0A8F76A, "check_squadmeetup_disturb" },
    { 0x3D238C31, "check_stair_guy" },
    { 0x9B9CB71E, "check_stat_complete" },
    { 0x4826A5EA, "check_stuck" },
    { 0xD2360390, "check_stuck_position" },
    { 0xF1D3D576, "check_stuck_to_player" },
    { 0xC376161E, "check_stuck_to_shield" },
    { 0xC0B30E75, "check_tank_platform_zone" },
    { 0xF464754E, "check_target_lost" },
    { 0xEB676401, "check_team" },
    { 0x43F8FC01, "check_time" },
    { 0xFEF51ABC, "check_to_clear_fire_sale" },
    { 0xA60B57FE, "check_to_kill_near_origin" },
    { 0x0C7E35C8, "check_to_release_chaff" },
    { 0xCA932CC8, "check_to_set_play_outro_movie" },
    { 0x36ECA434, "check_trig" },
    { 0x0A8E9BCE, "check_trigger" },
    { 0xEBCBD1FB, "check_turn" },
    { 0xEF5A26A4, "check_unloadgroup" },
    { 0xDB78371D, "check_valid_poi" },
    { 0x75EDA423, "check_valid_spawn_override" },
    { 0xF2DFB29F, "check_valid_weapon" },
    { 0xECA21E6C, "check_vehicle_button_lt" },
    { 0x9F6B0866, "check_vehicle_button_rt" },
    { 0x96ABAF7E, "check_vehicle_damage" },
    { 0xB3866E06, "check_vo_story_stat" },
    { 0xACECF7A4, "check_volume" },
    { 0x5D83F92E, "check_vulture_drop_pickup" },
    { 0xBC62118D, "check_wait" },
    { 0xC951082E, "check_weapon" },
    { 0x7221D39F, "check_weapon_ammo" },
    { 0x93842CE2, "check_weapon_used" },
    { 0x46A6DB2B, "check_welder" },
    { 0x79E2CBB9, "check_when_gondola_moves_if_groundent_is_undefined" },
    { 0xC78C95AF, "check_x_axis1" },
    { 0x55852674, "check_x_axis2" },
    { 0x4C3551D6, "check_y_axis1" },
    { 0x2632D76D, "check_y_axis2" },
    { 0x3D49C138, "check_zbarrier_piece_for_zombie_death" },
    { 0x2030D172, "check_zbarrier_piece_for_zombie_inert" },
    { 0x466FACB5, "check_zombie_damage_callbacks" },
    { 0x1538B29D, "check_zombie_death_animscript_callbacks" },
    { 0x2E6D7B0B, "check_zombie_death_event_callbacks" },
    { 0xDC8F290C, "check_zoom_controls" },
    { 0x6CC499C4, "checkagainst" },
    { 0x0903E135, "checkaivalid" },
    { 0x35613C72, "checkallowspectating" },
    { 0xFB47B174, "checkanim" },
    { 0x0A2C25BB, "checkapproachangles" },
    { 0xC65B5690, "checkarrivalenterpositions" },
    { 0xA4311D1E, "checkavailfirst" },
    { 0x2E17D934, "checkawardmostpointsthiscycle" },
    { 0xE5485C8C, "checkbad" },
    { 0x880CE17F, "checkbaseweaponcontractrequirement" },
    { 0xE04B206A, "checkbox" },
    { 0x5638FC12, "checkbridgevolume" },
    { 0xC7895499, "checkcargopickup" },
    { 0xFAC450CD, "checkchanged" },
    { 0x2276C67C, "checkcheatchanged" },
    { 0x533C384D, "checkcontractexpirations" },
    { 0x3ED434DC, "checkcorpseinlava" },
    { 0x8D442911, "checkcoverarrivalconditions" },
    { 0x4961A370, "checkcoverenterpos" },
    { 0x03A4BCA2, "checkcoverexitpos" },
    { 0xB1025303, "checkcoverexitposwithpath" },
    { 0x167025AF, "checkdist" },
    { 0x2D19539F, "checkdist2" },
    { 0x2E60DB9A, "checkdistance" },
    { 0xD53E924B, "checkdistancetoenemy" },
    { 0x97076223, "checkdistancetoevent" },
    { 0xEC317588, "checkdistancetoobject" },
    { 0x2A3809BB, "checkdistsq" },
    { 0xC942E2F2, "checkdualwield" },
    { 0x261A8166, "checkdvarupdates" },
    { 0xD77077A8, "checked" },
    { 0x4172ADB4, "checked_should_delete_hint" },
    { 0xB1994E1E, "checkendcombat" },
    { 0x874BDBED, "checkenemy" },
    { 0x5C729982, "checkent" },
    { 0x1BA6FCAE, "checker" },
    { 0x75E7145A, "checkfinalkillcamkill" },
    { 0xF5FB6EE7, "checkfor_radio_override" },
    { 0x6D82AE16, "checkforabruptkillcamend" },
    { 0x481DD8EB, "checkforalldead" },
    { 0x2A68D593, "checkforallplayersreachingdistance" },
    { 0x03F8C892, "checkforanyteamforfeit" },
    { 0x63A9062C, "checkforbeinginsidepipesafezone" },
    { 0x4DE0BCCB, "checkforbeinginsidepipesafezone_2" },
    { 0x8C300FA8, "checkforbleedout" },
    { 0xF489729A, "checkforemp" },
    { 0xC64C7A91, "checkforforfeit" },
    { 0x4D13985C, "checkforgestures" },
    { 0xEF1FE1BE, "checkforherosurvival" },
    { 0x206CD0CA, "checkforplayerelimination" },
    { 0x8BB13743, "checkforplayergestures" },
    { 0x022979BF, "checkforplayerswitch" },
    { 0xC09FA3C3, "checkforroomcleared" },
    { 0x0EE3D886, "checkforsimilardeaths" },
    { 0x788646DF, "checkforstundamage" },
    { 0x32B1B0C7, "checkfortracking" },
    { 0x8AF75B94, "checkforvalidaitype" },
    { 0x8A02911E, "checkforvalidmod" },
    { 0x0B5E9EB2, "checkforvalidweapon" },
    { 0x18F03BC2, "checkforwonderingoff" },
    { 0x66B46761, "checkfunc" },
    { 0x06BD9B55, "checkgenericcontractrequirement" },
    { 0x63F0C149, "checkgenericcontractrequirementfloat" },
    { 0x4A87CB9B, "checkgrenadefordud" },
    { 0xF8BB976D, "checkgrenadeinhand" },
    { 0x25BD2319, "checkgrenadethrow" },
    { 0x17B7A6C9, "checkgrenadethrowdist" },
    { 0x46FD1229, "checkgrenadethrowpos" },
    { 0x0BC79DFA, "checkgroupchallengecomplete" },
    { 0x88376484, "checkhatchetbounce" },
    { 0x92EB52C4, "checkhelicoptertag" },
    { 0x7FCEAA22, "checkhit" },
    { 0x90749942, "checkhitsthismag" },
    { 0x01E1E39C, "checkid" },
    { 0xBEDDD330, "checkiflastflag" },
    { 0x23B34DE6, "checkiflastflagcaptured" },
    { 0x5BC48792, "checkifswitchableweapon" },
    { 0x54563101, "checkifteamforfeits" },
    { 0x3168F4D8, "checkifweshouldmove" },
    { 0x5122FB5B, "checkignoreme" },
    { 0x4F704FF9, "checkignoremeflag" },
    { 0x1DD30526, "checkin" },
    { 0x782FFD35, "checkin_anims" },
    { 0xC417F0C3, "checkin_armraise" },
    { 0xFD9B785F, "checkin_civ_scenes" },
    { 0x8EB6A2B3, "checkin_cleanup" },
    { 0xC14C1CDD, "checkin_precache_anims" },
    { 0xCEF44CA4, "checkin_reception_scanner_fx" },
    { 0x41CA3675, "checkin_sounds" },
    { 0x534620C7, "checkin_squad_scenes" },
    { 0xCC26716D, "checking" },
    { 0x45D341CD, "checking_avogadro_storm_vox" },
    { 0xD5B25F5C, "checking_courtyard_almost_clear" },
    { 0xB646AF71, "checking_for_failed_revive" },
    { 0x29FFBBAD, "checking_for_richtofen_c_failure" },
    { 0xA25D320E, "checking_for_round_end" },
    { 0x1E780934, "checking_human_zombie_ratio" },
    { 0x15A11120, "checking_jetgun_fire" },
    { 0x63E17DE2, "checking_mason_bunker_1st_room_enemies" },
    { 0xA34E2E53, "checking_mason_courtyard_enemies" },
    { 0x2F0536F4, "checkinterrupt" },
    { 0x812315C4, "checkinterval" },
    { 0x605D778C, "checkintvalid" },
    { 0x46E23F48, "checkkdratiorequirement" },
    { 0x3893C4EC, "checkkillcount" },
    { 0x614375C6, "checkkillstreak5" },
    { 0xADE0A613, "checklanded" },
    { 0x7409F229, "checkme" },
    { 0xBC6BA042, "checkmilestonecomplete" },
    { 0x0E8056BF, "checkmov" },
    { 0xDF34649E, "checkmovementtypeerror" },
    { 0xBBDCE441, "checkmoving" },
    { 0xC19C6CB8, "checknavmeshdirection" },
    { 0x47740BAB, "checknode" },
    { 0xE9AAB5EA, "checknotplayerteam" },
    { 0xEC522F1D, "checknum" },
    { 0x2961BB01, "checkout" },
    { 0xDC5AEDFC, "checkpass" },
    { 0x09E23FBE, "checkperkcontractrequirement" },
    { 0xCE4B447B, "checkpiont" },
    { 0x4A7F72C7, "checkpitch" },
    { 0xC9EB73A7, "checkpitchvisibility" },
    { 0xCECE5F64, "checkplayer" },
    { 0xC242ACC9, "checkplayercount" },
    { 0x058B5666, "checkplayerscorelimitsoon" },
    { 0x25DCC41B, "checkplayerstinitus" },
    { 0x34F4D67C, "checkpoing" },
    { 0x46D49F27, "checkpoint" },
    { 0xE1DBB68C, "checkpoint1" },
    { 0x53E325C7, "checkpoint2" },
    { 0x2DE0AB5E, "checkpoint3" },
    { 0x13C28A80, "checkpoint_approach_vo" },
    { 0x806E2395, "checkpoint_break_through" },
    { 0x5CF2D652, "checkpoint_dialog" },
    { 0xA8061043, "checkpoint_entered" },
    { 0x149D9936, "checkpoint_event" },
    { 0xC25E57E3, "checkpoint_guy" },
    { 0x0DEA57BE, "checkpoint_index" },
    { 0xA85FB42F, "checkpoint_invulnerability" },
    { 0x16C70E24, "checkpoint_passthrough" },
    { 0x7DD3D71C, "checkpoint_reached" },
    { 0xF9D0BA93, "checkpoint_respawn_safe_spot_clear" },
    { 0x564FF894, "checkpoint_respawn_safe_spot_exists" },
    { 0x97EAB1EC, "checkpoint_respawn_safe_spot_set" },
    { 0x54E17C5B, "checkpoint_restart" },
    { 0xAF881E78, "checkpoint_restart_safe_spot" },
    { 0x64DB3861, "checkpoint_safe_int_screens" },
    { 0x1FDF4E0A, "checkpoint_save_restored" },
    { 0x26F611AD, "checkpoint_time" },
    { 0x1C799AEC, "checkpointed" },
    { 0x6AE4CD19, "checkpointindex" },
    { 0x7EB0029C, "checkpointrestart" },
    { 0xAE7F459E, "checkpoints" },
    { 0x99DCCC27, "checkpointtimes" },
    { 0xFE1DE148, "checkpointtriggers" },
    { 0x251FA94F, "checkpos" },
    { 0x5859452D, "checkpositiontime" },
    { 0xACD19053, "checkprone" },
    { 0xF3E9DC40, "checkroomforanim" },
    { 0x222AD89A, "checkroundscorelimit" },
    { 0x7CCF891D, "checkroundswitch" },
    { 0xBB6333A2, "checks" },
    { 0xCC44AFB6, "checksafezoneresets" },
    { 0x33392F48, "checkscorelimit" },
    { 0xEC2ED838, "checkscramblerstun" },
    { 0x31CE31FD, "checkspeakers" },
    { 0x918D5A54, "checkstringtrue" },
    { 0xD2C33E3A, "checkstringvalid" },
    { 0x1A861799, "checkstucktoplayer" },
    { 0xD9F763F5, "checkstucktoshield" },
    { 0x4A1FE65F, "checksuddendeathscorelimit" },
    { 0x02979DD4, "checksum" },
    { 0xCE2898B2, "checksurfacetypeiscorrect" },
    { 0xC6A2F100, "checkteam" },
    { 0x6A5753A8, "checkteamequipment" },
    { 0x7500F6E3, "checkteammissiles" },
    { 0x0B0063F2, "checkteamscorelimitsoon" },
    { 0xC416ED9B, "checkteamvehicles" },
    { 0x36B9BE88, "checktime" },
    { 0xA6140B51, "checktimelimit" },
    { 0xF4B15275, "checktimereachedevents" },
    { 0x5357A1E2, "checktoturnoffemp" },
    { 0x94B8AE15, "checktrig" },
    { 0xBE531137, "checkvisible" },
    { 0x17DC8DE7, "checkweaponchallengecomplete" },
    { 0xD1C5540F, "checkweaponchange" },
    { 0x34A3B7C3, "checkweaponkill" },
    { 0x6B8E5CD6, "checkweaponmilestonecomplete" },
    { 0xB22B258C, "checkweaponreload" },
    { 0x969E745F, "checkweaponsubstringcontractrequirement" },
    { 0xD5159392, "checkwithpath" },
    { 0x68A282C0, "checkzmroundswitch" },
    { 0x57EAD121, "checkzombiehumanratio" },
    { 0x290D11D1, "checkzone" },
    { 0xA41A7E82, "cheeky" },
    { 0x89EEA0F0, "cheer" },
    { 0x1FB79894, "cheer_sound" },
    { 0x6024DB68, "cheering" },
    { 0xB1BF0CE3, "cheerleader" },
    { 0x6437D55B, "cheers" },
    { 0x82A794F6, "cheese" },
    { 0x21F88A94, "cheev" },
    { 0xDD289F21, "cheeve" },
    { 0x147809BD, "chef" },
    { 0x9F51251D, "chekcing" },
    { 0xCD0D92A9, "chemical" },
    { 0x0DDC700B, "chemical_alarm" },
    { 0xFFFD6872, "chemicalgel_splat_duration_max" },
    { 0x1402422B, "cher_rus_flag" },
    { 0xC2C16B58, "cher_start" },
    { 0xF7DEAA67, "cherflag" },
    { 0xDF2E3DDE, "chernov" },
    { 0x585C3872, "chernov_death_init" },
    { 0x8A067C9D, "chernov_node" },
    { 0x7AAA6DBA, "chernov_remove_gun" },
    { 0x6000E57A, "cherry" },
    { 0x5D79E160, "cherry_kills" },
    { 0x78F303BE, "chess_cleared" },
    { 0x498C939C, "chess_guy_init" },
    { 0x008CB726, "chess_guys" },
    { 0x54801FB9, "chess_guys_drop_weapon" },
    { 0x01C5B96E, "chess_guys_investigate" },
    { 0xDF64200A, "chess_obj_org" },
    { 0x844E4834, "chest" },
    { 0x80C73095, "chest1" },
    { 0xA6C9AAFE, "chest2" },
    { 0xCCCC2567, "chest3" },
    { 0xC2BACC88, "chest4" },
    { 0xE8BD46F1, "chest5" },
    { 0xCA502312, "chest_accessed" },
    { 0x35EC949B, "chest_beat" },
    { 0x5501D382, "chest_box" },
    { 0x0587AF6A, "chest_ent" },
    { 0xB589AA6D, "chest_flashlight" },
    { 0xC086F77A, "chest_get_max_usage" },
    { 0x39F37460, "chest_get_min_usage" },
    { 0x9830275D, "chest_index" },
    { 0x13CB7A0E, "chest_joker_custom_movement" },
    { 0xBFE399EE, "chest_joker_model" },
    { 0x064909A3, "chest_level" },
    { 0xF4B9A146, "chest_lid" },
    { 0xD4B058DB, "chest_loc" },
    { 0x79CE122F, "chest_min_move_usage" },
    { 0x5AFBA163, "chest_moves" },
    { 0x28AA0A49, "chest_moving" },
    { 0xC49AF951, "chest_origin" },
    { 0xB11EF5A1, "chest_rubble" },
    { 0x17401AB2, "chest_user" },
    { 0xF0013E88, "chestindex" },
    { 0x4C2D8B27, "chests" },
    { 0x8E4DE8C4, "chew" },
    { 0x3D8E0595, "chi" },
    { 0xE91466A4, "chi3" },
    { 0xD6CACBDA, "chi_1a" },
    { 0x57A897FF, "chi_1a_dead" },
    { 0xC6366FED, "chi_1a_strat" },
    { 0x5B899D06, "chi_1a_wave" },
    { 0xA355D7F6, "chi_1b_dead" },
    { 0x8D41A4A5, "chi_1c_dead" },
    { 0x333BCBAF, "chi_1c_strat" },
    { 0x6E7B8404, "chi_1d_shoot_strat" },
    { 0x1A825ACC, "chi_1d_strat" },
    { 0x655C3EF9, "chi_1e_shoot_strat" },
    { 0xBDCEFDE9, "chi_1e_strat" },
    { 0x12745246, "chi_1f_strat" },
    { 0x6F34382B, "chi_1g_strat" },
    { 0xA45E72E3, "chi_2_wave_dead" },
    { 0x2DA18791, "chi_3_kill_shermans_2" },
    { 0xC847FD76, "chi_3_wave_dead" },
    { 0xD3F99830, "chi_3a" },
    { 0x25AE799F, "chi_3a_death" },
    { 0x17C8B0E7, "chi_3a_strat" },
    { 0x4601076B, "chi_3b" },
    { 0x547F1CF0, "chi_3b_death" },
    { 0x94B42478, "chi_3b_strat" },
    { 0x1FFE8D02, "chi_3c" },
    { 0xD0150C0D, "chi_3c_death" },
    { 0x10678F95, "chi_3c_shoot_strat" },
    { 0xC0E7FF05, "chi_3c_strat" },
    { 0xE895C463, "chi_tanks" },
    { 0xD0D3E378, "chi_wave_1a" },
    { 0x1CD8D84A, "chi_wave_1c" },
    { 0x8EE04785, "chi_wave_1d" },
    { 0x68DDCD1C, "chi_wave_1e" },
    { 0xDAE53C57, "chi_wave_1f" },
    { 0xB4E2C1EE, "chi_wave_1g" },
    { 0x02D1D8C9, "chi_wave_3" },
    { 0xBCA17832, "chi_wave_3_shoot_strat" },
    { 0x9D4BD7BB, "chiang" },
    { 0xC9DAA774, "chic" },
    { 0x397884AF, "chick" },
    { 0x0875140E, "chicken" },
    { 0xF50F68C4, "chicken_active_idle" },
    { 0x753B3ABD, "chicken_anim_death" },
    { 0x2CE4EDFB, "chicken_anim_loop" },
    { 0x593DE26B, "chicken_cleanup" },
    { 0x7AC7DCDA, "chicken_death_idle" },
    { 0xBC922B7B, "chicken_died" },
    { 0x6E1E77F7, "chicken_idle" },
    { 0x4DB284C1, "chicken_swerve" },
    { 0xC2E39CE1, "chickencoop" },
    { 0xFF835E20, "chickencoop_start" },
    { 0x973689B1, "chickens" },
    { 0x0FAE2641, "chickens2" },
    { 0xE9ABABD8, "chickens3" },
    { 0x3CF52CBA, "chickens3b" },
    { 0xACA5CBF6, "chicks" },
    { 0x16473DF0, "chief" },
    { 0x465B1138, "chien" },
    { 0xB5EF91CC, "chieves" },
    { 0xC73F1F2D, "child" },
    { 0xCE4AE306, "child_capture_zones" },
    { 0xB3EC682F, "child_guards_after_log_scene" },
    { 0x5AB1084E, "child_guards_alerted" },
    { 0x7A9B1F51, "child_lines" },
    { 0x43D33B65, "child_menu" },
    { 0x43A34966, "child_number_override" },
    { 0xA05E30D9, "child_search_party_vo" },
    { 0x16486958, "child_soldier_do_not_shoot_player" },
    { 0x1769E6F9, "child_soldiers" },
    { 0x2340B00C, "child_spawner" },
    { 0x5A160D62, "child_title" },
    { 0xFC6BD138, "children" },
    { 0x92128D15, "children_func" },
    { 0xB80B6A5E, "children_menu" },
    { 0xC37E4B2C, "childs" },
    { 0xF752F275, "chill" },
    { 0x73D2BA94, "chillin" },
    { 0x3A154B44, "chills" },
    { 0x8D587BB2, "chimes" },
    { 0x0EDE507C, "chimey_rumble" },
    { 0x4321B8B6, "chimney" },
    { 0xE6E49D0C, "chimney_crumble_fx" },
    { 0xB4D6C728, "chimney_smoke" },
    { 0xD6BB6D71, "chimney_targ" },
    { 0x641B823C, "chimney_wire1_fx" },
    { 0x882F4929, "chimney_wire2_fx" },
    { 0x8CA2890A, "china" },
    { 0x1C57D587, "chinalake" },
    { 0x100DA202, "chinalke" },
    { 0x24AC72AE, "chine" },
    { 0x9B8AFA9E, "chinese" },
    { 0x20B0D377, "chinese_names" },
    { 0xBA8E38BD, "chinoock" },
    { 0x6846FBB2, "chinook" },
    { 0x36C751C0, "chinook_attack_docks" },
    { 0xF21410E0, "chinook_boat3_ent" },
    { 0x0A71334F, "chinook_boat_orig_ent" },
    { 0x17740CED, "chinook_comes_over_mountainside_trigger" },
    { 0xDF4BA774, "chinook_defender" },
    { 0xCCDE9113, "chinook_defense" },
    { 0x0C1E09D6, "chinook_guys_active" },
    { 0x242E5A9B, "chinook_guys_killed" },
    { 0x533EB0AD, "chinook_lands" },
    { 0x6FB85B7F, "chinook_nva_behavior" },
    { 0xD686E5ED, "chinook_parts" },
    { 0x65BC2F56, "chinook_pilot_behavior" },
    { 0xE46E2924, "chinook_player_ent" },
    { 0x4D7EE844, "chinook_setup" },
    { 0x5394183D, "chinooks" },
    { 0xDBBA701F, "chip" },
    { 0x3397EA2A, "chis_fire_at_players" },
    { 0x92ECAEFC, "chis_fire_at_players_and_bunker" },
    { 0x4C78AF82, "chis_fire_towards_shermans" },
    { 0x2989C1A0, "chksum" },
    { 0xED5A7770, "chloe" },
    { 0x57D851F2, "chloe_kills" },
    { 0xABBC9DB1, "chloe_kills_total" },
    { 0x776E0356, "chloe_model" },
    { 0x48C4A338, "choi" },
    { 0xFCC8A1D4, "choice" },
    { 0x7C79D7AE, "choice_button_focus" },
    { 0x1240CFE3, "choke" },
    { 0xE68C7D58, "choke_action" },
    { 0x60DBA1F8, "choke_ai" },
    { 0x29102075, "choke_dragovich" },
    { 0xB32F4A95, "choke_spit_fx" },
    { 0xF80B4466, "choke_strength_test_complete" },
    { 0xF623449D, "choked" },
    { 0x23F42ED2, "chokes" },
    { 0xC5F55E66, "choking" },
    { 0xAEB6219E, "choose" },
    { 0x8D3B9172, "choose_a_line_to_play" },
    { 0x361F1D44, "choose_attachment_model" },
    { 0x033D8423, "choose_class" },
    { 0x77124E05, "choose_claw_fx" },
    { 0xC7CD5660, "choose_driveby_or_dismount" },
    { 0x8014FC1E, "choose_fate_round" },
    { 0x76809EA4, "choose_left_path" },
    { 0x1539C112, "choose_light_slot" },
    { 0xC8A1932D, "choose_lightfx" },
    { 0x4F5D4206, "choose_open_craftable" },
    { 0xA03118F8, "choose_path" },
    { 0x1CBB4EAE, "choose_primary_attachments" },
    { 0xBB52F711, "choose_prone_to_run_anim_variant" },
    { 0x81F79D3F, "choose_random_bump_count" },
    { 0x0075BDC8, "choose_random_guy" },
    { 0xED77876C, "choose_random_redshirt" },
    { 0x10FB9BF1, "choose_right_path" },
    { 0x57979878, "choose_run" },
    { 0xC6CB18FA, "choose_secondary_attachments" },
    { 0xC0D98B7B, "choose_sprint_anim" },
    { 0xE834A922, "choose_tag_and_chase" },
    { 0x407DEE83, "choose_tag_and_jump_down" },
    { 0x499AB936, "choose_target" },
    { 0xCBFF1671, "choose_target_drone" },
    { 0x78F4927D, "choose_weapon" },
    { 0x8952DE8B, "choose_weapon_option" },
    { 0x37931600, "chooseaivsaimeleeanimations" },
    { 0x5108EE89, "chooseaivsaimeleebackanimations" },
    { 0x224B6BA2, "chooseaivsaimeleefrontflipanimations" },
    { 0x7F1B7F17, "chooseaivsaimeleefrontwrestleanimations" },
    { 0xDF02D22B, "chooseaivsaimeleeleftanimations" },
    { 0x94FD48E4, "chooseaivsaimeleerightanimations" },
    { 0x8616D0CF, "chooseanimfromset" },
    { 0xCC2DFF4A, "choosearchetypevariant" },
    { 0x23F845BA, "choosebestcovernodeasap" },
    { 0xD19626E9, "choosebettercoverreason" },
    { 0xF34BE59E, "choosebettercoverservice" },
    { 0x1A7B944B, "choosebettercoverservicecodeversion" },
    { 0x655AD686, "choosebetterpositionservice" },
    { 0x4A13B9EE, "chooseclass" },
    { 0x54747C5A, "choosecoverdirection" },
    { 0x216468EB, "choosefrontcoverdirection" },
    { 0x4C6D220C, "choosejukedirection" },
    { 0x078E81F9, "choosenextbestnemesis" },
    { 0xBB55050D, "choosepose" },
    { 0xA9B5CAEF, "chooserandombody" },
    { 0x2651A506, "chooserandomguns" },
    { 0xA12B6501, "chooses" },
    { 0x0DC3EE6B, "choosesomethingtolookat" },
    { 0x6727EDBA, "chooseswordanim" },
    { 0xD3FC8FB7, "choosing" },
    { 0xDE8BA3C9, "chop" },
    { 0xFE9FED24, "chop5zone" },
    { 0xE485CB47, "chop_actor" },
    { 0x9F0E7465, "chop_actor_cb" },
    { 0xB78E592E, "chop_targets" },
    { 0xCDC8D865, "chop_zombies" },
    { 0x5DA54510, "choper" },
    { 0xE7FB6820, "choppah" },
    { 0xEA3E5133, "choppas" },
    { 0x7CDD5370, "chopped" },
    { 0x00C48B56, "chopper" },
    { 0xE288047F, "chopper_accumulated_friendly_damage" },
    { 0x35C42D03, "chopper_ai_mode" },
    { 0x30611D8E, "chopper_ai_mode_aim_turret" },
    { 0x516B3241, "chopper_ai_mode_flares" },
    { 0xC5039E8D, "chopper_ai_mode_missiles" },
    { 0xA9AE1BA4, "chopper_ai_mode_shoot_turret" },
    { 0xDCD352C3, "chopper_air_support" },
    { 0xA0C1D6B1, "chopper_air_support_activate" },
    { 0x8258D24A, "chopper_air_support_call_chopper" },
    { 0x795C47D5, "chopper_air_support_deactive" },
    { 0x81B1B3D5, "chopper_air_support_end" },
    { 0x67155D4B, "chopper_air_support_friendlyfire" },
    { 0xAE223660, "chopper_air_support_givebackweapon" },
    { 0xB1344C59, "chopper_air_support_mark" },
    { 0xD2890DDA, "chopper_air_support_paint_target" },
    { 0xC25C9DC3, "chopper_air_support_removefunctionality" },
    { 0x7B2B58E6, "chopper_blur" },
    { 0x929843AA, "chopper_boss" },
    { 0x9495BD14, "chopper_boss_behavior_little_bird" },
    { 0x7EE9FEBE, "chopper_boss_load_fx" },
    { 0x08379CC5, "chopper_boss_locs_populate" },
    { 0x99DEF623, "chopper_bullets_on_jump" },
    { 0x8C7E1BD8, "chopper_closest_open_path_start" },
    { 0x302A6E46, "chopper_collision_dialog" },
    { 0xEEC3E344, "chopper_coming" },
    { 0x6C604F44, "chopper_crash_savepoint" },
    { 0xAFD0D6EF, "chopper_crash_scene_starts_chain_reaction" },
    { 0x6F91CBAB, "chopper_crash_think" },
    { 0x3EE8CB7B, "chopper_crashes_into_pipes_anim" },
    { 0x616D2272, "chopper_dead_bodies" },
    { 0x244AF4A3, "chopper_dead_vo" },
    { 0x5BC122C1, "chopper_death_dudes_setup" },
    { 0x0ED3CDDA, "chopper_death_models" },
    { 0xB1DDE31D, "chopper_defs" },
    { 0x1E30E849, "chopper_dialog" },
    { 0xF14D2FE5, "chopper_doing_custom_action" },
    { 0x1C765A2F, "chopper_done_shooting" },
    { 0x88ED02BA, "chopper_door_closed_state" },
    { 0x79ADAFE8, "chopper_door_open" },
    { 0xCEFF16A2, "chopper_door_open_state" },
    { 0x4474FBB1, "chopper_drop_point" },
    { 0x3271D7F6, "chopper_drop_smoke_at_unloading" },
    { 0xC8A62B1A, "chopper_enhanced_vision" },
    { 0x6058BD78, "chopper_explode_everyone" },
    { 0x3C67A5CA, "chopper_failsafe" },
    { 0x0BBCBAC3, "chopper_find_spot" },
    { 0x440DD124, "chopper_find_target" },
    { 0x9CAA0B89, "chopper_fire" },
    { 0x591013F3, "chopper_fx" },
    { 0xF4778A04, "chopper_gunner" },
    { 0x3B039D8D, "chopper_gunner_player_head" },
    { 0x10449E72, "chopper_gunner_player_model" },
    { 0xE389A7A0, "chopper_gunner_time" },
    { 0x6E2633D3, "chopper_gunner_viewmodel" },
    { 0xC4C89E03, "chopper_guys_land" },
    { 0x0D071844, "chopper_heli_search" },
    { 0xA72EDB31, "chopper_heli_search_02" },
    { 0xE2C75F00, "chopper_heli_search_02_trigger" },
    { 0xA99B5C07, "chopper_heli_search_02_trigger_b" },
    { 0x5F4E0A45, "chopper_hide" },
    { 0x6051ECA4, "chopper_inbound" },
    { 0xE701D64D, "chopper_infrared_vision" },
    { 0x6A330DFE, "chopper_interior_models" },
    { 0x322E00DF, "chopper_models" },
    { 0x92C5DB1E, "chopper_monitor_death" },
    { 0xE9D12CB4, "chopper_mow_everyone" },
    { 0x1CBF1BAD, "chopper_over_bridge" },
    { 0x23A4F131, "chopper_pass_done" },
    { 0x09A0745E, "chopper_pass_in_progress" },
    { 0x9E8662E0, "chopper_path" },
    { 0x9677E932, "chopper_path_release" },
    { 0x27B4E0F7, "chopper_patrol" },
    { 0x770B3266, "chopper_player_get_on_gun" },
    { 0x13FB7157, "chopper_rail_tether_logic" },
    { 0x29A48D70, "chopper_ramp_flyover_start" },
    { 0x81B9AD99, "chopper_rappel" },
    { 0xAD8C60B6, "chopper_release_path" },
    { 0xB8A42982, "chopper_retreat" },
    { 0x31DD7753, "chopper_send" },
    { 0xA1052D4C, "chopper_shine_first_building" },
    { 0xEB069F9A, "chopper_shooting" },
    { 0x6FA2E200, "chopper_shooting_end" },
    { 0x92FC6FC0, "chopper_sound_ent" },
    { 0x9368EDC5, "chopper_sounds" },
    { 0x39A74936, "chopper_spawn" },
    { 0x195719B2, "chopper_spawn_from_targetname" },
    { 0x9F0965A1, "chopper_spawn_from_targetname_and_drive" },
    { 0xD3F6A337, "chopper_spawn_passenger" },
    { 0xBD29A415, "chopper_spawn_pilot_from_targetname" },
    { 0xB73413DF, "chopper_spawner" },
    { 0x38337A27, "chopper_special_fx" },
    { 0x554635C5, "chopper_spotlight_aim" },
    { 0x1CD24222, "chopper_spotlight_aim_loop" },
    { 0x7722B7B0, "chopper_support_confirm_kills_voiceover" },
    { 0x7167600A, "chopper_support_confirm_voiceover" },
    { 0x55D7B1A4, "chopper_support_custom_confirm_check" },
    { 0x9DB274C3, "chopper_support_killtank_reminder_voiceover" },
    { 0xD38DB799, "chopper_support_negative_voiceover" },
    { 0x64013536, "chopper_support_reminder_voiceover" },
    { 0xF15495A8, "chopper_support_request_confirm_voiceover" },
    { 0xD41720E1, "chopper_support_request_voiceover" },
    { 0xB0E93B38, "chopper_support_setup" },
    { 0xDF2EF75E, "chopper_takedown_vo" },
    { 0x1361018E, "chopper_target" },
    { 0x1E66EB45, "chopper_to_reznov" },
    { 0x1255E6BE, "chopper_truck_target" },
    { 0x077BBB95, "chopper_turret_off" },
    { 0x3B761E69, "chopper_turret_on" },
    { 0xC6B07E51, "chopper_unload_cargo" },
    { 0x84E078C9, "chopper_unload_cargo_claw" },
    { 0x174A4280, "chopper_unload_cargo_metalstorm" },
    { 0x411D5349, "chopper_unload_cargo_quad" },
    { 0x775C1A2E, "chopper_unload_rope_cargo" },
    { 0x7AC8F89A, "chopper_victim_logic" },
    { 0xE7739774, "chopper_wait_for_closest_open_path_start" },
    { 0x5107156A, "chopper_wind_helper" },
    { 0x3AEAF3B6, "chopper_yaw" },
    { 0xA9959039, "chopperattackarrow" },
    { 0x3EB34897, "choppercomlinkenemy" },
    { 0xDA86AFD4, "choppercomlinkfriendly" },
    { 0x188569A1, "choppercrashing" },
    { 0x2D05E582, "choppercrashingearthquake" },
    { 0x9425FE77, "choppercrashingfx" },
    { 0xD58D4EB7, "chopperdooropensound" },
    { 0xFCEB714D, "choppergunnerhackertoolradius" },
    { 0x3B5D495C, "choppergunnerhackertooltimems" },
    { 0x3CF4FBCD, "choppergunnerinteriorlight" },
    { 0x9DAB4E37, "choppergunneropendoor" },
    { 0x0326A21D, "choppergunneropendoorflag" },
    { 0x612C7AE3, "choppergunnerspawned" },
    { 0x51EB0E73, "chopperheight" },
    { 0x2F008CF7, "choppermodelenemy" },
    { 0x9790F1B4, "choppermodelfriendly" },
    { 0xC0EA6646, "chopperoverhead" },
    { 0x11AD3334, "chopperoverhead_1stdrop" },
    { 0xDD8647F7, "chopperowner" },
    { 0x691BE623, "chopperpath" },
    { 0xF29B8972, "chopperregular" },
    { 0x462B1EC9, "choppers" },
    { 0xD5E57549, "choppers_alerted" },
    { 0x68E2EC93, "choppers_inbound" },
    { 0xF96F0123, "choppers_spawnfunc" },
    { 0xBADC2FA8, "chopperstrike_5_called" },
    { 0x2A7318C6, "choppersupportcallnextaudio" },
    { 0xB1850889, "choppersupporthoverlocations" },
    { 0x98B315A8, "chopperuseanimtree" },
    { 0x1E76F11F, "chopperyaw" },
    { 0x89825337, "chopperzones" },
    { 0x26C705BF, "choppes" },
    { 0x21FCB4E5, "chopping" },
    { 0x8A409303, "choppr" },
    { 0xE8255080, "choppy" },
    { 0xD5D7A88C, "chopstick1" },
    { 0x47DF17C7, "chopstick2" },
    { 0xA27B379E, "chopsticks" },
    { 0x4272EA31, "chord_name" },
    { 0x2C1470A7, "chord_solved" },
    { 0x94E17B6F, "choreographing" },
    { 0x6EA4A6AA, "choreography" },
    { 0x2B62CC5B, "chose" },
    { 0x312D0D00, "chose_action" },
    { 0x9C70A5CF, "chosen" },
    { 0x652CE745, "chosen_anim" },
    { 0x51F5BE47, "chosen_item" },
    { 0xD1C7763E, "chosen_items" },
    { 0xEE9CFECF, "chosen_path" },
    { 0x0B9CA37A, "chosen_spot" },
    { 0x81EC66F3, "chosenangles" },
    { 0x6ECAC1E0, "chosenanim" },
    { 0x9B39335E, "chosenent" },
    { 0x4F651D61, "chosenindex" },
    { 0x3100F1E7, "chosennode" },
    { 0x6B16ACCB, "chosenorg" },
    { 0xEFD873ED, "chosenorigin" },
    { 0xED18CBC1, "chosenpoi" },
    { 0x8668930C, "chosenspawners" },
    { 0x1FC3B33B, "chosetojuke" },
    { 0x2F4A63BE, "chosing" },
    { 0xA438E13D, "chppoer_gunner_loop" },
    { 0x93A45346, "chr" },
    { 0xB066ADB6, "chr_breathing_better" },
    { 0xE3BBB423, "chr_breathing_hurt" },
    { 0xBF9D64E2, "chr_swtch_end" },
    { 0x98FE4C59, "chr_swtch_start" },
    { 0x8DC61BF2, "chris" },
    { 0xF9092C63, "chris_p" },
    { 0x3BC96AED, "chrisc" },
    { 0xEFC4761B, "chrise" },
    { 0xC1F38BE6, "chrisp" },
    { 0x29E9A242, "christ" },
    { 0x302BB53A, "christian" },
    { 0x3DB2E39D, "chronological" },
    { 0x9B85315F, "chsr" },
    { 0x93FDFA43, "chuck" },
    { 0x9F10E738, "chucked" },
    { 0xADED85F2, "chuckle" },
    { 0x4BFB01A3, "chuckling" },
    { 0xDE1DF884, "chug" },
    { 0x212324FA, "chugabud" },
    { 0x911E10CF, "chugabud_bleed_timeout" },
    { 0xE7CE33D9, "chugabud_bleedout" },
    { 0xCA89B120, "chugabud_corpse_cleanup" },
    { 0x246EEA7E, "chugabud_corpse_cleanup_on_spectator" },
    { 0x1F072769, "chugabud_corpse_revive_icon" },
    { 0x95F7C094, "chugabud_effects_cleanup" },
    { 0xF9106531, "chugabud_fake_death" },
    { 0xEE56EFBA, "chugabud_fake_revive" },
    { 0xC679753D, "chugabud_force_corpse_position" },
    { 0xA731F11C, "chugabud_force_player_position" },
    { 0x90760A83, "chugabud_get_spawnpoint" },
    { 0xDA95614B, "chugabud_give_loadout" },
    { 0xC410E6D8, "chugabud_grabbed" },
    { 0xA84DD7A7, "chugabud_handle_multiple_instances" },
    { 0xA9FF4819, "chugabud_hostmigration" },
    { 0x0C287313, "chugabud_info_volume1" },
    { 0x9A2103D8, "chugabud_info_volume2" },
    { 0x3FC345A7, "chugabud_laststand" },
    { 0x8DD75B82, "chugabud_laststand_cleanup" },
    { 0x03E15030, "chugabud_laststand_func" },
    { 0x4977D155, "chugabud_melee_weapons" },
    { 0x47AFD270, "chugabud_off" },
    { 0x5DAD6F6A, "chugabud_on" },
    { 0xFEF82963, "chugabud_player_init" },
    { 0xC41A9190, "chugabud_restore_claymore" },
    { 0x07D82659, "chugabud_restore_grenades" },
    { 0x087A579B, "chugabud_revive_hud_create" },
    { 0xC6C6EC40, "chugabud_save_grenades" },
    { 0xB065706F, "chugabud_save_loadout" },
    { 0x12A01758, "chugabud_save_perks" },
    { 0x1D6AF11D, "chugabud_shellshock" },
    { 0x3C55B6D9, "chugabud_spawn_corpse" },
    { 0x7675BEF6, "chugabud_spawn_struct" },
    { 0x14FFE2BA, "chugabud_timedout" },
    { 0xBCFC4BF9, "chugabud_weapon" },
    { 0xDDD9C775, "chugabuds" },
    { 0xDC681FFF, "chugabug_precache" },
    { 0x6244D0DC, "chunk" },
    { 0x93E0510D, "chunk1" },
    { 0xB9E2CB76, "chunk2" },
    { 0xDFE545DF, "chunk3" },
    { 0xD5D3ED00, "chunk4" },
    { 0xA0919940, "chunk_1" },
    { 0x1299087B, "chunk_2" },
    { 0xEC968E12, "chunk_3" },
    { 0x5E9DFD4D, "chunk_4" },
    { 0x389B82E4, "chunk_5" },
    { 0xAAA2F21F, "chunk_6" },
    { 0x84A077B6, "chunk_7" },
    { 0xF6A7E6F1, "chunk_8" },
    { 0xD0A56C88, "chunk_9" },
    { 0xB4BE6CD0, "chunk_debris_01" },
    { 0x91BB4EE5, "chunk_debris_01_start" },
    { 0x26C5DC0B, "chunk_debris_02" },
    { 0x00C361A2, "chunk_debris_03" },
    { 0xBFD61A6B, "chunk_debris_03_start" },
    { 0x72CAD0DD, "chunk_debris_04" },
    { 0x827D0295, "chunk_fx" },
    { 0xA935EEF9, "chunk_health" },
    { 0x62744425, "chunk_index" },
    { 0x2BCBA611, "chunk_rotate_piece" },
    { 0xCFD34F98, "chunk_sound" },
    { 0xB3294218, "chunk_time" },
    { 0x6083E01F, "chunks" },
    { 0xF0EDC1BE, "chunks_a_plenty_1" },
    { 0xA4E8CCEC, "chunks_a_plenty_3" },
    { 0x7E40DBE3, "chunks_grate" },
    { 0xCFE87961, "chunks_repair_grate" },
    { 0x5310392E, "chunks_variant1" },
    { 0x2D0DBEC5, "chunks_variant2" },
    { 0xE108C9F3, "chunks_variant4" },
    { 0xBB064F8A, "chunks_variant5" },
    { 0x74E38DAE, "chunky_server_hum" },
    { 0x1BCB6EA8, "church" },
    { 0x66D475E2, "church_area_clear" },
    { 0xC0B4EAE3, "church_bells" },
    { 0xFD1BE446, "church_ceiling_fxanim" },
    { 0xB4DA3C8F, "church_event_awareness" },
    { 0x68862964, "church_fence_push_trigger" },
    { 0xE8A8C5D9, "church_found_position" },
    { 0x75F63BA9, "church_handle_area_killed" },
    { 0xE982C43F, "church_holdup" },
    { 0x38497BD4, "church_holdup_dialogue" },
    { 0xDEF619C3, "church_intro" },
    { 0xFEC8FF0F, "church_left_mg" },
    { 0xE7AC774E, "church_lookout" },
    { 0xB2EC58AB, "church_lookout_cleanup" },
    { 0x0EF82ACB, "church_lookout_dead" },
    { 0xFD7BA2B9, "church_lookout_death" },
    { 0x198FBE11, "church_lookout_fire" },
    { 0x7F5972E9, "church_lookout_goto_bestpos" },
    { 0xBE8C3912, "church_lookout_stealth_behavior_alert_level_attack" },
    { 0x40F910A3, "church_lookout_stealth_behavior_alert_level_investigate" },
    { 0x91B5E3F3, "church_lookout_stealth_behavior_explosion" },
    { 0xEF9B9CD5, "church_lookout_stealth_behavior_found_corpse" },
    { 0xF6698B2C, "church_lookout_stealth_behavior_saw_corpse" },
    { 0xDBA94BF2, "church_lookout_wait" },
    { 0x32368D38, "church_main" },
    { 0xE8043514, "church_moveup_car" },
    { 0xFD23065A, "church_open_door" },
    { 0xE2049B3E, "church_open_door_commit" },
    { 0xD227B6D2, "church_patroller" },
    { 0x1C6D11D7, "church_patroller_dead" },
    { 0x3746261D, "church_patroller_death" },
    { 0x46D3079F, "church_patroller_faraway_trig" },
    { 0x716C248E, "church_right_mg" },
    { 0x2C4D1A26, "church_run_for_it" },
    { 0xBC824ADA, "church_run_for_it_commit" },
    { 0x2284D6F8, "church_run_for_it_dead_dialogue" },
    { 0x224933C5, "church_runup" },
    { 0x92AE7DFD, "church_runup2" },
    { 0xA53C2ED6, "church_sneakup" },
    { 0x7DA855D3, "church_sneakup_dialogue_help" },
    { 0x49DD34E4, "church_sneakup_dialogue_nag" },
    { 0x97B62B6E, "church_sneakup_dialogue_nag2" },
    { 0x3044891B, "church_volume_death_check" },
    { 0xD45A3BDB, "church_walkthrough" },
    { 0xEDC5C8B8, "church_walkthrough_lookaround" },
    { 0xDFF5A6EF, "churchside_area" },
    { 0x56C0CEC8, "churchtower_blown" },
    { 0xAD4CE1A8, "churchyard" },
    { 0x9A103355, "churn" },
    { 0x8052CD92, "churn_fx" },
    { 0x495A9453, "churning" },
    { 0x59F1D530, "chute" },
    { 0xAD974191, "chute_anim_loop" },
    { 0x7BD21465, "chute_deployed" },
    { 0x44C616B6, "chute_ent" },
    { 0x744A534A, "chute_hint_given" },
    { 0x11F83602, "chute_pull" },
    { 0xD90AA115, "chute_pulled" },
    { 0x4770BA6B, "chute_spawn_and_initial_animate" },
    { 0xEE28F437, "chute_start_spawners" },
    { 0x590A33DA, "chute_window_passed" },
    { 0x87CE773A, "chyort" },
    { 0xE819D3FE, "chyron" },
    { 0x06D97AB7, "chyron_menu_closed" },
    { 0xC685B3A3, "chyron_menu_open" },
    { 0x8AA23F1D, "chyron_text_active" },
    { 0x46F4E808, "chyronloop" },
    { 0x005BF0C6, "cia" },
    { 0x211F6288, "cia_alive" },
    { 0xD40657BD, "cia_easter_egg" },
    { 0x939266A9, "cia_easter_egg_success" },
    { 0x79507053, "cia_easter_egg_timer" },
    { 0x0E06FE91, "cia_easter_egg_timer_expired" },
    { 0x70A8BB45, "cia_easter_egg_vo" },
    { 0x347BFFB5, "ciaagent" },
    { 0xB456FBF4, "cic" },
    { 0x2790DE05, "cic_overheat_hud" },
    { 0xC9760E52, "cic_turret_alert_sound" },
    { 0x38BAA992, "cic_turret_blink_lights" },
    { 0x6C405C27, "cic_turret_damage" },
    { 0xC9084CFA, "cic_turret_death" },
    { 0x969BE05E, "cic_turret_death_movement" },
    { 0xD62B69B0, "cic_turret_dmg_snd" },
    { 0x39F05215, "cic_turret_emped" },
    { 0x20D6503C, "cic_turret_fire_for_time" },
    { 0x8929BFC3, "cic_turret_fireupdate" },
    { 0xB149AA04, "cic_turret_get_damage_effect" },
    { 0x0F5D34ED, "cic_turret_lens_flare" },
    { 0x6BF457CB, "cic_turret_main" },
    { 0x31D70AB3, "cic_turret_off" },
    { 0xD20B689F, "cic_turret_on" },
    { 0x0819EAB0, "cic_turret_on_target_thread" },
    { 0x197CACDF, "cic_turret_play_single_fx_on_tag" },
    { 0x2FAE15B2, "cic_turret_scripted" },
    { 0x044158B0, "cic_turret_set_team" },
    { 0x73A1F565, "cic_turret_start_ai" },
    { 0x64047FB9, "cic_turret_start_scripted" },
    { 0x4BF69F84, "cic_turret_think" },
    { 0xDF1ADF01, "cicturretcallback_vehicledamage" },
    { 0xC4FEB4E6, "cieling" },
    { 0xE6D1773F, "cients" },
    { 0x1C4D1250, "cig" },
    { 0xFCAB07FA, "cig_smoke" },
    { 0x572D7E99, "cigar" },
    { 0xE32E7F2F, "cigarette" },
    { 0xB4F679E4, "cililian" },
    { 0xF073EA7F, "cin_auto_center" },
    { 0x512A67A2, "cin_belov" },
    { 0x711E7694, "cin_brit1" },
    { 0xE325E5CF, "cin_brit2" },
    { 0xBD236B66, "cin_brit3" },
    { 0x0B184583, "cin_dragovich" },
    { 0x57517D15, "cin_everybody" },
    { 0xEA16A90E, "cin_guy1" },
    { 0xC4142EA5, "cin_guy2" },
    { 0x9E11B43C, "cin_guy3" },
    { 0x780F39D3, "cin_guy4" },
    { 0x3378D262, "cin_headlook_down" },
    { 0x6B2FE301, "cin_headlook_left" },
    { 0xEAFC60EC, "cin_headlook_right" },
    { 0x319899AA, "cin_headlook_tag" },
    { 0xC13C12F9, "cin_headlook_up" },
    { 0x30544657, "cin_hud" },
    { 0x5A767113, "cin_id" },
    { 0x342616D4, "cin_kravchenko" },
    { 0xC11C14AA, "cin_nevski" },
    { 0xBDF70E9C, "cin_petrenko" },
    { 0x3468D33C, "cin_reznov" },
    { 0x710F1A82, "cin_steiner" },
    { 0xD00A41C0, "cin_tvelin" },
    { 0xFC99813B, "cin_use_headlook" },
    { 0xF8056B83, "cin_use_tag_angles" },
    { 0x3B602E8C, "cin_view_fraction" },
    { 0x04ECCFB6, "cin_vikharev" },
    { 0x35BFA411, "cincapturedisablealpha" },
    { 0xFF78B470, "cincaptureenablealpha" },
    { 0x8241D7BE, "cincapturefps" },
    { 0x95524200, "cinch" },
    { 0x6EE193AE, "cine_notify" },
    { 0x00A12094, "cinema" },
    { 0xB684BAE0, "cinematic" },
    { 0xE3D0CE55, "cinematic_start" },
    { 0x3984ED6F, "cinematicingame" },
    { 0x0F8EEEC5, "cinematicingameloopfromfastfile" },
    { 0x67F93159, "cinematicingameloopresident" },
    { 0x78F99F3E, "cinematicingamesync" },
    { 0xC570918B, "cinematics" },
    { 0x1E9973BE, "cinemtaic" },
    { 0xFF05A5E4, "cipher" },
    { 0x39F432C0, "cipher_key" },
    { 0xEEBDB43B, "cipher_letter" },
    { 0xF090A335, "circle" },
    { 0x92B3C099, "circle_courtyard" },
    { 0xEC4B2244, "circle_line_intersect" },
    { 0x6CAE01C0, "circle_sides" },
    { 0x38364D32, "circle_stage" },
    { 0xE0B84543, "circle_struct" },
    { 0x7E2041F3, "circle_target" },
    { 0x7A277314, "circle_test" },
    { 0x9194EA2B, "circled" },
    { 0xB162C457, "circleinc" },
    { 0xED7F2C7C, "circlepoints" },
    { 0x722F7655, "circlepos" },
    { 0x5151BABF, "circleradius" },
    { 0xA9C99EE5, "circleres" },
    { 0x576FBE04, "circles" },
    { 0x89A9852E, "circletarget" },
    { 0x024B6800, "circling" },
    { 0x1CEC3A9C, "circling_close_allowed" },
    { 0xB374604E, "circling_heli_minigun_firethread" },
    { 0xF9CDE889, "circling_heli_rpg_spawners" },
    { 0x13BF395E, "circling_helis" },
    { 0x2A8FBC41, "circling_helis_fire" },
    { 0xEB19FE03, "circling_helis_rpg_guy_spawner" },
    { 0xD517393F, "circling_helis_rpg_guy_think" },
    { 0x1DC765B3, "circling_max_count" },
    { 0xC6F972CA, "circuit" },
    { 0x79A8F6A6, "circuit_sound" },
    { 0x1D670C5D, "circuited" },
    { 0x6DB85226, "circuiting" },
    { 0x89FE8FC6, "circular" },
    { 0x5F7C3CDC, "circulates" },
    { 0x5CCB4E92, "circumstance" },
    { 0x9F43F49D, "circumstances" },
    { 0xD4EE7FCB, "circumvent" },
    { 0x03601C04, "circuted" },
    { 0x3FF53990, "cistern_color_trigger" },
    { 0x916E8B37, "citadel" },
    { 0xCEC69E9C, "cities" },
    { 0x59BD8B87, "citizen" },
    { 0xB470DD80, "city" },
    { 0x8D27AEE3, "city_choppers_retreat" },
    { 0xD07055AD, "city_marker" },
    { 0xE227E629, "civ" },
    { 0x84A3795E, "civ_bouncer" },
    { 0x9A2E011B, "civ_bumped" },
    { 0x6A871FA1, "civ_dancer" },
    { 0xC77EF6BB, "civ_death_melee_bat" },
    { 0x6E550B95, "civ_escape" },
    { 0x4E0E5084, "civ_flee" },
    { 0x108066B1, "civ_get_detected" },
    { 0x3B63605B, "civ_get_goal_func" },
    { 0x64577B25, "civ_girl_goto_railing" },
    { 0xDDB610D8, "civ_goto_railing" },
    { 0x4F8529CA, "civ_idle" },
    { 0xF6336492, "civ_init" },
    { 0x7B1458D2, "civ_loop_anim" },
    { 0x905BAAEB, "civ_male" },
    { 0xCCE35EE8, "civ_pickup" },
    { 0x75BDCCA7, "civ_precache" },
    { 0xDD2DE296, "civ_run_from_node_to_node" },
    { 0x545D030F, "civ_set_goal_func" },
    { 0x1201FC27, "civ_shoot_at_timeout" },
    { 0xBD46AED6, "civ_spawn_props" },
    { 0x83B59648, "civ_spawner" },
    { 0x7ADFE7AE, "civ_stop_callback" },
    { 0x014FE0E6, "civ_timeout_death" },
    { 0xC46D3D7F, "civ_vtol" },
    { 0x50FE1C16, "civcount" },
    { 0xFB6A6472, "civil" },
    { 0x012DA1C3, "civilan" },
    { 0x8AA848CA, "civilian" },
    { 0x57640417, "civilian1" },
    { 0xE55C94DC, "civilian2" },
    { 0x0B5F0F45, "civilian3" },
    { 0x9957A00A, "civilian4" },
    { 0xB91BE90A, "civilian_ai_idle_and_react" },
    { 0x59ED4513, "civilian_ai_set_custom_animation_reaction" },
    { 0x57F76DE4, "civilian_aimedat" },
    { 0xA908609F, "civilian_anim_loop" },
    { 0xC548D0E5, "civilian_anim_single" },
    { 0x2F0AF519, "civilian_animation_react" },
    { 0x64CC9E81, "civilian_anims" },
    { 0x54B2CE28, "civilian_balcony_fling_anim" },
    { 0xB792F2DF, "civilian_car_riders_mission_fail" },
    { 0xBE230E46, "civilian_car_riders_spawn_and_idle" },
    { 0xF9EAE3D7, "civilian_car_riders_spawn_and_idle_start" },
    { 0x5EFA7515, "civilian_coke_worker_died" },
    { 0xAE4AE1CD, "civilian_corpse_limit" },
    { 0x33C320B8, "civilian_corpse_model1" },
    { 0xA5CA8FF3, "civilian_corpse_model2" },
    { 0x07CC88F5, "civilian_death" },
    { 0x7314CAA0, "civilian_delete" },
    { 0x20D6FC24, "civilian_deleted" },
    { 0xA02E0C58, "civilian_doidle" },
    { 0xE993AEAC, "civilian_drones" },
    { 0x53DC0C64, "civilian_friendlyfire" },
    { 0xE2919138, "civilian_group4_waiting_to_escape_anim" },
    { 0x0404B9AF, "civilian_health" },
    { 0x3C9621DB, "civilian_idle" },
    { 0x7962B80A, "civilian_init_done" },
    { 0x5CB3E9B8, "civilian_left_stairs_group1_anim" },
    { 0xD826F5D2, "civilian_left_stairs_group1_anim_ending" },
    { 0x828EFCCB, "civilian_left_stairs_group1_anim_starting" },
    { 0xB2872471, "civilian_left_stairs_group2_anim" },
    { 0x623E32A1, "civilian_lookahead_value" },
    { 0x065BE215, "civilian_loop_moveanims" },
    { 0x09416C26, "civilian_makevecarray" },
    { 0x19355D7D, "civilian_movetonode" },
    { 0x6E5A4981, "civilian_movetovec" },
    { 0xDB51D150, "civilian_movetovecarray" },
    { 0xD3F9BB73, "civilian_names" },
    { 0xBF088951, "civilian_prepare_for_animation" },
    { 0x6BA15831, "civilian_react_gunfire" },
    { 0xBDD37F02, "civilian_reaction_enable" },
    { 0xA35990BA, "civilian_reaction_notification" },
    { 0x570D63F2, "civilian_rocks_execution_anim" },
    { 0x974417E2, "civilian_run_hunched_a" },
    { 0x71419D79, "civilian_run_hunched_b" },
    { 0x4B3F2310, "civilian_run_hunched_c" },
    { 0x51A3B66E, "civilian_run_hunched_dodge" },
    { 0x7BD84C0B, "civilian_run_hunched_flinch" },
    { 0xD143457A, "civilian_run_upright" },
    { 0x2E194B92, "civilian_spawn" },
    { 0x325115BF, "civilian_spawn_init" },
    { 0xBB8B43DB, "civilian_stop_aimedat" },
    { 0x9441EAB2, "civilian_stop_idle" },
    { 0x364F5853, "civilian_stopidle" },
    { 0x1FBFD099, "civilian_todo" },
    { 0x28AA3F22, "civilian_waittill_arrayspawn" },
    { 0x5E670499, "civilian_waittill_arrayspawn_thread" },
    { 0xE47C3B7B, "civilian_waittill_spawn" },
    { 0x0DFFE532, "civilian_waittill_spawn_thread" },
    { 0x74BEEE59, "civilianarrayspawned" },
    { 0x56BBA783, "civilianblackboardinit" },
    { 0xD752EB0E, "civiliancoweractioninitialize" },
    { 0xE2BDCBBC, "civilianinit" },
    { 0xBA4429ED, "civilianispanicked" },
    { 0x98C37ED9, "civilianjetflyby" },
    { 0x2B54F9D9, "civilianmoveactionfinalize" },
    { 0x0E3F72DD, "civilianmoveactioninitialize" },
    { 0xA83CD44D, "civilianonanimscriptedcallback" },
    { 0x08E0E957, "civilianpanic" },
    { 0x8AC07505, "civilians" },
    { 0x5367D125, "civilians_injured_from_battle_anim" },
    { 0xC6649387, "civilians_running_from_battle_anim" },
    { 0x74AC496E, "civiliansex" },
    { 0x614FE6BC, "civilianspawned" },
    { 0xA0C833B7, "civilianspawnertargetnames" },
    { 0x4B48ADCA, "civilization" },
    { 0xFDAD4D85, "civis" },
    { 0x6ECAEB7A, "civrunanims" },
    { 0x9B50EFA0, "civs" },
    { 0xE21D7609, "civs_all_dead" },
    { 0x74ADA5CB, "civs_escape_into_mall_then_use_pathnodes" },
    { 0x1FEB3046, "civs_exiting_tag_align" },
    { 0x0005AB5C, "civs_scream" },
    { 0xD1D689D6, "ck_cost_col" },
    { 0x7D3ACB08, "cl" },
    { 0x5B63C5CA, "cl_clearkeys" },
    { 0xD1617B76, "clacker" },
    { 0xCB2CE3DB, "clacker_disable" },
    { 0x3BA4D10A, "clacker_drop" },
    { 0xCDA37840, "clacker_enable" },
    { 0x5584B569, "clacker_fire" },
    { 0x3AB8D893, "clacker_has_been_exercised" },
    { 0x012677D3, "clacker_init" },
    { 0xB6308CC1, "clacker_marker_setup" },
    { 0xF789E8B6, "clacker_markers" },
    { 0x4002519A, "clacker_nearfarslope_check" },
    { 0x605F4379, "clacker_notouch" },
    { 0x6F0E568C, "clacker_primary_attack" },
    { 0x4BFDDEE0, "clacker_standby" },
    { 0x432A6454, "clacker_use_shouting" },
    { 0x4B5D5269, "clackers" },
    { 0x15B8D773, "claim" },
    { 0xDFF82D42, "claim_a_node" },
    { 0x4F6F06AB, "claim_location" },
    { 0xCD99E01F, "claim_position" },
    { 0xCA3A254E, "claim_trigger" },
    { 0x92E6F1E6, "claimcallback" },
    { 0x02D1AD28, "claimed" },
    { 0xA7BB9074, "claimed_attractor_positions" },
    { 0x6E1DC91C, "claimed_by" },
    { 0xA5EC04BC, "claimed_count" },
    { 0x7AB7C7BD, "claimed_items" },
    { 0x4307B497, "claimed_node" },
    { 0xCFDE802F, "claimedby" },
    { 0x9934EA3A, "claimgraceperiod" },
    { 0x962DA9ED, "claiming" },
    { 0xCE6D6CE4, "claimplayer" },
    { 0x730E19B5, "claimpoi" },
    { 0xEB749822, "claims" },
    { 0x5000E280, "claimteam" },
    { 0x3232425F, "claimteammomentummultiplier" },
    { 0xE574F5C5, "claimtrigger" },
    { 0x31931862, "clamp" },
    { 0xF2B9833F, "clamp1" },
    { 0x80B21404, "clamp2" },
    { 0xA6B48E6D, "clamp3" },
    { 0x34AD1F32, "clamp4" },
    { 0x98ACFD67, "clamp_d" },
    { 0x764F2CE8, "clamp_diff" },
    { 0xB64A6B1B, "clamp_health_to_max_health" },
    { 0x68992A1F, "clamp_l" },
    { 0x8F170AB9, "clamp_max" },
    { 0xE9BCE947, "clamp_min" },
    { 0x25C6C7B5, "clamp_pitch" },
    { 0x14C5C581, "clamp_r" },
    { 0x4097A53E, "clamp_size" },
    { 0xD2D2298E, "clamp_u" },
    { 0xD6EADDF8, "clamp_value" },
    { 0x87F54EF2, "clamp_yaw" },
    { 0xAE264EA8, "clamped_ang" },
    { 0x3A173B45, "clamped_val" },
    { 0xA06EDCBA, "clampenttomapboundary" },
    { 0xD02067F3, "clampfrustration" },
    { 0xB528E54E, "clamping" },
    { 0x283246C5, "clamporigintomapboundary" },
    { 0x2615F42D, "clamps" },
    { 0x0091B0F5, "clampscorelimit" },
    { 0x1A46B805, "clamptarget" },
    { 0x0A7AD48B, "clamptonavmesh" },
    { 0x3FD72F96, "clamptonavmeshlocation" },
    { 0x0047BB83, "clangs" },
    { 0x1A43C361, "clarify" },
    { 0xC76A4607, "clarity" },
    { 0xFD991480, "clark" },
    { 0x44F52FAF, "clark_death" },
    { 0x444B90D2, "clark_death_done" },
    { 0xE9F32089, "clark_death_gutter_setup" },
    { 0x6263C1B3, "clark_death_in" },
    { 0xE58B97C6, "clark_death_out" },
    { 0xFE8DACC5, "clark_death_player" },
    { 0x3B21B842, "clark_death_weaver" },
    { 0x58105B56, "clark_down_the_pipe" },
    { 0xAD99C7AF, "clark_jump" },
    { 0x1067FF41, "clark_scene" },
    { 0xFD833C51, "clark_spawn_init" },
    { 0xC71C4DDB, "clark_unlock_gate" },
    { 0xDE527862, "clarkdeath8501" },
    { 0xB6F590ED, "clarke" },
    { 0x2D4441D4, "clarke_blood_on_face" },
    { 0x40E4D0A6, "clarke_head" },
    { 0x3C16009E, "clarke_headshot" },
    { 0xCD0252BB, "clarke_punched" },
    { 0xF59E0A12, "clarke_set_friendname" },
    { 0x640B4BF1, "clarke_sign_hit" },
    { 0x13581233, "clarke_slide_teleport" },
    { 0x93F9D512, "clarke_spit" },
    { 0xDE7627EC, "clarkes" },
    { 0xCB1842AB, "clarks" },
    { 0x8D77C4BF, "clasertripwire" },
    { 0xB1586AB0, "clash" },
    { 0xF34C06A3, "class" },
    { 0x7E5108A3, "class_all" },
    { 0xE189B1BF, "class_assault" },
    { 0xED6B172B, "class_assault_cd" },
    { 0x0CF02C3C, "class_assault_cd_sand" },
    { 0x9EC59EF7, "class_assault_cd_snow" },
    { 0x50B69ABA, "class_assault_cd_wet" },
    { 0x62645997, "class_assault_chn_pla" },
    { 0x909AC078, "class_assault_chn_pla_sand" },
    { 0xC5C3B6CB, "class_assault_chn_pla_snow" },
    { 0x13006FE6, "class_assault_chn_pla_wet" },
    { 0x5DE073BB, "class_assault_isa" },
    { 0xAC92086C, "class_assault_isa_sand" },
    { 0x46472A07, "class_assault_isa_snow" },
    { 0xEC71DD2A, "class_assault_isa_wet" },
    { 0x25825125, "class_assault_rus_pmc" },
    { 0xE0D1191E, "class_assault_rus_pmc_sand" },
    { 0xB7662009, "class_assault_rus_pmc_snow" },
    { 0xA6FA2A2C, "class_assault_rus_pmc_wet" },
    { 0x14087C0F, "class_assault_usa_fbi" },
    { 0xCBF83A40, "class_assault_usa_fbi_sand" },
    { 0x66BF6B23, "class_assault_usa_fbi_snow" },
    { 0x3B81BCEE, "class_assault_usa_fbi_wet" },
    { 0xA9079588, "class_assault_usa_seals" },
    { 0xFA9BD199, "class_assault_usa_seals_sand" },
    { 0x0579F2B6, "class_assault_usa_seals_snow" },
    { 0x76A2DE65, "class_assault_usa_seals_wet" },
    { 0xBEEE2687, "class_assault_usa_sog" },
    { 0x198DFD22, "class_assault_vtn_nva" },
    { 0x8448E8DD, "class_damage_feedback" },
    { 0x711388EA, "class_datatable" },
    { 0xDAC7C456, "class_exists" },
    { 0xE113EFFA, "class_index" },
    { 0x819BAA20, "class_init" },
    { 0x69D9897A, "class_lmg" },
    { 0xBEEE6A54, "class_lmg_cd" },
    { 0xA1CFD7C5, "class_lmg_cd_sand" },
    { 0x0F2EE11A, "class_lmg_chn_pla" },
    { 0x697ABDD7, "class_lmg_chn_pla_wet" },
    { 0x47FD6B16, "class_lmg_isa" },
    { 0x81B929F7, "class_lmg_isa_sand" },
    { 0xACE907A0, "class_lmg_rus_pmc" },
    { 0x2DF36CCE, "class_lmg_rus_pmc_snow" },
    { 0x25C89156, "class_lmg_usa_fbi" },
    { 0x5A53B401, "class_lmg_usa_seals" },
    { 0x5D50B81D, "class_lmg_usa_seals_snow" },
    { 0x8F973138, "class_lmg_usa_seals_wet" },
    { 0xF275DCD2, "class_lmg_usa_sog" },
    { 0xB2165DF3, "class_lmg_vtn_nva" },
    { 0xB54D1A86, "class_num" },
    { 0x4833CA26, "class_num_for_global_weapons" },
    { 0x71FC1E12, "class_num_for_killstreaks" },
    { 0x76BC7D40, "class_shotgun" },
    { 0xFFC49CBE, "class_shotgun_cd" },
    { 0xFAC6A6AF, "class_shotgun_cd_sand" },
    { 0xD91C2CD8, "class_shotgun_chn_pla" },
    { 0xC03CD415, "class_shotgun_chn_pla_wet" },
    { 0x7C91DC4C, "class_shotgun_isa" },
    { 0x83C2DCED, "class_shotgun_isa_sand" },
    { 0xA14AFD7A, "class_shotgun_rus_pmc" },
    { 0x9AC92308, "class_shotgun_rus_pmc_snow" },
    { 0x315D2760, "class_shotgun_usa_fbi" },
    { 0x1E930803, "class_shotgun_usa_seals" },
    { 0xD51B0D2F, "class_shotgun_usa_seals_snow" },
    { 0xFF0C8C42, "class_shotgun_usa_seals_wet" },
    { 0x8B556B28, "class_shotgun_usa_sog" },
    { 0xB24A0541, "class_shotgun_vtn_nva" },
    { 0x8D68192D, "class_smg" },
    { 0x01E27DE5, "class_smg_cd" },
    { 0x7B5083DE, "class_smg_cd_sand" },
    { 0xE331B125, "class_smg_chn_pla" },
    { 0xE83F8A2C, "class_smg_chn_pla_wet" },
    { 0x596524D1, "class_smg_isa" },
    { 0x36BF111A, "class_smg_isa_sand" },
    { 0x5FA3E517, "class_smg_rus_pmc" },
    { 0x4D5B794B, "class_smg_rus_pmc_snow" },
    { 0x8DD7A6D1, "class_smg_usa_fbi" },
    { 0x68EC89DA, "class_smg_usa_seals" },
    { 0x934B0F28, "class_smg_usa_seals_snow" },
    { 0x30BA5797, "class_smg_usa_seals_wet" },
    { 0xF6FACC8D, "class_smg_usa_sog" },
    { 0x54887CD0, "class_smg_vtn_nva" },
    { 0x74E5A943, "class_sniper" },
    { 0xF89A2B07, "class_sniper_cd" },
    { 0xC59F1C48, "class_sniper_cd_sand" },
    { 0xB2A2812B, "class_sniper_chn_pla" },
    { 0x447AA4BA, "class_sniper_chn_pla_wet" },
    { 0x3B3C2057, "class_sniper_isa" },
    { 0xF225D138, "class_sniper_isa_sand" },
    { 0xA819E399, "class_sniper_rus_pmc" },
    { 0x3BF55355, "class_sniper_rus_pmc_snow" },
    { 0xF501E5A3, "class_sniper_usa_fbi" },
    { 0x4067F5B4, "class_sniper_usa_seals" },
    { 0x91124BAA, "class_sniper_usa_seals_snow" },
    { 0xC4AEA751, "class_sniper_usa_seals_wet" },
    { 0x97148363, "class_sniper_usa_sog" },
    { 0xF109F08E, "class_sniper_vtn_nva" },
    { 0xC09CF661, "class_spawners" },
    { 0xAC05EBA3, "class_type_populate" },
    { 0x2D8BC6A1, "class_types" },
    { 0x26977E15, "classbasename" },
    { 0x5FA2F700, "classbonus" },
    { 0xF1243AD7, "classbonus_data" },
    { 0xB057FFE7, "classes" },
    { 0x692AC5D0, "classes_global_init" },
    { 0xC83E526A, "classgrenades" },
    { 0x8CB90DE3, "classic" },
    { 0x5F3BF532, "classic_collision_spawning" },
    { 0xF15A56C3, "classic_player_damage_callback" },
    { 0x7BEB0B48, "classicbuildables" },
    { 0x2DBF2D74, "classicon" },
    { 0x7A60F0DC, "classidx" },
    { 0x770196AD, "classification" },
    { 0x3425583F, "classifies" },
    { 0xAFDBAFE5, "classindex" },
    { 0x0C66899E, "classitem" },
    { 0x740D0FA7, "classlist" },
    { 0xD9148BB7, "classmap" },
    { 0xE6E9B8DE, "classname" },
    { 0x59254A41, "classnames" },
    { 0xDFC6D98D, "classnum" },
    { 0x3F743272, "classobj" },
    { 0x78DF3F23, "classprimaryattachments" },
    { 0x9E922A42, "classref" },
    { 0x035B7B44, "classsidearm" },
    { 0xFF164149, "classstat" },
    { 0xAB656F62, "classstatstring" },
    { 0x636B079F, "classtablelookup" },
    { 0x9E179950, "classteam" },
    { 0x0BB3FDD8, "classtime" },
    { 0x2F634D08, "classtoclassnum" },
    { 0x3558002D, "classtospawn" },
    { 0x175E74E8, "classtweaks" },
    { 0x28CAF1DB, "classtype" },
    { 0x3C9607C4, "classtypeidx" },
    { 0x7379401A, "classvalue" },
    { 0xB7196FC6, "classvehicledamage" },
    { 0xDC7BDF0E, "classweapons" },
    { 0x984A458E, "clause" },
    { 0x1029812C, "claw" },
    { 0xCE405F0D, "claw1_ai_damage_total" },
    { 0xBD6DB27C, "claw1_damage_total" },
    { 0x8FB46F0D, "claw1_spawn" },
    { 0x478E095D, "claw1_startup_pip" },
    { 0x9E57DAF9, "claw1_startup_screen_faded" },
    { 0x5E718246, "claw2_ai_damage_total" },
    { 0xC4EF3331, "claw2_damage_total" },
    { 0xC2154F42, "claw_01" },
    { 0x9C12D4D9, "claw_02" },
    { 0xCD29C090, "claw_1" },
    { 0x82F1E141, "claw_1_init" },
    { 0xFBA1B679, "claw_1_market_movement" },
    { 0x3F312FCB, "claw_2" },
    { 0x9C69F3B2, "claw_2_market_movement" },
    { 0x7A080A14, "claw_ai_angles" },
    { 0x03D6EDF2, "claw_ai_damage_override" },
    { 0xDC176F12, "claw_ai_origin" },
    { 0xBA315AD5, "claw_ang" },
    { 0x1C144715, "claw_animating" },
    { 0x89FB4B67, "claw_anims" },
    { 0xBE3965D7, "claw_anims_inited" },
    { 0x9701C946, "claw_arm_l" },
    { 0x82DF1788, "claw_arm_r" },
    { 0x4E1ECD91, "claw_back_track_death" },
    { 0xAC0BD75B, "claw_bigdog" },
    { 0x94A4D621, "claw_bigrig_exits" },
    { 0x92DCE3CB, "claw_burned_guy" },
    { 0x628513DF, "claw_camera_tag" },
    { 0x9F38BA65, "claw_cleanup" },
    { 0xE90DC840, "claw_cntxt" },
    { 0xF644A39A, "claw_complete" },
    { 0x67E6ACD8, "claw_crate_drop" },
    { 0x83F7EF79, "claw_crate_grab" },
    { 0x4EDB7D40, "claw_crate_move" },
    { 0x4A22DDB6, "claw_damage_filter_loop" },
    { 0xCB0ACC09, "claw_damage_watcher" },
    { 0x023A11A8, "claw_damaged" },
    { 0x185D83A2, "claw_damaged_mechz_endon_watcher" },
    { 0x22D9002C, "claw_damaged_player_endon_watcher" },
    { 0xFE812767, "claw_data_glove_on" },
    { 0x3CBEA4BB, "claw_death" },
    { 0xF03CA4E0, "claw_destroyed" },
    { 0xBFA39A17, "claw_done" },
    { 0x2C4F8B87, "claw_drop_pause" },
    { 0xA4C74E51, "claw_drop_think" },
    { 0x182CAE7E, "claw_ending" },
    { 0xF1BA3A4E, "claw_enemies_intro" },
    { 0x6D7ECC6A, "claw_event_over" },
    { 0x030D22B9, "claw_event_spawn_funcs" },
    { 0xD8FF8DE5, "claw_fail_condition" },
    { 0x5738A971, "claw_fire_direction_allow_hint" },
    { 0x9E9DFCE0, "claw_fire_direction_disable" },
    { 0x7F7679F9, "claw_fire_direction_enable" },
    { 0x4CDB1556, "claw_fire_direction_func" },
    { 0xF161275C, "claw_fire_direction_kill" },
    { 0x7ED6C9FC, "claw_fire_direction_remove_hint" },
    { 0x30874FB8, "claw_fire_direction_weapon" },
    { 0xD48B567C, "claw_fire_grenade" },
    { 0x1FDB273A, "claw_firing" },
    { 0x000DF38B, "claw_flamethrower_attachment" },
    { 0x61546823, "claw_flamethrower_control" },
    { 0x010FC1FD, "claw_flamethrower_max_dist" },
    { 0x1E67B67B, "claw_flamethrower_model" },
    { 0xFEA8AF02, "claw_flamethrower_perk_setup" },
    { 0xAB916F2C, "claw_flamethrower_tag" },
    { 0xB8745010, "claw_flamethrower_weapon" },
    { 0xF016299F, "claw_front_track_death" },
    { 0xDC36D485, "claw_fx" },
    { 0x7A57B96E, "claw_gib_chance" },
    { 0x7D0B7A05, "claw_give_flamethrower" },
    { 0x915B6160, "claw_grapple" },
    { 0x1382537F, "claw_grenade_launch" },
    { 0x5E3F35FD, "claw_grenade_launch_hack" },
    { 0x91B2DB0C, "claw_grenade_launch_pillar_hit" },
    { 0xC36BB404, "claw_grenade_speed_scale" },
    { 0x7343AB3E, "claw_grenade_tag" },
    { 0xFD59B055, "claw_grenade_turret_think" },
    { 0x0250C616, "claw_grenade_weapon" },
    { 0x696989AA, "claw_has_flamethrower" },
    { 0x6FAE30CF, "claw_kill" },
    { 0x09BFC893, "claw_kill_callback" },
    { 0x265B6A8D, "claw_kill_callback_control" },
    { 0xA2B5AF61, "claw_kill_enemies_behind" },
    { 0xA3C25C96, "claw_kills" },
    { 0x39CE0F1D, "claw_kills_total" },
    { 0xDBC0EB95, "claw_l" },
    { 0xD6D4F38B, "claw_link_arms" },
    { 0x82C9B07B, "claw_melee_dist_sq" },
    { 0xDD442E91, "claw_melee_lerp_time" },
    { 0x3657E0FE, "claw_move_arms" },
    { 0xF934BF50, "claw_movedone" },
    { 0x37BB4B54, "claw_nag_filter" },
    { 0x93EF4A1D, "claw_nag_vo_setup" },
    { 0x96466DDE, "claw_noharper_lapd_cop_logic" },
    { 0x6446945A, "claw_noharper_lapd_cop_logic_color" },
    { 0x862084E3, "claw_noharper_track_death" },
    { 0x08D0C9A4, "claw_number" },
    { 0x0E8B2869, "claw_origin" },
    { 0x73D23132, "claw_pathing" },
    { 0x73ACE523, "claw_pause" },
    { 0x33376614, "claw_pip_off" },
    { 0xDFEB571E, "claw_pip_on" },
    { 0x0551EDA3, "claw_player_damage_override" },
    { 0x27FD254F, "claw_pos" },
    { 0x6612E850, "claw_precache" },
    { 0xBFCFCA0B, "claw_r" },
    { 0x59F257A1, "claw_remove_blur" },
    { 0x61C23C6D, "claw_remove_flamethrower_perk_option" },
    { 0xDEB4EA30, "claw_rumble" },
    { 0x3EB07091, "claw_run_over_destructible_think" },
    { 0x5E6DBB73, "claw_run_over_destructibles" },
    { 0xCAF7B9D7, "claw_run_over_enemy_watcher" },
    { 0x431FBEB6, "claw_setup" },
    { 0xA3C3A505, "claw_shutdown" },
    { 0xB9DC5C5E, "claw_skipto_logic" },
    { 0xF002AB14, "claw_spawning" },
    { 0x608B0007, "claw_speeds" },
    { 0xDA8E12ED, "claw_start_timeout" },
    { 0xE5A76F22, "claw_starting_vo_done" },
    { 0xA056F572, "claw_startup" },
    { 0x842A413A, "claw_switch_down" },
    { 0x0D285FA9, "claw_switch_left" },
    { 0xBB9B9154, "claw_switch_right" },
    { 0xDC2D594E, "claw_switch_think" },
    { 0x8D084873, "claw_switch_timeout" },
    { 0x9E4E05D5, "claw_tag" },
    { 0x65ADE35D, "claw_think" },
    { 0xD97068F4, "claw_timeout" },
    { 0x82B2CF4B, "claw_toggle_firing" },
    { 0xDEC18682, "claw_turn_on_extracam" },
    { 0x42703229, "claw_turret" },
    { 0xCFB5D139, "claw_tutorial" },
    { 0x10A4C1D0, "claw_unlink_arms" },
    { 0xD3FB458A, "claw_update_hud" },
    { 0xE4FCA62A, "claw_vehicle_damage_override" },
    { 0x7985E469, "claw_vo_player_damage_override" },
    { 0xFA4DC079, "claw_walk_rumble_disable" },
    { 0xC371F2E7, "claw_weapon" },
    { 0xE2B23A77, "claw_z_arms" },
    { 0x7A1E2D2A, "claw_z_dist" },
    { 0x2FD4BB2F, "claws" },
    { 0xCC1CE153, "claws_destroyed" },
    { 0x76CA0112, "claws_move_through_market" },
    { 0xA3B76430, "claws_stop_firing" },
    { 0xC4F3E7D0, "claws_survived" },
    { 0xBBAA85A0, "claws_toggle_firing" },
    { 0x6BE3D099, "claws_walk_intro_elevator_room_rumble" },
    { 0xF9A6D9A5, "claymore" },
    { 0xC9C0CF28, "claymore_acquired" },
    { 0x4D54B7FF, "claymore_array" },
    { 0xACAE1B65, "claymore_count" },
    { 0x55383564, "claymore_create" },
    { 0x60EE6F4C, "claymore_damagewatch" },
    { 0xC372A10A, "claymore_detectiondot" },
    { 0x0C9F432B, "claymore_detectionmindist" },
    { 0xAF88E4F0, "claymore_detonate" },
    { 0x512BF047, "claymore_detonation" },
    { 0x7C6EB720, "claymore_detonationwatch" },
    { 0x90BD6B6F, "claymore_equipped" },
    { 0x9A6A6552, "claymore_influencer_radius" },
    { 0xCC0E5096, "claymore_influencer_score" },
    { 0x56CF30C2, "claymore_influencer_score_curve" },
    { 0x0A8A7605, "claymore_locs" },
    { 0x9AB644ED, "claymore_max_spawned" },
    { 0xD11754C5, "claymore_on_damage" },
    { 0x53CC4060, "claymore_on_emp" },
    { 0xD98F7D7E, "claymore_on_trigger" },
    { 0xA355E603, "claymore_on_trigger_laser_check" },
    { 0xB6EE2F42, "claymore_org" },
    { 0xD3650535, "claymore_pickup_station" },
    { 0x6026C70C, "claymore_planted" },
    { 0x87FA3D6B, "claymore_safe_to_plant" },
    { 0x04652D18, "claymore_set" },
    { 0x4E75398F, "claymore_setup" },
    { 0x35BF88BB, "claymore_spots" },
    { 0xCD2F0840, "claymore_throw_hint" },
    { 0x4494984E, "claymore_thrown" },
    { 0xDA15C7F6, "claymore_to_notsolid" },
    { 0x89EC130F, "claymore_triggers" },
    { 0x032A8167, "claymore_unitrigger_update_prompt" },
    { 0x5CB7A5EC, "claymore_wait_and_detonate" },
    { 0x1415E589, "claymore_watch" },
    { 0x6E158FAD, "claymore_watch_swipes" },
    { 0x3C572DAC, "claymorearray" },
    { 0x41C47CD3, "claymoreclip" },
    { 0xF8D12D3A, "claymorecount" },
    { 0xC84B4F02, "claymoredebug" },
    { 0xE59B2CF0, "claymoredetectionconeangle" },
    { 0x1C169037, "claymoredetectiondot" },
    { 0x4C786C75, "claymoredetectiongraceperiod" },
    { 0x11A1B942, "claymoredetectionmindist" },
    { 0xD8B0224C, "claymoredetectionradius" },
    { 0xE0207A2A, "claymoredetectiontrigger" },
    { 0xFE2C9DAE, "claymoredetectiontrigger_wait" },
    { 0x8210F5A9, "claymoredetonate" },
    { 0xBAA10313, "claymoredetonateradius" },
    { 0x42125056, "claymoredetonation" },
    { 0x91BD147C, "claymoreforward" },
    { 0xFE156C8C, "claymorefxid" },
    { 0x9ABDEB87, "claymorehackertoolradius" },
    { 0xC5EAAD7A, "claymorehackertooltimems" },
    { 0x75C6EAD3, "claymorelaserfxid" },
    { 0xD385B586, "claymoremodelcenteroffset" },
    { 0x53DAEEB4, "claymores" },
    { 0x35B4AF15, "claymores_max_per_player" },
    { 0x95B2B804, "claymores_on_damage" },
    { 0xDB774838, "claymores_pickedup" },
    { 0xC6ADAFD5, "claymores_planted" },
    { 0x6F33CFBA, "claymores_triggered" },
    { 0x5159C0CE, "claymoretracking" },
    { 0xE59BEBB8, "claytrig" },
    { 0x1CF52D1A, "clck" },
    { 0xC558A4DC, "clean" },
    { 0xF2C5297F, "clean_bedroom_reels" },
    { 0xB4E7904B, "clean_corpse" },
    { 0x2D5C2E92, "clean_deleted" },
    { 0x322FC557, "clean_fire_phy" },
    { 0xFE4469ED, "clean_gren_phy" },
    { 0xEF1F26CC, "clean_heads" },
    { 0xD4830028, "clean_lights" },
    { 0xD64986C4, "clean_macv_client_destructibles" },
    { 0x7AE26B5A, "clean_macv_destructibles" },
    { 0xF8F562A9, "clean_middle_ai" },
    { 0xCCFA5F6B, "clean_preflak_guys" },
    { 0x6563A8C1, "clean_previous_ai" },
    { 0x3C058830, "clean_room_doors" },
    { 0x062BFFA8, "clean_room_ending" },
    { 0xE974D30D, "clean_room_nag" },
    { 0x6E2C1DA0, "clean_room_vo" },
    { 0x359FF883, "clean_under_phy" },
    { 0x4305AF9C, "clean_up" },
    { 0x6AB92CA7, "clean_up_after_cleaning_room" },
    { 0x39A737B2, "clean_up_after_done" },
    { 0x7205B64C, "clean_up_after_drop_into_village_battle" },
    { 0xD78BE6FE, "clean_up_after_drop_into_water" },
    { 0x78624548, "clean_up_after_intro" },
    { 0x22FD617A, "clean_up_after_mg_dropdown" },
    { 0x70E0569E, "clean_up_after_regroup" },
    { 0xD41869E6, "clean_up_after_village_battles" },
    { 0x79310F7D, "clean_up_all_ai" },
    { 0xE7A75F3F, "clean_up_animated_grass" },
    { 0x218EE007, "clean_up_barge_ents" },
    { 0x385147B7, "clean_up_beartrap_test" },
    { 0x8573DF0A, "clean_up_before_cleaning_room" },
    { 0xDCEA19B1, "clean_up_before_done" },
    { 0xE4F38DA8, "clean_up_before_log_scene" },
    { 0xA7A34F17, "clean_up_behind" },
    { 0x2916DFE8, "clean_up_bridge_brutuses" },
    { 0x65D4C579, "clean_up_bunker_chains" },
    { 0x5A9D2DDE, "clean_up_bunker_doors" },
    { 0x08E07F07, "clean_up_charge" },
    { 0xF18759FF, "clean_up_christmas_lights" },
    { 0xF3C4B287, "clean_up_done" },
    { 0xB2608999, "clean_up_doors_and_signs_on_race_end" },
    { 0xF397E8D0, "clean_up_enemies_in_safe_zone" },
    { 0xB6AFF9BA, "clean_up_enemy_ai" },
    { 0x85922C90, "clean_up_ent_array" },
    { 0x292A8B5D, "clean_up_fadeout_hud" },
    { 0x8E8A09C7, "clean_up_fail_valley" },
    { 0x056D6703, "clean_up_final_brutuses" },
    { 0x44A08C0B, "clean_up_friendly_ai_quad" },
    { 0x5015D424, "clean_up_from_mason_lab" },
    { 0x533378B1, "clean_up_gas_attack" },
    { 0xFCB0380C, "clean_up_gas_room" },
    { 0x1C1C8A0A, "clean_up_group2" },
    { 0x8AD579C7, "clean_up_group2_ai" },
    { 0x099C8F31, "clean_up_hacked_box" },
    { 0x9C9DC3A3, "clean_up_in_house" },
    { 0x33D3BE21, "clean_up_left_over_ais" },
    { 0x58000876, "clean_up_left_over_ais_and_vehs" },
    { 0x840667CB, "clean_up_locked_box" },
    { 0xCAB94A7D, "clean_up_mason_bridge" },
    { 0xF9C044F9, "clean_up_mason_catwalk" },
    { 0x580530A6, "clean_up_mason_cctv" },
    { 0x604E61B0, "clean_up_mason_hallway" },
    { 0xF51488EF, "clean_up_mason_interrogation_room" },
    { 0x0DB94DA6, "clean_up_mason_lower_level" },
    { 0x4D6D9DF9, "clean_up_mason_salazar_exit" },
    { 0xE77CEE52, "clean_up_mason_start" },
    { 0xEB11E2B1, "clean_up_mason_wakeup" },
    { 0x21F86C82, "clean_up_motel" },
    { 0x266823D0, "clean_up_my_guys" },
    { 0xE2BE1D41, "clean_up_ragdoll_bucket" },
    { 0xFC63FD59, "clean_up_section_1_vcs" },
    { 0x2B3C134A, "clean_up_section_2_vcs" },
    { 0x84E7C9E7, "clean_up_spawned" },
    { 0xE377AADE, "clean_up_spawnedondeath" },
    { 0x2A58213D, "clean_up_special_round" },
    { 0x5051BC70, "clean_up_spin_models" },
    { 0x1B183862, "clean_up_stink" },
    { 0x1D67335F, "clean_up_stuff_before_hangar" },
    { 0xA5C40DBC, "clean_up_suicide_hud_on_bled_out" },
    { 0x9A3E66FC, "clean_up_suicide_hud_on_end_game" },
    { 0xB7FEE8BE, "clean_up_super_kill_blood" },
    { 0xF1622F45, "clean_up_tidy_up" },
    { 0xD367E38A, "clean_up_time_bomb_notifications" },
    { 0xA61642FF, "clean_up_tower_defense_section" },
    { 0x0CC6E846, "clean_up_unused_attack_points" },
    { 0xDA5428A7, "clean_up_vehicle_at_air_to_air" },
    { 0xB1FF5286, "clean_up_village_guards" },
    { 0xBD1E6D4F, "clean_wins_index" },
    { 0xCD5946B2, "cleandenies" },
    { 0x780525DA, "cleandeposithubs" },
    { 0x38A0342F, "cleandepositpoints" },
    { 0xA4390B09, "cleandeposits" },
    { 0x1ABE96BF, "cleaned" },
    { 0xBC2D0874, "cleaned_up_balcony" },
    { 0x96D75ED9, "cleaner" },
    { 0x86B69244, "cleanest" },
    { 0x9D326BDD, "cleanheadonkill" },
    { 0xD6982C2C, "cleaning" },
    { 0xC426822C, "cleaning_up" },
    { 0xDC4EA548, "cleaning_up_beat_2" },
    { 0xBECB9DBB, "cleaning_up_death" },
    { 0x9119E1D9, "cleanly" },
    { 0x58BA9C1F, "cleans" },
    { 0x2FAEBEC8, "cleanse_material" },
    { 0x64F2E724, "cleansed" },
    { 0x072B52E3, "cleansed_alive_check" },
    { 0xA01FA89B, "cleansed_game_started" },
    { 0x85C1B05D, "cleansed_kills_for_drops" },
    { 0x34CEE228, "cleansed_leader" },
    { 0x9AF7DBCD, "cleansed_loadout" },
    { 0x29380B59, "cleansed_player_laststand" },
    { 0x44ED99D0, "cleansed_powerup_history" },
    { 0x982F0F66, "cleansed_powerup_history_depth" },
    { 0x35AF4353, "cleansed_powerup_history_last" },
    { 0xC8FB8FB4, "cleansed_powerups" },
    { 0x28E081F3, "cleansed_set_leader" },
    { 0x62371AC4, "cleansed_zombie_round" },
    { 0x4AF378EC, "cleanseddamagechecks" },
    { 0x695A0B08, "cleansedonendgame" },
    { 0x90D0BC45, "cleansedontimelimit" },
    { 0x32E49D5B, "cleanup" },
    { 0x977DDFEE, "cleanup_aa_guns_area" },
    { 0x4E7D28D7, "cleanup_actor_anim_flags" },
    { 0x2E236884, "cleanup_after_landing" },
    { 0xAA1E479C, "cleanup_after_time" },
    { 0x6345B68F, "cleanup_afterzipline" },
    { 0xCA7FECC0, "cleanup_ai" },
    { 0x0C0FCEFC, "cleanup_ai_based_on_progression" },
    { 0xC977C364, "cleanup_ai_bp2wave2" },
    { 0x24FBB8F1, "cleanup_ai_claws" },
    { 0x4078B769, "cleanup_ai_on_level_notify" },
    { 0x6E05356C, "cleanup_ambient_drones" },
    { 0x212369D3, "cleanup_ambient_hips" },
    { 0x19F98452, "cleanup_ammo_obj" },
    { 0xA60E045F, "cleanup_arena" },
    { 0x503B1739, "cleanup_arena_horse" },
    { 0x44D9B769, "cleanup_array" },
    { 0x30D93B44, "cleanup_base_after_zipline" },
    { 0xA0D187B2, "cleanup_base_icons" },
    { 0x5247EF10, "cleanup_base_on_roof" },
    { 0xA261D5DF, "cleanup_beartrap_script_model" },
    { 0x3D13CCB1, "cleanup_before_alley" },
    { 0x4DF7931C, "cleanup_boat_drop" },
    { 0x1B851ADD, "cleanup_bombs" },
    { 0xF4E84949, "cleanup_bp1wave3" },
    { 0x725801B5, "cleanup_bp_ai" },
    { 0x27656596, "cleanup_bridge_ai" },
    { 0x7EE55468, "cleanup_bridge_sm" },
    { 0x81E8932E, "cleanup_btr_spawners" },
    { 0xAA3698A2, "cleanup_btr_triggers" },
    { 0x9B13F686, "cleanup_btr_vehicles" },
    { 0x71D73D90, "cleanup_cache" },
    { 0x1F572F27, "cleanup_checkin" },
    { 0x295F8CFA, "cleanup_claws" },
    { 0x6FAD0CE3, "cleanup_color_plaza_right_2_inside" },
    { 0x26ACEBE0, "cleanup_color_plaza_right_2_outside" },
    { 0x31701245, "cleanup_corpses" },
    { 0xBD9A062B, "cleanup_damage_hud" },
    { 0x5754AB8B, "cleanup_debug_print" },
    { 0xE7C8DC75, "cleanup_debug_print_clearmsg_t" },
    { 0x47D6CAA6, "cleanup_debug_print_t" },
    { 0x9F768C21, "cleanup_deck" },
    { 0x6A69F9CE, "cleanup_deck_allies" },
    { 0x424E2646, "cleanup_destructable_trees" },
    { 0x813AAAFB, "cleanup_di_right_guys" },
    { 0x1F6B9357, "cleanup_dial_anims" },
    { 0x54E248DF, "cleanup_drones" },
    { 0xBA2883C9, "cleanup_dvar_name" },
    { 0x6591C1C8, "cleanup_e1_origins" },
    { 0x5394E60B, "cleanup_e4b_bunker" },
    { 0x9522F139, "cleanup_early_tanks" },
    { 0xB2FFB466, "cleanup_end_game" },
    { 0x3D5D01FD, "cleanup_ent" },
    { 0x44D9A5BC, "cleanup_ents" },
    { 0x00D7ECAE, "cleanup_ents_for_defalco_escape_animation" },
    { 0x84E5EF54, "cleanup_exit_hallway_guys" },
    { 0x811AC1F2, "cleanup_fake_motorcade" },
    { 0x53581F68, "cleanup_fakeplayer_setup" },
    { 0xB7E441E4, "cleanup_fight" },
    { 0x9522EE35, "cleanup_final_push" },
    { 0x223EF4AC, "cleanup_first_area" },
    { 0x83CCAB45, "cleanup_first_bridge_ai" },
    { 0x911025CC, "cleanup_first_half" },
    { 0x12BB2630, "cleanup_floor_effect" },
    { 0x390E8F3B, "cleanup_flying_section" },
    { 0x3E3AAF20, "cleanup_follow_salazar_objective" },
    { 0x14A64AE9, "cleanup_for_deck" },
    { 0x6CE620C0, "cleanup_for_walkin" },
    { 0x92464303, "cleanup_forcecolor_redshirts" },
    { 0xCB919EF6, "cleanup_forcecolor_redshirts_done" },
    { 0x202DCFC9, "cleanup_freezegun_triggers" },
    { 0x633E2AFD, "cleanup_frogger_guys" },
    { 0x091C2C04, "cleanup_front_ai" },
    { 0x70C01976, "cleanup_front_door" },
    { 0x693D931C, "cleanup_ft_tut_hud" },
    { 0x41763F9C, "cleanup_func" },
    { 0x3C9F6315, "cleanup_fx_ents" },
    { 0x3A0D0ED5, "cleanup_fx_on_shutdown" },
    { 0x61196362, "cleanup_fxanims" },
    { 0xD0021288, "cleanup_grenade" },
    { 0xAB4A98FF, "cleanup_ground_emitters" },
    { 0xB1F6AE72, "cleanup_gun_pings" },
    { 0x848DF2D6, "cleanup_guys" },
    { 0x05E9E844, "cleanup_hackable_objects" },
    { 0xB0FEB25E, "cleanup_halls" },
    { 0xB0105934, "cleanup_hallway" },
    { 0xB6F3A129, "cleanup_helicopter_bridge_area" },
    { 0xB55F70BF, "cleanup_hill" },
    { 0x4AB97474, "cleanup_hill_ai" },
    { 0x1F079626, "cleanup_hip_dropoff" },
    { 0x89376114, "cleanup_initial_mgnest_through_digbat_parking_lot" },
    { 0xBCAE1014, "cleanup_intro" },
    { 0x46B60AFF, "cleanup_intro_defend" },
    { 0x4D3FE9E9, "cleanup_intro_part1" },
    { 0xC3149187, "cleanup_killcam_entity" },
    { 0xC85CBFBF, "cleanup_kvp" },
    { 0xD4EB424F, "cleanup_laststand_on_disconnect" },
    { 0x6690CFC4, "cleanup_law_obj" },
    { 0x33429882, "cleanup_light" },
    { 0xA3D8EC34, "cleanup_loop_sound" },
    { 0x883610AC, "cleanup_macv_ents" },
    { 0x94A71AA1, "cleanup_main" },
    { 0xD4C53398, "cleanup_marker" },
    { 0xB8D4120E, "cleanup_market" },
    { 0x8EF0FF87, "cleanup_meat" },
    { 0xB7E23DF6, "cleanup_meteor" },
    { 0xADFE5353, "cleanup_meteor_fx" },
    { 0x981FE68C, "cleanup_missile_launcher_event" },
    { 0xE20602E5, "cleanup_monkey" },
    { 0x2BA9380A, "cleanup_mortar_models" },
    { 0x7A4BBEC9, "cleanup_mortor_vehicles" },
    { 0x93E32A76, "cleanup_nicaragua_menendez_hill_notify" },
    { 0x8870ACDF, "cleanup_numbers_audio" },
    { 0xD0172B3F, "cleanup_nva" },
    { 0x0C4FCF06, "cleanup_objectives" },
    { 0x5BC4D085, "cleanup_on_restart" },
    { 0x6DA1CC07, "cleanup_onroof" },
    { 0xF11BED0F, "cleanup_path_blockers" },
    { 0xD7D84476, "cleanup_pathchoice" },
    { 0xE65BD9C6, "cleanup_player_committed_left" },
    { 0x78D5A17E, "cleanup_player_hands" },
    { 0xAF942DCD, "cleanup_populate_with_vehicles" },
    { 0x95D8B59C, "cleanup_post_heli_fight" },
    { 0xE16CCF39, "cleanup_progression_passed_digbat_parking_lot" },
    { 0x4FCC0052, "cleanup_rail" },
    { 0x0CBCBEC9, "cleanup_random_weapon_list" },
    { 0xC16823D3, "cleanup_red_guns" },
    { 0x4CCEE498, "cleanup_ride" },
    { 0x1EE7E94F, "cleanup_ride_vignette_by_goal" },
    { 0xB64C30F0, "cleanup_ride_vignettes" },
    { 0x1A7C563D, "cleanup_river_intro_barge" },
    { 0xFC3E5AF7, "cleanup_river_intro_boats" },
    { 0x34AEEAEF, "cleanup_river_lance_trash" },
    { 0x280D2271, "cleanup_riverbed" },
    { 0x1A5BC1A8, "cleanup_riverbed_fail_triggers" },
    { 0x4FCCB3DF, "cleanup_riverbed_scenes" },
    { 0x5F550F45, "cleanup_rocket_pods" },
    { 0x0F301520, "cleanup_rocket_takedown" },
    { 0x9576E98C, "cleanup_sampan_area" },
    { 0xC2DB2590, "cleanup_satchel_axis" },
    { 0x848855D7, "cleanup_savannah_start" },
    { 0x6D04F287, "cleanup_scanning" },
    { 0x180397FC, "cleanup_seals" },
    { 0x3EB8D8DF, "cleanup_server_room" },
    { 0x7F1AFCC8, "cleanup_slums_ai_by_targetname" },
    { 0xD729C91D, "cleanup_slums_think" },
    { 0x658CB8FC, "cleanup_sm_afterzipline" },
    { 0x49ADC3A9, "cleanup_spawners" },
    { 0x80FE3AF3, "cleanup_street" },
    { 0x29789AA4, "cleanup_street_ents" },
    { 0x8C979904, "cleanup_structs" },
    { 0x4A66F284, "cleanup_suicide_hud" },
    { 0x435CCAF0, "cleanup_tank_debris" },
    { 0x1E2FCA8F, "cleanup_tank_mines" },
    { 0xEF892BFF, "cleanup_targeting" },
    { 0xD2EECA99, "cleanup_tarp" },
    { 0x60A0E9C1, "cleanup_theater" },
    { 0x1025F389, "cleanup_time" },
    { 0xA92B29CB, "cleanup_town_ai" },
    { 0xB6F5044C, "cleanup_trig" },
    { 0x7B49E4F6, "cleanup_trigger" },
    { 0x6AC8FD5B, "cleanup_trigger_disable" },
    { 0xF1ECE8C0, "cleanup_trigger_enable" },
    { 0x443B66E9, "cleanup_triggers" },
    { 0x645AB226, "cleanup_trucks_on_bp3" },
    { 0x741489D7, "cleanup_underwater_dynents" },
    { 0xA8EBCCE0, "cleanup_unoccupied_floor" },
    { 0x2C36A1EA, "cleanup_vehicle" },
    { 0x84450169, "cleanup_vehicles_afterzipline" },
    { 0x52D6DF20, "cleanup_vignette" },
    { 0xF2439D89, "cleanup_warp_around_parking_lot" },
    { 0xFB02B656, "cleanup_watcher" },
    { 0xED89C9A8, "cleanup_wave_one" },
    { 0xFAB2F274, "cleanup_wave_one_shooters" },
    { 0xF44797F7, "cleanup_weap_obj" },
    { 0x09D2FDDF, "cleanup_weapon_models" },
    { 0x2AD3D30E, "cleanup_when_in_comms" },
    { 0x8718267F, "cleanup_yard_ai" },
    { 0x7EF4C167, "cleanup_zombie_monkey_sounds" },
    { 0xAF58439D, "cleanupaftermissiledeath" },
    { 0xB6223032, "cleanupchangestancetocrouch" },
    { 0x5CB49B20, "cleanupchangestancetostand" },
    { 0x19D33ED1, "cleanupchargemelee" },
    { 0xFB550F89, "cleanupchargemeleeattack" },
    { 0xDD5AE055, "cleanupcovermode" },
    { 0xE7029056, "cleanupenabled" },
    { 0x929A26F9, "cleanupequipment" },
    { 0x173B25BE, "cleanupfadeouthud" },
    { 0x8E89441D, "cleanupfx" },
    { 0xFC55E212, "cleanupkillcamentondeath" },
    { 0xDFA4139D, "cleanupmelee" },
    { 0xBE46614D, "cleanupoldheadchopper" },
    { 0xCC3801B8, "cleanupoldspringpad" },
    { 0xCEB02214, "cleanupoldsubwoofer" },
    { 0xD3CDE0A3, "cleanupoldtrap" },
    { 0xD96EE91B, "cleanupoldturbine" },
    { 0x443DCB5C, "cleanupoldturret" },
    { 0x7BA05992, "cleanupondeath" },
    { 0x196DA010, "cleanupproximitychainent" },
    { 0x76E86966, "cleanuprevivingteamate" },
    { 0xDDC2C972, "cleanupscramblerondelete" },
    { 0xF7640406, "cleanupspawneddynents" },
    { 0x22D4AD55, "cleanupteammateneedsrevivelist" },
    { 0xF91732D7, "cleanupthread" },
    { 0x2F7A18F3, "cleanupthrustersthread" },
    { 0x27DEC4C1, "cleanupthrustersthread_singleton" },
    { 0x7993C3F0, "cleanuptime" },
    { 0x8F1925FA, "cleanuptimemax" },
    { 0x51B51AE4, "cleanuptimemin" },
    { 0x1C02C3F9, "cleanupwaiter" },
    { 0xD4412064, "cleanupwatcherondeath" },
    { 0x3F1CA510, "cleanupwatchers" },
    { 0x521928C4, "cleanweaponobjectarray" },
    { 0x9D134160, "clear" },
    { 0x59CE3E06, "clear_after_ambushers_killed" },
    { 0xC5EE1C20, "clear_after_trigger_hit" },
    { 0x6E5848B9, "clear_ai_back_in_city" },
    { 0x37919788, "clear_ai_slop" },
    { 0x56B468ED, "clear_all_active_zombies" },
    { 0x21794682, "clear_all_corpses" },
    { 0x12E01F4C, "clear_all_guards_on_medium_boat" },
    { 0xD27D5D22, "clear_all_pickups" },
    { 0x686C882E, "clear_all_vehicles_but_heros" },
    { 0xDE775DE8, "clear_all_vehicles_but_heros_and_hind" },
    { 0x657A74C5, "clear_all_waypoints" },
    { 0x741D1015, "clear_all_zombie_attack_points_in_zone" },
    { 0x9F53CEB6, "clear_allowed_gameobjects" },
    { 0xBF8D6A7F, "clear_alt_weapon_message" },
    { 0x14462F4D, "clear_ambush_fields" },
    { 0xE7041ED8, "clear_anim" },
    { 0x2BC76AF2, "clear_anims_on_death" },
    { 0xDFD8A24D, "clear_another_player_discover_thread" },
    { 0x847C2BC4, "clear_area" },
    { 0xA6149F50, "clear_arena" },
    { 0x29AC50EC, "clear_background_civilians" },
    { 0x69DB2D50, "clear_barnes" },
    { 0x77463A31, "clear_barnes_ignore" },
    { 0xC61D0338, "clear_battlechatter_flags" },
    { 0x44D064D3, "clear_behind" },
    { 0x53013057, "clear_blocked_enemy_cache" },
    { 0x970F6255, "clear_blocking_point_objective" },
    { 0x9DFBC70A, "clear_bonus_ent" },
    { 0xF2D0CAAE, "clear_breach_gun_raised" },
    { 0x35D6971B, "clear_buildable_clientfield" },
    { 0xC94BC3A0, "clear_bunker_1st_room_enemies" },
    { 0x98EA02EE, "clear_c4" },
    { 0x14D7358D, "clear_carrier" },
    { 0xC37E229A, "clear_category_on_action_success" },
    { 0xE7E33B23, "clear_central_ai" },
    { 0x0062411C, "clear_clearzone" },
    { 0xDDFD9546, "clear_client_flags" },
    { 0xB1369E10, "clear_course" },
    { 0x1A47EE2B, "clear_cqb_run_anim" },
    { 0xC8D231B3, "clear_custom_approach_fields" },
    { 0x4D9B8F48, "clear_damage" },
    { 0xA48D4C4E, "clear_darkness_target" },
    { 0x0F64A8E0, "clear_deathanim" },
    { 0x68196AFA, "clear_dof" },
    { 0x10321372, "clear_domination_info" },
    { 0x4DC93362, "clear_dr_flag" },
    { 0xD31B4880, "clear_dvar" },
    { 0xE10B303E, "clear_e1_ai" },
    { 0x2983FE64, "clear_earlier_objectives" },
    { 0xCCD3B546, "clear_entities" },
    { 0xE96FB869, "clear_entity_selection" },
    { 0xAF4214AA, "clear_escape" },
    { 0x786D0921, "clear_escrows" },
    { 0x89A07C10, "clear_event3_flags" },
    { 0xD01F291B, "clear_event_on_prob" },
    { 0x259AA2D4, "clear_event_printname" },
    { 0xD9246B0A, "clear_exception" },
    { 0x6801A63F, "clear_exclusive_area" },
    { 0xFE21D375, "clear_exit_victims_spawn_funcs" },
    { 0xB85E47F9, "clear_fail_by_hut_patroller" },
    { 0x68EC327B, "clear_final_killcam_team" },
    { 0x60B02300, "clear_flag_on_death" },
    { 0x598FDDFE, "clear_flag_when_player_leaves_trigger" },
    { 0x8819C837, "clear_flightstick_animations" },
    { 0x8DA79053, "clear_fog_threads" },
    { 0xCD18C609, "clear_for_takeoff" },
    { 0xA5A725E4, "clear_force_color" },
    { 0xCF868018, "clear_forced_target" },
    { 0x24A146CF, "clear_from_boss_array_when_dead" },
    { 0xA80EEFB6, "clear_from_special_ai_array_when_dead" },
    { 0x3351EB51, "clear_fx" },
    { 0xB0F543DC, "clear_fx_hudelements" },
    { 0x26837E34, "clear_fx_on_death" },
    { 0x4F3BE0EC, "clear_glow" },
    { 0xBB63E9A8, "clear_guy" },
    { 0x1D829275, "clear_guys_near_etank1" },
    { 0x45BC6290, "clear_heat_wave_fx" },
    { 0x8C67DFE0, "clear_heavy_resistance" },
    { 0x10D3A828, "clear_helicopter" },
    { 0x35DAB85B, "clear_hints" },
    { 0x3A72FE52, "clear_hints_on_flag" },
    { 0x7DA71971, "clear_hints_on_mission_fail" },
    { 0x096C35B4, "clear_hints_on_stand" },
    { 0x4FE82CA3, "clear_horse_objective_on_bp3_event" },
    { 0x4CB535C5, "clear_horse_objective_on_end_of_event" },
    { 0xD9E65F05, "clear_horse_objective_on_enter" },
    { 0xB118D90A, "clear_hud" },
    { 0x8162B26B, "clear_hud_elems" },
    { 0x849B1BB5, "clear_ignore_all" },
    { 0xD1A39FF1, "clear_ignore_ent_array" },
    { 0x130C87C3, "clear_ignore_on_goal" },
    { 0x19E130F0, "clear_ignoreall_when_notified" },
    { 0x9947CB9C, "clear_ignoreme_after_delay" },
    { 0x5CE56002, "clear_interrupt_threads" },
    { 0x374B6290, "clear_is_drinking" },
    { 0x1C5D6C69, "clear_lander" },
    { 0x5D33D3F5, "clear_lane" },
    { 0x2DC4791A, "clear_left_building_guys" },
    { 0xC3834ADF, "clear_lighting_entities" },
    { 0x22A97A10, "clear_lighting_for_cod" },
    { 0xB391352E, "clear_lighting_pair" },
    { 0x525A420A, "clear_lockon_after_grapple" },
    { 0x716DBE5E, "clear_mature_blood" },
    { 0xB91D59C1, "clear_mdl_prv" },
    { 0x3C959725, "clear_mines" },
    { 0xE4A34C6F, "clear_model_names" },
    { 0x8AE0EACC, "clear_my_switchnode" },
    { 0x04230AB0, "clear_nml_rounds" },
    { 0x26CAF36E, "clear_node_on_death" },
    { 0xF9DE7A91, "clear_objective_model_on_death" },
    { 0x2096E08B, "clear_objective_squad" },
    { 0xA1B45BA2, "clear_old_breadcrumb" },
    { 0xB387D239, "clear_on_action_success" },
    { 0x1B8543C6, "clear_on_snipers_death" },
    { 0x8E6CDA20, "clear_on_victim_disconnect" },
    { 0x8614FCA8, "clear_one_off_fx" },
    { 0x03BF7624, "clear_owner" },
    { 0x346C3C5A, "clear_path_speed" },
    { 0xEAAA08E3, "clear_path_timers" },
    { 0xB7E449B2, "clear_player_attacked_by_dog_on_death" },
    { 0x9D221DDB, "clear_player_crystal" },
    { 0xD462EFB5, "clear_player_spawnpoints" },
    { 0xABD72DF3, "clear_player_staff" },
    { 0xFCA8537D, "clear_player_staff_by_player_number" },
    { 0x86D0E45C, "clear_player_threatbias_vs_apartment_enemies" },
    { 0xA989C896, "clear_poison_overlay" },
    { 0x903348B0, "clear_powerups" },
    { 0x2216566C, "clear_previews" },
    { 0x7D52C6BA, "clear_progress" },
    { 0x600AD865, "clear_progress_info" },
    { 0x1989C17B, "clear_promotion_order" },
    { 0xCB2F9DB7, "clear_rappel" },
    { 0xBE9BBC7D, "clear_rate" },
    { 0x0AE0ED14, "clear_red_flashing_overlay" },
    { 0xA924CC9E, "clear_ride_intro" },
    { 0x5CC8A116, "clear_room" },
    { 0x1EF37727, "clear_room_trig" },
    { 0x039C734A, "clear_run_anim" },
    { 0xEB8B5BEE, "clear_scene_skipping_ui" },
    { 0x9F83AD8A, "clear_screen_messages" },
    { 0x6D5C342D, "clear_section1" },
    { 0xD5524A89, "clear_section5" },
    { 0x8EAEB26A, "clear_section_generic" },
    { 0x69F5C8D8, "clear_settable_fx" },
    { 0x3F0FFD5A, "clear_slots" },
    { 0xF80D0616, "clear_slum_southeast_ai" },
    { 0x8BE5521C, "clear_sm_then_flag" },
    { 0x311D8EDA, "clear_spawn_points" },
    { 0x41D0CD52, "clear_squadcommand" },
    { 0x0DB246DA, "clear_static_flee_civs" },
    { 0x44EB5474, "clear_stink_ent" },
    { 0x6A6267D9, "clear_stored_weapondata" },
    { 0x092F6E96, "clear_stowed_weapon" },
    { 0xA0938376, "clear_streamer_hint" },
    { 0xD34612A5, "clear_street_lapd_car_explode" },
    { 0x36569909, "clear_stuck" },
    { 0x5960AF7C, "clear_tank_attack_point_on_death" },
    { 0x6B242F10, "clear_target" },
    { 0x6E68F6DC, "clear_target_ent_array" },
    { 0xAC948C81, "clear_target_radius" },
    { 0xEE989B2F, "clear_tesla_tube_effect" },
    { 0xD30087DE, "clear_the_street" },
    { 0xDC473BDB, "clear_threat" },
    { 0x77C0A2F5, "clear_threat_aim" },
    { 0x75117408, "clear_threatbias" },
    { 0xC21A920E, "clear_timer" },
    { 0xEA9C0FE7, "clear_timer_elems" },
    { 0x05D0500E, "clear_to_engage" },
    { 0x92698851, "clear_trigger" },
    { 0xB84F4A25, "clear_turn_anims" },
    { 0x130055EE, "clear_turret_ignore_ent_array" },
    { 0x735BFD2B, "clear_turret_target" },
    { 0xDA4A94C7, "clear_turret_target_ent_array" },
    { 0xF0168B54, "clear_universal_buttons" },
    { 0x55F23A5E, "clear_unload" },
    { 0xED3403A2, "clear_using_remote" },
    { 0x3BF11700, "clear_vel" },
    { 0x7EAC266B, "clear_weapon" },
    { 0xCDA092C8, "clear_zombie_stink_fx" },
    { 0x4605EEFB, "clear_zombies_in_packroom" },
    { 0xCA7C25AD, "clear_zone" },
    { 0xAA9B95E0, "clear_zone_objective_index" },
    { 0x99AEE1EF, "clearaioverridedamagecallbacks" },
    { 0xDB79F6A9, "clearall" },
    { 0x44B694DD, "clearallcooldowns" },
    { 0xC8ECD848, "clearallcorpses" },
    { 0x65DCE259, "clearallfacialanims" },
    { 0x59ED3045, "clearallfirst" },
    { 0xA5DF6C0C, "clearalllookingandtargeting" },
    { 0xEDA2D09E, "clearallmovement" },
    { 0x94B1213D, "clearallpreferedpoints" },
    { 0xBC94B7C0, "clearalltextafterhudelem" },
    { 0x16FF8143, "clearalternateaimparams" },
    { 0xC67A97B1, "clearance" },
    { 0xC3D84BCA, "clearandcacheperks" },
    { 0x3CBACD1F, "clearanim" },
    { 0x256B357F, "clearanimcache" },
    { 0x1A16EEBF, "clearanimlimited" },
    { 0x4DA93304, "clearaptarget" },
    { 0x9195292B, "cleararrivalpos" },
    { 0xCD277A47, "clearbunker" },
    { 0x844108B4, "clearcarrier" },
    { 0x44FFE93A, "clearcenterpopups" },
    { 0x8A6B89A3, "clearclientflag" },
    { 0x8019274D, "clearclutarget" },
    { 0xB1D7B4E3, "clearcooldown" },
    { 0x3C00420D, "clearcovershootstarttime" },
    { 0x505D0177, "clearctfaway" },
    { 0x4C238030, "clearcurrentfacialanim" },
    { 0xE227A9F6, "cleardamageindicator" },
    { 0x1D0977F3, "cleared" },
    { 0x14B6D923, "cleared_count" },
    { 0xC2AFB86C, "cleared_killstreak_delay" },
    { 0x8FCA33CC, "cleared_zone" },
    { 0xD0599BC5, "clearendgame" },
    { 0xC15140D4, "clearenemy" },
    { 0x13370A3B, "clearenemy_loc" },
    { 0x38898859, "clearenemycount" },
    { 0x7DBA8BDA, "clearentityowner" },
    { 0xDEC5BE9A, "clearentitytarget" },
    { 0xCC17E3E8, "clearescrows" },
    { 0x9DE0788F, "clearextracam" },
    { 0x93D8CDA0, "clearfaceanimonanimdone" },
    { 0x56683E87, "clearfaceanims" },
    { 0x79016222, "clearfinalkillcamteam" },
    { 0x2D56B327, "clearfixednodesafevolume" },
    { 0xE11CE512, "clearforcedgoal" },
    { 0x7FE86DA1, "clearfxondeath" },
    { 0xFB5720F7, "cleargoalvolume" },
    { 0xF49E34EA, "cleargoalyaw" },
    { 0xD7891149, "cleargroundflameent" },
    { 0xBB5F9FAA, "cleargunnertarget" },
    { 0xBC47BC11, "clearguy" },
    { 0x8B4E7E89, "clearhackertarget" },
    { 0xE33C758A, "clearidshortly" },
    { 0x74644AF8, "clearing" },
    { 0x86C9E1DF, "clearing_anim_fuel" },
    { 0xC1966565, "clearing_anim_inventory" },
    { 0xAC013399, "clearing_anim_loop" },
    { 0x12BE82AB, "clearing_anim_pilot" },
    { 0xA2165A64, "clearing_anim_radio" },
    { 0x3FB23733, "clearing_anim_single" },
    { 0x3FF1FD5D, "clearing_anim_spetz" },
    { 0x8560A0A8, "clearing_anim_tent" },
    { 0xFDAFE1D0, "clearing_anim_truck" },
    { 0xB81AB0D7, "clearing_animation" },
    { 0xDD5478D2, "clearing_banzai_hint" },
    { 0x2CFBC959, "clearing_cleanup" },
    { 0x4297AAA9, "clearing_dialog_hack" },
    { 0x63F0842D, "clearing_dog_hint" },
    { 0x159F512A, "clearing_expid_" },
    { 0x28E3BE93, "clearing_hints" },
    { 0x2610FED7, "clearing_notified" },
    { 0x430CD9EC, "clearing_pacifist" },
    { 0x91040B79, "clearing_player_grenaded" },
    { 0x02402AC0, "clearing_player_shooting" },
    { 0x923798B8, "clearing_powerups" },
    { 0x6FB86050, "clearing_tent" },
    { 0x3FB10948, "clearing_truck" },
    { 0x8EEA0D0E, "clearing_watch_my_radius" },
    { 0xC8FC3A28, "clearingfog_settings" },
    { 0x2FAE78EE, "clearinvaliddronetarget" },
    { 0xE63C5C9A, "clearirtarget" },
    { 0xBB6C1CFE, "clearisspeaking" },
    { 0xD0370F01, "clearlasttankattacker" },
    { 0xFE4C3399, "clearlockontarget" },
    { 0x63B5F862, "clearlookat" },
    { 0x8D87B0F9, "clearlookatent" },
    { 0x17F112D9, "clearlookatent_delay" },
    { 0xD848704C, "clearlowermessage" },
    { 0xA301A2A5, "clearly" },
    { 0x333EABAB, "clearmaterialoverride" },
    { 0x54F4A4C6, "clearmonitoredspeed" },
    { 0x2A71BA35, "clearmovehistory" },
    { 0xA9D1C687, "clearnearestenemyscrambler" },
    { 0x4AF868E0, "clearnewstatus" },
    { 0xC98E5A02, "clearning" },
    { 0x08190969, "clearoncompletion" },
    { 0x06B3DFA5, "clearonvictimdisconnect" },
    { 0x650157C5, "clearpath" },
    { 0x623DBA64, "clearpathfromscript" },
    { 0xF7A2618F, "clearperks" },
    { 0xBFC44526, "clearperksondeath" },
    { 0x4036C793, "clearphysicsgravity" },
    { 0x0EF6A6E9, "clearpitchorient" },
    { 0x33314FDE, "clearplayercorpses" },
    { 0x6C7B39AF, "clearplayergravity" },
    { 0x97B23BDE, "clearplayerlockfromqrdronelaunch" },
    { 0x1F5E76E7, "clearplayerobjpoints" },
    { 0x98A47CAF, "clearplayerstouchingflag" },
    { 0x557F9669, "clearpopups" },
    { 0x57A25F27, "clearpowerups" },
    { 0x6CBC2F85, "clearpowerupsongameend" },
    { 0xE4F394F5, "clearpreferedpoint" },
    { 0x102F0BEC, "clearpreferedpointsoutsidegoal" },
    { 0x86ABDDD9, "clearprogress" },
    { 0x9C2F0422, "clearremote" },
    { 0x34D1619D, "clearreturnflaghudelems" },
    { 0xB7EB16DC, "clearrideintro" },
    { 0x0AF2519A, "clearruntopos" },
    { 0x37CE4D0B, "clears" },
    { 0x0A7F212B, "clearscriptenemy" },
    { 0xA21C9CA4, "clearscriptgoal" },
    { 0xB17B90B9, "clearshoutcasterwaitingmessage" },
    { 0xE1238025, "clearsightposnear" },
    { 0x06BC0D94, "clearspawnpoints" },
    { 0xF298D1CB, "clearsteptriggersound" },
    { 0xAC9294D8, "clearstowedweapon" },
    { 0x54EBD83D, "clearsuppressionattack" },
    { 0xB038925A, "cleartargetent" },
    { 0x12613B3A, "cleartargetentity" },
    { 0x28BBFF14, "cleartargetyaw" },
    { 0xD6D525EF, "cleartextmarker" },
    { 0xDC1DD31F, "clearthreatbias" },
    { 0x8490A224, "clearthreatdetectorondelete" },
    { 0xF3A01A2C, "cleartopscorers" },
    { 0x62B52961, "clearturrettarget" },
    { 0xCB75B197, "clearturretyaw" },
    { 0x7EF4ED48, "clearup_garage_rts_guys" },
    { 0x5F2CA8AE, "clearup_safehouse_rts_guys" },
    { 0x3D27B3F8, "clearuplocationselection" },
    { 0xFE068E56, "clearupondisconnect" },
    { 0xA3A66630, "clearuseposition" },
    { 0x62FAEDA6, "clearusingremote" },
    { 0xADA64136, "clearvehgoalpos" },
    { 0x66D2AFF1, "clearviewlockent" },
    { 0x781B02B2, "clearzone" },
    { 0x7E15C4DD, "cleaup" },
    { 0xD60A8164, "clerk" },
    { 0x8E3D7625, "clerk_camera_pos" },
    { 0xF090BCA3, "click" },
    { 0x44E5FBB1, "click_array" },
    { 0x9BB0E756, "click_done" },
    { 0xDD031592, "clicks" },
    { 0xC5FE7427, "clickwaittime" },
    { 0xFA27B120, "client" },
    { 0xB256A939, "client1" },
    { 0xD85923A2, "client2" },
    { 0x356556A5, "client_action_vox_on" },
    { 0xB6D238CD, "client_data_stream_toggle" },
    { 0x4289512D, "client_difficultybonus" },
    { 0x8E78A759, "client_diorama_fx" },
    { 0x305A389F, "client_diorama_fx_3" },
    { 0x400C507C, "client_effect_on_id" },
    { 0xB0E2ABBE, "client_enable_ear_blood" },
    { 0x03BD75FA, "client_extracam_tv_bl" },
    { 0x7FD63E14, "client_extracam_tv_br" },
    { 0x939C5AC6, "client_extracam_tv_init" },
    { 0xE8E320E4, "client_extracam_tv_single" },
    { 0xCCD94F3B, "client_extracam_tv_ul" },
    { 0xA919BDE5, "client_extracam_tv_ur" },
    { 0xFF3F4456, "client_face_bleed_flag" },
    { 0xACA536E6, "client_fade_in1_time" },
    { 0x685F67EF, "client_fade_in2_time" },
    { 0xC3C45B7F, "client_fade_out1_time" },
    { 0xE675A7B6, "client_fade_out2_time" },
    { 0xEDD08B90, "client_field_ctf_carrier" },
    { 0x55BD74D7, "client_field_flag_gps_jammer_active" },
    { 0x6C01F92F, "client_field_flag_sg_jammer_active" },
    { 0xC05B32E7, "client_field_id" },
    { 0xB1EF9CD4, "client_field_key_index" },
    { 0xA81A352C, "client_field_keys" },
    { 0xB0D51391, "client_field_killstreak_hides_compass" },
    { 0x5BE48D38, "client_field_killstreak_spawn_protection" },
    { 0x739454D9, "client_field_name" },
    { 0xC0EFC48D, "client_field_operating_chopper_gunner" },
    { 0x6CA62025, "client_field_operating_predator" },
    { 0x451ED355, "client_field_operating_reaper" },
    { 0x91D6D704, "client_field_remote_killstreak_static" },
    { 0xDCC30F2F, "client_field_state" },
    { 0x33246A9D, "client_field_val" },
    { 0x914BF4E3, "client_field_value" },
    { 0x08E0716C, "client_fields" },
    { 0x0366DDBD, "client_flag" },
    { 0xE5629397, "client_flag_ai_charring" },
    { 0x9BFD430D, "client_flag_ally_extra_cam" },
    { 0x9BDA9322, "client_flag_ally_extra_cam_squad0" },
    { 0xC1DD0D8B, "client_flag_ally_extra_cam_squad1" },
    { 0x4FD59E50, "client_flag_ally_extra_cam_squad2" },
    { 0x75D818B9, "client_flag_ally_extra_cam_squad3" },
    { 0xCBED2E89, "client_flag_ally_switch" },
    { 0x2605A3B1, "client_flag_blood_pool" },
    { 0x77266E7F, "client_flag_blood_shoulder" },
    { 0xC068CB51, "client_flag_callback" },
    { 0x3A458BD2, "client_flag_camera_spike" },
    { 0x443AA9B7, "client_flag_camo_toggle" },
    { 0x50845472, "client_flag_cardboard" },
    { 0xDFB3F492, "client_flag_clock" },
    { 0xAB2B45A3, "client_flag_cod_lighting_actor" },
    { 0xF2871426, "client_flag_cod_lighting_origin" },
    { 0x40BA7EAF, "client_flag_cod_lighting_player" },
    { 0x4E6C96B1, "client_flag_countdown" },
    { 0x4AA80BE0, "client_flag_counteruav" },
    { 0x2A54A4E0, "client_flag_ctf_carrier" },
    { 0xEA285B6B, "client_flag_damage_heavy" },
    { 0xD069483A, "client_flag_damage_light" },
    { 0xED446F35, "client_flag_damage_off" },
    { 0x07B3F455, "client_flag_debug" },
    { 0x523964C9, "client_flag_destructible_car" },
    { 0x8970DE8E, "client_flag_destructible_destroyed" },
    { 0xB6D96AD0, "client_flag_drone_damage_hi" },
    { 0x34BB6AD1, "client_flag_drone_damage_low" },
    { 0xBE516EB9, "client_flag_drone_damage_med" },
    { 0xBF858306, "client_flag_emp" },
    { 0x471101B9, "client_flag_enemy_highlight" },
    { 0x859D9606, "client_flag_extra_cam" },
    { 0x5F2E9FA0, "client_flag_extracam_primary" },
    { 0x6605F9F0, "client_flag_extracam_secondary" },
    { 0x93979867, "client_flag_face_swap" },
    { 0x28389934, "client_flag_face_swap_init" },
    { 0x90DE25BD, "client_flag_face_swap_player" },
    { 0x5150189B, "client_flag_flag_away" },
    { 0xBA784277, "client_flag_flame_char_toggle" },
    { 0x9448F2A9, "client_flag_floating_body" },
    { 0x17E62D09, "client_flag_fov" },
    { 0x66C0168E, "client_flag_frogger_debris" },
    { 0x52354860, "client_flag_frosted_glass" },
    { 0x7CFFBE79, "client_flag_gasfreeze_toggle" },
    { 0xA0498624, "client_flag_glasses_cam" },
    { 0x735E6906, "client_flag_glove_l" },
    { 0x5F3BB748, "client_flag_glove_r" },
    { 0x0422B6A8, "client_flag_holo_red" },
    { 0x30AA5239, "client_flag_holo_table" },
    { 0x77444BAF, "client_flag_holo_visible" },
    { 0x5CB444A1, "client_flag_intro_extra_cam" },
    { 0xA4572067, "client_flag_karma_shot" },
    { 0x33E2BBD3, "client_flag_karma_vital_cam" },
    { 0x5ABD7EA1, "client_flag_map_monitor" },
    { 0x6E187DE4, "client_flag_messiah_mode" },
    { 0xD2C91F47, "client_flag_metal_glow" },
    { 0xCFCEF82F, "client_flag_microwave" },
    { 0x98415B7E, "client_flag_microwave_close" },
    { 0xECADB5C0, "client_flag_microwave_destroy" },
    { 0x28AFD29A, "client_flag_microwave_open" },
    { 0x27403450, "client_flag_mover_extra_cam" },
    { 0x10A92F17, "client_flag_mover_hologram" },
    { 0x1C1D79E7, "client_flag_multi_camera" },
    { 0x5C0941DD, "client_flag_operating_chopper_gunner" },
    { 0x45377BB5, "client_flag_operating_predator" },
    { 0x5728D305, "client_flag_operating_reaper" },
    { 0x5937336D, "client_flag_outline_toggle" },
    { 0x58B47140, "client_flag_overlay" },
    { 0xB89156F7, "client_flag_player_binoc" },
    { 0xFDD8785C, "client_flag_player_rain" },
    { 0x1DB2DBD8, "client_flag_player_wingsuit" },
    { 0x6F46D112, "client_flag_player_zodiac" },
    { 0xE923049B, "client_flag_proximity" },
    { 0x8ADF1FFE, "client_flag_rage_mode_high" },
    { 0x41929198, "client_flag_rage_mode_low" },
    { 0xB4BFF0F3, "client_flag_rage_mode_medium" },
    { 0x323341DF, "client_flag_rage_mode_reset" },
    { 0x984A1F54, "client_flag_remote_killstreak_static" },
    { 0x621FD7D7, "client_flag_remote_missile" },
    { 0x7662A69A, "client_flag_riotshield_destroy" },
    { 0x1E564295, "client_flag_scrambler" },
    { 0x19423B35, "client_flag_set_lighting_ent" },
    { 0xC83E9CAD, "client_flag_soct_damage_hi" },
    { 0x702CED5A, "client_flag_soct_damage_low" },
    { 0xB7232A16, "client_flag_soct_damage_med" },
    { 0x5554EA68, "client_flag_speeding_osprey" },
    { 0x01CE76A8, "client_flag_stun" },
    { 0xE175E149, "client_flag_stunned" },
    { 0x0AB0B6CC, "client_flag_swing_trail_fx" },
    { 0xB5902B19, "client_flag_tactical_insertion" },
    { 0x5CA0B81D, "client_flag_third_person_cam" },
    { 0x9A70DE99, "client_flag_timeout" },
    { 0xA496BB94, "client_flag_toggle" },
    { 0x0A76F2D0, "client_flag_tow_futz" },
    { 0xA45B7957, "client_flag_tow_highlight" },
    { 0x0B777B64, "client_flag_turret_fade_in1" },
    { 0x7D7EEA9F, "client_flag_turret_fade_in2" },
    { 0x3CDD0807, "client_flag_turret_fade_out1" },
    { 0xCAD598CC, "client_flag_turret_fade_out2" },
    { 0x96325092, "client_flag_turret_static_disable" },
    { 0x94BCAF17, "client_flag_turret_static_enable" },
    { 0x2E8AD046, "client_flag_use_lighting_ent" },
    { 0x9EB3ADD6, "client_flag_vehicle_gasfreeze_toggle" },
    { 0xF4617104, "client_flag_vehicle_lights" },
    { 0x3F85C92F, "client_flag_vehicle_outline" },
    { 0x57983D04, "client_flag_vehicle_reflection_blur" },
    { 0xFA08FE91, "client_flag_warn_fired" },
    { 0x3ED1AB35, "client_flag_warn_locked" },
    { 0x72B5A547, "client_flag_warn_targeted" },
    { 0x3B86AA7A, "client_flag_water_fx" },
    { 0x741B23E6, "client_flag_water_fx_player" },
    { 0xAA53D871, "client_flag_zoom" },
    { 0x3CC137C8, "client_flagasval_callback" },
    { 0xC521607C, "client_flags" },
    { 0xAE17E90A, "client_frame" },
    { 0xED5474D3, "client_gas_flag" },
    { 0xD1DA04B0, "client_hint" },
    { 0x41AC9A4A, "client_jfk_mon1" },
    { 0xCD2DD62E, "client_jfk_mon10" },
    { 0xF3305097, "client_jfk_mon11" },
    { 0x1BAA1FE1, "client_jfk_mon2" },
    { 0xF5A7A578, "client_jfk_mon3" },
    { 0xFFB8FE57, "client_jfk_mon4" },
    { 0xD9B683EE, "client_jfk_mon5" },
    { 0xB3B40985, "client_jfk_mon6" },
    { 0x8DB18F1C, "client_jfk_mon7" },
    { 0x379B416B, "client_jfk_mon8" },
    { 0x1198C702, "client_jfk_mon9" },
    { 0xCDE816F4, "client_lull_vox_on" },
    { 0xD271DA99, "client_menus" },
    { 0x3AB3A6E2, "client_morgue_door_left_flashes" },
    { 0x45DE0B53, "client_morgue_door_right_flashes" },
    { 0x66BEEB04, "client_morgue_door_static" },
    { 0xB716228A, "client_morgue_door_tweak" },
    { 0x5B16884C, "client_notify" },
    { 0x3981ABAF, "client_notify_listener" },
    { 0xDB60A434, "client_notify_str" },
    { 0xC1424CF4, "client_notify_string" },
    { 0x4D69EDEA, "client_notify_value" },
    { 0xDF95F14A, "client_nova6_flag" },
    { 0x4FDAF431, "client_num" },
    { 0x719CE80B, "client_raglaunch_flag" },
    { 0x4DDE89CA, "client_reznov_movie_small" },
    { 0x69BDAD59, "client_reznov_projector_on_intro" },
    { 0xCEAAE31F, "client_reznov_projector_on_movie" },
    { 0x05F607FE, "client_reznov_projector_on_outro" },
    { 0xEEEA0659, "client_reznov_projetor_off" },
    { 0x339DA150, "client_reznov_room_init" },
    { 0x87C57EB2, "client_roundbonus" },
    { 0x4FF80F1B, "client_rusalka_letters_bink" },
    { 0x835EFBFC, "client_rusalka_letters_bink_fade" },
    { 0xE08F8C45, "client_send" },
    { 0x08265C45, "client_side_fire" },
    { 0x28409E79, "client_swift_bleed" },
    { 0x5DB0DD6A, "client_switch_glasses" },
    { 0x9FDAD8C3, "client_switch_glasses_bink" },
    { 0xE9AEC4EC, "client_switch_glasses_limo" },
    { 0x93CD9F39, "client_switch_glasses_limo_bink" },
    { 0xF25370E5, "client_voice_setup" },
    { 0xAA190796, "client_wet_flag" },
    { 0x5B478AD5, "clientannouncement" },
    { 0x4CB54E9F, "clientbegin" },
    { 0x2B970F60, "clientclaimtrigger" },
    { 0xD88C7F2F, "clientent" },
    { 0xCDB2C8E4, "clientent1" },
    { 0x3FBA381F, "clientent2" },
    { 0x6C43AFE4, "cliententgibannihilate" },
    { 0x62316411, "cliententgibhead" },
    { 0x4EE18776, "cliententgibleftarm" },
    { 0x99280DBC, "cliententgibleftleg" },
    { 0x8F0DD4A7, "cliententgibrightarm" },
    { 0xB9B8D16D, "cliententgibrightleg" },
    { 0x1C6E58D4, "clientfaceanim" },
    { 0xC6774578, "clientfaceanim_shared" },
    { 0x71E9CB84, "clientfield" },
    { 0x20404089, "clientfield_buildable" },
    { 0xC5AE20A1, "clientfield_buildable_piece_cattlecatcher_plow" },
    { 0x096D2D3E, "clientfield_buildable_piece_count" },
    { 0x0815B7F4, "clientfield_buildable_piece_electric_trap_battery" },
    { 0x75DBC31C, "clientfield_buildable_piece_electric_trap_coil" },
    { 0x9B4E12E6, "clientfield_buildable_piece_electric_trap_spool" },
    { 0x7B096608, "clientfield_buildable_piece_headchopper_a" },
    { 0xED10D543, "clientfield_buildable_piece_headchopper_b" },
    { 0xC70E5ADA, "clientfield_buildable_piece_headchopper_c" },
    { 0x3915CA15, "clientfield_buildable_piece_headchopper_d" },
    { 0xC1FE9C47, "clientfield_buildable_piece_none" },
    { 0x8DCE220D, "clientfield_buildable_piece_riotshield_dolly" },
    { 0xC69F537B, "clientfield_buildable_piece_riotshield_door" },
    { 0xB9862184, "clientfield_buildable_piece_springpad_door" },
    { 0x823CF0BA, "clientfield_buildable_piece_springpad_flag" },
    { 0xE169C04F, "clientfield_buildable_piece_springpad_motor" },
    { 0x0852896A, "clientfield_buildable_piece_springpad_whistle" },
    { 0x4792416B, "clientfield_buildable_piece_subwoofer_motor" },
    { 0xF0D25697, "clientfield_buildable_piece_subwoofer_mount" },
    { 0xD0370B6B, "clientfield_buildable_piece_subwoofer_speaker" },
    { 0x89FE038C, "clientfield_buildable_piece_subwoofer_table" },
    { 0x7D29EF45, "clientfield_buildable_piece_turbine_body" },
    { 0x2B5A3650, "clientfield_buildable_piece_turbine_fan" },
    { 0xFB858C55, "clientfield_buildable_piece_turbine_panel" },
    { 0xBA739C88, "clientfield_buildable_piece_turret_ammo" },
    { 0x08D69F72, "clientfield_buildable_piece_turret_barrel" },
    { 0x6393A1E6, "clientfield_buildable_piece_turret_body" },
    { 0xCA22F4BA, "clientfield_code_callback" },
    { 0xE3DC9927, "clientfield_craftable" },
    { 0xB0E47EC1, "clientfield_craftable_piece_none" },
    { 0xB21886D6, "clientfield_craftable_piece_riotshield_clamp" },
    { 0x9C1A14EF, "clientfield_craftable_piece_riotshield_dolly" },
    { 0x4230C679, "clientfield_craftable_piece_riotshield_door" },
    { 0x25DD6806, "clientfield_name" },
    { 0x09307844, "clientfield_powerup_bon_fire" },
    { 0x6974D41B, "clientfield_powerup_double_points" },
    { 0x8328EDC6, "clientfield_powerup_fire_sale" },
    { 0x476F921D, "clientfield_powerup_fx_any_team_on" },
    { 0x8D2ABEF0, "clientfield_powerup_fx_name" },
    { 0x81BE6A78, "clientfield_powerup_fx_off" },
    { 0xD19EBF32, "clientfield_powerup_fx_on" },
    { 0x107AE340, "clientfield_powerup_fx_only_affects_grabber_on" },
    { 0x680E88AE, "clientfield_powerup_fx_zombie_grabbable_on" },
    { 0x191D6B0A, "clientfield_powerup_instant_kill" },
    { 0x7361882D, "clientfield_powerup_instant_kill_ug" },
    { 0x43552436, "clientfield_powerup_mini_gun" },
    { 0x651E97D2, "clientfield_powerup_state_flashing_off" },
    { 0x89BE7B24, "clientfield_powerup_state_flashing_on" },
    { 0x2A905969, "clientfield_powerup_state_off" },
    { 0x8C0ED3DD, "clientfield_powerup_state_on" },
    { 0x45714CDD, "clientfield_powerup_tesla" },
    { 0x8EAE7B53, "clientfield_powerup_zombie_blood" },
    { 0x7BBEDE4C, "clientfield_register" },
    { 0x451C604D, "clientfield_set" },
    { 0xDBF6880B, "clientfield_set_vulture_stink_enabled" },
    { 0xAC3F1DE8, "clientfield_shared" },
    { 0x443ECC69, "clientfield_version" },
    { 0x8205607E, "clientfieldaicheck" },
    { 0x65FBF13A, "clientfieldmodels" },
    { 0xC5B89765, "clientfieldname" },
    { 0x5505D874, "clientfieldnames" },
    { 0xD1ED79D8, "clientfieldprefix" },
    { 0x684C8F37, "clientfields" },
    { 0xC6DFEA96, "clientflag" },
    { 0x89D96821, "clientflag_juggernaut" },
    { 0xE2B69B9A, "clientflag_sergei" },
    { 0x6204DC09, "clientflags" },
    { 0xE730CFF4, "clienthassnapshot" },
    { 0xBA61489A, "clienthudelem" },
    { 0xFEE2B336, "clienthudelem_count" },
    { 0x9EE32E67, "clientid" },
    { 0x8C2D92DE, "clientids" },
    { 0x6A02A96A, "clientmax" },
    { 0xF396495B, "clientmenustack" },
    { 0x4FB1D61F, "clientnotifies" },
    { 0xEF3F75EB, "clientnotify" },
    { 0x59EC608F, "clientnotify_delay" },
    { 0xCF6FE380, "clientnum" },
    { 0x1526CE60, "clientobjid" },
    { 0x9DC68321, "clientreleasetrigger" },
    { 0x7DBD03CB, "clients" },
    { 0x3502D619, "clientscript" },
    { 0xEAA93B0F, "clientscriptmainmenu" },
    { 0x3AE68DD0, "clientscripts" },
    { 0x8F6BE231, "clientside" },
    { 0xF01F1366, "clientside_fx" },
    { 0x3383AD3F, "clientside_linkto" },
    { 0x502E49E7, "clientsided" },
    { 0xAAC40ACA, "clientsideeffect" },
    { 0x9F99B3E4, "clientsiding" },
    { 0xB172141C, "clientsysregister" },
    { 0x1BEC8000, "clientsyssetstate" },
    { 0x7380CB14, "clienttweakable" },
    { 0x3A8D6087, "clienttweakables" },
    { 0x4B65701C, "clientuimodels" },
    { 0xC7A6EDF5, "clientvoicesetup" },
    { 0x9F1E07CD, "clif" },
    { 0xA62550A1, "cliff" },
    { 0x9E07298E, "cliff_bm21_blows_up" },
    { 0x45767AD9, "cliff_clean_up" },
    { 0xD579C699, "cliff_complete" },
    { 0x416DBAD8, "cliff_debris1_01" },
    { 0xB3752A13, "cliff_debris1_02" },
    { 0x8D72AFAA, "cliff_debris1_03" },
    { 0xFF7A1EE5, "cliff_debris1_04" },
    { 0xD977A47C, "cliff_debris1_05" },
    { 0x4B7F13B7, "cliff_debris1_06" },
    { 0x257C994E, "cliff_debris1_07" },
    { 0x1BAA85CD, "cliff_debris2_01" },
    { 0x41AD0036, "cliff_debris2_02" },
    { 0x67AF7A9F, "cliff_debris2_03" },
    { 0x5D9E21C0, "cliff_debris2_04" },
    { 0x83A09C29, "cliff_debris2_05" },
    { 0xA9A31692, "cliff_debris2_06" },
    { 0xCFA590FB, "cliff_debris2_07" },
    { 0x20A0795D, "cliff_destroyed" },
    { 0x07B5836E, "cliff_dialogue" },
    { 0x4EA8E9A4, "cliff_dist" },
    { 0xC66EB5C1, "cliff_enemy_delete_org" },
    { 0xE85BB50C, "cliff_fall_death" },
    { 0x14821AE2, "cliff_fighting" },
    { 0xB942BF20, "cliff_fire" },
    { 0xF1912CA7, "cliff_glow" },
    { 0xBD45AB52, "cliff_gun" },
    { 0x5B1594A1, "cliff_intact" },
    { 0x088C3C78, "cliff_intro_harper_intro" },
    { 0x8ABA4DA6, "cliff_org" },
    { 0x48F0EF74, "cliff_rail" },
    { 0xE7F3C32E, "cliff_reminder" },
    { 0x9617E273, "cliff_remove_node" },
    { 0x6CFE437E, "cliff_rocks" },
    { 0xD4617AF8, "cliff_sniping" },
    { 0xA27DF466, "cliff_swing" },
    { 0xADCA4DFC, "cliff_swing_6_done" },
    { 0xFF868F6D, "cliff_swing_6_landing" },
    { 0x84A9111B, "cliff_swing_6_rumble" },
    { 0xB2C794A0, "cliff_swing_assist_rumble" },
    { 0x15CBF5B3, "cliff_swing_crosby" },
    { 0xF1E2A6C9, "cliff_swing_fail" },
    { 0x4EC611C7, "cliff_swing_fail_checked" },
    { 0x84644358, "cliff_swing_flying_rumble" },
    { 0xFC94016E, "cliff_swing_harper_1_fail" },
    { 0x6853A847, "cliff_swing_harper_2_fail" },
    { 0xC7DB8580, "cliff_swing_harper_3_fail" },
    { 0x1405CE6D, "cliff_swing_impact_player" },
    { 0xEF8B51C9, "cliff_swing_nag_vo" },
    { 0xF05D8FBD, "cliff_swing_player_1_fail" },
    { 0x553CFAB0, "cliff_swing_player_2_fail" },
    { 0xD42DD7D7, "cliff_swing_player_fx" },
    { 0x5F09975D, "cliff_swing_rope" },
    { 0xE5D42DF7, "cliff_swing_salazar" },
    { 0x44B0B844, "cliff_swing_stop_trail" },
    { 0x693D71AA, "cliff_swing_success_rumble" },
    { 0x26548DBC, "cliff_swing_success_window_assist_start" },
    { 0x32A1A86F, "cliff_swing_success_window_grab_start" },
    { 0x31DFABEE, "cliff_swing_success_window_harper" },
    { 0xD31FAE6F, "cliff_swing_success_window_player" },
    { 0x4CA01C47, "cliff_swing_tree_fall" },
    { 0xA732B8B9, "cliff_swing_tree_fall_rumble" },
    { 0x507B24BC, "cliffhanger" },
    { 0x1AA0F048, "cliffs" },
    { 0x15D1DCE0, "cliffs_up" },
    { 0x6D33BE60, "cliffside" },
    { 0x2035B758, "cliffside_ambient_fire" },
    { 0xC773BB45, "climates" },
    { 0xD47CE071, "climax" },
    { 0x730E5368, "climb" },
    { 0x823BACEC, "climb_over_wall" },
    { 0xBE0C2249, "climb_tag" },
    { 0x9987BFA3, "climb_traversal" },
    { 0xF88251C0, "climb_up" },
    { 0xDE22FC84, "climb_up_scene_done" },
    { 0x774AE2C8, "climbang" },
    { 0xC247EA37, "climbanim" },
    { 0xE7B36D7B, "climbed" },
    { 0x93E008DD, "climber" },
    { 0xA58B7D0A, "climbinanim" },
    { 0x64F2B930, "climbing" },
    { 0xD926DA3E, "climbing_into_bus" },
    { 0x8D403E54, "climbing_onto_bus" },
    { 0xFB4C7A77, "climbing_tree" },
    { 0x70C1A20B, "climbingtime" },
    { 0x7C226735, "climbinnode" },
    { 0x7F5199AC, "climbnode" },
    { 0xB21220F2, "climborg" },
    { 0xB49A98CE, "climbrate" },
    { 0x587F2E03, "climbs" },
    { 0xEF1D8CED, "clines" },
    { 0xF6B9D650, "cling" },
    { 0xBD030921, "cling_dettached" },
    { 0x136A7F12, "cling_enabled" },
    { 0x6B281E68, "cling_triggers" },
    { 0x44E46D48, "clinging" },
    { 0x383D7A55, "clingpistol" },
    { 0x988B1383, "clingtriggerusethink" },
    { 0xC039CC41, "clinic" },
    { 0x8FD2C291, "clinic_break_wall_think" },
    { 0x88DBCBA9, "clinic_break_window_think" },
    { 0x298B99B1, "clinic_ceiling_collapse" },
    { 0xC57D29CC, "clinic_door_kicked_in" },
    { 0xCEFB4C70, "clinic_enter_hall_1" },
    { 0x4102BBAB, "clinic_enter_hall_2" },
    { 0x0A110B87, "clinic_light_shake" },
    { 0x10DFB3C6, "clinic_move_heroes" },
    { 0x5FD58A33, "clinic_player_vo_1" },
    { 0xEDCE1AF8, "clinic_player_vo_2" },
    { 0x83AC3CCF, "clinic_spookies" },
    { 0x9F72442F, "clinic_stairwell_top" },
    { 0xB340B98B, "clip" },
    { 0xC42572DB, "clip_a" },
    { 0x8CCB6870, "clip_ai" },
    { 0x5886206C, "clip_ammo" },
    { 0x3232BE6A, "clip_amount" },
    { 0x588C8CA8, "clip_amt" },
    { 0x7FE4308F, "clip_and_stock_ammo" },
    { 0x521E03A0, "clip_b" },
    { 0xED35CA26, "clip_brush" },
    { 0x090C7F8E, "clip_chamber_doors" },
    { 0x66376A4B, "clip_count" },
    { 0x40D57E38, "clip_dead" },
    { 0x0308D024, "clip_detached" },
    { 0x4EF763AD, "clip_ent" },
    { 0x90E5BBAA, "clip_foot_left" },
    { 0xA0A20AF9, "clip_foot_right" },
    { 0x1C9DE5CE, "clip_link" },
    { 0x3F060339, "clip_living" },
    { 0x4B4EFAFE, "clip_mask" },
    { 0x2E0298E9, "clip_max_ammo" },
    { 0x219570AB, "clip_name" },
    { 0x470F6481, "clip_nosight_logic" },
    { 0x725DE8D1, "clip_nosight_logic2" },
    { 0x758F982A, "clip_nosight_wait" },
    { 0x486A9732, "clip_off_brute_force_debris" },
    { 0x472A3B76, "clip_percentage" },
    { 0x5C62DAC1, "clip_player" },
    { 0xB9CFCFA3, "clip_rolldoor" },
    { 0xED30E0BD, "clip_setup" },
    { 0xCE7CF2FE, "clip_shield1" },
    { 0xA87A7895, "clip_shield2" },
    { 0xC8A52151, "clip_size" },
    { 0xFD296C28, "clip_to_office" },
    { 0x5272F2C3, "clip_trainyard_door" },
    { 0xC51C6D8F, "clip_under_arch" },
    { 0x2B2AFDF1, "clipammo" },
    { 0xBE1918B5, "clipammotogive" },
    { 0x998A1D55, "clipboard" },
    { 0xD5F35745, "clipbrush" },
    { 0x08AAD6FD, "clipbrushes" },
    { 0xFD9DF870, "clipcount" },
    { 0x5BDAB3B2, "clipcount2" },
    { 0x78686951, "clipcountalt" },
    { 0x5439828B, "clipeffects" },
    { 0x1B6F23D5, "cliping" },
    { 0x983FDEBA, "clipmodel" },
    { 0x2B6DBEA5, "clipped_delta" },
    { 0x119BCD68, "clipper" },
    { 0xD84CA0C7, "clipping" },
    { 0x005D83EA, "clips" },
    { 0xED2CCD9A, "clips_on" },
    { 0x0C0B2188, "clipsize" },
    { 0xE1D49CA9, "clipstokill" },
    { 0xAA29FE4F, "cloak" },
    { 0xD6D4191B, "cloakamount" },
    { 0xE3B141B1, "cloaking" },
    { 0xEDDD808B, "cloakmaskcompression" },
    { 0xFBA4B972, "clobber" },
    { 0xC75E2285, "clobbered" },
    { 0xEED7ED51, "clock" },
    { 0x8A76B3BE, "clock_ai" },
    { 0x70ACC1EC, "clock_list" },
    { 0x72C667FB, "clock_run" },
    { 0x663E2494, "clock_shot" },
    { 0x1CB7CCB9, "clock_sound" },
    { 0x46EF998F, "clock_tank_blocker_delay" },
    { 0xAAD04527, "clock_timer" },
    { 0x4AACB580, "clock_tower_battle" },
    { 0x7AFE774E, "clock_tower_exploder_110" },
    { 0xA100F1B7, "clock_tower_exploder_111" },
    { 0x2EF9827C, "clock_tower_exploder_112" },
    { 0x54FBFCE5, "clock_tower_exploder_113" },
    { 0x9A656424, "clock_tower_exploders" },
    { 0xAC8458C0, "clockobject" },
    { 0xA9FD4919, "clocks_init" },
    { 0xDBA9C206, "clocktime" },
    { 0xF592D3E0, "clocktower" },
    { 0xCA8CE8E7, "clocktower_2_vo" },
    { 0x00FDCA9E, "clocktower_vo" },
    { 0x08D50041, "clockwise" },
    { 0x312EBF73, "clon" },
    { 0x11EE1E64, "clone" },
    { 0x40B299B0, "clone_activated" },
    { 0x38519482, "clone_actor_animate" },
    { 0x07596FC4, "clone_animate" },
    { 0xC1197211, "clone_appear_fx" },
    { 0x9467783D, "clone_cleanup_watch_player_presence" },
    { 0xAEFCEB70, "clone_count" },
    { 0x94521DCA, "clone_damage_finish" },
    { 0x46C43B11, "clone_damage_flicker" },
    { 0x84214261, "clone_damage_func" },
    { 0x1771F2C0, "clone_damaged" },
    { 0xED40D5DD, "clone_fade" },
    { 0x5BF6E966, "clone_first_point_distance" },
    { 0x20EC14BF, "clone_flashback_changed" },
    { 0x846F9A6E, "clone_flashback_changed_event" },
    { 0x79DEBAA3, "clone_give_weapon" },
    { 0x8ABF42D9, "clone_health_multiplier" },
    { 0xDCAB4E9A, "clone_height" },
    { 0x5E66E5AF, "clone_list" },
    { 0xE5ECB1E9, "clone_material_ally" },
    { 0x89995B11, "clone_material_damage_ally" },
    { 0x34FFE445, "clone_material_damage_enemy" },
    { 0x4DF5EA6D, "clone_material_enemy" },
    { 0x775BC9E1, "clone_max_clones_allowed" },
    { 0xBC88B9FB, "clone_max_search_radius" },
    { 0x7E9B1CBA, "clone_max_search_radius_initial" },
    { 0x6BEF72D9, "clone_min_search_radius" },
    { 0x499ED1BA, "clone_model" },
    { 0xEF5752AA, "clone_mover_animate" },
    { 0xB910897D, "clone_not_moving_dist_sq" },
    { 0xDAD80343, "clone_not_moving_poll_time" },
    { 0xC9F30F57, "clone_orb_fx" },
    { 0xD5ECC300, "clone_path_distance_threshold" },
    { 0xF4823323, "clone_path_distance_threshold_sq" },
    { 0xEDDD2027, "clone_player_angles" },
    { 0x707AB378, "clone_shader_const" },
    { 0xB8916ACA, "clone_shader_off" },
    { 0x34590637, "clone_shader_ramp_in_speed" },
    { 0x6C1DB124, "clone_shader_w_wire_brightness" },
    { 0x4886AABA, "clone_shader_x_unused" },
    { 0xE060DEB8, "clone_shader_z_tint_index" },
    { 0x920297AD, "clone_shutdown" },
    { 0x3C6DBBBA, "clone_spawn_distance" },
    { 0x73C5823D, "clone_spawn_facing_offset" },
    { 0xCAA3D56E, "clone_spawn_from_player_max" },
    { 0x4CEEBB28, "clone_spawn_height_offset" },
    { 0xDA038D98, "clone_spawn_velocity_offset" },
    { 0xC11C69DF, "clone_vanish_fx" },
    { 0xDCCA4D3B, "clone_watch_death" },
    { 0x5A1B0E7F, "clone_weapon" },
    { 0x1AA2E27A, "clonebehavior" },
    { 0x46BDD528, "cloned" },
    { 0xF574665F, "clonedamageoverride" },
    { 0x91737D19, "clonedentity" },
    { 0x9B74DFD5, "clonedistance" },
    { 0x963FD853, "cloneplayer" },
    { 0xC80742DE, "cloneplayerlook" },
    { 0xB0F6D497, "clones" },
    { 0x16383E98, "cloneserverutils" },
    { 0xCE5743F6, "cloneshaderoff" },
    { 0xFEDFDEE8, "cloneshaderon" },
    { 0x008A466C, "clonespawnsetup" },
    { 0x12FAB4D6, "clos" },
    { 0xB5A4F84F, "close" },
    { 0x136671F0, "close_alley_gates" },
    { 0xAF509C52, "close_automatic_door" },
    { 0x54498E29, "close_axis" },
    { 0x8D002C28, "close_bar_door" },
    { 0x194A0CC9, "close_base_gate" },
    { 0x587133CB, "close_boat_sounds" },
    { 0x693EE43F, "close_bottom_door_elevator" },
    { 0xA4FBC0A4, "close_bunker_door" },
    { 0xE7B19CCE, "close_bunker_hatch" },
    { 0x35046CCB, "close_chamber_doors_0" },
    { 0x0F01F262, "close_chamber_doors_1" },
    { 0x5274CFC8, "close_conference" },
    { 0xBA8DD527, "close_count" },
    { 0xBBA1FCD7, "close_crc_door" },
    { 0xDE195F66, "close_dist" },
    { 0x77AA39F6, "close_door" },
    { 0xF916F472, "close_door_to_water" },
    { 0xF0A0D0B1, "close_e3_door" },
    { 0x4CC53F32, "close_elev_doors" },
    { 0xC59A4027, "close_ending_transition" },
    { 0x17DEF493, "close_enemy_distance_sq" },
    { 0x14362102, "close_enough" },
    { 0x5A6D01B7, "close_explosive" },
    { 0x973E05DC, "close_firing_range_door" },
    { 0x20289210, "close_flag" },
    { 0xC19DEA83, "close_friendly_distance" },
    { 0x2C9AD998, "close_front_gate_trig" },
    { 0xFC5667BE, "close_front_gates" },
    { 0x84F8E7A8, "close_gate_until_hit" },
    { 0x9149906A, "close_guys" },
    { 0x1E10D4F4, "close_hatch" },
    { 0xDE1A930A, "close_hit_dialogue" },
    { 0x06A3734C, "close_impact" },
    { 0xE965F649, "close_internal" },
    { 0x83EE7BD7, "close_lander_bay_doors" },
    { 0x0E11B107, "close_lander_door" },
    { 0xF2E995A2, "close_lander_gate" },
    { 0x56049D4C, "close_left_door" },
    { 0x1384A299, "close_magic_boxes" },
    { 0xCAC78983, "close_menu" },
    { 0x92EF26D7, "close_on_player" },
    { 0xBFC26069, "close_open_door" },
    { 0xDCF76F3D, "close_patrol_trig" },
    { 0x90D1CDA5, "close_player" },
    { 0x5FDB2987, "close_right_door" },
    { 0x9A8B5C67, "close_shed_door" },
    { 0x92D8FAFA, "close_spot" },
    { 0xD719C751, "close_struct" },
    { 0x0206B0BC, "close_targets" },
    { 0x6C6F3335, "close_time" },
    { 0xD216B1D5, "close_to_any_friend" },
    { 0xFA01C54B, "close_to_art" },
    { 0x5D7CB7B3, "close_to_base" },
    { 0x5CD5F0B7, "close_to_lewrepel_trig" },
    { 0x509CD910, "close_to_node" },
    { 0x639A79AB, "close_to_player" },
    { 0xDD0EF53A, "close_to_player_nowattack" },
    { 0x38AB35CC, "close_to_tank" },
    { 0x876A7E23, "close_tower_trap_upgrade_panel" },
    { 0xAB265DD5, "close_traincar_door" },
    { 0xA0F52F12, "close_trigger" },
    { 0x0441602C, "close_war" },
    { 0xE0EF8134, "close_window_3" },
    { 0x6C755991, "close_zombs" },
    { 0x9BBF058B, "closeammoboxlid" },
    { 0x0761DEC1, "closeassault_stat" },
    { 0x556C154C, "closeby" },
    { 0x3C78AE86, "closebyai" },
    { 0xE959AD99, "closed" },
    { 0x672CB890, "closed_by_emp" },
    { 0x56C618E5, "closed_by_minigame" },
    { 0xDAEEE8AD, "closed_pieces" },
    { 0x50E6D6BB, "closedist" },
    { 0x3CF66E31, "closedlist" },
    { 0x61BAD6D2, "closedlistid" },
    { 0xC2E75AE1, "closeenemy" },
    { 0x09F7FB26, "closeengagementdist" },
    { 0xD63747FB, "closeenough" },
    { 0x76AE2169, "closefile" },
    { 0xC816912B, "closeguys" },
    { 0xEB306581, "closeingamemenu" },
    { 0x1EDB334B, "closekill" },
    { 0x2B74B70A, "closeluimenu" },
    { 0xF2733B12, "closely" },
    { 0xFAEB470D, "closemainmenu" },
    { 0x49876A9E, "closemenu" },
    { 0x58A15001, "closemenus" },
    { 0xEBC7EC67, "closenode" },
    { 0x3AF33A42, "closepoints" },
    { 0x6D40E57F, "closer" },
    { 0x357C614E, "closer_to_hatch" },
    { 0xFD516CC6, "closerange" },
    { 0x5C9E2564, "closerangesqr" },
    { 0x51E9036B, "closerdist" },
    { 0x322AEF65, "closerfunc" },
    { 0x97D8710A, "closeroll" },
    { 0x473E6B16, "closes" },
    { 0xB4D58996, "closest" },
    { 0x73A13F92, "closest_5" },
    { 0xDF95DCC3, "closest_ai" },
    { 0x18E55AA3, "closest_ally" },
    { 0xFF9BAFBB, "closest_ally2" },
    { 0x4CEEAEBA, "closest_ally_dist" },
    { 0x1FAF9C59, "closest_ally_weighted" },
    { 0x74B14D1C, "closest_attacker" },
    { 0xADFE28B4, "closest_attacker_dot" },
    { 0x682C8226, "closest_axis" },
    { 0x79F1AE15, "closest_axis_dist" },
    { 0x10BF4A86, "closest_axis_weighted" },
    { 0xB8C2AD45, "closest_dist" },
    { 0xF3E8C27D, "closest_dist2" },
    { 0xB18E9810, "closest_dist_sq" },
    { 0xAE8397D0, "closest_distance" },
    { 0x0E683173, "closest_distance_sq" },
    { 0x494687CA, "closest_distance_squared" },
    { 0xB60E80AD, "closest_distsqr" },
    { 0xC0140770, "closest_door_tag" },
    { 0x5C301876, "closest_dot" },
    { 0xEB98591B, "closest_dot_facing" },
    { 0x15BD6B4C, "closest_dot_position" },
    { 0xE52BA9F9, "closest_emp" },
    { 0x720B6E13, "closest_emp_distance_squared" },
    { 0x980E7AAF, "closest_enemy" },
    { 0x3959229F, "closest_enemy2" },
    { 0x8D832AF4, "closest_enemy_emp" },
    { 0xC1BEAE3C, "closest_ent" },
    { 0x13B105ED, "closest_ent_num" },
    { 0x11D7AB2A, "closest_exploder" },
    { 0x5F38049A, "closest_group" },
    { 0x7B8AFDD6, "closest_guy" },
    { 0x410E4807, "closest_index" },
    { 0xE0638CEC, "closest_index_radius" },
    { 0x2CD5DD3E, "closest_jump_point" },
    { 0x418E0D94, "closest_jump_tag" },
    { 0x8D1B84AA, "closest_key" },
    { 0x373F1695, "closest_node" },
    { 0xC98E8B9C, "closest_object" },
    { 0x68F8312B, "closest_other_player" },
    { 0xCF8DBD0C, "closest_path_drop" },
    { 0xA2044C95, "closest_path_start" },
    { 0x66AE3A28, "closest_path_start_dist" },
    { 0xE78E7ABB, "closest_patrollers" },
    { 0x01DB4C82, "closest_player" },
    { 0xDA420491, "closest_player_dist" },
    { 0x8277F5C9, "closest_player_override" },
    { 0x1AF0699D, "closest_player_tank" },
    { 0x42B455C8, "closest_player_targets_override" },
    { 0x15E3719E, "closest_player_transit" },
    { 0x335001DD, "closest_point" },
    { 0x8AA100A0, "closest_point_on_line" },
    { 0x7405198F, "closest_point_on_line_to_point" },
    { 0x216CBA4A, "closest_point_on_nav_volume" },
    { 0x358BA431, "closest_quad_index" },
    { 0x048B2A9E, "closest_redshirt" },
    { 0xE30C7B93, "closest_segment_point" },
    { 0x5FBBA12C, "closest_soul_runner_spot" },
    { 0xB1C271BC, "closest_spots" },
    { 0x1CDE0E42, "closest_struct" },
    { 0x9E9E1807, "closest_tag" },
    { 0xF11C4F0C, "closest_tank_tag" },
    { 0x43D08CEF, "closest_tank_tag_pos" },
    { 0x6B73C8CE, "closest_target" },
    { 0x546144F3, "closest_target_dist_squared" },
    { 0xA15CE5E7, "closest_vehicle" },
    { 0x91FD99A0, "closestai" },
    { 0x3A8262B2, "closestbomb" },
    { 0x22460F49, "closestcomparefunc" },
    { 0xF67FDB4F, "closestcomparefunc2d" },
    { 0x0C51988B, "closestcrate" },
    { 0xDF5323A3, "closestcratedistsq" },
    { 0x9F3304E9, "closestdesc" },
    { 0x7F115E22, "closestdist" },
    { 0x1BB8BC7B, "closestdistance" },
    { 0xCF591BBE, "closestdistsq" },
    { 0x7DDA806D, "closestendnode" },
    { 0x78DB2E6C, "closestendnodes" },
    { 0x891EFE5A, "closestenemy" },
    { 0xE532CC7F, "closestenemydistance" },
    { 0x8E48D75D, "closestent" },
    { 0x5812EA6F, "closestguy" },
    { 0x357522FE, "closestkillcament" },
    { 0xBC250C1A, "closestkillcamentdist" },
    { 0xE080CADA, "closestkillcamentindex" },
    { 0xEAC6C670, "closestnavmeshpoint" },
    { 0xB633B32A, "closestnode" },
    { 0x393B3D59, "closestpartdist" },
    { 0x61338191, "closestplayer" },
    { 0xCC93E499, "closestplayerpercentage" },
    { 0xC2E5E178, "closestplayers" },
    { 0xF4A8C22C, "closestpoint" },
    { 0x3BEB0A21, "closestpointdir" },
    { 0x118740CD, "closestpointonline" },
    { 0x07B2189F, "closestrandomnode" },
    { 0x82379626, "closestrandomnodes" },
    { 0xE9D6FF43, "closestratio" },
    { 0x39E4FEC4, "closestsoldier" },
    { 0x81DB7135, "closestsoldierdistance" },
    { 0x47B9839E, "closestsoldierincover" },
    { 0x1AA658C3, "closestsoldierincoverdistance" },
    { 0xDF772A7B, "closestsoldierincoverlocation" },
    { 0x751290D2, "closestsq" },
    { 0x63BC1092, "closeststartnode" },
    { 0xD2B9BADE, "closesttag" },
    { 0x2CA98C16, "closesttagdistsq" },
    { 0x909B922B, "closestteamenemy" },
    { 0x9D343BB4, "closestturret" },
    { 0xFA9BF056, "closestunitparams" },
    { 0x89320709, "closet" },
    { 0x1A7261C0, "closet_ambush" },
    { 0x586A5082, "closet_ambush_spawnfunc" },
    { 0xB98613F8, "closet_trigger" },
    { 0x2D2B8C19, "closetag" },
    { 0xD9574143, "closetargets" },
    { 0x1E946C1E, "closetargetscore" },
    { 0xB53139BC, "closetime" },
    { 0x832B0CED, "closetogoal" },
    { 0xAB2C8A90, "closetonode" },
    { 0xE96D8BE2, "closetozero" },
    { 0xEFA41600, "closets" },
    { 0x26A39995, "closezone" },
    { 0x256BF5CA, "closing" },
    { 0x8652AFBD, "closing_dialog" },
    { 0x20B1EC70, "closing_in" },
    { 0x442EEA1D, "closing_in_line" },
    { 0x3765326A, "closing_in_on_side" },
    { 0x857886AE, "closish" },
    { 0x7F4F35B0, "clost_banzai" },
    { 0x6C8C4CD3, "cloth" },
    { 0x92E58DA2, "cloth01" },
    { 0xBC3FB2EF, "cloth_fov" },
    { 0x9AAAA628, "cloth_grass" },
    { 0x87B6D33D, "clothflap_wind_ent" },
    { 0x522E9F6D, "clothflap_wind_id" },
    { 0x959BAFE4, "cloud" },
    { 0x12A33910, "cloud_ent_delete" },
    { 0x4DC47C9C, "cloud_exposure" },
    { 0x05B1910A, "cloud_find_spawn" },
    { 0x316A47AD, "cloud_fx" },
    { 0x0065235F, "cloud_fx_end" },
    { 0xB8D4B6DC, "cloud_move_time" },
    { 0x5C23CA8C, "cloud_spawn" },
    { 0x8FD5FCEB, "cloud_spawn_2" },
    { 0x8B9DAEC0, "cloud_time" },
    { 0xCD0E54F8, "cloud_update" },
    { 0x52347919, "cloud_update_fx" },
    { 0x8813675B, "cloud_wait_enemy_time" },
    { 0xF5035EE1, "cloudbursts" },
    { 0x72F66FB5, "cloudcover" },
    { 0xC222AE13, "cloudcoverfx" },
    { 0x8EA0DB16, "cloudfx" },
    { 0x7D91DF10, "cloudlight" },
    { 0x7B32E117, "clouds" },
    { 0x05640896, "clouds_create" },
    { 0xB12B2809, "clouds_off" },
    { 0xF42C09FD, "clouds_on" },
    { 0x571B9EBA, "clr" },
    { 0x1E93179C, "clr_sec" },
    { 0x6771C7D5, "clrm_o" },
    { 0x5591FF2A, "clrm_x" },
    { 0x09A67878, "cls_dr" },
    { 0x9944FE37, "clsoe" },
    { 0xC9230DF5, "clu" },
    { 0x8ADAB6BD, "club" },
    { 0x0B9D5BF2, "club_actor_think" },
    { 0x92D95FF6, "club_anims" },
    { 0xCB2FA7BE, "club_battle_damage_time" },
    { 0x1A5C355A, "club_battle_damage_timeout" },
    { 0xAF756D0B, "club_bodies_anims" },
    { 0x7BB553E4, "club_cleanup" },
    { 0x265D0C0D, "club_dj_front_lasers" },
    { 0x99B30869, "club_drones" },
    { 0x6CFA87AB, "club_dynents" },
    { 0xB1F42361, "club_enemies_think" },
    { 0xDD39CA5A, "club_fight" },
    { 0x806168C0, "club_fight_end" },
    { 0x02C989E5, "club_fight_objectives" },
    { 0xB49BC7CA, "club_fx" },
    { 0xAF68D236, "club_intro" },
    { 0x41924087, "club_music_duck" },
    { 0x322567D9, "club_music_duck_off" },
    { 0x405F1ED0, "club_music_snapshot" },
    { 0x0920C1F8, "club_precache_anims" },
    { 0x6343EAEE, "club_shoot_target_down" },
    { 0x13DA82EE, "club_speed_kill_challenge" },
    { 0x9FDA1C1F, "club_terrorist_think" },
    { 0x93FEC285, "club_terrorists_alerted" },
    { 0x1FEBA977, "clubbers" },
    { 0x18D34782, "clue" },
    { 0x2DA7856E, "clump" },
    { 0xE63511B1, "clumped" },
    { 0x353A403C, "clung" },
    { 0x76A0F628, "clunkier" },
    { 0xC8E376B1, "clunky" },
    { 0x0BECCBED, "cluster" },
    { 0x0EF9F53D, "cluster_count" },
    { 0x00D8CE88, "clustergrenademode" },
    { 0x55508F24, "clutter" },
    { 0xBD57E479, "clutz_challenge" },
    { 0xCA311435, "cm_delete" },
    { 0x6F5DC280, "cm_dont_kill" },
    { 0x4C0C6412, "cm_flag" },
    { 0xC9F43A95, "cm_input_watcher" },
    { 0x81E73DC4, "cm_kill_delay" },
    { 0xC1905327, "cmd" },
    { 0xD14B611C, "cmd_send_chopper" },
    { 0xA70D38E4, "cmd_skipto" },
    { 0x98BE8724, "cmd_strings" },
    { 0xF25F8E42, "cmd_tag" },
    { 0xAEBCBCFE, "cmd_take_poi" },
    { 0x4BADCEC0, "cmd_tokens" },
    { 0xE3FBA19E, "cmds" },
    { 0xA8C375D2, "cmissileturret" },
    { 0xECE11CF2, "cmon" },
    { 0xBCF7BB21, "cms_go" },
    { 0xC93FBFDA, "cn" },
    { 0xE7050F10, "cnfiguration" },
    { 0x544A6B10, "cnn" },
    { 0x703B8C9A, "cnt" },
    { 0x6870FF1C, "cnum" },
    { 0xEF423A43, "co" },
    { 0x5CB0AE67, "co_op" },
    { 0x5B902403, "co_spawn" },
    { 0x2403F835, "coast" },
    { 0xC6C95094, "coast_custom_third_person_override" },
    { 0x92B88BC5, "coast_custom_viewmodel_override" },
    { 0xB8D3401E, "coast_director_choose_run" },
    { 0x529B77FE, "coast_director_delay_transition" },
    { 0xBA7168FB, "coast_director_delay_weapon" },
    { 0xAF851A74, "coast_director_enter_level" },
    { 0xEE7D757C, "coast_director_entered_water" },
    { 0x27F8B5E8, "coast_director_exit_fx" },
    { 0x7DDF23AC, "coast_director_exit_level" },
    { 0xEF034354, "coast_director_exited_water" },
    { 0x56523138, "coast_director_failsafe" },
    { 0x6AE1EE05, "coast_director_find_exit" },
    { 0xAE84FFBA, "coast_director_find_exit_point" },
    { 0x85E2CD11, "coast_director_fx" },
    { 0x73115FCA, "coast_director_get_reentry_point" },
    { 0xB11D2E31, "coast_director_init" },
    { 0x92974D39, "coast_director_reenter_level" },
    { 0x35808437, "coast_director_should_drop_special_powerup" },
    { 0x70E0BE6B, "coast_director_sliding" },
    { 0x1E3DD895, "coast_director_start" },
    { 0x71F17FAC, "coast_director_water_drops_on_screen" },
    { 0xD79A548B, "coast_director_water_on_screen" },
    { 0x14ED2EB0, "coast_director_water_rise" },
    { 0x3ACF0541, "coast_director_water_rise_fx" },
    { 0xF7384E38, "coast_easter_egg_achieved" },
    { 0x5AB83214, "coast_egg_art_critic_message" },
    { 0x6690E6AB, "coast_egg_bartender" },
    { 0x32CC8FD1, "coast_egg_bottle_caught" },
    { 0xFAD63027, "coast_egg_bottle_cleanup" },
    { 0x5483E67B, "coast_egg_bottle_delivered" },
    { 0x4006D7B7, "coast_egg_bottle_think" },
    { 0xC9B17C5F, "coast_egg_broken_spark" },
    { 0x1264D447, "coast_egg_clear_bottle_on_death" },
    { 0xAF927581, "coast_egg_clear_bottle_on_disconnect" },
    { 0x67BDB5DE, "coast_egg_clear_fuse_on_death" },
    { 0x4E1D74A6, "coast_egg_clear_fuse_on_disconnect" },
    { 0xD33FDFD6, "coast_egg_debug_print3d" },
    { 0xC0D4B6B5, "coast_egg_device_delivered" },
    { 0xF655B376, "coast_egg_dial_rotate" },
    { 0x9DE79D1A, "coast_egg_dial_setup" },
    { 0x5562D539, "coast_egg_dial_think" },
    { 0x1A01211C, "coast_egg_dials_in_harmony" },
    { 0xA0999656, "coast_egg_fuse_box_think" },
    { 0x7E177B04, "coast_egg_fuse_controller" },
    { 0x8401D6BE, "coast_egg_fuse_lost" },
    { 0x96441294, "coast_egg_fuse_starts_holy" },
    { 0xB38A2724, "coast_egg_fuse_think" },
    { 0xBF160FC2, "coast_egg_holy_grenade_watcher" },
    { 0x36C34AB4, "coast_egg_musical_chairs_beach_beacon_used" },
    { 0xA58042DD, "coast_egg_musical_check" },
    { 0x9B9AEF78, "coast_egg_play_anim" },
    { 0x08AEE6A3, "coast_egg_power_source_react" },
    { 0x3744681D, "coast_egg_sacrifice_spot_start" },
    { 0x3825C03C, "coast_eggs_hud" },
    { 0x380C8072, "coast_eggs_hud_remove_on_death" },
    { 0x2460995C, "coast_fade_in_notify" },
    { 0xCAE00BD4, "coast_offhand_weapon_give_override" },
    { 0xE556482C, "coast_offhand_weapon_overrride" },
    { 0x686DDDE8, "coast_power_on_lighthouse_react" },
    { 0x6CC78954, "coast_precache_custom_models" },
    { 0x0B4ED093, "coast_remove_eggs_hud" },
    { 0x65821800, "coast_revive_solo_fx" },
    { 0x5A517C50, "coast_spawn_heuristic" },
    { 0x731A08FA, "coast_spawn_init_delay" },
    { 0x8BD5F2C7, "coast_zone_init" },
    { 0xE7A35244, "coat" },
    { 0x0AF777A7, "coated" },
    { 0x7C98E3F7, "coats" },
    { 0x7FAD3BE8, "coax" },
    { 0x111AC252, "cobbled" },
    { 0x474EB940, "cobra" },
    { 0xC7670DD9, "cobra1" },
    { 0xED698842, "cobra2" },
    { 0x76E19392, "cobra_bldg_activate" },
    { 0xFCE9F4CD, "cobra_bldg_mg" },
    { 0x6F510094, "cobra_bldg_mg_cleanup" },
    { 0xC785DEF5, "cobra_bldg_mg_targeting" },
    { 0x5C68D77E, "cobra_building_damage_fx" },
    { 0x856CE880, "cobra_crash" },
    { 0x9ECA7CAE, "cobra_crash_antenna_01" },
    { 0x78C80245, "cobra_crash_antenna_02" },
    { 0x505E1648, "cobra_crash_attached_fx" },
    { 0x0D6601F6, "cobra_crash_end" },
    { 0x88991FB1, "cobra_crash_fx" },
    { 0xD1152C91, "cobra_crash_roof_01" },
    { 0x94CE5D06, "cobra_crash_rotate" },
    { 0x44FEC36B, "cobra_crash_tree_01" },
    { 0xB1DB5A74, "cobra_crashsite_think" },
    { 0x728D0F6F, "cobra_death" },
    { 0x9E2B47E3, "cobra_fire" },
    { 0x7680B6AB, "cobra_flight_pts" },
    { 0xD7889F7C, "cobra_flightplan" },
    { 0x6E448B48, "cobra_flyover" },
    { 0x1C8AE235, "cobra_fx_1" },
    { 0x9F7807FB, "cobra_health_icon" },
    { 0x4ECF54E8, "cobra_health_overlay" },
    { 0x9FDAEBE1, "cobra_missile" },
    { 0x8633527C, "cobra_missile_fired_earthquake" },
    { 0xE61BFFBA, "cobra_missile_models" },
    { 0x9A101F90, "cobra_mp" },
    { 0x83E5DAB8, "cobra_player" },
    { 0x2B93ED68, "cobra_plaza_chase" },
    { 0xACCFC091, "cobra_raise" },
    { 0x8727704A, "cobra_retract" },
    { 0x493EAD60, "cobra_sequence" },
    { 0x660687C5, "cobra_sequence_reminder" },
    { 0x0BD235A2, "cobra_shoot_pts" },
    { 0x6FEF086A, "cobra_smoke" },
    { 0x1D8D1570, "cobra_streetfight" },
    { 0x625C86B5, "cobra_tag_1" },
    { 0x0338B691, "cobra_weapon_tags" },
    { 0x611C06CD, "cobra_wingman2_think" },
    { 0x862C5A7F, "cobra_wingman_think" },
    { 0xBBE679F8, "cobracrash01" },
    { 0x2DEDE933, "cobracrash02" },
    { 0x07EB6ECA, "cobracrash03" },
    { 0x69999762, "cobraflight" },
    { 0x15620A32, "cobrahealth" },
    { 0x02D11C6A, "cobrapilot" },
    { 0xBBA53BE6, "cobrapilot_difficulty" },
    { 0x37508325, "cobrapilot_grunt" },
    { 0x54711DE0, "cobrapilot_shoots_enemies" },
    { 0xEBCF7A31, "cobrapilot_shoots_enemies_cleanup" },
    { 0x5C21DF72, "cobrapilot_spawn" },
    { 0x58B4A75F, "cobrapilot_think" },
    { 0x2A942556, "cobrapilot_wave" },
    { 0x92CD686B, "cobras" },
    { 0x9381EEBC, "cobrastreets" },
    { 0xF2EF4F92, "cobrastreets_crewchief_think" },
    { 0x338E4714, "cobrastreets_instakill" },
    { 0x92E72D9F, "cobrastreets_kill" },
    { 0x670F462B, "cobratarget" },
    { 0x990AD1BB, "cobratarget_add" },
    { 0x3E7EC05F, "cobratarget_check_missilelock_air" },
    { 0x3205AA0A, "cobratarget_check_missilelock_all" },
    { 0x1535525C, "cobratarget_check_missilelock_ground" },
    { 0x43EFFEB0, "cobratarget_death" },
    { 0xFDF4B3C5, "cobratarget_holdlock_missilelock_air" },
    { 0x73FD23EA, "cobratarget_holdlock_missilelock_ground" },
    { 0x7A2A5D5F, "cobratarget_holdwait_missilelock_air" },
    { 0x9D43515C, "cobratarget_holdwait_missilelock_ground" },
    { 0x0FF644EF, "cobratarget_holdwait_missilelock_sound_start" },
    { 0x99B27345, "cobratarget_holdwait_missilelock_sound_stop" },
    { 0x742A7C5E, "cobratarget_islockingon" },
    { 0x04CF6732, "cobratarget_remove" },
    { 0x56FEF407, "cobratarget_sidewinder_has_target" },
    { 0x69D60AEE, "cobratarget_sidewinder_reticlelockon_start" },
    { 0xD83A750E, "cobratarget_sidewinder_reticlelockon_stop" },
    { 0x9881E78B, "cobratarget_unlockalltargets" },
    { 0xA3194222, "cobratarget_updateshader" },
    { 0x14134A69, "cobratarget_updateshaders_all" },
    { 0xAF7235DE, "cobratargetexcluders" },
    { 0x84B2573C, "cobraweapon" },
    { 0xDF51CC5F, "cobrawingman" },
    { 0x5940A20F, "cobrawingman2" },
    { 0xF6C7F3A3, "cocaine" },
    { 0x327A0791, "cocaine_brick" },
    { 0x781C6066, "cocaine_fog" },
    { 0xA54DE902, "cocaine_max_distance" },
    { 0x485D454F, "cocaine_screen_fade" },
    { 0xF0C052B0, "cocaine_vision_setup" },
    { 0xB6788D8B, "cocaine_vision_think" },
    { 0x60D06BAB, "cockney" },
    { 0x708ECDE0, "cockpit" },
    { 0x4E44BF4D, "cockpit_decals" },
    { 0x02FE49C1, "cockpit_idle" },
    { 0xAF7AAFD9, "cockpit_models" },
    { 0x2F6350AF, "cockpit_pullback" },
    { 0x8AE698EF, "cockpit_throttle" },
    { 0x6BFCDC66, "cocksucker" },
    { 0xD1B907E7, "cocktail" },
    { 0x4CFC4E65, "coconuts" },
    { 0xF7023D82, "cocoon" },
    { 0xA0BAB495, "cocooned" },
    { 0xC139887D, "cod" },
    { 0x2467BBCE, "cod1" },
    { 0xFE654165, "cod2" },
    { 0xD862C6FC, "cod3" },
    { 0xB2604C93, "cod4" },
    { 0x8C5DD22A, "cod5" },
    { 0x4058DD58, "cod7" },
    { 0x4196081A, "cod_finished" },
    { 0x4925C0DD, "cod_fog_bank" },
    { 0x89C2EE65, "codcaster" },
    { 0x6C5A6ED7, "codcaster_keyline_enable" },
    { 0xACD4C5DA, "code" },
    { 0xFAD05BB2, "code_classname" },
    { 0x9C8BFE9E, "code_face_enemy_dist" },
    { 0xF8CF7923, "code_mod" },
    { 0x74903C8E, "code_move" },
    { 0x4AD1BF97, "code_post_gfx" },
    { 0xDEF23B86, "codecall" },
    { 0x5A7E708E, "codecallback_activateexploder" },
    { 0xB89CFE24, "codecallback_actorcloned" },
    { 0x331F043E, "codecallback_actordamage" },
    { 0xD73F0C3E, "codecallback_actorkilled" },
    { 0xF951C605, "codecallback_actorshouldreact" },
    { 0x4449C9FD, "codecallback_actorspawned" },
    { 0x6258E7F7, "codecallback_airsupport" },
    { 0x8F1ED665, "codecallback_argusnotify" },
    { 0xE7BDF0A0, "codecallback_botentereduseredge" },
    { 0x70AA2C36, "codecallback_callclientscript" },
    { 0xE22FA2D1, "codecallback_callclientscriptonlevel" },
    { 0x99529282, "codecallback_callserverscript" },
    { 0xC0E00E7D, "codecallback_callserverscriptonlevel" },
    { 0x14095578, "codecallback_challengecomplete" },
    { 0xD38FF4F0, "codecallback_chargeshotweaponsoundnotify" },
    { 0x13924BF9, "codecallback_clientflag" },
    { 0x34132032, "codecallback_clientflagasval" },
    { 0x97362429, "codecallback_collectibleschanged" },
    { 0xAC0B9893, "codecallback_creatingcorpse" },
    { 0x345648E7, "codecallback_deactivateexploder" },
    { 0xD7B7A04D, "codecallback_dec20message" },
    { 0xD75726B4, "codecallback_decoration" },
    { 0xAC25795F, "codecallback_demojump" },
    { 0xC484B9AC, "codecallback_demoplayerswitch" },
    { 0xE6244A90, "codecallback_destructibleevent" },
    { 0xC94EE3C4, "codecallback_disconnectedduringload" },
    { 0xB58E0E36, "codecallback_dogsoundnotify" },
    { 0x1C946F2D, "codecallback_entityshutdown" },
    { 0x658B836F, "codecallback_entityspawned" },
    { 0x6913A8E7, "codecallback_extracamrendercharacterbodyitem" },
    { 0x2ED89511, "codecallback_extracamrendercharacterheaditem" },
    { 0xD1674DA0, "codecallback_extracamrendercharacterhelmetitem" },
    { 0x827CB99A, "codecallback_extracamrendercurrentheroheadshot" },
    { 0x648B2BD5, "codecallback_extracamrenderhero" },
    { 0x07E26B5E, "codecallback_extracamrenderlobbyclienthero" },
    { 0x3D7F6850, "codecallback_extracamrenderoutfitpreview" },
    { 0x9363AA55, "codecallback_extracamrenderwcpaintjobicon" },
    { 0xEC882A49, "codecallback_extracamrenderwcvarianticon" },
    { 0xB05486D8, "codecallback_faceeventnotify" },
    { 0x0094D329, "codecallback_fadeblackscreen" },
    { 0x2F55CFF4, "codecallback_finalizeinitialization" },
    { 0x3C1A7917, "codecallback_gadgetvisionpulse_reveal" },
    { 0x55ACA280, "codecallback_gibevent" },
    { 0xAD25BD72, "codecallback_glasssmash" },
    { 0x566D6E6A, "codecallback_gunchallengecomplete" },
    { 0x4E914CD8, "codecallback_hostmigration" },
    { 0xB380737F, "codecallback_hostmigrationsave" },
    { 0x64461AF2, "codecallback_killcambegin" },
    { 0x4509B906, "codecallback_killcamend" },
    { 0xB13AFAA8, "codecallback_launchsidemission" },
    { 0xD91FF55A, "codecallback_localclientchanged" },
    { 0xBE76DA88, "codecallback_localclientconnect" },
    { 0x4D2792D4, "codecallback_localclientdisconnect" },
    { 0xC6742594, "codecallback_localclientshutdown" },
    { 0x8A01AE8D, "codecallback_maprestart" },
    { 0xF321F903, "codecallback_medal" },
    { 0xCDCDD0B4, "codecallback_menumessage" },
    { 0x29617602, "codecallback_menuresponse" },
    { 0x666E5A06, "codecallback_migration_setupgametype" },
    { 0x75855E8F, "codecallback_onaddplayerstat" },
    { 0xFAA796B4, "codecallback_onaddweaponstat" },
    { 0x92F4B940, "codecallback_playaifootstep" },
    { 0x3BAA0A75, "codecallback_playcustomtraversal" },
    { 0x657088A5, "codecallback_playerconnect" },
    { 0x158695A6, "codecallback_playerdamage" },
    { 0x246A8E7B, "codecallback_playerdisconnect" },
    { 0x6B2594EA, "codecallback_playerfoliage" },
    { 0x64DAD2EB, "codecallback_playerfootstep" },
    { 0xA610F99D, "codecallback_playerjump" },
    { 0x58BEFED6, "codecallback_playerkilled" },
    { 0x07A72D2A, "codecallback_playerland" },
    { 0x720DBDE7, "codecallback_playerlaststand" },
    { 0xB56A3EFF, "codecallback_playermelee" },
    { 0xD79E319C, "codecallback_playermigrated" },
    { 0x49BC048E, "codecallback_playerrevive" },
    { 0xB0BF7CD5, "codecallback_playerspawned" },
    { 0x9187FD39, "codecallback_playerswitch" },
    { 0xB5FF8951, "codecallback_playlightloopexploder" },
    { 0x14721E8B, "codecallback_playweapondamageeffects" },
    { 0x25849824, "codecallback_playweapondeatheffects" },
    { 0x9C6701DF, "codecallback_precachegametype" },
    { 0x7F89F59A, "codecallback_prehostmigrationsave" },
    { 0xCB755575, "codecallback_preinitialization" },
    { 0xAA8D0863, "codecallback_rankup" },
    { 0xBCE3B0A3, "codecallback_saverestored" },
    { 0x26E3593F, "codecallback_serversceneinit" },
    { 0x49EF0FA3, "codecallback_serversceneplay" },
    { 0xFD71AD29, "codecallback_serverscenestop" },
    { 0xF39F3BEC, "codecallback_setactivecybercomability" },
    { 0x08F9D5C8, "codecallback_soundnotify" },
    { 0xA963BFD7, "codecallback_soundplayuidecodeloop" },
    { 0x915AC250, "codecallback_soundsetaiambientstate" },
    { 0x93B17DA6, "codecallback_soundsetambientstate" },
    { 0x3E2FCF68, "codecallback_startgametype" },
    { 0x1B8B7051, "codecallback_statechange" },
    { 0x6D2B285B, "codecallback_stoplightloopexploder" },
    { 0x6C24C560, "codecallback_suimessage" },
    { 0x75CD83B3, "codecallback_updatespawnpoints" },
    { 0x8D618209, "codecallback_vehicledamage" },
    { 0x6B913A11, "codecallback_vehiclekilled" },
    { 0xD660F89F, "codecallback_vehicleradiusdamage" },
    { 0x7BDAC1B4, "codecallback_vehiclespawned" },
    { 0x448624E2, "codeconstname" },
    { 0x13FBA52A, "coded" },
    { 0xFEC13903, "codefix" },
    { 0x13CF9EB9, "codegetclientfield" },
    { 0xF357BB27, "codegetplayerstateclientfield" },
    { 0xEB96CD82, "codegetuimodelclientfield" },
    { 0x600A5665, "codegetworldclientfield" },
    { 0x66667728, "codeimagename" },
    { 0xA4158394, "codeincrementclientfield" },
    { 0x35D4B2B8, "codeincrementplayerstateclientfield" },
    { 0x3A751559, "codeincrementuimodelclientfield" },
    { 0x162B4F86, "codeincrementworldclientfield" },
    { 0xD83EC960, "codelocalplayer" },
    { 0x2E5BE14B, "codeplayloopedfx" },
    { 0x47B7F91F, "codepredictcmd" },
    { 0xFFD8F36C, "coder" },
    { 0x01EA96BD, "coder_mod" },
    { 0xBFC8616F, "coders" },
    { 0x25DB6DD5, "codes" },
    { 0x9E5D824E, "codes_to_check" },
    { 0x672188C0, "codes_uploaded" },
    { 0xF285E75C, "codescripted" },
    { 0x50CD6C4E, "codescripts" },
    { 0xAB6D39B5, "codesetclientfield" },
    { 0xC3956143, "codesetplayerstateclientfield" },
    { 0x69AFE676, "codesetuimodelclientfield" },
    { 0x71AF1C79, "codesetworldclientfield" },
    { 0x39839687, "codespawn" },
    { 0x128D53D8, "codespawncb" },
    { 0x24A88DB8, "codespawnerforcespawn" },
    { 0x37DC1937, "codespawnerspawn" },
    { 0xB2B842E1, "codespawnfx" },
    { 0x5BB4075D, "codespawnturret" },
    { 0xA62CE605, "codespawnvehicle" },
    { 0x5C9E99EE, "codeword" },
    { 0x5C19B0EB, "coding" },
    { 0xE04CDBF4, "codpoints" },
    { 0x418E1F84, "codpointsaftersidebet" },
    { 0x1846C294, "codpointscap" },
    { 0x7FBC8BAF, "codpointscapped" },
    { 0x4E39954B, "codpointschallengescale" },
    { 0x43697A64, "codpointsearnedforrank" },
    { 0xE0ACB86C, "codpointsmatchbonus" },
    { 0xC1745E43, "codpointsmatchscale" },
    { 0x9364C56A, "codpointsxpscale" },
    { 0x08B82B17, "codww" },
    { 0x74F282C6, "cody" },
    { 0x518D8709, "coffee" },
    { 0x8E4E25A4, "coil" },
    { 0xBAE509D7, "coils" },
    { 0xDA531A76, "coin" },
    { 0x24A7FDD0, "coin_toss" },
    { 0x2F6A5963, "coincide" },
    { 0xD2C92EE7, "cointoss" },
    { 0xB3F9D563, "coke" },
    { 0x217A2986, "coke_bundle" },
    { 0x97E113B2, "coke_bundle_destroyed" },
    { 0xDA52F1A4, "coke_vision_fade_in_and_out" },
    { 0xD43961EA, "coke_vision_retrigger" },
    { 0x0365EC29, "coke_worker_died" },
    { 0xEAECCC0A, "coke_worker_run_away_and_die" },
    { 0xF14D5BC5, "col" },
    { 0x9C3BF066, "col1" },
    { 0x3B34771B, "col1diff" },
    { 0x28479D4A, "col1x" },
    { 0x763975FD, "col2" },
    { 0xC14725CC, "col2diff" },
    { 0x09D7DDAF, "col2x" },
    { 0x5036FB94, "col3" },
    { 0x2A34812B, "col4" },
    { 0x043206C2, "col5" },
    { 0xC3D8EB18, "col_brush" },
    { 0x1D0ADB22, "col_brush_name" },
    { 0x00864E30, "col_map_sp" },
    { 0xBB75AF96, "cola" },
    { 0x8A03265A, "colapse" },
    { 0xEF1C456B, "colapsing" },
    { 0x496E405B, "cold" },
    { 0x34239E7C, "cold_breath" },
    { 0x09B93514, "coler" },
    { 0x818E8C73, "colidecircle" },
    { 0x827C3DA4, "colin" },
    { 0xE127E7F7, "colindex" },
    { 0x27EBBC0C, "colinear" },
    { 0x1DE4107D, "colision" },
    { 0x74EBADE5, "coll_model" },
    { 0xE8B641FD, "coll_struct" },
    { 0x1650113A, "coll_vector_length" },
    { 0xC0A93693, "collaborate" },
    { 0xFBDA2816, "collaborating" },
    { 0x6B62F940, "collaboration" },
    { 0x090BE2D0, "collaborators" },
    { 0x9D4A436C, "collapes" },
    { 0xD3FA654C, "collapse" },
    { 0xB1037190, "collapse_door_and_load_area" },
    { 0x64A9309A, "collapse_guy_gun_remove" },
    { 0xE85E4A49, "collapse_roof" },
    { 0x727974E8, "collapse_time" },
    { 0x62788A8A, "collapse_vo" },
    { 0x72DC0F9E, "collapse_vox_said" },
    { 0xA8117460, "collapsed" },
    { 0x4133C66E, "collapsefx" },
    { 0xC4801361, "collapsemenu" },
    { 0x124A73CF, "collapses" },
    { 0x95AA6F5F, "collapsetime" },
    { 0x95AB28F5, "collapsing" },
    { 0x99AD03E4, "collapsing_bridge_init" },
    { 0x63015D84, "collapsing_catwalk_init" },
    { 0x01D7B2D9, "collapsing_holes" },
    { 0x293220A2, "collapsing_holes_init" },
    { 0x7F8455A4, "collapsing_platform_watcher" },
    { 0x7756B9D2, "collateral" },
    { 0x0D95A313, "collateral_damage_e5" },
    { 0x0186E35A, "collbox" },
    { 0x43EB80A1, "collect" },
    { 0x16118DF5, "collect_all" },
    { 0xD0B6B0C5, "collectable" },
    { 0x82693054, "collectables" },
    { 0x7CB0908E, "collected" },
    { 0x29D45B7E, "collected_all" },
    { 0x71CDD4FD, "collectible" },
    { 0xF94052A4, "collectible_achievement_unlock" },
    { 0x9B70595A, "collectible_aquire_unlock" },
    { 0x4D4E3F8E, "collectible_coop_found" },
    { 0xF36194FC, "collectible_corpse" },
    { 0xBE7202A4, "collectible_corpse_spawn" },
    { 0xD472D6B7, "collectible_dvar" },
    { 0x58F22BEB, "collectible_get_unlock" },
    { 0x8250F76B, "collectible_get_unlock_message" },
    { 0x7C204CF1, "collectible_get_unlock_value" },
    { 0x90E78C38, "collectible_has_been_found" },
    { 0x26D19216, "collectible_init" },
    { 0x1817CCCD, "collectible_item" },
    { 0x1166C5FC, "collectible_keys" },
    { 0x3EC33329, "collectible_name" },
    { 0xC1D6308D, "collectible_remove_found" },
    { 0x40D875A0, "collectible_save_restored" },
    { 0x5CA96BDC, "collectible_table" },
    { 0xB9629243, "collectible_table_key_col" },
    { 0x6B6980A0, "collectible_table_unlock_col" },
    { 0xE4279F3E, "collectible_thunder" },
    { 0x59007E17, "collectible_unlocks" },
    { 0x1DC10093, "collectible_value" },
    { 0x11F35DDA, "collectible_vampire" },
    { 0x802CDA42, "collectible_wait_for_pickup" },
    { 0x78E7435E, "collectiblenotify" },
    { 0xD275CEBC, "collectibles" },
    { 0xA9AEA5C0, "collectibles_berserker_mode_on" },
    { 0xAE402502, "collectibles_checkpoint_restore" },
    { 0x62415F99, "collectibles_level_challenge" },
    { 0x351CA1E8, "collectibles_level_restore" },
    { 0x6E29520C, "collectibles_start_num" },
    { 0x7217384B, "collectiblesarray" },
    { 0xA8C70767, "collecting" },
    { 0xF98D835D, "collection" },
    { 0x5A43BFBE, "collector" },
    { 0xE9D487DC, "collector_achievement_weapons" },
    { 0x799E8048, "collects" },
    { 0xFEA3B08C, "collectweaponpings" },
    { 0xF0FD3144, "college" },
    { 0x430AD6C9, "collide" },
    { 0xAB69552F, "collided" },
    { 0x413055C0, "collides" },
    { 0xE8D80CFC, "colliding" },
    { 0xB709FED6, "collin" },
    { 0x71177273, "collision" },
    { 0xF4BF0A10, "collision1" },
    { 0x3845E380, "collision10" },
    { 0x5E485DE9, "collision11" },
    { 0x6FD742C2, "collision11a" },
    { 0x844AD852, "collision12" },
    { 0x7A24509F, "collision12a" },
    { 0xAA4D52BB, "collision13" },
    { 0x6D060F18, "collision13a" },
    { 0xD04FCD24, "collision14" },
    { 0x77531CF5, "collision14a" },
    { 0x9D55975E, "collision14b" },
    { 0xF652478D, "collision15" },
    { 0x6A34DB6E, "collision15a" },
    { 0x1C54C1F6, "collision16" },
    { 0x42573C5F, "collision17" },
    { 0x6859B6C8, "collision18" },
    { 0x8E5C3131, "collision19" },
    { 0x3F0E9EB9, "collision1a" },
    { 0x65111922, "collision1b" },
    { 0x8B13938B, "collision1c" },
    { 0x66C6794B, "collision2" },
    { 0xB5494A81, "collision20" },
    { 0x8F46D018, "collision21" },
    { 0x014E3F53, "collision22" },
    { 0xDB4BC4EA, "collision23" },
    { 0x4D533425, "collision24" },
    { 0xAE808F48, "collision2a" },
    { 0x2087FE83, "collision2b" },
    { 0xFA85841A, "collision2c" },
    { 0x40C3FEE2, "collision3" },
    { 0x3C3D6B0F, "collision3a" },
    { 0xCA35FBD4, "collision3b" },
    { 0xB2CB6E1D, "collision4" },
    { 0xAE29C49E, "collision4a" },
    { 0x88274A35, "collision4b" },
    { 0x8CC8F3B4, "collision5" },
    { 0x396C3765, "collision5a" },
    { 0x5F6EB1CE, "collision5b" },
    { 0x85712C37, "collision5c" },
    { 0x7B5FD358, "collision5d" },
    { 0xFED062EF, "collision6" },
    { 0x4FE6D403, "collision6_debris" },
    { 0xAB5890F4, "collision6a" },
    { 0x1D60002F, "collision6b" },
    { 0xF75D85C6, "collision6c" },
    { 0xD8CDE886, "collision7" },
    { 0xB876D27B, "collision7a" },
    { 0x4AD557C1, "collision8" },
    { 0xA8875D4A, "collision8a" },
    { 0x24D2DD58, "collision9" },
    { 0x926AAB9F, "collision_avoid_time" },
    { 0x0795E296, "collision_chain_reaction_hanger_effects" },
    { 0xF4CD518C, "collision_chain_reaction_hanger_effects_new_version" },
    { 0xCBD28030, "collision_cooldown_ms" },
    { 0x0A09E455, "collision_damage" },
    { 0x94B9EA73, "collision_dir" },
    { 0xADD9D853, "collision_dot" },
    { 0xCD46EAAE, "collision_fail" },
    { 0x8E39DF93, "collision_feedback_ready" },
    { 0xC68D8534, "collision_feedback_time_last" },
    { 0xF21EE474, "collision_filter_damage" },
    { 0x843F1C6C, "collision_fx" },
    { 0xA0DF3B22, "collision_list" },
    { 0xF4377355, "collision_model" },
    { 0xD0133FFE, "collision_results_s" },
    { 0xF1D95FF2, "collision_sounds" },
    { 0x02A4C896, "collision_speed_min" },
    { 0xF4A468E3, "collision_test_point_in_box" },
    { 0x212D2591, "collision_test_point_in_cone" },
    { 0xB3DE2A82, "collision_test_point_in_cylinder" },
    { 0x42168CD9, "collision_test_point_in_pill" },
    { 0xA91B34F7, "collision_test_point_in_sphere" },
    { 0xB1BA2C10, "collision_test_points_in_box" },
    { 0x6D821268, "collision_test_points_in_cone" },
    { 0x8209836F, "collision_test_points_in_cylinder" },
    { 0xE3C34BEC, "collision_test_points_in_pill" },
    { 0x80D5962E, "collision_test_points_in_sphere" },
    { 0x7E8D5172, "collision_think" },
    { 0xDDA6F1FA, "collision_thread" },
    { 0x6612B085, "collisione1" },
    { 0x8C152AEE, "collisione2" },
    { 0xB217A557, "collisione3" },
    { 0xA8064C78, "collisione4" },
    { 0xCE08C6E1, "collisione5" },
    { 0xF40B414A, "collisione6" },
    { 0x609A8585, "collisionhandler" },
    { 0xCB0EB98A, "collisionnormal" },
    { 0xC1629922, "collisions" },
    { 0xD1A20A05, "collisiontestpointsincylinder" },
    { 0x9D12B640, "collisiontestpointsinsphere" },
    { 0xA4015AB7, "collmap" },
    { 0xC43F5558, "collsion" },
    { 0xD1732B65, "colmap" },
    { 0xCBBCD474, "colmaps" },
    { 0xE584223C, "colonel_kurtz" },
    { 0xD900369A, "color" },
    { 0x14DF00BE, "color0" },
    { 0x3AE17B27, "color1" },
    { 0xC8DA0BEC, "color2" },
    { 0xE485E316, "color_armed" },
    { 0x0254779E, "color_before_noharper_claw" },
    { 0xA9AEC768, "color_chain" },
    { 0xD7B46443, "color_chain3" },
    { 0x43FDCF9B, "color_chain_approach" },
    { 0x3118F7A9, "color_chain_cleanup" },
    { 0x8877B2C6, "color_chain_cleanup_2" },
    { 0xE90E5EC6, "color_chains_near_tanks" },
    { 0xBEED926F, "color_cold" },
    { 0x29045736, "color_cool_green" },
    { 0x102930E6, "color_cool_green_glow" },
    { 0x251A3136, "color_count" },
    { 0x51CA5BEE, "color_debug" },
    { 0x049C7858, "color_enabled" },
    { 0x599D5F0A, "color_failed" },
    { 0x07B6474E, "color_first_hallway_1" },
    { 0xE1B3CCE5, "color_first_hallway_2" },
    { 0x17364995, "color_fixed_node_radius" },
    { 0x9CAE7BD4, "color_force_goal" },
    { 0x7BAB5E54, "color_friendlies" },
    { 0xF4354D73, "color_glass_room" },
    { 0x34D88ACE, "color_hot" },
    { 0xC711005A, "color_id" },
    { 0x54160048, "color_is_dirty" },
    { 0x6234DAD9, "color_lightning_guy" },
    { 0x486B4154, "color_manager_debug_aigroup" },
    { 0x0292A1D8, "color_manager_debug_color_triggered" },
    { 0x85B6BD61, "color_manager_debug_kill_delay" },
    { 0xA58C40B8, "color_manager_debug_wait_aigroup" },
    { 0xA2F4D20E, "color_manager_get_next_color_trigger_state" },
    { 0xF9975B11, "color_manager_initialized" },
    { 0xC94C90C7, "color_manager_kill_spawners" },
    { 0x6E75AE43, "color_manager_think" },
    { 0xED1EDEF5, "color_manager_think_internal" },
    { 0x200CF843, "color_manager_track_ai_group" },
    { 0x2C9C4B5F, "color_manager_track_flag" },
    { 0x547A514A, "color_moderate" },
    { 0x4BF17A39, "color_node" },
    { 0x672DE5EF, "color_node_big_radius" },
    { 0x3EA13A61, "color_node_debug_val" },
    { 0xEE90A726, "color_node_finds_a_user" },
    { 0x1C1F8CCD, "color_node_finds_user_for_colorcode" },
    { 0x83EF2EF5, "color_node_finds_user_from_colorcodes" },
    { 0x3BFA4A28, "color_node_trigger" },
    { 0xE50CEDA7, "color_node_type_function" },
    { 0xE8565597, "color_only" },
    { 0x5710F92F, "color_order" },
    { 0x91B6DD25, "color_ordered_node_assignment" },
    { 0x9713BAF5, "color_passed" },
    { 0x55827E59, "color_repaired" },
    { 0xB64AD21A, "color_second_hallway" },
    { 0x3640DF55, "color_severe" },
    { 0xBC9231AA, "color_sound_selector" },
    { 0xE1C105E2, "color_spawners" },
    { 0x6C64AD4F, "color_sprint_to_goal" },
    { 0x0E9E532E, "color_team" },
    { 0xA04A528B, "color_trig" },
    { 0x76C1DECE, "color_trig_cleanup" },
    { 0x5F5EFB27, "color_trigger" },
    { 0x504E199E, "color_triggers" },
    { 0xF1EA47DA, "color_tween" },
    { 0x0CA0F86D, "color_unarmed" },
    { 0xBA758370, "color_user" },
    { 0x488E64DB, "color_users" },
    { 0xA1A15FE2, "color_warm" },
    { 0x7F0D8C85, "colorarray" },
    { 0x4463CBDD, "coloration" },
    { 0x8277DC52, "colorblue" },
    { 0x465F88EE, "colorchecklist" },
    { 0xA727B6B9, "colorcode" },
    { 0xB57C763F, "colorcoded" },
    { 0x7F8BC01B, "colorcoded_volumes" },
    { 0x0B92C3F0, "colorcodes" },
    { 0x058CDB44, "colorcodesbycolorindex" },
    { 0xDD60AAB2, "colorcodestring" },
    { 0x3BFE0F8B, "colordebug" },
    { 0x47B2FE3A, "colordeltapertime" },
    { 0x977D85E7, "colordissolve" },
    { 0x051B0E83, "colordissolveamount" },
    { 0x5C2CB52D, "colored" },
    { 0x50E004B5, "colored_friendlies" },
    { 0xBE4B85EE, "colored_ordered_node_assignment" },
    { 0x8C9D90AB, "colorgreen" },
    { 0xC454AF6A, "colorguys" },
    { 0x51C41C06, "colorindex" },
    { 0xC9CB18D6, "coloring" },
    { 0xEB17CBC9, "colorislegit" },
    { 0xEF233B7E, "colorlist" },
    { 0x8474F227, "colorname" },
    { 0x6D32BD9E, "colornode" },
    { 0x5808E12A, "colornode_replace_on_death" },
    { 0xF26EB6B4, "colornode_spawn_reinforcement" },
    { 0x38BEF852, "colornode_triggers" },
    { 0x7F54F901, "colornodes" },
    { 0xE2B79E8E, "colornodes_debug_ai" },
    { 0x7BED22B3, "colornodes_debug_array" },
    { 0x2117975A, "colornodes_intro" },
    { 0xE3C2F891, "colornumber" },
    { 0xFD61C660, "colornumberarray" },
    { 0xC89E6EDA, "coloroverride" },
    { 0x6DE20C0F, "colorred" },
    { 0x6F7B2095, "colors" },
    { 0x09EB5D4B, "colors_barn" },
    { 0x3720EBB6, "colors_go_line_done" },
    { 0xA52A175F, "colors_shared" },
    { 0xAE084489, "colors_trigger_0" },
    { 0x8805CA20, "colors_trigger_1" },
    { 0xFA0D395B, "colors_trigger_2" },
    { 0xD40ABEF2, "colors_trigger_3" },
    { 0x6F15F34E, "colorslot" },
    { 0x4DB28D15, "colorteam" },
    { 0x776218AB, "colortintvaluew" },
    { 0xF37AE0C5, "colortintvaluey" },
    { 0x197D5B2E, "colortintvaluez" },
    { 0xE9A89F10, "colortrig" },
    { 0x663F8C6D, "colorvalue" },
    { 0x190C23EF, "colorvector" },
    { 0x3173C00A, "colossus" },
    { 0x04EF8B8D, "colour" },
    { 0x3C949E19, "colspace" },
    { 0x2D1B51B9, "colspan" },
    { 0xA995E6EB, "colt" },
    { 0xD7A4AF42, "colt45" },
    { 0xB0F9CA86, "colt_victim" },
    { 0xC95CC3C7, "column" },
    { 0xB932B005, "column_header" },
    { 0x31E51B9E, "column_index" },
    { 0x468C7739, "columnindex" },
    { 0x4395685A, "columnname" },
    { 0x52343CB6, "columnoffset" },
    { 0x48F51EBE, "columns" },
    { 0x3B643302, "colums" },
    { 0xCB4AE15C, "com" },
    { 0xA41AE17F, "com_01a" },
    { 0xBB1747A6, "com_01a_render" },
    { 0x32137244, "com_01b" },
    { 0x05D18A23, "com_01b_render" },
    { 0x2D8DFA49, "com_02" },
    { 0xC17BE52C, "com_02_render" },
    { 0xD51D2B7E, "com_barrel_fire" },
    { 0x224FCFD7, "com_door_01_handleleft" },
    { 0xE5326C27, "com_fire_extinguisher" },
    { 0x69489A4F, "com_gamemodes" },
    { 0xD02CEF50, "com_milk_carton" },
    { 0x5A858496, "com_pail_metal1" },
    { 0xFE10696C, "com_pan_copper" },
    { 0xEB3C5041, "com_pipe_4_coupling_ceramic" },
    { 0x8109CFD7, "com_pipe_coupling_metal" },
    { 0x6F2D29F2, "com_plastic_bucket" },
    { 0x566FB1FC, "com_pot_metal" },
    { 0x118F9F39, "com_propane_tank" },
    { 0xEE7C10B5, "com_soup_can" },
    { 0xF19A5B71, "com_tires01_burning" },
    { 0xCFFB1E45, "comandeer" },
    { 0xF1A0C195, "combat" },
    { 0xAD50990E, "combat_animmode" },
    { 0xF3952DC9, "combat_announce_lock" },
    { 0x6906377F, "combat_announce_locking" },
    { 0x861A63BA, "combat_announce_locktimeout" },
    { 0x61DF5F68, "combat_announce_unlock" },
    { 0x4F953D30, "combat_announce_unlocking" },
    { 0xBF845FDB, "combat_dismount" },
    { 0xA235CD0F, "combat_efficiency_factor" },
    { 0x481EE088, "combat_efficiency_power_loss_scalar" },
    { 0xE35F8EFA, "combat_goal_volume" },
    { 0x36F4A13E, "combat_idle" },
    { 0x53BB92FC, "combat_jog" },
    { 0x551A479F, "combat_mount" },
    { 0x86BF83C9, "combat_restart" },
    { 0x0239C2E0, "combat_robot" },
    { 0x07EAF3BA, "combat_robot_add_x_velocity_max" },
    { 0xCA86E8A4, "combat_robot_add_x_velocity_min" },
    { 0x2BBE4D65, "combat_robot_add_y_velocity_max" },
    { 0x169FA5CB, "combat_robot_add_y_velocity_min" },
    { 0xE73E74CC, "combat_robot_add_z_velocity_max" },
    { 0x222816E2, "combat_robot_add_z_velocity_min" },
    { 0x506687C8, "combat_robot_damage" },
    { 0x35CCD30D, "combat_robot_defend_icon" },
    { 0xA6ACDB3F, "combat_robot_duration" },
    { 0xE3127AEE, "combat_robot_emp_duration" },
    { 0x5433AD74, "combat_robot_forward_spawn_offset" },
    { 0x59D2EDB5, "combat_robot_give_up_on_enemy" },
    { 0x4BBBA57B, "combat_robot_guard_radius" },
    { 0x3A7FC1B8, "combat_robot_ignore_unattackable_enemy" },
    { 0x0E57ED92, "combat_robot_influencer" },
    { 0x9AA9BABA, "combat_robot_killcam_time_offset" },
    { 0x6BF07E0C, "combat_robot_land" },
    { 0x4F38C979, "combat_robot_marker_name" },
    { 0x0E94EE64, "combat_robot_max_shutdown" },
    { 0x400CC2FE, "combat_robot_min_shutdown" },
    { 0x09FF592A, "combat_robot_name" },
    { 0xB67F425E, "combat_robot_nav_mesh_valid_location_boundary" },
    { 0x205B1421, "combat_robot_nav_mesh_valid_location_tolerance" },
    { 0x8AFBC8B9, "combat_robot_shutdown" },
    { 0xC40A06E9, "combat_robot_velocity_scalar" },
    { 0x4FBD5018, "combat_runanim" },
    { 0x7775D351, "combat_say" },
    { 0x191F4091, "combat_strafe" },
    { 0x0C48E7E8, "combat_taco_radius" },
    { 0xF7A55431, "combat_tactical_insertion" },
    { 0x01408013, "combat_target" },
    { 0xA859FD70, "combat_think" },
    { 0xBCC19909, "combat_throw_lethal" },
    { 0x03898A2E, "combat_throw_proximity" },
    { 0x5B3D70AA, "combat_throw_smoke" },
    { 0x2BBE6C14, "combat_throw_tactical" },
    { 0x4E67699E, "combat_toss_flash" },
    { 0x47DA49A4, "combat_toss_frag" },
    { 0x09C530F0, "combat_utility" },
    { 0x4E5B312B, "combatactive" },
    { 0x41FA8106, "combatalertanim" },
    { 0x6C542070, "combatalertanimdeath" },
    { 0xFD0F79EA, "combatalertanimdeathloop" },
    { 0x4E5D2310, "combatant" },
    { 0x3ECD47FB, "combatants" },
    { 0xDE865367, "combatbreaker" },
    { 0x8A143203, "combatefficiencybonus" },
    { 0x66B8395E, "combatefficiencyevent" },
    { 0xBD408006, "combatefficiencylastontime" },
    { 0x746ECA84, "combatefficiencyscore" },
    { 0x6DA73C7F, "combatendtime" },
    { 0x6D3FB4F7, "combatglobals" },
    { 0x6430ED51, "combatglobalsinit" },
    { 0xC2DBE35F, "combatidle" },
    { 0xC4AA48DE, "combatidleend" },
    { 0xB4D95E0F, "combatidlepreventoverlappingplayer" },
    { 0xFD00D4F3, "combatinit" },
    { 0xE032AB56, "combatlightfx1" },
    { 0x677C6A32, "combatlocomotion" },
    { 0x654662B9, "combatlocomotioncondition" },
    { 0xA97481B2, "combatlocomotionstart" },
    { 0xBC605BBD, "combatlocomotionupdate" },
    { 0xD9882618, "combatmemorytimeconst" },
    { 0x0DCFD69E, "combatmemorytimerand" },
    { 0xAEB9EAF0, "combatmode" },
    { 0x7E235587, "combatrobot" },
    { 0x0864F528, "combatrobotdamageoverride" },
    { 0x90EDE466, "combatrobotkillstreakid" },
    { 0x27728F74, "combatrobotowner" },
    { 0x5BF4A57C, "combatrobotteam" },
    { 0x2EE1E0B0, "combatrun" },
    { 0x1C5DF2D6, "combatrun_forward" },
    { 0x9823C5AF, "combatrunanim" },
    { 0xEE313DD2, "combattime" },
    { 0x46E740E6, "combattrainingwins" },
    { 0xB00A7D2C, "combatturn" },
    { 0x72487B82, "combination" },
    { 0xA43F99CD, "combinations" },
    { 0x22770208, "combine" },
    { 0x09BBE651, "combine_buildable_pieces" },
    { 0x26B513D7, "combine_center_building_zones" },
    { 0x5A83796F, "combine_craftable_pieces" },
    { 0x2961EDC3, "combine_hudpoints" },
    { 0x52D9EBF2, "combine_points" },
    { 0xBDF20DD7, "combine_sunlight_and_brightness" },
    { 0x35495468, "combineangles" },
    { 0xC48180D6, "combinearrays" },
    { 0x2112CF1C, "combined" },
    { 0xF0D656DB, "combined_score" },
    { 0x02802D2B, "combinedarray" },
    { 0x12CF2897, "combinedresult" },
    { 0x0E51AB3D, "combinemessage" },
    { 0x452E72BB, "combinemessageandtimer" },
    { 0x9AE8AE23, "combines" },
    { 0x704B3309, "combining" },
    { 0x37A571D5, "combo" },
    { 0xEDE6242E, "combo_death" },
    { 0x5B553524, "combos" },
    { 0x573FE812, "combotime" },
    { 0x74032136, "combust" },
    { 0xB128A1B9, "come" },
    { 0x7BE3D464, "comeback" },
    { 0xD187B4D5, "comeout_on_balcony_guys_setup" },
    { 0x7481D910, "comers" },
    { 0xCB04B4F0, "comes" },
    { 0x67BA6D77, "comfort" },
    { 0x4FDD65AC, "coming" },
    { 0x50F9596A, "coming_back" },
    { 0x70F612B9, "comingfrommenu" },
    { 0x071E866C, "comlink" },
    { 0xE13C7501, "comm" },
    { 0x947C0698, "comm_node" },
    { 0x93E63059, "comm_room_burnt" },
    { 0x875A2760, "comm_station_breach" },
    { 0xAE179D8A, "comma" },
    { 0xDE160664, "command" },
    { 0xC210EEB8, "command_center" },
    { 0x161258E2, "command_parser" },
    { 0x829694CC, "command_parserpitch" },
    { 0xC91FAA84, "command_used" },
    { 0x2C6605C7, "commanded" },
    { 0x3FE92F58, "commandeer" },
    { 0xCB363B6B, "commandeered" },
    { 0xFC7B8440, "commandeering" },
    { 0xA87ECDE1, "commander" },
    { 0x623A1294, "commander_think" },
    { 0x31F71001, "commanderbundle" },
    { 0x1EB560E0, "commandername" },
    { 0x0EBE5088, "commanders" },
    { 0xF9937532, "commandersdead" },
    { 0x040002F9, "commandin" },
    { 0xAAB7DB44, "commanding" },
    { 0xEB83A91B, "commando" },
    { 0xE57E8E84, "commando_acog" },
    { 0xD2CBD9EE, "commando_acog_sp" },
    { 0x448E6448, "commando_strat" },
    { 0xE0CEBC3A, "commandos" },
    { 0x13C90C97, "commands" },
    { 0xB64FF4AF, "commandservosounds" },
    { 0x903B0188, "commence" },
    { 0xD38DBE66, "commence_attack_on_death" },
    { 0xE673E4A3, "commences" },
    { 0xDC71FE89, "commencing" },
    { 0x470D3820, "commendable" },
    { 0x91C8E368, "comment" },
    { 0xEDD12BC2, "commentary" },
    { 0x8AD87D7B, "commented" },
    { 0x384AE930, "commenting" },
    { 0xB82FDE03, "comments" },
    { 0x5A50C028, "commisar" },
    { 0xFDEA6A95, "commissar" },
    { 0xE2165106, "commissar_action" },
    { 0x5028BCF4, "commissar_spawner" },
    { 0x34249536, "commission" },
    { 0x68D7EE52, "commit" },
    { 0xDA42BBC1, "commit_spawn_data" },
    { 0x3941250C, "commit_weapon_data" },
    { 0x5860A45D, "commits" },
    { 0xF7B2E459, "commitsave" },
    { 0x097843BF, "commitspawndata" },
    { 0x25AE89C2, "commitweapondata" },
    { 0xE499EBC2, "common" },
    { 0x26766013, "common_abort_box" },
    { 0xACA7D7F7, "common_context_action" },
    { 0xA24B7C10, "common_context_run" },
    { 0x612FBE67, "common_context_start" },
    { 0x1771BC32, "common_context_update" },
    { 0xC410281B, "common_destructible" },
    { 0x5C7600E3, "common_door_breach" },
    { 0x7B05E2A5, "common_event_startup" },
    { 0x6BB5C928, "common_move_to_box" },
    { 0x3B841722, "common_move_to_courtyard" },
    { 0x1420B030, "common_move_to_maze" },
    { 0xE4DAABDB, "common_move_to_table" },
    { 0xB16FAEF8, "common_mp_weapons" },
    { 0x9A63A61A, "common_precache" },
    { 0xE8F6BB27, "common_scripts" },
    { 0x3B401DEF, "commonly" },
    { 0xA4EEE8B2, "commononspawnuseweaponobject" },
    { 0x9804AF60, "commononspawnuseweaponobjectproximityalarm" },
    { 0x68A2627A, "commotion" },
    { 0x01EB0228, "comms" },
    { 0x5F61D92A, "comms_building_cleared" },
    { 0x636276A1, "comms_building_door_open" },
    { 0xD044B605, "comms_building_roof_trig" },
    { 0xD9317B10, "comms_building_trig" },
    { 0x4BD8D626, "comms_clear" },
    { 0x708062B9, "comms_close" },
    { 0x3B6E052F, "comms_contextual_melee_watch" },
    { 0x48E31F33, "comms_damage_monitor" },
    { 0x2E823544, "comms_destroyed" },
    { 0x4C23A58D, "comms_door_ent" },
    { 0xF35DF6B8, "comms_door_shut" },
    { 0x9DF3D677, "comms_east_north_node" },
    { 0x6FEA3859, "comms_east_south_node" },
    { 0x5139616D, "comms_east_trig" },
    { 0x788EC939, "comms_flr1_blue" },
    { 0xEF04491B, "comms_flr1_blue_anim" },
    { 0x36F8A3DA, "comms_flr1_green" },
    { 0x8493126E, "comms_flr1_green_anim" },
    { 0xF5E983EC, "comms_flr1_green_chair_anim" },
    { 0x13A54FB0, "comms_flr1_green_headphones" },
    { 0xFDD1D145, "comms_flr1_new" },
    { 0x193379E7, "comms_flr1_new_anim" },
    { 0x559DF5B7, "comms_flr1_orange" },
    { 0xF936C93D, "comms_flr1_orange_anim" },
    { 0x165CE571, "comms_flr1_orange_anim_down_stairs" },
    { 0x6754D244, "comms_flr2_blue" },
    { 0x18C8D81C, "comms_flr2_blue_anim" },
    { 0xF4AFD836, "comms_flr2_blue_chair_anim" },
    { 0x152150B9, "comms_flr2_green" },
    { 0x3AB5FF9B, "comms_flr2_green_anim" },
    { 0x97C89B81, "comms_flr2_green_chair_anim" },
    { 0x7954676D, "comms_flr2_green_headphones" },
    { 0xEDDF0A8E, "comms_flr2_orange" },
    { 0x9B853332, "comms_flr2_orange_anim" },
    { 0xA7A1FEDC, "comms_flr2_orange_headphones" },
    { 0x392F94CE, "comms_flr2_purple" },
    { 0x5F8A5672, "comms_flr2_purple_anim" },
    { 0x61115E1C, "comms_flr2_purple_headphones" },
    { 0xEFDE365B, "comms_flr3_blue" },
    { 0x63C573D1, "comms_flr3_blue_anim" },
    { 0xE1B6915F, "comms_flr3_blue_start_trig" },
    { 0x8905E568, "comms_flr3_green" },
    { 0xF3EC3650, "comms_flr3_green_anim" },
    { 0x73492642, "comms_flr3_green_chair_anim" },
    { 0xA543517D, "comms_flr3_orange" },
    { 0x7170556F, "comms_flr3_orange_anim" },
    { 0xA422B57D, "comms_flr3_orange_chair_anim" },
    { 0x751FE4C9, "comms_flr3_orange_headphones" },
    { 0xD3C29D76, "comms_flr4_blue" },
    { 0xD60E920A, "comms_flr4_blue_anim" },
    { 0x2FA35159, "comms_flr4_blue_anim_walk_round_corner" },
    { 0x1472EE78, "comms_flr4_blue_start_trig" },
    { 0xD8CD409F, "comms_flr4_green" },
    { 0x162CAC95, "comms_flr4_green_anim" },
    { 0xD75C0C64, "comms_flr4_orange" },
    { 0x11CF277C, "comms_flr4_orange_anim" },
    { 0x871C850B, "comms_flr4_orange_anim_death" },
    { 0x69E6E7CA, "comms_guard" },
    { 0x3C4BB870, "comms_left" },
    { 0x8BDFF0C6, "comms_music_setup" },
    { 0xAA189D47, "comms_north_east_node" },
    { 0xF0E003D5, "comms_north_trig" },
    { 0xE097EEE5, "comms_north_west_node" },
    { 0xCC685C63, "comms_on_alert" },
    { 0x87894C8B, "comms_open" },
    { 0xC582DEAD, "comms_south_east_node" },
    { 0x219842AF, "comms_south_trig" },
    { 0xCEC842B7, "comms_south_west_node" },
    { 0x674CFBD8, "comms_spawner_roof_sniper" },
    { 0xC32FC2E2, "comms_spawner_roof_sniper_array" },
    { 0x404485E1, "comms_spawner_roof_sniper_ents" },
    { 0x095080EF, "comms_spawner_roofminigame_2_ents" },
    { 0xAA498FD7, "comms_spawner_roofminigame_2_trig" },
    { 0x1BC6C54A, "comms_spawner_roofminigame_ents" },
    { 0x7321DB82, "comms_stop_anim_alert" },
    { 0x3DC4A0B5, "comms_west_north_node" },
    { 0x9EA0DC7B, "comms_west_south_node" },
    { 0x046F623B, "comms_west_trig" },
    { 0x96BA2633, "commstat_weapon_check" },
    { 0x7E3AAAC4, "communicate" },
    { 0x87B0884D, "communicating" },
    { 0x389EAAD3, "communication" },
    { 0xBAA1BE02, "communications" },
    { 0x10F34E10, "communist" },
    { 0x9132F8FB, "communists" },
    { 0x34772A68, "community" },
    { 0xCF472E21, "comp_fail_vox" },
    { 0x4B033B90, "comp_sound" },
    { 0x263F7DBD, "comp_sound_upper" },
    { 0x0180A35F, "compactor" },
    { 0x26BB755D, "companion" },
    { 0x519BC3D2, "company" },
    { 0x9C9B4A6D, "companyyyy" },
    { 0x5FC7522A, "compare" },
    { 0x007960F1, "compare_animtime" },
    { 0x12666275, "compare_dots" },
    { 0x763646AB, "compare_func" },
    { 0xBDF12BC8, "compare_seat_to_pilots" },
    { 0x4E4E7D41, "compare_type" },
    { 0x17CE871A, "compared" },
    { 0x82126FD8, "comparefunc" },
    { 0x43B8C1A1, "compareradioindexes" },
    { 0xE9FD9CE5, "compares" },
    { 0x99418E3C, "comparesizes" },
    { 0x53BB987E, "comparesizesfx" },
    { 0xFB7992F6, "compareteambygamestat" },
    { 0xAD14E8CD, "compareteambyteamscore" },
    { 0x8E798B88, "comparezoneindexes" },
    { 0xD1B1F7FB, "comparing" },
    { 0xFAB334FA, "comparison" },
    { 0x28468687, "comparison1" },
    { 0xB63F174C, "comparison2" },
    { 0x89A5FEEF, "compartment_01" },
    { 0x179E8FB4, "compartment_02" },
    { 0x614226C5, "compartmentalizes" },
    { 0x976395FA, "compartments" },
    { 0xB11C18B7, "compass" },
    { 0x95A88039, "compass_hint" },
    { 0x1DFBC270, "compass_icons" },
    { 0x60BB3FBA, "compass_map_name" },
    { 0xB6E8E35B, "compass_maps" },
    { 0x07C417E8, "compass_reminder" },
    { 0x18FCE12D, "compass_shader" },
    { 0x24DB6775, "compass_value" },
    { 0xAF79AD3F, "compassflashingoverlay" },
    { 0xCB44BE57, "compasshealthoverlay" },
    { 0x3D3CF298, "compassicon" },
    { 0x120EE273, "compassicons" },
    { 0xEC28D7D1, "compassradius" },
    { 0x9ECE751F, "compasstype" },
    { 0x6E21DC6F, "compatibility" },
    { 0x09381AA4, "compatibility_score" },
    { 0x83BEF828, "compatibility_score_needed" },
    { 0x652FB103, "compatible" },
    { 0x0AB0CE55, "compatible_attachment" },
    { 0x1637D2A4, "compatible_attachments" },
    { 0xC0EE47B7, "compeleted" },
    { 0xED1377B4, "compensate" },
    { 0xBA9751A7, "compensates" },
    { 0xF384B783, "compensation" },
    { 0x72CB2308, "compensator" },
    { 0x048B566A, "competition" },
    { 0xBA78C3AA, "competitive" },
    { 0x0274A076, "compilation" },
    { 0x5ADAE86C, "compile" },
    { 0xE2E60DB0, "compile_bonus" },
    { 0x99A41100, "compiled" },
    { 0xDDDA9606, "compiler" },
    { 0xE6C99E15, "compiling" },
    { 0xE6515691, "complacency" },
    { 0x1A8BD8A0, "complain" },
    { 0xFB67324B, "complains" },
    { 0x31CD1834, "complete" },
    { 0x06E056D8, "complete_be_1" },
    { 0x78E7C613, "complete_be_2" },
    { 0xE8E9A3FE, "complete_callback" },
    { 0x6BDDD820, "complete_count" },
    { 0x682FF7F7, "complete_craftable" },
    { 0xC596DFF9, "complete_flag" },
    { 0x5FF8B599, "complete_func" },
    { 0xAAB74B22, "complete_hacking_object" },
    { 0x315159A3, "complete_level" },
    { 0xA140BA21, "complete_me" },
    { 0xD329DEEA, "complete_msg" },
    { 0x7F6BD4C0, "complete_notify" },
    { 0xADB27467, "complete_puzzles1" },
    { 0x3BAB052C, "complete_puzzles2" },
    { 0xE4EEB8B4, "complete_sidequest" },
    { 0x0E972E3F, "complete_signal" },
    { 0x7D773B46, "complete_signals" },
    { 0x4425ED32, "complete_weapon_switch" },
    { 0xC0E548D8, "completed" },
    { 0x4001C9C9, "completed_emerging_into_playable_area" },
    { 0x36497229, "completed_specific_challenge" },
    { 0x7392B9DE, "completed_zone_capture" },
    { 0x951BC4DE, "completedanims" },
    { 0xFC4B5B4E, "completedgame" },
    { 0x4C54CE5F, "completednodes" },
    { 0x6BB58A0B, "completedrevive" },
    { 0xD4400BE4, "completelastshot" },
    { 0x3FFA05F1, "completely" },
    { 0x1BB5E8A2, "completely_shutdown" },
    { 0xCF3530C7, "completely_stopped" },
    { 0xC3846F05, "completeness" },
    { 0x6ACEFB27, "completes" },
    { 0x58DC0CF6, "completetimeinair" },
    { 0xAAD503BD, "completing" },
    { 0xDB248C03, "completion" },
    { 0x0D202EDC, "completion_flag" },
    { 0x685F6035, "completion_notify" },
    { 0x7D718BE8, "completionratio" },
    { 0xEA42203F, "complex" },
    { 0x42300153, "complex_explosion" },
    { 0xD3EAABB1, "complexity" },
    { 0xF8E5C96C, "complicated" },
    { 0xDDE1487C, "compliments" },
    { 0x8F787E1E, "component" },
    { 0xF3230281, "components" },
    { 0x55481373, "compose" },
    { 0x3867467E, "compose_scene" },
    { 0xBF75C20A, "compound" },
    { 0xC2A24087, "compound_alert_patrollers_think" },
    { 0x4462E03B, "compound_breach_bowman_open_door" },
    { 0xCDD3D7A8, "compound_breach_door_open" },
    { 0x42637C04, "compound_contextual_enemy_think" },
    { 0xF333CE8E, "compound_convoy_think" },
    { 0x13C279FB, "compound_door_breach" },
    { 0x17572956, "compound_door_breach_bowman" },
    { 0xC71FCDB8, "compound_door_breach_woods" },
    { 0x1B3C4C9F, "compound_door_opened" },
    { 0xFABE3B5B, "compound_entrance_veh" },
    { 0x7D020181, "compound_friendly_movement_think" },
    { 0xEF3C2ECE, "compound_gates_close" },
    { 0x670EB4CA, "compound_gates_open" },
    { 0xF94FFBB2, "compound_left_veh" },
    { 0x9D0654CC, "compound_limo" },
    { 0x7A07E076, "compound_main" },
    { 0x043257C1, "compound_mid_1_veh" },
    { 0xEFB0D626, "compound_mid_2_veh" },
    { 0xE4AD6A43, "compound_non_alert_patrollers_think" },
    { 0x6CA62057, "compound_patrollers" },
    { 0xE97F1A4B, "compound_player_btr" },
    { 0xE4BA89BC, "compound_player_inside_building_stealth" },
    { 0xC966BF66, "compound_player_outside" },
    { 0xD42C6D51, "compound_player_outside_building_stealth" },
    { 0x44C67ED8, "compound_player_speed_control" },
    { 0x622AFD33, "compound_player_think" },
    { 0xA1B5DCC6, "compound_security_think" },
    { 0xCAB6FF4C, "compound_security_vehicles_think" },
    { 0x5172C78B, "compound_stealth_think" },
    { 0x55889FFC, "compound_trigger1" },
    { 0xC7900F37, "compound_trigger2" },
    { 0x23D8B9FE, "compound_truck_enemies_think" },
    { 0xED7AE31D, "compound_trucks" },
    { 0x91372A72, "compound_vehicles" },
    { 0xA67B43B6, "compound_vision_trig" },
    { 0x15353692, "compound_window_trig" },
    { 0x603D6119, "compound_woods" },
    { 0xFAB85E85, "compound_woods_hiding" },
    { 0xD9BE3D5E, "compressed" },
    { 0x46148ECD, "compression" },
    { 0x3C6BEEAF, "comprimised" },
    { 0x5CA8C3A1, "compromised" },
    { 0xCDC43EE2, "compromising" },
    { 0x9971DEE6, "compulsory" },
    { 0xDE7E659E, "compund_vehicle_move_faster" },
    { 0x7214E4D2, "computation" },
    { 0xF017D138, "compute" },
    { 0x18798FAC, "compute_player_weapon_ammo_cost" },
    { 0xBC580B21, "computeattackerthreat" },
    { 0x849A5D6C, "computed" },
    { 0x98BD0F2A, "computer" },
    { 0xEAB3E44C, "computer_buildable_trig" },
    { 0xA3CA68D6, "computer_damage" },
    { 0x531F20C6, "computer_damage_a" },
    { 0x2D1CA65D, "computer_damage_b" },
    { 0x071A2BF4, "computer_damage_c" },
    { 0xECB1CB72, "computer_data_audio" },
    { 0x66158F03, "computer_guy_goes_back_to_work" },
    { 0x2C66B1D7, "computer_guy_think" },
    { 0x3FE28D66, "computer_guy_wait" },
    { 0xF1A1B72D, "computer_hintstring_regulator" },
    { 0x2EC39E63, "computer_loop" },
    { 0xC530CB03, "computer_loop_a" },
    { 0x53295BC8, "computer_loop_b" },
    { 0x792BD631, "computer_loop_c" },
    { 0x85DF4252, "computer_loops" },
    { 0x8BA4CDC6, "computer_screens_power" },
    { 0x9C931EC4, "computer_server_use" },
    { 0xB9589045, "computer_sounds_main_base" },
    { 0x4F4D346D, "computer_sounds_power_relay" },
    { 0x57D6271B, "computer_trig" },
    { 0x495E3F62, "computer_up" },
    { 0x94D623E5, "computers" },
    { 0xA7BE7379, "computing" },
    { 0x9169E7A2, "comrade" },
    { 0x467B6A6D, "comrades" },
    { 0x97FCB794, "comspot" },
    { 0x89538CE2, "comstat" },
    { 0x3D525097, "con" },
    { 0xBF41CB11, "con_sparks1" },
    { 0xE544457A, "con_sparks2" },
    { 0x0B46BFE3, "con_sparks3" },
    { 0x18E09B44, "concatenated" },
    { 0xFB18E697, "concatenation" },
    { 0x4BD30484, "concbridge_lrg_sect01" },
    { 0x60919391, "concbridge_lrg_sect01_start" },
    { 0xBDDA73BF, "concbridge_lrg_sect02" },
    { 0x9168385A, "concbridge_lrg_sect02_start" },
    { 0x97D7F956, "concbridge_lrg_sect03" },
    { 0x38A6C507, "concbridge_lrg_sect03_start" },
    { 0xD9CB9549, "concbridge_lrg_sect04" },
    { 0x378A4818, "concbridge_lrg_sect04_start" },
    { 0xF8FAE217, "concbridge_sm_sect01" },
    { 0x37780C62, "concbridge_sm_sect01_start" },
    { 0x86F372DC, "concbridge_sm_sect02" },
    { 0x6DF949F9, "concbridge_sm_sect02_start" },
    { 0x3D4C15F8, "conceal" },
    { 0xA23A800B, "concealed" },
    { 0x98D22660, "concealing" },
    { 0x712954F4, "concealment" },
    { 0x78C40937, "concentrate" },
    { 0x571A937C, "concentration" },
    { 0x7E2AB4FB, "concept" },
    { 0x1D27D39A, "concepts" },
    { 0xF772496B, "concern" },
    { 0xF13794A0, "concerned" },
    { 0xB9C4674A, "concerns" },
    { 0x9427981D, "concession" },
    { 0x481A5BF3, "concise" },
    { 0x509B27BC, "concrete" },
    { 0x2669ADED, "concrete1" },
    { 0xFA7E4D66, "concurrent" },
    { 0x44745415, "concurrent_waves" },
    { 0xD89EBF4B, "concurrently" },
    { 0x42B3231E, "concussed" },
    { 0x3E5D078D, "concussion" },
    { 0x49BDA497, "concussionendtime" },
    { 0x59E92572, "concussionsound" },
    { 0x3EE01ECC, "concussive_damage_radius_lg" },
    { 0x38B4F687, "concussive_damage_radius_sm" },
    { 0x618003BF, "concussive_explosion_dmg_max" },
    { 0xB4577281, "concussive_explosion_dmg_min" },
    { 0x950C9E03, "concussive_wave" },
    { 0x827C9548, "condition" },
    { 0xBB3FA8EF, "conditional" },
    { 0x6433E1B2, "conditional_power_indicators" },
    { 0xE39F238D, "conditionaleval" },
    { 0x4DD651EE, "conditionallefthandside" },
    { 0x099AC07C, "conditionalresult" },
    { 0x3A611136, "conditionals" },
    { 0x0428F79A, "conditionfunc" },
    { 0x58738590, "conditioning" },
    { 0xA7931007, "conditionlhs" },
    { 0x04ECB063, "conditions" },
    { 0xB8A83F96, "conditions_for_round" },
    { 0xFEAE781C, "conditons" },
    { 0x9078EEE4, "condo" },
    { 0x209A9248, "cone" },
    { 0xC8CBC253, "cone_apex" },
    { 0x4D3D6B88, "cone_base" },
    { 0xECE9C489, "cone_base_radius" },
    { 0x29A7CE45, "cone_check" },
    { 0x506B1066, "cone_height" },
    { 0x4B9835FF, "cone_height_unit_vector" },
    { 0xA40931FB, "cone_radial_unit_vector" },
    { 0xE4040549, "cone_radius" },
    { 0x81F470BE, "cone_tip" },
    { 0x56192981, "coneangle" },
    { 0x45C890A0, "conecheck" },
    { 0xF7D051D5, "conecosine" },
    { 0xEE21F763, "cones" },
    { 0x84570072, "conf_door" },
    { 0x3C1C8CDC, "conf_fx" },
    { 0x68A47009, "conf_get_tag_in_sight" },
    { 0x575CF307, "conf_rules" },
    { 0x299775A5, "conf_tag_in_radius" },
    { 0x9CB155AE, "conf_wins_index" },
    { 0x92E3A6B3, "conference" },
    { 0x740A3067, "config" },
    { 0xCB5E51DD, "configuration" },
    { 0x3B5BF853, "configure" },
    { 0x234895A1, "configure_team" },
    { 0xBF9F1C2F, "configure_team_internal" },
    { 0xB2859ADD, "configurechopperteampost" },
    { 0x9C82872D, "configured" },
    { 0x8AA2BE82, "configures" },
    { 0xAEBA7860, "configureteam" },
    { 0xD92AC79E, "configureteampost" },
    { 0xD36811FA, "configureteampostfunction" },
    { 0xCFBE7887, "configureteamprefunction" },
    { 0x0CC602CC, "confims" },
    { 0xE527F0FB, "confirm" },
    { 0xFFB1A2B2, "confirm_kill" },
    { 0xB078FD3D, "confirm_kills" },
    { 0x8AE9D8EB, "confirm_lines" },
    { 0x9594B083, "confirm_location" },
    { 0xAA935C91, "confirm_menendez_exit_started" },
    { 0x021B9754, "confirm_menendez_gaz_driveaway" },
    { 0x998BC177, "confirm_menendez_idle_started" },
    { 0x53641CCE, "confirm_menendez_reach_started" },
    { 0x2AF06F26, "confirm_targets_hit" },
    { 0x5AF445A6, "confirmation" },
    { 0xF9445070, "confirmed" },
    { 0xF81CFBE5, "confirming" },
    { 0x3DCD479A, "confirms" },
    { 0xDF947A37, "conflict" },
    { 0x03214669, "conflicting" },
    { 0xF397386E, "conflicts" },
    { 0xDBA46230, "confront" },
    { 0x8B85B603, "confront_steiner" },
    { 0xA988C0F9, "confront_steiner_fade_out" },
    { 0xBE065642, "confront_steiner_punch" },
    { 0xED2CCEB9, "confront_steiner_slam" },
    { 0x02EF743C, "confront_steiner_spit" },
    { 0x0F693C3C, "confused" },
    { 0x5C444BA9, "confusing" },
    { 0x0D326E2F, "confusion" },
    { 0x35939352, "congrats" },
    { 0x90E546B8, "conisder" },
    { 0x581ED3BF, "conjunction" },
    { 0x9811B98F, "connec" },
    { 0x3BA37349, "connect" },
    { 0xD06245B4, "connect_hangar_paths" },
    { 0x7BC446DD, "connect_nodes_to_path" },
    { 0x80D60480, "connect_paths" },
    { 0xCAD279FB, "connect_roof_watcher_path" },
    { 0x6E5A9C8E, "connect_roof_watcher_path_by_ai_group_count" },
    { 0xE54A2E19, "connect_zones" },
    { 0xFFCCD4CF, "connect_zones_for_ffotd" },
    { 0x5DA53846, "connecte" },
    { 0x08339876, "connected" },
    { 0xC7527C04, "connected_nodes" },
    { 0x4B7CCFD8, "connectedplayers" },
    { 0xF0CD13FF, "connecting" },
    { 0x2671827C, "connecting_first_player" },
    { 0xA1BB3685, "connection" },
    { 0xACEBB1C4, "connection_enemy_angle" },
    { 0x74EFBF6F, "connection_enemy_dist" },
    { 0xCC4BE9A1, "connection_enemy_health_pct" },
    { 0xC5987757, "connection_enemy_valid" },
    { 0xBFDF64F7, "connection_enemy_visible" },
    { 0x0DA7680A, "connection_health_pct" },
    { 0xCA82CEF5, "connection_on_notify" },
    { 0x064A8273, "connection_struct" },
    { 0x1989556B, "connection_timer" },
    { 0x2BDE10A0, "connection_type" },
    { 0x3D9B8EED, "connection_type_enemy_angle" },
    { 0x9B764A5C, "connection_type_enemy_dist" },
    { 0x12C4BE56, "connection_type_enemy_health_pct" },
    { 0xA0C7D022, "connection_type_enemy_valid" },
    { 0xBEDFD752, "connection_type_enemy_visible" },
    { 0x5F91342D, "connection_type_health_pct" },
    { 0x58B82ACC, "connection_type_notify" },
    { 0x033DF9F4, "connection_type_on_notify" },
    { 0xD383304E, "connection_type_timer" },
    { 0xC5E44AF5, "connection_type_utility" },
    { 0x9F03F30C, "connectionarray" },
    { 0x31A1A988, "connectionlinks" },
    { 0x0A998FCC, "connectionname" },
    { 0x4DC4F214, "connections" },
    { 0x4A6FE7E0, "connections_notify" },
    { 0xAD9CF821, "connections_utility" },
    { 0xE9057901, "connectionscore" },
    { 0xE25F0539, "connectionvalid" },
    { 0x560DCB16, "connector" },
    { 0xDE8377BF, "connectpaths" },
    { 0x196EB340, "connects" },
    { 0xA7DE1B72, "connecttraverses" },
    { 0x5D67C525, "conning" },
    { 0x8D611410, "conquer" },
    { 0x9104E70F, "conscience_vo" },
    { 0x9118BA29, "conscience_vo_end_early" },
    { 0xEFD2B36A, "conscience_vo_ended_early" },
    { 0x616AE803, "conscience_vo_played" },
    { 0xB0D41764, "consciousness" },
    { 0x61CB2F17, "consecuitve" },
    { 0x4860460D, "consecutive" },
    { 0xE4D42C41, "consecutive_electric_cherry_attacks" },
    { 0x85142830, "consecutively" },
    { 0xB08FD52F, "conseq4uences" },
    { 0x1994C4C0, "consequence" },
    { 0x171182EB, "consequences" },
    { 0x28D56F18, "consequences_will_never_be_the_same" },
    { 0x66EE31E0, "conserva" },
    { 0xFEF81B84, "conserve" },
    { 0xB23BA61F, "conserveammowhileplayerisinvulnerable" },
    { 0xCDBB4C93, "consice" },
    { 0xEBABD384, "consider" },
    { 0xA7870A5B, "consideration" },
    { 0x1B5E087A, "considerations" },
    { 0x1EC1B6D6, "considerchangingtarget" },
    { 0xD07089E7, "considered" },
    { 0x87E473E4, "considering" },
    { 0x36E36614, "considermissing" },
    { 0x14BF2737, "considers" },
    { 0x9EAEAB96, "considerthrowgrenade" },
    { 0x97A56C70, "consignment" },
    { 0xF788E1EA, "consist" },
    { 0x1B09C785, "consistant" },
    { 0xC7457D2B, "consistency" },
    { 0x82A0D241, "consistent" },
    { 0x951199CC, "consistently" },
    { 0x7E9838D8, "consitency" },
    { 0xE89A8A5C, "console" },
    { 0xE783BEE4, "console_auto_aim" },
    { 0x4049AB01, "console_auto_aim_2nd" },
    { 0x31018BF3, "console_blue" },
    { 0x91FC61D4, "console_explosion" },
    { 0x200762B0, "console_green" },
    { 0x699D86C7, "console_idle_anim" },
    { 0xF5A58F45, "console_input" },
    { 0xD87F9FB2, "console_model" },
    { 0xFCBE443D, "console_models" },
    { 0x8A19D8B3, "console_quadrant_1" },
    { 0x18126978, "console_quadrant_2" },
    { 0x3E14E3E1, "console_quadrant_3" },
    { 0xFC2147EE, "console_quadrant_4" },
    { 0xFE3E7230, "console_red" },
    { 0x6EABA579, "console_start" },
    { 0x3D24C90E, "console_twitch_anim" },
    { 0xE3D78BC9, "consoleactivated" },
    { 0xAD38591A, "consolegame" },
    { 0x47B0A293, "consolemodel" },
    { 0xB3034CC7, "consoleon" },
    { 0x519DCE27, "consolequadrants" },
    { 0x5976E49F, "consoles" },
    { 0x03BEDE5D, "consoleselectedhighlight" },
    { 0xBA404EFE, "consoleviewarms" },
    { 0xADA11B46, "consoleviewmodel" },
    { 0x830424C6, "consolexenon" },
    { 0xFAB9B24C, "consolidate" },
    { 0xA737AB60, "consolidated" },
    { 0x8F9A39EB, "consolidation" },
    { 0x2CCAFE4C, "consrete" },
    { 0xFB593FFE, "const" },
    { 0x20784B71, "const_aggressive_ai_engage_min" },
    { 0x29726119, "const_aggressive_ai_engage_min_fall_off" },
    { 0xA93F4E69, "const_ai_repeat_boost_accuracy" },
    { 0xE177C464, "const_ai_repeat_boost_health" },
    { 0x2C5F61C3, "const_ai_repeat_boost_speed" },
    { 0xF605019E, "const_ai_search_player_time" },
    { 0x7CA73721, "const_ai_update_delay" },
    { 0x1C52C556, "const_allies_cover_search_interval" },
    { 0xC19EFE9A, "const_ally_bullet_shield_time" },
    { 0x203CE37C, "const_ally_goal_radius" },
    { 0x246B1F00, "const_ally_squad_size" },
    { 0x47D66171, "const_ammo_armor_jug_start" },
    { 0x7BAEBA72, "const_ammo_armor_start" },
    { 0x192CCB5D, "const_armor_points_display_time" },
    { 0x0D1610B2, "const_armor_points_initial_display_time" },
    { 0xEA8C1558, "const_base_threat_weight" },
    { 0x5731BF04, "const_camp_response_interval" },
    { 0xB14E079B, "const_chopper_accel" },
    { 0xC491F246, "const_chopper_speed" },
    { 0x6F0D5BFD, "const_claymore_ent_dmg_max" },
    { 0xA9F6FE13, "const_claymore_ent_dmg_min" },
    { 0xA4C35A4F, "const_claymore_ent_dmg_radius" },
    { 0xA58B8956, "const_claymore_ent_phys_force" },
    { 0x5C545BCF, "const_claymore_ent_phys_radius" },
    { 0x1213F8AA, "const_claymore_ent_quake_radius" },
    { 0x4A7C770E, "const_claymore_ent_quake_scale" },
    { 0x35DF7AA3, "const_claymore_ent_quake_time" },
    { 0xF993D9D5, "const_claymore_ent_timer" },
    { 0x2B34F718, "const_claymore_ent_trig_angle" },
    { 0x50797672, "const_claymore_ent_trig_dist_min" },
    { 0x6CF76759, "const_claymore_ent_trig_radius" },
    { 0x8141E631, "const_claymore_goal_radius_aggressive" },
    { 0x7D544760, "const_claymore_goal_radius_default" },
    { 0x5D309EB8, "const_claymore_placed_max" },
    { 0x7E8F7239, "const_color_text_allies" },
    { 0x4AA7A030, "const_color_text_axis" },
    { 0x75F2D39C, "const_death_fail_wave" },
    { 0xF85CD272, "const_dog_spawn_over_time" },
    { 0x44974AAF, "const_dogsplode_c4_timer_neck_snap" },
    { 0xE98B4192, "const_domination_radius" },
    { 0xCFD11F70, "const_enemy_goto_goal_radius" },
    { 0xEF5EA8EC, "const_flag_airstrike" },
    { 0x211E7B56, "const_flag_bombing" },
    { 0xF1D2C744, "const_flag_camera_spike" },
    { 0x6AB26ABE, "const_flag_choppergunner" },
    { 0x61CED522, "const_flag_copterdamaged" },
    { 0xFE276443, "const_flag_copterrotor" },
    { 0x557DC8C3, "const_flag_countdown" },
    { 0xB21A0572, "const_flag_counteruav" },
    { 0xEF508359, "const_flag_crashing" },
    { 0xD94BD739, "const_flag_ctfcarrier" },
    { 0xB9DE40FC, "const_flag_destructable_destroyed" },
    { 0x401F4E33, "const_flag_destructible_car" },
    { 0x695EECCC, "const_flag_drawhudoutlinegreen" },
    { 0x2F5ABAFC, "const_flag_drawhudoutlinered" },
    { 0x715C0F10, "const_flag_elevator_floor_fx" },
    { 0xA2409081, "const_flag_elevator_fx" },
    { 0x63FB01E0, "const_flag_emp" },
    { 0xB173E4FD, "const_flag_flag_away" },
    { 0x93B9CB01, "const_flag_laseractive" },
    { 0x262236A7, "const_flag_missile_swarm" },
    { 0x7B9BB615, "const_flag_napalm" },
    { 0x30B352EA, "const_flag_opendoor" },
    { 0xE1EE53B1, "const_flag_operatingchoppergunner" },
    { 0xF3EB762E, "const_flag_operatingpredator" },
    { 0xEC8A9C3E, "const_flag_operatingreaper" },
    { 0xCB69C84E, "const_flag_outofbounds" },
    { 0xCCE5F38F, "const_flag_player_helicopter" },
    { 0x77F9E603, "const_flag_police_car" },
    { 0x0F2676E5, "const_flag_proximity" },
    { 0x67FE79B3, "const_flag_riotshield_deploy" },
    { 0xF2F93854, "const_flag_riotshield_destroy" },
    { 0x69D10F8B, "const_flag_rocket_fx" },
    { 0x017E901B, "const_flag_scrambler" },
    { 0xBF89E9AF, "const_flag_stunned" },
    { 0xB2806E0F, "const_flag_tactical_insertion" },
    { 0x398060C7, "const_flag_timeout" },
    { 0x4024F597, "const_flag_warn_fired" },
    { 0x4136828B, "const_flag_warn_locked" },
    { 0x9E8FB079, "const_flag_warn_targeted" },
    { 0xDCFA9225, "const_follow_dist" },
    { 0x7FB7FDDF, "const_friendly_goal_radius" },
    { 0x30310293, "const_fx_exploder_end_game_glass_shatter" },
    { 0xBB96F46F, "const_fx_exploder_nuke" },
    { 0x588D70B8, "const_fx_exploder_red_light_1" },
    { 0xCA94DFF3, "const_fx_exploder_red_light_2" },
    { 0xE203049F, "const_fx_exploder_rocket_coolant" },
    { 0x1E5D6ECD, "const_fx_exploder_switch_green_light" },
    { 0xFC304A9D, "const_fx_exploder_switch_red_light" },
    { 0x6516BFF8, "const_jug_drop_shield_health_percent" },
    { 0xF6D3DA58, "const_jug_high_shield" },
    { 0x0559FC8B, "const_jug_kill_on_pain" },
    { 0x8280C40E, "const_jug_low_shield" },
    { 0xCD251D12, "const_jug_med_shield" },
    { 0x2EB6696F, "const_jug_min_damage_pain" },
    { 0x9EA1490A, "const_jug_min_damage_pain_weak" },
    { 0x035E8D17, "const_jug_no_shield" },
    { 0x228B28D6, "const_jug_pop_helmet_health_percent" },
    { 0x8EAE393E, "const_jug_riotshield_bullet_block" },
    { 0x308128B2, "const_jug_run_dist" },
    { 0x7AFA72E2, "const_jug_weakened" },
    { 0x0BB76477, "const_jug_weakened_run_dist" },
    { 0x2FFDA0F5, "const_laststand_getup_bar_damage" },
    { 0x82457459, "const_laststand_getup_bar_regen" },
    { 0x47DF2BE6, "const_laststand_getup_bar_start" },
    { 0x638DAEA0, "const_laststand_getup_count_start" },
    { 0xB181E5C3, "const_long_death_remove_dist_min" },
    { 0xF589CFDE, "const_loot_drop_min_waves_last_drop" },
    { 0xEF8790D4, "const_loot_last_wave_drop_default" },
    { 0x265500DF, "const_loot_timeout" },
    { 0x3CE1E9E0, "const_maintain_squad_num" },
    { 0x2E4E794C, "const_martyrdom_c4_timer" },
    { 0x539F9E6C, "const_martyrdom_c4_timer_subsequent" },
    { 0x72F461D6, "const_max_follow_dist" },
    { 0x74239B11, "const_max_special_node_radius" },
    { 0xFA0A681D, "const_max_visible_dist" },
    { 0x277845B6, "const_merge_squad_member_max" },
    { 0xD71F4437, "const_min_rev_timer" },
    { 0xFC32CC18, "const_min_squad_spawners" },
    { 0x57B1A0D7, "const_mine_loc_range_player" },
    { 0x6B79AC79, "const_mine_loc_update_delay" },
    { 0xC174D91D, "const_mine_loc_weight_decay" },
    { 0xB6503777, "const_mine_loc_weight_inc" },
    { 0x38F02DED, "const_mine_loc_weight_max" },
    { 0x89357C33, "const_mine_plant_check_delay" },
    { 0x6B664FBD, "const_mine_plant_dist_ai_max" },
    { 0x0FACCB32, "const_mine_plant_dist_player_min" },
    { 0x6EA707A6, "const_mine_plant_height_ai_max" },
    { 0x336C9483, "const_mine_plant_time_between" },
    { 0x98A3C274, "const_mine_plant_weight_min" },
    { 0x69B3669E, "const_no_spawn_zone_radius" },
    { 0x04642725, "const_node_closest_height" },
    { 0xE3567130, "const_node_closest_height_increase" },
    { 0xAA2469CD, "const_node_closest_radius_increase" },
    { 0xA84BCC72, "const_node_closest_radius_invalid" },
    { 0xFCFFBCA5, "const_node_closest_radius_max" },
    { 0xE7E1150B, "const_node_closest_radius_min" },
    { 0x853C9199, "const_perk_timeout" },
    { 0x68826FE6, "const_priority_target_engage_dist" },
    { 0x9C0FCCC5, "const_regular_engage_dist_max" },
    { 0x5156AD82, "const_regular_engage_dist_max_falloff" },
    { 0x86F1252B, "const_regular_engage_dist_min" },
    { 0x17E95D6C, "const_regular_engage_dist_min_falloff" },
    { 0x339A0D02, "const_regular_follow_radius" },
    { 0x66D5C157, "const_regular_goal_radius_aggressive" },
    { 0xE75C3E16, "const_regular_goal_radius_default" },
    { 0x47E4F1C5, "const_rev_timer_decrease" },
    { 0x1620C6AC, "const_riotshield_follow_angle" },
    { 0x44C9FE37, "const_riotshield_follow_dist" },
    { 0xCDD58F15, "const_riotshield_follow_radius" },
    { 0xD04629F3, "const_squad_fill_delay" },
    { 0x6BAAC8A5, "const_squad_leader_goalradius" },
    { 0xB87C4D97, "const_squad_position_east" },
    { 0x2F9BCFF9, "const_squad_position_north" },
    { 0x0A2E5343, "const_squad_position_south" },
    { 0xC17B9455, "const_squad_position_west" },
    { 0x9061736F, "const_squad_size" },
    { 0xF9A91426, "const_start_objective_num" },
    { 0x94164A13, "const_start_rev_timer" },
    { 0xDF485A4A, "const_wait_reacquire_time" },
    { 0x8EFFADC2, "const_wave_ai_left_till_aggro" },
    { 0x2563B0AC, "const_wave_delay_before_ready_up" },
    { 0xD1F752EA, "const_wave_delay_countdown" },
    { 0x2EC0FC05, "const_wave_delay_total" },
    { 0x0A4A8A72, "const_wave_ended_timer_fade_delay" },
    { 0xA9E11389, "const_wave_reenforcement_special_ai" },
    { 0xB6494D17, "const_wave_reenforcement_squad" },
    { 0x94D6E53F, "const_wave_start_timeout" },
    { 0x7CCA36C9, "const_weapon_drop_alt_ammo_clip" },
    { 0x428E92E7, "const_weapon_drop_alt_ammo_stock" },
    { 0xB869B9F9, "const_weapon_drop_ammo_clip" },
    { 0xA7A4B178, "const_weapon_drop_ammo_clip_min" },
    { 0x19610497, "const_weapon_drop_ammo_stock" },
    { 0x25E3AC06, "const_weapon_drop_ammo_stock_min" },
    { 0x8BA557AC, "const_weapon_drop_rate" },
    { 0xC7CEABF0, "const_z_hide" },
    { 0xAE3C9221, "constant" },
    { 0xF4197DB3, "constant_drop_bad_place" },
    { 0x447A6C18, "constant_index" },
    { 0xCC32611F, "constant_size" },
    { 0xBFCDD6A3, "constant_tracers_to_self" },
    { 0x8D4C65A3, "constantindex" },
    { 0x36D89FAC, "constantly" },
    { 0x573D0CC8, "constants" },
    { 0x17E8CBC5, "constid" },
    { 0x197E099A, "constid_overlay_rccarcam_noise" },
    { 0xE773BDD3, "constid_overlay_rccarcam_scanline_intensity" },
    { 0xD6F13CB1, "constid_overlay_rccarcam_scanline_speed" },
    { 0x3864F3D7, "constidx" },
    { 0x6437CDB2, "constmaxsearchradius" },
    { 0x3C6E7674, "constminsearchradius" },
    { 0xC8069D43, "constname" },
    { 0x18A99AAA, "constprefix" },
    { 0x89648ACD, "constrain_gametype" },
    { 0x25BD7629, "constrain_map_size" },
    { 0x21FE21DE, "constraingametype" },
    { 0x11D2785D, "constrainmapsize" },
    { 0xA474A68F, "constraints" },
    { 0x5D51DE78, "construct" },
    { 0xDD28D63D, "construct_class" },
    { 0xD4FEB729, "construct_loadout" },
    { 0x95B17B00, "constructclass" },
    { 0x5613192A, "construction" },
    { 0x754DFE21, "construction_anims" },
    { 0xA3CB3DDD, "construction_dialog" },
    { 0x4C3A9D89, "construction_precache_anims" },
    { 0xE65B7DA5, "construction_vision_trigger_cleanup" },
    { 0x2980A84D, "constructmessage" },
    { 0x4B618891, "consulting" },
    { 0xBF540A1A, "consumable_increment" },
    { 0x6051E3CC, "consumableget" },
    { 0x6E6C0F9F, "consumableincrement" },
    { 0x14AF517D, "consume" },
    { 0xD48CF67E, "consume_scene_end" },
    { 0x3542AB43, "consumed" },
    { 0xBB6CCC3C, "consumes" },
    { 0xA6C4B341, "cont" },
    { 0x056ADBDB, "contact" },
    { 0xFFA8A87D, "contact_ent" },
    { 0xD476EA4C, "contact_point" },
    { 0xDACD4450, "contacted" },
    { 0xDA19036F, "contactpoint" },
    { 0x6900D4FA, "contacts" },
    { 0xE7A47C83, "contain" },
    { 0x5857F978, "contained" },
    { 0xDC3F315E, "container" },
    { 0x475C669C, "container_01" },
    { 0xD11D8EB9, "container_01_start" },
    { 0xB963D5D7, "container_02" },
    { 0xDF8D1922, "container_02_start" },
    { 0x93615B6E, "container_03" },
    { 0x3C6B964F, "container_03_start" },
    { 0x5D7A8B3E, "container_a" },
    { 0x2C22D03D, "container_a_moves" },
    { 0xEF44F934, "container_animations" },
    { 0x377810D5, "container_b" },
    { 0x02819A66, "container_b_moves" },
    { 0xF4F49426, "container_body1" },
    { 0xCEF219BD, "container_body2" },
    { 0x966301DD, "container_body_animations" },
    { 0x54ED90A0, "container_bugs" },
    { 0x1060F89B, "container_cleanup" },
    { 0x2E4FF524, "container_clear_lighting_ents" },
    { 0xD02FFFCB, "container_clip" },
    { 0xBE9B6C97, "container_dark_exposure" },
    { 0xE4949FBF, "container_heli_sequence" },
    { 0x80D4C7EF, "container_heli_sequence2" },
    { 0x350BF83A, "container_main" },
    { 0x9FEDC931, "container_rpg_moment" },
    { 0x728554F4, "container_splashes" },
    { 0x4571F75A, "container_update" },
    { 0x925B3DBA, "containerindex" },
    { 0x0EB1FBC1, "containers" },
    { 0x34FFA9DD, "containing" },
    { 0x45EAF55B, "containment" },
    { 0x3F089673, "containment_onplayerspawn" },
    { 0xA7C17E1D, "containment_post_init" },
    { 0x8592C5BA, "containment_pre_init" },
    { 0xFB2A4EDB, "containment_prestart" },
    { 0x9EAA21D7, "containment_trigger_shutdown" },
    { 0x72165648, "containment_trigger_startup" },
    { 0x6E2DA8F5, "containment_trigger_thread" },
    { 0x307B88F2, "contains" },
    { 0xFE6F96B2, "contaminations_given" },
    { 0x16159166, "contaminations_received" },
    { 0xE058D838, "contend" },
    { 0x26F1D24B, "contended" },
    { 0x9691DB0C, "contenders" },
    { 0x803131A8, "content" },
    { 0x8D32991F, "content_restrict" },
    { 0xDE9C1FD7, "content_type" },
    { 0x38F4E9A2, "content_weapons" },
    { 0x47A04143, "contents" },
    { 0xF0A582A1, "contents_actor" },
    { 0x734F1BCA, "contents_ai_avoid" },
    { 0x3C91A34D, "contents_ai_nosight" },
    { 0xFEC7CD50, "contents_alliestrigger" },
    { 0xC9706943, "contents_axistrigger" },
    { 0xE351C79B, "contents_canshootclip" },
    { 0x7C95C594, "contents_clipshot" },
    { 0x0CE598E2, "contents_corpse" },
    { 0xCA2F6F47, "contents_corpse_clipshot" },
    { 0x470588E1, "contents_detail" },
    { 0x7ADB5DDF, "contents_fake_actor" },
    { 0xF7968D1F, "contents_foliage" },
    { 0xB95B040A, "contents_glass" },
    { 0x6A855C93, "contents_item" },
    { 0x7C2FFF2D, "contents_itemclip" },
    { 0x9987D48C, "contents_lookat" },
    { 0x82231F83, "contents_mantle" },
    { 0xBD275B20, "contents_missileclip" },
    { 0xD4BFFAFE, "contents_monsterclip" },
    { 0x77D37179, "contents_neutraltrigger" },
    { 0xD6C89510, "contents_nodrop" },
    { 0x9D81C212, "contents_noncolliding" },
    { 0xB9F59F63, "contents_nonsentienttrigger" },
    { 0xEEB58639, "contents_player" },
    { 0x4D5C371F, "contents_playerclip" },
    { 0xFCE7C557, "contents_playertrigger" },
    { 0x34D108BD, "contents_playervehicleclip" },
    { 0xBA1130B1, "contents_sky" },
    { 0x40D66CD7, "contents_solid" },
    { 0x4F21BA1B, "contents_structural" },
    { 0x597A53DE, "contents_trigger" },
    { 0x44740437, "contents_use" },
    { 0x32278C08, "contents_utilityclip" },
    { 0xD65C3F12, "contents_vehicle" },
    { 0xE6079E90, "contents_vehicleclip" },
    { 0x2BE29BAA, "contents_vehicletrigger" },
    { 0x143ABFFF, "contents_water" },
    { 0xBB6D6957, "contest" },
    { 0x8B8D9564, "contest_over" },
    { 0x3AD1301C, "contested" },
    { 0xFA44E251, "contested_flag" },
    { 0x45C5AAAA, "contestedflag" },
    { 0xD30AAF02, "context" },
    { 0xAD3472A1, "context_2" },
    { 0x9ED74406, "context_debug" },
    { 0x95A3BC15, "context_done" },
    { 0xE4CAFEE4, "context_location" },
    { 0x9E3A11DE, "context_sensative_dialog" },
    { 0x2ADF9E73, "context_sensative_dialog_filler" },
    { 0xBFBBA50A, "context_sensative_dialog_guy_crawling" },
    { 0xED6CF0B6, "context_sensative_dialog_guy_in_sight" },
    { 0x728BCB5B, "context_sensative_dialog_guy_in_sight_check" },
    { 0xBB7778A1, "context_sensative_dialog_guy_pain" },
    { 0xEC463669, "context_sensative_dialog_guy_pain_falling" },
    { 0x12D8A2CD, "context_sensative_dialog_kill" },
    { 0x7D310FD0, "context_sensative_dialog_kill_thread" },
    { 0x25B09173, "context_sensative_dialog_locations" },
    { 0x5C30A2B0, "context_sensative_dialog_locations_add_notify_event" },
    { 0x41EC56FA, "context_sensative_dialog_locations_thread" },
    { 0xC78B089F, "context_sensative_dialog_play_random_group_sound" },
    { 0xDCEA86C4, "context_sensative_dialog_secondary_explosion_vehicle" },
    { 0x302EC6B6, "context_sensative_dialog_timedout" },
    { 0xB568A779, "context_sensative_dialog_timeouts" },
    { 0x662FE4C7, "context_sensative_dialog_vehicledeath" },
    { 0x68164C58, "context_sensative_dialog_vehiclespawn" },
    { 0x75F6AC4D, "contexts" },
    { 0xE8C7B944, "contextual" },
    { 0x9FC0768D, "contextual_melee" },
    { 0x6C95B7D9, "contextual_melee_allow_fire_button" },
    { 0x2DE60FBF, "contextual_melee_anim" },
    { 0x789154B5, "contextual_melee_complete" },
    { 0x67D04490, "contextual_melee_done" },
    { 0x94E93B98, "contextual_melee_guys" },
    { 0x3051CAE2, "contextual_melee_karambit_init" },
    { 0xE0150FDB, "contextual_melee_karambit_props_init" },
    { 0x59A7AD7E, "contextual_melee_show_hintstring" },
    { 0x9120A54C, "contextual_melee_start_anim" },
    { 0xDD7E2690, "contextual_melee_thread" },
    { 0xB744B79D, "contextual_melee_watch_for_anim_end" },
    { 0x9FD93751, "contextual_melee_watch_for_victim_died" },
    { 0x83760C9D, "contextual_trigger" },
    { 0x8D5C9EB2, "contextualmeleefeature" },
    { 0x5914597D, "contiguous" },
    { 0x6FB67733, "continually" },
    { 0x1C106504, "continuation" },
    { 0x30830872, "continue" },
    { 0xFC178380, "continue_cover_script" },
    { 0xC10FE569, "continue_credits" },
    { 0xBDE51EE1, "continue_draining_hero_weapon" },
    { 0x750197D2, "continue_explosions_till_player_leaves" },
    { 0x7171203E, "continue_exposed_combat" },
    { 0x34BC0D07, "continue_facing_object" },
    { 0x370BF1E2, "continue_failsafe_damage" },
    { 0x7491143C, "continue_hacking_object" },
    { 0xAC72D910, "continue_hold_think_loop" },
    { 0x28DE17FA, "continue_music_state_changes" },
    { 0x77C71004, "continue_path" },
    { 0x03C5D519, "continue_search" },
    { 0x2258C998, "continue_sparking" },
    { 0x3E882182, "continue_trigger_touch_think" },
    { 0x70F76046, "continue_wait" },
    { 0x26B3FA5A, "continue_waiting" },
    { 0x19C616B6, "continueattack" },
    { 0xFA793D99, "continuecycling" },
    { 0x792A4932, "continued" },
    { 0xE2FE2C84, "continued_text" },
    { 0xA21F823D, "continueholdthinkloop" },
    { 0x89F62C9D, "continueleaningatcovercondition" },
    { 0x4B595EFD, "continues" },
    { 0x32359939, "continuetacticalwalkscan" },
    { 0x0530364D, "continuetriggertouchthink" },
    { 0x207E8823, "continuing" },
    { 0xD82857A4, "continuous" },
    { 0x8F415641, "continuously" },
    { 0xAF50558C, "continute" },
    { 0xB2155EA6, "contour_point" },
    { 0xF2FA50CC, "contourdepth" },
    { 0x7B66D12B, "contract" },
    { 0x8E523A61, "contract0" },
    { 0x684FBFF8, "contract1" },
    { 0xDA572F33, "contract2" },
    { 0xD146D0AB, "contract_count" },
    { 0xED438349, "contract_game_ended" },
    { 0x62D51442, "contract_index" },
    { 0x33CD426D, "contract_kills" },
    { 0x9771FFF9, "contract_slot_met" },
    { 0x8DC68842, "contract_table" },
    { 0xC2591B36, "contract_type" },
    { 0x2320B45C, "contract_win" },
    { 0x06B74887, "contractexpirations" },
    { 0x3D625202, "contractexpired" },
    { 0xF0F168E3, "contractfail" },
    { 0x59F06DE4, "contractid" },
    { 0xBB81376D, "contractindex" },
    { 0x0FC0B6E0, "contractor" },
    { 0x3EDE458B, "contractors" },
    { 0x328DC274, "contractpass" },
    { 0xE1920D86, "contractrequirementmet" },
    { 0x1204B883, "contractrequirementsmet" },
    { 0x34F34F0A, "contracts" },
    { 0xB0387BB1, "contractsenabled" },
    { 0x6D8FFEBC, "contractsettings" },
    { 0xE9AC98D8, "contractstats" },
    { 0x0E43C080, "contractstattypes" },
    { 0x7AA49758, "contractstoprocess" },
    { 0xE23CC8AD, "contractwinevent" },
    { 0x827F34C8, "contrails" },
    { 0xCB6F1ADB, "contrast" },
    { 0x59202B42, "contrastmode" },
    { 0x63CD6773, "contributes" },
    { 0x5BE15680, "control" },
    { 0x03DE0BDC, "control_cam" },
    { 0xA49311E6, "control_chair" },
    { 0x75AC37FF, "control_final_lower" },
    { 0xF230B353, "control_final_wave" },
    { 0xE0405EA6, "control_initiated" },
    { 0xC1504C0B, "control_lights_groups" },
    { 0xB4B236E5, "control_lmg" },
    { 0x41D498E7, "control_nag" },
    { 0x1B993976, "control_room" },
    { 0x73A6B2A6, "control_room_a" },
    { 0xF0893325, "control_room_a_node" },
    { 0x4DA4383D, "control_room_b" },
    { 0xD9688C54, "control_room_b_node" },
    { 0x080662D9, "control_room_bigscreen" },
    { 0x27A1BDD4, "control_room_c" },
    { 0xA34C0153, "control_room_c_node" },
    { 0x7FA2FB21, "control_room_closet" },
    { 0x019F436B, "control_room_d" },
    { 0xC23FF4DA, "control_room_d_node" },
    { 0xE1D6A88F, "control_room_dialogue" },
    { 0x8805D5FD, "control_room_door" },
    { 0x432A695F, "control_room_drone_target" },
    { 0x73180D35, "control_room_exit" },
    { 0xDB0A5999, "control_room_noradscreen" },
    { 0x94189222, "control_room_player" },
    { 0x7FC54081, "control_room_player_2" },
    { 0x717A3347, "control_score" },
    { 0xFB48A49F, "control_spetz_slide" },
    { 0x63D6D307, "control_vec" },
    { 0x6B5FE3D3, "control_vision_set_glasses" },
    { 0xB7B26613, "controled" },
    { 0x2CC6CFCC, "controll" },
    { 0xFD3F9A14, "controllable" },
    { 0x3652CBAF, "controlled" },
    { 0xF21C46A9, "controller" },
    { 0xDAE8837E, "controller_layout" },
    { 0xF8DB07FB, "controller_layout_size_x" },
    { 0xD2D88D92, "controller_layout_size_y" },
    { 0x45D5D784, "controller_type" },
    { 0x5A4A7236, "controllercolor" },
    { 0x8CA942F0, "controllermodel" },
    { 0x3904D920, "controllers" },
    { 0xF214A7B1, "controllertype" },
    { 0x801A67B2, "controllevel" },
    { 0x165D987C, "controlling" },
    { 0x03DC1679, "controlroom_grigsby" },
    { 0x5F79738B, "controlroom_player" },
    { 0x3F193F73, "controlroom_price" },
    { 0x36D828AB, "controls" },
    { 0x21976B8C, "controls_active" },
    { 0x8A8EC184, "controlslinkto" },
    { 0xE642F97A, "controlsmenu" },
    { 0x51C41532, "controlsunlink" },
    { 0xF3C08521, "controlthe" },
    { 0xB74F93A4, "controlzoneentirely" },
    { 0x38CFDE7F, "contruction" },
    { 0x211FA132, "contruction_objectives" },
    { 0xF13C8D2C, "conv_fac" },
    { 0x01ED5214, "conveniece" },
    { 0x8968B0D6, "convenience" },
    { 0x0CA80B36, "convenient" },
    { 0x85303F3B, "conveniently" },
    { 0xC3D59C88, "convention" },
    { 0x129BB12F, "conventional" },
    { 0x22D5E5A3, "conventions" },
    { 0x38764711, "convered" },
    { 0x12CA9752, "converge" },
    { 0x1493FD97, "convergencetime" },
    { 0x1416C003, "converging" },
    { 0x69045940, "conversation" },
    { 0xA3B8486B, "conversations" },
    { 0x58D868BE, "converse" },
    { 0x4AA44A8D, "conversion" },
    { 0x7B22F90C, "conversions" },
    { 0x8BAED97E, "convert" },
    { 0x71669D4D, "convert_aiming_struct_to_origin" },
    { 0x94E6BB17, "convert_asd" },
    { 0x16D9CDCF, "convert_color_to_short_string" },
    { 0xAD6F5A69, "convert_guy_to_drone" },
    { 0x3A237B67, "convert_ips_to_mph" },
    { 0xCB5F7C1A, "convert_mason_models" },
    { 0x5F7E6FF1, "convert_mph_to_ips" },
    { 0x02B1E648, "convert_spawns_to_structs" },
    { 0xCAE6F134, "convert_tagent_to_ent" },
    { 0xB39DBBBE, "convert_time_to_str" },
    { 0x8A0C86C1, "converted" },
    { 0x0DF3BEA7, "converter" },
    { 0xDC164061, "converts" },
    { 0x468055D4, "convertsecondstomilliseconds" },
    { 0xAB5C2958, "convet" },
    { 0x3954BA1D, "convey" },
    { 0x9631FB0C, "conveyer" },
    { 0xEA21DE5D, "conveyer_belt_init" },
    { 0x700512E5, "conveyer_trigger" },
    { 0x2ADF4C0B, "conveying" },
    { 0xFA26CB22, "conveyor" },
    { 0x7581B49E, "convo" },
    { 0x244830C6, "convo_id" },
    { 0x16CD5D42, "convo_wait" },
    { 0x95853546, "convoluted" },
    { 0xAF94EF8B, "convoy" },
    { 0x6C4AF6D8, "convoy1" },
    { 0xFD99B816, "convoy1_clear" },
    { 0x136F458F, "convoy1_marineone" },
    { 0xACD00F9E, "convoy1_marineone_originalposition" },
    { 0x50E3068A, "convoy1_marineone_start" },
    { 0xE30A1735, "convoy1_motorcycle1" },
    { 0x6ED8158C, "convoy1_motorcycle1_originalposition" },
    { 0x0E6A446C, "convoy1_motorcycle1_start" },
    { 0x090C919E, "convoy1_motorcycle2" },
    { 0x294FD6D5, "convoy1_motorcycle2_originalposition" },
    { 0x87641F1F, "convoy1_motorcycle2_start" },
    { 0x57E22FBD, "convoy1_start" },
    { 0x9340165C, "convoy1originalposition" },
    { 0xDE526613, "convoy2" },
    { 0x91725D64, "convoy2_ai_react_to_stealth" },
    { 0x84170BB9, "convoy2_clear" },
    { 0x0AB33FBC, "convoy2_marineone" },
    { 0x0C78939B, "convoy2_marineone_originalposition" },
    { 0xD6514199, "convoy2_marineone_start" },
    { 0xE54E3781, "convoy2_outside_compound" },
    { 0x4E9FF0DE, "convoy2_past" },
    { 0x424B1EA6, "convoy2_stop" },
    { 0xB59799F1, "convoy2_truck_past_node" },
    { 0x07B8E33C, "convoy2loops" },
    { 0xB885BD03, "convoy_add_glow_shader" },
    { 0xDF393A70, "convoy_ai" },
    { 0x6AECD9D9, "convoy_array" },
    { 0x1994CD04, "convoy_at_dogfight" },
    { 0xCA46E699, "convoy_at_roadblock" },
    { 0x9AA6EED0, "convoy_attacked_by_sprinter_vans" },
    { 0x877D70A4, "convoy_audio" },
    { 0xA57C8C37, "convoy_awaken" },
    { 0x6531F80B, "convoy_barricade1_flamecave" },
    { 0x8F735465, "convoy_barricade1_flamecave_crush_barbedwire" },
    { 0xF8E39B5E, "convoy_barricade1_flamecave_faketankflame" },
    { 0xEAA9ADB0, "convoy_basic_fire_loop_rpg" },
    { 0x665CDB82, "convoy_being_fired_on" },
    { 0x73B66D74, "convoy_blocked_by_debris" },
    { 0x41487D17, "convoy_blown_anims" },
    { 0x9ED4FD31, "convoy_boat_add_driver" },
    { 0x34327112, "convoy_boat_add_gunner" },
    { 0x089C85B4, "convoy_boat_add_rpg_guy" },
    { 0x5682AEC0, "convoy_boat_spawn" },
    { 0xDB2258A1, "convoy_boat_speed_think" },
    { 0x8E2344F5, "convoy_crawlers" },
    { 0xEDEF263B, "convoy_deaths" },
    { 0x78CD65D2, "convoy_delete_counter" },
    { 0xF2CE16A1, "convoy_dialogdeathwatch" },
    { 0x7F03C974, "convoy_dialogiedproximitywatch" },
    { 0x8B9296AB, "convoy_dialogwatch" },
    { 0x9B7177A6, "convoy_distance_check" },
    { 0xFE53102D, "convoy_distance_check_stop" },
    { 0x7AF9F482, "convoy_distance_check_update" },
    { 0xB4EE2CA7, "convoy_do_anim" },
    { 0x7200A03D, "convoy_end" },
    { 0xFEB112BD, "convoy_flag_go" },
    { 0x49CCEE2B, "convoy_get_count_moving" },
    { 0x4645D96C, "convoy_get_count_stopped" },
    { 0xF7E441EA, "convoy_get_leader" },
    { 0xA932C40B, "convoy_get_path_node" },
    { 0x2367A886, "convoy_get_total_health" },
    { 0xB88C56F9, "convoy_ground_health_warning" },
    { 0x90340152, "convoy_guys_goto_nodes" },
    { 0xD35A2FB5, "convoy_healthatstart" },
    { 0xCC4125F5, "convoy_ied_bypassevent" },
    { 0xD6431153, "convoy_ied_lapwatch" },
    { 0x2383EBD2, "convoy_low_health_func" },
    { 0xDEC4ADE7, "convoy_members" },
    { 0x28A188E0, "convoy_mission_failed" },
    { 0x0D44D4A9, "convoy_monitor_health" },
    { 0xA657CDD0, "convoy_move_to_dogfight_position" },
    { 0x15CCD5E7, "convoy_move_to_position" },
    { 0x17F20693, "convoy_moveflag" },
    { 0xEFE295E2, "convoy_movement_barricade1" },
    { 0xBF565C53, "convoy_movement_bridge" },
    { 0x1C1CCD5F, "convoy_movement_destroy_mgnest" },
    { 0xF2272C55, "convoy_movement_sweep1" },
    { 0x1829A6BE, "convoy_movement_sweep2" },
    { 0xA9DD3D17, "convoy_open_barricade1" },
    { 0xE89D659F, "convoy_ownage" },
    { 0xF53BADD4, "convoy_pathing_start" },
    { 0x71FD42BB, "convoy_push_sdk" },
    { 0x617AF4E7, "convoy_register_stop_point" },
    { 0xEC169DA7, "convoy_regroup_check" },
    { 0x0CEBB4A8, "convoy_resumespeed" },
    { 0x5F6E8866, "convoy_set_leader" },
    { 0x71FCFC3F, "convoy_setspeed" },
    { 0x893366BD, "convoy_setup" },
    { 0xE4C2E351, "convoy_setup_fakehealth" },
    { 0x855A94F8, "convoy_setup_misc" },
    { 0xA1EC668A, "convoy_speed_check" },
    { 0xF80BAB3C, "convoy_speed_check_old" },
    { 0x9383A8CE, "convoy_stop" },
    { 0x6F5517FE, "convoy_stop_1" },
    { 0x49529D95, "convoy_stop_2" },
    { 0x2350232C, "convoy_stop_3" },
    { 0x2F896695, "convoy_stop_animation" },
    { 0xB751B37F, "convoy_stop_point_setup" },
    { 0x5C32EA6D, "convoy_stopped" },
    { 0xF23513DC, "convoy_stopped_by_ied" },
    { 0xACC7CBCD, "convoy_strafe_pip" },
    { 0xE79C4BA5, "convoy_strafing_exploders" },
    { 0xB77AC394, "convoy_strafing_fail_watcher" },
    { 0x677D4E47, "convoy_strafing_kill_cougar" },
    { 0xA07ADD9C, "convoy_sweep2_barbedwire_rollover" },
    { 0x06B6ED45, "convoy_trigger_proc" },
    { 0x0E4B6628, "convoy_trigger_setup" },
    { 0x5A23304B, "convoy_triggerwatch" },
    { 0xBF2DE36D, "convoy_up" },
    { 0xDB9EBDCE, "convoy_veh_stop" },
    { 0xF871C706, "convoy_vehicle_damage" },
    { 0x6AF0D327, "convoy_vehicle_flash_damage" },
    { 0xE90EAF8F, "convoy_vehicle_think" },
    { 0x506BCC9D, "convoy_vehicle_think_van" },
    { 0x1802902C, "convoy_waits_after_crane_building" },
    { 0xE99E8985, "convoy_waits_for_player_input" },
    { 0x11A0FCEA, "convoy_warning" },
    { 0xA858AE19, "convoy_wave2" },
    { 0x38EE85EA, "convoys" },
    { 0x543F805C, "convoywalk" },
    { 0x18E3D4F9, "convoywassetup" },
    { 0xCA488F99, "cook" },
    { 0x1846048E, "cook_off_chance" },
    { 0x534789C6, "cooked" },
    { 0x26D17A39, "cookedtime" },
    { 0x0B1D442F, "cooking" },
    { 0x22426380, "cookoff" },
    { 0x67FD1104, "cookoffholdtime" },
    { 0x861EFABC, "cookstages" },
    { 0x452B1B4E, "cooktime" },
    { 0x8854F3A6, "cool" },
    { 0xE22482CB, "cool_down_ent" },
    { 0x9F9EB622, "cool_down_over" },
    { 0x7BBCD1CF, "cool_down_timer" },
    { 0xF30D82E3, "cool_fx" },
    { 0x565C8686, "cool_ragdoll" },
    { 0x31F19FED, "cool_rage_death" },
    { 0x804EE9AE, "cooldown" },
    { 0x59B3A2BD, "cooldown_portal_timer" },
    { 0x06FB3EA5, "cooldown_switches" },
    { 0x9279CAAA, "cooldown_time" },
    { 0xCB33FAE8, "cooldown_time_attacker" },
    { 0xFB1B3014, "cooldown_time_entity" },
    { 0x09833188, "cooldown_time_global" },
    { 0xB6274FCD, "cooldown_time_global_start" },
    { 0x12EED3FC, "cooldown_timer" },
    { 0xB95BDE4D, "cooldown_weapon" },
    { 0xEB8B2B29, "cooled" },
    { 0x2FC1B02F, "cooler" },
    { 0xFC4E273A, "cooling" },
    { 0xDB99111D, "cooling_down" },
    { 0x1D14E58D, "cooloff" },
    { 0x24895A90, "coolrate" },
    { 0xBECEA1D9, "cools" },
    { 0x20E717F1, "coolsystem" },
    { 0xC03736BA, "coop" },
    { 0xE2C49328, "coop_allies_accuracy_scaler" },
    { 0x80E52FAD, "coop_axis_accuracy_scaler" },
    { 0xCA7AA540, "coop_bot_devgui_cmd" },
    { 0x09FE3B39, "coop_collectible" },
    { 0x093270A2, "coop_damage_and_accuracy_scaling" },
    { 0xA66B3DD5, "coop_death_invulnerability_time_modifier" },
    { 0xABA4E6AB, "coop_displacements" },
    { 0x82243644, "coop_enemy_accuracy_scalar" },
    { 0x4E14DCA9, "coop_enemy_accuracy_scalar_watcher" },
    { 0xCF830E5C, "coop_follow_radius_max" },
    { 0x4A1D6352, "coop_follow_radius_min" },
    { 0xB8384D83, "coop_friendly_accuracy_scalar" },
    { 0xA3F0621E, "coop_friendly_accuracy_scalar_watcher" },
    { 0x332FB907, "coop_healthscalar" },
    { 0x1E143D03, "coop_incap_weapon" },
    { 0x36C218FA, "coop_invuln_remover" },
    { 0x0F718639, "coop_linkto_flagbearer_start" },
    { 0xBA1BA51F, "coop_maxhealth_scalar_watcher" },
    { 0xDE0F1C4C, "coop_optimize" },
    { 0x71E37B45, "coop_optimize_remove_redshirt" },
    { 0xC939180A, "coop_player_give_flag_weapon" },
    { 0x598EBA42, "coop_player_spawn_placement" },
    { 0xCBFB3B50, "coop_player_take_flag_weapon" },
    { 0x4C34249A, "coop_player_threat_bias_adjuster" },
    { 0x5BEF6E1D, "coop_player_threatbias_scalar" },
    { 0xEA8D70A6, "coop_post_combat" },
    { 0x000FD797, "coop_pre_combat" },
    { 0x0714358D, "coop_scalar" },
    { 0x1012BFD5, "coop_set_spawner_adjustment_values" },
    { 0x46031771, "coop_sort" },
    { 0x2BFE4D56, "coop_spawner_count_adjuster" },
    { 0x19ADA90B, "coop_stat" },
    { 0xA40DC267, "coop_warp_complete" },
    { 0xCD638B1D, "coop_warp_player" },
    { 0x62566F4D, "cooped" },
    { 0xE6D96EBF, "coopepd" },
    { 0x72A4E1B6, "cooperation" },
    { 0x86B6D13C, "coopgame" },
    { 0x2FA3367A, "coopinfo" },
    { 0xD9D702F7, "coopoptimize" },
    { 0x2A39C27C, "coord" },
    { 0x658FE960, "coord_val" },
    { 0xF5F148F3, "coordinate" },
    { 0x644F44A2, "coordinates" },
    { 0x47BAD93F, "coords" },
    { 0xC907F849, "cop" },
    { 0x4F00F9BD, "cop_1" },
    { 0x75037426, "cop_2" },
    { 0x0F58B231, "cop_car_damage_override" },
    { 0x85E671B3, "cop_car_skid_done" },
    { 0xAEB7982B, "cop_sht" },
    { 0xD755D4E9, "cop_str" },
    { 0x675E847D, "copied" },
    { 0x952F6EB2, "copies" },
    { 0xB1D00AF7, "copilot" },
    { 0x34964CFF, "copilot_death_audio" },
    { 0x39FB944A, "copilot_predeath_audio" },
    { 0x4AD226D2, "copilot_spawner" },
    { 0xCC550714, "copilotvoicenumber" },
    { 0xAEAC1240, "cops" },
    { 0x70FBE567, "cops_damage_override" },
    { 0x26F00855, "copsiren1" },
    { 0x4CF282BE, "copsiren2" },
    { 0xCEE27FE2, "copter" },
    { 0x2CCB4F49, "copter_accellookahead" },
    { 0xE34DAEE3, "copter_exit_settings" },
    { 0xFF712967, "copter_maxaccel" },
    { 0xE8FF53E2, "copter_maxvel" },
    { 0x2B6E4FC1, "copter_pos" },
    { 0xC67FA2C9, "copter_rotspeed" },
    { 0x04ABB1DC, "copterai" },
    { 0x4D4749EE, "copterangles" },
    { 0xE667DB48, "coptercenteroffset" },
    { 0x20FF0749, "copterdamage" },
    { 0xEC6DD928, "copterdie" },
    { 0x2D7C2137, "copterexplodefx" },
    { 0x1E69A5FB, "copterexplosion" },
    { 0x9D972FAF, "copterfinalexplosion" },
    { 0x62ECE294, "coptermainrotor_fx" },
    { 0xF461CD39, "coptermove" },
    { 0xD0D94596, "coptermoverunning" },
    { 0x4A15E2AD, "copters" },
    { 0x2482C33F, "coptershoot" },
    { 0x3468BE35, "coptertailrotor_fx" },
    { 0xDFFB70AE, "coptertailrotordamaged_fx" },
    { 0xF3B7EE54, "coptertargetoffset" },
    { 0x2AC4DA5A, "copy" },
    { 0x4F6115DE, "copy_angles_of_selected_ents" },
    { 0x9941C4CF, "copy_cat" },
    { 0xABA4F11C, "copy_destructable_attachments" },
    { 0xCA7B75D3, "copy_destructible" },
    { 0xB0FFC6F1, "copy_dynent" },
    { 0xFFB51F50, "copy_ent" },
    { 0xAB122C3B, "copy_ents" },
    { 0x913A8431, "copy_fx_ent" },
    { 0xB2BC671C, "copy_miscmodel" },
    { 0x93A0E150, "copy_model" },
    { 0x1894C228, "copy_name" },
    { 0x6ED79FA5, "copy_orientation" },
    { 0xFE739D8B, "copy_powerup" },
    { 0xB0034803, "copy_scene" },
    { 0xC7A0D3E9, "copy_shot" },
    { 0x2EB0D321, "copy_thread" },
    { 0x1B3CA94C, "copy_values_between_fx_ents" },
    { 0x0B062F40, "copy_zombie_keys_onto_trigger" },
    { 0x5A924736, "copycat" },
    { 0x63C0FB84, "copycat_button_create" },
    { 0x91AC537D, "copycat_button_press" },
    { 0xA46FEAA0, "copycat_button_think" },
    { 0xA16A7965, "copycat_clone_loadout" },
    { 0xCF1ABA1F, "copycat_give_inventory" },
    { 0x6F84AFB6, "copycat_give_killstreaks" },
    { 0xDC13D7E7, "copycat_give_loadout" },
    { 0x2C138DF0, "copycat_give_perks" },
    { 0x8E988ADE, "copycat_give_primary_grenade" },
    { 0x911712C0, "copycat_give_primary_weapon" },
    { 0xDEA8B31D, "copycat_give_sidearm_weapon" },
    { 0x8AE33715, "copycat_give_special_grenade" },
    { 0x0713E890, "copycat_in_use" },
    { 0xDBDB7F3F, "copycat_remove_deathstreaks" },
    { 0x57211C8F, "copycat_text_create" },
    { 0xA688DB6A, "copycat_used" },
    { 0x142D7CEB, "copydestructstate" },
    { 0x33125CF3, "copygibstate" },
    { 0x37633A96, "copying" },
    { 0x62A7B04E, "copypowerup" },
    { 0xA37393DC, "copyright" },
    { 0x8D650E0C, "cor_trig" },
    { 0xB40A64E4, "coral" },
    { 0x069856B6, "corcky" },
    { 0x1613DE05, "cord" },
    { 0xABE1BCC5, "cord_pull" },
    { 0x49450E81, "cordis" },
    { 0xF011639C, "core" },
    { 0xDB526C07, "core_door" },
    { 0xA0700A5A, "core_entities" },
    { 0x0AE8E9F2, "core_model" },
    { 0x9B0E9CD2, "core_mover" },
    { 0x1EC3415F, "core_pos" },
    { 0x491E56F3, "coremove" },
    { 0x7DB68889, "corerotate" },
    { 0x5851AFDF, "cores" },
    { 0xDD361AC5, "coriolis" },
    { 0x73F89B82, "cork" },
    { 0xC89AC1E7, "corky" },
    { 0x874FFBF6, "corky_node" },
    { 0x3204FF8F, "corn" },
    { 0xA684B472, "corner" },
    { 0xB55F0326, "corner0" },
    { 0xDB617D8F, "corner1" },
    { 0x695A0E54, "corner2" },
    { 0x8F5C88BD, "corner3" },
    { 0x3A78DD29, "corner_approach" },
    { 0x00DBBC12, "corner_axis" },
    { 0xD8CC8160, "corner_left_ab_yaw" },
    { 0xF05B2BC2, "corner_left_lean_yaw_max" },
    { 0x9F4566E0, "corner_prediction_distance" },
    { 0xA53C0A57, "corner_predictor_status_arriving_cover" },
    { 0x47FD2CEE, "corner_predictor_status_arriving_exposed" },
    { 0x37375419, "corner_predictor_status_exiting_cover" },
    { 0x6D2B0258, "corner_predictor_status_exiting_exposed" },
    { 0x115058DC, "corner_predictor_status_no_path" },
    { 0x6C8E201C, "corner_predictor_status_straight_line_to_goal" },
    { 0xC1DFB6F4, "corner_predictor_status_success" },
    { 0xE9B47E0D, "corner_right_ab_yaw" },
    { 0x8A274FAB, "corner_right_lean_yaw_max" },
    { 0x37E2FC23, "corner_sign_models" },
    { 0x9E520817, "corner_straight_yaw_limit" },
    { 0xA8DC9737, "corner_think" },
    { 0x60E5DFD7, "corneraiming" },
    { 0xD57409A7, "cornerangle" },
    { 0x5C960753, "cornerdeathreleasegrenade" },
    { 0x9BA04C3F, "cornerdiff" },
    { 0x219488A7, "cornerdir" },
    { 0xE398DDC1, "cornerdirection" },
    { 0x99FB3DFC, "cornerdirlen" },
    { 0x7E0BE32E, "cornerdist" },
    { 0x686ADC0A, "cornerdistsq" },
    { 0x15CD8AFE, "cornering" },
    { 0x4D0D2064, "cornerleftdirection" },
    { 0x92069A37, "cornermode" },
    { 0x3BCF3E16, "cornernode" },
    { 0x48B92A50, "cornerorigin" },
    { 0x0B618561, "cornerreload" },
    { 0x7828B2F8, "cornerrightgrenadedeath" },
    { 0x0FFB22FD, "corners" },
    { 0x0E3D491A, "cornertotarget" },
    { 0x119A9ABF, "cornertotargetlen" },
    { 0x562FB7CB, "corneryaw" },
    { 0x0A7286B5, "cornfield" },
    { 0x9608E084, "cornfields" },
    { 0x37B5E7CC, "corny" },
    { 0x1099A36C, "coronas" },
    { 0x0722039A, "corporate" },
    { 0x01E25855, "corpse" },
    { 0xF428BA38, "corpse_adder" },
    { 0x4C65ED7B, "corpse_alley" },
    { 0x01475D71, "corpse_alley_drone_fires_at_civ" },
    { 0x5D8EC754, "corpse_alley_player_done" },
    { 0x06A9998C, "corpse_alley_player_jump_rumble" },
    { 0xBA057683, "corpse_alley_player_started" },
    { 0x9F8EC9C8, "corpse_alley_scene_setup" },
    { 0x429EA3EE, "corpse_alley_spotlight_on_player" },
    { 0x7DB99F41, "corpse_alley_started" },
    { 0x7070646E, "corpse_anims" },
    { 0x5471C2EF, "corpse_array" },
    { 0x4200E999, "corpse_back" },
    { 0x5D7A08A6, "corpse_burn_duration" },
    { 0x49123255, "corpse_character_funcs" },
    { 0xDBDDCDE4, "corpse_counter" },
    { 0xCD78FC15, "corpse_delay" },
    { 0x76D64C59, "corpse_entity" },
    { 0x3850E4F7, "corpse_explode" },
    { 0x499B298E, "corpse_flag" },
    { 0x45B53EA4, "corpse_found" },
    { 0xABE8275D, "corpse_front" },
    { 0x1D54A935, "corpse_funcs" },
    { 0x0EBA238B, "corpse_functions" },
    { 0x431C07D9, "corpse_height" },
    { 0x6114103D, "corpse_in_front" },
    { 0x3801B31E, "corpse_init" },
    { 0x10D3F942, "corpse_memory_damage_override" },
    { 0x57CD95BC, "corpse_memory_guys" },
    { 0x7AF7DFBA, "corpse_memory_init" },
    { 0xC38CAC76, "corpse_memory_place_models" },
    { 0x6EAA83AB, "corpse_memory_spawnfunc" },
    { 0x9FA0D57F, "corpse_model" },
    { 0x5260204F, "corpse_mover" },
    { 0x9B5E3163, "corpse_off_navmesh_watcher" },
    { 0xCD7B59A5, "corpse_push_think" },
    { 0x682EB8B8, "corpse_reach_fail" },
    { 0xA640B895, "corpse_room_cleanup_watcher" },
    { 0xF8A37712, "corpse_room_revive_watcher" },
    { 0x4D1D366C, "corpse_room_watcher" },
    { 0x83AF7B88, "corpse_sci_memory_damage_override" },
    { 0x526FD171, "corpse_sci_memory_spawnfunc" },
    { 0x6C36385F, "corpse_setup" },
    { 0xAE75A3E3, "corpse_sink_and_delete" },
    { 0xC4025C12, "corpse_structs" },
    { 0x5F2F12EC, "corpse_toggle" },
    { 0x0B33BA86, "corpse_total" },
    { 0x62290383, "corpse_trace" },
    { 0x0AB3DAE6, "corpse_trig" },
    { 0x0B7EC04A, "corpse_zone" },
    { 0x7F28A38A, "corpsecount" },
    { 0xC55CCA1F, "corpsedeletetime" },
    { 0x2D69F5DC, "corpsefind_wait" },
    { 0x0B071D8C, "corpseflamefx" },
    { 0x393410A4, "corpses" },
    { 0xC94A1D03, "corpses_b" },
    { 0x2D62BD7D, "corpsespot" },
    { 0xB258B094, "corpsman" },
    { 0xE6111FF1, "corral_jumper_logic" },
    { 0xE7DBF708, "corrcetly" },
    { 0x92753FE4, "corrdinate" },
    { 0xAB6D45A1, "correct" },
    { 0x369A8490, "correct_colored_friendlies" },
    { 0xA2B36EB6, "correct_colored_guy" },
    { 0x92685F60, "correct_input" },
    { 0x5A37FD8C, "correct_notes_playing" },
    { 0x7F884B2C, "correct_surface_type_for_screen_fx" },
    { 0xEA0601A8, "correct_tile" },
    { 0x23431EEC, "correct_type" },
    { 0xA77703BE, "correctangle" },
    { 0xD96DF7A1, "correctangles" },
    { 0xB68ABE67, "correcting" },
    { 0x07513A5D, "correction" },
    { 0xD14643AF, "correctish" },
    { 0xAC5D3F2C, "correctly" },
    { 0x4A7D5DC4, "correctness" },
    { 0x6AE79F48, "corrects" },
    { 0xB966DDB2, "corrent" },
    { 0xF735CE98, "correponds" },
    { 0x5C105546, "correspond" },
    { 0x9852C15A, "corresponding" },
    { 0x2CED81F9, "corresponds" },
    { 0x644BA53B, "corridor" },
    { 0xD0549A8C, "corridor2_fighting" },
    { 0xFCBD9664, "corridor_fighting" },
    { 0xA43F3CDA, "corridors" },
    { 0x271C5785, "corroborate" },
    { 0x4A397030, "corrosponding" },
    { 0x6D337CC7, "corrugated" },
    { 0x531F5AC0, "corrupt" },
    { 0x3C57D152, "corruption" },
    { 0x4C24E0EE, "corsair" },
    { 0x660E33F1, "corsair_fire" },
    { 0x46B3AC07, "corsair_highlight" },
    { 0x550D4645, "corsair_pacing_distance" },
    { 0x5E178EC8, "corsair_path" },
    { 0x39E374E3, "corsair_paths" },
    { 0x6A811243, "corsair_pby_pacing" },
    { 0xD7582E5E, "corsair_right_lead" },
    { 0xD935D227, "corsair_spin_prop" },
    { 0xC0E8231A, "corsair_turret_think" },
    { 0x86D1DD11, "corsairs" },
    { 0xB2771599, "corsairs_arrive" },
    { 0x8965D53F, "corsairs_chasing_zeros" },
    { 0x12B2A137, "corsairs_chasing_zeros_spawn" },
    { 0xEF0A72B2, "cos" },
    { 0xC1A5D6ED, "cos10" },
    { 0xE2B7171D, "cos120" },
    { 0x039972E0, "cos15" },
    { 0x1C6E97FF, "cos180" },
    { 0x04F1BD0C, "cos20" },
    { 0x947E4CFB, "cos45" },
    { 0x865A56E1, "cos50" },
    { 0x0956EFE0, "cos60" },
    { 0x79F4BDFA, "cos80" },
    { 0xF88C2425, "cos90" },
    { 0x71E9A448, "cos_45" },
    { 0x32C73BFF, "cos_60" },
    { 0xDB3C575E, "cos_angle" },
    { 0x6525BB7F, "cosa" },
    { 0xA6AF27E7, "cosangle" },
    { 0xD99655CD, "coscurrent" },
    { 0x6FC7B06C, "cosine" },
    { 0x5331E8A6, "cosine55" },
    { 0xFFE5E640, "cosmetic" },
    { 0x519E1063, "cosmic" },
    { 0x63707A8E, "cosmo" },
    { 0x349FC685, "cosmo_on_player_connect" },
    { 0x3C425FB5, "cosmo_on_player_spawned" },
    { 0x602F3CD5, "cosmodrome" },
    { 0x918D6A60, "cosmodrome_collision_fix" },
    { 0x3F6A09B0, "cosmodrome_first_vision_set" },
    { 0xD6CB7ADC, "cosmodrome_intermission" },
    { 0xDC03417C, "cosmodrome_maintenance_respawn_fix" },
    { 0x47FF6036, "cosmodrome_monkey_round_start_listener" },
    { 0x01B6520C, "cosmodrome_offhand_weapon_overrride" },
    { 0x282DC41B, "cosmodrome_power_vision_set_swap" },
    { 0xD5811623, "cosmodrome_precache" },
    { 0x9DD61969, "cosmodrome_rocket_fx" },
    { 0xC1096C8F, "cosmodrome_screen_switch" },
    { 0x85E41F6F, "cosmodrome_tv_init" },
    { 0xFB0ED8AD, "cosmodrome_tvs" },
    { 0x489883E1, "cosmodrome_vision_set" },
    { 0x9635D667, "cosmodrome_zone_init" },
    { 0xD4368A60, "cosmodrome_zpo_listener" },
    { 0x92B9FEBD, "cosmonauts" },
    { 0x3110787C, "cospitch" },
    { 0x0740FE02, "cost" },
    { 0xC8989CF1, "cost_door" },
    { 0x774657D3, "cost_func" },
    { 0x92C2E0C5, "cost_high" },
    { 0x322D7225, "cost_low_if_local" },
    { 0x7F1BA003, "cost_negligible" },
    { 0xFE4E69D3, "costhreshold" },
    { 0x39C53C6E, "costing" },
    { 0xA775094D, "costs" },
    { 0x69B54A75, "cotton1" },
    { 0x2EB94EFD, "couch" },
    { 0x0E745194, "coudl" },
    { 0xBBC6D332, "cougar" },
    { 0xDFA5FFCB, "cougar3_aim" },
    { 0x61DF8BB6, "cougar_anim" },
    { 0xFF42047F, "cougar_blend_go" },
    { 0x259F3B80, "cougar_chatter" },
    { 0x48772141, "cougar_controls_instructions" },
    { 0x10D60876, "cougar_crash_big_rig" },
    { 0x666B6531, "cougar_crash_snapshot" },
    { 0x30575535, "cougar_crawl_drone" },
    { 0x7933D511, "cougar_crawl_player_done" },
    { 0x63660982, "cougar_crawl_squibs" },
    { 0xA8FA35FD, "cougar_damage_override" },
    { 0x52DBFDBB, "cougar_damage_states" },
    { 0xF60C6C75, "cougar_down" },
    { 0xEF2C2EB1, "cougar_exit" },
    { 0x6B6DFBCF, "cougar_exit_claw_noharper" },
    { 0x28345301, "cougar_exit_claw_noharper_obj" },
    { 0xE81CA30D, "cougar_exit_cop_car" },
    { 0x95CA4428, "cougar_exit_dof1" },
    { 0x07D1B363, "cougar_exit_dof2" },
    { 0xE1CF38FA, "cougar_exit_dof3" },
    { 0x53D6A835, "cougar_exit_dof4" },
    { 0x2DD42DCC, "cougar_exit_dof5" },
    { 0x9FDB9D07, "cougar_exit_dof6" },
    { 0x3D701AC9, "cougar_exit_everything_else" },
    { 0x4DFADFE3, "cougar_exit_player" },
    { 0xED5291A6, "cougar_fall" },
    { 0x6F91D645, "cougar_fall_dof1" },
    { 0x959450AE, "cougar_fall_dof2" },
    { 0xBB96CB17, "cougar_fall_dof3" },
    { 0x8CE6DB95, "cougar_fall_exploders" },
    { 0x543CC702, "cougar_godrays" },
    { 0x89A16BB3, "cougar_jump_duck" },
    { 0x3A16B528, "cougar_radio_chatter" },
    { 0x92946F69, "cougar_radio_chatter_cleanup" },
    { 0x769F26E9, "cougar_rattle_scaling" },
    { 0x6B4403C4, "cougar_setup" },
    { 0xFC7E54A8, "cougar_steer_anim" },
    { 0xDCBCFAAA, "cougar_up" },
    { 0x09C00F64, "cougar_vol" },
    { 0x9775CB04, "cougar_wall_smash" },
    { 0x45D456BD, "cougars" },
    { 0x9208F3E1, "cough" },
    { 0xB4BF93A4, "cough_done" },
    { 0x0534A3F3, "cough_player" },
    { 0x345999BB, "cough_run_manager" },
    { 0x12865030, "cough_to_goal1" },
    { 0x848DBF6B, "cough_to_goal2" },
    { 0x241741C8, "cougher" },
    { 0xB6B984A7, "coughing" },
    { 0xF70C1563, "coughing_guy" },
    { 0x656B0319, "coughtype" },
    { 0x47528A84, "could" },
    { 0xC0CC8522, "couldnt" },
    { 0x4037693D, "couldntseeenemypos" },
    { 0x146D8392, "cound" },
    { 0x74952A22, "count" },
    { 0x63CCED2E, "count_alive_scientists" },
    { 0x786245EB, "count_allies" },
    { 0xCE6A3F02, "count_axis" },
    { 0xEA1008EC, "count_deaths" },
    { 0x71C6D145, "count_down" },
    { 0x7B7ACD24, "count_drones" },
    { 0xB831AC08, "count_gone" },
    { 0x1E1FE32B, "count_guys_by_script_noteworthy" },
    { 0xD10408E9, "count_keys" },
    { 0x5A85F779, "count_max" },
    { 0xB7A63F07, "count_min" },
    { 0xB98C76A2, "count_network_frames" },
    { 0x193A1A91, "count_players" },
    { 0x0C9473CC, "count_players_in_gr_head" },
    { 0xAD718D2B, "count_preexisting_dogs" },
    { 0x06C0A645, "count_staff_piece_pickup" },
    { 0x32C9792A, "count_target" },
    { 0x15986B94, "count_teh_time" },
    { 0x41CAC60E, "count_to_reach" },
    { 0xA7B36C06, "count_unload_que" },
    { 0xF849675A, "count_up" },
    { 0xA5B7466D, "count_zombies_in_zone" },
    { 0x62E34390, "countallies" },
    { 0xD5C1822C, "countaskillstreakvehicle" },
    { 0x25D2C491, "countaxis" },
    { 0x2C8DB1BA, "countdown" },
    { 0xF12FD75F, "countdown_begins" },
    { 0x13BA054D, "countdown_done" },
    { 0xC2EFBD30, "countdown_elem" },
    { 0x236C0222, "countdown_events" },
    { 0x51439D77, "countdown_finished" },
    { 0xE07ABAD8, "countdown_hud" },
    { 0x448C6709, "countdown_hudelem" },
    { 0x2BD493A2, "countdown_invalidate_achievement" },
    { 0x9FA9A67A, "countdown_reminder_thread" },
    { 0x492867C7, "countdown_speech" },
    { 0x7C10957C, "countdown_to_boom" },
    { 0xC0517085, "countdown_to_death" },
    { 0x005717C9, "countdown_to_kill" },
    { 0x55DEF242, "countdownl" },
    { 0x1E0BCB98, "countdownmgr" },
    { 0x71D013CC, "countdownr" },
    { 0x135F1855, "countdowntime" },
    { 0x3E04E9D4, "countdowntimerelem" },
    { 0xFA4D6F35, "counted" },
    { 0x0E7020F3, "counter" },
    { 0x51133FBA, "counter_100s" },
    { 0xC7473E20, "counter_10s" },
    { 0xE8874DD2, "counter_1s" },
    { 0x8056ADD5, "counter_model" },
    { 0xA2FCE333, "counter_name" },
    { 0xE6717DD6, "counter_num" },
    { 0x9E148C88, "counter_uav_acceleration_percentage" },
    { 0x2E7887FB, "counter_uav_deceleration_percentage" },
    { 0xC10D67A8, "counter_uav_duration_check" },
    { 0x11E37084, "counter_uav_duration_ms" },
    { 0xBF9D4BB0, "counter_uav_entities" },
    { 0x9A4805E4, "counter_uav_group_offset" },
    { 0xA35FAC4A, "counter_uav_group_size" },
    { 0x1E06C427, "counter_uav_health" },
    { 0xB20CE477, "counter_uav_killstreak_name" },
    { 0xE38B27BC, "counter_uav_location_duration_max" },
    { 0x609FE5B2, "counter_uav_location_duration_min" },
    { 0xE76B843B, "counter_uav_loop_sound" },
    { 0x5AE4E37E, "counter_uav_low_health" },
    { 0x7F1B15D4, "counter_uav_map_percentage" },
    { 0x4B36CB03, "counter_uav_model_scale" },
    { 0xC5A58285, "counter_uav_move_" },
    { 0x2A0F86C0, "counter_uav_name" },
    { 0x8E1B8A03, "counter_uav_offsets" },
    { 0xD2CEBB1C, "counter_uav_position_count" },
    { 0xF2976C31, "counter_uav_position_index" },
    { 0xD85FA843, "counter_uav_position_z_offset" },
    { 0x734CAFE3, "counter_uav_positions" },
    { 0x369302D1, "counter_uav_rotation_acceleration_percentage" },
    { 0x798A7AAE, "counter_uav_rotation_deceleration_percentage" },
    { 0x8E071C96, "counter_uav_rotation_duration" },
    { 0x72DF77B2, "counter_uav_speed" },
    { 0x6696B88E, "counter_uav_updated" },
    { 0xC00D3F8B, "counter_uav_vehicle_name" },
    { 0xE056B595, "counter_var" },
    { 0x243F0E35, "counteract" },
    { 0x302A8EFB, "counterattack" },
    { 0x2D665E6F, "countercycle" },
    { 0x0FEE6E2C, "counterm" },
    { 0xF3FD4CA2, "counters" },
    { 0x342821D3, "counterspyplane" },
    { 0x65EE1DF9, "counteruav" },
    { 0x3C868CCE, "counteruav_initialize" },
    { 0x1D3810DB, "counteruav_off" },
    { 0x8752903C, "counteruav_think" },
    { 0x16BFD239, "counteruav_watchfor_gamerules_destruction" },
    { 0xDCF04ABB, "counteruavchanged" },
    { 0xA4B18691, "counteruavlength" },
    { 0x05A34957, "counteruavlight" },
    { 0x169E31A0, "counteruavmodel" },
    { 0x561A049E, "counteruavmove" },
    { 0x8FB52941, "counteruavplane" },
    { 0x6DCCA1EA, "counteruavplane_death" },
    { 0x606E71B7, "counteruavplane_death_waiter" },
    { 0xF1CD81A5, "counteruavplane_timeout" },
    { 0xB6D11918, "counteruavplaneentrancetime" },
    { 0x745C0766, "counteruavplaneexittime" },
    { 0x8A7C78C1, "counteruavrig" },
    { 0x9CAA1930, "counteruavs" },
    { 0x113F87AE, "counteruavtime" },
    { 0xAE446BAD, "counteruavviewtime" },
    { 0x54C60949, "counteruavweapon" },
    { 0xDFB0700E, "counting" },
    { 0x59FAA9FC, "countlife" },
    { 0x9A05E278, "countmax" },
    { 0x4AE1F4E4, "countme" },
    { 0x08009433, "countourtrace" },
    { 0x8D6989AC, "countplayers" },
    { 0xF8C69D05, "countries" },
    { 0x53D62EDD, "countrol" },
    { 0x86F9831D, "country" },
    { 0xD26B5866, "countryid" },
    { 0x1ED20799, "countryids" },
    { 0x2D8B924F, "countrymen" },
    { 0x639519ED, "counts" },
    { 0x955A86BD, "countstowardrampage" },
    { 0xCCEF27DD, "counttime" },
    { 0x14C5783A, "counttowards" },
    { 0xF4125AFD, "countupduration" },
    { 0x9C79B3FC, "coup" },
    { 0x3ED56DED, "coup_amb" },
    { 0x6F884E04, "coup_anim" },
    { 0xB0A336C2, "coup_art" },
    { 0xAF38276F, "coup_audio" },
    { 0x3FD1D808, "coup_code" },
    { 0x05F2CAF5, "coup_fx" },
    { 0x74DB86B1, "coupla" },
    { 0x0CE57055, "couple" },
    { 0xBA1C2999, "couple_approach_window_anim" },
    { 0x3B3F7406, "couplea" },
    { 0x153CF99D, "coupleb" },
    { 0xEB53CD8F, "courage" },
    { 0x149012C6, "courier" },
    { 0x7E9F71BE, "course" },
    { 0x8E1321A1, "courses" },
    { 0xBC0B3C54, "court_chest" },
    { 0xD4CDDBEA, "courtyard" },
    { 0x5996D8C9, "courtyard_50cal_damage_override" },
    { 0x260BD2E8, "courtyard_aa_gun_1" },
    { 0x98134223, "courtyard_aa_gun_2" },
    { 0x7210C7BA, "courtyard_aa_gun_3" },
    { 0x11B1A8F4, "courtyard_adjust_threatbias" },
    { 0x8F8D2440, "courtyard_ai_behavior" },
    { 0xD031266D, "courtyard_ambience" },
    { 0x05EF8418, "courtyard_arrive" },
    { 0x0807C723, "courtyard_asd" },
    { 0xDED32418, "courtyard_asd_spawned" },
    { 0x10E0801B, "courtyard_asd_target_spawnfunc" },
    { 0xA1E656E3, "courtyard_axis_retreat_watcher" },
    { 0x0F6CBBC3, "courtyard_baddies" },
    { 0xA59178C8, "courtyard_baddies_logic" },
    { 0xD54F19B1, "courtyard_blocker" },
    { 0x85AF8CA5, "courtyard_blocker_truck" },
    { 0x7ADEDF2B, "courtyard_bomb_run" },
    { 0x9408912F, "courtyard_btr" },
    { 0xAAC5E382, "courtyard_btr_failsafe_trig" },
    { 0xBDF7EA64, "courtyard_btr_logic" },
    { 0x9E18D12C, "courtyard_btr_spawned" },
    { 0xBD697976, "courtyard_btrs" },
    { 0xD6E930D8, "courtyard_cartel_truck_gunner_dies" },
    { 0x47A82EFF, "courtyard_castle_spawners" },
    { 0xC22B995A, "courtyard_center_target" },
    { 0x7382762F, "courtyard_cleanup" },
    { 0x3491252B, "courtyard_cleanup_timeout" },
    { 0x368A4E84, "courtyard_clear" },
    { 0x824EFCE7, "courtyard_cleared" },
    { 0x42BA6574, "courtyard_color_chain" },
    { 0x4D28A6AF, "courtyard_depart" },
    { 0x4B75BD48, "courtyard_dialog_think" },
    { 0x82E02AD7, "courtyard_dragon_falls" },
    { 0x5F31CF21, "courtyard_drone_behaviour" },
    { 0xBA68D8D4, "courtyard_drone_cleanup" },
    { 0xCEAB8F76, "courtyard_event_done" },
    { 0xC156E78B, "courtyard_explosion_fx" },
    { 0x8355F6C6, "courtyard_fire_fake_rocket" },
    { 0x16B5335C, "courtyard_fire_flare" },
    { 0x4B68CE9F, "courtyard_floor2_spawnfunc" },
    { 0x7156D1AC, "courtyard_fountain_open" },
    { 0xD77AAA84, "courtyard_friendly_manager" },
    { 0x937211F6, "courtyard_friendly_vo" },
    { 0xAB9BF65C, "courtyard_gate" },
    { 0x8BCAC3FA, "courtyard_gate_nodes" },
    { 0x29FD6287, "courtyard_gate_open" },
    { 0xEAB75213, "courtyard_guards_alerted" },
    { 0x37AA84D0, "courtyard_gunner" },
    { 0x5767C479, "courtyard_gunner_think" },
    { 0x15CBE3A1, "courtyard_heli" },
    { 0x2908C44E, "courtyard_heli_allies" },
    { 0x8835D093, "courtyard_heli_anim" },
    { 0x74D83D2D, "courtyard_heli_drones" },
    { 0x55AD9FC0, "courtyard_heli_fail" },
    { 0xC379EDF4, "courtyard_heli_free_fly" },
    { 0xF62F24B3, "courtyard_heli_player" },
    { 0x406A8954, "courtyard_heli_think" },
    { 0x542521A9, "courtyard_heli_vo" },
    { 0x4782868B, "courtyard_heli_vo_reveal" },
    { 0x1C03EEA6, "courtyard_heli_waves" },
    { 0xE65A0EB6, "courtyard_hint" },
    { 0x27EBF27D, "courtyard_intro" },
    { 0xBA2A0005, "courtyard_intro_vo" },
    { 0xB73660FB, "courtyard_kill_off" },
    { 0x3F23716B, "courtyard_left_gate_door" },
    { 0x0C74FA5C, "courtyard_left_metalstorm_think" },
    { 0xA8B78145, "courtyard_logic" },
    { 0xDE553459, "courtyard_magic_rpgs" },
    { 0xADA2CA16, "courtyard_main" },
    { 0x95D76B88, "courtyard_metalstorm_think" },
    { 0x9C8FAEFE, "courtyard_mg_stuff" },
    { 0xFAC1C0B1, "courtyard_nag_lines" },
    { 0x6F2CF426, "courtyard_north_spawners" },
    { 0x779C9F15, "courtyard_objectives" },
    { 0x60F69FB9, "courtyard_patroller_behavior" },
    { 0x09039DDC, "courtyard_pdf_wave_1_fallback" },
    { 0x12EB2E57, "courtyard_prespawn_smoke" },
    { 0xC67F408B, "courtyard_rain" },
    { 0xB9CC6847, "courtyard_reznov_block" },
    { 0x769B4570, "courtyard_right_gate_door" },
    { 0x0F3E054D, "courtyard_right_metalstorm_think" },
    { 0xF4846003, "courtyard_right_target" },
    { 0xF023E178, "courtyard_right_target_2" },
    { 0xB6A1B761, "courtyard_rope" },
    { 0x4A2C7D53, "courtyard_rope_anim" },
    { 0x55E21969, "courtyard_rope_vo" },
    { 0xB4DBB470, "courtyard_runner_logic" },
    { 0x30AEE1B9, "courtyard_sounds" },
    { 0x0D3CA2F2, "courtyard_spawn" },
    { 0xF66DCDD2, "courtyard_spawn_funcs" },
    { 0xFE4EFF4F, "courtyard_teleport_reznov" },
    { 0x62571D1E, "courtyard_teleport_reznov_inside" },
    { 0x734A53DA, "courtyard_threatbias_group" },
    { 0x720E0210, "courtyard_timed_beats" },
    { 0x512E3F29, "courtyard_too" },
    { 0xA7A82D38, "courtyard_tower_target" },
    { 0x35FB85FF, "courtyard_tower_target_2" },
    { 0xAEB2713B, "courtyard_truck_spawn_func" },
    { 0xFBCA0872, "courtyard_trucks_2" },
    { 0x21CC82DB, "courtyard_trucks_3" },
    { 0xAE13B0BB, "courtyard_uaz" },
    { 0xA2E21D90, "courtyard_uaz_damage_override" },
    { 0xC0C24C0B, "courtyard_upstairs_dialog" },
    { 0xE2C16812, "courtyard_vehicles" },
    { 0x888DCA67, "courtyard_volume" },
    { 0x827E3830, "courtyard_vtol_one_fx" },
    { 0x88B875F3, "courtyard_vtol_think" },
    { 0xEE9923DA, "courtyard_vtol_two_fx" },
    { 0xE485AAA5, "courtyards" },
    { 0x76655182, "cover" },
    { 0x49D4938A, "cover_1" },
    { 0x23D21921, "cover_2" },
    { 0x233B8FAE, "cover_2_optional_vo" },
    { 0xFDCF9EB8, "cover_3" },
    { 0x0D3E0D8B, "cover_3_optional_vo" },
    { 0x9E1270B0, "cover_after_ambush" },
    { 0x5A9C5B57, "cover_aim_angle_epsilon" },
    { 0xFFA71599, "cover_alert_mode" },
    { 0x87455A51, "cover_any" },
    { 0xFFB37460, "cover_array" },
    { 0xA9F8D1DE, "cover_array_geo" },
    { 0x48071AC0, "cover_arrival" },
    { 0x989F4DE2, "cover_back_direction" },
    { 0xF8D3DFC7, "cover_behavior" },
    { 0xD6685844, "cover_blind_mode" },
    { 0xF344B14D, "cover_blown" },
    { 0x73DD4FAF, "cover_blown_player" },
    { 0x789526FD, "cover_choppers" },
    { 0x47F6C383, "cover_close" },
    { 0xC105D63D, "cover_conceal_crouch" },
    { 0x048E6D47, "cover_concealed" },
    { 0x90160C4F, "cover_convoy" },
    { 0xE5EEACFE, "cover_corner" },
    { 0x0AC84828, "cover_corner_valid_yaw_range_max" },
    { 0x656E26B6, "cover_corner_valid_yaw_range_min" },
    { 0x1248CA13, "cover_crouch" },
    { 0x9E320137, "cover_crouch_offset" },
    { 0x1DD38ED2, "cover_crouch_think" },
    { 0x1B0CDDCC, "cover_direction" },
    { 0xFCECB771, "cover_door" },
    { 0x64548E78, "cover_ent" },
    { 0x409A1037, "cover_exposed" },
    { 0xD2704B25, "cover_fire" },
    { 0xEC0920F0, "cover_fire_stop" },
    { 0x12C96041, "cover_fire_timeout" },
    { 0x2F8CBF80, "cover_from_heli" },
    { 0x59A7D578, "cover_front_direction" },
    { 0x490744D8, "cover_guard" },
    { 0xE7B2C358, "cover_hill" },
    { 0x8A38D761, "cover_lean_mode" },
    { 0x3D772BD6, "cover_left" },
    { 0x6AD6B953, "cover_left_crouch_offset" },
    { 0x5533C400, "cover_left_direction" },
    { 0x6E8E84E4, "cover_left_offset" },
    { 0x81FCB0D7, "cover_left_stand_offset" },
    { 0x38BC1904, "cover_left_yaw_offset" },
    { 0xC888901C, "cover_mode" },
    { 0x1885F523, "cover_mode_lean" },
    { 0xC49322E5, "cover_mode_none" },
    { 0x8FAC4D49, "cover_mode_over" },
    { 0x2D4919D0, "cover_name" },
    { 0xCDF44E41, "cover_node" },
    { 0xE618CD68, "cover_nodes" },
    { 0xA2197D33, "cover_nodes_first" },
    { 0x11CA15BB, "cover_nodes_last" },
    { 0x744856F7, "cover_none" },
    { 0x2D640115, "cover_open" },
    { 0x3E50E45B, "cover_over_mode" },
    { 0x0BE17B14, "cover_path" },
    { 0x7B1D5539, "cover_pillar" },
    { 0x95E06D0B, "cover_pillar_left_offset" },
    { 0xA41D4AF0, "cover_pillar_right_offset" },
    { 0x7B1F5F49, "cover_pillar_yaw_offset" },
    { 0xBF4EB7D9, "cover_prone" },
    { 0xF0D2825C, "cover_prone_think" },
    { 0x437AB469, "cover_relax" },
    { 0xAAF24E16, "cover_ridge" },
    { 0x5257FDAD, "cover_right" },
    { 0x38C93118, "cover_right_crouch_offset" },
    { 0xF1A4AC93, "cover_right_direction" },
    { 0x4D42D379, "cover_right_offset" },
    { 0x73C30816, "cover_right_stand_offset" },
    { 0xE8DCAA95, "cover_right_yaw_offset" },
    { 0x6F278F08, "cover_scan_mode" },
    { 0xA4BFF5E5, "cover_score" },
    { 0x8EA80361, "cover_screen_in_black" },
    { 0x69DE33AF, "cover_screen_in_white" },
    { 0xB512F5DD, "cover_shoot_min_time" },
    { 0xB10808A8, "cover_shoot_takedown_time" },
    { 0x0C1ABC24, "cover_smoke" },
    { 0xACEBF223, "cover_split" },
    { 0x1B708B4F, "cover_stand" },
    { 0xD350160B, "cover_stand_offset" },
    { 0xAA63D776, "cover_stand_think" },
    { 0xAC21608B, "cover_start" },
    { 0xE40551C7, "cover_think" },
    { 0xED3710C7, "cover_trans_splits_calculate_offsets" },
    { 0x88264B9D, "cover_trans_splits_set_anims" },
    { 0xBE71022C, "cover_transition" },
    { 0x694FDBA9, "cover_type" },
    { 0xD6E74200, "cover_type_concealed" },
    { 0xFD91E563, "cover_type_unconcealed" },
    { 0x2CC5DEE3, "cover_utility" },
    { 0xB5EFCB3D, "cover_vantage_mode" },
    { 0x080A5CA6, "cover_vault_closed" },
    { 0xACD78CBD, "cover_wall" },
    { 0x48E6DEA8, "cover_wall_think" },
    { 0xCD0999E2, "cover_warning_check" },
    { 0xF0887A01, "cover_warning_hud" },
    { 0x0E9ED5EB, "coverage" },
    { 0xF73D7CDD, "coveranim" },
    { 0xC9E2F404, "coverarrivaldebugtool" },
    { 0x15077926, "coverblindfireshootactionstart" },
    { 0x60FA02C8, "coverchangestanceactionstart" },
    { 0xA8972AEF, "covercleanuptothrowgrenade" },
    { 0xDC3C5746, "covercrouchleanpitch" },
    { 0x87EEB131, "coverdirection" },
    { 0x3FE5E895, "covered" },
    { 0x2620BD4F, "coverenterent" },
    { 0x7DF3574E, "coverenterpos" },
    { 0x8C4FA93A, "coverexit" },
    { 0x1F217EFB, "coverexit_blend_out" },
    { 0xB8DB97A6, "coverexitangles" },
    { 0x26D33406, "coverexitdist" },
    { 0x03AD91CC, "coverexitpos" },
    { 0x3BE50060, "coverexitpostdist" },
    { 0x2E474EA2, "coverexitsplit" },
    { 0x6FF3904A, "coverflankedactionterminate" },
    { 0x69106F0D, "coverflankedinitialize" },
    { 0x8E400012, "coverglobals" },
    { 0xDA480774, "coverglobalsinit" },
    { 0x4ABFD2D2, "coveridleinitialize" },
    { 0xE48B0656, "coveridleonly" },
    { 0xB52B09B3, "coveridleselecttime" },
    { 0xB1FDDB4D, "coveridleterminate" },
    { 0x3B70C233, "coveridleupdate" },
    { 0x34CC32EE, "covering" },
    { 0x8D4C7920, "coverleaninitialize" },
    { 0x638ABD17, "coverleanterminate" },
    { 0xFC7DEAE4, "coverlookattrigger" },
    { 0x1517F507, "covermode" },
    { 0x23B81526, "covernode" },
    { 0xD66C4A6B, "covernodename" },
    { 0xA9FE0A1F, "covernodepoints" },
    { 0xDBDC5E59, "covernodes" },
    { 0x6D4CA372, "covernotetrackarrivalinfo" },
    { 0x71570F9B, "covernotetrackexitinfo" },
    { 0xBF88F7E6, "coveroverinitialize" },
    { 0xD59447D9, "coveroverterminate" },
    { 0x7426F525, "coverpeekinitialize" },
    { 0x625BE0F8, "coverpeekterminate" },
    { 0x68F7A258, "coverpoint" },
    { 0x7F2F25B4, "coverpos" },
    { 0x6C442A11, "coverposestablishedtime" },
    { 0xEAD172DE, "coverpreparetothrowgrenade" },
    { 0x531D7683, "coverprint" },
    { 0x1CA5A47D, "coverrechamber" },
    { 0xCFA17891, "coverreload" },
    { 0x658AF6B3, "coverreloadinitialize" },
    { 0x1DA47BCD, "covers" },
    { 0x56CF6D45, "coversafetopopout" },
    { 0x4FA47D79, "coversearchinterval" },
    { 0x7617E5DE, "coversetupanim" },
    { 0x735B4AEA, "covershootstarttime" },
    { 0xDB3F2A39, "coverstandshots" },
    { 0xAB9D0C92, "covert" },
    { 0xB10ED19A, "covertest" },
    { 0xA94FCEC8, "coverthreatscale" },
    { 0x2D76CC63, "covertoselfangles" },
    { 0x7A737FD8, "covertrans" },
    { 0x17198DD8, "covertransangles" },
    { 0x19737398, "covertransdist" },
    { 0x766AC90D, "covertranspistol" },
    { 0xD2F8EBA7, "covertranspistolsplit" },
    { 0xD0A470FF, "covertranspredist" },
    { 0x967F5648, "covertranssplit" },
    { 0x162995B2, "covertype" },
    { 0x498D994A, "covervantageinitialize" },
    { 0x017DFCBE, "coverwarning" },
    { 0x269193F7, "coveted" },
    { 0x8076AA61, "covey" },
    { 0xB2DCC916, "covoy_deletes_properly" },
    { 0x87145C56, "cow" },
    { 0xA8BFBD19, "cow_audio" },
    { 0x1A2A5396, "cow_catchers" },
    { 0xD1DD8DEF, "cow_damage_trigger" },
    { 0x3C416D7E, "cow_damage_watch" },
    { 0x57FF2866, "cow_deleter" },
    { 0x85905978, "cow_deleter_level_sniff" },
    { 0xC543B79C, "cow_model" },
    { 0xFDF8D0B0, "cow_run" },
    { 0x54A422CD, "coward" },
    { 0x56DB68D2, "coward_spawn_func" },
    { 0x7A219A4C, "cowards" },
    { 0x15CA393F, "cowardswayout" },
    { 0xD58EBE5D, "cowbell" },
    { 0x949998FF, "cower" },
    { 0x66A1B874, "cower1" },
    { 0xD8A927AF, "cower2" },
    { 0xB2A6AD46, "cower3" },
    { 0x65EB6348, "cower_idle" },
    { 0x67780DC0, "cower_trans" },
    { 0x2BDA1381, "cowering" },
    { 0x8DEE6AD3, "cowering_civilian" },
    { 0xAE82B7A6, "cowering_scientist" },
    { 0x8F2E18F7, "cowering_scientist_trig" },
    { 0x7CD37CDC, "coworigin" },
    { 0xB5D121C9, "cows" },
    { 0x9707738A, "cowthink" },
    { 0xAE2029EF, "cowtrigs" },
    { 0x455887F4, "cp" },
    { 0x053990C3, "cp_ai_arrival" },
    { 0xFE5E8F85, "cp_init" },
    { 0x90FF1C3C, "cp_string" },
    { 0x2AB2470E, "cpb" },
    { 0x2B77CF72, "cpiece" },
    { 0x888B16F5, "cpierro" },
    { 0xBE189FD3, "cpincrement" },
    { 0x168F9550, "cpl" },
    { 0xDA523DCE, "cpoint" },
    { 0xB79C7771, "cpoints" },
    { 0x7E85ABAC, "cpp" },
    { 0xE67BC208, "cpt" },
    { 0x0C7E3C71, "cpu" },
    { 0x50999FAD, "cpu_fov_in" },
    { 0xF19B1F0C, "cpu_fov_out" },
    { 0x747452CD, "cpy" },
    { 0x50F07675, "cqb" },
    { 0x3D7CF633, "cqb_aim" },
    { 0xD5CB0297, "cqb_aim_points" },
    { 0x48CE6D04, "cqb_and_ignore" },
    { 0xF24ECA49, "cqb_endgame_1" },
    { 0x185144B2, "cqb_endgame_2" },
    { 0x3E53BF1B, "cqb_endgame_3" },
    { 0x85A63777, "cqb_endgame_array" },
    { 0x29CBAA90, "cqb_lobby" },
    { 0x5A192733, "cqb_on" },
    { 0x7ABB3B3F, "cqb_point_of_interest" },
    { 0x9E142371, "cqb_stand_wave_on_me" },
    { 0x3D935233, "cqb_target" },
    { 0xAA474510, "cqb_think" },
    { 0x2CDCD5B0, "cqb_track_thread" },
    { 0x970C7B7B, "cqb_walk" },
    { 0x5861CA5A, "cqbattributecallback" },
    { 0xAE2F12E5, "cqbchance" },
    { 0xB3280CD7, "cqbchance_spawners" },
    { 0x7668D5D2, "cqbdebug" },
    { 0x2BDCAB33, "cqbdebugglobal" },
    { 0xB6A21114, "cqbdecidewhatandhowtoshoot" },
    { 0xC8FD250C, "cqboff" },
    { 0x88F703E9, "cqbpointsofinterest" },
    { 0xE71339FD, "cqbsetupcomplete" },
    { 0xBA01B5EB, "cqbshootwhilemoving" },
    { 0xEC2E0408, "cqbstate" },
    { 0xA7E2BD1E, "cqbtracking" },
    { 0xC93339F6, "cqbwalk" },
    { 0xA47CDCBA, "cqbwalk_to_campfire" },
    { 0x32BB0C11, "cqbwalkanim" },
    { 0x80EC766A, "cqbwalking" },
    { 0xC810B4CD, "crack" },
    { 0xF971CADE, "crack1" },
    { 0xD36F5075, "crack2" },
    { 0xAD6CD60C, "crack3" },
    { 0x4E4CC49F, "crack_time_delay" },
    { 0xE183937A, "cracked" },
    { 0x2A79A993, "cracked01" },
    { 0xB8723A58, "cracked02" },
    { 0xDE74B4C1, "cracked03" },
    { 0x024B4A07, "cracked1" },
    { 0x9043DACC, "cracked2" },
    { 0x8B17F8B3, "cracked_backup" },
    { 0xD35D874C, "crackedcontents" },
    { 0x52628DDB, "cracking" },
    { 0x2E0B704C, "cracks" },
    { 0x565D2C52, "cracks_off" },
    { 0x381464A4, "cracks_on" },
    { 0xA164DA21, "craft" },
    { 0xD7D82FD3, "craft_failed" },
    { 0xA71B815C, "craft_shield_drop_override" },
    { 0xDCF785C5, "craft_shield_pickup_override" },
    { 0xFC2BDB4A, "craft_shield_piece_pickup_vo_override" },
    { 0x30C49CC4, "craft_start_time" },
    { 0xA623E0C0, "craft_succeed" },
    { 0x8AA1E537, "craft_time" },
    { 0x44CC2245, "craftable" },
    { 0x1BF61C98, "craftable_add_glow_fx" },
    { 0xFF0CDA95, "craftable_all_crafted" },
    { 0xF254FE3D, "craftable_can_use_shared_piece" },
    { 0x50D81C36, "craftable_claimed_locations" },
    { 0x5148B795, "craftable_clear_piece_crafting" },
    { 0x93415E3D, "craftable_complete" },
    { 0x32465EC9, "craftable_craft_custom_func" },
    { 0xD3534B91, "craftable_crafted" },
    { 0x09661E5A, "craftable_crafted_custom_func" },
    { 0xB008DF77, "craftable_has_piece" },
    { 0x6D9966EF, "craftable_id" },
    { 0x0F8D6189, "craftable_instance" },
    { 0xBD93252D, "craftable_invalid_choice" },
    { 0xD67B48FB, "craftable_is_piece_crafted" },
    { 0x2D9441CA, "craftable_is_piece_crafted_or_crafting" },
    { 0xC99143B0, "craftable_is_piece_crafting" },
    { 0x02812CE4, "craftable_is_shared" },
    { 0x8CF5108B, "craftable_model_attach_glow" },
    { 0x09967FF1, "craftable_name" },
    { 0xDB6EED8E, "craftable_need_all_pieces" },
    { 0x434F62A0, "craftable_obtained" },
    { 0x4BA9331D, "craftable_pickedup_timer" },
    { 0x90238C9A, "craftable_piece_count" },
    { 0x722CC978, "craftable_piece_released" },
    { 0x29AE0891, "craftable_piece_swap_allowed" },
    { 0x549FED8A, "craftable_piece_triggers" },
    { 0x59BC965E, "craftable_piece_unitriggers" },
    { 0xC1C86479, "craftable_pieces" },
    { 0xE9B04B86, "craftable_pieces_structs" },
    { 0xCFD8F554, "craftable_place_think" },
    { 0x089389F6, "craftable_play_craft_fx" },
    { 0x9BF851D3, "craftable_progress_end" },
    { 0x06491663, "craftable_set_piece_crafted" },
    { 0x4C98EDC8, "craftable_set_piece_crafting" },
    { 0x8B696CA3, "craftable_shield" },
    { 0xA081B24E, "craftable_shield_equipment" },
    { 0x55D294F8, "craftable_shield_grab" },
    { 0xA2D03EE5, "craftable_shield_model" },
    { 0x08A69E1E, "craftable_shield_weapon" },
    { 0xA7830130, "craftable_spawn_think" },
    { 0xECA16733, "craftable_struct" },
    { 0xC5EE3BCC, "craftable_stub" },
    { 0xB97382E4, "craftable_table" },
    { 0x30A68DF2, "craftable_table_lock" },
    { 0xE7F40A17, "craftable_tables" },
    { 0x49E99F2B, "craftable_timer" },
    { 0x97E1007C, "craftable_transfer_data" },
    { 0x4F91B11D, "craftable_trigger_think" },
    { 0xB4BA4FD7, "craftable_trigger_think_array" },
    { 0x3FC45D82, "craftable_use_hold_think" },
    { 0x00FCA28E, "craftable_use_hold_think_internal" },
    { 0xE1832857, "craftable_wait_your_turn" },
    { 0xC3207981, "craftable_waittill_spawned" },
    { 0x292B6949, "craftableaudio" },
    { 0x21469B77, "craftableindex" },
    { 0xDBA2448C, "craftablename" },
    { 0xE012FFF5, "craftablepickup" },
    { 0x206A8BC4, "craftablepickups" },
    { 0x4EA4AFFF, "craftablepieceindex" },
    { 0xC02ADCD4, "craftables" },
    { 0x84AE2A3C, "craftables_crafted" },
    { 0xF72B0650, "craftables_spawned_this_frame" },
    { 0x01779387, "craftables_stats_recorded" },
    { 0xF5A17FBE, "craftables_watch_swipes" },
    { 0xB8AFCA26, "craftablespawn" },
    { 0x05478CAB, "craftablespawn_check" },
    { 0xE312521D, "craftablestub" },
    { 0xBF0BB306, "craftablestub_finish_craft" },
    { 0xBFB18668, "craftablestub_remove" },
    { 0x1DF850C8, "craftablestub_update_prompt" },
    { 0x7029D54E, "craftabletrigger_update_prompt" },
    { 0x5B1D460E, "crafted" },
    { 0xDE42A32D, "crafted_" },
    { 0x4DE8BFE7, "crafting" },
    { 0xB119B18E, "crag" },
    { 0xB1F825EF, "craig" },
    { 0xE1D1CA1A, "crailturret" },
    { 0xA2295010, "crane" },
    { 0xAE714699, "crane01" },
    { 0xD473C102, "crane02" },
    { 0xAB153FD7, "crane_arm" },
    { 0xCDE79017, "crane_body" },
    { 0x6DC2FEEE, "crane_box" },
    { 0x0AA43170, "crane_box_control" },
    { 0x1D1F3991, "crane_building_ai_func" },
    { 0x06ABB4E7, "crane_building_edge_nodes" },
    { 0xEDBBDB32, "crane_building_spawner" },
    { 0x9E9ADD85, "crane_collapse_done" },
    { 0x7DADF700, "crane_container" },
    { 0x67D947BF, "crane_death" },
    { 0xB48FB7D0, "crane_destroy_panel_1" },
    { 0x2697270B, "crane_destroy_panel_2" },
    { 0x0094ACA2, "crane_destroy_panel_3" },
    { 0x729C1BDD, "crane_destroy_panel_4" },
    { 0x4C99A174, "crane_destroy_panel_5" },
    { 0xBEA110AF, "crane_destroy_panel_6" },
    { 0xFDE524A1, "crane_dvar_init" },
    { 0x12D39F0D, "crane_fall_start" },
    { 0x330D9137, "crane_hits_deck" },
    { 0x894DEDBD, "crane_impact" },
    { 0x6177BF36, "crane_model" },
    { 0x538FBE24, "crane_move" },
    { 0xC1281B57, "crane_moves" },
    { 0xAC72E029, "crane_package" },
    { 0x26CF4F7B, "crane_print_dvars" },
    { 0x632F9257, "crane_rooftop_fx" },
    { 0x651FE5B9, "crane_think" },
    { 0x1C17D401, "crane_trigger" },
    { 0x166FC37E, "cranes_start" },
    { 0xB64C01CE, "crank" },
    { 0x92E5A6F1, "crap" },
    { 0x046AE28D, "crapping" },
    { 0xC8B13238, "crappy" },
    { 0xFE6AC606, "crash" },
    { 0x857B080B, "crash_accel" },
    { 0xBC8797BF, "crash_actors" },
    { 0x7898BA78, "crash_ai_damage_override" },
    { 0xD8E3F685, "crash_angles" },
    { 0xD833535D, "crash_anim_delay_max" },
    { 0x15975E73, "crash_anim_delay_min" },
    { 0xEEDC7FC5, "crash_bigrig" },
    { 0x129E2FFE, "crash_bike" },
    { 0x6C2451CD, "crash_car" },
    { 0x43B44442, "crash_car_2" },
    { 0xD26BDAB9, "crash_car_drop_sign" },
    { 0x59C4C9EF, "crash_car_explode" },
    { 0xF9930038, "crash_chute" },
    { 0x2DA60448, "crash_city" },
    { 0x9C2BC496, "crash_collision_test" },
    { 0x03058C81, "crash_cougar_speed_max" },
    { 0xB02E1DBF, "crash_cougar_speed_min" },
    { 0x3C1E2DD6, "crash_course" },
    { 0x83B3C2AA, "crash_derailed_check" },
    { 0x6B7A5E2F, "crash_detour_check" },
    { 0x831C5309, "crash_done" },
    { 0x0E2118D0, "crash_door_exit" },
    { 0x13565418, "crash_door_open" },
    { 0x874200AE, "crash_dust_fx" },
    { 0xA2A3C824, "crash_eject" },
    { 0x0895DEBC, "crash_end" },
    { 0x60988E29, "crash_fail" },
    { 0xA5787372, "crash_fall" },
    { 0xD8FC4066, "crash_guy" },
    { 0x8962C7CD, "crash_heli" },
    { 0xF4E7DD2F, "crash_hit_building" },
    { 0x161DF267, "crash_huey_door_end" },
    { 0x5A3D0CC5, "crash_huey_strength_test_1" },
    { 0x9B790722, "crash_huey_strength_test_1_loop" },
    { 0x803F872E, "crash_huey_strength_test_2" },
    { 0xA6B4484F, "crash_huey_strength_test_2_loop" },
    { 0x92F0DF4E, "crash_into_building" },
    { 0x1A3D388E, "crash_land" },
    { 0x84200817, "crash_landing_fx" },
    { 0x4D9215B9, "crash_mask" },
    { 0x772BF08D, "crash_move_done" },
    { 0xF15D6C45, "crash_node" },
    { 0xA29D57CE, "crash_parts_animation" },
    { 0x7F694550, "crash_path" },
    { 0xD406F1BD, "crash_path_check" },
    { 0xB3A9FE3B, "crash_paths" },
    { 0xD25CCB4D, "crash_piece" },
    { 0x284E576D, "crash_plane" },
    { 0x908CDE52, "crash_player" },
    { 0x7BA501C5, "crash_pos" },
    { 0xEB625DA0, "crash_price" },
    { 0x2D32D3BB, "crash_setup_wounded" },
    { 0xE34B66C9, "crash_shake" },
    { 0xD8898397, "crash_start" },
    { 0xC385A426, "crash_start_node" },
    { 0x2DF8CDD6, "crash_steve" },
    { 0xF0103A4D, "crash_stop" },
    { 0x2A51B152, "crash_struct" },
    { 0xEEAC7F48, "crash_style" },
    { 0x2CCB8462, "crash_time" },
    { 0x6C280282, "crash_tracks_func" },
    { 0x3B45C7CA, "crash_triggers" },
    { 0xDAEBECD2, "crash_truck_delay" },
    { 0x8085CF6B, "crash_vcs" },
    { 0x707B448E, "crash_vel" },
    { 0xCAE04204, "crash_vel_forward" },
    { 0xBD6ED32C, "crash_vo" },
    { 0x9F960C36, "crash_wakeup" },
    { 0x952FB927, "crash_wakeup_overlay" },
    { 0x59608E66, "crash_wounded_dialogue" },
    { 0x671C3D5F, "crash_zone" },
    { 0x778CA4E6, "crash_zones" },
    { 0x6B34C789, "crashed" },
    { 0xA13E6D44, "crashed_heli" },
    { 0xEA99D7DE, "crashed_huey_trigger" },
    { 0xCD11FC8D, "crashed_limo" },
    { 0x4CB2B57C, "crashed_uaz" },
    { 0x12C89BAD, "crashed_while_deploying" },
    { 0x5DE638F2, "crashed_zero" },
    { 0x8968D226, "crashes" },
    { 0xBA64031A, "crashing" },
    { 0xB05A5D11, "crashing_plane" },
    { 0xA9B7E3C4, "crashleavingbattlefield" },
    { 0x8DAD00BC, "crashloc" },
    { 0x776AF45A, "crashnode" },
    { 0xBB56F983, "crashonnearestcrashpath" },
    { 0xAE0B2A38, "crashorg" },
    { 0xDCE97780, "crashorgheli" },
    { 0xDD457B13, "crashpath" },
    { 0x5AB11FBA, "crashpathdistance" },
    { 0x2E78C742, "crashpaths" },
    { 0x576839F3, "crashsite" },
    { 0x214C8C4A, "crashtrack_note_breakwall" },
    { 0xB0AA6324, "crashtrack_note_slide" },
    { 0x3DD967E4, "crashtrack_note_splash" },
    { 0xE897AEF6, "crashtype" },
    { 0x55B064E9, "crashtypes" },
    { 0x2E6383A2, "crate" },
    { 0x2ED258FF, "crate1" },
    { 0x3B269AF1, "crate_" },
    { 0xE031A5D0, "crate_align" },
    { 0x97A71DE9, "crate_anim_done" },
    { 0xAC05C302, "crate_animate" },
    { 0xDE501469, "crate_blocker" },
    { 0x522A0D42, "crate_blocker_col" },
    { 0x46EE48A7, "crate_bottom_point" },
    { 0x79D49E80, "crate_carry_spots" },
    { 0x70EB5BB1, "crate_check_tuning" },
    { 0xCC5215EF, "crate_chunks_delete" },
    { 0xDAFECB77, "crate_clip" },
    { 0xFD3254AE, "crate_clips" },
    { 0x13EECB09, "crate_data" },
    { 0xD7228FA2, "crate_death_monitor" },
    { 0xB2DEF856, "crate_drop" },
    { 0x609CA73D, "crate_drop_kill_trigger_think" },
    { 0x9C26A6B3, "crate_drop_think" },
    { 0x5213A733, "crate_ents" },
    { 0x57775FBD, "crate_goal_radius" },
    { 0xC4D42FD2, "crate_headicon_offset" },
    { 0x5AB08B7C, "crate_hook" },
    { 0xDC42EE46, "crate_investigate_crate" },
    { 0xE6F5D283, "crate_investigate_dialogue" },
    { 0x822B0616, "crate_investigate_player" },
    { 0xBA334B49, "crate_investigate_reznov" },
    { 0xF0FD05DF, "crate_investigate_vignette" },
    { 0xA9D9E96B, "crate_investigate_worker" },
    { 0x75F256BC, "crate_kill_event" },
    { 0x63D56CBC, "crate_kill_stealth_listener" },
    { 0x2619F458, "crate_kill_stealth_trigger" },
    { 0x5196B015, "crate_kill_success" },
    { 0x0C877C20, "crate_kill_success_listener" },
    { 0x9021B220, "crate_kill_trig_started" },
    { 0x55429059, "crate_kill_trig_stop" },
    { 0xB9B2B226, "crate_kill_worker" },
    { 0x3153FEA5, "crate_landed" },
    { 0x9E5077D9, "crate_length" },
    { 0x8B9965E0, "crate_lid" },
    { 0xC8486B77, "crate_locations" },
    { 0x99829598, "crate_lower" },
    { 0x0B543C41, "crate_map" },
    { 0xC56F5E93, "crate_models" },
    { 0x8C9A4D2B, "crate_num" },
    { 0x6435BD6F, "crate_origin" },
    { 0x51052E17, "crate_path_monitor" },
    { 0xABEAF01F, "crate_raise" },
    { 0x90410FE9, "crate_set_random_model" },
    { 0x94A7F61D, "crate_spawned" },
    { 0x8ABDB2FA, "crate_start_event" },
    { 0xB8CBE822, "crate_support" },
    { 0x15FA4A5B, "crate_tag" },
    { 0x77AA3775, "crate_touch_monitor" },
    { 0xC4AE60E3, "crate_trig" },
    { 0x9F89D456, "crate_triggers" },
    { 0xFAFBA7ED, "crate_type_name" },
    { 0xBEAEDE8E, "crate_use_interrupt" },
    { 0x06142E17, "crate_use_radius" },
    { 0x7862F48C, "crate_z_dist" },
    { 0x8717AD35, "crateactivate" },
    { 0x9CC3BE57, "cratebottom" },
    { 0x509BC0DD, "crateburn" },
    { 0x36C7BEAA, "cratecategory" },
    { 0x7F749256, "cratecategorykeys" },
    { 0x1A80460D, "cratecategorytypeweights" },
    { 0x99AB16AD, "cratecategoryweights" },
    { 0x1FEC9DBB, "cratecontrolleddrop" },
    { 0x6EC8663F, "cratecount" },
    { 0xF3B1DD7C, "cratedeactivate" },
    { 0x3CEAF7A3, "cratedelete" },
    { 0xCEE2A97A, "cratedistsq" },
    { 0xD67100EE, "cratedropper" },
    { 0xF28476D7, "cratedroptogroundkill" },
    { 0x6BF5BE4E, "cratedroptogroundtrace" },
    { 0x8DC1C450, "crateexpsound" },
    { 0x7D65A43C, "crategamblerthink" },
    { 0x69CB398C, "cratehealth" },
    { 0x1C9A452D, "crateignsound" },
    { 0xFA277019, "crateimpactsound" },
    { 0x5FE61ECE, "cratekill" },
    { 0x8C212895, "crateland" },
    { 0x3E4ECB50, "cratemodelboobytrapped" },
    { 0x208E80AB, "cratemodelenemy" },
    { 0xC1E9E0E8, "cratemodelfriendly" },
    { 0x1B6B6963, "cratemodelhacker" },
    { 0xC3D37045, "cratemodeltank" },
    { 0x3E27472F, "cratename" },
    { 0xEC5FD887, "cratenamekeys" },
    { 0x5EE17F86, "cratenonownerusetime" },
    { 0x381DC5AA, "crateobjid" },
    { 0x366AAD9B, "crateownerusetime" },
    { 0x4230965D, "cratephysics" },
    { 0x3D698404, "crater" },
    { 0x77FA6121, "crater2_blown" },
    { 0x967EC9A7, "crater_after" },
    { 0x7D394D86, "crater_before" },
    { 0x80F32A79, "crater_charge_fx1" },
    { 0xA6F5A4E2, "crater_charge_fx2" },
    { 0xCCF81F4B, "crater_charge_fx3" },
    { 0xF2FA99B4, "crater_charge_fx4" },
    { 0x18FD141D, "crater_charge_fx5" },
    { 0x6EC8AB81, "crater_distance_monitor" },
    { 0x2A6E113F, "crater_guy_logic" },
    { 0xD550C75D, "crater_trigger" },
    { 0x7754CB02, "cratereactivate" },
    { 0xABDEFDBD, "crateredophysics" },
    { 0xAFE0A964, "cratering" },
    { 0x425C00B7, "craters" },
    { 0x636BFE6D, "crates" },
    { 0xC4141FA2, "crates_on_fire" },
    { 0xF2525F6F, "cratespawn" },
    { 0x89CF7E73, "cratetimeout" },
    { 0x6A095FC2, "cratetimeoutthreader" },
    { 0x669382D2, "cratetype" },
    { 0xD59A697E, "cratetypekeys" },
    { 0x46AB69DD, "cratetypes" },
    { 0x063249D2, "cratetypestart" },
    { 0x2922A15D, "crateusethink" },
    { 0x5B3BAD0E, "crateusethinkowner" },
    { 0x63CF9272, "crateweapon" },
    { 0x12AE1716, "crawl" },
    { 0x3A5A74EA, "crawl_anim" },
    { 0xBBA4FE31, "crawl_anim_override" },
    { 0x45498850, "crawl_anim_rotate" },
    { 0x6FA27E51, "crawl_anim_stop" },
    { 0xC306441C, "crawl_array" },
    { 0x6C1C1497, "crawl_back_victim" },
    { 0x470E72DC, "crawl_death_watcher" },
    { 0xD656E6A0, "crawl_path" },
    { 0x9C955757, "crawl_ref_node" },
    { 0xD1473512, "crawl_rumble" },
    { 0x2A1A5885, "crawl_target_and_init_flags" },
    { 0x7B034E73, "crawl_think" },
    { 0xAEFF3BFE, "crawl_through_targets_to_init_flags" },
    { 0xC65F9FED, "crawl_tunnel_end" },
    { 0x57CE0931, "crawlanim" },
    { 0x192308D9, "crawled" },
    { 0x9D0A40BF, "crawler" },
    { 0x84CABA4C, "crawler_action" },
    { 0x48976681, "crawler_condition" },
    { 0xE43D169C, "crawler_created_vo_cooldown" },
    { 0xA16D9D5E, "crawler_damage_func" },
    { 0xBDD9DC94, "crawler_death" },
    { 0xDBD065D1, "crawler_end" },
    { 0x23246008, "crawler_idle" },
    { 0x62311A10, "crawler_ignore_delay" },
    { 0x4DE9BF96, "crawler_kill" },
    { 0xCB506B8E, "crawler_pickup" },
    { 0x0BAC8C79, "crawler_post_traverse" },
    { 0xF3330C02, "crawler_pre_traverse" },
    { 0xA5F99C85, "crawler_putdown" },
    { 0x819C772E, "crawler_round_count" },
    { 0x2B712D90, "crawler_round_ending" },
    { 0x93840FEB, "crawler_round_start" },
    { 0x7BEDC9B5, "crawler_round_starting" },
    { 0x98D15759, "crawler_round_stop" },
    { 0xF7282887, "crawler_round_tracker" },
    { 0xAB7CFEF1, "crawler_setup" },
    { 0x3897957D, "crawler_sling" },
    { 0x4657647D, "crawler_traverse_idle" },
    { 0x57EB6AEA, "crawler_unsling" },
    { 0x7C16F883, "crawler_update_locomotion" },
    { 0x1E1CBB95, "crawler_walk" },
    { 0xB5524C0C, "crawler_watch_death" },
    { 0xCCAF574A, "crawlerlifetime" },
    { 0x10246F02, "crawlerround_nomusic" },
    { 0x3C9D5AC6, "crawlers" },
    { 0x0E230874, "crawlers_enabled" },
    { 0xB9F0850A, "crawling" },
    { 0x1A0C865D, "crawling_stab_achievement" },
    { 0xD1F6AB66, "crawlingpain" },
    { 0x75402337, "crawlingpistol" },
    { 0xBF5B3CF3, "crawlingpistolstarting" },
    { 0x2317157C, "crawlonly" },
    { 0x3794E989, "crawls" },
    { 0x14477D80, "craziest" },
    { 0xBFF1BE00, "crazy" },
    { 0xD7DD2480, "crazy_bmp" },
    { 0x96EC62C4, "crazy_mg_actors" },
    { 0x2E96AD2A, "crazy_power" },
    { 0x353B09E9, "crc" },
    { 0x48FC5D1D, "crc_breach_enemy_fire" },
    { 0x796712FA, "crc_breach_event" },
    { 0x97A51B48, "crc_breach_flash" },
    { 0x697B930C, "crc_breach_rush" },
    { 0xF84E3244, "crc_door" },
    { 0x9E8C0F31, "crc_exit_event" },
    { 0xE8C862FD, "crc_eye_scan" },
    { 0xB36BB448, "crc_flashbang_add_script_noteworthy" },
    { 0x7F1A6795, "crc_glass_monster_clip_think" },
    { 0xC5D71A3E, "crc_interact" },
    { 0x980A4EE4, "crc_objectives" },
    { 0x86DBD56B, "crc_part01_loop" },
    { 0x3FB070D9, "crc_part02" },
    { 0x3F7C5CFE, "crc_part02_loop" },
    { 0x19ADF670, "crc_part03" },
    { 0x1146A589, "crc_part03_loop" },
    { 0x23BF4F4F, "crc_part04" },
    { 0x4957F9EC, "crc_part04_loop" },
    { 0xFDBCD4E6, "crc_part05" },
    { 0x3809C6E8, "crc_salazar_terminal_idle" },
    { 0x3760C3C1, "crc_terminal_event" },
    { 0x93FA33E6, "creaks" },
    { 0x39B2F43C, "creaksound" },
    { 0x6197F358, "creat" },
    { 0x8556ACC9, "creatcountdownhudelem" },
    { 0xF7F12A75, "create" },
    { 0x66C3557D, "create_2d_sound_list" },
    { 0xB5883E6E, "create_a_crack" },
    { 0x0CE03A3E, "create_after_strafe_fights" },
    { 0xE2B8F6DA, "create_ais_hudelem" },
    { 0x71C4095B, "create_aitank_influencers" },
    { 0xD608EF6F, "create_and_play_dialog" },
    { 0xC0453F9D, "create_and_play_dialog_egg" },
    { 0xD2D8453D, "create_and_play_director_vox" },
    { 0xB56964F1, "create_and_play_responses" },
    { 0x05F35539, "create_anim_model" },
    { 0xD5070A46, "create_anim_references_on_server" },
    { 0xA9732283, "create_apartment_badplace" },
    { 0x467EB775, "create_array_of_intel_items" },
    { 0xE6624649, "create_array_of_origins_from_table" },
    { 0x61AD100B, "create_artillery_influencers" },
    { 0x4DC9C0BC, "create_auto_turret_influencer" },
    { 0xBDD4DA8D, "create_auto_turret_influencer_close" },
    { 0x93BFF34E, "create_ballistic_knife_watcher" },
    { 0xCB7D7382, "create_ballistic_knife_watcher_zm" },
    { 0x6AB5E249, "create_barracks_waypoint" },
    { 0x1134C42D, "create_base_watchers" },
    { 0xB833837D, "create_beartrap_align" },
    { 0x059888F1, "create_billboard" },
    { 0x167474B9, "create_body_influencers" },
    { 0xC94E27CD, "create_bottle_unitrigger" },
    { 0xEEC583A7, "create_buttons_and_triggers" },
    { 0x91E9100C, "create_cam_node" },
    { 0x9EAE0CB5, "create_camera" },
    { 0x5B2C16CD, "create_camera_mark_effect" },
    { 0x1630015F, "create_camera_zoom_icon" },
    { 0x9B333F38, "create_candy_booze_trigger" },
    { 0xA0A4689D, "create_carlos_nag_array" },
    { 0x1B3BD905, "create_carry_object" },
    { 0x7F923C63, "create_chalk_hud" },
    { 0xB79CB078, "create_character_data_struct" },
    { 0x344147A4, "create_class_exclusion_list" },
    { 0x55717788, "create_claw_fx_hud" },
    { 0x473257A1, "create_claymore_watcher" },
    { 0x87AD8AA7, "create_claymore_watcher_zm" },
    { 0x4E1991E7, "create_client_hud_elem" },
    { 0xDD48CD40, "create_clustergrenade" },
    { 0xED24EBE4, "create_corpse" },
    { 0xE1B7F046, "create_counter_hud" },
    { 0x757C12B9, "create_cp" },
    { 0xFBAC5860, "create_craters" },
    { 0x5B92BE2A, "create_credit_element" },
    { 0xBC5102CB, "create_crossbow_rope" },
    { 0x77ED70CE, "create_crossfade_cinematic_hud" },
    { 0x92209EC8, "create_cylinder_influencer" },
    { 0xD84A82B9, "create_dead_bodies" },
    { 0x4381CCB7, "create_debug_hud_elemets" },
    { 0xAF860CCE, "create_defend_claymores" },
    { 0xE872949A, "create_defend_satchels" },
    { 0x41615467, "create_dog_influencers" },
    { 0x788C9109, "create_dogs" },
    { 0xA2509F77, "create_domination_info" },
    { 0x1271E4FE, "create_drone" },
    { 0xAE25B09A, "create_drop_shadow" },
    { 0x828CD696, "create_dyn_unitrigger" },
    { 0x7D0ACAAB, "create_effect" },
    { 0xC232C7E9, "create_ending_message" },
    { 0xBE47501A, "create_enemy_hud_icon" },
    { 0xEDDB7236, "create_enemy_influencer" },
    { 0x97C4B8F0, "create_enemy_model_actor" },
    { 0x904D40C2, "create_enemy_spawned_influencers" },
    { 0xFF1F0EB2, "create_enemy_waypoint" },
    { 0xF93165AA, "create_entity_enemy_influencer" },
    { 0xFEBC81F1, "create_entity_friendly_influencer" },
    { 0x4E9EFA49, "create_entity_influencer" },
    { 0x63C74F54, "create_entity_masked_enemy_influencer" },
    { 0xF6DE1BB7, "create_entity_masked_friendly_influencer" },
    { 0x8788619D, "create_equipment_turret" },
    { 0x025A0C97, "create_escape_progress_bar" },
    { 0xB5F752CE, "create_eyes" },
    { 0xEADFE2A9, "create_fake_jetpack_ai" },
    { 0x019E19AA, "create_fake_reznov" },
    { 0x02EC1755, "create_fake_vehicle_and_go_path" },
    { 0x4D8D3FDE, "create_fake_vehicle_damage" },
    { 0xAD8FE0C6, "create_fakeplayer_camera" },
    { 0x44D8E8A2, "create_fight" },
    { 0x1A04E427, "create_final_score" },
    { 0xAC8C475A, "create_fireworks" },
    { 0xA4D8E361, "create_flags_and_return_tokens" },
    { 0x436297AA, "create_flare_ent" },
    { 0x1F8B361B, "create_freeway_collapse" },
    { 0xC719B8F5, "create_freeway_collapse_struct" },
    { 0x757BE575, "create_friendly_hud_icon" },
    { 0xB943E01D, "create_friendly_influencer" },
    { 0xBBC4C8B5, "create_friendly_model_actor" },
    { 0x72EA84FD, "create_friendly_waypoint" },
    { 0xC2F732DE, "create_from_spawngroup_and_go_path" },
    { 0xCF75D3B6, "create_frozen_guy" },
    { 0xCC45BA03, "create_fullscreen_cinematic_hud" },
    { 0x52514C68, "create_fx_ent" },
    { 0x35F99DC4, "create_fx_menu" },
    { 0x31124F04, "create_global_raps_spawn_locations_list" },
    { 0xC620C427, "create_global_wasp_spawn_locations_list" },
    { 0xDB27CC5F, "create_gondola_poi" },
    { 0xB86B5252, "create_gravity_trap_spikes_in_ground" },
    { 0x268B0239, "create_gravity_trap_unitrigger" },
    { 0x4EF230D3, "create_grenade_influencers" },
    { 0x752B0799, "create_guard_model" },
    { 0x9269C06F, "create_gunner_hud" },
    { 0x3D1E77F0, "create_hanging_guy" },
    { 0x9FDF173E, "create_helicopter_influencers" },
    { 0xF21567E3, "create_hero_squad" },
    { 0xDF23F635, "create_high_score_struct" },
    { 0x6196AD32, "create_highlight_hud" },
    { 0x9C734946, "create_hillside_waypoint" },
    { 0x05AE6B53, "create_hud" },
    { 0x94D075E1, "create_hud_bar" },
    { 0xB472C227, "create_hud_elem" },
    { 0xE0F70242, "create_hud_list" },
    { 0xBD302A33, "create_hud_message" },
    { 0x5912C220, "create_hud_scoreboard" },
    { 0x219E86A2, "create_hudelem" },
    { 0x4951B76D, "create_hudelems" },
    { 0xAA8F160B, "create_icon" },
    { 0x806866EB, "create_ied_watcher" },
    { 0xAAD39157, "create_incendiary_watcher" },
    { 0xFA67201D, "create_influencer" },
    { 0x947133CC, "create_item_meat_watcher" },
    { 0x8D8723C3, "create_jetpack_ai" },
    { 0xD8321791, "create_jetpack_drone" },
    { 0x773E78DD, "create_key_door_unitrigger" },
    { 0xEDBAD9F9, "create_killcam_entity" },
    { 0xC138A4BF, "create_level_specific_weaponobject_watchers" },
    { 0xD1B69B2C, "create_level_threat_groups" },
    { 0xA023F0D5, "create_lightning_chain_params" },
    { 0xED741BB7, "create_lights" },
    { 0xB951B148, "create_loadout" },
    { 0xB7DA4A2E, "create_locker_doors" },
    { 0xFFA98DC5, "create_locker_trigger" },
    { 0x61B8D93A, "create_loop_effect" },
    { 0x10037BBE, "create_loop_sound" },
    { 0xAC417AE3, "create_looper" },
    { 0x0428198F, "create_loopsound" },
    { 0x94A86831, "create_mantle" },
    { 0xF6B6842C, "create_map_placed_influencer" },
    { 0x1FD0742F, "create_map_placed_influencers" },
    { 0xD1C906BA, "create_match_start_message" },
    { 0x34795465, "create_meat_player_hud" },
    { 0x44A58AD1, "create_meat_team_hud" },
    { 0x50240FA4, "create_mg_team" },
    { 0xC460FE4A, "create_missile_hud" },
    { 0xC6CDB132, "create_mission" },
    { 0x655C90E3, "create_module_hud_team_winer_score" },
    { 0x32C89C61, "create_move_ent" },
    { 0x09CD5D36, "create_movie_hud" },
    { 0x4AE5CC77, "create_nagsquads" },
    { 0xC4EFD22B, "create_napalm_fire_influencers" },
    { 0xF37084D1, "create_new_origin_ent" },
    { 0xD091566E, "create_new_wave" },
    { 0xF50226E9, "create_nova_body" },
    { 0x4E3E4238, "create_num" },
    { 0x67EBB71A, "create_objective_after_rpg_taken" },
    { 0x0D20F191, "create_offroad_waypoint" },
    { 0xB7152400, "create_oneshot_effect" },
    { 0x14E6F045, "create_overlay_element" },
    { 0x2170CD6B, "create_pack_object" },
    { 0xB443AE56, "create_pegasus_influencer" },
    { 0xF0C34AA4, "create_perk_random_machine_unitrigger_stub" },
    { 0x2DF8BF86, "create_player_corpse" },
    { 0x97102848, "create_player_huds" },
    { 0x918F66B2, "create_player_influencers" },
    { 0xD5F9AFB9, "create_player_model" },
    { 0x823F862E, "create_player_score_hud" },
    { 0x348D1C1A, "create_player_spawn_influencers" },
    { 0xC0F7A6D1, "create_player_targeting_array" },
    { 0xD8418E10, "create_playerview" },
    { 0xB35273DA, "create_portal" },
    { 0x4D378C37, "create_power_waypoint" },
    { 0x90B8683C, "create_powerup" },
    { 0xEB66EA5D, "create_price_dialogue_master" },
    { 0xD631E57E, "create_prisoner_model" },
    { 0x537BBC6D, "create_prop_model" },
    { 0x800BEE6C, "create_qrdrone_influencers" },
    { 0x606513C2, "create_radar_waypoint" },
    { 0x67E052F1, "create_radio" },
    { 0x1F477664, "create_rcbomb_influencers" },
    { 0x24DF0407, "create_reflection_object" },
    { 0x983D77FE, "create_reflection_objects" },
    { 0x605699E8, "create_remote_mortar_hud" },
    { 0x15A402E1, "create_remote_turret_hud" },
    { 0xFF219AE5, "create_retreat_group" },
    { 0x6E55E905, "create_retrievable_hint" },
    { 0x28599D81, "create_right_rocket_pod" },
    { 0xDB8D80B0, "create_robot_head_trigger" },
    { 0x18AB852C, "create_rope" },
    { 0x0D755A43, "create_sam_target" },
    { 0xDD1F7EA7, "create_satchel_watcher" },
    { 0x402B8700, "create_scene" },
    { 0xC3E2164B, "create_scene_add_shot" },
    { 0x5D3BB86A, "create_scene_hud" },
    { 0xB1EE3AF4, "create_score_hud" },
    { 0xDF39D922, "create_screen_generic" },
    { 0x6409CAB8, "create_see2_threat_group" },
    { 0x9CA5ACE8, "create_shot" },
    { 0x4B36B90C, "create_simple_hud" },
    { 0xAA7EA45E, "create_skipto" },
    { 0x0CBED4BD, "create_sound_random" },
    { 0xB82F4E71, "create_spawn_group" },
    { 0x88BE9487, "create_spawner_function" },
    { 0x2752269F, "create_spawner_list" },
    { 0xDEF78258, "create_spawner_list_func" },
    { 0x0B0A904E, "create_speed_hudelem" },
    { 0x42D3C903, "create_sphere_influencer" },
    { 0xC5E9EF1D, "create_splash_hudelems" },
    { 0x12506DDC, "create_spy_camera" },
    { 0x8C102C1F, "create_squad_influencers" },
    { 0x2B4DD118, "create_squad_waypoint" },
    { 0xC61FACAC, "create_start" },
    { 0x0BF9186D, "create_state_machine" },
    { 0x5722ED6F, "create_streamer_ent" },
    { 0x507C2F7B, "create_streamer_hint" },
    { 0xFFF3CE33, "create_target" },
    { 0xDD6E51AD, "create_target_indicator" },
    { 0x5E0E8CBA, "create_target_thread" },
    { 0x56F58B65, "create_team_hud" },
    { 0x96944AC3, "create_teamgather_event" },
    { 0xDE01C857, "create_temp_model_and_linkto_tag" },
    { 0x0849C8F7, "create_total_score_hud" },
    { 0x45A3B5ED, "create_track" },
    { 0x805971B0, "create_track_thread" },
    { 0x360E7312, "create_trail_loopsound" },
    { 0x5F8CA11C, "create_trigger" },
    { 0x9AF9A95E, "create_triggerfx" },
    { 0x5077B3BE, "create_trophy" },
    { 0xBA2B10B6, "create_turret" },
    { 0x2AF2F1E4, "create_tutorial_hud" },
    { 0x4DFDDB7A, "create_tutorial_message" },
    { 0x62A59367, "create_tvmissile_influencers" },
    { 0xA1B986BA, "create_unitrigger" },
    { 0x8247EE9D, "create_units_from_allsquads" },
    { 0xF56E55EB, "create_units_from_squad" },
    { 0xBE21F511, "create_use_object" },
    { 0x9BFD1B2B, "create_use_weapon_object_watcher" },
    { 0xA1015327, "create_veh_model" },
    { 0xD87B6202, "create_vehicle_from_spawngroup_and_gopath" },
    { 0x1867A325, "create_vehicle_influencers" },
    { 0x20D7FDBF, "create_vox" },
    { 0xA9E0D67D, "create_vox_timer" },
    { 0x810B6482, "create_warning_elem" },
    { 0x590A0AE0, "create_watcher" },
    { 0xF1483984, "create_weapon" },
    { 0xE8E7542A, "create_weapon_drop_array" },
    { 0x3B5C2406, "create_weapon_hud" },
    { 0x607B19D7, "create_weapon_object_watcher" },
    { 0x7A2BE673, "create_weaver_rope" },
    { 0x77CFF3BB, "create_woods_nag_array" },
    { 0x39402525, "create_zombie_blood_dig_spot" },
    { 0x9CDA5E00, "create_zombie_buildable_piece" },
    { 0xEBCEC76F, "create_zombie_escape_spot" },
    { 0xB6F106C8, "create_zombie_point_of_interest" },
    { 0xE46C8B14, "create_zombie_point_of_interest_attractor_positions" },
    { 0x80B3118E, "create_zoom_tutorial_message" },
    { 0xF7DA464E, "createacousticsensorwatcher" },
    { 0xD2EA0298, "createairstrikerewindwatcher" },
    { 0xE8751E44, "createart" },
    { 0x29761697, "createballisticknifewatcher" },
    { 0x010AC3F1, "createballisticknifewatcher_zm" },
    { 0x993B88B8, "createbar" },
    { 0x59D41911, "createbasewatchers" },
    { 0x568B3366, "createblackboardforentity" },
    { 0x805DB2A2, "createblackoverlay" },
    { 0x0AF35D09, "createbombkillcament" },
    { 0xB0FE9907, "createbombzone" },
    { 0x7F5B3680, "createbouncingbettywatcher" },
    { 0xB3C30921, "createbsm" },
    { 0x672E13EA, "createbustriggers" },
    { 0xAA86728B, "createcablecarpath" },
    { 0xC2F7A8FF, "createcachesummary" },
    { 0xDE6E407A, "createcam" },
    { 0xDC2B3F22, "createcam_precache" },
    { 0xC9647D4D, "createcameramenu" },
    { 0x09358D3A, "createcameraspikewatcher" },
    { 0x7F34F1C3, "createcarryobject" },
    { 0x20B12F27, "createcarryqrdrone" },
    { 0x9BB4E859, "createchatevent" },
    { 0x9D4F722C, "createchatphrase" },
    { 0x9B390B03, "createclaymorewatcher" },
    { 0x3D432B85, "createclaymorewatcher_zm" },
    { 0xD0D695FB, "createclienttimer" },
    { 0x9C898587, "createconditional" },
    { 0xBB16316A, "createcopter" },
    { 0x25D4B1FC, "createcustomcameramenu" },
    { 0x37071106, "createcustomextracamxcamdata" },
    { 0x6D4C9F6B, "created" },
    { 0xEC17C686, "created_influencers" },
    { 0x9B46C221, "created_player_smoke_struct" },
    { 0x39D71623, "createdeadbody" },
    { 0x4618834D, "createdecoywatcher" },
    { 0x25E68262, "createdestroyhint" },
    { 0x5DB2BC05, "createdistanceobject" },
    { 0x0894B1A9, "createdynentandlaunch" },
    { 0xC8001096, "createeffect" },
    { 0x39242999, "createeventrule" },
    { 0x6D1F7396, "createeventruleparamsarray" },
    { 0x025FE9CA, "createexploder" },
    { 0x4E061D57, "createextracamxcamdata" },
    { 0x2347C7C7, "createfireflypodwatcher" },
    { 0x74AB4E4B, "createflag" },
    { 0x38C72BF4, "createflaghint" },
    { 0xBBFCA8D9, "createflagspawninfluencer" },
    { 0x74F01D90, "createflagspawninfluencers" },
    { 0xBCA065D9, "createflagzone" },
    { 0xE2AE8CC7, "createflashbackclone" },
    { 0x1FA18F5D, "createfontstring" },
    { 0x4D5C55D3, "createfx" },
    { 0x07AD1728, "createfx_autosave" },
    { 0xBBBBA547, "createfx_callback" },
    { 0x8ADC5BE6, "createfx_callback_thread" },
    { 0x6B4377A2, "createfx_centerprint" },
    { 0x7D6F6A19, "createfx_centerprint_thread" },
    { 0x14F34F5C, "createfx_control_room_closet" },
    { 0xE03BBEAA, "createfx_delay_done" },
    { 0xE9C3CE23, "createfx_disable_fx" },
    { 0x4500C9FE, "createfx_draw_enabled" },
    { 0xC4EC8ABC, "createfx_drawdist" },
    { 0xAC2DE266, "createfx_emergency_backup" },
    { 0x362906F5, "createfx_enabled" },
    { 0x48177335, "createfx_exploder_reset" },
    { 0x7F909E0A, "createfx_hudelements" },
    { 0xE6D35130, "createfx_init" },
    { 0x918A03E0, "createfx_inputlocked" },
    { 0xE845925C, "createfx_last_player_forward" },
    { 0x87FA9B3B, "createfx_last_player_origin" },
    { 0x9D074B3C, "createfx_last_view_change_test" },
    { 0x2245A7AC, "createfx_lockedlist" },
    { 0x2ED618BC, "createfx_manipulate_offset" },
    { 0x0831007C, "createfx_options" },
    { 0xEDD06485, "createfx_save" },
    { 0xD926F07A, "createfx_selecting" },
    { 0xA17CB6D5, "createfx_setup" },
    { 0x53A0E10D, "createfx_setup_gump1a" },
    { 0x79A35B76, "createfx_setup_gump1b" },
    { 0x9FA5D5DF, "createfx_setup_gump1c" },
    { 0x95947D00, "createfx_setup_gump1d" },
    { 0x1DAA57AB, "createfx_setup_gump_checkin" },
    { 0x8DB101A6, "createfx_setup_gump_club" },
    { 0xB0FDE421, "createfx_setup_gump_construction" },
    { 0xDC921B50, "createfx_setup_gump_hotel" },
    { 0xC91D02B8, "createfx_setup_gump_mall" },
    { 0x24C514EB, "createfx_setup_gump_sundeck" },
    { 0xA878B869, "createfx_setup_gump_the_end" },
    { 0x1577FF13, "createfx_showorigin" },
    { 0xD8043C31, "createfxcursor" },
    { 0xA904A25C, "createfxdelay" },
    { 0x49A1C6E2, "createfxent" },
    { 0x8532A7AD, "createfxents" },
    { 0x30C75CAB, "createfxexploders" },
    { 0xED43C789, "createfxhudelements" },
    { 0xC851DB57, "createfxlogic" },
    { 0x9F03B4DE, "createfxmasks" },
    { 0x3F9CA8F7, "createfxplayers" },
    { 0x5D37308A, "creategadgetproximitygrenadewatcher" },
    { 0xB0C6A4CD, "creategridlink" },
    { 0x3D2C7331, "creategridnode" },
    { 0xD0A058D8, "creategroundflameent" },
    { 0xEB28EF80, "createhackerhint" },
    { 0xE5400906, "createhatchetwatcher" },
    { 0x2A0166F9, "createheliguardsupport" },
    { 0x7ACF2F62, "createicon" },
    { 0xD42D5D1F, "createinfocard" },
    { 0x85668CE6, "createinterfaceforentity" },
    { 0x832B6FC8, "createitemelems" },
    { 0x9D65AA41, "createkillcament" },
    { 0xDE8334A5, "createkillcams" },
    { 0xCDA2E0AA, "createkillstreaktimer" },
    { 0xC71E51C4, "createkillstreaktimerforteam" },
    { 0x18117DDF, "createkillzone" },
    { 0x30168F22, "createkniferangwatcher" },
    { 0xC2395CC0, "createlfx_hudelements" },
    { 0xFA7DE507, "createlfxhudelements" },
    { 0x45CAC412, "createlights" },
    { 0x2957C2FF, "createline" },
    { 0x1A6B9FC2, "createlineconstantly" },
    { 0x21F67F44, "createloadouticon" },
    { 0x81FF9096, "createloadouttext" },
    { 0x7B7D3E24, "createloopeffect" },
    { 0x65D1E514, "createloopsound" },
    { 0x5307AB20, "createluimenu" },
    { 0xE6103DB8, "createmenu" },
    { 0x9DD0E785, "createmenu_controls" },
    { 0x8645C299, "createmenu_init" },
    { 0x9E5D5395, "createmission" },
    { 0x2A02DCBD, "createnapalmrewindwatcher" },
    { 0x31D636AC, "createnetworkintruderwatcher" },
    { 0x1BCB322A, "createnewexploder" },
    { 0x155BF05C, "createoneshoteffect" },
    { 0x230AE274, "createpage" },
    { 0x2E8B440F, "createplayerhelicopterwatcher" },
    { 0xD7C5E52F, "createpowerup" },
    { 0x2057D0D7, "createprimaryprogressbar" },
    { 0x439EEC42, "createprimaryprogressbartext" },
    { 0x992488DB, "createprintchannel" },
    { 0x715453CA, "createproximitygrenadewatcher" },
    { 0xD678D97F, "createproximityweaponobjectwatcher" },
    { 0x1DB514EF, "createqrcode" },
    { 0x9AE06CA6, "createqrdrone" },
    { 0xF8CA2186, "createqrdronewatcher" },
    { 0x2410CC17, "createraceobjective" },
    { 0xE603660E, "createradiospawninfluencer" },
    { 0x92D02A83, "createrapshelicopterinfluencer" },
    { 0x267E6BB4, "createrapsinfluencer" },
    { 0x0FCA2DE4, "creatercbombwatcher" },
    { 0x4D32B1BD, "createremotecontrolactionprompthud" },
    { 0x11F54165, "createremoteweapontrigger" },
    { 0xDAF3D8B3, "createretrievablehint" },
    { 0x2C0BA61C, "createreturnmessageelems" },
    { 0x821584A4, "createrewindwatcher" },
    { 0x5BB99BB4, "createriotshieldattractor" },
    { 0xACE2A36D, "createrope" },
    { 0x9622EE6B, "createrule" },
    { 0x33277344, "creates" },
    { 0xF3877878, "createsamturret" },
    { 0xD7ED4157, "createsatchelwatcher" },
    { 0x48D9EB23, "createscenecodeimage" },
    { 0xD01280E2, "createscramblerwatcher" },
    { 0x284D88B1, "createscriptmodelofentity" },
    { 0x2DC3C5FB, "createsecondaryprogressbar" },
    { 0x220D67CE, "createsecondaryprogressbartext" },
    { 0xCB111D01, "createsensorgrenadewatcher" },
    { 0x6F88521B, "createserverbar" },
    { 0x6AADF29C, "createserverfontstring" },
    { 0xD945E9E7, "createservericon" },
    { 0x4D374377, "createservertimer" },
    { 0x5196235A, "createsoundaliasslot" },
    { 0x254751DB, "createsoundrandom" },
    { 0x6E3A732C, "createspawnpoint" },
    { 0x1A67071E, "createspecialcrossbowwatcher" },
    { 0x95C1A321, "createspecialcrossbowwatchertypes" },
    { 0x64D7C6A7, "createspikelauncherwatcher" },
    { 0x1CF476D9, "createsquad" },
    { 0xDDD003B0, "createsquadcommand" },
    { 0xF1D74C19, "createstatuscard" },
    { 0x2BD645E8, "createstingerstate" },
    { 0x82AEA45F, "createstreamerhint" },
    { 0x77211254, "createstreamermodelhint" },
    { 0x4C6908E2, "createstruct" },
    { 0xE4DF8DAD, "createstructs" },
    { 0x06E2CC64, "createsubmenu" },
    { 0x90BBE612, "createtactinsertwatcher" },
    { 0x4FC161C1, "createteamobjpoint" },
    { 0xA276E732, "createteamprogressbar" },
    { 0x067FAD4F, "createteamprogressbartext" },
    { 0x43F446E3, "createthreatbiasgroup" },
    { 0x22766AF5, "createthreatdetectorwatcher" },
    { 0x6963ACB2, "createtime" },
    { 0xEDBC40D4, "createtimer" },
    { 0xE9503286, "createtimerdisplay" },
    { 0x88690538, "createtrophysystemwatcher" },
    { 0x79BDFDD3, "createturret" },
    { 0xE53EFC26, "createturretinfluencer" },
    { 0x5821ABB6, "createuimodel" },
    { 0x1A87DFCF, "createunit" },
    { 0xCA5C4BA7, "createuseobject" },
    { 0xB8A70805, "createuseweaponobjectwatcher" },
    { 0x8693174C, "createvox" },
    { 0x8257BE17, "createwargamedatahudelem" },
    { 0x8EE5A301, "createweakpointwidget" },
    { 0x57B7F174, "createweaponobjectwatcher" },
    { 0x20A55B60, "createzapperstruct" },
    { 0x6FB8BB89, "createzombieeyes" },
    { 0x255C0B26, "createzombieeyesinternal" },
    { 0x5778C60F, "createzombienotifystring" },
    { 0xE74E7C6D, "createzonespawninfluencer" },
    { 0xF3B27562, "creatfx" },
    { 0x25BAF040, "creating" },
    { 0x4444B99F, "creating_corpse" },
    { 0x40E54574, "creating_particle_light" },
    { 0xA9B32052, "creatingexploderarray" },
    { 0x55930E8A, "creation" },
    { 0x0B807BCA, "creative" },
    { 0xB77C566F, "creator" },
    { 0xCAF4856A, "credit" },
    { 0xAEC8D9B7, "credit1" },
    { 0x3CC16A7C, "credit2" },
    { 0x62C3E4E5, "credit3" },
    { 0xB4F7ACF1, "credit_list" },
    { 0x85CD5CFD, "credited" },
    { 0x51BE46D5, "creditplayer" },
    { 0xE3627F25, "credits" },
    { 0x04C3C05E, "credits_abort" },
    { 0x897E8F46, "credits_active" },
    { 0x05857994, "credits_background" },
    { 0xA868D02E, "credits_cin_id" },
    { 0x927B1E17, "credits_end" },
    { 0x9B4BABED, "credits_frommenu" },
    { 0xBBE3AE02, "credits_fx" },
    { 0x1FDFA690, "credits_list" },
    { 0x34F313F4, "credits_list_pc" },
    { 0xF2BB9757, "credits_list_ps3" },
    { 0xB98FDF3C, "credits_list_wii" },
    { 0x60898B7F, "credits_main" },
    { 0xFEEAB028, "credits_movie1_done" },
    { 0xF90CAD31, "credits_movie2_done" },
    { 0x803461FA, "credits_movie3_done" },
    { 0x151D6753, "credits_movie4_done" },
    { 0x2548A8E4, "credits_movie5_done" },
    { 0x257319DD, "credits_movie6_done" },
    { 0x36EB28A6, "credits_movie7_done" },
    { 0x4100D2BF, "credits_movie8_done" },
    { 0x95247E00, "credits_movie9_done" },
    { 0x1AD7CD18, "credits_movie_1" },
    { 0x8CDF3C53, "credits_movie_2" },
    { 0x66DCC1EA, "credits_movie_3" },
    { 0xD8E43125, "credits_movie_4" },
    { 0xB2E1B6BC, "credits_movie_5" },
    { 0x24E925F7, "credits_movie_6" },
    { 0xFEE6AB8E, "credits_movie_7" },
    { 0x10C67439, "credits_movie_8" },
    { 0xEAC3F9D0, "credits_movie_9" },
    { 0x425C7A22, "credits_movie_complete" },
    { 0x04DCB78F, "credits_movie_done" },
    { 0x6AC24986, "credits_scroll_with_movies_sequence" },
    { 0x4C539224, "credits_sequence1" },
    { 0x843BE6FF, "credits_sequence1_abort" },
    { 0xCE182C8F, "credits_sequence1_done" },
    { 0x2DE5EAC2, "credits_sequence1_skip" },
    { 0xB1423BF5, "credits_sequence1a" },
    { 0x02E2554E, "credits_sequence1a_abort" },
    { 0x0542D5D8, "credits_sequence1a_done" },
    { 0x9BD658FD, "credits_sequence1a_skip" },
    { 0xBE5B015F, "credits_sequence2" },
    { 0xC1D0B2C8, "credits_sequence2_abort" },
    { 0x957D9F82, "credits_sequence2_done" },
    { 0x5BB6FF5F, "credits_sequence2_skip" },
    { 0x232E9584, "credits_sequence2a" },
    { 0x9F881B9F, "credits_sequence2a_abort" },
    { 0x97A880AF, "credits_sequence2a_done" },
    { 0xF4FBD5E2, "credits_sequence2a_skip" },
    { 0x985886F6, "credits_sequence3" },
    { 0x10E1D731, "credits_sequence3_abort" },
    { 0xE3CFBB79, "credits_sequence3_done" },
    { 0x2EB8B4B8, "credits_sequence_abort" },
    { 0xDDBB982D, "credits_skip" },
    { 0x708D4B24, "credits_snapshot" },
    { 0x4137E043, "creek" },
    { 0x56C31073, "creek_1" },
    { 0xA5AB58F6, "creek_1_amb" },
    { 0xCB313159, "creek_1_anim" },
    { 0x0A26DB65, "creek_1_art" },
    { 0x516408EF, "creek_1_assault" },
    { 0x79AF6AAA, "creek_1_calvary" },
    { 0x3E425E5C, "creek_1_drag" },
    { 0x739D3A07, "creek_1_fade_screen" },
    { 0xC100666C, "creek_1_fx" },
    { 0xA399785A, "creek_1_livestock" },
    { 0x77B805C4, "creek_1_spawn_func" },
    { 0x2A9620C6, "creek_1_start" },
    { 0xCEA1071A, "creek_1_start_anim" },
    { 0xEFBB70C3, "creek_1_start_fx" },
    { 0xCC0F7733, "creek_1_stealth" },
    { 0x7522C0AF, "creek_1_tank_battle" },
    { 0xC85E7F5C, "creek_1_tunnel" },
    { 0xD415FE9A, "creek_1_util" },
    { 0x146726FB, "creek_1b" },
    { 0x37F9CC7E, "creek_1b_amb" },
    { 0x34D3281A, "creek_axis_dialogue" },
    { 0x306DC70D, "creek_bridge_guy" },
    { 0x2EDEB052, "creek_cqb_end" },
    { 0x387CE216, "creek_cqb_setup" },
    { 0xCB445D09, "creek_cqb_start" },
    { 0x41C2C6B8, "creek_dialogue" },
    { 0x129290FF, "creek_gate" },
    { 0x726D5590, "creek_guard_node" },
    { 0x5A655EDD, "creek_helicopter" },
    { 0x361D454D, "creek_rain_3d_structs" },
    { 0x19B5D84F, "creek_rats_start" },
    { 0x7F9B679E, "creek_rice_vc_object_anim_single" },
    { 0xA54BAE5C, "creek_s01_helo_event" },
    { 0x054E0F95, "creek_s01_meatshield" },
    { 0xA44690AF, "creek_truck" },
    { 0xFF444450, "creep" },
    { 0x9D3D0245, "creeper" },
    { 0xF9696B3B, "creeps" },
    { 0xDD7849B1, "creepy" },
    { 0x69437219, "creepy_vo" },
    { 0xB07C26FA, "creepy_vo_trig" },
    { 0xD696B9D4, "crematorium_zone" },
    { 0x90270FD3, "crept" },
    { 0xB5286100, "cresendo" },
    { 0x7E82FC26, "crest" },
    { 0x5D66EC42, "crew" },
    { 0x27211992, "crew1_dest" },
    { 0xE867B203, "crew2_dest" },
    { 0x4185129C, "crew3_dest" },
    { 0xA6F8BF20, "crew_array" },
    { 0x28325D8E, "crew_count" },
    { 0xDC359DD7, "crew_counter" },
    { 0xB145E947, "crew_dead" },
    { 0x57A17A1C, "crew_fireat_hip" },
    { 0xEE0EAFE6, "crew_group" },
    { 0xAA9AAA36, "crew_group_a" },
    { 0x84982FCD, "crew_group_b" },
    { 0x5E95B564, "crew_group_c" },
    { 0x38933AFB, "crew_group_d" },
    { 0xA90A8272, "crew_group_player" },
    { 0x7E641CF2, "crew_id" },
    { 0xBB850E2B, "crew_member" },
    { 0x24F8CD11, "crew_monitor" },
    { 0x11539E0B, "crew_num" },
    { 0xFD4E86FF, "crew_remaining" },
    { 0x732FF19B, "crew_rocket_explode" },
    { 0x06EA42B1, "crew_rpg_logic" },
    { 0x2830B9EA, "crew_sleep" },
    { 0xDE06413B, "crew_sniper_logic" },
    { 0xF410D3BA, "crew_spawners" },
    { 0x0097141E, "crew_stinger_logic" },
    { 0x8E95088D, "crew_structs_a" },
    { 0xB49782F6, "crew_structs_b" },
    { 0xDA99FD5F, "crew_structs_c" },
    { 0xD088A480, "crew_structs_d" },
    { 0x947B8E3B, "crew_structs_player" },
    { 0xE2A57E69, "crew_type" },
    { 0x4FC63B27, "crew_watcher" },
    { 0x6B7D8CBD, "crewchief" },
    { 0xA7EB400C, "crewchiefrange" },
    { 0x410529FF, "crewchiefrangesquared" },
    { 0x04370755, "crewed" },
    { 0xDFED722B, "crewmembers" },
    { 0x181913B3, "crewposition" },
    { 0x83EDE38D, "crews" },
    { 0x37DA48D5, "crewsize" },
    { 0x21A717D4, "crewspawned" },
    { 0x3F1107B0, "crimes" },
    { 0x7FEA8E3A, "cripple" },
    { 0x4121E30A, "crippled" },
    { 0x150F6656, "criteria" },
    { 0x3801DFC9, "criterias" },
    { 0x704782E9, "critic" },
    { 0x6C4246AA, "critical" },
    { 0x8D18DA1E, "critter" },
    { 0xC01DB2A7, "critter_detect_death" },
    { 0x1D8D58F8, "critter_run" },
    { 0x458FDA4C, "critter_run_on_notify" },
    { 0x469C2211, "critter_run_on_trigger" },
    { 0x3693D681, "critters" },
    { 0x725F907A, "critters_init" },
    { 0xF4CBAAB4, "croc" },
    { 0x2F2AFC19, "croc_blink_lights" },
    { 0x4F5C8DEC, "croc_crash_movement" },
    { 0x44B750E3, "croc_death" },
    { 0x2A3253B9, "croc_destroyturret" },
    { 0x6E5C6858, "croc_emped" },
    { 0x5D77E34A, "croc_exit_vehicle" },
    { 0x7B70C02D, "croc_find_new_position" },
    { 0xCCAC52A6, "croc_find_next_patrol_node" },
    { 0x01B9DD24, "croc_main" },
    { 0x6906B3D7, "croc_movementupdate" },
    { 0x9CA4EDDA, "croc_off" },
    { 0xCBF58F0C, "croc_on" },
    { 0x7A1C08C0, "croc_player_bullet_shake" },
    { 0x6D3AA264, "croc_player_rocket_recoil" },
    { 0x19508532, "croc_requestasmstate" },
    { 0x8DC7B3F5, "croc_scripted" },
    { 0x75B8871A, "croc_set_swim_depth" },
    { 0x098D45EB, "croc_set_team" },
    { 0xD2B899CE, "croc_start_ai" },
    { 0x0EC7AC30, "croc_stop_ai" },
    { 0x11A691B5, "croc_testbuoyancy" },
    { 0xDF0DDEB5, "croc_think" },
    { 0xEC53FB51, "croc_update_damage_fx" },
    { 0x6592734B, "croccallback_vehicledamage" },
    { 0x157399D0, "crooked" },
    { 0x37A63E4B, "crosby" },
    { 0x00D3689C, "crosby_behavior" },
    { 0xFCC10C2E, "crosby_build" },
    { 0xAA6317D6, "crosby_celerium" },
    { 0x61723973, "crosby_defend_scene" },
    { 0x72737CAD, "crosby_elevator_ride" },
    { 0x5C746FAD, "crosby_enter_elevator_room" },
    { 0xC868BE4F, "crosby_enter_salazar_soct" },
    { 0x65A2FEC4, "crosby_lab_intro" },
    { 0xFF542C16, "crosby_scene" },
    { 0xDF31E37D, "crosby_setup" },
    { 0x9F28B3BA, "crosby_unload_from_soct" },
    { 0x34124D57, "cross" },
    { 0x7C49AE83, "cross_bow_bolts" },
    { 0x1DE1658A, "cross_out_time" },
    { 0xB1236C37, "cross_product" },
    { 0x5F755CEC, "cross_road" },
    { 0xCBDF5986, "cross_shot_angle" },
    { 0x3369B78B, "crossblendtime" },
    { 0x52D602A9, "crossbow" },
    { 0x7DBC758B, "crossbow_attach" },
    { 0x98083D49, "crossbow_detach" },
    { 0x1728524F, "crossbow_dw" },
    { 0xE6C66613, "crossbow_monkey_bolt" },
    { 0x41E6B062, "crossbow_on_player_connect" },
    { 0x910266B6, "crossbow_target_pt" },
    { 0xDCFF4E5A, "crossbow_target_trigger" },
    { 0x3790B778, "crossbow_weapon" },
    { 0xEDC45950, "crossbowclipkillcount" },
    { 0xB893194D, "crossbowlh" },
    { 0x7D67CD20, "crossbows" },
    { 0x131AB41C, "crossed" },
    { 0x2A296B35, "crosser_logic" },
    { 0x8CF09323, "crosses" },
    { 0x4A1C787F, "crossesnoflyzone" },
    { 0x6F0DE986, "crossesnoflyzones" },
    { 0x65A70361, "crossfade" },
    { 0x77B30AA0, "crossfade_cin_hud" },
    { 0xE98B94B8, "crossfadein" },
    { 0xD3BDBCB7, "crossfadeout" },
    { 0x1D5B5D03, "crossfire" },
    { 0x2805AB33, "crosshair" },
    { 0xFA99C8BE, "crosshair_dialog" },
    { 0x6DFF4E53, "crosshair_fadetopoint" },
    { 0x4B7A9177, "crosshair_follow_off" },
    { 0x2A669BAD, "crosshairradius" },
    { 0x7928BAE2, "crosshairs" },
    { 0x72B8B209, "crossing" },
    { 0x15656E2C, "crossplayerenemy" },
    { 0x88C57A9C, "crossproduct" },
    { 0xDD533236, "crotch" },
    { 0xB3B1C669, "crotchet" },
    { 0x8FF826CF, "crouch" },
    { 0xF77C0D01, "crouch_hint" },
    { 0xF0568BB4, "crouch_jump_down_40" },
    { 0xE2E7AB59, "crouch_modifier" },
    { 0x71A78C8B, "crouch_offset" },
    { 0x6DF38934, "crouch_players" },
    { 0xA105819D, "crouch_triggers" },
    { 0x96E88B52, "crouchaim" },
    { 0x1F8952E0, "crouchanim" },
    { 0xFE2E1F68, "crouchcivilian" },
    { 0x46DE6D3B, "crouchdist" },
    { 0x18847814, "crouched" },
    { 0x925A571B, "crouches" },
    { 0x54D4CC3A, "crouchguard" },
    { 0xA927796F, "crouchheightoffset" },
    { 0x0B340438, "crouchhint" },
    { 0xC0689F31, "crouching" },
    { 0x76FC69C3, "crouchingisok" },
    { 0x96D4B3DF, "crouchpain" },
    { 0xBA97DB74, "crouchreload" },
    { 0x3AB53D8E, "crouchrun" },
    { 0x106E76FA, "crouchrun_combatanim" },
    { 0x7474A6B9, "crouchrunanim" },
    { 0x1B4AEBFF, "crouchruntocrouch" },
    { 0x904518D5, "crouchruntoprone" },
    { 0xED4D36F0, "crouchruntopronerun" },
    { 0xF9D3FA56, "crouchruntopronewalk" },
    { 0xAFD8B8AB, "crouchruntostand" },
    { 0xFBA4C610, "crouchspeed" },
    { 0x798A12E1, "crouchtocrouchrun" },
    { 0x699821C9, "crouchtocrouchwalk" },
    { 0x30671C86, "crouchtoprone" },
    { 0xA49F7319, "crouchtopronerun" },
    { 0x528A71C1, "crouchtopronewalk" },
    { 0x314FA6FC, "crouchtostand" },
    { 0x67A406C3, "crouchtostandrun" },
    { 0x2FBA3E3F, "crouchtostandwalk" },
    { 0xE1F095DD, "crouchwalktocrouch" },
    { 0xA7F11D15, "crouchwalktostand" },
    { 0x5C3F7D0C, "crouchy" },
    { 0xF347CBB3, "crough" },
    { 0xFC9A1A80, "crow" },
    { 0x6D112599, "crow1" },
    { 0xE7BC21A2, "crow2_animate" },
    { 0x87E4AD63, "crow2_atrium" },
    { 0x2151DEC3, "crow3_animate" },
    { 0xBF9BCB78, "crow3_atrium" },
    { 0xCE381634, "crow4_animate" },
    { 0x7E222399, "crow4_atrium" },
    { 0xA34F00C5, "crow5_animate" },
    { 0xF8DB34FE, "crow5_atrium" },
    { 0x4162DCCF, "crow6_atrium" },
    { 0xAF68ABE4, "crow7_atrium" },
    { 0x4AC1A035, "crow8_atrium" },
    { 0x16CEC226, "crow_01" },
    { 0xF0CC47BD, "crow_02" },
    { 0xCAC9CD54, "crow_03" },
    { 0xA4C752EB, "crow_04" },
    { 0x7EC4D882, "crow_05" },
    { 0x58C25E19, "crow_06" },
    { 0x32BFE3B0, "crow_07" },
    { 0x6CE50FD7, "crow_08" },
    { 0x90425EA8, "crow_animate" },
    { 0x11EB4D93, "crow_anims" },
    { 0x44A6B226, "crow_delete" },
    { 0x514EA560, "crow_flyaway" },
    { 0x2F825CA1, "crow_idle" },
    { 0x44D2CCD6, "crow_idle_and_fly_away" },
    { 0xD10A7716, "crow_idle_loop" },
    { 0x2F12824B, "crow_rumble_pecks" },
    { 0x57BD58EF, "crow_spot" },
    { 0xFF8F8884, "crowd" },
    { 0x99A4DE5C, "crowd_anim" },
    { 0x2B30D9C5, "crowd_cheer_hush" },
    { 0xA1A0C7CB, "crowd_cheer_start" },
    { 0xACE7A447, "crowd_close_ent" },
    { 0xB0BBA575, "crowd_ents" },
    { 0x4B1C8C15, "crowd_models" },
    { 0x4C3DD244, "crowd_models_close" },
    { 0x36E5C425, "crowd_models_close_head" },
    { 0x1F56B2FD, "crowd_sounds_ent" },
    { 0xC4E6BD53, "crowdanim" },
    { 0x908CF4D5, "crowdanims_starting" },
    { 0xE717C6E7, "crowded" },
    { 0x58CAD4DC, "crowdfireweapon" },
    { 0xEDA62E1A, "crowdmember" },
    { 0x6E8ECE83, "crowdmember_setuptriggers" },
    { 0x41FB311F, "crowdmember_status" },
    { 0x64992BF5, "crowdmember_triggerevent" },
    { 0x70BFBF15, "crowdmembers" },
    { 0x64351637, "crowds" },
    { 0x0907AD02, "crowdstatus" },
    { 0xABBDE303, "crowdswell" },
    { 0x259202ED, "crowe" },
    { 0x39B4B4AB, "crows" },
    { 0x7CBFECF4, "crows_nest" },
    { 0x9CF1DCA1, "crows_nest_start" },
    { 0x33B7F0D2, "crrek_1_prop_setup" },
    { 0x9562B079, "crs" },
    { 0x132054A3, "crsh" },
    { 0xC56C0AD8, "crsh_over" },
    { 0x0C27558D, "crtor_points" },
    { 0x0DA0A7DC, "crucial" },
    { 0x450965B9, "crud" },
    { 0x19C078D6, "crude" },
    { 0x7125C900, "cruise" },
    { 0xAC0CE57A, "crumb" },
    { 0xC86B6AEB, "crumb_index" },
    { 0x766AC331, "crumb_is_bad" },
    { 0x47F4E401, "crumb_list" },
    { 0x43B2B140, "crumb_offset" },
    { 0x5B2BC20D, "crumbed" },
    { 0x7B610E36, "crumbing" },
    { 0x1C3B500B, "crumble" },
    { 0xC2D86F6A, "crumbles" },
    { 0xFBDF596E, "crumbling" },
    { 0x0BD3D0F5, "crumbs" },
    { 0x3B90F051, "crumple" },
    { 0xD72E7DE0, "crumple_trigger" },
    { 0x01935E1E, "crunch" },
    { 0xF60DC892, "crunch_sedan" },
    { 0x708A0ED5, "crunch_truck_2" },
    { 0x536DD147, "cruncher" },
    { 0xAF62C40B, "crunchy" },
    { 0xA3448E6A, "crush" },
    { 0xFC21357E, "crush_anim" },
    { 0xF3F2CCC4, "crush_anim_started" },
    { 0xB70990A9, "crush_car" },
    { 0x74EB0DFD, "crushed" },
    { 0x573225AF, "crushedvehicle" },
    { 0xC8BE729B, "crusher" },
    { 0xA459F0BA, "crushers" },
    { 0xA2BBF832, "crushes" },
    { 0x53257B46, "crushing" },
    { 0x153E7F6E, "crushnode" },
    { 0xAB12FE36, "crust" },
    { 0x117B7893, "cry" },
    { 0x3EAF46AE, "cry_watcher" },
    { 0x347D068D, "crying" },
    { 0x9D912AA6, "crypt_disc_rotation" },
    { 0xF0FA0A4A, "cryptokeysbeforematch" },
    { 0x4F689071, "crystal_debug" },
    { 0x93D9795E, "crystal_dropped" },
    { 0x251B8F40, "crystal_handler" },
    { 0xCAE69A93, "crystal_hotsauce_start" },
    { 0x5F154D23, "crystal_id" },
    { 0xE2FA8947, "crystal_play_glow_fx" },
    { 0xE057558F, "crystal_sauce_end" },
    { 0xB5154C12, "crystal_sauce_monitor" },
    { 0xE562BCB4, "crystal_shrink_logic" },
    { 0x2BFCBD0E, "crystal_shrink_thread" },
    { 0x119AF5F9, "crystal_trail_runner" },
    { 0x3BF43EEB, "crystal_trigger_thread" },
    { 0x602BF03C, "crystal_weaksauce_start" },
    { 0x6B0F3138, "crystals" },
    { 0xBC50E507, "cs_cargoship_spotlight_on" },
    { 0x814896C1, "cs_cargoship_wall_light_orange_pulse" },
    { 0x716A8888, "cs_cargoship_wall_light_red_pulse" },
    { 0x24AF411B, "cs_emit_1" },
    { 0xB2A7D1E0, "cs_emit_2" },
    { 0xD8AA4C49, "cs_emit_3" },
    { 0x96B6B056, "cs_emit_4" },
    { 0xBCB92ABF, "cs_emit_5" },
    { 0xE5F881F1, "cs_lighting_flash" },
    { 0xC026B206, "csc" },
    { 0x2481FDF4, "cscene" },
    { 0xFA3620F1, "csceneobject" },
    { 0x3073D1DE, "cscriptbundlebase" },
    { 0x28D48BA3, "cscriptbundleobjectbase" },
    { 0xD2D391F4, "cscriptdocbegin" },
    { 0x0548FE28, "cscriptdocend" },
    { 0x7D5EB8B9, "cscs" },
    { 0x7A0E6CF4, "csecurityblocker" },
    { 0xEC47EE73, "csecuritycamera" },
    { 0x342AED8E, "csecuritycrusher" },
    { 0x88078FDA, "csecuritydoor" },
    { 0xC2312072, "csecuritylight" },
    { 0xA1EB9DF5, "csecuritymover" },
    { 0xC7C13CBA, "csecuritynode" },
    { 0x06D93C00, "csecuritypanel" },
    { 0x6648EAAE, "csecurityreversepanel" },
    { 0x074BBCA6, "csecurityshutdownpanel" },
    { 0xEF8EB6B1, "csecuritysystem" },
    { 0xAA3F381C, "csf_no_exhaust" },
    { 0x42518866, "csf_no_tread" },
    { 0x3E417AF2, "csf_stat_rotor_mon" },
    { 0xEE2AD155, "csf_stationary_rotor" },
    { 0xB55C1179, "csfx" },
    { 0x39FC910D, "csp" },
    { 0xA1F2A769, "cst" },
    { 0xEDF79C3B, "csv" },
    { 0x0276701D, "csv_filename" },
    { 0x388CA26D, "csvfile" },
    { 0xA894E9B4, "csvfilename" },
    { 0x06D02CFE, "csvfilesaved" },
    { 0x5608BCD1, "csvinclude" },
    { 0x5DF511DA, "csvs" },
    { 0x5E919CB1, "ct_street_lamp_on" },
    { 0x19D4EAD4, "ctaches" },
    { 0xC164643E, "cteamgather" },
    { 0xC5E42F06, "ctf" },
    { 0xC35B4AD8, "ctf_carrier_influencer_radius" },
    { 0xF1FD6EF0, "ctf_carrier_influencer_score" },
    { 0x5868D2B4, "ctf_carrier_influencer_score_curve" },
    { 0x46F23746, "ctf_dropped_influencer_radius" },
    { 0x59F92E92, "ctf_dropped_influencer_score" },
    { 0xB8122CEE, "ctf_dropped_influencer_score_curve" },
    { 0xC817637A, "ctf_endgame" },
    { 0x542E089E, "ctf_enemy_base_influencer_radius" },
    { 0xA762795A, "ctf_enemy_base_influencer_score" },
    { 0xB6B8DC46, "ctf_enemy_base_influencer_score_curve" },
    { 0x6CA7EA01, "ctf_enemy_carrier_influencer_radius" },
    { 0x2513E977, "ctf_enemy_carrier_influencer_score" },
    { 0x79EFD11B, "ctf_enemy_carrier_influencer_score_curve" },
    { 0x0F5C9580, "ctf_flag_get_home" },
    { 0x851D9279, "ctf_flag_in_sight" },
    { 0x21B76283, "ctf_flag_is_close" },
    { 0x51B57BFD, "ctf_flank" },
    { 0x743165A7, "ctf_friendly_base_influencer_radius" },
    { 0x43F87D69, "ctf_friendly_base_influencer_score" },
    { 0x7DEC187D, "ctf_friendly_base_influencer_score_curve" },
    { 0xDF64434E, "ctf_friendly_carrier_influencer_radius" },
    { 0xFC3B5A8A, "ctf_friendly_carrier_influencer_score" },
    { 0x199FD276, "ctf_friendly_carrier_influencer_score_curve" },
    { 0xD43C600F, "ctf_gamemodespawndvars" },
    { 0x9F1352BC, "ctf_get_flag" },
    { 0xB06D4E3F, "ctf_getteamkillpenalty" },
    { 0xCBDE9E86, "ctf_getteamkillscore" },
    { 0x9074A139, "ctf_goal_radius" },
    { 0x1EB33300, "ctf_has_flag" },
    { 0x86DB42D1, "ctf_icon_hide" },
    { 0xEB6994E7, "ctf_move_to_flag" },
    { 0x6F487BD4, "ctf_nodes" },
    { 0x6274F19A, "ctf_rules" },
    { 0x5848F7DA, "ctf_setteamscore" },
    { 0x7EF0DAA5, "ctf_wins_index" },
    { 0x8997812A, "ctfbaseicon" },
    { 0x1267DD47, "ctfflags" },
    { 0xFA893B5A, "ctrl" },
    { 0x965C4207, "ctrlheld" },
    { 0x6676D945, "ctt1" },
    { 0x823ABAAA, "ctt1_fifty_percent_vox" },
    { 0xF4EFA5B3, "ctt1_first_kill_vox" },
    { 0x35450C6D, "ctt1_full_vox" },
    { 0x63B290EE, "ctt1_init" },
    { 0x8C7953AE, "ctt2" },
    { 0x38A0BBF4, "ctt2_full_vox" },
    { 0xFF7A299B, "ctt2_init" },
    { 0xBC3741EA, "ctt_aud_note" },
    { 0x36FD1ECD, "ctt_cleanup" },
    { 0x14B1245E, "ctt_first_kill" },
    { 0x384D443E, "ctt_trail_runner" },
    { 0x0997D05B, "ctto" },
    { 0x84039F35, "ctvg_build_over" },
    { 0x4B348707, "ctvg_tp_done" },
    { 0xCEC4AC19, "ctvg_validation" },
    { 0x6EAB00CA, "ctw_find_zombies_for_powerup" },
    { 0xC10FD96F, "ctw_light_tube" },
    { 0xDEC51D1F, "ctw_max_fail_vo" },
    { 0x1539DA77, "ctw_max_fail_watch" },
    { 0x2C0C26A5, "ctw_max_start_wisp" },
    { 0xC13F9CB8, "ctw_max_success_watch" },
    { 0x9819BADE, "ctw_max_wisp_enery_watch" },
    { 0xD51FC41C, "ctw_max_wisp_play_fx" },
    { 0xEED4DAF9, "ctw_power_up_ric_zombie" },
    { 0x8B0B44F4, "ctw_power_up_zombie" },
    { 0xDFAB047D, "ctw_power_up_zombie_m_fx" },
    { 0xC9F5EE9B, "ctw_return_wisp_to_guillotine" },
    { 0x0287D8B9, "ctw_ric_get_next_wisp_struct" },
    { 0xA83AC68F, "ctw_ric_guillotine_glow" },
    { 0x286FB48A, "ctw_ric_move_wisp" },
    { 0x3287E527, "ctw_ric_power_towers" },
    { 0xC165EF19, "ctw_ric_start_wisp" },
    { 0x545B3935, "ctw_ric_watch_wisp_dist" },
    { 0xB11807EE, "ctw_ric_watch_wisp_timeout" },
    { 0x0407500F, "ctw_wisp_moved" },
    { 0x3838DA83, "ctw_wisp_timeout" },
    { 0x0CE351B0, "cuav" },
    { 0x9DF94810, "cuav_map_x_offset" },
    { 0x597319F1, "cuav_map_x_percentage" },
    { 0x74E55157, "cuav_map_y_offset" },
    { 0x8876352E, "cuav_map_y_percentage" },
    { 0xFE090E47, "cuav_offset_index" },
    { 0xD4D7BDF4, "cuav_time" },
    { 0x53E2E696, "cuavhackertoolradius" },
    { 0x682CD56B, "cuavhackertooltimems" },
    { 0xAC7FF622, "cuba" },
    { 0xF322C5A6, "cuba_aasasination" },
    { 0x334BC6E5, "cuba_airfield" },
    { 0xC7BA13C3, "cuba_amb" },
    { 0x0301EF26, "cuba_anim" },
    { 0x8B83F4D0, "cuba_art" },
    { 0xE8D960C8, "cuba_assasination" },
    { 0xF32210EC, "cuba_bar" },
    { 0x3B92197D, "cuba_bar_amb" },
    { 0xA101C034, "cuba_bar_anim" },
    { 0x45D03845, "cuba_bar_fx" },
    { 0x0113BF0E, "cuba_compound" },
    { 0x8B934B5B, "cuba_context_melee" },
    { 0x668D962A, "cuba_custom_getouts" },
    { 0xC18EBC13, "cuba_drive" },
    { 0x6F170664, "cuba_escape" },
    { 0xD03BE227, "cuba_fx" },
    { 0xBCEE9BD1, "cuba_goatpath" },
    { 0x669C6893, "cuba_keep_moving" },
    { 0x967CD771, "cuba_load" },
    { 0x00A29334, "cuba_mansion" },
    { 0xE6F41965, "cuba_next_node" },
    { 0x82BDC763, "cuba_path_animation" },
    { 0xF133D168, "cuba_patrol_anims" },
    { 0x06E55C39, "cuba_pause_path" },
    { 0x8935A4D8, "cuba_scripters_to_sound" },
    { 0xD06D3862, "cuba_sign" },
    { 0xDFEFB32B, "cuba_sign_start" },
    { 0x4B93BDA4, "cuba_street" },
    { 0x1AED557D, "cuba_util" },
    { 0x07B0CCD8, "cuba_zipline" },
    { 0x3C6353B8, "cuban" },
    { 0xC22B3BCD, "cuban_names" },
    { 0x114EC860, "cuban_rebel_names" },
    { 0xD2B15642, "cubango" },
    { 0x599DF913, "cubans" },
    { 0x4489DFC6, "cube" },
    { 0x149F41D6, "cue" },
    { 0x3EB536F2, "cuelength" },
    { 0x17DFD51B, "cuename" },
    { 0x07786A49, "cues" },
    { 0x33165385, "culdesac" },
    { 0x7B0281B9, "cull" },
    { 0x7E42BACC, "cull_dist" },
    { 0x28E840F6, "cull_dist_adjustment" },
    { 0xDF69AC8D, "cull_distance" },
    { 0x03CF0869, "culldist" },
    { 0x4B7A85E6, "culled" },
    { 0x63FEC4CF, "culling" },
    { 0xDEAE857A, "culmulative_wait" },
    { 0xAD01F6E9, "cumbersome" },
    { 0x5662A5D4, "cumulative" },
    { 0x9C5AC991, "cumulatively" },
    { 0x542D8772, "cumulativepayoutpercentage" },
    { 0xF2BA2ABD, "cumulativeroundscores" },
    { 0x6DDEB73C, "cuold" },
    { 0x02BF792B, "cup" },
    { 0xB6BA8459, "cur" },
    { 0xFB12A63A, "cur_active_events" },
    { 0x4F2FA4FB, "cur_anim" },
    { 0x0EB28301, "cur_color" },
    { 0xBA754E2D, "cur_crumb" },
    { 0x974918AF, "cur_death_streak" },
    { 0xAFDEE995, "cur_fov" },
    { 0x05EB89B9, "cur_gamemode_win_streak" },
    { 0xE3BDCDED, "cur_kill_streak" },
    { 0xE8675A7E, "cur_level" },
    { 0xE9A656FC, "cur_level_start_pos" },
    { 0xF95949D5, "cur_level_type" },
    { 0x3FD9FB30, "cur_node" },
    { 0x23739ECC, "cur_num" },
    { 0x619168BA, "cur_origin" },
    { 0xA332D3CE, "cur_pitch" },
    { 0x90B1F2CB, "cur_player" },
    { 0xDAC04799, "cur_poi_index" },
    { 0xF1B94506, "cur_ranknum" },
    { 0x46084B6C, "cur_round" },
    { 0xB8A8616D, "cur_speed" },
    { 0x687D6B67, "cur_target" },
    { 0xEA7C3E8F, "cur_time" },
    { 0x148865D1, "cur_val" },
    { 0xD0314179, "cur_veh" },
    { 0xA7566957, "cur_wave" },
    { 0x6D3DB337, "cur_weap" },
    { 0xC2577628, "cur_weapon" },
    { 0x4D07769B, "cur_win_streak" },
    { 0x5A229C3E, "cur_z" },
    { 0xA5CBFCD9, "curangles" },
    { 0x46041F7E, "curanim" },
    { 0x7885092F, "curautosave" },
    { 0x9A0BA831, "curcharlevel" },
    { 0x808C68EF, "curclass" },
    { 0xA14EB0E6, "curcolor" },
    { 0xD52AFCE6, "curdir" },
    { 0xFF11F409, "curdist" },
    { 0xC5E4E7F8, "curdof" },
    { 0xF1D1FD6F, "curelement" },
    { 0x03E6E42B, "curenemy" },
    { 0x0B1144B5, "curenlty" },
    { 0x704E33E0, "curent" },
    { 0x42C01925, "curently" },
    { 0xDFAB62DC, "curentweapon" },
    { 0x7DA98503, "curevent" },
    { 0xFD5E5649, "curfrac" },
    { 0x77FCD40E, "curgameseg" },
    { 0x2BD05CB6, "curgrenadecount" },
    { 0xF4E4BA0F, "curhealth" },
    { 0xBD2BD544, "curheight" },
    { 0xA8A56CDC, "curious_mg" },
    { 0x87CE2DA7, "curl" },
    { 0xBE7C8A3C, "curmenu" },
    { 0x0810D589, "curnode" },
    { 0xD520929A, "curobjective" },
    { 0xB36CB577, "curorigin" },
    { 0x730E3648, "curpage" },
    { 0x37EAEDCC, "curpath" },
    { 0xB02B1CF0, "curpercent" },
    { 0x4101ED69, "curpos" },
    { 0x99A13F10, "curposition" },
    { 0x82ECE11C, "curpower" },
    { 0xFE4C4BD4, "curprogress" },
    { 0xD3D32279, "curr" },
    { 0x7A09B5F6, "curr_ability" },
    { 0x01B2347D, "curr_aim_anim" },
    { 0x94B317EE, "curr_ammo" },
    { 0x6218F4FD, "curr_angle" },
    { 0x18B92EBC, "curr_angles" },
    { 0xEBC5985B, "curr_anim" },
    { 0xE300D1DB, "curr_anim_end_time" },
    { 0xB315C55B, "curr_anim_key" },
    { 0x7FE8F906, "curr_auto_turrets_active" },
    { 0x05B4675E, "curr_briggs_anim" },
    { 0xF6369830, "curr_camshot_setting" },
    { 0x6BD65C58, "curr_char_anim" },
    { 0x57BC7FC3, "curr_day_num" },
    { 0xF154F859, "curr_delay" },
    { 0x7818FF0F, "curr_direction" },
    { 0xE3A73A8C, "curr_dist" },
    { 0x410B610B, "curr_exposure" },
    { 0x679F4749, "curr_face_base" },
    { 0xD5A0B54E, "curr_face_event" },
    { 0xB22D91ED, "curr_far_blur" },
    { 0x13BC26F1, "curr_far_end" },
    { 0x9CF8807A, "curr_far_start" },
    { 0xA308A90A, "curr_flag" },
    { 0x7516F9B0, "curr_flight_state" },
    { 0xC1CF2975, "curr_fov" },
    { 0x7D098623, "curr_frame" },
    { 0xDDB483B3, "curr_frame_count" },
    { 0x307398E3, "curr_fwd_vel" },
    { 0x40F11DEE, "curr_gametype_affects_rank" },
    { 0x7E5744F6, "curr_gump_info" },
    { 0xBFF46F79, "curr_idle_node" },
    { 0xBA383749, "curr_idx" },
    { 0x1AE719B8, "curr_info" },
    { 0xC6C55A1F, "curr_intensity" },
    { 0x87FFA9C9, "curr_key" },
    { 0x00A3DC47, "curr_lerp" },
    { 0x1954EF45, "curr_lightfx_slot" },
    { 0xA05A5B45, "curr_map_type" },
    { 0x58852333, "curr_model" },
    { 0x7BED0262, "curr_near_blur" },
    { 0xF46FD758, "curr_near_end" },
    { 0x745AC07B, "curr_near_start" },
    { 0x08AEFF90, "curr_node" },
    { 0x2C916324, "curr_node_dir" },
    { 0xD5BE9527, "curr_node_length" },
    { 0xFEE2B807, "curr_node_plane" },
    { 0x18293161, "curr_node_to_origin" },
    { 0xDE6F493E, "curr_obj_num" },
    { 0xE75C9ABB, "curr_pay_turret" },
    { 0xAB3E4D50, "curr_poi" },
    { 0x4A254448, "curr_poi_struct" },
    { 0x3A51F7FE, "curr_point" },
    { 0xC72F6EDA, "curr_pos" },
    { 0x8BFABF3E, "curr_radius" },
    { 0xA1D0C382, "curr_right_vel" },
    { 0xF90C030A, "curr_scale" },
    { 0x6B7A2E04, "curr_scene" },
    { 0x16AE1F83, "curr_scene_anim_keys" },
    { 0x8BA9EF86, "curr_scene_name" },
    { 0xE69605B7, "curr_size" },
    { 0xF1AA7978, "curr_slot" },
    { 0x875788D8, "curr_spotlighttype" },
    { 0x5F3C0084, "curr_stance" },
    { 0x6D181B0B, "curr_state" },
    { 0x4C63B252, "curr_streak" },
    { 0x0746187F, "curr_struct" },
    { 0x046E90C7, "curr_target" },
    { 0x871231EF, "curr_time" },
    { 0x3CD1369F, "curr_timer" },
    { 0xD9ABBD73, "curr_timescale" },
    { 0x128C24A3, "curr_tint" },
    { 0xBC399682, "curr_total" },
    { 0x47CA12E5, "curr_total_score" },
    { 0xEFAB0E88, "curr_track_index" },
    { 0xC630DC9A, "curr_trig" },
    { 0x14526368, "curr_trigger" },
    { 0xD6C526DF, "curr_up_vel" },
    { 0x2678A5B1, "curr_val" },
    { 0xDCE88437, "curr_value" },
    { 0x7CA5D3FD, "curr_vel" },
    { 0x0C4E0F97, "curr_weap" },
    { 0x8A87AC88, "curr_weapon" },
    { 0xABBA4D14, "curr_weapon_was_curr_equipment" },
    { 0xF450C75B, "curr_wire" },
    { 0x88C5355E, "curr_woods_anim" },
    { 0x48AF60BD, "curr_yaw" },
    { 0xACB1E176, "curr_zone" },
    { 0x481FAEB2, "currad" },
    { 0xCB769FF9, "currangles" },
    { 0x79BDF201, "curranimation" },
    { 0x55D78157, "currchallenges" },
    { 0x962C078F, "currclass" },
    { 0x40A80990, "currcp" },
    { 0x37213530, "currearnings" },
    { 0x018B98F2, "currectly" },
    { 0x8BCB93C7, "curremaining" },
    { 0x40B5AF80, "current" },
    { 0x9B1A25F8, "current_additional_time" },
    { 0x3D381124, "current_advance_level" },
    { 0x5AFD0FB5, "current_ai" },
    { 0xA455108A, "current_aim" },
    { 0xC1211159, "current_alpha" },
    { 0xD9F6250A, "current_ambient_line_cooldown" },
    { 0x7274C285, "current_ammo" },
    { 0x9D42EFD3, "current_amount" },
    { 0x04A38510, "current_angle" },
    { 0x2F998DFB, "current_angles" },
    { 0x15FCFC38, "current_anim" },
    { 0xC5968B50, "current_anim_speed" },
    { 0x0028567C, "current_anim_time" },
    { 0x90873830, "current_arena" },
    { 0x6437472A, "current_array" },
    { 0x6912FB74, "current_attack_line_cooldown" },
    { 0x63B76087, "current_b" },
    { 0x0ED8BFDD, "current_battle" },
    { 0x5C7885D7, "current_beat" },
    { 0xC14DFFC5, "current_bink" },
    { 0xB685CB6F, "current_bink_id" },
    { 0x983E987C, "current_board_dist" },
    { 0x46ED0C7D, "current_board_distance" },
    { 0x2E92FFC2, "current_breathing_waittime" },
    { 0x100CDC86, "current_buildable_piece" },
    { 0xC4B3A039, "current_buildable_pieces" },
    { 0xDE371B5C, "current_clamp" },
    { 0x52F1BF0E, "current_claw" },
    { 0x4AB5B9B0, "current_cockpit_state" },
    { 0x1AC01AC9, "current_color_index" },
    { 0xAF232FED, "current_color_order" },
    { 0xA87BF90A, "current_color_state" },
    { 0x7D67E246, "current_console" },
    { 0x891B8960, "current_convo" },
    { 0xFCF49D70, "current_cost" },
    { 0xA6C3A884, "current_count" },
    { 0xD6981308, "current_cp_hud" },
    { 0xF8EF2F24, "current_craftable_piece" },
    { 0x1666FE57, "current_craftable_pieces" },
    { 0xAD11F608, "current_crate" },
    { 0xB5DB04DC, "current_crumb" },
    { 0x592351F7, "current_cull" },
    { 0x0F736F48, "current_cutoff" },
    { 0x7FA88211, "current_d" },
    { 0x3F6CE1A8, "current_damage" },
    { 0xC7460162, "current_damage_state" },
    { 0x8B2B2FF3, "current_damage_state_index" },
    { 0x13246B46, "current_days" },
    { 0x075B3119, "current_debug_index" },
    { 0xEC52AF9C, "current_debug_spawn_manager" },
    { 0x8955AB4D, "current_debug_spawn_manager_targetname" },
    { 0x6E60AD7F, "current_defcon_level" },
    { 0xF2DFD712, "current_degrees" },
    { 0x79A36C76, "current_depth" },
    { 0xAE271447, "current_dest" },
    { 0x03CB8D05, "current_destination" },
    { 0x3C35D47F, "current_destruct_state" },
    { 0x29F4ABD3, "current_dist" },
    { 0x169FB9B5, "current_dist_squared" },
    { 0xB7648D5E, "current_distance" },
    { 0xD0EB2FD3, "current_distance_from_goal_squared" },
    { 0x4F88A71F, "current_distsq" },
    { 0xCE9BAB3D, "current_dmg" },
    { 0x4D81E503, "current_door" },
    { 0x27832C98, "current_dot" },
    { 0xEC643DB5, "current_driver" },
    { 0x479F274A, "current_edge_vo" },
    { 0x688597FE, "current_emotion" },
    { 0x11F67BA9, "current_enemy" },
    { 0x61301346, "current_enemy_fighters" },
    { 0xBD3CE0AA, "current_enemy_pos" },
    { 0xA929E42D, "current_equipment" },
    { 0x7532ED9E, "current_equipment_active" },
    { 0xC3E11458, "current_exposure" },
    { 0xFC07501B, "current_fallbackers" },
    { 0x64559EC5, "current_farblur" },
    { 0xC1546879, "current_farend" },
    { 0xEF820512, "current_farstart" },
    { 0x8FD6FA12, "current_fires" },
    { 0xCDA9703F, "current_floor" },
    { 0x90EEA5B5, "current_fog_val" },
    { 0x8921ED66, "current_forward" },
    { 0x1BF46B2C, "current_fov" },
    { 0x9DC680E3, "current_frac" },
    { 0xB9E870EE, "current_friendly_damage" },
    { 0x14106CB1, "current_fx" },
    { 0xFDBA7EB5, "current_fx_speed" },
    { 0xA5AAFC7A, "current_g" },
    { 0x233453B8, "current_game_module" },
    { 0x9AE139C2, "current_gear" },
    { 0x795F270E, "current_generator" },
    { 0x465B42A4, "current_ghost_room_name" },
    { 0xC11D07B7, "current_ghost_round_number" },
    { 0xA167A24E, "current_ghost_window_index" },
    { 0x357BDAF9, "current_gib_state" },
    { 0x5681E81A, "current_goal" },
    { 0x9FB7735F, "current_grenade" },
    { 0x987865D5, "current_hands_ent" },
    { 0x739B7725, "current_health" },
    { 0x5BADF298, "current_health_percentage" },
    { 0xFF4573D1, "current_health_ratio" },
    { 0x47987F54, "current_heart_waittime" },
    { 0x995270AE, "current_hero_weapon" },
    { 0xE9D7DBA1, "current_idle" },
    { 0x271BB893, "current_idle_anim" },
    { 0xF75E5AAA, "current_idle_line" },
    { 0x9A2689B7, "current_idle_time" },
    { 0xC1F29BE0, "current_idx" },
    { 0x0FE0A6A9, "current_index" },
    { 0x285D79B6, "current_intensity" },
    { 0xB0E7E377, "current_intersection_goal_volume" },
    { 0x952CE510, "current_intro_horse_override" },
    { 0x92301ECA, "current_item" },
    { 0xFE55D78C, "current_key" },
    { 0x8D72080B, "current_killed_line_cooldown" },
    { 0x08980476, "current_lethal_grenade" },
    { 0x4A421E0F, "current_level" },
    { 0x9E0F0DAD, "current_line" },
    { 0x47A41BCB, "current_list" },
    { 0xBCC01A7A, "current_location" },
    { 0x2292BB85, "current_location_cover_type" },
    { 0x67CE6CE3, "current_lvt" },
    { 0x77E994F4, "current_main_dir" },
    { 0x9BF748EA, "current_map_vehicle" },
    { 0x4DA8DB57, "current_max_speed" },
    { 0x973D329C, "current_melee_is_front" },
    { 0xF3E739D8, "current_melee_weapon" },
    { 0x5DFD6316, "current_mg_focus" },
    { 0xC8B9920E, "current_mode" },
    { 0x6A10680C, "current_model_name" },
    { 0x1E5B830F, "current_module" },
    { 0x0C21860C, "current_move_anim" },
    { 0x11AED43F, "current_mowdown_exploder_index" },
    { 0xB947BB1A, "current_multiplier" },
    { 0x595336E4, "current_music" },
    { 0x0C49021E, "current_music_state" },
    { 0x96E28096, "current_nearblur" },
    { 0x1C54B2BC, "current_nearend" },
    { 0x8AD67797, "current_nearstart" },
    { 0x25B604CF, "current_node" },
    { 0x1F7E2F6C, "current_node_2" },
    { 0x4580A9D5, "current_node_3" },
    { 0x42618B51, "current_num" },
    { 0x8A899C7C, "current_number_of_vehicles" },
    { 0x84A25836, "current_obj" },
    { 0xCBEEF53F, "current_obj_num" },
    { 0xCD7EC080, "current_objective" },
    { 0x56745D45, "current_occupier" },
    { 0x9CFA7FAF, "current_ocean_speed" },
    { 0x94074EB5, "current_offhand" },
    { 0xE62EF826, "current_offset" },
    { 0xB07B56B3, "current_org" },
    { 0x6039B6D5, "current_origin" },
    { 0x42D6DD1A, "current_page" },
    { 0x02112D4A, "current_path" },
    { 0x592C1C64, "current_path_depth" },
    { 0x04E02A85, "current_paths" },
    { 0x1CF0DD4A, "current_pathto_pos" },
    { 0xB9EB2268, "current_penalty_points" },
    { 0x8A46D631, "current_perk_random_machine" },
    { 0xC0ECCAD7, "current_piece" },
    { 0x48E003A6, "current_placeable_mine" },
    { 0xD4C8E8D4, "current_playback_speed" },
    { 0x2F9B26F8, "current_player" },
    { 0x169A5822, "current_player_location" },
    { 0x53BA1F32, "current_player_mine" },
    { 0xDD686719, "current_player_scene" },
    { 0xCB04AE10, "current_player_speed" },
    { 0x7BBCBB53, "current_players" },
    { 0x382D3DDD, "current_playing_anim" },
    { 0x8EC169F9, "current_poi" },
    { 0x6372DB5B, "current_point" },
    { 0xAAB28B83, "current_pos" },
    { 0x2A769346, "current_position" },
    { 0xFD5224C8, "current_power_hud" },
    { 0x15CC2460, "current_power_value" },
    { 0x9647D71A, "current_progress" },
    { 0x93706376, "current_pts_shooting" },
    { 0xC3DF0717, "current_r" },
    { 0xD70E2F4F, "current_region" },
    { 0xFBAA4334, "current_restorable_points" },
    { 0x490DBF87, "current_right" },
    { 0x8FED0B68, "current_roam" },
    { 0x91DD5EE2, "current_roll" },
    { 0x5D080476, "current_room" },
    { 0xB8F20EB7, "current_rope_sound" },
    { 0xE30E0509, "current_round" },
    { 0x291B1496, "current_run" },
    { 0x7FD143E6, "current_sale_time" },
    { 0x3D6CE2A3, "current_saved_level" },
    { 0x3A578D37, "current_saving_number" },
    { 0x210837BB, "current_scale" },
    { 0x67C7C241, "current_scene" },
    { 0xAA7F0BF8, "current_scene_index" },
    { 0xB9F5C906, "current_script" },
    { 0xB000FA50, "current_seat" },
    { 0x4F861B01, "current_select_ent" },
    { 0x1175FF0C, "current_size" },
    { 0x84863FCA, "current_skill" },
    { 0xD954EDCB, "current_skim" },
    { 0x4E59EFE2, "current_soul_runners" },
    { 0xB7B5E000, "current_spawn" },
    { 0x5B543FB5, "current_spawn_manager_index" },
    { 0xAA4319D5, "current_spawner" },
    { 0xC984AD24, "current_spawners" },
    { 0x73501F28, "current_speed" },
    { 0xED5C5D10, "current_speed_mph" },
    { 0x1212D7EF, "current_spot" },
    { 0xC7A5CF3F, "current_stage" },
    { 0x94D7A810, "current_stance_func" },
    { 0xFAC907B8, "current_stander" },
    { 0x43F9F67D, "current_stat_count" },
    { 0xCD5E73A3, "current_stat_value" },
    { 0x9D9C84EA, "current_state" },
    { 0x32C04D47, "current_static_value" },
    { 0xFEB88CB0, "current_steel_count" },
    { 0xBB788F35, "current_step" },
    { 0xB2421158, "current_struct" },
    { 0x1CE27AEC, "current_subtask" },
    { 0xC0AD040F, "current_sun_color" },
    { 0x765CB489, "current_support_positions" },
    { 0xA0BD515A, "current_sword" },
    { 0x694495E3, "current_tactical_grenade" },
    { 0x9C610970, "current_target" },
    { 0x58868374, "current_targeters" },
    { 0xEE5256DB, "current_targets" },
    { 0xD3A38B2C, "current_task" },
    { 0xA6D61EF0, "current_threshold" },
    { 0x49A93B24, "current_time" },
    { 0xC664E01A, "current_time_played" },
    { 0x3EF47E62, "current_time_value" },
    { 0xDE4E9352, "current_timescale" },
    { 0xE932F56F, "current_tok" },
    { 0xE14FD8F0, "current_tomahawk_weapon" },
    { 0x4A4DC1AC, "current_track" },
    { 0x911634E9, "current_trig" },
    { 0x4D4EF031, "current_trigger" },
    { 0x159FD64B, "current_turret_target" },
    { 0x7E2B96FD, "current_unit" },
    { 0xB7209C88, "current_unit_type" },
    { 0xD6030158, "current_up" },
    { 0x2D2E72B6, "current_value" },
    { 0x10C06743, "current_variable_offset" },
    { 0x58151AEE, "current_vector" },
    { 0x5EEECD43, "current_vision" },
    { 0x5D4DE6BE, "current_vision_set" },
    { 0x8D8C2F96, "current_vol" },
    { 0x48BE1E8C, "current_watch_group" },
    { 0x6808CC14, "current_wave" },
    { 0xC81FBF5D, "current_wave_cleared" },
    { 0x5BA086C6, "current_waypoint" },
    { 0xF07434CB, "current_weapon" },
    { 0x6EE636A9, "current_weapon_acvi" },
    { 0x93A58DE4, "current_weapon_options" },
    { 0xECAC0296, "current_weapon_type" },
    { 0x972B552A, "current_weapons" },
    { 0xB443BE73, "current_weight" },
    { 0xD2FB8CBA, "current_white" },
    { 0x516C100F, "current_window" },
    { 0x47C63EFD, "current_x" },
    { 0x791DD79E, "current_x_pos" },
    { 0x21C3C494, "current_y" },
    { 0xF46564B5, "current_yaw_line_debug" },
    { 0xC0FA809F, "current_zombie_array" },
    { 0x5FBF6C05, "current_zombie_count" },
    { 0xCABB890D, "current_zone" },
    { 0xF360DD32, "currentaat" },
    { 0x613B9D65, "currentaathashid" },
    { 0x90762E73, "currentadvertisedstatus" },
    { 0xE5674521, "currentalt" },
    { 0x3D4AA1F1, "currentaltweapon" },
    { 0x29757767, "currentambushtime" },
    { 0x94364B6A, "currentammo" },
    { 0xD4E3B0DD, "currentammoinclip" },
    { 0x6E879668, "currentammostock" },
    { 0x138EFA00, "currentang" },
    { 0x7502A5C9, "currentangle" },
    { 0xEA4B32C0, "currentangles" },
    { 0xA5C8C7EA, "currentanimation" },
    { 0x8B0F7F88, "currentasmstate" },
    { 0xFECA4DC7, "currentattachment" },
    { 0x64655CBE, "currentattachments" },
    { 0x6CCA6195, "currentbonus" },
    { 0x073A675D, "currentcamerashot" },
    { 0xD710A954, "currentcarrier" },
    { 0x6F414386, "currentclipfrac" },
    { 0x06B66FC2, "currentcolorcode" },
    { 0x0C527C56, "currentcolorforced" },
    { 0x4BBDB3AF, "currentcontendercount" },
    { 0xAE33E9C3, "currentconvoline" },
    { 0xCCCBA1DE, "currentconvoplayer" },
    { 0x0EFF8A1D, "currentcount" },
    { 0x5BBA4C09, "currentdamagecallbacks" },
    { 0x0C29C7DC, "currentdest" },
    { 0x8C278AB2, "currentdialogimportance" },
    { 0xDCB0C6DC, "currentdialognotifystring" },
    { 0x66CD570D, "currentdialogsound" },
    { 0xAA9BD2F3, "currentdifficulty" },
    { 0x41EB8175, "currentdir" },
    { 0x94CCF6B3, "currentdirection" },
    { 0x03A487B0, "currentdist" },
    { 0xDDE9A741, "currentdistance" },
    { 0x90DC0340, "currentdistanceforcar" },
    { 0x34D83A68, "currentdistsq" },
    { 0x9A927C1C, "currentdrfilter" },
    { 0xEC9BA907, "currentdvar" },
    { 0xE07A7C2A, "currentempduration" },
    { 0x7F0A5AB2, "currentenemypos" },
    { 0x4F44610A, "currentenemythreatscale" },
    { 0x4E920B93, "currenteyeangles" },
    { 0xFFF4D26F, "currenteyeright" },
    { 0x2772BB30, "currenteyeup" },
    { 0x34D43BE1, "currentfailcount" },
    { 0x04C120F6, "currentflag" },
    { 0xA3C87699, "currentfov" },
    { 0x90389EBD, "currentgameseg" },
    { 0x832F74E9, "currentgear" },
    { 0x045DB17D, "currentgeyser" },
    { 0xC5118BC4, "currentgibflag" },
    { 0x4FEA9189, "currentgoal" },
    { 0x628F6AF9, "currentgoalpos" },
    { 0x44261D80, "currentgoals" },
    { 0x80557A4F, "currentguncyclemaxpoints" },
    { 0x3B8FD4F1, "currentguncyclepoints" },
    { 0x2362CF72, "currenthealth" },
    { 0xC383ED41, "currentheight" },
    { 0x4A3F1522, "currentheroabilitymask" },
    { 0x226FC10C, "currentheroweaponmask" },
    { 0x64B27ECC, "currenthidden" },
    { 0x1181B4ED, "currenthighground" },
    { 0x0A3B5DA2, "currenthighscore" },
    { 0xC216F374, "currentindex" },
    { 0xAFC85362, "currentitemcount" },
    { 0x7A50F216, "currentkillstreak" },
    { 0x3C58DB76, "currentkillstreakdialog" },
    { 0x971FAD8D, "currentkillstreakid" },
    { 0x4B6A621F, "currentleaderdialog" },
    { 0x2C6BE564, "currentleaderdialoggroup" },
    { 0x55E2BCEC, "currentleaderdialogtime" },
    { 0xC18932B2, "currentlevel" },
    { 0x62538352, "currentloadsmoothing" },
    { 0x18505126, "currentlocomovementtype" },
    { 0xBB18E950, "currentlookahead" },
    { 0x4C9D1852, "currentlvt" },
    { 0xFFA77AC5, "currently" },
    { 0x2F7E6FD3, "currently_spawning" },
    { 0xD23FF669, "currentlyattached" },
    { 0x4D660673, "currentlybeingrevived" },
    { 0xF186E751, "currentlyplaying" },
    { 0x802C262E, "currentmarker" },
    { 0xFDF68E2E, "currentmilestone" },
    { 0x23DC5024, "currentmovetime" },
    { 0xCA0BCF64, "currentnode" },
    { 0x7BAEFA85, "currentnode_lookahead" },
    { 0x47CBD824, "currentnodeisstop" },
    { 0x7784D260, "currentnum" },
    { 0x0EFFF509, "currentobjective" },
    { 0xD10D4540, "currentoffhand" },
    { 0x61D0F1E6, "currentorigin" },
    { 0xAFB0C9DC, "currentownerentnum" },
    { 0x347F1B86, "currentpayoutpercentage" },
    { 0xED858442, "currentpitch" },
    { 0xF3664349, "currentplace" },
    { 0x63397CF7, "currentplayerdotprod" },
    { 0x51145D4E, "currentplayeroffset" },
    { 0x2A1F3700, "currentplayerrating" },
    { 0x3577C5D6, "currentplaytype" },
    { 0x3C5A3D02, "currentpoint" },
    { 0xD5122E78, "currentpointonpath" },
    { 0xD874080E, "currentpos" },
    { 0x43C6829B, "currentpower" },
    { 0xFF2A44D4, "currentpowerup" },
    { 0xB8A5C17D, "currentqueue" },
    { 0x3FE1E809, "currentratio" },
    { 0xBB901528, "currentrobotcount_" },
    { 0x5E08CCE8, "currentround" },
    { 0xB1813A38, "currentscene" },
    { 0x33343C56, "currentscore" },
    { 0x86531C07, "currentscoreplace" },
    { 0xD144C957, "currentseason" },
    { 0x685F3D33, "currentseglength" },
    { 0xE9DDE3AE, "currentsentientcount_" },
    { 0xE618351D, "currentsessionmode" },
    { 0x0C143970, "currentset" },
    { 0x9EC74D34, "currentshotlength" },
    { 0xC7FBFBE4, "currentspecialty" },
    { 0xBEEE0485, "currentspectatingclient" },
    { 0x0E87F711, "currentspeed" },
    { 0x246ADA07, "currentspore" },
    { 0x975CB61C, "currentsprintdist" },
    { 0x8386B625, "currentsquadleader" },
    { 0x84EF7050, "currentstance" },
    { 0x615E3C8F, "currentstate" },
    { 0x59FE7F5B, "currentstateupdatedresult" },
    { 0x9E8F846C, "currentstowed" },
    { 0x68349951, "currentsurface" },
    { 0x0B06C7A0, "currenttag" },
    { 0xD09B3360, "currenttank" },
    { 0x75100B6B, "currenttarget" },
    { 0xC803BACB, "currenttargetloc" },
    { 0x97AD7BBB, "currentteam" },
    { 0xA5FBC6FA, "currentthrottlesmoothing" },
    { 0x079990BB, "currenttime" },
    { 0xEB8E52B7, "currenttimescale" },
    { 0xF96C55DB, "currenttypesatellite" },
    { 0x973A8690, "currenttypespyplane" },
    { 0x9ADE7043, "currentvalue" },
    { 0x870626C7, "currentvox" },
    { 0x7EA64A13, "currentvoxpriority" },
    { 0xFD4F9B7C, "currentweapon" },
    { 0x92851F9D, "currentweaponname" },
    { 0x931F743F, "currentweapons" },
    { 0x67DCBE03, "currentweaponstarttime" },
    { 0x2F2CA7B8, "currentx" },
    { 0x1C9E2541, "currentyaw" },
    { 0x4F4F544E, "currentyawcolor" },
    { 0x2930EBD2, "currentzone" },
    { 0x710E76FE, "curretclipammo" },
    { 0xD7E58A99, "curretnly" },
    { 0x6469F0BE, "curretstockammo" },
    { 0x2D833A55, "curretturretname" },
    { 0x801CACA3, "currevent" },
    { 0x9F74079D, "currfacestate" },
    { 0x99D5B3B8, "currframe" },
    { 0x7F5535FB, "currgametype" },
    { 0x79D65F6B, "currhistoryslot" },
    { 0x7D939BBB, "currhitloccount" },
    { 0x2E43B566, "curridx" },
    { 0x71BC9FEC, "curritem" },
    { 0x224A57A9, "currnode" },
    { 0xC421265A, "currpart" },
    { 0x13E3D209, "currpos" },
    { 0x3E9ED2E5, "currrently" },
    { 0xDC5A654D, "currscore" },
    { 0x7081AD7A, "currspeed" },
    { 0x42AB6EBB, "currstat" },
    { 0xE1360CBC, "currstate" },
    { 0x93A433CD, "currstock" },
    { 0xB0B84F72, "currstring" },
    { 0x1E35811E, "currstruct" },
    { 0x7F90542E, "currtime" },
    { 0x67BA4FD6, "currval" },
    { 0x9DFF2BC0, "currvalue" },
    { 0xAE5EE9C9, "currweapon" },
    { 0x9D77F050, "currweaponitemindex" },
    { 0xE2FCF279, "currxp" },
    { 0x72467C61, "currz" },
    { 0x1A6998E1, "curscale" },
    { 0xF333F2AD, "curscore" },
    { 0x2DD4425D, "curse" },
    { 0xE441FC17, "cursor" },
    { 0x7D6F1859, "cursor_hint" },
    { 0x9E949228, "cursor_hint_weapon" },
    { 0x847182FE, "cursor_x" },
    { 0xAA73FD67, "cursor_y" },
    { 0x4EC16F80, "cursorcolor" },
    { 0xD8E251BF, "cursorhintent" },
    { 0x27B4AF72, "curspawndata" },
    { 0x875B3ADA, "curspeed" },
    { 0x9A16AD75, "cursquad" },
    { 0x4C04A17A, "cursquadcam" },
    { 0x1E8BE9F5, "curstance" },
    { 0xA4088989, "curtain" },
    { 0xE3317F78, "curtain_anim_init" },
    { 0xAC13464A, "curtain_anims" },
    { 0x78470C06, "curtain_clip" },
    { 0x000129AE, "curtain_fx" },
    { 0x1E60C123, "curtain_sheer" },
    { 0x15E22886, "curtain_sheer_hang" },
    { 0xAF538580, "curtains" },
    { 0xAE105D19, "curtains_clip" },
    { 0x8514FB78, "curtains_left" },
    { 0x81AEC75F, "curtains_move_done" },
    { 0x380CE587, "curtains_right" },
    { 0x9D71765E, "curteam" },
    { 0xE58E2BFE, "curtent" },
    { 0x6556D20E, "curtime" },
    { 0x9C1EF06B, "curtorg" },
    { 0x5A42E7FB, "curunit" },
    { 0x7B8BB636, "curval" },
    { 0x5C207C20, "curvalue" },
    { 0xF032D918, "curvature" },
    { 0x6CDB94FA, "curve" },
    { 0xDDD5A687, "curve1" },
    { 0x6BCE374C, "curve2" },
    { 0x91D0B1B5, "curve3" },
    { 0x1FC9427A, "curve4" },
    { 0x45CBBCE3, "curve5" },
    { 0x4477065C, "curve_begin" },
    { 0x95611D20, "curve_end" },
    { 0xA9BEAAFA, "curve_id" },
    { 0xF3777A4A, "curve_speed" },
    { 0x5B281605, "curve_test" },
    { 0xFF524ECA, "curved" },
    { 0xA4C1EBD9, "curveid" },
    { 0xAE6B924E, "curvelength" },
    { 0x8583D51A, "curveremaining" },
    { 0x11321775, "curves" },
    { 0x6B158EAC, "curvol" },
    { 0x4DA064EE, "curweap" },
    { 0xAD86F906, "curweap_base" },
    { 0x3FBC8E73, "curweapname" },
    { 0x6CED28A9, "curweapon" },
    { 0x4583EADF, "curweaponclass" },
    { 0xFEBBDA01, "curweapondata" },
    { 0x4FEBEA93, "curx" },
    { 0x29E9702A, "cury" },
    { 0xCCF502AA, "cushion" },
    { 0x9B5DF18A, "cushion_sound_triggers" },
    { 0xD6525E7B, "custermise" },
    { 0x3AC3EB8E, "custody" },
    { 0x02A2B2B4, "custom" },
    { 0xA18023E7, "custom_acid_trap_damage_func" },
    { 0xAF7B8B82, "custom_add_vox" },
    { 0x7837E42A, "custom_add_weapons" },
    { 0x514014FD, "custom_ai_getgrenadecb" },
    { 0xDC1EEDC8, "custom_ai_spawn_check_funcs" },
    { 0x670D9144, "custom_ai_type" },
    { 0xFCB88EE9, "custom_ai_weapon_loadout" },
    { 0xE8A07EB6, "custom_airborne_func" },
    { 0x43708B20, "custom_all" },
    { 0x058975F7, "custom_anim_done" },
    { 0xD95B2623, "custom_animation" },
    { 0x07C50605, "custom_animmode" },
    { 0xFB2EA9FF, "custom_approach" },
    { 0x43B663B6, "custom_approachanimrate" },
    { 0xDE79D2C0, "custom_approachnumber" },
    { 0x21E05E17, "custom_approachtype" },
    { 0x12AB9DD1, "custom_array_remove" },
    { 0x97ABCCF3, "custom_attack" },
    { 0x4987460C, "custom_bank_deposit_vo" },
    { 0xAF17CD68, "custom_bank_withdrawl_vo" },
    { 0x7F11FC7F, "custom_banking_vo" },
    { 0xA92CFA00, "custom_battlechatter" },
    { 0xCFDAB09B, "custom_berserk" },
    { 0x5FD2A986, "custom_boat_death" },
    { 0xDDBDD6DF, "custom_box_move_func" },
    { 0x02EE71E1, "custom_box_move_logic" },
    { 0x1462EDC3, "custom_breadcrumb_store_func" },
    { 0x81201D2D, "custom_brutus_barrier_fx" },
    { 0x9272A014, "custom_brutus_flame_death_fx" },
    { 0xBE0DFB93, "custom_brutus_on_fire_timeout" },
    { 0x602028E0, "custom_build_think" },
    { 0xF43B8B2A, "custom_buildable_need_part_vo" },
    { 0x3B3BCA49, "custom_buildable_wrong_part_vo" },
    { 0xC3BEB1B4, "custom_buildablestub_update_prompt" },
    { 0x45FB7687, "custom_building_volumes" },
    { 0x1FAA47C1, "custom_calvary_sampan_death" },
    { 0x0A56FF24, "custom_character" },
    { 0x7CD36E57, "custom_characters" },
    { 0x3AC0F8DE, "custom_check_firesale_loc_valid_func" },
    { 0x86202D39, "custom_class" },
    { 0x72398BCB, "custom_class_attachment_select_focus" },
    { 0xE7763E6C, "custom_class_closed" },
    { 0x35211642, "custom_class_init" },
    { 0xC82F44CC, "custom_class_remove" },
    { 0x58EF7272, "custom_class_start_threads" },
    { 0xD082ED6F, "custom_class_update" },
    { 0xDD603074, "custom_close_fn" },
    { 0x5115F2AD, "custom_completion_callback" },
    { 0x9F832401, "custom_confirm" },
    { 0x77220FC2, "custom_craftable_update_prompt" },
    { 0x93B7659F, "custom_craftable_validation" },
    { 0x855E2EF2, "custom_craftablestub_update_prompt" },
    { 0x5E18A90D, "custom_crawler_pickup_func" },
    { 0x9B883983, "custom_create_redacted_line" },
    { 0x0024C511, "custom_damage_func" },
    { 0x0CB718EB, "custom_data" },
    { 0xDB9618E3, "custom_death" },
    { 0x922DB3C9, "custom_death_anim" },
    { 0x8BDD9672, "custom_death_quote" },
    { 0x1E2E82D9, "custom_death_sequence" },
    { 0xB4339659, "custom_debris_function" },
    { 0xDB47953C, "custom_debug_color" },
    { 0x43867716, "custom_deny_func" },
    { 0x5270EDC7, "custom_derive_damage_refs" },
    { 0xD64BDE58, "custom_detect_range" },
    { 0x6680FEF1, "custom_devgui" },
    { 0x03494969, "custom_dog_save" },
    { 0x85ED6183, "custom_dog_target_validity_check" },
    { 0x77CD8B9F, "custom_door_buy_check" },
    { 0x38FC4863, "custom_door_deny_vo_func" },
    { 0x903A7F35, "custom_drone_run_cycles" },
    { 0x56A53BC8, "custom_drone_spawn_allies" },
    { 0xFCC0B839, "custom_drone_spawn_axis" },
    { 0xE1DAEB90, "custom_effect" },
    { 0xBA40CA37, "custom_electric_cherry_perk_threads" },
    { 0x6C71CD56, "custom_emp_detonate" },
    { 0xDAE44D7D, "custom_end_screen" },
    { 0x7A3C10E1, "custom_eog_no_defaults" },
    { 0x10765834, "custom_execution_germ_thread" },
    { 0x56265C66, "custom_execution_russ_thread" },
    { 0xDF942FEA, "custom_execution_thread" },
    { 0x8759EDE2, "custom_exitanimrate" },
    { 0x5B0BD0AC, "custom_exitnumber" },
    { 0xAEF934E3, "custom_exittype" },
    { 0x16A9CDC6, "custom_exposed_idle" },
    { 0x984DD9BB, "custom_fade_in_for_limo_slide" },
    { 0x93864ECC, "custom_fade_screen" },
    { 0xE248CA06, "custom_fade_screen_in" },
    { 0xCE280D61, "custom_fade_screen_out" },
    { 0x8D8ECAB6, "custom_fade_screen_text" },
    { 0x8E13211A, "custom_faller_death" },
    { 0xC0AB7A91, "custom_faller_entrance_logic" },
    { 0x89E6A049, "custom_fan_trap_damage_func" },
    { 0xCC901E24, "custom_firesale_box_leave" },
    { 0xF74FB2F1, "custom_friendly_fire_message" },
    { 0x2903EC17, "custom_friendly_fire_shader" },
    { 0xF0F247D8, "custom_funcs_get_enemies" },
    { 0x8DD6128B, "custom_funcs_restore" },
    { 0x5BD16460, "custom_funcs_save" },
    { 0xD3BC0206, "custom_game_over_hud_elem" },
    { 0xB245F6C9, "custom_gamemodes_modified_damage" },
    { 0xDB158A1D, "custom_gamemodes_vampirism_health" },
    { 0x9150D7D1, "custom_gary_fade" },
    { 0x7E137BB4, "custom_generic_deny_vo_func" },
    { 0x8E350F33, "custom_get_anim" },
    { 0xAEFF2AF8, "custom_get_round_enemy_array_func" },
    { 0xF1830A8E, "custom_getouts" },
    { 0x3A105510, "custom_gib_refs" },
    { 0x1C69025F, "custom_goalradius_override" },
    { 0x4418B5D3, "custom_gondola_moving_vo_func" },
    { 0xF093CB1C, "custom_hud_elem" },
    { 0x173F2B3F, "custom_hud_num" },
    { 0x39AC3EB7, "custom_idle_setup" },
    { 0x35644C63, "custom_intermission" },
    { 0x22710177, "custom_intro_text" },
    { 0xA8645163, "custom_introscreen" },
    { 0x0A490243, "custom_item_dmg" },
    { 0x5DA18848, "custom_joker_movement" },
    { 0xC021652F, "custom_kill_damaged_vo" },
    { 0xD991FF5E, "custom_laststand_func" },
    { 0x4C280119, "custom_level_run_cycles" },
    { 0xBD438A8A, "custom_limited_weapon_checks" },
    { 0x8987707D, "custom_loadout_achievement" },
    { 0xD3578686, "custom_location" },
    { 0x70D18318, "custom_logic_func" },
    { 0xB98175E6, "custom_logic_func_param" },
    { 0xAC9EE6CF, "custom_magic_box_do_weapon_rise" },
    { 0x01BDA053, "custom_magic_box_fx" },
    { 0x119158BE, "custom_magic_box_selection_logic" },
    { 0x04710D51, "custom_magic_box_timer_til_despawn" },
    { 0xC6955E8B, "custom_magic_box_weapon_wait" },
    { 0xEA77C366, "custom_magicbox_float_height" },
    { 0xCFBA51F4, "custom_magicbox_state_handler" },
    { 0x6C908B87, "custom_max_zombies" },
    { 0xE477AE37, "custom_mission_complete" },
    { 0x1D7C976F, "custom_no_game_setupfunc" },
    { 0x50E05040, "custom_notify" },
    { 0x1000671D, "custom_onuse" },
    { 0x3122EAE6, "custom_open_fn" },
    { 0x9306C641, "custom_pandora_show_func" },
    { 0x4AC86260, "custom_pap_deny_vo_func" },
    { 0x7AD944F8, "custom_pap_move_in" },
    { 0xD24765F7, "custom_pap_move_out" },
    { 0x0F61B6C1, "custom_pap_state_handler" },
    { 0xF7B93450, "custom_pap_validation" },
    { 0x5CFFDE0E, "custom_patrol_init" },
    { 0x67E7F2D0, "custom_perk_random_state_handler" },
    { 0xD728B173, "custom_perk_validation" },
    { 0x85D19EB3, "custom_plane_validation" },
    { 0x2C475B56, "custom_player_attacker" },
    { 0x204265BC, "custom_player_death_vo_func" },
    { 0xBC90250F, "custom_player_fake_death" },
    { 0x3ECD9B3A, "custom_player_fake_death_cleanup" },
    { 0xC54B811B, "custom_player_shellshock" },
    { 0xBBDF4C2D, "custom_player_track_ammo_count" },
    { 0xF6D718F5, "custom_points_on_turret_damage" },
    { 0x37F2357B, "custom_power_think" },
    { 0xA3C0A0ED, "custom_powerup_vo_response" },
    { 0xB47A7AEF, "custom_prematch_period" },
    { 0x63B98ACE, "custom_prone_acknowledge" },
    { 0xDEE11F7F, "custom_random_perk_weights" },
    { 0xB5F9D46F, "custom_retreating_guys1_thread" },
    { 0x8A723769, "custom_rise_func" },
    { 0xC70BA2F3, "custom_riseanim" },
    { 0x575B87D8, "custom_rumble" },
    { 0xDF3D552E, "custom_sampan_death" },
    { 0x02035777, "custom_saves" },
    { 0xF6CCAF2B, "custom_set_time" },
    { 0x48E68680, "custom_sound" },
    { 0x462D4EF2, "custom_spawn_init_func" },
    { 0x95CEFB19, "custom_spawner" },
    { 0x5879FC88, "custom_spawner_entry" },
    { 0x6A6EE9CB, "custom_spawnplayer" },
    { 0x586A584F, "custom_spectate_permissions" },
    { 0x065E0014, "custom_springpad_fling" },
    { 0xDFA585AC, "custom_state_functions" },
    { 0x7A0BBAFD, "custom_stealth_ai" },
    { 0x39A62604, "custom_stealth_detection_range_setup" },
    { 0xBB645A9E, "custom_stealth_enter_combat" },
    { 0x549B1417, "custom_stealth_full_alert" },
    { 0xEFC91E59, "custom_stealth_idle" },
    { 0x7787CC7D, "custom_stealth_monitor_damage" },
    { 0xC1A08FE7, "custom_stealth_react_to_approaching_player" },
    { 0xF5F7CA76, "custom_stealth_react_to_gun_fire" },
    { 0x9E1780B1, "custom_stealth_reduce_initial_health" },
    { 0x7FFA9754, "custom_stealth_soft_alert" },
    { 0x7A2C6C1C, "custom_stop_idle" },
    { 0x53BC55EE, "custom_strafe" },
    { 0x2CB6D1FC, "custom_string" },
    { 0xF813F084, "custom_target" },
    { 0x75ECA6B5, "custom_think" },
    { 0x4F70B82F, "custom_tower_trap_fires_func" },
    { 0x05B04D4D, "custom_trapped_zombies" },
    { 0x154A271A, "custom_traversal_anim_finished" },
    { 0x5B0C67F2, "custom_traversal_cleanup" },
    { 0xB876B1D8, "custom_treasure_chest_glowfx" },
    { 0x997A4627, "custom_umbra_hotfix" },
    { 0xD06296FA, "custom_unload" },
    { 0xCF914A69, "custom_unload_function" },
    { 0xB7B04AA6, "custom_update_retrieve_trigger" },
    { 0x516CE2FA, "custom_validation" },
    { 0x0031C032, "custom_vending_power_off" },
    { 0x3F903F04, "custom_vending_power_on" },
    { 0xD81ADB93, "custom_vending_precaching" },
    { 0xAA9BE895, "custom_vibrate_func" },
    { 0x3408C657, "custom_village_patrol_init" },
    { 0xC8D33DFC, "custom_war_audio_main_cb" },
    { 0x50F5994A, "custom_war_mission_complete" },
    { 0x8F04BC9B, "custom_war_player_insert" },
    { 0x27DA1657, "custom_weapon_wall_prices" },
    { 0xE28EB587, "custom_widows_wine_perk_threads" },
    { 0x9CADE18D, "custom_wind_callback" },
    { 0xC9DE8783, "custom_zombie_audio_func" },
    { 0x7282962E, "custom_zombie_health" },
    { 0x93C0D0E6, "custom_zombie_introscreen" },
    { 0x3B71FF22, "custom_zombie_player_loadout" },
    { 0xB485A9AF, "custom_zombie_player_loadout_init" },
    { 0x805D0ECC, "custom_zombie_powerup_drop" },
    { 0x492563DB, "custom_zombie_setup" },
    { 0xDE1C220C, "custom_zombie_sound_play_frequences" },
    { 0x334797CC, "custom_zombie_sound_play_round_numbers" },
    { 0x284D9FBB, "custom_zombie_sound_played_interval" },
    { 0xAE993C10, "custom_zombie_sounds" },
    { 0x25450E53, "custom_zombie_vox" },
    { 0xD59E51CD, "customalivecheck" },
    { 0x4C584265, "customassistamt" },
    { 0x19EF1F32, "customautosavecheck" },
    { 0x552D30AE, "custombadplacethread" },
    { 0x2FBD7752, "customchatevent" },
    { 0xBA97940D, "customchatphrase" },
    { 0xA022A0AC, "customclass" },
    { 0x6EF4FF83, "customclass_closed" },
    { 0x6F94F04D, "customclass_focus" },
    { 0x872264A3, "customclass_remove" },
    { 0xA9C3C860, "customclass_update" },
    { 0xA9C01D9C, "customclassnum" },
    { 0x51E2CCE3, "customdamagemonitor" },
    { 0x449BA2A1, "customdelay" },
    { 0xA2FA6ADC, "customevent" },
    { 0x5FF45E07, "customexplosound" },
    { 0xBA8BD131, "customfirstanim" },
    { 0x0520DE4C, "customfunction" },
    { 0x68C830E5, "customgametypeheader" },
    { 0xC82FDA53, "customgametypesubheader" },
    { 0x0DE0B2E9, "customheight_mode" },
    { 0xBD92FC6B, "customheight_mode_off" },
    { 0x0792DF47, "customheight_mode_offsetmodels" },
    { 0x9F508948, "customhudreveal" },
    { 0x2FA5D1C1, "customizable" },
    { 0xF02114DC, "customization" },
    { 0xFBFB9ECD, "customization_data_struct" },
    { 0xCC08EC3B, "customization_invalid_paintjob_index" },
    { 0x516C27FD, "customization_invalid_paintjob_slot" },
    { 0x04C38915, "customizationpaintjobinvalidid" },
    { 0x7EB72FDA, "customize" },
    { 0x7B68832A, "customized" },
    { 0x23FD44D0, "customleaderboards" },
    { 0xB72D583A, "customloadoutscavenge" },
    { 0xD7764441, "customloasdoutscavenge" },
    { 0x6785E5BF, "custommatch" },
    { 0xBA645F62, "custommayspawnlogic" },
    { 0x247E58D4, "custommoveanimset" },
    { 0xE9B45ABC, "customnotetracks" },
    { 0x499916AC, "customrandomweaponweights" },
    { 0x15860C48, "customrotation_mode" },
    { 0x4B940E3E, "customrotation_mode_off" },
    { 0xDBE54F64, "customshellshock" },
    { 0x2D3EAC75, "customspawnlogic" },
    { 0x6D3FC27F, "customtarget" },
    { 0xC66F3F44, "customteam_init" },
    { 0x049E0867, "customtimer" },
    { 0x88C7DF15, "customtraverseendnode" },
    { 0x848F298A, "customtraversestartnode" },
    { 0x2C2A1D35, "customunload" },
    { 0x5E5EF2BD, "customvoxallocid" },
    { 0xD8F15777, "customvoxlist" },
    { 0xEC51E9E6, "custum" },
    { 0x9AC962CF, "cut" },
    { 0x8E35CDA2, "cut0_lookat" },
    { 0x6BE0FF24, "cut0_pos_end" },
    { 0x7218EC8F, "cut0_pos_start" },
    { 0xE9A04E85, "cut1_lookat" },
    { 0x43602BB9, "cut1_pos_end" },
    { 0x2DBEFA52, "cut1_pos_start" },
    { 0x44311B60, "cut1_position_end" },
    { 0xB0903C33, "cut1_position_start" },
    { 0x0F468F58, "cut2_lookat" },
    { 0xA52FE00E, "cut2_lookat_end" },
    { 0x413D043D, "cut2_lookat_start" },
    { 0xADA2ED7C, "cut2_pos" },
    { 0xA92881E2, "cut2_pos_end" },
    { 0xE8DF3159, "cut2_pos_start" },
    { 0xE986C29D, "cut2_position_end" },
    { 0xA7D4BC0E, "cut2_position_start" },
    { 0x1F02791D, "cut3_lookat_end" },
    { 0xF98B968E, "cut3_lookat_start" },
    { 0xF2F0BFB2, "cut3_position_end" },
    { 0xF674FE69, "cut3_position_start" },
    { 0x422448C9, "cut4" },
    { 0xCEDCF7E7, "cut4_position_end" },
    { 0x040C3A0C, "cut4_position_start" },
    { 0x141C4CA9, "cut_chute" },
    { 0x6A19F3A2, "cut_current_dialogue" },
    { 0x01B7EDC9, "cut_effect" },
    { 0x7969390D, "cut_engine_trigger" },
    { 0x4277C717, "cut_off_time" },
    { 0x792F9D81, "cut_reznov_blind_anim_short" },
    { 0x61EDD758, "cut_tf" },
    { 0x8A35D2B5, "cut_time" },
    { 0x634BF11B, "cutaway_geo" },
    { 0xFD3197D4, "cutaway_geo_floor" },
    { 0xE94862CE, "cutoff" },
    { 0x7FDD15FF, "cutoff_ammo" },
    { 0x3239B930, "cutoff_power" },
    { 0xBB42318A, "cutoff_time" },
    { 0x281F4F62, "cutoff_val" },
    { 0xDDC40392, "cutoffinches" },
    { 0x3E10900F, "cutoffmph" },
    { 0x7F921296, "cuts" },
    { 0x770D3319, "cutscene" },
    { 0xE065663F, "cutscene_damage" },
    { 0x91885481, "cutscene_extra_logic" },
    { 0x3136F4D0, "cutscenes" },
    { 0xC2B6BCD0, "cutter" },
    { 0x8CC6363F, "cutting" },
    { 0x742939E2, "cutting_detail_level_convex_hull" },
    { 0x4CE601F0, "cutting_detail_level_expensive_full" },
    { 0x367B6968, "cutting_detail_level_obb" },
    { 0x358D89BE, "cutting_vents" },
    { 0xDCF98E10, "cuttoff" },
    { 0xE6CE57A1, "cuz" },
    { 0x4AA17D7F, "cvar" },
    { 0xB8EFB04A, "cvomplete" },
    { 0x594D30D8, "cw1" },
    { 0x9EE7F209, "cw_c" },
    { 0x6705AEF5, "cw_o" },
    { 0x37D08895, "cwd" },
    { 0x9B6ED5A5, "cy" },
    { 0x215133FC, "cyan" },
    { 0xCFBE494F, "cyan_guys" },
    { 0xD91EA273, "cyan_guys_lead_player_to_apartment" },
    { 0xC1A285BF, "cyans" },
    { 0x7CA44C9C, "cyber" },
    { 0x175490FB, "cybercom" },
    { 0xFC6A1234, "cybercom_abilities_per_wheel" },
    { 0x2BEA276C, "cybercom_stats_end_index" },
    { 0x630CA277, "cybercom_stats_start_index" },
    { 0x9D743E8D, "cycle" },
    { 0x82F75E18, "cycle_function" },
    { 0x8D8061BD, "cycle_item" },
    { 0xEC3122AF, "cycle_light_slot" },
    { 0xF3B59B71, "cycle_lines" },
    { 0xC051243B, "cycle_time" },
    { 0x6537FED2, "cyclecount" },
    { 0x281D4E83, "cyclecounter" },
    { 0x2DA4097A, "cycledelay" },
    { 0xD3005165, "cycledelta" },
    { 0xF5ED6D6C, "cyclehordist" },
    { 0xD880150C, "cycles" },
    { 0xE4BA40FF, "cyclesleft" },
    { 0x97F0B92A, "cycletime" },
    { 0xB4E12308, "cyclic" },
    { 0x7822D471, "cyclic_index" },
    { 0x40929A38, "cycling" },
    { 0xBCC09008, "cylees" },
    { 0x03F4A589, "cylider" },
    { 0x26926D4F, "cylinder" },
    { 0xF58CA2D9, "cylinder_base" },
    { 0xAE3F8E59, "cylinder_forward" },
    { 0xB42D642F, "cylinder_height" },
    { 0x10FCDA16, "cylinder_height_unit_vector" },
    { 0xA307AA0F, "cylinder_radial_vector" },
    { 0x47EAA3C4, "cylinder_radius" },
    { 0xC0DF8B8E, "cylinder_radius_squared" },
    { 0xF8E2A46B, "cylinder_top" },
    { 0x9BD524C9, "cylinder_up" },
    { 0x6AD24D30, "cylinderdamage" },
    { 0x2AE3811F, "cylinderlength" },
    { 0x0D0D9A16, "cylinders" },
    { 0xB05C481F, "cylindrical" },
    { 0xF4BAC2BB, "cymbal" },
    { 0x03F4BDDA, "cymbal_monkey_clone_weapon" },
    { 0x3D2F06A2, "cymbal_monkey_dual_view" },
    { 0x0D20E538, "cymbal_monkey_exists" },
    { 0xA2DB84CF, "cymbal_monkey_model" },
    { 0x4441AAB1, "cymbal_monkey_name" },
    { 0xFDBCB094, "cymbal_monkeys" },
    { 0xC171500E, "cz" },
    { 0xF947E690, "cz75_auto_mp" },
    { 0x878EB0D1, "cz_gun" },
    { 0x629D4192, "cz_gun_origin" },
    { 0x87645AC3, "d" },
    { 0x20200D20, "d1" },
    { 0x0104C3A1, "d1_accel" },
    { 0xFE68FBF6, "d1_decel" },
    { 0xE55E6373, "d1_new_angle" },
    { 0x92277C5B, "d2" },
    { 0x8DEE569A, "d2_accel" },
    { 0xBABFB4E1, "d2_decel" },
    { 0x5A5C695C, "d2_new_angle" },
    { 0x26D05EC5, "d3dbsp" },
    { 0x2A3165FF, "d6" },
    { 0x0E41B9D6, "d_bits" },
    { 0xFDA5F7C7, "d_e" },
    { 0x8D84C6F4, "d_gate1" },
    { 0xFF8C362F, "d_gate2" },
    { 0x638EF415, "d_skytrans" },
    { 0xA4C25D89, "d_suncolor" },
    { 0x96FAE439, "d_sundir" },
    { 0xD3768CF0, "d_sunlight" },
    { 0x476A0C04, "d_trig" },
    { 0x0242E6D0, "d_vers" },
    { 0x2E30D686, "d_weaver" },
    { 0x00E64DF0, "da" },
    { 0x0D89DE46, "daaaamn" },
    { 0x6C682382, "daamge" },
    { 0x32474D54, "dad" },
    { 0x737D8213, "dagger" },
    { 0x61C8F3B7, "dailogue" },
    { 0x87D561EC, "daily" },
    { 0xFAD2205F, "daily_slot" },
    { 0x35C2C0D1, "dailycontractcompleted" },
    { 0x2429FBFD, "dailycontractcurrent" },
    { 0xBC34E351, "dailycontractid" },
    { 0xA1D9A465, "dailycontracttarget" },
    { 0xB9181F1F, "daiquiri" },
    { 0x44CCC909, "daisy" },
    { 0xBE7EFEF9, "dale" },
    { 0xBCB7575E, "dalem" },
    { 0x885D9B05, "dam" },
    { 0x91D22E1C, "dam_amount" },
    { 0x59D0B36D, "dam_dir" },
    { 0x20BB44BA, "dam_point" },
    { 0x88DC7DAC, "dam_trigger" },
    { 0x75455CFF, "dam_trigger_thread" },
    { 0x72F01E20, "dam_type" },
    { 0xA1409ACB, "dam_types" },
    { 0xF9348FDA, "damage" },
    { 0x2B25E23D, "damage state" },
    { 0x2D49FAE7, "damage1" },
    { 0xBB428BAC, "damage2" },
    { 0xE1450615, "damage3" },
    { 0x0E3FBAC1, "damage_absorbed" },
    { 0x6DC9B27E, "damage_accumulating" },
    { 0x72F1F7F3, "damage_adder" },
    { 0x1C9FD2FD, "damage_afterdeath" },
    { 0x907C5315, "damage_amount" },
    { 0x0B2E8EB4, "damage_and_blur_player" },
    { 0xF5465591, "damage_anims" },
    { 0x7A155F1A, "damage_area" },
    { 0x25149D13, "damage_assists" },
    { 0x4EA7BF62, "damage_at_end_of_path" },
    { 0xA4DF3173, "damage_at_pathend" },
    { 0xCF81D72B, "damage_back_window" },
    { 0xCD2C8C52, "damage_bonus" },
    { 0x4F73361B, "damage_callback_no_pvp_damage" },
    { 0xDEF396F6, "damage_caused_by" },
    { 0x5DB1E3E3, "damage_check_ragdoll" },
    { 0xCCEF906C, "damage_church" },
    { 0x3BE3D676, "damage_count" },
    { 0xA5BE121F, "damage_counter" },
    { 0x3ECF592E, "damage_debug" },
    { 0x894FD1C6, "damage_delay" },
    { 0x9ABFDE56, "damage_detection" },
    { 0x81E0ACF3, "damage_dialogue" },
    { 0x9B63C916, "damage_dir" },
    { 0xF8B5C574, "damage_direction" },
    { 0xB475BC02, "damage_direction_back" },
    { 0x6562426C, "damage_direction_front" },
    { 0xDF900E5C, "damage_direction_left" },
    { 0x9E1B22B3, "damage_direction_right" },
    { 0xCB26F92D, "damage_done" },
    { 0x9D0E9D5E, "damage_during_trophy_down" },
    { 0x05D63722, "damage_effect" },
    { 0x2BC551D9, "damage_effect_loop_time" },
    { 0x64CAACD0, "damage_ent" },
    { 0x505D4742, "damage_everything" },
    { 0x4B3C2814, "damage_factor" },
    { 0xB40BDCC8, "damage_feedback" },
    { 0x1DDCB8F2, "damage_feedback_get_dead" },
    { 0xFA6998F2, "damage_feedback_get_stage" },
    { 0x89F05052, "damage_feedback_growth" },
    { 0xCE56E3D0, "damage_feedback_icon" },
    { 0x8F8DB8FC, "damage_feedback_sound" },
    { 0xBADDDE87, "damage_filter" },
    { 0x2A9BB48A, "damage_filter_disable" },
    { 0x5932AAFF, "damage_filter_enable" },
    { 0x0B7EA337, "damage_filter_heavy" },
    { 0x4D5C2714, "damage_filter_init" },
    { 0xF7E865D5, "damage_filter_intensity" },
    { 0xF65FB63E, "damage_filter_light" },
    { 0x23AC2AD2, "damage_filter_min_time" },
    { 0x040CE5D9, "damage_filter_off" },
    { 0xD920F678, "damage_floor_watcher" },
    { 0xAE71CF19, "damage_frac" },
    { 0x1838207B, "damage_func" },
    { 0x05108ECF, "damage_fx" },
    { 0x617B78B1, "damage_fx_ent" },
    { 0x91F14F33, "damage_fx_stages" },
    { 0xE6052593, "damage_heal" },
    { 0x34838A7A, "damage_heavy" },
    { 0xD631BEB9, "damage_hints" },
    { 0xE973E7A8, "damage_hints_cleanup" },
    { 0x92E396B3, "damage_immunity" },
    { 0x4F2A4CDB, "damage_interval_secs" },
    { 0x07CBECB9, "damage_level" },
    { 0x90537327, "damage_light" },
    { 0xDDCE5FBB, "damage_line" },
    { 0xE63DBF6D, "damage_loc" },
    { 0x7694B28C, "damage_location" },
    { 0x249C4C2D, "damage_melee_regen" },
    { 0x01855120, "damage_mirror" },
    { 0x55E1E323, "damage_mod" },
    { 0x69E6EAD0, "damage_model" },
    { 0x8DF15356, "damage_modifier" },
    { 0x35DA58AF, "damage_mult" },
    { 0x8430DB33, "damage_multipliers" },
    { 0xAE7C8D60, "damage_my_parts" },
    { 0xB98282A8, "damage_name" },
    { 0xC5C8474C, "damage_notdone" },
    { 0x9BD55E76, "damage_notify_wrapper" },
    { 0x2DBD6135, "damage_on_death" },
    { 0x5A36459D, "damage_on_fire" },
    { 0x57C65E7B, "damage_on_impact" },
    { 0x4A5F9AE3, "damage_one" },
    { 0x287755F3, "damage_ori" },
    { 0xAC082291, "damage_over_time" },
    { 0xB8D20441, "damage_override" },
    { 0xCD3C6DD5, "damage_own_team" },
    { 0x6605A374, "damage_penetration" },
    { 0xD5AF0AD4, "damage_per_frame" },
    { 0xA6C8CE20, "damage_percent" },
    { 0x5DF0890B, "damage_percent_dealt" },
    { 0x1999C3A1, "damage_percentage" },
    { 0x44222806, "damage_player" },
    { 0x770EEA17, "damage_player_vehicle" },
    { 0x422E4B22, "damage_prone_players" },
    { 0x979F7016, "damage_prone_players_override_func" },
    { 0x85ACD973, "damage_radius" },
    { 0xB954B858, "damage_range" },
    { 0x9CCC8642, "damage_ref_offset" },
    { 0xAA1277A6, "damage_ref_points" },
    { 0xC5CAC891, "damage_scale" },
    { 0x4C6078F0, "damage_scale_length" },
    { 0xFC8CE4CB, "damage_scoring_function" },
    { 0xC8073BEE, "damage_side_windows" },
    { 0xBAA92BF2, "damage_source" },
    { 0xE03B7081, "damage_spot" },
    { 0x44EE9F0C, "damage_state" },
    { 0xD61DCDFD, "damage_state1" },
    { 0xFC204866, "damage_state2" },
    { 0x2222C2CF, "damage_state3" },
    { 0x181169F0, "damage_state4" },
    { 0xEB44B630, "damage_state_1" },
    { 0x5D4C256B, "damage_state_2" },
    { 0x33AAF06D, "damage_state_changed" },
    { 0xC10B8719, "damage_state_check" },
    { 0x3E2BFBF5, "damage_state_fx_handles" },
    { 0xB761A495, "damage_state_index" },
    { 0x38CFB2F8, "damage_state_threshold_pct_1" },
    { 0xAAD72233, "damage_state_threshold_pct_2" },
    { 0x84D4A7CA, "damage_state_threshold_pct_3" },
    { 0xF6DC1705, "damage_state_threshold_pct_4" },
    { 0x91C684F1, "damage_sticktraps" },
    { 0x540B409E, "damage_str" },
    { 0xDDB7CC22, "damage_string" },
    { 0xC61856FE, "damage_taken" },
    { 0xBF0AA3EE, "damage_taken_normalized" },
    { 0x77DAD778, "damage_then_crash" },
    { 0x14120D5A, "damage_threshold" },
    { 0x2B5DCDB1, "damage_to_destroy" },
    { 0xE9090A59, "damage_to_pby_dialogue" },
    { 0x5120A30E, "damage_to_retreat" },
    { 0xDD2F609C, "damage_to_smoke" },
    { 0x6266A869, "damage_total" },
    { 0x01F04A08, "damage_trace" },
    { 0xC580961B, "damage_trace_passed" },
    { 0x34D4FFDF, "damage_tracker" },
    { 0x3CCCE727, "damage_transfered_to_player" },
    { 0x8893DECB, "damage_trig" },
    { 0xB9F32367, "damage_trigger" },
    { 0x0FF97018, "damage_trigger_monitor" },
    { 0x6EF6AD5F, "damage_trigger_name" },
    { 0x4AB85116, "damage_trigger_shoot_or_collide" },
    { 0x592E1F46, "damage_trigger_thread" },
    { 0x264C41DE, "damage_triggers" },
    { 0x6B10153C, "damage_triggers_turn_on" },
    { 0xD1406541, "damage_two" },
    { 0x623AAB11, "damage_type" },
    { 0xE12C35F8, "damage_types" },
    { 0x3B684CC2, "damage_vehicles" },
    { 0xE28E014E, "damage_visionset_think" },
    { 0x3EA515B7, "damage_void" },
    { 0xB2CAAE99, "damage_weapon" },
    { 0x03BEF794, "damage_weapon_class" },
    { 0x15958249, "damage_when_piece_breaks" },
    { 0xE07DAC96, "damageable" },
    { 0xE4E676F9, "damageafterhacking" },
    { 0x2FDD7F77, "damagealwayskillsplayer" },
    { 0xE7D89A06, "damageamount" },
    { 0xEB368735, "damageapplied" },
    { 0xC2E53561, "damagearea" },
    { 0xFAEA4F57, "damageattacker" },
    { 0x1584F753, "damagecallback" },
    { 0x8A105929, "damagecenter" },
    { 0x007D8E8A, "damageconetrace" },
    { 0x4EC6A32A, "damaged" },
    { 0xF28DAEF7, "damaged1" },
    { 0x80863FBC, "damaged2" },
    { 0xECDB09A6, "damaged_by_player" },
    { 0x4C1AD4C5, "damaged_by_subwoofer" },
    { 0x82F6CE3D, "damaged_done" },
    { 0xB8221252, "damaged_effect" },
    { 0xD47A0FFA, "damaged_part" },
    { 0xA4A9E9A9, "damaged_walking_audio" },
    { 0xDC8E5A65, "damagedby" },
    { 0x2E1C5666, "damagedbychargedsnipershot" },
    { 0x8F9A0752, "damagedbyspecial" },
    { 0xF19CAAC0, "damagedealt" },
    { 0x19D74FCF, "damagedir" },
    { 0xB3146E99, "damagedirection" },
    { 0x6D247AF1, "damagedlegs" },
    { 0x2657DCF2, "damagedone" },
    { 0x1F79F594, "damagedparts" },
    { 0x13FED2E4, "damagedplayers" },
    { 0x75D08E68, "damagedrearrotor" },
    { 0x0F5F7428, "damagedrotorfx" },
    { 0x681C8E25, "damagedtodeath" },
    { 0x74C91D93, "damagee" },
    { 0x7C624C9A, "damageeffectarea" },
    { 0x9AF9F671, "damageent" },
    { 0x60E572F7, "damageexplosive" },
    { 0xBE0BB31B, "damagefactor" },
    { 0xFC79DB9F, "damagefeedback" },
    { 0xFAF42039, "damagefeedback_shared" },
    { 0xE021B18C, "damagefraction" },
    { 0xAD8AFADC, "damagefromunderneath" },
    { 0x1EA9FAB0, "damagefx" },
    { 0x87E2DA06, "damagehit_origin" },
    { 0x77BD398C, "damageinfirearea" },
    { 0x4E833BC8, "damageinflictor" },
    { 0xE84FF79A, "damageinfo" },
    { 0x84DEED75, "damageinfocolorindex" },
    { 0x00B902D2, "damageinfovictim" },
    { 0x7AE91D1C, "damageinpoisonarea" },
    { 0x5E5F8B5E, "damageleg" },
    { 0xE542D7D4, "damagelevel" },
    { 0x7AACA1E8, "damagelevelchanged" },
    { 0x28528618, "damageloc" },
    { 0x787CBB8F, "damagelocation" },
    { 0x1FC0F3B7, "damagelocationisany" },
    { 0x25A1B4E0, "damagemax" },
    { 0xD2CA461E, "damagemin" },
    { 0x4E3DE306, "damagemod" },
    { 0xAFC8139F, "damagemode" },
    { 0x2EB17FD1, "damagemodel" },
    { 0x3CB9CC19, "damagemodifier" },
    { 0x21BD2FB3, "damagemultiplier" },
    { 0x40FBF63A, "damageopen" },
    { 0x8B51D298, "damageorigin" },
    { 0xE1E7A41A, "damageoverride" },
    { 0xF3CC8115, "damageoverrides" },
    { 0xAB191ED3, "damageowner" },
    { 0x98D30960, "damageperinterval" },
    { 0xA1827E17, "damageperrocket" },
    { 0x77E922E5, "damageplayer" },
    { 0x6F0E1976, "damageplayerinradius" },
    { 0x577172F4, "damageplayers" },
    { 0x8A1FA4D0, "damagepoint" },
    { 0x0260B9EC, "damagepos" },
    { 0xBFC1235B, "damageposition" },
    { 0xA24C0EFD, "damagepropanetank" },
    { 0x3AA3F16C, "damager" },
    { 0x2BE10038, "damager_trigger_thread" },
    { 0x06D32904, "damageradius" },
    { 0xAADCE8BF, "damageratio" },
    { 0x789A6C4F, "damagerecieved" },
    { 0x9555568F, "damageriotshield" },
    { 0x60A66BD5, "damages" },
    { 0x58B017F2, "damagescalar" },
    { 0x3C70A91E, "damageshellshockandrumble" },
    { 0x7A1093C9, "damageshield" },
    { 0x7AD6BF18, "damagestage" },
    { 0xF892CEB9, "damagestate" },
    { 0x9F9CB1CD, "damagestate_lv1_fx1" },
    { 0xC59F2C36, "damagestate_lv1_fx2" },
    { 0xEBA1A69F, "damagestate_lv1_fx3" },
    { 0xE1904DC0, "damagestate_lv1_fx4" },
    { 0x6CF1061D, "damagestate_lv1_numslots" },
    { 0x5CAFE07B, "damagestate_lv1_ratio" },
    { 0x43A29833, "damagestate_lv1_sound" },
    { 0x93D32ABB, "damagestate_lv1_tag1" },
    { 0x21CBBB80, "damagestate_lv1_tag2" },
    { 0x47CE35E9, "damagestate_lv1_tag3" },
    { 0x05DA99F6, "damagestate_lv1_tag4" },
    { 0x37F8F512, "damagestate_lv2_fx1" },
    { 0x11F67AA9, "damagestate_lv2_fx2" },
    { 0xEBF40040, "damagestate_lv2_fx3" },
    { 0xF605591F, "damagestate_lv2_fx4" },
    { 0x0265690C, "damagestate_lv2_numslots" },
    { 0x963A0A8C, "damagestate_lv2_ratio" },
    { 0xBF442CBC, "damagestate_lv2_sound" },
    { 0x1B9C04B2, "damagestate_lv2_tag1" },
    { 0xF5998A49, "damagestate_lv2_tag2" },
    { 0xCF970FE0, "damagestate_lv2_tag3" },
    { 0xD9A868BF, "damagestate_lv2_tag4" },
    { 0xB4F5F3EB, "damagestate_lv3_fx1" },
    { 0x42EE84B0, "damagestate_lv3_fx2" },
    { 0x68F0FF19, "damagestate_lv3_fx3" },
    { 0x26FD6326, "damagestate_lv3_fx4" },
    { 0xE6CFFF7B, "damagestate_lv3_numslots" },
    { 0xB45D1055, "damagestate_lv3_ratio" },
    { 0xE81B1999, "damagestate_lv3_sound" },
    { 0xF399F0CD, "damagestate_lv3_tag1" },
    { 0x199C6B36, "damagestate_lv3_tag2" },
    { 0x3F9EE59F, "damagestate_lv3_tag3" },
    { 0x358D8CC0, "damagestate_lv3_tag4" },
    { 0xB95BF2B8, "damagestate_lv4_fx1" },
    { 0x2B6361F3, "damagestate_lv4_fx2" },
    { 0x0560E78A, "damagestate_lv4_fx3" },
    { 0x776856C5, "damagestate_lv4_fx4" },
    { 0x3AC09DBA, "damagestate_lv4_numslots" },
    { 0xCF65E03E, "damagestate_lv4_ratio" },
    { 0x376B7F22, "damagestate_lv4_sound" },
    { 0x7DF721F4, "damagestate_lv4_tag1" },
    { 0xEFFE912F, "damagestate_lv4_tag2" },
    { 0xC9FC16C6, "damagestate_lv4_tag3" },
    { 0x0BEFB2B9, "damagestate_lv4_tag4" },
    { 0xE79F0EC1, "damagestate_lv5_fx1" },
    { 0x0DA1892A, "damagestate_lv5_fx2" },
    { 0x33A40393, "damagestate_lv5_fx3" },
    { 0x59A67DFC, "damagestate_lv5_fx4" },
    { 0x9797B361, "damagestate_lv5_numslots" },
    { 0xAACF6F07, "damagestate_lv5_ratio" },
    { 0x34384CAF, "damagestate_lv5_sound" },
    { 0x55D2A85F, "damagestate_lv5_tag1" },
    { 0xE3CB3924, "damagestate_lv5_tag2" },
    { 0x09CDB38D, "damagestate_lv5_tag3" },
    { 0x97C64452, "damagestate_lv5_tag4" },
    { 0x0999A6A6, "damagestate_lv6_fx1" },
    { 0xE3972C3D, "damagestate_lv6_fx2" },
    { 0xBD94B1D4, "damagestate_lv6_fx3" },
    { 0x9792376B, "damagestate_lv6_fx4" },
    { 0xEE464570, "damagestate_lv6_numslots" },
    { 0xF17EAAF8, "damagestate_lv6_ratio" },
    { 0xE385E548, "damagestate_lv6_sound" },
    { 0x1F11A036, "damagestate_lv6_tag1" },
    { 0xF90F25CD, "damagestate_lv6_tag2" },
    { 0xD30CAB64, "damagestate_lv6_tag3" },
    { 0xAD0A30FB, "damagestate_lv6_tag4" },
    { 0x435CD95A, "damagestate_numstates" },
    { 0x966E9C00, "damagestatevalue" },
    { 0x72E72733, "damagetaken" },
    { 0xB9D6F2DE, "damagetakenbefore" },
    { 0xD8C3E28B, "damagetakentype" },
    { 0x141A3A3D, "damagetarget" },
    { 0x6DF5DAAA, "damagetargetlights" },
    { 0xFFB68ADE, "damagethendestroyriotshield" },
    { 0x7D2BCD50, "damagetrig" },
    { 0x90267952, "damagetrigger" },
    { 0x35B8669A, "damagetype" },
    { 0x398FA429, "damagewait" },
    { 0xF8A87229, "damagewanderfwddot" },
    { 0xAE2C2F19, "damagewandermax" },
    { 0x08D20DA7, "damagewandermin" },
    { 0x37C4A030, "damagewanderspacing" },
    { 0x7BF3C52A, "damageweapon" },
    { 0x6B2A89B8, "damageweapon_name" },
    { 0xD91A0F93, "damageyaw" },
    { 0xBAA9A0CA, "damageyawforward" },
    { 0xE9A78AEB, "damaging" },
    { 0x7CCAF286, "damege" },
    { 0xDADEFD4D, "damge" },
    { 0x980253C9, "dammit" },
    { 0x3D4DE511, "damn" },
    { 0x6BDB6F1E, "damn_helicopters" },
    { 0x8E0DDC1D, "damn_helicopters_followup" },
    { 0xCB38C0BE, "damned" },
    { 0x8A57FB42, "damnit" },
    { 0x7953C601, "damoun" },
    { 0x3463302E, "dampen" },
    { 0xDCBC8552, "dampening" },
    { 0xAE60156E, "dan" },
    { 0x573146CE, "dance" },
    { 0x7475E51F, "dance_action" },
    { 0xD132EC72, "dance_anim" },
    { 0x14AFA955, "dance_attack" },
    { 0x683CF978, "dance_condition" },
    { 0x84955884, "dance_end" },
    { 0xA916AD6D, "dance_on_my_grave" },
    { 0x22BE8023, "dancers" },
    { 0x09D4E4E7, "dancing" },
    { 0x68CB4414, "danger" },
    { 0xCBED2C6F, "danger_anims" },
    { 0x6C8DF6F5, "danger_close" },
    { 0xF9F74EE8, "danger_close_confirm" },
    { 0x39431883, "danger_close_confirms" },
    { 0x6D100ACB, "danger_ender" },
    { 0x37717F56, "danger_influencer_id" },
    { 0x72FAAD2F, "dangercenter" },
    { 0x6E9D3BB3, "dangerclosesafedist" },
    { 0xB4E5A674, "dangerdist" },
    { 0xD90C8AB2, "dangerorigin" },
    { 0x28F9FD1F, "dangerous" },
    { 0x3CBFA25C, "dangerous_damage_frac" },
    { 0xDA80DC51, "dangerous_nodes" },
    { 0x5D8E7EA6, "dangerradius" },
    { 0x9089940B, "dangersprinttime" },
    { 0x374EFEAB, "dangerstarttime" },
    { 0x3175DF9E, "dangerzone" },
    { 0x653FA87D, "dangling" },
    { 0x9825B9E6, "danl" },
    { 0xC24B266D, "danny" },
    { 0x3DE18F14, "danode" },
    { 0xD0E1EC87, "danodes" },
    { 0xBB2E0F05, "dared" },
    { 0x37FF4F7E, "daring" },
    { 0x59056035, "dark" },
    { 0xE6901F4D, "dark_playerkill_wait" },
    { 0x189080D8, "darken" },
    { 0xAC7CE4C0, "darkening" },
    { 0x205EF0A4, "darker" },
    { 0x1FDAA823, "darkest" },
    { 0xC9908DBF, "darkline" },
    { 0x540891C6, "darklines" },
    { 0x9DD1CF58, "darkness" },
    { 0x4BD6614F, "darkness_ai_player_nearby" },
    { 0xA818A4D7, "darkness_ai_setup" },
    { 0x24833524, "darkness_ai_spawnerthread" },
    { 0x15104288, "darkness_ai_think" },
    { 0x173E1A67, "darkness_allied_bullet_shield" },
    { 0x5C50ABC4, "darkness_battlechatter" },
    { 0xD9192F64, "darkness_coop_unignore" },
    { 0xD7EAB870, "darkness_goal_management" },
    { 0x8E4D8298, "darkness_proxcheck" },
    { 0x2E6B3972, "darkness_randomfire" },
    { 0x94347FE0, "darkness_reset_target" },
    { 0x7D4293C9, "darkness_stop_wait" },
    { 0x83ABFC13, "darkness_target_reset_because_lights" },
    { 0xDF2C727D, "darkness_target_reset_because_targetdead" },
    { 0x1B70A251, "darkness_think" },
    { 0xF8158E60, "darkroom" },
    { 0xBF1AC33B, "darkscreenoverlay" },
    { 0xC1964872, "darktime" },
    { 0xDA615B88, "darktimemax" },
    { 0x35073A16, "darktimemin" },
    { 0xCEEC4B9A, "darpredictedcollision" },
    { 0x1711C442, "dart" },
    { 0x4C2BA673, "dart_board" },
    { 0x7611177D, "dart_duration" },
    { 0x85FAE13A, "dart_entered" },
    { 0x09449414, "dart_explosion_cam_distance" },
    { 0x479E8149, "dart_explosion_damage_max" },
    { 0x6293ACF7, "dart_explosion_damage_min" },
    { 0xEADACB0F, "dart_game_give_award" },
    { 0x4B7B8078, "dart_game_init" },
    { 0xA4E298DB, "dart_game_is_award_valid" },
    { 0x31F8E3B4, "dart_game_is_valid_weapon" },
    { 0xF80CB3E5, "dart_game_piece_think" },
    { 0x1DF3079E, "dart_hacked_health_update" },
    { 0x76B6403B, "dart_hacker_tool_duration" },
    { 0x362D4B85, "dart_hacker_tool_radius" },
    { 0xFB41ED4F, "dart_hide_compass_on_remote_control" },
    { 0xB2384079, "dart_killstreak_id" },
    { 0x553A2827, "dart_killstreak_name" },
    { 0xBF190FEA, "dart_killstreak_weapon" },
    { 0x9A166796, "dart_left" },
    { 0xAA894F81, "dart_max_height_offset" },
    { 0x6BD580F8, "dart_max_shot_count" },
    { 0x445C8F90, "dart_name" },
    { 0xFE2CC75C, "dart_original_team" },
    { 0x6BFD14D6, "dart_putaway" },
    { 0x00F526F3, "dart_round" },
    { 0x2C25D5E0, "dart_round_score" },
    { 0xFBED7153, "dart_stat_name" },
    { 0x0B048975, "dart_throw_failed" },
    { 0xD409A6BA, "dart_throw_timed_out" },
    { 0x0B073BC9, "dart_thrown_time" },
    { 0x84A6C65B, "dart_vehicle_name" },
    { 0x237C107E, "dart_visionset_alias" },
    { 0xF92871C8, "dart_visionset_file" },
    { 0x13E09B1A, "dart_watch_time" },
    { 0xA05FA4D1, "dartbda" },
    { 0x220F4322, "dartbundle" },
    { 0x8C6152E1, "dartdamageoverride" },
    { 0x48EAAC7B, "dartdistancefailure" },
    { 0xCBDFEB8D, "darts" },
    { 0xC020FA50, "darwin" },
    { 0x5DC6E759, "dash" },
    { 0x517C7756, "dash_ai" },
    { 0xB4C367BE, "dash_counter_round_reached_10" },
    { 0xAFB07D3E, "dash_counter_round_reached_5" },
    { 0xE656ACD7, "dash_counter_start_player_count" },
    { 0x1E36E9F5, "dash_crawl" },
    { 0x78932DEA, "dash_crawl_patrol" },
    { 0x831789E3, "dash_delay_save" },
    { 0xC3DEB1F6, "dash_dialogue" },
    { 0x29479D09, "dash_door_fast" },
    { 0xE4674EA8, "dash_door_l_open" },
    { 0xA75EDBAC, "dash_door_slow" },
    { 0xD7BA7925, "dash_door_super_fast" },
    { 0xDB22D1D6, "dash_fake_easy_mode" },
    { 0x5B735933, "dash_handle_doors_blowopen" },
    { 0x47AA7C45, "dash_handle_heli" },
    { 0xE054FD28, "dash_handle_nosight_clip" },
    { 0xDCEDC0F2, "dash_handle_price_stop_bullet_shield" },
    { 0x9EE5E78B, "dash_handle_stealth_unsure" },
    { 0x7F0A0F42, "dash_heli_agro" },
    { 0x8D421AA7, "dash_heli_liftoff" },
    { 0x7B362207, "dash_hind" },
    { 0x196C7ACF, "dash_hind_attack_enemy" },
    { 0xEE1F432D, "dash_hind_death_dialogue" },
    { 0x04D4866D, "dash_hind_deleted" },
    { 0xEDD0C995, "dash_hind_detect_damage" },
    { 0x35915AEC, "dash_hind_distance_logic" },
    { 0xF23520C4, "dash_holdup" },
    { 0x2A8B7E8C, "dash_idler" },
    { 0xB76CEA9E, "dash_intro_common" },
    { 0x78EB8F9B, "dash_intro_patrol" },
    { 0x32832AF3, "dash_intro_runner" },
    { 0xF743EAA9, "dash_kill_nosave" },
    { 0xCEA6B37C, "dash_last" },
    { 0x03732403, "dash_main" },
    { 0x28E7BBF9, "dash_reset_stealth_to_default" },
    { 0x64811163, "dash_run" },
    { 0x9CDF4AEE, "dash_run_check" },
    { 0xF257404D, "dash_sniper" },
    { 0x37C4D45A, "dash_sniper_alert" },
    { 0x384B007F, "dash_sniper_anim" },
    { 0xDDBBD714, "dash_sniper_attack" },
    { 0x002E0C6A, "dash_sniper_dead" },
    { 0x53109B86, "dash_sniper_death" },
    { 0x51FFF75F, "dash_sniper_player_weapon_check" },
    { 0x1C65EF11, "dash_spawn" },
    { 0x2518E899, "dash_stander" },
    { 0xA5FF7A88, "dash_start" },
    { 0x9AD75F9E, "dash_state_hidden" },
    { 0x0BB0CAD9, "dash_state_spotted" },
    { 0xCDCDED1B, "dashboard" },
    { 0xC2D42D86, "dashed" },
    { 0xA4A022E9, "dashes" },
    { 0x72254E15, "data" },
    { 0x6260E0B1, "data_1" },
    { 0x88635B1A, "data_2" },
    { 0xAE65D583, "data_3" },
    { 0x913A42E6, "data_audio" },
    { 0xBD69C7B8, "data_done" },
    { 0x5703DB1F, "data_fade_think" },
    { 0x48287C60, "data_glove_animation" },
    { 0xF7CC3AEA, "data_glove_bink_off" },
    { 0xB2F977BC, "data_glove_bink_on" },
    { 0x80CFC60C, "data_glove_claw_interact" },
    { 0x5844E02A, "data_glove_claw_screen" },
    { 0x0CAE3DCF, "data_glove_glow_off" },
    { 0x1FF0E262, "data_glove_input" },
    { 0xE61BDE29, "data_glove_input_button" },
    { 0x8AC6C8BD, "data_glove_off" },
    { 0x95EDC0F1, "data_glove_on" },
    { 0x4F57FBA1, "data_glove_on_with_light" },
    { 0x1F86AE9F, "data_glove_texture" },
    { 0x67889F1B, "data_lcn" },
    { 0x15E531BB, "data_stream_rotate_think" },
    { 0xDDBFD9E3, "data_struct" },
    { 0x7AED096E, "database" },
    { 0x0B3F5E95, "datalog_locs" },
    { 0xCD9EA424, "datalogs" },
    { 0x6FC7CA24, "datalogs_delay" },
    { 0x7541F39C, "dataname" },
    { 0x9E83F6EE, "datapad_model" },
    { 0x11288A9C, "datapad_rumble" },
    { 0xD6A57ECC, "dataparam" },
    { 0x92F8D5CB, "datatable" },
    { 0x6DF4C82A, "datatables" },
    { 0xDA1B6471, "date" },
    { 0x86BC7BC7, "date_string" },
    { 0x75F139A4, "date_to_day" },
    { 0xFAB7330D, "david" },
    { 0x60181E49, "dawdling" },
    { 0x902C0AD1, "day" },
    { 0x0C0B4554, "day_num" },
    { 0x3919A333, "day_off" },
    { 0x556EB5DE, "day_to_date" },
    { 0x2225817A, "daybreak" },
    { 0xC6D8945F, "daybreak_watcher" },
    { 0x0EC9500F, "daylight" },
    { 0x840D0712, "daylight_blue" },
    { 0x4E29F66B, "daylight_green" },
    { 0x6B5442CF, "daylight_red" },
    { 0xF56325B8, "days" },
    { 0x7C296EB2, "days_in_year" },
    { 0x84948F69, "days_remaining" },
    { 0xA77ACF7F, "days_remaining_string" },
    { 0xBD2EA1CD, "dazed" },
    { 0x81EAA787, "dazed_array" },
    { 0x72EDBD2B, "db" },
    { 0x37B7BE61, "db0" },
    { 0x83BCB333, "db2" },
    { 0x474830B9, "db_target" },
    { 0x0DBAC29C, "dbg_plane_taking_damage" },
    { 0x4BDF2B8E, "dbg_text_plane_dmg" },
    { 0x4EC85077, "dbg_training_planes" },
    { 0x04BF39E4, "dbid" },
    { 0x059ACDFE, "dbl_mast01" },
    { 0xDF985395, "dbl_mast02" },
    { 0x5B904757, "dbl_mast_platform" },
    { 0x410B3A4A, "dbl_mast_start" },
    { 0x38D45929, "dbline" },
    { 0x770EA233, "dbruington" },
    { 0x4CEB42C2, "dc" },
    { 0xB7E323B6, "dc0" },
    { 0x3716064E, "dc_icon" },
    { 0x3A312920, "dclamp" },
    { 0x6CFEF460, "dconst" },
    { 0x11420F0D, "dcs" },
    { 0x83E788FF, "dcsound" },
    { 0xF991E4E5, "ddbomb" },
    { 0x5DB7384C, "ddbombmodel" },
    { 0xC8501769, "ddeathflag" },
    { 0x69AFB5D8, "ddef" },
    { 0x8D3FC17B, "ddl" },
    { 0xC9A25510, "ddl_increment_amount" },
    { 0x673D4712, "ddm" },
    { 0xAA8C5858, "ddm_machine" },
    { 0x0A71BFAB, "ddm_machine_anims" },
    { 0xE4CEDB33, "ddm_machines" },
    { 0xF1776881, "ddm_start_harpers_shield" },
    { 0xF56FC360, "ddm_start_players_shield" },
    { 0x437DB5BC, "dds" },
    { 0x2ECC635A, "dds_ai_init" },
    { 0x14831BF7, "dds_category" },
    { 0xAA963F8B, "dds_characterid" },
    { 0x089F6246, "dds_clear_all_queued_events" },
    { 0xC5D32856, "dds_clear_all_queued_events_axis" },
    { 0xFBC99D0E, "dds_clear_event_override" },
    { 0x746DC90A, "dds_clear_old_expired_events" },
    { 0x6A65D50A, "dds_clear_old_expired_events_axis" },
    { 0xB39A7434, "dds_debug" },
    { 0xB3E5DFA9, "dds_debug_player_health" },
    { 0x70B1B6DD, "dds_disable" },
    { 0xB85025C5, "dds_dmg_attacker" },
    { 0x232A0CAE, "dds_enable" },
    { 0xE6DF7507, "dds_event_activate" },
    { 0x9A11539F, "dds_exclude_this_ai" },
    { 0xA06B69C1, "dds_find_infantry_threat" },
    { 0x8534BAF8, "dds_find_threats" },
    { 0xDC706259, "dds_friendly_fire" },
    { 0xB2216D2E, "dds_get_ai_id" },
    { 0xDF301766, "dds_get_alias_from_event" },
    { 0xDDD15401, "dds_getclock_position" },
    { 0x10F7383D, "dds_init" },
    { 0x8BD95D0F, "dds_killstreak_timer" },
    { 0xB0ED813B, "dds_label" },
    { 0x57C8317A, "dds_main_process" },
    { 0xE46B4EBA, "dds_main_process_axis" },
    { 0x6091359B, "dds_multikill_tracker" },
    { 0x2C48D2A8, "dds_notify" },
    { 0x2B21A3F1, "dds_notify_casualty" },
    { 0x1FE53367, "dds_notify_grenade" },
    { 0x0D770259, "dds_notify_mod" },
    { 0xCC80C404, "dds_notify_reload" },
    { 0x9DB5801A, "dds_notify_response" },
    { 0x345854C9, "dds_process_active_events" },
    { 0x65A34BCF, "dds_process_active_events_axis" },
    { 0x80DA87C0, "dds_reset_event_override_probability" },
    { 0x227EF23F, "dds_running_" },
    { 0xF79A26ED, "dds_running_allies" },
    { 0x8E3BA252, "dds_send_team_notify_on_disable" },
    { 0x6509F35F, "dds_set_event_override" },
    { 0x90CA8DD3, "dds_set_event_override_probability" },
    { 0x522663F3, "dds_set_player_character_name" },
    { 0xAEF547CF, "dds_sort_ent_damage" },
    { 0xE27370BC, "dds_sort_ent_dist" },
    { 0xF5CB8E64, "dds_sort_ent_duration" },
    { 0x5AA44481, "dds_threat_notify" },
    { 0xD7039F2B, "dds_try_suppressed" },
    { 0xD76366EF, "dds_variant_count_for_alias" },
    { 0xF12484EA, "dds_watch_ammo_low" },
    { 0xD0140771, "dds_watch_friendly_fire" },
    { 0xDD703F02, "dds_watch_grenade_flee" },
    { 0x8B84AF59, "dds_watch_player_health" },
    { 0x1CC767B2, "dds_woo_rspns_lm_00" },
    { 0x98F03794, "de" },
    { 0xA5218027, "deactivate" },
    { 0x86CDD551, "deactivate_all_in_array" },
    { 0xEBD6BA6A, "deactivate_barrier_goals" },
    { 0x64B23936, "deactivate_building_zones" },
    { 0x50D85B13, "deactivate_chugabud_effects_and_audio" },
    { 0x6551A380, "deactivate_consequences" },
    { 0x83139D73, "deactivate_detectors" },
    { 0x86E87041, "deactivate_exploder" },
    { 0xBF059D2A, "deactivate_f35_room" },
    { 0x5E5DD8FB, "deactivate_fake_friendly_dds" },
    { 0x88002889, "deactivate_friendly_dds" },
    { 0xAB4F7902, "deactivate_heli_guy" },
    { 0x652D8E2F, "deactivate_heli_guy_trigger" },
    { 0xA8C830BE, "deactivate_index" },
    { 0xB957281F, "deactivate_initial_barrier_goals" },
    { 0x1087E792, "deactivate_packapunch" },
    { 0xC83E92E5, "deactivate_per_player" },
    { 0xDD94CAEF, "deactivate_player_health_visionset" },
    { 0x8C08A5B4, "deactivate_security_system" },
    { 0xA69E9964, "deactivate_spawned" },
    { 0xD148F09D, "deactivate_weapon_toggle" },
    { 0x7661B8FE, "deactivate_zombie_point_of_interest" },
    { 0x73786D78, "deactivate_zone" },
    { 0x82D09793, "deactivateambientpackage" },
    { 0x832C835C, "deactivateambientroom" },
    { 0x55DB2421, "deactivateclientexploder" },
    { 0x836DD938, "deactivateclientradiantexploder" },
    { 0xC3A0BB21, "deactivated" },
    { 0x1D5C1B41, "deactivateeq" },
    { 0xD0BBB73D, "deactivateflashbackwarpaftertime" },
    { 0x34098487, "deactivatereverb" },
    { 0x2185789E, "deactivates" },
    { 0x661EDD62, "deactivating" },
    { 0x1558616C, "deactivation" },
    { 0xE8058D63, "deactivation_effects" },
    { 0x193C0C5B, "dead" },
    { 0x782D8AF6, "dead_88" },
    { 0x66D11C2C, "dead_arrows" },
    { 0xC72BD886, "dead_arty" },
    { 0xD7770CF5, "dead_axis" },
    { 0xA1791F4D, "dead_blowup" },
    { 0x5A3488FA, "dead_bodies" },
    { 0x88CCBB42, "dead_body" },
    { 0x53F1B48E, "dead_body_count" },
    { 0x1D9CD7F4, "dead_body_locs" },
    { 0x2BE47D0B, "dead_body_pool" },
    { 0x42AC2C9B, "dead_body_tarp01" },
    { 0xD0A4BD60, "dead_body_tarp02" },
    { 0x6EBAC868, "dead_civ" },
    { 0xAF26148E, "dead_civ_model" },
    { 0x189CF9F1, "dead_civilian" },
    { 0x88FB5D03, "dead_civs" },
    { 0xF9212A46, "dead_d" },
    { 0x844072ED, "dead_damage" },
    { 0xC265FD9C, "dead_drone" },
    { 0x9FB0D2FA, "dead_enemy" },
    { 0xC638BC59, "dead_enemy_pos" },
    { 0x3D33E444, "dead_friend_influencer_count" },
    { 0x76472451, "dead_friend_influencer_radius" },
    { 0xCC62E107, "dead_friend_influencer_score" },
    { 0xD51EEF6B, "dead_friend_influencer_score_curve" },
    { 0x16973296, "dead_friend_influencer_timeout_seconds" },
    { 0xD1F9BF0F, "dead_guy" },
    { 0x444CA38B, "dead_guy_threshold" },
    { 0x1ADD7918, "dead_heli_pilots" },
    { 0x775A90EA, "dead_hip_times" },
    { 0xCE490D74, "dead_horse_cleanup" },
    { 0x44D1D4DD, "dead_huey" },
    { 0x7A3851FA, "dead_mg" },
    { 0xF13C7C9B, "dead_on_arrival" },
    { 0x1F647119, "dead_param" },
    { 0x33287BB1, "dead_player" },
    { 0xA4F5D0B7, "dead_player_team" },
    { 0xCEB13B84, "dead_poses" },
    { 0xBB3B1AF8, "dead_stat" },
    { 0xE6805641, "dead_tanks" },
    { 0x34AB38EA, "dead_teammate" },
    { 0xABAF0409, "dead_wave" },
    { 0x2B9272E4, "dead_zone" },
    { 0x7C56C5FF, "deadbodies" },
    { 0x5B688FCB, "deadbody" },
    { 0xF80FDB26, "deadbody_tarp_fast" },
    { 0xDCF755A3, "deadbody_tarp_slow" },
    { 0x2BB7D85B, "deadchatwithdead" },
    { 0x510FEC6A, "deadchatwithteam" },
    { 0xE2F81B20, "deadcount" },
    { 0x2ABE41A1, "deaddriver" },
    { 0xD2DAD6C6, "deadening" },
    { 0xACE40EA2, "deadeye" },
    { 0x624F7337, "deadfallbackers" },
    { 0x5EDCBE07, "deadhearallliving" },
    { 0xCF617CD2, "deadhearkiller" },
    { 0xE511471F, "deadhearteamliving" },
    { 0x5E09FC5F, "deadlier" },
    { 0xBB455999, "deadline" },
    { 0xF7838446, "deadly" },
    { 0x0B085488, "deadly_mgs" },
    { 0x56D6A1AF, "deadpilot" },
    { 0x5FE8FE73, "deadplayer_stop" },
    { 0x27015FAF, "deadplayers" },
    { 0xA04D4C39, "deadquote" },
    { 0x6CD9D574, "deadquote_override" },
    { 0xC1BD1C70, "deadquotes" },
    { 0xF3CC9089, "deadrecontargetorigin" },
    { 0x6AD8589B, "deadshot" },
    { 0x74FB388B, "deadshot_client_field_func" },
    { 0x0FFFBD7E, "deadshot_code_callback_func" },
    { 0x460E9B50, "deadshot_machine_active_model" },
    { 0x888214F2, "deadshot_machine_disabled_model" },
    { 0x9B826A61, "deadshot_machine_light_fx" },
    { 0x6906AFBD, "deadshot_off" },
    { 0xE3FA9DF1, "deadshot_on" },
    { 0xB8C2130C, "deadshot_perk_bottle_weapon" },
    { 0xA4661D0E, "deadshot_perk_cost" },
    { 0x5618AF8A, "deadshot_perk_machine_setup" },
    { 0xB8D4AB7D, "deadshot_precache" },
    { 0x72A62E0D, "deadshot_precache_override_func" },
    { 0x6AB5C741, "deadshot_radiant_machine_name" },
    { 0xB2E4B43F, "deadshot_register_clientfield" },
    { 0x8BD0926C, "deadshot_set_clientfield" },
    { 0x48DC5341, "deadshot_shader" },
    { 0x99A1FCCB, "deadstop" },
    { 0xF57B8D22, "deadt72" },
    { 0x54660B49, "deadzone" },
    { 0x30196914, "deadzoneheight" },
    { 0xFAD4571F, "deadzonewidth" },
    { 0x1E5EFA02, "deafaults" },
    { 0x2956917E, "deafult" },
    { 0x494FDFA3, "deal" },
    { 0x0FD8EBA7, "deal_damage_when_shot" },
    { 0x12E92DC5, "deal_no_crush_damage" },
    { 0x5953867E, "dealer" },
    { 0xBCA0457D, "dealing" },
    { 0xE21C8BC0, "deallocatetransport" },
    { 0x91E72E92, "deals" },
    { 0x03EE9DCD, "dealt" },
    { 0x0E7C7DCF, "dealth" },
    { 0xC568A7BD, "dear" },
    { 0x07E8BE66, "deatch" },
    { 0x3C2DE44C, "deatchcard_timedout" },
    { 0x128F8789, "death" },
    { 0x1AD71AC0, "death_achievements" },
    { 0xAE962FDE, "death_after_anim" },
    { 0x276DC81A, "death_ai_anim" },
    { 0xCE3F3F6C, "death_angles" },
    { 0xD7B4C86B, "death_anim" },
    { 0x542AD102, "death_anim_length" },
    { 0xCBF3A1CB, "death_anim_name" },
    { 0x233740C8, "death_anim_short_circuit" },
    { 0x7975DF96, "death_animation" },
    { 0xC272544A, "death_anims" },
    { 0xC06CCE5B, "death_array" },
    { 0x0969A5C4, "death_assigned" },
    { 0xE0635255, "death_at_end" },
    { 0x8241CF16, "death_b" },
    { 0xDEB9AD6F, "death_before_explode" },
    { 0x2D9A1D2C, "death_blossom_active" },
    { 0xC4DDAAD1, "death_blossom_cooldown_notification" },
    { 0x05CD1C0D, "death_blossom_kills" },
    { 0x5F16005A, "death_blossom_think" },
    { 0xB9276BDB, "death_blossom_track_3x" },
    { 0x72B17D9E, "death_bucket" },
    { 0xDE599974, "death_by_drone" },
    { 0x6F0DCA95, "death_by_drone_loop" },
    { 0xE2328859, "death_by_player" },
    { 0xEC8704DD, "death_callback" },
    { 0x27954DDB, "death_card_think" },
    { 0x0C4A36C9, "death_cheat" },
    { 0x12D49BF5, "death_check_for_challenge_updates" },
    { 0xD7D18B9C, "death_choices" },
    { 0x7A75ABD9, "death_cleanup_level_variables" },
    { 0xF6A4FB44, "death_cleanup_riders" },
    { 0xB080B0A8, "death_counter" },
    { 0xD7499DC0, "death_counter_huey" },
    { 0xA7FCB1D6, "death_delay_finished" },
    { 0x8EFDF776, "death_delayed_ragdoll" },
    { 0x54E4707F, "death_direction" },
    { 0xD36C8379, "death_dodger" },
    { 0x802E9730, "death_dynent_count" },
    { 0x8B90FCF7, "death_effect" },
    { 0x81E9FF8B, "death_ent" },
    { 0x2BB8313E, "death_enter_cb" },
    { 0x3EE1ED0D, "death_explo_damage_zomb" },
    { 0x6DC8AC4C, "death_explo_radius_plr" },
    { 0xC8A157BA, "death_explo_radius_zomb" },
    { 0xE64B3429, "death_explosion_back13" },
    { 0xA13F7E3B, "death_explosion_forward13" },
    { 0x012C6CCD, "death_explosion_left11" },
    { 0xDB99BBD6, "death_explosion_right13" },
    { 0x31CC5740, "death_explosion_up10" },
    { 0xEB3DCD36, "death_finished" },
    { 0x443DB678, "death_fire" },
    { 0x786467A2, "death_fire_loop_audio" },
    { 0x01C34545, "death_firesound" },
    { 0xB8BAE35A, "death_flame_fx" },
    { 0xCA867984, "death_from" },
    { 0x961965B6, "death_func" },
    { 0x21DBA815, "death_function_sewer_guard" },
    { 0xF92793AE, "death_fx" },
    { 0x17B1C77A, "death_fx_struct" },
    { 0xA07C65BD, "death_fx_thread" },
    { 0xB46A7728, "death_gas_radius" },
    { 0x8F371B61, "death_gas_time" },
    { 0xD66EE1D2, "death_goal_point" },
    { 0xA2165154, "death_guys" },
    { 0x869EAD44, "death_heli" },
    { 0xFA70A994, "death_if_not_moving" },
    { 0x1EB7282B, "death_incomming" },
    { 0xC12AF6C0, "death_index" },
    { 0x57F402C8, "death_info" },
    { 0x4C5C8654, "death_invuln_time" },
    { 0x8AD8DC05, "death_jolt" },
    { 0x0344C487, "death_loop_scene" },
    { 0x4C9BE28B, "death_make_badplace" },
    { 0x2CBDBBA3, "death_model" },
    { 0x7D4035E3, "death_model_name" },
    { 0xBA9821CE, "death_monitor" },
    { 0xB2F9C86F, "death_music_state" },
    { 0x2F49935E, "death_music_stinger" },
    { 0x8FC6B360, "death_node" },
    { 0xA099454A, "death_node_array" },
    { 0xD68E0AAA, "death_node_name" },
    { 0xCDCD2367, "death_notify" },
    { 0xBB11B633, "death_notify_wrapper" },
    { 0xD5C89A1F, "death_occured" },
    { 0x3F7B661C, "death_or_disconnect" },
    { 0x55B80A65, "death_or_explode" },
    { 0x260EBF4E, "death_org" },
    { 0xDA89B58A, "death_origin" },
    { 0x26BAC1C0, "death_quote" },
    { 0xF229336A, "death_radius_damage" },
    { 0x4A6056DD, "death_ragdoll" },
    { 0xF3ED71FB, "death_ref" },
    { 0x0B9CDEF2, "death_report" },
    { 0x4E92F966, "death_run_onfront" },
    { 0xF72745D4, "death_scene" },
    { 0x872F512D, "death_script" },
    { 0x2AF215EC, "death_shot" },
    { 0xE9DE6408, "death_shut_off" },
    { 0x09C3CCE1, "death_sound" },
    { 0x3B5F1994, "death_sound_think" },
    { 0x2E5BBD88, "death_sounds" },
    { 0x8D0306F4, "death_source_origin" },
    { 0x092773BD, "death_speed" },
    { 0x05FB4F47, "death_spiral" },
    { 0x72520958, "death_start" },
    { 0x71043044, "death_start_notify" },
    { 0xD8486ABF, "death_state_activated" },
    { 0xCA46B382, "death_streak" },
    { 0xAC0F5E64, "death_streamer_think" },
    { 0x7B9DA05F, "death_string" },
    { 0x593D39AF, "death_struct" },
    { 0xCE4A4860, "death_suicide_crash" },
    { 0x0DC301FC, "death_tank" },
    { 0x576D46A1, "death_tank_move_trigger" },
    { 0x7DE942BD, "death_tank_spawn_trigger" },
    { 0xA6E3F58C, "death_think" },
    { 0xE0DDAD9F, "death_time" },
    { 0x87D59F8F, "death_timer" },
    { 0x6B12E956, "death_timers" },
    { 0x0322B70F, "death_to_all_zombies" },
    { 0xA5DD9C2A, "death_trig" },
    { 0xF4E77870, "death_turret_rotate" },
    { 0x73711B24, "death_type" },
    { 0xF0ED8257, "death_types" },
    { 0x2DBEE3DB, "death_update_crash" },
    { 0xF45A89E6, "death_vars" },
    { 0xB8B2B10F, "death_wait" },
    { 0x7BE6A7A4, "death_watcher" },
    { 0x9698DE18, "death_weapon" },
    { 0x127D48EE, "death_z" },
    { 0x5E6A5213, "deathaction" },
    { 0xCF028029, "deathangles" },
    { 0x853099EE, "deathanim" },
    { 0x97EC8DEC, "deathanim_substate" },
    { 0xD86E7D41, "deathanimarray" },
    { 0xB2E5F7D2, "deathanimduration" },
    { 0xA85F4DD9, "deathanimhorz" },
    { 0xF607A618, "deathanimloop" },
    { 0x54461811, "deathanims" },
    { 0xB66929A3, "deathanimscript" },
    { 0x4CDC747F, "deathanimvert" },
    { 0x6539F238, "deatharray" },
    { 0xBC91631E, "deathcam" },
    { 0xCB05B1D1, "deathcamtime" },
    { 0x0AAF245F, "deathcard" },
    { 0x9379FD9D, "deathcard_give" },
    { 0x7B79F56D, "deathcard_give_solo" },
    { 0xD06A628C, "deathcard_grab" },
    { 0x853A73D9, "deathcard_grabbed" },
    { 0xADD86142, "deathcard_laststand" },
    { 0x620E4513, "deathcard_laststand_func" },
    { 0x1A8A1D33, "deathcard_save_perks" },
    { 0x51C7C017, "deathcard_spawn" },
    { 0xCDF12040, "deathcard_spawn_func" },
    { 0x1AECEC69, "deathcard_timedout" },
    { 0x398BFCDB, "deathcard_timeout" },
    { 0x662F6391, "deathcard_wobble" },
    { 0xF7CE49E6, "deathcards" },
    { 0xCC999BF8, "deathchain_goalvolume" },
    { 0x0CFD4779, "deathchainainotify" },
    { 0x90FDD126, "deathchainspawnerlogic" },
    { 0x06E52561, "deathchar" },
    { 0x9AE398F6, "deathcount" },
    { 0x134A325E, "deathcountdown" },
    { 0x0455D89F, "deathcounter" },
    { 0xCB0B439D, "deathdamage_max" },
    { 0x086F4EB3, "deathdamage_min" },
    { 0x9D126428, "deathdodger" },
    { 0x477702BE, "deathface" },
    { 0xB52A9867, "deathflag" },
    { 0x349974DE, "deathflag_check_count" },
    { 0x353483F0, "deathflag_func" },
    { 0x9E9970DE, "deathflags" },
    { 0x99593E23, "deathforceragdoll" },
    { 0x7F47D09A, "deathfuncs" },
    { 0xF9B89F89, "deathfunction" },
    { 0x49CF23EE, "deathfunction_clear_camo" },
    { 0xCA093F3B, "deathfunction_old" },
    { 0x93862780, "deathfunctions" },
    { 0xC0D3C64F, "deathfx" },
    { 0x6E1AA831, "deathfx_ent" },
    { 0x3E543CF4, "deathfxdef" },
    { 0x6ECC4742, "deathfxname" },
    { 0xB6DAB08C, "deathfxsound" },
    { 0x41EBE619, "deathfxtag" },
    { 0x61797647, "deathfxtype" },
    { 0xA7370153, "deathglobals" },
    { 0xC2BB3E6D, "deathglobalsinit" },
    { 0x62AF4614, "deathgoal" },
    { 0x9289595F, "deathhelmetpop" },
    { 0x529D0B66, "deathiconobjid" },
    { 0xF17C3089, "deathicons" },
    { 0x993844C5, "deathinfo" },
    { 0xFA8E1DED, "deathloc" },
    { 0x9011DD3B, "deathmachinekills" },
    { 0xFF2AC7EC, "deathmatch" },
    { 0xC8E6AD50, "deathmodel" },
    { 0x2B61D4A7, "deathmodel_attached" },
    { 0x0AE457DE, "deathmodel_pieces" },
    { 0xAE6C3B68, "deathmonitorname" },
    { 0x7311DE0E, "deathmove" },
    { 0xAEBFC9F9, "deathnode" },
    { 0x22A29DAB, "deathnode_g" },
    { 0x34826656, "deathnode_r" },
    { 0xD3D46D6A, "deathnotify" },
    { 0x78E24484, "deathoccured" },
    { 0x682B7FC7, "deathorigin" },
    { 0xDF5DEE4C, "deathpenalty" },
    { 0xFB250194, "deathpointloss" },
    { 0x3E8A6F77, "deathpoints_already_given" },
    { 0x83639904, "deathquakeduration" },
    { 0x5DED6CAE, "deathquakeradius" },
    { 0x3A4D6B5A, "deathquakescale" },
    { 0x87F873F6, "deathquotes" },
    { 0x17D0B327, "deathray" },
    { 0x8841002E, "deathremovenotify" },
    { 0x9F317FDA, "deathroll_off_notify" },
    { 0xC6C94063, "deathrolloff" },
    { 0xFE33E0AF, "deathrollon" },
    { 0xADD55F80, "deaths" },
    { 0x39A3F3FC, "deathscript" },
    { 0xC4F3DFBE, "deathseq" },
    { 0xAEF1A16E, "deathshield" },
    { 0x0A6EABD6, "deathsound" },
    { 0x30D9D6F3, "deathspawner" },
    { 0xA3FC3CCD, "deathspawnerents" },
    { 0xAF59D001, "deathspawnerpreview" },
    { 0x2066CEA2, "deathspawners" },
    { 0x5AC03401, "deathspot" },
    { 0x39BF5AA5, "deathstreakactive" },
    { 0xF7207CEE, "deathstreaks" },
    { 0xEA56FBA2, "deathstring" },
    { 0xC30658FD, "deathstring_passed" },
    { 0x57A0C0A5, "deathtestfunction" },
    { 0x9F66AF5E, "deathtime" },
    { 0x4E147BC7, "deathtimeoffset" },
    { 0xD1F3362E, "deathtouch" },
    { 0x0318A24B, "deathtrig" },
    { 0x8F39BD5E, "deathtriggers" },
    { 0x402BF878, "deathtypes" },
    { 0x4C459917, "deathvolume" },
    { 0xD0639028, "deathvox" },
    { 0xA5D39E9E, "deathwait" },
    { 0xC29840B6, "deathwaittracker" },
    { 0x580C271C, "debounce" },
    { 0x75492F0D, "debounce_think" },
    { 0x5394AE04, "debounce_triggers" },
    { 0xC91253EC, "debounceallbuttons" },
    { 0xA916A3F9, "debri" },
    { 0x49C7221C, "debridement" },
    { 0xCDF34354, "debrief" },
    { 0x7E51F6C1, "debrief_start" },
    { 0x69839F6D, "debrief_trigger" },
    { 0x6CE23194, "debriefing" },
    { 0x4EE1BC07, "debriefings" },
    { 0x55750B30, "debris" },
    { 0x8D8E1FDA, "debris_array" },
    { 0x963F7193, "debris_audio" },
    { 0xE8F88605, "debris_collision" },
    { 0xDD99A44E, "debris_crash_and_burn" },
    { 0xB4CB44B6, "debris_delete" },
    { 0x0D0AF297, "debris_float" },
    { 0x38A63E1C, "debris_float_away" },
    { 0xB7AB6021, "debris_init" },
    { 0xF8917F84, "debris_move" },
    { 0x05843691, "debris_move_start" },
    { 0xAE4A49CA, "debris_ready_delete" },
    { 0xD0C6E6A6, "debris_settle" },
    { 0x02EE35F8, "debris_speed" },
    { 0x900E3857, "debris_stop" },
    { 0xDA27E568, "debris_struct" },
    { 0x0644B599, "debris_think" },
    { 0x308FFC88, "debris_triggers" },
    { 0xB3F14750, "debris_trigs" },
    { 0xDDCF2F66, "debris_turn_1" },
    { 0x91CA3A94, "debris_turn_3" },
    { 0x70376165, "debris_vehicle" },
    { 0x704B1EB4, "debris_zbarrier_move" },
    { 0xEA8E134A, "debrisfx" },
    { 0x61DCA649, "debrisgroup" },
    { 0x7D9FC5F1, "debruis" },
    { 0xF96F74AA, "debug" },
    { 0xAB924519, "debug_action_string" },
    { 0x3CD4C207, "debug_active_event_stat" },
    { 0x97832127, "debug_ai" },
    { 0xF015CC72, "debug_ai_counter" },
    { 0x08E09156, "debug_ai_counts" },
    { 0x914B629D, "debug_ai_createhud" },
    { 0xC8A6C332, "debug_ai_engage_dist" },
    { 0xAB1FE01C, "debug_ai_health" },
    { 0x8F7E14BE, "debug_ai_health_spawnfunc" },
    { 0x83294898, "debug_ai_move_to_point" },
    { 0xD0691664, "debug_ai_move_to_points_considered" },
    { 0x2DF97830, "debug_ai_movement_type" },
    { 0xA2EA8113, "debug_ai_print" },
    { 0x51413942, "debug_ai_prints" },
    { 0x839CCD79, "debug_ai_prints_thread" },
    { 0xB098C7FF, "debug_ai_stealth" },
    { 0x8BFAA8D3, "debug_ai_stealth_draw_stealth_info" },
    { 0x7DDB4F65, "debug_aimer" },
    { 0x9196C355, "debug_airsupport_cylinder" },
    { 0xE0C8AF4F, "debug_allow_combat" },
    { 0x5F551B9C, "debug_allow_movement" },
    { 0x297B05A2, "debug_anim_print" },
    { 0x86812DCB, "debug_animation_lengths" },
    { 0xCD5DF5F3, "debug_animsound" },
    { 0x493715DC, "debug_animsoundsave" },
    { 0x0E2B31D5, "debug_animsoundtag" },
    { 0xA21FD562, "debug_animsoundtagselected" },
    { 0x16B2D138, "debug_arrival" },
    { 0x67FED571, "debug_arrival_cross" },
    { 0x37D44795, "debug_arrival_line" },
    { 0x87EC4D4E, "debug_arrival_record_text" },
    { 0x7504F4C7, "debug_arrivals_on_actor" },
    { 0x609027B6, "debug_astro" },
    { 0x7C8FE3B3, "debug_attack_spots_taken" },
    { 0xCC7BD16A, "debug_axis" },
    { 0xBCE48547, "debug_badpath" },
    { 0x6DC46463, "debug_balcony" },
    { 0xC9878298, "debug_balcony_line" },
    { 0x44AC803C, "debug_banzai" },
    { 0xE4A2193F, "debug_banzai_link" },
    { 0x4412ED1B, "debug_bayonet" },
    { 0xF4F8B52A, "debug_bayonet_think" },
    { 0xC8B95801, "debug_berserk" },
    { 0x21DE7DC6, "debug_berserk_org" },
    { 0x574FC571, "debug_blocker" },
    { 0x073EEE97, "debug_blood_drip" },
    { 0x0AF5ADE1, "debug_bomb" },
    { 0x340E3AAF, "debug_boss_boat" },
    { 0x34173C11, "debug_breadcrumb_level" },
    { 0x9BE63A53, "debug_breadcrumb_trail" },
    { 0xFAD250ED, "debug_breadcrumbs" },
    { 0x6F3DEE22, "debug_camera_model" },
    { 0x04BED8A5, "debug_center_screen" },
    { 0x9FB5759C, "debug_center_screen_toggle" },
    { 0xD544F57A, "debug_character_count" },
    { 0xDC6B1C3F, "debug_check" },
    { 0x29741F3C, "debug_chosenmeleeanimations" },
    { 0xB5002A71, "debug_circle" },
    { 0x1754579F, "debug_circle_drawlines" },
    { 0xC1F10D00, "debug_color_friendlies" },
    { 0x18A2937F, "debug_color_huds" },
    { 0x04392AD0, "debug_color_pallete" },
    { 0x765F8002, "debug_color_update" },
    { 0x9CE725D3, "debug_colorfriendlies" },
    { 0x37241CF5, "debug_colornodes" },
    { 0x0E931067, "debug_compound_door_breach" },
    { 0x2048FE19, "debug_corevillers" },
    { 0xA1B71366, "debug_corner" },
    { 0xF83A5968, "debug_cycle_damage_states" },
    { 0xFD0B80CB, "debug_cylinder" },
    { 0xAEB9F435, "debug_damage_display_color" },
    { 0xF3F25E68, "debug_dds_on" },
    { 0x59847375, "debug_delete_ai" },
    { 0xC8BF479B, "debug_destroy_hud_elem" },
    { 0x895F4896, "debug_di_blockade" },
    { 0x01B5839D, "debug_director" },
    { 0x03A1A4C9, "debug_display" },
    { 0xF7237BDF, "debug_display_time" },
    { 0x8F674FC4, "debug_dist_sq" },
    { 0xA3C8C9A0, "debug_door_breach_line" },
    { 0xFF25E0E3, "debug_draw" },
    { 0xE82BFF83, "debug_draw_attractor_positions" },
    { 0x5BA98D0E, "debug_draw_bomb_explosion" },
    { 0x4EC856BC, "debug_draw_bomb_path" },
    { 0xC47475C9, "debug_draw_claimed_attractor_positions" },
    { 0x7428844B, "debug_draw_goalpos" },
    { 0xC769E6F6, "debug_draw_info" },
    { 0xC7D0D818, "debug_draw_line" },
    { 0x06D9DED9, "debug_draw_mixer" },
    { 0x1128A518, "debug_draw_new_attractor_positions" },
    { 0xD72A4215, "debug_draw_orient" },
    { 0xE2AE5F04, "debug_draw_showhud" },
    { 0xCBA71656, "debug_draw_star" },
    { 0xAEFE1ADD, "debug_drone_count" },
    { 0x661DC4DF, "debug_drones_thread" },
    { 0x8D3BA7C8, "debug_drop_location" },
    { 0x75CBC5F8, "debug_dupe_scene" },
    { 0xD4B139D5, "debug_duration" },
    { 0xCAE1351C, "debug_dynamic_ai_spawner" },
    { 0xDC38A341, "debug_end_takeoff" },
    { 0x330F5F9F, "debug_enemies" },
    { 0xB25EF867, "debug_enemypos" },
    { 0x8F8D81CB, "debug_enemyposproc" },
    { 0x23A0659E, "debug_enemyposreplay" },
    { 0x3F8623E8, "debug_engagedist" },
    { 0x87E576FD, "debug_entline_until_notify" },
    { 0xFA30D8CB, "debug_ents" },
    { 0xCC895343, "debug_event" },
    { 0x4BC9AECE, "debug_exploit" },
    { 0x7520E302, "debug_explosion_death_gib" },
    { 0x0580EDEE, "debug_fake_m202" },
    { 0x7AC5D561, "debug_fake_move_gravity" },
    { 0x8872EEDF, "debug_first_attachment" },
    { 0x6F5DEE8D, "debug_flak88_drawlines" },
    { 0x446CDBD9, "debug_flak_target" },
    { 0xB8F04EA0, "debug_fontscale" },
    { 0xAABE5B57, "debug_fov_bone_distance" },
    { 0x9DE2B307, "debug_fov_loop" },
    { 0x236D0D4F, "debug_fov_loop_client" },
    { 0xACFC993C, "debug_friendly_count" },
    { 0xF327B504, "debug_friendlyfire" },
    { 0xABDC560A, "debug_funcs" },
    { 0x7D8F4279, "debug_get_player_position" },
    { 0xFAE9B425, "debug_give_piece" },
    { 0xC6CCE2E4, "debug_goal" },
    { 0x1B48A096, "debug_goalradius" },
    { 0xDE35DF5B, "debug_goodness" },
    { 0xA6C34A2A, "debug_headmodel" },
    { 0x60739D4F, "debug_health" },
    { 0x7C6A5565, "debug_health_bar" },
    { 0x95DE76A7, "debug_health_text" },
    { 0xCA9E7366, "debug_heat_wave_traces" },
    { 0x6E467E84, "debug_height" },
    { 0x86951E54, "debug_horse" },
    { 0x6836A6C8, "debug_hud" },
    { 0xA523FF74, "debug_hud_columns" },
    { 0x403091EE, "debug_hud_elem_add" },
    { 0xA237AB59, "debug_hud_elem_remove" },
    { 0x8D151557, "debug_hud_elem_set_text" },
    { 0x4FADFE51, "debug_hud_elems" },
    { 0x549BFE47, "debug_hud_remove" },
    { 0x352A139C, "debug_hud_update" },
    { 0x5BF34339, "debug_hudelem" },
    { 0xAB862E18, "debug_huey_position" },
    { 0xBF5EE736, "debug_in_position" },
    { 0x2E55D28F, "debug_items" },
    { 0x9B5A2DAE, "debug_jet" },
    { 0x3194B76C, "debug_keyline_zombies" },
    { 0x3B9BF9AA, "debug_leader" },
    { 0x51F4FBE2, "debug_leap_node" },
    { 0xF2C9D9CB, "debug_leapnode" },
    { 0xF0931F09, "debug_level" },
    { 0x44C0AF31, "debug_level_stealth" },
    { 0xA9C39C8B, "debug_line" },
    { 0x26CF2270, "debug_line_emitter" },
    { 0x44A0AAC0, "debug_line_frames" },
    { 0x4E9C0977, "debug_line_on_damage" },
    { 0x347F88F3, "debug_line_to_target" },
    { 0x1068DCEA, "debug_lines" },
    { 0x874D6EE3, "debug_loop" },
    { 0x3E99B966, "debug_low_gravity" },
    { 0x51BC322C, "debug_magic_bullet_shield_death" },
    { 0x12769AD6, "debug_main" },
    { 0x67FBC755, "debug_mansion_door_breach" },
    { 0x2F07ADBD, "debug_maxvisibledist" },
    { 0xBCCF990F, "debug_melee" },
    { 0x2C8B157C, "debug_melee_line" },
    { 0x793163AB, "debug_melee_on_actor" },
    { 0x4ED4457C, "debug_menu" },
    { 0xEFE704FE, "debug_message" },
    { 0x30A27600, "debug_message_clear" },
    { 0x57990CFF, "debug_missile" },
    { 0xE6973A36, "debug_missile_dots" },
    { 0x5A84C632, "debug_misstime" },
    { 0x8C3CC5C0, "debug_model" },
    { 0xD4501D30, "debug_model_debug" },
    { 0xCFF1139E, "debug_monsterclips" },
    { 0x960DB110, "debug_motorcycle_hud" },
    { 0x4D1942E9, "debug_motorcycle_hud1" },
    { 0x85E6F33C, "debug_msg" },
    { 0x601A3622, "debug_next_corner" },
    { 0x447F3156, "debug_no_fly_zones" },
    { 0x8BD4C862, "debug_nuke" },
    { 0x57E1535D, "debug_num_vehicles" },
    { 0x593AD126, "debug_number" },
    { 0x9BBBE75A, "debug_on" },
    { 0x75396CB7, "debug_origin" },
    { 0x298281D8, "debug_p1" },
    { 0x9B89F113, "debug_p2" },
    { 0xFBA6C995, "debug_pain" },
    { 0xD9C82F66, "debug_parking_door_breach" },
    { 0x45292AA7, "debug_passengeranims" },
    { 0x9D163EF3, "debug_patrol" },
    { 0x81F2C26A, "debug_plane_line" },
    { 0x4C641456, "debug_play_new_camera" },
    { 0x5327B0A0, "debug_playback_hud" },
    { 0x09D16436, "debug_player" },
    { 0xE8B99762, "debug_player_damage" },
    { 0x638A0BE1, "debug_player_death" },
    { 0x2D225E78, "debug_pole_plane" },
    { 0x3104DC3B, "debug_positions" },
    { 0x321DBF3A, "debug_positions_in_heli" },
    { 0x5C73CB5D, "debug_power_gondola_on" },
    { 0x1C18CCCE, "debug_powered_items" },
    { 0xAFBBEC46, "debug_print" },
    { 0x8ADF2DBF, "debug_print3d" },
    { 0x436A8E7C, "debug_print3d_simple" },
    { 0x83517383, "debug_print3d_simple_heli" },
    { 0xD943CFDF, "debug_print_ber3b" },
    { 0x19B057BF, "debug_print_dialogue" },
    { 0x842347B1, "debug_print_emp_points" },
    { 0x132028DE, "debug_print_ent_array" },
    { 0x4072890D, "debug_print_heli" },
    { 0xFA4DF926, "debug_print_latest_state" },
    { 0x24F8EE8F, "debug_print_line" },
    { 0xB80DA699, "debug_print_mechz_round" },
    { 0x6FF53EDA, "debug_print_origins" },
    { 0x77812959, "debug_print_out_all_triggers" },
    { 0x693B551E, "debug_print_target" },
    { 0x1C943B8D, "debug_prison_spoon_quest" },
    { 0xA5CA80A3, "debug_radius" },
    { 0x2A687E8D, "debug_rappel" },
    { 0x0DC87A50, "debug_rcbomb" },
    { 0x38935CCB, "debug_realtime_engage_dist" },
    { 0x55C3B9C2, "debug_reflection" },
    { 0xC3F5D140, "debug_reflection_buttons" },
    { 0xBF06EE8C, "debug_reflection_matte" },
    { 0xE91D9B6B, "debug_reflection_objects" },
    { 0x84F2E56F, "debug_reflectionobject" },
    { 0x8D055234, "debug_replay" },
    { 0x09A82D91, "debug_reset_timeouts" },
    { 0x16EEBB5D, "debug_river" },
    { 0x2A2B4C6F, "debug_rocket_targetting" },
    { 0x5304E2B0, "debug_rotate_attachment" },
    { 0x050C98EE, "debug_round_advancer" },
    { 0x8DBEDE50, "debug_route" },
    { 0x4B0CBF8C, "debug_script" },
    { 0xB3B40DBD, "debug_script_flag_trigs" },
    { 0xB47C8915, "debug_script_flag_trigs_print" },
    { 0x9636292E, "debug_script_flag_trigs_print_waittill" },
    { 0xA8103BCF, "debug_script_structs" },
    { 0x99E3604F, "debug_sentinel_debug_compact" },
    { 0xC0BAE7E6, "debug_set_generator_active" },
    { 0xC2E8C83B, "debug_set_generator_inactive" },
    { 0x9A2022C7, "debug_set_speed" },
    { 0x7B32678E, "debug_shared" },
    { 0x47C751C7, "debug_shot_target" },
    { 0x870EE4A0, "debug_should_buff_zombies" },
    { 0xCD520FE2, "debug_show" },
    { 0x171E2298, "debug_show_ent" },
    { 0x7F2E035F, "debug_show_spawn_locations" },
    { 0x6C82C36C, "debug_show_viewpos" },
    { 0x75D7026E, "debug_show_wheel" },
    { 0x49BC3BC2, "debug_slowmo" },
    { 0x10E2C498, "debug_spawn_nodes" },
    { 0x52A3E23A, "debug_spawn_refresh" },
    { 0xC81E15B7, "debug_speech" },
    { 0x2C78DD1A, "debug_speed" },
    { 0x172E04FA, "debug_sphere" },
    { 0x13B3A7AE, "debug_sphere_draw_type" },
    { 0x3E9FF4C1, "debug_sphere_until_notify" },
    { 0x44EA2D9C, "debug_spherical_cone" },
    { 0xC5DC6D71, "debug_spot" },
    { 0xF17B600A, "debug_sq_bg_quest_starter" },
    { 0x17B21CC4, "debug_staff_charge" },
    { 0xEDFC50AD, "debug_star" },
    { 0xD6101AEE, "debug_star_pos" },
    { 0xB793DBF9, "debug_stat_types" },
    { 0xB485DBBE, "debug_stealth" },
    { 0x8DF8A47F, "debug_stealth_loop" },
    { 0xC63B7911, "debug_stop" },
    { 0x587D919F, "debug_stopenemypos" },
    { 0x2F99AAD7, "debug_strafe_plane" },
    { 0x72D5B916, "debug_strength_test_anims" },
    { 0xCA693E92, "debug_string" },
    { 0xB5EB8CB2, "debug_sundial_button_triggers" },
    { 0x11E93DA1, "debug_sundial_buttons" },
    { 0x621AFA13, "debug_tag" },
    { 0x3CDEE6C6, "debug_tag_player_tag_camera" },
    { 0x971D6A05, "debug_tank" },
    { 0xE998BA4B, "debug_tank_damage" },
    { 0xD7562CBA, "debug_tank_health" },
    { 0xBA444955, "debug_test" },
    { 0x1CAD3643, "debug_test_renders" },
    { 0x7564640C, "debug_text" },
    { 0xAEC4CDAC, "debug_the_zero_bug" },
    { 0x9E585B31, "debug_thread" },
    { 0xDC61D84E, "debug_time" },
    { 0x190D825D, "debug_time_bomb_print" },
    { 0x502A3488, "debug_timer" },
    { 0x598F2AC7, "debug_toggle_playercamlinkto" },
    { 0x6F0A1944, "debug_toggle_playercamlinktoeffect" },
    { 0x11910AFB, "debug_tower_guys" },
    { 0xC31E4384, "debug_tower_trap_timer" },
    { 0x1226A8B8, "debug_trace" },
    { 0xA844306F, "debug_tracker" },
    { 0xC250F4B0, "debug_traversal_ast" },
    { 0x1C53196E, "debug_triggers" },
    { 0x7C4AB268, "debug_turn_print" },
    { 0xD06822DE, "debug_turnanims" },
    { 0x52DE3197, "debug_turret" },
    { 0x3E40DD9F, "debug_turret_count" },
    { 0x81892303, "debug_ui" },
    { 0xF60D345A, "debug_unitriggers" },
    { 0x1D3E9F25, "debug_update_angles" },
    { 0xB0D54231, "debug_update_timeouts" },
    { 0x06E8C13B, "debug_variant_type" },
    { 0xCA15986F, "debug_vc_and_sampan" },
    { 0x4C130829, "debug_vc_sampan_pos_at_death" },
    { 0x53A9B7E3, "debug_vehicle" },
    { 0x5641A673, "debug_vehicle_count" },
    { 0xDD75DC7A, "debug_vehicle_paths" },
    { 0x6AFCC7E1, "debug_vehicle_turret_ai" },
    { 0xAB6C7ED2, "debug_vehicleresume" },
    { 0xEB02DD26, "debug_vehiclesetspeed" },
    { 0x26A1F65A, "debug_vehiclesittags" },
    { 0x1DE521F2, "debug_warp_player_to_fountain" },
    { 0x2E0EEE58, "debug_warp_point" },
    { 0x33F36DC3, "debug_watch_dead_zeros" },
    { 0x5B801DB4, "debug_watch_for_zone_capture" },
    { 0x815B7F71, "debug_watch_for_zone_recapture" },
    { 0x26146CD5, "debug_waveleader" },
    { 0x1B8D68E9, "debug_weapon" },
    { 0xAA8507CF, "debug_width" },
    { 0xB722E223, "debug_woods_horse" },
    { 0x922B6F6A, "debug_xp_display_color" },
    { 0x76EFC8AF, "debug_xpos" },
    { 0xE4D112A2, "debug_yinc" },
    { 0xF3F08D5C, "debug_ypos" },
    { 0x27C941A0, "debug_zipline" },
    { 0x10C00BE5, "debug_zombie_count_hud" },
    { 0xCBEA0384, "debugactivemanagers" },
    { 0x63B6DCEA, "debugaddstateinfo" },
    { 0x5C79376F, "debugaiming" },
    { 0xBFB689C7, "debuganimindex" },
    { 0xADAA63C7, "debuganimloop" },
    { 0x9C4E7F62, "debuganimscriptlevel" },
    { 0x17522C8B, "debuganimscripttime" },
    { 0xCF5EB605, "debugartillerydangercenters" },
    { 0x58A237B8, "debugartillerydangercenters_thread" },
    { 0x7F6E71D1, "debugbox" },
    { 0x53098C6C, "debugboxheight" },
    { 0x53E61BF7, "debugboxwidth" },
    { 0xDD31229F, "debugbreak" },
    { 0x951441F1, "debugburstprint" },
    { 0xE9125088, "debugchains" },
    { 0xFEFB6F32, "debugchainsphere" },
    { 0x2800F30F, "debugcheckforexit" },
    { 0xDB9B994C, "debugcleanstatestack" },
    { 0xC7620B50, "debugclearstate" },
    { 0xB6F11103, "debugcolor" },
    { 0xEDE28CB6, "debugcolorfriendlies" },
    { 0xE50C92C3, "debugcolorfriendliestogglewatch" },
    { 0xDB607289, "debugdirection" },
    { 0x198F6ED8, "debugdvars" },
    { 0x0854BD0A, "debugelectrictrap" },
    { 0x1A0E1701, "debugent" },
    { 0x60413593, "debugfailedcoverusage" },
    { 0x4ADF11F8, "debugger" },
    { 0xB1985A97, "debugging" },
    { 0x23AA9C40, "debuggingof" },
    { 0xCE092E73, "debuggoal" },
    { 0x45855ECF, "debuggoalpos" },
    { 0xCC467E71, "debugheadchopper" },
    { 0x9E2D6DC4, "debughealth" },
    { 0xD6DDB95F, "debugheight" },
    { 0xC5DC6229, "debughitloc" },
    { 0x9EF84307, "debugidentifier" },
    { 0x10E87F6A, "debuginfo" },
    { 0x4A329886, "debuging" },
    { 0x11173F0B, "debugisincombat" },
    { 0xB856D862, "debugjump" },
    { 0x5C78DB61, "debugleft" },
    { 0x5D8D5524, "debuglevel" },
    { 0x93B7208C, "debugline" },
    { 0x70530C75, "debuglinespecial" },
    { 0x99B7D197, "debuglittlebird" },
    { 0xC6E54B50, "debuglocoexplosion" },
    { 0x4C69DBBB, "debuglookatenabled" },
    { 0x18B96EAE, "debugmissile" },
    { 0x623A7FF5, "debugmisstime" },
    { 0x27526D8C, "debugmisstimeoff" },
    { 0x3E163F37, "debugname" },
    { 0x2F8718FB, "debugnearbyplayers" },
    { 0x86703645, "debugon" },
    { 0x4D1EC408, "debugorigin" },
    { 0xA112C258, "debugpause" },
    { 0xF5F52796, "debugpointsarray" },
    { 0x7E3CCDCA, "debugpopstate" },
    { 0xC148299C, "debugpos" },
    { 0x2EB85FC7, "debugposinternal" },
    { 0xA31A81D7, "debugpossize" },
    { 0x65A8FDFB, "debugprint" },
    { 0xCFF8A17D, "debugprintendsequence" },
    { 0x2358ED00, "debugprintevents" },
    { 0x13FCF649, "debugprintln" },
    { 0x7C7C05A1, "debugpushstate" },
    { 0xE1C6FAC0, "debugqueueevents" },
    { 0xF7D62320, "debugrambooutposition" },
    { 0x39B7B21A, "debugrtengagedistcolor" },
    { 0x87BFEAA1, "debugshouldclearstate" },
    { 0x283C6335, "debugspawners" },
    { 0x1D606209, "debugspawning" },
    { 0xC57C2ED4, "debugspringpad" },
    { 0x617F6EBA, "debugstar" },
    { 0x8B887B8C, "debugstartpos" },
    { 0x218EA7CD, "debugstring" },
    { 0xFF562098, "debugsubwoofer" },
    { 0x90382EE0, "debugsubwooferprint3d" },
    { 0x27BB498A, "debugtag" },
    { 0x90E7D7C5, "debugtags" },
    { 0x4B54A797, "debugtakecoverwarnings" },
    { 0x5333AA8D, "debugtargetpos" },
    { 0x00F089ED, "debugteamcolors" },
    { 0x60681997, "debugtext" },
    { 0xDA39CD7E, "debugthreat" },
    { 0xD891D05D, "debugthreatcalc" },
    { 0x66B1971B, "debugtimeout" },
    { 0x750F5E0F, "debugturbine" },
    { 0xDE98BAC6, "debugturns" },
    { 0x0C50C938, "debugturret" },
    { 0xF0A93A41, "debugunawarebehavior" },
    { 0xE7D4202C, "debugunawareprox" },
    { 0xC739BF21, "debugvar" },
    { 0x7C95B24A, "debugwavecount" },
    { 0x091CD497, "dec" },
    { 0x3D2A4D85, "dec20" },
    { 0xD2EE8F8D, "decadence" },
    { 0x0F033AC8, "decal" },
    { 0xBCE338E3, "decals" },
    { 0xD720F7B4, "decap" },
    { 0xA96B9A61, "decapitate" },
    { 0xF1822685, "decapitate_heads" },
    { 0x6DBD3D77, "decapitated" },
    { 0x2DCE6B1E, "decapitation" },
    { 0x2D374565, "decay" },
    { 0x60B5C2C8, "decay_duration" },
    { 0x4C0DA5E6, "decay_hit_counts" },
    { 0x14FB563A, "decay_immediately" },
    { 0x675B27B0, "decay_player_damages" },
    { 0x96416C5E, "decay_rate" },
    { 0x73D7313C, "decay_start" },
    { 0xAA8125B8, "decay_start_time" },
    { 0x16B00D73, "decay_time" },
    { 0x94CD9010, "decayplayerdamages" },
    { 0x8E315648, "decayprogress" },
    { 0x4654B177, "decayrate" },
    { 0x7D1C6725, "decayscale" },
    { 0x475A7702, "decaytime" },
    { 0xD3701C78, "deccallcount" },
    { 0x6E8CC2B9, "deccel" },
    { 0xF0685E48, "dece" },
    { 0xAB4B9D45, "decease" },
    { 0x94AF5CDB, "deceased" },
    { 0x65306914, "decel" },
    { 0x81170D74, "decel_id" },
    { 0xC645175F, "decel_pitch" },
    { 0x695D2E10, "decel_time" },
    { 0xA3523B2B, "decelation" },
    { 0x3CE7F9D3, "decelerate" },
    { 0x5F1D1D21, "decelerate_time" },
    { 0x6F084C56, "decelerating" },
    { 0x63247A13, "decelerating_speed_fraction" },
    { 0xEE3265AE, "decelerating_throttle_fraction" },
    { 0xDC16B480, "deceleration" },
    { 0xFFD93662, "decelfraction" },
    { 0x80871E24, "decelleration" },
    { 0x8D848D2A, "decelrate" },
    { 0x124276E3, "decelsec" },
    { 0x8846FE67, "deceltime" },
    { 0x8B4909CA, "decend_sound" },
    { 0xA4EA5C8A, "decending" },
    { 0x14E51426, "decent" },
    { 0x40B3CD00, "decent_leftlimp" },
    { 0x040CA28B, "decent_rightlimp" },
    { 0x980B2358, "decent_straight_limp" },
    { 0x28494565, "decide" },
    { 0x7D588472, "decide_hide_show_chest_hint" },
    { 0xCBF7F254, "decide_hide_show_hint" },
    { 0xF89DA17B, "decided" },
    { 0xF5FB0143, "decidedanimation" },
    { 0x84A8A274, "decideinitiator" },
    { 0xDAE35058, "decideminiarrivalanim" },
    { 0x926E441B, "decidenumcrawls" },
    { 0xB0BC7B9F, "decidenumshotsforburst" },
    { 0xF5B728E8, "decidenumshotsforfull" },
    { 0x7EC7C274, "decides" },
    { 0x3EDE64BC, "decidewhatandhowtoshoot" },
    { 0x05A29530, "deciding" },
    { 0xFD74ED4A, "decimal" },
    { 0x2F067969, "decimalhud" },
    { 0xC2E76A85, "decimals" },
    { 0x5AB7CD0F, "decision" },
    { 0xE52089D6, "decisions" },
    { 0xA4636976, "deck" },
    { 0x847F256A, "deck_aftdeck_enemies" },
    { 0x27566FCF, "deck_aftdeck_runners" },
    { 0xDF3B8063, "deck_ai" },
    { 0x7CAC88F4, "deck_align" },
    { 0x0023571D, "deck_cable_dialogue" },
    { 0x86AF7158, "deck_camera_target" },
    { 0xEE663DA1, "deck_danger_zone" },
    { 0xE1E43544, "deck_dialogue1" },
    { 0x89774947, "deck_dialogue1_kill" },
    { 0xC11F1B0A, "deck_drop" },
    { 0xF31E08D1, "deck_end_door_state" },
    { 0xEF1F177B, "deck_enemies_a" },
    { 0x7D17A840, "deck_enemies_b" },
    { 0x4B18F2FC, "deck_enemies_behavior" },
    { 0xE0731E16, "deck_enemies_behavior2" },
    { 0xA31A22A9, "deck_enemies_c" },
    { 0x612686B6, "deck_enemies_d" },
    { 0x4ED68EF2, "deck_enemies_herokill" },
    { 0xA34E7850, "deck_enemies_logic" },
    { 0x0A8453CF, "deck_enemies_see" },
    { 0xAE756C09, "deck_enemies_spawnfunc" },
    { 0xACBDDAA0, "deck_enemy_die" },
    { 0x544AFDA3, "deck_event_crashed_drone_cover" },
    { 0x20EFECB5, "deck_event_f38_crash" },
    { 0x0D0D0327, "deck_event_f38_crash_rumble" },
    { 0xB54A08FD, "deck_event_jetpack_ai" },
    { 0x55F2D7A2, "deck_event_jetpack_drones" },
    { 0x66F5AAF7, "deck_event_jetpack_drones_cleanup" },
    { 0xF9A0C1F1, "deck_event_menendez_takeoff" },
    { 0x2FAEA999, "deck_event_menendez_takeoff_sound" },
    { 0xF6777359, "deck_event_menendez_takeoff_vo" },
    { 0x9169399D, "deck_event_pip_drones" },
    { 0x31D737C1, "deck_fxanim_start" },
    { 0xA9C007E5, "deck_gun_destroyed" },
    { 0x08F148BD, "deck_heli" },
    { 0x4A58F246, "deck_heli_minigun_fx" },
    { 0x18C0FD69, "deck_heroes" },
    { 0x27E7A226, "deck_heroes_holdtheline" },
    { 0x3F8C1E0C, "deck_hide_no_mason_rpgs_think" },
    { 0xE322A4E9, "deck_kill_off_sleepers" },
    { 0xF08118A6, "deck_kill_off_sleepers_dialogue" },
    { 0x96D23B62, "deck_main" },
    { 0xFCD0CE9D, "deck_minigun_dodamage" },
    { 0xBEDE607D, "deck_minigun_dodamage_to_ent" },
    { 0x2551413D, "deck_panel" },
    { 0x82A4DE54, "deck_reveal_combat_vo_start" },
    { 0x6FB0F782, "deck_ropes_01" },
    { 0xDDF574DA, "deck_sliding_plane_target" },
    { 0xACFB2767, "deck_start" },
    { 0xC0E6E736, "deck_support" },
    { 0x63DE546E, "deck_target" },
    { 0x5FC2AF91, "deck_targets" },
    { 0xCE358AEB, "deck_training" },
    { 0xD18E9464, "deck_turn_off_cells" },
    { 0xCDB91D00, "deck_vtols_hide" },
    { 0xCC5F771B, "deck_vtols_show" },
    { 0x0F56892A, "deck_wave" },
    { 0x7766FC69, "decks" },
    { 0x0A68C3EE, "deckshot" },
    { 0x03CA607B, "declaration" },
    { 0xF782CE1A, "declarations" },
    { 0x29F5D451, "declare" },
    { 0x9DEADD5C, "declare_objectives" },
    { 0xFCB278FF, "declare_scenes" },
    { 0xF59CFC65, "declare_sidequest" },
    { 0x93B970B8, "declare_sidequest_asset" },
    { 0xF1E70F21, "declare_sidequest_asset_from_struct" },
    { 0x8554607B, "declare_sidequest_icon" },
    { 0x5A90ED82, "declare_sidequest_stage" },
    { 0xFF87971B, "declare_stage_asset" },
    { 0x9A85E396, "declare_stage_asset_from_struct" },
    { 0xF2DC5F55, "declare_stage_title" },
    { 0xE5DD22C9, "declareambientpackage" },
    { 0x9A9DE506, "declareambientroom" },
    { 0x1CC82E84, "declarebusstate" },
    { 0x37F50C87, "declared" },
    { 0x842CAA91, "declaremusicstate" },
    { 0x8E0B5A38, "declares" },
    { 0x9E1CB004, "declaring" },
    { 0xA65EC0DC, "decodestring" },
    { 0x32455C04, "decomposed" },
    { 0xBED869EE, "decon_alarm" },
    { 0xF95D6C43, "deconstruct" },
    { 0x6921F21A, "deconstruct_fxanims" },
    { 0x4777EE71, "deconstruct_fxanims_in_trigger" },
    { 0x8C2C94D4, "deconstruct_models" },
    { 0xB9BF03D2, "deconstructions" },
    { 0xE7E04366, "decontamination" },
    { 0x9B0BD804, "decontamination_alarm" },
    { 0x550DFC5C, "decontamination_off" },
    { 0x787BCE26, "decontamination_on" },
    { 0x9A914864, "decontruct_fxanim" },
    { 0x05A7E46C, "decorate" },
    { 0xEDBB760B, "decoration" },
    { 0x6B0E4272, "decoration_awarded" },
    { 0x8F94416A, "decorations" },
    { 0x5F90EEFF, "decorative" },
    { 0xB97178F7, "decoy" },
    { 0x5E759834, "decoy_grenade" },
    { 0x3B3EDC1F, "decoy_spawn_distance" },
    { 0x74803187, "decoy_spawn_lifetime" },
    { 0x634A0A24, "decoy_spawn_radius" },
    { 0xAC1978DD, "decoy_time" },
    { 0xFF29A09B, "decoydetonate" },
    { 0x5484F857, "decoytown" },
    { 0x69DCF9AA, "decoyweapons" },
    { 0x04CB4065, "decrease" },
    { 0xF9F0F9B1, "decrease_fov" },
    { 0xCDFAAF69, "decrease_respawner_count" },
    { 0x51AC9FC5, "decrease_rev_time" },
    { 0xD1C37F1B, "decrease_value" },
    { 0x193BC27B, "decreased" },
    { 0x9F65E374, "decreases" },
    { 0x5E908830, "decreasing" },
    { 0xD641EA04, "decrement" },
    { 0xC0A3B968, "decrement_array_min_zero" },
    { 0x79ADC2C1, "decrement_detector_count" },
    { 0x36F941B3, "decrement_ignoreme" },
    { 0x8A511094, "decrement_is_drinking" },
    { 0xA6F335CB, "decrement_list_offset" },
    { 0x53D28288, "decrement_no_end_game_check" },
    { 0x01EA13EB, "decrement_on_death" },
    { 0x004EC308, "decrement_security_node_count" },
    { 0xD97DE208, "decrementbulletsinclip" },
    { 0x4F20255B, "decrementcolorusers" },
    { 0xBBB8C467, "decremented" },
    { 0x6A988B64, "decrementing" },
    { 0x14A866A5, "decrementlastobituaryplayercountafterfade" },
    { 0xDF0492B7, "decrements" },
    { 0x39501754, "decrese" },
    { 0x3045AD44, "dectime" },
    { 0x39942374, "dedicated" },
    { 0x236660B8, "deduct" },
    { 0xB5AAA823, "deduct_player_ante" },
    { 0x991F536A, "deduction" },
    { 0x9CFABE43, "deductplayerante" },
    { 0xDB600009, "deemed" },
    { 0xD4E4E803, "deep" },
    { 0x30228F7F, "deep_fail_trig" },
    { 0x1BE57CAB, "deep_water_trigs" },
    { 0x4B10708A, "def" },
    { 0x0DC6BD88, "def_far_blur" },
    { 0x44D380DE, "def_far_end" },
    { 0x79BAD84D, "def_far_start" },
    { 0x4551A76D, "def_near_blur" },
    { 0x5A4B2B71, "def_near_end" },
    { 0xBEC658FA, "def_near_start" },
    { 0x5C9C28E7, "defalco" },
    { 0xFDED106E, "defalco_blows_up_building" },
    { 0xF0794308, "defalco_body_bloody" },
    { 0x0E3C77FB, "defalco_dancefloor" },
    { 0x8AB3FCBC, "defalco_death" },
    { 0xE3E9FCE2, "defalco_encounter_dof01" },
    { 0xBDE78279, "defalco_encounter_dof02" },
    { 0x97E50810, "defalco_encounter_dof03" },
    { 0xA1F660EF, "defalco_encounter_dof04" },
    { 0x7BF3E686, "defalco_encounter_dof05" },
    { 0x55F16C1D, "defalco_encounter_dof06" },
    { 0xB621897B, "defalco_escape" },
    { 0x14FB0A02, "defalco_escape_defalco" },
    { 0xFB94602A, "defalco_escape_end_mission" },
    { 0xD5023E46, "defalco_escape_escort" },
    { 0x8E35F86A, "defalco_escape_karma" },
    { 0x35B30014, "defalco_escape_vehicle_callback" },
    { 0x55237A38, "defalco_execution_mature_filter" },
    { 0xC7C95B67, "defalco_guard_setup" },
    { 0x0511FE9E, "defalco_gunpoint" },
    { 0xDA1B9B77, "defalco_head_shot" },
    { 0x81F2D853, "defalco_helipad_pip" },
    { 0x17517D3E, "defalco_karma_exiting_pool_area_pip" },
    { 0x970FBDAA, "defalco_kill_player" },
    { 0x9E7F9B5D, "defalco_knife" },
    { 0x64864391, "defalco_knife_bloody" },
    { 0x4CF0A4A5, "defalco_marker_think" },
    { 0x41FBB93D, "defalco_move_speed" },
    { 0xAB261635, "defalco_reaches_end" },
    { 0x98AD908E, "defalco_reaction_done" },
    { 0xE2BBB5FA, "defalco_render_main" },
    { 0x2FA06EAC, "defalco_scale" },
    { 0x9A96174B, "defalco_shot_head" },
    { 0x39CAAD71, "defalco_stopped" },
    { 0xE0E70DB2, "defalco_take_down_scenes" },
    { 0x0F951E1C, "defalco_trainyard_main" },
    { 0xA88D85FD, "defalco_walk" },
    { 0xC9CF637C, "defalco_walk_to_plane" },
    { 0x37D892B3, "defalco_was_alive" },
    { 0x7D7E64BF, "defalco_zoom" },
    { 0x00CF13A2, "defalco_zoom_done" },
    { 0x25D841E8, "default" },
    { 0xA6FDC15A, "default2" },
    { 0x32508EF3, "default_1st_move_weighting_func" },
    { 0xCCC72A0C, "default_accuracy" },
    { 0x099983CD, "default_actor_weapon" },
    { 0x362B506A, "default_ai_follower" },
    { 0xB5A30773, "default_ai_leader" },
    { 0x468F5699, "default_ai_limit" },
    { 0x04A15670, "default_aispread" },
    { 0x81CD0A1C, "default_armor" },
    { 0x98E7E0F6, "default_arrival_yaw" },
    { 0xDE1A7D98, "default_attachment" },
    { 0xDC782885, "default_box_move_logic" },
    { 0x08AC094D, "default_camera_pitch" },
    { 0x69278BD2, "default_check_firesale_loc_valid_func" },
    { 0xC6DB4911, "default_concrete_surface_type" },
    { 0x9E987E48, "default_connection_score" },
    { 0xEF1D310A, "default_convergence" },
    { 0x74FDFCE3, "default_corner_dist" },
    { 0x0E2D5EDC, "default_corpse_dialogue" },
    { 0xBE74AFB0, "default_corpse_structs" },
    { 0x2995F126, "default_cryptokey_lootxp" },
    { 0x0B3C8EA9, "default_cullradius" },
    { 0x4DA6D473, "default_cymbal_monkey_weighting_func" },
    { 0x254EFB5A, "default_daily_cryptokeys" },
    { 0x8244A7CD, "default_damage_func" },
    { 0x5DDEE2DF, "default_deadzone" },
    { 0xE4CD6318, "default_debug_contract_slot" },
    { 0xFED4335E, "default_delayed_exit" },
    { 0xA601EFAD, "default_desired_arrival_distance" },
    { 0x417075B7, "default_determinewinner" },
    { 0xCB25635B, "default_dirt_surface_type" },
    { 0x5E21859D, "default_dist_sq_visible" },
    { 0x9B369226, "default_distance" },
    { 0x6F392F35, "default_enemy_yaw" },
    { 0xB4252535, "default_equipment" },
    { 0xC961FBCF, "default_event_awareness" },
    { 0xEA4F5CFA, "default_event_awareness_cleanup" },
    { 0x8C6F4904, "default_event_awareness_dialogue" },
    { 0xC1B8F94B, "default_event_awareness_ended_cleanup" },
    { 0x73830BC3, "default_event_awareness_enders" },
    { 0x94AC87CE, "default_event_awareness_handle_changes" },
    { 0x1A7BF278, "default_event_awareness_killed_cleanup" },
    { 0x738544E1, "default_event_awareness_setup" },
    { 0x1726CC69, "default_event_awareness_wait" },
    { 0xD21E6614, "default_event_awareness_waitclear" },
    { 0xF532EA09, "default_event_awareness_waitclear_ai" },
    { 0x34F4B39C, "default_event_awareness_waitclear_ai_proc" },
    { 0x26D3FF04, "default_exit_level" },
    { 0x57D84BB4, "default_exploder" },
    { 0x957A1A60, "default_exposure" },
    { 0x6F7CC1C9, "default_fade" },
    { 0xE42810AA, "default_far_blur" },
    { 0x82409AD0, "default_far_end" },
    { 0x0B75A363, "default_far_start" },
    { 0x3C55BD62, "default_find_exit_point" },
    { 0xF803AF94, "default_find_exit_position_override" },
    { 0xA35AB8F1, "default_flag_change_handler" },
    { 0xD4D2768D, "default_fog" },
    { 0x8A9F30CA, "default_fog_bank" },
    { 0x844294A5, "default_fog_print" },
    { 0x0EF7A2B4, "default_fov" },
    { 0x4A3FC3F0, "default_fov_lerp_time" },
    { 0xCF16853D, "default_friendly_fail" },
    { 0x51EAFD21, "default_game_mode" },
    { 0x5716FF11, "default_gamemodespawndvars" },
    { 0xDA304BA5, "default_getteamkillpenalty" },
    { 0x72921290, "default_getteamkillscore" },
    { 0x3D887EDF, "default_gettimelimit" },
    { 0x26B7442B, "default_gettimelimitdvarvalue" },
    { 0xD2D326F4, "default_give" },
    { 0xD810A547, "default_goalheight" },
    { 0x8138B73C, "default_goalradius" },
    { 0xCABBB705, "default_hackable_angledot" },
    { 0x2652A745, "default_hackable_cost_mult" },
    { 0x43518F3E, "default_hackable_distance" },
    { 0xE28FA154, "default_hackable_hack_time" },
    { 0x7FC02219, "default_hackable_prompt" },
    { 0xE179A5D0, "default_hackable_timeout" },
    { 0xE4F16508, "default_hacking_base_speed" },
    { 0xC580D7AB, "default_husk_effects" },
    { 0x63A28F1E, "default_intensity" },
    { 0x04349658, "default_iskillboosting" },
    { 0x472C0B38, "default_keep" },
    { 0x8C0B3727, "default_land_function" },
    { 0xBFD0A648, "default_laststandpistol" },
    { 0x78DBAE5D, "default_light" },
    { 0x8C883E0E, "default_lightning_chain_params" },
    { 0x0699BA05, "default_line_delay" },
    { 0x36CD914F, "default_live_character_exploder" },
    { 0xB2EEB9EA, "default_magic_box_check_equipment" },
    { 0x7C11C498, "default_mason_carry_crouch_speed" },
    { 0x3D4EBEBD, "default_max_zombie_func" },
    { 0x83FF6E16, "default_maxsightdistsq" },
    { 0x78D1BFA0, "default_maxsightdistsq_afghan" },
    { 0xCA1D8BCB, "default_maxvisibledist" },
    { 0x0696DEEF, "default_maxvisibledist_afghan" },
    { 0xDC140BFB, "default_move_acceleration" },
    { 0xA4DEC99F, "default_movement_stance" },
    { 0x1C03B6AD, "default_movespeed" },
    { 0x98CAD36B, "default_near_blur" },
    { 0xA8A54CCF, "default_near_end" },
    { 0x8E786D04, "default_near_start" },
    { 0x1027F04D, "default_obj_dist" },
    { 0xC4C198B0, "default_onalivecountchange" },
    { 0xD617FE3E, "default_ondeadevent" },
    { 0x7A7141A5, "default_onforfeit" },
    { 0x45C10F52, "default_onlastteamaliveevent" },
    { 0x6AB3DE3D, "default_ononeleftevent" },
    { 0x8450550F, "default_onplayerscore" },
    { 0xD6F12FA4, "default_onpostspawnplayer" },
    { 0xACA983ED, "default_onroundendgame" },
    { 0x451B246B, "default_onroundscorelimit" },
    { 0x8455A753, "default_onscorelimit" },
    { 0x91904565, "default_onspawnintermission" },
    { 0x63452E7A, "default_onspawnplayer" },
    { 0x3127DF38, "default_onspawnspectator" },
    { 0xAA0FE5C3, "default_onteamscore" },
    { 0x3C98C1E8, "default_ontimelimit" },
    { 0xB94A82D7, "default_override_attacker_entity" },
    { 0x121C1942, "default_pandora_fx_func" },
    { 0x54CEC97D, "default_pandora_show_func" },
    { 0x7623FFE1, "default_path_fixed_offset" },
    { 0x4F0E4131, "default_path_variable_offset" },
    { 0x712B232C, "default_pathenemyfightdist" },
    { 0x8CE6CCD2, "default_pathenemyfightdist_afghan" },
    { 0x695704C7, "default_perk" },
    { 0x4CABB0A8, "default_perkicon" },
    { 0xE7379303, "default_pitch" },
    { 0xA9A611C6, "default_pitch_down" },
    { 0x4ADA59E5, "default_pitch_up" },
    { 0x5DF7AFE0, "default_player" },
    { 0x13BAA845, "default_player_health" },
    { 0x3DCB956E, "default_player_height" },
    { 0xBF792D75, "default_player_melee_height" },
    { 0x93841C6B, "default_player_melee_range" },
    { 0x6BA5F5E0, "default_player_melee_width" },
    { 0xA0302C0B, "default_pos" },
    { 0xF60F697F, "default_position_struct_targetname" },
    { 0x194811C8, "default_power_empty" },
    { 0x95308272, "default_power_full" },
    { 0x46ED58F6, "default_range" },
    { 0x4375C3F0, "default_ray_gun_weighting_func" },
    { 0x0C816C86, "default_ref" },
    { 0x60D6A100, "default_rules" },
    { 0x07D00DDE, "default_run_speed" },
    { 0xDBB76978, "default_settings" },
    { 0x574EB415, "default_skipto" },
    { 0x1A1B9513, "default_sky_intensity_factor_0" },
    { 0xF4191AAA, "default_sky_intensity_factor_1" },
    { 0x9F61306D, "default_snow_surface_type" },
    { 0x7D3C88D6, "default_solo_laststandpistol" },
    { 0x0F16225D, "default_spawnmessage" },
    { 0xA6F8B2E0, "default_speed" },
    { 0xA31D2D67, "default_spotted_dialogue" },
    { 0xBF530ACD, "default_squad_leader" },
    { 0xB7EA7D1F, "default_stance" },
    { 0xCA04F36D, "default_start" },
    { 0x6BB5243E, "default_start_corner_dist" },
    { 0xCFC78025, "default_start_location" },
    { 0xDCDCD44B, "default_step_time" },
    { 0xA0339773, "default_sun_samplesize" },
    { 0xD768077F, "default_surface_type_for_screen_fx" },
    { 0x665F6F5B, "default_surface_type_for_tread_fx" },
    { 0x68628BA9, "default_tac_arrive_distance" },
    { 0xB2420F42, "default_take" },
    { 0x9BA02F38, "default_tank_health" },
    { 0x54BBD038, "default_target" },
    { 0x46CC346E, "default_tesla_weighting_func" },
    { 0x269DDFAF, "default_trait_value" },
    { 0xD02E72AF, "default_trans_in" },
    { 0xACF42F84, "default_transition_in" },
    { 0x75436917, "default_type" },
    { 0xD1E94A2F, "default_unwield" },
    { 0x3EA37366, "default_upgrade_weapon_weighting_func" },
    { 0x59D49E94, "default_val" },
    { 0xD3CFABA1, "default_validate_enemy_path_length" },
    { 0xFE0BA25E, "default_value" },
    { 0x5C73BAE7, "default_vending_precaching" },
    { 0x66D5434D, "default_visionset" },
    { 0xDE7E0EC0, "default_wait" },
    { 0xF89BA3C2, "default_weak_spot_damage_limit" },
    { 0xCA0A87C8, "default_weap" },
    { 0x1DF31B33, "default_weapon" },
    { 0x0E9B66CA, "default_weekly_cryptokeys" },
    { 0x8FC3F8CA, "default_weighting_func" },
    { 0x44EDE878, "default_wield" },
    { 0x57B2F18E, "defaultads" },
    { 0xC95ABE80, "defaultaimlimit" },
    { 0x9FB31C6B, "defaultattributevalue" },
    { 0x6A8F7EBF, "defaultbottomarc" },
    { 0xA139C050, "defaultclass" },
    { 0xF78F4B95, "defaultdelay" },
    { 0x361ABA0B, "defaultdirection" },
    { 0xA9DC6068, "defaultdist" },
    { 0x706A5469, "defaultdistance" },
    { 0x08D11436, "defaultdropdistance" },
    { 0x552F3FFB, "defaulted" },
    { 0xFCAE7EFB, "defaultexception" },
    { 0x87BE8D44, "defaultfire" },
    { 0xE170BEE1, "defaultfov" },
    { 0xAB8A7560, "defaulthackedhealthupdatecallback" },
    { 0x9EB4EC17, "defaultimagerender" },
    { 0x0CF39A9C, "defaultindex" },
    { 0x3EDF18B0, "defaulting" },
    { 0xEB0C9111, "defaultitemrender" },
    { 0x26DDA78A, "defaultjukedirection" },
    { 0x1FE6B865, "defaultleftarc" },
    { 0x5BF5AE31, "defaultlimit" },
    { 0xFF5F9338, "defaultlookahead" },
    { 0x5DE13A8C, "defaultmaxhealth" },
    { 0xD3DC67E5, "defaultmdl" },
    { 0xC0FDF540, "defaultmovespeed" },
    { 0xB0D054AC, "defaultmovetime" },
    { 0x1702B3D0, "defaultoffenseradius" },
    { 0x7357B588, "defaultoffenseradiussq" },
    { 0x019F157E, "defaultoffmode" },
    { 0x136C003A, "defaultonmode" },
    { 0x682AEC38, "defaultpackage" },
    { 0xD30BCD43, "defaultplayerdeathwatchtime" },
    { 0x367BD117, "defaultrange" },
    { 0xEC8DBB61, "defaultrangeclose" },
    { 0x3D62D337, "defaultrepeatrate" },
    { 0x5E9B0CCA, "defaultrightarc" },
    { 0xB272DD98, "defaultrole" },
    { 0xF2762611, "defaultroom" },
    { 0x4C61A183, "defaults" },
    { 0x0F8CA85E, "defaultscore" },
    { 0x228A391C, "defaultsetting" },
    { 0x151AA7E3, "defaultstate_death_enter" },
    { 0xED491970, "defaultstate_death_update" },
    { 0x138F8590, "defaultstate_driving_enter" },
    { 0x4770CA98, "defaultstate_emped_enter" },
    { 0x52A3C3D2, "defaultstate_emped_exit" },
    { 0x117A02E5, "defaultstate_emped_update" },
    { 0xE96B1036, "defaultstate_off_enter" },
    { 0xD1F7694C, "defaultstate_off_exit" },
    { 0x2995BFC0, "defaultstate_surge_update" },
    { 0xC5B2AD92, "defaultsun" },
    { 0x2EAE8482, "defaulttargets" },
    { 0xF5144A83, "defaulttime" },
    { 0x3436E0E7, "defaulttoparc" },
    { 0x542AC0C6, "defaultturnstrength" },
    { 0xB24CB93F, "defaultusetagangles" },
    { 0x9744F3AB, "defaultvalue" },
    { 0x22F80978, "defaultvehicle" },
    { 0xFD15C898, "defaultvehicle_mp" },
    { 0xF49F12A4, "defaultweapon" },
    { 0x0D5FF0F6, "defcon" },
    { 0x2566F896, "defcon_activated" },
    { 0xDDCDC38B, "defcon_active" },
    { 0x1A1A8186, "defcon_countdown_time" },
    { 0xAA149025, "defcon_level" },
    { 0x542C343F, "defcon_pack_poi" },
    { 0x3CDCAE22, "defcon_reset" },
    { 0xA090F692, "defcon_sign_lights" },
    { 0x37719D98, "defcon_sign_setup" },
    { 0x47A986E9, "defcon_signs" },
    { 0x47580064, "defeat" },
    { 0xBD998FC7, "defeated" },
    { 0x3EDA1944, "defeating" },
    { 0xB3F75E61, "defector" },
    { 0xA651BAD1, "defend" },
    { 0x0BDD6043, "defend1_set_ai_pathing_distances" },
    { 0xC002EB78, "defend_1_done" },
    { 0x78A79041, "defend_2_done" },
    { 0xB938E44C, "defend_against_btr" },
    { 0xD0FD8883, "defend_against_wave3_vehicle" },
    { 0x8FABB72A, "defend_armory_spawners" },
    { 0x24803294, "defend_asd_destroyed" },
    { 0xFE356F11, "defend_axis_killed" },
    { 0x4B3D137C, "defend_axis_strat" },
    { 0x5C4E9F79, "defend_beach_obj_struct" },
    { 0x2054184F, "defend_blow_heavy_wall" },
    { 0xDBD91A9C, "defend_bp1_logic" },
    { 0xBE2DDCFB, "defend_chopper_targetting" },
    { 0xDFCB4B5F, "defend_clark" },
    { 0x593D6365, "defend_claymores_glow" },
    { 0xAF9FB598, "defend_crash_hide" },
    { 0x2B500474, "defend_dialog" },
    { 0x775653B7, "defend_door_open" },
    { 0xB00648E7, "defend_escape_spotlights" },
    { 0x0A5628DD, "defend_event_killspawner" },
    { 0x894D6D25, "defend_floodspawn" },
    { 0xA7E7AF94, "defend_gate_keypad" },
    { 0x1D23B233, "defend_halftrack_2" },
    { 0x20F96876, "defend_heat_area_until_enemies_leave" },
    { 0xC22333C4, "defend_heat_area_until_player_goes_back" },
    { 0x4BA69FF3, "defend_jumpto" },
    { 0x4388269D, "defend_loudspeaker_started" },
    { 0x0CFE356D, "defend_obj_struct" },
    { 0x7013AC19, "defend_open_outside_gates" },
    { 0xF574BB9A, "defend_phase_two" },
    { 0xF26933DF, "defend_pillar_hide" },
    { 0x6B1D153C, "defend_pillar_show" },
    { 0xEDEE28BD, "defend_prone_chance" },
    { 0xBEE68206, "defend_prone_crawl" },
    { 0x5B4BDD15, "defend_ragdoll_splash" },
    { 0x81A6B79A, "defend_retreat_choppers_setup" },
    { 0x464450AC, "defend_reznov" },
    { 0x6B6A1C4C, "defend_reznov_weapon_drop_check" },
    { 0x5D30091E, "defend_reznov_welding_fx" },
    { 0x6ED8F517, "defend_satchels_glow" },
    { 0x3D680ADC, "defend_second_area" },
    { 0x300C8630, "defend_start" },
    { 0xEF6B5A44, "defend_tank" },
    { 0x4936C87A, "defend_tank_blow_gates" },
    { 0xF4D33F9E, "defend_tank_setup" },
    { 0x848F8789, "defend_the_roof_with_javelin" },
    { 0xE10FA6A7, "defend_timer" },
    { 0x9B988124, "defend_vision" },
    { 0xE408428F, "defend_wave" },
    { 0x46F635B1, "defend_wave_retreating" },
    { 0x55B4B935, "defend_welding_room_fail" },
    { 0x51BFC67E, "defended" },
    { 0x1EE2861C, "defendedflag" },
    { 0xCDD88E98, "defender" },
    { 0x7BD67314, "defender_archetype" },
    { 0x0829178B, "defender_guys" },
    { 0xF8F4E802, "defender_variant" },
    { 0x2B562027, "defenderanim" },
    { 0xFE56B7A5, "defenderarchetype" },
    { 0x047D47EF, "defenderforward" },
    { 0x915CE401, "defenderforwarddotattackvector" },
    { 0x0DEE202E, "defenderright" },
    { 0xA995BD32, "defenderrightdotattackvector" },
    { 0xB7057673, "defenders" },
    { 0x2DEBDD33, "defenders_bp3" },
    { 0x404D6FDD, "defenders_killed" },
    { 0x66838B89, "defenderscaptureprogresshud" },
    { 0x66C22923, "defenderteam" },
    { 0x52A671B6, "defendertoattacker" },
    { 0xAE3F370F, "defenderup" },
    { 0xF0952E4B, "defendervariant" },
    { 0x0C2878E9, "defenderwinneralternatefrontanim" },
    { 0xC8613167, "defenderwinnerbackanim" },
    { 0xE72A7B4D, "defenderwinnerfrontanim" },
    { 0x2C7FA30D, "defenderwinnerleftanim" },
    { 0x62905556, "defenderwinnerrightanim" },
    { 0xFE7BBBB7, "defending" },
    { 0xD5A61065, "defendloc" },
    { 0xA46270B6, "defendmessage" },
    { 0x59E3BB09, "defendpoint" },
    { 0xD2B735B8, "defends" },
    { 0xCB901797, "defense" },
    { 0xEDDB6999, "defense_field_down" },
    { 0xA05D25EF, "defenseglobalcount" },
    { 0xAD9A2751, "defenseorderdialog" },
    { 0xD725F556, "defenseorderdialogkey" },
    { 0x50115C4E, "defenses" },
    { 0x3500E031, "defensesuccessratio" },
    { 0xFFCF0748, "defensive" },
    { 0x813275BB, "defer" },
    { 0x97E943D3, "defer_vision_set_naked" },
    { 0x6F376FBE, "defiend" },
    { 0xD01A815C, "definately" },
    { 0xED135714, "define" },
    { 0x1E3213CF, "define_active_chain" },
    { 0xAB3989B7, "define_air_to_air_offsets" },
    { 0x0685E3CA, "define_elevator_parts" },
    { 0x068A7C71, "define_filter" },
    { 0x2F1A2F43, "define_reverb" },
    { 0xF2561238, "defined" },
    { 0x81AE339A, "definefilter" },
    { 0x9C3FC487, "defines" },
    { 0x7810209D, "defining" },
    { 0x7DB07959, "definite" },
    { 0xB6E54E04, "definitely" },
    { 0x67189206, "definition" },
    { 0x7C95DE4B, "definitionname" },
    { 0x4C2258B9, "definitions" },
    { 0x8A9E281D, "deflected" },
    { 0xB1E82838, "deflector_start" },
    { 0xE0434151, "deflector_start_trig" },
    { 0xCD7BB4A8, "defualting" },
    { 0x00631A2B, "defuse" },
    { 0x9FFA02B5, "defused" },
    { 0xCA1F8D7C, "defusedobject" },
    { 0x098B6F32, "defuseobject" },
    { 0x8E1A3A0A, "defuses" },
    { 0xB88DDAE0, "defusetime" },
    { 0x1E93651D, "defusetrig" },
    { 0x026F401F, "defuseweapon" },
    { 0x2E5CA28E, "defusing" },
    { 0x07786E1F, "defval" },
    { 0x7112EAF3, "deg" },
    { 0x660604F3, "degradation" },
    { 0x03E629B0, "degrades" },
    { 0xDB9B70A9, "degree" },
    { 0xCC33F720, "degrees" },
    { 0x6B16832E, "degreesrolled" },
    { 0x4C88918E, "degreestoroll" },
    { 0x4AF2025A, "degreestorotate" },
    { 0x4B72AEF6, "degress" },
    { 0x929FD00D, "degs_per_pos" },
    { 0xCEF7A870, "del" },
    { 0x7D7CF689, "del_objects" },
    { 0x4BEAEB69, "del_poi" },
    { 0xBE597F00, "deladditionaltarget" },
    { 0xF54A9D2F, "delat" },
    { 0x67520C6A, "delay" },
    { 0x45366A92, "delay_after_flag" },
    { 0x36E1B9AE, "delay_after_func" },
    { 0x2456FD1F, "delay_after_health_lost" },
    { 0x3D24DA21, "delay_after_text" },
    { 0x2B3D1DC0, "delay_after_trigger" },
    { 0x15C4680B, "delay_at47_retreat_goalradius" },
    { 0x06C7DA4A, "delay_base" },
    { 0x4299B446, "delay_between_messages" },
    { 0xFE817C53, "delay_between_redacts_max" },
    { 0x816CBE5D, "delay_between_redacts_min" },
    { 0xD51352B5, "delay_between_shots" },
    { 0xD8658FFA, "delay_between_trucks" },
    { 0x00EF8231, "delay_body" },
    { 0x7E19E93B, "delay_box_hide" },
    { 0x10DD3CC0, "delay_cagelight_fx" },
    { 0xDC79FE83, "delay_cross" },
    { 0x309A4300, "delay_delete" },
    { 0x0AB72F23, "delay_delete_contact_ent" },
    { 0x6920734B, "delay_destroy_corpses_near_blocker" },
    { 0xC3A68825, "delay_destroy_timebomb_override_structs" },
    { 0x884A5EB4, "delay_difference" },
    { 0x9159A2E3, "delay_drone_damage" },
    { 0xA0D8D2DE, "delay_e4b_line_c_sm" },
    { 0x6F00318F, "delay_exits_arrivals_on" },
    { 0xE605DBDC, "delay_fade_away" },
    { 0x58BAE95B, "delay_fail_time" },
    { 0xDC09E118, "delay_falling_debris_1" },
    { 0x80E197AB, "delay_flag2_on_flag1" },
    { 0xAA0B5403, "delay_for_clients_then_execute" },
    { 0xF9B46649, "delay_frac" },
    { 0x443E645A, "delay_free_vehicle" },
    { 0x0947A5FF, "delay_fx" },
    { 0x89C9B220, "delay_give_challenge" },
    { 0xDFC2B083, "delay_grenade_vignette_arrivals" },
    { 0x99336133, "delay_halftrack_explosion" },
    { 0x9D7D01A9, "delay_hide" },
    { 0xB52CE4F3, "delay_ignoreme_off" },
    { 0xD1C34276, "delay_in_seconds" },
    { 0xDA552170, "delay_intro_fog" },
    { 0x2B9F8159, "delay_kill" },
    { 0x19458FFA, "delay_kill_loop_sound_and_delete" },
    { 0xB8C6D430, "delay_machine_timeout" },
    { 0x835D3348, "delay_mangrove_walk" },
    { 0x9337F531, "delay_max" },
    { 0x00AFD38F, "delay_min" },
    { 0x1CBBD5FA, "delay_network_frames" },
    { 0x63DE5980, "delay_nodes" },
    { 0x63F226D7, "delay_nodes_2" },
    { 0x6729B6BA, "delay_notify" },
    { 0x045DCF1A, "delay_objective_after_intro" },
    { 0x804531D4, "delay_police_car_damage" },
    { 0x00CEA6F0, "delay_post_portal_effect" },
    { 0xDFD0D50B, "delay_pre_portal_effect" },
    { 0x5F52184D, "delay_print_spot" },
    { 0xCC568DA6, "delay_queue" },
    { 0xAC2EF928, "delay_range" },
    { 0x15F03A03, "delay_rush" },
    { 0x72F8D810, "delay_s" },
    { 0xEE4E9833, "delay_set" },
    { 0x91D8B2F8, "delay_set_exert_id" },
    { 0xCD162090, "delay_set_gravity" },
    { 0x2E85CAD4, "delay_setspeed" },
    { 0x9AF7ADA6, "delay_showing_vulture_ent" },
    { 0xE8DC5946, "delay_size" },
    { 0x5502BD8A, "delay_soct_damage" },
    { 0xFCC1CF12, "delay_spawners" },
    { 0xEA4BBD0D, "delay_target_toenemy_thread" },
    { 0x2E2869F1, "delay_thread" },
    { 0xBA9DA35C, "delay_thread_watch_host_migrate" },
    { 0x61ACE20E, "delay_time" },
    { 0xE40D5948, "delay_timer" },
    { 0xA609CD78, "delay_trace" },
    { 0xAFE51805, "delay_transport_check" },
    { 0xDD2041CE, "delay_trigger_think" },
    { 0xD81F0D71, "delay_turning_on_eyes" },
    { 0x882F3E4A, "delay_unit_think" },
    { 0xCD4C01FC, "delay_unload_message" },
    { 0x320701B4, "delay_until_bottle_in_place" },
    { 0x6114CA4A, "delay_until_bottle_spawn" },
    { 0xC9F0D519, "delay_weapon_firing" },
    { 0x4080E379, "delayambientvox" },
    { 0x34E0D5DD, "delaybeforeleaving" },
    { 0x92F83987, "delaybeforeplayagain" },
    { 0x8F398136, "delaydark" },
    { 0xA1F1BDD0, "delaydestroy" },
    { 0xF184F6D9, "delayearthquake" },
    { 0x487FBBFD, "delayed" },
    { 0xD5CBB994, "delayed_add_knife_to_player_hands" },
    { 0xD8072057, "delayed_autosave_start" },
    { 0x98FC01EC, "delayed_blending_restore" },
    { 0xD281E97A, "delayed_body_delete" },
    { 0x3DFD2854, "delayed_computer_hacked_vox" },
    { 0x56448EB6, "delayed_death" },
    { 0x14133822, "delayed_default_start" },
    { 0x1A32C391, "delayed_delete" },
    { 0x0B879971, "delayed_delete_hey_charlie_clips" },
    { 0x49130B2F, "delayed_earthquake" },
    { 0x262FF8AA, "delayed_first_notify" },
    { 0x833B59D1, "delayed_fx_thread" },
    { 0x23FD94FC, "delayed_go_to_node_village" },
    { 0x8F0B8828, "delayed_guys" },
    { 0xD193A6A1, "delayed_hide_tag" },
    { 0xE02DF214, "delayed_hud_destroy" },
    { 0x31011F63, "delayed_jump_pad_start" },
    { 0xC1968457, "delayed_loser_response" },
    { 0x0F7E727B, "delayed_notify" },
    { 0xC9AF9747, "delayed_player_seek_think" },
    { 0x88F55B2B, "delayed_player_success" },
    { 0x6D46E376, "delayed_poweron_vox" },
    { 0x9CB4B591, "delayed_ragdoll" },
    { 0xCDC58056, "delayed_rush" },
    { 0x2CFDFA77, "delayed_save" },
    { 0x195FDBBF, "delayed_screen_restore" },
    { 0xB8C4BF9F, "delayed_show_guy" },
    { 0xEF49E6D0, "delayed_song_loop" },
    { 0xDF8288A5, "delayed_sound_play_thread" },
    { 0xF264CB92, "delayed_spawn_and_kill" },
    { 0x9FEBE517, "delayed_spawn_attack_gaz63_single_50" },
    { 0x9873F186, "delayed_start_skit" },
    { 0x2927F9C5, "delayed_train_exit" },
    { 0x13F8B8DD, "delayed_trigger_use_tunnel" },
    { 0x9A591BA4, "delayed_zombie_eye_glow" },
    { 0xF267CFA7, "delayedbadplace" },
    { 0xE8ECFF89, "delayeddeath" },
    { 0x869FDF13, "delayeddeletion" },
    { 0x618324DB, "delayeddeletiononswappedweapons" },
    { 0x89C8EB87, "delayeddialogue" },
    { 0xC2A85B28, "delayedexception" },
    { 0xBF6F96F2, "delayedfofoverlay" },
    { 0x29978F2E, "delayedleaderdialog" },
    { 0x62D9D3DB, "delayedleaderdialogbothteams" },
    { 0xBEC61AD3, "delayedplayergoal" },
    { 0x86D0D014, "delayedremove_thread" },
    { 0xD5857E10, "delayedscriptchange" },
    { 0x025E5582, "delayedspikedetonation" },
    { 0x1A47C5C1, "delayent" },
    { 0x9C53209B, "delayer" },
    { 0xCE297BA2, "delayinc" },
    { 0x66336546, "delaying" },
    { 0xABCDBD86, "delayingactionenemywaves" },
    { 0x9DF35C4F, "delaykey" },
    { 0xA4EF8430, "delaymax" },
    { 0x1267628E, "delaymin" },
    { 0xED6F04E4, "delaymodelswap" },
    { 0x6A56032D, "delaymovement" },
    { 0x5C392815, "delaymovementatend" },
    { 0xFD3F3D1A, "delayms" },
    { 0x2A875564, "delayoffsetter" },
    { 0x8866D74A, "delayoverride" },
    { 0x78F795D5, "delayplayer" },
    { 0x0A9E0425, "delays" },
    { 0x822BF3D1, "delayseconds" },
    { 0x2AFFA3FA, "delaysetanimtime" },
    { 0x71F8B7F6, "delaysnapshot" },
    { 0x0DAB6E27, "delaysndenddelete" },
    { 0xA4E667E3, "delaysonar" },
    { 0x5C367763, "delaystandardmelee" },
    { 0xBB9C80BA, "delaystart" },
    { 0x10085183, "delaystartragdoll" },
    { 0x8F17877C, "delaystreak" },
    { 0x243C91CE, "delaythread" },
    { 0x10961B79, "delaythread_loc" },
    { 0x433AC8FD, "delaythread_proc" },
    { 0xA5C79465, "delaytime" },
    { 0x97FC2B54, "delaytimeincrement" },
    { 0xEDC8F638, "delaytimesec" },
    { 0x01D5FCA0, "delaytotal" },
    { 0xDF640EE9, "delaytrace" },
    { 0x124515C8, "delayunit" },
    { 0x36F9C4CB, "delayzones" },
    { 0x108FCB2A, "deldroplocation" },
    { 0x1546F33F, "delegation" },
    { 0xA7AA5746, "delents" },
    { 0x30F525D5, "delerious" },
    { 0xB60BBA26, "deletable_magic_bullet_shield" },
    { 0x5BF3E6AA, "deletablenoteworthy" },
    { 0xDC8C8404, "delete" },
    { 0x2489C9A7, "delete_after" },
    { 0x0BED76CF, "delete_after_3_sec" },
    { 0x72F82848, "delete_after_aa_destroyed" },
    { 0x6342302D, "delete_after_anim" },
    { 0xB831FB5E, "delete_after_bb" },
    { 0x06A247E6, "delete_after_destruction_wait_time" },
    { 0xAF7C007F, "delete_after_stealth" },
    { 0x003EF12D, "delete_after_time" },
    { 0x3E1BF5B8, "delete_after_trig" },
    { 0xF2CEAB9F, "delete_aggressive" },
    { 0xB6629C43, "delete_ai_from_southeast_slum" },
    { 0xE027E3FE, "delete_ai_in_zone" },
    { 0x4EE3D7FC, "delete_aigroup_after_trigger" },
    { 0xA1B88F22, "delete_ais_from_scene" },
    { 0x8A23CAB1, "delete_alert_lights" },
    { 0xBCC0CC80, "delete_align_pts" },
    { 0x7E64F710, "delete_all" },
    { 0xBA24FEC4, "delete_all_axis" },
    { 0x5CF387EE, "delete_all_civs" },
    { 0xE93A77CF, "delete_all_corpse" },
    { 0x2D821259, "delete_all_enemies" },
    { 0x628D4661, "delete_all_fx" },
    { 0xC3A74FF6, "delete_all_ms_guys" },
    { 0x932F6E16, "delete_all_non_heros" },
    { 0xD8628A3B, "delete_all_spawns" },
    { 0x5B8BFA9A, "delete_all_springpads" },
    { 0xFFF80C78, "delete_all_touching" },
    { 0xF1354171, "delete_all_transports" },
    { 0x20E28253, "delete_and_create_runway_jets" },
    { 0xC61B7009, "delete_and_sink_fx" },
    { 0x650A021E, "delete_anim_link_on_death" },
    { 0x123AF3F4, "delete_any_guys_in_tent" },
    { 0xDBAD53E0, "delete_apartment_badplace" },
    { 0xB48D4052, "delete_armory_rush" },
    { 0x5C4145D6, "delete_array" },
    { 0x7E8274C5, "delete_arrays_in_sp" },
    { 0xFD3FA553, "delete_at_bb" },
    { 0x375EFA16, "delete_at_dist_sq" },
    { 0xCF0FECB1, "delete_at_end_node" },
    { 0xAD070D6B, "delete_at_end_of_line" },
    { 0xFEFEDDD3, "delete_at_end_of_patrol" },
    { 0x2054FAAE, "delete_at_end_of_spline" },
    { 0x864BA38E, "delete_at_goal" },
    { 0xD197EF8A, "delete_at_gun_pickup" },
    { 0x54BD84EB, "delete_at_node" },
    { 0x1A697984, "delete_at_path_end" },
    { 0x8BF7B0D8, "delete_at_scene_change" },
    { 0x7B8BBF36, "delete_at_spline_end" },
    { 0xF174F87D, "delete_atrium_walkers" },
    { 0xBCB3EAED, "delete_attached_ropes" },
    { 0xA96B062B, "delete_attack_coord_hint" },
    { 0x8E454C2E, "delete_axis_ai_during_c4_scene" },
    { 0x82C82AA3, "delete_axis_ai_during_weaver_scene" },
    { 0xE10831BC, "delete_bank_teller" },
    { 0x734560EF, "delete_behind" },
    { 0xA5E799B5, "delete_behind_dist_sq" },
    { 0x60FA78DA, "delete_binoc_krav_guards" },
    { 0xDA1C716E, "delete_binoc_scientists" },
    { 0xA98D8271, "delete_binoc_snipers" },
    { 0xE839C37C, "delete_binoc_snipers_basewalk" },
    { 0xBC4EAF6D, "delete_blocked" },
    { 0x1493FF0A, "delete_blockers" },
    { 0x750C8877, "delete_boarding_clips" },
    { 0x56D09232, "delete_both" },
    { 0x4EDDB8E7, "delete_bounce_light_brushes" },
    { 0x5D01B0D9, "delete_bp2_exit_battle" },
    { 0x3EABF2FA, "delete_bp2_vehicles_objectives" },
    { 0x3B975C27, "delete_bp3_vehicles_objectives" },
    { 0xF18E0853, "delete_bus_pieces" },
    { 0x67ECF04E, "delete_by_noteworthy" },
    { 0x56B23D77, "delete_by_type" },
    { 0x1C824FAB, "delete_cams" },
    { 0x784C4064, "delete_child_soldiers_when_player_drops_down" },
    { 0xE8263D02, "delete_chopper_volume_stuff" },
    { 0xC1E2D034, "delete_chopsticks" },
    { 0x6D115120, "delete_chopsticks_when_i_die" },
    { 0x91D7DFEC, "delete_chute_ent" },
    { 0xDEE8DF92, "delete_chute_message" },
    { 0x0DF7677A, "delete_civs" },
    { 0x93EB8E30, "delete_clarke_head" },
    { 0x1086A279, "delete_claymores_on_death" },
    { 0x8887AA49, "delete_collision" },
    { 0xBB2B642D, "delete_color_entrance" },
    { 0x76E21A7C, "delete_color_triggers" },
    { 0xA61CF0A7, "delete_color_triggers_done" },
    { 0x73B59DE7, "delete_confirm_arrow" },
    { 0x1066C40B, "delete_controlroom_friendlies" },
    { 0x8B31A9A3, "delete_corpse" },
    { 0x6910C5A7, "delete_corpse_arena" },
    { 0x0464C6F1, "delete_corpse_bp1" },
    { 0xD5130461, "delete_corpse_wave2" },
    { 0xAF1089F8, "delete_corpse_wave3" },
    { 0x48582C92, "delete_corpses" },
    { 0x3282BCE2, "delete_corpses_on_strengthtest" },
    { 0x4E53FB72, "delete_crashed_heli" },
    { 0xB98E17FB, "delete_dead_horse_after_charge" },
    { 0x3096A511, "delete_deathmodel_piece" },
    { 0x48F49FC7, "delete_deck_combat" },
    { 0xB59DADD5, "delete_destructible" },
    { 0x119309D7, "delete_dist" },
    { 0x70BDA45E, "delete_dist_sq" },
    { 0x3279CB0A, "delete_dome" },
    { 0x1942FC8F, "delete_door" },
    { 0x080DF55D, "delete_door_bash_clip" },
    { 0xA7E6705F, "delete_drive_vehicles" },
    { 0x7BB1DFF7, "delete_drone" },
    { 0x771B9A2E, "delete_drones" },
    { 0xFB10FE21, "delete_dropped_weapons" },
    { 0x143A3F5B, "delete_dude" },
    { 0x6B354FE2, "delete_early_e2_trigs" },
    { 0x74D235D1, "delete_em" },
    { 0x9FC64C77, "delete_emergency_light" },
    { 0x3F8DC27A, "delete_ent" },
    { 0x09F4F118, "delete_ent_array" },
    { 0x696CF646, "delete_ent_if_defined" },
    { 0x01D21B55, "delete_ent_on_death" },
    { 0xE912F56D, "delete_ent_on_owner_death" },
    { 0xD9BA2632, "delete_entities" },
    { 0x3FAFB7F5, "delete_ents" },
    { 0x5F94DD1D, "delete_ents_inside_trigger" },
    { 0xBFF97CDB, "delete_ents_on_surface" },
    { 0x0EA5D08B, "delete_ents_touching" },
    { 0x9114FF78, "delete_everyone_not_in_server_room" },
    { 0x6B015CCA, "delete_execution_enemies" },
    { 0xC2109A61, "delete_existing_time_bomb_model" },
    { 0x662F4708, "delete_exploder" },
    { 0xACFF04BD, "delete_exploder_on_clients" },
    { 0x347525C0, "delete_extra_pbys" },
    { 0xA0009F7C, "delete_fake_huey_riders" },
    { 0x45D4C713, "delete_fake_weaver_and_krav_and_woods" },
    { 0xBACDEE88, "delete_first_convoy" },
    { 0x95590608, "delete_first_floor" },
    { 0x6699F649, "delete_flag" },
    { 0x1ABC88FB, "delete_floor" },
    { 0xF0AE15C9, "delete_friendlies_hallway" },
    { 0xB269681A, "delete_frontend_objects" },
    { 0x3B1FE193, "delete_fxanims_touching" },
    { 0xD1DF78C5, "delete_ghost_pianist" },
    { 0x9D5E26CA, "delete_good_model" },
    { 0x1F9269C0, "delete_group" },
    { 0x98C75AB2, "delete_gumped_deadpose_characters" },
    { 0x4B5F2944, "delete_gunner_sound_ent" },
    { 0xE1DA6536, "delete_guy_radius_trig" },
    { 0x3B8B6247, "delete_guys" },
    { 0x447A7FB9, "delete_harper" },
    { 0x69B1F905, "delete_heli_nodes" },
    { 0x9F7A24EA, "delete_heli_think" },
    { 0x1B92D137, "delete_hero" },
    { 0xDF4EE22D, "delete_hint_print_activated_air_support" },
    { 0xDD80D312, "delete_house_allies" },
    { 0x7C793768, "delete_if_cantsee" },
    { 0xDD652EC0, "delete_if_defined" },
    { 0x86D690BD, "delete_if_not_active" },
    { 0x72E69272, "delete_if_obj_complete" },
    { 0x03CC057E, "delete_in_a_bit" },
    { 0xAF8332B3, "delete_in_createfx" },
    { 0xA4C61E8C, "delete_in_e2" },
    { 0x3206D67D, "delete_in_five" },
    { 0xAE4B6939, "delete_inside_dogsled_quadrant" },
    { 0x4AB914B5, "delete_intro_scenes" },
    { 0xA13F657F, "delete_island_blocker" },
    { 0x9A6FE773, "delete_lab_colors" },
    { 0xF3101E67, "delete_later" },
    { 0x62964EA9, "delete_link_chain" },
    { 0x019A0389, "delete_links_then_self" },
    { 0x2B06DDF4, "delete_living" },
    { 0x436A6CD9, "delete_loop_distance" },
    { 0x247913B4, "delete_loop_sound_save_restore" },
    { 0xCE276271, "delete_me" },
    { 0x1139B7E2, "delete_me_after" },
    { 0x515FE45F, "delete_me_after_flag" },
    { 0xBC1DCA71, "delete_me_in_a_bit" },
    { 0x2531A507, "delete_meeting_clip" },
    { 0x6634CF57, "delete_menendez_scenes" },
    { 0x073C33AD, "delete_message_after_a_while" },
    { 0x40836C9A, "delete_model" },
    { 0x4750E999, "delete_models_from_scene" },
    { 0x55DDE1C6, "delete_models_on_zodiac" },
    { 0x4936D920, "delete_molotov_immediately" },
    { 0x6743BBB8, "delete_molotov_later" },
    { 0x65860297, "delete_molotov_when_dead" },
    { 0x6C0C79D4, "delete_monkey" },
    { 0x0C913473, "delete_monkey_bolt_on_zombie_holder_death" },
    { 0x2FB9D87A, "delete_msg" },
    { 0x4CAEFBC3, "delete_node" },
    { 0x813F0F32, "delete_nodes" },
    { 0xF330E4A3, "delete_noteworthy_ents" },
    { 0xFB178C36, "delete_noteworthy_group" },
    { 0x296AD8D0, "delete_notify" },
    { 0x62B06758, "delete_obj_when_picked_up" },
    { 0x28245B2E, "delete_offramp_vehicles" },
    { 0x6827F5AE, "delete_old" },
    { 0x93A8FD6A, "delete_old_turrets" },
    { 0xC2D0BF44, "delete_oldest_clone" },
    { 0xFD5DDA56, "delete_oldest_rat" },
    { 0x3B5900A9, "delete_on_count_zero" },
    { 0x794502D4, "delete_on_damage" },
    { 0x3E3A41EB, "delete_on_death" },
    { 0xA144110B, "delete_on_death_or_notify" },
    { 0xF2D39415, "delete_on_death_wait" },
    { 0xD2BD3A55, "delete_on_death_wait_sound" },
    { 0xC1712092, "delete_on_delete" },
    { 0xBDCA8905, "delete_on_disconnect" },
    { 0xA39DF081, "delete_on_end_node" },
    { 0xDF8F5262, "delete_on_ent_notify" },
    { 0x7E170451, "delete_on_flag" },
    { 0xB5C15E7E, "delete_on_goal" },
    { 0xC60D639E, "delete_on_hit_by_player" },
    { 0x2F8D222D, "delete_on_level_notify" },
    { 0xFC1CB537, "delete_on_load" },
    { 0x504ECB90, "delete_on_newcrew" },
    { 0xD7CBA974, "delete_on_not_defined" },
    { 0x5DE836C8, "delete_on_notify" },
    { 0xC8D174D4, "delete_on_path_end" },
    { 0xF103AE16, "delete_on_real_meat_pickup" },
    { 0x85C11235, "delete_on_trigger" },
    { 0xB31995FA, "delete_on_truck_transition" },
    { 0xDF5EAEA5, "delete_on_unloaded" },
    { 0xED4F4F2E, "delete_original_ai_spawns" },
    { 0x612663F7, "delete_origins_afterfight" },
    { 0xF00F1DB8, "delete_outside_ship_quadrant" },
    { 0xA9E6E636, "delete_path" },
    { 0xD04BE6D5, "delete_patrol" },
    { 0x428098F2, "delete_patrol_a_when_stealth_is_done" },
    { 0x8126D36E, "delete_perk_machine_clip" },
    { 0x3D63464B, "delete_pickup_after_awhile" },
    { 0xB57AD6E2, "delete_pieces" },
    { 0xDE3CC939, "delete_pieces_after_animate" },
    { 0x784CD71F, "delete_pilot" },
    { 0xF1DBEFF8, "delete_pilot_and_copilot" },
    { 0x45D179A6, "delete_pilots" },
    { 0xAE687A81, "delete_placeable_trigger" },
    { 0x8CAA0AEB, "delete_plane" },
    { 0x7768D627, "delete_plane_at_end" },
    { 0x0F18EC2E, "delete_player_horse" },
    { 0xE2ECFE6F, "delete_player_melee_hammock_button" },
    { 0x674BF085, "delete_plaza_left_color" },
    { 0x974EFF60, "delete_plaza_right_color" },
    { 0x1618E75B, "delete_pressed" },
    { 0x398E1481, "delete_punk_buster" },
    { 0xAC4AD5B0, "delete_radio" },
    { 0x62CDE5C8, "delete_radio_internal" },
    { 0x8ECF6E52, "delete_ragdoll_corpses" },
    { 0x08CA12EF, "delete_rain_ent" },
    { 0xE1618EB2, "delete_rappel_rope" },
    { 0x30590D7E, "delete_recon_model" },
    { 0x85B31690, "delete_regroup_door" },
    { 0xDF8AD07B, "delete_reznov_color_chain_left" },
    { 0x0AE6672E, "delete_reznov_color_chain_right" },
    { 0xB1D46DC8, "delete_ride_vignette_array" },
    { 0xDA35785A, "delete_rider_and_horse_at_end_of_node" },
    { 0xBC218457, "delete_rider_asap" },
    { 0x1C06A349, "delete_river_corpses" },
    { 0x7773FE63, "delete_rope" },
    { 0x982DC101, "delete_rotor_fx_on_save_restore" },
    { 0xF46AB32F, "delete_route1_fs" },
    { 0x4D484CFD, "delete_rush" },
    { 0xC4995104, "delete_safe" },
    { 0x7614EB65, "delete_sam_drone_corpses" },
    { 0x14FDC635, "delete_scene" },
    { 0x82BDEC41, "delete_scene_all" },
    { 0x1F3759C0, "delete_scene_data" },
    { 0xAF3DD704, "delete_scenes" },
    { 0x7D585AAE, "delete_scientists" },
    { 0x368120A1, "delete_script_bundle" },
    { 0x258701DE, "delete_second_main_convoy" },
    { 0x160D536A, "delete_section1_ride_scenes" },
    { 0xDB8CF36F, "delete_section1_scenes" },
    { 0x68CA5141, "delete_section3_scenes" },
    { 0xC3B5D405, "delete_section_2_scenes" },
    { 0xE5DA3466, "delete_security_wounded" },
    { 0xCC203103, "delete_selection" },
    { 0xF0B9364E, "delete_self_after_time" },
    { 0x7B70A8B6, "delete_ship_shields" },
    { 0xB93AD783, "delete_sndent" },
    { 0x881F018A, "delete_soon" },
    { 0xB1CD05F6, "delete_sound_ent" },
    { 0x5B8A0F61, "delete_sound_ent_on_death" },
    { 0x8EC8186C, "delete_spawned_monkey_on_turned" },
    { 0x26568881, "delete_spawned_path_nodes" },
    { 0x7542BEC9, "delete_spawner" },
    { 0xC951066E, "delete_spawner_radius" },
    { 0x35742FA8, "delete_spawners_by_classname" },
    { 0x27AFAA1B, "delete_spawners_in_radius" },
    { 0x924B9868, "delete_spawners_touching" },
    { 0x8FC8F1EF, "delete_spawns" },
    { 0x7A14FC71, "delete_special_ops_entities" },
    { 0x181C9C02, "delete_spots" },
    { 0x2D8C0639, "delete_spotting_target" },
    { 0x4FC76990, "delete_sq_ents" },
    { 0x457AAF75, "delete_stage_assets" },
    { 0x74831711, "delete_start" },
    { 0xEFDA8844, "delete_streamer_ent" },
    { 0xA834B157, "delete_street_allies" },
    { 0x385DB816, "delete_struct_array" },
    { 0x7BC582F7, "delete_structs" },
    { 0xF79B64E6, "delete_swap_vehicles" },
    { 0x645CC59F, "delete_targ" },
    { 0x25649334, "delete_target" },
    { 0x472AF465, "delete_target_on_trigger" },
    { 0x9D0A266E, "delete_targetname_ents" },
    { 0x07B0BBEB, "delete_temp_ent" },
    { 0xFEF00564, "delete_these" },
    { 0x92DA15A0, "delete_time" },
    { 0xA0A1403D, "delete_time_bomb_model" },
    { 0x388EBEE2, "delete_timer" },
    { 0xFB5A08DD, "delete_trig" },
    { 0x3EDCECF0, "delete_trig_onuse" },
    { 0x55D3C75D, "delete_trigger" },
    { 0x820A126D, "delete_trigger_touch_message_on_notify" },
    { 0x5F064856, "delete_trigger_with_linkname" },
    { 0xA733C19C, "delete_triggers" },
    { 0xB98CDE1C, "delete_trigs" },
    { 0x5A4F5D1D, "delete_truck_ents" },
    { 0x0CF3C02C, "delete_truck_riders_when_end_scene_starts" },
    { 0x206E051E, "delete_truck_sound_ent" },
    { 0x93032490, "delete_upon_flag" },
    { 0x4D35D2FC, "delete_upon_secondfloor" },
    { 0xDA21EDD5, "delete_veh_corpse_player_not_around" },
    { 0xF48C4533, "delete_vehicle_after_opening" },
    { 0x15CEA91D, "delete_vehicle_at_end" },
    { 0x3FDED0B2, "delete_vehicle_at_end_of_node" },
    { 0xD322A3C0, "delete_vehicle_on_flag" },
    { 0x14722001, "delete_vehicle_on_notify" },
    { 0xBE0F90D8, "delete_vehicles" },
    { 0x10656960, "delete_vehicles_touching" },
    { 0x4D2004C1, "delete_vo_nag_group" },
    { 0xE4515D7F, "delete_vo_origin" },
    { 0x01E6C570, "delete_volumes" },
    { 0xB48EB38F, "delete_vtol_interior" },
    { 0x63698B0C, "delete_wait" },
    { 0xB6AEA513, "delete_wake" },
    { 0xE8CC9EDC, "delete_wake_audio" },
    { 0x007F5B75, "delete_water_trail" },
    { 0x9C60CB10, "delete_wave" },
    { 0xBAFDD3ED, "delete_weapon_object_array" },
    { 0xBEB06A8E, "delete_weapon_objects" },
    { 0x7A1611DF, "delete_weapon_objects_on_disconnect" },
    { 0x2CA32D90, "delete_when_in_createfx" },
    { 0x327F3247, "delete_when_noone_looking" },
    { 0x44F5623D, "delete_when_not_looking_at" },
    { 0x319848DD, "delete_window_sound_ent" },
    { 0x27DE1108, "delete_with_plane" },
    { 0x6EFC0045, "delete_wounding_sight_blocker" },
    { 0xD1CEE7C9, "delete_zodiac_scenes" },
    { 0x2B1AD43B, "delete_zombie_for_capture_event" },
    { 0x9D062D5D, "delete_zombie_noone_looking" },
    { 0x2B956715, "deleteactionbuttons" },
    { 0x2496930D, "deleteaftertime" },
    { 0xCD2A6D4D, "deleteaftertimeandnetworkframe" },
    { 0x3BD23ABD, "deleteaftertimethread" },
    { 0x090CDE6A, "deleteai_special" },
    { 0x6B8C4A6F, "deleteallpoi" },
    { 0x09D423B8, "deleteatlimit" },
    { 0x72810E3C, "deletebaseicon" },
    { 0x63CBB77B, "deletebuildabletarp" },
    { 0x75311BE9, "deletebuyabledebris" },
    { 0x11F52517, "deletebuyabledoors" },
    { 0xDD14AF42, "deletec4andclaymoresondisconnect" },
    { 0x6A310293, "deletecameraglass" },
    { 0x8D5D6A86, "deletechalktriggers" },
    { 0xBADB2329, "deletecharacter" },
    { 0x9E455EFE, "deletecharactertriggers" },
    { 0x0AA4A351, "deletecivilianai" },
    { 0x3739B19F, "deletecopter" },
    { 0xD96F8B8B, "deletecorpses" },
    { 0x400FE3AC, "deletecounteruav" },
    { 0x9039468D, "deletecrate" },
    { 0x5C3C0148, "deleted" },
    { 0xC75063FB, "deleted_bits" },
    { 0x1586B5D1, "deleted_ents" },
    { 0xB01FD5FC, "deleted_spawners" },
    { 0x838A9557, "deleted_squib_drone_near_goal" },
    { 0x0AC5ADB1, "deletedelay" },
    { 0x8618C3AD, "deletedfakeents" },
    { 0x32824BD5, "deleteelem" },
    { 0x1C1FA263, "deleteent" },
    { 0xD52E9F7C, "deleteentaftertime" },
    { 0x1D903755, "deleteentity" },
    { 0xB9E9934D, "deleteentonownerdeath" },
    { 0x4CC1AD35, "deleteentontimeout" },
    { 0x8B53AF04, "deleteentwhensounddone" },
    { 0x03D0159C, "deleteexplosivesonspawn" },
    { 0xE476D9DE, "deletefakeent" },
    { 0xD146E139, "deletefakeweaponsondeath" },
    { 0x04A1B76F, "deletefriends" },
    { 0x28573E36, "deletefx" },
    { 0x7F6EE06C, "deletegroups" },
    { 0x40838BFA, "deletehelicoptercallback" },
    { 0x9D568FAB, "deleteifnotused" },
    { 0x2FC135EB, "deleteimmediate" },
    { 0xC821A964, "deleteing" },
    { 0x05410D23, "deleteit" },
    { 0x751C73E6, "deleteme" },
    { 0x22126C71, "deleteme_in_n_seconds" },
    { 0xBFA5A312, "deletemeatendofpath" },
    { 0x9BBBA202, "deletemeonnotify" },
    { 0xBBA05219, "deletemes" },
    { 0x60C4E5BA, "deletemodels" },
    { 0x8C9618B7, "deleteobjpoint" },
    { 0xEB6BE465, "deleteonconditions" },
    { 0x6DE97287, "deleteondeath" },
    { 0xEF79C9CC, "deleteondifferentobjectspawn" },
    { 0xF619D60C, "deleteonendfx" },
    { 0x32564EC5, "deleteonflag" },
    { 0x26DD9112, "deleteongoal" },
    { 0x6D14AB65, "deleteonkillbrush" },
    { 0x55B9A415, "deleteonkillbrushoverride" },
    { 0x05CB8E5F, "deleteonmissileswarmstop" },
    { 0x4C2141B1, "deleteonownerleave" },
    { 0x2E19F5ED, "deleteonplayerspawn" },
    { 0x97FDC0E4, "deleteonteamchange" },
    { 0xF8827F92, "deleteontruegoal" },
    { 0x0EDD42D6, "deleteonzerocount" },
    { 0x98BCF281, "deletepathnode" },
    { 0xA79DC1CE, "deletepickupafterawhile" },
    { 0x45F9310B, "deletepickups" },
    { 0xB153942A, "deleteplacedentity" },
    { 0x2A228F73, "deleteplayerheli" },
    { 0x8883EDA1, "deletepreferedpoint" },
    { 0xAC732275, "deleteriotshieldonplayerdeath" },
    { 0x2C0C3E08, "deleterope" },
    { 0xC67500B7, "deletes" },
    { 0x9BFE8037, "deletesatchelandbettysondisconnect" },
    { 0x6615E906, "deletesatchelsandbettysondisconnect" },
    { 0x1A6172B2, "deletesatchelsandclaymoresondisconnect" },
    { 0x2A2F9A59, "deleteshieldmodelonweaponpickup" },
    { 0xBE06502B, "deleteshieldondamage" },
    { 0x78C83A7A, "deleteshieldonplayerdeathordisconnect" },
    { 0x58248412, "deleteshieldontriggerdeath" },
    { 0x9A4DA74D, "deleteslothbarricade" },
    { 0xA3FD2FCC, "deleteslothbarricades" },
    { 0xCE1F1AA9, "deletesound" },
    { 0x120EB462, "deletesquad" },
    { 0x17A1948F, "deletestatuscardtimer" },
    { 0x44EAC556, "deletestatusslot" },
    { 0x8E586CC9, "deletestatusslots" },
    { 0xC7BBFC70, "deletetrigger" },
    { 0xDE056B73, "deletetriggeronparentdeath" },
    { 0x86C742BF, "deletetriggerwhenpickedup" },
    { 0x4D31A1C5, "deleteturretusetrigger" },
    { 0x69FBDB45, "deleteweaponobject" },
    { 0x0856D9CC, "deleteweaponobjectarray" },
    { 0xAE3283B9, "deleteweaponobjecthelper" },
    { 0x3868E5FC, "deleteweaponobjectinstance" },
    { 0xCA88D4FF, "deleteweaponobjectson" },
    { 0x7B20BDD1, "deleteweaponobjectsondisconnect" },
    { 0x2D76AB1B, "deleteweapons" },
    { 0x5CBB78AE, "deletewhenfinished" },
    { 0x6BFED701, "deletewhenparentdies" },
    { 0xC72C6DBB, "deletewhensafe" },
    { 0x232DDAFC, "deletezombieeyes" },
    { 0x3005C34E, "deletezombiesinradius" },
    { 0xDD67948D, "deleting" },
    { 0x8E55B713, "deletion" },
    { 0xEB073B42, "deletions" },
    { 0xBB5D5013, "deligation" },
    { 0xE51DF3E3, "deliiter" },
    { 0x95428D6E, "delineate" },
    { 0xCD0B0851, "delinf" },
    { 0x2550F104, "deliver" },
    { 0x6038A367, "delivered" },
    { 0x8C9FF62C, "delivered_pkg" },
    { 0x53AC97B7, "delivers" },
    { 0xD793CF9D, "delivery" },
    { 0x23B2FF53, "delivery_refuel" },
    { 0x4F9B8D1E, "delivery_trig" },
    { 0xF38E0AAE, "delivery_tube" },
    { 0x0AF87FA8, "deliverytext" },
    { 0x497479D6, "delobjs" },
    { 0xF1646C95, "delta" },
    { 0x5F853908, "delta_angles" },
    { 0x26D1E03E, "delta_camdrift" },
    { 0x15CB6CB0, "delta_change" },
    { 0x043FE1F9, "delta_far_blur" },
    { 0xFD4BE01D, "delta_far_end" },
    { 0xEEBCD58E, "delta_far_start" },
    { 0x069C8BCE, "delta_near_blur" },
    { 0x7186FB84, "delta_near_end" },
    { 0x965BFCEF, "delta_near_start" },
    { 0x36D82D1E, "delta_score" },
    { 0xDD3D9543, "delta_time" },
    { 0xA491B2CE, "delta_vec" },
    { 0xD5F0FAA9, "delta_yaw" },
    { 0x5B5AA492, "delta_z" },
    { 0x9D3FE635, "deltaangles" },
    { 0x6DC09519, "deltachangeperframe" },
    { 0xEBA44E82, "deltadir" },
    { 0x72575D39, "deltaf" },
    { 0x8FCD11AB, "deltaorigin" },
    { 0x98C693D1, "deltaplus" },
    { 0x71A6A67C, "deltarotate" },
    { 0x843725E4, "deltas" },
    { 0xCDE8AE45, "deltasq" },
    { 0x5E34AB7B, "deltat" },
    { 0x754498D2, "deltatime" },
    { 0xCD32AFA0, "deltatoother" },
    { 0x4873FDB6, "deltayaw" },
    { 0xDA4D7395, "deltaz" },
    { 0x0767306D, "delusional" },
    { 0xF4FA22D9, "dem" },
    { 0xE421C543, "dem_defends" },
    { 0x3649F4F9, "dem_endgame" },
    { 0x1878C066, "dem_endgamewithkillcam" },
    { 0x430318A3, "dem_enemy_base_influencer_radius" },
    { 0x4830F4ED, "dem_enemy_base_influencer_score" },
    { 0x0585FC41, "dem_enemy_base_influencer_score_curve" },
    { 0x3120BA6A, "dem_get_alive_zones" },
    { 0xF95227C7, "dem_get_bomb_goal" },
    { 0x6B1C3E2A, "dem_getteamkillpenalty" },
    { 0x574AA137, "dem_getteamkillscore" },
    { 0x9542C71B, "dem_nodes" },
    { 0xEED7B875, "dem_offends" },
    { 0x51C48E40, "dem_playerspawnedcb" },
    { 0x09792641, "dem_rules" },
    { 0x5D659878, "dem_spawns" },
    { 0xFDA6E5A8, "dem_wins_index" },
    { 0x5A36779C, "demand" },
    { 0xC26E12EC, "demanding" },
    { 0x610B427E, "dembombzonename" },
    { 0x0C16BE38, "demigod" },
    { 0xF6064B4F, "demigod_mode_on_boat" },
    { 0x93ED41EC, "demo" },
    { 0x92AB5886, "demo_bookmark_event" },
    { 0x4FD3DBC8, "demo_bookmark_game_result" },
    { 0x1A643B2E, "demo_bookmark_kill" },
    { 0x464450AF, "demo_bookmark_medal" },
    { 0x0696E65E, "demo_bookmark_round_result" },
    { 0xF8B9BC01, "demo_bookmark_score_event" },
    { 0xF5928905, "demo_bookmark_zm_player_bledout" },
    { 0x8F5B57A9, "demo_bookmark_zm_player_downed" },
    { 0x879ED7AB, "demo_bookmark_zm_player_revived" },
    { 0xD5FE2FBA, "demo_bookmark_zm_round_end" },
    { 0x7035A050, "demo_bookmark_zm_sidequest_event" },
    { 0x0BD87534, "demo_end_sound_off" },
    { 0xF0A962C5, "demo_fade" },
    { 0xDABF81DC, "demo_guy" },
    { 0xA22C1D4E, "demo_intro_screen" },
    { 0xCEAD83DB, "demo_jump" },
    { 0x9628395C, "demo_jump_monitor" },
    { 0xAF11D676, "demo_line_4_clear" },
    { 0x20264424, "demo_line_6_clear" },
    { 0xD12674CF, "demo_monitor" },
    { 0xF82B042B, "demo_nplplayer_change" },
    { 0x9FA2938F, "demo_player_switch" },
    { 0xFF873D67, "demo_plplayer_change" },
    { 0x58B2D2BD, "demo_rain_and_village_trigger_overrides" },
    { 0xFDEE0676, "demo_setup" },
    { 0x8D83AE40, "demo_shared" },
    { 0x5CFC08D1, "demo_spectate_monitor" },
    { 0xC5EF503E, "demo_teleport_1" },
    { 0xF402FF1D, "demo_think" },
    { 0xA54C1757, "demo_walkthrough" },
    { 0xF9AE5F2C, "demobookmarkpriority" },
    { 0x44FD963E, "demofixup" },
    { 0xAB963D1C, "demoing" },
    { 0x0A9F7CEE, "demoisanyfreemovecamera" },
    { 0x3DCD1179, "demoisdollycamera" },
    { 0xC4D510F5, "demoiseditcamera" },
    { 0x69E06AE5, "demoismoviecamera" },
    { 0xD6B333A7, "demolition" },
    { 0xA9E30B1E, "demolitions" },
    { 0x0566DF3F, "demolitions_stat" },
    { 0xC5B4310B, "demolocalclients" },
    { 0xE22110B3, "demolockonhighlightdistance" },
    { 0x64733F3A, "demolockonviewheightoffset1" },
    { 0x3E70C4D1, "demolockonviewheightoffset2" },
    { 0x01E07EBA, "demolockonviewpitchmax1" },
    { 0xDBDE0451, "demolockonviewpitchmax2" },
    { 0x166DD634, "demolockonviewpitchmin1" },
    { 0x8875456F, "demolockonviewpitchmin2" },
    { 0x70A19A31, "demonstrate" },
    { 0x08522BE4, "demonstrating" },
    { 0x382A4A2E, "demonstration" },
    { 0x30C04647, "demoonce" },
    { 0xC0CAE934, "demorecord_minplayers" },
    { 0x5BBFF4EF, "demos" },
    { 0x243B5E5D, "demote" },
    { 0xE5F2FA6A, "demoteplayer" },
    { 0xF03D576C, "demothink" },
    { 0x95C676C2, "demotion" },
    { 0x64F0E368, "dempsey" },
    { 0xA1F5EADE, "dempsey_char_index" },
    { 0x36F8CCE5, "dempsey_char_index_r" },
    { 0x34E08484, "dempsey_gersh_vox" },
    { 0x26BF4D6F, "dempsy" },
    { 0x13147717, "deniable" },
    { 0x4C374968, "denial" },
    { 0xCFFDE1FC, "denied" },
    { 0xB11B6669, "denlo" },
    { 0x22E720A6, "denom" },
    { 0x393F6711, "denomvalue" },
    { 0xE08F32D8, "denote" },
    { 0x38E11ECA, "dense" },
    { 0x0C5CCDB3, "density" },
    { 0x848C1752, "dent" },
    { 0x72AC4EA7, "deny" },
    { 0x36EDBECC, "dep" },
    { 0x4C40203B, "depart" },
    { 0x35A58EEA, "depart_door" },
    { 0x315A9503, "depart_early" },
    { 0x52B107EF, "depart_points" },
    { 0xBAD629CA, "depart_station" },
    { 0xACBFAB25, "departing" },
    { 0xF5F396F5, "departing_early" },
    { 0x008471D3, "department" },
    { 0xCA1CDDDA, "departs" },
    { 0x25CAE1DF, "departure" },
    { 0xC04C0C3B, "depend" },
    { 0x859BCEAA, "dependancy" },
    { 0x10B87956, "dependant" },
    { 0x632AC8C9, "dependants" },
    { 0x38AC6EB0, "depended" },
    { 0x3AAAE6CE, "dependencies" },
    { 0x5871055E, "dependency" },
    { 0x610587A1, "dependenent" },
    { 0x6443AFCA, "dependent" },
    { 0x716A084E, "dependin" },
    { 0x0A41CF25, "depending" },
    { 0x78E161DA, "depends" },
    { 0x6FF1B86C, "deplete" },
    { 0xCC8D8100, "depleted" },
    { 0x7F8BAD6C, "deploy" },
    { 0x5E5829EE, "deploy_attempt" },
    { 0x9E07A0EA, "deploy_hud_armed" },
    { 0x27F1D73F, "deploy_hud_deployed" },
    { 0xD4379FA6, "deploy_riotshield" },
    { 0x7DDE423C, "deploy_shield" },
    { 0xA0A5AF99, "deploy_talon_vo" },
    { 0x9C565E69, "deploy_turret" },
    { 0xFB3115B4, "deploy_turret_damage_amt" },
    { 0x50118F30, "deploy_turret_damage_fx" },
    { 0x8295E870, "deploy_turret_damage_states" },
    { 0x4BC7A7B4, "deployable" },
    { 0x7899484B, "deployanim" },
    { 0xC988144F, "deployed" },
    { 0x7240FD17, "deployed_damage_shield" },
    { 0xCC0E0482, "deployed_equipment" },
    { 0x5A237B4F, "deployed_riotshield" },
    { 0x7F964075, "deployed_riotshield_damage_callback" },
    { 0xF055B993, "deployed_set_shield_health" },
    { 0xD3318735, "deployed_time" },
    { 0xF185B9F7, "deployedshieldmodel" },
    { 0x13960675, "deployedunit" },
    { 0xA102B768, "deployempturret" },
    { 0x0D2A3B9C, "deploying" },
    { 0x7148A218, "deployment" },
    { 0xBE995E75, "deployriotshield" },
    { 0xC6232F6F, "deploys" },
    { 0xB0DA8041, "deploysound" },
    { 0xFADBC6DE, "deploysoundplayer" },
    { 0xB75E4051, "deposit" },
    { 0x338B52D4, "deposit_num" },
    { 0x30ABD23C, "deposit_spot" },
    { 0x73BDCB82, "deposit_trig" },
    { 0x30917A8B, "deposit_triggers" },
    { 0xDFCEF88D, "depot" },
    { 0xA15C64A4, "depot_lava_pit" },
    { 0xA5361C00, "depot_lava_seen" },
    { 0x731901E6, "depower_on_disconnect" },
    { 0x31A37AB0, "depowered_count" },
    { 0x084A4F12, "deprecate" },
    { 0x4602A852, "deprecated" },
    { 0x35EC4292, "deprecated_lines" },
    { 0x97893BDC, "deprecatedtraversethink" },
    { 0xFC25FA97, "depreciated" },
    { 0x45E452B9, "depress" },
    { 0x791CD136, "depricated" },
    { 0x4D4EFF70, "dept" },
    { 0x97C3688A, "dept_store_entered" },
    { 0xD20976C0, "dept_target_movement" },
    { 0x9320A378, "depth" },
    { 0xB1375E77, "depth_allow_crouch" },
    { 0xA09C71BD, "depth_allow_prone" },
    { 0xFACF8EE3, "depth_allow_stand" },
    { 0x198680AD, "depth_near" },
    { 0xB3E79E85, "depth_of_field" },
    { 0xDEC357B7, "depth_of_field_off" },
    { 0x0C2696A7, "depth_of_field_old" },
    { 0x030F98D5, "depth_of_field_tween" },
    { 0x1F09C453, "depth_scale" },
    { 0xBC6F37CF, "depth_test" },
    { 0x67645338, "depthdist" },
    { 0x56E96612, "depthinwater" },
    { 0x5AD123A9, "depthoffield" },
    { 0x0BD5BCDE, "depthofplayerinwater" },
    { 0xA6DFB8D3, "depths" },
    { 0xCF753724, "depthtest" },
    { 0x82F2B39E, "der" },
    { 0x51492507, "derailed" },
    { 0xBA04EA11, "deregister_hackable" },
    { 0xFCBE2F17, "deregister_hackable_struct" },
    { 0xCACDB13C, "deregister_revive_override" },
    { 0x0D5B5054, "deregister_zombie_death_event_callback" },
    { 0xAD59D114, "deregistered" },
    { 0x4D330F7F, "derez" },
    { 0x539030FC, "derezzed" },
    { 0x00538838, "derive" },
    { 0x04EFBC01, "derive_damage_refs" },
    { 0x129B726C, "derived" },
    { 0x28EABD38, "derrp" },
    { 0xE7493C8E, "desc" },
    { 0xCAC40345, "descend" },
    { 0x6A0A4D32, "descended" },
    { 0x91D149AC, "descendent" },
    { 0xCAF55CAF, "descendents" },
    { 0x5124D423, "descending" },
    { 0x3E2CFE32, "descendingent" },
    { 0xA5620FD4, "descends" },
    { 0x6A9C5CB5, "descent" },
    { 0x65830F28, "descent_dialog" },
    { 0xC19A156E, "descent_nag" },
    { 0x242A7A86, "descrease" },
    { 0x31B4A366, "describe" },
    { 0x7D17D616, "described" },
    { 0x1F331899, "describes" },
    { 0x14B8B11F, "describing" },
    { 0x9D13DF39, "description" },
    { 0xAA5B9403, "descriptionallies" },
    { 0xDC0AE00A, "descriptionaxis" },
    { 0xAE568570, "descriptions" },
    { 0x5DA78F32, "descriptionstring" },
    { 0xDDDEE59B, "descriptiontextforallies" },
    { 0xCA597192, "descriptiontextforaxis" },
    { 0x73D1AD80, "descriptionvalue" },
    { 0xE4AC08F9, "descriptive" },
    { 0x2E3C0039, "descriptive_text" },
    { 0x5490ADBA, "descriptor" },
    { 0x77E1972B, "descriptor_index" },
    { 0x94854235, "descriptors" },
    { 0xBBA4F633, "descriptorsbylinkname" },
    { 0x7FEB0B79, "descvalue" },
    { 0x3ADED38C, "deselect" },
    { 0x3373E372, "deselect_entity" },
    { 0x61EAA04D, "deselectall" },
    { 0x7BBF838A, "desert" },
    { 0xBA3BDC1D, "deserted" },
    { 0x80B9800A, "deserted_fadein_snapshot" },
    { 0xA4F6F89A, "deserted_flip_over" },
    { 0x59107237, "deserted_sequence" },
    { 0xBABD6EFC, "deserted_start_fade_out" },
    { 0x1608B213, "deserted_truck_kickout_impact" },
    { 0xDC39BE69, "deserted_truck_kickout_impact_player" },
    { 0xF95349EC, "deserted_truck_kickup_dust" },
    { 0xD00AD97B, "deserter_behaviour" },
    { 0x632D075A, "deserters" },
    { 0x24CBFD1A, "desertionfailtrig" },
    { 0xBE3C1C42, "desertionwarntrig" },
    { 0x57CD2855, "deserve" },
    { 0xB3FEACCB, "deserved" },
    { 0x79D980A4, "deserves" },
    { 0x210A2647, "design" },
    { 0x269BE1CD, "designate" },
    { 0x7824D37F, "designate_rival_hero" },
    { 0x3D487373, "designated" },
    { 0xF0003201, "designated_target" },
    { 0x0323474C, "designates" },
    { 0x069C12F2, "designation" },
    { 0xD4C4E67D, "designations" },
    { 0x34F577C7, "designator" },
    { 0x40AB690C, "designed" },
    { 0x54CE1ACA, "designer" },
    { 0xC44A0B05, "designers" },
    { 0xB459FBC5, "desination" },
    { 0xC294FDE0, "desirability" },
    { 0xFFA81F0A, "desirable" },
    { 0x475BB4F2, "desirable_chest_location" },
    { 0x6C9701A7, "desireable" },
    { 0x28A6EF41, "desired" },
    { 0xB6C2AA28, "desired_aim_vel_pitch" },
    { 0xD1DF8F07, "desired_aim_vel_yaw" },
    { 0x35EDC664, "desired_angles" },
    { 0xB24955DD, "desired_anim_pose" },
    { 0x447EEE04, "desired_attribute" },
    { 0xC19C8B2D, "desired_blend" },
    { 0x524487E5, "desired_delete_count" },
    { 0x38A80F43, "desired_forward" },
    { 0xE35CED3B, "desired_fwd_vel" },
    { 0xD7685055, "desired_goalpos" },
    { 0xA7630BB3, "desired_nodes" },
    { 0x77F390F5, "desired_offset" },
    { 0x45E2D162, "desired_origin" },
    { 0x415B6D06, "desired_point" },
    { 0x61C9E75A, "desired_right_vel" },
    { 0x2B028435, "desired_script" },
    { 0xD7A3BFDF, "desired_slow_speed" },
    { 0x5B352ECD, "desired_squads" },
    { 0x297A627C, "desired_stance" },
    { 0xCD36F5C7, "desired_up_vel" },
    { 0x800F96A5, "desired_vel" },
    { 0x29841BB9, "desired_vel_y" },
    { 0x4F869622, "desired_vel_z" },
    { 0x483AA7DE, "desiredangle" },
    { 0x8B8D8741, "desiredangles" },
    { 0xB86E860D, "desiredcornerdirection" },
    { 0x5823CF3A, "desireddeathtime" },
    { 0xBE260A2E, "desireddelay" },
    { 0xCF270141, "desireddelta" },
    { 0x239643AE, "desireddir" },
    { 0x5576066B, "desireddirentity" },
    { 0x6A6E2902, "desireddirentityoffset" },
    { 0x79A313C1, "desireddist" },
    { 0x3AC63317, "desireddistsqrd" },
    { 0x50224406, "desiredendpos" },
    { 0x390946A8, "desiredfacingyaw" },
    { 0xD451C822, "desiredid" },
    { 0xC7AD7D76, "desiredmovement" },
    { 0xD64795B1, "desirednode" },
    { 0x93C233B1, "desiredpos" },
    { 0x7E0E1BFE, "desiredpose" },
    { 0x049A4A48, "desiredposition" },
    { 0x36B8E903, "desiredround" },
    { 0x0B5EE329, "desiredscale" },
    { 0xC7DB1A1B, "desiredspawnposition" },
    { 0x219B6F32, "desiredspeed" },
    { 0xA45DBA2D, "desiredstance" },
    { 0xAD488718, "desiredstepdir" },
    { 0x0FDC7205, "desiredtimeofdeath" },
    { 0xFE97F422, "desiredyaw" },
    { 0x39D558FB, "desiredyawcolor" },
    { 0xA33AE789, "desiredz" },
    { 0xB7356946, "desk" },
    { 0x4035EFA6, "desk_guy" },
    { 0xEC661CA4, "desk_guy02" },
    { 0xD26AD7EE, "desk_guys_logic" },
    { 0x6A635385, "desk_node" },
    { 0x94BD8563, "desk_targetname" },
    { 0xA84BFDF9, "desks" },
    { 0x92C6F95B, "despair" },
    { 0x9C410E30, "desparate" },
    { 0x4E1F827F, "despawning" },
    { 0x6CF6713C, "desperate" },
    { 0xA83065EA, "desstination" },
    { 0xC91531F1, "dest" },
    { 0xF7337D6A, "dest1" },
    { 0xD1310301, "dest2" },
    { 0xFFA2CF65, "dest_angle" },
    { 0x80BC0074, "dest_angles" },
    { 0x84DD6BA9, "dest_array_aft" },
    { 0x7428B2D2, "dest_array_bow" },
    { 0xABF8A878, "dest_barricades" },
    { 0xB488FE39, "dest_barricades_brush" },
    { 0x0D903E6E, "dest_clip" },
    { 0x90A3FE21, "dest_collision_watcher" },
    { 0x13789E51, "dest_debug" },
    { 0xCCE6522F, "dest_jun_sampan_large_d0" },
    { 0xCCBC1CC0, "dest_light" },
    { 0x188B6A48, "dest_locations" },
    { 0x4EFBF2DA, "dest_model_think" },
    { 0x31EDEAF5, "dest_name" },
    { 0x417C3248, "dest_node" },
    { 0xF928AF71, "dest_node_targetname" },
    { 0xB150D763, "dest_nodes" },
    { 0x22284836, "dest_opel_blitz_full" },
    { 0x7E98C9F6, "dest_org" },
    { 0xB9127D72, "dest_origin" },
    { 0x2D4A3B56, "dest_point" },
    { 0x5C9F2EC9, "dest_points" },
    { 0xA2850092, "dest_pos" },
    { 0x9EED0845, "dest_room" },
    { 0xBA7924B7, "dest_struct" },
    { 0x517F7F37, "dest_target_name" },
    { 0x62BCFF91, "dest_test_palm_spawnfrond1" },
    { 0xF45219E2, "dest_trig" },
    { 0x8C85DAA7, "dest_vol" },
    { 0x01D804B8, "dest_z_height" },
    { 0x24363853, "destabalize" },
    { 0x7DB54625, "destabilization" },
    { 0xCC3F4BEF, "destang" },
    { 0x86542251, "destangles" },
    { 0xB4F29E9E, "destdir" },
    { 0x7BDF1958, "destent" },
    { 0xB3B2AB6E, "destfov" },
    { 0xF571697F, "destination" },
    { 0x9B1F1E2D, "destination reached" },
    { 0x68BDA8D7, "destination_name" },
    { 0x4F010B4E, "destination_node" },
    { 0xE6C9F7F1, "destination_nodes" },
    { 0x8E56C1A0, "destination_point" },
    { 0x30E683BC, "destination_pos" },
    { 0x986A3621, "destination_struct" },
    { 0x7BCD5F8D, "destination_target" },
    { 0x5917213F, "destination_vector" },
    { 0x24AD8C72, "destinationname" },
    { 0x84389823, "destinationpoint" },
    { 0x25C54C86, "destinations" },
    { 0x6835E75F, "destinationvec" },
    { 0xDF1F87C9, "destintation reached" },
    { 0x459CCA09, "destiny" },
    { 0x56375830, "destname" },
    { 0xF95CF5A1, "destnode" },
    { 0xE7DD3E5A, "destnode1" },
    { 0xC1DAC3F1, "destnode2" },
    { 0xFC4C6C2F, "destnode_pointer" },
    { 0x1B39AF48, "destnodes" },
    { 0xF8314D45, "destorg" },
    { 0xC7F79C6F, "destorigin" },
    { 0x1BF0DE9B, "destory" },
    { 0x05FD0B10, "destoryed" },
    { 0x2D17BCEA, "destoyed" },
    { 0x48B134A9, "destpoint" },
    { 0xAC823F81, "destpos" },
    { 0x3BA0729A, "destratio" },
    { 0xF4E4938B, "destrcution" },
    { 0xCD1A41D4, "destro" },
    { 0x89CD542D, "destroy" },
    { 0xBDF05599, "destroy_action_prompt_hud" },
    { 0xF21F1057, "destroy_ai_scorestreak_coldblooded" },
    { 0xB58599A9, "destroy_all" },
    { 0xB8474998, "destroy_arch" },
    { 0xDE63BC80, "destroy_arch_upon_death" },
    { 0xD3D0295B, "destroy_armor_icon" },
    { 0x36326D27, "destroy_array" },
    { 0xD874FE4F, "destroy_barge_housing" },
    { 0xF8F52D57, "destroy_barge_turrets" },
    { 0x1A9256C5, "destroy_barricade" },
    { 0xF0985978, "destroy_barricade_thread" },
    { 0x6467C22B, "destroy_begun" },
    { 0x451C48D9, "destroy_billboard" },
    { 0xD6518660, "destroy_buffel" },
    { 0xB92D8C41, "destroy_building1" },
    { 0x2B34FB7C, "destroy_building4" },
    { 0x1CF53D3E, "destroy_bunkers" },
    { 0x386A6D7B, "destroy_chalk_hud" },
    { 0xC383ADA2, "destroy_chase_truck" },
    { 0x12B4FFC8, "destroy_chase_truck_end" },
    { 0x183979FE, "destroy_chunks" },
    { 0x9CC6ABE5, "destroy_container" },
    { 0xDDE749CF, "destroy_corpses" },
    { 0xAEA1262F, "destroy_debug_hud_elemets" },
    { 0xC3E06ABD, "destroy_delay" },
    { 0x83D6585C, "destroy_dev_info" },
    { 0x67FDE52F, "destroy_domination_info" },
    { 0xC2703FC3, "destroy_driveby_truck" },
    { 0xED04A3E5, "destroy_drone_" },
    { 0x7D23E086, "destroy_drone_1" },
    { 0x605DE203, "destroy_emergence_holes" },
    { 0x4A577D17, "destroy_enemy_targets" },
    { 0xC5341E6F, "destroy_ent" },
    { 0xFBBDD488, "destroy_equipment" },
    { 0x352342D5, "destroy_equipment_turret" },
    { 0x5FCBF3BC, "destroy_fn" },
    { 0x7671552A, "destroy_friendly_by_heli" },
    { 0x35683960, "destroy_gas_station_tanker" },
    { 0x38DD8248, "destroy_geo_piece" },
    { 0xD6F2325A, "destroy_gravity_trap_spikes_in_ground" },
    { 0x212A918E, "destroy_greandes_in_trigger" },
    { 0x9A8D1FD9, "destroy_ground_spikes" },
    { 0xB48769AE, "destroy_gun" },
    { 0xF933F9B6, "destroy_heli_by_friendly" },
    { 0x32007D33, "destroy_heli_using_bullets" },
    { 0x7B486A03, "destroy_helicopter_markers" },
    { 0xA001BA86, "destroy_hq_roof" },
    { 0xEF76706B, "destroy_hud" },
    { 0xA5E7951F, "destroy_hud_elem" },
    { 0x255B709E, "destroy_hud_elem_on_death" },
    { 0xA91DC551, "destroy_hud_elements" },
    { 0x2B043152, "destroy_immediately" },
    { 0x618A151D, "destroy_item" },
    { 0xF7AAEC44, "destroy_launchpad_chopper" },
    { 0x1F8B4593, "destroy_launchpad_chopper_hitground" },
    { 0x48BCBBA4, "destroy_maze_fountain" },
    { 0xDDF5AEA2, "destroy_me" },
    { 0x87EE885E, "destroy_me_on_player_notify" },
    { 0x91F0B9D0, "destroy_mg" },
    { 0x0B8F85D2, "destroy_missile_hud" },
    { 0xC5A39495, "destroy_object" },
    { 0x24971AB5, "destroy_octobomb" },
    { 0x31FBB3FD, "destroy_on_notify" },
    { 0xAB4386B6, "destroy_only" },
    { 0xAC0A0506, "destroy_other_teams_supplemental_watcher_objects" },
    { 0x41A5DA07, "destroy_overlay_on_death" },
    { 0xCC632DAC, "destroy_overlay_on_missile_done" },
    { 0x4A7D6482, "destroy_overlays_on_owner_disconnect" },
    { 0xB06C7F77, "destroy_palm_tree2" },
    { 0x3CFEA2D7, "destroy_palmtree2a" },
    { 0xCAF7339C, "destroy_palmtree2b" },
    { 0xEA1C8085, "destroy_parking_lot_vehicles_before_parking_lot_on_veteran" },
    { 0xE3D84E4E, "destroy_piece" },
    { 0x95014AE8, "destroy_placed_subwoofer" },
    { 0xF10841FF, "destroy_placed_turbine" },
    { 0xC2CFDCA6, "destroy_plane" },
    { 0x52F0C27C, "destroy_pooled_items" },
    { 0xBEA48276, "destroy_popup" },
    { 0x948159D8, "destroy_progress_info" },
    { 0x05D5C125, "destroy_prompt_on_open" },
    { 0xED42B2B4, "destroy_rear_crane" },
    { 0xB2B6D440, "destroy_remote_hud" },
    { 0x5E785FEF, "destroy_revive_progress" },
    { 0x50B93B0F, "destroy_revive_progress_on_downed" },
    { 0x5427F8E1, "destroy_riotshield" },
    { 0x372BFEB0, "destroy_rocket_target" },
    { 0x39F68866, "destroy_roof_on_helicopter_crash" },
    { 0xA9E02A3E, "destroy_sdks_to_win" },
    { 0x8A453ED4, "destroy_siegebot" },
    { 0xC0C86EA2, "destroy_slowly" },
    { 0xC6F7F701, "destroy_spin_models" },
    { 0x97586346, "destroy_stuck_weapons" },
    { 0xB40BF836, "destroy_supplemental_watcher_objects" },
    { 0xEFB0F9A4, "destroy_supply_crates" },
    { 0x618F5B49, "destroy_tactical_insertion" },
    { 0xCBCCEB40, "destroy_tactical_insertions" },
    { 0x0D9C769B, "destroy_team" },
    { 0xF33FDF22, "destroy_time_bomb_save" },
    { 0xFA723FE9, "destroy_time_bomb_save_if_user_bleeds_out_or_disconnects" },
    { 0x85578855, "destroy_timer_hud" },
    { 0x3A43578E, "destroy_turret" },
    { 0xAF8EF4AC, "destroy_tutorial_hud" },
    { 0xC8E1BD82, "destroy_tutorial_message" },
    { 0x10C561E2, "destroy_tweak_hud_elements" },
    { 0x131C3C10, "destroy_vehicle" },
    { 0xDB52ED3A, "destroy_vehicles_disconnect_nodes" },
    { 0x24C9C57A, "destroy_warning_elem" },
    { 0x81474D92, "destroy_warning_elem_when_hit_again" },
    { 0xF4820EFA, "destroy_warning_elem_when_mission_failed" },
    { 0xCE1E5936, "destroy_weapon_in_blackout" },
    { 0x3BE8C6FD, "destroy_weapon_on_disconnect" },
    { 0xF71CAB6A, "destroy_when_movie_is_stopped" },
    { 0x4FCD0611, "destroy_window_by_melee" },
    { 0xF4CAF688, "destroy_window_by_torpedo" },
    { 0xB8CBD3A3, "destroyablebytrophysystem" },
    { 0xC61312F0, "destroyactivevehicles" },
    { 0xB6AC9C42, "destroyallraps" },
    { 0xD859A3F4, "destroycorpses" },
    { 0xEBEC17C9, "destroycounteruav" },
    { 0x31A2EA04, "destroycounteruavbyemp" },
    { 0xD5190D67, "destroydecoy" },
    { 0xC39989E1, "destroydish" },
    { 0xD04637C1, "destroydroneplane" },
    { 0xDFD493A9, "destroydummyvehcile" },
    { 0x9F826871, "destroydummyvehicle" },
    { 0x804944DA, "destroyed" },
    { 0x47F9982A, "destroyed_afterwards" },
    { 0x131E0584, "destroyed_balcony_models" },
    { 0xBBC3D0FE, "destroyed_both_88s" },
    { 0x18ED71E4, "destroyed_callback" },
    { 0x473378D9, "destroyed_car" },
    { 0x11819CA2, "destroyed_cb" },
    { 0x782F312D, "destroyed_comms_fx" },
    { 0xB23ABB3D, "destroyed_comms_sparks" },
    { 0xDBAE2C50, "destroyed_complete" },
    { 0x44714B46, "destroyed_exploder" },
    { 0xB4D2AB7E, "destroyed_explosive" },
    { 0x8D89E948, "destroyed_first_88" },
    { 0x79007E3E, "destroyed_helicopter" },
    { 0x5D7053AC, "destroyed_last_88" },
    { 0xE0ADF7D0, "destroyed_model" },
    { 0x74A78B1F, "destroyed_noriegas_jet" },
    { 0x0677ABC9, "destroyed_piece" },
    { 0xE583A4C0, "destroyed_pieces" },
    { 0xD03EFC24, "destroyed_second_88" },
    { 0x7D5DF5A3, "destroyed_second_last_88" },
    { 0x605C4DE9, "destroyed_spyplane" },
    { 0x9394096E, "destroyed_team" },
    { 0x1526F0D7, "destroyed_thrasher_head" },
    { 0xD997A493, "destroyed_vehicle" },
    { 0xA61BC6BC, "destroyedaircraft" },
    { 0x4DBD0E2F, "destroyedaircrafttime" },
    { 0xF462CDDE, "destroyedbuilding" },
    { 0x911D0D35, "destroyedby" },
    { 0x4C2B2AD9, "destroyedbyemp" },
    { 0xCF52F049, "destroyedcopter" },
    { 0xAF7A76C2, "destroyedequipment" },
    { 0x9FFCCF72, "destroyedequiptment" },
    { 0x094D41F7, "destroyedexplosive" },
    { 0xCD6A83B1, "destroyedhelicopter" },
    { 0x780DAFB8, "destroyedkillstreak" },
    { 0x9E1DE6C1, "destroyedobj" },
    { 0x0DE83641, "destroyedplayercontrolledaircraft" },
    { 0x2595D5BB, "destroyedqrdrone" },
    { 0x16FF5F39, "destroyedsentryturret" },
    { 0xF87D4480, "destroyedspores" },
    { 0xE22FBC66, "destroyedtacticalinsert" },
    { 0xA20DAB88, "destroyedturret" },
    { 0x9C3ABBF4, "destroyelem" },
    { 0x9036A554, "destroyent" },
    { 0x39A181B4, "destroyentities" },
    { 0x6A501184, "destroyentityheadicons" },
    { 0x0F292C33, "destroyequipment" },
    { 0x2C75E03C, "destroyer" },
    { 0xADEA79E7, "destroyer1_alarm" },
    { 0xF404C874, "destroyer2_alarm" },
    { 0xFA132699, "destroyer3_alarm" },
    { 0x629AC12F, "destroyerhelicopter" },
    { 0xA44F1CB0, "destroyerhelicopterplayer" },
    { 0xBE5E59BF, "destroyerm220tow" },
    { 0x3ACC12E1, "destroyerrcbomb" },
    { 0x8B2079FF, "destroyers" },
    { 0x9F43DC5A, "destroyerturret" },
    { 0x9D7A53A0, "destroyeruav" },
    { 0x52785AA5, "destroyes" },
    { 0x77CEF287, "destroyfunc" },
    { 0xD5DED6F9, "destroyglintfx" },
    { 0x5EA271BF, "destroygrenadetimers" },
    { 0xBAD584D0, "destroyheadcb" },
    { 0xCE6727F1, "destroyheadchopperonplantedblockeropen" },
    { 0x077A5BDE, "destroyheadchopperonplantedentitydeath" },
    { 0xC2611DBC, "destroyheadchopperstouching" },
    { 0x497E5092, "destroyheadiconsondeath" },
    { 0xE4597740, "destroyheadiconsondeath_singleton" },
    { 0xB75A45FC, "destroyhealthdebug" },
    { 0xBB89DE1A, "destroyhelicopter" },
    { 0x0F598B8A, "destroyhint" },
    { 0x2F09BDC5, "destroyhints" },
    { 0x534CFAAD, "destroyhqaftertime" },
    { 0x151EE984, "destroyhud" },
    { 0x6D358955, "destroyhudelem" },
    { 0x22FA2DBB, "destroying" },
    { 0x5D32FA1A, "destroying_window" },
    { 0x4898B42F, "destroyingweapon" },
    { 0xB88FE190, "destroyitemelems" },
    { 0x9051130D, "destroykillstreaktimers" },
    { 0x7E6838E7, "destroylockoncanceledmessage" },
    { 0x87C85FDD, "destroymissileoutofbounds" },
    { 0x4B8B0719, "destroyneutralgameplayvehicles" },
    { 0x90C432BD, "destroynonairscorestreak_poststatslock" },
    { 0x2598E234, "destroyobject" },
    { 0xFD8A3138, "destroyondeath" },
    { 0x6AF90814, "destroyotherteamsactivevehicles" },
    { 0xA9C66247, "destroyotherteamsequipment" },
    { 0x95456371, "destroyplayerhelicopter" },
    { 0xAF360A70, "destroypower" },
    { 0xEF81FD44, "destroyrcbomb" },
    { 0x303C3635, "destroyremotecontrolactionprompthud" },
    { 0xC8543C8A, "destroyremotehud" },
    { 0x095BBA2C, "destroys" },
    { 0x653825E5, "destroysafezoneaftertime" },
    { 0x7EA6B1CC, "destroysatellite" },
    { 0xD6C6626B, "destroysatellitebyemp" },
    { 0x9E382D0E, "destroyscoreeventgiven" },
    { 0x046D75F7, "destroyscorestreak" },
    { 0x26A5AF4C, "destroysequipment" },
    { 0x7F83E63F, "destroyslowly" },
    { 0xC44A006D, "destroystartmsghud" },
    { 0x29ABE150, "destroytacticalinsertions" },
    { 0xDAE2A98F, "destroytag" },
    { 0x523758A7, "destroyteammessage" },
    { 0xF6275FCA, "destroytime" },
    { 0xEF5F78E4, "destroytower" },
    { 0xE9E95D2B, "destroyturret" },
    { 0xE58EB1B3, "destroyuav" },
    { 0xD66E4079, "destroyweakpointwidget" },
    { 0xA0D97B77, "destruct" },
    { 0xC6E96FE5, "destruct_clientfield" },
    { 0x868A96E0, "destruct_clientfield_bits" },
    { 0x4582C3C0, "destruct_clientfield_type" },
    { 0x614E35A8, "destruct_flag" },
    { 0x77C5FA16, "destruct_max_pieces" },
    { 0x618CE4B0, "destruct_piece_number" },
    { 0xFCF255B1, "destruct_state" },
    { 0x23C3EC60, "destruct_toggle_gib_model_flag" },
    { 0x9266A159, "destruct_undamaged_flag" },
    { 0x0C5BFC57, "destructable" },
    { 0x8DEBA6C4, "destructable_destruct" },
    { 0x00467FAE, "destructable_index" },
    { 0x78C3856E, "destructable_think" },
    { 0x3A8D0C91, "destructablefx" },
    { 0x1247AB0E, "destructables" },
    { 0xF3534C3C, "destructed" },
    { 0xC8C4714F, "destructible" },
    { 0x26F169C5, "destructible_anim" },
    { 0x40DA6B54, "destructible_anims" },
    { 0x0F517D9E, "destructible_assistance" },
    { 0x4769DBB8, "destructible_barrel_death_think" },
    { 0xCA75A586, "destructible_barrel_explosion" },
    { 0x07938640, "destructible_barrel_fire_think" },
    { 0xAAF711ED, "destructible_base_piece_death" },
    { 0x46D1A59E, "destructible_building" },
    { 0xDC95F9CB, "destructible_building_behavior" },
    { 0xBE22B863, "destructible_building_trigger" },
    { 0x38953052, "destructible_building_triggers" },
    { 0xE7484C42, "destructible_callbacks" },
    { 0x5EE8D628, "destructible_car_animate" },
    { 0xFA841913, "destructible_car_anims" },
    { 0x491EB7F1, "destructible_car_death_notify" },
    { 0xFD20C396, "destructible_car_death_think" },
    { 0x7CABC668, "destructible_car_explosion" },
    { 0xD3948EF0, "destructible_car_explosion_animate" },
    { 0x1A832562, "destructible_car_fire_think" },
    { 0xE81733F0, "destructible_car_grenade_stuck_explode" },
    { 0x0AD7669B, "destructible_car_grenade_stuck_think" },
    { 0x88E15D17, "destructible_car_hacked_c4" },
    { 0x7FB51864, "destructible_car_lights" },
    { 0x660134B8, "destructible_ceiling_fan_think" },
    { 0x87344F6B, "destructible_character" },
    { 0xA160097D, "destructible_clientfield" },
    { 0x0CE07273, "destructible_clientfield_num_bits" },
    { 0x1C59A630, "destructible_cover_geo_think" },
    { 0x71DAFC5E, "destructible_cover_think" },
    { 0x2E8B792E, "destructible_create" },
    { 0x1A0D1662, "destructible_crumble" },
    { 0x17153226, "destructible_damage_logic" },
    { 0xD6510678, "destructible_damage_thread_running" },
    { 0xC0F5C302, "destructible_death_radiusdamage" },
    { 0x2D75EC4F, "destructible_def" },
    { 0xE52E8716, "destructible_defs" },
    { 0xBE8B9566, "destructible_disable_explosion" },
    { 0x3B61C982, "destructible_equipment" },
    { 0xDDAEAC8D, "destructible_equipment_list_add" },
    { 0x272AF104, "destructible_equipment_list_check" },
    { 0x3E24751E, "destructible_event" },
    { 0x02956828, "destructible_event_callback" },
    { 0xACEE6FD9, "destructible_explode" },
    { 0xE812CF73, "destructible_force_explosion" },
    { 0x733AE570, "destructible_fx" },
    { 0x6197B12A, "destructible_glass_barricade" },
    { 0xCE7E19C2, "destructible_healthdrain" },
    { 0x4577895A, "destructible_info" },
    { 0xFE341BAC, "destructible_init" },
    { 0x7F932DB5, "destructible_jeeps" },
    { 0xA46E2706, "destructible_killspawner" },
    { 0xD661FEB9, "destructible_lights" },
    { 0x2882740E, "destructible_loopfx" },
    { 0x052B77C1, "destructible_loopsound" },
    { 0x55CD9D91, "destructible_model" },
    { 0x18AE6255, "destructible_part" },
    { 0x1C67CEA4, "destructible_parts" },
    { 0xF1B71C55, "destructible_physics" },
    { 0xB3806D14, "destructible_pointers" },
    { 0x16F38BD2, "destructible_pointers_inited" },
    { 0x459C340F, "destructible_radio" },
    { 0x471AE4AC, "destructible_radio_loop" },
    { 0xFEC4C1A9, "destructible_record_initial_values" },
    { 0x371EC019, "destructible_recycle_spawn" },
    { 0xE15F9A07, "destructible_sound" },
    { 0x0EDFF28D, "destructible_speaker" },
    { 0xF28D042D, "destructible_speakers_init" },
    { 0x1A921B29, "destructible_splash_damage" },
    { 0xF0F57279, "destructible_state" },
    { 0x3D8AC1CA, "destructible_tank_grenade_stuck_explode" },
    { 0xF2576089, "destructible_tank_grenade_stuck_think" },
    { 0x1CE1AEA5, "destructible_tank_hacked_c4" },
    { 0x91E88D76, "destructible_think" },
    { 0x946575FE, "destructible_thread" },
    { 0x807B5FFB, "destructible_trigs" },
    { 0x92DFF85A, "destructible_type" },
    { 0x3AFC5847, "destructible_update_part" },
    { 0xF8EF752D, "destructible_vehicle_damage_to_death" },
    { 0x139A3F33, "destructible_vehicle_play_explosion_sound" },
    { 0x675DBCA3, "destructiblecar" },
    { 0x7B6755F4, "destructibledef" },
    { 0x11299FE1, "destructibleindex" },
    { 0x2ED7264F, "destructibleparts" },
    { 0x61C9E616, "destructibles" },
    { 0xCE2EC4F0, "destructibles_in_area" },
    { 0xFCC8A573, "destructibles_think" },
    { 0x1C34E3D5, "destructiblespawnedents" },
    { 0x3D78C416, "destructiblespawnedentslimit" },
    { 0x8689D147, "destructibletype" },
    { 0xD6A99E2F, "destruction" },
    { 0x6BF3988A, "destruction_watcher" },
    { 0x3DD4F2FD, "destruction_yay" },
    { 0xA0F0F076, "destructions" },
    { 0x56240B03, "destructive" },
    { 0x6280CB37, "destructleftarmpieces" },
    { 0x2EE2085D, "destructleftlegpieces" },
    { 0xE6D09004, "destructnumberrandompieces" },
    { 0xBE3B22D7, "destructpiece" },
    { 0x3082AC0F, "destructrandompieces" },
    { 0x64D5AF6E, "destructrightarmpieces" },
    { 0xA6B12E94, "destructrightlegpieces" },
    { 0x1DB74D15, "destructserverutils" },
    { 0x95F2A159, "destscale" },
    { 0xBFC0D62D, "destsroyed" },
    { 0x030532B7, "destuctableinfo" },
    { 0x545AC7A6, "destuctibles" },
    { 0x286FD49F, "destuction" },
    { 0x3C3E5540, "destvar" },
    { 0xE9145332, "destyaw" },
    { 0x355681F4, "desynched" },
    { 0xF09562B0, "desynched_time" },
    { 0x9EE3D528, "det" },
    { 0xCB3BF380, "detach" },
    { 0xB3F58079, "detach_after_anim" },
    { 0x4AA90456, "detach_all_weapons" },
    { 0xDAA389B0, "detach_boiler" },
    { 0xA6793E71, "detach_briefcase" },
    { 0x4243B4B4, "detach_carry_object_model" },
    { 0x1F428A2B, "detach_chair1" },
    { 0x786922B0, "detach_chair1_death" },
    { 0xAD3B1AF0, "detach_chair2" },
    { 0x6380325F, "detach_chair2_death" },
    { 0x5465314E, "detach_cig" },
    { 0x9E743D91, "detach_flashlight" },
    { 0xEB953D74, "detach_flashlight_on_death" },
    { 0x2657E61E, "detach_flashlight_onspotted" },
    { 0xB5D21688, "detach_from_bus" },
    { 0x369480B7, "detach_from_path" },
    { 0xC3760EC6, "detach_getoutrigs" },
    { 0x02C20883, "detach_mask" },
    { 0x0D5D3F06, "detach_model" },
    { 0x16B463CC, "detach_models_with_substr" },
    { 0x9847C7B3, "detach_molotov" },
    { 0xDD1F2147, "detach_on_window" },
    { 0x1F32F94A, "detach_path" },
    { 0x2D2FED95, "detach_phone" },
    { 0x01EF63BA, "detach_player_clip_to_pbr" },
    { 0x914C02AB, "detach_shell" },
    { 0x1FB96528, "detach_spraycan" },
    { 0x35508063, "detach_tank" },
    { 0xC59AE55B, "detach_torch" },
    { 0x9688E0CB, "detach_weapon" },
    { 0xD00FCD18, "detachable" },
    { 0xE40DB749, "detachall" },
    { 0xB3FB7C8C, "detachall_on_death" },
    { 0x8C77A8B8, "detachallplayersfromclinging" },
    { 0x2D5D672B, "detachallweaponmodels" },
    { 0x459078F3, "detachcarryobjectmodel" },
    { 0xA3B843C6, "detachdec20terminal" },
    { 0xCCAECB13, "detached" },
    { 0x92899EEC, "detaches" },
    { 0xF267A4F6, "detachflag" },
    { 0x1A5331EA, "detachflamethrowertank" },
    { 0x9B337E4F, "detachfrombusonevent" },
    { 0x382ADEA8, "detachgrenadeonscriptchange" },
    { 0x7CF80B98, "detaching" },
    { 0xCE08121C, "detachment" },
    { 0x22159A2A, "detachmodelname" },
    { 0x435E0187, "detachmortar" },
    { 0xA3E4D4FE, "detachmortarondeath" },
    { 0xF2FE79AA, "detachshieldmodel" },
    { 0x5B24666B, "detachusemodels" },
    { 0xD983BF7C, "detachweapon" },
    { 0x19F17CAA, "detail" },
    { 0xACC4E709, "detail_level" },
    { 0x734C6C3D, "detailed" },
    { 0x7A5E8465, "details" },
    { 0xCDEC87D8, "detain" },
    { 0xD6465362, "detatch" },
    { 0x7728EF7B, "detatch_f38_parts" },
    { 0xCF403A0A, "detclacker_disarm" },
    { 0x28E14F8C, "detcord" },
    { 0x6C57B517, "detcord_logic" },
    { 0x8751F120, "detec_len" },
    { 0x57B6A1F8, "detect" },
    { 0xDC303BDA, "detect_and_change_music_states" },
    { 0x4B113A49, "detect_back_mask" },
    { 0x189B963B, "detect_dist" },
    { 0xD67C170D, "detect_dist_squared" },
    { 0x6A88BC01, "detect_distsqrd" },
    { 0x1AFBDDD3, "detect_early_death" },
    { 0x10E7D150, "detect_flashlight_on_off_button" },
    { 0xD201F243, "detect_flashlight_weapon_switch" },
    { 0xD180539D, "detect_friendly_fire" },
    { 0xF1E198BC, "detect_friendly_fire_fail" },
    { 0x6F56FCFB, "detect_front_mask" },
    { 0xB72C80CA, "detect_if_player_sticks_around" },
    { 0x22432AE6, "detect_indicator_appear_delay" },
    { 0xC32A66F7, "detect_indicator_lost_delay" },
    { 0x68AC2397, "detect_jeep_deaths" },
    { 0x77F9F523, "detect_left_mask" },
    { 0xB773C5D9, "detect_lose_radius" },
    { 0x07A79732, "detect_lose_radius_near" },
    { 0x621BC013, "detect_lose_z_threshold" },
    { 0x6879AA4B, "detect_nearby_enemies_wait_time" },
    { 0x7859F36A, "detect_player_alerted_vc" },
    { 0x48D7DD42, "detect_player_attacker" },
    { 0xAA55D1D2, "detect_player_behind_mg" },
    { 0x01675C70, "detect_player_hitting_gunner" },
    { 0xF06398CE, "detect_player_in_water" },
    { 0x34ED131A, "detect_player_mantle" },
    { 0x8C5794CB, "detect_player_melee_hammock_button" },
    { 0x89B959E5, "detect_player_melee_sampan_button" },
    { 0x3C6914FA, "detect_player_on_rooftop" },
    { 0x4DB5333C, "detect_player_use_shelf_trigger" },
    { 0xAEC92059, "detect_radius" },
    { 0x234506B2, "detect_radius_near" },
    { 0xDEDAE346, "detect_range" },
    { 0x57226A0E, "detect_recent_flashed" },
    { 0x344D84EA, "detect_right_mask" },
    { 0x42E56113, "detect_squad" },
    { 0x70778B48, "detect_trigger_and_cough" },
    { 0x7DB92F93, "detect_z_threshold" },
    { 0xE91CD020, "detectable" },
    { 0x56A5EC0B, "detected" },
    { 0x737F5A16, "detected_farid" },
    { 0x6CF33DDD, "detected_loop_alias" },
    { 0x8695A929, "detectentities" },
    { 0xF5E4778C, "detectexplosives" },
    { 0xE84C6727, "detectfriendlyfireonentity" },
    { 0xA10094D9, "detecticonwaiter" },
    { 0x134ABD8F, "detectid" },
    { 0x9DED2A60, "detecting" },
    { 0xCB4ADFAA, "detection" },
    { 0xEA3ECA50, "detection_blocker_cleanup" },
    { 0x66867FE0, "detection_complete" },
    { 0x7CC7CF9A, "detection_event_drone_pathing" },
    { 0x4E373FD8, "detection_fail_think" },
    { 0x4A3B3209, "detection_level" },
    { 0xEA823068, "detection_range" },
    { 0x785EE496, "detection_spotlight_think" },
    { 0xE003035C, "detection_state" },
    { 0x249278C4, "detection_tarp_blocker_think" },
    { 0xF5E78358, "detectionconeangle" },
    { 0x57EA46BB, "detectioncycletime" },
    { 0x9B05884F, "detectiondot" },
    { 0xEB2C7DDD, "detectiongraceperiod" },
    { 0xAA62C6AA, "detectionmindist" },
    { 0xCFB8E23C, "detectionrefreshtime" },
    { 0xBD0EB850, "detectionvolume" },
    { 0xA0D5A30F, "detector" },
    { 0xEE718F9A, "detector_brush" },
    { 0x46186BD6, "detectors" },
    { 0x023EC612, "detectreviveiconwaiter" },
    { 0x9EFF5C53, "detects" },
    { 0x16FA3C12, "detectshieldmodel" },
    { 0x9A98F083, "detectteam" },
    { 0x1558AA2E, "detents" },
    { 0xCB454195, "determains" },
    { 0xA630F74B, "determin" },
    { 0xBCBCB2F6, "determination" },
    { 0x1B2ED2EC, "determine" },
    { 0x41DD9AAF, "determine_closest_node" },
    { 0x4AB7B64D, "determine_convoy_spawn_points" },
    { 0x47C43C40, "determine_deathtoll" },
    { 0xC931A9EC, "determine_fallback_weapon" },
    { 0x6F04E424, "determine_launch_vector" },
    { 0x725AB30F, "determine_top_earners" },
    { 0xA33AC034, "determine_winnings" },
    { 0x703557EC, "determinebestattackpos" },
    { 0x8829417D, "determinebestent" },
    { 0xAD240818, "determinebestpos" },
    { 0xDDBE3880, "determined" },
    { 0x9EBB8278, "determineexposedapproachtype" },
    { 0x04F7F95D, "determinegroundpoint" },
    { 0xCD0C0BCC, "determinenodeapproachtype" },
    { 0x6209A1C8, "determinenodeexittype" },
    { 0x47F737EF, "determines" },
    { 0x6070197B, "determinetargetpoint" },
    { 0xF2724C55, "determineteamwinnerbygamestat" },
    { 0x776DDB14, "determineteamwinnerbyteamscore" },
    { 0x9DF6BFF1, "determinetopearners" },
    { 0x7EE71215, "determinewagerwinnings" },
    { 0x96257F61, "determinewinner" },
    { 0x9BF5CC95, "determining" },
    { 0x30863B6C, "detete" },
    { 0xDE6CB952, "detfx" },
    { 0xE8B55D4A, "dethrone" },
    { 0x030E86A9, "detmarkers" },
    { 0xC1EAF281, "detonate" },
    { 0x19B19AB4, "detonate_bomb" },
    { 0x9016B5C9, "detonate_c4_when_dead" },
    { 0xCBD87296, "detonate_car" },
    { 0xC2B04EF8, "detonate_car_setup" },
    { 0x2CD3213B, "detonate_damage_monitored" },
    { 0x28F7B846, "detonate_point" },
    { 0x9C381AF4, "detonate_sides" },
    { 0x91A6F4BB, "detonate_sides_disabled" },
    { 0x9A73585E, "detonate_time_bomb" },
    { 0x24023A3C, "detonate_weapon_object_array" },
    { 0xF9782F33, "detonatealliftouchingsphere" },
    { 0x9ED39217, "detonated" },
    { 0x0DCA9C3C, "detonateheight" },
    { 0xDC38659C, "detonateiftouchingsphere" },
    { 0xDE7469BB, "detonateradius" },
    { 0x349A92A8, "detonates" },
    { 0xE869A457, "detonatestationary" },
    { 0xEF331BD6, "detonatetime" },
    { 0x38199EBB, "detonateviaemp" },
    { 0x67B65207, "detonateweaponobjectarray" },
    { 0xE2DF025B, "detonatewhenstationary" },
    { 0xE2E05034, "detonating" },
    { 0x9219D43E, "detonation" },
    { 0xD0034C58, "detonation_distance" },
    { 0x816CDC7B, "detonation_distance_sq" },
    { 0xABCFDB4D, "detonation_monitor" },
    { 0xEF6305B7, "detonationdelay" },
    { 0xB7BC3121, "detonations" },
    { 0xE0666173, "detonationsound" },
    { 0xB8EF75D3, "detonator" },
    { 0xB4CC5EF8, "detonator_obj_0" },
    { 0xDACED961, "detonator_obj_1" },
    { 0x43C6DC92, "detonator_think" },
    { 0xB9D14F02, "detonators" },
    { 0xEFC09F42, "detour" },
    { 0x5B1AE47F, "detour_flag" },
    { 0x304F7255, "detoured" },
    { 0x6C2D40AE, "detouring" },
    { 0x5D24996B, "detouringpath" },
    { 0x2C0AA3E6, "detournode" },
    { 0xEC9EEAE7, "detourpath" },
    { 0xE722AC8D, "detours" },
    { 0x1992AB9B, "detpack" },
    { 0xCDB66BE2, "detpack_about_to_blow" },
    { 0x84E62ACE, "detpack_detonated" },
    { 0x67A6BA68, "detpack_explo_metal" },
    { 0x7666BF44, "detpack_explo_wood" },
    { 0x51E00FF9, "detpack_rush_flare" },
    { 0xE26FABBA, "detpacks" },
    { 0xE8B3AD91, "detpackstunradius" },
    { 0x7F031EA3, "detroyscoreeventgiven" },
    { 0x0D69F8E6, "detructible" },
    { 0xD8839855, "detsound" },
    { 0xD884B40F, "dettachplayerfrombus" },
    { 0xEAE8C9FA, "dev" },
    { 0xDACC02EC, "dev_add_camera_settings" },
    { 0xC3A3DB2E, "dev_animtest" },
    { 0xE6087C12, "dev_cac_camera" },
    { 0x785FE0A2, "dev_cac_camera_on" },
    { 0x09316032, "dev_cac_cycle_body" },
    { 0x6F55C64F, "dev_cac_cycle_character" },
    { 0x38202D21, "dev_cac_cycle_hat" },
    { 0xED0150A4, "dev_cac_cycle_head" },
    { 0x76986D21, "dev_cac_cycle_player" },
    { 0x110D170D, "dev_cac_cycle_render_options" },
    { 0xC3E77685, "dev_cac_dpad_think" },
    { 0xC34E1D63, "dev_cac_gdt_update_think" },
    { 0x1C057B11, "dev_cac_init" },
    { 0x878A4A51, "dev_cac_overlay" },
    { 0x593BB238, "dev_cac_overlay_create" },
    { 0x69269D1A, "dev_cac_overlay_destroy" },
    { 0xD3646F84, "dev_cac_overlay_think" },
    { 0x46C49047, "dev_cac_overlay_update" },
    { 0x55774F38, "dev_cac_player" },
    { 0x38710113, "dev_cac_player_valid" },
    { 0x690B8D4D, "dev_cac_set_model_range" },
    { 0x847A07B5, "dev_cac_set_player_model" },
    { 0x3C73629F, "dev_class" },
    { 0xB317C5CB, "dev_drones_ambience" },
    { 0xDFD134B8, "dev_ending" },
    { 0xAD281DE7, "dev_equipment" },
    { 0xCF8658AC, "dev_freeroam" },
    { 0xAB832B3D, "dev_freeroam_exterior" },
    { 0xACC998CB, "dev_freeroam_interior" },
    { 0x47561D0C, "dev_freeroam_main" },
    { 0xFE53BFD5, "dev_get_node_pair" },
    { 0xD1C383D9, "dev_grenade" },
    { 0x451F15F2, "dev_gui" },
    { 0x3E07336C, "dev_gui_supply_drop" },
    { 0x69EFA674, "dev_halltest" },
    { 0x969A2E4C, "dev_last_stand" },
    { 0x24DDAC78, "dev_print_camera_settings" },
    { 0x1DB5C39D, "dev_print_flashlight_settings" },
    { 0xE4E4789E, "dev_shared" },
    { 0x7249A9AA, "dev_skip_boat_drag" },
    { 0x34F3CA97, "dev_skipto_drones" },
    { 0x828B3023, "dev_skipto_ending" },
    { 0xEDEE8072, "dev_skipto_warning" },
    { 0xB056E3D2, "dev_takeoff_rocket" },
    { 0xE07D5817, "dev_water_rush" },
    { 0x1D04F5A7, "devadd" },
    { 0xA03B7FFB, "devaddpitch" },
    { 0xCEA0C5B2, "devaddroll" },
    { 0x57C3CB00, "devaddyaw" },
    { 0x9723FF3A, "devastated" },
    { 0xD1B63DC1, "devblock" },
    { 0xB784CFAE, "devblocked" },
    { 0x7A39B03A, "devcheater" },
    { 0xD5C053C1, "devdvar" },
    { 0x0AFA3EF8, "develop" },
    { 0x5033510B, "developed" },
    { 0x3C109F4D, "developer" },
    { 0x01D10DF4, "development" },
    { 0xF99173D5, "devfreeroam_main" },
    { 0xE462855B, "devgui" },
    { 0xE27A8138, "devgui_add_ability" },
    { 0xA586D886, "devgui_add_weapon" },
    { 0x1567189B, "devgui_add_weapon_and_attachments" },
    { 0x17589213, "devgui_add_weapon_entry" },
    { 0x4FB8BDAB, "devgui_all_spawn" },
    { 0x10834033, "devgui_award_challenge" },
    { 0xED94FCF9, "devgui_bot_spawn" },
    { 0x84CA773C, "devgui_bot_spawn_think" },
    { 0x3826985B, "devgui_break" },
    { 0x0D87BD0A, "devgui_buildable" },
    { 0x254E4484, "devgui_chest_end_monitor" },
    { 0x9C8F54AE, "devgui_cosmodrome" },
    { 0x545A4B27, "devgui_crate_delete" },
    { 0x649863AB, "devgui_crate_spawn" },
    { 0xE840CD0A, "devgui_crates" },
    { 0x6E8D2619, "devgui_debug_hud" },
    { 0xD20CB955, "devgui_debug_route" },
    { 0xC0BF6D27, "devgui_debug_spawn" },
    { 0x052F3FEA, "devgui_dockside" },
    { 0xDD7DDC82, "devgui_dog_camera" },
    { 0x1339F9D6, "devgui_dog_delete" },
    { 0x40FD21D0, "devgui_dog_spawn" },
    { 0xCCED6D39, "devgui_dog_think" },
    { 0xE5B7979D, "devgui_double_wide" },
    { 0x4B49CF65, "devgui_dpad_watch" },
    { 0x7F23B6CF, "devgui_duga" },
    { 0x536C51CF, "devgui_endgame" },
    { 0x7CC16E06, "devgui_exit_show" },
    { 0x91ADDCBA, "devgui_express" },
    { 0x1A66BAE4, "devgui_force_giant_robot" },
    { 0xF06A1A87, "devgui_force_giant_robot_foot" },
    { 0x5D69DF3A, "devgui_force_three_robot_round" },
    { 0x2A04FC28, "devgui_health" },
    { 0xA72D8BE8, "devgui_health_debug" },
    { 0xFA9469D3, "devgui_height" },
    { 0x289CA173, "devgui_increase_momentum" },
    { 0x6225E431, "devgui_int" },
    { 0x7B99600B, "devgui_mountain" },
    { 0x6D47DAC5, "devgui_mp" },
    { 0x1915B2EB, "devgui_nuked" },
    { 0x0283C5C9, "devgui_octobomb_give" },
    { 0x7EFBE513, "devgui_radiation" },
    { 0x6BCF7FCA, "devgui_russianbase" },
    { 0x89B6616D, "devgui_setup" },
    { 0xA77F3479, "devgui_show_hq" },
    { 0xD0DDA7BC, "devgui_spawn_active" },
    { 0x8195CB32, "devgui_spawn_index" },
    { 0xA4D2DCC5, "devgui_spawn_show" },
    { 0x1870C86A, "devgui_spawn_think" },
    { 0x26AFDBF2, "devgui_sq" },
    { 0x907D076F, "devgui_start_spawn_index" },
    { 0x020FD851, "devgui_string" },
    { 0xB458B3D8, "devgui_support_ee" },
    { 0x3F2D4647, "devgui_timeaway" },
    { 0x57A60E2F, "devgui_toggle_ammo" },
    { 0x725C2564, "devgui_toggle_no_ghost" },
    { 0x113A105B, "devgui_toggle_show_spawn_locations" },
    { 0x1FEFB654, "devgui_unlimited_ammo" },
    { 0xD4757F3C, "devgui_unlimited_momentum" },
    { 0x9D4FA4C2, "devgui_warp_to_mansion" },
    { 0xD14BC604, "devgui_watch_abilities" },
    { 0xE10B3B9A, "devgui_weapons_added" },
    { 0xD93874CA, "devgui_width" },
    { 0x4B652958, "devgui_zombie_healthbar" },
    { 0x2B06B8D0, "devgui_zombie_spawn" },
    { 0xEACE8596, "devhelipathdebugdraw" },
    { 0x491E9093, "devhelp" },
    { 0xBE782ECA, "devhelp_hudelements" },
    { 0xE1EA53A5, "deviate" },
    { 0x6FE9DBBB, "deviated" },
    { 0xA9CC4B7A, "deviation" },
    { 0x257AF89F, "deviationdistance" },
    { 0x367264FF, "device" },
    { 0x56CB9D3C, "device_lost" },
    { 0xC997F299, "device_replace_on_death" },
    { 0x96A1FCD4, "device_return_from_death" },
    { 0xFA513706, "devices" },
    { 0xFFA30600, "devider" },
    { 0x3D827C21, "devil" },
    { 0xE2F502C4, "devil_dialog_delay" },
    { 0xA6EEB4D1, "devil_is_speaking" },
    { 0xF7B87D23, "devil_vox" },
    { 0x03BAF1BF, "devmode" },
    { 0x5DCCEA61, "devongetormakebot" },
    { 0xE02C6167, "devotion" },
    { 0xDD6C6690, "devour" },
    { 0xA98B4088, "devraw" },
    { 0x7FFC8675, "devs" },
    { 0x5528F222, "devstraferunpathdebugdraw" },
    { 0x4BFAE575, "devteam" },
    { 0xD3836797, "devtrack" },
    { 0xDA124378, "df21poi" },
    { 0x0CACD5F4, "df_splines" },
    { 0xA8A124EE, "dfend" },
    { 0x52AA0758, "dflags" },
    { 0xA3A604E7, "dflt" },
    { 0x0041C14B, "dfmissile_up" },
    { 0xB1A6857A, "dforward" },
    { 0x1F122E77, "dfs_go" },
    { 0x225DC3AA, "dg_sq_map" },
    { 0x8F699CF7, "dg_sq_player" },
    { 0xA4DB3B3A, "dguzzo" },
    { 0x56FC9BA1, "dh" },
    { 0x03B62241, "dhb" },
    { 0x86814471, "dhweapon" },
    { 0xDBB10DD8, "dhweapons" },
    { 0x08DF175C, "di_billboard" },
    { 0xDD51E5C2, "di_blockade" },
    { 0xECF120D6, "di_blockade_destroyed" },
    { 0xDD9CD4E2, "di_left_side" },
    { 0x9CF0A8F8, "di_path_end" },
    { 0x22483960, "diable" },
    { 0x5BCB2C93, "diable_fog_in_noclip" },
    { 0x70A02FF0, "diablepain" },
    { 0x51C5E211, "diaglen" },
    { 0x14505D5F, "diagnostics" },
    { 0xF487E848, "diagonal" },
    { 0x029DEC6D, "diagonally" },
    { 0x8CC05963, "diagonals" },
    { 0x7439C1F4, "diagram" },
    { 0xAD852A9F, "dial" },
    { 0xC629EA95, "dial_anim" },
    { 0x9B57C947, "dial_animations" },
    { 0x134B9337, "dial_name" },
    { 0x58999522, "dial_trigger" },
    { 0x865B4256, "dial_vehicle" },
    { 0x2EF5534F, "dialgues" },
    { 0xD23F5D93, "diallow" },
    { 0x71B8DBA1, "dialog" },
    { 0x6088505A, "dialog1" },
    { 0x3A85D5F1, "dialog2" },
    { 0xCC10EBC9, "dialog_additional_lines_w_timeout" },
    { 0xDEBA53A6, "dialog_additional_lines_w_timeout_2" },
    { 0xA9AD1DF8, "dialog_ambush" },
    { 0x4EED9669, "dialog_ambush_finished" },
    { 0x8B4B3BDD, "dialog_and_anim" },
    { 0xDFC658F5, "dialog_balcony_enemies" },
    { 0x947BE993, "dialog_bbc" },
    { 0x03E11086, "dialog_blow_up_tower" },
    { 0xB6282A51, "dialog_box_button_pressed" },
    { 0xF1175864, "dialog_box_cursor" },
    { 0xB248118A, "dialog_bridge_combat" },
    { 0x3C899423, "dialog_bridge_radio" },
    { 0x868B1456, "dialog_building_collapse" },
    { 0xDEE5A8AC, "dialog_category" },
    { 0xA1063238, "dialog_chance" },
    { 0x379EC654, "dialog_check_houses" },
    { 0x2116A8A8, "dialog_choppers_dropping" },
    { 0x2D0CAB05, "dialog_church" },
    { 0x683A94A7, "dialog_church_spotted" },
    { 0xBF4E5E07, "dialog_clear_on_hq_breach" },
    { 0x04CF09F6, "dialog_cleared_to_engage" },
    { 0xD84D292C, "dialog_combat_deck" },
    { 0x817FC3A4, "dialog_combat_mason_elevator" },
    { 0x80CAD894, "dialog_combat_menendez_takeoff" },
    { 0x4A07A705, "dialog_combat_sensitive_room" },
    { 0xC51CCE4C, "dialog_contacts_in_the_woods" },
    { 0xFFB0BA59, "dialog_debugger" },
    { 0x945F5542, "dialog_deck_exit" },
    { 0x7D6188E9, "dialog_deck_reveal" },
    { 0x5547B179, "dialog_devil_dog" },
    { 0x16629164, "dialog_done" },
    { 0x9B96F0A3, "dialog_drive_into_forest" },
    { 0x343B29DA, "dialog_during_super_kill" },
    { 0x068EFFA7, "dialog_end_convo" },
    { 0x20CC7ACB, "dialog_end_of_course" },
    { 0xC5CEC843, "dialog_enemy_helicopters" },
    { 0xD8955922, "dialog_enemy_kills" },
    { 0x74A7F595, "dialog_enemy_vehicle" },
    { 0x09ECD82A, "dialog_enter_compound" },
    { 0xDE69D9DF, "dialog_first_fight_clear_and_move" },
    { 0xE67BFE6A, "dialog_flag_all" },
    { 0x0E4008DD, "dialog_flag_exert" },
    { 0xB048F0A9, "dialog_flag_gadget_ready" },
    { 0xD1934742, "dialog_flag_interrupt" },
    { 0xD512176F, "dialog_flag_stolen_gadget_ready" },
    { 0x2F0EC686, "dialog_flag_team" },
    { 0x9283870A, "dialog_flag_underwater" },
    { 0x078EB010, "dialog_flags_pain" },
    { 0xD8DB98DF, "dialog_flags_shout" },
    { 0x3D294825, "dialog_flank_mg" },
    { 0xD4201FD4, "dialog_fly_extra" },
    { 0x2A10C1DC, "dialog_fly_nag" },
    { 0x47F0863D, "dialog_fly_russian" },
    { 0x5E5D0719, "dialog_fly_story" },
    { 0xFC1CD178, "dialog_for_base_alert" },
    { 0xB9482BD3, "dialog_generic" },
    { 0x6A814C17, "dialog_germans_retreating" },
    { 0x1757FA7D, "dialog_germans_running" },
    { 0xB58B3C55, "dialog_get_fence_open" },
    { 0x3611F3C2, "dialog_get_off_your_ass" },
    { 0xAB4D0DD5, "dialog_goes_our_boys" },
    { 0xB95678A2, "dialog_grigs_guys_jibjab" },
    { 0xE45B12E7, "dialog_halftracks" },
    { 0x1925441E, "dialog_halftracks_1_eliminated" },
    { 0x9DED35C6, "dialog_hallway_breach" },
    { 0x02EDB317, "dialog_harper_turret" },
    { 0xAF7D0880, "dialog_hijack" },
    { 0x5D00A66E, "dialog_huds" },
    { 0x65F2119A, "dialog_infantry_wheat_field" },
    { 0x7AF58A3A, "dialog_intro" },
    { 0x3C3F8555, "dialog_intro_hallway" },
    { 0xDA1EF678, "dialog_intro_hallway_combat" },
    { 0xD3FD908A, "dialog_intro_hallway_combat_friendly" },
    { 0x2B01C68C, "dialog_intro_old" },
    { 0xF3C3C861, "dialog_intro_to_slums" },
    { 0x991D1433, "dialog_jackson_do_it" },
    { 0xFA959893, "dialog_junkyard1" },
    { 0x888E2958, "dialog_junkyard2" },
    { 0xAABFA8CC, "dialog_killconfirm" },
    { 0x18B6D8CF, "dialog_last_charge" },
    { 0x6303E93F, "dialog_last_charge2" },
    { 0x7A65AECD, "dialog_lead_charge" },
    { 0xB7D30513, "dialog_left_path_top" },
    { 0x6B548085, "dialog_lower_level_start" },
    { 0x6FBFFAA6, "dialog_lower_level_turret_hallway" },
    { 0x1D322FC5, "dialog_m202_redshirt" },
    { 0xB507EFEE, "dialog_mantle_intro" },
    { 0x2EDBDB2F, "dialog_mantle_single_tank" },
    { 0xE2C5A287, "dialog_mason_elevator" },
    { 0x3967E054, "dialog_mason_hangar" },
    { 0xA4097CD1, "dialog_menendez_escaping" },
    { 0x3ED14A5C, "dialog_mg_killed" },
    { 0x407F3C12, "dialog_more_panzershreck" },
    { 0xECF4B75F, "dialog_msg" },
    { 0xD0B8930F, "dialog_msg2" },
    { 0x32368AD0, "dialog_nag_till_in_pit" },
    { 0x931077A5, "dialog_name" },
    { 0xB0DCF8E4, "dialog_on_a_loop" },
    { 0x083BC424, "dialog_opening" },
    { 0x02D8D20D, "dialog_pacing_shoot_enemies" },
    { 0x1015C0D0, "dialog_panzershreck" },
    { 0xE6ACC11F, "dialog_panzershreck_window" },
    { 0xFE56BF65, "dialog_passing_church" },
    { 0x809CDE17, "dialog_plant_at_tower" },
    { 0x4BB7F5C9, "dialog_player_into_wheat_field" },
    { 0xE1D39F2B, "dialog_post_knife_kill" },
    { 0x76D14166, "dialog_pre_super_kill" },
    { 0x028236F8, "dialog_price_finds_griggs" },
    { 0x71733B2C, "dialog_proceed_upstairs" },
    { 0xC458E289, "dialog_radio_turrets" },
    { 0xFB571693, "dialog_rat_tunnel_vcs" },
    { 0x0C437621, "dialog_rathole_1_opens" },
    { 0xD9BB7004, "dialog_rathole_river" },
    { 0x2107288F, "dialog_reach_compound" },
    { 0x2A7FEDE8, "dialog_regroup_at_barn" },
    { 0x2F5FB11B, "dialog_remind_player_m202" },
    { 0x2D060987, "dialog_rescue" },
    { 0x168AA955, "dialog_rescue_breach" },
    { 0x035B446C, "dialog_ride_griggs" },
    { 0x9651EABC, "dialog_ride_price" },
    { 0x89F168F8, "dialog_right_path_top" },
    { 0xB1C372E4, "dialog_river_aa_gun" },
    { 0x866A486F, "dialog_rooftop" },
    { 0x3E1E9B01, "dialog_rpg" },
    { 0xA785AD7D, "dialog_rpgs_on_rooftops" },
    { 0x88438065, "dialog_rpgs_on_rooftops2" },
    { 0x6CCB9E4B, "dialog_run_to_barn" },
    { 0xA041EA7B, "dialog_seal_support_objective" },
    { 0xC2F92D49, "dialog_second_fight_clear_and_move" },
    { 0xEF1D636A, "dialog_sensitive_room" },
    { 0x1061C495, "dialog_server_offline" },
    { 0x49877FD4, "dialog_sprint_reminders" },
    { 0x3DD7A200, "dialog_start_convo" },
    { 0xEBAFE7A2, "dialog_tango_down" },
    { 0x11A9F8D0, "dialog_tank_1_success" },
    { 0xC63AA487, "dialog_tank_2_success" },
    { 0x92E9B90A, "dialog_tank_3_success" },
    { 0xE1744EAC, "dialog_tank_5_success" },
    { 0x9EF6CE8A, "dialog_tank_surprise" },
    { 0x919E1251, "dialog_tanks_appear" },
    { 0x21E7CE2F, "dialog_text_box" },
    { 0x5EABE035, "dialog_text_box_buttons" },
    { 0x561FA6F4, "dialog_text_box_cursor" },
    { 0x8D7A3A66, "dialog_text_box_input" },
    { 0xCE615580, "dialog_throttle" },
    { 0x304CD8A9, "dialog_tower_2_cleared" },
    { 0xCF3A5773, "dialog_tower_4_cleared" },
    { 0x9247F499, "dialog_treeline_hold_fire" },
    { 0xBD7682EA, "dialog_trench_center" },
    { 0xC2C86D30, "dialog_trigger" },
    { 0x2451929B, "dialog_triggers" },
    { 0x39569FC2, "dialog_truck_road_shoot" },
    { 0x59B3397D, "dialog_trucks_with_shooters" },
    { 0xDFAC2A5F, "dialog_tv_station_locked_down" },
    { 0xB5F1D96E, "dialog_van_jump" },
    { 0x69526A0E, "dialog_vc_intro" },
    { 0x98BA1220, "dialog_vos" },
    { 0x6AA4A777, "dialog_wait" },
    { 0xF9B59E85, "dialog_wait_for_mg_kill" },
    { 0x76B3D6F3, "dialog_wakeup" },
    { 0xD5B44BCA, "dialog_wakeup_kill" },
    { 0xBDCF6DCD, "dialog_ziptie_room" },
    { 0x51E5955F, "dialogalias" },
    { 0x30DDC316, "dialoganim" },
    { 0x26160003, "dialogbuffer" },
    { 0xE3DAEB88, "dialogbufferkey" },
    { 0x4B6DF1C1, "dialogbundle" },
    { 0x65B518F1, "dialogchance" },
    { 0xD81B464E, "dialoge" },
    { 0x1B619CD6, "dialogflags" },
    { 0xE8273736, "dialoggroup" },
    { 0xE5E11629, "dialoggroups" },
    { 0xDFDAE223, "dialogindex" },
    { 0xC1FB84A6, "dialogkey" },
    { 0xF234A17D, "dialogkey_priority" },
    { 0x4A1EAE3D, "dialogplaying" },
    { 0x64B58E9E, "dialogprint" },
    { 0x93E4C148, "dialogs" },
    { 0xDEB2E389, "dialogthread" },
    { 0x9F296CF6, "dialogtime" },
    { 0x917EC387, "dialogue" },
    { 0xBB80E85D, "dialogue_array" },
    { 0xBDC10755, "dialogue_breach" },
    { 0x9E35D374, "dialogue_c4_hints" },
    { 0xD7A48BB5, "dialogue_clear" },
    { 0xB2943317, "dialogue_cobraflight" },
    { 0x022C4F03, "dialogue_cobrastreets" },
    { 0x8EDFE6A8, "dialogue_crash_site_nag" },
    { 0x6B6250E9, "dialogue_crash_site_nag_cleanup" },
    { 0xA8E1CFEA, "dialogue_done" },
    { 0x0BA79E4F, "dialogue_execute" },
    { 0x65A962D0, "dialogue_func" },
    { 0xAB45B642, "dialogue_humanshield" },
    { 0x8DAB0FC0, "dialogue_interrupted" },
    { 0xCBFCE6A0, "dialogue_intro" },
    { 0xDE089DA4, "dialogue_line" },
    { 0x7B672DC3, "dialogue_loader" },
    { 0x0270E641, "dialogue_loudspeaker" },
    { 0x6F184286, "dialogue_more_mortars" },
    { 0xD5535B69, "dialogue_move" },
    { 0xC7FFCEE9, "dialogue_notify" },
    { 0x94132F59, "dialogue_nuke" },
    { 0x482E6E10, "dialogue_plaza" },
    { 0xEEBA4633, "dialogue_queue" },
    { 0xB641ED1C, "dialogue_safety" },
    { 0xF1618E89, "dialogue_setup" },
    { 0xB834B05A, "dialogue_smoke_hints" },
    { 0xFC8DA4BF, "dialogue_smoke_hints_cleanup" },
    { 0x2DF1B921, "dialogue_smoketown" },
    { 0x37C9F372, "dialogue_sound_done" },
    { 0x58507B03, "dialogue_south_tank_attack" },
    { 0xCC43C4D3, "dialogue_tarmac_hints" },
    { 0x77A1A6B5, "dialogue_timer" },
    { 0xE0BC96CA, "dialogue_trigger" },
    { 0xCAA98E38, "dialogue_turret_left" },
    { 0x954F7DAF, "dialogue_waittills" },
    { 0x395B3AE3, "dialogueareaclear" },
    { 0x91003CD2, "dialoguegatehint_max" },
    { 0x131395BB, "dialoguegatehint_number" },
    { 0x26B548DF, "dialoguehostiledown" },
    { 0x28AE8084, "dialoguejavelingoodshot_max" },
    { 0xB715CCE5, "dialoguejavelingoodshot_number" },
    { 0x1F2243FD, "dialogueline" },
    { 0xA316ADC5, "dialoguemovelines" },
    { 0xD5F4341A, "dialoguename" },
    { 0x2AFAAA64, "dialoguenotetrack" },
    { 0x07E2AD90, "dialoguerpggoodshot_max" },
    { 0xEF416FC1, "dialoguerpggoodshot_number" },
    { 0x995B16D0, "dialoguerpghit_max" },
    { 0x21535301, "dialoguerpghit_number" },
    { 0x17B7EE7E, "dialogues" },
    { 0x02581B01, "dialoguesniperconfirm_max" },
    { 0x1C4CF5F6, "dialoguesniperconfirm_number" },
    { 0xE616CDF0, "dialoguestring" },
    { 0x49AE1E0F, "dialoguetype" },
    { 0x1AAD519F, "dialouge" },
    { 0x8D7CEC26, "dials" },
    { 0xDB7E83B0, "diameter" },
    { 0x30155AE7, "diamond" },
    { 0xACF0CF54, "diarmaid" },
    { 0xBE8AA6B2, "diary" },
    { 0x0FD27C10, "diary_hud" },
    { 0xBD504D6B, "diary_reading" },
    { 0xC6879770, "diary_skip" },
    { 0x5B03A4D1, "diaryhud" },
    { 0xD37A1F97, "diarylinetime" },
    { 0x9B1C85EB, "diasables" },
    { 0xB4C54FD4, "dice" },
    { 0x98D42E4A, "dick" },
    { 0xF3E5F238, "dickhead" },
    { 0x044CB587, "dictate" },
    { 0x74072701, "dictated" },
    { 0xD1EBE47E, "dictates" },
    { 0xA8DE4D6C, "did" },
    { 0x225710FF, "did_aagun_gun_target_2_random_move" },
    { 0xD1F2AD16, "did_alley_jets1" },
    { 0xC798223D, "did_jets_mover" },
    { 0xE1610490, "did_notetrack" },
    { 0xD8E17F38, "did_once" },
    { 0x9D965177, "did_player_die" },
    { 0xDA2FB0EE, "did_scene1" },
    { 0x549D9EF3, "did_zpu_warning" },
    { 0x0C75E84B, "didanim" },
    { 0xBCF3E06A, "didany" },
    { 0xD31326DF, "didcoolstuff" },
    { 0x7DDE65E2, "didloserfailchallenge" },
    { 0x81EDEDDA, "didnt" },
    { 0x6A336B44, "didshufflemove" },
    { 0x5120AF50, "didsomething" },
    { 0xA3B92CCC, "didsomethingotherthanshooting" },
    { 0xCA6FDAE1, "didstatusnotify" },
    { 0x36EFE19F, "didweights" },
    { 0xCEE0C7D5, "die" },
    { 0xFB7E96C6, "die_after_spawn" },
    { 0xD45D10B5, "die_and_notify" },
    { 0xFF181623, "die_asap" },
    { 0x8DA732A4, "die_behind_player" },
    { 0x61444C84, "die_coward" },
    { 0x3A20338D, "die_from_hudson_grenade" },
    { 0xB3475968, "die_from_rpg" },
    { 0x500F9256, "die_if_near" },
    { 0xAC28579E, "die_in_x_sec" },
    { 0xC96C3E9C, "die_index" },
    { 0x524E2561, "die_on_spline" },
    { 0xA8D96E33, "die_shortly" },
    { 0xA7BBDF29, "die_soon" },
    { 0x1FE6EA24, "die_when_told" },
    { 0x5E2661C5, "die_when_tower_blows1" },
    { 0x8428DC2E, "die_when_tower_blows2" },
    { 0xAA2B5697, "die_when_tower_blows3" },
    { 0x21C207EC, "die_when_up_starts" },
    { 0xA7E2C34B, "died" },
    { 0x32905F72, "died_by_emp" },
    { 0xD14263AD, "died_by_flame_explosion" },
    { 0x8392B508, "died_in_gas_event" },
    { 0x7614A86E, "died_in_vehicle" },
    { 0x58E7421A, "died_of_headshot" },
    { 0xAE58F1D7, "diedinscriptedanim" },
    { 0x76DFDE9A, "diedonturret" },
    { 0xE1700654, "diedonvehicle" },
    { 0x23BBFF6B, "dieee" },
    { 0xA0671507, "dieindex" },
    { 0x054B95D3, "dieing" },
    { 0x15231DD9, "dieinnseconds" },
    { 0x2DD6576B, "dieonentitydeath" },
    { 0x02D907C2, "diequietly" },
    { 0x93C0118D, "dier" },
    { 0xA9C60198, "dieroll" },
    { 0x5A754563, "dierorigin" },
    { 0x0349BC34, "dierwasspawner" },
    { 0x6DBD9724, "dies" },
    { 0x93FA591F, "diewhenfinished" },
    { 0xF4E3423E, "dif" },
    { 0x9ECA5352, "dif_angle" },
    { 0x61F06E55, "dif_frac" },
    { 0x4CB423CC, "diff" },
    { 0xD20DC83D, "diff1" },
    { 0xF81042A6, "diff2" },
    { 0x8E0ABF35, "diff_ang" },
    { 0x8A6CB0DA, "diff_days" },
    { 0x039B46CE, "diff_degrees" },
    { 0x7880530A, "diff_forward" },
    { 0x7C3E0F77, "diff_frac" },
    { 0x8742E747, "diff_org" },
    { 0x0C141113, "diff_per_dist" },
    { 0xD35C182A, "diff_struct_value" },
    { 0xEBF1810C, "diff_up" },
    { 0x42AE5EEB, "diff_vec" },
    { 0x7190920F, "diff_weight" },
    { 0x02E40420, "diff_xp_mult" },
    { 0x84E2DEAC, "diffangles" },
    { 0xCC7BBAA9, "differ" },
    { 0x730C3740, "difference" },
    { 0x1B9AAC2D, "difference_expo_per_frame" },
    { 0x3DA4BBC7, "difference_vec" },
    { 0x9416CB72, "differenceallies" },
    { 0x7223FC53, "differenceaxis" },
    { 0x6E1AC26B, "differences" },
    { 0x0D2896F0, "different" },
    { 0x4859F543, "differentiate" },
    { 0x428A05C6, "differentiating" },
    { 0xB212D6F0, "differentiation" },
    { 0x566F0655, "differently" },
    { 0xB4F6EBDF, "differing" },
    { 0x75650FB5, "differing_starts" },
    { 0x8D9C9A82, "differnet" },
    { 0x023E552B, "differnt" },
    { 0xFD487520, "differs" },
    { 0x7B4E3679, "difficult" },
    { 0x5AACF822, "difficulties" },
    { 0x3F0972CA, "difficulty" },
    { 0x94A26FBB, "difficulty_adjustments" },
    { 0x74392D28, "difficulty_array" },
    { 0xAFA02FC9, "difficulty_chance" },
    { 0x637A9BA5, "difficulty_change" },
    { 0xF5D45E8B, "difficulty_func" },
    { 0xB9A00567, "difficulty_init" },
    { 0xABBE1BEA, "difficulty_pump_thread" },
    { 0x72EA9F01, "difficulty_scale" },
    { 0xE8674008, "difficulty_scale_down" },
    { 0xCF0B2B03, "difficulty_scale_up" },
    { 0xC3AC9289, "difficulty_select" },
    { 0x1C428B6A, "difficulty_shader" },
    { 0xE9224440, "difficulty_starting_frac" },
    { 0xD3F5BB46, "difficulty_veteran" },
    { 0xB39B4011, "difficulty_xp_multiplier" },
    { 0x18BC4A7C, "difficultybasedaccuracy" },
    { 0x4B0F33CE, "difficultyscaler" },
    { 0xF2FC2101, "difficultysettings" },
    { 0x0FA88217, "difficultysettings_frac_data_points" },
    { 0x819C236E, "difficultysettings_stepfunc_percent" },
    { 0x4F0F998E, "difficultysettingselectedwait" },
    { 0xD96E6BF3, "difficultyslot_t" },
    { 0x632A13ED, "difficultystring" },
    { 0xA3B20BFD, "difficultytimerscale" },
    { 0x4DAACBAA, "difficultytype" },
    { 0x9E8BF07B, "difficultyypos" },
    { 0x39F0AF0A, "diffpos" },
    { 0x02C1FA48, "difftoprefereddirectness" },
    { 0x8E503881, "difftrack" },
    { 0x16E1291E, "difftrackangle" },
    { 0x3B7C8ADD, "diffuse" },
    { 0x5AE1C4F4, "diffuse_high" },
    { 0xA49C6A86, "diffuse_low" },
    { 0x68EB8C47, "diffvisionon" },
    { 0x5CBDBB5C, "diffx" },
    { 0x82C035C5, "diffy" },
    { 0xA8C2B02E, "diffz" },
    { 0x6F146B57, "difussing" },
    { 0x1AE5BCA7, "dig" },
    { 0x4230E348, "dig_disconnect_watch" },
    { 0x66BB8C3F, "dig_get_rare_powerups" },
    { 0xC1D45C78, "dig_has_powerup_spawned" },
    { 0x3F7B7FF2, "dig_last_prize_rare" },
    { 0x99A26965, "dig_magic_box_moved" },
    { 0x9094DD9B, "dig_n_powerups_spawned" },
    { 0x98CAA660, "dig_n_zombie_bloods_spawned" },
    { 0x90A38237, "dig_powerups_tracking" },
    { 0x45218586, "dig_reward_dialog" },
    { 0x6CA8F779, "dig_reward_vo_cooldown" },
    { 0x00637DE0, "dig_set_powerup_spawned" },
    { 0x55B27A6D, "dig_spawners" },
    { 0x56BA198B, "dig_spot_get_staff_piece" },
    { 0xB312418A, "dig_spot_spawn" },
    { 0x17652ACA, "dig_spot_trigger_visibility" },
    { 0xAB43ECA6, "dig_spots_init" },
    { 0x496B8F6C, "dig_spots_respawn" },
    { 0xDD7A9AAE, "dig_up_grenade" },
    { 0x86D04E30, "dig_up_powerup" },
    { 0xE07A8850, "dig_up_weapon" },
    { 0xF8352F34, "dig_up_weapon_shared" },
    { 0x8BC1969D, "dig_up_weapon_timed_out" },
    { 0x56CD0BC2, "dig_up_zombie" },
    { 0xB5843B10, "dig_vars" },
    { 0x8923B68D, "dig_vo_cooldown" },
    { 0xD6F71490, "digbat" },
    { 0x4DD89F9A, "digbat_blood_pool" },
    { 0x6DF323AE, "digbat_challenge_track" },
    { 0xCB2B703B, "digbat_charge_vo" },
    { 0x935AA3AE, "digbat_common_setup" },
    { 0x7A5443F6, "digbat_drop_baton_on_death" },
    { 0x82AAB571, "digbat_gauntlet" },
    { 0x0C272787, "digbat_gauntlet_spawn_wave" },
    { 0x26422EE4, "digbat_gauntlet_think" },
    { 0xD6A449D9, "digbat_gauntlet_vo" },
    { 0x6E7955B1, "digbat_gauntlet_vo_count" },
    { 0x9C0DC370, "digbat_get_closer_if_melee_blocked" },
    { 0xD90D3518, "digbat_guantlet_fail_safe" },
    { 0x0EAF6D58, "digbat_hunt_immediately_behavior" },
    { 0x2E57E8B3, "digbat_kick_open_door" },
    { 0x57782785, "digbat_mason_control" },
    { 0x5E248C88, "digbat_melee_weapon" },
    { 0x32A257CD, "digbat_parking" },
    { 0xE871DAC5, "digbat_tackle" },
    { 0x800533B8, "digbat_tackle_dialog" },
    { 0xEBF9113F, "digbat_tackle_started" },
    { 0x9CB2DD54, "digbat_tackle_wall" },
    { 0xF6A904EF, "digbat_todo" },
    { 0xC924747B, "digbats" },
    { 0x19127C3B, "digger" },
    { 0xF257C559, "digger_activate" },
    { 0x0A44EF71, "digger_anim" },
    { 0xC1BDA8EF, "digger_arm_breach_logic" },
    { 0x5567A905, "digger_arm_fx" },
    { 0x0E2C7960, "digger_arm_lift" },
    { 0xE6B78977, "digger_arm_logic" },
    { 0x519D0063, "digger_arm_raised" },
    { 0x1137A109, "digger_arm_smash" },
    { 0x12ACC3EF, "digger_damage_player" },
    { 0x7EF2B10A, "digger_debug_star" },
    { 0x7B5FFA5E, "digger_debugger_counter" },
    { 0xB0A33B03, "digger_dig_init" },
    { 0x44109C23, "digger_dig_think" },
    { 0xF0B2BCB7, "digger_digging_earthquake_rumble" },
    { 0x2BB21065, "digger_follow_path" },
    { 0xF3E06BD3, "digger_follow_path_calc_speed" },
    { 0x86FB2310, "digger_follow_path_recalc_speed" },
    { 0x62213886, "digger_hack_func" },
    { 0x8483B0FD, "digger_hack_qualifer" },
    { 0xAFBD2526, "digger_hacked" },
    { 0x583EC468, "digger_init" },
    { 0x4AD5A124, "digger_init_flags" },
    { 0x37CC5047, "digger_logic_stop" },
    { 0x4EC92A54, "digger_moving_earthquake_rumble" },
    { 0x1873609B, "digger_name" },
    { 0x8C738482, "digger_push_player" },
    { 0x936A1FB6, "digger_reached_end" },
    { 0x93BF7673, "digger_rotate" },
    { 0xEFD48321, "digger_round_logic" },
    { 0x194457DF, "digger_speed" },
    { 0x4B290403, "digger_speed_multiplier" },
    { 0x1F3059DA, "digger_start_time" },
    { 0xECD837D5, "digger_struct" },
    { 0x3B33179C, "digger_think_biodome" },
    { 0x0081AC11, "digger_think_blocker" },
    { 0x553B8DA4, "digger_think_blocker_remove" },
    { 0x3700CA5E, "digger_think_move" },
    { 0x7BD90791, "digger_think_panel" },
    { 0x2EBE2D2B, "digger_time_in_mins" },
    { 0xC994F73B, "digger_to_activate" },
    { 0xCF66DDE9, "digger_visibility_toggle" },
    { 0x6CD36E9B, "digger_wheel" },
    { 0x3943B1DA, "diggers" },
    { 0xD00AC1BC, "diggers_global_time" },
    { 0xA6DD3F5B, "diggers_think_no_mans_land" },
    { 0x58D10195, "diggers_visible" },
    { 0x16E673C3, "diggin" },
    { 0xCEC28766, "digging" },
    { 0x70933C28, "digit" },
    { 0x7218C003, "digit_slot" },
    { 0x4DAF2C9E, "digit_value" },
    { 0x83FFD6CF, "digital" },
    { 0x8B711A55, "digitalblood" },
    { 0x31F6C8C3, "digits" },
    { 0x96548E62, "digsite" },
    { 0xD18E20A7, "diligent" },
    { 0x5DBCDF2C, "diluted" },
    { 0x9ECCF48D, "dim" },
    { 0x1C336E60, "dim_race_arrows" },
    { 0x0B4948CA, "dime" },
    { 0xB41DB80B, "dimension" },
    { 0x619239D4, "dimensional" },
    { 0xDC42276A, "dimensions" },
    { 0x4025E240, "diminishing_probability" },
    { 0x42149FA1, "dimitri" },
    { 0x2E91DAD2, "dimspecular" },
    { 0xC4CF6EF6, "din" },
    { 0x460C9E9F, "diner" },
    { 0xA0A155AA, "diner_front_door" },
    { 0x5C9F5F84, "diner_hatch" },
    { 0xD85AB475, "diner_hatch_access" },
    { 0x85282D27, "diner_hatch_col" },
    { 0x173200D6, "diner_hatch_mantle" },
    { 0x18EB8D6E, "diner_side_door" },
    { 0x3329CF93, "dinerhatch" },
    { 0x0F229BD1, "dinerhatchbuildable" },
    { 0x4BA1AA85, "dingbat_shot_sound" },
    { 0x0EBEFD6A, "dining" },
    { 0xE3BF6D8B, "dining_zone" },
    { 0x37096912, "diorama" },
    { 0x64824B8B, "diorama01" },
    { 0x0117D65E, "diorama01_read" },
    { 0xF27ADC50, "diorama02" },
    { 0x71A24DE7, "diorama02_read" },
    { 0x26DF8E38, "diorama03_read" },
    { 0x410914D1, "diorama04_read" },
    { 0xCDE46042, "diorama05_read" },
    { 0x8A84C5F4, "diorama06" },
    { 0x281141BB, "diorama06_read" },
    { 0x66A31ED2, "diorama_anim_time" },
    { 0xAF07AC1D, "dioramas" },
    { 0x70FC0A58, "dip" },
    { 0x4FF8BFBE, "dip_the_spoon" },
    { 0xBD00FF2A, "dir" },
    { 0x786C82F7, "dir1" },
    { 0x066513BC, "dir2" },
    { 0xCE68197F, "dir_2d" },
    { 0xF78C044D, "dir_cliff" },
    { 0x4187FEB6, "dir_from_impact" },
    { 0x1F8449CE, "dir_movement" },
    { 0x9D25501B, "dir_norm" },
    { 0x2BA40406, "dir_size" },
    { 0x242A638C, "dir_text" },
    { 0xC0688973, "dir_to_boat" },
    { 0x9D49B2EB, "dir_to_enemy" },
    { 0x627AA564, "dir_to_goal" },
    { 0x49831849, "dir_to_node" },
    { 0x37C72AB6, "dir_to_player" },
    { 0xFA7ADAD9, "dir_to_raps" },
    { 0x22198425, "dir_to_right" },
    { 0xB133509E, "dir_to_rpg" },
    { 0xBA3647E3, "dir_to_spawner" },
    { 0x9D4A55D2, "dir_to_target" },
    { 0x0A158F62, "dir_up" },
    { 0x8CE8BA53, "dir_x" },
    { 0x66E63FEA, "dir_y" },
    { 0xD0F3AAFF, "dircetly" },
    { 0x73140703, "direcions" },
    { 0x37B1B72F, "direclty" },
    { 0xA682C292, "direct" },
    { 0x5ECAE256, "direct_attack_min_distance" },
    { 0xDCA2494B, "direct_attack_player" },
    { 0xB4B1C76E, "direct_on_player" },
    { 0x429E017D, "direct_vec" },
    { 0xD2A142A5, "directed" },
    { 0xE7D4FA4A, "directed_fate_to" },
    { 0xA70C20F8, "directed_kill" },
    { 0x0D85B41E, "directed_pickup_award_to" },
    { 0x557C65ED, "directhitwithmolotov" },
    { 0x31ED92AB, "directin" },
    { 0x42F82E9E, "directing" },
    { 0x102E3D58, "direction" },
    { 0x9BE4DC93, "direction_angles" },
    { 0x427D2117, "direction_change" },
    { 0x1E198702, "direction_failures" },
    { 0x84B565FE, "direction_forward" },
    { 0xD65C28A6, "direction_inbound_left" },
    { 0x638EB39B, "direction_input_ls" },
    { 0xF6CD8BEB, "direction_org" },
    { 0x360FFA8D, "direction_origin" },
    { 0x34D7A5CF, "direction_vec" },
    { 0x5F7B105A, "direction_vec_override" },
    { 0xE17EC856, "direction_vector" },
    { 0x41D760BF, "directional" },
    { 0xE4314A5F, "directional_impact_scale" },
    { 0x3D43F166, "directional_warning" },
    { 0x3F443551, "directionalhitarray" },
    { 0x4E05F15D, "directionalhitindicator" },
    { 0xD52E3D20, "directionchange" },
    { 0x5BCF17E1, "directionofimpact" },
    { 0xED2B5E1E, "directiononpath" },
    { 0xE2AA5A33, "directions" },
    { 0x59A0C49E, "directionscale" },
    { 0x45831727, "directionstyle" },
    { 0x142EAC8D, "directiontoenemy" },
    { 0x00554A44, "directiontonext" },
    { 0xB1C3C1CC, "directiontracker" },
    { 0x240EF2CF, "directionup" },
    { 0x13DF59BE, "directionvec" },
    { 0x4AA3E779, "directionyaw" },
    { 0x7DE1D0B4, "directive" },
    { 0x468A6BBE, "directkill" },
    { 0x88AD409F, "directly" },
    { 0xA4228EC7, "directness" },
    { 0x87F9F4B7, "directnessscore" },
    { 0xC8223E81, "director" },
    { 0x5FB49631, "director_activated" },
    { 0xA708D914, "director_activation_damage" },
    { 0x9222267E, "director_activation_hit_player" },
    { 0xC57A4E44, "director_add_weapon" },
    { 0xCEC8055A, "director_aggro" },
    { 0x17C72956, "director_ambient_vox" },
    { 0x98909001, "director_angry_vox" },
    { 0x0EC6FCB3, "director_anim" },
    { 0xF5E57A5D, "director_animscripted" },
    { 0x348542F9, "director_animscripted_timeout" },
    { 0xA9739D92, "director_behind_vox" },
    { 0x4D017C0F, "director_blur" },
    { 0x05C8A375, "director_buff_cooldown" },
    { 0x9C7FE1FA, "director_calmed" },
    { 0xD2980FCB, "director_custom_damage" },
    { 0x8755F02A, "director_custom_fling" },
    { 0xCE59186E, "director_custom_idle" },
    { 0xB9C84322, "director_custom_stumble" },
    { 0xBC3F062A, "director_death" },
    { 0x2ED84E48, "director_delay_melee" },
    { 0x49DF8AAD, "director_delayed_activation" },
    { 0x0FB47B57, "director_devgui_health" },
    { 0xBC049302, "director_display_damage" },
    { 0xD50DB459, "director_electric_buff_range" },
    { 0x122F3214, "director_electric_buff_range_sq" },
    { 0xC9CC0C26, "director_electrify_range_sq" },
    { 0xD4C5D7F1, "director_emerging_audio" },
    { 0x52133A2E, "director_enemy_range" },
    { 0x32473434, "director_exit" },
    { 0xC51A95A3, "director_exit_level" },
    { 0x3DBDBCB0, "director_find_exit" },
    { 0x4B424A6E, "director_fling" },
    { 0xA78BEF99, "director_flip_light_flag" },
    { 0xE4C9B5E5, "director_full_damage" },
    { 0x97D9991C, "director_get_zombies_to_buff" },
    { 0x1F38C2F4, "director_ground_attack_delay" },
    { 0x41012F53, "director_health_reduce" },
    { 0x70B8DE72, "director_health_watch" },
    { 0xA1529A2D, "director_humangun_hit_response" },
    { 0x37BBA6D3, "director_humangun_react" },
    { 0x52F51C0D, "director_init_done" },
    { 0x44C571A5, "director_instakill" },
    { 0x80EE62A8, "director_intro_vox" },
    { 0xDE985A31, "director_is_speaking" },
    { 0x6DD0E10B, "director_kill_prone" },
    { 0x8B4405DE, "director_leave_map" },
    { 0x903D28B1, "director_light_set" },
    { 0xF13037AF, "director_max_ammo_available" },
    { 0x823FB6A2, "director_max_ammo_chance" },
    { 0xFD25F7B4, "director_max_ammo_chance_default" },
    { 0x958E5EB3, "director_max_ammo_chance_inc" },
    { 0x1BE0DC79, "director_max_ammo_drop" },
    { 0x38365592, "director_max_ammo_round" },
    { 0xFBF7DD6A, "director_max_ammo_watcher" },
    { 0x2229FA7E, "director_max_damage_taken" },
    { 0x0FF4B33B, "director_max_damage_taken_easy" },
    { 0x76FE8A56, "director_max_speed_buff" },
    { 0xE208AC40, "director_melee_anim" },
    { 0x9E3FC52B, "director_melee_miss" },
    { 0x83E63511, "director_non_attacker" },
    { 0x0E1EC43F, "director_notify" },
    { 0x1E3AFAAD, "director_nuke_damage" },
    { 0x83F27DD8, "director_precache_models" },
    { 0x1FDE4D98, "director_prespawn" },
    { 0x613BB631, "director_print" },
    { 0xB68C1074, "director_reenter_level" },
    { 0xBD94D9C8, "director_reenter_map" },
    { 0x7277003E, "director_reset_health" },
    { 0xFF1D614D, "director_reset_light_flag" },
    { 0x0AD693C2, "director_run_change" },
    { 0xBDAAE9CB, "director_scream_delay" },
    { 0x88C3ED17, "director_scream_in_water" },
    { 0x44DDA396, "director_set_animarray_standing" },
    { 0x7AC22726, "director_should_drop_special_powerup" },
    { 0x3A710015, "director_spawn_zombies" },
    { 0x01053AAB, "director_speed_buff" },
    { 0xEC6F603D, "director_speed_buff_range" },
    { 0xC52906E8, "director_speed_buff_range_sq" },
    { 0xA42C11CD, "director_sprint2walk" },
    { 0x5F803F98, "director_sprint2walk_watcher" },
    { 0x380E1403, "director_stumble_watcher" },
    { 0xD7B9D6D4, "director_submerging_audio" },
    { 0xA8B4088F, "director_tesla_damage" },
    { 0x71DEF115, "director_transition" },
    { 0x0DB5B4A7, "director_vox_futz" },
    { 0xF5D56600, "director_vox_init" },
    { 0x645DAB98, "director_wait_for_run_change" },
    { 0x71A76023, "director_watch_damage" },
    { 0xE883130C, "director_zomb" },
    { 0x9DD8BB02, "director_zombie" },
    { 0x1DF33335, "director_zombie_anim_override" },
    { 0xDBB2C959, "director_zombie_apply_buff" },
    { 0x1FFE29E3, "director_zombie_can_buff" },
    { 0xD603EE7A, "director_zombie_check_for_activation" },
    { 0xE4BC15C9, "director_zombie_check_for_buff" },
    { 0x8F1A78FB, "director_zombie_check_player_proximity" },
    { 0x9DD67ADA, "director_zombie_choose_buff" },
    { 0x4775EE1C, "director_zombie_choose_run" },
    { 0x3C2D7C21, "director_zombie_custom_think" },
    { 0xC2EA7100, "director_zombie_default_enter_level" },
    { 0x3AB2B38A, "director_zombie_default_pathfind_heuristic" },
    { 0x6CC01CED, "director_zombie_default_spawn_heuristic" },
    { 0x64A96EC1, "director_zombie_die" },
    { 0x384665F4, "director_zombie_electric_buff" },
    { 0xF5714518, "director_zombie_enemy_is_far" },
    { 0x57F5EDF2, "director_zombie_enter_level" },
    { 0xD1EE0212, "director_zombie_get_num_speed_buff" },
    { 0xE2259AF2, "director_zombie_ground_hit" },
    { 0x6F4249B7, "director_zombie_ground_hit_think" },
    { 0xFABCB4DD, "director_zombie_groundhit_damage" },
    { 0x6D05D5D0, "director_zombie_groundhit_radius" },
    { 0xF305648F, "director_zombie_health_manager" },
    { 0x51E2A804, "director_zombie_health_mult" },
    { 0x099D9035, "director_zombie_idle_setup" },
    { 0xCF6324FE, "director_zombie_manager" },
    { 0x2FF07506, "director_zombie_max_health" },
    { 0x14CAA71C, "director_zombie_min_health" },
    { 0xFC9BCCA8, "director_zombie_pathfind_heuristic" },
    { 0x7C9EF17A, "director_zombie_pick_best_spawner" },
    { 0x63AF43FB, "director_zombie_proximity_wake" },
    { 0x70B93B80, "director_zombie_range" },
    { 0xD1DD9649, "director_zombie_scream_a_chance" },
    { 0x23F53183, "director_zombie_scream_a_radius" },
    { 0xB3814E1A, "director_zombie_scream_a_radius_sq" },
    { 0xCB8CA278, "director_zombie_scream_b_chance" },
    { 0x757713B6, "director_zombie_scream_b_radius" },
    { 0x2101B865, "director_zombie_scream_b_radius_sq" },
    { 0xFA44C12A, "director_zombie_spawn" },
    { 0x9AE17F43, "director_zombie_spawn_heuristic" },
    { 0xD529157A, "director_zombie_spawners" },
    { 0xE935F782, "director_zombie_speed_buff" },
    { 0x693178F8, "director_zombie_sprint_watcher" },
    { 0xA5916F47, "director_zombie_think" },
    { 0x00378F7E, "director_zombie_update" },
    { 0xE90D6301, "director_zombie_update_goal_radius" },
    { 0x5A8462C3, "director_zombie_update_next_groundhit" },
    { 0xAFFD1577, "director_zombie_update_proximity_wake" },
    { 0xBEE3FE6D, "director_zombified" },
    { 0xC3EA7F78, "director_zombified_watcher" },
    { 0xFDA736A8, "directors" },
    { 0x19985832, "directory" },
    { 0xAB0F909D, "directs" },
    { 0x484F8EC4, "direwolf_eye_glow_fx" },
    { 0xE5AEE6DF, "direwolf_eye_glow_fx_bits" },
    { 0x89200712, "direwolf_eye_glow_fx_clientfield" },
    { 0x9CAAA21D, "direwolf_eye_glow_fx_file" },
    { 0xAD87373D, "direwolf_eye_glow_fx_tag" },
    { 0x82E57933, "direwolf_eye_glow_fx_type" },
    { 0xBEEA0195, "direwolfeyeglowfxhandler" },
    { 0x722F5B6F, "direwolfspawnsetup" },
    { 0x52338EC9, "dirofdrone" },
    { 0x39C184AA, "dirt" },
    { 0x4FA99F9F, "dirt_edge_fx" },
    { 0x8BD08EAC, "dirt_enable_explosion" },
    { 0x70CBC1EC, "dirt_enable_fall_damage" },
    { 0x178FC937, "dirt_enable_gravity_spikes" },
    { 0x55215B2E, "dirt_enable_slide" },
    { 0xB660D8D4, "dirt_fx_org" },
    { 0xF1B9582D, "dirt_model_shoots_dirt" },
    { 0x8FFCCD8D, "dirt_overlay_control" },
    { 0xE912D8A9, "dirt_path_allies" },
    { 0x70B0F170, "dirt_path_barn_truck" },
    { 0xA69B992F, "dirt_path_charlie" },
    { 0x0E987089, "dirt_path_disable_truck" },
    { 0xD4B449CC, "dirt_path_helicopter" },
    { 0xD4ED5320, "dirt_path_helicopter_react" },
    { 0x9C556D7C, "dirt_path_mark" },
    { 0x5B4AE8B4, "dirt_path_mark_path_end" },
    { 0xEEC5DC84, "dirt_path_player" },
    { 0x1CF316DC, "dirt_path_player_speed" },
    { 0x31D684F2, "dirt_path_price" },
    { 0x94465ADB, "dirt_path_price_dialogue" },
    { 0x5364B138, "dirt_path_steve" },
    { 0xD46C6024, "dirt_path_truck" },
    { 0x2BF1FE21, "dirt_surface_type" },
    { 0xB215A7C6, "dirtduration" },
    { 0x8604EB83, "dirtfadetime" },
    { 0x042D10D3, "dirtfx_org" },
    { 0x668E8081, "dirtmodel" },
    { 0x62131CA8, "dirtmodels" },
    { 0x00A2597B, "dirtoenemy" },
    { 0xE87715DD, "dirtomason" },
    { 0x0064BB59, "dirtonode" },
    { 0x3FB78D52, "dirtoowner" },
    { 0x5BA5C23C, "dirtoplayerenter" },
    { 0x5D0C2C6E, "dirtoplayerexit" },
    { 0x3CDA5CD9, "dirtopos" },
    { 0xBEE1759B, "dirtoprimaryenemy" },
    { 0xD948B03B, "dirtoreactiontarget" },
    { 0x84BE66C8, "dirtoreactorigin" },
    { 0x575428A9, "dirtostartpos2d" },
    { 0x7E1D2E82, "dirtotarget" },
    { 0xAACC3DEF, "dirty" },
    { 0xB9E84A54, "dirvec" },
    { 0xE3037993, "dis" },
    { 0xDC8D5E26, "dis_from_player" },
    { 0x156D5A2F, "dis_sq_from_player" },
    { 0xA56CDF77, "disabaling" },
    { 0x54BDB053, "disable" },
    { 0x1ECBB279, "disable120runngun" },
    { 0x7948F95E, "disable_activation" },
    { 0x478C1426, "disable_additionalprimaryweapon_machine_locations" },
    { 0xCBFB9AEE, "disable_afterlife_prop" },
    { 0x1AB61688, "disable_ai_bleeder" },
    { 0x09772F68, "disable_ai_color" },
    { 0x2AEFD6EC, "disable_ai_getoff" },
    { 0x64472B30, "disable_ai_revive" },
    { 0x38D43232, "disable_ai_reviver" },
    { 0x5456B558, "disable_ai_swimming" },
    { 0xC22A01F5, "disable_aim_assist" },
    { 0x47125B07, "disable_all_filters_on_game_ended" },
    { 0xEB0924A1, "disable_all_prompts_for_player" },
    { 0xB6ECC65B, "disable_ammo_cache" },
    { 0x170C8FEE, "disable_argus" },
    { 0x459FBCD4, "disable_arrivals" },
    { 0xC7674FC6, "disable_arrivalsandexits_dmg_watcher" },
    { 0xAC60FE3F, "disable_arrivalsandexits_til_lastnode" },
    { 0x1114BD7D, "disable_auto_adjust_threatbias" },
    { 0xCEB47C29, "disable_blackscreen_clientfield" },
    { 0x52D9A29B, "disable_blindfire" },
    { 0x14CD2C76, "disable_blood" },
    { 0x5CDAE787, "disable_boats_when_group_cleared" },
    { 0xF18FECC6, "disable_bow_turret_fire" },
    { 0x5A484813, "disable_bridge_nodes" },
    { 0x1714903D, "disable_bridge_triggers_for_zak_start" },
    { 0x0174191D, "disable_buff" },
    { 0x448ABCE3, "disable_bump_trigger" },
    { 0x6FA056EB, "disable_bunker_lightflares" },
    { 0x49453B79, "disable_buttons" },
    { 0xD51F22B1, "disable_callboxes" },
    { 0xCC709E22, "disable_careful" },
    { 0xE4725B69, "disable_chaplin" },
    { 0x6AC2C01D, "disable_chaplin_grain" },
    { 0xA6F6E6F5, "disable_charge_when_no_arms" },
    { 0x792AEB6C, "disable_chugabud_corpse" },
    { 0xA919058A, "disable_claw_boot" },
    { 0x43480AE3, "disable_color_trigs" },
    { 0xE0EC94AE, "disable_colors" },
    { 0x4BC0C112, "disable_complex_behaviors" },
    { 0xF69B081C, "disable_cqb" },
    { 0x4725A358, "disable_cqbsprint" },
    { 0xCD8D875F, "disable_cqbwalk" },
    { 0xEBD0325E, "disable_cqbwalk_ign_demo_wrapper" },
    { 0x2C534BE8, "disable_cybercom" },
    { 0xEAFFFB33, "disable_damage_blur" },
    { 0xA250F238, "disable_damage_overlay" },
    { 0x83F60F23, "disable_damage_overlay_in_vehicle" },
    { 0xE1AA6FA4, "disable_damagefeedback" },
    { 0x4FEA5CB2, "disable_deadlyness_on_stealth_spotted" },
    { 0xE80F1A40, "disable_deadshot" },
    { 0x836CC4B6, "disable_deadshot_clientfield" },
    { 0xB478495C, "disable_decend_until_notify" },
    { 0x2C7FA62A, "disable_dist" },
    { 0x6E8DEDD8, "disable_diveto_prone" },
    { 0x0B1B5949, "disable_driver_turret" },
    { 0x9CC30FFE, "disable_driver_weapons" },
    { 0x5AF75A7E, "disable_drone_explosive_deaths" },
    { 0x6AED8276, "disable_drones_thread" },
    { 0x54855528, "disable_drown" },
    { 0x463FDEF0, "disable_drowning" },
    { 0x8AA176C0, "disable_elevator_buys" },
    { 0x530B48E4, "disable_elevator_spawners" },
    { 0x85808CC3, "disable_elite" },
    { 0x030A0305, "disable_end_game_intermission" },
    { 0x759EC028, "disable_equipment_team_object" },
    { 0xB0006D57, "disable_explosion" },
    { 0xA42E3524, "disable_extra_cam" },
    { 0x2D3E6AD4, "disable_fade" },
    { 0x084E5C8A, "disable_filter_angola_gun_cam" },
    { 0x3D054560, "disable_filter_base_frame_transition" },
    { 0x1ABA1139, "disable_filter_binoculars" },
    { 0x493FA18B, "disable_filter_binoculars_with_outline" },
    { 0x75E16415, "disable_filter_blood_droplets" },
    { 0x5DC1F50F, "disable_filter_blood_spatter" },
    { 0x678B7AE7, "disable_filter_blood_splats" },
    { 0x5FE54ECD, "disable_filter_claw_boot" },
    { 0x71F77805, "disable_filter_custom_tow" },
    { 0xF1A62E7B, "disable_filter_drowning_damage" },
    { 0xA32E572B, "disable_filter_emp" },
    { 0x0671D8B9, "disable_filter_ev_interference" },
    { 0xEB426FA1, "disable_filter_f35_damage" },
    { 0x4A86FCB7, "disable_filter_feedback_blood" },
    { 0x31A9A938, "disable_filter_frame_transition" },
    { 0xACBA895B, "disable_filter_frost" },
    { 0x9A5E99AA, "disable_filter_gasmask" },
    { 0x8B0733FC, "disable_filter_harper_blood" },
    { 0x75D85722, "disable_filter_hazmat" },
    { 0xFD9AB75C, "disable_filter_helmet" },
    { 0x040DFB81, "disable_filter_hud_outline" },
    { 0x1FD7D8FA, "disable_filter_hud_projected_grid" },
    { 0xB291F5E9, "disable_filter_hud_projected_pip" },
    { 0x4A40038E, "disable_filter_karma_lowlight" },
    { 0x3987EE2A, "disable_filter_karma_spiderbot" },
    { 0xA349AD2A, "disable_filter_keyline_blend" },
    { 0xE8A4A279, "disable_filter_lensflare" },
    { 0x08B4A2CF, "disable_filter_massiah" },
    { 0x1ECAC0B5, "disable_filter_oob" },
    { 0xD17703CB, "disable_filter_overdrive" },
    { 0x0053E193, "disable_filter_oxygenmask" },
    { 0xA7ECA1AA, "disable_filter_pakistan3_outline" },
    { 0xD35BC94E, "disable_filter_pentagon_blowout" },
    { 0x2348BD1C, "disable_filter_pentagon_bulgeblur" },
    { 0x4EFC4551, "disable_filter_pentagon_fullscreen" },
    { 0xEE9E6EB7, "disable_filter_pentagon_multicam1" },
    { 0x7C96FF7C, "disable_filter_pentagon_multicam2" },
    { 0x1EEF0721, "disable_filter_radialblur" },
    { 0xBF022458, "disable_filter_rage" },
    { 0x510652AE, "disable_filter_rage_hit" },
    { 0x7DA78A75, "disable_filter_raindrops" },
    { 0x74C70DFD, "disable_filter_rccarcam" },
    { 0x22FD2A5A, "disable_filter_rts_hologram" },
    { 0xACDF3427, "disable_filter_rts_vehicle_damage" },
    { 0x28ACE260, "disable_filter_sam_damage" },
    { 0xFFD46FC4, "disable_filter_satellite_transition" },
    { 0x04858098, "disable_filter_sonar_attachment" },
    { 0xBC6B5811, "disable_filter_sonar_glass" },
    { 0x92FCBC77, "disable_filter_speed_burst" },
    { 0xE8EE9075, "disable_filter_sprite_blood" },
    { 0x972F68B0, "disable_filter_sprite_dirt" },
    { 0xCFB866D9, "disable_filter_sprite_rain" },
    { 0x0E455396, "disable_filter_sprite_transition" },
    { 0xE5A84437, "disable_filter_squirrel_raindrops" },
    { 0x66935CD4, "disable_filter_superflare" },
    { 0x73418308, "disable_filter_tactical" },
    { 0x25548A10, "disable_filter_tacticalmask" },
    { 0x9F3853BE, "disable_filter_teargas" },
    { 0xBB2096A1, "disable_filter_teleportation" },
    { 0xF21915B1, "disable_filter_teleporter_base" },
    { 0xF0467A75, "disable_filter_teleporter_sprite" },
    { 0x4F343C03, "disable_filter_teleporter_top" },
    { 0x48A2212F, "disable_filter_vehicle_damage" },
    { 0x231250B9, "disable_filter_vehicle_hijack_oor" },
    { 0x741DE3D1, "disable_filter_vehiclehijack" },
    { 0x3255F545, "disable_filter_vision_pulse" },
    { 0x9698AB0F, "disable_filter_warp_sr71" },
    { 0xADEB2C19, "disable_filter_water_dive" },
    { 0xC8EC83D4, "disable_filter_water_sheeting" },
    { 0xDECC230D, "disable_filter_zm_turned" },
    { 0x97D58E26, "disable_filter_zodiac_raindrops" },
    { 0x4D236261, "disable_firesale_drop" },
    { 0x2797E8EB, "disable_firing" },
    { 0x0EC10EDE, "disable_flag_for_hut_when_trigger_hit" },
    { 0xAF1DAC3F, "disable_flag_for_wave1_when_trigger_hit" },
    { 0x97B86E6A, "disable_flag_for_wave2_when_trigger_hit" },
    { 0x60060150, "disable_flame_fx" },
    { 0x7CCB9AF0, "disable_for_high_aicount" },
    { 0x22D0173A, "disable_frac" },
    { 0x1F6708EA, "disable_free_perks_before_power" },
    { 0x459201E3, "disable_friendly_color" },
    { 0x6BF14AC4, "disable_friendly_deadlyness" },
    { 0x6EA2C18C, "disable_fx" },
    { 0x7C6DEE09, "disable_fx_upgrade_aquired" },
    { 0x5AAFB5EA, "disable_fx_zmb_tranzit_shield_explo" },
    { 0x02DABBD7, "disable_fx_zmb_wall_buy_semtex" },
    { 0x0513D1EE, "disable_gameplay" },
    { 0xCE9432F3, "disable_gameplay_trigger" },
    { 0x718C6D8C, "disable_ghost_zone_door_ai_clips" },
    { 0x89AEAE25, "disable_grenade_dismount_check" },
    { 0xAEB89E8B, "disable_grenades" },
    { 0x148B6771, "disable_grenades_for_team" },
    { 0x9A49D028, "disable_gunner_weapons_until_after_titlescreen" },
    { 0x365C53F7, "disable_hacking" },
    { 0x17B59FE3, "disable_harper_background_vo" },
    { 0x146411CB, "disable_head_gib" },
    { 0x705829AC, "disable_heat" },
    { 0x8E357031, "disable_heat_behavior" },
    { 0x834CA490, "disable_hero_gadget_activation" },
    { 0x7242F58E, "disable_hero_power_charging" },
    { 0x3EE46EB8, "disable_idle_drift" },
    { 0x26DA1937, "disable_idle_strafing" },
    { 0xCBCEA8F4, "disable_ignoreme_on_stealth_spotted" },
    { 0x673D6E2A, "disable_intermission" },
    { 0xF15FAF1C, "disable_invulnerability_over_time" },
    { 0x218D0AF6, "disable_invulnerability_thread_running" },
    { 0x8AC96CF1, "disable_kill_thread" },
    { 0x16EDC09B, "disable_lens_flare" },
    { 0x81964D6B, "disable_long_death" },
    { 0xA264C0C5, "disable_look_around" },
    { 0x05A5B54C, "disable_make_useable" },
    { 0x21822C71, "disable_manual_switching" },
    { 0x9FA8B6B6, "disable_melee" },
    { 0x96762E2C, "disable_melee_until_flag" },
    { 0xA14D6D84, "disable_melee_wallbuy_icons" },
    { 0x2AB1BA27, "disable_menu" },
    { 0x13F7454C, "disable_mines_at_dome" },
    { 0x0624413D, "disable_missiles" },
    { 0xA60B3F80, "disable_mission_spawn_manager" },
    { 0x7A7BD9A4, "disable_morse_code" },
    { 0x57D8A863, "disable_mount_anim" },
    { 0xE1F9E1FD, "disable_move_killer" },
    { 0xD126B318, "disable_mystery_boxes_in_zone" },
    { 0xA7C4B22B, "disable_nags" },
    { 0x38B3B5CB, "disable_node_arrivals" },
    { 0x26980EED, "disable_nodes" },
    { 0xF923A63B, "disable_nuke_delay_spawning" },
    { 0x7A843D41, "disable_nvg" },
    { 0xE54C54C3, "disable_object" },
    { 0x3FABAA13, "disable_oneshotfx_with_noteworthy" },
    { 0x625294AE, "disable_overheat" },
    { 0x3C155012, "disable_pain" },
    { 0x6754A666, "disable_perk_before_power" },
    { 0xCDFE4920, "disable_perk_machines_in_zone" },
    { 0x2E3F8E7B, "disable_phalanx_cannons" },
    { 0xBF8F9CEB, "disable_player_damage_knockback" },
    { 0x523876CC, "disable_player_move_states" },
    { 0xF6C93DEC, "disable_player_offhand" },
    { 0xC1AB6978, "disable_player_weapon" },
    { 0x77EEDFD1, "disable_player_weapon_fire_for_time" },
    { 0xEB556AD3, "disable_player_weapons" },
    { 0x4E189590, "disable_powerup_if_player_on_bridge" },
    { 0x926F0E24, "disable_print3d_ent" },
    { 0x4B449A58, "disable_prompt_for_player" },
    { 0xA93A5AAD, "disable_protips" },
    { 0x0DD32C70, "disable_pull_out_sword" },
    { 0xFF716478, "disable_quickrevive" },
    { 0x71F91719, "disable_rage" },
    { 0xA362D607, "disable_rambo" },
    { 0xC107A341, "disable_random_alt_weapon_drops" },
    { 0x45BD830C, "disable_random_perk_machines_in_zone" },
    { 0x71146731, "disable_random_weapon_drops" },
    { 0xB1DE766F, "disable_react" },
    { 0x1B0A1D7D, "disable_replace_on_death" },
    { 0x535154AD, "disable_rotate_hud" },
    { 0xB2457172, "disable_scope_view" },
    { 0x61FC3D35, "disable_seam_set" },
    { 0x12C7E390, "disable_side_step" },
    { 0x4FBAA8DA, "disable_sides" },
    { 0x1C0D8FC1, "disable_slingshot" },
    { 0xE9E57045, "disable_slowmo" },
    { 0xC10695F6, "disable_sniper_glint" },
    { 0xFD0BD823, "disable_sound" },
    { 0xD840D202, "disable_spawn_managers" },
    { 0x559986EE, "disable_sprint" },
    { 0x8E5C64CD, "disable_stances_in_zones" },
    { 0x7919A4E5, "disable_straffing_drone_shooting" },
    { 0xFD23EC6F, "disable_surprise" },
    { 0xD174F657, "disable_swim_move_input" },
    { 0x9B532CF5, "disable_swimming" },
    { 0xEF92D9C5, "disable_tacinsert" },
    { 0x719DBEFB, "disable_tactical_walk" },
    { 0xBEE9D8D9, "disable_teleporter_" },
    { 0xA2477BBB, "disable_thermal" },
    { 0xDA04A0A1, "disable_time" },
    { 0x621575B8, "disable_tow_usage" },
    { 0xBD2C5542, "disable_traps" },
    { 0x2FE1E955, "disable_traversal_clip_around_mansion" },
    { 0x2A7B9CEE, "disable_trigger" },
    { 0x3A258C8D, "disable_trigger_with_noteworthy" },
    { 0x22DE851E, "disable_trigger_with_targetname" },
    { 0x895BD111, "disable_triggers" },
    { 0x488C331A, "disable_triggers_with_noteworthy" },
    { 0xC6CD34CD, "disable_triggers_with_targetname" },
    { 0xEAAFF40F, "disable_turnanims" },
    { 0x3E54C8ED, "disable_turns_until_next_goal" },
    { 0x4BBDD74C, "disable_turret" },
    { 0x3E8B6025, "disable_turret_static" },
    { 0x9AF6E9CF, "disable_turrets" },
    { 0x720D8B48, "disable_underwater_snapshot" },
    { 0x68C71127, "disable_use" },
    { 0x219CD1CE, "disable_weapon" },
    { 0xC843D468, "disable_weapon_changes" },
    { 0xD52427E9, "disable_weapon_toggle" },
    { 0xF2037371, "disable_weapons" },
    { 0xABF48C80, "disable_weavers_btr" },
    { 0x5B707A20, "disable_wing_tip_trail" },
    { 0x59EBE171, "disable_zip_buys" },
    { 0x4BCDEF0D, "disableafterlife" },
    { 0x80765127, "disableaimassist" },
    { 0x9E621AC6, "disableaivsaimelee" },
    { 0xF7152589, "disableallparticlefxinlevel" },
    { 0xBF77BAFA, "disableallzonesexcept" },
    { 0x7850127E, "disableammodrop" },
    { 0xEC985C04, "disablearrivalinreach" },
    { 0xE844240D, "disablearrivals" },
    { 0x65961F0A, "disablearrivals_delayed" },
    { 0x6F8FF77F, "disableattachments" },
    { 0xA9CFC7B5, "disableautodetonation" },
    { 0xEF189EB3, "disablebackwardrunngun" },
    { 0x3DB2FECD, "disablebadplace" },
    { 0x8687D408, "disablebattlechatter" },
    { 0x043B32A7, "disablebehaviortracker" },
    { 0x6448C9EE, "disableberserker" },
    { 0x64705521, "disablebulletwhizbyreaction" },
    { 0x11382DEF, "disableburndamage" },
    { 0x00CEC536, "disablecac" },
    { 0x14F14269, "disablechallenges" },
    { 0xD981631B, "disablechar" },
    { 0x83A2CE8D, "disableclassselection" },
    { 0xB4E9A855, "disableclientlinkto" },
    { 0x4301DAB6, "disablecling" },
    { 0x9BC0E56D, "disablecoverab" },
    { 0x91572F2D, "disabled" },
    { 0x4EDFD5B9, "disabled_at_bunker" },
    { 0x87346297, "disabled_at_church" },
    { 0x6EF1243C, "disabled_by_emp" },
    { 0x14EF721C, "disabled_by_special_grenade" },
    { 0xB5878FB8, "disabled_list" },
    { 0x46793F8F, "disabled_perks" },
    { 0x72485AFC, "disabled_sam_counter" },
    { 0x231B7E5C, "disabled_weapon" },
    { 0x3EAB105F, "disabledartmissilelocking" },
    { 0x41A42923, "disabledbyspecial" },
    { 0xE9BA3885, "disabledeathstreak" },
    { 0x52C06BD6, "disabledelayeddeathbodydelete" },
    { 0x07A1A3C4, "disabledetonation" },
    { 0x5E9446B8, "disabledriverfiring" },
    { 0xAF53122E, "disableduplicaterendering" },
    { 0xBB691531, "disabledusability" },
    { 0x2ED57B6D, "disabledweapon" },
    { 0x84DD71CE, "disableelectrodamage" },
    { 0x8477D3E2, "disableexits" },
    { 0x00B2D1DE, "disablefinalkillcam" },
    { 0x4AEADE9A, "disablefiring" },
    { 0xC65A3CE5, "disablefx" },
    { 0x10B4402E, "disablefxaniminsplitscreencount" },
    { 0x824A604A, "disablegenericdialog" },
    { 0x22DD92A9, "disablegrenadesuicide" },
    { 0x6E9C95FF, "disablegunnerfiring" },
    { 0x7E413DBF, "disablehintstring" },
    { 0x5284992D, "disableidlestrafing" },
    { 0x7732147B, "disableinitialholddelay" },
    { 0x4890E520, "disableinvulnerability" },
    { 0xCF83225B, "disablelightning" },
    { 0x38542F25, "disablelockon" },
    { 0x9316BD69, "disablelongdeath" },
    { 0x648AFDE0, "disablelongdeaths" },
    { 0x9BDF0E65, "disablemelee" },
    { 0xC6DA0131, "disablemomentum" },
    { 0x36D875CE, "disablename" },
    { 0x7C24CCDA, "disableobject" },
    { 0xE9210E96, "disableoffhandspecial" },
    { 0x518A4A08, "disableoffhandweapons" },
    { 0xCDD3641C, "disableoutrovisionset" },
    { 0x3C967A2B, "disablepain" },
    { 0x113A0740, "disableplayeroob" },
    { 0xBF2F215D, "disableplayerroundstartdelay" },
    { 0x1E5D39DB, "disableplayerweapons" },
    { 0xEFAE3E4C, "disablepowerups" },
    { 0x29D9F951, "disableprematchmessages" },
    { 0x98848FD7, "disableprimaryweaponswitch" },
    { 0xB9455FD4, "disableproxcheck" },
    { 0xA579E0EB, "disabler" },
    { 0xCAE4C956, "disablercbombtrigger" },
    { 0x62527420, "disablereacquire" },
    { 0xC52872A0, "disablereact" },
    { 0xA322CED5, "disableremoteweaponswitch" },
    { 0xB9250149, "disablerepath" },
    { 0x7D5318D0, "disableresult" },
    { 0xC5829CC8, "disableroundstartdelay" },
    { 0x7F776682, "disables" },
    { 0x32502D04, "disablesceneskipping" },
    { 0x2902F0FC, "disableshader" },
    { 0xEBEC6551, "disablespawner" },
    { 0xE5319D38, "disablespawners" },
    { 0x8742D22A, "disablespawnpointlist" },
    { 0xFA59DE5F, "disablespeedblur" },
    { 0xF2B67583, "disablesprint" },
    { 0xB03EE83A, "disablestattracking" },
    { 0x3802ED0E, "disabletacinsert" },
    { 0xB16ABF25, "disabletargetservice" },
    { 0x781C14E8, "disabletime" },
    { 0xF8EA9EDB, "disabletransitionin" },
    { 0xCDDE274E, "disabletransitionout" },
    { 0x63DF3D25, "disabletrigger" },
    { 0x4816AEC3, "disabletriggerthink" },
    { 0x73C930C5, "disableturns" },
    { 0x7B18782E, "disableturretdismount" },
    { 0x3C64A65B, "disableusability" },
    { 0x28509085, "disablevehicleburndamage" },
    { 0xBD96A419, "disablevehiclesounds" },
    { 0xC1C50EF2, "disablevehiclespawners" },
    { 0x7CC7626E, "disablevpshader" },
    { 0xDE644DF3, "disablewatersurfacefx" },
    { 0xE6152EDE, "disableweaponcycling" },
    { 0x1351D926, "disableweaponcyclingduringhold" },
    { 0x82EA317C, "disableweapondrop" },
    { 0xB67FA293, "disableweaponfire" },
    { 0xC49581EC, "disableweaponreload" },
    { 0x1271A73E, "disableweapons" },
    { 0x4D023CF9, "disablewoundedset" },
    { 0x0D6C4980, "disablezombies" },
    { 0x7BA926D6, "disabling" },
    { 0xC5244E32, "disallow" },
    { 0xFD9A0F7A, "disallow_player_sidearm" },
    { 0xC1551E08, "disallowatmatchstart" },
    { 0x70F93445, "disallowed" },
    { 0xBEDA73BE, "disallowing" },
    { 0xE5642753, "disallowplaceablepickup" },
    { 0x3B84E30B, "disallowremotecontrol" },
    { 0x03FCF7BD, "disallows" },
    { 0xDECF06CF, "disallowvehicleusage" },
    { 0xFAA9701E, "disance" },
    { 0x162C8E70, "disapate" },
    { 0xF2DAF698, "disapear" },
    { 0x01D87449, "disaplayed" },
    { 0xED475388, "disappear" },
    { 0xC9A8AB09, "disappear_fx" },
    { 0xCD5B36B1, "disappear_in_flash" },
    { 0x6FD83303, "disappear_point" },
    { 0x2DAF279B, "disappeared" },
    { 0x30D753D0, "disappearing" },
    { 0x60D8FAA3, "disappears" },
    { 0x04DBCCB2, "disappointment" },
    { 0xCC8D1E73, "disarm" },
    { 0x047AEC33, "disarmable" },
    { 0x917C37F5, "disarmedhackedcarepackage" },
    { 0x6481DAF2, "disarmingcrate" },
    { 0x5868C432, "disc" },
    { 0xD16B9039, "discard" },
    { 0x6FBDDA06, "discard_quickrevive" },
    { 0xEA7A7866, "discarded" },
    { 0x22063B06, "discarded_zones" },
    { 0x30E9844F, "discarding" },
    { 0x7F9F5CEE, "discardtime" },
    { 0x73528C43, "discoloration" },
    { 0x9FE92ABB, "disconect" },
    { 0x083C01D4, "disconnecct" },
    { 0x643A7DAF, "disconnect" },
    { 0x18C2311A, "disconnect_debris_paths" },
    { 0xC4355756, "disconnect_door_zones" },
    { 0x46C81208, "disconnect_failsafe_pad_poi_clean" },
    { 0xDC5C8FBE, "disconnect_node" },
    { 0xD3A494B6, "disconnect_paths" },
    { 0x1329CAC5, "disconnect_paths_around_me_based_on_speed" },
    { 0xD0B76CF7, "disconnect_paths_around_vehicle" },
    { 0xA0C91054, "disconnect_paths_when_done" },
    { 0xD0448B20, "disconnect_paths_whenstopped" },
    { 0xAF31A1B5, "disconnect_paths_while_moving" },
    { 0x1A4E96AC, "disconnect_reconnect_paths" },
    { 0x9E10E80A, "disconnect_watcher" },
    { 0x78956CF4, "disconnected" },
    { 0x43A93591, "disconnecting" },
    { 0x6AAD7E03, "disconnecting_player" },
    { 0xD4206467, "disconnection" },
    { 0xE30209C5, "disconnectpathdetail" },
    { 0x75CDB9A5, "disconnectpathonstop" },
    { 0x14C24D9D, "disconnectpaths" },
    { 0x05C7DD9A, "disconnectpathstime" },
    { 0x3EDA8902, "disconnectpathswrapper" },
    { 0xFC00C6F6, "disconnects" },
    { 0xD80C4198, "disconnecttraverses" },
    { 0x03D78F33, "disconnnect" },
    { 0x4D668230, "discounting" },
    { 0xFEC376F9, "discourage" },
    { 0xF04EF914, "discover" },
    { 0xADD3B092, "discover_bridge3_guys" },
    { 0x73ED57E8, "discover_dig_site_trigger_touch" },
    { 0x084407D1, "discover_dig_site_vo" },
    { 0xEE50B901, "discover_pack_a_punch" },
    { 0xE5719EAA, "discover_pap_vo_played" },
    { 0x4E2AD5B7, "discovered" },
    { 0xA284893E, "discreet" },
    { 0x0EC53CC6, "discriminant" },
    { 0xD8C2B9BD, "discs" },
    { 0x2F4608F3, "discs_to_rotate" },
    { 0xE15F08F2, "discussed" },
    { 0xB38E1EBD, "discusses" },
    { 0x243F5ED9, "discussion" },
    { 0x95F49F90, "discussions" },
    { 0xBC45FAF6, "disembarks" },
    { 0x6F220CD6, "disengage" },
    { 0xA19205E6, "disengaged" },
    { 0x26711110, "disguise" },
    { 0x442AF5C8, "disguise_anim" },
    { 0xEC5712F4, "disguised" },
    { 0x627A1D11, "dish" },
    { 0x49BDB88B, "dish_base" },
    { 0x1F97DC0C, "dish_gears" },
    { 0x36FD1D18, "dish_inside" },
    { 0x1070D178, "dish_poi" },
    { 0x89ED62BC, "dish_stop" },
    { 0x9B57B3AD, "dish_top" },
    { 0x8D0BB8BE, "dished" },
    { 0x2F26FB41, "dishes" },
    { 0xD7F4E175, "disint_chance" },
    { 0x9CFB130C, "disintegrate" },
    { 0x43CD4A49, "disintegrate_zombie" },
    { 0x5C01ADCE, "dismantle" },
    { 0xFC335CFC, "dismissed" },
    { 0xDCDA4442, "dismount" },
    { 0x59739470, "dismount_enabled" },
    { 0x034F6B36, "dismount_message" },
    { 0x7530496D, "dismount_right" },
    { 0xF8BE544B, "dismount_start" },
    { 0x06DD9D87, "dismount_think" },
    { 0x3262C706, "dismount_time" },
    { 0x2BF14D50, "dismount_timer" },
    { 0x68DD2D75, "dismount_timer_over" },
    { 0xBE68BFFB, "dismount_vehicle" },
    { 0xF2761F55, "dismounted" },
    { 0x0F0F97AE, "dismounting" },
    { 0x26816B8D, "dismounts" },
    { 0x7AF07368, "dismounttrig" },
    { 0xD1A25160, "dismouting" },
    { 0x46A52FAE, "disobey" },
    { 0xB6D44374, "disorderly" },
    { 0xB2EF859F, "dispatch" },
    { 0x8845D346, "dispensable_sm_count" },
    { 0xF4F6F010, "displace" },
    { 0xE863628C, "displacement" },
    { 0x1F68BC9A, "displacement_vector" },
    { 0x116C6D27, "displacement_vector1" },
    { 0x9F64FDEC, "displacement_vector2" },
    { 0x678029F5, "displaceprint" },
    { 0x31FC30CA, "displaceredshirts" },
    { 0x6BEF7095, "display" },
    { 0x6861553D, "display_3d" },
    { 0x03A76413, "display_ai_supplements" },
    { 0x752B17E7, "display_ai_supplements_menu" },
    { 0xF2242F9A, "display_air_support_hint_console" },
    { 0x136A3E58, "display_air_support_hint_pc" },
    { 0x1081250A, "display_animname" },
    { 0x49E24C84, "display_animsound" },
    { 0xBE23B5B2, "display_closest_only" },
    { 0x7BD1F8A4, "display_dev_info" },
    { 0x343A1217, "display_domination_info" },
    { 0x19E93060, "display_ent_origin" },
    { 0x4EC45174, "display_fail" },
    { 0x02B18760, "display_final_shooting_trajectory" },
    { 0x3B714815, "display_fx_add_options" },
    { 0x896DC4AD, "display_fx_info" },
    { 0xACDA0F13, "display_hint" },
    { 0xF55DC342, "display_hints" },
    { 0x7451B38F, "display_hud_player_leader" },
    { 0x8FACC748, "display_hud_player_team_member" },
    { 0x9E89FE83, "display_in_box" },
    { 0x662F18EC, "display_info" },
    { 0xDD9CDF38, "display_level_name" },
    { 0x7EAE555D, "display_message" },
    { 0xD73FEDD2, "display_module_text" },
    { 0x6DAE5E5E, "display_plane_speed" },
    { 0xAAA1BE0C, "display_player_health" },
    { 0x28DAAEC0, "display_progress_info" },
    { 0xA3E702B5, "display_prompt_until_player_hits_attack" },
    { 0x76C29863, "display_rank_column" },
    { 0x4836FF5C, "display_rewards" },
    { 0x259F2FA6, "display_scene_menu" },
    { 0xD484A0B5, "display_seq" },
    { 0x1E569E21, "display_skiptos" },
    { 0xD65619D7, "display_sniper_hint" },
    { 0x68003601, "display_stage_title" },
    { 0xF322A18F, "display_starts" },
    { 0xD9DA1B9C, "display_starts_pressed" },
    { 0xBBBB8E53, "display_string" },
    { 0xBB7AAF31, "display_success" },
    { 0xC3A23077, "display_success_text_time" },
    { 0xB014FAAD, "display_tag_origin" },
    { 0xD97DD7CD, "display_text" },
    { 0x5F3DA143, "display_time" },
    { 0xA0D5BB7C, "display_time_survived" },
    { 0xDFCC11F8, "display_trigger_touch_message" },
    { 0x3F7F62D2, "display_unavailable_time" },
    { 0x81527DF0, "display_unit_hud" },
    { 0x88ABF42D, "display_vo" },
    { 0x3FD0BC8D, "displaychallengecomplete" },
    { 0x413BA843, "displaycontract" },
    { 0xAB3F15C2, "displayed" },
    { 0xEB6DACC1, "displayed_hints" },
    { 0x838DBA2A, "displayendgame" },
    { 0x694CD070, "displayendgamemilestone" },
    { 0x40F86C93, "displayendgamepopups" },
    { 0x2A88A806, "displaygameend" },
    { 0x95B75203, "displaygamemodemessage" },
    { 0x3DEACD24, "displayhalftimetext" },
    { 0x069DF493, "displaying" },
    { 0xCD60B997, "displayingcarryhint" },
    { 0xB856ED96, "displayingdamagehints" },
    { 0xC3E674A3, "displaykillstreak" },
    { 0x49E598DF, "displaykillstreakhackedteammessagetoall" },
    { 0xABC9CBF9, "displaykillstreakstartteammessagetoall" },
    { 0x8806CE2B, "displaykillstreakteammessagetoall" },
    { 0xEC576E9F, "displaylockoncanceledmessage" },
    { 0xE6623E96, "displaymedal" },
    { 0xD31A1DC2, "displaymessage" },
    { 0xA2BCC5C6, "displaymissionfailed" },
    { 0x62C08B38, "displaymomentumpopupswaiter" },
    { 0xB82BBE1C, "displayname" },
    { 0x66DC8C94, "displaypage" },
    { 0xF4BDEE85, "displayperk" },
    { 0x7A243F7C, "displayplayerdead" },
    { 0xD3829ECA, "displaypopupswaiter" },
    { 0x0A631550, "displayrankup" },
    { 0xD87E5C3E, "displayroundend" },
    { 0x1EBBB333, "displayroundendtext" },
    { 0xFEFC8B03, "displayroundswitch" },
    { 0x6D0E71E4, "displays" },
    { 0x1BF15196, "displaysign" },
    { 0x32AC38FB, "displayspawnmessage" },
    { 0x04F6EAA7, "displayteammatedead" },
    { 0x4CB0411F, "displayteammessage" },
    { 0x7DE845ED, "displayteammessagetoall" },
    { 0x6793049F, "displayteammessagetoteam" },
    { 0x57624CB5, "displayteammessagewaiter" },
    { 0x8CEEA16F, "displaytextonhudelem" },
    { 0xD2987025, "displaythreat" },
    { 0xE289D4B4, "displaytopplayermodel" },
    { 0x06144EF9, "displaywagerpopup" },
    { 0xDA1F4811, "displayweakpoint" },
    { 0x1E6D58C9, "disputed" },
    { 0xBBE83CC6, "disputed_territory" },
    { 0x71734A5A, "disregard" },
    { 0xF02CDDED, "disregarded" },
    { 0x2E085FEF, "disregardheight" },
    { 0x2B660355, "disregards" },
    { 0xEB446C4B, "disrupted" },
    { 0x37EE8C4F, "disruptor" },
    { 0x9C08CC93, "disrupts" },
    { 0x8F938CDE, "dissapears" },
    { 0x51C36AE1, "dissappear" },
    { 0x85C17788, "dissappears" },
    { 0x8B97E54F, "dissipate" },
    { 0xB039A79C, "dissolve" },
    { 0xCA34D554, "dissolve_material" },
    { 0x2F844E85, "dissolving" },
    { 0x025A59A4, "dissovle" },
    { 0x2A97D9FD, "dist" },
    { 0x83E2084E, "dist1" },
    { 0x5DDF8DE5, "dist2" },
    { 0x6FAFD22D, "dist2dfromstartpostotargetsq" },
    { 0x30B7E9BA, "dist2dtostartpos" },
    { 0x4BD39D6F, "dist2dtotargetsq" },
    { 0x193555A3, "dist2rd" },
    { 0x96E2A1C9, "dist_1" },
    { 0x7C17B264, "dist_1_to_2" },
    { 0xBCE51C32, "dist_2" },
    { 0xBE060C58, "dist_2_to_3" },
    { 0xF505910E, "dist_2dsq" },
    { 0x2200A701, "dist_3_to_1" },
    { 0x1A1389B4, "dist_add_curr" },
    { 0x3F407B0B, "dist_add_up" },
    { 0xDF8006F7, "dist_array" },
    { 0x306D91CD, "dist_away_from_sweet_line" },
    { 0x83DD0271, "dist_back" },
    { 0x18B45CA4, "dist_behind" },
    { 0xB385C170, "dist_between" },
    { 0x80D1D5AC, "dist_beyond_enemy" },
    { 0x1BC2FB6A, "dist_bl" },
    { 0xD78C7664, "dist_br" },
    { 0x996D7BF1, "dist_bus_attack" },
    { 0xD8DA25C8, "dist_cap" },
    { 0x75C0F5CA, "dist_cap_swap" },
    { 0x836D53F8, "dist_check" },
    { 0xF7EFFA79, "dist_closest" },
    { 0x26897349, "dist_crash" },
    { 0xFB914B00, "dist_curr" },
    { 0x173E9539, "dist_difference" },
    { 0x0D92FA24, "dist_enemy" },
    { 0x34781226, "dist_f" },
    { 0xE1CF5CB1, "dist_fix" },
    { 0xF168A4E7, "dist_forward" },
    { 0x66FDEA0D, "dist_from_boundary" },
    { 0x26A37369, "dist_from_enemy" },
    { 0x874E9DA7, "dist_from_jeep" },
    { 0xC5AE8548, "dist_from_jeep_reverse" },
    { 0x5811A5B8, "dist_from_player" },
    { 0xC3444ADB, "dist_from_pos2" },
    { 0xD73DF1F2, "dist_from_rez" },
    { 0x3D65D130, "dist_from_target" },
    { 0x81497095, "dist_from_turret2" },
    { 0x6EB0F855, "dist_front" },
    { 0xF0197BC3, "dist_fwd" },
    { 0xC01D8C0A, "dist_in_front_of_enemy" },
    { 0x33166116, "dist_init" },
    { 0x6B9CF670, "dist_kill" },
    { 0x1FDDE3FA, "dist_max" },
    { 0xE279D8E4, "dist_min" },
    { 0xAC81EC9B, "dist_modifier" },
    { 0x335A9C2A, "dist_mult" },
    { 0x166F0573, "dist_next" },
    { 0xC0C69015, "dist_pct" },
    { 0xAC45A23F, "dist_player" },
    { 0xC22E229E, "dist_pos" },
    { 0x53D06A65, "dist_range_attack_max" },
    { 0x3EB1C2CB, "dist_range_attack_min" },
    { 0x7DA0D599, "dist_ratio" },
    { 0x76D66DB1, "dist_rear_max" },
    { 0xE44E4C0F, "dist_rear_min" },
    { 0x3DB32236, "dist_right" },
    { 0xEDCC7754, "dist_scalar" },
    { 0xC30EA5E1, "dist_side" },
    { 0x2EE42964, "dist_so_far" },
    { 0xCEA909A8, "dist_sq" },
    { 0xCA17AD74, "dist_sq_from_ied" },
    { 0xD37DD4D2, "dist_sq_to_end" },
    { 0x751DD4B5, "dist_sq_to_tag" },
    { 0xDDDF3FDF, "dist_sq_to_tank" },
    { 0x54736A3C, "dist_sqd" },
    { 0xA846CEDA, "dist_sqr" },
    { 0xE87FD02A, "dist_sqrd" },
    { 0xDB297AA3, "dist_squared" },
    { 0x71066A4B, "dist_struct" },
    { 0x2D696D70, "dist_tank" },
    { 0x1450F762, "dist_thresh" },
    { 0x81FEA5F9, "dist_threshold" },
    { 0xC98DEB32, "dist_to_bomb" },
    { 0xF8350176, "dist_to_check" },
    { 0xEB90D9E1, "dist_to_closest_player" },
    { 0xEB870278, "dist_to_enemy_squared" },
    { 0x3D921577, "dist_to_goal" },
    { 0x5A456F77, "dist_to_ground" },
    { 0x564DF8B8, "dist_to_impact" },
    { 0xF76AD085, "dist_to_keep" },
    { 0x57B120F3, "dist_to_least_hunted_sq" },
    { 0x59D627F4, "dist_to_next_node" },
    { 0x453F3BAA, "dist_to_node" },
    { 0x9CFB7E11, "dist_to_player" },
    { 0xA3D0A3AC, "dist_to_point" },
    { 0x8446333E, "dist_to_tank" },
    { 0x002F30A9, "dist_to_target" },
    { 0xC52B2D64, "dist_to_target_sq" },
    { 0x5FA2A69B, "dist_to_trap" },
    { 0x2B3D52C1, "dist_to_zone_origin" },
    { 0x291DE433, "dist_touching" },
    { 0xD5C4512B, "dist_travelled" },
    { 0xF1DA5067, "dist_up" },
    { 0xAEC0EA43, "dist_update" },
    { 0x7F5EDE6D, "dist_vector" },
    { 0x3DB20414, "dist_warn" },
    { 0xC7098117, "dist_x_death" },
    { 0x8A19B362, "dist_x_death_start" },
    { 0xC384EF3B, "dist_x_max" },
    { 0x729F55BE, "dist_x_max_start" },
    { 0xD8A396D5, "dist_x_min" },
    { 0x4657DAD1, "dist_y" },
    { 0x3753297A, "dist_y_death" },
    { 0x6017C773, "dist_y_death_start" },
    { 0x17784F6E, "dist_y_max" },
    { 0xE02AEA4F, "dist_y_max_start" },
    { 0x6A4FBE30, "dist_y_min" },
    { 0x6E88F005, "dist_y_min_start" },
    { 0x6C5A553A, "dist_z" },
    { 0xAD589456, "dist_zombie" },
    { 0x7D15E2F8, "distance" },
    { 0xA74F2041, "distance1" },
    { 0xCD519AAA, "distance2" },
    { 0x087EA89A, "distance2d" },
    { 0xEF2A38B6, "distance2dsq" },
    { 0x316422D1, "distance2dsquared" },
    { 0x2A62B575, "distance_2_player" },
    { 0x355083C2, "distance_2_player_sqr" },
    { 0x40125BA9, "distance_2d" },
    { 0xEC6C19F7, "distance_ahead_start_slowing" },
    { 0x798C0EC5, "distance_ahead_stop_slowing" },
    { 0xF5263C8E, "distance_along" },
    { 0x27E438FB, "distance_apart" },
    { 0x64FBD7B6, "distance_between_players" },
    { 0x11929D1F, "distance_between_rumble" },
    { 0x34CBD03C, "distance_between_wheels" },
    { 0x0D3A5A95, "distance_check" },
    { 0xADC15622, "distance_check_sqr" },
    { 0x08343E19, "distance_convoy" },
    { 0x74EF1A2F, "distance_cull" },
    { 0x72F9D65E, "distance_diff" },
    { 0xF4297DDF, "distance_down_path" },
    { 0x57766C02, "distance_factor" },
    { 0xD671A4DF, "distance_fight_smoke_hint" },
    { 0xBC83C35C, "distance_foward" },
    { 0x62887B19, "distance_from_axis" },
    { 0xC22C11D3, "distance_from_explosion" },
    { 0x4B4F983F, "distance_from_jump_origin2" },
    { 0xEDA764E8, "distance_from_origin" },
    { 0x463189F5, "distance_from_player" },
    { 0x2A2DD1AA, "distance_in" },
    { 0xF76E234B, "distance_max" },
    { 0x47E360A0, "distance_moved" },
    { 0x4AB1C04B, "distance_nearest" },
    { 0x0EA2C079, "distance_num" },
    { 0xF2D9D92D, "distance_ok" },
    { 0x4583F550, "distance_player" },
    { 0x98E190DF, "distance_score" },
    { 0xF2926B7C, "distance_shutdown_override" },
    { 0x24C4F8DB, "distance_sq" },
    { 0x67407262, "distance_square" },
    { 0x941AD982, "distance_squared" },
    { 0x3E1604C7, "distance_squared_check" },
    { 0x601BE3FE, "distance_squared_to_player" },
    { 0x8E669FBA, "distance_squared_to_target_node_pos" },
    { 0xBB8A446C, "distance_tag_8" },
    { 0xE18CBED5, "distance_tag_9" },
    { 0xF9E057FC, "distance_to" },
    { 0x4D8C10E1, "distance_to_ai" },
    { 0x15718789, "distance_to_black_hole" },
    { 0x5C429DAD, "distance_to_centrifuge" },
    { 0x8D53EF85, "distance_to_closest_enemy_emp_ui_model" },
    { 0x12E9F62D, "distance_to_convoy" },
    { 0x24721462, "distance_to_end" },
    { 0x18E412EB, "distance_to_enemy_less_than" },
    { 0xDEAD4BF0, "distance_to_move" },
    { 0x51904648, "distance_to_owner" },
    { 0xDC86D025, "distance_to_play_sound" },
    { 0x29561114, "distance_to_player" },
    { 0xC757740C, "distance_to_target" },
    { 0xB45B2E5A, "distance_tracker_aggressive_distance" },
    { 0xE76D7512, "distance_tracker_aggressive_height" },
    { 0x641BA580, "distance_traveled" },
    { 0x1A553B0D, "distance_warning" },
    { 0x18076570, "distance_warning_percentage" },
    { 0x651CC2A2, "distance_warning_percentage_default" },
    { 0x82287A84, "distancealongtrack" },
    { 0xC91A3ADD, "distancebetweencars" },
    { 0x89CC2AF0, "distancecheck" },
    { 0x5D8DFB8A, "distancedelta" },
    { 0xCBCBDC32, "distanceentityandsubwoofer" },
    { 0x77EF7A73, "distancefromcenter" },
    { 0xFC057FC9, "distancefromground" },
    { 0x87379D4F, "distancefromplayertobox" },
    { 0x6344BFF7, "distancefrompoint1" },
    { 0x00F37C5E, "distancefromtagorigin" },
    { 0x5FE0DEB8, "distanceinches" },
    { 0x2E3897D9, "distanceincreaseratio" },
    { 0x34FF10C9, "distancelimitmax" },
    { 0x4FF43C77, "distancelimitmin" },
    { 0x89F7F660, "distancemask" },
    { 0x5D3404E5, "distanceminthresholdsq" },
    { 0xC1A962D4, "distancemod" },
    { 0x095E32D9, "distancemoved" },
    { 0xE713A30A, "distancemoving" },
    { 0x6A2E61AD, "distanceobject" },
    { 0x2172EF28, "distanceobjectforwholeteamthink" },
    { 0x3F57B8BD, "distanceobjectplayertouchthink" },
    { 0x0D5730FB, "distanceobjectthink" },
    { 0xB4D41F6A, "distanceperupdate" },
    { 0xB091D6B4, "distanceprimaryenemytotargetsqr" },
    { 0x73F2AF53, "distances" },
    { 0x580E4124, "distancescalarsq" },
    { 0xDE3E8C8C, "distanceselftotargetsqr" },
    { 0x53DFDEB0, "distancesq" },
    { 0xE636C4B2, "distancesqr" },
    { 0xC8C31226, "distancesqrtoleft" },
    { 0xD69CDBBD, "distancesqrtoright" },
    { 0xCB3D1C9B, "distancesquared" },
    { 0x926804F4, "distancethisround" },
    { 0x13B2DEF1, "distancethreshold" },
    { 0x378CFD61, "distancethresholdsq" },
    { 0xCB7EB1B2, "distancetoend" },
    { 0xB555BEAD, "distancetoenemy" },
    { 0xE0942FDD, "distancetoenemysq" },
    { 0xBA1ABD85, "distancetoenemysqr" },
    { 0x41BFE992, "distancetoentity" },
    { 0x0BD1C7A4, "distancetoexplosion" },
    { 0xE63E8B6E, "distancetofirstrotate" },
    { 0xABC6040E, "distancetogoal" },
    { 0x24E1AAEA, "distancetogoalsq" },
    { 0xCDB20D3C, "distancetogoalsqr" },
    { 0x747FA5DB, "distancetogrenade" },
    { 0x72CBB824, "distancetoplayer" },
    { 0x9742F62B, "distancetopointsqr" },
    { 0xBA6EA12E, "distancetopulse" },
    { 0xE529415C, "distancetotarget" },
    { 0xEDF6415E, "distancetotargetsqr" },
    { 0xAEC0D418, "distant" },
    { 0x976B2AB0, "distant_explosion" },
    { 0xBDBEBC61, "distant_explosion_dialogue" },
    { 0x10F6D835, "distant_explosion_event" },
    { 0x05B31D62, "distant_explosion_guard" },
    { 0xB26DC433, "distant_explosion_helicopters" },
    { 0xAB1DB68B, "distant_explosion_reznov" },
    { 0xC1D03651, "distant_explosion_vignette" },
    { 0x6081E31B, "distant_explosions" },
    { 0x0263212D, "distant_explosions_setup" },
    { 0x2C87A243, "distant_rappel_01" },
    { 0xD78CF3F6, "distant_rappel_01_start" },
    { 0xBA803308, "distant_rappel_02" },
    { 0x7830454D, "distant_rappel_02_start" },
    { 0xCD87D5FF, "distant_retreater_setup" },
    { 0x9EABC204, "distant_retreaters" },
    { 0x296F241F, "distant_rocket" },
    { 0x592915D0, "distant_rocket_arm" },
    { 0x3138DD29, "distant_rocket_arm1" },
    { 0x507137E3, "distant_rocket_arm1_move" },
    { 0x573B5792, "distant_rocket_arm2" },
    { 0x2230EE66, "distant_rocket_arm2_move" },
    { 0x7D3DD1FB, "distant_rocket_arm3" },
    { 0x0A43785D, "distant_rocket_arm3_move" },
    { 0xA3404C64, "distant_rocket_arm4" },
    { 0xBA17FCD8, "distant_rocket_arm4_move" },
    { 0xF7F1AFC4, "distant_rocket_engine" },
    { 0xD4668E5B, "distant_rocket_gantry" },
    { 0xF2974568, "distant_rocket_gantry1" },
    { 0x1CAAE7DC, "distant_rocket_gantry1_move" },
    { 0x649EB4A3, "distant_rocket_gantry2" },
    { 0x6B21E2A5, "distant_rocket_gantry2_move" },
    { 0xBABDE48B, "distant_rocket_launch" },
    { 0x46D4E143, "distant_rockets_think" },
    { 0xADC58735, "distantpoints" },
    { 0x2C18542D, "distawayfromengagementarea" },
    { 0x5EF6D693, "distbetween" },
    { 0xEF8D4FF3, "distcheck" },
    { 0x3BFF0BB8, "distcurrentsq" },
    { 0x4272BE95, "distdelta" },
    { 0x76321991, "distengagementheight" },
    { 0x36F8EEF5, "distfrac" },
    { 0x4177F319, "distfrom" },
    { 0x520BFDDC, "distfromideal" },
    { 0xFE369119, "distfrompreferredheight" },
    { 0x22D236D8, "distfromtarget2d" },
    { 0xDF3426AD, "distinchessq" },
    { 0x631A8FC9, "distinct" },
    { 0x56276774, "distinguish" },
    { 0xBFB4D78C, "distinguishable" },
    { 0x7FF670D2, "distinmiles" },
    { 0xC36F82A7, "distlerpval" },
    { 0x340C4AC5, "distmax" },
    { 0x1EEDA32B, "distmin" },
    { 0x7BD9AC3A, "distnace" },
    { 0x097D42D8, "distortion" },
    { 0x37A06573, "distover1sec" },
    { 0xD5121454, "distracted" },
    { 0x22F282AF, "distracted_guys_spawn" },
    { 0xC31810DF, "distractedguys_alert" },
    { 0x6C2A1E62, "distractedguys_alert_trigger" },
    { 0xFFBF348C, "distractedguys_animate" },
    { 0xBBC3847A, "distractedguystruct" },
    { 0xBB461771, "distracting" },
    { 0x4BBD4647, "distraction" },
    { 0xE9E0D1E0, "distraction_anim_bowman" },
    { 0xF9B08808, "distraction_anim_brooks" },
    { 0x94CB7714, "distraction_anim_guard1" },
    { 0x06D2E64F, "distraction_anim_guard2" },
    { 0xC3696736, "distraction_anim_woods" },
    { 0x84FC951C, "distress" },
    { 0xB47216FC, "distribute" },
    { 0xB47E2C70, "distributed" },
    { 0x5E67DEBF, "distributes" },
    { 0x86D49A9B, "distribution" },
    { 0x1C6280D7, "district" },
    { 0x8B8A1CC3, "distrust" },
    { 0x42327639, "distscore" },
    { 0x2C3E05AD, "distsq" },
    { 0x0C29813E, "distsq1" },
    { 0xE62706D5, "distsq2" },
    { 0x4D1B293B, "distsqfromenemy" },
    { 0x8E298A96, "distsqfromnodetoenterpos" },
    { 0x2BE11DF5, "distsqmax" },
    { 0x66C5A115, "distsqr" },
    { 0x0661F78B, "distsqrd" },
    { 0x8315FE13, "distsqrd2" },
    { 0x8948C452, "distsqtoenemy" },
    { 0x3F575302, "distsqtonode" },
    { 0x195B95B7, "distsqtoshootpos" },
    { 0x9FEE669C, "distsquared" },
    { 0x799278CE, "diststring" },
    { 0xB8357D4E, "distsum" },
    { 0xBDE9F2D3, "disttoanimstart" },
    { 0x4DA6EA94, "disttoapproachpoint" },
    { 0x3BD3DCDD, "disttoarea" },
    { 0x4C5FB516, "disttobaitnode" },
    { 0xBCA12E13, "disttobarrier" },
    { 0x6A273C02, "disttoenemy" },
    { 0xDE7AFF98, "disttoenemysqr" },
    { 0xD00625E9, "disttoenemysquared" },
    { 0x4215843F, "disttogoal" },
    { 0x0DBBCECB, "disttogoalsq" },
    { 0x24178BC8, "disttonodesqr" },
    { 0xE2D16E6E, "disttoorigin2d" },
    { 0x5795F122, "disttooriginscore" },
    { 0x9F488299, "disttoplayer" },
    { 0xABF8FB79, "disttoplayer2" },
    { 0xD28C9F8A, "disttoplayerbase" },
    { 0x8678B60A, "disttopoi" },
    { 0xAA384760, "disttopos" },
    { 0xF613EADB, "disttoscrambler" },
    { 0x206FFBAB, "disttoside" },
    { 0x87A72774, "disttosquad" },
    { 0xBC437B91, "disttotarget" },
    { 0x790CE801, "disttotargetsq" },
    { 0x86920B57, "disttotop" },
    { 0x1037638E, "disttovictim" },
    { 0x99C57EA9, "disturbed" },
    { 0x5035A684, "distx_death" },
    { 0xD1F93C40, "distx_max" },
    { 0x2AF70DF1, "disty_death" },
    { 0x7FA66C5D, "disty_max" },
    { 0xBD0A7773, "disty_min" },
    { 0x9CAB0685, "ditch" },
    { 0xAAC7E068, "ditch_spawner_a" },
    { 0x6B96A04F, "ditch_spawner_a_strat" },
    { 0x1CCF4FA3, "ditch_spawner_b" },
    { 0x39DCD000, "ditch_spawner_b_strat" },
    { 0xB8C866FD, "ditch_street_friendlies" },
    { 0x80A0DDE7, "ditto" },
    { 0x550AE8CE, "div" },
    { 0x2D98438A, "div_time" },
    { 0x2C882D77, "dive" },
    { 0x99EF7A20, "dive_and_betty" },
    { 0xC485DEB2, "dive_and_surface_audio" },
    { 0x3DE8705A, "dive_anim_ai" },
    { 0x811CEB3F, "dive_anim_player" },
    { 0xF8ADF7A8, "dive_mask_off" },
    { 0x2AB0A76E, "dive_to_prone" },
    { 0x708C7F4C, "dive_traverse" },
    { 0x7E34ED7A, "dive_trigger" },
    { 0xC0341638, "diveanim" },
    { 0x3A439011, "dived" },
    { 0x8FD75683, "divemask" },
    { 0x9FED83DE, "divemask_equip" },
    { 0x28E431CD, "divemask_unequip" },
    { 0x9B80555F, "diver_splash" },
    { 0xA93C3864, "diver_vignette" },
    { 0x4E39A567, "diver_waiting" },
    { 0x9D5E2453, "diverge" },
    { 0x766B6CCE, "divers" },
    { 0xB85F08C1, "divert" },
    { 0x95F5E109, "divertclackerrange" },
    { 0x597E12AE, "diverted" },
    { 0x58779AAE, "dives" },
    { 0xBC49F1EF, "divespot" },
    { 0x814CA28B, "divetobase" },
    { 0x6F6C35CB, "divetonuke" },
    { 0x5A7E24D5, "divetonuke_explode" },
    { 0x4692FC60, "divetonuke_explode_network_optimized" },
    { 0x29499EC2, "divetonuke_host_migration_func" },
    { 0x4DADAD8D, "divetonuke_off" },
    { 0xAB41EFA1, "divetonuke_on" },
    { 0xBFCB6B7A, "divetonuke_perk_machine_setup" },
    { 0xD6883799, "divetonuke_perk_machine_think" },
    { 0xC008656D, "divetonuke_precache" },
    { 0x42FC85BD, "divetonuke_precache_override_func" },
    { 0x031815EF, "divetonuke_register_clientfield" },
    { 0x230C333C, "divetonuke_set_clientfield" },
    { 0xFDE9FA72, "divetopos" },
    { 0xCD8D74AE, "divetoprone" },
    { 0x471486A2, "divide" },
    { 0x3033EEC2, "divided" },
    { 0x9108DCCE, "dividedmovetime" },
    { 0xC4643BB7, "dividers" },
    { 0x4213B76D, "divides" },
    { 0x540F8F93, "dividing" },
    { 0x9912AD72, "diving" },
    { 0x660A1C05, "divisble" },
    { 0xD400A8FE, "divisible" },
    { 0x8974DFF0, "division" },
    { 0x35DDA209, "divisor" },
    { 0x0D7706C7, "divy_it_up" },
    { 0x5C09F085, "dizzy" },
    { 0xA3019073, "dj" },
    { 0x531776F6, "dj_jump_spawn" },
    { 0xDBD2EDDD, "dj_killed" },
    { 0x7CFF160A, "dk" },
    { 0xD6D03CA9, "dk_leave_thread" },
    { 0x2A5F77DB, "dkgreen" },
    { 0x5DEB0196, "dlaufer" },
    { 0x59ED0F44, "dlc" },
    { 0x9A09DBE5, "dlc1" },
    { 0xE60ED0B7, "dlc3" },
    { 0x9AF8E71F, "dlc3_client" },
    { 0x6325B031, "dlc3_code" },
    { 0xD91A08A8, "dlc3_fx" },
    { 0x4BAB3A56, "dlc3_teleporter" },
    { 0x5EC9856D, "dlc3_threadcalls" },
    { 0x37C12215, "dlc3_threadcalls2" },
    { 0xCEF0D8AE, "dlc3_zombie_five_teleports" },
    { 0x01FFF241, "dlc5" },
    { 0xC1E325A0, "dlg" },
    { 0xB2D1F001, "dlg_easy_rhino_done" },
    { 0x756DEDE6, "dlg_ent" },
    { 0x9F1DD70C, "dlg_intro_1min_done" },
    { 0x78E78577, "dlg_intro_onground_fps_done" },
    { 0x1B187359, "dlg_kill_order_done" },
    { 0xE19649DE, "dlg_msg" },
    { 0x40047B31, "dlg_notetrack_fired" },
    { 0x542EB761, "dlight" },
    { 0xDC4EC040, "dlight_ent1" },
    { 0x4E562F7B, "dlight_ent2" },
    { 0x2853B512, "dlight_ent3" },
    { 0x9A5B244D, "dlight_ent4" },
    { 0x3DFBEDBA, "dlm" },
    { 0x7ED6A348, "dlsnfx" },
    { 0xC9040ADC, "dm" },
    { 0x7937A894, "dm_rules" },
    { 0xABA18F4F, "dm_wins_index" },
    { 0x077B3718, "dmendelsohn" },
    { 0xE7A9EB0B, "dmg" },
    { 0x3552E158, "dmg1" },
    { 0x3C3C9430, "dmg1_id" },
    { 0xA75A5093, "dmg2" },
    { 0x8157D62A, "dmg3" },
    { 0xAC802A52, "dmg_amnt" },
    { 0xD2A046EA, "dmg_amount" },
    { 0x2BA85E3B, "dmg_attacker" },
    { 0x2F222D2D, "dmg_ent" },
    { 0xCA2A453F, "dmg_factor" },
    { 0x8D9432B1, "dmg_factor_calc" },
    { 0x15822B5D, "dmg_factor_size" },
    { 0x6EE3F244, "dmg_factored" },
    { 0xC112341F, "dmg_faked" },
    { 0xB3461102, "dmg_mod" },
    { 0xA243A0CD, "dmg_model" },
    { 0xE8BE71DD, "dmg_notify" },
    { 0xE03F774C, "dmg_origin" },
    { 0x24165E9C, "dmg_point" },
    { 0x3C28D0DF, "dmg_points" },
    { 0x4EDA4A28, "dmg_pos" },
    { 0xD2B0AD10, "dmg_radius" },
    { 0x12BF65E0, "dmg_src" },
    { 0x316ACF9F, "dmg_taken" },
    { 0x9EDDF170, "dmg_taken_max" },
    { 0xD6144D8E, "dmg_thresholds" },
    { 0x6FEF90E4, "dmg_total" },
    { 0x356A143C, "dmg_trig" },
    { 0xFE28BF26, "dmg_trigger" },
    { 0xE5F012D6, "dmg_type" },
    { 0xE0C5DC7F, "dmgamount" },
    { 0xF23F5B83, "dmgfxorigin" },
    { 0xC82EF5FD, "dmgtrig" },
    { 0xC1D6C693, "dmgtype" },
    { 0x0A362AFF, "dmgweapon" },
    { 0x18BB48A8, "dmitri" },
    { 0xCBB8C981, "dmm" },
    { 0x8EEC5E92, "dmodel" },
    { 0xDC3140C4, "dnireparalais" },
    { 0x818B0DD0, "dniweapon" },
    { 0x14B3F23A, "dnormal" },
    { 0x1508FFAE, "do" },
    { 0xD5100893, "do_1st_pass_tuning" },
    { 0xBBFB1613, "do_2d_rain_audio" },
    { 0xF9576F63, "do_2nd_pass_tuning" },
    { 0xD6DD2F7E, "do_3rd_pass_tuning" },
    { 0xB89380A2, "do_a_generic_plane_damage_line" },
    { 0x9FF66A9A, "do_a_jet" },
    { 0xE545ACF5, "do_a_lightning_1" },
    { 0x77CC6E06, "do_a_mortar" },
    { 0x87FF39B5, "do_a_rpg_tower_damage_line" },
    { 0x6C8781EF, "do_a_taunt" },
    { 0x63E96873, "do_additional_precaching" },
    { 0x22B9813E, "do_airfield_dialogue" },
    { 0x7D56172B, "do_airstrike_hud_elem" },
    { 0x611EB3F1, "do_alasad" },
    { 0x3D454A47, "do_alive_cleanup_wait" },
    { 0xFA626D3E, "do_ally_switch" },
    { 0x763D0180, "do_ally_switch_transition" },
    { 0x50EDFDA9, "do_ambush" },
    { 0xDF1C0492, "do_anim" },
    { 0xAEFC586E, "do_anim_reach" },
    { 0x62ADBE59, "do_anim_single" },
    { 0xC452769D, "do_anims" },
    { 0x9018DF7E, "do_announcer_playvox" },
    { 0x027F7DD2, "do_antitank_ai" },
    { 0xB88DD450, "do_approach_to_loop" },
    { 0xCB044016, "do_area_spawn" },
    { 0x5FEC528F, "do_arty_move" },
    { 0xD229ED75, "do_arty_spawn" },
    { 0x49ACF21C, "do_attract" },
    { 0x2D7F29B9, "do_automoton_vox" },
    { 0xFBF2175B, "do_avogadro_flee_vo" },
    { 0xB2398E99, "do_balcony_death_now" },
    { 0x9F2C8053, "do_barracks_objectives" },
    { 0x2ACB06DA, "do_basejump_fov" },
    { 0x6FDAA432, "do_battlechatter" },
    { 0xFAA88799, "do_beacon_sound" },
    { 0x68237AA2, "do_black_hole_bomb_sound" },
    { 0xAF2D4365, "do_blocker" },
    { 0x57A7C577, "do_bloody_death" },
    { 0x9301ABE7, "do_bounce_off" },
    { 0x3E0BAC9A, "do_bowie_flourish_begin" },
    { 0x1054E2DE, "do_bowie_flourish_end" },
    { 0xC4B8C549, "do_boxcar_smoketrail_fx" },
    { 0x89044ABB, "do_boxcar_sun_rays" },
    { 0x92D40A82, "do_brake_rumble" },
    { 0xA5BF7445, "do_brake_warning_rumble" },
    { 0x21F3FC41, "do_bucket_fill" },
    { 0xCBED55C4, "do_build_death" },
    { 0x2B7ECC7E, "do_bullet_gib" },
    { 0x20BE48DA, "do_bulletcam" },
    { 0xB458C1FA, "do_bunker_group" },
    { 0x76658529, "do_burning_death" },
    { 0xE5BE1053, "do_bus_brake_lights" },
    { 0xDA807426, "do_bus_flashing_lights" },
    { 0x6F576062, "do_bus_head_lights" },
    { 0x2FE26CF4, "do_bus_interior_lights" },
    { 0xD8A0F455, "do_bus_turnal_signal_left_lights" },
    { 0x253EA7C2, "do_bus_turnal_signal_right_lights" },
    { 0xA21862E4, "do_call_and_response_dialogue" },
    { 0x87F611D4, "do_car_idle_after_hijack" },
    { 0x7667C706, "do_castle_dialogue" },
    { 0x2361638D, "do_center_standing" },
    { 0xB25DCB6E, "do_chute_feedback" },
    { 0x46D3A558, "do_chyron_text" },
    { 0x2A3CEC38, "do_cinematic_blending" },
    { 0xE4F7D6CB, "do_cleanup" },
    { 0xF5E436A6, "do_cleanup_check" },
    { 0x67F43698, "do_climb" },
    { 0x8F9A23AC, "do_collectible_corpse" },
    { 0xEEAA8928, "do_combat_getout" },
    { 0x4592A3AE, "do_combat_idle" },
    { 0x07FB980F, "do_connectpaths" },
    { 0x861635FD, "do_contextual_melee" },
    { 0xEFC6991E, "do_cooldown" },
    { 0xC0BD714B, "do_cooldown_fx" },
    { 0x4C4B3449, "do_corpse_face_hack" },
    { 0x3F0AE483, "do_countdown_dialogue" },
    { 0x03CCD94B, "do_courtyard_destruction" },
    { 0x994E53F3, "do_custom_introscreen" },
    { 0xBA99A9EE, "do_custom_muzzleflash" },
    { 0xD65827EA, "do_damage" },
    { 0x2F31684B, "do_damage_network_safe" },
    { 0x725E7248, "do_days" },
    { 0x5DF2C048, "do_de_rumble" },
    { 0xE6F48D52, "do_dead_cleanup_wait" },
    { 0x5EA5C7D9, "do_death" },
    { 0xE362CB1A, "do_death_anims" },
    { 0xD30BF627, "do_death_dynents" },
    { 0x84D2E8DE, "do_death_fx" },
    { 0x6E09F691, "do_death_sound" },
    { 0x0E086E21, "do_death_tank_event" },
    { 0x2C42E6A4, "do_death_tank_sequence" },
    { 0xE0C58113, "do_death_timescale" },
    { 0xC2BA4F67, "do_decapitation_event" },
    { 0xD6EA0974, "do_delete" },
    { 0x08FF5BCD, "do_delete_trigger" },
    { 0x3B0043E5, "do_delta" },
    { 0x80604822, "do_depth_setup" },
    { 0x04A8E177, "do_dialogue" },
    { 0x3F672255, "do_digger_arm_fx" },
    { 0xF4616A07, "do_digger_digging_earthquake_rumble" },
    { 0xE41ACAE4, "do_digger_moving_earthquake_rumble" },
    { 0xE643871D, "do_director_playvox" },
    { 0x4061AE41, "do_disable_weapons" },
    { 0xC1FDF66A, "do_door_breach_guys" },
    { 0x3E84F16F, "do_dragovich_death" },
    { 0x2052D549, "do_drive_by_shooting_sequence" },
    { 0x9953C72E, "do_drive_thread" },
    { 0x9BAB7FE2, "do_drivepath" },
    { 0xDB315569, "do_drop_idle_anim" },
    { 0x42CD6C95, "do_dummy_vehicles" },
    { 0x45BE97FE, "do_earthquake" },
    { 0x46B7D838, "do_enable" },
    { 0x175B1F0C, "do_end_synchronized_melee" },
    { 0x808A45A6, "do_event_thread" },
    { 0xAD04F0E9, "do_exclude" },
    { 0x38A32FF2, "do_explosion" },
    { 0xD461FA7E, "do_explosion_sound" },
    { 0x2138026D, "do_explosive_gib" },
    { 0xBA7D3CD5, "do_extended_death" },
    { 0x78A061B9, "do_extra_dmg_no_fire" },
    { 0xBEA442F0, "do_eye" },
    { 0xF3744922, "do_face" },
    { 0xABD84759, "do_face_anims" },
    { 0x285EB156, "do_fake_fb_schrecks" },
    { 0x07369648, "do_fake_firing" },
    { 0x61F96252, "do_fake_flamethrower_fire" },
    { 0x8ED0A858, "do_fake_schreck" },
    { 0x3C58CB33, "do_fake_schrecks" },
    { 0x73182308, "do_fall_feedback" },
    { 0x13EAC496, "do_fb_effects" },
    { 0xE0E167AE, "do_final_battle_fortify" },
    { 0x98DE7223, "do_final_killcam" },
    { 0x9D2ED501, "do_fire_delay" },
    { 0xDC3C2964, "do_firing" },
    { 0x1005C39E, "do_first_interstitial" },
    { 0x86A1D71E, "do_flame_bunker" },
    { 0x951F3C92, "do_flame_bunker_flame_damage" },
    { 0xF34B2F2F, "do_flame_bunker_tank_damage" },
    { 0xC7465C01, "do_flame_death" },
    { 0x1E4494FD, "do_flash" },
    { 0x94716D13, "do_flashbacks" },
    { 0x1B5C2B1A, "do_flashbang_guy_v2" },
    { 0xD366F094, "do_flashlight_stuff" },
    { 0xF7DD1EE0, "do_flat_tires" },
    { 0xC5C47364, "do_flight_anims" },
    { 0x3A9EB0AF, "do_flight_feedback" },
    { 0xAE678F09, "do_flipper_corpse_cleanup" },
    { 0x5A92098C, "do_floodspawners" },
    { 0x15891189, "do_floor3green" },
    { 0x29897E3B, "do_foot_effect" },
    { 0xDD9B0689, "do_force_death" },
    { 0x3E19D80A, "do_fortification_spawn" },
    { 0x055B361F, "do_foxhole1_trench_combat" },
    { 0x2C62F265, "do_foxhole3_trench_combat" },
    { 0xC0532D6C, "do_fp_wrist_grab" },
    { 0x67588EF0, "do_friendly_battlechatter" },
    { 0xAA4C8AFC, "do_friendly_consistency_check" },
    { 0x964EE5E2, "do_friendly_firing" },
    { 0x562E27F3, "do_frontend_save" },
    { 0x0E39A555, "do_frost_diminish" },
    { 0x89E1D77B, "do_fx" },
    { 0xECA28D87, "do_fx_and_model_swap" },
    { 0xF30DF46E, "do_game_mode_shellshock" },
    { 0x199FE7A0, "do_generic" },
    { 0xBE6B58B3, "do_generic_retreats" },
    { 0x5A579D99, "do_gib" },
    { 0x1BF7F0E2, "do_gib_death" },
    { 0x34C290E7, "do_gib_dynents" },
    { 0xAF982A9E, "do_gib_fx" },
    { 0xEC30D3DF, "do_give_back_weapon" },
    { 0x6716D30F, "do_glass_traverses" },
    { 0x740A0C76, "do_glasses_movie" },
    { 0x276DA4FB, "do_glow_now" },
    { 0xE7258B4F, "do_gradual_timescale" },
    { 0xA6E70EDF, "do_gravity_spike_fx" },
    { 0x0F3A80A2, "do_gravity_spike_fx_circle" },
    { 0x0F11F817, "do_hat_gib" },
    { 0xE549F9AF, "do_headshot" },
    { 0x1D930EFD, "do_headshot_gib_fx" },
    { 0xEA07A038, "do_hide_destroyed_earth" },
    { 0x1115523C, "do_hide_earth" },
    { 0x21430C8C, "do_hide_weapon" },
    { 0x66993975, "do_hijack" },
    { 0xA15B6CF1, "do_hijack_others" },
    { 0xC1F18100, "do_hijack_vehicle_anim" },
    { 0x4FEAA0CD, "do_hill_aim_anims" },
    { 0x2B409590, "do_hill_death_anims" },
    { 0xE17A1C80, "do_hill_pain_anims" },
    { 0x07C24FDB, "do_hud_for_ft_tut" },
    { 0x2447B661, "do_hud_for_ft_tut_by_client" },
    { 0xA2498CD7, "do_idle" },
    { 0x33B5DB6A, "do_if_defined" },
    { 0x86A01B28, "do_ignore_config" },
    { 0x84922861, "do_ignore_inversion" },
    { 0x2065B4E9, "do_in_order" },
    { 0x87A65AD3, "do_individual_combat" },
    { 0x598274E7, "do_inflight_dialogue" },
    { 0xED814C2A, "do_inflight_visionsets" },
    { 0x47E3E3DB, "do_initial_power_off_callback" },
    { 0x3A9CA958, "do_initial_sparks" },
    { 0xA380996B, "do_intermediate_damage_states" },
    { 0xC264939B, "do_interstitial_1" },
    { 0x505D2460, "do_interstitial_2" },
    { 0x765F9EC9, "do_interstitial_3" },
    { 0x346C02D6, "do_interstitial_4" },
    { 0x4AB14D7E, "do_intro_dialogue" },
    { 0xA725D733, "do_it_now" },
    { 0x70BDBE2E, "do_jump_frost_update" },
    { 0xC19109B3, "do_kill_damage" },
    { 0x4EDD595F, "do_knuckle_crack" },
    { 0x0D7A2E87, "do_lander_rumble_quake" },
    { 0x8FEC7F40, "do_launch" },
    { 0x1EEEF9AE, "do_leaper_emerge" },
    { 0x7E1EF5C6, "do_lightning_loop" },
    { 0xF7F91C07, "do_line" },
    { 0xE3D66A49, "do_link" },
    { 0x5BB74B64, "do_little_bird_beach_flyby" },
    { 0xA0A733F9, "do_logic" },
    { 0x781691CF, "do_loop" },
    { 0xB6F82BC6, "do_loudspeaker_dialog_second_cover" },
    { 0xF76E2B29, "do_mason_custom_intro_screen" },
    { 0xD046799C, "do_meat_shield" },
    { 0x867556E3, "do_melee" },
    { 0xE0748DF2, "do_melee_attack" },
    { 0xBAF1DCDC, "do_melee_fight" },
    { 0xB51668FC, "do_melee_fx" },
    { 0xBDEA30AE, "do_melee_scene" },
    { 0xDF9C33AB, "do_melee_weapon_flourish_begin" },
    { 0xAB53338B, "do_melee_weapon_flourish_end" },
    { 0x7CC6303B, "do_milk_drops_on_camera_for_time" },
    { 0x0245D2EE, "do_monkey_sound" },
    { 0x5F3D37E5, "do_mooncomp_vox" },
    { 0x3336B7C6, "do_mortar" },
    { 0x6C677494, "do_moto_setup" },
    { 0x6A24A1A2, "do_movement" },
    { 0xDC4727D4, "do_my_loop" },
    { 0x87383D26, "do_nag_dialogue" },
    { 0x9245902E, "do_nag_loop" },
    { 0x387D3CA1, "do_nag_vo" },
    { 0xBB030133, "do_nag_vo_array" },
    { 0x0C282E2E, "do_netfriendly_flood_spawn" },
    { 0xCE9A04D2, "do_netfriendly_trigger_spawn" },
    { 0xCB69739A, "do_no_game_skipto" },
    { 0x6079DE07, "do_nonlethal_melee_damage" },
    { 0x801EE442, "do_not_align" },
    { 0xB0A46C09, "do_not_allow_death" },
    { 0x3E601ED2, "do_not_clear_targets_during_think" },
    { 0x3174AF9F, "do_not_display_equipment_pickup_hint" },
    { 0xFA81F2C8, "do_not_set_anim_rate" },
    { 0xEDB2061C, "do_not_track_used" },
    { 0xD03196A3, "do_not_update_death_count" },
    { 0x021EB7CE, "do_not_use_dof" },
    { 0x54553915, "do_notetracks" },
    { 0x24435440, "do_nothing" },
    { 0x8BA4840C, "do_octobomb_sound" },
    { 0x8C19DAB6, "do_one_shot_use" },
    { 0x73FB55D9, "do_open" },
    { 0x94660E11, "do_or_die" },
    { 0x4007ACE6, "do_outro" },
    { 0xD2EE8551, "do_pain" },
    { 0x4F3D92F8, "do_panzerschreck_retreat" },
    { 0x3EE0EAB0, "do_path_anim" },
    { 0xB16661A8, "do_path_anim_anim" },
    { 0xEC87B5AE, "do_phase" },
    { 0x731DFB76, "do_phys_pulses" },
    { 0x01323F9F, "do_phys_trace" },
    { 0x3A23BE5D, "do_pip1" },
    { 0x602638C6, "do_pip2" },
    { 0xD31C84B0, "do_pipe_fxanims" },
    { 0xD5B9EF73, "do_pistol_getout" },
    { 0x8FCF2661, "do_pistol_idle" },
    { 0xCC475D06, "do_planter_dialogue" },
    { 0x82DB9C4B, "do_player_bus_location_vox" },
    { 0xAFA54448, "do_player_bus_zombie_vox" },
    { 0x29CB39E6, "do_player_damage" },
    { 0x4A96E299, "do_player_general_vox" },
    { 0xD283B393, "do_player_hookup" },
    { 0xFB568CFB, "do_player_idle_drift" },
    { 0x07134602, "do_player_killstreak_dialog" },
    { 0xEBAF0CE6, "do_player_or_npc_playvox" },
    { 0xA4662347, "do_player_playdialog" },
    { 0x4349838E, "do_player_playvox" },
    { 0x0BE75904, "do_player_playvox_custom" },
    { 0x1232FD6C, "do_player_playvox_egg" },
    { 0x3833A7FD, "do_player_rappel" },
    { 0x2B3D75BA, "do_player_support" },
    { 0xFDDC3886, "do_player_view_particles" },
    { 0xA8A5E210, "do_player_vo" },
    { 0xDEE53381, "do_player_weap_dialog" },
    { 0x1426C490, "do_player_zipline" },
    { 0x1F1625D3, "do_post_chunk_repair_delay" },
    { 0x50CACD90, "do_post_game_damage" },
    { 0x8F2C8C07, "do_post_game_death" },
    { 0x20864EF4, "do_pre_engine_dialog" },
    { 0xBD42385A, "do_precacheing" },
    { 0x0D2705FF, "do_precaching" },
    { 0x4C3DDE63, "do_preflight_dialogue" },
    { 0xBCCF8FE3, "do_print3d" },
    { 0x641E6860, "do_print3d_pos" },
    { 0x6E0FC67E, "do_radio_tower_explode" },
    { 0xD0426BCF, "do_radio_tower_owned_event" },
    { 0xA331438E, "do_ragdoll" },
    { 0x88DDA3F9, "do_ragdoll_death" },
    { 0xDBC67A12, "do_rail_ai" },
    { 0x8E42DABC, "do_rail_bombers" },
    { 0xAB1D20D1, "do_rail_drones" },
    { 0xB8F76C1B, "do_rail_events" },
    { 0xC55E4A90, "do_railclimb" },
    { 0x982EDCB7, "do_rain" },
    { 0x74C32A27, "do_random_ack_line" },
    { 0x3DD5F2AC, "do_random_congrats" },
    { 0x7655383A, "do_random_contact_line" },
    { 0x5FCF9252, "do_random_enemy_line" },
    { 0x8B680073, "do_random_explosions" },
    { 0xAD8BFD1A, "do_random_smoke" },
    { 0x6E541B69, "do_random_squad_command" },
    { 0x417703B5, "do_randomized_zigzag_path" },
    { 0x8959BF3F, "do_ranged_attack" },
    { 0x43DD3E74, "do_rappel_shake_and_rumble" },
    { 0x60629DDA, "do_reach" },
    { 0x91AD5594, "do_reaction" },
    { 0x08FAFEEF, "do_redshirt_dialogue" },
    { 0x0650E08F, "do_remove_string" },
    { 0x05D68587, "do_resurrect_hint_fx" },
    { 0x3DE8B43C, "do_resurrected_on_dead_body_fx" },
    { 0xFFE831F5, "do_resurrected_on_spawned_player_fx" },
    { 0x6948807A, "do_retain" },
    { 0x707C2BDD, "do_retreat_trucks" },
    { 0x4EBDB91D, "do_reveal_enemy_pulse" },
    { 0xED3423EE, "do_revive_ended_normally" },
    { 0x933F52F8, "do_reznov_cutscene" },
    { 0x40450532, "do_rifle_gren_hud_elem" },
    { 0x94A5F75E, "do_rise" },
    { 0xD2199485, "do_rl_rumble" },
    { 0x563A98FF, "do_rr_rumble" },
    { 0x06F4BA9F, "do_rts_cleanup" },
    { 0x3EC1C12A, "do_rubberband" },
    { 0xFFF48F4A, "do_rumble" },
    { 0x6379CE7B, "do_runway_visionsets" },
    { 0x349DD29C, "do_sam_vo_rumble" },
    { 0x1665470C, "do_scene_sub" },
    { 0xAAB0D56F, "do_scripted_crash" },
    { 0x284082B3, "do_secondary_fb_effects" },
    { 0xDFDBE572, "do_secondary_zone_checks" },
    { 0xC9D9342D, "do_secret_menu" },
    { 0xDA55D1BD, "do_set_cqbwalking" },
    { 0x28444B6D, "do_set_pacifist" },
    { 0xCDE98201, "do_shake" },
    { 0xCA0C1EE3, "do_shakeandrumble" },
    { 0x3D40493E, "do_shoot" },
    { 0x7CEE00B6, "do_show" },
    { 0xED64E5D7, "do_show_destroyed_earth" },
    { 0xBE3DCAC3, "do_show_earth" },
    { 0xE296B6E4, "do_side_death_fx" },
    { 0x1DBDB419, "do_single_dummy_vehicle" },
    { 0x6FF9CB3E, "do_single_lightning" },
    { 0x7709F696, "do_single_static_dummy_vehicle" },
    { 0x8BDD19EB, "do_slamzoom" },
    { 0x232C740A, "do_slow_things" },
    { 0xAD0BB3AB, "do_smoke_at_intervals" },
    { 0xB96682E2, "do_soul_swap" },
    { 0xF4719B93, "do_sound_for_event" },
    { 0xAC621B6E, "do_spawn" },
    { 0x6CD7E352, "do_spawn_anim" },
    { 0xB5168D92, "do_spotlight_warning" },
    { 0xFC742B8E, "do_spray_model" },
    { 0x2BBE1607, "do_sprint_hint" },
    { 0xDFEC53B9, "do_sprint_unlimited" },
    { 0xF2C29F60, "do_squad_warning" },
    { 0x1E0CB020, "do_sr71_takeoff_anims" },
    { 0xDA7234E2, "do_sr_rumble" },
    { 0xE8259A37, "do_sro_intro_dialogue" },
    { 0xBC15F24F, "do_ss1_logic" },
    { 0xD3D8B154, "do_ss2_logic" },
    { 0x03DAB436, "do_ss_failure_vox" },
    { 0x04A167F8, "do_ss_start_vox" },
    { 0xCA3D5A09, "do_ss_success_vox" },
    { 0x80A5A3B1, "do_start_synchronized_melee" },
    { 0x0090EDB0, "do_static_fx" },
    { 0x611E7D36, "do_stats" },
    { 0x64118B58, "do_stats_for_gibs" },
    { 0xDBD09C4A, "do_stealth" },
    { 0x7B4CBE69, "do_stop_wait_triggers" },
    { 0x517B6379, "do_stun" },
    { 0xF17478D1, "do_sugarcane_sprint_unlimited" },
    { 0x956CAAF4, "do_sunsamplesize" },
    { 0x6E4DD978, "do_supply_drop" },
    { 0x4B5A4260, "do_supply_drop_anim" },
    { 0xFBCC2B00, "do_supply_drop_detonation" },
    { 0xE433CD43, "do_supplydrop" },
    { 0x9E229B59, "do_switch_transition" },
    { 0x6775BA3B, "do_synchronized_melee_cleanup" },
    { 0xB5721297, "do_talk" },
    { 0x367A9797, "do_talon_breach_anim" },
    { 0x2D2EEBF7, "do_tank_fill" },
    { 0x476E5882, "do_tank_sweep_auto_damage" },
    { 0xCEC83772, "do_target_player" },
    { 0xD6AC4414, "do_tarp_flap" },
    { 0x3EC2AE09, "do_teardown_sound" },
    { 0x8A067970, "do_temp_dialogue" },
    { 0xDE45C38C, "do_tentacle_burst" },
    { 0x25521204, "do_tentacle_grab" },
    { 0xF7277F7C, "do_thank_maxis" },
    { 0x7FF7ACA9, "do_third_interstitial" },
    { 0x154128E1, "do_tiger_retreats" },
    { 0x6505E967, "do_timer_resets" },
    { 0xA7C2A1E4, "do_timescale" },
    { 0x14439125, "do_tow_shoot" },
    { 0x589CE774, "do_trace" },
    { 0xCB8FFE75, "do_treadfx" },
    { 0x6F583AD0, "do_trig_sparks" },
    { 0x730FE3DF, "do_triggered_cougar_crawl_squib_struct" },
    { 0xBCC1A4AC, "do_turn_anim" },
    { 0x16804DD7, "do_turret_scanning" },
    { 0xF46B86C0, "do_tutorial_dialogue" },
    { 0x608606E4, "do_unload" },
    { 0x3B8AE343, "do_vcs" },
    { 0x167CB344, "do_veh_damage_hud" },
    { 0x31F9DF6C, "do_veh_extra_damage_no_play" },
    { 0x06595C20, "do_veh_extra_damage_no_play_update" },
    { 0x0EE7B6C1, "do_vehicle_damage" },
    { 0xDAF1857A, "do_vehicle_notetracks" },
    { 0x4CB7EFA6, "do_vehicle_retreats" },
    { 0x2CEF81B1, "do_very_damaged_feedback" },
    { 0x424C89F4, "do_victory_scene" },
    { 0x37DBBE9B, "do_vignette" },
    { 0x9898D17B, "do_vision_local_pulse" },
    { 0x2CF010AA, "do_vision_world_pulse" },
    { 0x166068A8, "do_vo_nag_loop" },
    { 0xCC8455DC, "do_vtol_escape" },
    { 0x3F43E9A6, "do_vtol_halo_jump" },
    { 0x2AB0EFC9, "do_vtol_sounds" },
    { 0xF7D7076F, "do_vulture_death" },
    { 0xE189E192, "do_wait" },
    { 0xF9DE30E1, "do_wait_any" },
    { 0xB5CA8E50, "do_wait_endons_array" },
    { 0xAF01149F, "do_weapon_detonation" },
    { 0x51A4CE20, "do_what_they_do" },
    { 0x1212C738, "do_wipeout" },
    { 0xB99B9F2E, "do_wobble" },
    { 0x6B226AD4, "do_zipline" },
    { 0xD59853B1, "do_zombie_emerge" },
    { 0xD43633E9, "do_zombie_explode" },
    { 0x1843C621, "do_zombie_fall" },
    { 0xC20E97E0, "do_zombie_flush" },
    { 0x7B062181, "do_zombie_rise" },
    { 0x50B1A577, "do_zombie_spawn" },
    { 0xAFFDFB25, "do_zombies_playvocals" },
    { 0x30DDAC33, "doa" },
    { 0xABEF8392, "doabarrelroll" },
    { 0x8A1411FD, "doaim" },
    { 0x41924155, "doaimawarenotetracks" },
    { 0xC4B5D55C, "doairstrike" },
    { 0xB1387BD9, "doanim" },
    { 0xF5291508, "doanimation" },
    { 0x3DB0D46D, "doannihilate" },
    { 0x1A45AF95, "doarmorfx" },
    { 0x317F1454, "doartillery" },
    { 0xBC4D0492, "doartillerystrike" },
    { 0xD2468908, "doautosave" },
    { 0xD797C738, "doautospawn" },
    { 0x12CF7EC2, "dobalcony" },
    { 0x3F826912, "dobj" },
    { 0x59EEF0D1, "dobodydamage" },
    { 0x219BBA12, "dobombkillcams" },
    { 0xFA593625, "dobombrun" },
    { 0x8FA1A956, "doboxleave" },
    { 0xDE3344DC, "doburningsound" },
    { 0xE4D8B761, "doc" },
    { 0x5F95A71C, "doc_guys" },
    { 0xE940E06C, "dochallengecallback" },
    { 0x2C95CC1E, "dochallengecompleteui" },
    { 0x4EBC23EA, "dochangeclass" },
    { 0x578A9B45, "dochangeteam" },
    { 0x67DAB863, "docile" },
    { 0xC05CB850, "dock" },
    { 0x8E4831C5, "dock_ai" },
    { 0x99AB4E74, "dock_ai_attack_player" },
    { 0x3F052821, "dock_animation_struct" },
    { 0xE9A24371, "dock_animation_struct2" },
    { 0x54000109, "dock_clip" },
    { 0x3B5C1353, "dock_crates" },
    { 0x66AEC322, "dock_gulls" },
    { 0x4D474F7F, "dock_gulls1" },
    { 0xDB3FE044, "dock_gulls2" },
    { 0x01425AAD, "dock_gulls3" },
    { 0x59139086, "dock_patrol_ai" },
    { 0xCF899160, "dock_patroller_spawnfunc" },
    { 0xC56EADA4, "dock_rumble" },
    { 0x7F296D71, "dock_stealth_ai" },
    { 0x4FFDDD9D, "dock_stealth_ensurance" },
    { 0x3476846F, "dock_stealth_listener" },
    { 0x9180E0B0, "dock_stealth_trigger_check" },
    { 0x259C1987, "dock_stealth_watch_gunfire" },
    { 0x0180EA37, "dock_stop" },
    { 0xDD9B7B41, "dock_trigger" },
    { 0x8A44A468, "dock_triggers" },
    { 0xF7C2FEEE, "dock_vo" },
    { 0xE3037DBD, "dock_worker" },
    { 0xAAC0390A, "dock_worker_run_from_player" },
    { 0xC8B1407C, "dock_workers" },
    { 0xB35FFAE3, "docked" },
    { 0x47A2A348, "docking" },
    { 0xED0F5738, "docking_sequence" },
    { 0xD4130CCE, "docking_sequence_initiated" },
    { 0xF2E8073B, "docks" },
    { 0x598871D8, "docks_anims" },
    { 0x659E7C37, "docks_clean_up" },
    { 0x8FBC2E7A, "docks_cleaned" },
    { 0xAACAFB9A, "docks_container_moment" },
    { 0xDEE71B8E, "docks_crate_cleanup" },
    { 0xD589DBBB, "docks_elevator_approach_vo" },
    { 0xF5F3AF3F, "docks_elevator_exit_vo" },
    { 0x8116CE65, "docks_elevator_ride_vo" },
    { 0x3B5EF81E, "docks_elevator_wait_vo" },
    { 0x0DEF95FE, "docks_gate_ambush" },
    { 0x335F4EBB, "docks_glass_smash" },
    { 0x92FFFB2F, "docks_ik_headtracking_limits" },
    { 0x74B7E234, "docks_intro" },
    { 0x4AC8F216, "docks_jeep" },
    { 0x4FD0DE51, "docks_magic_rpg_setup" },
    { 0x67D36E06, "docks_magic_rpg_think" },
    { 0x88FCC907, "docks_mason_down" },
    { 0xF5BAC7A6, "docks_objectives" },
    { 0xEF327A8D, "docks_setup" },
    { 0x7FA9AB76, "docks_sniping_setup_vo" },
    { 0x2C47ED2C, "docks_sniping_walk_vo" },
    { 0xB654B3C3, "docks_trigger_cleanup" },
    { 0x4691BF8B, "docksdie_order_to_samsite" },
    { 0x16264441, "dockside" },
    { 0x8AB776D4, "dockside_aigrenadeget" },
    { 0x45C53040, "dockside_airstrikego" },
    { 0xD2F8EBA5, "dockside_airstrikemsg" },
    { 0x27B6531B, "dockside_airstrikewatch" },
    { 0x41C97C1B, "dockside_base" },
    { 0xE89F1244, "dockside_cargodamagewatch" },
    { 0x68341557, "dockside_create_death" },
    { 0xA2B36910, "dockside_custom_playerspawn" },
    { 0xDC152A11, "dockside_enemybasedamagewatch" },
    { 0x7244ADB8, "dockside_enemybasewatch" },
    { 0x063D70B3, "dockside_fade_out" },
    { 0x55AD6E0D, "dockside_fastrope_intro" },
    { 0xC2BFA34D, "dockside_geo_changes" },
    { 0x5E069E9A, "dockside_intro" },
    { 0xD72B7D64, "dockside_level_player_startfps" },
    { 0xBEDB85FE, "dockside_level_precache" },
    { 0x53766062, "dockside_level_scenario_one" },
    { 0xAEF05A11, "dockside_level_scenario_one_registerevents" },
    { 0x311E201A, "dockside_level_scenario_three" },
    { 0x73D49D84, "dockside_level_scenario_two" },
    { 0x8B528058, "dockside_level_setup" },
    { 0xC16AFD06, "dockside_level_waitforpoifailnotify" },
    { 0xB9437B32, "dockside_level_waitforpoinotify" },
    { 0x329B1B4E, "dockside_missile_control" },
    { 0xAC19716D, "dockside_missile_deathring" },
    { 0xEAEDF4A0, "dockside_missile_oob_check" },
    { 0x26D4AFA7, "dockside_mission_complete_s1" },
    { 0x70A04BB3, "dockside_mission_control_abort" },
    { 0x0A48C891, "dockside_outro" },
    { 0xDA5F893F, "dockside_player_oobwatch" },
    { 0xE3E2C576, "dockside_props" },
    { 0x4D8CF2BD, "dockside_scenario_one_audio_init" },
    { 0x5B546E25, "dockside_scenario_one_end" },
    { 0x08BCA8EC, "dockside_scenario_one_intro" },
    { 0xE5C59B5F, "dockside_scenario_one_intro_audio" },
    { 0xF0B2D9D8, "dockside_setstart" },
    { 0xE3E399F4, "dockside_setup_devgui" },
    { 0xF52A4B82, "dockside_ship" },
    { 0x93FDC7B6, "dockside_watch_devgui" },
    { 0xF174D49E, "docktrig" },
    { 0xB8113836, "doclockwiserotation" },
    { 0x2A291F9C, "doconnectpaths" },
    { 0x0A891A13, "docoverexitanimation" },
    { 0x8D71385C, "docowardswayanims" },
    { 0x9048E508, "docs" },
    { 0x99B40DE4, "doctor" },
    { 0x7D2533FC, "doctor_and_nurse_anim" },
    { 0xD8B9453A, "doctor_model" },
    { 0xC1E6338E, "document" },
    { 0x838516FB, "document_think" },
    { 0x3B7745D3, "document_trigger" },
    { 0x2FFDFBB1, "documentation" },
    { 0x02BDDED1, "documented" },
    { 0x044B2031, "documents" },
    { 0xC3945CD5, "dodamage" },
    { 0x7D924302, "dodamage_onhit" },
    { 0xA2F24E04, "dodamagefeedback" },
    { 0xC5892324, "dodamagetohead" },
    { 0x1111B90A, "dodeadeventupdates" },
    { 0xE093EE0F, "dodeathfromarray" },
    { 0xF19638F7, "dodebug" },
    { 0x64803D3F, "dodelete" },
    { 0x5EC250F2, "dodge" },
    { 0x2B8F9181, "dodge_car" },
    { 0x421235B3, "dodge_car_anim" },
    { 0x49F60E84, "dodge_car_done" },
    { 0x7D96429E, "dodge_player" },
    { 0x407A66C8, "dodge_score_highlight" },
    { 0x4E50CA1A, "dodge_show_revive_icon" },
    { 0x04E966FE, "dodgeloadout" },
    { 0x37BD9728, "dodgepoint" },
    { 0x05196A19, "dodgerangesq" },
    { 0x98F8807D, "dodges" },
    { 0xD20044A3, "dodging" },
    { 0x8707B46E, "dodgy" },
    { 0x39B7E488, "dodialogue" },
    { 0x6B8F38D5, "dodisplaymessage" },
    { 0x65E5CF8E, "dodogflamedamage" },
    { 0xFC0BE399, "dodogincendiarydamage" },
    { 0xAE77CA3C, "dodogincendiarygrounddamage" },
    { 0x495CFD47, "dodogmolotovslapdamage" },
    { 0x425ABCAD, "dodognapalmgrounddamage" },
    { 0xFA572A1E, "dodognapalmstrikedamage" },
    { 0xD1AEDC32, "dodogtraverse" },
    { 0xC8E795D7, "doe" },
    { 0x12F87E0E, "doempbehavior" },
    { 0x84B82FFC, "doempdestroyfx" },
    { 0x7E4E6781, "doenableuav" },
    { 0xA53634F9, "doendgamescoreboard" },
    { 0xC33296A0, "doendgamesequence" },
    { 0x620A4F8E, "does" },
    { 0x7D0F05A7, "does_ai_exist" },
    { 0x610D6409, "does_enemy_have_color_trig" },
    { 0x13A1BA8E, "does_enemy_have_parameter_nodes" },
    { 0x4B802A8E, "does_exploder_exist" },
    { 0xA33B5E2E, "does_fall_into_pap_hole" },
    { 0xA9DF8CA1, "does_have_target" },
    { 0xB6CB8787, "does_have_user" },
    { 0xF8CEEF8B, "does_melee_type_need_legs" },
    { 0x6CDCD775, "does_need_user" },
    { 0xA3C425D1, "does_not_count_to_round" },
    { 0x262023B1, "does_player_completely_avoid_damage" },
    { 0xFCA731A4, "does_player_have_correct_navcard" },
    { 0x7A804048, "does_player_have_map_navcard" },
    { 0x69945FED, "does_player_have_mortar" },
    { 0x9FC7DDBC, "does_reach_runaway_goal" },
    { 0x39A73CFE, "does_rocket_shoot_through_wall" },
    { 0xE999DD1B, "does_spawner_exist" },
    { 0x53F67426, "does_super_soct_exist" },
    { 0x5C243554, "does_turret_have_target" },
    { 0x5DD552C2, "does_turret_have_user" },
    { 0xD59FEC4C, "does_turret_need_user" },
    { 0xFA726CD1, "doesfiredamage" },
    { 0x3CE95B4A, "doesmicrowaveturretaffectdog" },
    { 0x29698D6D, "doesmicrowaveturretaffectentity" },
    { 0xBF3E76B4, "doesn" },
    { 0x975A326D, "doesnodeallowstance" },
    { 0x8A3565C8, "doesnt" },
    { 0x0582B7E5, "doesplayerhavekillstreak" },
    { 0x691F8BFF, "doesrulehavevalidparam" },
    { 0x2026E859, "doesscoreinfocounttowardrampage" },
    { 0xB413DD89, "doessquadhaveanyspeciesoftype" },
    { 0x3819B2B8, "doesstreakcountmatch" },
    { 0x880744A4, "doesstreakcountmatches" },
    { 0xDB2F983E, "doest" },
    { 0x2AA13CA3, "doesweaponreplacespawnweapon" },
    { 0x4EFD186C, "doexclude" },
    { 0x35111C97, "doexpensivelookahead" },
    { 0xCEC10937, "doexplosion" },
    { 0xFD148F7C, "doexplosivebodydamage" },
    { 0xB312B207, "doexposedblindfire" },
    { 0x56E0269C, "dof" },
    { 0xED130120, "dof_03" },
    { 0x3A34E98B, "dof_arm_look" },
    { 0x0FF24A13, "dof_back_to_hanging" },
    { 0x45F83393, "dof_beatdown" },
    { 0xFFAEE713, "dof_body" },
    { 0x4EB3219B, "dof_caught" },
    { 0x55FE6198, "dof_change_looking_at_woods_from_hole" },
    { 0x9D2ECD54, "dof_chopper" },
    { 0x1BA08ECD, "dof_chopper_setting" },
    { 0x76A957EA, "dof_civilian_3" },
    { 0xD99BAF42, "dof_civs" },
    { 0x32CE64F0, "dof_close_door" },
    { 0xC98198E6, "dof_com_1" },
    { 0x19996D32, "dof_com_reset" },
    { 0xE36621B4, "dof_convo" },
    { 0x02A0278D, "dof_convoy" },
    { 0xBF2A4D93, "dof_defalco_closeup" },
    { 0x796BB177, "dof_default_setting" },
    { 0xA754A903, "dof_door_guy" },
    { 0xA5D43D05, "dof_drag_guy_1" },
    { 0xCBD6B76E, "dof_drag_guy_2" },
    { 0x97272E4E, "dof_enable" },
    { 0x53022181, "dof_eyescan" },
    { 0xE4CAA73E, "dof_far_blur" },
    { 0xE5FE22D4, "dof_far_end" },
    { 0x55F2CEFF, "dof_far_start" },
    { 0x802BED10, "dof_faraway" },
    { 0x591F4384, "dof_focus_on_hands" },
    { 0xE78B9DB5, "dof_focuser_tag" },
    { 0xA62E90F3, "dof_frontend" },
    { 0xE2668644, "dof_fwd_look_1" },
    { 0x546DF57F, "dof_fwd_look_2" },
    { 0x2E6B7B16, "dof_fwd_look_3" },
    { 0xDB7314DF, "dof_gatepull" },
    { 0xB16D761B, "dof_get_up" },
    { 0xDC13EC09, "dof_goons" },
    { 0xC366E0DB, "dof_grab_chair" },
    { 0x834CD683, "dof_grab_hat" },
    { 0x5C072D4B, "dof_grab_noriega" },
    { 0xF97439DE, "dof_guard" },
    { 0x1E06D953, "dof_guard_4" },
    { 0x8CE0A1C0, "dof_guardfallen" },
    { 0x86A29FE1, "dof_gun_closeup" },
    { 0x36FC883B, "dof_gun_look_1" },
    { 0xC4F51900, "dof_gun_look_2" },
    { 0xEAF79369, "dof_gun_look_3" },
    { 0x79F75597, "dof_hands" },
    { 0xFA32A4E1, "dof_harper" },
    { 0x49E86525, "dof_harper_1" },
    { 0x6FEADF8E, "dof_harper_2" },
    { 0x8BDC0118, "dof_harper_4" },
    { 0xFC006B3A, "dof_harper_capture" },
    { 0xDE8081C7, "dof_harper_closeup" },
    { 0xF7A50E78, "dof_harper_pushdoor" },
    { 0x33E0C73F, "dof_harper_track_3" },
    { 0xB36CF7EC, "dof_hit_noriega" },
    { 0xCA9782AD, "dof_hit_wall" },
    { 0x5ADBE261, "dof_hookup" },
    { 0xEA59FFD1, "dof_horses" },
    { 0xA5415D89, "dof_humvee" },
    { 0x10837A67, "dof_intro" },
    { 0x8CF8D94E, "dof_intro_fire" },
    { 0x6E0A13E0, "dof_intro_zhao" },
    { 0x8698647F, "dof_jfk_setting" },
    { 0x1490F65A, "dof_josefina" },
    { 0x4C92F190, "dof_josefina_struggle" },
    { 0x4E542040, "dof_jumped" },
    { 0xCEC3E309, "dof_kid" },
    { 0x860E7854, "dof_kid_helper" },
    { 0x74416A00, "dof_kids" },
    { 0x4CD6E02A, "dof_kill_men" },
    { 0xE90E14BC, "dof_krav_focus" },
    { 0x9DEED2C3, "dof_krav_unfocus" },
    { 0x86132970, "dof_land" },
    { 0x972EA503, "dof_landed" },
    { 0xDD692ED0, "dof_leader" },
    { 0x5AB714AD, "dof_leg_look" },
    { 0x6B9A48AC, "dof_lerp" },
    { 0x7891AA3B, "dof_limo_setting" },
    { 0x2E46C3DE, "dof_look_at_bag1" },
    { 0x649DE83A, "dof_look_at_guys1" },
    { 0x3E9B6DD1, "dof_look_at_guys2" },
    { 0x18C8E811, "dof_look_down" },
    { 0xB56BD6EA, "dof_lookout" },
    { 0x8A9A31A2, "dof_mason_bag_empty" },
    { 0x5A7DEFB2, "dof_mason_gun_at_noriega" },
    { 0xEF6D156A, "dof_mason_jump" },
    { 0xF7AE8B47, "dof_mason_look" },
    { 0x009FB891, "dof_menendez" },
    { 0xD894CF15, "dof_menendez_1" },
    { 0xFE97497E, "dof_menendez_2" },
    { 0x2499C3E7, "dof_menendez_3" },
    { 0x0113A24A, "dof_menendez_capture" },
    { 0xEB584BB7, "dof_menendez_closeup" },
    { 0xAD1E66D1, "dof_menendez_look_1" },
    { 0xD320E13A, "dof_menendez_look_2" },
    { 0xF9235BA3, "dof_menendez_look_3" },
    { 0x544DF8FA, "dof_mirror" },
    { 0x6AD0FA9F, "dof_mkcnight_mason" },
    { 0x58CA7B92, "dof_motorcade_start" },
    { 0xA2C44C9F, "dof_near_blur" },
    { 0xBC831B03, "dof_near_end" },
    { 0x3EB88DF0, "dof_near_start" },
    { 0xF2B0E60A, "dof_noriega" },
    { 0x2B7AB06C, "dof_noriega_look_1" },
    { 0x9D821FA7, "dof_noriega_look_2" },
    { 0x777FA53E, "dof_noriega_look_3" },
    { 0xB9734131, "dof_noriega_look_4" },
    { 0x7FCF36F5, "dof_noriega_shoots" },
    { 0x715934B2, "dof_number_attack_hold_head" },
    { 0xEF1A81FE, "dof_omar" },
    { 0xE74D2319, "dof_opening" },
    { 0x428B2896, "dof_passing_gaurd" },
    { 0xEFA316AB, "dof_pendant" },
    { 0x77C86724, "dof_pmc1_closeup" },
    { 0x4FED4A57, "dof_pmc2_closeup" },
    { 0xCB4572EC, "dof_point_gun" },
    { 0xDC1A89BC, "dof_pool_setting" },
    { 0xF08DC166, "dof_quadrotor" },
    { 0x7EE33451, "dof_rappelers" },
    { 0xE51D5A61, "dof_rappelers2" },
    { 0xBF1ADFF8, "dof_rappelers3" },
    { 0xC92C38D7, "dof_rappelers4" },
    { 0x23143815, "dof_rappell" },
    { 0x58329F58, "dof_reflection" },
    { 0x26908A54, "dof_reset" },
    { 0xB72813EC, "dof_road_setting" },
    { 0xF47078EA, "dof_room" },
    { 0xD5075599, "dof_rubble" },
    { 0x49C15BF6, "dof_rubble_2" },
    { 0x8AC64170, "dof_run2wall" },
    { 0x530EBD99, "dof_salazar_1" },
    { 0x523F070F, "dof_sceneabbreviation_shotnumber" },
    { 0xDE077FA4, "dof_security_setting" },
    { 0xA2F79A64, "dof_shed_open" },
    { 0xCF8ECC70, "dof_shoe_look" },
    { 0xF1DCC691, "dof_shoot_leg" },
    { 0x89D796E9, "dof_shoot_vtol1" },
    { 0x478A375B, "dof_shoot_vtol10" },
    { 0x2187BCF2, "dof_shoot_vtol11" },
    { 0xFB854289, "dof_shoot_vtol12" },
    { 0xD582C820, "dof_shoot_vtol13" },
    { 0xDF9420FF, "dof_shoot_vtol14" },
    { 0xB991A696, "dof_shoot_vtol15" },
    { 0xAFDA1152, "dof_shoot_vtol2" },
    { 0xD5DC8BBB, "dof_shoot_vtol3" },
    { 0xFBDF0624, "dof_shoot_vtol4" },
    { 0x21E1808D, "dof_shoot_vtol5" },
    { 0x47E3FAF6, "dof_shoot_vtol6" },
    { 0x6DE6755F, "dof_shoot_vtol7" },
    { 0x93E8EFC8, "dof_shoot_vtol8" },
    { 0xB9EB6A31, "dof_shoot_vtol9" },
    { 0x2CC02B60, "dof_shotgun_look_2" },
    { 0x0CA48550, "dof_shove_noriega" },
    { 0x950206E7, "dof_sr_car" },
    { 0x91182362, "dof_sr_debris_falling" },
    { 0x530CF35B, "dof_sr_first_explosion" },
    { 0xB1BDE9CB, "dof_sr_first_rpg" },
    { 0x82A818BD, "dof_sr_get_up_hand" },
    { 0xF59D075F, "dof_sr_hands" },
    { 0x629F7642, "dof_sr_hook_up" },
    { 0x7528FE77, "dof_sr_second_explosion" },
    { 0xB3000257, "dof_sr_second_rpg" },
    { 0x8C4D2F4F, "dof_stab" },
    { 0x24466920, "dof_stab_menendez" },
    { 0xC6834EB9, "dof_start" },
    { 0x4C44D7F2, "dof_steiner_office" },
    { 0x51FB33BA, "dof_steiner_office_1" },
    { 0x2BF8B951, "dof_steiner_office_2" },
    { 0x7A17FCE2, "dof_stomp" },
    { 0xC795A7B5, "dof_strangle" },
    { 0xE0114B8A, "dof_struggle" },
    { 0x82D2DBF9, "dof_sunset" },
    { 0x75531106, "dof_syringe" },
    { 0xEF26A8B9, "dof_take_gun" },
    { 0x4B9F7A01, "dof_tank_off" },
    { 0xC9A6CCF5, "dof_tank_on" },
    { 0xFBFA1998, "dof_tarmac_setting" },
    { 0xA0891236, "dof_throw_bag" },
    { 0xB3D41762, "dof_throw_gun" },
    { 0xA466C11E, "dof_time_lapse" },
    { 0xDA636952, "dof_transition" },
    { 0xF7D732F4, "dof_truck" },
    { 0x665B65D8, "dof_tv_smash" },
    { 0xC9E80DAE, "dof_vent" },
    { 0x74EA2208, "dof_vtol" },
    { 0x0FC583D4, "dof_vtol_1" },
    { 0x81CCF30F, "dof_vtol_2" },
    { 0xEEEFBD39, "dof_vtol_flight" },
    { 0xBB990580, "dof_vtol_leave" },
    { 0xE04759B3, "dof_vtol_liftoff" },
    { 0x4A62D189, "dof_walk_menendez" },
    { 0x224E1B69, "dof_walk_out" },
    { 0x896AA91B, "dof_warroom_setting" },
    { 0x6FC2AB1F, "dof_woods" },
    { 0x08E7DB14, "dof_woods1" },
    { 0x7AEF4A4F, "dof_woods2" },
    { 0x4A3554F1, "dof_woods_end" },
    { 0xE063A3D9, "dof_woods_up" },
    { 0xF531D169, "dof_zhao" },
    { 0x8F1C96C9, "doface" },
    { 0xBF2AA0BA, "doface_generichuman" },
    { 0xF05EAE1B, "doface_player" },
    { 0x34EADFC9, "dofacialanim" },
    { 0x75161ACB, "dofdefault" },
    { 0x2A569AF3, "dofeedback" },
    { 0xED82189B, "dofinalkillcam" },
    { 0x7A34684B, "dofiring" },
    { 0x82658853, "dofiringdeath" },
    { 0x521FCA0B, "doflameaudio" },
    { 0x72D46630, "doflamedamage" },
    { 0x9B59D729, "doflashbanged" },
    { 0x0A542456, "dofog" },
    { 0x8A1F6BA6, "dofprone" },
    { 0x80BABFDB, "dofrange" },
    { 0x26156CA2, "dofreg" },
    { 0xE3349F77, "dofutz" },
    { 0xC6940DD6, "dofvars" },
    { 0xD0C990AC, "dofvarupdate" },
    { 0x7CE2A105, "dog" },
    { 0xFB1A25FE, "dog_abort" },
    { 0x6D7CBFA7, "dog_anim" },
    { 0x917C075C, "dog_animation_generic" },
    { 0x63FAEB77, "dog_animation_wakeup_fast" },
    { 0x88D84DA6, "dog_animation_wakeup_slow" },
    { 0x092A6F1E, "dog_anims" },
    { 0x9B5D971F, "dog_array" },
    { 0x004943F5, "dog_attack_trigger" },
    { 0x149294FE, "dog_attack_when_enemy" },
    { 0xAD759625, "dog_attacks_fence" },
    { 0x3B0D1A95, "dog_attacks_player" },
    { 0xC5AE1118, "dog_attacks_player_if_he_feels_threatened" },
    { 0x787FD392, "dog_bark_delay" },
    { 0xDFF51545, "dog_behave" },
    { 0x323A210F, "dog_behind_audio" },
    { 0xA759EE63, "dog_blocker_clip" },
    { 0xB15CCB1C, "dog_body" },
    { 0xFB0CF2CA, "dog_can_spawn_time" },
    { 0x44B883E2, "dog_cant_kill_in_one_hit" },
    { 0xBEC45090, "dog_check" },
    { 0x88AAC8EF, "dog_claimed" },
    { 0xEEDAFA05, "dog_clean_up" },
    { 0xD785D454, "dog_cleanup_wait" },
    { 0xC8544CF1, "dog_cleanup_waiter" },
    { 0x8E29F4D9, "dog_clip_monitor" },
    { 0xE5DA80AF, "dog_clip_watcher" },
    { 0x3BF97B85, "dog_clips" },
    { 0x4E6EC088, "dog_combat" },
    { 0x3A228285, "dog_count" },
    { 0xC6E85ED2, "dog_count_max_at_once" },
    { 0x971FCE06, "dog_create_spawn_influencer" },
    { 0x54B9A74B, "dog_damage" },
    { 0x6A19E6EC, "dog_damage_func" },
    { 0x216D2EDE, "dog_death" },
    { 0x747CD154, "dog_death_hud" },
    { 0xDA666E3B, "dog_death_quote" },
    { 0x24D0F772, "dog_deathquote" },
    { 0xA859DC2D, "dog_debug" },
    { 0x3547DEA6, "dog_debug_anims" },
    { 0xAC51098C, "dog_debug_anims_ent" },
    { 0x1D2B3893, "dog_debug_orient" },
    { 0x3C74D4E2, "dog_debug_patrol" },
    { 0x4A252A85, "dog_debug_print" },
    { 0x6768445D, "dog_debug_sound" },
    { 0x198511FC, "dog_debug_turns" },
    { 0x344F3125, "dog_debug_usage" },
    { 0x39475062, "dog_died" },
    { 0x3DBD8408, "dog_difficulty_max_time" },
    { 0x40443086, "dog_difficulty_min_time" },
    { 0xC53B7808, "dog_door" },
    { 0xA12210AB, "dog_door_open" },
    { 0x5DA27D75, "dog_dvar_update" },
    { 0x6F4F96AD, "dog_dvar_updater" },
    { 0xBACBF551, "dog_early_notetrack" },
    { 0x29918162, "dog_eater_unlink_on_death" },
    { 0x3D474943, "dog_enemy_team_mask" },
    { 0x5D3F68B4, "dog_exit_show" },
    { 0x6CC568D8, "dog_explode_fx" },
    { 0x28AE2267, "dog_eye" },
    { 0x4CA371F9, "dog_flashed" },
    { 0xAB72D903, "dog_flee_org" },
    { 0x8CEBD67B, "dog_follow_node_array_then_attack_target" },
    { 0x08F3A391, "dog_free_kill" },
    { 0x4BC83022, "dog_fx" },
    { 0x90C42418, "dog_fx_eye_glow" },
    { 0x166F2B53, "dog_fx_trail" },
    { 0xD8C66518, "dog_get_count" },
    { 0x6BEE217C, "dog_get_dvar" },
    { 0x98BF40F6, "dog_get_dvar_int" },
    { 0xE5321612, "dog_get_exit_node" },
    { 0x9ADB416C, "dog_get_living" },
    { 0xB87FCDA2, "dog_go" },
    { 0x18FAEAAC, "dog_handler" },
    { 0x3DD6C9C8, "dog_handler2_setup" },
    { 0xC05D4336, "dog_handler2_wakeup" },
    { 0x1C37C1F4, "dog_handler_anim" },
    { 0xEB19DC36, "dog_handler_setup" },
    { 0x427719BA, "dog_health" },
    { 0x44A54BE1, "dog_health_increase" },
    { 0xE5624260, "dog_health_regen" },
    { 0xF7AE2E49, "dog_health_regen_think" },
    { 0xEDDE9AC4, "dog_health_regen_time" },
    { 0x92E9F723, "dog_hint" },
    { 0x3B3DDF64, "dog_hint_fade" },
    { 0x9D0779EB, "dog_hits_before_kill" },
    { 0x2121392F, "dog_incident_origin" },
    { 0x472BF6B2, "dog_influencer_radius" },
    { 0x40D1E176, "dog_influencer_score" },
    { 0x4FACA6E2, "dog_influencer_score_curve" },
    { 0x4D14EDAE, "dog_init" },
    { 0x1CF6CF4C, "dog_intermission" },
    { 0x13B3841A, "dog_is_alive" },
    { 0xBD69D66E, "dog_is_coming" },
    { 0x8FA8B3B3, "dog_jump_down" },
    { 0x58D2D205, "dog_jump_down_far" },
    { 0x90A83C6D, "dog_jump_think" },
    { 0x7D0345BC, "dog_jump_up" },
    { 0xF2682403, "dog_jump_up_high" },
    { 0x62CCC298, "dog_kill" },
    { 0xA9D0FAAB, "dog_killed" },
    { 0x62A07A8B, "dog_killstreak_init" },
    { 0x25A98345, "dog_leave" },
    { 0x7CBB167B, "dog_leave_failsafe" },
    { 0x5146D8EC, "dog_locations" },
    { 0xD2E901A5, "dog_locs" },
    { 0xFC137A62, "dog_loop" },
    { 0x93F6388E, "dog_loop_sound" },
    { 0x1415306E, "dog_manager_abort" },
    { 0xFAEBCE75, "dog_manager_delete_dogs" },
    { 0x06820781, "dog_manager_dog_alive_tracker" },
    { 0x53135F92, "dog_manager_dog_time_limit" },
    { 0xAB8FA017, "dog_manager_game_ended" },
    { 0xB944B696, "dog_manager_get_dogs" },
    { 0x4B764FA6, "dog_manager_spawn_dog" },
    { 0xEC5275D9, "dog_manager_spawn_dogs" },
    { 0xA1657C3A, "dog_manager_spawn_more_dogs_on_death" },
    { 0x2500E874, "dog_max_dog_attackers" },
    { 0x79A5E9F4, "dog_melee_damage" },
    { 0x283E878B, "dog_melee_death" },
    { 0xCF25C105, "dog_melee_index" },
    { 0x4E8319A7, "dog_melee_miss" },
    { 0x75926BBA, "dog_melee_range" },
    { 0x32AAEE4B, "dog_melee_timing_array" },
    { 0x490E4D81, "dog_mode" },
    { 0x5BBD4B36, "dog_model_enemy" },
    { 0xB49FF6E3, "dog_model_friendly" },
    { 0x088452AF, "dog_move" },
    { 0x78BE54F8, "dog_move_audio" },
    { 0xB2A66709, "dog_no_longer_melee_able" },
    { 0x8262B7AF, "dog_notify_level_on_death" },
    { 0x15D329D5, "dog_objective_next_update" },
    { 0x4DEC1E08, "dog_objectives" },
    { 0xB441F3D7, "dog_on_u" },
    { 0x62D0F1EB, "dog_owner_kills" },
    { 0x1554A6C8, "dog_pain" },
    { 0x47965D5A, "dog_patrol" },
    { 0x14B6BAAE, "dog_patrol_debug" },
    { 0xB973C0B6, "dog_patrol_near_enemy" },
    { 0xC5DD1773, "dog_patrol_near_objective" },
    { 0x91129751, "dog_patrol_path_waiter" },
    { 0x0E4CE39E, "dog_patrol_wait" },
    { 0xABCE65B4, "dog_patrol_when_no_enemy" },
    { 0x113F4917, "dog_pick_node_away_from_enemy" },
    { 0x8CBD51E3, "dog_pick_node_final" },
    { 0xD9E7F0BD, "dog_pick_node_near_team" },
    { 0x8CFBF674, "dog_pick_node_random" },
    { 0x49E6DE19, "dog_player_damage" },
    { 0xF3498C64, "dog_prespawn" },
    { 0x70ACEDFA, "dog_presstime" },
    { 0xB72CE78D, "dog_print" },
    { 0x194280B8, "dog_register_death" },
    { 0x9B73E833, "dog_reloc" },
    { 0x8EF904D4, "dog_reloc_monitor" },
    { 0x84EBEE86, "dog_reloc_trig_array" },
    { 0x0333F95A, "dog_relocate_init" },
    { 0x55736391, "dog_round_aftermath" },
    { 0x1AE748D4, "dog_round_count" },
    { 0xD7C2375A, "dog_round_ending" },
    { 0x843B73A8, "dog_round_spawning" },
    { 0x3FD71905, "dog_round_start" },
    { 0x1F9A4153, "dog_round_start_time" },
    { 0x8B27D5E3, "dog_round_starting" },
    { 0x58806457, "dog_round_stop" },
    { 0xBD2B1213, "dog_round_track_override" },
    { 0xB7C69D79, "dog_round_tracker" },
    { 0x4EE7D855, "dog_round_wait_func" },
    { 0xB085EADA, "dog_rounds_allowed" },
    { 0x0459C76D, "dog_rounds_enabled" },
    { 0x5EECAD79, "dog_run_off" },
    { 0x048024BE, "dog_run_think" },
    { 0xE29134B5, "dog_running" },
    { 0xEA573C06, "dog_runoff" },
    { 0x13928F75, "dog_script_fix" },
    { 0x5BE72F58, "dog_seek_player" },
    { 0x1B915EBE, "dog_set_model" },
    { 0x6ECE2D8C, "dog_set_owner" },
    { 0x8F27A074, "dog_set_team" },
    { 0xD5AE234F, "dog_settings" },
    { 0x9C7E18AF, "dog_setup" },
    { 0x3565EA48, "dog_setup_func" },
    { 0xB86C232D, "dog_sound_print" },
    { 0xB6238C74, "dog_sounds" },
    { 0x81587D15, "dog_spawn" },
    { 0x50BE7D1D, "dog_spawn_factory_logic" },
    { 0x3706787A, "dog_spawn_func" },
    { 0x18CDA252, "dog_spawn_fx" },
    { 0x6EB95783, "dog_spawn_show" },
    { 0x07215EAC, "dog_spawn_sumpf_logic" },
    { 0x270E6EF8, "dog_spawn_time_delay_max" },
    { 0x42039AA6, "dog_spawn_time_delay_min" },
    { 0x437A7192, "dog_spawn_transit_logic" },
    { 0x88278484, "dog_spawner" },
    { 0x5DA2EF75, "dog_spawner_init" },
    { 0x6B76CA37, "dog_spawners" },
    { 0xA16D1F64, "dog_spawns" },
    { 0x4F194AA7, "dog_spotted" },
    { 0xFA6D1E62, "dog_stalk_audio" },
    { 0x8457889C, "dog_start" },
    { 0x54AE2C5F, "dog_start_monitor" },
    { 0xD3C06010, "dog_stop" },
    { 0x9C6ED203, "dog_stop_monitor" },
    { 0x37ED8852, "dog_targets" },
    { 0xA8E8C8A3, "dog_team" },
    { 0x074D7149, "dog_that_runs_on_slum_entrance" },
    { 0xDFC624E0, "dog_thread_behavior_function" },
    { 0x7BAFFF5E, "dog_thundergun_disintegrate" },
    { 0x79101C39, "dog_thundergun_knockdown" },
    { 0x8A1AD953, "dog_time" },
    { 0xB13C43AC, "dog_trigger" },
    { 0x82EDB020, "dog_type" },
    { 0xCF8A40CD, "dog_usage" },
    { 0x0B803B46, "dog_usage_init" },
    { 0xBB2F69AB, "dog_usage_kills" },
    { 0xE33958C2, "dog_usage_monitor" },
    { 0xC4966FC1, "dog_usage_time_alive" },
    { 0x913DC5F1, "dog_victim_think" },
    { 0x18378FBB, "dog_wait" },
    { 0x47DC88BF, "dog_wait_print" },
    { 0x54A0F41F, "dog_walk_max_yaw_delta" },
    { 0xC61A21AA, "dog_walk_min_lookahead_dist" },
    { 0x8159CFA5, "dog_wall_and_window_hop" },
    { 0xA1950E36, "dog_watch_for_owner_team_change" },
    { 0x622F888A, "dogangle" },
    { 0x8022E995, "doganims" },
    { 0x6DF91607, "dogattackaidist" },
    { 0x53615493, "dogattackallowtime" },
    { 0x58575C55, "dogattackplayercloserangedist" },
    { 0x2296AB16, "dogattackplayerdist" },
    { 0x9EC6CD00, "dogchutethink" },
    { 0x2492841A, "dogcount" },
    { 0x495C0EF5, "dogdeathdevent" },
    { 0x4952D100, "dogdistanceweight" },
    { 0xCFCA7EE6, "dogdistsum" },
    { 0xB96F66D4, "dogexitnodes" },
    { 0xBC648695, "dogfight" },
    { 0xF3BCA529, "dogfight_allies_weapons_think" },
    { 0xD6555638, "dogfight_ally_avoid_player" },
    { 0xDCFC5962, "dogfight_ambient_building_explosions" },
    { 0xE4E8D893, "dogfight_ambient_drone_spawn_manager" },
    { 0x9DFA3970, "dogfight_convoy_strafe" },
    { 0xBF527618, "dogfight_convoy_strafe_follow" },
    { 0x768FC206, "dogfight_countermeasures_think" },
    { 0xAFBD5138, "dogfight_done" },
    { 0x3519A4A8, "dogfight_drone_evade" },
    { 0x6DE5410A, "dogfight_drones_weapons_think" },
    { 0xAE6C534D, "dogfight_enemy_counter" },
    { 0x2EC7D53B, "dogfight_event_logic" },
    { 0xC9F7FF0F, "dogfight_friendly_vo_callouts" },
    { 0x0B8F1B07, "dogfight_player_strafe" },
    { 0x6F62F0E9, "dogfight_player_strafe_follow" },
    { 0x4594F2C4, "dogfight_save_restore" },
    { 0x374172C6, "dogfight_switch_node_test" },
    { 0x40F90B42, "dogfight_targets" },
    { 0x7AF1B6CC, "dogfight_warning" },
    { 0xF5B5C9BB, "dogfight_warning_time_last" },
    { 0x8F9E6A04, "dogfighter" },
    { 0x3B4D6693, "dogfighting" },
    { 0x156013E4, "dogfights" },
    { 0x9831824F, "dogfights_done" },
    { 0x590A4F3E, "dogfights_manage_wave_count" },
    { 0x3CF70B12, "dogfights_monitor_failure_distance" },
    { 0x0EC02F48, "dogfights_monitor_warning_distance" },
    { 0x46CD63A9, "dogfights_objective_get_available_position" },
    { 0x348E825D, "dogfights_objective_index" },
    { 0x36F70EBA, "dogfights_objective_marker_active" },
    { 0x12E1EE14, "dogfights_objective_release_position" },
    { 0x1877D9AE, "dogfights_objective_setup" },
    { 0x420564B0, "dogfights_objective_strafe_marker_active" },
    { 0xBEEBF4B9, "dogfights_objective_update_counter" },
    { 0xF5917B6D, "dogfights_story_done" },
    { 0x0734F4C7, "dogfights_targets" },
    { 0x6EEBD459, "dogfights_volume" },
    { 0x8E7C0381, "doggy" },
    { 0x790FBF2A, "doggy_attack_vox" },
    { 0x5FFDCC31, "doggy_movement_vox" },
    { 0x51F3776A, "doghealth_regularregendelay" },
    { 0xD944567A, "doghealthregen" },
    { 0x51153D62, "doghealthregendisabled" },
    { 0x3F59C04B, "doghintelem" },
    { 0xF6C81079, "doghitelem" },
    { 0xFA786969, "dogibbeddeath" },
    { 0x8728F326, "dogibbing" },
    { 0xC54ED64F, "dogidlenotetracks" },
    { 0x58913613, "dogiveammo" },
    { 0x8ACEBC4F, "dogivehealth" },
    { 0x7A834FED, "dogiveinvuln" },
    { 0x38D71DA7, "dogivekillstreak" },
    { 0x061B7C22, "dogivelives" },
    { 0xF16FBE31, "dogiveperk" },
    { 0x2BF4B1ED, "dogivescore" },
    { 0xE31E4ED1, "doglassdamage" },
    { 0xB2C986EB, "doglookpose" },
    { 0x565A8906, "dogmanagerongetdogs" },
    { 0xB8824DF6, "dogmeleebiteattacktime" },
    { 0xCAF623DE, "dogmeleebiteattacktimestart" },
    { 0x6A435B99, "dogmeleefinishattacktime" },
    { 0x8CC29A43, "dogmeleefinishattacktimestart" },
    { 0x48ACB5F8, "dogmeleeplayercounter" },
    { 0xFA3468C2, "dogquantity" },
    { 0x2ED4B8E8, "dogrenadethrow" },
    { 0x75421224, "doground_nomusic" },
    { 0xC5BF2601, "dogrunpainspeed" },
    { 0x57867FBE, "dogrunturnspeed" },
    { 0xCCD19994, "dogs" },
    { 0xDEEC75C6, "dogs_attach_c4" },
    { 0x991D1C11, "dogs_backup" },
    { 0x5718E892, "dogs_complete" },
    { 0x4DC2DA18, "dogs_delete_dogs" },
    { 0x06A9B9FC, "dogs_dog_dead" },
    { 0xF9BCAD57, "dogs_dont_instant_kill" },
    { 0x484CE28E, "dogs_eater" },
    { 0x02A07463, "dogs_eater_bark" },
    { 0x92244AF9, "dogs_eater_death" },
    { 0x6BA00FD1, "dogs_eater_eat" },
    { 0xE18B2FE0, "dogs_eater_growl" },
    { 0x61C54E76, "dogs_enabled" },
    { 0x1A98EEC7, "dogs_food" },
    { 0xBA45482C, "dogs_in_the_bsp" },
    { 0x5CFD1854, "dogs_loaded" },
    { 0x8E413C44, "dogs_main" },
    { 0x597983DF, "dogs_moveup" },
    { 0xD6FD417D, "dogs_sneakpast" },
    { 0x6903E20A, "dogsactive" },
    { 0x1F6801C8, "dogsactivekillstreak" },
    { 0x58998753, "dogshit" },
    { 0xD79C02E6, "dogsinitialized" },
    { 0x9A9388F7, "dogsinterval" },
    { 0x35FA7203, "dogsled" },
    { 0xDB9C3245, "dogsled_beckoner" },
    { 0xBF4D4B86, "dogsled_fog" },
    { 0x01CD0172, "dogsleds" },
    { 0x133EDE9E, "dogsleds_reset" },
    { 0x167E91BA, "dogsmomentum" },
    { 0xCB91AD1E, "dogsonflashdogs" },
    { 0x4DC0C3B5, "dogspawnnodes" },
    { 0xCE42F587, "dogsplat" },
    { 0x15F74996, "dogsplode" },
    { 0x35234669, "dogsquad" },
    { 0x692870F4, "dogstartmoveangles" },
    { 0x12E97FE3, "dogstartmoveanim" },
    { 0x184D79B4, "dogstartmovedist" },
    { 0xC57A6899, "dogstoppingdistsq" },
    { 0x706216A2, "dogstrig" },
    { 0xE2217577, "dogtag" },
    { 0x4282FCB4, "dogtag_spawned" },
    { 0xDBC75B54, "dogtag_vanish_fx" },
    { 0x38C3F2AE, "dogtags" },
    { 0x4E172B2B, "dogtraverseanims" },
    { 0xFE018C3D, "dogturnangle" },
    { 0x1AAB1C90, "dogturnaroundangle" },
    { 0x16AC79D3, "dogturnmindistancetogoal" },
    { 0x0FC5710D, "dogtype" },
    { 0x92185F32, "dogvibrate" },
    { 0xDAC75E82, "doh" },
    { 0x0F4E22CB, "dohackedstats" },
    { 0x46568E8C, "doimmediateragdolldeath" },
    { 0x1C6C37FF, "doin" },
    { 0x7D38CF1B, "doincendiarydamage" },
    { 0x2A9D4686, "doincendiarygrounddamage" },
    { 0xBF07B8C6, "doinfo" },
    { 0x0A66CFD2, "doing" },
    { 0x49529F9C, "doing_cinematic" },
    { 0x36C90D8A, "doing_defend_color_chains" },
    { 0xB988971E, "doing_equipment_attack" },
    { 0xD24CCEBA, "doing_ft_sweep" },
    { 0x58B71094, "doing_last_minute_exposed_approach" },
    { 0xC1708923, "doing_scripted_burn_damage" },
    { 0x6574D9ED, "doing_shield_attack" },
    { 0x94B2C9BF, "doing_shootwhilemoving" },
    { 0x52298928, "doing_tank_sweep" },
    { 0xC93510CE, "doingadditivepain" },
    { 0x4E428710, "doingaimelee" },
    { 0xF5B7EA4E, "doingambush" },
    { 0x2434C340, "doingbalconydeath" },
    { 0x9E3B36CC, "doingcqbapproach" },
    { 0xF0868AEC, "doingintroscreen" },
    { 0x8F238B76, "doinglongdeath" },
    { 0xDECBF609, "doingnotify" },
    { 0x320CC363, "doingragdolldeath" },
    { 0x608568F5, "doinitialspawnmessaging" },
    { 0x254FEF14, "dointelacquiredui" },
    { 0xD75F44B0, "dointroscreen" },
    { 0xE71F7397, "dojo" },
    { 0x0CFAAC96, "dojump" },
    { 0xABF09007, "dokillcam" },
    { 0x5C7F94A6, "dokillcamentity" },
    { 0xE3725562, "dolastminuteexposedapproach" },
    { 0xAB40AEE0, "dolastminuteexposedapproachconditions" },
    { 0x690382B2, "dolastminuteexposedapproachmidconditions" },
    { 0x51C48773, "dolastminuteexposedapproachpreconditions" },
    { 0x28949483, "dolastminuteexposedapproachwrapper" },
    { 0xE46EDF3F, "dole" },
    { 0x3CCB73E8, "doline" },
    { 0xEE80381E, "doll" },
    { 0xB6E680BA, "dollars" },
    { 0x8C4CD081, "dolls" },
    { 0xA83DF20B, "dolly" },
    { 0x1B0A7299, "dolly_movement" },
    { 0x2D9905AA, "dollyend" },
    { 0xA5D3BD2D, "dollygo" },
    { 0x7CD2A9B1, "dollystart" },
    { 0xCB3C79C0, "dollytime" },
    { 0x9EB4942B, "dolocation" },
    { 0xD1888139, "dolocationalsound" },
    { 0x57D4B53B, "dolook" },
    { 0xC1B07584, "dolos" },
    { 0x98D3C28F, "dom" },
    { 0x45F578D1, "dom_defends" },
    { 0x44EACAF4, "dom_enemy_flag_influencer_radius" },
    { 0x86A51A74, "dom_enemy_flag_influencer_score" },
    { 0x4D47BA68, "dom_enemy_flag_influencer_score_curve" },
    { 0xCC73CD50, "dom_flag" },
    { 0xB6D6BFFC, "dom_flag_base_fx_override" },
    { 0x628641CD, "dom_flag_cap_fx_override" },
    { 0x6BC76D5C, "dom_gamemodespawndvars" },
    { 0x5A67B4DC, "dom_get_best_flag" },
    { 0x40BD74AB, "dom_get_closest_flag" },
    { 0x4BE4C21D, "dom_get_random_flag" },
    { 0x4C9E332F, "dom_get_random_friendly_flag" },
    { 0xD28DC951, "dom_get_weighted_contested_flag" },
    { 0x2CAF8008, "dom_get_weighted_enemy_flag" },
    { 0x2D93D403, "dom_get_weighted_flag" },
    { 0xFCFE61AD, "dom_has_two_flags" },
    { 0x94AB7235, "dom_is_flag_contested" },
    { 0x726B5872, "dom_is_game_start" },
    { 0x739AD6D4, "dom_is_near_flag" },
    { 0xBA2F70D3, "dom_offends" },
    { 0x62D99982, "dom_owned_inner_flag_influencer_radius" },
    { 0x4D638D46, "dom_owned_inner_flag_influencer_score" },
    { 0x31C528F2, "dom_owned_inner_flag_influencer_score_curve" },
    { 0x21333F99, "dom_owned_outer_flag_influencer_radius" },
    { 0xF120B11F, "dom_owned_outer_flag_influencer_score" },
    { 0xDB3A9D13, "dom_owned_outer_flag_influencer_score_curve" },
    { 0xD9D211D0, "dom_point" },
    { 0xE0B8E3B3, "dom_rules" },
    { 0x6C70459F, "dom_unowned_flag" },
    { 0x79C65410, "dom_unowned_flag_influencer_radius" },
    { 0xF8E741B8, "dom_unowned_flag_influencer_score" },
    { 0x014F7DCB, "dom_unowned_inner_flag_influencer_radius" },
    { 0x5D142145, "dom_unowned_inner_flag_influencer_score" },
    { 0x2D813B09, "dom_unowned_inner_flag_influencer_score_curve" },
    { 0xB80BB3BA, "dom_wins_index" },
    { 0x3F2D2478, "domaintraverse_animation" },
    { 0x11722C1D, "domaintraverse_animationaiming" },
    { 0xAB756E06, "domaintraverse_notetracks" },
    { 0xE57D0B55, "domattackermultikill" },
    { 0x02C3C09B, "domaxanglecheck" },
    { 0x5459EAF7, "domaxdamage" },
    { 0xDC8506B8, "domdebug" },
    { 0xA73CCA70, "dome" },
    { 0x611A87EB, "dome_apex" },
    { 0x77020B0A, "dome_exploded" },
    { 0xB4B350EE, "dome_friendly_combat_dialogue" },
    { 0x0CAAE511, "dome_malfunction_pad" },
    { 0x03C89AFF, "dome_mg_adjust" },
    { 0x267472D4, "dome_pacing_dialogue" },
    { 0x403A6E3C, "domeapex" },
    { 0xF72CD3E3, "domedal" },
    { 0xD3A8BD16, "domedalcallback" },
    { 0x64E1E91B, "domeleeafterwait" },
    { 0x5ADE10EF, "domelights" },
    { 0x81C4ED25, "domflag" },
    { 0x31025B34, "domflagbasefxoverride" },
    { 0xCE8D93E1, "domflagcapfxoverride" },
    { 0x1B33A134, "domflags" },
    { 0x3F20A492, "domidpointcheck" },
    { 0x6EC4549E, "dominate" },
    { 0x529CA4F1, "dominate_weight" },
    { 0x556A6B7E, "dominated" },
    { 0x488FC46D, "dominated_challenge_check" },
    { 0xC41D7AB7, "dominating" },
    { 0x96BFC56D, "domination" },
    { 0x54AC0C62, "domination_progress1" },
    { 0x2EA991F9, "domination_progress2" },
    { 0x0D1A5E19, "domination_progress_text" },
    { 0xE14A5CB8, "domination_progress_text_enemy" },
    { 0xA4F354C1, "domination_progress_text_friendly" },
    { 0xA2BA7BEF, "domination_progress_text_left" },
    { 0xF7C2E04A, "domination_progress_text_right" },
    { 0x93CB4535, "dominationpoint" },
    { 0x2DC0F34B, "dominationstatus" },
    { 0x5DF9BD36, "dominiarrival" },
    { 0x7B30BA59, "dominoes" },
    { 0x75A03D20, "domissiledrone" },
    { 0xE2BFF375, "domissioncallback" },
    { 0xF3F82461, "domolotovslapdamage" },
    { 0x4A6042E9, "domortar" },
    { 0xCCDA0E12, "domortarfiresound" },
    { 0xB6F4A84B, "domortarstrike" },
    { 0x74EA2DEC, "domplayerspawngenerateinfluencers" },
    { 0xDE7F6853, "dompoint" },
    { 0x5517EC8A, "domwatchpoint" },
    { 0x26CC5354, "don" },
    { 0x682963A2, "donaho" },
    { 0x7D393CE3, "donanim" },
    { 0xF1054FC5, "donapalm" },
    { 0x214DD4FB, "donapalmgrounddamage" },
    { 0xAEC07428, "donapalmstrikedamage" },
    { 0xF8857CCC, "donate" },
    { 0xAF0772E0, "donated" },
    { 0x355070E1, "done" },
    { 0x90F83311, "done speaking" },
    { 0xCC4C335B, "done_aimaware" },
    { 0xDF245174, "done_animating" },
    { 0x0102C0A5, "done_avoiding" },
    { 0x30144CD3, "done_boosting" },
    { 0x9166D362, "done_changing_cover_pos" },
    { 0x0A205CB7, "done_crash_anim" },
    { 0x0119C3EF, "done_cycling" },
    { 0x382C4D1A, "done_exerting" },
    { 0x64F0ACE1, "done_firing" },
    { 0x9B3B785D, "done_following_path" },
    { 0xFE52CFB6, "done_level_notify" },
    { 0xB44ED6E8, "done_line_firing" },
    { 0x0947E05F, "done_notify" },
    { 0xCD6F6A27, "done_setting_new_color" },
    { 0x61CBA642, "done_speaking" },
    { 0xFFC40EE6, "done_spotting_relay" },
    { 0x796B2D4C, "done_squib" },
    { 0xD28F567B, "done_strafe_squibs" },
    { 0xE2DD7300, "done_strafing" },
    { 0x923E3B77, "done_stumbling" },
    { 0x66E7BD9C, "done_switching_turrets" },
    { 0xF55B0F70, "done_trigger" },
    { 0x7953A630, "done_using" },
    { 0x9021213B, "doneempfx" },
    { 0xCC49BA9F, "donemoving" },
    { 0x97253302, "donenotify" },
    { 0x815565B3, "dong" },
    { 0xF0FBD09D, "donggg" },
    { 0x6CD41DD1, "donkey" },
    { 0xB6E67E5E, "donkeykong" },
    { 0xEC2A9F7A, "donkeykong_autosaves" },
    { 0x8284E59B, "donkeykong_cleanup" },
    { 0x49B4265D, "donkeykong_colortriggers" },
    { 0x89C14BE3, "donkeykong_end_nag_vo" },
    { 0xF6074BA2, "donkeykong_end_vo" },
    { 0x49305E58, "donkeykong_kill_off_balcony_cartel" },
    { 0xDAB03344, "donkeykong_open_door" },
    { 0x532C5C30, "donkeykong_setup" },
    { 0x4C7655B2, "donkeykong_spawn_house_enemies" },
    { 0x60F9705B, "donkeykong_spawn_left_ridge_enemies" },
    { 0xB2E8AEC5, "donkeykong_stair_runner" },
    { 0x4E8330CE, "donkeykong_truck" },
    { 0x07C9D1ED, "donkeykong_truck_disable_turret_on_gunner_death" },
    { 0xDC0C894B, "donkeykong_truck_gunner_death" },
    { 0x029DB79E, "donkeykong_truck_shoot" },
    { 0x05BA1F7F, "donkeykong_truck_spawn_occupants" },
    { 0x874CCFD4, "donkeykong_vo" },
    { 0xC12CC8D6, "dononattackcoverbehavior" },
    { 0x4116CCB3, "donor" },
    { 0x8769BE88, "donotclear" },
    { 0x6B1A911B, "donotdamageowner" },
    { 0xB31AB2CF, "donotetrack" },
    { 0xC7930296, "donotetracks" },
    { 0xE1C4DE4F, "donotetracks_flak88" },
    { 0x7AD76E7B, "donotetracksforever" },
    { 0x288809B9, "donotetracksforeverfunc" },
    { 0xB884D48B, "donotetracksforeverintercept" },
    { 0xA9903697, "donotetracksforeverproc" },
    { 0x79366113, "donotetracksforexit" },
    { 0xEB6C0573, "donotetracksforpopup" },
    { 0xC4B703C8, "donotetracksfortime" },
    { 0x8CF6FB7C, "donotetracksfortimeendnotify" },
    { 0x3DC078E2, "donotetracksfortimeintercept" },
    { 0xFD474120, "donotetracksfortimeproc" },
    { 0x88D10CD0, "donotetracksintercept" },
    { 0xD377996C, "donotetracksnoshootstandcombat" },
    { 0xB5066D8D, "donotetrackspostcallback" },
    { 0xA51C4427, "donotetrackspostcallbackwithendon" },
    { 0x975D420C, "donotetracksuntilinterrupted" },
    { 0xD3496042, "donotetrackswithendon" },
    { 0xD8F75259, "donothing" },
    { 0x8A0486EB, "donothingfunc" },
    { 0xE5EE2225, "donotify" },
    { 0xBEA73497, "donotmovecamera" },
    { 0xCF148182, "donotrackusedstatonpickup" },
    { 0xE58A040D, "donotstop" },
    { 0xAF264FE8, "dont" },
    { 0x52767D5C, "dont_align_to_node_angles" },
    { 0x45480A15, "dont_allow_meat_interaction" },
    { 0x0A49C06C, "dont_arrive_at_goal" },
    { 0x5EB0E82A, "dont_attack_trigger" },
    { 0x763368DB, "dont_auto_balance" },
    { 0x20782FE8, "dont_auto_delete" },
    { 0xB948C049, "dont_auto_delete_scene" },
    { 0xDCE22E1E, "dont_autofire" },
    { 0xE5A91A7A, "dont_clear_anim" },
    { 0x18D0885E, "dont_delete" },
    { 0x83275CAE, "dont_die_on_me" },
    { 0xDDA81F7E, "dont_drop_flamer" },
    { 0x358F18E0, "dont_enable_weapons" },
    { 0x5F2A8DA7, "dont_end_idle" },
    { 0x011983E4, "dont_fire_when_unloading" },
    { 0x4D1EB6F5, "dont_forget_to_disarm" },
    { 0x75A72B3C, "dont_free_vehicle" },
    { 0x02A364DB, "dont_hit_me" },
    { 0x4814CE65, "dont_kill_riders" },
    { 0xA5E484FD, "dont_kill_threads" },
    { 0x7922D633, "dont_link_common_wallbuys" },
    { 0xF21ADEAE, "dont_lowerweapon" },
    { 0x4309675C, "dont_move" },
    { 0x093A67AB, "dont_move_time_max" },
    { 0xDC2DF365, "dont_move_time_min" },
    { 0xBA583961, "dont_patrol" },
    { 0xA55FC767, "dont_prone_while_touching" },
    { 0x046CD9FE, "dont_prone_while_touching_kill" },
    { 0x7686DACD, "dont_reduce_giptp_on_killanimscript" },
    { 0xDF4C6127, "dont_remove" },
    { 0x681C1B20, "dont_rethread" },
    { 0xB2F29F05, "dont_save_now" },
    { 0x33E7A838, "dont_shoot_enter_base_trigger" },
    { 0x989CD383, "dont_shoot_steiner" },
    { 0x1ED68CF6, "dont_show_c4_hint" },
    { 0xA954E196, "dont_show_hud" },
    { 0xE29D36E0, "dont_stop_flag" },
    { 0xA74B8A38, "dont_target" },
    { 0x00157BE6, "dont_throw_gib" },
    { 0xD810D16A, "dont_touch_the_meat" },
    { 0xEE901600, "dont_tread_on_z" },
    { 0xDD4E6EEE, "dont_turn" },
    { 0x51729F67, "dont_unset_perk_when_machine_paused" },
    { 0x67AE88C9, "dont_use_female_replacements" },
    { 0x7A1C58AB, "dont_use_goal_volume" },
    { 0x4294F0C2, "dontalert" },
    { 0x6E4AC306, "dontallowexplode" },
    { 0x6A2BDA7B, "dontannouncereturn" },
    { 0xFDAD2112, "dontascend" },
    { 0xE4F2B4BE, "dontattackme" },
    { 0x35CFA090, "dontavoidplayer" },
    { 0x7FB97D34, "dontcalcwagerwinnings" },
    { 0xA92E753F, "dontchangestate" },
    { 0x323DF155, "dontclamp" },
    { 0x64A70B30, "dontcqbtrackunlesswemovecqbagain" },
    { 0x479315E5, "dontcrouchtime" },
    { 0x8B3258D9, "dontdelete" },
    { 0x42C38732, "dontdisconnectpaths" },
    { 0x4DA00DBB, "dontdonotetracks" },
    { 0x72C6B2EA, "dontdropaiclips" },
    { 0x84EDAC03, "dontdropweapon" },
    { 0x435F7B44, "dontfire" },
    { 0x3E2D1CF4, "dontfreeme" },
    { 0x13013DEB, "dontgetup" },
    { 0xF5607BAE, "dontgiveuponsuppressionyet" },
    { 0xC05708B5, "dontinterpolate" },
    { 0x56164114, "dontlet_player_on_snipers_back" },
    { 0x0BCA3110, "dontlinkplayertotrigger" },
    { 0xADC607AC, "dontmelee" },
    { 0x85AA8F3E, "dontmeleeme" },
    { 0xB0F2B27A, "dontmovein" },
    { 0x37023935, "dontpeek" },
    { 0x446662D3, "dontplay_flag" },
    { 0x707AFF93, "dontpushplayer" },
    { 0x2C0DEE97, "dontpushtime" },
    { 0x296867F5, "dontreloadammo" },
    { 0x9DE05FA0, "dontremove" },
    { 0x99866796, "dontrevivehud" },
    { 0x00A23DCF, "dontsave" },
    { 0xBDF40825, "dontshoot" },
    { 0x9E710D47, "dontshootstraight" },
    { 0xA621309A, "dontshootwhilemoving" },
    { 0xA4B4A42C, "dontshootwhilemoving_old" },
    { 0x10629D43, "dontshow" },
    { 0xAD385CD6, "dontshowendreason" },
    { 0x9B631F62, "dontspeak" },
    { 0xC7F2C5D0, "dontswitchtoprimarybeforemoving" },
    { 0xE4C1EEA9, "dontsync" },
    { 0x8F4A8A95, "donttankcrush" },
    { 0x3BFD4704, "dontthrottle" },
    { 0x2209FAC9, "dontunloadonend" },
    { 0x55B45131, "doomsday" },
    { 0xCD299F87, "doonelefteventupdates" },
    { 0x089ABCDB, "doonlylegdamage" },
    { 0x560CFE33, "dooown" },
    { 0x79C2AAE5, "door" },
    { 0x0C48E586, "door1" },
    { 0x7797F601, "door1_org" },
    { 0x76EB8BDA, "door1node" },
    { 0xE6466B1D, "door2" },
    { 0x882893DA, "door2_org" },
    { 0xC043F0B4, "door3" },
    { 0x9A41764B, "door4" },
    { 0x194C9AFF, "door_3f" },
    { 0xD62687B1, "door_a" },
    { 0x84186020, "door_a_close" },
    { 0xC69C6FF4, "door_a_open" },
    { 0x7BEF2F1B, "door_activate" },
    { 0x4706F85C, "door_activate_func" },
    { 0xF6D0DB5D, "door_ai_damage_override" },
    { 0x1585184F, "door_align" },
    { 0x4ABFFE9E, "door_align_node" },
    { 0xE641AF94, "door_anglesmod" },
    { 0x27E6C447, "door_anim" },
    { 0x07F84216, "door_anim_node" },
    { 0xFC29021A, "door_b" },
    { 0xB12CEB8D, "door_b_open" },
    { 0x0750815B, "door_block" },
    { 0xE1C45DB6, "door_blocker" },
    { 0x1346F4FF, "door_breach" },
    { 0x32935317, "door_breach_1" },
    { 0x6A55D546, "door_breach_big_room" },
    { 0x390475D7, "door_breach_can_open" },
    { 0xA091D106, "door_breach_door" },
    { 0xC77558B2, "door_breach_door_reset" },
    { 0x3D5AD1CF, "door_breach_exploder_wait" },
    { 0x38181371, "door_breach_get_door_from_trig" },
    { 0x4451A18E, "door_breach_get_player_struct_dot" },
    { 0x86A590DE, "door_breach_get_struct_from_trig" },
    { 0x27D6F0BC, "door_breach_init" },
    { 0xA61D2931, "door_breach_init_gunnable_doors" },
    { 0x38BFACE4, "door_breach_init_triggers" },
    { 0xA7391881, "door_breach_left" },
    { 0x8F0399DA, "door_breach_load_door_anims" },
    { 0xFD81FE5F, "door_breach_load_fx" },
    { 0x6CA0B1E5, "door_breach_load_player_anims" },
    { 0x42DACDCE, "door_breach_node" },
    { 0x24CA64D8, "door_breach_open_all_doors" },
    { 0xED7B996C, "door_breach_right" },
    { 0x33010289, "door_breach_set_interactive_model" },
    { 0xD5488531, "door_breach_set_viewmodel" },
    { 0xC91C109A, "door_breach_start" },
    { 0x0F6AFC18, "door_breach_trigger_off" },
    { 0x0D490652, "door_breach_trigger_on" },
    { 0x9CE06299, "door_breach_wait" },
    { 0xA431491F, "door_breach_wait_for_button_pressed" },
    { 0x84CD1704, "door_breached" },
    { 0x53C1CE7A, "door_burst" },
    { 0x91E94473, "door_burst_start" },
    { 0x4ABC1A14, "door_button" },
    { 0x82832255, "door_button_glo" },
    { 0xF494F528, "door_buy" },
    { 0x7527F79E, "door_classify" },
    { 0x4EE59283, "door_clean" },
    { 0xFEEFE067, "door_clean_up_corpses" },
    { 0xDA2D0258, "door_clearance_timer" },
    { 0x2E533CEA, "door_clip" },
    { 0x68C6A367, "door_clip_ai" },
    { 0xEDF428AA, "door_clip_attach" },
    { 0xF37BEB8A, "door_clip_fix" },
    { 0x88D27114, "door_close" },
    { 0x0B090F5D, "door_close_disconnect" },
    { 0x1CCF4FF7, "door_close_thread" },
    { 0x4764C784, "door_close_zombie_think" },
    { 0x202C0038, "door_closed" },
    { 0xCA15B287, "door_closes" },
    { 0x25F72EE6, "door_col" },
    { 0xB1ED43DE, "door_coll" },
    { 0xFB9B6840, "door_collision" },
    { 0xD316C7FF, "door_connect_paths" },
    { 0xE14963D6, "door_connectpaths" },
    { 0x4171FDAF, "door_construction" },
    { 0xFBC983E6, "door_control_thread" },
    { 0x9953764B, "door_cooldown" },
    { 0xD76C717A, "door_damage_think" },
    { 0x28F602FE, "door_death" },
    { 0x6A420A4D, "door_death_ai_setup" },
    { 0xD1317A6A, "door_death_back_started" },
    { 0xC5BFC1D0, "door_death_front_started" },
    { 0x75F2308B, "door_death_path_connect" },
    { 0x1123CA44, "door_death_started" },
    { 0x8A24108E, "door_debug_line" },
    { 0x6B4171E5, "door_delay" },
    { 0xEBEEC274, "door_dest" },
    { 0x18D3D23B, "door_dialog_function" },
    { 0xD048D178, "door_dist" },
    { 0x95362E1C, "door_docks_left" },
    { 0xAC948F73, "door_docks_right" },
    { 0x27681E47, "door_ent" },
    { 0x34F382B8, "door_fall_over" },
    { 0x7ABFCF9E, "door_flag" },
    { 0xBC89D101, "door_goal" },
    { 0x837CC95F, "door_gramophone_elsewhere_hint" },
    { 0xEDFA496C, "door_guard_dead" },
    { 0x2C9050A9, "door_guy" },
    { 0x43A6B71E, "door_guy_logic" },
    { 0xC1CBFE7C, "door_guys_1" },
    { 0x33D36DB7, "door_guys_2" },
    { 0xDB628E13, "door_hack" },
    { 0x6CAC1BBB, "door_hack_precached" },
    { 0x5B86D8C8, "door_hacked" },
    { 0xAEE6BA35, "door_hinge" },
    { 0x4EB3BB3E, "door_hinge_nag_lines" },
    { 0xC18F4702, "door_hold_trigger" },
    { 0xBA1A5792, "door_hydro" },
    { 0xE25A088E, "door_idle" },
    { 0x522D7A2C, "door_index" },
    { 0x0504894E, "door_init" },
    { 0xE0D3AE9D, "door_is_moving" },
    { 0x3D706FF2, "door_key_fx" },
    { 0x10AC440B, "door_key_icon" },
    { 0x96A4595F, "door_key_model" },
    { 0xDC701D52, "door_kick" },
    { 0x2D7C2315, "door_kick_guy_logic" },
    { 0x01D96E09, "door_kick_sound_and_fx" },
    { 0x7E8654D3, "door_kick_trig" },
    { 0x563E59AD, "door_kicker_killed" },
    { 0xB893BE09, "door_kill_counter" },
    { 0xF0ADE505, "door_kill_notify1" },
    { 0x16B05F6E, "door_kill_notify2" },
    { 0x3CB2D9D7, "door_kill_notify3" },
    { 0x32A180F8, "door_kill_notify4" },
    { 0x58A3FB61, "door_kill_notify5" },
    { 0x525AE385, "door_knock_vox_occurring" },
    { 0x181A23A4, "door_l" },
    { 0x01A203AE, "door_l2" },
    { 0x7AEC779B, "door_left" },
    { 0x2D97769B, "door_left_warped" },
    { 0x54BFB8BF, "door_light_switch" },
    { 0x48616828, "door_link" },
    { 0xEF27CEF9, "door_local_power_off" },
    { 0x42BD420D, "door_local_power_on" },
    { 0xA471FD1A, "door_locked" },
    { 0x532F4A0F, "door_locked_fx" },
    { 0x4561C06E, "door_loop_sound" },
    { 0xF97E1747, "door_lower" },
    { 0x57C4F4C6, "door_lower_dmg" },
    { 0xD7FC8B3F, "door_main" },
    { 0xBE7178EF, "door_model" },
    { 0x7527F224, "door_model1" },
    { 0xE72F615F, "door_model2" },
    { 0x19F167DA, "door_monitor" },
    { 0x992558AF, "door_monster_clip" },
    { 0x4F55BC66, "door_move_dist" },
    { 0xAF934376, "door_move_think" },
    { 0x4DC9ECCA, "door_moving" },
    { 0x3E00CBA4, "door_nag_array" },
    { 0xDD73CC51, "door_name" },
    { 0x14DEDFFC, "door_node" },
    { 0x10B6FE65, "door_nodes_linked" },
    { 0x58E61531, "door_north" },
    { 0x4C546008, "door_notetracks" },
    { 0xDF09B156, "door_notify_done" },
    { 0xAC609A62, "door_notify_think" },
    { 0x5D6BC709, "door_obj_struct" },
    { 0x1C5A0116, "door_objmodel" },
    { 0x9340B55E, "door_office_01" },
    { 0xC0DB3ADF, "door_office_01_start" },
    { 0xCFA042E1, "door_offset" },
    { 0x4881DB90, "door_open" },
    { 0xC12A58C0, "door_open_angle" },
    { 0xF89EB548, "door_open_anim" },
    { 0xE3BED177, "door_open_blocker" },
    { 0x8ED55DC0, "door_open_double" },
    { 0xC6A4B825, "door_open_kick" },
    { 0x39C70F94, "door_open_message" },
    { 0xC217F768, "door_open_method" },
    { 0xCBE19A70, "door_open_slow" },
    { 0x2AE5F494, "door_open_time" },
    { 0x5191FDC4, "door_open_update" },
    { 0x76046123, "door_opened" },
    { 0xD8601988, "door_opening" },
    { 0x869BB97B, "door_opens" },
    { 0xB7E69E82, "door_org" },
    { 0x3C30B2CD, "door_orgs" },
    { 0xC50F710A, "door_originmod" },
    { 0xEEDB0A14, "door_out_opened" },
    { 0xC778530D, "door_parts_hide" },
    { 0xC089B9BB, "door_perk_drop_list" },
    { 0x96D05310, "door_player_clip" },
    { 0x4D51DD9D, "door_player_dist_sq" },
    { 0x63F0D086, "door_pos" },
    { 0x8E663855, "door_power_off" },
    { 0x79937029, "door_power_on" },
    { 0x143B34EC, "door_powerup" },
    { 0xEEBB2F18, "door_powerup_drop" },
    { 0x46D95D79, "door_price_reduction_for_solo" },
    { 0x83E51931, "door_pusher" },
    { 0x5C50A8AA, "door_r" },
    { 0x50CCE83C, "door_r2" },
    { 0x1E3F0567, "door_range" },
    { 0x87ED5DA9, "door_record_hint" },
    { 0x3D650FF6, "door_remove_corpses" },
    { 0x9EB26F5B, "door_repaired_rumble_n_sound" },
    { 0x43007E1C, "door_reznov_lines" },
    { 0x9C7CECCE, "door_right" },
    { 0x3C508D36, "door_roof_left" },
    { 0xA159358D, "door_roof_right" },
    { 0xAD3459D5, "door_rotate" },
    { 0x35E577FD, "door_rotation_done" },
    { 0xD0387DC0, "door_rumble_on_buy" },
    { 0x0A9648C8, "door_rumble_on_open" },
    { 0xBBEA488D, "door_sergei_guard" },
    { 0x62AEFC4F, "door_set_closed" },
    { 0x73AD69DB, "door_set_open" },
    { 0x1213D8BC, "door_should_open" },
    { 0x17B61EBA, "door_shut_rumble" },
    { 0x2E92D1F2, "door_slam_open" },
    { 0x4936FA1E, "door_slide_horizontal" },
    { 0x8E5CC522, "door_slide_open_units" },
    { 0x91D68DC8, "door_smoketown_lz" },
    { 0x5A5CDE81, "door_snd" },
    { 0xB6884A53, "door_snd_alarm" },
    { 0x0211C670, "door_solid_thread" },
    { 0x77B3E368, "door_solid_thread_anim" },
    { 0xDB1F86CB, "door_south" },
    { 0x19DB6ABC, "door_start" },
    { 0xA9F06427, "door_start_open" },
    { 0x2122BD38, "door_start_sound" },
    { 0xD9BD0C97, "door_state" },
    { 0xA0D70B4E, "door_states" },
    { 0xEE82C654, "door_stop_sound" },
    { 0x7FF1ADA5, "door_str" },
    { 0x3D380693, "door_struct" },
    { 0xB58C2757, "door_struct_debug" },
    { 0xDF33A916, "door_swing_angle" },
    { 0x6A344751, "door_switch_func" },
    { 0x4D8358E6, "door_switch_setup" },
    { 0x6D291F15, "door_target_end" },
    { 0x13FE8465, "door_technical_driver_climb_out" },
    { 0x1F9DF297, "door_technical_passenger_climb_out" },
    { 0xA14A6F40, "door_think" },
    { 0x4484DDF3, "door_time" },
    { 0x8ED3C312, "door_time_close" },
    { 0xFD1E4B6A, "door_time_min" },
    { 0x0937B006, "door_time_open" },
    { 0xC247950F, "door_to_hall" },
    { 0xDBC79A6E, "door_to_office" },
    { 0x1B3FF199, "door_to_office_open" },
    { 0x81AC7586, "door_to_open" },
    { 0x0FCE3905, "door_to_rifle_handler" },
    { 0x69911100, "door_trace_org" },
    { 0x5377A76D, "door_travel_accel" },
    { 0xDCCD1772, "door_travel_decel" },
    { 0x742BA394, "door_travel_delay" },
    { 0x1A97FCE7, "door_travel_dist" },
    { 0xF04C5410, "door_travel_time" },
    { 0xACC245B6, "door_trig" },
    { 0x85B8CF84, "door_trigger_at_target" },
    { 0xC1037F4D, "door_trigger_radius" },
    { 0x053AA6DF, "door_triggeroffsetx" },
    { 0xDF382C76, "door_triggeroffsety" },
    { 0xB935B20D, "door_triggeroffsetz" },
    { 0x7337BB4F, "door_triggers" },
    { 0xE5F8E9A9, "door_trigs" },
    { 0x24B4CDEC, "door_unlock_method" },
    { 0xA78CD9AF, "door_unlocked" },
    { 0x16FD9D90, "door_unlocked_fx" },
    { 0x078E58CB, "door_update" },
    { 0xC200B894, "door_update_lock_scripted" },
    { 0x7594491C, "door_upper" },
    { 0x328025C9, "door_upper_dmg" },
    { 0x1DC9E423, "door_use_hold" },
    { 0x05439050, "door_use_trigger" },
    { 0x2D949D0F, "door_vox" },
    { 0xF8B17120, "door_wait_until_clear" },
    { 0x2E4FD56E, "door_wait_until_user_release" },
    { 0xCBD1F2E6, "door_waiting_to_open" },
    { 0xDBDAB83D, "door_watch_open_sesame" },
    { 0xA1764F10, "door_watcher" },
    { 0xF167B54F, "door_wobble" },
    { 0xC00F7489, "door_zbarrier_move" },
    { 0xFC0F471B, "doorbash" },
    { 0x7B622AED, "doorblast" },
    { 0x5940BAD4, "doorblast_start" },
    { 0x3F28EFBD, "doorblocker" },
    { 0xB6974F3C, "doorblocker_anim_on_trigger" },
    { 0x54E4D2D4, "doorblocker_node" },
    { 0xB013A0ED, "doorblow" },
    { 0x154C103C, "doorbreach_guy_finish" },
    { 0x439478A7, "doorclose" },
    { 0xE1172956, "doorder" },
    { 0x71F73995, "doorflashchance" },
    { 0x1D0065AF, "doorkick" },
    { 0x3587D709, "doorknob" },
    { 0xEB05D582, "doorknob_shoot_to_open" },
    { 0xEACC3D43, "doorl" },
    { 0xD538B3E6, "doorl_link" },
    { 0xFFBBA90A, "doorleft" },
    { 0x4A0EC82C, "doorname" },
    { 0xD20880AF, "doornum" },
    { 0xB0EEA771, "dooropen" },
    { 0x38B347D5, "doorpastmidpoint" },
    { 0x66E5055D, "doorr" },
    { 0x5C1F98A0, "doorr_link" },
    { 0x430868D9, "doorright" },
    { 0x85585B9C, "doorrs" },
    { 0x40E28AF4, "doors" },
    { 0x20285D6B, "doors_down" },
    { 0x53BF1FEA, "doors_finished_moving" },
    { 0x22B0AEF7, "doors_outer_down" },
    { 0xD0B43E28, "doors_outer_up" },
    { 0xEA3FBB62, "doors_purchased" },
    { 0x83EC2658, "doors_shared" },
    { 0x98A9400C, "doors_trigs" },
    { 0x20C7C254, "doors_up" },
    { 0x38462404, "doorsclosed" },
    { 0xF1965936, "doorsdisabledfortime" },
    { 0x9DB58902, "doorstatefx" },
    { 0x1992EB4F, "doorstep" },
    { 0xDFDB6A6D, "doorstop" },
    { 0x21F35C60, "doorstrigger" },
    { 0x14D7A86E, "doortrigs" },
    { 0xDF3D135D, "doortrigtn" },
    { 0xF2A7734A, "doorway" },
    { 0xC48E0DDC, "doosh" },
    { 0x4B9D4416, "doown" },
    { 0xB31B67F9, "dopainfromarray" },
    { 0x6B151027, "doperkfeedback" },
    { 0x66DC4A4D, "dopickychecks" },
    { 0xAFD31613, "doplanemortar" },
    { 0xED083AE2, "doplanestrike" },
    { 0xC5E9B501, "doplaysound" },
    { 0xD48316DF, "doppleganger" },
    { 0xEBF1262C, "doprematch" },
    { 0x078A3EA7, "doprint" },
    { 0x1FBAFDD5, "doprintln" },
    { 0xD123B266, "doproperkcallback" },
    { 0xF81B3444, "doquickmessage" },
    { 0x96504F1A, "doradarsweep" },
    { 0xD29CDCAE, "dorandomoffset" },
    { 0x5EB765A0, "dorattle" },
    { 0x41522663, "doreach" },
    { 0xFD3BF087, "doreaction" },
    { 0x2D38EB0F, "doreactnotetracks" },
    { 0xF10373AE, "dorechamberanim" },
    { 0x3185818D, "doreload" },
    { 0x3D5CA412, "doreloadanim" },
    { 0xD2B813F2, "doremovalthread" },
    { 0x7C34FD98, "doremoveammo" },
    { 0x9A083D14, "doremovehealth" },
    { 0xCB47619A, "doremoveinvuln" },
    { 0xF61D7F78, "doremovekillstreak" },
    { 0x6435E7B7, "doremovelives" },
    { 0x92F258E6, "doremoveperk" },
    { 0x75534244, "doremovescore" },
    { 0x7CD85A6D, "doreveal" },
    { 0xC924CA59, "dorigin" },
    { 0x3D759626, "doriotshielddeploy" },
    { 0x7A587ED7, "dorope1" },
    { 0xA8F96A45, "dorumble" },
    { 0x43D24A0E, "dosage" },
    { 0x61482265, "dosave" },
    { 0x7C59ABF7, "dosavegame" },
    { 0x25AD9F18, "doscalemovespeed" },
    { 0x1572C0B0, "doscalereloadspeed" },
    { 0x8811EAC9, "doscoreeventcallback" },
    { 0xD89C31E7, "doscriptedanim" },
    { 0xD368CF0C, "dosemi" },
    { 0xBF26CC1A, "dosetdamagemodifier" },
    { 0xF249FFF9, "dosetheader" },
    { 0x925C003B, "dosethealthregen" },
    { 0x425216F7, "dosetsubheader" },
    { 0x461E4792, "doshellshock" },
    { 0x7D6EE01B, "doshoot" },
    { 0x87D8D416, "doshowonradar" },
    { 0x1127FE53, "dosidebets" },
    { 0x2A78B779, "dosidestep" },
    { 0x555DC784, "dosighttrace" },
    { 0x8276E8FD, "dosimeter" },
    { 0xE9B522B2, "dosimpletraverse" },
    { 0xA303327E, "doskillupdate" },
    { 0xAB6BEB66, "dosneak" },
    { 0xF96A9F03, "dosound" },
    { 0x243D0D73, "dospawn" },
    { 0x20DB7F81, "dospawn_array" },
    { 0x4497FD4E, "dospawnqueueupdates" },
    { 0xD51FD25C, "dosplevelwrapup" },
    { 0x2B3A0C7D, "dosquadinitialnotification" },
    { 0x114875B0, "dossier" },
    { 0x496B1FD7, "dostartlevelsequence" },
    { 0x6601A321, "dostartmultiplayersequence" },
    { 0x6E3A8A10, "dostat" },
    { 0xF0B69EBD, "dostraferuns" },
    { 0xCD86DA16, "dostun" },
    { 0x5BC6ED08, "dosuicidegrenade" },
    { 0x785CEA6F, "dosunrisecolors" },
    { 0x0A6C52A8, "dosupplydrop" },
    { 0x42BD74DE, "dot" },
    { 0xA00745E3, "dot_active" },
    { 0x91F6079B, "dot_ai" },
    { 0xE473038A, "dot_barricade" },
    { 0x8A20B5C7, "dot_changed" },
    { 0x11D1C1B3, "dot_check" },
    { 0x226A49DE, "dot_check_passed" },
    { 0x4ECD635A, "dot_color" },
    { 0x66ED0ABD, "dot_dist" },
    { 0xD67DDF80, "dot_facing_pos" },
    { 0xD312F7D9, "dot_from" },
    { 0xE984946E, "dot_limit" },
    { 0x4194E098, "dot_location" },
    { 0x7CB3CCC3, "dot_only" },
    { 0x6C82EEA4, "dot_position" },
    { 0xFBD9BA9A, "dot_product" },
    { 0xAE083F0C, "dot_range" },
    { 0x7668795E, "dot_threshold" },
    { 0xBBDEB29E, "dot_to" },
    { 0x37686DCA, "dot_to_fov" },
    { 0x2A9729B0, "dot_to_horse" },
    { 0xBD1B1333, "dot_to_self" },
    { 0x0935E6CC, "dot_value" },
    { 0x29D8F4BD, "dot_weapon" },
    { 0x8C0D45DF, "dot_with_forward" },
    { 0x042BDB3E, "dot_with_right" },
    { 0xC1B50183, "dotext" },
    { 0x61758D05, "dotforward" },
    { 0x92C6AA67, "dothebriefing" },
    { 0xD78A67F5, "dothedirty" },
    { 0x55F7939B, "dotlimit" },
    { 0x0F528834, "dotmax" },
    { 0x3C5EFC7A, "dotmin" },
    { 0x62E3C90E, "dotopscorers" },
    { 0x69381E4D, "dotprod" },
    { 0x5A13B92B, "dotproduct" },
    { 0x85B998A5, "dotrace" },
    { 0x32459284, "dotracethisframe" },
    { 0x2E1DD418, "dotraverse" },
    { 0x4C8328B7, "dotraverse_animation" },
    { 0xE7763E41, "dots" },
    { 0xBCC5A591, "dotted" },
    { 0x204EB3FB, "doturn" },
    { 0x5B5793D3, "doturnnotetracks" },
    { 0xFE0179E9, "dotvalue" },
    { 0x9AB368AB, "dotypelimit" },
    { 0x01874D86, "double" },
    { 0x534F5A35, "double_dist" },
    { 0xBF9368E5, "double_distsq" },
    { 0xFE9B43E6, "double_door_init" },
    { 0x74C46E9F, "double_door_obj" },
    { 0xACFC2658, "double_door_think" },
    { 0xB9E8A658, "double_doors_open_at_start" },
    { 0x34FD2ECD, "double_grenades_allowed" },
    { 0xB3D55082, "double_hind" },
    { 0x2DAB3FCF, "double_line" },
    { 0x885A5CFE, "double_mast" },
    { 0xF8727A07, "double_points_ability_check_active" },
    { 0xBD367D9E, "double_points_ability_start_time" },
    { 0xB985DF1D, "double_points_lost" },
    { 0xF5FF3F30, "double_points_pickedup" },
    { 0xE0BB1F2D, "double_points_powerup" },
    { 0x107E2E81, "double_shot_audio_death" },
    { 0x6FB8BE87, "double_shot_audio_loop" },
    { 0xF2AA992B, "double_shot_chicken_time_add" },
    { 0x55DF56FA, "double_shot_disconnect_watch" },
    { 0x248B79C5, "double_shot_disconnect_watch_helper" },
    { 0xCEC22F0D, "double_shot_exit_watcher" },
    { 0x7E3B4454, "double_shot_fire" },
    { 0x63F4EDB5, "double_shot_fire_loop" },
    { 0x45CD4D4F, "double_shot_model" },
    { 0xA3B24BEF, "double_shot_orb" },
    { 0xBF8DF2AB, "double_shot_update" },
    { 0x989C086D, "double_shot_wait_for_pickup_audio" },
    { 0x464DA465, "double_speed_sq" },
    { 0x05482046, "double_strobe" },
    { 0x61DAA9E7, "double_wide_override" },
    { 0x55D9A0FD, "double_wide_volume" },
    { 0x59342ABE, "doublebarrel" },
    { 0xA90A3B5A, "doublebarrel_sawed_grip" },
    { 0x2BB48CDC, "doubleclip" },
    { 0x465840B6, "doubled" },
    { 0xF1EB59E1, "doubleheader" },
    { 0x1E3438EE, "doublejump" },
    { 0xEF85A4C0, "doublejump_begin" },
    { 0xE0747764, "doublejump_end" },
    { 0xB6F6F9C6, "doublejump_maxupwardsvelocity" },
    { 0x42BB87CF, "doublejump_start" },
    { 0x28F1A0D3, "doublejump_v_up" },
    { 0x49D3C2E2, "doublekill" },
    { 0x2174FE30, "doubleline" },
    { 0x93AF7ACB, "doubleovertime" },
    { 0xC27108D0, "doubler" },
    { 0xCB61E2C5, "doubler_status" },
    { 0xE8738339, "doubles" },
    { 0x79C45571, "doubletap" },
    { 0x74E5E581, "doubletap2" },
    { 0x4CFF622D, "doubletap2_client_field_func" },
    { 0xCC3FEC48, "doubletap2_code_callback_func" },
    { 0x02D1B79A, "doubletap2_machine_active_model" },
    { 0x8B0BFB7C, "doubletap2_machine_disabled_model" },
    { 0x30B3410F, "doubletap2_machine_light_fx" },
    { 0x7E012766, "doubletap2_perk_bottle_weapon" },
    { 0xC9B7A6A8, "doubletap2_perk_cost" },
    { 0x0FA064AC, "doubletap2_perk_machine_setup" },
    { 0x150621EF, "doubletap2_precache" },
    { 0x54DED91B, "doubletap2_precache_override_func" },
    { 0x596E4DCB, "doubletap2_radiant_machine_name" },
    { 0x90C13E4D, "doubletap2_register_clientfield" },
    { 0x7A56AFFA, "doubletap2_set_clientfield" },
    { 0x979B0777, "doubletap2_shader" },
    { 0xE365A834, "doubletap_detonate" },
    { 0x4880BBCB, "doubletap_jingle" },
    { 0x7114E513, "doubletap_off" },
    { 0xBD00857F, "doubletap_on" },
    { 0x8547E899, "doubletap_sumpf_on" },
    { 0x5C847A9C, "doublexp_timer" },
    { 0x2D504749, "doublexpstring" },
    { 0xF993E19B, "doublexptimerfired" },
    { 0x1F0BDA3F, "doubling" },
    { 0x3969909A, "doubly" },
    { 0xC6679461, "doubt" },
    { 0xE6569C5F, "dounload" },
    { 0xD81513A7, "dour" },
    { 0x3E1AD689, "dove" },
    { 0xF0E4F38D, "dowait" },
    { 0x21ADD005, "dowakeup" },
    { 0xCB4CDF8E, "dowalkanim" },
    { 0xF69B1DB0, "doweaponspecificcorpseeffects" },
    { 0xE72E33A8, "doweaponspecifickilleffects" },
    { 0x3B0DEDE1, "down" },
    { 0xD29700F5, "down_angle" },
    { 0xE76FAE1C, "down_arc" },
    { 0x9D8ABBA8, "down_bright" },
    { 0x66946B4C, "down_exposed" },
    { 0x1DB9F2CD, "down_hill" },
    { 0x86A2A0C2, "down_origin" },
    { 0x54AE55C0, "down_part2_proc_ran" },
    { 0x4C2AC8B6, "down_pressed" },
    { 0xA1913D3E, "down_relay_station" },
    { 0x3D05D223, "down_ropes" },
    { 0xDD747D02, "down_score" },
    { 0x2C4251F7, "down_time" },
    { 0x503F5686, "down_to_door" },
    { 0xFF956AB1, "downaimlimit" },
    { 0x99A8B256, "downanim" },
    { 0xF517008F, "downarc" },
    { 0x0E7C50CE, "downed" },
    { 0x40311D5A, "downed_player" },
    { 0xC208AAA0, "downedplayers" },
    { 0x12295C46, "downfall" },
    { 0x22CB4C34, "downgear" },
    { 0x4C6FBB02, "downgrade" },
    { 0x7E28C7A2, "downgraded" },
    { 0x4D802A68, "downhill" },
    { 0x5827016B, "downhill_narration" },
    { 0x31DB6D63, "downindex" },
    { 0x61D020ED, "downlink" },
    { 0xCD48314C, "download_event" },
    { 0x1C1514CA, "download_event_sniper_count" },
    { 0x19E74E8A, "download_event_vo" },
    { 0x18253CC1, "downlooklimit" },
    { 0x5AD8FB50, "downrange" },
    { 0xC60DB088, "downs" },
    { 0xA4740D0B, "downshift" },
    { 0x9BA4EBFF, "downshiftpoint" },
    { 0x5F81B78C, "downstair_ground_ambient_ai" },
    { 0x748C4880, "downstair_runners" },
    { 0x0DD6E2B5, "downstair_runners_ai" },
    { 0xF456327B, "downstairs" },
    { 0x51DB751D, "downstairs_blocked_path_fx" },
    { 0xA35937FD, "downstairs_burn_trigs" },
    { 0x23A904F6, "downstairs_dialog" },
    { 0x240BA192, "downstairs_fire" },
    { 0x1234FC50, "downstairs_furnace_setup" },
    { 0x95C80FAE, "downstairs_runanim" },
    { 0x4C4A82DB, "downstiars" },
    { 0xDBB54B36, "downtime" },
    { 0x09795D85, "downtown" },
    { 0x6621AEAB, "downward" },
    { 0x391DFF8A, "downwards" },
    { 0xF4438D99, "dozen" },
    { 0xC6C121C9, "dp" },
    { 0x118101CE, "dp_connect" },
    { 0xEFB65942, "dpad" },
    { 0x61D18625, "dpad_down" },
    { 0xA817770A, "dpad_down_pressed" },
    { 0x77C6E696, "dpad_left" },
    { 0x81B15D4D, "dpad_left_pressed" },
    { 0xE90D1B0D, "dpad_modifier_button" },
    { 0x00C44735, "dpad_modifier_button2" },
    { 0xA5B1094B, "dpad_reminder" },
    { 0xA5FF2EA0, "dpad_reminder_loop" },
    { 0x1E83B66D, "dpad_right" },
    { 0x3C844102, "dpad_right_pressed" },
    { 0xEBFDEB3A, "dpad_up" },
    { 0x03922FE1, "dpad_up_pressed" },
    { 0x2DE99C2A, "dparam" },
    { 0x9159F6F4, "dpg" },
    { 0x506612B6, "dpower" },
    { 0x992866C0, "dps" },
    { 0x12C6169B, "dr" },
    { 0x92BCC1EC, "dr_ai_classname" },
    { 0x526FD960, "dr_animation" },
    { 0x7CAC3EB2, "dr_cull_always" },
    { 0xE99B5389, "dr_cull_never" },
    { 0x6EE4768E, "dr_death_timer" },
    { 0x6FCAFC7F, "dr_delay" },
    { 0xA3C0568A, "dr_event" },
    { 0x737081F2, "dr_fake_death" },
    { 0x900D035F, "dr_group" },
    { 0x81589BEF, "dr_method_custom_material" },
    { 0xCEAE2831, "dr_method_default_material" },
    { 0xB85D5CAC, "dr_method_enemy_material" },
    { 0x24D8D20F, "dr_method_off" },
    { 0x4CF82ACB, "dr_method_thermal_material" },
    { 0xE83C4B52, "dr_need_player" },
    { 0x96CB2419, "dr_percent" },
    { 0xB2A2C7E7, "dr_player_trace" },
    { 0x7B67E510, "dr_populate" },
    { 0xCA397ACE, "dr_respawn" },
    { 0x26F0CF72, "dr_type_framebuffer" },
    { 0xA5C5DE44, "dr_type_framebuffer_duplicate" },
    { 0x05EA7E00, "dr_type_offscreen" },
    { 0x3ACBECC5, "dr_wait" },
    { 0xB9399E81, "dr_wave_count" },
    { 0x70342E87, "dr_wave_size" },
    { 0x93D97015, "draftenabled" },
    { 0xF7DEACE7, "drag" },
    { 0xC88A349E, "drag_aftermath" },
    { 0xB4DB0155, "drag_anim_complete" },
    { 0x2A281C3F, "drag_avogadro" },
    { 0x342AF2FB, "drag_bubbles" },
    { 0x0CA9B4F7, "drag_chinook" },
    { 0xDFEB51CE, "drag_chinook_think" },
    { 0x0151E3C2, "drag_cleanup" },
    { 0x241D8EC6, "drag_crash_pbr_1" },
    { 0xFE1B145D, "drag_crash_pbr_2" },
    { 0xD81899F4, "drag_crash_pbr_3" },
    { 0x358BB7B9, "drag_end" },
    { 0xF2256554, "drag_end_stop" },
    { 0x330056F0, "drag_ends" },
    { 0x52377988, "drag_fade_to_black" },
    { 0x7E3C8768, "drag_huey_1_think" },
    { 0x28911983, "drag_huey_2_think" },
    { 0xBF869010, "drag_idle" },
    { 0x7021A085, "drag_idle_ai" },
    { 0x98811A54, "drag_loop" },
    { 0xE81DCA49, "drag_loop_ai" },
    { 0xAF6329A7, "drag_melee_trigger" },
    { 0xF8BD7AE3, "drag_player_towards_spot" },
    { 0x44A8355F, "drag_range_squared" },
    { 0xDBA2329E, "drag_rope_1" },
    { 0x0C4717F4, "drag_rope_1_end" },
    { 0xD1DB078E, "drag_rope_2_3_4" },
    { 0x186744D5, "drag_shots" },
    { 0x8751C69B, "drag_speed" },
    { 0x6E6F4C76, "drag_start_time" },
    { 0x7DBE8C5D, "drag_starts" },
    { 0xE026BCA1, "drag_state" },
    { 0x2FB70CD5, "drag_target" },
    { 0x20E30E48, "drag_trig_with_org" },
    { 0xED84461B, "drag_trig_with_wheel" },
    { 0x701600EA, "drag_trigger" },
    { 0x3FCBD5B9, "drag_use_rope_tech" },
    { 0xD09882F7, "drag_vector" },
    { 0x437CC6ED, "draganov" },
    { 0x636E40DD, "dragged" },
    { 0xB741A57B, "dragger" },
    { 0xC7D95216, "dragger_spawner" },
    { 0x2B0FF7A6, "dragging" },
    { 0xB81FA002, "drago" },
    { 0xC8913F4A, "drago_bubbles" },
    { 0x748082B3, "drago_head_splash" },
    { 0xBA4CE33E, "drago_landing" },
    { 0xD82D3B1F, "drago_spit" },
    { 0xE81D2518, "dragon" },
    { 0xCCE3E8B4, "dragon_allowfriendlyfiredamage" },
    { 0x110BFC7E, "dragon_callback_damage" },
    { 0xCC65427E, "dragon_deaths" },
    { 0x0E5D98E1, "dragon_enemies" },
    { 0x4DE5F3D3, "dragon_follow_dist" },
    { 0xABA418AC, "dragon_fov_angle" },
    { 0x20BD34E1, "dragon_initialize" },
    { 0xEF6B94D4, "dragon_melee_dist" },
    { 0xB852D50F, "dragon_move_dist_height" },
    { 0x3966756F, "dragon_recall_death" },
    { 0xCD3112CF, "dragon_target_selection" },
    { 0xA924686C, "dragonenemy" },
    { 0x1BC036D4, "dragonfire" },
    { 0x90FE61F3, "dragons" },
    { 0x3A1332E4, "dragons_breath" },
    { 0x1D18889C, "dragons_breath_flame_death_fx" },
    { 0xC240C5F8, "dragons_breath_selected" },
    { 0x554F550C, "dragons_breath_shotgun_behavior" },
    { 0x4E9FCD49, "dragons_breath_shotgun_spawners" },
    { 0x14820A42, "dragonsbreath_bolts_msg" },
    { 0x1B6BDD50, "dragovich" },
    { 0xFE4BA319, "dragovich_death_pose" },
    { 0x8FF59DC2, "dragovich_door_node" },
    { 0x21A68F03, "dragovich_fight" },
    { 0x10A46F76, "dragovich_fight_pull_down" },
    { 0xAD97B36D, "dragovich_fired" },
    { 0x182C4C43, "dragovich_group_exit_count" },
    { 0x80FC9FD7, "dragovich_group_min_exited" },
    { 0x464A8223, "dragovich_leaves" },
    { 0x09340CED, "dragovich_leaves_earthquake" },
    { 0xF9040F50, "dragovich_leaves_exit_room" },
    { 0x96F7FEF0, "dragovich_leaves_grenade" },
    { 0x7B019A9D, "dragovich_leaves_redshirt_vo" },
    { 0xD93C0219, "dragovich_leaves_sequence" },
    { 0x20F88228, "dragovich_spawnfunction" },
    { 0x22E02AE0, "dragovich_steiner_outside_talk" },
    { 0x2015B65E, "drags" },
    { 0xCF473411, "dragset" },
    { 0xB5F1EA54, "dragsound" },
    { 0x5390672F, "dragtaguntildeath" },
    { 0x65B5DC85, "drain" },
    { 0x9BBC9C07, "drain_player" },
    { 0xD94290B3, "drain_tanks" },
    { 0xA41248AB, "drain_update" },
    { 0xDD615972, "drained" },
    { 0xC0729BAE, "drama" },
    { 0x56A7136A, "dramatic" },
    { 0x022658C4, "dramatically" },
    { 0xAECE8801, "drank" },
    { 0x4DF4FA98, "drap" },
    { 0xF4E0A979, "drastic" },
    { 0x58065377, "draw" },
    { 0xA34D02F5, "draw_3d_sphere" },
    { 0x1388D023, "draw_3d_text" },
    { 0x4A4E496D, "draw_all_shots" },
    { 0xEE6688DC, "draw_all_targets" },
    { 0xF8F3548E, "draw_all_tracks" },
    { 0x31774563, "draw_all_tracks_and_targets" },
    { 0xF5316BCA, "draw_animation_reference" },
    { 0x6CB53FAB, "draw_animsounds_in_hud" },
    { 0xA4FF6201, "draw_arrow" },
    { 0xF6109257, "draw_arrow_time" },
    { 0xA2790511, "draw_axis" },
    { 0xFC499EEB, "draw_axis_model" },
    { 0xD8BFFFCA, "draw_axis_models" },
    { 0xB77DA444, "draw_axis_think" },
    { 0x6552FC3E, "draw_bomb" },
    { 0x94C65F8E, "draw_bomb_axis" },
    { 0x3C27FCD9, "draw_box" },
    { 0xE0A685F8, "draw_checkpoint" },
    { 0xF8AAFE83, "draw_color_friendlies" },
    { 0x62460786, "draw_colored_nodes" },
    { 0x59EF90C2, "draw_colornodes" },
    { 0x69AE1DA7, "draw_cone" },
    { 0xC2241D80, "draw_cylinder" },
    { 0xD4E0FF95, "draw_debug_box" },
    { 0x3D73EF9E, "draw_debug_cross" },
    { 0xB055A316, "draw_debug_info" },
    { 0xCA094938, "draw_debug_line" },
    { 0x08CADE7D, "draw_debug_line_stupid_animation" },
    { 0x71536EFA, "draw_debug_line_to_target_distance" },
    { 0xD5DF7193, "draw_debug_lines" },
    { 0xD49F8C0B, "draw_debug_lines_to_target" },
    { 0x00B01DDB, "draw_debug_location" },
    { 0x2D73D580, "draw_debug_marker" },
    { 0xB2186976, "draw_debug_star" },
    { 0x24DCDF07, "draw_distance" },
    { 0xAB760B43, "draw_effects_list" },
    { 0xAA136890, "draw_ent_locations" },
    { 0x3C3E5FBB, "draw_explosion" },
    { 0x8CFA2C49, "draw_fancy_hudline" },
    { 0x6F741391, "draw_forward_line_until_notify" },
    { 0xC2A604B0, "draw_goal_radius" },
    { 0x19627067, "draw_goalpos" },
    { 0x0563EA53, "draw_guy" },
    { 0xB76CB1E4, "draw_hud_on_death" },
    { 0x8B1FFEB2, "draw_info" },
    { 0x4FB25394, "draw_line" },
    { 0x45B78700, "draw_line_ent_to_ent" },
    { 0x18E5A989, "draw_line_ent_to_pos" },
    { 0x754E1810, "draw_line_for_time" },
    { 0x6B409F43, "draw_line_from_ent_for_time" },
    { 0x2DD84193, "draw_line_from_ent_to_ent_for_time" },
    { 0xAFE3ECBC, "draw_line_from_ent_to_ent_until_notify" },
    { 0xFFCCA550, "draw_line_from_ent_to_vec" },
    { 0x9FBCC79F, "draw_line_list" },
    { 0xBB126252, "draw_line_pos_to_pos" },
    { 0x257F9219, "draw_line_segments" },
    { 0x2C52DCCA, "draw_line_to_ent_for_time" },
    { 0xF9FE750F, "draw_line_to_gun" },
    { 0xD5AB81F0, "draw_line_to_player" },
    { 0x2DC91ABF, "draw_line_until_notify" },
    { 0xAE1C3F87, "draw_marked_locations" },
    { 0xD2F42A47, "draw_missile_target_line" },
    { 0x90CB07DF, "draw_model_axis" },
    { 0x878F4D13, "draw_notetrack" },
    { 0x331C8147, "draw_path" },
    { 0x71FC369F, "draw_pathnode" },
    { 0x6C832592, "draw_pathnode_stop" },
    { 0x11A3F646, "draw_pathnode_think" },
    { 0x7A3AF9AD, "draw_pathnodes_stop" },
    { 0xEC30BD53, "draw_pill" },
    { 0x1E87E956, "draw_placement_circle" },
    { 0x14B38084, "draw_player_health_packets" },
    { 0x0AA59F85, "draw_player_viewtag" },
    { 0x348D62F8, "draw_point" },
    { 0x78BDDA93, "draw_point_thread" },
    { 0x41F59618, "draw_runner_up_bounds" },
    { 0x56E8BAA2, "draw_scene_lines" },
    { 0x9A550570, "draw_scene_node_info" },
    { 0x703D6219, "draw_selectables" },
    { 0xA92EE4EA, "draw_shot" },
    { 0x4E039592, "draw_shot_target" },
    { 0x6136ED26, "draw_shot_track" },
    { 0x088A141D, "draw_smoke" },
    { 0x6B2995E9, "draw_sphere" },
    { 0x772FE4A4, "draw_sphere_at_origin" },
    { 0xA909B62F, "draw_sphere_axis" },
    { 0x30762EF0, "draw_structs" },
    { 0x76BDD7D2, "draw_tag" },
    { 0x507FD1A1, "draw_tag_angles" },
    { 0x4C977CFE, "draw_tag_for_time" },
    { 0x29C80C92, "draw_tag_forever" },
    { 0x5ADF76A0, "draw_tag_name" },
    { 0xB94F38DD, "draw_tags" },
    { 0x555487F3, "draw_tank_tag" },
    { 0x3DDCB245, "draw_target" },
    { 0xC62B98CD, "draw_target_color" },
    { 0xBB22BA86, "draw_team_targetname" },
    { 0x7A75169F, "draw_text" },
    { 0x2957EB42, "draw_text_heli" },
    { 0xC56FD55F, "draw_track" },
    { 0xDA23955C, "draw_track_pos" },
    { 0x4467AD14, "draw_track_results" },
    { 0x0FBB5B39, "draw_trajectory" },
    { 0xB6A941FD, "draw_weapons" },
    { 0xC77F0242, "draw_zone_spawned_from" },
    { 0x96135D9A, "drawairstrikeattackarrow" },
    { 0x4F2AE073, "drawanimtime" },
    { 0x2A01746B, "drawapproachvec" },
    { 0x351B2D2A, "drawarrow" },
    { 0x1990F86F, "drawarrowforever" },
    { 0x428A21E4, "drawatag" },
    { 0x3AAEF36C, "drawbcdirections" },
    { 0x04E9F583, "drawbcobject" },
    { 0x3177E390, "drawbounds" },
    { 0xC679ED47, "drawchopperattackarrow" },
    { 0x97E53B60, "drawcolor" },
    { 0x48916384, "drawcurve" },
    { 0x77810775, "drawcylinder" },
    { 0xCDCB4E10, "drawcylinder_think" },
    { 0xE11082F0, "drawdebug" },
    { 0xD02396C8, "drawdebugcross" },
    { 0xFC140677, "drawdebugcrossold" },
    { 0xAA3639D9, "drawdebugcrossspecial" },
    { 0x56DA803A, "drawdebugenttext" },
    { 0x31372144, "drawdebugenttoentinternal" },
    { 0x2FA6A884, "drawdebuginfo" },
    { 0x2E6E6BFC, "drawdebuginfothread" },
    { 0x4B340FBE, "drawdebugline" },
    { 0xB975103D, "drawdebuglineenttoent" },
    { 0xACCDF135, "drawdebuglineinternal" },
    { 0xDB76710E, "drawempdamageorigin" },
    { 0x35AFC60E, "drawenttag" },
    { 0x777B48DA, "drawer" },
    { 0xF558280D, "draweventpointanddir" },
    { 0x9C3326FC, "drawfollowers" },
    { 0xB525432F, "drawfriend" },
    { 0xBE8A9804, "drawgridbounds" },
    { 0x8519BCC3, "drawgridnode" },
    { 0x8037AA46, "drawhit" },
    { 0x3AE6C3A9, "drawing" },
    { 0xFA803EDC, "drawing_spawn_data" },
    { 0x5087E874, "drawleader" },
    { 0xBF00ADAD, "drawline" },
    { 0xEA4390D6, "drawline_from_ent" },
    { 0x57159628, "drawline_from_player" },
    { 0x93F59C69, "drawlineon_org" },
    { 0xA30F8C23, "drawlink" },
    { 0xB59C4C0C, "drawlinkforever" },
    { 0xE8703428, "drawlinkfull" },
    { 0xB6AB668E, "drawlookaheaddir" },
    { 0xB6D31B67, "drawminimapbounds" },
    { 0xCDCA839B, "drawn" },
    { 0xD135411F, "drawn_axis_model" },
    { 0x049D8580, "drawn_targets" },
    { 0xC15814C2, "drawn_tracks" },
    { 0x3273D960, "drawncount" },
    { 0x46A7A4CF, "drawnode" },
    { 0x4C38993B, "drawnoteworthytext" },
    { 0x23E07D86, "drawoffhandmodelinhand" },
    { 0xCF899826, "drawoffset" },
    { 0xF5069EC8, "drawoncompass" },
    { 0x514736B3, "draworg" },
    { 0x91F86A0B, "draworg2" },
    { 0x772B561C, "draworgforever" },
    { 0x499456D5, "draworigin" },
    { 0x252CEE46, "draworiginforever" },
    { 0xA1B4A9E6, "draworiginlines" },
    { 0x06D6B630, "draworigintext" },
    { 0x2302CD4A, "drawpath" },
    { 0xEE6E587D, "drawpathoffshoots" },
    { 0x2F793F75, "drawpathsegment" },
    { 0xE47FACD3, "drawplayerkills" },
    { 0x70FAB24C, "drawplayerpaths" },
    { 0x80969B2D, "drawplayerusage" },
    { 0x3A767F94, "drawplayerviewforever" },
    { 0x4B7E6B83, "drawpos" },
    { 0x5976C677, "drawrangedebug" },
    { 0xD00D6CAE, "draws" },
    { 0xE350F598, "drawspawndata" },
    { 0x29C49EEC, "drawspawngraph" },
    { 0xD02A2E25, "drawspeedacceltext" },
    { 0x0A848CC0, "drawstring" },
    { 0x81E926FB, "drawstringtime" },
    { 0x03670931, "drawtag" },
    { 0x23C143A2, "drawtagforever" },
    { 0x9C8F13FC, "drawtargetnametext" },
    { 0x6A9ADB24, "drawtime" },
    { 0xE1A447EE, "drawtimer" },
    { 0xAA93D992, "drawtrace" },
    { 0x64847110, "drawtrajectory" },
    { 0xFE7BEA74, "drawtransanglesonnode" },
    { 0x132D92F1, "drawusers" },
    { 0xC4A39C07, "drawvec" },
    { 0xA2793330, "drcull1" },
    { 0x1480A26B, "drcull2" },
    { 0xEE7E2802, "drcull3" },
    { 0xC14702B2, "dream" },
    { 0x6E9F1D3D, "dreams" },
    { 0x31E41E7A, "dressing" },
    { 0x11E4893B, "dressing_zone" },
    { 0x6200CBBB, "drew" },
    { 0x60E53078, "drfilters" },
    { 0x12C18EF3, "drg_active" },
    { 0xF582D445, "drg_puzzle_reset" },
    { 0xB8727163, "drg_puzzle_trig_think" },
    { 0xE02C3C87, "drg_puzzle_trig_watch_fade" },
    { 0x38727599, "drh" },
    { 0x4BD099A6, "drift" },
    { 0x79616D96, "drift_speed" },
    { 0x0D9264BE, "drift_target" },
    { 0x525E4129, "drifted" },
    { 0xDA99C93A, "drifting" },
    { 0x7A74F3D9, "drifts" },
    { 0xE5AFC118, "drill" },
    { 0xF4BE5619, "drink" },
    { 0xC95FAB41, "drink_booze_anim" },
    { 0xAAF6EA6B, "drinkers" },
    { 0x2C69EBAF, "drinking" },
    { 0x503A4BC8, "dripping" },
    { 0xB00A5D12, "drivable" },
    { 0x78D36BFD, "drivablerapsinair" },
    { 0x247D6D4F, "drive" },
    { 0x12722F10, "drive_and_stop" },
    { 0x719C5E48, "drive_arrivewalla" },
    { 0xC192F191, "drive_backward" },
    { 0x83A58DD1, "drive_basehelicopters" },
    { 0xF849047F, "drive_blend_anims_with_steering" },
    { 0xDA4FACBA, "drive_boat_obj" },
    { 0x28CF34D1, "drive_by_truck" },
    { 0xF4031292, "drive_carjack1" },
    { 0x25D2863C, "drive_carsounds" },
    { 0x1EAD07BC, "drive_casualguards1" },
    { 0x90B476F7, "drive_casualguards2" },
    { 0x6AB1FC8E, "drive_casualguards3" },
    { 0xAFA2AB34, "drive_celebrators2" },
    { 0xDF2B6B41, "drive_client_connected_notifies" },
    { 0x60986813, "drive_dogchase1" },
    { 0x58D728B2, "drive_done" },
    { 0xFBACA2E5, "drive_doorkick1" },
    { 0x21AF1D4E, "drive_doorkick2" },
    { 0x111AD661, "drive_dumpsterhide1" },
    { 0x89C0EA2F, "drive_eatingdog1" },
    { 0x51A84D08, "drive_endcrowd" },
    { 0x818BFA89, "drive_fastrope1" },
    { 0x68188663, "drive_firingsquad" },
    { 0xFBEC28A8, "drive_firstperson_anims" },
    { 0x61599C8B, "drive_fov" },
    { 0x12A0B970, "drive_fx" },
    { 0x2BE1451D, "drive_garage2" },
    { 0x8A4E932F, "drive_getin" },
    { 0xBDC0320B, "drive_gunpoint1" },
    { 0x3C419858, "drive_idle" },
    { 0xB5786F2C, "drive_interrogation1" },
    { 0x87ED303E, "drive_magic_bullet" },
    { 0x1573AC2D, "drive_motorcycle" },
    { 0x047BBD9E, "drive_node" },
    { 0x1756450C, "drive_phonering" },
    { 0xFED020B3, "drive_reaction" },
    { 0x95765200, "drive_runners1" },
    { 0x077DC13B, "drive_runners2" },
    { 0xD232CF92, "drive_save_game" },
    { 0x1CF74C18, "drive_shake" },
    { 0x49BCBF8A, "drive_shooting_anims" },
    { 0x50B1CA8C, "drive_shooting_done" },
    { 0xB15C4024, "drive_shooting_update_anims" },
    { 0xADB9337A, "drive_slomo" },
    { 0xF222BFCE, "drive_sneakattack" },
    { 0x607319E6, "drive_spawn_thread" },
    { 0x6D0B6014, "drive_spiderbot" },
    { 0xF10A019C, "drive_spraypaint1" },
    { 0x5B06D4AF, "drive_stand_idle" },
    { 0x3767872B, "drive_street_blockers" },
    { 0x7F42CB9F, "drive_switch_to_first_person" },
    { 0xEE7732AB, "drive_talkingguards1" },
    { 0xA0A44224, "drive_target_enemy" },
    { 0xA95489FE, "drive_thread" },
    { 0xAE98FA85, "drive_throttle_anims" },
    { 0x36C35235, "drive_time" },
    { 0x246B94C9, "drive_to_target_struct_delay" },
    { 0x7D19C0F9, "drive_to_target_struct_on_notify" },
    { 0x448FC856, "drive_trashstumble" },
    { 0xCDA80D92, "drive_turning_anims" },
    { 0xB9A748EB, "drive_under_fire" },
    { 0xCCE2028F, "drive_vo" },
    { 0x368F60AA, "drive_windowshout1" },
    { 0xD03A74A8, "drive_ziptie1" },
    { 0x4241E3E3, "drive_ziptie2" },
    { 0x1C3F697A, "drive_ziptie3" },
    { 0x8E46D8B5, "drive_ziptie4" },
    { 0x68445E4C, "drive_ziptie5" },
    { 0xDBB494FF, "driveable" },
    { 0x1B99EA92, "drivebysoundtime0" },
    { 0x419C64FB, "drivebysoundtime1" },
    { 0xD0DF8686, "drivemode" },
    { 0x72EFF24A, "drivemodeaccel" },
    { 0x5EE7FF51, "drivemodedecel" },
    { 0xC6EDE233, "drivemodespeedscale" },
    { 0xE432A4B3, "driven" },
    { 0x11D23BEE, "drivendistancethisdrive" },
    { 0xC1535232, "drivepath" },
    { 0xEC01147F, "driver" },
    { 0xF090922F, "driver2" },
    { 0x04152C3E, "driver_ang" },
    { 0x24CE6704, "driver_anims" },
    { 0x6E215344, "driver_dead" },
    { 0xA07E2854, "driver_death" },
    { 0x61423EB7, "driver_death_monitor" },
    { 0x16B2FA56, "driver_far_rear" },
    { 0x93355AAC, "driver_gaz_melee_fail" },
    { 0xD2F7A080, "driver_idle_speed" },
    { 0xA84CDD03, "driver_in" },
    { 0x03934C47, "driver_local_client" },
    { 0x9BA68F7B, "driver_offset" },
    { 0x6F2E44BC, "driver_only_update" },
    { 0x4F85DEBC, "driver_pos" },
    { 0x7FC8F579, "driver_seat" },
    { 0xE1C82FFD, "driver_seat_angle" },
    { 0x489584B1, "driver_setup" },
    { 0x1A711632, "driver_shot" },
    { 0xB82CA37C, "driver_side_rear" },
    { 0x378EB1DA, "driver_spawner" },
    { 0x73EC1F69, "driver_turnleft1" },
    { 0x99EE99D2, "driver_turnleft2" },
    { 0xBFF1143B, "driver_turnleft3" },
    { 0x463141B4, "driver_turnright1" },
    { 0xE21FE4D0, "driver_turnspecial" },
    { 0xC8242DD8, "driver_turret" },
    { 0x0260A4B5, "driver_wave" },
    { 0xD81BB350, "driveranim" },
    { 0xC8BE13C5, "driverdead" },
    { 0xF94AC5C5, "driverlocalclient" },
    { 0x49EF7D86, "drivers" },
    { 0xC5FE9A16, "drives" },
    { 0xC248EEBC, "driveway" },
    { 0xADF5F2CA, "driving" },
    { 0x1C5CF881, "driving_anims" },
    { 0x65F548D5, "driving_enter" },
    { 0xB3CD289F, "driving_fx" },
    { 0x53DB56B1, "driving_fx_collision_override" },
    { 0xF831238D, "driving_fx_jump_landing_override" },
    { 0xE1B96966, "driving_rumble" },
    { 0xE419203C, "driving_state" },
    { 0x47717CF6, "drivingvehicle" },
    { 0xDFE08B44, "drkck" },
    { 0xD07C5F3D, "drl" },
    { 0xEEAC62C4, "droche" },
    { 0xA6F90FB2, "droens" },
    { 0xBF791649, "drone" },
    { 0x6E24A6D2, "drone1" },
    { 0x48222C69, "drone2" },
    { 0x87B247BD, "drone_1" },
    { 0xADB4C226, "drone_2" },
    { 0xD3B73C8F, "drone_3" },
    { 0xC9A5E3B0, "drone_4" },
    { 0xEFA85E19, "drone_5" },
    { 0x15AAD882, "drone_6" },
    { 0x3BAD52EB, "drone_7" },
    { 0xDC0B8D7A, "drone_abort" },
    { 0xC944C8F2, "drone_action" },
    { 0xD2F811B6, "drone_active_time" },
    { 0x20AA0218, "drone_add_cheap_spotlight" },
    { 0x62B2644C, "drone_add_spawner" },
    { 0x172E7D62, "drone_ai_gotopoint_delay" },
    { 0x20CF3396, "drone_ai_shoot" },
    { 0x9FE07C18, "drone_ai_takeover_off" },
    { 0xBA6D8652, "drone_ai_takeover_on" },
    { 0x8EA2E8EF, "drone_ai_takeover_trigger" },
    { 0x0F20BFA7, "drone_aim_at_target" },
    { 0x84A3BC4B, "drone_allies_assignweapon_american" },
    { 0xB898DB1A, "drone_allies_assignweapon_british" },
    { 0xBDE81180, "drone_allies_assignweapon_russian" },
    { 0x8E4E433D, "drone_allowfriendlyfiredamage" },
    { 0xE9D7A92B, "drone_anim" },
    { 0x5D1026C0, "drone_anim_loop" },
    { 0x6F2C04FE, "drone_anim_weight" },
    { 0x2609FA16, "drone_animarray" },
    { 0x298FB00E, "drone_animate_fx" },
    { 0x1CF29256, "drone_animation" },
    { 0x1097570A, "drone_anims" },
    { 0x709CB408, "drone_approach" },
    { 0x15B3E000, "drone_aprpoach_interval" },
    { 0x27DE861B, "drone_array" },
    { 0x2432A61A, "drone_assign_weapon" },
    { 0xC97BC269, "drone_at_last_node" },
    { 0xF7344508, "drone_attack_player" },
    { 0x4823C2A0, "drone_attack_silo" },
    { 0xA821E1E6, "drone_attack_water_tower" },
    { 0xA9E5A371, "drone_attacks_player" },
    { 0x3577AB25, "drone_available" },
    { 0xDACDB8D9, "drone_available_ragdoll" },
    { 0xDF8C5E13, "drone_avoid" },
    { 0x101518B6, "drone_axis_assignweapon_german" },
    { 0x0C713015, "drone_axis_assignweapon_japanese" },
    { 0x9464F740, "drone_badplace_auto" },
    { 0x07BAEB4D, "drone_bank_search" },
    { 0x880C2002, "drone_bank_search_logic" },
    { 0xD0232431, "drone_bank_searchlight_on" },
    { 0x4F670D08, "drone_barrage" },
    { 0xBA7B03A5, "drone_beyond_swap" },
    { 0x72413AF6, "drone_breadcrumbs" },
    { 0xB49C4150, "drone_button_watch" },
    { 0x160652F3, "drone_callback_damage" },
    { 0x1E8C6E66, "drone_cam_pip_sounds" },
    { 0xFA17B337, "drone_character_axis" },
    { 0x7F2D1184, "drone_choice_helper_message" },
    { 0x6CC57300, "drone_chopper_damage_scale" },
    { 0xBC2B9FE4, "drone_class" },
    { 0xB7F93A31, "drone_claw_wflamethrower" },
    { 0xD9EAF018, "drone_cleanup" },
    { 0x360E87D4, "drone_collision" },
    { 0x67A1C3C2, "drone_control_alley_go" },
    { 0xBD642E2A, "drone_control_alley_qrotor_start" },
    { 0xD7B6496E, "drone_control_alley_start_control" },
    { 0xC3987C7F, "drone_control_allied_quadrotor_spawnfunc" },
    { 0x84C7793F, "drone_control_ambient_fx" },
    { 0xB7FC5D5E, "drone_control_cleanup" },
    { 0x9308DBFB, "drone_control_do_ambient_crossover" },
    { 0x3E484DBD, "drone_control_do_ambient_quadrotors" },
    { 0x60689117, "drone_control_do_ambient_vtols" },
    { 0x1DA1C653, "drone_control_drones_offline" },
    { 0xF2B5B437, "drone_control_farmhouse_cleanup" },
    { 0x74226BC3, "drone_control_farmhouse_go" },
    { 0xE7644241, "drone_control_farmhouse_reached" },
    { 0x1CA571E0, "drone_control_farmhouse_started" },
    { 0x9D8BB659, "drone_control_fire_magic_rpgs_at_target" },
    { 0x56603007, "drone_control_gauntlet_ambience" },
    { 0xCB2EE321, "drone_control_gauntlet_go" },
    { 0x0150D167, "drone_control_gauntlet_magic_rpgs" },
    { 0xDEE2F340, "drone_control_go" },
    { 0x6FFEB360, "drone_control_lost" },
    { 0x7A26A297, "drone_control_lower_spawnfunc" },
    { 0x528723CC, "drone_control_morals_rail_vtol_go" },
    { 0x41C108DB, "drone_control_player_damage_callback" },
    { 0x07A2DFCC, "drone_control_quadrotor_sounds" },
    { 0xA81E6B43, "drone_control_quadrotors_move_to_player_look_position_test" },
    { 0x809459D3, "drone_control_room" },
    { 0x4CE62EC9, "drone_control_salazar_takes_left" },
    { 0x5B4EFDF4, "drone_control_salazar_takes_right" },
    { 0xE0A9878D, "drone_control_setup" },
    { 0x53495634, "drone_control_setup_threat_bias" },
    { 0x27583CB2, "drone_control_skipto_setup" },
    { 0x6AC9AF8C, "drone_control_splitpath_cliffside_ambient" },
    { 0xC9125198, "drone_control_splitpath_go" },
    { 0xA4B14401, "drone_control_started" },
    { 0xE9F964BA, "drone_control_terrorist_spawnfunc" },
    { 0xC60BCF95, "drone_control_threat_control_think" },
    { 0xEB92F976, "drone_control_turret_death_cleanup" },
    { 0x0387256E, "drone_control_turret_fire_think" },
    { 0xD4A956F7, "drone_control_turret_kill" },
    { 0x607D4575, "drone_control_turret_think" },
    { 0x306B9238, "drone_corpse" },
    { 0xDE462E81, "drone_count" },
    { 0xF66523BD, "drone_cover" },
    { 0x04C17FB9, "drone_cover_and_run" },
    { 0x3115ADFC, "drone_cover_fire" },
    { 0x2700BD30, "drone_cover_hide" },
    { 0x0FD0378B, "drone_cover_show" },
    { 0x934FBDA8, "drone_cover_think" },
    { 0x830D5D94, "drone_cover_toggle" },
    { 0xBDCFDA6B, "drone_crane" },
    { 0x444C90FD, "drone_crash" },
    { 0xEB02CD95, "drone_crash_into_car" },
    { 0xC3E84DB7, "drone_crash_when_sewer_entered" },
    { 0x64A83FE9, "drone_create_badplace_ontrig" },
    { 0x45361A9B, "drone_custom_run_cycles" },
    { 0x444989DD, "drone_cycle_override" },
    { 0x90C96336, "drone_damage_fx_hi_1" },
    { 0x6AC6E8CD, "drone_damage_fx_hi_2" },
    { 0x54D10D2B, "drone_damage_fx_low" },
    { 0x2E233453, "drone_damage_fx_med_1" },
    { 0xBC1BC518, "drone_damage_fx_med_2" },
    { 0xA06827A4, "drone_data" },
    { 0x5F5B2852, "drone_death" },
    { 0xAA7366AB, "drone_death_anim_flag" },
    { 0x3F684303, "drone_death_func" },
    { 0x65D490F0, "drone_death_hud" },
    { 0x6764930D, "drone_death_quake_max_time" },
    { 0x4DB5CDAF, "drone_death_quake_min_time" },
    { 0xAA3B274B, "drone_death_quake_scale_max_dist" },
    { 0x993D1E5E, "drone_death_queue" },
    { 0x1031C509, "drone_death_thread" },
    { 0x019F8CAB, "drone_debugline" },
    { 0x5E045456, "drone_deck_fire_squibs" },
    { 0xD3484929, "drone_delayed_bulletdeath" },
    { 0x1EAD6320, "drone_delays" },
    { 0x42D12F3D, "drone_delete" },
    { 0x91E9EB57, "drone_delete_on_unload" },
    { 0x0DDD65D5, "drone_delete_sound_loops" },
    { 0x8760CD80, "drone_delete_thread" },
    { 0x4B891877, "drone_destroy_unowned" },
    { 0x6FEEE1DA, "drone_detected_player" },
    { 0xB630FC3B, "drone_detects_damage_for_alert" },
    { 0xAAAF3C40, "drone_detects_player" },
    { 0x2B77749C, "drone_dist" },
    { 0xA5886F9F, "drone_dodeath" },
    { 0xB8B7F21F, "drone_dodeath_impacts" },
    { 0x7975D26D, "drone_done_firing_at_civ" },
    { 0xAE19E63E, "drone_drop_weapon" },
    { 0x8EF8D208, "drone_e4_downhill_burst" },
    { 0x4205932C, "drone_e4_hill_trans" },
    { 0x64CAC88B, "drone_earthquake" },
    { 0xEF4C0AAC, "drone_escape_start" },
    { 0x7BAE0797, "drone_evade" },
    { 0xD8264186, "drone_event_looped_anim" },
    { 0x510D538C, "drone_event_run_and_shoot" },
    { 0xDFE5153C, "drone_event_shoot" },
    { 0x1E319466, "drone_explode_at_end_node" },
    { 0xB7D13998, "drone_explode_impact" },
    { 0xEBF8A4AA, "drone_explode_think" },
    { 0x6A5D3B9E, "drone_explosion_big" },
    { 0xC13C2AB9, "drone_explosion_small" },
    { 0x1D86EB66, "drone_extra_1" },
    { 0xF78470FD, "drone_extra_2" },
    { 0xD181F694, "drone_extra_3" },
    { 0xAB7F7C2B, "drone_extra_4" },
    { 0x857D01C2, "drone_extra_5" },
    { 0x5F7A8759, "drone_extra_6" },
    { 0xD881025B, "drone_fade_out" },
    { 0xD225D2C8, "drone_fail" },
    { 0x0CE9CF36, "drone_fake_fire_at_target" },
    { 0x8AF3F43F, "drone_fakedeath" },
    { 0xEB949F0F, "drone_fire_" },
    { 0x3F5FB498, "drone_fire_at_deck" },
    { 0x68DD70F3, "drone_fire_at_jiffylube" },
    { 0xDFB654D3, "drone_fire_at_market_walkway_trigger" },
    { 0x248AD078, "drone_fire_at_target" },
    { 0x48F26068, "drone_fire_at_vehicle_type" },
    { 0x5EF78689, "drone_fire_missile" },
    { 0x366447FC, "drone_fire_squibs" },
    { 0xB417D725, "drone_fire_turret" },
    { 0x97C0D82D, "drone_fireat_player" },
    { 0x7C9D7E39, "drone_flamedeath" },
    { 0x4909E03F, "drone_fly" },
    { 0x67FACB61, "drone_flyaway" },
    { 0x4F8CA196, "drone_flyaway_logic" },
    { 0xAD3695B6, "drone_focus_rooftop" },
    { 0x73556F66, "drone_follow_linked_structs" },
    { 0x39209F6E, "drone_fx" },
    { 0x3B4E16C0, "drone_gantry_entry" },
    { 0xB34C3982, "drone_gaz_melee_fail" },
    { 0xFFC2C562, "drone_generic_fire" },
    { 0x9886B945, "drone_geo_changes" },
    { 0xBE805219, "drone_get_allies_spawner_class" },
    { 0x05E5FC94, "drone_get_axis_spawner_class" },
    { 0x24741DB7, "drone_get_explosion_death_dir" },
    { 0x2E7F813D, "drone_hack_time" },
    { 0x5BA7AF5C, "drone_hacked" },
    { 0x8017B7CE, "drone_head_icon" },
    { 0x66DA0791, "drone_helicopter_setup" },
    { 0x096263CA, "drone_helideath" },
    { 0x12E922C7, "drone_hide_weapon" },
    { 0xA674381E, "drone_hints" },
    { 0xC423F4C2, "drone_hud_elem_constant_size" },
    { 0x6A609822, "drone_hud_marked_target" },
    { 0x839EABAA, "drone_idle" },
    { 0xF8470ABE, "drone_idle_anim" },
    { 0x854A5B20, "drone_idle_row_boat" },
    { 0xB58C8FA2, "drone_impact" },
    { 0xFDDEFF95, "drone_in_swap" },
    { 0x43999B72, "drone_init" },
    { 0xF740DB22, "drone_intro" },
    { 0xBF698E2F, "drone_intro_ai" },
    { 0x0717C076, "drone_intro_ais" },
    { 0x47DCC1AA, "drone_intro_billboard" },
    { 0xFF2AC1C4, "drone_intro_blockade" },
    { 0x95894877, "drone_intro_enemies" },
    { 0xCFB0C9AB, "drone_intro_entries" },
    { 0xA64F56DF, "drone_intro_finished" },
    { 0x6C8154E3, "drone_intro_glass_break" },
    { 0xF3854D4A, "drone_intro_glass_building" },
    { 0xC906BCA4, "drone_intro_lookat_targets" },
    { 0x3FB68A9A, "drone_intro_path_end" },
    { 0xA82833E7, "drone_intro_player_face_fx" },
    { 0xACD4875D, "drone_intro_scaffolding" },
    { 0x0F8C0994, "drone_intro_soct_0_logic" },
    { 0xC0C3F446, "drone_intruderwatch" },
    { 0x4A47EF7C, "drone_kill" },
    { 0xCEDDE946, "drone_kill_challenge" },
    { 0x4C755AF8, "drone_kill_count" },
    { 0xEB0E95DF, "drone_killedby_bus" },
    { 0xB39E3E79, "drone_killer" },
    { 0x477E53A5, "drone_lens_flare" },
    { 0x780C17BC, "drone_level_player_startfps" },
    { 0xEB5F0A86, "drone_level_precache" },
    { 0xE4750C1A, "drone_level_scenario_one" },
    { 0xC0B16460, "drone_level_setup" },
    { 0x7A5DB5BC, "drone_line_goal" },
    { 0x7B828AD4, "drone_line_path" },
    { 0x9558285C, "drone_link" },
    { 0xCAA4ECC4, "drone_list" },
    { 0x1472B778, "drone_list_1" },
    { 0x867A26B3, "drone_list_2" },
    { 0x48B5701C, "drone_listener" },
    { 0xF991F3F9, "drone_lod" },
    { 0xDDFEA5DA, "drone_lookahead_value" },
    { 0x20E79652, "drone_lookat_restart" },
    { 0x5AFC4777, "drone_lookaway_restart" },
    { 0xD46CB172, "drone_loop_anim" },
    { 0x606FFFB0, "drone_loop_run_anim" },
    { 0x5E937158, "drone_low_delete" },
    { 0xA8E2D20D, "drone_low_not_trig" },
    { 0xCDC8F1F7, "drone_magicmarker" },
    { 0x5F001F33, "drone_manager_process" },
    { 0x212D6D1D, "drone_marine_model_index" },
    { 0xCF00DFA6, "drone_meeting_event" },
    { 0x9F789795, "drone_mg42_fail" },
    { 0x7850D506, "drone_min_emps" },
    { 0x3B026426, "drone_min_spawn_distance" },
    { 0x239644CC, "drone_missile_earthquake" },
    { 0xC5D1FBB8, "drone_missile_oob_check" },
    { 0x51A07BCC, "drone_mission_complete" },
    { 0x56EC5CDF, "drone_mission_complete_s1" },
    { 0xC06E8463, "drone_model" },
    { 0xAD1559C3, "drone_mortardeath" },
    { 0x622B38C3, "drone_move" },
    { 0xA9C5E1BF, "drone_move_to_ent" },
    { 0x4D593619, "drone_move_to_ent_and_delete" },
    { 0x21059B84, "drone_move_to_ent_and_fire" },
    { 0x1D400FEF, "drone_muzzleflash" },
    { 0x854AB4DA, "drone_nag" },
    { 0x3598E92C, "drone_names" },
    { 0x353F5C15, "drone_notetrack" },
    { 0x0BDBF527, "drone_notify" },
    { 0x9C59730E, "drone_org" },
    { 0x8C6816E8, "drone_outro_fail" },
    { 0x0C95DB40, "drone_outro_fail_emp_fx" },
    { 0xCDF817D2, "drone_outro_player_fire" },
    { 0xD43BDE58, "drone_outro_succeed" },
    { 0x1D9C71A4, "drone_pain" },
    { 0x49CA1380, "drone_pain_for_time" },
    { 0x3A830F8B, "drone_path_ent" },
    { 0xBC3EE2BF, "drone_pick_run_anim" },
    { 0xDB4E5F7E, "drone_play_anim" },
    { 0xB2A08DFB, "drone_play_paddle_anim" },
    { 0x4E0BA570, "drone_player_damage_override" },
    { 0x894A7077, "drone_player_oobwatch" },
    { 0x127A3462, "drone_playidleanimation" },
    { 0x5DDC2818, "drone_powdeath" },
    { 0xEA1D9B87, "drone_precache" },
    { 0xAA188F1D, "drone_print_speed" },
    { 0x24622792, "drone_proximity_check" },
    { 0x0C025DA1, "drone_punisher_fire" },
    { 0xC898B429, "drone_punisher_logic" },
    { 0xB274737B, "drone_punishment" },
    { 0xA12A9E9D, "drone_ragdoll" },
    { 0x5B4C2E26, "drone_random_targets" },
    { 0x90FD3D09, "drone_remainder" },
    { 0xBCAFF861, "drone_remove_collision" },
    { 0xE03F11D0, "drone_respawn_after_death" },
    { 0x05FFDB9D, "drone_rotate_angle" },
    { 0xAADD3639, "drone_rpg" },
    { 0xC811FAA1, "drone_run_and_shoot_blanks" },
    { 0x9673276D, "drone_run_anim_speed" },
    { 0xAB28920C, "drone_run_cycle" },
    { 0x9B7614C3, "drone_run_cycle_override" },
    { 0x7E294D34, "drone_run_cycle_speed" },
    { 0xED24C358, "drone_run_rate" },
    { 0xA5567162, "drone_run_rate_multiplier" },
    { 0x06AE73C7, "drone_run_speed" },
    { 0x5171D016, "drone_runchain" },
    { 0x13E4351C, "drone_runchain_array" },
    { 0x0DA73A20, "drone_runto" },
    { 0x87E28300, "drone_sam_attack" },
    { 0x270DFBC7, "drone_sam_attack_score" },
    { 0xF5B12EBA, "drone_savannahdeath" },
    { 0x490FA871, "drone_score_max" },
    { 0xB68786CF, "drone_score_min" },
    { 0xE2FEDB4E, "drone_score_time" },
    { 0xD1923950, "drone_script_noteworthy_check" },
    { 0x84E76762, "drone_scripted_spawn" },
    { 0xEFFEDFE6, "drone_searcher_alt_logic" },
    { 0xAF593D3B, "drone_searcher_deathwatch" },
    { 0x8E35DEC0, "drone_searcher_done" },
    { 0x1EC678AA, "drone_searcher_flyoff" },
    { 0xF93BB2D2, "drone_searcher_logic" },
    { 0x8A75CBA6, "drone_searcher_searchlight_off" },
    { 0xE0A661B8, "drone_searcher_searchlight_on" },
    { 0x76DCBE18, "drone_searcher_spotlight_alt_movement" },
    { 0xD4E26649, "drone_searcher_target_movement" },
    { 0xC7907504, "drone_searchlight" },
    { 0xF8E94E9A, "drone_secondary_death_fx_1" },
    { 0xA1048619, "drone_set_run_cycle" },
    { 0x653258B3, "drone_set_turret_target_idle_cycle" },
    { 0x9DC62D65, "drone_setname" },
    { 0x74688FA0, "drone_setstart" },
    { 0xE8387223, "drone_setup" },
    { 0x1728749C, "drone_setup_devgui" },
    { 0xFC527719, "drone_sfx" },
    { 0x50C5E119, "drone_shoot_at_player" },
    { 0x6CB73979, "drone_shoot_at_player_skipped_claws" },
    { 0x79B27279, "drone_shoot_blanks" },
    { 0x52130147, "drone_shoot_bullets" },
    { 0xB7FE479F, "drone_shooting" },
    { 0xF83F7706, "drone_shot3_fire" },
    { 0x159CBFB2, "drone_should_return" },
    { 0x29C61EE2, "drone_show_weapon" },
    { 0x6B3925EE, "drone_singleaction" },
    { 0x5100A639, "drone_slowdown_for_time" },
    { 0xEDC2B8C6, "drone_soct_damage_scale" },
    { 0x0DFF19C1, "drone_spawn" },
    { 0xF2D1A1C4, "drone_spawn_done" },
    { 0x33EE613D, "drone_spawn_emps" },
    { 0x360A0EDE, "drone_spawn_func" },
    { 0xE23F0BAE, "drone_spawned" },
    { 0x7A6A7F97, "drone_spawned_this_frame" },
    { 0x9E0886A8, "drone_spawner" },
    { 0x25A76B9D, "drone_spawner_active" },
    { 0x3FFD169A, "drone_spawner_side" },
    { 0x42E9E067, "drone_spawner_wait_for_activation" },
    { 0x419B1043, "drone_spawners" },
    { 0x508FFB11, "drone_spawners_array" },
    { 0xD28CD861, "drone_spawnfunction" },
    { 0xA0D06057, "drone_spawnfunction_passnode" },
    { 0xE4E7B5D6, "drone_spawngroup" },
    { 0xFFA1070D, "drone_speed_adjust" },
    { 0x4568DE5D, "drone_speed_manager" },
    { 0xD1BEE97A, "drone_speed_max" },
    { 0x945ADE64, "drone_speed_min" },
    { 0x7354F6E0, "drone_speed_override" },
    { 0x4F2F2372, "drone_spotlight_control" },
    { 0x6C4D512C, "drone_spotlight_detection" },
    { 0xDDD2A30F, "drone_spotlight_detection_parameters" },
    { 0x752DDFB9, "drone_spotlight_index" },
    { 0x09FA6B10, "drone_spotlight_movement" },
    { 0xE5204BE9, "drone_spotlight_swapped" },
    { 0x97786BC1, "drone_spotlight_tag" },
    { 0x0D23981D, "drone_spotlight_turret" },
    { 0x2CFB85C1, "drone_spotted_player" },
    { 0x5E308C7D, "drone_squib_fire_at_lapd" },
    { 0xE19CDCA7, "drone_squibs" },
    { 0xB8E5851E, "drone_startintro" },
    { 0xE7E71171, "drone_stealth" },
    { 0x9FCBBF8C, "drone_stop_cover" },
    { 0x04F39CB2, "drone_stop_fire_" },
    { 0x0E148782, "drone_stop_gunfire_check" },
    { 0xB244B82A, "drone_strike" },
    { 0x6C0F0160, "drone_strike_complete" },
    { 0x49231826, "drone_strike_count" },
    { 0x969DD156, "drone_strike_end_offset" },
    { 0x513E9309, "drone_strike_flight_time" },
    { 0xFB24B28E, "drone_strike_forward_offset" },
    { 0x6A0EEF6C, "drone_strike_left_offset" },
    { 0x1739FD00, "drone_strike_location_selector" },
    { 0x814BED40, "drone_strike_model" },
    { 0xC338A2B8, "drone_strike_name" },
    { 0x4CB29021, "drone_strike_right_offset" },
    { 0x7CF6B7B6, "drone_strike_spawn_interval" },
    { 0xE6FAA067, "drone_strike_start_offset" },
    { 0x85EA4735, "drone_strike_z_offset" },
    { 0x1C43596F, "drone_struct" },
    { 0x732FEAB6, "drone_structs" },
    { 0x4AB45A78, "drone_stun_time" },
    { 0x28FC2318, "drone_suppress_archway_think" },
    { 0x82827FE8, "drone_swap_cap" },
    { 0x846518EA, "drone_swap_for_ai" },
    { 0x96D10AFD, "drone_swap_manager" },
    { 0x2A88853A, "drone_swapper" },
    { 0x4E2E567A, "drone_swarm_fire_missile" },
    { 0x9C31290D, "drone_swarm_fire_squibs" },
    { 0x62830043, "drone_swarm_start_fire_" },
    { 0x036604DB, "drone_swarm_start_fire_2" },
    { 0x6872AD45, "drone_swarm_stop_fire_" },
    { 0xFCE8841A, "drone_swim_to_ent" },
    { 0x06992DBC, "drone_tank" },
    { 0x5E55C28D, "drone_tank_cap" },
    { 0x425CC877, "drone_target" },
    { 0x91D3BA4A, "drone_target_acquired" },
    { 0xE4E11D71, "drone_target_death_watcher" },
    { 0xCDD8A831, "drone_target_id" },
    { 0x0905C4E2, "drone_target_search" },
    { 0xB6279BAE, "drone_targets" },
    { 0x3A94BE4C, "drone_think" },
    { 0xA7B4E8C1, "drone_think_func" },
    { 0xF54E2D47, "drone_threads" },
    { 0x97074384, "drone_throws_molotov" },
    { 0x1EE52EEF, "drone_to_soct_setup" },
    { 0xE8E24496, "drone_total_time" },
    { 0x5F28F643, "drone_track_ent" },
    { 0x386E77AB, "drone_track_ent_height" },
    { 0x0D04938D, "drone_tread_water_idle" },
    { 0x9EB3C7EA, "drone_trig" },
    { 0xD7E1562A, "drone_trig_script_noteworthy" },
    { 0x6B9C4D38, "drone_trigger" },
    { 0xBA5536C4, "drone_trigger_1" },
    { 0x2C5CA5FF, "drone_trigger_2" },
    { 0x065A2B96, "drone_trigger_3" },
    { 0x484DC789, "drone_trigger_4" },
    { 0xF775F1BF, "drone_trigger_apc" },
    { 0x0564A982, "drone_trigger_array" },
    { 0xD3A7CA03, "drone_trigger_defend" },
    { 0x4AA54F28, "drone_trigger_defend_b" },
    { 0xE060904A, "drone_trigger_e4_downhill" },
    { 0x608CF6D3, "drone_trigger_e5_left" },
    { 0x73C9E246, "drone_trigger_e5_right" },
    { 0x9B05DDB3, "drone_trigger_intro" },
    { 0x0E24B50F, "drone_trigger_player_drums_one" },
    { 0x81FB45AD, "drone_trigger_player_drums_two" },
    { 0xB3D28BBC, "drone_trigger_spawn_time" },
    { 0x60E795D3, "drone_trigger_thread" },
    { 0xAF0BAC55, "drone_trigger_woods_drums" },
    { 0x304EBD93, "drone_triggers" },
    { 0xDBA09354, "drone_triggers_delay_first_spawn" },
    { 0xE90DE652, "drone_triggers_think" },
    { 0xB9782EA5, "drone_trigs" },
    { 0xA62DC9AB, "drone_trigs_axis" },
    { 0x15CC8FED, "drone_turret_index_left" },
    { 0x8EF72690, "drone_turret_index_right" },
    { 0x3E511366, "drone_tut_takeoverwatch" },
    { 0xE31B00FA, "drone_tutorial" },
    { 0x920B4BF9, "drone_tutorial_exit" },
    { 0x31E54CD1, "drone_tutorialmsg" },
    { 0x6C4746E4, "drone_type" },
    { 0x85ACF9EC, "drone_unloader" },
    { 0x3B932B30, "drone_up_down_transition" },
    { 0x2EEF77AD, "drone_update_target" },
    { 0x727B7A9E, "drone_vc_model_index" },
    { 0x954C64C1, "drone_vics" },
    { 0x36097282, "drone_walk_anim_loop" },
    { 0xAD1579EE, "drone_watch_devgui" },
    { 0xE217CF4A, "drone_watchbuttonpress" },
    { 0x5A76F572, "drone_wave_" },
    { 0x21BDD08F, "drone_wave_1" },
    { 0xAFB66154, "drone_wave_2" },
    { 0xD5B8DBBD, "drone_wave_3" },
    { 0x0BA24DA7, "drone_wave_complete" },
    { 0x15004105, "drone_weaponlist_allies" },
    { 0x2BB8AB64, "drone_weaponlist_axis" },
    { 0x527E87B8, "drone_window_target" },
    { 0xFB7B4DAE, "droneanim" },
    { 0x1CDBAF84, "droneanimfinished" },
    { 0x5B95B4F8, "dronearray" },
    { 0xBD6CAE75, "droneattachtags" },
    { 0xF1D6D59C, "dronecallbackthread" },
    { 0x8E3F667E, "dronecodespawner" },
    { 0x5317EAC6, "dronecustomdeath" },
    { 0xCE693C04, "dronedistance" },
    { 0x55BCA38D, "droneextraanims" },
    { 0xA8DA988A, "dronefailed" },
    { 0x32A5E09F, "droneidleanims" },
    { 0x500BE540, "dronekills" },
    { 0x5F56019A, "dronerunanims" },
    { 0x6A76583D, "dronerunoffset" },
    { 0xEC601392, "dronerunrate" },
    { 0xA2BE4C40, "drones" },
    { 0x90C63C25, "drones_active" },
    { 0x29E3616F, "drones_add_custom_func" },
    { 0xED7353F7, "drones_assign_global_spawner" },
    { 0xC8C45561, "drones_assign_spawner" },
    { 0x3E43E4F0, "drones_clear_variables" },
    { 0x01CD77AD, "drones_death_notify_wrapper" },
    { 0xF80960E6, "drones_delete" },
    { 0xF81A90C9, "drones_delete_spawned" },
    { 0x3A27D009, "drones_disable_sound" },
    { 0x06651762, "drones_firing_at_the_player" },
    { 0x7F4E1D2C, "drones_float_away" },
    { 0xF13BFC17, "drones_get_array" },
    { 0xCA0CA2C5, "drones_get_data_from_script_string" },
    { 0x90475C5C, "drones_get_spawner" },
    { 0xF840E4EC, "drones_get_struct_from_script_string" },
    { 0x840B71C0, "drones_get_triger_from_scipt_string" },
    { 0xE2BEA959, "drones_get_trigger_from_script_string" },
    { 0xBDD38D77, "drones_get_triggers" },
    { 0xA9C3F9E2, "drones_gone" },
    { 0xF01D3391, "drones_init" },
    { 0x538A992E, "drones_init_max" },
    { 0xA37D742D, "drones_mg_target" },
    { 0xFCD53407, "drones_mobilize_general" },
    { 0x4E229D50, "drones_on_bridge" },
    { 0x1194CE5F, "drones_pause" },
    { 0x3154CAA0, "drones_per_wave" },
    { 0xC6932AF5, "drones_respawner_created" },
    { 0x43B5F174, "drones_respawner_used" },
    { 0x3F4266DE, "drones_set_cheap_flag" },
    { 0x4A7BA218, "drones_set_friendly_fire" },
    { 0x1A7874C2, "drones_set_impact_effect" },
    { 0x9361685E, "drones_set_max" },
    { 0xCCBF57E1, "drones_set_max_ragdolls" },
    { 0x7F7F9A57, "drones_set_muzzleflash" },
    { 0xF68402E3, "drones_set_respawn_death_delay" },
    { 0x2C13F763, "drones_setup_spawner" },
    { 0xB27337B3, "drones_setup_unique_anims" },
    { 0x5AB6B053, "drones_spawned" },
    { 0x622512D0, "drones_speed_modifier" },
    { 0xD1EF7775, "drones_start" },
    { 0xA161F7F0, "drones_swap_spawner_ally" },
    { 0x7D1B8CF5, "drones_swap_spawner_axis" },
    { 0x79EF5B1B, "drones_system_initialized" },
    { 0x6A82BC7F, "drones_wait_stop" },
    { 0xDC0CB78A, "drones_wasp" },
    { 0x2D1EFAA9, "droneshot" },
    { 0x2ACD03E7, "droneshot_actor" },
    { 0x7FB0E6A2, "droneshot_camera_active" },
    { 0xC1CA3C32, "droneshot_capture" },
    { 0x045FD9FA, "droneshot_capture_playback" },
    { 0x14F8A27A, "droneshot_controls" },
    { 0xEC71BC97, "droneshot_playback" },
    { 0xEF634C5B, "droneshot_render_selectshot" },
    { 0xC24D0716, "droneshot_render_setup" },
    { 0x675C2C38, "droneshot_start" },
    { 0x6CFDD1E3, "dronesowned" },
    { 0x8E7E35E2, "dronespawn" },
    { 0xACB820E7, "dronespawn_check" },
    { 0xF4E02954, "dronespawn_setstruct" },
    { 0x0D5EA997, "dronespawn_setstruct_from_guy" },
    { 0x51C673C2, "dronestepheight" },
    { 0x2763EAAB, "dronestrike" },
    { 0xB45679D2, "dronestrikeawardempscoreevent" },
    { 0xAE1B534E, "dronestrikeawardscoreevent_singleton" },
    { 0x516499E1, "dronestrikelocationselected" },
    { 0x7462738A, "dronestrikes" },
    { 0x1220C8CE, "dronestruct" },
    { 0x38A935C3, "dronetag" },
    { 0xB93841E2, "dronetarget" },
    { 0x33D7900B, "dronetrig" },
    { 0x212DA058, "dronetrig1" },
    { 0x6D32952A, "dronetrig3" },
    { 0xAC9D6675, "dronwing" },
    { 0xF09CA2ED, "drooling" },
    { 0x50C62E42, "drop" },
    { 0x6F86589F, "drop1" },
    { 0xFD7EE964, "drop2" },
    { 0x238163CD, "drop3" },
    { 0xB179F492, "drop4" },
    { 0x6574FFC0, "drop6" },
    { 0xF6EFBC3A, "drop_a_mortar" },
    { 0xD33EE699, "drop_all_barriers" },
    { 0x26382144, "drop_all_to_ground" },
    { 0xA8C1BAA0, "drop_all_weapons" },
    { 0xE262550E, "drop_angle" },
    { 0xD37C99EB, "drop_asd" },
    { 0x0538C9E7, "drop_bigdog_by_chopper" },
    { 0x360CC029, "drop_bodies" },
    { 0x2923B450, "drop_bombs" },
    { 0xAF17C1A4, "drop_bombs_rumble" },
    { 0xC570A7C5, "drop_bombs_waittill" },
    { 0xB9E5239E, "drop_building1" },
    { 0xEF2E1E06, "drop_candidate_array" },
    { 0x46240C91, "drop_car" },
    { 0xDBDF2FE1, "drop_chance" },
    { 0xBA75B2CA, "drop_cover_crate" },
    { 0x8885290E, "drop_crate" },
    { 0xFE2E1C4A, "drop_crate_before_alley" },
    { 0xB937498F, "drop_crate_before_heli" },
    { 0xAE575478, "drop_deploying" },
    { 0xE066498C, "drop_direction" },
    { 0x90EC1851, "drop_dist" },
    { 0x0DE2854C, "drop_distance" },
    { 0x405C8162, "drop_down_border" },
    { 0xC65F8A60, "drop_down_invulnerability_think" },
    { 0x586262BA, "drop_dust_fx" },
    { 0x8FAE3F1F, "drop_exit_struct_name" },
    { 0x4BA83A21, "drop_fn" },
    { 0xB0130315, "drop_for_death" },
    { 0xC1344433, "drop_from_goal_distance2d" },
    { 0xCF8F7207, "drop_fx" },
    { 0xE9221084, "drop_gear" },
    { 0x8B2E9FBC, "drop_goal" },
    { 0x98D8F216, "drop_grenades_to_ground" },
    { 0x8F46B2F7, "drop_guy1" },
    { 0x4341BE25, "drop_guy3" },
    { 0xD13A4EEA, "drop_guy4" },
    { 0x87A0D65A, "drop_health_timeout_thread" },
    { 0x0E30FC4F, "drop_health_trigger_think" },
    { 0x62F6A6EC, "drop_height" },
    { 0xE906E4A5, "drop_in_then_seek" },
    { 0x30749C13, "drop_index" },
    { 0xB2C5A2E4, "drop_item" },
    { 0xD2474EFE, "drop_javelin" },
    { 0x9D720F2B, "drop_jug_by_chopper" },
    { 0x11953726, "drop_killcam" },
    { 0xC6372501, "drop_knives_to_ground" },
    { 0x7369FC52, "drop_leader" },
    { 0x5B579C59, "drop_left_gun" },
    { 0x52103262, "drop_lift" },
    { 0x2F87D08F, "drop_light" },
    { 0x0843A5C4, "drop_limited_weapon" },
    { 0x8E00B612, "drop_m202" },
    { 0xA10C843F, "drop_marine" },
    { 0x85FB49E9, "drop_max_ammo_at_death_location" },
    { 0x0560C24F, "drop_me" },
    { 0xBBA95E68, "drop_meat" },
    { 0xFD738718, "drop_model" },
    { 0x556C7C51, "drop_mortars_in_front_of_player" },
    { 0x9D2091B1, "drop_mortars_on_plane_ride" },
    { 0x0B54EB01, "drop_node" },
    { 0x4CA53D47, "drop_not_occupied" },
    { 0xC952289F, "drop_now" },
    { 0x03E5000B, "drop_num" },
    { 0x972FD3C0, "drop_object" },
    { 0xE4D98A49, "drop_objects_to_ground" },
    { 0x1CE47398, "drop_off" },
    { 0x84C7A1B8, "drop_offset" },
    { 0xA59D3B59, "drop_offset_tag" },
    { 0xB908E870, "drop_on_mover" },
    { 0x4489FCCF, "drop_origin" },
    { 0x38E94531, "drop_piece" },
    { 0x35DB651C, "drop_pistol" },
    { 0x581D2B89, "drop_point" },
    { 0x1151B561, "drop_pos" },
    { 0x438DB373, "drop_powerup" },
    { 0x652BE538, "drop_rotate" },
    { 0x880A4054, "drop_scavenger_for_death" },
    { 0xDB7504EE, "drop_secured" },
    { 0x11AD8107, "drop_selection_to_ground" },
    { 0x2E0539AB, "drop_slots_for_network" },
    { 0x43D63258, "drop_spawn_points" },
    { 0x5638AFA2, "drop_speed" },
    { 0x863C54F9, "drop_speed_max" },
    { 0x43D485F9, "drop_spot" },
    { 0xEE5FD130, "drop_spots" },
    { 0x32DADFE9, "drop_starting_crate" },
    { 0xB992D0ED, "drop_stretcher" },
    { 0xCB9708B6, "drop_struct" },
    { 0x252FA23C, "drop_struct_name" },
    { 0x830CC68C, "drop_supplies" },
    { 0x92FC0506, "drop_time" },
    { 0xA3DCA615, "drop_time_last" },
    { 0x5E25AEE5, "drop_to_floor" },
    { 0x0C65F4CC, "drop_to_ground" },
    { 0xB8CD7800, "drop_trace" },
    { 0x6B1AD30F, "drop_turret" },
    { 0x1FCE1F97, "drop_unlinked_grenades" },
    { 0x4CDAB420, "drop_vista_1" },
    { 0xBEE2235B, "drop_vista_2" },
    { 0xEE7A502D, "drop_vista_think" },
    { 0x550A6AE1, "drop_weapon_toks" },
    { 0xEDA44950, "drop_wingman" },
    { 0xB6076FAE, "dropaiammo" },
    { 0x33468348, "dropaiweapon" },
    { 0xEF422B7C, "dropallaiweapons" },
    { 0x78BD77F5, "dropallaroundhq" },
    { 0x636195E5, "dropalltoground" },
    { 0xF0963D23, "dropalltogroundaftercratedelete" },
    { 0x838B714E, "dropangles" },
    { 0x8CE4329D, "dropanim" },
    { 0x8264E4DE, "dropbomb" },
    { 0xD6B34B57, "dropbombkillcam" },
    { 0x428FFA25, "dropbombmodel" },
    { 0xF94FAEE5, "dropbombs_and_quake" },
    { 0xA0444DC0, "dropbreadcrumbs" },
    { 0x0CD95AE0, "dropclip" },
    { 0xC415FE77, "dropclipmodel" },
    { 0x4E878F8F, "dropcrate" },
    { 0xE53F7C08, "dropcratestoground" },
    { 0x193B1325, "dropcratetoground" },
    { 0x61DD8E7C, "dropdead" },
    { 0xC9E6C378, "dropdeletetime" },
    { 0xD93836DA, "dropdown" },
    { 0xD1F4C491, "dropdown_anims" },
    { 0x47CEB53D, "dropdown_drone" },
    { 0xED40ECA2, "dropdown_guy" },
    { 0x71E08365, "dropdown_objectives" },
    { 0x24B7A2B9, "dropdown_precache_anims" },
    { 0x1891E3A4, "dropeds" },
    { 0x787981BF, "dropeverythingondoorstoground" },
    { 0x404DF303, "dropeverythingtouchingcrate" },
    { 0x01D3D7BB, "dropflashlightondeath" },
    { 0x2ADF23D4, "dropgrenade" },
    { 0x9EAF352D, "dropgrenadestoground" },
    { 0x5BFBD7BD, "dropgun_dialogue" },
    { 0x91478C15, "dropgunnotetrack" },
    { 0xEBA20FE9, "dropheadchopper" },
    { 0xFA28F32C, "drophealth" },
    { 0x4B09CBE7, "dropheight" },
    { 0x562A2C6F, "dropitem" },
    { 0x5AF0940F, "dropjetgun" },
    { 0xB7CFFE3B, "dropkillcam" },
    { 0x1D9757DA, "dropkillcams" },
    { 0x71CF3D3A, "dropkillthread" },
    { 0xD36601C2, "dropknivestoground" },
    { 0x20D42983, "dropletcheck" },
    { 0x6F22892C, "droplets" },
    { 0x26BED480, "droplimitedweapon" },
    { 0xCF9424E7, "droplocation" },
    { 0xB2C19E5E, "droplocations" },
    { 0x8F9A22E6, "dropnode" },
    { 0x6F7ACF19, "dropnodes" },
    { 0xDDE1CE51, "dropnodetofloor" },
    { 0xA576D049, "dropoff" },
    { 0x7E24330C, "dropoff_done" },
    { 0x908E9804, "dropoff_heli" },
    { 0x9D6ADADE, "dropoff_huey_guy_function" },
    { 0x3E33441E, "dropoffhand" },
    { 0xB12A1A40, "dropoffs" },
    { 0x95101843, "dropoffset" },
    { 0x18DC315D, "droponbus" },
    { 0x54DC9797, "droponelevator" },
    { 0xBE206D34, "droponmover" },
    { 0x08B0CE00, "droporigin" },
    { 0x63091A36, "droporigin_reflect" },
    { 0x0EB84C98, "dropovernode" },
    { 0x65C34EE8, "droppability" },
    { 0xAE95D7F8, "droppable_weapons" },
    { 0x809BC3B9, "dropped" },
    { 0x6511AABC, "dropped_" },
    { 0xADA0367C, "dropped_equipment" },
    { 0x8795F5DB, "dropped_equipment_destroy" },
    { 0xB0139E2D, "dropped_equipment_think" },
    { 0x7D4C1994, "dropped_equipment_unitrigger_think" },
    { 0xF4E8514A, "dropped_flag" },
    { 0xFF2C342A, "dropped_gun" },
    { 0xBF9CA8D5, "dropped_riot_shields" },
    { 0x2E45809F, "dropped_weapon_before_melee" },
    { 0xA8F28CD5, "droppeddeathweapon" },
    { 0xB3D9482C, "droppeditem" },
    { 0x12E45979, "droppedraps" },
    { 0x4D76FB16, "droppedsidearm" },
    { 0x5CF9CC61, "droppedtagrespawn" },
    { 0x395C0209, "droppedweapon" },
    { 0xDFAA6ED0, "droppedweaponent" },
    { 0x27C0E8A8, "droppedweaponname" },
    { 0x0482FB9F, "dropper" },
    { 0x7F0CEF26, "droppers" },
    { 0x5A8D7F56, "dropphysweapon" },
    { 0xE313646A, "dropping" },
    { 0x15D3A720, "dropping_weapons" },
    { 0x9BEE2DD5, "droppingplayer" },
    { 0x56ADCF6E, "droppingraps" },
    { 0x83575BD4, "droppingtoground" },
    { 0xADC34DAB, "droppng" },
    { 0xEA73D436, "droppowerup" },
    { 0x32CC6293, "droppoweruptemptation" },
    { 0x04045406, "dropraps" },
    { 0x65B4FBDB, "dropreactordoors" },
    { 0x49D1D167, "dropriotshield" },
    { 0xA2E2C98D, "drops" },
    { 0x4FDF7E8B, "drops_on" },
    { 0x3912053B, "drops_time" },
    { 0x5CD03093, "dropscavengerfordeath" },
    { 0x1906D003, "dropscavengeritem" },
    { 0xC81BEE01, "dropshield" },
    { 0xAE1C9264, "dropship" },
    { 0x4685399E, "dropslipgun" },
    { 0x5778C182, "dropspawnpoints" },
    { 0x79649F6B, "dropspeed" },
    { 0x97BD5EFB, "dropspeedbump" },
    { 0x7AD30272, "dropspot" },
    { 0x4878CBFC, "dropspringpad" },
    { 0xDADD18B0, "dropstock" },
    { 0x8B76EEE0, "dropsubwoofer" },
    { 0x5D0D7FF2, "droptag" },
    { 0x2EDA2DF3, "droptagoffset" },
    { 0x92AED0E5, "droptarget" },
    { 0xBF59452D, "dropteam" },
    { 0x7999ACFD, "droptime" },
    { 0x2A8E17C4, "droptimearray" },
    { 0xE773B7DC, "droptoground" },
    { 0x5500FCEF, "droptrap" },
    { 0xE4B67497, "dropturbine" },
    { 0x11A9D2B0, "dropturret" },
    { 0x75E726A0, "dropturretonnotify" },
    { 0x8A8D0B58, "dropturretproc" },
    { 0x30A2B996, "dropundervehicleorigin" },
    { 0x17B5981E, "dropundervehicleoriginoverride" },
    { 0xF42D4C12, "dropweapon" },
    { 0x0B40A59F, "dropweaponfordeath" },
    { 0x2C80FB9F, "dropweaponname" },
    { 0xEC04FB1F, "dropweaponstoground" },
    { 0x0355138C, "dropweapontoground" },
    { 0x33BD0073, "dropweaponwrapper" },
    { 0xD2DB8729, "drown" },
    { 0xD141EB5E, "drown_blur_duration" },
    { 0x095330CF, "drown_damage" },
    { 0x460FC258, "drown_damage_after_time" },
    { 0x8E026421, "drown_damage_interval" },
    { 0x80D8E469, "drown_fade_duration" },
    { 0xB2F9C891, "drown_frame_pass" },
    { 0xBB36A14E, "drown_innerradius" },
    { 0xD058A703, "drown_opacity" },
    { 0x8580CE47, "drown_outerradius" },
    { 0x52F2729F, "drown_overlay_blur_amount" },
    { 0xD5C91E57, "drown_overlay_duration_in" },
    { 0xBF8D8240, "drown_overlay_duration_loop" },
    { 0xB828F522, "drown_overlay_duration_out" },
    { 0x4E4C0E96, "drown_overlay_inner_radius" },
    { 0xACB1EE10, "drown_overlay_lerp_count" },
    { 0xDFBF2D71, "drown_overlay_outer_radius" },
    { 0x66632237, "drown_overlay_priority" },
    { 0xED9FC8A0, "drown_overlay_should_offset" },
    { 0xC7F5130C, "drown_overlay_should_velocity" },
    { 0x70A32F2F, "drown_overlay_should_velocity_scale" },
    { 0x300A7219, "drown_overlay_time_fade_in" },
    { 0x9A19AF50, "drown_overlay_time_fade_out" },
    { 0x575DD582, "drown_pre_damage_stage_time" },
    { 0xEAAE0D0E, "drown_radius" },
    { 0xFA7CB42D, "drown_radius_scale" },
    { 0xB56D56F6, "drown_reset_times" },
    { 0xD06129E6, "drown_screen_effect_name" },
    { 0x09E4C0F6, "drown_stage_1" },
    { 0xE3E2468D, "drown_stage_2" },
    { 0xBDDFCC24, "drown_stage_3" },
    { 0x97DD51BB, "drown_stage_4" },
    { 0xAA5D5689, "drown_stage_bits" },
    { 0x680DABF0, "drown_stage_callback" },
    { 0x001D9FCB, "drown_stage_none" },
    { 0x3BD02312, "drown_start_before_damage_time" },
    { 0x7F303FFC, "drown_start_time" },
    { 0x92CCBBEE, "drown_time_change" },
    { 0xF64FA8B5, "drown_vision_set" },
    { 0xDB4379FB, "drown_vox" },
    { 0xF79B7B56, "drowned" },
    { 0xD27FCB0F, "drowned_vc_end_idle" },
    { 0x0B25E4FE, "drownflags" },
    { 0x4A05555F, "drowning" },
    { 0x3F772F23, "drowning_drones" },
    { 0x1E228123, "drowning_drones_spawn" },
    { 0xF6108186, "drowning_heartbeat" },
    { 0x2E384C4F, "drowning_phase" },
    { 0x861762A0, "drowns" },
    { 0x0482D0AD, "drownstage" },
    { 0x87CE38E0, "drtype1" },
    { 0xF9D5A81B, "drtype2" },
    { 0xD3D32DB2, "drtype3" },
    { 0xC6634716, "drub" },
    { 0x545BD7DB, "drug" },
    { 0xAE5D88FA, "drugs" },
    { 0x386AB651, "drum" },
    { 0xF261305E, "drum_blown" },
    { 0x357F1179, "drum_count" },
    { 0xB1EF6B5C, "drum_pristine" },
    { 0xBC072CF5, "drum_success" },
    { 0xD3F2581E, "drume" },
    { 0x500B2038, "drums" },
    { 0x4ABB4E7D, "drunk" },
    { 0xB11ED701, "drval1" },
    { 0xD721516A, "drval2" },
    { 0xFD23CBD3, "drval3" },
    { 0xB24854A0, "dry" },
    { 0xE6F0899D, "dry_land_tracker" },
    { 0xA0336DB9, "dryer_playerclip" },
    { 0x0DE70615, "dryer_teleports_zombie" },
    { 0x3ECCA3AF, "dryer_trigger_thread" },
    { 0xB625020C, "dryer_zombies_thread" },
    { 0x4AB70A9F, "dryland" },
    { 0x86268A52, "drylevel" },
    { 0xECC39C32, "ds" },
    { 0xC674C30A, "dsec" },
    { 0x3033F22F, "dsiplay_hint" },
    { 0xC1A97F3A, "dsl" },
    { 0xE7ABF9A3, "dsm" },
    { 0x13DAD7F5, "dsm_obj" },
    { 0x1F9BD8A4, "dsm_trig" },
    { 0xE1816F87, "dspawned" },
    { 0xE8366136, "dsquared" },
    { 0xF1BD5282, "dst" },
    { 0x1494695F, "dst1" },
    { 0xA28CFA24, "dst2" },
    { 0xC88F748D, "dst3" },
    { 0x56880552, "dst4" },
    { 0x6913F5BE, "dst_mga" },
    { 0xD1441141, "dst_node" },
    { 0x06C36D78, "dst_s" },
    { 0x5ECB0B6D, "dt" },
    { 0xC1E32237, "dt_damage_callback" },
    { 0xD21E632D, "dt_damage_state" },
    { 0x0ADBBD5A, "dt_damage_state_fx" },
    { 0xF794806C, "dt_respawn" },
    { 0xA7A8B12A, "dte" },
    { 0x5AAB55CF, "dte_watcher" },
    { 0xBD23BCFF, "dthis" },
    { 0x058D6EA7, "dtp" },
    { 0x23ED6B08, "dtp_effects" },
    { 0x1C759F79, "dtp_end" },
    { 0xB09AA005, "dtp_land" },
    { 0xF3CA412A, "dtp_push" },
    { 0x92579412, "dtp_start" },
    { 0x84CF4CEC, "dtp_through_glass" },
    { 0xB08365F0, "dtpglasskills" },
    { 0xE69187EA, "dtpglasskilltimeout" },
    { 0x7999D2EA, "dtpglasstimeout" },
    { 0xE0764BF2, "dtpkills" },
    { 0x6052F1C4, "dtpkilltimeout" },
    { 0xDDEA7612, "dtpthroughglasswatcher" },
    { 0x8604EAB4, "dtptime" },
    { 0xA4772A60, "dtptimeout" },
    { 0x0A5227D5, "dtpwatcher" },
    { 0x08D5E1A5, "dtrig" },
    { 0xBACBCFE1, "dtrigorg" },
    { 0x4CD72DFB, "dtype" },
    { 0x38C89104, "du" },
    { 0x98E6DC13, "dual" },
    { 0x238C02AB, "dual_firing" },
    { 0x0CEE9747, "dual_wield_name" },
    { 0x5FA0430A, "dual_wield_weapon" },
    { 0x5F96DDCC, "dualai_todo" },
    { 0x323E9228, "dualgrenadesactive" },
    { 0x150449BE, "dualmortaruntildeath" },
    { 0x43157796, "dualoptic" },
    { 0x7B78E30E, "dualweapondroplogic" },
    { 0xD147659A, "dualweaponname" },
    { 0x72B96D34, "dualwield" },
    { 0x4FE440A0, "dualwieldweapon" },
    { 0x4F98053F, "dubm" },
    { 0xF674CEE6, "duck" },
    { 0xBE3BFAEC, "duck_bullets" },
    { 0xE4915D73, "duck_cleanup" },
    { 0xE92AD591, "duck_club_music" },
    { 0x839BB146, "duck_once" },
    { 0x5CB448DC, "duckidle" },
    { 0xFF4301EB, "duckidleoccurrence" },
    { 0xB0065B77, "duckin" },
    { 0x5FE8747A, "ducking" },
    { 0xE72EC8C2, "duckout" },
    { 0x59B79319, "ducks" },
    { 0x893C7F4B, "ducksinarow" },
    { 0x08549791, "duct" },
    { 0x8EC47848, "dud" },
    { 0xFBBC8808, "dud_dial_handler" },
    { 0x7D7EB085, "dud_func" },
    { 0x8CADB8D9, "dud_gong_handler" },
    { 0x0643A4C5, "dude" },
    { 0x6E0ECCDF, "dude_array" },
    { 0x34E83105, "dude_on_left" },
    { 0x770BF9CF, "dude_runs_up_stairs" },
    { 0x960BDA6A, "dudeguys_charge_setup" },
    { 0x417C8773, "duderino" },
    { 0xCF4D4C54, "dudes" },
    { 0xDE417AF5, "dudes_needing_warps" },
    { 0xB4C6F2B1, "due" },
    { 0x65B9EAA2, "due_day" },
    { 0xA0BB47A2, "duffels" },
    { 0x00CBE783, "dug" },
    { 0x6849BE1F, "dug_zombie_complete_emerging_into_playable_area" },
    { 0xD6A291A9, "dug_zombie_entered_playable" },
    { 0x83FC6B30, "dug_zombie_rise" },
    { 0x03B0E9B9, "dug_zombie_spawn_init" },
    { 0x8D90D591, "dug_zombie_think" },
    { 0xDDABABB0, "duga" },
    { 0xF6BA8EA4, "duh" },
    { 0x6ECB850B, "dukes" },
    { 0x2E87FE41, "dukes_of_hazard_button_choice_made" },
    { 0x95E88786, "dukes_of_hazard_choice" },
    { 0x9ECEDBBA, "dukes_of_hazard_mode" },
    { 0xBDE38CF3, "dukes_of_hazard_mode_choosing" },
    { 0x576F85DD, "dukes_of_hazard_mode_drone" },
    { 0xE243085C, "dukes_of_hazard_mode_setup" },
    { 0xE44280DE, "dukes_of_hazard_mode_soct" },
    { 0x07BF94C5, "dukes_of_hazzard_trigger" },
    { 0x191F634C, "dull" },
    { 0x43E364D9, "dumb" },
    { 0x6580361C, "dumbass" },
    { 0xE6EB1B69, "dumbbbb" },
    { 0xA10063BF, "dumbest" },
    { 0x5D96C90F, "dummies" },
    { 0xBF268FDB, "dummy" },
    { 0xFED9A1E8, "dummy1" },
    { 0x70E11123, "dummy2" },
    { 0x257235D5, "dummy_anim_first_frame_think" },
    { 0xB9DE3513, "dummy_anim_ref" },
    { 0xFF0F9584, "dummy_anim_think" },
    { 0xD67815E9, "dummy_array" },
    { 0x9B2D6753, "dummy_character_funcs" },
    { 0xEFFBC077, "dummy_delete" },
    { 0x4DCB4FF6, "dummy_dummy" },
    { 0x8ECD7AB7, "dummy_fire_behavior" },
    { 0x77A00A20, "dummy_follow_path_think" },
    { 0xDC59692B, "dummy_spawn_manager" },
    { 0x32008EF8, "dummy_step_aside_think" },
    { 0x8C7F7EC9, "dummy_target" },
    { 0xD9D2E24A, "dummy_think_funcs" },
    { 0x24F26F36, "dummy_think_manager" },
    { 0xCA139AC8, "dummy_to_vehicle" },
    { 0x654C8654, "dummy_turret" },
    { 0x696F9367, "dummyfunction" },
    { 0xA136E9D4, "dummyid" },
    { 0xDCD4FA19, "dummyspawner" },
    { 0x6AB539D0, "dummyspawners" },
    { 0xF7FF2D16, "dummyvar" },
    { 0x83CBB563, "dummyvec" },
    { 0x2FC0B31B, "dump" },
    { 0x7748D4CD, "dump_guard_goto" },
    { 0xF062FFE4, "dump_handle" },
    { 0x92E3181E, "dump_metal_positions" },
    { 0x1CFDC9BC, "dump_models" },
    { 0x8A8A27C3, "dump_passerbys_handle" },
    { 0xCD9DC465, "dump_vehicles" },
    { 0xB9B17FDB, "dumpanimarray" },
    { 0xDA803390, "dumped" },
    { 0x3A4AF6EB, "dumpguard1" },
    { 0xC84387B0, "dumpguard2" },
    { 0xEE460219, "dumpguard3" },
    { 0xAC526626, "dumpguard4" },
    { 0x10B56C85, "dumping" },
    { 0x9A3609EB, "dumpkilllog" },
    { 0x4CE57A3A, "dumps" },
    { 0xBF41DEAC, "dumpsettings" },
    { 0x76A446CB, "dumpster" },
    { 0xD0BBBB28, "dumpster_anims" },
    { 0xD95FF8FC, "dumpster_clip" },
    { 0x6CDBA634, "dumpsterguy" },
    { 0xCAACB336, "dumpsterguy_push_condition1" },
    { 0xA4AA38CD, "dumpsterguy_push_condition2" },
    { 0x7EA7BE64, "dumpsterguy_push_condition3" },
    { 0xDFA293B3, "dumpsterhide" },
    { 0xE49F4289, "dune_flame_tree_guy_death" },
    { 0xB0A00CC9, "dune_flame_tree_guy_strat" },
    { 0x947D671A, "dunes" },
    { 0xE7D9DE87, "dunes_ambush_beat_2_timeout" },
    { 0x250EC15A, "dunes_ambush_beat_3_timeout" },
    { 0x5EFE282D, "dunes_flame_tree" },
    { 0x924C930D, "dunes_flame_tree_achievement" },
    { 0x7440B885, "dunes_flame_tree_debug" },
    { 0xF8979B2B, "dunes_flame_tree_notify" },
    { 0x90240EA9, "dung" },
    { 0x63C0338F, "dunno" },
    { 0xC035D359, "dupe" },
    { 0x260089B4, "dupechecksize" },
    { 0x44D7B75F, "duped" },
    { 0x43ABC67F, "duped_cart_props" },
    { 0x9AEE0510, "dupes" },
    { 0x2D17DF7B, "dupliate" },
    { 0x30B70010, "duplicate" },
    { 0x1C38F9CF, "duplicate_render" },
    { 0x9E20367A, "duplicate_render_bundle" },
    { 0x186E4FF4, "duplicated" },
    { 0x3AD3B220, "duplicaterender" },
    { 0xBCD453EF, "duplicaterender_mgr" },
    { 0x207C9868, "duplicaterenderbundle" },
    { 0x92442EFB, "duplicates" },
    { 0xE6168E91, "duplicating" },
    { 0x23EA4BD8, "duplictes" },
    { 0x7D9D66C0, "duprenderbundelsinited" },
    { 0x441D0B3F, "dups" },
    { 0xD2FAFD4E, "dur" },
    { 0xA6976069, "durango" },
    { 0x62240A71, "duration" },
    { 0x4AE4E2DE, "duration_lerp_thread" },
    { 0x7E177146, "duration_lerp_thread_per_player" },
    { 0x978FEC50, "duration_ms" },
    { 0x35B49033, "duration_seconds" },
    { 0x98FE0D1B, "durationframes" },
    { 0xB0875D69, "durationms" },
    { 0xA7C0E889, "durationmsec" },
    { 0x33D19FEA, "durationofflare" },
    { 0x70CE2F94, "durationofincendiary" },
    { 0x81868C06, "durationoftabun" },
    { 0x9CEEBFD8, "durations" },
    { 0x333E3560, "durationseconds" },
    { 0x18EF2B1E, "duraton" },
    { 0xC7BE2EF2, "during" },
    { 0x206339FF, "durration" },
    { 0x8FDBEE2B, "durret" },
    { 0x5EE8B3D0, "durring" },
    { 0xB5D1E4E1, "dust" },
    { 0x5CC83963, "dust_ent" },
    { 0xEDB89ED3, "dust_ent_1" },
    { 0xA5407687, "dust_interval" },
    { 0x65540CE5, "dust_name" },
    { 0x5489CDC2, "dust_origin" },
    { 0x9E3DE319, "dust_points" },
    { 0xE53B7C66, "dust_points_structs" },
    { 0x94838E0E, "dust_spill" },
    { 0x5D8C98FE, "dust_structs" },
    { 0x83952ACC, "dust_structs_far" },
    { 0x309E5343, "dust_structs_near" },
    { 0x2C360A4C, "dust_tag" },
    { 0x2A0876F7, "dust_time" },
    { 0x48B77CFF, "dustmotes" },
    { 0x7DBFB8D7, "duststorm_local_drone" },
    { 0x08B5CCB9, "duties" },
    { 0x8B7B8E99, "duty" },
    { 0x680E92DC, "duys" },
    { 0x14F658AE, "dvar" },
    { 0x6286D65C, "dvar_check_new" },
    { 0x8D395BF5, "dvar_check_old" },
    { 0xE617F89B, "dvar_init" },
    { 0x48379D54, "dvar_name" },
    { 0xBA1B521E, "dvar_saved" },
    { 0xD0C3786F, "dvar_sentinel_getback_to_volume_epsilon" },
    { 0x9019491D, "dvar_turned_on" },
    { 0x05C1627C, "dvar_value" },
    { 0x1A0C4CF3, "dvar_watcher" },
    { 0x69EAB741, "dvarcurrent" },
    { 0x14EBB25B, "dvarfloatvalue" },
    { 0x6C3ED140, "dvarintvalue" },
    { 0x90C70533, "dvarname" },
    { 0x67542BD1, "dvars" },
    { 0x2A5AD9E9, "dvarstring" },
    { 0x26D02A0B, "dvarval" },
    { 0x6B1F7819, "dvarvalue" },
    { 0x69F993D0, "dvarvalues" },
    { 0xDDF92ADB, "dvec" },
    { 0x75AE704E, "dvxy" },
    { 0x84CD85D6, "dw" },
    { 0x5A23C658, "dw_clipcount" },
    { 0xDA0A0B9C, "dw_name" },
    { 0x9C154235, "dw_weapon" },
    { 0x153E8A77, "dweapon" },
    { 0xF6D4F511, "dx" },
    { 0xEBFFD582, "dxy" },
    { 0xD0D27AA8, "dy" },
    { 0xC226750C, "dydx" },
    { 0x53125B70, "dying" },
    { 0xF2AEC28E, "dying_civs" },
    { 0x30729FE8, "dying_crawl" },
    { 0xC6DA29E6, "dying_crawl_back" },
    { 0x22F2E518, "dying_damage" },
    { 0x31DD8DF6, "dying_ent" },
    { 0xE5B8C161, "dyingcrawl" },
    { 0xEA4498B0, "dyingcrawlaiming" },
    { 0xDC68C6D7, "dyingcrawlbackaim" },
    { 0x6FF4933F, "dyingent" },
    { 0xFB95D3BF, "dyingplayer" },
    { 0xD7A16EC6, "dyn" },
    { 0x7A489A88, "dyn_box" },
    { 0xD77B79EC, "dyn_ent" },
    { 0x510164E8, "dyn_ent_group" },
    { 0x3E23BA83, "dyn_ent_groups" },
    { 0xD3229376, "dyn_ent_modelnames" },
    { 0xF231472E, "dyn_ent_name" },
    { 0x1CAFA08C, "dyn_ent_selected_group" },
    { 0xF9211D94, "dyn_ent_spawn" },
    { 0xB4A21CEF, "dyn_ents" },
    { 0x6CF6708D, "dyn_heli" },
    { 0x1E2B9E95, "dyn_light_glow" },
    { 0x7D356A6C, "dyn_model" },
    { 0x1857B66F, "dyn_models" },
    { 0x6F9822F7, "dyn_planted" },
    { 0xAAB24385, "dyn_pos" },
    { 0x24CAE08C, "dynamic" },
    { 0x990090AE, "dynamic_ad_swap" },
    { 0x34690750, "dynamic_ai_spawner" },
    { 0x8153B07F, "dynamic_ai_spawner_create_enemy_spawner" },
    { 0xAC174EC6, "dynamic_ai_spawner_find_spawners" },
    { 0x55282E01, "dynamic_ai_spawner_init" },
    { 0x686FEA73, "dynamic_ai_spawner_setup_spawner" },
    { 0xBBB00779, "dynamic_alias" },
    { 0xAF4FB42E, "dynamic_dog_threat" },
    { 0x9F5A3E51, "dynamic_player_breath" },
    { 0xA88D77C7, "dynamic_run_ahead_test" },
    { 0xCEED9EB3, "dynamic_run_set" },
    { 0xBA29155A, "dynamic_run_speed" },
    { 0xD2640178, "dynamic_run_speed_stopped" },
    { 0xF451888F, "dynamic_spawn_dummy_model" },
    { 0x1F088176, "dynamic_spawn_hud" },
    { 0x5C2529B2, "dynamic_stubs" },
    { 0xD7EA2956, "dynamically" },
    { 0x3128F5C9, "dynamicpath" },
    { 0x1A9B22C0, "dynamicpaths" },
    { 0x57FD85A4, "dynamite" },
    { 0xF86DC7EB, "dynamite_blown" },
    { 0x4C4CEFFC, "dynamite_failsafe" },
    { 0x099DA584, "dynamite_plant_control" },
    { 0x33133165, "dynamite_planted" },
    { 0x4113B810, "dynamite_ready" },
    { 0xEC2209E9, "dynant" },
    { 0x0DC9468D, "dynent" },
    { 0xE101F754, "dynent_cleanup" },
    { 0x2168B421, "dynent_cleanup_active" },
    { 0x0B10EDB7, "dynent_cleanup_monitor" },
    { 0xE49FA1FF, "dynent_control" },
    { 0x4D69849D, "dynent_count" },
    { 0xB0D62E90, "dynent_groups" },
    { 0x8D3F9839, "dynent_name" },
    { 0x8240671D, "dynent_spawn_points" },
    { 0xAE5BAD0C, "dynents" },
    { 0x42D9E9E3, "dz" },
    { 0x6161E05A, "e" },
    { 0xAC9FB467, "e1" },
    { 0xE33423E1, "e1_alley" },
    { 0x17FE3CE2, "e1_alley_bricks" },
    { 0xF9B77F03, "e1_alley_mg_death" },
    { 0x4667FF46, "e1_approaching_first_rocks" },
    { 0x7E35FC3F, "e1_arty_crew_setup_death" },
    { 0x3BDD9C16, "e1_backtrack_blocking" },
    { 0x98750B52, "e1_banzai_charge" },
    { 0xEB597DC2, "e1_banzai_guys" },
    { 0x08DD22F8, "e1_begin_charge" },
    { 0x75B005BC, "e1_bombers_above_target" },
    { 0x3BAEE15E, "e1_bridge_walker" },
    { 0xDD85A956, "e1_cache_idle1" },
    { 0xB7832EED, "e1_cache_idle2" },
    { 0x2A241D67, "e1_cart_props" },
    { 0xA69862AC, "e1_cave_defenders" },
    { 0xE416AFA9, "e1_cleanup_structs" },
    { 0x54F92F55, "e1_clear" },
    { 0x013AB775, "e1_crouch_by_opening" },
    { 0x6EC15D0B, "e1_drones" },
    { 0x2B9D5F24, "e1_enter_limousine_and_greet" },
    { 0xAFD96829, "e1_entering_house_vo" },
    { 0x2747EF94, "e1_exiting_library_vo" },
    { 0x09A72649, "e1_fake_gun_fire" },
    { 0x2E874987, "e1_far_blur" },
    { 0x4E4A929B, "e1_far_end" },
    { 0x81384AF8, "e1_far_start" },
    { 0x3BD7A8CE, "e1_flameguy_setup" },
    { 0x75CCF19C, "e1_flight_main" },
    { 0xEE7BD83C, "e1_gun_fall" },
    { 0x4537CDBA, "e1_heli" },
    { 0x5B62903D, "e1_helicopter_landing" },
    { 0xF135C291, "e1_helipad_landing" },
    { 0xAB2F20D1, "e1_hudson_flashback" },
    { 0x33E038FD, "e1_hudson_open_door" },
    { 0x5C0EB53C, "e1_huey_takeoff" },
    { 0x74BF4F26, "e1_huey_troops_think" },
    { 0x50D2A5D2, "e1_init_molotov_throwers" },
    { 0xAD20193E, "e1_intro_friendlies_move" },
    { 0x86FEA101, "e1_intro_scene" },
    { 0x97D630A9, "e1_jumpto" },
    { 0x3E72347B, "e1_library_knock_bookshelf_over" },
    { 0x1B6FEF5D, "e1_main" },
    { 0x82ED6280, "e1_mg_guy_banzai" },
    { 0x62AE85B7, "e1_mg_start" },
    { 0xEB7ADC89, "e1_molotov_thrower_think" },
    { 0x2D11EC41, "e1_monitor_cave_defenders" },
    { 0x48599C11, "e1_monitor_cave_defenders2" },
    { 0xC0D54EEE, "e1_more_cave_defenders" },
    { 0xAA9986C1, "e1_mortar_threshold" },
    { 0x8001FC92, "e1_motorcade_arrival" },
    { 0x2496F1BD, "e1_motorcade_peels_out" },
    { 0xA1D04157, "e1_move_vehicles" },
    { 0x08EB16FF, "e1_mowdown_minigun_rumble" },
    { 0x35541A50, "e1_near_blur" },
    { 0x95EF9B96, "e1_near_end" },
    { 0xE0491755, "e1_near_start" },
    { 0xF367AB6A, "e1_objectives" },
    { 0x4B597256, "e1_opening_screen_dialogue" },
    { 0x7795C1E4, "e1_pak2_animate" },
    { 0x473B3C7A, "e1_pak_crew_move" },
    { 0x9DA83D96, "e1_pak_crew_shoot" },
    { 0xC421BD05, "e1_pak_fire" },
    { 0xACB39ED6, "e1_pak_move" },
    { 0xAF3684D2, "e1_pak_shoot" },
    { 0xBF64C281, "e1_patrollers_dead" },
    { 0x46DAA47E, "e1_play_player_vo" },
    { 0xB33BC92F, "e1_player_breaks_stealth_during_pacing" },
    { 0x1B50C0B1, "e1_player_released" },
    { 0x46A2C1C0, "e1_player_released_player_anims" },
    { 0x7D3BF961, "e1_punch_done" },
    { 0x384B5406, "e1_return_nodes" },
    { 0x3262891A, "e1_rez_10_done" },
    { 0x1B2091FF, "e1_ride_lookout1" },
    { 0xA91922C4, "e1_ride_lookout2" },
    { 0xFF889422, "e1_rus_listeners" },
    { 0x644D68CA, "e1_s1_player_wood_idle_scene" },
    { 0xC29C21AF, "e1_s1_player_wood_scene" },
    { 0xC038461B, "e1_s1_pulwar_scene" },
    { 0xB6A82A24, "e1_s1_pulwar_single_scene" },
    { 0x1A3F89AA, "e1_s2_horse_approach" },
    { 0x567BE58A, "e1_s2_lotr_horse_scene" },
    { 0x74B24D19, "e1_s2_lotr_woods_horse_scene" },
    { 0x137988A2, "e1_s2_ride_vignettes" },
    { 0x43AE9ECC, "e1_sarge_mg_dialogue" },
    { 0x9FE8F42C, "e1_second_rocket_barrage" },
    { 0x71309B29, "e1_setup" },
    { 0xD2CD4C34, "e1_shooting_done" },
    { 0x6263D300, "e1_shrink_viewclamp" },
    { 0x0EBD21E8, "e1_smokegrenade_stop" },
    { 0xBE19E208, "e1_smokegrenade_stopthread" },
    { 0x9C56BCC7, "e1_smokethrown" },
    { 0x3C9D4DF3, "e1_smoky_hallway_start" },
    { 0xF4A6A1AB, "e1_spider_redshirt" },
    { 0x936C3C2A, "e1_spider_reinforcements" },
    { 0x519BEF91, "e1_spider_reinforcements_stop" },
    { 0xF29DC849, "e1_spider_surprise" },
    { 0x24819FB6, "e1_spiderhole_guys_assign_color" },
    { 0x8DA206DC, "e1_spiderholes_triggered" },
    { 0xE5D031D2, "e1_start" },
    { 0xDE22E188, "e1_startpoint" },
    { 0x91AF99BF, "e1_stop_cave_defenders" },
    { 0x024C55EF, "e1_stop_cave_defenders2" },
    { 0xBD812143, "e1_straps" },
    { 0x3CD1542B, "e1_tank_into_trap" },
    { 0xDC90874C, "e1_tank_trap" },
    { 0x88FE7DF6, "e1_timing_feedback" },
    { 0x17E86632, "e1_timing_feedback_time" },
    { 0x3174F347, "e1_track_smokegrenade_for_player" },
    { 0x67A0FD5A, "e1_waitfor_player_break_stealth" },
    { 0x9623BC63, "e1_walk_to_limousine" },
    { 0x255D8371, "e1_wall_stumble" },
    { 0x0FFA7747, "e1_watch_for_smoke_intersection" },
    { 0x8102ED0B, "e1_weaver_idle" },
    { 0x4C3CAA6D, "e1_woods_finished" },
    { 0x5C116551, "e1_zhao_finished" },
    { 0xF7CEB518, "e1b_transition_cowbell" },
    { 0x8C1C2B6E, "e1c" },
    { 0xD59D605F, "e1c_close" },
    { 0x245D3331, "e1c_guys" },
    { 0xF119C723, "e1c_items" },
    { 0xFD069A33, "e1c_marine_spawn_mgr_pauser" },
    { 0xAD853007, "e1c_nva_spawner" },
    { 0xCEF59F56, "e1c_putdown_hudson" },
    { 0x131527AC, "e1c_stop_bunker_mortars" },
    { 0x7C69F48A, "e1c_trench_runners_think" },
    { 0x3F55EDE5, "e1origin" },
    { 0x3A98452C, "e2" },
    { 0xE01ECC90, "e2_alley_tanks" },
    { 0xCFFFD42F, "e2_backtrack_blocking" },
    { 0xAD4632CB, "e2_blockofficerb_guys_setup" },
    { 0xF76C52C4, "e2_bridge_banzai_setup" },
    { 0xE764A528, "e2_bridge_banzai_spawnfunc" },
    { 0x70B4E272, "e2_bridge_commentary_setup" },
    { 0xD48D7AEE, "e2_charge_destroy_flaks_vo" },
    { 0xB0F5C4DB, "e2_charge_drones" },
    { 0x6A25D1F5, "e2_charge_tanks_shoot" },
    { 0x964C785B, "e2_check_for_bridge_skip" },
    { 0x80F33E62, "e2_clear" },
    { 0x028103AE, "e2_collectible_corpse" },
    { 0x12612B3E, "e2_dbattle_right_tanks" },
    { 0x44597F5D, "e2_dialogue" },
    { 0xA8A96298, "e2_drone_battle_right_init" },
    { 0xD2167777, "e2_end_bash_door_dialogue" },
    { 0x86ECE5FA, "e2_end_cachedooranim" },
    { 0xCBB7EE1F, "e2_end_playergate" },
    { 0xDB2D3D5D, "e2_end_sarge_bash_door" },
    { 0x7AD12C73, "e2_end_sargedialogue" },
    { 0x7BC57238, "e2_end_setdoorangle" },
    { 0xC3857B23, "e2_escape_gas_dialog" },
    { 0x5D1DF0A1, "e2_exit_bunker_sm_watcher" },
    { 0x282A47ED, "e2_exit_redshirt_vo" },
    { 0xB1DC4A43, "e2_fall_effects" },
    { 0xFE7D9661, "e2_fire_struct" },
    { 0x8D55A5D7, "e2_first_rocket_barrage" },
    { 0xB48EB82D, "e2_flak88_vo" },
    { 0x3208125D, "e2_flamer1_setup" },
    { 0x87647728, "e2_flamer_setup" },
    { 0x878B197B, "e2_flamer_struct_movers" },
    { 0xDEBB2B41, "e2_friendly_fodder" },
    { 0x27C268A1, "e2_grotto_fight" },
    { 0x91A9BBDA, "e2_halftrack_guys_setup" },
    { 0x87237A74, "e2_hall_doors_stumble_objectanim" },
    { 0x8D987A3E, "e2_hall_doors_stumble_playeranim" },
    { 0xCE064249, "e2_hallway_2_roof" },
    { 0xFDD1B08A, "e2_hidesatchels" },
    { 0x676D7004, "e2_init_charge" },
    { 0xFF60F04F, "e2_init_friendly_spawners" },
    { 0x51B0B078, "e2_jumpto" },
    { 0xFB50A523, "e2_lab_dialog" },
    { 0xEC75EF8C, "e2_linefight_a_start" },
    { 0x7BC0A5C0, "e2_linefight_a_stop" },
    { 0x1614C28C, "e2_main" },
    { 0x9F273887, "e2_mean_patrollers_setup" },
    { 0xE2C77A3F, "e2_mortar_looping" },
    { 0x2AE2BF6F, "e2_mortar_looping2" },
    { 0x3AEF98BD, "e2_motorcade_camera_cuts" },
    { 0x376A7C1C, "e2_objective" },
    { 0x2993415F, "e2_objectives" },
    { 0x8B86C942, "e2_objectives_update_flak88" },
    { 0x70DB52D3, "e2_player_jump" },
    { 0x561150F3, "e2_player_skipped_bridge" },
    { 0xBD998A0A, "e2_plaza_amb_left" },
    { 0xF632E52D, "e2_plaza_amb_left_panzer" },
    { 0xF6A5E1D4, "e2_plaza_planes_init" },
    { 0x5DAE00E0, "e2_refresh_satchel_ammo" },
    { 0xA9DC0FB9, "e2_ride_limousine" },
    { 0x8754807D, "e2_roof_clark_jump_dialog" },
    { 0x98F32085, "e2_roof_top" },
    { 0x5862EB32, "e2_roof_weaver_jump_dialog" },
    { 0x185C4FE4, "e2_runout_startidl" },
    { 0x90B96C3B, "e2_s1_base_activity" },
    { 0x823ED91E, "e2_s1_base_props" },
    { 0x7334B1AC, "e2_s1_ride_scenes" },
    { 0xD1968310, "e2_satchel_init" },
    { 0xA8B16493, "e2_second_rocket_barrage" },
    { 0x7BF862B6, "e2_setup" },
    { 0x789591FD, "e2_showsatchels" },
    { 0xAD216453, "e2_sniper_dead" },
    { 0x59A25B50, "e2_stairs_node" },
    { 0x280C92A9, "e2_start" },
    { 0x5DAC5A21, "e2_startpoint" },
    { 0xB3CB1924, "e2_stop_narrow_rushers" },
    { 0xB4904E12, "e2_stumble_on_cart" },
    { 0x9B770D69, "e2_stumble_on_cart_playeranim" },
    { 0x0D615213, "e2_tank_plaza_logic" },
    { 0xDB9BD860, "e2_tank_plaza_shoot" },
    { 0xC6033AE4, "e2_tank_plaza_wait_move" },
    { 0xC52CD525, "e2_track_satchel_for_player" },
    { 0xE8A190AF, "e2_u_cut_end" },
    { 0x930BFE80, "e2_u_cut_exit" },
    { 0xE4B1AA24, "e2_u_cut_exit_spawners" },
    { 0x233ACB39, "e2_up_stairs" },
    { 0x319D6C6C, "e2_watch_for_bunker_intersection" },
    { 0x5006ABCD, "e2a" },
    { 0x76092636, "e2b" },
    { 0x6C9BAA2A, "e2origin" },
    { 0x0A0A94FD, "e2sniper" },
    { 0x609ABF95, "e3" },
    { 0x01472264, "e3_allies_storm_reich" },
    { 0x797C6106, "e3_ambient_panzers" },
    { 0x688AE116, "e3_approachfight" },
    { 0xFAAF9581, "e3_arguing_setup" },
    { 0x378B0BD1, "e3_arguing_setup2" },
    { 0x6905392A, "e3_attackers_setup" },
    { 0x157CBF82, "e3_bb_finder1_setup" },
    { 0x8E1591A5, "e3_bb_finder2_setup" },
    { 0x3F0579FC, "e3_bb_finder3_setup" },
    { 0x30DAC9BF, "e3_bb_runner_setup" },
    { 0x81857271, "e3_brainwash_straps" },
    { 0xA5441922, "e3_brainwash_vignette" },
    { 0xCE6D06AE, "e3_bunker_defenders" },
    { 0x63AA618A, "e3_bunker_interior" },
    { 0x804D7172, "e3_bunkertop_relocategunners" },
    { 0xDF2F2DAC, "e3_bunkertop_spawn" },
    { 0x1E3C01FB, "e3_call_the_jets" },
    { 0xBD2398DF, "e3_clear" },
    { 0x22A089CD, "e3_complete" },
    { 0xFC078E2B, "e3_count_axis_deaths" },
    { 0xF6C19AF6, "e3_courtyard_followers_logic" },
    { 0xF729E7EB, "e3_drone_slowspeed" },
    { 0x96107527, "e3_drones_storm_reich" },
    { 0xFF923C50, "e3_dudes_chatter1_setup" },
    { 0xC1E18C5F, "e3_dudes_chatter2_setup" },
    { 0x2EC7BB8B, "e3_e4" },
    { 0x7C103FE8, "e3_e4_tunnel_exploder" },
    { 0xD684B5F2, "e3_e4_tunnel_vo" },
    { 0x59159EE7, "e3_end" },
    { 0x6250BF8E, "e3_end_snapshot" },
    { 0x4EE2D80D, "e3_entguys_killed" },
    { 0x6114657A, "e3_entguys_woken" },
    { 0xA117DF91, "e3_exit_security" },
    { 0xD93D289A, "e3_extra_mortar" },
    { 0x75972DE9, "e3_extras_break_off_chain" },
    { 0xE23975CC, "e3_extras_break_off_strat" },
    { 0x2C2F5FAB, "e3_extras_break_off_strat_2" },
    { 0xD556506D, "e3_fake_throw_molotov" },
    { 0x7EFF35D3, "e3_fake_throw_molotov_left" },
    { 0x11409CE9, "e3_fightison" },
    { 0x611E7BD6, "e3_forward_comrades" },
    { 0x091B28AF, "e3_friendlies_move_1" },
    { 0x9713B974, "e3_friendlies_move_2" },
    { 0x43995732, "e3_go" },
    { 0x8BB86333, "e3_halftrack_mg_guy" },
    { 0x4D27CEF1, "e3_hallway_dialog" },
    { 0x1A0A3680, "e3_init_bunker_friendlies" },
    { 0xA4E54AB3, "e3_init_defenders" },
    { 0x058A74D7, "e3_init_event" },
    { 0x9DCA7F17, "e3_jumpto" },
    { 0x4E24387D, "e3_killspawners_after_trig" },
    { 0xD2EF5323, "e3_knock_down" },
    { 0xC89EFDC6, "e3_left_treesnipers" },
    { 0x17763725, "e3_lefthand_defenders" },
    { 0x4402C369, "e3_leftrear_linefight_start" },
    { 0x5660ED2F, "e3_main" },
    { 0x46BD572F, "e3_man_01_think" },
    { 0x0AF15984, "e3_man_02_think" },
    { 0x25D328A1, "e3_man_03_think" },
    { 0xDB4E53C8, "e3_metal_detector_beeps" },
    { 0xD05E955F, "e3_monitor_bunker_status" },
    { 0xDE30D03F, "e3_monitor_defenders" },
    { 0x7D32309E, "e3_morgue_doors_objectanim" },
    { 0x088D6BBC, "e3_morgue_doors_playeranim" },
    { 0xD8B4A6B8, "e3_objectives" },
    { 0x11CB177E, "e3_optional_flashback" },
    { 0x0A05D99A, "e3_outro_anim_start" },
    { 0x7F6E3E51, "e3_panzer_guys_setup" },
    { 0xF176F641, "e3_panzer_set_threatgroup" },
    { 0x9B07EE16, "e3_pass_through_security" },
    { 0xA0243EE2, "e3_patrolguy1_setup" },
    { 0x1561CF05, "e3_patrolguy2_setup" },
    { 0xDA72055E, "e3_pillar_fx1n2" },
    { 0xD598801C, "e3_pillar_fx3" },
    { 0xAF9605B3, "e3_pillar_fx4" },
    { 0x89938B4A, "e3_pillar_fx5" },
    { 0x3525E0DB, "e3_play_chernov_death_anim" },
    { 0xAA94D0A4, "e3_player_enters_tunnel" },
    { 0x169E6CB5, "e3_player_reaches_bunker" },
    { 0x6CCB4E71, "e3_playerneartank" },
    { 0x9CB62764, "e3_redshirts_setup" },
    { 0x656DACA6, "e3_reich_germans_init" },
    { 0xE87F6276, "e3_reich_stormers_init" },
    { 0x9076FE70, "e3_righthand_defenders" },
    { 0x28A220C4, "e3_rightrear_linefight_start" },
    { 0x43E38B20, "e3_rightrear_spiderholes_start" },
    { 0x6F288403, "e3_rightrear_spiderholes_triggered" },
    { 0x3669D7C4, "e3_roofguys_setup" },
    { 0x425E40E2, "e3_s1_arena_rocks_scene" },
    { 0x9167DEA1, "e3_s1_chopper_crash_scene" },
    { 0x903203C6, "e3_s1_leave_map_room_scene" },
    { 0x80262D75, "e3_s1_map_room_idle_scene" },
    { 0x48AEC955, "e3_s1_ride_out_scene" },
    { 0x48AAD5CF, "e3_sarge_mortar_reminder" },
    { 0xC74BA820, "e3_save_stairs" },
    { 0xF02B28B7, "e3_security_replace_body_with_full" },
    { 0xF576239F, "e3_setup" },
    { 0xE39E85DA, "e3_snipers_setup" },
    { 0xD28BACC1, "e3_sniping_cover_battle" },
    { 0x77071ECE, "e3_spawn_axis_controller" },
    { 0xDFFFFA11, "e3_spawn_group" },
    { 0x7FEAE462, "e3_spawn_mgr_1" },
    { 0xF0A36E47, "e3_spawner_wave_flow" },
    { 0x606FFDE8, "e3_spawner_wave_on" },
    { 0x48D58A5D, "e3_spawner_wave_on_light" },
    { 0x82A48873, "e3_stairs_friendly_moveup" },
    { 0x646780C1, "e3_stairs_node" },
    { 0x9C741B5B, "e3_stairs_spawner" },
    { 0x69A7BABA, "e3_stairwell_dialog" },
    { 0x02DEB90C, "e3_start" },
    { 0x8ACB90E5, "e3_start_trigger" },
    { 0x19C73A2E, "e3_startpoint" },
    { 0x5B231153, "e3_startpoint_bash" },
    { 0xA919E0AB, "e3_stop_lower_defenders" },
    { 0x35F82E11, "e3_t55_tank" },
    { 0xED5C7001, "e3_t55_tank_path" },
    { 0xC05CC024, "e3_tank_destroyed" },
    { 0xF461F829, "e3_tank_dialogue" },
    { 0x3F653632, "e3_tank_explode" },
    { 0x2A533A1B, "e3_tank_fire" },
    { 0x9B8F9ADD, "e3_tankfollowers" },
    { 0x7EA4EAE0, "e3_tanks_init" },
    { 0x465BBB2C, "e3_tankstart" },
    { 0xCDB2A897, "e3_threat_stuff" },
    { 0xBB5C995E, "e3_transition_dialogue" },
    { 0xFC586009, "e3_treesniper_spawn" },
    { 0xA04F6847, "e3_trigger_when_guys_dead" },
    { 0x67857440, "e3_trigsoff" },
    { 0x4D7D113D, "e3_tunnels_radio" },
    { 0xF5C54E16, "e3_tunnels_radio_takedamage" },
    { 0x6D4B6B71, "e3_tunnels_spawn" },
    { 0xE7209086, "e3_turrets_ignoregoals_false" },
    { 0x385B6BED, "e3_turrets_ignoregoals_true" },
    { 0x96238169, "e3_wait_begin_ending" },
    { 0xD94DA9CE, "e3_which_way_dialog" },
    { 0xDC8FDE27, "e3_window_breach_dialog" },
    { 0x1CE5EFDD, "e3b" },
    { 0x79E4676F, "e3b_jumpto" },
    { 0xEE93505A, "e4" },
    { 0xB77771A0, "e4_alley" },
    { 0xD7C7E0CF, "e4_antinov_damage_mod" },
    { 0xF48E9A34, "e4_antinov_defend_squad_management" },
    { 0xE14A28A0, "e4_antinov_health_monitor" },
    { 0xE9020A0D, "e4_armory_siren" },
    { 0xB7CBF878, "e4_board_elevator" },
    { 0x5EA31E3A, "e4_checkin_at_desk" },
    { 0x723BDDCB, "e4_claw_01_think" },
    { 0xB0CD0C50, "e4_claw_02_think" },
    { 0x7D4887B4, "e4_clear" },
    { 0x453B678B, "e4_covering_fire_guys_logic" },
    { 0xFB50C31A, "e4_drop_ready" },
    { 0x7C49C395, "e4_droppin_napalm" },
    { 0xC3F1487C, "e4_e4b_transition_force_clean" },
    { 0xAE50BD3F, "e4_floor1_stairs" },
    { 0x6CF95C1D, "e4_halftrack_guy_setup" },
    { 0xB08E4621, "e4_hallway_runner_logic" },
    { 0xE1D5DC5E, "e4_jumpto" },
    { 0x86F4CFCD, "e4_knock_over_shelf" },
    { 0x1FA90406, "e4_main" },
    { 0x6AC68CE7, "e4_officer_setup" },
    { 0x0F711DCF, "e4_optional_flashback" },
    { 0x0110795F, "e4_phantoms" },
    { 0xE070E71F, "e4_phantoms_path" },
    { 0xC63E7E7D, "e4_player_flank" },
    { 0x5E42047E, "e4_player_through_door_ai_management" },
    { 0x6BF5A19A, "e4_redshirt" },
    { 0xFAB0F217, "e4_rolling_door_closing" },
    { 0x6734677B, "e4_rusher_think" },
    { 0x62A53338, "e4_s1_binoc_scene" },
    { 0x6AC05C50, "e4_s1_return_base_charge_scene" },
    { 0x6168BB22, "e4_s1_return_base_charge_scene_no_player" },
    { 0x58DA68C1, "e4_s1_return_base_lineup_scene" },
    { 0xE292105E, "e4_s1_return_base_lineup_single_scene" },
    { 0x87B72F99, "e4_s5_player_and_horse_fall" },
    { 0x90BA95A8, "e4_s5_tank_fall" },
    { 0xADD87208, "e4_s6_player_grabs_on_tank_scene" },
    { 0xDA8E62AA, "e4_s6_strangle_scene" },
    { 0x9C52428E, "e4_s6_tank_fight" },
    { 0xA6F40607, "e4_s6_tank_fight_scene" },
    { 0xB5ECFD3C, "e4_setup" },
    { 0x61095F38, "e4_spawn_functions" },
    { 0xD688F783, "e4_stealth_cleared" },
    { 0x7336B992, "e4_total_phantoms" },
    { 0x76EE72C1, "e4_walk_through_pool" },
    { 0xD6B5E6E3, "e4_walk_to_elevator" },
    { 0x9B814EB2, "e4_wall_stumble" },
    { 0x9784BDE2, "e4_weapon_cache_radio" },
    { 0x8369A482, "e4_weld_upstairs_attacker_logic" },
    { 0x46EB835D, "e4_welding_timer" },
    { 0x4CB63EEF, "e4_welding_vault_door_movement" },
    { 0x73A14BB6, "e4_wep_cache_vo" },
    { 0x5EF4A17C, "e4b" },
    { 0x0788907D, "e4b_bunker_ents" },
    { 0x2C857BA9, "e4b_e5_prevent_backtrack" },
    { 0x3A78FBF2, "e4b_line_b_taken" },
    { 0x87FB56A5, "e4b_line_c_start_guys" },
    { 0xB9A45AEC, "e4b_mmg_guy" },
    { 0xFA034559, "e4b_start" },
    { 0xE4F1B884, "e4b_start_guys" },
    { 0x84F71BE5, "e4c" },
    { 0xF926EEF2, "e4c_enter_bunker_radio" },
    { 0x9588C2EF, "e4c_woods_jam" },
    { 0x1495CAC3, "e5" },
    { 0x65F67FDE, "e5_air_interval" },
    { 0xE9F8D20D, "e5_base_path" },
    { 0xDF200079, "e5_bomber_wave" },
    { 0x1213C569, "e5_clear" },
    { 0x35B62DB2, "e5_door" },
    { 0xF2B8EB9E, "e5_elevator_descends" },
    { 0xEF1ACF11, "e5_halftrack_mg_guy" },
    { 0x55088BF2, "e5_holeguys_setup" },
    { 0x853349B0, "e5_jeep_tanks" },
    { 0xF74B2B75, "e5_jumpto" },
    { 0xBCA5792A, "e5_kill_trigs" },
    { 0xFE6B33B9, "e5_main" },
    { 0x3B794A7B, "e5_player_slide" },
    { 0xE7C9F7A4, "e5_playerdown_fakenades" },
    { 0xC48E43FC, "e5_radio_loc" },
    { 0x284530CB, "e5_radio_vo" },
    { 0x76492AE1, "e5_rubble_start" },
    { 0x205D4EAC, "e5_s1_celebration_riders_scene" },
    { 0x153080B2, "e5_s1_celebration_scene" },
    { 0x083ADAC1, "e5_s1_walk_in_scene" },
    { 0x6995CBD1, "e5_s2_interrogation" },
    { 0xDA7291DF, "e5_s2_interrogation_loop_scene" },
    { 0xA9A1CEA5, "e5_s2_interrogation_move2shoot_scene" },
    { 0xA0E9CB85, "e5_s2_interrogation_punch_scene" },
    { 0xECB7B0B2, "e5_s2_interrogation_shoot_v1_scene" },
    { 0x40C5997D, "e5_s2_interrogation_shoot_v2_scene" },
    { 0x243B1BFB, "e5_s4_beatdown_scene" },
    { 0x3E92F1E5, "e5_setup" },
    { 0x8506B7A6, "e5_tank" },
    { 0xB92E4F3E, "e5_tanks_dead" },
    { 0xB687DB0D, "e5b_jumpto" },
    { 0x558F9021, "e5saidamrun" },
    { 0x20F44E58, "e5saidonmove" },
    { 0x349CF98D, "e5saidrunning" },
    { 0xA28E5B88, "e6" },
    { 0x2CD30746, "e6_clear" },
    { 0xB50D9815, "e6_enter_warroom" },
    { 0x3C1EA23D, "e6_exit_warroom" },
    { 0x9B6119F4, "e6_jumpto" },
    { 0x7039D858, "e6_main" },
    { 0x97654ADA, "e6_open_elevator_doors" },
    { 0x061812E1, "e6_s2_deserted_bush_anim_scene" },
    { 0x116AFD5F, "e6_s2_deserted_part1_scene" },
    { 0x1446BD68, "e6_s2_deserted_part2_scene" },
    { 0x5C09B985, "e6_s2_deserted_part3_scene" },
    { 0x81508B7B, "e6_s2_deserted_single_scene" },
    { 0xEE620F22, "e6_s2_offtruck_scene" },
    { 0xCE2280B0, "e6_s2_ontruck_1_scene" },
    { 0xA88C3547, "e6_s2_ontruck_2_scene" },
    { 0x9BB4EC95, "e6_s2_ontruck_trucks_scene" },
    { 0x3B1478C2, "e6_setup" },
    { 0xA15584B8, "e6_walk_down_stairs" },
    { 0xC890D5F1, "e7" },
    { 0x28D7DB72, "e7_bike_crash_at_end_node" },
    { 0x0F43CF79, "e7_bike_exit_troops_trucks" },
    { 0x898041AB, "e7_bike_prompts" },
    { 0xC037A9E3, "e7_bike_prompts_shot_flag" },
    { 0xA7CDC383, "e7_bloom_effect" },
    { 0x11E27064, "e7_bridge_guy_logic" },
    { 0x3088AE8F, "e7_bridge_quad_50_attacks" },
    { 0xE50EEFFC, "e7_bridge_repel_guys_logic" },
    { 0x18B503D3, "e7_bridge_rpg_at_player" },
    { 0x59E61A05, "e7_chopper" },
    { 0xBEA73542, "e7_clark_jump" },
    { 0xAB353FD0, "e7_cleanup" },
    { 0xAB73B3A7, "e7_debug_hud" },
    { 0xA7628715, "e7_discuss_the_mission" },
    { 0xF449D932, "e7_enemy_bike_rider_logic" },
    { 0x94629F50, "e7_enemy_motorycle_logic" },
    { 0xDEAFC255, "e7_enter_briefing" },
    { 0x3799367C, "e7_final_fall" },
    { 0x76B53912, "e7_gaz_chaser_logic" },
    { 0x2FB80BAE, "e7_gaz_rail_logic" },
    { 0x04B13CC9, "e7_init_e7_flags" },
    { 0x21B23AAA, "e7_intro" },
    { 0x1C0A316A, "e7_intro_bike" },
    { 0x40718636, "e7_intro_player" },
    { 0x80DF0CD3, "e7_jumpto" },
    { 0x6A8F9A7A, "e7_lerp_fov_with_speed" },
    { 0x6D184D2B, "e7_main" },
    { 0x893E23ED, "e7_nothreat_bikes_logic" },
    { 0x1EBFCE94, "e7_play_player_vo" },
    { 0xAD93DBAF, "e7_player_bike_setup" },
    { 0x8DA292FF, "e7_player_bike_to_truck" },
    { 0xAC68F867, "e7_player_damage_control" },
    { 0x942A8E29, "e7_player_exit_fail" },
    { 0x63F611AE, "e7_player_rez_speed_monitor" },
    { 0xA6D0969D, "e7_player_speed_fail_logic" },
    { 0x4417913C, "e7_power_pole_fall" },
    { 0x1CFE1C1B, "e7_pull_tarp" },
    { 0xCE639ADC, "e7_rail_bridge_guys_logic" },
    { 0xF47FF050, "e7_rail_trigger_activation" },
    { 0xE8F57039, "e7_rez_bike" },
    { 0xA85ABD0E, "e7_rez_bike_logic" },
    { 0xB67796B5, "e7_rez_truck_setup" },
    { 0x74A92B81, "e7_reznovs_demise" },
    { 0x3E2C26BC, "e7_rider_crash" },
    { 0x1D313D41, "e7_roadside_guys_logic" },
    { 0x6AD249B7, "e7_scripted_fx" },
    { 0x7BEE7F1B, "e7_setup" },
    { 0x1FCE6E8B, "e7_slowmo_manager" },
    { 0xB3345457, "e7_spawn_functions" },
    { 0x75CF7E97, "e7_spetsnaz_done" },
    { 0x919DEBD5, "e7_tracking_player" },
    { 0x35B6D052, "e7_train" },
    { 0x6BAFB04F, "e7_vehicle_damage_logic" },
    { 0x6CC94F59, "e7_vo" },
    { 0x3C86D827, "e7_warehouse_breach" },
    { 0x0C615018, "e7_warehouse_breachguys_logic" },
    { 0x5D6A3D79, "e7_wave_spawning" },
    { 0xD24F1EB3, "e7_window_bullet" },
    { 0xE53DB2CC, "e7_window_exit_enemy_management" },
    { 0x4ACEF878, "e8_aqua_room_trigger" },
    { 0x1EF37620, "e8_aquarium_rpg_killers_trigger" },
    { 0x8AD9A79E, "e8_bw_fov_in" },
    { 0xEDD08318, "e8_civs_staircase_triggered" },
    { 0x5058FFBC, "e8_complete" },
    { 0x574565A2, "e8_end_rpg_killer" },
    { 0x0B090195, "e8_enter_mall_part2_trigger" },
    { 0x0AC47707, "e8_enter_mall_trigger" },
    { 0x2BB49150, "e8_enter_mall_vo" },
    { 0xE80E3C64, "e8_flanking_helicopters" },
    { 0x7CF83BA1, "e8_hudson_vignette" },
    { 0x55659F27, "e8_hudson_vignette_playeranims" },
    { 0xFE2176BA, "e8_intro_civilians" },
    { 0x678C7138, "e8_intro_guard_anims" },
    { 0xBF441B9F, "e8_kill_all_enemy_at_end_of_mall" },
    { 0x8129CAF2, "e8_mall_low_left_at_castle_trigger" },
    { 0x725DAB36, "e8_mall_low_left_mid_trigger" },
    { 0x86795E65, "e8_mall_low_right_at_castle_trigger" },
    { 0x49190641, "e8_mall_low_right_mid_trigger" },
    { 0x41ECB630, "e8_mall_rappel_guys_on_bridge_trigger" },
    { 0x390ACCEE, "e8_mall_ul_approach_aqua_trigger" },
    { 0x4176185C, "e8_mall_ul_mid_point_trigger" },
    { 0x44891189, "e8_mall_ul_reached_staircase_trigger" },
    { 0xEC67C3BA, "e8_mall_ul_staircase_trigger" },
    { 0x4FF2DC2E, "e8_mall_upper_left_wave1_trigger" },
    { 0x6BA3F8CD, "e8_mall_upper_right_wave1_trigger" },
    { 0x5AD41FB2, "e8_mall_upper_right_wave2_trigger" },
    { 0x4D4F959C, "e8_mall_ur_approach_aqua_trigger" },
    { 0xFD0671F8, "e8_mall_ur_approach_castle_trigger" },
    { 0x2565E266, "e8_mall_ur_mid_point_trigger" },
    { 0xF6650BDC, "e8_mall_ur_reached_sniper_castle_trigger" },
    { 0x876F6ADE, "e8_punch_fov_out" },
    { 0xCDBAC9D1, "e8_reznov_brainwash" },
    { 0xD4FB152C, "e8_setup_wounded_civs_groupa" },
    { 0x210009FE, "e8_setup_wounded_civs_groupc" },
    { 0x125FC64F, "e8_snd_number_loop" },
    { 0x7BD31612, "e8_snd_number_wait" },
    { 0x2343B01E, "e8_start_bridge_left_trigger" },
    { 0x66A2D85B, "e8_start_bridge_right_trigger" },
    { 0xA4DBAA46, "e8_start_left_staircase_trigger" },
    { 0x0A923D8F, "e8_start_right_staircase_trigger" },
    { 0xB68A0574, "e8_startup_civ_anims" },
    { 0xC8463A80, "e8_str_cleanup_civs_groupa" },
    { 0xFC27E82F, "e8_the_end_enemy_spawners" },
    { 0xF1EF211A, "e8_thread_a1" },
    { 0xCBECA6B1, "e8_thread_a2" },
    { 0xA5EA2C48, "e8_thread_a3" },
    { 0xDD62A1FE, "e8_wave_spawning" },
    { 0x7C8BE11F, "e9" },
    { 0x4FAA577D, "e90" },
    { 0x6F80AD9C, "e9_balcony_blocker_trigger" },
    { 0x81244E78, "e9_balcony_blowup_ledge_fall_anim" },
    { 0x9A021830, "e9_balcony_blowup_stairs_stumble_anim" },
    { 0x8A1F0B27, "e9_br_table_zoom_in" },
    { 0xDF4A39E8, "e9_brainwash_vignette" },
    { 0x22611C59, "e9_bridge_runners" },
    { 0x82044A32, "e9_bunker_enemy_management" },
    { 0x6941E9E5, "e9_bunker_right_begin_trigger" },
    { 0xBA86E9B5, "e9_civ_bridge_to_stairs" },
    { 0xC3029817, "e9_civ_left_end_trigger" },
    { 0xB2FA54D8, "e9_civ_left_wave1_trigger" },
    { 0x204B8F17, "e9_civ_middle_end_trigger" },
    { 0x11C23EF4, "e9_civ_right_end_trigger" },
    { 0x119CA0B8, "e9_civ_right_wave2_trigger" },
    { 0xF43D6299, "e9_civ_rocks_right_trigger" },
    { 0xC1600D7B, "e9_civilian_spawning" },
    { 0xD7FF4F64, "e9_civs_left_pre_metal_storm_trigger" },
    { 0xABF12E82, "e9_cliffs_trigger" },
    { 0x7BE0EAEF, "e9_keep_player_busy_at_start_trigger" },
    { 0x8DF6AB8A, "e9_left_staircase_climbing_trigger" },
    { 0x5B93982C, "e9_left_upper_tunnel_spawner" },
    { 0xF038EFFB, "e9_manager_upper_left_stairs" },
    { 0xA5836E92, "e9_player_in_pool_area" },
    { 0x17ACBB95, "e9_player_reaches_bottom_left_stairs_trigger" },
    { 0x2B8196BF, "e9_player_wabo_paco" },
    { 0x16EBE6DF, "e9_post_ms_background_enemy_rusher_control" },
    { 0xAC0351F2, "e9_post_ms_left_begin_trigger" },
    { 0xFFD5234F, "e9_post_ms_right_begin_trigger" },
    { 0xCF93EEB7, "e9_rusalka_zoom_in" },
    { 0xB0EA90E9, "e9_setup_balcony_explosion_blocker_triggers" },
    { 0xB270D12F, "e9_short_waco_paco" },
    { 0xF245048B, "e9_skipto_animation" },
    { 0x6AA2E03E, "e9_stairs_by_blockage_trigger" },
    { 0x17A17CFD, "e9_start_balcony_death_event" },
    { 0xE5356E45, "e9_start_player_rushers" },
    { 0xFD5A3465, "e9_steiner_emit_numbers" },
    { 0x093085A7, "e9_sundeck_west_rpg" },
    { 0x3EF57A03, "e9_wave_spawning" },
    { 0x3EF9E5E5, "e_01_apc_digbat_alley" },
    { 0xC1C5BCB1, "e_01_army_street_push" },
    { 0x7820CAFC, "e_01_fire_building_civs" },
    { 0x993F755A, "e_01_left_path" },
    { 0xA30C09BF, "e_01_left_path_cleanup" },
    { 0x79DF2D1C, "e_01_overlook" },
    { 0xA95ADAA3, "e_01_overlook_advance" },
    { 0xF0507D2A, "e_01_overlook_apc_think" },
    { 0x7646E470, "e_01_overlook_attach_strobe" },
    { 0x7047497A, "e_01_overlook_detach_strobe" },
    { 0x8702AA2F, "e_02_apache_attack" },
    { 0xA7BC0D11, "e_02_gazebo_destruction" },
    { 0x1EF54613, "e_02_heli_think" },
    { 0xAFDC6547, "e_03_alley_jeep" },
    { 0x38F021B6, "e_03_building_destroy" },
    { 0x9087EDE9, "e_04_apc_wall_crash" },
    { 0x66B4E83A, "e_04_rooftop_ambience" },
    { 0xCBA3949E, "e_07_delete_on_goal" },
    { 0x6CC47A32, "e_07_mg_nest" },
    { 0xAA5826D7, "e_07_rooftop_ambience" },
    { 0xD7B8A1D2, "e_10_zpu_burst_fire" },
    { 0x9767A4FE, "e_10_zpu_challenge_watch" },
    { 0x0F894C49, "e_10_zpu_think" },
    { 0xFC9E63F2, "e_11_sniper_shot" },
    { 0x42190A26, "e_11_sniper_think" },
    { 0x6B1BE046, "e_11_snipers" },
    { 0xE014D64A, "e_12_building_fire" },
    { 0xAECF2A62, "e_13_apc_passenger_think" },
    { 0xD8C8B81F, "e_13_apc_trigger_watch" },
    { 0x90F84C33, "e_15_dumpster_push" },
    { 0x5F08CEAD, "e_16_claymore_alley" },
    { 0x9D6CF535, "e_16_claymore_detonation" },
    { 0x9B0F80AB, "e_16_detonate" },
    { 0xECA7850B, "e_16_holding_claymore" },
    { 0x0D99B3F9, "e_16_satchel_damage" },
    { 0x9BDD7703, "e_16_spawn_claymore" },
    { 0xA91027C8, "e_17_brute_force" },
    { 0x347DA0FD, "e_18_lock_breaker" },
    { 0x80CE6320, "e_18_lock_breaker_door" },
    { 0x5BA57045, "e_18_lock_breaker_reward" },
    { 0x3F1DE57D, "e_19_attach" },
    { 0xD95771FD, "e_19_left_side" },
    { 0x36E2A73E, "e_19_molotov_digbat" },
    { 0xE9CF3414, "e_19_molotov_digbat_alley" },
    { 0xF818328A, "e_19_molotov_triggered" },
    { 0x797109D6, "e_19_right_side" },
    { 0x0D28C96A, "e_19_shot" },
    { 0xD4C200FD, "e_20_scared_couple" },
    { 0x45CA6807, "e_21_store_rummage" },
    { 0x46757DA3, "e_22_woman_beating" },
    { 0x8BD65CFD, "e_23_parking_lot" },
    { 0xC525E8D3, "e_ac130" },
    { 0xD08DB518, "e_actor" },
    { 0x817941A2, "e_add" },
    { 0x777CAD3A, "e_afterlife_corpse" },
    { 0xF4B1D057, "e_ai" },
    { 0xB3221D7A, "e_ai_passenger" },
    { 0x030EEA4B, "e_ai_rpg" },
    { 0x3991A614, "e_alarm_sound" },
    { 0x6609C808, "e_align" },
    { 0x374E7E4E, "e_align_obj" },
    { 0xDEE1C358, "e_ammo_cache" },
    { 0x087348C6, "e_angled" },
    { 0xB6106C7F, "e_apache" },
    { 0x1E8BEF32, "e_apache_barrel" },
    { 0xC9092F60, "e_apache_checkpoint_target" },
    { 0x2C33C1F7, "e_archway_collision" },
    { 0xE90F8373, "e_archway_drone_target" },
    { 0xE96D309A, "e_area" },
    { 0xBD11E107, "e_arlington" },
    { 0x593CAAFD, "e_armory_doors" },
    { 0x24BC4372, "e_arms_attacker" },
    { 0xCD78FC38, "e_array" },
    { 0x3A93455D, "e_asd_hallway_clip" },
    { 0xB4033A82, "e_asd_target_origin" },
    { 0x06784A7C, "e_asd_turret_target" },
    { 0xC1E60DFF, "e_asset" },
    { 0x82CC1C10, "e_attachpoint" },
    { 0x677B3E78, "e_attacker" },
    { 0x8444458D, "e_attacking_player" },
    { 0x894DB75A, "e_axis" },
    { 0x51C90977, "e_axis_in_cache" },
    { 0x84075D09, "e_balcony_look_target" },
    { 0xDCE3BFBC, "e_balcony_lookat" },
    { 0x147CC747, "e_ball_fx" },
    { 0x44118079, "e_base_pos" },
    { 0x499564A2, "e_base_target" },
    { 0xEEF681DE, "e_bdog_back_volume" },
    { 0x2E49F0E2, "e_bdog_front_volume_1" },
    { 0x08477679, "e_bdog_front_volume_2" },
    { 0x1873F8C3, "e_bdog_move_back" },
    { 0x2A6582F2, "e_beartrap" },
    { 0xC967A7F2, "e_beartrap_closest" },
    { 0x3068E92D, "e_best_target" },
    { 0x330D4B72, "e_billboard" },
    { 0x840EFFEF, "e_billy" },
    { 0x227669FE, "e_binoc" },
    { 0xD3A9C3BC, "e_blockade_target" },
    { 0xD5E880E2, "e_blockage_clip" },
    { 0x37B32D34, "e_blood_pool" },
    { 0x886CA8C3, "e_boat" },
    { 0xFB1D7841, "e_body" },
    { 0xC1161421, "e_bomb2" },
    { 0x0BCC9FED, "e_bottle" },
    { 0xB0909311, "e_bouncer" },
    { 0xD893832D, "e_bowl" },
    { 0x0AAAE69C, "e_box" },
    { 0x28D0D02F, "e_bp_objective" },
    { 0x898CAAAC, "e_brick" },
    { 0x8DE6057E, "e_bridge" },
    { 0xE6267456, "e_bridge_target" },
    { 0x2B73A923, "e_brush" },
    { 0xB12B8838, "e_buffel_tip_blocker" },
    { 0x2AD4CE59, "e_bus" },
    { 0xDE65E605, "e_bus_escape" },
    { 0x6B58F5B1, "e_cabana" },
    { 0xB2B6A505, "e_cache" },
    { 0x9012DD1E, "e_cam" },
    { 0x351745FC, "e_camera" },
    { 0x429BE292, "e_camera_mount" },
    { 0xCEB50578, "e_camera_sound" },
    { 0x6237DB4F, "e_camera_two" },
    { 0x40DC9D85, "e_can_switch_trigger" },
    { 0x05DE38E4, "e_capture_link" },
    { 0x021A4C59, "e_car" },
    { 0x5FA9D8EF, "e_cart" },
    { 0x836E9E7C, "e_cartel" },
    { 0x15617DAB, "e_catch_trig" },
    { 0xF443471A, "e_celerium_device" },
    { 0x433BA5BD, "e_celerium_door_left_clip" },
    { 0x2162694A, "e_celerium_door_left_rear_clip" },
    { 0xAF48C7E4, "e_celerium_door_right_clip" },
    { 0x0D8DA579, "e_celerium_door_right_rear_clip" },
    { 0xEE1F84CF, "e_celerium_shield" },
    { 0xF2B334E1, "e_celerium_shield_glow" },
    { 0xE252AC96, "e_celerium_shield_screen" },
    { 0x063A5260, "e_cessna_target" },
    { 0x0CCA4E99, "e_chaff" },
    { 0x0F8FC9D6, "e_character" },
    { 0xAD931ECF, "e_check" },
    { 0x9966D810, "e_check_point" },
    { 0xA3DDAA95, "e_checkme" },
    { 0x3B9D69BA, "e_chopper" },
    { 0x391935BD, "e_chugabud_corpse" },
    { 0x0BE1DE0B, "e_chunks" },
    { 0xFC5473EF, "e_cia_card" },
    { 0xFBEFFD53, "e_cigar_box" },
    { 0xD10A8335, "e_civ" },
    { 0xBEFFD105, "e_claw_turret" },
    { 0xC030D4BF, "e_cleanup" },
    { 0x5E66A130, "e_cleanup_volume" },
    { 0x938354CB, "e_clear_street1" },
    { 0x0D874DCF, "e_clip" },
    { 0x5524A904, "e_clip1" },
    { 0xA1299DD6, "e_clip3" },
    { 0x46ABCE68, "e_clip_clean_room_door" },
    { 0xF1059651, "e_clip_linkto" },
    { 0x4EC85D4A, "e_closest" },
    { 0x4EB49A16, "e_closest_player" },
    { 0x6454CF0B, "e_closest_shooter" },
    { 0xB3F1EA32, "e_closest_target" },
    { 0x62EB07C9, "e_closest_weapon" },
    { 0x2A42C45D, "e_club_elevator_left_door" },
    { 0x776F50B0, "e_club_elevator_right_door" },
    { 0x5E4DF0EF, "e_cocaine" },
    { 0xE0DF394F, "e_coke" },
    { 0x02783E81, "e_collectable" },
    { 0xCD35B76C, "e_collide_trigger" },
    { 0x7925D66F, "e_collision" },
    { 0x694E22E1, "e_container_keypad" },
    { 0xD31CD672, "e_control_room_target" },
    { 0x5D5EF481, "e_corpse" },
    { 0xA96F7511, "e_corpse_location" },
    { 0x231EFF45, "e_cougar_window" },
    { 0x49EBE6E8, "e_courtyard_drone_light_target" },
    { 0x90993E64, "e_crafter" },
    { 0x1DA6FD34, "e_crane" },
    { 0xC3AD4E38, "e_crash_effect_ent" },
    { 0x9EA7D90A, "e_cratercharge_obj" },
    { 0x40B41114, "e_crawl_back_guy" },
    { 0x27582D3B, "e_curr_area" },
    { 0xA4970714, "e_current" },
    { 0x77FA3B17, "e_current_pos" },
    { 0x0578AC24, "e_current_target" },
    { 0xE3E180D2, "e_current_user" },
    { 0x56A50043, "e_current_wall" },
    { 0x0EF9C76B, "e_damage_trigger" },
    { 0xC8DB566C, "e_dancer" },
    { 0x11E1878D, "e_danger_zone" },
    { 0x939A7C6E, "e_dart" },
    { 0xAFDAC44E, "e_ddm_1" },
    { 0x89D849E5, "e_ddm_2" },
    { 0xD5C46508, "e_ddm_machine_1" },
    { 0x47CBD443, "e_ddm_machine_2" },
    { 0x14ACD2CC, "e_dead_civ" },
    { 0x48B3274C, "e_debris" },
    { 0xB2704270, "e_defend_door_03l" },
    { 0x9DDF0369, "e_defend_door_03l_clip" },
    { 0x666B4D9E, "e_defend_door_03r" },
    { 0x5C023A0B, "e_defend_door_03r_clip" },
    { 0x6BFB6DA6, "e_defend_door_3l" },
    { 0x8815565C, "e_defined" },
    { 0x421779F0, "e_delivery_trigger" },
    { 0x2D13D22C, "e_dempsey" },
    { 0xDEC5DB15, "e_dest" },
    { 0x06A147D3, "e_destructible" },
    { 0xCF84718E, "e_dialog_pos" },
    { 0x37A98BA4, "e_digbat" },
    { 0x88D66198, "e_digbat_1" },
    { 0xFADDD0D3, "e_digbat_2" },
    { 0xCEC04A72, "e_disable_trigger" },
    { 0x4768A576, "e_disc" },
    { 0xDC1D22F1, "e_dog" },
    { 0x8D61F350, "e_dog_spawner" },
    { 0xE5B85E7E, "e_dongle" },
    { 0x0F2C7E89, "e_door" },
    { 0x2591C392, "e_door1" },
    { 0xFF8F4929, "e_door2" },
    { 0xE09DAB06, "e_door_clip" },
    { 0x2DD3E20A, "e_door_coll" },
    { 0x8C7E827F, "e_door_left" },
    { 0x5548791A, "e_door_right" },
    { 0xEDB02579, "e_door_target_ent" },
    { 0x325F12BD, "e_drone" },
    { 0xA400739C, "e_drone_light_target" },
    { 0x264EC63C, "e_dyn_path" },
    { 0xA91CA8F1, "e_dynent" },
    { 0x701982B6, "e_e3_left_door" },
    { 0x5718E3B9, "e_e3_right_door" },
    { 0x86B1C6C3, "e_elevator" },
    { 0x3001A887, "e_elevator_bottom_gate" },
    { 0x6D2E3FF4, "e_elevator_clip" },
    { 0x47EB21B2, "e_elevator_door" },
    { 0xD1681748, "e_elevator_mason" },
    { 0x459410C5, "e_elevator_model" },
    { 0x3156FA63, "e_elevator_move_target" },
    { 0x1DB86FDA, "e_elevator_regroup" },
    { 0x10425F39, "e_elevator_vtol" },
    { 0xEC74DEC0, "e_end" },
    { 0xE98B4E9B, "e_enemy" },
    { 0x100F3800, "e_enemy_ai" },
    { 0x4C9C8550, "e_ent" },
    { 0x15F3DE12, "e_ent2" },
    { 0x0315E324, "e_entity" },
    { 0xEB156161, "e_escape_blast_doors" },
    { 0xE7ADDEC1, "e_escape_volume" },
    { 0x63328890, "e_executioner" },
    { 0x5E97D615, "e_executioner_volume" },
    { 0x3402AB14, "e_exit_door" },
    { 0x06F44119, "e_exit_door_collision" },
    { 0xD4B22ADC, "e_exterior_lift_red_light" },
    { 0xCABB98CA, "e_exterior_lift_scanner" },
    { 0x7B2C375D, "e_extra_cam" },
    { 0x19B11E7D, "e_extraction_point_1" },
    { 0x3FB398E6, "e_extraction_point_2" },
    { 0xC5B310A6, "e_fake" },
    { 0x9726248E, "e_fake_beartrap" },
    { 0x07363D1F, "e_fake_elevator" },
    { 0xFF0AAE2C, "e_fake_guard" },
    { 0x3D3F230C, "e_fake_vo" },
    { 0x203D6B6C, "e_fallback_volume" },
    { 0x0E1FA718, "e_fallback_volume_control_room_middle" },
    { 0x1A287389, "e_fallback_volume_control_room_rear" },
    { 0x5606C964, "e_fan" },
    { 0x698CBB2F, "e_farid" },
    { 0xE29CD421, "e_farid_hint" },
    { 0xB8A01BB1, "e_final_look_target" },
    { 0x9BC342EA, "e_finn" },
    { 0x94852C4D, "e_fire" },
    { 0x0D529EAE, "e_fire_after" },
    { 0x426507E0, "e_fire_tag" },
    { 0x4495B51D, "e_fire_water" },
    { 0x7C50BAEF, "e_flare_effect_mover" },
    { 0x208E2AFE, "e_flare_weapon_effect" },
    { 0xAAFD61ED, "e_floor" },
    { 0x8328A3DD, "e_focus_target" },
    { 0xCE8EA34A, "e_foliage" },
    { 0x4B2FE35C, "e_followee" },
    { 0x90B6C6EF, "e_found" },
    { 0xF0488808, "e_frame" },
    { 0x4B19C935, "e_friend" },
    { 0xF6009DE3, "e_front_volume" },
    { 0x77755FF1, "e_frustrum" },
    { 0x8CA0A44F, "e_fx" },
    { 0x6374990B, "e_fx_offset" },
    { 0x51CC03BA, "e_fx_tag" },
    { 0x38B609E2, "e_fxanim_defend_room_door" },
    { 0xEC4734AA, "e_fxanim_server_arm_loop" },
    { 0x5321E021, "e_fxanim_server_arm_modems" },
    { 0xBFE9D19A, "e_gameobject" },
    { 0x8F1A11BB, "e_garage_bottom_piece" },
    { 0xA0C025B7, "e_garage_clip" },
    { 0xF13AC413, "e_garage_entrance" },
    { 0x90DB2FCE, "e_garage_mid_piece" },
    { 0xE7DC9537, "e_garage_window_target" },
    { 0x4F92C5FA, "e_gascan" },
    { 0x8B19D73E, "e_gdt_align" },
    { 0x2370450C, "e_gem_model" },
    { 0x41685025, "e_gem_pos" },
    { 0x5DED10AC, "e_gg_zone" },
    { 0x1E85BD2A, "e_ghost" },
    { 0x4547B253, "e_gimbal" },
    { 0x378EEE5B, "e_glass" },
    { 0x57825414, "e_goal" },
    { 0xAB891F49, "e_goal_volume" },
    { 0xC9AE457A, "e_goalvolume" },
    { 0x07CD58B2, "e_goalvolume_backright" },
    { 0x67B0FF1D, "e_goalvolume_frontleft" },
    { 0x05C6EAF1, "e_gondola" },
    { 0x1B26E578, "e_grabbed" },
    { 0x9F0E1D5E, "e_grabber" },
    { 0x61AB6F62, "e_grapple_target" },
    { 0x4FF20C5D, "e_grass" },
    { 0x1A30A879, "e_grenade" },
    { 0xAE0DAFC2, "e_grenade1" },
    { 0x880B3559, "e_grenade2" },
    { 0xBEB24237, "e_grenade_fake" },
    { 0xB324FF00, "e_guard" },
    { 0xEDAD8C71, "e_gunfire" },
    { 0x5ABBAE22, "e_guy" },
    { 0xFEBB477F, "e_harper" },
    { 0x5A2927C2, "e_harpers_shield" },
    { 0xA87110ED, "e_hatch" },
    { 0x9E9A84FB, "e_head_attacker" },
    { 0x62215EC6, "e_held_by_mechz" },
    { 0x638E0F11, "e_heli" },
    { 0x2DD5C5DD, "e_hero" },
    { 0x8DC7F36A, "e_hillary" },
    { 0xD39D1E34, "e_hind_obj" },
    { 0xACDB2586, "e_hint" },
    { 0x4A56FC02, "e_hit_ent" },
    { 0xB8FD2C63, "e_home_telepoint" },
    { 0x6E2232E4, "e_horse" },
    { 0xF0A5A13E, "e_horse_from_scene" },
    { 0x833A9907, "e_hudson_pos" },
    { 0xF190A084, "e_humvee_extra_cam" },
    { 0xB7A54F4C, "e_ice_block" },
    { 0xC6A5915A, "e_icebreaker" },
    { 0x1750372F, "e_ignition_point" },
    { 0xCDF1179B, "e_ignore" },
    { 0xFB19C839, "e_inflictor" },
    { 0x912AC17E, "e_info_volume" },
    { 0xDF688ED3, "e_interact_entity" },
    { 0x1BC0A01A, "e_interior_lift_red_light" },
    { 0xDB70251A, "e_isaac_container" },
    { 0x4CDB636E, "e_jeep_door_mount" },
    { 0x59F40B5E, "e_key" },
    { 0x00047326, "e_kill_zone" },
    { 0x79CD66D0, "e_killer" },
    { 0x93559703, "e_krav" },
    { 0xA5DCEC40, "e_krav_pos" },
    { 0xA752D58B, "e_lab_blast_doors" },
    { 0x93121DFB, "e_lab_shelf_clip_hide" },
    { 0x0D119198, "e_lab_shelf_clip_show" },
    { 0x03ECACEC, "e_lab_stair_blocker_clip" },
    { 0x86FADCB7, "e_lab_stair_blocker_m" },
    { 0x905F1D2A, "e_labdoor" },
    { 0x9E170D4D, "e_landmark" },
    { 0x30AF5449, "e_last" },
    { 0x7D0D350F, "e_last_area" },
    { 0x56D39277, "e_last_target" },
    { 0x83E33A19, "e_leader_pos" },
    { 0x98A4B5D6, "e_leaper_target" },
    { 0xF3CA6CDB, "e_least_hunted" },
    { 0x585B611C, "e_left_2_1_door" },
    { 0xB794C985, "e_left_door" },
    { 0x6B17769E, "e_left_lobby_door" },
    { 0xC96BB3C2, "e_left_lobby_top_door" },
    { 0x11B11F84, "e_left_mirror" },
    { 0x8CEA03BD, "e_left_window" },
    { 0x8305C467, "e_lever" },
    { 0x3C4D1AF9, "e_lift_scanner" },
    { 0x57923FA7, "e_light" },
    { 0xC93EF955, "e_link" },
    { 0xF4F2D282, "e_linked" },
    { 0xE0D020C4, "e_linker" },
    { 0xEC0F65C6, "e_linkto" },
    { 0xE63D759E, "e_linkto_target" },
    { 0x404559EF, "e_lockpick" },
    { 0xE8BC67A0, "e_look" },
    { 0x04A7C396, "e_look_at_ent" },
    { 0xEF1C623F, "e_lookat" },
    { 0x2156364D, "e_lookat_target" },
    { 0x26ABB593, "e_los_ignore_me" },
    { 0x4BA6250A, "e_main_disc" },
    { 0xFA095CEA, "e_mantler_target" },
    { 0x87921DAE, "e_market_volume" },
    { 0xD1600AFD, "e_mason" },
    { 0x7E168EA1, "e_master_key_target" },
    { 0xE701A5B3, "e_menendez" },
    { 0xB73A3637, "e_menendez_hill" },
    { 0x04B6D16C, "e_menendez_turret" },
    { 0xCD1097F4, "e_metal_storm" },
    { 0x973828CF, "e_missile" },
    { 0x168D6A04, "e_missile1" },
    { 0x8894D93F, "e_missile2" },
    { 0x60E5CBCE, "e_missile_target1" },
    { 0x3AE35165, "e_missile_target2" },
    { 0x14E0D6FC, "e_missile_target3" },
    { 0xEEDE5C93, "e_missile_target4" },
    { 0x3125B750, "e_model" },
    { 0x1CAE8AA4, "e_model_nofx" },
    { 0x7F51743B, "e_models" },
    { 0x9C83BCDA, "e_mortar" },
    { 0x42EDD1E7, "e_mortar1" },
    { 0xD0E662AC, "e_mortar2" },
    { 0xF6E8DD15, "e_mortar3" },
    { 0xC28775C4, "e_mountain" },
    { 0x67E4EC0E, "e_move" },
    { 0xAE451748, "e_mover" },
    { 0x20A5B260, "e_mover_broken" },
    { 0x352365A9, "e_my_target" },
    { 0x296BD711, "e_new_gem" },
    { 0x0D8598E0, "e_new_wall" },
    { 0xFA6B4E56, "e_next_target" },
    { 0x0E1D6D92, "e_nikolai" },
    { 0x3ABAD633, "e_nml_zone" },
    { 0x1BF82AFF, "e_no_prone" },
    { 0x27B8EF56, "e_number" },
    { 0x8B6FBF68, "e_obj" },
    { 0xA90EF4B2, "e_obj_location" },
    { 0x29942015, "e_obj_marker" },
    { 0xCD765438, "e_object" },
    { 0x40B90829, "e_occluders_on" },
    { 0x8856A274, "e_oldest" },
    { 0x1AB151FC, "e_opp" },
    { 0x2C3A4FFD, "e_org" },
    { 0x83683DC7, "e_origin" },
    { 0x5D3564A6, "e_origin_0" },
    { 0x8337DF0F, "e_origin_1" },
    { 0xC9B72AF8, "e_original_next_target" },
    { 0xEEFD8747, "e_originator" },
    { 0xACA0D97D, "e_other" },
    { 0x28A08272, "e_owner" },
    { 0xB9D38D59, "e_p_align" },
    { 0xAAE06D9B, "e_pa_pos" },
    { 0x6C61F6C6, "e_pa_vo" },
    { 0xFE1E2B36, "e_parasite_drop" },
    { 0xA2A3FA61, "e_parent" },
    { 0xE850C6D4, "e_patroller" },
    { 0x694DA627, "e_pdf_rpg_target" },
    { 0xF3313E2E, "e_perk_machine_trigger" },
    { 0x061141F0, "e_perk_trigger" },
    { 0x56EF6B49, "e_piece" },
    { 0xF7425551, "e_plane" },
    { 0x9591E5CD, "e_planter" },
    { 0xAFE8A821, "e_play_on" },
    { 0x6BFE1586, "e_player" },
    { 0x4CD6B5CB, "e_player1" },
    { 0xDACF4690, "e_player2" },
    { 0x593DCC64, "e_player_align" },
    { 0x1701B3B3, "e_player_asd_window_clip" },
    { 0xC625070D, "e_player_body" },
    { 0x57D52101, "e_player_chair_clip" },
    { 0xF7D4BA79, "e_player_closest_on_tank" },
    { 0x24EE04F8, "e_player_elevator_bottom_clip" },
    { 0x708B250C, "e_player_elevator_top_clip" },
    { 0x99952034, "e_player_hatch_spot" },
    { 0xFBA28CA1, "e_player_link" },
    { 0x2507791D, "e_player_rig" },
    { 0xFA10E959, "e_player_scene_horse" },
    { 0x013F318D, "e_player_to_attack" },
    { 0xD8CFD4DC, "e_playerclip" },
    { 0xF108C5A8, "e_plinth" },
    { 0xB4581883, "e_poi" },
    { 0xDDCB6651, "e_portal_frame" },
    { 0x9866F6F9, "e_pos" },
    { 0x4B827D1D, "e_potal" },
    { 0x589CCEAC, "e_powered_zombie" },
    { 0xAB0CED81, "e_previous_pos" },
    { 0xA57C232F, "e_priority_target" },
    { 0xE40110B0, "e_proj" },
    { 0x622504F0, "e_projectile" },
    { 0x4FC9CC34, "e_pusher" },
    { 0x29321C27, "e_railturret" },
    { 0xAC0E60E4, "e_railturret_snd1" },
    { 0x1E15D01F, "e_railturret_snd2" },
    { 0x7B11D634, "e_receptionist" },
    { 0xD208519A, "e_redshirt" },
    { 0xBDA1E244, "e_ref" },
    { 0x6275CBE2, "e_releaser" },
    { 0x83FD1F97, "e_revivee" },
    { 0x19C42028, "e_reviver" },
    { 0x1A0ABBF7, "e_richtofen" },
    { 0xEB2993CB, "e_rider" },
    { 0x87BFF641, "e_right_2_1_door" },
    { 0x0D5E2118, "e_right_door" },
    { 0x505172B3, "e_right_lobby_door" },
    { 0x472DE247, "e_right_lobby_top_door" },
    { 0x6F9A2B51, "e_right_mirror" },
    { 0x578590CC, "e_right_window" },
    { 0x59D7441F, "e_ring" },
    { 0x6104A93B, "e_robot" },
    { 0x3C91FDA1, "e_rocket" },
    { 0xC2CE8FFF, "e_roof" },
    { 0x967E4280, "e_roof_zone" },
    { 0x56A582E4, "e_rooftop_target" },
    { 0x80DAF40C, "e_room" },
    { 0xC73B5B11, "e_rope" },
    { 0x2934D3A0, "e_rotation_origin" },
    { 0x89A455F9, "e_rotation_struct" },
    { 0x35D6278C, "e_rotator" },
    { 0x848A02EE, "e_rpg" },
    { 0xAFFEA967, "e_rpg_jeep_target" },
    { 0x74B98FAD, "e_rubber_band_to" },
    { 0xDFC7EFC7, "e_runon" },
    { 0x34868759, "e_sacrifice_volume" },
    { 0xEBB3767B, "e_safe_zone" },
    { 0xEC5F9EF7, "e_sal" },
    { 0x4DE8C9CB, "e_salazar_spotlight_start" },
    { 0x3A2112E5, "e_savimbi_enemy" },
    { 0xE97FB8B9, "e_scanner" },
    { 0xF3CE04A6, "e_scene_link" },
    { 0xE4B99BD3, "e_scene_object" },
    { 0xB77112EF, "e_searchlight" },
    { 0xF50B8757, "e_secsystem" },
    { 0xB31C488F, "e_shelf" },
    { 0x972B2705, "e_shell" },
    { 0xCA2E5F6E, "e_shield" },
    { 0xB88F7A14, "e_shockbox" },
    { 0xDCDDFA52, "e_shoot_target" },
    { 0xC73FC1DB, "e_shooter" },
    { 0xCD807478, "e_shovel" },
    { 0x40A8ACFC, "e_shower_zone" },
    { 0x21C05335, "e_sm" },
    { 0x9585C13A, "e_sniper_guard" },
    { 0x826D22E5, "e_sniper_turret" },
    { 0xB6FD593E, "e_soct" },
    { 0xDF5BAA0F, "e_solarsystem" },
    { 0x75443889, "e_soldier" },
    { 0xB6E91729, "e_soldier2" },
    { 0x90E69CC0, "e_soldier3" },
    { 0x9AF7F59F, "e_soldier4" },
    { 0xAA515C9F, "e_some_ent" },
    { 0x72ADB5D6, "e_sound" },
    { 0xE1D115B5, "e_sound_pos" },
    { 0xE2851972, "e_source" },
    { 0x78242C39, "e_sparky_beam" },
    { 0xFD563F35, "e_spawned" },
    { 0x1178F0F3, "e_spawner" },
    { 0x6429C3ED, "e_spawner_capture_zombie" },
    { 0x67DAC978, "e_spawnpoint" },
    { 0xB87B8F90, "e_speaker" },
    { 0xB379FBF8, "e_special_item" },
    { 0x8EC5296F, "e_special_zombie" },
    { 0x29FE72DD, "e_spin" },
    { 0x1C0317BF, "e_spotlight" },
    { 0x7050B71D, "e_spotlight_prone_trigger" },
    { 0x91214FFF, "e_spotlight_search_target1" },
    { 0x1F19E0C4, "e_spotlight_search_target2" },
    { 0x451C5B2D, "e_spotlight_search_target3" },
    { 0x54442ACD, "e_spotlight_target" },
    { 0xFAAE8CD7, "e_sq_sign_attacker" },
    { 0xDDC4C0B8, "e_stables_clip" },
    { 0xF953BB9D, "e_staff" },
    { 0xB3AABA8F, "e_staff_standard" },
    { 0x7CE2424A, "e_staff_standard_upgraded" },
    { 0x5F728593, "e_start" },
    { 0xDC54F370, "e_start_pos" },
    { 0xF2F62B79, "e_statue" },
    { 0x1479CB6A, "e_stinger1" },
    { 0xEE775101, "e_stinger2" },
    { 0xD3B49C28, "e_streamer" },
    { 0x73987BC8, "e_streamer_hint" },
    { 0x4734FCD1, "e_streamer_hint1" },
    { 0x6EE1B061, "e_street_volume" },
    { 0x064F20F2, "e_strobe" },
    { 0x137FEE7A, "e_surface" },
    { 0x3CF76C37, "e_surface_default_angles" },
    { 0xF69A2EE9, "e_surface_default_origin" },
    { 0x7328E119, "e_switch" },
    { 0x27FBDCCF, "e_table" },
    { 0xFAA1C604, "e_table1" },
    { 0x46A6BAD6, "e_table3" },
    { 0xB06A8603, "e_tag" },
    { 0x0BBC9404, "e_tag_origin" },
    { 0xB3599DE7, "e_takeo" },
    { 0x3802504D, "e_takeoff_look_target" },
    { 0x9609E73E, "e_talker" },
    { 0x236F0A77, "e_tank_obj" },
    { 0x377A9C22, "e_target" },
    { 0xFE2DEA7F, "e_target1" },
    { 0x8C267B44, "e_target2" },
    { 0x3285D63C, "e_target_current" },
    { 0xE8F3FCD8, "e_target_ent" },
    { 0xEDBC8427, "e_target_fx" },
    { 0xE3D352B6, "e_target_left" },
    { 0x7AB4A08A, "e_target_previous" },
    { 0xD4361E0D, "e_target_right" },
    { 0x958A6ADB, "e_target_tag" },
    { 0x8CCC3A0D, "e_target_torch" },
    { 0xBDB767AF, "e_targetname" },
    { 0xBE1F149F, "e_temp" },
    { 0xB2ED5482, "e_temp_approach" },
    { 0xA0B89D60, "e_temp_fx" },
    { 0x9E61C073, "e_temp_goal" },
    { 0x1C459135, "e_temp_guard" },
    { 0x2CD16D61, "e_temp_left" },
    { 0x1B06A608, "e_temp_origin" },
    { 0x456CC7CC, "e_temp_right" },
    { 0x88F374ED, "e_temp_target" },
    { 0x4446BF22, "e_temp_trigger" },
    { 0x7F76CBB3, "e_thing" },
    { 0x21AEC262, "e_thrower" },
    { 0x21F69925, "e_tile" },
    { 0xF787F99E, "e_time_bomb_volume" },
    { 0x5EC0E91C, "e_titus_target" },
    { 0x1AF717C0, "e_to_be_deleted" },
    { 0xF038492F, "e_to_check" },
    { 0xEDD0B330, "e_to_delete" },
    { 0xED4C2B7B, "e_to_ignore" },
    { 0xF77BEF35, "e_to_link" },
    { 0x7CD76A8E, "e_to_touch" },
    { 0xCCA34455, "e_torch" },
    { 0xAB7EB971, "e_touched" },
    { 0xB8963552, "e_touching" },
    { 0x34C43F98, "e_tower" },
    { 0x64F74491, "e_tower_clip" },
    { 0x442284FB, "e_tower_door" },
    { 0x03828E39, "e_trace_ignore" },
    { 0x48DD883B, "e_trail" },
    { 0x472F840C, "e_trap" },
    { 0x44D9AB82, "e_trap_model" },
    { 0x677F3E1D, "e_trash" },
    { 0xF7EBB04B, "e_trig" },
    { 0x58A772CF, "e_trig_elevator_panel" },
    { 0x00705670, "e_trig_split_path" },
    { 0xF92A03E7, "e_trigger" },
    { 0xCAE6FCAC, "e_triggered" },
    { 0xDF09AE6A, "e_triggerer" },
    { 0x29AFAB5E, "e_triggers" },
    { 0xA64F617F, "e_trough_clip" },
    { 0x800861A2, "e_truck" },
    { 0x76BCDEA7, "e_turret" },
    { 0x44DEE395, "e_turret_target" },
    { 0x0011B4AB, "e_tv" },
    { 0x8F062E08, "e_unique_player" },
    { 0x6E9900EB, "e_unit" },
    { 0x59FC9A02, "e_upgraded_staff" },
    { 0x8FDD7F13, "e_upper_house_spawner" },
    { 0xCC8B1B30, "e_user" },
    { 0x17AAD696, "e_veh" },
    { 0x6AF83013, "e_vehicle" },
    { 0xB1365941, "e_vehilce" },
    { 0xEF6539D1, "e_victim" },
    { 0x1D1251D1, "e_visible_laser" },
    { 0xFE164365, "e_vo_origin" },
    { 0x9C169A5C, "e_vol" },
    { 0x9C341739, "e_vol_backdrop" },
    { 0x67825717, "e_volume" },
    { 0x8304F83C, "e_volume1" },
    { 0xF50C6777, "e_volume2" },
    { 0x3084E2DF, "e_volume_1" },
    { 0xBE7D73A4, "e_volume_2" },
    { 0xE47FEE0D, "e_volume_3" },
    { 0x7DC8B824, "e_volume_fallback" },
    { 0xBBBB8F87, "e_volume_to_wait_for" },
    { 0xF6EB08CC, "e_wagon_clip" },
    { 0xEC523DD5, "e_wall" },
    { 0xEFF5446A, "e_warehouse" },
    { 0x833E5F22, "e_warehouse_1" },
    { 0x5D3BE4B9, "e_warehouse_2" },
    { 0xDEDF403C, "e_wasp" },
    { 0x771B4113, "e_water_fx" },
    { 0xDAA69C19, "e_weapon" },
    { 0xAB378B56, "e_wheel" },
    { 0x5C96FE71, "e_whirlwind" },
    { 0x65669D7B, "e_who" },
    { 0x8B8FB828, "e_widows_wine_player" },
    { 0x37DCC322, "e_wire" },
    { 0x78D62209, "e_woods" },
    { 0x79E3BE4A, "e_woods_pos" },
    { 0x0CC2E85D, "e_wounded" },
    { 0xF338B1F5, "e_wunderfizz" },
    { 0x81C79F58, "e_xcam" },
    { 0x6B313D27, "e_yemeni_spawner" },
    { 0x2953533C, "e_zhao_pos" },
    { 0x715C1733, "e_zombie" },
    { 0xC5E4B996, "e_zombie_blood" },
    { 0x2079B5DB, "e_zone" },
    { 0x850AD052, "each" },
    { 0x1E7612BC, "eachother" },
    { 0x02CE2951, "ead" },
    { 0x6E80611E, "eade" },
    { 0x068A4AC2, "eady" },
    { 0xFFCB494B, "eagle" },
    { 0x05748CE0, "eagle_eye_crosby_jumps" },
    { 0x8C30D5B4, "eagle_eye_extra_arms" },
    { 0x885CEFB8, "eagle_eye_far_flung" },
    { 0x9C3D59D5, "eagle_eye_harper_nag" },
    { 0xBF97D437, "eagle_eye_leap_of_faith" },
    { 0x785E8C1F, "eagle_eye_rough_landing" },
    { 0x54EF6853, "eagle_eye_setup" },
    { 0xB8D27DB1, "eagle_eye_squad_waits" },
    { 0x03C8A8E1, "eagle_eye_start_glasses" },
    { 0x6C521EC0, "eagle_eye_surface_link" },
    { 0x31542FEE, "eagle_eye_swing" },
    { 0xDA775AF0, "eagle_eye_vertigo" },
    { 0x868945B1, "eagle_eye_vo" },
    { 0xFFBA8135, "eagle_fall" },
    { 0xEFD6967D, "eagle_setup" },
    { 0xDB29D5CC, "eagle_slip" },
    { 0x3D409AAA, "eagles" },
    { 0x6AC43FAD, "eah" },
    { 0x252DAAB5, "ealth" },
    { 0xCAC877EC, "eaniment" },
    { 0x4C0AC146, "eapon" },
    { 0x77D6B82A, "eapproachtrigger" },
    { 0x000BB773, "ear_fov" },
    { 0x58D056B5, "eariler" },
    { 0x40D31F70, "earler" },
    { 0xC88C877B, "earlier" },
    { 0x788268E2, "earliest" },
    { 0x3305096D, "earliestplayer" },
    { 0x37BDEC1C, "earliestspawntime" },
    { 0x6FB9AA9D, "earliesttime" },
    { 0x915054B4, "earliestzombie" },
    { 0x32141807, "earliestzombietime" },
    { 0x764F5EBA, "early" },
    { 0x6C3F56B3, "early_action" },
    { 0xD3AB0071, "early_barnes_swim" },
    { 0xB57971CC, "early_check_over" },
    { 0x9342FBDA, "early_chopper" },
    { 0xB0A71BE3, "early_contextual_player_hands" },
    { 0xDFBC6665, "early_death" },
    { 0xFB95EC78, "early_ending_trigs" },
    { 0x433D72B9, "early_exit" },
    { 0xF707B605, "early_exit_watch" },
    { 0x3952AEA5, "early_game_end" },
    { 0x259EDAB6, "early_goal_arrive" },
    { 0x4B158A5A, "early_kill_german" },
    { 0x0D7F9759, "early_level" },
    { 0x47E67499, "early_sling_release_done" },
    { 0xD9EE959C, "earlyout_animscripted" },
    { 0x6794F7FB, "earn" },
    { 0x8E1BFFE3, "earn_5_scorestreaks_anteup" },
    { 0xC2BCF0F6, "earn_scorestreak_anteup" },
    { 0x7B522F70, "earned" },
    { 0xDFB9AF94, "earned_lives" },
    { 0xD530AECA, "earned_points" },
    { 0xC97D6DDA, "earned_points_tracking" },
    { 0x0512B599, "earnedakill" },
    { 0xF3055CA7, "earnedakillstreak" },
    { 0xDAE437D6, "earnedcuavassistscore" },
    { 0xF0AEB55F, "earneddogskillstreak" },
    { 0xCECCD207, "earnedempassistscore" },
    { 0xC69B0766, "earnedkillstreak" },
    { 0x043B10C4, "earnedmicrowaveassistscore" },
    { 0xE67FDD38, "earnedsatelliteassistscore" },
    { 0xFB9D3BC7, "earnedspecialistweapon" },
    { 0x7885966D, "earneduavassistscore" },
    { 0xB3F308E5, "earning" },
    { 0x8F6F4C9A, "earns" },
    { 0x832FDCAB, "earth" },
    { 0xA7DACEAB, "earth_break" },
    { 0x337BB564, "earth_crack" },
    { 0x9CF04C2E, "earthquake" },
    { 0xCD9A4435, "earthquake_and_rumble_here" },
    { 0x5253FF59, "earthquake_degree" },
    { 0x56ECE47A, "earthquake_delay" },
    { 0x06A497D4, "earthquake_name" },
    { 0x90D0CB63, "earthquake_origin" },
    { 0xF2CE36E7, "earthquake_radius" },
    { 0x166E8821, "earthquake_rumble_approach" },
    { 0xB8C8DA0D, "earthquake_scale" },
    { 0x124CACFA, "earthquake_struct" },
    { 0x6539522A, "earthquake_time" },
    { 0xF4846B2F, "earthquake_trig" },
    { 0xDC4E870C, "earthquake_trig_2" },
    { 0xCFCC03E8, "earthquaker" },
    { 0x562489C4, "earthquaker_small" },
    { 0xF5CE7E51, "earthquakes" },
    { 0xE3720B17, "ease" },
    { 0xA17C6666, "easier" },
    { 0x233B0889, "easiest" },
    { 0x04E720F6, "easily" },
    { 0xC8284112, "easing" },
    { 0x5D47EA1E, "east" },
    { 0x4B2F6D7E, "east_spawners" },
    { 0x53FEE075, "eastend" },
    { 0x13333D47, "easter" },
    { 0x3D5C74D3, "easter_egg_song_vo" },
    { 0x3F63F160, "easteregg_scream_complete" },
    { 0x705C06CA, "easterly" },
    { 0xC3A2C74B, "eastern" },
    { 0x3281AEB3, "eastvector" },
    { 0xBB2CA79B, "easy" },
    { 0x56A3A12D, "easy_prone_check" },
    { 0x6351DCD6, "easyweapons" },
    { 0x62F5CFE1, "eat" },
    { 0xC1425222, "eat4_dude" },
    { 0xC33C9862, "eat_idle" },
    { 0x3A239EF1, "eat_idle_b" },
    { 0xDC4CFB8E, "eate" },
    { 0x36333AB4, "eaten" },
    { 0x31F1F8A7, "eating" },
    { 0xC4EEC313, "eatingdog" },
    { 0xDDF51F42, "eatingdogs" },
    { 0x98167688, "eats" },
    { 0x3A212FD7, "eattacker" },
    { 0xAD14F907, "eattackerisnotowner" },
    { 0xB7EBC2DC, "eattackernotself" },
    { 0x1F029484, "eattackpoint" },
    { 0xC0EB95B6, "eatten" },
    { 0xA4E96BD4, "eay" },
    { 0xFE9AECC4, "eb0" },
    { 0x249D672D, "eb1" },
    { 0x06DE2540, "ebadplace" },
    { 0x82808A58, "eblackhawk" },
    { 0x6862DF29, "eblackhawk_depart_path" },
    { 0xD4C569D4, "ebreachmodel" },
    { 0x005BE23F, "ebreakable" },
    { 0x4023CBE5, "ec" },
    { 0x340C1037, "ecamera" },
    { 0xB95EC48F, "echelon" },
    { 0x65453702, "echo" },
    { 0x9CA7D7C3, "echopper" },
    { 0xA5FFC05F, "eckert" },
    { 0xA9C66AE2, "eclasses" },
    { 0x442748A4, "eclipse" },
    { 0x0374D667, "eclipse_fog_on" },
    { 0xFD0C48C9, "eclipse_watcher" },
    { 0xC2092524, "eclosestvalidtarget" },
    { 0xDC26B91D, "ecobra" },
    { 0x94B7D0B6, "economic" },
    { 0x535B761C, "ecrewchief" },
    { 0x65C7038B, "ect" },
    { 0xD90FF3B5, "ecurrentnode" },
    { 0x42275D03, "edamagetrig" },
    { 0xB9B57DD5, "edc" },
    { 0xFB7B00E3, "edeletenode" },
    { 0x86907CBE, "edeletepathstart" },
    { 0x6471057E, "edge" },
    { 0xC3F77A13, "edge_check" },
    { 0x47A003F6, "edge_fog_start" },
    { 0xD88F647F, "edge_of_world" },
    { 0xA8A7906A, "edge_of_world_fail" },
    { 0xCF368501, "edge_of_world_notify" },
    { 0x1FD5943D, "edge_of_world_timer" },
    { 0x4260D926, "edge_of_world_warning" },
    { 0x15C18461, "edges" },
    { 0x36A862E5, "edisable_filter_tacticalmask" },
    { 0xBD5886D9, "edit" },
    { 0xD027303F, "edit_add_cpoint" },
    { 0xC161FA91, "edit_add_target_cpoint" },
    { 0x7BF49F90, "edit_cp_highlight" },
    { 0x08C01D73, "edit_current_cp" },
    { 0xA1AE1E8F, "edit_delete_cpoint" },
    { 0x93AB20C1, "edit_delete_target_cpoint" },
    { 0xB7F0C9B5, "edit_help" },
    { 0xADB8C87C, "edit_shot" },
    { 0xEC017B71, "edit_shot_change_target" },
    { 0x0FF100FB, "edit_shot_change_track" },
    { 0x3F7BC18C, "edit_shot_target" },
    { 0x3284381F, "edit_shot_target_thread" },
    { 0xB24DEEF8, "edit_shot_track" },
    { 0x99734CA0, "edit_shot_track_button_pressed" },
    { 0xC6BCF122, "edit_shot_track_buttons" },
    { 0x0DB36B27, "edit_shot_track_cp_hud_info" },
    { 0x528A4162, "edit_shot_track_hud" },
    { 0x25721951, "edit_shot_track_input" },
    { 0x72D71E93, "edit_shot_track_thread" },
    { 0x991DB6BB, "edit_sync_time_to_target" },
    { 0x709A18F5, "edit_sync_time_to_track" },
    { 0x82CFDEE7, "edit_target" },
    { 0x21873A0E, "edit_track_cp_update_info" },
    { 0xF93861E8, "edit_track_select_track" },
    { 0x12BAAE5C, "edit_update_cpoint_attrib" },
    { 0x52082A26, "edit_update_cpoint_origin" },
    { 0x1B38144D, "editable" },
    { 0x52FF8F83, "editaction" },
    { 0x9A919906, "edited" },
    { 0x6A295C6F, "editing" },
    { 0x9CF34DB5, "edition" },
    { 0x281C7E86, "editor" },
    { 0x988E9790, "edits" },
    { 0xF197C0E9, "edo" },
    { 0xF9CB4EB6, "edoor" },
    { 0xF3DAA9FC, "edr" },
    { 0xBD268640, "edriver" },
    { 0x2FAC9C55, "education" },
    { 0xF41ED713, "ee" },
    { 0x6A941ACE, "ee_all_staffs_upgraded" },
    { 0x89B873D7, "ee_debug" },
    { 0xD53C56C8, "ee_ending_beam_fx" },
    { 0x260A328B, "ee_in_use" },
    { 0xE3BEB300, "ee_main_end_level" },
    { 0xB473923D, "ee_main_progress" },
    { 0xEF2B6BAB, "ee_mech_zombies_alive" },
    { 0xAFC7AD6B, "ee_mech_zombies_killed" },
    { 0x10532E02, "ee_mech_zombies_spawned" },
    { 0xC6EF7F82, "ee_mechz_do_jump" },
    { 0x560A9669, "ee_mechz_spawn" },
    { 0xA43EAFBE, "ee_plane_vehicledamage" },
    { 0x13F8B19B, "ee_samantha_say" },
    { 0x51FAD791, "ee_stepped_on" },
    { 0x2442E889, "ee_upgrade_beacon" },
    { 0x0B54A2B0, "ee_zombie_blood_dig" },
    { 0xEBCC8C45, "ee_zombie_blood_dig_disconnect_watch" },
    { 0x116238AF, "ee_zombie_killed_override" },
    { 0x1281E984, "eee" },
    { 0xFDB245F1, "eendnode" },
    { 0x228A0BF1, "eent" },
    { 0x856A863F, "eenttospawn" },
    { 0x3ED03F95, "eeroom_powerup_drop" },
    { 0x86F20184, "eeroom_visionset_init" },
    { 0x6D2BD309, "eeroom_visionset_off" },
    { 0x29FF92FD, "eeroom_visionset_on" },
    { 0x23558C55, "eeroom_visionset_triggers" },
    { 0x26B66A35, "eerooms" },
    { 0x3144FAD5, "eeroomsinuse" },
    { 0x24EDC8B9, "eexploder" },
    { 0x1F756BD7, "eexploderorigin" },
    { 0xF21FA405, "ef2_disable_vehicle_sounds" },
    { 0x5FA05283, "efects" },
    { 0xC6980A5E, "eff" },
    { 0xE422BD7A, "effecient" },
    { 0x5F813DDE, "effect" },
    { 0x0AA9CB37, "effect01" },
    { 0x98A25BFC, "effect02" },
    { 0xBEA4D665, "effect03" },
    { 0x4C9D672A, "effect04" },
    { 0x729FE193, "effect05" },
    { 0x800F2436, "effect0dist" },
    { 0xFC4F3853, "effect1" },
    { 0xA8F4840F, "effect1dist" },
    { 0x8A47C918, "effect2" },
    { 0xD772EBD8, "effect2dist" },
    { 0xB04A4381, "effect3" },
    { 0xF39F5401, "effect3dist" },
    { 0x6E56A78E, "effect4" },
    { 0xD62ECC6A, "effect4dist" },
    { 0x945921F7, "effect5" },
    { 0x2251B2BC, "effect6" },
    { 0x48542D25, "effect7" },
    { 0xA638EAA2, "effect8" },
    { 0xCC3B650B, "effect9" },
    { 0x59563284, "effect_array" },
    { 0x490CF7A4, "effect_ent" },
    { 0xFBAC9C53, "effect_handle" },
    { 0xB5B2FB6F, "effect_index" },
    { 0x3048689F, "effect_life" },
    { 0x20931451, "effect_list_offset" },
    { 0x0A8DA0EE, "effect_list_offset_max" },
    { 0x251E8804, "effect_name" },
    { 0x63D422FD, "effect_pos" },
    { 0xD23A0410, "effect_scriptbundle" },
    { 0xD3837AFB, "effect_scriptbundles" },
    { 0xAA1E8636, "effect_soundalias" },
    { 0x43DE2F08, "effect_tag_origin" },
    { 0x56285B26, "effect_tags" },
    { 0xD4F32FF5, "effect_type" },
    { 0xDE470363, "effect_version" },
    { 0xC178E4DD, "effectarea" },
    { 0xEC6F0623, "effectdir" },
    { 0x801C6E21, "effected" },
    { 0x8D78A1C5, "effectent" },
    { 0x3CC13FA5, "effectid" },
    { 0x9D0A955D, "effectid2" },
    { 0x1CD9A662, "effecting" },
    { 0x5A3DB178, "effective" },
    { 0x1510CB7D, "effectively" },
    { 0xFE451169, "effectiveness" },
    { 0x16C669FB, "effectlifetime" },
    { 0xF97B7723, "effectname" },
    { 0xDB776E35, "effectobj" },
    { 0x8CE65AA4, "effectorigin" },
    { 0x2FABA941, "effects" },
    { 0xCFD4743A, "effects_init" },
    { 0x97C9B3A9, "effects_init_" },
    { 0xD5AAFF32, "effects_init_1" },
    { 0x5CEF0ABE, "effects_init_failsafe" },
    { 0x02A0FC41, "effects_init_thread" },
    { 0x0D68E72E, "effectsed" },
    { 0x24AE5CFC, "effectstructs" },
    { 0xDEC3A811, "effet" },
    { 0xA9E16703, "effetcs" },
    { 0x73398F76, "efficeint" },
    { 0x723FE182, "efficiency" },
    { 0xB10043AE, "efficient" },
    { 0xEF39FFDB, "effort" },
    { 0x7A1680FA, "efforts" },
    { 0xF02C5AD9, "efindee" },
    { 0x8972C297, "efurthesttree" },
    { 0x129CFF30, "efx" },
    { 0xA819E241, "eg" },
    { 0x4A911FA4, "egamemodes" },
    { 0x24A5F073, "egatedude" },
    { 0x4772599C, "egg" },
    { 0x18B211D5, "egg_damage_counter" },
    { 0x570B6266, "egg_drop_soup" },
    { 0xECD8787E, "egg_sound_ent" },
    { 0x32E30992, "egghead" },
    { 0xE1D7CB2F, "egghud" },
    { 0xE5F4F1DF, "eggs" },
    { 0x3F2D68C1, "egoalvolume" },
    { 0x13862E7F, "egriggsnode" },
    { 0x4F40C968, "egs" },
    { 0xB98DA8CB, "eguy" },
    { 0xE600218E, "egyptian" },
    { 0x4F7CC8E7, "egyptian_names" },
    { 0x36127306, "eh" },
    { 0x8E7837B1, "ehind" },
    { 0x84D4EEF5, "ehindintro" },
    { 0x2FBD1F48, "ehostile" },
    { 0xAFC788C1, "ei_door_open" },
    { 0xD49BB1AE, "ei_door_open_finished" },
    { 0x334700C2, "ei_door_opened_left" },
    { 0xAA485A31, "ei_door_opened_right" },
    { 0xF3B9DF33, "ei_door_think" },
    { 0xAAD706C1, "ei_setup" },
    { 0xEA2F1DDE, "eight" },
    { 0xC7EE4BCA, "eight_bit_easteregg" },
    { 0x9B546ACB, "eighty" },
    { 0x1131895F, "eindow" },
    { 0x51E6A548, "einflictor" },
    { 0xB618F7D2, "einfluencer_curve_constant" },
    { 0xAF5BC76A, "einfluencer_curve_inverse_linear" },
    { 0xB98953C5, "einfluencer_curve_linear" },
    { 0x6E363379, "einfluencer_curve_negative_to_positive" },
    { 0xAD83432B, "einfluencer_curve_steep" },
    { 0xE8BD980A, "einfluencer_shape_cylinder" },
    { 0x2A581E4F, "einfluencer_shape_sphere" },
    { 0x514067CD, "einfluencer_type_dog" },
    { 0xA797D77C, "einfluencer_type_enemy_spawned" },
    { 0x9E1FBBA7, "einfluencer_type_game_mode" },
    { 0xFD2D1430, "einfluencer_type_normal" },
    { 0x4ACCCDF2, "einfluencer_type_player" },
    { 0xD51FCC49, "einfluencer_type_squad" },
    { 0xF134AD37, "einfluencer_type_vehicle" },
    { 0x480FA705, "einfluencer_type_weapon" },
    { 0x9F982F4E, "einstein" },
    { 0x1EF73B8C, "eitehr" },
    { 0xA0A5B4EE, "either" },
    { 0x19C44BBC, "eject" },
    { 0xF4A8A7E7, "eject_done" },
    { 0xA2D62737, "eject_drone_spawn" },
    { 0x90B863FC, "eject_drone_spawned" },
    { 0xC7B020E3, "eject_from_my_node" },
    { 0x229DCD6F, "eject_lvt" },
    { 0x9009A596, "eject_move_align_struct" },
    { 0x3EF34BDF, "eject_plan_fire_before_eject" },
    { 0x8A54C23A, "eject_plane_fire" },
    { 0x549FD6ED, "eject_player_trigger" },
    { 0xE2FEA226, "eject_player_trigger_init" },
    { 0xA7289FA0, "eject_sequence_ready" },
    { 0x64EB5CEE, "eject_sequence_started" },
    { 0x46CF8952, "eject_wait_for_player_position" },
    { 0x5BE15B9F, "ejected" },
    { 0x6299C443, "ejected_overrun" },
    { 0xD7FA23B9, "ejecter" },
    { 0xA668C98C, "ejecting" },
    { 0x76194146, "ejection" },
    { 0xA3BB397F, "ekey" },
    { 0xF399D61A, "ekeysbuildable" },
    { 0xA995C3E4, "elaborate" },
    { 0x639D2411, "elalamein" },
    { 0x2184C94D, "eland" },
    { 0x4B2E105E, "eland1" },
    { 0x252B95F5, "eland2" },
    { 0xFF291B8C, "eland3" },
    { 0xABB9A908, "eland_hero_shoot" },
    { 0xFCE3E2B8, "eland_think" },
    { 0x5FFF20ED, "elandnode" },
    { 0x603260E9, "elapse" },
    { 0x31465FCF, "elapsed" },
    { 0xF0F6C90D, "elapsed_frame_count" },
    { 0xE09589B5, "elapsed_time" },
    { 0xBFBFAE04, "elapsed_time_counter" },
    { 0x608D195E, "elapsedrounded" },
    { 0x6D61993C, "elapsedtime" },
    { 0x4A57AEBC, "elapsedtimestopping" },
    { 0x2EBDCE6A, "elastnode" },
    { 0x13AD6BEE, "elbow" },
    { 0x693A2FBC, "elduderino" },
    { 0xF71988EB, "ele" },
    { 0xE2A70338, "ele1" },
    { 0x82088DD5, "ele1e" },
    { 0x54AE7273, "ele2" },
    { 0xF3F4E764, "ele2e" },
    { 0x4DE5B73A, "elec" },
    { 0x5496C2A2, "elec_barrier_damage" },
    { 0xE9BCF22E, "elec_box_orgs" },
    { 0x79CCB5CD, "elec_done" },
    { 0xBBF2C833, "elec_door_triggers" },
    { 0x5D4B7513, "elec_gen_spots" },
    { 0x4399F0D3, "elec_loop" },
    { 0x01DB9C80, "elec_trap_cooldown_time" },
    { 0x1B934988, "elec_trap_time" },
    { 0xB0D0CA76, "elecswitchbuildable" },
    { 0x235BC77A, "elect" },
    { 0x37119ADA, "electic_cherry_precache" },
    { 0x0A0A18C2, "electrap_handler" },
    { 0xD9287FE0, "electrap_loop_sound" },
    { 0x3AC05F51, "electrap_sound_ent" },
    { 0xCA449554, "electric" },
    { 0xBB6418DD, "electric_chair_player_thread" },
    { 0x248B46CE, "electric_chair_player_thread_custom_func" },
    { 0x6EC6D29E, "electric_chair_trigger_thread" },
    { 0x23B76B7D, "electric_chair_trigger_thread_" },
    { 0x84225799, "electric_chair_trigger_thread_custom_func" },
    { 0x03C0C6A8, "electric_chair_vo" },
    { 0x3B83450C, "electric_cherry" },
    { 0xF3AB8914, "electric_cherry_client_field_func" },
    { 0x8EB471D3, "electric_cherry_code_callback_func" },
    { 0x868EB37E, "electric_cherry_cooldown_started" },
    { 0x2C48DCA2, "electric_cherry_cooldown_timer" },
    { 0xFA3A7CE4, "electric_cherry_death_fx" },
    { 0xBDEFEC69, "electric_cherry_downed_attack_damage" },
    { 0xD3314EB3, "electric_cherry_downed_attack_points" },
    { 0x6DD0F79C, "electric_cherry_downed_attack_radius" },
    { 0xACD69592, "electric_cherry_end" },
    { 0x6051FEBD, "electric_cherry_host_migration_func" },
    { 0x9AEEDD49, "electric_cherry_laststand" },
    { 0x9ECA9445, "electric_cherry_machine_active_model" },
    { 0xA66431D7, "electric_cherry_machine_disabled_model" },
    { 0xA7B713D4, "electric_cherry_machine_light_fx" },
    { 0x80C00E12, "electric_cherry_off" },
    { 0xF6E94A64, "electric_cherry_on" },
    { 0x6115B5BD, "electric_cherry_perk_bottle_weapon" },
    { 0x99055CC1, "electric_cherry_perk_cost" },
    { 0x5FE54D08, "electric_cherry_perk_lost" },
    { 0x25D80DD3, "electric_cherry_perk_machine_setup" },
    { 0x1867899C, "electric_cherry_perk_machine_think" },
    { 0x8F686275, "electric_cherry_player_init" },
    { 0xC93CC370, "electric_cherry_precache" },
    { 0xAD083728, "electric_cherry_precache_override_func" },
    { 0x517CB1C0, "electric_cherry_radiant_machine_name" },
    { 0x42AC83F2, "electric_cherry_register_clientfield" },
    { 0xF1B9F957, "electric_cherry_reload_attack" },
    { 0x0D3AEB08, "electric_cherry_reload_attack_fx" },
    { 0xBA7A1CB9, "electric_cherry_reload_fx" },
    { 0xDA51A7DB, "electric_cherry_set_clientfield" },
    { 0x1889D5BC, "electric_cherry_shader" },
    { 0x7A1CE718, "electric_cherry_shock_fx" },
    { 0x71957349, "electric_cherry_start" },
    { 0x04D52B1F, "electric_cherry_stun" },
    { 0x26C8842B, "electric_cherry_stun_cycles" },
    { 0x4274B341, "electric_cherry_visionset" },
    { 0xFA9DFA4F, "electric_current_doubletap_machine" },
    { 0x2F0F0771, "electric_current_juggernog_machine" },
    { 0xBD8215BE, "electric_current_open_middle_door" },
    { 0xBF320A7C, "electric_current_reload_machine" },
    { 0x4D5504CC, "electric_current_revive_machine" },
    { 0x71D60F7F, "electric_door" },
    { 0x35D7B346, "electric_door_function" },
    { 0x44027D4A, "electric_ent" },
    { 0x027FE3BD, "electric_explosion_init" },
    { 0x8121D6ED, "electric_explosion_think" },
    { 0x5509550F, "electric_hallway_trap_piece_hide" },
    { 0xB3E2A02C, "electric_hallway_trap_piece_show" },
    { 0xCC96B9DC, "electric_killed" },
    { 0xAAEC4159, "electric_light" },
    { 0x8729910F, "electric_on_middle_door" },
    { 0xD3581D0D, "electric_perks_dialog" },
    { 0x9326CBAD, "electric_poi" },
    { 0x109F2E96, "electric_pulse" },
    { 0x10C4A01C, "electric_pulse_points" },
    { 0x9AB612A8, "electric_puzzle_1_init" },
    { 0x69295049, "electric_puzzle_1_run" },
    { 0xC2723D51, "electric_puzzle_2_cleanup" },
    { 0x34AB750E, "electric_puzzle_2_complete" },
    { 0x1FE92091, "electric_puzzle_2_init" },
    { 0x4D80AC56, "electric_puzzle_2_run" },
    { 0x3DCFA4D8, "electric_puzzle_watch_staff" },
    { 0x5FBEDD25, "electric_relays" },
    { 0xC917485F, "electric_switch" },
    { 0x2A6F315C, "electric_switch_init" },
    { 0xE5CFF313, "electric_tower01" },
    { 0x73C883D8, "electric_tower02" },
    { 0x803A35AC, "electric_towers_start" },
    { 0xDE3378BA, "electric_trap" },
    { 0xA1EB5708, "electric_trap_battery" },
    { 0xCCF11449, "electric_trap_battery_init" },
    { 0x6A0B67A0, "electric_trap_coil" },
    { 0xAAA97F2D, "electric_trap_dialog" },
    { 0x1FC3F4EF, "electric_trap_fx" },
    { 0xDBD27E2D, "electric_trap_move_switch" },
    { 0x38067E3A, "electric_trap_spool" },
    { 0xFD01812F, "electric_trap_think" },
    { 0x2AA1A67B, "electric_trap_wire_sparks" },
    { 0x1289F85E, "electric_trap_wire_sparks_stop" },
    { 0x82FB6263, "electrical" },
    { 0x203E023A, "electrical_damage_radius_lg" },
    { 0xE3B32735, "electrical_damage_radius_sm" },
    { 0x5660F23D, "electrical_explosion_dmg_max" },
    { 0x93C4FD53, "electrical_explosion_dmg_min" },
    { 0x56C5A9BE, "electrical_flicker" },
    { 0xFCBF1C2B, "electrical_room_sound" },
    { 0x79298C39, "electricdamagetrig" },
    { 0x8BA056E1, "electrice" },
    { 0x88AFF238, "electricity" },
    { 0xE590FE60, "electricity_on" },
    { 0x91E7D5EC, "electricleverdown" },
    { 0x59628E5F, "electricleverup" },
    { 0x02A8F0E6, "electricradius" },
    { 0x7BEAA478, "electricswitch" },
    { 0x29929445, "electrictrap" },
    { 0xDCAAC4FA, "electrictrap_health" },
    { 0xB45D55F1, "electrictrap_name" },
    { 0xAA47A777, "electrictrapbuildable" },
    { 0xAAC91EF9, "electrictrapbuytrigger" },
    { 0x77E67F72, "electrictrapdamage" },
    { 0x34DEBE0D, "electrictrapdecay" },
    { 0x87115A83, "electrictrapfx" },
    { 0xDF6AD0D5, "electrictrapkill" },
    { 0x536DF66C, "electrictrappoints" },
    { 0x2474B063, "electrictrapthink" },
    { 0xA081BAED, "electrified" },
    { 0x625C470E, "electrifiedby" },
    { 0x7FE12DEA, "electrifiedkilled" },
    { 0x2BCB45EA, "electrify" },
    { 0xE3B77070, "electro_strike" },
    { 0x1EE145B0, "electroball" },
    { 0x69391F4A, "electroctute_death_fx" },
    { 0x53091182, "electrocute" },
    { 0x7E3C22A2, "electrocute_timeout" },
    { 0x725D5B3A, "electrocuted_zombies" },
    { 0xCA2D8C73, "electrocuting" },
    { 0xEA072BA8, "electrocuting_zombie" },
    { 0x9A556E29, "electrocution" },
    { 0x0C742387, "electrocution_lockout" },
    { 0x533FE9F7, "electron" },
    { 0x91EC6281, "elegant" },
    { 0x69D6D8C4, "elem" },
    { 0x27121065, "elem1" },
    { 0x4D148ACE, "elem2" },
    { 0x73170537, "elem3" },
    { 0x5C0BEA08, "elem_ready_up" },
    { 0x1B319342, "elem_ready_up_setup" },
    { 0x9197A75E, "elem_text" },
    { 0x9C55A0A9, "elemcount" },
    { 0xC0316523, "element" },
    { 0xD9DD4B95, "element_number" },
    { 0x7FDAB4FC, "elemental" },
    { 0xF7E328FA, "elemental_round_fx" },
    { 0x38BA58FB, "elemental_round_ring_fx" },
    { 0x941898BF, "elementals" },
    { 0x36E3CBD4, "elementenum" },
    { 0x32667F5E, "elementname" },
    { 0x37C87DD4, "elementnumber" },
    { 0x36EC5712, "elements" },
    { 0x6348EFD8, "elemes" },
    { 0x83A3BD0E, "eleminating" },
    { 0x280887B9, "elemphysicaltovirtual" },
    { 0xF3B59F77, "elems" },
    { 0xF83454EC, "elemtype" },
    { 0xE63C1B45, "elemvirtualtophysical" },
    { 0x4EDFFD66, "elephant" },
    { 0x96B3E8A3, "elese" },
    { 0x6C19C1D7, "elev" },
    { 0xA3EC9955, "elev_clean_up_corpses" },
    { 0x953A8CC5, "elev_clear" },
    { 0xC0CCCCFC, "elev_remove_corpses" },
    { 0xA6ED3421, "elev_zone_trig" },
    { 0x7BED2771, "elev_zone_trig2" },
    { 0xE9600F9D, "elevate" },
    { 0x5C34D002, "elevation" },
    { 0xCC70D530, "elevationdelta" },
    { 0x6018E357, "elevator" },
    { 0x1803C0FC, "elevator1" },
    { 0x30D944B5, "elevator1_3d_audio" },
    { 0x8A0B3037, "elevator2" },
    { 0x598AFA5C, "elevator2_3d_audio" },
    { 0xA87BE71E, "elevator2_door" },
    { 0xFB9C9010, "elevator2_door_bottom" },
    { 0x543A3616, "elevator2_inside" },
    { 0xDCD8E042, "elevator_" },
    { 0xF1E9A73B, "elevator_arrive" },
    { 0x662B78A5, "elevator_arrived" },
    { 0xC1341766, "elevator_at_rest" },
    { 0x823587F0, "elevator_audio" },
    { 0xBB98EB93, "elevator_black_screen_squash_check" },
    { 0xA771D022, "elevator_buy" },
    { 0x2DCDBB27, "elevator_buy_think" },
    { 0xFCC9693C, "elevator_close_doors" },
    { 0xCF83CD80, "elevator_close_doors_top" },
    { 0xC95B4BE3, "elevator_closet_cleanup" },
    { 0xF9D2BB91, "elevator_connect_paths" },
    { 0xBBFBF315, "elevator_damage_watch" },
    { 0x25DB3FAD, "elevator_debris_rumble" },
    { 0x2F35D343, "elevator_delete" },
    { 0xDD662FDC, "elevator_depart_early" },
    { 0x50386FAF, "elevator_descent_dialog" },
    { 0x49A877BC, "elevator_dialogue" },
    { 0xC00B72BF, "elevator_disable_paths" },
    { 0x02C21AED, "elevator_disconnect_paths" },
    { 0xD4BB57AB, "elevator_door_clip" },
    { 0xFFB8C813, "elevator_door_inner_bottom" },
    { 0xC3DBEC2F, "elevator_door_inner_top" },
    { 0xDB3947FB, "elevator_door_outside1_bottom" },
    { 0xEDA7F507, "elevator_door_outside1_top" },
    { 0x0F58338E, "elevator_door_outside2_bottom" },
    { 0xD4E6A984, "elevator_door_outside2_top" },
    { 0xCB61AE88, "elevator_door_playerclip" },
    { 0x7B16043B, "elevator_door_safety" },
    { 0x47474BCC, "elevator_door_safety_clip" },
    { 0xD8D34734, "elevator_doors_closed" },
    { 0x41147E04, "elevator_doors_open" },
    { 0xC53DD8A2, "elevator_drop_ents" },
    { 0x9AC75416, "elevator_enable_paths" },
    { 0xC3427759, "elevator_ent" },
    { 0x7E3E0E36, "elevator_ent_2" },
    { 0xC2A499C6, "elevator_event" },
    { 0xD4B0E759, "elevator_fall_and_explode" },
    { 0x1705AB68, "elevator_finished" },
    { 0x27DE007E, "elevator_flashlight_off" },
    { 0xD599FE4B, "elevator_gate" },
    { 0xD1A789AA, "elevator_gates" },
    { 0x6675FE6F, "elevator_grigsby" },
    { 0xA9F907CB, "elevator_guys_spawn_func" },
    { 0xBE05853B, "elevator_harper_approach" },
    { 0x1EE18F99, "elevator_hint_text" },
    { 0x1A709A3A, "elevator_initial_wait" },
    { 0x527D4909, "elevator_is_on_floor" },
    { 0x5597C621, "elevator_jetpacks_land" },
    { 0xF21E8E34, "elevator_key_prompt" },
    { 0x6D50F06E, "elevator_keys" },
    { 0x0AE2046E, "elevator_kill" },
    { 0x378E4C44, "elevator_kill_guard" },
    { 0x650D9676, "elevator_kill_guard_response" },
    { 0x232BD591, "elevator_kill_hatch" },
    { 0x4B381A3A, "elevator_kill_player" },
    { 0x310C42FD, "elevator_kill_reznov" },
    { 0xBE1F8925, "elevator_kill_scientist" },
    { 0x095A38C5, "elevator_kill_scientist_response" },
    { 0x303E005B, "elevator_kill_vignette" },
    { 0xAE1E2CF9, "elevator_klaxon_speaker" },
    { 0x4D3B5BC3, "elevator_level_for_floor" },
    { 0x7F948D2C, "elevator_logic" },
    { 0x917C5D41, "elevator_loop_n_stop_sounds" },
    { 0xF8C94C1B, "elevator_looping_sounds" },
    { 0xED785013, "elevator_models_hidden" },
    { 0xE9198F9F, "elevator_models_hide" },
    { 0x5F362D53, "elevator_models_link" },
    { 0x460652FC, "elevator_models_show" },
    { 0x5107C299, "elevator_move" },
    { 0xD8C1C607, "elevator_move_doors" },
    { 0x9D956251, "elevator_move_sound" },
    { 0xD86D98CF, "elevator_move_time" },
    { 0x59D53147, "elevator_move_to" },
    { 0x6E18A2AA, "elevator_moveto" },
    { 0x66347F8C, "elevator_moving" },
    { 0xD6EB1096, "elevator_names" },
    { 0x81C3EA4E, "elevator_next_floor" },
    { 0x5F9F45A2, "elevator_open" },
    { 0x928FE001, "elevator_open_2" },
    { 0x3E7775B8, "elevator_open_doors" },
    { 0x8120D944, "elevator_open_doors_top" },
    { 0x827579E1, "elevator_operation" },
    { 0xEB076E22, "elevator_parent" },
    { 0x03A545E9, "elevator_path_nodes" },
    { 0x803D15E5, "elevator_paths_onoff" },
    { 0x40F216DC, "elevator_perk_offset" },
    { 0x28F9B941, "elevator_perks" },
    { 0xCD2028A4, "elevator_perks_building" },
    { 0x412A66CD, "elevator_player" },
    { 0xE0746B92, "elevator_player_clip" },
    { 0xD17EA64C, "elevator_players" },
    { 0x881E3E74, "elevator_pos" },
    { 0xA01285E5, "elevator_price" },
    { 0x1AA75044, "elevator_ride" },
    { 0xC21F69CD, "elevator_riding" },
    { 0x801271E4, "elevator_rise_duration" },
    { 0x0AEDF429, "elevator_roof_watcher" },
    { 0x8FC587C9, "elevator_rumble" },
    { 0x07977381, "elevator_salazar_approach" },
    { 0xC1D2B91E, "elevator_scrape_oneshots" },
    { 0x88A24FB7, "elevator_set_moving" },
    { 0x6979948E, "elevator_shaft_middle_2_respawn_nodes" },
    { 0x3E7E855F, "elevator_shaft_middle_2_respawn_nodes_index" },
    { 0x8B6B10D1, "elevator_slide" },
    { 0x9383B643, "elevator_slide_player" },
    { 0x8F03A2AC, "elevator_slide_reznov" },
    { 0x3AC79375, "elevator_slide_reznov_idle" },
    { 0xDEE61190, "elevator_slide_reznov_shortcircuit" },
    { 0x05AB2C30, "elevator_slide_start" },
    { 0x57EE1FC3, "elevator_slide_started" },
    { 0xCEE29D22, "elevator_slide_vignette" },
    { 0x37EE6D48, "elevator_sparks" },
    { 0xC6218DC9, "elevator_sparks_fx" },
    { 0x113C638F, "elevator_spawn" },
    { 0x29939C1A, "elevator_stop" },
    { 0x5729A79E, "elevator_stop_1_sound" },
    { 0x0B5E0E66, "elevator_stop_delay_1" },
    { 0xE55B93FD, "elevator_stop_delay_2" },
    { 0x3574D89E, "elevator_stop_top" },
    { 0xFE6B925E, "elevator_system_init" },
    { 0xF49BF2E5, "elevator_target" },
    { 0xE161346E, "elevator_think" },
    { 0xC7B42877, "elevator_transition" },
    { 0x20E05451, "elevator_traverse_watcher" },
    { 0x037C0B9A, "elevator_trigger" },
    { 0x76EB8C4E, "elevator_upper" },
    { 0xBC36E5B7, "elevator_vig_done" },
    { 0xC5DC056C, "elevator_vo_mason" },
    { 0xBEB60A33, "elevator_volumes" },
    { 0x67A2AA15, "elevator_waittill_squad_boarded" },
    { 0x92AA3270, "elevator_wires" },
    { 0xDEE22CEA, "elevatorname" },
    { 0xE4A7500E, "elevators" },
    { 0xCEAB1BAA, "elevators_set_no_cull" },
    { 0xEE2FA185, "elevators_stop" },
    { 0xAB96C8AE, "eleveator_ai_logic" },
    { 0xA09F9E26, "eleven" },
    { 0x034854F1, "elid" },
    { 0xC650FF71, "elidarm" },
    { 0xE5B679F6, "elidfxent" },
    { 0x75986416, "eligable" },
    { 0x39D91EEE, "eligible" },
    { 0x73881EE1, "eligible_for_death_invulnerability" },
    { 0xA0BC5D5D, "eligible_results" },
    { 0xB9F36C47, "eliminate" },
    { 0x283BA2C1, "eliminated" },
    { 0x7522519A, "eliminatedstring" },
    { 0x8620603E, "eliminates" },
    { 0xCD4B6382, "eliminating" },
    { 0x7C84E78C, "elimination" },
    { 0xBD3E42AE, "elite" },
    { 0x272D5C33, "elm" },
    { 0xAFE29B98, "eloc" },
    { 0xB7B39C0F, "elocation" },
    { 0x875E3846, "elocos" },
    { 0xE042FE48, "elookat" },
    { 0x79D7A4EA, "else" },
    { 0xDC11685B, "elseif" },
    { 0xB2ED15A5, "elses" },
    { 0xDC2C27FF, "elsewhere" },
    { 0x24EA7320, "elv" },
    { 0x436B1658, "elv_snd" },
    { 0xE4796ED1, "elysium" },
    { 0xA5E47345, "elysium_bloody" },
    { 0xC40B03CB, "em" },
    { 0x25BB44B3, "emanating" },
    { 0x94190CE6, "embarassed" },
    { 0xE834E4D2, "embbedddeed" },
    { 0xE741050F, "embedded" },
    { 0x506F96DE, "ember" },
    { 0xF66BC123, "emblem" },
    { 0x9C92A554, "embrace" },
    { 0x038F0EA2, "ememy" },
    { 0xD5B9F30A, "emerge" },
    { 0x16EFDC5E, "emerge_anim" },
    { 0x39DC81A4, "emerge_bottom" },
    { 0xA93865EE, "emerge_top" },
    { 0x07C6453B, "emerge_trig" },
    { 0x269D967A, "emerged" },
    { 0xE236707C, "emergence" },
    { 0xDAB017CD, "emergence_hole_spawn" },
    { 0xB9F10D00, "emergency" },
    { 0xC8C6BAB9, "emergency_crack_time_delay" },
    { 0xC6FF056B, "emergency_light_activate" },
    { 0xD8F8ACB6, "emergency_light_active" },
    { 0x96664ADE, "emergency_light_init" },
    { 0x4E400591, "emergency_light_play_cheap_fx_out_of_range_of_trigger" },
    { 0x758C34AD, "emergency_light_trigger_think" },
    { 0xF8CCAC45, "emerges" },
    { 0x1A5546DB, "emerging" },
    { 0x622527BE, "emissile" },
    { 0x338E9E96, "emissile_target" },
    { 0x6799F110, "emissilekilltrig" },
    { 0xD8655D2C, "emissive" },
    { 0x9A176D1D, "emitter" },
    { 0xC7536B1E, "emitter_thunder" },
    { 0xDEEEE35C, "emitters" },
    { 0x9E095151, "emodel" },
    { 0x8C2988A6, "emodes" },
    { 0x5F7E5BE4, "emotion" },
    { 0xA0C818F3, "emotional" },
    { 0xC2BDA8E3, "emotional_state_system" },
    { 0x8790B7C1, "emp" },
    { 0xA2C592E8, "emp_and_die" },
    { 0x69C9D845, "emp_behavior_duration" },
    { 0xC68FC2F4, "emp_bomb" },
    { 0x0F03B6D3, "emp_bomb_exists" },
    { 0x8E611925, "emp_callback" },
    { 0xFCDCAA89, "emp_count" },
    { 0x51851270, "emp_crazy_death" },
    { 0xEF3F0217, "emp_damage" },
    { 0xAFFE9CF5, "emp_damage_cb" },
    { 0x8FB24E90, "emp_damage_to_apply" },
    { 0x7D5AFC17, "emp_death_fx_1" },
    { 0x46FE10E6, "emp_death_sound_1" },
    { 0xBCC29803, "emp_death_tag_1" },
    { 0xC0369B5A, "emp_deployed" },
    { 0xD6B0C71D, "emp_destroyed_missile_swarm" },
    { 0x573F3004, "emp_detonate" },
    { 0xF1B18618, "emp_detonate_boss" },
    { 0x76811997, "emp_detonate_bus" },
    { 0xE5938E08, "emp_detonate_zombies" },
    { 0x12B59BAC, "emp_duration" },
    { 0xCE3DE793, "emp_end" },
    { 0x33258E48, "emp_ended" },
    { 0x6A568E15, "emp_filter_duration" },
    { 0x60BF2E5B, "emp_filter_index" },
    { 0x2B16EAC0, "emp_filter_off" },
    { 0x104ECC9A, "emp_filter_on" },
    { 0xEEB19DC1, "emp_filter_over_time" },
    { 0xD44CF756, "emp_fx" },
    { 0x3D83D307, "emp_fx_start" },
    { 0xEBBB31C7, "emp_fx_tag" },
    { 0x74592754, "emp_grenade_sp" },
    { 0x34364BEE, "emp_grenaded" },
    { 0x169AA145, "emp_headicon_offset" },
    { 0x6AA63EDE, "emp_health" },
    { 0x2877891F, "emp_invalid_placement_model" },
    { 0xFC5864CA, "emp_isempd" },
    { 0xCFD5A1E4, "emp_isteamemped" },
    { 0x87CB24FC, "emp_jamenemies" },
    { 0x2B1FAC56, "emp_jammed" },
    { 0x3FCA355B, "emp_jammed_vp" },
    { 0xA74A9364, "emp_jamotherteams" },
    { 0x78CFF462, "emp_jamplayers" },
    { 0x0CE31055, "emp_killstreaks" },
    { 0xBD55C0FF, "emp_low_health" },
    { 0x01C58BBA, "emp_max_time" },
    { 0x45AD0924, "emp_min_time" },
    { 0x725C6B3B, "emp_model" },
    { 0xAA7BF305, "emp_name" },
    { 0x71123C42, "emp_players" },
    { 0xAE1592DD, "emp_playertracker" },
    { 0xA9419ED6, "emp_radius" },
    { 0xF91EBCA8, "emp_rumble_loop" },
    { 0xF0941238, "emp_shutdown_end" },
    { 0xCB33655B, "emp_shutdown_start" },
    { 0x633D77A8, "emp_startup_fx" },
    { 0xEDA07136, "emp_static" },
    { 0xD2F4E7B9, "emp_teamtracker" },
    { 0x669E9643, "emp_thread_stop" },
    { 0x6F305D17, "emp_time" },
    { 0x53CCF209, "emp_time_left" },
    { 0xCCD0EBB8, "emp_time_left_ms" },
    { 0xF70B47E0, "emp_turret_deploy" },
    { 0x49BAF355, "emp_turret_deploy_start" },
    { 0x7EE25D8F, "emp_turret_init" },
    { 0xA5D25A17, "emp_update" },
    { 0xBFBFD24B, "emp_update_distance_delay" },
    { 0xF0D86114, "emp_update_distance_no_emp_delay" },
    { 0x482C0131, "emp_updated" },
    { 0xBC52D305, "emp_use" },
    { 0x523F85E4, "emp_valid_placement_model" },
    { 0x47AA891C, "emp_vehicle" },
    { 0xFCE4A95E, "emp_vehicle_name" },
    { 0x018C095B, "emp_vp_jammed" },
    { 0xE797291C, "emp_watcher" },
    { 0x4B482C38, "emp_weapon_damage" },
    { 0x66D34E9B, "empale" },
    { 0xA1591836, "empanim" },
    { 0x63856D52, "empbase" },
    { 0xDC179027, "empclip" },
    { 0x7BE986AE, "empdamage" },
    { 0xCF848804, "empdamagedrone" },
    { 0x35EB2C3C, "empdistance" },
    { 0x9D16E332, "empdowntime" },
    { 0xC334C88D, "empduration" },
    { 0x6044D9AE, "emped" },
    { 0x881B0951, "emped_enter" },
    { 0x4208588D, "emped_exit" },
    { 0x13A253C0, "emped_reenter" },
    { 0x1576E3AC, "emped_singleton" },
    { 0x6B70970A, "emped_update" },
    { 0x8F17FF39, "empedby" },
    { 0xE6ECCD82, "empedendtime" },
    { 0xABF6BABA, "empeffect" },
    { 0x2A2BB935, "empeffects" },
    { 0x3C2345F3, "empendtime" },
    { 0x0E1C0328, "empent" },
    { 0xCD50B2C7, "empexplosiondamageents" },
    { 0x198FB697, "empfx" },
    { 0x37805FB0, "empfxdelay" },
    { 0xFFDC4251, "empgrenade" },
    { 0x2BE0D392, "empgrenadecleansewaiter" },
    { 0xF1B43687, "empgrenaded" },
    { 0x4235EF83, "empgrenadedeathwaiter" },
    { 0xFA5231D4, "empgrenadeexplode" },
    { 0xDC9026D2, "empgrenadeshutoff" },
    { 0xCDB61FCF, "empgrenadestokill" },
    { 0x64019B72, "empgrenadetimedout" },
    { 0xCD3A8653, "emphasis" },
    { 0x40C9CE1B, "emphudflickeroff" },
    { 0xD67635A7, "emphudflickeron" },
    { 0x0FCC5EE6, "empirically" },
    { 0x9EBD939F, "empkillstreakbundle" },
    { 0xDF59AE13, "empkillstreakweapon" },
    { 0xD025B95C, "emplaced" },
    { 0x12C7B514, "employed" },
    { 0x38CA2F7D, "employee" },
    { 0x5F709ED4, "empo" },
    { 0x841DA7DA, "empowner" },
    { 0x0D9733D5, "empowners" },
    { 0x0F24425E, "empplayer" },
    { 0xB669EEF1, "empplayerffadisconnect" },
    { 0x4914AB93, "emprebootmenu" },
    { 0x7DADF7B8, "emprumbleloop" },
    { 0x9752E1E8, "emps" },
    { 0x0547E2A8, "empshutdowntime" },
    { 0x527DE770, "empstarttime" },
    { 0x5892E2DE, "empstoptime" },
    { 0x009DC5D7, "emptied" },
    { 0x9664C668, "empties" },
    { 0xE365B116, "emptime" },
    { 0xA50D8FD2, "emptimeout" },
    { 0xACC70B97, "emptracker" },
    { 0x916B3972, "emptrackingstart" },
    { 0xE09CABA4, "empty" },
    { 0x30EFD336, "empty_array" },
    { 0xEF038C1F, "empty_arrived_func" },
    { 0x7B3C526C, "empty_clip_powerup" },
    { 0xE6908A97, "empty_function" },
    { 0xFB8AC53A, "empty_init_func" },
    { 0x79977F70, "empty_kill_func" },
    { 0xCA1774B2, "empty_param" },
    { 0xBE446F29, "empty_spawner" },
    { 0x1C3C9AA0, "empty_spawners" },
    { 0x75836493, "emptyarray" },
    { 0x05F17700, "emptyslot" },
    { 0x7ABC30C0, "emptyspawner" },
    { 0xD9467DDB, "empx" },
    { 0xDAB0AF2E, "emtpy_castro_kill" },
    { 0x9AAD2A28, "emulate" },
    { 0x52039490, "en" },
    { 0xA93730E1, "en_num" },
    { 0xBAE40A28, "enable" },
    { 0x8A5ECE73, "enable3dwaypoints" },
    { 0xF42ED446, "enable_additional_primary_weapon_perk_for_level" },
    { 0x85D59246, "enable_additive_pain" },
    { 0x99421EBF, "enable_afterlife_prop" },
    { 0x460B6FBD, "enable_ai_bleeder" },
    { 0x3B5620D5, "enable_ai_color" },
    { 0x76A97C4A, "enable_ai_color_allies" },
    { 0x32757B63, "enable_ai_revive" },
    { 0x7CE0A3BB, "enable_ai_reviver" },
    { 0x752AE0D0, "enable_aim_assist" },
    { 0xD79DE9C3, "enable_all_tutorial_triggers" },
    { 0x9BC74A0D, "enable_argus" },
    { 0xA7EACE49, "enable_arrivals" },
    { 0xEDCAC3AD, "enable_arrivals_on_last_node" },
    { 0xF099EC5C, "enable_auto_adjust_threatbias" },
    { 0xC130BD7B, "enable_auto_disconnect_path" },
    { 0x9D695D9E, "enable_auto_use" },
    { 0x90BB5837, "enable_base_spawn_managers" },
    { 0xAAE447F0, "enable_blackboard_debug_tracking" },
    { 0xBE9A4B27, "enable_bleeding" },
    { 0x5CC93AA5, "enable_blood" },
    { 0x0F8CD963, "enable_boost_camera_fx" },
    { 0xF38F3AF5, "enable_bow_turret_fire" },
    { 0xE442EE33, "enable_breach_weapon" },
    { 0xA004CA03, "enable_bridge2_destruction" },
    { 0x13743FB8, "enable_brutus_rounds" },
    { 0xFB65B016, "enable_bunker_lightflares" },
    { 0x80A9C472, "enable_buttons" },
    { 0x34B2435A, "enable_callboxes" },
    { 0xDEEACA85, "enable_car_turning" },
    { 0x706E6A05, "enable_careful" },
    { 0x011451F9, "enable_charring" },
    { 0x69107FC0, "enable_claw_fire_direction_feature" },
    { 0xA02FC541, "enable_color_after_anim" },
    { 0xF9C38515, "enable_cover_warning" },
    { 0x4D57C813, "enable_cqb" },
    { 0x9E181F94, "enable_cqbanim" },
    { 0xA0538643, "enable_cqbsprint" },
    { 0x5E8998E4, "enable_cqbwalk" },
    { 0x5544DA23, "enable_cqbwalk_ign_demo_wrapper" },
    { 0x786C76A1, "enable_cybercom" },
    { 0xAAE1D875, "enable_damagefeedback" },
    { 0x4928F643, "enable_deadshot_perk_for_level" },
    { 0x5B480FE3, "enable_divetonuke_perk_for_level" },
    { 0x6BA0E519, "enable_dog_rounds" },
    { 0x67E7F8CD, "enable_doubletap2_perk_for_level" },
    { 0xF85E128E, "enable_driver_turret" },
    { 0x9A81269F, "enable_driver_weapons" },
    { 0x7B2E2F3D, "enable_drone_control" },
    { 0x131D498F, "enable_drown" },
    { 0x66CC6FF1, "enable_drowning" },
    { 0x3842FAB2, "enable_electric_cherry_perk_for_level" },
    { 0xAE736A33, "enable_elevator_buys" },
    { 0xF8AD57DC, "enable_elite" },
    { 0x684F15FF, "enable_emp" },
    { 0x0BE110D3, "enable_extra_cam" },
    { 0xE8A9B12B, "enable_fake_death" },
    { 0x65FD911D, "enable_filter_angola_gun_cam" },
    { 0x98F28B31, "enable_filter_base_frame_transition" },
    { 0x93DF2062, "enable_filter_binoculars" },
    { 0x148AD096, "enable_filter_binoculars_with_outline" },
    { 0xB64257D2, "enable_filter_blood_droplets" },
    { 0xAAEBA942, "enable_filter_blood_spatter" },
    { 0x6C430B78, "enable_filter_blood_splats" },
    { 0x45796C08, "enable_filter_claw_boot" },
    { 0x7C1436CA, "enable_filter_custom_tow" },
    { 0x402EAA2E, "enable_filter_drowning_damage" },
    { 0x714B3E9E, "enable_filter_emp" },
    { 0x0496935C, "enable_filter_ev_interference" },
    { 0x1861F2EA, "enable_filter_f35_damage" },
    { 0xC6391B80, "enable_filter_feedback_blood" },
    { 0xEA3C2F8F, "enable_filter_frame_transition" },
    { 0x2C78ED36, "enable_filter_frost" },
    { 0xA1B351FB, "enable_filter_gasmask" },
    { 0x4FD7205B, "enable_filter_harper_blood" },
    { 0xE063BF35, "enable_filter_hazmat" },
    { 0xCEE27707, "enable_filter_helmet" },
    { 0xF1966B2C, "enable_filter_hud_outline" },
    { 0x5D6F61D9, "enable_filter_hud_projected_grid" },
    { 0xB5049B53, "enable_filter_hud_projected_grid_haiti" },
    { 0x3FA270BC, "enable_filter_hud_projected_pip" },
    { 0x750BC5F1, "enable_filter_karma_lowlight" },
    { 0xA66DB2AF, "enable_filter_karma_spiderbot" },
    { 0x64955317, "enable_filter_keyline_blend" },
    { 0x3D2176F8, "enable_filter_lensflare" },
    { 0xD6CA923E, "enable_filter_massiah" },
    { 0x20F4A80C, "enable_filter_oob" },
    { 0x46839542, "enable_filter_overdrive" },
    { 0x4247AEE0, "enable_filter_oxygenmask" },
    { 0x270B9B5F, "enable_filter_pakistan3_outline" },
    { 0x83E523DD, "enable_filter_pentagon_blowout" },
    { 0xBF5E8093, "enable_filter_pentagon_bulgeblur" },
    { 0x80D90F74, "enable_filter_pentagon_fullscreen" },
    { 0xF4262D24, "enable_filter_pentagon_multicam1" },
    { 0x662D9C5F, "enable_filter_pentagon_multicam2" },
    { 0xBC34F612, "enable_filter_radialblur" },
    { 0xDDC5B293, "enable_filter_rage" },
    { 0xFCD56A01, "enable_filter_rage_hit" },
    { 0xDA6BDA68, "enable_filter_rage_simple" },
    { 0xA40F9AC8, "enable_filter_raindrops" },
    { 0xDCE9FC32, "enable_filter_rccarcam" },
    { 0x646C8255, "enable_filter_rts_hologram" },
    { 0x52736190, "enable_filter_rts_vehicle_damage" },
    { 0x8D5A692B, "enable_filter_sam_damage" },
    { 0x4B6F1E43, "enable_filter_satellite_transition" },
    { 0xCD327356, "enable_filter_sgen_sprite_rain" },
    { 0x09DA3AB7, "enable_filter_sonar_attachment" },
    { 0x85BC9954, "enable_filter_sonar_glass" },
    { 0x84761056, "enable_filter_speed_burst" },
    { 0xF6FF9686, "enable_filter_sprite_blood" },
    { 0xC4E616EE, "enable_filter_sprite_blood_heavy" },
    { 0x6068E36D, "enable_filter_sprite_dirt" },
    { 0x151F2488, "enable_filter_sprite_rain" },
    { 0xD40F55EB, "enable_filter_sprite_transition" },
    { 0xC1F28AA0, "enable_filter_squirrel_raindrops" },
    { 0x04ED1C93, "enable_filter_superflare" },
    { 0x95CE59EF, "enable_filter_tactical" },
    { 0x40B0197B, "enable_filter_tacticalmask" },
    { 0xFB971D9B, "enable_filter_teargas" },
    { 0x7A91BAE8, "enable_filter_teleportation" },
    { 0x4264D7A0, "enable_filter_teleporter_base" },
    { 0x4018823C, "enable_filter_teleporter_sprite" },
    { 0xE927DC0C, "enable_filter_teleporter_top" },
    { 0x96203FD0, "enable_filter_vehicle_damage" },
    { 0x1A848C42, "enable_filter_vehicle_hijack_oor" },
    { 0x9850A644, "enable_filter_vehiclehijack" },
    { 0xC4F1D452, "enable_filter_vision_pulse" },
    { 0x752210EA, "enable_filter_warp_sr71" },
    { 0xB232A996, "enable_filter_water_dive" },
    { 0x794E7807, "enable_filter_water_sheeting" },
    { 0x8CB14040, "enable_filter_zm_turned" },
    { 0x48B7ECDD, "enable_filter_zodiac_raindrops" },
    { 0xFEAA6695, "enable_flag" },
    { 0x9B873D76, "enable_friendly_color" },
    { 0x49BF4F6D, "enable_friendly_color_gradual" },
    { 0x3DDA5FAD, "enable_friendly_fire" },
    { 0x1B9D4011, "enable_gasmask_audio" },
    { 0xB4CFFC35, "enable_ghost_zone_door_ai_clips" },
    { 0x8551205E, "enable_grenades" },
    { 0x9283F29A, "enable_grenades_for_team" },
    { 0x42D7AFCA, "enable_guard" },
    { 0x64FF4520, "enable_hacking" },
    { 0xFCD30F70, "enable_headlook" },
    { 0xF8D657F3, "enable_headlook_notorso" },
    { 0x1A1C4A89, "enable_heat" },
    { 0x4340D172, "enable_heat_behavior" },
    { 0xD91D99ED, "enable_idle_drift" },
    { 0xC47D28B5, "enable_influencers" },
    { 0x49DED1E8, "enable_initial_spawn_influencers" },
    { 0x9CAD8469, "enable_ir_beacon" },
    { 0x242D42BD, "enable_juggernaut_perk_for_level" },
    { 0xC8F12004, "enable_laser" },
    { 0x8F561250, "enable_leaper_rounds" },
    { 0xDFF391D2, "enable_long_death" },
    { 0x97EE3F04, "enable_magic" },
    { 0x24025DB6, "enable_mechz_rounds" },
    { 0xD8C9EF6E, "enable_menu" },
    { 0x59477890, "enable_missiles" },
    { 0x62FB2349, "enable_morse_code" },
    { 0x995CB002, "enable_move_killer" },
    { 0x8713FA1B, "enable_moveup" },
    { 0x19B6CCFB, "enable_mystery_boxes_in_zone" },
    { 0x3BCF8B97, "enable_node" },
    { 0x03F4F84E, "enable_nodes" },
    { 0xED0ABEEE, "enable_object" },
    { 0x8CD89159, "enable_overlay" },
    { 0xD2FDC7BD, "enable_pacifists_to_attack_me" },
    { 0x8D86E3AF, "enable_pain" },
    { 0x27D9A75F, "enable_perk_machines_in_zone" },
    { 0x2469D66C, "enable_phalanx_cannons" },
    { 0xCB73E415, "enable_phdflopper_perk_for_level" },
    { 0xB30B9720, "enable_player" },
    { 0x8DCFABDD, "enable_player_influencers" },
    { 0x6D96E0F1, "enable_player_move_states" },
    { 0x311C0B2B, "enable_player_weapon" },
    { 0x413D9D0A, "enable_player_weapons" },
    { 0xC2E02C73, "enable_powerup_if_no_player_on_bridge" },
    { 0x05C55B70, "enable_quick_revive_perk_for_level" },
    { 0x6092CD3E, "enable_radio_spawn_influencer" },
    { 0xE3FD02FC, "enable_rambo" },
    { 0xF4945C5E, "enable_random_alt_weapon_drops" },
    { 0x26135431, "enable_random_perk_machines_in_zone" },
    { 0x40C2F886, "enable_random_weapon_drops" },
    { 0x9EDDEF7D, "enable_raps_rounds" },
    { 0x795DCA74, "enable_react" },
    { 0xA2E16848, "enable_regular_pain_on_low_health" },
    { 0x2C9E7B54, "enable_rotate_hud" },
    { 0x025B54AD, "enable_rotation" },
    { 0x4F185B91, "enable_scope" },
    { 0xEC609C41, "enable_sleight_of_hand_perk_for_level" },
    { 0xB9AF5D9E, "enable_sms" },
    { 0xE3AD55EF, "enable_sprint" },
    { 0xD5673936, "enable_staminup_perk_for_level" },
    { 0xBEA353C8, "enable_straffing_drone_missiles" },
    { 0xDEF6EE85, "enable_swap_attachments" },
    { 0x616BC618, "enable_swimming" },
    { 0x6DBAF6D4, "enable_tactical_walk" },
    { 0x5223DAF4, "enable_target_laser" },
    { 0x4DD00B59, "enable_trigger" },
    { 0xA224AA12, "enable_trigger_with_noteworthy" },
    { 0xE7A79E95, "enable_trigger_with_targetname" },
    { 0xC7F9BC9F, "enable_triggers_with_noteworthy" },
    { 0x2E0393C0, "enable_triggers_with_targetname" },
    { 0xC45DFB35, "enable_turret" },
    { 0x2C46315E, "enable_turret_emp" },
    { 0x4AEC2FB1, "enable_turret_laser" },
    { 0xE657046A, "enable_turret_static" },
    { 0xC3B14604, "enable_turrets" },
    { 0x529406C2, "enable_vehicle_avoidance" },
    { 0x736A9A5A, "enable_vulture_perk_for_level" },
    { 0x9160F2B2, "enable_wasp_rounds" },
    { 0xF7B87573, "enable_weapon" },
    { 0xBCF9D2B6, "enable_weapon_toggle" },
    { 0xB0DA5222, "enable_weapons" },
    { 0x8D8B2172, "enable_widows_wine_perk_for_level" },
    { 0x189440A9, "enable_wing_tip_trail" },
    { 0x3D1207E5, "enable_zone" },
    { 0x1E71BECA, "enable_zone_elevators_init" },
    { 0xADD4A57C, "enable_zone_on_flag" },
    { 0x4473B3A5, "enable_zone_portals" },
    { 0x3FAAAA0E, "enable_zone_portals_init" },
    { 0x27EAE2DD, "enable_zone_spawn_influencer" },
    { 0x9A203F68, "enableafterlife" },
    { 0x8DAFB866, "enableaimassist" },
    { 0x24D2A47D, "enablebattlechatter" },
    { 0xEB4BBBC3, "enableberserker" },
    { 0xF1F9365D, "enablebind" },
    { 0xCDFA7AF2, "enableclientlinkto" },
    { 0x89006CF3, "enablecling" },
    { 0xB55533BC, "enabled" },
    { 0xB646B007, "enabled_list" },
    { 0xCC70E058, "enabledartmissilelocking" },
    { 0xD8516FE4, "enabledeathicons" },
    { 0xC67E4725, "enabledeathshield" },
    { 0x09A74770, "enabledeathstreak" },
    { 0x94B4FD36, "enablefrontendlockedweaponoverlay" },
    { 0xC6BC5674, "enablefrontendstreamingoverlay" },
    { 0xAB23D927, "enablefrontendtokenlockedweaponoverlay" },
    { 0x03F2411C, "enablegrenadetouchdamage" },
    { 0x19953C39, "enablehealthshield" },
    { 0x4189CC7D, "enableinfluencer" },
    { 0x83FD42B5, "enableinvulnerability" },
    { 0x8F279593, "enablelinkto" },
    { 0xE6CD077E, "enablelockon" },
    { 0x6E5D6588, "enablenavmeshtrigger" },
    { 0x2440A53D, "enableobject" },
    { 0xBC5D23EB, "enableobstacle" },
    { 0x35F19EA9, "enableoccluder" },
    { 0x7EB46A19, "enableoffhandspecial" },
    { 0x4B9F6977, "enableoffhandweapons" },
    { 0xD51AA72A, "enableplayerweapons" },
    { 0xC281D25F, "enablepowerups" },
    { 0x8D7FE2D7, "enablepushtime" },
    { 0xD8D8C261, "enablepvpdamage" },
    { 0x0928985A, "enabler" },
    { 0x6EB828AE, "enablerepath" },
    { 0xA8D99101, "enableroundstartdelay" },
    { 0x2F2B12C3, "enables" },
    { 0x65861B74, "enablespawner" },
    { 0x184C4D67, "enablespawners" },
    { 0xB4643BA5, "enablespawnpointlist" },
    { 0x3CBCDF3A, "enablespeedblur" },
    { 0x84BED14D, "enabletext" },
    { 0x13EC514F, "enablethermaldraw" },
    { 0x12B6DC9B, "enableturretafterwait" },
    { 0x64F21AE5, "enableturretdismount" },
    { 0x0B1C908E, "enableusability" },
    { 0x59354625, "enablevehiclehealthbar" },
    { 0xBAB65D14, "enablevehiclesounds" },
    { 0x9F97706C, "enablewatersheetfx" },
    { 0x6C8F914F, "enableweaponcycling" },
    { 0xCA06DCFC, "enableweaponcyclingafterhold" },
    { 0x34D04C40, "enableweaponfire" },
    { 0x7D186BE3, "enableweaponreload" },
    { 0x901E0817, "enableweapons" },
    { 0x9392DD91, "enablezombies" },
    { 0x0EBAEA29, "enabling" },
    { 0xC95156F4, "enact" },
    { 0x34CF1297, "enacted" },
    { 0x16F6BD80, "enagage_dist" },
    { 0xC297E418, "enale" },
    { 0xCD589DD0, "enclosed" },
    { 0xDE0C47D8, "enclsoed" },
    { 0x9D9728DA, "encoding" },
    { 0x454155B6, "encompased" },
    { 0xCA047F80, "encompass" },
    { 0xF7A83713, "encompassed" },
    { 0xBD830AEC, "encompasses" },
    { 0x734942DC, "encounter" },
    { 0xF8D6721D, "encounter_init" },
    { 0x59BB64BF, "encountered" },
    { 0xFE90762C, "encountering" },
    { 0x2A83561F, "encounters" },
    { 0xF8069E45, "encounters_team" },
    { 0xE8BF29BC, "encourage_player" },
    { 0xED0AF2AD, "encourage_player_to_dive" },
    { 0x538D750D, "encourage_player_toshoot" },
    { 0x8D7E5A10, "encouragement" },
    { 0xC5955897, "encourages" },
    { 0xF87A6DED, "encouraging" },
    { 0x11B6448E, "encroach" },
    { 0x71591EB0, "encroach_nav" },
    { 0xC23698AF, "encroach_start" },
    { 0x4D655CD7, "encroacher" },
    { 0x3C65F950, "encroacherdiv" },
    { 0xA2932231, "encroacherinit" },
    { 0x16B1D532, "encroaching" },
    { 0x80259417, "encroachmaxwait" },
    { 0x24A787FE, "encroachment" },
    { 0xCB152299, "encroachminwait" },
    { 0x14354FB8, "encroachrate" },
    { 0x979200F1, "encroachtimer" },
    { 0x67C63931, "encrypted_phrase" },
    { 0x3C6BCDE6, "encryption" },
    { 0x2E848D0F, "encure" },
    { 0x03FC1574, "end" },
    { 0x18E2BBBB, "end line sound" },
    { 0x6412E650, "end04" },
    { 0x3F23B514, "end04_fade_out_black" },
    { 0xD43651CE, "end04_start_drag" },
    { 0x8A1560B9, "end05" },
    { 0xC0302897, "end05_fade_out_black" },
    { 0x742BCF19, "end05_start_drag" },
    { 0x9045BDD4, "end05_start_kids" },
    { 0xB017DB22, "end06" },
    { 0xCF2B485A, "end06_fade_out_black" },
    { 0x7EFB75B4, "end06_start_drag" },
    { 0xA1AE001D, "end06_start_kids" },
    { 0xE563C6BE, "end2" },
    { 0x13CA2F01, "end_action" },
    { 0x13CA82D7, "end_admin_heroes_initial_cover_think" },
    { 0xE0BCC1F5, "end_air_battle_manager_" },
    { 0xF6923C10, "end_air_battle_manager_start_landing_vtols" },
    { 0xE1BA9EBD, "end_alpha" },
    { 0x25C792E5, "end_amb_airstrikes_vo" },
    { 0x122E25EC, "end_ambient_asd" },
    { 0x2F120971, "end_ambient_drones" },
    { 0x5FDC9054, "end_ambient_drones_" },
    { 0x9C48AB16, "end_ambient_drones_start_drop_group_3" },
    { 0xDE3C4709, "end_ambient_drones_start_drop_group_4" },
    { 0xB839CCA0, "end_ambient_drones_start_drop_group_5" },
    { 0xD8E8C482, "end_ambient_hips" },
    { 0x88B607E8, "end_ambushwaitfunction" },
    { 0xF27B62C0, "end_ammo_cleanup" },
    { 0x6A90F059, "end_and_clean_patrol_behaviors" },
    { 0xFB498ADC, "end_angle" },
    { 0x42F4AE1F, "end_angles" },
    { 0x4858795C, "end_anim_reach" },
    { 0x7BCB6D93, "end_anim_snapshot" },
    { 0xC5C17B1F, "end_anim_thread" },
    { 0x2F2E297B, "end_arena_migs" },
    { 0x3A271186, "end_array" },
    { 0xE8F330BF, "end_asm_terminated_thread" },
    { 0xF3B632F7, "end_asm_timeout_thread" },
    { 0x61CC13FB, "end_at_node" },
    { 0x63F079B8, "end_at_num_guys" },
    { 0x44FD873A, "end_attack_thread" },
    { 0x1F81BE6D, "end_attack_thread_gun" },
    { 0xB0C6A8C1, "end_attack_thread_rocket" },
    { 0x4A1EAA99, "end_audio_idle_loop" },
    { 0xCB7DB361, "end_avogadro_turbines" },
    { 0x59C979E9, "end_b2_anim_loops" },
    { 0xABD5C295, "end_bang" },
    { 0x0A9B2CD1, "end_banzai_attack" },
    { 0x30297992, "end_banzai_charge_yell" },
    { 0x7D692252, "end_base_attack_thread" },
    { 0x4168BC9B, "end_base_migs" },
    { 0xE4C51C76, "end_beat_trigger" },
    { 0x93B53267, "end_binocular_scene" },
    { 0xD5EC9871, "end_blink_notify" },
    { 0xC180AE12, "end_blocker1_conversation" },
    { 0x999F3D74, "end_blur" },
    { 0xD87DF241, "end_bmp_action" },
    { 0xD63C61BC, "end_boat_sounds" },
    { 0xAC615690, "end_boost" },
    { 0x34155802, "end_bottom" },
    { 0xA9EBC461, "end_bp3_fail_safe" },
    { 0xCD2D1D25, "end_bp3_spawn_manager_cleared" },
    { 0xEB96B2C7, "end_breathing" },
    { 0x24AA1206, "end_bridge_launchers" },
    { 0x3AE0BE8C, "end_bunker_paper_burner_scenes" },
    { 0x58FE4F27, "end_burst" },
    { 0x3ED2BFC0, "end_cache_loop" },
    { 0xB4574E56, "end_camera" },
    { 0x6043E632, "end_carry_vo" },
    { 0x56EEA934, "end_chain_street_left_1" },
    { 0xC8F6186F, "end_chain_street_left_2" },
    { 0x458BC1A3, "end_chalk_dust" },
    { 0x97C4A733, "end_chase_vo" },
    { 0x067E4A6F, "end_cia_easter_egg" },
    { 0xD9078C43, "end_cluster_grenades" },
    { 0xDD641994, "end_color" },
    { 0x14520943, "end_condition1" },
    { 0xA24A9A08, "end_condition2" },
    { 0xC84D1471, "end_condition3" },
    { 0x89620CC1, "end_confirm" },
    { 0x66D601BB, "end_contextual_melee" },
    { 0xD33BD3E6, "end_cool_downs" },
    { 0x84657533, "end_cqb_debug" },
    { 0x71FC50D1, "end_cqb_tracking" },
    { 0xBA674C33, "end_credits_music" },
    { 0x7CEB0F52, "end_current_shoot" },
    { 0xE794F764, "end_current_tank_paths" },
    { 0xE34383F4, "end_curve_1" },
    { 0x554AF32F, "end_curve_2" },
    { 0x2F4878C6, "end_curve_3" },
    { 0x713C14B9, "end_curve_4" },
    { 0x726A1213, "end_damage_effects" },
    { 0xE5C2F3D9, "end_damage_filter" },
    { 0x234507B4, "end_damage_filter_watcher" },
    { 0x33C96657, "end_damage_state_index" },
    { 0xC9DDB997, "end_death_delay" },
    { 0x32D2508F, "end_decrease" },
    { 0x10B8FABA, "end_delete" },
    { 0x561AB6A3, "end_delete_patrol" },
    { 0x958588C5, "end_delete_secondfloor" },
    { 0xA156B054, "end_demo_jump_listener" },
    { 0xFD908400, "end_detection" },
    { 0xBD42FD88, "end_dialog_finished" },
    { 0x6AF85E15, "end_dialog_sequence" },
    { 0x5AF68795, "end_dialogue" },
    { 0xEE9EB6DF, "end_dialogue_broken_stealth" },
    { 0xA17F2FEF, "end_dialogue_when_stealth_breaks" },
    { 0x7D40A044, "end_difficulty_report_index" },
    { 0xF327FC23, "end_diorama_fx_3" },
    { 0xDDCB0E96, "end_diorama_smoke" },
    { 0x5EDE2398, "end_dir" },
    { 0x9436266E, "end_donotrackusedonhacked" },
    { 0xEA82002A, "end_donotrackusedonpickup" },
    { 0xD4E3135C, "end_door_pos" },
    { 0x0935812C, "end_dot" },
    { 0x314F846A, "end_draw_map_bounds" },
    { 0x92FB6891, "end_drive" },
    { 0x7FFCB739, "end_drive_vo" },
    { 0x7B4D272B, "end_drone_behaviors" },
    { 0xCDD68DD3, "end_drone_swap" },
    { 0x1F7AF066, "end_duplicate_fadein" },
    { 0x19523FBC, "end_dust_fx" },
    { 0xB2AB13D6, "end_dying_crawl_back_aim" },
    { 0xCFAC0D04, "end_emp_behavior" },
    { 0xE238CCB2, "end_emp_monitor_distance" },
    { 0x654EF0B7, "end_enemy_player" },
    { 0xE50E00FD, "end_enemy_street_vo" },
    { 0x55828FAA, "end_ent" },
    { 0x07BF2808, "end_escape_run" },
    { 0x672755E3, "end_execution" },
    { 0x48C54E97, "end_exit_gr_rumble" },
    { 0x1EAFF3C3, "end_expl_manager_" },
    { 0x24F1F606, "end_expl_manager_drones" },
    { 0xA310B007, "end_expl_manager_intro" },
    { 0xE5A3F888, "end_expl_manager_landing" },
    { 0x0E618EB6, "end_expl_manager_pregameplay" },
    { 0xB2EB62C3, "end_expl_manager_vtols" },
    { 0xEB19095E, "end_explode" },
    { 0x72B3E970, "end_exploder_number" },
    { 0x4E71FE33, "end_exploders" },
    { 0xBF92F1E3, "end_extended_death" },
    { 0x74DD31FD, "end_extra_control_room" },
    { 0xA7EEB330, "end_extra_locker_room" },
    { 0x821356AD, "end_fade" },
    { 0xAA5D6E0D, "end_fade_in" },
    { 0x203A65EC, "end_fade_out" },
    { 0xAB02B20C, "end_failsafe_reenable_offhand_special" },
    { 0x0E1C0E7D, "end_fake_water_tread" },
    { 0xBF5CC0E8, "end_fakefire_1" },
    { 0x31643023, "end_fakefire_2" },
    { 0xDC807A57, "end_far_loop" },
    { 0x7149B052, "end_fardist" },
    { 0xB265F2C7, "end_fight" },
    { 0x9F9DC02F, "end_fight_console_player" },
    { 0xD9D4B2CC, "end_fight_drago_dead" },
    { 0xDAFBE74E, "end_fight_drago_fire" },
    { 0x87A6095A, "end_fight_drago_shot" },
    { 0x9D8540CA, "end_fight_intro_dragovich" },
    { 0x69BFC422, "end_fight_intro_dragovich_slowmo" },
    { 0x70EA7518, "end_fight_intro_player" },
    { 0x4E7BEC1D, "end_fight_lose" },
    { 0x55F78FD7, "end_fight_lose_dragovich" },
    { 0x3B44449F, "end_fight_lose_player" },
    { 0x73D4B31A, "end_fight_win_dragovich" },
    { 0x4E1E1D68, "end_fight_win_player" },
    { 0xF66D3F52, "end_firing" },
    { 0x17B9BA39, "end_flag" },
    { 0xC334D0F3, "end_float" },
    { 0x41F4426D, "end_floating" },
    { 0xD1CE0591, "end_flock_manager_" },
    { 0x163F49EC, "end_flock_manager_start_landing_vtols" },
    { 0xBDF2610B, "end_flock_manager_start_landing_vtols_2" },
    { 0x7180CE76, "end_forest_drones" },
    { 0x311948ED, "end_forest_drones_2" },
    { 0x400A1590, "end_fov" },
    { 0x35E40052, "end_freefall" },
    { 0xBDEF4AE3, "end_friend_1" },
    { 0x4BE7DBA8, "end_friend_2" },
    { 0x71EA5611, "end_friend_3" },
    { 0x9D8B25FF, "end_friendly_player_shoot_watcher" },
    { 0x3993BA5A, "end_fullscreen_glasses_bink" },
    { 0x98CEDAD9, "end_func" },
    { 0xE6E399A9, "end_game" },
    { 0x9EDC9D41, "end_game_early" },
    { 0xAE330754, "end_game_flow" },
    { 0x8B2B6810, "end_game_introduction" },
    { 0x61DBDF53, "end_game_player_was_spectator" },
    { 0x7E93C9A2, "end_game_reward_maxis" },
    { 0x7ADE6E5E, "end_game_reward_maxis_wrapper" },
    { 0x6E9A98B4, "end_game_reward_richtofen" },
    { 0x4ED93DA0, "end_game_reward_richtofen_wrapper" },
    { 0x2FA3F68C, "end_game_reward_starts_maxis" },
    { 0x8353484E, "end_game_reward_starts_richtofen" },
    { 0x5E3571BB, "end_game_state" },
    { 0x3CADF69B, "end_game_taunts" },
    { 0x5EB91F18, "end_game_turn_off_vulture_overlay" },
    { 0x62B83777, "end_game_turn_off_whoswho" },
    { 0x4B6B216D, "end_game_video" },
    { 0x6746BE69, "end_game_warning_num" },
    { 0x30E38AD2, "end_gameover_snapshot" },
    { 0xA72AB89B, "end_gap_anim" },
    { 0x39C8A092, "end_gas_door_blocker" },
    { 0x146D52DD, "end_gauntlet" },
    { 0x9E962514, "end_getoutrig_abort_while_deploying" },
    { 0xE352229D, "end_ghost_round" },
    { 0x74C6BA92, "end_glasses_bink" },
    { 0x7ADE0315, "end_goal_node" },
    { 0xA1E7162D, "end_groans" },
    { 0x46E0EDED, "end_ground_sounds" },
    { 0xE2CE4F26, "end_gun_jam" },
    { 0x11348D97, "end_guys" },
    { 0xCDC78607, "end_hacker_hud" },
    { 0x38FD13B9, "end_handle_player_fall" },
    { 0xE955FBCD, "end_hands_animator" },
    { 0xEC97F019, "end_health_fade_off_watcher" },
    { 0xF9283C47, "end_health_regen" },
    { 0x3CB5F638, "end_healthregen" },
    { 0x2369D4CE, "end_heartbeat_loop" },
    { 0xB9F00ECA, "end_height" },
    { 0x8B4D43CB, "end_heli" },
    { 0xBA2911CE, "end_heli_circle" },
    { 0x6788CE81, "end_hind_action" },
    { 0x224446B8, "end_hip_drop_off" },
    { 0xDE45CE1B, "end_horse_charge_scenes" },
    { 0x25684B1C, "end_house_fail" },
    { 0xD3531FB9, "end_html_table" },
    { 0x524E70EB, "end_huey_attack" },
    { 0xFC04002B, "end_huey_attack_special" },
    { 0xDA8839F7, "end_huey_use_mg" },
    { 0x6F193E90, "end_hunt" },
    { 0xBCAA5A3D, "end_idle" },
    { 0xDDE01E26, "end_igc" },
    { 0x893FBBB3, "end_immolating_thread" },
    { 0x48926C19, "end_in_tube_rumble" },
    { 0x4ED8D59D, "end_index" },
    { 0xD93563AC, "end_intro_flak" },
    { 0x59B1CBF8, "end_invulnerability" },
    { 0xB0CD75F5, "end_jeep_tow_ride" },
    { 0xDA16903B, "end_jeep_vo" },
    { 0x4BF661A3, "end_jetwing_rumble" },
    { 0x0F2FC023, "end_jump" },
    { 0x4B905323, "end_jump_mantle" },
    { 0xDED47A5C, "end_killcam" },
    { 0x60D4443E, "end_last_stand" },
    { 0x34BE73B6, "end_launch" },
    { 0xA3223469, "end_launch_dialog" },
    { 0x5DB023E3, "end_level" },
    { 0xB11C546E, "end_level_dialog" },
    { 0x4E84F524, "end_level_fade" },
    { 0x539B7959, "end_level_fade_out" },
    { 0x03B09315, "end_level_hud" },
    { 0x2861BD47, "end_level_music_switcher" },
    { 0xA7095486, "end_level_music_waiter_polonsky" },
    { 0x662B2763, "end_level_music_waiter_sarge" },
    { 0x1F18FE2F, "end_level_polonsky" },
    { 0xFA8AC17D, "end_level_roebuck" },
    { 0x80ACEEF2, "end_level_snapshot" },
    { 0xA13E838B, "end_level_stats" },
    { 0xCB826294, "end_life_link" },
    { 0x2B462D33, "end_lightning" },
    { 0xE848B5E7, "end_limo_escaped_fail" },
    { 0xF67691D9, "end_line" },
    { 0x2725A21B, "end_loc" },
    { 0x1D3D68BE, "end_local_power" },
    { 0x0D6E3F12, "end_lock_on" },
    { 0x5D1AEF6C, "end_look_ent" },
    { 0x0E363E95, "end_loop" },
    { 0x1656FE63, "end_looping_sound" },
    { 0x315E8EC6, "end_low_vehicle" },
    { 0x405E970F, "end_lvl" },
    { 0xEDA479DE, "end_machinegun_attack_thread" },
    { 0x6856CEA2, "end_magic_bullet_glass" },
    { 0x5A45D9E4, "end_main" },
    { 0x54A2867E, "end_main_drones_1" },
    { 0xD241BC91, "end_maneuvers" },
    { 0xC05F8FE8, "end_mangrove_drones" },
    { 0xF039852A, "end_mantle_angle" },
    { 0x9A6B2487, "end_market_vo" },
    { 0x735BAB79, "end_mason_final_push_checker" },
    { 0xE8DBE591, "end_mason_hill_wave2" },
    { 0x14DF0BEA, "end_meat" },
    { 0xB24B27DD, "end_melee" },
    { 0xB3D7B4B9, "end_melee_all" },
    { 0x78C6C5D5, "end_melee_struggle" },
    { 0xBD5A8BA9, "end_menendez" },
    { 0xF5F97654, "end_mg_behavior" },
    { 0x44C92869, "end_microwaveentitypostshutdowncleanup" },
    { 0x13B31285, "end_missile" },
    { 0x27BAAE97, "end_mission" },
    { 0xF6876ED2, "end_monkey_attacks" },
    { 0x3ED54E9C, "end_monkey_steal" },
    { 0x3D519007, "end_movement_thread" },
    { 0x7007D77F, "end_moveup" },
    { 0xEC17BC11, "end_movie" },
    { 0xA888EF2A, "end_msg" },
    { 0xF9554262, "end_msg_1" },
    { 0xD352C7F9, "end_msg_2" },
    { 0x78940070, "end_music" },
    { 0x558E404C, "end_nag_flag" },
    { 0x37A8C4E9, "end_neardist" },
    { 0xC5308256, "end_next_wave_timer" },
    { 0x83C45A56, "end_nixie_countdown" },
    { 0xC28B56B3, "end_node" },
    { 0x6E2F5AD0, "end_node1" },
    { 0xE036CA0B, "end_node2" },
    { 0xB357B383, "end_node_goto" },
    { 0x4B63FFC2, "end_nojump" },
    { 0x960B9698, "end_notetrack" },
    { 0x199E0D00, "end_notify" },
    { 0x72A13F79, "end_nudge_collision" },
    { 0x2F703B08, "end_obj6" },
    { 0xC84F467D, "end_objective_trigger" },
    { 0xA9599ADA, "end_of_crowd_anim" },
    { 0x591771F4, "end_of_game_summary" },
    { 0x3D476D56, "end_of_game_summary_begin" },
    { 0x3DEF8D9A, "end_of_game_summary_end" },
    { 0x80B00F5A, "end_of_jungle_escape" },
    { 0xA5CC5273, "end_of_level" },
    { 0xF40E1EE3, "end_of_rope" },
    { 0x191BB225, "end_of_round" },
    { 0xE837177C, "end_of_round_cleanup" },
    { 0xD6305DF2, "end_of_script" },
    { 0x5D9CB37E, "end_of_scripting" },
    { 0xD74C7782, "end_of_scripting_burn" },
    { 0x9319CF9C, "end_of_street_cars" },
    { 0x9D4A1AE0, "end_of_track" },
    { 0x9D411F9C, "end_of_tunnels_movies" },
    { 0x264C2CCC, "end_on" },
    { 0xB1FE3C1B, "end_on_death" },
    { 0x39D70352, "end_on_end" },
    { 0x6820682E, "end_on_goal" },
    { 0x63CB60F8, "end_on_notify" },
    { 0xFEA9FB9A, "end_on_timer" },
    { 0x5B475E0F, "end_org" },
    { 0x91627C91, "end_origin" },
    { 0x3DA0A5EF, "end_other_blood_splat" },
    { 0x6CC6E004, "end_overdrive_boost_fx" },
    { 0xE46E1FDD, "end_overlay" },
    { 0xF6D1AD38, "end_pacifist" },
    { 0xD19D4706, "end_path_interrupt" },
    { 0x196E3A95, "end_path_magic_rpgs" },
    { 0x3A962A36, "end_path_truck" },
    { 0xE2A515E6, "end_pathcheck" },
    { 0x26A06965, "end_patrol" },
    { 0x1D62EE96, "end_patrol_blocker_trigger_fail" },
    { 0xF25E32A6, "end_patrol_on_enemy_targetting" },
    { 0x64AE4E61, "end_pbr" },
    { 0x6AA13149, "end_pipe_slide" },
    { 0x15DDDF76, "end_plant_message" },
    { 0xCCFB5134, "end_play_body" },
    { 0x69167DB5, "end_play_punch_pain_anim" },
    { 0x8AF7F733, "end_play_subwoofer_pain_anim" },
    { 0xAC142B25, "end_play_thundergun_pain_anim" },
    { 0x6BA5D022, "end_player_block" },
    { 0x0CCF26FA, "end_player_breath_audio" },
    { 0xF01E7A33, "end_player_heli" },
    { 0xF5609BDD, "end_player_in_soct_fail" },
    { 0xCAB1AE2F, "end_point" },
    { 0xA8A166F1, "end_point_notify" },
    { 0xC9A22076, "end_points" },
    { 0xFA146125, "end_portal" },
    { 0x679A97B7, "end_pos" },
    { 0xC9D14E5C, "end_pos1" },
    { 0x8B223EBF, "end_pos_1" },
    { 0x9E46254A, "end_position" },
    { 0xC2BB9180, "end_position_ent" },
    { 0xEC429285, "end_positions" },
    { 0x8E88E5E2, "end_prevent_stuck" },
    { 0xB66EB629, "end_print3d" },
    { 0x55925AB5, "end_print_fx" },
    { 0x70ADDA17, "end_pt" },
    { 0x75536DEC, "end_race" },
    { 0xAFDF62C5, "end_radius" },
    { 0x12D3B76A, "end_rage_health_fade" },
    { 0x37C46ADB, "end_rage_high_player_damage_vo" },
    { 0x4C584D9E, "end_rage_low_player_fire_vo" },
    { 0x500B2D8B, "end_rage_melee_player_vo" },
    { 0x65DF0E67, "end_rage_sprint_vo" },
    { 0x6548E30F, "end_rail" },
    { 0x854E9D4F, "end_rail_gunner_truck" },
    { 0x1943EE3D, "end_rain" },
    { 0xDE4A2229, "end_random_scale" },
    { 0x0F162DBB, "end_rappel" },
    { 0x40C6A646, "end_rappel_scene" },
    { 0xBD3CEB04, "end_redshirts_behavior" },
    { 0x80DD40EA, "end_reflect" },
    { 0xB691E43D, "end_remote" },
    { 0x564C0CF7, "end_remote_control_ai_tank" },
    { 0x3D085248, "end_remote_control_turret" },
    { 0xEDEE8D35, "end_remote_sentry" },
    { 0x564139BB, "end_report_damage" },
    { 0xD27732D2, "end_repulsor_fx" },
    { 0xD9C9CB29, "end_respawn" },
    { 0xC12701E1, "end_revive_watcher" },
    { 0x83CF5C5C, "end_reznov_speech" },
    { 0x006F8249, "end_ride" },
    { 0x15612CC1, "end_road_rpg_guy" },
    { 0x77EB1A59, "end_rocket_attack_thread" },
    { 0x24D60C1C, "end_rocket_audio" },
    { 0x537B9C50, "end_rocket_strat" },
    { 0xE78062CA, "end_rotate" },
    { 0x975F7014, "end_rotate_barge" },
    { 0xED57B2B5, "end_round" },
    { 0x8AE54550, "end_round_think" },
    { 0x835DC078, "end_rounds_early" },
    { 0xDD19A303, "end_rpg_spot" },
    { 0xF14265CC, "end_rts" },
    { 0x5FE1BC9B, "end_salazar_speed_control" },
    { 0x04F43717, "end_scale" },
    { 0x41FB4525, "end_scene" },
    { 0x35EB65FE, "end_scene_actor_unlink_on_death" },
    { 0x6C1AB9DA, "end_scene_actors" },
    { 0xE36F9BB2, "end_scene_dialogue" },
    { 0x57FBDAB6, "end_scene_if_i_die" },
    { 0x372F1B3C, "end_scene_node" },
    { 0x58025C85, "end_schrecks" },
    { 0x4C30F0C7, "end_screen" },
    { 0x9B08D9A2, "end_script" },
    { 0x85C63E5E, "end_script_corner" },
    { 0x67A94BE2, "end_scripting_for_burn" },
    { 0xFF3DC863, "end_sea_cowbell" },
    { 0x5DA1AADA, "end_seaknight_leaving" },
    { 0xD8432ABF, "end_second_delete" },
    { 0xFFD5D93C, "end_sequence" },
    { 0x49548F5E, "end_sequence_clean_up" },
    { 0xA8642046, "end_sequence_physics_explosion" },
    { 0xBFE7A76D, "end_sergei_hold_loop" },
    { 0xB8383AD5, "end_sergei_loop" },
    { 0xC8386114, "end_sgt_loop" },
    { 0xBB35B6A3, "end_shoot_while_moving" },
    { 0xCFCE38DB, "end_shot" },
    { 0x7E8D136B, "end_sink_ship" },
    { 0x345B4A7C, "end_slo_mo" },
    { 0xCB648204, "end_slowmo" },
    { 0xC148F46B, "end_solo_loop" },
    { 0x7778B26B, "end_sounds" },
    { 0xF5E63990, "end_spawners" },
    { 0x759545BE, "end_speed_control" },
    { 0x7B9F637A, "end_speedscale" },
    { 0xD46634AB, "end_speedup" },
    { 0xAABABBB5, "end_spline_behavior" },
    { 0x1AEB12E3, "end_spot" },
    { 0x3DF05BF1, "end_spot_array" },
    { 0xC7FBA7D2, "end_spots" },
    { 0xA9E3945D, "end_sprint_hint" },
    { 0xE20CD351, "end_sprint_to_goal" },
    { 0xF2B3715D, "end_stand_idle_thread" },
    { 0xA408C121, "end_start" },
    { 0x30A15719, "end_start_player_anim" },
    { 0x7ED981BE, "end_static_loop_black" },
    { 0x51950578, "end_stealth" },
    { 0x2F9FCC58, "end_strangle_scene" },
    { 0xD30ADA46, "end_street" },
    { 0x4F21A2D4, "end_struct" },
    { 0xFADC9C3B, "end_sun_color" },
    { 0xFB29505C, "end_superflare" },
    { 0xE2AD787C, "end_synchronized_melee" },
    { 0x13303B9E, "end_tank_fire_at" },
    { 0x864A6F04, "end_tank_reset_turret" },
    { 0x3E9AA344, "end_target" },
    { 0x37FA4A8F, "end_team_change_watch" },
    { 0x29B9359F, "end_tellmemore_conversation" },
    { 0x8ECB0419, "end_tf" },
    { 0xA06D3FC5, "end_the_game" },
    { 0x5C9A9963, "end_the_intro" },
    { 0xFF53D7A9, "end_the_summary" },
    { 0x7D1D3D30, "end_time" },
    { 0xB19D2E1B, "end_time_ms" },
    { 0x90E17D1D, "end_timescale_over_time" },
    { 0x06471C12, "end_toggle_field_fx_" },
    { 0xBB5D4E18, "end_top" },
    { 0xF06180F4, "end_train_idle_1" },
    { 0x6268F02F, "end_train_idle_2" },
    { 0x3C6675C6, "end_train_idle_3" },
    { 0x252B470D, "end_trig" },
    { 0x16C6E7CD, "end_trigger" },
    { 0xE24413DE, "end_trigger1" },
    { 0xBC419975, "end_trigger2" },
    { 0x963F1F0C, "end_trigger3" },
    { 0xE19AB6D0, "end_trigger_thread" },
    { 0xF5E3260C, "end_truck1_spawns" },
    { 0x3D355AD9, "end_truck2_spawns" },
    { 0xC4DE391E, "end_truck3_spawns" },
    { 0x5E980EDA, "end_truck_gunner" },
    { 0xE87D9C8F, "end_truck_gunner_think" },
    { 0x0C5A288C, "end_turn_obj_breadcrumb" },
    { 0x3051C0B2, "end_turret_audio" },
    { 0xF62D8533, "end_turret_keyline" },
    { 0xB02688CE, "end_turret_reservation" },
    { 0x352FC935, "end_turret_scanning" },
    { 0x243B75AC, "end_unacquire_weapon_thread" },
    { 0xCA490675, "end_unaware_behavior" },
    { 0x7C284023, "end_underwater_snapshot" },
    { 0x82017C20, "end_unstoppableforce_boost_fx" },
    { 0x01A70496, "end_v_node" },
    { 0xDCBC7038, "end_val" },
    { 0x1BE11912, "end_value" },
    { 0xB9E1F423, "end_vec" },
    { 0xE5E4AFE0, "end_veh_collision_watcher" },
    { 0xCA5CFEC8, "end_vehicle_switch" },
    { 0xE8B21ED4, "end_vision_set_power" },
    { 0xCDED6C62, "end_vo" },
    { 0x50F96761, "end_vo_at_tunnel_end" },
    { 0x1031303C, "end_wait" },
    { 0x19931D06, "end_wait_condition" },
    { 0xBD051E0D, "end_wait_loop" },
    { 0x5B47442A, "end_watch_for_attacks" },
    { 0x3ABBA251, "end_water_visionset" },
    { 0xB1298B0D, "end_weap_cleanup" },
    { 0xF6D7C69C, "end_weapon_grab" },
    { 0xF55CB8FB, "end_weapon_swap" },
    { 0xE1B85CEB, "end_window" },
    { 0x6D7CF208, "end_woods_freakout_trigger" },
    { 0x55677768, "end_yard_drones_2" },
    { 0xD9C8782F, "end_yard_retreat" },
    { 0xA0A5E37A, "end_zipline_debug" },
    { 0xA64C8FC1, "endaiming" },
    { 0x3FECA860, "endalpha" },
    { 0xAFA6E2B6, "endammo" },
    { 0x6B2E8F85, "endangle" },
    { 0x6E5A0D14, "endangles" },
    { 0x0C1EA903, "endanim" },
    { 0x880ACA2B, "endanimationlocation" },
    { 0xC3CF2D4B, "endanimdeath" },
    { 0x49955765, "endanimdeathloop" },
    { 0xAB6E77FF, "endanimdelta" },
    { 0x2EB1688D, "endanimloop" },
    { 0xF4E2D359, "endanimloopdeath" },
    { 0xADE63EA3, "endanimloopdeathloop" },
    { 0xC54C51AB, "endbanzailaststand" },
    { 0x1F0688DD, "endblend" },
    { 0xB8B7FCDA, "endblendtime" },
    { 0xD59A1980, "endcamanimscripted" },
    { 0xE9F4BE0E, "endclip" },
    { 0x113419F8, "endcondition1" },
    { 0x833B8933, "endcondition2" },
    { 0x5D390ECA, "endcondition3" },
    { 0x898ACDCF, "endcustomevent" },
    { 0x8072BA94, "enddartremotecontrol" },
    { 0x6CE8DF75, "enddeaths" },
    { 0x216C467D, "enddebuginfo" },
    { 0xACC1BBDC, "enddefeatreasontext" },
    { 0x834051A9, "enddir" },
    { 0x485BE877, "enddirection" },
    { 0x403C1CD4, "enddist" },
    { 0x08355023, "enddrag_actors" },
    { 0x5206B49D, "enddrawstring" },
    { 0x20A03517, "ended" },
    { 0x5551058F, "ended_final_killcam_cleanup" },
    { 0x548EAF1E, "ended_killcam_cleanup" },
    { 0x43AB661C, "endedearly" },
    { 0x0C6AB8B2, "endedfinalkillcamcleanup" },
    { 0x40CE2FCC, "endedkillcamcleanup" },
    { 0xFA9DBAAE, "endee" },
    { 0x2584F8C5, "endelem" },
    { 0xA4876CFD, "enden" },
    { 0xDC69B011, "ender" },
    { 0x05D4A40A, "ender1" },
    { 0xDFD229A1, "ender2" },
    { 0xB9CFAF38, "ender3" },
    { 0x89A6D9F2, "ender_flag" },
    { 0x48869F1A, "endextracamanimscripted" },
    { 0x240A1F0D, "endfight_fog_settings" },
    { 0x4E5390FF, "endfire_node" },
    { 0x3F4E3E32, "endflag" },
    { 0x07EF18AD, "endfov" },
    { 0xBE775B7B, "endframe" },
    { 0x0FE02A7C, "endfullthreshold" },
    { 0x11BC1B62, "endgame" },
    { 0xE3E5599E, "endgame_damage" },
    { 0x6C5F97FE, "endgame_sequence" },
    { 0xCBB0CBA3, "endgame_trig" },
    { 0xA59E087E, "endgamefunction" },
    { 0xDAD2DBE6, "endgamemannequin" },
    { 0xE5C306CF, "endgamemessage" },
    { 0xC8FA349A, "endgameonscorelimit" },
    { 0xF1B9C317, "endgameontimelimit" },
    { 0x957C57FC, "endgamesplayed" },
    { 0xCB9154CD, "endgameupdate" },
    { 0x7799A666, "endgamexcamname" },
    { 0x69A3D868, "endgates" },
    { 0x881FE205, "endgoal" },
    { 0x5A1ADB4D, "endheight" },
    { 0x0C2C1362, "endhits" },
    { 0xADBEA1D2, "endidle" },
    { 0x0457ACF7, "endidleatframeend" },
    { 0xA7AF6B51, "endif" },
    { 0xAA0C586F, "endind" },
    { 0x3804E934, "ending" },
    { 0x227309E9, "ending_ai" },
    { 0x5293A16B, "ending_allies_run" },
    { 0x02344F01, "ending_ammo" },
    { 0xD184B132, "ending_bog_redshirts" },
    { 0x85EAED9A, "ending_brightness" },
    { 0x545FF6A4, "ending_ceiling" },
    { 0xCF1118BF, "ending_choppers" },
    { 0x67249ABA, "ending_claw_behaviour" },
    { 0x3011BEE7, "ending_cowbell" },
    { 0x293E64F7, "ending_dialog" },
    { 0x5894B0CA, "ending_dofchange" },
    { 0x52B56D4D, "ending_doors_playeranim" },
    { 0xE6AFFA1A, "ending_dying_near_goal_node" },
    { 0x149C2110, "ending_enemies_kill" },
    { 0xCF9BD208, "ending_enemies_think" },
    { 0xCD09E29F, "ending_explosions" },
    { 0x5C73334B, "ending_explosions_large" },
    { 0xB9822EB7, "ending_explosions_small" },
    { 0x4E9E3AA3, "ending_extended_death" },
    { 0xE63FB5BE, "ending_f35_think" },
    { 0xC535AFEB, "ending_floor" },
    { 0x35F88F67, "ending_hazmat_ai" },
    { 0x09765A87, "ending_hazmat_ai2" },
    { 0x34D6A409, "ending_heartbeat" },
    { 0xCF83BFBB, "ending_hostile_drone_2_behaviour" },
    { 0x633D63E8, "ending_hostile_drone_behaviour" },
    { 0x860C0FA4, "ending_hostile_drones_dead" },
    { 0x2BD1DA94, "ending_in_position" },
    { 0x22DA0A63, "ending_launch_ai" },
    { 0xC105C8B3, "ending_node_name" },
    { 0x46CF4283, "ending_outside_capture" },
    { 0xA66AA560, "ending_outside_killed" },
    { 0x538C92EA, "ending_ready_to_mount" },
    { 0x06A7076E, "ending_rejoice" },
    { 0x77A17533, "ending_rpg_fail" },
    { 0x12BCF758, "ending_rumble" },
    { 0xFCFE1F36, "ending_run_explosion" },
    { 0xDD05D6FC, "ending_sequence" },
    { 0x1FE66AAB, "ending_set_time" },
    { 0x5AD9870F, "ending_shadowchange" },
    { 0x9B6D193F, "ending_signal" },
    { 0x75C7EAC4, "ending_slowmo" },
    { 0x09CAF485, "ending_smoke_pillar" },
    { 0x8AADB763, "ending_soldier_1" },
    { 0x18A64828, "ending_soldier_2" },
    { 0x3EA8C291, "ending_soldier_3" },
    { 0xFCB5269E, "ending_soldier_4" },
    { 0x6F267CE1, "ending_speech" },
    { 0x61DF42E1, "ending_start" },
    { 0xC0756FDB, "ending_switch_to_player" },
    { 0x815801B6, "ending_tank_1_think" },
    { 0x8085E75C, "ending_timeout" },
    { 0xCF4CE65B, "ending_timeout_fail" },
    { 0xE65BEF2F, "ending_tracers_large" },
    { 0xEE5A679B, "ending_tracers_small" },
    { 0x9901363E, "ending_tunnel_ai" },
    { 0xA68E5F5F, "ending_vc_action" },
    { 0x558A0722, "ending_vo" },
    { 0x1EE93409, "ending_vtol_think" },
    { 0xC64308D2, "endingorigin" },
    { 0x74B79EAC, "endings_anims" },
    { 0x3C98601D, "endings_main" },
    { 0xA56D3A36, "endinwater" },
    { 0xE6E4A5AF, "endiswallrun" },
    { 0xE3C47A21, "endkillcam" },
    { 0x879719D7, "endkills" },
    { 0x4FE4527C, "endkillstreaktimers" },
    { 0xAA9409CF, "endleadin" },
    { 0x33D1E98F, "endless_mf_grenades_mf" },
    { 0x3EC9C842, "endlessly" },
    { 0xC3ACBEC6, "endlevel" },
    { 0x089678D8, "endlevel_transition" },
    { 0xD14A0054, "endlobby" },
    { 0x8E3BC4DE, "endloc" },
    { 0x2A71E77D, "endlocationselection" },
    { 0x53A3D1A0, "endlocs_route1" },
    { 0x1E45C235, "endlook" },
    { 0x0C1F9454, "endlookyloosnap" },
    { 0x1ACECEC1, "endlosses" },
    { 0x2925BFD9, "endmeleeonkillanimscript" },
    { 0x1B4FE12C, "endmessagedefaultduration" },
    { 0xA486B1AA, "endmgstreak" },
    { 0x3B74C6CF, "endmgstreakwhenleavemg" },
    { 0x887E8258, "endmisses" },
    { 0x51AF5883, "endmovement" },
    { 0x71AFF40F, "endmsg" },
    { 0xE3D78B27, "endmusicpackage" },
    { 0xF4E6DC2C, "endnewenemyreactionanim" },
    { 0x372D66E8, "endnode" },
    { 0xCA0485F1, "endnode1" },
    { 0x16097AC3, "endnode3" },
    { 0x956AE083, "endnodes" },
    { 0x47604E39, "endnodestn" },
    { 0x49FF66B8, "endnote" },
    { 0x9D2DDFCF, "endnotify" },
    { 0xFA26CD12, "endofahead" },
    { 0x1A71BBE3, "endofbehind" },
    { 0x3F9D5F5A, "endoffullfxsq" },
    { 0x6AE741A2, "endofhalffxsq" },
    { 0xCE17CB48, "endoflineentity" },
    { 0x2FC951D2, "endofside" },
    { 0xA4348A8E, "endofstateconnection" },
    { 0x428A889F, "endon" },
    { 0x59898B94, "endon1" },
    { 0xCB90FACF, "endon2" },
    { 0x1B8F782B, "endon_bad_path" },
    { 0x0CF00F21, "endon_condition" },
    { 0xEB253101, "endon_ent" },
    { 0x06FBDF20, "endon_flag" },
    { 0xF5671C73, "endon_goal" },
    { 0x7BE66641, "endon_msg" },
    { 0x65742D37, "endon_name" },
    { 0xB4040A61, "endon_notify" },
    { 0x12723A12, "endon_signal" },
    { 0x1508AF1D, "endon_signals" },
    { 0xAE2FEAD3, "endon_str" },
    { 0xE68145CD, "endon_string" },
    { 0x275D5D7B, "endonbus" },
    { 0x49CDA2B7, "endondeath" },
    { 0xFB840CCD, "endonevent" },
    { 0x6B7D2DF5, "endonflag" },
    { 0x2FC14444, "endongoo" },
    { 0xBD76CEA6, "endonmsg" },
    { 0x0E96A787, "endonnote" },
    { 0xC58E87F4, "endonnotify" },
    { 0xA0FEB116, "endonremoveanimactive" },
    { 0x24EFE626, "endons" },
    { 0xBEBC2430, "endonstr" },
    { 0x9AA326A8, "endonstring" },
    { 0x4263DB9A, "endonstring2" },
    { 0x68665603, "endonstring3" },
    { 0x8E68D06C, "endonstring4" },
    { 0xD0D8EF06, "endontimer" },
    { 0x617E5F61, "endontrig" },
    { 0x7E575574, "endonweaponstring" },
    { 0xD828A97D, "endonwhat" },
    { 0x46D82B16, "endorg" },
    { 0x55D26589, "endorgs" },
    { 0xD0697212, "endorigin" },
    { 0x4653CE6C, "endoverride" },
    { 0x5AB1469C, "endparent" },
    { 0x2DFE7320, "endparty" },
    { 0xF7599715, "endpathrandomness" },
    { 0xB0D72D0F, "endplayerbreathingsoundondeath" },
    { 0x56F00A76, "endpoint" },
    { 0x576BFE7B, "endpoint1" },
    { 0xE5648F40, "endpoint2" },
    { 0xDBC71A4F, "endpoint_tn" },
    { 0x6AC461B2, "endpos" },
    { 0x92CF0EDB, "endpose" },
    { 0xB8B1F3CD, "endposition" },
    { 0x73749340, "endposition_" },
    { 0x1FFF389B, "endprediction" },
    { 0xA62A4645, "endpregame" },
    { 0x223C519F, "endprestige" },
    { 0xD506B2A0, "endprice_actors" },
    { 0xD025C298, "endprogressbar" },
    { 0x9E5E5350, "endpt" },
    { 0x54EB6606, "endradius" },
    { 0xEC43E68A, "endrate" },
    { 0x7494BE90, "endreason" },
    { 0x35492F1B, "endreasonstring" },
    { 0x10EC1005, "endreasontext" },
    { 0xB4B73481, "endreasonypos" },
    { 0x28A576CD, "endremotecontrol" },
    { 0x6D35A80D, "endremotecontrolweapon" },
    { 0xF7D11BC2, "endremotecontrolweaponuse" },
    { 0x80C222CC, "endremoteturret" },
    { 0x8C04DB67, "ends" },
    { 0x16D0FEF6, "ends_closed" },
    { 0x014BBCC6, "ends_on_death" },
    { 0x9E089B3C, "endscene" },
    { 0xA3F79152, "endscore" },
    { 0x8E1DD5A3, "endscripting" },
    { 0xFFFC8211, "endselectionon" },
    { 0xD7AAF14A, "endselectionongameend" },
    { 0x1AC6BEA1, "endselectiononhostmigration" },
    { 0x71AEE04A, "endselectionthink" },
    { 0xC3F9C5BD, "endsentinelremotecontrol" },
    { 0xE78D2B94, "endshot" },
    { 0xFFA32106, "endshotloop" },
    { 0x5161A329, "endslider_entrance_clip" },
    { 0x107E8E72, "endslides" },
    { 0x0619DD2C, "endslo" },
    { 0x98E9ED4A, "endspawni" },
    { 0x06BDDF15, "endspeed" },
    { 0x9CAC995A, "endsquadcommandselectionon" },
    { 0xFA7AA82B, "endsquadcommandselectionongameend" },
    { 0x1A2485D1, "endst" },
    { 0xC1DC18E6, "endstandidlethread" },
    { 0xEE59ECE7, "endstring" },
    { 0x23F559EF, "endsuncolor" },
    { 0x8A50BB70, "endswamp" },
    { 0x69F947BD, "endtankremotecontrol" },
    { 0x20301A6B, "endtargetyawupdate" },
    { 0xCD916B35, "endteleportthread" },
    { 0x29185D28, "endtest" },
    { 0xFCF8066F, "endthedirty" },
    { 0xC93A4EEC, "endthread" },
    { 0xE48BEEC7, "endtime" },
    { 0x49EDF33C, "endtimeplayedtotal" },
    { 0xA76D8185, "endtransanim" },
    { 0x06FDF18B, "endturretremotecontrol" },
    { 0x6794E271, "endtwitch" },
    { 0x00B314BC, "endtype" },
    { 0xDFC2FB4B, "endunawarebehavior" },
    { 0x1C1C6C85, "endunlockpoints" },
    { 0xDE1CEBAE, "endured" },
    { 0x61A99450, "endusecallback" },
    { 0x4E744509, "endval" },
    { 0x2B8CC06F, "endvalue" },
    { 0x706C686F, "endvictoryreasontext" },
    { 0x72A508E7, "endwait" },
    { 0xB156854B, "endwatchforbflagcapaftertime" },
    { 0x988973AE, "endwatchforemoveremoteweapon" },
    { 0x81999F8E, "endwatchforoverheat" },
    { 0x08E31EF0, "endwatchforremoveremoteweapon" },
    { 0x89153FFC, "endwaterheight" },
    { 0xC726E1E9, "endwins" },
    { 0x46CDA0F5, "endyaw" },
    { 0x29FE8FDD, "ene" },
    { 0x4A4CF472, "enem" },
    { 0xD5FF82BC, "enemeies" },
    { 0x2DD1359B, "enemeis" },
    { 0x5E3477A0, "enemey" },
    { 0x657B1773, "enemies" },
    { 0xAD9BC910, "enemies1" },
    { 0x1FA3384B, "enemies2" },
    { 0xF9A0BDE2, "enemies3" },
    { 0x6BA82D1D, "enemies4" },
    { 0x45A5B2B4, "enemies5" },
    { 0xB7AD21EF, "enemies6" },
    { 0x965D8429, "enemies_alive" },
    { 0x12ADDBCC, "enemies_at_the_door" },
    { 0x65686371, "enemies_capture1" },
    { 0x8B6ADDDA, "enemies_capture2" },
    { 0xB16D5843, "enemies_capture3" },
    { 0x472FD95F, "enemies_charge_allies" },
    { 0x474C3092, "enemies_close" },
    { 0xA989C976, "enemies_death_msg" },
    { 0xF417EC8F, "enemies_delayed_kill" },
    { 0x03948031, "enemies_fall_back" },
    { 0xF28E428C, "enemies_fall_back_thread" },
    { 0x3F7A0AA4, "enemies_hit_num" },
    { 0xCE286879, "enemies_ignore_equipment" },
    { 0x40140039, "enemies_ignore_player_hacking_turret" },
    { 0x18CD3181, "enemies_in_range" },
    { 0xE16FFFD5, "enemies_left" },
    { 0xC87F1669, "enemies_left_on_deck" },
    { 0x97076F98, "enemies_locked_on_me_threat_bias" },
    { 0x0A293B67, "enemies_locked_on_me_threat_bias_duration" },
    { 0x392335B9, "enemies_locking_on_me_threat_bias" },
    { 0x9623F214, "enemies_locking_on_me_threat_bias_duration" },
    { 0xB0892EAC, "enemies_new" },
    { 0x8FEF51D5, "enemies_remain_in_zone" },
    { 0x56DD3EC6, "enemies_still_alive" },
    { 0xCE22A02C, "enemieskilledbyplayer" },
    { 0xFD805952, "enemieskilledintimewindow" },
    { 0x4500CB8E, "enemiesonbus" },
    { 0xA641C430, "enemiespresent" },
    { 0x85842561, "enemieswithinstandingrange" },
    { 0x6050AB17, "enemy" },
    { 0x3E37CCC6, "enemy01" },
    { 0x1835525D, "enemy02" },
    { 0x392D56DF, "enemy_1" },
    { 0xC725E7A4, "enemy_2" },
    { 0xBBE20BD1, "enemy_accuracy" },
    { 0xFBBC167F, "enemy_accuracy_assignment" },
    { 0x10BA05A7, "enemy_activity_before_log_scene" },
    { 0x529B39FC, "enemy_ai" },
    { 0x54581DF4, "enemy_ai_damage" },
    { 0xE1D63B75, "enemy_ai_disable_grenades" },
    { 0xEA3C7F5C, "enemy_ai_keep_your_distance" },
    { 0x6E1CC728, "enemy_ai_ratio" },
    { 0x536F5EA5, "enemy_aigroup" },
    { 0x5929F7BF, "enemy_ais" },
    { 0xAC67F12B, "enemy_alert_level" },
    { 0x1D31A20E, "enemy_alert_level_alerted_again" },
    { 0x1847430D, "enemy_alert_level_alerted_once" },
    { 0x7A86276A, "enemy_alert_level_attack" },
    { 0x0B15DBE2, "enemy_alert_level_change" },
    { 0xEA099619, "enemy_alert_level_forget" },
    { 0xE7172510, "enemy_alert_level_logic" },
    { 0x2DF0A072, "enemy_alert_level_lostem" },
    { 0x76652623, "enemy_alert_level_normal" },
    { 0xB56C2492, "enemy_alert_level_waittime" },
    { 0x096E9F98, "enemy_already_spotted" },
    { 0xC15C560E, "enemy_angles" },
    { 0xE817280B, "enemy_animation_attack" },
    { 0x9633B55E, "enemy_animation_custom" },
    { 0xE0D01BB8, "enemy_animation_do_anim" },
    { 0x30402189, "enemy_animation_foundcorpse" },
    { 0x28B2852A, "enemy_animation_generic" },
    { 0xB3B5CE0D, "enemy_animation_loop" },
    { 0x71B17F12, "enemy_animation_nothing" },
    { 0x2F08389B, "enemy_animation_post_anim" },
    { 0x2168FBFA, "enemy_animation_pre_anim" },
    { 0xA6B4F8A6, "enemy_animation_sawcorpse" },
    { 0x6AE00124, "enemy_animation_whizby" },
    { 0x84C3CC18, "enemy_animation_wrapper" },
    { 0x26539A7E, "enemy_announce_corpse" },
    { 0x9CE74CA7, "enemy_announce_hmph" },
    { 0xFA3A78D5, "enemy_announce_huh" },
    { 0xBBD99447, "enemy_announce_snd" },
    { 0x1695236B, "enemy_announce_snd_reset" },
    { 0x806D8A5D, "enemy_announce_spotted" },
    { 0x38B87CE8, "enemy_announce_spotted_bring_team" },
    { 0x6CCF18B3, "enemy_announce_wtf" },
    { 0x5BAFCE5F, "enemy_armor" },
    { 0x7F22FA2D, "enemy_array" },
    { 0xB7872FC6, "enemy_attack" },
    { 0x7F46451D, "enemy_attack_current_origin" },
    { 0xB002FFAC, "enemy_attack_current_time" },
    { 0x28E207C0, "enemy_attack_shout" },
    { 0x499B50A7, "enemy_attack_start_distance" },
    { 0x7D6E8200, "enemy_attack_start_origin" },
    { 0x65E280AE, "enemy_attack_start_stance" },
    { 0x96AB40FD, "enemy_attack_start_time" },
    { 0xA9077979, "enemy_attacks" },
    { 0x162A62C6, "enemy_awareness_loop" },
    { 0x29F38FA5, "enemy_awareness_reaction" },
    { 0xDC66793C, "enemy_awareness_reaction_attack" },
    { 0xB0F48EDD, "enemy_awareness_reaction_explosion" },
    { 0x90394890, "enemy_awareness_reaction_flashbang" },
    { 0x365CE018, "enemy_awareness_reaction_heard_scream" },
    { 0x262361BA, "enemy_awareness_reaction_safety" },
    { 0x8EBB17FF, "enemy_awareness_reaction_whizby" },
    { 0x00A39F41, "enemy_base" },
    { 0x037A53FF, "enemy_basin_tanks" },
    { 0x2F526155, "enemy_battle_think" },
    { 0xBB493E11, "enemy_before_clean_room" },
    { 0x387971B0, "enemy_bike_deathfx" },
    { 0xBA5B9A0C, "enemy_bike_rail_tether_logic" },
    { 0x3A744B88, "enemy_bike_rider_spawning_in_progress" },
    { 0xE8FA20F0, "enemy_blindfire_wait_time_max" },
    { 0x53F7964E, "enemy_blindfire_wait_time_min" },
    { 0xE87049F3, "enemy_blowup_bridge" },
    { 0xBE0E22AB, "enemy_bmp" },
    { 0xDD583A7E, "enemy_boat_ramming" },
    { 0x350AF372, "enemy_boat_reinforce" },
    { 0xF4182023, "enemy_breach_doors" },
    { 0x8379C72A, "enemy_breached_wire" },
    { 0x0D00C1C1, "enemy_center" },
    { 0x9E69AF40, "enemy_chatter_time_max" },
    { 0x4B92407E, "enemy_chatter_time_min" },
    { 0xC60D9A7B, "enemy_chopper" },
    { 0x09767C89, "enemy_chopper_inbound" },
    { 0xE140EF8B, "enemy_clean_up" },
    { 0x293E4B23, "enemy_clinging" },
    { 0x2B48BCDC, "enemy_close_in_on_target" },
    { 0xEFBC7F7D, "enemy_color_chain" },
    { 0xA9392B35, "enemy_color_hint_trigger_think" },
    { 0xDEC44147, "enemy_contact_watcher" },
    { 0x01ECD2B5, "enemy_cornerr" },
    { 0xD560D6FB, "enemy_corpse_add_to_stack" },
    { 0x8FA5DA96, "enemy_corpse_alert_level" },
    { 0x9209B248, "enemy_corpse_clear" },
    { 0x81FC5E31, "enemy_corpse_death" },
    { 0x6F22D0BB, "enemy_corpse_found" },
    { 0x3BDE678C, "enemy_corpse_found_behavior" },
    { 0x89BD6B70, "enemy_corpse_found_loop" },
    { 0xB14F8F51, "enemy_corpse_logic" },
    { 0x9818CB97, "enemy_corpse_loop" },
    { 0xED5A09EA, "enemy_corpse_reaction_takenode" },
    { 0xD39E4C7D, "enemy_corpse_saw_behavior" },
    { 0x2A1ADBE4, "enemy_corpse_saw_wrapper" },
    { 0x6920A235, "enemy_corpse_shorten_stack" },
    { 0x1D538B1F, "enemy_count" },
    { 0xAB95D804, "enemy_damage_override" },
    { 0xDB3CBADD, "enemy_damaged_by_freezegun" },
    { 0x6F6C0F18, "enemy_data_save_filter_func" },
    { 0x9E420F23, "enemy_data_save_func" },
    { 0x1612A0B8, "enemy_death_detection" },
    { 0x08FBE991, "enemy_death_watcher" },
    { 0xAE1E13CC, "enemy_default_ai_functions" },
    { 0x4B99AF94, "enemy_detects_player_vo" },
    { 0xE0728793, "enemy_dialog_zone" },
    { 0xAD92287C, "enemy_dialogue" },
    { 0xE645284D, "enemy_dist_sq" },
    { 0x49CECF67, "enemy_distance" },
    { 0x89281E95, "enemy_dodge_bike" },
    { 0xBB90AAFD, "enemy_dog_init" },
    { 0x71EC38A1, "enemy_dog_locations" },
    { 0x16B4E557, "enemy_dog_spawns" },
    { 0x5856C87D, "enemy_dogs_inbound" },
    { 0xE8EBA043, "enemy_door_trigger" },
    { 0x9DDF1327, "enemy_dot" },
    { 0x7CB9CC1A, "enemy_drone_setup" },
    { 0x5E866F39, "enemy_emp_active" },
    { 0x0AB71319, "enemy_ent" },
    { 0xD1FC05B1, "enemy_enter_meatshield_room" },
    { 0x47537F17, "enemy_equipment_shader_active" },
    { 0xD6171545, "enemy_equipment_shader_hacked" },
    { 0x96A7E840, "enemy_equipment_shader_off" },
    { 0x80708156, "enemy_evasion_reaction_time_max" },
    { 0x657B55A8, "enemy_evasion_reaction_time_min" },
    { 0xD275B7A8, "enemy_event_awareness" },
    { 0xC02B8DDD, "enemy_event_declare_to_team" },
    { 0xC6773705, "enemy_event_listeners_init" },
    { 0x94C7F11F, "enemy_event_listeners_logic" },
    { 0x176EB2B7, "enemy_event_listeners_proc" },
    { 0x5CE3F776, "enemy_exposed" },
    { 0xB6236D9D, "enemy_eye" },
    { 0x609F69FE, "enemy_eye_pos" },
    { 0x12DAF4E0, "enemy_fighting_looping_audio" },
    { 0x6E7082D8, "enemy_find_nodes_at_origin" },
    { 0xE6FEFEAF, "enemy_find_original_goal" },
    { 0x86CABC5A, "enemy_flag_influencer" },
    { 0xB2FD113A, "enemy_found_corpse_loop" },
    { 0x775F0C2F, "enemy_found_in_the_dark" },
    { 0x2FA6AD9F, "enemy_get_closest_pathnodes" },
    { 0x231E6CCA, "enemy_go_back" },
    { 0xF2B781D6, "enemy_goal_update_after_anim" },
    { 0x92AF6ABB, "enemy_grave_tanks" },
    { 0xA5EFFF07, "enemy_grenades" },
    { 0xD1BD0948, "enemy_ground_pos" },
    { 0x61F89AEC, "enemy_health" },
    { 0x6854FBC1, "enemy_hears_explosion" },
    { 0x18543C07, "enemy_heli_reinforcement_barncenter" },
    { 0xF473310F, "enemy_heli_reinforcement_barnleft" },
    { 0x0FA070BC, "enemy_heli_reinforcement_cowfield" },
    { 0x9A61E806, "enemy_heli_reinforcement_parkinglot" },
    { 0x5789752F, "enemy_heli_reinforcement_shoulder" },
    { 0x4B00EDFC, "enemy_helo" },
    { 0xA2489AF5, "enemy_highlight_display" },
    { 0x43EE2D3F, "enemy_highlight_display_frame" },
    { 0xEAB5058B, "enemy_highlight_display_pulse" },
    { 0x5F9074E0, "enemy_highlight_display_stop" },
    { 0xE88F18D7, "enemy_highlight_elems" },
    { 0xF8F1EFF7, "enemy_highlight_ents" },
    { 0x283C782F, "enemy_hind_damage" },
    { 0x39D5556E, "enemy_hind_dead" },
    { 0x197837A1, "enemy_hind_dmg_fx" },
    { 0x0A193B32, "enemy_hind_fire_rocket_barrage" },
    { 0xD4272E16, "enemy_hind_fire_single_rocket" },
    { 0xA8FB34DF, "enemy_hind_keep_dist_from_target" },
    { 0x1905ABC4, "enemy_hind_minigun_attack" },
    { 0x0AC41E8F, "enemy_hind_move_position" },
    { 0xA395143D, "enemy_hind_ratio" },
    { 0xA4553583, "enemy_hind_rocket_attack" },
    { 0x3859C78C, "enemy_hind_set_flag_on_death" },
    { 0xF4A222CC, "enemy_hind_think" },
    { 0x7DC33951, "enemy_hind_weapon_think" },
    { 0xC0BFDBA2, "enemy_hinds_arrive" },
    { 0xE62DF241, "enemy_hip" },
    { 0xF47A12A3, "enemy_hip_1_death_watcher" },
    { 0x19181F60, "enemy_hip_1_think" },
    { 0xB42544B4, "enemy_hip_2_death_watcher" },
    { 0x902C4397, "enemy_hip_2_destroy_huey" },
    { 0x1E0B3BDB, "enemy_hip_2_think" },
    { 0x8A8F80B5, "enemy_hip_cleanup_if_passed" },
    { 0xA0ED5D97, "enemy_hip_damage" },
    { 0xBCFD3D78, "enemy_hip_fire_player" },
    { 0x5869A028, "enemy_hip_rappel" },
    { 0xBB0B63B2, "enemy_hip_rappel_death_watcher" },
    { 0xEA846E05, "enemy_hip_ratio" },
    { 0x9B87B4D5, "enemy_hip_strafe" },
    { 0x6A3B6044, "enemy_hip_strafe_fire" },
    { 0x08D5F968, "enemy_hips" },
    { 0x5681F2D9, "enemy_hunting_player" },
    { 0xCF051717, "enemy_in_foliage" },
    { 0xD68E368A, "enemy_in_region" },
    { 0x869C7035, "enemy_in_sight" },
    { 0x9C2051A5, "enemy_infantry" },
    { 0x5B45E2BF, "enemy_infantry_spawn_setup" },
    { 0x96004894, "enemy_infantry_tank_encroach" },
    { 0xAB0B4F78, "enemy_influencer_radius" },
    { 0xD60EFF10, "enemy_influencer_score" },
    { 0xCEE9B914, "enemy_influencer_score_curve" },
    { 0x209BAE84, "enemy_init" },
    { 0xDE1EC8FE, "enemy_interior_flashbangs" },
    { 0x2F0BEB74, "enemy_interior_grenadeswap" },
    { 0xD521FD9B, "enemy_investigate_explosion" },
    { 0x4699CAB4, "enemy_is_below" },
    { 0xB7C9F335, "enemy_is_dog" },
    { 0xD8BF3A5A, "enemy_is_hind" },
    { 0x6CD37E3B, "enemy_is_not_valid" },
    { 0xC245B139, "enemy_is_tank" },
    { 0x5D9CEB71, "enemy_killed" },
    { 0x760C6A2F, "enemy_killed_by_dw_microwavegun" },
    { 0x800DBABB, "enemy_killed_by_freezegun" },
    { 0xCE2F74CB, "enemy_killed_by_jetgun" },
    { 0x227551B1, "enemy_killed_by_microwavegun" },
    { 0x24E25DFC, "enemy_killed_by_subwoofer" },
    { 0x88A72013, "enemy_killed_by_tesla" },
    { 0x05705AB6, "enemy_killed_by_thundergun" },
    { 0x875B92CC, "enemy_killed_thread" },
    { 0x8DEF8DCB, "enemy_kills_using_sniper_tree_challenge" },
    { 0xC6C67662, "enemy_kills_with_beartrap_challenge" },
    { 0x8C0A28FE, "enemy_lab_ext_0" },
    { 0xEE890AFB, "enemy_lab_ext_0_ai" },
    { 0xFB370E83, "enemy_lab_in_back" },
    { 0x0D775034, "enemy_lab_in_hallway" },
    { 0x05ABBDFD, "enemy_left_1" },
    { 0x2BAE3866, "enemy_left_2" },
    { 0x479F59F0, "enemy_left_4" },
    { 0x927B769B, "enemy_light_fx" },
    { 0xE9CB5C0A, "enemy_loadout_reset" },
    { 0x9830C3A7, "enemy_location" },
    { 0x0EC0A572, "enemy_location_override" },
    { 0x19DF7C63, "enemy_location_override_func" },
    { 0x94369F28, "enemy_locked" },
    { 0x78169FED, "enemy_locking" },
    { 0xA38B14EC, "enemy_logic" },
    { 0xB4D70B03, "enemy_look_dir_offset" },
    { 0xA01A5994, "enemy_look_dir_offst" },
    { 0xB568172A, "enemy_mass" },
    { 0x1EF427B7, "enemy_mass_trigger" },
    { 0xBF981425, "enemy_melee_damage_override" },
    { 0x12B60A4C, "enemy_message_loop" },
    { 0xC35636F2, "enemy_motion_direction" },
    { 0x44E1AF23, "enemy_motion_time_delta" },
    { 0xE3F29D5F, "enemy_moved" },
    { 0x4B26E89B, "enemy_noteworthy" },
    { 0xB569FDA7, "enemy_notification" },
    { 0x8198D69A, "enemy_on_bus" },
    { 0x472F4D5A, "enemy_on_roof" },
    { 0x5ACD6159, "enemy_on_top_of_metro" },
    { 0xB526E13E, "enemy_on_turret" },
    { 0x14E6E90C, "enemy_org" },
    { 0xDBE533C0, "enemy_origin" },
    { 0xFBB03FEB, "enemy_origins" },
    { 0x6480C442, "enemy_override" },
    { 0xD0F59F27, "enemy_percent_damaged_by_freezegun" },
    { 0xC943F68D, "enemy_player" },
    { 0xF1D742E3, "enemy_population" },
    { 0xCF92DA34, "enemy_pos" },
    { 0x1E0A37D0, "enemy_predicted_position" },
    { 0xB1BF639C, "enemy_radius" },
    { 0x069CB541, "enemy_rail_bikes" },
    { 0x64FB0C79, "enemy_raps_global_locations" },
    { 0x40DE9AB2, "enemy_reaction_state_alert" },
    { 0xC23C5242, "enemy_remaining" },
    { 0xB33F1CC8, "enemy_replenish" },
    { 0xD488822A, "enemy_respawn" },
    { 0xFC426CC1, "enemy_respawn_listener" },
    { 0x3F854A96, "enemy_rocket_damage" },
    { 0x272DB0C0, "enemy_rpg_damage_override" },
    { 0x434B63EC, "enemy_run_from_forest_to_beach" },
    { 0x5C66F07B, "enemy_runner_in_warehouse_spawner" },
    { 0xD2406DD1, "enemy_runto_and_lookaround" },
    { 0xFE9E2111, "enemy_sam_damage" },
    { 0xCC87D13F, "enemy_sam_ratio" },
    { 0xB17B56EC, "enemy_sam_samage" },
    { 0x68B947AF, "enemy_saw_corpse_logic" },
    { 0x885C1C39, "enemy_setup" },
    { 0xD133F17D, "enemy_sniper_spotted_vo" },
    { 0x556A5ABF, "enemy_soct_attach_wheel" },
    { 0x12FF40CE, "enemy_soct_damage_override" },
    { 0x7F7FB528, "enemy_soct_must_shoot_logic" },
    { 0x48F2DD2F, "enemy_soct_setup" },
    { 0x6D74966A, "enemy_soct_shoot_logic" },
    { 0x6ED9E4AB, "enemy_soct_speed_control" },
    { 0x58CCDABC, "enemy_soct_stop_firing_at_end" },
    { 0x63EC654F, "enemy_spawn" },
    { 0x69694EA9, "enemy_spawn_control" },
    { 0xE7BE9ED6, "enemy_spawn_function" },
    { 0xE5C7B116, "enemy_spawn_locations" },
    { 0x17123A35, "enemy_spawn_time" },
    { 0x7FB63EF0, "enemy_spawn_zone" },
    { 0x3EABD3E7, "enemy_spawned_influencer_radius" },
    { 0x242263A9, "enemy_spawned_influencer_score" },
    { 0xC10B1CBD, "enemy_spawned_influencer_score_curve" },
    { 0x0DC8812C, "enemy_spawned_influencer_timeout_seconds" },
    { 0x3E4E7F32, "enemy_spawner" },
    { 0x009009A7, "enemy_spawner_targetname" },
    { 0xA1AF0216, "enemy_spawns" },
    { 0x598BA9D5, "enemy_speed_control" },
    { 0x3AA83D9D, "enemy_spotlight_pos" },
    { 0x91F4FE95, "enemy_spotted" },
    { 0x4E99A1D6, "enemy_spotted_clear_favorite" },
    { 0x234EE042, "enemy_spotted_dialogue" },
    { 0x16D26E60, "enemy_squad" },
    { 0xC08F9DD0, "enemy_squad_queue" },
    { 0xA3460DC5, "enemy_squad_spawnasquad" },
    { 0x75FC96F5, "enemy_squad_spawner" },
    { 0xC61B9B78, "enemy_stairs" },
    { 0x39B2EEED, "enemy_stairs_0" },
    { 0x13B07484, "enemy_stairs_1" },
    { 0xDB2B7E6E, "enemy_stance" },
    { 0x574B210E, "enemy_state_alert" },
    { 0xF3A49DB0, "enemy_state_hidden" },
    { 0x857D98F3, "enemy_state_spotted" },
    { 0xD432FDC9, "enemy_stop_current_behavior" },
    { 0x65E74690, "enemy_tag_array" },
    { 0x2F96592A, "enemy_tank" },
    { 0x52A6BCCF, "enemy_tank_dead" },
    { 0x9E7CBF4F, "enemy_tank_encroach_mvmt" },
    { 0x08E1B8D6, "enemy_tank_wait_for_friendly_tank_to_die" },
    { 0x0CE5A1E5, "enemy_tanks" },
    { 0x6B4C79EA, "enemy_tanks_extra" },
    { 0xB1FBAA8B, "enemy_target_update" },
    { 0x103490B4, "enemy_targets" },
    { 0x36A7B4ED, "enemy_team" },
    { 0x97F592A8, "enemy_team_mask" },
    { 0x011C5F59, "enemy_team_name" },
    { 0x8F232C47, "enemy_teams_mask" },
    { 0xD1AA5C12, "enemy_think_wait" },
    { 0xD7768DC6, "enemy_threat" },
    { 0x3B9DCF91, "enemy_threat_logic" },
    { 0x7A8FF6D2, "enemy_threat_logic_dog" },
    { 0x0589E8D7, "enemy_threat_loop" },
    { 0x4A4369C5, "enemy_threat_set_spotted" },
    { 0xE78B4163, "enemy_to_player" },
    { 0xD52D0955, "enemy_triggers" },
    { 0xAB113025, "enemy_trigspawn" },
    { 0x5564FA87, "enemy_troops_inbound" },
    { 0xE0FD0E28, "enemy_trucks_crash_through_barrier" },
    { 0x8DAB4771, "enemy_try_180_turn" },
    { 0x231EBB32, "enemy_type" },
    { 0x79621B24, "enemy_type_default" },
    { 0xF0A0322D, "enemy_unit_delayzones" },
    { 0xABF6AA4B, "enemy_units" },
    { 0x3D0DA636, "enemy_units_nextid" },
    { 0xCA86514B, "enemy_unitthinkcb" },
    { 0x5C89E73C, "enemy_vec" },
    { 0x9E7D832F, "enemy_veh" },
    { 0xF66E67D3, "enemy_vehicle_active" },
    { 0x687F7159, "enemy_vehicle_hacked" },
    { 0xAFEA5932, "enemy_vehicle_inactive" },
    { 0x9D0F15B1, "enemy_vehicles" },
    { 0xBDB9DF1F, "enemy_vel_offset" },
    { 0x9AF5263F, "enemy_velocity" },
    { 0x21B30838, "enemy_visible" },
    { 0x5C938BC7, "enemy_vo" },
    { 0x6D880EC8, "enemy_vo_post_log_pre_house" },
    { 0x1040782D, "enemy_vtol" },
    { 0xFB09C13F, "enemy_wait_for_damage" },
    { 0x273ED4AB, "enemy_wait_for_whizby" },
    { 0x35B83DDF, "enemy_wait_to_be_killed" },
    { 0x8580C6EA, "enemy_wasp_global_locations" },
    { 0x7FA2FADF, "enemy_wave_control" },
    { 0x52C5BD5F, "enemy_weapon_influencer_length" },
    { 0x53CAE219, "enemy_weapon_influencer_radius" },
    { 0x601A149F, "enemy_weapon_influencer_score" },
    { 0x744CE493, "enemy_weapon_influencer_score_curve" },
    { 0x125BB22B, "enemy_wetness" },
    { 0x16BCE384, "enemy_within_shoot_radius" },
    { 0x80597F3B, "enemy_yaw" },
    { 0xEF095088, "enemy_yaw_vec" },
    { 0x68FE333D, "enemy_zone_spawner" },
    { 0x0A75AB07, "enemy_zpu_damage" },
    { 0x6A2FC6D5, "enemy_zpu_ratio" },
    { 0x786884D4, "enemyaccuracy" },
    { 0xF28B9955, "enemyai" },
    { 0xC0BBE830, "enemyangle" },
    { 0xEA9C339B, "enemyangles" },
    { 0x2B04E115, "enemyapproachtrig" },
    { 0x1A858AE4, "enemyarmor" },
    { 0xC94A2638, "enemyarmorindex" },
    { 0x399C5F4A, "enemyarray" },
    { 0xF6B66E04, "enemybasepoi" },
    { 0x618D77FC, "enemybestspawnflag" },
    { 0x97F0918D, "enemycarrier" },
    { 0xAB84F319, "enemycarriervisible" },
    { 0x02C99545, "enemyclass" },
    { 0x8E9B318E, "enemycontactleveldelay" },
    { 0xDB6A54A4, "enemycount" },
    { 0x9305FA3D, "enemycounteruavactive" },
    { 0x7DBFBB48, "enemycrateobjid" },
    { 0xCD7A38E0, "enemycrosshairrange" },
    { 0x2FCCECE0, "enemycuavactive" },
    { 0x434B37C0, "enemydefensespots" },
    { 0x9F3CE915, "enemydeployed" },
    { 0xDB74C947, "enemydestroy" },
    { 0xAAE40EF6, "enemydetectedbitfield" },
    { 0x10937834, "enemydir" },
    { 0x0E563F76, "enemydirraw" },
    { 0x94189173, "enemydist" },
    { 0x194303FE, "enemydistance" },
    { 0x1532F35A, "enemydistancesq" },
    { 0xAFB00FF6, "enemydistanceweight" },
    { 0xB93B82BF, "enemydistsq" },
    { 0xDDB85454, "enemydistsum" },
    { 0xD22C51B2, "enemydogmodel" },
    { 0x4E6C2FE5, "enemyempactive" },
    { 0x7ED0DC6F, "enemyempactivefunc" },
    { 0x7E727584, "enemyempowner" },
    { 0x379A1676, "enemyenddialog" },
    { 0x97106BA6, "enemyent" },
    { 0xDCF44221, "enemyequip" },
    { 0xD3C48678, "enemyequip_changed" },
    { 0x68982FC6, "enemyeye" },
    { 0x927D7EFD, "enemyflag" },
    { 0xC250FE8F, "enemyflagsowned" },
    { 0x7B1A8986, "enemyforward" },
    { 0xE65BDFEB, "enemyforwarddir" },
    { 0x7DF78F26, "enemyfwd" },
    { 0xAE195F51, "enemyfx" },
    { 0x546D2507, "enemyheli" },
    { 0x10CCF560, "enemyinf" },
    { 0x5AEE941D, "enemyinfluencers" },
    { 0xCD1ABF67, "enemyinfo" },
    { 0xF7F1E7B9, "enemyinproximity" },
    { 0x4B5CF0AD, "enemyisapproaching" },
    { 0x87C5220A, "enemyishiding" },
    { 0xE13D14A9, "enemyisingeneraldirection" },
    { 0xB844A6B2, "enemyislocking" },
    { 0x1A9DE08E, "enemylightfxname" },
    { 0xBBC8FC75, "enemylightfxtag" },
    { 0xE672E392, "enemylockedon" },
    { 0x09750CF6, "enemylocs" },
    { 0x732EA74E, "enemylosttime" },
    { 0x7116F71F, "enemymechs" },
    { 0x23A2EC58, "enemymissile_changed" },
    { 0xEF069668, "enemymissiles" },
    { 0x9C4B6D82, "enemymissilevehicle_changed" },
    { 0x94894126, "enemymodel" },
    { 0x8B6A6E23, "enemynearbyback" },
    { 0x22773BEF, "enemynearbyfront" },
    { 0x7F2C3F6D, "enemynearbyleft" },
    { 0xF0986D10, "enemynearbyright" },
    { 0x3D7CD829, "enemynearbytime" },
    { 0xB783D28C, "enemynotify" },
    { 0xDF161771, "enemynum" },
    { 0x66C9B6DB, "enemyobituarytext" },
    { 0xC71963CD, "enemyobjid" },
    { 0x8A810A75, "enemyorigin" },
    { 0xCD4E651F, "enemyoverride" },
    { 0xC42B417B, "enemypainchance" },
    { 0xC6D3017B, "enemypoint" },
    { 0xD55FA868, "enemypop" },
    { 0x476717A3, "enemypos" },
    { 0x3CA0F1F4, "enemypose" },
    { 0x75CE353B, "enemypositiononnavmesh" },
    { 0xA7A7EA46, "enemyque" },
    { 0x0F637831, "enemyradius" },
    { 0x0DC1C14E, "enemyrange" },
    { 0xA727DB19, "enemyrightbehindme" },
    { 0x51E9458D, "enemyrpglocs" },
    { 0xFB398ECE, "enemys" },
    { 0x4A897CD1, "enemys_run_to_safety" },
    { 0x9399AF70, "enemyscrambleramount" },
    { 0x91971C86, "enemyscriptmovervehicle_changed" },
    { 0x50E7AA82, "enemyseekingplayer" },
    { 0xE1C02941, "enemyshit" },
    { 0x802DA293, "enemyshootatpos" },
    { 0xB8D128A2, "enemyside" },
    { 0xE5B9400D, "enemysights" },
    { 0x9E075D26, "enemyspawninit" },
    { 0x7209244D, "enemyspawnlocs" },
    { 0xAC15E7D6, "enemyspotteddialog" },
    { 0xB4038D67, "enemystance" },
    { 0x88786589, "enemystartdialog" },
    { 0x58E59B5E, "enemystartdialogkey" },
    { 0x62A30D32, "enemystartmultipledialogkey" },
    { 0x5BE06A8A, "enemytank1_setup" },
    { 0x0F3E87FB, "enemytargets" },
    { 0xCB57D3AC, "enemyteam" },
    { 0x0911EFDB, "enemythreat" },
    { 0x07E3BE70, "enemythreattime" },
    { 0x76CA4565, "enemytooclose" },
    { 0xE80DF3DA, "enemytoself" },
    { 0xE1ED6589, "enemytrig" },
    { 0x1582E451, "enemytrigger" },
    { 0xA6C40E15, "enemyvehicle" },
    { 0x67F63B94, "enemyvehicle_changed" },
    { 0x89C26264, "enemyvehicles" },
    { 0x83ECB300, "enemyvel" },
    { 0xA905D08E, "enemyvelocity" },
    { 0x4E5899E5, "enemyvolume" },
    { 0x4CF86DCF, "enemyvoscrambleramount" },
    { 0x4ED02885, "enemywatcher" },
    { 0xA771FF41, "enemywavesallowed" },
    { 0xC75459D0, "enemyyaw" },
    { 0x1E431D7B, "enenmy" },
    { 0x9339E71A, "eneny" },
    { 0xC45ED401, "energy" },
    { 0x6D1C8392, "enetering" },
    { 0x7EBA5539, "enextnode" },
    { 0xBFE22579, "enforce" },
    { 0x05B342EE, "enforce_deps" },
    { 0x61725B69, "enforce_flame_deaths" },
    { 0x61BB99FF, "enforced" },
    { 0xB7D1E7B0, "enforces" },
    { 0x760384AF, "eng" },
    { 0x30107164, "eng1" },
    { 0xA217E09F, "eng2" },
    { 0x1CCFBE04, "engage" },
    { 0x03A11B08, "engage_chopper_lines" },
    { 0xB9531D91, "engage_delaying_action" },
    { 0x7FDE37D7, "engage_dist" },
    { 0x856A5846, "engage_dist_debug_hud_destroy" },
    { 0x88B8378E, "engage_dists_add" },
    { 0x1BE47913, "engage_dists_watcher" },
    { 0xFED3F96F, "engage_enemies_locked_on_me" },
    { 0x630790CE, "engage_enemies_locking_on_me" },
    { 0x8167DAFA, "engage_height" },
    { 0x292BE92C, "engage_min_dist" },
    { 0x423EDE92, "engage_min_dist_fall_off" },
    { 0xA355E00A, "engage_obj" },
    { 0x3B75B35F, "engage_player_dist" },
    { 0x47E9A4B7, "engage_threat" },
    { 0x86104F48, "engaged" },
    { 0xED835556, "engaged_auto_move" },
    { 0x7910DBB1, "engagedelay" },
    { 0xCBADEDE4, "engagedist" },
    { 0x28798E2C, "engagedist_hud_changetext" },
    { 0x899DD89E, "engagedistmax" },
    { 0x1C25FA40, "engagedistmin" },
    { 0x75C920CF, "engagedistmulligan" },
    { 0x550A16CA, "engagedistoptimal" },
    { 0x99EA7B17, "engagedists" },
    { 0xCA1DAD0C, "engagedisttype" },
    { 0xA01AEF5A, "engagemaxdist" },
    { 0xC9DC91A4, "engagemaxfalloffdist" },
    { 0x0B6B06B0, "engagement" },
    { 0x6BDE5E03, "engagement_dist" },
    { 0x4C544C34, "engagement_dist_func" },
    { 0x22379305, "engagement_dist_squared" },
    { 0x6977740E, "engagement_distance" },
    { 0xE74609D7, "engagement_distance_debug_init" },
    { 0xD6BB5795, "engagement_distance_debug_toggle" },
    { 0xD4344727, "engagement_gun" },
    { 0x79F44AFB, "engagement_rifle" },
    { 0xC0F41D37, "engagement_shotgun" },
    { 0x65BAF8B2, "engagement_smg" },
    { 0x0A3C596A, "engagement_sniper" },
    { 0x0DC75DA0, "engagementdist" },
    { 0xCA67B2EA, "engagementdistmax" },
    { 0x4D52F4F4, "engagementdistmin" },
    { 0xF7C19119, "engagementheightmax" },
    { 0x52676FA7, "engagementheightmin" },
    { 0x5902D284, "engagementmindist" },
    { 0xFC49371B, "engagements" },
    { 0xBDF12110, "engagemindist" },
    { 0xC36083D6, "engageminfalloffdist" },
    { 0xF0494EB7, "engages" },
    { 0xB69E5E8D, "engaging" },
    { 0x95318609, "engagmement_distance" },
    { 0xD2B955A9, "engauge" },
    { 0x9F783763, "engine" },
    { 0x22F3CCD3, "engine_1" },
    { 0xB0EC5D98, "engine_2" },
    { 0xD6EED801, "engine_3" },
    { 0x94FB3C0E, "engine_4" },
    { 0x75AE9C2C, "engine_audio" },
    { 0x59E3FBEC, "engine_damage_high" },
    { 0x4E02F57E, "engine_damage_low" },
    { 0x9772A756, "engine_dmg_snd" },
    { 0x86D85427, "engine_explosion" },
    { 0x47766E4A, "engine_fire" },
    { 0xAB03A174, "engine_fx_left" },
    { 0x5E2C792B, "engine_fx_right" },
    { 0x387A05A5, "engine_off" },
    { 0xE2D93619, "engine_on" },
    { 0xEF895113, "engine_sound" },
    { 0x34A180DD, "engine_startup" },
    { 0xFCDCA70A, "engine_trail" },
    { 0xA49A2A3E, "engineer" },
    { 0xE3DC8F68, "engineer_l1" },
    { 0x55E3FEA3, "engineer_l2" },
    { 0x9E0C1125, "engineer_prespawn" },
    { 0x079A1226, "engineer_r1" },
    { 0xE19797BD, "engineer_r2" },
    { 0xF473F067, "engineer_spawner" },
    { 0xDA3A73AB, "engineer_think" },
    { 0x7D22FF81, "engineered" },
    { 0x500C4F42, "engineering" },
    { 0xD7C39321, "engineers" },
    { 0x5D095CE4, "engineers_build_bridge" },
    { 0x8B70E290, "engineers_jumping" },
    { 0xAF3A02B1, "engineers_take_cover" },
    { 0xF27F2B53, "enginefire_plane_passed" },
    { 0x5F517F59, "enginefirefx" },
    { 0x469A5715, "enginefx" },
    { 0x7052B604, "enginerollfx" },
    { 0xF22C1D52, "engines" },
    { 0x5CFFB394, "engines_hit" },
    { 0x075E9C48, "engines_off" },
    { 0xD7FF8F29, "enginesmolderfx" },
    { 0xF313871C, "enginesnd" },
    { 0xB603346E, "enginestutterhandler" },
    { 0xFCD9939B, "enginetype" },
    { 0x4DCD59E8, "englund" },
    { 0x0789B817, "enguaged" },
    { 0x719801C5, "engulfed" },
    { 0x38D7F43E, "engulfing" },
    { 0x4B861469, "enimation" },
    { 0x1C612828, "enities" },
    { 0x78ABE6CD, "enitiy" },
    { 0x98609554, "enlarge_amount" },
    { 0x773B0359, "enlarge_follower_goalradius_upon_seeing_player" },
    { 0x76930AD3, "enlarged" },
    { 0x3C6DDEAC, "enlarges" },
    { 0xAE0B3258, "enlarging" },
    { 0x9E9CD0F7, "enmey" },
    { 0xBFC0DB7E, "enmies" },
    { 0xE60D5B5E, "enode" },
    { 0xCCCF4C0B, "enoderetreat" },
    { 0xC94D7563, "enoteworthy" },
    { 0x8A66957D, "enough" },
    { 0x31E1DA00, "enough_damage_for_gib" },
    { 0xEBA6158D, "enough_metered_allies" },
    { 0x3AA37851, "enrage_anim" },
    { 0xA6561EC5, "enraged" },
    { 0x7754E2F4, "enricco" },
    { 0x719870AA, "ensc" },
    { 0x4C30D71F, "ensure" },
    { 0x9BDEF6B7, "ensure_chunk_is_back_to_origin" },
    { 0x5B8096C5, "ensure_next_group" },
    { 0x5E3E51A2, "ensure_trigger" },
    { 0x8C0630B5, "ensurelaststandparamsvalidity" },
    { 0xD5BD79A6, "ensures" },
    { 0x33150A89, "ensurestanceisallowed" },
    { 0x63A7B19A, "ensuring" },
    { 0xA3D46EE4, "ent" },
    { 0x11E3FF05, "ent1" },
    { 0x4F61688F, "ent10" },
    { 0x295EEE26, "ent11" },
    { 0x035C73BD, "ent12" },
    { 0xDD59F954, "ent13" },
    { 0xB7577EEB, "ent14" },
    { 0x91550482, "ent15" },
    { 0x6B528A19, "ent16" },
    { 0x45500FB0, "ent17" },
    { 0x7F753BD7, "ent18" },
    { 0x5972C16E, "ent19" },
    { 0x37E6796E, "ent2" },
    { 0xCDF8CEBA, "ent20" },
    { 0xF3FB4923, "ent21" },
    { 0x81F3D9E8, "ent22" },
    { 0xA7F65451, "ent23" },
    { 0x6602B85E, "ent24" },
    { 0x8C0532C7, "ent25" },
    { 0x19FDC38C, "ent26" },
    { 0x40003DF5, "ent27" },
    { 0x9DE4FB72, "ent28" },
    { 0xC3E775DB, "ent29" },
    { 0x5DE8F3D7, "ent3" },
    { 0x4C9034E5, "ent30" },
    { 0x268DBA7C, "ent31" },
    { 0x989529B7, "ent32" },
    { 0x7292AF4E, "ent33" },
    { 0xB4864B41, "ent34" },
    { 0x8E83D0D8, "ent35" },
    { 0x008B4013, "ent36" },
    { 0xDA88C5AA, "ent37" },
    { 0x1C7C619D, "ent38" },
    { 0xF679E734, "ent39" },
    { 0x53D79AF8, "ent4" },
    { 0x94414DD8, "ent40" },
    { 0xBA43C841, "ent41" },
    { 0xE04642AA, "ent42" },
    { 0x0648BD13, "ent43" },
    { 0x2C4B377C, "ent44" },
    { 0x524DB1E5, "ent45" },
    { 0x78502C4E, "ent46" },
    { 0x79DA1561, "ent5" },
    { 0x9FDC8FCA, "ent6" },
    { 0xC5DF0A33, "ent7" },
    { 0xBBCDB154, "ent8" },
    { 0xE1D02BBD, "ent9" },
    { 0x1093BC58, "ent_1" },
    { 0x829B2B93, "ent_2" },
    { 0x29CC71A2, "ent_actor" },
    { 0x71727699, "ent_ai" },
    { 0x7A6A7D29, "ent_already_in" },
    { 0x88EFDAD8, "ent_already_in_trigger" },
    { 0x3E120E76, "ent_array" },
    { 0x797EB03E, "ent_attacker" },
    { 0x665A4A27, "ent_audio" },
    { 0xB6A0BAC1, "ent_bhb" },
    { 0xD89C34CF, "ent_bomb" },
    { 0xF532BD65, "ent_camo_material_callback" },
    { 0x90E09D1C, "ent_can_see_me" },
    { 0xC0BA7915, "ent_centrifuge" },
    { 0x438E38F5, "ent_check_against" },
    { 0x5C82001B, "ent_clock" },
    { 0x688C8CAC, "ent_cover" },
    { 0xABA5E2CA, "ent_delete" },
    { 0x37D84835, "ent_dial" },
    { 0x98483732, "ent_distance" },
    { 0x697823AF, "ent_door" },
    { 0xFA5849B4, "ent_door_col" },
    { 0xAF46FC3B, "ent_draw_axis" },
    { 0xB454B469, "ent_flag" },
    { 0x3EBE5C82, "ent_flag_assert" },
    { 0x196D409B, "ent_flag_clear" },
    { 0x3FA99484, "ent_flag_clear_delayed" },
    { 0xA8BB146D, "ent_flag_delay_name" },
    { 0xC6CE615D, "ent_flag_exist" },
    { 0x8E2416D2, "ent_flag_init" },
    { 0xB431AA0C, "ent_flag_init_ai_standards" },
    { 0x9B2BF98D, "ent_flag_name" },
    { 0x7F4E3064, "ent_flag_set" },
    { 0x328391C7, "ent_flag_set_delayed" },
    { 0xB3E6CDD0, "ent_flag_toggle" },
    { 0x419F1E2F, "ent_flag_wait" },
    { 0x1132B507, "ent_flag_wait_ai_standards" },
    { 0x007FE669, "ent_flag_wait_either" },
    { 0x4AB426BD, "ent_flag_wait_or_timeout" },
    { 0x14F5639B, "ent_flag_waitopen" },
    { 0x872C474E, "ent_flags_lock" },
    { 0x2E4C3DB0, "ent_found_index" },
    { 0xBE0A9746, "ent_fx_origin" },
    { 0xF593D568, "ent_gathervalidbarriers" },
    { 0xCAEB1D31, "ent_get" },
    { 0xDBCE19B3, "ent_grenade" },
    { 0xBCD66F74, "ent_guy" },
    { 0x6BEDFEC1, "ent_hacker" },
    { 0x2A62A6FB, "ent_heli" },
    { 0x1C581EC4, "ent_id" },
    { 0x299048AD, "ent_is_highlighted" },
    { 0x1FD6C912, "ent_is_launcher" },
    { 0xCCAAE7B1, "ent_is_selected" },
    { 0x1BF5F062, "ent_linked_delete" },
    { 0xE4A9B72F, "ent_list" },
    { 0x24CE9E3A, "ent_model" },
    { 0x2CB098A6, "ent_name" },
    { 0x2036ED91, "ent_name_visible" },
    { 0x871CF26F, "ent_new" },
    { 0x7B4B2DC5, "ent_num" },
    { 0x55EBAF3C, "ent_number" },
    { 0xDE90E30C, "ent_or_ent_array" },
    { 0x4A44C2F3, "ent_or_org" },
    { 0x447BF7C3, "ent_or_pos" },
    { 0x1C85FCA1, "ent_origin" },
    { 0x15E40AEB, "ent_parts" },
    { 0xA173B33C, "ent_player" },
    { 0x9CC9078C, "ent_ply" },
    { 0x2D5716FD, "ent_poi" },
    { 0x49483887, "ent_pos" },
    { 0x35ABC04C, "ent_pos_eyes" },
    { 0x5A729F65, "ent_powerup" },
    { 0x228116AC, "ent_print" },
    { 0x96514C56, "ent_print_text" },
    { 0x7FE29FAA, "ent_released_from_claw_grab_achievement" },
    { 0x66CC9416, "ent_set_flag" },
    { 0x02DBA5A2, "ent_set_outline" },
    { 0xD83D7416, "ent_start_point" },
    { 0xAB229054, "ent_target" },
    { 0xCF709175, "ent_targetname" },
    { 0x70B69844, "ent_targetnames" },
    { 0x0CF9AFC7, "ent_targets" },
    { 0x73AA4AC6, "ent_targs" },
    { 0xE6206A68, "ent_team" },
    { 0xD5CAD162, "ent_times_out" },
    { 0x844022DD, "ent_to_play_anim_off" },
    { 0xF4ECB3D3, "ent_trace_origin" },
    { 0x1F501EFD, "ent_trig" },
    { 0xD67FD3FD, "ent_trigger" },
    { 0x18F7EF93, "ent_type" },
    { 0x12D043EB, "ent_useless" },
    { 0xB347DA11, "ent_vehicle" },
    { 0x22B50D59, "ent_volume" },
    { 0x3CA51D1B, "ent_wait_for_flag_or_time_elapses" },
    { 0x961A2B60, "ent_waits_for_level_notify" },
    { 0xC7B04F12, "ent_waits_for_trigger" },
    { 0x3DF01F81, "ent_zombie" },
    { 0xF1269735, "enta_broadcast_pipe01_a" },
    { 0x1729119E, "enta_broadcast_pipe01_b" },
    { 0xD6E04852, "enta_broadcast_pipe02_a" },
    { 0xB0DDCDE9, "enta_broadcast_pipe02_b" },
    { 0x5FA9B4E1, "enta_ceiling_garbage" },
    { 0x0FB0A722, "enta_chain01" },
    { 0xE9AE2CB9, "enta_chain02" },
    { 0xC3ABB250, "enta_chain03" },
    { 0x7176FCEB, "enta_chain_650" },
    { 0x142C2668, "enta_curtain_sheer" },
    { 0x84CE4FFB, "enta_curtain_sheer_hang" },
    { 0x6525CACA, "enta_dead_body_tarp01" },
    { 0x3F235061, "enta_dead_body_tarp02" },
    { 0xDD2C8563, "enta_deadbody_tarp_fast" },
    { 0x03513E4A, "enta_deadbody_tarp_slow" },
    { 0x81C66608, "enta_deck_panel" },
    { 0xB4831C11, "enta_deck_ropes_01" },
    { 0xF4FFE412, "enta_egg_ice_break_trigger" },
    { 0x33428B54, "enta_fish02" },
    { 0x594505BD, "enta_fish03" },
    { 0xE73D9682, "enta_fish04" },
    { 0x0D4010EB, "enta_fish05" },
    { 0x87776EA0, "enta_fish2" },
    { 0xAD79E909, "enta_fish3" },
    { 0xC48F8E2E, "enta_harmony_triggers" },
    { 0x7B1EA152, "enta_huey_debris01" },
    { 0x551C26E9, "enta_huey_debris02" },
    { 0x2F19AC80, "enta_huey_debris03" },
    { 0x392B055F, "enta_huey_debris04" },
    { 0x13288AF6, "enta_huey_debris05" },
    { 0x0C603539, "enta_lantern_hang_on" },
    { 0x2789A46A, "enta_leafmed" },
    { 0x72FC623C, "enta_leafsm" },
    { 0xB9B04C01, "enta_line_flag02" },
    { 0x6B7290D7, "enta_made_the_shot_trigger" },
    { 0x9B284943, "enta_mgcurtainside" },
    { 0xF110D2F0, "enta_nets" },
    { 0x1015741B, "enta_panel_rattle" },
    { 0x60886FBB, "enta_pants01" },
    { 0x34AE8DF2, "enta_preserver" },
    { 0x40D49F9B, "enta_roaches" },
    { 0x5E97419D, "enta_runway_crate01" },
    { 0xF1459E72, "enta_seagull_circle_01" },
    { 0xCB432409, "enta_seagull_circle_02" },
    { 0xA540A9A0, "enta_seagull_circle_03" },
    { 0xEA722A22, "enta_shiprope" },
    { 0x6D3D2B22, "enta_shirts01" },
    { 0x473AB0B9, "enta_shirts02" },
    { 0x8D0AF8A4, "enta_sound_beacon_triggers" },
    { 0x9D129E77, "enta_square_anetta" },
    { 0xBD477ACC, "enta_streamer01" },
    { 0x2F4EEA07, "enta_streamer02" },
    { 0x73028BA9, "enta_streamer_01" },
    { 0x99050612, "enta_streamer_02" },
    { 0xDF555294, "enta_tarp1" },
    { 0xF9314566, "enta_tarp_cover01" },
    { 0x5C1E4682, "enta_tarp_crate_stack" },
    { 0xB05CDC1A, "enta_tarp_stack" },
    { 0x1515DA92, "enta_vinemed" },
    { 0x7DD3BCB4, "enta_vinesm" },
    { 0x5A8382F2, "enta_windsock" },
    { 0x00D7AE50, "enta_wire_sway_01" },
    { 0x72DF1D8B, "enta_wire_sway_02" },
    { 0x4CDCA322, "enta_wire_sway_03" },
    { 0xBEE4125D, "enta_wire_sway_04" },
    { 0x60ABCF38, "enta_wires_multi" },
    { 0xEDA2380D, "enta_wires_pistons" },
    { 0x6139949E, "enta_wires_spool" },
    { 0xA1DE47B3, "enta_wirespark_long" },
    { 0xFF6D39ED, "enta_wirespark_med" },
    { 0x3B332A01, "entanglement" },
    { 0xA9A948A4, "entangles" },
    { 0x7547C2D3, "entarray" },
    { 0x4F484664, "entbitarray0" },
    { 0x754AC0CD, "entbitarray1" },
    { 0x39CB3821, "entcanseeme" },
    { 0xB76FCB40, "entcounts" },
    { 0xA7BA22FD, "entdestroyed" },
    { 0xD6036EC7, "entdirection" },
    { 0x5264AA61, "enter" },
    { 0x86109653, "enter_anim" },
    { 0xC432E0CF, "enter_arena_struct" },
    { 0x6576E602, "enter_armory" },
    { 0x682B0BE7, "enter_atrium_trigger" },
    { 0x987F1D02, "enter_b_tunnels" },
    { 0x17A73CEB, "enter_bar_animations" },
    { 0x55E2C198, "enter_btr_mig_1" },
    { 0xC7EA30D3, "enter_btr_mig_2" },
    { 0xA6A56CF3, "enter_bunker" },
    { 0x23613757, "enter_bunker_objective" },
    { 0xE8296722, "enter_burnt_apartment" },
    { 0x1CD89263, "enter_club_dialog" },
    { 0x65018EAB, "enter_cougar" },
    { 0xCA516D94, "enter_cougar_hands" },
    { 0x6271CA03, "enter_cougar_potus" },
    { 0x5DCB1C0B, "enter_cougar_wheel" },
    { 0xA0872869, "enter_count" },
    { 0x36AB5A00, "enter_crossroad_bldg" },
    { 0x9C69B964, "enter_dist" },
    { 0x9B8C409C, "enter_door" },
    { 0xA450B69A, "enter_final_room" },
    { 0xC37D9820, "enter_final_warehouse" },
    { 0xB565BE3E, "enter_func" },
    { 0x53621492, "enter_gump_trigger0" },
    { 0x79648EFB, "enter_gump_trigger1" },
    { 0x075D1FC0, "enter_gump_trigger2" },
    { 0x2D5F9A29, "enter_gump_trigger3" },
    { 0x749293FD, "enter_height" },
    { 0x5A545853, "enter_house_dialog" },
    { 0x1DD8BE00, "enter_jeep" },
    { 0xBB30E84F, "enter_jeep_fail" },
    { 0xEEB27653, "enter_jet_cockpit" },
    { 0x6AD36DFF, "enter_jet_hud" },
    { 0x593AA45E, "enter_jet_players_hand" },
    { 0xCE4F53ED, "enter_mall_objectives" },
    { 0x5FBC62B8, "enter_node" },
    { 0xF3F47570, "enter_rejack_standby" },
    { 0xD8815EC1, "enter_sea" },
    { 0x29B84983, "enter_soct" },
    { 0x2418088B, "enter_subpen" },
    { 0xD6DF29DA, "enter_subpen_door" },
    { 0x6296AC4D, "enter_subpen_door_open" },
    { 0x0C9D5547, "enter_theater" },
    { 0xE990BFD2, "enter_trig" },
    { 0x7FCCF8F0, "enter_trigger" },
    { 0x637DBD55, "enter_tunnel_nag" },
    { 0x80EB92FC, "enter_vehicle" },
    { 0x9B7A565C, "enterance" },
    { 0xEFC5089F, "enterances" },
    { 0xE4CEB6D6, "enteranim" },
    { 0xA6FB0BF2, "enterbase" },
    { 0x77094522, "enterdeathanim" },
    { 0x6FE4A14E, "entered" },
    { 0x612DCAA0, "entered_c4" },
    { 0x57278062, "entered_cougar" },
    { 0x9C02558D, "entered_foot_from_tank_bunker" },
    { 0xCF2628AD, "entered_level" },
    { 0x34262A8F, "entered_lower_decks" },
    { 0x0786DD4A, "entered_pose" },
    { 0xE17402C9, "entered_tvstation" },
    { 0xFCA8CD05, "entered_xenon_auto_aim_stop_logic" },
    { 0x50D970F7, "enteredplayablearea" },
    { 0x7E588757, "enteredresurrect" },
    { 0x5F5B53A2, "enteredvehicle" },
    { 0xE2D82116, "enterhelicopter" },
    { 0x29337C27, "entering" },
    { 0xB6EAFB08, "entering_bus" },
    { 0x663AFBBE, "entering_combat" },
    { 0x565C9D04, "entering_elevator" },
    { 0x068CC29B, "entering_last_stand" },
    { 0x814A8B9C, "entering_level" },
    { 0xBAA5EF55, "entering_morgue" },
    { 0x24995759, "entering_the_cave" },
    { 0xBC05FA25, "enteringvehicle" },
    { 0x299D2679, "enterpoint" },
    { 0x9C4A9751, "enterpos" },
    { 0x35CB4385, "enterprising" },
    { 0xA48A40C9, "enterprone" },
    { 0x015513A6, "enterpronewrapper" },
    { 0xD07D228A, "enterpronewrapperproc" },
    { 0x03986E08, "enters" },
    { 0x72F91BB5, "enterstage" },
    { 0x2BFD9B57, "entertaining" },
    { 0x26DB4FB6, "entertime" },
    { 0x85A98779, "entfirsttarget" },
    { 0xC1057C9B, "entforwardvec" },
    { 0x2FCB755D, "entfov" },
    { 0xECED3216, "entfx" },
    { 0x7235794C, "entgroups" },
    { 0xF3330B06, "enthrone" },
    { 0x29FEA793, "entid" },
    { 0x3C497874, "entidstr" },
    { 0x69325DE5, "enties" },
    { 0xFD9DD238, "entindex" },
    { 0xBBDB70D0, "entinfo" },
    { 0x3F49B2E2, "entire" },
    { 0xBAC9770F, "entirely" },
    { 0x368D8317, "entirety" },
    { 0xA73FC93E, "entiry" },
    { 0x8168AEBB, "entisplayer" },
    { 0xE51F0447, "entites" },
    { 0x4B8A5D64, "entities" },
    { 0xEC2460C9, "entities_are_selected" },
    { 0xD998F55E, "entities_exist_by_name" },
    { 0x324B484A, "entities_for_delete" },
    { 0x377F1DEA, "entities_s" },
    { 0x931C9730, "entities_waiting_to_spawn" },
    { 0x17C7D510, "entitieswithheadicons" },
    { 0x532BBE78, "entitiles" },
    { 0x7FC01644, "entitise" },
    { 0xA58EF0B9, "entitiy" },
    { 0xAA10FCE8, "entity" },
    { 0xA9CCC652, "entity_callback" },
    { 0x46673EAC, "entity_center" },
    { 0x67310B3E, "entity_common_spawn_setup" },
    { 0x24E5D972, "entity_connect_dynamic_nodes_to_navigation_mesh" },
    { 0x161B6D85, "entity_connect_nodes" },
    { 0x77CC9C1C, "entity_connect_nodes_to_navigation_mesh" },
    { 0xC804F9A2, "entity_death_in_pose_after_time" },
    { 0xAE9A031D, "entity_died" },
    { 0x0F263F87, "entity_disconnect_dynamic_nodes_from_navigation_mesh" },
    { 0x60FF934E, "entity_eye" },
    { 0x9137893B, "entity_fake_tracers" },
    { 0x07021DD4, "entity_grab_attached_dynamic_nodes" },
    { 0x32E1DBDC, "entity_highlight_disable" },
    { 0xEED41B85, "entity_highlight_enable" },
    { 0x07143580, "entity_id" },
    { 0xFCC0ED98, "entity_in_active_zone" },
    { 0xBE71A21B, "entity_in_zone" },
    { 0xFDB04391, "entity_index" },
    { 0xF3B5C5C1, "entity_indexes" },
    { 0x93DD0ABF, "entity_info" },
    { 0xFD0114A6, "entity_is_allowed" },
    { 0xEB32798A, "entity_is_in_front_of_me" },
    { 0x7DA34782, "entity_is_on_bus" },
    { 0xF6688929, "entity_num" },
    { 0x45560BD3, "entity_on_tank" },
    { 0x79B9C7A7, "entity_or_point" },
    { 0x0F1F6E3D, "entity_or_point_array" },
    { 0xCE2258E7, "entity_override" },
    { 0xBBE8EC7F, "entity_overrride" },
    { 0x8AB234F1, "entity_shutdown" },
    { 0x45729FBB, "entity_spawned" },
    { 0x8FAB45B2, "entity_spawntimes" },
    { 0xB13C93ED, "entity_taken_over" },
    { 0x9C762BD1, "entity_targetname" },
    { 0x898F686F, "entity_to_kill" },
    { 0x706C7548, "entityangles" },
    { 0x663AA8D9, "entitybit" },
    { 0x537F7D91, "entityentnum" },
    { 0x50FA193F, "entityforward" },
    { 0x6372A4C1, "entitygroup" },
    { 0x2D48C773, "entityheadiconhandler" },
    { 0x2D8C2134, "entityheadiconoffset" },
    { 0xD5FB9674, "entityheadicons" },
    { 0x851C6CD8, "entityheadicons_shared" },
    { 0xFD105442, "entityheadiconteam" },
    { 0x1D6FDE7E, "entityheadobjectives" },
    { 0x7D070B9C, "entityindex" },
    { 0x57EC9A3A, "entityinfront" },
    { 0x25C079CD, "entityisarchetype" },
    { 0x3FD7F188, "entitylerptime" },
    { 0x26708F40, "entitylist" },
    { 0x1050D145, "entitynavmeshposition" },
    { 0xA22CD1D8, "entitynum" },
    { 0x9307290B, "entitynumber" },
    { 0x897539EE, "entityorigin" },
    { 0x14A6C5AA, "entitypoint" },
    { 0x4E52E88A, "entityradius" },
    { 0x0D5DA096, "entityshutdown" },
    { 0xF139F4B0, "entityshutdown_callback" },
    { 0xFD677ED2, "entityspawned" },
    { 0x51C9425F, "entitystarttime" },
    { 0x764A3F13, "entityteam" },
    { 0xFC52C403, "entitytrace" },
    { 0xF88344F1, "entitytype_t" },
    { 0xA939A4FB, "entitytypes" },
    { 0x50A5409C, "entlist" },
    { 0x5555550B, "entlosradiusdamage" },
    { 0xA3971AC5, "entname" },
    { 0x270018C4, "entnum" },
    { 0xF78F3868, "entnumkeys" },
    { 0xCFF9A482, "entpos" },
    { 0x2F631FFB, "entrace" },
    { 0x594F42D7, "entrance" },
    { 0x5C8DB049, "entrance_door_open" },
    { 0x0303269C, "entrance_guards" },
    { 0x009DC899, "entrance_nodes" },
    { 0xD7BC5003, "entranceguys" },
    { 0xB2300337, "entranceguys_hangin" },
    { 0xB53FA68E, "entrances" },
    { 0x753FFE88, "entree" },
    { 0x282D1B03, "entrence" },
    { 0xA9134B8F, "entries" },
    { 0xA9BCABD2, "entring" },
    { 0xFCF5AE5B, "entry" },
    { 0x5392364F, "entry_points" },
    { 0xE1905893, "entry_ramp_start" },
    { 0xFAAC688C, "entry_vo_trig" },
    { 0xAAE4EEFA, "entrygate" },
    { 0x3AB8DAEF, "entrypoint" },
    { 0xE62AC736, "entrypoints" },
    { 0x39EB5CA8, "entryway" },
    { 0xD25E74E4, "entryway_trigger_thread" },
    { 0xDE878E17, "ents" },
    { 0xE03A8D3C, "ents1" },
    { 0x5241FC77, "ents2" },
    { 0x2C3F820E, "ents3" },
    { 0x6E331E01, "ents4" },
    { 0x96BA9D8B, "ents_being_flushed" },
    { 0x0785B0B2, "ents_from_script_int" },
    { 0xA6B527B6, "ents_in_trigger" },
    { 0x54A34A6F, "ents_saved" },
    { 0x203380F5, "ents_to_delete" },
    { 0x6379EDBA, "ents_to_delete_2" },
    { 0xC82D11B0, "entsearch" },
    { 0x6E829DCF, "enttarget" },
    { 0xB00F0FD3, "enttomyunitvec" },
    { 0x91616215, "enttomyvec" },
    { 0xA63FC9B4, "enttonotify" },
    { 0x7DA3B038, "enttowatch" },
    { 0x833338E1, "entunitforwardvec" },
    { 0x0C433ED8, "entwasselected" },
    { 0x626EC5FD, "enty" },
    { 0x5D1EF442, "enum" },
    { 0x769DB7B8, "enumerateweapons" },
    { 0x12A27B8D, "enums" },
    { 0xF7BC81AF, "enused" },
    { 0xEFD963B6, "env" },
    { 0xE3B80FD5, "env_destroy_delay" },
    { 0x0A5065E6, "enviroment" },
    { 0x80DF6C1C, "environ" },
    { 0x129ECA28, "environment" },
    { 0x986914CF, "environmental" },
    { 0x3F96ADD5, "environmental_challenge" },
    { 0x1A4308B0, "enxplosion" },
    { 0x78060EF9, "eo" },
    { 0x763F39AD, "eof" },
    { 0xFEFE6996, "eorgfx" },
    { 0x226BD50F, "eot" },
    { 0x58BD3694, "eother" },
    { 0x16F8B499, "eotodo" },
    { 0xA271A4AA, "eoughton" },
    { 0xD549BA2E, "epathend" },
    { 0x8F3218D3, "epathpoint" },
    { 0x0954AAD6, "epaths" },
    { 0xFC56285D, "epathstart" },
    { 0x06CD491E, "epd" },
    { 0x80D52804, "epd_demo_outro" },
    { 0x84F3934A, "epic" },
    { 0x791B687F, "epic_boss_battle" },
    { 0x7885B8EE, "epic_sugarfield_jets" },
    { 0x00BD3C8C, "epictauntmodels" },
    { 0x13674108, "epictauntxmodels" },
    { 0xFA12089A, "epidermal" },
    { 0x32C6F4BF, "epilog" },
    { 0xA0409355, "epilogue_delay_interrogation" },
    { 0xF60B0AA2, "epilogue_delay_patrol" },
    { 0xBA05FC00, "epilogue_delay_prisoner" },
    { 0xBE0C7AD4, "epilogue_delay_search" },
    { 0x9B3441E4, "epipen" },
    { 0x3F27EF65, "eplayer" },
    { 0xD7E78686, "eplayerview" },
    { 0xD801213B, "epoints" },
    { 0xD5BE7C9D, "epricenode" },
    { 0x2EA3EC65, "epsilon" },
    { 0xE30A01DD, "epxplo" },
    { 0x2C011A27, "eq" },
    { 0x29607BEE, "eq_defs" },
    { 0x4C03B0D5, "eq_main_track" },
    { 0xEF6F515C, "eq_mix_track" },
    { 0x3BB36B0A, "eq_num" },
    { 0x282BB78E, "eq_table" },
    { 0xCCDD3385, "eq_touching" },
    { 0x5FCF792F, "eq_track" },
    { 0x37F0082A, "eq_trigger" },
    { 0xD2995103, "eq_trigger_num" },
    { 0x00226D5F, "eq_trigger_table" },
    { 0xAC7D816E, "eq_unitrigger_offset" },
    { 0x8EE37E19, "eqindex" },
    { 0xCDC99AC6, "eqoff" },
    { 0x7EE8E558, "eqon" },
    { 0x8D95B8E0, "eqstub_get_unitrigger_origin" },
    { 0xAB6E4C54, "eqstub_on_spawn_trigger" },
    { 0x725460AF, "eqtype" },
    { 0xDC3D82CF, "equal" },
    { 0x7741DE79, "equal_to" },
    { 0x8E050992, "equally" },
    { 0x89607296, "equals" },
    { 0x993F3A73, "equates" },
    { 0x4A39F01F, "equation" },
    { 0xBE0FD4A6, "equations" },
    { 0xDD3978AB, "equip" },
    { 0x71463CEE, "equip_dieseldrone_zm" },
    { 0x1423B780, "equip_dieseldrone_zm_given" },
    { 0xC4A7DB16, "equip_electrictrap_zm_taken" },
    { 0x4C553619, "equip_gasmask_zm_activate" },
    { 0x70AB5A70, "equip_gasmask_zm_deactivate" },
    { 0xFC56070F, "equip_gasmask_zm_taken" },
    { 0x59469F87, "equip_headchopper_zm_taken" },
    { 0xACDA076B, "equip_machete" },
    { 0x95C3C40B, "equip_name" },
    { 0x85F3ECD1, "equip_savimbi_machete" },
    { 0x67E26982, "equip_savimbi_machete_battle" },
    { 0x902B423F, "equip_springpad_zm_pickup" },
    { 0x7715AF58, "equip_springpad_zm_taken" },
    { 0x5C23936C, "equip_subwoofer_zm_taken" },
    { 0x58877600, "equip_turbine_zm_cleaned_up" },
    { 0x4381EC7D, "equip_turbine_zm_taken" },
    { 0xDE5CC4B4, "equip_turret_zm_taken" },
    { 0xA894D66D, "equip_wooods" },
    { 0x0FC5DAA7, "equipbutton" },
    { 0x6F854FE0, "equiped" },
    { 0xCB6BC3E3, "equipment" },
    { 0x862027BB, "equipment_activated_clientfield_cb" },
    { 0xF4185185, "equipment_ammo_changed" },
    { 0x411A141E, "equipment_buy" },
    { 0x0D8519A4, "equipment_can_move" },
    { 0x8D0A9E65, "equipment_cycling" },
    { 0xBE54F405, "equipment_damage" },
    { 0x214BCB7E, "equipment_dead_zone_pos" },
    { 0x95E5A8A9, "equipment_dead_zone_rad2" },
    { 0xB7FFD2E8, "equipment_dead_zone_type" },
    { 0x660B1787, "equipment_dev_gui" },
    { 0x622203DE, "equipment_disappear_fx" },
    { 0x8190327D, "equipment_drop" },
    { 0xFFA8FA02, "equipment_drop_to_planted" },
    { 0x2780F73C, "equipment_dropped" },
    { 0xE253C4A5, "equipment_enabled" },
    { 0xD3DC3E34, "equipment_enemyequip_detect_material" },
    { 0x7E558DCE, "equipment_enemyequip_material" },
    { 0xDCF3C072, "equipment_enemyvehicle_material" },
    { 0x17B683BA, "equipment_etrap_needs_power" },
    { 0xA2593207, "equipment_friendlyequip_material" },
    { 0x4D08735B, "equipment_friendlyvehicle_material" },
    { 0x26F2C42B, "equipment_from_deployed" },
    { 0xD758BF29, "equipment_give" },
    { 0x21B2D73F, "equipment_got_in_round" },
    { 0x21B1F338, "equipment_grab" },
    { 0x9C45B67D, "equipment_headchopper_needs_power" },
    { 0x839717D0, "equipment_ignored_by_zombies" },
    { 0x7883FE23, "equipment_name" },
    { 0xEF337223, "equipment_nearby" },
    { 0xDA6209C8, "equipment_onspawnretrievableweaponobject" },
    { 0x86FC058F, "equipment_orphaned" },
    { 0x80C3C459, "equipment_placed" },
    { 0x7187C3E2, "equipment_placement_watcher" },
    { 0x908F5D7A, "equipment_planted" },
    { 0x8F270871, "equipment_release" },
    { 0xFAF4746B, "equipment_retrievable_material" },
    { 0xB0C32386, "equipment_retrieve" },
    { 0x22FD698D, "equipment_safe_to_drop" },
    { 0xF2F9EFDB, "equipment_safe_to_drop_ffotd" },
    { 0x62C1DB37, "equipment_select_response_done" },
    { 0x58BABAEF, "equipment_slot_watcher" },
    { 0x8A8A10A2, "equipment_spawn_think" },
    { 0x44C502D2, "equipment_spawns" },
    { 0xB2F740C0, "equipment_springpad_needs_power" },
    { 0xD4890044, "equipment_subwoofer_needs_power" },
    { 0x2B367473, "equipment_take" },
    { 0x47ACE5A9, "equipment_team_pick_up" },
    { 0xD2F65AB6, "equipment_to_deployed" },
    { 0x009D7E33, "equipment_transfer" },
    { 0x9053FABE, "equipment_trigger" },
    { 0x72FD6052, "equipment_tu_dead_zone_pos" },
    { 0x240D1D65, "equipment_tu_dead_zone_rad2" },
    { 0xEF52B46C, "equipment_turret_needs_power" },
    { 0xDD732968, "equipment_unplaceable_material" },
    { 0xC877B8C7, "equipment_watch_placement" },
    { 0x1EC3305E, "equipment_weapon" },
    { 0x767F4449, "equipment_weights" },
    { 0x316ED18E, "equipmentarray" },
    { 0xBE7BB045, "equipmentdr" },
    { 0xF7A085AB, "equipmentenemyfx" },
    { 0x8314A4BD, "equipmentfriendfx" },
    { 0xEBA34EB1, "equipmenthackertoolradius" },
    { 0xF43DC420, "equipmenthackertooltimems" },
    { 0x977F1E2C, "equipmentoldownerteam" },
    { 0x8523E939, "equipmentoldteam" },
    { 0xC51E26D9, "equipmentoldwatcherteam" },
    { 0x04AF4482, "equipmentref" },
    { 0xA2924AD2, "equipments" },
    { 0x5B865983, "equipmenttagfx" },
    { 0x5662BA25, "equipmentteamobject" },
    { 0xF7C7947A, "equipmentvo" },
    { 0x43D27C5C, "equipmentwatchplayerteamchanged" },
    { 0xEEAA16E1, "equipmentwatchteamfx" },
    { 0xBE9F5946, "equipname" },
    { 0x64BD970E, "equipped" },
    { 0x5286803C, "equippedkillstreak" },
    { 0x754842E7, "equipping" },
    { 0x61E7B024, "equipshader" },
    { 0xF7D2D651, "equiptment" },
    { 0x293E6D7D, "equiv" },
    { 0x481AA75D, "equivalent" },
    { 0x5A745879, "equivelent" },
    { 0x6A5D6265, "equpiment" },
    { 0x951CA48D, "era" },
    { 0x64508CF0, "era_2020" },
    { 0x9BA512B0, "era_loadout_achievement" },
    { 0x4BF83B89, "erase" },
    { 0xB84ED3FC, "erase_final_killcam" },
    { 0x74E7519C, "erasefinalkillcam" },
    { 0x0DA8BB80, "erases" },
    { 0xFD12BAE9, "ere" },
    { 0xBD6B20FC, "erik" },
    { 0xDA460765, "erik_celerium_door_nag" },
    { 0x7E729CBF, "eriks" },
    { 0xBCAF2210, "ernie" },
    { 0xD26E0D0D, "eroomvolume" },
    { 0x4D261406, "erope" },
    { 0x1B46C586, "err" },
    { 0xFFAD61A8, "erroneously" },
    { 0xFE17AF4D, "error" },
    { 0x606BA7F5, "error2" },
    { 0x58F82C4B, "error_hud" },
    { 0x1F9143C3, "error_msg" },
    { 0x4C206F9A, "error_on_screen" },
    { 0x52C151FA, "errored" },
    { 0xEFB0CF54, "errorifmissing" },
    { 0x7FA4084C, "errorifmissingoverride" },
    { 0x95D3DAF8, "errormsg" },
    { 0xBB07C7CC, "errors" },
    { 0xDC266FD9, "eruption" },
    { 0x3C71EF94, "erupts" },
    { 0xDFFC2555, "es" },
    { 0x83ABD0CF, "esc_alrm" },
    { 0xB1CF1C73, "esc_node" },
    { 0xDB977AEE, "escalation" },
    { 0x98C00783, "escalator" },
    { 0xD6F24A88, "escalator_doors_open" },
    { 0xA0B59090, "escape" },
    { 0xA5769DA6, "escape_alarm" },
    { 0x4A46096C, "escape_anim_time" },
    { 0xC3931D63, "escape_anims" },
    { 0xADDD6948, "escape_autosaves" },
    { 0x97E0AB05, "escape_battle_checkpoints" },
    { 0xD333FD34, "escape_battle_cleanup" },
    { 0x7F7A4B37, "escape_battle_drone_start" },
    { 0x0EF27D7B, "escape_battle_hint" },
    { 0x0DB333B2, "escape_battle_spawn_func" },
    { 0x04FDE155, "escape_battle_vo" },
    { 0x19783254, "escape_boss_drone_logic" },
    { 0xA11E7369, "escape_boss_spawn_func" },
    { 0xFD2561F4, "escape_bosses_checkpoints" },
    { 0x2D5B424A, "escape_bosses_clean_up" },
    { 0x4C3E721F, "escape_bosses_fail" },
    { 0xE0B43E9B, "escape_bosses_objectives" },
    { 0xA767C412, "escape_bosses_started" },
    { 0x0589E1AE, "escape_bosses_vo" },
    { 0xA89EB2F8, "escape_cargohold1_enter" },
    { 0xB1DBE2A3, "escape_cargohold_flood" },
    { 0x429E40BE, "escape_catwalk" },
    { 0x85CE6E8F, "escape_catwalk_live" },
    { 0x52A369D9, "escape_catwalk_sway" },
    { 0x5B55833D, "escape_ceiling_start" },
    { 0x27E0BC74, "escape_count" },
    { 0x656AE61F, "escape_debri" },
    { 0x6E4D1A8B, "escape_debri_launch" },
    { 0x42D3CBF9, "escape_debri_wait" },
    { 0x51F2D901, "escape_dialogue" },
    { 0xC440D122, "escape_dogs" },
    { 0x94B5BECB, "escape_done" },
    { 0x86CBA138, "escape_door_right" },
    { 0x4287DEF5, "escape_doors_open" },
    { 0x843FF194, "escape_doors_setup" },
    { 0x0883B031, "escape_drop_flag" },
    { 0xC830437B, "escape_elevator_1_state" },
    { 0x0CF71B54, "escape_elevator_2_state" },
    { 0x1BFAD8B5, "escape_elevator_3_state" },
    { 0x5331F2DE, "escape_elevator_4_state" },
    { 0x9255AF8F, "escape_elevator_5_state" },
    { 0x3F8031CF, "escape_elevator_damage_drop_state" },
    { 0xF570119E, "escape_elevator_damage_idle_state" },
    { 0x734790FA, "escape_elevator_damage_impact_state" },
    { 0x0F2A2CE7, "escape_elevator_drop" },
    { 0xFF6CBD66, "escape_elevator_idle" },
    { 0x6F3C6F46, "escape_elevator_impact" },
    { 0x5875D31A, "escape_elevator_prestine_drop_state" },
    { 0xDA3D6BFF, "escape_elevator_prestine_idle_state" },
    { 0xBE52F163, "escape_elevator_prestine_impact_state" },
    { 0xA82F038F, "escape_ending_first_frame" },
    { 0xDE73E0D8, "escape_ending_friends_arrival_started" },
    { 0x4A478328, "escape_ending_started" },
    { 0x311CB911, "escape_enemy_vo" },
    { 0x382FC655, "escape_event" },
    { 0x7860F002, "escape_event_ai" },
    { 0x65CF6191, "escape_event_countdown_vo" },
    { 0xF95BDE92, "escape_event_fx" },
    { 0x88EE7FB7, "escape_event_player" },
    { 0x31588E65, "escape_event_rotate" },
    { 0xF176EF27, "escape_event_sndfx" },
    { 0x5DBE59ED, "escape_event_vo" },
    { 0x64D7176C, "escape_event_waterleak_blur" },
    { 0x56F7E5B8, "escape_explosion" },
    { 0x63FFE947, "escape_explosion_drops" },
    { 0xE093A3D0, "escape_fakefire" },
    { 0xAE441B79, "escape_fallback" },
    { 0xD547F699, "escape_flight_vo" },
    { 0x642C4BEB, "escape_fx_setup" },
    { 0x35543254, "escape_fx_setup_throw_obj" },
    { 0xBD54FD6A, "escape_goal" },
    { 0x7D9DAFA8, "escape_grigsby" },
    { 0xC299E351, "escape_hallways_lower_flood" },
    { 0x4975EDD8, "escape_handle_wrongway" },
    { 0x89B0A7EB, "escape_handle_wrongway_kill" },
    { 0x3C3AC327, "escape_heroes" },
    { 0xA3ADD1C7, "escape_heroes2" },
    { 0x179E4569, "escape_heroes_findorder" },
    { 0x757BCF80, "escape_heroes_holdtheline" },
    { 0x23BD8214, "escape_heroes_holdtheline_adjust_rate_vs_ai" },
    { 0x4B804F2B, "escape_heroes_holdtheline_decide_jog_run_sprint" },
    { 0x013B36C7, "escape_heroes_holdtheline_run_or_walk_asone" },
    { 0x1E60687E, "escape_heroes_holdtheline_stay_in_single_file" },
    { 0xE7513B21, "escape_heroes_rescue" },
    { 0x53409E4D, "escape_heroes_run" },
    { 0xDA9B2753, "escape_heroes_run_wait" },
    { 0x7F71D7A4, "escape_heroes_runanim_setup" },
    { 0x4D9BBE99, "escape_heroes_turn_setup" },
    { 0x17976D7F, "escape_intro_checkpoints" },
    { 0x844E91FC, "escape_intro_hints" },
    { 0xFDA9A5F6, "escape_intro_left_turn_fway_trigger" },
    { 0xE2ECF576, "escape_intro_objectives" },
    { 0xEE1629CF, "escape_intro_spawn_funcs" },
    { 0xF38CBF8B, "escape_intro_vo" },
    { 0x254A3B36, "escape_invisible_timer" },
    { 0x2549E6C4, "escape_lab" },
    { 0x12BFB370, "escape_main" },
    { 0x5C3A0121, "escape_mission_failed" },
    { 0x15285811, "escape_monkey_counter" },
    { 0x807B6E54, "escape_music" },
    { 0x620BDFD7, "escape_nag" },
    { 0x9157922A, "escape_new_explosion_scene" },
    { 0x097016DF, "escape_node" },
    { 0x818C0966, "escape_nodes" },
    { 0xFC0598D0, "escape_occurrence" },
    { 0x517EE527, "escape_old_explosion_scene" },
    { 0x0EC90561, "escape_opel" },
    { 0x0E945B6D, "escape_path_trucks" },
    { 0xC9D14092, "escape_plane_override" },
    { 0x523F3C08, "escape_plane_override_no_damage" },
    { 0xEAF4D3A8, "escape_player" },
    { 0xF081E6C1, "escape_player_last_quake" },
    { 0x8E05914C, "escape_pod" },
    { 0x170DA416, "escape_pod_are_all_alive_players_ready" },
    { 0x0CBD83E2, "escape_pod_blocker_door" },
    { 0x32FB6662, "escape_pod_breaking_rotate" },
    { 0xD39640B4, "escape_pod_corpse_respawn_node_index" },
    { 0x0F9DFECC, "escape_pod_corpse_respawn_nodes" },
    { 0xFDE90DD3, "escape_pod_death_trigger_think" },
    { 0xB532F58E, "escape_pod_falling_begin" },
    { 0xC34D3BCA, "escape_pod_falling_complete" },
    { 0x14512930, "escape_pod_get_all_alive_players" },
    { 0x35D8960F, "escape_pod_get_all_alive_players_inside" },
    { 0xA99B2100, "escape_pod_host_migration_respawn_check" },
    { 0x5C672771, "escape_pod_key_prompt" },
    { 0x7119AEDE, "escape_pod_linknodes" },
    { 0x54C1B220, "escape_pod_move" },
    { 0x38AEE41C, "escape_pod_moving_back_to_start_position" },
    { 0xD4354189, "escape_pod_returns_to_start_location" },
    { 0x03894032, "escape_pod_rotate" },
    { 0x74D05533, "escape_pod_shake" },
    { 0xDAA8D9F6, "escape_pod_state" },
    { 0x14407590, "escape_pod_state_run" },
    { 0xE1B5875F, "escape_pod_tell_fx" },
    { 0x141F0925, "escape_pod_trigger" },
    { 0xC84C7B91, "escape_pod_unlinknodes" },
    { 0xFDEFBA62, "escape_pod_walk_on_off" },
    { 0x9CBA69DE, "escape_pod_walk_on_off_watch" },
    { 0x49D79CB6, "escape_position" },
    { 0x16D1B406, "escape_price" },
    { 0x7F8BEFCA, "escape_progress" },
    { 0x71DFC682, "escape_quake" },
    { 0x267E46C3, "escape_rail" },
    { 0xFCF1A5D5, "escape_rail_obj" },
    { 0x07E586AE, "escape_rpg_enemy_logic" },
    { 0x84FC3166, "escape_run_section" },
    { 0x795986CB, "escape_seaknight" },
    { 0x00CAEA1A, "escape_setup" },
    { 0x1EC6A1AF, "escape_shellshock" },
    { 0xD6BD72D6, "escape_shellshock_heartbeat" },
    { 0x9C97F9BA, "escape_shellshock_thing" },
    { 0x7D7F8EA2, "escape_shellshock_vision" },
    { 0x16CA7A46, "escape_show_waterlevel" },
    { 0x233BBE5F, "escape_spot" },
    { 0xD58B9220, "escape_spot_fx" },
    { 0xD6C369DC, "escape_spot_in_zone" },
    { 0xCEAC7F50, "escape_spot_monitor" },
    { 0xCF4920CA, "escape_spot_player_logic" },
    { 0xC7697F9D, "escape_spot_round_logic" },
    { 0xB53B8988, "escape_struct" },
    { 0xD9159806, "escape_stumble_num" },
    { 0x36D7F111, "escape_tilt_gravity" },
    { 0xD92FA214, "escape_tiltboat" },
    { 0x0FB9479E, "escape_timer" },
    { 0x7247611E, "escape_timer_section" },
    { 0x835C1640, "escape_truck" },
    { 0x234F0526, "escape_turn" },
    { 0x36782E59, "escape_turns" },
    { 0x9C688F9A, "escape_unlink_player" },
    { 0x25357C2E, "escape_vo" },
    { 0xBF85C9CA, "escape_waterlevel" },
    { 0x965389D5, "escape_waterlevel_parts" },
    { 0x3488A512, "escape_waterlevel_parts_fx" },
    { 0x7E144FF9, "escapeangle" },
    { 0x9DBFCD8F, "escapeanim" },
    { 0xE62BC974, "escaped" },
    { 0x1433A5F7, "escaped_fake_grenade" },
    { 0x1159E3D8, "escaped_zombies" },
    { 0x4F61E7F9, "escaped_zombies_cleanup" },
    { 0x94E26402, "escaped_zombies_cleanup_init" },
    { 0x8939CF85, "escapedir" },
    { 0x1CC308F8, "escapeelevatoruseanimtree" },
    { 0x98091AAA, "escapefx" },
    { 0x6001A87B, "escapes" },
    { 0xEAE8516D, "escapeseq" },
    { 0x475CD311, "escaping" },
    { 0xBD458C8A, "eschmidt" },
    { 0xC1889DFD, "escort" },
    { 0xADDADC8A, "escort_boat" },
    { 0x1BC52419, "escort_boat_2" },
    { 0xF5C2A9B0, "escort_boat_3" },
    { 0xFFD4028F, "escort_boat_4" },
    { 0x0BC6E698, "escort_boat_challenge_tracking" },
    { 0x9A36DC02, "escort_boat_follow" },
    { 0x68D290F0, "escort_boat_kills" },
    { 0x2C6913A6, "escort_boat_small" },
    { 0xD0F600B6, "escort_drone" },
    { 0x92C5E703, "escort_drone_adjust_goal_for_enemy_height" },
    { 0x629514C3, "escort_drone_blink_lights" },
    { 0x9138DAFD, "escort_drone_check_move" },
    { 0x60E3C300, "escort_drone_claimed" },
    { 0x003C09BC, "escort_drone_cleanup_fx" },
    { 0x43D2B3EB, "escort_drone_collision" },
    { 0x9CB0A561, "escort_drone_collision_player" },
    { 0x33D1D386, "escort_drone_emped" },
    { 0x121F6CD8, "escort_drone_exit_vehicle" },
    { 0xB4C682D0, "escort_drone_fails" },
    { 0x22D800AB, "escort_drone_find_new_position" },
    { 0xD3EEEE97, "escort_drone_fire_for_time" },
    { 0xE0295516, "escort_drone_fireupdate" },
    { 0xA1815E22, "escort_drone_get_closest_node" },
    { 0x34EF2740, "escort_drone_level_out_for_landing" },
    { 0x668471A2, "escort_drone_main" },
    { 0x3EE8E4F5, "escort_drone_movementupdate" },
    { 0x82F4194C, "escort_drone_off" },
    { 0xB4BF1376, "escort_drone_on" },
    { 0x1FCD2C90, "escort_drone_play_single_fx_on_tag" },
    { 0x97F9037C, "escort_drone_power_loss_multiplier" },
    { 0x57D22D2E, "escort_drone_predicted_collision" },
    { 0xEF093563, "escort_drone_scripted" },
    { 0x1D84EF8D, "escort_drone_set_team" },
    { 0x1B42C1CC, "escort_drone_start_ai" },
    { 0x8EEA0384, "escort_drone_start_scripted" },
    { 0x060DAB5E, "escort_drone_teleport_to_nearest_node" },
    { 0x1AFC2596, "escort_drone_temp_bullet_shield" },
    { 0x7F7A4153, "escort_drone_think" },
    { 0x349104F2, "escort_drone_time" },
    { 0x44C23A64, "escort_guard_ai" },
    { 0x64403F2A, "escort_guard_spawner" },
    { 0x3BAE2A89, "escort_position" },
    { 0xE8F7716D, "escort_react" },
    { 0x408169F4, "escort_sci_ai" },
    { 0xB4B6B740, "escort_spetz" },
    { 0x3540B54E, "escort_to_park" },
    { 0x50F0CE3E, "escort_trig" },
    { 0xCE2672D3, "escort_vtol_go_on_rail" },
    { 0x6F75185C, "escort_wins_index" },
    { 0x7A3A2085, "escortbulletpowerloss" },
    { 0x0045EE24, "escortburstcountmax" },
    { 0xEDA1AF8A, "escortburstcountmin" },
    { 0x54CAF231, "escortburstpowerloss" },
    { 0xE39B0629, "escortburstwaittime" },
    { 0x5E0A563E, "escortdronecallback_vehicledamage" },
    { 0x3FDA65B8, "escortexplosionpowerloss" },
    { 0x05E845F0, "escorthoverheight" },
    { 0x104D7D6B, "escorting" },
    { 0x58A4A7D1, "escortlaunchdistance" },
    { 0x28CB7691, "escortmiscpowerloss" },
    { 0x6FB40B05, "escortnexttime" },
    { 0x480432E4, "escortposition" },
    { 0x558039BC, "escorts" },
    { 0xC19D28C9, "escorttargetacquiretime" },
    { 0xD8C3074D, "escorttethermaxdist" },
    { 0x3814E6FF, "escorttethermindist" },
    { 0x7553303A, "escpaed" },
    { 0xC8090AE3, "escrows" },
    { 0x5160A183, "escrowstruct" },
    { 0x1AE95344, "eseaknight" },
    { 0xCA9C31E0, "eseaknightspawner" },
    { 0xBE2BE90E, "eslot" },
    { 0x20084CAA, "esm" },
    { 0x6F336CD1, "esmokeorg" },
    { 0x55153834, "esniper_org" },
    { 0x2E30F0E5, "esoteric" },
    { 0x58342EA9, "esource" },
    { 0x876EC8CC, "espawned" },
    { 0x9B917A8A, "espawner" },
    { 0xE6A14301, "espawntrigger" },
    { 0x4529868A, "especially" },
    { 0xE2441B60, "esque" },
    { 0xF4EB2435, "essance" },
    { 0xCB9E1C59, "essence" },
    { 0xE952805F, "essential" },
    { 0xFAA20202, "essentially" },
    { 0x07C40302, "establish" },
    { 0x2B12EFC4, "establish_gondola_door_definition" },
    { 0x5FDFB347, "establish_gondola_gate_definition" },
    { 0x2A81CB98, "establish_gondola_landing_door_definition" },
    { 0x4766CE8B, "establish_gondola_landing_gate_definition" },
    { 0xFB167CE0, "establish_mystery_wallbuy_categories" },
    { 0x6353B615, "established" },
    { 0x5173ED6A, "establishes" },
    { 0x7AA6B36E, "establishing" },
    { 0x17E9EBE1, "estartent" },
    { 0xBC63DCCB, "estartenttag" },
    { 0x27458D0E, "estartnode" },
    { 0x0BDC12BF, "estartpath" },
    { 0x35712960, "estartpoint" },
    { 0x67EAA039, "estate" },
    { 0xA2AD503C, "este" },
    { 0x600A8A2F, "estimate" },
    { 0x869FB6F9, "estimated" },
    { 0x31D25875, "estimated_due_date" },
    { 0x1BCE2E1D, "estimated_offset" },
    { 0x94458E08, "estimatedanimrate" },
    { 0x34402791, "estimatedanimrate_l" },
    { 0x4862D94F, "estimatedanimrate_r" },
    { 0xE4847476, "estimates" },
    { 0xE91FFB24, "estimation" },
    { 0x1C832F43, "estr" },
    { 0xB415BEBD, "estrafevolume" },
    { 0x6DF4B61A, "et" },
    { 0xFB32E6D8, "et_actor" },
    { 0x6C912D07, "et_actor_corpse" },
    { 0x4134AB2D, "et_actor_spawner" },
    { 0xF9D67D0F, "et_fx" },
    { 0x884462EB, "et_general" },
    { 0x2B22E07E, "et_helicopter" },
    { 0x94E111DC, "et_item" },
    { 0x91684A73, "et_lensflare" },
    { 0x0B7A336C, "et_loop_fx" },
    { 0xBE82538F, "et_missile" },
    { 0x42DC2576, "et_phys_explosion_spheres" },
    { 0x63CD7811, "et_plane" },
    { 0x0C42FE46, "et_player" },
    { 0xF806BBAD, "et_player_corpse" },
    { 0x77ABF0EA, "et_player_invisible" },
    { 0xD050B5D8, "et_primary_light" },
    { 0xA062856D, "et_reflection_probe" },
    { 0x1DA667AB, "et_scriptmover" },
    { 0x0FD64A9A, "et_sound_blend" },
    { 0xCB045A88, "et_streamer_hint" },
    { 0x1DB3EAA7, "et_trigger" },
    { 0xE7597AD3, "et_vehicle" },
    { 0x24192652, "et_vehicle_corpse" },
    { 0x29E493CE, "et_vehicle_spawner" },
    { 0x78E42F1E, "et_zbarrier" },
    { 0x188C7277, "eta" },
    { 0x089EA57E, "etank1_own_player" },
    { 0x2DF3C906, "etank1_wait_for_apc" },
    { 0xDB5906BD, "etarget" },
    { 0x185135A4, "etargetent" },
    { 0x46ECB0DC, "etargetoffset" },
    { 0x03EF744C, "etargetoriginal" },
    { 0xB757EB7C, "etargets" },
    { 0xCC877DA5, "etc" },
    { 0x2D55A679, "etching" },
    { 0x0F43D8F1, "eternity" },
    { 0x147B0C28, "ethem" },
    { 0x4EA0384F, "ether" },
    { 0x99532594, "ethiopia" },
    { 0x31A1A4F5, "etime" },
    { 0xA7A1ED4A, "etrap_choke" },
    { 0x2A419506, "etrap_choke_count" },
    { 0xB3DF3622, "etrap_cleanup" },
    { 0x794A0199, "etrap_damage" },
    { 0x64FDA5D0, "etrig" },
    { 0xB80266D2, "etrigger" },
    { 0x1D8A3F1A, "etype" },
    { 0xEC690254, "euler" },
    { 0xFACA11A6, "european" },
    { 0x09C3D894, "europeantour" },
    { 0x21EFC148, "ev" },
    { 0x493D1380, "ev1_approacher_think" },
    { 0xBA650C4B, "ev1_bombing_plane" },
    { 0xFD4E93AA, "ev1_bombing_planes" },
    { 0x78F5309F, "ev1_burning_tank_commander" },
    { 0x4FB2413C, "ev1_checker_think" },
    { 0x8961EDF0, "ev1_cleanup" },
    { 0xE205ED76, "ev1_disable_left_side_triggers" },
    { 0x5243C715, "ev1_disable_right_side_triggers" },
    { 0x9AF94939, "ev1_drone_trigers_manager" },
    { 0xCF9BA850, "ev1_enemies_run_chasing" },
    { 0xCB3C55D9, "ev1_fire_think" },
    { 0xC4EC413D, "ev1_floating_body" },
    { 0xAB16EE18, "ev1_gunner_think" },
    { 0xDA9C5F16, "ev1_initial_escape_germans" },
    { 0xD0F5404D, "ev1_initial_escape_germans_2" },
    { 0x33A6EB4B, "ev1_jumper1_think" },
    { 0x723819D0, "ev1_jumper2_think" },
    { 0xD42488A9, "ev1_left_path_obj" },
    { 0x8357B85C, "ev1_objectives" },
    { 0x22E1B4AB, "ev1_patrol_think" },
    { 0x1F5FD706, "ev1_patrollers" },
    { 0x7E860CF0, "ev1_plane_bomb_l" },
    { 0xA4888759, "ev1_plane_bomb_m" },
    { 0x3281181E, "ev1_plane_bomb_r" },
    { 0x40C501BE, "ev1_rail_reactions_init" },
    { 0xD66B792A, "ev1_right_path_obj" },
    { 0x9A66BBA0, "ev1_right_side_tank_battle" },
    { 0xA5428CB6, "ev1_spawn_checkpoint_truck" },
    { 0x6B0369C4, "ev1_spawn_checkpoint_trucks_ambient" },
    { 0x7BD73A19, "ev1_spawners_anims_init" },
    { 0xDB717B48, "ev1_spawners_init" },
    { 0x124EC2E3, "ev1_stand_guard_think" },
    { 0x3653CCF2, "ev1_tank_5_obj" },
    { 0x13FFB2CA, "ev1_tank_obj" },
    { 0x5B6A4F1B, "ev1_tank_temp_obj" },
    { 0x72B99748, "ev1_temp_text" },
    { 0x59797BDF, "ev1_trench_flame_guy_think" },
    { 0xB39326E5, "ev1_trench_right_blow_up_guy_think" },
    { 0x3CEB7A07, "ev1_trench_think" },
    { 0x3A4706D9, "ev1_trench_think_cough1" },
    { 0x60498142, "ev1_trench_think_cough2" },
    { 0x436B80D2, "ev1_tripping_over" },
    { 0xC6E3DD75, "ev1_truck_delete_at_end" },
    { 0x6A3B2295, "ev1_truck_falling_off_bridge" },
    { 0x6913C848, "ev1_truck_falling_off_bridge_tank" },
    { 0x78FFA9B1, "ev1_truck_falling_off_bridge_truck" },
    { 0x0F9A6E08, "ev1_update_tank_obj" },
    { 0x03037A9B, "ev2_ambient_t34_actions" },
    { 0x9B46FF47, "ev2_ambient_tank_hits" },
    { 0x5D5C50AE, "ev2_ambient_tank_hits_enemy" },
    { 0xB7B51C16, "ev2_ambient_tank_hits_friend" },
    { 0xAD7A5A57, "ev2_battle_tank_1_and_2" },
    { 0xF1663DDB, "ev2_battle_tank_3_and_4" },
    { 0x1C393F32, "ev2_battle_tank_5" },
    { 0xE186E434, "ev2_blow_up_stuff" },
    { 0x66E73EFE, "ev2_blow_up_stuff2" },
    { 0x0969FE82, "ev2_bombing_dialog" },
    { 0xAB70E528, "ev2_check_los" },
    { 0x3F1A4CDF, "ev2_cleanup" },
    { 0x024AB037, "ev2_debris_turn1" },
    { 0xB645BB65, "ev2_debris_turn3" },
    { 0xD0ACF8B0, "ev2_delayed_trigger_wait" },
    { 0x4EDEDC44, "ev2_detect_player" },
    { 0x9A5FB22C, "ev2_dialogs" },
    { 0x99B8E0D8, "ev2_door_trigger" },
    { 0x78410F09, "ev2_enter_tunnel_dialog" },
    { 0x844512F7, "ev2_force_delete_enemies_barn" },
    { 0x03563231, "ev2_go_open_barn_door_1" },
    { 0x2958AC9A, "ev2_go_open_barn_door_2" },
    { 0x582406E6, "ev2_guys_at_door" },
    { 0x3C4E2A76, "ev2_halftrack_think" },
    { 0xFCB9CCD4, "ev2_ignore_players_initially" },
    { 0xC2E3D742, "ev2_loop_ambient_mg_burst" },
    { 0x7BC36ADF, "ev2_mount_player_on_tank_1" },
    { 0x79102785, "ev2_objectives" },
    { 0x9827BF04, "ev2_outro_player_trig_skipto" },
    { 0xBE854FDD, "ev2_pacing" },
    { 0x8A0524C0, "ev2_pacing_dialog" },
    { 0x3D59B2DB, "ev2_panther" },
    { 0xFBD668ED, "ev2_panther_fire_at_jeep2" },
    { 0x9F4704E0, "ev2_panzershreck_barrage" },
    { 0x8B8F1E5B, "ev2_panzershreck_respawns" },
    { 0xB982F4BD, "ev2_panzershreck_single_respawn" },
    { 0xDAE27E1F, "ev2_player_discovered" },
    { 0x86A1B1CC, "ev2_player_get_on_tank" },
    { 0x0B6D61C3, "ev2_player_mounted" },
    { 0xA2E4A989, "ev2_rail_reactions_init_a" },
    { 0xC8E723F2, "ev2_rail_reactions_init_b" },
    { 0xEEE99E5B, "ev2_rail_reactions_init_c" },
    { 0x14EC18C4, "ev2_rail_reactions_init_d" },
    { 0x3AEE932D, "ev2_rail_reactions_init_e" },
    { 0xC5819E34, "ev2_rail_start_section" },
    { 0x932ED029, "ev2_react_to_players" },
    { 0xF8BE38B3, "ev2_regroup_at_the_barn" },
    { 0x06E7F5F1, "ev2_regroup_open_barn_door" },
    { 0xC6B391BB, "ev2_regroup_success" },
    { 0xEE9BD69D, "ev2_regroup_tank_appears" },
    { 0x3A2BB6D5, "ev2_regroup_time" },
    { 0x724FA11E, "ev2_road_ai_pathing" },
    { 0x355673AA, "ev2_road_ai_side" },
    { 0x322136F6, "ev2_ship_00" },
    { 0x5823B15F, "ev2_ship_01" },
    { 0xE61C4224, "ev2_ship_02" },
    { 0x0C1EBC8D, "ev2_ship_03" },
    { 0x9A174D52, "ev2_ship_04" },
    { 0xC019C7BB, "ev2_ship_05" },
    { 0xD8CEABAC, "ev2_shreck_barrage" },
    { 0x687CB612, "ev2_shreck_loop" },
    { 0x5CB4F3C2, "ev2_spawners_anims_init" },
    { 0xA057F98F, "ev2_spawners_init" },
    { 0xE3032D44, "ev2_start_art_dust" },
    { 0x146FC8FF, "ev2_stay_behind_tank_dialog" },
    { 0x2DC6DB1E, "ev2_stop_art_dust" },
    { 0x3280EF16, "ev2_tank1" },
    { 0x0C7E74AD, "ev2_tank2" },
    { 0xE67BFA44, "ev2_tank3" },
    { 0xC0797FDB, "ev2_tank4" },
    { 0x9A770572, "ev2_tank5" },
    { 0xAC52ED66, "ev2_tank5_destroyed" },
    { 0xCB6966D4, "ev2_tank_1_can_mount" },
    { 0x58A1111F, "ev2_tank_2_can_mount" },
    { 0x44C5A2B6, "ev2_tank_3_can_mount" },
    { 0x2469859E, "ev2_tank_3b_can_mount" },
    { 0x35AECA0C, "ev2_tank_5_barrage" },
    { 0x916500CD, "ev2_tank_battle_3_force_start" },
    { 0x7FEB6F8E, "ev2_tank_battle_4_force_start" },
    { 0x4D97EBE2, "ev2_tank_end_node_detection" },
    { 0x9551E94E, "ev2_tank_guard_think" },
    { 0x3B02B2D6, "ev2_tank_loop_at_player" },
    { 0xDEC2C675, "ev2_tank_loop_fire" },
    { 0x3135ED71, "ev2_tank_mantle" },
    { 0x4000CB27, "ev2_tank_mantled" },
    { 0x2269D6AC, "ev2_tank_move_up_dialog" },
    { 0xFB98A297, "ev2_tank_movement" },
    { 0x30E666A0, "ev2_tank_movement_stop_mantle" },
    { 0xE8E60194, "ev2_tank_start_on_different_path" },
    { 0x83E59236, "ev2_tank_start_on_path" },
    { 0xB5F19550, "ev2_tank_think" },
    { 0x853FA2D4, "ev2_tank_threat_manager" },
    { 0xCC2AAEE5, "ev2_tanks_remaining" },
    { 0x700DBE99, "ev2_throw_guy_out_window" },
    { 0x2B421386, "ev2_truck_crash_anim" },
    { 0xDEF4251C, "ev2_truck_unload1_think" },
    { 0x73DD9947, "ev2_truck_unload2_think" },
    { 0x03ACE065, "ev2_wait_for_buddy_tank_death" },
    { 0x471C7F66, "ev2_wait_for_player_to_damage" },
    { 0x735BC886, "ev2_wait_for_player_to_get_close" },
    { 0x3A380B8C, "ev2_wait_for_tank_dialog" },
    { 0xC31F9FE2, "ev2_walk_barn" },
    { 0x869C5A23, "ev3" },
    { 0xD747CF96, "ev3_ambient_tank_hits" },
    { 0x9EE9DDE2, "ev3_barrels_init" },
    { 0x3AE6668D, "ev3_camp_spawn_goal" },
    { 0xD15F0E29, "ev3_chasing_tank_think" },
    { 0x3776DBAD, "ev3_destructible_truck_death_run" },
    { 0x8421F8A5, "ev3_digger_init" },
    { 0xD4FF38F4, "ev3_end_tank_1" },
    { 0x208FC767, "ev3_escaping_german" },
    { 0x6910D54B, "ev3_escaping_german_delay" },
    { 0x55F8785E, "ev3_execution_enemy_ai" },
    { 0xE81BD29A, "ev3_executioner_ai" },
    { 0x750103A9, "ev3_force_end_section_1" },
    { 0x89975FA0, "ev3_german_retreat" },
    { 0x9E42F074, "ev3_halftrack2" },
    { 0x9773E30C, "ev3_halftrack_detect_damage" },
    { 0xFE03C96A, "ev3_halftrack_mg_ai" },
    { 0x7AE85827, "ev3_halftracks_move" },
    { 0xB2912DC0, "ev3_initial_planes" },
    { 0x63183CBA, "ev3_knife_kill_enemy_ai" },
    { 0x3DF310C4, "ev3_mg42_only_player_kill2" },
    { 0x63F58B2D, "ev3_mg42_only_player_kill3" },
    { 0x16CB2A2E, "ev3_mg42_spawn_goal" },
    { 0xFF148F5E, "ev3_objectives" },
    { 0x888D86A7, "ev3_opel2_event" },
    { 0x4833FEB8, "ev3_opel_move" },
    { 0x99D1E0EA, "ev3_player_kill_enemy_ai" },
    { 0xBDF9039A, "ev3_retreat_final" },
    { 0xE37A788A, "ev3_retreat_final_plane1" },
    { 0xBD77FE21, "ev3_retreat_final_plane2" },
    { 0xC64F4F45, "ev3_retreat_final_tanks1" },
    { 0xEC51C9AE, "ev3_retreat_final_tanks2" },
    { 0xFD14B38A, "ev3_retreat_initial" },
    { 0xC99E3275, "ev3_retreat_lower_path" },
    { 0x1ACE6FCC, "ev3_retreat_plane" },
    { 0xE2EEA4CC, "ev3_retreat_random_death" },
    { 0x51B47FCC, "ev3_retreat_upper_path" },
    { 0x905A9C46, "ev3_runner_spawn_goal" },
    { 0xCEDF6D8C, "ev3_section1_anim" },
    { 0x4488C4AE, "ev3_section1_check_stealth_level" },
    { 0x110E686C, "ev3_section1_failsafe" },
    { 0x594B0930, "ev3_section1_stealth_broken" },
    { 0x829A191D, "ev3_section2_check_stealth_level" },
    { 0x6C475FBD, "ev3_section2_stealth_broken" },
    { 0xE02C3542, "ev3_spawners_1_custom_init" },
    { 0x6CDB5CF5, "ev3_spawners_2_custom_init" },
    { 0x558A8F4F, "ev3_spawners_anims_init" },
    { 0x97FFB916, "ev3_tank_shoot_and_run" },
    { 0x84F969A3, "ev3_temp_friends_init" },
    { 0x1AD9805D, "ev3_throw_guy_out_tower" },
    { 0x02F2F318, "ev3_tower_event" },
    { 0x0E83B58D, "ev3_tower_event_ai_spawn" },
    { 0x01494399, "ev3_tower_event_blow_up_t34" },
    { 0x243C90F9, "ev3_tower_event_force_blow_up" },
    { 0xFA749398, "ev3_tower_event_panzershreck_loop" },
    { 0x21D0AEF4, "ev3_tower_event_spawn_t34" },
    { 0xEEFC2053, "ev3_tower_event_spawn_t34_trigger_wait" },
    { 0xD880AAE4, "ev3_tower_event_t34_fire_loop" },
    { 0x9EBD2D4C, "ev3_tower_event_tracers_loop" },
    { 0x06B0D283, "ev3_track_opel_truck_death" },
    { 0xAF5319B3, "ev3_truck_destroyed" },
    { 0xF11F5D2A, "ev3_truck_special_stop" },
    { 0xF99857BD, "ev3_trucks_stop" },
    { 0xC7D781DF, "ev3_weapon_check_enemy_ai" },
    { 0x12A74621, "ev3_weapons_check_1_init" },
    { 0xAC69E978, "ev3_weapons_check_2_init" },
    { 0xC1257C4F, "ev3_weapons_check_3_init" },
    { 0x2442ED56, "ev3_weapons_check_4_init" },
    { 0x4A144478, "ev4_out_of_ammo_part_1" },
    { 0xBC1BB3B3, "ev4_out_of_ammo_part_2" },
    { 0x9619394A, "ev4_out_of_ammo_part_3" },
    { 0x273C78DF, "ev4_spawners_custom_1_init" },
    { 0x64064632, "ev4_spawners_custom_2_init" },
    { 0xFB3C1616, "ev_fire_weapon" },
    { 0x82772F58, "evac" },
    { 0x0E1A956D, "evac_fail_time" },
    { 0xFB993ECF, "evacuate" },
    { 0x88E4A919, "evacuated" },
    { 0xCD35E04A, "evacuating" },
    { 0x1C47BDC4, "evacuation" },
    { 0xF392BD68, "evade" },
    { 0x7B210C63, "evade_enemies_locked_on_me" },
    { 0x3FB67C4A, "evade_enemies_locking_on_me" },
    { 0x746DACB5, "evade_now" },
    { 0x2F1C2CFC, "evaded" },
    { 0xFF81BC54, "evadedirectionyaw" },
    { 0xE86B6069, "evading" },
    { 0x29317EFB, "evading_player" },
    { 0xBCAFE188, "eval_func" },
    { 0xC7574085, "evalate" },
    { 0x00E2F536, "evals" },
    { 0xF2BD26E0, "evaluate" },
    { 0x562E2E62, "evaluate_connections" },
    { 0x59B7B808, "evaluate_zone_path_override" },
    { 0xF53C305C, "evaluateattackevent" },
    { 0xFDF6557D, "evaluateblockedanimations" },
    { 0x581D6964, "evaluated" },
    { 0x75A53577, "evaluated_dist" },
    { 0xF833CB6F, "evaluatedthisframe" },
    { 0xA48A898F, "evaluatefiringevent" },
    { 0x8A86AD38, "evaluategametypeeventruleconditional" },
    { 0x88AAB781, "evaluatehumanexposedarrivalanimations" },
    { 0xC92E500F, "evaluatehumanturnanimations" },
    { 0x4D7827DC, "evaluatemeleeevent" },
    { 0x5656F7C5, "evaluatemoveevent" },
    { 0x237C9349, "evaluaterambochance" },
    { 0x77D5F46D, "evaluatereloadevent" },
    { 0x9242958B, "evaluates" },
    { 0x025C807F, "evaluatesuppressionevent" },
    { 0x957E6561, "evaluating" },
    { 0x25F59437, "evaluation" },
    { 0x084B4B0C, "evaluator" },
    { 0x1CCFDC75, "evaluator_checkanimationagainstgeo" },
    { 0x290B739E, "evaluator_checkanimationagainstnavmesh" },
    { 0x51C701A9, "evaluator_checkanimationarrivalposition" },
    { 0xF9822C6A, "evaluator_checkanimationendpointagainstgeo" },
    { 0x7D978902, "evaluator_checkanimationforovershootinggoal" },
    { 0xFB224694, "evaluator_findfirstvalidanimation" },
    { 0x4E5A2ACC, "evaporate_update" },
    { 0x1FBCE01A, "evasion" },
    { 0xF689EDCB, "evasion_index" },
    { 0x61C2EBFC, "evasion_path" },
    { 0x3599B9FA, "evasive" },
    { 0x2680E7A6, "evasive_action_done" },
    { 0x77BDACD8, "evasive_addpoint" },
    { 0x0FEF015B, "evasive_createmaneuvers" },
    { 0xB344EB5E, "evasive_drawpoints" },
    { 0x233BCDE8, "evasive_endmaneuvers" },
    { 0xF85D5119, "evasive_getallpoints" },
    { 0x717542E0, "evasive_maneuver" },
    { 0xFB45B1EE, "evasive_move" },
    { 0x93A83988, "evasive_points" },
    { 0x82B24C19, "evasive_startmaneuvers" },
    { 0x4825C76F, "evasive_think" },
    { 0x3B99B0B2, "evd_01" },
    { 0x582FE21D, "evd_01_render" },
    { 0xA6F94586, "evehicle" },
    { 0xB470F436, "evehicledeathorigin" },
    { 0x4ECC51EC, "evehicleorigin" },
    { 0x1F517C5D, "evehile" },
    { 0x08C1EFA3, "evel" },
    { 0xBCBCFAD1, "even" },
    { 0x10C5197A, "even_more_guys" },
    { 0x59AE6837, "even_number" },
    { 0x0DA77BB7, "evening" },
    { 0x3A1D353C, "evenly" },
    { 0x1D8CF5B8, "evens" },
    { 0x279E4E97, "event" },
    { 0x6E8DE75D, "event01_woods" },
    { 0x62E8A548, "event02_runtopipe" },
    { 0xCF2EFBD7, "event03_woodsindisguise" },
    { 0x95140223, "event04_walkingrail" },
    { 0x36065030, "event05_inverteddoorkick" },
    { 0xF7DBBDB3, "event06_zipline" },
    { 0x9B2306B1, "event07_hideoverwall" },
    { 0x4CBFB214, "event08_controlroombunkerbreach" },
    { 0x597A101A, "event09_complexengagement" },
    { 0x6F0B96BC, "event1" },
    { 0xEB65F084, "event10" },
    { 0x6291F511, "event10_blackroom" },
    { 0x9AD73C8A, "event10_close_floating_number_group" },
    { 0xFCD6B7C1, "event10_closer_floating_numbers" },
    { 0x23AD245F, "event10_denseteargasfadeaway" },
    { 0x58B8C105, "event10_dialogue" },
    { 0x6704CCB4, "event10_distant_floating_numbers" },
    { 0xE91F86F9, "event10_flash_to_bed" },
    { 0x93428B60, "event10_jumpto" },
    { 0x85B84A0C, "event10_numbers_close_in" },
    { 0xE5B6B8AE, "event10_rusalka_letters" },
    { 0xD1E33957, "event10_rusalka_scratch_zoom" },
    { 0xB42D1F91, "event10_start" },
    { 0x57FE1568, "event10_steiner_plead" },
    { 0x3BAF1C93, "event10_teargasroom" },
    { 0x11686AED, "event11" },
    { 0x373AA0C0, "event11_assassinatescientists" },
    { 0x7E1F41DF, "event11_jumpto" },
    { 0x8D14FAD4, "event11_start" },
    { 0x376AE556, "event12" },
    { 0x80FBB07B, "event12_headscientist" },
    { 0x6A0AC48A, "event12_jumpto" },
    { 0x5D6D5FBF, "event13" },
    { 0x2A4EE6F5, "event13_garage" },
    { 0xD42EA771, "event13_jumpto" },
    { 0x535C06E0, "event14" },
    { 0xCA61104D, "event14_bridgecollapse" },
    { 0x70857959, "event14_btrattack" },
    { 0x12F2B4A3, "event14_btrdrive" },
    { 0x4C028C94, "event14_btrdriveslow" },
    { 0xFE5E62FC, "event14_jumpto" },
    { 0x2C851EFE, "event14_open_first_gate" },
    { 0x050FE32A, "event14_protectsquad" },
    { 0x26DD9831, "event14_push_door_closed" },
    { 0x9EC88A8E, "event14_spawn_escort_migs" },
    { 0x678DBA55, "event14_start" },
    { 0x34A20F57, "event14_update_obj_after_entering_btr" },
    { 0x55A8BE17, "event14v2_drag_at_gate" },
    { 0x6E864666, "event14v2_limo_btr_bump" },
    { 0xC68E8FF1, "event14v2_match_btr_to_limo_speed" },
    { 0xF0C60FE7, "event14v2_ram_drag_now" },
    { 0x795E8149, "event15" },
    { 0xBBFDDC5B, "event15_jumpto" },
    { 0x5036AE3E, "event15_playerchoice" },
    { 0x9F60FBB2, "event16" },
    { 0xF5DD597F, "event16_davedevil" },
    { 0xBD641B26, "event16_jumpto" },
    { 0xC563761B, "event17" },
    { 0x7085009A, "event17_inboundchopper" },
    { 0x15D1ECDD, "event17_jumpto" },
    { 0xFB2C6DEE, "event1_2ndbridge" },
    { 0xCE7AE79D, "event1_aa_gun_fire" },
    { 0xA3C3D2E2, "event1_aa_gunner_alert" },
    { 0x7003AFB7, "event1_aa_repel_hit_targets" },
    { 0xB2B4DF5F, "event1_aaa_targetname_transmitter" },
    { 0x0671C319, "event1_action" },
    { 0x5DFD10FF, "event1_additional_repellers" },
    { 0xBC5C9925, "event1_adjust_fall_effects" },
    { 0x540D3C3B, "event1_adjust_vision_settings" },
    { 0x0AA5FC16, "event1_after_ambush" },
    { 0x9AEC330F, "event1_after_beatdown_enemies" },
    { 0xCC6246ED, "event1_after_intro_start" },
    { 0x4C1A4763, "event1_ai_kill_redshirts" },
    { 0x4AC547E7, "event1_ai_ride_think" },
    { 0xCDBFDE04, "event1_ai_takes_cover_behind_rocks" },
    { 0xC3767CAA, "event1_aisneak_alarm_flag" },
    { 0x0725CB48, "event1_aisneak_apt1" },
    { 0x7088FD6F, "event1_aisneak_battlechatter" },
    { 0x3582A4F1, "event1_aisneak_sarge_dialogue" },
    { 0xE578DE70, "event1_ambient_aaa_fx" },
    { 0xF3306645, "event1_ambient_lci_trigger" },
    { 0xAFDA758E, "event1_ambient_plane_crash" },
    { 0x99E497F3, "event1_ambient_planes_setup" },
    { 0x52A0012B, "event1_ambient_streetbattle_drones" },
    { 0x6407E70C, "event1_ambients" },
    { 0x929AFADF, "event1_amtank1_think" },
    { 0xEF9C82F4, "event1_amtank2_think" },
    { 0x70960611, "event1_amtank3_think" },
    { 0xBEA0B0F5, "event1_amtank_fire_watcher" },
    { 0x54C8781C, "event1_animate_barnes" },
    { 0x616FB595, "event1_animate_civ_mowdown" },
    { 0x6A7B14C0, "event1_animate_fake_spirit" },
    { 0x009AC003, "event1_animate_heli" },
    { 0x7293F552, "event1_animate_nva_mowdown" },
    { 0x0AC1EFE8, "event1_animate_passage_beatdown" },
    { 0x78FA1D5D, "event1_animate_pilot_inside_heli" },
    { 0x9D040F2E, "event1_animate_pilots" },
    { 0xF274E114, "event1_animate_player" },
    { 0x8C6454E7, "event1_animate_reznov" },
    { 0x8F242E8E, "event1_animate_reznov_idle_in_water" },
    { 0x861FC2E1, "event1_animate_reznov_open_door" },
    { 0xE84D92C1, "event1_animate_sampan6" },
    { 0xB424D845, "event1_animate_stairs_mowdown_ent" },
    { 0x099AE287, "event1_animate_vc_on_sampan" },
    { 0xD4D72F29, "event1_animate_vcs" },
    { 0xAE1C86A0, "event1_apc_column" },
    { 0x0C1A6CFA, "event1_artillary_fire" },
    { 0x448AB7BB, "event1_artillaryattack" },
    { 0x97638649, "event1_artillery_random_target" },
    { 0xC221C160, "event1_artillery_trig" },
    { 0xEAFA38CE, "event1_arty_fire" },
    { 0xAD18702E, "event1_atrium_dialogue" },
    { 0xF9844D31, "event1_atrium_mger" },
    { 0x9E3478EE, "event1_atrium_mger_alert" },
    { 0x21860D8C, "event1_atrium_mger_alertflag" },
    { 0xBF08D4B9, "event1_atrium_mger_friendlies" },
    { 0xA1D9D7C4, "event1_awesomeread" },
    { 0xD4ED4AEC, "event1_axis_beatdown_death" },
    { 0xD37387CE, "event1_balcony_fall_remains_fx" },
    { 0xAAF81A09, "event1_balcony_mger" },
    { 0x96C81906, "event1_balcony_mger_alert" },
    { 0xAFD9A8D0, "event1_balcony_rpg_guy_think" },
    { 0x23DE74AB, "event1_banzai_spawner" },
    { 0x1116D19B, "event1_barechest_guy_vignette" },
    { 0xEF6C37F3, "event1_barnes_effects" },
    { 0x74EDB3D1, "event1_barnes_notetrack_dialogue" },
    { 0xFBB7BAF8, "event1_battlechatter" },
    { 0xECA30C38, "event1_beach_tanks_setup" },
    { 0xA843EE99, "event1_binoculars" },
    { 0x24E7BA04, "event1_block_castle_wall" },
    { 0x85670E72, "event1_boatsquad1" },
    { 0xF151F597, "event1_boatsquad1_lookat" },
    { 0x8845E1DB, "event1_boatsquad1_rush" },
    { 0xA2980BD2, "event1_boatsquad1_rush_thread" },
    { 0x96B90934, "event1_bodybag_vignette" },
    { 0x7770BC65, "event1_bodybag_vignette_humans" },
    { 0x66C7FEAF, "event1_bodybag_vignette_props" },
    { 0x5C7967EA, "event1_bomber_crash" },
    { 0xA41F0F7E, "event1_bunker_doors" },
    { 0x265D6A49, "event1_bunker_doors_open" },
    { 0x51A95FB4, "event1_campfire" },
    { 0x0B53B5E8, "event1_change_sun_dir" },
    { 0xF60F75FB, "event1_check_for_weapons" },
    { 0x9790AE71, "event1_civ_animate_hallway_cower" },
    { 0x2FB3D346, "event1_civilian_mowdown" },
    { 0x126B65C4, "event1_civilians_vignette" },
    { 0xF914BC04, "event1_civs_animate_corner_surprise" },
    { 0x2DD4A7CD, "event1_civs_animate_hallway" },
    { 0x03973315, "event1_cleanup" },
    { 0x4F89818D, "event1_cleanup2" },
    { 0xDED16D15, "event1_cleanup_lvts" },
    { 0x69F2FB1F, "event1_cleanup_setup" },
    { 0xD4C4432F, "event1_copilot_notetrack_dilogue" },
    { 0x0242A34E, "event1_copilot_scripted_intro_dialogue" },
    { 0x62DF1B88, "event1_copilot_shot" },
    { 0xFCE6591A, "event1_copilot_shot_cloud" },
    { 0x49B8A361, "event1_coral_timed_death" },
    { 0xCC129B74, "event1_corner_explosion" },
    { 0x17DD2594, "event1_crash_main" },
    { 0x3902D7EF, "event1_crawling_guys" },
    { 0x53BFCEA1, "event1_crazy_plane_crash" },
    { 0xEB1FC6F4, "event1_crazy_plane_prop_fx" },
    { 0x69CA295A, "event1_deep_water_run_change" },
    { 0x8EF1B7B4, "event1_delay_huey" },
    { 0x3187437A, "event1_delete_helmet" },
    { 0x11CCFE30, "event1_detonate_huts" },
    { 0x4D82D30D, "event1_dialogue" },
    { 0xCC362202, "event1_dialogue_2" },
    { 0xF5F2AD1D, "event1_dialogue_count" },
    { 0x60E59AE7, "event1_dialogue_setup" },
    { 0xE0C69705, "event1_discover_campfire_guys" },
    { 0x606C31BE, "event1_distant_walla" },
    { 0xD697F256, "event1_dof" },
    { 0x84CD64E7, "event1_dogattack" },
    { 0xE8432CD2, "event1_door_open" },
    { 0x6C46D3A0, "event1_drag1_setup" },
    { 0x7C9B58E1, "event1_drop_crane_load" },
    { 0x7DE2A422, "event1_end" },
    { 0x9213BA6A, "event1_end_patrols" },
    { 0x088C27ED, "event1_ends" },
    { 0x5894719D, "event1_ents" },
    { 0xA7634211, "event1_explode_and_fade_to_white" },
    { 0xAA91C472, "event1_explosion_near_right_side_friendlies" },
    { 0x4DB68E89, "event1_extra_setup" },
    { 0x72E0BA7C, "event1_fakefire" },
    { 0x9F30022D, "event1_fakefire_think" },
    { 0x490FF706, "event1_fallingdebris_dialogue" },
    { 0xAAA757C3, "event1_fallingdebris_drop" },
    { 0x56C9908C, "event1_fallingdebris_think" },
    { 0x3DAF9DD5, "event1_fallingdebris_triggers_setup" },
    { 0xF50EAD7F, "event1_fallingsign" },
    { 0x25881CE5, "event1_fallingsign_dropletter" },
    { 0xED696795, "event1_fallingsign_fire_rocket" },
    { 0xE9CC5497, "event1_fallingsign_playersquake" },
    { 0x386F8374, "event1_fallingsign_preview_rockets" },
    { 0xA3715D7F, "event1_fightstart_by_shoot" },
    { 0xD4196548, "event1_fightstart_by_trig" },
    { 0x4C981F1A, "event1_fire_beatdown" },
    { 0x390A5A38, "event1_first_encounter_spotlight" },
    { 0x67E2F9DB, "event1_first_rusher_explosive_internal" },
    { 0x40930559, "event1_first_rusher_kill_think" },
    { 0x90A29110, "event1_flame_tank_waiter" },
    { 0x2D9C27C2, "event1_flamedeath" },
    { 0x69FFB19C, "event1_flametank_moveup_strat" },
    { 0x9EF38F05, "event1_flashlight" },
    { 0xC0BDD037, "event1_flashlight_off" },
    { 0x6903BB30, "event1_floating_bodies" },
    { 0xA54FBE6F, "event1_followtankinternal" },
    { 0x021C38B7, "event1_followtanks" },
    { 0x47715781, "event1_foxhole1" },
    { 0x6D73D1EA, "event1_foxhole2" },
    { 0x93764C53, "event1_foxhole3" },
    { 0x4BD0DDC3, "event1_freeze_helping_soldier_01" },
    { 0xD9C96E88, "event1_freeze_helping_soldier_02" },
    { 0xA9D75388, "event1_friendlies_on_right_side_think" },
    { 0x7EEE00C5, "event1_front_fallback" },
    { 0x0639BCFF, "event1_get_ai_off_of_lvt" },
    { 0x57B54226, "event1_get_on_mg" },
    { 0x92337DA3, "event1_get_players_off_of_lvt" },
    { 0x394ECFB2, "event1_give_guys_names" },
    { 0x8FBEA51C, "event1_give_look_control" },
    { 0x20C3D588, "event1_give_nambo" },
    { 0x397AFE92, "event1_give_player_weapons" },
    { 0xDAF51356, "event1_grenade_throw" },
    { 0xEF6EBCD8, "event1_guy_2_shed" },
    { 0x7464B343, "event1_guy_rappel" },
    { 0x98A0AFDF, "event1_guys_on_coral" },
    { 0xCAC0214C, "event1_guys_with_player_follow_tanks" },
    { 0xB71DC108, "event1_hack_anim_playback" },
    { 0x2C65D24C, "event1_hack_specular" },
    { 0xF0C29591, "event1_hallway_civ_left_cower" },
    { 0xDF0955E0, "event1_handle_objectives" },
    { 0x62C74E57, "event1_headtracking_player_check" },
    { 0x0D366938, "event1_headtracking_test_start" },
    { 0xCCB4E936, "event1_held_guy" },
    { 0x378168E9, "event1_held_guy_dialog" },
    { 0x65A0F26E, "event1_heli_ambiance" },
    { 0xB5684399, "event1_heli_fog_change" },
    { 0x2F5BC854, "event1_helicopter_internal_damage" },
    { 0x3CB6BC0E, "event1_helping_soldier_vignette" },
    { 0x89908108, "event1_hero_huey_dust" },
    { 0x489D8B5D, "event1_hide_hud" },
    { 0x39456757, "event1_hueys_onstation" },
    { 0x4B9726E5, "event1_hueywire_spark" },
    { 0x4CEDEABC, "event1_hut1_fx" },
    { 0xE762C45C, "event1_hut_collapse" },
    { 0xA7637FA5, "event1_hut_waiter_setup" },
    { 0x7A75555D, "event1_hut_waiter_setup2" },
    { 0x516AF077, "event1_hutexplosion" },
    { 0x2EF9EC41, "event1_hutexplosion_remains" },
    { 0x550FECD9, "event1_init_flags" },
    { 0x318BA24A, "event1_init_patrollers" },
    { 0x31E74947, "event1_intro" },
    { 0x6226471A, "event1_intro_aa_guns" },
    { 0x4367A932, "event1_intro_dialog" },
    { 0xD1230D0C, "event1_intro_dialogue" },
    { 0x06E5275D, "event1_intro_execution_vignette" },
    { 0xD46880DF, "event1_intro_huey_takeoffs" },
    { 0x10063F87, "event1_intro_music" },
    { 0x64B949CE, "event1_intro_player_blocker" },
    { 0x1BDA7067, "event1_intro_reznov_dialogue" },
    { 0xA9CB4480, "event1_intro_roebuck_start" },
    { 0x0D2D7287, "event1_intro_sullivan_start" },
    { 0xE2FD8243, "event1_introigc_gunshotfx" },
    { 0xD56EC905, "event1_introigc_headshotfx" },
    { 0x98040663, "event1_introigc_victimdialogue" },
    { 0x5324101C, "event1_japs_on_hut_strat" },
    { 0x35326777, "event1_jeep_crash" },
    { 0xE8FD3248, "event1_jeep_crash_avoid_guys" },
    { 0x63AB6C68, "event1_jeep_crash_fx" },
    { 0x7CA2FDFA, "event1_jeep_crash_jump" },
    { 0xA16FA40B, "event1_jeep_crash_jump_qte" },
    { 0x9ED80DEE, "event1_jeep_crash_swerve" },
    { 0x35A0AD0C, "event1_jeep_crash_woods" },
    { 0x8FE4CF7D, "event1_joiners" },
    { 0xBF8E2EC0, "event1_joiners_thread" },
    { 0x2A6FB128, "event1_jumpto" },
    { 0x76805A5B, "event1_katyusha" },
    { 0xFDFE0803, "event1_katyusha_rocket_barrage" },
    { 0x2466F00B, "event1_katyusha_rocket_barrage_side" },
    { 0x9E3BFEEE, "event1_katyusha_rocket_barrage_side_single" },
    { 0x8D06EEE5, "event1_katyusha_rocket_fly_think" },
    { 0x43556877, "event1_kill_if_player_skips_skydemon" },
    { 0x99D7F7C0, "event1_kill_if_riders_are_alive" },
    { 0x35E699CC, "event1_kill_off_enemies" },
    { 0x55489A1A, "event1_kill_player_on_too_far_up" },
    { 0xA391A91F, "event1_kill_player_on_too_far_up_during_strike" },
    { 0x36E535B8, "event1_kill_player_on_too_far_up_during_strike_ender" },
    { 0xB858CA14, "event1_killoff_mg_guys" },
    { 0x966BB3AA, "event1_knees_execution" },
    { 0x4B85B85C, "event1_knees_execution_2man_anims" },
    { 0x9553B56B, "event1_knees_execution_gunshotfx" },
    { 0x7D17CCDD, "event1_knees_execution_headshotfx" },
    { 0xAD318D10, "event1_knees_execution_interruptflag" },
    { 0x293853D5, "event1_knees_execution_victim_saved" },
    { 0xDADC6A54, "event1_knees_execution_watcher_anims" },
    { 0xC05B587F, "event1_knees_executioner_reset" },
    { 0x2FBEF263, "event1_large_explosions" },
    { 0x9F66C8C3, "event1_lci_rocket_fire" },
    { 0xFA96B0B0, "event1_left_art_stop_fire" },
    { 0x9A6D5E79, "event1_lerp_water_fog" },
    { 0x5A25ABDE, "event1_let_player_shoot" },
    { 0xA124C1C6, "event1_loadingdock_patroller" },
    { 0x05F333FE, "event1_lst_door_open" },
    { 0x377DB042, "event1_macv" },
    { 0x297041E4, "event1_macv_after_skydemon" },
    { 0xC08F820B, "event1_macv_dialogue" },
    { 0x5F657764, "event1_macv_fight_think" },
    { 0xBAC1D72B, "event1_macv_skydemon_main" },
    { 0x260B92DC, "event1_main" },
    { 0x4B44E8CC, "event1_main_wire" },
    { 0xF59CB650, "event1_manage_friendlies" },
    { 0x474C49F6, "event1_manage_friendlies_01" },
    { 0x99174BC8, "event1_master_thread" },
    { 0x9B6CA6F5, "event1_meatshield_player_model" },
    { 0x79A79F8C, "event1_medic_vignette" },
    { 0x76E49146, "event1_mg_dialog" },
    { 0x4AEE9D99, "event1_mg_target" },
    { 0x99B67EE9, "event1_mg_tarp" },
    { 0x827B5155, "event1_mg_tracer" },
    { 0xF9B32B1E, "event1_mg_tracer_ends" },
    { 0x14928E31, "event1_mger_death" },
    { 0x26C8E780, "event1_mitch_blood_pool" },
    { 0x7A2A2418, "event1_mitch_slash" },
    { 0xF15B771C, "event1_model3_fire" },
    { 0xA99DFF0D, "event1_model3_fire_think" },
    { 0x6D41AD77, "event1_monitor_civilian_mowdown" },
    { 0x02D405CB, "event1_mortars" },
    { 0xFC5D4D92, "event1_moveup_start" },
    { 0x44471063, "event1_napalm_bombing_run" },
    { 0x0292CFCA, "event1_near_shed" },
    { 0xA54CAEC7, "event1_new" },
    { 0xA66EA844, "event1_new_skipto" },
    { 0x3C230B7A, "event1_new_skipto_after_skydemon" },
    { 0x37095906, "event1_new_skipto_mowdown" },
    { 0xA4060097, "event1_no_water_run_change" },
    { 0xF4631963, "event1_nva_repel" },
    { 0x4F169B83, "event1_nva_rpg_guys" },
    { 0xD7391493, "event1_objective_blocker" },
    { 0x70782C4D, "event1_objective_left_art_done" },
    { 0x4DFC4C00, "event1_objective_right_art_done" },
    { 0x1EF366C2, "event1_objective_thread_follow_squad" },
    { 0xD4B99663, "event1_objective_thread_left_art" },
    { 0x0FA79F32, "event1_objective_thread_right_art" },
    { 0xFEFB38F1, "event1_objective_watcher" },
    { 0x33C0484F, "event1_objectives" },
    { 0x21DBEDCB, "event1_objectives_finish" },
    { 0xA7757032, "event1_objectivewaiter" },
    { 0xED6CD76F, "event1_on_player_connect" },
    { 0x74081D81, "event1_on_save_restored" },
    { 0xA2CDE50E, "event1_open_fire" },
    { 0x18254288, "event1_orange_team_death" },
    { 0xD61F67EB, "event1_outer_guys" },
    { 0x03BF2F52, "event1_past_mg" },
    { 0x6625FFFC, "event1_patroller_reaction_internal" },
    { 0x0FFB16BF, "event1_patroller_reactions" },
    { 0x9F92310D, "event1_pby_pontoons_up_hatch_open" },
    { 0x8D2F5EEA, "event1_pillar_cover_guys" },
    { 0x931265CE, "event1_pillar_guys_sound" },
    { 0x8CE1940B, "event1_plane_bomb_dropper" },
    { 0x361489DA, "event1_plane_bomb_dropper_think" },
    { 0xB36467D6, "event1_plane_down" },
    { 0x2D712937, "event1_plane_explosion" },
    { 0xEA3355A2, "event1_planes" },
    { 0x36E3AE2B, "event1_play_right_off_effects" },
    { 0x41D0EE38, "event1_player_at_the_door_loop" },
    { 0xE76446A7, "event1_player_balcony_fall" },
    { 0xDD168EFE, "event1_player_balcony_fall_think" },
    { 0xB746D9F1, "event1_player_below_water_above_again" },
    { 0xD9BD8DFF, "event1_player_below_water_first_time" },
    { 0x253EB915, "event1_player_blink_eye" },
    { 0x8731C12E, "event1_player_breaks_window" },
    { 0xFD28B69F, "event1_player_breath_underwater" },
    { 0xEA7A44D8, "event1_player_hand_fire_into_huey" },
    { 0x42C5A1D4, "event1_player_hand_touch_water" },
    { 0x9F4E340A, "event1_player_model" },
    { 0xC0E0C3BE, "event1_player_notetrack_dialogue_and_sounds" },
    { 0x91F707EA, "event1_player_position" },
    { 0xC4ADA61F, "event1_player_prints" },
    { 0xAE2BDCDA, "event1_player_release_player" },
    { 0x89D135FB, "event1_player_release_vignette" },
    { 0x687C1377, "event1_player_repel" },
    { 0x1C7959AC, "event1_player_ride_think" },
    { 0x79526C57, "event1_player_scripted_intro_dialogue" },
    { 0x6439C854, "event1_player_switch_dragon_breath" },
    { 0xC0C47739, "event1_player_talk_to_barnes" },
    { 0x2EDD2D21, "event1_player_tank_dismount" },
    { 0x7872C297, "event1_player_view_explosions" },
    { 0xB570A12A, "event1_player_water_in_face" },
    { 0xA8597B72, "event1_plop_water" },
    { 0x5EA2B779, "event1_pond_fight" },
    { 0xFB868288, "event1_pond_fighter_damage" },
    { 0x015F2B1E, "event1_pop_smoke" },
    { 0xD13A5642, "event1_pop_smoke_anim" },
    { 0xD1CAEA5C, "event1_pop_smoke_skip" },
    { 0x54E961BB, "event1_post_aftermath_mortars" },
    { 0x9CCCBF15, "event1_post_rocket_dialogue" },
    { 0xB6BDE35F, "event1_post_rockets_moveup_ai" },
    { 0xB1594158, "event1_precache_everything" },
    { 0xE2CD155E, "event1_put_ai_on_lvt" },
    { 0x27E624C0, "event1_put_players_on_lvt" },
    { 0xC35168F3, "event1_radio_guy_moveup" },
    { 0x72897EAD, "event1_radio_man" },
    { 0x3B8AFD8E, "event1_random_arty_shake" },
    { 0x0A377BEB, "event1_random_arty_shake_cleanup" },
    { 0xFF1D8EE3, "event1_ready_soldiers_vignette" },
    { 0x88BA5B9A, "event1_rear_fallback" },
    { 0xA101F980, "event1_recon" },
    { 0x4477E253, "event1_redshirt_repel" },
    { 0xF37DD94B, "event1_redshirt_runway_vo" },
    { 0xA081DAA7, "event1_redshirts_move_up" },
    { 0x4E5365D2, "event1_redshirts_regroup" },
    { 0x987D3985, "event1_regroup" },
    { 0x3F37E3E4, "event1_regroup_before_pacing" },
    { 0xE85F16EB, "event1_remove_spawners_for_coop" },
    { 0xDFFFCE2F, "event1_remove_start_ents" },
    { 0xE0418B7F, "event1_repel" },
    { 0x7690CF74, "event1_repel_bowman_breaks_glass" },
    { 0xA7F0FF7A, "event1_repel_guys" },
    { 0x3B1850D1, "event1_repel_guys_animate_rope" },
    { 0x7E464386, "event1_repel_guys_internal" },
    { 0xE9C091E7, "event1_repel_heli_think" },
    { 0x35058964, "event1_repel_pilot" },
    { 0x5E492EE3, "event1_repel_room_enemy_think" },
    { 0xA80FC95E, "event1_repel_troop_ready" },
    { 0xFC619727, "event1_rescue_pow" },
    { 0xACCF9C8D, "event1_rescuers" },
    { 0xEBE11027, "event1_reset_dvars" },
    { 0xA1009872, "event1_response_group" },
    { 0x0437C3A7, "event1_reznov" },
    { 0x21B2991D, "event1_rider_dismount_anim" },
    { 0x695DA036, "event1_rider_idle_anim" },
    { 0x10B5111A, "event1_rider_idle_anim_roebuck_roebuck" },
    { 0x69725D4B, "event1_riders_take_cover_and_die" },
    { 0x0A213F3B, "event1_right_art_stop_fire" },
    { 0x3C0811C0, "event1_right_artsetup" },
    { 0xD4B2B6E1, "event1_right_side_friendly_setup" },
    { 0xD89C590A, "event1_road_convoy" },
    { 0xBBAA8ECC, "event1_rocket_hints" },
    { 0x7D711BAA, "event1_rocket_hints_finish" },
    { 0xF710565F, "event1_rocket_hints_thread" },
    { 0xDCAF27D1, "event1_rocket_impact_think" },
    { 0x11C853D9, "event1_rocketlaunchigc" },
    { 0x6D861164, "event1_roebuck_after_intro_run" },
    { 0x64772AEC, "event1_rooftop_rockets" },
    { 0x3F8EF4BD, "event1_ropes_repel" },
    { 0xC7C3B304, "event1_runway_phantoms" },
    { 0xD91B3047, "event1_rushers" },
    { 0xB038955A, "event1_saferoom_dialogue" },
    { 0x1DE5DA01, "event1_sampan6" },
    { 0xD45345DD, "event1_sampan_wakes_internal" },
    { 0x39788BFA, "event1_sampan_wakes_think" },
    { 0xCF600F75, "event1_save_ryan" },
    { 0x741D8016, "event1_seal_tunnel_entrance" },
    { 0xDF9F1F35, "event1_second_encounter_guys_back_last" },
    { 0x2AB92A74, "event1_second_encounters_runners" },
    { 0x185BF975, "event1_second_encounters_runners_think" },
    { 0x072502F1, "event1_set_objective" },
    { 0x95173612, "event1_set_start_position" },
    { 0x6CB16FEE, "event1_set_sun_dir" },
    { 0x625D7C24, "event1_set_up_grass_guy" },
    { 0x8B7DA0E6, "event1_setup" },
    { 0xF6DC6F10, "event1_setup_aa_gun" },
    { 0x21499B30, "event1_setup_ai_anims" },
    { 0xEAB1AC53, "event1_setup_germans_watching_bombers" },
    { 0x1FFD9620, "event1_setup_heros" },
    { 0x3101EEB1, "event1_setup_hueys" },
    { 0x47B1D283, "event1_setup_intro_huey" },
    { 0x0D38A957, "event1_setup_lvts_with_drones" },
    { 0x1482F990, "event1_setup_pilots" },
    { 0xE86CCD72, "event1_setup_player" },
    { 0xF7094DE9, "event1_setup_player_anims" },
    { 0x44DCD0CD, "event1_setup_prop_anims" },
    { 0x6120CF8B, "event1_setup_repel_player" },
    { 0x37F82057, "event1_setup_repel_spirit" },
    { 0xB0C0ED45, "event1_setup_rushers" },
    { 0xD7E220F7, "event1_setup_sampan" },
    { 0x12DAC80B, "event1_setup_vcs" },
    { 0x9B638A0B, "event1_ship_fire_controller" },
    { 0x63906971, "event1_shooting_start" },
    { 0x22816752, "event1_show_hud" },
    { 0xB1F4F9AC, "event1_showdown" },
    { 0x9419EC5C, "event1_showdown_color_delay" },
    { 0xB885E564, "event1_showdown_damage" },
    { 0x607AA13E, "event1_sky_metal" },
    { 0x8196EA35, "event1_skydemon_ai_deathfunc" },
    { 0x448F9628, "event1_skydemon_ai_shoot" },
    { 0x1F46ADA9, "event1_skydemon_ai_think" },
    { 0xBCE0AF87, "event1_skydemon_animated_mowdown" },
    { 0x87264EAE, "event1_skydemon_done" },
    { 0xD1BFAD62, "event1_skydemon_firing_think" },
    { 0x0815C1E3, "event1_skydemon_player_lookat_think" },
    { 0xEDF3F525, "event1_skydemon_repel_think" },
    { 0xFA946F8C, "event1_small_bunker_rocket_damage_think" },
    { 0xEDCE783B, "event1_small_explosions" },
    { 0x21A19AE4, "event1_small_room_fog_monitor" },
    { 0xC93E9EBB, "event1_smoke_check" },
    { 0x60C8D3FD, "event1_smoke_popped" },
    { 0x65768301, "event1_smoke_screen" },
    { 0x83907E45, "event1_smoky_hallway" },
    { 0xE0CC33E4, "event1_smoky_hallway_aicrouch" },
    { 0x188692D8, "event1_smoky_hallway_playerspeed" },
    { 0xE2389ED3, "event1_smoky_hallway_playervision" },
    { 0x08E1E27A, "event1_smoky_hallway_sargewarning" },
    { 0x206E5580, "event1_spawn_rear_defenders" },
    { 0xCDFC8304, "event1_spiderhole_ambush_melee" },
    { 0x1395B9E7, "event1_spirit_repel" },
    { 0xF632E165, "event1_spirit_think" },
    { 0x9F6146A0, "event1_spotlight_off_gun" },
    { 0x64625F9C, "event1_spotlight_on_gun" },
    { 0xFF86EBDC, "event1_spotlight_shine_positions" },
    { 0xAF8B547A, "event1_squad_moveup" },
    { 0xC5E54833, "event1_squibline" },
    { 0x3F272B32, "event1_squibline_think" },
    { 0x6C19D9BD, "event1_squibline_think_burst" },
    { 0x1E666A12, "event1_squibline_think_impacts" },
    { 0xB2783ACE, "event1_squibline_think_impacts_for_anim" },
    { 0x7D8101ED, "event1_squibline_think_v2" },
    { 0x4769BE47, "event1_stair_guy_back_die_if_not_killed" },
    { 0x02747F47, "event1_stair_guy_back_special_death" },
    { 0x1D740869, "event1_stair_guy_back_think" },
    { 0x6173B729, "event1_stair_guy_front_die_if_not_killed" },
    { 0x5359CBA9, "event1_stair_guy_front_special_death" },
    { 0xF55F5B0F, "event1_stair_guy_front_think" },
    { 0x07C70814, "event1_staircase_molotov_thrower_think" },
    { 0xDE774FB1, "event1_stairs_civilian_shooters" },
    { 0x8F2EE099, "event1_start" },
    { 0xE9CFC9E2, "event1_start_action" },
    { 0x3267A1F7, "event1_start_air_escort" },
    { 0x21478AD1, "event1_start_apt2" },
    { 0x8A1F2D12, "event1_start_atrium" },
    { 0x4D27CDFB, "event1_start_cobra" },
    { 0xF744656B, "event1_start_delayed_patrollers" },
    { 0x48555DFD, "event1_start_loadingdock" },
    { 0xA8DE93A9, "event1_start_outside" },
    { 0xD39A01E2, "event1_start_phantoms" },
    { 0x46CAA649, "event1_start_runway_armada" },
    { 0xAE2C2C45, "event1_start_seaknights" },
    { 0xE0BAC384, "event1_start_street_regroup" },
    { 0x90C6BF10, "event1_startothertanks" },
    { 0xEB768B14, "event1_stop_tutorial" },
    { 0x0977F27F, "event1_strength_test_button_prompt" },
    { 0x43A282C4, "event1_strength_test_fail_timer" },
    { 0x7E79C3FD, "event1_strength_test_rumble" },
    { 0x32B1EDD6, "event1_stuck_lvt_anim" },
    { 0x801DECAD, "event1_stuck_on_coral" },
    { 0xFBD16C3F, "event1_sullivan_3_route" },
    { 0xE49275AA, "event1_sullivan_goodjob" },
    { 0x77E5CD8A, "event1_sullivan_instruct_rockets" },
    { 0xBCEC13F8, "event1_support_chopper_01_guys_think" },
    { 0x20F0A995, "event1_support_chopper_takeoff" },
    { 0x66D1423D, "event1_support_chopper_vignette" },
    { 0x485FB4D7, "event1_support_choppers" },
    { 0xEED45D76, "event1_support_troops_rightside" },
    { 0xB4FCAA6B, "event1_switch_weapons_on" },
    { 0xE1738561, "event1_tank2_attacked" },
    { 0xE999145A, "event1_tank3_attacked" },
    { 0xC75645E8, "event1_tank3_moveup_start" },
    { 0xBA856A85, "event1_tank3_riders_explosion_death" },
    { 0xA90FDF64, "event1_tank3_targets_link" },
    { 0x506F94F5, "event1_tank_explosion_effect" },
    { 0x8FF6C056, "event1_threads" },
    { 0xCF531F16, "event1_threatbias_management" },
    { 0xC210F638, "event1_time" },
    { 0x23F24E2A, "event1_timer" },
    { 0xF7CCABD7, "event1_to_battle_stations" },
    { 0xC06DAFF6, "event1_towers_vignette" },
    { 0xB6CE55EB, "event1_tracer_burst" },
    { 0xE7528AF2, "event1_tree_sniper_ambush" },
    { 0xE071092A, "event1_tree_snipers" },
    { 0xA76495EF, "event1_treesniper_pawn" },
    { 0x3F303570, "event1_trigger_hallway_civs" },
    { 0xDD247A1A, "event1_trigs_off" },
    { 0xAC1FCF86, "event1_tunnel_dialogue" },
    { 0xDAA521C9, "event1_tutorial" },
    { 0x3D7AD0C8, "event1_tutorial_waypoints" },
    { 0x4D090C85, "event1_under_hut" },
    { 0x507C5D49, "event1_underwater_squib" },
    { 0x37991A61, "event1_underwater_squib_kill_ai" },
    { 0x400D42EB, "event1_unlink_at_animation_end" },
    { 0xC0B24214, "event1_unlockplayer" },
    { 0x5D215D34, "event1_upper_mg" },
    { 0x4820924C, "event1_vignette_start" },
    { 0x5E007424, "event1_vignettes" },
    { 0xD1956B7A, "event1_wait_for_objectives_done" },
    { 0x62355992, "event1_wait_for_player_to_open_door" },
    { 0x69CB403A, "event1_wait_until_player_shoots" },
    { 0x49111203, "event1_wake_up_the_player" },
    { 0xC6C18742, "event1_warn_player_on_too_far_up" },
    { 0xAA50896A, "event1_warp_supplydrop" },
    { 0xEEE8B8F3, "event1_warroom_dialogue" },
    { 0x17A65BAB, "event1_warroom_dialogue_early" },
    { 0x96B10C46, "event1_water_depth_out_think" },
    { 0x4ED5418F, "event1_water_depth_think" },
    { 0x33CECC92, "event1_weapon_handler" },
    { 0xBD658AFF, "event1_woods" },
    { 0x354CC8E8, "event1_woods_repel" },
    { 0xAD577CE6, "event1_woods_think" },
    { 0x0CDB2875, "event1_woodsrunsjumpsdives" },
    { 0xF0F1773D, "event1a" },
    { 0xF03E82F5, "event1a_flash_update_vision" },
    { 0x125485F8, "event1a_skipto_setup" },
    { 0x16F3F1A6, "event1b" },
    { 0x00389F33, "event1b_cleanup" },
    { 0x8012481E, "event1b_fire_japs_up_hill" },
    { 0x167C7170, "event1b_friendlies_cleaup1" },
    { 0xA1C457E5, "event1b_friendlies_cleaup1_co_op" },
    { 0xB654207A, "event1b_friendlies_hut_cleaup1" },
    { 0x3E05C296, "event1b_randomfirepoint" },
    { 0x270E9428, "event1b_setup" },
    { 0x58355F71, "event1b_skipto_setup" },
    { 0x537635EA, "event1b_tank1_movesup" },
    { 0x98722D25, "event1b_tree_sniper" },
    { 0xC2894E3D, "event1b_update_vision" },
    { 0x587F8A4B, "event1b_vision_settings" },
    { 0x433DCFDA, "event1c_bunker_mortars" },
    { 0x10F11436, "event1c_bunkerguys_vignette" },
    { 0x8D26B33E, "event1c_crash_ambient_marines" },
    { 0xD4514C88, "event1c_heroicsoldier_rumble" },
    { 0x13523D7D, "event1c_heroicsoldier_vignette" },
    { 0x896E1CD8, "event1c_heroicsoldier_vignette_listener" },
    { 0xB9FBCAFD, "event1c_jumpdown_guys" },
    { 0x28B4A16B, "event1c_mortarguy_vignette" },
    { 0x424EB0B6, "event1c_mortarstrikes" },
    { 0x2C264563, "event1c_pre_runway_mortars" },
    { 0xFF877C78, "event1c_radiosgt_vignette" },
    { 0x75A1BDB5, "event1c_runway_mortars" },
    { 0xC903D2F3, "event1c_trench_mortars_1" },
    { 0x56FC63B8, "event1c_trench_mortars_2" },
    { 0x750AEB9C, "event1c_trench_walk" },
    { 0x873781EB, "event1c_trench_walk_mortars" },
    { 0x2D28143C, "event1c_trench_walk_player_damage" },
    { 0x57D1D035, "event1c_trench_walk_turns" },
    { 0x6C16A6CF, "event1c_trenchsgt_vignette" },
    { 0x8D44A670, "event1c_trenchsgt_vo" },
    { 0x3DA70050, "event1c_update_vision" },
    { 0x54180D9F, "event1c_vignettes" },
    { 0x2E662EC2, "event1c_vision_settings" },
    { 0xF8C0E3D5, "event1c_woods_think" },
    { 0xD5CB9D05, "event1d_start" },
    { 0x1E483D2F, "event1d_update_vision" },
    { 0x36F6FA8D, "event1d_vision_settings" },
    { 0x5C96D3C2, "event1e_update_vision" },
    { 0xB5339004, "event1e_vision_settings" },
    { 0xE11305F7, "event2" },
    { 0x1FE42D44, "event2_2" },
    { 0x11242674, "event2_above_water_fail" },
    { 0xBAB1B855, "event2_action_dialogue" },
    { 0x04580C9A, "event2_after_shrine" },
    { 0x0B384C29, "event2_ah_ah_ah" },
    { 0xA6930FFF, "event2_amb_mortarstrikes" },
    { 0x8B2AAF0D, "event2_animate_player" },
    { 0xAA20921A, "event2_animate_sampan6" },
    { 0xC01C86CC, "event2_animate_special_meatshield_guy" },
    { 0x23F86B56, "event2_animate_vc_and_boat" },
    { 0xAE2DD36C, "event2_animate_vcs_and_sampans_main" },
    { 0x83C57E27, "event2_apc_approach" },
    { 0x02D436F0, "event2_apc_crush" },
    { 0x323D2157, "event2_apc_crush_heli" },
    { 0xB525CE78, "event2_apc_crush_player_watch" },
    { 0x58DE373B, "event2_apc_crush_squad_watch" },
    { 0x8D179BCA, "event2_arty" },
    { 0x96EF43B3, "event2_arty_fx_reset" },
    { 0xB80BF68C, "event2_arty_setup" },
    { 0x7CD36A2D, "event2_arty_shake" },
    { 0x94FABDE7, "event2_banzai" },
    { 0xE081256C, "event2_barrel_explode" },
    { 0xDB3D9095, "event2_barrels" },
    { 0x8B956437, "event2_beach" },
    { 0x184092E5, "event2_beach_clear" },
    { 0x64EADADC, "event2_beach_dialogue" },
    { 0x24E51474, "event2_beach_grenade" },
    { 0xC1FBD742, "event2_beach_start" },
    { 0xE271904F, "event2_before_shrine" },
    { 0x49993E84, "event2_before_shrine_dialogue" },
    { 0xAAD086D4, "event2_before_shrine_waittill" },
    { 0x29B66D24, "event2_boat_3_drone_con" },
    { 0x95A53CB7, "event2_boat_approach" },
    { 0xA9CDD005, "event2_boat_fx" },
    { 0xA515A69E, "event2_boatsquad2_raft" },
    { 0x3A8B1330, "event2_bodydump" },
    { 0xF4708855, "event2_bombing_drop_011" },
    { 0x78574996, "event2_bombing_drop_1" },
    { 0x98AA0A2A, "event2_bombing_starts" },
    { 0x0AAB29C4, "event2_bunker_exit" },
    { 0x3E60F69B, "event2_bunker_exit_heli" },
    { 0x963BEF1A, "event2_bunker_update_vision" },
    { 0x5AB1FC1C, "event2_bunker_vision_settings" },
    { 0x54EA12F2, "event2_cleanup" },
    { 0xACE1A784, "event2_cleanup_setup" },
    { 0x6813815B, "event2_debris" },
    { 0x854D3D3E, "event2_debris_cleanup" },
    { 0x3D5874F7, "event2_debris_m" },
    { 0x64CFCE4F, "event2_decide_search_loop_time_for_boat" },
    { 0xC3716E23, "event2_delete_ship_shields" },
    { 0x13DD9BB1, "event2_delete_u_cut_blocker" },
    { 0x9BF00757, "event2_destruction_dialogue" },
    { 0x22AA5999, "event2_dialog_thread" },
    { 0x18F92F9C, "event2_dialogue" },
    { 0xF8BE4E3C, "event2_dialogue_m" },
    { 0x8F1B0414, "event2_dialogue_splined" },
    { 0xD9B8B08D, "event2_dialogue_splined_general" },
    { 0xC21F1589, "event2_dialogue_splined_ptboat" },
    { 0x08B4FA0F, "event2_disable_meatshield_mantle_trigs" },
    { 0x933355A0, "event2_ends" },
    { 0x9557B834, "event2_enter_u_cut_guys" },
    { 0x9EBD6A3D, "event2_enter_ucut_watcher" },
    { 0x432B0BF0, "event2_ents" },
    { 0x325117A2, "event2_exit_u_cut_hand_2_hand" },
    { 0x5EC25DE6, "event2_exit_ucut" },
    { 0x4E8BBCED, "event2_exit_ucut_heli" },
    { 0x88427198, "event2_exitgate_action" },
    { 0xD9452844, "event2_fake_bullet_whizbies" },
    { 0x4CF420A4, "event2_falling_animation" },
    { 0xF53B12CC, "event2_first_bridge" },
    { 0x53900B53, "event2_first_bridge_heli" },
    { 0xE3DD3FB3, "event2_flak_front_of_plane" },
    { 0x2A22E21B, "event2_flak_shake" },
    { 0x0533F528, "event2_flame_marine" },
    { 0xF89219F4, "event2_flame_marine_nva_burn" },
    { 0x8B053C2F, "event2_flank_right" },
    { 0x2C4DCF92, "event2_flank_right_heli" },
    { 0x678440AC, "event2_flashbacks" },
    { 0x27786027, "event2_flood_spawner" },
    { 0x84DC9778, "event2_foxhole1" },
    { 0xF6E406B3, "event2_foxhole2" },
    { 0xD0E18C4A, "event2_foxhole3" },
    { 0x47D8ADD3, "event2_friends_setup" },
    { 0xB0581F21, "event2_grenade_death_guy_explode" },
    { 0x665265DB, "event2_handle_objectives" },
    { 0xB189E960, "event2_headshot" },
    { 0x2AB7B3FF, "event2_heli_think" },
    { 0x2CD9B7CD, "event2_hideatpipe" },
    { 0x5672C395, "event2_house_guys" },
    { 0xBB7AC786, "event2_hudson_hand_2_hand" },
    { 0x99F2CE8D, "event2_huey_strafe" },
    { 0xC9DF5A45, "event2_idle_flashbacks" },
    { 0x8AD88AE1, "event2_initial_ambush" },
    { 0x7921A2F0, "event2_intro" },
    { 0x116F3429, "event2_jogger_start" },
    { 0x57D833FF, "event2_jogger_thread" },
    { 0x4E79FBD9, "event2_jumpto" },
    { 0x22CE2079, "event2_karambitintoduction" },
    { 0x797B7040, "event2_kill_enemyai_before_goatpath" },
    { 0xD0031545, "event2_kill_off_remaining" },
    { 0x77DA8A71, "event2_ladder_heli" },
    { 0x83D79F40, "event2_machine_gun_turret_dive" },
    { 0xA357EC14, "event2_machine_gun_turret_dive_rumble" },
    { 0x74F1C26D, "event2_main" },
    { 0xED75E2B8, "event2_main_function" },
    { 0x610F32AF, "event2_main_rocket_attack" },
    { 0x17ACE6DC, "event2_manage_the_ocean_water" },
    { 0xAF1EB90D, "event2_meathield_jumpto" },
    { 0xC401230C, "event2_meatshield_animate_player" },
    { 0x26DF1414, "event2_meatshield_reset_player" },
    { 0x29CC5ABF, "event2_meatshield_scene_main" },
    { 0x4FC4CCFA, "event2_meatshield_setup_player" },
    { 0x3B791742, "event2_meatshield_vc_failsafe" },
    { 0xE08AB530, "event2_mg42_target" },
    { 0xA8F7BE30, "event2_mg42_target_movement" },
    { 0x3AF08624, "event2_mg42_target_wrapper" },
    { 0x95B75FCF, "event2_mg_dialogue" },
    { 0xD9D670FA, "event2_mg_dismount" },
    { 0x9095FD26, "event2_mg_force" },
    { 0x8C4B55B9, "event2_mg_get_speaker" },
    { 0x0C07E37E, "event2_mg_net" },
    { 0x05D128E1, "event2_mg_owner_death" },
    { 0x948242D1, "event2_mg_targets" },
    { 0x6C731A53, "event2_mg_think" },
    { 0x8C8686B5, "event2_mg_thread" },
    { 0xD5377DA9, "event2_mgs" },
    { 0x7C460A51, "event2_monitor_enemies" },
    { 0x6C92EBA5, "event2_morgue_doors_flash_start" },
    { 0x957D9D56, "event2_mortarhut_explode" },
    { 0x9C9AC3C5, "event2_moveup_dialog" },
    { 0xC585894B, "event2_narrows_backup" },
    { 0x94FA4DA5, "event2_narrows_guys" },
    { 0x393809CC, "event2_nearing_morgue" },
    { 0x06AEABD0, "event2_nva_land_or_death" },
    { 0x6597EC79, "event2_nva_leaper" },
    { 0xA223621A, "event2_objectives" },
    { 0xCD69C578, "event2_on_sampan_fail_watcher" },
    { 0xCB9EE444, "event2_over" },
    { 0x25B9FE95, "event2_pby_b_1st_pass" },
    { 0xA3D82634, "event2_pby_engine_control" },
    { 0x9484653E, "event2_phantom_strike" },
    { 0x523FA55F, "event2_phantom_ucut" },
    { 0xAC90A5EE, "event2_playerbodycarry" },
    { 0x3EA75B29, "event2_players_start" },
    { 0x13D5969F, "event2_playersprint_failsafe" },
    { 0xD7B23627, "event2_ptboat_1st_pass" },
    { 0x652F5FC3, "event2_ptboat_2nd_pass" },
    { 0x9039317F, "event2_ptboat_2nd_pass_m" },
    { 0x1239467C, "event2_ptboat_3rd_pass" },
    { 0xF41B2B72, "event2_ptboats_4th_pass" },
    { 0x045B0D32, "event2_rejoin_squad" },
    { 0xD8290B9F, "event2_reset_squad_colors" },
    { 0x89C1361A, "event2_runtopipe" },
    { 0xE3077813, "event2_seat_control" },
    { 0x9649196F, "event2_seat_control_m" },
    { 0x6C941ED9, "event2_setup" },
    { 0x756FC865, "event2_setup_ai_anims" },
    { 0x62FA5BF3, "event2_setup_first_ship_drones" },
    { 0xB4C2D782, "event2_setup_first_ship_drones_flee" },
    { 0xACB76A5F, "event2_setup_first_ship_drones_respond_aft" },
    { 0x59FE6758, "event2_setup_first_ship_drones_respond_bow" },
    { 0x208EE403, "event2_setup_first_ship_drones_respond_tower" },
    { 0x78E09A9C, "event2_setup_mg" },
    { 0x577CA6A8, "event2_setup_player_anims" },
    { 0xC894DDE9, "event2_setup_player_meatshield_trigger" },
    { 0xAE8287BC, "event2_setup_prop_anims" },
    { 0x8A7C3989, "event2_setup_second_ship_drone_turnon_lights" },
    { 0x3C10FC31, "event2_setup_second_ship_drones" },
    { 0xFAC9E8DF, "event2_setup_second_ship_drones_aft" },
    { 0xA810E5D8, "event2_setup_second_ship_drones_bow" },
    { 0xBC53FA08, "event2_setup_second_ship_drones_con" },
    { 0xB278EA96, "event2_setup_third_ship_drones" },
    { 0x67C55CDF, "event2_setup_third_ship_drones_con" },
    { 0xD9B52BF3, "event2_shutup" },
    { 0x1F0A0717, "event2_sink_all_boats" },
    { 0x8E945051, "event2_sky_metal" },
    { 0x4234290A, "event2_snare_death" },
    { 0x7288F4A9, "event2_snare_death_break_rope" },
    { 0x2A2E8884, "event2_snare_dialog" },
    { 0x948AF895, "event2_snare_trap" },
    { 0xD969E510, "event2_snare_trap_temple_dialogue" },
    { 0x5D0F6260, "event2_spawn_drowners" },
    { 0xAF74226D, "event2_spawn_event3_blockers" },
    { 0x02F59F97, "event2_spawn_rowboat_with_drones" },
    { 0x70BBBC7D, "event2_spawned_cleanup" },
    { 0xC521F899, "event2_spawned_nva_cleanup" },
    { 0xA9165FDB, "event2_spawner_relocation" },
    { 0x755F00E5, "event2_split_squad" },
    { 0xE9E2D921, "event2_spot_light_damage" },
    { 0x025B6D5E, "event2_spotlight" },
    { 0x47D469F3, "event2_spotter" },
    { 0x3301EC02, "event2_start" },
    { 0x688C678B, "event2_start_allies" },
    { 0x740470A3, "event2_start_go" },
    { 0xF0A6C857, "event2_start_metrowave" },
    { 0x026743C5, "event2_start_runback" },
    { 0x72C24715, "event2_started" },
    { 0x882BB34D, "event2_starts" },
    { 0x13412E2D, "event2_stop_held_guy_vignette" },
    { 0xAF1F391F, "event2_stop_spotlight" },
    { 0xE11BD2DF, "event2_strafe_boats" },
    { 0x3DE14D1E, "event2_strafe_boats_force_player_play" },
    { 0x577355FB, "event2_strafe_boats_m" },
    { 0x15FF7AA2, "event2_straight_path" },
    { 0x890B712C, "event2_strength_test" },
    { 0x8C11428C, "event2_strength_test_button_prompt" },
    { 0x609E9FD9, "event2_strength_test_fail_timer" },
    { 0x467B3A30, "event2_strength_test_rumble" },
    { 0x63F692F0, "event2_tackle" },
    { 0x590D00A9, "event2_threatbias_management" },
    { 0x541B6115, "event2_threatbiasgroups" },
    { 0xA542DFDD, "event2_time" },
    { 0x5919CD85, "event2_timer" },
    { 0xE5FA3B16, "event2_top_melee" },
    { 0x8F74C080, "event2_top_melee_back" },
    { 0x6BB8A41D, "event2_top_of_hill" },
    { 0x53F24C82, "event2_trigsoff" },
    { 0x8EDEC667, "event2_twin_apc" },
    { 0x248AF6E6, "event2_u_cut" },
    { 0x9125F487, "event2_u_cut_allies" },
    { 0xF8397DA5, "event2_u_cut_back_allies" },
    { 0x04509013, "event2_u_cut_back_guys" },
    { 0x9A4B19D8, "event2_update_vision" },
    { 0x8E93400B, "event2_uphill_dialog" },
    { 0xCA86A380, "event2_vc_death" },
    { 0x8319A893, "event2_vc_death_blood_cloud" },
    { 0xAF0EABBB, "event2_vc_meatshield_animate_myboat" },
    { 0xB9EA48C2, "event2_vc_wait_for_alert" },
    { 0xDBCE9AC0, "event2_vc_waittill_meatshield_done" },
    { 0x87E0534A, "event2_vision_settings" },
    { 0x253A43F4, "event2_wait_for_sullivan" },
    { 0x56D0A42A, "event2_waittill_obstacle_explode" },
    { 0x2626893C, "event2_waittill_player_near_meatshield_sampan_trig" },
    { 0x427B13A8, "event2_wood_stroll" },
    { 0x1E61AE3E, "event2_woods_grab_guy_vignette" },
    { 0xA157E9F7, "event2_woods_ladder_blindfire" },
    { 0x5F02D418, "event2_woods_trans_to_defend" },
    { 0x35737A58, "event2a_jumpto" },
    { 0x2B90EC09, "event2a_start" },
    { 0x8500C809, "event2b_jumpto" },
    { 0x5C0937B2, "event2b_start" },
    { 0xC4E8B31F, "event2c_start" },
    { 0x6226AFF0, "event2d_start" },
    { 0x9108B5AD, "event2e_start" },
    { 0xBB108B8E, "event3" },
    { 0xE17BF9DF, "event3_action" },
    { 0x750F613B, "event3_ambient" },
    { 0xCBA4FBD8, "event3_ambient_anims" },
    { 0x4C392ACE, "event3_anim_reach" },
    { 0x2BB0A211, "event3_anim_reached" },
    { 0x33AC8685, "event3_blocker" },
    { 0x10694812, "event3_bloom" },
    { 0x0050E164, "event3_cavalry_arrives" },
    { 0xF0B6338D, "event3_charge" },
    { 0xE714CCF0, "event3_charge_set" },
    { 0xD820C9EB, "event3_cleanup" },
    { 0xC4CA10DD, "event3_cleanup_setup" },
    { 0xA33314E4, "event3_close_hatch" },
    { 0x9CA945A4, "event3_complete" },
    { 0x1F626152, "event3_crawl_burn_nva" },
    { 0xECE81017, "event3_dialogue" },
    { 0xAE265851, "event3_done" },
    { 0x85866244, "event3_doors" },
    { 0x3B697584, "event3_double_feign_anim" },
    { 0xE57C5BE7, "event3_elevator" },
    { 0x1DEC4144, "event3_end" },
    { 0xF16920F7, "event3_ends" },
    { 0xAC3289C4, "event3_ent_shootguys" },
    { 0x38B410EE, "event3_entrance_guys_killed" },
    { 0x9EE66E47, "event3_ents" },
    { 0xBBEE1A15, "event3_execution" },
    { 0x277CEB35, "event3_execution_2man_anims" },
    { 0xC8A8862C, "event3_execution_gunshotfx" },
    { 0x9A7556E4, "event3_execution_headshotfx" },
    { 0xF500EE1E, "event3_feign_death_scene" },
    { 0x58D8605A, "event3_feign_getup" },
    { 0x54A5BAAF, "event3_feign_interrupt_thread" },
    { 0xC06FAEFF, "event3_feign_interrupted" },
    { 0x435FE8BA, "event3_feign_interrupted_flare" },
    { 0x14BE39F1, "event3_feign_start" },
    { 0x0D03124F, "event3_fightstart" },
    { 0x87E8D2C6, "event3_fightstart_by_trig" },
    { 0xF80A82EC, "event3_fightstart_loop" },
    { 0x5AB79A12, "event3_finale_airmada" },
    { 0xA1493828, "event3_finish" },
    { 0xD3186EE7, "event3_flak_flash_single" },
    { 0xB509F298, "event3_flak_flashes" },
    { 0x865AFD27, "event3_flare" },
    { 0x6563A563, "event3_flash_to_bed" },
    { 0xFBAEFE9D, "event3_flashroom_visionset" },
    { 0x4193C373, "event3_flashrooms" },
    { 0x65C059E1, "event3_flow" },
    { 0xA012460F, "event3_fougasse_activation" },
    { 0x0B29B2AE, "event3_fougasse_blockers" },
    { 0x568C6467, "event3_foxhole1" },
    { 0xE484F52C, "event3_foxhole2" },
    { 0x0A876F95, "event3_foxhole3" },
    { 0x24E686DB, "event3_freeze_hatch" },
    { 0xC3C97B2D, "event3_freeze_marine" },
    { 0xFDB3C320, "event3_front_planter_guys" },
    { 0x73ED4E01, "event3_gatehouse_guys_killed" },
    { 0x30118D23, "event3_gatehouse_mg" },
    { 0xF54FBBF2, "event3_goat_path" },
    { 0x3C212C22, "event3_heroes_to_law" },
    { 0x3C4C177B, "event3_hold_the_line" },
    { 0xF50BC1B6, "event3_hold_the_line_watcher" },
    { 0x31A8192C, "event3_huey_strafe_crash" },
    { 0xE5E07D31, "event3_intro" },
    { 0xAF983712, "event3_jumpto" },
    { 0x3DE8EF50, "event3_kam_c" },
    { 0x4C865395, "event3_kamikaze_zero" },
    { 0x3B65861D, "event3_kill_guys_together" },
    { 0x08660FF3, "event3_killthedogs" },
    { 0xB3948DD4, "event3_leave_sword" },
    { 0x472D072A, "event3_main" },
    { 0x372CB94D, "event3_meetwithhudson" },
    { 0xD6F7D588, "event3_mg_blow" },
    { 0xBDCEB4CF, "event3_migflyover" },
    { 0x1EE0D4B0, "event3_move_woods_near_end" },
    { 0x35724C71, "event3_objectives" },
    { 0xE0FE3A49, "event3_outro_test" },
    { 0xBD5DFAB6, "event3_panther_kill" },
    { 0x59444F1D, "event3_panther_manualspawn" },
    { 0x1E996971, "event3_panther_turret_think" },
    { 0x30E1C8EA, "event3_plane_crash_clear_switchnode" },
    { 0x14AAAD91, "event3_plane_crash_into_plane" },
    { 0x204B769F, "event3_plane_crash_set_switchnode" },
    { 0x9530E3EC, "event3_play_midlevel_igc" },
    { 0x86CA75C0, "event3_player_ahead" },
    { 0x333E2CED, "event3_player_use_fougasse_one" },
    { 0xB70D48BB, "event3_player_use_fougasse_two" },
    { 0x1DEEDF8C, "event3_players_start" },
    { 0xC22574BF, "event3_portable_mg" },
    { 0x73E3F543, "event3_regroup_athouse" },
    { 0x9AE6473E, "event3_ridge_enemy_dialog" },
    { 0x73C74294, "event3_right_guys_killed" },
    { 0x29A6AA1E, "event3_section_1" },
    { 0x75FEEE34, "event3_section_1_complete" },
    { 0x5EBFA02D, "event3_section_2_complete" },
    { 0x2ECFE040, "event3_setup" },
    { 0x5BEE4688, "event3_show_tank_poi" },
    { 0x993CCA1D, "event3_single_feign2_anim" },
    { 0x1318E142, "event3_squad_paci_till_fight" },
    { 0x17B7920F, "event3_stabber_death" },
    { 0x3B2D6EBE, "event3_stabber_death_thread" },
    { 0x2886A7AF, "event3_start" },
    { 0xDFE10FB8, "event3_start_allies" },
    { 0x8494E128, "event3_start_fight" },
    { 0x993DA2C1, "event3_stealth_attack" },
    { 0x78FE584C, "event3_stealth_run" },
    { 0xCCA24811, "event3_tank_phase" },
    { 0xAADA80D2, "event3_teleport_friendlies" },
    { 0x1B8216D4, "event3_temp_replace_friendlies" },
    { 0xCFB06AD0, "event3_threatbias_management" },
    { 0xE9770F4A, "event3_time" },
    { 0x2440761C, "event3_timer" },
    { 0x5B328D97, "event3_trans_to_china" },
    { 0xACB602D4, "event3_trans_to_fougasse_two" },
    { 0xCB6A639F, "event3_triggered_lightning" },
    { 0xA459506C, "event3_trigs_off" },
    { 0x3304D345, "event3_update_vision" },
    { 0x448BB885, "event3_vignette_mg_death" },
    { 0x86437453, "event3_vision_settings" },
    { 0x8EFA4A07, "event3_woods_drum_activation" },
    { 0xA8DA83AC, "event3_woods_fougasse_drum" },
    { 0xE1319261, "event3_woods_manning_gun" },
    { 0xE369DCE9, "event3_woods_trans_to_defend" },
    { 0xC2D6C7C5, "event3_woodsindisguise" },
    { 0xA5246709, "event3b2_update_vision" },
    { 0x7C130CEF, "event3b2_vision_settings" },
    { 0x02E4A5E4, "event3b_jumpto" },
    { 0xE355213D, "event3b_start" },
    { 0xD889B137, "event3b_update_vision" },
    { 0x3C5B7075, "event3b_vision_settings" },
    { 0x42AB23C0, "event3c_start" },
    { 0x31D1A8EA, "event3c_update_vision" },
    { 0xBD11514C, "event3c_vision_settings" },
    { 0xE24E8C85, "event3d_update_vision" },
    { 0xF8E23093, "event3d_vision_settings" },
    { 0xFD042781, "event4" },
    { 0xEFABE279, "event4_airstrike_test" },
    { 0xB9C603FD, "event4_ambush_start" },
    { 0x088F0BEF, "event4_babies_in_trench" },
    { 0x450D4724, "event4_barrel_impulse" },
    { 0x7893E2D9, "event4_barrel_sparks" },
    { 0x87919E86, "event4_baseonalert" },
    { 0xA925C4B0, "event4_bypass_initial_enemies" },
    { 0xA0483A30, "event4_castle_fall" },
    { 0x3F97B900, "event4_cleanup" },
    { 0xACD71AE0, "event4_cleanup_crew" },
    { 0x62AC3185, "event4_cleanup_firetrig" },
    { 0x51EB416A, "event4_cleanup_setup" },
    { 0x54D75F4C, "event4_cleanup_swimmers" },
    { 0x4E65D915, "event4_clear_bunker" },
    { 0x37CB433D, "event4_communicationsbuildingdistraction" },
    { 0xB8B20271, "event4_conversation" },
    { 0x5A3C4748, "event4_convoy_comes" },
    { 0xEA6979AD, "event4_convoy_kills_player_on_road" },
    { 0x1C1AC845, "event4_convoy_spots_player_on_road" },
    { 0x10F6623B, "event4_corsair_rescue_1" },
    { 0x2FE2A96A, "event4_cover_allies" },
    { 0x2759AE41, "event4_damage_control" },
    { 0x24853273, "event4_detect_barrels" },
    { 0xC98E118E, "event4_dialogue" },
    { 0x3C19A00F, "event4_didplayer_gunjump" },
    { 0x57729A13, "event4_disable_weapon" },
    { 0x4D1F48E8, "event4_door_kicker" },
    { 0x50FAA850, "event4_drowning_drones" },
    { 0xFBBA9CF7, "event4_elevator1" },
    { 0x89B32DBC, "event4_elevator2" },
    { 0x840C4AC0, "event4_enable_weapon" },
    { 0xC154BA82, "event4_ends" },
    { 0x1E0644F1, "event4_entranceguys_come" },
    { 0x13D76D32, "event4_ents" },
    { 0xD59F1AF0, "event4_explosions" },
    { 0xC691DB0E, "event4_fallback" },
    { 0x7440B165, "event4_fire_response_gun" },
    { 0x5028B15B, "event4_first_ship_drones" },
    { 0x8E12B358, "event4_fleet_shoot" },
    { 0xC8D0ED79, "event4_float_numbers" },
    { 0x1D497D86, "event4_floating_number_spline" },
    { 0x6513DC5D, "event4_floating_numbers" },
    { 0xCA3F2785, "event4_fly_across_landing" },
    { 0xEBC8C028, "event4_follow_woods" },
    { 0xCE0742F1, "event4_fuel_trail" },
    { 0x9515C583, "event4_gunjump_loop" },
    { 0x490CA1BB, "event4_hara_fx" },
    { 0x2A2A32BE, "event4_hara_kiri" },
    { 0x87ACAAD9, "event4_hill_transition" },
    { 0xD5DDE5E1, "event4_hilltop_briefing" },
    { 0x8A1353EA, "event4_hint_check" },
    { 0x005888B2, "event4_hole1_guys" },
    { 0xC3E4B37F, "event4_hole2_guys" },
    { 0xD3ADA1D3, "event4_house_guys" },
    { 0x0F17A279, "event4_initial_enemies" },
    { 0xD6D951DA, "event4_intro" },
    { 0xE6A32403, "event4_jumpto" },
    { 0x1E5B6F80, "event4_kamikaze_end_fx" },
    { 0x4F594B0E, "event4_kamikaze_filler" },
    { 0xE4B788A7, "event4_kamikaze_path_explode" },
    { 0x1AF8638E, "event4_kamikaze_ship" },
    { 0x693DC455, "event4_kamikaze_ship_animation" },
    { 0x3DF79F24, "event4_kamikaze_ship_response" },
    { 0x1F4E00BD, "event4_kick_a_barrel" },
    { 0xA64283B0, "event4_last_area" },
    { 0x5710E224, "event4_last_objective" },
    { 0xD892DF88, "event4_mid_igc" },
    { 0xBB527A91, "event4_napalm_drop" },
    { 0xD5A270A2, "event4_new_progression" },
    { 0xB18FF893, "event4_numbers_close_in" },
    { 0x9DE8C623, "event4_nva_accuracy" },
    { 0x4DD290ED, "event4_objective" },
    { 0x5C5D27EC, "event4_objectives" },
    { 0x9C002DC1, "event4_officers" },
    { 0xCD13C3A6, "event4_part1_transition_boats" },
    { 0x1EDC1428, "event4_part2point5" },
    { 0x5413D90A, "event4_part2point5_fake_deaths" },
    { 0x4486274A, "event4_part3" },
    { 0x78554109, "event4_pby_crashing" },
    { 0x8169BC75, "event4_phantom_drop" },
    { 0xAAEA8037, "event4_player_coop_truck_anim" },
    { 0xCB568DE8, "event4_player_running_away" },
    { 0x858C8DB5, "event4_player_truck_anim" },
    { 0x0CFD1B0B, "event4_players_start" },
    { 0x5DD4F0C5, "event4_ptboat_ambush" },
    { 0x36722A92, "event4_ptboat_ambush_dialogue" },
    { 0xE1F3E2DC, "event4_ptboat_control" },
    { 0x1C711BEB, "event4_ptboat_first_wave" },
    { 0x1ACBF667, "event4_ptboat_fourth_wave" },
    { 0x25F34B89, "event4_ptboat_rescue_2" },
    { 0xB6841A58, "event4_ptboat_rescue_2_cleanup" },
    { 0x0BBA1DBC, "event4_ptboat_rescue_2_dialog" },
    { 0xB3B17392, "event4_ptboat_rescue_2_zeros_spawn_b" },
    { 0xD9B3EDFB, "event4_ptboat_rescue_2_zeros_spawn_c" },
    { 0x3D5BE8ED, "event4_ptboat_save_second_guy" },
    { 0xA0A8AD05, "event4_ptboat_save_second_guy_track" },
    { 0x20890E5C, "event4_ptboat_save_third_guy" },
    { 0xC25E6AFF, "event4_ptboat_second_wave" },
    { 0xF8F12368, "event4_ptboat_third_wave" },
    { 0xB8C94969, "event4_push_scene" },
    { 0x24363703, "event4_push_scene_setup" },
    { 0x92AE0B45, "event4_raft_drones" },
    { 0xFF34542D, "event4_random_zeros" },
    { 0x9346C1AC, "event4_rescue_1_ambient_flee_pt" },
    { 0x6AFB5C0F, "event4_rescue_zeros" },
    { 0xBDCBDCFF, "event4_roebuck_truck" },
    { 0x35AC03F6, "event4_savetheday" },
    { 0x9A50C831, "event4_seat_control" },
    { 0x4740A44B, "event4_setup" },
    { 0x6400BFC1, "event4_setup_barrels" },
    { 0xA97629C0, "event4_single_explosion" },
    { 0x2A4D1020, "event4_sinking_ship" },
    { 0xB1781A36, "event4_smash_gate" },
    { 0xC73FEF43, "event4_sound_notifies" },
    { 0x6E73A184, "event4_spawn_nva_hill_start" },
    { 0xC0D64E62, "event4_spawn_nva_rushers" },
    { 0x852A0EDF, "event4_squad_rally" },
    { 0xC7576C80, "event4_start" },
    { 0xBAA3EBB5, "event4_start_allies" },
    { 0xFDBAE2A6, "event4_start_downhill" },
    { 0xB52C8304, "event4_start_fuel_spill" },
    { 0x3D9D6C13, "event4_started" },
    { 0x576B69EF, "event4_sullivan_dialog" },
    { 0xE1C89990, "event4_sullivan_light_fuel" },
    { 0x6A584D15, "event4_sullivan_roebuck_dialog" },
    { 0x71442874, "event4_sullivan_truck" },
    { 0x6F3274AA, "event4_switch_spawners_hill_a" },
    { 0x492FFA41, "event4_switch_spawners_hill_b" },
    { 0x9EEA3107, "event4_talker" },
    { 0x2BE45803, "event4_tank_dust" },
    { 0xF7B2FF82, "event4_tank_dust_think" },
    { 0x08E663C3, "event4_tanks_coming" },
    { 0x823F72EB, "event4_threatbias" },
    { 0x0CA08AE7, "event4_throw_barrel" },
    { 0x2064C2C1, "event4_tigers_close_in" },
    { 0x171BE006, "event4_timed_entranceguys" },
    { 0x80696C13, "event4_tower" },
    { 0x9099FE70, "event4_tower_impact" },
    { 0xE3EDBD0A, "event4_trench_a" },
    { 0xBDEB42A1, "event4_trench_b" },
    { 0xDD69D051, "event4_trenches_burned" },
    { 0x4D37B6D0, "event4_trigger" },
    { 0x5A6393CE, "event4_truck_anims" },
    { 0x5A6BE977, "event4_truck_barrels" },
    { 0x3ECBD5E2, "event4_truck_dialogue" },
    { 0x374F7ED2, "event4_truck_go" },
    { 0x51A33AB3, "event4_truck_hint" },
    { 0xE0184080, "event4_truck_scene" },
    { 0x6AB5A0C4, "event4_truck_sounds" },
    { 0x3D6736B5, "event4_tunnel_dialog" },
    { 0x84B498E8, "event4_twopointfive" },
    { 0x63DA3BEF, "event4_update_escape_objective" },
    { 0x6E0635AA, "event4_update_vision" },
    { 0xB1D50C3D, "event4_vignettes" },
    { 0x512B7B0C, "event4_vision_settings" },
    { 0x54AB8D79, "event4_walkingrail" },
    { 0xFBE12044, "event4_watch_early_switch" },
    { 0x480C8CAD, "event4_woods_cache" },
    { 0xC0CBE447, "event4_woods_improvise" },
    { 0x91A0AD6B, "event4_woods_kick" },
    { 0x958BAFAE, "event4a_jumpto" },
    { 0xC37322A1, "event4b" },
    { 0xD7F3BAA7, "event4b_allies_goprone_a" },
    { 0x65EC4B6C, "event4b_allies_goprone_b" },
    { 0xAD5857BB, "event4b_allies_think" },
    { 0xFD4EB189, "event4b_backtrack_blocker" },
    { 0x8EF23A66, "event4b_bunker_cleanup" },
    { 0xABC96B72, "event4b_death_loops" },
    { 0x98DAE055, "event4b_first_approach" },
    { 0x60E5EE35, "event4b_friendly_fire_incident" },
    { 0x35B50D1F, "event4b_hilltop_melee" },
    { 0x2F2D3BC9, "event4b_hilltop_woods" },
    { 0x46A5993A, "event4b_intro" },
    { 0x57CEA0E3, "event4b_jumpto" },
    { 0x964BBB69, "event4b_marine_yell_huey" },
    { 0x39E70C09, "event4b_start_line_a" },
    { 0x5FE98672, "event4b_start_line_b" },
    { 0x85EC00DB, "event4b_start_line_c" },
    { 0x7249875D, "event4b_transition_event5" },
    { 0xB2DDD71D, "event4b_tree_fx" },
    { 0x03544CCA, "event4b_update_vision" },
    { 0xFBD3B6E0, "event4b_vignette_marine_arm" },
    { 0x4E98EBAC, "event4b_vision_settings" },
    { 0xFDC3D753, "event4b_woods_jam" },
    { 0xE1904884, "event4c_jumpto" },
    { 0x700E4897, "event4c_update_vision" },
    { 0x648451D5, "event4c_vision_settings" },
    { 0xD701AD18, "event5" },
    { 0x00B08789, "event5_ambient_airstrikes" },
    { 0x49433233, "event5_big_finale" },
    { 0x2F012253, "event5_bunker_door" },
    { 0xD2170E58, "event5_bunker_guy_spawn" },
    { 0x4038C3EE, "event5_charge_set" },
    { 0x74C95C19, "event5_clear_out_camp" },
    { 0xA5BD6FA0, "event5_closedoors" },
    { 0xB7CA1C99, "event5_dialogue" },
    { 0x279886DA, "event5_drone_thread" },
    { 0xFE26EE51, "event5_first_wave" },
    { 0x9FC04CC5, "event5_init_movieplaying_surfaces" },
    { 0x0EE2E353, "event5_intro" },
    { 0x50CB6D22, "event5_inverteddoorkick" },
    { 0xD4C00C01, "event5_jeep_tow_battle" },
    { 0x01BB1BA4, "event5_jumpto" },
    { 0x9B7F1267, "event5_leave_satchel" },
    { 0x4E85E51F, "event5_movie_control" },
    { 0xBF8BD51B, "event5_napalm_grid" },
    { 0x09E69FBF, "event5_near_roebuck" },
    { 0xB251B05F, "event5_opendoor" },
    { 0x7416E905, "event5_opening" },
    { 0x893CDDB6, "event5_outtro_guy_spawn" },
    { 0xA8E42104, "event5_plant_charges" },
    { 0x8933C2EA, "event5_radio_vo" },
    { 0xAC9F3B6B, "event5_redshirt_jeep" },
    { 0x7747A885, "event5_redshirt_think" },
    { 0x05460DAE, "event5_reset_respawner2" },
    { 0x3E990C00, "event5_ride_the_jeep" },
    { 0x7306B8FD, "event5_roebuck_charge" },
    { 0xBBF961FA, "event5_roebuck_charge_dialogue" },
    { 0xD1A96A8E, "event5_roebuck_charge_movment" },
    { 0xA2A137D5, "event5_roebuck_plant_charge_timer" },
    { 0x5687CF37, "event5_roebuck_post_charge_dialogue" },
    { 0xE0B42E5D, "event5_setup_redshirts" },
    { 0x456790F8, "event5_setup_respawner2" },
    { 0x26612FA5, "event5_skipto" },
    { 0xD7D3BFC1, "event5_small_movies_go" },
    { 0x4BF037EB, "event5_split_up" },
    { 0x1483D9FD, "event5_start" },
    { 0x88A62342, "event5_start_allies" },
    { 0x5EAD0E59, "event5_start_respawner" },
    { 0x943A491F, "event5_sullivan_position" },
    { 0x7E1BAB66, "event5_t55_ambient" },
    { 0x6BF86350, "event5_threatbiasgroups" },
    { 0x7C4155F7, "event5_update_vision" },
    { 0x783ADD35, "event5_vision_settings" },
    { 0x14A02E9C, "event5_wave_0_think" },
    { 0xBC2FD6B5, "event5_weaponsfreeonroof" },
    { 0x49091C53, "event6" },
    { 0xA1DAC6DA, "event6_blow_up_compound" },
    { 0x96C4B681, "event6_boat1" },
    { 0xBCC730EA, "event6_boat2" },
    { 0x4E0639AD, "event6_boat_ride" },
    { 0xA0AB991E, "event6_dialog" },
    { 0xDC3ABB28, "event6_dialogue" },
    { 0xD758BF88, "event6_dissolve_roof" },
    { 0x29071CD8, "event6_enemy_nodes" },
    { 0x69B8F28D, "event6_escorting_corsairs" },
    { 0x8B36652A, "event6_exit_trigger_think" },
    { 0x7F29B96B, "event6_fletcher_swap" },
    { 0x4C1CFC5D, "event6_get_ai_on_boats" },
    { 0x43FC730B, "event6_get_to_boat" },
    { 0xB1499ED5, "event6_get_to_boat_roebuck" },
    { 0x7ECA9EE2, "event6_get_to_boat_sullivan" },
    { 0xB2D2BEEE, "event6_guys_to_boats" },
    { 0x4C8FD5A5, "event6_jumpto" },
    { 0x322B622B, "event6_limo_warps" },
    { 0xC96FC018, "event6_mg_manned" },
    { 0x5095F003, "event6_navigate" },
    { 0x447FBC0A, "event6_no_death_last_stand" },
    { 0x855B9296, "event6_no_death_last_stand_internal" },
    { 0x4FE42555, "event6_open_rocket_gantry" },
    { 0xC7B35C93, "event6_outtro" },
    { 0x6ABBEA34, "event6_outtro_detach_shotgun" },
    { 0xB98643B4, "event6_outtro_effects" },
    { 0x97114E14, "event6_outtro_effects_internal" },
    { 0x18BBFC32, "event6_outtro_enemy" },
    { 0x0054E9E9, "event6_outtro_player" },
    { 0x205983CB, "event6_outtro_player_part2" },
    { 0x8B14DB1E, "event6_outtro_player_warp" },
    { 0x49631A39, "event6_outtro_playerspectate_think" },
    { 0x95741C52, "event6_outtro_sounds" },
    { 0xB2AA47A6, "event6_outtro_start" },
    { 0x6D1D5C80, "event6_outtro_strike" },
    { 0xB320BB19, "event6_outtro_sullivan_in_boat" },
    { 0xC6AB5DA5, "event6_player_outtro" },
    { 0x687458A0, "event6_pontoons_up" },
    { 0x8BCB9DD6, "event6_ptboat_control" },
    { 0xD8B4CF29, "event6_rescueweaver" },
    { 0xCF487DA8, "event6_rescueweaverdemo" },
    { 0x337405EA, "event6_reset_ignoreme" },
    { 0x838495DD, "event6_rocket_clamps" },
    { 0x9B274F6A, "event6_rocket_rumble" },
    { 0x063F5C83, "event6_rocket_takeoff" },
    { 0x657611CE, "event6_russian_dialogue" },
    { 0xEE5DC2FF, "event6_seat_control" },
    { 0x8F6141B9, "event6_spawn_getaway_zeros_0" },
    { 0x695EC750, "event6_spawn_getaway_zeros_1" },
    { 0xDB66368B, "event6_spawn_getaway_zeros_2" },
    { 0xB563BC22, "event6_spawn_getaway_zeros_3" },
    { 0x06541765, "event6_spawn_getaway_zeros_3point5" },
    { 0x276B2B5D, "event6_spawn_getaway_zeros_4" },
    { 0xD9318BB1, "event6_spawner3" },
    { 0x0A41AD66, "event6_start" },
    { 0x0D60E407, "event6_start_allies" },
    { 0xD65F8A93, "event6_stop_laststand" },
    { 0xE531AC7C, "event6_sullivan_outtro" },
    { 0xF9A01582, "event6_sullivan_to_boats" },
    { 0xB140033C, "event6_update_vision" },
    { 0x1AABB8D6, "event6_vision_settings" },
    { 0x9C069A41, "event6_zipline" },
    { 0x2306A1EA, "event7" },
    { 0xFAF6D469, "event7_blocked_off" },
    { 0xBABD5AE3, "event7_dialogue" },
    { 0xC844D00B, "event7_hideoverwall" },
    { 0x9A887B2A, "event7_jump_off_bike_audio" },
    { 0x5DBF2F4E, "event7_jumpto" },
    { 0x2BCB9C16, "event7_main" },
    { 0xFD2814AF, "event7_number_loop_end_timer" },
    { 0x087061C2, "event7_number_loop_start" },
    { 0x671C410F, "event7_on_save_restored" },
    { 0xCC6EF0E9, "event7_russianchopper" },
    { 0xB031D0AE, "event7_sniperengineers" },
    { 0x4BD6DC83, "event7_start" },
    { 0x90CBD164, "event7_weaponsdown" },
    { 0x64FA3DDD, "event8" },
    { 0x33B9DECA, "event8_c4_tutorial_message" },
    { 0x86089F5A, "event8_controlroombunkerbreach" },
    { 0x82E7A016, "event8_controlroombunkerkilleveryone" },
    { 0x7B7AC27E, "event8_destroyrocket" },
    { 0xC9B97D1A, "event8_dialogue" },
    { 0xE1EE758A, "event8_do_reznov_reveal_video" },
    { 0x2A050B32, "event8_get_player_mover" },
    { 0xE18AB7C0, "event8_hudson_own_player" },
    { 0x57D4E16F, "event8_jumpto" },
    { 0xEBF242C8, "event8_prep_reznov_reveal_video" },
    { 0xDC2D5A42, "event8_reznov_flashback" },
    { 0x28FE3BC0, "event8_rocketaftermath" },
    { 0xADE95424, "event8_start" },
    { 0x20EC5FE5, "event8_to_com_room" },
    { 0x37DD1DF7, "event8_triggers" },
    { 0x3EF7C374, "event9" },
    { 0xE6FE5E63, "event9_2" },
    { 0xC0FBE3FA, "event9_3" },
    { 0x10F6BC8A, "event9_glassroomfight" },
    { 0xAC86D370, "event9_jumpto" },
    { 0x4CD17584, "event9_save" },
    { 0xC5A5D454, "event9_scenefromhell" },
    { 0x9EF8081A, "event9_temp_cuba_movie" },
    { 0xC643E34C, "event9_triggers" },
    { 0xDA0C7C06, "event9_triggers_into_tunnel" },
    { 0x79BB12D0, "event9_triggers_nosympathy_trig" },
    { 0x14F19AF8, "event9_triggers_on_fire_trig" },
    { 0xE9207A42, "event_1_amb" },
    { 0xE82A24CA, "event_1_amb_1" },
    { 0xC227AA61, "event_1_amb_2" },
    { 0x3F57C7AE, "event_1_audio_01" },
    { 0x19554D45, "event_1_audio_02" },
    { 0xDF14921B, "event_1_beat_loop" },
    { 0xB9FA2FA3, "event_1_camera_tween" },
    { 0x9D1F4703, "event_1_clean_up" },
    { 0xEA207AE9, "event_1_crowd" },
    { 0x6872D65E, "event_1_crowd_logic" },
    { 0xCCA06E9A, "event_1_delta_camera" },
    { 0xB84E5E98, "event_1_ends" },
    { 0xCBCEEA70, "event_1_finished" },
    { 0xAF1AE4A7, "event_1_grab_baton" },
    { 0xC47BF7B3, "event_1_grab_keys" },
    { 0x4C07E70E, "event_1_guard_death" },
    { 0x5893F838, "event_1_intro" },
    { 0xA8F16911, "event_1_intro_ai_freeze" },
    { 0x1EB81A36, "event_1_intro_freeze" },
    { 0xB551C0F3, "event_1_intro_props_freeze" },
    { 0x4EF052EE, "event_1_knife_tutorial" },
    { 0x926FCB99, "event_1_melee_pressed" },
    { 0x8EEE2280, "event_1_monitor_arena" },
    { 0xD3DE5E8F, "event_1_music" },
    { 0xFC167E13, "event_1_player_can_melee" },
    { 0x07A7A61A, "event_1_r_trigger_pressed" },
    { 0x9E4755E6, "event_1_rumble_shake" },
    { 0x1C4528C8, "event_1_wait_for_melee" },
    { 0x4AFD9AD4, "event_1_wait_for_punch" },
    { 0xDC90E015, "event_2_amb" },
    { 0x96163D1A, "event_2_amb_2" },
    { 0xEF77B54B, "event_2_audio_01" },
    { 0xB17CB4E7, "event_2_dialog" },
    { 0x94B3DDA5, "event_2_ends" },
    { 0xC74C4A3E, "event_2_escape" },
    { 0x1CA2248F, "event_2_guard_attack_player" },
    { 0xB1463237, "event_2_los_delete" },
    { 0xEC0B02C0, "event_2_music" },
    { 0x086D3D7B, "event_2_one_off" },
    { 0x7B5A4A13, "event_2_passenger_stay" },
    { 0x2FA8ACDC, "event_2_prisoner_death" },
    { 0x15235E53, "event_2_prisoner_recovery" },
    { 0x5E07A93F, "event_2_reznov_path" },
    { 0x3D814E0F, "event_2_sergei_intro" },
    { 0x2B63A588, "event_2_sergei_intro_blocker" },
    { 0xB32099C3, "event_2_sergei_intro_blocker_die" },
    { 0x9499465D, "event_2_sergei_intro_player_vo" },
    { 0xFDC18CAA, "event_2_sergei_post_intro" },
    { 0x119D8676, "event_2_strobe_tunnel_fight" },
    { 0x7D294345, "event_2_top_of_tunnel" },
    { 0xC78B6B2F, "event_2_vig_control_box_guy" },
    { 0xB0460914, "event_2_vig_post_sergei" },
    { 0x8CE5FE87, "event_2_vig_pre_sergei_01" },
    { 0x1ADE8F4C, "event_2_vig_pre_sergei_02" },
    { 0x40E109B5, "event_2_vig_pre_sergei_03" },
    { 0xDC8F75F1, "event_2_vig_ready_passengers" },
    { 0x2D5973A7, "event_2b_ends" },
    { 0x7379D82C, "event_3_audio_01" },
    { 0xE5814767, "event_3_audio_02" },
    { 0xC6D27A28, "event_3_bleed" },
    { 0x06854CD1, "event_3_board_and_exit_inclinator" },
    { 0xEBDF2E22, "event_3_drop_axe" },
    { 0xC1CCABBD, "event_3_inclinator" },
    { 0x986D0255, "event_3_inclinator_conversation" },
    { 0x33B1A62C, "event_3_inclinator_light" },
    { 0x87CF416C, "event_3_move_to_door" },
    { 0x3D781E59, "event_3_open_inclinator_door" },
    { 0xFEA65F44, "event_3_pick_up_axe" },
    { 0xE3344B73, "event_3_player_armed" },
    { 0xB5E0B2EA, "event_3_remove_inclinator" },
    { 0xD9ACE016, "event_3_reznov_unlock_door" },
    { 0x10E35B57, "event_3_russians_board" },
    { 0x470B08A2, "event_3_russians_wait" },
    { 0xD8A451F2, "event_3_sergei_board" },
    { 0x5EB8329E, "event_3_shake_player" },
    { 0x8224C1A1, "event_3_vig_exit_room" },
    { 0xA491EFB9, "event_3_vig_skirmish_1" },
    { 0xCA946A22, "event_3_vig_skirmish_2" },
    { 0xFB2E05D3, "event_4_amb" },
    { 0x47AAC651, "event_4_audio_01" },
    { 0xFDB08C46, "event_4_bridge" },
    { 0x4D64C6B6, "event_4_bridge_guards_think" },
    { 0x457EFE23, "event_4_bridge_think" },
    { 0x13C40F9A, "event_4_damage_player" },
    { 0x97C1D773, "event_4_ends" },
    { 0xE8A23791, "event_4_exit" },
    { 0x03CE4F05, "event_4_exit_impacts" },
    { 0x806B5AC4, "event_4_exit_mg" },
    { 0x79C942C4, "event_4_exit_think" },
    { 0xF31B9E1A, "event_4_hanging_bodies" },
    { 0x45E1DC99, "event_4_lamp_pulse" },
    { 0xC0F9EEE6, "event_4_notetrack_impacts" },
    { 0xA6EEB15D, "event_4_panel_1" },
    { 0xCCF12BC6, "event_4_panel_2" },
    { 0x262739D4, "event_4_passenger_exit_inclinator" },
    { 0x9FC5DBC1, "event_4_reznov" },
    { 0xD98204C0, "event_4_reznov_warning" },
    { 0xF0F8035E, "event_4_sergei" },
    { 0x384BDA12, "event_4_vig_kick" },
    { 0xF2E73B58, "event_5_anims" },
    { 0x0270A893, "event_6_anims" },
    { 0xDB8BDE6A, "event_7_anims" },
    { 0x1039FD6D, "event_8_anims" },
    { 0x1F78FE2C, "event_9_anims" },
    { 0xDFCFD076, "event_alias" },
    { 0x88BE852E, "event_atgun_action" },
    { 0x0E041A47, "event_atgun_setup" },
    { 0x3808A614, "event_atgun_start" },
    { 0x38EA6840, "event_atgun_tank" },
    { 0xBDDAB375, "event_atgun_tank_start" },
    { 0x884F796E, "event_atgun_waveleadertrig" },
    { 0x381B8883, "event_attach_glasses_to_tag_weapon_right" },
    { 0xA9FA1C11, "event_attach_pendant_to_woods" },
    { 0xB0CD51F1, "event_awareness" },
    { 0x0056AC20, "event_awareness_handler" },
    { 0xCB4009CE, "event_bridge_action" },
    { 0xA0E1C57E, "event_bridge_mgnest" },
    { 0x976A2667, "event_bridge_setup" },
    { 0xBEF44934, "event_bridge_start" },
    { 0xE7E0A414, "event_btr_diabled_jumpto" },
    { 0x03EDBEA9, "event_btr_rail" },
    { 0x5E0B99FB, "event_btr_rail_jumpto" },
    { 0x50F2D9CB, "event_callback" },
    { 0xFA811D86, "event_carter_hunt_office" },
    { 0xA7F7153C, "event_church_action" },
    { 0x9CB5D3A1, "event_church_goodlos" },
    { 0xFD3F6C86, "event_church_nashornmolotovs" },
    { 0xF1AAE8A1, "event_church_setup" },
    { 0x6EADBD8A, "event_church_start" },
    { 0x00AF27D2, "event_cleanup" },
    { 0x3932A826, "event_clearall" },
    { 0xC93300F8, "event_clearqueuebyref" },
    { 0x4BF99590, "event_convoywalk_action" },
    { 0x3AC8043D, "event_convoywalk_setup" },
    { 0xB0E4542E, "event_convoywalk_start" },
    { 0x39D4EB23, "event_debug" },
    { 0x516D30DB, "event_destroy_copter_done" },
    { 0xA9682260, "event_destroy_helicopter" },
    { 0xC3BD3782, "event_dialog" },
    { 0x667065DF, "event_douse_menendez" },
    { 0x08ED6A36, "event_ended" },
    { 0x7C1B6E99, "event_ent" },
    { 0x905D043B, "event_explore_lab" },
    { 0x1C78CBF2, "event_explosion_index" },
    { 0xE6331388, "event_flag" },
    { 0x3BF83AA3, "event_flags" },
    { 0xAFC7198A, "event_foyer_action" },
    { 0xAEE7556A, "event_foyer_introscene" },
    { 0xECAE3B89, "event_foyer_pacing_action" },
    { 0x55998549, "event_foyer_pacing_start" },
    { 0x6086E99B, "event_foyer_setup" },
    { 0x99789510, "event_foyer_start" },
    { 0x27652BC0, "event_func" },
    { 0x5CA890E9, "event_func_index" },
    { 0xD623A7EB, "event_funcs" },
    { 0xC2553001, "event_functions" },
    { 0x8DE5C2C4, "event_gas_attack" },
    { 0x8A5ED9A0, "event_gas_attack_jumpto" },
    { 0x9F367985, "event_global_setup" },
    { 0x3FFB8A71, "event_heart_beat" },
    { 0x9179FDD8, "event_hide_blood_decals" },
    { 0x1A31D291, "event_hide_bloody_menendez" },
    { 0x1200D4AB, "event_hide_bloody_pendant" },
    { 0xC48EB91F, "event_hide_bloody_woods" },
    { 0x5B18B9A0, "event_hide_cell_phone_a" },
    { 0xCD2028DB, "event_hide_cell_phone_b" },
    { 0x3191E6E0, "event_hide_fish_2" },
    { 0x2324B70B, "event_hide_isi_kneecpd_both" },
    { 0x332FD960, "event_hide_isi_kneecpd_lft" },
    { 0x7978B104, "event_hide_isisoldier" },
    { 0xC7471F18, "event_hide_masonjr_glasses" },
    { 0x19FEDFFB, "event_hide_menendez" },
    { 0xCF8C3F9D, "event_hide_menendez_old" },
    { 0x0464220C, "event_hide_menendez_pendant" },
    { 0x6DD615CD, "event_hide_pendant" },
    { 0x45509201, "event_hide_woods" },
    { 0x864FA4E6, "event_horizon_spot" },
    { 0xA8783F28, "event_hudelem" },
    { 0x5E7AD7F3, "event_hudson_lab" },
    { 0x805288EE, "event_index" },
    { 0x76801A92, "event_info" },
    { 0x220CEFC5, "event_intro_action" },
    { 0xD641CA5A, "event_intro_setup" },
    { 0x9AD5B5E5, "event_intro_start" },
    { 0xB49848F3, "event_iron_lung" },
    { 0x3C6691E4, "event_iterator" },
    { 0x26948A6F, "event_lab_entrance_done" },
    { 0x20A15B20, "event_lab_entrance_jumpto" },
    { 0x5A2A25D9, "event_lights_out1" },
    { 0x802CA042, "event_lights_out2" },
    { 0xA62F1AAB, "event_lights_out3" },
    { 0xCC319514, "event_lights_out4" },
    { 0xF2340F7D, "event_lights_out5" },
    { 0x183689E6, "event_lights_out6" },
    { 0x3E39044F, "event_lights_out7" },
    { 0xFB4F3A5E, "event_listener" },
    { 0x227EE0B0, "event_mason_lab" },
    { 0x5E73EE2B, "event_mason_lab_done" },
    { 0x839AF5AC, "event_mason_lab_jumpto" },
    { 0x1A5B9E90, "event_mason_stealth" },
    { 0x6E1468CB, "event_mason_stealth_done" },
    { 0x2CB0064C, "event_mason_stealth_jumpto" },
    { 0x2573320F, "event_name" },
    { 0xCFA7C593, "event_notesendondeath" },
    { 0xB9197739, "event_notify" },
    { 0x17494ABA, "event_num" },
    { 0x26470359, "event_number" },
    { 0x51FC9C79, "event_obj" },
    { 0x8D8477BB, "event_objective_text" },
    { 0xEC14FE7A, "event_objectives" },
    { 0x49D2F6C2, "event_override" },
    { 0x74078710, "event_override_name" },
    { 0x766D1EC2, "event_override_probability" },
    { 0x0E4DF855, "event_param" },
    { 0xC6A0F0A4, "event_params" },
    { 0x54DE62F0, "event_parliament_action" },
    { 0x1D0F4F6C, "event_parliament_doors_start" },
    { 0xAA5CAF1D, "event_parliament_setup" },
    { 0x336B5B0E, "event_parliament_start" },
    { 0x9D50E41C, "event_play_blood_vfx" },
    { 0x7FE90303, "event_play_cell_phone_a_vfx" },
    { 0x5316E8DB, "event_play_cell_phone_vfx" },
    { 0x96F1246E, "event_play_cig_flick_ash_vfx" },
    { 0xA70877FD, "event_play_cig_smoke_exhale_vfx" },
    { 0x72C5DACB, "event_play_cig_smoke_inhale_vfx" },
    { 0x1E95692F, "event_play_muzzle_flash" },
    { 0x90304A85, "event_playsound" },
    { 0x5FCFC175, "event_plaza_start" },
    { 0x2CA91294, "event_populate" },
    { 0x9DBD74D1, "event_process" },
    { 0x69BE25C3, "event_queue" },
    { 0x2C079CE7, "event_reach_lab" },
    { 0xC83113F5, "event_ref" },
    { 0x7EBA142A, "event_reich_start" },
    { 0x22B6BA2D, "event_reset_lights" },
    { 0xCF5111B1, "event_roof_action" },
    { 0x73E60801, "event_roof_ai_flagbearer" },
    { 0xB391BD18, "event_roof_flagbearerdeath" },
    { 0xEA42DF5D, "event_roof_flagplant_start" },
    { 0x574C3C12, "event_roof_midpoint_start" },
    { 0xCCFA415E, "event_roof_setup" },
    { 0xEC729F11, "event_roof_start" },
    { 0xC01E44DD, "event_run_to_carter" },
    { 0x022BB5DE, "event_security_room" },
    { 0xB104FCC2, "event_security_room_jumpto" },
    { 0x23043CD7, "event_setup_firehorse" },
    { 0x5424FCAF, "event_setup_wave2_bp3" },
    { 0xB1435BE5, "event_show_all_blood_decals" },
    { 0x7B1481F5, "event_show_blood_decal_00" },
    { 0x5512078C, "event_show_blood_decal_01" },
    { 0xC71976C7, "event_show_blood_decal_02" },
    { 0xA116FC5E, "event_show_blood_decal_03" },
    { 0xFA6302DA, "event_show_bloody_menendez" },
    { 0x8F1C6DEA, "event_show_bloody_pendant" },
    { 0xEAFB68AE, "event_show_bloody_woods" },
    { 0x0DC29C46, "event_show_isi_kneecpd_both" },
    { 0x51953C5B, "event_show_isi_kneecpd_lft" },
    { 0x18631A2D, "event_show_isisoldier" },
    { 0x8E0EC29E, "event_show_menendez" },
    { 0x489322A6, "event_show_pendant" },
    { 0x2C49CBA2, "event_show_woods" },
    { 0xE841EB15, "event_size" },
    { 0x93013F94, "event_start_door_open" },
    { 0x0E201E11, "event_state" },
    { 0x59D2F336, "event_steiners_office" },
    { 0xBDF4D52A, "event_steiners_office_jumpto" },
    { 0x22CE8371, "event_stop_cell_phone_vfx" },
    { 0xB6E67C89, "event_stop_door" },
    { 0xF9FE719C, "event_street_battle" },
    { 0x28B32B0C, "event_sweep_action1" },
    { 0x9ABA9A47, "event_sweep_action2" },
    { 0x74B81FDE, "event_sweep_action3" },
    { 0x17100825, "event_sweep_barricade1_fc_failsafe" },
    { 0x757B6988, "event_sweep_setup" },
    { 0x812D1857, "event_sweep_start" },
    { 0xDE4ECA20, "event_sweep_start_barricade1" },
    { 0x7AE0F590, "event_sweep_start_sweep2" },
    { 0x3996217F, "event_text" },
    { 0x10B035B6, "event_thread" },
    { 0xF3AB4465, "event_timer" },
    { 0xB6BA7FDA, "event_trigger" },
    { 0xB92067D0, "event_tv_model_swap" },
    { 0x241AC5B2, "event_type" },
    { 0x342B254C, "event_type_callback" },
    { 0x309BAA75, "event_type_dialog" },
    { 0x6058A997, "event_type_fx" },
    { 0x7CB22654, "event_type_multi" },
    { 0xF4238852, "event_type_music" },
    { 0x45C68C12, "event_type_sfx" },
    { 0x01FB163D, "event_types" },
    { 0x344D15AE, "event_village_walk" },
    { 0xE0F6D9AE, "event_wave_action" },
    { 0x6C9143C7, "event_wave_setup" },
    { 0x9695CF94, "event_wave_start" },
    { 0xBAE3DD1A, "event_weight" },
    { 0xDAB428B5, "eventaction" },
    { 0x27AC6674, "eventactionminwait" },
    { 0x3A9869CA, "eventarray" },
    { 0xA1CF515C, "eventdeathreact_v1" },
    { 0xBFE0EE23, "eventdeathreact_v1_ai0" },
    { 0x99DE73BA, "eventdeathreact_v1_ai1" },
    { 0x73DBF951, "eventdeathreact_v1_ai2" },
    { 0x6F33CA91, "eventdeathreact_v1_self" },
    { 0x13D6C097, "eventdeathreact_v2" },
    { 0x03B5DBC4, "eventdeathreact_v2_ai0" },
    { 0x29B8562D, "eventdeathreact_v2_ai1" },
    { 0x4FBAD096, "eventdeathreact_v2_ai2" },
    { 0x138BB620, "eventdeathreact_v2_self" },
    { 0xEDD4462E, "eventdeathreact_v3" },
    { 0xABB24EE1, "eventdeathreact_v3_ai0" },
    { 0x85AFD478, "eventdeathreact_v3_ai1" },
    { 0xF7B743B3, "eventdeathreact_v3_ai2" },
    { 0xE237DFA3, "eventdeathreact_v3_self" },
    { 0x2B1A563F, "eventduration" },
    { 0x104AF6B3, "evente1c_area_blocker" },
    { 0x7E1B9FA7, "eventendreact" },
    { 0x7B511450, "eventexploreact_v1" },
    { 0x25E0D90D, "eventfunc" },
    { 0x87BB8120, "eventhough" },
    { 0x743CD749, "eventindex" },
    { 0x94FE952F, "eventkeys" },
    { 0x9987CCBF, "eventmovereact_v1" },
    { 0x97BB242A, "eventname" },
    { 0xF8F13143, "eventpriority" },
    { 0x5DD26946, "eventreaction" },
    { 0x0C71D09D, "eventreactionend" },
    { 0xAC4A2A0D, "eventreactionent" },
    { 0x1BD1CC59, "eventreactionnearbyai" },
    { 0xE2509405, "eventreactionparticipant" },
    { 0x7B400496, "eventreactionspot" },
    { 0xA81C95B9, "eventreactiontarget" },
    { 0x710AD1B9, "eventreactiontime" },
    { 0xC0B51E7E, "eventreceived" },
    { 0x3A71F14E, "events" },
    { 0x5EA0E657, "events_dialogchannellock" },
    { 0x76C9513F, "events_dlgent" },
    { 0x67A534EA, "events_main" },
    { 0x46299E9F, "eventsperminute" },
    { 0x01F8B58A, "eventstate" },
    { 0x6FA12575, "eventstatus" },
    { 0x0BE4C744, "eventtime" },
    { 0xC2BC51FF, "eventtype" },
    { 0xC8C763EA, "eventtypeminwait" },
    { 0xBE9109E2, "eventually" },
    { 0x84DAB7BD, "ever" },
    { 0xA4D659B6, "ever_been_on_the_moon" },
    { 0x1AA7CA25, "everexisted" },
    { 0x42BBDEBA, "everexistedcount" },
    { 0x76A85E67, "everone" },
    { 0xFEEA28BA, "evertime" },
    { 0xAA72B006, "every" },
    { 0x97F61872, "everybody" },
    { 0xE82F0FAA, "everybodydone" },
    { 0x3F19822E, "everyone" },
    { 0x0ADE03EE, "everyone_anim_reach" },
    { 0x86EEB8D9, "everyone_anim_single" },
    { 0xEA987E91, "everyone_finished_anim" },
    { 0x7D845FD0, "everyone_in_place" },
    { 0xA0BD6472, "everyone_in_position" },
    { 0x2BBBF9B5, "everyone_single_solo" },
    { 0x8CAD42D3, "everyone_walk_to_trigger" },
    { 0x7B692416, "everyonehearseveryone" },
    { 0x3CAE8051, "everyones" },
    { 0x20DDEC78, "everythign" },
    { 0xCA3EDDD6, "everything" },
    { 0xEB064379, "everytime" },
    { 0xD19994FA, "everyvehicle" },
    { 0x05668DCB, "everywhere" },
    { 0x8C9F37F1, "evevator" },
    { 0xCDE7A9A6, "eveyone" },
    { 0x12C901B3, "eveywhere" },
    { 0x89D5A592, "evictim" },
    { 0x0201BE1E, "evidence" },
    { 0xC566C127, "evil" },
    { 0x8353BC7D, "evm" },
    { 0x62923D80, "evolume" },
    { 0x2D3D6ECC, "evt" },
    { 0xBAA7E309, "evt_1_civs_loud" },
    { 0x20F004AF, "evt_1_screams" },
    { 0xC4F68E68, "evt_1_torture" },
    { 0x4AD37599, "evt_blizzard_gust" },
    { 0x22AA8F1C, "evt_c4_det" },
    { 0x56449443, "evt_carpenter_end" },
    { 0x3419DF0E, "evt_dragovich_drown_loop" },
    { 0x1CC34FB1, "evt_jet_flyby2" },
    { 0xAF3E5437, "evt_numbers" },
    { 0xD5EACC76, "ex" },
    { 0xCEDA355A, "exact" },
    { 0x47EC7C47, "exactly" },
    { 0x66CF526D, "exagerate" },
    { 0x6BDB1418, "exagerating" },
    { 0x4710E249, "exahustfx" },
    { 0x404AF55D, "examlpe" },
    { 0x91B2D975, "example" },
    { 0x0BB17F56, "example1" },
    { 0xE5AF04ED, "example2" },
    { 0xBFAC8A84, "example3" },
    { 0x99AA101B, "example4" },
    { 0x3F0DF044, "examples" },
    { 0x867FB27C, "excavator" },
    { 0xA2E9C522, "excavator_console" },
    { 0x469CA526, "excecutes" },
    { 0x2D5A5CD9, "exceed" },
    { 0x174E5F06, "exceeded" },
    { 0xA9B83D28, "exceededmaxqrdrones" },
    { 0x49ADE279, "exceededtime" },
    { 0xC7550E6F, "exceeding" },
    { 0xEB727990, "exceeds" },
    { 0x3D81FD2D, "excellent" },
    { 0x85D86800, "excent" },
    { 0x64954E42, "except" },
    { 0xE5EB6328, "exception" },
    { 0x97CDA1C9, "exception_exposed" },
    { 0x6C050394, "exception_exposed_mg42_portable" },
    { 0x865B1A88, "exception_exposed_panzer_guy" },
    { 0x0776ED9F, "exception_stop" },
    { 0x3FAF557A, "exceptionfunc" },
    { 0xEBBC2DC3, "exceptions" },
    { 0xD1F2298D, "excepts" },
    { 0x0985F980, "excess" },
    { 0x73A32085, "excess_ammo" },
    { 0x951E2BB2, "excessive" },
    { 0xA20F9434, "excessively_bloody_death" },
    { 0xA612F352, "exchange" },
    { 0xCA4E4DA3, "exchange_baddie_flags_on_death" },
    { 0xE92D6949, "exchange_baddie_main_think" },
    { 0x587C4618, "exchange_baddie_runs_to_car" },
    { 0x34BB7CEB, "exchange_baddies" },
    { 0xB5EACA42, "exchange_barrett_trigger" },
    { 0xF15C740B, "exchange_block_view_on_attack" },
    { 0xED239DA2, "exchange_bored_idle" },
    { 0x3E8897B0, "exchange_brick_drop" },
    { 0x6120F97E, "exchange_case_velcalc" },
    { 0x8FBFF3A9, "exchange_claymore" },
    { 0x07AFDBE0, "exchange_dof" },
    { 0xAE73948F, "exchange_flag" },
    { 0xBFDDA204, "exchange_flag_relinks" },
    { 0x6F3BCDFE, "exchange_flag_rotates" },
    { 0x61FF8848, "exchange_followup_heli_shoots_hotel" },
    { 0xB64D53B4, "exchange_get_safe_shot" },
    { 0x936C8463, "exchange_guards" },
    { 0x3BCC57D0, "exchange_guy_dies" },
    { 0x80348A59, "exchange_heli" },
    { 0xFAB90A4A, "exchange_heli_death_spiral" },
    { 0x29D2A6B6, "exchange_heli_pilot" },
    { 0xF0676514, "exchange_heli_preps_missiles" },
    { 0x8F153054, "exchange_heli_second_wave" },
    { 0xEB12728F, "exchange_heli_shoots_hotel" },
    { 0x32F5C0DC, "exchange_heli_think" },
    { 0x70E39297, "exchange_heli_tracking" },
    { 0x946F06C8, "exchange_impact_alert" },
    { 0x0B04BDC2, "exchange_mission_failure" },
    { 0x41CA9788, "exchange_player_fires" },
    { 0xE5ADF890, "exchange_ready_to_run" },
    { 0x453FDB7C, "exchange_rider_gets_out" },
    { 0x349D59F2, "exchange_riders" },
    { 0xEFB4B564, "exchange_scale_dof_while_on_turret" },
    { 0x076C4234, "exchange_second_heli" },
    { 0x98E58657, "exchange_sniper_windmod" },
    { 0x02352646, "exchange_sort_by_handler" },
    { 0xF59697B5, "exchange_trace_converter" },
    { 0x9FA617BF, "exchange_turret" },
    { 0x88E7D654, "exchange_turret_org" },
    { 0xE1F16980, "exchange_turret_traces" },
    { 0x990DEA03, "exchange_uaz" },
    { 0x441D3594, "exchange_uaz_preps_for_escape" },
    { 0x5204F89C, "exchange_uaz_that_backs_up" },
    { 0xA63B7CF4, "exchange_unlink" },
    { 0x2DC2093C, "exchange_vehicle_clip" },
    { 0x5675B97C, "exchange_vehicle_waits_for_passengers" },
    { 0x1445198A, "exchange_vehicles_flee_conflict" },
    { 0x6846B2D1, "exchange_wait_until_other_base_uazs_go" },
    { 0x14ADEDF6, "exchange_wait_until_other_spawned_uazs_go" },
    { 0x3EDFB6D1, "exchange_wait_until_other_uazs_go" },
    { 0x803749E3, "exchange_waittill_time_to_go_to_car" },
    { 0x41DC42C8, "exchange_wind_flag" },
    { 0xFB6E1676, "exchange_wind_flunctuates" },
    { 0xEC00CD71, "exchange_wind_generator" },
    { 0x7CFB3426, "exchange_zak_and_guards_jab_it_up" },
    { 0xA67F6B6E, "exchange_zaks_car_door" },
    { 0xA51CC8EE, "exchanger_surprise_time" },
    { 0xBD53B88D, "excited" },
    { 0x667F1EB0, "excitedly" },
    { 0x804A19B6, "exciting" },
    { 0xF20E98C7, "excl" },
    { 0xD010FBB9, "exclude" },
    { 0x4F7194AF, "exclude_cleanup_adding_to_total" },
    { 0x8AC75273, "exclude_distance_cleanup_adding_to_total" },
    { 0x84270C91, "exclude_item" },
    { 0x1CB4153F, "excluded" },
    { 0x2A46F61B, "excluded_guy" },
    { 0x43BF5F75, "excluded_player" },
    { 0xF147016D, "excludedai" },
    { 0x1E1BF5C6, "excludedir" },
    { 0xC1D36C97, "excludeflag" },
    { 0x00A29E4E, "excludefromobjective" },
    { 0x0809A051, "excludelist" },
    { 0xA5280A67, "excludeme" },
    { 0x98CCDD59, "excluder" },
    { 0x90B2C310, "excluders" },
    { 0x72CA62F0, "excludes" },
    { 0xCE78AD77, "excludeself" },
    { 0x6C0E4FAC, "excluding" },
    { 0xBE426D83, "exclusion" },
    { 0xB4D7FE41, "exclusion_timer" },
    { 0xFA037545, "exclusionindex" },
    { 0x0B1DEBF2, "exclusions" },
    { 0xC0D5DD97, "exclusive" },
    { 0x8A03CEFA, "exclusively" },
    { 0x7AA625D7, "excruciating" },
    { 0xA0B07E76, "excuse" },
    { 0xC2F31606, "excused" },
    { 0x5B36B769, "excuted" },
    { 0xB3BE5A6F, "exe" },
    { 0x49FA2446, "exec" },
    { 0xDC7FA98F, "exec_func" },
    { 0xA9842591, "exec_post_system" },
    { 0xE2E3F0AC, "exec_pre_system" },
    { 0x5E0B5C74, "execcarexit" },
    { 0x2F40DE54, "execdevgui" },
    { 0x44743666, "execdialog" },
    { 0x56498C32, "execdrive" },
    { 0xB132468B, "execending" },
    { 0xF5CD8BC4, "execintro" },
    { 0x8F7002A0, "execure" },
    { 0x7053D69D, "executable" },
    { 0xA008F7DC, "executables" },
    { 0x461BA226, "execute" },
    { 0x7E15F513, "execute_ai" },
    { 0x20F4D167, "execute_ai_solo" },
    { 0x6B6FE792, "execute_hud_elem" },
    { 0xCB42C140, "execute_mode" },
    { 0x3EB1BA3E, "execute_target" },
    { 0xCC22B81A, "execute_the_breach" },
    { 0x03E2D9CB, "execute_trigger" },
    { 0x7086DA57, "execute_weap_beacon_rumble" },
    { 0x5C7812D6, "executed" },
    { 0x0DABF208, "executed_civs" },
    { 0x1E6F1CC5, "executedat" },
    { 0xC21ADB3A, "executegametypeeventrule" },
    { 0x16A60275, "executeonce" },
    { 0xAECFCA8B, "executeordermovewithai" },
    { 0x31FE8CDA, "executeordermovewithplayer" },
    { 0xD8E0B618, "executeordersquadattack" },
    { 0x6D586BCE, "executeordersquadpatrol" },
    { 0xEA1BB317, "executepostroundevents" },
    { 0xFE935559, "executes" },
    { 0x9BBC6F67, "executesquadmanaged" },
    { 0x5C5284B0, "executesquadmoveto" },
    { 0x9147D3DF, "executing" },
    { 0x4235F665, "execution" },
    { 0xABDBE69E, "execution_abort" },
    { 0xB4B4F5F2, "execution_abort_for_progression" },
    { 0x7043E58A, "execution_about_done" },
    { 0x6C6EEEBA, "execution_allies_german_safe_strat" },
    { 0x5B6D11CD, "execution_allies_strat" },
    { 0x4A4746CD, "execution_attach_knife" },
    { 0x48087278, "execution_axis_strat" },
    { 0x633C0E02, "execution_blood_fx1" },
    { 0x3D399399, "execution_blood_fx2" },
    { 0x17371930, "execution_blood_fx3" },
    { 0x2148720F, "execution_blood_fx4" },
    { 0xFB45F7A6, "execution_blood_fx5" },
    { 0xD5437D3D, "execution_blood_fx6" },
    { 0xABC9C7EE, "execution_corpse_setup" },
    { 0xEA11BE88, "execution_done" },
    { 0xCF22A7F5, "execution_drop_knife" },
    { 0x30CC4857, "execution_end" },
    { 0x77DAC9D4, "execution_enemies_chase_after_player" },
    { 0x4C2E6A0C, "execution_enemy" },
    { 0xCD4232B1, "execution_escape" },
    { 0xBB57C6BE, "execution_gunshot" },
    { 0x668D7A75, "execution_half_shield" },
    { 0x37BE92FE, "execution_interrupted" },
    { 0xD46C1CF4, "execution_is_ready" },
    { 0xD166E9BA, "execution_logic" },
    { 0x239ED8A4, "execution_non_mature_objective" },
    { 0x8579E8E6, "execution_over" },
    { 0xF8D97D63, "execution_rage" },
    { 0xC597A6B0, "execution_scene" },
    { 0x61585A3C, "execution_start" },
    { 0xCABCF5AA, "execution_start_timer" },
    { 0xCE34E952, "execution_stop_by_firing" },
    { 0x9FFA23BA, "execution_stop_by_spotted" },
    { 0xAF72D106, "execution_stop_timer_for_axe_scene" },
    { 0xB91E2CF6, "execution_throat" },
    { 0xBD8F330E, "execution_vignette" },
    { 0x57723CBC, "execution_vignette_interrupt_end_watch" },
    { 0xCD725D52, "execution_vignette_interrupt_watch" },
    { 0xDAD33379, "execution_watcher_stoploop" },
    { 0xEFE4F5A9, "executiondone" },
    { 0x3FE1E4B4, "executioner" },
    { 0x322E6EAD, "executioner_animname" },
    { 0xE0826D19, "executioner_spawner" },
    { 0x158CE8A7, "executioners" },
    { 0xFE9A1F2F, "executionnum" },
    { 0x4E626574, "executions" },
    { 0xEFCE914E, "executionsuccess" },
    { 0xD9D0D7DC, "execvehiclestealthdetection" },
    { 0x15F8D47C, "exempt" },
    { 0x6DC4AF6B, "exercise" },
    { 0x13110899, "exert" },
    { 0x5FD352BB, "exert_id" },
    { 0x64778638, "exert_sounds" },
    { 0x9AA4A4FF, "exert_timer" },
    { 0x5DB5997B, "exertbuffer" },
    { 0x70C33F75, "exertion" },
    { 0x4B400D50, "exerts" },
    { 0xE9D27DB6, "exes" },
    { 0xEE01D71B, "exeuctioners" },
    { 0xD883479B, "exfil" },
    { 0xCC10E7F6, "exhale" },
    { 0xCF958168, "exhale_smoke" },
    { 0x2B872924, "exhalefx" },
    { 0x6D851FE9, "exhales" },
    { 0x8B7368EF, "exhaling" },
    { 0x60CD8BED, "exhaust" },
    { 0xE3748B1A, "exhaust_fx" },
    { 0xF95629B9, "exhaust_id_left" },
    { 0xC2794CE4, "exhaust_id_right" },
    { 0x44B79AB8, "exhaust_tag_left" },
    { 0xE464DAC7, "exhaust_tag_right" },
    { 0x020F875A, "exhaustdelay" },
    { 0x44DAC89A, "exhausted" },
    { 0x8E611F5B, "exhaustfx" },
    { 0x6C1D5136, "exhaustfxname" },
    { 0xB781AFBE, "exhaustfxtag1" },
    { 0x917F3555, "exhaustfxtag2" },
    { 0x2FE955AA, "exhaustleftfxhandle" },
    { 0x9273FA81, "exhaustrightfxhandle" },
    { 0xC088AFAE, "exhaustrightfxhandlee" },
    { 0x592FD9D0, "exhibit" },
    { 0x4B69BA51, "exigint" },
    { 0x17B57CF2, "exindex" },
    { 0x229A7427, "exisiting" },
    { 0x6A70A652, "exist" },
    { 0xE236A6AB, "existance" },
    { 0x276F8BCD, "existant" },
    { 0x47599D65, "existed" },
    { 0xE95FCF5F, "existence" },
    { 0x05C84F29, "existent" },
    { 0xBFF1D65E, "existing" },
    { 0x116C13B3, "existing_enemies" },
    { 0xF31467E9, "existingchair" },
    { 0x946DAF0E, "existingequipment" },
    { 0x34A59AFA, "existinggadget" },
    { 0xDBCA4C5D, "exists" },
    { 0x9862A17D, "exit" },
    { 0xCCA52BA7, "exit_align" },
    { 0x817A456F, "exit_anim" },
    { 0x0433D1EB, "exit_arena_struct" },
    { 0x2D2D80FE, "exit_b_tunnels" },
    { 0xEAB7E5B0, "exit_back_l" },
    { 0x9EB2F0DE, "exit_back_r" },
    { 0x1564070A, "exit_boat" },
    { 0x383D59D4, "exit_breach_pmcs_dialog" },
    { 0x5AE6C830, "exit_bunker_allies" },
    { 0xABE7823C, "exit_bunker_dialogue" },
    { 0x44E28EB9, "exit_bus_dist" },
    { 0xF9F1778C, "exit_church_dialog" },
    { 0x8CBFEFE3, "exit_clean_room" },
    { 0x1A03BDA4, "exit_cleanup" },
    { 0x7F5886B7, "exit_club_anims" },
    { 0x0426A71E, "exit_club_clean_up" },
    { 0x1359DD55, "exit_club_cleanup" },
    { 0x5AB91FF3, "exit_club_deathposes" },
    { 0x8B75160F, "exit_club_dialog" },
    { 0x1F9D358F, "exit_club_objectives" },
    { 0x107A0383, "exit_container_area" },
    { 0xA02877D1, "exit_courtyard" },
    { 0x28E44836, "exit_death" },
    { 0xF9306460, "exit_dist" },
    { 0x6EE144A0, "exit_door" },
    { 0xB356760B, "exit_door_col" },
    { 0xBD77767E, "exit_driver_anim" },
    { 0x6A2501BD, "exit_early" },
    { 0x79B8DA23, "exit_enabled" },
    { 0x09CE3B46, "exit_ents" },
    { 0x29B918B1, "exit_event1" },
    { 0x9FFC0086, "exit_f35" },
    { 0xFF2B89D2, "exit_func" },
    { 0xE0934AFF, "exit_garage" },
    { 0x10BA567E, "exit_gate_nag" },
    { 0xBDF1E161, "exit_gr_manual_looping_rumble" },
    { 0x388494F1, "exit_ground" },
    { 0x28AD6237, "exit_heli_magic_rpgs" },
    { 0x2B44D3D7, "exit_high_loop_anim" },
    { 0x93E9F020, "exit_hud_prompt" },
    { 0x70FB8846, "exit_hut_dialog" },
    { 0x11458A22, "exit_level" },
    { 0x954CD233, "exit_level_func" },
    { 0x6B86D432, "exit_loc" },
    { 0x63B86466, "exit_low" },
    { 0x11CA1752, "exit_mac_v" },
    { 0x4B25F41D, "exit_macv" },
    { 0xE550D525, "exit_map_room_scene" },
    { 0x05878E55, "exit_menu" },
    { 0xFEB84A05, "exit_moonpool" },
    { 0xE87CD5FC, "exit_news_room_door" },
    { 0x2271F594, "exit_node" },
    { 0x98C93808, "exit_open" },
    { 0x53EEFEB6, "exit_origin" },
    { 0x9D2F19DC, "exit_out" },
    { 0xF88CA2AE, "exit_passenger2_anim" },
    { 0xC069F510, "exit_passenger_anim" },
    { 0x9A96BC95, "exit_path" },
    { 0xFB615C36, "exit_plane" },
    { 0x5764525D, "exit_points" },
    { 0x8F780822, "exit_portal_fx_spot" },
    { 0x0AD4D800, "exit_positions" },
    { 0xD0EE6E5F, "exit_run_vo" },
    { 0x1E4D42AE, "exit_scene_menu" },
    { 0xC95B9AA1, "exit_sniper" },
    { 0xD3370EE2, "exit_spawn_point" },
    { 0x9F2CD182, "exit_speech" },
    { 0xCC3F3F6A, "exit_stage" },
    { 0x15345222, "exit_stage_1" },
    { 0xEF31D7B9, "exit_stage_2" },
    { 0x61550980, "exit_stance" },
    { 0x340A04CB, "exit_struct" },
    { 0x4BF89A15, "exit_taken" },
    { 0x4B3D32D6, "exit_taken_fadeout" },
    { 0xCB7A053E, "exit_tent_dust" },
    { 0x67B2414B, "exit_time" },
    { 0x99DBA289, "exit_to_weaver_building_fail_trig" },
    { 0xD940E508, "exit_train_pathing" },
    { 0x63742464, "exit_train_pathing_assign" },
    { 0xAF1AB309, "exit_train_pathing_num" },
    { 0xB879F8BE, "exit_trig" },
    { 0x43605624, "exit_trigger" },
    { 0x46876357, "exit_triggers" },
    { 0x77633854, "exit_u_cut_spawners" },
    { 0x04F64B70, "exit_variable" },
    { 0x133288A0, "exit_vehicle" },
    { 0x30486E13, "exit_wallrun" },
    { 0x35DD3328, "exit_war_room" },
    { 0xB62BE823, "exit_wave" },
    { 0x1A860EA7, "exit_zipline" },
    { 0x5D14E736, "exitaligntimes" },
    { 0xB27A967D, "exitangles" },
    { 0x54CC02C2, "exitanim" },
    { 0x33B2B835, "exitanimref" },
    { 0x55339F81, "exitblackscreentime" },
    { 0x48951DFB, "exitcarwaiter" },
    { 0x770573AA, "exitdir" },
    { 0xB908AB6C, "exitduprenderbundle" },
    { 0x1BC0E62A, "exited" },
    { 0x7AC7D963, "exited_vehicle" },
    { 0xB024A368, "exitendnode" },
    { 0xD26B2BF8, "exitgate" },
    { 0x49D694FF, "exitgroundanim" },
    { 0x25EC6E61, "exitgrounddeathanim" },
    { 0x2F78B39B, "exitheliwaiter" },
    { 0x84A0B07E, "exithighanim" },
    { 0xB561966A, "exithighdeathanim" },
    { 0x242D8005, "exithighlandanim" },
    { 0x629D9EF3, "exithighlanddeathanim" },
    { 0xA529A064, "exithighloopanim" },
    { 0x3649B95C, "exithighloopdeathanim" },
    { 0x979F03EB, "exiting" },
    { 0x99671CFA, "exiting_vehicle" },
    { 0x97EF630A, "exiting_window" },
    { 0x4461020C, "exitingcover" },
    { 0x7D3CAC7D, "exitlevel" },
    { 0x60CF8622, "exitlowanim" },
    { 0x24C6BF4E, "exitlowdeathanim" },
    { 0xE5CD855D, "exitnode" },
    { 0xEC239D0D, "exitnode_str" },
    { 0xB9EC2773, "exitorigin" },
    { 0x31E2C0E5, "exitpoint" },
    { 0x5CD8F0BD, "exitpos" },
    { 0x51F910FD, "exitpostfxbundle" },
    { 0x90F4AB85, "exitprone" },
    { 0x9159A9BA, "exitpronewrapper" },
    { 0xBDD91DB6, "exitpronewrapperproc" },
    { 0x8282A01E, "exitratio" },
    { 0x2603E821, "exitreason" },
    { 0x62816D75, "exitrequestedbyowner" },
    { 0x0EB3BC3C, "exits" },
    { 0xD97CB0A1, "exitstage" },
    { 0xC3CECB77, "exitstartnode" },
    { 0x8DEA54EC, "exitstarttime" },
    { 0x6D1EE25F, "exittag" },
    { 0xAE33A1A7, "exittanktrigger" },
    { 0xB5DED67A, "exittime" },
    { 0x533483B5, "exittype" },
    { 0xE2C71564, "exitvector" },
    { 0xF572D3FE, "exityaw" },
    { 0x70B880C2, "exloder_166" },
    { 0x1C0460F3, "exloder_242" },
    { 0xF601E68A, "exloder_243" },
    { 0x3AF3116F, "exloder_750" },
    { 0xDFE12C75, "exloder_88" },
    { 0xA16FA88D, "exlosivedamage" },
    { 0xC2899B62, "exlposion" },
    { 0x97216CC9, "exo_breakdown" },
    { 0x958A4FD2, "exp" },
    { 0xB3F18C38, "exp1_origin" },
    { 0x15379DFA, "exp1_palm" },
    { 0x8E8F0C34, "exp2" },
    { 0x2C8B2551, "exp2_origin" },
    { 0x761DD716, "exp3_origin" },
    { 0x51770BE0, "exp3_palm" },
    { 0x5C12435E, "exp_chamber1" },
    { 0x360FC8F5, "exp_chamber2" },
    { 0x100D4E8C, "exp_chamber3" },
    { 0xD1879B54, "exp_chamber3_5" },
    { 0x5E060B04, "exp_control" },
    { 0xAC500F0F, "exp_divetobase" },
    { 0x43A14888, "exp_ent" },
    { 0xF4C8566F, "exp_enter_base" },
    { 0xC37B2954, "exp_escape" },
    { 0x2CF279E2, "exp_fade_overlay" },
    { 0x916E9003, "exp_flood" },
    { 0x3B75AF15, "exp_high" },
    { 0xD5209271, "exp_hit_rattle" },
    { 0x16C3D8A6, "exp_key" },
    { 0xD92E97A9, "exp_ladder" },
    { 0x60A21601, "exp_low" },
    { 0xCDE6DEA0, "exp_name" },
    { 0xA22F2BB5, "exp_org" },
    { 0x34711F91, "exp_pos" },
    { 0x19892A8A, "exp_pos1" },
    { 0xF386B021, "exp_pos2" },
    { 0xCD8435B8, "exp_pos3" },
    { 0xD7958E97, "exp_pos4" },
    { 0x7BA4D9CD, "exp_torp1" },
    { 0x62A05ADD, "expand" },
    { 0x3CC3F463, "expand_goalradius" },
    { 0x3A590364, "expand_goalradius_ongoal" },
    { 0xEB6B8895, "expand_maxs" },
    { 0x6EBD6237, "expand_mins" },
    { 0xF458AA8A, "expanded" },
    { 0x873741CB, "expanding" },
    { 0x16043C34, "expandmaxs" },
    { 0x2DBFC460, "expandmenu" },
    { 0xD60982EA, "expandmins" },
    { 0x4D3FF41C, "expands" },
    { 0x0B018C34, "expansive" },
    { 0x5C97AA2A, "expect" },
    { 0x02B0A52C, "expectations" },
    { 0x562415BD, "expected" },
    { 0xFB2FC8A8, "expected_enemies" },
    { 0xA78D7673, "expected_friends" },
    { 0x985B5C73, "expected_percent" },
    { 0xA3168A32, "expectedplayernum" },
    { 0x406A61C4, "expectedreaction" },
    { 0x8562C506, "expecting" },
    { 0xE5F824E5, "expects" },
    { 0x589A5FE5, "expedient" },
    { 0x3702D797, "expedite" },
    { 0x9467951F, "expenable" },
    { 0x3D35B666, "expended" },
    { 0x0A183C70, "expensive" },
    { 0x21F5B4D5, "experience" },
    { 0x37AEAE24, "experiences" },
    { 0xA6816CE7, "experiments" },
    { 0x79F2F916, "expertise" },
    { 0xC6025161, "expid" },
    { 0xB2397BF2, "expiration" },
    { 0xA2A8CF58, "expire" },
    { 0x3F79040C, "expired" },
    { 0x98391050, "expirednote" },
    { 0x799E3033, "expires" },
    { 0xD310CD93, "expiretime" },
    { 0x9314DE5A, "expl" },
    { 0xB04A7912, "explain" },
    { 0xBC16261E, "explaining" },
    { 0x9073DC1D, "explains" },
    { 0xF59DCF06, "explanation" },
    { 0xA7E15FB9, "explanations" },
    { 0x93978DD0, "explanatory" },
    { 0x062511C5, "expland" },
    { 0x4706C168, "explanitory" },
    { 0x3E25332D, "explicit" },
    { 0xEC1D2AB7, "explicitely" },
    { 0x00661750, "explicitly" },
    { 0xB4CBE8F9, "explo" },
    { 0x7B93C158, "explo_metal_rand_done" },
    { 0xE1432D9A, "explo_origin" },
    { 0xD402E771, "explo_sound" },
    { 0x7C6643EF, "explodable" },
    { 0x5B68118A, "explodable_bagofbarrels_burn" },
    { 0xCD9A97D8, "explodable_bagofbarrels_explode" },
    { 0xFC187893, "explodable_bagofbarrels_think" },
    { 0x6B0D580D, "explodable_bagofcrates_burn" },
    { 0x48B61771, "explodable_bagofcrates_explode" },
    { 0xBA6E1F7E, "explodable_bagofcrates_think" },
    { 0x7A7F26E6, "explodable_barrel_burn" },
    { 0xC19689F4, "explodable_barrel_explode" },
    { 0x5CBC13A7, "explodable_barrel_think" },
    { 0xB450C5B3, "explodable_liferaft_burn" },
    { 0x34499BBB, "explodable_liferaft_explode" },
    { 0x59A5116C, "explodable_liferaft_think" },
    { 0x126EA6DE, "explodable_oiltank_burn" },
    { 0x17B230FC, "explodable_oiltank_explode" },
    { 0x7F23317A, "explodable_oiltank_small_burn" },
    { 0x092D8268, "explodable_oiltank_small_explode" },
    { 0xA47DDD43, "explodable_oiltank_small_think" },
    { 0xE565323F, "explodable_oiltank_think" },
    { 0xE980042E, "explodable_tarpcrate_burn" },
    { 0xAB30D6EC, "explodable_tarpcrate_explode" },
    { 0xF1FCB5CF, "explodable_tarpcrate_think" },
    { 0x1142C720, "explodable_volume" },
    { 0xF9E3A003, "explodable_volume_ent_think" },
    { 0x3511E709, "explodable_volume_think" },
    { 0x4A271236, "explodables" },
    { 0x3C655080, "explode" },
    { 0xF8767953, "explode_0_time" },
    { 0xC31006D8, "explode_1_time" },
    { 0x40222B3D, "explode_1st_offset" },
    { 0x0174967D, "explode_2_time" },
    { 0x7BF68BE1, "explode_2nd_offset" },
    { 0x0C6E521E, "explode_all_drones" },
    { 0x896B9F38, "explode_anim" },
    { 0xC3D947FD, "explode_complex" },
    { 0x9D634ED3, "explode_dist" },
    { 0x679268AB, "explode_drone" },
    { 0x7D92CD8A, "explode_drones" },
    { 0xA16662E5, "explode_event" },
    { 0xF30725E1, "explode_gas_in_streets" },
    { 0xACFF3B98, "explode_into_dust" },
    { 0x849F133D, "explode_into_goo" },
    { 0x7894C286, "explode_main_offset" },
    { 0x7F8B4F4D, "explode_me" },
    { 0x09A620C8, "explode_notify_wrapper" },
    { 0x722A8820, "explode_on_damage" },
    { 0xFC1C6D17, "explode_on_death" },
    { 0xA26ED124, "explode_orient" },
    { 0xB84891D5, "explode_origin" },
    { 0x23E71C06, "explode_overheated_jetgun" },
    { 0xC92B43F2, "explode_pipes" },
    { 0x45FB3C83, "explode_pos" },
    { 0x12EC6646, "explode_position" },
    { 0xA1672EB9, "explode_position_valid" },
    { 0x85312E91, "explode_radius" },
    { 0x0A50EC58, "explode_struct" },
    { 0xAF5A4EAF, "explode_stuff" },
    { 0x62C51123, "explode_then_flicker" },
    { 0xBD17DE24, "explode_time" },
    { 0xAE258FF5, "explode_to_near_zombies" },
    { 0x543EE65E, "explode_tower" },
    { 0x1003A73A, "explode_tower_time" },
    { 0x0484D7E9, "explode_trig" },
    { 0xECB1B131, "explode_trigger" },
    { 0x1CA84136, "explode_trigger_org" },
    { 0xE19966EC, "explode_vtol" },
    { 0x381FD530, "explode_vtol_manager" },
    { 0x89593BEA, "explode_when_out" },
    { 0x904E13D1, "explode_when_triggered" },
    { 0xA4E0853F, "explodeanim" },
    { 0x6C758A84, "exploded" },
    { 0xCA7BCC6B, "exploded_" },
    { 0xD1BE9D9C, "explodedfunction" },
    { 0xCFB0887A, "explodefx" },
    { 0xC9ADA02D, "explodeoncontact" },
    { 0xAFC8E002, "explodepoint" },
    { 0x087B330E, "explodepos" },
    { 0x80983C42, "exploder" },
    { 0x738921E0, "exploder10780" },
    { 0x452AF364, "exploder2" },
    { 0xCE26B729, "exploder205" },
    { 0xBD318D65, "exploder230" },
    { 0x6B2D6DCD, "exploder3" },
    { 0x73A4110C, "exploder33" },
    { 0xF173799E, "exploder_1000" },
    { 0x54637F97, "exploder_1000_detonated" },
    { 0x08AE79DB, "exploder_100_detonated" },
    { 0xDC201AE2, "exploder_10549" },
    { 0xB39F0268, "exploder_10550" },
    { 0xD9A17CD1, "exploder_10551" },
    { 0xFFA3F73A, "exploder_10552" },
    { 0x25A671A3, "exploder_10553" },
    { 0x4BA8EC0C, "exploder_10554" },
    { 0xDABA0EDB, "exploder_1250" },
    { 0xC2FD8936, "exploder_1350" },
    { 0xE467A02B, "exploder_1500" },
    { 0x1995F13B, "exploder_2000" },
    { 0x167D9AE8, "exploder_300_target" },
    { 0xAB59CAF4, "exploder_3233" },
    { 0xAA6047A4, "exploder_850" },
    { 0x572D5256, "exploder_9901" },
    { 0xED593488, "exploder_after_load" },
    { 0x4A25D63F, "exploder_after_wait" },
    { 0x8A9168E2, "exploder_animate" },
    { 0x061F8F20, "exploder_array" },
    { 0x04FE2577, "exploder_before_load" },
    { 0x0C177025, "exploder_case" },
    { 0xC88348B7, "exploder_city_intro" },
    { 0x33720B3E, "exploder_damage" },
    { 0xB69AA3D5, "exploder_damager_trigger_by_hind" },
    { 0xCFA4F08C, "exploder_deck_smoke" },
    { 0xE20E686B, "exploder_defalco_dead_explosions" },
    { 0xBDBA5FB9, "exploder_defalco_osprey_spotlight" },
    { 0x18F2ADBE, "exploder_delay" },
    { 0x4C8A9773, "exploder_detonated" },
    { 0x3AB4FF7D, "exploder_duration" },
    { 0xE115BB32, "exploder_earthquake" },
    { 0x0E0DE7C4, "exploder_eye_scan" },
    { 0x8AD4F90F, "exploder_fade" },
    { 0xF98273AF, "exploder_fast" },
    { 0x411DA2F8, "exploder_find" },
    { 0xD09751AE, "exploder_for_period" },
    { 0xF7BBAA61, "exploder_freeway_destruction" },
    { 0x7784BDAC, "exploder_frogger_fx" },
    { 0xB12240A5, "exploder_gas_startion" },
    { 0x4D357FE6, "exploder_group" },
    { 0xC639E08A, "exploder_hack" },
    { 0x26F660FB, "exploder_heli_end" },
    { 0x28C68CF2, "exploder_id" },
    { 0x0F89E5CB, "exploder_id_set" },
    { 0x92EC706C, "exploder_int" },
    { 0x389D912E, "exploder_interior_fx" },
    { 0x11858315, "exploder_intro" },
    { 0xC61DCDE4, "exploder_intro_light" },
    { 0x12806A98, "exploder_is_glass_exploder" },
    { 0x9CB2CBAA, "exploder_is_lightning_exploder" },
    { 0x3966E07E, "exploder_light_flicker_bridge" },
    { 0x0CB592F9, "exploder_light_flicker_cctv" },
    { 0xEF8476B8, "exploder_light_flicker_cic" },
    { 0x9752B344, "exploder_light_flicker_flooded_area" },
    { 0xA988E7F0, "exploder_light_flicker_hangar" },
    { 0x1E4783D2, "exploder_light_flicker_hangar_control" },
    { 0x262ABECD, "exploder_light_flicker_intro" },
    { 0x3AC72356, "exploder_light_flicker_lower_levels" },
    { 0x8FCEB956, "exploder_light_flicker_office_turret" },
    { 0xEEC0D83B, "exploder_light_flicker_sensitive_room" },
    { 0xFCA1D4C6, "exploder_light_flicker_server_room" },
    { 0x6B0FD149, "exploder_linktargets" },
    { 0xEC6BC651, "exploder_load" },
    { 0x3C45DAE5, "exploder_loc" },
    { 0x3CA60E87, "exploder_menendez_stables_roof_collapse" },
    { 0x3911F790, "exploder_name" },
    { 0x4A49EE0B, "exploder_num" },
    { 0x527C963F, "exploder_on_trigger" },
    { 0xED4A1B2D, "exploder_phys" },
    { 0x57EA7268, "exploder_playsound" },
    { 0x4CFDBB1E, "exploder_rumble" },
    { 0x7C2AB398, "exploder_server" },
    { 0xC49A2ED6, "exploder_shared" },
    { 0xB4C80B2D, "exploder_showlinks" },
    { 0xCCE948AE, "exploder_sound" },
    { 0x930AFC87, "exploder_staples_center" },
    { 0xA64D5961, "exploder_statue" },
    { 0xB854D423, "exploder_statue_old" },
    { 0x593E8A39, "exploder_stop" },
    { 0x1C367E4A, "exploder_string" },
    { 0xA1EA122B, "exploder_sunflare" },
    { 0xF737A7BF, "exploder_super_kill_blood_alive_a_defalco" },
    { 0x2CB16B73, "exploder_super_kill_blood_alive_a_farid" },
    { 0x9B798574, "exploder_super_kill_blood_alive_b_defalco" },
    { 0xBA2819AC, "exploder_super_kill_blood_alive_b_farid" },
    { 0xA52564C1, "exploder_super_kill_blood_alive_c_karma" },
    { 0x56FA6795, "exploder_super_kill_blood_briggs" },
    { 0xB18E5534, "exploder_super_kill_blood_dead_a_farid" },
    { 0x2F38D77B, "exploder_super_kill_blood_dead_b_farid" },
    { 0xDDAA2A46, "exploder_super_kill_blood_dead_c_karma" },
    { 0x5E3173AE, "exploder_super_kill_blood_guard_1" },
    { 0x382EF945, "exploder_super_kill_blood_guard_2" },
    { 0x514B89FD, "exploder_super_kill_snow" },
    { 0x309FDDE8, "exploder_tankersparker_links" },
    { 0xCB14A66F, "exploder_trigger" },
    { 0xD18B08D5, "exploder_trigs_mark19_think" },
    { 0x8C09AB96, "exploder_wait" },
    { 0xA77C386D, "exploderarray" },
    { 0x8CA8C081, "exploderbase" },
    { 0xF06A1339, "exploderchunk" },
    { 0xDF0A6170, "exploderchunks" },
    { 0x88BE265F, "explodercount" },
    { 0xD96AD05E, "exploderfunction" },
    { 0x0FFC3508, "exploderfx" },
    { 0x88C57F2B, "explodergroup" },
    { 0xDB41E970, "exploderhandle" },
    { 0xD6EC05D1, "exploderid" },
    { 0x3A2B42AE, "exploderindex" },
    { 0xCCD4477A, "explodernum" },
    { 0xEA8ED38D, "exploders" },
    { 0x99249459, "exploderstruct" },
    { 0xA69AB6AB, "explodes" },
    { 0x8AA99521, "explodey" },
    { 0x5625DA01, "exploding" },
    { 0x7DBFCF5A, "exploding_column" },
    { 0x553A2006, "exploding_destructible_car_death" },
    { 0x2526153A, "exploding_jetgun_fx" },
    { 0x9CB54324, "explodingvehicles_challenge" },
    { 0x40D00CFA, "exploit" },
    { 0x9A596559, "exploit_reroute" },
    { 0x022C20B6, "exploiting" },
    { 0xBB0AFF75, "exploits" },
    { 0x7820A6C6, "explored" },
    { 0xC3D0AA30, "explos" },
    { 0xA28E7762, "explosion" },
    { 0x9A899CAA, "explosion_1" },
    { 0x74872241, "explosion_2" },
    { 0x4E84A7D8, "explosion_3" },
    { 0x589600B7, "explosion_4" },
    { 0x3293864E, "explosion_5" },
    { 0x5C08AD02, "explosion_activate" },
    { 0xCDC65966, "explosion_anim" },
    { 0x22B341CE, "explosion_at_struct" },
    { 0x3D17C2DB, "explosion_barrage_delay" },
    { 0xB55175A2, "explosion_base" },
    { 0x87A7629A, "explosion_baseclose_manager" },
    { 0x4FE4E6D1, "explosion_basefar_manager" },
    { 0x926F5D14, "explosion_boom" },
    { 0x6EFB9B88, "explosion_c" },
    { 0x52BEB2EA, "explosion_car1" },
    { 0x6831F5C7, "explosion_cave_ambient" },
    { 0x6CB4476F, "explosion_choke" },
    { 0x7F67D645, "explosion_damage_max" },
    { 0x6A492EAB, "explosion_damage_min" },
    { 0xEE5BFB2D, "explosion_death" },
    { 0xF87E91C5, "explosion_death_gib_chance" },
    { 0x54DDDA85, "explosion_death_gib_min_damage" },
    { 0xDFC65FF9, "explosion_death_offset" },
    { 0x5C1BBD70, "explosion_death_override" },
    { 0x4AA7560F, "explosion_death_ragdollfraction" },
    { 0x5AFF53D4, "explosion_death_trigger" },
    { 0xBAA0A39E, "explosion_delay" },
    { 0x1708F081, "explosion_dirt_duration" },
    { 0x9FB25381, "explosion_dirt_fade_time" },
    { 0xD24D8AAC, "explosion_distance" },
    { 0xC7296A4A, "explosion_effect" },
    { 0x47130D86, "explosion_failsafe" },
    { 0x644F9A81, "explosion_incoming" },
    { 0xE31495EF, "explosion_inner" },
    { 0xE79315AC, "explosion_launch" },
    { 0xD1EE8B8F, "explosion_launch_monitor" },
    { 0x7AA64289, "explosion_launcher" },
    { 0x899DC080, "explosion_launchers" },
    { 0x774BCA65, "explosion_magnitude" },
    { 0xEA11BB1E, "explosion_manager" },
    { 0xE835701F, "explosion_max_damage" },
    { 0x98E906D9, "explosion_min_damage" },
    { 0xCC0BCFEB, "explosion_ori" },
    { 0x71C6C92F, "explosion_origin" },
    { 0xE56F0B69, "explosion_point" },
    { 0x058DC7E0, "explosion_points" },
    { 0x99E3CFD3, "explosion_points_structs" },
    { 0x15C23F41, "explosion_pos" },
    { 0x10A20258, "explosion_position" },
    { 0x42897B0B, "explosion_radius" },
    { 0x36C65B28, "explosion_radius_flash" },
    { 0x04490756, "explosion_radius_frag" },
    { 0x0F2AC2D6, "explosion_radius_type" },
    { 0x441AB7A0, "explosion_range" },
    { 0x3416408C, "explosion_safe_distance" },
    { 0x5786AC04, "explosion_safe_distance_player" },
    { 0x2CB14D8E, "explosion_sound" },
    { 0x24CE6D60, "explosion_started" },
    { 0x54553F10, "explosion_startnotify" },
    { 0xEB4F7724, "explosion_state" },
    { 0xEB3085FA, "explosion_stopnotify" },
    { 0xEB311F8A, "explosion_strength" },
    { 0xF8D3D516, "explosion_struct" },
    { 0x84FF0389, "explosion_structs" },
    { 0x5BBC39D9, "explosion_thread" },
    { 0xD1E6C0FE, "explosion_trigger_thread" },
    { 0x2F79FAC9, "explosion_type" },
    { 0x48D7856E, "explosionangles" },
    { 0x1C8F42C9, "explosiondamage" },
    { 0xF516DB17, "explosiondir" },
    { 0xE85B6AC7, "explosiondistance" },
    { 0x48E4E691, "explosioneffect" },
    { 0xA207FBA7, "explosionforce" },
    { 0xC6B32228, "explosionfx" },
    { 0x5461CAC2, "explosionhide" },
    { 0xCF84350C, "explosioninnerradius" },
    { 0x46030633, "explosionm" },
    { 0x214136EB, "explosionmaxdamage" },
    { 0x36E7219D, "explosionmindamage" },
    { 0x0D686A20, "explosionorigin" },
    { 0x94FEF5B8, "explosionpoint" },
    { 0x39181614, "explosionpos" },
    { 0xE34299FC, "explosionradius" },
    { 0x1FBEC830, "explosionradiusminsq" },
    { 0xEEEBDAF4, "explosionradiussq" },
    { 0x01CC812D, "explosions" },
    { 0x6B937030, "explosions_go_off" },
    { 0x7438C114, "explosions_start" },
    { 0xC394BA1C, "explosionvec" },
    { 0xA84BF462, "explosive" },
    { 0xF67AAA2D, "explosive_arrow_death_indicator_hudelement" },
    { 0x821E9FB4, "explosive_bolt" },
    { 0xF0F61C4C, "explosive_bolt_earthquake" },
    { 0x3E6989C9, "explosive_bolts_msg" },
    { 0x07282BAD, "explosive_bolts_selected" },
    { 0xE04CCA37, "explosive_car_kills" },
    { 0xBFD2AC88, "explosive_car_kills_total" },
    { 0x8C5725F1, "explosive_charge" },
    { 0x5251801E, "explosive_charge_2" },
    { 0xB6FEDD4C, "explosive_charge_2_obj" },
    { 0xEAB4561F, "explosive_charge_flashy" },
    { 0x361AD90B, "explosive_charge_model" },
    { 0x71E461D3, "explosive_charge_obj" },
    { 0x425A06F9, "explosive_charge_shot_level_full" },
    { 0xBE63C816, "explosive_charge_shot_level_high" },
    { 0xFED950D0, "explosive_charge_shot_level_low" },
    { 0x7FBCD300, "explosive_charges_left" },
    { 0xAAE4D4A1, "explosive_concussive_explosion" },
    { 0x41EB1C9E, "explosive_damage" },
    { 0xD88A3ECF, "explosive_dart_death_indicator_hudelement" },
    { 0xD845902D, "explosive_death" },
    { 0xF69147D4, "explosive_death_index" },
    { 0x8AEB31AC, "explosive_distance" },
    { 0x1013F172, "explosive_dmg_req" },
    { 0x5AD1FCF3, "explosive_dmg_taken" },
    { 0x09091A4B, "explosive_dmg_taken_on_grab_start" },
    { 0xC3F45E13, "explosive_electrical_explosion" },
    { 0x244706EC, "explosive_hint_timer" },
    { 0x6CB467E7, "explosive_incendiary_explosion" },
    { 0xE9E6090A, "explosive_instakill" },
    { 0xDB77DEF7, "explosive_items" },
    { 0x89185F58, "explosive_kills" },
    { 0xA55E6B77, "explosive_kills_total" },
    { 0x73D3FFDA, "explosive_mods" },
    { 0xA2EC9313, "explosive_nitrogen_tank_death_indicator_hudelement" },
    { 0x0624688F, "explosive_obj_fail" },
    { 0x703EEC9B, "explosive_set" },
    { 0x107EDFC0, "explosive_set_2" },
    { 0x07543FFC, "explosive_tip" },
    { 0xFA0F0B3C, "explosive_tip_hint" },
    { 0x22CDFEE9, "explosive_trigger_hint_press" },
    { 0xF305D186, "explosive_trigger_hint_press_2" },
    { 0x1B0F7897, "explosive_trigger_press" },
    { 0xE8573124, "explosive_trigger_press_2" },
    { 0x8229D210, "explosive_vehice_death_indicator_hudelement" },
    { 0x41234A0F, "explosive_volume" },
    { 0x0678D7C9, "explosivedamage" },
    { 0xDE630C24, "explosivedamage_data" },
    { 0x5FC3C3A4, "explosivedamagereduction" },
    { 0x54E5EF0C, "explosivedeath" },
    { 0x8A47B972, "explosiveinfo" },
    { 0xCF01AFD1, "explosivekilled" },
    { 0x10DEAB31, "explosivekills" },
    { 0x2B951F06, "explosiveplanttime" },
    { 0x0B18482D, "explosives" },
    { 0xBE5865C9, "explosives_in_place" },
    { 0xD68A8569, "explosives_objective" },
    { 0xAEEE5014, "explosives_start" },
    { 0x0540B5CD, "explosivestraining_begin" },
    { 0x36B043B5, "explosivestraining_end" },
    { 0x6946CA8D, "explosiveweakspottags" },
    { 0xD73524E6, "explosivve" },
    { 0x50C8F7AE, "explostion" },
    { 0x0ABFB1A9, "expolosion" },
    { 0xEF00AE34, "exponent" },
    { 0x042CE49E, "exponent_is_dirty" },
    { 0xD7CDF1B6, "exponential" },
    { 0xB494C9BB, "exponentially" },
    { 0x4DDB971C, "exporg" },
    { 0x5FBB5FC7, "export" },
    { 0xDDB2EA17, "export_labels" },
    { 0x82AB32D1, "export_scene_abbrev" },
    { 0x94643273, "export_status_thread" },
    { 0xCF51CECB, "export_to_html" },
    { 0xDFC2FE8C, "exported" },
    { 0xFFE4B2BE, "exports" },
    { 0x09305FFF, "exposecombatmainloops" },
    { 0xFFC4386B, "exposed" },
    { 0x7960B8F3, "exposed2" },
    { 0xD5299EAE, "exposed2_" },
    { 0x409FBC7A, "exposed_blindfire_wait_max" },
    { 0x033BB164, "exposed_blindfire_wait_min" },
    { 0x29B2A4BC, "exposed_crouch_death_fetal" },
    { 0x3F1B8F32, "exposed_crouch_turn_left" },
    { 0x07326321, "exposed_crouch_turn_right" },
    { 0x1BA75F82, "exposed_grenadethrowb" },
    { 0xA8E81B67, "exposed_modern" },
    { 0xDF7AD843, "exposed_no" },
    { 0x8CC6E8CE, "exposed_pain_2_crouch" },
    { 0x696048E7, "exposed_pain_leg" },
    { 0x47D858F9, "exposed_time" },
    { 0xDC864E76, "exposed_type" },
    { 0xA130E677, "exposed_yes" },
    { 0x33DA0C34, "exposedanimset" },
    { 0xC8F4DF7F, "exposedapproachwaittillclose" },
    { 0xFD21B5F9, "exposedbehavior" },
    { 0x750E1421, "exposedcantseeenemywait" },
    { 0x79D0AC24, "exposedcombatcantseeenemybehavior" },
    { 0xBF66C79F, "exposedcombatcheckputawaypistol" },
    { 0x165E4083, "exposedcombatcheckreloadorusepistol" },
    { 0x88869271, "exposedcombatcheckstance" },
    { 0x0487862C, "exposedcombatconsiderthrowgrenade" },
    { 0x111A166A, "exposedcombatmainloop" },
    { 0xE48D8051, "exposedcombatmainloopsetup" },
    { 0x4BC42CD1, "exposedcombatneedtoturn" },
    { 0x31AA72F4, "exposedcombatrambo" },
    { 0x9008A3B9, "exposedcombatreacquirewhennecessary" },
    { 0x3B7EC6D6, "exposedcombatshootuntilneedtoturn" },
    { 0xC393C332, "exposedcombatstopusingrpgcheck" },
    { 0xED4BE6A6, "exposedcombatturndebugmsg" },
    { 0xE240E618, "exposedcombatwait" },
    { 0x8195E305, "exposedcombatwaitforstancechange" },
    { 0x4FA6B5C2, "exposedfiring" },
    { 0x99B0E24C, "exposedmelees" },
    { 0xA778E8E3, "exposedpainactionstart" },
    { 0x30DA45C2, "exposedrechamber" },
    { 0x9D0C9450, "exposedreload" },
    { 0x8DFC1748, "exposedreloading" },
    { 0x6820B34D, "exposedset" },
    { 0x51CC295A, "exposedsetdesiredstancetostand" },
    { 0x37060AFF, "exposedsetignore" },
    { 0x8F0C26D4, "exposedtimeinseconds" },
    { 0x5F49BC66, "exposedtranstypes" },
    { 0xCC9A2A8C, "exposedwait" },
    { 0xB800CB40, "exposing" },
    { 0xE7D8E98A, "exposion" },
    { 0xF17DEB5A, "exposure" },
    { 0xE10DE163, "exposure_flicker" },
    { 0x091E7CE6, "exposure_val" },
    { 0xD4910843, "express" },
    { 0xD744C865, "express_cave" },
    { 0xE9A61767, "express_city" },
    { 0xC5C33F21, "express_cockpit" },
    { 0x2277AAB1, "express_desert" },
    { 0x3FFF4EE3, "express_hangar" },
    { 0xBAC037FE, "express_hills" },
    { 0x272F0DBE, "express_largeroom" },
    { 0x00A88222, "express_mediumroom" },
    { 0xBAE99C76, "express_outdoor" },
    { 0xCE3560B0, "express_sewerpipe" },
    { 0xAD759BF2, "express_smallroom" },
    { 0xEEC07B60, "express_stoneroom" },
    { 0xF242DF01, "express_underwater" },
    { 0xE6D67AE3, "expression" },
    { 0xCB905FD2, "expressions" },
    { 0xF5FAC162, "expspot" },
    { 0x669B288F, "exsnp" },
    { 0x37FAB5E0, "exsnpu" },
    { 0x2D943976, "ext" },
    { 0xA1D44C9C, "ext_door_l" },
    { 0xC593DDF2, "ext_door_r" },
    { 0x76C261BC, "ext_doors" },
    { 0x2CEA6134, "ext_far_blur" },
    { 0x225957DA, "ext_far_end" },
    { 0x9ACD10E1, "ext_far_start" },
    { 0x32583279, "ext_near_blur" },
    { 0xE9669D9D, "ext_near_end" },
    { 0xFF038F0E, "ext_near_start" },
    { 0xE0DD262D, "extend" },
    { 0x0FFE3F04, "extend_left_arm" },
    { 0xCE4C51D5, "extend_right_arm" },
    { 0x63DA66DA, "extended" },
    { 0xE2BB393C, "extended_death_ended" },
    { 0x9CB3775D, "extended_death_gib_chance" },
    { 0xBA53CB22, "extended_death_loop" },
    { 0x6072B3BB, "extending" },
    { 0x1743502C, "extends" },
    { 0x90CD9468, "extension" },
    { 0x4104CCBD, "extent" },
    { 0x66F2FE71, "extention" },
    { 0xC4C09D7C, "extents" },
    { 0x8C58557B, "exterior" },
    { 0x62CF79C9, "exterior_array" },
    { 0x961053F7, "exterior_goal" },
    { 0xF9CC362E, "exterior_goals" },
    { 0x1855760E, "exterior_idle_sound_ent" },
    { 0x2C98FDD2, "exterior_rim_lights" },
    { 0xA015E7D9, "exterior_segment" },
    { 0x189534F6, "exterior_vision" },
    { 0xE9289C6E, "exterior_window_anim" },
    { 0x606BE64D, "exterior_window_anim_exit" },
    { 0xEEFB7D1A, "exteriors" },
    { 0xC0E553B5, "exterminate_player" },
    { 0xD9A688FC, "external" },
    { 0x35B9C2A0, "external_before_launch" },
    { 0xC3D4B6F9, "externally" },
    { 0xB9562ACC, "exteror" },
    { 0xA048745E, "extinguiser" },
    { 0x961C1961, "extinguish" },
    { 0xB04E57C9, "extra" },
    { 0x63B1AB47, "extra_banzai_current" },
    { 0xB4D39D7C, "extra_banzai_min" },
    { 0x9477ADB5, "extra_banzai_queue" },
    { 0xD29EBA9C, "extra_bookcase_strat" },
    { 0x992BEAE7, "extra_bullets" },
    { 0xDC780449, "extra_cam" },
    { 0x4CF1D1C1, "extra_cam_active_primary" },
    { 0x381FA097, "extra_cam_active_seconday" },
    { 0x544B98DE, "extra_cam_cur_fov" },
    { 0xE319871F, "extra_cam_enabled" },
    { 0xD68FA938, "extra_cam_headshot_hero_data" },
    { 0x1CAB6ED3, "extra_cam_hero_data" },
    { 0x4FCAE572, "extra_cam_init" },
    { 0x3BD0563C, "extra_cam_lobby_client_hero_data" },
    { 0x50504801, "extra_cam_mirror_fov" },
    { 0x6E5C82C3, "extra_cam_move" },
    { 0xE6E4720B, "extra_cam_outfit_preview_data" },
    { 0x63D084FE, "extra_cam_render_character_body_item_func_callback" },
    { 0x29F391EC, "extra_cam_render_character_head_item_func_callback" },
    { 0xA89AD62B, "extra_cam_render_character_helmet_item_func_callback" },
    { 0x43877A5B, "extra_cam_render_current_hero_headshot_func_callback" },
    { 0x81C41302, "extra_cam_render_hero_func_callback" },
    { 0xC35758C9, "extra_cam_render_lobby_client_hero_func_callback" },
    { 0x0CE31346, "extra_cam_render_outfit_preview_func_callback" },
    { 0x0DAE963B, "extra_cam_render_wc_paintjobicon_func_callback" },
    { 0x1A11C561, "extra_cam_render_wc_varianticon_func_callback" },
    { 0x91F69B8F, "extra_cam_startup" },
    { 0x56D2A26C, "extra_cam_surfaces" },
    { 0xED7F5136, "extra_cam_title" },
    { 0x10AD18F8, "extra_cam_wc_paintjob_icon" },
    { 0x18C4EA64, "extra_cam_wc_variant_icon" },
    { 0xBA072A68, "extra_cam_window" },
    { 0x480EF640, "extra_cams" },
    { 0x45825B64, "extra_check" },
    { 0xD4E7CE53, "extra_control_room" },
    { 0x35A2C247, "extra_control_room_guy" },
    { 0x9F656401, "extra_count" },
    { 0xC2DF6971, "extra_custom_death_logic" },
    { 0x49487B2F, "extra_damage" },
    { 0xAF7285D2, "extra_death_func_to_check_for_splat_death" },
    { 0x9CEF0A29, "extra_delay" },
    { 0x5E3B4CF0, "extra_dest" },
    { 0xE2D9A32A, "extra_ents" },
    { 0xEE83E9E7, "extra_events" },
    { 0x2E274D90, "extra_grenadesuicide_current" },
    { 0xA3DF6F3B, "extra_grenadesuicide_min" },
    { 0xF4D94E02, "extra_grenadesuicide_queue" },
    { 0x4665D005, "extra_guy" },
    { 0x06549694, "extra_guys" },
    { 0x306862D6, "extra_health" },
    { 0x49B5B29C, "extra_hero" },
    { 0xD1F72ADD, "extra_hero_goal_pos" },
    { 0xE7C15796, "extra_horses_left" },
    { 0xADC43EFE, "extra_huey_explosions" },
    { 0xF71C0A7C, "extra_hueys_distance" },
    { 0xE8715908, "extra_info" },
    { 0x890F74C0, "extra_life_model" },
    { 0x581E9363, "extra_life_spawner" },
    { 0xC280DAD5, "extra_lives" },
    { 0xB8C5E867, "extra_lives_base" },
    { 0x45581C72, "extra_lives_display" },
    { 0xAAFBF017, "extra_lives_range" },
    { 0xC8B2A1A5, "extra_lives_sizzle" },
    { 0x554E27DE, "extra_locker_room" },
    { 0x0B2A2E1E, "extra_locker_room_guy" },
    { 0x391DB301, "extra_low_damage_notified" },
    { 0x48797A87, "extra_low_health" },
    { 0xC7B880FB, "extra_low_health_callback" },
    { 0x848694F1, "extra_marines" },
    { 0x22F75353, "extra_model_1" },
    { 0xB0EFE418, "extra_model_2" },
    { 0xD6F25E81, "extra_model_3" },
    { 0x6F0F9B6C, "extra_muj_riders" },
    { 0x4340ACD8, "extra_muzzle_flash" },
    { 0x66EC77C2, "extra_parts" },
    { 0x717DBDAE, "extra_pow" },
    { 0xCAF3D0EE, "extra_pt_boats_turn" },
    { 0xFCC7A3B4, "extra_qrs" },
    { 0x22D727EA, "extra_runner" },
    { 0x35D06B2A, "extra_score" },
    { 0xBB386068, "extra_spawns" },
    { 0x0607396C, "extra_spin" },
    { 0xD1284FB9, "extra_standard_current" },
    { 0x1F9C2842, "extra_standard_min" },
    { 0xF11B5B1F, "extra_standard_queue" },
    { 0xC67E00F7, "extra_target" },
    { 0xF2008E29, "extra_text" },
    { 0xF0CF2C6A, "extra_trig" },
    { 0xA7DBEA13, "extra_triggers" },
    { 0xBC3963CB, "extra_up" },
    { 0x5F9627A6, "extra_vo_shit" },
    { 0x8AE3C135, "extra_wait_time" },
    { 0xFE11185C, "extra_x" },
    { 0xCD0505FF, "extraboundary" },
    { 0x9A1DD45E, "extracam" },
    { 0xC0D023D3, "extracam1" },
    { 0x4EC8B498, "extracam2" },
    { 0x74CB2F01, "extracam3" },
    { 0x32D7930E, "extracam4" },
    { 0x58DA0D77, "extracam5" },
    { 0x058F279C, "extracam_01" },
    { 0x43DFBD55, "extracam_data" },
    { 0x5E987323, "extracam_data_struct" },
    { 0x01C0F890, "extracam_height" },
    { 0xC5B6DDEF, "extracam_index" },
    { 0xBF1F2002, "extracam_init_index" },
    { 0x86CC0DBB, "extracam_init_item" },
    { 0x1D060F3C, "extracam_offscreen_y" },
    { 0x3C85FA0D, "extracam_quadrant" },
    { 0x5C8226FA, "extracam_required_fov" },
    { 0x0759ECAB, "extracam_reset_index" },
    { 0xDFA06AF9, "extracam_screen" },
    { 0x10DBF4D2, "extracam_tv_test" },
    { 0xF26F10B3, "extracam_width" },
    { 0xF38FB3EF, "extracam_x" },
    { 0xCD8D3986, "extracam_y" },
    { 0x2C3BD034, "extracamactive" },
    { 0x2E5C6F3A, "extracamactive_multi" },
    { 0xBBEE2B9F, "extracamanimscripted" },
    { 0x0066EC6E, "extracamdata" },
    { 0x472666BA, "extracamindex" },
    { 0xF42C94C1, "extracams" },
    { 0x118C19F4, "extracamswitcher1" },
    { 0x8393892F, "extracamswitcher2" },
    { 0x5D910EC6, "extracamswitcher3" },
    { 0x9F84AAB9, "extracamswitcher4" },
    { 0x42A076A4, "extract" },
    { 0x51101F07, "extracted" },
    { 0xA3BACF84, "extracting" },
    { 0xD11884CE, "extraction" },
    { 0xAB9434B5, "extraction_point" },
    { 0x823077C4, "extractionpoint" },
    { 0x987A8CD7, "extracts" },
    { 0x3CA9088B, "extraendon" },
    { 0xEC7BFC2D, "extraguys" },
    { 0xC8506905, "extrainfo" },
    { 0xF4FBF35A, "extrainfostr" },
    { 0x0B0DD9F1, "extraneous" },
    { 0x5E2D17AA, "extranotify" },
    { 0xF72F3073, "extraordinary" },
    { 0x44A06448, "extraperks" },
    { 0xA106738A, "extrapolate" },
    { 0x741E010C, "extraradiusdvar" },
    { 0x427468C0, "extras" },
    { 0x8D380A13, "extraspawnpoints" },
    { 0x0D41C14C, "extraspawnpointsused" },
    { 0xA4BA2B9E, "extratime" },
    { 0xB96FFE49, "extratimerequired" },
    { 0x09B66531, "extratrackrequired" },
    { 0xBB9F0DDE, "extrawait" },
    { 0x79921C9E, "extraweap" },
    { 0x7467C73D, "extraweight" },
    { 0x71A9B46B, "extreme" },
    { 0xF91FAD80, "extreme_bloody_death" },
    { 0x6BB7D6B1, "extreme_bloody_death_fx" },
    { 0xF8681460, "eye" },
    { 0x4A831E53, "eye_fx_ent" },
    { 0x6C9C1EEE, "eye_height" },
    { 0x1C25FF68, "eye_in_the_sky" },
    { 0x39C349D3, "eye_org" },
    { 0x33FA7EA3, "eye_pos" },
    { 0x288A79E6, "eye_position" },
    { 0x053FE514, "eye_scanner_loop" },
    { 0xE0B32761, "eye_scene" },
    { 0x153099B8, "eye_scene_node" },
    { 0x4DBC8F58, "eye_stab_krav" },
    { 0x47205EB2, "eye_trace" },
    { 0x77FDED7F, "eyeball" },
    { 0x9A7FD725, "eyeball_off_luminance_override" },
    { 0x8357EE79, "eyeball_on_luminance_override" },
    { 0xF7460384, "eyeballed" },
    { 0x6D1CD997, "eyeforward" },
    { 0x3EFCB1A5, "eyeglowfx" },
    { 0x1D7BF821, "eyeheight" },
    { 0x81BF8A92, "eyeinthesky_controls" },
    { 0xBFF873EA, "eyelids" },
    { 0x91DA7A1A, "eyelooklimit" },
    { 0xC8867071, "eyelookmax" },
    { 0xD6991CF9, "eyeoffset" },
    { 0xF8BA1BC6, "eyeorigin" },
    { 0xACAC1362, "eyepoint" },
    { 0x0225046E, "eyepos" },
    { 0x2215B799, "eyeposition" },
    { 0xFE56760B, "eyes" },
    { 0xC1896D90, "eyes look now" },
    { 0x770277DC, "eyes_on_the_wall" },
    { 0x900FEC00, "eyes_spawned" },
    { 0xF5478868, "eyesatenemy" },
    { 0x420E0439, "eyesonly" },
    { 0x3225ED90, "eyesonlylook" },
    { 0x10D600FE, "eyick" },
    { 0x3B5F65F1, "f" },
    { 0xFB2095B7, "f11" },
    { 0xBC00DF01, "f2" },
    { 0xEB480121, "f2b" },
    { 0x95FBB305, "f35" },
    { 0xDDA672DA, "f35_allies" },
    { 0x5C452FAA, "f35_ambient_console_lights" },
    { 0xB354BC5B, "f35_blinking_light" },
    { 0xC0BB0540, "f35_boarding" },
    { 0x95368BDC, "f35_collision_detection" },
    { 0x67A50245, "f35_collision_watcher" },
    { 0x8F016641, "f35_context" },
    { 0x38150875, "f35_control_check_ads" },
    { 0x3C214E2A, "f35_control_check_boost" },
    { 0x539C6298, "f35_control_check_deathblossom" },
    { 0x5DBEA881, "f35_control_check_hover" },
    { 0x2366978C, "f35_control_check_mode" },
    { 0xCDEA0F36, "f35_control_check_movement" },
    { 0x453FE6B8, "f35_control_check_weapons" },
    { 0xC7F5BBF1, "f35_crash" },
    { 0x55CACB74, "f35_crash_done" },
    { 0x7B8CBC26, "f35_crash_fx" },
    { 0xDF8BD399, "f35_crash_sound" },
    { 0x5975BA54, "f35_damage_bink" },
    { 0x3B7A49AF, "f35_damage_callback" },
    { 0x1FE958B3, "f35_damage_heavy" },
    { 0xBB975F32, "f35_damage_light" },
    { 0xD671BD0D, "f35_damage_off" },
    { 0x3E6058EF, "f35_damage_reset" },
    { 0xCB98DE31, "f35_damage_shader" },
    { 0x5E4FA467, "f35_damage_shader_time" },
    { 0xDD495F58, "f35_death_blossom" },
    { 0x6AA0871D, "f35_death_blossom_watcher" },
    { 0xDDC515DC, "f35_destroy_panels" },
    { 0xD555B527, "f35_dogfights" },
    { 0xE3DFBF03, "f35_eject" },
    { 0xB219626E, "f35_eject_collision" },
    { 0x9F12F725, "f35_eject_eject" },
    { 0xCE3BD9C9, "f35_eject_enemies_fly_away" },
    { 0x1CEE1DB5, "f35_eject_highlight_drone" },
    { 0x5EC78E9C, "f35_eject_intro" },
    { 0x9871626B, "f35_eject_intro_test" },
    { 0xD228C434, "f35_eject_manual" },
    { 0x369870D7, "f35_eject_notetrack_body_impact" },
    { 0xB37950BF, "f35_eject_notetrack_chute_opens" },
    { 0x31AA02F1, "f35_eject_notetrack_eject" },
    { 0x27736833, "f35_eject_notetrack_explosion" },
    { 0x7AACC0E8, "f35_eject_notetrack_hit_building" },
    { 0x0279C531, "f35_eject_notetrack_hit_ground" },
    { 0x18774821, "f35_eject_notetrack_start_jets" },
    { 0x40AC3E6C, "f35_eject_notify_start" },
    { 0x603AC1F9, "f35_eject_player" },
    { 0xBED753B3, "f35_eject_sequence_setup" },
    { 0x678FA5CC, "f35_eject_warp_plane_to_collision" },
    { 0x58EA507E, "f35_enable_ads" },
    { 0x616194D9, "f35_end_flybys" },
    { 0xBC5BABB6, "f35_exterior" },
    { 0x8B42658A, "f35_fire_guns" },
    { 0x31C62923, "f35_flight_start" },
    { 0xC0088468, "f35_get_approach_point" },
    { 0x4C51C040, "f35_get_available_approach_point" },
    { 0x9A2D49C5, "f35_get_goal_point" },
    { 0x80C57596, "f35_get_in" },
    { 0x8721CA1B, "f35_give_player_control" },
    { 0x252651FE, "f35_ground_targets" },
    { 0x906D1978, "f35_guns_get_damage" },
    { 0xD0F157FB, "f35_h_low" },
    { 0xDFA5CC43, "f35_h_max" },
    { 0x1E5A8947, "f35_h_mid" },
    { 0xA53E6730, "f35_health_elem" },
    { 0x1BD9B860, "f35_health_regen" },
    { 0x9F91DFD5, "f35_health_regen_start" },
    { 0x62B9F449, "f35_health_regen_think" },
    { 0x0CF6BA7D, "f35_health_regen_update_last_damaged_timer" },
    { 0xA68A2738, "f35_health_regen_wait_for_damage" },
    { 0x0E2075AE, "f35_health_system" },
    { 0xB56A30B8, "f35_health_warning_audio" },
    { 0xF71354D6, "f35_hide_landing_gear" },
    { 0x97535F9D, "f35_hide_outer_model_parts" },
    { 0x4DDA620E, "f35_hit_object_switch_to_vtol" },
    { 0x8FF9B2B6, "f35_hotel" },
    { 0x7CEB75C5, "f35_hud_damage" },
    { 0x374206E7, "f35_hud_damage_ent" },
    { 0x503CCE50, "f35_hud_damage_event" },
    { 0xD02A37AC, "f35_init_console" },
    { 0xAF9BDFD6, "f35_intercepts_drone" },
    { 0xDE6DB9E8, "f35_interior" },
    { 0xB64671F3, "f35_interior_damage_anims" },
    { 0xAECA261E, "f35_intro" },
    { 0xC87BCD08, "f35_land_fx" },
    { 0x75BF4C85, "f35_landing_gear" },
    { 0x31A8E751, "f35_lock_to_mesh" },
    { 0xF6A584A6, "f35_lockon_target" },
    { 0xCC2A3062, "f35_loop" },
    { 0x7C9A8728, "f35_mode_switch" },
    { 0x8064BB94, "f35_mode_switch_vtol" },
    { 0xD535A045, "f35_move_to_position" },
    { 0x68CF8B7D, "f35_outro" },
    { 0x9654F7D0, "f35_pacing" },
    { 0xA817DBAD, "f35_player_damage_callback" },
    { 0x2DBDC1F4, "f35_player_damage_watcher" },
    { 0x99775118, "f35_remove_visor" },
    { 0xBBD6C16A, "f35_restore_fov" },
    { 0x5F782200, "f35_rewind_start" },
    { 0xDDA39602, "f35_rooftops" },
    { 0xF03CC8A1, "f35_scale_speed_down" },
    { 0xEEC9F445, "f35_scale_speed_to_max" },
    { 0xD9AB4CAB, "f35_scale_speed_to_min" },
    { 0xE6D6B8CE, "f35_scale_speed_up" },
    { 0xB299A6B6, "f35_scripted_functionality" },
    { 0x303E9AAF, "f35_setup" },
    { 0xD86C9A77, "f35_setup_visor" },
    { 0x84FE2133, "f35_show_base_console" },
    { 0x0C757959, "f35_show_console" },
    { 0x71D8645C, "f35_start_flybys" },
    { 0x3346681B, "f35_startup" },
    { 0xE6FC9151, "f35_startup_console" },
    { 0x7D6E9D85, "f35_switch_modes" },
    { 0xDB58FEB0, "f35_switch_modes_now" },
    { 0xB708CD4D, "f35_target_death_watcher" },
    { 0x7C4389FD, "f35_tower_02_start" },
    { 0xE5A12111, "f35_trenchrun" },
    { 0xD1E2054B, "f35_try_to_play_damage_bink" },
    { 0x2093AB3E, "f35_tutorial" },
    { 0x3E207AD7, "f35_tutorial_func" },
    { 0xC7B35A4C, "f35_vtol_spawn_func" },
    { 0x1338B156, "f35_wait_until_path_clear" },
    { 0xF6C1B2AF, "f35_wakeup" },
    { 0x99568F55, "f35_zoom_fov" },
    { 0x4F48EF94, "f35s" },
    { 0xA7DB7BB0, "f38" },
    { 0xEA91F51B, "f38_crash_into_bridge" },
    { 0x7CF05113, "f38_crash_rocket_notetrack" },
    { 0x0D7497D0, "f38_delete_offscreen" },
    { 0x53DF23F3, "f38_fire_guns" },
    { 0xA72AE6B1, "f38_firing_cannons" },
    { 0x3AD14ECB, "f38_firing_missile" },
    { 0x82686B85, "f38_flyoff" },
    { 0xA4D3C16E, "f38_goto_struct" },
    { 0xCB4B7186, "f38_init_fake_vehicle" },
    { 0xEAA5E064, "f38_ready" },
    { 0xBDD3979D, "f38_shot_down_drone" },
    { 0xA17A64F7, "f38_stop_firing" },
    { 0xF9B96BFA, "f38_stops_firing_guns" },
    { 0xCF8632E8, "f38_struct" },
    { 0x4151661B, "f38s" },
    { 0x1C93503B, "f38s_play_exhaust" },
    { 0xA00FBD77, "f4" },
    { 0x9E3087BD, "f4_add_contrails" },
    { 0xE4642D6B, "f4_delete_on_end" },
    { 0x7D2637D5, "f4easyrhino" },
    { 0x36DF4AAE, "f4s" },
    { 0x52D06C38, "f4u" },
    { 0x7A0D430E, "f5" },
    { 0xC16CC740, "f_alpha" },
    { 0x44DBE26B, "f_animlength" },
    { 0xF8425FD9, "f_best_score" },
    { 0xBFE668E3, "f_delay_seconds" },
    { 0xD2F04CC5, "f_distance" },
    { 0x726CF099, "f_dot" },
    { 0x05810F1D, "f_groundref_x" },
    { 0xDF7E94B4, "f_groundref_y" },
    { 0x518603EF, "f_groundref_z" },
    { 0xEE2CED89, "f_gyard_area" },
    { 0x45FBCA4B, "f_limpspeed" },
    { 0xD4B5124A, "f_limpspeedsettime" },
    { 0x4077FCA8, "f_min_dot" },
    { 0x62E0C521, "f_progression_pct" },
    { 0xFBF5EA82, "f_scale" },
    { 0x99F70B32, "f_score" },
    { 0xFA42EFF5, "f_speed" },
    { 0xE45B3978, "f_thunder_wall_effect_area_sq" },
    { 0x7353F506, "f_thunder_wall_range_sq" },
    { 0xA91E4467, "f_turned_range_sq" },
    { 0xED987F54, "f_waittime" },
    { 0x013D189A, "fa" },
    { 0xB2710967, "fa38" },
    { 0x3A9824AD, "fa38_fire_weapon" },
    { 0x8B768385, "fa38_fly" },
    { 0x735AB246, "fa38_flyby_playback" },
    { 0x5D1CC638, "fa38_hover" },
    { 0x34123E1D, "fa38_init_fx" },
    { 0xC38D2AF9, "fa38_intro_car_roof_sparks" },
    { 0x37EBB1A3, "fa38_landing" },
    { 0xC884F12A, "fa38_missle_fire" },
    { 0xB1E05819, "fa38_rumble" },
    { 0xE81D9FAE, "fa38_stop_snd" },
    { 0x547D53DE, "fa38s" },
    { 0x67C123B6, "fa_drone_death" },
    { 0x8A3A9B47, "fa_drone_move" },
    { 0xC177352D, "fa_drone_spawn" },
    { 0xFE5E4E36, "fa_print" },
    { 0x1341F230, "fa_show_hud" },
    { 0xA0DF5289, "fa_speak" },
    { 0xF13B7E36, "fa_speak_finished" },
    { 0x43B73616, "fa_start_drone_path" },
    { 0xCB55B20A, "fa_take_weapons" },
    { 0x42F3CD72, "fa_visionset_bright" },
    { 0xE691E71E, "fa_visionset_dark" },
    { 0x1702777E, "fa_visionset_dogsled" },
    { 0xF47C6D79, "fa_visionset_nazibase" },
    { 0xB3E98F8E, "fa_visionset_reznov" },
    { 0xD2636DA0, "fa_visionset_shipstart" },
    { 0xD0084E29, "faalling" },
    { 0x7DC55C15, "fable" },
    { 0x71ADEFDD, "fabname" },
    { 0x867A90F5, "fabrication" },
    { 0x39E374CE, "faccuracy" },
    { 0x4BF1E5D2, "face" },
    { 0x5BBD21AD, "face_alert" },
    { 0x7E0D85BF, "face_ang" },
    { 0xFC4B90A1, "face_anim_tree" },
    { 0xA3DE6B81, "face_barrel" },
    { 0x47B0E90A, "face_burn_explosion" },
    { 0xD42A3397, "face_curr_base" },
    { 0x20A91AEB, "face_curr_base_idx" },
    { 0x662F3F70, "face_curr_event" },
    { 0x299E5790, "face_curr_event_idx" },
    { 0x5B46DD1D, "face_death" },
    { 0x7C2AEFD7, "face_disable" },
    { 0x4430A3AB, "face_event" },
    { 0xCF353BBE, "face_event_handler" },
    { 0x05EA1FE0, "face_forward" },
    { 0x97E5B29F, "face_here" },
    { 0x41DCA4BB, "face_kick" },
    { 0xC24D6DC2, "face_notify" },
    { 0xEE956A3E, "face_player" },
    { 0x973C1591, "face_pos" },
    { 0xA7A53D54, "face_state" },
    { 0xFDCFAF26, "face_struct" },
    { 0x1739A744, "face_swap" },
    { 0x0BC15B4A, "face_swap_end" },
    { 0xADF99D35, "face_swap_init" },
    { 0x258DE03B, "face_swap_other" },
    { 0x21DEDF5C, "face_swap_player" },
    { 0x5127887A, "face_target" },
    { 0xA7C95E80, "face_timer" },
    { 0xCA9BFADE, "face_timer_expired" },
    { 0x93C18E87, "faceangle" },
    { 0x632BF876, "faceangleoffset" },
    { 0x0DD491ED, "faceanim" },
    { 0x17CF1BBB, "faceburn_volume_check" },
    { 0x8F41CDFA, "faceburned" },
    { 0xAD28E037, "facecrow" },
    { 0x88122D12, "faced" },
    { 0x4B775787, "facedir" },
    { 0xAE14A77B, "facee" },
    { 0x5FD00963, "faceenemyatendofapproach" },
    { 0xF1E2FD07, "faceenemydelay" },
    { 0x4F4BB5CC, "faceenemyimmediately" },
    { 0x81D66FC1, "faceenemyormotionafterabit" },
    { 0x6C42BEA7, "faceframeendnotify" },
    { 0x1777A79F, "facelastnotifynum" },
    { 0x301CE6CD, "facelookaheadforabit" },
    { 0x3F70A76C, "facemotion" },
    { 0x9979C4F3, "facenodeangle" },
    { 0xD7F8D2AF, "facenormal" },
    { 0x664DF6FE, "facepaint" },
    { 0xC24CD04A, "faceplate" },
    { 0xB087942F, "faceplate_health" },
    { 0x02700F09, "faceplate_pos" },
    { 0x2B192F3D, "faceresult" },
    { 0x5A4142DD, "faces" },
    { 0x841161C8, "facestates" },
    { 0x617D06CF, "facestatesarray" },
    { 0x052928A5, "facewaitforresult" },
    { 0x2D439217, "facewaiting" },
    { 0x66C5D1AB, "faceyaw" },
    { 0x840E10E5, "facial" },
    { 0x729F7647, "facial_anim" },
    { 0xC48802F2, "facial_animation" },
    { 0x3E06E58A, "facial_recognition_bink" },
    { 0xA3AE74FB, "facial_state_animscripted" },
    { 0xD8EF5A8E, "facial_state_combat" },
    { 0x319A5624, "facial_state_combat_aim" },
    { 0xBB07ED5E, "facial_state_combat_shoot" },
    { 0x8E8CC2AC, "facial_state_death" },
    { 0x5937E301, "facial_state_inactive" },
    { 0xD3D83A16, "facial_state_jumping" },
    { 0xCA68AB6A, "facial_state_melee" },
    { 0x5848915E, "facial_state_pain" },
    { 0x43B6A8C4, "facial_state_sliding" },
    { 0xF0590A9E, "facial_state_sprinting" },
    { 0x7566FA21, "facial_state_swimming" },
    { 0x00B02F6F, "facial_state_wallrunning" },
    { 0x93F8DEEF, "facial_system_fade_dist" },
    { 0x36AB5EFB, "facial_system_fade_distsq" },
    { 0x7432BE7A, "facialanim" },
    { 0xA6584104, "facialanimationarray" },
    { 0x4F353102, "facialanimationsinit" },
    { 0x48AF690B, "facialanimationthink" },
    { 0xA4D41FEE, "facialanimationthink_getwaittime" },
    { 0xEAAC2C92, "facialanimdone" },
    { 0xB2BD6FCE, "facialanimlength" },
    { 0x4616D711, "facialdeathanimstarted" },
    { 0x07234D7D, "facialdialogueactive" },
    { 0xC7B00089, "facialdialoguehandler" },
    { 0xE9E414CB, "facialrec_defalco_transition_start" },
    { 0x06F45131, "facialrec_menendez_transition_start" },
    { 0xC5BA1475, "facialrec_soldier_transition_start" },
    { 0x64F0A36D, "facialrecognitionui_defalco" },
    { 0x3040EE29, "facialrecognitionui_menendez" },
    { 0xC96543AE, "facialrecognitionui_militia_leader" },
    { 0x8A3BCF50, "facialrecognitionui_soldier1" },
    { 0xFC433E8B, "facialrecognitionui_soldier2" },
    { 0xD640C422, "facialrecognitionui_soldier3" },
    { 0x4848335D, "facialrecognitionui_soldier4" },
    { 0x2245B8F4, "facialrecognitionui_soldier5" },
    { 0x944D282F, "facialrecognitionui_soldier6" },
    { 0xF4D21D98, "facialrectransition" },
    { 0x75941CF4, "facials" },
    { 0x731C6CFE, "facialsoundalias" },
    { 0x3BCC9BD2, "facialsounddone" },
    { 0xE406E271, "facialsoundnotify" },
    { 0xCE65A577, "facilitate" },
    { 0xDDA0AFA6, "facility" },
    { 0xDD9EF283, "facing" },
    { 0xA86CC84B, "facing_angle" },
    { 0xB37B87AA, "facing_angles" },
    { 0x07AA0B3B, "facing_astro" },
    { 0x24850F23, "facing_diff" },
    { 0xD00A58DA, "facing_dist" },
    { 0x576DA4B1, "facing_enemy_immediately" },
    { 0x0EB44079, "facing_player" },
    { 0x3B7D83B0, "facing_same_way" },
    { 0x98B56CE0, "facing_vec" },
    { 0x331BC04C, "facing_yaw_vec" },
    { 0x6DCA59B4, "facingangle" },
    { 0x31366D0D, "facingthief" },
    { 0x9ACB4BEA, "facingvector" },
    { 0x83AD898C, "facingyaw" },
    { 0xD21C06CB, "fact" },
    { 0x1370530B, "faction" },
    { 0xEB4C286A, "factions" },
    { 0x77FFAE80, "factor" },
    { 0x43B226A3, "factor_max" },
    { 0x064E1B8D, "factor_min" },
    { 0x7A9CB0AB, "factors" },
    { 0x5EAB8F21, "factory" },
    { 0xECA363B1, "factory_assault" },
    { 0x1DABA8B7, "factory_closest_player" },
    { 0x235CB67A, "factory_custom_spawn_location_selection" },
    { 0x0A591100, "factory_cymbal_monkey_weighting_func" },
    { 0xDADB60C3, "factory_exit_level" },
    { 0xBC11BB8B, "factory_find_exit_point" },
    { 0x3B2006D2, "factory_german_safe" },
    { 0x4C48E34C, "factory_objectives" },
    { 0xC6A16CBD, "factory_playanim" },
    { 0x9AE43C6E, "factory_quadrotors" },
    { 0x408E8617, "factory_ray_gun_weighting_func" },
    { 0xF20CBE8B, "factory_validate_last_closest_player" },
    { 0xCE41565B, "factory_zone_init" },
    { 0x2EA48404, "factory_zpo_listener" },
    { 0xDC7FF543, "fade" },
    { 0x9BEDFEB8, "fade2black" },
    { 0x72D440D6, "fade_cleanup" },
    { 0xD2216113, "fade_complete" },
    { 0x9E22B035, "fade_cross_hair" },
    { 0xE3C579B9, "fade_diary_hud" },
    { 0x2253E1A3, "fade_distance" },
    { 0xC203EE82, "fade_duration" },
    { 0x464DA4E5, "fade_ent" },
    { 0x3F78C931, "fade_for_anim" },
    { 0x324DC609, "fade_fov_lerp" },
    { 0xC67C64FE, "fade_from_black" },
    { 0x230E90BD, "fade_from_black_rr" },
    { 0xDC56A9C4, "fade_from_white" },
    { 0x0A26CE1A, "fade_hint_text_after_time" },
    { 0x29832D35, "fade_hud" },
    { 0xD5B7E20B, "fade_hud_high_to_low" },
    { 0xFA719F09, "fade_hud_low_to_high" },
    { 0x207B5CCF, "fade_in" },
    { 0x3B67452B, "fade_in_black" },
    { 0x48867DAB, "fade_in_blur_time" },
    { 0xDEC47E9F, "fade_in_complete" },
    { 0x446CCD41, "fade_in_end" },
    { 0x2D8F61CA, "fade_in_start" },
    { 0xFAF66064, "fade_in_static" },
    { 0xFFAAE1EB, "fade_in_sw_extra_cam" },
    { 0xD31D40B5, "fade_in_time" },
    { 0xB062B61A, "fade_in_turret_static1" },
    { 0x8A603BB1, "fade_in_turret_static2" },
    { 0x1B172805, "fade_introblack" },
    { 0x9CBD7222, "fade_mission_complete" },
    { 0x0A6BF5D0, "fade_off_burst_intensity" },
    { 0xF39FFF1A, "fade_out" },
    { 0x96377490, "fade_out_complete" },
    { 0x2A52B980, "fade_out_end" },
    { 0x672D78CF, "fade_out_for_user_test" },
    { 0xA926E51C, "fade_out_hint_hud" },
    { 0x72343989, "fade_out_house_end" },
    { 0xF84F5E8C, "fade_out_intro_screen_zm" },
    { 0xC7F0A955, "fade_out_no_intel" },
    { 0xE494F51E, "fade_out_one_intel" },
    { 0xCB60D483, "fade_out_overlay" },
    { 0x23C79853, "fade_out_start" },
    { 0xC8F3267B, "fade_out_static" },
    { 0x64EEBCD8, "fade_out_sw_extra_cam" },
    { 0xB9B64E1E, "fade_out_time" },
    { 0x1F1C409D, "fade_out_turret_static1" },
    { 0x451EBB06, "fade_out_turret_static2" },
    { 0xADCD1A2F, "fade_out_weapon_hud" },
    { 0x9E80A4FC, "fade_over_time" },
    { 0x5386235E, "fade_overlay" },
    { 0xC66E1807, "fade_rage_high_to_low" },
    { 0xADA99465, "fade_rage_low_to_high" },
    { 0x94D92E62, "fade_screen" },
    { 0xCE2AC8D4, "fade_screen_text" },
    { 0x593604DC, "fade_shift_high_to_low" },
    { 0x0B592B66, "fade_shift_low_to_high" },
    { 0xA475E7B7, "fade_speed" },
    { 0xD504FC73, "fade_steps" },
    { 0x58A7AECC, "fade_then_kill_hud" },
    { 0x1C457231, "fade_time" },
    { 0xE787E359, "fade_to_black" },
    { 0xD53889E2, "fade_to_black_for_x_sec" },
    { 0x7DC3AD80, "fade_to_black_rr" },
    { 0x872B3895, "fade_to_black_then_back" },
    { 0x05449B8F, "fade_to_black_time" },
    { 0x4844A762, "fade_to_menendez" },
    { 0x0AF20DA6, "fade_to_white_on_death" },
    { 0x8FD93042, "fade_up_over_time" },
    { 0x6F128C32, "fade_warp_high_to_low" },
    { 0xBC5A8ABC, "fade_warp_low_to_high" },
    { 0xA3E0550E, "fade_with_shellshock_and_visionset" },
    { 0x5AB95F3D, "fadeaway" },
    { 0x919C78BA, "fadecustomgametypehudelem" },
    { 0x3966E97D, "faded" },
    { 0x42A91E4C, "fadedelay" },
    { 0x35DB4931, "fadefiretoskip" },
    { 0x2020C9AE, "fadefromwhite" },
    { 0x8376DC53, "fadefullinterval" },
    { 0xBBE24E91, "fadefunc" },
    { 0x48E3CC9E, "fadehud" },
    { 0x09C2CD76, "fadein" },
    { 0x825F847B, "fadein_fog" },
    { 0x8713BD95, "fadeinblackout" },
    { 0xBA0745F0, "fadeinfiretoskip" },
    { 0xE83A553D, "fadeiniconchild" },
    { 0x8D487D34, "fadeiniconelem" },
    { 0x9AD5CC7E, "fadeiniconelemandchildren" },
    { 0x9F6D9E10, "fadeinloop" },
    { 0xAE51FE1B, "fadeinsound" },
    { 0xBEF3C25E, "fadeinstart" },
    { 0xD27F6249, "fadeintime" },
    { 0x18C75FBE, "fademodelout" },
    { 0xFF23F8B1, "fadeout" },
    { 0xDD3A9B3C, "fadeout_duration" },
    { 0xBB139A74, "fadeout_fog" },
    { 0x261C45E9, "fadeout_skip_text" },
    { 0x7F1E53E7, "fadeout_time" },
    { 0x56370771, "fadeoutandstopsound" },
    { 0xF1BCE942, "fadeoutblackout" },
    { 0xFB870488, "fadeoutend" },
    { 0x97B1675D, "fadeoutfulltime" },
    { 0xAC705DF5, "fadeouthalftime" },
    { 0xCF1EF24B, "fadeouticonelemandchildren" },
    { 0xA3AA25CB, "fadeoutloop" },
    { 0xDB8F7B66, "fadeouttime" },
    { 0x5006E653, "fadeouttoblack" },
    { 0x842398BF, "fadeover_time" },
    { 0x10493565, "fadeoverlay" },
    { 0xBA7F003E, "fadeovertime" },
    { 0x8A28B80B, "faderevivemessageover" },
    { 0x6737D3B2, "fades" },
    { 0x3D1999DA, "fadeseconds" },
    { 0x1ABE528E, "fadestarttime" },
    { 0x164E4778, "fadetime" },
    { 0xD21903EA, "fadetime_text" },
    { 0x01B66A6A, "fadetimer" },
    { 0x2E0836F9, "fadetoblack" },
    { 0xD739DE6C, "fadetoblackandbackin" },
    { 0xCA1673D1, "fadetoblackforxsec" },
    { 0x97BC99B9, "fadetoblackrr" },
    { 0x858F5CE7, "fadetowhite" },
    { 0xCBE966FC, "fadeup" },
    { 0xC1F7A3A1, "fadevolume" },
    { 0x81610743, "fadewhentargeted" },
    { 0x2F704712, "fadewhiteout" },
    { 0x222005C6, "fading" },
    { 0x963316CC, "fadnig" },
    { 0x289FFFC1, "fail" },
    { 0xB3719931, "fail_after_log" },
    { 0xC4E3CE4A, "fail_after_log_action" },
    { 0xCF69711E, "fail_animation" },
    { 0x9B07A565, "fail_beach" },
    { 0x61F7C7B6, "fail_beach_action" },
    { 0x641A7A97, "fail_beach_enemy_logic" },
    { 0x74CFA7FE, "fail_before_log" },
    { 0x7544AC6F, "fail_before_log_action" },
    { 0x926C88A6, "fail_before_log_timeout" },
    { 0x474E6B0A, "fail_bomberpass" },
    { 0x705CF8FB, "fail_by_fake_spotted" },
    { 0x1D2D3C73, "fail_by_firing" },
    { 0x8F8F24AD, "fail_by_grenade_throw" },
    { 0xD45B755B, "fail_by_hut_patroller" },
    { 0x1090F539, "fail_by_spotted" },
    { 0x25E27125, "fail_callback" },
    { 0x136EF377, "fail_child_guards" },
    { 0xECF48427, "fail_condition_all_enemies_dead" },
    { 0x4B31B289, "fail_count" },
    { 0x27EEA0C7, "fail_delay_time" },
    { 0x913FA0DC, "fail_disabled" },
    { 0xC9DB7604, "fail_dist" },
    { 0x102A122C, "fail_gate_watcher" },
    { 0x01E8C29D, "fail_ground_tolerance" },
    { 0x8DCD14B1, "fail_hacking_object" },
    { 0xD4D61A6F, "fail_hint" },
    { 0xFA8122C8, "fail_if_damage_waiter" },
    { 0xAFB436D5, "fail_if_friendlies_in_line_of_fire" },
    { 0x3A31238F, "fail_if_killed_by_player" },
    { 0xF5A254E3, "fail_igc" },
    { 0x2AF643E7, "fail_left" },
    { 0xB5C65ED1, "fail_limo_crash" },
    { 0xB004060A, "fail_line" },
    { 0x3DDC4911, "fail_message" },
    { 0xA097EFF8, "fail_messages" },
    { 0x5737094A, "fail_mission_delay" },
    { 0xA72E5F63, "fail_mission_flag" },
    { 0xCF6A9C0D, "fail_mission_if_not_in_crouch_cover" },
    { 0x09FD7A57, "fail_mission_if_player_visible" },
    { 0x25E55190, "fail_mission_if_stealth_broken" },
    { 0x50DC0309, "fail_mission_on_flag_carrier_death" },
    { 0x856C9841, "fail_mortar_run" },
    { 0x662078CA, "fail_msg_index_key" },
    { 0xB6F2C758, "fail_node" },
    { 0x3BE5B8AD, "fail_notetrack" },
    { 0xA95C9751, "fail_on_damage" },
    { 0x9491849E, "fail_on_ff" },
    { 0xA60DBE4A, "fail_on_friendly_fire" },
    { 0x8F1EEA13, "fail_player" },
    { 0xCECE90D3, "fail_player_for_going_back_to_village" },
    { 0xF6C00357, "fail_player_for_leaving_hudson_and_woods_wave_1" },
    { 0x84B8941C, "fail_player_for_leaving_hudson_and_woods_wave_2" },
    { 0x748321C2, "fail_player_for_moving_to_escape_early" },
    { 0xC9A96164, "fail_player_for_not_jumping" },
    { 0xF3C70829, "fail_player_if_cover_not_taken_inside_house" },
    { 0x461C9417, "fail_player_if_he_backtracks" },
    { 0x51190D75, "fail_player_if_not_exit_house" },
    { 0xFBC68030, "fail_player_if_not_in_house" },
    { 0xD32F49E2, "fail_right" },
    { 0xF86EBBBB, "fail_safe" },
    { 0xFD90ACEC, "fail_scene" },
    { 0xB6268F3D, "fail_skit" },
    { 0x463EAD65, "fail_speed" },
    { 0xCB8C8F24, "fail_takeoff" },
    { 0x8BCA97D4, "fail_tank" },
    { 0xF5097A3D, "fail_threshold" },
    { 0x52CC3517, "fail_time" },
    { 0x942CA825, "fail_timeout" },
    { 0xC5C5BE5B, "fail_to_black" },
    { 0x43418D72, "fail_trig" },
    { 0x2700DF10, "fail_trigger" },
    { 0x488E3BFB, "fail_triggers" },
    { 0x2E184999, "fail_valley" },
    { 0x7765BCE2, "fail_valley_action" },
    { 0x14FCA8C0, "fail_warning" },
    { 0x9E47711C, "fail_watcher" },
    { 0xEA4D2300, "fail_watcher_notetrack" },
    { 0x47D961AE, "failed" },
    { 0x0B4B9DDA, "failed2enter" },
    { 0x1CA5D02E, "failed_activate" },
    { 0xA82A23E8, "failed_cash_back_prones" },
    { 0x4AABA242, "failed_charge_next_melee_time" },
    { 0xB8D774C0, "failed_init_next_melee_time" },
    { 0x1156F946, "failed_melee_mbs" },
    { 0xE673907D, "failed_revives" },
    { 0xE4ED1451, "failed_standard_next_melee_time" },
    { 0xBFED803B, "failed_to_pursue" },
    { 0xA139CA09, "failed_to_pursue_timer" },
    { 0xEB539716, "failed_to_pursue_trigger" },
    { 0x3A81EC53, "failedachievement" },
    { 0xC4D01A99, "faileddistancecheck" },
    { 0x1AA6D707, "failing" },
    { 0xA068F823, "failingmission" },
    { 0x71587974, "failinig" },
    { 0xED68BEB2, "faillines" },
    { 0x04031636, "failmissionforengaging" },
    { 0x830819AC, "failondeath" },
    { 0xDB7F174E, "failonlast" },
    { 0x226139E8, "fails" },
    { 0xA7D64832, "failsafe" },
    { 0x09D6B4DD, "failsafe_debug_stop" },
    { 0x29C90AE5, "failsafe_for_ambush" },
    { 0xB24E0B2D, "failsafe_harper_rooftop" },
    { 0x11275952, "failsafe_interrupt" },
    { 0xF807C05B, "failsafe_pad_poi_clean" },
    { 0x012FAE26, "failsafe_reenable_offhand_special" },
    { 0xEC9A829E, "failsafe_revive_give_back_weapons" },
    { 0x10254396, "failsafe_time" },
    { 0x255EE424, "failsafe_time_s" },
    { 0x539CFB52, "failsafe_timeout" },
    { 0xD4CE6D79, "failsafe_waittime" },
    { 0xE22985BD, "failsafes" },
    { 0x4F61A335, "failsafetimer" },
    { 0xB8217916, "failtime" },
    { 0x4D32BD28, "failtime_sec" },
    { 0x0C2A7375, "failure" },
    { 0x3A1EF711, "failure_flags" },
    { 0x65930D27, "failure_hud_elem" },
    { 0xE0F8992A, "failurecount" },
    { 0xEF1DE836, "failurelimit" },
    { 0x09555E44, "failures" },
    { 0x7C73645F, "fair" },
    { 0x97DDB790, "fair_grenade_trigger_think" },
    { 0x05B4EA40, "fair_patroller_think" },
    { 0x97DFDC24, "fair_spawner_seeks_player" },
    { 0x9FB6B5C4, "fairbanks" },
    { 0xF14C42CE, "fairbattle_autosave" },
    { 0xBF4F1052, "fairbattle_detected" },
    { 0x2D75BC92, "fairbattle_high_intensity" },
    { 0x910CF9C4, "fairground_air_war" },
    { 0x8D313AD3, "fairground_battle" },
    { 0xEBBEE782, "fairground_chopper_spawners" },
    { 0xAE5C0C0F, "fairground_enemies" },
    { 0x5D0CCD72, "fairground_keep_player_out_of_pool" },
    { 0xF7309E87, "fairground_patrollers" },
    { 0xEBCB5610, "fairgrounds_after_prep" },
    { 0x6E5FE11A, "fairgrounds_before_battle" },
    { 0x18A4DBCD, "fairgrounds_wait_until_player_is_ready" },
    { 0xC7C78602, "fairly" },
    { 0x9812AD01, "faisel" },
    { 0x40408873, "faith" },
    { 0xD55AE5BA, "fake" },
    { 0x4B6AFA15, "fake_aft_board" },
    { 0x084A0F6F, "fake_anim_loop" },
    { 0x1499B79B, "fake_anim_loop_solo" },
    { 0x099F6BC0, "fake_arms" },
    { 0x5803E7B6, "fake_arms_door_open" },
    { 0x3F85E218, "fake_battle_loop" },
    { 0xC8AA6243, "fake_betty" },
    { 0x7CD286FA, "fake_bike" },
    { 0xF3E2D731, "fake_blister_gunners" },
    { 0x0BC07F10, "fake_blister_gunners_cleanup" },
    { 0x13FB7552, "fake_boats" },
    { 0x3E134EE1, "fake_body" },
    { 0xCA799695, "fake_buffel" },
    { 0x8BEE9CCD, "fake_building_collapse" },
    { 0xB9112189, "fake_bullet" },
    { 0xCBDACD80, "fake_bullets" },
    { 0xC37F1F5D, "fake_case" },
    { 0x44B5BE83, "fake_chopper_ammo" },
    { 0xF780AA58, "fake_combat_sounds" },
    { 0xB690AEE4, "fake_conversation" },
    { 0xEFFA48C8, "fake_corpses" },
    { 0x0124EA26, "fake_damage" },
    { 0x026E5138, "fake_damage_state" },
    { 0x4433B565, "fake_death" },
    { 0x1E6FE883, "fake_defalco" },
    { 0xE8A444EB, "fake_destination" },
    { 0xA9D3FDF9, "fake_destructible_blue_bowl" },
    { 0xCDF79370, "fake_ent" },
    { 0x5A09E6A7, "fake_ent_plane" },
    { 0x6B5ED41E, "fake_ent_planes" },
    { 0xAC3A5BC9, "fake_f35" },
    { 0xC488A6ED, "fake_fire" },
    { 0xE0215467, "fake_fire_front_player" },
    { 0x58F74286, "fake_fire_origin" },
    { 0x5132B40F, "fake_fire_player" },
    { 0x3A04CDB6, "fake_flash_me" },
    { 0xDCD9C605, "fake_goal_radius" },
    { 0x6956D08A, "fake_grenade_guy_damage_think" },
    { 0xB8723F21, "fake_grenade_toss" },
    { 0xF39621CA, "fake_ground_ent" },
    { 0xEDF684ED, "fake_gun" },
    { 0x3BFFE96B, "fake_head" },
    { 0x2BC88D3F, "fake_health" },
    { 0x7B963E15, "fake_heli_snd" },
    { 0x164F76C4, "fake_housing_barge_damage" },
    { 0x3F356BDA, "fake_huey_loops" },
    { 0x41DA3361, "fake_huey_sounds" },
    { 0x17A741ED, "fake_intro" },
    { 0x6ACFBB3A, "fake_intro_helis_flyby" },
    { 0x28E9D5BB, "fake_kill_player" },
    { 0x445D5356, "fake_killed" },
    { 0xADE0CB14, "fake_launch" },
    { 0x6C81CD82, "fake_launch_claw" },
    { 0x4CDACF48, "fake_lighting_cleanup" },
    { 0x32B81A66, "fake_linkto" },
    { 0x02B998AC, "fake_location" },
    { 0x3F55E050, "fake_lvt_guys_anim" },
    { 0x69A806FA, "fake_m202" },
    { 0x58851A1D, "fake_mason" },
    { 0x798C5E90, "fake_meat" },
    { 0x01739C45, "fake_mg" },
    { 0x3F769CD6, "fake_mg_audio" },
    { 0x5704ED14, "fake_mg_fire" },
    { 0xBBCFEAD4, "fake_mgs" },
    { 0x0A3D66EF, "fake_missile" },
    { 0xBAC52F70, "fake_model" },
    { 0x9D04BDE9, "fake_molotov" },
    { 0xCD3D97BE, "fake_molotov_tossed" },
    { 0xD03A157A, "fake_mortar" },
    { 0xD84738A9, "fake_mortar_sounds" },
    { 0x34B104D3, "fake_motion" },
    { 0x28CADD68, "fake_muzzleflash" },
    { 0x1D9DF2D6, "fake_notetrack" },
    { 0xC4934AD6, "fake_orig" },
    { 0x3E6F178D, "fake_orig_2" },
    { 0xCCD13667, "fake_origin" },
    { 0xAE770262, "fake_physics_launch" },
    { 0x56DC9AC9, "fake_physics_vehicle_launch" },
    { 0xC74ED6D1, "fake_physicslaunch" },
    { 0x45BC73E0, "fake_pieces" },
    { 0xC43B00FB, "fake_plane_part" },
    { 0xB2A6CA26, "fake_player" },
    { 0xF11F8EED, "fake_player_body" },
    { 0x4D76AA55, "fake_player_hands" },
    { 0xE1DC9171, "fake_player_hands_1" },
    { 0x07DF0BDA, "fake_player_hands_2" },
    { 0x280EE780, "fake_position" },
    { 0xA59CE5C0, "fake_ppsh" },
    { 0xE27995C2, "fake_ppsh2" },
    { 0x438FE022, "fake_radiation" },
    { 0x16DC3C08, "fake_rage_ai_damage_override" },
    { 0xFE534775, "fake_reich_mg_trigs" },
    { 0x355A590E, "fake_revive" },
    { 0x1801D4E7, "fake_rider_delete" },
    { 0x1F31C60E, "fake_rpg" },
    { 0x06628DD1, "fake_rpg_fire" },
    { 0xFACC636D, "fake_rpg_shot" },
    { 0xB7EBDE9A, "fake_rpg_struct" },
    { 0x345009EE, "fake_rusalka" },
    { 0xAFB431F3, "fake_rush" },
    { 0xBC54267F, "fake_sdk" },
    { 0x58E4E7D1, "fake_shots_init" },
    { 0xD638385E, "fake_side_barge_damage" },
    { 0x7480C2F0, "fake_slide_heli_krav" },
    { 0x3EC4D240, "fake_slide_heli_woods" },
    { 0x4DC08F11, "fake_slide_krav" },
    { 0xC2A72B4F, "fake_slide_woods" },
    { 0x81136C8F, "fake_smoke_audio" },
    { 0xEA6CB2FB, "fake_sound_fade" },
    { 0x54C8A28F, "fake_splash_audio" },
    { 0xF05CC4AD, "fake_spotlight_movement" },
    { 0x42B6094E, "fake_stealth" },
    { 0x5DC57E40, "fake_stealth_spotted" },
    { 0x8C6B0F3D, "fake_suppressedbehavior" },
    { 0x7BBB852C, "fake_surrender_guys" },
    { 0x4B124923, "fake_tag" },
    { 0xF579B4AC, "fake_tag_destroy" },
    { 0x282B57C2, "fake_target" },
    { 0x7B16470F, "fake_teleport_done" },
    { 0xF7B2D8AC, "fake_throw_molotov" },
    { 0x9A7A41E3, "fake_time_warp" },
    { 0x595F34DA, "fake_tracer" },
    { 0x547B3E47, "fake_turret" },
    { 0xDD92F786, "fake_use" },
    { 0x212D66E9, "fake_vehicle_deleted" },
    { 0x0770073D, "fake_wait_node" },
    { 0x6E5B0B9B, "fake_water_tread" },
    { 0x7A078DB9, "fake_weapon" },
    { 0x71EAAB63, "fake_weapon_powerup_thread" },
    { 0x4DCCFD98, "fake_weapon_powerup_timeout" },
    { 0xE107F690, "fakeaa_fire_chase" },
    { 0x799C97A4, "fakeai" },
    { 0xFF36B036, "fakeailogic" },
    { 0x0024AB4B, "fakearms" },
    { 0xB07CEF16, "fakebomb" },
    { 0x09117C67, "fakeclassname" },
    { 0x40FBA18A, "faked" },
    { 0x3A7EA645, "fakedamagefrom" },
    { 0x660FF284, "fakedeath" },
    { 0x34AA6AB3, "fakedrones" },
    { 0x98B08C7A, "fakedualwieldshooting" },
    { 0xE400B256, "fakeenemy" },
    { 0x36649ED1, "fakeent" },
    { 0x6BDA7C4A, "fakeent1" },
    { 0x45D801E1, "fakeent2" },
    { 0x1FD58778, "fakeent3" },
    { 0x29E6E057, "fakeent4" },
    { 0x03E465EE, "fakeent5" },
    { 0x23FC1535, "fakeeye" },
    { 0x172D3F46, "fakefire" },
    { 0x975B141F, "fakefire_max_range" },
    { 0xBFCAAA10, "fakefire_max_range_sqr" },
    { 0x38A2739B, "fakefire_max_shots" },
    { 0x37BCC562, "fakefire_max_wait_duration" },
    { 0x761A8D19, "fakefire_min_shots" },
    { 0x08A356A0, "fakefire_min_wait_duration" },
    { 0x8D948442, "fakefire_move_target" },
    { 0x1C21A057, "fakefire_on_runningcivs" },
    { 0xFE1D3D05, "fakefire_thread" },
    { 0x2985CF66, "fakefireweapon" },
    { 0x95BD7884, "fakegun" },
    { 0x4E711BEA, "fakehero" },
    { 0xB9E255FC, "fakehero2" },
    { 0xC68E6222, "fakelag" },
    { 0x7AED5BA6, "fakelink_failsafe" },
    { 0xFC5AC9F1, "fakelinkto" },
    { 0xEBA9B631, "fakemodel" },
    { 0xCF85B924, "fakemotorcade" },
    { 0x14702678, "fakeorigin" },
    { 0x546C4D56, "fakeout_donotetracks_animscripts" },
    { 0x948A8133, "fakeowner" },
    { 0x09C2AC0F, "fakepistolweaponanims" },
    { 0xD742CEC5, "fakeplayer" },
    { 0x339D656F, "fakeplayer_setup" },
    { 0xAC2A7180, "fakeramp_endnode" },
    { 0x9E6AD19F, "fakeramp_startnode" },
    { 0x9BA37989, "fakeredshirt" },
    { 0x5DD46A38, "fakerifle" },
    { 0x8EB37073, "fakerpg" },
    { 0x129AA859, "fakerpm" },
    { 0x52DB6A35, "fakes" },
    { 0xB2FE62C8, "fakeself" },
    { 0x517C9415, "fakeshooters" },
    { 0x134415A2, "fakeshoters" },
    { 0x6482520A, "fakespawnpoints" },
    { 0x1C535EAD, "fakespirit" },
    { 0x9D388E1D, "faketarget" },
    { 0xB8564875, "faketarget_stop_moving" },
    { 0xFA144784, "faketargetent" },
    { 0x67205784, "faketimevalue" },
    { 0xB4A66C27, "fakeveh" },
    { 0xE7F64166, "fakevehicle" },
    { 0x1217803A, "fakey_dude" },
    { 0xA21665A6, "fakey_dude_damage" },
    { 0x2BC216CB, "faking" },
    { 0x18CA425A, "falce" },
    { 0x6FFA4E0A, "fall" },
    { 0xF84BD14B, "fall_and_bounce" },
    { 0xD4E739BF, "fall_and_hang" },
    { 0xCC322D5E, "fall_anim" },
    { 0xBDE12B2B, "fall_anim_finished" },
    { 0xF7FCA74C, "fall_back_and_delete" },
    { 0x1136389C, "fall_back_to_defensive_position" },
    { 0xB2D5627D, "fall_back_to_stairs" },
    { 0xD80714F6, "fall_damage" },
    { 0xBBED9BCD, "fall_damage_dirt_duration" },
    { 0xE684D8E9, "fall_damage_fade_time" },
    { 0x16F6C635, "fall_death" },
    { 0x679A169B, "fall_destruction" },
    { 0x854001E9, "fall_dist" },
    { 0xB2E1C0CD, "fall_down" },
    { 0xD1876DB6, "fall_down_to_bleed" },
    { 0xD1D680B0, "fall_in" },
    { 0x580DA9D3, "fall_in_dialog" },
    { 0x7611C39F, "fall_locations" },
    { 0x7AA95883, "fall_loop" },
    { 0xA96CC6CC, "fall_out_of_world" },
    { 0xB841ECC9, "fall_pos" },
    { 0xB205EC23, "fall_splat" },
    { 0x62511C33, "fall_tag" },
    { 0xEB84DFEE, "fall_time" },
    { 0x824C3859, "fall_to_bed_crossfade" },
    { 0x71F9AD75, "fall_to_death" },
    { 0x104646F5, "fallanim" },
    { 0x641392AD, "fallanimstatedef" },
    { 0x748DB797, "fallback" },
    { 0x05D4B3A4, "fallback initiated " },
    { 0xBD260C57, "fallback_430" },
    { 0x20207AE5, "fallback_add_previous_group" },
    { 0x2B3B637C, "fallback_ai" },
    { 0x856D632D, "fallback_ai_think" },
    { 0xD849C7A6, "fallback_ai_think_death" },
    { 0x253431E5, "fallback_arrived" },
    { 0xC3780FB0, "fallback_behavior" },
    { 0x03DEA55E, "fallback_clear_death" },
    { 0xDCFFD6E1, "fallback_clear_goal" },
    { 0xBE520072, "fallback_cleared" },
    { 0xC75BA888, "fallback_coverprint" },
    { 0x82718FAC, "fallback_death" },
    { 0x5028FCF1, "fallback_firstspawn" },
    { 0x1DB74D4B, "fallback_goal" },
    { 0x1AE79A61, "fallback_initiated" },
    { 0xE8C32F3B, "fallback_interrupt" },
    { 0xC9A9BBE8, "fallback_monitor" },
    { 0xB1254026, "fallback_node" },
    { 0x7EB70F59, "fallback_nodes" },
    { 0x9A8699FA, "fallback_nodes_targetname" },
    { 0x0E916A39, "fallback_notify" },
    { 0x2A0643BA, "fallback_num" },
    { 0xC8A47BF2, "fallback_occupied" },
    { 0xF1C26076, "fallback_on_ai_count" },
    { 0x64F3E104, "fallback_overmind" },
    { 0x76FF3FE4, "fallback_overmind_internal" },
    { 0x8917BC13, "fallback_planters" },
    { 0xF5F82783, "fallback_print" },
    { 0xEF1A6A6E, "fallback_reached_goal" },
    { 0xF721F94F, "fallback_ready" },
    { 0x33F74B77, "fallback_spawner_think" },
    { 0xB9121C7F, "fallback_text" },
    { 0x49BA1BAE, "fallback_think" },
    { 0x9056F52F, "fallback_trigger_targetname" },
    { 0xCB08E221, "fallback_wait" },
    { 0xD8D14352, "fallback_weapon" },
    { 0x92FAD920, "fallback_weapon_name" },
    { 0x604B95FF, "fallbacker_died" },
    { 0xC6228147, "fallbacker_trigger" },
    { 0xFE847C75, "fallbackers" },
    { 0x72C5CBE7, "fallblend" },
    { 0x1B0249B7, "fallcow" },
    { 0x1FBAB856, "falldist" },
    { 0x57EE63BA, "falldude" },
    { 0xFBF2B2B7, "fallen" },
    { 0x62DC7FE6, "fallen_building" },
    { 0x1DC668E9, "fallen_left" },
    { 0xCCE91894, "fallen_right" },
    { 0xD3AD4F3B, "faller" },
    { 0xC3B8A871, "faller_anim" },
    { 0x92638FCC, "faller_attack_01_time" },
    { 0xA98BC3D1, "faller_attack_02_time" },
    { 0x547C38B0, "faller_death_ragdoll" },
    { 0x0FF2464A, "faller_dist_sq_visible" },
    { 0xD6136365, "faller_drop" },
    { 0x5049E503, "faller_emerge_time" },
    { 0xC16B47B3, "faller_fall_time" },
    { 0x11B27D68, "faller_init" },
    { 0x6DB518C8, "faller_location_logic" },
    { 0x64B3B23D, "faller_on_ground" },
    { 0x342DE866, "faller_script_parameters" },
    { 0x0E15092F, "faller_spawn_points" },
    { 0x84C54CCA, "fallerceilingdeath" },
    { 0xACE3AB7E, "fallerdropaction" },
    { 0x847E3D27, "fallerdropactionterminate" },
    { 0xC8069639, "fallerdropactionupdate" },
    { 0xFAFDDADA, "fallers" },
    { 0x3092678D, "fallguy_left" },
    { 0xBBBB7CB0, "fallguy_right" },
    { 0x907CB066, "falling" },
    { 0x5A60D109, "falling_boards_audio" },
    { 0x18D218B6, "falling_ceiling" },
    { 0xCFD2D6D1, "falling_death" },
    { 0x2B667BAA, "falling_death_init" },
    { 0x74FB8848, "falling_debris" },
    { 0x874F3C5B, "falling_debris_audio" },
    { 0xB3BCD7F3, "falling_eagle" },
    { 0xC9579A6E, "falling_eagle_director" },
    { 0x1101471E, "falling_ice" },
    { 0xBDF5D6D4, "falling_light_trig" },
    { 0x4F83D0E1, "falling_to_death" },
    { 0x20AD86D7, "falling_tower_anims" },
    { 0x1D8E05F1, "falling_tree" },
    { 0xBA095552, "falling_tree_anims" },
    { 0xC69AB90B, "falling_tree_model" },
    { 0x79DC5B59, "fallingdebris_drop" },
    { 0x55929BD6, "fallingdebris_think" },
    { 0x91D8CA12, "fallingsign_detache" },
    { 0x45D3D540, "fallingsign_detachg" },
    { 0x9BEA22F1, "fallingsign_detachn" },
    { 0x5E2EA23A, "fallingsign_dialogue" },
    { 0x0320048C, "fallingsign_letter_detachfx" },
    { 0x4608923B, "fallingsign_letters" },
    { 0xACBF410F, "fallingsign_rumble" },
    { 0xE5D4B71F, "falllocation" },
    { 0x107FF1D1, "falloff" },
    { 0xFD8B2C36, "fallout" },
    { 0x384A8164, "falloutfx" },
    { 0xCC1BED45, "falls" },
    { 0xAB51B2DA, "fallstart" },
    { 0xD7C77205, "falltime" },
    { 0x2921D92A, "false" },
    { 0x7405D32E, "false_flags" },
    { 0x9C44D8DA, "false_on" },
    { 0xB974B6E0, "false_value" },
    { 0x5E098EE3, "falter" },
    { 0xFFD7A074, "falure" },
    { 0xFE974123, "famas" },
    { 0xEA333B4D, "famhouse" },
    { 0x614DA270, "familiar" },
    { 0xA3647426, "familiar_face_started" },
    { 0x842FBB05, "family" },
    { 0xE83772CD, "famount" },
    { 0x395A55D0, "fan" },
    { 0xDF855E2C, "fan_1" },
    { 0x518CCD67, "fan_2" },
    { 0x5DE14BBA, "fan_array" },
    { 0x8AC1BD7F, "fan_death" },
    { 0xEA782809, "fan_ents" },
    { 0xA1932CEA, "fan_trap_damage" },
    { 0xF1953B9B, "fan_trap_finished" },
    { 0x46D39D6F, "fan_trap_fxanims" },
    { 0xDACE8141, "fan_trap_move_switch" },
    { 0xCB2F944A, "fan_trap_rumble" },
    { 0xA2E9B7FF, "fan_trap_rumble_think" },
    { 0x279479DB, "fan_trap_think" },
    { 0x8BF46456, "fan_trap_timeout" },
    { 0x40077DD1, "fan_traps" },
    { 0x74E8F190, "fanatical" },
    { 0x20DD2CD5, "fancier" },
    { 0x0DE6A190, "fancy" },
    { 0xC8BA9783, "fandango" },
    { 0x1C5C342E, "fangle" },
    { 0xEA26F7BB, "fans" },
    { 0x546EB43C, "fans_chamber" },
    { 0x03A39222, "fans_chamber_off" },
    { 0x6F7E8014, "fans_chamber_on" },
    { 0x6F302C53, "fans_room" },
    { 0xCDDF74B5, "fans_room_off" },
    { 0x06835009, "fans_room_on" },
    { 0xA1506C2C, "far" },
    { 0x389A4DDC, "far_blur" },
    { 0x4133DE40, "far_blur_1" },
    { 0xB33B4D7B, "far_blur_2" },
    { 0x41EC5AAF, "far_dist" },
    { 0x9A9309F2, "far_end" },
    { 0x17E1B5BA, "far_end_1" },
    { 0xF1DF3B51, "far_end_2" },
    { 0xE7C6D607, "far_enough" },
    { 0x65BF7539, "far_grass_array" },
    { 0x8D887A80, "far_guard_wait_for_end" },
    { 0x9EC71C5F, "far_guard_wait_for_throw" },
    { 0x8194517D, "far_look_node" },
    { 0x7214F701, "far_min" },
    { 0xEB2B397D, "far_points_dist" },
    { 0x3DDE1C98, "far_right_ai_retreat" },
    { 0xB1CB81A9, "far_start" },
    { 0x5573D25D, "far_start_1" },
    { 0x7B764CC6, "far_start_2" },
    { 0x76B6B3AC, "far_struct" },
    { 0xC034E315, "far_trig" },
    { 0xE4B6A707, "farblur" },
    { 0x774B04E9, "farboats" },
    { 0xDE56317C, "fardist" },
    { 0xABCE2F1B, "farend" },
    { 0x5B28A10D, "farengagementdist" },
    { 0x1919708B, "farid" },
    { 0x5A4DF001, "farid_body_shot" },
    { 0xBB8AA8B5, "farid_call_dialog" },
    { 0xF6909F06, "farid_comm" },
    { 0xFDEAF71F, "farid_comm_one" },
    { 0x94BB405E, "farid_shot" },
    { 0xCB0C8226, "farid_shot_duck" },
    { 0xA0F041F7, "farid_undercover_damage_callback" },
    { 0xEE64C05C, "faring" },
    { 0x6F61BD84, "farish" },
    { 0x9BF5FA71, "farm" },
    { 0x075AF4A3, "farm_clear" },
    { 0x16927C7A, "farm_clear_enemies" },
    { 0xA85F4D88, "farm_color_trigger" },
    { 0x79A64C69, "farm_complete" },
    { 0x6085BED4, "farm_defenders" },
    { 0x635AE39E, "farm_dialogue" },
    { 0xEAA57089, "farm_dog_spawn_function" },
    { 0xBB6FF07D, "farm_dogs" },
    { 0x8D143D11, "farm_dogs_delete" },
    { 0xDB4EBD1A, "farm_enemies_timer" },
    { 0xC5772597, "farm_forerunners" },
    { 0x67AC1B8A, "farm_javelin_nag" },
    { 0x1DCF0AC2, "farm_porch_exploit" },
    { 0xDF1F21D8, "farm_push" },
    { 0x52EADD52, "farm_reached" },
    { 0x0F865A5D, "farm_rpg_guy_attacks_bm21s" },
    { 0x25996210, "farm_rpg_spawner" },
    { 0xC2262696, "farm_treasure_chest_init" },
    { 0x67610938, "farmer" },
    { 0x3D1D7EEB, "farmgirl" },
    { 0x5A246657, "farmhouse_defender" },
    { 0xA4F43863, "farmtrig" },
    { 0x95F91AFF, "farp_autoland_print_on" },
    { 0xB748F777, "farpicon" },
    { 0x79815671, "farpoints" },
    { 0x4B39D1EA, "farpos" },
    { 0xA5948BC8, "farspawns" },
    { 0xCDC87B78, "farstart" },
    { 0x5F3FD92D, "farther" },
    { 0xAF24C787, "fartherfunc" },
    { 0x68093898, "farthest" },
    { 0x6BAB441B, "farthest_dist" },
    { 0x499DB6C7, "farthest_node" },
    { 0xC5E27E80, "fascist" },
    { 0x16AA20AB, "fascists" },
    { 0x249EB97B, "fast" },
    { 0x381CD8F3, "fast_complete_spider_bot" },
    { 0x1E254358, "fast_flash_color" },
    { 0x46C9159C, "fast_flash_time" },
    { 0xA685880F, "fast_forward_begin" },
    { 0x8949320F, "fast_forward_end" },
    { 0x39743ABC, "fast_forward_heroes" },
    { 0xD45118B3, "fast_reload_on" },
    { 0x73DA475F, "fast_reset" },
    { 0x11A2E696, "fast_spawn_trigger" },
    { 0xEFCE1376, "fast_sprint" },
    { 0x829C9043, "fastbeepduration" },
    { 0x5480DD87, "fastburst" },
    { 0xB4DF183C, "fastburstfirenumshots" },
    { 0x3E7B2DED, "fastcrouch" },
    { 0xB170C4D6, "faster" },
    { 0xF1D99A39, "fastest" },
    { 0x886ED31F, "fastestrepeatwait" },
    { 0x7EDCB0D0, "fastestruncheckpointtimes" },
    { 0x09315AAD, "fastfile" },
    { 0xE79BC337, "fastfire" },
    { 0xC80A3EFF, "fasthands" },
    { 0xE2F5C977, "fastlink" },
    { 0x55F5C726, "fastlook" },
    { 0x655029EB, "fastmags" },
    { 0x51832D10, "fastrestart" },
    { 0xF5EB5D33, "fastrope" },
    { 0x6A584B81, "fastrope_ai_think" },
    { 0xA601A36F, "fastrope_ai_think_hack" },
    { 0x33235CF9, "fastrope_animload" },
    { 0xCA9408F4, "fastrope_animload_heli" },
    { 0x8B949FAB, "fastrope_animload_player" },
    { 0xADEF1EB8, "fastrope_animname" },
    { 0x2E138CCF, "fastrope_attach_helicopter" },
    { 0xBFEE26CD, "fastrope_calc" },
    { 0x706401B9, "fastrope_createseat" },
    { 0x6DDCF616, "fastrope_down" },
    { 0xC50E5B41, "fastrope_find_seat" },
    { 0x4B39CD60, "fastrope_free_seat" },
    { 0x00849E09, "fastrope_get_heli" },
    { 0xC99CD12E, "fastrope_getindex" },
    { 0xE00F13CF, "fastrope_getside" },
    { 0x941ACC62, "fastrope_getspin" },
    { 0x33B885C6, "fastrope_globals" },
    { 0xA6B89028, "fastrope_grab" },
    { 0xA478C31E, "fastrope_guys_spawn" },
    { 0x17AABCB3, "fastrope_heli_cleanup" },
    { 0x9AA2A234, "fastrope_heli_fly" },
    { 0x3904AE00, "fastrope_heli_fly_sea" },
    { 0xA1CB607A, "fastrope_heli_overtake" },
    { 0xD2D08E27, "fastrope_heli_overtake_now" },
    { 0x02763A41, "fastrope_heli_playexteriorlightfx" },
    { 0x057E8F73, "fastrope_heli_playinteriorlightfx" },
    { 0x0519204B, "fastrope_heli_playinteriorlightfx2" },
    { 0xBCA515A8, "fastrope_heli_setup" },
    { 0x4E818A33, "fastrope_heli_setup_seats" },
    { 0xB435B503, "fastrope_heli_waittill_unload" },
    { 0xC3CCB46B, "fastrope_heliname" },
    { 0x937700B0, "fastrope_helo" },
    { 0x46C40199, "fastrope_land" },
    { 0x5632CE96, "fastrope_override" },
    { 0x2FFDCAE7, "fastrope_override_vehicle" },
    { 0xCC3866EB, "fastrope_player_attach" },
    { 0x1F1AABBF, "fastrope_player_quake" },
    { 0x5F94FB4C, "fastrope_player_think" },
    { 0xBAEB91FD, "fastrope_player_unload" },
    { 0xED84C7F5, "fastrope_player_unload_lock" },
    { 0xA459D6F8, "fastrope_player_unload_nolock" },
    { 0x9D4AB6AA, "fastrope_player_unload_nolock2" },
    { 0x59D6D4DD, "fastrope_player_viewshift" },
    { 0xF7E2B315, "fastrope_player_viewshift_lock" },
    { 0xC8C7BE18, "fastrope_player_viewshift_nolock" },
    { 0x96EC284A, "fastrope_player_viewshift_nolock2" },
    { 0xB2E2B74A, "fastrope_post_unload" },
    { 0x29C5BDBD, "fastrope_pre_unload" },
    { 0x1D520A85, "fastrope_precache" },
    { 0x3C56917C, "fastrope_que_check" },
    { 0x52D33443, "fastrope_resetlighting" },
    { 0xFCCCA95D, "fastrope_ropeanimload" },
    { 0x2032EC66, "fastrope_ropethink" },
    { 0xB037A92D, "fastrope_seat" },
    { 0x60049275, "fastrope_setup" },
    { 0xAD3C749B, "fastrope_spawner_think" },
    { 0x16C47BA9, "fastrope_vtol" },
    { 0x85EA4E5F, "fastrope_wait_que" },
    { 0x709AB9BA, "fastrope_waiton_helicopter" },
    { 0xA599CD5A, "fastropeoffset" },
    { 0x6F4B20AA, "fastropers" },
    { 0xA1EFACB6, "fastroping" },
    { 0x1562EF49, "fastsprintfunc" },
    { 0x38D93D45, "faststand" },
    { 0x3C987015, "fastsweep" },
    { 0x554B775A, "fat" },
    { 0x5D7F4509, "fatal" },
    { 0x551A5D2F, "fatal_damage_location" },
    { 0x5B9DEE6C, "fatal_shot" },
    { 0x7C61AC53, "fatal_triggers" },
    { 0x5536B381, "fatalimpactrate" },
    { 0x863AD1D4, "fatally" },
    { 0xECD78C13, "fate" },
    { 0xC423496E, "fate1_msg" },
    { 0xB46ACD55, "fate2_msg" },
    { 0x66BCDE34, "fate3_msg" },
    { 0x321F7133, "fate4_msg" },
    { 0xCB7E0A61, "fate_cb" },
    { 0x7E636E95, "fate_fortune" },
    { 0x2CD6028B, "fate_of_firepower" },
    { 0x1E168157, "fate_of_fortune" },
    { 0x3F501FDA, "fate_of_friendship" },
    { 0x7CD77306, "fate_of_furious_feet" },
    { 0x99A3DC7C, "fate_shot_orb" },
    { 0x7C518913, "fate_show_msg" },
    { 0x214EC5C5, "fate_title1" },
    { 0x4751402E, "fate_title2" },
    { 0x09131DD1, "fate_triggers" },
    { 0xC34952ED, "fated" },
    { 0xE0C4EFC7, "fated_active_idle" },
    { 0x565ACA86, "fated_double_shot_update" },
    { 0x5EFFB8DD, "fates_have_been_chosen" },
    { 0x2D91E5CB, "fatguy" },
    { 0x39A77E8F, "father" },
    { 0xB921F105, "fault_vo_interval" },
    { 0x8F0E1BF3, "faultdeath" },
    { 0xBD929A4A, "faults" },
    { 0xABDC79A1, "faultsmodel" },
    { 0x4179D230, "faulty" },
    { 0xEF8DAA11, "faux" },
    { 0x16FFA513, "fav_weapon" },
    { 0xAE3E72BF, "favor" },
    { 0x1BA79947, "favor_blindfire" },
    { 0xEC094F76, "favor_lean" },
    { 0x8ACCA3E6, "favor_suppressedbehavior" },
    { 0xF7FFC22F, "favorable" },
    { 0x6D59B608, "favorblindfire" },
    { 0xE458FCA9, "favorclosespawnent" },
    { 0x0294573A, "favorclosespawnscalar" },
    { 0xF3D99BC4, "favored" },
    { 0xA8071538, "favoredspawnpoints" },
    { 0x93A4141D, "favorite" },
    { 0x78436F04, "favorite_enemy" },
    { 0x1E2573E1, "favorite_level_weapon" },
    { 0x79A066E0, "favorite_level_weaponname" },
    { 0x3C63F0B5, "favorite_wall_weapons_list" },
    { 0xE4DD588C, "favorite_weapon" },
    { 0x0E13E56D, "favorite_weaponname" },
    { 0xC6DEDAB7, "favoriteenemy" },
    { 0xBC6DA944, "favoritespots" },
    { 0xF95A1E9B, "favorrpgagainstenemy" },
    { 0xD311910A, "favourateenemy" },
    { 0xDB635892, "favouriteenemy" },
    { 0xC7E87710, "fbarragedelay" },
    { 0x768C6A9F, "fbl" },
    { 0xC09CC6CA, "fblockfraction" },
    { 0x22B90601, "fbr" },
    { 0xAA3B8EB7, "fbsoff" },
    { 0xB53823C8, "fc" },
    { 0xC52D4E77, "fc_node" },
    { 0x09446E0E, "fc_noteworthy" },
    { 0x81678AB9, "fc_trigger" },
    { 0xDF220A88, "fc_trigs" },
    { 0x7E49756A, "fconeanglecos" },
    { 0x622E03E3, "fcs" },
    { 0xEE909BBF, "fcuntion" },
    { 0x7E1AEEDE, "fdelay" },
    { 0x77219565, "fdeu" },
    { 0x6315C442, "fdin" },
    { 0x48AD96F1, "fdist" },
    { 0x021CF8EC, "fdistance" },
    { 0x6681DFC2, "fdo" },
    { 0xE753C6D2, "fdot" },
    { 0x6E06CDBB, "fear" },
    { 0xFD7CCC30, "feared" },
    { 0x28AFAD5E, "fearless_challenge" },
    { 0x75DFFE5A, "fears" },
    { 0x449E5E0E, "feasting" },
    { 0x631AAEFD, "feathers" },
    { 0x0B30A0C9, "feature" },
    { 0x35988F07, "feature_cac" },
    { 0x7EBAEEB2, "featureless" },
    { 0x54AD53C0, "features" },
    { 0x7DB17A28, "feb" },
    { 0x5E2F4B57, "february" },
    { 0x61C0589E, "fed" },
    { 0xE6F79781, "feed" },
    { 0xD742CFFC, "feedback" },
    { 0x60578AAD, "feedback1" },
    { 0x865A0516, "feedback2" },
    { 0xAC5C7F7F, "feedback3" },
    { 0xA581A589, "feedfacialrec" },
    { 0x878251A8, "feeds" },
    { 0xB6E3C439, "feel" },
    { 0x2F7CC04F, "feeling" },
    { 0x509C0470, "feels" },
    { 0x86CFF0F1, "feet" },
    { 0xC4D1A52F, "feet_dry" },
    { 0x9D44F72B, "feidt" },
    { 0x2FFF0F14, "feign" },
    { 0x4EB157DE, "feign2" },
    { 0xA1A09988, "feign_1" },
    { 0x610892B5, "feign_enemy" },
    { 0x82EFA68F, "feign_interrupted" },
    { 0x7C8A1C54, "feigning" },
    { 0x91A18AAE, "fell" },
    { 0xDDF33751, "fell_down" },
    { 0xFCCD69FB, "fell_while_sliding" },
    { 0xE6DAD3F4, "felloffthemap" },
    { 0x9E8549D8, "fellow" },
    { 0x016610D6, "felt" },
    { 0xEC1BA2CD, "female" },
    { 0x13E2921C, "female_ghost_spawner" },
    { 0xF7357650, "female_override" },
    { 0xE6506B83, "female_percent" },
    { 0x4D96EDEC, "female_perk" },
    { 0x720AF16C, "female_spawner" },
    { 0x734AD625, "femalebundle" },
    { 0xEB401A4C, "females" },
    { 0x6EB38F38, "fence" },
    { 0xBCD60DFE, "fence01_clip" },
    { 0x02BFB952, "fence1_nag" },
    { 0x2E415098, "fence_break" },
    { 0x1973AE8E, "fence_climb" },
    { 0x9299D6D7, "fence_climber" },
    { 0x087257A0, "fence_cut_node" },
    { 0x9A5F45FF, "fenceclimb" },
    { 0x87B13526, "fencedog" },
    { 0x1AB120C2, "fencemetal1" },
    { 0x31D0AEC8, "fend" },
    { 0xA3D81E03, "feng" },
    { 0x0E57D4ED, "fense_start" },
    { 0x42FADB4F, "fense_start_spawners" },
    { 0x0A61D8BD, "fense_to_base_handler" },
    { 0xD097EBE6, "ferris" },
    { 0x5E9DF30B, "fetch" },
    { 0x7B0789F3, "fetch_buildable_action" },
    { 0xA22C205C, "fetch_buildable_condition" },
    { 0x03FF8B4A, "fetch_buildable_interrupt" },
    { 0x8FF5F9F3, "fetch_buildable_start" },
    { 0x5E81D440, "fetched" },
    { 0x27F37C55, "fetching" },
    { 0xBEFA0059, "fever" },
    { 0x9BE584C5, "few" },
    { 0xD7AC0614, "fewer" },
    { 0x5F214ED3, "fewest" },
    { 0xE82BB61A, "fexplosionduration" },
    { 0x734487D5, "ff" },
    { 0x96150309, "ff5555" },
    { 0x64F2C3C2, "ff_kill_penalty" },
    { 0xE2F17286, "ffa" },
    { 0xB882A685, "ffadeintime" },
    { 0x47961E1C, "ffadetime" },
    { 0xF71104F1, "ffadetimein" },
    { 0x702D5B28, "ffadetimeout" },
    { 0x5B131C69, "ffateam" },
    { 0x70EA034B, "ffd" },
    { 0x24E50E79, "fff" },
    { 0xD2218645, "ffffff" },
    { 0xC3381A90, "ffotd" },
    { 0x9E352461, "ffotd_melee_miss_func" },
    { 0x7EB957F2, "ffotd_player_threads" },
    { 0xBE731F01, "ffotd_zombie_init_done" },
    { 0xB380E67B, "ffotds" },
    { 0xCDD4501C, "ffpoints" },
    { 0x36C4D724, "ffs" },
    { 0x8EDCF892, "fg42" },
    { 0x77F17085, "fgetarg" },
    { 0xF59A892E, "fgmonitor" },
    { 0x3BDD91C9, "fgtext" },
    { 0xABE3F757, "fibre" },
    { 0xD7E4B0FE, "fiche_stick_x_value" },
    { 0x46B5FF8F, "fiche_stick_y_value" },
    { 0x0D699C8C, "fiche_zoom_value" },
    { 0x28B64496, "fiddling" },
    { 0xABEE6A59, "fidgets" },
    { 0x7204BE63, "field" },
    { 0xA426EB03, "field_a" },
    { 0xC4334844, "field_allies" },
    { 0x7FBEE5BD, "field_axis" },
    { 0x321F7BC8, "field_b" },
    { 0x97F79BEB, "field_backup_line_clear" },
    { 0x7DD8D10C, "field_backup_truck" },
    { 0x504C7B51, "field_basement" },
    { 0x91C4C36C, "field_basement_door" },
    { 0x57F43188, "field_basement_door_sound" },
    { 0x55ED3482, "field_basement_nag" },
    { 0xFF08A4CD, "field_begin" },
    { 0x140C778B, "field_begin_planes_end" },
    { 0x3E3F1C1C, "field_bmp1" },
    { 0xB0468B57, "field_bmp2" },
    { 0x8A4410EE, "field_bmp3" },
    { 0xCC37ACE1, "field_bmp4" },
    { 0x316578FE, "field_bmp_make_followme" },
    { 0x3822DAE5, "field_bmp_quake" },
    { 0xAD1213E5, "field_bmps_stop" },
    { 0xC8C3EC4F, "field_clean_up" },
    { 0x1FFBFED8, "field_color_chain_start" },
    { 0x0790BBA5, "field_creep" },
    { 0x5D2F1732, "field_creep_dialogue" },
    { 0xFD1E34E7, "field_creep_player" },
    { 0x402F501B, "field_creep_player_calc_movement" },
    { 0xC9FA6BC2, "field_creep_player_cleanup" },
    { 0xE86173B3, "field_cutting_it_close" },
    { 0xA2B35AD2, "field_damage_state_handler" },
    { 0x29E4E6A6, "field_death_spawn_dynents" },
    { 0x757C21D1, "field_dialgue" },
    { 0x0331A074, "field_do_deathfx" },
    { 0x7898779A, "field_do_empdeathfx" },
    { 0xA8A702D1, "field_do_standarddeathfx" },
    { 0xE15533D5, "field_endmission" },
    { 0x4423D2EA, "field_enemy_alert_level_1" },
    { 0x1E215881, "field_enemy_alert_level_2" },
    { 0xAD9AB51C, "field_enemy_awareness" },
    { 0x0CEF6A8D, "field_enemy_death" },
    { 0x2E7430E2, "field_enemy_patrol_thread" },
    { 0x170BA584, "field_enemy_patrol_thread2" },
    { 0xB0D30FC7, "field_enemy_think" },
    { 0x4ECFD767, "field_enemy_think2" },
    { 0x811B0D91, "field_enemy_walk_behind_bmp" },
    { 0xA129C468, "field_fallback" },
    { 0x051F733B, "field_fire_guards" },
    { 0x1F72A9BA, "field_flyby_speed" },
    { 0xBD86206A, "field_getdown" },
    { 0xA3259C76, "field_gib_spawn_dynents" },
    { 0x1BAAFB33, "field_guard_spawners" },
    { 0x0C67C990, "field_guards" },
    { 0x98B83775, "field_handle_cleanup" },
    { 0xF321FEED, "field_handle_cleanup2" },
    { 0x1DBE639C, "field_handle_enemys" },
    { 0x0DD48EF8, "field_handle_flags" },
    { 0xDC56B3F4, "field_handle_price_spotted" },
    { 0xABE694AA, "field_handle_special_nodes" },
    { 0xB1AF0DA3, "field_handle_special_nodes_jog" },
    { 0x8ADABBBD, "field_helicopter" },
    { 0xC1260158, "field_helicopter_spot" },
    { 0xC6E91AE0, "field_init" },
    { 0x1DBF8829, "field_jumpto_hero_init" },
    { 0x22292464, "field_line_1" },
    { 0x9430939F, "field_line_2" },
    { 0xC05EC801, "field_loading_line_clear" },
    { 0xD5608CE8, "field_loading_truck_goal_volumes" },
    { 0x34B6AD8A, "field_loading_truck_spawn" },
    { 0xAEF61919, "field_main" },
    { 0x413495BD, "field_meeting" },
    { 0xBCE009D6, "field_moveup" },
    { 0x3ED22DA0, "field_moveup2" },
    { 0x36044DA3, "field_name" },
    { 0x9EDB7296, "field_open" },
    { 0x3382AD30, "field_org" },
    { 0x8E48BF63, "field_pacing_guards" },
    { 0xAC4334F2, "field_player_skipto" },
    { 0x8D9EE72F, "field_player_way_ahead" },
    { 0xD466EB74, "field_price_done" },
    { 0x3D7EC732, "field_prone_goal" },
    { 0x3F735068, "field_road" },
    { 0xD2EBE98E, "field_russian_dialogue_1" },
    { 0xACE96F25, "field_russian_dialogue_2" },
    { 0xE1182724, "field_russian_think" },
    { 0x9CCC7518, "field_russians" },
    { 0x3BEE0FA7, "field_russians_go_up_hill" },
    { 0x22F8702C, "field_second_backup_truck_death" },
    { 0xE0584A5B, "field_second_backup_truck_unload" },
    { 0x259AEF37, "field_set_lighting_ent" },
    { 0x69FE5263, "field_spawn" },
    { 0x33EE7C21, "field_spawners" },
    { 0x145B9181, "field_spoted" },
    { 0x77761E26, "field_squad_behave" },
    { 0xAB4DF801, "field_squad_landing_dialogue" },
    { 0x0A16026F, "field_squad_moves_in" },
    { 0xDA110E8C, "field_stay_down" },
    { 0x805F7AD9, "field_stop_bmps" },
    { 0x9B93F633, "field_teleport_vehicles_jumpto" },
    { 0xBD0A5ED1, "field_toggle_ambient_anim_handler1" },
    { 0xE30CD93A, "field_toggle_ambient_anim_handler2" },
    { 0x090F53A3, "field_toggle_ambient_anim_handler3" },
    { 0x2F11CE0C, "field_toggle_ambient_anim_handler4" },
    { 0xFDD6061A, "field_toggle_burn" },
    { 0xAFB272A9, "field_toggle_dnidamagefx" },
    { 0x76A86769, "field_toggle_emp" },
    { 0xBB617896, "field_toggle_exhaustfx_handler" },
    { 0x61B1074E, "field_toggle_gas_freeze" },
    { 0x06EBA53B, "field_toggle_hack_handler" },
    { 0xE7209115, "field_toggle_keyline_handler" },
    { 0x11A8F6E7, "field_toggle_lensflare" },
    { 0xDDFFB130, "field_toggle_lights_group_handler1" },
    { 0x5007206B, "field_toggle_lights_group_handler2" },
    { 0x2A04A602, "field_toggle_lights_group_handler3" },
    { 0x9C0C153D, "field_toggle_lights_group_handler4" },
    { 0xDB208247, "field_toggle_lights_handler" },
    { 0x4B9F6D8E, "field_toggle_lockon_handler" },
    { 0x0523B4B9, "field_toggle_retrievable_handler" },
    { 0x5B756B95, "field_toggle_sounds" },
    { 0x4B1B830D, "field_toggle_treadfx" },
    { 0xA4FC412C, "field_toggle_unplaceable_handler" },
    { 0xD721E00F, "field_truck" },
    { 0xFFFD7BD4, "field_truck_guards" },
    { 0xF03D1165, "field_update_alert_level" },
    { 0x44B84CE9, "field_update_damage_state" },
    { 0x5FDBF5FB, "field_use_engine_damage_sounds" },
    { 0xCB412BA8, "field_use_lighting_ent" },
    { 0x1E4C4069, "field_value" },
    { 0xF26F1347, "field_waittill_player_near_price" },
    { 0x4A1FD8E8, "field_waittill_player_passed_guards" },
    { 0xA0FBD278, "field_working_guards" },
    { 0x7F86519E, "fieldname" },
    { 0x6564A252, "fields" },
    { 0x501EBF93, "fields_equal" },
    { 0x1A82ADDA, "fieldvalue" },
    { 0x3DB824E8, "fiery" },
    { 0x08DE9747, "fifo" },
    { 0x388C7BB4, "fifteen" },
    { 0x878684D4, "fifth" },
    { 0x4D6158AD, "fifty" },
    { 0x2C1E9761, "fighitng" },
    { 0x8C89259D, "fight" },
    { 0x00E5659D, "fight_across_the_gap_until_the_enemies_die" },
    { 0x93FB5511, "fight_distance" },
    { 0x33102889, "fight_drones" },
    { 0xD1C94F76, "fight_in_bp" },
    { 0x577C06C4, "fight_index" },
    { 0xC48AD9A6, "fight_looping" },
    { 0xCC2057F4, "fight_node" },
    { 0xC667B9E4, "fight_the_mg" },
    { 0x77F057A5, "fight_to_compound" },
    { 0xD13BFDAD, "fight_to_isaac_main" },
    { 0x87AD5E5D, "fight_until_price_has_no_target" },
    { 0xB718CD26, "fight_uphill" },
    { 0xEA587E69, "fight_uphill_done" },
    { 0x932C58AA, "fight_uphill_starts_early" },
    { 0xF221A7EF, "fight_volume_0" },
    { 0xCC1F2D86, "fight_volume_1" },
    { 0xB4FC7203, "fight_waitfor_ch1" },
    { 0x42F502C8, "fight_waitfor_ch2" },
    { 0x68F77D31, "fight_waitfor_ch3" },
    { 0x2703E13E, "fight_waitfor_ch4" },
    { 0xA6A18D9D, "fightdist" },
    { 0xB3D48D81, "fightdone" },
    { 0x88ED128C, "fighter" },
    { 0x2B13FB0F, "fighters" },
    { 0xC7654A8B, "fighting" },
    { 0x8E398A74, "fighting_withdrawl" },
    { 0x3B8D4D7D, "fightnode" },
    { 0x07F454DC, "fights" },
    { 0x25D1BC0D, "figure" },
    { 0x4B4BF300, "figure_days_amount" },
    { 0x5CDF8F76, "figure_out_attacker" },
    { 0xADCDF849, "figure_out_friendly_fire" },
    { 0xF00B2ED0, "figure_out_gametype_friendly_fire" },
    { 0x3DD1D1B3, "figured" },
    { 0x15231AC6, "figureoutattacker" },
    { 0x71D31062, "figureoutfriendlyfire" },
    { 0x8822C584, "figureoutgametypefriendlyfire" },
    { 0x406AB9B7, "figureoutweapon" },
    { 0xDB16A372, "figureoutwinningteam" },
    { 0x03ACA58C, "figures" },
    { 0xB7BA13B8, "figuring" },
    { 0x51166293, "file" },
    { 0x390FA8D4, "file_error" },
    { 0x1234FE6D, "filed" },
    { 0x6741050E, "filename" },
    { 0x8723BB3D, "filenum" },
    { 0x067696C4, "fileprint" },
    { 0x36C64811, "fileprint_chk" },
    { 0x17BDC2CA, "fileprint_end" },
    { 0x959B694A, "fileprint_entitystart" },
    { 0xB18E9764, "fileprint_filename" },
    { 0xD6ADEB69, "fileprint_map_entity_end" },
    { 0x0EFE6442, "fileprint_map_entity_start" },
    { 0x32D09EAD, "fileprint_map_header" },
    { 0xEDAF1FC4, "fileprint_map_keypairprint" },
    { 0x2B5034BA, "fileprint_map_start" },
    { 0x47ADB7E3, "fileprint_mapentcount" },
    { 0x08FA095F, "fileprint_radiant_vec" },
    { 0x7C90E8D1, "fileprint_start" },
    { 0xE00904D7, "fileprintlinecount" },
    { 0x005535C2, "files" },
    { 0x97993416, "filing" },
    { 0xFB0014E2, "fill" },
    { 0xCAD875B2, "fill_balanced_teams" },
    { 0x2734B5FD, "fill_current_clip" },
    { 0x383C9566, "fill_huey_with_script_models" },
    { 0x27722869, "fill_left_side_spawner" },
    { 0x7BBE1878, "fill_model" },
    { 0x3D190EAB, "fill_step" },
    { 0x134CD900, "fill_theater_left" },
    { 0x517D346F, "fill_theater_right" },
    { 0x387B8859, "fillattempt" },
    { 0x31F712A1, "fillcenter" },
    { 0xF0F05DF5, "filled" },
    { 0x05130FB3, "filler" },
    { 0xF53DF062, "fillers" },
    { 0xC7A45ECE, "filling" },
    { 0xBCA771AD, "fills" },
    { 0x0B90CD91, "fillup" },
    { 0x21028F4B, "film" },
    { 0x5295A384, "film_grain_init" },
    { 0x0B2B0490, "filmy" },
    { 0x62F62B3E, "filp" },
    { 0x3D5DE9EB, "filter" },
    { 0x82267398, "filter_bots" },
    { 0xC68DBB3B, "filter_classname" },
    { 0x3228E2E1, "filter_deleted" },
    { 0x90070F36, "filter_dt" },
    { 0x769D6522, "filter_effect_damage_amount" },
    { 0x3E8D7E57, "filter_fade_in_rate" },
    { 0x58DFF8E2, "filter_fade_in_time" },
    { 0x629AE11A, "filter_fade_out_rate" },
    { 0xBBCA51F7, "filter_fade_out_time" },
    { 0xA39F5ECC, "filter_func" },
    { 0xAB4ED07D, "filter_id" },
    { 0x5CBBB002, "filter_index" },
    { 0xA5A3E3FF, "filter_index_blood" },
    { 0x2E3B39B9, "filter_index_bonuszm" },
    { 0xE8C2BC2E, "filter_index_dirt" },
    { 0xC60B5FC5, "filter_index_drown" },
    { 0x854D8CFD, "filter_index_emp" },
    { 0x29C1CE5C, "filter_index_environment" },
    { 0xD99F94C9, "filter_index_gadget" },
    { 0xC7860793, "filter_index_oob" },
    { 0x6AB77A91, "filter_index_overdrive" },
    { 0x4EC7E5E5, "filter_index_player_shock" },
    { 0x7368754D, "filter_index_speed_burst" },
    { 0x9D2F65BB, "filter_index_vehicle" },
    { 0x34651BB3, "filter_index_vision_pulse" },
    { 0x313CFFDE, "filter_index_water_mist" },
    { 0xDB4DD846, "filter_index_water_sheet" },
    { 0x1F9F361D, "filter_matcount" },
    { 0x6EE9A5C7, "filter_matid" },
    { 0x047FD726, "filter_nag_vo" },
    { 0x342CF95B, "filter_out_names" },
    { 0xA0FD282B, "filter_player_respawns" },
    { 0xF5554002, "filter_script_vehicles_from_vehicle_descriptors" },
    { 0xB93AC825, "filter_shared" },
    { 0xE31260DB, "filter_vo_callout_ai" },
    { 0x2A596920, "filtered" },
    { 0x311275ED, "filteredpoints" },
    { 0x8DEA34C0, "filtergroup" },
    { 0xE6FE3AA4, "filterid" },
    { 0xF8918CB4, "filterid_condensation" },
    { 0x31AE96E1, "filterid_warp" },
    { 0x6E2EA7B5, "filtering" },
    { 0x4BB210CA, "filters" },
    { 0x644433CD, "filterset" },
    { 0x73E2EB57, "filterslot" },
    { 0x2B38E8EE, "filterthreats" },
    { 0x9C26BF46, "filth" },
    { 0x8C4F2813, "filthy" },
    { 0xB8A4AD03, "filtration" },
    { 0xA24C6208, "fin" },
    { 0x7671B2AF, "final" },
    { 0x985E03B8, "final_airstrike_called" },
    { 0x09086B9F, "final_angle" },
    { 0x9D1C3F26, "final_angles" },
    { 0xA3BF5B69, "final_anim_then_run_off" },
    { 0xCB2A7F90, "final_approach_started" },
    { 0xDD40289A, "final_banzai_charge" },
    { 0xBA6A6582, "final_barrage" },
    { 0x43E8F49C, "final_battle" },
    { 0xA88EEB6F, "final_battle_dialog" },
    { 0xA6AD2EA4, "final_battle_reveal" },
    { 0xDD63413A, "final_battle_vo" },
    { 0x654F72C5, "final_bldg_fired_upon" },
    { 0x7087606C, "final_blink" },
    { 0x82E001AD, "final_breach" },
    { 0x3E1070CE, "final_breach_shotgun" },
    { 0x457C4A6B, "final_breacher_right" },
    { 0x646821FA, "final_breacher_right_think" },
    { 0x425A6E93, "final_breacher_shotgun" },
    { 0x83340F52, "final_breacher_shotgun_think" },
    { 0x01771F44, "final_cloud_fog" },
    { 0xBFBC3C2C, "final_combined_score" },
    { 0x1BDCAA71, "final_damage" },
    { 0x04B8FE22, "final_dest" },
    { 0x0E2EF6E6, "final_destination" },
    { 0xA62ED02F, "final_dir" },
    { 0x430EAF86, "final_dist" },
    { 0x24F22D2B, "final_effect_ent" },
    { 0xC97E7879, "final_explode" },
    { 0x53F40343, "final_explosion" },
    { 0x0D7D0A51, "final_fall" },
    { 0x29F4A9BA, "final_flicker" },
    { 0x0FBB2D00, "final_flight_activated" },
    { 0x6483E2BF, "final_flight_player_thread" },
    { 0xA8D31A6F, "final_flight_players" },
    { 0xC460346E, "final_flight_setup" },
    { 0x807AC54D, "final_flight_trigger" },
    { 0x3ACCBE2B, "final_fov" },
    { 0x1A88CEC3, "final_goal" },
    { 0x4CC1952C, "final_grenade" },
    { 0x9E1F0787, "final_griggs" },
    { 0xA9072247, "final_heli_clip" },
    { 0x814331C1, "final_husk_cleanup_t" },
    { 0x4A20EF53, "final_killcam" },
    { 0x9127CA46, "final_killcam_done" },
    { 0x7D5F6485, "final_killcam_internal" },
    { 0x2F9D143C, "final_killcam_waiter" },
    { 0x9A9C7E21, "final_obj" },
    { 0xFBFD7885, "final_opacity" },
    { 0xFEE37578, "final_origin" },
    { 0xAA7F584C, "final_pos" },
    { 0x34A5839D, "final_price" },
    { 0xB3B48FF9, "final_push_anims" },
    { 0x98FC1517, "final_push_cleanup" },
    { 0x718CCCEB, "final_push_start_vo" },
    { 0x4801CF28, "final_push_vo" },
    { 0x2AC44896, "final_render" },
    { 0xE7803AAF, "final_retreat" },
    { 0xBB8E9DC3, "final_roll" },
    { 0xF063F82F, "final_room" },
    { 0x44CD9BA1, "final_room_obj" },
    { 0xDDAE523D, "final_scene_nag" },
    { 0xE72E1190, "final_scene_vo" },
    { 0x287F01E4, "final_score" },
    { 0xC95ADF84, "final_showdown_create_icon" },
    { 0x3E9BCE83, "final_showdown_track_team" },
    { 0x65742403, "final_showdown_track_weasel" },
    { 0x58E568D5, "final_showdown_update_icon" },
    { 0xBBB0DE91, "final_showdown_zombie_logic" },
    { 0x187F7BD3, "final_speed" },
    { 0xA723704A, "final_stair_pos" },
    { 0xE41E879A, "final_stand_wait" },
    { 0x28510530, "final_street_skydemon_strafe" },
    { 0xF9688B87, "final_struc" },
    { 0xEEB16271, "final_struct" },
    { 0xDF7047D8, "final_structs" },
    { 0x87ABDD1D, "final_target" },
    { 0xD1648355, "final_time" },
    { 0x4D1C07CD, "final_time_bonus" },
    { 0x67BA76D7, "final_time_sec" },
    { 0x653CFCB2, "final_trigger" },
    { 0x1E417AEF, "final_turn" },
    { 0xDE93C6FA, "final_wolf_complete_vo" },
    { 0x0C79521C, "finalaccuracy" },
    { 0x3CBBADD3, "finalangles" },
    { 0x725A9AC0, "finalanim" },
    { 0x9D11CB90, "finaldamage" },
    { 0x61A05607, "finaldeath" },
    { 0x7D0ACBDF, "finaldest" },
    { 0x05889A38, "finaldif" },
    { 0x912BBD3E, "finaldiff" },
    { 0x48B9D056, "finaldistance" },
    { 0x2501FE10, "finale" },
    { 0xD005988B, "finale_airmada_start_vo" },
    { 0xCBA27393, "finale_explosions" },
    { 0x139EEFC8, "finale_heli_spawn_func" },
    { 0x0D3DE66E, "finale_helis" },
    { 0xC39C45BF, "finale_loc" },
    { 0x1FA9C287, "finale_plane" },
    { 0x0DAD0041, "finale_player_clip" },
    { 0xB0BDD339, "finale_shake_rumble" },
    { 0xBC143230, "finale_uber_awesome_phantoms" },
    { 0x8A5B3F9B, "finalexitpos" },
    { 0x3A71BEAC, "finalgameend" },
    { 0xE276DA6E, "finalgenericdialog" },
    { 0xBD95F91A, "finalhelideathexplode" },
    { 0x9E765C32, "finaliize" },
    { 0x1DBFBFC1, "finalindex" },
    { 0x3DDBB801, "finalization" },
    { 0xDA8E82E7, "finalize" },
    { 0xCDA32664, "finalize_clientfields" },
    { 0xC3FE1DC4, "finalize_game" },
    { 0x4066DADE, "finalize_initialization" },
    { 0x42C84BBA, "finalize_round" },
    { 0x3A4B1CEB, "finalize_spawnpoint_choice" },
    { 0x35CD80FB, "finalize_type_clientfields" },
    { 0xF145E759, "finalizeclientfields" },
    { 0x5436B900, "finalizecratecategory" },
    { 0x9CFEDAE1, "finalized" },
    { 0xDB4939D1, "finalizematchrecord" },
    { 0x678A5282, "finalizenodechoice" },
    { 0x0A3E0BAF, "finalizespawnpointchoice" },
    { 0xDD4FD279, "finalizewagergame" },
    { 0xD5C19825, "finalizewagerround" },
    { 0x6A1E7AAB, "finalkill" },
    { 0x9B58C640, "finalkillcam" },
    { 0x0184B03A, "finalkillcam_winner" },
    { 0x9081043A, "finalkillcam_winnerpicked" },
    { 0x2F562355, "finalkillcamkiller" },
    { 0x20ACBA97, "finalkillcamsettings" },
    { 0x04E3B78E, "finalkillcamwaiter" },
    { 0x11B1FF72, "finally" },
    { 0x60CFDBC7, "finalnode" },
    { 0x9A0B5966, "finalpositionyawoffset" },
    { 0x10EC741C, "finaltime" },
    { 0xBA2F02E8, "finalyaw" },
    { 0xFEFF83A7, "finalz" },
    { 0x4BE4E237, "finalzdest" },
    { 0x5DF8EF1C, "find" },
    { 0xB2A4D2F3, "find_a_new_turret_spot" },
    { 0x74271FFC, "find_ai_for_classtype" },
    { 0xCA1A9D1D, "find_alternate_player_place" },
    { 0xC749B3F8, "find_another" },
    { 0xCB9D5EE7, "find_bench" },
    { 0x157229DE, "find_best_drone_triggers" },
    { 0x158116C6, "find_best_zone" },
    { 0xB31651A2, "find_box_center" },
    { 0x00FBF9E8, "find_buildable_stub" },
    { 0x66FDDC89, "find_bunker_tunnel" },
    { 0x3623027F, "find_child_soldiers" },
    { 0x0EEDA85E, "find_classtype_for_ai" },
    { 0x71C4A863, "find_classtype_for_player" },
    { 0x2D897B7C, "find_closer_enemy" },
    { 0xD12FEC6C, "find_closest_target_to_view" },
    { 0x533E92A8, "find_connected_turrets" },
    { 0xC70B0BC4, "find_cover" },
    { 0xCC197006, "find_craftable_stub" },
    { 0x6BB46ACF, "find_dds_category_by_name" },
    { 0xA2C388D8, "find_debris_model" },
    { 0x689B5DCC, "find_destructibles" },
    { 0x43E2B864, "find_different_way_to_attack_last_seen_position" },
    { 0xE126042E, "find_dr_filter" },
    { 0xC1272F9D, "find_enemy" },
    { 0xE0053FE4, "find_exit_bus" },
    { 0x40B60944, "find_exit_loc" },
    { 0x5D89F354, "find_exit_point" },
    { 0xD41A63E5, "find_farthest_retreat_point" },
    { 0x1239265B, "find_flesh" },
    { 0xD1E7A490, "find_flesh_dog" },
    { 0x003E8A33, "find_flesh_struct_string" },
    { 0x62782CA4, "find_free_slot" },
    { 0x46B6212E, "find_furthest" },
    { 0xCBA338C2, "find_good_ambush_spot" },
    { 0x25F2D6C5, "find_ground_pos" },
    { 0xFF99CFD2, "find_hackable_object" },
    { 0x5D1B6A42, "find_halfway_point" },
    { 0x48A201E4, "find_melee_weapon" },
    { 0xC1A069B4, "find_menendez_dialog" },
    { 0xABBA0A8B, "find_menendez_main" },
    { 0xA77F14F9, "find_metro_climber" },
    { 0x810B60A3, "find_missile_fire_at_target_the_player_is_looking_at" },
    { 0x73D3D350, "find_my_guys" },
    { 0xB1244147, "find_nearest" },
    { 0x6F6E0A4D, "find_new_enemy_if_blocked" },
    { 0x3C83498D, "find_new_enemy_immediately" },
    { 0x82CB74A5, "find_new_gump" },
    { 0x5A2FE36B, "find_next_open_position" },
    { 0x03E83FBA, "find_nodes" },
    { 0x0A688C5A, "find_out_about_enemies" },
    { 0x8C0D8733, "find_perk" },
    { 0x40BCC100, "find_portal_destination" },
    { 0x84784F54, "find_remote_weapon" },
    { 0x12FD235F, "find_slot_by_ref" },
    { 0x87C37B3F, "find_spot_funcs" },
    { 0xCB9DBF67, "find_steiner" },
    { 0xFAA929EC, "find_target" },
    { 0xC5081C0A, "find_target_after_getout" },
    { 0x35B6CA58, "find_unclaimed_node" },
    { 0xFE65CE02, "find_vehicle_node_on_chain_by_script_noteworthy" },
    { 0xD2D12F9F, "find_woods" },
    { 0xFAFE6292, "findalltriggers" },
    { 0xCF8A9B67, "findambushnodes" },
    { 0x832411D1, "findanimbyname" },
    { 0x4A189F31, "findaveragepoint" },
    { 0x42784DCD, "findaveragepointvec" },
    { 0x6D6BDFA6, "findbestchopperwaypoint" },
    { 0x8A4BA3DB, "findbestcovernode" },
    { 0x96DBACFA, "findbestcovernodes" },
    { 0x8AEC1719, "findbestsplittime" },
    { 0x2633F9C5, "findbody_guy_foundbody" },
    { 0x3BD45B52, "findbody_guy_setup" },
    { 0x09DD5384, "findboxcenter" },
    { 0xC2C5B9E7, "findclosestnavmeshpositiontoenemy" },
    { 0x77F32481, "findcovernearself" },
    { 0x575F410D, "findcovernode" },
    { 0x0DAF64FB, "findcovernodeatlocation" },
    { 0xAABCEF9E, "findcqbpointsofinterest" },
    { 0x703B2D25, "finddefaultpackage" },
    { 0xBD43BFC2, "finddefaultroom" },
    { 0xE894EF1E, "findgoodsuppressspot" },
    { 0x99BE1563, "findguytoyellat" },
    { 0x48AE28F0, "findhighestpriorityambientpackage" },
    { 0x89F820B9, "findhighestpriorityambientroom" },
    { 0x32F5956C, "finding" },
    { 0xE589B5C5, "finding_woods_anim" },
    { 0x82E587AE, "finding_woods_lighting_anim" },
    { 0x74271C4E, "findingcqbpointsofinterest" },
    { 0xBAEB80C6, "findinitnode" },
    { 0xDAFF192A, "findnewnode" },
    { 0x4796E657, "findnewposition" },
    { 0x5EEF1EB8, "findnodesservice" },
    { 0x04A26559, "findpath" },
    { 0xC6D8B7FE, "findpathresult" },
    { 0x5485E3E3, "findreacquiredirectpath" },
    { 0xD8F22A29, "findreacquirenode" },
    { 0x18E10FA5, "findreacquireproximatepath" },
    { 0xDBD24A5F, "finds" },
    { 0x7BC2381C, "findshufflecovernode" },
    { 0x16769D01, "findspawnerscript" },
    { 0xA51E1A37, "findstaticmodelindex" },
    { 0xAFCCF10F, "findstring" },
    { 0x5206851F, "findstruct" },
    { 0x9F0D75FF, "findwoodsroom" },
    { 0xC5DF504D, "findwoodssequence" },
    { 0xF6F18CB6, "findwoodssnapshot" },
    { 0xD0A559B6, "findzombieenemy" },
    { 0x83FB6985, "fine" },
    { 0x946857A8, "finest" },
    { 0xF1AD11BA, "finger" },
    { 0xB39D08C7, "finger1" },
    { 0xE836AE35, "fingers" },
    { 0x91F528F4, "fingy" },
    { 0xBF1224D8, "finish" },
    { 0x6F1E0900, "finish_anim" },
    { 0x7F110851, "finish_background_vehicles" },
    { 0x2B4F1BD8, "finish_burn" },
    { 0x06FEBAA4, "finish_cache_animation" },
    { 0x986B1829, "finish_combined_score" },
    { 0x024DC9C7, "finish_contextual_melee" },
    { 0xDDCE1C40, "finish_corner" },
    { 0x4709C958, "finish_crafting_shared_piece" },
    { 0xBB819CCC, "finish_creating_entity" },
    { 0x49EC7271, "finish_event1_objectives" },
    { 0x4A68E0E8, "finish_event2_objectives" },
    { 0x483A6E4F, "finish_event3_objectives" },
    { 0xAD711009, "finish_event_1" },
    { 0xD3738A72, "finish_event_2" },
    { 0xF97604DB, "finish_event_3" },
    { 0x2E32DEAE, "finish_hill" },
    { 0x73144975, "finish_line" },
    { 0xBCA98B2C, "finish_on_last_guy_death" },
    { 0xE8E3D2FF, "finish_pain" },
    { 0x32871F8E, "finish_per_client" },
    { 0xBD182CC7, "finish_planting_equipment" },
    { 0x806F12C8, "finish_potus_objective" },
    { 0x26D531A9, "finish_rejack" },
    { 0xE3E58EB7, "finish_rise_notetracks" },
    { 0x6429667F, "finish_score" },
    { 0x6FB6722F, "finish_skip_scene" },
    { 0xFD37EF5C, "finish_time" },
    { 0x73D0B1F3, "finish_while_loop" },
    { 0x2C68393C, "finishactordamage" },
    { 0x83F69225, "finishactordamagewrapper" },
    { 0xAB42C663, "finishairstrikeusage" },
    { 0xD96F4AB1, "finishcustomtraversallistener" },
    { 0xC92C5DD5, "finishdualhardpointlocationusage" },
    { 0x6301ECEB, "finished" },
    { 0xF42B7E06, "finished spawning" },
    { 0xEA8AB8FA, "finished_boarding" },
    { 0xF8D5F1EC, "finished_custom_animmode" },
    { 0xA3E6B080, "finished_eating" },
    { 0xA2860EF5, "finished_events" },
    { 0x0BC37F54, "finished_feign_ambush_anim" },
    { 0xBBB5E8A9, "finished_local_pulse" },
    { 0x45C41813, "finished_path" },
    { 0xB96B72C4, "finished_playing" },
    { 0x638004B2, "finished_playing_postfx_bundle" },
    { 0x6465CC56, "finished_queued_animation" },
    { 0xFEF2CB83, "finished_radio" },
    { 0xA56D5376, "finished_scene" },
    { 0xE3750A35, "finished_spawning" },
    { 0xEB4ADCC3, "finished_track" },
    { 0x96008209, "finishedfunc" },
    { 0xB80B54D0, "finishednotify" },
    { 0x9BB8A4D0, "finishedreload" },
    { 0x28DCC0C4, "finishes" },
    { 0xB49A99FF, "finishhardpointlocationusage" },
    { 0x7223F0C0, "finishing" },
    { 0x5C631ADA, "finishlookat" },
    { 0xE379CD9D, "finishlooponexit" },
    { 0xE558EF0B, "finishmeleehit" },
    { 0x82379D28, "finishnotetracks" },
    { 0x788E5CB8, "finishplayerdamage" },
    { 0x8CC0A609, "finishplayerdamagewrapper" },
    { 0x145785E5, "finishplayingduprenderbundle" },
    { 0x381F14D2, "finishplayingpostfxbundle" },
    { 0x2DB21CAE, "finishsquadcommandusage" },
    { 0xF695853E, "finishtraversal" },
    { 0x3F754D91, "finishtraversedrop" },
    { 0xF41BCE9B, "finishvehicledamage" },
    { 0xC8FBA501, "finishvehicleradiusdamage" },
    { 0x14B31C89, "finishwhileloop" },
    { 0x8940D490, "finite" },
    { 0xDBD11306, "finnaly" },
    { 0xABF19A10, "finnerdamage" },
    { 0xE2834518, "fir_dir" },
    { 0xC7569801, "fire" },
    { 0xB662F785, "fire_1" },
    { 0xE874C704, "fire_20mm" },
    { 0x29E0FEE1, "fire_additional_shots" },
    { 0x66998D1C, "fire_aim_idle_time" },
    { 0x48CC1224, "fire_angles" },
    { 0xE4750EDE, "fire_angola_mortar" },
    { 0xAF4194E2, "fire_anims" },
    { 0xCB26A24C, "fire_aoe_start" },
    { 0xA59CE3B9, "fire_apc_gun" },
    { 0x155E8671, "fire_apc_gun_for_crush" },
    { 0x4ECF909F, "fire_arty_gun" },
    { 0xB6C99B9B, "fire_at" },
    { 0xCC8CCAA9, "fire_at_array" },
    { 0xC6F3C759, "fire_at_bar" },
    { 0xEFCDC2D6, "fire_at_carrier" },
    { 0xB777F01F, "fire_at_drones" },
    { 0x2A64CC28, "fire_at_f35" },
    { 0x51790122, "fire_at_friendly_pbr" },
    { 0xCFE4C95F, "fire_at_leadoff" },
    { 0x8B54D07C, "fire_at_origin" },
    { 0xDA66ABE3, "fire_at_pct" },
    { 0x906D02F1, "fire_at_player" },
    { 0x5B2EE90B, "fire_at_player_while_waiting" },
    { 0xBE6D4231, "fire_at_rooftop" },
    { 0x20FFE81B, "fire_at_sampan_guys" },
    { 0x909802B6, "fire_at_specific_target" },
    { 0x06931189, "fire_at_target" },
    { 0x3773A055, "fire_at_target_at_end" },
    { 0xCA40BB91, "fire_at_target_at_end_tank1" },
    { 0x20F1246D, "fire_at_target_name" },
    { 0xCF679D80, "fire_at_targets" },
    { 0xB9211DEE, "fire_audio_random_max_duration" },
    { 0x12C740DB, "fire_audio_repeat_duration" },
    { 0x8C94EB50, "fire_barrel" },
    { 0xC09B7E49, "fire_barrel1_detach" },
    { 0xEA2CD8BC, "fire_barrel2_detach" },
    { 0xB759BCC1, "fire_beam" },
    { 0x1DC1E3D3, "fire_beam_id" },
    { 0x7332C2B3, "fire_bomblet" },
    { 0x870EB7AD, "fire_buffel_think" },
    { 0xC2A03EAC, "fire_bullet" },
    { 0xC222CE7E, "fire_burst" },
    { 0xFCF15AE8, "fire_burts" },
    { 0x0FEA804A, "fire_can" },
    { 0x3AC6CC4B, "fire_casters" },
    { 0x5A7D34D1, "fire_center_truck_rockets" },
    { 0x6E5CD014, "fire_choices" },
    { 0xB242FBC9, "fire_count" },
    { 0x7ACDF16C, "fire_crates" },
    { 0x5BD40D05, "fire_crouch_idle_time" },
    { 0xBE13B557, "fire_damage" },
    { 0x3925C480, "fire_damage_func" },
    { 0x438E4CCD, "fire_damage_player" },
    { 0x728D1179, "fire_damage_setup" },
    { 0x771CCA0C, "fire_death_blossom" },
    { 0x2ACE77C2, "fire_death_sm_fx" },
    { 0x68A79CCF, "fire_death_torso_fx" },
    { 0x762EF891, "fire_delay" },
    { 0x7633AE2E, "fire_delay_max" },
    { 0xC90B1CF0, "fire_delay_min" },
    { 0xD118F747, "fire_direction" },
    { 0xA8E9A190, "fire_direction_func" },
    { 0xF7F3C839, "fire_direction_kills_complete" },
    { 0x9DD50A7B, "fire_direction_shader_on" },
    { 0x1BFC0176, "fire_direction_stop_hint" },
    { 0xBDDC35E9, "fire_direction_stop_weapon" },
    { 0xE3076F9D, "fire_direction_used" },
    { 0xE41D9C97, "fire_dying_missile_at_boat" },
    { 0xF2AB7F4F, "fire_effect" },
    { 0xA3F1F153, "fire_end_name" },
    { 0x1ED3EC02, "fire_ends" },
    { 0xDF10DE43, "fire_ent" },
    { 0x4326232C, "fire_extinguish" },
    { 0x3965CC09, "fire_extinguisher" },
    { 0xF401EC4E, "fire_flak88" },
    { 0x5DA90926, "fire_flamethrower" },
    { 0x01BDACF0, "fire_flicker" },
    { 0xE64B68E1, "fire_flicker_init" },
    { 0x7068DBD1, "fire_flicker_then_stop" },
    { 0xFF27B95B, "fire_flickers" },
    { 0xEC5588C9, "fire_footsteps" },
    { 0xB462D907, "fire_for_effect" },
    { 0xB913648F, "fire_for_rounds" },
    { 0xAFB82FAF, "fire_for_time" },
    { 0x3A34DC3C, "fire_from" },
    { 0x608A291E, "fire_func" },
    { 0x60CE6396, "fire_fx" },
    { 0xE2EB283C, "fire_fx_ent" },
    { 0x2AFB0640, "fire_fx_max_duration" },
    { 0x4D4626EB, "fire_fx_origin" },
    { 0xD3D61576, "fire_grenade_at_target" },
    { 0x6FD92EE2, "fire_grenade_watch" },
    { 0xD151A0F0, "fire_guard1" },
    { 0x4359102B, "fire_guard2" },
    { 0xB6D6D6F1, "fire_guard_spawners" },
    { 0x9CB7FB82, "fire_guards" },
    { 0x3092A01D, "fire_gunner" },
    { 0xC9797B6F, "fire_guns_base" },
    { 0x08B2603E, "fire_guys_in_area" },
    { 0xB027B297, "fire_half_blanks" },
    { 0x6098F05B, "fire_horse" },
    { 0x4F42FE57, "fire_hud" },
    { 0x6755DBD0, "fire_hurt_structs" },
    { 0x98DAC956, "fire_hurts_trigs" },
    { 0x08F5E2D6, "fire_hydrant" },
    { 0x8F03A8BE, "fire_hydrant_break" },
    { 0xAC073A03, "fire_hydrant_timing" },
    { 0xEE5CCCB6, "fire_in_the_hole" },
    { 0xDF33D2B8, "fire_index" },
    { 0x9D3C61E8, "fire_interval_max" },
    { 0xF7E24076, "fire_interval_min" },
    { 0x58214B60, "fire_intro_truck_rockets" },
    { 0x91162229, "fire_javelin" },
    { 0xA21D8168, "fire_jump" },
    { 0x55BCE6B0, "fire_katyusha" },
    { 0xCA18764E, "fire_katyusha_rockets" },
    { 0x1DC96269, "fire_left_truck_rockets" },
    { 0x2E6ECC7B, "fire_lights" },
    { 0x76ED4EBC, "fire_link_cooldown" },
    { 0xC9D8A3D8, "fire_loop_generic" },
    { 0xDFFE9771, "fire_loop_toggle" },
    { 0xB73A3C40, "fire_machine_gun_on" },
    { 0xF9BA2987, "fire_magic_bullet_huey_rocket" },
    { 0x757729D8, "fire_magic_bullet_rpg" },
    { 0x8BD48AFB, "fire_magic_bullet_rpg_structs" },
    { 0x61946563, "fire_magic_bullets" },
    { 0x328BB54E, "fire_magic_rpd" },
    { 0x0C893AE5, "fire_magic_rpg" },
    { 0x51A73693, "fire_magic_rpg_struct" },
    { 0xD08A94C9, "fire_mg_continuously_end" },
    { 0x9819779C, "fire_missile" },
    { 0x356262A3, "fire_missile_" },
    { 0xB64E0A87, "fire_missile_done" },
    { 0x64FB64EE, "fire_missile_from_behind_the_player" },
    { 0x26B3C8FD, "fire_mode" },
    { 0xE236F67B, "fire_model" },
    { 0xCFD513B3, "fire_mortar" },
    { 0x6748EC7F, "fire_msg" },
    { 0xD0E4F2A7, "fire_my_turret" },
    { 0xEF19AF98, "fire_node" },
    { 0x108C6973, "fire_nodes" },
    { 0xED094593, "fire_notetrack_functions" },
    { 0xCE1C84BF, "fire_notify" },
    { 0xE2F1BDDC, "fire_now" },
    { 0x702C8AD3, "fire_on_drones" },
    { 0x6E134E23, "fire_on_player_in_sight" },
    { 0x0273963D, "fire_on_target" },
    { 0xBD0FBDC6, "fire_org" },
    { 0x2E946587, "fire_orig" },
    { 0x933E9B22, "fire_origin" },
    { 0xA851FCED, "fire_origins" },
    { 0x926BD6B5, "fire_pile1" },
    { 0x42D5598D, "fire_pile1_detach" },
    { 0xB86E511E, "fire_pile2" },
    { 0xE28D1680, "fire_pile2_detach" },
    { 0xE664EEC6, "fire_pitch" },
    { 0xBE283BA2, "fire_pod_logic" },
    { 0x3EDA31C6, "fire_point" },
    { 0xB0B39F79, "fire_points" },
    { 0xBB7A9102, "fire_pos" },
    { 0x2FBDCAD7, "fire_pos_11" },
    { 0xBCADFF2D, "fire_puzzle_1_cleanup" },
    { 0x94FA4882, "fire_puzzle_1_complete" },
    { 0xBADC3CB5, "fire_puzzle_1_init" },
    { 0x8487A3A2, "fire_puzzle_1_run" },
    { 0x5CF6E84A, "fire_puzzle_2_cleanup" },
    { 0x501871CF, "fire_puzzle_2_complete" },
    { 0x4C0B94BC, "fire_puzzle_2_init" },
    { 0x601C220C, "fire_puzzle_2_is_complete" },
    { 0x5B72F9C5, "fire_puzzle_2_run" },
    { 0x6FE3D250, "fire_puzzle_2_torch_flame" },
    { 0x98B7D4B1, "fire_puzzle_torch_run" },
    { 0xC1E34803, "fire_puzzle_watch_staff" },
    { 0x7AD69616, "fire_radius" },
    { 0x3465C70B, "fire_random_bomblet" },
    { 0x4B10617A, "fire_rate" },
    { 0xDCD91518, "fire_right_truck_rockets" },
    { 0x1BB326EF, "fire_river_missile" },
    { 0x0CA7F0EF, "fire_rock_at_vtol" },
    { 0x70D8FF36, "fire_rock_at_vtol_defalco" },
    { 0xA6F57FF9, "fire_rock_at_vtol_nodefalco" },
    { 0x28EEE57C, "fire_rocket" },
    { 0xA9921FA7, "fire_rocket_at_pos" },
    { 0x0B6C48C4, "fire_rocket_series" },
    { 0x3EE0F23F, "fire_rockets" },
    { 0xA1249804, "fire_round" },
    { 0xB872D021, "fire_rpg" },
    { 0x4219184E, "fire_rpg_at_btr" },
    { 0xC54994FC, "fire_rpg_at_plane" },
    { 0x0D653DAB, "fire_rpg_at_random_drones" },
    { 0xE5A71908, "fire_rpgs_at_hind" },
    { 0xA7795658, "fire_rpgs_from_structs" },
    { 0x0EB2B5E3, "fire_rumble" },
    { 0xEBEC68A1, "fire_sacrifice_completed" },
    { 0xDCEEC692, "fire_sacrifice_death_clone" },
    { 0x73FCFA45, "fire_sale" },
    { 0x4D4CB529, "fire_sale_fix" },
    { 0xCAE2D477, "fire_sale_off" },
    { 0x3D5DD783, "fire_sale_on" },
    { 0x3864539F, "fire_sale_pickedup" },
    { 0xEA3B4BDC, "fire_sale_weapon_wait" },
    { 0xC8817E06, "fire_schreck_at_pos" },
    { 0xCC55569A, "fire_screenshake" },
    { 0x0954ADC4, "fire_shreck" },
    { 0x09D4CF4F, "fire_shreck_at_pos" },
    { 0x06CBEE77, "fire_shrecks" },
    { 0x1BBA8362, "fire_shrecks_with_damage" },
    { 0xDC00B66E, "fire_shrecks_without_damage" },
    { 0xFE0C952F, "fire_slingshot" },
    { 0x291AC48B, "fire_sound_ent" },
    { 0x20E78E80, "fire_sounds" },
    { 0xE5FB1439, "fire_spikes" },
    { 0xF62B608C, "fire_spot" },
    { 0x146713B0, "fire_spot_1" },
    { 0x866E82EB, "fire_spot_2" },
    { 0x606C0882, "fire_spot_3" },
    { 0x52EC8B27, "fire_spread_shots" },
    { 0xF98583DE, "fire_staff_area_of_effect" },
    { 0xD85B0552, "fire_staff_explosion" },
    { 0x4268F623, "fire_staff_update_grenade_fuse" },
    { 0x76925900, "fire_start" },
    { 0xA4919D8A, "fire_start_name" },
    { 0xBB7F182B, "fire_starts" },
    { 0x9BC38BE3, "fire_state_name" },
    { 0xF0296777, "fire_stingers_base" },
    { 0x6C8E0D8C, "fire_stop" },
    { 0xA8A9C87E, "fire_straight" },
    { 0xFB40CC67, "fire_struct" },
    { 0xE617B938, "fire_stun_zombie_choked" },
    { 0xB9C032B5, "fire_support_nags" },
    { 0xAE7EAF2C, "fire_tag" },
    { 0x6FEC252F, "fire_tags" },
    { 0xCFED2816, "fire_targets" },
    { 0x11509B7D, "fire_threshold" },
    { 0x8878B457, "fire_time" },
    { 0x7042D781, "fire_time_base" },
    { 0x504D10B7, "fire_time_complete" },
    { 0x997FCD77, "fire_timer" },
    { 0x737D530E, "fire_times" },
    { 0xA7C75D32, "fire_trap_fx" },
    { 0x94B52AB2, "fire_trig" },
    { 0xCB0AD682, "fire_turret" },
    { 0xC717A621, "fire_turret_2" },
    { 0x70B7218E, "fire_turret_for_time" },
    { 0x3EF3CCE0, "fire_turret_hud" },
    { 0x8BB0E380, "fire_uw_a" },
    { 0x1F601F72, "fire_vect" },
    { 0x02BE83E7, "fire_vehicle_until_notify" },
    { 0x9DD2E317, "fire_wait" },
    { 0x7CF641FE, "fire_wait_x" },
    { 0xA2F8BC67, "fire_wait_y" },
    { 0xF7B61010, "fire_weapon" },
    { 0xC7C4B49E, "fire_weapon_on_ent" },
    { 0xDFE8DA0F, "fire_weapon_on_heli" },
    { 0xF500A768, "fire_weapon_on_target" },
    { 0xACD6C46C, "fire_when_on_target" },
    { 0x188D9054, "fire_works_summon" },
    { 0x5AE7061B, "fire_works_zombie_validation" },
    { 0xDF143205, "fire_yaw" },
    { 0x706552D2, "fire_zone_exploder" },
    { 0x97B8679E, "fireangle" },
    { 0xF68C9776, "fireanim" },
    { 0xDF5AB02D, "fireanimend" },
    { 0xF430D7C4, "fireatplayers" },
    { 0x5C025E5A, "fireball" },
    { 0x8D19BA07, "fireball_explosion_radius" },
    { 0x215CD4EA, "fireball_speed" },
    { 0xCBE07D96, "fireballdlight" },
    { 0x6AA27F55, "fireballs" },
    { 0x34538EE1, "firebarrel" },
    { 0xCB36D98C, "firebeam" },
    { 0x1C876335, "firebug" },
    { 0x93B1B31A, "firebug_state_hunt_trans_to_move" },
    { 0x0DD7B8EA, "firebugcount" },
    { 0xB47618B0, "firebuilding1_explode" },
    { 0x26CD8C72, "firebuilding1_explosion" },
    { 0x0EDA0F3D, "firebuilding1_thread" },
    { 0xEA1395C7, "firebuilding2_explode" },
    { 0x4BAE21BD, "firebuilding2_explosion" },
    { 0xA940B678, "firebuilding2_thread" },
    { 0x9CDB327D, "fireburst" },
    { 0xCB645151, "firechance" },
    { 0x8144FF35, "firecontroller" },
    { 0xBEB3DF9E, "firecount" },
    { 0xA7491A97, "fired" },
    { 0xCAAA5C65, "fired_at_guy" },
    { 0xE64D9752, "fired_barrett" },
    { 0x3A3CDFA1, "fired_barrett_dist" },
    { 0xBBF82727, "fired_early" },
    { 0xD737A214, "fired_grenade" },
    { 0x04E30F8C, "fired_gun" },
    { 0xA839ED6A, "fired_rocket" },
    { 0xCD1F5452, "fired_weapon" },
    { 0x97B9F9CE, "firedbyai" },
    { 0x4A94E8EE, "firedelay" },
    { 0x5E0515FF, "firedgrenade" },
    { 0xD61E998D, "firedkillstreakweapon" },
    { 0x6B8EEA05, "firedone" },
    { 0x60F4D035, "firedown" },
    { 0xC8A2E04B, "firedrockettargets" },
    { 0x60B3CC24, "firedsound" },
    { 0x73074487, "fireeffect1" },
    { 0x00FFD54C, "fireeffect2" },
    { 0xB6EFD881, "fireeffectarea" },
    { 0xB3EA2468, "fireent" },
    { 0x44C5DFE1, "firefight" },
    { 0x692EFDD6, "firefight_countdown_achievement_time_remaining" },
    { 0x533B6996, "firefight_countdown_achievement_valid" },
    { 0x7E49BAD0, "firefight_countdown_duration" },
    { 0x13DE9E69, "firefight_friendlies" },
    { 0xD9B5F484, "firefight_friendly_weapon_pickup1" },
    { 0x4BBD63BF, "firefight_friendly_weapon_pickup2" },
    { 0x13CC1C1A, "fireflares" },
    { 0x9FE367DB, "fireflicker" },
    { 0x65C696BC, "fireflies_attack_speed_scale" },
    { 0x2D29DC1D, "fireflies_attacking" },
    { 0x917DA836, "fireflies_chasing" },
    { 0x5BCD062C, "fireflies_collision_check_interval" },
    { 0xF7F4BE46, "fireflies_emit_time" },
    { 0xAFB23EE4, "fireflies_height_variance" },
    { 0x760E32ED, "fireflies_min_speed" },
    { 0xCE2B8735, "fireflies_radius" },
    { 0xD3D1F492, "fireflies_spawn_height" },
    { 0x0349E9ED, "fireflies_spawn_height_wall" },
    { 0x1F929BE9, "fireflies_spawn_height_wall_angle" },
    { 0x92E128B5, "fireflies_spawn_height_wall_angle_cos" },
    { 0xD15AAA87, "firefly_attack" },
    { 0xC0C4F0D9, "firefly_attacking" },
    { 0xFB950047, "firefly_chase" },
    { 0x03A089BB, "firefly_check_for_collisions" },
    { 0x3BCA47AF, "firefly_check_move" },
    { 0xC4FB08F0, "firefly_damage_target" },
    { 0x90FBA777, "firefly_death" },
    { 0x3BBBAD88, "firefly_debug" },
    { 0x231D32D6, "firefly_deploying" },
    { 0x249C969D, "firefly_dieing" },
    { 0x3DDFC934, "firefly_effect_cb" },
    { 0x3115859C, "firefly_hunting" },
    { 0x40245849, "firefly_init" },
    { 0x729C2B24, "firefly_killcam_move" },
    { 0x38D25DF7, "firefly_killcam_stop" },
    { 0xC2DD71E6, "firefly_link_attacking" },
    { 0x654599BC, "firefly_move" },
    { 0x541F0416, "firefly_mover" },
    { 0xFBA7B282, "firefly_mover_damage" },
    { 0xC628A642, "firefly_partial_move" },
    { 0x2559CDE9, "firefly_pod_activation_time" },
    { 0x27F1BA88, "firefly_pod_destroyed" },
    { 0x197357E1, "firefly_pod_detection_radius" },
    { 0x3BF629E7, "firefly_pod_detonate" },
    { 0xC9E7E54B, "firefly_pod_grace_period" },
    { 0x0B1F3E24, "firefly_pod_partial_move_percent" },
    { 0xD0099366, "firefly_pod_random_movement" },
    { 0xB89D2A69, "firefly_pod_random_point" },
    { 0x79871484, "firefly_pod_release_fireflies" },
    { 0x83614051, "firefly_pod_rotated_point" },
    { 0x20F71F76, "firefly_pod_secondary_explosion_weapon" },
    { 0x878BC806, "firefly_pod_should_damage" },
    { 0x3D3DCB0B, "firefly_pod_splat_duration_max" },
    { 0xCFECC4D1, "firefly_pod_start" },
    { 0xF2A9479F, "firefly_pod_weapon" },
    { 0xAD9F7FFE, "firefly_rotate" },
    { 0xAAA322BD, "firefly_spawn_vehicle" },
    { 0xE78BFFE3, "firefly_spyrograph_patrol" },
    { 0x04DC1EBD, "firefly_state_change" },
    { 0xE42D4CCD, "firefly_state_hunt_trans_to_move" },
    { 0xDE159D8D, "firefly_swarm" },
    { 0xCC728698, "firefly_target" },
    { 0x7F55C5C4, "firefly_watch_for_game_ended" },
    { 0x7453793F, "firefly_watch_for_target_death" },
    { 0xE7FF9FA6, "firefly_watch_fx_finished" },
    { 0x4133A1D7, "firefx" },
    { 0x3869CEF0, "firefxdelay" },
    { 0xC6AA0F64, "firefxsound" },
    { 0xAB72FA50, "firefxtimeout" },
    { 0x5B53EAD4, "firegunnerweapon" },
    { 0xDA84A589, "fireheliweapon" },
    { 0x5F3FB546, "firehorse_actual_logic" },
    { 0x2CF430EE, "firehorse_cache_guard_logic" },
    { 0xA6EAECCC, "firehorse_mason_logic" },
    { 0x6FCF0984, "firehorse_woods_logic" },
    { 0x2CA55EAE, "firehorse_zhao_logic" },
    { 0x31A2E047, "fireing" },
    { 0xB43E79D9, "firelauncher" },
    { 0x5A20EAB4, "firelocation" },
    { 0x6AB0B02D, "firemg" },
    { 0xE7AFC757, "firemissile" },
    { 0x88A8BC9E, "firendlies" },
    { 0xCB37CD6E, "firendly" },
    { 0x93200371, "firenode" },
    { 0x4C01C0D9, "firenode_count" },
    { 0x778FE499, "firepoint" },
    { 0x4A5ABBE2, "firepoint1" },
    { 0x7EF46150, "firepoints" },
    { 0xA4B9FB71, "firepos" },
    { 0x66C52C84, "firepower" },
    { 0x87990A4D, "firepower_fate" },
    { 0xA7BE9133, "firerate" },
    { 0x8F921601, "firerocketlauncher" },
    { 0x13F50070, "firerockets" },
    { 0x3D101B28, "fires" },
    { 0xAEE5CBB0, "firesale" },
    { 0xB882D560, "firesale_chest_is_leaving" },
    { 0xC2EF2F15, "firesale_over" },
    { 0x574DEB68, "firesale_vox_firstime" },
    { 0x7F6EAFE1, "firescout" },
    { 0x4E1169A2, "firescout_drone" },
    { 0x2FD3DC68, "firescout_fire_missiles" },
    { 0x7923C47E, "firesound" },
    { 0x40125168, "firesounddeath" },
    { 0x0CB9FFF7, "firesounddelay" },
    { 0x31E47B39, "firesoundplayer" },
    { 0x6C681849, "firespot" },
    { 0xA3450E39, "firestructs" },
    { 0x254D42DE, "firetargetnode" },
    { 0xF6F0C816, "fireteam" },
    { 0xBD8F1C66, "fireteam_bazooka" },
    { 0x79F4EDBA, "fireteam_bazooka_reload" },
    { 0xA25D6C32, "fireteam_cooldown_time" },
    { 0xB605646F, "fireteam_dialogue" },
    { 0xC4061A1C, "fireteam_dialogue_deny_wait" },
    { 0x37FA703F, "fireteam_dialogue_last_deny" },
    { 0xE5DA2129, "fireteam_done_firing" },
    { 0x1BA208A8, "fireteam_door_open" },
    { 0xCD45B5BB, "fireteam_door_opened" },
    { 0xEA8709DC, "fireteam_entrance_action" },
    { 0x530BD566, "fireteam_entrance_index" },
    { 0xFB365243, "fireteam_finished" },
    { 0x62944877, "fireteam_flamethrower" },
    { 0x14EB39EF, "fireteam_flamethrower_pickentrance" },
    { 0x2C614E00, "fireteam_hint_hud" },
    { 0x80232FAC, "fireteam_hud" },
    { 0x0C061DD3, "fireteam_hud_fade_time" },
    { 0x5DA4A86C, "fireteam_input_pause_time" },
    { 0xA2E825A6, "fireteam_member_reached_goal" },
    { 0x91B8F403, "fireteam_member_reached_node" },
    { 0x577F9331, "fireteam_mg" },
    { 0x82D723FC, "fireteam_postshoot" },
    { 0x5C3157ED, "fireteam_preshoot" },
    { 0xAAC0B5CF, "fireteam_reached_nodes" },
    { 0xFFF96ED9, "fireteam_request_dialogue" },
    { 0xEBC25233, "fireteam_request_done" },
    { 0x8C658E53, "fireteam_request_wait_max" },
    { 0x0F50D05D, "fireteam_request_wait_min" },
    { 0x47D57BAD, "fireteam_requester" },
    { 0xD6D5EB96, "fireteam_reset_ais" },
    { 0xCE0E1136, "fireteam_reset_ais_customfunc" },
    { 0x8B5C3D61, "fireteam_reset_ais_delayed_danger" },
    { 0x1112A539, "fireteam_role" },
    { 0xD4CFC7FD, "fireteam_runto_nextnode" },
    { 0xA2E9C0E5, "fireteam_runto_nodes" },
    { 0x29B70B7C, "fireteam_setup_ais" },
    { 0x0F7783D2, "fireteam_spawn_ais" },
    { 0x579D6319, "fireteam_starting" },
    { 0x2B8DA66B, "fireteam_warp_ais" },
    { 0xBDBE224C, "fireteamcontrolarray" },
    { 0x8C918C89, "fireteams" },
    { 0x2B64E5E5, "fireteams_action_slot" },
    { 0x410CDA42, "fireteams_call_in_team" },
    { 0x12FA6CE0, "fireteams_catch_input" },
    { 0xF5162EC5, "fireteams_cooldown_timer" },
    { 0x1583B52A, "fireteams_dpad_button" },
    { 0xD8549E15, "fireteams_firsthint" },
    { 0xCA764EE4, "fireteams_give_ability" },
    { 0x07A43A06, "fireteams_give_ability_allplayers" },
    { 0x5A2C9AA5, "fireteams_hide_destroyed_states" },
    { 0xC74D090D, "fireteams_hud_clear" },
    { 0xF11A6AFB, "fireteams_hud_print" },
    { 0xC99EE1B2, "fireteams_init" },
    { 0x0485F1A3, "fireteams_init_func" },
    { 0x0BFABA1A, "fireteams_onplayerconnect" },
    { 0xAEF45222, "fireteams_onplayerspawned" },
    { 0x9FFD7CD1, "fireteams_pickentrance" },
    { 0xF5EB5978, "fireteams_populate_leveldotfireteams" },
    { 0xA4369F47, "fireteams_reset_ais_customfunc" },
    { 0x1152D69C, "fireteams_set_available" },
    { 0x611A893F, "fireteams_set_unavailable" },
    { 0x279D9695, "fireteams_setup_hud" },
    { 0x9A05F1DD, "firetest" },
    { 0x3B139956, "firetime" },
    { 0x109E28C9, "firetimes" },
    { 0x60ABDD97, "firetoskip" },
    { 0x7558FE9F, "fireturret" },
    { 0x2FA3EB39, "firetype" },
    { 0x82EA2DE4, "fireuntiloutofammo" },
    { 0x7320DE4F, "fireuntiloutofammointernal" },
    { 0xE239E76A, "fireup" },
    { 0x6E34A08E, "fireupdate" },
    { 0x55BA7C8D, "firewall" },
    { 0xA2DFBF9A, "firewater_exposure" },
    { 0x8CC4D42B, "firewater_visionset" },
    { 0x90AD4ED1, "fireweapon" },
    { 0x18CF3467, "fireweapon_quake" },
    { 0x482C55A2, "firework" },
    { 0xA0C2638A, "firework_forward_launch" },
    { 0xFA8E946D, "fireworks" },
    { 0xD94CC609, "fireworks_launch" },
    { 0xB3E631B4, "firing" },
    { 0x1E57D694, "firing_at_player" },
    { 0x296A64F0, "firing_cannon" },
    { 0x9F08F644, "firing_range_door_open" },
    { 0xE838DAC2, "firing_rockets" },
    { 0xFB5E947B, "firing_solution_watcher" },
    { 0xF33EAED4, "firing_starts_1" },
    { 0x65461E0F, "firing_starts_2" },
    { 0x3F43A3A6, "firing_starts_3" },
    { 0x81373F99, "firing_starts_4" },
    { 0x31E57584, "firing_target" },
    { 0xFB1B53E6, "firingdeathallowed" },
    { 0x7F148704, "firingpointprocedure_override" },
    { 0x2486E120, "firingweapon" },
    { 0xC5C5FA5F, "firint" },
    { 0x9742C4B9, "firm" },
    { 0xA0CD6B51, "first" },
    { 0x0A96E5BA, "first_88_obj" },
    { 0x3894B814, "first_angles" },
    { 0x0A276E30, "first_approach" },
    { 0x2B7E3F19, "first_balcony_action" },
    { 0xFD36EC0A, "first_bars" },
    { 0xEDEF01D7, "first_bars1" },
    { 0x7BE7929C, "first_bars2" },
    { 0xF654FD58, "first_big_room" },
    { 0xA2F99451, "first_boat_encounter_player_skipto" },
    { 0x2A3598BA, "first_boss_spawner" },
    { 0xBF3E78EA, "first_bp1_btr" },
    { 0x0FEE8B50, "first_breach_org" },
    { 0x73A5C7B3, "first_bridge_brutus_killed" },
    { 0xCAFC17D8, "first_chopper_fly_over" },
    { 0xC5613C1A, "first_color_trig" },
    { 0xF33E81C1, "first_consumables_used_watcher" },
    { 0x66AC0A72, "first_contextual_melee_started" },
    { 0x9B8A1725, "first_cover" },
    { 0x52715F70, "first_cover_reznov" },
    { 0x7BB184CE, "first_cover_vignette" },
    { 0x7B97C9DB, "first_daily_mp_contract_index" },
    { 0x2A140A0D, "first_deleter" },
    { 0x4AF90C8E, "first_digger_activated" },
    { 0x368B936C, "first_door" },
    { 0x180820C3, "first_drone_strike" },
    { 0x7BF93287, "first_enemyattack_thread" },
    { 0xB4AD5C92, "first_fade_to_black" },
    { 0xAD2B320E, "first_fight" },
    { 0x673D4EA3, "first_fight_counter" },
    { 0xA495FA91, "first_fight_guys" },
    { 0x51DE8F21, "first_fired_on_event" },
    { 0x0F364847, "first_flashback" },
    { 0x65D580F2, "first_floor_chain_delete" },
    { 0x44ECB9DE, "first_floor_kill_trig" },
    { 0xBCE93DD6, "first_floor_lab_main" },
    { 0xF3586255, "first_fly_away_trigger" },
    { 0x5E8939AD, "first_fov" },
    { 0xF968E47B, "first_frame" },
    { 0x90E97C95, "first_frame_delay_anim" },
    { 0xCDCA0FBC, "first_frame_player_cave_enter" },
    { 0x238310B9, "first_frame_scenes" },
    { 0x0258E269, "first_frame_time" },
    { 0x02928257, "first_friendly_advancement_trigger" },
    { 0x69A7A75C, "first_gate_enemies" },
    { 0xD06E78B9, "first_gate_poppers" },
    { 0x456F3BB5, "first_gate_truck" },
    { 0xDCC1D505, "first_goal" },
    { 0x5697543D, "first_ground" },
    { 0x88BE2B9B, "first_gunboat_attack" },
    { 0x78291AAC, "first_guys" },
    { 0x0FD0E98F, "first_half" },
    { 0x592454C4, "first_half_ai" },
    { 0xCF83FA26, "first_half_compound_ai" },
    { 0x24411A70, "first_half_traces" },
    { 0xEF3B6982, "first_hall_gunfire" },
    { 0xCAFF3D61, "first_heli_behavior" },
    { 0xA63AC1FA, "first_heli_hide_event" },
    { 0x3BB963B5, "first_house_breach_volume" },
    { 0xB8F5192A, "first_init" },
    { 0x25A09F78, "first_int_tv_rounds" },
    { 0xF38E7890, "first_interstitial_camera" },
    { 0x2946ED1F, "first_interstitial_go" },
    { 0xEBA28AC3, "first_island_1" },
    { 0x20E2DB00, "first_island_1_pos" },
    { 0x799B1B88, "first_island_2" },
    { 0x7212DF6B, "first_island_2_pos" },
    { 0x84EB6017, "first_island_drones" },
    { 0x59D20928, "first_junction" },
    { 0xE38F4989, "first_limp_point" },
    { 0x5D62902D, "first_line_guys" },
    { 0xF27899C0, "first_line_played" },
    { 0x6005FD8B, "first_line_trig" },
    { 0x2C85A1DE, "first_line_wait" },
    { 0xEDD94260, "first_line_y_offset" },
    { 0xDD507F41, "first_location" },
    { 0x121F72F0, "first_location_callout" },
    { 0xA17DBE3B, "first_magic_box_seen_vo" },
    { 0x1249DD2C, "first_maigc_box_discovered" },
    { 0x12BED9CE, "first_mech_zombie_seen" },
    { 0x145CA9C7, "first_mg_guys" },
    { 0x8FBD23C7, "first_mig_bombs" },
    { 0xB248BB23, "first_mortar" },
    { 0x8BCF59E8, "first_node" },
    { 0x5D60A7F2, "first_node_name" },
    { 0x67688ACF, "first_notify" },
    { 0xBF819A1D, "first_objective" },
    { 0x82829DE0, "first_objective_done" },
    { 0x9AA41D12, "first_origin" },
    { 0x89D3AA05, "first_panther_prompt" },
    { 0xC4C6811B, "first_part" },
    { 0xEE856C89, "first_pass_completed" },
    { 0xAD172C26, "first_pass_starting" },
    { 0xF7D440A4, "first_patrol_array" },
    { 0x10507540, "first_patrol_clear" },
    { 0x838E5E53, "first_patrol_clear_monitor" },
    { 0x606C2D5D, "first_person_notify" },
    { 0xFC8A3CD8, "first_player_connect" },
    { 0x9815D703, "first_player_ready" },
    { 0xF7683DA1, "first_player_vox" },
    { 0xCA03EF0D, "first_pool_dog" },
    { 0xD1BB1465, "first_power_on" },
    { 0x6A6B84CE, "first_powerup_intro_done" },
    { 0xFAE1E276, "first_radiation_dialogue" },
    { 0x187E6A3C, "first_rappel_guy_1" },
    { 0x3F61066A, "first_rappel_guy_1_sync" },
    { 0x8A85D977, "first_rappel_guy_2" },
    { 0x873BEE4F, "first_rappel_guy_2_sync" },
    { 0x64835F0E, "first_rappel_guy_3" },
    { 0xA6A11970, "first_rebel_base_visit" },
    { 0x2F91FEF4, "first_round" },
    { 0x3711FEB1, "first_round_spawn_func" },
    { 0x04875908, "first_row" },
    { 0x21B6AC70, "first_rpg_spawner" },
    { 0xDF9C01D9, "first_rpg_spawner_think" },
    { 0x5615C5FB, "first_run" },
    { 0xD1F1B972, "first_runners_func" },
    { 0x0B4B508C, "first_sampan_encounter" },
    { 0xD8FA243C, "first_scene" },
    { 0xB71E27BC, "first_set" },
    { 0x3C2F1E94, "first_shot" },
    { 0x3837EE90, "first_shot_time" },
    { 0x2039084F, "first_signal_on_node" },
    { 0xB60DBFEC, "first_sky_trans" },
    { 0xE89B37CC, "first_skydemon" },
    { 0xB4483C70, "first_snap_on" },
    { 0xBA297709, "first_sniper_guy" },
    { 0x94910B2F, "first_sniper_setup" },
    { 0xF7B40429, "first_spawn" },
    { 0x55215EED, "first_special_mp_contract_index" },
    { 0x9C0AC457, "first_struct" },
    { 0x2D164BC4, "first_tank" },
    { 0xBCB149C0, "first_teleporter_use" },
    { 0x738883D2, "first_tickle" },
    { 0x392DE1C7, "first_time" },
    { 0x8B391B0B, "first_time_opening_perk_hut" },
    { 0x66643A9D, "first_time_triggered" },
    { 0x25D60DE5, "first_topspot" },
    { 0x4D9C1663, "first_tower" },
    { 0x74CCD6E0, "first_tower_pos" },
    { 0x38579E7A, "first_transformer_structs" },
    { 0x25588C82, "first_trig" },
    { 0x62EC0AD0, "first_trig_name" },
    { 0x02FA4584, "first_truck_spawner" },
    { 0x559AD7A4, "first_turn_sampans_2_arrive" },
    { 0x7634A421, "first_turn_sampans_arrive" },
    { 0x4A369E99, "first_unassigned_contract_slot" },
    { 0x2071EB47, "first_update" },
    { 0x15AABD80, "first_usable" },
    { 0x84ABB593, "first_village_redshirts" },
    { 0x0179BE7B, "first_village_zsu_shoot" },
    { 0xE1349E5A, "first_visible" },
    { 0xECF6E0B7, "first_walk" },
    { 0xC95FECDA, "first_warning_given" },
    { 0x48949DA8, "first_wave_tank_vo" },
    { 0xB963EA25, "first_weekly_mp_contract_index" },
    { 0xC16BC938, "first_with_radio" },
    { 0x09E7BC68, "first_wolf_complete_vo" },
    { 0x9D0A9180, "first_wolf_encounter_vo" },
    { 0x29EB7EF1, "first_zombie_killed_in_zone" },
    { 0x70BF7220, "firstarray" },
    { 0x9A7A4A51, "firstaxiskilled" },
    { 0x49A77F87, "firstbreacher" },
    { 0x3ECA11F7, "firstbuilding_breach" },
    { 0x24178B22, "firstbuilding_breach_automatic_thread" },
    { 0x7D81CDCE, "firstbuilding_check_for_clear" },
    { 0xF4E57A97, "firstcontact" },
    { 0xB07E8923, "firstdroplocation" },
    { 0x3E19B7ED, "firstdropreferencepoint" },
    { 0x5CF22758, "firstelem" },
    { 0xFF98E5EB, "firstflicker" },
    { 0x7D581F10, "firstframe" },
    { 0xB7D562E6, "firstgroup" },
    { 0x16A2DE15, "firstheliexplo" },
    { 0x83B32E8F, "firstinit" },
    { 0xABB61B15, "firstinqueue" },
    { 0xFBBEC24B, "firstlookwait" },
    { 0xCF19F96B, "firstloop" },
    { 0x3CE50818, "firstmodel" },
    { 0x677141B6, "firstmove" },
    { 0x0B22D89B, "firstmovedistance" },
    { 0x37520601, "firstnode" },
    { 0x2FA7D0CA, "firstpass" },
    { 0x9C8AA5D2, "firstperson" },
    { 0xF913815C, "firstperson_fx_overdrive" },
    { 0x5B712CC2, "firstperson_fx_unstoppableforce" },
    { 0xB14145EB, "firstperson_water_fx" },
    { 0xD5749AB0, "firstpersononly" },
    { 0x1A4F6147, "firstplaceonradar" },
    { 0xC1030E93, "firstplay" },
    { 0x4CCF124E, "firstplayer" },
    { 0xA527C1F3, "firstround" },
    { 0xCEA5DF04, "firstrun" },
    { 0x18D2785E, "firstshake_lights_back_on_setflag" },
    { 0x224146A1, "firstsnapshot" },
    { 0x2CA04D86, "firstsnd" },
    { 0xAC3F0A6A, "firstspawn" },
    { 0xD27044BA, "firstspawners" },
    { 0x6FD1A0F9, "firstspot" },
    { 0x6B97BC98, "firststrafe" },
    { 0x6C227197, "firsttargetname" },
    { 0xBEF92006, "firsttime" },
    { 0x46FD7603, "firsttimedamaged" },
    { 0x66184A91, "firsttitle" },
    { 0xE7241C96, "firstwait" },
    { 0x4C0453AF, "firstweaponraise" },
    { 0xB09C4130, "firth" },
    { 0x906C995D, "fis" },
    { 0xC7924CFF, "fish" },
    { 0xEDB7E4C5, "fish02" },
    { 0xC7B56A5C, "fish03" },
    { 0xA1B2EFF3, "fish04" },
    { 0x7BB0758A, "fish05" },
    { 0xA4251474, "fish1" },
    { 0xA4F1C821, "fish1_start" },
    { 0x162C83AF, "fish2" },
    { 0xF02A0946, "fish3" },
    { 0x4B62FBDC, "fish_2" },
    { 0x98C0FCD2, "fish_tank" },
    { 0x0FA42F04, "fished" },
    { 0xB892CF81, "fishing" },
    { 0x2A045AEB, "fishtank_lrg_01" },
    { 0xA6787C7C, "fishtank_sm_01" },
    { 0x187FEBB7, "fishtank_sm_02" },
    { 0x23A2F7F9, "fissures" },
    { 0xBFC3DD33, "fist" },
    { 0x1E652A22, "fit" },
    { 0xD8F1A0CB, "fit_radius" },
    { 0xCFE49D99, "fit_radius_corner" },
    { 0x247A75D7, "fitness" },
    { 0xB60519ED, "fits" },
    { 0x3B816933, "fitzgerald" },
    { 0xFA92699D, "five" },
    { 0x6C39B317, "five_seconds" },
    { 0x32659393, "fiveorigin" },
    { 0xE682E70E, "fix" },
    { 0x9D474F65, "fix_bad_dog_location" },
    { 0xA52C135C, "fix_challenge_stats_on_spawn" },
    { 0x077333B5, "fix_challenge_stats_performed" },
    { 0xD02329CC, "fix_couch_stuckspot" },
    { 0x5961DE03, "fix_createfxent_index" },
    { 0x3EB3DBAD, "fix_dist" },
    { 0x03FD8F24, "fix_hax" },
    { 0x3D1F942D, "fix_health_in_a_frame" },
    { 0xCFC0D421, "fix_trigger_array" },
    { 0x2FAB1FD6, "fix_tu6_ar_garand" },
    { 0xCD6AF20B, "fix_tu6_pistol_shotgun" },
    { 0x149B3818, "fix_tu6_weapon_for_diamond" },
    { 0xC2E0450C, "fixalltires" },
    { 0x814BD42A, "fixated" },
    { 0x1B8E7E51, "fixed" },
    { 0xCAF6BA1C, "fixed_bp1_logic" },
    { 0x4CA3AE6F, "fixed_max_player_use_radius" },
    { 0xE9B31ACE, "fixed_move_order" },
    { 0xE6AB0105, "fixed_offset" },
    { 0x7EAF3742, "fixed_offset_z" },
    { 0x957691BA, "fixed_scan_order" },
    { 0xE0B52584, "fixedlinkyawonly" },
    { 0x96584E06, "fixedmovement" },
    { 0x25D14901, "fixednode" },
    { 0xDC7F58CC, "fixednode_set" },
    { 0x0E5BA2DA, "fixednode_trigger_setup" },
    { 0x170D7BCF, "fixednode_unset" },
    { 0x0C02C072, "fixednodesafe" },
    { 0x3A59872C, "fixednodesaferadius" },
    { 0xCDA54457, "fixednodewason" },
    { 0x39C288EE, "fixes" },
    { 0x8344F0B2, "fixing" },
    { 0x7EF503D0, "fixme" },
    { 0x02D102B4, "fixmed" },
    { 0xF94699E2, "fixnode" },
    { 0x6642C135, "fixup" },
    { 0xCCFCC608, "fixup_set" },
    { 0x9ED4F804, "fixups" },
    { 0x819D026F, "fizzle" },
    { 0xB042383D, "fizzleout" },
    { 0x6A2F0233, "fkcb" },
    { 0x90317C9C, "fkce" },
    { 0x2588281E, "fkilldelay" },
    { 0xB70EF5E0, "fl_flag" },
    { 0xCC0982E9, "flacked" },
    { 0xAD23E503, "flag" },
    { 0x4008E0D0, "flag check is running" },
    { 0xCCA6AFE0, "flag1" },
    { 0x3EAE1F1B, "flag2" },
    { 0x18ABA4B2, "flag3" },
    { 0x8AB313ED, "flag4" },
    { 0x35F52794, "flag_abort" },
    { 0x1D899CA7, "flag_activated" },
    { 0x6B7190E8, "flag_adjacent" },
    { 0xC691C0D1, "flag_array" },
    { 0x754E9595, "flag_art" },
    { 0xDEBAC2F0, "flag_assert" },
    { 0xA275B90C, "flag_blocker" },
    { 0xDD32168F, "flag_blockers" },
    { 0x6D6D4FB4, "flag_bridge_done" },
    { 0x734976CC, "flag_captured" },
    { 0x51FFFCA9, "flag_clear" },
    { 0x35DFFEF6, "flag_clear_delayed" },
    { 0x3C6805E4, "flag_clear_innseconds" },
    { 0x9D05CA58, "flag_clear_trigger" },
    { 0x952EA708, "flag_client_flag_ally_switch" },
    { 0xA3EAA681, "flag_client_flag_died" },
    { 0x1C7D7341, "flag_client_flag_died_veh" },
    { 0x039796E4, "flag_client_flag_gpr_updated" },
    { 0x2083B400, "flag_client_flag_make_fake_blackhawk" },
    { 0xF6446E38, "flag_client_flag_remote_missile" },
    { 0x918F1C29, "flag_client_flag_reticle" },
    { 0x08118B0A, "flag_client_flag_third_person_cam" },
    { 0x19F9690F, "flag_compass_init" },
    { 0xA2F26C3E, "flag_compass_update" },
    { 0xE9249E3D, "flag_courtyard_helicopter" },
    { 0x68EE77B7, "flag_delay" },
    { 0x0174DE2F, "flag_delete" },
    { 0x00E958DD, "flag_descriptor" },
    { 0x837C5307, "flag_detach" },
    { 0x1DC1E366, "flag_disable_proxcheck" },
    { 0xBF65C72E, "flag_e1_player_at_goal" },
    { 0x73216284, "flag_ender" },
    { 0xCC5A49E2, "flag_enemy" },
    { 0x03AC4EDB, "flag_entity" },
    { 0x6211B1F6, "flag_exists" },
    { 0xFD69AE59, "flag_fail_deadquote" },
    { 0x343777EB, "flag_fail_warning" },
    { 0xB97F28DE, "flag_flare" },
    { 0xA88B74E9, "flag_frontend_usecomputer" },
    { 0x8820647F, "flag_hanger_exploded" },
    { 0x21F4D678, "flag_heli_hit" },
    { 0x7BA7C8DC, "flag_hudelem" },
    { 0x3248CA1A, "flag_index" },
    { 0x0487D2C0, "flag_init" },
    { 0x5F536B2D, "flag_init_func" },
    { 0xF3B08CEB, "flag_inits" },
    { 0xE6207857, "flag_intro_melee_happened" },
    { 0x676C8967, "flag_intro_punch_happened" },
    { 0xE475EB2C, "flag_inuse" },
    { 0x4490B583, "flag_is_set_and_defined" },
    { 0x8F438E90, "flag_live" },
    { 0x881C5413, "flag_mine" },
    { 0x87913BAE, "flag_model_init" },
    { 0x883CF02B, "flag_model_update" },
    { 0x7ECEEC8D, "flag_msg" },
    { 0x8CEFBA83, "flag_name" },
    { 0xED02EE86, "flag_name_override" },
    { 0x63D87DB1, "flag_neutralized" },
    { 0x9EB7A335, "flag_notify" },
    { 0xBC189487, "flag_objective" },
    { 0x772B6060, "flag_on_cleared" },
    { 0x9B6C6092, "flag_on_flash" },
    { 0xA0C5CD17, "flag_on_notify" },
    { 0xFEA0B904, "flag_origin" },
    { 0x12674606, "flag_override" },
    { 0x25468769, "flag_owned" },
    { 0x5F60F263, "flag_pickup_dialogue" },
    { 0x9E9860DC, "flag_plant_trigger_string" },
    { 0x13657BF4, "flag_player_on_roof" },
    { 0x89C21A40, "flag_pos" },
    { 0x028FC434, "flag_primary" },
    { 0x157EC1F9, "flag_ref" },
    { 0xA58F66FE, "flag_reznov_to_helicopter" },
    { 0x4AF4433C, "flag_secondary" },
    { 0x050BF07E, "flag_set" },
    { 0xBF3A511D, "flag_set_delayed" },
    { 0xF5FA35CA, "flag_set_for_time" },
    { 0x6B2261D1, "flag_set_innseconds" },
    { 0x524FF423, "flag_set_on_completion" },
    { 0x69782929, "flag_set_on_death" },
    { 0x515B4437, "flag_set_player_trigger" },
    { 0xC6742DFE, "flag_set_touching" },
    { 0x438FB303, "flag_set_trigger" },
    { 0xB273CD8D, "flag_shared" },
    { 0x59F1D373, "flag_sound" },
    { 0x84AF67C3, "flag_spawn" },
    { 0x8A211487, "flag_str" },
    { 0xDB03FED9, "flag_string" },
    { 0xC852E2DF, "flag_target_spacing" },
    { 0xD08E2482, "flag_think" },
    { 0x5E2F0580, "flag_to_set" },
    { 0xA7FC7A66, "flag_to_set_when_done" },
    { 0x851DFEBB, "flag_to_wait_for" },
    { 0xC6D8CEA0, "flag_to_wait_for_2" },
    { 0x1A643666, "flag_toggle" },
    { 0x64476B2B, "flag_trigger_init" },
    { 0xD00F2901, "flag_triggers" },
    { 0x60B0E7FA, "flag_triggers_init" },
    { 0xE2D5F128, "flag_turret_for_use" },
    { 0xD0CA23A4, "flag_unset_trigger" },
    { 0x7B4B089D, "flag_wait" },
    { 0x6F126079, "flag_wait_all" },
    { 0xE3EB035E, "flag_wait_any" },
    { 0xC545CC04, "flag_wait_any_array" },
    { 0x1CECEB57, "flag_wait_array" },
    { 0x351FED27, "flag_wait_clear" },
    { 0xBBFEF1BB, "flag_wait_either" },
    { 0xDD26D891, "flag_wait_for_osc" },
    { 0x605D2120, "flag_wait_helper" },
    { 0x90E4805B, "flag_wait_on" },
    { 0x8EABFD13, "flag_wait_or_timeout" },
    { 0xCD463342, "flag_wait_then_func" },
    { 0x66193749, "flag_waitopen" },
    { 0xAE759F1B, "flag_waitopen_array" },
    { 0xC48E003F, "flag_waitopen_or_timeout" },
    { 0xE32CADDC, "flag_waits" },
    { 0xCE277565, "flag_watch_base" },
    { 0x3C1427E9, "flag_when_c4_thrown" },
    { 0x3C93E317, "flag_when_lowered" },
    { 0x6FF3B7FC, "flag_zone" },
    { 0x8B7851BF, "flag_zones" },
    { 0x0D311AF1, "flagactivatedelay" },
    { 0xE91E02C4, "flagattachradar" },
    { 0xED713354, "flagbase" },
    { 0x49ACCBA6, "flagbasefx" },
    { 0xEFF42F1D, "flagbasefxid" },
    { 0x5B609F84, "flagbearer" },
    { 0x9828EF23, "flagbearer_deathrun_start" },
    { 0xD8C3CD54, "flagbearer_interact_notetracks" },
    { 0x005861E6, "flagbearer_mantled" },
    { 0xBB5F2CEB, "flagbearer_outro_hud_cleanup" },
    { 0xC2DB2885, "flagbearer_plant_done" },
    { 0x6A73BD9B, "flagbearer_plant_start" },
    { 0x34CDD5BE, "flagbearer_shot_done" },
    { 0xAE2D0D0E, "flagbearer_shot_start" },
    { 0xA8E670D8, "flagbearer_waitnode_anim" },
    { 0x98F21AA7, "flagcanbeneutralized" },
    { 0xF2DEA157, "flagcapture" },
    { 0x3B3B5C82, "flagcapturecondition" },
    { 0x95E1E5E2, "flagcapturedfromneutral" },
    { 0x69AB2922, "flagcapturedfromteam" },
    { 0xBC06038E, "flagcapturegraceperiod" },
    { 0xD347EC14, "flagcapturelpm" },
    { 0x902E7F04, "flagcapturetime" },
    { 0x78729AFF, "flagcarried" },
    { 0xF48B6319, "flagcarrier" },
    { 0x019CF346, "flagchanging" },
    { 0x93185B38, "flagcount" },
    { 0x6149E6B8, "flagdecaytime" },
    { 0x6A59C02C, "flagenemyunattackable" },
    { 0x6A408C55, "flagenemyunattackableservice" },
    { 0xD1F6AA29, "flagged" },
    { 0x8B7AA105, "flagged_for_use" },
    { 0x160913BF, "flaghints" },
    { 0x15EC317C, "flaghudfx" },
    { 0x5FE77E56, "flaginactivedecay" },
    { 0x6AAE7BDE, "flaginactiveresettime" },
    { 0x6C65FBC5, "flagindex" },
    { 0x0A64C75D, "flaging" },
    { 0x540B233B, "flaglabel" },
    { 0x45A5813E, "flagminutes" },
    { 0x41D33DD2, "flagmodel" },
    { 0xC06225B2, "flagmsg" },
    { 0xA74BFB3E, "flagname" },
    { 0x095FC2B2, "flagneutralized" },
    { 0x7C7C95DF, "flagneutraltimer" },
    { 0x5B871639, "flagorder" },
    { 0x2B901199, "flagorigin" },
    { 0x71B6F01C, "flagradarmover" },
    { 0x69C415FC, "flagraise_trigger_wait" },
    { 0x96BAE806, "flagrespawntime" },
    { 0xFA265071, "flagreturn" },
    { 0xD49153A5, "flagrunner" },
    { 0x980D0A72, "flags" },
    { 0x2E4D4593, "flags_changed" },
    { 0x0C9E1DD3, "flags_do_or_check" },
    { 0x0D85161C, "flags_lock" },
    { 0x5E1ABB4B, "flags_set" },
    { 0xE699B4F5, "flagset" },
    { 0x66797AC4, "flagsets" },
    { 0x388469E6, "flagsetup" },
    { 0xB307AB0B, "flagsetupcomplete" },
    { 0xBDF758B1, "flagship" },
    { 0x32995E3D, "flagsowned" },
    { 0xC7D5D8AE, "flagspawninginstr" },
    { 0x58C98297, "flagspawns" },
    { 0x06649C84, "flagstring" },
    { 0x957E94CE, "flagsys" },
    { 0xF0A66D22, "flagsys_shared" },
    { 0xC7644472, "flagsys_wait" },
    { 0x9332F481, "flagsys_wait_any" },
    { 0x042504E2, "flagsys_wait_any_flag" },
    { 0x9F0EC48C, "flagsys_wait_clear" },
    { 0x5E79DBB0, "flagteam" },
    { 0xCE90A938, "flagtime" },
    { 0x2A410051, "flagtouchreturntime" },
    { 0xA52BE7E5, "flagtrig" },
    { 0x2AE00095, "flagtrigger" },
    { 0xA3B3700F, "flagwatchradarownerlost" },
    { 0x79539AC1, "flagzone" },
    { 0x2D1E3AE8, "flagzones" },
    { 0x1ED617C7, "flahslight_off" },
    { 0x84493DB3, "flahslight_on" },
    { 0x1796B02C, "flahslight_start" },
    { 0x90AC45EB, "flail" },
    { 0x48779BB5, "flailing" },
    { 0xAC9D6775, "flair" },
    { 0x1519FB5F, "flak" },
    { 0xB75DAA3D, "flak0" },
    { 0x8C2DE621, "flak0_destroyed" },
    { 0xF292592B, "flak0_satchel_trig" },
    { 0x915B2FD4, "flak1" },
    { 0xCD009678, "flak1_destroyed" },
    { 0x7298CA1C, "flak1_satchel_trig" },
    { 0x03629F0F, "flak2" },
    { 0x95C77AF3, "flak2_destroyed" },
    { 0x6493BF09, "flak2_satchel_trig" },
    { 0xDD6024A6, "flak3" },
    { 0x5DBC3192, "flak3_destroyed" },
    { 0x2E295082, "flak3_satchel_trig" },
    { 0x2D335F57, "flak88" },
    { 0xABF01F24, "flak88_bomb_model" },
    { 0x888801EA, "flak88_bomb_model_obj" },
    { 0x4A3FE0B2, "flak88_cleanup_after_death" },
    { 0x004CF3B6, "flak88_crew_waittill_damage" },
    { 0x186136F5, "flak88_crew_waittill_death" },
    { 0xAC3D2627, "flak88_dismount_crew" },
    { 0xC755C1B6, "flak88_explosives" },
    { 0x4744B34A, "flak88_explosives_wait" },
    { 0x858D7E97, "flak88_guard_array" },
    { 0x5A5DBEC4, "flak88_init" },
    { 0x15DBD09E, "flak88_shell_model" },
    { 0xFB3E151E, "flak88_waittill_crewdead" },
    { 0xC558840E, "flak88s" },
    { 0x62B3D689, "flak_accuracy" },
    { 0x5E55FE68, "flak_accuracy_min" },
    { 0x378A9A2A, "flak_acquire_target" },
    { 0xE3186EC8, "flak_and_crew_removesplashsheild" },
    { 0x76D04DDC, "flak_and_crew_splashsheild" },
    { 0x4D5183D1, "flak_area" },
    { 0xCEC71DBD, "flak_damage_godrays" },
    { 0x5BBD3DF5, "flak_death_think" },
    { 0xBC90446F, "flak_defense_trig" },
    { 0xE86E3963, "flak_destroyed" },
    { 0xCC429308, "flak_drone" },
    { 0xC74A93F2, "flak_drone_hover_acceleration" },
    { 0xCF6EFBA7, "flak_drone_hover_height" },
    { 0x14BAD6A3, "flak_drone_hover_height_variance" },
    { 0x8F2D57BB, "flak_drone_hover_inner_radius" },
    { 0x5F24288C, "flak_drone_hover_outter_radius" },
    { 0x08C008CA, "flak_drone_hover_point_spacing" },
    { 0xBB628F9C, "flak_drone_hover_radius" },
    { 0xAFDF262B, "flak_drone_hover_speed" },
    { 0xD5C3ADEE, "flak_drone_missile_too_close_to_parent_distance" },
    { 0x9012A484, "flak_drone_move_speed" },
    { 0x25F7AC52, "flak_drone_name" },
    { 0x089AA6DE, "flak_drone_near_goal_notify_dist" },
    { 0x53B4E1BE, "flak_drone_spawn_offset" },
    { 0x1B4F65D2, "flak_drone_stun_duration" },
    { 0x9AA02EC6, "flak_drone_time_at_same_position_max" },
    { 0x3FFA5038, "flak_drone_time_at_same_position_min" },
    { 0x294E4669, "flak_drone_vehicle_name" },
    { 0x23DF2144, "flak_flankers" },
    { 0xFBA56A1B, "flak_front_of_pby" },
    { 0x41D93438, "flak_large_hole" },
    { 0xBE6C233F, "flak_maxrange" },
    { 0x18421121, "flak_maxrange_squared" },
    { 0x446BA842, "flak_mg_nosight_toggle" },
    { 0x82624CA5, "flak_minrange" },
    { 0xB525231B, "flak_minrange_squared" },
    { 0xACADFE36, "flak_moment" },
    { 0xA27F788A, "flak_monitorturretangles" },
    { 0xB4C322B4, "flak_org" },
    { 0x677511D4, "flak_pos_tag_barrel" },
    { 0x75A3A0F6, "flak_pos_tag_flash" },
    { 0xC47D2731, "flak_rumble" },
    { 0xC2259ED0, "flak_rumble_start" },
    { 0x396DA7C7, "flak_shoot" },
    { 0x8FAD936A, "flak_spot" },
    { 0xC1A079AD, "flak_target" },
    { 0x810FC758, "flak_target_think" },
    { 0xD2F99BC9, "flak_tracer" },
    { 0xD61074C0, "flak_tracers" },
    { 0x403F990B, "flak_trigs" },
    { 0xA63FFD95, "flak_use_dismount" },
    { 0x7790BE5C, "flakai_cleared" },
    { 0x3D98386E, "flakaicountmod" },
    { 0xF3A0E643, "flakbarrel" },
    { 0xEA02090C, "flakcenter" },
    { 0x3054299E, "flakcrew_animation_think" },
    { 0x9368C678, "flakcrew_gunbackinhand" },
    { 0xBF1CE51E, "flakcrew_playanim" },
    { 0xDE4B9486, "flakdistance" },
    { 0xB56848AC, "flakdronedamageoverride" },
    { 0x0958D917, "flakdronedistancetogoalsquared" },
    { 0x9B596A7F, "flakgun" },
    { 0x93658D81, "flakjacket" },
    { 0x6756D9BC, "flakjacket_data" },
    { 0xDB237309, "flakjacketclaymore" },
    { 0x11C64459, "flakjacketprotected" },
    { 0x4412788A, "flakjacketprotectedmp" },
    { 0x855FFD52, "flakname" },
    { 0xA4CE275B, "flakorg" },
    { 0x5DFEBEE6, "flaks" },
    { 0x354F9F68, "flaks_alive" },
    { 0x45FE510A, "flaks_left" },
    { 0x89EB200C, "flakspawners_retreat" },
    { 0xDB29ACD4, "flaktrack_end_of_path" },
    { 0xC2EA0D6D, "flakvierling" },
    { 0xD073D966, "flame" },
    { 0xF7E1CF21, "flame_allowed_time" },
    { 0xE8664FFA, "flame_anim" },
    { 0x9069F9DA, "flame_battle_left1" },
    { 0x6A677F71, "flame_battle_left2" },
    { 0x44650508, "flame_battle_left3" },
    { 0xB392DB7D, "flame_battle_right1" },
    { 0xD99555E6, "flame_battle_right2" },
    { 0x485BB969, "flame_building" },
    { 0x7C11E354, "flame_bunker_array" },
    { 0x0CACF902, "flame_bunker_continue" },
    { 0x12A69097, "flame_bunker_get_flame_vo" },
    { 0x5D25AE5D, "flame_bunker_inside" },
    { 0x19102CE0, "flame_bunker_mg_damage_total" },
    { 0x68B86604, "flame_bunker_vo" },
    { 0xA365BC73, "flame_bunker_vo_2" },
    { 0x416D6E49, "flame_burst" },
    { 0x39631721, "flame_burst_admin" },
    { 0xC9E1203B, "flame_burst_ensure_dmg" },
    { 0x53393995, "flame_chance" },
    { 0xE571E237, "flame_damage_fx" },
    { 0xCB3B7CB9, "flame_damage_over_time" },
    { 0xC9BE53B6, "flame_damage_time" },
    { 0xFB9494C3, "flame_death_canned" },
    { 0x039D8298, "flame_death_d" },
    { 0xB7251C46, "flame_death_fx" },
    { 0xD4A3AB45, "flame_death_ragdoll" },
    { 0x943D2EB4, "flame_death_run_die" },
    { 0xFBCF0013, "flame_disabler" },
    { 0xC47A489B, "flame_enemies" },
    { 0x60243AF9, "flame_fire" },
    { 0xFFC5CC47, "flame_fx_timeout" },
    { 0x729D5631, "flame_guy_death" },
    { 0x4A88B888, "flame_guy_explode" },
    { 0xB7567C39, "flame_guys" },
    { 0x7E6F74C6, "flame_guys_func" },
    { 0x642E3736, "flame_instakill" },
    { 0x3E7972BD, "flame_jets" },
    { 0x20E33CC4, "flame_kills" },
    { 0x78D69362, "flame_move_target" },
    { 0x919C9F86, "flame_notify" },
    { 0x776EBCB6, "flame_nva" },
    { 0xDDD43D7F, "flame_nva_spawner" },
    { 0x6412390E, "flame_on_success" },
    { 0x6E4FF357, "flame_overlay" },
    { 0x777D8209, "flame_squad_remainder" },
    { 0xFF89B2D3, "flame_thrower_guy_dead" },
    { 0x55E60C02, "flame_time" },
    { 0x368513F2, "flame_time_threshold" },
    { 0x1D9BC51B, "flame_tree_flamed" },
    { 0x80985052, "flame_trig_watcher" },
    { 0xDBD7C10B, "flame_trigger" },
    { 0x3D4681B6, "flame_truck" },
    { 0x2FA38658, "flame_truck_setup" },
    { 0x977EA33F, "flame_vision_enabled" },
    { 0x37CD5851, "flame_vision_trigger_think" },
    { 0xC12031F3, "flamebased" },
    { 0xDB88016D, "flamebunker" },
    { 0x925BD223, "flamebunker_death_fx" },
    { 0x0AC7EBB6, "flamebunker_death_shoot" },
    { 0x2FAC5686, "flameburntime" },
    { 0x6419D816, "flamed" },
    { 0x97BB6C9D, "flamedamage" },
    { 0x8F2C4D50, "flamedeath" },
    { 0x0C56AB5F, "flameguy" },
    { 0x8D2C9A5C, "flameguy_init" },
    { 0x63FB0F17, "flameguy_spawn" },
    { 0x8B1E9F7A, "flameguy_spawner" },
    { 0x88DBCF06, "flameguy_think" },
    { 0x2083E98B, "flamejet" },
    { 0xAE30DE2D, "flamejetfx" },
    { 0x012213EA, "flamejets" },
    { 0xDD125B85, "flamepaintime" },
    { 0xE032A030, "flamer" },
    { 0xCF3D8440, "flamer_advance_bunkers" },
    { 0x8C1132D5, "flamer_arrays" },
    { 0x177DBB3B, "flamer_blow" },
    { 0xCB9AC041, "flamer_fire_towards_building" },
    { 0x45B0D67A, "flamer_setup" },
    { 0x8B44CCE7, "flamer_spawn_strat" },
    { 0x33814C3F, "flamer_spot" },
    { 0xA9F978E7, "flamer_strat" },
    { 0x14B9048E, "flamer_strat_fake_death" },
    { 0x0CDDF813, "flamer_util" },
    { 0x6798477F, "flamerplayer" },
    { 0x727FDB9B, "flamers" },
    { 0x06351A99, "flames" },
    { 0xEFE7D501, "flamestarttime" },
    { 0x9DCAE555, "flamesweeptime" },
    { 0xE506772E, "flametank" },
    { 0xFA22EB27, "flametank_carnage_event" },
    { 0xC38F46EB, "flametank_dead" },
    { 0xA10DA505, "flametank_in_second_area" },
    { 0x20DFDA2E, "flametank_riders" },
    { 0xB68F1FED, "flametank_started_flaming" },
    { 0x465A47CD, "flametank_tree_sniper" },
    { 0x70B42F51, "flametanks" },
    { 0xF3E2ED90, "flametargets" },
    { 0xF37A2BDF, "flamethrower" },
    { 0x47CC19D5, "flamethrower_anim" },
    { 0x0F9C58E2, "flamethrower_attached" },
    { 0xEA078EEF, "flamethrower_complete" },
    { 0x1D54DBAD, "flamethrower_damage_zombies" },
    { 0x3C61AAC5, "flamethrower_fx_watcher" },
    { 0x8AAB5AB1, "flamethrower_hint" },
    { 0xAF6211C5, "flamethrower_linked" },
    { 0x18140C1A, "flamethrower_offset_x" },
    { 0x3E168683, "flamethrower_offset_y" },
    { 0xCC0F1748, "flamethrower_offset_z" },
    { 0x98AC8A48, "flamethrower_origin" },
    { 0xC14A17DB, "flamethrower_pick_target" },
    { 0x3B2914EE, "flamethrower_pickup" },
    { 0xAC2160F5, "flamethrower_prox" },
    { 0x569994F9, "flamethrower_reload" },
    { 0x6E485447, "flamethrower_shoot" },
    { 0x19338AA1, "flamethrower_stop_" },
    { 0x3ECAE062, "flamethrower_stop_shoot" },
    { 0x2FBE022B, "flamethrower_swap" },
    { 0x4BD49962, "flamethrower_trigger" },
    { 0x58A4E300, "flamethrower_trigger_array" },
    { 0x3FC80DB1, "flamethrower_turret_think" },
    { 0x71732FE8, "flamethrower_tutorial" },
    { 0xEF6B1866, "flamethrowers" },
    { 0x2815C9AA, "flamethrowershootdelay_max" },
    { 0xAB010BB4, "flamethrowershootdelay_min" },
    { 0x52FBD154, "flamethrowershootswitch" },
    { 0x210ECE87, "flamethrowershootswitchtimer" },
    { 0xD205E46C, "flamethrowershoottime_max" },
    { 0x0F69EF82, "flamethrowershoottime_min" },
    { 0xC0534A6B, "flamethrowertank" },
    { 0x6CE66618, "flamethrowertankattachtag" },
    { 0x7107391A, "flamethrowertankmodel" },
    { 0x1654FAD9, "flametime" },
    { 0xD3FBADF9, "flametimer" },
    { 0xEC9023A6, "flametrigger" },
    { 0xB8C7536D, "flameup" },
    { 0xBCE1D71F, "flaming" },
    { 0xE1FC89CE, "flaming_horse_logic" },
    { 0x95B26E6D, "flaming_left1_done" },
    { 0xB2D9CF34, "flaming_left2_done" },
    { 0x49ACC863, "flaming_left3_done" },
    { 0x57385F40, "flaming_right1_done" },
    { 0x0B203D69, "flaming_right2_done" },
    { 0x8959FDF8, "flamingbull" },
    { 0xDEC85BBA, "flammable" },
    { 0xDCE6D9EA, "flammable_crate_burn" },
    { 0xBBE4AFB8, "flammable_crate_explode" },
    { 0x1141F373, "flammable_crate_think" },
    { 0x26C5DC15, "flank" },
    { 0xCD239328, "flank_brush" },
    { 0xC44076F9, "flank_guy" },
    { 0x4CCCE46C, "flank_node" },
    { 0xBB9A1F67, "flank_player_at_flashroom" },
    { 0x536C2D42, "flanked" },
    { 0x3F497B84, "flanker" },
    { 0x5AABC514, "flanker_hint" },
    { 0xB5EE9F37, "flankers" },
    { 0xCD2A723C, "flankers2_dead" },
    { 0x4599F313, "flanking" },
    { 0x9471EEFD, "flanking_wall_breached" },
    { 0x0C99AC64, "flanks" },
    { 0xBEECD80F, "flanks_apartment" },
    { 0x334E05FC, "flap" },
    { 0x6B12FA1D, "flappy" },
    { 0xBBFC8377, "flare" },
    { 0xE7B52F11, "flare_burns_out" },
    { 0xC3B4AE5C, "flare_burstdist" },
    { 0xCF066557, "flare_dir" },
    { 0x2B8C6F07, "flare_distance" },
    { 0x786CF31A, "flare_done" },
    { 0x34DF2439, "flare_ent" },
    { 0x3A57D1C8, "flare_explodes" },
    { 0xF76716AF, "flare_fade_node" },
    { 0xECFCBA2E, "flare_fire_1" },
    { 0xC6FA3FC5, "flare_fire_2" },
    { 0x67ECACD3, "flare_from_targetname" },
    { 0x5A75A068, "flare_fx" },
    { 0xCAD16CC6, "flare_get_dvar" },
    { 0x0BCECDB8, "flare_get_dvar_int" },
    { 0x8B595109, "flare_guard_lives" },
    { 0x7E8D1A53, "flare_guy" },
    { 0xA80512C9, "flare_guy_alive" },
    { 0xF3E26AFD, "flare_guy_killed" },
    { 0xE34A8F1C, "flare_guy_killed_flare" },
    { 0xD0A8E646, "flare_guy_lives_flare" },
    { 0xA4EA1A47, "flare_height" },
    { 0xA9A7CE20, "flare_init_flags" },
    { 0xDD766B03, "flare_initial_fx" },
    { 0x2EC82FFF, "flare_intro_node" },
    { 0xEC817988, "flare_monitor" },
    { 0x38505829, "flare_off" },
    { 0xEEF31147, "flare_path" },
    { 0xA9F08B43, "flare_sky_effect" },
    { 0xBFB3BFCD, "flare_starts" },
    { 0xF003C585, "flare_suncolor" },
    { 0xCBB8DDFB, "flareangles" },
    { 0x37E82979, "flareattackerdamage" },
    { 0x5BFD6E85, "flareburnoutfadewait" },
    { 0x6E9F8648, "flarebutton1" },
    { 0xE0A6F583, "flarebutton2" },
    { 0x3EF91884, "flarecount" },
    { 0x5E9FDC16, "flared_or_tabuned_death" },
    { 0x2AF78660, "flaredistancescale" },
    { 0xD7A4EEBA, "flaredistancesq" },
    { 0x2A99941F, "flareduration" },
    { 0x69AEC6F7, "flareeffectarea" },
    { 0xF51B5B1D, "flarelookawayfadewait" },
    { 0x472A5BC6, "flareobject" },
    { 0x824E4826, "flareoffset" },
    { 0xFC5906D5, "flareorigin" },
    { 0x3F91AE77, "flareplane" },
    { 0x2C9AFCAE, "flares" },
    { 0xC593B2B1, "flares_fire" },
    { 0x127A770E, "flares_fire_burst" },
    { 0x02506BDC, "flares_get_vehicle_velocity" },
    { 0x64314203, "flares_out" },
    { 0x188749F3, "flares_redirect_missiles" },
    { 0x2A9E87DB, "flares_think" },
    { 0x6F46E1AE, "flarespeedscale" },
    { 0xB94D1846, "flaretargetents" },
    { 0xE3C40B24, "flaretime" },
    { 0xFB0E1D43, "flarevision" },
    { 0x2258C0C9, "flarevisioneffectheight" },
    { 0x1EE87B3A, "flarevisioneffectradius" },
    { 0x4D685008, "flarewait" },
    { 0xE22C5811, "flasbacks" },
    { 0x8C24652D, "flash" },
    { 0x81FC3829, "flash_angle" },
    { 0xE04BDB6B, "flash_barrel_01_start" },
    { 0x88F21728, "flash_barrel_02_start" },
    { 0xC1CBEA5B, "flash_center_text" },
    { 0x87679B06, "flash_chamber" },
    { 0xE5CCD92C, "flash_chamber_doors" },
    { 0xAD3FB8D3, "flash_chamber_fans" },
    { 0x0A4CD362, "flash_cluster_armed" },
    { 0x86BB8607, "flash_cluster_deployed" },
    { 0xC0F77B61, "flash_color_deleted_left" },
    { 0x7D54D1CC, "flash_color_deleted_right" },
    { 0xBD47CAEB, "flash_color_left" },
    { 0xECCC8E5E, "flash_color_right" },
    { 0xF234747D, "flash_count" },
    { 0xDE7B3F49, "flash_dialog_six" },
    { 0xABE92F21, "flash_dialog_three" },
    { 0xC1ADD290, "flash_dist" },
    { 0xF436E711, "flash_dogs" },
    { 0x974E1F70, "flash_door" },
    { 0xA2A8141B, "flash_fade_frames" },
    { 0xE8EB87AC, "flash_fade_in_time" },
    { 0x63ABBB6D, "flash_fade_out_time" },
    { 0x8466502E, "flash_frames" },
    { 0x4A3FAF73, "flash_grenade_thrown" },
    { 0x174A8011, "flash_guy" },
    { 0x0E7086D4, "flash_hold_frames" },
    { 0xC51AC806, "flash_immunity" },
    { 0xD5A78C43, "flash_in_effect" },
    { 0xC23F1FD5, "flash_light_fx" },
    { 0x92502E85, "flash_light_tag" },
    { 0xDF3C225F, "flash_lights" },
    { 0x23E0AC90, "flash_lighttower_mod_original" },
    { 0x83103AC4, "flash_normally" },
    { 0xED7F4CC6, "flash_origin" },
    { 0x6D01FD48, "flash_out_effect" },
    { 0xCA19A1EF, "flash_pentagon_numbers" },
    { 0x885F0ABE, "flash_points1" },
    { 0x625C9055, "flash_points2" },
    { 0x3C5A15EC, "flash_points3" },
    { 0xB9C4F76E, "flash_pos" },
    { 0x4424B527, "flash_room_doors" },
    { 0x563B2EBC, "flash_rumble_loop" },
    { 0x9BD92AE8, "flash_scavenger_icon" },
    { 0x96586204, "flash_screen_fade_out" },
    { 0xAFA83786, "flash_screen_white" },
    { 0x234FA07F, "flash_signal_failure" },
    { 0x44AB9EF5, "flash_text" },
    { 0xF1A4583E, "flash_throw_offset" },
    { 0x9BDE339B, "flash_time" },
    { 0x25593E23, "flash_timer" },
    { 0x3B2AFDD4, "flash_trigger" },
    { 0xE9E6B3E9, "flash_volumes" },
    { 0xB1D4A001, "flash_wait_time" },
    { 0x90F0181E, "flash_wait_time_max" },
    { 0x237839C0, "flash_wait_time_min" },
    { 0x0772C9AE, "flash_warning_indicator" },
    { 0xF28CDDBC, "flash_warroom_numbers" },
    { 0xC20C9940, "flash_watch_trigger" },
    { 0xF378BC13, "flash_when_low" },
    { 0xF76CE35D, "flashanimarray" },
    { 0xF0BD555E, "flashanimindex" },
    { 0x2ABA9C3D, "flashanims" },
    { 0xC63675E8, "flashback" },
    { 0xA5DA780D, "flashback_1_trig" },
    { 0xED3D7194, "flashback_activated" },
    { 0x825F6A3B, "flashback_audio" },
    { 0x50DB3269, "flashback_clone_duration" },
    { 0xA9A99BBB, "flashback_disappear_fx" },
    { 0x4861F35E, "flashback_disappear_sound_1p" },
    { 0x4B332708, "flashback_disappear_sound_3p" },
    { 0x86A802C3, "flashback_done" },
    { 0xEF86D7B7, "flashback_fade_in_time" },
    { 0x3908E0BC, "flashback_fade_out_time" },
    { 0xD333FC12, "flashback_hud" },
    { 0x39F96758, "flashback_material_ghost" },
    { 0xD89B99C0, "flashback_movie_done" },
    { 0x678FB7D6, "flashback_movie_play" },
    { 0x5FF245A1, "flashback_reappear_sound_1p" },
    { 0x6049104B, "flashback_reappear_sound_3p" },
    { 0xB4DA9D8C, "flashback_reappear_tagfx" },
    { 0xA1D67EAC, "flashback_shader_const" },
    { 0x38E6BD2E, "flashback_shader_x_unused" },
    { 0xC3C4FB77, "flashback_shader_y_hdr_brightness" },
    { 0xE83F009C, "flashback_shader_z_tint_index" },
    { 0x1845CBDE, "flashback_trail_fx" },
    { 0x1700A757, "flashback_trail_impact_fx" },
    { 0x0DFB09F6, "flashback_vo" },
    { 0x9287C0C4, "flashback_warp_length" },
    { 0xCDB8EDC5, "flashbackfinish" },
    { 0xC0AD7D83, "flashbacks" },
    { 0x069C334C, "flashbackstart" },
    { 0xBA21BE83, "flashbacktime" },
    { 0x62618CFE, "flashbacktrailfx" },
    { 0x7D14AE92, "flashbacktrailimpact" },
    { 0x974E802B, "flashbang" },
    { 0x306F38EF, "flashbang_ammo_monitor" },
    { 0xF9FD7C9F, "flashbang_detect" },
    { 0x9041F64E, "flashbang_from_corner" },
    { 0x47DDA1DB, "flashbang_from_corner_nade" },
    { 0xF116107D, "flashbang_hint" },
    { 0xF3CD241C, "flashbanganim" },
    { 0xD6B86360, "flashbanged" },
    { 0x45EDB799, "flashbangers" },
    { 0x8ADBD349, "flashbangimmunity" },
    { 0x22ABCC0A, "flashbangs" },
    { 0xCD188C9A, "flashdelay" },
    { 0x5F40E686, "flashdonetime" },
    { 0x53C623C1, "flashduration" },
    { 0x16193DDA, "flashed" },
    { 0xC31E972E, "flashed_debug" },
    { 0xAAE38E5E, "flashed_hud_elem" },
    { 0x9E3FA005, "flashedanim" },
    { 0x37DBAEB7, "flashendtime" },
    { 0xE84853A5, "flashes" },
    { 0xDBA34317, "flashes_needed" },
    { 0x50B39C45, "flashfrac" },
    { 0xF8C61387, "flashfunc" },
    { 0x9C36D33F, "flashgrenadeindex" },
    { 0xF5F10E8C, "flashgrenades" },
    { 0xF95F28BB, "flashing" },
    { 0x3A56FB68, "flashing_delta_time" },
    { 0x9DD12C72, "flashing_is_on" },
    { 0xB55E3660, "flashing_min_timer" },
    { 0x1CDA2E89, "flashing_timer" },
    { 0xE15A4480, "flashing_timers" },
    { 0x070B8821, "flashing_value" },
    { 0x250A4EC8, "flashing_values" },
    { 0xEB1CB310, "flashinglights" },
    { 0x2146CAA3, "flashingsignalfailure" },
    { 0xEB5A0CF8, "flashingteam" },
    { 0x89231C3B, "flashlight" },
    { 0xEC4569C4, "flashlight_ambush_spawner_death_count" },
    { 0xDBBEE341, "flashlight_ambush_spawner_death_counter" },
    { 0xD59FE6E3, "flashlight_ambush_spawner_death_max" },
    { 0xC4AD81A5, "flashlight_ambush_spawner_death_watcher" },
    { 0x21F0AC9B, "flashlight_anim_setup" },
    { 0x13AC804D, "flashlight_enabled" },
    { 0x5411C652, "flashlight_fire" },
    { 0x9EA6348B, "flashlight_fx_change" },
    { 0xEF2DF2FA, "flashlight_fx_ent" },
    { 0x1D151E2F, "flashlight_guy" },
    { 0x7F4A9591, "flashlight_guy_attacks" },
    { 0x20CDF5A2, "flashlight_light" },
    { 0x99FB3B6D, "flashlight_light_death" },
    { 0x3B69ABC0, "flashlight_mason" },
    { 0xE9F51B3A, "flashlight_melee_detection" },
    { 0xBC577E03, "flashlight_melee_handle" },
    { 0xAC29CE9D, "flashlight_off" },
    { 0x4EF23451, "flashlight_on" },
    { 0x8FB9BE15, "flashlight_on_off_enabled" },
    { 0x919286B8, "flashlight_pos" },
    { 0x1E146A82, "flashlight_pos_name" },
    { 0xAE8113DD, "flashlight_seal" },
    { 0xE4DCA1D6, "flashlight_spawner" },
    { 0x9EFC13D3, "flashlight_tgt" },
    { 0x1B90DE53, "flashlight_tgt_name" },
    { 0x71FF89C7, "flashlight_toss" },
    { 0x758B9000, "flashlight_vc_behavior" },
    { 0x58DFB466, "flashlight_visionset" },
    { 0x1ED37D5C, "flashlight_visionset_off" },
    { 0xA36F91DA, "flashlights" },
    { 0x55062EAF, "flashlightweapon" },
    { 0xC897003D, "flashmonitor" },
    { 0xB7669DB2, "flashnearbyallies" },
    { 0x9BE82A29, "flashorg" },
    { 0x7D9348F5, "flashpoint" },
    { 0xE6427F40, "flashpoint_amb" },
    { 0x9AEE1D17, "flashpoint_anim" },
    { 0x411404CE, "flashpoint_anims" },
    { 0xF8C1E977, "flashpoint_art" },
    { 0xB6196E66, "flashpoint_e1" },
    { 0x307FBE42, "flashpoint_e10" },
    { 0x568238AB, "flashpoint_e11" },
    { 0xE47AC970, "flashpoint_e12" },
    { 0x0A7D43D9, "flashpoint_e13" },
    { 0xC889A7E6, "flashpoint_e14" },
    { 0xEE8C224F, "flashpoint_e15" },
    { 0x7C84B314, "flashpoint_e16" },
    { 0xA2872D7D, "flashpoint_e17" },
    { 0x9016F3FD, "flashpoint_e2" },
    { 0x6A147994, "flashpoint_e3" },
    { 0x4411FF2B, "flashpoint_e4" },
    { 0x1E0F84C2, "flashpoint_e5" },
    { 0xF80D0A59, "flashpoint_e6" },
    { 0xD20A8FF0, "flashpoint_e7" },
    { 0x0C2FBC17, "flashpoint_e8" },
    { 0xE62D41AE, "flashpoint_e9" },
    { 0xAA00E172, "flashpoint_fx" },
    { 0x84EE8F7A, "flashpoint_obj_c4_building" },
    { 0x773CC726, "flashpoint_obj_clear_out_comms" },
    { 0x65D496BF, "flashpoint_obj_destroy_rocket" },
    { 0xC22665ED, "flashpoint_obj_escape_base" },
    { 0xEE56F1A8, "flashpoint_obj_get_disguise" },
    { 0xD3990230, "flashpoint_obj_get_to_comms" },
    { 0xD03E8AC0, "flashpoint_obj_meet_squad" },
    { 0x1C0FB660, "flashpoint_obj_rescue_weaver" },
    { 0x5B34D4EF, "flashpoint_obj_stealth" },
    { 0x40279721, "flashpoint_obj_stop_rocket" },
    { 0x1CBC5B5A, "flashpoint_portal" },
    { 0x707E79DC, "flashpoint_util" },
    { 0x1B6CD19F, "flashrate" },
    { 0x449AAFD6, "flashroom_enemy_flank_player" },
    { 0xB3800D86, "flashrumbleduration" },
    { 0xE6350C5C, "flashrumbleloop" },
    { 0xD514AB92, "flashsound" },
    { 0x81DB17DD, "flashthread" },
    { 0xC030DCE7, "flashthrown" },
    { 0x3215E285, "flashtype" },
    { 0xD45C9EB6, "flashy" },
    { 0x9B441C58, "flat" },
    { 0xC10FFF5C, "flat_always" },
    { 0xC12BF938, "flat_angle" },
    { 0xE17A8193, "flat_angles" },
    { 0xBFEC607E, "flat_mapped_normal_vector" },
    { 0xEE111AFC, "flat_mapped_old_normal_vector" },
    { 0xEA2A359B, "flat_never" },
    { 0x7BA59F8D, "flat_origin" },
    { 0x0D15444D, "flat_spinners" },
    { 0x27146D56, "flat_vector" },
    { 0xB0CECACD, "flatbed" },
    { 0x35462BD8, "flatbed_guys" },
    { 0x56824EE1, "flaten" },
    { 0x5546E201, "flaten_vector" },
    { 0xAB15F45D, "flatly" },
    { 0x3C7FDC49, "flatness" },
    { 0x8A5505F5, "flatten" },
    { 0x0FDE018F, "flattenalltires" },
    { 0xBC8DAD22, "flattened" },
    { 0xE3740AE7, "flattened_out" },
    { 0xC4C61183, "flattenedplayerorigin" },
    { 0x3C689C3D, "flattenedscramblerorigin" },
    { 0x24F7AD26, "flattenedselforigin" },
    { 0x6DC1D8B8, "flattenroll" },
    { 0x2659FDC4, "flattens" },
    { 0x1913DB96, "flattenyaw" },
    { 0x225EEF99, "flatter" },
    { 0x36D29042, "flattirechance" },
    { 0x1B88D61B, "flattirechanceaccumulation" },
    { 0x7ABF2747, "flattirecount" },
    { 0x7834AEBE, "flatvec" },
    { 0x66B86340, "flavors" },
    { 0x0D4B8B93, "flaw" },
    { 0xD7E5D248, "flawed" },
    { 0x489E76D6, "flechettes" },
    { 0x96D52ACD, "flee" },
    { 0x16F1427A, "flee_guy_runs" },
    { 0x20BA71FE, "flee_heat_area" },
    { 0x2D36B60C, "flee_hideout" },
    { 0x437ED024, "flee_node" },
    { 0xE90B0C01, "flee_overpass" },
    { 0x48731FDB, "fleeing" },
    { 0x2ADBA0F2, "fleeing_civ_goto" },
    { 0x03023C5F, "fleeing_drones" },
    { 0xFEC21817, "fleeing_drones_spawn" },
    { 0x874EB7E3, "fleet" },
    { 0x75AAA436, "fleft" },
    { 0x086AEAD9, "flength" },
    { 0x703E1129, "flerptime" },
    { 0x3F6BA8A9, "flesh" },
    { 0xC092CF3B, "flesh_hit" },
    { 0x9D903380, "flesh_hit_body_fatal_exit" },
    { 0x1279112A, "flesh_hit_head_fatal_exit" },
    { 0x8C868CA1, "flesh_hit_knife" },
    { 0x4E54BE9C, "flesh_hit_neck_fatal" },
    { 0x349671CE, "flesh_hit_splat_large" },
    { 0x189A958F, "flesh_slash_knife_blood_emitter" },
    { 0x71B038D6, "fleshed" },
    { 0x67C4804C, "fleshhit" },
    { 0xE83A5D7C, "fletcher" },
    { 0xECFCDDCB, "fletcher_ai_biggun_fire" },
    { 0x94339991, "fletcher_ai_biggun_think" },
    { 0xBA5C2BA7, "fletcher_ai_turret_think" },
    { 0x12598F5B, "fletcher_animation" },
    { 0x11EEDF5B, "fletcher_client_init" },
    { 0xC3D523FD, "fletcher_init" },
    { 0x62AEDA3F, "fletchers" },
    { 0x07548591, "flevel" },
    { 0x4301C62F, "flew" },
    { 0x34C93E52, "flexibility" },
    { 0x976C7346, "flexiblethreatwaiter" },
    { 0x52EA5C7E, "flick" },
    { 0xC940F4B0, "flick_the_cig" },
    { 0x215C229A, "flick_time" },
    { 0x27CA79A7, "flicker" },
    { 0x52410B2C, "flicker_amt" },
    { 0x09144A83, "flicker_field_fx" },
    { 0x942B0167, "flicker_killer" },
    { 0x319DC11E, "flicker_light" },
    { 0x33CB7B81, "flicker_lights" },
    { 0xDE14E1B9, "flicker_off" },
    { 0x9241D2CD, "flicker_on" },
    { 0xFDC80DDA, "flicker_out_time" },
    { 0x211BAA36, "flicker_start_time" },
    { 0x1B78964A, "flicker_stop" },
    { 0x5E802304, "flicker_time_high" },
    { 0x36CE3356, "flicker_time_low" },
    { 0x5AFAC779, "flickering" },
    { 0xD0D85406, "flickering_func" },
    { 0xA6EE4D43, "flickering_lights" },
    { 0xDF98EDB0, "flickerings" },
    { 0x060E2645, "flickerlight" },
    { 0x6337E98C, "flickerlightintensity" },
    { 0x51863D1E, "flickers" },
    { 0xB5C7A5B4, "flickertime" },
    { 0x8500502E, "flickertimemax" },
    { 0xD7D7BEF0, "flickertimemin" },
    { 0x2D729005, "flickervisionset" },
    { 0xD56D7504, "flickery" },
    { 0x762AB082, "flicking" },
    { 0x7EC57961, "flicks" },
    { 0xB13CC540, "flies" },
    { 0x95C0C0AF, "flight" },
    { 0xABE31CCB, "flight_crash" },
    { 0x6FBCBB06, "flight_crash_overlay" },
    { 0x4F659063, "flight_crash_rotate" },
    { 0x9F1C24A4, "flight_dialogue" },
    { 0x63FCDBAA, "flight_flags_think" },
    { 0x8372DA91, "flight_helicopter" },
    { 0xA2115714, "flight_helicopter_dlight" },
    { 0x92DC0EE9, "flight_helmet" },
    { 0x386D3F78, "flight_helmet_cleanup" },
    { 0x1ED41CFC, "flight_helmet_listener" },
    { 0xB97E2D55, "flight_time" },
    { 0x4E123F8E, "flightannounce" },
    { 0xD5D1A786, "flightplan" },
    { 0xBBB60F75, "flightstick" },
    { 0x66A9FA16, "fligth_missile" },
    { 0xBC21D648, "flimptime" },
    { 0x78A443E9, "flimptime_accel" },
    { 0xE326A4FB, "flimptime_deccel" },
    { 0x37C63E87, "flinch" },
    { 0x0FC767CD, "flinch_anim" },
    { 0x617180EA, "flinch_done" },
    { 0x7278E048, "flinchanim" },
    { 0x33646074, "flinchcount" },
    { 0x969BE173, "flinches" },
    { 0xF2C54CD9, "flinching" },
    { 0xF1E5A649, "flinchwhensuppressed" },
    { 0x7ADD2A61, "fling" },
    { 0x7D303FCE, "fling_ai" },
    { 0x455A1653, "fling_anim" },
    { 0xDDBF5065, "fling_avogadro" },
    { 0x299AD4B8, "fling_body" },
    { 0xDFB4AA79, "fling_dir" },
    { 0x28052BED, "fling_drones" },
    { 0x992A286D, "fling_force" },
    { 0x14149B86, "fling_force_v" },
    { 0xB2AA696F, "fling_force_vhi" },
    { 0x7AE8C5AD, "fling_force_vlo" },
    { 0xA95C1373, "fling_player" },
    { 0x4922FF05, "fling_range_squared" },
    { 0x95173854, "fling_scaler" },
    { 0xBDF79EB6, "fling_targets" },
    { 0xB826EE1C, "fling_this_way" },
    { 0xE3E3D182, "fling_vec" },
    { 0x85FF1405, "fling_vel" },
    { 0x9DE7E3A2, "fling_zombie" },
    { 0x7651214E, "flinged" },
    { 0x321A9C48, "flinger" },
    { 0xCADDEDDB, "flinger_anims" },
    { 0x6E04FC68, "flinger_animtree" },
    { 0x4873B46B, "flinger_fling" },
    { 0x48181C85, "flinger_func" },
    { 0xCDE4B11E, "flinger_in_place" },
    { 0x8388CC11, "flinger_poi" },
    { 0x124B91C1, "flinger_think" },
    { 0x35B5B561, "flinger_trig" },
    { 0x4600FC27, "flinging" },
    { 0xB949EE08, "flings" },
    { 0xAC5F6F14, "flip" },
    { 0x1E31E6E6, "flip_array" },
    { 0x0CE1F2AD, "flip_sparks" },
    { 0x56D05889, "flip_table" },
    { 0xB4699824, "flip_table_check" },
    { 0xC4045258, "flip_table_start" },
    { 0x72DAA637, "flip_up_targets" },
    { 0xE3B7F6B6, "flipanglethreshold" },
    { 0x58C213E3, "flipbook" },
    { 0x0AFA1EE8, "flipindex" },
    { 0x1E94952F, "flipped" },
    { 0x71D8D520, "flipped_car" },
    { 0xDA5E1029, "flipper" },
    { 0x25389CB2, "flipper1" },
    { 0x85C58C76, "flipper1_radius_check" },
    { 0xFF362249, "flipper2" },
    { 0x596C0D23, "flipper2_radius_check" },
    { 0x4414059F, "flipper_anchor" },
    { 0x1F4AD32F, "flipper_area" },
    { 0x1CC00D5C, "flipper_closed_struct" },
    { 0x58C766AC, "flipper_open_struct" },
    { 0xD526E3A7, "flipper_second_dust" },
    { 0x35EDCCFC, "flipping" },
    { 0xE70AF585, "flipping_shooting_crash_accel" },
    { 0xBB8173FC, "flipping_shooting_crash_movement" },
    { 0x9A875413, "flipping_shooting_death" },
    { 0xEBF02955, "flipping_shooting_dmg_snd" },
    { 0xC1098C87, "flips" },
    { 0x34E5646A, "fliptruck_ghettoanimate" },
    { 0x33724181, "float" },
    { 0xA4599198, "float_anim_rate" },
    { 0x3FDBF57C, "float_board" },
    { 0x91433E18, "float_body" },
    { 0xBC26E01F, "float_capped" },
    { 0xCEE3275D, "float_height" },
    { 0x553DEE00, "float_input" },
    { 0x5F7C4066, "float_longer_on_death" },
    { 0xB926519E, "float_max" },
    { 0x4BAE7340, "float_min" },
    { 0xDA075282, "float_pos" },
    { 0xDEBBC50C, "float_print3d" },
    { 0x61084A6E, "floated" },
    { 0x1CD1C568, "floater" },
    { 0xF0E6519C, "floater_bob" },
    { 0x00BA67DC, "floater_move" },
    { 0xBF60939D, "floater_spawner" },
    { 0xF8948821, "floater_think" },
    { 0x972BA403, "floaters" },
    { 0x429F733C, "floatheight" },
    { 0x47029C77, "floatiness" },
    { 0x7E4208C7, "floating" },
    { 0x4D36D07E, "floating_boards_init" },
    { 0xC9C4C57E, "floating_bodies" },
    { 0x7752FBC4, "floating_bodies_backtrack_cleanup" },
    { 0x66907FEB, "floating_debris" },
    { 0xB94584A6, "floating_debris_spawner" },
    { 0x9097141C, "floating_dyn_ents" },
    { 0x9455A47F, "floating_dyn_ents_market" },
    { 0x63C759B6, "floatingoffset" },
    { 0x6BD342A2, "floatlonger" },
    { 0x7B544595, "floatmyboat" },
    { 0xAFC525AD, "floatparts" },
    { 0xEC9BEFA8, "floats" },
    { 0x1BC38FDE, "floatval" },
    { 0x088D1132, "floaty" },
    { 0x054A52F6, "flodding" },
    { 0xB866F920, "flogger_vocal_monitor" },
    { 0x92C0A01F, "flood" },
    { 0x60FCF683, "flood_and_secure" },
    { 0xB233ED43, "flood_and_secure_spawn" },
    { 0xEA02ECDF, "flood_and_secure_spawn_goal" },
    { 0x22E6CA1E, "flood_and_secure_spawner" },
    { 0x3893CBCB, "flood_and_secure_spawner_think" },
    { 0x7B593129, "flood_begin" },
    { 0x6D4A638E, "flood_event" },
    { 0xC9DC5783, "flood_fill_start_point" },
    { 0x8BE88225, "flood_fill_start_point_distance_squared" },
    { 0x9C322A54, "flood_pulsers" },
    { 0x12443BFA, "flood_room_guys" },
    { 0x133262D7, "flood_spawn" },
    { 0x6055EA3A, "flood_spawner" },
    { 0x329CEBD8, "flood_spawner_array" },
    { 0x66CEFEF7, "flood_spawner_init" },
    { 0x4B9C68BF, "flood_spawner_max_size" },
    { 0x35DED169, "flood_spawner_monitor" },
    { 0xAAFB15FF, "flood_spawner_scripted" },
    { 0x7B8466AF, "flood_spawner_think" },
    { 0x9899554A, "flood_spawner_trigs" },
    { 0x9C037FB5, "flood_spawners" },
    { 0xADE20212, "flood_stop" },
    { 0x4602D1A7, "flood_trigger_think" },
    { 0x17528B24, "flooded" },
    { 0x706586E9, "flooded_streets" },
    { 0x575FBB21, "flooding" },
    { 0xFBF6AD51, "floodl" },
    { 0x015D827B, "floodlightl" },
    { 0xDD9DF125, "floodlightr" },
    { 0x889AFB94, "floodlights_on" },
    { 0x778A4877, "floodlights_org" },
    { 0x10195F0F, "floodr" },
    { 0xBFE42F48, "floodspawn" },
    { 0xE96C8CD5, "floodspawncount" },
    { 0xA687D5BD, "floodspawner" },
    { 0x948A68F4, "floodspawner_switch" },
    { 0x9207C87C, "floodspawners" },
    { 0x227BA390, "floodspawning" },
    { 0x0ED96839, "floor" },
    { 0x93B38B02, "floor1" },
    { 0x6DB11099, "floor2" },
    { 0xDFA2D81E, "floor2_guys_setup" },
    { 0x558463BF, "floor2_mgguy_setup" },
    { 0x47AE9630, "floor3" },
    { 0xF7D3D4C0, "floor3_guys_dead" },
    { 0x8D82E6D4, "floor_blood" },
    { 0x5E3DAF80, "floor_changed" },
    { 0x5A20F7FA, "floor_collapse_init" },
    { 0xE4697EFA, "floor_damage_percentage" },
    { 0x9F453743, "floor_effects_active" },
    { 0x1435DD56, "floor_falls" },
    { 0xE0AE9BAD, "floor_goal" },
    { 0xF49F6955, "floor_guy" },
    { 0x9C145CE5, "floor_height" },
    { 0xAA2159A2, "floor_models" },
    { 0xD8B2BDEB, "floor_player" },
    { 0xEA651A9A, "floor_pos" },
    { 0x59F47F32, "floor_self" },
    { 0x27C656D4, "floor_stop" },
    { 0xFBA1C83F, "floor_struct" },
    { 0xFD1E5998, "floor_tracker" },
    { 0x45B99354, "floor_victim" },
    { 0xFF17FF85, "floor_watch" },
    { 0xA749A477, "floored_at_flak" },
    { 0x517AD15E, "flooredyawdiff" },
    { 0x0E1FCC4F, "flooring" },
    { 0x8E7776D8, "floorname" },
    { 0x76B5E3C9, "floorpos" },
    { 0xC84D3070, "floors" },
    { 0x6CAEE3DE, "floorstruct" },
    { 0x6D0586DE, "flop" },
    { 0x87E2B2DB, "flopper" },
    { 0xA9224522, "flopper_network_optimized" },
    { 0x5EACB686, "flopping" },
    { 0x886DDC7D, "flourescent" },
    { 0x6A0FD5D8, "flourish_fn" },
    { 0xCFD02688, "flourish_weapon" },
    { 0x573786D2, "flourish_weapon_name" },
    { 0xAEF922D1, "flow" },
    { 0xF2123698, "flower" },
    { 0x053F33B7, "flowing" },
    { 0xA010D7ED, "flown" },
    { 0xEC6C9769, "floyd" },
    { 0xF28FBF91, "flr_model" },
    { 0x577763C0, "flshmax" },
    { 0x049FF4FE, "flshmin" },
    { 0x5A567772, "flt_alert_delay" },
    { 0x7E633CCB, "flt_black_hole_vision_transition_time" },
    { 0x12F70504, "flt_moveto_time" },
    { 0x39D0600F, "flt_time" },
    { 0x1774826B, "flt_transition_time" },
    { 0xDB9D82F7, "fluid" },
    { 0x70BB2345, "flung" },
    { 0x81603BED, "flurry" },
    { 0x2C4AF7D9, "flush" },
    { 0x499D49CC, "flush_dialog" },
    { 0x3307917C, "flush_dialog_on_player" },
    { 0x0D4E1B9C, "flush_done" },
    { 0x24BC567A, "flush_ents" },
    { 0x68BE96A1, "flush_fx_done" },
    { 0x94711851, "flush_gpr" },
    { 0x688C3803, "flush_gump" },
    { 0x40698AB9, "flush_killstreak_dialog_on_player" },
    { 0x3B9C1D1E, "flush_leader_dialog_key" },
    { 0x9ED3224A, "flush_leader_dialog_key_on_player" },
    { 0x78C468D8, "flush_objective_dialog" },
    { 0xB8957DB8, "flush_objective_dialog_on_player" },
    { 0xC6C0D2D9, "flush_path" },
    { 0x32E61862, "flushalldialog" },
    { 0xD99D939D, "flushdialog" },
    { 0x63C739B9, "flushdialogonplayer" },
    { 0x87DBF206, "flushed" },
    { 0x69A7E769, "flushes" },
    { 0x3C4B838E, "flushgroup" },
    { 0x0011F65E, "flushgroupdialog" },
    { 0xAA8700B6, "flushgroupdialogonplayer" },
    { 0x637734E2, "flushgump" },
    { 0xF633776F, "flushing" },
    { 0xE0885B7A, "flushing_" },
    { 0x48243963, "flushing_la_1b_gump_3" },
    { 0xEDF5A23E, "flushing_yemen_gump_market_streets" },
    { 0xC28D6D69, "flushing_yemen_gump_speech" },
    { 0x43CFAF40, "flushobjectiveflagdialog" },
    { 0x0FFA1361, "flushscale" },
    { 0x7CEBB55A, "flushspeed" },
    { 0x3C2EEF1C, "flushsubtitles" },
    { 0xEFEA26D3, "flutter_left" },
    { 0x237C7246, "flutter_right" },
    { 0x09FF6EFB, "fluttering" },
    { 0x16818DE8, "flux" },
    { 0x7BA0875C, "fly" },
    { 0x098FCE8D, "fly_amb" },
    { 0xB1129B24, "fly_anim" },
    { 0xC58DDD5D, "fly_away" },
    { 0xB62D8469, "fly_away_1" },
    { 0xDC2FFED2, "fly_away_2" },
    { 0x4E376E0D, "fly_away_5" },
    { 0x6892811B, "fly_away_notify" },
    { 0xEC127FC4, "fly_away_trigger" },
    { 0xC7BF7F09, "fly_callbacks" },
    { 0x3D534538, "fly_cam" },
    { 0xE88957BC, "fly_crow_fly" },
    { 0x39848645, "fly_down_hud" },
    { 0x049F0872, "fly_ent" },
    { 0x07F6FA15, "fly_fx" },
    { 0xA3D9A2E2, "fly_height" },
    { 0xC9E42FCE, "fly_igc" },
    { 0x3DCE4FD0, "fly_in_distance" },
    { 0x5BDA98F0, "fly_in_the_vent" },
    { 0x76C79BAE, "fly_over_point" },
    { 0xA363C9FE, "fly_path" },
    { 0xED8661B3, "fly_path_set_speed" },
    { 0x742C141F, "fly_pos" },
    { 0x33578769, "fly_status" },
    { 0x8122C598, "fly_time" },
    { 0x110E6BB0, "fly_to" },
    { 0xB6E3DA92, "fly_to_spline_end" },
    { 0xF2B782E8, "fly_to_struct" },
    { 0x6FBA0975, "fly_trigger" },
    { 0xAD0A7333, "fly_trigger_target" },
    { 0xA924DCFE, "fly_up_hud" },
    { 0x80566CA4, "flyable" },
    { 0x7D7B2424, "flyairstrikeplane" },
    { 0xDBFE8315, "flyblend" },
    { 0xBC053993, "flyby" },
    { 0x8088078A, "flyby_afterburner" },
    { 0xAE9484ED, "flyby_audio_entry" },
    { 0x73B25859, "flyby_audio_start_delay" },
    { 0x54FEEED3, "flyby_feedback" },
    { 0xDC88B4A4, "flyby_feedback_active" },
    { 0x9EB25BEE, "flyby_feedback_watcher" },
    { 0x3D713588, "flyby_go" },
    { 0xBF2C47A5, "flyby_plane_think" },
    { 0xB037A149, "flyby_planesound" },
    { 0x00A69163, "flyby_sound" },
    { 0xE4C58837, "flyby_timeout" },
    { 0xEEC00B81, "flybyonly" },
    { 0x5651AAC2, "flybys" },
    { 0xF1B60E61, "flybys_total" },
    { 0xA2F94668, "flybysound" },
    { 0x54F67AD2, "flybysoundloop" },
    { 0xDCAEF83A, "flyentdelete" },
    { 0xD6BC5905, "flyheight" },
    { 0x5E718ED5, "flyhomevec" },
    { 0x0A1B2131, "flyin" },
    { 0x8C4215CF, "flyin_dialog_pilot" },
    { 0x1FBAEC52, "flyin_hide_cells" },
    { 0xC1B3D7E0, "flyin_intro_civilian_mowdown" },
    { 0x53E4A68D, "flyin_show_cells" },
    { 0x000707AC, "flying" },
    { 0x92DDBFD3, "flying_arm" },
    { 0xA62B1273, "flying_booster_rotate_update" },
    { 0x7B7B87E6, "flying_callback" },
    { 0x12123A14, "flying_huey" },
    { 0xE6244E97, "flying_intro" },
    { 0xCF21850A, "flying_levels" },
    { 0x6ECE6FDC, "flyingbodies" },
    { 0xEC21E6A1, "flyingdir" },
    { 0xE419D5F2, "flyover" },
    { 0x8021B801, "flyover_to_tower_handler" },
    { 0x81BEDF7D, "flyovers" },
    { 0x8ADAE6B2, "flyplane" },
    { 0xCBE42B9F, "flys" },
    { 0xCC2A94AD, "flyspeed" },
    { 0x31A25ACF, "flytime" },
    { 0x58B7A347, "flyto" },
    { 0x22DC1A0D, "flytrap" },
    { 0x7DC05CE4, "flytrap_audio_mover" },
    { 0xA7A3CD0C, "flytrap_counter" },
    { 0xEDD55CC4, "flytrap_lev_objects" },
    { 0x12ECA29B, "flytrap_samantha_vox" },
    { 0xB32E8469, "fmissionlength" },
    { 0x34B3E458, "fmj" },
    { 0x33BA6929, "fmovetime" },
    { 0x1E0B8310, "fmultiplier" },
    { 0x4330B48D, "fn" },
    { 0x4B769811, "fn_custom_round_ai_spawn" },
    { 0xE863F304, "fn_custom_wasp_favourate_enemy" },
    { 0x78EAA3CC, "fn_custom_zombie_spawner_selection" },
    { 0xF4786758, "fn_move_weapon_in" },
    { 0x0DDF33D7, "fn_move_weapon_out" },
    { 0xA3A87D80, "fn_on_spawned" },
    { 0x1847D2BC, "fn_planted_cb" },
    { 0x1FF0CC30, "fname" },
    { 0xC9C16612, "fnfal" },
    { 0xAFB0F99B, "fnodenum" },
    { 0xAA2B4B48, "fnodes" },
    { 0x1D2E3A24, "fo" },
    { 0xDFBB6CCA, "foam" },
    { 0xA8DA0BEC, "foawerawer" },
    { 0x9F7B2E5E, "fob" },
    { 0xC214F138, "focal" },
    { 0x25954F5A, "focalpoint" },
    { 0x4F056F8F, "focker" },
    { 0x51E4CE63, "focus" },
    { 0xBC944DD8, "focus_dist_squared" },
    { 0x13D36C83, "focus_distance" },
    { 0xAB3A1748, "focus_rate" },
    { 0x5CD9CCFB, "focus_rooftop_guard" },
    { 0x508C6E11, "focus_target" },
    { 0x3D32E158, "focused" },
    { 0xD99C00AB, "focused_anims" },
    { 0x45405515, "focuseditem" },
    { 0xE71C93A7, "focuses" },
    { 0xD8FC153D, "focusing" },
    { 0x1558A965, "focussed" },
    { 0x7C27E379, "fodder" },
    { 0xF9EABCE4, "fodder_guys" },
    { 0x2D73BF23, "fog" },
    { 0x1942F5DB, "fog_adjust" },
    { 0x9CF661E6, "fog_apply" },
    { 0x39F3E158, "fog_armory" },
    { 0xEF192488, "fog_b" },
    { 0xAEC0CEC4, "fog_bank" },
    { 0xB1966978, "fog_bank_1" },
    { 0x239DD8B3, "fog_bank_2" },
    { 0x539964E7, "fog_bank_2_callback" },
    { 0xFD9B5E4A, "fog_bank_3" },
    { 0x70BE5714, "fog_bank_3_callback" },
    { 0x6FA2CD85, "fog_bank_4" },
    { 0x9235EB07, "fog_bank_controller" },
    { 0x4F3807E2, "fog_bank_eject_sequence" },
    { 0x99984D85, "fog_bike_downhill" },
    { 0x460FF65E, "fog_bike_train" },
    { 0x2364435A, "fog_change" },
    { 0xBF76C01B, "fog_col_scale" },
    { 0x18821BD6, "fog_controller" },
    { 0xF3367B43, "fog_courtyard" },
    { 0x9D55EFB8, "fog_disabled_in_noclip" },
    { 0xE45966BB, "fog_for_ending" },
    { 0xBFD0E04C, "fog_for_merchantship" },
    { 0xC38ABFBD, "fog_for_rescue" },
    { 0x160623C5, "fog_freefall_settings" },
    { 0xAD258895, "fog_g" },
    { 0xB4766C64, "fog_hallway_settings" },
    { 0x2520256F, "fog_in" },
    { 0xDBDD885F, "fog_inclinator" },
    { 0x6C7DEAFC, "fog_intro" },
    { 0xCBEB1287, "fog_level_increase" },
    { 0xF12713A2, "fog_mines" },
    { 0xF748AF6F, "fog_minigun" },
    { 0x9499A8F3, "fog_normal_height" },
    { 0xDCBF62CF, "fog_normal_height_ground" },
    { 0xD45BFE50, "fog_normal_height_mid" },
    { 0x6CD4CD68, "fog_normal_mid" },
    { 0x6213AA54, "fog_normal_near" },
    { 0x4A59B83A, "fog_out" },
    { 0x4F40CB18, "fog_r" },
    { 0x3DC3AF08, "fog_rate" },
    { 0x3164820A, "fog_remove" },
    { 0x2068DE0E, "fog_scalar" },
    { 0xE6F7F220, "fog_scale" },
    { 0xEBEA88F2, "fog_setting" },
    { 0xCF48A87D, "fog_settings" },
    { 0x57161885, "fog_setup" },
    { 0xF984B4D1, "fog_slingshot" },
    { 0x73B9AABC, "fog_stairs" },
    { 0xBE17B820, "fog_to_set" },
    { 0x985CF40B, "fog_transition" },
    { 0xFD0916FE, "fog_trigger" },
    { 0x0EB31F20, "fog_trigger_current" },
    { 0x11100DEB, "fog_triggers_setup" },
    { 0x506C623E, "fog_type" },
    { 0xB7D1EFF9, "fog_updater" },
    { 0x273B2529, "fog_value" },
    { 0x8DBEBD32, "fog_vol_to_visionset_force_instant_transition" },
    { 0x3DB57C32, "fog_vol_to_visionset_hostmigration_monitor" },
    { 0x73B98351, "fog_vol_to_visionset_instant_transition_monitor" },
    { 0xF5FDCB4D, "fog_vol_to_visionset_monitor" },
    { 0x3AEA3C1A, "fog_vol_to_visionset_set_info" },
    { 0xA95252C1, "fog_vol_to_visionset_set_suffix" },
    { 0x8702198B, "fog_warehouse" },
    { 0x5DA117B8, "fogall" },
    { 0x466B974D, "fogbaseheight" },
    { 0xAD0B86B3, "fogblue" },
    { 0xC6B94609, "fogcheck" },
    { 0x1244E112, "fogclear" },
    { 0x03278628, "fogcolorblue" },
    { 0x2C94E86D, "fogcolorgreen" },
    { 0xB1E47359, "fogcolorred" },
    { 0x8978D5CA, "fogcolorscale" },
    { 0x8D74BC29, "fogcolorscale_new" },
    { 0x9D70E1CE, "fogexphalfheight" },
    { 0xAEAA3AF7, "fogexphalfplane" },
    { 0xF9A30307, "fogflash" },
    { 0x55F12EAD, "fogfraction" },
    { 0x7DB29070, "foggreen" },
    { 0xBAC4CDA2, "foggyness" },
    { 0x2AF58D22, "fogmaxopacity" },
    { 0x3CFB7029, "fognearplane" },
    { 0xE531C2F0, "fogred" },
    { 0x36600512, "fogs" },
    { 0x38F3D274, "fogsettings" },
    { 0xA4DEF5BC, "fogsundir" },
    { 0x1F66499A, "fogvalue" },
    { 0x78E22388, "foilage" },
    { 0xD9570687, "folded" },
    { 0x556FCEA1, "folder" },
    { 0x39606096, "foley" },
    { 0x06414BEE, "foliage" },
    { 0xFF415C57, "foliage_attackers" },
    { 0xB584627B, "foliage_axis_ai" },
    { 0x32AE64F2, "foliage_cover" },
    { 0xE04652D4, "foliage_cover_player_off" },
    { 0x23D878DE, "foliage_cover_player_on" },
    { 0x30117253, "foliage_cover_watch_trigger" },
    { 0x1C601B0B, "foliage_detect_dist" },
    { 0xA72E55B1, "foliage_detect_distsqrd" },
    { 0xA5FB430A, "foliage_found_dist" },
    { 0xAF5A7DD4, "foliage_found_distsqrd" },
    { 0x01F55A70, "foliage_last_stance" },
    { 0x7FBC1A3F, "foliage_sight_dist" },
    { 0x6FD1B56D, "foliage_sight_distsqrd" },
    { 0xBF05EF9E, "foliage_trigger_stack" },
    { 0x5D798B03, "folk" },
    { 0x2EE15C72, "folks" },
    { 0xDAACCC96, "follow" },
    { 0xFC244BD7, "follow_close" },
    { 0x0C55F83A, "follow_closely" },
    { 0x76E18263, "follow_convoy" },
    { 0x1B93C521, "follow_coop_players" },
    { 0x0249B999, "follow_duration" },
    { 0x5713A5AF, "follow_enemy" },
    { 0xC287213C, "follow_ent" },
    { 0x7E14E9F0, "follow_entity" },
    { 0x271A56E3, "follow_handler" },
    { 0x2A7118D3, "follow_horse_angles" },
    { 0x00137307, "follow_index" },
    { 0xEAD2EC53, "follow_leader_regular" },
    { 0x24A93F44, "follow_leader_riotshield" },
    { 0xD62B45FC, "follow_mover" },
    { 0x72CC1F95, "follow_node" },
    { 0x3A75EEE4, "follow_nodes" },
    { 0xC494534F, "follow_nodes_done" },
    { 0xE1B2E5FB, "follow_obj_loc" },
    { 0x3831A720, "follow_path" },
    { 0xC782BD9B, "follow_path_done" },
    { 0x8CAD6C8B, "follow_path_drone" },
    { 0x845B60D6, "follow_path_end" },
    { 0xEFA16C3F, "follow_path_get_ent" },
    { 0xD93A8F94, "follow_path_get_node" },
    { 0x6919D457, "follow_path_new_goal" },
    { 0x2CF89F06, "follow_path_node_trigger_wait" },
    { 0x9CBFDA43, "follow_path_old_forcecolor" },
    { 0xDE96FBE3, "follow_path_set_ent" },
    { 0x6925A1B8, "follow_path_set_node" },
    { 0x5945031D, "follow_path_skipto" },
    { 0xB6FDFD82, "follow_player" },
    { 0x86E68A1C, "follow_points" },
    { 0x4B46BE50, "follow_price" },
    { 0xEEA105D9, "follow_pt" },
    { 0xF5CE6AF3, "follow_spotlight_path" },
    { 0x9AC29B06, "follow_strength" },
    { 0x4941D970, "follow_struct_chain" },
    { 0xFA1D14C6, "follow_the_leader" },
    { 0x3B4AD5B2, "followbomb" },
    { 0x7FD9D122, "followdist" },
    { 0x8E5E46BE, "followdistsq" },
    { 0xEE1A7A59, "followed" },
    { 0x5A32785D, "followent" },
    { 0x7201B23F, "follower" },
    { 0xA0A2714A, "follower_class" },
    { 0x181E3CB7, "follower_count" },
    { 0xB8B05DB0, "follower_goal_pos" },
    { 0xC8D5325D, "follower_size" },
    { 0x5C384F9A, "follower_spawner" },
    { 0xFE250746, "followers" },
    { 0xA17AABF3, "followinf" },
    { 0x7B78318A, "following" },
    { 0xE79FDFB0, "following_gunner" },
    { 0xB3167B1D, "following_human_zombie" },
    { 0x1F59F556, "following_player" },
    { 0x73C8D4BC, "following_player_zipline" },
    { 0x01A2A0BC, "followmax" },
    { 0x3EAF0008, "followme" },
    { 0x7EB75EB2, "followmin" },
    { 0x26FB2D7B, "followmode" },
    { 0x77A97C63, "followpath" },
    { 0x6597C357, "followposition" },
    { 0x8D8CA209, "follows" },
    { 0xFDD5A3B5, "followscriptedpath" },
    { 0x776EE71F, "followspeed" },
    { 0x7605071D, "followup" },
    { 0xEB862415, "follwing" },
    { 0x7BFDF336, "folowing" },
    { 0x44ED8F8B, "foltarget" },
    { 0xB15AF709, "fom" },
    { 0x83253AC2, "font" },
    { 0x65A1E9C4, "font3duseglowcolor" },
    { 0x5E2578BC, "font_pulse" },
    { 0x1AD5C13D, "font_pulse_init" },
    { 0x7F6140B9, "font_scale" },
    { 0x59FE855E, "font_size" },
    { 0x526C56E4, "font_style" },
    { 0x7A8AC85B, "fontelem" },
    { 0x250C7467, "fontheight" },
    { 0xD0331995, "fontpulse" },
    { 0xE860ACF3, "fontpulseinit" },
    { 0x6E83770D, "fonts" },
    { 0x2363DA9C, "fontscale" },
    { 0xFD208A76, "fontscaler" },
    { 0x0CCEFF55, "fontsize" },
    { 0x2E57D865, "fontstring" },
    { 0x1EDF1D5C, "fontstyle3d" },
    { 0xFD5FEBDB, "foo" },
    { 0x61E4477D, "fool" },
    { 0xB36A34E5, "foolery" },
    { 0x1F6E0AB3, "foolish" },
    { 0xCBD83C21, "foorstep" },
    { 0x31D07435, "foot" },
    { 0xE9257907, "foot_depth" },
    { 0xC90AA992, "foot_org" },
    { 0x5305DD36, "foot_pos" },
    { 0x518DAFF1, "foot_position" },
    { 0x0FFEA91E, "foot_rumbles" },
    { 0x87652DC9, "foot_side" },
    { 0xD1E66E19, "foot_soldier_logic" },
    { 0xE3E45849, "foot_sync" },
    { 0xC1C294CD, "foot_sync_timeout" },
    { 0x397D1B6A, "footage" },
    { 0xFAB1F86E, "football" },
    { 0x4C197112, "football_fire_pos" },
    { 0xFB3224A4, "footer" },
    { 0x69FDA9E2, "footfall" },
    { 0x557CF32A, "foothold" },
    { 0xEFB4E08A, "footprint" },
    { 0x5BE74494, "footprint_check_for_nearby_players" },
    { 0x2C87DAFF, "footprint_warning_vo" },
    { 0xA93CF9AD, "footprint_zombie_killed" },
    { 0x538CC9FF, "footstep" },
    { 0xA812EA81, "footstep_damage" },
    { 0xBDA33F7A, "footstep_handler" },
    { 0xE7F1803B, "footstep_left_large_theia" },
    { 0x6F90EAA6, "footstep_left_monitor" },
    { 0x48782F49, "footstep_left_small" },
    { 0x24087996, "footstep_right_large_theia" },
    { 0x7080094F, "footstep_right_monitor" },
    { 0x2358C6A8, "footstep_right_small" },
    { 0xD12E2C6C, "footstep_vol_override" },
    { 0xC9CBFB32, "footsteparray" },
    { 0x7F8BC4BC, "footstepbones" },
    { 0x1946B35F, "footstepdoeverything" },
    { 0xFB2C752C, "footstepdofootstepfx" },
    { 0xA6596DEF, "footstepfxtable" },
    { 0x94BD6F91, "footstepindex" },
    { 0x6644663D, "footstepprepend" },
    { 0xCADE3606, "footsteps" },
    { 0x7B3DCBAA, "footsteps_shared" },
    { 0xF51DAEF7, "footstepscriptcallback" },
    { 0xFFA2D4EE, "for" },
    { 0xEA7DD72F, "for_ai_print" },
    { 0xF125712D, "for_bowman_vo" },
    { 0x68BEA3E2, "for_each" },
    { 0x99EE18C6, "for_ghost_round_presentation" },
    { 0x51A5EC8B, "for_killing" },
    { 0x73E32720, "for_testing_only" },
    { 0xC2C8A0EA, "for_time" },
    { 0x7820AD23, "for_time_loop" },
    { 0xB396EC95, "forard" },
    { 0xF9D4D24E, "force" },
    { 0xD1ACB6F9, "force_ai_to_move_up" },
    { 0x3B2262AE, "force_ais_to_move_up" },
    { 0x620BC33E, "force_all" },
    { 0x3FBDCC94, "force_all_complete" },
    { 0x5F02A792, "force_all_hudoutlineson" },
    { 0xE3FAF6BE, "force_ally_switch_totype" },
    { 0xE44DC8F1, "force_attachments" },
    { 0x334CC84C, "force_attachments_list" },
    { 0x517B6E8E, "force_barnes_to_move_up_bridge" },
    { 0x8A6C7EBB, "force_behavior" },
    { 0x938C8F90, "force_blowup_msg" },
    { 0xD5B3A59E, "force_bullet_cam_on_castro" },
    { 0x566F8C51, "force_cam_pos" },
    { 0xBA19385F, "force_cancel_placement" },
    { 0xFF7F785D, "force_challenge_stat" },
    { 0x394C9D99, "force_chaser" },
    { 0x135B9EBE, "force_check_now" },
    { 0x69A23B1A, "force_corpse_respawn_position" },
    { 0x503EFDAF, "force_crawler" },
    { 0xE6826F90, "force_custom_battlechatter" },
    { 0x649837DA, "force_death_trig" },
    { 0xF27747D4, "force_delete" },
    { 0x92B00660, "force_delete_sound" },
    { 0x299D6FB0, "force_deletion_of_soundent" },
    { 0x6002A8AE, "force_detonation" },
    { 0x9500B0CB, "force_digger" },
    { 0x4F0EB767, "force_disable_color" },
    { 0x18279109, "force_drink" },
    { 0x2A941B61, "force_drones_engage_each_other" },
    { 0xAE011034, "force_drop_knives_to_ground_on_death" },
    { 0x6F079A19, "force_eclipse_watcher" },
    { 0x99DAD83B, "force_em" },
    { 0xB0C9EB30, "force_enable_player" },
    { 0x8DAA84A8, "force_end_microwave_vox" },
    { 0xB7C3DD10, "force_explode" },
    { 0x0670B5D2, "force_explosion" },
    { 0xF4444417, "force_extended_death_anim" },
    { 0x805E7331, "force_fail" },
    { 0x98F69770, "force_fail_after_timer" },
    { 0xC7B8C17A, "force_fall" },
    { 0xF38AAFF6, "force_fall_death_trig" },
    { 0x813DE173, "force_field" },
    { 0x1D6E6F88, "force_fire_at_balcony_friendly" },
    { 0x43C6BB06, "force_fire_turret_on_target_when_possible_with_vo" },
    { 0x168CC21D, "force_from_torso" },
    { 0x1F8A0CA7, "force_game_controller_bindings" },
    { 0xADD6C0D2, "force_get_enemies" },
    { 0x23B70F19, "force_ghost_round_end" },
    { 0xEDA446B2, "force_ghost_round_start" },
    { 0x3908212C, "force_giant_robot_0" },
    { 0x5F0A9B95, "force_giant_robot_1" },
    { 0x850D15FE, "force_giant_robot_2" },
    { 0xF67EAA79, "force_gib" },
    { 0xC1B5CE90, "force_gib_chance" },
    { 0x4C65A486, "force_go_to_node_by_name" },
    { 0x19E98020, "force_goal" },
    { 0xAF9CC59F, "force_goal_after_unload" },
    { 0x8EEB0F1D, "force_goal_self" },
    { 0x571E0484, "force_goal_self_util" },
    { 0x89AF22F1, "force_gondola_teleport" },
    { 0x7DE39FB2, "force_grenade_explod_time" },
    { 0x327EDE4E, "force_grenade_pos" },
    { 0x1B69FDE8, "force_grenade_throw" },
    { 0xC917F4C9, "force_grenade_throw_tag" },
    { 0x7F925385, "force_grenade_toss" },
    { 0xBDC32B2B, "force_grenade_toss_internal" },
    { 0x433A2685, "force_harper_to_frogger_start" },
    { 0x03B1A7C4, "force_head_gib" },
    { 0x5A745FA1, "force_heli_nocull" },
    { 0xF1703C3C, "force_heli_turret_forward" },
    { 0xF510366B, "force_hide_swimming_arms" },
    { 0xF3D94DBD, "force_high_speed" },
    { 0xFDAAF1DC, "force_instagib" },
    { 0x3E1FB3D1, "force_jump" },
    { 0x0E3A896C, "force_kill_opel2" },
    { 0xE4314A01, "force_killable" },
    { 0xC5F4EF77, "force_killable_timer" },
    { 0xBE8CCFF3, "force_last_wave" },
    { 0xEB437C79, "force_left_foot" },
    { 0x3E34C3EC, "force_legacy_message" },
    { 0xCE5FC04A, "force_lock_doors" },
    { 0xA8F13C2F, "force_loop" },
    { 0x68841EC2, "force_mag" },
    { 0xAA77BAB5, "force_max" },
    { 0xBD37EA7E, "force_menu_back" },
    { 0xD509C5FB, "force_min" },
    { 0x0FD7F116, "force_minigame" },
    { 0xDAA44C7E, "force_move_ai_to_apc" },
    { 0x03B17BBC, "force_move_friends" },
    { 0xF890594A, "force_move_guy" },
    { 0x019B85B1, "force_movement_wake" },
    { 0xE83F09EB, "force_navcomputer_trigger_think" },
    { 0x4F1A9D9B, "force_new_assignment" },
    { 0x6C9E9554, "force_no_ghost" },
    { 0x39FA3677, "force_not_prone" },
    { 0x09781D24, "force_not_prone_init" },
    { 0xA4D60039, "force_open" },
    { 0xE5D0C7AF, "force_open_time" },
    { 0x13BBDFF6, "force_patrol_think" },
    { 0x0DE9CAFD, "force_pickup" },
    { 0x789C5AA2, "force_play_ambient_sound" },
    { 0xB6175335, "force_play_ambient_sound_intro" },
    { 0xCE0F68E3, "force_play_vc_death_audio" },
    { 0x96145F41, "force_player4_override" },
    { 0x4BD4D055, "force_player_being_targetted" },
    { 0x7E0AC2E7, "force_player_into_position" },
    { 0x7B442C8E, "force_player_move" },
    { 0xBA03D93B, "force_player_move_init" },
    { 0x4DC2A347, "force_player_respawn_position" },
    { 0xA4AC8FA8, "force_player_to_battle_2" },
    { 0x716E1593, "force_player_to_use_legit_sniper_escape_weapon" },
    { 0xDB42080A, "force_players_into_seat" },
    { 0xB980221A, "force_players_off_tank" },
    { 0x7CEC2334, "force_position" },
    { 0x28223325, "force_prologue_body" },
    { 0x1E2F3955, "force_prone" },
    { 0x0A8D5FA3, "force_random_powerup_drop" },
    { 0x32B7EA24, "force_reaction_anim_truck" },
    { 0x387EF029, "force_recapture_start" },
    { 0xCD97A939, "force_remove" },
    { 0xA6D2BB86, "force_reverb_for_intro" },
    { 0x1793DA40, "force_right_foot" },
    { 0xFC8F3738, "force_riser" },
    { 0xF3947208, "force_run" },
    { 0x68E9D719, "force_scale_factor" },
    { 0x31158307, "force_set_all" },
    { 0x9C05FB88, "force_set_creek_ambush_path_visionset" },
    { 0x0F0B7D36, "force_set_creek_rain_visionset" },
    { 0x2D8D0302, "force_set_creek_village_visionset" },
    { 0x5AA5A2C7, "force_set_creek_visionset" },
    { 0xA679BEBD, "force_set_creek_warroom_visionset" },
    { 0x7E070C35, "force_shock_file_for_intro" },
    { 0x81C7E566, "force_shoot_directly_at_target_sq" },
    { 0xAF68E56E, "force_short_scene_transition_effect" },
    { 0x46291F4C, "force_show_swimming_arms" },
    { 0xC5ED7AE4, "force_snapshot_to_plane" },
    { 0x0083193B, "force_snapshot_wait" },
    { 0x1BC2B35C, "force_solo_quick_revive" },
    { 0x73FDB64E, "force_spawn" },
    { 0x68238F8B, "force_spawn_ai" },
    { 0xAA0679D9, "force_spawn_ai_array" },
    { 0x6CA72DAE, "force_spawn_guy" },
    { 0xDEE290C9, "force_sprint" },
    { 0x663ADE7E, "force_squad_prone" },
    { 0x3DCB78C8, "force_start_alarm_sounds" },
    { 0xDD4284AE, "force_starting_floor" },
    { 0x60B75312, "force_starting_origin" },
    { 0xADBCC988, "force_starting_origin_offset" },
    { 0x5C8904C5, "force_stop" },
    { 0x005B6A22, "force_stop_old_drone_vox" },
    { 0x562CF2C6, "force_stop_old_thread" },
    { 0x530E9525, "force_stop_sound" },
    { 0x7B77A86A, "force_stoploopsound_end" },
    { 0x85D01080, "force_stowed_weapon_update" },
    { 0x4FB84FFC, "force_stream_changed" },
    { 0xA1500FC0, "force_street_flyby_snapshot" },
    { 0xC9CD5657, "force_swim_anim" },
    { 0x2CD365C3, "force_takeoff" },
    { 0x769DB646, "force_target" },
    { 0x4ACADDA9, "force_team_characters" },
    { 0x750FB2E8, "force_teleport" },
    { 0x717624D5, "force_this_color" },
    { 0x5645F397, "force_three_robot_round" },
    { 0x79310E00, "force_to_goal" },
    { 0x1E4E19E4, "force_to_goal_exact" },
    { 0x64EA4493, "force_to_goal_ignore_player" },
    { 0x0A540726, "force_tracking" },
    { 0xCDA7936B, "force_transmit_on_turn" },
    { 0x2ED9CA57, "force_traversal_movement" },
    { 0x26C63193, "force_trigger" },
    { 0x5CC00D6A, "force_update" },
    { 0x02DE2E7F, "force_update_player_clientfields" },
    { 0x52484BE6, "force_upload" },
    { 0x644B35D9, "force_use_tow" },
    { 0x2F159ED0, "force_variant" },
    { 0x35A93BE8, "force_vehicle_turret_target" },
    { 0x3FCFAC5A, "force_verb" },
    { 0xFA84C5E2, "force_wait_for_forcefield_looper" },
    { 0x63C29EED, "force_wait_for_gersh_line" },
    { 0xCC7FD45A, "force_wait_on_kill_line" },
    { 0xEB51CF7B, "force_weather" },
    { 0x32DB9D98, "force_weather_none" },
    { 0x09BFAF60, "force_weather_rain" },
    { 0xABAF57C7, "force_weather_snow" },
    { 0xDCB62A5F, "force_x" },
    { 0xB6B3AFF6, "force_y" },
    { 0x90B1358D, "force_z" },
    { 0xC944D999, "force_z_offset" },
    { 0x8E00DB6E, "force_zombie_crawler" },
    { 0xDBC8D457, "force_zone" },
    { 0xBBCB5D8C, "force_zone_capture" },
    { 0xD9F2EAC9, "force_zone_recapture" },
    { 0x9DCCA00A, "forceairsupportmapheight" },
    { 0x19E2E2B3, "forceall" },
    { 0xAB69E449, "forceallallies" },
    { 0xA6255DA5, "forceallowselect" },
    { 0xF9E5ADCD, "forceallydistanceweight" },
    { 0x8BD8AC47, "forceambientroom" },
    { 0x73793D1A, "forceangles" },
    { 0xAB5D1D52, "forceanglevector" },
    { 0x195E43C1, "forceanhilateondeath" },
    { 0x3FE9EE34, "forceautoassign" },
    { 0xBEA6DBB4, "forcebehavior" },
    { 0xBBCE1951, "forcebigdogsetcanmoveifneeded" },
    { 0x37ADC688, "forcebuoyancy" },
    { 0x7A6A5A97, "forcecharacter" },
    { 0x6276D2BB, "forcechargedsniperdeath" },
    { 0x503A19CE, "forcechoke" },
    { 0x346F292B, "forceclearclientruntree" },
    { 0x84917F77, "forcecolor" },
    { 0xEF23B0AE, "forcecolors" },
    { 0xF6BF32E1, "forcecorner" },
    { 0xF2D2DF6C, "forcecornermode" },
    { 0xE8B2DC1C, "forcecqb" },
    { 0x47BB8612, "forcecqbstopidle" },
    { 0xF060478E, "forced" },
    { 0x8F10788E, "forced_attachment" },
    { 0x280E7401, "forced_corpse_position" },
    { 0xAC5EE5D2, "forced_cover" },
    { 0x76F328CB, "forced_entry" },
    { 0xEA097246, "forced_grenade_thrown" },
    { 0x10409539, "forced_level_1" },
    { 0x36430FA2, "forced_level_2" },
    { 0x5C458A0B, "forced_level_3" },
    { 0x2311CD81, "forced_malfunction" },
    { 0xA9286CFF, "forced_move_now" },
    { 0x0D9CF04D, "forced_perk" },
    { 0xA091F4A0, "forced_player_position" },
    { 0x8B06DE4D, "forced_pos" },
    { 0x8CA2A895, "forced_prone" },
    { 0x91634938, "forced_startingposition" },
    { 0xD09239C7, "forced_suicide" },
    { 0x174FAD86, "forced_target" },
    { 0x32E2A339, "forced_targets" },
    { 0xEE6D2744, "forced_user" },
    { 0x9D81C7ED, "forced_weapon" },
    { 0xC6290BA4, "forcedamagefeedback" },
    { 0xE663BF8D, "forcedamagehitlocation" },
    { 0xE2165E3B, "forcedamageshellshockandrumble" },
    { 0x6E197FFE, "forcedclass" },
    { 0x6BD6A9BC, "forcedcornerdirection" },
    { 0x7F31FAAC, "forcedcornermode" },
    { 0x8C68B88B, "forcedcover" },
    { 0x419D528B, "forcedebughostmigration" },
    { 0x9B6966DF, "forcedelete" },
    { 0x73353C45, "forcedend" },
    { 0xC8CDE451, "forcedetail" },
    { 0xB2E9B345, "forcedetonation" },
    { 0x18D37EAD, "forcedfriendlyfirerule" },
    { 0x36D7E1E5, "forcedgasdeath" },
    { 0x577A64B6, "forcedremoval" },
    { 0x661A1C05, "forceend" },
    { 0xDABCF0D3, "forceenemydistanceweight" },
    { 0x79750128, "forceexploding" },
    { 0x14C6E80C, "forceexplosivedamage" },
    { 0x48C126D4, "forcefade" },
    { 0x688B84C7, "forceflamedeath" },
    { 0x7B94A4B7, "forceful" },
    { 0x9339BF1A, "forcefully" },
    { 0xC030DA5C, "forcegamemodemappings" },
    { 0x4578A2A5, "forcegasdeath" },
    { 0x778DCC4E, "forcegetenemies" },
    { 0xA6CF2246, "forcegibbing" },
    { 0x9BBE8448, "forcego" },
    { 0x6130AFEF, "forcegoal" },
    { 0x82A87D88, "forcegrenadethrow" },
    { 0x9E58747E, "forcehide" },
    { 0x64D58FA3, "forceinfraredmaterialsstreaming" },
    { 0x9FD2616A, "forcekill" },
    { 0x53E1FA54, "forcekillai" },
    { 0x1E795127, "forcekillcam" },
    { 0x27ADB7E7, "forcelevelend" },
    { 0x2AEA5622, "forcelongdeath" },
    { 0x274084F5, "forcemodel" },
    { 0xD9C0BAF5, "forcemove" },
    { 0xC61E3943, "forcemovementscriptstate" },
    { 0x28911C2B, "forcenewanim" },
    { 0x88291C1D, "forcenewchoice" },
    { 0xAEEEF5B1, "forceoffhandend" },
    { 0xEB025809, "forceon" },
    { 0xC5B7231A, "forceonemissile" },
    { 0x8D483834, "forceorigin" },
    { 0x519E0044, "forcepoint" },
    { 0x2CD17DC5, "forcepointvariance" },
    { 0xB01D8B74, "forcepointx" },
    { 0xD62005DD, "forcepointy" },
    { 0xA1B39C66, "forceradar" },
    { 0xBA976497, "forceragdoll" },
    { 0x5434B2D6, "forceragdollimmediate" },
    { 0x357FB45F, "forceredraw" },
    { 0x3806BC3A, "forceremove" },
    { 0x6B7C4E44, "forcerobotsoldiermindcontrollevel1" },
    { 0xDD83BD7F, "forcerobotsoldiermindcontrollevel2" },
    { 0xB7814316, "forcerobotsoldiermindcontrollevel3" },
    { 0xD22C3CF1, "forces" },
    { 0xE6B0593B, "forceshoot" },
    { 0xDBA94053, "forceshootdistsq" },
    { 0xBF823C9D, "forceshow" },
    { 0xA13F7BF4, "forceshutdown" },
    { 0xBA76289B, "forcesidearm" },
    { 0xB36DA37E, "forceslick" },
    { 0x7431D193, "forcespawn" },
    { 0x4484F2C2, "forcespawns" },
    { 0x619135A0, "forcespawnteam" },
    { 0xAF29C476, "forcestancechange" },
    { 0x1A7F9566, "forcestart" },
    { 0xB8B27FB0, "forcestinger" },
    { 0x53791AB9, "forcestopduprenderbundle" },
    { 0xE2215F56, "forcestoppostfxbundle" },
    { 0x18EA8641, "forcestowedweaponupdate" },
    { 0x2E76FA01, "forcestreamxmodel" },
    { 0xA2B35476, "forcetacticalwalk" },
    { 0x9C5A83FF, "forcetacticalwalkcallback" },
    { 0x137E3B21, "forcetarget" },
    { 0xB64279A1, "forceteam" },
    { 0x9869AB67, "forceteleport" },
    { 0x0F87839B, "forceteleport_goal" },
    { 0xB0DEC955, "forcetexturestoload" },
    { 0xB771F62E, "forcethrow" },
    { 0x843B464D, "forcetonode" },
    { 0x6C2EBEE9, "forceupdate" },
    { 0x8EA297FB, "forceuseweapon" },
    { 0x5078D5FA, "forceviewmodelanimation" },
    { 0x5022EAE2, "forcewaitremotecontrol" },
    { 0x2FD3EDCE, "forceweapon" },
    { 0xC81AE412, "forcex" },
    { 0xEE1D5E7B, "forcey" },
    { 0x7C15EF40, "forcez" },
    { 0x47F82711, "forcibly" },
    { 0xC6641C67, "forcing" },
    { 0x5A4F7E17, "fore" },
    { 0x087F03E7, "forearm" },
    { 0x79E0F792, "foreground" },
    { 0x8D6EAC9D, "foreground_tower_collapses" },
    { 0xBBAD09F7, "foreign" },
    { 0x19E4E60B, "foreshadow" },
    { 0xED04BFD0, "foreshadow_death" },
    { 0xBB154312, "foreshadow_destination" },
    { 0xF3A5AD55, "foreshadowing" },
    { 0xE1DFE97E, "forest" },
    { 0x91E6389E, "forest_ai_cleanup" },
    { 0x55173758, "forest_ambient_aa" },
    { 0x08DEA2A2, "forest_ambient_bombers" },
    { 0x9A5C4A3F, "forest_birds" },
    { 0x477ACEE0, "forest_drones" },
    { 0xAF994969, "forest_enemy_damage_override_func" },
    { 0xEBC72F78, "forest_friendlies" },
    { 0xCBE68BA0, "forest_friends" },
    { 0x7A012DC1, "forest_mid" },
    { 0x86976A5E, "forest_tank_1_strat" },
    { 0x8BFBEFA1, "forest_tank_2_strat" },
    { 0x77C593E0, "forest_tanks" },
    { 0x6F5FBE39, "forest_truck_spawners_strat" },
    { 0x39331FA7, "forest_zone" },
    { 0xF567DC4E, "forever" },
    { 0x485A51AE, "foreverever" },
    { 0x0F5E573A, "foreverrr" },
    { 0xBC7C993A, "forfeit" },
    { 0xD343F3A0, "forfeit in progress" },
    { 0x4DFB2196, "forfeit_count" },
    { 0xE0F2E2E6, "forfeit_delay" },
    { 0xB0BCD5CD, "forfeited" },
    { 0xA43AE9C2, "forget" },
    { 0x83A5F40D, "forgets" },
    { 0xF87EA07D, "forgettime" },
    { 0xB3F585DE, "forgetting" },
    { 0x281924D9, "forgive" },
    { 0x72810B38, "forgive_warning_delay" },
    { 0x0B8BD4EC, "forgot" },
    { 0x90419E89, "forgotten" },
    { 0x462CCC59, "fork" },
    { 0xDBA33B29, "forklift_worker_scenes" },
    { 0xE78270F1, "forkpoint" },
    { 0x58229118, "forloop" },
    { 0x2A3BAACF, "form" },
    { 0xE4F9C995, "formally" },
    { 0xFD3FBAE8, "format" },
    { 0x3A325FC6, "formatfloat" },
    { 0x19040FBA, "formation" },
    { 0x977A7C8E, "formation_anim" },
    { 0xD6288835, "formations" },
    { 0x5F7C241C, "formatting" },
    { 0x931D9C14, "formed" },
    { 0xE6F100B2, "former" },
    { 0xF60B68BF, "formerly" },
    { 0x581C778D, "formula" },
    { 0x268E19AB, "forseen" },
    { 0x2C38438A, "forshadowing" },
    { 0xA50D1012, "forth" },
    { 0x41D60241, "forth_shot" },
    { 0x9ED4BA92, "fortification" },
    { 0x9418F89D, "fortifications" },
    { 0x559974A7, "fortified" },
    { 0x34FB6DD4, "fortify" },
    { 0x5FD59AC5, "fortune_fate" },
    { 0x2B37310B, "forty" },
    { 0x2BD786D2, "forvariety" },
    { 0x1A859714, "forward" },
    { 0x0B1D2813, "forward0_wind_ent" },
    { 0xF200D338, "forward1_wind_ent" },
    { 0x80796FDE, "forward2" },
    { 0xAE3171DD, "forward2_wind_ent" },
    { 0xF7218A46, "forward_45_left" },
    { 0x75F2905D, "forward_45_right" },
    { 0x3679E6FF, "forward_angles" },
    { 0x06FE156C, "forward_anim" },
    { 0xB70AEDF8, "forward_dir" },
    { 0xAF11E9DA, "forward_direction" },
    { 0x0F0AF94D, "forward_displacement_vector1" },
    { 0x350D73B6, "forward_displacement_vector2" },
    { 0x5B0FEE1F, "forward_displacement_vector3" },
    { 0x50FE9540, "forward_displacement_vector4" },
    { 0x77010FA9, "forward_displacement_vector5" },
    { 0x554CE0E7, "forward_dist" },
    { 0x4DA52162, "forward_distance" },
    { 0x231DAE3F, "forward_distance1" },
    { 0xB1163F04, "forward_distance2" },
    { 0xD718B96D, "forward_distance3" },
    { 0x65114A32, "forward_distance4" },
    { 0x8B13C49B, "forward_distance5" },
    { 0x61624B8C, "forward_dot" },
    { 0xF3585099, "forward_euler_integration" },
    { 0xFCFCC837, "forward_fire_angle" },
    { 0x6A8E551D, "forward_idle" },
    { 0x1E1288F5, "forward_left_45_vec" },
    { 0x5B256CC0, "forward_mag" },
    { 0x08B77BB1, "forward_max_reaction_dist_sq" },
    { 0x0A8722D3, "forward_min_reaction_dist_sq" },
    { 0x706F5193, "forward_node" },
    { 0x8D5A5A61, "forward_norm" },
    { 0xB374286F, "forward_org" },
    { 0x84E7B571, "forward_origin" },
    { 0xC9D6C72A, "forward_position" },
    { 0xACF65AF7, "forward_position1" },
    { 0x3AEEEBBC, "forward_position2" },
    { 0x98FBBEDE, "forward_reaction_interval" },
    { 0x61FB4FBC, "forward_right_45_vec" },
    { 0xA19E3B72, "forward_scaling" },
    { 0x45AF465F, "forward_search" },
    { 0xB223ACD7, "forward_squad" },
    { 0xAFF199F3, "forward_squad_guy" },
    { 0x3FA1BF19, "forward_squad_move" },
    { 0x42A6DBB4, "forward_struct" },
    { 0xFE775560, "forward_units" },
    { 0xF8C20983, "forward_vec" },
    { 0xA29F1A32, "forward_vec3" },
    { 0x9407EF2D, "forward_vect" },
    { 0xE3D7DA52, "forward_vector" },
    { 0x92F2AD77, "forward_view_angles" },
    { 0x99E536DD, "forward_wind0_id" },
    { 0xD8C64612, "forward_wind1_id" },
    { 0x1F34631B, "forward_wind2_id" },
    { 0x7ECE4DDF, "forward_wind_vol" },
    { 0x0CEACCA5, "forwardangle" },
    { 0x1C4ABAA0, "forwardclose" },
    { 0xD79411C9, "forwarddir" },
    { 0xA0B22974, "forwarddist" },
    { 0xAD28CB05, "forwarddistance" },
    { 0xB3E91D7C, "forwarddotbanzai" },
    { 0xB74CD52B, "forwarddotmy" },
    { 0xDAF15C73, "forwardent" },
    { 0xB393F1E7, "forwardfar" },
    { 0x730BF454, "forwarding" },
    { 0xE7B57D64, "forwardjukeengagementdistmax" },
    { 0xD296D5CA, "forwardjukeengagementdistmin" },
    { 0x9BFDDB03, "forwardjukeengagementheightmax" },
    { 0x611438ED, "forwardjukeengagementheightmin" },
    { 0x3D4B46F7, "forwardleft" },
    { 0x3A3C9089, "forwardnoz" },
    { 0x4B4188A5, "forwardoffset" },
    { 0x13ABF7BB, "forwardpart" },
    { 0x5453726D, "forwardposition" },
    { 0x7A81DB96, "forwardpositiononwall" },
    { 0xC0E97471, "forwardpositionvalid" },
    { 0xAF36CB32, "forwardright" },
    { 0xFF06270C, "forwardrunanim" },
    { 0x271A8487, "forwards" },
    { 0x3BAC9BFC, "forwardthrow" },
    { 0x7AC385D2, "forwardvec" },
    { 0x7A6B8AD8, "forwardvec2d" },
    { 0xF23DB4B1, "forwardvector" },
    { 0x541E12A4, "forwardweight" },
    { 0x9B216115, "forwardyaw" },
    { 0x25A54F57, "fos" },
    { 0x1B93F678, "fot" },
    { 0x6AF00BDD, "fougasese" },
    { 0x393740C0, "fougasse" },
    { 0xD471BB2D, "fougasse_fail_timer" },
    { 0xFEE20D63, "fougasse_obj_cleanup" },
    { 0xE5C4EC7F, "fougasse_obj_num" },
    { 0xFDF20482, "fougasse_spawner_pause_manager" },
    { 0x9855FEE5, "fougasse_spawners_think" },
    { 0xF29475F7, "fougasse_timer_dialogue" },
    { 0x871A3F80, "fought" },
    { 0x33B720BB, "foughttime" },
    { 0xEB568523, "found" },
    { 0xCE561745, "found_bad_target" },
    { 0xDE690B82, "found_corpse" },
    { 0xCFDD6DC7, "found_corpse_behavior" },
    { 0x8B88E532, "found_corpse_notify" },
    { 0xD421B5D6, "found_corpse_wait" },
    { 0xF2CE15CE, "found_correct_position" },
    { 0x1BA18AB3, "found_count" },
    { 0x229D7F5A, "found_current_skipto" },
    { 0xB56B8E3A, "found_dist" },
    { 0x24072AE4, "found_distsqrd" },
    { 0x7446ACE8, "found_ee_radio_count" },
    { 0x74CF8AFF, "found_infountain" },
    { 0x0E88F633, "found_item" },
    { 0x36043AA4, "found_loc" },
    { 0xDBD1D4B2, "found_node" },
    { 0xAD34739B, "found_path" },
    { 0x6EE92ED9, "found_player" },
    { 0xA69886B4, "found_point" },
    { 0x927F492F, "found_position" },
    { 0x257309E1, "found_spawners" },
    { 0x77EB2435, "found_strela" },
    { 0x7904227A, "found_toucher" },
    { 0xA363B4F1, "found_unexcluded" },
    { 0x6D6BA39E, "found_weapon" },
    { 0xAA492F36, "found_weapon_target" },
    { 0x24413817, "foundanims" },
    { 0x690D55F4, "foundanode" },
    { 0xE298D578, "foundaspot" },
    { 0x3748F64E, "foundation" },
    { 0x5A7E5686, "foundbettercover" },
    { 0x8F0C608B, "foundcorpse" },
    { 0x410DE38C, "foundgamemode" },
    { 0x0805FD7E, "foundgoal" },
    { 0xCC7A115C, "foundit" },
    { 0x7881D8DE, "foundmatch" },
    { 0x4D459E88, "foundnewplayer" },
    { 0x04BB8B9B, "foundnode" },
    { 0xDDC8C9C1, "foundone" },
    { 0xB43D22BE, "foundpath" },
    { 0x84C53EE1, "foundzone" },
    { 0xBAD46F2D, "fountain" },
    { 0x0EF1DA0D, "fountain_debug_print" },
    { 0x39585B85, "fountain_fxanim" },
    { 0x28E6A2D0, "fountain_mg" },
    { 0x71038F6E, "fountain_mg42_activate" },
    { 0xCBBCC391, "fountain_open_sesame" },
    { 0xA014866C, "fountain_out" },
    { 0xEF8CB347, "fountain_setup" },
    { 0xFDDE51EC, "fountain_shooter" },
    { 0x06F19401, "fountain_top" },
    { 0xA4E99036, "fountain_transport_think" },
    { 0x34F663F1, "four" },
    { 0x7B1D8016, "four_part_convos" },
    { 0x7C30779C, "four_player_coopenemyaccuracyscalar" },
    { 0xFD59FCE7, "four_player_coopfriendlyaccuracyscalar" },
    { 0xF45F8E27, "four_player_coopfriendlythreatbiasscalar" },
    { 0x7FC7AC2B, "four_player_coopplayerdifficultyhealth" },
    { 0x161F6FD1, "four_player_deathinvulnerabletimemodifier" },
    { 0x550F6F64, "four_player_enemy_pain_chance_modifier" },
    { 0xF2AF205F, "four_player_hit_invulnerability_modifier" },
    { 0x35555E78, "fourecent" },
    { 0xC4A50CF1, "fourteen" },
    { 0x15B17D2D, "fourth" },
    { 0x12911811, "fourth_guy" },
    { 0x7939CCF8, "fourth_guys" },
    { 0x8DCA945D, "fourth_village_area_cleared" },
    { 0xBCC602A1, "fouterdamage" },
    { 0x6798EB4A, "fov" },
    { 0x5FB7C746, "fov_angle" },
    { 0x33880A3D, "fov_bone_control" },
    { 0xA8CFC341, "fov_change_1" },
    { 0x9317F440, "fov_change_1_start" },
    { 0xCED23DAA, "fov_change_2" },
    { 0xF4D4B813, "fov_change_3" },
    { 0x67A81D9E, "fov_cos" },
    { 0x413623EB, "fov_inc" },
    { 0x4556A8D8, "fov_is_dirty" },
    { 0xF43AB76E, "fov_lerp" },
    { 0x269F18B7, "fov_lerper" },
    { 0xA1328891, "fov_lerps" },
    { 0x28963421, "fov_listener" },
    { 0x6249E6D1, "fov_max" },
    { 0xCFC1C52F, "fov_min" },
    { 0x207FEFC8, "fov_multiplier" },
    { 0xD1620897, "fov_origin" },
    { 0x84645366, "fov_reset" },
    { 0xA413D4D3, "fov_set" },
    { 0xD2731514, "fov_tag_origin" },
    { 0xA9312D11, "fov_thread" },
    { 0x360EF51A, "fov_to_dot" },
    { 0x8CC3D7E5, "fov_toggle" },
    { 0x8EB54DE4, "fov_transition" },
    { 0xBCD59D68, "fovads" },
    { 0xA1F56F1F, "fovcosine" },
    { 0xBEA11B80, "fovcosinebusy" },
    { 0x6CA4986F, "fovdot" },
    { 0xD51D1E6C, "fovinnerfraction" },
    { 0xE9190FC5, "fovpercent" },
    { 0xD9904485, "fovs" },
    { 0xBF2DB7AF, "fovslidercheck" },
    { 0xA6751562, "foward" },
    { 0xF5BD1B0D, "fowd" },
    { 0x65924F82, "fowled" },
    { 0x725B686A, "foxhole" },
    { 0x81FF3FDD, "foxhole1friendlyarray" },
    { 0xC8890635, "foxhole1wave1" },
    { 0xEB46F606, "foxhole1wave1spawners" },
    { 0xEE8B809E, "foxhole1wave2" },
    { 0x77DC3961, "foxhole1wave2spawners" },
    { 0x0C979C5C, "foxhole2wave1" },
    { 0xD01704F3, "foxhole2wave1spawners" },
    { 0xC3FDCEEB, "foxhole3friendlyarray" },
    { 0xF9FA1527, "foxhole3wave1" },
    { 0x6F7917F4, "foxhole3wave1spawners" },
    { 0x87F2A5EC, "foxhole3wave2" },
    { 0x0E8ED9E3, "foxhole3wave2spawners" },
    { 0x6A59D825, "foxholes" },
    { 0x41041F4F, "foxtrot" },
    { 0xE2AE7F2C, "foyer" },
    { 0xE0C5B8F7, "foyer_bazookateam" },
    { 0x2DD9189C, "foyer_bazookateam_dialogue" },
    { 0x09B385A5, "foyer_defenders" },
    { 0xD5ACCDF9, "foyer_flagbearer_buddies_spawnfunc" },
    { 0x83A6BDA4, "foyer_force_ai_fire" },
    { 0xE55829DD, "foyer_intro_hallway_running_dialogue" },
    { 0x1F18F08C, "foyer_main" },
    { 0xBFA964FB, "foyer_mg" },
    { 0x7A20377F, "foyer_midpoint" },
    { 0xC01B5AA6, "foyer_pacing_friendly_hallrunners_spawnfunc" },
    { 0x0C283E73, "foyer_spawn_redshirts_1" },
    { 0x0F85B6BC, "foyer_support" },
    { 0x9B76BFD1, "foyer_zone" },
    { 0x651FB143, "fozen" },
    { 0x25295D79, "fp_give_reward" },
    { 0x83182B7D, "fp_init_stat" },
    { 0x98916BAA, "fp_reward_override" },
    { 0x21700432, "fpc" },
    { 0xF932D5E8, "fpercent" },
    { 0x4BC16074, "fpower" },
    { 0x0F4F279C, "fpredist" },
    { 0xA2B29765, "fprintfields" },
    { 0x73AB5C8C, "fprintln" },
    { 0x8197AAC2, "fps" },
    { 0xF216C490, "fps_claw" },
    { 0x732C5ACB, "fps_claw_done" },
    { 0xEF06C71E, "fps_claw_done_done" },
    { 0x2562C3D3, "fps_claw_fire" },
    { 0x75BC27C6, "fps_claw_fire_done" },
    { 0xC3953EC9, "fps_claw_fire_done_done" },
    { 0x76B7B815, "fps_claw_gren" },
    { 0xFA5685B8, "fps_claw_gren_done" },
    { 0x43D29D53, "fps_claw_gren_done_done" },
    { 0x11C645FD, "fps_garage_guys" },
    { 0x9DC7CD9D, "fps_heroes" },
    { 0x2A40E24E, "fps_inf" },
    { 0x41562A11, "fps_inf_done" },
    { 0x307C6BD4, "fps_inf_done_done" },
    { 0x3E53A6B4, "fps_menu" },
    { 0xF20511CD, "fps_move_single" },
    { 0x5B3C78D0, "fps_move_single_done" },
    { 0x0EC6900B, "fps_move_single_done_done" },
    { 0x7C8D6FD5, "fps_move_single_ready" },
    { 0x4A6F4296, "fps_onlymode" },
    { 0xE7BDE48F, "fps_turret" },
    { 0x7219C1F2, "fps_turret_done" },
    { 0xFE60D205, "fps_turret_done_done" },
    { 0xCC2889CC, "fps_unselect" },
    { 0x1F7E69F7, "fps_unselect_done" },
    { 0xA8CD069A, "fps_unselect_done_done" },
    { 0x12436F78, "fps_unselect_ready" },
    { 0xB59AE5DC, "fq_client_hint" },
    { 0xD803991F, "fquakepower" },
    { 0x3B6244C1, "fr" },
    { 0xDDE96BB6, "fr_bulletpenalty_bits" },
    { 0x66A8CE3A, "fr_death_penalty_seconds" },
    { 0xAF85B506, "fr_faults_bits" },
    { 0x7CDC0B0B, "fr_num_tracks" },
    { 0x422FE44F, "fr_on" },
    { 0xCD21A455, "fr_retries_bits" },
    { 0x9429CD3C, "fr_spawn_z_offset" },
    { 0xC810CFEE, "fr_state_dialog" },
    { 0xFB46DB14, "fr_state_finished" },
    { 0x79424DB8, "fr_state_paused" },
    { 0xD6C66103, "fr_state_prestart" },
    { 0xC82522D3, "fr_state_quit" },
    { 0x0C9EA4BB, "fr_state_running" },
    { 0xF8E7E827, "fr_target_disable_fx" },
    { 0x8E44204E, "fr_target_disable_sound" },
    { 0xEABCE8A5, "fr_target_impact_fx" },
    { 0x8BC66162, "fr_time_bits" },
    { 0x5D8548F5, "frac" },
    { 0x8DF9803F, "frac0" },
    { 0x67F705D6, "frac1" },
    { 0x1A78C5F7, "frac_range" },
    { 0xAC65C39B, "fracaccel" },
    { 0xA2794946, "fracconst" },
    { 0x6F8F484C, "fracdecel" },
    { 0x18DD9B7B, "fraction" },
    { 0x6A50203B, "fraction_skip" },
    { 0x1A303D44, "fractional" },
    { 0xCFDB969B, "fractionaltimeuntiltheywrap" },
    { 0x6B186262, "fractiondistance" },
    { 0x24C8AF1A, "fractions" },
    { 0x008476C9, "fractiontoblend" },
    { 0x1117D44B, "fradius" },
    { 0xC57B5F51, "frag" },
    { 0x009A59E4, "frag_grenade_sp" },
    { 0x27D8ED8B, "frag_lights" },
    { 0x4BC506B0, "frag_start" },
    { 0x93F453A7, "frag_too_low_hint" },
    { 0xC7F839FE, "frag_training" },
    { 0x5FE364C9, "frag_trigger_think" },
    { 0xC11AE181, "fragbuttonpressed" },
    { 0x57750221, "fraggrenade" },
    { 0x8C44DA73, "fragile" },
    { 0x61452B38, "frags" },
    { 0x2B8FBE21, "fragtraining_begin" },
    { 0x004DED79, "fragtraining_end" },
    { 0x6BC42F5C, "frame" },
    { 0x322967BE, "frame_bg" },
    { 0x2403C318, "frame_count" },
    { 0x0C7A7D6D, "frame_counter" },
    { 0xE83B9B83, "frame_delta_yaw" },
    { 0x0D8CDF82, "frame_difference" },
    { 0x7525836D, "frame_qty" },
    { 0x10CBCFC8, "frame_ratio" },
    { 0x9E1173F6, "frame_time_s" },
    { 0x193A8484, "framebuffer_duplicate_filter_set" },
    { 0xDC893ECA, "framebuffer_filter_set" },
    { 0xBFC75071, "framecount" },
    { 0x04F5F1D8, "framecounts" },
    { 0x5DAC93AB, "frameend" },
    { 0x874DE21A, "framefraction" },
    { 0x24330950, "frameindex" },
    { 0x6E55586F, "frameinterval" },
    { 0xAE032936, "framer" },
    { 0x68D815D2, "framerate" },
    { 0xD405A39F, "frames" },
    { 0xFBB42627, "frames_since_jump" },
    { 0x7A37FA7B, "framessincetargetscan" },
    { 0xCA5882CF, "frametime" },
    { 0x24D12C93, "framework" },
    { 0x3D6B0B45, "framing" },
    { 0x5336C124, "frand" },
    { 0x3D36F167, "frandomtime" },
    { 0x5D481A03, "frank" },
    { 0x96A0A5CC, "frantic" },
    { 0x3A4B7B9F, "frantic_engineers" },
    { 0xB66CCA50, "frcx" },
    { 0x2B4CA53F, "freadln" },
    { 0x760F7CDA, "freak" },
    { 0x74E05616, "freaking" },
    { 0x3E99AA6A, "freakish" },
    { 0x47438466, "freakout" },
    { 0x3E6C2917, "free" },
    { 0xAF885CFB, "free_bleeder" },
    { 0x669D9673, "free_blockers_available" },
    { 0xF579C379, "free_fall" },
    { 0x0CB64B9E, "free_perk" },
    { 0xBCE49437, "free_perk_powerup" },
    { 0x22EDC4DD, "free_player_camera" },
    { 0x22B329B9, "free_pow_trig" },
    { 0x129F74B9, "free_reviver" },
    { 0xB40B95A5, "free_rockets" },
    { 0xFB0F160E, "free_vehicle" },
    { 0x226EBC24, "freebees" },
    { 0xDD4101FC, "freecam" },
    { 0x80929AEB, "freecodeimage" },
    { 0xA1BC29A4, "freecurve" },
    { 0x824CDE31, "freed" },
    { 0xD926A349, "freedom" },
    { 0x832EA418, "freefall" },
    { 0x908C0F77, "freefall0_wind_ent" },
    { 0x5F8F3A5C, "freefall1_wind_ent" },
    { 0x351596B1, "freefall2_wind_ent" },
    { 0x6CA28AF0, "freefall_speed" },
    { 0x1EE3DF2F, "freefall_stop" },
    { 0xF21BE329, "freefall_wind0_id" },
    { 0x6CBDCDCE, "freefall_wind1_id" },
    { 0xF7298B67, "freefall_wind2_id" },
    { 0x1EDFDBAB, "freefall_wind_vol" },
    { 0x2F32F200, "freefalling" },
    { 0xEBDCF8B2, "freegameplayhudelems" },
    { 0xB5F759C9, "freeing" },
    { 0x73D42CBC, "freekillstreaktimer" },
    { 0x41BF4C3A, "freelook" },
    { 0x43A3C67A, "freely" },
    { 0x057328C7, "freeonend" },
    { 0x38C50EBF, "freepassused" },
    { 0xA5E55398, "freeplayer" },
    { 0xD31F9573, "freeplayers" },
    { 0x0C999A08, "freeroam" },
    { 0x44F78AB6, "freerun" },
    { 0x5C60CDDC, "freerunbesttimeupdated" },
    { 0xD069A1B6, "freerunbulletpenaltyupdated" },
    { 0x7D2B77A9, "freeruncheckpointupdated" },
    { 0x00AD9D02, "freerunfaultsupdated" },
    { 0xAA7F64C1, "freerunfinishtimeupdated" },
    { 0x3768CF9B, "freerunmode" },
    { 0xB7A29F53, "freerunmusic" },
    { 0x497CEBCC, "freerunpausedtimeupdated" },
    { 0xC6CE0F39, "freerunretriesupdated" },
    { 0x6EEFE46B, "freerunsethighscores" },
    { 0x9214001E, "freerunstarttimeupdated" },
    { 0x16CAB10F, "freerunstatechanged" },
    { 0x7B5865B4, "freeruntimeadjustmentsignupdated" },
    { 0xAC5D4A6D, "freeruntimeadjustmentupdated" },
    { 0xA080E8CE, "frees" },
    { 0x23009815, "freevehicle" },
    { 0x9BD01684, "freeway" },
    { 0xA1A26393, "freeway_barrier_suspension_audio" },
    { 0x423C6D33, "freeway_chunks_fall" },
    { 0x80B188ED, "freeway_cleanup" },
    { 0x301E2259, "freeway_set_turret_targets" },
    { 0x5DD4A037, "freeways" },
    { 0x8ADD346C, "freewhensafe" },
    { 0xC2E27E50, "freeze" },
    { 0x0465768D, "freeze_controls_delay" },
    { 0xF2F9C45B, "freeze_controls_for_time" },
    { 0x1CB29800, "freeze_everyone" },
    { 0xAD72485D, "freeze_me" },
    { 0xFFC1A0C5, "freeze_origin" },
    { 0x056CEE95, "freeze_player_controls" },
    { 0xE3C73203, "freeze_players" },
    { 0xB3B694B5, "freeze_zombie" },
    { 0x9E9D9E62, "freezecontrolonconnect" },
    { 0xFAF8F736, "freezecontrols" },
    { 0x92A1D2F6, "freezecontrols_all" },
    { 0xC148B5AC, "freezecontrolsallowlook" },
    { 0x7699F8DF, "freezecontrolswrapper" },
    { 0x195A7EA7, "freezeframe" },
    { 0x0E5978FF, "freezeframed_vehicles" },
    { 0x7AE81D5E, "freezegun" },
    { 0x329F9609, "freezegun_cleanup_freezegun_triggers" },
    { 0x2CDC13C5, "freezegun_clear_extremity_damage_fx" },
    { 0xE7D37555, "freezegun_clear_torso_damage_fx" },
    { 0x172B6A1A, "freezegun_damage" },
    { 0x46BDA273, "freezegun_damage_fx_handles" },
    { 0x1341F740, "freezegun_damage_response" },
    { 0x06BCB8AD, "freezegun_damage_response_func" },
    { 0x298E3F1F, "freezegun_damage_torso_fx" },
    { 0x44EE18C9, "freezegun_death" },
    { 0x5A668C86, "freezegun_debug_print" },
    { 0x77AF4448, "freezegun_devgui_dvar_think" },
    { 0x00325E21, "freezegun_do_crumple" },
    { 0xD516B52A, "freezegun_do_damage" },
    { 0xA707F1D9, "freezegun_do_gib" },
    { 0x18F336DE, "freezegun_do_gib_fx" },
    { 0xFE2EA43C, "freezegun_do_shatter" },
    { 0x658AEA45, "freezegun_end_all_extremity_damage_fx" },
    { 0x5BE9E3D5, "freezegun_end_all_torso_damage_fx" },
    { 0x9CF3D061, "freezegun_end_extremity_damage_fx" },
    { 0x6884A217, "freezegun_end_extremity_damage_fx_for_all_localclients" },
    { 0x76843AB3, "freezegun_enemies" },
    { 0xC8D85B92, "freezegun_enemies_dist_ratio" },
    { 0x686F79BB, "freezegun_extremity_damage_fx" },
    { 0xD89539F7, "freezegun_extremity_damage_fx_handles" },
    { 0x97C1BAD7, "freezegun_fired" },
    { 0xAB5BC110, "freezegun_get_crumple_effect" },
    { 0xCE2DE6A5, "freezegun_get_cylinder_radius" },
    { 0xE49A9A16, "freezegun_get_enemies_in_range" },
    { 0x3F74D289, "freezegun_get_gibforce" },
    { 0x2F0A1C1A, "freezegun_get_gibfx" },
    { 0x7B237E1D, "freezegun_get_gibsound" },
    { 0x48D96976, "freezegun_get_gibtrailfx" },
    { 0x15373982, "freezegun_get_inner_damage" },
    { 0xC4D3A4E4, "freezegun_get_inner_range" },
    { 0xC4A68095, "freezegun_get_outer_damage" },
    { 0x66B2BA05, "freezegun_get_outer_range" },
    { 0x5CF537C3, "freezegun_get_shatter_effect" },
    { 0x794050C8, "freezegun_get_shatter_inner_damage" },
    { 0x1AF5578F, "freezegun_get_shatter_outer_damage" },
    { 0xA986048F, "freezegun_get_shatter_range" },
    { 0xA4B09F84, "freezegun_gib_override" },
    { 0xCBA8AD13, "freezegun_inner_range_squared" },
    { 0xE17E4DF5, "freezegun_on_player_connect" },
    { 0xA68379F6, "freezegun_outer_range_squared" },
    { 0xB57578E2, "freezegun_play_all_extremity_damage_fx" },
    { 0x654CCF9E, "freezegun_play_all_torso_damage_fx" },
    { 0x19C966BA, "freezegun_play_extremity_damage_fx" },
    { 0x83B3B00E, "freezegun_run_skipped_death_events" },
    { 0xA5A9AFD2, "freezegun_set_extremity_damage_fx" },
    { 0xFDBB9CCE, "freezegun_set_torso_damage_fx" },
    { 0x2C1F6B2F, "freezegun_torso_damage_fx" },
    { 0x58525685, "freezegun_wait_for_crumple" },
    { 0x16D4D968, "freezegun_wait_for_shatter" },
    { 0x890F5017, "freezeplayerforroundend" },
    { 0xEB7EB93B, "freezes" },
    { 0x9C00FCD1, "freezing" },
    { 0x73E46AB3, "freidrich" },
    { 0x01DCFB78, "freidrick" },
    { 0x258347E2, "freight" },
    { 0x6130FAB3, "freighter" },
    { 0x73F18E26, "freindlychains" },
    { 0x526EB60D, "french" },
    { 0x463A98E3, "freq" },
    { 0x86D869B5, "frequency" },
    { 0x253D6783, "frequent" },
    { 0x8BAAC7AE, "frequently" },
    { 0x030E265B, "fresh" },
    { 0x33142E46, "freshly" },
    { 0x25665CDB, "frgame" },
    { 0x74AECC0C, "friday" },
    { 0x42C5BAF6, "fridge" },
    { 0x78D536BD, "fridge_move_dialog" },
    { 0x40A88415, "fried" },
    { 0x7C951778, "friedly" },
    { 0xD28193B0, "friednlies" },
    { 0xB0FA958C, "friednly" },
    { 0xF6E61B13, "friedrich" },
    { 0x4C32CC14, "frieldies" },
    { 0x0C868289, "friend" },
    { 0xFA460F92, "friend1" },
    { 0xC2046401, "friend1_re_spawned" },
    { 0xE6A0D4FB, "friend1_start" },
    { 0xD4439529, "friend2" },
    { 0x5805661C, "friend2_re_spawned" },
    { 0x9787F2B8, "friend2_start" },
    { 0x99D010AD, "friend_add" },
    { 0x9366F668, "friend_bunker_strat" },
    { 0xE544A489, "friend_follow_player" },
    { 0xA59264C4, "friend_follow_player_stop" },
    { 0xB7993AB5, "friend_forest_spawner_strat" },
    { 0xAA6ECC02, "friend_goal_in_radius" },
    { 0xBD3D1236, "friend_in_radius" },
    { 0xD56979CE, "friend_kill_points" },
    { 0xF36B8920, "friend_not_foe" },
    { 0xD3D6BA6C, "friend_not_foe_team" },
    { 0x08E5CE8A, "friend_origin" },
    { 0xC4B4071C, "friend_remove" },
    { 0x898709E3, "friend_remove_on_death" },
    { 0x032BD2C0, "friend_strong_influencer_length" },
    { 0x20BF6116, "friend_strong_influencer_radius" },
    { 0xE451A8E2, "friend_strong_influencer_score" },
    { 0x5FD89B3E, "friend_strong_influencer_score_curve" },
    { 0x022CE77F, "friend_team" },
    { 0x71A3508C, "friend_trap_spawner_extra_strat" },
    { 0x50660EC7, "friend_weak_influencer_radius" },
    { 0x0446FF09, "friend_weak_influencer_score" },
    { 0xA41FEF5D, "friend_weak_influencer_score_curve" },
    { 0x953A6189, "friendicons" },
    { 0x00B64CF2, "friendies" },
    { 0xA7DE9E75, "friendies_extra" },
    { 0x84A7E6AF, "friendleaderboarda" },
    { 0x12A07774, "friendleaderboardb" },
    { 0x98D94F03, "friendles" },
    { 0x1BF7D641, "friendlier" },
    { 0xF5F55BD8, "friendlies" },
    { 0x6906F3EF, "friendlies_advance_up_the_bridge" },
    { 0x5F6D0E55, "friendlies_arrange_in_hallway_of_apartment" },
    { 0x2D508F14, "friendlies_become_awesome" },
    { 0xCFD81626, "friendlies_become_invulnerable" },
    { 0xD1638BFD, "friendlies_blow_bmp02" },
    { 0x734111C6, "friendlies_c" },
    { 0xEB41BF7D, "friendlies_charge_alley_early" },
    { 0xB71D1ABB, "friendlies_coming_out" },
    { 0xB57A4FE5, "friendlies_compound_dialogue" },
    { 0x61D93A7F, "friendlies_fighting_nodes" },
    { 0x6234077A, "friendlies_focus_fire_on_turret_after_time" },
    { 0x7103C37E, "friendlies_force_teleport" },
    { 0x699A2ECC, "friendlies_help_upstairs" },
    { 0x32A2996C, "friendlies_into_choppers" },
    { 0xBA9390D3, "friendlies_intro_patrolwalk" },
    { 0xFCE691AC, "friendlies_move" },
    { 0xCE1AE8D9, "friendlies_move_into_courtyard" },
    { 0x6FF96A24, "friendlies_not_in_chopper" },
    { 0x5E8814A6, "friendlies_open_upstairs_door" },
    { 0x783FEACC, "friendlies_past_killzone" },
    { 0x72C8A4E7, "friendlies_plaza_seaknights" },
    { 0xFB0D9632, "friendlies_setup" },
    { 0x5CA5114F, "friendlies_skipto_setup" },
    { 0x5A048524, "friendlies_start_paths" },
    { 0x86212253, "friendlies_stop_on_truck_spotted" },
    { 0xF8F49E75, "friendlies_stop_paths_to_fight" },
    { 0xAECB979A, "friendlies_stuck_ingulch" },
    { 0xD8F9D095, "friendlies_take_fire" },
    { 0x17A71526, "friendlies_told_to_load_choppers" },
    { 0x6D73EBB0, "friendlies_up" },
    { 0x3E820B54, "friendly" },
    { 0x40E1F635, "friendly1" },
    { 0x66E4709E, "friendly2" },
    { 0x8CE6EB07, "friendly3" },
    { 0x82D59228, "friendly4" },
    { 0xA8D80C91, "friendly5" },
    { 0xCEDA86FA, "friendly6" },
    { 0xF4DD0163, "friendly7" },
    { 0x32C402D0, "friendly_accuracy" },
    { 0x32ECE8D2, "friendly_adjust_movement_speed" },
    { 0xBF09D5BD, "friendly_advance_chain" },
    { 0xB8E76549, "friendly_ai" },
    { 0x2B5F3004, "friendly_ai_getwet" },
    { 0x1A8BAB46, "friendly_ai_intruderwatch" },
    { 0x8018954C, "friendly_ai_think" },
    { 0x4B64A940, "friendly_ais" },
    { 0xF375C151, "friendly_apc_movement" },
    { 0xB3304986, "friendly_asd_death" },
    { 0x5DDA1DFB, "friendly_asd_in_theater" },
    { 0x0D8A4FB8, "friendly_asd_think" },
    { 0x47187D80, "friendly_at4" },
    { 0x0F851321, "friendly_attack_time" },
    { 0x90350540, "friendly_basin_tanks" },
    { 0x5CF7E8E8, "friendly_blows_gate" },
    { 0xC94DAF9F, "friendly_blue_color" },
    { 0xE6807E54, "friendly_bmp" },
    { 0x65096063, "friendly_bmp_damage_ignore_timer" },
    { 0xDF00FE2D, "friendly_boat" },
    { 0x29B0582C, "friendly_boats" },
    { 0x011587AF, "friendly_breach_thread" },
    { 0xD620762E, "friendly_breach_vent" },
    { 0x57358493, "friendly_bridge_flank_grabber" },
    { 0x1E795D69, "friendly_chain_admin_last" },
    { 0x10114BC0, "friendly_chain_control" },
    { 0xEEF0AE09, "friendly_chain_on_death" },
    { 0x3E59F3E6, "friendly_check_radius" },
    { 0x7897F16D, "friendly_cliff_target" },
    { 0x7767078D, "friendly_compute_score" },
    { 0x021F2F59, "friendly_compute_stances_ai" },
    { 0x1E97CEFC, "friendly_compute_stances_player" },
    { 0x0FDAAD65, "friendly_convoy" },
    { 0x7A5C0F82, "friendly_cycle_spawner" },
    { 0x200E0F2F, "friendly_damage_max" },
    { 0x63A90F7D, "friendly_default_ai_functions" },
    { 0x634D26D8, "friendly_default_movespeed_scale" },
    { 0xD9CDBB41, "friendly_default_stance_handler_distances" },
    { 0x598A0201, "friendly_died" },
    { 0x3E4E9917, "friendly_door_bash_done" },
    { 0x3542D2CF, "friendly_doorbreach_dooropen" },
    { 0x8954D924, "friendly_drone_shoot_logic" },
    { 0x11038322, "friendly_face_started" },
    { 0x706F7B05, "friendly_finished_using_mg42" },
    { 0x600ADD77, "friendly_fire" },
    { 0x36510FEB, "friendly_fire_callback" },
    { 0x3763BDA2, "friendly_fire_check" },
    { 0x8E75A073, "friendly_fire_checker" },
    { 0x2DE1B253, "friendly_fire_checkpoints" },
    { 0x8DC6698F, "friendly_fire_checks_on_friendly_boats" },
    { 0xB27C7A4D, "friendly_fire_fail_during_surrender" },
    { 0x7A76E7DF, "friendly_fire_fail_if_shot_by_player" },
    { 0x3C1C4514, "friendly_fire_instant_fail" },
    { 0x3B73B8A0, "friendly_fire_instant_fail_add" },
    { 0x54F1192B, "friendly_fire_instant_fail_remove" },
    { 0x07C39099, "friendly_fire_kill_tank" },
    { 0x77263E46, "friendly_fire_kill_tank_reduce" },
    { 0xE4164D53, "friendly_fire_mission_failure" },
    { 0x7E463804, "friendly_fire_reduce" },
    { 0x6ECD409B, "friendly_fire_reset" },
    { 0xDA276961, "friendly_fire_shield" },
    { 0xF08EBF85, "friendly_fire_shield_callback" },
    { 0x99F182F3, "friendly_fire_terminate" },
    { 0x29FF364E, "friendly_fire_think" },
    { 0xCC4D293D, "friendly_fire_vehicle_thread" },
    { 0xAC074237, "friendly_flank_deleter" },
    { 0x2C0C0C68, "friendly_force_spawner_think" },
    { 0xF20A61CE, "friendly_getangles_ai" },
    { 0xF2365573, "friendly_getangles_player" },
    { 0x4054262A, "friendly_getstance_ai" },
    { 0x6E19E0AF, "friendly_getstance_player" },
    { 0x381B0DA4, "friendly_getvelocity" },
    { 0xE5692C9F, "friendly_give_gun" },
    { 0x965BD7E9, "friendly_globals" },
    { 0x1CFAC250, "friendly_globals_check_wave" },
    { 0xAA9E667C, "friendly_grave_tanks" },
    { 0x469B0A12, "friendly_grenades" },
    { 0x6360F8E1, "friendly_health" },
    { 0x6934559A, "friendly_health_init" },
    { 0x5EF5408A, "friendly_hillside_cover_" },
    { 0x1FBF8389, "friendly_huey_death_c" },
    { 0xDDCBE796, "friendly_huey_death_d" },
    { 0x3916652D, "friendly_huey_think" },
    { 0xF7837190, "friendly_human_shield_setup" },
    { 0xD7FF5625, "friendly_init" },
    { 0xEC44035E, "friendly_light_fx" },
    { 0x49B83CBF, "friendly_logic" },
    { 0x981F1E04, "friendly_main" },
    { 0xB9B745CB, "friendly_mantle_through_window" },
    { 0x6BBFB209, "friendly_message_loop" },
    { 0x93CBBBE5, "friendly_mg42" },
    { 0x9665263C, "friendly_mg42_cleanup" },
    { 0x9F15247E, "friendly_mg42_death_notify" },
    { 0x49637B42, "friendly_mg42_doneusingturret" },
    { 0xF62DD411, "friendly_mg42_endtrigger" },
    { 0x2CB28854, "friendly_mg42_stop_use" },
    { 0x5882F840, "friendly_mg42_think" },
    { 0xB8CB5525, "friendly_mg42_useable" },
    { 0xEDBB7CA7, "friendly_mg42_wait_for_use" },
    { 0xD464C689, "friendly_mgturret" },
    { 0x8E74A409, "friendly_min" },
    { 0xFA38E8AA, "friendly_movememnt_advance" },
    { 0xC7C9BF05, "friendly_movememnt_advance_logic" },
    { 0x0216A54C, "friendly_movement_reset" },
    { 0x9FCA5F1C, "friendly_movement_speed" },
    { 0xEA6EEBCC, "friendly_movement_wait" },
    { 0x4E1C5AB0, "friendly_movespeed_calc_loop" },
    { 0x4B577BB1, "friendly_origin" },
    { 0x3E9F445B, "friendly_outline" },
    { 0x06E96447, "friendly_overpass_dialogue_response" },
    { 0x19EB0636, "friendly_pbr_crew_spawn_function" },
    { 0xFDEE310C, "friendly_player" },
    { 0x0317E859, "friendly_player_shoot_watcher" },
    { 0xEC0FB73E, "friendly_player_tracking_nav" },
    { 0x6ED1B239, "friendly_promotion_thread" },
    { 0x4DB5108C, "friendly_pushplayer" },
    { 0x65F9740C, "friendly_reinforcements_magic_bullet" },
    { 0xE28C9AE5, "friendly_repel_animload" },
    { 0xB07EC1D7, "friendly_repel_spawner_think" },
    { 0x8C72FFC9, "friendly_respawn" },
    { 0xE66FD73B, "friendly_respawn_clear" },
    { 0x8EF9E6B8, "friendly_respawn_trigger" },
    { 0x8488C35B, "friendly_respawn_vision_checker_thread" },
    { 0x100F9928, "friendly_respawners_init" },
    { 0xF5E2EE43, "friendly_retreat_strat" },
    { 0x314F0ECF, "friendly_run_into_chopper" },
    { 0xEE647C1D, "friendly_run_into_chopper_death_handler" },
    { 0x028CCB7D, "friendly_set" },
    { 0xCDA66D73, "friendly_set_movespeed_scale" },
    { 0x79587AA4, "friendly_set_stance_handler_distances" },
    { 0xFAEA198E, "friendly_setup" },
    { 0xA86CC45D, "friendly_setup_thread" },
    { 0x8E22A9D2, "friendly_should_speed_up" },
    { 0xDD91EBB8, "friendly_sight_distance" },
    { 0xB0A9A57C, "friendly_spawn" },
    { 0xAE6DE479, "friendly_spawner" },
    { 0x1A229282, "friendly_spawner_death" },
    { 0x3CA022BC, "friendly_spawner_think" },
    { 0xD5192A80, "friendly_spawner_vision_checker" },
    { 0x3DCF94B0, "friendly_spawners" },
    { 0x894423F4, "friendly_spotted_getup_from_prone" },
    { 0x4ADC9A4A, "friendly_spotted_getup_from_prone_rotate" },
    { 0x177A7F17, "friendly_squad" },
    { 0x665E2E2D, "friendly_squad_array" },
    { 0xE8C5EE5A, "friendly_squad_clear_to_fire" },
    { 0xB83521C0, "friendly_squad_gets_off_boat" },
    { 0xEDF3B9B7, "friendly_squad_holds_fire" },
    { 0x4434D243, "friendly_squad_queue" },
    { 0x5D4791F9, "friendly_squad_relocator_for_skiptos" },
    { 0xB45ED332, "friendly_squad_spawner" },
    { 0xBE7B0623, "friendly_stance" },
    { 0x82A3F776, "friendly_stance_handler" },
    { 0x27DE508B, "friendly_stance_handler_change_stance_down" },
    { 0xF8A27C74, "friendly_stance_handler_change_stance_up" },
    { 0x5E6BB03D, "friendly_stance_handler_check_mightbeseen" },
    { 0x5B2EEBD3, "friendly_stance_handler_init" },
    { 0x62CF6A96, "friendly_stance_handler_resume_path" },
    { 0xF6E1BAFE, "friendly_stance_handler_return_ai_sight" },
    { 0xA641257E, "friendly_stance_handler_set_stance_up" },
    { 0x71D47765, "friendly_stance_handler_stay_still" },
    { 0x7FC827B1, "friendly_startup_thread" },
    { 0xE225B409, "friendly_state_alert" },
    { 0xBAEA469D, "friendly_state_hidden" },
    { 0x6805F240, "friendly_state_spotted" },
    { 0xFC092B12, "friendly_stealth_state" },
    { 0xCA3615A7, "friendly_tank" },
    { 0x4C941FAA, "friendly_tank_wait_for_enemy_tank_die_then_move" },
    { 0xC51C80F2, "friendly_tank_wait_for_enemy_tank_to_die" },
    { 0x00ECD11E, "friendly_tanks" },
    { 0x7B12DC97, "friendly_targets" },
    { 0x45602B15, "friendly_think" },
    { 0x49B7D62D, "friendly_trig" },
    { 0x77B63D18, "friendly_trigger_think" },
    { 0xF1742C6D, "friendly_unit_spawned_" },
    { 0x189C9B66, "friendly_unit_spawned_bigdog_pkg" },
    { 0xEE099349, "friendly_unit_spawned_infantry_ally_reg2_pkg" },
    { 0x9D460FF2, "friendly_unit_spawned_metalstorm_pkg" },
    { 0x9E42E053, "friendly_vent_think" },
    { 0xE2C30B2B, "friendly_vent_think2" },
    { 0x42C5FDA6, "friendly_vo_retreat_1" },
    { 0x1CC3833D, "friendly_vo_retreat_2" },
    { 0x0006AD5A, "friendly_waittill_death" },
    { 0x4FF0AEA0, "friendly_wave" },
    { 0xD9B64445, "friendly_wave_active" },
    { 0x6F2405D9, "friendly_wave_masterthread" },
    { 0x856BD915, "friendly_wave_start" },
    { 0xCA38C5C9, "friendly_wave_trig" },
    { 0x5C1B3991, "friendly_wave_trigger" },
    { 0x0924144B, "friendly_waves" },
    { 0x2E0D831B, "friendlyattacked" },
    { 0x32E264FF, "friendlychain" },
    { 0x731691D1, "friendlychain_ondeath" },
    { 0xEC718C07, "friendlychain_ondeaththink" },
    { 0x5EA13706, "friendlychains" },
    { 0x7043F659, "friendlycolor" },
    { 0x43BC17B2, "friendlycolortriggertargetname1" },
    { 0x1DB99D49, "friendlycolortriggertargetname2" },
    { 0x5656AD2A, "friendlycontentoutlines" },
    { 0x365D47D9, "friendlycount" },
    { 0x300D4679, "friendlycounthudelem" },
    { 0xE5F0CD07, "friendlydamage" },
    { 0xB2024721, "friendlydeath_thread" },
    { 0xA027F809, "friendlydogmodel" },
    { 0x1AEA12EF, "friendlyenddialog" },
    { 0x2C095B86, "friendlyexplosivedamage" },
    { 0x98DF9150, "friendlyfire" },
    { 0x3659FA11, "friendlyfire_attacker_not_vehicle_owner" },
    { 0xC277BC34, "friendlyfire_count" },
    { 0xACE2A4E9, "friendlyfire_friendly_kill_points" },
    { 0xF183B43C, "friendlyfire_notify" },
    { 0xF3317F3F, "friendlyfire_override_attacker_entity" },
    { 0x6724D788, "friendlyfire_shield" },
    { 0x48BDAB32, "friendlyfire_shield_callback" },
    { 0x221666D8, "friendlyfirecheck" },
    { 0xA53E798D, "friendlyfirecount" },
    { 0x054B946D, "friendlyfiredelay" },
    { 0x512CD40A, "friendlyfiredelaytime" },
    { 0xB8F294E8, "friendlyfiredisabled" },
    { 0x455EB60A, "friendlyfirerule" },
    { 0x408563A6, "friendlyfx" },
    { 0x89830FE1, "friendlyhacking" },
    { 0xB6CF4A1D, "friendlyhackingmask" },
    { 0xC9C9FEA5, "friendlyhackingsoundid" },
    { 0xC26174E8, "friendlyinfluencers" },
    { 0x7A12FCC7, "friendlylightfxname" },
    { 0x56BBE6DA, "friendlylightfxtag" },
    { 0x21C82C78, "friendlylockingonmask" },
    { 0x3C0CBC75, "friendlyname" },
    { 0x1898D8E5, "friendlynamedist" },
    { 0x9E770708, "friendlyobituarytext" },
    { 0xB276A5FC, "friendlyobjid" },
    { 0xBDBF9FA5, "friendlyreaction" },
    { 0x14E2A1B5, "friendlyreactionanims" },
    { 0x29B97FB5, "friendlyscrambleramount" },
    { 0xC3F2B4FD, "friendlyspawnorg" },
    { 0xC943B8E7, "friendlyspawntrigger" },
    { 0x0A14B986, "friendlyspawnwave" },
    { 0x7ADA2745, "friendlyspawnwave_triggerthink" },
    { 0x60B32EC0, "friendlystartdialog" },
    { 0x376337FB, "friendlystarts" },
    { 0x9EBEEF21, "friendlytargeting" },
    { 0x8B19135D, "friendlytargetingmask" },
    { 0x32420E69, "friendlytargetlocked" },
    { 0xCCFE9340, "friendlytrigger" },
    { 0xFACB92EF, "friendlywave" },
    { 0xF47D295E, "friendlywave_thread" },
    { 0xF72125E9, "friendlywaypoint" },
    { 0xB932F128, "friendname" },
    { 0x56FAA35E, "friendnotfoe" },
    { 0x2DA28080, "friends" },
    { 0xFBC1F184, "friends_count" },
    { 0x33004BBB, "friends_engage_snipers" },
    { 0x5537B1A7, "friends_node_name" },
    { 0x4451404C, "friends_reached_stairs" },
    { 0xC90BD4AB, "friendship" },
    { 0x14B7EFDC, "friendship_fate" },
    { 0xBEF52AE7, "friendstospeak" },
    { 0xEA2B6A8D, "fright" },
    { 0x98201A24, "frinited" },
    { 0xA67778B7, "frisked" },
    { 0xD8D27B87, "frisks" },
    { 0xFE7A4836, "frisky_idle" },
    { 0xBE4602FC, "fritz" },
    { 0x952484EA, "frleaderboard" },
    { 0xBE568AA6, "frm" },
    { 0x90000B9C, "frmae" },
    { 0x2B456D35, "frmo" },
    { 0x725195D4, "fro" },
    { 0xE41D1533, "frog" },
    { 0x609A539F, "frogger" },
    { 0xE963EF5D, "frogger_ai_entries" },
    { 0xF09779C0, "frogger_corpse_control" },
    { 0xE05674D8, "frogger_crosby_movement" },
    { 0x4C6F29B3, "frogger_debris" },
    { 0xE775A4BC, "frogger_debris_audio" },
    { 0x67A23C7A, "frogger_debris_collision_rumble" },
    { 0xC95D5752, "frogger_debris_pain_react" },
    { 0xEF5F8AC2, "frogger_done" },
    { 0xF6AFCA10, "frogger_door_kick_1_func" },
    { 0x4567FB01, "frogger_door_kick_2_func" },
    { 0x32C50940, "frogger_harper_movement" },
    { 0x26944215, "frogger_reconstruct_ents" },
    { 0xB3F9F95D, "frogger_set_dvars" },
    { 0xC3C5AEFE, "frogger_setup_ai" },
    { 0xDC6694C7, "frogger_setup_environment" },
    { 0xF8DEB5BF, "frogger_start_spawning_dyn_ents" },
    { 0x6DDE9B8D, "frogger_started" },
    { 0xDFCB818D, "frogger_street_wave" },
    { 0xE89352F5, "frogger_water_default_height_offset" },
    { 0xCFC56297, "frogger_water_height_offset" },
    { 0x95E779AD, "frogger_water_rumble" },
    { 0xEC7DFE40, "frogger_water_surge" },
    { 0x68044D19, "from" },
    { 0xB25A8016, "from_ai" },
    { 0x68773F14, "from_door" },
    { 0x179D416A, "from_emp" },
    { 0x00FBF19B, "from_ent" },
    { 0x165B0969, "from_front" },
    { 0xD1224E37, "from_gesture_blend_time" },
    { 0x25DB96A2, "from_idle_blend_time" },
    { 0x1D458D21, "from_maze" },
    { 0x893B36F7, "from_notify" },
    { 0x4F6B8B45, "from_position" },
    { 0x0B8ACF59, "from_radiant_count" },
    { 0xAB887F3E, "from_rear" },
    { 0xCE2E4DEB, "from_state" },
    { 0x550AD24B, "from_state_name" },
    { 0x1FB8C9B4, "from_taunt_blend_time" },
    { 0x8D685748, "from_trigger" },
    { 0x9D09B4F0, "from_world" },
    { 0xAFE5A4A6, "fromarmed" },
    { 0xF99F1CCD, "frombehind" },
    { 0xD52B4F6E, "fromcode" },
    { 0xE51193A6, "fromcolor" },
    { 0x5D063DA0, "froment" },
    { 0x1B44784F, "fromexposed" },
    { 0x55B8AE49, "fromnode" },
    { 0x5AA5B937, "fromorigin" },
    { 0xEF3DB0B6, "fromplayer" },
    { 0x10C74FB1, "frompoint" },
    { 0x30346029, "frompos" },
    { 0xFB6AF46E, "fromsquadid" },
    { 0x513F41DC, "fromstate" },
    { 0x00F9B569, "fromweapon" },
    { 0x3EF17522, "frond" },
    { 0xD1AB85EF, "frond_origin" },
    { 0xEFE0A259, "frondmodel" },
    { 0x33E070DA, "frondnum" },
    { 0xF2DF2AED, "fronds" },
    { 0xDEC9CE92, "front" },
    { 0xCD59A97E, "front_angle" },
    { 0xAA224E5E, "front_angle_dif" },
    { 0x76EAEFBE, "front_angle_threshold" },
    { 0x3BFBB061, "front_angles" },
    { 0xEFEB9335, "front_bathroom_chain" },
    { 0x1B5865A6, "front_bathroom_cleared" },
    { 0xC1DFED03, "front_board" },
    { 0xF7407F82, "front_bunker" },
    { 0x3EF845CF, "front_cleared" },
    { 0x58FF76B7, "front_col_left" },
    { 0x6358FEF2, "front_col_right" },
    { 0xA74142DD, "front_death" },
    { 0x491E48E1, "front_dist" },
    { 0xC1499221, "front_door" },
    { 0xC7EB9A42, "front_door_anims" },
    { 0xE35DE3A0, "front_door_battle_chatter" },
    { 0xC17B9FE0, "front_door_cleanup" },
    { 0x1034EBBE, "front_door_clip" },
    { 0x892BE984, "front_door_dialog" },
    { 0x9402DA20, "front_door_enemies_1" },
    { 0x72BB7715, "front_door_enemies_1_ai" },
    { 0xFB287345, "front_door_enemies_cleared" },
    { 0xD064897E, "front_door_freebie" },
    { 0xE260E3C8, "front_door_inside" },
    { 0x88ADC89B, "front_door_main" },
    { 0xCC699451, "front_doorsmen_cleared" },
    { 0xDBE61596, "front_face" },
    { 0xDC35D7A7, "front_flip_type" },
    { 0x5E839305, "front_gate_clip" },
    { 0x73B1235B, "front_gate_close_wait" },
    { 0x76459688, "front_guard" },
    { 0x01DC7A86, "front_gun_active" },
    { 0xA94699B8, "front_gunner" },
    { 0xCB8843B0, "front_gunner_struct" },
    { 0xCDA2CF20, "front_guy_offset" },
    { 0x2A52E707, "front_guy_origin" },
    { 0x3638D0D2, "front_hit_fletcher_kamikaze_chunk_1" },
    { 0x7B47C87B, "front_hit_fletcher_kamikaze_gun_1" },
    { 0x09405940, "front_hit_fletcher_kamikaze_gun_2" },
    { 0xC22E97AD, "front_jeep" },
    { 0x6FD2893D, "front_line_struct" },
    { 0xEC0B0B54, "front_line_volume" },
    { 0xCE086221, "front_max_turn" },
    { 0xB1F0E6A7, "front_melee" },
    { 0xBDC18340, "front_mg_room_cleared" },
    { 0xEFBDE008, "front_offset" },
    { 0x29EF088C, "front_piece_damage_level" },
    { 0x5478E979, "front_point" },
    { 0x116FD707, "front_ref_point" },
    { 0x636FA77A, "front_slam" },
    { 0x1EA80DC1, "front_sounds" },
    { 0x933D7419, "front_structs" },
    { 0x419517FF, "front_turret" },
    { 0x637B8AA2, "front_wrestle_type" },
    { 0x57B69611, "frontal" },
    { 0x8F60B5BF, "frontangoffset" },
    { 0x3F5713AD, "frontanim" },
    { 0xA0A1A60F, "frontarmor" },
    { 0xC9B92E3B, "frontarmorhudelem" },
    { 0xD562785E, "frontc4location" },
    { 0xFEFB754E, "frontdist" },
    { 0xB69A8BFC, "frontdlightfx" },
    { 0x1742072E, "frontdlightfxhandle" },
    { 0xD8B068F9, "frontend" },
    { 0x63CCA8A4, "frontend_amb" },
    { 0xFC5FCBDB, "frontend_anim" },
    { 0x1A44434B, "frontend_art" },
    { 0x90A9A1C6, "frontend_data_glove_on" },
    { 0x9755FA56, "frontend_dec20_message" },
    { 0x1AFC5085, "frontend_delete_ospreys" },
    { 0x16B57B49, "frontend_do_save" },
    { 0x6DAC9927, "frontend_flag_init" },
    { 0xE3C15B3E, "frontend_fx" },
    { 0xB4362824, "frontend_get_hub_number" },
    { 0x4C8CB90E, "frontend_init_common" },
    { 0xE2A2A25D, "frontend_init_shaders" },
    { 0x1786F687, "frontend_just_finished_rts" },
    { 0x2C4E1171, "frontend_menu" },
    { 0x97EB190A, "frontend_menu_init" },
    { 0xCB8AA8C9, "frontend_platform_skip_button_check" },
    { 0x9F6014A0, "frontend_player_connect" },
    { 0x9BE547F7, "frontend_precache" },
    { 0x0E1EA8F8, "frontend_refresh_scene" },
    { 0x95AB532E, "frontend_reset_mixers" },
    { 0x15D0EC45, "frontend_resume" },
    { 0x91A32E2C, "frontend_rts_level_respond" },
    { 0x7B33B1A4, "frontend_run_osprey" },
    { 0xA8406DD7, "frontend_run_ospreys" },
    { 0x96363F4E, "frontend_run_scene" },
    { 0x3F2AEDAC, "frontend_setup_devgui" },
    { 0x6925F1EB, "frontend_sf_a" },
    { 0xF71E82B0, "frontend_sf_b" },
    { 0x1D20FD19, "frontend_sf_c" },
    { 0x06E8D1DF, "frontend_should_use_vtol" },
    { 0xA9EF8D42, "frontend_so_precache" },
    { 0x42FB8FDC, "frontend_so_run" },
    { 0xEAF75F74, "frontend_top_menu_start" },
    { 0x51CBDAE8, "frontend_util" },
    { 0x7C1139BE, "frontend_watch_devgui" },
    { 0xCBDC0951, "frontend_watch_resume" },
    { 0xC221530E, "frontend_watch_scene_skip" },
    { 0xDBE3C341, "frontendclientconnected" },
    { 0x506A52A0, "frontendmodel" },
    { 0x2BCB465B, "frontgoal" },
    { 0x8BEC6092, "frontish" },
    { 0x9C635284, "frontline" },
    { 0xB2A4E3F8, "frontline_axis" },
    { 0xB1B82730, "frontline_radius_expand" },
    { 0x2C6482D7, "frontlocal" },
    { 0x7848E7FD, "frontorgoffset" },
    { 0xD460A1A4, "frontright" },
    { 0x05772AE4, "frontscanner" },
    { 0xB6EF767E, "frontworld" },
    { 0x20D88031, "frost" },
    { 0xDD3739BC, "frost_duration" },
    { 0xCD078D65, "frost_filter_duration" },
    { 0x6189A34B, "frost_filter_index" },
    { 0xB1CF2950, "frost_filter_off" },
    { 0x823AEDCA, "frost_filter_on" },
    { 0x74D25151, "frost_filter_over_time" },
    { 0x1D03226C, "frost_overlay" },
    { 0x175481B2, "frost_overlay_off" },
    { 0xE7016784, "frost_overlay_on" },
    { 0x58678647, "frosted_glass" },
    { 0xB0327322, "frosty" },
    { 0x2DA60E13, "frotatetime" },
    { 0x1F027D08, "frothing" },
    { 0x1774B073, "frozen" },
    { 0xE0C68997, "frozen_zombie_gib" },
    { 0x6799822A, "frozen_zombie_shatter" },
    { 0x239829E5, "frozenmomentchanged" },
    { 0xD11ACDFE, "frozenmomentstyle" },
    { 0x30DB6E95, "fruit" },
    { 0x39B4AAD8, "frustrating" },
    { 0x88C68852, "frustration" },
    { 0xA8057F5C, "frustrationlevel" },
    { 0x7CE63EDD, "frustrum" },
    { 0xC624FA72, "fry" },
    { 0x06AC6218, "fs_trigs" },
    { 0xC1786CEC, "fsetspeed" },
    { 0x48AEB37E, "fsize" },
    { 0x0FAB5133, "fss" },
    { 0x1F712337, "ft" },
    { 0x49F4FD13, "ft_guy" },
    { 0x4ABD83A6, "ftime" },
    { 0x2DAD6589, "ftl" },
    { 0xFB4C8439, "ftl_lantern_charged" },
    { 0xDC2CE24E, "ftl_lantern_increment" },
    { 0x084FA30D, "ftn_chatter" },
    { 0xC660FBAB, "ftn_walker1_setup" },
    { 0x1A477ECC, "ftn_walker2_setup" },
    { 0xDD0C9BB5, "ftn_walker3_setup" },
    { 0xB638C746, "ftn_walker4_setup" },
    { 0x6993541E, "ftn_walker_early_setup" },
    { 0xA1F7BDD7, "ftr" },
    { 0x7BF5436E, "fts" },
    { 0xE3EB59CA, "ftw" },
    { 0xF96EA8CE, "fu" },
    { 0x8EF43661, "fubar" },
    { 0x2D33C370, "fuck" },
    { 0xFE53D106, "fuck_the_hinds_are_back" },
    { 0xE0F1CF03, "fucked" },
    { 0x64D906E9, "fucken" },
    { 0x8D1E6A65, "fucker" },
    { 0x3A510174, "fuckers" },
    { 0x91C4DBDD, "fuckin" },
    { 0x8B8576E8, "fucking" },
    { 0xEA0D24DB, "fucks" },
    { 0x2EC8689F, "fuction" },
    { 0x0A578626, "fuctions" },
    { 0x6F342392, "fudge" },
    { 0xC7A7335C, "fudge_factor" },
    { 0x80997CC9, "fuel" },
    { 0xBF7B666A, "fuel_area_dialog" },
    { 0x2FF96F44, "fuel_depot_begin" },
    { 0xD0D94375, "fuel_depot_dialog" },
    { 0x69A4AD8A, "fuel_depot_goal_nodes" },
    { 0x7C4F1986, "fuel_depot_infantry_evasion" },
    { 0x6C63C68D, "fuel_depot_objectives" },
    { 0x9DF0AD20, "fuel_depot_sampans_arrive" },
    { 0x2B71DC3A, "fuel_depot_truck" },
    { 0xD4663671, "fuel_explosion" },
    { 0xC8EDF126, "fuel_go" },
    { 0x10CBA9FB, "fuel_hose" },
    { 0xD70EF67E, "fuel_hose_start" },
    { 0xFC34C13C, "fuel_tank" },
    { 0x2705F74C, "fuel_tank_damage_trigs" },
    { 0x2EE72708, "fuel_trail" },
    { 0x5DF5D0F2, "fuel_truck_props" },
    { 0x3BACF26C, "fuel_truck_rpgs" },
    { 0x59072E49, "fuel_truck_runner_logic" },
    { 0x25A088C1, "fuel_truck_runners" },
    { 0x2DD5F9A7, "fuel_truck_zpu_damage_notify" },
    { 0x8389426E, "fuel_truck_zpus" },
    { 0xBC201618, "fuel_trucks_backup_trigger" },
    { 0x20BD4610, "fueler" },
    { 0xB6865C7F, "fueling" },
    { 0x3033BFD3, "fuellife" },
    { 0x52D24C7B, "fueltank_blowup" },
    { 0x714804A4, "fueltanks" },
    { 0x7B1E1EF1, "fugassi" },
    { 0x35F0F510, "fugazis" },
    { 0x8B01A052, "fuge" },
    { 0x30D59423, "fugitives" },
    { 0xBDB08201, "fuhrer" },
    { 0xE16CBBB9, "fuk" },
    { 0x5158CDFC, "fulani" },
    { 0x58DCDA3E, "full" },
    { 0xE39ED38B, "full_alias" },
    { 0x3A5EF9C7, "full_ammo_move_hud" },
    { 0x4AF5F7F3, "full_ammo_on_hud" },
    { 0x02ED4A69, "full_ammo_pickedup" },
    { 0xC1B9B2AE, "full_ammo_powerup" },
    { 0xD9F63CA2, "full_charge_shotlevel" },
    { 0x0F7AC602, "full_count" },
    { 0x03CB463A, "full_damage" },
    { 0xC81E81B5, "full_damage_amount" },
    { 0xAA56C019, "full_damage_dist" },
    { 0x57F58154, "full_diff_for_anim" },
    { 0x39BCBEE4, "full_drone_list" },
    { 0x7A65AB26, "full_effects_pitch" },
    { 0x6FAFA279, "full_movement_type" },
    { 0x7375613A, "full_period" },
    { 0x402CD7E8, "full_playthrough_set_up_charge" },
    { 0xC0CCF0CC, "full_power_wait_time" },
    { 0x8C6E5919, "full_screen" },
    { 0x520B5901, "full_screen_static_done" },
    { 0xAF05BACD, "fullahead" },
    { 0x2B7B4818, "fullahead_amb" },
    { 0x3EABCFFF, "fullahead_anim" },
    { 0x0FDECABF, "fullahead_art" },
    { 0x4DC104F9, "fullahead_drones" },
    { 0xC45BDC3A, "fullahead_fx" },
    { 0x222104CF, "fullahead_p2_dogsled" },
    { 0x130B13B2, "fullahead_p2_nazibase" },
    { 0xFBE38E12, "fullahead_p2_shiparrival" },
    { 0x2C60ABF1, "fullahead_p2_shipcargo" },
    { 0x764003EA, "fullahead_p2_shipcinema" },
    { 0x5C6F631B, "fullahead_p2_shipfirefight" },
    { 0xA5D2F0E0, "fullahead_p2_shipmast" },
    { 0xD2BEC7FA, "fullahead_p2_wrapup" },
    { 0x785EDBF4, "fullahead_util" },
    { 0xB42DDCB6, "fullalpha" },
    { 0x1088B589, "fullalphatime" },
    { 0xFF73E6C3, "fullblend" },
    { 0xE19B65CA, "fullbody" },
    { 0x26A21513, "fullbodyexplosion" },
    { 0xF5F7C955, "fullclipnomisses" },
    { 0xA346DE34, "fulldelta" },
    { 0xC7EE66E5, "fullforward" },
    { 0xDDCBFA19, "fullgametypename" },
    { 0x0E8F9E40, "fullhealth" },
    { 0x81F3D07B, "fullhealthtime" },
    { 0xACA71A83, "fullname" },
    { 0x3440567C, "fullpath_file" },
    { 0x9B661C6C, "fullproof" },
    { 0xC0BE0914, "fullrank" },
    { 0x9EC21E71, "fullrun" },
    { 0x2A4B0022, "fullscreen" },
    { 0x006C56BB, "fullscreen_black_active" },
    { 0x13743D73, "fullscreen_cin_hud" },
    { 0x9EB5D027, "fullscreen_fx" },
    { 0xAC8AA904, "fullscreen_hud_destroy_after_id" },
    { 0x6FCF4C7F, "fullscreen_shader_fade" },
    { 0x0F04F433, "fullscreen_static" },
    { 0xEE362255, "fullscreen_trans" },
    { 0xC18B5F75, "fullscreen_trans_in" },
    { 0x58101F54, "fullscreen_trans_out" },
    { 0xE8F1051E, "fullsprint" },
    { 0x68F4F909, "fullsprintanim" },
    { 0x366A63A5, "fulltraceresults" },
    { 0xB8AFC4AB, "fully" },
    { 0xE2367AE6, "fully_charged" },
    { 0x19D99308, "fullyaquired" },
    { 0x16B4FC7B, "fumes" },
    { 0x53742AF4, "fun" },
    { 0x86365A77, "func" },
    { 0xB904E29C, "func1" },
    { 0x2B0C51D7, "func2" },
    { 0x7FE1E6B4, "func_action" },
    { 0xB2881135, "func_activate" },
    { 0xEFA4059D, "func_after_cleared" },
    { 0x47769843, "func_after_death" },
    { 0xBFA18D59, "func_after_flag" },
    { 0x6C63427E, "func_ai_custom" },
    { 0x226CED3C, "func_ai_make_aggressive" },
    { 0x61BB1ED0, "func_audio" },
    { 0x261413D0, "func_behavior" },
    { 0x7F0C0B63, "func_brake" },
    { 0xA5825607, "func_button_check" },
    { 0x3758B6EB, "func_callback" },
    { 0xC443362C, "func_can_revive" },
    { 0xCE4B52A2, "func_check" },
    { 0xCAD00DF3, "func_clientfield_register" },
    { 0x363E5058, "func_clientfield_set" },
    { 0x74F6FA4E, "func_clone_plant_respawn" },
    { 0x5089F3D5, "func_code_callback" },
    { 0x6E5A57A9, "func_condition" },
    { 0xE1B31CC1, "func_conditions_for_round" },
    { 0x4AC8ED5C, "func_count_added" },
    { 0x88011A2F, "func_countdown" },
    { 0x52D9B7B7, "func_custom" },
    { 0xC3CB9D57, "func_custom_cleanup_check" },
    { 0xD109CB41, "func_custom_placeable_mine_round_replenish" },
    { 0x171FDD35, "func_custom_sentinel_drone_cleanup_check" },
    { 0xE4B1C209, "func_damage" },
    { 0xBCC4BD64, "func_damage_override" },
    { 0xBC6061C3, "func_debug" },
    { 0x07B6CF62, "func_drop_when_players_own" },
    { 0x28636CE2, "func_during_bink" },
    { 0xD31627FA, "func_end_nag" },
    { 0x5EFFB4D6, "func_ended" },
    { 0x482283B0, "func_filter" },
    { 0x9BD2DB80, "func_filter_save" },
    { 0x5E184351, "func_for_link_list" },
    { 0xC47D548A, "func_for_unlink_list" },
    { 0x0187A0A9, "func_get_best_target" },
    { 0xC6B0F99D, "func_get_delay_between_rounds" },
    { 0x647EB78B, "func_get_locations" },
    { 0x92130BC6, "func_get_spawners" },
    { 0xE5823333, "func_get_zombie_spawn_delay" },
    { 0xE27B0049, "func_getbestmissileturrettarget" },
    { 0x83931A4E, "func_give_player_perk" },
    { 0x8C7AC545, "func_grab_powerup" },
    { 0x9704020B, "func_group" },
    { 0xCD88DA75, "func_gump" },
    { 0x190F4052, "func_handler" },
    { 0xB2B9CFA9, "func_host_migration" },
    { 0xE29222B4, "func_humangun_check" },
    { 0x45438924, "func_init" },
    { 0x0861B087, "func_init_thread" },
    { 0xB7EEBEDB, "func_interrupt" },
    { 0x7FD59383, "func_is_reviving" },
    { 0x9086FC29, "func_jetpack_live_to_deck" },
    { 0x760E0F7A, "func_jetpack_run_to_cover" },
    { 0xE406DC3D, "func_jump_pad_pulse_override" },
    { 0x330AF417, "func_key" },
    { 0x0661E70C, "func_logic" },
    { 0xCA283C6A, "func_magicbox_update_prompt_use_override" },
    { 0xD5D77812, "func_magicbox_weapon_spawned" },
    { 0x72607801, "func_mod_damage_override" },
    { 0x4B996B2F, "func_name" },
    { 0x7D89E07B, "func_no_delete" },
    { 0x0DF0DAF3, "func_on_ai_group_cleared" },
    { 0x90CFAB16, "func_on_death" },
    { 0xFE90CE5B, "func_on_notify" },
    { 0xEE894C4E, "func_on_state_change" },
    { 0xF3F06F1E, "func_on_trig" },
    { 0xDB395C04, "func_on_trigger" },
    { 0x6DC11B1C, "func_outro_enemy_attacker" },
    { 0x8C223920, "func_outro_warp_to_deck_struct" },
    { 0x904F03E2, "func_override" },
    { 0x712B41D4, "func_override_wallbuy_prompt" },
    { 0xCD7EDCAB, "func_per_player_msg" },
    { 0x6130433A, "func_perk_fx_think" },
    { 0x685B2E5D, "func_perk_machine_power_override" },
    { 0x5EEBEAEE, "func_perk_machine_setup" },
    { 0x0E45C117, "func_perk_machine_thread" },
    { 0xBC180F43, "func_player_damage" },
    { 0x1E5C4A4D, "func_pointer" },
    { 0x1C4FA09E, "func_postinit" },
    { 0xF2045D09, "func_precache" },
    { 0x4BF4B85B, "func_preinit" },
    { 0x616077D9, "func_prompt_and_visibility" },
    { 0x57B17860, "func_ptr" },
    { 0x921FE062, "func_rappel" },
    { 0x5C201C5D, "func_raygun_mark3_damage_response" },
    { 0xB0D729FF, "func_respawn_enemies" },
    { 0x00AFE58C, "func_restore" },
    { 0xA4DA442E, "func_rise_fx" },
    { 0x06A678A9, "func_save" },
    { 0xED44063F, "func_save_enemy_data" },
    { 0x30F8CF59, "func_setup" },
    { 0xD1B42977, "func_should_always_drop" },
    { 0x8EBC0F8C, "func_should_drop_carpenter" },
    { 0xDC32FD56, "func_should_drop_fire_sale" },
    { 0xCB167381, "func_should_drop_meat" },
    { 0xC4C29FA9, "func_should_drop_minigun" },
    { 0x03BFA697, "func_should_drop_with_regular_powerups" },
    { 0x45887568, "func_should_never_drop" },
    { 0xBA8DFC5D, "func_skipto_cleanup" },
    { 0x275F3EFE, "func_slot_watcher_override" },
    { 0xDD22FD62, "func_sort" },
    { 0x1D010B6F, "func_spawn" },
    { 0x2D065612, "func_spawn_civilian_run_to_volume" },
    { 0x9D970064, "func_spawn_execution_villagers" },
    { 0x92D2A93E, "func_spawn_pdf_execution_grounds" },
    { 0x760A8ECB, "func_spawn_stables_exit_door_blocker" },
    { 0xA9723F67, "func_spawn_stables_exit_door_guys" },
    { 0x9FB3B059, "func_spawn_stables_pdf" },
    { 0xC466DD7C, "func_spawn_truck_driver" },
    { 0x86A009AF, "func_spawn_truck_gunner" },
    { 0xF3EE0E2B, "func_spawn_veh_truck_courtyard" },
    { 0xB9CA58F3, "func_spawn_villager_run_to_volume" },
    { 0xF7669C82, "func_start" },
    { 0x7DCA197C, "func_take_player_perk" },
    { 0x11654BBA, "func_test" },
    { 0xE513B143, "func_unitrigger_logic" },
    { 0xF313500D, "func_update" },
    { 0x266E4883, "func_update_msg" },
    { 0x544DF8E5, "func_when_done" },
    { 0x75BBC9C9, "func_ziptie_guard" },
    { 0xED95A142, "func_zombies_find_valid_exit_locations" },
    { 0x52CBF32F, "funcion" },
    { 0x420BD703, "funciton" },
    { 0x0FD5180A, "funcname" },
    { 0x7187EB45, "funcnames" },
    { 0x85A871AE, "funcs" },
    { 0xC79C0DA1, "funct" },
    { 0x54623DA6, "functinos" },
    { 0x23DAE961, "functio" },
    { 0xAEDDD25D, "function" },
    { 0x4BFF1520, "function_done" },
    { 0xC6507E78, "function_stack" },
    { 0x39BFE3D5, "function_stack_caller_waits_for_turn" },
    { 0x82F394E3, "function_stack_proc" },
    { 0xD1278BE0, "function_thread" },
    { 0x90B7101A, "function_to_call_on_hack" },
    { 0x8430DEA3, "functionaility" },
    { 0xED40AC76, "functional" },
    { 0x4C6D7DC6, "functionality" },
    { 0x2B16D535, "functionality_override" },
    { 0xF21B6460, "functionheld" },
    { 0xE76DAFA4, "functionname" },
    { 0x078B47D7, "functionnames" },
    { 0x7D26EA74, "functionparam" },
    { 0xF7E5D479, "functionparamcount" },
    { 0x3C45D411, "functionptr" },
    { 0xD203129C, "functions" },
    { 0xC0BD9B08, "functios" },
    { 0x32E97E62, "functon" },
    { 0x9ADF94BE, "functor" },
    { 0x1BBF1D76, "fundamental" },
    { 0xE6BCCA7B, "fundamentally" },
    { 0x195E7F73, "funds" },
    { 0x305699EC, "funky" },
    { 0xC3B5DD07, "funny" },
    { 0xF5CD604A, "funny_trigger" },
    { 0x93A38A5A, "funtion" },
    { 0xCC119870, "furiesnearplayer" },
    { 0x40671470, "furious" },
    { 0x68082AB0, "furious_feet_fate" },
    { 0x85902FC3, "furiousevents" },
    { 0xD434D204, "furiousinfo" },
    { 0x5598E222, "furiouslevel" },
    { 0x1DDF7FD5, "furiously" },
    { 0x1D7731A3, "furnace" },
    { 0xD6C38950, "furnace_burst" },
    { 0x7144DDC9, "furniture" },
    { 0x138AEAC0, "furniture_clear_vignette" },
    { 0x4163838D, "furniture_gun_note_a" },
    { 0x83571F80, "furniture_gun_note_d" },
    { 0x9F4A63BA, "furniture_movers_walk" },
    { 0x96057537, "furniture_note_2_a_1" },
    { 0x23FE05FC, "furniture_note_2_a_2" },
    { 0x7B06915A, "furniture_note_2_d_1" },
    { 0x550416F1, "furniture_note_2_d_2" },
    { 0x4CD9CF0E, "furniture_note_3_a_1" },
    { 0x26D754A5, "furniture_note_3_a_2" },
    { 0xAB15DE13, "furniture_note_3_d_1" },
    { 0x390E6ED8, "furniture_note_3_d_2" },
    { 0xB8D091FA, "furniturepushsound" },
    { 0xBFA60169, "further" },
    { 0x1D08489F, "furthering" },
    { 0x158CFC94, "furthest" },
    { 0xDFF8004C, "furthest_player" },
    { 0x6C54F3F3, "furthestcomparefunc" },
    { 0xCB7E10D5, "furthestcomparefunc2d" },
    { 0x20616BA2, "furthestpointalongtowardsgoal" },
    { 0xA162A2AE, "furthestpointtowardsgoalclear" },
    { 0x3686EA09, "fury" },
    { 0x70D48C24, "fury_bamf_appear_dist_horizontal" },
    { 0x79AA1DAD, "fury_bamf_appear_dist_offset" },
    { 0x4AD52AFA, "fury_bamf_appear_dist_vertical" },
    { 0xF0386588, "fury_bamf_attack_damage_max" },
    { 0x4ADE4416, "fury_bamf_attack_damage_min" },
    { 0xD5210126, "fury_bamf_attack_radius" },
    { 0x7B608189, "fury_bamf_cooldown_max" },
    { 0x9655AD37, "fury_bamf_cooldown_min" },
    { 0xFC64DEC6, "fury_bamf_fov" },
    { 0xFCC85427, "fury_bamf_global_delay_msec" },
    { 0xEE728D58, "fury_bamf_land_clientfield" },
    { 0xDF53E3DF, "fury_bamf_land_fx" },
    { 0x320B127E, "fury_bamf_melee_damage_max" },
    { 0xC4933420, "fury_bamf_melee_damage_min" },
    { 0x4707614D, "fury_bamf_melee_dist_max" },
    { 0xC41C1F43, "fury_bamf_melee_dist_min" },
    { 0x7C25D494, "fury_bamf_melee_dist_min_after_juke" },
    { 0xB06B1B66, "fury_bamf_melee_distance_bb" },
    { 0x97B222D4, "fury_bamf_melee_nt" },
    { 0x2E4C8A21, "fury_bamf_melee_range" },
    { 0x180C5215, "fury_bamf_nt_explode" },
    { 0x3C8B1AF1, "fury_bamf_nt_land" },
    { 0x5A26E12E, "fury_bamf_nt_start" },
    { 0x2114644E, "fury_bamf_nt_stop" },
    { 0x2C47024C, "fury_bamf_velocity" },
    { 0x1DADFCF2, "fury_body_smoke_effect" },
    { 0xA476DE5A, "fury_breath_effect" },
    { 0x0DE352DD, "fury_damage_clientfield" },
    { 0xA1D74A29, "fury_damage_effect" },
    { 0xDEFC7B40, "fury_death_clientfield" },
    { 0x3D2F0D11, "fury_death_dissolved_nt" },
    { 0xA326F94A, "fury_death_model_swap" },
    { 0x12A20DB2, "fury_death_model_swap_effect" },
    { 0x2B7C3050, "fury_death_start_dissolve_nt" },
    { 0x4C559A6E, "fury_favor_forward_juke_fov" },
    { 0x5BAD2D79, "fury_footstep_amb_effect" },
    { 0x5D869C9E, "fury_furious_chance" },
    { 0x03CA17CB, "fury_furious_global_delay_max_msec" },
    { 0x65945B29, "fury_furious_global_delay_min_msec" },
    { 0x738309E5, "fury_furious_level_step" },
    { 0x42080E80, "fury_furious_level_threshold" },
    { 0xA5E22DB1, "fury_furious_max_ai" },
    { 0xEE20A0A1, "fury_furious_mode_clientfield" },
    { 0x556A1A03, "fury_health_multiplier_upto_round_20" },
    { 0x108A34BA, "fury_health_multiplier_upto_round_50" },
    { 0xDAEE0C02, "fury_health_multiplier_upto_round_after50" },
    { 0xA2E4E3E2, "fury_juke_chance" },
    { 0xB6CE02BD, "fury_juke_clientfield" },
    { 0xB8FF0F22, "fury_juke_cooldown_max" },
    { 0x8E6D03DC, "fury_juke_cooldown_min" },
    { 0x6BD82262, "fury_juke_global_delay_msec" },
    { 0xB0052DE8, "fury_juke_long" },
    { 0x051D5EEB, "fury_juke_long_dist" },
    { 0xE6F4ADF3, "fury_juke_max_dist" },
    { 0xFCFBD580, "fury_juke_med" },
    { 0xD1ED9DD3, "fury_juke_med_dist" },
    { 0x130194A8, "fury_juke_short" },
    { 0xE982C7AB, "fury_juke_short_dist" },
    { 0xEE0EF3FA, "fury_melee_dist_sq" },
    { 0x1F0547A0, "fury_movement_variants" },
    { 0xA9A2DDAE, "fury_radius" },
    { 0x3D6B1185, "fury_taunt_global_delay_msec" },
    { 0x5B13592D, "fury_too_close_to_bamf_dist" },
    { 0x53DED6BA, "fury_too_close_to_juke_dist" },
    { 0x714C0827, "fury_zigzag_max" },
    { 0x16A62999, "fury_zigzag_min" },
    { 0xB158E871, "fus" },
    { 0xD10F71BE, "fuse" },
    { 0x3FAB3924, "fuse_array" },
    { 0x2A9FC271, "fuse_attached" },
    { 0xFB415FD0, "fuse_box" },
    { 0x46BD92C1, "fuse_box_trigger" },
    { 0x5B815EC7, "fuse_delivered" },
    { 0x5855791B, "fuse_first_frame" },
    { 0x4DB27483, "fuse_found" },
    { 0xCCC40FCF, "fuse_jnt" },
    { 0x21F284AF, "fuse_lost" },
    { 0xDB5AB28A, "fuse_placed" },
    { 0x054226ED, "fuse_play_anim" },
    { 0x8A717DE2, "fuse_play_slomo" },
    { 0x6370145A, "fuse_reset" },
    { 0x130F7EDA, "fuse_time" },
    { 0xDDEF5055, "fusebox" },
    { 0x028993C8, "fusebox_angles" },
    { 0xAFEE6CE7, "fuselage" },
    { 0x20ED23B1, "fuselage_blocker_fx" },
    { 0x7BA77622, "fuselage_breached" },
    { 0x232020FF, "fuselage_vo_support" },
    { 0xF2F84185, "fusemodel" },
    { 0x9FAB2C71, "fusetime" },
    { 0x32D0CBA3, "futher" },
    { 0x1ACB3F5A, "futile" },
    { 0x0E675528, "future" },
    { 0x98907A56, "futurepos" },
    { 0xD239A57D, "futuristic" },
    { 0xFE36FBB0, "futz" },
    { 0x85CABDCA, "fuzz" },
    { 0xD36C2E65, "fv" },
    { 0xD299DBB6, "fva" },
    { 0xDBA9B08D, "fvec" },
    { 0xF7C650EF, "fvec_player" },
    { 0x7D0BCC10, "fvec_victim" },
    { 0x560D0108, "fviewkick" },
    { 0xAD69B3FC, "fw" },
    { 0xA24A5370, "fwd" },
    { 0xA0784E1E, "fwd_back" },
    { 0x0F0A19C4, "fwd_dir" },
    { 0xC033F148, "fwd_dot" },
    { 0x3DF6DF8A, "fwd_dot2d" },
    { 0xF4F8FDC8, "fwd_left" },
    { 0x29326553, "fwd_max" },
    { 0xAC1DA75D, "fwd_min" },
    { 0x34BAAA68, "fwd_radio_mast" },
    { 0xF49F149A, "fwd_radio_tower" },
    { 0x5D2201D3, "fwd_radio_tower_start" },
    { 0x70BAC817, "fwd_right" },
    { 0xB2DF131E, "fwd_wire_tower" },
    { 0x28B80295, "fwd_wire_tower_b" },
    { 0x21F9E40C, "fwd_wire_tower_b_start" },
    { 0xFF88C3F0, "fwd_wire_tower_hits_roof" },
    { 0xB1C0F000, "fwd_yaw" },
    { 0xB3936710, "fwdangles" },
    { 0xFAD66805, "fwddot" },
    { 0x21FDDFC5, "fweight" },
    { 0x5753664B, "fx" },
    { 0x3D1FE718, "fx1" },
    { 0xAF275653, "fx2" },
    { 0xE5A7812D, "fx2d" },
    { 0x8924DBEA, "fx3" },
    { 0x1703DF46, "fx_aat_blast_furnace_burn" },
    { 0xB1903FD4, "fx_aat_blast_furnace_explode" },
    { 0x6486D6CB, "fx_aat_dead_wire_zap" },
    { 0x2C2F1496, "fx_aat_turned_eyes" },
    { 0xC4261081, "fx_aat_turned_torso" },
    { 0x463AA3FD, "fx_activation_electric_loop" },
    { 0x3776F8A3, "fx_ai_slow_vortex" },
    { 0xAE132C05, "fx_airstrike_afterburner" },
    { 0x4EC5D5FF, "fx_airstrike_bomb" },
    { 0x876C2613, "fx_airstrike_bomb_explosion" },
    { 0x5CCF9EC5, "fx_airstrike_bomb_run" },
    { 0x8BD25BFF, "fx_airstrike_contrail" },
    { 0x7E3D06AA, "fx_alias" },
    { 0x194D81C2, "fx_ang" },
    { 0x0E293072, "fx_angles" },
    { 0x3A80EFF4, "fx_ango_blood_outro" },
    { 0x8A61F681, "fx_anim" },
    { 0x7CA17F0B, "fx_anim_barrel_woods" },
    { 0x1A68FEBB, "fx_anim_barrels" },
    { 0xF3FF7748, "fx_anim_hangar_door" },
    { 0xACB04753, "fx_anim_level_init" },
    { 0xC7F5DEA8, "fx_anims" },
    { 0x13B3E699, "fx_array" },
    { 0xE4C45CBB, "fx_array_id" },
    { 0x992B2801, "fx_artifact_pulse_thread" },
    { 0xB3BED27E, "fx_audio_setup" },
    { 0xD9FB910D, "fx_base" },
    { 0x4AC9950F, "fx_beam" },
    { 0x2FF1D7E2, "fx_beam_stop" },
    { 0x8EA160F4, "fx_blizzard" },
    { 0x484C3786, "fx_bomb_explosion" },
    { 0x7CE938D0, "fx_bottle_cycling" },
    { 0xE92AB7C3, "fx_bottom" },
    { 0x2A6F602F, "fx_character" },
    { 0x8DBC2EB4, "fx_chunks" },
    { 0xE9557F8E, "fx_cleanup" },
    { 0xA6F76AD0, "fx_colorid" },
    { 0x1E8ABDA5, "fx_com_1" },
    { 0x3D48C982, "fx_contact_explosion" },
    { 0xBD919440, "fx_crash_effects" },
    { 0xDFBB9F2B, "fx_crashed_heli" },
    { 0x655E7C26, "fx_cuav_afterburner" },
    { 0xFE4F074C, "fx_cuav_burner" },
    { 0x603C5DA2, "fx_damage_effects" },
    { 0xA9B83C10, "fx_death" },
    { 0xD55B5A43, "fx_dept" },
    { 0xCEAB090B, "fx_dir" },
    { 0x9D038674, "fx_disconnect_watch" },
    { 0x83E43C86, "fx_dog_eye" },
    { 0x316C2861, "fx_dog_trail" },
    { 0x52E73129, "fx_dog_trail_sound" },
    { 0x865C83AC, "fx_dog_trail_type" },
    { 0x0D75099E, "fx_done" },
    { 0x5220B6DF, "fx_door_ambient" },
    { 0x64110235, "fx_door_closed" },
    { 0xDC35F90D, "fx_door_open" },
    { 0xEBD2CC12, "fx_drawn" },
    { 0x97274486, "fx_dust" },
    { 0xEB0606D0, "fx_elevator_fall" },
    { 0xB4CA9D6D, "fx_ent" },
    { 0x88AF6023, "fx_ent_failsafe" },
    { 0xF4D8D56C, "fx_ents" },
    { 0xC82C8B62, "fx_exclude_default_explosion" },
    { 0x0063B5EC, "fx_exclude_default_eye_glow" },
    { 0xEA555295, "fx_exclude_edge_fog" },
    { 0x22575944, "fx_exclude_footsteps" },
    { 0xD73AD8C8, "fx_exclude_tesla_head_light" },
    { 0x039F457A, "fx_exp_factory_window_7_volume" },
    { 0xEB01A23F, "fx_exp_glass_hotel_entrance_volume" },
    { 0xDADBD939, "fx_exp_glass_hotel_garage_entrance_volume" },
    { 0x0E2CEA37, "fx_exp_glass_hotel_garage_exit_volume" },
    { 0x64B902BB, "fx_exp_glass_market_entrance_trigger" },
    { 0x68873FCD, "fx_exp_glass_market_exit_trigger" },
    { 0x162CD253, "fx_exp_model_triggered" },
    { 0x2578297F, "fx_eye_glow" },
    { 0x34297332, "fx_field" },
    { 0x7DDDBB94, "fx_field_old" },
    { 0x3944F342, "fx_fire_player_md" },
    { 0x955472F1, "fx_fire_player_sm" },
    { 0x0E4AA86E, "fx_fire_player_torso" },
    { 0x2703338F, "fx_fire_player_torso_loop" },
    { 0xA9971231, "fx_fire_zombie_md" },
    { 0x80920B58, "fx_firepoint" },
    { 0xD63DA851, "fx_flame_lg" },
    { 0xFDDBBA22, "fx_flame_sm" },
    { 0x1326D2A6, "fx_flare" },
    { 0x58582B91, "fx_for_power_path" },
    { 0xCC5512CD, "fx_forward" },
    { 0x9B73020D, "fx_glow" },
    { 0x9D239F7F, "fx_green" },
    { 0xB22E1894, "fx_handle" },
    { 0x910FB8F1, "fx_handle_deep" },
    { 0xCF5664B2, "fx_handle_hand_le" },
    { 0x61D6D635, "fx_handle_hand_rt" },
    { 0x2431E251, "fx_handle_ripple" },
    { 0x38FF66BC, "fx_handle_underwater" },
    { 0x390F2D83, "fx_handle_wake" },
    { 0x56208401, "fx_handlers" },
    { 0x655E6107, "fx_handles" },
    { 0x18A69435, "fx_heli_chaff" },
    { 0xF44F90F1, "fx_heli_dust" },
    { 0x586D93E7, "fx_heli_flare" },
    { 0xCFD5B95B, "fx_heli_warning" },
    { 0xDB89B2AA, "fx_heli_water" },
    { 0x34B7CAF4, "fx_highlightedent" },
    { 0x41B1E044, "fx_hind_warning" },
    { 0x2242649D, "fx_id" },
    { 0x6CD8E6B5, "fx_id_location" },
    { 0xA6055148, "fx_impact" },
    { 0x5F9CE018, "fx_init" },
    { 0x01D3AE45, "fx_interval" },
    { 0x858DAF24, "fx_intro" },
    { 0x4471C5A2, "fx_jet_trail" },
    { 0x6906AC53, "fx_kickup" },
    { 0xFFA09F1E, "fx_l" },
    { 0xCDF50C68, "fx_lake_blast" },
    { 0x5F73BB9B, "fx_large_explosion" },
    { 0x1E9F7F9D, "fx_laser_cutter_on" },
    { 0x32AF11D5, "fx_lc_bolt" },
    { 0xF68DCEE2, "fx_lc_shock" },
    { 0x649A4C8F, "fx_lc_shock_eyes" },
    { 0xF858AECC, "fx_lc_shock_nonfatal" },
    { 0x1222517D, "fx_lc_shock_secondary" },
    { 0xE2F51105, "fx_legs" },
    { 0xCEF3B032, "fx_light" },
    { 0x24C9E8A6, "fx_light_fall" },
    { 0xC9B3071C, "fx_lights_out" },
    { 0xB6C43E1D, "fx_lights_reset" },
    { 0x4359F0D7, "fx_linker" },
    { 0xC2ACBFDA, "fx_list" },
    { 0x181A8676, "fx_list_count" },
    { 0x6AA3CFC7, "fx_local_heli_rain" },
    { 0xEAC5095B, "fx_management" },
    { 0x2CD9DCC8, "fx_marker" },
    { 0x998D9A41, "fx_missile_stop" },
    { 0xA5C1510D, "fx_model" },
    { 0x69D4348C, "fx_models" },
    { 0x1AF96132, "fx_mon_chamber_fog_dropdown" },
    { 0x9B457796, "fx_mon_chamber_wall_glow" },
    { 0x9C8BBF36, "fx_morals_vtol_crash" },
    { 0x9B24EBA9, "fx_multinode" },
    { 0x4528DA6B, "fx_name" },
    { 0xC3E42A10, "fx_napalm_bomb" },
    { 0x4EDB75CE, "fx_napalm_marker" },
    { 0x08BC7C7A, "fx_node" },
    { 0xD6EA3859, "fx_null" },
    { 0xA000C33E, "fx_num" },
    { 0x23B1AACD, "fx_obj" },
    { 0xE9BBAC1B, "fx_object" },
    { 0x0474C093, "fx_octobomb" },
    { 0xCD151D3D, "fx_octobomb_spores_leg_le" },
    { 0x07C893FB, "fx_octobomb_spores_leg_ri" },
    { 0x7974FF00, "fx_octobomb_spores_spine" },
    { 0x39B71BAE, "fx_octobomb_tentacle_hit" },
    { 0xD5E6A521, "fx_on" },
    { 0xCDBF090A, "fx_on_piece_timeout" },
    { 0xF12D5A25, "fx_on_pieces" },
    { 0xA610B0D8, "fx_org" },
    { 0xF8CFB9CD, "fx_orig" },
    { 0x0989508C, "fx_origin" },
    { 0xA109950F, "fx_origins" },
    { 0xF205A5F1, "fx_overrides" },
    { 0xD54705B1, "fx_per_frame" },
    { 0x6B3A8684, "fx_piece" },
    { 0x4A7455E7, "fx_play_slinters" },
    { 0xEBE96181, "fx_player" },
    { 0x3D3AEEDC, "fx_point" },
    { 0x11F51A1F, "fx_points" },
    { 0xEB550668, "fx_pos" },
    { 0xC8BAABC7, "fx_position" },
    { 0x3B888C8E, "fx_prespawn_time" },
    { 0xD98AE1CA, "fx_quad_trail" },
    { 0x4BA593F0, "fx_r" },
    { 0x3BFD5383, "fx_red" },
    { 0xFD7B1766, "fx_rotating" },
    { 0xF588A045, "fx_shared" },
    { 0xF3476353, "fx_slide_vehicles" },
    { 0x591FB640, "fx_slow_vortex" },
    { 0x21370447, "fx_small_explosion" },
    { 0x94592698, "fx_smokegrenade_single" },
    { 0xD8B61354, "fx_snow_wall_hvy" },
    { 0x221ACF50, "fx_soct_dmg_1_console_spark" },
    { 0x7081A324, "fx_soct_dmg_1_smk_vent" },
    { 0x1CDCA867, "fx_soct_dmg_2_console_spark" },
    { 0x43C0A8B5, "fx_soct_dmg_2_smk_vent" },
    { 0x4E640B9A, "fx_soct_dmg_3_console_spark" },
    { 0x5BB31F62, "fx_soct_dmg_3_smk_vent" },
    { 0xC9725BBD, "fx_spark" },
    { 0xAB8A23EF, "fx_spawn_delay" },
    { 0x8063FFCF, "fx_speed" },
    { 0xBE0D4B67, "fx_spine" },
    { 0x9EE6A794, "fx_spit" },
    { 0x8FF1295B, "fx_splash" },
    { 0xD623BF76, "fx_spot" },
    { 0x23E0FF07, "fx_spotlight_controls" },
    { 0xF2633AE3, "fx_spyplane_afterburner" },
    { 0xC06EADDB, "fx_spyplane_burner" },
    { 0x581A0EF4, "fx_sr71_glint" },
    { 0x756EF29C, "fx_sr71_trail" },
    { 0x28B9DF62, "fx_standard_flash" },
    { 0x311BED6A, "fx_start_time" },
    { 0xDB3CAE85, "fx_state" },
    { 0xE5CE5260, "fx_state_change" },
    { 0xE7FFABC5, "fx_struct" },
    { 0x2A4C5154, "fx_structs" },
    { 0x88E290A8, "fx_sub_explosion" },
    { 0x23D947F2, "fx_surface_names" },
    { 0x464322D3, "fx_tabun_0" },
    { 0x2040A86A, "fx_tabun_1" },
    { 0xFA3E2E01, "fx_tabun_2" },
    { 0xD43BB398, "fx_tabun_3" },
    { 0xBF366281, "fx_tabun_radius0" },
    { 0x9933E818, "fx_tabun_radius1" },
    { 0x0B3B5753, "fx_tabun_radius2" },
    { 0xE538DCEA, "fx_tabun_radius3" },
    { 0x65C43E09, "fx_tabun_single" },
    { 0xF95E1D2E, "fx_tag" },
    { 0xAA3B0015, "fx_tank_blast" },
    { 0x61B3B156, "fx_tear_down_monitor" },
    { 0x760E2C76, "fx_thing" },
    { 0x0E18161A, "fx_think" },
    { 0x6C26BC7D, "fx_time_offset" },
    { 0xD95F104E, "fx_to_play" },
    { 0x4EEFDEFF, "fx_top" },
    { 0xE450BA24, "fx_tower_light_exp" },
    { 0x316E81ED, "fx_trace" },
    { 0x0A864E0B, "fx_treedelete" },
    { 0x1C0C62F1, "fx_treefall" },
    { 0xAC385010, "fx_treefall_sm" },
    { 0x5A32704B, "fx_trophy_radius_indicator" },
    { 0x806BE764, "fx_turret" },
    { 0xACE08030, "fx_u2_damage_trail" },
    { 0x04459CA9, "fx_u2_explode" },
    { 0x5A14C357, "fx_uav_burner" },
    { 0xF72C9C5F, "fx_uav_damage_trail" },
    { 0xA542DDBE, "fx_uav_lights" },
    { 0xCA04BBCE, "fx_vehicle_explosion" },
    { 0x819E620E, "fx_volume_cobrastreets" },
    { 0xA98AD517, "fx_volume_intro" },
    { 0x311D3BE3, "fx_volume_plazatown" },
    { 0x64368E1E, "fx_volume_smoketown" },
    { 0x9E69EA83, "fx_vomit_projectile" },
    { 0x0BFFD7C5, "fx_vtol_1" },
    { 0xEA3558F9, "fx_vtol_1_pieces" },
    { 0x3202522E, "fx_vtol_2" },
    { 0x099C9049, "fx_vtol_2_parts" },
    { 0xEB372264, "fx_vtol_2_pieces" },
    { 0x5804CC97, "fx_vtol_3" },
    { 0x047D3B7C, "fx_vtol_3_parts" },
    { 0x3A476D53, "fx_vtol_3_pieces" },
    { 0x4DF373B8, "fx_vtol_4" },
    { 0x986D47D6, "fx_vtol_4_pieces" },
    { 0x2D646055, "fx_vtol_debris_1" },
    { 0x5366DABE, "fx_vtol_debris_2" },
    { 0x79695527, "fx_vtol_debris_3" },
    { 0x2382B008, "fx_wait_set" },
    { 0xEC27D8D2, "fx_wake_lvt_churn" },
    { 0x2C31E24E, "fx_watch_z_value" },
    { 0x7FCB88C0, "fx_widows_wine_wrap" },
    { 0x2792EEAC, "fx_wires" },
    { 0x7A570010, "fx_x_offset" },
    { 0x51430957, "fx_y_offset" },
    { 0x62AC264B, "fx_yaw_offset" },
    { 0xFC7591EE, "fx_z_offset" },
    { 0xBF06FB70, "fx_zombie_tesla_electric_bolt" },
    { 0x322320D5, "fx_zombie_tesla_ug_elec_bolt" },
    { 0x3F05B5AC, "fxangle" },
    { 0x747B60AF, "fxangles" },
    { 0xBE27AB3C, "fxanim" },
    { 0xB2077B7B, "fxanim_3_loop" },
    { 0x8102457D, "fxanim_5_tag" },
    { 0xE308F6A3, "fxanim_aerial_vehicles" },
    { 0x8053D876, "fxanim_afghan_chopper_crash_anim" },
    { 0xD59FF25C, "fxanim_afghan_chopper_crash_blades_anim" },
    { 0xD3E944FB, "fxanim_afghan_chopper_crash_rocks_anim" },
    { 0x4C476153, "fxanim_afghan_shrubs_time_lapse_fast_anim" },
    { 0x697F566B, "fxanim_afghan_shrubs_time_lapse_norm_anim" },
    { 0xCD5052FD, "fxanim_afghan_shrubs_time_lapse_ramp_anim" },
    { 0x5E32CC9E, "fxanim_align" },
    { 0x9E26A500, "fxanim_alley_power_pole_start" },
    { 0xD702873B, "fxanim_angola_barge_aft_debris_anim" },
    { 0xD874920C, "fxanim_angola_barge_cables_anim" },
    { 0xF410D9B5, "fxanim_angola_barge_crane_hit_anim" },
    { 0x747E111A, "fxanim_angola_barge_crane_idle_anim" },
    { 0x18212582, "fxanim_angola_barge_crane_rear_fall_anim" },
    { 0x0AA8DD0D, "fxanim_angola_barge_crane_rear_fall_idle_anim" },
    { 0x0ECF3FFC, "fxanim_angola_barge_crane_rear_sink_anim" },
    { 0x066A27FD, "fxanim_angola_barge_crane_side_fall_anim" },
    { 0x9500474B, "fxanim_angola_barge_gaz66_02_anim" },
    { 0x83313784, "fxanim_angola_barge_gaz66_anim" },
    { 0x2905B895, "fxanim_angola_barge_side_debris_anim" },
    { 0xB6023C2A, "fxanim_angola_barge_side_panel_01_anim" },
    { 0x68A03BDF, "fxanim_angola_barge_side_panel_02_anim" },
    { 0xAFC7875C, "fxanim_angola_barge_side_panel_03_anim" },
    { 0x78A50BA3, "fxanim_angola_barge_tarp_rpg_anim" },
    { 0x08728E57, "fxanim_angola_barge_wheelhouse_anim" },
    { 0x6365E504, "fxanim_angola_barge_wheelhouse_mod" },
    { 0x97FA4CE8, "fxanim_angola_boat_death_med_01_anim" },
    { 0x85A706A1, "fxanim_angola_boat_death_med_02_anim" },
    { 0xD57E4F86, "fxanim_angola_boat_death_med_03_anim" },
    { 0x479909EF, "fxanim_angola_boat_death_med_04_anim" },
    { 0x9BC1337A, "fxanim_angola_boat_death_sml_01_anim" },
    { 0xAB1E016F, "fxanim_angola_boat_death_sml_02_anim" },
    { 0xAA0D816C, "fxanim_angola_boat_death_sml_03_anim" },
    { 0xE92BFE21, "fxanim_angola_boat_death_sml_04_anim" },
    { 0xCDE7FEB3, "fxanim_angola_boat_jump_01_anim" },
    { 0xA94C16FE, "fxanim_angola_boat_jump_02_anim" },
    { 0xE934D402, "fxanim_angola_buffel_tip_anim" },
    { 0x7AE9E591, "fxanim_angola_buffel_tip_dead_anim" },
    { 0xF82B9A38, "fxanim_angola_eland_explode_anim" },
    { 0xF31D88D3, "fxanim_angola_eland_hero_shoot_anim" },
    { 0x4BF77032, "fxanim_angola_eland_shoot_anim" },
    { 0xA4C43646, "fxanim_angola_heli_gear_anim" },
    { 0x8B23AD25, "fxanim_angola_hind_crash_veh_anim" },
    { 0x2595886E, "fxanim_angola_waterfall_truck_anim" },
    { 0x3154E271, "fxanim_apc_wall_divider_start" },
    { 0x9C75A91E, "fxanim_aquarium_explosion" },
    { 0xF13ED830, "fxanim_aquarium_pillar_start" },
    { 0xF830A31F, "fxanim_archway_collapse_start" },
    { 0x3351FFD4, "fxanim_archway_debug" },
    { 0x7187D039, "fxanim_archway_start" },
    { 0xFA152CF2, "fxanim_balcony_block_start" },
    { 0x4E630390, "fxanim_balcony_collapse_start" },
    { 0xA17349FC, "fxanim_balcony_courtyard_start" },
    { 0x720821CD, "fxanim_barn_explode_01_start" },
    { 0xD164D076, "fxanim_barn_explode_02_start" },
    { 0x0F072360, "fxanim_barrel_kick" },
    { 0x5211C160, "fxanim_beach_grass_logic" },
    { 0x86E95F41, "fxanim_billboard_pillar_top03_start" },
    { 0xCE545344, "fxanim_black_elevator_debris_start" },
    { 0xAF6C090E, "fxanim_black_f38_bridge_crash_anim" },
    { 0xBC307371, "fxanim_blanket_start" },
    { 0x04698D44, "fxanim_bldg_convoy_block_start" },
    { 0x00AB4D32, "fxanim_bldg_rubble_start" },
    { 0xEE3EB887, "fxanim_break_wall_crumble_start" },
    { 0x53D69ABD, "fxanim_bridge_drop_start" },
    { 0xDADE3EC7, "fxanim_bridge_explode_start" },
    { 0x5E6A71AF, "fxanim_bridges" },
    { 0xF2BF75AE, "fxanim_bus_dam_1st_hit_start" },
    { 0x58E04082, "fxanim_bus_dam_2nd_hit_start" },
    { 0x7C2AFED6, "fxanim_bus_dam_break_balc_start" },
    { 0x32F96512, "fxanim_bus_dam_break_wall_start" },
    { 0x0FC14305, "fxanim_bus_dam_wedge_balc_start" },
    { 0x732CF181, "fxanim_bus_dam_wedge_wall_start" },
    { 0x99EA62C0, "fxanim_car_corner_crash_start" },
    { 0x41D3B69D, "fxanim_catwalk_collapse_start" },
    { 0x35CD954B, "fxanim_catwalk_end_collapse_start" },
    { 0xDFEF86B7, "fxanim_catwalk_vtol_start" },
    { 0xE31C41BB, "fxanim_ceiling_01_start" },
    { 0x42B39578, "fxanim_ceiling_02_start" },
    { 0x4B4ECCB5, "fxanim_ceiling_03_start" },
    { 0xB10C823F, "fxanim_ceiling_collapse_start" },
    { 0x95A8D5F9, "fxanim_chains" },
    { 0xEF09EC39, "fxanim_change_on" },
    { 0x1A6007BC, "fxanim_circle_bar_start" },
    { 0xF908385E, "fxanim_cliff_collapse_start" },
    { 0x4AAFF853, "fxanim_closet_bomb_start" },
    { 0xE37A6E62, "fxanim_club_dj_lasers_start" },
    { 0xA1CF0E74, "fxanim_club_laser_1_fall_start" },
    { 0xA6E961D5, "fxanim_club_laser_2_fall_start" },
    { 0xACD3B143, "fxanim_club_laser_4_fall_start" },
    { 0xD7BD5277, "fxanim_club_top_lasers_start" },
    { 0xCE320BA6, "fxanim_column_explode_start" },
    { 0x278B805D, "fxanim_construct_front_door" },
    { 0xADA916C0, "fxanim_construct_hangar" },
    { 0x8A972A51, "fxanim_construct_interior" },
    { 0xC3C8ED34, "fxanim_crow_log_start" },
    { 0x334C3DEF, "fxanim_crow_up_start" },
    { 0xEEB79D1D, "fxanim_damage_trigger_shoot" },
    { 0x537E8462, "fxanim_debris" },
    { 0x8844344E, "fxanim_debris_02_start" },
    { 0x663DA067, "fxanim_debris_fx" },
    { 0x24826145, "fxanim_debris_layer_1_start" },
    { 0x0F29008E, "fxanim_debris_layer_2_start" },
    { 0x6B000C4B, "fxanim_debris_layer_3_start" },
    { 0xE00BB571, "fxanim_deck_vtol_1_start" },
    { 0x10E25A3A, "fxanim_deck_vtol_2_start" },
    { 0xD2FE2F67, "fxanim_deck_vtol_3_start" },
    { 0xFC902FF8, "fxanim_deck_vtol_4_start" },
    { 0xAB9FAC05, "fxanim_deconstruct" },
    { 0x9122A670, "fxanim_deconstruction_with_existence_check" },
    { 0x86DBEB90, "fxanim_deconstructions" },
    { 0x00F667B8, "fxanim_deconstructions_for_mason_side1" },
    { 0x72FDD6F3, "fxanim_deconstructions_for_mason_side2" },
    { 0xEA447E49, "fxanim_deconstructions_for_menendez_side" },
    { 0x25319D6E, "fxanim_defend_room_01_start" },
    { 0x662F1125, "fxanim_defend_room_02_start" },
    { 0x9587C5E9, "fxanim_defend_room_door_01_start" },
    { 0x6BB74112, "fxanim_defend_room_door_02_start" },
    { 0x77AC1BB2, "fxanim_defend_room_monitors_01_start" },
    { 0x4733D009, "fxanim_defend_room_monitors_02_start" },
    { 0x6791BC6C, "fxanim_defend_room_monitors_03_start" },
    { 0x7CA763F2, "fxanim_delete" },
    { 0x870A21E5, "fxanim_delete_intro" },
    { 0xB9FB71C9, "fxanim_destruct_until_flag" },
    { 0xFF77091F, "fxanim_destruction_control" },
    { 0xBC806A41, "fxanim_dome_explode_start" },
    { 0xD0E19EF6, "fxanim_drone_blockade_start" },
    { 0xEFBEC4CD, "fxanim_drone_chunks_start" },
    { 0x928B4262, "fxanim_drone_cover_start" },
    { 0x06D75647, "fxanim_drone_scaffold_01_start" },
    { 0x30820F14, "fxanim_drone_scaffold_02_start" },
    { 0x681226D1, "fxanim_drone_scaffold_03_start" },
    { 0xC0BCA09E, "fxanim_drone_scaffold_04_start" },
    { 0x0FF7B01B, "fxanim_drone_scaffold_05_start" },
    { 0x287FA79C, "fxanim_drone_skyscraper_crash_start" },
    { 0x1CE4C4C6, "fxanim_drones" },
    { 0x00AE8B66, "fxanim_dustdevils" },
    { 0x4B36DEE4, "fxanim_elevator_asd_dmg_start" },
    { 0xCDA3DA12, "fxanim_ent" },
    { 0x83BEB13A, "fxanim_entities" },
    { 0x92A63F6C, "fxanim_exploding_column" },
    { 0xBB8D28D4, "fxanim_f35_blast_chunks_start" },
    { 0xA9386A40, "fxanim_f35_hover" },
    { 0x3834FE46, "fxanim_f38_launch_fail_start" },
    { 0xEF6C8B8C, "fxanim_falling_ceiling" },
    { 0xC9BFBCB6, "fxanim_falling_rocks_start" },
    { 0xE9D40D9E, "fxanim_falling_rocks_start_kickoff" },
    { 0x16195567, "fxanim_fence_break_start" },
    { 0xAEA4A918, "fxanim_flags" },
    { 0x83F373D6, "fxanim_flank_start" },
    { 0xFA47C4D0, "fxanim_flash_car_crash_anim" },
    { 0xCC8DA9AC, "fxanim_flash_lighttower_mod" },
    { 0x7631C8C3, "fxanim_flash_rocket_mod" },
    { 0xB35558C2, "fxanim_floor_collapse_start" },
    { 0x0C648F46, "fxanim_fountain_start" },
    { 0xF59EB184, "fxanim_freeway_chunks_fall_start" },
    { 0xC25400F5, "fxanim_freeway_collapse_start" },
    { 0xA3100135, "fxanim_fx" },
    { 0xF2E03311, "fxanim_fx_1" },
    { 0x9CE216FC, "fxanim_fx_1_tag" },
    { 0x18E2AD7A, "fxanim_fx_2" },
    { 0xBD514DE3, "fxanim_fx_2_tag" },
    { 0x3EE527E3, "fxanim_fx_3" },
    { 0x2B9C3596, "fxanim_fx_3_tag" },
    { 0x64E7A24C, "fxanim_fx_4" },
    { 0x77B450B5, "fxanim_fx_4_tag" },
    { 0x8AEA1CB5, "fxanim_fx_5" },
    { 0x2C709698, "fxanim_fx_5_tag" },
    { 0x10CF929C, "fxanim_garage_roof_start" },
    { 0x38586F8B, "fxanim_gate_crash_start" },
    { 0xA582694C, "fxanim_gazebo_start" },
    { 0x0F5C4120, "fxanim_gp_cattails_scaled8_idle_anim" },
    { 0xC0A03CCC, "fxanim_gp_cattails_scaled8_walkthrough_anim" },
    { 0xF5792530, "fxanim_gp_parachute_jetpack01_anim" },
    { 0x76F37A69, "fxanim_gp_parachute_jetpack02_anim" },
    { 0xFB996B6E, "fxanim_gp_parachute_jetpack03_anim" },
    { 0x22545EBB, "fxanim_grass" },
    { 0xFFA05F1A, "fxanim_grass_delete_until_needed" },
    { 0x34E5F855, "fxanim_grass_enemy_logic" },
    { 0x54863DD7, "fxanim_grass_heli_land_start" },
    { 0xAE17C580, "fxanim_grass_logic" },
    { 0x9B1C2628, "fxanim_grass_restore" },
    { 0xEA26E2DF, "fxanim_grass_stop_animating" },
    { 0x6B897934, "fxanim_hall_blinds_start" },
    { 0xA2FF75B4, "fxanim_heli_explode_start" },
    { 0xB165D625, "fxanim_helo_arch_start" },
    { 0x7C93654B, "fxanim_hide" },
    { 0xD6EFCCE1, "fxanim_hind_crash_start" },
    { 0xDF6D6C70, "fxanim_horse_wall_break_start" },
    { 0x94D5DA01, "fxanim_hostage_hut_start" },
    { 0x920EAEC5, "fxanim_hut_explode_start" },
    { 0xBFDC99DA, "fxanim_hut_explode_watertower_start" },
    { 0xCA03B8BD, "fxanim_init" },
    { 0x0183C636, "fxanim_is_hidden" },
    { 0x67CD4BF5, "fxanim_is_model" },
    { 0xB985FDF6, "fxanim_jetpack_vtol_explode_1_start" },
    { 0x5A294F4D, "fxanim_jetpack_vtol_explode_2_start" },
    { 0xC5805010, "fxanim_jetpack_vtol_explode_3_start" },
    { 0x36C9500D, "fxanim_la_cockpit_panels_loop_anim" },
    { 0x9157F4FF, "fxanim_la_cop_car_shootup_anim" },
    { 0xA41A4625, "fxanim_la_cop_car_shootup_explode_anim" },
    { 0xC5376C0B, "fxanim_la_cougar_crawl_exit_anim" },
    { 0x3828DB73, "fxanim_la_cougar_interior_anim" },
    { 0x9607E7AF, "fxanim_la_cougar_interior_static_mod" },
    { 0x4EA4C9E6, "fxanim_la_cougar_wire_anim" },
    { 0x75B262C6, "fxanim_la_drone_ambient_01_anim" },
    { 0xBA5A803B, "fxanim_la_drone_ambient_02_anim" },
    { 0x97DADC05, "fxanim_la_drone_crash_tower_anim" },
    { 0x0FE5BC95, "fxanim_la_freeway_drone_anim" },
    { 0xAE4F4F9F, "fxanim_la_freeway_fa38_anim" },
    { 0xD438E19D, "fxanim_la_sniper_bus_anim" },
    { 0x40FD2485, "fxanim_la_sniper_trains_02_anim" },
    { 0xB2EABAAA, "fxanim_la_sniper_trains_anim" },
    { 0x4A519FA0, "fxanim_laundromat_wall_start" },
    { 0xC77461C1, "fxanim_library_start" },
    { 0xA021FB50, "fxanim_lift" },
    { 0xFA37DB53, "fxanim_lightning_tree_start" },
    { 0x5DF75D1B, "fxanim_lion_statue_01_start" },
    { 0xE1B59458, "fxanim_lion_statue_02_start" },
    { 0xE9F09E45, "fxanim_mall_explosion" },
    { 0x776DD5A5, "fxanim_market_bus_crash_start" },
    { 0x1FFC92A4, "fxanim_market_bus_shelf_01_start" },
    { 0x20BA7C57, "fxanim_market_bus_shelf_02_start" },
    { 0xEB43E76A, "fxanim_market_bus_shelf_03_start" },
    { 0x871A9265, "fxanim_market_bus_shelf_04_start" },
    { 0x9FE98E90, "fxanim_market_canopy_delete" },
    { 0x3677FF45, "fxanim_market_car_crash_start" },
    { 0xB826A7D4, "fxanim_max_anims" },
    { 0x5EA8D2F1, "fxanim_metal_storm_enter01_start" },
    { 0x8F7F77BA, "fxanim_metal_storm_enter02_start" },
    { 0x36774B77, "fxanim_misc" },
    { 0x6D63E552, "fxanim_model" },
    { 0xE63BD8D6, "fxanim_mon_01_01_cliffintro_anim" },
    { 0xC8F41C49, "fxanim_mon_01_01_cliffswing1_anim" },
    { 0x07EBCCF0, "fxanim_mon_01_01_cliffswing1_b_anim" },
    { 0xA36A22AC, "fxanim_mon_01_01_cliffswing1_idle_anim" },
    { 0xC7366810, "fxanim_mon_01_01_cliffswing2_anim" },
    { 0x8A34BF15, "fxanim_mon_01_01_cliffswing2_b_anim" },
    { 0x8FBB7B6B, "fxanim_mon_01_01_cliffswing2_idle_anim" },
    { 0xE97D3843, "fxanim_mon_01_01_cliffswing3_anim" },
    { 0x20789C72, "fxanim_mon_01_01_cliffswing3_b_anim" },
    { 0xB0FF4F56, "fxanim_mon_01_01_cliffswing3_idle_anim" },
    { 0x124C95C2, "fxanim_mon_01_01_cliffswing4_anim" },
    { 0x40C760F7, "fxanim_mon_01_01_cliffswing4_b_anim" },
    { 0x961F114D, "fxanim_mon_01_01_cliffswing4_idle_anim" },
    { 0x1ECA1C4D, "fxanim_mon_01_01_cliffswing5_anim" },
    { 0x9E08139C, "fxanim_mon_01_01_cliffswing5_b_anim" },
    { 0x09FC6EE8, "fxanim_mon_01_01_cliffswing5_idle_anim" },
    { 0xF4C02554, "fxanim_mon_01_01_cliffswing6_anim" },
    { 0xE319D651, "fxanim_mon_01_01_cliffswing6_b_anim" },
    { 0x5E7CE1B7, "fxanim_mon_01_01_cliffswing6_idle_anim" },
    { 0xFD6DE58D, "fxanim_monsoon_heli_explode_anim" },
    { 0xDFF9B0D2, "fxanim_mortar_rocks_start" },
    { 0xC07DD54B, "fxanim_mov_warehouse_ceiling_fall_anim" },
    { 0xDB87FD0D, "fxanim_mov_warehouse_column_dam_anim" },
    { 0xDF6DA132, "fxanim_msg" },
    { 0x56FBD351, "fxanim_mudslide_debris_start" },
    { 0xA1F3D2B5, "fxanim_nic_blanket_anim" },
    { 0x448F25B5, "fxanim_nic_truck_crash_anim" },
    { 0x4C070562, "fxanim_nic_truck_stop_anim" },
    { 0xE323534A, "fxanim_not_cheap" },
    { 0x43055752, "fxanim_overlook_building_start" },
    { 0x5753CE5F, "fxanim_pak_bus_dam_enter_bus_anim" },
    { 0x5B9C901D, "fxanim_pak_bus_dam_exit_bus_anim" },
    { 0x0D3973B3, "fxanim_pak_bus_dam_idle_bus_anim" },
    { 0x53FE51D6, "fxanim_pak_car_corner_veh_crash_anim" },
    { 0xFBFC12F1, "fxanim_pak_car_corner_veh_loop_anim" },
    { 0xFA7F68E7, "fxanim_pak_catwalk01_start" },
    { 0x7676C360, "fxanim_pak_market_bus_crash_bus_anim" },
    { 0x0495C960, "fxanim_pak_market_bus_crash_car_anim" },
    { 0x486D4478, "fxanim_pak_market_car_crash_car_anim" },
    { 0x99D79D40, "fxanim_pak_market_car_crash_idle_anim" },
    { 0x84167FBF, "fxanim_palm_grp01_start" },
    { 0xF03F5C8C, "fxanim_palm_grp02_start" },
    { 0x4A5C68A0, "fxanim_panama_laundromat_apc_anim" },
    { 0xF75C3F19, "fxanim_panama_private_jet_anim" },
    { 0x842A5630, "fxanim_panama_truck_flag_anim" },
    { 0x2FECC2A3, "fxanim_parent" },
    { 0x8ED767C5, "fxanim_pipes_block_start" },
    { 0x58C4D124, "fxanim_pipes_break_burst_0" },
    { 0x4605525C, "fxanim_pipes_break_burst_01_start" },
    { 0x0A516C0F, "fxanim_pipes_break_burst_02_start" },
    { 0x6C9BADE6, "fxanim_pipes_break_loop_0" },
    { 0xF997350E, "fxanim_pipes_break_loop_01_start" },
    { 0x0EF095C5, "fxanim_pipes_break_loop_02_start" },
    { 0xA92737D0, "fxanim_pipes_fire_start" },
    { 0xA6079022, "fxanim_play_fx" },
    { 0x09B57B27, "fxanim_play_fx_think" },
    { 0x3DDED238, "fxanim_police_car_f35_start" },
    { 0x553906D5, "fxanim_police_car_flip_start" },
    { 0x20AA1774, "fxanim_porch_explode_start" },
    { 0x4BFCC019, "fxanim_private_jet_start" },
    { 0x3AB80BFA, "fxanim_radar_tower_start" },
    { 0xC1C9CF43, "fxanim_rappel_rope_start" },
    { 0xBAD40FC2, "fxanim_rat_alley01_start" },
    { 0xB1CDD83B, "fxanim_reconstruct" },
    { 0x82410326, "fxanim_river_debris_start" },
    { 0xC2D2E3C2, "fxanim_road_sign_snipe_01_start" },
    { 0x230D0959, "fxanim_road_sign_snipe_02_start" },
    { 0x46EE17BC, "fxanim_road_sign_snipe_03_start" },
    { 0x5E18F943, "fxanim_road_sign_snipe_04_start" },
    { 0x440F50AA, "fxanim_rock_arch_collapse_start" },
    { 0xB4E78E5E, "fxanim_rock_arch_start" },
    { 0x0853B601, "fxanim_rock_index" },
    { 0x22ED2573, "fxanim_rock_peak_explosion_start" },
    { 0xEADCE0E2, "fxanim_rock_slide" },
    { 0x449E17AB, "fxanim_rock_slide_start" },
    { 0x62B69970, "fxanim_rock_tags" },
    { 0x480178C7, "fxanim_scaffold_collapse_02_start" },
    { 0x27573CE0, "fxanim_scaffold_collapse_start" },
    { 0x741067ED, "fxanim_scene" },
    { 0xD859DD39, "fxanim_scene_1" },
    { 0x9261A89E, "fxanim_scene_1_loop" },
    { 0xFE5C57A2, "fxanim_scene_2" },
    { 0x32795E0B, "fxanim_scene_2_loop" },
    { 0x245ED20B, "fxanim_scene_3" },
    { 0x1B687A60, "fxanim_scene_3_loop" },
    { 0xF9EE0996, "fxanim_scene_anim_keys" },
    { 0x8FB69CEC, "fxanim_scenes" },
    { 0xB16A97ED, "fxanim_seagull01_delete" },
    { 0x91C71617, "fxanim_server_arm_loop_start" },
    { 0x73CD34D6, "fxanim_set_to_detonate" },
    { 0x0D5E63D8, "fxanim_shrine_lft_mudslide_start" },
    { 0x52968FFC, "fxanim_shrine_lft_start" },
    { 0x1BA414B5, "fxanim_silo_end_collapse_start" },
    { 0xCBFC1672, "fxanim_skyscraper02_impact_start" },
    { 0xE9F99967, "fxanim_skyscraper02_start" },
    { 0x241600D3, "fxanim_smokestack_collapse_01_start" },
    { 0xE8A578D0, "fxanim_smokestack_collapse_02_start" },
    { 0x71E2F051, "fxanim_smokestack_collapse_start" },
    { 0x1EB2D68C, "fxanim_sniper_drone_crash_start" },
    { 0x4AC88D69, "fxanim_sniper_freeway_start" },
    { 0xADFD14CD, "fxanim_solar_system_01_start" },
    { 0x0D59C376, "fxanim_solar_system_02_start" },
    { 0xFC0C6093, "fxanim_solar_system_03_start" },
    { 0x6752A40C, "fxanim_solar_system_04_start" },
    { 0x8C807DA9, "fxanim_solar_system_05_start" },
    { 0x4A441CD2, "fxanim_solar_system_06_start" },
    { 0xFB29C73F, "fxanim_solar_system_07_start" },
    { 0x9BFDDF38, "fxanim_solar_system_08_start" },
    { 0x62103A04, "fxanim_speed" },
    { 0xF4CC82B7, "fxanim_speeds" },
    { 0xB95DC9FF, "fxanim_spire_collapse_start" },
    { 0xBF0B46BB, "fxanim_stairwell_ceiling_start" },
    { 0x67C65119, "fxanim_start" },
    { 0x6E5DC48F, "fxanim_statue" },
    { 0xA827F204, "fxanim_statue_02_crumble_start" },
    { 0x71655D6B, "fxanim_statue_crumble_start" },
    { 0xAF192401, "fxanim_statue_end" },
    { 0xD7EE7B3C, "fxanim_statue_entrance" },
    { 0xA23A7D9F, "fxanim_statue_lrg_crumble_start" },
    { 0x49FF9920, "fxanim_store_bomb_01_start" },
    { 0x73D11365, "fxanim_tag" },
    { 0x7DC0332A, "fxanim_tarp_tree_start" },
    { 0xED283A56, "fxanim_temple_door_start" },
    { 0x63CA6E4B, "fxanim_test" },
    { 0x95AA25ED, "fxanim_think" },
    { 0xA39078E5, "fxanim_tower_collapse_start" },
    { 0xAF3BDB2B, "fxanim_tree" },
    { 0x46A2FDA1, "fxanim_tree_d_blood_fall01_start" },
    { 0x221CA76A, "fxanim_tree_d_blood_fall02_start" },
    { 0x48EF4C93, "fxanim_tree_fall_rt_start" },
    { 0x6602FC17, "fxanim_tree_palm_start" },
    { 0x09DA6C06, "fxanim_tree_trigger" },
    { 0xD8A9FCA1, "fxanim_trough_break_1_start" },
    { 0xB423A66A, "fxanim_trough_break_2_start" },
    { 0xCBF2E937, "fxanim_truck_fence_start" },
    { 0x6B89C802, "fxanim_village_tower_start" },
    { 0x2279C28B, "fxanim_vines_start" },
    { 0x2F863A1C, "fxanim_vtol1_crash_start" },
    { 0xB2E9A0B3, "fxanim_vtol2_crash_start" },
    { 0xBBE2F66B, "fxanim_vtol_door" },
    { 0xCF1EDC4C, "fxanim_vtol_int_debris" },
    { 0xBAFE8029, "fxanim_vtol_int_hit_start" },
    { 0x1E303B74, "fxanim_vtol_int_open_start" },
    { 0x8BF3B1C7, "fxanim_vtol_interior" },
    { 0x11319DB4, "fxanim_wait" },
    { 0x49F35957, "fxanim_wait_max" },
    { 0x2EFE2DA9, "fxanim_wait_min" },
    { 0x960D23A7, "fxanim_waits" },
    { 0x65BD8359, "fxanim_waittill" },
    { 0xB86B7FCD, "fxanim_waittill_1" },
    { 0xDE6DFA36, "fxanim_waittill_2" },
    { 0x0470749F, "fxanim_waittill_3" },
    { 0x80F989AA, "fxanim_waittill_flag" },
    { 0x43B4BCAC, "fxanim_wall_fall_start" },
    { 0x2CA49729, "fxanim_wall_tackle_start" },
    { 0x3B7303B9, "fxanim_war_laser_turret_search_01_anim" },
    { 0xB6864980, "fxanim_war_laser_turret_search_02_anim" },
    { 0x18BBA2F3, "fxanim_war_laser_turret_search_03_anim" },
    { 0x64FF4272, "fxanim_war_laser_turret_search_04_anim" },
    { 0x7722E663, "fxanim_water_tower_block_end_start" },
    { 0x6508B111, "fxanim_water_tower_block_start" },
    { 0x7DC35815, "fxanim_water_tower_brick_index" },
    { 0xD8F62A88, "fxanim_water_tower_brick_jnts" },
    { 0xFE32C773, "fxanim_water_tower_start" },
    { 0x8215D319, "fxanim_watertower_river_start" },
    { 0x67336916, "fxanim_wind_barrel_01" },
    { 0x346309C7, "fxanim_wind_barrel_01_start" },
    { 0x5E0DC294, "fxanim_wind_barrel_02_start" },
    { 0x36853689, "fxanim_wind_crates_start" },
    { 0xD76A1CC5, "fxanim_wind_light_start" },
    { 0xDAB8FC9D, "fxanim_wire_think" },
    { 0xFF8FDEE8, "fxanim_yemen_speech_vtol_anim" },
    { 0xF5E04A76, "fxanim_yemen_vtol1_veh_crash_anim" },
    { 0x7FBF6E11, "fxanim_yemen_vtol1_veh_loop_anim" },
    { 0xB11F8921, "fxanim_yemen_vtol2_vtol_anim" },
    { 0x65DE905D, "fxanimname" },
    { 0xE6030AFF, "fxanims" },
    { 0xAB5210B6, "fxarray" },
    { 0xDECED2D8, "fxaxis" },
    { 0xF5655F71, "fxblocksight" },
    { 0x49264928, "fxbreachleaks" },
    { 0xD2E922F6, "fxchecktime" },
    { 0xA10F70DD, "fxclientutils" },
    { 0x0E3CD976, "fxcobrastreets" },
    { 0xFDEC0B75, "fxcolorbit" },
    { 0xB7AC1552, "fxcommand" },
    { 0x21316230, "fxcount" },
    { 0xAFE2E125, "fxcounter" },
    { 0x38DA90EC, "fxdamage" },
    { 0xB20DD6B0, "fxdef" },
    { 0xF9FBD324, "fxdelay" },
    { 0xD35A5792, "fxemitters" },
    { 0x9A1CF5DC, "fxendpos" },
    { 0x8247345A, "fxent" },
    { 0x4FA075FE, "fxent0" },
    { 0x75A2F067, "fxent1" },
    { 0x039B812C, "fxent2" },
    { 0x299DFB95, "fxent3" },
    { 0xB7968C5A, "fxent4" },
    { 0xB90365DA, "fxentlighting" },
    { 0xA8FF6155, "fxents" },
    { 0xF6912758, "fxexplodernum" },
    { 0x61445FBD, "fxfile" },
    { 0x89140B04, "fxfilename" },
    { 0xE8F02163, "fxfireloopmod" },
    { 0xFC28B0A9, "fxflag" },
    { 0x7990BC65, "fxhandle" },
    { 0x72481774, "fxhandles" },
    { 0xAFD83B8F, "fxhash" },
    { 0xEC003720, "fxhashleft" },
    { 0xD50D730F, "fxhashright" },
    { 0x672E7D56, "fxhashs" },
    { 0x25F19531, "fxhudelements" },
    { 0x8AE2FA04, "fxid" },
    { 0x932CE28E, "fxid2" },
    { 0x3890C2B7, "fxids" },
    { 0x922B6D0D, "fxindex" },
    { 0x10CB04DA, "fxintensity" },
    { 0x209D3DCF, "fxintro" },
    { 0x9B258281, "fxinvalidlocation" },
    { 0x2FFB7083, "fxlength" },
    { 0x3BF4A6A9, "fxlight" },
    { 0xC198D349, "fxline" },
    { 0xE477846F, "fxlist" },
    { 0x5E8CED56, "fxlocation" },
    { 0xB045AE3D, "fxlowhealth" },
    { 0xBBA61A9A, "fxmarkedlocation" },
    { 0xB7126CE3, "fxmaxdist" },
    { 0x1705EE7A, "fxmodel" },
    { 0x36572BDF, "fxn" },
    { 0x748494E6, "fxname" },
    { 0xCC8C4519, "fxnames" },
    { 0xE23DB623, "fxnode" },
    { 0x45CDED02, "fxnormal" },
    { 0xBEA51F05, "fxnum" },
    { 0x1E5277EA, "fxobj" },
    { 0x3E7E6E3F, "fxorg" },
    { 0xC1A8D1E1, "fxorigin" },
    { 0x38CE0B42, "fxpieces" },
    { 0xA6073D14, "fxplay_index" },
    { 0x859DA90E, "fxplay_indexmax" },
    { 0x80A9B637, "fxplay_model" },
    { 0xB3B74F0D, "fxplay_model_array" },
    { 0x7E1DAB2F, "fxplay_writeindex" },
    { 0x335C462B, "fxplazatown" },
    { 0xA5EEDEC7, "fxpos" },
    { 0x2996B467, "fxpos2" },
    { 0x8304729D, "fxpos_array" },
    { 0xC560CBBF, "fxprops" },
    { 0x42C63F4E, "fxquake" },
    { 0x088641AA, "fxs" },
    { 0xBFC03292, "fxscriptbundle" },
    { 0xBF87F956, "fxsmoketown" },
    { 0x2135B750, "fxsound" },
    { 0x264ABE33, "fxspot" },
    { 0x44C0B699, "fxspot_clavicle_left" },
    { 0x1A01FF44, "fxspot_clavicle_right" },
    { 0xB72547DC, "fxspot_head" },
    { 0x3A9D877F, "fxspot_spine" },
    { 0x02FF69F1, "fxstart" },
    { 0x5402531B, "fxstop" },
    { 0x6F6566EE, "fxswap" },
    { 0xFA7B225D, "fxtag" },
    { 0x638FFFA4, "fxtagname" },
    { 0xF8774253, "fxtagorigin" },
    { 0x2DF466A8, "fxteam" },
    { 0xE2D22FC2, "fxtimer" },
    { 0x72BAE50E, "fxtoplay" },
    { 0xE5D845C0, "fxtowerexploders" },
    { 0x0E758DB9, "fxtv" },
    { 0x26B8BCB2, "fxvalidlocation" },
    { 0xC846BB09, "fxville" },
    { 0xBD3ACC58, "fxy_2d_calc_latency" },
    { 0x3150EBE2, "fy" },
    { 0xC60470C8, "fy2d" },
    { 0x1A2A5557, "fyi" },
    { 0x32762C50, "fzoffset" },
    { 0x155CEB88, "g" },
    { 0xAF70E811, "g1" },
    { 0x3A31CC0A, "g11" },
    { 0xDECBAC9E, "g20" },
    { 0x26757ECE, "g20_1" },
    { 0x82C06E39, "g20_1_death" },
    { 0xA1E6EF7E, "g20_1_saved" },
    { 0x00730465, "g20_2" },
    { 0x0857907E, "g20_2_death" },
    { 0x6217BFC9, "g20_2_saved" },
    { 0x1736EA2E, "g20_attack_drone" },
    { 0x0A62C8A7, "g20_attackers" },
    { 0xBCF58F79, "g20_attackers_damage" },
    { 0x78AF6F98, "g20_attackers_spawn_func" },
    { 0x5F02ACB2, "g20_cougar" },
    { 0x5F7FDEC3, "g20_cougar_fail_time" },
    { 0x63FC7789, "g20_cougar_wait_done" },
    { 0x3622DD41, "g20_fail" },
    { 0x20EE2838, "g20_group1_greet_harper_started" },
    { 0x2C945975, "g20_group1_ss1" },
    { 0x94FAE6C3, "g20_group_meetup" },
    { 0x3341ED02, "g20_veh" },
    { 0x28E1C6F6, "g_allow_teamchange" },
    { 0x1B0E2142, "g_allowvote" },
    { 0xAE8D7081, "g_findconfigstringindex" },
    { 0xF7120D8C, "g_force" },
    { 0xB246A528, "g_force_time" },
    { 0xE9A76737, "g_force_title" },
    { 0xED08C730, "g_force_val" },
    { 0xA9623639, "g_fraction" },
    { 0x895BF3B2, "g_friendlyfiredist" },
    { 0x09A74C84, "g_gameskill" },
    { 0x53270C28, "g_he_alignx" },
    { 0x79298691, "g_he_aligny" },
    { 0x4E60FB76, "g_he_font" },
    { 0x3EACACAD, "g_he_horzalign" },
    { 0x34FA1A5F, "g_he_vertalign" },
    { 0x3936287B, "g_helicopterlookaheadtime" },
    { 0xC2E6DB54, "g_hitlocnames" },
    { 0x05BA1506, "g_holdusetime" },
    { 0xF34B5758, "g_local" },
    { 0x5BA87CDB, "g_org" },
    { 0x482F2126, "g_scripted_idle_anim" },
    { 0xC217E840, "g_speed" },
    { 0x116339CD, "g_start" },
    { 0xE63E3C18, "g_target" },
    { 0x541275AC, "g_time" },
    { 0x88C6A7A8, "g_vel" },
    { 0x6F66C54A, "gadge_mrpukey_on_connect" },
    { 0x7FBB3F9D, "gadget" },
    { 0xF1916D1C, "gadget_action_already_active" },
    { 0x4E7F30FD, "gadget_action_button_held" },
    { 0x4CB44E49, "gadget_action_button_holding" },
    { 0x92E52CC7, "gadget_action_button_release" },
    { 0x77308544, "gadget_action_cannot_activate" },
    { 0xED2770FA, "gadget_action_fill_up" },
    { 0x5EFCFF21, "gadget_action_fire" },
    { 0x9E818547, "gadget_action_flicker" },
    { 0xF2B537DA, "gadget_action_give" },
    { 0x8B72F86F, "gadget_action_ignore" },
    { 0xF5F56FF4, "gadget_action_off" },
    { 0xE81B367E, "gadget_action_on" },
    { 0xF23DF5D6, "gadget_action_primed" },
    { 0x5961CABA, "gadget_action_ready" },
    { 0x94FFC346, "gadget_action_requires_targets" },
    { 0xB2963367, "gadget_action_skipped" },
    { 0x16944C74, "gadget_action_take" },
    { 0x29961C34, "gadget_armor_flicker" },
    { 0xE4E11F03, "gadget_armor_is_flickering" },
    { 0x24782613, "gadget_armor_is_inuse" },
    { 0xEF8F7527, "gadget_armor_off" },
    { 0x27D2AB93, "gadget_armor_on" },
    { 0x362BC1A8, "gadget_armor_on_connect" },
    { 0x9B27736E, "gadget_armor_on_flicker" },
    { 0xF593F079, "gadget_armor_on_give" },
    { 0x0C03E583, "gadget_armor_on_take" },
    { 0x098B378E, "gadget_armor_status" },
    { 0xDCE4F8F3, "gadget_breadcrumbduration" },
    { 0x02164E92, "gadget_cacophany_is_flickering" },
    { 0xDEA97FDC, "gadget_cacophany_is_inuse" },
    { 0x6C067EFD, "gadget_cacophany_is_primed" },
    { 0x120F3C62, "gadget_cacophany_off" },
    { 0x42E85E54, "gadget_cacophany_on" },
    { 0xA11B5C77, "gadget_cacophany_on_connect" },
    { 0x639BF239, "gadget_cacophany_on_flicker" },
    { 0x77666AE8, "gadget_cacophany_on_give" },
    { 0xBEA195FE, "gadget_cacophany_on_take" },
    { 0x9B8EAFF2, "gadget_camo_off_time" },
    { 0x4A551DFF, "gadget_camo_render" },
    { 0xFF653120, "gadget_camo_shader_break" },
    { 0x57E170D5, "gadget_camo_shader_flicker" },
    { 0xC787E796, "gadget_camo_shader_off" },
    { 0x60490C08, "gadget_camo_shader_on" },
    { 0x1BAAA346, "gadget_checkheroabilitykill" },
    { 0xE35DFA9E, "gadget_cleanse_flicker" },
    { 0xBA97ACDD, "gadget_cleanse_is_flickering" },
    { 0x5E9069B9, "gadget_cleanse_is_inuse" },
    { 0xD9079385, "gadget_cleanse_off" },
    { 0xC6BE0179, "gadget_cleanse_on" },
    { 0xE5937CBE, "gadget_cleanse_on_connect" },
    { 0xC8CD9188, "gadget_cleanse_on_flicker" },
    { 0xE8DF45DF, "gadget_cleanse_on_give" },
    { 0xDB5E1E95, "gadget_cleanse_on_take" },
    { 0x1E438B36, "gadget_cleanse_start" },
    { 0xE014CBA9, "gadget_clone_is_flickering" },
    { 0x2DC12C1D, "gadget_clone_is_inuse" },
    { 0xE4FE20C9, "gadget_clone_off" },
    { 0x33FADCBD, "gadget_clone_on" },
    { 0xB05B9D52, "gadget_clone_on_connect" },
    { 0x7F1C395C, "gadget_clone_on_flicker" },
    { 0xA3F945FB, "gadget_clone_on_give" },
    { 0xA0CE69D9, "gadget_clone_on_take" },
    { 0x1E7514CE, "gadget_clone_render" },
    { 0x6F20BF82, "gadget_combat_efficiency_enabled" },
    { 0xD49E274E, "gadget_combat_efficiency_is_flickering" },
    { 0xFD490370, "gadget_combat_efficiency_is_inuse" },
    { 0x93968950, "gadget_combat_efficiency_on_activate" },
    { 0x4EFDCEFB, "gadget_combat_efficiency_on_connect" },
    { 0x1FB7EA1D, "gadget_combat_efficiency_on_flicker" },
    { 0xCE638C14, "gadget_combat_efficiency_on_give" },
    { 0xE58640BE, "gadget_combat_efficiency_on_off" },
    { 0x66BFD148, "gadget_combat_efficiency_on_spawn" },
    { 0xC4A4C062, "gadget_combat_efficiency_on_take" },
    { 0x39C85E49, "gadget_combat_efficiency_power_drain" },
    { 0xA83013B4, "gadget_combat_efficiency_ready" },
    { 0x52A16DE6, "gadget_concussive_wave_is_flickering" },
    { 0x9B3F10A8, "gadget_concussive_wave_is_inuse" },
    { 0x96C5B0E1, "gadget_concussive_wave_is_primed" },
    { 0x92FC0C6E, "gadget_concussive_wave_off" },
    { 0x34DD1440, "gadget_concussive_wave_on" },
    { 0x1D1DB9D3, "gadget_concussive_wave_on_connect" },
    { 0x52E40575, "gadget_concussive_wave_on_flicker" },
    { 0x6418A4DC, "gadget_concussive_wave_on_give" },
    { 0x1D94DC8A, "gadget_concussive_wave_on_take" },
    { 0xA7C7F261, "gadget_drone_despawn" },
    { 0x40E130BF, "gadget_drone_flicker" },
    { 0xA76D3838, "gadget_drone_is_flickering" },
    { 0x1990D6C6, "gadget_drone_is_inuse" },
    { 0x48716A6C, "gadget_drone_off" },
    { 0x60ACE016, "gadget_drone_on" },
    { 0x932A2D61, "gadget_drone_on_connect" },
    { 0x6964CABF, "gadget_drone_on_flicker" },
    { 0xD7922042, "gadget_drone_on_give" },
    { 0x844BF11C, "gadget_drone_on_take" },
    { 0x9B65FAF6, "gadget_drone_spawn" },
    { 0x91B1B897, "gadget_es_strike_is_flickering" },
    { 0x411E6E2F, "gadget_es_strike_is_inuse" },
    { 0xEC5008E3, "gadget_es_strike_off" },
    { 0x3211462F, "gadget_es_strike_on" },
    { 0x0B61A584, "gadget_es_strike_on_connect" },
    { 0xF4C32D3A, "gadget_es_strike_on_flicker" },
    { 0x16DE280D, "gadget_es_strike_on_give" },
    { 0x8A49B72F, "gadget_es_strike_on_take" },
    { 0x9EA7A824, "gadget_exo_breakdown_is_flickering" },
    { 0x010CED8A, "gadget_exo_breakdown_is_inuse" },
    { 0xEEF5315B, "gadget_exo_breakdown_is_primed" },
    { 0xEAD04890, "gadget_exo_breakdown_off" },
    { 0x1D36A30A, "gadget_exo_breakdown_on" },
    { 0x126F0E75, "gadget_exo_breakdown_on_connect" },
    { 0xFDF21253, "gadget_exo_breakdown_on_flicker" },
    { 0x7BBC329E, "gadget_exo_breakdown_on_give" },
    { 0xA37DD970, "gadget_exo_breakdown_on_take" },
    { 0x9D2A518E, "gadget_firefly_is_primed" },
    { 0xE1E64030, "gadget_firefly_swarm_is_flickering" },
    { 0x06194B7E, "gadget_firefly_swarm_is_inuse" },
    { 0xB1976484, "gadget_firefly_swarm_off" },
    { 0x1FE024EE, "gadget_firefly_swarm_on" },
    { 0x4A3AA959, "gadget_firefly_swarm_on_connect" },
    { 0xD4552077, "gadget_firefly_swarm_on_flicker" },
    { 0x74F27FAA, "gadget_firefly_swarm_on_give" },
    { 0xDB0A7244, "gadget_firefly_swarm_on_take" },
    { 0x8ABC8D46, "gadget_flag" },
    { 0x95CA4855, "gadget_flashback_is_flickering" },
    { 0x90FCD171, "gadget_flashback_is_inuse" },
    { 0xC2D1F5C2, "gadget_flashback_is_primed" },
    { 0xC23CB11D, "gadget_flashback_off" },
    { 0x368B57D1, "gadget_flashback_on" },
    { 0x65109C96, "gadget_flashback_on_connect" },
    { 0x51535640, "gadget_flashback_on_flicker" },
    { 0x42BD2787, "gadget_flashback_on_give" },
    { 0xD5E07D1D, "gadget_flashback_on_take" },
    { 0x6BF3F470, "gadget_flashback_spawned" },
    { 0x4AA7E3FC, "gadget_flicker" },
    { 0xE9C26B76, "gadget_flicker_callback" },
    { 0x815AC4D8, "gadget_flickerondamage" },
    { 0x091016A3, "gadget_flickeronpowerloss" },
    { 0xB26A4F6F, "gadget_flickertime" },
    { 0xD1D17A92, "gadget_forced_malfunction_is_flickering" },
    { 0xDFFAE3DC, "gadget_forced_malfunction_is_inuse" },
    { 0x7F26EAFD, "gadget_forced_malfunction_is_primed" },
    { 0x2D460862, "gadget_forced_malfunction_off" },
    { 0x9B45E254, "gadget_forced_malfunction_on" },
    { 0xBD256077, "gadget_forced_malfunction_on_connect" },
    { 0x7FA5F639, "gadget_forced_malfunction_on_flicker" },
    { 0xD23DF6E8, "gadget_forced_malfunction_on_give" },
    { 0x197921FE, "gadget_forced_malfunction_on_take" },
    { 0xE91F7FFF, "gadget_give_callback" },
    { 0xDBE98D36, "gadget_give_random_gadget" },
    { 0x046EB16F, "gadget_hacker_flicker" },
    { 0xFB15F4E8, "gadget_hacker_is_flickering" },
    { 0x47AD61F6, "gadget_hacker_is_inuse" },
    { 0x0161187C, "gadget_hacker_off" },
    { 0x65C783C6, "gadget_hacker_on" },
    { 0xD5CA6C91, "gadget_hacker_on_connect" },
    { 0xC6C5EBEF, "gadget_hacker_on_flicker" },
    { 0xBD78C792, "gadget_hacker_on_give" },
    { 0xE1EBC5AC, "gadget_hacker_on_take" },
    { 0x2DD89D87, "gadget_has_type" },
    { 0x025F27A3, "gadget_heat_wave_flicker" },
    { 0xB76301E4, "gadget_heat_wave_is_flickering" },
    { 0x2B12374A, "gadget_heat_wave_is_inuse" },
    { 0x24BFBFDA, "gadget_heat_wave_on_activate" },
    { 0x5F8C8735, "gadget_heat_wave_on_connect" },
    { 0xAB533C93, "gadget_heat_wave_on_deactivate" },
    { 0xF6AA5A13, "gadget_heat_wave_on_flicker" },
    { 0xB521F65E, "gadget_heat_wave_on_give" },
    { 0xCA582876, "gadget_heat_wave_on_player_spawn" },
    { 0xDCE39D30, "gadget_heat_wave_on_take" },
    { 0xE48CBC30, "gadget_held_0" },
    { 0x0A8F3699, "gadget_held_1" },
    { 0x3091B102, "gadget_held_2" },
    { 0xBC382C1D, "gadget_held_count" },
    { 0x13AC8CB5, "gadget_hero_weapon_is_flickering" },
    { 0x487E0A51, "gadget_hero_weapon_is_inuse" },
    { 0x8FDB70E7, "gadget_hero_weapon_on_activate" },
    { 0xFB88E576, "gadget_hero_weapon_on_connect" },
    { 0x967BD520, "gadget_hero_weapon_on_flicker" },
    { 0x390203E7, "gadget_hero_weapon_on_give" },
    { 0xC3A1AA13, "gadget_hero_weapon_on_off" },
    { 0xC4A7CC89, "gadget_hero_weapon_on_spawn" },
    { 0xE7EC777D, "gadget_hero_weapon_on_take" },
    { 0x35E96D3B, "gadget_hero_weapon_ready" },
    { 0xE95159EA, "gadget_heroversion_2_0" },
    { 0x5DDA9D3A, "gadget_iff_override_is_flickering" },
    { 0xDD752664, "gadget_iff_override_is_inuse" },
    { 0x54113655, "gadget_iff_override_is_primed" },
    { 0x4377752A, "gadget_iff_override_off" },
    { 0x3E1F85FC, "gadget_iff_override_on" },
    { 0x96787FDF, "gadget_iff_override_on_connect" },
    { 0x4C6C9561, "gadget_iff_override_on_flicker" },
    { 0x2B859620, "gadget_iff_override_on_give" },
    { 0xBDD75256, "gadget_iff_override_on_take" },
    { 0xA881191B, "gadget_immolation_is_flickering" },
    { 0xB024AECB, "gadget_immolation_is_inuse" },
    { 0x77BCC634, "gadget_immolation_is_primed" },
    { 0x43D6EC7F, "gadget_immolation_off" },
    { 0x7C43428B, "gadget_immolation_on" },
    { 0x44821BC0, "gadget_immolation_on_connect" },
    { 0x51E92CC6, "gadget_immolation_on_flicker" },
    { 0xF4FF64C1, "gadget_immolation_on_give" },
    { 0x6947E88B, "gadget_immolation_on_take" },
    { 0x4AA7ECDD, "gadget_is_active" },
    { 0x625FB64C, "gadget_is_camo_suit_flickering" },
    { 0x7BF047DB, "gadget_is_camo_suit_on" },
    { 0xDB4E8AE0, "gadget_is_escort_drone_on" },
    { 0x3BE121EB, "gadget_is_flickering" },
    { 0x3D3243A6, "gadget_is_in_use" },
    { 0x9A857717, "gadget_is_type" },
    { 0x493AE09D, "gadget_key" },
    { 0x4990CFF1, "gadget_max_hitpoints" },
    { 0x0A3F0292, "gadget_misdirection_is_flickering" },
    { 0x7F86BBDC, "gadget_misdirection_is_inuse" },
    { 0xA84BF2FD, "gadget_misdirection_is_primed" },
    { 0x53A55062, "gadget_misdirection_off" },
    { 0x06167A54, "gadget_misdirection_on" },
    { 0x8270F877, "gadget_misdirection_on_connect" },
    { 0x44F18E39, "gadget_misdirection_on_flicker" },
    { 0x3149BEE8, "gadget_misdirection_on_give" },
    { 0x7884E9FE, "gadget_misdirection_on_take" },
    { 0xF1409FC3, "gadget_mrpukey_is_flickering" },
    { 0xEC5153D3, "gadget_mrpukey_is_inuse" },
    { 0xA05CCC6C, "gadget_mrpukey_is_primed" },
    { 0x0A21F6E7, "gadget_mrpukey_off" },
    { 0x79FD7153, "gadget_mrpukey_on" },
    { 0x037C482E, "gadget_mrpukey_on_flicker" },
    { 0x70600839, "gadget_mrpukey_on_give" },
    { 0x86CFFD43, "gadget_mrpukey_on_take" },
    { 0x585ED386, "gadget_multirocket_fire" },
    { 0x213A18A8, "gadget_multirocket_fire_hint_off" },
    { 0xD1052CC2, "gadget_multirocket_fire_hint_on" },
    { 0x5CC7D5EB, "gadget_multirocket_fire_watcher" },
    { 0x86198BFA, "gadget_multirocket_flicker" },
    { 0x75DF5581, "gadget_multirocket_is_flickering" },
    { 0x03136AB5, "gadget_multirocket_is_inuse" },
    { 0x8083C221, "gadget_multirocket_off" },
    { 0xC6869395, "gadget_multirocket_on" },
    { 0x3DB86A4A, "gadget_multirocket_on_connect" },
    { 0x23E9BAB4, "gadget_multirocket_on_flicker" },
    { 0x05C2CD03, "gadget_multirocket_on_give" },
    { 0x685DF0A1, "gadget_multirocket_on_take" },
    { 0xA6C889E3, "gadget_multirocket_proximity_explode" },
    { 0x2F7A23B9, "gadget_multirocket_remove_targets" },
    { 0x6B46BF7C, "gadget_multirocket_target_acquire" },
    { 0x3E8BCCAF, "gadget_multirocket_weapon_watcher" },
    { 0x3F22A7B3, "gadget_off_callback" },
    { 0x96468301, "gadget_off_penalty_count" },
    { 0xFCCE6DA2, "gadget_off_penalty_none" },
    { 0x2AFF5348, "gadget_off_penalty_shut_off" },
    { 0x5EB315C3, "gadget_off_penalty_turn_off" },
    { 0xEB88EB3F, "gadget_on_callback" },
    { 0x82E13A68, "gadget_other_is_flickering" },
    { 0x4D562E76, "gadget_other_is_inuse" },
    { 0x73509156, "gadget_other_on_activate" },
    { 0x327B4D11, "gadget_other_on_connect" },
    { 0x2376CC6F, "gadget_other_on_flicker" },
    { 0x1EFE9912, "gadget_other_on_give" },
    { 0xAF4D837C, "gadget_other_on_off" },
    { 0x3A9413E6, "gadget_other_on_spawn" },
    { 0x4371972C, "gadget_other_on_take" },
    { 0xAF938542, "gadget_other_ready" },
    { 0xFDADA264, "gadget_overdrive_is_flickering" },
    { 0x99C38CCA, "gadget_overdrive_is_inuse" },
    { 0x0A0A9DD0, "gadget_overdrive_off" },
    { 0x372C774A, "gadget_overdrive_on" },
    { 0xF40798B5, "gadget_overdrive_on_connect" },
    { 0x8B256B93, "gadget_overdrive_on_flicker" },
    { 0x6F36BADE, "gadget_overdrive_on_give" },
    { 0x96F861B0, "gadget_overdrive_on_take" },
    { 0xB3A94301, "gadget_power_armor_on" },
    { 0x19CA800D, "gadget_power_consume_on_ammo_use" },
    { 0x4BDD0A0F, "gadget_power_reset" },
    { 0xF6AA5E8F, "gadget_power_reset_on_class_change" },
    { 0x145D28BB, "gadget_power_reset_on_round_switch" },
    { 0x2C62ACAA, "gadget_power_reset_on_team_change" },
    { 0x41887F53, "gadget_power_round_end_active_penalty" },
    { 0x4476898C, "gadget_power_usage_rate" },
    { 0x5BD17311, "gadget_powergainscorefactor" },
    { 0xE3D5C434, "gadget_powergainscoreignoreself" },
    { 0xAFFCBBAC, "gadget_powergainscoreignorewhenactive" },
    { 0x9E433E35, "gadget_powermoveloss" },
    { 0x1AA14D79, "gadget_powermovespeed" },
    { 0x8A740DD7, "gadget_powerofflossondamage" },
    { 0x0EC935F1, "gadget_poweronlossondamage" },
    { 0xC16F51E2, "gadget_powerreplenishfactor" },
    { 0x093EDE4A, "gadget_powersprintloss" },
    { 0x5358B1AF, "gadget_powertakedowngain" },
    { 0xEA4245B3, "gadget_primed" },
    { 0xDB6CDBE7, "gadget_primed_callback" },
    { 0x03191932, "gadget_pulse_duration" },
    { 0xB54BBD02, "gadget_pulse_max_range" },
    { 0xF168E6C9, "gadget_rapid_strike_is_flickering" },
    { 0x96B27BBD, "gadget_rapid_strike_is_inuse" },
    { 0x5B9296A9, "gadget_rapid_strike_off" },
    { 0xE3AE201D, "gadget_rapid_strike_on" },
    { 0x672B2D72, "gadget_rapid_strike_on_connect" },
    { 0xDEC6547C, "gadget_rapid_strike_on_flicker" },
    { 0xD7B6939B, "gadget_rapid_strike_on_give" },
    { 0xD2114E79, "gadget_rapid_strike_on_take" },
    { 0x7F87BE84, "gadget_ravage_core_is_flickering" },
    { 0x9B19B36A, "gadget_ravage_core_is_inuse" },
    { 0x38D64430, "gadget_ravage_core_off" },
    { 0x272C182A, "gadget_ravage_core_on" },
    { 0x882E77D5, "gadget_ravage_core_on_connect" },
    { 0xF2C75EB3, "gadget_ravage_core_on_flicker" },
    { 0x5F263C7E, "gadget_ravage_core_on_give" },
    { 0x5AA8D250, "gadget_ravage_core_on_take" },
    { 0x2440B005, "gadget_ready" },
    { 0x6620C1E9, "gadget_ready_callback" },
    { 0x1C2437FE, "gadget_ready_flag" },
    { 0x3AC95671, "gadget_recover_flag" },
    { 0x0526C4BD, "gadget_reset" },
    { 0x0B48B321, "gadget_resurrect" },
    { 0x3EFDC53A, "gadget_resurrect_delay_updateteamstatus" },
    { 0x4723D8CC, "gadget_resurrect_duration" },
    { 0x77AF85D7, "gadget_resurrect_is_flickering" },
    { 0x07B9336F, "gadget_resurrect_is_inuse" },
    { 0xF885C9D0, "gadget_resurrect_is_player_predead" },
    { 0x5ADAB2A0, "gadget_resurrect_is_primed" },
    { 0xF00B1078, "gadget_resurrect_is_ready" },
    { 0xC5460123, "gadget_resurrect_off" },
    { 0xEBF05E6F, "gadget_resurrect_on" },
    { 0x8D17EFC4, "gadget_resurrect_on_connect" },
    { 0xBE7FA67A, "gadget_resurrect_on_flicker" },
    { 0x3F55DE4D, "gadget_resurrect_on_give" },
    { 0xA3C47C6C, "gadget_resurrect_on_spawned" },
    { 0xC993B96F, "gadget_resurrect_on_take" },
    { 0xDF4988D6, "gadget_resurrect_secondary_deathcam_time" },
    { 0x21432960, "gadget_resurrect_start" },
    { 0xA7D38B50, "gadget_roulette" },
    { 0xD54205C5, "gadget_roulette_flicker" },
    { 0x41F588AE, "gadget_roulette_give_earned_specialist" },
    { 0x0327CBBE, "gadget_roulette_is_flickering" },
    { 0x4CFA6FA0, "gadget_roulette_is_inuse" },
    { 0xA3B109BF, "gadget_roulette_is_ready" },
    { 0xCA371720, "gadget_roulette_on_activate" },
    { 0x1A90B6AB, "gadget_roulette_on_connect" },
    { 0xFC8F7639, "gadget_roulette_on_deactivate" },
    { 0x27BF03C4, "gadget_roulette_on_deactivate_helper" },
    { 0x26221A8D, "gadget_roulette_on_flicker" },
    { 0xA55195E4, "gadget_roulette_on_give" },
    { 0xE25ADB10, "gadget_roulette_on_player_spawn" },
    { 0xE13E0D32, "gadget_roulette_on_take" },
    { 0xAAB070F0, "gadget_security_breach_is_flickering" },
    { 0x439B773E, "gadget_security_breach_is_inuse" },
    { 0xBBD467E7, "gadget_security_breach_is_primed" },
    { 0xAE24E944, "gadget_security_breach_off" },
    { 0xC5D34EAE, "gadget_security_breach_on" },
    { 0x03EE9B19, "gadget_security_breach_on_connect" },
    { 0x612F0337, "gadget_security_breach_on_flicker" },
    { 0x2F62C66A, "gadget_security_breach_on_give" },
    { 0x957AB904, "gadget_security_breach_on_take" },
    { 0xD34DD456, "gadget_sensory_overload_is_flickering" },
    { 0x1A766E18, "gadget_sensory_overload_is_inuse" },
    { 0xCE8BF231, "gadget_sensory_overload_is_primed" },
    { 0xC1D76FFE, "gadget_sensory_overload_off" },
    { 0x15E437B0, "gadget_sensory_overload_on" },
    { 0xE100D1C3, "gadget_sensory_overload_on_connect" },
    { 0xCEAB21E5, "gadget_sensory_overload_on_flicker" },
    { 0xB0D7EFEC, "gadget_sensory_overload_on_give" },
    { 0xD9C4129A, "gadget_sensory_overload_on_take" },
    { 0xA850A436, "gadget_servo_shortout_is_flickering" },
    { 0xD0064A78, "gadget_servo_shortout_is_inuse" },
    { 0x2BE7B311, "gadget_servo_shortout_is_primed" },
    { 0xC1CE069E, "gadget_servo_shortout_off" },
    { 0x39B385D0, "gadget_servo_shortout_on" },
    { 0x901D2323, "gadget_servo_shortout_on_connect" },
    { 0x2B96D045, "gadget_servo_shortout_on_flicker" },
    { 0xFC4FE7CC, "gadget_servo_shortout_on_give" },
    { 0x3E88BF7A, "gadget_servo_shortout_on_take" },
    { 0xB0DF69D8, "gadget_shieldreflectpowergain" },
    { 0x8B965410, "gadget_shieldreflectpowerloss" },
    { 0x578640DD, "gadget_shock_field_is_flickering" },
    { 0xC51245B9, "gadget_shock_field_is_inuse" },
    { 0x44BC8785, "gadget_shock_field_off" },
    { 0xBE1DBD79, "gadget_shock_field_on" },
    { 0x8BAEB8BE, "gadget_shock_field_on_connect" },
    { 0x6EE8CD88, "gadget_shock_field_on_flicker" },
    { 0x87EF79DF, "gadget_shock_field_on_give" },
    { 0x7A6E5295, "gadget_shock_field_on_take" },
    { 0x1E737206, "gadget_shockfield_damage" },
    { 0xE540F273, "gadget_shockfield_radius" },
    { 0x99902FA0, "gadget_slot_count" },
    { 0x4387AB03, "gadget_slot_for_type" },
    { 0x43A90939, "gadget_smokescreen_is_flickering" },
    { 0xCEB5552D, "gadget_smokescreen_is_inuse" },
    { 0xE11CF076, "gadget_smokescreen_is_primed" },
    { 0x89901879, "gadget_smokescreen_off" },
    { 0xBD67C28D, "gadget_smokescreen_on" },
    { 0x53FF0722, "gadget_smokescreen_on_connect" },
    { 0xBFB84B6C, "gadget_smokescreen_on_flicker" },
    { 0xA17871AB, "gadget_smokescreen_on_give" },
    { 0x70F70B89, "gadget_smokescreen_on_take" },
    { 0x5B8D7647, "gadget_speed_burst_flicker" },
    { 0x8386C640, "gadget_speed_burst_is_flickering" },
    { 0x15880B4E, "gadget_speed_burst_is_inuse" },
    { 0x51B450F4, "gadget_speed_burst_off" },
    { 0x4471717E, "gadget_speed_burst_on" },
    { 0xBFAFA469, "gadget_speed_burst_on_connect" },
    { 0x070950C7, "gadget_speed_burst_on_flicker" },
    { 0x41C1EA5A, "gadget_speed_burst_on_give" },
    { 0x65A0FEF4, "gadget_speed_burst_on_take" },
    { 0x090ADF31, "gadget_speedburstwallrunjumpvelocity" },
    { 0xE4B7EE54, "gadget_surge_is_flickering" },
    { 0x08721BFA, "gadget_surge_is_inuse" },
    { 0x5FF9A66B, "gadget_surge_is_primed" },
    { 0xEBB88A60, "gadget_surge_off" },
    { 0xC6108DBA, "gadget_surge_on" },
    { 0xE8723625, "gadget_surge_on_connect" },
    { 0x03F2D883, "gadget_surge_on_flicker" },
    { 0x113A0C6E, "gadget_surge_on_give" },
    { 0xAA2B0180, "gadget_surge_on_take" },
    { 0xA0A61E62, "gadget_system_overload_is_flickering" },
    { 0xD7934BEC, "gadget_system_overload_is_inuse" },
    { 0xA7A30EED, "gadget_system_overload_is_primed" },
    { 0x7EB9A812, "gadget_system_overload_off" },
    { 0xE1F18864, "gadget_system_overload_on" },
    { 0x613DCE47, "gadget_system_overload_on_connect" },
    { 0xD25B7289, "gadget_system_overload_on_flicker" },
    { 0x88154E18, "gadget_system_overload_on_give" },
    { 0x319CE16E, "gadget_system_overload_on_take" },
    { 0x37EB82CD, "gadget_take_callback" },
    { 0x8D8FA879, "gadget_takedownrevealtime" },
    { 0xEB1A1028, "gadget_thief" },
    { 0xAAC33C1D, "gadget_thief_active" },
    { 0xDC57CABD, "gadget_thief_flicker" },
    { 0x8909E8F6, "gadget_thief_is_flickering" },
    { 0x2BBE8C38, "gadget_thief_is_inuse" },
    { 0x93BBDDA7, "gadget_thief_is_ready" },
    { 0x3646319F, "gadget_thief_kill_callback" },
    { 0x0443D988, "gadget_thief_on_activate" },
    { 0x081F89E3, "gadget_thief_on_connect" },
    { 0x187CEB81, "gadget_thief_on_deactivate" },
    { 0x4B26D505, "gadget_thief_on_flicker" },
    { 0xF42FFC8C, "gadget_thief_on_give" },
    { 0x5A521C68, "gadget_thief_on_player_spawn" },
    { 0xF0DD0E3A, "gadget_thief_on_take" },
    { 0x77983C03, "gadget_thief_slot" },
    { 0x06E5E790, "gadget_turnoff_onempjammed" },
    { 0x2FC8F038, "gadget_turret_deploy_failed_activate" },
    { 0x5BE5E142, "gadget_turret_deploy_is_flickering" },
    { 0xF4CF064C, "gadget_turret_deploy_is_inuse" },
    { 0x7807EBB2, "gadget_turret_deploy_off" },
    { 0xB3CA9584, "gadget_turret_deploy_on" },
    { 0xB88D04A7, "gadget_turret_deploy_on_connect" },
    { 0x94E225E9, "gadget_turret_deploy_on_flicker" },
    { 0xC8C50EF8, "gadget_turret_deploy_on_give" },
    { 0x853EFE4E, "gadget_turret_deploy_on_take" },
    { 0xB7F952CC, "gadget_turret_deploy_taken" },
    { 0x2A634154, "gadget_turret_off" },
    { 0x90854C68, "gadget_type" },
    { 0x0625D580, "gadget_type_active_camo" },
    { 0xB5BDC09C, "gadget_type_armor" },
    { 0xE7ACBAF9, "gadget_type_cacophany" },
    { 0x92652B82, "gadget_type_cleanse" },
    { 0xE36AA386, "gadget_type_clone" },
    { 0x7977BF6D, "gadget_type_combat_efficiency" },
    { 0xCA45ECB1, "gadget_type_concussive_wave" },
    { 0x949965A3, "gadget_type_drone" },
    { 0x832700E9, "gadget_type_energy_shield" },
    { 0xF6FDB3F8, "gadget_type_es_strike" },
    { 0xC8FABFCF, "gadget_type_exo_breakdown" },
    { 0x180CAD1F, "gadget_type_firefly_swarm" },
    { 0x55D930D2, "gadget_type_flashback" },
    { 0x7A69DD43, "gadget_type_forced_malfunction" },
    { 0x54662527, "gadget_type_grenade" },
    { 0x3806EA4D, "gadget_type_hacker" },
    { 0xF4BE4DC7, "gadget_type_heat_wave" },
    { 0x1258A436, "gadget_type_hero_weapon" },
    { 0xEB86153F, "gadget_type_iff_override" },
    { 0xF454802E, "gadget_type_immolation" },
    { 0xFC0F82AC, "gadget_type_infrared" },
    { 0x13CE992C, "gadget_type_juke" },
    { 0x2A7FA163, "gadget_type_misdirection" },
    { 0x31892E4C, "gadget_type_mrpukey" },
    { 0x993094B5, "gadget_type_multi_rocket" },
    { 0xA0482D21, "gadget_type_none" },
    { 0xADFA7AAD, "gadget_type_optic_camo" },
    { 0x6C690E8F, "gadget_type_other" },
    { 0x4F46DF4F, "gadget_type_overdrive" },
    { 0x78E11518, "gadget_type_rapid_strike" },
    { 0x1300C3C7, "gadget_type_ravage_core" },
    { 0xA7F5CA30, "gadget_type_resurrect" },
    { 0x9730306B, "gadget_type_roulette" },
    { 0x96A4E053, "gadget_type_security_breach" },
    { 0xC025329F, "gadget_type_sensory_overload" },
    { 0x4DA0E113, "gadget_type_servo_shortout" },
    { 0x7E8FA59A, "gadget_type_shock_field" },
    { 0x854F8D5E, "gadget_type_smokescreen" },
    { 0xBBD96BBB, "gadget_type_speed_burst" },
    { 0x5474DFDB, "gadget_type_surge" },
    { 0x625F2D31, "gadget_type_system_overload" },
    { 0x56A286D9, "gadget_type_thief" },
    { 0xAADD67F1, "gadget_type_turret_deploy" },
    { 0xD8C26ADE, "gadget_type_unstoppable_force" },
    { 0xB5CF4359, "gadget_type_vision_pulse" },
    { 0xE70192CD, "gadget_unstoppable_force_is_flickering" },
    { 0x0AE33369, "gadget_unstoppable_force_is_inuse" },
    { 0xF5F70C55, "gadget_unstoppable_force_off" },
    { 0xD693CC29, "gadget_unstoppable_force_on" },
    { 0x23DD24EE, "gadget_unstoppable_force_on_connect" },
    { 0xC6DC2378, "gadget_unstoppable_force_on_flicker" },
    { 0xB94AD56F, "gadget_unstoppable_force_on_give" },
    { 0x4F4C1F25, "gadget_unstoppable_force_on_take" },
    { 0x1CA59E0D, "gadget_val" },
    { 0xC8B119DA, "gadget_vision_pulse" },
    { 0xBB685FE3, "gadget_vision_pulse_flicker" },
    { 0x32706C24, "gadget_vision_pulse_is_flickering" },
    { 0x53D8D98A, "gadget_vision_pulse_is_inuse" },
    { 0x8481EC90, "gadget_vision_pulse_off" },
    { 0x4B54EF0A, "gadget_vision_pulse_on" },
    { 0x0E8ADA75, "gadget_vision_pulse_on_connect" },
    { 0xFA0DDE53, "gadget_vision_pulse_on_flicker" },
    { 0x97E4169E, "gadget_vision_pulse_on_give" },
    { 0xBBB240D2, "gadget_vision_pulse_on_spawn" },
    { 0xBFA5BD70, "gadget_vision_pulse_on_take" },
    { 0xAED643AC, "gadget_vision_pulse_ramp_hold_func" },
    { 0x637BF313, "gadget_vision_pulse_start" },
    { 0x085F13C1, "gadget_vision_pulse_watch_death" },
    { 0x79CBE2B9, "gadget_vision_pulse_watch_emp" },
    { 0xF0C41442, "gadget_visionpulse_changed" },
    { 0x841FCCF5, "gadget_visionpulse_reveal" },
    { 0x49E2CB45, "gadget_was_active_last_damage" },
    { 0x486CF433, "gadgetaction_e" },
    { 0xD1693908, "gadgetcharging" },
    { 0x868603C7, "gadgetdeactivate" },
    { 0xD2036119, "gadgetflickering" },
    { 0x76145BB7, "gadgetgetslot" },
    { 0x442C2E3D, "gadgethitpoints" },
    { 0x7620E707, "gadgetisactive" },
    { 0x63736F2E, "gadgetisready" },
    { 0x57988017, "gadgetnames" },
    { 0xEDF36E37, "gadgetnamestring" },
    { 0x0822AA28, "gadgetpowerchange" },
    { 0x5C93D934, "gadgetpowerget" },
    { 0x92A1048D, "gadgetpowerreset" },
    { 0xA0B29C50, "gadgetpowerset" },
    { 0xFEC92C59, "gadgetpulsegetowner" },
    { 0xA7643C4E, "gadgetpulseresetreveal" },
    { 0x9058CF48, "gadgetreadysoundplayer" },
    { 0x645F7522, "gadgetrouletteprobabilities" },
    { 0xDFD342DC, "gadgets" },
    { 0x87952054, "gadgets_print" },
    { 0x22A32106, "gadgets_save_power" },
    { 0x35A6B583, "gadgets_wait_for_death" },
    { 0x56806B7B, "gadgets_wait_for_game_end" },
    { 0xC6A94C5B, "gadgetsetactivatetime" },
    { 0x610FA17E, "gadgetsetentity" },
    { 0x692D71BC, "gadgetsetinfrared" },
    { 0x069E6CA8, "gadgetstatechange" },
    { 0x18959191, "gadgettargetresult" },
    { 0xA43862A5, "gadgetthiefactive" },
    { 0x22A1096A, "gadgetthiefarray" },
    { 0x5CC6569A, "gadgetthiefchargingslot" },
    { 0xBEB346FF, "gadgetthiefkillpowergain" },
    { 0xB5CACA08, "gadgetthiefkillpowergainwithoutmultiplier" },
    { 0xD8F2D6AA, "gadgetthiefshutdownfullcharge" },
    { 0x4E101858, "gadgetthieftimecharge" },
    { 0x94A008B6, "gadgetturretdeploy" },
    { 0xF0E5F885, "gadgetturretrecover" },
    { 0x99339CD5, "gadgettype" },
    { 0x5A7FFDE5, "gadgettype_e" },
    { 0xE7452659, "gadgetvisionpulse_reveal_func" },
    { 0xC83A8A9D, "gadgetweapon" },
    { 0x5ACD7C3C, "gag" },
    { 0x67478D04, "gagdget" },
    { 0x9FC9B220, "gagged" },
    { 0x7F0B0DFF, "gags" },
    { 0x456A6DB8, "gain" },
    { 0x276723CB, "gained" },
    { 0xED41F7A4, "gaines" },
    { 0xE38E0420, "gaining" },
    { 0x8FCBE713, "gains" },
    { 0xC7B54708, "gaintoadd" },
    { 0x9CC1182F, "gal" },
    { 0xC59402BD, "galaxy" },
    { 0xCD1A2BA9, "gallery" },
    { 0x8732048C, "gallop" },
    { 0x401785DC, "gallop_driving" },
    { 0xE5EC533C, "galloping" },
    { 0xA02645D6, "galloping_face_plant" },
    { 0x892358A0, "gallow_col" },
    { 0x35FB91D9, "galore" },
    { 0x76BE9DC6, "gam" },
    { 0x7E172AA9, "gambler" },
    { 0x4FED65D1, "gambler_crate_name" },
    { 0x3130DB5F, "game" },
    { 0xAB0230DA, "game_characters" },
    { 0x67462431, "game_end" },
    { 0xDC5C76EE, "game_end_func" },
    { 0xE394D1E9, "game_end_reset_if_not_achieved" },
    { 0xABB5F667, "game_end_time" },
    { 0x7C2866D3, "game_end_vox" },
    { 0xF6C1B57E, "game_ende" },
    { 0xC8AB51DE, "game_ended" },
    { 0x14FF4D7E, "game_introduction" },
    { 0x03FC2F2F, "game_mode" },
    { 0x7E94CA68, "game_mode_custom_onplayerdisconnect" },
    { 0x02F12283, "game_mode_group" },
    { 0x491B927E, "game_mode_objects" },
    { 0x4EB2F852, "game_mode_spawn_player_logic" },
    { 0xAD32F8FD, "game_mode_started" },
    { 0x3C323FA1, "game_mode_suffix" },
    { 0xF83F899E, "game_module" },
    { 0x3D7097BA, "game_module_classic_index" },
    { 0x732BA78D, "game_module_cleansed_index" },
    { 0x8D0B9EB2, "game_module_containment_index" },
    { 0xED1075E3, "game_module_custom_intermission" },
    { 0xD28FDA97, "game_module_ended" },
    { 0xA8CE5817, "game_module_grief_index" },
    { 0x1066962F, "game_module_index" },
    { 0xDF778617, "game_module_nml_index" },
    { 0xBCCCDA55, "game_module_onplayerconnect" },
    { 0xC83B1350, "game_module_player_damage_callback" },
    { 0xA23BFBE8, "game_module_player_damage_grief_callback" },
    { 0x23D0E449, "game_module_post_zombie_spawn_init" },
    { 0x899676D6, "game_module_pre_zombie_spawn_init" },
    { 0xCFFAFACB, "game_module_standard_index" },
    { 0xCE2C23B1, "game_module_team_name_override_og_x" },
    { 0xB8E6968C, "game_module_timer" },
    { 0x02E3F2DE, "game_module_turned_index" },
    { 0xFD9A9C1B, "game_objects_allowed" },
    { 0x5E155AC0, "game_objects_setup" },
    { 0x2FD0AE3C, "game_over" },
    { 0xBFF517DE, "game_over_bg" },
    { 0x686B12DA, "game_over_fog_and_vision_fix" },
    { 0x130CE0DE, "game_over_hud" },
    { 0x8763D432, "game_over_msg" },
    { 0x28990994, "game_over_msg2" },
    { 0x66457083, "game_rules" },
    { 0x2D407884, "game_saving" },
    { 0xC48B6DE7, "game_skippage_watcher" },
    { 0xC4F60B6A, "game_start_solo_vo" },
    { 0x8E462FFE, "game_start_time" },
    { 0xF9131C50, "game_start_vo" },
    { 0x8F64660B, "game_success" },
    { 0xB9E82EDE, "game_summary" },
    { 0x686C403A, "game_summary_ingame" },
    { 0xB98D4A71, "game_tutorial_go" },
    { 0xEE22A7C1, "game_tutorial_render_instructions" },
    { 0xDB1F154A, "game_type" },
    { 0x6C5446BF, "game_winner" },
    { 0xF048F2FA, "gameadvertisement" },
    { 0x43E8F690, "gameadvertisementruleround" },
    { 0xFAC2E979, "gameadvertisementruleroundswon" },
    { 0x71A3CA51, "gameadvertisementrulescorepercent" },
    { 0xAAD6B004, "gameadvertisementruletimeleft" },
    { 0xDA38C6FF, "gamedata" },
    { 0x2095ECA4, "gamedef" },
    { 0xE9B6CDD9, "gamedef_table" },
    { 0x01E34ED7, "gamedefs" },
    { 0xDECC2810, "gamedifficulty" },
    { 0x50F6F0DE, "gameend" },
    { 0x06B0D921, "gameended" },
    { 0x89024BF4, "gameendheliwaiter" },
    { 0x37B8DC91, "gameendtime" },
    { 0x1A838ABE, "gameendwatcher" },
    { 0x374DD4B5, "gameflag" },
    { 0x71945BE3, "gameforfeited" },
    { 0x02AFB638, "gamehasstarted" },
    { 0xED9310CB, "gamehistoryfinishmatch" },
    { 0x666632BB, "gamehistoryplayerkicked" },
    { 0x1EFFE5AF, "gamehistoryplayerquit" },
    { 0x0F9F33D2, "gamehistorystartmatch" },
    { 0x71859219, "gameisdraw" },
    { 0x2CBFF95D, "gameitems" },
    { 0xB0D9A04F, "gamelength" },
    { 0x390861BC, "gamelengthtime" },
    { 0x2F69E897, "gamemgr" },
    { 0xD6356E96, "gamemode" },
    { 0xA64A0CBA, "gamemode_basic_training" },
    { 0x831DC0FA, "gamemode_callback_setup" },
    { 0x699F7585, "gamemode_chosenclass" },
    { 0x08D4654C, "gamemode_common_setup" },
    { 0xFD19485C, "gamemode_league_match" },
    { 0x39AC887F, "gamemode_local_splitscreen" },
    { 0x7518F496, "gamemode_map_location_init" },
    { 0x68145CE7, "gamemode_map_location_main" },
    { 0x21431F5B, "gamemode_map_location_precache" },
    { 0x115BEBB4, "gamemode_map_location_premain" },
    { 0x3EEC5019, "gamemode_map_location_premain_func" },
    { 0xAC109B0F, "gamemode_map_main" },
    { 0x53346648, "gamemode_map_postinit" },
    { 0x599DACC3, "gamemode_map_precache" },
    { 0xC309816D, "gamemode_map_preinit" },
    { 0x0BBEFE90, "gamemode_match" },
    { 0x47F3A357, "gamemode_match_info" },
    { 0xDF283B60, "gamemode_post_spawn_logic" },
    { 0xDE30D3F0, "gamemode_private_match" },
    { 0x075E6590, "gamemode_public_match" },
    { 0x420E8A92, "gamemode_rts" },
    { 0x616EDF94, "gamemode_theater" },
    { 0x9586233F, "gamemode_wager_match" },
    { 0xFA2AD736, "gamemode_win_streak" },
    { 0x75C035A0, "gamemodecolumn" },
    { 0xE08AAB83, "gamemodeisarena" },
    { 0x53C31FE7, "gamemodeismode" },
    { 0xEE30D1D3, "gamemodeisusingstats" },
    { 0x234D763E, "gamemodeisusingxp" },
    { 0xCE151E6F, "gamemodeleaderboard" },
    { 0x2E4D787A, "gamemodeloadout" },
    { 0x19973438, "gamemodemodifyplayerdamage" },
    { 0x14B772E5, "gamemodemsg" },
    { 0xD15D5707, "gamemodespawndvars" },
    { 0x7E3D1D67, "gamemodule" },
    { 0x26C0CFDE, "gamemodules" },
    { 0xBAFAC07E, "gamemodulewinningteam" },
    { 0x8404DD52, "gamename" },
    { 0xE119970E, "gameobject" },
    { 0x646C835F, "gameobject_is_player_looking_at" },
    { 0xDAC81169, "gameobject_link" },
    { 0x266A02EA, "gameobjectlocations" },
    { 0x951DD4C2, "gameobjectnames" },
    { 0xA230C2B1, "gameobjects" },
    { 0x744539FE, "gameobjects_dropped" },
    { 0xA0A1716B, "gameobjects_shared" },
    { 0x8012D223, "gameobjswapping" },
    { 0xEC741909, "gameops_count" },
    { 0x3497A892, "gameops_description" },
    { 0x6F5BD0B7, "gameops_event_max_count" },
    { 0xD7CE1E25, "gameops_event_table_name" },
    { 0xE56F2A3D, "gameops_mode" },
    { 0xCA85DA85, "gameops_name" },
    { 0x0EDD0424, "gameops_pop_event" },
    { 0x32266B8D, "gameops_push_event" },
    { 0x61673A4C, "gameops_reset_event" },
    { 0x6A110B01, "gameops_reward" },
    { 0x8F3A4497, "gameops_time" },
    { 0x1DA937DD, "gameover" },
    { 0x78B054FC, "gameover_screen" },
    { 0x67893D0C, "gameover_snapshot" },
    { 0xA42945A1, "gamepadusedlast" },
    { 0x9B905619, "gameplay" },
    { 0xE49D5310, "gameplay_ambush" },
    { 0x8BF7071F, "gameplay_chuch" },
    { 0x43F10B13, "gameplay_fields" },
    { 0x50AD17D8, "gameplay_hijack" },
    { 0x7B46DCFB, "gameplay_junkyard1" },
    { 0x093F6DC0, "gameplay_junkyard2" },
    { 0x8216BA48, "gameplay_start" },
    { 0x39CECB3F, "gameplay_started_callback" },
    { 0x111EF5B7, "gameplaytrigger" },
    { 0xBC03D94F, "gamer" },
    { 0x29301E60, "gamerep" },
    { 0x437EA181, "gamerepanalyzeandreport" },
    { 0x9262B574, "gamerepinitializeparams" },
    { 0x8A39C0E0, "gamerepplayerconnected" },
    { 0xFD7B00CE, "gamerepplayerdisconnected" },
    { 0xC2A49C72, "gamerepprepareandreport" },
    { 0xC1C31328, "gamerepprepareandreportfilm" },
    { 0xF7B23602, "gamerepthresholdexceeded" },
    { 0xB1E1FD9C, "gamerepupdateinformationforround" },
    { 0x496AA952, "gamerepupdatenonpersistentplayerinformation" },
    { 0x1281701B, "gamerepupdatepersistentplayerinformation" },
    { 0x0E2BE394, "gameresultbookmark" },
    { 0x6F68FAFB, "gamerpicture" },
    { 0xE230059A, "gamerpictures" },
    { 0x96015EE6, "games" },
    { 0xBA4B48D2, "gameseg" },
    { 0x400BCBCC, "gameseg_completed" },
    { 0x6C41E242, "gameskill" },
    { 0xE997F0D6, "gameskill_shared" },
    { 0xA76DE5FA, "gameskillhighest" },
    { 0x57830DDC, "gameskilllowest" },
    { 0xDC15645B, "gamespeed_proc" },
    { 0xF82FF088, "gamespeed_reset" },
    { 0x6D8C329F, "gamespeed_reset_on_death" },
    { 0x2625C2C1, "gamespeed_set" },
    { 0x168ED7D8, "gamespeed_slowmo" },
    { 0x006706EA, "gamestarttime" },
    { 0x694F8FF5, "gamestat" },
    { 0x3EE3ED82, "gamestate" },
    { 0x2AC13BC4, "gamestats" },
    { 0x97CBB4C6, "gametimer" },
    { 0xBEFD5B2C, "gametweaks" },
    { 0x76C6E677, "gametype" },
    { 0xF15DAF2D, "gametype_death_streak" },
    { 0x45210D9B, "gametype_kill_streak" },
    { 0xD94C2CF5, "gametype_specific_battle_chatter" },
    { 0x82146F31, "gametype_tick_sound" },
    { 0x4167C878, "gametype_void" },
    { 0x6BBF5440, "gametype_win" },
    { 0x79C606E4, "gametypeactions" },
    { 0xBF0CF2F4, "gametypeevents" },
    { 0x7B25757A, "gametypefactor" },
    { 0x3934D5AE, "gametypes" },
    { 0xC570CA22, "gametypes_zm" },
    { 0x2B829C4E, "gametypespawnwaiter" },
    { 0x50CEE368, "gametypespecificbattlechatter" },
    { 0x60CC13EA, "gametypestable" },
    { 0x56416EE2, "gametypestarted" },
    { 0x676E08AD, "gametypevariantsonplayerconnect" },
    { 0xD8341A63, "gametypevariantsonplayerdisconnect" },
    { 0x95E501D3, "gametypevariantsthink" },
    { 0xE10A5DDC, "gamma" },
    { 0x5B4B4FA4, "gamplay" },
    { 0x13D7ADBE, "gangbangers" },
    { 0x7F361D27, "ganked" },
    { 0xCADB5F6C, "gantries" },
    { 0xDACA4690, "gantry" },
    { 0x4404426C, "gantry_1" },
    { 0x897CED93, "gantry_1_arm" },
    { 0xB60BB1A7, "gantry_2" },
    { 0xDA68D678, "gantry_2_arm" },
    { 0x8D35A3A6, "gantry_alarm" },
    { 0x91BBE133, "gantry_audio" },
    { 0x677D5FEC, "gantry_audio_intro" },
    { 0x10E153A4, "gantry_center" },
    { 0x25F8AEA8, "gantry_left" },
    { 0x322B7AE8, "gantry_reminder_thread" },
    { 0x38657F77, "gantry_right" },
    { 0xC2ACFD31, "gantry_steam" },
    { 0xA7FC7A1D, "gantt" },
    { 0xD4A35B43, "gap" },
    { 0xC4A003F9, "gap_reach_starts" },
    { 0x7E9250A8, "gap_reached" },
    { 0xB35DD205, "gapindex" },
    { 0x06F165B2, "gaps" },
    { 0x2415602E, "garage" },
    { 0x724342A5, "garage_all_door" },
    { 0x2B4415EE, "garage_breach_rumble" },
    { 0xE636F372, "garage_breachers" },
    { 0x71262448, "garage_checkpoint_trig" },
    { 0x7DDFC74B, "garage_cleanup" },
    { 0x567E9830, "garage_cleanup_ai" },
    { 0x74745E55, "garage_door" },
    { 0xA9E79960, "garage_door_open" },
    { 0x9E07AF86, "garage_doors_control" },
    { 0x291674B2, "garage_fps" },
    { 0xB71373C5, "garage_fps_done" },
    { 0x3813C80F, "garage_start" },
    { 0xB551D32E, "garage_waittill_goal_start" },
    { 0x31F5E1FB, "garage_worker_react" },
    { 0x921FBE34, "garand" },
    { 0x08B78E01, "garand_ammo" },
    { 0x832C2C6E, "garbage" },
    { 0x2EB73B76, "garden" },
    { 0x688FED41, "gargoyle" },
    { 0xECD966C1, "gargoyle_speaks" },
    { 0x4AD265B6, "gargoyle_watch_early_door_hit" },
    { 0x68FA0208, "garrote_stand" },
    { 0x4B7EB562, "gary" },
    { 0x629BEC08, "gas" },
    { 0xC99EB191, "gas1" },
    { 0xEFA12BFA, "gas2" },
    { 0x38453BF8, "gas_ai_think" },
    { 0x888A7F5E, "gas_ai_trig_entered" },
    { 0xB18F24A2, "gas_ai_trig_left" },
    { 0xCC5EED2B, "gas_amount" },
    { 0x3EB60F23, "gas_angles" },
    { 0xEB0EF47D, "gas_attach_head" },
    { 0x7699DD87, "gas_attack" },
    { 0x3EE73620, "gas_attack_audio" },
    { 0xE9D1D54C, "gas_attack_dialogue" },
    { 0xA6BC9DEA, "gas_attack_done" },
    { 0x107DA495, "gas_attack_enter_fog" },
    { 0x552E2F4F, "gas_attack_exit_fog" },
    { 0x40F5B7A6, "gas_attack_gas_death" },
    { 0x223C8EBB, "gas_attack_gas_house_death" },
    { 0x1F78744A, "gas_attack_objectives" },
    { 0x781CCF24, "gas_attack_rushers" },
    { 0xF6B06D72, "gas_attack_seagulls" },
    { 0x082A5E77, "gas_attack_start_fog" },
    { 0x79F8C867, "gas_attack_vignettes" },
    { 0x9E0E85BF, "gas_attack_weaver_btr" },
    { 0xE9876754, "gas_by_player" },
    { 0x28524F1D, "gas_canister_attach_trail" },
    { 0x1E5E5976, "gas_civs" },
    { 0xAE3D4B63, "gas_cough" },
    { 0x17281FE3, "gas_death_trigs" },
    { 0x435FB850, "gas_disable_btr" },
    { 0x870B94F7, "gas_emitter" },
    { 0x1331A064, "gas_end_door_l" },
    { 0x5768256A, "gas_end_door_r" },
    { 0xB2A7AF76, "gas_end_door_trig" },
    { 0xA183675C, "gas_enemy_detect_dist" },
    { 0xCC8B8754, "gas_engagement_max_dist" },
    { 0x50C92C06, "gas_engagement_min_dist" },
    { 0xA6F3D56E, "gas_ent" },
    { 0x44557AD1, "gas_explode_at_point" },
    { 0xA8B00599, "gas_explode_point" },
    { 0x6800A599, "gas_fog_transition" },
    { 0x5BAC7B87, "gas_grenade" },
    { 0xC54FC8DD, "gas_hazmat_allies_spawnfunc" },
    { 0xC7CDAC5B, "gas_hero" },
    { 0x3D41C83E, "gas_hero_cleanup" },
    { 0xF99D7B70, "gas_hiss_damage" },
    { 0xB971B4E8, "gas_hurt" },
    { 0x6FBEE74A, "gas_leak" },
    { 0xDAD937EE, "gas_leak_jumpto" },
    { 0x434B448B, "gas_mask" },
    { 0x270E2E4D, "gas_mask_model" },
    { 0x9886D04D, "gas_mask_off" },
    { 0x64353452, "gas_mask_remove" },
    { 0x298C7444, "gas_mask_weapon_lower" },
    { 0x56634F73, "gas_mask_weapon_raise" },
    { 0x24EBDE82, "gas_max_dist" },
    { 0x5430B313, "gas_max_height" },
    { 0x877A87B0, "gas_on" },
    { 0x9F4D289D, "gas_origin" },
    { 0xD2CA5BB3, "gas_player_safe_dist" },
    { 0x86204729, "gas_player_trig_entered" },
    { 0x367AE0DF, "gas_player_trig_left" },
    { 0xD0C40783, "gas_point" },
    { 0xBAF56F61, "gas_release_thread" },
    { 0x2BCB57EA, "gas_released" },
    { 0x09E86FDC, "gas_room_timer" },
    { 0xD465B4D2, "gas_rupture_failsafe" },
    { 0x80FFF612, "gas_rusher_spawnfunc" },
    { 0x6D5EF020, "gas_shader_on" },
    { 0x27A6364D, "gas_start" },
    { 0x5C708FF0, "gas_start_dist" },
    { 0x569FB2F9, "gas_start_door_l" },
    { 0x0A9ABE27, "gas_start_door_r" },
    { 0xB8C943F9, "gas_start_door_trig" },
    { 0x074E5481, "gas_start_height" },
    { 0xD15CC829, "gas_station" },
    { 0xED816001, "gas_station_collateral_damage" },
    { 0x71D01800, "gas_station_d" },
    { 0x5D97E3F2, "gas_station_death" },
    { 0xC075A4D1, "gas_station_trigger_think" },
    { 0xBC464DA0, "gas_struct" },
    { 0xF7560BEB, "gas_tank" },
    { 0x0D4F96CA, "gas_tanks" },
    { 0xEDF58D0F, "gas_tanks_counter" },
    { 0xF7B3572C, "gas_time" },
    { 0xA1DB77DA, "gas_trig_init" },
    { 0x5A1C61D4, "gas_trig_think" },
    { 0x514C16C8, "gas_trigs" },
    { 0xD31D3841, "gas_trigs_think" },
    { 0x41153028, "gas_vel" },
    { 0x5FBA445D, "gas_volume" },
    { 0x776E65F2, "gas_weaver_squad_spawnfunc" },
    { 0x7D550704, "gas_workers" },
    { 0x7ABFA676, "gasbuttonpressed" },
    { 0x538B431E, "gascan" },
    { 0xF3AE625C, "gascan_01" },
    { 0x65B5D197, "gascan_02" },
    { 0x3FB3572E, "gascan_03" },
    { 0x9C762F42, "gascan_drop" },
    { 0x2961449F, "gascan_start" },
    { 0x25392E64, "gascan_window_start" },
    { 0xCEB0F020, "gaseffectarea" },
    { 0xAD81E8F1, "gasguy_spawnfunction" },
    { 0x562C8310, "gasmask" },
    { 0x28D41431, "gasmask_activation_watcher_thread" },
    { 0x7DD87435, "gasmask_active" },
    { 0x4BE44715, "gasmask_audio_ent" },
    { 0x902BC56B, "gasmask_breathing" },
    { 0xDAED1AD5, "gasmask_change_player_headmodel" },
    { 0xDDA3E241, "gasmask_cleanup" },
    { 0x6AF10A60, "gasmask_debug_print" },
    { 0xB1382B0C, "gasmask_get_head_model" },
    { 0x50B31C9B, "gasmask_listener" },
    { 0x6B9C1326, "gasmask_off" },
    { 0xE32360A4, "gasmask_on_cracked_1" },
    { 0x552ACFDF, "gasmask_on_cracked_2" },
    { 0x2F285576, "gasmask_on_cracked_3" },
    { 0xD7EA20E3, "gasmask_on_player_connect" },
    { 0x67CFCEBB, "gasmask_on_pristine" },
    { 0x9CEE2510, "gasmask_overlay_handler" },
    { 0x0A86A16D, "gasmask_overlay_remove_handler" },
    { 0xF6363EB2, "gasmask_put_on" },
    { 0x7C6F1E8F, "gasmask_remove" },
    { 0x7CD9AA57, "gasmask_removed_watcher_thread" },
    { 0x27D7EB16, "gasmask_reset_player_model" },
    { 0x6C901E2E, "gasmask_reset_player_set_viewmodel" },
    { 0x7BBD1025, "gasmask_set_player_model" },
    { 0x7628A380, "gasmask_set_player_viewmodel" },
    { 0xFF8A9487, "gasmask_toggle" },
    { 0xFAD8F198, "gasmask_watch_buttonpress" },
    { 0xD3E2E395, "gasoline" },
    { 0x3E315ECC, "gasroom_dooropen" },
    { 0x60369E21, "gasroomtimerelem" },
    { 0x92F08F18, "gassed" },
    { 0xF24BFCBF, "gassed_civ" },
    { 0x1B8B0E58, "gasstationtrigger" },
    { 0x633080DA, "gastown_crash_civs" },
    { 0x2A97D7D1, "gastrap" },
    { 0x60DE06A5, "gastrap_a" },
    { 0x24C2B6FE, "gastrap_a_woods" },
    { 0x86E0810E, "gastrap_b" },
    { 0xC7898375, "gastrap_b_woods" },
    { 0x017B7B71, "gastrap_door_kick" },
    { 0x4A4D54C5, "gastrap_mantle" },
    { 0x025B73DE, "gastrap_mantle_woods" },
    { 0x40F8302A, "gastrap_mask_off" },
    { 0x06092F9D, "gasusage" },
    { 0x7D67C678, "gate" },
    { 0x91FF5153, "gate opened" },
    { 0xA83842C1, "gate1" },
    { 0x4CE1AFE2, "gate1_origin" },
    { 0xCE3ABD2A, "gate2" },
    { 0x32249404, "gate2_height" },
    { 0xF1CBC961, "gate_1_monsterclip" },
    { 0xBC6DE642, "gate_2_monsterclip" },
    { 0x603EAEBF, "gate_blocker" },
    { 0xDC41214A, "gate_blocker_uaz" },
    { 0x079EC43C, "gate_blowup" },
    { 0x3CC1DA31, "gate_clip" },
    { 0x29FDDFC1, "gate_clip2" },
    { 0xCDC850C0, "gate_closes" },
    { 0xB603F973, "gate_col" },
    { 0x5D13A1CD, "gate_collision" },
    { 0x944C07E7, "gate_docks_left" },
    { 0xA532D5E2, "gate_docks_right" },
    { 0x953F5B02, "gate_guard_a" },
    { 0x6F3CE099, "gate_guard_b" },
    { 0x36599E2B, "gate_guys" },
    { 0x309D2FF6, "gate_height" },
    { 0x4C1E6EE1, "gate_hold_loop" },
    { 0x25BD2134, "gate_iron_open" },
    { 0xC95458A0, "gate_is_locked" },
    { 0xBA45CA3D, "gate_kick" },
    { 0xA9609DC4, "gate_kick_start" },
    { 0x820187E1, "gate_l" },
    { 0x2D188F7E, "gate_l_clip" },
    { 0x1D749973, "gate_left_approach" },
    { 0x5F545C56, "gate_lock" },
    { 0x42F26119, "gate_locked" },
    { 0x90106D48, "gate_locked_start" },
    { 0x361D3ECF, "gate_long_barricade1a" },
    { 0xC415CF94, "gate_long_barricade1b" },
    { 0xAB3196B2, "gate_long_barricade2a" },
    { 0x852F1C49, "gate_long_barricade2b" },
    { 0x6ECF040C, "gate_move" },
    { 0xF44CF1FD, "gate_move_think" },
    { 0x5B30A65A, "gate_opens" },
    { 0xB3FD0040, "gate_orig" },
    { 0xA420483A, "gate_player_participation" },
    { 0xD5D4EC7F, "gate_r" },
    { 0xAF5A7CA8, "gate_r_clip" },
    { 0xFCB8CE52, "gate_right_approach" },
    { 0x28F58C70, "gate_right_push_forward" },
    { 0x55ECB4FF, "gate_right_reach" },
    { 0xA2AEE448, "gate_right_reach_trig_wait" },
    { 0x3E366653, "gate_roof_left" },
    { 0xE58468C6, "gate_roof_right" },
    { 0x14CDE88E, "gate_rotate" },
    { 0x5DAF1C48, "gate_sequence" },
    { 0x1A72159B, "gate_sequence_starting" },
    { 0x579A1A12, "gate_setup" },
    { 0xF8E35DB2, "gate_squad_advance_no_bmp" },
    { 0x9990C9DB, "gate_structs" },
    { 0x32F66DBB, "gate_swing" },
    { 0x77A3AD44, "gate_trigger_watcher" },
    { 0xFEEAC424, "gate_unlocked" },
    { 0xB3671F24, "gatebrushes" },
    { 0xF0975DAA, "gateclip" },
    { 0x3AB6A5AC, "gated" },
    { 0x6158A45F, "gatedownwait" },
    { 0x10C4DF5E, "gateflag" },
    { 0xC670E61C, "gatehouse_mgguy" },
    { 0xE1015450, "gateopen" },
    { 0x05236B25, "gatepull" },
    { 0x74DBD1D3, "gates" },
    { 0x490599F0, "gateupwait" },
    { 0x93AECF2C, "gather" },
    { 0x215848CC, "gather_countdown" },
    { 0xA4F703FC, "gather_delay" },
    { 0xF389CF35, "gather_floor_effect" },
    { 0x6780BFF4, "gather_hud_elem" },
    { 0x02577197, "gather_players" },
    { 0x3918DF88, "gather_position_offset" },
    { 0x2DD0106D, "gather_radius" },
    { 0xFFA2DD0F, "gathered" },
    { 0x2F2B830D, "gathered_hud_elem" },
    { 0xBB6C5809, "gatherer" },
    { 0xE144C15C, "gathering" },
    { 0x3AAE852F, "gathers" },
    { 0xE28D6210, "gatherspawnentities" },
    { 0xE45CCC70, "gatherspawnpoints" },
    { 0xB0CE19B9, "gating" },
    { 0x0B0B1902, "gauge" },
    { 0x9E9D8A4D, "gauges" },
    { 0xA3A0E7F7, "gauntlet" },
    { 0xBB7B06CC, "gauntlet_death" },
    { 0x0F22BDF6, "gauntlet_recover" },
    { 0x1D7DD44D, "gauntlet_upper_left_terrorists_cleanup" },
    { 0x99A7043D, "gauntlet_upper_left_terrorists_trigger" },
    { 0x9731E67D, "gauntlet_weapons" },
    { 0x05858548, "gaussian" },
    { 0x8038FA22, "gave" },
    { 0x885415C1, "gave_grenade" },
    { 0x96CE4C14, "gave_smoke_hint" },
    { 0xC9856534, "gavin" },
    { 0x67F2AC90, "gavinl" },
    { 0xA179ED67, "gawk" },
    { 0x6507BBB1, "gawk_behind_right" },
    { 0x7452E9F5, "gawk_front_left" },
    { 0x795FF2A5, "gawkers" },
    { 0xA594F739, "gawking" },
    { 0x588A9329, "gaz" },
    { 0x71041E2C, "gaz63" },
    { 0xA983783F, "gaz63_flatbed" },
    { 0x5C804A55, "gaz63_quad50" },
    { 0x46013C56, "gaz63_quad50_turret" },
    { 0x41312D0C, "gaz63_troops" },
    { 0x160D575F, "gaz63troops" },
    { 0xFEFCAEF1, "gaz66" },
    { 0xD878F872, "gaz_50cal1" },
    { 0xB2767E09, "gaz_50cal2" },
    { 0xE0A0D4D3, "gaz_alley_destroyed" },
    { 0xC230990E, "gaz_and_kamarov_fight" },
    { 0x348FF0F6, "gaz_animation" },
    { 0x27AB07DA, "gaz_attacker_logic" },
    { 0xA8614A50, "gaz_crash_brush" },
    { 0x0F73C63D, "gaz_crash_manager" },
    { 0x01CB0284, "gaz_door" },
    { 0x25C83DA5, "gaz_gate_destroyed" },
    { 0x36ED38C6, "gaz_go" },
    { 0xA1076575, "gaz_goes_to_cut_the_power" },
    { 0xF6BC6A34, "gaz_guys" },
    { 0x35F60DA4, "gaz_guys_death_monitor" },
    { 0x7012DCC5, "gaz_guys_init" },
    { 0x9AD90DB8, "gaz_guys_react" },
    { 0x560690AE, "gaz_guys_setup" },
    { 0xD3E1B6DE, "gaz_hut_node" },
    { 0xC5E865C8, "gaz_load_and_delete" },
    { 0x6E14390C, "gaz_meeting_org" },
    { 0x18594E70, "gaz_melee" },
    { 0xC3E6E8C4, "gaz_melee_failed" },
    { 0x7CF93190, "gaz_melee_main" },
    { 0x7D5F4B1B, "gaz_melee_xcam_skipto" },
    { 0xCB201740, "gaz_node" },
    { 0x1CDFD916, "gaz_opens_door_and_enters" },
    { 0x2FA4E403, "gaz_physics_launch" },
    { 0xB55B1D74, "gaz_rail_tether_logic" },
    { 0x833A2E69, "gaz_runs_by_window" },
    { 0xAA9E5B41, "gaz_sound" },
    { 0xF1A0E348, "gaz_spawner" },
    { 0xFB137A63, "gaz_spawners" },
    { 0x2BD92BA3, "gaz_talks_to_vip" },
    { 0xEDB93124, "gaz_teleport_node" },
    { 0xADE065EE, "gaz_teleports_upstairs" },
    { 0x9AC15F93, "gaz_tether_logic" },
    { 0x73FD94EC, "gaz_think" },
    { 0x1410A8FC, "gaz_tiger_interior" },
    { 0xBC8351A9, "gaz_tigers_go" },
    { 0xC7879A5D, "gaz_truck" },
    { 0x378CB131, "gaz_truck_delete" },
    { 0xC9699BBE, "gaz_truck_destroy" },
    { 0xE77844A3, "gaz_victim_fail" },
    { 0xB337AA8E, "gazcopy" },
    { 0x50E62199, "gazdist" },
    { 0xF76F922F, "gazdummy" },
    { 0xF87BF1E7, "gazebo" },
    { 0x3E70AA39, "gazebo_audio_loop" },
    { 0xBC555737, "gazebo_impacts" },
    { 0xF0539B1D, "gazorg" },
    { 0x5376766C, "gcm" },
    { 0x1DDE51F9, "gcm_active_message" },
    { 0x480585EB, "gd_table_fail_on_last" },
    { 0x84EE6903, "gd_table_game_scenario" },
    { 0x39029889, "gd_table_game_type" },
    { 0xDF10492F, "gd_table_hackable" },
    { 0x671E123F, "gd_table_item_param" },
    { 0xDA6114F7, "gd_table_num_objectives" },
    { 0x11BF2114, "gd_table_objstr" },
    { 0x38828CAA, "gd_table_objstr_3d" },
    { 0xB28973CB, "gd_table_scenario_index" },
    { 0x3FD8447F, "gd_table_time_limit" },
    { 0x434016D2, "gd_table_userdef_1" },
    { 0x1D3D9C69, "gd_table_userdef_2" },
    { 0xF73B2200, "gd_table_userdef_3" },
    { 0x014C7ADF, "gd_table_userdef_4" },
    { 0xDB4A0076, "gd_table_userdef_5" },
    { 0xB547860D, "gd_table_userdef_6" },
    { 0x8F450BA4, "gd_table_userdef_7" },
    { 0x99566483, "gd_table_userdef_8" },
    { 0xB2D710B6, "gd_table_wait_on_flag" },
    { 0xC3854FF9, "gd_table_wave_id" },
    { 0xF8105700, "gdt" },
    { 0xDC5A3B14, "gdt_update" },
    { 0x94D5F22B, "gdts" },
    { 0x908D758F, "ge0" },
    { 0x448880BD, "ge2" },
    { 0x3ECC46E0, "gear" },
    { 0xA4DC485D, "gear_alias" },
    { 0x71233305, "gear_change_time" },
    { 0xF11EBDA9, "gear_changed" },
    { 0xAE46DB4B, "gear_pitch" },
    { 0xE18A1F34, "gear_ratio" },
    { 0xA44C3C8A, "gear_setup" },
    { 0xB96762E3, "gear_speeds" },
    { 0xFF36888A, "gear_state" },
    { 0xDF8C9408, "gearchoices" },
    { 0xA98BB973, "geared" },
    { 0x2393C277, "gearmodel" },
    { 0x4E11F58B, "gears" },
    { 0x497A723B, "gearsets" },
    { 0xF3EFC331, "gearstatechanged" },
    { 0xC88A4EE6, "gearstuff" },
    { 0xF3E0D74E, "gearworks" },
    { 0xCCF58AC9, "gef" },
    { 0x490E52E3, "gel" },
    { 0x230BD87A, "gem" },
    { 0x261DD588, "gem_name" },
    { 0x04B4AC40, "gem_position" },
    { 0xA89CE290, "gem_start_pos" },
    { 0x5F2C59F5, "gems" },
    { 0xFD095E11, "gen" },
    { 0xF27D98CE, "gen_clip" },
    { 0x8FD746A6, "gen_loop" },
    { 0xA5CC1DCA, "gender" },
    { 0xF286613F, "general" },
    { 0x9037B101, "general_congrats_vo" },
    { 0x952F35DB, "general_debug_message" },
    { 0xA4B67DCC, "general_enemy_vo" },
    { 0xEDB46493, "general_help_vo" },
    { 0x4F7D22B8, "general_ram_vo" },
    { 0x544BD058, "general_seals" },
    { 0xFE19D897, "general_video" },
    { 0x39869CFF, "general_vignette_function" },
    { 0xCCCEADC7, "general_vignette_spawn_function" },
    { 0xFDBB21AB, "general_vox_timer" },
    { 0x981841B7, "generalize" },
    { 0xCCD63C51, "generalized" },
    { 0x418890E2, "generally" },
    { 0x4F048446, "generals" },
    { 0xEF3199C8, "generate" },
    { 0x50FA26A9, "generate_baseline_spawn_point_scores" },
    { 0xD436483E, "generate_box_points_lists" },
    { 0x4E3EDFDC, "generate_client_fx_log" },
    { 0x3A6AB2C6, "generate_colmaps_vehicles" },
    { 0xC87A4106, "generate_cone_points_lists" },
    { 0x01105F68, "generate_cylinder_points_list" },
    { 0x779C07DA, "generate_equipment_unitrigger" },
    { 0x29877F62, "generate_fx_log" },
    { 0xBDE57FCB, "generate_next_struct_angles" },
    { 0x036F06E1, "generate_offsets" },
    { 0xAED6C43D, "generate_patrollers" },
    { 0x66D7DD5F, "generate_piece" },
    { 0x56CE3D29, "generate_piece_makers" },
    { 0xDE125E20, "generate_piece_unitrigger" },
    { 0x028D3D2E, "generate_pill_points_lists" },
    { 0x4509D511, "generate_potential_enemy_soct_list" },
    { 0x06A352B8, "generate_sequence" },
    { 0xF1C57A23, "generate_shovel_unitrigger" },
    { 0x3BA3CC99, "generate_sphere_points_list" },
    { 0xEFC451F1, "generate_targetname" },
    { 0x4F958596, "generate_unrestricted_nixie_tube_solution" },
    { 0xA05055FE, "generate_weapon_data" },
    { 0x76F59AAF, "generate_zombie_buildable_piece" },
    { 0x5CF75FF1, "generate_zombie_craftable_piece" },
    { 0xDC4D708E, "generatebuildabletarps" },
    { 0x2C0CE6DC, "generated" },
    { 0xDCD93345, "generated_instances" },
    { 0x5E7ED06B, "generated_piece" },
    { 0xE1EAE506, "generated_radius_attract_positions" },
    { 0x0C3C997C, "generatelocations" },
    { 0xA36C4ADD, "generatepath" },
    { 0x1AE49514, "generatepathforaccuratedist" },
    { 0xFA64FA7E, "generateplane" },
    { 0xA972A8D5, "generatepointsaroundcenter" },
    { 0x9196B834, "generaterandompoints" },
    { 0xA5E2C5E3, "generates" },
    { 0x8684EAA3, "generatesquadname" },
    { 0x92887FC9, "generating" },
    { 0x4376A24F, "generation" },
    { 0xAE1EE0F4, "generator" },
    { 0x9AF9FA5C, "generator_angle" },
    { 0x647CA115, "generator_arc" },
    { 0x97124BD1, "generator_attack_cancel_think" },
    { 0xDCDD22AE, "generator_buildable_blinkout_time" },
    { 0x8C1457AF, "generator_buildable_full_power_time" },
    { 0x91033091, "generator_challenge_main_thread" },
    { 0x8ADF4F47, "generator_compromised_vo" },
    { 0x6BA1F314, "generator_cost" },
    { 0x47EB0CBC, "generator_damage" },
    { 0x7CCA847B, "generator_deactivated_vo" },
    { 0x9CCD585F, "generator_done" },
    { 0x5B2B85F0, "generator_initiated_vo" },
    { 0x31D88FAF, "generator_interrupted_vo" },
    { 0xB5904B7C, "generator_is_active" },
    { 0x095E55DF, "generator_lerp_done" },
    { 0xBC9B82D8, "generator_lights_on" },
    { 0x0DA7C115, "generator_loop" },
    { 0x9A2A3C08, "generator_move" },
    { 0x6826121A, "generator_off" },
    { 0xEB125670, "generator_oil_lamp_control" },
    { 0x4487A2E0, "generator_open_sesame" },
    { 0xA67BA216, "generator_panel_" },
    { 0xC3572715, "generator_panel_trigger_thread" },
    { 0xD696599F, "generator_power_states_color" },
    { 0x7B69FD5F, "generator_set_state" },
    { 0xF25CF6C0, "generator_sound" },
    { 0x62F1F64F, "generator_soundent" },
    { 0x12E0A3C4, "generator_state_off" },
    { 0xA5796577, "generator_state_power_down" },
    { 0xD6DF70A8, "generator_state_power_up" },
    { 0x897916BA, "generator_state_turn_off" },
    { 0x13C6336C, "generator_state_turn_on" },
    { 0x31E12954, "generator_struct" },
    { 0xA16405F3, "generator_trigger_prompt_and_visibility" },
    { 0x0AA7D2B4, "generator_turns_off_after_anim" },
    { 0x5E3742F6, "generator_under_attack_warnings" },
    { 0xE3AEDCAC, "generator_unitrigger_think" },
    { 0xE1473B00, "generator_zones" },
    { 0xE0CB35E7, "generators" },
    { 0x9F777290, "generic" },
    { 0x38AFD81A, "generic_allied" },
    { 0xA935EF63, "generic_anims" },
    { 0x699169F9, "generic_clue_index" },
    { 0xE35C60FB, "generic_combat" },
    { 0x2044863C, "generic_compass_hint_reminder" },
    { 0x426EC30D, "generic_dead" },
    { 0x5A7BBD20, "generic_double_strobe" },
    { 0x107E87E3, "generic_flickering" },
    { 0xDBBA7791, "generic_hint_dialogue" },
    { 0xC500C37C, "generic_hint_hint_lines" },
    { 0x351AB0F6, "generic_human" },
    { 0x5BEC7BB1, "generic_level_threads" },
    { 0x53D7C247, "generic_lines_amount" },
    { 0xF22707AE, "generic_marine1" },
    { 0xCC248D45, "generic_marine2" },
    { 0xDB89E1D7, "generic_nag" },
    { 0x54A98AED, "generic_pulses" },
    { 0x15EB8213, "generic_pulsing" },
    { 0xF8AFA7CC, "generic_rumble_explosion" },
    { 0x6F421D25, "generic_rumble_loop" },
    { 0xCDE258CC, "generic_shore_guys_function" },
    { 0x0182A03F, "generic_stage_complete" },
    { 0xCBDD7A61, "generic_stage_end" },
    { 0x6E1C2E3E, "generic_stage_end_func" },
    { 0xC1D310EA, "generic_stage_start" },
    { 0x89A4D66B, "generic_stage_start_func" },
    { 0x7C99D41A, "generic_style" },
    { 0x84B46697, "generic_style_init" },
    { 0x9725E4F4, "generic_style_setdamage" },
    { 0x1C2F0DE6, "generic_style_setquake" },
    { 0x3A6D9C9D, "generic_style_setradius" },
    { 0x6FF73B89, "generic_wake_up" },
    { 0x3047CF8A, "generically" },
    { 0x2AA4189D, "genericbaitcount" },
    { 0x0F4C74E0, "genericbulletkill" },
    { 0xC9890FFC, "genericfilterinitialized" },
    { 0x2032FCD8, "generichmg" },
    { 0x782B235D, "generickey" },
    { 0x1610F5BC, "genericlmg" },
    { 0xDD79E895, "genericpistol" },
    { 0x1E5C6203, "genericriflebolt" },
    { 0x9C2C264E, "genericriflesa" },
    { 0xC5CCD013, "genericsmg" },
    { 0x1C7B8CC1, "genericsniper" },
    { 0x776D0DFD, "geneva" },
    { 0xAF07F066, "genocide_audio" },
    { 0x3877B80B, "genocide_audio_trigger" },
    { 0x6E538B7D, "genric" },
    { 0x2975A126, "gentle" },
    { 0x1B5C7DD6, "gentlemen" },
    { 0xD706E3A8, "geo" },
    { 0x7E64CF7B, "geo_anims" },
    { 0x9AF249E9, "geo_arty_tarp" },
    { 0x0A05719E, "geo_changes" },
    { 0xD91C41CD, "geo_event1_door_collapse" },
    { 0xA398F206, "geo_event4_gates" },
    { 0x3B6A2BC6, "geo_event5_bunkerdoor" },
    { 0x65933FB9, "geo_guy_to_shed" },
    { 0x734D5573, "geo_hut1_collapse" },
    { 0xB8BC5A48, "geo_hut4_pieces" },
    { 0xE192EA14, "geo_intro_hut_light" },
    { 0x3D4AE1DE, "geo_off" },
    { 0x838A0F10, "geo_on" },
    { 0x67007512, "geo_tower_fall" },
    { 0xF3961B49, "geo_under_hut_collapse" },
    { 0x88B50778, "geodestroyedarray" },
    { 0x24D17734, "geointactarray" },
    { 0xAF555C54, "geometric" },
    { 0xFF8D1485, "geometry" },
    { 0xC8BAD7B0, "geoprefixes" },
    { 0x16DCEE7C, "geotrail" },
    { 0xCC991D3F, "geotrails" },
    { 0x604ABA63, "german" },
    { 0x91B987D3, "german_1" },
    { 0x1FB21898, "german_2" },
    { 0x45B49301, "german_3" },
    { 0x26267492, "german_names" },
    { 0x502B46C6, "german_outro_notetracks" },
    { 0x4F30A44C, "german_shepherd_attackidle" },
    { 0x3DEBA80D, "german_shepherd_attackidle_bark" },
    { 0xB64D7F02, "german_shepherd_attackidle_growl" },
    { 0x3F288B84, "german_soldiertype" },
    { 0x7D905652, "germans" },
    { 0x619F34C8, "germany" },
    { 0xE837371D, "germs" },
    { 0xC232AE1C, "gersh" },
    { 0xEF2CE18A, "gesture" },
    { 0x9C447B0A, "gesture0index" },
    { 0x5A633109, "gesture1index" },
    { 0x2EAD7A10, "gesture2index" },
    { 0x13E29B63, "gesture_closer" },
    { 0xDC863D31, "gesture_stop" },
    { 0xCB1878B7, "gesture_type_boast" },
    { 0xD49E3018, "gesture_type_good_game" },
    { 0x2547DF3E, "gesture_type_max" },
    { 0xF5CA7245, "gesture_type_threaten" },
    { 0x77C5FBFC, "gestureanimname" },
    { 0x27E17E90, "gesturefinished" },
    { 0x88BA1FC5, "gestures" },
    { 0xC3201EAC, "gesturesmodel" },
    { 0x584B58ED, "gesturestarted" },
    { 0xB8ED5F6A, "gesturetype" },
    { 0x7922262B, "get" },
    { 0x306DA0EE, "get2dyaw" },
    { 0x062D98B6, "get3dcinematictimeremaining" },
    { 0xF9440444, "get_2d_yaw" },
    { 0x393C0923, "get_2nd_last_vehicle_node_on_chain" },
    { 0xB1D2D7D9, "get_a_generic_friendly" },
    { 0x43C5E4E9, "get_a_target" },
    { 0x88026496, "get_abarbed_wire_ai" },
    { 0xB2B27DFD, "get_accuracy" },
    { 0x9639FB8B, "get_accuracy_result" },
    { 0x3942679B, "get_achievement" },
    { 0x7541B67D, "get_active_scene" },
    { 0xC1E1CB3C, "get_active_scenes" },
    { 0xD0D86F17, "get_active_vortex_count" },
    { 0x0E2232C4, "get_active_zone_names" },
    { 0x6D66AA0E, "get_active_zones_entities" },
    { 0x1A0B1441, "get_actor_count" },
    { 0x7FB0B698, "get_actual_craftablespawn" },
    { 0x8B2B97F4, "get_actual_uts_craftable" },
    { 0xD6E4BD69, "get_adjacencies_to_zone" },
    { 0x9C1446D7, "get_ahead_ent" },
    { 0x423EAE50, "get_ai" },
    { 0xB7DEE03A, "get_ai_array" },
    { 0xBBBABB8D, "get_ai_by_animname" },
    { 0xD8F60F10, "get_ai_class_for_weapon_drop" },
    { 0xE76DDADC, "get_ai_classname" },
    { 0x4A51687D, "get_ai_classtype" },
    { 0xE5F5F134, "get_ai_count" },
    { 0xE4F26B68, "get_ai_desc" },
    { 0x779AFC37, "get_ai_from_spawn_manager" },
    { 0x289E6FD1, "get_ai_group_ai" },
    { 0x1913DEC8, "get_ai_group_count" },
    { 0x041E09B9, "get_ai_group_sentient_count" },
    { 0x3F872959, "get_ai_group_spawner_count" },
    { 0x29843855, "get_ai_health" },
    { 0x39B8C242, "get_ai_in_area" },
    { 0x49D045B9, "get_ai_index" },
    { 0x967D6FDA, "get_ai_name" },
    { 0xF76A9328, "get_ai_number" },
    { 0x0969EC62, "get_ai_on_horse" },
    { 0x6162F8EF, "get_ai_ref_by_index" },
    { 0xAF605F48, "get_ai_struct" },
    { 0xC6733220, "get_ai_target" },
    { 0x189916CB, "get_ai_targets" },
    { 0x3AA9220A, "get_ai_threats" },
    { 0xCE06C1B8, "get_ai_touching" },
    { 0xFDD76ECD, "get_ai_touching_volume" },
    { 0x28FB6CBD, "get_ai_type_ref" },
    { 0x217C66CF, "get_ai_within_radius" },
    { 0xC3084716, "get_aianims" },
    { 0x54CD01E1, "get_aim_offset" },
    { 0xBCEA9293, "get_air_blast_range" },
    { 0x699E493B, "get_ais" },
    { 0x7DF4C50B, "get_ais_from_scene" },
    { 0xB2A7123A, "get_aispecies" },
    { 0xD924D3D8, "get_aispecies_array" },
    { 0xEDEAA1BF, "get_alert_level" },
    { 0x8651C3CD, "get_alias_from_stored" },
    { 0x635B76AB, "get_align_ent" },
    { 0x768D2C08, "get_align_pt" },
    { 0x82D19144, "get_align_tag" },
    { 0x5384417D, "get_alignment_object" },
    { 0x09888F2A, "get_alive_from_noteworthy" },
    { 0x8DCD2DB7, "get_alive_noteworthy_tanks" },
    { 0xFF62D224, "get_alive_players_on_meat_team" },
    { 0x4AC0DE5B, "get_all" },
    { 0x001EDBD8, "get_all_alive_players_s" },
    { 0xB8BBE7F3, "get_all_allied_and_enemy_players" },
    { 0x4219028B, "get_all_closest" },
    { 0x65666F24, "get_all_ents_in_chain" },
    { 0xBD7BED27, "get_all_farthest" },
    { 0x166A57A7, "get_all_force_color_friendlies" },
    { 0xDB719646, "get_all_heroes" },
    { 0x3DB055AF, "get_all_mine_locs" },
    { 0x375588A3, "get_all_other_players" },
    { 0xD15BCA28, "get_all_the_map_spawners" },
    { 0xF40AA672, "get_all_the_map_spawners_on_side" },
    { 0x2C27D22C, "get_all_threatbias_groups" },
    { 0xA93F58EF, "get_all_zone_zbarriers" },
    { 0x9018799D, "get_allied_color_team" },
    { 0x7A602290, "get_allies_by_color" },
    { 0x2C234992, "get_ally_name_string" },
    { 0x4A063D19, "get_ambiant_unused_nodes" },
    { 0x1424BDF6, "get_american_name" },
    { 0x8140243C, "get_ammo_cost" },
    { 0xFBEB3417, "get_ammo_cost_for_weapon" },
    { 0x99634EA1, "get_anim" },
    { 0xBD5B4C23, "get_anim_ent" },
    { 0x14CB10A5, "get_anim_name" },
    { 0x0F10033D, "get_anim_position" },
    { 0x55991A57, "get_anim_relative_start_time" },
    { 0xF908E317, "get_anim_string" },
    { 0x2DBF64C7, "get_anim_struct" },
    { 0xBF5A3026, "get_anim_struct_no_angles" },
    { 0x2B10FBDD, "get_anim_struct_no_angles_2" },
    { 0x85D13355, "get_animation_endings" },
    { 0x9176616F, "get_animtime_for_current_shot" },
    { 0x75F2450A, "get_animtime_for_current_shot_plus_curr_frames" },
    { 0xF486F935, "get_animtree" },
    { 0xB9F719EC, "get_any" },
    { 0x6D551A21, "get_armor_bullet_body" },
    { 0x7E3410AB, "get_armor_bullet_head" },
    { 0x530EEDBD, "get_armor_damage" },
    { 0x63941F1A, "get_armor_explosive_body" },
    { 0x006FB09C, "get_armor_explosive_head" },
    { 0x7FAF4C39, "get_array" },
    { 0xEA902447, "get_array_keys_in_order" },
    { 0x0190FD57, "get_array_of_closest" },
    { 0xD6D0DAF8, "get_array_of_closets_test" },
    { 0x18343CCB, "get_array_of_farthest" },
    { 0xE2C5F32D, "get_array_sorted_dot_prod" },
    { 0x784EE767, "get_array_spots" },
    { 0x33FEB2F5, "get_array_within_fov" },
    { 0xFF713E9A, "get_artyshake_speaker" },
    { 0xC560C3D4, "get_attachment_index" },
    { 0x2A15FB99, "get_attachment_name" },
    { 0xC4AB8694, "get_attachments_intersection" },
    { 0x965BE57E, "get_attack_anim" },
    { 0x0187ECDA, "get_attack_speed" },
    { 0x9CAEC431, "get_attack_spot" },
    { 0xAA5294E8, "get_attack_spot_index" },
    { 0xDB391B26, "get_attackable" },
    { 0x79E00D21, "get_attackable_slot" },
    { 0x6C10829B, "get_attacker" },
    { 0xF66A4AE0, "get_audiolog_vo" },
    { 0x3BEC8FD4, "get_available_fall_locations" },
    { 0x69562C41, "get_available_human" },
    { 0x36F1EA42, "get_available_items" },
    { 0x12C8A00D, "get_availablepositions" },
    { 0x5B414B12, "get_avg_center" },
    { 0x3039512C, "get_away_time" },
    { 0xFBF99F1E, "get_axis_in_volume" },
    { 0x96B5D2A5, "get_back_in_cockpit" },
    { 0x491DE213, "get_back_on_horse" },
    { 0x1C7C077E, "get_banned_attachment" },
    { 0x1430F822, "get_banzai_player_anim_length" },
    { 0xA0AF8736, "get_banzai_player_attacker_anim_length" },
    { 0x72524C50, "get_base_enemy_accuracy" },
    { 0x0FB6F85A, "get_base_fx" },
    { 0x4B3CD399, "get_base_name" },
    { 0xEB2F655C, "get_base_weapon" },
    { 0xE10A4F9E, "get_base_weapon_name" },
    { 0x2453CF4A, "get_base_weapon_param" },
    { 0xABA439F7, "get_baseweapon_for_attachment" },
    { 0x3010BF8A, "get_beartrap_targetname_from_scene_name" },
    { 0xA0A4C1F1, "get_behavior_attribute" },
    { 0x728357C0, "get_behavior_orient" },
    { 0x35A106E2, "get_best_area_attack_node" },
    { 0x186690F2, "get_best_available_colored_node" },
    { 0xC4DBD2F3, "get_best_available_new_colored_node" },
    { 0xFF8D15E3, "get_best_brutus_spawn_pos" },
    { 0x110E7C78, "get_best_drone_for_straffing" },
    { 0xF5977381, "get_best_entry" },
    { 0x4B02B46D, "get_best_flag" },
    { 0x0C154089, "get_best_flying_target_node" },
    { 0x30A64CED, "get_best_mechz_spawn_pos" },
    { 0x04BDC0F7, "get_best_poi_target" },
    { 0x253A828B, "get_best_spawn_point" },
    { 0x73ABEE32, "get_best_spawnpoint" },
    { 0x4134072B, "get_best_spline_node" },
    { 0x21BCBFC8, "get_best_taco" },
    { 0x1DB4E9BC, "get_best_vtol" },
    { 0xF714995A, "get_best_weighted_spawnpoint" },
    { 0x931FB7D6, "get_bestdrone" },
    { 0xA6135FC3, "get_bit_offset" },
    { 0x0B43FE8F, "get_blackholebomb_destination_point" },
    { 0xCA2EB485, "get_blade_clip" },
    { 0x32FDAA1E, "get_bleed_tags" },
    { 0xAD34A378, "get_blended_difficulty" },
    { 0x105EBBC7, "get_blockers" },
    { 0xE4029054, "get_blocking_point_closest_to_player" },
    { 0x079515DE, "get_bosses_ai" },
    { 0xBF2C2D1B, "get_bosses_nonai" },
    { 0x07A9265D, "get_bot_default_settings" },
    { 0x12CB2D73, "get_bot_settings" },
    { 0x459E3F9F, "get_bot_threats" },
    { 0x0D447E48, "get_branching_scene_label" },
    { 0x377AD5FD, "get_breakaway_path" },
    { 0xFA1C028F, "get_bridge_brutus_count" },
    { 0x33B31413, "get_bridge_brutuses" },
    { 0x36D5B487, "get_british_name" },
    { 0x05CA48B4, "get_brutus_interest_points" },
    { 0xA0D9F922, "get_brutus_spawn_pos_val" },
    { 0x732CA013, "get_build_trigger" },
    { 0xB6445006, "get_buildable_hint" },
    { 0xD94FCF81, "get_buildable_pickup" },
    { 0x3789DA4B, "get_buildable_stat_name" },
    { 0x963B86FA, "get_buildable_vo_name" },
    { 0xB41894FF, "get_bullet_gib_ref" },
    { 0xC983F0CE, "get_bundle" },
    { 0x45C6F51B, "get_bundle_for_ai" },
    { 0x3EC05698, "get_by_index" },
    { 0x204232BD, "get_by_menu_name" },
    { 0xC120F6A5, "get_by_name" },
    { 0x780C77F8, "get_by_script_animname_from_list" },
    { 0xABF31BF2, "get_camera_center_point" },
    { 0xD9E3FA21, "get_camera_launch_direction" },
    { 0x6B121B4F, "get_camera_tween" },
    { 0xAC4BB726, "get_camera_tween_out" },
    { 0x02D50FAF, "get_camo_index" },
    { 0x9D3DF6F2, "get_camo_index_for_camo" },
    { 0xEACB1DAD, "get_camo_name_for_index" },
    { 0xF983D1A0, "get_campaign" },
    { 0x128E094A, "get_campaign_state" },
    { 0xC5924DA3, "get_cansee_array" },
    { 0x8B444FCF, "get_canshoot_array" },
    { 0xEE4E0A21, "get_cantrace_array" },
    { 0xCD820C53, "get_cap_fx" },
    { 0x5FB09CA8, "get_capture_zombies_needed" },
    { 0x5A72A0E1, "get_captured_zone_count" },
    { 0x63001052, "get_capturing_flag" },
    { 0x77BDD074, "get_career_stats" },
    { 0x4FCBCB66, "get_carrier" },
    { 0xF9C17188, "get_catwalk_ally_victims" },
    { 0x5BBCB769, "get_center_of_array" },
    { 0x7B1CF471, "get_chained_structs" },
    { 0xBCD0079E, "get_challenge_by_type" },
    { 0xD3AB8551, "get_challenge_complete" },
    { 0xCC514C7E, "get_challenge_group_stat" },
    { 0x32A05852, "get_challenge_stat" },
    { 0x0CD593CF, "get_character" },
    { 0x7D59E996, "get_character_body" },
    { 0x87EC3132, "get_character_body_color" },
    { 0xA4A750BD, "get_character_body_colors" },
    { 0xBA2060C8, "get_character_head" },
    { 0xF9865C49, "get_character_helmet" },
    { 0x6ABAF171, "get_character_helmet_color" },
    { 0x227C64D8, "get_character_helmet_colors" },
    { 0xA98F523C, "get_character_line" },
    { 0x51D314DF, "get_character_mode" },
    { 0xE37BF19C, "get_character_showcase_weapon" },
    { 0xA32E3363, "get_checkpoint_times_for_track" },
    { 0x7D1AF378, "get_chest_index" },
    { 0xFC677805, "get_chest_pieces" },
    { 0x18595D02, "get_chopper_now" },
    { 0x0F9EA7EE, "get_chugabug_spawn_point_from_nodes" },
    { 0x41CB34B7, "get_chunk_state" },
    { 0xBBE9331E, "get_claim_team" },
    { 0x4D8D21D6, "get_claimed_attack_points_between_indicies" },
    { 0xEF003336, "get_class" },
    { 0x2330B21A, "get_class_accuracy" },
    { 0xBD2FDC1A, "get_class_armor" },
    { 0xDDABDF1B, "get_class_equipment" },
    { 0x00809D22, "get_class_grenade_ammo" },
    { 0xAB516D24, "get_class_grenades" },
    { 0x7169F733, "get_class_health" },
    { 0xEFBCE822, "get_class_icon" },
    { 0x4C51FAE7, "get_class_index" },
    { 0x181D1AB2, "get_class_killstreaks" },
    { 0x0FA39434, "get_class_perks" },
    { 0x58ECEF48, "get_class_ref" },
    { 0x3A801285, "get_class_ref_by_index" },
    { 0x502A4986, "get_class_speed" },
    { 0x37D20AA2, "get_class_struct" },
    { 0x7BB1E5BA, "get_class_weapon_clip" },
    { 0x71F09452, "get_class_weapon_stock" },
    { 0xF2A177A4, "get_class_weapons" },
    { 0xCDF2B402, "get_classtype_idx" },
    { 0xA6DC7F27, "get_cliff_face_pos" },
    { 0xB02C2D9B, "get_closest" },
    { 0x9469E2C4, "get_closest_2d" },
    { 0x171D8D00, "get_closest_ai" },
    { 0x017F1013, "get_closest_ai_exclude" },
    { 0xB5494B30, "get_closest_ally" },
    { 0xC292D5A9, "get_closest_attacker_with_missile_locked_on_to_me" },
    { 0x937D4935, "get_closest_axis" },
    { 0x03AEB26C, "get_closest_black_hole" },
    { 0x5D35326E, "get_closest_colored_friendly" },
    { 0xB316160B, "get_closest_covernode" },
    { 0x1C5EAC3D, "get_closest_document" },
    { 0xFE123DE4, "get_closest_doublewidenode" },
    { 0x89D9299E, "get_closest_element" },
    { 0x838C3A3A, "get_closest_enemy" },
    { 0x8754FEEE, "get_closest_enemy_emp_killstreak" },
    { 0xFEF65D3D, "get_closest_ent" },
    { 0x536D392A, "get_closest_ent_from_array" },
    { 0x8E1F65A4, "get_closest_exclude" },
    { 0xF5FD90C6, "get_closest_from_group" },
    { 0x1BDF1424, "get_closest_fx" },
    { 0x1DEFC872, "get_closest_index" },
    { 0x68C18107, "get_closest_index_2d" },
    { 0x7CE409DC, "get_closest_index_to_entity" },
    { 0xBBD304C7, "get_closest_killcam_entity" },
    { 0x8B0B8629, "get_closest_living" },
    { 0x088EB732, "get_closest_mechz_spawn_pos" },
    { 0xC4C3061F, "get_closest_mechz_tag_on_tank" },
    { 0xA578528A, "get_closest_node" },
    { 0xB69BAA55, "get_closest_non_destroyed_chunk" },
    { 0x48404313, "get_closest_objective_group" },
    { 0x4EDDD73B, "get_closest_pathnode" },
    { 0xFA8A28F1, "get_closest_player" },
    { 0xD7332A0E, "get_closest_player_ally" },
    { 0xD8006CF0, "get_closest_player_enemy" },
    { 0x71D7B81B, "get_closest_player_healthy" },
    { 0x41D2375A, "get_closest_player_to_richtofen" },
    { 0xEEBD2665, "get_closest_player_using_paths" },
    { 0xEF15FE0C, "get_closest_point" },
    { 0xAB2EFCC5, "get_closest_prisoners" },
    { 0x436740BE, "get_closest_tag" },
    { 0x1E17C9F4, "get_closest_team_door" },
    { 0xDD980265, "get_closest_to" },
    { 0x5E603FCA, "get_closest_to_me" },
    { 0x7636AF25, "get_closest_trap_for_brutus" },
    { 0x078965B5, "get_closest_unitrigger_index" },
    { 0x05A2CEEF, "get_closest_unitriggers" },
    { 0xA572C4B4, "get_closest_valid_player" },
    { 0xB780352B, "get_closest_valid_player_override" },
    { 0x8E2136BA, "get_closest_valid_tank_tag" },
    { 0x476F2C76, "get_closest_window_repair" },
    { 0xED19FAA2, "get_cluster_direction" },
    { 0x76928E98, "get_col" },
    { 0x61B337C2, "get_collision_chopper_in_position" },
    { 0xA738D3A3, "get_color_from_order" },
    { 0x8C344990, "get_color_fx" },
    { 0xD12D059E, "get_color_list" },
    { 0xEC095F6A, "get_color_spawner" },
    { 0x410F7F76, "get_colorcodes_and_activate_trigger" },
    { 0xD30CB8B3, "get_colorcodes_from_trigger" },
    { 0xC3E705B2, "get_commander_dialog_alias" },
    { 0xD2924C1E, "get_compasstypeformodel" },
    { 0xBC5289E5, "get_compasstypeforvehicletype" },
    { 0x84CB185B, "get_console_model" },
    { 0xFF29DAC6, "get_contested_zone_count" },
    { 0x5DBBB045, "get_contested_zones" },
    { 0xFC922F57, "get_context" },
    { 0x27F3BE5D, "get_contract_stat" },
    { 0x9D42EC99, "get_coop" },
    { 0x6979803C, "get_coop_enemy_accuracy_modifier" },
    { 0x242EA84E, "get_coop_enemy_pain_chance_modifier" },
    { 0xC29E1B7D, "get_coop_friendly_accuracy_modifier" },
    { 0x35C3FD5F, "get_coop_friendly_threat_bias_scalar" },
    { 0xE314B70D, "get_coop_hit_invulnerability_modifier" },
    { 0xD6A24E36, "get_coop_player_death_invulnerable_time_modifier" },
    { 0xC7E81340, "get_coop_player_health_modifier" },
    { 0x5955AB6C, "get_correct_model_array" },
    { 0xE14B398A, "get_correct_switch_node" },
    { 0xE8BB02B7, "get_correct_times" },
    { 0x195478AD, "get_countdown_hud" },
    { 0xBFF7D1DC, "get_craftable_hint" },
    { 0xB6DAC932, "get_craftable_model" },
    { 0x5F3F3E5B, "get_craftable_pickup" },
    { 0x94DE816B, "get_craftable_piece" },
    { 0x1F5D26ED, "get_craftable_piece_model" },
    { 0x2E12FF6D, "get_craftable_stat_name" },
    { 0x6DC79E38, "get_craftable_tables" },
    { 0xDFC0D988, "get_craftable_vo_name" },
    { 0xA2EC2607, "get_crosshair_radius" },
    { 0x961E63C3, "get_crumb_position" },
    { 0xD7FE0309, "get_crystal_from_script_int" },
    { 0x53617E1D, "get_cur_player_class" },
    { 0x788A3A0B, "get_curr_scene_name" },
    { 0xF5E9BDC1, "get_curr_target_threat" },
    { 0x8DCFC41F, "get_current_actor_count" },
    { 0xBEF7CCF4, "get_current_class" },
    { 0xF55FDA9C, "get_current_corpse_count" },
    { 0x3013200C, "get_current_foliage_trigger" },
    { 0xFD188096, "get_current_frozen_moment_params" },
    { 0xDDE455AD, "get_current_game_module" },
    { 0x3A154951, "get_current_ghost_count" },
    { 0xD2C733F0, "get_current_ghosts" },
    { 0x30F083DC, "get_current_raps_count" },
    { 0x276EE093, "get_current_round_score_limit" },
    { 0x4B5A00CB, "get_current_state" },
    { 0x22B5BB47, "get_current_track_time" },
    { 0x1DF77248, "get_current_turned_match" },
    { 0xACC1C531, "get_current_wasp_count" },
    { 0xCD600A16, "get_current_zombie_count" },
    { 0x009FC636, "get_current_zone" },
    { 0x0538D2DC, "get_curtain_anim" },
    { 0x7EF71AD3, "get_custom_damage_effect" },
    { 0x98A9F3BA, "get_custom_zombie_sound_play_frequency" },
    { 0x5EDE48B0, "get_damage_duration" },
    { 0x5DE415C0, "get_damage_fx_ent" },
    { 0x42FCAE3C, "get_damage_per_second" },
    { 0xF7814A24, "get_damage_trigger" },
    { 0x96F9D972, "get_damageable_ents" },
    { 0x9DEA3DA8, "get_death_anim" },
    { 0x64E84E6F, "get_death_type" },
    { 0x1F219452, "get_death_vox" },
    { 0xD2B117BC, "get_debug_ai_print" },
    { 0xB01AD95E, "get_debug_circle_color" },
    { 0x93F4A0E4, "get_debug_geometry_circular_segment_count" },
    { 0x0A13EB9B, "get_debug_spawnpoint" },
    { 0x8D6BCDA5, "get_debug_team" },
    { 0x26164C7D, "get_debug_timer" },
    { 0x23685D89, "get_decoy_spawn_loc" },
    { 0x933E7231, "get_default_fire_direction_weapon" },
    { 0x50A7DCD6, "get_default_head" },
    { 0x0564648A, "get_default_vehicle_name" },
    { 0x5B5C6CE4, "get_default_weapondata" },
    { 0x85DE1ACA, "get_delay_between_rounds" },
    { 0xFCC3282A, "get_delayed_position" },
    { 0x00DF748F, "get_deletegroups" },
    { 0x424D35F3, "get_designation" },
    { 0x76998135, "get_desired_origin" },
    { 0xA1E060A0, "get_destroyed_chunks" },
    { 0xBCB80409, "get_destroyed_chunks_without_grate" },
    { 0x7A7B4AC0, "get_destroyed_repair_grates" },
    { 0xDD7D05C7, "get_destruct_bundle" },
    { 0xF7BD04BE, "get_destruct_bundles" },
    { 0xE271C56D, "get_destruct_flag" },
    { 0xD2FCCD6C, "get_destruct_flags" },
    { 0x0FA21D28, "get_destructible_equipment_list" },
    { 0xF06D0F39, "get_destructible_index" },
    { 0xF08025D4, "get_dialog_bundle_alias" },
    { 0x1AEF1475, "get_difficulty" },
    { 0x1984AA7D, "get_difficulty_damage_modifier" },
    { 0xA2816C3B, "get_difficulty_scaled_health" },
    { 0x2C0DFFD8, "get_digits_from_score" },
    { 0x53047915, "get_direction" },
    { 0x5984E1DE, "get_direction_to_struct_after" },
    { 0x0D7ADB95, "get_dist_score" },
    { 0xFF2B5C3B, "get_dist_to_cliff_face" },
    { 0x8B8E58DE, "get_distance_for_weapon" },
    { 0x6E97CEC8, "get_distance_from_ent" },
    { 0x422F78D2, "get_distance_threat" },
    { 0x8EF7C9C4, "get_dog_count" },
    { 0xF4229065, "get_dog_health" },
    { 0x36A65B50, "get_dog_hits_before_kill" },
    { 0x489EC1C5, "get_dog_locations_in_zones" },
    { 0x8A1F9500, "get_dog_press_time" },
    { 0x8F91C850, "get_dog_quantity" },
    { 0xA025C21F, "get_dog_type" },
    { 0x884A8B8B, "get_dot" },
    { 0x8E06D9B5, "get_dot_direction" },
    { 0x454CC60D, "get_dot_forward" },
    { 0xB41D331C, "get_dot_from_eye" },
    { 0xA35F7D3C, "get_dot_production_2d" },
    { 0x35F4FA40, "get_dot_right" },
    { 0x6076976D, "get_dot_up" },
    { 0xE2991906, "get_dragon_enemy" },
    { 0xA3D3C254, "get_driver" },
    { 0xF217F180, "get_drone_model_array" },
    { 0x5F5C7AD7, "get_drone_spawn_pos" },
    { 0x8F95F9ED, "get_drone_spawn_trigger" },
    { 0xE34766DC, "get_drone_spawn_wait" },
    { 0x71251215, "get_drone_spotlight_detection_dot_tolerance" },
    { 0x0C2B3BE8, "get_drone_spotlight_frames_before_detection" },
    { 0x7F34D05F, "get_due_day" },
    { 0xB72F3726, "get_dummy" },
    { 0xD06DD46A, "get_dummy_character" },
    { 0xC930DF08, "get_dummy_character_array" },
    { 0x1E812545, "get_dummy_spawner_array" },
    { 0xA974BE09, "get_duration_of_structs" },
    { 0x751827B8, "get_dvar_float_default" },
    { 0x5BB757B5, "get_dvar_int_default" },
    { 0x9E1A208B, "get_dvar_string" },
    { 0xDAAE1556, "get_dvar_vec" },
    { 0x485C5858, "get_earliest_claim_player" },
    { 0x91C3DE6F, "get_easy_numbers" },
    { 0x3564B86A, "get_elapsed_time" },
    { 0x954EE39D, "get_emergence_hole_spawn_point" },
    { 0x66BD7319, "get_emp_grenade_damage" },
    { 0xD45BCE56, "get_empty_bunk" },
    { 0x22F478A2, "get_enemies" },
    { 0xC35210A8, "get_enemies_in_view" },
    { 0x90732DAE, "get_enemies_living" },
    { 0x367FDF4A, "get_enemy" },
    { 0x5176096B, "get_enemy_color_trigger" },
    { 0x9E9FF706, "get_enemy_count" },
    { 0xF8AE406C, "get_enemy_pain_chance" },
    { 0xEFBAE489, "get_enemy_players" },
    { 0xB37C6C7E, "get_enemy_team" },
    { 0xCA533271, "get_enemy_team_mask" },
    { 0x4F30F381, "get_engage_dists" },
    { 0x3983140D, "get_ent" },
    { 0xA2C485C7, "get_ent_array" },
    { 0x09004F74, "get_ent_index" },
    { 0x4E779701, "get_ent_with_key_from_array" },
    { 0x03DA2D8C, "get_ents" },
    { 0x55A9DD35, "get_ents_touching_trigger" },
    { 0x8911ADC9, "get_ents_within_dist" },
    { 0x6A00B9DB, "get_environment_exits" },
    { 0x6F1D0362, "get_equipment_hint" },
    { 0xC4677AB6, "get_equipment_howto_hint" },
    { 0x68EDAEC2, "get_equipment_icon" },
    { 0x3D5DD523, "get_equipped_hero_ability" },
    { 0x8CD09ADB, "get_escape_position" },
    { 0x4C2110D2, "get_escape_position_in_current_zone" },
    { 0x0C1D18BE, "get_estimated_due_date" },
    { 0x4CCF4660, "get_evac_org" },
    { 0x64A0A03C, "get_event1_pow_group" },
    { 0x8474C561, "get_event_override" },
    { 0xFE50D051, "get_event_ref_by_index" },
    { 0xAF9FE39B, "get_existing_ent" },
    { 0x6D75A1B4, "get_explosion_animation" },
    { 0x5D49E314, "get_explosion_death" },
    { 0x84C7F9F8, "get_explosion_death_dir" },
    { 0xA5639B4F, "get_explosion_death_dir_test" },
    { 0x4DA01D3A, "get_explosion_gib_ref" },
    { 0x02AE680D, "get_explosive_crossbow_pain" },
    { 0x7B095303, "get_explosive_crossbow_run_pain" },
    { 0x3C2F7BDD, "get_explosive_death_ai" },
    { 0x8A571602, "get_explosive_death_horse" },
    { 0xB320960A, "get_extended_death_seq" },
    { 0x2C8B0628, "get_extra_damage" },
    { 0xFBA4EBCD, "get_extracam" },
    { 0xBE287E39, "get_eye" },
    { 0x6B4BD44E, "get_eyeball_color" },
    { 0x28DED1D3, "get_eyeball_off_luminance" },
    { 0xD2A9F995, "get_eyeball_on_luminance" },
    { 0x06C4DC84, "get_f35_vtol" },
    { 0x20616934, "get_facing_barricade" },
    { 0xEF27182E, "get_fade_hud" },
    { 0x6E960C37, "get_fall_anim" },
    { 0x259F4792, "get_fall_death_anim" },
    { 0x6AE5CE6D, "get_fall_emerge_anim" },
    { 0x50224FAB, "get_far_boards" },
    { 0x8E7B4AB7, "get_farthest" },
    { 0xF90F2134, "get_farthest_available_zombie" },
    { 0xEFA8B4DE, "get_farthest_dog_location" },
    { 0x1335DC11, "get_farthest_wait_location" },
    { 0x5A23D5BB, "get_favorite_enemy" },
    { 0x1C9CEC18, "get_fire_direction_shooters" },
    { 0xBEBAF26A, "get_firefight_friendlies" },
    { 0x0A6A33C7, "get_firefight_friendlies_noplayer" },
    { 0x2C94DD28, "get_firepoint_target" },
    { 0x20944F99, "get_first_active_name" },
    { 0x385E37F8, "get_first_available" },
    { 0x7B598841, "get_first_coop_index" },
    { 0x97F8B80B, "get_first_valid_killstreak_alt_weapon" },
    { 0xDB0684DA, "get_flag_carry_model" },
    { 0x536CC94A, "get_flag_model" },
    { 0x1E796987, "get_flags" },
    { 0x827D3CFC, "get_flak_accuracy" },
    { 0x70FC6497, "get_flak_spot" },
    { 0xFACDD170, "get_flamethrower_crouch_pain" },
    { 0xB3A72613, "get_flamethrower_pain" },
    { 0xE5E70AC8, "get_flamethrower_stand_pain" },
    { 0xA3F896ED, "get_flamethrower_trigger" },
    { 0x60480416, "get_flattire_animation" },
    { 0x64B009F5, "get_floating_body_fx_origin" },
    { 0xA5AA1690, "get_fly_trigger" },
    { 0xB5416805, "get_fog_by_priority" },
    { 0x4F54CEEC, "get_force_attachments" },
    { 0xE731E36F, "get_force_color" },
    { 0xC285644A, "get_force_color_guys" },
    { 0xF52A6E5F, "get_forced_attachment" },
    { 0xF0314F6D, "get_forward" },
    { 0x3BDDD6CD, "get_free_ai" },
    { 0xD20EC9E5, "get_free_blocker_model_from_pool" },
    { 0xA2355239, "get_free_teleport_pos" },
    { 0x89C70B04, "get_freefall_volume" },
    { 0x9EC7D9F5, "get_friendly_by_color" },
    { 0x9E890150, "get_friendly_chain_node" },
    { 0x633D1B8C, "get_friendly_players" },
    { 0x3E135528, "get_friendly_team_mask" },
    { 0xDAEBA505, "get_friends" },
    { 0xB9D9A9A3, "get_friends_by_color" },
    { 0x73FA632C, "get_from_entity" },
    { 0x570EAD9C, "get_from_entity_target" },
    { 0x887199F1, "get_from_spawnstruct" },
    { 0xBCA8C69F, "get_from_spawnstruct_target" },
    { 0x9250D27A, "get_from_vehicle_node" },
    { 0xCFB16C31, "get_from_weapon" },
    { 0x473370EB, "get_fuel_trigger" },
    { 0x97E4070C, "get_func" },
    { 0xCA3D89CB, "get_furthest" },
    { 0x2696D9C2, "get_furthest_from_these" },
    { 0x8A4D7349, "get_furthest_offscreen" },
    { 0x86B0E854, "get_fx" },
    { 0x115E4AE3, "get_fx_bundle" },
    { 0x8DE9BAE2, "get_fx_character_bundles" },
    { 0x2841D093, "get_fx_options" },
    { 0x227BF24E, "get_fx_state" },
    { 0x828C8DD0, "get_gadget_name" },
    { 0x1BBADAAB, "get_gadget_recover_name" },
    { 0x4B791BE1, "get_gadget_weapon" },
    { 0xEE3C8D53, "get_game_mode_group_stat" },
    { 0x6592ECDF, "get_game_mode_stat" },
    { 0x41DD939F, "get_game_module" },
    { 0x92066064, "get_game_module_players" },
    { 0xECF6D352, "get_game_var" },
    { 0xD95C4E0F, "get_gamemode_var" },
    { 0x8B287992, "get_gametype_name" },
    { 0xDA43903D, "get_gascan" },
    { 0x2CE1039E, "get_gascan_two" },
    { 0x1EF3D569, "get_general_difficulty_level" },
    { 0x0D5BCCBF, "get_general_stat" },
    { 0x933A6645, "get_generator_capture_start_cost" },
    { 0x199EF94E, "get_generic_allies" },
    { 0x5E0D2DCE, "get_generic_ally_manifest" },
    { 0xA1545F3E, "get_generic_human_root" },
    { 0x7C93ACF7, "get_gib_bundle" },
    { 0xDA91512E, "get_gib_bundles" },
    { 0xD0FBC377, "get_gib_data" },
    { 0xC74EAD8C, "get_gib_def" },
    { 0xEA99838F, "get_gib_dir_bits" },
    { 0x03B9166C, "get_gib_extended_death_anims" },
    { 0x0A43187D, "get_gib_flag" },
    { 0x11A4FB4E, "get_gib_ref" },
    { 0x5592EBA8, "get_gib_ref_by_direction" },
    { 0x2024B4BE, "get_gib_scale_bits" },
    { 0x7AB362DB, "get_glaive_enemy" },
    { 0xF72AA954, "get_global_stat" },
    { 0x4536B4A7, "get_goal" },
    { 0x9797DD30, "get_goal_func" },
    { 0x7072ECDD, "get_gondola_doors_and_gates" },
    { 0xDD37A0F6, "get_gramophone_song" },
    { 0x7918CC79, "get_grapple_range" },
    { 0x9C78EBAE, "get_greatest_threat" },
    { 0x12E13271, "get_grenade_charge_power" },
    { 0x6F0BA36E, "get_group_threat" },
    { 0x8A2BBC69, "get_guard_points" },
    { 0x0D0CCB51, "get_guide_struct_angles" },
    { 0x10EDC230, "get_gump_info" },
    { 0xE8F788ED, "get_gun_then_go_to_color" },
    { 0x4255B548, "get_guy_at_node" },
    { 0x0150B788, "get_guy_with_script_noteworthy_from_spawner" },
    { 0x15F5DBDB, "get_guy_with_targetname_from_spawner" },
    { 0xC4EE0590, "get_guys_with_targetname_from_spawner" },
    { 0xD67EBACC, "get_hack_angles" },
    { 0xFCD5410E, "get_hack_fx" },
    { 0xE4C1703B, "get_hack_loop_fx" },
    { 0x6AF74FAA, "get_hack_pos" },
    { 0x2E4C583D, "get_hack_protection" },
    { 0x4BDA9BAE, "get_hack_scoreevent" },
    { 0x73A79EED, "get_hack_timeout" },
    { 0x5A20910C, "get_hack_tool_inner_radius" },
    { 0x7E69436D, "get_hack_tool_inner_time" },
    { 0x1B0D5003, "get_hack_tool_no_line_of_sight_time" },
    { 0xD8684DEB, "get_hack_tool_outer_radius" },
    { 0x2EACC046, "get_hack_tool_outer_time" },
    { 0x0C0B1504, "get_hackable_trigger" },
    { 0x5F2B7C13, "get_hacked_health" },
    { 0x5B1233B0, "get_hacked_timeout_duration_ms" },
    { 0x86897E09, "get_hardened_award" },
    { 0xE0397A22, "get_heading_of_object" },
    { 0xA7C2F2C3, "get_health_overlay_cutoff" },
    { 0x4F826843, "get_height" },
    { 0x44B32B11, "get_held_weapon_match_or_root_match" },
    { 0x595CC128, "get_heli_sound_ent" },
    { 0x719A06C4, "get_hero_ability_mask" },
    { 0x5E798BAC, "get_hero_by_name" },
    { 0x79FFA0D0, "get_hero_weapon_mask" },
    { 0xB269E456, "get_heroes" },
    { 0xEBFAE8EC, "get_heroes_by_name" },
    { 0xB98972F1, "get_hide_model_if_unavailable" },
    { 0xBD426152, "get_high_score_stat" },
    { 0xA018187E, "get_highest_dot" },
    { 0x205D4444, "get_highest_scoring_player" },
    { 0x5BD30BB5, "get_highest_weapon_usage" },
    { 0xF257827D, "get_hint" },
    { 0xA61845FB, "get_hint_string" },
    { 0x4BFFCAF8, "get_hologram_scalable_models" },
    { 0x0C093488, "get_horse_rider" },
    { 0x58EE8DB8, "get_horse_root" },
    { 0x3516E5C4, "get_host" },
    { 0xACC126DC, "get_host_player" },
    { 0xB6063908, "get_host_team" },
    { 0xF62D7A5E, "get_how_many_progressed_from" },
    { 0x14FEABA1, "get_howto_hint" },
    { 0x8C2EF15F, "get_hud_multi" },
    { 0x08321626, "get_hud_score" },
    { 0x98416EE9, "get_hudson_ent" },
    { 0xF30D345E, "get_ice_blast_range" },
    { 0x89B61B7D, "get_icon" },
    { 0xCF6EE244, "get_idle_anim" },
    { 0xEB39D703, "get_ied_damage_amount" },
    { 0x126A1B46, "get_if_top_killstreak_has_been_used" },
    { 0xB315110E, "get_ignoreme" },
    { 0x4B513520, "get_impact_damage" },
    { 0x5992195D, "get_impact_vol_from_speed" },
    { 0x230EADD7, "get_in" },
    { 0xAAC0C535, "get_in_heli_nag_vo" },
    { 0x7309A6CE, "get_in_vehicle" },
    { 0xC8617138, "get_inert_crawl_substate" },
    { 0x3C23FE88, "get_inert_substate" },
    { 0x2736E65B, "get_influencer_type_index" },
    { 0x33A2E4AE, "get_info" },
    { 0x99B231E5, "get_info_by_type" },
    { 0x210E75DF, "get_info_set" },
    { 0x2FCC4A32, "get_insta_kill_spawn_point_from_nodes" },
    { 0x9E93FB2A, "get_interact_offset" },
    { 0x60061206, "get_is_in_box" },
    { 0x5CD00B1B, "get_item_count" },
    { 0xB6D42EBA, "get_item_for_pickup" },
    { 0x3DCE388A, "get_item_from_string" },
    { 0x8C346133, "get_item_from_string_ammo" },
    { 0xAB940076, "get_item_from_string_damage" },
    { 0xCC19F46F, "get_item_from_string_health" },
    { 0x2512E951, "get_item_from_string_perk" },
    { 0xB3671109, "get_item_from_string_weapon" },
    { 0xB6628788, "get_item_health" },
    { 0x5CED335B, "get_item_name" },
    { 0xE8CF76EE, "get_jetgun_engine_direction" },
    { 0xC323EED7, "get_jumpon_target" },
    { 0x3C355857, "get_keep_weapons" },
    { 0xF43AC13A, "get_kill_fx_endon" },
    { 0x85908717, "get_killcam_entity" },
    { 0x0F2CA412, "get_killcam_entity_info" },
    { 0x048C3310, "get_killcam_entity_info_starttime" },
    { 0xBFC9A666, "get_killcam_entity_start_time" },
    { 0x22BDF8DF, "get_killstreak_for_weapon" },
    { 0xA81814EF, "get_killstreak_for_weapon_for_stats" },
    { 0x1E0678B1, "get_killstreak_index_by_id" },
    { 0x6C573877, "get_killstreak_inform_dialog" },
    { 0x56C93E0B, "get_killstreak_momentum_cost" },
    { 0x57D54214, "get_killstreak_quantity" },
    { 0xBD4E9E16, "get_killstreak_team_kill_penalty_scale" },
    { 0xC0494914, "get_killstreak_usage" },
    { 0xFDB8D155, "get_killstreak_usage_by_killstreak" },
    { 0x9D25749F, "get_killstreak_weapon" },
    { 0x5AF6FB71, "get_king_tiger_anim" },
    { 0x0D25CC1F, "get_kvp_from_tokens" },
    { 0x89391F48, "get_label" },
    { 0x08EBE8EE, "get_labelled_lights_in_radius" },
    { 0x2FEC7C43, "get_landmark_qualifier" },
    { 0x840DC583, "get_laser" },
    { 0x842263F0, "get_last_attacker" },
    { 0x2ABDDC78, "get_last_ent_in_chain" },
    { 0xD937B5A5, "get_last_model_from_part" },
    { 0x0747ACA4, "get_last_selected_ent" },
    { 0xB9F8A5A8, "get_last_selected_entity" },
    { 0x2529BDD1, "get_last_valid_position" },
    { 0x65A87788, "get_last_vehicle_node_on_chain" },
    { 0x3087C224, "get_launch_params_from_structs" },
    { 0x7E537A98, "get_least_used_from_array" },
    { 0xDC11916A, "get_least_used_index" },
    { 0xC461CA58, "get_leaving_sound_ent" },
    { 0xF2D71159, "get_left_behind_plea" },
    { 0xBEE48356, "get_left_behind_response" },
    { 0x1052BBD6, "get_left_hand_weapon_model_name" },
    { 0x3A9C9BAB, "get_leftstick" },
    { 0x822C6338, "get_lerp_duration" },
    { 0xA22095E3, "get_lerp_time" },
    { 0xE72F9013, "get_lethal_grenade" },
    { 0x6A8744ED, "get_letter_space" },
    { 0xC53B79F0, "get_level" },
    { 0x64E841BE, "get_level_ambient_fx" },
    { 0x8A73D79E, "get_level_completed" },
    { 0xFB404DA7, "get_level_era" },
    { 0x1A542281, "get_level_fx" },
    { 0xAEDE5019, "get_level_index" },
    { 0xF33F9CBA, "get_level_name" },
    { 0x69BA5096, "get_level_number_completed" },
    { 0x11BD4E7A, "get_level_skill" },
    { 0x55BEB7C6, "get_level_veteran_award" },
    { 0x724DDFB9, "get_levelstart_volume" },
    { 0xC05B38CE, "get_lightning_ball_damage_per_sec" },
    { 0xFA6FE615, "get_lightning_blast_range" },
    { 0xAC2087DD, "get_lights" },
    { 0x6426CA24, "get_lights_by_label" },
    { 0x669B9EE2, "get_lights_in_radius" },
    { 0x4AF9CB85, "get_limb_data" },
    { 0x71F5645F, "get_linear_destroyed_chunk" },
    { 0xAAFA0AE4, "get_link_entity_for_host_migration" },
    { 0x30A117E2, "get_linked_ents" },
    { 0x4B89DF48, "get_linked_node" },
    { 0x84D82E63, "get_linked_nodes" },
    { 0xF9884EEE, "get_linked_structs" },
    { 0x007361C0, "get_linked_trigger" },
    { 0x2736E4D1, "get_links" },
    { 0xFA369EDE, "get_lives_remaining" },
    { 0x132A9E19, "get_living" },
    { 0x67373B16, "get_living_ai" },
    { 0x4226481C, "get_living_ai_array" },
    { 0x6D808770, "get_living_aispecies" },
    { 0x3C55C91A, "get_living_aispecies_array" },
    { 0x1FDBD58B, "get_local_power_cost" },
    { 0xC95E41A1, "get_location_from_chest_index" },
    { 0x4564705D, "get_location_gametype_stat" },
    { 0xB8FF5C8F, "get_lock_hint_string" },
    { 0xB065324B, "get_lock_on_time" },
    { 0xC9149A61, "get_lock_sound_ent" },
    { 0x990D9271, "get_locked_difficulty_step_val" },
    { 0x829CBBF8, "get_locked_difficulty_val" },
    { 0x60EA154F, "get_locomotion_target" },
    { 0x5FDEF0CB, "get_logic_function_starting_index" },
    { 0x41990A66, "get_long_regen_time" },
    { 0x02C520D1, "get_lookat_origin" },
    { 0xF529455F, "get_loot_chance" },
    { 0xEF899EFC, "get_loot_desc" },
    { 0xA1A80226, "get_loot_name" },
    { 0x1FFC8772, "get_loot_param" },
    { 0x1106F1C9, "get_loot_rank" },
    { 0xB436177B, "get_loot_ref_by_index" },
    { 0x8DEF5913, "get_loot_type" },
    { 0x3E460F7A, "get_loot_version_by_index" },
    { 0xC7EFB400, "get_loot_versions" },
    { 0x24F9025E, "get_loot_wave_lock" },
    { 0x0FB53357, "get_loot_wave_unlock" },
    { 0xE40B0D5E, "get_los_penalty" },
    { 0xC9361324, "get_lost_line_of_sight_limit_msec" },
    { 0xAD5F691D, "get_low_health" },
    { 0x789D18E2, "get_lowest_skill" },
    { 0x4A792189, "get_magic_box_zbarrier_state" },
    { 0x78278A95, "get_magic_boxes" },
    { 0x00F1726B, "get_main_circular_path" },
    { 0x96938D71, "get_mantle_anim" },
    { 0x4E8BF0D1, "get_map_stat" },
    { 0x2D759C9C, "get_map_weaponlocker_stat" },
    { 0xB6EC114C, "get_master_key" },
    { 0xD351B9A9, "get_max_health" },
    { 0xF5841A8A, "get_max_value" },
    { 0x3873CA84, "get_melee_bundles" },
    { 0xA01A7777, "get_menu_name" },
    { 0x52DFEC0B, "get_min_ai_threshold" },
    { 0x0C2E732E, "get_min_pop_time" },
    { 0x985F8198, "get_min_value" },
    { 0xA1924AD7, "get_minigame_blocker_models" },
    { 0x85D8F505, "get_minigame_blocker_structs" },
    { 0xBE27B43F, "get_minigame_clip_brushes" },
    { 0xA2AB3D2F, "get_minigame_sloth_barriers" },
    { 0x7BB57CC3, "get_mirror_cam_offset" },
    { 0x702B3695, "get_miss_time_constant" },
    { 0x43C73456, "get_miss_time_distance_factor" },
    { 0x7DEAB2F2, "get_miss_time_reset_delay" },
    { 0xD087B36C, "get_mission_dvar" },
    { 0x6A133294, "get_mobility_body" },
    { 0x4C219CD6, "get_mobility_head" },
    { 0xBDA6F7E2, "get_mod" },
    { 0x641FC3C1, "get_mod_chance" },
    { 0x72475C49, "get_mod_type" },
    { 0x29D36BE4, "get_model_from_part" },
    { 0xD0593752, "get_model_or_models_from_scene" },
    { 0x6D891874, "get_month_number" },
    { 0xED0DAC44, "get_month_string" },
    { 0x1F528EF9, "get_most_threatening_object" },
    { 0xFDDC36A2, "get_muj" },
    { 0x84E7DCAF, "get_muj_ai" },
    { 0x0ECC3879, "get_my_groupname" },
    { 0x5FBAF9DB, "get_my_sm" },
    { 0xF6C4472B, "get_my_vehicleride" },
    { 0x4BCB2DA6, "get_mystery_box_from_script_noteworthy" },
    { 0x0E9E6C8B, "get_name" },
    { 0xF4CDD1A8, "get_name_for_nationality" },
    { 0xF486E6E9, "get_nav_points" },
    { 0x3A823AE4, "get_near_boards" },
    { 0x2B8DD45E, "get_nearby_banzai_guys" },
    { 0x7CDF707C, "get_nearest" },
    { 0x203D7BB8, "get_nearest_common" },
    { 0x9F01DD1A, "get_nearest_friend_within_speaking_distance" },
    { 0x97AD206D, "get_nearest_not_plr" },
    { 0x9F49A08D, "get_nearest_seam" },
    { 0x974B24A8, "get_nearest_squadmate" },
    { 0x06C2798C, "get_nearest_target" },
    { 0xD53DCDB7, "get_new_threat" },
    { 0x3481F08A, "get_next_compatible_attachment" },
    { 0x9F54C17D, "get_next_ent_with_same_id" },
    { 0xFA1DFE0D, "get_next_from_spectate_list" },
    { 0x27962B29, "get_next_obj_id" },
    { 0x19EB00D4, "get_next_powerup" },
    { 0x3EB32A89, "get_next_safehouse" },
    { 0x51EA7FE4, "get_next_spot_during_ghost_round_presentation" },
    { 0xABA9988F, "get_next_state" },
    { 0xD4B72975, "get_next_vo" },
    { 0xC37DC622, "get_node_funcs_based_on_target" },
    { 0x51E69F83, "get_node_index_from_node_array" },
    { 0x7F36B5B4, "get_non_destroyed_chunks" },
    { 0x0AD06258, "get_non_destroyed_chunks_grate" },
    { 0xDCB438A2, "get_non_destroyed_variant1" },
    { 0xB6B1BE39, "get_non_destroyed_variant2" },
    { 0x9AC09CAF, "get_non_destroyed_variant4" },
    { 0x74BE2246, "get_non_destroyed_variant5" },
    { 0x5218C147, "get_non_team_min_dist" },
    { 0x30934C61, "get_non_team_sum" },
    { 0x61853DAA, "get_nonalternate_weapon" },
    { 0x39F86E1F, "get_normal_anim_time" },
    { 0x813E6EF7, "get_normalized_camera_movement" },
    { 0xDFAE71D9, "get_normalized_dpad_movement" },
    { 0xC059A8F7, "get_normalized_movement" },
    { 0xBB648889, "get_normalized_speed" },
    { 0xBAE47110, "get_not_in_pain" },
    { 0x0115FC5A, "get_notify_strings" },
    { 0x20C7889B, "get_num_ai" },
    { 0xEE0D5485, "get_num_hinds" },
    { 0xB99F5B87, "get_num_horses_per_rpg" },
    { 0xFBEF781F, "get_num_priorityattackers" },
    { 0x62DB7C40, "get_num_territories_conquered" },
    { 0x49631106, "get_num_touching_except_team" },
    { 0x280A3281, "get_num_window_destroyed" },
    { 0x3893030D, "get_number_in_queue" },
    { 0x47CA390F, "get_number_of_valid_players" },
    { 0x25FA2662, "get_number_variants" },
    { 0x91C21610, "get_nums_from_origins" },
    { 0xA9FC89CD, "get_object_id" },
    { 0x8989C410, "get_objective_ids" },
    { 0xE17AB6DA, "get_objects" },
    { 0x34911376, "get_occupied_zones" },
    { 0x6D0DE531, "get_off_horse_at_end_of_path" },
    { 0xE89A0B9D, "get_off_inclinator" },
    { 0xA03A4445, "get_off_path" },
    { 0x744D02BD, "get_off_sam" },
    { 0xCB85BF16, "get_offset_angles" },
    { 0xEA32EE28, "get_offset_origin" },
    { 0xE55A5D84, "get_offset_scale" },
    { 0x66BA3103, "get_old_damage" },
    { 0xEDB3A94E, "get_on_and_go_path" },
    { 0xB6B0CA71, "get_on_path" },
    { 0x9F53022A, "get_on_plane" },
    { 0x880D6071, "get_on_sam" },
    { 0xFB4ACC90, "get_on_trigger" },
    { 0x805FDAFC, "get_operator_ent" },
    { 0x6CDCCA25, "get_opposite_side" },
    { 0x1A257835, "get_option" },
    { 0x90076459, "get_orig_name" },
    { 0xE7FDE41E, "get_origin_array" },
    { 0x9F9A2D2C, "get_other_team" },
    { 0xA791434C, "get_other_teams_alive_players_s" },
    { 0x0CFDE690, "get_other_teams_rounds_won" },
    { 0xDCA9DBA2, "get_out" },
    { 0xBC576D29, "get_out_override" },
    { 0xE4079C10, "get_outro_ai_target" },
    { 0x4878A4F1, "get_outside_range" },
    { 0x9E5184D0, "get_overloaded_func" },
    { 0x4A1421FD, "get_owner_team" },
    { 0x7DBAD239, "get_pacifist" },
    { 0x0011A37A, "get_pack_a_punch_camo_index" },
    { 0x8249C134, "get_pack_a_punch_weapon_options" },
    { 0x868C1B5A, "get_package_drop_target" },
    { 0xA59B698C, "get_packicon_offset" },
    { 0x709D39F9, "get_pap_zbarrier_state" },
    { 0xD3D4F77C, "get_parasite_enemy" },
    { 0x00F8184E, "get_parent" },
    { 0x0975D802, "get_parent_by_tagname" },
    { 0xEFEE8818, "get_path_from_array" },
    { 0xDC63FDE0, "get_path_getfunc" },
    { 0xA88DB63B, "get_path_length_to_enemy" },
    { 0xDAA96B3F, "get_pathpoints_start" },
    { 0xC9F97B11, "get_pathpoints_straight_strafe_bank_away" },
    { 0x9097C22B, "get_patrol_anims" },
    { 0xDFDF561D, "get_patrol_run_anims" },
    { 0x8D20286D, "get_pby_by_player" },
    { 0x65D77778, "get_perk_array" },
    { 0x6D502803, "get_perk_elevator" },
    { 0x5E5B8F49, "get_perk_machine_ents" },
    { 0x324DD0D7, "get_perk_machine_start_state" },
    { 0xF23E6C01, "get_perk_machine_trigger" },
    { 0xF97EDE7C, "get_perk_machine_trigger_from_vending_entity" },
    { 0x653866FB, "get_perk_machines" },
    { 0xD6015253, "get_perk_weapon_model" },
    { 0x07BA9EB9, "get_phase_time" },
    { 0x2FD4CD2A, "get_pickup_type_from_model" },
    { 0xDEA19606, "get_pilot_ent" },
    { 0x10D7DD7F, "get_pipes_in_range" },
    { 0x7F81E280, "get_pitch" },
    { 0x7A7431D9, "get_pivot_tether_distance" },
    { 0x8502C1DF, "get_pkg_ref_by_index" },
    { 0xE6F34A2E, "get_plane_ramps" },
    { 0xDD09E5A1, "get_player" },
    { 0xFBE7370C, "get_player_aim_pos" },
    { 0xA9CC4C74, "get_player_and_vehicle_array" },
    { 0x0B623584, "get_player_angles" },
    { 0xD14AD855, "get_player_back_to_base" },
    { 0xAB06AF15, "get_player_character_if_present" },
    { 0xA0F1C203, "get_player_closest_to" },
    { 0xC6A6F725, "get_player_controlled_zone_count_for_recapture" },
    { 0x613160EB, "get_player_cougar" },
    { 0xE4553EA9, "get_player_count" },
    { 0x5B6B62DB, "get_player_crossbow_weapon" },
    { 0x9D895340, "get_player_death_invulnerable_time" },
    { 0x502E5701, "get_player_dialog_alias" },
    { 0xF0299CBC, "get_player_difficulty_health" },
    { 0x55E5682D, "get_player_dog_neck_miss_anim" },
    { 0xD1D91F24, "get_player_equipment" },
    { 0xC3A00E1D, "get_player_feet_from_view" },
    { 0x95C90B8E, "get_player_general_location" },
    { 0xC127B241, "get_player_health_regular_regen_delay" },
    { 0x4BB1AD3D, "get_player_height" },
    { 0x2841B80F, "get_player_hero_weapon" },
    { 0x6C4EFA62, "get_player_hit_invuln_time" },
    { 0x39F2F63B, "get_player_horse" },
    { 0x36FB6288, "get_player_in_region" },
    { 0x9F412398, "get_player_index" },
    { 0x706DFFB0, "get_player_index_number" },
    { 0x121FFF60, "get_player_input" },
    { 0x47CE22BF, "get_player_knockdown_knob" },
    { 0xE8D849BE, "get_player_knockdown_late_knob" },
    { 0xF1B12C31, "get_player_lethal_grenade" },
    { 0xF620ADF1, "get_player_location" },
    { 0x171222C3, "get_player_melee_weapon" },
    { 0x336D41BB, "get_player_named" },
    { 0xCD822FA5, "get_player_off_horse" },
    { 0x3030D78D, "get_player_on_barge" },
    { 0x2412B7E9, "get_player_on_horse" },
    { 0xE0E4966E, "get_player_on_soc_t" },
    { 0x3EA8C538, "get_player_out_of_playable_area_monitor_wait_time" },
    { 0x1B7E7A33, "get_player_perk_list" },
    { 0xBE16A666, "get_player_perk_purchase_limit" },
    { 0xE00032D5, "get_player_placeable_mine" },
    { 0x28376B5E, "get_player_pressing_use_button" },
    { 0xF7A8E646, "get_player_rank" },
    { 0x0BAE705D, "get_player_rts_mode" },
    { 0x2F3243BE, "get_player_spawn_point" },
    { 0xCEDC5E08, "get_player_spawning_dvars" },
    { 0x1358A61D, "get_player_spawns_for_gametype" },
    { 0xC5CD182A, "get_player_stat" },
    { 0xD849B9D0, "get_player_tactical_grenade" },
    { 0x765DEBAC, "get_player_threat" },
    { 0x872F62F0, "get_player_threat_bias" },
    { 0x3D4A2521, "get_player_to_follow" },
    { 0x201BDF19, "get_player_too_many_weapons_monitor_wait_time" },
    { 0x79A1439F, "get_player_touching" },
    { 0x8E7FCE22, "get_player_touching_trigger" },
    { 0x8A67D1F9, "get_player_uimodel" },
    { 0xEA8EAC3C, "get_player_vehicle" },
    { 0x133E5170, "get_player_view_dog_knock_down_anim" },
    { 0x27303E59, "get_player_view_dog_knock_down_late_anim" },
    { 0x78DAD454, "get_player_weapon_limit" },
    { 0x18C769A4, "get_player_weapon_with_same_base" },
    { 0x8D71A0A8, "get_player_weapondata" },
    { 0x88F46E52, "get_player_with_meat" },
    { 0x684EC97E, "get_player_xp_difficulty_multiplier" },
    { 0xBFCC6CEE, "get_player_zone" },
    { 0x7A717FEB, "get_playerone" },
    { 0x84777F48, "get_players" },
    { 0x1B81BF72, "get_players_avg_origin" },
    { 0xB171F166, "get_players_healthy" },
    { 0xFE14B116, "get_players_in_basin_tanks" },
    { 0x49B12A2A, "get_players_in_bunker" },
    { 0xE9FD6B1E, "get_players_in_capture_zone" },
    { 0x858B7FFB, "get_players_in_zone" },
    { 0x41857E0D, "get_players_into_truck" },
    { 0x8942BCDA, "get_players_off_turrets" },
    { 0x9392B39A, "get_players_on_meat_team" },
    { 0x6E2BE6B3, "get_players_on_tank" },
    { 0x315AEC1C, "get_players_on_team" },
    { 0x865B9156, "get_players_out_of_tank" },
    { 0xDF3F8FBE, "get_players_pby" },
    { 0xDF2CF6EF, "get_players_playing" },
    { 0x9F848B18, "get_players_rival_or_ally" },
    { 0x9EE5346A, "get_players_too_far_to_hear" },
    { 0xC6B25CD0, "get_players_touching" },
    { 0x472977F9, "get_poi_ref_by_index" },
    { 0x396DE056, "get_poi_taken_pct" },
    { 0xD6010A27, "get_point_on_circle" },
    { 0xCEF90423, "get_points_multiplier" },
    { 0x2F66087D, "get_portable_mg_spot" },
    { 0x606CFB15, "get_pos_adjustments" },
    { 0x3C650F28, "get_pos_on_water" },
    { 0xF2133E87, "get_pos_on_water_level" },
    { 0x5A4C71E7, "get_position" },
    { 0x0751B21B, "get_positive_or_negative_suffix" },
    { 0x35A2E21C, "get_potential_melee_info" },
    { 0x42A6831F, "get_potential_targets" },
    { 0xF6245F3B, "get_power_stubs" },
    { 0x9B5760E0, "get_powered_item_cost" },
    { 0x1A9E255D, "get_powerups" },
    { 0xB50895D6, "get_pregame_class" },
    { 0x693B8AC5, "get_previous_ent_with_same_id" },
    { 0xFFA85D87, "get_previous_state" },
    { 0x531D1AFA, "get_primary_killcam_entity" },
    { 0xDE7B13FA, "get_prioritized_colorcoded_nodes" },
    { 0xD5E871CC, "get_priority_item_for_brutus" },
    { 0x60D56B87, "get_progress" },
    { 0x0A0B7B4C, "get_progress_rate" },
    { 0xD002F416, "get_prone_ent" },
    { 0x943B6531, "get_prop" },
    { 0xC9F6A699, "get_prop_count" },
    { 0x6AD4C73E, "get_punk_buster" },
    { 0x6C376BFC, "get_push_vector" },
    { 0xB01C7A23, "get_race_zombie_health" },
    { 0xC68A0933, "get_ragdoll_drones" },
    { 0x66884D97, "get_random" },
    { 0x82D8D01B, "get_random_ai_no_closer_than" },
    { 0x64D0D3F0, "get_random_ally_or_player" },
    { 0x0B5D0709, "get_random_ambient_drone" },
    { 0x4C2AEA64, "get_random_artillery_origins" },
    { 0xBA2CCD7A, "get_random_brutus_spawn_pos" },
    { 0xB2D3FFB3, "get_random_character" },
    { 0xBB86B402, "get_random_cleanup_wait_time" },
    { 0xE775AFE5, "get_random_destroyed_chunk" },
    { 0x96698097, "get_random_encounter_match" },
    { 0x58A1B741, "get_random_excluding" },
    { 0xA376EFD7, "get_random_from_spectate_list" },
    { 0x3812B585, "get_random_intermission_point" },
    { 0x73D1E677, "get_random_key" },
    { 0x200D35BF, "get_random_mine_location" },
    { 0xC838E139, "get_random_model" },
    { 0x524D8421, "get_random_mortar_origins" },
    { 0x94F25191, "get_random_non_destroyed_chunk" },
    { 0xEBBA8AE1, "get_random_phase_state" },
    { 0xB49B4F30, "get_random_pickup_location" },
    { 0xF17300AD, "get_random_pickup_type" },
    { 0x1695AEC5, "get_random_pilot_index" },
    { 0xD4B64A0D, "get_random_player" },
    { 0x29A2BEFC, "get_random_powerup_name" },
    { 0xEA3370FC, "get_random_prize_model" },
    { 0x2660F28F, "get_random_side" },
    { 0x57B84EF5, "get_random_speaker" },
    { 0xE1966260, "get_random_spot_in_player_view" },
    { 0xBDC2EF89, "get_random_vector_range" },
    { 0xCF347277, "get_random_weapon_by_class" },
    { 0x1B07F087, "get_random_weapon_with_attachments_by_class" },
    { 0xA478854F, "get_randomfriend" },
    { 0x0304E089, "get_randomfriend_excluding" },
    { 0x8E6DA669, "get_randomfriend_notsarge" },
    { 0x70E1BB5B, "get_randomfriend_notsarge_excluding" },
    { 0x38A8F7A3, "get_randomized_corpse_list" },
    { 0xF73507CE, "get_randomized_targets" },
    { 0xD948EFBD, "get_range" },
    { 0x66BB4851, "get_raps_spawn_total" },
    { 0x506B3702, "get_ready_gadget" },
    { 0x9ADCE54F, "get_ready_gun_gadget" },
    { 0xBABC2195, "get_ready_to_dodge" },
    { 0x16898891, "get_recapture_attacker_count" },
    { 0x1476FB23, "get_recapture_zombies_needed" },
    { 0x6B584EBA, "get_recapture_zone" },
    { 0xFE323248, "get_recent_stat" },
    { 0x4AC55AFC, "get_redact_length" },
    { 0xAD27D9D2, "get_ref_by_index" },
    { 0x57DA3B4E, "get_registered_meat_match" },
    { 0x6FD0B086, "get_registered_race" },
    { 0x1ED94F0D, "get_registered_turned_match" },
    { 0xE820FDC1, "get_regular_random_powerup_name" },
    { 0x14ED47B4, "get_relative_position_string" },
    { 0xC0FA17B2, "get_relative_team" },
    { 0x2485666C, "get_remaining_seconds" },
    { 0xE8F28D29, "get_replay_range" },
    { 0x30FCD9E2, "get_required_bot_counts" },
    { 0xA0AE5175, "get_reset_time" },
    { 0x680098E2, "get_response_chance" },
    { 0x8046647F, "get_restored_checkpoint_start_node" },
    { 0x15908133, "get_reticle_index" },
    { 0x0D72CAFB, "get_revive_time" },
    { 0x0B57F4CA, "get_reward_category" },
    { 0x696EE824, "get_reward_stat" },
    { 0xE0E61BDC, "get_reznov_into_tunnel" },
    { 0xAD4EC07A, "get_rider" },
    { 0xEEDC9D25, "get_rider_info" },
    { 0x465B29E0, "get_rightstick" },
    { 0x29679CE8, "get_riotshield_back_pos" },
    { 0x098DF407, "get_rise_anim" },
    { 0xF5728122, "get_rise_death_anim" },
    { 0x14F13661, "get_robot_bundle" },
    { 0x3DD5DA8E, "get_rocket_pod_fire_pos" },
    { 0x4C742502, "get_root" },
    { 0x686E6F31, "get_root_level" },
    { 0x8DD53CE2, "get_rotations_per_second" },
    { 0x105ADCD5, "get_round_enemy_array" },
    { 0xA4919CB9, "get_round_enemy_array_wrapper" },
    { 0x1FE8D3B2, "get_round_number" },
    { 0x3325E398, "get_round_switch_dialog" },
    { 0x6D50F6AD, "get_rounds_played" },
    { 0x6950200C, "get_rounds_won" },
    { 0x5E245A23, "get_rule_ref_by_index" },
    { 0x75975635, "get_rush_enemies" },
    { 0xD7A73F2D, "get_russian_name" },
    { 0x7AA645D0, "get_safe_breadcrumb_pos" },
    { 0x6BB25F49, "get_safehouse_position_struct" },
    { 0x83369705, "get_sam_forward" },
    { 0xBFC1A660, "get_sam_pos" },
    { 0x9B21F9FB, "get_scaled_steer_over_speed" },
    { 0xFD277BF3, "get_scaling_lock_cost" },
    { 0x4B86AABE, "get_scene_start_angles" },
    { 0xE1329FE4, "get_scene_start_pos" },
    { 0xC9D6049B, "get_scenedef" },
    { 0x5C74C6BA, "get_scenedefs" },
    { 0x5B632C55, "get_score_curve_index" },
    { 0x10582F80, "get_score_for_spawn" },
    { 0x054E8128, "get_score_string_from_digits" },
    { 0xB7AF54AE, "get_script_bundle" },
    { 0xF05CB807, "get_script_bundle_instances" },
    { 0x6409B8E5, "get_script_bundle_list" },
    { 0x9088DFD1, "get_script_bundles" },
    { 0x10500222, "get_script_bundles_of_type" },
    { 0xF5B5996A, "get_script_linkto_targets" },
    { 0x05A97B46, "get_script_modelvehicles" },
    { 0x8CC50016, "get_script_origin_by_noteworthy" },
    { 0x21ACA0F7, "get_script_palette" },
    { 0xB16AE01E, "get_seat_tag_position" },
    { 0x74ACD992, "get_secondary_killcam_entity" },
    { 0xDE7F54DB, "get_sector_center_point" },
    { 0x4481F33B, "get_segment_bytype" },
    { 0x6BEE136C, "get_selected_fx_indices" },
    { 0xDC98554B, "get_selected_move_vector" },
    { 0x115F78FF, "get_selected_option" },
    { 0x200C9855, "get_selection_alias_from_targetname" },
    { 0x2FFE0772, "get_self_ent" },
    { 0xF02617EC, "get_sentinel_drone_enemy" },
    { 0xAB641EE6, "get_sentinel_nearest_zombie" },
    { 0xACC1DCA3, "get_sequence_array" },
    { 0xC80DA111, "get_shared_ammo_weapon" },
    { 0x38AF9DC3, "get_shared_linkto" },
    { 0x686B23C9, "get_shot_specific_tail_override" },
    { 0x61D57769, "get_shot_to_death" },
    { 0x7BA02A96, "get_shots_to_kill" },
    { 0xAE1D93EE, "get_shoutcaster_fx" },
    { 0x048305AA, "get_show_emblem" },
    { 0xC9F6EA78, "get_show_paintshop" },
    { 0xBCFB8776, "get_show_payer_tag" },
    { 0x29449004, "get_shuffle_to_corner_start_anim" },
    { 0xADF7CE94, "get_sidequest_stage" },
    { 0x614FAD13, "get_skeleton" },
    { 0xD75E9BFD, "get_skill_from_index" },
    { 0x0B7CD2CD, "get_skinner_ai" },
    { 0xBAADA1BD, "get_skipto_names" },
    { 0x1E5A4206, "get_skydemon" },
    { 0x95BDD841, "get_slingshot_objective_offset" },
    { 0x8E89B257, "get_smallest_team" },
    { 0x3C191331, "get_smoke_grenades" },
    { 0xED152E7B, "get_smoothed_speed" },
    { 0x1F591D91, "get_snapped_spot_origin" },
    { 0x0222089A, "get_sorted_players" },
    { 0xC9E6D3D0, "get_sorted_skipto_spots" },
    { 0x96E8D453, "get_sorted_starts" },
    { 0x84D90DA4, "get_source_node" },
    { 0xF2378251, "get_soviet_ai" },
    { 0x1D528FC9, "get_spawn_manager_array" },
    { 0x7181571A, "get_spawn_node" },
    { 0x105D04BC, "get_spawner_target_nodes" },
    { 0x1D784F19, "get_spawners" },
    { 0x8AC59BBB, "get_spawners_and_spawn_group" },
    { 0xF7A2D9C3, "get_spawners_by_classname" },
    { 0xBDC32AE0, "get_spawners_by_targetname" },
    { 0x4E237DCC, "get_spawnmanager_spawn_count" },
    { 0x5880F755, "get_spawnpoint_array" },
    { 0xA1A08E8B, "get_spawnpoint_dm" },
    { 0xE87FFE7E, "get_spawnpoint_final" },
    { 0xA8B6AE24, "get_spawnpoint_near_team" },
    { 0x68EB5B1B, "get_spawnpoint_random" },
    { 0xB5A3A27A, "get_speaking_location_maxis_drone" },
    { 0x42615F90, "get_special_ai" },
    { 0xA6ACA67A, "get_special_ai_array" },
    { 0xF6E97840, "get_special_ai_quantity" },
    { 0x6DEE13E5, "get_special_ai_type_quantity" },
    { 0x833A45DE, "get_specialtydata" },
    { 0x3B7C2CEB, "get_specific_ai" },
    { 0xA157D632, "get_specific_character" },
    { 0x9641563A, "get_specific_player" },
    { 0xB45A4C02, "get_specific_single_ai" },
    { 0xFB62BCAF, "get_specific_stat" },
    { 0x62D8DBFF, "get_specific_vehicle" },
    { 0xE9E4FC6F, "get_speed" },
    { 0x574BF432, "get_split_number" },
    { 0x6A47A2CE, "get_splitscreen_team" },
    { 0x1DAF8AE6, "get_sprint_cooldown" },
    { 0x6C0045C9, "get_sprint_duration" },
    { 0x64F27E83, "get_sq_stages_in_order" },
    { 0xFA329DBE, "get_squad_array" },
    { 0x3D58D4EB, "get_squad_type" },
    { 0xBB1D0449, "get_squadmates_inside" },
    { 0xC5877CA7, "get_square_points" },
    { 0x9CC411FA, "get_staff_info_from_element_index" },
    { 0x09B485A9, "get_staff_info_from_weapon_name" },
    { 0xA3FFA665, "get_stair_count" },
    { 0xF506DEC4, "get_start_points" },
    { 0x221925F0, "get_start_state" },
    { 0x483FA8CA, "get_start_time" },
    { 0xE107C92B, "get_starting_ammo" },
    { 0xB4F8C6F5, "get_starting_guys" },
    { 0xCED9CC28, "get_stat" },
    { 0x524763B5, "get_stat_combined_rank_value" },
    { 0x54809195, "get_stat_combined_rank_value_grief" },
    { 0xE39193AF, "get_stat_combined_rank_value_survival_classic" },
    { 0x556FA6FE, "get_stat_distance_traveled" },
    { 0x49D34012, "get_stat_dvar_name" },
    { 0x7CED7626, "get_stat_dvarfloat" },
    { 0xDB80B6A7, "get_stat_round_number" },
    { 0xE5413C9E, "get_stat_value" },
    { 0x47381425, "get_state" },
    { 0xD4AD8DC0, "get_state_callbacks" },
    { 0x9B0B78C3, "get_stats" },
    { 0xF4A85CB3, "get_stats_for_track" },
    { 0x092C50E9, "get_status_quote" },
    { 0x095A742C, "get_step_announce_vox" },
    { 0xBAF033ED, "get_stepped_difficulty" },
    { 0x32D8F367, "get_stinger_target_override" },
    { 0x0AA06422, "get_stop_watch" },
    { 0x60A5A63A, "get_stored_weapondata" },
    { 0xC63E83FE, "get_story_stat" },
    { 0xABD22102, "get_streak_hud" },
    { 0x0CE5AE69, "get_strikeforce_available_level_list" },
    { 0x23684E67, "get_strikeforce_tokens_remaining" },
    { 0x55505BC1, "get_string" },
    { 0xF5B4071D, "get_string_for_skiptos" },
    { 0x5BE3A883, "get_string_for_starts" },
    { 0x13A5941D, "get_strong_target" },
    { 0x1C318CE5, "get_struct" },
    { 0x34C94B3F, "get_struct_array" },
    { 0xF9CE5121, "get_struct_by_number" },
    { 0x41C91B70, "get_suppress_point" },
    { 0x47D3D5BC, "get_surface_fx" },
    { 0xA8F1B19D, "get_survival_stat" },
    { 0x092CAECF, "get_swimming_depth" },
    { 0xE1904220, "get_table_var" },
    { 0x36F8A3CC, "get_tag_for_damage_location" },
    { 0x355F32F3, "get_tag_from_part" },
    { 0xCAA6E21E, "get_talker_func" },
    { 0xF40A96B2, "get_tank_anim" },
    { 0x0F6723B9, "get_target" },
    { 0x7A614BFA, "get_target_bread_crumb" },
    { 0xEA2B979A, "get_target_ents" },
    { 0x76138B46, "get_target_func" },
    { 0x68F3A11B, "get_target_id" },
    { 0x9A6421F8, "get_target_lock_on_origin" },
    { 0x4020E4BB, "get_target_nodes" },
    { 0x461AEEBA, "get_target_score" },
    { 0xDB8154C6, "get_target_structs" },
    { 0x3FB56153, "get_target_type_score" },
    { 0x52E46950, "get_target_vertical_offset" },
    { 0xB3049D27, "get_targetable_player_count" },
    { 0x86AEA5D3, "get_targeted_ai" },
    { 0xEFFBC7FD, "get_targeted_structs" },
    { 0x276B5AF0, "get_targets" },
    { 0x6E86D040, "get_targets_in_range" },
    { 0xEAB45329, "get_team" },
    { 0xC664826A, "get_team_alive_players_s" },
    { 0x8FC8CD86, "get_team_color_fx" },
    { 0x0F055EE3, "get_team_color_id" },
    { 0x95816A7C, "get_team_mask" },
    { 0x7872332D, "get_team_players_in_laststand" },
    { 0x7F4A71B0, "get_team_spawnpoints" },
    { 0x4869A1EB, "get_team_substr" },
    { 0x05E706B2, "get_tear_anim" },
    { 0xD1218914, "get_tear_anim2" },
    { 0x61FCE955, "get_teleport_fx_from_enum" },
    { 0x26330297, "get_teleporter_dest_ent_name" },
    { 0x0CAD30BB, "get_teleporter_target_positions" },
    { 0xE43F3FB5, "get_temp_stat" },
    { 0xEB9E272A, "get_the_player_up_drone_vo" },
    { 0x5830F74C, "get_there" },
    { 0x13BD5A52, "get_threat" },
    { 0x20513B0D, "get_threat_goal_radius" },
    { 0x7F890F7A, "get_throttle_effect" },
    { 0xB2153288, "get_throttle_position" },
    { 0xCEAD22D0, "get_throw_velocity" },
    { 0x85B998C7, "get_thrown_beacon" },
    { 0x03C6AA7C, "get_thrown_black_hole_bomb" },
    { 0xD8BB007C, "get_thrown_monkey" },
    { 0x09E041FE, "get_thrown_octobomb" },
    { 0x64F31FF1, "get_thrown_quantum_bomb" },
    { 0xC1A32FB9, "get_time" },
    { 0xE7D85094, "get_time_bomb_saved_round_type" },
    { 0xA7F89606, "get_time_delta" },
    { 0xD7A03114, "get_time_frac" },
    { 0xD655BD13, "get_time_in_seconds" },
    { 0xABC2CFCF, "get_time_left" },
    { 0x26EBEE10, "get_time_remaining" },
    { 0xC6F593E0, "get_time_remaining_in_seconds" },
    { 0x37ACC08C, "get_time_required_to_avoid_bus" },
    { 0xD734BDAF, "get_timer_hud" },
    { 0xC34CCBF1, "get_to_boat_display" },
    { 0xBE26D18F, "get_to_bunker" },
    { 0x773EEE61, "get_to_log_fail" },
    { 0x0785B76C, "get_to_node" },
    { 0xCD8B37D7, "get_to_node_no_matter_what" },
    { 0xEFC4A577, "get_to_player" },
    { 0x9E7CA5DE, "get_to_sam_exploders" },
    { 0xE65BDD7F, "get_to_sam_magic_bullets" },
    { 0x4B2825B5, "get_to_sam_magic_bullets_player" },
    { 0x989D5DCB, "get_to_sam_straffing_runs" },
    { 0x69748B5D, "get_to_the_back" },
    { 0x8DC99CC9, "get_to_the_car_nag" },
    { 0xD8768168, "get_top_killstreak" },
    { 0x83732122, "get_top_killstreak_unique_id" },
    { 0x70F1FE07, "get_top_scores_stats" },
    { 0x4B9BEC2D, "get_total_enemies" },
    { 0x80FC3571, "get_touching" },
    { 0x44C19F8F, "get_transition_in" },
    { 0x25136496, "get_transport_startloc" },
    { 0x8F56DF79, "get_trap_array" },
    { 0x639D57E0, "get_trap_light_name" },
    { 0xC98FCDD8, "get_trap_score" },
    { 0x628C134A, "get_traps" },
    { 0x5E37734C, "get_traverse_disconnect_brush" },
    { 0x7137C4CD, "get_trigger_eq_nums" },
    { 0xC8E21C5B, "get_trigger_flag" },
    { 0x3C832EDD, "get_trigger_for_craftable" },
    { 0x22715AC8, "get_trigger_height" },
    { 0x3713B134, "get_trigger_look_target" },
    { 0xCF3A14EF, "get_trigger_radius" },
    { 0x77D33DA8, "get_trigger_targs" },
    { 0xF925B7B9, "get_triggers" },
    { 0xACE94B43, "get_true_vehicle" },
    { 0x9E7804FC, "get_turn_angle_delta" },
    { 0x663D315C, "get_turret_anim" },
    { 0x8A533C43, "get_turret_node" },
    { 0xC704CA7B, "get_turret_parent" },
    { 0x69827E02, "get_turret_setup_anim" },
    { 0x358007B4, "get_turret_target" },
    { 0xFFCE94C8, "get_turret_team" },
    { 0x4BE9DA22, "get_turret_user" },
    { 0x18AB98F7, "get_turret_weapon_name" },
    { 0x33535779, "get_tv_breacher" },
    { 0x6F9DDA36, "get_type" },
    { 0x01EADB62, "get_unclaimed_attack_point" },
    { 0x4E6E564F, "get_unclaimed_attack_points_between_indicies" },
    { 0x00993D56, "get_unused_bonus_ent" },
    { 0x106A64CA, "get_unused_bonus_ent_count" },
    { 0xA894E3D9, "get_unused_crash_locations" },
    { 0x8A07F36C, "get_unused_emergence_hole_spawn_point" },
    { 0xAEEE3204, "get_unused_explosion" },
    { 0xE479D768, "get_unused_stink_ent" },
    { 0x496E7AFC, "get_unused_stink_ent_count" },
    { 0xF779394C, "get_unused_struct" },
    { 0x812C0E5F, "get_unused_vortex" },
    { 0x2233574D, "get_up" },
    { 0x09EF909A, "get_update_rate" },
    { 0x50B008FE, "get_update_teams" },
    { 0x8A0EC24E, "get_upgrade" },
    { 0x08FD97B4, "get_upgrade_name" },
    { 0x7AC738AD, "get_upgrade_weapon" },
    { 0xA5D01EFD, "get_upgraded_ammo_cost" },
    { 0xCD241CB2, "get_use_trigger" },
    { 0xADB7105F, "get_user" },
    { 0xD3AD1AB4, "get_valid_exit_points_for_zombie" },
    { 0xD0A878D9, "get_valid_object_defs" },
    { 0xF19401B5, "get_valid_objects" },
    { 0xF86E10AD, "get_valid_powerup" },
    { 0xF2A099A6, "get_valid_spawn_location" },
    { 0xC52AB2C3, "get_valid_spawner_array" },
    { 0x4D5984A3, "get_variant_from_entity_num" },
    { 0x35A3BD3A, "get_vehicle" },
    { 0xD0E426D8, "get_vehicle_array" },
    { 0xDCC92596, "get_vehicle_count" },
    { 0x237A0C0C, "get_vehicle_damage_state_index_from_health_percentage" },
    { 0x89166848, "get_vehicle_name" },
    { 0xDD3249E9, "get_vehicle_name_key_for_damage_states" },
    { 0xC7FD7B93, "get_vehicle_spawner" },
    { 0xF0C33061, "get_vehicle_spawner_array" },
    { 0x4A88A242, "get_vehicle_target" },
    { 0xC8E7716C, "get_vehicle_velocity" },
    { 0x59B6D5A5, "get_vehiclearray" },
    { 0xBD297FA3, "get_vehiclenode_any_dynamic" },
    { 0xDFE18D74, "get_vehicles_with_spawners" },
    { 0x30708ECB, "get_velocity" },
    { 0x3511C0E6, "get_vending_ents" },
    { 0xCD5BC54F, "get_vending_machine" },
    { 0x9CB38ED4, "get_view_num" },
    { 0x18C5A043, "get_visible_carrier_model" },
    { 0xA46737DF, "get_visual_for_trigger" },
    { 0x224E6CF9, "get_vm" },
    { 0xF50C93F8, "get_vol_from_speed" },
    { 0xB94D7A3E, "get_vulture_drop_duration" },
    { 0xF0C7E5A2, "get_vulture_drop_type" },
    { 0xE7184555, "get_wait" },
    { 0x15226B4F, "get_wait_locations_in_zone" },
    { 0x99BA7416, "get_wait_locations_in_zones" },
    { 0x458CA622, "get_wait_max" },
    { 0xFF2C37E3, "get_war_enemies_living" },
    { 0x4032E1E1, "get_war_gamefailonstatus_byidx" },
    { 0x74994918, "get_war_gamegetwaitonflag_byidx" },
    { 0x1E0785FF, "get_war_gameidx_byname" },
    { 0x2A358E86, "get_war_gameitemparam_byidx" },
    { 0xF8675B84, "get_war_gamenumobjs_byidx" },
    { 0x3CCEE232, "get_war_gameobjhackable_byidx" },
    { 0xE833D1BD, "get_war_gameobjstr3d_byidx" },
    { 0xD20296B4, "get_war_gameobjstr_byidx" },
    { 0xC5EB53AA, "get_war_gameobjtime_byidx" },
    { 0x33854750, "get_war_gametype_byidx" },
    { 0x5DFE4654, "get_war_gameuserdef_byidx" },
    { 0xB5A542BC, "get_war_gamewaveid_byidx" },
    { 0x8C0691A9, "get_war_scenario_gametypes" },
    { 0x3F20F81C, "get_warning_trigger_radius" },
    { 0xBCCEFC3B, "get_wave_boss_delay" },
    { 0x8CE23050, "get_wave_index" },
    { 0xF3DC2B4C, "get_wave_number_by_index" },
    { 0x781CCEF5, "get_wave_startdelay" },
    { 0x6E341A10, "get_wavenum_by_userdefined" },
    { 0x94FC3766, "get_weapon" },
    { 0x5D0ECA1C, "get_weapon_by_name" },
    { 0xFAF6A1FA, "get_weapon_cost" },
    { 0xA6B20992, "get_weapon_damage" },
    { 0x9508E249, "get_weapon_display_name" },
    { 0xA7EA1512, "get_weapon_hint" },
    { 0xDCA15F4B, "get_weapon_hint_ammo" },
    { 0x42DBE1A3, "get_weapon_name_from_alt" },
    { 0x41F1F078, "get_weapon_name_with_attachments" },
    { 0x2E80B92F, "get_weapon_num" },
    { 0x426BE3F1, "get_weapon_object_watcher" },
    { 0x2BEE4716, "get_weapon_object_watcher_by_weapon" },
    { 0x6476B55E, "get_weapon_stats" },
    { 0x16751FC1, "get_weapon_toggle" },
    { 0xD422716D, "get_weapon_type" },
    { 0x0215E9EE, "get_weapon_with_attachments" },
    { 0x145D50D6, "get_weapondata" },
    { 0x03BAE832, "get_weaponstat_dvar_name" },
    { 0x517FBB7E, "get_weaponstat_value" },
    { 0x5A3D6730, "get_weighted_random_perk" },
    { 0xB237CC74, "get_wheel_fx" },
    { 0x6320537D, "get_whole_number" },
    { 0x233F5CE2, "get_winning_team" },
    { 0x0D0EE115, "get_within_range" },
    { 0x41353AAD, "get_worst_drone_trigger" },
    { 0x1AED2639, "get_worthy_damage_ratio" },
    { 0x328FAC32, "get_xp_amount_for_killstreak" },
    { 0xF83D0B2F, "get_yaw" },
    { 0x52EE8E09, "get_yaw2d" },
    { 0x2CB48504, "get_yaw_to_combat_target" },
    { 0x6F52A087, "get_yaw_to_origin180" },
    { 0x24E78CA7, "get_yaw_to_target" },
    { 0x6F82068D, "get_year" },
    { 0x4FBCDA7A, "get_zipline_end_node" },
    { 0x353D9B54, "get_zipline_vehicle" },
    { 0x00B213EA, "get_zombie_array" },
    { 0xDD614043, "get_zombie_blood_hint_generic_vox" },
    { 0x5A1BF759, "get_zombie_blood_hint_vox" },
    { 0xA8061825, "get_zombie_count_for_round" },
    { 0xB2BAF1B5, "get_zombie_death_player_points" },
    { 0x2400B2C5, "get_zombie_death_team_points" },
    { 0xB7616A10, "get_zombie_hint" },
    { 0x533B0C62, "get_zombie_point_of_interest" },
    { 0x05234FFD, "get_zombie_point_of_intrest" },
    { 0x6A46E950, "get_zombie_spawn_delay" },
    { 0xDD49583A, "get_zombie_to_delete" },
    { 0x200F651A, "get_zombie_weapon_gib_callback" },
    { 0x7BC10545, "get_zombie_weapon_gib_head_callback" },
    { 0xE795C0FA, "get_zombies_touching_volume" },
    { 0x9FA6F8E1, "get_zone_craftable_tables" },
    { 0x31CFB41E, "get_zone_dog_locations" },
    { 0xC0720E8F, "get_zone_from_position" },
    { 0xBE733956, "get_zone_magic_boxes" },
    { 0x9C3F02AD, "get_zone_objective_index" },
    { 0x79E5FA88, "get_zone_perk_machines" },
    { 0x0584FD3A, "get_zone_plane_ramp" },
    { 0x426839B5, "get_zone_traps" },
    { 0x11D53BED, "get_zone_trigger" },
    { 0x779A715F, "get_zone_zbarriers" },
    { 0x8D4FBEB7, "get_zones_using_objective_index" },
    { 0xF87075B4, "getaatonweapon" },
    { 0x31244784, "getabovebuildingslocation" },
    { 0x47D277BC, "getabsmaxs" },
    { 0x34452442, "getabsmins" },
    { 0xA6595B94, "getachievement" },
    { 0xF96C3F5C, "getactionbind" },
    { 0xD67BA129, "getactionforbinding" },
    { 0x16AE4342, "getactivecontractprogress" },
    { 0x49DAF81C, "getactivecontracttimepassed" },
    { 0x9A45BB16, "getactivekillstreaks" },
    { 0xBCB4123A, "getactivelocalclients" },
    { 0xA60320FC, "getactivesquads" },
    { 0x2BA4336D, "getactorarray" },
    { 0xF68840C4, "getactorspawnerteamarray" },
    { 0x18E2CEAC, "getactorteamcountradius" },
    { 0x86775358, "getactorweaponoptions" },
    { 0xAD23A9DE, "getadjusedplayer" },
    { 0xB162A2B9, "getai" },
    { 0x5AC04B5F, "getai_by_noteworthy" },
    { 0x33222815, "getaiarchetypearray" },
    { 0x0C20C2E8, "getaiarray" },
    { 0xCCB6A779, "getaiarraytouchingvolume" },
    { 0x21AA6F0B, "getaiattribute" },
    { 0x029CCB39, "getaiboneorigin" },
    { 0x1831C19C, "getaibyspecies" },
    { 0xE4EAB046, "getaicount" },
    { 0x97FC6D10, "getaicurrentweapon" },
    { 0x81FB76F4, "getaicurrentweaponslot" },
    { 0x6D350B52, "getaifxname" },
    { 0xC5FC3B3B, "getaimaxammo" },
    { 0xC8421317, "getaimdelay" },
    { 0xD6537A56, "getaimlimitsfromentry" },
    { 0x3135DC49, "getaimpitchtoenemyfromnode" },
    { 0x779163F6, "getaimpitchtoshootentorpos" },
    { 0xDC0520D4, "getaimyawtoenemyfromnode" },
    { 0xF4431646, "getaimyawtopoint" },
    { 0x42F7466B, "getaimyawtoshootentorpos" },
    { 0x84E5EB49, "getaiprimaryweapon" },
    { 0xE0365546, "getairstrikedanger" },
    { 0xEBA152C5, "getaisecondaryweapon" },
    { 0x8CECCDB6, "getaisidearmweapon" },
    { 0x24E95264, "getaispeciesarray" },
    { 0x9B454BFD, "getaitargets" },
    { 0xB8494651, "getaiteamarray" },
    { 0x1FA31B7C, "getaitriggerflags" },
    { 0xCB62069C, "getaivelocity" },
    { 0x75A52F41, "getalias" },
    { 0xA7BB7DFD, "getaliveplayerscount" },
    { 0x016F5B3A, "getallalliedandenemyplayers" },
    { 0xCBC90467, "getallnodes" },
    { 0x0A2CF048, "getallotherplayers" },
    { 0x6551A301, "getallturrets" },
    { 0xD359D917, "getallvehiclenodes" },
    { 0xC973F2CE, "getammocount" },
    { 0xC4F62C56, "getangledelta" },
    { 0xB46A69C4, "getanglefrombits" },
    { 0x426FBD8F, "getangles" },
    { 0xE231FC68, "getangles_func" },
    { 0xE59C5C89, "getanglestolikelyenemypath" },
    { 0xAA8F926B, "getangleusingdirection" },
    { 0x39790BB6, "getangularvelocity" },
    { 0x90B52A1C, "getanim" },
    { 0x76D3D860, "getanim_from_animname" },
    { 0x19F2A34A, "getanim_generic" },
    { 0xAA9EC904, "getanimaimlimit" },
    { 0xD1AA51FB, "getanimatemodel" },
    { 0xF9B75E90, "getanimcurrframecount" },
    { 0xAA5A9B7D, "getanimcurrframecount_for_current_shot" },
    { 0x9927C12F, "getanimdirection" },
    { 0x76A6E601, "getanimendorigin" },
    { 0x2F294467, "getanimendpos" },
    { 0xEEFECD78, "getanimframecount" },
    { 0xF23D3D98, "getanimfromasd" },
    { 0x0CFEA9DB, "getanimhasnotetrackfromasd" },
    { 0xE1C7A0C8, "getanimlength" },
    { 0x3553EA2C, "getanimlengthfromasd" },
    { 0xEF7256DF, "getanimstatecategory" },
    { 0x8E261ED5, "getanimstatefromasd" },
    { 0x9E139A8F, "getanimsubstatefromasd" },
    { 0xF2F3368F, "getanimtime" },
    { 0x908ED3B6, "getanynodearray" },
    { 0x0A3919BE, "getapproachent" },
    { 0x14F14560, "getarea" },
    { 0x40497C83, "getarenapointsstat" },
    { 0x3E7FDC00, "getarmor" },
    { 0x7F723116, "getarray" },
    { 0xB69C373B, "getarraykey" },
    { 0x391512DA, "getarraykeys" },
    { 0xC5E266AD, "getarrivalsplittime" },
    { 0x9E1B9192, "getartillerydanger" },
    { 0x26278C20, "getassignedteam" },
    { 0x05180759, "getassignedteamname" },
    { 0x04EA457C, "getassistingplayers" },
    { 0xC09E367E, "getattachignorecollision" },
    { 0xD99660DB, "getattachmentchangemodifierbutton" },
    { 0x249D3729, "getattachmentcosmeticvariantforweapon" },
    { 0x72DDEE44, "getattachmentcosmeticvariantindexes" },
    { 0xC8F293B8, "getattachmentindex" },
    { 0x05933877, "getattachmentsdisabled" },
    { 0x008489C0, "getattachmentslot" },
    { 0xBB59B4B7, "getattachmentstring" },
    { 0xE6DCB6D2, "getattachmodelname" },
    { 0x5BAEE0F6, "getattachpos" },
    { 0xB6009D8B, "getattachsize" },
    { 0x9FD57871, "getattachtagname" },
    { 0xE45A26BB, "getavailablenearbyai" },
    { 0x775E0CD5, "getaway" },
    { 0x5AE04AC0, "getaway_event" },
    { 0x11CCE900, "getaway_rail" },
    { 0x949BD257, "getaway_rail_beat" },
    { 0xFE246384, "getaway_vehicle_1" },
    { 0x702BD2BF, "getaway_vehicle_2" },
    { 0x40805484, "getaway_vehicles_unloaded" },
    { 0xA89659DB, "getbackdeathanim" },
    { 0xF81CA948, "getbackpoint" },
    { 0x54CE71F1, "getbalconynode" },
    { 0xA6019EE6, "getbamfmeleedistance" },
    { 0x2D0FBE55, "getbarrierattacklocation" },
    { 0x92654D88, "getbaseweapon" },
    { 0x54D2DE57, "getbaseweaponitemindex" },
    { 0x23BE4E6B, "getbaseweaponparam" },
    { 0x6BF9F407, "getbclocation" },
    { 0x2BEDBA4B, "getbehaviortreestatus" },
    { 0xF293A9BB, "getbestcovermode" },
    { 0x6963B5CC, "getbestcovernodeifavailable" },
    { 0x693DE452, "getbestflakdirection" },
    { 0xA614E56A, "getbesthackertooltarget" },
    { 0xD8B0A150, "getbestinfluencepos" },
    { 0x048AF228, "getbestinitialorientangles" },
    { 0x615347F1, "getbestjavelintarget" },
    { 0x776A4496, "getbestmissileturrettarget" },
    { 0x60C8FDA8, "getbestmissileturrettarget_f38" },
    { 0xB97EB85A, "getbestmissileturrettarget_f38_deathblossom" },
    { 0xE5E8920A, "getbestmissileturrettargetlist" },
    { 0xA8EB3E94, "getbestplanedirection" },
    { 0x04BC3D80, "getbestspawnpoint" },
    { 0xFBCD4D29, "getbeststepoutpos" },
    { 0x30C2BA82, "getbeststingertarget" },
    { 0x7F1A054A, "getbesttarget" },
    { 0xF6C0DFF6, "getbestweightednode" },
    { 0x67666F43, "getbestweightedspawnpoint" },
    { 0x0B050A0E, "getbetterteam" },
    { 0x725D26D9, "getbitsforangle" },
    { 0xC3F3E8E8, "getblackboardattribute" },
    { 0x0E5C482B, "getblackboardevents" },
    { 0x5F9BD2A0, "getbleedergetupanim" },
    { 0x9F99D778, "getbleederreviveanim" },
    { 0x5CEB25B8, "getbleedloopanim" },
    { 0x0498035C, "getblend" },
    { 0xAEFAB9F4, "getbodyaccentcolorcountforhero" },
    { 0xD0C1AB6F, "getbodydamagedirection" },
    { 0xC234688F, "getbodyrenderoptionspacked" },
    { 0xACC2AE33, "getbombpoint" },
    { 0xE2388CCF, "getboredofthisnodetime" },
    { 0x199A9D5D, "getbotsettings" },
    { 0x71558786, "getboundaryflags" },
    { 0x1C563CC3, "getboundaryflagspawns" },
    { 0x65C3981C, "getbrake" },
    { 0x33277744, "getbuildkitattachmentcosmeticvariantindexes" },
    { 0x9116AD1F, "getbuildkitweapon" },
    { 0xB47F77BF, "getbuildkitweaponoptions" },
    { 0xDC809CCE, "getbulletgibref" },
    { 0x225D784B, "getburstdelaytime" },
    { 0x65C95764, "getbuscount" },
    { 0x335EC76A, "getbusname" },
    { 0x2FDD85F4, "getbuttonpress" },
    { 0x3151F397, "getcacdatagroup" },
    { 0x2BFE6300, "getcamangles" },
    { 0x0451F507, "getcamanglesbylocalclientnum" },
    { 0x5F3E774C, "getcamanimtime" },
    { 0xE71B0308, "getcamerapos" },
    { 0xD22B2A4E, "getcampos" },
    { 0x97A1337D, "getcamposbylocalclientnum" },
    { 0xB7C9E94D, "getcargoownerteam" },
    { 0xF8892858, "getcenter" },
    { 0xD0951719, "getcenteroflocations" },
    { 0x06083923, "getcentroid" },
    { 0x9AF7862E, "getchain" },
    { 0xDB2ECC51, "getchains" },
    { 0x603E8553, "getchallengelevels" },
    { 0x6C47FA5C, "getchallengestatus" },
    { 0x2069579F, "getcharacterbodymodel" },
    { 0xDE9665D2, "getcharacterbodyrenderoptions" },
    { 0xFDEEDC89, "getcharacterbodystyleindex" },
    { 0x0C744330, "getcharacterbodytype" },
    { 0xA01A0104, "getcharacterdataformenu" },
    { 0xA66127EB, "getcharacterfields" },
    { 0xC7171631, "getcharacterheadmodel" },
    { 0x40DBD9D4, "getcharacterheadrenderoptions" },
    { 0x852BE2B0, "getcharacterhelmethideshead" },
    { 0x1C26398A, "getcharacterhelmetmodel" },
    { 0xE05E857B, "getcharacterhelmetrenderoptions" },
    { 0x419FAC08, "getcharacterindex" },
    { 0xFCC693E5, "getcharactermoderenderoptions" },
    { 0x1BCF2EA0, "getchargedorsniperweaponbodypainanim" },
    { 0x1E23C817, "getchopperdroppoint" },
    { 0x33E2754F, "getchunkservice" },
    { 0x8690324F, "getcinematictimeremaining" },
    { 0xF61EDDE2, "getclaimednode" },
    { 0x73A9CD36, "getclaimteam" },
    { 0x260CFAE9, "getclass" },
    { 0x29DA5080, "getclasschoice" },
    { 0xD4E257CB, "getclassstat" },
    { 0xECD65892, "getclientfield" },
    { 0xD8EE31FE, "getclientfieldtoplayer" },
    { 0x36E9ABD4, "getclientflag" },
    { 0x41423FD8, "getclientsysstate" },
    { 0x43CC4179, "getclienttime" },
    { 0xEE8D1555, "getclones" },
    { 0x089C41B6, "getclosertobalconynode" },
    { 0x8E3DF1C8, "getclosest" },
    { 0xE85267F8, "getclosestaccurantent" },
    { 0xAE973562, "getclosestai" },
    { 0xBE8068C2, "getclosestaiment" },
    { 0x4B9D0F74, "getclosestenemysqdist" },
    { 0x21700417, "getclosestent" },
    { 0x2F9223F2, "getclosestfx" },
    { 0xEB546A9C, "getclosestinarray" },
    { 0xA9DEE582, "getclosestinfov" },
    { 0xDDDA4ED0, "getclosestkillcamentity" },
    { 0xAD53940F, "getclosestplaceturret" },
    { 0x1ACB8A7C, "getclosestpoi" },
    { 0xEED6DAB7, "getclosestpointonnavmesh" },
    { 0x8790DC2E, "getclosestpointonnavvolume" },
    { 0x8E67AE2B, "getclosestrandomhelicopterposition" },
    { 0xFF500118, "getclosests_flickering_model" },
    { 0x00A79893, "getclosestspeaker" },
    { 0x5EE38FE3, "getclosestto" },
    { 0x1BFB2259, "getclosesttome" },
    { 0x1857ECB4, "getclosesttoplayer" },
    { 0x6330CDC2, "getclosestunittype" },
    { 0x8D164707, "getcloseto_stairs" },
    { 0xCE37CED8, "getcloseto_stairs_trig" },
    { 0xDC910A4A, "getcloseto_stairs_trigger" },
    { 0x8FAD7022, "getclustergrenadevelocity" },
    { 0x35DB3641, "getcodpointscapped" },
    { 0x266F74F4, "getcodpointsstat" },
    { 0x549A461A, "getcolornumberarray" },
    { 0x7D1547D7, "getcolumnoffsetforgametype" },
    { 0xD8A526A8, "getcombatefficiencyevent" },
    { 0xCB64CC6B, "getcommandfromkey" },
    { 0x3640F8F4, "getcompatibleoperation" },
    { 0x536EE286, "getconnections" },
    { 0xF634AD8C, "getcontractname" },
    { 0x3B943DAB, "getcontractrequiredcount" },
    { 0xA7B4B2B9, "getcontractrequirements" },
    { 0x9A3BE0F0, "getcontractresetconditions" },
    { 0x5AEDB311, "getcontractrewardcp" },
    { 0xC38B1B18, "getcontractrewardxp" },
    { 0x8325A95A, "getcontractstatname" },
    { 0x231EA44F, "getcontractstattype" },
    { 0x79C45BBE, "getcontractstoprocess" },
    { 0xF1AB8DB6, "getcontrollerposition" },
    { 0xD974DE0F, "getcontrollertype" },
    { 0x471958FF, "getcooldownleft" },
    { 0xD74AAA6F, "getcoopvalue" },
    { 0x4A6D23BD, "getcornermode" },
    { 0xDCD08AA4, "getcorpseanim" },
    { 0xBD90138E, "getcorpsearray" },
    { 0xBD7C3CF0, "getcorrectcoverangles" },
    { 0x6AC858B3, "getcountofteamswithplayers" },
    { 0x889C7B20, "getcovernode" },
    { 0x6734CBE7, "getcovernodearray" },
    { 0xD9DC16BE, "getcovernodeyawtoenemy" },
    { 0xAEFDADC0, "getcovernodeyawtoorigin" },
    { 0x6EC14BE4, "getcovertype" },
    { 0x0390F311, "getcratedroporigin" },
    { 0xA68E7EF3, "getcrateheadobjective" },
    { 0x27E994CE, "getcrouchdeathanim" },
    { 0xC5C99D76, "getcrouchpainanim" },
    { 0xF73BE367, "getcrouchrunanim" },
    { 0x207BBD54, "getcrouchsniperdeathanimarray" },
    { 0x443220F5, "getcurrent_groupstruct" },
    { 0x4703D166, "getcurrentanimscriptedname" },
    { 0xF121876C, "getcurrentarcadehighscore" },
    { 0x79A933C3, "getcurrentdifficultysetting" },
    { 0x637B5398, "getcurrenteventoriginator" },
    { 0x5A7C780B, "getcurrenteventtypename" },
    { 0x388A6654, "getcurrentfraction" },
    { 0x02647B1D, "getcurrentgamemode" },
    { 0x7DDF1DCE, "getcurrentoffhand" },
    { 0x5DE2B4A3, "getcurrentposition" },
    { 0x48C6A3A2, "getcurrentweapon" },
    { 0x7CA4B5BB, "getcurrentweaponaltweapon" },
    { 0x56FBC62A, "getcurrentweaponclipammo" },
    { 0xBE89CEBB, "getcurrentweaponslotname" },
    { 0x198BE511, "getcurrentweaponspinlerp" },
    { 0x095D5EB8, "getcurve" },
    { 0xB89618C7, "getcustomclassloadoutitem" },
    { 0xAEFBABDD, "getcustomclassmodifier" },
    { 0x7998DAC8, "getcustomteamname" },
    { 0x8A018FD1, "getcvar" },
    { 0x29B468CD, "getcvarfloat" },
    { 0x30BF0CEC, "getcvarint" },
    { 0x699E26A4, "getcycleoriginoffset" },
    { 0x8E1DA51E, "getdamageableentarray" },
    { 0xE4C15522, "getdamageableents" },
    { 0x278C706F, "getdamagemodifier" },
    { 0x81805364, "getdamagetype" },
    { 0x05173D7E, "getdartmissiletargets" },
    { 0xD7FA713F, "getdate" },
    { 0x41026D34, "getdeathanim" },
    { 0x280499A3, "getdebugdvar" },
    { 0xD27593AB, "getdebugdvarfloat" },
    { 0x3B7B9756, "getdebugdvarint" },
    { 0x1A1F3973, "getdebugeye" },
    { 0xE5E45AD4, "getdecorations" },
    { 0x30C5092E, "getdefaultacceleration" },
    { 0xB52547EA, "getdefaultclassslot" },
    { 0x8428DEC1, "getdefaultclassslotwithexclusions" },
    { 0xC0623917, "getdefendloc" },
    { 0x59D63C2F, "getdeltaturnyaw" },
    { 0x9C48E5F3, "getdemofileid" },
    { 0xFD927922, "getdemoversion" },
    { 0xF59111C6, "getdepthoffield_farblur" },
    { 0xD2717DCC, "getdepthoffield_farend" },
    { 0x3B614667, "getdepthoffield_farstart" },
    { 0xA6D6C9E7, "getdepthoffield_nearblur" },
    { 0x9C8CC87B, "getdepthoffield_nearend" },
    { 0x277CC4D8, "getdepthoffield_nearstart" },
    { 0x5AB6D227, "getdescription" },
    { 0x929563F5, "getdesiredgrenadetimervalue" },
    { 0x98113EB2, "getdesiredidlepose" },
    { 0x499C5B7D, "getdesiredsidestepdir" },
    { 0x6801299D, "getdestructibledefs" },
    { 0x165D029C, "getdestructiblename" },
    { 0x91891B7C, "getdifficulty" },
    { 0x0197D081, "getdirectionaliasplayerrelative" },
    { 0x220C3426, "getdirectioncompass" },
    { 0x3AF4BD02, "getdirectionfacingclock" },
    { 0x84032866, "getdirectionfacingflank" },
    { 0x2F4D3BE0, "getdirectionreferenceside" },
    { 0x7C29AC17, "getdist" },
    { 0x8D0415AF, "getdistancefromlastvalidplayerloc" },
    { 0xF9C93CA9, "getdistancefromscreencenter" },
    { 0x2FDA4DE7, "getdlcavailable" },
    { 0x20A43863, "getdomflagusestring" },
    { 0x51AFCCC6, "getdronemodel" },
    { 0xD1344E73, "getdropdirection" },
    { 0x49013C01, "getdropheight" },
    { 0x324734AE, "getdroppedweapons" },
    { 0x6199FCAA, "getdroptofloorposition" },
    { 0x84368297, "getdstat" },
    { 0x39DEDD77, "getdstatarraycount" },
    { 0x56563E4E, "getdudefromarray" },
    { 0x2F8EA401, "getdudesfromarray" },
    { 0x6AE06304, "getdvar" },
    { 0xD4FF6C05, "getdvarcolorblue" },
    { 0x4FB44716, "getdvarcolorgreen" },
    { 0x51068FD6, "getdvarcolorred" },
    { 0xF3087FAA, "getdvarfloat" },
    { 0x0500B969, "getdvarfloatdefault" },
    { 0x4BD0142F, "getdvarint" },
    { 0x429BFFAA, "getdvarintdefault" },
    { 0x6F1EBE57, "getdvarstring" },
    { 0x19FA9E01, "getdvarvector" },
    { 0xB6D08743, "getdynent" },
    { 0x893E786E, "getdynentarray" },
    { 0x2AC4731A, "getdynmodels" },
    { 0x61FD95CB, "getearliestclaimplayer" },
    { 0xF5B9C711, "getem" },
    { 0xCCECEFD3, "getendreasontext" },
    { 0x1D5161AD, "getenemies" },
    { 0xB9335106, "getenemiesinzone" },
    { 0x0CB35E6C, "getenemyarray" },
    { 0x24240B4A, "getenemydistancesqr" },
    { 0x75DEDFDE, "getenemydogtagmodel" },
    { 0x382D4896, "getenemyeyepos" },
    { 0x4B03D9F9, "getenemyinfo" },
    { 0x5E0E0E7D, "getenemyplayers" },
    { 0x19059B92, "getenemypose" },
    { 0xBD75CE82, "getenemysightpos" },
    { 0x14881D7E, "getenemytarget" },
    { 0xC7762542, "getenemyteam" },
    { 0xCFE8E6C7, "getenemyteamwithgreatestbotcount" },
    { 0x82A3F074, "getenemyteamwithlowestplayercount" },
    { 0x6ADA35BA, "getent" },
    { 0x3DE80635, "getent_and_assert" },
    { 0x9409425A, "getent_safe" },
    { 0x99201F25, "getentarray" },
    { 0xB84EF19F, "getentbynum" },
    { 0x4B192207, "getenterbutton" },
    { 0x162FAA57, "getentityanimrate" },
    { 0xC7F3CE11, "getentitynumber" },
    { 0xB6BB65DA, "getentitytype" },
    { 0x93237922, "getentnavmaterial" },
    { 0x2235F722, "getentnum" },
    { 0x65848894, "getequipmentheadobjective" },
    { 0x1C91BA4C, "getequippedbodyaccentcolorforhero" },
    { 0x10E04AAD, "getequippedbodyindexforhero" },
    { 0xE33C5DED, "getequippedcharacterindexforlobbyclienthero" },
    { 0x72FD07C7, "getequippedheadindexforhero" },
    { 0x2238BF37, "getequippedhelmetaccentcolorforhero" },
    { 0xECC40696, "getequippedhelmetindexforhero" },
    { 0x297CC4A0, "getequippedheroindex" },
    { 0x8E76EA25, "getequippedheromode" },
    { 0x814F3F20, "getequippedshowcaseweaponforhero" },
    { 0xF5639177, "getestimatedtimeuntilscorelimit" },
    { 0x71557D38, "geteventlocationinfo" },
    { 0xD03E7614, "geteventpointofinterest" },
    { 0x3ECE539C, "geteventstate" },
    { 0x85741BCA, "getexitsplittime" },
    { 0xCCE5A6DF, "getexploderid" },
    { 0xF032C555, "getexplosiongibref" },
    { 0xCA1AAE24, "getexplosivedamagemodifier" },
    { 0x0D126775, "getexposedapproachdata" },
    { 0x501EB072, "geteye" },
    { 0x6D1DE06E, "geteyeapprox" },
    { 0x7183CD8E, "geteyeyawtoorigin" },
    { 0xE72B7AA4, "getfacialanimoverride" },
    { 0x61DFD7A0, "getfarai" },
    { 0x494C5662, "getfarthest" },
    { 0xB8FB0621, "getfilter" },
    { 0xF14712A1, "getfinalkill" },
    { 0x060E46DE, "getfiremode" },
    { 0xEFAEBE7F, "getfirstarraykey" },
    { 0x91430AEB, "getfirstavailableoffsetindex" },
    { 0xABF9F4D3, "getfirstavailableseat" },
    { 0xF1AD228D, "getfirstheadofgender" },
    { 0x72E1011B, "getfirstheroofgender" },
    { 0xEFE105F4, "getfirstradio" },
    { 0x0AA6DCEE, "getfirsttouchfraction" },
    { 0xA9448AA2, "getfirstvalidkillstreakaltweapon" },
    { 0x72FA281D, "getfirstzone" },
    { 0x1C76CCEF, "getfivefriendliestimeout" },
    { 0xABE303DC, "getflagradarowner" },
    { 0x0AEEE880, "getflags" },
    { 0x8F6610EE, "getflagteam" },
    { 0xC322DB69, "getflashbangedstrength" },
    { 0x54221C2E, "getflinchanim" },
    { 0xB66945DD, "getflyingac130anglestopoint" },
    { 0x6BE72EEA, "getfogsettings" },
    { 0xE34AAB24, "getfooteffect" },
    { 0xE97AD525, "getfootorigin" },
    { 0x98945509, "getfootstepstrings" },
    { 0x3E11318F, "getfractionmaxammo" },
    { 0x8CBDE445, "getfractionstartammo" },
    { 0x4CB33548, "getfraggrenadecount" },
    { 0xC94DFFEF, "getfreeactionnode" },
    { 0x37142CA1, "getfreeactorcount" },
    { 0x5341D2E7, "getfreeruntrackindex" },
    { 0x4D6434CC, "getfreespawnpoint" },
    { 0x907DF6FE, "getfriendlies" },
    { 0x9B97ACEF, "getfriendlydogtagmodel" },
    { 0x8B5158A0, "getfriendlyplayers" },
    { 0x887106FA, "getfriendlyscenter" },
    { 0xF8EAAF49, "getfriendlyspawnstart" },
    { 0x8C8338E5, "getfriendlyspawntrigger" },
    { 0x43C4EFC0, "getfullcustomweaponname" },
    { 0xE512A9CD, "getfullweaponname" },
    { 0xCAE20849, "getfunc" },
    { 0xA87C8DCD, "getfurthestent" },
    { 0x69440BCA, "getfurthestinarray" },
    { 0xE38768CD, "getfx" },
    { 0xF95E9854, "getfxarraybyid" },
    { 0x6D5612B6, "getfxfromsurfacetable" },
    { 0xD297535E, "getgadgetpower" },
    { 0xE20F20D1, "getgamelength" },
    { 0x216FCC45, "getgamemodename" },
    { 0xAF659A06, "getgamerepparamlimit" },
    { 0xBA1A1E0D, "getgamescore" },
    { 0x3A11A7AF, "getgametypeenumfromname" },
    { 0x99849E1B, "getgametypeeventrulesforevent" },
    { 0x468DFC60, "getgametypename" },
    { 0x4DC43066, "getgametyperules" },
    { 0x92A88DA3, "getgametypesetting" },
    { 0xEFBCFABD, "getgenericanim" },
    { 0xC5FA66A6, "getgoal" },
    { 0xCA42AAD9, "getgoals" },
    { 0xAC91AD60, "getgoalspeedmph" },
    { 0xB0095C0F, "getgoalyaw" },
    { 0xF077A9CE, "getgrappletargetarray" },
    { 0xAB898FE1, "getgrenadedropvelocity" },
    { 0xD08C3002, "getgrenadeithrew" },
    { 0xFC4397C2, "getgrenademodel" },
    { 0x4E755208, "getgrenadethrowoffset" },
    { 0x9824BA1B, "getgridlink" },
    { 0xC4F3E608, "getgridlinkbyhash" },
    { 0x180937C7, "getgridnode" },
    { 0xFC753CB5, "getgroundent" },
    { 0x92E87FDD, "getgroundenttype" },
    { 0x41E3CBF7, "getgroundpointfororigin" },
    { 0x6DC39D7F, "getgroundposition" },
    { 0x72A499C8, "getguid" },
    { 0xE933059F, "getgunangles" },
    { 0x826EB671, "getgunneranimpitch" },
    { 0xF88045DC, "getgunnertargetent" },
    { 0xD24A7EA9, "getgunnertargetvec" },
    { 0x95FC6F83, "getgunpitchtoshootentorpos" },
    { 0x34F1AEEA, "getgunyawtoshootentorpos" },
    { 0x4C449B29, "getgvalue" },
    { 0x21BA8AFE, "getgvrule" },
    { 0x0B34A15F, "gethackertoolinnerradius" },
    { 0x143E0D2E, "gethackertoolouterradius" },
    { 0x19B81CD9, "gethackertoolradius" },
    { 0x62278142, "gethackoutertime" },
    { 0x12527F57, "gethacktime" },
    { 0x9F3B7035, "gethandbrake" },
    { 0x57C0C9AD, "gethardenedaward" },
    { 0x29D3D5E7, "getheadchoppersnear" },
    { 0x3C4382FA, "getheadchopperstouching" },
    { 0xBE4BB3C2, "getheadgender" },
    { 0x09217353, "gethealthregenmodifier" },
    { 0xA867C403, "gethealthregentime" },
    { 0x7CA9FA5A, "gethealthvampirismmodifier" },
    { 0x3E10274E, "gethealthyenemies" },
    { 0x91A7544B, "gethelidamagestate" },
    { 0x6C7AE09A, "getheliend" },
    { 0xD1ED9B4B, "getheliheightlock" },
    { 0x8D974E5A, "getheliheightlockheight" },
    { 0xED1A8466, "gethelipath" },
    { 0xAB1844A1, "gethelistart" },
    { 0x00A0C085, "gethelmetaccentcolorcountforhero" },
    { 0x2908D746, "getheroabilityname" },
    { 0xEDCFE955, "getherobodymodelindices" },
    { 0x8725E343, "getheroes" },
    { 0xE3233D08, "getherogender" },
    { 0x7EED1B1F, "getheroheadmodelindices" },
    { 0x01059916, "getherohelmetmodelindices" },
    { 0x1F748B66, "getheroweaponname" },
    { 0xBAFECEC5, "gethighestnodestance" },
    { 0x7742689B, "gethighestpriorityevent" },
    { 0x4F9A094D, "gethighestscore" },
    { 0xB2A6C667, "gethighestscoringplayer" },
    { 0xAE8065AB, "gethighestteamscoreteam" },
    { 0x1CE1AA62, "gethighestwagerweaponusage" },
    { 0x2FBF4779, "gethitenttype" },
    { 0x0AA585F9, "gethitlocheight" },
    { 0x9316D183, "gethityaw" },
    { 0x453DB3E5, "gethorizontaloffsetfromscreencenter" },
    { 0x5E770196, "gethostplayer" },
    { 0xB3D3E6B9, "gethostplayerforbots" },
    { 0xD606D5D6, "gethudweapontype" },
    { 0xCC1BC459, "gethunkerdownpainanim" },
    { 0xB3A405B0, "gethvalue" },
    { 0x885798DE, "geticonforcrate" },
    { 0x5C484AE4, "getid" },
    { 0x08B565C2, "getideallocationforfx" },
    { 0x466E285F, "getidleanimname" },
    { 0xAE20AF86, "getidleinanimname" },
    { 0x3A5977E5, "getidleoutanimname" },
    { 0x418FAB16, "getiftopkillstreakhasbeenused" },
    { 0xB64B47AC, "getignoreent" },
    { 0xD86112FE, "getin" },
    { 0x8B24579B, "getin_fast" },
    { 0x9D293ABD, "getinactivesquads" },
    { 0xB0FB5B6A, "getindexforactivecontract" },
    { 0x6D0BF873, "getinfluencerpreset" },
    { 0x435E1965, "getinfoindex" },
    { 0x508907F5, "geting" },
    { 0x734DB218, "getinitialhelicopterflyheight" },
    { 0x30EE26F7, "getinkillcam" },
    { 0x077E3C3B, "getinorgs" },
    { 0xFBDA64E1, "getinventoryweapon" },
    { 0x04B1BF30, "getipaddress" },
    { 0xBB8807D9, "getitemarray" },
    { 0x0DAC874D, "getitemattachment" },
    { 0x3F160DFD, "getitemgroupforweaponname" },
    { 0x0F85C59E, "getitemgroupfromitemindex" },
    { 0x8BAB24E2, "getitemindex" },
    { 0xABF9DC9B, "getitemindexfromname" },
    { 0xE967A021, "getitemindexfromref" },
    { 0x52EF33CB, "getitemweaponname" },
    { 0x8AC60C08, "getjointeampermissions" },
    { 0x66A87965, "getjukevector" },
    { 0xF92B2F7B, "getkeepweapons" },
    { 0x69CC2C33, "getkeybinding" },
    { 0xD7779E2D, "getkillcamentity" },
    { 0x56C48F16, "getkillstreakbymenuname" },
    { 0xD82EBEEA, "getkillstreakforweapon" },
    { 0xA436C7D5, "getkillstreakfromweapon" },
    { 0x14F4F303, "getkillstreakindex" },
    { 0x6864DAB7, "getkillstreakindexbyid" },
    { 0x58FB7A9A, "getkillstreakinformdialog" },
    { 0x24E171E1, "getkillstreaklevel" },
    { 0xBD73F1A5, "getkillstreakmenuname" },
    { 0x65D6C6C8, "getkillstreakmomentumcost" },
    { 0xCCC5727B, "getkillstreaknum" },
    { 0x5ABC8628, "getkillstreaks" },
    { 0x2AA00489, "getkillstreakteamkillpenaltyscale" },
    { 0x85A7E55B, "getkillstreaktimerforkillstreak" },
    { 0xAB48025E, "getkillstreakusage" },
    { 0x2425D7F7, "getkillstreakusagebykillstreak" },
    { 0xC9AFCFD1, "getkillstreakweapon" },
    { 0x5AF34C2C, "getknownlength" },
    { 0x5E54DDF3, "getlabel" },
    { 0x1972066B, "getlandmark" },
    { 0xB15BA9ED, "getlastoutwatertime" },
    { 0x4F9A4C7F, "getlastteamalive" },
    { 0x4DD79D0B, "getlastweapon" },
    { 0xD83ACA08, "getleader" },
    { 0xC0867D9B, "getleaderdialogvariant" },
    { 0x8C3E1178, "getleagueteamid" },
    { 0xE3D1FCB6, "getlefttreadhealth" },
    { 0x9D871CD2, "getlegpainanim" },
    { 0x32DB9599, "getlevelalias" },
    { 0xB726942A, "getlevelcompleted" },
    { 0x2E7B6835, "getlevelindex" },
    { 0xFA3C9CAE, "getlevelname" },
    { 0x33DC7D0E, "getlevelskill" },
    { 0x48689A93, "getlevelveteranaward" },
    { 0xA1C1ED16, "getlightcolor" },
    { 0xBE2B3110, "getlightexponent" },
    { 0x03CDB4D6, "getlightfovinner" },
    { 0x0183E173, "getlightfovouter" },
    { 0x4F251210, "getlightintensity" },
    { 0x176C3F73, "getlightradius" },
    { 0x52B8AB2B, "getlinkedent" },
    { 0x45F35C99, "getlinkrunningtraverses" },
    { 0xF177D620, "getlinktraverses" },
    { 0x9521F11A, "getloaclplayers" },
    { 0x1135BF93, "getloadoutallocation" },
    { 0x6282E51F, "getloadoutgunsmithvariantindex" },
    { 0x4BE09268, "getloadoutitem" },
    { 0x3AF33FFD, "getloadoutitemfromddlstats" },
    { 0x52BEF0D7, "getloadoutitemfromprofile" },
    { 0xD71C6C1C, "getloadoutitemindex" },
    { 0xCB7863FF, "getloadoutitemref" },
    { 0xFF83114C, "getloadoutperks" },
    { 0x8AF4D36D, "getloadoutweapon" },
    { 0xD7759321, "getlocalclientangles" },
    { 0x795BC73B, "getlocalclientdriver" },
    { 0xBC8FD75A, "getlocalclienteyepos" },
    { 0xA848FADE, "getlocalclientfov" },
    { 0x548DAB87, "getlocalclienthealth" },
    { 0xBCEFCD7F, "getlocalclientmaxhealth" },
    { 0x8448E0EE, "getlocalclientnumber" },
    { 0xCF4AAD6E, "getlocalclientonvehicle" },
    { 0x357BFC11, "getlocalclientpos" },
    { 0x7C1CD5AD, "getlocalgunnerangles" },
    { 0x757A2F14, "getlocalizedshortcircuitedapproachpoint" },
    { 0x79C174A3, "getlocalplayer" },
    { 0xD4B4BD92, "getlocalplayers" },
    { 0x59F5E750, "getlocalplayerteam" },
    { 0xAC38D303, "getlocalprofilefloat" },
    { 0xAFEDF5EE, "getlocalprofileint" },
    { 0x0B7E5836, "getlocation" },
    { 0x8BE43AE5, "getlocationforfx" },
    { 0x6410F7D2, "getlockonlossradius" },
    { 0xA5A2ACA3, "getlockonorigin" },
    { 0xA35DF227, "getlockonradius" },
    { 0x1BAB420E, "getlockonspeed" },
    { 0x652F6D6A, "getlockontime" },
    { 0xD7D340AA, "getlookaheadangle" },
    { 0xCDA70552, "getlookaheaddir" },
    { 0x4705A395, "getlookaheaddist" },
    { 0xF576A8DB, "getlookaheadorigin" },
    { 0x81A06DC5, "getlookatpos" },
    { 0x9E91D5CE, "getlookyawtopoint" },
    { 0xB4F1390B, "getlosersteamscores" },
    { 0x21D45686, "getlospenalty" },
    { 0x1C9FF9A4, "getlowestskill" },
    { 0x0E9022FE, "getluimenu" },
    { 0x23C5960E, "getluimenudata" },
    { 0x76203849, "getmachetegibref" },
    { 0x7A72DD8C, "getmapcenter" },
    { 0xBB49A702, "getmapsundirection" },
    { 0x70D8BC51, "getmapsunlight" },
    { 0x68001DDD, "getmasonallies" },
    { 0x482743C6, "getmatchtype" },
    { 0x0D41B872, "getmaxactivecontracts" },
    { 0x277F38B3, "getmaxdirectionsandexcludedirfromapproachtype" },
    { 0xCE18847C, "getmaxlocalclients" },
    { 0xEB8246B9, "getmaxmapwidth" },
    { 0xBBAF5F6B, "getmaxpoint" },
    { 0x810B6E08, "getmaxreversespeed" },
    { 0x48281D9E, "getmaxs" },
    { 0x7197C6B8, "getmaxspeed" },
    { 0x3EB018C1, "getmaxtargetheight" },
    { 0xBE896334, "getmaxvehicles" },
    { 0x00F6D554, "getmembers" },
    { 0x192E538F, "getmenuheight" },
    { 0x9CA8B4A1, "getmeshheight" },
    { 0xBB32D88E, "getmicrosecondsraw" },
    { 0x1705D04B, "getmigrationstatus" },
    { 0xEAA48678, "getminbitcountfornum" },
    { 0xAF1FDB99, "getminimumflyheight" },
    { 0xBD042231, "getminpoint" },
    { 0xAEB18D50, "getmins" },
    { 0xD2AFF5D7, "getmintargetheight" },
    { 0xF102ED31, "getmiscmodels" },
    { 0xEE13CCB6, "getmissileowner" },
    { 0xEF9BD07B, "getmissiondvarstring" },
    { 0xFB697979, "getmissionuniqueid" },
    { 0x288A7E7D, "getmissionversion" },
    { 0xEB260EDA, "getmodel" },
    { 0xA0D9C84C, "getmodifiedhealth" },
    { 0xC4A4C669, "getmostkilled" },
    { 0x92F658AA, "getmostkilledby" },
    { 0xFC213376, "getmotionangle" },
    { 0x9BCAD89A, "getmoveanimname" },
    { 0x4ABB1F0A, "getmovedelta" },
    { 0x7CDA11FC, "getmovementsoundstate" },
    { 0x07771FBC, "getmovementtype" },
    { 0x065C5701, "getmovespeedscale" },
    { 0xCC1A84B9, "getmoving" },
    { 0xDF0CD98D, "getmpdialogname" },
    { 0x2DC55EC6, "getname" },
    { 0xCCEB7679, "getnames" },
    { 0x6D9DE587, "getnavmeshfacenormal" },
    { 0xA7FB0A13, "getnavmeshtriggersforpoint" },
    { 0xDE350DD8, "getnavpointsinradius" },
    { 0xF03EB5A7, "getnavvolumepointsinbox" },
    { 0xC48A1137, "getnearai" },
    { 0xFB0FAAB2, "getnearbyperformanceai" },
    { 0x6D5B92C7, "getnearestnode" },
    { 0x8C0D6A9C, "getnearesttalker" },
    { 0x8B513D71, "getnegotiationendnode" },
    { 0xEE6C108E, "getnegotiationstartnode" },
    { 0x0E26FC07, "getnewenemyreactionanim" },
    { 0x9B690402, "getnewnodepositionaheadofvehicle" },
    { 0xC62C62AF, "getnewstance" },
    { 0x93BE6580, "getnextarraykey" },
    { 0x71FA2B02, "getnextdropdirection" },
    { 0x679F86F3, "getnextexploder" },
    { 0x74CC34ED, "getnextflashanim" },
    { 0x8043A782, "getnexthardpointitem" },
    { 0xDFFD2D7E, "getnexthighestscore" },
    { 0xCBC4B77A, "getnextlevelindex" },
    { 0xCBE64BB2, "getnextmoveposition" },
    { 0xC1C1E2E6, "getnextmoveposition_evasive" },
    { 0xEFAC5BC3, "getnextmoveposition_forwardjuke" },
    { 0x4A95B514, "getnextmoveposition_ranged" },
    { 0x93D07F7E, "getnextmoveposition_tactical" },
    { 0xD92AA446, "getnextmoveposition_unaware" },
    { 0x3B254302, "getnextmoveposition_wander" },
    { 0xA71443C4, "getnextobjid" },
    { 0x4DC1907D, "getnextradio" },
    { 0xFBFA19E6, "getnextradiofromqueue" },
    { 0x0F79399C, "getnexttraversalnodeonpath" },
    { 0x6C4AF6F0, "getnextvalidsquad" },
    { 0xD63C3536, "getnextzone" },
    { 0x3B8C8963, "getnextzonefromqueue" },
    { 0xB4CB3503, "getnode" },
    { 0x9FC563C5, "getnode_safe" },
    { 0xFE0CFD2E, "getnodearray" },
    { 0xF1EC6341, "getnodearraysorted" },
    { 0x82CBC0A4, "getnodeavgusepos" },
    { 0xBB653372, "getnodedirection" },
    { 0x1115EABA, "getnodeforward" },
    { 0x394897F3, "getnodeforwardyaw" },
    { 0xA13C01A7, "getnodehash" },
    { 0xD1C41093, "getnodeindexonpath" },
    { 0xE9CB73AA, "getnodeoffset" },
    { 0x0D3D5EF6, "getnodeoffsetangles" },
    { 0x75ECF7CB, "getnodeoffsetposition" },
    { 0x9B7CE199, "getnodeorigin" },
    { 0x9290C708, "getnodeowner" },
    { 0xC0545F55, "getnodesinradius" },
    { 0x406081BA, "getnodesinradiussorted" },
    { 0x31946BD5, "getnodestanceyawoffset" },
    { 0x57F9843B, "getnodetype" },
    { 0x79B616C3, "getnodeusetime" },
    { 0xF6BF4849, "getnodeyawtoenemy" },
    { 0xEE7E36F5, "getnodeyawtoorigin" },
    { 0xAC07401E, "getnoflyzoneheight" },
    { 0x8D29C581, "getnoflyzoneheightcrossed" },
    { 0x2BAFA7EA, "getnonpredictedlocalplayer" },
    { 0xBD1DA8E5, "getnonridingai" },
    { 0x2E21EC49, "getnonteammindist" },
    { 0x12DC84AC, "getnonteamsum" },
    { 0x1905A33A, "getnormalanimtime" },
    { 0xD2A2BCCC, "getnormalhealth" },
    { 0x86BD5886, "getnormalizedcameramovement" },
    { 0xA4D94983, "getnormalizedmovement" },
    { 0x75B668B9, "getnorthyaw" },
    { 0xAAB3CA28, "getnotetrack" },
    { 0xB84A1F6C, "getnotetracksindelta" },
    { 0xD8959C32, "getnotetracktimes" },
    { 0xB96AB1B9, "getnumbercivilianspawnersbytargetname" },
    { 0x30B9FB13, "getnumberoffootnotetracks" },
    { 0xB5C0BC41, "getnumberofpkgsbeingtransported" },
    { 0xC2F1DF14, "getnumberoftypebeingtransported" },
    { 0x7BEFA15A, "getnumchallengescomplete" },
    { 0x6C6E7B10, "getnumconnectedplayers" },
    { 0x4441FF8D, "getnumexpectedplayers" },
    { 0xA0DEAC6D, "getnumflattires" },
    { 0xEEF8812F, "getnumgvrules" },
    { 0x8BA193A5, "getnumrestarts" },
    { 0xBBEB3FA6, "getnumtouching" },
    { 0x1E2D9ECA, "getnumtouchingexceptteam" },
    { 0x9211ADAF, "getnumtransports" },
    { 0x5531F423, "getnumzbarrierpieces" },
    { 0x06E5794A, "getobj" },
    { 0xEFE537BA, "getobjectivehinttext" },
    { 0x523A314F, "getobjectivescoretext" },
    { 0xD20E7521, "getobjectivetext" },
    { 0xC76225A9, "getobjpointbyindex" },
    { 0xBD1DE60A, "getobjpointbyname" },
    { 0x6F256229, "getoccupantseat" },
    { 0xA748B0BF, "getoffpath" },
    { 0x4FC81008, "getoldradius" },
    { 0xCB3F8C99, "getonpath" },
    { 0xD20D959E, "getoobuimodel" },
    { 0x1096B310, "getopeningside" },
    { 0x3A337541, "getorientmode" },
    { 0xE59527C1, "getorigin" },
    { 0xAFC3C2A4, "getoriginalongstrafepath" },
    { 0x58867303, "getoriginoffsets" },
    { 0x28E07F29, "getormakebot" },
    { 0x661D73D9, "getotherflag" },
    { 0xA1BDEC54, "getotherhelicopterpointtoavoid" },
    { 0x993A1F11, "getothernodeinnegotiationpair" },
    { 0xFAD13578, "getotherteam" },
    { 0x1CA58D67, "getotherteamsmask" },
    { 0xCCF099CC, "getotherteamsroundswon" },
    { 0x9D6CBAB9, "getout" },
    { 0x1C8DBD9B, "getout_anim" },
    { 0x8B4CE694, "getout_combat" },
    { 0x38BE014D, "getout_delete" },
    { 0xD496F6F6, "getout_fast" },
    { 0x293B4329, "getout_pistol" },
    { 0xCA54719B, "getout_rigspawn" },
    { 0xCD9B139A, "getout_secondary" },
    { 0xBA7AA643, "getout_secondary_tag" },
    { 0xB3339ADB, "getout_timed_anim" },
    { 0xE61E6A3A, "getoutland" },
    { 0x324D2803, "getoutloop" },
    { 0x10D1173C, "getoutloopsnd" },
    { 0x4CB1BC81, "getoutrig" },
    { 0x42B12292, "getoutrig_abort" },
    { 0x7D0CD4BA, "getoutrig_abort_while_deploying" },
    { 0xFA5D6EBB, "getoutrig_disable_abort" },
    { 0xA2101443, "getoutrig_disable_abort_notify_after_riders_out" },
    { 0xA694F6FB, "getoutrig_model" },
    { 0xDCF88D0C, "getoutrig_model_idle" },
    { 0x6F323C43, "getoutriganimating" },
    { 0x45361F2E, "getoutsnd" },
    { 0x24475455, "getoutstance" },
    { 0x94C41C1F, "getownedandboundingflagspawns" },
    { 0xF931F320, "getownedflagspawns" },
    { 0xF97C0820, "getowner" },
    { 0x03CF0C5B, "getownerteam" },
    { 0x5D785924, "getpainanim" },
    { 0x50F4CB91, "getparamvalueforplayer" },
    { 0x639BA96B, "getparasitefiringrate" },
    { 0x31F58F3B, "getparent" },
    { 0xF8F96B4A, "getparententity" },
    { 0x0E15B819, "getpartname" },
    { 0x4DDBC729, "getpatharray" },
    { 0xEBDE6CFB, "getpathbetweenarrayofpoints" },
    { 0xAC602B47, "getpathbetweenpoints" },
    { 0xE48448A5, "getpathfixedoffset" },
    { 0x62B40292, "getpathlength" },
    { 0xE6C2D65B, "getpathmode" },
    { 0x33F22103, "getpathvariableoffset" },
    { 0xB7CC66C6, "getperfectinfo" },
    { 0x316BC7CA, "getperks" },
    { 0xF91F8F2D, "getpermutation" },
    { 0xB7E35FF6, "getpersistentprofilevar" },
    { 0x69B75DAC, "getpersonalthreatbias" },
    { 0x9142EE49, "getpersstat" },
    { 0xEF7BF7DC, "getpickupgroundpoint" },
    { 0x655F5AC8, "getpiececount" },
    { 0x6E440C6F, "getpitch" },
    { 0x6E2D9E78, "getpitchtoenemy" },
    { 0xD3D056BF, "getpitchtolookentorpos" },
    { 0x1185723A, "getpitchtoorigin" },
    { 0x398EC5B3, "getpitchtoshootentorpos" },
    { 0x78A779D4, "getpitchtospot" },
    { 0x270AD188, "getpkgrequirement" },
    { 0x67161136, "getplacementforplayer" },
    { 0xC8500421, "getplacementstartheight" },
    { 0xC5D15A53, "getplaneexittype" },
    { 0x035B04DA, "getplanemodel" },
    { 0x97D5D732, "getplant" },
    { 0x307E65A3, "getplaybacktime" },
    { 0x89C87C9C, "getplayerangles" },
    { 0xFC485E4F, "getplayerattachmentcosmeticvariantindexes" },
    { 0x808C570E, "getplayerbyname" },
    { 0x1B865DA9, "getplayerc4" },
    { 0x52D99059, "getplayercamerapos" },
    { 0x81F35D1B, "getplayerclaymores" },
    { 0x5F6B2268, "getplayercorpse" },
    { 0xE62A6B94, "getplayerdata" },
    { 0x292B6CBB, "getplayerfromclientnum" },
    { 0x303F31C3, "getplayergendertype" },
    { 0xFD9D8517, "getplayergibdef" },
    { 0x7F3D2376, "getplayergravity" },
    { 0xA77ECA75, "getplayerhelispeed" },
    { 0x3F10449F, "getplayers" },
    { 0xDC5AB8ED, "getplayersclass" },
    { 0xB790B8F4, "getplayerselectedgesture" },
    { 0xA96DC615, "getplayerselectedgesturename" },
    { 0x30F07961, "getplayerselectedtaunt" },
    { 0xA1764460, "getplayerselectedtauntname" },
    { 0xB5CA0647, "getplayerseliminated" },
    { 0xBDA66CCF, "getplayershowcaseweapon" },
    { 0xD62D13D0, "getplayersleft" },
    { 0x5A9FA271, "getplayersneededcount" },
    { 0xDD68B18B, "getplayersonteam" },
    { 0xD3EDF2F2, "getplayerspawnid" },
    { 0x983F3DAD, "getplayerspeed" },
    { 0x6FE01934, "getplayersplace" },
    { 0x01A2AD4A, "getplayersquad" },
    { 0x1AC535E9, "getplayersquadid" },
    { 0x6F4D3B9D, "getplayersride" },
    { 0x85CF8194, "getplayerstancebasedoffset" },
    { 0xC8C9E5B4, "getplayervehicle" },
    { 0x1E60168E, "getplayerviewheight" },
    { 0xE314917A, "getplayspacecenter" },
    { 0x50E7B6AF, "getplayspacemaxwidth" },
    { 0x8E6C26D9, "getpoibyref" },
    { 0xA29B80B7, "getpoients" },
    { 0x0D35E7A8, "getpointcost" },
    { 0x1D071F5E, "getpointdirection" },
    { 0xBF157F6D, "getpointinbounds" },
    { 0x180453BE, "getpointonline" },
    { 0xA555E5C1, "getpoiobjectives" },
    { 0xDD24519F, "getpotentialtargets" },
    { 0x2480B0E1, "getpredictedaimyawtoshootentorpos" },
    { 0xA8E101AC, "getpredictedpathmidpoint" },
    { 0x582EB258, "getpredictedrevivepoint" },
    { 0x43EE5D97, "getpredictedyawtoenemy" },
    { 0x78670B61, "getpreferedvalidpoints" },
    { 0xD3D77B16, "getpreferredweapon" },
    { 0x0DDDE7A0, "getpregameclass" },
    { 0x1E7C4EB6, "getprestigelevel" },
    { 0x8AFAFB9C, "getprimarydeltaanim" },
    { 0x32CE3724, "getpronedeathanim" },
    { 0xB3A32BB4, "getpronepainanim" },
    { 0xEC1316B9, "getproximitychain" },
    { 0x4CAF859B, "getquadrant" },
    { 0xC991CA07, "getqueueevents" },
    { 0xC8DEEBF7, "getradioarray" },
    { 0x14EDE7BD, "getrandom_spammodel" },
    { 0xBDDC5293, "getrandomcharacter" },
    { 0xDC2745A6, "getrandomcovermode" },
    { 0xCC7417A7, "getrandomcratetype" },
    { 0x917FA966, "getrandomgadget" },
    { 0x89E23AB9, "getrandomgunfromprogression" },
    { 0xF3F428F0, "getrandomhelicopterleaveorigin" },
    { 0x67F820D0, "getrandomhelicopterposition" },
    { 0x45DDD959, "getrandomhelicopterstartorigin" },
    { 0xC0A62E74, "getrandomintermissionpoint" },
    { 0x67F20622, "getrandomintfromseed" },
    { 0x79EF74D2, "getrandommappoint" },
    { 0x050989E7, "getrandomnotrichtofen" },
    { 0x8B9953E3, "getrandomoffset" },
    { 0xA310D598, "getrandompointonnavvolume" },
    { 0x8F09C494, "getrandompos" },
    { 0x9C5EF83F, "getrandomvalidcustomclass" },
    { 0x9AA9E569, "getrank" },
    { 0xB89B44CA, "getrankforxp" },
    { 0x3DD70944, "getrankfromname" },
    { 0xA8F48405, "getrankinfocodpointsearned" },
    { 0x8B105FA6, "getrankinfofull" },
    { 0x61B8C112, "getrankinfoicon" },
    { 0x42515315, "getrankinfolevel" },
    { 0x6DD6F60D, "getrankinfomaxxp" },
    { 0x1F2CF483, "getrankinfominxp" },
    { 0x7F094B0E, "getrankinfounlockattachment" },
    { 0xE3CE7771, "getrankinfounlockcamo" },
    { 0x0DD86CD0, "getrankinfounlockchallenge" },
    { 0x5B4CCFB9, "getrankinfounlockfeature" },
    { 0xB571F6CD, "getrankinfounlockperk" },
    { 0x05FA726D, "getrankinfounlockweapon" },
    { 0xE5C51041, "getrankinfoxpamt" },
    { 0xC60D35E9, "getrankxp" },
    { 0x8B6F38EE, "getrankxpcapped" },
    { 0xA76B42CB, "getrankxpstat" },
    { 0x7FE4C480, "getratio" },
    { 0xE03CA3F7, "getrcbombplacement" },
    { 0x981F787C, "getreacquirenode" },
    { 0xC73D31F7, "getreactanim" },
    { 0x772488D8, "getreactaniminternal" },
    { 0xA554E3FE, "getreactionevent" },
    { 0x872042B7, "getreadytofire" },
    { 0x11C999A9, "getrealac130angles" },
    { 0x3586FB08, "getrealtime" },
    { 0x235B2A18, "getrecentstat" },
    { 0x17FDC725, "getreffromitemindex" },
    { 0xD2EE87AD, "getreflectionlocs" },
    { 0xC30E8AE6, "getreflectionorigin" },
    { 0x50493E48, "getrelativeteam" },
    { 0x1A03BFB9, "getremainingburstdelaytime" },
    { 0xF07F6AD4, "getremotename" },
    { 0xCD53B410, "getreplaygunlockonorigin" },
    { 0x712CF456, "getrespawndelay" },
    { 0xB57572DD, "getretrievableweapons" },
    { 0xC9AA60D5, "getrevealpulsemaxradius" },
    { 0x2D3F69AD, "getrevealpulseorigin" },
    { 0x290BDD19, "getrevealpulseradius" },
    { 0x61FD64CE, "getrevivepoint" },
    { 0x927F479E, "getrevivergetupanim" },
    { 0xA9FF4E52, "getreviverreviveanim" },
    { 0xE94201F6, "getrewindwatcher" },
    { 0x7B0925AF, "getrighttreadhealth" },
    { 0x481F3BEE, "getrocketcamera" },
    { 0xDF9037A3, "getrope" },
    { 0xBA8E2545, "getroundlength" },
    { 0xB728C7A5, "getroundsplayed" },
    { 0x02574DD0, "getroundstartdelay" },
    { 0xE008B8F9, "getroundswitchdialog" },
    { 0x347C82D4, "getroundswon" },
    { 0x61E845CB, "getroundtimeplayed" },
    { 0xDAAAA3C1, "getroundwinlimitwinningteam" },
    { 0xB5D0FE7D, "getrunanim" },
    { 0xE81C4BD0, "getrunanimupdatefrequency" },
    { 0x94C55658, "getrunanimweights" },
    { 0x7E7AA6A0, "getrunbackwardsdistancesquared" },
    { 0xF2FCF2CA, "getruncrossbowdeathanimarray" },
    { 0xC2979220, "getrunningforwarddeathanim" },
    { 0x6DE0DA48, "getrunningforwardpainanim" },
    { 0x56962A5B, "getrunningforwardreactanim" },
    { 0xA2DA1E0A, "gets" },
    { 0x05F046D4, "getscaledforplayers" },
    { 0x575986E3, "getscoreeventcolumn" },
    { 0xF0DDB5C8, "getscoreeventtableid" },
    { 0xE711EB8A, "getscoreeventtablename" },
    { 0x04988DD3, "getscoreinfolabel" },
    { 0x57FB3DA2, "getscoreinfovalue" },
    { 0xB7A18AAB, "getscoreinfoxp" },
    { 0x8A974786, "getscoremultiplier" },
    { 0xDE5F2318, "getscoreperminute" },
    { 0xEAE05241, "getscorerank" },
    { 0x843AD29D, "getscoreremaining" },
    { 0x6D3203B3, "getscriptbrake" },
    { 0x45134B36, "getscriptoriginpoolindex" },
    { 0x63EE40C1, "getseatfiringangles" },
    { 0xB4980289, "getseatoccupant" },
    { 0xDB9B974B, "getsecondaryweapon" },
    { 0xD3CFDA0B, "getserverhighestclientfieldversion" },
    { 0xD9502965, "getservertime" },
    { 0xDA42691F, "getsessstat" },
    { 0x153A204C, "getshaderconstantindex" },
    { 0xF938E0BB, "getshaderconstantvalue" },
    { 0xBEEC9667, "getshootanimprefix" },
    { 0x0CC086DF, "getshootatpos" },
    { 0x8D4A3E44, "getshootpospitch" },
    { 0x07C1BDE2, "getshortcircuitedarrivalanimtime" },
    { 0xB18B35FF, "getshortcircuitedexitanimtime" },
    { 0xD399090E, "getshoutcastersetting" },
    { 0x56B9727A, "getsingleairstrikedanger" },
    { 0xB28B5DC6, "getsingleartillerydanger" },
    { 0x6BA5CAE4, "getslotforperk" },
    { 0xB9F757ED, "getsmokegrenadecount" },
    { 0x016D67F6, "getsnapshotackindex" },
    { 0x93FE01E4, "getsnapshotindexarray" },
    { 0xC07D02BA, "getsniperburstdelaytime" },
    { 0x8D1DAAF8, "getsortedspawnpoints" },
    { 0x628275FD, "getsoundkey" },
    { 0x345116CC, "getspawner_byid" },
    { 0xD35375B8, "getspawnerarray" },
    { 0xE215B4C1, "getspawnerteamarray" },
    { 0xFE9B0DCE, "getspawnpoint" },
    { 0x1581CDCC, "getspawnpoint_dm" },
    { 0xAEC49AFF, "getspawnpoint_final" },
    { 0xFC419740, "getspawnpoint_nearteam" },
    { 0x8D0FD390, "getspawnpoint_random" },
    { 0x951D2E53, "getspawnpoint_safespawn" },
    { 0xC580FCD7, "getspawnpoint_turned" },
    { 0xAF9729A1, "getspawnpointarray" },
    { 0xD63BE771, "getspawnpoints" },
    { 0x505A826D, "getspawnsboundingflag" },
    { 0x7F325125, "getspeakers" },
    { 0x8DD37644, "getspecialistindex" },
    { 0xF9BA8078, "getspecificcharacter" },
    { 0xB62CB89C, "getspeed" },
    { 0xEDBE4101, "getspeedmph" },
    { 0x0DEA647E, "getspikelauncheractivespikecount" },
    { 0x2551192E, "getsplitscreenteam" },
    { 0xC872CA8F, "getspm" },
    { 0x93C64C07, "getsquad" },
    { 0xE7B1AF9C, "getsquadbreadcrumb" },
    { 0xA8F42C6A, "getsquadbypkg" },
    { 0x63F9AF24, "getsquadcenter" },
    { 0x6309E924, "getsquadleader" },
    { 0xFA045BE0, "getsquadlistfromselected" },
    { 0xB0A81A71, "getsquadsbytype" },
    { 0xE2705D45, "getss" },
    { 0x653BA713, "getstance" },
    { 0x4D2D5024, "getstance_func" },
    { 0x1342EDB4, "getstancestring" },
    { 0xA35CC42A, "getstandchargedsniperdeathanimarray" },
    { 0x253581ED, "getstandcrossbowdeathanimarray" },
    { 0x84F05836, "getstanddeathanim" },
    { 0x983239FE, "getstandpainanim" },
    { 0xBFC0AF58, "getstandpistoldeathanimarray" },
    { 0x58BC3DB8, "getstandpowerdeathanimarray" },
    { 0xA174D22E, "getstandrpgdeathanimarray" },
    { 0x183BD93C, "getstandsniperdeathanimarray" },
    { 0xAEB0CAB8, "getstandspreaddeathanimarray" },
    { 0x9A018E31, "getstandwalkanim" },
    { 0x1CDB4AB1, "getstartangles" },
    { 0xB9B16ACF, "getstartorigin" },
    { 0x12161271, "getstat" },
    { 0x7BFD5BA1, "getstates" },
    { 0x61C3990E, "getstatnamewithgametype" },
    { 0x3EF40B5C, "getstatnumberwithgametype" },
    { 0xBC37A245, "getstatstablename" },
    { 0x6C9824C7, "getsteerfactor" },
    { 0xC4989EC2, "getsteering" },
    { 0x5377F3A6, "getstepoutdistance" },
    { 0x7FA5BB36, "getstolenheroweapon" },
    { 0x5A0AFC7C, "getstopwatch" },
    { 0xC872E89B, "getstowedweapon" },
    { 0x84E97A43, "getstrafedistance" },
    { 0x491DD49C, "getstrikepath" },
    { 0xCCEA913E, "getstrongbulletdamagedeathanim" },
    { 0xA0A9F584, "getstruct" },
    { 0xD19DF56B, "getstruct_and_assert" },
    { 0x5C014584, "getstruct_safe" },
    { 0xDE0F12F3, "getstructarray" },
    { 0x201C62E3, "getstructent" },
    { 0xE8EF6CB0, "getstructfield" },
    { 0x8ADBA991, "getstructfieldorzero" },
    { 0xA1928F28, "getstumblepainanim" },
    { 0xF45850EC, "getsubstr" },
    { 0xA092897A, "getsurfacestrings" },
    { 0xAD665F20, "getswingangle" },
    { 0x7F8C532F, "getswordgibref" },
    { 0xB67632F3, "getsystemtime" },
    { 0x6068791E, "gettacticalinsertions" },
    { 0xFC5AD8BD, "gettag" },
    { 0xCD1D99BD, "gettagangles" },
    { 0x68CEE910, "gettagforpos" },
    { 0x6C4EAE71, "gettagforwardvector" },
    { 0xD48F2AB3, "gettagorigin" },
    { 0xD5054843, "gettakennodes" },
    { 0x0D415854, "gettargetangleoffset" },
    { 0x30BBC3CC, "gettargetdummies" },
    { 0xF82F9FE5, "gettargetentity" },
    { 0x26614EE7, "gettargeteveryone" },
    { 0xCB8892F2, "gettargeteyeoffset" },
    { 0x0D272B04, "gettargetlockentity" },
    { 0x21C55373, "gettargetlockentityarray" },
    { 0xBAC5F945, "gettargetotherteam" },
    { 0xFA767B46, "gettargetplayerseliminated" },
    { 0xA208DE62, "gettargetplayerseliminatedonotherteam" },
    { 0xD3EF2856, "gettargetplayerseliminatedonplayersteam" },
    { 0x15022C19, "gettargetplayersleft" },
    { 0xEDB33737, "gettargetplayersleftonotherteam" },
    { 0x47067D17, "gettargetplayersleftonplayersteam" },
    { 0x4CB892BD, "gettargetplayersteam" },
    { 0xEECDBFB2, "gettargetpos" },
    { 0x52AA79E8, "gettargetscreenangles" },
    { 0xBA5699F0, "gettargetsforgametypeeventrule" },
    { 0x78B15A3A, "gettargettingai" },
    { 0x2553CA4A, "gettargetupdownoffset" },
    { 0x7C010ED4, "gettdmstartspawnname" },
    { 0xE7353088, "getteam" },
    { 0xB05DF9C4, "getteambalance" },
    { 0xC7E5B759, "getteamchoice" },
    { 0xB427B2F2, "getteamflagcarrymodel" },
    { 0x82762A23, "getteamflagcount" },
    { 0xE2B453D5, "getteamflagicon" },
    { 0xF72C9DD5, "getteamflagmodel" },
    { 0x8BF6DEBC, "getteamindex" },
    { 0x8B7E4E17, "getteamkillpenalty" },
    { 0x1BBCF4BE, "getteamkillscore" },
    { 0xA2358F90, "getteammask" },
    { 0xEBBA863F, "getteamopstableid" },
    { 0x842DE26C, "getteamradar" },
    { 0xD028B82B, "getteamsatellite" },
    { 0xA7DCA17E, "getteamscore" },
    { 0xD696E595, "getteamscoreforround" },
    { 0xC2B354FB, "getteamscoreratio" },
    { 0xBE10352C, "getteamspawnpoints" },
    { 0xBC90A6A0, "getteamspyplane" },
    { 0xEA5E2381, "getteamsquads" },
    { 0x01CB9860, "getteamstartspawnname" },
    { 0xA4188294, "getter" },
    { 0x3E323D2C, "getterfunction" },
    { 0xF0A13CA2, "gettextwidth" },
    { 0x60E43DC1, "getthiefpowergain" },
    { 0x58AE68F7, "getthreat" },
    { 0x12D05134, "getthreatbias" },
    { 0x492DAADD, "getthreatbiasgroup" },
    { 0x58A7452E, "getthreats" },
    { 0x23629963, "getthrottle" },
    { 0xD131A6E0, "gettime" },
    { 0xC9F1F9A2, "gettimefromlevelstart" },
    { 0xC6632977, "gettimefromvehiclenodetonode" },
    { 0x0C2DEB19, "gettimelimit" },
    { 0x3F2A2AED, "gettimelimitdvarvalue" },
    { 0x3C9BD810, "gettimepassed" },
    { 0xA5369DB4, "gettimeremaining" },
    { 0x3BF23306, "gettimescale" },
    { 0x1CDB8B24, "gettin" },
    { 0xAB4A4223, "getting" },
    { 0xECC6068D, "getting_killed" },
    { 0xE9BE6228, "getting_killed_quickly" },
    { 0x560F46E8, "getting_on_ladder" },
    { 0x950868B2, "gettocart" },
    { 0xCF31B20E, "gettopkillstreak" },
    { 0xCFDBF500, "gettopkillstreakuniqueid" },
    { 0x469FC36E, "gettoplayers" },
    { 0x4B472F31, "gettopplayersbodymodel" },
    { 0x9D5612D4, "gettopplayersbodyrenderoptions" },
    { 0x00972B87, "gettopplayersgesture" },
    { 0x4E38486C, "gettopplayershelmetmodel" },
    { 0x8BC5EB3D, "gettopplayershelmetrenderoptions" },
    { 0x0D5713EA, "gettopplayersindex" },
    { 0x35E1B582, "gettopplayerstaunt" },
    { 0x276477A1, "gettopplayersteam" },
    { 0x7FEA98E6, "gettopplayersweaponinfo" },
    { 0x5D0C2BC0, "gettopplayersweaponrenderoptions" },
    { 0xE70758A5, "gettopscorercount" },
    { 0xBF24D151, "gettotalammo" },
    { 0x12AAC631, "gettotalplayersneededtoreachdistance" },
    { 0xD95AE389, "gettotaltimeplayed" },
    { 0xE406B982, "gettotalunlockedweaponattachments" },
    { 0x7B2B845A, "gettouchingvolume" },
    { 0x6C29F8F2, "gettrackerfxposition" },
    { 0x16FF7316, "gettraitstatvalue" },
    { 0x00254224, "gettraitvalue" },
    { 0x54816EB5, "gettransitionanim" },
    { 0x743EBBF6, "gettranssplittime" },
    { 0x4EE30B97, "gettreadhealth" },
    { 0xC7F4A7BD, "gettriggerpriorities" },
    { 0xF07226DC, "gettriggers" },
    { 0x1F79D967, "getturnangle" },
    { 0xD853634D, "getturnanim" },
    { 0x3FE48A81, "getturret" },
    { 0xC061776F, "getturretarclimits" },
    { 0xBE4E84FA, "getturretheatvalue" },
    { 0x5C475E9E, "getturretlimitsyaw" },
    { 0x410F56F9, "getturretnamefromupgradecount" },
    { 0x1A93EB9A, "getturretowner" },
    { 0x8A34AE5A, "getturrettarget" },
    { 0x6E7CF0C4, "getturrettargetvec" },
    { 0x4C37AD51, "getturretweapon" },
    { 0x7478CA90, "getturretweaponname" },
    { 0xD2E67CAE, "gettweakabledvar" },
    { 0x2F06E419, "gettweakabledvarvalue" },
    { 0x2CC01E2C, "gettweakablelastvalue" },
    { 0x9471660C, "gettweakablevalue" },
    { 0x557EB98C, "getuimodel" },
    { 0x0DD1BD95, "getuimodelforcontroller" },
    { 0x938048A7, "getuimodelvalue" },
    { 0x1EF0BA0F, "getuniqueflagnameindex" },
    { 0x4219A919, "getunit" },
    { 0x518551AD, "getunownedflagneareststart" },
    { 0x455256E4, "getup" },
    { 0xDE852B72, "getup_back" },
    { 0x8B479DE8, "getup_bar_value" },
    { 0x9BE86855, "getup_belly" },
    { 0xB36DE4CA, "getup_direction" },
    { 0x52C1C35C, "getupallowed" },
    { 0xB479C3B3, "getupanim" },
    { 0xA2B8F592, "getupdateteams" },
    { 0xB6FF90E2, "getupgradedpiecenumlives" },
    { 0x35B61BDE, "getupifpronebeforemoving" },
    { 0x2A692500, "getupladder" },
    { 0x17BBC617, "getups" },
    { 0x71A121C6, "getuserate" },
    { 0xBABC1DDB, "getutc" },
    { 0x886A6448, "getval" },
    { 0x4D08ED62, "getvalidcoverpeekouts" },
    { 0x05CFBB4B, "getvalidprotectlocationstart" },
    { 0x85E45CC7, "getvalidrandomcrashnode" },
    { 0x21DC60F3, "getvalidrandomleavenode" },
    { 0x20C58BA2, "getvalidrandomstartnode" },
    { 0xD9AFE5F3, "getvalidtargets" },
    { 0x63A3D9DE, "getvalidvoxlist" },
    { 0x4AD7CD92, "getvalueinrange" },
    { 0x9C8D1606, "getvar" },
    { 0xAE100D56, "getvectorarrayaverage" },
    { 0x9DA8F1A5, "getvectorrightangle" },
    { 0x8639C416, "getvehdamagemultiplier" },
    { 0x9CB37000, "getvehiclearray" },
    { 0x3472F3A1, "getvehicleavoidance" },
    { 0xE7AE0CF8, "getvehicleavoidancenodes" },
    { 0xD2D46DDE, "getvehiclebulletdamage" },
    { 0x4E28FDB7, "getvehiclehealth" },
    { 0x243BB261, "getvehiclenode" },
    { 0x533B6F1B, "getvehiclenode_safe" },
    { 0x8F8FB3B0, "getvehiclenodearray" },
    { 0xDD4657F1, "getvehicleoccupied" },
    { 0xD1B6FC6A, "getvehicleowner" },
    { 0x5F61262C, "getvehicleprojectilescalar" },
    { 0x42BEE061, "getvehicleprojectilesplashscalar" },
    { 0x7374BD7B, "getvehiclespawner" },
    { 0x6643D7E6, "getvehiclespawnerarray" },
    { 0x534D0025, "getvehicletargets" },
    { 0x2D2DDFD9, "getvehicleteamarray" },
    { 0x87F994C0, "getvehicletreadfxarray" },
    { 0xD4A3AEF4, "getvehicletriggerflags" },
    { 0xD389B572, "getvehicleunderneathsplashscalar" },
    { 0xA7EBE3E4, "getvehoccupants" },
    { 0x1439C75A, "getvelocity" },
    { 0x5415E6FB, "getvelocity_func" },
    { 0x68EC07F6, "getvendingmachinenotify" },
    { 0xB208B27E, "getverticaltan" },
    { 0x4C1C1B75, "getvictimbodyindex" },
    { 0x2FD0EE13, "getviewmodel" },
    { 0x1F24C2BA, "getviewpos" },
    { 0x34593ACC, "getvisiblecarriermodel" },
    { 0x655A9447, "getvisiblenode" },
    { 0x5984583E, "getvisiblenodes" },
    { 0x78D830E2, "getvisionpulsemaxradius" },
    { 0x91C70AF4, "getvisionpulseradius" },
    { 0xB39BDB6E, "getvisionsetnaked" },
    { 0xEE49A365, "getwagergametypelist" },
    { 0x5772C4D7, "getwallrunwallnormal" },
    { 0x89C97992, "getwatcherforweapon" },
    { 0x27DBF963, "getwatchernames" },
    { 0x7A23A070, "getwatcherweapons" },
    { 0x41D22555, "getwaterheight" },
    { 0xC4D5EC1F, "getweapon" },
    { 0x9B8EEE2C, "getweaponaccuracy" },
    { 0x159A070B, "getweaponammoclip" },
    { 0xE2F2CA49, "getweaponammofuel" },
    { 0x54D84899, "getweaponammostock" },
    { 0x697703F5, "getweaponammototal" },
    { 0x1F124A13, "getweaponattachments" },
    { 0x91CA66EB, "getweaponbasedgrenadecount" },
    { 0xBC47C25C, "getweaponbasedsmokegrenadecount" },
    { 0xA79C4C62, "getweaponchoice" },
    { 0xD7DDCF6D, "getweaponclass" },
    { 0x99618D67, "getweaponclass_array" },
    { 0x634D0F82, "getweaponclasszm" },
    { 0xC0DAD488, "getweaponclipmodel" },
    { 0x0DB9C802, "getweapondisplayname" },
    { 0x1A31ED32, "getweaponexplosionradius" },
    { 0x6A57E840, "getweaponfiresound" },
    { 0x1184302F, "getweaponfiresoundplayer" },
    { 0x9872DCFC, "getweaponfordecoy" },
    { 0xD530B733, "getweaponforwarddir" },
    { 0xE1ECC55C, "getweaponforweaponroot" },
    { 0x8E969C0B, "getweaponfusetime" },
    { 0x829C0364, "getweapongroup" },
    { 0x9BB127F1, "getweaponhackratio" },
    { 0x2CFA0531, "getweaponindex" },
    { 0x003AE84C, "getweaponindexfromname" },
    { 0x2D22FFE1, "getweaponinfoclip" },
    { 0x1B4C5AE8, "getweaponinfostring" },
    { 0x529B1EF7, "getweaponinfotype" },
    { 0xB0C3D179, "getweaponmindamagerange" },
    { 0x8BA30CAE, "getweaponmodel" },
    { 0x8FF9D066, "getweaponmuzzlepoint" },
    { 0xF97C4E1A, "getweaponobjecthackerradius" },
    { 0x97A1A49E, "getweaponobjecthacktimems" },
    { 0x2D30DDEE, "getweaponobjectwatcher" },
    { 0x610815C9, "getweaponobjectwatcherbyweapon" },
    { 0x1C1CF99A, "getweaponoptic" },
    { 0x16A63CBF, "getweaponoptions" },
    { 0xA4B7263C, "getweaponpickupsound" },
    { 0x304213EB, "getweaponpickupsoundplayer" },
    { 0x88BAE2C0, "getweaponprojexplosionsound" },
    { 0xB7AAFC41, "getweaponpulloutanim" },
    { 0xEE5B53A7, "getweaponrenderoptions" },
    { 0x21995B5A, "getweaponslist" },
    { 0xDA26566C, "getweaponslistprimaries" },
    { 0x07C422B5, "getweaponstat" },
    { 0x42B18222, "getweaponstowedmodel" },
    { 0x88DC3137, "getweaponsupportedattachments" },
    { 0xFFDC46A4, "getweaponswitchanim" },
    { 0x8DB69F37, "getweaponwithattachments" },
    { 0xC0F9F92A, "getweaponxcam" },
    { 0xF1405BC9, "getwheelsurface" },
    { 0xF5D0B54A, "getwinningteam" },
    { 0x79D6CCD1, "getwinningteamfromloser" },
    { 0x2FAF7654, "getwoodsoutside" },
    { 0xAC0FFD19, "getworldfogscriptid" },
    { 0x5CBA608E, "getxcam" },
    { 0xB3C67946, "getxcammousecontrol" },
    { 0x2E2873C6, "getxpamountforkillstreak" },
    { 0x6DD97E6B, "getxpeventcolumn" },
    { 0xD011C2C7, "getxpscale" },
    { 0xF49DD4FD, "getxuid" },
    { 0xFCAA5774, "getyaw" },
    { 0x41F6C01E, "getyaw2d" },
    { 0x5B863F14, "getyawangles" },
    { 0xEA85AD6A, "getyawfromorigin" },
    { 0xB8B76821, "getyawtoenemy" },
    { 0xDF15D2AD, "getyawtoorigin" },
    { 0xC43DF297, "getyawtospot" },
    { 0x1F191B59, "getyawtotag" },
    { 0x96BFC2DB, "getzbarrierarray" },
    { 0xDB6566BA, "getzbarrierattackslothorzoffset" },
    { 0x10440B37, "getzbarriernumattackslots" },
    { 0x63F99B7D, "getzbarrierpieceanimlengthforstate" },
    { 0xB43E98B0, "getzbarrierpieceanimstate" },
    { 0xBD20FC8C, "getzbarrierpieceanimsubstate" },
    { 0xEB222CA7, "getzbarrierpieceindicesinstate" },
    { 0x3C427221, "getzbarrierpiecestate" },
    { 0x75DDB352, "getzbarrierreachthroughattackanimstate" },
    { 0xBEFD5632, "getzbarriertauntanimstate" },
    { 0x6433B776, "getzmgamemodule" },
    { 0xB42D30BE, "getzmroundsplayed" },
    { 0x66DBF6C1, "getzombieleaderboardnumber" },
    { 0xACD2BB3B, "getzombiestatvariable" },
    { 0x0CF0E4E8, "getzonearray" },
    { 0x8BA5B480, "gewehr43" },
    { 0xEAB49798, "geyser" },
    { 0xC74CCD80, "geyser_activate" },
    { 0xE86FE0CD, "geyser_active" },
    { 0x640AD2C0, "geyser_anim" },
    { 0x4EE98CEB, "geyser_anims" },
    { 0xF6AA5438, "geyser_animtree" },
    { 0x0296497E, "geyser_blocker_remove" },
    { 0x270EC846, "geyser_blocker_think" },
    { 0xD4800095, "geyser_dust_time" },
    { 0x9B780F50, "geyser_earthquake" },
    { 0x3CAAE66A, "geyser_enabled" },
    { 0x6626F64E, "geyser_end" },
    { 0xDEB57EC7, "geyser_erupt" },
    { 0xA0B13DE9, "geyser_erupt_old" },
    { 0xA3F470F9, "geyser_fx" },
    { 0x17E2E86F, "geyser_sounds" },
    { 0xBA4B707D, "geyser_start" },
    { 0x1C1E3702, "geyser_start_ready_fx" },
    { 0xA6E9D9E0, "geyser_stop_effects" },
    { 0xCC3BF738, "geyser_stop_ready_fx" },
    { 0x502566D8, "geyser_trigger_dust_activate" },
    { 0x09AF7029, "geyser_trigger_dust_think" },
    { 0x6C76A328, "geyser_watch_for_player" },
    { 0xA00AB344, "geyser_watch_for_zombies" },
    { 0x13CF2DA2, "geyserfx" },
    { 0x2567A173, "geysers" },
    { 0x5D5DDC2C, "geysertrigger" },
    { 0x3FF2B651, "gforce" },
    { 0x5FAFA2B2, "gfx" },
    { 0xDD71DCD1, "gfx_map" },
    { 0xCE9ABA06, "gfx_shared" },
    { 0x7308D2D7, "gg" },
    { 0xF026D188, "gge" },
    { 0x3D59B27D, "ghe" },
    { 0xE59580F9, "gheight" },
    { 0xAD1A0D80, "ghetto" },
    { 0xB0FEAABC, "ghetto_animate_through_chain" },
    { 0x2A136F70, "ghetto_linkto" },
    { 0x70676731, "ghetto_tag" },
    { 0xCC186DD8, "ghetto_tag_create" },
    { 0x190B195E, "ghetto_unlink" },
    { 0xEE8C489B, "ghettolinkto" },
    { 0x25A9C079, "ghettomodel_obj" },
    { 0x6E2851A0, "ghettotag" },
    { 0x9AB9AD4B, "ghettotags" },
    { 0xDB94A0C6, "ghey" },
    { 0x2F07EB4B, "ghillie" },
    { 0x190EAA1A, "ghillie_leaves" },
    { 0x8C8E79FE, "ghost" },
    { 0x5FEFC5FB, "ghost_ai" },
    { 0x54B432E1, "ghost_amount" },
    { 0x2D3CD265, "ghost_back_flying_out_path_starts" },
    { 0xC9B1F426, "ghost_back_standing_locations" },
    { 0x94381DB8, "ghost_bad_path_failsafe" },
    { 0x018552B1, "ghost_bad_path_init" },
    { 0x074EF74C, "ghost_bad_spawn_zone_init" },
    { 0x105F4676, "ghost_bad_spawn_zones" },
    { 0xAE624E84, "ghost_check_point" },
    { 0x8ED6CEC2, "ghost_count" },
    { 0x9E2A1738, "ghost_custom_think_done" },
    { 0x16058775, "ghost_custom_think_func_logic" },
    { 0x4B4AE88A, "ghost_custom_think_logic" },
    { 0x1B2649DB, "ghost_damage_func" },
    { 0x0C201435, "ghost_damage_vo_watcher" },
    { 0x4E43ED96, "ghost_damaged_player" },
    { 0xB3925035, "ghost_data" },
    { 0x78368096, "ghost_death_func" },
    { 0x6C69564A, "ghost_debug" },
    { 0xA1990323, "ghost_delete_node" },
    { 0xBDB89644, "ghost_devgui_toggle_no_ghost" },
    { 0x0989E222, "ghost_devgui_warp_to_mansion" },
    { 0xCABF457E, "ghost_drained_player" },
    { 0x05594A6C, "ghost_drop_down_locations" },
    { 0xAA50C3E1, "ghost_effects" },
    { 0xD24D3E67, "ghost_entry_room_to_mansion" },
    { 0x1AAB1BB5, "ghost_entry_room_to_maze" },
    { 0x0E02F2E1, "ghost_force_killable" },
    { 0x7A52AC57, "ghost_front_flying_out_path_starts" },
    { 0xAD51E458, "ghost_front_standing_locations" },
    { 0x50BEA04F, "ghost_gazebo_pit_perk_pos" },
    { 0x97C97316, "ghost_gazebo_pit_volume" },
    { 0xF8F912A4, "ghost_german_behavior" },
    { 0x4B2EA9A5, "ghost_german_setup" },
    { 0x125058B1, "ghost_head_damage" },
    { 0x2B8E658B, "ghost_health" },
    { 0x47D49C40, "ghost_impact_effects" },
    { 0x4CEB5A7D, "ghost_init_end" },
    { 0x65AD48EE, "ghost_init_start" },
    { 0x9F2E249A, "ghost_is_adjacent" },
    { 0x28B00AF8, "ghost_location" },
    { 0x979FA753, "ghost_locations" },
    { 0x8D0C680B, "ghost_mansion_from_maze_push_trigger" },
    { 0xB365B224, "ghost_mansion_to_maze_push_trigger_left" },
    { 0xB8669C1B, "ghost_mansion_to_maze_push_trigger_right" },
    { 0x50DD8801, "ghost_next_drain_time_left" },
    { 0xFE7632FD, "ghost_node" },
    { 0x0B322B1D, "ghost_piano_reward_unavailable" },
    { 0x49422AE5, "ghost_piano_warp_to_bar" },
    { 0x0E59B6AF, "ghost_piano_warp_to_mansion_piano" },
    { 0x5BF4E157, "ghost_powerup" },
    { 0xD8843DE2, "ghost_print" },
    { 0x8346012E, "ghost_reset_anim" },
    { 0x0C84F173, "ghost_rooms" },
    { 0xA1B98EC9, "ghost_round_end" },
    { 0x18EDC6C3, "ghost_round_last_ghost_origin" },
    { 0xBE57C5CA, "ghost_round_last_ghost_origin_last" },
    { 0x856008CF, "ghost_round_override_init" },
    { 0x2E756406, "ghost_round_presentation_ghost" },
    { 0xA57BC082, "ghost_round_presentation_reset" },
    { 0x339359CA, "ghost_round_presentation_sound" },
    { 0x492E40F3, "ghost_round_presentation_think" },
    { 0x02D5A8A2, "ghost_round_start" },
    { 0xB2B2AF68, "ghost_round_start_conditions_met" },
    { 0xF2C23467, "ghost_round_start_monitor_time" },
    { 0xB309226E, "ghost_round_think" },
    { 0x865E8392, "ghost_round_think_override_func" },
    { 0xB1E64CAB, "ghost_script_move_sin" },
    { 0x98016D53, "ghost_spawn_locations" },
    { 0x0809D39E, "ghost_spawners" },
    { 0x502F140A, "ghost_springpad_fling" },
    { 0x391ED071, "ghost_start_area" },
    { 0xB5B27711, "ghost_steal_vo_watcher" },
    { 0xE9195429, "ghost_storage_start" },
    { 0x3D346B97, "ghost_switch_windows" },
    { 0x3D512F0F, "ghost_talk_to_target" },
    { 0x65C35F19, "ghost_talking" },
    { 0x7F8C760A, "ghost_teleport_point_index" },
    { 0xAACABE7F, "ghost_teleport_to_playable_area" },
    { 0x5A7C8E6B, "ghost_think" },
    { 0xE5ABB380, "ghost_visuals" },
    { 0x2ED85924, "ghost_vox" },
    { 0x727176A5, "ghost_vox_think" },
    { 0x1522973A, "ghost_wait_show" },
    { 0xA6C920FC, "ghost_wait_show_to_others" },
    { 0xB696C946, "ghost_wait_show_to_player" },
    { 0x44EBEC9A, "ghost_zone_door_clips" },
    { 0x48154E43, "ghost_zone_fountain_teleport_logic" },
    { 0xBEEF191F, "ghost_zone_name" },
    { 0x60109F7D, "ghost_zone_overrides" },
    { 0xD99C6914, "ghost_zone_spawning_think" },
    { 0x98592B6C, "ghost_zone_spawning_think_override_func" },
    { 0x25CED37D, "ghost_zone_start_lower_locations" },
    { 0x1B057350, "ghost_zone_teleport_logic" },
    { 0x18AB2C03, "ghostafterwait" },
    { 0x1A154E32, "ghostindemo" },
    { 0x91BD38A3, "ghostly" },
    { 0xBC1FE9E1, "ghosts" },
    { 0x01EC6FB5, "ghostship_fog" },
    { 0x5EE62119, "gi" },
    { 0xB2933395, "gi_unit_body" },
    { 0xD5F6FABF, "gi_unit_head" },
    { 0x967C254C, "giant" },
    { 0x7CA41045, "giant_cleanup" },
    { 0xBFA9D5A6, "giant_robot_close_head_entrance" },
    { 0xBA0A4CEE, "giant_robot_discovered" },
    { 0x5260B944, "giant_robot_discovered_vo" },
    { 0x56B8E9D5, "giant_robot_eject_disconnect_watcher" },
    { 0x8F82B5C2, "giant_robot_foot_waittill_sole_shot" },
    { 0xD7E51A9C, "giant_robot_footstep_safe_spots" },
    { 0x24B11CBA, "giant_robot_head_player_eject_end" },
    { 0xDAC76EC1, "giant_robot_head_player_eject_start" },
    { 0x60541037, "giant_robot_head_player_eject_thread" },
    { 0xF4EACAE0, "giant_robot_head_player_eject_thread_custom_func" },
    { 0x6E9CA2FC, "giant_robot_head_teleport_timeout" },
    { 0x582ADCD3, "giant_robot_id" },
    { 0x89FC4A1B, "giant_robot_initial_spawns" },
    { 0x069CD990, "giant_robot_intro_complete" },
    { 0x375CE386, "giant_robot_intro_exploder" },
    { 0x1062D05A, "giant_robot_intro_walk" },
    { 0xF6CEE52B, "giant_robot_spawn_end" },
    { 0xE5278E48, "giant_robot_spawn_start" },
    { 0x764593E8, "giant_robot_start_walk" },
    { 0x9132F14C, "giant_robot_stop" },
    { 0xF264B734, "giant_robot_think" },
    { 0x66476B55, "giant_robot_transition" },
    { 0x0E3719B6, "giant_robot_walk_cycle_complete" },
    { 0xF19072A9, "gib" },
    { 0xC6D59BE4, "gib_annihilate_flag" },
    { 0x2BB4034A, "gib_arm" },
    { 0x38C5093D, "gib_callback" },
    { 0xF7045680, "gib_chance" },
    { 0x1DE754B7, "gib_clientfield" },
    { 0xDE8A6760, "gib_clientfield_bits_actor" },
    { 0x0AE9EB4E, "gib_clientfield_bits_player" },
    { 0xFA5F3F12, "gib_clientfield_type" },
    { 0xEFE10ED8, "gib_corpse" },
    { 0xE25B8744, "gib_data" },
    { 0x25DA3A72, "gib_death" },
    { 0x86319A3A, "gib_death_1" },
    { 0x602F1FD1, "gib_death_2" },
    { 0x3A2CA568, "gib_death_3" },
    { 0x443DFE47, "gib_death_4" },
    { 0xB21754B9, "gib_debug_print" },
    { 0x4A86F5DD, "gib_delete" },
    { 0xB116F0C4, "gib_dir_bits" },
    { 0xA24B1B5A, "gib_fest" },
    { 0xC777903A, "gib_flag" },
    { 0x18CBDB15, "gib_flag_bits" },
    { 0x20C3AB28, "gib_flag_stripped" },
    { 0xB748690E, "gib_fx" },
    { 0xCFC6BE98, "gib_handler" },
    { 0x1A57A765, "gib_hat_model" },
    { 0x4B4318E2, "gib_head" },
    { 0x3469B63C, "gib_head_callback" },
    { 0xAB53F7D1, "gib_head_hat_flag" },
    { 0x89C8FC78, "gib_head_model" },
    { 0x50AE654B, "gib_legs" },
    { 0x5378E5EE, "gib_legs_both_legs_flag" },
    { 0x27C8E5A9, "gib_legs_left_leg_flag" },
    { 0xF3A6C2DC, "gib_legs_left_leg_gone_model" },
    { 0x13049537, "gib_legs_no_legs_model" },
    { 0xC96D08F6, "gib_legs_right_leg_flag" },
    { 0xC125DA87, "gib_legs_right_leg_gone_model" },
    { 0x627ECD0E, "gib_legs_undamaged_model" },
    { 0x23534029, "gib_location" },
    { 0x41524BDE, "gib_on_blundergat_damage" },
    { 0x18EB93A9, "gib_on_damage" },
    { 0xD70BFA44, "gib_override" },
    { 0x57DF343B, "gib_player" },
    { 0x8C38A9BD, "gib_ragdoll" },
    { 0xEEB7B47A, "gib_random_parts" },
    { 0x106CA5DD, "gib_range_squared" },
    { 0x20FEBDDB, "gib_ref" },
    { 0x4F29B364, "gib_rocket" },
    { 0xB624B795, "gib_scale_bits" },
    { 0x00BD3CE1, "gib_spawn" },
    { 0x92B382BB, "gib_state" },
    { 0xC233F74B, "gib_style" },
    { 0xA4B722B7, "gib_tags" },
    { 0x791FE6F8, "gib_throttle" },
    { 0x192CCFFF, "gib_time" },
    { 0xD1084742, "gib_toggle_gib_model_flag" },
    { 0x077F1378, "gib_torso_guts_flag" },
    { 0x5E98B325, "gib_torso_guts_gone_model" },
    { 0xAB1ED52B, "gib_torso_head_flag" },
    { 0x40B61CF2, "gib_torso_head_gone_model" },
    { 0xDD069E99, "gib_torso_left_arm_flag" },
    { 0x7FC8BF2C, "gib_torso_left_arm_gone_model" },
    { 0x0466231B, "gib_torso_no_arms_model" },
    { 0x6F2EB0DE, "gib_torso_right_arm_flag" },
    { 0x1A4DFB9F, "gib_torso_right_arm_gone_model" },
    { 0x14FA4D0C, "gib_torso_undamaged_model" },
    { 0xC7875B84, "gib_type" },
    { 0x94874FFF, "gib_undamaged_flag" },
    { 0xE3665FAD, "gib_vel" },
    { 0x979D676E, "gib_zombies_head" },
    { 0xA833A2D8, "gibarray" },
    { 0x1A717E8D, "gibbable" },
    { 0x03571C46, "gibbed" },
    { 0x1E8537B4, "gibbed_limbs" },
    { 0xBA73190C, "gibbed_pieces" },
    { 0x278BC757, "gibbedpieces" },
    { 0xB3A0E3AF, "gibbing" },
    { 0xFA3358F6, "gibbings" },
    { 0x5EC70049, "gibbundle" },
    { 0x66F67637, "gibcallbacks" },
    { 0xBFF2CF93, "gibclientutils" },
    { 0xB418A196, "gibcount" },
    { 0x97C94CE5, "gibdeath" },
    { 0x723E29A6, "gibdef" },
    { 0x19C51405, "gibdefinitions" },
    { 0x471062E6, "gibdelay" },
    { 0xED7B9B36, "gibdir" },
    { 0xE3BA76C7, "gibdynentfx" },
    { 0x5E3C1644, "gibentity" },
    { 0xEA852687, "gibflag" },
    { 0x3CC5C77E, "gibflags" },
    { 0x76527A6F, "gibfx" },
    { 0xE0183CB9, "gibfxtag" },
    { 0x96E36114, "gibhat" },
    { 0x65D0A3EB, "gibhead" },
    { 0x19A99733, "gibhidetag" },
    { 0xECBDC254, "gibleftarm" },
    { 0x18B95D62, "gibleftleg" },
    { 0x2D662B8E, "giblegs" },
    { 0x23BCDD1E, "gibmaxcount" },
    { 0x0E5AC6F0, "gibmodel" },
    { 0xF9CE5BAA, "gibpart" },
    { 0x4AF6C6E9, "gibpiece" },
    { 0x79390EC7, "gibpieceflag" },
    { 0x0DAB34F7, "gibpiecelookup" },
    { 0xF815BC88, "gibpiecename" },
    { 0x43EE536E, "gibpiecestruct" },
    { 0x66DC76A9, "gibresettime" },
    { 0x6BD6A8E5, "gibrightarm" },
    { 0xEE545103, "gibrightleg" },
    { 0x5CE61D20, "gibs" },
    { 0x97D6AAB7, "gibserverutils" },
    { 0xA6209976, "gibsound" },
    { 0x20826A1F, "gibspawn1" },
    { 0x82C5C3AD, "gibspawn1_defined" },
    { 0xAE7AFAE4, "gibspawn2" },
    { 0xFA74DC8A, "gibspawn2_defined" },
    { 0xD47D754D, "gibspawn3" },
    { 0x45263A17, "gibspawn3_defined" },
    { 0x62760612, "gibspawn4" },
    { 0x4168B6E4, "gibspawn4_defined" },
    { 0x8878807B, "gibspawn5" },
    { 0x9C50F051, "gibspawn5_defined" },
    { 0x87CF788F, "gibspawntag1" },
    { 0xF9EC9CFD, "gibspawntag1_defined" },
    { 0x15C80954, "gibspawntag2" },
    { 0xCE11581A, "gibspawntag2_defined" },
    { 0x3BCA83BD, "gibspawntag3" },
    { 0x68576927, "gibspawntag3_defined" },
    { 0xC9C31482, "gibspawntag4" },
    { 0x09A90BF4, "gibspawntag4_defined" },
    { 0xEFC58EEB, "gibspawntag5" },
    { 0x6D9171E1, "gibspawntag5_defined" },
    { 0xE19D938A, "gibspeed" },
    { 0x15DBA72C, "gibstate" },
    { 0x95915D2E, "gibstruct" },
    { 0x27228E48, "gibsworth" },
    { 0x33FD34A3, "gibtag" },
    { 0x91C820F8, "gibtimer" },
    { 0x33BBA463, "gift" },
    { 0x376F6B3E, "gift_trigger" },
    { 0x844CBDCA, "giftiger" },
    { 0x6397E1E4, "gig" },
    { 0xBF359717, "gigs" },
    { 0x05B32467, "gil" },
    { 0xF7FC478F, "gimbal" },
    { 0x5FEFF680, "gimme" },
    { 0x5A121138, "gimme_anim" },
    { 0xC69C1C69, "gimmie" },
    { 0xF948B604, "gimp_friendlies" },
    { 0xB8C4C0CD, "girders" },
    { 0xE6DB5907, "girl" },
    { 0x524431CF, "girl_1" },
    { 0xE03CC294, "girl_2" },
    { 0xAA49E925, "girl_dance4" },
    { 0xF87746FE, "girls" },
    { 0x5B0ED0BA, "give" },
    { 0xE4AE4515, "give up" },
    { 0x870B5138, "give_ability_now" },
    { 0x52C9C74A, "give_achievement" },
    { 0xAFAF20EB, "give_additional_primary_weapon_perk" },
    { 0xAF3D290B, "give_afterlife" },
    { 0x4C16E397, "give_ai_key" },
    { 0x380DD131, "give_ai_key_internal" },
    { 0xAE55ED84, "give_air_strike" },
    { 0x8EDFD503, "give_airstrike_to_all" },
    { 0x98EDAEA3, "give_ammo" },
    { 0x153EAF3F, "give_ammo_to_stupid_player" },
    { 0x9D7CCF96, "give_armor" },
    { 0xEC406829, "give_armor_amount" },
    { 0x75F710F6, "give_back_weapons" },
    { 0x0B81C1F0, "give_ballistic_knife" },
    { 0xF630D0AD, "give_beartraps_to_player_wrapper" },
    { 0xB287C624, "give_betties_after_rounds" },
    { 0xB2FE916B, "give_bonus_ammo" },
    { 0x3453D650, "give_bonus_points" },
    { 0xFD1EA670, "give_bonus_stink" },
    { 0x9430872D, "give_bowie" },
    { 0xBD181031, "give_build_kit_weapon" },
    { 0xCB861C5F, "give_bullet_shield" },
    { 0x39BB28EB, "give_capture_credit" },
    { 0xE82D73DF, "give_chernov_outro_flag" },
    { 0xB6193D7C, "give_civ_phone" },
    { 0xFE52DA09, "give_claymores_after_rounds" },
    { 0x69A87549, "give_craftable" },
    { 0x1F519216, "give_crate_killstreak_done" },
    { 0x1DD9D9FD, "give_crossbow" },
    { 0x9084E24B, "give_crossbow_expolsive" },
    { 0xCC920406, "give_deadshot_perk" },
    { 0x59B43B7D, "give_default_minigame_loadout" },
    { 0x701A5B3D, "give_door_open_prompt" },
    { 0x30ACA7A0, "give_dude_weapon" },
    { 0x34848EB9, "give_engineer_weapon" },
    { 0x7227D32B, "give_fallback" },
    { 0x38B8D666, "give_fallback_weapon" },
    { 0x608C4799, "give_flip_weapon_singleton" },
    { 0xDE5837E9, "give_fn" },
    { 0xA5C0460F, "give_for_streak" },
    { 0x6A0D11B4, "give_friendlies" },
    { 0x4818D313, "give_friendlies_monitor_use" },
    { 0x09EA16BF, "give_friendlies_thread_running" },
    { 0xD783EBC1, "give_gadget" },
    { 0x8CB25BB4, "give_generic_headlook" },
    { 0xB7A63200, "give_golden_shovel" },
    { 0x2BD1EC99, "give_grenade" },
    { 0xCA8F79EB, "give_gun_notify" },
    { 0x83B4A402, "give_guns_to_walltop_dudes" },
    { 0xFD286440, "give_held_credit" },
    { 0x34C150F2, "give_helmet" },
    { 0xB627F9AC, "give_hero_weapon" },
    { 0xCECAEC26, "give_hint" },
    { 0xBB52559B, "give_if_streak_count_matches" },
    { 0xEE585F92, "give_infinite_ammo" },
    { 0xE407D9C6, "give_internal" },
    { 0xFA3E4ABE, "give_john_woo_achievement" },
    { 0xC54B4A8C, "give_juggernaut_perk" },
    { 0xBEC4EA57, "give_killstreak" },
    { 0x1C38C267, "give_laststand" },
    { 0x8E336293, "give_lethal_grenade_thread" },
    { 0x729463EF, "give_light_armor" },
    { 0xBCBF5C97, "give_link_ent" },
    { 0x777B035F, "give_loadout" },
    { 0xBC7028B9, "give_map" },
    { 0xBE69E60F, "give_mason_weapons" },
    { 0xD6D39210, "give_match_bonus" },
    { 0x63C40086, "give_max_ammo_for_sniper_weapons" },
    { 0x49B30184, "give_me_a_gun" },
    { 0x927BE869, "give_me_my_head" },
    { 0xE6A5F6A5, "give_me_rockets" },
    { 0x61A1841A, "give_melee_weapon" },
    { 0x39D0D758, "give_melee_weapon_by_name" },
    { 0x256A9653, "give_menendez_guns" },
    { 0x8B3B463D, "give_menendez_perks" },
    { 0x6581C270, "give_model" },
    { 0x3E2607CB, "give_models_guns" },
    { 0x4AF8FCCC, "give_neutralized_credit" },
    { 0x82880FD8, "give_object" },
    { 0x7B2E1AF4, "give_owned" },
    { 0x7AE1B288, "give_pack_object" },
    { 0xC40F8692, "give_pdf_forcecolor" },
    { 0xF59BAB01, "give_perk" },
    { 0x47805C8B, "give_perk_for_a_time" },
    { 0x1DA41B1C, "give_perk_presentation" },
    { 0xFCA438C1, "give_perk_reward" },
    { 0x796DD6DA, "give_personality_characters" },
    { 0x60547EB3, "give_planted_grenade_thread" },
    { 0x082A5CC4, "give_player_all_perks" },
    { 0x45A4C2A7, "give_player_ammo" },
    { 0x1D620AAA, "give_player_armor" },
    { 0xD2A3E40E, "give_player_beartrap" },
    { 0xC4C2DC6B, "give_player_equipment" },
    { 0xA1615ED2, "give_player_godmode_for_timer_after_knife_throw" },
    { 0xFEAF45D4, "give_player_grenades" },
    { 0xC1DFEDD7, "give_player_headlook_during_scene" },
    { 0xFC201A7A, "give_player_key" },
    { 0xC6D20F42, "give_player_killstreaks" },
    { 0xAF28D243, "give_player_loadout" },
    { 0x3A75D996, "give_player_lots_of_m202_ammo" },
    { 0xEA3314E7, "give_player_macguffin_upon_receipt" },
    { 0xD1458F9A, "give_player_max_ammo" },
    { 0x62E78F1B, "give_player_minigame_loadout" },
    { 0x8F60F51F, "give_player_minigame_loadout_wrapper" },
    { 0xB7450843, "give_player_model_override" },
    { 0x03ADFC61, "give_player_mortars" },
    { 0x75FCF964, "give_player_perks" },
    { 0x90B1811A, "give_player_plunger_early" },
    { 0xBAA0CE4B, "give_player_rewards" },
    { 0x0807289A, "give_player_rpg" },
    { 0x12B44EA1, "give_player_shiv" },
    { 0x150A6FF2, "give_player_spoon_upon_receipt" },
    { 0xAD2A83BE, "give_player_sq_tpo_switch" },
    { 0xFB843CC9, "give_player_weapon_back" },
    { 0x4E6A4D54, "give_player_weapons" },
    { 0x36BC6D1E, "give_players_satchel_charge_and_threatbiasgroup" },
    { 0xD4F7AF48, "give_points" },
    { 0x543CDDAB, "give_powerup" },
    { 0x1FD1D9B5, "give_quick_revive_perk" },
    { 0x57435073, "give_random_perk" },
    { 0x48079E2F, "give_redshirt_gas_mask" },
    { 0xE4114064, "give_ref" },
    { 0x00289A8C, "give_reward" },
    { 0xA8CBDFE8, "give_reznov_weapon" },
    { 0x79ECC977, "give_round1_abilities" },
    { 0x7CA235EA, "give_scene_models_guns" },
    { 0x850C9918, "give_shovel" },
    { 0xCD06DBD5, "give_sq_bg_reward" },
    { 0x000D3724, "give_stage_drones_collision" },
    { 0x3D040FEE, "give_start_weapon" },
    { 0xB628DA11, "give_start_weapons" },
    { 0x4D4B6D2C, "give_tactical_granade_thread" },
    { 0xCC1B7EB8, "give_tactical_grenade_thread" },
    { 0x9FC49B2F, "give_tazer" },
    { 0x15A6CA9D, "give_team_characters" },
    { 0x7A1DACC7, "give_trophy" },
    { 0x55E2599B, "give_unregulated_threatbias" },
    { 0xE3720938, "give_vulture_bonus" },
    { 0x25BCEF4B, "give_vulture_perk" },
    { 0x40E2F6B9, "give_weapon" },
    { 0x06B59F2D, "give_weapon_back" },
    { 0x0D5883F0, "give_weapons" },
    { 0x6173A35A, "give_woods_gun" },
    { 0x8346C91B, "give_zhao_and_woods_health" },
    { 0x0A724D44, "giveability" },
    { 0xC718BB8F, "giveachievement" },
    { 0x44F50E0B, "giveachievement_wrapper" },
    { 0x8307B1B8, "giveammo" },
    { 0x085B1D74, "giveattackerandinflictorownerassist" },
    { 0x40B38F47, "giveback" },
    { 0x8DDCB54F, "giveback_player_weapons" },
    { 0x376BEA4D, "giveback_weapons" },
    { 0xA6EA9349, "givebaseweapon" },
    { 0x704D1B6C, "givecarryqrdrone" },
    { 0x0CEC4C18, "givecontractrewards" },
    { 0x29B51FE5, "givecrateammo" },
    { 0x6F182448, "givecratecapturemedal" },
    { 0x75AF8D2A, "givecrateitem" },
    { 0x4A5F0E8D, "givecratekillstreak" },
    { 0x964FEEC3, "givecratekillstreakwaiter" },
    { 0x3091002B, "givecrateweapon" },
    { 0x0A0C0AEB, "givecustomcharacters" },
    { 0x992D1966, "givecustomgamemodeplayerkilledscore" },
    { 0xED44E709, "givecustomloadout" },
    { 0xF07412C0, "givedecoration" },
    { 0x7AEB642D, "givededicatedshadow" },
    { 0x91E82E7B, "giveextraperks" },
    { 0x0C6BA395, "giveextrazombies" },
    { 0x84A4B6DE, "giveflagcapturexp" },
    { 0x57D5323B, "giveflipweapon" },
    { 0xF47CD5F6, "givefunction" },
    { 0x255A8968, "givegamerpicture" },
    { 0x6CB1B82C, "givegamerpicture_wrapper" },
    { 0x56194185, "givehardpoint" },
    { 0x6D8283A0, "givehardpointitem" },
    { 0xFEC7DDAB, "givehardpointitemforstreak" },
    { 0x95B6634B, "givehardpointitems" },
    { 0xF8594D34, "givehealth" },
    { 0x4DDD42BA, "giveheroweapon" },
    { 0xDEB51712, "givehuntedlethalgrenade" },
    { 0xC62032E9, "givehuntedtacticalgrenade" },
    { 0xDF09C95A, "givehuntedweapon" },
    { 0x2AA9CFA4, "giveinflictorownerassist" },
    { 0xF4F11E83, "givekillstats" },
    { 0x479C4898, "givekillstreak" },
    { 0x8C5A4793, "givekillstreakforstreak" },
    { 0xEC177867, "givekillstreakifstreakcountmatches" },
    { 0x358C9E2B, "givekillstreakinternal" },
    { 0x66234473, "givekillstreaks" },
    { 0x550EFB14, "givekillstreakweapon" },
    { 0x6DB03A8E, "givekillxp" },
    { 0x869F38E1, "givelastattackerwarning" },
    { 0xDBD2C557, "givelives" },
    { 0xA61641C6, "giveloadout" },
    { 0x68857C5F, "giveloadout_finalize" },
    { 0x79D05183, "giveloadout_init" },
    { 0x5EDB1868, "giveloadoutlevelspecific" },
    { 0xB3D97C2C, "givemagicbulletshield" },
    { 0xBEF742AE, "givematchbonus" },
    { 0x704B802A, "givemaxammo" },
    { 0x8C30E057, "givemedal" },
    { 0x3F1DCA70, "given" },
    { 0xB1264487, "given_amt" },
    { 0x1D55146C, "givenuponenemy" },
    { 0xBEA64207, "giveobject" },
    { 0xF8820BF9, "giveorremoveinvuln" },
    { 0x8BA5A13B, "giveorremovekillstreak" },
    { 0x363B0681, "giveownedhardpointitem" },
    { 0xBCC3B383, "giveownedkillstreak" },
    { 0xD23C71B9, "giveperks" },
    { 0xDF8EB6BE, "giveplayercontrolofrcbomb" },
    { 0x494030B3, "giveplayermomentum" },
    { 0xF56EBC1E, "giveplayermomentumnotification" },
    { 0x7E99FB41, "giveplayerscore" },
    { 0x9B842C9D, "giveplayerxpdisplay" },
    { 0xA79D7152, "givepointstowin" },
    { 0xCBC1672E, "givepowerup" },
    { 0x6CCC7536, "givepreviouslyearnedspecialistweapon" },
    { 0xAF9CF7D0, "giveprimaryoffhand" },
    { 0xA713E0CC, "giver" },
    { 0x381F2FFF, "giverandomweapon" },
    { 0x2589CAF0, "giverankxp" },
    { 0xCD165B35, "gives" },
    { 0x7AEB2DE4, "givescore" },
    { 0x76B01F20, "givesecondaryoffhand" },
    { 0x78FFBBC6, "givespecializedcrateweapon" },
    { 0xE193F5C5, "givespecialoffhand" },
    { 0x8A2E2B2D, "givesquadfeatures" },
    { 0x2D04E7E8, "givestartammo" },
    { 0x68917156, "givestartloadout" },
    { 0x9D4429ED, "givestolenweapononspawn" },
    { 0x57656623, "givestolenweaponslot" },
    { 0x806E3C51, "giveteamscore" },
    { 0x595758A3, "giveteamscoreforobjective" },
    { 0x794E30E4, "giveteamscoreforobjective_delaypostprocessing" },
    { 0xAABBE699, "giveturretback" },
    { 0x9320359D, "giveunlocktoken" },
    { 0x0000F21D, "giveuponmeleetime" },
    { 0x53D09583, "giveuponsuppression" },
    { 0xB577E1B8, "giveuponsuppressiontime" },
    { 0xFE922AD9, "giveupradiussqrd" },
    { 0x48B18EBE, "giveuptime" },
    { 0x860A040A, "giveweapon" },
    { 0xA11BD22A, "giveweaponnextattachment" },
    { 0x86D76F45, "giveweapons" },
    { 0x37A8EE32, "givexp" },
    { 0xBD86B501, "givexp_kill" },
    { 0xD281429C, "givin" },
    { 0x968B79CB, "giving" },
    { 0x2C1063DB, "gizma" },
    { 0xB381C3B0, "gk_dialogue" },
    { 0xC8BCC496, "gko" },
    { 0xD0ED9054, "gl" },
    { 0x89FFAC8F, "gl_lantern_crash_movement" },
    { 0x994FDD5A, "gl_lantern_damage_watcher" },
    { 0xF757B8AD, "gl_lantern_delete" },
    { 0x2CA77738, "gl_lantern_get_next_struct" },
    { 0xAF378373, "gl_lantern_move" },
    { 0xD4560F3B, "gl_lantern_move_to_struct" },
    { 0xD1254D48, "gl_lantern_pickup_watch" },
    { 0x670346D8, "gl_lantern_respawn" },
    { 0x88896CF0, "gl_lantern_respawn_wait" },
    { 0x15706611, "gl_lantern_spawn" },
    { 0xBA9BFF27, "gl_lantern_stop_spin_on_land" },
    { 0x8B8D85FD, "gl_lantern_teleport" },
    { 0x91E5656C, "gl_m16_upgraded_zm" },
    { 0x030F94DC, "gl_too_low_hint" },
    { 0x93F986B9, "glaaaaaare" },
    { 0x8BD4821B, "glad" },
    { 0x2EFF3919, "glaive" },
    { 0x226D16ED, "glaive_allowfriendlyfiredamage" },
    { 0xC24FBFDD, "glaive_blood_fx" },
    { 0xC6E986C3, "glaive_callback_damage" },
    { 0x856B724A, "glaive_change_position_toattack_target_delay" },
    { 0xE9AB3B34, "glaive_enemies" },
    { 0x5F305FB8, "glaive_enemy" },
    { 0x871A3B7A, "glaive_follow_dist" },
    { 0xCC28D50D, "glaive_following_target_range" },
    { 0x7ACB5C21, "glaive_fov_angle" },
    { 0xE25879CA, "glaive_ignore_cooldown" },
    { 0xBFC23708, "glaive_ignore_ent_cooldown" },
    { 0x4178DBAE, "glaive_initialize" },
    { 0x42D206F0, "glaive_margwa_aim_tag" },
    { 0x2795E6F3, "glaive_max_time_at_same_position" },
    { 0x50CCCC93, "glaive_melee_dist" },
    { 0xA305AAE4, "glaive_move_dist_height" },
    { 0x3501CC51, "glaive_move_dist_max" },
    { 0x12AF886F, "glaive_near_goal_dist" },
    { 0x649E089E, "glaive_radius" },
    { 0x6C4A17D0, "glaive_repath_range" },
    { 0xAD866C00, "glaive_target_selection" },
    { 0x9E7195D7, "glaivebloodfxhandler" },
    { 0xF23A98EB, "glaiveenemy" },
    { 0x6AFDAEE5, "glance" },
    { 0x6B21D273, "glancetransitiontime" },
    { 0xA90454DA, "glare" },
    { 0xBAA86887, "glass" },
    { 0x17A31E6C, "glass1" },
    { 0x89AA8DA7, "glass2" },
    { 0x63A8133E, "glass3" },
    { 0x5AA7E630, "glass_breach_think" },
    { 0xC366DF47, "glass_break" },
    { 0x348995AF, "glass_break_crows_start" },
    { 0xC65B4E6B, "glass_break_delay" },
    { 0x6DEB6F21, "glass_break_exploder" },
    { 0x7504B760, "glass_break_f" },
    { 0xF11D7F7A, "glass_break_l" },
    { 0x6D364794, "glass_break_r" },
    { 0xC5C38ECD, "glass_broken" },
    { 0x5D5A2A87, "glass_bullets_left" },
    { 0x738B1E02, "glass_bullets_right" },
    { 0xD4AECF1B, "glass_destroyed" },
    { 0xD3F4561A, "glass_exploder_init" },
    { 0x32F3AF14, "glass_exploder_think" },
    { 0x7FF671FC, "glass_exploder_watcher" },
    { 0x9B2B1758, "glass_fx" },
    { 0xDC031C38, "glass_fx_angle" },
    { 0xC9398FE5, "glass_gets_destroyed" },
    { 0x373F4E68, "glass_group_exploder_think" },
    { 0x86110596, "glass_list" },
    { 0x7B5DA7BC, "glass_logic" },
    { 0x8653B896, "glass_node_fix" },
    { 0x8290A1B3, "glass_node_think" },
    { 0x7658A61F, "glass_only_player_can_break" },
    { 0x56ECEF90, "glass_origin" },
    { 0x90718109, "glass_play_break_fx" },
    { 0xF1177E34, "glass_room_table_flip" },
    { 0x804DBE6D, "glass_room_tunnel_engagements" },
    { 0x4191F199, "glass_shatter" },
    { 0xBBB7065F, "glass_shatter_wait" },
    { 0xFD14BBC6, "glass_shattered" },
    { 0x7413B17A, "glass_smash" },
    { 0xBD7D8AE9, "glass_struct" },
    { 0xA4607E60, "glass_structs" },
    { 0xC446F17A, "glassarray" },
    { 0xE0B36459, "glasscollision_alt" },
    { 0x61631B73, "glasses" },
    { 0xA8E0D4D3, "glasses_bink_playing" },
    { 0x944ED0FB, "glasses_cam" },
    { 0x1C55F6A9, "glasses_movie_done" },
    { 0x0B36D9E9, "glasses_on" },
    { 0x7AA49BC5, "glasses_precache" },
    { 0xBB6A0E7E, "glasses_scene" },
    { 0xF8C9E12C, "glassexploder" },
    { 0x67E04AE0, "glassexploderindex" },
    { 0x625521B9, "glassexploderssetupcorrectly" },
    { 0x99DC5795, "glasshealth" },
    { 0xBE97ADEE, "glassradiusdamage" },
    { 0x823044D0, "glide_time" },
    { 0x5B6261DE, "glider" },
    { 0x8164DC47, "glides" },
    { 0x1A5C7109, "glimpses" },
    { 0xFB496E99, "glines" },
    { 0x8FED893F, "glint" },
    { 0xBE080EC0, "glint_fx" },
    { 0xFC775ABC, "glinty" },
    { 0x97E916DE, "glitch" },
    { 0x30032C9E, "glitches" },
    { 0x171765CB, "glitchy" },
    { 0x152F5A0F, "glo_hinge" },
    { 0x30E7635D, "glo_hinge_bot" },
    { 0xD2ACD02B, "glo_hinge_top" },
    { 0x6F5380D6, "glo_hinges" },
    { 0xD3E0EAFC, "global" },
    { 0x5BC37390, "global_actor_killed_callback" },
    { 0x948F8197, "global_actor_killed_challenges_callback" },
    { 0xD7176273, "global_ai_array" },
    { 0x6D65F101, "global_ai_cleanup_category_clear" },
    { 0x23F52086, "global_ai_cleanup_category_set" },
    { 0x51C77CD6, "global_anim_array" },
    { 0x5B594C00, "global_axis_settings" },
    { 0x8CB70CFC, "global_brutus_powerup_prevention" },
    { 0xD3D9513F, "global_callback_actor_killed_mason" },
    { 0xD4133429, "global_callback_actor_killed_menendez" },
    { 0x487406CD, "global_counter" },
    { 0x49BC1FDA, "global_creek_heroes_setup" },
    { 0xE88BB559, "global_damage_func" },
    { 0x6A21F752, "global_damage_func_ads" },
    { 0x2D60DE78, "global_funcs" },
    { 0x0AC7BE9B, "global_futz_watcher" },
    { 0xD6A4E7F5, "global_fx" },
    { 0x104F34B4, "global_fx_create" },
    { 0xF921BA9E, "global_gib_chance" },
    { 0x3B5652B4, "global_jug_behavior" },
    { 0x6C56E098, "global_kill_func" },
    { 0xF72D8B94, "global_neutral_settings" },
    { 0x5148C4E3, "global_oh_shit_cooldown_timer" },
    { 0x3F148836, "global_power" },
    { 0x4C4A66FB, "global_power_only" },
    { 0xCAFB8F44, "global_repel_anims_loaded" },
    { 0xDB4139B0, "global_spawn_count" },
    { 0x6A9E2403, "global_spawn_throttle" },
    { 0x9CE20742, "global_spawn_timer" },
    { 0x183CC1A7, "global_vars_hud" },
    { 0xAA12F7FE, "global_vehicle_spawn_func" },
    { 0x7E7BEF18, "global_zombies_killed" },
    { 0x7F8C1AD4, "global_zone_names" },
    { 0x97F58EC7, "globalafterlifes" },
    { 0x455804BD, "globalarraylookup" },
    { 0x3BB38240, "globalbackstabs" },
    { 0x50931859, "globalbankshots" },
    { 0x5266A7C0, "globalbarrelsdestroyed" },
    { 0x6347DCB4, "globalbombsdestroyed" },
    { 0xC8A13FB5, "globalbombsdestroyedbycommunists" },
    { 0x1898826D, "globalbombsdestroyedbyops" },
    { 0xAB476338, "globalbombsdestroyedbyteam" },
    { 0x99F56FFA, "globalbuzzkills" },
    { 0xA1CCD926, "globalcarsdestroyed" },
    { 0x788AB886, "globalchallenges" },
    { 0x5F9AB94C, "globalcomebacks" },
    { 0x0A9A3496, "globalcontractscppaid" },
    { 0x57E35AAE, "globalcontractsfailed" },
    { 0x540336D9, "globalcontractspassed" },
    { 0x1F5669B6, "globalcooloff" },
    { 0x9E7C6EC8, "globalcrossbowfired" },
    { 0xB4D9D516, "globaldembombsdestroyed" },
    { 0x852C1B89, "globaldembombsprotected" },
    { 0x6C5CB756, "globaldistancesprinted" },
    { 0x3D37E4C9, "globalexecutions" },
    { 0xA4CCD36A, "globalfeetfallen" },
    { 0x07223B2F, "globalfraggrenadesfired" },
    { 0xE636B61E, "globalfree" },
    { 0x48CEC971, "globalgrenadelaunchertracking" },
    { 0xB44E1BFD, "globalgrenadetracking" },
    { 0x6B9E1BF2, "globalized" },
    { 0xB02DCE0A, "globalkillstreakscalled" },
    { 0x4AB7F080, "globalkillstreaksdeathsfrom" },
    { 0xB988DA2A, "globalkillstreaksdestroyed" },
    { 0x2508C1CA, "globallarryskilled" },
    { 0xAA8E3DD8, "globalleaderboards" },
    { 0x2282EECE, "globallogic" },
    { 0xC0611484, "globallogic_actor" },
    { 0x051C2821, "globallogic_audio" },
    { 0xC58DC2EB, "globallogic_audio_dialog_on_player_override" },
    { 0x05DEB553, "globallogic_defaults" },
    { 0xB976075A, "globallogic_player" },
    { 0xE32B5089, "globallogic_score" },
    { 0xC4B7BF0C, "globallogic_setupcallbacks_zombies" },
    { 0xA4B13374, "globallogic_setupdefault_zombiecallbacks" },
    { 0x7956EECE, "globallogic_spawn" },
    { 0x88A69B2F, "globallogic_ui" },
    { 0xC46F5728, "globallogic_utils" },
    { 0xDEAEF99F, "globallogic_vehicle" },
    { 0xFC7AE8F9, "globally" },
    { 0xA86BAA0F, "globalmissiletracking" },
    { 0x3D9E455A, "globalpaybacks" },
    { 0x4DC38AD6, "globalrevives" },
    { 0xD9DF9ABF, "globals" },
    { 0x6B31497C, "globals_init" },
    { 0x225B4952, "globalsatchelchargefired" },
    { 0x615F7B8E, "globalscramblesound" },
    { 0xD6103A46, "globalsharepackages" },
    { 0xC317A785, "globalshotsfired" },
    { 0x62498E20, "globalskewered" },
    { 0x388CAB07, "globalteammedals" },
    { 0x8503363C, "globalthink" },
    { 0x03721A12, "globalvolume" },
    { 0x318C75F6, "globalzone" },
    { 0x5133A474, "globe" },
    { 0x571FE8EC, "globe_activate" },
    { 0xAE8149EB, "globe_down" },
    { 0x9501AABB, "globe_show_map" },
    { 0x865EBAD4, "globe_up" },
    { 0x1A7AF867, "globes" },
    { 0xC13EF7DA, "glocke" },
    { 0x490823D5, "glockes" },
    { 0x96987E4B, "glorious" },
    { 0x369334D8, "glory" },
    { 0x0B25D308, "glove" },
    { 0x5FAAE8F7, "glove_fx_on" },
    { 0x6C45D21C, "gloved" },
    { 0xE61BB123, "gloves" },
    { 0xCBD240EE, "glow" },
    { 0xCE3920AC, "glow_barrels" },
    { 0x10594FA1, "glow_change" },
    { 0x0289E75A, "glow_for_time" },
    { 0x49105E09, "glow_fx_array" },
    { 0x692A1288, "glow_location" },
    { 0x93EC140E, "glow_metal" },
    { 0xE6F6C7DD, "glow_monitor" },
    { 0x51470CBC, "glow_obj" },
    { 0x7E140A2E, "glow_obj_array" },
    { 0xCF9A586B, "glow_obj_b" },
    { 0xA997DE02, "glow_obj_c" },
    { 0xF40B6915, "glow_obj_cleanup" },
    { 0x44DE164C, "glow_obj_demo_jump_listener" },
    { 0xEF10F6B3, "glow_ring" },
    { 0xCB6019ED, "glow_window" },
    { 0xF8901CA6, "glowalpha" },
    { 0xC5D6F09A, "glowbb" },
    { 0xDDCF6F97, "glowcolor" },
    { 0x9A16F931, "glowed" },
    { 0x46962A2C, "glowfx" },
    { 0xFA331012, "glowing" },
    { 0xCEAF3848, "glowing_model" },
    { 0x58B09032, "glowing_retrievable_model" },
    { 0xC4F3A679, "glowing_rope" },
    { 0x51CB4846, "glowingbeacon" },
    { 0x3602D200, "gloworg" },
    { 0x84BFFD11, "glows" },
    { 0xA0B11E9B, "glowy" },
    { 0x27DFDD7D, "glowy_model" },
    { 0x77ACD29D, "glowy_rails" },
    { 0x5AACDCEA, "gm5" },
    { 0xE1F19B7F, "gm5_end_node" },
    { 0xC5EB90EC, "gmc" },
    { 0xBBDA380D, "gmj" },
    { 0x4F498217, "gmsk" },
    { 0xD3951877, "gmsk2" },
    { 0x0010BD13, "gmt" },
    { 0x4B914237, "gmt_offset" },
    { 0x9438185E, "gnaw" },
    { 0x45BA3613, "gnoll_target" },
    { 0x0492C1E9, "gnses" },
    { 0x16E98CCF, "gnu" },
    { 0x42F4FF8F, "go" },
    { 0xB1A38C69, "go_axis" },
    { 0xD8DBF567, "go_back" },
    { 0x3F19103D, "go_back_on_navvolume" },
    { 0x35656C68, "go_backward_node" },
    { 0xF4DBE6A6, "go_behind_barn" },
    { 0x8B121A20, "go_fast_1" },
    { 0xFD19895B, "go_fast_2" },
    { 0x90F43870, "go_forward_node" },
    { 0xE2708751, "go_go_ambient_planes" },
    { 0xA9B92B00, "go_helipad_guys" },
    { 0xC143407B, "go_hot" },
    { 0xE402428D, "go_hud_elem" },
    { 0x3F864A58, "go_into_tunnel_check" },
    { 0xF2B59508, "go_left_node" },
    { 0x676CB366, "go_no_matter_what" },
    { 0xD58A19DB, "go_over_wall" },
    { 0x341335DF, "go_past_ads_tut" },
    { 0x69785EB9, "go_past_ft_tut" },
    { 0xFF72658F, "go_path" },
    { 0x2FE82BEC, "go_pos" },
    { 0xCD8C3634, "go_prone" },
    { 0xEDC87CD4, "go_prone_line_check" },
    { 0xF557F0DB, "go_right_node" },
    { 0x5B91A08D, "go_silent" },
    { 0x2E942070, "go_sliders" },
    { 0x6EF5FAAD, "go_through_linked_nodes" },
    { 0x217BD47B, "go_to_and_setup_zipline" },
    { 0x67B695C9, "go_to_appropriate_goal" },
    { 0xB18D1A97, "go_to_cover_nodes" },
    { 0x7CDE29AD, "go_to_goal" },
    { 0xA8ACF8A5, "go_to_ground" },
    { 0xB860F0FC, "go_to_hide" },
    { 0xBD13793A, "go_to_near_owner" },
    { 0xA75A1050, "go_to_node" },
    { 0xEBAFD7B5, "go_to_node_arrays" },
    { 0xF7A84996, "go_to_node_by_name" },
    { 0xEC0B3F42, "go_to_node_by_noteworthy" },
    { 0x7EF0ED73, "go_to_node_delayed" },
    { 0x3C1BA37C, "go_to_node_set_goal_node" },
    { 0xEBA92F06, "go_to_node_set_goal_pos" },
    { 0x4AD5011D, "go_to_node_using_funcs" },
    { 0x28B60C38, "go_to_node_wait_for_player" },
    { 0xB73798A5, "go_to_node_with_notify" },
    { 0x93B98F3B, "go_to_nodes" },
    { 0xADBEC6DA, "go_to_origin" },
    { 0xF36D5AC7, "go_to_overlook" },
    { 0x7FFDBE09, "go_to_owner" },
    { 0xF477E8B4, "go_to_rebel_base" },
    { 0x33869EA8, "go_to_spawner_target" },
    { 0xD0CF063F, "go_to_struct" },
    { 0x7B819B2C, "go_to_unoccupied_node" },
    { 0x57A34BB7, "go_to_vulture" },
    { 0x4C5ED855, "go_up_hill" },
    { 0x48522EC6, "go_wave_two" },
    { 0x41D1AAF0, "goal" },
    { 0x133A38C9, "goal1" },
    { 0x393CB332, "goal2" },
    { 0x5F3F2D9B, "goal3" },
    { 0x81B11EF1, "goal_ang" },
    { 0x9F440F8B, "goal_angles" },
    { 0xD201D09A, "goal_array" },
    { 0x5AA7D4A0, "goal_attack_to_close_player" },
    { 0x1B78080F, "goal_cam_pos" },
    { 0x43A2D9DC, "goal_captor" },
    { 0xCAE1C399, "goal_changed" },
    { 0x27D2A269, "goal_changed_previous_frame" },
    { 0x9DB85CB7, "goal_die_to_player" },
    { 0xFF8F6944, "goal_dir" },
    { 0x99C72643, "goal_dist" },
    { 0xF2290D43, "goal_dist_f35_sq" },
    { 0xCD982772, "goal_dist_potus_sq" },
    { 0x64B677A8, "goal_failsafe" },
    { 0xE1EA3D0D, "goal_flag" },
    { 0xF50E4D02, "goal_flag_monitor" },
    { 0xD52328EF, "goal_in_trigger" },
    { 0x0B3AF919, "goal_index" },
    { 0xE74917FB, "goal_local_angles" },
    { 0x9DDE8226, "goal_local_offset" },
    { 0x783DEFBA, "goal_name" },
    { 0xC5F9F37F, "goal_node" },
    { 0x2504C6D7, "goal_node_name" },
    { 0x833B35FB, "goal_node_polonsky" },
    { 0xE2233DFF, "goal_node_radio" },
    { 0x2E3B8749, "goal_node_roebuck" },
    { 0x4D845DD4, "goal_node_targetname" },
    { 0x6CB68A86, "goal_nodes" },
    { 0x7AB80485, "goal_num_1" },
    { 0xA0BA7EEE, "goal_num_2" },
    { 0xC6BCF957, "goal_num_3" },
    { 0xFA541D16, "goal_offset" },
    { 0xDB79C8A5, "goal_origin" },
    { 0xBA6B4AF4, "goal_path_setup_needs_finishing" },
    { 0x7AA7336B, "goal_point" },
    { 0x4610C54A, "goal_points" },
    { 0xDD430493, "goal_pos" },
    { 0x141E460B, "goal_pos_back" },
    { 0x7203CF17, "goal_pos_front" },
    { 0x29A17C73, "goal_priority" },
    { 0xB1A1DC0D, "goal_prisonerl" },
    { 0xF5D86113, "goal_prisonerr" },
    { 0xA53104A1, "goal_radius" },
    { 0xA53E7A98, "goal_react_to_player" },
    { 0x259B3251, "goal_set" },
    { 0xBD5D3702, "goal_set_logic_small" },
    { 0x308F9AB8, "goal_speed" },
    { 0x884F3906, "goal_spots" },
    { 0xC92EF128, "goal_struct" },
    { 0xAF14B7C3, "goal_structs" },
    { 0x9D0B5121, "goal_tag" },
    { 0xEB084E47, "goal_then_cqb_aim" },
    { 0x7E8B4734, "goal_time" },
    { 0xEBF7D9AF, "goal_type" },
    { 0xA5F4CEB5, "goal_volume" },
    { 0xE13533BE, "goal_volume_init" },
    { 0xB61DFA9E, "goal_wait_notify_lase" },
    { 0x6A517A0A, "goal_watcher_patrol" },
    { 0x6FB6A6D3, "goal_watcher_target" },
    { 0xA68AD6E5, "goal_when_cantsee" },
    { 0xFF3CC935, "goal_world_offset" },
    { 0xA2463F80, "goal_yaw" },
    { 0xE47958BF, "goal_z" },
    { 0x743C4FD9, "goalangle" },
    { 0x81240290, "goalangles" },
    { 0x0FCB7865, "goaldir" },
    { 0x4C242AE0, "goaldist" },
    { 0x020617E6, "goaldradius" },
    { 0x93975DBF, "goalent" },
    { 0x4AE43031, "goalentity" },
    { 0x60FFEF39, "goalfailures" },
    { 0x19A22366, "goalflag" },
    { 0x3096A55F, "goalforced" },
    { 0x2BF19F8F, "goalforgiveness" },
    { 0xA1ED1ED1, "goalheight" },
    { 0xFBA6C968, "goaling" },
    { 0x0B92ED9F, "goalmatchesnode" },
    { 0x7565BC14, "goalnode" },
    { 0x35F4C387, "goalnodes" },
    { 0x65522CD6, "goalnoflyzone" },
    { 0x11205B49, "goalnoflyzones" },
    { 0x13846936, "goalorigin" },
    { 0xED8A8315, "goalpath" },
    { 0xE80BC3D2, "goalpoint" },
    { 0xAE11119E, "goalpos" },
    { 0x68B98F93, "goalpos1" },
    { 0xF6B22058, "goalpos2" },
    { 0x889A7B07, "goalpos_after_anim" },
    { 0xC9492B89, "goalposition" },
    { 0xD26DDD0E, "goalposupdatetime" },
    { 0x2C4EE229, "goalrad" },
    { 0xAF8C247F, "goalradii" },
    { 0x07DFAF62, "goalradius" },
    { 0xD56E5D23, "goalradius_changed" },
    { 0x1C5606C9, "goalradiussquared" },
    { 0x47939743, "goalradiusthreshold" },
    { 0x096483FC, "goalraidus" },
    { 0xDEA0935B, "goals" },
    { 0x5CB6B821, "goalspeed" },
    { 0xF39F6F4B, "goalstruct" },
    { 0xA0F31E50, "goaltag" },
    { 0x9E331C3E, "goaltagonground" },
    { 0xBAA607CB, "goaltime" },
    { 0x5B96FDA4, "goaltrigger" },
    { 0x2058D306, "goalvolume" },
    { 0xEC48ABB9, "goalvolumes" },
    { 0xCA6486B0, "goalweight" },
    { 0x9CACF768, "goalx" },
    { 0xC2AF71D1, "goaly" },
    { 0xD8EE79D1, "goalyaw" },
    { 0x8387618E, "goalyawangle" },
    { 0xA58851FE, "goalyawmethod" },
    { 0x11BDD7A8, "goat" },
    { 0x254964BD, "goatpath" },
    { 0xAD712825, "goatpath_complete" },
    { 0x8879551D, "gobj_model_offset" },
    { 0x63EC40BB, "gobj_objective_name" },
    { 0x4A284043, "gobj_offset" },
    { 0xE51B2D2D, "gobj_team" },
    { 0xF0367D9A, "gobj_trigger" },
    { 0xCBF03A71, "gobj_visuals" },
    { 0x740C713C, "goblack" },
    { 0x059EA1C1, "gocmd" },
    { 0x9F924BD9, "god" },
    { 0x990B71B0, "god_node" },
    { 0x54055CFB, "god_off" },
    { 0xFDF99C07, "god_on" },
    { 0xADB55110, "god_ray" },
    { 0x144E551D, "god_rod_perk_dialog" },
    { 0xA49FD7AF, "god_rod_shader_on" },
    { 0x8473FFBA, "god_rod_stop_hint" },
    { 0x28DE08BD, "god_rod_stop_weapon" },
    { 0x5CE2E1B6, "god_rod_weapon" },
    { 0x6287A869, "goddam" },
    { 0x9A111085, "goddammit" },
    { 0x4194CCC5, "goddamn" },
    { 0x38B3F2B2, "goddamned" },
    { 0xFD09A38E, "goddard" },
    { 0xC5FEDD9D, "goddard_re_spawned" },
    { 0xA1F6FFAF, "goddard_start" },
    { 0x60A1F06C, "godforsaken" },
    { 0x59CB8E21, "godirectly" },
    { 0x9DB45504, "godmode" },
    { 0x9FADFDFC, "godmodeallowed" },
    { 0x46C150C0, "godoff" },
    { 0x3B928E9A, "godon" },
    { 0xEB1D7F17, "godray" },
    { 0x7BAB4ACE, "godrays" },
    { 0x9A79C582, "godrod_challenge" },
    { 0x1EF72EDB, "goes" },
    { 0x85BD3F97, "gofloor" },
    { 0x8C6A3733, "goggles" },
    { 0xEEBAC46C, "goggles_controls" },
    { 0x0485148F, "goggles_fov" },
    { 0xD63410D3, "goggles_zoom" },
    { 0xE30DC0AD, "goggles_zoom_lerp" },
    { 0x2ACB34A3, "goggles_zoom_sound" },
    { 0x7C4DA1C1, "gogo" },
    { 0x0FA30D93, "gogogo" },
    { 0x7CF94A1F, "goign" },
    { 0x6495466A, "goin" },
    { 0xC340C1F1, "going" },
    { 0xE1E655D5, "going_back" },
    { 0xC1BA5730, "going_dark" },
    { 0x3992EEF1, "going_home" },
    { 0x9F998BEA, "going_to_baitnode" },
    { 0x9076D0C1, "going_to_link_node" },
    { 0x0054287C, "going_to_roof" },
    { 0xF7B89DF3, "going_up" },
    { 0xE8A8446D, "going_up_to_roof_nag" },
    { 0xC4917AB7, "goingtocovernode" },
    { 0x276E06C9, "goingtodifferentnode" },
    { 0xFB581D96, "goingtonode" },
    { 0x5A9F0337, "gold" },
    { 0xE3714856, "goldbar" },
    { 0x7EE3C186, "golden" },
    { 0x1FAC6C8A, "goldmine" },
    { 0x0E9A0E65, "golf" },
    { 0xCEBADC69, "golfcourse_water_drops" },
    { 0x424578D3, "goliath" },
    { 0x0A977EE7, "goliath_canned_left" },
    { 0xDDFF2AE2, "goliath_canned_right" },
    { 0xBADAEAD0, "goliath_strat" },
    { 0x740398DA, "goliath_strat_explode" },
    { 0xEC380802, "goliaths" },
    { 0x7B15AF56, "goliaths_left" },
    { 0xD2E1002D, "goliaths_right" },
    { 0xEA8512FB, "gondola_arrived" },
    { 0xEAEEEE0A, "gondola_cab" },
    { 0x129B3F7C, "gondola_chain_fx_anim" },
    { 0xB3BA1D6B, "gondola_chains_fxanims" },
    { 0x70017173, "gondola_cooldown" },
    { 0x5687CF6D, "gondola_doors_move" },
    { 0x06D4D4C9, "gondola_gate_and_door_moves" },
    { 0x35D5D1F6, "gondola_gate_moves" },
    { 0x249D5F36, "gondola_hostmigration" },
    { 0x6AC6BE2B, "gondola_lights_green" },
    { 0x82F51D8F, "gondola_lights_red" },
    { 0x233556E2, "gondola_moving" },
    { 0x784119C8, "gondola_moving_vo" },
    { 0x46A93EE7, "gondola_physics_explosion" },
    { 0xE57DD29D, "gondola_powered_on_roof" },
    { 0x2209F608, "gondola_sway" },
    { 0x494979E7, "gondola_triggered" },
    { 0x9555A95F, "gondolaloopsounds" },
    { 0x9F34AEED, "gondolasounds" },
    { 0xB3A723E4, "gone" },
    { 0xFFAC18B6, "gong" },
    { 0xB4C87A43, "gong_handler" },
    { 0x6AD41E2E, "gong_trigger_handler" },
    { 0x0B210B5B, "gong_watcher" },
    { 0x6C1012A9, "gongs" },
    { 0x81B56C9C, "gonna" },
    { 0xFF6F49AE, "goo_chain_depth" },
    { 0x24AFAF5A, "goo_last_pos" },
    { 0xDA26147D, "goo_last_vel" },
    { 0xEB4DB1FA, "good" },
    { 0x72B52CF3, "good_balcony" },
    { 0x87632626, "good_kill_dialogue" },
    { 0xB5A0FACD, "good_melee_target" },
    { 0x5D004A09, "good_mystery_wallbuy" },
    { 0xD0CE0960, "good_old_style_turret_tracing" },
    { 0x879F7CC9, "good_shot" },
    { 0x1CA4B6C1, "good_shot_vo" },
    { 0xFCD1EFE1, "good_spot" },
    { 0xB5E74B2C, "good_spot_check" },
    { 0xF8E8B1B9, "goodaccuracy" },
    { 0x9EF92DC6, "gooddist" },
    { 0xD340D796, "goodenemy" },
    { 0x20355DFC, "goodenemyonly" },
    { 0xFC76B848, "goodfriendlydistancefromplayersquared" },
    { 0xF75F5670, "goodie" },
    { 0x2CA58DDB, "goodies" },
    { 0xC57153FF, "goodness" },
    { 0x27467DFE, "goodnode" },
    { 0x919067A6, "goodradiussqrd" },
    { 0x1ED5BE75, "goods" },
    { 0x8BD9BF03, "goodshootpos" },
    { 0x5CA5E5E7, "goodshootposvalid" },
    { 0x916E3C90, "goodtraces" },
    { 0xD2EB3D49, "goodweap" },
    { 0x6B090CAB, "googles" },
    { 0x95376449, "gooo" },
    { 0x6CE18503, "gooodnight" },
    { 0x459879BC, "goooo" },
    { 0x9212C9F2, "goose" },
    { 0x06E29272, "gopath" },
    { 0xFBA69EF7, "gopher_fx" },
    { 0x2B141C7F, "gopher_init" },
    { 0xBC8FE72A, "gordon" },
    { 0x998D4EC0, "gore" },
    { 0x444B083B, "gorge" },
    { 0x7FD7C6EB, "gorky" },
    { 0xD5D2FEF0, "gorts" },
    { 0xE5DBE6FF, "goslin" },
    { 0x9C0A6350, "goslowmo" },
    { 0x34B24FD0, "gospeed" },
    { 0x3F6AA549, "got" },
    { 0xA5FB63C6, "got known enemy2" },
    { 0x804F5C21, "got_a_tomahawk_kill" },
    { 0x9443D9E6, "got_ability" },
    { 0x6BA63C86, "got_ai" },
    { 0xB3DC68FB, "got_booze" },
    { 0xAE7A291A, "got_easter_egg_reward" },
    { 0xEEAAF6B9, "got_flaked" },
    { 0x93330F76, "got_in_car" },
    { 0xD0962564, "got_in_round" },
    { 0x5201155C, "got_link" },
    { 0x01A866D0, "got_machete_attached" },
    { 0xAF77D3C6, "got_northeast" },
    { 0x61EF6960, "got_northwest" },
    { 0xC15621CC, "got_rider" },
    { 0xF3B31E14, "got_southeast" },
    { 0x9648918A, "got_southwest" },
    { 0xEB058044, "got_to_entrance" },
    { 0x7FD48D7A, "got_to_exit" },
    { 0xDF3238C5, "got_to_exit_on_alert" },
    { 0x2ECF27D1, "gotcha" },
    { 0x4473A15A, "gothismany" },
    { 0xE42A4FFC, "gotime" },
    { 0xF3C1F5D9, "gotnewhighscore" },
    { 0x3447CCBC, "goto" },
    { 0x1F355AD7, "goto next fallback" },
    { 0x7317DA2E, "goto_barge" },
    { 0xC74D9E62, "goto_current_colorindex" },
    { 0x75B50151, "goto_func" },
    { 0x9DD65783, "goto_new_position" },
    { 0x3F986A94, "goto_next_bunker" },
    { 0x16A1567B, "goto_node" },
    { 0xAEC00FC8, "goto_node_targetname" },
    { 0x2E581D2A, "goto_retreat_nodes" },
    { 0xF7D1395B, "goto_spot" },
    { 0x61B4DADC, "goto_struct" },
    { 0xADD40619, "goto_turret" },
    { 0xCA2DFA63, "goto_wander_anim_point" },
    { 0xE6952E8D, "gotocover" },
    { 0x967FAD46, "gotofunc" },
    { 0x370CF6D0, "gotonode" },
    { 0xD417602A, "gotonodeanddelete" },
    { 0x9735AA8C, "gotonodeandwait" },
    { 0x1E48C03E, "gotopoint" },
    { 0x2173A41A, "gotopos" },
    { 0x5B2C1707, "gototarget" },
    { 0x329C6435, "gotothelevel" },
    { 0x08BA73D2, "gotovolume" },
    { 0xBD24F176, "gotpullbacknotify" },
    { 0xA23F6BA9, "gotrigger" },
    { 0xF9C8CF44, "gotta" },
    { 0x52B8453E, "gotten" },
    { 0xCB1729DE, "gound" },
    { 0x8EA61D88, "government" },
    { 0x6910F8A3, "governments" },
    { 0x40D635DE, "gp_tutorial_turret" },
    { 0x6D0C00EF, "gpad_a" },
    { 0xFB0491B4, "gpad_b" },
    { 0x1E87F73F, "gpad_back" },
    { 0x6B4DEADA, "gpad_down" },
    { 0xCF6F7125, "gpad_l3" },
    { 0xB0E821BA, "gpad_l_shldr" },
    { 0x27890A1B, "gpad_l_trig" },
    { 0xC80CF849, "gpad_left" },
    { 0x80448C97, "gpad_r3" },
    { 0xAE081348, "gpad_r_shldr" },
    { 0x55E5543D, "gpad_r_trig" },
    { 0xB95E3274, "gpad_right" },
    { 0x29BC80A2, "gpad_start" },
    { 0x0F071CF1, "gpad_up" },
    { 0x16F5B33E, "gpad_x" },
    { 0x3CF82DA7, "gpad_y" },
    { 0xF219339A, "gpr" },
    { 0x5618C862, "gpr_cb" },
    { 0x988EC259, "gpr_ffff" },
    { 0x68F045F6, "gpr_op_code_bar" },
    { 0x6392F0F2, "gpr_op_code_bldg" },
    { 0x55896F91, "gpr_op_code_fx" },
    { 0x84A47B87, "gpr_op_code_set_team" },
    { 0x6E366D19, "gpr_op_shift" },
    { 0xE1CDA6F9, "gpr_payload" },
    { 0xBAC0D816, "gpr_queue" },
    { 0x0510B4C3, "gpr_shift" },
    { 0x876D4EDA, "gpr_sign_bit" },
    { 0xB48E0ECC, "gpr_state" },
    { 0x07AC3CC6, "gpr_updated" },
    { 0xFD117F21, "gpsjammeractive" },
    { 0x631F60A4, "gpsjammerinactive" },
    { 0x1F1CC3EA, "gpsjammerprotection" },
    { 0xB576929E, "gr_eject_fall_complete" },
    { 0x9DF817C8, "gr_eject_landing_rumble" },
    { 0xD5CC02D6, "gr_eject_landing_rumble_on_position" },
    { 0xB03C4326, "gr_eject_sequence_complete" },
    { 0xA4D81F61, "gr_foot_hatch_closed" },
    { 0x42F46193, "gr_head_eject_trigger_visibility" },
    { 0x3EC1BFE6, "gr_head_exit_trigger_start" },
    { 0x86D94575, "gr_head_forced_bleed_out" },
    { 0x241BE89D, "gr_mason" },
    { 0xB54C257D, "gr_weaver" },
    { 0xA1CD57A9, "gr_woods" },
    { 0x3FA6C0A7, "grab" },
    { 0x50FDFC20, "grab_ai_by_script_noteworthy" },
    { 0x35F8C4C9, "grab_ai_by_targetname" },
    { 0x6D679B91, "grab_ais_by_script_noteworthy" },
    { 0x9BE91AF3, "grab_bonfire_sale" },
    { 0x88D5FA3A, "grab_carpenter" },
    { 0xA75D3D72, "grab_check" },
    { 0xF304FB0F, "grab_count" },
    { 0x3829BA5A, "grab_detonator" },
    { 0x73857F09, "grab_double_points" },
    { 0xAA4D46E1, "grab_dragovich" },
    { 0x9CC0D3CC, "grab_fire_sale" },
    { 0x1C927783, "grab_free_perk" },
    { 0x50D0A2EF, "grab_friendlies" },
    { 0xE72C77FA, "grab_full_ammo" },
    { 0x46BB325C, "grab_gun" },
    { 0x325911DE, "grab_insta_kill" },
    { 0x7DE52DF3, "grab_light_origin" },
    { 0xC2688C83, "grab_minigun" },
    { 0x576218B9, "grab_nuke" },
    { 0x3355FEAE, "grab_perk" },
    { 0xF96FBB6A, "grab_perk_hint" },
    { 0x14CDE1FD, "grab_player" },
    { 0xCCA0A206, "grab_powerup" },
    { 0x9F93D206, "grab_rope_actions" },
    { 0x4F7872E8, "grab_shield_charge" },
    { 0xBF43AD80, "grab_starting_friends" },
    { 0xC7A975C1, "grab_starting_guys" },
    { 0x99E416A2, "grab_weapon" },
    { 0x2223377E, "grab_weapon_hint" },
    { 0xAEEB4A30, "grab_weapon_name" },
    { 0x61DFDA23, "grab_ww_grenade" },
    { 0x570BF626, "grabbable_by_anyone" },
    { 0x7F7C6EDC, "grabbed" },
    { 0x6A04CB82, "grabbed_from_magicbox" },
    { 0x817CD17C, "grabbed_from_perk_random" },
    { 0x88D12FED, "grabbed_level_notify" },
    { 0xD34FD37A, "grabber" },
    { 0xDA307AF5, "grabbers" },
    { 0xEB1B97C9, "grabbing" },
    { 0xE14A021E, "grabs" },
    { 0x9A94DF07, "grace" },
    { 0xE58D664D, "grace_period" },
    { 0xE7E9D341, "grace_period_ending" },
    { 0x1EE47B30, "graceful" },
    { 0xE45CFE95, "gracefully" },
    { 0x637E0994, "graceperiod" },
    { 0x4C94A76E, "graceperiodfunc" },
    { 0x8636C407, "graceperiods" },
    { 0xE58538FE, "graces" },
    { 0xB1EB6CD9, "gracetimeatdestination" },
    { 0xFC13AE9B, "graciously" },
    { 0x290B98FA, "gradiate_move_speed" },
    { 0xC8ED3335, "gradual" },
    { 0x74C19898, "gradually" },
    { 0x3C3F8251, "graffiti" },
    { 0xEA2F7D72, "grain" },
    { 0x0B816B9F, "grain_filter" },
    { 0xA501E17D, "grainstrength" },
    { 0xED1D61E5, "gramophone" },
    { 0x3109D6B8, "gramophone_" },
    { 0x3B3E77EF, "gramophone_model" },
    { 0x2AF351C9, "gramophone_place_vo" },
    { 0x8FFA2305, "gramophone_vinyl_player_picked_up" },
    { 0x84D14ECD, "gramophonecraftable" },
    { 0x8D21FD49, "granade" },
    { 0x400A1625, "grand" },
    { 0x21120AA7, "grandfather" },
    { 0xBBDB9808, "grandfather_clock" },
    { 0xDFE26F95, "grant" },
    { 0x0684C87C, "grant_enemy" },
    { 0x72F9BEEC, "grant_node" },
    { 0x056FACC2, "granted" },
    { 0x671A6607, "granularity" },
    { 0x3B823567, "graph" },
    { 0xC96E6857, "graphic" },
    { 0xC2315878, "graphic_filter_on" },
    { 0xB647AF0E, "graphics" },
    { 0xC2DAA8EE, "grapple" },
    { 0xAC3CB3C8, "grapple_direction" },
    { 0x2F0976F1, "grapple_done" },
    { 0x5B757ACC, "grapple_drone_flyby" },
    { 0xE45657FE, "grapple_hud_text" },
    { 0x62B68D4A, "grapple_is_fatal" },
    { 0xC639AD94, "grapple_name" },
    { 0xF8094267, "grapple_notarget_distance" },
    { 0x46473359, "grapple_notarget_enabled" },
    { 0x4EF0A823, "grapple_origin" },
    { 0x4DFCC30F, "grapple_outline_material" },
    { 0x6510E565, "grapple_retarget_delay" },
    { 0xF87C2875, "grapple_rope" },
    { 0xBF58CFF7, "grapple_rope_run" },
    { 0x8DA68C26, "grapple_target" },
    { 0x1738F1C9, "grapple_target_weight_dot_over_dist" },
    { 0x9E41B359, "grapple_targets" },
    { 0xF9127EA5, "grapple_type" },
    { 0xB4D1C1E1, "grapple_type_pullentin" },
    { 0xB692C5BF, "grapple_type_reelplayer" },
    { 0xBED59511, "grapple_type_targetonly" },
    { 0x9226EB69, "grapple_type_ungrapplable" },
    { 0x1E6C65F1, "grapple_unwield" },
    { 0xF543D7DA, "grapple_valid_target_check" },
    { 0x8E70AB6E, "grappleweapon" },
    { 0xF98E9974, "graps" },
    { 0xEA2D6EDA, "grasp" },
    { 0xC42AF471, "grass" },
    { 0xB3382BA4, "grass_admin_camo_guys_strat" },
    { 0xE09D70D3, "grass_admin_camo_guys_strat_2" },
    { 0xBA9AF66A, "grass_admin_camo_guys_strat_3" },
    { 0xB1F53495, "grass_admin_surprise" },
    { 0x76DAE39B, "grass_admin_surprise_damage" },
    { 0x86163F23, "grass_admin_surprise_proximity" },
    { 0x5650AC76, "grass_ambush_vo_1" },
    { 0x304E320D, "grass_ambush_vo_2" },
    { 0x7BD0C303, "grass_array" },
    { 0x7D314D10, "grass_bunkers_surprise_damage" },
    { 0x821E18A4, "grass_camo_guys_1_strat" },
    { 0x4BF69627, "grass_camo_halfshield_delay" },
    { 0x09EBA565, "grass_camo_ignore_delay" },
    { 0xFEE5D9FA, "grass_delete_when_offscreen" },
    { 0xD23EAA0D, "grass_guy" },
    { 0x28D2AE55, "grass_guy_shoots_trapped_guy" },
    { 0x2C2C874D, "grass_guy_shoots_trapped_guy2" },
    { 0x73274F8C, "grass_guys" },
    { 0x8936C5B7, "grass_mortars_camo_guys_strat" },
    { 0xC4C69853, "grass_obj" },
    { 0x88ACE56D, "grass_surprise" },
    { 0xB474EE83, "grass_surprise_damage" },
    { 0xE3627F6D, "grass_surprise_half_shield" },
    { 0xBB201885, "grass_to_player" },
    { 0x2056C162, "grass_trig" },
    { 0xA0C99F2D, "grassy_knoll" },
    { 0x013C69EE, "grate" },
    { 0x44A035E3, "grate_order" },
    { 0xA4BB6640, "grate_order1" },
    { 0x16C2D57B, "grate_order2" },
    { 0xF0C05B12, "grate_order3" },
    { 0x62C7CA4D, "grate_order4" },
    { 0x3CC54FE4, "grate_order5" },
    { 0xAECCBF1F, "grate_order6" },
    { 0xD891884F, "grate_order_destroyed" },
    { 0x69749CD7, "grate_repair_order" },
    { 0x5368C57C, "grate_repair_order1" },
    { 0xC57034B7, "grate_repair_order2" },
    { 0x9F6DBA4E, "grate_repair_order3" },
    { 0xE1615641, "grate_repair_order4" },
    { 0xBB5EDBD8, "grate_repair_order5" },
    { 0x2D664B13, "grate_repair_order6" },
    { 0x50DB78F5, "grate_shake_swap" },
    { 0x9ADE8811, "grates" },
    { 0x57AEFA07, "grating" },
    { 0x6B912B62, "gratitude" },
    { 0x07C47D93, "grav" },
    { 0x80470504, "grave" },
    { 0x4956F5C1, "grave_blow_in_face" },
    { 0xD786FAF5, "grave_ents" },
    { 0xE1FB00C0, "grave_spawners" },
    { 0xC975DA42, "grave_state_count" },
    { 0xEAC14100, "gravel" },
    { 0x850E13B7, "graves" },
    { 0x3E48D350, "graves_blowstatus" },
    { 0xC214C302, "graves_d" },
    { 0x96D13F04, "gravesites" },
    { 0xA62A4A2C, "gravespot" },
    { 0x6637C62B, "gravestone" },
    { 0xDA06AC96, "gravestone_isblowing" },
    { 0x4239AB52, "gravetrig" },
    { 0xFFA15DCC, "graveyard" },
    { 0x8F206047, "graveyard_ambush" },
    { 0xC636CA01, "graveyard_backhalf" },
    { 0x1C0BC9D9, "graveyard_check" },
    { 0x6EF6B966, "graveyard_church_breakable" },
    { 0x723C90FB, "graveyard_church_breakable_flag" },
    { 0x64AF9E49, "graveyard_church_ladder" },
    { 0xA6CCA03E, "graveyard_deadhind" },
    { 0x81954F11, "graveyard_friendly_strat" },
    { 0x8DA413F0, "graveyard_get_down" },
    { 0xC9A6FFFC, "graveyard_hind" },
    { 0x2E09962A, "graveyard_hind_attack_enemy" },
    { 0x9A7D5110, "graveyard_hind_death_dialogue" },
    { 0xB0C8233E, "graveyard_hind_detect_damage" },
    { 0x66D8C74F, "graveyard_hind_find_best_perimeter" },
    { 0x3FF74446, "graveyard_hind_kill_body" },
    { 0xA77D3948, "graveyard_hind_ready" },
    { 0x7DA237AC, "graveyard_hind_spot_behavior" },
    { 0xA9E3173A, "graveyard_hind_spot_enemy" },
    { 0xE532C4FF, "graveyard_hind_stinger_flares_fire_burst" },
    { 0x4FFD274C, "graveyard_hind_stinger_logic" },
    { 0x90D0ECF5, "graveyard_hind_stinger_reaction_wait" },
    { 0x61EE19C0, "graveyard_hind_strafe_path" },
    { 0x9309C26C, "graveyard_main" },
    { 0xB1D3D797, "graveyard_moveup" },
    { 0x6BAB39F2, "graveyard_panther_strat" },
    { 0x3462FAAF, "graveyard_pos" },
    { 0x9F6A4FE6, "graveyard_tanks" },
    { 0x0CF5DC1D, "graveyard_tanks_2" },
    { 0x28D2AD3F, "graveyard_waithind" },
    { 0xB8D13625, "gravity" },
    { 0x2FC58187, "gravity_anim" },
    { 0x671DC9EB, "gravity_player_in" },
    { 0xBC826F7E, "gravity_player_out" },
    { 0xBBECD0B4, "gravity_pulls" },
    { 0xAED871B4, "gravity_shift" },
    { 0xDEF2E02A, "gravity_slam_down" },
    { 0xF00CA2D8, "gravity_slam_fx" },
    { 0x1386CD6A, "gravity_slam_player_fx" },
    { 0x7B5260FB, "gravity_slam_speed" },
    { 0xE7543328, "gravity_spike_expired" },
    { 0x6685B216, "gravity_spike_melee_kill" },
    { 0xA38A9D64, "gravity_spike_planted_play" },
    { 0x7441D62B, "gravity_spike_position_valid" },
    { 0x0F895FAF, "gravity_spike_table" },
    { 0xD88B33BD, "gravity_spike_zombie_explode" },
    { 0x5C7E4FF5, "gravity_spikes" },
    { 0xFC513E92, "gravity_spikes_dirt_duration" },
    { 0x3338E3F0, "gravity_spikes_dirt_fade_time" },
    { 0x811279E5, "gravity_str" },
    { 0x3B94D3AC, "gravity_trap_check" },
    { 0x60E87E59, "gravity_trap_complete" },
    { 0x07C1F58A, "gravity_trap_destroy" },
    { 0xD925ADB6, "gravity_trap_fx" },
    { 0x85B1964C, "gravity_trap_fx_off" },
    { 0xDEADC276, "gravity_trap_fx_on" },
    { 0x99BB9DB1, "gravity_trap_location" },
    { 0xEDA083D6, "gravity_trap_loop" },
    { 0x954EC67A, "gravity_trap_notify_watcher" },
    { 0xF392F058, "gravity_trap_planted" },
    { 0x4B3BF003, "gravity_trap_rumble" },
    { 0xDEF5E8B7, "gravity_trap_rumble_callback" },
    { 0x49D6151C, "gravity_trap_spike_spark" },
    { 0xE1885A4B, "gravity_trap_spike_watcher" },
    { 0x2CCC1B84, "gravity_trap_spikes_retrieved" },
    { 0xAF8BE6F0, "gravity_trap_timeout_watcher" },
    { 0x6A359E28, "gravity_trap_trigger_activate" },
    { 0x23D2CC59, "gravity_trap_trigger_think" },
    { 0x66B8CE07, "gravity_trap_trigger_visibility" },
    { 0x817FF1ED, "gravity_trap_unitrigger_stub" },
    { 0xE56D070C, "gravity_trigger" },
    { 0x4881E08F, "gravity_triggers" },
    { 0xFC16FEF9, "gravity_zombie_death_response" },
    { 0xD03A733C, "gravity_zombie_in" },
    { 0xA866A413, "gravity_zombie_out" },
    { 0xC508229A, "gravity_zombie_update" },
    { 0xA1E09ED6, "gravityforce" },
    { 0x89B417E9, "gravityspike_owner" },
    { 0xE68B4090, "gravityspike_position_check" },
    { 0xC584B3CD, "gravityspikes_altfire_watcher" },
    { 0x1F53D39A, "gravityspikes_attack_watcher" },
    { 0x6716A6E7, "gravityspikes_attack_watchers_end" },
    { 0xE0511E28, "gravityspikes_power_expired" },
    { 0x4650A121, "gravityspikes_power_override" },
    { 0x6B90B056, "gravityspikes_power_update" },
    { 0xCCA97C44, "gravityspikes_slam" },
    { 0x887585BA, "gravityspikes_state" },
    { 0x152E0AAC, "gravityspikes_state_charging" },
    { 0xC40CDC44, "gravityspikes_state_depleted" },
    { 0x07DADCB9, "gravityspikes_state_inuse" },
    { 0x08911D69, "gravityspikes_state_not_picked_up" },
    { 0xB687BC8E, "gravityspikes_state_ready" },
    { 0x2460A8F9, "gravityspikes_stuck_above_zombie_watcher" },
    { 0x844248DE, "gravityspikes_swipe_watcher" },
    { 0x8142ACA1, "gravityspikes_target_filter_callback" },
    { 0x64F2541B, "gravityspikes_target_filtering" },
    { 0xC34EBAF4, "gravityspikes_timer_end" },
    { 0xD4F304C0, "gravitytoblendtime" },
    { 0xFDB324B4, "gray" },
    { 0x1A8E4E15, "gray1" },
    { 0x4090C87E, "gray2" },
    { 0x669342E7, "gray3" },
    { 0x5C81EA08, "gray4" },
    { 0x82846471, "gray5" },
    { 0xA886DEDA, "gray6" },
    { 0xCE895943, "gray7" },
    { 0xC4780064, "gray8" },
    { 0xEA7A7ACD, "gray9" },
    { 0x50C728D1, "grazing" },
    { 0x5C702A1A, "greanade" },
    { 0x15E4CD87, "greande" },
    { 0x8459AC7E, "greandes" },
    { 0x88581954, "great" },
    { 0x0D7499F1, "greater" },
    { 0x8DA16499, "greater_dot" },
    { 0x9F116CB5, "greater_than" },
    { 0xDEA371C6, "greater_than_or_equal_to" },
    { 0x546C4FB4, "greaterthan" },
    { 0xBC50C2FF, "greaterthanequals" },
    { 0x583A990C, "greatest" },
    { 0xFA122911, "greatly" },
    { 0xF4F4A128, "greed" },
    { 0xBF8B5F73, "greedcardsactive" },
    { 0x1B2FFFA9, "greedy" },
    { 0x10E5C2B2, "green" },
    { 0x789F2C5B, "green_allies" },
    { 0x9B4F35CB, "green_awning" },
    { 0x18DD05FC, "green_awning_clip" },
    { 0xF7E065D4, "green_backyard" },
    { 0x72CF8FF5, "green_guys" },
    { 0xCC332D7F, "green_light" },
    { 0x3FE147F1, "green_new" },
    { 0x24EA2C50, "green_patio" },
    { 0xD2EB5D09, "green_patio_clip" },
    { 0xE8DA3926, "green_reticle_color_index" },
    { 0xD2510694, "green_smoke" },
    { 0x1635A4F9, "green_structs" },
    { 0x5BE6F854, "green_zone_volume" },
    { 0x46C27377, "greenbarrel1" },
    { 0xD4BB043C, "greenbarrel2" },
    { 0x10FBE542, "greenhouse" },
    { 0x40795FE9, "greenhouse_barn_door" },
    { 0xC2331D36, "greenhouse_fake_target" },
    { 0x9F62BB0E, "greenhouse_heli_light_off" },
    { 0x19D27194, "greenhouse_helicopter_reaction_wait" },
    { 0x3F27EEA9, "greenhouse_stinger" },
    { 0x11D53F3E, "greenlight" },
    { 0xC5875D3D, "greens" },
    { 0x392B262E, "greer" },
    { 0x551C47B8, "greet" },
    { 0xB46975CE, "greeting_timer" },
    { 0x44C61513, "greets" },
    { 0xF0E69B12, "greifing" },
    { 0x0D66E4E7, "gren" },
    { 0xE5C98F9F, "gren_lookat_override" },
    { 0x730115B9, "gren_orig" },
    { 0x0F461B5D, "grenade" },
    { 0xAD28EFB2, "grenade_aim_pt" },
    { 0xFE6E9F3A, "grenade_ammo" },
    { 0x8C631A30, "grenade_angles" },
    { 0x50AECF17, "grenade_array" },
    { 0x854BB753, "grenade_blinking_light" },
    { 0x767914B8, "grenade_bounce" },
    { 0x1652A72B, "grenade_bounce_monitor" },
    { 0xC9DCCC13, "grenade_bounces" },
    { 0xCC7F03FE, "grenade_cache" },
    { 0xD660954F, "grenade_cache_index" },
    { 0x512FB311, "grenade_choice" },
    { 0xE98F05CD, "grenade_count" },
    { 0x658581DC, "grenade_cower" },
    { 0x49FC0E66, "grenade_death_indicator_hudelement" },
    { 0x69110CF3, "grenade_death_indicator_hudelement_cleanup" },
    { 0xFED824A2, "grenade_death_text_hudelement" },
    { 0x187A9EB5, "grenade_debug" },
    { 0x4EBC24C9, "grenade_dev_gui" },
    { 0x221A1680, "grenade_dist" },
    { 0xFC2C29A3, "grenade_dist_sq" },
    { 0xDC84AA50, "grenade_dive_challenge" },
    { 0xE637FE03, "grenade_dive_divetoprone_watcher" },
    { 0x277F88D0, "grenade_dive_watch_standup" },
    { 0x33C4218A, "grenade_drop_done" },
    { 0x744106A7, "grenade_dud" },
    { 0x2876C7CF, "grenade_earthquake" },
    { 0x4541F36F, "grenade_end" },
    { 0x305EA9B4, "grenade_ended" },
    { 0x2A0C5607, "grenade_endpoint_influencer" },
    { 0x448346EC, "grenade_endpoint_influencer_radius" },
    { 0x4362D85C, "grenade_endpoint_influencer_score" },
    { 0xFD1557E0, "grenade_endpoint_influencer_score_curve" },
    { 0xE51A4CDF, "grenade_ent" },
    { 0x783AAC9F, "grenade_explode" },
    { 0x8B048789, "grenade_exploded" },
    { 0xDE28FBBB, "grenade_explosion_effect" },
    { 0xE5CCF3DC, "grenade_fire" },
    { 0x1D6D074B, "grenade_fire_bigdog" },
    { 0x44183798, "grenade_flee" },
    { 0x012893F0, "grenade_hint_logic" },
    { 0x0284CB1F, "grenade_hit" },
    { 0xC276D17A, "grenade_influencer_radius" },
    { 0x9127374E, "grenade_influencer_score" },
    { 0xB7097FEA, "grenade_influencer_score_curve" },
    { 0xC33AFDF1, "grenade_instance" },
    { 0x9EF99C2C, "grenade_land_pos" },
    { 0x8D77177B, "grenade_launch_rumble" },
    { 0x21DBB663, "grenade_launcher_fire" },
    { 0x0B396190, "grenade_launcher_hint" },
    { 0x42BEF449, "grenade_launncher_fire" },
    { 0xAA78A4B9, "grenade_lifetime" },
    { 0x1A24ADD8, "grenade_marked" },
    { 0xDDF60287, "grenade_model" },
    { 0x35323EF6, "grenade_multiattack_bookmark_count" },
    { 0xA23F758F, "grenade_multiattack_count" },
    { 0xB558C169, "grenade_multiattack_ent" },
    { 0x42B867DB, "grenade_multikill_count" },
    { 0x4D7782C9, "grenade_name" },
    { 0xBB4EF04F, "grenade_notifies" },
    { 0x223B8D1B, "grenade_on_spawn" },
    { 0xAD1B201A, "grenade_org" },
    { 0x5E2F08D6, "grenade_origin" },
    { 0xBEDF2DA7, "grenade_overlap_dist_sq" },
    { 0x03BDF4B5, "grenade_owner" },
    { 0x4B07DC44, "grenade_pickup" },
    { 0x30F7BC14, "grenade_planted" },
    { 0xAE9F4498, "grenade_pullback" },
    { 0x99784FF7, "grenade_ref" },
    { 0xC52D1105, "grenade_respond_dist_sq" },
    { 0x51415825, "grenade_return_running_kick_forward_1" },
    { 0x7743D28E, "grenade_return_running_kick_forward_2" },
    { 0xEB4D4DD7, "grenade_return_throw" },
    { 0x5FA46E5D, "grenade_room_swap" },
    { 0xDF7277EC, "grenade_safe_to_bounce" },
    { 0xB22F1F2C, "grenade_safe_to_throw" },
    { 0x14EDE75C, "grenade_spawner" },
    { 0x0FEA45A4, "grenade_start" },
    { 0xE13A7747, "grenade_start_pos" },
    { 0xAA2BC3CF, "grenade_stolen_by_sam" },
    { 0xC4CF2014, "grenade_stuck" },
    { 0x0EB497B4, "grenade_suicide" },
    { 0xC80FC75B, "grenade_target" },
    { 0xBF6EDE24, "grenade_throw_cancelled" },
    { 0x994C1FD7, "grenade_throw_distsq_medium" },
    { 0x1759F910, "grenade_throw_distsq_short" },
    { 0x61434B13, "grenade_throw_done" },
    { 0x84F74DBC, "grenade_throw_time" },
    { 0x03652869, "grenade_throwback" },
    { 0x56B903F9, "grenade_timeout" },
    { 0x35048235, "grenade_toss" },
    { 0xB1FDB613, "grenade_tracking" },
    { 0xF7DB3728, "grenade_type" },
    { 0xE6E18C79, "grenade_velocity" },
    { 0x6056CA46, "grenade_vignette" },
    { 0x63B1212B, "grenade_vignette_post" },
    { 0x1499E8B1, "grenade_vignette_temp_hack" },
    { 0x24FAE37E, "grenade_wait_for_stop" },
    { 0x3E4AAF36, "grenade_waittill_still_or_bounce" },
    { 0xDA9796C1, "grenade_watch" },
    { 0x2E25CBA8, "grenade_watcher" },
    { 0x5EF79ACC, "grenade_weapon" },
    { 0xD937392F, "grenadeammo" },
    { 0xDAE90322, "grenadeammoarray" },
    { 0x28E57852, "grenadeangle" },
    { 0xDD128D6D, "grenadeanims" },
    { 0x3B77AAA4, "grenadearray" },
    { 0x356D8EC0, "grenadeawareness" },
    { 0xB22DB54A, "grenadeawareness_old" },
    { 0xE61CE536, "grenadecooldownelapsed" },
    { 0x12291302, "grenadecount" },
    { 0xFB4AA718, "grenadecountprimary" },
    { 0x61409868, "grenadecountsecondary" },
    { 0x8AE50DBA, "grenadecowerside" },
    { 0x1003DCA3, "grenaded" },
    { 0xD8E26D13, "grenadedamagemultiplier" },
    { 0xABC53174, "grenadedanger" },
    { 0xB2CA7B8A, "grenadedebug" },
    { 0x0184AD51, "grenadedest" },
    { 0x49BAA05D, "grenadedist" },
    { 0x27AD447B, "grenadedistancesquared" },
    { 0xA14D51C4, "grenadeent" },
    { 0x9E739B08, "grenadeexplosionfx" },
    { 0xFB83B72D, "grenadeflee" },
    { 0x7B384ECD, "grenadehidden" },
    { 0x3F7EAD67, "grenadeimpactdeath" },
    { 0x3C7C0DE3, "grenadekillcounter" },
    { 0x3EF7283B, "grenadelauncherdudtime" },
    { 0x95709514, "grenadelauncherdudtimedvar" },
    { 0x92416037, "grenadelauncherdudtimemax" },
    { 0x774C3489, "grenadelauncherdudtimemin" },
    { 0xB56A7D97, "grenadeline" },
    { 0x07FF6B0D, "grenademissreason" },
    { 0x845188A4, "grenadename" },
    { 0xB5227353, "grenadeorigin" },
    { 0xFCEBEA04, "grenadeprimaryname" },
    { 0x745B0E94, "grenaders" },
    { 0x962DFD9C, "grenades" },
    { 0xF217ACFB, "grenades_dropped" },
    { 0x6C3E7ECE, "grenadesecondarycount" },
    { 0x448621D0, "grenadesecondaryname" },
    { 0xE003B76E, "grenadeshoot" },
    { 0x424556B9, "grenadesonlyprev" },
    { 0x8E51D34C, "grenadestarttime" },
    { 0xC44068E7, "grenadestuck" },
    { 0xC1ACDE73, "grenadesused" },
    { 0x9AB3D916, "grenadetarget" },
    { 0xB9F11F01, "grenadetest" },
    { 0x5C5C08E3, "grenadethrow" },
    { 0x56BD25DA, "grenadethrowback" },
    { 0x52E217BE, "grenadethrower" },
    { 0x44F09A71, "grenadethrowerteam" },
    { 0x93D9836B, "grenadethrowinfo" },
    { 0xF044B54A, "grenadethrowinfos" },
    { 0x9D047330, "grenadethrownat" },
    { 0x8D434D86, "grenadethrownposition" },
    { 0x4AA1FD8A, "grenadethrowoffset" },
    { 0x821533C5, "grenadethrowoffsets" },
    { 0x30741BE2, "grenadethrowposition" },
    { 0xCA56C167, "grenadethrowwaittime" },
    { 0xEA169FEC, "grenadetimer" },
    { 0x21A633D9, "grenadetimerdebug" },
    { 0x335BA18E, "grenadetimerhudelem" },
    { 0xFEDEEEEF, "grenadetimers" },
    { 0xD00503F9, "grenadetoggle" },
    { 0x59E58232, "grenadetoss_is_attacking" },
    { 0x39F37796, "grenadetracking" },
    { 0x24C44AFE, "grenadetrackingstart" },
    { 0x36A09995, "grenadetype" },
    { 0xBD1A8795, "grenadetypeprimary" },
    { 0x22F7EDCA, "grenadetypeprimarycount" },
    { 0x81F1FCE4, "grenadetypes" },
    { 0xF5FFBA49, "grenadetypesecondary" },
    { 0xC87CEDB6, "grenadetypesecondarycount" },
    { 0x66CB8722, "grenadetypespecial" },
    { 0x877B90BF, "grenadetypespecialcount" },
    { 0x22C5EF5D, "grenadeweapon" },
    { 0xB4FA9CA4, "grenadeweaponname" },
    { 0x3DD66A83, "grenadiers" },
    { 0xB1F9DD93, "grendade" },
    { 0x866FD6C2, "grendades" },
    { 0xF5FD7E8E, "grende" },
    { 0x17783DC6, "grew" },
    { 0x637D3298, "grey" },
    { 0x23D1E7F6, "grey_on_off" },
    { 0x47D8B6A1, "grg" },
    { 0xB9021C7C, "grgsindex" },
    { 0x8206CD09, "grgsrpgdialog" },
    { 0xE500E219, "grid" },
    { 0x9148A952, "grid_shader_disable" },
    { 0x40CC8C45, "grid_shader_disable_drone" },
    { 0x7CCFEC97, "grid_shader_disable_god_rod" },
    { 0x9797EAD7, "grid_shader_enable" },
    { 0x8268FB50, "grid_shader_enable_drone" },
    { 0x09F5B0F2, "grid_shader_enable_god_rod" },
    { 0xA36C13F1, "grid_shader_enabled" },
    { 0xDE081D11, "grid_shader_off" },
    { 0x99BC8E7C, "grid_shader_off_god_rod" },
    { 0xA81162E5, "grid_shader_on" },
    { 0x565EC938, "grid_shader_on_god_rod" },
    { 0xAF952AE9, "gridaveragerunningtraverse" },
    { 0xCFA56EA4, "gridaveragetraverse" },
    { 0x7082655F, "gridavgusetime" },
    { 0xDF30A225, "gridlink" },
    { 0x67299349, "gridnode" },
    { 0x36324206, "gridsize" },
    { 0xE0294F29, "gridtotalusetime" },
    { 0xCE95B9B3, "gridtraverse" },
    { 0xE9EEB453, "gridx" },
    { 0xC3EC39EA, "gridy" },
    { 0x7F79FFE6, "grief" },
    { 0xE7D0DFBF, "grief_custom_stat_update" },
    { 0x95D6B909, "grief_game_end_check_func" },
    { 0x418DA6EA, "grief_hasriotshield" },
    { 0xA81D043F, "grief_initial" },
    { 0x6B71EEDE, "grief_laststand_weapon_save" },
    { 0x23785C86, "grief_laststand_weapons_return" },
    { 0x25CCC97D, "grief_onplayerconnect" },
    { 0x73F0FBF3, "grief_onplayerdisconnect" },
    { 0xA9413526, "grief_reset_message" },
    { 0x2CA9A514, "grief_restore_player_score" },
    { 0xF9D616FA, "grief_round_end_custom_logic" },
    { 0x1D609CED, "grief_savedweapon_claymore" },
    { 0x9B796772, "grief_savedweapon_claymore_clip" },
    { 0x4FA0F4A4, "grief_savedweapon_currentoffhandweapon" },
    { 0x82863365, "grief_savedweapon_currentoffhandweapon_clip" },
    { 0x4E63A733, "grief_savedweapon_currentoffhandweapon_stock" },
    { 0x0E1D9C44, "grief_savedweapon_currentweapon" },
    { 0x8D90694B, "grief_savedweapon_equipment" },
    { 0x14542434, "grief_savedweapon_grenades" },
    { 0xBA4202D5, "grief_savedweapon_grenades_clip" },
    { 0xDF103C7A, "grief_savedweapon_tactical" },
    { 0xB5DEFB2F, "grief_savedweapon_tactical_clip" },
    { 0xC662A334, "grief_savedweapon_weapons" },
    { 0x0A695E03, "grief_savedweapon_weaponsammo_clip" },
    { 0x3451E701, "grief_savedweapon_weaponsammo_stock" },
    { 0xB0234293, "grief_soul_catcher_state_manager" },
    { 0xE34F5A26, "grief_store_player_scores" },
    { 0xC1E15F25, "grief_treasure_chest_init" },
    { 0xF1BD6C75, "griefbuildables" },
    { 0x2BB0CF7A, "griefing" },
    { 0x7146E196, "griffen" },
    { 0xF4DDECF0, "griggs" },
    { 0xF9B76BD2, "griggs_come_out" },
    { 0x2B47808B, "griggs_fake_gun" },
    { 0xF17FFD96, "griggs_grab_gun" },
    { 0x3EC95C51, "griggs_idle" },
    { 0x1A00049B, "griggs_loose" },
    { 0x9C9E397F, "griggs_node" },
    { 0x330119FC, "griggs_plays_music" },
    { 0x1D9DE5E5, "griggs_spawner" },
    { 0x33006BF4, "griggs_spawners" },
    { 0x4367AF9B, "griggs_squad" },
    { 0x8A853E59, "griggs_think" },
    { 0x5B525AF5, "griggs_to_flyover_handler" },
    { 0xA6AFD334, "griggsdummy" },
    { 0xAE5586FA, "griggsorg" },
    { 0x126FCCCD, "grigs" },
    { 0x9E3B261D, "grigs_clip_handoff" },
    { 0xA1AE39EE, "grigsby" },
    { 0x3F1519C3, "grigsby_countdown_dialogue" },
    { 0x1855722E, "grigsby_countdown_spam" },
    { 0xFBB318F7, "grigsby_spawner" },
    { 0x512BC51B, "grigsby_think" },
    { 0xF00643BB, "grigsby_warning" },
    { 0xEF23BFC6, "grill_fire" },
    { 0xEF123AF8, "grim" },
    { 0xB5092291, "grind_range_squared" },
    { 0x14ED569C, "grinder" },
    { 0xDF98A09B, "grinding" },
    { 0xFA34BC65, "gringo" },
    { 0xC474B519, "gringo_spraypaint_vo" },
    { 0xF4741774, "gringos" },
    { 0x1CE3252D, "grip" },
    { 0xC99AA0BF, "grn_dgs" },
    { 0xF2143150, "groaning" },
    { 0x2EA59A18, "groggy_wakeup" },
    { 0x5EC3EFD0, "groin" },
    { 0x79F4D07C, "gropu" },
    { 0xFE2E9DFB, "gross" },
    { 0x2D10851C, "grotto" },
    { 0xCE6BABC0, "ground" },
    { 0x277BB545, "ground_allied_forces" },
    { 0x67999421, "ground_ang" },
    { 0x2425EB66, "ground_attack_index" },
    { 0xB6B83DA0, "ground_attack_tank_points" },
    { 0x7B14641C, "ground_attack_targets" },
    { 0xF142ED91, "ground_attack_vehicle_death" },
    { 0x912B4359, "ground_attack_vehicles" },
    { 0xAE3CA55C, "ground_battles" },
    { 0x83F42FF7, "ground_drone_landing" },
    { 0xABA584C6, "ground_ent" },
    { 0x710619F1, "ground_fx" },
    { 0xB8BAD88E, "ground_height" },
    { 0x74EE5186, "ground_hit" },
    { 0x45801589, "ground_hit_done" },
    { 0x594E3F4F, "ground_level" },
    { 0xC0D3F115, "ground_origin" },
    { 0x7288326A, "ground_parachutes_start" },
    { 0x76A10587, "ground_playerlook_trace" },
    { 0x42AF7BC3, "ground_pos" },
    { 0xC9641D86, "ground_position" },
    { 0x1F28B3F4, "ground_ref_ent" },
    { 0x0656EFC1, "ground_search_time" },
    { 0x9050F13A, "ground_sound_ent" },
    { 0x97BDB02E, "ground_targets_done" },
    { 0x66A19FBF, "ground_targets_escape" },
    { 0x831B20FE, "ground_tell" },
    { 0xA5728FF8, "ground_tell_location" },
    { 0xD3524150, "ground_tolerance" },
    { 0x55CF63D2, "ground_trace" },
    { 0x1A361CF5, "ground_trace_fail" },
    { 0x9E38E41F, "ground_type" },
    { 0xDC7A201F, "ground_vehicle_damage_callback" },
    { 0x3592A07B, "ground_vehicle_fires_at_player" },
    { 0x99A67B0B, "ground_visible_distance" },
    { 0x7B8F8949, "groundbased" },
    { 0x9579FC74, "groundburnarea" },
    { 0x5AD2ED74, "groundburntime" },
    { 0xAB27B230, "groundcombat" },
    { 0x57736C53, "grounded" },
    { 0xC1CFFD4F, "groundent" },
    { 0x8F57E821, "groundentity" },
    { 0xEEA91BF0, "groundflameent" },
    { 0x4F9801F0, "groundfrom" },
    { 0x7DB19BBA, "groundfx" },
    { 0xAC0BE005, "groundhit_anim" },
    { 0x8F494715, "groundhit_fx_watcher" },
    { 0x02209AAA, "groundhit_watcher" },
    { 0xEB9A6B79, "groundnormal" },
    { 0x551B0D42, "groundpoint" },
    { 0x747DD68D, "groundpoints" },
    { 0x19A2974E, "groundpos" },
    { 0xC66BCBFB, "groundpos_ignore_water" },
    { 0xDA191ED4, "groundpos_ignore_water_new" },
    { 0xCCA0E2F9, "groundposition" },
    { 0x0379280F, "groundr_ang" },
    { 0xFCCA50AD, "groundr_vec" },
    { 0xC55F27EB, "grounds" },
    { 0x0CBC4F0B, "groundtrace" },
    { 0xA0214178, "groundtype" },
    { 0x26BE9EB6, "groundvec" },
    { 0xC5DEAFA2, "group" },
    { 0x7FB62296, "group0" },
    { 0xA5B89CFF, "group1" },
    { 0xBA20A4D9, "group12_death_min" },
    { 0xB2832DFF, "group12_pkill_min" },
    { 0xAAAACD47, "group1_deaths" },
    { 0x4B5C27D6, "group1_enemies" },
    { 0x7C3E5A33, "group1_enemies_think" },
    { 0xF8A42891, "group1index" },
    { 0x33B12DC4, "group2" },
    { 0x50C1E6E2, "group2_deaths" },
    { 0x19234498, "group2index" },
    { 0x59B3A82D, "group3" },
    { 0x9E6D1B93, "group3_death_min" },
    { 0xE7EA04D9, "group3_deaths" },
    { 0x2788B47D, "group3_pkill_min" },
    { 0xE7AC38F2, "group4" },
    { 0x69E89D81, "group4_civs_at_window_anim" },
    { 0x0DAEB35B, "group5" },
    { 0x9BA74420, "group6" },
    { 0xEB0957D1, "group_add_spawn_function" },
    { 0xC7361EE0, "group_basin_friendly_tanks" },
    { 0x9041B234, "group_cover_go3_started" },
    { 0xCC57CD13, "group_dancing" },
    { 0x1DB8DC88, "group_gone" },
    { 0xAA3FC4F4, "group_grave_friendly_tanks" },
    { 0xEC1F1A5A, "group_highlight_thread" },
    { 0x21AC6C33, "group_index" },
    { 0x0772EBAF, "group_light" },
    { 0x32C9007C, "group_mode" },
    { 0xFC26754F, "group_mode_thread" },
    { 0x7E3CD530, "group_name" },
    { 0x4EC1B492, "group_notify" },
    { 0x7B9C392B, "group_num" },
    { 0x7650C180, "group_obj" },
    { 0x893D21BB, "group_objective_marker" },
    { 0x4C663A5A, "group_objective_markers" },
    { 0xF394A02F, "group_one_ai_death" },
    { 0xA4B9AF6D, "group_one_death_rattle" },
    { 0x5342E8EB, "group_plant_bomb" },
    { 0xE8754558, "group_s" },
    { 0xD48DBEDE, "group_selected" },
    { 0xA6FABC7E, "group_size" },
    { 0xE6000994, "group_to_merge_into" },
    { 0x4F57E671, "group_two_ai_death" },
    { 0xF4FED92B, "group_two_death_rattle" },
    { 0x5472584D, "group_vox_fighting" },
    { 0x81E812E4, "group_vox_reznov_fight" },
    { 0x29C0DC4C, "group_vox_running" },
    { 0xB7225344, "group_walk_to_officers" },
    { 0xED493991, "group_weapon_assault" },
    { 0x4871E1A1, "group_weapon_pistol" },
    { 0x661430B5, "grouped" },
    { 0x2DD77209, "groupedanim_pos" },
    { 0xCDC2372E, "groupedanimevent" },
    { 0xED100991, "groupedmortars" },
    { 0xA6F4F631, "groupid" },
    { 0x09930C8E, "grouping" },
    { 0xD964BB31, "groupings" },
    { 0xAE0918A0, "groupisdead" },
    { 0x2D29332F, "groupname" },
    { 0x2A48145A, "groupnum" },
    { 0xDA48AC79, "groupnumber" },
    { 0x2B68E862, "grouprappel" },
    { 0x792435B5, "grouprappel_done" },
    { 0xD893027C, "grouprappel_ignore_until_doors" },
    { 0xDA52426D, "groups" },
    { 0x1503A579, "groupsightpos" },
    { 0xEFF7EC35, "groupsize" },
    { 0x3258E36F, "groupspawn" },
    { 0x86C9545D, "groupspawners" },
    { 0xD9EA5357, "grouptargetdummies" },
    { 0xC0C0D149, "grouptimerdone" },
    { 0xEB801F68, "grouptn" },
    { 0x72BC90FC, "groupwarp" },
    { 0xE9628BFA, "grove" },
    { 0x092E1EB4, "grow" },
    { 0xE81CB074, "growing" },
    { 0x9CD0736C, "growing_hitmarker" },
    { 0x1E8EB110, "growl" },
    { 0xF43E3594, "growl_bark_done" },
    { 0x586B2608, "growling" },
    { 0xF88C36A7, "grows" },
    { 0xE56B661B, "grp01_01" },
    { 0x44DFBF5E, "grp01_01_start" },
    { 0x7363F6E0, "grp01_02" },
    { 0xE7D62A55, "grp01_02_start" },
    { 0x99667149, "grp01_03" },
    { 0x0B6E4418, "grp01_03_start" },
    { 0x5772D556, "grp01_04" },
    { 0x0C8AC107, "grp01_04_start" },
    { 0xCC470452, "grp02_01" },
    { 0x4E5334BB, "grp02_01_start" },
    { 0xA64489E9, "grp02_02" },
    { 0xADEA8878, "grp02_02_start" },
    { 0x80420F80, "grp02_03" },
    { 0xB685BFB5, "grp02_03_start" },
    { 0xE78926A1, "grp03_01" },
    { 0xE4E400E0, "grp03_01_start" },
    { 0x0D8BA10A, "grp03_02" },
    { 0x42C22463, "grp03_02_start" },
    { 0x338E1B73, "grp03_03" },
    { 0x7AB0D3C6, "grp03_03_start" },
    { 0xFAA3D5D8, "grp04_01" },
    { 0x967C16BD, "grp04_01_start" },
    { 0x6CAB4513, "grp04_02" },
    { 0x8B9EEC26, "grp04_02_start" },
    { 0x46A8CAAA, "grp04_03" },
    { 0x160F6343, "grp04_03_start" },
    { 0xFE893B27, "grp05_01" },
    { 0x9810FC92, "grp05_01_start" },
    { 0x8C81CBEC, "grp05_02" },
    { 0xC1E18169, "grp05_02_start" },
    { 0x16646144, "grp_name" },
    { 0x59B87F4C, "grr" },
    { 0x91AB30E1, "grunt" },
    { 0x1F9E2988, "grunts" },
    { 0x5E0B8742, "gruunt" },
    { 0x1894C9D0, "gryphon" },
    { 0x7AD742A3, "gs" },
    { 0xBD647880, "gs1" },
    { 0x2F6BE7BB, "gs2" },
    { 0xEA2FAE22, "gsc" },
    { 0x65069578, "gscdoc" },
    { 0x8C00BB67, "gscdocbegin" },
    { 0x57417097, "gscdocend" },
    { 0xF4410701, "gsh" },
    { 0xB08E63E5, "gsindex" },
    { 0xB24D6B0E, "gso" },
    { 0xD8317252, "gstelmack" },
    { 0xA0D9BD0C, "gt" },
    { 0x57CFC891, "gtfo" },
    { 0x5C72D25B, "gtg" },
    { 0xBBD07956, "gu1" },
    { 0x95CDFEED, "gu2" },
    { 0xA7ECCA8F, "guantlet" },
    { 0x7F0525D9, "guarantee" },
    { 0x253696DF, "guaranteed" },
    { 0x7B4CE490, "guarantees" },
    { 0xEF9093D4, "guard" },
    { 0x7AC2D7B5, "guard1" },
    { 0xAA383599, "guard1_attach_left" },
    { 0x0A138B73, "guard1_attach_papers" },
    { 0xB9272006, "guard1_attach_reel" },
    { 0xD51EEC44, "guard1_attach_right" },
    { 0xA97F548D, "guard1_detach" },
    { 0xCF9BEC33, "guard1_detach_left" },
    { 0x67231626, "guard1_detach_right" },
    { 0xFBE9B086, "guard1_detach_stuff" },
    { 0x3C6B6B11, "guard1_goal" },
    { 0x7BE9924C, "guard1_node" },
    { 0xA0C5521E, "guard2" },
    { 0x503A7B22, "guard2_attach_left" },
    { 0x9798FF08, "guard2_attach_papers" },
    { 0x1F6DCE11, "guard2_attach_right" },
    { 0x49371180, "guard2_detach" },
    { 0x2D3C9F78, "guard2_detach_left" },
    { 0xEE741187, "guard2_detach_right" },
    { 0x9D9607AF, "guard2_detach_stuff" },
    { 0x43E418F0, "guard2_goal" },
    { 0x92DC8DDD, "guard2_node" },
    { 0xC6C7CC87, "guard3" },
    { 0xBCB673A8, "guard4" },
    { 0xE2B8EE11, "guard5" },
    { 0xA3B9E6C8, "guard_1" },
    { 0x15C15603, "guard_2" },
    { 0xEFBEDB9A, "guard_3" },
    { 0x84802798, "guard_a" },
    { 0x903F0ED0, "guard_alerted_by_touch" },
    { 0xCD4B0017, "guard_anim_done" },
    { 0xF68796D3, "guard_b" },
    { 0x56EE56AB, "guard_b2" },
    { 0xD06E77AD, "guard_boat" },
    { 0xB7B0BDC5, "guard_c_logic" },
    { 0x04E593D7, "guard_dialog" },
    { 0x4B3CE7B0, "guard_done_talking" },
    { 0xDE0A5988, "guard_hind_attack_targets" },
    { 0xF31D5CFF, "guard_hind_logic" },
    { 0x8255C104, "guard_hind_movement" },
    { 0xF50A1A5D, "guard_house" },
    { 0xB4E93E1E, "guard_monitor_for_enemy" },
    { 0xC5930353, "guard_node" },
    { 0x59361E32, "guard_points_debug" },
    { 0x5B14A0D7, "guard_pos" },
    { 0x63E549D8, "guard_react_and_celebrate" },
    { 0xF5CE9342, "guard_runs_away_and_dies" },
    { 0x39A58E68, "guard_runs_up_stairs" },
    { 0x8A405E0E, "guard_setup" },
    { 0x8ACBB58D, "guard_shack" },
    { 0x6CDCACB2, "guard_sleeper_idle" },
    { 0xAF353EE9, "guard_sleeper_react" },
    { 0x1E74FCF9, "guard_spawner" },
    { 0x4D3E7314, "guard_the_vaultdoors" },
    { 0xDDCAD704, "guard_the_vaultdoors_grigsby" },
    { 0xD4B66F95, "guard_think" },
    { 0x88976B7A, "guard_tower" },
    { 0x83695218, "guard_tower_array" },
    { 0x01063281, "guard_tower_blocker" },
    { 0x216FE7CF, "guard_tower_d" },
    { 0xDF10753F, "guard_tower_melee" },
    { 0xDCB86A2A, "guard_tower_melee_fail" },
    { 0x20A1847F, "guard_tower_red_cursor" },
    { 0xF59FAEEC, "guard_uazs" },
    { 0x7C3F1E9A, "guard_waitfor_death" },
    { 0x87365D77, "guarded" },
    { 0xE59B21E0, "guardhouse" },
    { 0xE67364A0, "guardian_time" },
    { 0x98424714, "guarding" },
    { 0xB726B0A1, "guardlocation" },
    { 0x15F22FD2, "guardmarker" },
    { 0x657060C9, "guardpoints" },
    { 0xBD8C882D, "guardposition" },
    { 0x1CA0FB66, "guardradius" },
    { 0x46293247, "guards" },
    { 0x41E1278F, "guards_1" },
    { 0x62810A06, "guards_and_prisoners_scene" },
    { 0xD5F9BCC4, "guards_spawned" },
    { 0xD29B84A0, "guardtocarry" },
    { 0x43507F99, "guardtower_dead_enemies" },
    { 0xEC4FE3D3, "guarenteed" },
    { 0xB22AB7AC, "guarentees" },
    { 0xEE4743CC, "guess" },
    { 0xB34A5FAF, "guessed" },
    { 0xD01B947C, "guessing" },
    { 0x2C35F352, "guests" },
    { 0xCB6D58EE, "gui" },
    { 0x041ACFAE, "guid" },
    { 0x8784BED7, "guidance" },
    { 0x21F205D7, "guide" },
    { 0x60639690, "guide_structs" },
    { 0x6F4494F1, "guided" },
    { 0x17F63B26, "guided_missile_exploded" },
    { 0xB8D5FC56, "guided_missile_exploded_manually" },
    { 0x4E72C500, "guided_missile_grain" },
    { 0x29158C2C, "guided_missile_lost_signal" },
    { 0x001A36D5, "guided_missile_overlay" },
    { 0xA05DE6BD, "guidedmissilemaxhight" },
    { 0x72DB88C1, "guidedmissileoverlay" },
    { 0xCCD4956F, "guidedmissiletype" },
    { 0x0E27FD8C, "guidelines" },
    { 0x8D789F8E, "guides" },
    { 0xAD5A5EAD, "guillotine_trigger_reject_func" },
    { 0x64E197A6, "guilt" },
    { 0x6C4D95F3, "guilty" },
    { 0x3A58BFFE, "gulch" },
    { 0x6C052CFB, "gulch_ambush_started" },
    { 0x22F384FD, "gulch_node" },
    { 0x9CD35361, "gulch_panzer" },
    { 0x0FF5CB94, "gulch_panzer_mg" },
    { 0x848BDD3A, "gulch_tiger" },
    { 0x6206D047, "gulchtiger" },
    { 0xA809BEB9, "gulchtiger_area" },
    { 0x1D9F2BF0, "gulchtiger_speed_loop" },
    { 0xBD695D8F, "gullfx2_placement" },
    { 0x67ED73C4, "gullfx2_play" },
    { 0xEB089937, "gullfx_placement" },
    { 0x79FD04EC, "gullfx_play" },
    { 0xBC9C2E09, "gulliver" },
    { 0xA936313C, "gulliver_dialog" },
    { 0x1FCED09D, "gulliver_eye_scan" },
    { 0x4199030A, "gulliver_reached" },
    { 0x8A57680C, "gulliver_think" },
    { 0xB965D1BB, "gulliver_viewmodel_render_flag_set" },
    { 0xA4E80752, "gulliver_wait_for_tazer" },
    { 0xC1FFD0CA, "gulliver_walkin" },
    { 0x1D6DD44D, "gumball" },
    { 0xCF608AEE, "gump" },
    { 0x95CA5194, "gump_blackscreen_off" },
    { 0x976DED9E, "gump_blackscreen_on" },
    { 0xFC9422EA, "gump_demo_jump_listener" },
    { 0xDC1CFFB6, "gump_flushed" },
    { 0x9EE90FE2, "gump_loaded" },
    { 0x22849A33, "gump_loading" },
    { 0x0ECBFADA, "gump_loading_slot" },
    { 0x2EDCE111, "gump_test" },
    { 0x77E3A036, "gump_trigs" },
    { 0xCA9FD64F, "gump_watch_trigger" },
    { 0x72B75331, "gumped" },
    { 0xAED91473, "gumpname" },
    { 0x4A2DDF68, "gumpnamequeued" },
    { 0x1DBE7B11, "gumps" },
    { 0x0D60F4E1, "gun" },
    { 0xD02A8A83, "gun0" },
    { 0xAA28101A, "gun1" },
    { 0xAE417B3E, "gun1_destroyed" },
    { 0xFBD8FABA, "gun1_flamed" },
    { 0xF1504BBD, "gun1_org" },
    { 0x842595B1, "gun2" },
    { 0x02CC484D, "gun2_destroyed" },
    { 0xF695EDB6, "gun2_org" },
    { 0x5E231B48, "gun3" },
    { 0xD9F05C24, "gun3_destroyed" },
    { 0xDDAD1B9B, "gun3_org" },
    { 0x68347427, "gun4" },
    { 0xE027C17B, "gun4_destroyed" },
    { 0xC5445EDC, "gun4_org" },
    { 0x0AECB2F6, "gun_actual_target" },
    { 0xB3C94F2F, "gun_aim_dir" },
    { 0x7C99471A, "gun_align_x" },
    { 0x03BC109C, "gun_ang" },
    { 0xD4599D73, "gun_array" },
    { 0x82B23A28, "gun_attached" },
    { 0x24CDB405, "gun_back" },
    { 0x7846E670, "gun_boat_alive" },
    { 0xFC35CE96, "gun_bone" },
    { 0x837DC2A9, "gun_btn_x" },
    { 0x5D7B4840, "gun_btn_y" },
    { 0xD1EFCABB, "gun_chest" },
    { 0x92546E43, "gun_control_stop_instant_fail" },
    { 0xDDDC6E2C, "gun_core_ang" },
    { 0x593E57B2, "gun_core_pos" },
    { 0xC70402E8, "gun_damage_fx" },
    { 0x876AFEA6, "gun_dead" },
    { 0x251568E7, "gun_detach_damage" },
    { 0x22384963, "gun_ent" },
    { 0x0759CE60, "gun_fire" },
    { 0xAE4E0F55, "gun_fired_and_ready_105mm" },
    { 0x54DC12F7, "gun_firing_time" },
    { 0xEC4A58CA, "gun_flash" },
    { 0x86577423, "gun_forward" },
    { 0xC53FA4C1, "gun_front" },
    { 0x33F9E8F2, "gun_game_achievement" },
    { 0x1E3E515D, "gun_guy" },
    { 0x53500EF7, "gun_hand" },
    { 0x11341335, "gun_horizalign" },
    { 0x29641DEE, "gun_icon_x" },
    { 0x4F669857, "gun_icon_y" },
    { 0x017D06D8, "gun_index" },
    { 0xD25B1A92, "gun_killorigin" },
    { 0xDBED06C8, "gun_leave_behind" },
    { 0xFDDAC6C7, "gun_left" },
    { 0x7A5231DC, "gun_level_complete" },
    { 0xC5DD45A8, "gun_load_anim" },
    { 0xD9F4DF31, "gun_location" },
    { 0x965A0B2B, "gun_lower" },
    { 0x2047489B, "gun_model" },
    { 0x55A87064, "gun_num" },
    { 0x049CE8C7, "gun_number" },
    { 0xE02BD1E3, "gun_off" },
    { 0xB587F92F, "gun_on" },
    { 0xA52760E3, "gun_on_ground" },
    { 0xCC58FC9D, "gun_on_target" },
    { 0x003728E6, "gun_org" },
    { 0xE78E7DC2, "gun_origin" },
    { 0xC75D4118, "gun_pickup_left" },
    { 0xADF6B1A7, "gun_pickup_right" },
    { 0x0F21A096, "gun_placed_again" },
    { 0xFEA1FC22, "gun_pos" },
    { 0x1831177D, "gun_position" },
    { 0xF2451C5F, "gun_pullout" },
    { 0x0A7E7ED4, "gun_raise" },
    { 0x4C09C083, "gun_range" },
    { 0x1774F0E6, "gun_rear" },
    { 0xEFED45A3, "gun_recall" },
    { 0xFD6C4374, "gun_remove" },
    { 0xA8377A27, "gun_remove_drone" },
    { 0x8DB39318, "gun_removed" },
    { 0x81C8A3CF, "gun_resist_controls" },
    { 0x8B7D5C42, "gun_right" },
    { 0xB19057A9, "gun_rules" },
    { 0xC5DD68BC, "gun_shots_to_victim" },
    { 0x4F90AF07, "gun_struct" },
    { 0xCDEDA8FE, "gun_structs" },
    { 0x7901AC63, "gun_switchto" },
    { 0xF1A61A4C, "gun_tag" },
    { 0xCB47137C, "gun_targ" },
    { 0x66964B04, "gun_text_x" },
    { 0x8C98C56D, "gun_text_y" },
    { 0x462E13E2, "gun_to_heli" },
    { 0x9A9714DB, "gun_triggers" },
    { 0xCBCDADE1, "gunangles" },
    { 0x6A9FA640, "gunblockedbywall" },
    { 0x2A9456EB, "gunboat" },
    { 0x834DBF89, "gunboat_left_ram_fx" },
    { 0x26237912, "gunboat_ram_left" },
    { 0x1808F481, "gunboat_ram_right" },
    { 0x5EE37246, "gunboat_right_ram_fx" },
    { 0x735584A1, "gunboat_rpg_linkto" },
    { 0xB85FA7CA, "gunboats" },
    { 0x41D2ED78, "gunc0" },
    { 0x67D567E1, "gunc1" },
    { 0x41032CC9, "guncycle" },
    { 0x1755E798, "guncycletimer" },
    { 0x93C42307, "guncyclewaiter" },
    { 0xE6F45DB0, "gunfighteroverkillactive" },
    { 0x2D74C3D5, "gunfire" },
    { 0xE3989E61, "gunfireloopfx" },
    { 0x80104749, "gunfireloopfxthread" },
    { 0x8DF6FE7D, "gunfireloopfxvec" },
    { 0x762B842D, "gunfireloopfxvecthread" },
    { 0xD6F345BC, "gung" },
    { 0x266B48A7, "gungamekillscore" },
    { 0x6FFDD493, "gungho" },
    { 0xF9BE0056, "gunhand" },
    { 0xFF0AC263, "gunindex" },
    { 0xEE82B9B9, "gunlist" },
    { 0x2D52F7E0, "gunname" },
    { 0xECD18C8A, "gunned" },
    { 0xD8AEDACC, "gunner" },
    { 0x2DBBDD3D, "gunner1" },
    { 0xBEF31F51, "gunner1ontarget" },
    { 0x53BE57A6, "gunner2" },
    { 0x49BCDA7A, "gunner2ontarget" },
    { 0x44CE7CD3, "gunner_aim_think" },
    { 0x7588FDE6, "gunner_alive" },
    { 0xC7C67A00, "gunner_anim_count" },
    { 0xD7F1993E, "gunner_barrel_angles" },
    { 0xEAB9F170, "gunner_barrel_origin" },
    { 0x4CCF72DB, "gunner_damage_override" },
    { 0x4DED3661, "gunner_dead" },
    { 0x661C64A0, "gunner_death_logic" },
    { 0x9C14DA2A, "gunner_death_think" },
    { 0xBDCB3DB4, "gunner_deck_left" },
    { 0xF4A339F7, "gunner_deck_left_pos" },
    { 0x13DD886B, "gunner_deck_right" },
    { 0xEDBF4448, "gunner_deck_right_pos" },
    { 0x96BA9649, "gunner_died" },
    { 0xB4EEA0E6, "gunner_dies" },
    { 0x3C6610DF, "gunner_direct_fire_at_player" },
    { 0xCFAB7FD1, "gunner_exit_soct" },
    { 0x20666B83, "gunner_fire_at_player" },
    { 0xD68C9789, "gunner_fired" },
    { 0x38ABD367, "gunner_fired_notify" },
    { 0x29C5140C, "gunner_focus_fire" },
    { 0xE4BAEA0A, "gunner_forward" },
    { 0x93104BDD, "gunner_getblendnumber" },
    { 0xDCF51109, "gunner_health" },
    { 0x0F165BA4, "gunner_left" },
    { 0x8B11866E, "gunner_location" },
    { 0x367E6886, "gunner_lookattarget" },
    { 0x5853D7C4, "gunner_loop_start" },
    { 0x42D128E5, "gunner_new_target" },
    { 0xCBBFC28B, "gunner_node" },
    { 0x3CD9822A, "gunner_noteworthy" },
    { 0x35B8367D, "gunner_num" },
    { 0x96441CF2, "gunner_position" },
    { 0x8F81709B, "gunner_right" },
    { 0xD6E31F8C, "gunner_seat" },
    { 0xA3162751, "gunner_shoot_burts" },
    { 0x8DD1AC34, "gunner_spawn" },
    { 0x67C52AD1, "gunner_spawner" },
    { 0xA4825D50, "gunner_start_firing_node" },
    { 0x7AD6726B, "gunner_stop_firing" },
    { 0xE4D69135, "gunner_tag" },
    { 0x6942ABBD, "gunner_think" },
    { 0x867919E6, "gunner_tower_left" },
    { 0x7E464F65, "gunner_tower_left_pos" },
    { 0x56B4F87D, "gunner_tower_right" },
    { 0x189EA91E, "gunner_tower_right_pos" },
    { 0x2D8ECCE4, "gunner_truck" },
    { 0x8C2D5C45, "gunner_turret_on_target" },
    { 0x25137287, "gunner_turret_on_target_range" },
    { 0x83141210, "gunner_turret_overheat" },
    { 0x089E5A4C, "gunner_turret_own_target" },
    { 0x1B8D1583, "gunner_turret_stop_overheat" },
    { 0x26A48385, "gunner_use_turret" },
    { 0xF4BAFDC7, "gunner_weapon" },
    { 0x468FC67F, "gunner_weapon_name" },
    { 0xC1B05DAB, "gunnercopy" },
    { 0xD4CEC11C, "gunnerdist" },
    { 0xDCA2B26F, "gunnerpathfound" },
    { 0xFA5F6C4F, "gunners" },
    { 0x869EAF69, "gunners_killed" },
    { 0xA72B322F, "gunnershots" },
    { 0x6E55FD6D, "gunnerstartpath" },
    { 0x623B9A9A, "gunnerstartpathdebug" },
    { 0x111A57AC, "gunnertargetfov" },
    { 0x251F04AE, "gunnertargetrange" },
    { 0xD2E30958, "gunnerweapon" },
    { 0x7CABC407, "gunnerweaponplayerequiv" },
    { 0xE60C7350, "gunnner" },
    { 0x71292A7F, "gunorigin" },
    { 0x29F365F9, "gunpoint" },
    { 0x6F0AEC4E, "gunpoint_crouch" },
    { 0x50EB65FC, "gunpoint_stand" },
    { 0x8ED5C7E8, "gunposition" },
    { 0x937B9383, "gunpositions" },
    { 0x14356D41, "gunprimary" },
    { 0xF31A80F5, "gunprimaryclipammo" },
    { 0x71F4D62C, "gunprogress" },
    { 0x8FBFABD6, "gunprogression" },
    { 0xC8AF4F01, "gunprogressionsize" },
    { 0x9111820A, "gunprogressionthink" },
    { 0x8C5522E6, "gunready" },
    { 0x2E51EC26, "gunreload" },
    { 0xDEC1B588, "guns" },
    { 0x2BC533F9, "guns_remaining" },
    { 0x617E6803, "gunship" },
    { 0x93CB0F0B, "gunship_support" },
    { 0x82894372, "gunships" },
    { 0x9B35E8E5, "gunshop" },
    { 0xA41BA33A, "gunshop_zone" },
    { 0x032BFF41, "gunshot" },
    { 0xCA9A6D15, "gunshot_comm_station" },
    { 0xACC47068, "gunshots" },
    { 0xCFE9E80E, "gunsidearm" },
    { 0x701BB47B, "gunsoundentity" },
    { 0xA7464129, "gunspot" },
    { 0x7ACF8499, "gunstructs" },
    { 0x239886DA, "guntruck" },
    { 0x21F203FE, "guntruck_destroyed" },
    { 0xADBDD5A8, "gunyouwant_zm" },
    { 0xC4E34786, "gurads_attack_player_when_stealth_is_broken" },
    { 0xBCB71907, "gurglesque" },
    { 0x57F042E4, "gush" },
    { 0x5021D318, "gust" },
    { 0x582ABBBF, "gusto" },
    { 0x505C4BF3, "gusts" },
    { 0xC92A6FDB, "gut" },
    { 0x8F96D0FA, "guts" },
    { 0x8FF15AEE, "guts_explosion" },
    { 0xE1D2D0A4, "gutter" },
    { 0x6B45B25E, "guy" },
    { 0xDC90236A, "guy0" },
    { 0x66C293B7, "guy01" },
    { 0xF4BB247C, "guy02" },
    { 0x02929DD3, "guy1" },
    { 0x004566D9, "guy10" },
    { 0xDA42EC70, "guy11" },
    { 0x4C4A5BAB, "guy12" },
    { 0xE7F0ADA9, "guy1_sequence" },
    { 0xDD0412C9, "guy1_sequence2" },
    { 0x41B1D4A0, "guy1_shot_callback" },
    { 0x86255F13, "guy1_spawn" },
    { 0x233F16CE, "guy1_spawner" },
    { 0x4C6CA78B, "guy1node" },
    { 0x908B2E98, "guy2" },
    { 0x134AF0A8, "guy2_sequence" },
    { 0xBB78C2C3, "guy2_shot_callback" },
    { 0x8497D598, "guy2_spawn" },
    { 0x5F0713ED, "guy2_spawner" },
    { 0xAA4455DC, "guy2node" },
    { 0xB68DA901, "guy3" },
    { 0x50D8D643, "guy3_sequence" },
    { 0x749A0D0E, "guy4" },
    { 0x9A9C8777, "guy5" },
    { 0x2895183C, "guy6" },
    { 0x4E9792A5, "guy7" },
    { 0xAC7C5022, "guy8" },
    { 0xD27ECA8B, "guy9" },
    { 0xA077319C, "guy_01" },
    { 0x127EA0D7, "guy_02" },
    { 0x0365B50E, "guy_1" },
    { 0xDD633AA5, "guy_2" },
    { 0xB760C03C, "guy_3" },
    { 0x915E45D3, "guy_4" },
    { 0x70CD2890, "guy_alive" },
    { 0xB41D6C8B, "guy_and_door" },
    { 0x75990FE9, "guy_and_flashlight" },
    { 0xE45E673D, "guy_angles" },
    { 0xB9962E8B, "guy_anime" },
    { 0x06530304, "guy_array" },
    { 0x64159FCB, "guy_array_enter" },
    { 0xDB09571A, "guy_array_enter_vehicle" },
    { 0x7EB31AB7, "guy_back_attack" },
    { 0x83F887FB, "guy_backtohide" },
    { 0xF6FC0376, "guy_backtohide_check" },
    { 0x88E3E596, "guy_blowup" },
    { 0x1344347F, "guy_box_helper" },
    { 0x86DEF4C5, "guy_box_host" },
    { 0x7A5C5767, "guy_dance5" },
    { 0x38ADB39B, "guy_dead" },
    { 0xD3B705C9, "guy_death" },
    { 0x2B7A85B8, "guy_death_fire" },
    { 0x04C97E55, "guy_death_fire_check" },
    { 0x00E3132F, "guy_deathhandle" },
    { 0xF748964E, "guy_deathimate_me" },
    { 0x9C6656A1, "guy_detect_enemy" },
    { 0x7560F2F3, "guy_drive_reaction" },
    { 0xD55E70DE, "guy_drive_reaction_check" },
    { 0xFA1F5826, "guy_duck" },
    { 0xEF63D1AF, "guy_duck_idle" },
    { 0x1C33C686, "guy_duck_once" },
    { 0x77395D4B, "guy_duck_once_check" },
    { 0xE1AF2E9B, "guy_duck_out" },
    { 0x8D31845E, "guy_east" },
    { 0xD420A0A1, "guy_enter" },
    { 0x0EE1C73C, "guy_enter_vehicle" },
    { 0x09AAF4D0, "guy_escape" },
    { 0xF3BF253D, "guy_escape_check" },
    { 0x14B5F9EC, "guy_explosion_launch" },
    { 0x4C5ECC38, "guy_follow_target_entity" },
    { 0x3344EE41, "guy_force_remove_from_vehicle" },
    { 0xCBB0CC35, "guy_going_towards_stairs" },
    { 0xFF5C806E, "guy_going_towards_stairs_falsify_delay" },
    { 0xCDA8D5D3, "guy_handle" },
    { 0x592D96AD, "guy_hidden" },
    { 0xDCBD7162, "guy_hide_attack_back" },
    { 0x8C218067, "guy_hide_attack_back_check" },
    { 0x55EEAA52, "guy_hide_attack_forward" },
    { 0xC0E63E37, "guy_hide_attack_forward_check" },
    { 0x07D7C3BC, "guy_hide_attack_left" },
    { 0xB6D81B69, "guy_hide_attack_left_check" },
    { 0x91D1ADBB, "guy_hide_attack_left_standing" },
    { 0x68DA66C2, "guy_hide_starting_back" },
    { 0x2902DB17, "guy_hide_startingleft" },
    { 0xA7D847A6, "guy_hidetoback_check" },
    { 0x8058380F, "guy_hidetoback_startingback" },
    { 0xADF49FE9, "guy_hop_on_mg" },
    { 0xDEF567C7, "guy_idle" },
    { 0x7D61A33E, "guy_jumpout_window" },
    { 0xC6FA3E76, "guy_knocked_off" },
    { 0xF547BACA, "guy_make_killable" },
    { 0xCC937028, "guy_man_gunner_turret" },
    { 0xAB40C1BC, "guy_man_turret" },
    { 0x2185F051, "guy_mantle_onto_box" },
    { 0x794F314B, "guy_move_to_driver" },
    { 0x9792C584, "guy_name" },
    { 0xCEE34597, "guy_num" },
    { 0xEBCFF833, "guy_origin" },
    { 0xB09FF1E2, "guy_origins" },
    { 0x4A0B26CF, "guy_out_of_missiles" },
    { 0xF3D3FAFB, "guy_picknose" },
    { 0x93B4E31D, "guy_primary" },
    { 0x97E0A696, "guy_queue_anim" },
    { 0xAF56C5D6, "guy_react" },
    { 0xD146223B, "guy_react_check" },
    { 0xE959CE44, "guy_reaction" },
    { 0x94564155, "guy_retreats" },
    { 0xFF288681, "guy_right" },
    { 0x804B9E9D, "guy_run_to_node_and_delete" },
    { 0x54BC8159, "guy_runtovehicle" },
    { 0xB7D63856, "guy_runtovehicle_fast" },
    { 0x31D75D68, "guy_runtovehicle_load" },
    { 0x0AEC877B, "guy_runtovehicle_loaded" },
    { 0x9C0298F1, "guy_secondary" },
    { 0x52D9873D, "guy_shot" },
    { 0x047BFB3A, "guy_snipe" },
    { 0xED016D0B, "guy_soldier2_meatshield_not_threat" },
    { 0x562A97CD, "guy_soldier2_meatshield_threat" },
    { 0xD5291E8E, "guy_soldier3_meatshield_not_threat" },
    { 0xCE5AD0E4, "guy_soldier3_meatshield_threat" },
    { 0xBD7FF83D, "guy_soldier4_meatshield_not_threat" },
    { 0xC22254D3, "guy_soldier4_meatshield_threat" },
    { 0x1A1940B0, "guy_south" },
    { 0x71ED7072, "guy_south2" },
    { 0xD715C7C7, "guy_spawner" },
    { 0xE3366ABE, "guy_spawners" },
    { 0x2D3E1095, "guy_spot" },
    { 0x41FB8E1B, "guy_stand" },
    { 0xF70A211A, "guy_stand_attack" },
    { 0xEA04D5DE, "guy_stand_down" },
    { 0x907A5699, "guy_start_swimming" },
    { 0x7693C417, "guy_stay_on_turret" },
    { 0x154CD969, "guy_stops_animating_on_high_alert" },
    { 0xEABD32B7, "guy_surrender_anim_custom" },
    { 0x3FEF5AC8, "guy_surrender_thread" },
    { 0x8C9CAF3B, "guy_targetname" },
    { 0x501279CD, "guy_thrown_out_window" },
    { 0xD780D864, "guy_to_goal_blind" },
    { 0x1644286B, "guy_turn_hardleft" },
    { 0x8213BEDE, "guy_turn_hardright" },
    { 0x2BC8E52C, "guy_turn_left" },
    { 0xFFE50A79, "guy_turn_left_check" },
    { 0xBFF32DC3, "guy_turn_right" },
    { 0xDCC3D70E, "guy_turn_right_check" },
    { 0x18E78B72, "guy_turret_fire" },
    { 0xEE098204, "guy_turret_turnleft" },
    { 0xAD34057B, "guy_turret_turnright" },
    { 0x1164883C, "guy_twitch" },
    { 0xAA0DDD85, "guy_twitch_idle" },
    { 0x4A342910, "guy_unlink" },
    { 0xF1B8DAE7, "guy_unlink_on_death" },
    { 0xFB837974, "guy_unload" },
    { 0x502B3D62, "guy_unload_que" },
    { 0x72EF3BC4, "guy_vehicle_death" },
    { 0xC87F46A1, "guy_weave" },
    { 0xE69A71EC, "guy_weave_check" },
    { 0x21CC5D03, "guya" },
    { 0x52EB3D71, "guyarray" },
    { 0xAFC4EDC8, "guyb" },
    { 0x791680BA, "guyindex" },
    { 0x2032B3A3, "guyname" },
    { 0x93197546, "guynum" },
    { 0x568AB329, "guypackets" },
    { 0x35EF0EC1, "guys" },
    { 0xE27965FA, "guys1" },
    { 0xBC76EB91, "guys2" },
    { 0x96747128, "guys3" },
    { 0xA085CA07, "guys4" },
    { 0x7A834F9E, "guys5" },
    { 0x5480D535, "guys6" },
    { 0xB5A986C5, "guys_1" },
    { 0xDBAC012E, "guys_2" },
    { 0xA0CC5E78, "guys_47mm_1_force_expand" },
    { 0xB30F9C05, "guys_47mm_1_radius_expand" },
    { 0xEC96786A, "guys_47mm_2_radius_expand" },
    { 0x91225068, "guys_47mm_4_radius_expand" },
    { 0x60892C6E, "guys_ai" },
    { 0xAD991667, "guys_alive" },
    { 0xD5A0F414, "guys_animating" },
    { 0x03AEB4EE, "guys_areclose" },
    { 0x4740E34B, "guys_ascend_admin_stairs" },
    { 0xFA664C3A, "guys_at_berm" },
    { 0x5EC30E4A, "guys_at_door" },
    { 0x881630DB, "guys_b_exiting_base_doors" },
    { 0xCCA9B0E0, "guys_climb_cliff" },
    { 0x7F904989, "guys_count" },
    { 0x8DE7E8C6, "guys_dead" },
    { 0x9798A04E, "guys_exiting_base_doors" },
    { 0x02A3F7C3, "guys_frontline_radius_expand" },
    { 0xEC4444B8, "guys_frontline_radius_expand_2" },
    { 0xC33F6BB4, "guys_in_pain" },
    { 0x32BF8BD2, "guys_in_volume" },
    { 0x2A4B61A8, "guys_inside" },
    { 0x7B28DDB7, "guys_killed" },
    { 0x8984CC7A, "guys_killed_weight" },
    { 0x0457B0E7, "guys_left" },
    { 0x3B3FFD94, "guys_on_boat" },
    { 0xD92B77E6, "guys_onground_killed" },
    { 0x91A0E67D, "guys_per_rappel_line" },
    { 0x9A58B7B4, "guys_reached_gate" },
    { 0x03279E76, "guys_ready_for_campfire_attack" },
    { 0x45D6B574, "guys_still_alive" },
    { 0x1037E99B, "guys_thinned_out" },
    { 0x76511F9F, "guys_to_animate" },
    { 0x99A3297A, "guys_to_check" },
    { 0x8CF3D08D, "guys_to_die_before_next_health_drop" },
    { 0x96E29EB6, "guys_to_kill" },
    { 0x9FCA5F6A, "guys_to_leapfrog_up" },
    { 0x601332D1, "guys_to_nodes" },
    { 0x2AE8DFD1, "guys_to_send_out" },
    { 0x94B7F470, "guys_touching_volume" },
    { 0x14D632EA, "guys_turned_green" },
    { 0x038D99F1, "guys_underwater_getting_shot" },
    { 0x21FA7A14, "guysalive" },
    { 0x47C29090, "guysarray" },
    { 0xDDF393D4, "guyso" },
    { 0xBAAE7306, "guyssn" },
    { 0x42E986CB, "guystn" },
    { 0x816707D6, "guystoremove" },
    { 0xFAB89350, "guytargetname" },
    { 0x93E07063, "guythrewtov" },
    { 0x92EAA1DE, "guyweapon" },
    { 0x59DCFA64, "guywires" },
    { 0xA98BE4AD, "guyxs" },
    { 0x53007878, "guzzo" },
    { 0xB2158716, "guzzo_print_3d" },
    { 0x5BCE041B, "guzzo_util" },
    { 0x73C8385B, "gvar" },
    { 0x3DB07D27, "gve" },
    { 0xCBB7188E, "gvtodo" },
    { 0x9CEDC35E, "gzheng" },
    { 0xEF5A711F, "h" },
    { 0xE4D48D14, "h1" },
    { 0x56DBFC4F, "h2" },
    { 0x6B75D6ED, "h20" },
    { 0x2FE88BCD, "h2h_hudson" },
    { 0x30D981E6, "h3" },
    { 0x05DFDD7D, "h_align" },
    { 0xA428C9D4, "h_crk" },
    { 0x7E89B783, "h_e" },
    { 0x33FDF7D1, "h_mud_overlay" },
    { 0x040E4C44, "ha" },
    { 0x3740D202, "habing" },
    { 0xF9E78D26, "hack" },
    { 0x22BC5906, "hack_boards" },
    { 0xA7AA40A8, "hack_box" },
    { 0xB9F3574D, "hack_box_qualifier" },
    { 0xB9BAD448, "hack_chair" },
    { 0x6514BE69, "hack_done" },
    { 0x96D11A0C, "hack_doors" },
    { 0x8BC1B9C9, "hack_duration" },
    { 0x09034760, "hack_fxanim_notify_fix" },
    { 0x3466B70C, "hack_hudson_react" },
    { 0xE0FB0FDB, "hack_moving_platform" },
    { 0x7ADD387D, "hack_packapunch" },
    { 0x04678364, "hack_perks" },
    { 0x5C836466, "hack_powerups" },
    { 0x835EFC12, "hack_stealth_settings" },
    { 0x030BA60E, "hack_success" },
    { 0xCB86D4A6, "hack_things" },
    { 0x75B20DBE, "hack_to_switch_melee_weapons" },
    { 0xE86124CB, "hack_trigger" },
    { 0xA7C3E09A, "hack_trigger_think" },
    { 0xE129252A, "hack_triggers" },
    { 0x862BC532, "hack_wallbuys" },
    { 0xDA616C44, "hack_windows" },
    { 0x742A6662, "hackable" },
    { 0xD2005AB1, "hackable_" },
    { 0xD0065713, "hackable_angledot" },
    { 0x14C4771D, "hackable_being_hacked" },
    { 0xA7E354DB, "hackable_cost_mult" },
    { 0x771CA058, "hackable_default_power_per_frame" },
    { 0x450C3DE8, "hackable_deregistered" },
    { 0x6E991EBF, "hackable_distance_sq" },
    { 0xDD1164E9, "hackable_fail_callback" },
    { 0x4285BB8E, "hackable_hack_time" },
    { 0x685796E4, "hackable_hacked_amount" },
    { 0x74C58911, "hackable_hacked_callback" },
    { 0xA0D2C0F7, "hackable_items" },
    { 0xFF2D4D2B, "hackable_object_thread" },
    { 0x90A6EEED, "hackable_progress_prompt" },
    { 0x462969F7, "hackable_speed_mult" },
    { 0x80AF18CF, "hackable_start_callback" },
    { 0x7B57CEC1, "hackable_test_callback" },
    { 0x22E8E842, "hackable_timeout" },
    { 0x660F7EC2, "hackable_turret_disable" },
    { 0x88FA1C07, "hackable_turret_enable" },
    { 0x589C73D6, "hackable_turret_think" },
    { 0x30AC2DC6, "hackable_watch_timeout" },
    { 0x17E09F03, "hackangle" },
    { 0x90D320A9, "hacked" },
    { 0xFE977B51, "hacked_before_breached_flag" },
    { 0x79EE246B, "hacked_ent" },
    { 0x17841A3A, "hacked_flag" },
    { 0x96E69632, "hackedcallbackpost" },
    { 0xC18DE8CF, "hackedcallbackpre" },
    { 0xBD48615F, "hackeddamagetaken" },
    { 0x727836B2, "hackeddialogkey" },
    { 0x119FA745, "hackedduration" },
    { 0x440349BF, "hackedhealth" },
    { 0xC339443C, "hackedhealthupdate" },
    { 0xDE46AE0D, "hackedhealthupdatecallback" },
    { 0x9CB2938E, "hackedkillstreakref" },
    { 0x790D5C8D, "hackedordestroyedequipment" },
    { 0xC373FCBB, "hackedpostfunction" },
    { 0x0DA11ACC, "hackedprefunction" },
    { 0xDAB0490C, "hackedprotection" },
    { 0xFC4A6B77, "hackedscoreevent" },
    { 0x99CDE924, "hackedstartdialogkey" },
    { 0x6D4D3EFC, "hackedtext" },
    { 0x6806D767, "hackedtoolinnerradius" },
    { 0x4C5B76F0, "hackedtoollostlineofsightlimitms" },
    { 0x1F2ED796, "hackedtoolouterradius" },
    { 0xD509A5AF, "hacker" },
    { 0x16547E88, "hacker_active" },
    { 0xF68B9C3E, "hacker_alreadyhacked" },
    { 0x9049492B, "hacker_debug" },
    { 0x73C65CEF, "hacker_debug_print" },
    { 0x655278DA, "hacker_delete_placeable_trigger" },
    { 0xFF133197, "hacker_do_hack" },
    { 0xC1D0939D, "hacker_health_overlay" },
    { 0x6F1B7122, "hacker_hides_blocker_trigger_thread" },
    { 0xCF6D9B98, "hacker_location_random_init" },
    { 0x90827CEE, "hacker_max_range" },
    { 0xBBA1FEEC, "hacker_on_player_connect" },
    { 0x09CB4598, "hacker_outline_material" },
    { 0x1B637B4C, "hacker_pos" },
    { 0x96A0D75E, "hacker_position_cleanup" },
    { 0xC35FFF84, "hacker_round_reward" },
    { 0x5A9DA66E, "hacker_slot" },
    { 0x4EED8BE9, "hacker_sound_ent" },
    { 0x5DC095B5, "hacker_sweet_spot_ratio" },
    { 0x90FB1E1D, "hacker_target" },
    { 0x42743D08, "hacker_tool" },
    { 0x3208913D, "hacker_tool_active" },
    { 0x4A13E712, "hacker_tool_array" },
    { 0xA2F7B9C5, "hacker_tool_fired" },
    { 0x256B58A3, "hacker_tool_firewall" },
    { 0x485593C0, "hacker_tool_hacking" },
    { 0xCA1FCBC8, "hacker_tool_inactive" },
    { 0x66CD22E1, "hacker_tool_positions" },
    { 0x1D7C3F19, "hacker_tool_status_breaching" },
    { 0x7C64AF49, "hacker_tool_status_emped" },
    { 0x18C31E75, "hacker_tool_status_hacking" },
    { 0x63C965A1, "hacker_tool_status_scanning" },
    { 0x7FAE632A, "hacker_trigger_pool_think" },
    { 0x07C5FCC3, "hacker_wait_and_react" },
    { 0x4C4A7454, "hacker_wait_trigger_or_damage" },
    { 0x1A1DA3F9, "hackerfx" },
    { 0xCEE96F18, "hackerhint" },
    { 0xE496DFF3, "hackerhints" },
    { 0x8A685063, "hackerhintstring" },
    { 0x77989EB9, "hackerinit" },
    { 0xE2F5C237, "hackerloopfx" },
    { 0x59C3C200, "hackernotmoving" },
    { 0xEAEEE105, "hackerobjid" },
    { 0xCF22DD30, "hackerplayer" },
    { 0x4877737D, "hackerprogressbar" },
    { 0xAB54372B, "hackerremoveweapon" },
    { 0xE5A34F3C, "hackerresult" },
    { 0x3C456332, "hackersoftsighttest" },
    { 0x7B9C0C69, "hackertexthud" },
    { 0x668F9391, "hackerthink" },
    { 0xACBF959D, "hackertool_update_ent" },
    { 0x66D630A2, "hackertooldamage" },
    { 0x4DD66DEF, "hackertooldebugtext" },
    { 0x65AE1709, "hackertoolhacktimems" },
    { 0xE525578D, "hackertoolinnerradius" },
    { 0x4FD6409C, "hackertoolinnertimems" },
    { 0x0CA129FE, "hackertoollockfinalized" },
    { 0xACFA2760, "hackertoollockonfov" },
    { 0x5B365E75, "hackertoollockonradius" },
    { 0xF5255377, "hackertoollockstarted" },
    { 0xC213B727, "hackertoollockstarttime" },
    { 0x5276D275, "hackertoollocktimeelapsed" },
    { 0x572D19E3, "hackertoollostsightlimitms" },
    { 0x71B4CB97, "hackertoollostsightlinetime" },
    { 0xF916253A, "hackertoolmaxequipmentdistance" },
    { 0xC23C0356, "hackertoolmaxequipmentdistancesq" },
    { 0x4CB41131, "hackertoolnosighthackdistance" },
    { 0x57D2B7B0, "hackertoolouterradius" },
    { 0x48A0EBC1, "hackertooloutertimems" },
    { 0x357DBB57, "hackertoolprogressbar" },
    { 0xB907073D, "hackertoolprogresstext" },
    { 0xDFDB97FF, "hackertoolradius" },
    { 0xEBF4516E, "hackertooltarget" },
    { 0x7D2F5598, "hackertooltargetloop" },
    { 0x9A5FF691, "hackertooltargets" },
    { 0x8569DA12, "hackertooltimems" },
    { 0xEEDA7749, "hackertrigger" },
    { 0x4686B801, "hackertriggerorigintag" },
    { 0xDC15C9DB, "hackertriggersetvisibility" },
    { 0xA6598614, "hackerunfreezeplayer" },
    { 0x762B9D6C, "hackery" },
    { 0x43D288C4, "hackeryish" },
    { 0x7B3CF7AE, "hackexit" },
    { 0x931609BC, "hackey" },
    { 0x44613D84, "hackey_look_at_ent" },
    { 0x9AFF8F34, "hackfx" },
    { 0xAC959FBA, "hacking" },
    { 0xC04376C5, "hacking_player_weapon" },
    { 0x20AD2DB8, "hackingsoundid" },
    { 0xCA520B29, "hackingsweetspotid" },
    { 0xB74843CA, "hackingtimenolineofsightscale" },
    { 0xFB902055, "hackingtimescale" },
    { 0xAF2D2CFE, "hackish" },
    { 0x369F739A, "hackloopfx" },
    { 0x1A8F3F02, "hackout" },
    { 0xE581BB36, "hackpercentage" },
    { 0x45AEA4C6, "hackprogressbar" },
    { 0x85074FB2, "hackprogresstext" },
    { 0x9FC6A4F3, "hackratio" },
    { 0x08964659, "hacks" },
    { 0x72DBE4B9, "hacksaw" },
    { 0xE4E0F499, "hacktime" },
    { 0xBE9D3961, "hacktimems" },
    { 0x1962695E, "hacktofixstart" },
    { 0x0EFB67D7, "hacktoolinnertime" },
    { 0xB980BBEC, "hacktoolnolineofsighttime" },
    { 0xB20E47C2, "hacktooloutertime" },
    { 0x84AF0E73, "hacky" },
    { 0xCEC77288, "had" },
    { 0xB8E08F70, "had_ballistic" },
    { 0xC0D5CCF3, "had_ballistic_upgraded" },
    { 0x0BC1CFF0, "had_fallback_weapon" },
    { 0xD8B7843C, "had_to_delay" },
    { 0xC2AAF513, "had_weapon" },
    { 0x5EC242BE, "hadclingpistol" },
    { 0x5BC8E795, "hadgroupdialog" },
    { 0x8BCFA1DD, "hadpistol" },
    { 0x8F0C79F2, "hadspawned" },
    { 0x9C863391, "hadweaponbeforepickingup" },
    { 0xF4C9ECF1, "hae" },
    { 0xDF9DE5BA, "haggerty" },
    { 0x36BD88E4, "hah" },
    { 0x774EE0B5, "haha" },
    { 0xF72D7797, "hahah" },
    { 0x4CA2E0EC, "hahaha" },
    { 0x1D9DAA0D, "hahahaha" },
    { 0x896A5E5E, "hai1" },
    { 0xA179959C, "hai1_01" },
    { 0x8B08864B, "hai1_01_render" },
    { 0xB37B179D, "hai1_01a" },
    { 0x60DBECE0, "hai1_01a_render" },
    { 0xD97D9206, "hai1_01b" },
    { 0x7070E8D1, "hai1_01b_render" },
    { 0xB2DDAEC9, "hai_01" },
    { 0x09FFDEAC, "hai_01_render" },
    { 0xFEE2A39B, "hai_03" },
    { 0x1E2CBD42, "hai_03_render" },
    { 0xE4067E35, "hair" },
    { 0x768EB858, "haiti" },
    { 0x7B247449, "haiti_amb" },
    { 0xF86AE380, "haiti_anim" },
    { 0x0169AAEE, "haiti_art" },
    { 0x78A4993D, "haiti_endings" },
    { 0xF2E89B9B, "haiti_front_door" },
    { 0x6CB99AB9, "haiti_fx" },
    { 0x3320CF93, "haiti_intro" },
    { 0x45D348D5, "haiti_jetwing" },
    { 0x625D4FC5, "haiti_ny_controls" },
    { 0x11AF222F, "haiti_transmission" },
    { 0x91B6883B, "haiti_util" },
    { 0xC8A0091B, "haiti_vision" },
    { 0xE402DEED, "haitian" },
    { 0x38834316, "half" },
    { 0x11B0587A, "half_angle" },
    { 0x824A72CE, "half_box_depth" },
    { 0xD15921D6, "half_box_height" },
    { 0x4E3AD13D, "half_box_width" },
    { 0xEE53E56E, "half_cone_height" },
    { 0xCBBF6877, "half_cylinder_height" },
    { 0xDB957782, "half_damage" },
    { 0xD51DFB6D, "half_damage_amount" },
    { 0x370979C5, "half_dist" },
    { 0x7E1C2E38, "half_height" },
    { 0x05694B92, "half_time" },
    { 0x65FD24DA, "half_way" },
    { 0x20CAF227, "half_x" },
    { 0xFAC877BE, "half_y" },
    { 0xD4C5FD55, "half_z" },
    { 0x84C9A0BE, "halfalpha" },
    { 0x567425FB, "halfdistance" },
    { 0xCA5C4668, "halfgravity" },
    { 0x16AB6933, "halfheight" },
    { 0xE2808918, "halflife" },
    { 0x176384AA, "halfnode" },
    { 0x67BC0A7C, "halfplane" },
    { 0x8EE030C0, "halfrate" },
    { 0x408AD641, "halfsize" },
    { 0x87B8FFE9, "halftime" },
    { 0x4E993783, "halftimeroundenddelay" },
    { 0x4DDE7545, "halftimesubcaption" },
    { 0x41BAADF1, "halftimetype" },
    { 0x0AAE4133, "halftrack" },
    { 0x7BFCDA1F, "halftrack2_riders_setup" },
    { 0xA9B368E0, "halftrack_advance_a" },
    { 0x1BBAD81B, "halftrack_advance_b" },
    { 0x7E60D8AA, "halftrack_field" },
    { 0xFC63666E, "halftrack_house" },
    { 0xABBD07C7, "halftrack_mg_behavior" },
    { 0x488CDCE2, "halftracks" },
    { 0xD524D73B, "halftracks_move_trigger" },
    { 0xB0D2D78F, "halftracks_moving" },
    { 0xCB22C2BB, "halfway" },
    { 0xFE75E362, "halfway_dist" },
    { 0xBC0667F3, "halfway_height" },
    { 0xBEA9516C, "halfway_point" },
    { 0x7AAAFA20, "halfway_through_field" },
    { 0x407F3727, "halfwaydist" },
    { 0x6E7336B0, "halfwaydist_new" },
    { 0x45830BEA, "halfwayheight" },
    { 0xE93CE489, "halfwayheight_new" },
    { 0x5CF2D9F3, "halfwayscore" },
    { 0x1C92218C, "hall" },
    { 0xBBFEF92A, "hall_defense_fallback" },
    { 0x5ACAC817, "hall_door" },
    { 0x15BC78A0, "hall_door_clip" },
    { 0xCD99F842, "hall_door_collision" },
    { 0x7E388469, "hallway" },
    { 0x561D9D72, "hallway1" },
    { 0x4ECF4A96, "hallway1_pmcs" },
    { 0xFFE6919B, "hallway1_start" },
    { 0x301B2309, "hallway2" },
    { 0x83A4C8D8, "hallway2_start" },
    { 0xA2A9B02C, "hallway_advancer" },
    { 0x8B43DD71, "hallway_ai_logic" },
    { 0x06C886C1, "hallway_battle_advance" },
    { 0x1B0D6AE9, "hallway_breach_closet_monitor" },
    { 0x95B9AC86, "hallway_breach_guys" },
    { 0x605DB93D, "hallway_breach_kick_fx" },
    { 0x69430D10, "hallway_cleared" },
    { 0x089DB98E, "hallway_defender_trig" },
    { 0xC7DC01C4, "hallway_door" },
    { 0x6610719B, "hallway_exposure" },
    { 0x48228298, "hallway_fire" },
    { 0x9F91DA04, "hallway_friendly_think" },
    { 0x3C24ED3A, "hallway_front_rush" },
    { 0xFA12F565, "hallway_guy" },
    { 0xA7913A9F, "hallway_left" },
    { 0x53D4CBE6, "hallway_left_door" },
    { 0x7B6555D8, "hallway_light" },
    { 0x4D59DE1E, "hallway_light_model" },
    { 0xB9C0BD6C, "hallway_mg" },
    { 0x8B45B4C9, "hallway_pmc_think" },
    { 0x66525D78, "hallway_popnrun" },
    { 0xA0ADE429, "hallway_right_door" },
    { 0x57B497DF, "hallway_turret_think" },
    { 0x8AB742E0, "hallways" },
    { 0x9F46E190, "hallways_breach" },
    { 0x7C119346, "hallways_breach_alavi_hack" },
    { 0x57A55C49, "hallways_breach_clip" },
    { 0x5B77CDF0, "hallways_breach_moveout" },
    { 0xD46E37B1, "hallways_dialogue" },
    { 0xBCC2E1AF, "hallways_enter" },
    { 0x8B724DB7, "hallways_heroes" },
    { 0x69A1CF54, "hallways_heroes_atgoal" },
    { 0x1C45BE2F, "hallways_heroes_ready" },
    { 0xF467AC73, "hallways_heroes_solo" },
    { 0x7A9E4FAE, "hallways_lower_runners" },
    { 0x7A7FF948, "hallways_lower_runners1_death" },
    { 0xC95A20A8, "hallways_lower_runners2" },
    { 0xE02E3A92, "hallways_lower_runners_common" },
    { 0x04469E3A, "hallways_lower_runners_deathnotify" },
    { 0x6E33D28E, "hallways_lower_runners_instakill" },
    { 0x8E075940, "hallways_main" },
    { 0x0E4740F0, "hallways_player_speed" },
    { 0x46DE7D29, "hallwaysnap" },
    { 0x8E9990C7, "halo" },
    { 0x87D2B5BB, "halo_jump_go" },
    { 0x64A3358C, "halo_jump_speed_match" },
    { 0xED3B33BF, "halo_jump_think" },
    { 0xDAE81CCF, "halo_jumpers_fx" },
    { 0x4CA5F4D4, "halt" },
    { 0x1CBD6605, "halt_patrol" },
    { 0x801F0B5B, "halt_stretcher" },
    { 0x459C6E42, "haltadvance" },
    { 0x81B892D0, "haltfire" },
    { 0xCED0E547, "halts" },
    { 0xFA081BBF, "halve" },
    { 0x3E639CD4, "halve_score" },
    { 0x82091129, "halved" },
    { 0xA03D1BC6, "halves" },
    { 0x073CA0ED, "halway" },
    { 0xC4B619A9, "ham" },
    { 0x413D0D43, "ham_radio_damage" },
    { 0xFF4E0EBA, "ham_radio_loop" },
    { 0xD66A2B3D, "hamilton" },
    { 0x99C2F3B7, "hammer" },
    { 0xCEC957D1, "hammer_audio_limiter" },
    { 0x4A4D447C, "hammered" },
    { 0x36B35EE9, "hammering" },
    { 0x5002B267, "hammock" },
    { 0x0ACA1950, "hammock_detect_player_attack" },
    { 0x72A0BF01, "hammock_killed_by_player" },
    { 0x19BF7EE8, "hammock_killed_by_woods" },
    { 0x56799A5F, "hammock_name" },
    { 0x3333715B, "hamp" },
    { 0xEAB89412, "han" },
    { 0xB9994752, "hand" },
    { 0x0A36FCAA, "hand_2_hand_done" },
    { 0x4154DB7D, "hand_2_hand_kill_shot" },
    { 0xD2580F11, "hand_pos" },
    { 0x29791946, "hand_to_hand" },
    { 0x161D61D3, "handbrake" },
    { 0xFFF53E61, "handcuffs" },
    { 0x5DBDA665, "handed" },
    { 0xB6489F0B, "handeling" },
    { 0x8B8E909A, "handes" },
    { 0xE3FB4A3B, "handful" },
    { 0xFF6C015E, "handing" },
    { 0x0BFB3493, "handle" },
    { 0x4B7A2209, "handle_ai_hero_movement" },
    { 0x52B2DC1D, "handle_ai_stairs" },
    { 0xFFB39109, "handle_all_followers_dying" },
    { 0xE39438B9, "handle_attached_guys" },
    { 0xE96866FF, "handle_badplaces" },
    { 0xB45C9235, "handle_basejump_fov" },
    { 0x212E675C, "handle_bleeder_death" },
    { 0x8301E2AB, "handle_cac_customization" },
    { 0xADE2F410, "handle_cac_customization_attachmentvariant" },
    { 0x970C5A0A, "handle_cac_customization_closed" },
    { 0x0A188BA2, "handle_cac_customization_focus" },
    { 0xDB76BFD5, "handle_cac_customization_weaponoption" },
    { 0x5D80758B, "handle_camera" },
    { 0x43F6125E, "handle_child_soldiers" },
    { 0xB8F7F8F8, "handle_civilian_sounds" },
    { 0x33A22809, "handle_clear_c4" },
    { 0xD99F9AE6, "handle_custom_weapon_refunds" },
    { 0x73AD91F8, "handle_death" },
    { 0x2D2C3B8F, "handle_death_notetracks" },
    { 0x364FB5CA, "handle_deck_end_door" },
    { 0xE3EDFE1F, "handle_delete" },
    { 0x5637F4CA, "handle_detached_guys_check" },
    { 0x48793F85, "handle_detonation" },
    { 0xA9437042, "handle_dogbite_notetrack" },
    { 0x07F11BB4, "handle_effects" },
    { 0xED7CD46D, "handle_fall_death_notetracks" },
    { 0xCAE6D210, "handle_fall_notetracks" },
    { 0xAF1320D0, "handle_falling_death" },
    { 0x178F38E8, "handle_fire_sale" },
    { 0xDBDEC429, "handle_followers_dying" },
    { 0x3A4CCE98, "handle_forced_streaming" },
    { 0x5FA610CA, "handle_gasfreeze_ai_death" },
    { 0x533880EE, "handle_generator_capture" },
    { 0xBBA3DF08, "handle_hind_interior" },
    { 0x701345F3, "handle_horizontal_board_clientside_fx" },
    { 0xD1565832, "handle_horse_charge_blow_up_horses" },
    { 0x4EFE5CCE, "handle_horse_charge_ending" },
    { 0xCAADB018, "handle_horse_charge_extra_horses" },
    { 0xE6AEC42C, "handle_horse_charge_hind" },
    { 0xE9B13EF9, "handle_horse_charge_intro_hind" },
    { 0x26939EA6, "handle_horse_charge_mig_fly_overs" },
    { 0x3B451D8B, "handle_horse_charge_mortars" },
    { 0x61B1F358, "handle_horse_charge_new_horses" },
    { 0x6FDD6739, "handle_horse_charge_push_off_migs_and_mortars" },
    { 0x25A10494, "handle_horse_charge_rpg_shot_at_btr" },
    { 0xCE1DFEE0, "handle_horse_charge_rpg_shot_at_uaz" },
    { 0xA397DE1B, "handle_horse_death_fx" },
    { 0xDB3A2EE7, "handle_if_mg_is_killed_early" },
    { 0x5D99FB7C, "handle_interrogation_shake" },
    { 0xA0C41361, "handle_jetgun_pain_notetracks" },
    { 0x770F65DC, "handle_krav_strangle_setup_horses" },
    { 0xEFFBCF13, "handle_krav_tank_falling_out_of_the_world" },
    { 0xF7C22DDA, "handle_length" },
    { 0xB06F0D35, "handle_lod_display_for_driver" },
    { 0x6F3DA9F5, "handle_m32_allies" },
    { 0xB1FFF6B9, "handle_m32_gas_death" },
    { 0xFFEA20A1, "handle_map_controls" },
    { 0xAD8A27DE, "handle_meat_event" },
    { 0x07B40741, "handle_meat_events" },
    { 0x8A1C8F49, "handle_movie_dvars" },
    { 0xA8A4822F, "handle_notetrack" },
    { 0x2EE5DC76, "handle_notetracks" },
    { 0x10C3D9D4, "handle_numbers" },
    { 0xD238737D, "handle_overheated_jetgun" },
    { 0xAF1EE44E, "handle_pdf_hangar_movement" },
    { 0x241B1750, "handle_pickup_btr_chase" },
    { 0x30FA406E, "handle_player_flanking" },
    { 0xD74351BF, "handle_player_hud" },
    { 0x82131040, "handle_player_poi" },
    { 0x5E7CD12A, "handle_post_board_repair_rewards" },
    { 0x56A836E0, "handle_prefixed_notetracks" },
    { 0xB8873DF0, "handle_punch_pain_notetracks" },
    { 0x2E7BAB98, "handle_punch_timescale" },
    { 0xE3E8293D, "handle_quadrotor_flyaway" },
    { 0xCF155DDA, "handle_radiation_warning" },
    { 0xFCC2B3F6, "handle_reviver_death" },
    { 0x2EEB832C, "handle_reviver_goal_change" },
    { 0x50E738ED, "handle_rider_death" },
    { 0x02A31759, "handle_riotshield_pain_notetracks" },
    { 0x55F80F50, "handle_rise_notetracks" },
    { 0x044F05F1, "handle_rock_clientside_fx" },
    { 0xB861F2A8, "handle_shop_guy_1_nodes" },
    { 0xF82CFE9B, "handle_shop_guy_2_nodes" },
    { 0x7A9575D1, "handle_sit_dec20" },
    { 0xCC64404B, "handle_skiptos" },
    { 0xC82C4B27, "handle_special_ai_death" },
    { 0xB5ECB525, "handle_sr71_transition_fov" },
    { 0xEFB5B029, "handle_stand_dec20" },
    { 0xDF32A5D9, "handle_starts" },
    { 0x6B27EDC6, "handle_subwoofer_pain_notetracks" },
    { 0x0BAD8B74, "handle_surveillance_toggle" },
    { 0x06492173, "handle_tank_bunker_collision" },
    { 0x1D84F220, "handle_tank_climb_hind" },
    { 0x249451C6, "handle_tank_climb_migs_and_mortars" },
    { 0x6FFF5ECA, "handle_tank_climb_setup_axis" },
    { 0x3B5FA127, "handle_tank_climb_setup_horses" },
    { 0x7B4F2586, "handle_tank_earthquake" },
    { 0xF833928A, "handle_tank_explosion" },
    { 0xDBAF9DE6, "handle_tank_fight_mortars" },
    { 0xB094C6D8, "handle_tank_fight_run_horses" },
    { 0x68E9697E, "handle_tank_fight_run_migs" },
    { 0x112F73DE, "handle_tank_roll_over_mortars" },
    { 0xB24AB36E, "handle_tank_strangle_run_horses" },
    { 0xB240A661, "handle_target" },
    { 0x8374F16D, "handle_thrown_smoke_grenade" },
    { 0xA024186C, "handle_thundergun_pain_notetracks" },
    { 0x9CD26C94, "handle_truck_death" },
    { 0x2910F0EE, "handle_unload_event" },
    { 0x2483CC67, "handle_use" },
    { 0xB04E8299, "handle_vertical_board_clientside_fx" },
    { 0x510C8745, "handle_vulture" },
    { 0x61CF2476, "handle_vulture_falling_death" },
    { 0xA37F89CA, "handle_wind_tunnel_bunker_collision" },
    { 0xB145B28F, "handle_xcam" },
    { 0x397591AB, "handle_zombie_lowg_risers" },
    { 0xD9FA15ED, "handle_zombie_risers" },
    { 0x53982D29, "handle_zombie_risers_foliage" },
    { 0xEFF9F4BD, "handle_zombie_risers_lowg" },
    { 0x85F71CFD, "handle_zombie_risers_water" },
    { 0xA5780874, "handleasrocketdamage" },
    { 0x5338121B, "handlebackcrawlnotetracks" },
    { 0xFEEC9F0D, "handlebanzaifailednotetracks" },
    { 0x864B2FD6, "handlebanzaiknockdownnotetracks" },
    { 0x43AB931A, "handlebanzailaststandnotetracks" },
    { 0x90BB8025, "handlebars" },
    { 0xB96614CF, "handlebigdogdeathfunction" },
    { 0xAF458654, "handlebleedernotetracks" },
    { 0xE6FC328A, "handlebox" },
    { 0x00C51BF7, "handlecamochange" },
    { 0xC8316985, "handlecleanup" },
    { 0x486B946D, "handled" },
    { 0x825EF784, "handledamage" },
    { 0xF71710DB, "handledeath" },
    { 0xC04F3467, "handledeathfunction" },
    { 0x4D7D1204, "handledogsoundnotetracks" },
    { 0xC6D4FD2A, "handledropclip" },
    { 0x567C2348, "handleed" },
    { 0x0ED59D79, "handleelement" },
    { 0xC988740F, "handleflamedamage" },
    { 0xEEF9C953, "handlegibnotetracks" },
    { 0x078330D1, "handleincomingmissile" },
    { 0x2396247C, "handleincomingsam" },
    { 0x722626B7, "handlemeleebiteattacknotetracks" },
    { 0xD58ADA97, "handlemeleebiteattacknotetracks2" },
    { 0x04AB407C, "handlemeleefinishattacknotetracks" },
    { 0x872BADA7, "handlenewsidebet" },
    { 0x08ED1270, "handlenotetrack" },
    { 0xB9B78207, "handleorg" },
    { 0xA4E7EDEB, "handlepickup" },
    { 0x0C213586, "handlepickupandthrow" },
    { 0x8C7E4704, "handleplayer" },
    { 0xECD0389C, "handleplayerknockdownnotetracks" },
    { 0x5949CB92, "handleplaygesture" },
    { 0x67142C9F, "handleplaytop0gesture" },
    { 0x912CA9DC, "handleplaytop1gesture" },
    { 0x10AD2F85, "handleplaytop2gesture" },
    { 0xDD3A3A08, "handleputaway" },
    { 0xB721762C, "handleputawaycleanup" },
    { 0x5C8E462B, "handler" },
    { 0x00540FBD, "handler_range" },
    { 0x0435EA56, "handlerevivernotetracks" },
    { 0xBC51D8E6, "handlerflagval" },
    { 0x471292F7, "handlerfunction" },
    { 0x11BC09C9, "handlerglobalflagval" },
    { 0xA6107E0A, "handlers" },
    { 0x368BCBC2, "handles" },
    { 0x705715D4, "handlesidetosidenotetracks" },
    { 0xFCC60454, "handlestartaipart" },
    { 0xED78A948, "handlestolenscoreevent" },
    { 0x09F86A66, "handlesuppressingenemy" },
    { 0x2CFB2067, "handlesurfacenotetrackfx" },
    { 0xDD8BF2AD, "handlethiefkill" },
    { 0xAE4F634E, "handletopthreeplayers" },
    { 0x91C4F110, "handletraversealignment" },
    { 0xBBDC685E, "handletraversedeathnotetrack" },
    { 0xF9257CDA, "handletraversedrop" },
    { 0x1122AA9D, "handletraversenotetracks" },
    { 0xEF875616, "handling" },
    { 0x65CFA8E9, "handmodel" },
    { 0x34CC3EF9, "handoff" },
    { 0x059DEF78, "handofnod" },
    { 0x2FFB1537, "handofnod_attack" },
    { 0x0C8F0465, "handofnod_launch_abort" },
    { 0x0ACCA9B5, "handofnod_launched" },
    { 0x78BFBF5D, "hands" },
    { 0xC4BC5531, "hands_callback" },
    { 0x52B4C162, "hands_flightstick_animator" },
    { 0x2557D467, "hands_flightstick_animator_think" },
    { 0x01192974, "hands_notetrack_watcher" },
    { 0x3CCA28AA, "handsignal" },
    { 0xF4D88777, "handy" },
    { 0x9396CCE9, "hang" },
    { 0x00D51BA4, "hangar" },
    { 0xECF37610, "hangar1_ai_management" },
    { 0x2C5664A4, "hangar1_fuel_trucks_logic" },
    { 0x9D32E7B2, "hangar1_middle_guys" },
    { 0xE2C453ED, "hangar1_middle_guys_logic" },
    { 0xF583F23A, "hangar1_player_prevention" },
    { 0xE27B7CF1, "hangar1_runner_logic" },
    { 0xC771F599, "hangar1_runners" },
    { 0x94757B7D, "hangar_0_bad" },
    { 0xC1CCA3A3, "hangar_0_good" },
    { 0xC5450998, "hangar_1_bad" },
    { 0x639C3518, "hangar_1_good" },
    { 0x0026FB47, "hangar_2_bad" },
    { 0xA4F19919, "hangar_2_good" },
    { 0xE5D83E62, "hangar_3_bad" },
    { 0xB5865296, "hangar_3_good" },
    { 0x8C923ED1, "hangar_4_bad" },
    { 0x106DA417, "hangar_4_good" },
    { 0x720827D7, "hangar_approach_swap_to_soct" },
    { 0xCC02698B, "hangar_blocker" },
    { 0x6B2C99AF, "hangar_cessna_flyby" },
    { 0x4176C5F8, "hangar_door_clip" },
    { 0x50950055, "hangar_door_left_1" },
    { 0x26547420, "hangar_door_right_1" },
    { 0x82980AB6, "hangar_doors" },
    { 0x2E420361, "hangar_doors_open" },
    { 0x7E043FA7, "hangar_doors_start" },
    { 0x0410F3F1, "hangar_drone_spawning" },
    { 0xAC9CD8E8, "hangar_exploder" },
    { 0x69148172, "hangar_frontline" },
    { 0xFB3F80C2, "hangar_gone_hot" },
    { 0x3C6F1138, "hangar_gump_wait" },
    { 0xA3A7DAA9, "hangar_guy2_logic" },
    { 0x99676DF8, "hangar_intruder_door_open" },
    { 0xBEDA8407, "hangar_intruder_specialty" },
    { 0x197161A5, "hangar_lock_gate_clip" },
    { 0x10D2E714, "hangar_main" },
    { 0x4A203E43, "hangar_pdf" },
    { 0x6CD5C204, "hangar_pdf_seals" },
    { 0xB1D132A6, "hangar_random_wind_gusts" },
    { 0xFDD35129, "hangar_roof_vo" },
    { 0xB9470A8F, "hangar_roof_vo_struct" },
    { 0xC16D0424, "hangar_rpg" },
    { 0xF00C1FB4, "hangar_rpg_guy" },
    { 0x37FBBC9F, "hangar_seals" },
    { 0xDD631CF0, "hangar_signal_guy_logic" },
    { 0x9686331E, "hangar_started" },
    { 0x055A4BD7, "hangars" },
    { 0x34A28A85, "hanged_ger" },
    { 0xFB5E0A97, "hanged_germans_init" },
    { 0x3D5DD030, "hanger" },
    { 0x2A667267, "hanger_1st_explosion_time" },
    { 0x3C942FFD, "hanger_chase_started" },
    { 0xE32941AE, "hanger_ending_chase_anims" },
    { 0x88F50563, "hanger_explodes_time" },
    { 0x7D848FB5, "hanger_failure_explosion_time" },
    { 0x8C53244F, "hanger_hit_by_tower_start_time" },
    { 0xD3F07CC7, "hanger_skipto_enemy_hacks" },
    { 0x1C013663, "hanger_wait_for_player_to_enter" },
    { 0x38A88860, "hangerdoor" },
    { 0xCBB4D202, "hangguy" },
    { 0x7EDFEABD, "hangguy_with_ragdoll" },
    { 0xF154668E, "hangguy_with_ragdoll1" },
    { 0x67DE671F, "hanging" },
    { 0xF9AE6CB4, "hanging_dead_guy" },
    { 0x957AA3C5, "hanging_on" },
    { 0xD0E0BEB8, "hanging_yell" },
    { 0xB2CC29C5, "hangout_time" },
    { 0xAE236460, "hangs" },
    { 0x9F8F8BBE, "hangtime" },
    { 0x579EF78D, "happen" },
    { 0x1F959A3A, "happened" },
    { 0xB0B3AD9B, "happening" },
    { 0xE9C1500C, "happens" },
    { 0x1B0ABF96, "happesn" },
    { 0x800BB3DD, "happy" },
    { 0x58E14793, "hara" },
    { 0x90A5436F, "harbor" },
    { 0xD2137E0B, "harcoded" },
    { 0xCAE8B6CE, "hard" },
    { 0x67D6784B, "hardcoded" },
    { 0x9BBD9267, "hardcore" },
    { 0x09A17249, "hardcore_award" },
    { 0x42C8807A, "hardcoremedalpopup" },
    { 0x50527FFE, "hardcoremode" },
    { 0xB5C94410, "hardened" },
    { 0xC7DB6680, "hardened_mp" },
    { 0xE31E6583, "hardenedaward" },
    { 0x269F9317, "harder" },
    { 0x1CE0CFDE, "hardest" },
    { 0x10B8BB98, "hardest2kill" },
    { 0xF109AA08, "hardest2killnum" },
    { 0x2391C93C, "hardlinewatchfordeath" },
    { 0x2EB03926, "hardlinewatchingfordeath" },
    { 0x27A48DC4, "hardpoint" },
    { 0xA0155F46, "hardpoint_name" },
    { 0x8EC9593E, "hardpoint_state" },
    { 0xD48F21A4, "hardpoint_used" },
    { 0x6F752EF6, "hardpointfx" },
    { 0xC1B1C4D6, "hardpointhints" },
    { 0xB6F1B312, "hardpointinforms" },
    { 0x49E4EE30, "hardpointitems" },
    { 0xA7F1B756, "hardpointitemselector" },
    { 0xD1D36CD7, "hardpointitemwaiter" },
    { 0x458773D0, "hardpointkillstreakearnedcount" },
    { 0x3E6E8AEA, "hardpointmomentum" },
    { 0xE20870A5, "hardpointname" },
    { 0x04CE951F, "hardpointnotify" },
    { 0xBE898E77, "hardpoints" },
    { 0x98FB37A2, "hardpointsenabled" },
    { 0xA912FA7B, "hardpointtweaks" },
    { 0x4E6859EC, "hardpointtype" },
    { 0x266FE82E, "hardpointtypefordamage" },
    { 0x04A37870, "hardpointweapon" },
    { 0xE5501738, "hardrain" },
    { 0xF12D275B, "hardwired" },
    { 0xC0D75DEF, "harm" },
    { 0xEA685834, "harmed" },
    { 0xB9075638, "harmless" },
    { 0x550D01E1, "harmony" },
    { 0xD06A9083, "harness" },
    { 0xD2B7269A, "harp" },
    { 0x349D8960, "harp_path_kill_trig" },
    { 0xEAB7D6EB, "harper" },
    { 0x08CA2385, "harper_alive_or_not" },
    { 0xBD303C5B, "harper_and_gaz_scene" },
    { 0xE7ACCDED, "harper_and_karma_loop" },
    { 0x5DB9528D, "harper_anim_blend" },
    { 0x853E910C, "harper_anim_blends" },
    { 0x0F02A1B4, "harper_at_ladder" },
    { 0x9857554D, "harper_attack_drone" },
    { 0x1F1F751D, "harper_awareness" },
    { 0x3E4F402D, "harper_beeline_to_bank" },
    { 0x9D9C9F42, "harper_catchup_alley" },
    { 0xF4618EB6, "harper_celerium" },
    { 0xC9145BED, "harper_celerium_catchup" },
    { 0x5CC64A65, "harper_claw_defend_logic" },
    { 0x513CA1CF, "harper_colortrigger_alley" },
    { 0x23FD30BF, "harper_ddm_ready" },
    { 0x7F358E93, "harper_defend_scene" },
    { 0x2C56D326, "harper_dialog" },
    { 0x5D1315FE, "harper_dialogue_complete" },
    { 0xBD368DFE, "harper_drags_pilot_to_van" },
    { 0x02A0A5CD, "harper_elevator_ride" },
    { 0xD3D70451, "harper_end_hand_signals" },
    { 0xEA64AD4B, "harper_ending" },
    { 0x8138C451, "harper_enter_bank" },
    { 0x55DE9589, "harper_enter_jetwing" },
    { 0xC189B99B, "harper_face_burn" },
    { 0x800CDE10, "harper_face_burned" },
    { 0x10674798, "harper_face_scarred" },
    { 0xB2FBDC89, "harper_finds_karma_pip" },
    { 0xCB7844EB, "harper_fire_sniperstorm" },
    { 0x8BD712EE, "harper_fires_from_van" },
    { 0xF3F898E8, "harper_gaz_melee_fail" },
    { 0x3325692B, "harper_get_knocked_down" },
    { 0x9A2B835C, "harper_get_to_room" },
    { 0x0BBAFF24, "harper_give_scarred_face" },
    { 0x07FD3541, "harper_grappel" },
    { 0xC1566782, "harper_grenade_launch" },
    { 0xE9A7028D, "harper_helmet" },
    { 0x8A0F34F3, "harper_in_position" },
    { 0x0CD552F1, "harper_intro_jetwing" },
    { 0x6B0E40BB, "harper_jetwing_start" },
    { 0xAEBB9B57, "harper_jetwing_think" },
    { 0x14E8E714, "harper_kick" },
    { 0xA78C1E62, "harper_kill" },
    { 0xFF587E7A, "harper_kill_gaz_driver" },
    { 0xBCC3F63C, "harper_knocked_down" },
    { 0x17349A64, "harper_lab_intro" },
    { 0x0C1054EC, "harper_lookat_player" },
    { 0xECDCE04F, "harper_monitor_drone" },
    { 0x6011D2B9, "harper_movement" },
    { 0x3B20E92E, "harper_movement_bank" },
    { 0x5D58F3F2, "harper_path1_started" },
    { 0xECC1A591, "harper_path2_started" },
    { 0xA03CD1AA, "harper_path4_hide_exit_done" },
    { 0x61FF1B05, "harper_path4_hide_exit_started" },
    { 0xD5B8624B, "harper_pathing_gaz_melee" },
    { 0x830709D3, "harper_railing_throw" },
    { 0x51F5A380, "harper_reveal_vision" },
    { 0xD89B5697, "harper_rooftop_door_close_started" },
    { 0x5B2BCD98, "harper_rooftop_melee" },
    { 0x5E1C69DB, "harper_run_to_gate" },
    { 0xAE6E8F6F, "harper_say_closing_vo" },
    { 0xB1477D9F, "harper_set_friendly_fire" },
    { 0x6405F8FA, "harper_shield_fx" },
    { 0x4D615856, "harper_shoot_at_drone" },
    { 0xDF06CF2D, "harper_shooting" },
    { 0x14E5B5FE, "harper_shot" },
    { 0xBE89BF48, "harper_shot_callback" },
    { 0xE0124A54, "harper_shot_complete" },
    { 0x26BCA0B5, "harper_slide" },
    { 0x3E091D18, "harper_sniper_nag" },
    { 0x52A0BBA6, "harper_spawner" },
    { 0x63CF5E69, "harper_speed_up" },
    { 0xEF6FE3CB, "harper_switch_claw_nag" },
    { 0xCB0A6682, "harper_takeover_turret" },
    { 0x36634A7A, "harper_think" },
    { 0xF48257FC, "harper_titus_asd" },
    { 0x367E40AF, "harper_to_sandbags" },
    { 0x107AE9C9, "harper_waittill_not_talking" },
    { 0xBD718B5B, "harper_wakes_up" },
    { 0xCA6648ED, "harper_wakeup" },
    { 0x31C9B7D2, "harper_water_wake" },
    { 0xC87038F4, "harper_woke_up" },
    { 0x304227CA, "harpers" },
    { 0xBD7684AC, "harpointtype" },
    { 0xAAE6FAFA, "harpoon" },
    { 0x326AE33D, "harrassing" },
    { 0x4156BE3B, "harrassment" },
    { 0xEFC8238F, "harrington" },
    { 0xC9C66010, "harris" },
    { 0xA0F8272B, "harris_and_brooks_to_cover" },
    { 0x577B61F1, "harris_brooks_breach" },
    { 0x329EA406, "harris_door_open" },
    { 0x23D2F610, "harris_door_pos" },
    { 0x574AA55F, "harris_node" },
    { 0xBC6C9336, "harris_position" },
    { 0xC23BD217, "harris_prone" },
    { 0xC1C18A22, "harris_teleport" },
    { 0x390071F7, "has" },
    { 0x29CB5A47, "has_achievement" },
    { 0xF6C3CD9F, "has_active_gadget" },
    { 0xB7E23998, "has_ally_drop" },
    { 0x15FF5A62, "has_alt_weapon" },
    { 0x6BF8BCD9, "has_altmelee" },
    { 0x01D5127D, "has_anim" },
    { 0x52B66E86, "has_any_ballistic_knife" },
    { 0x2F5E9A73, "has_at_least_one_active_enemy_turret" },
    { 0xEEEB9A69, "has_attachment" },
    { 0x00A961C8, "has_awareness_perk_purchased_and_equipped" },
    { 0x24C4313F, "has_banzai_attacker" },
    { 0xCDA68261, "has_barrel_been_hit" },
    { 0x7E2FE666, "has_bayonet" },
    { 0xB63814D3, "has_been_added" },
    { 0x08D9AA6C, "has_been_damaged_by_player" },
    { 0xB800EAE4, "has_been_opened" },
    { 0x2984B154, "has_been_used" },
    { 0x14527BE0, "has_been_used_once" },
    { 0x18775385, "has_behavior_attribute" },
    { 0x3FF950BA, "has_betties" },
    { 0xD79FA2A8, "has_blind_eye_perk_purchased_and_equipped" },
    { 0x4F2B1707, "has_blocker_affecting_perk" },
    { 0x609F4F0C, "has_bowie" },
    { 0x4142641A, "has_camo" },
    { 0x64D93074, "has_campaign" },
    { 0x49CF062C, "has_card" },
    { 0x5B8BD94B, "has_challenge_occured" },
    { 0x6671D912, "has_char_group" },
    { 0x6422CA5C, "has_cleanse_changed" },
    { 0xD2E32273, "has_cold_blooded_perk_purchased_and_equipped" },
    { 0x32553838, "has_collectible" },
    { 0x8E9C2EFB, "has_color" },
    { 0xD3C55BD0, "has_delta" },
    { 0x64DACA19, "has_deployed_equipment" },
    { 0x05269730, "has_destruct_def" },
    { 0xD24EE073, "has_diary" },
    { 0x7235E1E9, "has_different" },
    { 0x77F3197F, "has_drunk_wunderfizz" },
    { 0x4536665E, "has_enemy" },
    { 0x1AEB76A8, "has_engine_sound" },
    { 0xF7F7F7EC, "has_enough_power" },
    { 0x6D8527B1, "has_equipped" },
    { 0xD0715501, "has_exit_point" },
    { 0xABA6456B, "has_faceplate" },
    { 0x4FD5FE7E, "has_fast_hands_perk_purchased_and_equipped" },
    { 0xE2D97928, "has_flag" },
    { 0x0A193FD4, "has_flak_jacket_perk_purchased_and_equipped" },
    { 0x71EE758F, "has_flame_thrower" },
    { 0xA3F0B600, "has_flamethrower" },
    { 0xB2630B08, "has_frontarmor" },
    { 0x877E3BA6, "has_ghost_perk_purchased_and_equipped" },
    { 0x850E7732, "has_gibbed_piece" },
    { 0x4516A480, "has_gung_ho_perk_purchased_and_equipped" },
    { 0x096CA415, "has_hacker_changed" },
    { 0x95FD231D, "has_hacker_perk_purchased_and_equipped" },
    { 0x14889F7A, "has_hacking_changed" },
    { 0x496B5DD8, "has_hard_wired_perk_purchased_and_equipped" },
    { 0xBA91BB36, "has_helicopter_dust_kickup" },
    { 0x29E7C4C1, "has_helmet" },
    { 0xE0710A11, "has_hero_weapon" },
    { 0x8EBE6388, "has_hind_enemy" },
    { 0x3F7081DE, "has_init_state" },
    { 0xEE43AEF0, "has_intro" },
    { 0x91439B7B, "has_intruder" },
    { 0x0C8655B7, "has_ir" },
    { 0xE21164AC, "has_jetquiet_perk_purchased_and_equipped" },
    { 0x187E852F, "has_key_object" },
    { 0x8E14D250, "has_killstreak" },
    { 0x74962607, "has_killstreak_in_class" },
    { 0xA7EAF627, "has_laser" },
    { 0x5BDB578E, "has_launcher" },
    { 0xABC28C49, "has_left_knee_armor" },
    { 0x6F97A2A8, "has_left_shoulder_armor" },
    { 0xC81CD539, "has_legs" },
    { 0xF6438589, "has_legs_no" },
    { 0xA6007BF4, "has_legs_type" },
    { 0x5466C94D, "has_legs_yes" },
    { 0xA41E2799, "has_lethal_nade" },
    { 0x255289EA, "has_level_veteran_award" },
    { 0xE83CF36E, "has_lmg" },
    { 0xA92050F5, "has_local_power" },
    { 0x829AD2E4, "has_lockon" },
    { 0x64715C1B, "has_meat" },
    { 0xD3232542, "has_menendez_weapons" },
    { 0xD6533813, "has_minigun" },
    { 0x04597FF7, "has_minimap" },
    { 0x05CEE268, "has_mission_hardened_award" },
    { 0x1A81B412, "has_multiple_ais" },
    { 0xDF33E7F1, "has_multiple_props" },
    { 0x7E8A89AE, "has_nearby_enemy" },
    { 0xBF95F2F0, "has_new_target" },
    { 0x0CC8737C, "has_next_scene" },
    { 0xBA0E23DF, "has_ninja_perk_purchased_and_equipped" },
    { 0xC491736B, "has_owner" },
    { 0x88FC178C, "has_pack_a_punch" },
    { 0x4B8E04A1, "has_packapunch_weapon" },
    { 0xEDAEA3BE, "has_perk" },
    { 0x7AB4A703, "has_perk_paused" },
    { 0xB01E45A5, "has_played_afterlife_trigger_hint" },
    { 0xB65C332B, "has_played_pakistan_1" },
    { 0x8FE752AD, "has_player" },
    { 0xC00A0708, "has_player_equipment" },
    { 0xBAC76C25, "has_player_fired_grapple_device" },
    { 0x39A7C90B, "has_player_hero_weapon" },
    { 0x9AC155E1, "has_player_received_reward" },
    { 0x24475DAC, "has_players" },
    { 0x6D2E297F, "has_powercap" },
    { 0xD3FA4074, "has_powerplant" },
    { 0xEAE333F5, "has_powerup_weapon" },
    { 0xC938ACD6, "has_progressed_fwd" },
    { 0xC8E63EC0, "has_purchased_perk_equipped" },
    { 0x7CEE3607, "has_purchased_perk_equipped_with_specific_stat" },
    { 0xA59FC9FA, "has_radar" },
    { 0xAFB6519C, "has_reach_the_end_of_tall_grass" },
    { 0xD5B760B9, "has_revive" },
    { 0x1A8ED636, "has_revive_staff" },
    { 0xFE571972, "has_richtofen" },
    { 0x362235EE, "has_rider" },
    { 0x3B950B2E, "has_right_knee_armor" },
    { 0xD469243B, "has_right_shoulder_armor" },
    { 0xD351A1F2, "has_rocketbarrage" },
    { 0x23A6B9C5, "has_satellite" },
    { 0x979ADF29, "has_save" },
    { 0x46A93A87, "has_scavenger_perk_purchased_and_equipped" },
    { 0x7FBFD588, "has_script_drop_weapon" },
    { 0x325418D3, "has_scripted_notetracks" },
    { 0xC9EB3BB8, "has_shell" },
    { 0xEC8B8338, "has_shield_changed" },
    { 0x1C6BD2AB, "has_soul" },
    { 0x420B3EDF, "has_sound" },
    { 0xE0F169EA, "has_spawned_leaper_this_round" },
    { 0xFBD3A085, "has_spawnflag" },
    { 0x5F310C36, "has_specific_powerup_weapon" },
    { 0x6B2D9831, "has_state" },
    { 0x815A2B06, "has_stored_weapondata" },
    { 0x1F49EB5B, "has_str" },
    { 0x2C925ACE, "has_tablet" },
    { 0x9399CD7C, "has_tactical_mask_purchased_and_equipped" },
    { 0xDDA2EBD6, "has_tactical_nade" },
    { 0x0FD9481D, "has_taken_damage" },
    { 0xD68E99C5, "has_target" },
    { 0xF82B659A, "has_tazer" },
    { 0x3E698825, "has_terrain" },
    { 0xAABAF32F, "has_tesla" },
    { 0x231137E6, "has_threat" },
    { 0xF674CA95, "has_time_bomb_restored_this_round" },
    { 0x06FB876F, "has_toughness_perk_purchased_and_equipped" },
    { 0x07AED76A, "has_tried" },
    { 0x626555D0, "has_trophy" },
    { 0x6C5BE790, "has_turret" },
    { 0x1D4C2872, "has_upgrade" },
    { 0x9F93CAD8, "has_upgraded_ballistic_knife" },
    { 0xEC030825, "has_upgraded_staff" },
    { 0x724F237A, "has_used_perk_random" },
    { 0x4BDCC96E, "has_vinyl" },
    { 0xA38CF3D8, "has_vis" },
    { 0xA6AF8548, "has_visible_target" },
    { 0xFDCC64E7, "has_vo" },
    { 0x4EDF60F2, "has_weapon" },
    { 0x3C39F0A1, "has_weapon_or_attachments" },
    { 0x863F7B87, "has_weapon_or_upgrade" },
    { 0xE01A26B5, "has_weasel" },
    { 0xB27DF650, "hasachievement" },
    { 0xCBAB235A, "hasactivecontractexpired" },
    { 0x5B2C5001, "hasactivecounteruav" },
    { 0xCA8DA989, "hasactiveemp" },
    { 0xFC7C4077, "hasaiattribute" },
    { 0xC0CF1406, "hasaivsaienemy" },
    { 0xFE69C52C, "hasallintel" },
    { 0xB5A6B5E6, "hasalreadyearnedkillstreak" },
    { 0x1DF5A963, "hasambientpackage" },
    { 0xE92FD90C, "hasambientroom" },
    { 0x4F83E905, "hasammo" },
    { 0x20D86EA9, "hasanimstatefromasd" },
    { 0x9F258730, "hasanimtree" },
    { 0xEC5DBFA5, "hasanykillstreak" },
    { 0x05B5BA89, "hasarmorpiercing" },
    { 0x6370D04A, "hasattachedweapons" },
    { 0xE2EC9BD3, "hasbarriers" },
    { 0x5F10037F, "hasbeencaptured" },
    { 0xE918CACF, "hasbeenpaused" },
    { 0xFA236953, "hasbeenplanted" },
    { 0x5ED00C54, "hasbodyarmor" },
    { 0xDB6B42D3, "hascamo" },
    { 0xD1028449, "hascasualty" },
    { 0x5F2BBE73, "hasclaymore" },
    { 0xE88B8199, "hasclip" },
    { 0x1455E4B0, "hascloseaivsaienemy" },
    { 0x0948E553, "hascloseenemy" },
    { 0x58891F54, "hascloseenemytomelee" },
    { 0x0F889598, "hascodemovenotetrack" },
    { 0xB4A4112B, "hascol" },
    { 0x147454A3, "hascollectible" },
    { 0x68593761, "hascombatjumpout" },
    { 0xE7B58D0D, "hascommando" },
    { 0xB22DA42F, "hascompletedallgamechallenges" },
    { 0xCFCD9F89, "hascompletedsuperee" },
    { 0x52C4A459, "hascovermerequest" },
    { 0xF420D724, "hasdependant" },
    { 0x7C367AF3, "hasdlcavailable" },
    { 0xF72343A0, "hasdobj" },
    { 0x9805039C, "hasdodged" },
    { 0x8061EA77, "hasdonecombat" },
    { 0x2A910B83, "hasdoor" },
    { 0xB6B75142, "hasdstats" },
    { 0x78702C57, "hasemp" },
    { 0x90D01729, "hasenemy" },
    { 0x7AD2DA4B, "hasenemychanged" },
    { 0x3B64C67E, "hasenemysightpos" },
    { 0xACADB348, "hasenoughlegstomove" },
    { 0x757F54F2, "hasexitalign" },
    { 0xF57CD859, "haseyes" },
    { 0x0A1ED911, "hasfiredrecently" },
    { 0xF4628B80, "hasfirenotetrack" },
    { 0xB6F6C8A7, "hasflakjacket" },
    { 0x820262AC, "hasflares" },
    { 0x709B65BC, "hasflashbangs" },
    { 0x8367682E, "hasfmj" },
    { 0x21742996, "hasgibpieces" },
    { 0x33910E9A, "hasgoal" },
    { 0x4F487865, "hasgren" },
    { 0xC38D7BED, "hash" },
    { 0x2C8EE667, "hash_id" },
    { 0x95D88248, "hashcontractstats" },
    { 0xA4DA98A1, "hashead" },
    { 0x49C32515, "hashelicopterdustkickup" },
    { 0x05A0B2F6, "hashelicopterturret" },
    { 0xB386359E, "hashstring" },
    { 0xCE087354, "hashtoorigin" },
    { 0xE031130F, "hasindexactivecounteruav" },
    { 0x0D033858, "hasit" },
    { 0x58604289, "haskeyobject" },
    { 0x45D532D3, "haskill" },
    { 0x0D558D20, "haskillstreakbeenused" },
    { 0x9DF34F7E, "haskillstreakequipped" },
    { 0x07DD9F84, "haskillstreakinclass" },
    { 0xE25A3CE6, "hasknife" },
    { 0xD055769F, "hasknifelikeweapon" },
    { 0x3BB7F8CA, "haslastenemysightpos" },
    { 0x93A8FFC7, "haslevelveteranaward" },
    { 0x8963677A, "haslightarmor" },
    { 0x23529B81, "haslowammo" },
    { 0xCFCB9C35, "hasmachetelikeweapon" },
    { 0xE3858CB2, "hasmaxprimaryweapons" },
    { 0x48F8E5A4, "hasmessage" },
    { 0xA097A0EA, "hasminiraps" },
    { 0x454A99C5, "hasmissionhardenedaward" },
    { 0xD09690EC, "hasmortar" },
    { 0xC95A3982, "hasnotdonecombat" },
    { 0xBE7FA575, "hasnt" },
    { 0xF58182E5, "hasone" },
    { 0xAD3742B4, "haspart" },
    { 0xDF2053CA, "haspath" },
    { 0xDF6954D8, "haspausedtimer" },
    { 0x88542FCF, "hasperk" },
    { 0x94B8A8E5, "hasperkalready" },
    { 0xC9FAAF0A, "hasperkspecialtychugabud" },
    { 0xA336D73E, "hasperkspecialtytombstone" },
    { 0xAC8007C0, "hasperkspecialtyvulture" },
    { 0x54E9A737, "haspickup" },
    { 0x5CA71F8E, "haspistoljumpout" },
    { 0x22C33E2B, "hasplayerweaponprev" },
    { 0x6991EA91, "haspoppedpustule" },
    { 0xCBA3F0DD, "haspotentalaivsaimeleeenemy" },
    { 0x00ACDFD9, "haspowerup" },
    { 0x9E3D8AA9, "hasradar" },
    { 0xC08D6CDB, "hasreconmodel" },
    { 0x34EBA11F, "hasreloaded" },
    { 0xB52C7C1C, "hasriders" },
    { 0x8E7B3A52, "hasriotshield" },
    { 0xFD3F68E1, "hasriotshieldequipped" },
    { 0x1C06337B, "hasrocketlauncher" },
    { 0x3A172AF6, "hasroom" },
    { 0xF04B55B6, "hassatellite" },
    { 0xC47AC029, "hasscope" },
    { 0x9E90DDE7, "hasscriptgoal" },
    { 0x031CC1BB, "hasseasonpass" },
    { 0x1EC2B24F, "hassecondaryweapon" },
    { 0xB4A11F36, "hasseenfavoriteenemy" },
    { 0x81035024, "hasselected" },
    { 0xB0C19313, "hasspawned" },
    { 0xDCBA9CEF, "hasspyplane" },
    { 0x24F82396, "hassquadmakeupchanged" },
    { 0xF93082BC, "hasstartaim" },
    { 0xC44F3562, "hasstarted" },
    { 0x9902003A, "hasstopaim" },
    { 0x4811617B, "hasstowed" },
    { 0x97FDBFA5, "hassuicidegrenade" },
    { 0xFAB8A33A, "hassuppressableenemy" },
    { 0xD72E3FFB, "hastacticalinsertion" },
    { 0xBB61B344, "hastacticalmask" },
    { 0x01C5BB9C, "hastacticalmaskoverlay" },
    { 0x30E642E9, "hastagflash" },
    { 0xF56360BF, "hastargetent" },
    { 0xB5F3B6A1, "hastomahawk" },
    { 0xD5943B21, "hasturnedberserk" },
    { 0x90910DAD, "hasturret" },
    { 0xD018D425, "hasuav" },
    { 0x28125F84, "hasusedweapon" },
    { 0xE0F94C3C, "hasvalidinterrupt" },
    { 0xDC79BADC, "haswalkers" },
    { 0xCAAC13DB, "haswallweapon" },
    { 0x2103FF4B, "hasweapon" },
    { 0xA281FFC4, "hasweaponmalfunctioned" },
    { 0x2EEF1918, "hat" },
    { 0x1105F740, "hat_anim" },
    { 0x9EEEBFB6, "hat_floats" },
    { 0x85D2029C, "hat_gibbed" },
    { 0x2823A2AE, "hat_off" },
    { 0x3693FCC1, "hatch" },
    { 0x79F4DC35, "hatch_anim_setup" },
    { 0x7355DAA2, "hatch_anims" },
    { 0xDA90361D, "hatch_available" },
    { 0x6D23CA9E, "hatch_clip" },
    { 0x20E02D04, "hatch_dist" },
    { 0x3B32829F, "hatch_do_closed_loop" },
    { 0x92E85233, "hatch_do_open_loop" },
    { 0xBA79BBEA, "hatch_drop_allowed" },
    { 0x2E029220, "hatch_fail" },
    { 0x476C9A10, "hatch_foot" },
    { 0xDC3ACB17, "hatch_guy_throw_grenade" },
    { 0x9736A828, "hatch_jump" },
    { 0xCA519451, "hatch_location" },
    { 0x4D84C115, "hatch_mantle" },
    { 0x3E823338, "hatch_mantle_allowed" },
    { 0x335AFC46, "hatch_move_heroes" },
    { 0x4539A4C2, "hatch_notify_heroes" },
    { 0xFC6CEA24, "hatch_open" },
    { 0xCC632604, "hatch_opening" },
    { 0x28C5AF75, "hatch_opens_above" },
    { 0x90D9CE64, "hatch_player_clip" },
    { 0x1EEB73BB, "hatch_ripped_open" },
    { 0x86B6A6EC, "hatch_tag" },
    { 0x9A464472, "hatch_trig" },
    { 0x7304B9A2, "hatch_vec" },
    { 0x3BA2CA3C, "hatchback" },
    { 0xA36E7D6D, "hatchback1" },
    { 0xC970F7D6, "hatchback2" },
    { 0x234A1C11, "hatches" },
    { 0xE156801E, "hatchet" },
    { 0xDFD97540, "hatchet_achieve_given" },
    { 0x2F592054, "hatchet_achievement_spawnfunc" },
    { 0xF0F5A00B, "hatchet_chop_guard" },
    { 0x592B7BD4, "hatchet_guard" },
    { 0x02B0E84C, "hatchet_guard_alerted" },
    { 0x1F84E4F9, "hatchet_guard_spawner" },
    { 0xE59FCE9B, "hatchet_hit_dialog_killer" },
    { 0xECE3FFE2, "hatchet_hit_guard" },
    { 0x9FFCEA0D, "hatchet_kill" },
    { 0xF8EF5363, "hatchet_kill_arm_blood" },
    { 0x26CFCF5A, "hatchet_kill_chest_blood" },
    { 0xDE807E18, "hatchet_kill_event" },
    { 0x0B62532C, "hatchet_kill_fail" },
    { 0xE25DA4E4, "hatchet_kill_guard_anims" },
    { 0x4CB53C04, "hatchet_kill_resolve" },
    { 0x30611CB4, "hatchet_kill_start" },
    { 0x232C6CC7, "hatchet_kill_start_listener" },
    { 0x7A386EA8, "hatchet_kill_stealth_listener" },
    { 0xA719DA59, "hatchet_kill_success" },
    { 0x8B3BBB31, "hatchet_kill_switch_reset_death_anim" },
    { 0x49C8CC14, "hatchet_pickup_trigger" },
    { 0xC48BBD9D, "hatchet_rebirth_sp" },
    { 0x2D8313EB, "hatchet_resolve" },
    { 0x0B9C10D9, "hatchet_spin" },
    { 0x25E89F03, "hatchet_throw" },
    { 0xAB0904B8, "hatchet_throw_close_guard" },
    { 0xB5BEEC78, "hatchet_throw_dialogue" },
    { 0x0F5AEC7E, "hatchet_throw_fail" },
    { 0xB8884857, "hatchet_throw_far_guard" },
    { 0xEF542DAC, "hatchet_throw_far_guard_prep_anims" },
    { 0xEF364439, "hatchet_throw_guard" },
    { 0x46217FF5, "hatchet_throw_hud" },
    { 0xFC315818, "hatchet_throw_physics_objects" },
    { 0xAF6E61F9, "hatchet_throw_player" },
    { 0xD2B6CCBA, "hatchet_throw_reznov" },
    { 0x5CBBB2C0, "hatchet_throw_scale" },
    { 0xF7B820C8, "hatchet_throw_vignette" },
    { 0x0CC4F4E6, "hatchet_throw_watch_no_throw" },
    { 0x0405B657, "hatchet_thrown" },
    { 0x9AFF2F97, "hatchet_worker" },
    { 0xB36AF275, "hatchetkills" },
    { 0x11E72E42, "hatchetpickuptrigger" },
    { 0xF95ECC35, "hate" },
    { 0x59FCC36D, "hater" },
    { 0x30643900, "hating" },
    { 0xAE4A924E, "hatlamp" },
    { 0xE7897CF1, "hatlamps" },
    { 0x16AFE8CF, "hatmodel" },
    { 0x0D817DF3, "hats" },
    { 0xA8695008, "hattrickchallenge" },
    { 0x1C9ADF91, "hattrickchallengehattrickcount" },
    { 0x1D4F109B, "hattrickchallengeheadshotcount" },
    { 0xE22F31CF, "haul" },
    { 0x26CA8B89, "hault" },
    { 0x7956B2B4, "hault_enemy_before_log_scene" },
    { 0xEC79F53F, "haulting" },
    { 0x81D0D401, "haunted_sniping" },
    { 0xC679C543, "have" },
    { 0xB0A9288C, "have_flashlight" },
    { 0x5B4F55FE, "have_intel" },
    { 0x9ECF991C, "have_moving_clip_for_door" },
    { 0x43F5C2B3, "have_sound" },
    { 0x7227B382, "have_zombie_weapon_gib_callback" },
    { 0x192D7E1D, "have_zombie_weapon_gib_head_callback" },
    { 0x5D0FB9BE, "haveallplacedsidebets" },
    { 0x8ED96612, "havegonetocover" },
    { 0x34FFA662, "havenothingtoshoot" },
    { 0x7ACAB641, "havent" },
    { 0xA4A7899B, "haventramboedwithintime" },
    { 0xD25CA6C1, "haveoneshot" },
    { 0xD55B9558, "havetoolowtoattackenemy" },
    { 0xC6B655C6, "having" },
    { 0x50A67C15, "havoc_hits_ground" },
    { 0x96E52F74, "hax" },
    { 0x3CE1EB23, "haxxor" },
    { 0x1BBD1394, "haxxx" },
    { 0x68E81ED3, "haxxxorrr" },
    { 0x9CA800F5, "haxxxorrrrd" },
    { 0xA5F9702D, "haxxzor" },
    { 0x5A51D331, "haycart_anim" },
    { 0xFE29C28F, "haycart_enter_village_anim" },
    { 0x419E977D, "hazard" },
    { 0xC9E9947C, "hazardous" },
    { 0x7817FE3C, "hazards" },
    { 0x1BE21036, "hazardtarget" },
    { 0xDE3B65C0, "hazmat" },
    { 0xDDFB49F5, "hazmat_allies" },
    { 0xF47DC940, "hazmat_cracked" },
    { 0xA8926F45, "hazmat_died" },
    { 0xFCD4B22E, "hazmat_distance_checker" },
    { 0x144018E3, "hazmat_guys" },
    { 0x198AC231, "hazmat_guys_spawnfunc" },
    { 0x75B2E065, "hazmat_health" },
    { 0x5DB10CFF, "hazmat_health_create_hudelem" },
    { 0x8CB3AAC2, "hazmat_health_display" },
    { 0x7253C9CE, "hazmat_health_init" },
    { 0xE63C63B2, "hazmat_health_max" },
    { 0x5CE2A1B4, "hazmat_health_save_restore" },
    { 0x0273B01F, "hazmat_health_suit_destroyed" },
    { 0xE103E467, "hazmat_health_take_damage" },
    { 0x84ED3A37, "hazmat_health_turn_off" },
    { 0x8E41E7A3, "hazmat_hudelem" },
    { 0x22EEF024, "hazmat_init_on_players" },
    { 0x0B765DB6, "hazmat_off" },
    { 0x348AACA8, "hazmat_on" },
    { 0x5DCD925A, "hazmat_set_death_dvar" },
    { 0xD02727E4, "hazmat_suit_destroyed" },
    { 0xFE778D71, "hazmat_trigger" },
    { 0x5B070D81, "hazmat_trigger2" },
    { 0x52066617, "hazmat_watch_sprint" },
    { 0x9780BA27, "hazmat_window_mantle" },
    { 0x09084DB7, "hazzard" },
    { 0x94EEEF0C, "hb_bowman_hit" },
    { 0xC4DECE47, "hb_bowman_spit" },
    { 0x751D4DCD, "hb_gun_at_head" },
    { 0x50134116, "hc" },
    { 0x3DFDAE19, "hcc" },
    { 0x1AE77D06, "hde" },
    { 0x6C0462A0, "he" },
    { 0x8E0191BC, "he_align_bottom" },
    { 0xA7BFE60A, "he_align_center" },
    { 0x8A1E32E6, "he_align_left" },
    { 0xD0185992, "he_align_middle" },
    { 0x139B537D, "he_align_right" },
    { 0x67EE0916, "he_align_top" },
    { 0x9826F137, "he_font_bigfixed" },
    { 0x53A40A5A, "he_font_default" },
    { 0x628D7908, "he_font_objective" },
    { 0x482990C2, "he_font_smallfixed" },
    { 0x6B67FBCF, "head" },
    { 0xF2D468C9, "head_armor_mp" },
    { 0x411AA705, "head_array" },
    { 0x11A41D82, "head_camo_mp" },
    { 0x337C5D83, "head_chopper" },
    { 0x476E9BF9, "head_down_escape_corridor" },
    { 0x93F2CFBF, "head_enter_blocker" },
    { 0xF4D505E0, "head_enter_left" },
    { 0xD6045CCF, "head_enter_right" },
    { 0x011F2AF9, "head_exit_blocker" },
    { 0xF8D649E6, "head_exit_left" },
    { 0x5F67887D, "head_exit_right" },
    { 0xB8416EE4, "head_flak_mp" },
    { 0x586521AF, "head_gib_chance" },
    { 0x62277A3F, "head_gib_damage_over_time" },
    { 0x83D1C411, "head_gibbed" },
    { 0x76D2F278, "head_gibs_this_frame" },
    { 0x41461BAF, "head_height" },
    { 0xB39BFEEE, "head_icon_allies" },
    { 0x2914B2E7, "head_icon_axis" },
    { 0x0A29010F, "head_icon_show_both" },
    { 0x0A6D4266, "head_icon_show_enemy" },
    { 0xF3F8E6D7, "head_icon_show_mine" },
    { 0x13D13686, "head_index" },
    { 0x5E150E0B, "head_left_model" },
    { 0x97B2DDD4, "head_mesh_lods" },
    { 0x170DFEDA, "head_mid_model" },
    { 0x4E00D411, "head_model" },
    { 0x98ED8CD8, "head_origin" },
    { 0xD6FDE22C, "head_pos" },
    { 0xE877BB9B, "head_position" },
    { 0x19072699, "head_render_options" },
    { 0xB406E5F2, "head_right_model" },
    { 0x4E7801EB, "head_sci_checkpoint_trig" },
    { 0x1B9EC839, "head_sci_kill_trig" },
    { 0xFEC448F0, "head_scientist" },
    { 0x22A2A659, "head_scientist_trig" },
    { 0x875DD897, "head_shot_bathroom_guy" },
    { 0xDA789CA8, "head_should_gib" },
    { 0xE7D283AF, "head_showing" },
    { 0x047B248C, "head_sight_check_rating" },
    { 0x2351E86F, "head_standard_mp" },
    { 0x8486A1EA, "head_texture_lods" },
    { 0x3D010A9C, "head_to_the_pipe" },
    { 0x07775306, "head_utility_mp" },
    { 0xB5497362, "headalive" },
    { 0x0A0C7C5F, "headattached" },
    { 0x30A7326F, "headbang_time" },
    { 0x74C9E308, "headbutt" },
    { 0xD1086830, "headbutt_anim" },
    { 0x79864063, "headchop_height" },
    { 0x1C58A768, "headchopper" },
    { 0xEEDB5759, "headchopper_add_chop_ent" },
    { 0xD15C8FF0, "headchopper_animate" },
    { 0xB6E40FBB, "headchopper_audio" },
    { 0xB7562A8F, "headchopper_bad_areas" },
    { 0x88278163, "headchopper_blade" },
    { 0xE31ED7A9, "headchopper_cleanup" },
    { 0x979C92EC, "headchopper_crank" },
    { 0xBD1BA120, "headchopper_damage" },
    { 0xC56D9D96, "headchopper_expired" },
    { 0xA039FFA9, "headchopper_fx" },
    { 0xA8B6D044, "headchopper_hinge" },
    { 0x493F8A98, "headchopper_in_range" },
    { 0x0D85483B, "headchopper_kill_vo" },
    { 0x07D40CDA, "headchopper_kills" },
    { 0x2F8384BB, "headchopper_last_damage_time" },
    { 0x892F47AE, "headchopper_mount" },
    { 0x18F53072, "headchopper_name" },
    { 0xABA2FF08, "headchopper_power_off" },
    { 0xFE3A8DA2, "headchopper_power_on" },
    { 0x3EA922F8, "headchopper_slice_times" },
    { 0xEE2322F2, "headchopper_sound_ent" },
    { 0x15489B47, "headchopper_zombie_damage_response" },
    { 0x0B534045, "headchopper_zombie_death_remove_chopper" },
    { 0xE390AEFC, "headchopper_zombie_death_response" },
    { 0xA154ECAC, "headchopperattack" },
    { 0x821A708E, "headchopperaudiocleanup" },
    { 0x381E1C40, "headchopperbuildable" },
    { 0xD8816A03, "headchoppers" },
    { 0x5ADE4030, "headchopperthink" },
    { 0xBCE84D64, "headchopperthinkcleanup" },
    { 0x817400D4, "headclosest" },
    { 0xB811D874, "headdestroyed" },
    { 0x0EE4D514, "headed" },
    { 0x62B839B2, "header" },
    { 0xEED1BA45, "headerfont" },
    { 0x93D8B23D, "headers" },
    { 0x0C23A7CF, "headertext" },
    { 0xB77C9D35, "headhealthmax" },
    { 0x997920F7, "headhorizontalweight" },
    { 0x6D8F43C0, "headicon" },
    { 0x914F3A66, "headicon_offset" },
    { 0x12FC99DA, "headiconobjectiveid" },
    { 0xA36F83FB, "headiconteam" },
    { 0xA8A59F61, "headindex" },
    { 0xA58F78CF, "headinfo" },
    { 0x9A1B0631, "heading" },
    { 0xA338A0E7, "heading_shader" },
    { 0x2CC27261, "heading_text" },
    { 0x2673F2BE, "headingsize" },
    { 0x1423A95B, "headlamp_broken" },
    { 0x178D0187, "headlamp_dist_sq" },
    { 0x70A8F1BF, "headlamp_on" },
    { 0xD6CED018, "headless" },
    { 0xA2E7D6A9, "headless_mannequin_count" },
    { 0x9CB44A2D, "headlight" },
    { 0x965756BE, "headlight1" },
    { 0x7054DC55, "headlight2" },
    { 0xBF4B6A5A, "headlight_fx" },
    { 0xAE4EFA20, "headlight_left_org" },
    { 0x347DA781, "headlight_right_org" },
    { 0xC795152E, "headlighteffect" },
    { 0x87C6819B, "headlightfx" },
    { 0xD502550B, "headlightl" },
    { 0xFA91B7EA, "headlightleftfxhandle" },
    { 0x14E6A481, "headlightleftfxname" },
    { 0xF0F37695, "headlightr" },
    { 0x6B749AC1, "headlightrightfxhandle" },
    { 0x918D4D1A, "headlightrightfxname" },
    { 0xCAF0FC2C, "headlights" },
    { 0x8EE2C772, "headlights_off" },
    { 0xD5AD6C44, "headlights_on" },
    { 0x43C0378D, "headlightslensflare_l" },
    { 0x87F6BC93, "headlightslensflare_r" },
    { 0x27720912, "headlook" },
    { 0xE5FDDA7E, "headmodel" },
    { 0xB89F3419, "headmodelfull" },
    { 0x953A1A71, "headmodelpartial" },
    { 0x4E09343B, "headopen" },
    { 0x314F996C, "headphones" },
    { 0x1FF8C812, "headphones_rotate" },
    { 0xEBDA9E17, "headrenderoptions" },
    { 0x0CD2D21E, "headroom" },
    { 0xE93CED96, "heads" },
    { 0x78CA5CC9, "headset" },
    { 0x1BFE6ADF, "headshot" },
    { 0xB5516F2F, "headshot_blood_fx" },
    { 0x3C3E8A17, "headshot_count" },
    { 0xDB6DD47B, "headshot_guy" },
    { 0x25DDA6E9, "headshot_kills" },
    { 0x75861E92, "headshot_kills_total" },
    { 0x94D3DAB6, "headshot_mod" },
    { 0x553F2AA9, "headshot_slowmo_delay" },
    { 0x377E9E23, "headshot_slowmo_timescale" },
    { 0x566803AD, "headshot_slowmo_timescale_interval" },
    { 0xB7336905, "headshot_tags" },
    { 0xB79A4566, "headshots" },
    { 0x3879F817, "headshots_index" },
    { 0x6A486E0B, "headshots_only" },
    { 0xB0A54FE0, "headshotslowmo" },
    { 0x6E94B786, "headshotted" },
    { 0x4A127EFB, "headshotweight" },
    { 0x3A8B42D7, "headspot" },
    { 0x9DD5931D, "headstart" },
    { 0xEDC01299, "headtag" },
    { 0x7276CDAF, "headtracking_mason" },
    { 0x21D59EEA, "headtracking_off" },
    { 0x953903BC, "headtracking_on" },
    { 0x8B5EED31, "headtracking_start" },
    { 0xFFB4945B, "headtracking_stop" },
    { 0xDBEF9945, "headverticalweight" },
    { 0x34CB2B83, "healmet" },
    { 0x3A90F16B, "health" },
    { 0x4D2B26FB, "health_add" },
    { 0xC37A4653, "health_ambient_room_change" },
    { 0x9100B422, "health_at_max" },
    { 0xDBDBC34E, "health_before_fire" },
    { 0xF57D78BF, "health_bonus" },
    { 0xCD9F6F84, "health_buffer" },
    { 0x36E66CE0, "health_bulletdamageble" },
    { 0x946B09EF, "health_color" },
    { 0xEE2F6CF6, "health_data" },
    { 0x500AC280, "health_drain" },
    { 0x56FDB585, "health_drain_state_change" },
    { 0xCC933F55, "health_drop" },
    { 0x2F8C3A37, "health_evasive" },
    { 0x1DB06ADF, "health_factor" },
    { 0x307DE877, "health_fade_off_watcher" },
    { 0xA619A552, "health_frac" },
    { 0x9452BA81, "health_full" },
    { 0x243B8594, "health_fx" },
    { 0xF18D58F4, "health_indicator_create" },
    { 0x4A17A11C, "health_indicator_damagewait" },
    { 0x2DE2B931, "health_indicator_getcolor" },
    { 0x89C172D1, "health_indicator_redscreenflash" },
    { 0x06BE1417, "health_leak" },
    { 0x918887D0, "health_lost" },
    { 0x70734C08, "health_low" },
    { 0xF5224FEC, "health_max" },
    { 0x95048B2F, "health_multiplier" },
    { 0xDAB39A69, "health_opacity" },
    { 0xCAA441EB, "health_original" },
    { 0x526F7753, "health_pct" },
    { 0x313CD569, "health_percent" },
    { 0xC17FBD96, "health_percentage" },
    { 0x55ED49D3, "health_ratio" },
    { 0x1B3B78B1, "health_regen" },
    { 0x34C8BA3B, "health_regen_damage_multiplier" },
    { 0x386CC76F, "health_regen_hp_scale" },
    { 0x3905C053, "health_regen_per_frame" },
    { 0xF8A02DDE, "health_regen_restart_scale" },
    { 0x09D203C0, "health_regen_station" },
    { 0xAB0F4A73, "health_regeninc" },
    { 0xC7192630, "health_regentimer" },
    { 0xAD71FA73, "health_removehudelems" },
    { 0x4BED2908, "health_scale" },
    { 0x522F0628, "health_slice" },
    { 0xE029AE4A, "health_snapshot" },
    { 0x97918365, "health_state" },
    { 0x259F90FA, "health_think" },
    { 0x496283F7, "health_threshold" },
    { 0xCC35E0A9, "health_threshold_off" },
    { 0x3C35B0A1, "health_update" },
    { 0xF98F78C5, "health_warnings" },
    { 0xA78259A2, "health_warningsound_start" },
    { 0x2D0BE11A, "health_warningsound_stop" },
    { 0xF790C083, "healthadded" },
    { 0x35164452, "healthbar" },
    { 0x7E842153, "healthbarhudelems" },
    { 0xFBE7C2FE, "healthbarkeys" },
    { 0x1B2628CD, "healthbuffer" },
    { 0x90AE96E5, "healthcap" },
    { 0x38A62B0E, "healthdefault" },
    { 0x776A5622, "healthdiff" },
    { 0x01AD11DF, "healthdrain" },
    { 0x9826F816, "healthdrain_amount" },
    { 0x5C92A291, "healthdrain_interval" },
    { 0x6BD785C0, "healthdrain_modelname" },
    { 0x68444957, "healthdrain_tagname" },
    { 0x5CAD004C, "healthfadeoffwatcher" },
    { 0x67603F2F, "healthfrac" },
    { 0xF839D525, "healthfraction" },
    { 0x10CEAF15, "healthlost" },
    { 0x66FA0467, "healthmax" },
    { 0x0C5425D9, "healthmin" },
    { 0xC3616F87, "healthmonitor" },
    { 0x18001E6D, "healthoverlay" },
    { 0x2D8009B8, "healthoverlay_remove" },
    { 0x552557BE, "healthoverlaycutoff" },
    { 0xB47EDAC0, "healthratio" },
    { 0xA168494A, "healthregendisabled" },
    { 0x63CAB177, "healthregenerated" },
    { 0x6AEA2F00, "healthregenerationstreak" },
    { 0xB3FD519B, "healthscalar" },
    { 0xE6EE1730, "healthy" },
    { 0xE3E0EF39, "healthy_enemies" },
    { 0xB8649DA3, "healthy_players" },
    { 0x54867386, "healthyplayers" },
    { 0xF18F322E, "healthyspores" },
    { 0x273176C9, "hear" },
    { 0x58508DC5, "hearbeat" },
    { 0x8FBEBFDA, "hearbeatwait" },
    { 0xD437352F, "heard" },
    { 0x4B7E940E, "heard_corpse" },
    { 0xD1E54E8D, "heard_dr_monkey_killee" },
    { 0xC00585E2, "heard_dr_monkey_killer" },
    { 0x2D406B41, "heard_scream" },
    { 0x64DA9A7F, "hearing" },
    { 0x62D707EF, "hearing_distance" },
    { 0x69FE35C0, "hears" },
    { 0x740F8E9F, "heart" },
    { 0xF631A658, "heart_beat_controller_walkby" },
    { 0x4401A1D8, "heart_wait_counter" },
    { 0x72FE072E, "heart_waittime" },
    { 0xA101CE9F, "heartbeat" },
    { 0xC902A53D, "heartbeat_controller_intro" },
    { 0x54FEB68A, "heartbeat_high" },
    { 0xE3F8049C, "heartbeat_init" },
    { 0x78B02C51, "heartbeat_interval" },
    { 0x844EED7C, "heartbeat_low" },
    { 0x53D5B13F, "heartbeat_medium" },
    { 0xA59B4EB3, "heartbeat_reset" },
    { 0xBCE92C0C, "heartbeat_state_transitions" },
    { 0x565590D3, "heartbeat_str" },
    { 0x95AD3E60, "heartbeatsnd" },
    { 0x19585826, "hearts" },
    { 0x0B40553F, "heat" },
    { 0x7393F2D7, "heat_1" },
    { 0x018C839C, "heat_2" },
    { 0xC46D4C98, "heat_area_cleared" },
    { 0xF2352376, "heat_enemies_back_off" },
    { 0x7CD6B2D0, "heat_helis_transport_guys_in" },
    { 0x7C17C167, "heat_pipe01" },
    { 0xD71FD6D2, "heat_pipe01_start" },
    { 0x0A10522C, "heat_pipe02" },
    { 0x3FBE372C, "heat_progression_summons_kill_heli" },
    { 0xF0AE72BB, "heat_reload_anim" },
    { 0xF51253EC, "heat_spawners_attack" },
    { 0x0BADB275, "heat_wave" },
    { 0xFD354153, "heat_wave_burn_entities" },
    { 0x472EFB77, "heat_wave_burn_sound" },
    { 0xD43BE497, "heat_wave_damage_entities" },
    { 0x73AA2B7A, "heat_wave_damage_projectiles" },
    { 0x8C8249F2, "heat_wave_fx" },
    { 0x3C6F8127, "heat_wave_fx_cleanup" },
    { 0xCE104E3F, "heat_wave_setup" },
    { 0xCD3AA110, "heat_wave_think" },
    { 0x3A204421, "heat_wave_think_finished" },
    { 0xF59972FB, "heat_wave_trace_entity" },
    { 0xE5A95295, "heath" },
    { 0xAE0FF3C1, "heating" },
    { 0xB1F078BB, "heatlh" },
    { 0xD56D5645, "heatrate" },
    { 0xBC6CFF9E, "heatseeker" },
    { 0x752AD91D, "heatseeking" },
    { 0x181A2AA3, "heatseekingmissile" },
    { 0x44E9BAA9, "heatsinks" },
    { 0xCD97DAD4, "heatval" },
    { 0x2125FEDC, "heatwave" },
    { 0x02A4FB67, "heatwave_activate_postfx" },
    { 0x95A4BC29, "heatwave_activate_visionset" },
    { 0x481B9D60, "heatwave_activate_visionset_alias" },
    { 0x0618AEC4, "heatwave_activate_visionset_priority" },
    { 0x60B58764, "heatwave_activate_visionset_ramp_hold" },
    { 0x75453E66, "heatwave_activate_visionset_ramp_in" },
    { 0x10F4A641, "heatwave_activate_visionset_ramp_out" },
    { 0xE385D40D, "heatwave_activate_visionset_steps" },
    { 0x5CB528AD, "heatwave_charred_visionset" },
    { 0xFD0B3F04, "heatwave_charred_visionset_alias" },
    { 0x48407768, "heatwave_charred_visionset_priority" },
    { 0x962BDB78, "heatwave_charred_visionset_ramp_hold" },
    { 0x79CD648A, "heatwave_charred_visionset_ramp_in" },
    { 0x6C64AD7D, "heatwave_charred_visionset_ramp_out" },
    { 0x450472F9, "heatwave_charred_visionset_steps" },
    { 0x8BEE8F30, "heatwave_damage_ratio" },
    { 0x3178C2B3, "heatwave_duration" },
    { 0x55EDFEE7, "heatwave_effect_duration" },
    { 0x1E782069, "heatwave_explosion_1p_fx" },
    { 0x4A2B2D23, "heatwave_explosion_distortion_volume_air_fx" },
    { 0x5EBE49B8, "heatwave_explosion_distortion_volume_fx" },
    { 0x3D31BD7D, "heatwave_explosion_fx" },
    { 0x8C177F19, "heatwave_fx_height" },
    { 0x15CCD3F3, "heatwave_glass_damage" },
    { 0xAE864953, "heatwave_grace_period" },
    { 0xD9FC77C7, "heatwave_projectile_trace_z" },
    { 0x5EF598E4, "heatwave_speed" },
    { 0x19598C01, "heatwave_trace_z_offset" },
    { 0x71C81404, "heatwave_victim_tagfxset" },
    { 0xC9A5771E, "heatwavefx" },
    { 0x84132900, "heaven" },
    { 0x1FE55045, "heavenly" },
    { 0xB3CED10F, "heavier" },
    { 0x8DCC56A6, "heavies" },
    { 0x16076A6B, "heavily" },
    { 0x804CEFF6, "heavy" },
    { 0x83465DF4, "heavy_consecutive_attack_interval" },
    { 0x118D1322, "heavy_damage" },
    { 0x2463811A, "heavy_damage_ratio" },
    { 0xCB8F96D2, "heavy_damage_threshold" },
    { 0xB327E32A, "heavy_machine_gunner" },
    { 0xFB2B11C3, "heavy_resistance_encountered" },
    { 0xB1B14968, "heavy_smoke" },
    { 0x189A97BC, "heavy_snow" },
    { 0x05C0366B, "heavy_training" },
    { 0x6F671990, "heavy_training_ai" },
    { 0x0B5497AB, "heavy_training_chopper_squads" },
    { 0xE74DC268, "heavy_training_chopper_status" },
    { 0x4D9A87AE, "heavy_training_choppers" },
    { 0x6E54D49A, "heavy_training_monitor_ai_death" },
    { 0xCD73A9EA, "heavy_training_monitor_chopper_unload" },
    { 0x8C88DF4F, "heavy_training_squads" },
    { 0xCCC8EE7D, "heavycollisionrumble" },
    { 0xE726D30F, "heavycollisionspeed" },
    { 0x9264E9FC, "heavysquad" },
    { 0x35B1C133, "heed" },
    { 0x8971A489, "heeeyaaaah" },
    { 0x88785CCA, "heels" },
    { 0x9A0D2DC8, "heh" },
    { 0x49B95D45, "hehe" },
    { 0x29FABC09, "heigher" },
    { 0xE363B850, "height" },
    { 0x948AB13C, "height_boost" },
    { 0xE695CCBD, "height_check" },
    { 0x22CCF4A0, "height_check_dist" },
    { 0xBD35801B, "height_delta" },
    { 0xD946C9D0, "height_dif" },
    { 0x7D90A986, "height_diff" },
    { 0xE2725110, "height_fps" },
    { 0xCC2D9493, "height_mesh_threshold_high" },
    { 0xF6E2E0F7, "height_mesh_threshold_low" },
    { 0x96DB1E36, "height_offset" },
    { 0xC88CBFF8, "height_rts" },
    { 0x758D534B, "height_scale" },
    { 0x1896B39F, "height_squared_check" },
    { 0x40A8F800, "height_tolerance" },
    { 0x7485E6BE, "heightaboveground" },
    { 0x73C69CD8, "heightchange" },
    { 0x54A07375, "heightdiff" },
    { 0x8FAB9799, "heightdifference" },
    { 0xEB2632C9, "heighten" },
    { 0x677C1C05, "heightgate" },
    { 0xD77EB728, "heightincrease" },
    { 0x68B76B29, "heightoffset" },
    { 0x16ED073B, "heights" },
    { 0x7F8C7186, "heightscore" },
    { 0x0F44F4D9, "heightthreshold" },
    { 0x9C940615, "heighttoenemy" },
    { 0x6E827099, "hel_alrm_off" },
    { 0xCF0B392D, "hel_alrm_on" },
    { 0x6757B851, "helav" },
    { 0x6D620E00, "held" },
    { 0x075EC008, "held_guy" },
    { 0xEAA14662, "held_guy_blood_fx" },
    { 0x9EF503AA, "held_weapons" },
    { 0xE22A57BC, "heldballisticknife" },
    { 0xA84D573B, "heldtime" },
    { 0x20A505FC, "heldweapon" },
    { 0xB2961BBF, "heldweapons" },
    { 0xC6D8A186, "helecopter" },
    { 0x5B824555, "heli" },
    { 0xD638FAE5, "heli01_chunks" },
    { 0xC01F3ABC, "heli01_chunks_start" },
    { 0x0437F4B5, "heli01_rotor" },
    { 0x203D35EC, "heli01_rotor_start" },
    { 0x97F56024, "heli2forward" },
    { 0xB07E1602, "heli2forward_normal" },
    { 0x93CAF7F0, "heli2target_normal" },
    { 0x7A98489E, "heli_02_flyover" },
    { 0xA3646282, "heli_02_start_node" },
    { 0x627D2471, "heli_1" },
    { 0xAFCA3AEE, "heli_abort" },
    { 0xB2CA0BF0, "heli_accel" },
    { 0xC315A2C9, "heli_action_done" },
    { 0x1CEA9E12, "heli_active_camo_damage_disable" },
    { 0xFED87DD5, "heli_active_camo_damage_update" },
    { 0x99813E5D, "heli_adjust_pitch_down" },
    { 0x9A592502, "heli_ai" },
    { 0x3E8E53E9, "heli_aim_update" },
    { 0xDEA7579F, "heli_alarm" },
    { 0xF3FFF001, "heli_alarm_ent" },
    { 0xF5829945, "heli_alarm_on" },
    { 0x9DB23507, "heli_amored_maxhealth" },
    { 0x5FF2AB95, "heli_angle_offset" },
    { 0x314EA537, "heli_anim" },
    { 0xEAE377BD, "heli_armor" },
    { 0xA0DF20A3, "heli_armor_bulletdamage" },
    { 0x7FAA47EF, "heli_array" },
    { 0xC2106C1F, "heli_attack_bullets_loop" },
    { 0x43605A9D, "heli_attack_destruction" },
    { 0x8BEA9E1C, "heli_attack_drone_targets" },
    { 0xF75A2E71, "heli_attack_drone_targets_func" },
    { 0x33722D75, "heli_attack_entrance" },
    { 0x4456B39D, "heli_attacks_price" },
    { 0x57A49E0A, "heli_attacks_price_new" },
    { 0x8EC058EA, "heli_attacks_start" },
    { 0x69CC05ED, "heli_attract_range" },
    { 0x70652E29, "heli_attract_strength" },
    { 0x727F117A, "heli_avoidance" },
    { 0xEB4F4A36, "heli_away" },
    { 0x6808AB2A, "heli_b" },
    { 0x0449C70F, "heli_barge_path_offset" },
    { 0xAD6D907E, "heli_barge_path_start" },
    { 0x75B4E006, "heli_blade" },
    { 0xC13A9978, "heli_block_org" },
    { 0xE84834F2, "heli_bone" },
    { 0xE224C70F, "heli_bone1" },
    { 0x701D57D4, "heli_bone2" },
    { 0x961FD23D, "heli_bone3" },
    { 0x24186302, "heli_bone4" },
    { 0xBDC1A0AA, "heli_breadcrumbs" },
    { 0x754D83ED, "heli_building_impact" },
    { 0x0EFBB134, "heli_centroid" },
    { 0x9D098020, "heli_chaser_spawners" },
    { 0x51D2B765, "heli_check_for_spotlight" },
    { 0xB2D44407, "heli_circle_area_gun" },
    { 0x9024B165, "heli_circle_area_start" },
    { 0x8E758B37, "heli_circle_area_stop" },
    { 0x3AC96D0C, "heli_cleanup" },
    { 0x4AA3E42B, "heli_collision_point" },
    { 0x472D9172, "heli_comes_to_rest" },
    { 0xC637C7F3, "heli_comlink_bootup_anim" },
    { 0x728A8A8F, "heli_comlink_lights_off" },
    { 0x1AC0363B, "heli_comlink_lights_on" },
    { 0x02066610, "heli_comlink_lights_on_after_wait" },
    { 0x02B2755F, "heli_comlink_lights_on_delay" },
    { 0x56983258, "heli_context_switch" },
    { 0xA5848CED, "heli_cover_detection" },
    { 0xE54B1121, "heli_crash" },
    { 0x5BAB7807, "heli_crash_ai_spawn_func" },
    { 0xC6017802, "heli_crash_audio" },
    { 0xD9B800F6, "heli_crash_basic_crash" },
    { 0x9217D1E4, "heli_crash_done" },
    { 0xDB3FFF54, "heli_crash_hind_logic" },
    { 0x055EC3F8, "heli_crash_paths" },
    { 0x5BCF2906, "heli_crash_pitch_random_until_death" },
    { 0xA3BF24B7, "heli_crash_scene_done" },
    { 0x7315C8BB, "heli_crash_smoke_trail_fx" },
    { 0x53E12355, "heli_crash_soct_end" },
    { 0xF4AF5FE7, "heli_crash_spin_audio" },
    { 0xE3844AD4, "heli_crash_think" },
    { 0xDAC914C1, "heli_crash_watch_for_anim_end" },
    { 0xA2E3F9BB, "heli_crash_watch_for_ground_then_explode" },
    { 0xADB97823, "heli_crashers" },
    { 0x469A4A2B, "heli_crew" },
    { 0xA5D0EF38, "heli_crew_init" },
    { 0xC541BC73, "heli_crew_reset_on_notify" },
    { 0xC8EE453E, "heli_current_index" },
    { 0x184262DC, "heli_custom_flyby" },
    { 0xF52E085B, "heli_damage" },
    { 0xF264CDDC, "heli_damage_monitor" },
    { 0x555C01A0, "heli_data" },
    { 0x480F7BB7, "heli_death_trail" },
    { 0xA02D08FD, "heli_debug" },
    { 0x0FFD2A49, "heli_debug_crash" },
    { 0xC4BE1171, "heli_deck_movement" },
    { 0xFF53CE8D, "heli_default_decel" },
    { 0x7EE872D9, "heli_delete_sound_loops" },
    { 0xED9B9CFF, "heli_deletefx" },
    { 0x931DF75B, "heli_deploy_flares" },
    { 0x7935952C, "heli_dest_wait" },
    { 0xE68AC78B, "heli_direction" },
    { 0xA2F00270, "heli_direction_2" },
    { 0x1C28F8F8, "heli_done" },
    { 0x9FCD3DDB, "heli_dot_target" },
    { 0x8DFE71EC, "heli_down" },
    { 0x3C5E6A63, "heli_drop_goal" },
    { 0xBA5D22F3, "heli_drop_help" },
    { 0x8B29FD4F, "heli_encourage_kill_streak" },
    { 0x1F405975, "heli_end_anim_explosion" },
    { 0xAD6057F1, "heli_end_shooting" },
    { 0xDB9B6515, "heli_engage" },
    { 0xA48E71BD, "heli_engage_debug" },
    { 0xC6BEB31B, "heli_entityshutdown" },
    { 0x899E30E5, "heli_entrance_z_help" },
    { 0xD93F0A9B, "heli_evade" },
    { 0x3FD8FD51, "heli_evasive" },
    { 0x1AF23B5C, "heli_existance" },
    { 0xEBE171F7, "heli_explode" },
    { 0x92026ACD, "heli_explosion" },
    { 0x939778C3, "heli_extra_low_health_fx" },
    { 0xCD6B4D1E, "heli_final_call_fail" },
    { 0x64DB2E49, "heli_final_strafe_fail_watch" },
    { 0x67AAF1C4, "heli_fire" },
    { 0x40A190D7, "heli_fire_burst" },
    { 0x8259D443, "heli_fire_chaff" },
    { 0x55D53F52, "heli_fire_rockets" },
    { 0x8898FA77, "heli_fires" },
    { 0x19125CAB, "heli_fires_around_price" },
    { 0x8427B08E, "heli_flag" },
    { 0xD31BF75C, "heli_flight_path" },
    { 0x3030D2FB, "heli_flight_path_2" },
    { 0xF6B0DD93, "heli_fly" },
    { 0x3DF58B72, "heli_fly_well" },
    { 0x6381F9B0, "heli_flyby_1_start_node" },
    { 0xD2C35B01, "heli_flyby_2_start_node" },
    { 0x00E08834, "heli_flyby_rumble" },
    { 0xB69DEF2E, "heli_flypath" },
    { 0xF15E06AC, "heli_focusonplayer" },
    { 0xD657DE54, "heli_follow_boat" },
    { 0x9B05BBB1, "heli_forced_wait" },
    { 0x29F0ED90, "heli_forward_norm" },
    { 0xBBDD33F1, "heli_fougasse" },
    { 0x0BD7F084, "heli_friendly_fire" },
    { 0x73735309, "heli_friendlyfire" },
    { 0xC233870C, "heli_get_dvar" },
    { 0x91077906, "heli_get_dvar_int" },
    { 0x7C2805FF, "heli_get_protect_spot" },
    { 0x9787B0D0, "heli_go_struct_path" },
    { 0xEE41517A, "heli_goal_pos_obstructed" },
    { 0x8E0A0281, "heli_going_down" },
    { 0xA3962052, "heli_groans" },
    { 0x6E84273A, "heli_guard_fire_time" },
    { 0x3FDA26CB, "heli_guard_gunner" },
    { 0x21062E47, "heli_guard_max_pause" },
    { 0xED013446, "heli_guard_max_shots" },
    { 0x46BBB855, "heli_guard_min_pause" },
    { 0x57A60F54, "heli_guard_min_shots" },
    { 0x7361D891, "heli_guard_spinup" },
    { 0xFDEFBB43, "heli_guard_target_death_watcher" },
    { 0xE3B7EAA2, "heli_gunner_killstreak" },
    { 0x14289AC3, "heli_gunner_mp" },
    { 0xCA546AF9, "heli_gunner_shoot" },
    { 0xA7FF8431, "heli_gunner_spawn" },
    { 0xF76A9FB9, "heli_gunner_vtol_state" },
    { 0xDDCA5939, "heli_guy" },
    { 0x535B76C3, "heli_guy_accuracy" },
    { 0x1ACEDB42, "heli_guy_death" },
    { 0x051CD60E, "heli_guy_died" },
    { 0x234C0094, "heli_guy_health_multiplier" },
    { 0x0B69D6B8, "heli_guy_respawn_delay" },
    { 0xB78B3D5E, "heli_guy_spawned" },
    { 0xC74C4513, "heli_hacked_health_update" },
    { 0xDAA7B433, "heli_handle_challenge_death" },
    { 0x0CEF2241, "heli_hardpoint_timer" },
    { 0x3089A1AA, "heli_health" },
    { 0x07FBFC15, "heli_health_degrade" },
    { 0x69A78336, "heli_health_player" },
    { 0x4D1566D9, "heli_height" },
    { 0x812FE69F, "heli_height_meshes" },
    { 0xC18849BF, "heli_hide_door_top" },
    { 0xD7E23B43, "heli_hind" },
    { 0xCDBBBAC4, "heli_hint_tutorial" },
    { 0x3172B963, "heli_hip" },
    { 0xE73FBAD8, "heli_hit_fx" },
    { 0xE78DF6E0, "heli_hits_ground" },
    { 0x6FDF6951, "heli_hits_wall" },
    { 0xACED502E, "heli_hover" },
    { 0x7987ADD6, "heli_idle_run_transition" },
    { 0x55D76277, "heli_inflight" },
    { 0x855D1DEB, "heli_inital_cooldown" },
    { 0x6D91BADB, "heli_int" },
    { 0xCF150324, "heli_interior_lights_on" },
    { 0xE97B7791, "heli_intro_fire" },
    { 0xBDFAFFBD, "heli_intro_reverb" },
    { 0xACC114DA, "heli_intro_verb" },
    { 0xBC569790, "heli_intro_verb_off" },
    { 0x8CB1B14C, "heli_jump" },
    { 0x0621DCEC, "heli_jump_main" },
    { 0xA673D253, "heli_jump_snapshot" },
    { 0xE82F2925, "heli_jump_trigger" },
    { 0xF6A3551F, "heli_kill_damage_override" },
    { 0xE0C0607B, "heli_kill_monitor" },
    { 0xF4F3FD29, "heli_kill_streak" },
    { 0xC0BC9C57, "heli_kill_streak_time_stamp" },
    { 0x93E0F465, "heli_kill_zone" },
    { 0x4867A711, "heli_killed_damage_watch" },
    { 0xCC4A5E30, "heli_killed_death_watch" },
    { 0xC2111309, "heli_killed_fake" },
    { 0x869A470A, "heli_killed_think" },
    { 0x1A865A91, "heli_kills_price" },
    { 0xC75D3FA7, "heli_land" },
    { 0xCE13D46C, "heli_landing_gear_down" },
    { 0x1A0A4B15, "heli_leave" },
    { 0xDDB7D724, "heli_leavenodes" },
    { 0x705306A5, "heli_light_delete_on_death" },
    { 0x72167A8C, "heli_limo_stream" },
    { 0x52884BC1, "heli_lingering_invincibility" },
    { 0xB0F82A9A, "heli_linkto_sound_ents_delete" },
    { 0xCB539BF2, "heli_lock_monitor" },
    { 0x98BDCB17, "heli_lookat_trigger" },
    { 0xFF9612D2, "heli_loop" },
    { 0xA606F857, "heli_loop_paths" },
    { 0xD79F8F84, "heli_loop_sound_delete" },
    { 0x926ADF68, "heli_loopmax" },
    { 0x7175B6C4, "heli_low_health_fx" },
    { 0xD6370A56, "heli_main_think" },
    { 0x9469B89A, "heli_makes_sparks" },
    { 0xA03E568D, "heli_match_best_boat_speed" },
    { 0x08680D42, "heli_max_speed" },
    { 0x0E51480C, "heli_maxhealth" },
    { 0xA6CB7713, "heli_mg_burst" },
    { 0x20670C8B, "heli_minigun_attach" },
    { 0xD5CA9792, "heli_minigun_burstfire" },
    { 0x0E233CD8, "heli_minigun_fire" },
    { 0x31188778, "heli_minigun_firethread" },
    { 0xC515D480, "heli_minigun_stopfire" },
    { 0xAFEF876B, "heli_minigun_targetthread" },
    { 0x79D3A6CD, "heli_missile_controls" },
    { 0xB793D9CD, "heli_missile_damage_event_manager" },
    { 0x2C9B97C1, "heli_missile_engage_dist" },
    { 0x4DF1A245, "heli_missile_friendlycare" },
    { 0xA31C2DA3, "heli_missile_incoming" },
    { 0xA3B188E3, "heli_missile_max" },
    { 0x0FA0C06E, "heli_missile_range" },
    { 0xEF6D5DA6, "heli_missile_regen" },
    { 0x1D32F542, "heli_missile_regen_time" },
    { 0xE3CC8C78, "heli_missile_reload_time" },
    { 0xA3BF9000, "heli_missile_rof" },
    { 0x31B81B26, "heli_missile_target_cone" },
    { 0x6354B21B, "heli_mobilespawn" },
    { 0x7D4F434F, "heli_monitor_health" },
    { 0xA384789B, "heli_monitor_health_ruins" },
    { 0xA9E6FA13, "heli_monitor_near_goal" },
    { 0x3C785F5F, "heli_move" },
    { 0x4DBBABF3, "heli_move_after_set_time" },
    { 0xA24FE306, "heli_move_think" },
    { 0xF6896152, "heli_move_think_ruins" },
    { 0x31871E2F, "heli_moves_again" },
    { 0xE283B30D, "heli_mph" },
    { 0x35117241, "heli_name" },
    { 0xB9B85D1A, "heli_near_player" },
    { 0xEE5854AC, "heli_node" },
    { 0xF83CD291, "heli_objective" },
    { 0x09B3CB9E, "heli_on_collision_course" },
    { 0x76E63A44, "heli_one" },
    { 0xE1B218F2, "heli_osprey" },
    { 0x42381C60, "heli_owner_exit" },
    { 0x0B3453F2, "heli_owner_teamkillkicked" },
    { 0xA57AF496, "heli_pad_kravchenko" },
    { 0x9442D65C, "heli_pad_reinforcements" },
    { 0x9CBA62F7, "heli_part" },
    { 0xAADE441C, "heli_part1" },
    { 0x1CE5B357, "heli_part2" },
    { 0xF6E338EE, "heli_part3" },
    { 0x38D6D4E1, "heli_part4" },
    { 0x6E7BCD7D, "heli_path" },
    { 0x3D9D0BE5, "heli_path_complete" },
    { 0x33E86815, "heli_path_debug" },
    { 0xA1B90EBC, "heli_path_graph" },
    { 0x3E5BE45D, "heli_path_manager" },
    { 0x6AE508A1, "heli_path_speed" },
    { 0x1854003C, "heli_paths" },
    { 0xA4836B72, "heli_pickup_model" },
    { 0xE2FE6770, "heli_pickup_update" },
    { 0xC2FC95D2, "heli_pilot" },
    { 0x68CD52B3, "heli_pilot_maker" },
    { 0x651A9148, "heli_pitch_align" },
    { 0x74076A9A, "heli_player_btr" },
    { 0x6067858C, "heli_player_controlled_mp" },
    { 0x889B5E8E, "heli_player_damage_monitor" },
    { 0x238751A4, "heli_player_damage_override" },
    { 0xF087EA9E, "heli_populate_passengers" },
    { 0x3F3D8342, "heli_pos_struct" },
    { 0x24B745F6, "heli_post_cooldown" },
    { 0x9D36BB44, "heli_primary_path" },
    { 0x9C7995A5, "heli_protect" },
    { 0x613D62A2, "heli_protect_pos_time" },
    { 0x2109B53A, "heli_protect_radius" },
    { 0x98D9BBB3, "heli_protect_time" },
    { 0x365C4DD2, "heli_rage_missile" },
    { 0x60F10DF9, "heli_random_point_in_radius" },
    { 0x5673CE1C, "heli_rappel" },
    { 0x18AD16C1, "heli_rappel_ai" },
    { 0xB27F556E, "heli_rappelers_to_ground" },
    { 0x0E642199, "heli_reached_barge_rear" },
    { 0x7155B37E, "heli_rescue_trigger" },
    { 0xF789D025, "heli_reset" },
    { 0x6ACB7605, "heli_restore_spot" },
    { 0x1D3CDF59, "heli_ride_done" },
    { 0xF5AC4334, "heli_ride_player_quake" },
    { 0xEB0A7F11, "heli_rocket_loop" },
    { 0x16E78341, "heli_rocket_target1" },
    { 0x584754D2, "heli_roof_crash" },
    { 0xD2628A91, "heli_room" },
    { 0x6F96217E, "heli_rumbles" },
    { 0xAD466B83, "heli_rumbles_at_rest" },
    { 0xAE4EF457, "heli_run_dof_off" },
    { 0xB4CD08E3, "heli_run_dof_on" },
    { 0x0A15B2FB, "heli_screen_shake" },
    { 0xE0F14F17, "heli_searchlight_dlight" },
    { 0xF517BC6E, "heli_searchlight_off" },
    { 0x3660A440, "heli_searchlight_on" },
    { 0xC902E748, "heli_searchlight_target" },
    { 0xBC88F376, "heli_searchlight_target_calcai" },
    { 0xD9E7D5D1, "heli_searchlight_think" },
    { 0x6E5A58FD, "heli_secondary_explosions" },
    { 0x52D6627F, "heli_select_death" },
    { 0x62660FEA, "heli_set_active_camo_state" },
    { 0x10122E5B, "heli_set_rotor_state" },
    { 0x60BF93A5, "heli_shoot" },
    { 0x3D117B99, "heli_shoot_at_crane" },
    { 0x34A24EFA, "heli_shoot_logic" },
    { 0x46189FF4, "heli_shoot_think_ruins" },
    { 0x8906281C, "heli_shoots_dirt" },
    { 0x1038AEF0, "heli_shoots_rockets_at_ent" },
    { 0xAE95E374, "heli_shoots_rockets_at_price" },
    { 0x55BB50B6, "heli_shoots_targetnamed_rocket" },
    { 0x500A1ACF, "heli_shot_down" },
    { 0xED2FC8DB, "heli_shot_down_detection" },
    { 0x78D6C996, "heli_show_door_top" },
    { 0x47E5DF94, "heli_snapshot" },
    { 0xCD42A845, "heli_snip_trig" },
    { 0x1CB04F54, "heli_snipe_a_node" },
    { 0x33D0F625, "heli_snipe_b_node" },
    { 0xA018E45E, "heli_snipe_c_node" },
    { 0xF48003BF, "heli_snipe_d_node" },
    { 0x2945915A, "heli_snipe_origin" },
    { 0xED546895, "heli_sound" },
    { 0xF13D07A3, "heli_sound_ent_delete" },
    { 0xA56741AE, "heli_sound_play" },
    { 0x4681852F, "heli_sound_spawnfunc" },
    { 0x63835026, "heli_sparks" },
    { 0x2C6F8189, "heli_speed" },
    { 0x1E968D80, "heli_spin" },
    { 0x39AC7C1C, "heli_spotlight" },
    { 0xC7B902CE, "heli_spotlight_enable" },
    { 0x72024AEB, "heli_spotlight_stealth_done" },
    { 0x1CF99792, "heli_squad_size" },
    { 0x50379AC0, "heli_squashes_stuff" },
    { 0x627BE997, "heli_start_angles" },
    { 0x1612215E, "heli_start_anim_callback" },
    { 0x6DF9188B, "heli_start_node" },
    { 0x479A59AF, "heli_start_pos" },
    { 0x02F393B4, "heli_start_shooting" },
    { 0x9027E64B, "heli_startnodes" },
    { 0xA42635C4, "heli_stealth_fail" },
    { 0x3CB2A2FD, "heli_stop_moving" },
    { 0x80E29232, "heli_stop_patterns" },
    { 0x628B5C4D, "heli_stop_spotlight" },
    { 0x4620449C, "heli_stops_rumbles" },
    { 0xA226F351, "heli_strafe" },
    { 0x9FF2DF3B, "heli_strafe_check_fail" },
    { 0xC6B74482, "heli_strafe_controls" },
    { 0x9A9F35D1, "heli_strafe_follow_player" },
    { 0xD57FCDFB, "heli_strafe_run" },
    { 0xFB58E254, "heli_strafe_run_controls" },
    { 0xC099183B, "heli_strafe_run_sound" },
    { 0xB6CAB68C, "heli_strafing_watch" },
    { 0xF2A5814E, "heli_streak_encourage_kills" },
    { 0xF9DBC803, "heli_streak_max_kills" },
    { 0x45AED0C3, "heli_streak_max_time" },
    { 0xCE65325E, "heli_supplydrop_mp" },
    { 0xC3FCB72D, "heli_support" },
    { 0x4E4F1EAF, "heli_sweep_new_debug" },
    { 0x4E8C4673, "heli_sweep_player_in_target_trig" },
    { 0x75AB1679, "heli_takeoff_trigger" },
    { 0x9FEF12D3, "heli_target" },
    { 0x705BB1A1, "heli_target_array" },
    { 0xCE17A1F3, "heli_target_recognition" },
    { 0x48D6E602, "heli_target_spawnprotection" },
    { 0x5279FDCD, "heli_targeting" },
    { 0x3FA2F21D, "heli_targeting_delay" },
    { 0x746D3893, "heli_team" },
    { 0x4396FDF4, "heli_test" },
    { 0x0DF886B4, "heli_testing" },
    { 0xC58CA530, "heli_think" },
    { 0x929EA5BC, "heli_timeup" },
    { 0x904BC259, "heli_to_avoid" },
    { 0x5CC96827, "heli_to_crash" },
    { 0x5468DF0A, "heli_toggle_main_rotor_fx" },
    { 0xEECE0B2A, "heli_toggle_rotor_fx" },
    { 0x8D618883, "heli_trace" },
    { 0xA06EA6D6, "heli_tracker_triggers_array" },
    { 0x454061E6, "heli_trig" },
    { 0x5249D762, "heli_trig_interval" },
    { 0x58B8433C, "heli_trigger" },
    { 0xE6F5FDED, "heli_trigger_think" },
    { 0xE603E317, "heli_triggers_crane_fall" },
    { 0x0D53F5F0, "heli_turn_think" },
    { 0x5A265556, "heli_turret" },
    { 0xA570AF72, "heli_turret_angle_tan" },
    { 0x2B5E26D8, "heli_turret_challenge_watch" },
    { 0x3EDE3DD1, "heli_turret_challenge_watch_think" },
    { 0x916B787E, "heli_turret_damage_watch" },
    { 0x21344461, "heli_turret_early_exit" },
    { 0x693ADE2F, "heli_turret_engage_dist" },
    { 0xB12075B6, "heli_turret_events" },
    { 0xE1EDD9C9, "heli_turret_fade_time" },
    { 0x1F4AEBC7, "heli_turret_index" },
    { 0x3DCBB69D, "heli_turret_point" },
    { 0x24549086, "heli_turret_spinup_delay" },
    { 0x9F1DF338, "heli_turret_target_cone" },
    { 0x0C4B1BB3, "heli_turret_think" },
    { 0x3B26AC9C, "heli_turret_vo" },
    { 0xD2526B2D, "heli_turret_watch_overheat" },
    { 0x21902388, "heli_turret_zap_end" },
    { 0x75CA822B, "heli_turret_zap_start" },
    { 0x9E005407, "heli_turretclipsize" },
    { 0x02597BF2, "heli_turretreloadtime" },
    { 0xFB1C1CC9, "heli_turrets" },
    { 0x30D06B90, "heli_type" },
    { 0xE718A35D, "heli_update_dvar" },
    { 0x39D3E100, "heli_update_global_dvars" },
    { 0xA5D83180, "heli_valid_target_cone" },
    { 0x99C94EB0, "heli_vehicle_damage" },
    { 0xA9977C7A, "heli_visual_range" },
    { 0x7FB68EED, "heli_vo" },
    { 0xCF5261CB, "heli_wait" },
    { 0x38368EFA, "heli_wait_node" },
    { 0x34D71B3A, "heli_warning_distance" },
    { 0x598B1AB9, "heli_weapon_controls" },
    { 0x01F136BF, "heli_weapons_bay_close" },
    { 0x3BC7CD79, "heli_weapons_bay_open" },
    { 0x52868662, "heli_weaver_eye" },
    { 0xBACE912B, "heli_weaver_eye_start" },
    { 0x78EEC88E, "heli_woods" },
    { 0x2BD605D7, "heli_zombie_poi" },
    { 0x481741F5, "heliangles" },
    { 0xA895D3B4, "helicomlinkbootupanim" },
    { 0x24D855A8, "helicoper" },
    { 0xE0ECC876, "helicoptedetonateviaemp" },
    { 0xE685164A, "helicopter" },
    { 0x73FB8497, "helicopter1" },
    { 0x4B5845C6, "helicopter1_flyby" },
    { 0xB8E429B9, "helicopter1_setup" },
    { 0x01F4155C, "helicopter2" },
    { 0x7E3BB6DD, "helicopter2_flyby" },
    { 0x27F68FC5, "helicopter3" },
    { 0x353A55F8, "helicopter_01" },
    { 0x80E46D32, "helicopter_1_rpg_struct" },
    { 0x130FF968, "helicopter_alloted_time" },
    { 0xF987F128, "helicopter_assist" },
    { 0xB9DB5AE1, "helicopter_attack" },
    { 0x5EEA502B, "helicopter_attack_pick_points" },
    { 0x27EC9519, "helicopter_attack_points" },
    { 0x6C59EB2A, "helicopter_bridge_destroyed" },
    { 0x5D37268D, "helicopter_bridge_obj_num" },
    { 0x065B4330, "helicopter_bridge_player_boat_skipto" },
    { 0xBF995C16, "helicopter_broadcast" },
    { 0xD20E1832, "helicopter_camo_damage_duration" },
    { 0x998FB28B, "helicopter_camo_damage_limit" },
    { 0x00F0C2B3, "helicopter_camo_flicker_duration" },
    { 0xDC76060A, "helicopter_camo_state_flicker" },
    { 0x83175311, "helicopter_camo_state_off" },
    { 0x8A9F14E5, "helicopter_camo_state_on" },
    { 0xACAF858A, "helicopter_close_door" },
    { 0x2A6E871F, "helicopter_collision" },
    { 0xB02DF080, "helicopter_comlink" },
    { 0x021AFA0A, "helicopter_crash" },
    { 0x2F62A067, "helicopter_crash_accel" },
    { 0x9D35CF9F, "helicopter_crash_locations" },
    { 0xD5E8BCDE, "helicopter_crash_move" },
    { 0x037751EE, "helicopter_crash_movement" },
    { 0x7CEF10AC, "helicopter_crash_path" },
    { 0x249175B0, "helicopter_crash_rotate" },
    { 0x960E5E07, "helicopter_crash_rotation" },
    { 0xC07D6B4A, "helicopter_crash_zone_accel" },
    { 0x5938769D, "helicopter_crashed" },
    { 0xC1FBA8DB, "helicopter_damage_watcher" },
    { 0x40AE9A4E, "helicopter_death_anims" },
    { 0x4D8FC52F, "helicopter_delete_node" },
    { 0x385F810E, "helicopter_destroyed" },
    { 0xACFB4A4A, "helicopter_destroyed_early" },
    { 0x88C220ED, "helicopter_destruction_set_piece" },
    { 0xD0CB5C72, "helicopter_distance_offset" },
    { 0x0C4D5081, "helicopter_drops_off_troops" },
    { 0xDC88FD03, "helicopter_drops_off_troops_old" },
    { 0xE9A55FB1, "helicopter_dust_kickup" },
    { 0xC40C7636, "helicopter_entrance_trigger" },
    { 0x6B93AFBC, "helicopter_explode" },
    { 0xCA692EE3, "helicopter_find_best_breadcrumb" },
    { 0xD8453E44, "helicopter_fire_barrage" },
    { 0xB78F7C1B, "helicopter_fire_rockets" },
    { 0xC91AB063, "helicopter_fire_update" },
    { 0x2391ACFB, "helicopter_fire_update2" },
    { 0x42C9987C, "helicopter_fires_at_player" },
    { 0x5AE0BF9A, "helicopter_fires_rockets_at_target" },
    { 0x9C414167, "helicopter_flies_by_overhead" },
    { 0x53CAF8F0, "helicopter_fly_down_attack_path" },
    { 0x1F4C5F4F, "helicopter_fly_past" },
    { 0xACD49847, "helicopter_flyby" },
    { 0x327F248A, "helicopter_flyby_trigger" },
    { 0xBF748CEF, "helicopter_fog" },
    { 0x313BCF0D, "helicopter_getturrettargetent" },
    { 0xBA02AA50, "helicopter_gone" },
    { 0xEE7F85AE, "helicopter_group" },
    { 0x32FF5750, "helicopter_guard" },
    { 0xBA7E0F70, "helicopter_gunner" },
    { 0x4B9383C6, "helicopter_gunner_angle_offset" },
    { 0xFDEDCAE1, "helicopter_gunner_assistant_0_target_tag" },
    { 0x58A43D32, "helicopter_gunner_assistant_1_target_tag" },
    { 0xC9267E09, "helicopter_gunner_assistant_name" },
    { 0x3D126A83, "helicopter_gunner_assistant_seat_count" },
    { 0xD803A257, "helicopter_gunner_assistant_seat_start_index" },
    { 0x5796A1BA, "helicopter_gunner_camshake_delay" },
    { 0x262AC0C2, "helicopter_gunner_camshake_size" },
    { 0xE252556A, "helicopter_gunner_camshake_time" },
    { 0x2B6ADC2F, "helicopter_gunner_duration" },
    { 0xDBEE99D8, "helicopter_gunner_enhanced_vision" },
    { 0xFEC9E790, "helicopter_gunner_forced_wait" },
    { 0xDB4DEB69, "helicopter_gunner_hacker_tool_duration" },
    { 0x9B42D3EF, "helicopter_gunner_hacker_tool_radius" },
    { 0xC62E284D, "helicopter_gunner_helicopter_health" },
    { 0xF3F108C3, "helicopter_gunner_helicopter_missiles_to_destroy" },
    { 0xAF69F2A9, "helicopter_gunner_hide_compass_on_remote_control" },
    { 0x24DF291F, "helicopter_gunner_infrared_vision" },
    { 0xC2EDFD3A, "helicopter_gunner_name" },
    { 0x927B4611, "helicopter_gunner_vehicle_name" },
    { 0x950114DB, "helicopter_gunner_weapon_name" },
    { 0x0A9AB73B, "helicopter_gunner_z_offset" },
    { 0xADD77B9C, "helicopter_hallway_start" },
    { 0xDCAB3EC8, "helicopter_haters" },
    { 0xAADC362F, "helicopter_health" },
    { 0x7A6D1D87, "helicopter_influencer_length" },
    { 0x8A98DC61, "helicopter_influencer_radius" },
    { 0xD34CC857, "helicopter_influencer_score" },
    { 0xFAE3773B, "helicopter_influencer_score_curve" },
    { 0xDEA73B22, "helicopter_killzone_fire" },
    { 0x9360DFEF, "helicopter_landing_scene" },
    { 0x70602EEE, "helicopter_leave_delay" },
    { 0x3FA2F111, "helicopter_list" },
    { 0xB3B1D651, "helicopter_massacre_guys" },
    { 0xCE263B2E, "helicopter_movement" },
    { 0x1EDA4340, "helicopter_open_door" },
    { 0x6BFF52E7, "helicopter_pilot1_idle" },
    { 0x2DB3314F, "helicopter_pilot1_twitch_clickpannel" },
    { 0x537ACCAB, "helicopter_pilot1_twitch_lookback" },
    { 0x89805AA7, "helicopter_pilot1_twitch_lookoutside" },
    { 0xDF2E617E, "helicopter_pilot2_idle" },
    { 0x134DC6BE, "helicopter_pilot2_twitch_clickpannel" },
    { 0xC9DCB66A, "helicopter_pilot2_twitch_lookoutside" },
    { 0x2DB7D299, "helicopter_pilot2_twitch_radio" },
    { 0x2EAD17C6, "helicopter_rappel_intro" },
    { 0x8D0C41E9, "helicopter_rappel_unload" },
    { 0x080A41AC, "helicopter_scripted_init" },
    { 0x6514D5FF, "helicopter_scripted_strafe" },
    { 0x9025DB79, "helicopter_searchlight_effect" },
    { 0x4F93F131, "helicopter_searchlight_off" },
    { 0x2F948085, "helicopter_searchlight_on" },
    { 0x7FAB1E39, "helicopter_setturrettargetent" },
    { 0x01399D0C, "helicopter_setup" },
    { 0x0C3AA959, "helicopter_sounds" },
    { 0xCDA3AD12, "helicopter_spawn" },
    { 0x9BEB14F1, "helicopter_speed_scale" },
    { 0x6E0BFE1A, "helicopter_strafe_to_tower" },
    { 0xC43A22C0, "helicopter_sweep_draw_debug" },
    { 0xAC51B534, "helicopter_sweep_init" },
    { 0xBC2DB503, "helicopter_sweep_player_breadcrumb" },
    { 0x0E19C401, "helicopter_sweep_select_pattern" },
    { 0xD80A4F4F, "helicopter_sweep_shoot" },
    { 0xE38329FF, "helicopter_think" },
    { 0x66FB2797, "helicopter_trigger" },
    { 0x7A72A6D8, "helicopter_unload" },
    { 0xF7D41710, "helicopter_unloaded_ai" },
    { 0x38E72152, "helicopter_watch_damage" },
    { 0xB4FB859B, "helicopter_watch_lockon" },
    { 0xC2B90D52, "helicopter_world_edge_failure" },
    { 0x11B143A0, "helicopter_world_edge_warning" },
    { 0x8DCF5BB5, "helicopterenveffectscleanup" },
    { 0xC915FA70, "helicopterenveffectsupdate" },
    { 0x0D5D4949, "helicopterforward" },
    { 0x3D00912F, "helicoptergunner_hacked_health_callback" },
    { 0xC23B805C, "helicoptergunnerdamageoverride" },
    { 0x5DB964F1, "helicopterinterval" },
    { 0xFEE720B7, "helicopterleave" },
    { 0xDB38A403, "helicopterreforigin" },
    { 0xA757F585, "helicopters" },
    { 0x0B848042, "helicopters_destroy_bridge" },
    { 0x101979EC, "helicopters_flies_by_overhead" },
    { 0xA7EFC850, "helicopters_fly_away" },
    { 0x32F21C69, "helicopters_fly_by" },
    { 0xC43615C2, "helicopters_fly_in_and_destroy_bridge" },
    { 0x62F76066, "helicopterthink" },
    { 0xDC3D73E5, "helicopterthinkdebugvisitall" },
    { 0x78EDC502, "helicopterthinkthread" },
    { 0x71FF7287, "helicopterturretmaxangle" },
    { 0xF39DAFDE, "helicoptervehicleinfo" },
    { 0xEC20B505, "helicpter" },
    { 0xBAB69B59, "helictoper_friendly_fire" },
    { 0xC353E232, "helideathtrails" },
    { 0xBF7E1524, "helidefaultnode" },
    { 0x5B42C085, "helidelivercrate" },
    { 0xCD99CE62, "helidestroyed" },
    { 0x7F3090EA, "helidrop" },
    { 0x210E03AD, "helidrop_clacker_divert" },
    { 0xF01DEA0D, "helidrop_rider_setup" },
    { 0xB8474F27, "helidropcrate" },
    { 0xD6379181, "heliextralowhealthfx" },
    { 0x076AEF56, "heligoalpos" },
    { 0x6182E57C, "heliguard" },
    { 0xCA32FE4D, "heliguardflyovernfz" },
    { 0x707D38FC, "heliguardsupport_arraycontains" },
    { 0x2F3858B2, "heliguardsupport_attacktargets" },
    { 0x268A94D4, "heliguardsupport_firestart" },
    { 0x0FD44068, "heliguardsupport_firestop" },
    { 0xBC1DF11C, "heliguardsupport_followplayer" },
    { 0xC2EE615E, "heliguardsupport_getclosestlinkednode" },
    { 0x8080A211, "heliguardsupport_getclosestnode" },
    { 0xEF3DB153, "heliguardsupport_getcloseststartnode" },
    { 0xFC0A5677, "heliguardsupport_getlinkedstructs" },
    { 0x74C49969, "heliguardsupport_leave" },
    { 0x1D34DAC7, "heliguardsupport_movetoplayer" },
    { 0x361D9709, "heliguardsupport_movetoplayervertical" },
    { 0xE9543C33, "heliguardsupport_setairnodemesh" },
    { 0xFE6C78D3, "heliguardsupport_setairstartnodes" },
    { 0x31FB99C4, "heliguardsupport_watchforearlyleave" },
    { 0x8097F265, "heliguardsupport_watchownerdamage" },
    { 0x45A29047, "heliguardsupport_watchownerloss" },
    { 0x533CA266, "heliguardsupport_watchroundend" },
    { 0xA828B549, "heliguardsupport_watchsamproximity" },
    { 0x1CE5BCF6, "heliguardsupport_watchtimeout" },
    { 0x7DBF88C4, "heligunner" },
    { 0x64855B68, "heligunnervtoldownanim" },
    { 0x74DE72C7, "heligunnervtolupanim" },
    { 0x0037490C, "heliheightlockoffset" },
    { 0x1197C85F, "heliinproximity" },
    { 0xA15C7440, "helilocation" },
    { 0xB1578875, "helilowhealthfx" },
    { 0x040F7AEB, "helimissile" },
    { 0x786743DC, "heliname" },
    { 0x1B130B15, "helinode" },
    { 0x3D64B16B, "heliorigin" },
    { 0x64E95656, "heliowner" },
    { 0x314BDF48, "helipad" },
    { 0x7D71D00B, "helipad_ai_detach_shield_early" },
    { 0x1C7434B9, "helipad_ai_plant_shield" },
    { 0x283F00F1, "helipad_ai_plant_shield_early" },
    { 0xCCAE8F7A, "helipad_arrive" },
    { 0xDBFA03A4, "helipad_battle_intro_vo" },
    { 0x4CE561AF, "helipad_battle_main" },
    { 0x3CB36A42, "helipad_battle_salazar_titus" },
    { 0x772B09BE, "helipad_battle_spawn_gaz" },
    { 0xE7DB3412, "helipad_clean_up" },
    { 0x095F55AB, "helipad_destroy_lion_statue" },
    { 0xE93F102B, "helipad_fx_tarp" },
    { 0x89813554, "helipad_landing" },
    { 0x7468E7C5, "helipad_midway_cleanup" },
    { 0x59966B32, "helipad_plant_shield" },
    { 0xEA4D433B, "helipad_rail_limo" },
    { 0xA1B5F80E, "helipad_salazar_crouch" },
    { 0xDA64B351, "helipad_shield_plants" },
    { 0xC254D82C, "helipad_squad_destroy_helicopter" },
    { 0x225BD62A, "helipad_squad_destroy_helicopter_vo" },
    { 0x13A257B3, "helipad_squad_vo" },
    { 0xE78AAD82, "helipad_startup_sound" },
    { 0xE07892A0, "helipath" },
    { 0x5B8BC571, "heliruinscallback_vehicledamage" },
    { 0x4FF627A4, "helis" },
    { 0xE4D9992E, "helis_alive" },
    { 0x754B10B5, "helis_ambient" },
    { 0x1F043218, "helis_move" },
    { 0x5816C44A, "helis_move2" },
    { 0xDCE94EA3, "helis_stop_firing" },
    { 0xA25D357C, "helisoundvalues" },
    { 0xC8E8114E, "helitarget" },
    { 0x6AF67392, "helitime" },
    { 0xC72CB934, "helitimer" },
    { 0x88FDE87A, "heliturretdogtrace" },
    { 0x07966C0D, "heliturretsighttrace" },
    { 0xDB4AD17D, "helitype" },
    { 0xF5E4667B, "heliwatcher" },
    { 0x9D75E148, "hell" },
    { 0xF074A26E, "hellads" },
    { 0x600963A4, "hellfire" },
    { 0x7DEDAB81, "hellfire_detonated" },
    { 0x093AA1EC, "hellfireobjid" },
    { 0xC12A7A54, "hellhole_grenades" },
    { 0x024493FC, "hellhole_projectile_watch" },
    { 0x07810242, "hellhole_time" },
    { 0x5BCC056B, "hellhole_tomahawk" },
    { 0xE16833AB, "hellhole_tomahawk_watch" },
    { 0xBDCB49E6, "hellhound" },
    { 0x437D114F, "hello" },
    { 0xB50DA223, "hellstorm" },
    { 0xCC6BEF22, "helluva" },
    { 0x56DEBBEE, "helmet" },
    { 0xF8D58167, "helmet_brush" },
    { 0x47E68F2D, "helmet_crack_sound" },
    { 0x1AFEB4FB, "helmet_dmg" },
    { 0x07D41A16, "helmet_dmg_for_removal" },
    { 0xE3AE2D8C, "helmet_eject" },
    { 0xD3027599, "helmet_guy_strat" },
    { 0x083D10AB, "helmet_hits" },
    { 0x9771CC39, "helmet_logic" },
    { 0x08D03601, "helmet_mesh_lods" },
    { 0x88932AD4, "helmet_model" },
    { 0xA78FB584, "helmet_off" },
    { 0xF1B5F906, "helmet_ona_stick" },
    { 0x3791C5D6, "helmet_pop" },
    { 0xA75D14AE, "helmet_render_options" },
    { 0x8ECE6890, "helmet_shot_done" },
    { 0x28BE6C1D, "helmet_texture_lods" },
    { 0x41EE03A5, "helmet_trick_done" },
    { 0xB70F58CC, "helmet_vignette_trig" },
    { 0x54F15524, "helmetcolorcount" },
    { 0x2A99874E, "helmetcolors" },
    { 0xBF37AF0A, "helmetindex" },
    { 0x8363D287, "helmetlaunch" },
    { 0xF1A3FA15, "helmetmodel" },
    { 0xCC399D8B, "helmetpop" },
    { 0x41F29968, "helmetpopper" },
    { 0xD44A8060, "helmetrenderoptions" },
    { 0x69659E11, "helmets" },
    { 0x29AD2B2A, "helmetsidemodel" },
    { 0x0F7D5083, "helo" },
    { 0x91E53810, "helo_adjust_goal_for_enemy_height" },
    { 0xEE41514E, "helo_ambient_elements" },
    { 0x4DE4BE6F, "helo_audio_loopers" },
    { 0xA07738AF, "helo_destroyed_by_mortar" },
    { 0x421C6F06, "helo_find_new_position" },
    { 0xE2276EE5, "helo_icon" },
    { 0x3B8BEB47, "helo_rpg" },
    { 0x06C90E17, "helo_shot_down_by_rpg" },
    { 0xEAD144F2, "helos" },
    { 0x4E83DF80, "helotargetlocations" },
    { 0x65939E34, "help" },
    { 0x9F030794, "help_bowman_and_brooks" },
    { 0x7BDA789B, "help_game_end" },
    { 0x3F33025E, "help_kill_dist" },
    { 0x58C55E9D, "help_kill_dudes" },
    { 0xC189A3FF, "help_list" },
    { 0x1301DD8A, "help_menu" },
    { 0xE437B7BD, "help_on_last_frame" },
    { 0x13452A1B, "help_player_blow_barricade" },
    { 0x065B8C8B, "help_screen_height_fps" },
    { 0xEC75FB73, "help_screen_height_rts" },
    { 0xCD6917F6, "help_screen_width" },
    { 0x2D0241EE, "help_screen_x" },
    { 0x565E1EEB, "help_screen_y_fps" },
    { 0x3C788DD3, "help_screen_y_rts" },
    { 0xA31DFC6E, "help_spacing" },
    { 0x5DB66B3D, "help_the_player_area_trig" },
    { 0x5C62A3F0, "help_time" },
    { 0x2528AEC3, "helpdlg" },
    { 0x7BDBF1D7, "helped" },
    { 0x37A56CD1, "helper" },
    { 0xEA7F5B2D, "helper_guy" },
    { 0xD0BD0641, "helper_message" },
    { 0x99786BB8, "helpers" },
    { 0xA7E513B5, "helpful" },
    { 0xF5728D29, "helpgameend" },
    { 0x7EFF8AF4, "helping" },
    { 0x6AECE233, "helping_soldier" },
    { 0x3CCB4C22, "helping_soldier_names" },
    { 0xEC53ED27, "helps" },
    { 0xB28C1A81, "helptext" },
    { 0x102A5F18, "helth" },
    { 0xFCC7A39A, "helvetica" },
    { 0x242ED014, "hemires" },
    { 0x6D273C5E, "hence" },
    { 0x1625F5E2, "her" },
    { 0xE0F677B7, "herald" },
    { 0xA0D948EE, "heralds" },
    { 0x6E4ECF1A, "hercules" },
    { 0x6768DC02, "herd" },
    { 0x8D6B566B, "here" },
    { 0x054F7213, "here_it_comes" },
    { 0xBCB12C8C, "heree" },
    { 0x2EBDE660, "hereforth" },
    { 0x717A34E1, "hero" },
    { 0x3DE7D01A, "hero1" },
    { 0x870EB0DD, "hero1_node_name" },
    { 0x17E555B1, "hero2" },
    { 0xC2E8E952, "hero2_node_name" },
    { 0xF1E2DB48, "hero3" },
    { 0xFBF43427, "hero4" },
    { 0xD5F1B9BE, "hero5" },
    { 0x901C3455, "hero_a" },
    { 0x5B94FC48, "hero_ability_kill_event" },
    { 0xC656D563, "hero_ability_kill_events" },
    { 0x4F1EC14D, "hero_ability_multikill_event" },
    { 0x49291DCC, "hero_ability_multikill_events" },
    { 0x52B16B18, "hero_animate_at_horch" },
    { 0x42E82B74, "hero_append" },
    { 0xF6F77532, "hero_attacks_enemy" },
    { 0x2E0D60CD, "hero_call_sniper_pos" },
    { 0x89827D0F, "hero_catch_up_teleport" },
    { 0xBD1509CA, "hero_chain_start" },
    { 0xE3D84590, "hero_chain_trig" },
    { 0x61ABC45D, "hero_clientfield_power" },
    { 0xE96562FE, "hero_clientfield_power_flash" },
    { 0x8F407759, "hero_clientfield_state" },
    { 0x7C337349, "hero_color" },
    { 0xC060055A, "hero_customize_idle_anim" },
    { 0x05CAA110, "hero_dies_nowfail" },
    { 0x61ED2C7A, "hero_dive" },
    { 0xEB654191, "hero_downstairs_bb" },
    { 0x0198C6A2, "hero_drone" },
    { 0x4E08FDA7, "hero_drone_think" },
    { 0x999840DB, "hero_eland_scene" },
    { 0x01F9522C, "hero_finish_barwalk" },
    { 0x930FBBE4, "hero_gadget_activated" },
    { 0xE33E05DF, "hero_getup" },
    { 0xE4A9B630, "hero_give_ammo" },
    { 0xFAAB915D, "hero_guy" },
    { 0x33FF34B9, "hero_handle_ammo_save" },
    { 0x7EC14AE3, "hero_head_bone" },
    { 0xB445C1AC, "hero_helmet_bone" },
    { 0x0A722C3B, "hero_huey" },
    { 0x46547FE6, "hero_huey_copilot" },
    { 0x7E15DC56, "hero_huey_dust" },
    { 0x5EEA5B23, "hero_huey_glare" },
    { 0x206EFD07, "hero_huey_gunner" },
    { 0x58920EB0, "hero_huey_pilot" },
    { 0x1E2ABD80, "hero_jeep" },
    { 0x79749A35, "hero_jumping_out" },
    { 0x5F7047C5, "hero_liftbeam_torun" },
    { 0xE4418BBC, "hero_list" },
    { 0xBC425825, "hero_lobby_client_idle_anim" },
    { 0x1DA951EB, "hero_mannequin_anims" },
    { 0xB625CF61, "hero_maxpower" },
    { 0xB0B0F7BA, "hero_mesh_lods" },
    { 0xED55127B, "hero_minpower" },
    { 0x1996889B, "hero_model" },
    { 0x45D1CDD3, "hero_movement" },
    { 0x34B8FCE5, "hero_name" },
    { 0x94F3D61B, "hero_noammo" },
    { 0xFFE5CC93, "hero_nodes" },
    { 0x20A6C987, "hero_ondeath" },
    { 0x8E221E2C, "hero_ongameend" },
    { 0x38DFD13B, "hero_opendoor_2" },
    { 0x12DD56D2, "hero_opendoor_3" },
    { 0x619B5EF3, "hero_player" },
    { 0x71F5A14F, "hero_power" },
    { 0x344C251E, "hero_power_event" },
    { 0xEE417828, "hero_power_event_callback" },
    { 0x2FF8E129, "hero_power_prev" },
    { 0xD1E823C5, "hero_power_update" },
    { 0xB7F29145, "hero_rain_thread" },
    { 0x63700426, "hero_rappels_down" },
    { 0x571ECD1A, "hero_register_dialog" },
    { 0xCE8A30C7, "hero_restricted" },
    { 0x13E15461, "hero_run_anim" },
    { 0xDB56E6EC, "hero_save_ammo" },
    { 0xAD3D92CD, "hero_scripted_travel" },
    { 0x019C11EB, "hero_setup" },
    { 0xA1920FA2, "hero_setup_thread" },
    { 0x20BC5312, "hero_shutdown" },
    { 0x15633EB9, "hero_shutdown_gadget" },
    { 0x8A6147A6, "hero_spawned" },
    { 0xA691904B, "hero_spawners" },
    { 0xBD7C72A7, "hero_spawners_eventname" },
    { 0x5BE6733E, "hero_speak" },
    { 0xEA8E0E4F, "hero_start_spot" },
    { 0x05477413, "hero_start_structs" },
    { 0x586C3357, "hero_state_charging" },
    { 0x2E9DABE6, "hero_state_hidden" },
    { 0x62FF62EC, "hero_state_inuse" },
    { 0x7DB52803, "hero_state_ready" },
    { 0xF0753A6C, "hero_state_unavailable" },
    { 0xCD6CF15E, "hero_stumble" },
    { 0xC377B0F4, "hero_texture_lods" },
    { 0x52BBBF1B, "hero_throw_grenade" },
    { 0x8DE7217B, "hero_wait_byhole" },
    { 0xE436C20C, "hero_wait_for_death" },
    { 0x20226D3A, "hero_wait_for_game_end" },
    { 0x191559A7, "hero_wait_for_out_of_ammo" },
    { 0xE4764333, "hero_wakeup" },
    { 0x1C7FEFB0, "hero_weapon" },
    { 0xF830A2C5, "hero_weapon_bone" },
    { 0x925A9753, "hero_weapon_multikill_event" },
    { 0x7D770B82, "hero_weapon_multikill_events" },
    { 0xF59C6D9A, "hero_weapon_state" },
    { 0x98B960DE, "hero_weapon_success_reaction" },
    { 0xC5270749, "hero_wetness" },
    { 0x52482DE5, "heroability" },
    { 0xE4119D57, "heroability_off" },
    { 0x231BC03A, "heroabilityactivateneardeath" },
    { 0xF9AEBA09, "heroabilityactivatetime" },
    { 0xB54B427B, "heroabilityactive" },
    { 0x01E528E3, "heroabilitydectivatetime" },
    { 0xD138E7D9, "heroabilitymask" },
    { 0x0A297B2C, "heroabilityname" },
    { 0xF2750538, "heroabilityref" },
    { 0x352ED367, "heroabilitystat" },
    { 0x8FF45BEE, "heroabilitywasactiverecently" },
    { 0x6A876531, "heroes" },
    { 0x11F53658, "heroes3" },
    { 0xF60414CE, "heroes5" },
    { 0xA9FF1FFC, "heroes7" },
    { 0x074AF83A, "heroes_are_outside" },
    { 0xBF450511, "heroes_attack_enemies" },
    { 0x730B8E10, "heroes_attacking" },
    { 0xAFE0AE63, "heroes_breach" },
    { 0x515A7284, "heroes_controller" },
    { 0xB184B021, "heroes_cqbwalk" },
    { 0x4F0C1B52, "heroes_fighting" },
    { 0xEB895681, "heroes_force_teleport" },
    { 0x924036D1, "heroes_initial_loadout" },
    { 0xFEEFA699, "heroes_inpos" },
    { 0xE6428327, "heroes_load_jeep" },
    { 0xCF74AF85, "heroes_lock_in_place" },
    { 0x48DCDCAA, "heroes_make_invincible" },
    { 0x637F7271, "heroes_runto_boat" },
    { 0xCF59492B, "heroes_satchel_house" },
    { 0xBA173AFA, "heroes_stopidle" },
    { 0x7FED1A5B, "heroes_threatbias" },
    { 0x82109B34, "heroes_to_boat" },
    { 0xCF9E92B9, "herogadget" },
    { 0xB1394E3D, "herogadgetnotified" },
    { 0x59BA72FD, "heroic" },
    { 0xD99E7586, "heroic_death_nva" },
    { 0xD433C64A, "heroic_marine" },
    { 0x75159AE2, "heroic_nva_drop_wep" },
    { 0x6F6D3F83, "heroic_nva_fire_gun" },
    { 0x09C037E0, "heroname" },
    { 0xFCA0906F, "heroplaydialog" },
    { 0x72817588, "heros" },
    { 0xA76FF029, "heros_reach_to_rappel_spot_and_idle" },
    { 0x87AFA11D, "heros_shields_off" },
    { 0x8AE2A7D1, "heros_shields_on" },
    { 0xA15FA3F6, "heroshield" },
    { 0x83B38129, "herospot" },
    { 0xE60AA5B1, "heroweapon" },
    { 0x598122DE, "heroweapon_kill_power" },
    { 0x09341E29, "heroweaponequivalent" },
    { 0x6A936B17, "heroweaponhits" },
    { 0x3AE86DF1, "heroweaponkill" },
    { 0x10A64CAE, "heroweaponkillcount" },
    { 0x39C0D0AC, "heroweaponkillsthisactivation" },
    { 0xEDA1934D, "heroweaponmask" },
    { 0x86A740F0, "heroweaponname" },
    { 0xD8DFA09C, "heroweaponref" },
    { 0x6F75D638, "heroweaponshots" },
    { 0x958170A4, "heroweaponstable" },
    { 0x53462A44, "herr" },
    { 0x3C28704B, "hes" },
    { 0x3CE37025, "hesitance" },
    { 0x79DF2B0C, "hesitate" },
    { 0xFA34D458, "hex" },
    { 0x50B9BC44, "hexes" },
    { 0x20374EC1, "hey" },
    { 0x85E8F995, "hey_charlie_player_node" },
    { 0x97BC9347, "heycart" },
    { 0xAF121193, "hfrequency" },
    { 0xB8095772, "hg" },
    { 0x34221F8C, "hi" },
    { 0x8D4CD639, "hi_altitude" },
    { 0x7A400F8D, "hi_priority_target" },
    { 0xA6C4ACE5, "hickup" },
    { 0x1B0BB0F4, "hickups" },
    { 0x455E72A0, "hid" },
    { 0x0BFF506D, "hidden" },
    { 0xAD20E523, "hidden_compassicon" },
    { 0x219930C9, "hidden_in_foliage" },
    { 0x5A8DED57, "hidden_permanently" },
    { 0x95A12863, "hidden_terrain" },
    { 0x8EEB694E, "hidden_tow" },
    { 0x8A474667, "hidden_tow_gold" },
    { 0x4D6AC29C, "hidden_weapon" },
    { 0xCB04B29F, "hidden_worldicon" },
    { 0xF15BEDD5, "hiddenplayers" },
    { 0xC5489404, "hidding" },
    { 0x50CCEE8D, "hide" },
    { 0xEF38A287, "hide2crouch" },
    { 0x04ABC23C, "hide_3rdperson_ropes" },
    { 0x9FFB0222, "hide_ads_message" },
    { 0xB4054CEE, "hide_after" },
    { 0x49B26BF6, "hide_after_wait_time" },
    { 0x2CE01C56, "hide_ai_until_bridgewalk" },
    { 0x1F94DDBC, "hide_all_player_models" },
    { 0xDCB2B412, "hide_all_turret_bones" },
    { 0x0B1412E6, "hide_ammo_count" },
    { 0xBA72BD6C, "hide_and_remove_player_weapons" },
    { 0x43B257B6, "hide_and_seek_target" },
    { 0xE2B256E5, "hide_and_show" },
    { 0xA5E82CBD, "hide_and_show_additional_rockets" },
    { 0x9FAFFAB6, "hide_and_show_glowing_grass" },
    { 0xA8B63A65, "hide_armory_stuff" },
    { 0xA3FB8011, "hide_arms" },
    { 0x0DC0D1AE, "hide_at_pipe" },
    { 0xDBB65D27, "hide_at_pipe_02" },
    { 0xB5B3E2BE, "hide_at_pipe_03" },
    { 0x8BFD8BAD, "hide_at_pipe_node" },
    { 0xA91E4122, "hide_attack_back" },
    { 0xD5D98E16, "hide_attack_back_occurrence" },
    { 0x60271712, "hide_attack_forward" },
    { 0xB871757C, "hide_attack_left" },
    { 0xEDCE8064, "hide_attack_left_occurrence" },
    { 0x2063487B, "hide_attack_left_standing" },
    { 0x3E90D471, "hide_attack_left_standing_occurrence" },
    { 0xD2500676, "hide_banzai_deathquote" },
    { 0x562EFD9F, "hide_base" },
    { 0x8E10C551, "hide_beer_can" },
    { 0x74E03A51, "hide_behinder" },
    { 0x3DECA736, "hide_blood_stain" },
    { 0x7D8C80E4, "hide_body" },
    { 0x99E99470, "hide_body_tarp" },
    { 0xFE8AC645, "hide_body_tarp_start" },
    { 0x07E825FD, "hide_body_trigger" },
    { 0x30EED3E9, "hide_boxes_for_minigame" },
    { 0xE9BE79CE, "hide_briggs" },
    { 0x665C7206, "hide_brush_model" },
    { 0x101DA287, "hide_buildable_table_model" },
    { 0x8EE1567F, "hide_chest" },
    { 0x294C5F36, "hide_chest_sound_thread" },
    { 0x85977030, "hide_compass" },
    { 0x2800B934, "hide_comstat_objects" },
    { 0xED43139E, "hide_cracked_parts" },
    { 0x2F030B99, "hide_craftable_table_model" },
    { 0x3569779D, "hide_damaged" },
    { 0x8AD76565, "hide_data_element" },
    { 0x614979A8, "hide_destroyed_earth" },
    { 0xC91ED5EB, "hide_destroyed_model" },
    { 0x2490C125, "hide_diggers" },
    { 0xEA9602C1, "hide_distance" },
    { 0x92F820AC, "hide_dog_exits" },
    { 0x0A4038B1, "hide_dog_spawns" },
    { 0x587A65C2, "hide_door_buy_when_hacker_active" },
    { 0xBAABE828, "hide_door_left" },
    { 0x3B7DAE4A, "hide_door_left_warped" },
    { 0xCE8903F7, "hide_door_right" },
    { 0xB1B35D8C, "hide_earth" },
    { 0x22E9C2F4, "hide_enemy" },
    { 0x76AF038F, "hide_ent" },
    { 0xBE25A51A, "hide_equipment_hint_text" },
    { 0xC4A6160B, "hide_exploding_column" },
    { 0x81DD1DC1, "hide_fa38_elevator_fxanim_model" },
    { 0x6E4D4CAE, "hide_fish" },
    { 0x66C6F97B, "hide_for_target" },
    { 0xEADE1C23, "hide_freeway_collapse" },
    { 0x33F5156D, "hide_friendly" },
    { 0x027110C7, "hide_geo" },
    { 0xD7CCA954, "hide_glowing_rope" },
    { 0x443C4CA6, "hide_guards" },
    { 0xD8114D06, "hide_gump_loading_for_hotjoiners" },
    { 0x705C186E, "hide_harper" },
    { 0x7E5EA1E2, "hide_hatch" },
    { 0xE38AAC78, "hide_heli" },
    { 0xB85DD68F, "hide_helmet" },
    { 0x3E03341E, "hide_him" },
    { 0xC6E0AF1B, "hide_hint" },
    { 0xF9E5537B, "hide_hint_text" },
    { 0x4EDFE9FB, "hide_hint_when_hackers_active" },
    { 0x16A0B7FE, "hide_holo_table_props" },
    { 0x3A437449, "hide_hq_points" },
    { 0x87A4A08B, "hide_hud" },
    { 0xF8EAD0B0, "hide_hud_prompt" },
    { 0xE0E2D0FE, "hide_icon_distance_and_los" },
    { 0x785B0202, "hide_icons" },
    { 0x3A9A4F05, "hide_intact" },
    { 0x95386EAD, "hide_intro_boat_wake_effects" },
    { 0x315AE03D, "hide_intro_vtols" },
    { 0x5DF20049, "hide_laser" },
    { 0xD9E8B113, "hide_limo_burn" },
    { 0xFC91083E, "hide_masonjr" },
    { 0x7E3F55C1, "hide_masonjr_gun" },
    { 0xE54AA3CC, "hide_maze_fountain_water" },
    { 0xFA34ED42, "hide_me" },
    { 0x5ABA5037, "hide_me_make_me_notsolid" },
    { 0x9DB048D0, "hide_meteor" },
    { 0xDF11241A, "hide_mghut_dmg" },
    { 0x028BFB17, "hide_model" },
    { 0x7EBDBEB4, "hide_non_meat_objects" },
    { 0xDE8EF005, "hide_owner" },
    { 0x6C023F8A, "hide_paintshop_bg" },
    { 0xA4BE3C4F, "hide_part" },
    { 0xD44395AF, "hide_perks" },
    { 0xDE8895DA, "hide_phone_chloe" },
    { 0x230FEE4D, "hide_phone_kurtz" },
    { 0x4E1C91A5, "hide_phone_kurtz_returned" },
    { 0x427EB6B5, "hide_pilot_and_copilot" },
    { 0x07BBEE19, "hide_player_arms_underwater" },
    { 0x386EDC76, "hide_player_body" },
    { 0xAA52DDC0, "hide_player_body_for_courgar_fall" },
    { 0x9EA16A5F, "hide_player_body_in_intro" },
    { 0x683F8007, "hide_player_carry" },
    { 0x67E15619, "hide_player_hud" },
    { 0xF86E4FD9, "hide_player_ropes" },
    { 0x2DE88736, "hide_players" },
    { 0xAAF98C25, "hide_pop" },
    { 0x0E565DE9, "hide_post_grenade_room" },
    { 0x4DC9DD54, "hide_prison_blood" },
    { 0x87C785B8, "hide_progress_info" },
    { 0x5EA28AB3, "hide_prop" },
    { 0xE6600092, "hide_rain_fx_when_underwater" },
    { 0x2C2A05DA, "hide_rappelcrash02_for_brief" },
    { 0x492C2643, "hide_revive_message" },
    { 0x28786FE8, "hide_reznov" },
    { 0x00A2B29D, "hide_rock_model" },
    { 0x9DEFC1DA, "hide_rubble" },
    { 0x52094240, "hide_salazar" },
    { 0x9CF1AEDE, "hide_sam_turret" },
    { 0x017CBF47, "hide_savannah_rocks" },
    { 0x986639A5, "hide_scanner_gun" },
    { 0x7D9F3CCD, "hide_scene_names" },
    { 0xB9AE2C6F, "hide_secserv_01" },
    { 0x47A6BD34, "hide_secserv_02" },
    { 0x172B349E, "hide_show_start" },
    { 0x91D99D7A, "hide_show_vtol_parts" },
    { 0xF50A334C, "hide_sloth_barrier" },
    { 0x9A1BD6B3, "hide_smoke_grenades" },
    { 0xDEA4F465, "hide_spas" },
    { 0x70DCA8B4, "hide_spawnpoints" },
    { 0x1333A571, "hide_spiderbot_case" },
    { 0x32E60448, "hide_spot" },
    { 0x80834820, "hide_staff_model" },
    { 0x3D187708, "hide_startspawnpoints" },
    { 0x006AF953, "hide_static_column" },
    { 0x9540E861, "hide_static_door" },
    { 0xC441A93F, "hide_super_kill_bodies" },
    { 0x1EDDFFD1, "hide_surface" },
    { 0x06E21FFB, "hide_swimming_arms" },
    { 0x66CD4CD0, "hide_tablet" },
    { 0xB4A3BC70, "hide_temple_props" },
    { 0x3DF581CE, "hide_trig" },
    { 0x5EB48BE7, "hide_triggers" },
    { 0x1D4372D1, "hide_triggers_1st_floor" },
    { 0x76D9B72E, "hide_turret" },
    { 0x3FC6ECD2, "hide_turret_count" },
    { 0xC372B430, "hide_vehicle" },
    { 0xEC7BBD45, "hide_victory_grass" },
    { 0x1B27E3C3, "hide_view" },
    { 0xB6DCB992, "hide_viewmodel" },
    { 0x3B28659D, "hide_wall_chunks" },
    { 0x74EF352C, "hide_wallbuy" },
    { 0x5815AB75, "hide_waypoint" },
    { 0x8B1AAAFC, "hide_weapon" },
    { 0xD983BB0B, "hide_when_unavailable" },
    { 0x09BFBE14, "hide_window" },
    { 0x8A59B7AA, "hide_woods_ak47" },
    { 0x95166CA5, "hide_zone_objective_while_recapture_group_runs_to_next_generator" },
    { 0xF3D3DBF2, "hideactionbuttons" },
    { 0x1637172A, "hideafterwait" },
    { 0xBC8737DE, "hideall" },
    { 0x638AFC2F, "hideallcounteruavstosameteam" },
    { 0x02D4482D, "hideallentityheadicons" },
    { 0xC2EAD98D, "hideallperks" },
    { 0x22F9B11F, "hideallplayershudicons" },
    { 0xA6E0AC1F, "hidealluavstosameteam" },
    { 0xB82E4C21, "hideapart" },
    { 0x6C20FDFF, "hidearmswhenanimdone" },
    { 0x0CDFECB3, "hideaway" },
    { 0x88E375A3, "hidebanzaihint" },
    { 0x1BBDD434, "hidecompassafterwait" },
    { 0x1C9B77C1, "hidecompassonuse" },
    { 0x3A37C554, "hideelem" },
    { 0x1B3D5C61, "hidef" },
    { 0xE8347813, "hideflag" },
    { 0x7BCCC9EE, "hidefromteam" },
    { 0x2B69851E, "hidehelmet" },
    { 0x56D41164, "hidehudonnotify" },
    { 0x641B6957, "hideidle" },
    { 0x743093AB, "hidekillstreak" },
    { 0x8ACEE1D9, "hideline3full" },
    { 0xFF3F4614, "hideloadoutaftertime" },
    { 0xC7CD3259, "hideloadoutattribute" },
    { 0x2D6AC902, "hideloadoutondeath" },
    { 0xF669F4EC, "hideloadoutonkill" },
    { 0x39E86E4F, "hideloop" },
    { 0x6F8DA447, "hidemarker" },
    { 0xC6FD0A30, "hidemenu" },
    { 0x2ABE1E5F, "hidemeuntilflag" },
    { 0x0527ED14, "hidemodel" },
    { 0x7EB7BD94, "hideobject" },
    { 0xA88BB42E, "hideobjective" },
    { 0x60DEF683, "hideout" },
    { 0xEAC9A653, "hideoutcomeuiforallplayers" },
    { 0xF02EF84E, "hideoutpoints" },
    { 0xDB20C8D6, "hidepart" },
    { 0x74B6CB2D, "hideperk" },
    { 0x735ACE3D, "hideperknameaftertime" },
    { 0xD6E20F2C, "hideperks" },
    { 0x455D44A5, "hideperksaftertime" },
    { 0xFA06874F, "hideperksondeath" },
    { 0x94061373, "hideperksonkill" },
    { 0x5891E6AB, "hideplayerhudongameend" },
    { 0x44D89D94, "hider_spawner" },
    { 0x2D1D250C, "hides" },
    { 0xD3C9A4C8, "hidesafespawnmessage" },
    { 0x22295220, "hidescores" },
    { 0xAF174D97, "hidespawnpoints" },
    { 0x45D39795, "hidestartspawnpoints" },
    { 0x201670BE, "hidestaticmodel" },
    { 0xD543AE8E, "hidestatusslots" },
    { 0x8D9AD26F, "hidetag" },
    { 0xDEEAD00E, "hidetextonly" },
    { 0x01813CD2, "hidetimerdisplayongameend" },
    { 0x26C1B58B, "hidetoback" },
    { 0xFA923C5F, "hidetosameteam" },
    { 0x4EECB25F, "hideview_trig" },
    { 0x3C3596E5, "hideviewmodel" },
    { 0xF4DFE0CD, "hideweapon" },
    { 0xC6BCCB7F, "hidewhendead" },
    { 0x1A4C0425, "hidewhenindemo" },
    { 0x40DCE60D, "hidewheninkillcam" },
    { 0x5773C805, "hidewheninmenu" },
    { 0xF5D9EE81, "hidewhileremotecontrolling" },
    { 0xECCE422D, "hidewindow" },
    { 0xCE3BD217, "hideyawoffset" },
    { 0xEE22CD10, "hidezbarrierpiece" },
    { 0x73D2CA38, "hiding" },
    { 0x1027215B, "hiding_door" },
    { 0xA76545FF, "hiding_door_actor_damage" },
    { 0x607F2F78, "hiding_door_blindfire_loop" },
    { 0xDC6C65A0, "hiding_door_death" },
    { 0x0AFDBAA5, "hiding_door_death_door_connections" },
    { 0xADC1240F, "hiding_door_guy" },
    { 0x23BF7A3A, "hiding_door_guy_cleanup" },
    { 0x14895461, "hiding_door_guy_grenade_throw" },
    { 0x4CE756AD, "hiding_door_guy_pushplayer" },
    { 0xDAE98DDA, "hiding_door_leave_door" },
    { 0xCC86CD85, "hiding_door_play_scene" },
    { 0x25B947B6, "hiding_door_spawner" },
    { 0x58497064, "hiding_door_starts_open" },
    { 0x50ABEBCC, "hiding_door_stop_threads" },
    { 0x34E030C0, "hiding_guy" },
    { 0xF67F75C3, "hiding_log_dof_end" },
    { 0x641AA9B0, "hiding_log_dof_start" },
    { 0xC13E1593, "hiding_place_type" },
    { 0x56EAA751, "hiding_trig" },
    { 0x4863A857, "hiding_window" },
    { 0x4288E637, "hidinghudfornotify" },
    { 0x0DA02A66, "hierarchy" },
    { 0x15D70286, "higgins" },
    { 0xA13C9FD9, "high" },
    { 0xFC3F616E, "high_accuracy_guys" },
    { 0x6E0A61F6, "high_alert" },
    { 0xEEC86361, "high_alert_on_death" },
    { 0x82505AF4, "high_frac" },
    { 0x6425FDCD, "high_rumble_range" },
    { 0xB1959C71, "high_rumble_string" },
    { 0x929A6EB6, "high_score_count" },
    { 0x65F0B951, "high_val" },
    { 0xC331AE65, "high_value_target" },
    { 0x28E4059F, "high_wait" },
    { 0x0526880C, "high_weight" },
    { 0xF024885A, "highalertanim" },
    { 0x95122DA4, "highalertanimdeath" },
    { 0x366413F6, "highalertanimdeathloop" },
    { 0xB4D35500, "higher" },
    { 0x07205B58, "higher_number" },
    { 0x6065ACBF, "highest" },
    { 0x1DC61148, "highest_killstreak" },
    { 0x99B7D267, "highest_killstreak_level" },
    { 0xE33AB4B7, "highest_killstreak_type" },
    { 0x661C7E97, "highest_nodegroup" },
    { 0x48221AF2, "highest_num" },
    { 0x30AEDE05, "highest_objective_id" },
    { 0xE52F2F24, "highest_pitch" },
    { 0x3B4CA5D4, "highest_score" },
    { 0x47FD6F89, "highest_score_fog" },
    { 0x17B4EAD6, "highest_score_pistol" },
    { 0xC6BA19DF, "highest_score_vision" },
    { 0x1B2AA8A5, "highest_team" },
    { 0x0A6F3447, "highest_track" },
    { 0x4D7BCBB6, "highest_version" },
    { 0x92591E84, "highestgroup" },
    { 0x7A2A2FAF, "highestmapreached" },
    { 0x76A3AB82, "highestmomentumcost" },
    { 0x19A319A0, "highestplayer" },
    { 0x4F7DFE63, "highestpoint" },
    { 0xDEC0FEAF, "highestscore" },
    { 0x5A4931DF, "higheststance" },
    { 0x3F947853, "highestsupportedstance" },
    { 0x556F8E1E, "highestvalue" },
    { 0x9548D8DA, "highestwins" },
    { 0xF9FEFD9F, "highexitlandheight" },
    { 0xA1B61A44, "highground" },
    { 0x79DC9B21, "highground_history" },
    { 0x44598626, "highgroundpoint" },
    { 0x6829BBF7, "highgrounds" },
    { 0xC0710AB7, "highlight" },
    { 0x61262439, "highlight_icon" },
    { 0x2700658F, "highlight_object" },
    { 0x61F2506D, "highlight_player" },
    { 0xE8721F16, "highlight_thread" },
    { 0x459E92CF, "highlight_trace_next" },
    { 0x17C88A1F, "highlight_trace_result" },
    { 0x4CAAB37C, "highlighted" },
    { 0xF0EEAF6A, "highlighted_object" },
    { 0x18E8BA9C, "highlighted_struct" },
    { 0xE05D7FBB, "highlightedent" },
    { 0xEFC91BE9, "highlighting" },
    { 0x6ECEB1EE, "highlights" },
    { 0x62BA1884, "highly" },
    { 0xAEEFB550, "highlyawareradius" },
    { 0x5E57BFD2, "highpass" },
    { 0x5FD4B6C2, "highrise" },
    { 0xF79C86C2, "highrise_audio_custom_response_line" },
    { 0xB4A451FF, "highrise_chugabud_post_respawn_func" },
    { 0x23398604, "highrise_chugabud_reject_corpse_func" },
    { 0x0C080544, "highrise_chugabud_reject_node_func" },
    { 0xAAAEF0E7, "highrise_link_nodes" },
    { 0x804F773E, "highrise_pap_move_in" },
    { 0x387756F9, "highrise_pap_move_out" },
    { 0x80427B4D, "highrise_player_connect_callback" },
    { 0xEE7E3EE4, "highrise_post_respawn_callback" },
    { 0x6CB344B6, "highrise_respawn_override" },
    { 0xB7DF7F66, "highrise_sidequest_achieved" },
    { 0xB383EED3, "highrise_sq_started" },
    { 0xCB82B5B2, "highrise_unlink_nodes" },
    { 0x8586A3C7, "highrise_validate_enemy_path_length" },
    { 0x9466F4B0, "highrise_zone_init" },
    { 0x9A6F652D, "highscore" },
    { 0x387C7D2C, "highscores" },
    { 0x5046D89F, "highshelf" },
    { 0x6BA697C8, "highside" },
    { 0x2E96AD5A, "highspeed" },
    { 0x62B34B6F, "hight" },
    { 0xA4BDEA01, "highwater_global_stat" },
    { 0xC300F6AE, "highwater_map_stat" },
    { 0xE0C1DD0E, "highway" },
    { 0xDD0689A8, "highway_lamp_post" },
    { 0xA252938F, "highway_routes" },
    { 0xAEB84041, "highz" },
    { 0x61BCEA25, "hijack" },
    { 0xFFF294BB, "hijack_bridge_snapwatch" },
    { 0x8E9B8848, "hijack_done" },
    { 0x9ADE6A1D, "hijack_vo" },
    { 0xEAD96ABA, "hijackcrate" },
    { 0xC79C5212, "hijacked" },
    { 0x86960286, "hijacked_allied_bridge_spawnfunc" },
    { 0xA214F366, "hijacked_allied_spawnfunc" },
    { 0x4523D782, "hijacked_ambient_guys" },
    { 0x65C7F975, "hijacked_ambient_spawnfunc" },
    { 0x282BC3C9, "hijacked_anims" },
    { 0x032657EF, "hijacked_bridge_approach_save" },
    { 0xD621FEDD, "hijacked_bridge_building_swap" },
    { 0x240B0335, "hijacked_bridge_drone_crash" },
    { 0xC6D7EB41, "hijacked_bridge_enemies_clear" },
    { 0xCFCB0A3F, "hijacked_bridge_event" },
    { 0xD2790C08, "hijacked_bridge_explode" },
    { 0x89B23A16, "hijacked_bridge_fell" },
    { 0x3781C999, "hijacked_bridge_guys" },
    { 0x12963895, "hijacked_bridge_guys_move_up" },
    { 0xD900C19D, "hijacked_bridge_ledge_crumble" },
    { 0x0EA36534, "hijacked_bridge_ledge_delete_collision_clip" },
    { 0xEF3F0F5B, "hijacked_bridge_soldier_fall" },
    { 0x1543F280, "hijacked_bridge_swap" },
    { 0xE69F2AC4, "hijacked_building_battle_started" },
    { 0xC7010689, "hijacked_building_guys_exposed" },
    { 0x790B3087, "hijacked_cleanup" },
    { 0x68FBFC6A, "hijacked_crash_drone_near_player" },
    { 0xBB4AE0AC, "hijacked_destructibles_setup" },
    { 0x2F500FC4, "hijacked_drone_control_lost" },
    { 0xC6FD2D13, "hijacked_hostile_player_quadrotor_spawnfunc" },
    { 0x83DDBC59, "hijacked_hostile_quadrotor_spawnfunc" },
    { 0xAEAB6BA3, "hijacked_left_foreshadow" },
    { 0xB51373D6, "hijacked_magicbullet_shoot" },
    { 0xE308380B, "hijacked_menendez" },
    { 0xF86580D8, "hijacked_miniboss_clear_listener" },
    { 0x09C5C3B2, "hijacked_miniboss_done" },
    { 0xFBA5C06A, "hijacked_right_foreshadow" },
    { 0x9061ABE4, "hijacked_setup" },
    { 0x7D8779E2, "hijacked_setup_trees" },
    { 0xB2332C1D, "hijacked_skipto_quadrotors_init" },
    { 0x6F15B69B, "hijacked_skipto_salazar_init" },
    { 0x2B8FD2AD, "hijacked_skipto_setup" },
    { 0xDDEFFA09, "hijacked_suicide_drone_start" },
    { 0xD0FA5FE5, "hijacked_threat_bias_control" },
    { 0xA03AF093, "hijacked_vehicle_entity" },
    { 0xE4173183, "hijacking" },
    { 0x10F8414F, "hijackteamcrate" },
    { 0x482841D1, "hilarious" },
    { 0xF1EC3B34, "hill" },
    { 0x00A26EDF, "hill_angles" },
    { 0x2DF25EC8, "hill_fight_max" },
    { 0x07794A6E, "hill_nearest_node" },
    { 0x10A3C19A, "hill_obj" },
    { 0x14D4E685, "hill_radius" },
    { 0x7222C7FE, "hill_second_molotov_house_radius" },
    { 0x0A820F67, "hill_trans" },
    { 0xAD1D9026, "hillary" },
    { 0x10BEC4C3, "hillary_think" },
    { 0xD1BEACC2, "hillbattle" },
    { 0x149F49E0, "hillbump" },
    { 0xDBD31427, "hills" },
    { 0xE20886D5, "hillside" },
    { 0xED9B8777, "hillside_encounter" },
    { 0xDF1AE3AA, "hillside_fight_checkpoints" },
    { 0xFC86F7F0, "hillside_guys" },
    { 0x96320A7D, "hillside_guys_behavior" },
    { 0x3F19A8AD, "hillside_support" },
    { 0xB96BB5AD, "hilltop" },
    { 0xF9B02E45, "hilltop_friendly_orgs" },
    { 0x540EEBDD, "hilltop_mortar_team" },
    { 0xC70576E9, "hilltop_mortar_team_1" },
    { 0xED07F152, "hilltop_mortar_team_2" },
    { 0xFDF37E08, "hilltop_russian_leader_hangout" },
    { 0x468AEBC4, "hilltop_shoot_window" },
    { 0x92766071, "hilltop_sniper" },
    { 0x900D4CB0, "hilltop_sniper_moves_in" },
    { 0x31541696, "hilltop_woods" },
    { 0x9B74C051, "him" },
    { 0x96BD9BB5, "himf" },
    { 0x8B942E3F, "himself" },
    { 0xF195708A, "hind" },
    { 0x1EB99757, "hind1" },
    { 0xB1FAE17E, "hind1_attack_base" },
    { 0xCA716970, "hind1_behavior" },
    { 0xACB2281C, "hind2" },
    { 0xE0F134AD, "hind2_attack_base" },
    { 0x51103CE1, "hind2_behavior" },
    { 0x1BD65282, "hind_1" },
    { 0xC53EB338, "hind_approach_attack" },
    { 0x25650386, "hind_attach_crate" },
    { 0xCD101C21, "hind_attack" },
    { 0x709AC4BB, "hind_attack_base" },
    { 0x38F23A0E, "hind_attack_find_tow" },
    { 0x3843A688, "hind_attack_indefinitely" },
    { 0x16C8FDD4, "hind_attack_think" },
    { 0x86F17F20, "hind_attackbase_timer" },
    { 0xB4852BDE, "hind_baseattack" },
    { 0x88E6959E, "hind_bombplayer" },
    { 0xDF5F8106, "hind_bullet_only_used" },
    { 0x731A815E, "hind_charge_logic" },
    { 0x6B87D1C9, "hind_charge_shoot" },
    { 0xFCCEEE0D, "hind_clear_of_sam_zone" },
    { 0xCE2D8C4A, "hind_crash" },
    { 0xDAF6832E, "hind_crash_failsafe" },
    { 0xED6BA11F, "hind_crash_fx" },
    { 0xE0D04AA6, "hind_crashing" },
    { 0xFB353B13, "hind_damage_think" },
    { 0x422B46C7, "hind_dashboard" },
    { 0x3CA40672, "hind_dashboard_start" },
    { 0x6EBFE06F, "hind_dead" },
    { 0x6A5F2A32, "hind_death_fx" },
    { 0xA2464CD4, "hind_deploy_flares" },
    { 0x3FBCBEA9, "hind_destroyed_parts" },
    { 0xE84EBE95, "hind_dust" },
    { 0x2C157F77, "hind_dust_up_1" },
    { 0x28D662FB, "hind_dust_up_and_cooldown" },
    { 0xFC5DBBFA, "hind_earthquake" },
    { 0x277CEAEC, "hind_evade" },
    { 0x3D0E5A49, "hind_exit" },
    { 0xA3CA065B, "hind_exit_sequence" },
    { 0x39410289, "hind_falling_animation" },
    { 0x8D3ED409, "hind_fight" },
    { 0xD31C490F, "hind_fire_at" },
    { 0xA6C253D3, "hind_fire_missiles" },
    { 0xAEA2A345, "hind_fire_missiles_at_housing" },
    { 0x920AACC0, "hind_fire_while_hover" },
    { 0xB9479B06, "hind_fireat_target" },
    { 0x7762A2A3, "hind_fires_into_forest" },
    { 0x56A946DA, "hind_fires_rockets" },
    { 0x82D7C896, "hind_firing_rockets" },
    { 0x50642914, "hind_first_dust" },
    { 0xA58EA45A, "hind_fly_path" },
    { 0x9C0D2385, "hind_go_to_position_and_hold" },
    { 0xB4FDBD95, "hind_go_to_vent" },
    { 0x5790BE2D, "hind_guns_think" },
    { 0x8BC0A943, "hind_hit_run_scene" },
    { 0x6B8B3D1B, "hind_hold_postion" },
    { 0x038C4109, "hind_hover" },
    { 0x8525A8F2, "hind_interior_anims" },
    { 0x0D1DCBDD, "hind_intro" },
    { 0x1BD0B023, "hind_intro_target2" },
    { 0xCC5EC788, "hind_intro_think" },
    { 0xED60B67A, "hind_intro_think2" },
    { 0x399688F6, "hind_landing" },
    { 0x9CBB4751, "hind_list" },
    { 0x193CD1BA, "hind_lock_on_player_off" },
    { 0x10F46C6C, "hind_lock_on_player_on" },
    { 0x73163EA0, "hind_look_at" },
    { 0x62B1813F, "hind_missiles_fired" },
    { 0xC093DF65, "hind_missiles_impact_on_housing" },
    { 0x0E7B3109, "hind_on_snapshot" },
    { 0xF10F91CB, "hind_out_of_rockets" },
    { 0x42734CCD, "hind_periscope" },
    { 0x6F536B74, "hind_periscope_start" },
    { 0xAF357858, "hind_reach_goal" },
    { 0xA32B37A8, "hind_rocket_attack" },
    { 0x9CECF4A7, "hind_rocket_damage" },
    { 0x16C5C8F3, "hind_rocket_sequence" },
    { 0xE2CE9645, "hind_rocket_strafe" },
    { 0x7FADF0BF, "hind_rocket_target" },
    { 0xD933FF32, "hind_rockets_sp" },
    { 0xF83F4D56, "hind_sequence" },
    { 0x07471EEA, "hind_setup_rocket_attack" },
    { 0x8E77B639, "hind_shoots_the_tanker" },
    { 0x8FFB6D90, "hind_sniper_left" },
    { 0x7F02E8CF, "hind_spotlight" },
    { 0xE241B21C, "hind_spotted" },
    { 0x9C738800, "hind_start_battle" },
    { 0xC1B76B9B, "hind_start_firing" },
    { 0x945BA65B, "hind_start_path" },
    { 0x6EA0BDAA, "hind_starting_special_action" },
    { 0xB1467220, "hind_stop_attack_aftertime" },
    { 0x7045C2C0, "hind_strafe" },
    { 0x887A0463, "hind_strafe_fire" },
    { 0x1C761B3A, "hind_strafe_states_logic" },
    { 0x191BE6B3, "hind_tag" },
    { 0x60CB8092, "hind_takeoff_trigger" },
    { 0x3C369772, "hind_target" },
    { 0x87EBC627, "hind_target_and_fire" },
    { 0x52563E5B, "hind_top_light" },
    { 0xBEB4895B, "hind_top_light_break" },
    { 0x5C10679E, "hind_top_light_break_start" },
    { 0x12FC749E, "hind_top_light_start" },
    { 0x9B3FCCB5, "hind_tree_explosion" },
    { 0x01AFED9A, "hind_tree_fx" },
    { 0x6D9E366D, "hind_tree_rotate" },
    { 0x991BD1CC, "hind_trees_fall" },
    { 0xF8072C0D, "hind_truck_chase" },
    { 0xE390B2D4, "hind_truck_chase_attack" },
    { 0x4F40BFDE, "hind_truck_chase_behavior" },
    { 0x06D90CC2, "hind_truck_chase_logic" },
    { 0x2621F4E5, "hind_vehicle_damage" },
    { 0xE8ECCB6C, "hind_vs_hind" },
    { 0xAA05696F, "hind_vs_hinds" },
    { 0xEF0BCFD6, "hind_vs_hip" },
    { 0xDA216214, "hind_watch_rocket_fire" },
    { 0xC4D761E7, "hind_weapon_system" },
    { 0x11A1CEA9, "hind_weapons_think" },
    { 0x23DFB7CB, "hind_wire01" },
    { 0xF567D3EE, "hind_wire01_start" },
    { 0xB1D84890, "hind_wire02" },
    { 0x366547A5, "hind_wire02_start" },
    { 0x893A7FE7, "hindattacker" },
    { 0x0819E4E6, "hindenemy" },
    { 0x53533CC5, "hinds" },
    { 0x8A365A6B, "hinds_killed" },
    { 0x81578942, "hindset" },
    { 0x686F66E1, "hindsight" },
    { 0xCB92F621, "hing" },
    { 0xCA72FDCE, "hinge" },
    { 0xD14EE3B2, "hinge_breach" },
    { 0x9220FC00, "hinge_door_open" },
    { 0xB933C65B, "hinge_fx" },
    { 0xAED1D32D, "hinge_shot" },
    { 0xD95EC20E, "hinged" },
    { 0xBB2AB771, "hinges" },
    { 0x916DC9FA, "hint" },
    { 0xF68CD127, "hint_active" },
    { 0x8F36FC79, "hint_cooldown_ms" },
    { 0x8C042919, "hint_create" },
    { 0x8B33BE78, "hint_damage_type_watcher" },
    { 0xD58BC430, "hint_delete" },
    { 0x09C81627, "hint_fade" },
    { 0x77CAAE57, "hint_flag_drop_string" },
    { 0x82DCB326, "hint_flag_pickup_string" },
    { 0xFD5226ED, "hint_gambler" },
    { 0x897F4E54, "hint_given" },
    { 0xC8BE772B, "hint_grab" },
    { 0x0DF20691, "hint_grab_parm1" },
    { 0x4D9E6AF3, "hint_huds" },
    { 0x22B073F6, "hint_icon" },
    { 0xB869613A, "hint_lines" },
    { 0xD34AEE9D, "hint_menu_handle" },
    { 0xB87F3B45, "hint_message_create" },
    { 0x94E43A34, "hint_message_delete" },
    { 0xFEAD3503, "hint_missile_helper_check" },
    { 0xCE922CB0, "hint_model" },
    { 0x7A637612, "hint_more" },
    { 0x627D4143, "hint_over" },
    { 0xD10DB908, "hint_parm1" },
    { 0x43152843, "hint_parm2" },
    { 0xAC28DA98, "hint_position_internal" },
    { 0xC5A417BA, "hint_said" },
    { 0x4772939C, "hint_setup" },
    { 0x9D653082, "hint_string" },
    { 0xB15B61C9, "hint_string_override" },
    { 0xCA89CF0E, "hint_string_print" },
    { 0x364C55D0, "hint_string_shown" },
    { 0xAFD2BEEC, "hint_swap" },
    { 0x85E645A2, "hint_swap_parm1" },
    { 0x296821C3, "hint_text_display_height" },
    { 0x91C563EB, "hint_text_display_time_default" },
    { 0x6684A30D, "hint_text_removed" },
    { 0x254CEB20, "hint_text_size" },
    { 0xFE6229BC, "hint_text_turn_off_notify" },
    { 0xD77E85C5, "hint_text_while_in_trig" },
    { 0x2800C3B8, "hint_timer" },
    { 0x5EF4ADDE, "hint_trigger_think" },
    { 0xE32F7DB4, "hint_wrong" },
    { 0x41595982, "hintbackground" },
    { 0xB94BC8B3, "hintelem" },
    { 0x512A400B, "hintelem2" },
    { 0x44CF7E38, "hintfade" },
    { 0x8407D8E1, "hinticon" },
    { 0xB9897FB6, "hinting" },
    { 0x80EACD67, "hintmessage" },
    { 0xCD44ACC1, "hintmessagedeaththink" },
    { 0x163CBCA3, "hintmessageplayers" },
    { 0x9636E78B, "hintprint" },
    { 0xB038414B, "hintprintduration" },
    { 0xDFBEBCAC, "hintprintwait" },
    { 0xA35B8675, "hints" },
    { 0xD8691DF5, "hintshown" },
    { 0xCB060F47, "hintstrig" },
    { 0x5D25E13D, "hintstring" },
    { 0x8CD3E2FC, "hintstrings" },
    { 0x8556A807, "hinttext" },
    { 0x2464CB73, "hinttexthudelem" },
    { 0x3D9002D4, "hip" },
    { 0x43DE94B5, "hip1" },
    { 0xA6CA3396, "hip1_arena_behavior" },
    { 0x5722DCE8, "hip1_bp1_logic" },
    { 0x69C98B79, "hip1_dropoff_logic" },
    { 0x69E10F1E, "hip2" },
    { 0x1B5561BF, "hip2_arena_behavior" },
    { 0x15FD7D3A, "hip2_arena_land" },
    { 0xB0EF3F7F, "hip2_bp1_logic" },
    { 0x11316EFE, "hip2_dropoff_logic" },
    { 0x2B7573F9, "hip3_arena_land" },
    { 0x85719C93, "hip3_arena_manager" },
    { 0xE527C920, "hip3_behavior" },
    { 0xD8A18B31, "hip3_countermeasures" },
    { 0x090DC443, "hip3_dropoff_logic" },
    { 0xD870DB88, "hip3_guy_logic" },
    { 0x19193D0B, "hip3_leave_arena" },
    { 0xEA23C578, "hip3_replenish" },
    { 0x9F82A634, "hip4_arena_manager" },
    { 0x89E59505, "hip4_behavior" },
    { 0xF0C3CCBA, "hip4_countermeasures" },
    { 0x8CC67928, "hip4_dropoff_logic" },
    { 0x1960C3AB, "hip4_guy_logic" },
    { 0xBEF82C50, "hip4_leave_arena" },
    { 0xA69B088B, "hip4_replenish" },
    { 0x3A646DC8, "hip_1" },
    { 0xAC6BDD03, "hip_2" },
    { 0xF08A1206, "hip_ambient_arena_behavior" },
    { 0xD7F91662, "hip_arena_takeoff_logic" },
    { 0xFDBA7653, "hip_attack" },
    { 0x9E111048, "hip_attack_cache" },
    { 0x20DD8AA7, "hip_circle" },
    { 0xD281CB5C, "hip_crash" },
    { 0x162C6BCE, "hip_crash_begin" },
    { 0xFD58D989, "hip_dead" },
    { 0x52DAC65E, "hip_death_watcher" },
    { 0xE1614136, "hip_deploy_flares" },
    { 0xE9507FA6, "hip_evade" },
    { 0xA205782D, "hip_fire_required" },
    { 0x69FA6DE8, "hip_flyby_bp2" },
    { 0x9528D127, "hip_flyby_flares" },
    { 0xD96E79A8, "hip_flyby_shot" },
    { 0x47E14129, "hip_flyby_stingers" },
    { 0x4BA1D96B, "hip_heli" },
    { 0xD091B475, "hip_heli_tail_fx" },
    { 0xC95615A3, "hip_land_dropoff" },
    { 0x9C3C98F6, "hip_land_unload" },
    { 0x2C47046E, "hip_rappel_done" },
    { 0x0C334F37, "hip_rappel_unload" },
    { 0x0F44EF47, "hips" },
    { 0xD43CB002, "hips_arena_ambient" },
    { 0xA29CB2E1, "hips_killed" },
    { 0x527F03BA, "hiptagorigin" },
    { 0xAF97720F, "his" },
    { 0x56D621F3, "his_speed" },
    { 0x23A92CEA, "hiscore" },
    { 0x3995F8EE, "hisdudeness" },
    { 0x813148D6, "hiss" },
    { 0xF19ECE23, "history" },
    { 0x335F8BB3, "history_count" },
    { 0x5B947B7A, "history_index" },
    { 0x82BE2665, "historyindex" },
    { 0x214F5F40, "historysize" },
    { 0xA5861930, "hit" },
    { 0x4BD1D9D5, "hit_again" },
    { 0x069E4D28, "hit_anim" },
    { 0x2AD12D55, "hit_by_enemy" },
    { 0x5D480BDD, "hit_by_melee" },
    { 0xE260EB5E, "hit_by_player_array" },
    { 0x922D3854, "hit_by_rpg" },
    { 0x73C61515, "hit_by_tomahawk" },
    { 0xBA89D8DF, "hit_by_train" },
    { 0xCF122B80, "hit_by_wave" },
    { 0xA9CF7673, "hit_count_to_die" },
    { 0xA3FFFF71, "hit_counter" },
    { 0xAA67C0CF, "hit_current_skipto" },
    { 0x0D497ED8, "hit_damage" },
    { 0x87F13F9E, "hit_dudes" },
    { 0x765A9AB6, "hit_ent" },
    { 0xC7A5B906, "hit_entity" },
    { 0x3882063E, "hit_first_move_trig" },
    { 0x77E1C0B7, "hit_from" },
    { 0xD45D870E, "hit_geo" },
    { 0x69F80162, "hit_ground" },
    { 0xD2322937, "hit_info" },
    { 0x249C4F46, "hit_intensity" },
    { 0x3333C19F, "hit_loc" },
    { 0xD79828CA, "hit_location" },
    { 0x7DD9CFBF, "hit_node" },
    { 0xC43E6BD5, "hit_norm" },
    { 0xE59B31FE, "hit_officer_again" },
    { 0x8A2B6FE5, "hit_origin" },
    { 0x83E0FA88, "hit_player" },
    { 0x0CB68497, "hit_player_with_meat" },
    { 0xA1C7FED3, "hit_pos" },
    { 0x8AB6E896, "hit_position" },
    { 0x6E7BBF1C, "hit_radius_sq" },
    { 0x059FA6CD, "hit_rate" },
    { 0x593D3D07, "hit_rocket_fail_check" },
    { 0x72EB1FC4, "hit_rumble" },
    { 0x8794FD9C, "hit_sam" },
    { 0xBE589679, "hit_slomo" },
    { 0x75573743, "hit_success_listener" },
    { 0x98BEE98C, "hit_surface" },
    { 0x45C92D61, "hit_tag" },
    { 0x8EF36B40, "hit_target" },
    { 0xF65BF686, "hit_the_ground" },
    { 0x46B5C38B, "hit_trigger_by_name" },
    { 0x7803EC47, "hit_trigger_by_noteworthy" },
    { 0x21C0B504, "hit_vo_spacing" },
    { 0xBAC22017, "hit_wall" },
    { 0x75F169BB, "hit_warning_number" },
    { 0x786A36FF, "hit_zak" },
    { 0x075125EB, "hit_zakhaev" },
    { 0x84653154, "hitalias" },
    { 0x9E583A21, "hitbodyarmor" },
    { 0xE7B29727, "hitby" },
    { 0x9144AD34, "hitbyflameweapon" },
    { 0x5D2CBCF8, "hitbyplayervehiclethread" },
    { 0x82729EC9, "hitch" },
    { 0xC702B279, "hitches" },
    { 0x9FE9527F, "hitching" },
    { 0x82352EED, "hitcount" },
    { 0x2EEF80C6, "hitcountlauncherthreshold" },
    { 0x42F30D4C, "hitdest" },
    { 0x86F4E7A5, "hitdir" },
    { 0x6FE51603, "hitdirection" },
    { 0x1767EB64, "hitenemy" },
    { 0x084663FF, "hitent" },
    { 0x70CDCB71, "hitentity" },
    { 0x1DBCF329, "hitentnum" },
    { 0xD820AB99, "hitforce" },
    { 0xECDE4380, "hitfrom" },
    { 0x51FBC3A4, "hitindex" },
    { 0x8C1CEDA8, "hiting" },
    { 0xED6ACE03, "hitintensity" },
    { 0x9488D47D, "hitler_script" },
    { 0x07482416, "hitler_speak" },
    { 0x508909F2, "hitloc" },
    { 0x8C3953BA, "hitloc_all" },
    { 0xE9326A90, "hitloc_chest" },
    { 0x95599C84, "hitloc_groin" },
    { 0x9EA4F685, "hitloc_gun" },
    { 0x19F14413, "hitloc_head" },
    { 0x643205FA, "hitloc_helmet" },
    { 0xF79FB03B, "hitloc_hips" },
    { 0xA1270EAE, "hitloc_l_arm_lwr" },
    { 0xFE79954A, "hitloc_l_arm_upr" },
    { 0x9EFA779A, "hitloc_l_foot" },
    { 0x38ADD8F9, "hitloc_l_hand" },
    { 0xF6CFE238, "hitloc_l_leg_lwr" },
    { 0xFE4CFF48, "hitloc_l_leg_upr" },
    { 0x51AF9F35, "hitloc_left_arm" },
    { 0xF4F86D96, "hitloc_legs" },
    { 0xC74DBA2C, "hitloc_neck" },
    { 0xC5C48314, "hitloc_r_arm_lwr" },
    { 0xC6CF073C, "hitloc_r_arm_upr" },
    { 0x134291C0, "hitloc_r_foot" },
    { 0xEAC4E1A7, "hitloc_r_hand" },
    { 0xA07A5D96, "hitloc_r_leg_lwr" },
    { 0x76424782, "hitloc_r_leg_upr" },
    { 0xF1D4EBDE, "hitloc_right_arm" },
    { 0xB25E4A16, "hitloc_shield" },
    { 0xA901CF14, "hitloc_torso_lwr" },
    { 0x3D59C9DD, "hitloc_torso_mid" },
    { 0xAA0C533C, "hitloc_torso_upr" },
    { 0x33FDED15, "hitlocation" },
    { 0x50A6212C, "hitlocation_t" },
    { 0xCF4CF5E9, "hitlocationinfo" },
    { 0xDBDC6F64, "hitlocations" },
    { 0x8F66CDF7, "hitlocinited" },
    { 0x34CDBB7D, "hitlocs" },
    { 0xE892F396, "hitlog" },
    { 0x45E9299C, "hitman" },
    { 0x5FFE2C5E, "hitmarker" },
    { 0x99BC8E3A, "hitmax" },
    { 0x172A3FAE, "hitn" },
    { 0x37704D54, "hitnode" },
    { 0x272E07B1, "hitnoode" },
    { 0x775AFC89, "hitnormal" },
    { 0x604CBD09, "hitoffset" },
    { 0xA2DFE760, "hitp" },
    { 0x47336312, "hitpoint" },
    { 0x211C3A1D, "hitpoints" },
    { 0xEDC0B538, "hitpoints_loss_event" },
    { 0x7F37E5F2, "hitpointsleft" },
    { 0x73C6F93E, "hitpointsratio" },
    { 0x22C017DE, "hitpos" },
    { 0x1B50B86B, "hitposinbus" },
    { 0x64B68F01, "hitroundlimit" },
    { 0x057D80CB, "hitroundscorelimit" },
    { 0xA77DC09F, "hitroundwinlimit" },
    { 0x14E7569B, "hits" },
    { 0x8C66796F, "hits_taken" },
    { 0x418B6A33, "hitscorelimit" },
    { 0x0C56560C, "hitsomething" },
    { 0x9358B50D, "hitsound" },
    { 0x5711EF1B, "hitsoundtracker" },
    { 0x97AF17D8, "hitspot" },
    { 0xE71BF721, "hitspot1" },
    { 0x0D1E718A, "hitspot2" },
    { 0x3320EBF3, "hitspot3" },
    { 0xEC6EED74, "hitsthismag" },
    { 0xA9E6146F, "hitstodestroybmp" },
    { 0x5FF987F5, "hitstodestroyt72" },
    { 0x0D0E0E1C, "hittable" },
    { 0x822DA56A, "hittimes" },
    { 0xD84E3864, "hitting" },
    { 0x36AF612C, "hitwall" },
    { 0xDF1EEE42, "hitwithincendiary" },
    { 0x823D8381, "hitwithnapalmstrike" },
    { 0x32E95026, "hitzmroundlimit" },
    { 0x32D3C0AE, "hitzmroundwinlimit" },
    { 0x9E4B3DF0, "hitzmscorelimit" },
    { 0x5CFFDC90, "hive_gun" },
    { 0xB6665077, "hive_gun_splat_duration_max" },
    { 0x52353868, "hive_pod_hits_vs_killstreaks_and_robots" },
    { 0x0EBC2E56, "hiya" },
    { 0x30BCC500, "hiyeeah" },
    { 0x8027145E, "hk" },
    { 0x26B8F961, "hk21" },
    { 0xCDCFEDAF, "hkai_navmesh_material" },
    { 0x10536D8F, "hlnd_spectator_hud" },
    { 0x17E01E04, "hlo" },
    { 0x1011AE38, "hls" },
    { 0xCB226E8D, "hlth" },
    { 0x3C727D14, "hlth_dmg" },
    { 0x5A237EAF, "hm_link_origins" },
    { 0x6B404DB7, "hmg" },
    { 0x10CE52BE, "hmg_boat_challenge_tracking" },
    { 0x53152AEE, "hmgs" },
    { 0x3B2C7A6F, "hmo" },
    { 0x991137EC, "hmt" },
    { 0x55282C52, "hmtf" },
    { 0x31689AFC, "hmtx" },
    { 0xE81D2ABA, "ho" },
    { 0x1A08B24A, "hobbit_ai" },
    { 0x8AA18654, "hobbit_trigger" },
    { 0x8A269155, "hobbit_trooper" },
    { 0xB2281A5E, "hodge" },
    { 0xBA084B67, "hoen" },
    { 0xA2CBC621, "hog" },
    { 0x56C6D14F, "hoi" },
    { 0x9F218A96, "hoist" },
    { 0xFF9C2559, "hoist_done" },
    { 0x455BF883, "hoist_drop01" },
    { 0xD3548948, "hoist_drop02" },
    { 0xDA75F51D, "hoist_drop_audio" },
    { 0x4F8B0BF5, "hoist_pig_struct" },
    { 0x6373C4DF, "hoist_pig_struct_model" },
    { 0xB19F3F1B, "hoist_piggy" },
    { 0x298670AF, "hoist_rise01" },
    { 0xB77F0174, "hoist_rise02" },
    { 0x5C7990CB, "hoist_rise_audio_end" },
    { 0x130473E8, "hoist_rise_audio_start" },
    { 0x5A915482, "hol1_amb" },
    { 0x732C3B95, "hol1_anim" },
    { 0xFF327C6B, "hol1_asylum" },
    { 0x4205055D, "hol1_building_interrior" },
    { 0x9D3EB860, "hol1_fx" },
    { 0xC7FE1CA5, "hol1_outdoors" },
    { 0x9BE2490E, "hol1_rail" },
    { 0x0C9A6F50, "hol1_status" },
    { 0x7C535047, "hol1_stealth" },
    { 0xA88F3F88, "hol1_tunnel" },
    { 0x4883AF8E, "hol1_util" },
    { 0x42FE1664, "hol2" },
    { 0x7A27567B, "hol2_airstrike" },
    { 0x3AD54355, "hol2_amb" },
    { 0x8502C57C, "hol2_anim" },
    { 0xAD555156, "hol2_asylum" },
    { 0xC1A46134, "hol2_building_interrior" },
    { 0x089F0F82, "hol2_event1" },
    { 0xE29C9519, "hol2_event2" },
    { 0xBC9A1AB0, "hol2_event3" },
    { 0xC6AB738F, "hol2_event4" },
    { 0xE1E9CF2D, "hol2_fx" },
    { 0x4C05BAB0, "hol2_outdoors" },
    { 0x0935BAC1, "hol2_tunnel" },
    { 0xFEF2DCBA, "hol2ized" },
    { 0x690090CD, "hol3" },
    { 0x07CD7E18, "hol3_amb" },
    { 0x1416D1FF, "hol3_anim" },
    { 0xEC3100BF, "hol3_art" },
    { 0x2DC427F5, "hol3_asylum" },
    { 0xBBCB3D8F, "hol3_building_interrior" },
    { 0x8FD5F008, "hol3_callbacks" },
    { 0x2C0BCCAC, "hol3_defend" },
    { 0xFBFE163F, "hol3_end" },
    { 0xE87A8E3A, "hol3_fx" },
    { 0xA4DF7817, "hol3_outdoors" },
    { 0x234C2DFD, "hol3_street" },
    { 0x402C7BD7, "hol3_temp_kill_axis" },
    { 0x7B8D676E, "hol3_tunnel" },
    { 0xEA4ACBB0, "hol3_yard" },
    { 0xD6822DE2, "hold" },
    { 0x9F7D0891, "hold_angles" },
    { 0x961E1582, "hold_black_time" },
    { 0x10C2E50A, "hold_cannon" },
    { 0xB8F99E33, "hold_dialog_time" },
    { 0x25380D31, "hold_dist" },
    { 0xE9A8A2C5, "hold_fire" },
    { 0x5FF1FF0A, "hold_fire_chat" },
    { 0xE3D77AED, "hold_fire_debug" },
    { 0xA296C414, "hold_fordeath" },
    { 0xF6D579A0, "hold_indefintely" },
    { 0x2C103ED0, "hold_map_items" },
    { 0xCBE6BCDB, "hold_meat_monitor" },
    { 0x8FD0B8AF, "hold_origin" },
    { 0x87EDB3B7, "hold_player_for_salazar_ending" },
    { 0xFDD83DD8, "hold_position" },
    { 0x923C7302, "hold_required" },
    { 0x86B0FCAB, "hold_start" },
    { 0x52832501, "hold_static_time" },
    { 0x560173E6, "hold_time" },
    { 0x9E1CD7B0, "hold_timer" },
    { 0x980A143A, "hold_weapons_till_notify" },
    { 0xEA1477EE, "holdcameralastframe" },
    { 0x3F5950B3, "holder" },
    { 0xB1D64362, "holders" },
    { 0x5FB3C5FE, "holdfire" },
    { 0x9CFC5C6A, "holdflagentirematch" },
    { 0x095E238F, "holdfullstatic" },
    { 0x843CB1CE, "holding" },
    { 0x3C951546, "holding_placeable" },
    { 0x212549B4, "holding_position" },
    { 0x88AC562A, "holdingbuyableweaponupgrade" },
    { 0xCD3693B5, "holdingpistollikesmg" },
    { 0xE3DB9E9D, "holdingsmg" },
    { 0xCDC19B66, "holdingupgrade" },
    { 0x3D00D14E, "holdingweapon" },
    { 0x85109611, "holdouts" },
    { 0xA4072D04, "holdover" },
    { 0x4A74CCAD, "holds" },
    { 0x2B11E924, "holdswitchstatic" },
    { 0xFC84A84B, "hole" },
    { 0x6E24330B, "hole1_guys" },
    { 0xEDD88C3E, "hole2_guys" },
    { 0x2491BD34, "hole_fx" },
    { 0xF62C7EBF, "hole_pull_speed" },
    { 0x7D0361C5, "hole_struct" },
    { 0x26F0F055, "holed" },
    { 0x151127AA, "holes" },
    { 0x428B5A35, "holland" },
    { 0xCA50CD56, "hollding" },
    { 0xC0B6D57A, "hollers" },
    { 0xA30D41B7, "holmes" },
    { 0xE09386C1, "holo" },
    { 0x5A819149, "holo_city" },
    { 0xCE5D56A0, "holo_table" },
    { 0xF8148145, "holo_table_boot_sequence" },
    { 0x0E63E736, "holo_table_change_poi" },
    { 0x42C7779E, "holo_table_city" },
    { 0x16C9939C, "holo_table_exploder" },
    { 0xC7E8D587, "holo_table_exploder_switch" },
    { 0x5D8CEA1D, "holo_table_feature_prop" },
    { 0xFCA32A14, "holo_table_flicker_out" },
    { 0x58BA9DD5, "holo_table_get_selected_struct" },
    { 0x6F202DDC, "holo_table_get_table" },
    { 0x08471439, "holo_table_initialize" },
    { 0x56865599, "holo_table_prop_blink_on" },
    { 0x589D4809, "holo_table_render_pois" },
    { 0x0731972F, "holo_table_reset_display" },
    { 0x1E7E48E6, "holo_table_rotate" },
    { 0xDA9245F6, "holo_table_run" },
    { 0xB0103D2F, "holo_table_run_poi" },
    { 0x8B2E941B, "holo_table_scale_overtime" },
    { 0x5CBCCDC4, "holo_table_scale_overtime_reverse" },
    { 0x915C366B, "holo_table_screen" },
    { 0x5234692D, "holo_table_system_init" },
    { 0x0E308C4B, "holo_tables" },
    { 0x5945D3A4, "hologram" },
    { 0x1D475E7A, "hologram_city" },
    { 0xEBF83DBD, "hologram_defalco" },
    { 0x0A1C752E, "hologram_material_name" },
    { 0x488BD439, "hologram_menendez" },
    { 0x62BD1471, "hologram_start" },
    { 0x92C97F3A, "hologrammateialname" },
    { 0x3ECBF3D7, "holograms" },
    { 0xC885FBA7, "holotable" },
    { 0x3980217E, "holster" },
    { 0x7EE6B403, "holster_guns_on_approach" },
    { 0xB4BA4402, "holster_sidearm_switch_to_weapon" },
    { 0xD8121D10, "holster_weapon_switch_to_sidearm" },
    { 0x7C8A9861, "holsters" },
    { 0x64F68031, "holstertarget" },
    { 0x647ABEA7, "holy" },
    { 0xA15608CC, "home" },
    { 0xF06DBD97, "home_angles" },
    { 0xB30BD909, "home_breaker" },
    { 0xE7DBE24D, "home_enemy" },
    { 0xDADFB90E, "home_mine" },
    { 0xD689AC49, "home_origin" },
    { 0x84831AE0, "home_team" },
    { 0xD52850E4, "homemade_error" },
    { 0x4C0F87DB, "homepad" },
    { 0xA63CF1D0, "homepad_loop" },
    { 0xD98CD64F, "homes" },
    { 0x4A169A4C, "homies" },
    { 0x4EAB201A, "homing_beacon_vo" },
    { 0x4CB57870, "hon" },
    { 0xA9824E86, "honey" },
    { 0xBD004EFB, "honker_get_sound" },
    { 0x8CB0BE10, "honker_initiate" },
    { 0x34FC2F9B, "honker_think" },
    { 0x0C306605, "honker_thinking" },
    { 0x546931DF, "honkingvehicle" },
    { 0xC1DDC677, "honor" },
    { 0x9E01F392, "honorguard" },
    { 0xC592805E, "honorguard_combat_dialogue" },
    { 0xC7AF4DDF, "hood" },
    { 0x9FAE17CA, "hood_tag" },
    { 0x7BAA590D, "hoof" },
    { 0xEDB1C848, "hook" },
    { 0x0592008C, "hook_attach" },
    { 0x745D4FB6, "hook_detach" },
    { 0x24FB9C09, "hook_up_trig" },
    { 0xDC55AA4B, "hookah" },
    { 0xF098FB5B, "hooked" },
    { 0x15202594, "hookedup" },
    { 0xC5B27690, "hooking" },
    { 0xC9ABF963, "hooks" },
    { 0x80D86D68, "hookshot" },
    { 0x3B4D3E3F, "hookup" },
    { 0x5DEA4541, "hooligans" },
    { 0x56024F16, "hooooold" },
    { 0xC8C8378B, "hoooooooooooo" },
    { 0x8FCD0ACB, "hoop" },
    { 0xAC8CEBB6, "hoots" },
    { 0x00B0839E, "hop" },
    { 0x90C3E576, "hopchance" },
    { 0x323AE2E7, "hope" },
    { 0xA159FAE1, "hoped" },
    { 0x3559F1F5, "hopefully" },
    { 0xF1C652A0, "hopeless" },
    { 0xE4955BE5, "hopelessly" },
    { 0x31FB6D22, "hoping" },
    { 0x78EB619B, "hopper" },
    { 0xA9E1B846, "hopping" },
    { 0xAE53AB01, "hops" },
    { 0x3A8A1310, "hor_dir" },
    { 0xF815203B, "hor_length" },
    { 0x3EFBB9EA, "hor_normal" },
    { 0x859D4015, "horch" },
    { 0xDBFD25F7, "horch_anim" },
    { 0x20F56860, "horch_come" },
    { 0x751EDF69, "horch_movetag" },
    { 0x401DB840, "horchguy1_animate_dead" },
    { 0x609061AD, "horchguy1_setup" },
    { 0x9FB652C8, "horchguy1_stoploop" },
    { 0xE3AE7561, "horchguy2_chairanim" },
    { 0xE14E420A, "horchguy2_setup" },
    { 0x18516049, "horchguy2_stoploop" },
    { 0x88A81DD7, "horchhide_cutoff" },
    { 0xBDBEA428, "horchhide_done" },
    { 0x0033CACE, "horchhide_talk_count" },
    { 0x59AC1864, "horchs" },
    { 0x5B46E9CD, "horde" },
    { 0x2EEEEB59, "horde_kill_report" },
    { 0x3ABB9B70, "horde_run_clock" },
    { 0x1641DB8D, "horde_spawning_stopped" },
    { 0xF5409200, "horindex" },
    { 0x5642C134, "horizalign" },
    { 0xA2A44554, "horizdistsquared" },
    { 0xB4896176, "horizon" },
    { 0xC0C7020D, "horizon_flashes" },
    { 0xDC310FE6, "horizonal_spinners" },
    { 0xDEF34483, "horizonal_spinners_think" },
    { 0x142A1A8D, "horizontal" },
    { 0x84EC6381, "horizontal_align_center" },
    { 0x39D683D0, "horizontal_align_center_safearea" },
    { 0x5313FF21, "horizontal_align_default" },
    { 0x9B0C38A9, "horizontal_align_fullscreen" },
    { 0xEC64EFC9, "horizontal_align_left" },
    { 0x88156E98, "horizontal_align_max" },
    { 0xDCE204C3, "horizontal_align_noscale" },
    { 0x6FD8D0F4, "horizontal_align_right" },
    { 0x64284B6F, "horizontal_align_subleft" },
    { 0x0ACDDC41, "horizontal_align_to640" },
    { 0x338AE565, "horizontaldelta" },
    { 0x48430948, "horizontaldistance" },
    { 0xF32150B0, "horizontally" },
    { 0x1F6750F7, "horizontle" },
    { 0x5B0E90FA, "horn" },
    { 0xA8B3476D, "horn_audio" },
    { 0xA2EF7FB0, "horn_ent" },
    { 0x5AA379EE, "horn_struct" },
    { 0x35C38C5C, "hornets" },
    { 0x319AD38A, "horrible" },
    { 0x39694356, "horribly" },
    { 0x0549A330, "horse" },
    { 0x09160589, "horse1" },
    { 0xE11E59CA, "horse1_pos" },
    { 0x2F187FF2, "horse2" },
    { 0x911E1171, "horse2_pos" },
    { 0x04D6F598, "horse3_pos" },
    { 0xEC4139A7, "horse4_pos" },
    { 0xCCA696A2, "horse_actor_damage" },
    { 0x2F6FA8A0, "horse_ai_aim_anims" },
    { 0x48A9533E, "horse_ai_anims" },
    { 0x67042C39, "horse_allow_sprint" },
    { 0x31CAD0D9, "horse_animating" },
    { 0x46642AD4, "horse_animating_override" },
    { 0x06B9C5C3, "horse_anims" },
    { 0x4D63DE13, "horse_anims_inited" },
    { 0xFBEAC9B5, "horse_auto_kill_watch" },
    { 0xA656CA4B, "horse_breathing" },
    { 0x975A671B, "horse_charge" },
    { 0xF399ED5D, "horse_charge_clean_up_weapons" },
    { 0x6C2E230A, "horse_charge_event" },
    { 0xC4E404EC, "horse_charge_finished" },
    { 0xBEC48CDD, "horse_charge_line_up_event" },
    { 0xDE9E39AF, "horse_charge_muj1" },
    { 0x6C96CA74, "horse_charge_muj2" },
    { 0x929944DD, "horse_charge_muj3" },
    { 0x2091D5A2, "horse_charge_muj4" },
    { 0x5AC3BB61, "horse_choose_patrol_path" },
    { 0x8E52DCBB, "horse_colors" },
    { 0x0999CCD8, "horse_damage" },
    { 0x2964F76C, "horse_damage_panic" },
    { 0xFE262C9F, "horse_death" },
    { 0x9DE89EA3, "horse_death_nicaragua" },
    { 0x7AF31226, "horse_deaths" },
    { 0x7CFCF87A, "horse_deaths_explosive" },
    { 0x2C1E6E86, "horse_defender" },
    { 0x647E2BC0, "horse_dismount_anim" },
    { 0x3C5795AB, "horse_done" },
    { 0x35618FCA, "horse_eater_idles" },
    { 0x34492D85, "horse_facing" },
    { 0x421F3AB1, "horse_fallen" },
    { 0x3E1C2717, "horse_feet" },
    { 0x6CDC232C, "horse_fidget_1" },
    { 0xDEE39267, "horse_fidget_2" },
    { 0x87B8B4A7, "horse_fidget_sounds" },
    { 0x74CB2599, "horse_fire_anim" },
    { 0x40949770, "horse_follow_player" },
    { 0x0CC5C9E8, "horse_follow_truck" },
    { 0xF65AA6C1, "horse_fx" },
    { 0xDFE57244, "horse_has_rider" },
    { 0x7BA7480E, "horse_hitching_post" },
    { 0xF4310F78, "horse_idles" },
    { 0x4627D201, "horse_in_combat" },
    { 0x416E275C, "horse_intro_allow_sprint" },
    { 0xFD73C185, "horse_is_exit_position_ok" },
    { 0x8FA8A19F, "horse_jump" },
    { 0xB0A1FE63, "horse_model_variants" },
    { 0x425C066A, "horse_mount_anim" },
    { 0x33E0FD48, "horse_override_max_speed" },
    { 0xE32E4B94, "horse_panic" },
    { 0xA18A171D, "horse_patrol_path_1" },
    { 0xC78C9186, "horse_patrol_path_2" },
    { 0xED8F0BEF, "horse_patrol_path_3" },
    { 0xAC0AB3EF, "horse_patroller_behavior" },
    { 0x80314888, "horse_player" },
    { 0x2109ED1B, "horse_player_anims" },
    { 0xE291419C, "horse_rearback" },
    { 0xF9B45D63, "horse_reinforcement_behavior" },
    { 0xB626BEEF, "horse_remove" },
    { 0xE555EC5A, "horse_reverse_tether" },
    { 0x162848C1, "horse_ride_sync_count" },
    { 0x53E31ED6, "horse_rider_can_update_anim" },
    { 0x9F90330D, "horse_rider_setup_anim_funcs" },
    { 0x66A202DC, "horse_rider_update_idle_anim" },
    { 0x13C657D3, "horse_rider_update_rearback_anim" },
    { 0x18A8B014, "horse_rider_update_reverse_anim" },
    { 0x5CD50493, "horse_rider_update_run_anim" },
    { 0xDB6A57D1, "horse_rider_update_turn_anim" },
    { 0x244979A5, "horse_runaway_bp2" },
    { 0xA2B9AA66, "horse_set_avoidance" },
    { 0x8BF7C17A, "horse_setup" },
    { 0x06A70B54, "horse_shoot_wait_time" },
    { 0x4D64B7E7, "horse_spawn_disabled" },
    { 0x54C804B2, "horse_spawn_enabled" },
    { 0x3334B33D, "horse_spawn_func" },
    { 0x6B8E6053, "horse_speeds" },
    { 0x0290231C, "horse_sprint_anims" },
    { 0xA84316EB, "horse_sprint_idx" },
    { 0x9372748F, "horse_sprint_unlimited" },
    { 0xF4BAF7F4, "horse_stalk_player" },
    { 0x9D260057, "horse_stop" },
    { 0xA18EDB1B, "horse_stop_stalking_player" },
    { 0x66D7F437, "horse_strafe_controls" },
    { 0x1E38ED68, "horse_struct" },
    { 0x2D058E79, "horse_targetname" },
    { 0xD2060DF2, "horse_toggle_follow_behavior" },
    { 0x66113F3E, "horse_transition" },
    { 0x3620526B, "horse_turn180" },
    { 0x8035AF29, "horse_turn_speeds" },
    { 0xF804647C, "horse_unitdisperse" },
    { 0x6F47E4CA, "horse_unitdispersetolocation" },
    { 0x6FC3A029, "horse_update_reigns" },
    { 0xB9DF8454, "horse_viewmodel_variants" },
    { 0x053EA25D, "horse_wait_for_reigns" },
    { 0x910582E9, "horse_waittill_no_roll" },
    { 0xD7B16D86, "horse_walk_lineup" },
    { 0x29D8A9D4, "horse_watch_use_objective" },
    { 0xE5003E57, "horse_woods_runaway" },
    { 0x37537315, "horse_zhao" },
    { 0xBE95B989, "horse_zhao_runaway" },
    { 0xB5CB45B1, "horseback" },
    { 0x1F4A2BCF, "horsecallback_vehicledamage" },
    { 0x1CA5327B, "horsefootstepbones" },
    { 0x863E91E0, "horsehoe" },
    { 0x67BFE57D, "horselocs" },
    { 0x09B0979C, "horseman" },
    { 0xDF3F2BA8, "horsemen" },
    { 0xD5B9949B, "horses" },
    { 0x69477B16, "horses_after_krav_behavior" },
    { 0x6EA211EC, "horses_after_krav_down" },
    { 0x83E4D1D5, "horses_from_behind" },
    { 0xF8A10453, "horses_in_stable" },
    { 0x47D9A4A9, "horseshoe" },
    { 0x0F5DA325, "horshoe" },
    { 0xC0E3BB6C, "horz_align" },
    { 0x740218B1, "horzalign" },
    { 0x26203559, "horzanim" },
    { 0xB11FA976, "horzvelocityvariance" },
    { 0x502C53E6, "horzweight" },
    { 0xF7DA01C2, "hose" },
    { 0x1538F362, "hosed" },
    { 0xDEACE14C, "hoslter" },
    { 0x6CD7E0C7, "hospital" },
    { 0xBDB4D59B, "host" },
    { 0xCFAAC213, "host_ended_game" },
    { 0xCFC6D946, "host_migration" },
    { 0xAFEDC284, "host_migration_activate_visionset_func" },
    { 0xDDB7B79B, "host_migration_active" },
    { 0x47E173C8, "host_migration_begin" },
    { 0x0CB74264, "host_migration_countdown_begin" },
    { 0xEB15BE1B, "host_migration_deactivate_visionset_func" },
    { 0x3554B2FC, "host_migration_end" },
    { 0xA0A0888F, "host_migration_func" },
    { 0x05761225, "host_migration_listener" },
    { 0x247A0FC6, "host_migration_listener_custom_func" },
    { 0x0D783307, "host_migration_respawn" },
    { 0xE62307B4, "host_options" },
    { 0x0E5EB0C2, "host_options_development" },
    { 0xAF09B1B4, "host_options_dvar" },
    { 0x846149D6, "host_options_enabled" },
    { 0x9057F0E6, "host_options_enabled_dvar" },
    { 0xFF6B5545, "host_options_init" },
    { 0x23E6E0F1, "host_player" },
    { 0x05EF9C3E, "host_sucks_end_game" },
    { 0x00115BB9, "host_team" },
    { 0x39AD7378, "hostage" },
    { 0x2BD2FFBB, "hostage_hut_start" },
    { 0x8249A016, "hostage_timer" },
    { 0xD68B28D3, "hostages" },
    { 0xDB7E784B, "hostforcedend" },
    { 0xA0B93971, "hostidledout" },
    { 0x791D5D39, "hostile" },
    { 0xF7C2D7D6, "hostile_bathroom" },
    { 0xAFEF8A33, "hostile_bathroom_think" },
    { 0x65CE9301, "hostile_drones_timeout" },
    { 0x2D0542BC, "hostiledownbeingspoken" },
    { 0x1147DF70, "hostiles" },
    { 0xB679A75A, "hostilesspawned" },
    { 0x5A5B0805, "hosting" },
    { 0x6C1D04BD, "hostmigration" },
    { 0x377BD0AD, "hostmigration_ai_link_entity_callback" },
    { 0x11225A52, "hostmigration_enoughplayers" },
    { 0xDCF8A610, "hostmigration_link_entity_callback" },
    { 0xC303B23B, "hostmigration_occured" },
    { 0xB0EF837E, "hostmigration_put_player_in_better_place" },
    { 0x58C95257, "hostmigration_shared" },
    { 0x16988971, "hostmigrationawaremoveto" },
    { 0xA5AF66C5, "hostmigrationcontrolsfrozen" },
    { 0x7EC47890, "hostmigrationreturnedplayercount" },
    { 0x5F3B0FCC, "hostmigrationtimer" },
    { 0x41818ACC, "hostmigrationtimerthink" },
    { 0x36993D4C, "hostmigrationtimerthink_internal" },
    { 0xE2942B82, "hostmigrationwait" },
    { 0x07CD16B3, "hostmigrationwaitforplayers" },
    { 0xB21E4376, "hostname" },
    { 0x83F8F3EC, "hostplayer" },
    { 0x4437C9BA, "hosts" },
    { 0x98BCF614, "hostsucks" },
    { 0xCD6ED35B, "hosue" },
    { 0x68A699FA, "hot" },
    { 0x1F43AF97, "hot_key_buy" },
    { 0x191659C4, "hot_key_command" },
    { 0x154B7C9A, "hot_key_takeover" },
    { 0x8F4F9DD5, "hotel" },
    { 0xEC21B064, "hotel_0_spwn_fn" },
    { 0x9644CC31, "hotel_approach_wall_hole_damage_trigger" },
    { 0x0D72ABB2, "hotel_back_civ" },
    { 0xD24FDA9A, "hotel_back_civ_scenes" },
    { 0x366935FC, "hotel_blocker_soct_setup" },
    { 0x72137FFE, "hotel_civ" },
    { 0x194B9F75, "hotel_clean_up" },
    { 0x4192AEF3, "hotel_crash_chopper_drone1" },
    { 0x776D0616, "hotel_drone_condition_vo" },
    { 0x23A9AD92, "hotel_entrance" },
    { 0x8D28FBA6, "hotel_front_civ" },
    { 0xEC8633A6, "hotel_front_civ_scenes" },
    { 0xA867C4DF, "hotel_front_drone_0" },
    { 0x82654A76, "hotel_front_drone_1" },
    { 0xE20BFCA8, "hotel_left_garage_trigger" },
    { 0xCAC9A486, "hotel_look_org" },
    { 0xD83BBA72, "hotel_org" },
    { 0xC09D0CDC, "hotel_path_fail" },
    { 0xD7376A07, "hotel_rumble" },
    { 0x73E12A3D, "hotel_soct_shooter_damage_override" },
    { 0x0A0F791B, "hotel_st_billboard_magic_struct" },
    { 0xA9A5F789, "hotel_street_heli_think" },
    { 0x374DEAC5, "hotel_super_soct_condition" },
    { 0xA7B874FD, "hotel_super_soct_condition_vo" },
    { 0x1ECF5B4D, "hothandscount" },
    { 0xB33E334C, "hothandsweapon" },
    { 0xA1658083, "hothandsweaponswitched" },
    { 0xDBA6F33E, "hotjoin" },
    { 0x20AE5B37, "hotjoin_extra_blackscreen_time" },
    { 0xDBFDD66C, "hotjoin_player_setup" },
    { 0x4D9D9EE8, "hotjoin_setup_player" },
    { 0xBB2B7081, "hotjoined" },
    { 0xF7563242, "hotjoining" },
    { 0x80E3FE21, "hotjoins" },
    { 0xB710619F, "hotkey" },
    { 0x93A48126, "hotkeys" },
    { 0xD970BBFF, "hotness" },
    { 0x1E5986DB, "hotpotato" },
    { 0x56F050BF, "hotsauce" },
    { 0x2FDEA462, "hotshot" },
    { 0xA2E9BDB2, "hottest" },
    { 0x89C4FB61, "hotwire" },
    { 0x8EA91463, "hou" },
    { 0xA21A7EBB, "hour" },
    { 0xD153A815, "hour_hand" },
    { 0xF02041AF, "hour_hand_array" },
    { 0x759FA0C8, "hour_values" },
    { 0x70DFA15A, "hours" },
    { 0x80169452, "hours_ones" },
    { 0xAB050361, "hours_tens" },
    { 0xFA16AAFB, "house" },
    { 0xBDC4DB62, "house01_badguy01" },
    { 0xB7F76949, "house1_cleared" },
    { 0xAE972F44, "house1_to_house2_handler" },
    { 0x2BABAE2F, "house1_upstairs_dead" },
    { 0x29563BF6, "house2_start" },
    { 0xFF1F9AC6, "house2_start_spawners" },
    { 0x7EEAC2A0, "house2_to_griggs_handler" },
    { 0x46A3B20C, "house_7_burned" },
    { 0x06DA732C, "house_allies" },
    { 0x8319A298, "house_anims" },
    { 0x18DCA2B7, "house_assault" },
    { 0x28A12F0A, "house_blocker_delete" },
    { 0x6AD025AA, "house_blocker_off" },
    { 0xADB4637C, "house_blocker_on" },
    { 0x6A2EE10C, "house_blown_up" },
    { 0xC4FA7CA5, "house_breach_1" },
    { 0x158AD12E, "house_breach_dialogue" },
    { 0x53AB8D41, "house_chase_spawner" },
    { 0xF5BDC3AD, "house_clean_up_and_reset" },
    { 0x9D2E608C, "house_clip" },
    { 0x60AE08F3, "house_dest_clip" },
    { 0xCA1CC5A2, "house_drive_by" },
    { 0x99DEC736, "house_end_flag" },
    { 0xED9E9D8C, "house_event_backyard" },
    { 0x71510630, "house_event_end" },
    { 0x412D1EA9, "house_event_exit" },
    { 0xC05F05F6, "house_event_front" },
    { 0x9C4EA18B, "house_event_walk_to_shed" },
    { 0x56A4E2E5, "house_events" },
    { 0xF8E79EFB, "house_fail_retreat_after_reveal" },
    { 0xD0B2F168, "house_fail_stealth_if_running_around" },
    { 0x9BA456D0, "house_fallback" },
    { 0x8292EB12, "house_fire" },
    { 0x17F767BF, "house_fire_4_deaths" },
    { 0xFE7EC8A6, "house_fire_4_deaths_think" },
    { 0x54847560, "house_fire_5_deaths" },
    { 0xFE26C949, "house_fire_5_deaths_think" },
    { 0x3127B11A, "house_fire_7_deaths" },
    { 0x8B7C16CF, "house_fire_7_deaths_think" },
    { 0x38E1945C, "house_fire_9_deaths" },
    { 0x8E4E344D, "house_fire_9_deaths_think" },
    { 0x34B1C4CE, "house_fire_damage" },
    { 0x12F38D2D, "house_frontyard_obj" },
    { 0xAAAC9536, "house_guys" },
    { 0xBDBF5A0A, "house_guys_playerseek" },
    { 0x3983DFE1, "house_guys_set_bias" },
    { 0xD5BFA8EF, "house_ik_headtracking_limits" },
    { 0x89058D6E, "house_intro_setup" },
    { 0xE77BCE66, "house_objectives" },
    { 0x504A52C9, "house_patroller_death_function" },
    { 0x63F9FAEE, "house_player_at_exit" },
    { 0xE9FFF860, "house_radius" },
    { 0xB9B18FB7, "house_right_mgguy_strat" },
    { 0x3D81F50E, "house_sdk" },
    { 0x9E910ED4, "house_shutter_guys" },
    { 0x52B74500, "house_shutters" },
    { 0x5697A7A9, "house_target" },
    { 0x57287A2D, "house_warn_player_logic" },
    { 0x03CB2B65, "housed" },
    { 0xF0C8316B, "housefighting_begin" },
    { 0x8A0A0414, "housekeeping" },
    { 0x319C159A, "houses" },
    { 0x66B4605E, "housing" },
    { 0xFDDC9233, "housing_origin" },
    { 0x30A54523, "housing_trigger" },
    { 0xEBDE819D, "hover" },
    { 0xCA13656B, "hover_and_fire_at_entrance" },
    { 0x6BCE6D01, "hover_at_end" },
    { 0x9EC4D297, "hover_at_spline_end" },
    { 0x5D221639, "hover_heli_trigger" },
    { 0x84373DD7, "hover_huey" },
    { 0x59CD10D3, "hover_spots" },
    { 0x626420AB, "hover_time" },
    { 0x174C1B7C, "hovercorrectheight" },
    { 0xAD1F6EB7, "hoverents" },
    { 0x29B64090, "hovergoal" },
    { 0x0CBB3E8B, "hovering" },
    { 0x4E2BFB8D, "hovering_huey" },
    { 0x51484250, "hoveroverplayer" },
    { 0x76AAB685, "hoverpoint" },
    { 0x1B5428DC, "hovers" },
    { 0x2AC33762, "hoverwait" },
    { 0x42A41F91, "how" },
    { 0x7CEFD1C0, "how_close" },
    { 0xCBD89E19, "how_early" },
    { 0xC79143D0, "how_high" },
    { 0x57AE9BEE, "how_long" },
    { 0xDBABCCA9, "how_many" },
    { 0x601F9BFF, "how_many_istouching" },
    { 0x53AD60CF, "how_many_shots" },
    { 0xCC2C5BF9, "however" },
    { 0xF961AAC9, "howitzer" },
    { 0x21047A7F, "howl" },
    { 0x53B251EF, "howlong" },
    { 0x9568AB44, "howlongtodofinalstandfor" },
    { 0x2CFEACC5, "howlongtodolaststandforwithoutrevive" },
    { 0x7E4ECD19, "howlongtodolaststandforwithrevive" },
    { 0x70B50D7C, "howmany" },
    { 0x9C54134F, "howmanycanspawn" },
    { 0x7F94AC30, "howmanytospawn" },
    { 0x7CE1AF92, "howto" },
    { 0xEF6F15CE, "howto_hint" },
    { 0xE62C6FD5, "howtostring" },
    { 0x8A386D3D, "hp" },
    { 0xF4D2CCEC, "hp_alpha" },
    { 0x2513814C, "hp_inc" },
    { 0x5FF5C17C, "hp_mod" },
    { 0x78006F81, "hp_regen_per_frame" },
    { 0x8EDC7156, "hpeak" },
    { 0xA4C5D852, "hpm" },
    { 0xA708C165, "hpr" },
    { 0x810646FC, "hps" },
    { 0x6435F2D4, "hq" },
    { 0x709BB784, "hq2tv_red_starts" },
    { 0xE7F5AAE9, "hq2tv_start" },
    { 0xC5097C23, "hq2tv_start_spawners" },
    { 0xA6AE1490, "hq_area" },
    { 0xDDEE0E9C, "hq_breach" },
    { 0xD780ED05, "hq_breach_enemies" },
    { 0xA237E150, "hq_breachers" },
    { 0x15A63CF9, "hq_breachers_think" },
    { 0xD0DD3669, "hq_captured" },
    { 0x74A30441, "hq_cleared_move_up" },
    { 0xD5CCF178, "hq_destroyed" },
    { 0x5B3ED1B8, "hq_entered_wait" },
    { 0xC5A1F6E5, "hq_finished" },
    { 0x30DB22F7, "hq_initial_spawns_influencer_radius" },
    { 0x05598AF9, "hq_initial_spawns_influencer_score" },
    { 0xA070BE8D, "hq_initial_spawns_influencer_score_curve" },
    { 0x631DE6E5, "hq_is_contested" },
    { 0x7FCF2445, "hq_models" },
    { 0x2BA4858E, "hq_nearest_node" },
    { 0x36749DA0, "hq_objective_influencer_inner_radius" },
    { 0xF03CCB08, "hq_objective_influencer_inner_score" },
    { 0xF808C6BC, "hq_objective_influencer_inner_score_curve" },
    { 0x49B8B1F7, "hq_objective_influencer_radius" },
    { 0x117B1FF9, "hq_objective_influencer_score" },
    { 0x4CDDAB8D, "hq_objective_influencer_score_curve" },
    { 0xC76D7631, "hq_origin" },
    { 0xDF58C061, "hq_primary_lights" },
    { 0x552F0A65, "hq_radius" },
    { 0x8F036BDC, "hq_reset" },
    { 0x35FF40EC, "hq_rules" },
    { 0x07E78B1E, "hqautodestroytime" },
    { 0x6ED83D91, "hqdestroyedbytimer" },
    { 0xDECB0FD5, "hqdestroyedinenemystr" },
    { 0x4C8814F6, "hqdestroyedinfriendlystr" },
    { 0x2DA06F95, "hqdestroytime" },
    { 0x7834B445, "hqmainloop" },
    { 0x95680D77, "hqowningteam" },
    { 0xD1FC3DF8, "hqrevealtime" },
    { 0x1F74BC43, "hqspawninginstr" },
    { 0xBEE57ADE, "hqspawntime" },
    { 0x8BC689C4, "hr1" },
    { 0xFDCDF8FF, "hr2" },
    { 0x9DC7AB26, "href" },
    { 0x3B277710, "hrrmph" },
    { 0x586A18D6, "hrs" },
    { 0x15DF2CFA, "hrsx" },
    { 0x1C47EC35, "hschmitt" },
    { 0x824459E0, "hsnd" },
    { 0x0A8FE636, "hte" },
    { 0xA299CFDA, "hti" },
    { 0x7563CA96, "html" },
    { 0x62C3C10D, "http" },
    { 0x264552C2, "hub" },
    { 0x5CEAE4FA, "hub_a" },
    { 0x36E86A91, "hub_b" },
    { 0x10E5F028, "hub_c" },
    { 0x1AF74907, "hub_d" },
    { 0x61A6D837, "hub_none" },
    { 0xC151EC8B, "hub_num" },
    { 0x402A699E, "hub_number" },
    { 0x4BCDDD6C, "hub_start_func" },
    { 0x724A4794, "hud" },
    { 0x0518CEF5, "hud1" },
    { 0x28E08B50, "hud1_flashrate" },
    { 0x4778B04E, "hud1_scale" },
    { 0xAACB2CEE, "hud1_xpos" },
    { 0xB44B9CB9, "hud1_ypos" },
    { 0x2B1B495E, "hud2" },
    { 0xAC4E827D, "hud2_scale" },
    { 0xAB7A1A5B, "hud2_xpos" },
    { 0x71E5D748, "hud2_ypos" },
    { 0x1901FB66, "hud_array" },
    { 0x7087EC7F, "hud_beginusehudflagprogressbars" },
    { 0xFD83CF66, "hud_beginusehudflagprogressbarsforplayers" },
    { 0x89B8D748, "hud_bonus" },
    { 0x19374E70, "hud_boost" },
    { 0xD3E41456, "hud_bullets" },
    { 0x0BF8452B, "hud_categories" },
    { 0x5ED0E685, "hud_categories_axis" },
    { 0xE603AB74, "hud_color" },
    { 0xF49DA875, "hud_combined_score" },
    { 0x8E5DB4A9, "hud_create_bar" },
    { 0x454612DB, "hud_createflagprogressbar" },
    { 0x1AB1E6D2, "hud_createplayerflagelems" },
    { 0xDF9A309F, "hud_createplayersflagelems" },
    { 0x969EC482, "hud_current" },
    { 0xC90AF761, "hud_damagefeedback" },
    { 0xE07FFE0B, "hud_damagefeedback_additional" },
    { 0x4158CE40, "hud_damagefeedback_blue" },
    { 0x8B4FC7F2, "hud_damagefeedback_orange" },
    { 0x65D7ECB8, "hud_debug_add" },
    { 0x658513FF, "hud_debug_add_display" },
    { 0xDA7C28DB, "hud_debug_add_frac" },
    { 0x821070FC, "hud_debug_add_message" },
    { 0x27FE2739, "hud_debug_add_num" },
    { 0x7E960C05, "hud_debug_add_second_string" },
    { 0x6C35AD78, "hud_debug_add_string" },
    { 0xECF0CB72, "hud_debug_clear" },
    { 0x4E623FB7, "hud_debug_drone_count" },
    { 0xBCE86934, "hud_debug_drone_count_label" },
    { 0xB6CEDD2A, "hud_debug_timer" },
    { 0x63240438, "hud_destroyed" },
    { 0x61FB6C3C, "hud_dirt" },
    { 0x409B62A3, "hud_display" },
    { 0xDF0895CE, "hud_draw_score" },
    { 0x01B41652, "hud_draw_score_for_elements" },
    { 0xBEAEB5AA, "hud_elem" },
    { 0x89CD289B, "hud_elem_fade_in" },
    { 0xA3BA350E, "hud_elem_fade_out" },
    { 0x03015426, "hud_elem_icon" },
    { 0xBA9B454A, "hud_elem_interupt" },
    { 0xD03F3F65, "hud_elems" },
    { 0xAEE81175, "hud_end_reason" },
    { 0x116C31B6, "hud_ending" },
    { 0xAC315964, "hud_event_override" },
    { 0x603D1360, "hud_event_override_probability" },
    { 0xBB3D430D, "hud_fade" },
    { 0x7C58B2AD, "hud_fade_in" },
    { 0x10B37C97, "hud_fade_to_black" },
    { 0xCA222812, "hud_fire_wait_scale" },
    { 0x79FEA2BF, "hud_font_scaler" },
    { 0xEF0B291B, "hud_gadget" },
    { 0x0B744036, "hud_hardest2kill" },
    { 0xC6F1992B, "hud_heli" },
    { 0x249AEFE3, "hud_hide" },
    { 0xB2A0E7A3, "hud_hideflagprogressbar" },
    { 0xD2194E8C, "hud_hidehudforplayer" },
    { 0x6C118DD3, "hud_hideprogressandcountsforallplayers" },
    { 0x9B0DEDBC, "hud_icon" },
    { 0x22A49155, "hud_icon_alpha" },
    { 0x18DBC465, "hud_init" },
    { 0x0A850C89, "hud_items" },
    { 0x93A04057, "hud_kill" },
    { 0x0E99F1A7, "hud_ks_m202" },
    { 0x3EB3582A, "hud_letters" },
    { 0x7B79AD86, "hud_mantle" },
    { 0xC7C35B95, "hud_marked_target" },
    { 0x8476F328, "hud_marker_create" },
    { 0x4D476A30, "hud_message" },
    { 0x8A9B53A0, "hud_message_queue" },
    { 0xF90DF0D3, "hud_message_scroll_down" },
    { 0x3A5D1C54, "hud_message_shared" },
    { 0x5092C34B, "hud_minigun_create" },
    { 0x87A8C663, "hud_minigun_destroy" },
    { 0xEB314D75, "hud_minigun_think" },
    { 0xE626D677, "hud_mission" },
    { 0x124260AC, "hud_mission_score" },
    { 0x6A0B9DE8, "hud_missiondifficulty" },
    { 0xCCE807AB, "hud_missiondifficultyvalue" },
    { 0x81D92252, "hud_missionroundbonus" },
    { 0x1A845CC5, "hud_missionroundbonusvalue" },
    { 0x0B5B6D47, "hud_missionscore" },
    { 0xF1851926, "hud_missionscorevalue" },
    { 0x205A5C9D, "hud_momentum_progress" },
    { 0x59367135, "hud_momentumreason" },
    { 0xB63E6796, "hud_momentumupdate" },
    { 0x79266238, "hud_mortar_hint" },
    { 0x39223AD3, "hud_mostheadshots" },
    { 0xD5BC6B18, "hud_mostrevives" },
    { 0x94AF5B0A, "hud_msg" },
    { 0xB1D76481, "hud_msg_queue_clearall" },
    { 0x483DC019, "hud_mult" },
    { 0xC8478ED6, "hud_name" },
    { 0xD969A149, "hud_names" },
    { 0x0A32AEF7, "hud_newhighscore" },
    { 0x0CD61A9B, "hud_outline" },
    { 0x5B6B41CE, "hud_player_name" },
    { 0xA1869C2A, "hud_pointpulse" },
    { 0x7EA541E5, "hud_prompt" },
    { 0x1B691447, "hud_prompt_control" },
    { 0xB8714EA8, "hud_prompt_exit" },
    { 0x866F698E, "hud_radio_in_use" },
    { 0xC81EBD72, "hud_rankscroreupdate" },
    { 0x01732D0A, "hud_rocket_create" },
    { 0x23E5BD5C, "hud_rocket_destroy" },
    { 0x9586CD01, "hud_rocket_reset_m202" },
    { 0xA94A46B2, "hud_rocket_think" },
    { 0x011F82A1, "hud_satchel_deathwatch" },
    { 0xB231DABD, "hud_satchel_hint" },
    { 0x7170800D, "hud_scaleonly" },
    { 0x9A930B33, "hud_score" },
    { 0x9E6098E8, "hud_score_x_offset" },
    { 0x108990CE, "hud_scoreminusupdate" },
    { 0xBBD4E712, "hud_scoremulti" },
    { 0x0A22A830, "hud_scoreplusupdate" },
    { 0xCDB6DAE2, "hud_scores" },
    { 0xB5F43638, "hud_selector" },
    { 0xFE04E7E8, "hud_selector_fade_out" },
    { 0x895E5681, "hud_setflagprogressbar" },
    { 0x75E280E7, "hud_shaders" },
    { 0x2CB6EC38, "hud_shared" },
    { 0x2D800EE2, "hud_should_show" },
    { 0x96F0B600, "hud_show" },
    { 0x713B8AA3, "hud_show_warmap_available" },
    { 0xB41552B6, "hud_showflagprogressbar" },
    { 0x39512F53, "hud_showhudforplayer" },
    { 0x2ECDF436, "hud_showprogressbarforplayer" },
    { 0x1B20FEC1, "hud_showprogressbarsforallplayers" },
    { 0xBBC99A56, "hud_signal_indicator_blink" },
    { 0x11A4737A, "hud_signal_indicator_destroy" },
    { 0xD197243E, "hud_sizzle" },
    { 0x6CB43B88, "hud_stats" },
    { 0x89011F1C, "hud_string" },
    { 0xF451FA36, "hud_string2" },
    { 0x1A54749F, "hud_string3" },
    { 0x4E521DC3, "hud_surveillance_interference" },
    { 0x2BB78E12, "hud_surveillance_no_target" },
    { 0x0F9D5640, "hud_surveillance_recording" },
    { 0x432F9B01, "hud_surveillance_state_change" },
    { 0x44F338BF, "hud_target_blink" },
    { 0x0A1AB051, "hud_target_blink_off" },
    { 0xC16E5425, "hud_target_blink_on" },
    { 0xA54A397D, "hud_target_blink_timer" },
    { 0x78355DBF, "hud_threadedshowplayercountforallplayers" },
    { 0xB6472990, "hud_time" },
    { 0x299C0681, "hud_time_remaining" },
    { 0x2E330912, "hud_timer" },
    { 0x3E2C36F2, "hud_timer_colon" },
    { 0xA6C8D30F, "hud_title" },
    { 0x92DD1797, "hud_to_remove" },
    { 0xF76FDE28, "hud_total_score" },
    { 0xA5F5BBD2, "hud_total_score_points" },
    { 0xEAECF041, "hud_totalammo" },
    { 0x7CC3C2D8, "hud_transporter_flash" },
    { 0xDE2C0EC8, "hud_update" },
    { 0xF59A7D8F, "hud_update_score" },
    { 0xEF621AB1, "hud_update_vehicle_custom" },
    { 0x1ED78F39, "hud_updatehudparentingforplayer" },
    { 0xD7077DE9, "hud_util_shared" },
    { 0xC3077DA1, "hud_utility" },
    { 0x7B440784, "hud_utility_hide" },
    { 0x59C7B05A, "hud_utility_init" },
    { 0xA2164E9F, "hud_utility_show" },
    { 0x863CA7F2, "hud_value" },
    { 0x92687262, "hud_weaponname" },
    { 0x5F2F1CCB, "hud_word" },
    { 0x91B7D2E9, "hud_x" },
    { 0x6BB55880, "hud_y" },
    { 0xF912BA0C, "hud_y_size" },
    { 0xDDBCC7BB, "hud_z" },
    { 0x60130741, "hud_zero_deaths" },
    { 0x66DBA7E4, "hud_zoom_pcnt" },
    { 0x6A746E00, "hudalpha" },
    { 0x1CCBF243, "hudarray" },
    { 0xFCE3E50D, "hudbad" },
    { 0xEB0FB338, "hudbadtext" },
    { 0x27CBFC2D, "hudblack" },
    { 0x6AC669CB, "huddebugnum" },
    { 0x14FFD4E5, "hudelem" },
    { 0x6D920386, "hudelem1" },
    { 0xA2B3E562, "hudelem10" },
    { 0xC8B65FCB, "hudelem11" },
    { 0x56AEF090, "hudelem12" },
    { 0x478F891D, "hudelem2" },
    { 0x218D0EB4, "hudelem3" },
    { 0xFB8A944B, "hudelem4" },
    { 0xD58819E2, "hudelem5" },
    { 0xAF859F79, "hudelem6" },
    { 0x89832510, "hudelem7" },
    { 0xC3A85137, "hudelem8" },
    { 0x9DA5D6CE, "hudelem9" },
    { 0xC3AA3EA5, "hudelem_count" },
    { 0x12705C36, "hudelem_destroy" },
    { 0x9ABADEDF, "hudelem_destroyer" },
    { 0x694F2603, "hudelem_string" },
    { 0x2C5494F9, "hudelem_y" },
    { 0x3BF2B94F, "hudelements" },
    { 0x10B2F152, "hudelemicon" },
    { 0x38C290CE, "hudelemlist1" },
    { 0x12C01665, "hudelemlist2" },
    { 0xAD2B839C, "hudelempointer" },
    { 0xA22BA8F4, "hudelems" },
    { 0x53131098, "hudelm" },
    { 0x3E0B838B, "hudelm_unpause_ender" },
    { 0xCCC45DD3, "hudgood" },
    { 0xFA8013B6, "hudgoodtext" },
    { 0xE51BAC47, "hudhud" },
    { 0x5501BE3B, "hudimageincrease" },
    { 0xC7161E98, "hudimagesize" },
    { 0xDABBF06E, "hudimagespacing" },
    { 0x2A688868, "hudindex" },
    { 0xC1D0B1A9, "huditem" },
    { 0x32094A20, "huditems" },
    { 0xDF61241F, "huditemsoff" },
    { 0x59E2BBC7, "hudlinetext" },
    { 0xA3C44918, "hudmsgshare" },
    { 0x42450274, "hudnum" },
    { 0x3341D7BE, "hudnumai" },
    { 0x214C6693, "hudobj" },
    { 0x45AC76E3, "hudobj_changecolor" },
    { 0x98F769BE, "hudobjarray" },
    { 0x64FF60B2, "hudok" },
    { 0x69763ECF, "hudoktext" },
    { 0x230BC4BF, "hudon" },
    { 0x310026C6, "hudons" },
    { 0x71668A08, "hudpoor" },
    { 0xCC344D2D, "hudpoortext" },
    { 0x9643E8AC, "hudreticle" },
    { 0x21A2A494, "hudround" },
    { 0xD1BC5E07, "huds" },
    { 0x0AD66D38, "huds_come_on_mason_0" },
    { 0x21CFC58D, "huds_cover_woods_he_s_a_0" },
    { 0x3C70EF0A, "huds_fall_back_fall_back_0" },
    { 0xD701153B, "huds_we_gotta_fall_back_0" },
    { 0x9CF5472D, "huds_we_gotta_get_out_of_0" },
    { 0xB40C0546, "huds_woods_is_under_fire_0" },
    { 0x7AEA3D67, "hudshader" },
    { 0xC0313810, "hudshader_size_x" },
    { 0xE633B279, "hudshader_size_y" },
    { 0x381859E3, "hudskill" },
    { 0x46FF7838, "hudson" },
    { 0x044CF96E, "hudson_after_ladder" },
    { 0x0D557313, "hudson_after_log_anim_dialog" },
    { 0x771E0220, "hudson_anim" },
    { 0x65CC4EE4, "hudson_at_beach_evauation_point" },
    { 0x1C3453C6, "hudson_attack_node" },
    { 0xBE4B8BE7, "hudson_barge_think" },
    { 0xB1396832, "hudson_blood_pool" },
    { 0x0653C5B2, "hudson_breachroom_after" },
    { 0x36213DE9, "hudson_btr" },
    { 0xA6E0BAFC, "hudson_btr_hero" },
    { 0x92BC1AE7, "hudson_carry_blocker" },
    { 0x547CE1DB, "hudson_carry_woods" },
    { 0x761B971B, "hudson_carry_woods_vo" },
    { 0x10AF82B4, "hudson_catch_up" },
    { 0xCA76CE3E, "hudson_climb_up" },
    { 0x515093A5, "hudson_control_vision" },
    { 0x73E2CBD0, "hudson_cover" },
    { 0x4F62ABC7, "hudson_crouch_walk" },
    { 0x61B501CF, "hudson_damage_override" },
    { 0x970FB3A3, "hudson_delta" },
    { 0x43000721, "hudson_drops_off_woods_and_hudson_at_village_enterance" },
    { 0x8910E7A1, "hudson_enter_bunker" },
    { 0x2E8A45A2, "hudson_exits_water_and_climb" },
    { 0x19F8EDC3, "hudson_explplains_2_done" },
    { 0x1BB43B70, "hudson_final_scene" },
    { 0x2BDE9814, "hudson_fires_pistol" },
    { 0x2A46C1B4, "hudson_flood_dialog" },
    { 0xF23F57C8, "hudson_get_into_position_after_rock_blockage" },
    { 0x4451110F, "hudson_heli" },
    { 0x41AC9836, "hudson_heli_think" },
    { 0xBAA276EB, "hudson_idle_on_shore_started" },
    { 0x06C3C325, "hudson_in_office" },
    { 0xF3F7B0B3, "hudson_intro" },
    { 0x77A4AB38, "hudson_join_battle" },
    { 0xD884DE6B, "hudson_jungle_stealth_logic" },
    { 0x4791AE8E, "hudson_lab_kill_all_enemies" },
    { 0x9998DE26, "hudson_lab_last_stand" },
    { 0x636A33FF, "hudson_lab_left_window_drones" },
    { 0xEA34426D, "hudson_lab_left_window_drones_spawnfunc" },
    { 0x2E73F39F, "hudson_lab_objectives" },
    { 0x553A35CB, "hudson_lab_redshirts" },
    { 0x7D2845A9, "hudson_lab_redshirts_spawnfunc" },
    { 0xB1C984FC, "hudson_lab_right_window_drones" },
    { 0xFD0D285E, "hudson_lab_right_window_drones_spawnfunc" },
    { 0xBF790C54, "hudson_lab_rpg_left" },
    { 0xBBE4A506, "hudson_lab_rpg_left_spawnfunc" },
    { 0xF2651D8B, "hudson_lab_rpg_right" },
    { 0xEFF60469, "hudson_lab_rpg_right_spawnfunc" },
    { 0x94895946, "hudson_lab_scientists" },
    { 0x43F9ACAC, "hudson_lab_scientists_spawnfunc" },
    { 0x89B25C3A, "hudson_ladders" },
    { 0xD48A0D0E, "hudson_last_followup" },
    { 0x98FF0894, "hudson_move_with_woods" },
    { 0x69EE8EBC, "hudson_moves_to_dense_foliage_cover3" },
    { 0x285325AF, "hudson_nag_lines" },
    { 0xC354022B, "hudson_no_backpack" },
    { 0x39543227, "hudson_node" },
    { 0xD386E1CE, "hudson_notify_grenade_throw" },
    { 0x7E05404B, "hudson_path_chosen" },
    { 0x48F5573C, "hudson_post_map_room_hack" },
    { 0x1761F787, "hudson_punch_notify" },
    { 0x0D4953C1, "hudson_rally_goal" },
    { 0xDF8D6CD7, "hudson_redshirts" },
    { 0xD4D668E9, "hudson_sniper_spot" },
    { 0x6C0D2260, "hudson_split_up_loop" },
    { 0xB3D2C65D, "hudson_start" },
    { 0x3F7D8FD2, "hudson_start_2" },
    { 0x36C2C330, "hudson_start_angles" },
    { 0x9C877B1A, "hudson_start_org" },
    { 0xAFDB808C, "hudson_start_snapshot" },
    { 0x634699DF, "hudson_take_out_pistol" },
    { 0xA1EA58B0, "hudson_take_out_rifle" },
    { 0x6CC289CE, "hudson_threw_smoke_grenade" },
    { 0x1D7407F8, "hudson_throw_smoke_grenade" },
    { 0x9E0EB331, "hudson_throwing_smoke" },
    { 0x717CC93C, "hudson_throwing_smoke_grenade_vo_wave_1" },
    { 0xE3843877, "hudson_throwing_smoke_grenade_vo_wave_2" },
    { 0x848CCF29, "hudson_trigger" },
    { 0xC03448A4, "hudson_under_log" },
    { 0xC2A52384, "hudson_under_ship_movement" },
    { 0x37BD1C4A, "hudson_vc" },
    { 0x46A5DE2B, "hudson_vic" },
    { 0x9657E25F, "hudson_village_ahead_vo" },
    { 0x9FB332A6, "hudson_vo" },
    { 0x9218FECF, "hudson_vo_first_time" },
    { 0x3D9D055E, "hudson_vo_said" },
    { 0x515AE39C, "hudson_waiting_for_dense_foliage_move" },
    { 0x89DBBC7D, "hudson_waiting_for_stealth_move_to_house" },
    { 0xDB0B1035, "hudson_water_origin" },
    { 0x4C1E2C73, "hudsonand" },
    { 0x42202A07, "hudstring" },
    { 0x978C17E5, "hudsun_approaches_child_solider_encounter" },
    { 0xA0C0E9F2, "hudsupdisplay" },
    { 0x02C044E7, "hudtime" },
    { 0x16A05639, "hudtimerindex" },
    { 0xA46DD7AA, "hudtotal" },
    { 0x59A9AC97, "hudtotaltext" },
    { 0x66BB1BAB, "hudtweaks" },
    { 0x984CC1FD, "hue" },
    { 0xE876890D, "hue_city" },
    { 0xF3FDDFFB, "hue_city_ai_spawnfuncs" },
    { 0x6652D258, "hue_city_amb" },
    { 0x2137A73F, "hue_city_anim" },
    { 0xD992E385, "hue_city_anim_main" },
    { 0xFD11334E, "hue_city_anim_streets" },
    { 0x4AB654FF, "hue_city_art" },
    { 0x3222D2E1, "hue_city_event1" },
    { 0x84B90DDC, "hue_city_event1_reznov" },
    { 0x58254D4A, "hue_city_event2" },
    { 0x7E27C7B3, "hue_city_event3" },
    { 0xD4DDF06F, "hue_city_event_1_new" },
    { 0xA4965A7A, "hue_city_fx" },
    { 0x4C33B1BC, "hue_city_spas_switch" },
    { 0x88360746, "huey" },
    { 0x52E5CCA2, "huey0" },
    { 0x78E8470B, "huey1" },
    { 0x0C428B92, "huey1_end_point" },
    { 0x05E96631, "huey1_end_point_2" },
    { 0xFBB8F6DE, "huey1_idle_location" },
    { 0x79390DD5, "huey1_start_point" },
    { 0x6504DB5A, "huey1_start_point_2" },
    { 0x06E0D7D0, "huey2" },
    { 0x1921BFCD, "huey2_end_point" },
    { 0xDA126242, "huey2_end_point_2" },
    { 0x68D4A1A1, "huey2_idle_location" },
    { 0xC5F39FDA, "huey2_start_point" },
    { 0xA08369A9, "huey2_start_point_2" },
    { 0x2CE35239, "huey3" },
    { 0xEC341D4C, "huey3_idle_location" },
    { 0x2A5AD4A0, "huey3_support_start" },
    { 0xBE131692, "huey4_water" },
    { 0x1DDFEC74, "huey4_water2" },
    { 0xF348E726, "huey_1" },
    { 0x3BBB1DCD, "huey_1_crash_path_start" },
    { 0xCD466CBD, "huey_2" },
    { 0xBB20C818, "huey_2_crash_path_start" },
    { 0x13BFDAD6, "huey_a" },
    { 0xBC7E1620, "huey_ads_toggle" },
    { 0xCB8B2488, "huey_anim_reference" },
    { 0xEDBD606D, "huey_b" },
    { 0xC7BAE604, "huey_c" },
    { 0x3C5B4F2B, "huey_cleared_next_area" },
    { 0xD2FDC179, "huey_cockpit_interior_damage" },
    { 0x3498C79D, "huey_cockpit_interior_damage_all" },
    { 0xC43DF3A5, "huey_cone_light" },
    { 0xF1AC4E0F, "huey_copilot" },
    { 0xB8F2EB51, "huey_crash_effects" },
    { 0xA1B86B9B, "huey_d" },
    { 0x28FF2514, "huey_damage_cockpit_fx_based_on_health" },
    { 0x5263AB86, "huey_damage_cockpit_swap" },
    { 0xC542E5BF, "huey_damage_health_watch" },
    { 0xAC6E23DE, "huey_damage_player" },
    { 0x6AF97CF7, "huey_damage_think" },
    { 0x8D9002E9, "huey_death_explosion" },
    { 0xED410743, "huey_death_fade_out" },
    { 0x6F872A58, "huey_deaths" },
    { 0x58456811, "huey_debris01" },
    { 0x7E47E27A, "huey_debris02" },
    { 0xA44A5CE3, "huey_debris03" },
    { 0xCA4CD74C, "huey_debris04" },
    { 0xF04F51B5, "huey_debris05" },
    { 0x6B61DAAE, "huey_deck_support" },
    { 0x8B845017, "huey_difficulty_watcher" },
    { 0x173B71C9, "huey_do_very_damaged_feedback" },
    { 0x08A5598F, "huey_door_open_stage_1" },
    { 0xD6F8F52C, "huey_door_open_stage_1_loop" },
    { 0x969DEA54, "huey_door_open_stage_2" },
    { 0x9D235FB5, "huey_door_open_stage_2_loop" },
    { 0x9E28CD33, "huey_door_opens" },
    { 0xD46EE2D8, "huey_dropoff_node" },
    { 0x58E11A6C, "huey_ent" },
    { 0xD5269A5C, "huey_fire_mg" },
    { 0x8D11B5DA, "huey_fire_mg_no_target" },
    { 0x174050F2, "huey_fov" },
    { 0xA745AFD9, "huey_guys" },
    { 0xA046A295, "huey_health_take_damage" },
    { 0xEF829038, "huey_int" },
    { 0xB6773D6C, "huey_int_dmg_start" },
    { 0xAB7F8FEB, "huey_int_necklace" },
    { 0xCFA42BCE, "huey_intro_effects" },
    { 0x6D02E0CB, "huey_junk" },
    { 0xA59591CF, "huey_leaving" },
    { 0x43573BEF, "huey_models" },
    { 0x734D534C, "huey_name" },
    { 0x2036F4F2, "huey_number" },
    { 0xCF3A0671, "huey_parts" },
    { 0x6A7704E9, "huey_passenger_setup" },
    { 0x50528A02, "huey_peel_and_dropoff" },
    { 0x7A4BB679, "huey_pilot" },
    { 0x91FA522D, "huey_pilot_1" },
    { 0xF1D3A0CC, "huey_pilot_attach_point" },
    { 0x234D0B84, "huey_ramp_dmg_fx_up_and_down" },
    { 0xEFFFEEF7, "huey_rappel_tags" },
    { 0xE0F575F1, "huey_ready_to_die" },
    { 0xA875C8A1, "huey_regen_health" },
    { 0x6C5F42F3, "huey_riders_think" },
    { 0xA8A2F018, "huey_rocket_launcher" },
    { 0x9CFB2555, "huey_rocket_shoot" },
    { 0xBD090845, "huey_rpg_guys_support" },
    { 0x42A8B42D, "huey_save_restore" },
    { 0x8653C381, "huey_shoot_logic" },
    { 0x516A7C07, "huey_shoot_start" },
    { 0x9684987D, "huey_shoot_stop" },
    { 0xD74C6791, "huey_simple_control" },
    { 0xA006CC4A, "huey_squadron" },
    { 0xCD49B6EC, "huey_squadron_path" },
    { 0x82C5B30B, "huey_stop_shooting" },
    { 0x07A65555, "huey_stop_strafing_trigger" },
    { 0x5BAA4F74, "huey_strafe" },
    { 0x5AEDDE03, "huey_strafe_1_done" },
    { 0xD79413E6, "huey_strafe_path" },
    { 0xBF4920C3, "huey_support_begins" },
    { 0x96DB124C, "huey_support_vo" },
    { 0x0A58D0B2, "huey_switch_targets" },
    { 0x35E32077, "huey_tag" },
    { 0xAE62935C, "huey_target_death_listener" },
    { 0x56066BDE, "huey_troops" },
    { 0x3F5D0624, "huey_zoom_fov" },
    { 0x51B5357D, "hueydamage" },
    { 0xAC44B7F9, "hueys" },
    { 0x3142BB4B, "hueys_hit" },
    { 0x12F62A71, "hueys_onstation" },
    { 0x859F6F21, "hueys_onstation_path" },
    { 0xE451B6CF, "hug" },
    { 0x9DE2B1C3, "hug_ground" },
    { 0xBD4716B0, "huge" },
    { 0x5CDB12CC, "huge_ar_kill_index" },
    { 0xC108A878, "huge_kills_specialist_weapon_index" },
    { 0x1146B171, "huge_lmg_kill_index" },
    { 0x6A398612, "huge_melee_weapon_kill_index" },
    { 0xB500A85F, "huge_shotgun_kill_index" },
    { 0xC2343B38, "huge_smg_kill_index" },
    { 0x4363C310, "huge_sniper_kill_index" },
    { 0x616EEBEA, "huge_total_wins_index" },
    { 0x30F49839, "huge_total_wins_index_2" },
    { 0x0AF21DD0, "huge_total_wins_index_3" },
    { 0x150376AF, "huge_total_wins_index_4" },
    { 0xEF00FC46, "huge_total_wins_index_5" },
    { 0xC8FE81DD, "huge_total_wins_index_6" },
    { 0xA2FC0774, "huge_total_wins_index_7" },
    { 0xAD0D6053, "huge_total_wins_index_8" },
    { 0x6AF5B4B3, "huge_total_wins_index_grand_slam" },
    { 0x0A543138, "huh" },
    { 0xD88ED7F7, "hulk" },
    { 0xCE7D7F18, "hull" },
    { 0xB34A779B, "hull_dist" },
    { 0xF56BA588, "hull_target" },
    { 0x3F56799C, "human" },
    { 0xD8B6EE9D, "human_avg" },
    { 0xDB027A44, "human_bonus_period" },
    { 0x738807FA, "human_bonus_points" },
    { 0x373FD187, "human_cover_flankability" },
    { 0x6F8E90DB, "human_cover_flankable" },
    { 0xF14F22B8, "human_cover_unflankable" },
    { 0xA7B7D91C, "human_death_frequency" },
    { 0xB0ABB805, "human_enemies" },
    { 0xC4EED823, "human_facial_dialog_active" },
    { 0x87D007B0, "human_finish_bonus_points" },
    { 0xCB9E06D2, "human_locomotion_movement_default" },
    { 0x81018159, "human_locomotion_movement_patrol" },
    { 0x9C4347A7, "human_locomotion_movement_sprint" },
    { 0xCF2517DF, "human_locomotion_movement_type" },
    { 0x7DFBF8E2, "human_locomotion_variation" },
    { 0xC218F0D3, "human_player_kill_points" },
    { 0xEFB51BC3, "human_player_suicide_penalty" },
    { 0x2B47DC88, "human_ranks" },
    { 0xD53F75DB, "human_roadblock_guys" },
    { 0x1CF0AE44, "human_room_gas" },
    { 0x46A8AD5B, "human_score" },
    { 0x1735EF14, "humanclientutils" },
    { 0xEBCEF71A, "humancombatlocomotioncondition" },
    { 0x34BE32B1, "humancount" },
    { 0xE942528D, "humanexist" },
    { 0x354F8239, "humangibkilledoverride" },
    { 0xE85AA78A, "humangun" },
    { 0xAA6E1263, "humangun_director_hit_response" },
    { 0x0872E1CE, "humangun_hit_response" },
    { 0xFDED3A32, "humangun_leave" },
    { 0xC827664D, "humangun_zombie_1st_hit_was_upgraded" },
    { 0xB4517A3A, "humangun_zombie_2nd_hit_response" },
    { 0xE3CDA5E1, "humangun_zombie_hit_response" },
    { 0x1D84E0BA, "humanify" },
    { 0x9C570F91, "humanify_custom_loadout" },
    { 0x7B3E1876, "humanifying" },
    { 0xE044F1C5, "humanifyplayer" },
    { 0x5AD83C65, "humaninterface" },
    { 0x6A83BCD0, "humanity" },
    { 0x61380892, "humanized" },
    { 0x594056B1, "humannoncombatlocomotioncondition" },
    { 0x6E11AFC3, "humanriotshieldbehavior" },
    { 0xCBD97D62, "humanriotshieldinterface" },
    { 0x4CDBFE2B, "humanriotshieldserverutils" },
    { 0x6CD135FD, "humanriotshieldspawnsetup" },
    { 0x384A282F, "humanrpgbehavior" },
    { 0x2935CC06, "humanrpginterface" },
    { 0x221351DF, "humans" },
    { 0xF035CA0F, "humanshield" },
    { 0xF3AB53B4, "humanshield_player_weapon" },
    { 0xC7AE72A0, "humanshield_timer_kill" },
    { 0x8B5FBCD9, "humanshouldsprint" },
    { 0xBB62DF56, "humansoldierserverutils" },
    { 0x99CD565E, "humidity" },
    { 0xE958D617, "humiliated" },
    { 0x3FF0E00B, "hummer" },
    { 0x95AB865F, "hummersoundent" },
    { 0x06DF712C, "humongous" },
    { 0xAC49CC1A, "humor" },
    { 0x7ADC4E71, "humping" },
    { 0x42C1C32F, "humvee" },
    { 0xBC3BC134, "humvee50cal" },
    { 0x77B705CC, "humvee50cal_mp" },
    { 0xC637C285, "hunched_volume" },
    { 0x38E7533B, "hundred" },
    { 0x555226DA, "hundreds" },
    { 0xA5A9D105, "hung" },
    { 0x2BE75D40, "hunker" },
    { 0xC6FFA4FF, "hunkeranim" },
    { 0x6D6FDB04, "hunkerdown" },
    { 0x04C639D3, "hunkered" },
    { 0xEAAA56E3, "hunkereddown" },
    { 0xEA25CA37, "hunkerup" },
    { 0x6B84A4DE, "hunt" },
    { 0x118B20B3, "hunt_down_player" },
    { 0xDDA80A7D, "hunt_horse_behavior" },
    { 0x693FA5F0, "hunt_horse_spawn" },
    { 0xFC1FD3CA, "hunt_player" },
    { 0xFA7E61BB, "hunt_truck_behavior" },
    { 0x81399ED5, "hunt_truck_draw_target" },
    { 0xE1D38565, "hunt_truck_label" },
    { 0xC0627F4E, "hunt_truck_spawn" },
    { 0xAAC84768, "hunt_uaz_behavior" },
    { 0x15D80637, "hunt_uaz_spawn" },
    { 0xDA97AD21, "hunted" },
    { 0x4A0937AC, "hunted_amb" },
    { 0x66D2CD13, "hunted_anim" },
    { 0xF58E8163, "hunted_art" },
    { 0x53852D6B, "hunted_by" },
    { 0xCC6115D2, "hunted_by_sentinel" },
    { 0x81EC6839, "hunted_dive_2_pronehide_v2" },
    { 0x5BE9EDD0, "hunted_dive_2_pronehide_v3" },
    { 0x9D1BA24D, "hunted_flares_fire_burst" },
    { 0xF0F9FE76, "hunted_fx" },
    { 0x3A2E887E, "hunted_hp1_goingdown" },
    { 0xFD92D418, "hunted_hp1_maydaymayday" },
    { 0x0751CFBA, "hunted_intro" },
    { 0x21CD5325, "hunted_intro_dvars" },
    { 0x662131D8, "hunted_pronehide_2_stand" },
    { 0x0B4FF008, "hunted_pronehide_2_stand_v1" },
    { 0x7D575F43, "hunted_pronehide_2_stand_v2" },
    { 0x5754E4DA, "hunted_pronehide_2_stand_v3" },
    { 0x47E444E2, "hunted_pronehide_idle_v2" },
    { 0x6DE6BF4B, "hunted_pronehide_idle_v3" },
    { 0xADDCFCA4, "hunted_sas2_tooquiet" },
    { 0xE93EAB35, "hunted_style_door_open" },
    { 0xD8BB4921, "huntedcratelandoverride" },
    { 0x5E7EE507, "hunter" },
    { 0x06FB94DC, "hunter_attack_target_range" },
    { 0xB45CA624, "hunter_change_position_toattack_target_delay" },
    { 0x3BB0F8C1, "hunter_claimed" },
    { 0xF5A4219E, "hunter_collision_player" },
    { 0x0903A65E, "hunter_combat_speed_ratio" },
    { 0xF51F5F9F, "hunter_damage_amount_to_show_pain" },
    { 0x557E6B95, "hunter_drone_spawner" },
    { 0xB5C19EAF, "hunter_emped" },
    { 0x2B961BE0, "hunter_enable_attack_drones" },
    { 0x7682DF85, "hunter_enable_scanner_fx" },
    { 0xED185668, "hunter_enable_sideturrets_yield_mainturret_target" },
    { 0x1A26E6D5, "hunter_enable_weakspots" },
    { 0x55E65823, "hunter_exit_vehicle" },
    { 0xED543896, "hunter_fire_one_missile" },
    { 0x09F2DB2F, "hunter_following_target_range" },
    { 0x18FB105E, "hunter_frontscanning" },
    { 0x596B8091, "hunter_goal_point_step" },
    { 0xAEC8CB94, "hunter_halfheight" },
    { 0x4A1F0E84, "hunter_initialize" },
    { 0x49E9F3CA, "hunter_inittagarrays" },
    { 0x0295EE7D, "hunter_level_out_for_landing" },
    { 0x45BBE5DD, "hunter_lockon_fx" },
    { 0x5176D091, "hunter_lockontargetinsight" },
    { 0x5A14C09C, "hunter_lockontargetoutsight" },
    { 0x88BD853F, "hunter_missile_lockon_delay" },
    { 0x9DFDC592, "hunter_missile_minimal_interval" },
    { 0x620E9D85, "hunter_missile_weapon" },
    { 0x011DD707, "hunter_missile_weapon_player" },
    { 0xDD1DF31A, "hunter_pain_for_time" },
    { 0x020BCFEA, "hunter_pain_small" },
    { 0x57397BEC, "hunter_radius" },
    { 0xB3DF73A8, "hunter_scanner_clearlooktarget" },
    { 0x079426A0, "hunter_scanner_fov" },
    { 0xD92EDEF5, "hunter_scanner_init" },
    { 0xA3BF0829, "hunter_scanner_looktarget" },
    { 0xAAB09C2F, "hunter_scanner_pitch" },
    { 0x0DF06575, "hunter_scanner_range_pitch" },
    { 0xB290B2B2, "hunter_scanner_range_yaw" },
    { 0xEDB5ECFD, "hunter_scanner_scanspeed" },
    { 0x0FF25493, "hunter_scanner_settargetentity" },
    { 0x4406E447, "hunter_scanner_settargetposition" },
    { 0xC3843B7D, "hunter_scanner_tag" },
    { 0xFF2C418A, "hunter_scanner_view_distance" },
    { 0xB7946AA4, "hunter_scripted" },
    { 0x352E91DF, "hunter_seek_enemy_delay" },
    { 0xC2F7D68D, "hunter_self_destruct" },
    { 0x6506546E, "hunter_set_team" },
    { 0xF52E9192, "hunter_spawndrones" },
    { 0x20C7264D, "hunter_strafe_cooldown" },
    { 0xF69CA21E, "hunter_strafe_distance_to_enemy_distance_ratio" },
    { 0x5305CEB3, "hunter_strafe_speed_ratio" },
    { 0xDDA5866E, "hunter_turret_range" },
    { 0xBF95BCFF, "hunter_unaware_speed_ratio" },
    { 0xF47E4A8F, "hunter_update_rumble" },
    { 0xB3D525F0, "hunter_waittime_before_deploydrone" },
    { 0x8FFF56D4, "huntercallback_vehicledamage" },
    { 0x4EECAAFE, "hunters" },
    { 0x1BDD6578, "hunters_after_hero" },
    { 0x5D5405E6, "hunters_after_hero_infountain" },
    { 0x61621281, "hunters_on_hero" },
    { 0xF64BF449, "hunters_on_hero_infountain" },
    { 0x8CDDD362, "hunting" },
    { 0x3FFE80AE, "hunting_player" },
    { 0xB492D733, "hurdle" },
    { 0x28ECF901, "hurdle_rusher" },
    { 0xE167794B, "hurdler" },
    { 0xFA5313BA, "huristic" },
    { 0xEA70AF3A, "hurl" },
    { 0x051F2A2E, "hurray" },
    { 0x93DE8CAD, "hurry" },
    { 0x8F804B3E, "hurryup" },
    { 0x1A848282, "hurt" },
    { 0x830A47AF, "hurt_trigger" },
    { 0x61787735, "hurt_trigger_immune_end_time" },
    { 0x7D1BC4F6, "hurt_triggers" },
    { 0x1428596A, "hurtagain" },
    { 0xB18E0ECF, "hurtattacker" },
    { 0x5A2C8B56, "hurtgen_style" },
    { 0xF22AE26C, "hurthealth" },
    { 0x4C086446, "hurtling" },
    { 0x209F8744, "hurtme" },
    { 0x22D95626, "hurtnode" },
    { 0xE099CF3D, "hurttime" },
    { 0x7EDF5CD5, "hurttriggers" },
    { 0x85182B6A, "hurtvictim" },
    { 0x873C2002, "husk" },
    { 0xE072FD92, "husk_cleanup_t" },
    { 0xF7A07937, "husk_do_cleanup" },
    { 0x54C338D8, "husk_model" },
    { 0x1FCB8F4D, "husks" },
    { 0x69EEC524, "hustle" },
    { 0x1222A104, "hut" },
    { 0x62B6DEED, "hut01" },
    { 0xD84FCED4, "hut01_start" },
    { 0xAE0D16B5, "hut1_splash" },
    { 0x81EA9C34, "hut4_hit_hut" },
    { 0x2B4FBE55, "hut_4_exp" },
    { 0x5A3135F8, "hut_approach_clip" },
    { 0x06E4FA8E, "hut_baddies_logic" },
    { 0xBFFA2311, "hut_battle" },
    { 0x1805EE2C, "hut_breach" },
    { 0xEB739905, "hut_breach_ended" },
    { 0x8B997325, "hut_breach_go" },
    { 0x1D28FE45, "hut_breach_trigger" },
    { 0x8B38E966, "hut_clean" },
    { 0x1420FCA9, "hut_clear_monitor" },
    { 0x2BDCE10D, "hut_cleared" },
    { 0xA96B62C8, "hut_destroyed" },
    { 0xEE90EF7E, "hut_door_closed" },
    { 0x17994C27, "hut_explo" },
    { 0xB98FD0B1, "hut_explo_fires" },
    { 0xEA7AC8CE, "hut_explode" },
    { 0xF2D5A303, "hut_explode1" },
    { 0x80CE33C8, "hut_explode2" },
    { 0x2230ADF9, "hut_explode_jeep" },
    { 0xB031F5E8, "hut_explode_jeep_start" },
    { 0x527F93EF, "hut_explode_start" },
    { 0xE59EAA6D, "hut_friendlies_chats_about_russians" },
    { 0xE0E0C912, "hut_fxanim" },
    { 0x6DCD3502, "hut_fxanim_notify" },
    { 0x99EE7947, "hut_guys" },
    { 0x389096DB, "hut_heli" },
    { 0x138E886A, "hut_kill_done" },
    { 0x072E42C0, "hut_kill_player_override" },
    { 0xD33F9318, "hut_kill_triggers_hit_first_time" },
    { 0x15DC392D, "hut_obj_org" },
    { 0xB722B281, "hut_origin" },
    { 0xEDE655D5, "hut_patrol" },
    { 0x626C744E, "hut_patroller" },
    { 0xF60AC588, "hut_patroller_passed_window" },
    { 0x77F7F5CD, "hut_runner" },
    { 0xF959AB38, "hut_runner_think" },
    { 0x711415A2, "hut_sentry" },
    { 0x93159FC5, "hut_think" },
    { 0x59BD1FDD, "hut_trig" },
    { 0x18AF3559, "hut_tv" },
    { 0x0202E47D, "hutch" },
    { 0x21C4A7B7, "huts" },
    { 0x3FA0F5A0, "hvi" },
    { 0x8DE8D385, "hvt" },
    { 0xE289B2A0, "hvy_truck" },
    { 0xF15DBAFA, "hwy_drone_0_logic" },
    { 0xBC080108, "hwy_soct_3_logic" },
    { 0x7137711D, "hya" },
    { 0xBB51B557, "hybrid" },
    { 0xFB0A3E0D, "hydrant" },
    { 0x213AA964, "hydraulic" },
    { 0x18541EB1, "hydro" },
    { 0x74751CA1, "hyper" },
    { 0x61229863, "hyperdrive" },
    { 0x70E44BF3, "hypersonic" },
    { 0x92ACF7F4, "hyperspacein" },
    { 0x7F074C64, "hypocritical" },
    { 0x06513557, "hz" },
    { 0xC957F6B6, "i" },
    { 0x3EFD7800, "i2" },
    { 0xA72A056A, "i_am_down" },
    { 0xF6792E30, "i_am_the_drone" },
    { 0xFE8CBC09, "i_amount" },
    { 0x70905731, "i_amt" },
    { 0xE9AC9C20, "i_direction" },
    { 0xC505C05E, "i_dmg_type" },
    { 0x0DC2C212, "i_dont_think_they_exist" },
    { 0xD30AA291, "i_dont_want_to_hurt_you" },
    { 0xCE5E1DBA, "i_found_corpse" },
    { 0x42CCF376, "i_got_tired" },
    { 0xF7BB55BD, "i_got_you" },
    { 0xCB15DBA5, "i_local_client_num" },
    { 0xD2122406, "i_mean_it" },
    { 0xE3CAC4B3, "i_num_armor_pieces" },
    { 0x3EFE0D08, "i_random" },
    { 0xFB51C7EF, "i_scene" },
    { 0xD764CBA7, "i_start" },
    { 0x5ADE5848, "i_state" },
    { 0x4FE17261, "i_tried_to_glitch_the_hero_weapon" },
    { 0x53896880, "iammeleeing" },
    { 0xB0917433, "iangle" },
    { 0xA5CB64D1, "ianim" },
    { 0xBAD3E09E, "ianimnumber" },
    { 0x9255DB77, "iav" },
    { 0x9B4084AE, "iavs" },
    { 0x7B00E2C8, "ibanner" },
    { 0x128D71F1, "ibarragesize" },
    { 0xDDFEFE1E, "ibasespeed" },
    { 0x30CB1CB2, "iblastradius" },
    { 0x47241502, "iblocked" },
    { 0x5CC41B3F, "ibulletsfired" },
    { 0xDA227818, "iburst" },
    { 0x4392F4FB, "iburstnumber" },
    { 0x9D6AEB16, "icamerastyle" },
    { 0x42A006B8, "icarus" },
    { 0x04EB9549, "icb" },
    { 0x6A46918E, "icbm" },
    { 0xC9D757AF, "icbm_amb" },
    { 0x25D20832, "icbm_anim" },
    { 0x86CEBECC, "icbm_art" },
    { 0xEC5F00E1, "icbm_audio" },
    { 0x9892C3CA, "icbm_code" },
    { 0xE097E7CE, "icbm_combat_tension" },
    { 0xA4DBDC91, "icbm_dialog" },
    { 0xABFF03D9, "icbm_friendly_state_alert" },
    { 0xA8EBBF0D, "icbm_friendly_state_hidden" },
    { 0xD83313D0, "icbm_friendly_state_spotted" },
    { 0x1976A11B, "icbm_fx" },
    { 0x4543E78B, "icbm_grg_678" },
    { 0xA933B78D, "icbm_grg_678452056" },
    { 0x5B4447F7, "icbm_grg_getbusy" },
    { 0x7F684B7A, "icbm_grg_goodtogo" },
    { 0xBDA67783, "icbm_grg_leavemebehind" },
    { 0x558D39A7, "icbm_hqr_gettingabortcodes" },
    { 0x76A9CA95, "icbm_introscreen" },
    { 0x809B4793, "icbm_missile" },
    { 0x6609E662, "icbm_missile01" },
    { 0x40076BF9, "icbm_missile02" },
    { 0xCA72C2C7, "icbm_powerlinetower02" },
    { 0x5909F771, "icbm_pri_cutloose" },
    { 0x524CE881, "icbm_pri_gogogo" },
    { 0x276D7BDA, "icbm_pri_gotgriggs" },
    { 0x4F0D16B9, "icbm_pri_keepitquiet" },
    { 0x8C7E656C, "icbm_pri_readytobreach" },
    { 0x27FF150C, "icbm_pri_thisisplace" },
    { 0x01251E5D, "icbm_pri_youallright" },
    { 0x3369F1A5, "icbm_ru1_howmany" },
    { 0xEBA90BB7, "icbm_ru1_ifihad" },
    { 0x28899019, "icbm_ru1_tovarisch" },
    { 0xCE9E88A6, "icbm_ru1_whereothers" },
    { 0x086E8154, "icbm_ru1_whereshacksaw" },
    { 0x338A5954, "icbm_ru1_whoisofficer" },
    { 0xE43A9790, "icbm_ru2_youhadit" },
    { 0xC9F7A7B2, "icbm_sas2_2secured" },
    { 0x716D5207, "icbm_sas2_roomclear" },
    { 0xFC5026C3, "icbm_tower_tension" },
    { 0x70944EA2, "icbm_uk2_3clear" },
    { 0x5B0E79F8, "icbm_uk2_floorsclear" },
    { 0x41E205EC, "icbm_uk2_roomclear" },
    { 0x8EACA0C6, "icbm_uk2_roomclear2" },
    { 0xC2F7F956, "ice" },
    { 0xC94EF6A4, "ice_affect_mechz" },
    { 0xE5197B5B, "ice_affect_zombie" },
    { 0xDBE49033, "ice_blocks" },
    { 0xC7475FB2, "ice_gem" },
    { 0xF610CD68, "ice_puzzle_1_cleanup" },
    { 0x6A85B821, "ice_puzzle_1_complete" },
    { 0x2A704782, "ice_puzzle_1_init" },
    { 0xDD616543, "ice_puzzle_1_run" },
    { 0x6AA0B46F, "ice_puzzle_2_init" },
    { 0xD0BEB464, "ice_puzzle_2_run" },
    { 0x486CEE81, "ice_scraper_animate" },
    { 0x5152D889, "ice_scrapers_init" },
    { 0x7D788186, "ice_solid" },
    { 0x27DEA370, "ice_staff_blizzard_do_kills" },
    { 0x43B7D930, "ice_staff_blizzard_off" },
    { 0x8F634B9A, "ice_staff_blizzard_timeout" },
    { 0xE435840D, "ice_staff_pieces" },
    { 0x08BEC872, "ice_stone_run" },
    { 0xB5073B52, "ice_stones_remaining" },
    { 0x2D7101FC, "ice_tiles_randomize" },
    { 0xAA6737FB, "ice_trigger" },
    { 0x49CF101A, "iceman" },
    { 0x164136A9, "icky" },
    { 0xE0C27BFA, "icon" },
    { 0x0C4FC960, "icon2d" },
    { 0x631AABBF, "icon_fullbright_alpha" },
    { 0xD50B63E7, "icon_halfbright_alpha" },
    { 0x86CA1AE9, "icon_highlighted_alpha" },
    { 0xBC956A30, "icon_highlighted_color" },
    { 0x39C04D6B, "icon_index" },
    { 0x34579393, "icon_jitter" },
    { 0x33A3231F, "icon_jitter_delete" },
    { 0xC41A1EA1, "icon_keys" },
    { 0xF814E008, "icon_name" },
    { 0x4F4E413B, "icon_selected_alpha" },
    { 0xDE3B7B42, "icon_selected_color" },
    { 0x61657916, "icon_size" },
    { 0xEDB0CDE4, "icon_size_highlighted" },
    { 0x1A1772E2, "icon_size_selected" },
    { 0xFF4F7594, "iconbase3d" },
    { 0x7A351E7E, "iconcapture2d" },
    { 0x8907FE81, "iconcapture3d" },
    { 0xE7EDC598, "iconcaptureflag2d" },
    { 0xA635DEA3, "iconcaptureflag3d" },
    { 0x909675AB, "iconcarrier3d" },
    { 0x05FF2607, "iconcount" },
    { 0x27149CDC, "icondefend2d" },
    { 0xE55CB5E7, "icondefend3d" },
    { 0x8C9AA322, "icondropped2d" },
    { 0x7AF68F75, "icondropped3d" },
    { 0x6DB99AB3, "iconelem" },
    { 0xE80466D0, "iconelem1" },
    { 0x5A0BD60B, "iconelem2" },
    { 0x34095BA2, "iconelem3" },
    { 0x04F1850F, "iconenemycarrier3d" },
    { 0x47C87858, "iconescort2d" },
    { 0x088AFA63, "iconescort3d" },
    { 0x0860188F, "iconheight" },
    { 0xEFD8D500, "iconindexother" },
    { 0x24B2F3B4, "iconkill2d" },
    { 0xE57575BF, "iconkill3d" },
    { 0x280EC76C, "iconmat" },
    { 0xF7CB8199, "iconmaterial" },
    { 0x037A8587, "iconname" },
    { 0x80F6756B, "iconoffset" },
    { 0x60E3A384, "iconorg" },
    { 0xE9E5E6EA, "iconreturn2d" },
    { 0xD841D33D, "iconreturn3d" },
    { 0x85AFBC75, "icons" },
    { 0x8F7E944D, "iconsize" },
    { 0x7C0CDF19, "iconspacing" },
    { 0x491711EB, "icontakenenemy2d" },
    { 0x0A305EA0, "icontakenenemy3d" },
    { 0x3AA0BC24, "icontakenfriendly2d" },
    { 0x79876F6F, "icontakenfriendly3d" },
    { 0xD9E467FD, "iconwaitforflag3d" },
    { 0x57EA834E, "iconwidth" },
    { 0x849C1BB0, "icur" },
    { 0x03D29746, "id" },
    { 0x9E5787D0, "id2" },
    { 0x246E5A4C, "id_complete" },
    { 0x2632257F, "id_defalco" },
    { 0x35DE50FC, "id_end" },
    { 0xB3AABE1E, "id_i" },
    { 0x143127EB, "id_melee" },
    { 0x726B3A66, "id_melee_approach" },
    { 0x982F98FD, "id_melee_bypass_fail" },
    { 0xC4248826, "id_melee_fail" },
    { 0x3B25A300, "id_melee_guards_alerted" },
    { 0x3F5E1E5F, "id_melee_success" },
    { 0xD549C246, "id_menendez_event" },
    { 0xB18778D3, "id_status_info_think" },
    { 0x9CD24E96, "id_string" },
    { 0xBC38B123, "id_think" },
    { 0xF9A179ED, "idamage" },
    { 0x4B90F335, "idamagemax" },
    { 0x7622FE7B, "idamagemin" },
    { 0x3EED1904, "idea" },
    { 0x0A32BD00, "ideal" },
    { 0x21747453, "ideal_dist" },
    { 0x0F385DDE, "ideal_distance" },
    { 0x1CD10448, "idealaccel" },
    { 0xA541A9F9, "idealadd" },
    { 0x7D44ED30, "idealdist" },
    { 0xF4E044CB, "idealdistteam" },
    { 0xB609E490, "idealdisttoowner" },
    { 0x57610445, "ideally" },
    { 0x18020672, "idealstartpos" },
    { 0xCF68C3EC, "idealtraceinterval" },
    { 0xAA81081A, "idealtransangles" },
    { 0xC281A40D, "ident" },
    { 0xFABF880A, "identical" },
    { 0x45190BD7, "identically" },
    { 0xEDAC5A73, "identification" },
    { 0xA080D23A, "identified" },
    { 0xFCC0CA08, "identified_entities" },
    { 0x4CAD6D9C, "identifier" },
    { 0x21F56DDF, "identifiers" },
    { 0x72AFE805, "identifies" },
    { 0x7DC1161D, "identify" },
    { 0x0962EE86, "identify_low_road_snipers" },
    { 0x027BB70C, "identifyer" },
    { 0xA2F2400B, "identifying" },
    { 0xCABFF233, "identity" },
    { 0x5B1B42D9, "idetify" },
    { 0xBF827987, "idflags" },
    { 0x9459B05A, "idflags_destructible_entity" },
    { 0xAD343218, "idflags_disable_ragdoll_skip" },
    { 0x41CF007B, "idflags_hurt_trigger_allow_laststand" },
    { 0x865A1847, "idflags_no_armor" },
    { 0x69D5A64B, "idflags_no_knockback" },
    { 0x4E96C667, "idflags_no_protection" },
    { 0xD4B2E9D9, "idflags_no_team_protection" },
    { 0x44B18A05, "idflags_noflag" },
    { 0x681A3CE6, "idflags_passthru" },
    { 0xDC68A61D, "idflags_penetration" },
    { 0xC67C835D, "idflags_power_armor" },
    { 0x0D9A156C, "idflags_radius" },
    { 0x4F4D1502, "idflags_shield_explosive_impact" },
    { 0x4B82DC1C, "idflags_shield_explosive_impact_huge" },
    { 0x46309EE1, "idflags_shield_explosive_splash" },
    { 0x1EC50A94, "idflagstime" },
    { 0x42517170, "idgun" },
    { 0x23E2B5FC, "idgun_add_vehicle_death_state" },
    { 0xAFB57718, "idgun_damage" },
    { 0x0654F1C0, "idgun_damage_cb" },
    { 0x2743854E, "idgun_damage_direction" },
    { 0x345B17E3, "idgun_death_speed" },
    { 0x4E200B11, "idgun_draw_debug" },
    { 0x63117055, "idgun_veh_kill_dist_sqr" },
    { 0xAF66BD29, "idgun_vision_on" },
    { 0xD299AD1A, "idgun_weapons" },
    { 0xCA03B09E, "idiot" },
    { 0x8820D043, "idiota" },
    { 0x50EAF946, "idkfa" },
    { 0xDB4ADE87, "idle" },
    { 0x7762E06C, "idle1" },
    { 0xE96A4FA7, "idle2" },
    { 0x21D73BB4, "idle_ai_anim" },
    { 0xCD63CAA6, "idle_ang" },
    { 0xC62D47CD, "idle_anim" },
    { 0xC00DDAFC, "idle_anim_finished_state" },
    { 0xB7546D38, "idle_anim_think" },
    { 0x49298B0A, "idle_anime" },
    { 0x3506D94C, "idle_anims" },
    { 0xBB097425, "idle_animstop" },
    { 0xDC10C94D, "idle_at_cover" },
    { 0x071D8BDE, "idle_combat" },
    { 0x17D760EA, "idle_done" },
    { 0xA9176CCF, "idle_end_time" },
    { 0x0C45B809, "idle_ent" },
    { 0x9F0D9AEA, "idle_hardleft" },
    { 0x571CDD39, "idle_hardright" },
    { 0x62FBFA98, "idle_here" },
    { 0x558E71E4, "idle_holder" },
    { 0x5D1C32B4, "idle_loop" },
    { 0x39D95A3F, "idle_name" },
    { 0x714B3291, "idle_on_reach" },
    { 0x794FD77C, "idle_org" },
    { 0xA1874112, "idle_override" },
    { 0x918595EF, "idle_pistol" },
    { 0xD6A347CF, "idle_player_anim" },
    { 0x7BB14083, "idle_points" },
    { 0xFB143822, "idle_relative_to_target" },
    { 0x27E60F8E, "idle_run_trans_speed" },
    { 0xC4A6CF81, "idle_state" },
    { 0x434D9DEA, "idle_stop" },
    { 0xCE9B5F3A, "idle_stop_notify" },
    { 0x4D2F3CE9, "idle_struct" },
    { 0x6CC0875B, "idle_swim_fx" },
    { 0xEE290B4A, "idle_taco_radius" },
    { 0xF4B464BE, "idle_threat_timeout" },
    { 0xDF99BCC4, "idle_til_2nd_pass_tuning" },
    { 0x17532D07, "idle_til_explosion_tuning" },
    { 0x8F6919CD, "idle_time" },
    { 0xA3895057, "idle_twitch" },
    { 0x79D8A4B2, "idle_twitchin" },
    { 0x971BAD63, "idle_until_price_has_target" },
    { 0x50D1CC66, "idle_warn_time" },
    { 0x352EB9BB, "idle_window_shutters" },
    { 0x71A78048, "idleanim" },
    { 0xE2CBC24F, "idleanimarray" },
    { 0xB80A2721, "idleanimname" },
    { 0xBA91151F, "idleanimoverridearray" },
    { 0x814B6873, "idleanimoverrideweights" },
    { 0x857CA163, "idleanims" },
    { 0x36AC32CF, "idleanimsetarray" },
    { 0xBE622BD1, "idleanimtransition" },
    { 0xB84F0BA3, "idleanimweights" },
    { 0xA8C0D37A, "idlearray" },
    { 0x8FB30000, "idleblend" },
    { 0xA9EF5F6A, "idlecallback" },
    { 0x579527BB, "idlechance" },
    { 0xB65DE1BC, "idleface" },
    { 0x2B9327F4, "idleflagreturntime" },
    { 0x0A9CAD82, "idleguard" },
    { 0x3C30AA5F, "idleguard1" },
    { 0xCA293B24, "idleguard2" },
    { 0x70CA4FCD, "idleguards" },
    { 0x085489C4, "idleinanimname" },
    { 0x56802CD9, "idleing" },
    { 0x8B618747, "idlelookatbehavior" },
    { 0x1928ECD8, "idlelookatbehaviortidyup" },
    { 0x97FA7A2C, "idlelookatfeatureenabled" },
    { 0x908124D0, "idleoccurrence" },
    { 0xFD422097, "idleoutanimname" },
    { 0x7B2ADE4B, "idlepoint" },
    { 0xC16489CA, "idlerpm" },
    { 0x44066F7E, "idles" },
    { 0xAF4D6631, "idleset" },
    { 0x679E2F72, "idlestrafe" },
    { 0x490BFB62, "idlestrafecleanup" },
    { 0x3728865F, "idlestrafecleanuponkillanimscript" },
    { 0x789D9D9C, "idlestrafecleanupthreadactive" },
    { 0x9E673A9F, "idlestrafedecidedirectionandanim" },
    { 0x89D6F333, "idlestrafedecidenumsteps" },
    { 0xDD962DBF, "idlestrafegetendtransitionanim" },
    { 0x5B9C0B6C, "idlestrafegetstarttransitionanim" },
    { 0x2F5FB827, "idlestrafenumsteps" },
    { 0xA3E5F7B7, "idlestrafeplayanim" },
    { 0x7690D2F1, "idlestrafetracking" },
    { 0x4EC50584, "idlestrafetransitionto" },
    { 0xF9378723, "idlestrafing" },
    { 0xBEE58253, "idletextprint" },
    { 0xB65D78DB, "idlethread" },
    { 0xB77D9098, "idlewait" },
    { 0xF7C33102, "idlewaitabit" },
    { 0x18FF4EC2, "idling" },
    { 0xD0F90BCE, "idlingatcover" },
    { 0x43BB67F9, "ids" },
    { 0xE64EB84A, "iduration" },
    { 0x99D1B5AA, "idx" },
    { 0x95745C0E, "idx_next" },
    { 0x29D511AF, "ie" },
    { 0xB0730579, "ied" },
    { 0xB743DC75, "ied_exploded" },
    { 0xC54877F5, "ied_getiedmodel" },
    { 0xCFA1D29C, "ied_hit_convoy" },
    { 0x4DB4DFB4, "ied_initialspawns" },
    { 0xC7DFEDFA, "ied_marker" },
    { 0xB0C2CD80, "ied_planted" },
    { 0x3907C38F, "ied_randominitialspawns" },
    { 0xD74353EC, "ied_spawn_disabled" },
    { 0xC10F5CB7, "ied_spawn_enabled" },
    { 0x50AD5FFC, "iedlocs" },
    { 0x6BE287B0, "ieds" },
    { 0x6BF7BDEC, "ieds_to_spawn" },
    { 0x6A0B9351, "iedspot" },
    { 0x0C7608CA, "ieffectexplodernum" },
    { 0x325A8F74, "ientitynumber" },
    { 0x72226BFD, "iexploder" },
    { 0x8F455F57, "iexplodernum" },
    { 0x097894B0, "iexplosionnumber" },
    { 0xB7CDA274, "if" },
    { 0xDA4DF67A, "if_defined" },
    { 0xC642FE57, "if_occupied" },
    { 0x3D2667AF, "ifadetime" },
    { 0x410114EA, "iff" },
    { 0x03CEDE31, "iff_override" },
    { 0x6EB14BB1, "iff_override_reverted" },
    { 0xF5C12ECD, "ifiretime" },
    { 0x03B6577D, "ifirstbreachers" },
    { 0x28768E77, "iflashfuse" },
    { 0xC036F4CC, "ifovcos" },
    { 0x9EE5D267, "ifs" },
    { 0xD946B38C, "igc" },
    { 0x8E6F0FFD, "igc_finished" },
    { 0x6F0721FF, "igc_guys" },
    { 0xEAF442D2, "igcactive" },
    { 0xA82C6E0F, "igcs" },
    { 0xFF25E593, "igcstarttime" },
    { 0x5D120BC3, "igcviewtimesec" },
    { 0x0FCF5083, "ignite" },
    { 0xA9423E63, "ignite_jet" },
    { 0x3E165ABD, "ignited" },
    { 0x174E3530, "ignition" },
    { 0xB3D3E679, "ignoer" },
    { 0x652CBE10, "ignomeme" },
    { 0x184DFFCB, "ignorall" },
    { 0x2BAFB34F, "ignore" },
    { 0xA83D7C9F, "ignore_actor_kill_times" },
    { 0x6B720184, "ignore_ai" },
    { 0x743152F7, "ignore_all" },
    { 0xFA3E545E, "ignore_all_poi" },
    { 0xAD6347B8, "ignore_all_till_flag" },
    { 0x3EDDB285, "ignore_all_timer" },
    { 0x450D7601, "ignore_ammomode" },
    { 0x68F06767, "ignore_and_run" },
    { 0x0D144BA9, "ignore_bowmans_big_rocket" },
    { 0xF47AEF4A, "ignore_characters" },
    { 0x940A01A9, "ignore_chugabud" },
    { 0x9EFE705A, "ignore_claymore" },
    { 0xE9EE65FD, "ignore_cleanup_mgr" },
    { 0xF2AC70EF, "ignore_common_run" },
    { 0xC05B7C15, "ignore_cooldown" },
    { 0x65168DAA, "ignore_counter" },
    { 0x839602EE, "ignore_death_jolt" },
    { 0xD19A3BAF, "ignore_devgui_death" },
    { 0xCA65CC5C, "ignore_direct_attack" },
    { 0xAE0A0C99, "ignore_distance_tracking" },
    { 0xBC3D4880, "ignore_double_points_upgrade" },
    { 0x3D4B2961, "ignore_double_wide" },
    { 0x74C345FB, "ignore_electric_trap" },
    { 0xA11F98F1, "ignore_emp_states" },
    { 0xDF537B6C, "ignore_enabled_check" },
    { 0x692B62B6, "ignore_enemy" },
    { 0xB62B7F6A, "ignore_enemy_count" },
    { 0x1ED5B414, "ignore_enemy_timer" },
    { 0x869F5C3E, "ignore_enemyoverride" },
    { 0x62086531, "ignore_ent" },
    { 0x25231847, "ignore_entity" },
    { 0x94441B82, "ignore_equipment" },
    { 0x326AE135, "ignore_everything" },
    { 0x9FBE525C, "ignore_find_flesh" },
    { 0x934B79C2, "ignore_fire_time" },
    { 0xBFF4A75B, "ignore_friendlies_till_past_killzone" },
    { 0xE7FD6A28, "ignore_func" },
    { 0x01AAA052, "ignore_game_over_death" },
    { 0xA714E2A3, "ignore_goal" },
    { 0xA7D1D70C, "ignore_gravity" },
    { 0xDBA2FFD5, "ignore_gravityspikes_ragdoll" },
    { 0xF39459A1, "ignore_headchopper" },
    { 0x98B8B2FE, "ignore_inert" },
    { 0x47B00FE5, "ignore_initial_notetracks" },
    { 0xE158C836, "ignore_insta_kill" },
    { 0xE463757D, "ignore_last_spot" },
    { 0x4CB0BCE1, "ignore_laststand_players" },
    { 0xEB2898F0, "ignore_lava_damage" },
    { 0xC020BCAC, "ignore_me" },
    { 0xFF462CBA, "ignore_me_timer" },
    { 0xBA5A110C, "ignore_me_timer_old" },
    { 0xE237BCB0, "ignore_me_timer_prev_value" },
    { 0x36C29EC3, "ignore_mine_dist_check" },
    { 0xE5E875EF, "ignore_nml_delete" },
    { 0xC507B448, "ignore_non_sentient" },
    { 0xA1C8DBDC, "ignore_none" },
    { 0x5917ADE1, "ignore_nuke" },
    { 0xD4F9DE41, "ignore_off" },
    { 0xCD034935, "ignore_on" },
    { 0x504DCA0F, "ignore_on_migrate" },
    { 0x70E3DEFA, "ignore_open" },
    { 0x54CD1E6B, "ignore_open_sesame" },
    { 0x46A42812, "ignore_path_delays" },
    { 0x3F8B26A5, "ignore_player" },
    { 0x82A9C8C8, "ignore_player_as_he_runs_down_the_hill" },
    { 0x566698AA, "ignore_player_func" },
    { 0x252FB1BB, "ignore_player_onflag_setup" },
    { 0x20CF1E8F, "ignore_player_setup" },
    { 0xB104BF6E, "ignore_player_valid" },
    { 0x0BDAC2A4, "ignore_players_guy" },
    { 0x480259C6, "ignore_poi" },
    { 0x940AAAE3, "ignore_poi_targetname" },
    { 0xC96B03BF, "ignore_power_state" },
    { 0x348989B5, "ignore_rampage_kill_times" },
    { 0x089C2151, "ignore_range" },
    { 0x2429EB40, "ignore_range_powerup" },
    { 0x8749B04F, "ignore_riotshield" },
    { 0x833CFBAE, "ignore_round_robbin_death" },
    { 0xEA694EBE, "ignore_round_spawn_failsafe" },
    { 0x5C08348E, "ignore_round_start_friendly_fire" },
    { 0x58A89D24, "ignore_seat_check" },
    { 0xE834AD38, "ignore_segment_dist" },
    { 0xE2F4BF11, "ignore_settings" },
    { 0x40234E3F, "ignore_sight_checks" },
    { 0xB80C453B, "ignore_slowgun_anim_rates" },
    { 0x163BF95F, "ignore_solo_last_stand" },
    { 0x9E054668, "ignore_spawn_visibility_check_max" },
    { 0x6C482B8B, "ignore_spawner_func" },
    { 0x6FE666BD, "ignore_speed_buff" },
    { 0x5F3874D3, "ignore_spring_pad" },
    { 0x891F9288, "ignore_squad" },
    { 0x177BD133, "ignore_stop_func" },
    { 0x1EA59FA8, "ignore_subwoofer" },
    { 0x14C4C2F1, "ignore_suppression_until_ambush" },
    { 0x26B17735, "ignore_surpression" },
    { 0xA106FBCC, "ignore_systems" },
    { 0x214803FD, "ignore_target" },
    { 0xC252E8EE, "ignore_targetted_nodes" },
    { 0xFBB0DF15, "ignore_team" },
    { 0xDAEFFC03, "ignore_team_kills" },
    { 0x0BFDEC75, "ignore_til_goal" },
    { 0x055A3963, "ignore_til_path_end" },
    { 0xED99F7E7, "ignore_til_path_end_interrupt" },
    { 0x78F29DDC, "ignore_til_path_end_or_dmg" },
    { 0xAE5F4623, "ignore_till_goal" },
    { 0x4D78A435, "ignore_time" },
    { 0xF9CB081F, "ignore_timebomb_slowdown" },
    { 0xBEABCB6D, "ignore_timer" },
    { 0x5472CBE1, "ignore_touch_checks" },
    { 0xBD38C0CD, "ignore_trace_distance" },
    { 0x3000885F, "ignore_transition" },
    { 0x6E8FDD64, "ignore_traverse" },
    { 0xCBF607ED, "ignore_traverse_disconnect" },
    { 0x1D9FDF1D, "ignore_triggers" },
    { 0x0046CE32, "ignore_truck_guys_till_truck_stopped" },
    { 0x90D1CE2A, "ignore_until_high_alert" },
    { 0xEBB5C0A6, "ignore_use_blocker_clip_for_pathing_check" },
    { 0x37841EC8, "ignore_used_positions" },
    { 0x9E6D772F, "ignore_val" },
    { 0x8254595E, "ignore_vehicle_underneath_splash_scalar" },
    { 0x18C3D48A, "ignore_vo_notetracks" },
    { 0x247A4A6A, "ignore_vortex_ragdoll" },
    { 0x3ABE12E9, "ignore_wait" },
    { 0x5F6A69FD, "ignore_water_damage" },
    { 0x246DAFCC, "ignore_zombie" },
    { 0xE5A45DC0, "ignore_zombie_lift" },
    { 0xB61CA8F0, "ignore_zone" },
    { 0x20DFB701, "ignoreactors" },
    { 0xE1046EBD, "ignoreai" },
    { 0xFF2ED4E2, "ignorealivecheck" },
    { 0xC584775C, "ignoreall" },
    { 0x5A446661, "ignoreall_for_running_away" },
    { 0x78E31782, "ignoreall_off" },
    { 0x62EB27F6, "ignoreall_old" },
    { 0xB2E225F4, "ignoreall_on" },
    { 0x70229AB4, "ignoreallenemies" },
    { 0x4272631C, "ignoreallenemies_threaded" },
    { 0xCB14B99A, "ignoreattacker" },
    { 0x2539F9A5, "ignorebackwardposition" },
    { 0x698D714C, "ignorebulletdamage" },
    { 0x8F77A706, "ignorebulletsfired" },
    { 0xB344C3DF, "ignorecheapentityflag" },
    { 0xBC3E0E99, "ignored" },
    { 0xFBD3515B, "ignored_by_friendlies" },
    { 0x5C51E42E, "ignored_by_tank_cannon" },
    { 0x42DF920A, "ignored_till_fastrope" },
    { 0xFA036E16, "ignoredamagescale" },
    { 0xCC97E727, "ignoredeath" },
    { 0x3A087745, "ignoredecoy" },
    { 0x3DB8C3EE, "ignoredirection" },
    { 0x75AE2A2E, "ignoreeachother" },
    { 0x0A19E779, "ignoreempjammed" },
    { 0xA3F0CBE1, "ignoreenemy" },
    { 0xCA22A7DE, "ignoreent" },
    { 0x0BC58741, "ignoreents" },
    { 0x630F9831, "ignoreexclusion" },
    { 0x375CF54A, "ignorefirefly" },
    { 0x8D0741D4, "ignorefirstshotwait" },
    { 0xCBF830E5, "ignoreflag" },
    { 0xDE2917FF, "ignoreforfixednodesafecheck" },
    { 0xAEC07A31, "ignoreforfriendlyfire" },
    { 0xCD0301AF, "ignoregravity" },
    { 0xCEB0EE4E, "ignorelocationaldamage" },
    { 0x13B37767, "ignorelos" },
    { 0x255B9315, "ignoreme" },
    { 0x54157C57, "ignoreme_old" },
    { 0xD2F14A48, "ignoreme_thread" },
    { 0x977887E4, "ignoreme_till_close" },
    { 0x71F23BD7, "ignoreme_till_stealth_broken" },
    { 0x20D5E8CF, "ignoreme_when_in_trigger" },
    { 0xA8E832F1, "ignoremelee" },
    { 0x7FDE64F4, "ignoremetimer" },
    { 0xC4316530, "ignorenearbyspeakers" },
    { 0xB814918F, "ignorenearbyspkrs" },
    { 0x05DCC7F9, "ignoreneutralfriendlyfire" },
    { 0x8A835767, "ignorenode" },
    { 0xA695CA1B, "ignoreoccupied" },
    { 0x95B3156D, "ignoreorigin" },
    { 0x14FB0B7C, "ignorepathenemyfightdist" },
    { 0x873A91D0, "ignoreplayer" },
    { 0x82256BBB, "ignoreplayers" },
    { 0x56D39948, "ignoreragdoll" },
    { 0xDA54DDC1, "ignorerandombulletdamage" },
    { 0x60AF91F5, "ignorerunandgundist" },
    { 0x1A22CC16, "ignores" },
    { 0xD5339C65, "ignoreself" },
    { 0xFA4B89EE, "ignoresflakjacket" },
    { 0x348DBC9C, "ignoresightpos" },
    { 0x92291E3F, "ignoreslightarmor" },
    { 0x55879659, "ignorespawninglimit" },
    { 0x270CEFA3, "ignoresuppresion" },
    { 0x501514B8, "ignoresuppression" },
    { 0xF7E96B72, "ignoresuppression_old" },
    { 0x286060F3, "ignoresuppressiontime" },
    { 0x4814ADB4, "ignoreteam" },
    { 0x916C0917, "ignoreteamkills" },
    { 0x6AA9C5A6, "ignoretilpathenders" },
    { 0x1DAAA566, "ignoretriggerdamage" },
    { 0xC99818E0, "ignoretriggers" },
    { 0x2D30FE6C, "ignorevehicles" },
    { 0x5CAE3E73, "ignorevignettemodeforanimreach" },
    { 0x8434B443, "ignorevisible" },
    { 0x7ABD3730, "ignorevortices" },
    { 0x06DD5211, "ignorewhenactive" },
    { 0x608C0BAE, "ignorewhilefallingback" },
    { 0x22F0A8CA, "ignoring" },
    { 0xA500A39C, "ignorme_count" },
    { 0x2DD09515, "ignormeshield_off" },
    { 0x70316028, "ihealth" },
    { 0x40C0CDD3, "iheight" },
    { 0xC1DEFB53, "ii" },
    { 0xDDFD907A, "iiiiit" },
    { 0x29708D32, "iindex" },
    { 0x61BCB0B5, "iinterval" },
    { 0x75DA0681, "ik" },
    { 0x5782032E, "ikeyfriendlies" },
    { 0x6B5585E8, "ikillmax" },
    { 0x8612CDF9, "ikpriority" },
    { 0x33E66A8E, "il" },
    { 0xD53DD508, "il2" },
    { 0xDB67EED4, "il2_1" },
    { 0x4D6F5E0F, "il2_2" },
    { 0x276CE3A6, "il2_3" },
    { 0xE64C4461, "il2_3_plane_sweep_think" },
    { 0x69607F99, "il2_4" },
    { 0x2F272B86, "il2_4_plane_sweep_think" },
    { 0x435E0530, "il2_5" },
    { 0x5F4EB4B3, "il2_5_plane_sweep_think" },
    { 0x83EBCC06, "il2_fly" },
    { 0x706B00EE, "il2_nodes" },
    { 0xFA952868, "il2_nodes2" },
    { 0x9817FFEB, "ilastexplosion" },
    { 0xA30194F1, "illegal" },
    { 0x55BBCC78, "illision" },
    { 0x846FE3E4, "illusion" },
    { 0xAD7214A0, "illustrate" },
    { 0x0F00ED0B, "illustrative" },
    { 0x2D3DBAF5, "iloadnumber" },
    { 0x59E8E4F7, "im" },
    { 0x662904D1, "im_a_shark" },
    { 0x162F2036, "im_watching_anim_done" },
    { 0x80FDDB9C, "image" },
    { 0x594457EA, "image_room" },
    { 0x90B5499D, "imagea" },
    { 0xB6B7C406, "imageb" },
    { 0x77ED44B2, "imagefadeout" },
    { 0x54058FBD, "imagename" },
    { 0x7C9297DF, "images" },
    { 0xB346EFD9, "imagetext" },
    { 0xFA0D5D10, "imaginary" },
    { 0x04CA9757, "imagine" },
    { 0xB8C5A285, "imaging" },
    { 0xCC396D52, "imagining" },
    { 0xAEF12D9B, "imaxrange" },
    { 0x367E67E4, "imaxrangelocal" },
    { 0xA27CB63D, "imdead" },
    { 0x43CBB729, "iminent" },
    { 0x892BB7A9, "iminrange" },
    { 0xE2E043E6, "iminrangelocal" },
    { 0x0010A953, "iminwater" },
    { 0x032D476A, "imissiontime_ms" },
    { 0x96D51763, "imitates" },
    { 0xC708203B, "immature" },
    { 0x0B3C43F8, "immediate" },
    { 0x11B86C33, "immediate_switch" },
    { 0x809AB3AE, "immediatecapture" },
    { 0x48A742C7, "immediatedetonation" },
    { 0x4E681C5D, "immediateexplosion" },
    { 0x244BE1FD, "immediately" },
    { 0x7BA23079, "immediatespeed" },
    { 0xCA9ECEC3, "immediatley" },
    { 0x1A1864EA, "immediatly" },
    { 0xC8D0715D, "immense" },
    { 0x304C498C, "immidiate" },
    { 0x60A99DB4, "imminent" },
    { 0xAC5778CD, "immobile" },
    { 0x77ECFB26, "immobilized" },
    { 0xD2546D51, "immobilized_tank" },
    { 0x59B8F089, "immobilizes" },
    { 0xD0EECAC8, "immolation" },
    { 0x384EA086, "immune" },
    { 0x8B811BA6, "immune_result_direct" },
    { 0xD3228933, "immune_result_indirect" },
    { 0x5B5E616B, "immune_trigger" },
    { 0x23BB4339, "immune_vehicle_notify" },
    { 0x06C2AC6E, "immunespecialty" },
    { 0xF260A513, "immunetodemofreecamera" },
    { 0x593A32E2, "immunetodemogamehudsettings" },
    { 0xFCE8B58B, "immunities" },
    { 0x67F240EF, "immunity" },
    { 0xD449A995, "immunity_register" },
    { 0x34DFD095, "immunity_time" },
    { 0xD9372142, "imnotmeleeing" },
    { 0x68BB0FEF, "imodelindex" },
    { 0x22E31701, "imp_context" },
    { 0xF9FCDCE1, "imp_context_reset" },
    { 0x0383022F, "impact" },
    { 0xCFF816AF, "impact_animate" },
    { 0x6271329D, "impact_chest" },
    { 0xF0E597AF, "impact_dir" },
    { 0x316511D7, "impact_dir_normal" },
    { 0x896CFB10, "impact_fx" },
    { 0x02F1EAE8, "impact_head" },
    { 0xCD52DF20, "impact_hips" },
    { 0x057D9EF1, "impact_humangun" },
    { 0x5E7E6DB4, "impact_humangun_upgraded" },
    { 0x7B1F7CD1, "impact_l_arm" },
    { 0xC203A1FF, "impact_l_leg" },
    { 0x1474E1C4, "impact_org" },
    { 0x63242251, "impact_orient" },
    { 0xECEE67F8, "impact_origin" },
    { 0xF5361FCC, "impact_pos" },
    { 0xDDC4EB8E, "impact_pt" },
    { 0xDCEA8133, "impact_r_arm" },
    { 0x06A23E39, "impact_r_leg" },
    { 0x3093B5EF, "impact_slows_player_scale" },
    { 0x91239C99, "impact_state" },
    { 0x7CF81B22, "impact_trigger_attach" },
    { 0x718CD703, "impact_vel" },
    { 0x50839EFB, "impactamount" },
    { 0x92DC0464, "impactcf" },
    { 0x1913A7CC, "impactdir" },
    { 0x6578C574, "impacted" },
    { 0xAD39AE9B, "impactpos" },
    { 0x3B295C76, "impacts" },
    { 0x9BC554E6, "impactvelocity" },
    { 0x7438D5C0, "impactwater" },
    { 0x99CD89C0, "impassible" },
    { 0x068E23C2, "impatient" },
    { 0xFDFF914B, "impatient_allies" },
    { 0x07E8B3CE, "impatient_player" },
    { 0x24609A8C, "impending" },
    { 0xD56BF486, "impending_mortar_death_function" },
    { 0xFB8228FD, "imperialists" },
    { 0xE1E3F341, "implanted" },
    { 0x4D21DCC0, "implement" },
    { 0xAD1D6637, "implementation" },
    { 0x85878553, "implemented" },
    { 0x4B62592C, "implementes" },
    { 0x3E2E4AEB, "implements" },
    { 0xBCABD41C, "implicit" },
    { 0x56FEE2AB, "implied" },
    { 0x1CD9B684, "implies" },
    { 0x2FB52A37, "implimented" },
    { 0x8E9895CD, "implosion" },
    { 0x5396C408, "imply" },
    { 0xD712320B, "imply_explosives_use" },
    { 0xC814725A, "import" },
    { 0x5DF22B63, "importance" },
    { 0xD959C735, "important" },
    { 0x36C47233, "important_string" },
    { 0x17D24C98, "importantly" },
    { 0x8EBA5B3D, "importantpeopletalkingtime" },
    { 0x955645ED, "imported" },
    { 0x84FCC296, "importing" },
    { 0x371054F8, "imposed" },
    { 0x9C0354C6, "impossible" },
    { 0xD3E597DA, "impossibly" },
    { 0x91E8A8C7, "impressed" },
    { 0x4CCC68FE, "impressive" },
    { 0x1B749EE5, "improper" },
    { 0xD5A11E28, "improperly" },
    { 0xA1C5BD7F, "improve" },
    { 0x50517DE9, "improved" },
    { 0x1FFDBE35, "improved_sightconetrace" },
    { 0x7A5E1B17, "improvement" },
    { 0xFE60DECE, "improvements" },
    { 0xA674CCBB, "improvise" },
    { 0x9E119DE6, "improvise_lobby" },
    { 0x1D378125, "improvised" },
    { 0x017BD9E9, "impulse_max" },
    { 0x1EEB6E97, "impulse_min" },
    { 0x38A8E69A, "imran" },
    { 0x71B045B3, "imwalkinhere" },
    { 0xE7E175BC, "in" },
    { 0xC41D3E77, "in_a_different_scene" },
    { 0x425F84B1, "in_air" },
    { 0xA366310C, "in_airlock" },
    { 0xAD75F3C4, "in_anim" },
    { 0xA26E242D, "in_arc" },
    { 0x7D80F938, "in_area" },
    { 0xA4CFD854, "in_arena" },
    { 0x88CF0FF8, "in_bad_area" },
    { 0x4F5E4481, "in_bad_zone" },
    { 0x90E699DC, "in_bad_zone_watcher" },
    { 0x06A31779, "in_banzai_attack" },
    { 0x2023E5C7, "in_banzai_melee" },
    { 0xE291851A, "in_bar" },
    { 0xB5B35D54, "in_base" },
    { 0xEFE15FCD, "in_base_shoot_think" },
    { 0x14C4F72F, "in_between_time" },
    { 0xC5CFA105, "in_boat" },
    { 0xC971973A, "in_box" },
    { 0xD006CF1C, "in_bulletcam" },
    { 0x2076583A, "in_bunker_b_node" },
    { 0x4569BB02, "in_camptown_directive" },
    { 0x9AC47C34, "in_chopper" },
    { 0xF117AC20, "in_compact_mode" },
    { 0x6CD8F845, "in_conf_room" },
    { 0x8C842D6F, "in_country" },
    { 0x95118181, "in_death_anim" },
    { 0x4C636C51, "in_defensive_pos_early" },
    { 0x90FF5A5A, "in_disguise" },
    { 0x0AF5A4A9, "in_elevator" },
    { 0x93743209, "in_enabled_playable_area" },
    { 0xEC86EDB7, "in_enabled_zone" },
    { 0x73851D37, "in_escape_pod_trigger" },
    { 0x405FA0F1, "in_fire_range" },
    { 0xC4DADB10, "in_fire_zone" },
    { 0x0DC17708, "in_fix_area" },
    { 0x221BA338, "in_fov" },
    { 0x85982707, "in_front_of_car_civs" },
    { 0x4D26836C, "in_front_of_player" },
    { 0x10F1520C, "in_game_checklist_plane_piece_crafted" },
    { 0xB9F47B03, "in_game_checklist_plane_piece_dropped" },
    { 0xB1E18DA1, "in_game_checklist_plane_piece_picked_up" },
    { 0xEC3C4FBE, "in_game_checklist_setup" },
    { 0xC9F89420, "in_game_dialogue_setup" },
    { 0x392A9880, "in_gather_position" },
    { 0x9DB83758, "in_getweaponslist" },
    { 0xCAAC9938, "in_giant_robot_head" },
    { 0xD7C8DF5E, "in_goal" },
    { 0xE9C5B003, "in_gravity_trap" },
    { 0xFFF44F00, "in_hellhole" },
    { 0xA404FCE8, "in_house_dialog" },
    { 0xDF14F3EE, "in_igc" },
    { 0x5890C17B, "in_intermission" },
    { 0x0BA0C9AA, "in_kill_brush" },
    { 0xC6255556, "in_last_stand" },
    { 0xC2EEE29C, "in_life_brush" },
    { 0x441F473A, "in_limo" },
    { 0x36DE0DA9, "in_low_g" },
    { 0x98905394, "in_low_gravity" },
    { 0x6283B546, "in_message_range" },
    { 0x1475FD25, "in_pack_enclosure" },
    { 0xE46194B6, "in_page" },
    { 0x66DF2B7B, "in_pain" },
    { 0x593E4C2A, "in_pit" },
    { 0x8DFBDE03, "in_pit_with_frags" },
    { 0x5A259D80, "in_place" },
    { 0xE4BA7AF3, "in_plane" },
    { 0xDE90B29F, "in_playable_area" },
    { 0x3E66F8F6, "in_playable_zone" },
    { 0x54FA5EB0, "in_player_fov" },
    { 0xDC6970C1, "in_player_sights" },
    { 0x23FE9229, "in_player_zone" },
    { 0xD0AE5802, "in_position" },
    { 0x0E30F650, "in_position_dialogue_line" },
    { 0x21FDAD59, "in_position_for_kill" },
    { 0x44EACDAD, "in_position_min_time" },
    { 0x463CF559, "in_position_start_time" },
    { 0x9815FE47, "in_proper_seat" },
    { 0x26BBB37A, "in_range" },
    { 0x0ABEC9EF, "in_range_2d" },
    { 0x951127A4, "in_range_distance" },
    { 0x5A55B830, "in_reverse_fire_range" },
    { 0x1273780D, "in_revive_trigger" },
    { 0xEEDAFEB7, "in_reznov_room" },
    { 0x71430A46, "in_rt_cached" },
    { 0xEA0A7E12, "in_rts_mode" },
    { 0x868C60D1, "in_saving_position" },
    { 0x29F31875, "in_shared_inventory" },
    { 0x2E650F63, "in_spawnspectator" },
    { 0xA052E6FB, "in_special_attack" },
    { 0xDBC603F8, "in_tb_groups" },
    { 0x5809E158, "in_the_ceiling" },
    { 0x71474B5D, "in_the_elevator" },
    { 0x06CFE882, "in_the_ground" },
    { 0x02AE29C4, "in_the_jungle" },
    { 0x96D2D338, "in_time" },
    { 0x69E05AFD, "in_to_ft" },
    { 0x87845BB2, "in_transition" },
    { 0xE3BB699F, "in_traversal" },
    { 0xA5C5C0DB, "in_tube_manual_looping_rumble" },
    { 0x09253F7D, "in_tunnel_goal" },
    { 0xAB9EC428, "in_use" },
    { 0xF348861C, "in_use_by" },
    { 0x733CE01B, "in_vec" },
    { 0xA641CE84, "in_view" },
    { 0x17276561, "in_volume" },
    { 0x4B083854, "in_water" },
    { 0x88B58A8A, "in_whitelist" },
    { 0x7175DF91, "in_zombie_menu" },
    { 0x0E36A25E, "in_zombify_call" },
    { 0x4195C4C1, "in_zone" },
    { 0x4C1B9F36, "inability" },
    { 0x5D228076, "inaccesible_player_func" },
    { 0xE37B377E, "inaccessible" },
    { 0x5332F22B, "inaccessible_player_func" },
    { 0x4821B943, "inaccuracy" },
    { 0xF8C2CFD6, "inaccurate" },
    { 0x9FB43F42, "inactive" },
    { 0xCF7D188E, "inactive_count" },
    { 0xAFFDDDF2, "inactive_objective" },
    { 0x9C65DC93, "inactive_reasses_time" },
    { 0x65B3B4D0, "inactive_reassess_time" },
    { 0x5A237050, "inactive_timer" },
    { 0xB92BF04B, "inactivity" },
    { 0xCD2D17DB, "inafantry" },
    { 0x2B17FFEB, "inagnumber" },
    { 0x31E7DBE3, "inags" },
    { 0x74324280, "inair" },
    { 0x68BB1260, "inalready" },
    { 0x564EBEE4, "inarc" },
    { 0x293DAD5F, "inarea" },
    { 0xC271A96B, "inbanzaimelee" },
    { 0x46644E44, "inbed_spot" },
    { 0x0D3009F4, "inbetween" },
    { 0x3DE47BE6, "inbombzone" },
    { 0x1091B3C9, "inbombzoneteam" },
    { 0xC8E93AFC, "inbound" },
    { 0x97083588, "inboundnearplayertext" },
    { 0x95F58ABF, "inbounds" },
    { 0x69AED139, "inboundtext" },
    { 0x3463C938, "inburnarea" },
    { 0x75A4790F, "inc" },
    { 0xAAC1337E, "inc_challenge_stat" },
    { 0x8A25B8E7, "inc_count" },
    { 0x42DEB003, "inc_exp" },
    { 0x68C93B33, "inc_general_stat" },
    { 0xC0D8CA14, "inc_pilot" },
    { 0xF25D66AD, "inc_size" },
    { 0xDE42F0F3, "inc_speed" },
    { 0x624BD58C, "inc_streak" },
    { 0x76FAC97D, "inc_tint" },
    { 0xBF8E852D, "inc_value" },
    { 0x133584C4, "inc_vec" },
    { 0xA3DEA9E1, "inc_vol" },
    { 0xAA37D9C9, "incamera" },
    { 0xC0404B79, "incang" },
    { 0x06A796CC, "incap" },
    { 0x31D12F2F, "incarceration" },
    { 0x04C96618, "incase" },
    { 0xCB1E9FE6, "inccodpoints" },
    { 0x055B7A5E, "inccontracttime" },
    { 0xAD308D9D, "inccratekillstreakusagestat" },
    { 0x62C4D250, "inccutoff" },
    { 0x947991B6, "incdistance" },
    { 0xB3ED876F, "incements" },
    { 0x95D4067B, "incendiaries" },
    { 0xFCB56D9F, "incendiary" },
    { 0xB61E2836, "incendiary_damage_radius_lg" },
    { 0xADFF3169, "incendiary_damage_radius_sm" },
    { 0x7057BC19, "incendiary_explosion_dmg_max" },
    { 0xCAFD9AA7, "incendiary_explosion_dmg_min" },
    { 0x9F9B4DF1, "incendiary_grenade_event" },
    { 0x5E64EB94, "incendiary_grenade_explosion" },
    { 0x8772B94D, "incendiary_system_spawn" },
    { 0xE3C1FF7B, "incendiary_water" },
    { 0xE20975D2, "incendiarydamageradius" },
    { 0xC19E19AB, "incendiarydamagethistick" },
    { 0xBB2E86BC, "incendiaryfiredamage" },
    { 0xDEEE66A6, "incendiaryfiredamagehardcore" },
    { 0x4857EF20, "incendiaryfiredamageticktime" },
    { 0x8B6A49FB, "incendiaryfireduration" },
    { 0xF0F3C565, "incendiaryfxduration" },
    { 0x7E9EC3C7, "incendiarygrenade" },
    { 0xADD421A2, "incendiarygroundburntime" },
    { 0xB31F8DFF, "incendiarylastburntby" },
    { 0x6A9FD138, "incentive" },
    { 0xE7E7CDC8, "incexp" },
    { 0xD153965D, "incfarblur" },
    { 0x150E7801, "incfarend" },
    { 0x6E0D018A, "incfarstart" },
    { 0x54287484, "incfov" },
    { 0xB1EC4D45, "inch" },
    { 0xD303BCFD, "inches" },
    { 0x46DFF30A, "inches_per_hour" },
    { 0x5F24E03C, "inches_per_min" },
    { 0x5F19DD89, "inches_per_sec_to_mph" },
    { 0xF73A10BC, "inches_per_second" },
    { 0xB6BCECFE, "inchespersecond" },
    { 0x2BE3911F, "incident" },
    { 0xFDC7FB6A, "incint" },
    { 0xA2BBB5ED, "incitemstatbyindex" },
    { 0x1A7FC352, "incitemstatbyreference" },
    { 0xC66A74A3, "inckillstreaktracker" },
    { 0xA82549E6, "inclaimedlocation" },
    { 0x35700F14, "inclinator" },
    { 0x9ECF9395, "incline" },
    { 0x013240EC, "inclosed" },
    { 0x2DBDEF67, "incloserange" },
    { 0x4F45A367, "include" },
    { 0xC352DD17, "include_achievement" },
    { 0x90F6A18C, "include_ai" },
    { 0xE16ACDF6, "include_buildable" },
    { 0x0A0A31E9, "include_buildables" },
    { 0x2B260840, "include_craftable" },
    { 0x3EBEC56B, "include_craftables" },
    { 0x91D9B0BA, "include_equipment" },
    { 0x7E593D71, "include_equipment_for_level" },
    { 0x7E257812, "include_game_modules" },
    { 0x40FEC36C, "include_gametype" },
    { 0x9812C8A0, "include_key_craftable" },
    { 0xEAF76FB7, "include_perk_in_random_rotation" },
    { 0x50A4FF91, "include_perks" },
    { 0xA823CD4E, "include_perks_in_random_rotation" },
    { 0xC776EEBD, "include_player" },
    { 0xB64C75A4, "include_powered_item" },
    { 0xB03CF9D7, "include_powered_items" },
    { 0xF30DA1C6, "include_powerup" },
    { 0x5DACEF79, "include_powerups" },
    { 0xF8412821, "include_upgraded_weapon" },
    { 0xE810E262, "include_weapon" },
    { 0x6E1AF22D, "include_weapons" },
    { 0xE8B1EC09, "include_zombie_buildable" },
    { 0xAC4E44A7, "include_zombie_craftable" },
    { 0x5754D369, "include_zombie_equipment" },
    { 0x2A156BC5, "include_zombie_powerup" },
    { 0xC9B9A8DF, "include_zombie_weapon" },
    { 0xD9470461, "included" },
    { 0xE73C8895, "includegametype" },
    { 0x372BC1DE, "includes" },
    { 0x4F805ED7, "includesarge" },
    { 0x362052A9, "includeteamkilldelay" },
    { 0xBC2161A2, "including" },
    { 0x00A83A9C, "includingai" },
    { 0x4A0782B2, "incluide" },
    { 0x0D56E00D, "inclusive" },
    { 0x4CE0124E, "incnearblur" },
    { 0x62236B04, "incnearend" },
    { 0xB2A8B86F, "incnearstart" },
    { 0xE38A7C94, "incodespawn" },
    { 0x9400F55B, "incodpoints" },
    { 0x2BBD0621, "incolor" },
    { 0x31DD1B05, "incoming" },
    { 0x1E00E252, "incoming_alert" },
    { 0x987A4B9C, "incoming_bombers" },
    { 0xB96537C0, "incoming_bombers_size" },
    { 0x91B95059, "incoming_chopper_vo" },
    { 0x9B89B0C5, "incoming_delay" },
    { 0x28423B91, "incoming_dogs_vo" },
    { 0xEDE11490, "incoming_enemies" },
    { 0xF5D89B27, "incoming_ent" },
    { 0x4CB2B053, "incoming_infantry_vo" },
    { 0xF6201EA9, "incoming_lines" },
    { 0x9D178A90, "incoming_missile" },
    { 0xB6279074, "incoming_missile_owner" },
    { 0x8C2360CA, "incoming_projectile_alert" },
    { 0x33796385, "incoming_rpg" },
    { 0x5BDB3D65, "incoming_sound" },
    { 0x651758C7, "incoming_sound_ent" },
    { 0xD2E5285E, "incoming_special_grenade_tracking" },
    { 0x8E21BE41, "incoming_velocity" },
    { 0x14E65ECE, "incominggrenadetracking" },
    { 0x0048EB4F, "incomingnum" },
    { 0x24C51706, "incomingprojectileradius" },
    { 0x46829ACF, "incomingspecialgrenadetracking" },
    { 0x74DF9A14, "incomming" },
    { 0x537C5CE5, "incomming_missile" },
    { 0xDED42138, "incomming_missile_blink_off" },
    { 0x8F4E9BF2, "incomming_missile_blink_on" },
    { 0x0035C0F4, "incomming_missiles" },
    { 0xBA9AA306, "incommingmissile_missile_death" },
    { 0xC18DC64D, "incommingmissile_sound_start" },
    { 0xB7AAA5BF, "incommingmissile_sound_stop" },
    { 0x0A623F1D, "incommingmissile_think" },
    { 0x66627BC4, "incompass" },
    { 0x4D044B61, "incomplete" },
    { 0xA5BE58A1, "inconsequential" },
    { 0x59E9DDC0, "inconsistant" },
    { 0xC4CB31B4, "inconsistencies" },
    { 0xDD80406C, "inconsistent" },
    { 0x14899F51, "incorporate" },
    { 0x156CF246, "incorrect" },
    { 0xF1021B2B, "incorrectly" },
    { 0xEC3C08D5, "incpersstat" },
    { 0x6DB5C83F, "incr" },
    { 0x8EBAE387, "incranimaimweight" },
    { 0x93249CBD, "incranimlookweight" },
    { 0xD8416955, "incrankxp" },
    { 0x4B74D075, "increament" },
    { 0x9BCE7C6D, "increase" },
    { 0xF886825C, "increase_accuracy_after_delay" },
    { 0x8E3DD639, "increase_fov" },
    { 0x7E57F782, "increase_ghost_health" },
    { 0xF79A378A, "increase_goal_radius_when_friendlies_flank" },
    { 0x0172C607, "increase_hit_count" },
    { 0x533868AC, "increase_lighting" },
    { 0xCFF1398B, "increase_mortar_delay" },
    { 0xDFB392E2, "increase_player_speed_after_dog_leaves" },
    { 0x7DB4CD60, "increase_shake_01" },
    { 0xEFBC3C9B, "increase_shake_02" },
    { 0x6863CA72, "increase_static" },
    { 0xE92907E3, "increase_value" },
    { 0xDA160E93, "increased" },
    { 0xF7BD2B86, "increasedkillstreakcount" },
    { 0x9FF0E26C, "increases" },
    { 0x16874E18, "increasing" },
    { 0x94F74D1D, "increasingly" },
    { 0x661BCB08, "incredibly" },
    { 0x331EFEDC, "increment" },
    { 0x9A990B27, "increment_amount" },
    { 0xA5F08D67, "increment_challenge_stat" },
    { 0xBE54368F, "increment_client_stat" },
    { 0xF81A1BCA, "increment_contract_times" },
    { 0xB21CF22A, "increment_count_and_spawn" },
    { 0x24FABB12, "increment_damage_timer" },
    { 0xC79651D3, "increment_dog_round_stat" },
    { 0x357EDC35, "increment_downed_stat" },
    { 0xC539AC66, "increment_escrow_for_player" },
    { 0x8E4E444F, "increment_global_stat" },
    { 0x139BEFEB, "increment_ignoreme" },
    { 0x1783EBEC, "increment_is_drinking" },
    { 0xAFC707B0, "increment_leap_weight" },
    { 0x00B3F6B2, "increment_life_stat" },
    { 0xE3B89053, "increment_list_offset" },
    { 0x29F2F25E, "increment_magic_box" },
    { 0x5A4BDA6C, "increment_map_cheat_stat" },
    { 0xD32AB984, "increment_map_stat" },
    { 0xFB450820, "increment_no_end_game_check" },
    { 0x14ECA715, "increment_nuked_zombie" },
    { 0x117E9702, "increment_off" },
    { 0x98E65874, "increment_on" },
    { 0x19AE90A3, "increment_on_death" },
    { 0x83EA9C03, "increment_player_perk_purchase_limit" },
    { 0xAB59A8C1, "increment_player_stat" },
    { 0xCE8D7318, "increment_root_stat" },
    { 0x6B433789, "increment_stat" },
    { 0xA52CFD21, "increment_take_cover_warnings_on_death" },
    { 0x688ED188, "increment_to_player" },
    { 0x4CF50A34, "increment_uimodel" },
    { 0xF098D242, "increment_window_repaired" },
    { 0x73234881, "increment_windows_repaired" },
    { 0xC1771F83, "increment_z" },
    { 0x0D691FA6, "increment_zm_dash_counter" },
    { 0x6231CFED, "incrementactivecontractprogress" },
    { 0x96ECB28F, "incrementactivecontracttime" },
    { 0xF63372DB, "incremental" },
    { 0x4CD58EC6, "incrementally" },
    { 0x1787D66C, "incrementcontracttimes" },
    { 0x8554C1B8, "incrementcounter" },
    { 0x5BFD80BF, "incremented" },
    { 0x79508D45, "incrementescrow" },
    { 0x8EB56AD1, "incrementescrowforplayer" },
    { 0x8CA28A2C, "incrementing" },
    { 0x6C72D43C, "incrementlifestat" },
    { 0xD1D6CFBF, "incrementmatchcompletionstat" },
    { 0x2CCCF6D1, "incrementplayerstat" },
    { 0x27FA4A1F, "increments" },
    { 0xD8E987F4, "incrementspecificweaponpickedupcount" },
    { 0xAA60A1F8, "incrgrenadekillcount" },
    { 0x02981BD8, "incriment" },
    { 0x47B34DD6, "incs" },
    { 0xB2B8E537, "incsgoal" },
    { 0x7BF7D322, "inctotalkills" },
    { 0xD17071CE, "incvalue" },
    { 0x3D4CC622, "incwhite" },
    { 0x6B932030, "ind" },
    { 0xA17D3FFE, "indecisive" },
    { 0x598DF7AA, "indeed" },
    { 0xF456BCF5, "indefinitely" },
    { 0x61E078F8, "indeicators" },
    { 0x73FC70FF, "indent" },
    { 0x191F2447, "indentlevel" },
    { 0xDB827984, "independantly" },
    { 0x93C2B3BD, "independent" },
    { 0x5ABB7FC0, "independently" },
    { 0x5E76F0AF, "index" },
    { 0x1DC37564, "index1" },
    { 0x160430BC, "index1_str" },
    { 0x335CF628, "index1_val" },
    { 0x8FCAE49F, "index2" },
    { 0x761A06D3, "index2_str" },
    { 0xB40E59BF, "index2_val" },
    { 0x37CC20A4, "index_ai" },
    { 0x44AE5225, "index_array" },
    { 0x7548105E, "index_change" },
    { 0x2FB6E6B4, "index_col" },
    { 0xFB60F061, "index_end" },
    { 0xB0D63DE2, "index_is_selected" },
    { 0x1C6A775F, "index_key" },
    { 0x5B09C647, "index_name" },
    { 0x1C500E3E, "index_names" },
    { 0xD5CE3222, "index_num" },
    { 0x020F8787, "index_small" },
    { 0xC2883625, "index_spawners" },
    { 0xD0FA76EA, "index_start" },
    { 0x19E0D343, "index_to_save" },
    { 0x0209020F, "index_to_update" },
    { 0x3D7BF00D, "index_to_use" },
    { 0xEAACA225, "index_wave" },
    { 0xBB2C8A0A, "index_weapon" },
    { 0x56BF78AD, "index_weapon_tok" },
    { 0xD02E97F4, "indexed" },
    { 0x4A0476FB, "indexes" },
    { 0xC4362435, "indexinarray" },
    { 0x29C7E691, "indexing" },
    { 0x93A1A6A2, "indexname" },
    { 0x933D4F13, "indexnew" },
    { 0xE929CFF6, "indexs" },
    { 0x78634598, "indexstring" },
    { 0x02BE3BAA, "india" },
    { 0x6F139E6A, "india_safe" },
    { 0x24D3C8E2, "india_up" },
    { 0xD71418C8, "indicate" },
    { 0x4144D135, "indicate_skipto" },
    { 0xEECA480D, "indicate_start" },
    { 0x359AD3DC, "indicated" },
    { 0xAF70B2E3, "indicates" },
    { 0x9CF496C9, "indicating" },
    { 0x4DE2B94F, "indication" },
    { 0xB7ACCDF4, "indicator" },
    { 0xEB374CE7, "indicators" },
    { 0xA69DB2C4, "indices" },
    { 0xF4C884B9, "indicies" },
    { 0xFA828F17, "indirect" },
    { 0xE16F9C7A, "indirectly" },
    { 0xE3F052E9, "indiscriminately" },
    { 0xEFC5ED1C, "indistinct" },
    { 0x149E0455, "indiv" },
    { 0xFC1E2518, "individual" },
    { 0x02E50323, "individual_sampan_setup" },
    { 0x7CA513C5, "individualdelay" },
    { 0x504B7C1D, "individually" },
    { 0x4EC5C1A3, "individuial" },
    { 0xCF0353D8, "indiviual" },
    { 0x50EF9A51, "indivual" },
    { 0x3BF064F4, "indoor" },
    { 0xDAA3B908, "indoor_canister_1" },
    { 0x5E98FA3E, "indoor_chain" },
    { 0x1A92B7F0, "indoor_crow2" },
    { 0x40953259, "indoor_crow3" },
    { 0xFEA19666, "indoor_crow4" },
    { 0xE71EE293, "indoor_crow_damage_trig" },
    { 0xDDD57AF4, "indoor_crow_fly" },
    { 0xBFF69819, "indoor_crows" },
    { 0x0AAA1CD5, "indoor_enemy" },
    { 0xCB68BACA, "indoor_fighter" },
    { 0xD0D88D22, "indoor_force_goal" },
    { 0x3EEEEE71, "indoor_forcegoal" },
    { 0x3285F41C, "indoor_rusher" },
    { 0x8D055FF5, "indoor_think" },
    { 0x595A9460, "indoor_volumes" },
    { 0x219E01E7, "indoors" },
    { 0x96C422B8, "indsutrial" },
    { 0x167E8625, "indulgent" },
    { 0xE4379F18, "industrial" },
    { 0x5D71B493, "ineffective" },
    { 0xC737B2BD, "inefficient" },
    { 0x4104E7ED, "inendgameflow" },
    { 0xFCF47F35, "inermission_rocket_init" },
    { 0x73CF01CF, "inert" },
    { 0x47601ADA, "inert_bump" },
    { 0x922C3A1E, "inert_crawl_substate_index" },
    { 0x91AE1E3E, "inert_crawl_substates" },
    { 0x54C387BA, "inert_crawl_trans_run" },
    { 0xABD4A633, "inert_crawl_trans_sprint" },
    { 0x919CF734, "inert_crawl_trans_walk" },
    { 0xE6A570D1, "inert_damage" },
    { 0xEEB756A3, "inert_delay" },
    { 0xA86378DB, "inert_eye_glow" },
    { 0x1DB47196, "inert_locations" },
    { 0x5AA0CDB7, "inert_spawn_location" },
    { 0xD9D1BF3A, "inert_substate_index" },
    { 0x8064A2A6, "inert_substate_override" },
    { 0x222B07D2, "inert_substates" },
    { 0x1B1A99F6, "inert_think" },
    { 0x1A766208, "inert_trans_anim" },
    { 0x4270F0C6, "inert_trans_run" },
    { 0x84940477, "inert_trans_sprint" },
    { 0x9849CB18, "inert_trans_walk" },
    { 0xCDD077DF, "inert_transition" },
    { 0xEADA0969, "inert_wakeup" },
    { 0x22F1CED5, "inert_wakeup_ai_dist" },
    { 0x6B24AEFC, "inert_wakeup_dist" },
    { 0x4C134545, "inert_wakeup_grenade_dist" },
    { 0x5F3EDB04, "inert_wakeup_override" },
    { 0x6BDE4A2B, "inert_wakeup_sprint_dist" },
    { 0xE17A509B, "inert_watch_goal" },
    { 0x3CF685DA, "inert_weapon_fired_dist" },
    { 0xB66AB52C, "inert_zombies_init" },
    { 0xBE6BE554, "inexistent" },
    { 0x785CDAB7, "inexplicable" },
    { 0xB7981502, "inf" },
    { 0x09F41282, "inf2squad" },
    { 0x7AF1B63E, "inf_all_move" },
    { 0xD8AAE141, "inf_all_move_done" },
    { 0x1C7F1844, "inf_all_move_done_done" },
    { 0xFEEB2E76, "inf_move" },
    { 0xF679D1F9, "inf_move_done" },
    { 0xD077C2FC, "inf_move_done_done" },
    { 0x08EE6192, "inf_move_ready" },
    { 0x47C923AB, "inf_prompt" },
    { 0xEC71CB3E, "inf_prompt_done" },
    { 0x860DE041, "inf_prompt_done_done" },
    { 0xD68D3C2B, "inf_prompt_ready" },
    { 0xBD2AE07B, "infamous" },
    { 0xC20B2E4E, "infantry" },
    { 0xDDB1627F, "infantry_close" },
    { 0xBB1268D7, "infantry_dialogue" },
    { 0xE53E44DB, "infantry_exposed" },
    { 0x198EE780, "infantry_generic" },
    { 0xDB64EBFB, "infantry_init" },
    { 0x438D1998, "infantry_many" },
    { 0x03B35F91, "infantry_panzer" },
    { 0x03BF5C1C, "infantry_sniper" },
    { 0x25E141E0, "infantryfrozen_spawnfunction" },
    { 0xAB4FF9E6, "infantryhung_spawnfunction" },
    { 0xAB4DA0E2, "infantryman" },
    { 0xF597B9BC, "infants" },
    { 0x36A42FDA, "infatry" },
    { 0x9C173E2D, "infected" },
    { 0xD50F2C00, "infection" },
    { 0xEAE01395, "infects" },
    { 0x0233EAF6, "infidel" },
    { 0xA6A2D8E9, "infidels" },
    { 0xF0C3D525, "infiltrate" },
    { 0x6BB968FA, "infiltration" },
    { 0xE8B0A4FE, "infinalfight" },
    { 0x6598A171, "infinalkillcam" },
    { 0xABC1EE99, "infinate" },
    { 0x8697C531, "infinite" },
    { 0x9443B54E, "infinite_ally" },
    { 0x830F6ECF, "infinite_block" },
    { 0x6FE46CE1, "infinite_mana" },
    { 0x4525673A, "infinite_stinger" },
    { 0xA260245B, "infiniteammo" },
    { 0x47AE3A4B, "infiniteloop" },
    { 0xE3C0899C, "infinitely" },
    { 0x580B42CA, "infinitespawn" },
    { 0x4EB5821D, "infinity" },
    { 0xFECCB0D9, "infintite_block" },
    { 0xD0EFEBA3, "infirearea" },
    { 0xA69238BA, "infirmary" },
    { 0x26CDD294, "inflagradius" },
    { 0x0E934800, "inflagzone" },
    { 0x47CFD3CB, "inflarevisionarea" },
    { 0x0BF0071E, "inflate" },
    { 0x78186316, "inflict" },
    { 0xF1F434D9, "inflicted" },
    { 0x75DB6CBF, "inflicter" },
    { 0x178903FD, "inflictor" },
    { 0x7F40242C, "inflictor_weapon" },
    { 0x1BD1265F, "inflictorbirthtime" },
    { 0x3274411A, "inflictorchallenge_hatchettosscount" },
    { 0xF3F73EE4, "inflictorent" },
    { 0xD8A308C4, "inflictorentnum" },
    { 0x6DEB0E0C, "inflictorenttype" },
    { 0xFEE5A1C2, "inflictoriscooked" },
    { 0x3FEED773, "inflictorownerwassprinting" },
    { 0x123016D7, "inflictorownerweaponatlaunchpickedup" },
    { 0x96BAF7E9, "inflictorplayerhasengineerperk" },
    { 0xDDEA8D89, "inflicts" },
    { 0xF993840E, "inflight" },
    { 0xAD66A037, "inflight_cut_1" },
    { 0x3B5F30FC, "inflight_cut_2" },
    { 0xF37A26F2, "inflight_in_cockpit" },
    { 0x870DB0CA, "influence" },
    { 0x0C34173A, "influenced" },
    { 0xECC9583C, "influencepos" },
    { 0xB860B29C, "influencer" },
    { 0x13DEBD0F, "influencer_enemy_sphere" },
    { 0xCA9D1FA2, "influencer_entity" },
    { 0xA3BAD657, "influencer_friendly_cylinder" },
    { 0x53AD7DC6, "influencer_friendly_sphere" },
    { 0xBF8CE3D1, "influencer_helicopter_cylinder" },
    { 0x72DE8D4C, "influencer_id" },
    { 0xB7874897, "influencer_org" },
    { 0x9CD1B785, "influencer_qrdrone_cylinder" },
    { 0x74B79A2D, "influencer_removed" },
    { 0xB3000E6F, "influencer_squad" },
    { 0x26D6A650, "influencer_team" },
    { 0x7F414C90, "influencer_tvmissile_cylinder" },
    { 0xCD8F3420, "influencer_weapon_cylinder" },
    { 0xBFEEBE5B, "influencerent" },
    { 0x09DE0EFB, "influencerid" },
    { 0xAD2B0CDF, "influencers" },
    { 0x15CCA7F1, "influencersenemy" },
    { 0xFD6DF31A, "influencersfriendly" },
    { 0x8B173C54, "influencertype" },
    { 0xDE632D05, "influences" },
    { 0x38BFCE81, "info" },
    { 0x424945D3, "info_array" },
    { 0x08FAAFD6, "info_by_type" },
    { 0xB04F8E81, "info_gather" },
    { 0xCA9F5538, "info_index" },
    { 0x4F86DDE3, "info_intermissions" },
    { 0x9A3E4388, "info_keys" },
    { 0xAD7D0AA2, "info_origin" },
    { 0xD12AB93B, "info_player_deathmatch" },
    { 0x61E16B66, "info_player_respawn" },
    { 0xF5B1F099, "info_player_respawns" },
    { 0xFA719F13, "info_player_spawn" },
    { 0xA0BF62E6, "info_player_start" },
    { 0x3F790AC0, "info_recorded" },
    { 0x157F3BE7, "info_struct" },
    { 0xAFD8785B, "info_vehicle_node" },
    { 0x6DEC14CA, "info_volume" },
    { 0x7FCD60CC, "info_volume_vehicle_collide" },
    { 0x4E7A9905, "info_volumes" },
    { 0xD7802897, "infocard" },
    { 0x64DE3647, "infocard_details_scale" },
    { 0x5DF5DC27, "infocard_height" },
    { 0xCF4027D9, "infocard_icon" },
    { 0xD8FC30E8, "infocard_offscreen_x" },
    { 0xD6A1950C, "infocard_onscreen_x" },
    { 0xF3CAEE83, "infocard_prep_top" },
    { 0x796F6FFD, "infocard_req_check_size" },
    { 0x6C09AC64, "infocard_req_height" },
    { 0x1CCC7DFA, "infocard_req_icon_size" },
    { 0x2E8560D7, "infocard_req_icon_x" },
    { 0x1DD38C2E, "infocard_req_top" },
    { 0xBC61B32F, "infocard_req_width" },
    { 0xB8849F26, "infocard_width" },
    { 0x69293DE7, "infocard_y" },
    { 0x508D0D0A, "infocardautohide" },
    { 0x3DE276DC, "infog" },
    { 0xAA7B4852, "infog_clientfield_cb" },
    { 0x9B48E37F, "infogtimer" },
    { 0x68EEDB83, "infoindex" },
    { 0xF8128306, "infomessage" },
    { 0x1E061C96, "inform" },
    { 0x1A80E98C, "inform_clientvm_of_migration" },
    { 0x40B348C0, "inform_on_ads_button" },
    { 0x6C6A062F, "inform_on_damage_trigger" },
    { 0x97C47A5A, "inform_on_ft_button" },
    { 0x53AC82A7, "inform_on_touch_trigger" },
    { 0x8BBBA479, "informant" },
    { 0xCF77D9FE, "informant_org" },
    { 0x6D1C7A59, "information" },
    { 0xB4B4A419, "informative" },
    { 0x1E21CFF6, "informattacking" },
    { 0x6010B1F6, "informdialog" },
    { 0xBDDC4A59, "informed" },
    { 0x41C3823F, "informer" },
    { 0x592D275E, "informincoming" },
    { 0x8992A18A, "informing" },
    { 0x70554612, "informkillconfirm" },
    { 0x3CA53173, "informreloading" },
    { 0x93259209, "informs" },
    { 0xA9A6C838, "informsupressed" },
    { 0xC9725A05, "informto" },
    { 0x45B0E6A8, "infos" },
    { 0xB3B9815A, "infostring" },
    { 0x6F9474C4, "infotext" },
    { 0x40D2233E, "infovolumedebuginit" },
    { 0x38E7C152, "inframes" },
    { 0x9C8DF89A, "infrared" },
    { 0x3175176B, "infrared_changed" },
    { 0x79A43A63, "infrared_gadget_off" },
    { 0xCB313EAF, "infrared_gadget_on" },
    { 0x62B1E44A, "infrared_is_inuse" },
    { 0x31A4F050, "infrared_off" },
    { 0xA27C7C35, "infrared_on_connect" },
    { 0x0CC7674B, "infrared_on_disconnect" },
    { 0x38C3B55E, "infrared_on_give" },
    { 0xBCF65D92, "infrared_on_spawn" },
    { 0x60855C30, "infrared_on_take" },
    { 0xE5DBD8F3, "infrared_removed" },
    { 0xEDF42B0A, "infraredvisionset" },
    { 0x40CD50F4, "infrastructure" },
    { 0x970967EB, "infromation" },
    { 0xE4E4C5C9, "infront" },
    { 0xB66FE4F5, "infrot" },
    { 0x774BD060, "infsquad" },
    { 0x5A34F0A7, "infsquadid" },
    { 0x8512AFC7, "infullscreen" },
    { 0x96A48BFE, "infx" },
    { 0xDD9A8F6B, "ing" },
    { 0x9CA7E17A, "ingame" },
    { 0x32F50555, "ingenuity" },
    { 0x34B5D90F, "ingnored" },
    { 0x00B4AE0D, "ingore" },
    { 0x5D52D25E, "ingoreall" },
    { 0xEEE1EF0B, "ingoreme" },
    { 0x96EF9B8C, "ingores" },
    { 0x266BE277, "ingraceperiod" },
    { 0xE38B80E2, "ingrenadeblastradius" },
    { 0x8EC91217, "ingroundincendiary" },
    { 0x12A9E5DA, "ingroundnapalm" },
    { 0xD392EA9C, "inhale" },
    { 0xBF0EC985, "inhaling" },
    { 0x4E9C5D9F, "inheliproximity" },
    { 0x54B26BA0, "inherent" },
    { 0x52E6F6AD, "inherited" },
    { 0xB1003556, "inheriting" },
    { 0x4D5E1E33, "inhibit_scoring_from_zombies" },
    { 0xB2118873, "inintial" },
    { 0xC35E6AAB, "init" },
    { 0xE3D27DA3, "init71" },
    { 0x0923FF8B, "init_1" },
    { 0x971C9050, "init_2" },
    { 0xAAF12960, "init_aa_guy" },
    { 0x18F95194, "init_abilities" },
    { 0xC2C3841B, "init_achievement" },
    { 0x4DAA9C02, "init_achievement_variable" },
    { 0xF865D481, "init_acid_trap_trigs" },
    { 0xA76F834F, "init_active_camo" },
    { 0x479EC7DC, "init_activision_credits" },
    { 0x5C64F570, "init_activision_credits_pc" },
    { 0x0662F34B, "init_activision_credits_ps3" },
    { 0x8494CA28, "init_activision_credits_wii" },
    { 0x152480B1, "init_additional_primary_weapon" },
    { 0x0742DBFE, "init_additionalprimaryweapon_machine_locations" },
    { 0x4C0D45E9, "init_afghan_anims_part1" },
    { 0x96CE0059, "init_afghan_anims_part1b" },
    { 0x720FC052, "init_afghan_anims_part2" },
    { 0x23BFD133, "init_after_save_restore" },
    { 0x032FB3A3, "init_ai_anims" },
    { 0x4DED0809, "init_ai_drone_spawners" },
    { 0x3A204F73, "init_ai_e1_breach" },
    { 0x57823F63, "init_ai_e2_stairs" },
    { 0x47BF4287, "init_ai_rappel" },
    { 0x69B14CC1, "init_ai_supplements" },
    { 0xCB74B415, "init_aibattlechatter" },
    { 0x24C97663, "init_aircraft_list" },
    { 0x0AA1143A, "init_airfield_flags" },
    { 0xC9820BAE, "init_airfield_settings" },
    { 0xB9890F58, "init_alcatraz_zipline" },
    { 0x362896C0, "init_all_preexisting_dogs" },
    { 0x0BD8C4FC, "init_allies" },
    { 0x85B5A9E0, "init_ally" },
    { 0x16405032, "init_ambient_boats" },
    { 0x40468D77, "init_ambient_fake_vehicle" },
    { 0xD10CD23B, "init_ambient_models" },
    { 0xC7DFE233, "init_ambient_oneoff_models" },
    { 0x3BF62FDA, "init_ambient_oneoff_vehicles" },
    { 0x44E51E21, "init_ambient_package_triggers" },
    { 0xCB714442, "init_ambient_vehicles" },
    { 0x95AC4846, "init_ambush_fields" },
    { 0x6E6F6D35, "init_ammo_ring" },
    { 0x205FF143, "init_and_run" },
    { 0xAD24544F, "init_angola_anims" },
    { 0xD34D9BDB, "init_anim_model" },
    { 0x14E7B25A, "init_anim_rate" },
    { 0x599EB192, "init_anim_set_overrides" },
    { 0x4342B859, "init_anim_slice_times" },
    { 0xF061D0D6, "init_animated_bridges" },
    { 0x0B8FFFD7, "init_animatedmodels" },
    { 0x1BB0BBCC, "init_animatedmodels_dump" },
    { 0x1E6DEAC8, "init_anims" },
    { 0x8BDD3CB7, "init_animscripts" },
    { 0x63FAC781, "init_animsounds" },
    { 0xD5348A76, "init_animsounds_for_animname" },
    { 0x631BFEB5, "init_animtree" },
    { 0x9C1D74FA, "init_apc_alley_army" },
    { 0x6AA42097, "init_apc_alley_digbats" },
    { 0x868B1458, "init_ape_powerup_drops" },
    { 0xDBBFE474, "init_ape_zombie_anims" },
    { 0xC58E171F, "init_arms" },
    { 0x83883D2B, "init_astro_zombie_anims" },
    { 0x573F0339, "init_astro_zombie_fx" },
    { 0x69EA2871, "init_attack_point" },
    { 0x709A79A3, "init_attackdrones" },
    { 0x4E8CC9C3, "init_attackdrones_start_ai" },
    { 0x061894D1, "init_audio_aliases" },
    { 0xDA8E936E, "init_audio_functions" },
    { 0x54034374, "init_audio_material_triggers" },
    { 0xE7B2B133, "init_audio_step_triggers" },
    { 0xA4CC501C, "init_audio_triggers" },
    { 0x9F276FC1, "init_audio_turret" },
    { 0xDC85F705, "init_axis" },
    { 0xD1A57038, "init_back_hallway_breachers" },
    { 0xDC15DDB6, "init_background_scenes" },
    { 0x1CC6B8A7, "init_balcony_ai" },
    { 0x700F9FE1, "init_balcony_plane" },
    { 0x3CD0AD8A, "init_ball_turret" },
    { 0xA048D8A3, "init_barnes_pointat_triggers" },
    { 0x1ACDDC76, "init_barricades" },
    { 0xF60264D5, "init_basement_guy" },
    { 0x306CC05B, "init_battlechatter" },
    { 0xCFB3C79D, "init_bg_elements" },
    { 0x5BFB53DB, "init_blitz" },
    { 0x48499CFD, "init_blocker_fx" },
    { 0x7EF3C147, "init_blockers" },
    { 0xEFF8A342, "init_board_lights" },
    { 0x498442AB, "init_boat_list" },
    { 0xCC0F301F, "init_bookshelf_guy" },
    { 0x64C6BBF2, "init_bot_gametype" },
    { 0x090B0AF3, "init_bot_settings" },
    { 0x58DA1482, "init_bouncing_betties" },
    { 0x00652C4D, "init_box" },
    { 0x023B9880, "init_box_footprints" },
    { 0x8DD9F05F, "init_box_respin" },
    { 0xEBD3992D, "init_box_respin_respin" },
    { 0x1298558C, "init_broadcastcenter" },
    { 0xBFAB4186, "init_build_buildables" },
    { 0x47CDE955, "init_buildables" },
    { 0x9C1288E3, "init_building_explosion_states" },
    { 0x02864623, "init_bunker_damage" },
    { 0x30251085, "init_buried_stats" },
    { 0xF829113C, "init_bus" },
    { 0xF939AF6C, "init_bus_door_anims" },
    { 0xC585EF9C, "init_bus_props_anims" },
    { 0x27BA232D, "init_button_wrappers" },
    { 0x141A32C6, "init_buy" },
    { 0xF053C0D8, "init_call_boxes" },
    { 0x10BC1A16, "init_callbacks" },
    { 0xC40086C1, "init_candy_context" },
    { 0x391D882A, "init_capture_progress" },
    { 0x10A0D455, "init_capture_zombie" },
    { 0xDD1B941D, "init_capture_zone" },
    { 0x5E78485C, "init_capture_zones" },
    { 0xA17A5A7F, "init_car_anims" },
    { 0x6F32627C, "init_casual_hero" },
    { 0xA1BDAACF, "init_cd" },
    { 0xFE8126AA, "init_celerium_flags" },
    { 0x9139FBD4, "init_chaff" },
    { 0x73817716, "init_characters" },
    { 0xAE398070, "init_checkpoint_spotlights" },
    { 0xD44ADA08, "init_civilians" },
    { 0xB520815A, "init_clark_death" },
    { 0x56765C97, "init_clark_death_dof_and_fog" },
    { 0x6EFF02CB, "init_claw" },
    { 0x449D1FCE, "init_claw_boot_sequence" },
    { 0x0C42DAE6, "init_claw_damage_filter" },
    { 0xA33E7EBF, "init_cleansed" },
    { 0x215DFFAB, "init_cleansed_powerup_fx" },
    { 0xC3391121, "init_cleansed_powerups" },
    { 0xEA228B9C, "init_clearing_anims" },
    { 0xE2448AC6, "init_clearing_player_anims" },
    { 0x5EA17D6E, "init_clearing_prop_anims" },
    { 0xFF58A260, "init_client_field_callback_funcs" },
    { 0xCB6627C6, "init_client_flag_callback_funcs" },
    { 0xBF80C789, "init_client_flag_callbacks" },
    { 0x525BE11F, "init_client_flags" },
    { 0x04C64E7B, "init_client_mp_variables" },
    { 0x0A9E17E5, "init_client_sp_variables" },
    { 0x8AEEFA17, "init_clientfaceanim" },
    { 0x2EA898A8, "init_clientfields" },
    { 0x4C20CB5F, "init_clientflag_variables" },
    { 0x6C157398, "init_clientflags" },
    { 0x54A2B7C6, "init_club_battle_damage_timing" },
    { 0x58D58259, "init_code_filters" },
    { 0x2F9A48DD, "init_color_grouping" },
    { 0xA99DC04E, "init_compound_anims" },
    { 0xB679619C, "init_compound_player_anims" },
    { 0x8AEDC808, "init_compound_prop_anims" },
    { 0x8ABD3F2B, "init_compound_vehicle_anims" },
    { 0xA030546E, "init_compound_woods" },
    { 0x068A1859, "init_constants" },
    { 0x306CB562, "init_containment" },
    { 0xE54878A9, "init_convoy_vehicle" },
    { 0x6BF5FAE9, "init_corpse_poses" },
    { 0x548074BA, "init_cosmodrome_box_screens" },
    { 0xF2524300, "init_courtyard_ai" },
    { 0x63E9B372, "init_courtyard_destruction" },
    { 0x85B8B059, "init_courtyard_envfx" },
    { 0xC3D564BB, "init_courtyard_gunner_truck" },
    { 0xABFD8A71, "init_courtyard_rpg_rebels" },
    { 0x485A97DE, "init_courtyard_trucks" },
    { 0xF89BB811, "init_craftable_choke" },
    { 0x95743E9F, "init_craftables" },
    { 0x952D7EFD, "init_crash_triggers" },
    { 0x9400E972, "init_crashing_anims" },
    { 0xF2382CBB, "init_crawl_back_guy" },
    { 0xC65687EB, "init_crc_glass_monster_clip" },
    { 0x611DF7BC, "init_credits" },
    { 0xFD9FD803, "init_crew_emplacement" },
    { 0x71948372, "init_crosshair_material" },
    { 0x039524A5, "init_crypt_gems" },
    { 0x04EB944F, "init_custom_ai_type" },
    { 0xCD3CBF15, "init_custom_perks" },
    { 0x5ADDC9FB, "init_custom_traversals" },
    { 0x0799CFC6, "init_damage_filter" },
    { 0xDBCB04C4, "init_damage_fxanims" },
    { 0x8727A91A, "init_dds_active_events" },
    { 0x62944E88, "init_dds_categories" },
    { 0x555E02DC, "init_dds_categories_axis" },
    { 0x8BAD1488, "init_dds_countryids" },
    { 0x3DD24F05, "init_dds_flags" },
    { 0xB3926CF8, "init_deadshot" },
    { 0xD2E4FA20, "init_debug_center_screen" },
    { 0x55BF5E33, "init_deck_ambient_oneoffs" },
    { 0x3BAE772F, "init_defalco_osprey" },
    { 0xDB4E0C7D, "init_default_zcleansed_powerups" },
    { 0xD487DE87, "init_defend_left_asd" },
    { 0x65D83D5F, "init_defend_rappelers" },
    { 0x3B6F140C, "init_defend_right_asd" },
    { 0x04B2B14F, "init_delay" },
    { 0x90502A3D, "init_desk_guy" },
    { 0x3AABE370, "init_dialogue" },
    { 0x85AD55F5, "init_difficulty" },
    { 0x74D88763, "init_director_behind_vox" },
    { 0xB79F117C, "init_director_zombie_anims" },
    { 0xD5005E6C, "init_divetobase" },
    { 0xA1AF6BB4, "init_divetonuke" },
    { 0xE727A181, "init_docks_colt_victims" },
    { 0xC2C8793D, "init_docks_container_pdf" },
    { 0x3B2DBC6D, "init_docks_container_pdf_rpg" },
    { 0x214074C8, "init_docks_frontgate_pdf" },
    { 0xD17C9809, "init_docks_gate_turret_truck" },
    { 0x3EF78240, "init_dog" },
    { 0x2B543353, "init_dog_anims" },
    { 0xE7F97171, "init_dog_fx" },
    { 0x7181D36B, "init_dogs" },
    { 0x8265A63A, "init_door" },
    { 0xDD5AEDB1, "init_door_anims" },
    { 0xAC16DCEF, "init_door_clip" },
    { 0xD1C2BD0F, "init_door_collision" },
    { 0x90F4CB69, "init_door_sounds" },
    { 0x3AC873B5, "init_doors" },
    { 0xA6E30992, "init_doubletap2" },
    { 0x6B3B35B2, "init_drive" },
    { 0x2B8B970B, "init_driveable_wingsuit" },
    { 0x5FFBF5E7, "init_drone_anims" },
    { 0x4C519FF0, "init_drone_manager" },
    { 0x3E613EAF, "init_drones" },
    { 0x20456414, "init_drones_for_level" },
    { 0xE67F083C, "init_droneshot_scenes" },
    { 0xB7589864, "init_dropoffset" },
    { 0x2AF717C6, "init_dtp_triggers" },
    { 0x7A51F056, "init_dummies" },
    { 0xFA6541CA, "init_dummy_spawn_triggers" },
    { 0x30100A56, "init_dummy_spawners" },
    { 0x1E1B8841, "init_dummy_think_triggers" },
    { 0xE5E53B1A, "init_duplicate_render_bundles" },
    { 0x74CB963F, "init_duplicaterender_settings" },
    { 0x8124512C, "init_dvars" },
    { 0xD0EEA55D, "init_e5_slide_guys" },
    { 0xD260002E, "init_ee_ghost_piano_flags" },
    { 0xBB2A5489, "init_elec_trap_trigs" },
    { 0x0FD67ECD, "init_electric_cherry" },
    { 0x78EDCF58, "init_elevator" },
    { 0xCF22681F, "init_elevator1_doors" },
    { 0x966420D0, "init_elevator2_doors" },
    { 0x17594DCD, "init_elevator_devgui" },
    { 0x33EF09AE, "init_elevator_perks" },
    { 0xB361F60D, "init_elevator_shaft_zones" },
    { 0xC83D3033, "init_elevators" },
    { 0x4C00C9AE, "init_end_rail_gunner_truck" },
    { 0xFA066393, "init_ending_friendlies" },
    { 0x4A2D0425, "init_engineer_zombie_anims" },
    { 0x7642BCFC, "init_engineers" },
    { 0xE277F74C, "init_ent_shader_materials" },
    { 0x8B28D431, "init_equipment_hint_hudelem" },
    { 0x45209F4F, "init_equipment_upgrade" },
    { 0xECDE7654, "init_escape_elevators_anims" },
    { 0xE428CD51, "init_escape_elevators_animtree" },
    { 0x0546DA13, "init_escape_pod" },
    { 0x3C74F3A1, "init_escape_shot_woods" },
    { 0x47FE02A5, "init_escape_stair_guy" },
    { 0x9E0D5B3A, "init_event" },
    { 0x0141EE42, "init_event4_truck" },
    { 0x51A2F97E, "init_event_flags" },
    { 0xC360B5F6, "init_excavator_consoles" },
    { 0xD9AB85AC, "init_exploders" },
    { 0x01A193C6, "init_explosions" },
    { 0x9A2A31C1, "init_extra_blackhole_anims" },
    { 0x5660E23E, "init_f35_hud_damage" },
    { 0x47EDD956, "init_faceburn" },
    { 0x5206D76F, "init_factory_objectives" },
    { 0x26B38D85, "init_fake_slide_heli_woods" },
    { 0x6DC018C8, "init_fake_slide_krav" },
    { 0x74796978, "init_fake_slide_woods" },
    { 0xFAC6CA3E, "init_fake_targets" },
    { 0xCFEA2AD1, "init_fan_fxanim" },
    { 0x49E08A07, "init_fan_trap_animtree" },
    { 0xB895E299, "init_fan_trap_trigs" },
    { 0xED2AADFC, "init_fastrope" },
    { 0x20F254BB, "init_fbi" },
    { 0x9C2E97B2, "init_female_spawn" },
    { 0xD82F29B2, "init_fetch_buildables" },
    { 0x5D486074, "init_fight" },
    { 0x6E727311, "init_fighter" },
    { 0x54301512, "init_filter_angola_gun_cam" },
    { 0x28BCBD68, "init_filter_base_frame_transition" },
    { 0x987D4651, "init_filter_binoculars" },
    { 0x458CAB93, "init_filter_binoculars_with_outline" },
    { 0x669D56AD, "init_filter_blood_droplets" },
    { 0x2C6745D7, "init_filter_blood_spatter" },
    { 0x87A235EF, "init_filter_blood_splats" },
    { 0x9ED1F175, "init_filter_claw_boot" },
    { 0x37FBC3D9, "init_filter_crackedglass_pakistan3" },
    { 0xC7DC7C1D, "init_filter_custom_tow" },
    { 0xE50AC283, "init_filter_drowning_damage" },
    { 0x3EDE9623, "init_filter_emp" },
    { 0x2FAED441, "init_filter_ev_interference" },
    { 0xBD27C279, "init_filter_f35_damage" },
    { 0x0CFE957F, "init_filter_feedback_blood" },
    { 0x08CFE9E0, "init_filter_frame_transition" },
    { 0x1B1D6213, "init_filter_frost" },
    { 0x1107C372, "init_filter_gasmask" },
    { 0x0E724104, "init_filter_harper_blood" },
    { 0x932D212A, "init_filter_hazmat" },
    { 0x5A922E24, "init_filter_helmet" },
    { 0x2282C1C9, "init_filter_hud_outline" },
    { 0xC09E0F83, "init_filter_hud_outline_code" },
    { 0x90159C32, "init_filter_hud_projected_grid" },
    { 0x6DB44C5C, "init_filter_hud_projected_grid_haiti" },
    { 0xECDF7E11, "init_filter_hud_projected_pip" },
    { 0xBB890EE2, "init_filter_indices" },
    { 0xF9D06048, "init_filter_infrared" },
    { 0x5AEF0326, "init_filter_karma_lowlight" },
    { 0xBD7C1082, "init_filter_karma_spiderbot" },
    { 0x73164CD2, "init_filter_keyline_blend" },
    { 0x198645B1, "init_filter_lensflare" },
    { 0xF2877227, "init_filter_massiah" },
    { 0x19A3ADFD, "init_filter_oob" },
    { 0x1F1AF853, "init_filter_overdrive" },
    { 0x7F2884CB, "init_filter_oxygenmask" },
    { 0x23F44C52, "init_filter_pakistan3_outline" },
    { 0x199703F6, "init_filter_pentagon_blowout" },
    { 0x2EE3DAB4, "init_filter_pentagon_bulgeblur" },
    { 0x956C3FE9, "init_filter_pentagon_fullscreen" },
    { 0xAFE5AE4F, "init_filter_pentagon_multicam1" },
    { 0x3DDE3F14, "init_filter_pentagon_multicam2" },
    { 0x29C41029, "init_filter_radialblur" },
    { 0x8EB0D550, "init_filter_rage" },
    { 0xFEC11BD6, "init_filter_rage_hit" },
    { 0x382A50E5, "init_filter_rage_simple" },
    { 0x5C4AECCD, "init_filter_raindrops" },
    { 0x75295385, "init_filter_rccarcam" },
    { 0x6FFCA252, "init_filter_rts_hologram" },
    { 0xD2CADE1F, "init_filter_rts_vehicle_damage" },
    { 0xBDF18B0C, "init_filter_satellite_transition" },
    { 0x9F990145, "init_filter_scope" },
    { 0xE4987221, "init_filter_sgen_sprite_rain" },
    { 0x9B3C4C50, "init_filter_sonar" },
    { 0xE1E12BF0, "init_filter_sonar_attachment" },
    { 0xCD6FC7CF, "init_filter_speed_burst" },
    { 0x45B9CD7D, "init_filter_sprite_blood" },
    { 0x1532508D, "init_filter_sprite_blood_heavy" },
    { 0xBD07E308, "init_filter_sprite_dirt" },
    { 0xB5F9C4A1, "init_filter_sprite_rain" },
    { 0x2A3F316E, "init_filter_sprite_transition" },
    { 0xC12B34CF, "init_filter_squirrel_raindrops" },
    { 0x3F30C15C, "init_filter_superflare" },
    { 0xF0078020, "init_filter_tactical" },
    { 0x10DC6EA8, "init_filter_tacticalmask" },
    { 0x85BDAC06, "init_filter_teargas" },
    { 0xF44C9DD9, "init_filter_teleportation" },
    { 0x52F1F1E9, "init_filter_teleporter_base" },
    { 0xC769801D, "init_filter_teleporter_sprite" },
    { 0xEBCE407B, "init_filter_teleporter_top" },
    { 0x36872DE5, "init_filter_tvguided" },
    { 0x87678077, "init_filter_vehicle_damage" },
    { 0x179634E1, "init_filter_vehicle_hijack_oor" },
    { 0x28C704C9, "init_filter_vehiclehijack" },
    { 0x1D7F017D, "init_filter_vision_pulse" },
    { 0xCFEB5827, "init_filter_warp_sr71" },
    { 0x93562451, "init_filter_water_dive" },
    { 0x0209DD8C, "init_filter_water_sheeting" },
    { 0xD8DF67B5, "init_filter_zm_turned" },
    { 0x009E05CE, "init_filter_zodiac_raindrops" },
    { 0x4C8FCEBE, "init_final_killcam" },
    { 0x61A6BA4A, "init_final_killcam_team" },
    { 0xBD99B131, "init_final_launcher" },
    { 0x326EB95E, "init_fire_building_civilians" },
    { 0x92158F2C, "init_fire_direction" },
    { 0x6A83CF21, "init_fire_direction_vars" },
    { 0x321D4727, "init_fire_fx" },
    { 0xE6916830, "init_first_blood_guys" },
    { 0x37AF8A07, "init_flags" },
    { 0x6AF7DA6C, "init_flamethrower_triggers" },
    { 0x7F0D078D, "init_flinger" },
    { 0x84A44527, "init_floor_guys" },
    { 0x980CA37E, "init_fog_vol_to_visionset_monitor" },
    { 0x60058E5F, "init_foliage_cover" },
    { 0x23BD3271, "init_foliage_cover_variables" },
    { 0x7E545807, "init_foliage_stealth_on_player" },
    { 0xF75E5145, "init_foliage_triggers" },
    { 0x3C7DB356, "init_footstep_safe_spots" },
    { 0x803D2E7D, "init_for_menendez_scene" },
    { 0xD84156A3, "init_force_goal_guy" },
    { 0xE2B3346B, "init_foreshadow_seals" },
    { 0x40EC5F72, "init_fountain" },
    { 0xD4D17EA3, "init_fountain_zone" },
    { 0xEE9B4B73, "init_friendlies" },
    { 0x34247146, "init_friendly_fire_stats" },
    { 0x67C7352A, "init_friendly_heli" },
    { 0x8CE6B97C, "init_friendly_reinforcements" },
    { 0xC0DC941A, "init_friendlychain" },
    { 0x8A4BB48C, "init_func" },
    { 0x59142605, "init_func_pointers" },
    { 0x530D010F, "init_funcs" },
    { 0xE9C0E162, "init_function" },
    { 0x4024E860, "init_function_overrides" },
    { 0xF53E79D4, "init_fx" },
    { 0x4840772F, "init_fx_anims" },
    { 0x90289952, "init_fxanims" },
    { 0x9744FB77, "init_game_mode_objects" },
    { 0xED18AED9, "init_gamemodecommonvox" },
    { 0x8DE36410, "init_gamemodes" },
    { 0xDCFC866C, "init_gamemodespecificvox" },
    { 0x6A8D9F97, "init_garage_door_guys" },
    { 0x0BB5B72D, "init_generator" },
    { 0xCA5F2742, "init_generic_anims" },
    { 0xA685D616, "init_generic_frontend_questions" },
    { 0x23C83334, "init_generic_human_anims" },
    { 0x11B0C9B5, "init_generic_human_scenes" },
    { 0x92ABFE84, "init_geyser_anims" },
    { 0xE851F039, "init_ghost_piano" },
    { 0xC1C77FD0, "init_ghost_script_move_path_data" },
    { 0xE0F369AA, "init_ghost_sounds" },
    { 0x2A1E4CD9, "init_ghost_spawners" },
    { 0x4BD59C94, "init_ghost_zone" },
    { 0x1E8F6F14, "init_giant_robot" },
    { 0x0784BF7A, "init_giant_robot_end" },
    { 0xE73FE92B, "init_giant_robot_glows" },
    { 0xC0A1AD9D, "init_giant_robot_glows_end" },
    { 0x8BDD1F0E, "init_giant_robot_glows_start" },
    { 0xE6492D81, "init_giant_robot_start" },
    { 0x50E32C38, "init_gib_tags" },
    { 0x6509D5A7, "init_global" },
    { 0x4D48D22E, "init_god_rod" },
    { 0xBB37093F, "init_gondola_chains_animtree" },
    { 0x7A325B14, "init_gongs" },
    { 0xC30C0EA2, "init_gr_mason" },
    { 0x2CC0626E, "init_gr_woods" },
    { 0xAC7429B6, "init_griefvox" },
    { 0x806B99E9, "init_guard_points" },
    { 0x5A030C38, "init_guy_ragdoll_death" },
    { 0x175DDC01, "init_hackable_turrets" },
    { 0xD466385C, "init_hackables" },
    { 0xFD60DDA4, "init_hacking_anims" },
    { 0xBE823B94, "init_han_head" },
    { 0xBCBD4C25, "init_hangar_assaulters" },
    { 0x05EC3370, "init_hangar_pdf" },
    { 0x6DA1DA4C, "init_hangar_seals" },
    { 0xAC7F9B6A, "init_hangars" },
    { 0x20E99A34, "init_harper" },
    { 0x98463184, "init_hedge_maze_spawnpoints" },
    { 0xEA8BA2DD, "init_heli_anims" },
    { 0xF0094E43, "init_heli_sound_values" },
    { 0x9664B1BD, "init_heli_sounds" },
    { 0x65A38D71, "init_heli_sounds_ai_attack" },
    { 0xD66961C1, "init_heli_sounds_alouette" },
    { 0x4BBF42BE, "init_heli_sounds_apache" },
    { 0xA2F4083E, "init_heli_sounds_blackhawk" },
    { 0xC0E60E85, "init_heli_sounds_chinook" },
    { 0x8D9A7BC6, "init_heli_sounds_f35" },
    { 0x02FF4752, "init_heli_sounds_f35_la2" },
    { 0xA267D292, "init_heli_sounds_f35_vtol" },
    { 0xC3134172, "init_heli_sounds_firescout" },
    { 0xF124B201, "init_heli_sounds_gunner" },
    { 0xAF276A42, "init_heli_sounds_heli_future" },
    { 0xC294A2CA, "init_heli_sounds_heli_guard" },
    { 0x0444A591, "init_heli_sounds_heli_osprey" },
    { 0x8B55F951, "init_heli_sounds_heli_osprey_rts" },
    { 0x2876955B, "init_heli_sounds_hind" },
    { 0x66CF13FA, "init_heli_sounds_hind_enemy" },
    { 0xCA34763E, "init_heli_sounds_hind_vorkuta" },
    { 0x21AC641B, "init_heli_sounds_hip" },
    { 0x51C56AB7, "init_heli_sounds_huey" },
    { 0x122C706D, "init_heli_sounds_huey_player" },
    { 0xE87FB5FC, "init_heli_sounds_huey_toda" },
    { 0x28C34530, "init_heli_sounds_jetwing" },
    { 0xB99BFE8D, "init_heli_sounds_littlebird" },
    { 0x32413C7A, "init_heli_sounds_osprey" },
    { 0x4DF051A0, "init_heli_sounds_pavelow_la2" },
    { 0x3F02E4B6, "init_heli_sounds_plane_x78" },
    { 0x5F8FA20C, "init_heli_sounds_player_controlled" },
    { 0x9F7A18E8, "init_heli_sounds_player_drone" },
    { 0x43D8CB15, "init_heli_sounds_player_drone_so" },
    { 0xAED28369, "init_heli_sounds_supply" },
    { 0x300021A3, "init_heli_sounds_vtol" },
    { 0x57F4862B, "init_heli_sounds_zombietron" },
    { 0x211BD6AA, "init_heli_turrets" },
    { 0x9860511E, "init_helicopter_anims" },
    { 0xCC2A42E0, "init_helicopter_console_anims" },
    { 0x9A9077B0, "init_helicopter_list" },
    { 0x57AC9E4C, "init_helicopter_player_anims" },
    { 0x66773296, "init_hero" },
    { 0x095D0518, "init_hero_ent_flags" },
    { 0xA667F348, "init_hero_startstruct" },
    { 0xE29F0DD6, "init_heroes" },
    { 0x7FC0F932, "init_heroes_fridge_move" },
    { 0x1B6CD7D7, "init_hidden_objects" },
    { 0x7990E294, "init_highrise_player_dialogue" },
    { 0xA67B1A19, "init_highrise_stats" },
    { 0xA6FDC776, "init_hill_launcher" },
    { 0xD4231B3A, "init_hill_shooter" },
    { 0x8497896D, "init_hind" },
    { 0x58E878D5, "init_hind_flight_dvars_flying" },
    { 0xAB7717EA, "init_hint_hudelem" },
    { 0xF2B034A4, "init_hint_trigger" },
    { 0xB6B2FDFD, "init_hud" },
    { 0xB581B2B2, "init_hud_shaders" },
    { 0xEBCAAE27, "init_hudson" },
    { 0x309409ED, "init_huey" },
    { 0x291FA155, "init_huey_flight_dvars_flying" },
    { 0xB6D9D5C8, "init_huey_player_dvars" },
    { 0xFD84A65F, "init_huey_weapons" },
    { 0x09E3897E, "init_hunched_volume" },
    { 0x150A261A, "init_idle_nodes" },
    { 0xBD4A250D, "init_ignore_player_handler" },
    { 0x53D09023, "init_inert_substates" },
    { 0x7EDAFF42, "init_inert_zombies" },
    { 0x26B711C5, "init_intel_map" },
    { 0x771B6C4A, "init_interference_triggers" },
    { 0x08FAF9D9, "init_interiors" },
    { 0x670D901D, "init_internal" },
    { 0xE2CC4E3A, "init_interstitial_questions" },
    { 0xB8E91D80, "init_intro_flags" },
    { 0x659D7ABC, "init_intro_settings" },
    { 0xD6C5C83F, "init_isa" },
    { 0x225D3667, "init_item_meat" },
    { 0xF3E90129, "init_items_for_pickup" },
    { 0xD2F900CA, "init_jail" },
    { 0xB4D79681, "init_jail_anims" },
    { 0x2F84A772, "init_jail_animtree" },
    { 0xB70C42FC, "init_japanese_anims" },
    { 0xA6D30842, "init_jetpack_ai_anims" },
    { 0x9C31B0F7, "init_jetpack_anims" },
    { 0x6DD2C844, "init_jetpack_drone_anims" },
    { 0x7BE0288E, "init_juggernaut" },
    { 0xF826B4D3, "init_jumpto_helis" },
    { 0xC0C42164, "init_kc_elements" },
    { 0x6E44A138, "init_kill_functions" },
    { 0x616D5663, "init_la" },
    { 0x4058CD4E, "init_lab_defend_flags" },
    { 0xFE6291E7, "init_lab_flags" },
    { 0x224A0F06, "init_lab_interior" },
    { 0x956DC4DB, "init_lab_nitrogen_guys" },
    { 0x727DA8E5, "init_lab_nitrogen_guys_back_up" },
    { 0x5299F0A7, "init_lab_scientists" },
    { 0x9857DF93, "init_lander_screen" },
    { 0xB251A206, "init_leaderboards" },
    { 0x65521682, "init_learjet_pdf_frontline_rpg" },
    { 0xC198E728, "init_learjet_rpg_seals" },
    { 0xA14D4CD6, "init_left_side_runners_ignore" },
    { 0xDE719A70, "init_level" },
    { 0x4B642C0C, "init_level_flags" },
    { 0x9C130F3F, "init_level_has_vehicles" },
    { 0x1B9447BA, "init_level_setup" },
    { 0x30A8BCAC, "init_level_specific_audio" },
    { 0x9D569BC0, "init_level_specific_frontend_questions" },
    { 0xF554A89C, "init_level_specific_stuff" },
    { 0x0904EEA0, "init_level_specific_wall_buy_fx" },
    { 0xECF72B7E, "init_level_variables" },
    { 0xCB3D951D, "init_level_vars" },
    { 0xCD9DD3E2, "init_levelvars" },
    { 0xDFE8D61E, "init_lid_anims" },
    { 0x9A1A437C, "init_lift_guys" },
    { 0x73B4C2AC, "init_lighting_pairs" },
    { 0xDC55B15D, "init_lights" },
    { 0x4E41A122, "init_loading_movie_cctv" },
    { 0x67735A44, "init_loading_movie_cctv2" },
    { 0xC0C9E98A, "init_loadout" },
    { 0xBB43A500, "init_loadout_weapons" },
    { 0xB9F4F57B, "init_local" },
    { 0x25B510B9, "init_local_player_count" },
    { 0x1A98BA64, "init_low_gravity_anims" },
    { 0xD9F8AEE0, "init_low_gravity_fx" },
    { 0xF661E681, "init_low_road" },
    { 0x327CA0C8, "init_low_road_heroes" },
    { 0xDF753858, "init_machines" },
    { 0xE150D233, "init_macv_ai_anims" },
    { 0x590AFA20, "init_macv_dialogue" },
    { 0xE0934EA3, "init_map_shader_constant" },
    { 0xB8A2E861, "init_maze_blocker_pool" },
    { 0xEB1C0904, "init_maze_clientfields" },
    { 0x87467C89, "init_maze_permutations" },
    { 0x1EC8BCEB, "init_meatshield_anims" },
    { 0xC09D2582, "init_meatvox" },
    { 0x31EF7F9D, "init_melee_fight" },
    { 0x3FEBAFFD, "init_melee_weapon" },
    { 0x5E58851F, "init_mg42s" },
    { 0x1CFD5E45, "init_mg_animent" },
    { 0x0C3CFEAA, "init_mg_tarp" },
    { 0x18162BCF, "init_mgturretsettings" },
    { 0xED8CD1A4, "init_minigun_ring" },
    { 0x65584C7B, "init_mixer_lights" },
    { 0xA58278A6, "init_model_anims" },
    { 0x19D47973, "init_model_scenes" },
    { 0x1021302C, "init_models" },
    { 0xBA74B081, "init_models_and_variables_loadout" },
    { 0x114C815D, "init_monkey_zombie_anims" },
    { 0x25377FA7, "init_monsoon_frost_filter" },
    { 0x6D2087E4, "init_moon_nml_round" },
    { 0xD4D827DC, "init_morse_code" },
    { 0x4C0A15FD, "init_mortar_guy" },
    { 0xE665D149, "init_mortar_headlights" },
    { 0x992A8DE8, "init_mortars" },
    { 0x64F4FEFA, "init_mortor_vehicle_movement" },
    { 0xCEC607F9, "init_motel_flags" },
    { 0xFD12ABE9, "init_motel_path_runners" },
    { 0xCCD8B1DA, "init_motorcycle_audio" },
    { 0xED174241, "init_mov_anims_scenes" },
    { 0xB521A879, "init_movement" },
    { 0x454348A0, "init_mover_tree" },
    { 0xA842185C, "init_mp_paths" },
    { 0xA15EE12C, "init_music_states" },
    { 0x229F8D08, "init_mutator" },
    { 0xDABB7F23, "init_mutators" },
    { 0xDD1B0E06, "init_napalm_zombie" },
    { 0x58EB639F, "init_napalmstrike" },
    { 0xC366E9C7, "init_navcard" },
    { 0xB35E0086, "init_navcomputer" },
    { 0xF12DC8F1, "init_nitrogen_asd" },
    { 0x884440EF, "init_no_mans_land" },
    { 0x9E2BFD53, "init_node_arrays" },
    { 0xA89E079E, "init_node_flags" },
    { 0xABC49676, "init_node_scan" },
    { 0xC05B149E, "init_notetracks" },
    { 0xBC32EADF, "init_notetracks_for_animname" },
    { 0x7CE9929C, "init_npc_animation" },
    { 0xC2CE7525, "init_nuked_perks" },
    { 0xBA573BC0, "init_object_animation" },
    { 0xFB2A3836, "init_objectives" },
    { 0x3CF07515, "init_once" },
    { 0x2EF85A01, "init_oneoff_ambient_models" },
    { 0x3E8EEB3A, "init_original_vehicle" },
    { 0x45E79BF1, "init_outro_anim" },
    { 0xFF062A3B, "init_overloaded_funcs" },
    { 0x44C7C0D0, "init_pack_a_punch" },
    { 0xA781C279, "init_pack_a_punch_round" },
    { 0x38E41C6C, "init_pack_door" },
    { 0xFE0331BB, "init_pakistan_defalco_scene" },
    { 0xD07AAC38, "init_palm_trees" },
    { 0xCF998B8F, "init_pap_animtree" },
    { 0x36A637D6, "init_parameters" },
    { 0x86D79FAB, "init_patrol_anims" },
    { 0x1FEEAD89, "init_pay_turret" },
    { 0xB30EA6DA, "init_pdf_hangar_assaulters" },
    { 0x275AFBC9, "init_pdf_runner" },
    { 0x14866416, "init_pentagon_box_screens" },
    { 0xF18CCF18, "init_pentagon_client_flags" },
    { 0x81D5C2AA, "init_perk_custom_threads" },
    { 0x17276169, "init_perk_elevators_anims" },
    { 0x3992DB6D, "init_perk_elvators_animtree" },
    { 0x8BC2177B, "init_perk_machines" },
    { 0xDCDDA5C4, "init_perk_machines_fx" },
    { 0xAB996531, "init_persist_ambience" },
    { 0xA0CDC1D2, "init_persistent_abilities" },
    { 0xC4470AD3, "init_phalanx_cannons" },
    { 0xE59CA3C8, "init_phase_anims" },
    { 0x098CBBAB, "init_phd_flopper" },
    { 0xB1DD9BC7, "init_pla" },
    { 0x4D3BA3EA, "init_plane_types" },
    { 0xF9BC788F, "init_plant_charges" },
    { 0x0D3F0F21, "init_player" },
    { 0x477A1C55, "init_player_achievement_stats" },
    { 0xE0348DBE, "init_player_animation" },
    { 0x064D2F42, "init_player_anims" },
    { 0x5D92BDC2, "init_player_contract_events" },
    { 0x02A223F4, "init_player_eject_logic" },
    { 0xF59954A4, "init_player_equipment" },
    { 0x93BD348D, "init_player_flags" },
    { 0xD696A98F, "init_player_hero_weapon" },
    { 0x62706CB1, "init_player_lethal_grenade" },
    { 0xD5CC670C, "init_player_levelvars" },
    { 0x06CA4F43, "init_player_melee_weapon" },
    { 0xB5604C06, "init_player_offhand_weapons" },
    { 0x50BF7355, "init_player_placeable_mine" },
    { 0xAB883501, "init_player_sidequest_stats" },
    { 0xBC782E50, "init_player_tactical_grenade" },
    { 0x9CE79C2C, "init_player_threat" },
    { 0xA849D3E8, "init_player_threat_all" },
    { 0xF6C622BE, "init_player_vars" },
    { 0x2DF19ADA, "init_player_ziplines" },
    { 0x093A1348, "init_player_zombie_blood_vars" },
    { 0x4A83AF2B, "init_player_zombie_vars" },
    { 0x6E448304, "init_plaza" },
    { 0x7025B4D2, "init_pmc" },
    { 0xFB63F288, "init_pos" },
    { 0x07E41DF4, "init_postfx_bundles" },
    { 0x89332ADD, "init_powerups" },
    { 0x108FD88D, "init_precache" },
    { 0x3F468495, "init_prisoners" },
    { 0x97C8ED42, "init_progress_info" },
    { 0x2099AC12, "init_prop_anims" },
    { 0xD66248B8, "init_props_animtree" },
    { 0x87A63BC7, "init_push_allies" },
    { 0x843FEA54, "init_push_gunner" },
    { 0x73AD569E, "init_push_runners" },
    { 0x2DE9EE2A, "init_push_triggers" },
    { 0x3C0B4C2B, "init_quad_zombie_anims" },
    { 0x9402ECB1, "init_quick_revive" },
    { 0x04AF4174, "init_racevox" },
    { 0x9BD7BDC3, "init_radio_destructibles" },
    { 0x1EA59A67, "init_ramp_volume" },
    { 0xC8D7ED9E, "init_react_dist" },
    { 0x807B8614, "init_react_timers" },
    { 0x2465105E, "init_recapture_zombie" },
    { 0xB18975B5, "init_regions" },
    { 0xADDF2FF1, "init_registration" },
    { 0x73F25579, "init_rejack_ui" },
    { 0xA265FB2B, "init_results_hudelem" },
    { 0x2A69009B, "init_rewind" },
    { 0x9FF3C645, "init_ride_killstreak" },
    { 0x1BFBC1EB, "init_ride_killstreak_internal" },
    { 0xF9BE68E3, "init_right_path_asd" },
    { 0x5D06D1EA, "init_riser_fx" },
    { 0x12E5FE29, "init_roam_points" },
    { 0xE876F048, "init_rocket_debris" },
    { 0xE07483A9, "init_roof_enemies" },
    { 0x9B14F5CB, "init_roofs" },
    { 0x99147BC6, "init_rooftop_pdf" },
    { 0x9ED282EA, "init_rso_cam" },
    { 0xBBB17ECB, "init_rso_focus" },
    { 0x76108FA3, "init_rts_flags" },
    { 0xF543F5C6, "init_rts_sounds" },
    { 0xD7FE98BB, "init_ruins_flags" },
    { 0x5C45A5EA, "init_runner_delete" },
    { 0x68EA3E29, "init_rusher" },
    { 0x46AC8E3F, "init_russian_roulette_anims" },
    { 0xCDAEEC77, "init_russian_roulette_player_anims" },
    { 0xC2FA31F7, "init_russian_roulette_prop_anims" },
    { 0x42CB76C1, "init_russian_vo" },
    { 0x272FBE7A, "init_sacrifice_volume" },
    { 0xF2C6529B, "init_sam_hud_damage" },
    { 0x7B9117F8, "init_sam_promises" },
    { 0x76FE5C12, "init_scene_e4" },
    { 0x5A3CFF18, "init_scene_sequence_started" },
    { 0xF87B2C29, "init_scenes" },
    { 0x22F57D70, "init_screecher_zones" },
    { 0x09A658EA, "init_screen_stats" },
    { 0x8FC7A2CC, "init_script_brushmodels" },
    { 0x24617BAC, "init_seals" },
    { 0xC91EEF26, "init_seq_anim_lookup" },
    { 0x5A928971, "init_sergei" },
    { 0xF6312113, "init_serverfaceanim" },
    { 0x36CCA348, "init_session_mode_flags" },
    { 0xA019D748, "init_shader_constant" },
    { 0x8D9D1CCC, "init_shaderconstants" },
    { 0x1463E4E5, "init_shared" },
    { 0x26521DE5, "init_shellshocks" },
    { 0x301FCE17, "init_shovel" },
    { 0x98EF478D, "init_shovel_player" },
    { 0xBB41E83B, "init_sidequest" },
    { 0x5DE2035B, "init_sidequest_1" },
    { 0xEBDA9420, "init_sidequest_2" },
    { 0x875A993B, "init_sidequest_vo" },
    { 0x89EAB5DA, "init_sidequests" },
    { 0x2387A156, "init_skits" },
    { 0x45DC0310, "init_sleight_of_hand" },
    { 0x05798ED5, "init_slums_pre_mgnest_axis" },
    { 0x8B16068A, "init_snowcat_animation" },
    { 0x64398EF6, "init_solar_systems" },
    { 0x8B059977, "init_sonic_zombie" },
    { 0x8ECA036A, "init_sounds" },
    { 0x17BD9142, "init_sp_paths" },
    { 0xA82F642A, "init_spark_fx" },
    { 0xF3DA698F, "init_spawn_funcs" },
    { 0xC0827600, "init_spawn_funcs_wave2_bp2" },
    { 0xE684F069, "init_spawn_funcs_wave2_bp3" },
    { 0x4684CFAD, "init_spawn_functions" },
    { 0x620C7D91, "init_spawn_system" },
    { 0x4D085DEF, "init_spawnable_weapon_upgrade" },
    { 0x952CB887, "init_spawner_set" },
    { 0x4ACF448D, "init_spawner_teams" },
    { 0x80D541EB, "init_spawners_in_cave" },
    { 0xA57B3540, "init_spawnfuncs" },
    { 0x4F78E10A, "init_spawns" },
    { 0xF2D2093C, "init_spiderhole_anims" },
    { 0xCB1996AA, "init_spiderhole_lid_anims" },
    { 0x7FBEBE2E, "init_spiderholes" },
    { 0x99B87681, "init_spinner" },
    { 0xAB545E5C, "init_splitter_ring" },
    { 0x1029C07D, "init_sprint_blocker" },
    { 0xB8EBB501, "init_squadbattlechatter" },
    { 0xD3945921, "init_squadmanager" },
    { 0xBF888E64, "init_stage" },
    { 0x8377A7D8, "init_stage_1" },
    { 0xF57F1713, "init_stage_2" },
    { 0xE23FBC47, "init_staminup" },
    { 0x04692F38, "init_standard_farm" },
    { 0x5C7AFB9B, "init_standard_response_chances" },
    { 0x7FA7FB01, "init_standard_zombie_anims" },
    { 0x67009A07, "init_standoff_seal" },
    { 0xE41CA92A, "init_starting_chest_location" },
    { 0xEDA1201B, "init_starting_perk_random_machine_location" },
    { 0x3BF2D331, "init_starts" },
    { 0xC14179A8, "init_stat" },
    { 0x9174840A, "init_state_machine_for_role" },
    { 0x1FAF2FB4, "init_states" },
    { 0x054AA0A7, "init_stealth_carry_flags" },
    { 0xD47E6A4A, "init_steves_flags" },
    { 0x993CD1EA, "init_stolen_compound_anims" },
    { 0x45A28ACB, "init_stolen_tunnel_anims" },
    { 0x91F712C3, "init_street" },
    { 0x011FB638, "init_street_dialogue" },
    { 0xDFB26268, "init_strings" },
    { 0x4C66B665, "init_struct" },
    { 0x8DAD416C, "init_struct_targeted_origins" },
    { 0x5920A574, "init_structs" },
    { 0xFCDCBF3D, "init_summon_box" },
    { 0xA464AB90, "init_summon_hacks" },
    { 0x17CAC160, "init_supersprint_anims" },
    { 0x1D9F0DB4, "init_supply_drops" },
    { 0x93C67A30, "init_sw_cam" },
    { 0x941A88DE, "init_switch" },
    { 0x1E12CF34, "init_tag_array" },
    { 0xFA0821C1, "init_takeoff_prop_anims" },
    { 0x3F9C4D39, "init_target" },
    { 0x7A40A27B, "init_target_ent" },
    { 0x1B39C8E5, "init_target_group" },
    { 0x1DC3ABD8, "init_targetname" },
    { 0x1795F906, "init_tarp_clip" },
    { 0xA190A62F, "init_technical" },
    { 0x5BEC4183, "init_technical_gunner" },
    { 0x4C957CEB, "init_teleport_points" },
    { 0xDA3CD0F6, "init_teleporter_lights" },
    { 0xC60B0756, "init_teleporter_message" },
    { 0x72E2B0C5, "init_temp_contextual_guys" },
    { 0xC9F11049, "init_temple_geyser" },
    { 0xDA638558, "init_terrain_sounds" },
    { 0xA5EA2F43, "init_tesla" },
    { 0xEC7B1CAB, "init_text" },
    { 0xAA2A153A, "init_tflame_model_anims" },
    { 0x4362FCC1, "init_theater_box_indicator" },
    { 0x9365C41C, "init_thief_zombie_anims" },
    { 0xAA9E8BF6, "init_thinking" },
    { 0xA41A2A62, "init_thread" },
    { 0x1054E43C, "init_threatbias_groups" },
    { 0x0EEA9439, "init_threatbiasgroups" },
    { 0x3BEB8146, "init_thundergun" },
    { 0x4AB7C2CC, "init_time_bomb" },
    { 0xC5F6CC64, "init_time_bomb_ghost_rounds" },
    { 0x2509D4AC, "init_to_stat_value" },
    { 0xC6FF3260, "init_tomb_ambient_scripts" },
    { 0xBFCD93B0, "init_tomb_stats" },
    { 0x087BDA31, "init_top_ladder_pdf" },
    { 0xC0BEA9AD, "init_tower_trap_trigs" },
    { 0xF7071654, "init_transit_dr_stats" },
    { 0xE1280A49, "init_transit_gump" },
    { 0x19E4DAB6, "init_transit_player_dialogue" },
    { 0x547DDA0B, "init_transit_stats" },
    { 0xC968A37A, "init_trap_door" },
    { 0x7BC233CA, "init_traps" },
    { 0xA7781E10, "init_traverse" },
    { 0x08D53EE3, "init_traverse_anims" },
    { 0x942C9F71, "init_tree_anims" },
    { 0xCB322CB3, "init_tree_snipers" },
    { 0x981C8AF5, "init_treyarch_credits" },
    { 0xD06B5253, "init_treyarch_credits_pc" },
    { 0x03B184F2, "init_treyarch_credits_ps3" },
    { 0x6095DEDD, "init_treyarch_credits_wii" },
    { 0x550F6B86, "init_trigger" },
    { 0x2810B07D, "init_trigger_2" },
    { 0x17E2ADFD, "init_trigger_data" },
    { 0xC4450EFA, "init_trigger_flags" },
    { 0x67BABD39, "init_triggers" },
    { 0x54367CF8, "init_truck_driver" },
    { 0xF7B2C41F, "init_tunnel_anims" },
    { 0x6F36AA94, "init_tunnel_hint" },
    { 0x7ACF4B17, "init_tunnel_player_anims" },
    { 0xCA21D697, "init_tunnel_prop_anims" },
    { 0x74DD6B84, "init_turned_zones" },
    { 0xF2710FD4, "init_turret_difficulty_settings" },
    { 0x269C02E3, "init_turret_info" },
    { 0x8A4E8DB7, "init_turrets" },
    { 0xEDBF16CE, "init_upgrade" },
    { 0x99F6207D, "init_usable_mortars" },
    { 0x8126E6D1, "init_use_trigger_hints" },
    { 0x72949236, "init_util_flags" },
    { 0xB2DBE562, "init_utility" },
    { 0x995411BA, "init_vehicle" },
    { 0xB97DA8B1, "init_vehicle_animation" },
    { 0xE679FD31, "init_vehicle_anims" },
    { 0xF8E61088, "init_vehicle_entities" },
    { 0xEE104DBE, "init_vehicle_lights" },
    { 0x545484E8, "init_vehicle_threads" },
    { 0xD41BAE35, "init_vehicles" },
    { 0xA9D1F935, "init_victory_enemy" },
    { 0x3CFAE75E, "init_victory_friendly" },
    { 0xCA719CD1, "init_viewarm" },
    { 0xAC2CEBAA, "init_viewmodels_and_campaign" },
    { 0xE9C4CF87, "init_vision_set" },
    { 0x7DBE516A, "init_vision_triggers" },
    { 0xDCE0F34B, "init_vo" },
    { 0xA28DAC9B, "init_vo_heli_dmg" },
    { 0xA2AE2D80, "init_vo_nag_2nd_village" },
    { 0x1DE19CE6, "init_vo_nag_rockets" },
    { 0x7AE76F83, "init_vo_reloading" },
    { 0xE230521C, "init_voice" },
    { 0xCA665D3D, "init_voiceovers" },
    { 0xFEC13B49, "init_vortices" },
    { 0x923BF761, "init_vtol" },
    { 0x3506D4DD, "init_vulture" },
    { 0x7236D1DB, "init_wall_clip" },
    { 0x55A9D3FB, "init_wallbuy_fx" },
    { 0x23BC9951, "init_wallbuys" },
    { 0x8B66D7C0, "init_water_dvars" },
    { 0xA0079258, "init_water_volume" },
    { 0x0F2F3AED, "init_wave3bp1_setup" },
    { 0xE326292F, "init_weapon_cabinet" },
    { 0x5EF304A1, "init_weapon_cache" },
    { 0x0FD62E67, "init_weapon_stat" },
    { 0x3CFED041, "init_weapon_toggle" },
    { 0x07FA249F, "init_weapon_upgrade" },
    { 0xCC916919, "init_weapons" },
    { 0xAB2ADCAA, "init_weather_manager" },
    { 0xD3E6120E, "init_weaver" },
    { 0x57CF2C61, "init_weights" },
    { 0x28504119, "init_widows_wine" },
    { 0xA5D0D9FC, "init_window_jumper" },
    { 0xB06115C8, "init_wingsuit_flags" },
    { 0x3DBDCDE1, "init_wounded_crawler" },
    { 0xB66BCD01, "init_xmodel" },
    { 0xF903959B, "init_zeppelin" },
    { 0x88D6F543, "init_zombie_airlocks" },
    { 0xAA84C16A, "init_zombie_asylum" },
    { 0xE189AD3F, "init_zombie_explode_fx" },
    { 0xEC89B835, "init_zombie_run_cycle" },
    { 0x8029E801, "init_zombie_spawner_name" },
    { 0x9B6974D6, "init_zombie_sumpf" },
    { 0xD91DE63E, "init_zombie_theater" },
    { 0x2D8B6C0B, "init_zombie_weapon" },
    { 0xA14A64D8, "init_zone_capture_zombie_common" },
    { 0x91AAC6C7, "init_zones" },
    { 0xB092FE0D, "init_zpu_aa_gun" },
    { 0xC9237310, "initactionchain" },
    { 0xE91C748C, "initactivisioncredits" },
    { 0x0141029C, "initactorbookmarkparams" },
    { 0xD99813B4, "initadjusttocoverparams" },
    { 0xE48518AF, "initailize" },
    { 0xE249918A, "initairsupport" },
    { 0xD7C72A74, "inital" },
    { 0xFCB49EEA, "initalized" },
    { 0x2942FB7F, "initambusheffects" },
    { 0x568AE9B4, "initammobox" },
    { 0x1991369C, "initanim" },
    { 0x6CA62E0D, "initanimationmocomps" },
    { 0x3A287D22, "initanimdeath" },
    { 0x7F7FEB44, "initanimdeathloop" },
    { 0xDC3903FE, "initanimloop" },
    { 0x0A5E2FE8, "initanimloopdeath" },
    { 0x2A207C52, "initanimloopdeathloop" },
    { 0x1FAEC76C, "initanimtree" },
    { 0x951F2929, "initapothiconfurybehaviorsandasm" },
    { 0x7F0ABD05, "initaudioaliases" },
    { 0x4DACF2A5, "initautoaim" },
    { 0x17801844, "initautoturret" },
    { 0xC27EE036, "initbarreltrap" },
    { 0xB87C129B, "initbridgeriser" },
    { 0x2068A2E3, "initburnplayer" },
    { 0x590A6038, "initbustires" },
    { 0x3FF08C05, "initbuttonlayout" },
    { 0xCB50C32E, "initchallengedata" },
    { 0xB7A915CB, "initchallengestats" },
    { 0x6CDBE7D7, "initcharacterface" },
    { 0x64B491E4, "initcharacterstartindex" },
    { 0xA64FD903, "initchickens" },
    { 0xEB6045A5, "initclassinfo" },
    { 0x9976DE65, "initclaymoreammo" },
    { 0xA147A220, "initcommondoganims" },
    { 0xFED0244D, "initcontact" },
    { 0x85652D72, "initcovercrouchnode" },
    { 0xE92B99CB, "initcredits" },
    { 0x1AECF547, "initcustomgametypeheader" },
    { 0x92B08013, "initdec20terminal" },
    { 0x7E814E3E, "initdelaymax" },
    { 0x1383D8E0, "initdelaymin" },
    { 0x2620C3FC, "initdifficulty" },
    { 0xCE6A5D8A, "initdirecthitweapons" },
    { 0xD0E18182, "initdlc3_vars" },
    { 0xE882F724, "initdlc3_vars2" },
    { 0x4AB45A3E, "initdof" },
    { 0x0730BFE6, "initdoganimations" },
    { 0x1D997E1E, "initdogs" },
    { 0xAE444BD4, "initdroplocations" },
    { 0xC6E4BB37, "initdvars" },
    { 0x540091E0, "inited" },
    { 0x430FAD04, "inited_lights" },
    { 0x3D8A3717, "initedentityheadicons" },
    { 0xF231B11B, "initelectrictrap" },
    { 0xE16E7519, "initenemyselection" },
    { 0x42A584BA, "initfallerbehaviorsandasm" },
    { 0x89D58E56, "initfinalkillcam" },
    { 0x5E2E5F19, "initfinalkillcamteam" },
    { 0xCAD92A31, "initflakdrone" },
    { 0x63E16AC6, "initflamefx" },
    { 0x0352C964, "initflashed" },
    { 0x25159F7E, "initfriendlies" },
    { 0x53BE14C9, "initfunc" },
    { 0x19F2C777, "initfunction" },
    { 0x1936F03B, "initgametypeawards" },
    { 0xB557EBD3, "initgamevars" },
    { 0x7B24C584, "inithelicopter" },
    { 0xBE423BBC, "inithelicopterpositions" },
    { 0xB5FD53C7, "inithelicopterseat" },
    { 0xCD6182A1, "inithistory" },
    { 0x138F0446, "inithud" },
    { 0xE375CC57, "initial" },
    { 0xF6D80597, "initial_angle" },
    { 0x0D38967E, "initial_attract_func" },
    { 0x3102E532, "initial_bp1_logic" },
    { 0xDB6A8E84, "initial_cartel_spawned" },
    { 0x91692556, "initial_combat_area" },
    { 0xA235A29A, "initial_contact_spawners" },
    { 0x3A298478, "initial_convoy_checkpoint_stop" },
    { 0xA7F0BDAC, "initial_current_weapon" },
    { 0xEFBD053B, "initial_delay" },
    { 0xDBFAF8EF, "initial_engagement_player_boat_skipto" },
    { 0x4727F907, "initial_force" },
    { 0x0C7C6C1F, "initial_friendlies" },
    { 0x21F152DD, "initial_friendly_setup" },
    { 0xF0C44A25, "initial_hit_occurred" },
    { 0xBA9E43E3, "initial_human_selected" },
    { 0xB9AEC4F4, "initial_impact" },
    { 0x07816A5D, "initial_island_engagement" },
    { 0x1B9F2418, "initial_leaders" },
    { 0xD8882F2E, "initial_napalm_drones1" },
    { 0xB285B4C5, "initial_napalm_drones2" },
    { 0xA29EB6E7, "initial_path" },
    { 0xE272897C, "initial_plane_napalm_drop" },
    { 0xFEDC4D18, "initial_plants" },
    { 0x0B657918, "initial_point" },
    { 0xD3532C79, "initial_preparation" },
    { 0xE99863D4, "initial_primaryweapon" },
    { 0x044EBF6D, "initial_quick_revive_power_off" },
    { 0x9140244A, "initial_reactions" },
    { 0xB31C6007, "initial_round_wait_func" },
    { 0x348D0F64, "initial_secondaryweapon" },
    { 0x16267079, "initial_setup" },
    { 0x31AD650B, "initial_setup_vehicle_override" },
    { 0xD86A048F, "initial_spawn" },
    { 0x8E9B21DC, "initial_spawn_influencer_ents" },
    { 0x5F37F267, "initial_spawn_influencers1" },
    { 0xED30832C, "initial_spawn_influencers2" },
    { 0x1923B052, "initial_spawn_trigger" },
    { 0xF01299FD, "initial_spawners" },
    { 0x0E122AA7, "initial_special_ais" },
    { 0xBB64FBD1, "initial_state" },
    { 0x817065E5, "initial_target" },
    { 0x3D581C5B, "initial_time_s" },
    { 0x8D009E7F, "initial_velocity" },
    { 0x8E13C9B1, "initial_wait_delay" },
    { 0x7DB84788, "initial_zone" },
    { 0xB511CBDB, "initialangles" },
    { 0xE15984D4, "initialblack" },
    { 0x609A85A3, "initialblackend" },
    { 0xE419AE70, "initialdelay" },
    { 0xF6EDE59B, "initialdmscoreupdate" },
    { 0x0266F5FA, "initialgoal" },
    { 0xD0F4EB8C, "initialgoalpos" },
    { 0xF6537105, "initialhealth" },
    { 0x3DFB41CD, "initialhealthbody" },
    { 0x537FBA13, "initialhealthleg" },
    { 0xE82A59E2, "initialiazed" },
    { 0x9D289BC3, "initialilze" },
    { 0x190DF934, "initialimpulse" },
    { 0x202F9C48, "initialise" },
    { 0x3EEB10EB, "initialitze" },
    { 0x63C90AE9, "initialization" },
    { 0x6D3AFE60, "initializations" },
    { 0xE6CAB0FF, "initialize" },
    { 0x758862AB, "initialize_arena_vo" },
    { 0xB8FD215F, "initialize_base_icon" },
    { 0x112DEE30, "initialize_bonus_entity_pool" },
    { 0x7FA899DF, "initialize_character_group" },
    { 0xAA9D5B3F, "initialize_custom_perk_arrays" },
    { 0xCE07CA0D, "initialize_ent_flags" },
    { 0x44C53C9F, "initialize_hologram" },
    { 0x95443392, "initialize_intel" },
    { 0xF69038F1, "initialize_match_stats" },
    { 0x64E3832C, "initialize_nationality" },
    { 0xDCB14347, "initialize_occupied_flag" },
    { 0xD7BF381F, "initialize_per_client" },
    { 0x1D714814, "initialize_player_spawning_dvars" },
    { 0xDC1992C5, "initialize_scenes" },
    { 0xC1B5461F, "initialize_single_ally" },
    { 0x7F5EED60, "initialize_spawn_func" },
    { 0x135EFF3E, "initialize_spawn_function" },
    { 0xA5FB9690, "initialize_stat_tracking" },
    { 0x071E847A, "initialize_stink_entity_pool" },
    { 0x5D7C99CA, "initialize_vehicle_damage_effects_for_level" },
    { 0x7A69E87B, "initialize_vehicle_damage_state_data" },
    { 0x4C7AD304, "initialize_waves" },
    { 0x88598D94, "initializeactionarray" },
    { 0x620E68F2, "initializecling" },
    { 0x771CD069, "initialized" },
    { 0xD692DEE2, "initializedextracam" },
    { 0xD74935DB, "initializedgibcallbacks" },
    { 0xF9D077AC, "initializeevents" },
    { 0x36656E17, "initializematchstats" },
    { 0xC09FA883, "initializenotetrackhandlers" },
    { 0xC88E2D92, "initializepower" },
    { 0xBB53556F, "initializer" },
    { 0x93B6EE94, "initializereactioneventcbs" },
    { 0x9550DB06, "initializes" },
    { 0x2E618D3E, "initializestattracking" },
    { 0xDA85CA7A, "initializing" },
    { 0xA7BBD934, "initializion" },
    { 0xDE6188EC, "initialloadoutgiven" },
    { 0xC500ACBA, "initially" },
    { 0x587ABF06, "initialoffset" },
    { 0x2DB823B5, "initialorigin" },
    { 0xDA54A529, "initialoriginonterrain" },
    { 0xA1F4DEBB, "initialpoint" },
    { 0x48A61C34, "initialrandomwaitseconds" },
    { 0x41AAA5E4, "initialscoreupdate" },
    { 0xF6E89231, "initialspawnprotection" },
    { 0x85931188, "initialspeed" },
    { 0xC589BD96, "initialtargetorigin" },
    { 0x3F716516, "initialvalue" },
    { 0x59615BCE, "initialvelocity" },
    { 0xB2575892, "initialvelocityx" },
    { 0xD859D2FB, "initialvelocityy" },
    { 0x665263C0, "initialvelocityz" },
    { 0xC15C43E3, "initialwaituntilsettled" },
    { 0x01DDAB10, "initialweaponcount" },
    { 0x701B6ED5, "initialweaponraise" },
    { 0x98B099EC, "initialzones" },
    { 0x84D59280, "initiate" },
    { 0x752D7084, "initiated" },
    { 0x89502242, "initiater" },
    { 0xAF529CAB, "initiates" },
    { 0x0FA4EC01, "initiating" },
    { 0xA01C1AD7, "initiation" },
    { 0x255B522C, "initiator" },
    { 0x80262773, "initied" },
    { 0x2E0065EB, "initiliazed" },
    { 0x1FFAA2D4, "initilization" },
    { 0x7F31B3A2, "initilize" },
    { 0x99790493, "initilizing" },
    { 0xA35B1D02, "initinversion" },
    { 0xF334EEE4, "inititialize" },
    { 0xFAFD4E5F, "initiwcredits" },
    { 0x5A6E3CAC, "initjumpstruct" },
    { 0x673C6082, "initkcelements" },
    { 0x997E9A8B, "initkeys" },
    { 0x53BF0981, "initkillstreak" },
    { 0x5B0334B1, "initlaststand" },
    { 0x6D7BFEB3, "initlevel" },
    { 0xF90F420B, "initlevel2" },
    { 0x125C84B8, "initlevelface" },
    { 0x5E35DA12, "initlocalplayers" },
    { 0xB0F0DC06, "initlockfield" },
    { 0x618E8C7D, "initmargwabehaviorsandasm" },
    { 0x75050FC3, "initmechzbehaviorsandasm" },
    { 0x2D7DF35A, "initmenudata" },
    { 0xC1CE2247, "initmissiondata" },
    { 0x1488E214, "initmodelanims" },
    { 0x207F8294, "initmodelanims_delay" },
    { 0xD8626214, "initmovestartstoptransitions" },
    { 0x4675A945, "initmoviescreen" },
    { 0x3DA74183, "initnode" },
    { 0x79C89FBE, "initnodename" },
    { 0xEEE4063C, "initnotetrackhandler" },
    { 0xCB5C5225, "initnotifymessage" },
    { 0x890B95BA, "initnotifymessageinternal" },
    { 0x3F171777, "initnotifymessagezombie" },
    { 0x5B96904C, "initpendulumtrap" },
    { 0xE4A4BDF7, "initperkdvars" },
    { 0xF4F342C9, "initpersstat" },
    { 0xF930D132, "initpickups" },
    { 0x432DCADC, "initplayer" },
    { 0x92FA676F, "initplayerhud" },
    { 0x82872B5C, "initpois" },
    { 0xDE4C01E2, "initposemovementfunctions" },
    { 0xCFF64198, "initprecache" },
    { 0x27603F4A, "initprice" },
    { 0x4BD6B8CE, "initpronedof" },
    { 0xA70A4D0D, "initproptrap" },
    { 0x66FFB804, "initpurgatoryenemycountelem" },
    { 0x1E18C1B3, "initrazbehaviorsandasm" },
    { 0xB97521AE, "initrcbomb" },
    { 0xDE4FA73A, "initreacttimers" },
    { 0xE24D194D, "initremoteweapon" },
    { 0x226AD760, "initrewindobjectwatchers" },
    { 0xEA17E107, "initridekillstreak" },
    { 0xED063821, "initridekillstreak_internal" },
    { 0x5EF259F7, "initrotatingrig" },
    { 0x6EC66C65, "initround" },
    { 0xE02AB65C, "initrules" },
    { 0xFFB9F38A, "inits" },
    { 0x4597A5A7, "initscale" },
    { 0xD9FC380B, "initscoreinfo" },
    { 0x7EA03D30, "initsensitivity" },
    { 0xEB0BA513, "initsentinel" },
    { 0x9589A929, "initshepherddoganimations" },
    { 0x0C30E56B, "initshot" },
    { 0xD25C4885, "initshotloop" },
    { 0x9AA7AC57, "initskeletonbehaviorsandasm" },
    { 0x52014196, "initskill" },
    { 0xE6F5D4C0, "initstataward" },
    { 0x0D403D3E, "initstate" },
    { 0x01088C9F, "initstaticweaponstime" },
    { 0xFB6254A4, "initstatusslots" },
    { 0x3103D6B7, "initstructs" },
    { 0xC9F18456, "initsubtitles" },
    { 0x0A806762, "initteamchallenges" },
    { 0x0B436C23, "initteamvariables" },
    { 0xD83C7355, "initthrasherbehaviorsandasm" },
    { 0xA767F9B4, "initthreatbias" },
    { 0x306DAAE1, "initthumbsticklayout" },
    { 0x5A0DB360, "inittime" },
    { 0x428C4A45, "inittransitiontime" },
    { 0x591AAB01, "initturret" },
    { 0x344A116B, "initturretvehicle" },
    { 0x7D36D031, "initutility" },
    { 0x695F3C31, "initvehicle" },
    { 0x18E19C81, "initvehiclemap" },
    { 0xE6651399, "initvelocityforward" },
    { 0xF1E5D209, "initvelocityup" },
    { 0x35E51C4F, "initvibration" },
    { 0x4D6D1A00, "initwagerplayer" },
    { 0x1C860DD3, "initwatertriggers" },
    { 0xDE0C0C9F, "initweapon" },
    { 0x42D27F93, "initweaponattachments" },
    { 0x722FD532, "initweaponhud" },
    { 0x6FD77A93, "initweaponlist" },
    { 0xC83FB604, "initweaponstats" },
    { 0xD50C0BBE, "initweights" },
    { 0x6033AC8D, "initwindowtraverse" },
    { 0x6D502B1E, "initzipline" },
    { 0x31E1C1F5, "initzmbehaviorsandasm" },
    { 0x46F62F6F, "initzmfactorybehaviorsandasm" },
    { 0x339717FA, "initzombiebehaviorsandasm" },
    { 0x4D8A7A38, "initzombiedoganimations" },
    { 0x2669304A, "initzombieleaderboarddata" },
    { 0x6579AD2E, "iniy" },
    { 0x92805C9C, "injection" },
    { 0x8E40A9E7, "injur" },
    { 0x084D12AC, "injured" },
    { 0xB8DD77EA, "injured_group_b_scene" },
    { 0x63470D6F, "injured_group_c_scene" },
    { 0x0955B344, "injured_walk" },
    { 0x603E3544, "injury" },
    { 0xC9B64B1C, "inked" },
    { 0x9BF1CCA9, "inkillcam" },
    { 0x9BA6F378, "inl" },
    { 0x9CB7CE9C, "inlaststand" },
    { 0x1EF6EE68, "inlength" },
    { 0x13567FB2, "inline" },
    { 0xCC0A7F50, "inloading" },
    { 0xDE3C865A, "inlockingstate" },
    { 0xFE3DA169, "inmaterialoverridetrigger" },
    { 0x41DBA124, "inmeleecharge" },
    { 0xFBD7EEF5, "inmemory" },
    { 0xD16BA27B, "inner" },
    { 0x316CE5A2, "inner_ambience" },
    { 0xE0D7385D, "inner_club_dialog" },
    { 0x180CD7DA, "inner_crate_door" },
    { 0xFF7578CD, "inner_damage" },
    { 0xC0C0A2E0, "inner_radius" },
    { 0x340CCA8D, "inner_range" },
    { 0x4E0BA4D8, "inner_ruins_crosby" },
    { 0xEC03B792, "inner_ruins_destroy_c4_watch" },
    { 0x2F7BC1DA, "inner_ruins_destroy_choice" },
    { 0xAE482914, "inner_ruins_destroy_left_temple" },
    { 0xAAFFD794, "inner_ruins_destroy_message" },
    { 0x8CA755BA, "inner_ruins_destruction_left" },
    { 0x06040C89, "inner_ruins_destruction_right" },
    { 0x01F1D703, "inner_ruins_door_think" },
    { 0x8FAD3B80, "inner_ruins_harper" },
    { 0xEBE1B92B, "inner_ruins_harper_shoot_door" },
    { 0xD1129E8A, "inner_ruins_harper_titus" },
    { 0xA9D4E106, "inner_ruins_kill_spawners" },
    { 0x9A8C32A5, "inner_ruins_main" },
    { 0xF14CA52D, "inner_ruins_player_vo" },
    { 0xD4DEF302, "inner_ruins_salazar" },
    { 0x89E7356C, "inner_solar_objectives" },
    { 0x625B00BA, "inner_x" },
    { 0x885D7B23, "inner_y" },
    { 0x08755587, "inner_zigzag_radius" },
    { 0xAA04EA22, "innerbox" },
    { 0xE68CE97A, "innerdetect" },
    { 0xB29AE90C, "innerdif" },
    { 0x85EF8317, "innerpos" },
    { 0x927857A5, "innerradius" },
    { 0x9C039E0E, "innerspacing" },
    { 0x2092EA95, "innerzigzagradius" },
    { 0x80D3D275, "innner" },
    { 0x7BBC60DF, "innocent" },
    { 0x0ECB70A0, "innofly" },
    { 0x74C52AAE, "innoplacementtrigger" },
    { 0xA7289E1B, "innwards" },
    { 0x8A835E85, "inodes" },
    { 0x9192BC2B, "inoperative" },
    { 0xC8C5D66A, "inorange" },
    { 0x25436E44, "inorder" },
    { 0x15C4B06C, "inore" },
    { 0x8E73036D, "inovertime" },
    { 0x64C14CB4, "inpain" },
    { 0x08C3A6DD, "inplace" },
    { 0x7F9D4AB5, "inplayablearea" },
    { 0x0BC37320, "inplayerfov" },
    { 0x10CEC36F, "inpoisonarea" },
    { 0x6FAF4825, "inposition" },
    { 0x35A23885, "inprematchperiod" },
    { 0x7DF6A28D, "inprogress" },
    { 0x740405C8, "inprojroom" },
    { 0x7263D0BD, "inpsect" },
    { 0x6259CD87, "input" },
    { 0x742DEA33, "input_button_press_detected" },
    { 0xCDC636C7, "input_lstick_detected" },
    { 0xECB20D89, "input_select_shot" },
    { 0x830234AF, "input_stick_detected" },
    { 0x6CFE48C3, "input_timeout" },
    { 0x6D8D2FAC, "input_trigs_detected" },
    { 0x9669E07A, "inputarray" },
    { 0x12FD31D9, "inputing" },
    { 0xE088AC7E, "inputs" },
    { 0x53083C7F, "inputsound_nexttime" },
    { 0xC7AFC80F, "inputtype" },
    { 0x2C1CBB93, "inque" },
    { 0xEF7A5816, "inr" },
    { 0xCD83BA7B, "inrange" },
    { 0xC9C68B17, "inrangepos" },
    { 0x00FB7810, "inrangetime" },
    { 0x8FF27D76, "inrankxp" },
    { 0x47D0A144, "inreticle" },
    { 0xD9781708, "insafearea" },
    { 0x76A4C594, "insamezone" },
    { 0x8F23A09B, "insane" },
    { 0xE0A7244D, "insane_scream" },
    { 0x71638B62, "insanity" },
    { 0xC19427D9, "inseq" },
    { 0x9B01F652, "insert" },
    { 0x4ADF169C, "insert_allies_by_heli" },
    { 0x5C2FAAB0, "insert_allies_by_ladder" },
    { 0x7D0F3C1A, "insert_effect" },
    { 0x04692AB9, "insert_effect_node" },
    { 0xCB9EE0BC, "insert_fake_splitscreen_here" },
    { 0x7C83F8C2, "insert_in_array" },
    { 0xF07AF5B9, "insertclone" },
    { 0x13136D65, "inserted" },
    { 0xC2A5460C, "insertedclone" },
    { 0x4524BE18, "insertion" },
    { 0x5FEE9333, "insertion_sort" },
    { 0x35275331, "insertiontrackingstart" },
    { 0x508B3C5D, "inserts" },
    { 0x0054CD6D, "inside" },
    { 0x9FF676F3, "inside_bounds" },
    { 0xF86FFC57, "inside_cave" },
    { 0x7041BC46, "inside_chamber" },
    { 0x96D8F336, "inside_elevator" },
    { 0xEE3B645B, "inside_flashroom" },
    { 0xD316796C, "inside_lift_init" },
    { 0x86EF79B8, "inside_lift_move_down" },
    { 0xE106CE93, "inside_lift_move_up" },
    { 0xF0C26B84, "inside_node" },
    { 0xFF86E5EA, "inside_osprey" },
    { 0x507713AE, "inside_pos" },
    { 0x3B76A4F2, "inside_scanner" },
    { 0x2AAAB717, "inside_screen_angles" },
    { 0x891F41A2, "inside_screen_crosshair_radius" },
    { 0x2718EDBA, "inside_screen_lockon_radius" },
    { 0x9814BBCD, "inside_screen_radius" },
    { 0x3BC2CFB4, "inside_sniper_building" },
    { 0xB88A4954, "inside_start" },
    { 0xB0A06235, "inside_tower_lift" },
    { 0xE7F4D914, "inside_trigger" },
    { 0x66358804, "insideapreticlelocked" },
    { 0x13957682, "insideapreticlenolock" },
    { 0x74AB9720, "insidebox" },
    { 0x89DBF78E, "insidedot" },
    { 0xF6F25745, "insideheli" },
    { 0x65B69BEC, "insidejavelinreticlelocked" },
    { 0x1AF6ED0A, "insidejavelinreticlenolock" },
    { 0x77F5A8ED, "insidemissileturretreticlelocked" },
    { 0x7169D5E3, "insidemissileturretreticlenolock" },
    { 0x3E01F0B4, "insidenoflyzones" },
    { 0x3FAF5F24, "insiders" },
    { 0xDCBC2B46, "insidestingerreticledetect" },
    { 0x289C9899, "insidestingerreticlelocked" },
    { 0x6B6AFF1F, "insidestingerreticlenolock" },
    { 0x546653F9, "insidetargets" },
    { 0x30BFA9CF, "insight" },
    { 0x04E77203, "insmashattackrange" },
    { 0x0F28A0AF, "insolence" },
    { 0x1C915F31, "insolid" },
    { 0x5BADC12B, "inspect" },
    { 0x1868915A, "inspection_node" },
    { 0x2377C829, "inspection_pose_cp" },
    { 0xF9FAB9D3, "inspection_pose_zm" },
    { 0xBB3926E0, "inspector" },
    { 0x2D76958B, "inspectors" },
    { 0x5D0193F3, "inspired" },
    { 0x7F83FB95, "inst_trigs" },
    { 0x417C3FF2, "insta" },
    { 0x6ADAE83C, "insta_fail_trigger" },
    { 0x840700C1, "insta_kill" },
    { 0x80D8AE39, "insta_kill_on_hud" },
    { 0x32BCF18A, "insta_kill_over" },
    { 0x8E30B6F3, "insta_kill_pers_upgrade_icon" },
    { 0x021571E3, "insta_kill_pickedup" },
    { 0x8678E513, "insta_kill_player" },
    { 0x72BF79B0, "insta_kill_powerup" },
    { 0xC8E54B8F, "insta_kill_powerup_override" },
    { 0x94142EFB, "insta_kill_triggers" },
    { 0x51F00958, "insta_kill_upgraded_player_kill_func" },
    { 0xDD92CAAE, "insta_killed" },
    { 0x6A4A7A1E, "instakill" },
    { 0x0ECE4077, "instakill_func" },
    { 0x3044875E, "instakill_on" },
    { 0x20CEE125, "installation" },
    { 0xD4CD8495, "installed" },
    { 0x1BBBBBC4, "instance" },
    { 0xFF06F877, "instances" },
    { 0x8AD5C12C, "instant" },
    { 0x05CBD696, "instant_explode" },
    { 0x6FED51D8, "instant_high_alert" },
    { 0xB38BA218, "instant_melee_kill" },
    { 0x60797FD4, "instant_spawn" },
    { 0x00ACC90F, "instant_sun" },
    { 0x6B08F7AC, "instant_wetness" },
    { 0x4F7EA36D, "instantaneous" },
    { 0xA97CC790, "instantaneously" },
    { 0xF704F918, "instantfire" },
    { 0x9E50401F, "instantiate" },
    { 0xFEFBBA09, "instantiated" },
    { 0x87FC1D09, "instantly" },
    { 0x8DF5B097, "instantly_promote_nearest_friendly" },
    { 0x6C9E4241, "instantly_set_color_from_array" },
    { 0x8B4CD070, "instantly_set_color_from_array_with_classname" },
    { 0xBF2C8E88, "instantrespawn" },
    { 0xF8CF70F5, "instead" },
    { 0x3376998A, "insteptrigger" },
    { 0x1AAF5705, "instinct" },
    { 0x36141B94, "instincts" },
    { 0xDF8CF1BF, "instruct" },
    { 0x23B66EB4, "instruct1" },
    { 0x95BDDDEF, "instruct2" },
    { 0x6FBB6386, "instruct3" },
    { 0x9391B2C4, "instructed" },
    { 0x9FE0E517, "instruction" },
    { 0x3FDE823C, "instruction1" },
    { 0xB1E5F177, "instruction2" },
    { 0x8BE3770E, "instruction3" },
    { 0xAA1728A5, "instruction_string" },
    { 0x764AFF48, "instructional" },
    { 0x0B44DCCE, "instructions" },
    { 0xD6C16A5B, "instructions_bp1_wave3" },
    { 0xDE0212B4, "instructions_elem" },
    { 0x3C59955F, "instructions_elem10" },
    { 0x5CD1727E, "instructions_elem2" },
    { 0x82D3ECE7, "instructions_elem3" },
    { 0x78C29408, "instructions_elem4" },
    { 0x9EC50E71, "instructions_elem5" },
    { 0xC4C788DA, "instructions_elem6" },
    { 0xEACA0343, "instructions_elem7" },
    { 0xE0B8AA64, "instructions_elem8" },
    { 0x06BB24CD, "instructions_elem9" },
    { 0x586CF69C, "instructions_firehorse" },
    { 0x75428039, "instrumented" },
    { 0x38D81569, "instruments" },
    { 0x351DF9D2, "instruments_init" },
    { 0x3366BF6C, "insufficient" },
    { 0xD99428C8, "insulated" },
    { 0xCAFA10EB, "insurance" },
    { 0x8D6CCC3B, "insure" },
    { 0xCB12D6AF, "insure_crawler_is_above_ground" },
    { 0xE4DA4039, "insure_player_does_not_set_forcecolor_twice_in_one_frame" },
    { 0x3400427C, "insurgency" },
    { 0x939F281B, "insurgents" },
    { 0x41626190, "insyncmeleewithtarget" },
    { 0x0B6B79A0, "int" },
    { 0xE8798E07, "int_1_tv_rounds" },
    { 0x31EE4E90, "int_2_tv_rounds" },
    { 0x01D8482D, "int_3_tv_rounds" },
    { 0x430129DD, "int_4_krav_weaver" },
    { 0x0C3AFAFE, "int_4_tv_rounds" },
    { 0x03F8B256, "int_5_reznov_vorkuta" },
    { 0xDA036963, "int_5_tv_rounds" },
    { 0xCD368AA6, "int_afghan_cratercharge_plant" },
    { 0x812DC9D6, "int_afghan_cratercharge_plant_from_stairs" },
    { 0x8411ADB3, "int_amount" },
    { 0xB537B22D, "int_angola_climb_tree_down" },
    { 0xDD328CE2, "int_angola_climb_tree_up" },
    { 0x6FFAC944, "int_angola_rescue_swim_backstroke" },
    { 0xBA141D2B, "int_angola_rescue_swim_tread" },
    { 0x6A3BB418, "int_anim" },
    { 0xC4702D35, "int_boat_boost_press" },
    { 0x3E15CA51, "int_boat_steering" },
    { 0xB8E5D450, "int_capped" },
    { 0x30579142, "int_clean" },
    { 0x7343EA0B, "int_client_num" },
    { 0x931FDB7A, "int_clientnum" },
    { 0x8C1032A1, "int_close" },
    { 0x9ECD089F, "int_contextual_melee_neckstab_quick" },
    { 0x4E9B120B, "int_contextual_melee_pakistan_neckstab" },
    { 0xB9F40B6E, "int_damage_model" },
    { 0xA0031B77, "int_data_glove_gameselect_idle" },
    { 0xA4074FF7, "int_data_glove_gameselect_input" },
    { 0xE70FD97C, "int_data_glove_gameselect_pullout" },
    { 0xD9633A72, "int_data_glove_gameselect_putaway" },
    { 0x27B505EB, "int_data_glove_pullout_alt" },
    { 0xCD073D0F, "int_digbat_tackle_combat_idle" },
    { 0x64CB5BC5, "int_digbat_tackle_getup" },
    { 0x9660D23E, "int_distance" },
    { 0xB9FA82EA, "int_dmg_fx" },
    { 0xD0EC6966, "int_door_open_masons_room" },
    { 0xF0D730D2, "int_doors" },
    { 0x66CF8A26, "int_esc_play_movie" },
    { 0xBBF57569, "int_esc_play_movie_done" },
    { 0x0907F21E, "int_esc_play_movie_id" },
    { 0x87E224EA, "int_escape" },
    { 0xE6A0B22B, "int_escape_amb" },
    { 0x026858FE, "int_escape_anim" },
    { 0x57E7E088, "int_escape_art" },
    { 0x57A0537F, "int_escape_fx" },
    { 0x04B8A585, "int_escape_util" },
    { 0x13D93702, "int_far_blur" },
    { 0x86A11A78, "int_far_end" },
    { 0x6517F59B, "int_far_start" },
    { 0xC61EF840, "int_flick" },
    { 0x78DEE2D9, "int_hits" },
    { 0x0C7B276D, "int_horse_player_canter_f" },
    { 0x9633858E, "int_horse_player_canter_left" },
    { 0x8A94DE45, "int_horse_player_canter_right" },
    { 0x59A51F5B, "int_horse_player_death_galloping" },
    { 0x52378A10, "int_horse_player_death_galloping_faceplant" },
    { 0x7D9792E9, "int_horse_player_death_standing_fast" },
    { 0x27EDE28C, "int_horse_player_death_standing_slow" },
    { 0x900C2D1A, "int_horse_player_eat_idle" },
    { 0x2685BF39, "int_horse_player_eat_idle_b" },
    { 0x1066CAE5, "int_horse_player_eat_idle_b_to_eat_idle" },
    { 0x8BA85967, "int_horse_player_eat_idle_b_to_stand_idle" },
    { 0x39E054BD, "int_horse_player_eat_idle_b_twitch_a" },
    { 0x5FE2CF26, "int_horse_player_eat_idle_b_twitch_b" },
    { 0x85E5498F, "int_horse_player_eat_idle_b_twitch_c" },
    { 0x6E310BD5, "int_horse_player_eat_idle_to_eat_idle_b" },
    { 0xD04786D0, "int_horse_player_eat_idle_to_stand_idle" },
    { 0x92C2A42D, "int_horse_player_eat_idle_to_wide_idle" },
    { 0x279BFC2C, "int_horse_player_eat_idle_twitch_a" },
    { 0x99A36B67, "int_horse_player_eat_idle_twitch_b" },
    { 0xA60E1D25, "int_horse_player_forward_idle" },
    { 0x515D1731, "int_horse_player_forward_idle_to_eat_idle" },
    { 0xC2CE2319, "int_horse_player_forward_idle_to_right_idle" },
    { 0x8CE6FC7B, "int_horse_player_forward_idle_to_stand_idle" },
    { 0x428DFA6E, "int_horse_player_frisky_idle" },
    { 0xD1D017C1, "int_horse_player_frisky_idle_to_wide_idle" },
    { 0x0EBD3D40, "int_horse_player_frisky_idle_twitch_a" },
    { 0x80C4AC7B, "int_horse_player_frisky_idle_twitch_b" },
    { 0x5AC23212, "int_horse_player_frisky_idle_twitch_c" },
    { 0xAE67C7E1, "int_horse_player_get_off_combat_leftside" },
    { 0xAFCD6F7A, "int_horse_player_get_off_combat_rightside" },
    { 0xDFAF89B6, "int_horse_player_get_off_leftside" },
    { 0x4E24A83B, "int_horse_player_get_off_rightside" },
    { 0x05CF510D, "int_horse_player_get_on_combat_leftside" },
    { 0x60A9073E, "int_horse_player_get_on_combat_rightside" },
    { 0x6DBB542A, "int_horse_player_get_on_leftside" },
    { 0xC8EADA07, "int_horse_player_get_on_rightside" },
    { 0x4314B622, "int_horse_player_idle_turn_l" },
    { 0x5F05D7AC, "int_horse_player_idle_turn_r" },
    { 0x89F6F2D2, "int_horse_player_jump_init" },
    { 0x11D86C98, "int_horse_player_jump_land_from_above" },
    { 0x0AA2DC66, "int_horse_player_jump_midair" },
    { 0xC3D25B5F, "int_horse_player_rearback_nofall" },
    { 0x1D29F69A, "int_horse_player_right_idle" },
    { 0x7B8FBB49, "int_horse_player_right_idle_to_forward_idle" },
    { 0x0CAD3450, "int_horse_player_right_idle_to_stand_idle" },
    { 0xDBB08A55, "int_horse_player_sprint_boost" },
    { 0xEE8D869A, "int_horse_player_sprint_f" },
    { 0x5983B747, "int_horse_player_sprint_left" },
    { 0x566FF5C2, "int_horse_player_sprint_right" },
    { 0x0CC2A2B4, "int_horse_player_stand_idle" },
    { 0x7F4DAF78, "int_horse_player_stand_idle_to_eat_idle" },
    { 0x60F19687, "int_horse_player_stand_idle_to_forward_idle" },
    { 0x9E4C0998, "int_horse_player_stand_idle_to_right_idle" },
    { 0x42727217, "int_horse_player_stand_idle_to_wide_idle" },
    { 0x28A059AA, "int_horse_player_stand_idle_twitch_a" },
    { 0x44AAF561, "int_horse_player_trot_f" },
    { 0x8C47B742, "int_horse_player_trot_left" },
    { 0x4667A5B1, "int_horse_player_trot_right" },
    { 0xE445BBB2, "int_horse_player_turn180_r" },
    { 0x398996CD, "int_horse_player_walk_b" },
    { 0xA17FAD29, "int_horse_player_walk_f" },
    { 0xFCB8110A, "int_horse_player_walk_left" },
    { 0x846020D9, "int_horse_player_walk_right" },
    { 0x5F8E4EC9, "int_horse_player_wide_idle" },
    { 0xFAB6F742, "int_horse_player_wide_idle_to_forward_idle" },
    { 0xF8F4DB4B, "int_horse_player_wide_idle_to_frisky_idle" },
    { 0xDEBA0D3D, "int_horse_player_wide_idle_to_right_idle" },
    { 0xEF41010D, "int_horse_player_wide_idle_twitch_a" },
    { 0x6A59E115, "int_horse_rider_hitwall" },
    { 0x8A677518, "int_how_many_hits" },
    { 0x5D183609, "int_input" },
    { 0x496CBA83, "int_karma_player_crc_mainframe_1" },
    { 0xD7654B48, "int_karma_player_crc_mainframe_2" },
    { 0xFD67C5B1, "int_karma_player_crc_mainframe_3" },
    { 0xBB7429BE, "int_karma_player_crc_mainframe_4" },
    { 0xE176A427, "int_karma_player_crc_mainframe_5" },
    { 0x6F6F34EC, "int_karma_player_crc_mainframe_6" },
    { 0x9571AF55, "int_karma_player_crc_mainframe_7" },
    { 0xF3566CD2, "int_karma_player_crc_mainframe_8" },
    { 0x1958E73B, "int_karma_player_crc_mainframe_9" },
    { 0x5CCD1ADE, "int_lift_door_dist" },
    { 0xEA3E141D, "int_lift_door_time" },
    { 0xF3A68A24, "int_lift_move_time" },
    { 0xC5147073, "int_lighting" },
    { 0xD7BC23C2, "int_list_index" },
    { 0x026CBA5B, "int_local_client_num" },
    { 0x4717C7A9, "int_local_player_num" },
    { 0xE5587103, "int_max" },
    { 0x444FFB38, "int_max_num_zombies_per_frame" },
    { 0xBEB97620, "int_meatshield_angola_player_back" },
    { 0x0DA1C069, "int_meatshield_angola_player_back_to_backleft" },
    { 0xE333D714, "int_meatshield_angola_player_back_to_backright" },
    { 0x08A07553, "int_meatshield_angola_player_backleft" },
    { 0xBB48D121, "int_meatshield_angola_player_backleft_to_back" },
    { 0x8A7A05C6, "int_meatshield_angola_player_backright" },
    { 0x3AF8C7C0, "int_meatshield_angola_player_backright_to_back" },
    { 0xAA6ECEED, "int_min" },
    { 0x31C05F66, "int_model" },
    { 0xC9A598DB, "int_monsoon_cave_grab" },
    { 0x176BF833, "int_monsoon_elevator" },
    { 0x1B581CF3, "int_monsoon_elevator_ext" },
    { 0xF235FDAA, "int_monsoon_remove_binoculars" },
    { 0x678D59E5, "int_monsoon_squirrelsuit_chute" },
    { 0xBB257B17, "int_monsoon_squirrelsuit_landing" },
    { 0x166986B0, "int_motion_sensor_pullout" },
    { 0x756B9B63, "int_near_blur" },
    { 0xCAB34497, "int_near_end" },
    { 0xAC61ED7C, "int_near_start" },
    { 0xB8335A02, "int_nicaragua_barn_door_open" },
    { 0xE72A94D9, "int_objects" },
    { 0xE719E765, "int_out" },
    { 0xCD2C39A4, "int_panama_pull_power_lever" },
    { 0x95714B68, "int_player_afghan_gun_fire" },
    { 0xC20E426D, "int_player_afghan_gun_raise_finish_fail" },
    { 0x3AAD6D8B, "int_player_afghan_gun_raise_intro_to_middle" },
    { 0xDDEAC4D6, "int_player_afghan_gun_raise_middle_to_finish" },
    { 0xAD0D78A2, "int_player_afghan_gun_raise_middle_to_offscreen" },
    { 0xF0F7CCF1, "int_player_afghan_gun_raise_middle_to_outofview" },
    { 0xE7EF49DD, "int_player_kick" },
    { 0xC4E60903, "int_priority" },
    { 0xF7DFA3DD, "int_rappel_time" },
    { 0x9B808D9D, "int_room_snapshot" },
    { 0x0545F9E1, "int_set" },
    { 0xB5C7B9D0, "int_specialty_afghanistan_intruder" },
    { 0xB45A01B0, "int_specialty_afghanistan_lockbreaker" },
    { 0xDF361CBC, "int_specialty_angola_bruteforce" },
    { 0xED161F08, "int_specialty_angola_intruder" },
    { 0x82485658, "int_specialty_angola_lockbreaker" },
    { 0x82D10C33, "int_specialty_blackout_bruteforce" },
    { 0x1F2A6CD9, "int_specialty_blackout_bruteforce_console" },
    { 0x46D2E6DB, "int_specialty_blackout_intruder" },
    { 0xB96CFCA9, "int_specialty_blackout_lockbreaker" },
    { 0xBB34A49B, "int_specialty_haiti_bruteforce" },
    { 0x65095573, "int_specialty_haiti_intruder" },
    { 0x8B868351, "int_specialty_haiti_lockbreaker" },
    { 0x22880032, "int_specialty_karma_bruteforce" },
    { 0xC381B3E2, "int_specialty_karma_intruder" },
    { 0xA5E43686, "int_specialty_karma_lockbreaker" },
    { 0x9A35974D, "int_specialty_la_intruder" },
    { 0x49BCC63F, "int_specialty_la_lockbreaker" },
    { 0xAF41C6AB, "int_specialty_monsoon_bruteforce" },
    { 0xBCB57683, "int_specialty_monsoon_intruder" },
    { 0x66A18FC1, "int_specialty_monsoon_lockbreaker" },
    { 0xD13A4F29, "int_specialty_nicaragua_bruteforce" },
    { 0xC3968CFD, "int_specialty_nicaragua_intruder" },
    { 0x8DDD05CF, "int_specialty_nicaragua_lockbreaker" },
    { 0x84D55749, "int_specialty_pakistan_intruder" },
    { 0xFA927F0E, "int_specialty_panama_bruteforce" },
    { 0x14C831E6, "int_specialty_panama_intruder" },
    { 0x961C134A, "int_specialty_panama_lockbreaker" },
    { 0x1E3BFCBE, "int_specialty_war_mode_lockbreaker" },
    { 0xC85919A8, "int_specialty_yemen_bruteforce" },
    { 0x8D1643AC, "int_specialty_yemen_intruder" },
    { 0x285C6C7C, "int_specialty_yemen_lockbreaker" },
    { 0x2FB00DBE, "int_st" },
    { 0x3C532020, "int_start_spot" },
    { 0xA2F15AD5, "int_strike" },
    { 0x42D2FB38, "int_struct" },
    { 0xA68B81AE, "int_sunglasses_on_frontend" },
    { 0xCCA16D04, "int_time" },
    { 0xF881F4DB, "int_trans" },
    { 0xA4D8D41B, "int_tree_climb_10" },
    { 0x23703A46, "int_tree_climb_20" },
    { 0x52BC2F48, "int_tree_climb_down_10" },
    { 0x0F704929, "int_tree_climb_down_20" },
    { 0x8378F7BF, "int_type" },
    { 0xD70A92D5, "int_war_mode_hack" },
    { 0x245F4C66, "int_war_mode_player_death" },
    { 0x153E32C4, "intact" },
    { 0xBE3A7E2B, "intactgeo" },
    { 0xC1C7CB2E, "intead" },
    { 0x86B9B9E8, "inteded" },
    { 0x5BE04BC5, "intefere" },
    { 0xF3D7F14D, "integer" },
    { 0x98AFADCC, "integers" },
    { 0xB30AE91E, "integrate" },
    { 0x508630FE, "integrated" },
    { 0xF2A17381, "integrates" },
    { 0x6377ADED, "integration" },
    { 0xB76BF8E6, "integration_on_player_connect" },
    { 0xCA05BB03, "integration_power_vision_set_swap" },
    { 0xAF0234D7, "integrationstep" },
    { 0x1261C8F1, "integreate" },
    { 0x86124FEA, "integrity" },
    { 0xB5DC5CEB, "intel" },
    { 0x347A4CA6, "intel_counter" },
    { 0x8D5758BB, "intel_feedback" },
    { 0xF5F59C0A, "intel_found" },
    { 0x74F3295A, "intel_items" },
    { 0xFE852024, "intel_map" },
    { 0xA6915334, "intel_round_multiplier" },
    { 0xADB2F2CE, "intel_start" },
    { 0x2FB9FB9F, "intel_table_lookup" },
    { 0xA7FFE97C, "inteleportation" },
    { 0xB0DC7A42, "inteleportcount" },
    { 0xB7A058BC, "intelligence" },
    { 0xB4C6E8E1, "intelligence_items" },
    { 0x276193B4, "intelligent" },
    { 0xB3BBAD71, "intelligently" },
    { 0x0F72161F, "intend" },
    { 0xBA57F124, "intended" },
    { 0x835BF969, "intendedyawchangeperframe" },
    { 0x22D39D1D, "intense" },
    { 0x0AA423C1, "intense_snow" },
    { 0x1F3D1BE1, "intensified" },
    { 0x796F8568, "intensities" },
    { 0x23C392A4, "intensity" },
    { 0x1156CBDC, "intensity0" },
    { 0x37594645, "intensity1" },
    { 0x7328F6EB, "intensity_change" },
    { 0xC6F2CC5B, "intensity_high" },
    { 0x8281D9EE, "intensity_is_dirty" },
    { 0x47382ABF, "intensity_low" },
    { 0xC9376368, "intensity_val" },
    { 0xA785CE84, "intensitycap" },
    { 0x10D9B1B4, "intensitychange" },
    { 0x1EC65682, "intensive" },
    { 0x6F99BCAF, "intent" },
    { 0x5C14D967, "intention" },
    { 0xEC5526D8, "intentional" },
    { 0x1F1442DD, "intentionally" },
    { 0x615DC3DE, "intentions" },
    { 0x7DBAB8D1, "inter_chair_setup" },
    { 0x52F921D6, "inter_glass_setup" },
    { 0xE9262A3C, "inter_hatch_setup" },
    { 0x6C8F4CCE, "inter_table_setup" },
    { 0x13D7D31F, "interact" },
    { 0x96A1AD55, "interact_array" },
    { 0xE2CD815E, "interact_entity_highlight" },
    { 0xA32167D8, "interact_func" },
    { 0x0CCA344B, "interact_hold_time" },
    { 0xDECA905B, "interact_offset" },
    { 0x5ACB172B, "interact_points" },
    { 0x4BD6B61C, "interact_pos" },
    { 0x9921132C, "interact_prio" },
    { 0x07CC1D81, "interact_standard_height" },
    { 0x675DA345, "interact_types" },
    { 0x2589EE56, "interactables" },
    { 0x224192F0, "interactanim" },
    { 0x33D4AC21, "interacting" },
    { 0xC44BDAF7, "interaction" },
    { 0x5BA6E4C7, "interaction_height" },
    { 0x6373CAEE, "interaction_priority" },
    { 0xFFCC3134, "interaction_trigger_height" },
    { 0x1ADCB0D3, "interaction_trigger_radius" },
    { 0x3DBF925D, "interaction_types" },
    { 0x7A79A22F, "interaction_yaw_offset" },
    { 0xBF642DFA, "interaction_z_offset" },
    { 0xC181BB2E, "interactions" },
    { 0xF670A10B, "interactive" },
    { 0x2DB3876D, "interactive_cardboardboxthink" },
    { 0x4A0A2BD5, "interactive_cratethink" },
    { 0x174D55FF, "interactive_fencethink" },
    { 0xA3A446D1, "interactive_main" },
    { 0xF2D6621B, "interactive_precachefx" },
    { 0xC17DED72, "interactive_wallthink" },
    { 0x219C2DA6, "interacts" },
    { 0xF698AFE4, "interactteam" },
    { 0x953020ED, "intercept" },
    { 0x3039316D, "intercept_zeroes_00" },
    { 0xF0186CCE, "intercept_zeroes_00a" },
    { 0x0A36B704, "intercept_zeroes_01" },
    { 0x563BABD6, "intercept_zeroes_03" },
    { 0xE64BE59A, "intercepted" },
    { 0xBFFCE74D, "interceptfunction" },
    { 0x610DBB7B, "intercepting" },
    { 0xFDA627FE, "interceptnotetracksforweaponswitch" },
    { 0x3C096F09, "interchange" },
    { 0x9262D3C4, "intercom" },
    { 0x0A8413EE, "interconnected" },
    { 0x12B822A3, "interdimensional_gun_attacker" },
    { 0x8396344C, "interdimensional_gun_inflictor" },
    { 0x100FE2BA, "interdimensional_gun_kill" },
    { 0x4F117CC1, "interdimensional_gun_kill_vortex_explosion" },
    { 0xD42D83C3, "interdimensional_gun_projectile" },
    { 0x4C35CC5E, "interdimensional_gun_weapon" },
    { 0x716C688F, "interdimensional_kill" },
    { 0x7B999663, "interest" },
    { 0x0FA8E958, "interested" },
    { 0x28CAAD3D, "interesting" },
    { 0x7AB4AA52, "interests" },
    { 0xB1A18C4A, "interface" },
    { 0x6525B785, "interfaces" },
    { 0xB4730E2D, "interfere" },
    { 0xEE53E0CD, "interference" },
    { 0xB5B27E35, "interference_trigger_think" },
    { 0x2C3F882C, "interferes" },
    { 0x00D595CF, "interim" },
    { 0x21216740, "interioir" },
    { 0x75DF6D25, "interior" },
    { 0x1DF9877E, "interior_anims" },
    { 0x2BA483F6, "interior_boss_spawner" },
    { 0x03752160, "interior_breach_without_worry" },
    { 0x68C04A5C, "interior_clear_group_b_move_up" },
    { 0x23142F49, "interior_cover_tracks_init" },
    { 0xCB15007D, "interior_door_react_to_kick" },
    { 0x52BDC2F6, "interior_door_vo" },
    { 0x8B97329D, "interior_doorway_fallback_guys" },
    { 0xFBCC3C92, "interior_doorway_fallback_spawners" },
    { 0xC0D72599, "interior_fight_a_goal_volume" },
    { 0x81C02692, "interior_fight_a_spawners" },
    { 0x9ABA737E, "interior_fight_a_struct" },
    { 0x268D0367, "interior_fight_a_volume" },
    { 0x46028955, "interior_fire_barrel_spawners" },
    { 0x029EFE03, "interior_firebarrel_guys" },
    { 0xADB2FCB8, "interior_first_line_fallback" },
    { 0xB4F8AE6A, "interior_hole_boss" },
    { 0xC6EFDF08, "interior_idle_sound_ent" },
    { 0x4FC2E9D4, "interior_lift_bottom_connect_left" },
    { 0x96ACCE0B, "interior_lift_bottom_connect_right" },
    { 0x1EABE4E0, "interior_lift_top_connect_left" },
    { 0xB34569CF, "interior_lift_top_connect_right" },
    { 0xD4E420BD, "interior_light_play" },
    { 0x1D282627, "interior_lights" },
    { 0xDCC0D639, "interior_lights_off" },
    { 0xEF50DC4D, "interior_lights_on" },
    { 0x00CB902F, "interior_model" },
    { 0x451482B3, "interior_open_door" },
    { 0xEB3DD928, "interior_override" },
    { 0x506C068C, "interior_ruins_vision" },
    { 0x8E027A24, "interior_squad_breach_move_in" },
    { 0x9E6B0AC4, "interior_window_anim" },
    { 0x76CA324B, "interior_window_anim_exit" },
    { 0xBCF28767, "interior_wire_vo" },
    { 0x6C2520A5, "interiorlightfx" },
    { 0x71F52F6B, "interiorlightfxhandle" },
    { 0xCECD8242, "interiorlights" },
    { 0xD30E7675, "interiorlighttag" },
    { 0x60EB2134, "interiors" },
    { 0x3AE8A6CB, "interiort" },
    { 0x99146532, "intermediate" },
    { 0xC2A00C2E, "intermediate_damage" },
    { 0x36400FB1, "intermediate_node" },
    { 0xCABE29B4, "intermediateguardposition" },
    { 0x4E0E3E8A, "intermediateguardtime" },
    { 0x4B93AF95, "intermission" },
    { 0xF66D0BFF, "intermission_cam_model" },
    { 0x4F7F70EA, "intermission_monitor" },
    { 0xA8AA1A28, "intermission_rocket_blur" },
    { 0x18ACC832, "intermission_streamer_hint_priority" },
    { 0x17837263, "intermission_struct" },
    { 0x7C9D9EE4, "intermissions" },
    { 0x5A2F97C3, "intermittently" },
    { 0x4AAFBD92, "internal" },
    { 0xF26200C4, "internal_msg" },
    { 0x31D768F8, "internal_stop_magic_bullet_shield" },
    { 0x473B486E, "internal_update_grave_state" },
    { 0x95059979, "internalexecuterule" },
    { 0x44BE339F, "internally" },
    { 0x9EE2A51D, "internalmain" },
    { 0x1DDEB19D, "internals" },
    { 0xFF524512, "interogation" },
    { 0x3460A468, "interogation_speaker" },
    { 0xC6B46F21, "interogation_speaker_think" },
    { 0x1C15EC67, "interogator" },
    { 0xA30EACDE, "interogators" },
    { 0x4C3DEB86, "interpolate" },
    { 0x5FEBC2D0, "interpolater" },
    { 0x85EE3D39, "interpolates" },
    { 0x073EA83F, "interpolating" },
    { 0xB82CCAC5, "interpolation" },
    { 0xB950C9A4, "interpret" },
    { 0xD0713B86, "interps" },
    { 0x26878937, "interpz" },
    { 0x6479CC8D, "interrior" },
    { 0x9391BC50, "interro" },
    { 0x1D866005, "interrogate" },
    { 0x5ED4A0A7, "interrogate_jumpto" },
    { 0x9927B1DA, "interrogation" },
    { 0xA4C5E988, "interrogation_break_mirror" },
    { 0x42D8BEE0, "interrogation_bullets" },
    { 0x8AD5AE7C, "interrogation_camera" },
    { 0x3DC7DF2D, "interrogation_done" },
    { 0xA98A318D, "interrogation_handcuffs" },
    { 0xC82514FD, "interrogation_interrupted" },
    { 0x6B6A3425, "interrogation_lightflicker" },
    { 0xEACD14FE, "interrogation_menendez_bleed" },
    { 0x7AC6F9C0, "interrogation_midway_through" },
    { 0x79D94E18, "interrogation_reels" },
    { 0x76451BB1, "interrogation_room_watcher" },
    { 0xF9936383, "interrogation_scene" },
    { 0x29D252BC, "interrogation_setup" },
    { 0x32EC29BF, "interrogator" },
    { 0xD44F8561, "interrogator_ent" },
    { 0x9D0C9D6F, "interrogator_lines" },
    { 0x8D0AE99E, "interrupeted" },
    { 0x264BE92E, "interrupt" },
    { 0xD8AD6E8D, "interrupt_" },
    { 0x4ABD0AC8, "interrupt_farmer" },
    { 0x50E11A74, "interrupt_gondola_call_trigger_" },
    { 0x2E8C5628, "interrupt_gondola_call_trigger_docks" },
    { 0xC2361B06, "interrupt_gondola_call_trigger_roof" },
    { 0x937906E9, "interrupt_gondola_move_trigger_" },
    { 0x14F3055F, "interrupt_gondola_move_trigger_docks" },
    { 0x7070385F, "interrupt_gondola_move_trigger_roof" },
    { 0xFE359AC3, "interrupt_guard_node" },
    { 0xD0C4B8FE, "interrupt_patroller_go_to_node" },
    { 0x5E25E2CD, "interrupt_shot" },
    { 0x79B60562, "interrupt_wandering" },
    { 0x5FF8161B, "interrupt_woods_split_talking" },
    { 0x11B3E03A, "interruptable" },
    { 0xB2CCB988, "interruptanimation" },
    { 0x1D04F718, "interruptdeath" },
    { 0x0E8F0A71, "interrupted" },
    { 0xFE6DC7ED, "interrupteddeath" },
    { 0xE88C9008, "interruptee" },
    { 0xAB45B852, "interrupting" },
    { 0xDB1DD69C, "interruption" },
    { 0x5CEAB8DF, "interruptions" },
    { 0x461EC708, "interruptive" },
    { 0x6077BEB3, "interruptothers" },
    { 0x06692FA4, "interruptpoint" },
    { 0x3106A551, "interrupts" },
    { 0x65024D01, "interrupttarget" },
    { 0xF428DE4C, "intersect" },
    { 0xC329A0FD, "intersect_vip_cougar_died" },
    { 0x5BE0E1CC, "intersect_vip_cougar_saved" },
    { 0x173B57FC, "intersecting" },
    { 0x664D3576, "intersection" },
    { 0x212A1B24, "intersection_backtrack_fail" },
    { 0xDB0E7641, "intersection_deathposes" },
    { 0x117CEDEA, "intersection_fallback_kill_count" },
    { 0x540EDA23, "intersection_goal_volume_update" },
    { 0x7FD05FC5, "intersection_kill_count" },
    { 0xBAD7BE6B, "intersection_kill_update" },
    { 0x14870221, "intersection_last_truck" },
    { 0x10361063, "intersection_osprey" },
    { 0x61B9984E, "intersection_ss_kill" },
    { 0x3B194C28, "intersection_ss_turn_off_mbs" },
    { 0x2028D414, "intersection_ss_turn_off_mbs_when_player_gets_there" },
    { 0x8B70D82C, "intersection_started" },
    { 0xC595C07C, "intersection_vo" },
    { 0x89EBD65B, "intersection_vo_pmc_callouts" },
    { 0x7FD6290A, "interstial" },
    { 0x77F0928B, "interstitial" },
    { 0x1AA86B03, "interstitial_ai_anims" },
    { 0xF6492C4D, "interstitial_player_camera_movement_control" },
    { 0x2353146E, "interstitial_skipped" },
    { 0xA1301EEA, "interstitials" },
    { 0x3D6580A6, "interupt" },
    { 0xC87411E2, "interuptable" },
    { 0x2C870029, "interupted" },
    { 0x186EEDF4, "interuption" },
    { 0x32B93ACA, "interval" },
    { 0xE4B3B3A5, "interval_change" },
    { 0x7CFFAE51, "interval_max" },
    { 0xEA778CAF, "interval_min" },
    { 0x84A4702C, "interval_sec" },
    { 0xA5D9E08E, "interval_wait" },
    { 0x09907E16, "intervaldist" },
    { 0x1D6D6B05, "intervals" },
    { 0x1775F8BC, "inthemoneyonradar" },
    { 0xDA2224E2, "intial" },
    { 0x7068061A, "intial_up" },
    { 0xC5BC4890, "intialize" },
    { 0x47E4390F, "intially" },
    { 0x65EEAD2F, "intime" },
    { 0x028472C2, "intimidating" },
    { 0x0652C19C, "intionally" },
    { 0x631BE984, "intitializations" },
    { 0x010FE6EA, "intmax" },
    { 0x6D65413E, "intn" },
    { 0x9367BBA7, "into" },
    { 0xBAE97376, "into_character_done" },
    { 0x2D4DD886, "into_snd_snapshot" },
    { 0x056F2AE2, "intr" },
    { 0x61A73FB2, "intr_on" },
    { 0x02855A41, "intransit" },
    { 0x6B13F886, "intrinsic" },
    { 0x21B8A3E1, "intro" },
    { 0xFED2743C, "intro1_drones" },
    { 0x40BCA4FD, "intro2_drones" },
    { 0x97AA8CCB, "intro4_drones" },
    { 0xF8DB7420, "intro5_drones" },
    { 0x24A95BED, "intro_01" },
    { 0x536C54B0, "intro_01_render" },
    { 0x4AABD656, "intro_02" },
    { 0xC42B97E1, "intro_02_render" },
    { 0x789DBB55, "intro_a" },
    { 0x91C9B6B7, "intro_a_player" },
    { 0xDE761345, "intro_achievement_detection" },
    { 0xD2EE2111, "intro_ai_fire" },
    { 0x95CCABD7, "intro_ai_scopedown" },
    { 0xE5F85D08, "intro_ai_scopeup" },
    { 0x4745A76F, "intro_ai_start" },
    { 0x72B2A542, "intro_ambulance" },
    { 0x7FBA22D3, "intro_anim" },
    { 0x15058F56, "intro_anim_claw_done" },
    { 0x7AA284C6, "intro_anim_done" },
    { 0xCB7F4B53, "intro_anim_name" },
    { 0xB4D33F8B, "intro_animation_finished" },
    { 0xAADFA602, "intro_anims" },
    { 0xBEACF198, "intro_area_horses" },
    { 0x7B3AD121, "intro_asd_think" },
    { 0x94F5DC53, "intro_attack_logic" },
    { 0x83BAA0D2, "intro_avoid_tableguys" },
    { 0x3BB4B9F0, "intro_barrage" },
    { 0x4F9836A2, "intro_barrage_quake" },
    { 0x343B9E7B, "intro_base" },
    { 0xACC4E6E1, "intro_bat_digbat" },
    { 0xC0FC121C, "intro_birds" },
    { 0x259D639C, "intro_black_screen" },
    { 0xA0B14B75, "intro_blackhawks" },
    { 0x72B159ED, "intro_block_triggers" },
    { 0x2EF31001, "intro_cam" },
    { 0x6023B294, "intro_cam_aim_clamp_pitch" },
    { 0x8B2339D3, "intro_cam_aim_clamp_yaw" },
    { 0x6C7E2E80, "intro_cam_aim_max_vel" },
    { 0x47C60623, "intro_cam_aim_vel" },
    { 0x58644DE8, "intro_cam_aim_vel_pitch" },
    { 0xB22953C7, "intro_cam_aim_vel_yaw" },
    { 0x96F79455, "intro_cam_angle_clamp" },
    { 0xBE7C7C2C, "intro_cam_dt" },
    { 0xD618A66B, "intro_cctv_assigned" },
    { 0xDB4EDAEA, "intro_cctv_complete" },
    { 0x44B23306, "intro_cctv_started" },
    { 0xE9E554F4, "intro_change_color" },
    { 0xCA86A3E2, "intro_chopper_fight" },
    { 0x11260939, "intro_church_tower_explode" },
    { 0xE2601F72, "intro_cin_id" },
    { 0x4E23107A, "intro_civ" },
    { 0xB567DA7B, "intro_civilian_saved" },
    { 0x97A2E193, "intro_civilian_watch" },
    { 0x35D161E3, "intro_claw_fire_done" },
    { 0xAF9197EA, "intro_claw_target_stop" },
    { 0xDCDF9AA0, "intro_cleanup" },
    { 0x3FDDB822, "intro_cleanup2" },
    { 0xCD2CDF9A, "intro_close_in_on_target" },
    { 0x9FA9F7AD, "intro_close_redshirt_think" },
    { 0xBD5AC766, "intro_column_damage" },
    { 0xEB9CDCD9, "intro_complete" },
    { 0xACD701D2, "intro_convoy_jet" },
    { 0x312CE6FB, "intro_cop1" },
    { 0xBF2577C0, "intro_cop2" },
    { 0xE527F229, "intro_cop3" },
    { 0xA3345636, "intro_cop4" },
    { 0xDFF631CF, "intro_corpse_hide" },
    { 0xB1812F2B, "intro_cougar" },
    { 0x6075490A, "intro_cougars" },
    { 0xB4D6A265, "intro_courtyard_convoy_done" },
    { 0x885DBD8C, "intro_courtyard_defend" },
    { 0xE13A3DF7, "intro_courtyard_gate_control" },
    { 0x886AAAFE, "intro_cqb_into_shack" },
    { 0xA9158DBA, "intro_credits" },
    { 0xD2C8397A, "intro_delete_canisters" },
    { 0xE4152D44, "intro_dialog" },
    { 0xD84CD3AE, "intro_dialogue" },
    { 0x6CEA1471, "intro_digbat_watch" },
    { 0x730D636B, "intro_dof" },
    { 0xA97D583F, "intro_dof_grab_rope" },
    { 0x3385DDAF, "intro_dof_lhand_plant" },
    { 0x8668F636, "intro_dof_look_down" },
    { 0x92766E4C, "intro_dof_look_harper" },
    { 0xC3854CB5, "intro_dof_look_left" },
    { 0x8D68338B, "intro_dof_look_rhand" },
    { 0x860C779D, "intro_dof_rhand_plant" },
    { 0xB162A3A4, "intro_done" },
    { 0xD0A3C45F, "intro_doors" },
    { 0x4B249455, "intro_dragovich_slowmo" },
    { 0xEF6491AD, "intro_drive_finished" },
    { 0x866BBDA2, "intro_drone" },
    { 0x24E2FEE4, "intro_drone_shooting_started" },
    { 0x62F98312, "intro_enemies_2a_setup" },
    { 0xFBE96C1F, "intro_enemies_kill" },
    { 0x9E07961B, "intro_enemy_logic" },
    { 0x866C8EFA, "intro_enemy_mortar_attacks" },
    { 0xD1F91DB1, "intro_execution_done" },
    { 0x581B691B, "intro_execution_friendlies_moveup" },
    { 0x7D49D3A1, "intro_execution_friends_dialogue" },
    { 0x149D1D2B, "intro_execution_guy_cleanup" },
    { 0x68BE6A61, "intro_execution_interrupted" },
    { 0xFB4C1477, "intro_execution_runpast_colorchain" },
    { 0xB22FF4CD, "intro_explosion_1" },
    { 0xD8326F36, "intro_explosion_2" },
    { 0xFE34E99F, "intro_explosion_3" },
    { 0xF630E4AC, "intro_explosion_aftermath" },
    { 0xF3F6F662, "intro_exterior" },
    { 0x52EF2BDE, "intro_fade" },
    { 0x8A945C7C, "intro_fade_in" },
    { 0x4FBA3296, "intro_fade_in2" },
    { 0x6E2455B1, "intro_fail_trigger" },
    { 0xC2A26A18, "intro_fail_triggers" },
    { 0xD5B41516, "intro_fake_ambience" },
    { 0xF13D0387, "intro_fake_gunfire_stop" },
    { 0x388E626B, "intro_fakefire" },
    { 0x9E0DB0DD, "intro_fakefire_end" },
    { 0x19966D9E, "intro_fight" },
    { 0x935C5B8E, "intro_finished" },
    { 0x5F4056EE, "intro_flak" },
    { 0xC6B5CE94, "intro_flak_hatch_open" },
    { 0x5F53A8CB, "intro_flak_knockdown" },
    { 0xE53C5615, "intro_flame" },
    { 0x5A433EF6, "intro_flame_back_fade" },
    { 0xC9DA1D67, "intro_flame_end" },
    { 0xA3791B0E, "intro_flame_pause" },
    { 0xA27152BC, "intro_flashback_dialogue" },
    { 0xBD69E835, "intro_flyover" },
    { 0x1404986B, "intro_fog_town" },
    { 0x42359E0E, "intro_force_visionset_changes" },
    { 0xBD010407, "intro_fork_smokers" },
    { 0x72007038, "intro_fxanims" },
    { 0x95B2EEC5, "intro_german_1_death" },
    { 0xBF65B2A0, "intro_german_2_injured_loop" },
    { 0xC57BF06F, "intro_german_3_injured_loop" },
    { 0x79DEC2D5, "intro_german_dialog" },
    { 0x928867D8, "intro_german_end_anim_at_damage" },
    { 0xA719835B, "intro_german_injured_kill" },
    { 0x02B6248D, "intro_giveback_weapon" },
    { 0xE5516A6E, "intro_go" },
    { 0xA151BB73, "intro_guard" },
    { 0xFC5D7F6C, "intro_guard_fx" },
    { 0xE73A11A8, "intro_gunner_think" },
    { 0x203E4C9C, "intro_guys" },
    { 0xD7CE6A23, "intro_guys_advance" },
    { 0x88D375DC, "intro_guys_ai_stop_shield" },
    { 0x6F1D420F, "intro_guys_die" },
    { 0x614DE350, "intro_guys_move" },
    { 0xF9476155, "intro_hall" },
    { 0x6814291F, "intro_handle_last_patrol_clip" },
    { 0xBF209E3D, "intro_handle_last_patrol_clip_spotted" },
    { 0xD7D8A54B, "intro_handle_leave_area_clip" },
    { 0x2F83C539, "intro_handle_leave_area_clip_spotted" },
    { 0x19C1FFC3, "intro_handle_leave_area_flag" },
    { 0xA533EC19, "intro_handle_safezone_flag" },
    { 0x75CE8B19, "intro_handle_spotted_dialogue" },
    { 0x96BBDCA4, "intro_hands_end" },
    { 0xF1480475, "intro_harper_kick_rumble" },
    { 0x1F043C67, "intro_heli_hit_by_missile" },
    { 0x97EA8963, "intro_heli_minigun_firethread" },
    { 0xA679E0D2, "intro_heli_rain_fx" },
    { 0xD9C8F346, "intro_helis_fire" },
    { 0x057CFE3B, "intro_helpout_dudes_setup" },
    { 0x23FE92D2, "intro_hide_fxanim" },
    { 0x93813F36, "intro_hill_interrupted" },
    { 0xFC60BAEA, "intro_hillpatrol_check" },
    { 0x7DC2D97C, "intro_holdup" },
    { 0x0B0534BD, "intro_horsemen" },
    { 0x288504B9, "intro_horses_pos" },
    { 0xBB55BB52, "intro_house_collapse" },
    { 0x575BCB27, "intro_hq_barrel_spawners_strat" },
    { 0x944E0877, "intro_hud" },
    { 0x9D68421A, "intro_hud_done" },
    { 0x477D13AC, "intro_hud_fadeout" },
    { 0x03C9B93B, "intro_huey" },
    { 0xD471CB43, "intro_igc" },
    { 0x566FBC98, "intro_igc_friendlies_strat" },
    { 0xD36947CE, "intro_igc_guys" },
    { 0x61155F49, "intro_image_comes_in" },
    { 0x0421760F, "intro_impact_missile" },
    { 0x9F91B43D, "intro_interrupt" },
    { 0xE8119580, "intro_jeep_stuck_spawners_strat" },
    { 0x8125570E, "intro_jetpack_wait" },
    { 0xC6D887B5, "intro_jump_vtol_think" },
    { 0x110C2916, "intro_lander" },
    { 0x31510185, "intro_last_patrol" },
    { 0x3B552642, "intro_last_patrol_dead" },
    { 0xFB09ADE1, "intro_last_patroller_corpse_name" },
    { 0x2C0BD646, "intro_lastguy_death" },
    { 0x11E68178, "intro_lastguy_think" },
    { 0x7A0FB9AF, "intro_leave_area" },
    { 0x98D27FA4, "intro_leave_area_dialogue" },
    { 0x312AA939, "intro_left_area" },
    { 0x5FF63CB3, "intro_leftdoor" },
    { 0x7C3BD5EA, "intro_line" },
    { 0xED55E63F, "intro_loudspeaker" },
    { 0x5855575B, "intro_main" },
    { 0x5F69352E, "intro_mason" },
    { 0x6076AFFA, "intro_melee_fights" },
    { 0x009F67BA, "intro_models" },
    { 0xDC3F4EE7, "intro_move_engineer_climb" },
    { 0xB3C9CE12, "intro_move_player_origin" },
    { 0xF2570A24, "intro_move_player_to_rear" },
    { 0x844F0D8B, "intro_movie_abort" },
    { 0xA88A6453, "intro_movie_done" },
    { 0x1328CE08, "intro_movie_hack" },
    { 0xB1153682, "intro_movie_prompt_abort" },
    { 0x977D9995, "intro_music" },
    { 0x177897F4, "intro_names" },
    { 0xA1CA97EA, "intro_narration" },
    { 0xECB51574, "intro_narration_callback" },
    { 0xF29A28A3, "intro_noriega" },
    { 0xC0D95094, "intro_notetrack_catcher" },
    { 0xC04E1E55, "intro_offset" },
    { 0x20A3D2ED, "intro_offsets_dialog_time" },
    { 0x7C80A6C6, "intro_overlook_door" },
    { 0x476E41B7, "intro_overlook_gun_fire" },
    { 0x376D0636, "intro_patrol_guys_dead" },
    { 0x15A5E5C1, "intro_pdf_sprint" },
    { 0x7A1DA58F, "intro_pipe_building_01_guy" },
    { 0x79B633F3, "intro_player" },
    { 0xBE767423, "intro_player_clamp_bottom" },
    { 0x4EE5567D, "intro_player_clamp_left" },
    { 0x3DF83DE0, "intro_player_clamp_right" },
    { 0xFDFA82DF, "intro_player_clamp_top" },
    { 0xE1A4B2EA, "intro_player_dof1" },
    { 0xC01DFFCE, "intro_player_dof10" },
    { 0xE6207A37, "intro_player_dof11" },
    { 0x74190AFC, "intro_player_dof12" },
    { 0x9A1B8565, "intro_player_dof13" },
    { 0x2814162A, "intro_player_dof14" },
    { 0x4E169093, "intro_player_dof15" },
    { 0xBBA23881, "intro_player_dof2" },
    { 0x959FBE18, "intro_player_dof3" },
    { 0x9FB116F7, "intro_player_dof4" },
    { 0x79AE9C8E, "intro_player_dof5" },
    { 0x53AC2225, "intro_player_dof6" },
    { 0x2DA9A7BC, "intro_player_dof7" },
    { 0xD7935A0B, "intro_player_dof8" },
    { 0xB190DFA2, "intro_player_dof9" },
    { 0xB020AA45, "intro_player_rumble" },
    { 0x7B0D55A9, "intro_player_scene_logic" },
    { 0x7B648B93, "intro_player_vo_1" },
    { 0x095D1C58, "intro_player_vo_2" },
    { 0x846CD308, "intro_poi" },
    { 0x26CA6BEA, "intro_pos_1" },
    { 0x00C7F181, "intro_pos_2" },
    { 0xD4F0BF10, "intro_powerup" },
    { 0xBB996508, "intro_powerup_activate" },
    { 0xCBCE9BD5, "intro_powerup_restored" },
    { 0xD2BAF60F, "intro_prisoners" },
    { 0xE3841D99, "intro_quad" },
    { 0x51A424E8, "intro_quad_fire" },
    { 0xA554B40F, "intro_quad_heavydmg" },
    { 0x5BDF1ABB, "intro_quad_off" },
    { 0x763748C7, "intro_quad_on" },
    { 0xB917F0E0, "intro_quad_showfps" },
    { 0x220AF451, "intro_quad_spawn" },
    { 0x8DE0E2B4, "intro_rail" },
    { 0x8DBE821E, "intro_redshirts" },
    { 0x7F710AC8, "intro_rejoin_player_to_hands" },
    { 0x32C720E9, "intro_release_player" },
    { 0xFD321251, "intro_restore_share_screen" },
    { 0xB838AD4D, "intro_return_from_black" },
    { 0xEAC06F42, "intro_ridgeline_check" },
    { 0xFA86F5FE, "intro_rightdoor" },
    { 0xBAFE51E7, "intro_road_pak" },
    { 0x39F1E511, "intro_rock_show" },
    { 0xCB2E20D5, "intro_room" },
    { 0x2478D991, "intro_rope_l" },
    { 0x389B8B4F, "intro_rope_r" },
    { 0xA6CF3860, "intro_rumble1" },
    { 0x18D6A79B, "intro_rumble2" },
    { 0x298EB4A4, "intro_runup" },
    { 0x8B4B71C3, "intro_rus_flag" },
    { 0x0E4294E8, "intro_russian_1_death" },
    { 0x8370C218, "intro_save_restore" },
    { 0x1AB4414C, "intro_scene" },
    { 0x21E38D67, "intro_scene_misc" },
    { 0x0FE17C18, "intro_screen" },
    { 0xC77B9999, "intro_screen_dialogue" },
    { 0x48DF886E, "intro_scuffle" },
    { 0xD9AB1352, "intro_set_cull_dist" },
    { 0x866F08EB, "intro_setup" },
    { 0x5383FC61, "intro_setup_player" },
    { 0x464AC4F4, "intro_shellshock" },
    { 0xFE935F74, "intro_show_gun" },
    { 0x07050538, "intro_snapshot" },
    { 0xFDE4C130, "intro_sneakup_patrollers" },
    { 0x6CF85A9F, "intro_sneakup_patrollers_death" },
    { 0x080897E1, "intro_sneakup_patrollers_dialogue" },
    { 0xE99BCF43, "intro_sneakup_patrollers_kill" },
    { 0x43DEA3B8, "intro_sneakup_patrollers_kill_dialogue" },
    { 0xEF4CC7D6, "intro_sneakup_patrollers_moveto_kill" },
    { 0x1417D8AA, "intro_sneakup_tableguys" },
    { 0x31531720, "intro_sounds" },
    { 0x5D124787, "intro_spawn_dynents" },
    { 0x574A42B0, "intro_spawns" },
    { 0x07DC3556, "intro_speech" },
    { 0x676155EE, "intro_ss" },
    { 0xFE8294FB, "intro_start_ambient_activity" },
    { 0x7DAC05CC, "intro_start_civ_anims" },
    { 0x1DB0CFB3, "intro_started" },
    { 0x316729C6, "intro_static_shader" },
    { 0x3B0BA2BE, "intro_street_runners_strat" },
    { 0x998CB33B, "intro_street_spawners" },
    { 0x1B7B7895, "intro_swim_anim_gap" },
    { 0x6E3245FF, "intro_tableguys_event_awareness" },
    { 0x36825F55, "intro_tank_lookat" },
    { 0x115DCC6C, "intro_tankdrive" },
    { 0x1A3B902C, "intro_text_crawls" },
    { 0x3C1C2D6A, "intro_threat_rockets" },
    { 0xF2C4F3F7, "intro_time" },
    { 0xD7916595, "intro_to_church_spotted" },
    { 0x6CB6A270, "intro_trigger" },
    { 0xD05EDCA9, "intro_truck_behaviour" },
    { 0xB57BE73F, "intro_vehicles" },
    { 0x39882337, "intro_vehicles_spawn" },
    { 0xB7A12FA7, "intro_vehicles_start_moving" },
    { 0x3515F754, "intro_viewhands_anim_done" },
    { 0x18B9F934, "intro_vision" },
    { 0xD0212420, "intro_visionset_1" },
    { 0x4228935B, "intro_visionset_2" },
    { 0x1C2618F2, "intro_visionset_3" },
    { 0x8E2D882D, "intro_visionset_4" },
    { 0x682B0DC4, "intro_visionset_5" },
    { 0x37F6E2E9, "intro_vo" },
    { 0x517D4259, "intro_vox_or_skit" },
    { 0x4B17E7F4, "intro_vtol1_explosion" },
    { 0xD383A73B, "intro_vtol2_explosion" },
    { 0xFEEF2E12, "intro_vtol3_explosion" },
    { 0x9E269453, "intro_vtol_pieces" },
    { 0x34B8EFBF, "intro_vtol_sound" },
    { 0xEC5804B7, "intro_wait" },
    { 0x7F3C6AC0, "intro_wait_anim_done" },
    { 0x37402999, "intro_wait_notify" },
    { 0x50C7F4F3, "intro_waver1_strat" },
    { 0x958D1B14, "intro_waver2_strat" },
    { 0xA86B33A9, "intro_windshield_swap" },
    { 0x933B9967, "intro_worker_pa_dialog" },
    { 0x55BBDCE9, "intro_workers" },
    { 0x35C8C856, "introanim" },
    { 0x89779836, "introblack" },
    { 0x9261255D, "introblackbacking" },
    { 0xE8399D95, "introdialog" },
    { 0x7230B454, "introduce" },
    { 0xBE52A978, "introduced" },
    { 0x683C5BC7, "introduces" },
    { 0x167D8C41, "introduction" },
    { 0xAA29E7F7, "introduction_abort_watcher" },
    { 0x4667FB79, "introduction_complete" },
    { 0x017A2219, "introhilltrigs" },
    { 0x92DA6580, "introigc" },
    { 0xE2925A5D, "introigc_victim_playerkill" },
    { 0xE4CA3288, "intros" },
    { 0x7F43D69B, "introscene" },
    { 0x3A506053, "introscene_artystrikes" },
    { 0x8DF260BF, "introscene_closedoors_far" },
    { 0x08307532, "introscene_closedoors_near" },
    { 0x03F1E04C, "introscene_closedoors_near_startanim" },
    { 0xDD3F45E3, "introscene_closedoors_near_warpdone" },
    { 0x7AD383A7, "introscene_playercheck" },
    { 0xADC7B145, "introscreen" },
    { 0x1CBF599C, "introscreen_almost_complete" },
    { 0xA0C790B1, "introscreen_black" },
    { 0x316515EC, "introscreen_blackscreen_waiting_on_flag" },
    { 0x6D19C882, "introscreen_clear_redacted_flags" },
    { 0x1D4A1B3D, "introscreen_complete" },
    { 0xAF43259C, "introscreen_corner_line" },
    { 0x46853D29, "introscreen_create_line" },
    { 0x48B3ABCC, "introscreen_create_redacted_line" },
    { 0x5C9A57EB, "introscreen_create_typewriter_line" },
    { 0x28E8D705, "introscreen_delay" },
    { 0x31385CA8, "introscreen_done" },
    { 0xE9B01101, "introscreen_dontfreezcontrols" },
    { 0x6F77E98B, "introscreen_fadeouttext" },
    { 0x6DE839A8, "introscreen_feed_lines" },
    { 0xC6B350B6, "introscreen_generic_black_fade_in" },
    { 0xFEECBF9A, "introscreen_generic_fade_in" },
    { 0x63264BDC, "introscreen_generic_white_fade_in" },
    { 0xA224DE34, "introscreen_lui_typewriter_delay" },
    { 0xB4441F88, "introscreen_override" },
    { 0x31C6E33C, "introscreen_player_connect" },
    { 0x7D64909B, "introscreen_redact_delay" },
    { 0x84703381, "introscreen_report_disconnected_clients" },
    { 0x90F4E65B, "introscreen_shader" },
    { 0x0D7B5AEC, "introscreen_shader_fadeout_time" },
    { 0x4DE35A65, "introscreen_typewriter_delay" },
    { 0x8CE659DA, "introscreen_waitontext_flag" },
    { 0xDC2A5B0A, "introsnpshot" },
    { 0xE793470D, "introsquad" },
    { 0xCEBD5DBA, "introstring" },
    { 0xE0CA0AE0, "introstring_custom" },
    { 0x3308DF5C, "introstring_text_color" },
    { 0x77D56136, "introtime" },
    { 0x670FF0C2, "introtrigs" },
    { 0x19B7F27C, "introwhite" },
    { 0x32757D14, "intruder" },
    { 0x1C7D9D6F, "intruder_anims" },
    { 0xB2ECB6A5, "intruder_being_planted" },
    { 0xD93A680C, "intruder_blocker_clip" },
    { 0x0EDF7822, "intruder_box" },
    { 0xEE732548, "intruder_box_accessed" },
    { 0x50AE5A22, "intruder_box_opened" },
    { 0x70CF19CE, "intruder_cutter_on" },
    { 0xB1DE63A4, "intruder_deathwatch" },
    { 0xC3D3AAD5, "intruder_device" },
    { 0x411F87AD, "intruder_disrupted" },
    { 0x88F8093F, "intruder_door" },
    { 0xB03FBA3D, "intruder_fx" },
    { 0x448C09AB, "intruder_gatecrash" },
    { 0x66F5E42F, "intruder_glow_hide" },
    { 0xA7391A56, "intruder_guard_shotat" },
    { 0x41C6EA4F, "intruder_guy_logic" },
    { 0x1C4E965E, "intruder_hide_bolts" },
    { 0x293B20FB, "intruder_perk" },
    { 0x1AAE66B0, "intruder_perk_guy_spawn_func" },
    { 0x11E45286, "intruder_perk_scene" },
    { 0x02A308F3, "intruder_placed_" },
    { 0x2EEC18F5, "intruder_planted" },
    { 0x17E78348, "intruder_planted_" },
    { 0xA2AF8A03, "intruder_planted_rts_poi_mainframe" },
    { 0x6B38D66F, "intruder_plantwatch" },
    { 0xD35D6677, "intruder_prefix" },
    { 0x22F76878, "intruder_rumble" },
    { 0x71DC9D60, "intruder_sam" },
    { 0x24C898CF, "intruder_sam_death" },
    { 0xDED3D27D, "intruder_sam_drone_end" },
    { 0xAE6B547D, "intruder_sam_drone_score_watcher" },
    { 0x6DF04516, "intruder_sam_end" },
    { 0x8DB90E0E, "intruder_sam_timer" },
    { 0xBA6F3F2D, "intruder_trigger" },
    { 0x9607B5B1, "intruder_turret" },
    { 0xEC8CBA16, "intruder_turret_move_qrdrones" },
    { 0x0BF42FBE, "intruder_turret_player_watcher" },
    { 0x11215B38, "intruder_zap" },
    { 0xECBEBB2E, "intruder_zap_end" },
    { 0x5FCD915D, "intruder_zap_start" },
    { 0x519D3A4B, "intrudermodel" },
    { 0x93A79B74, "intruderplantstring" },
    { 0xD5C19687, "intruders" },
    { 0x9ADFFCE0, "intrusion" },
    { 0x2B71A54B, "ints" },
    { 0x41EE6FCF, "intseed" },
    { 0xFFA4FB0D, "intterupted" },
    { 0x6E52046D, "inumber" },
    { 0x361EA891, "inumflares" },
    { 0xA7CF226D, "inuse" },
    { 0x8039DAE2, "inuse_func" },
    { 0xBF1B6093, "inused" },
    { 0xD761601E, "inv_count" },
    { 0x9C30EE5B, "invaders" },
    { 0x7C7E4C92, "invalid" },
    { 0x56898F92, "invalid_area" },
    { 0x1260806C, "invalid_assistant_seat_index" },
    { 0xF7284221, "invalid_bonus_ammo_weapons" },
    { 0x3875B275, "invalid_exit_yaw" },
    { 0x278D8842, "invalid_id" },
    { 0x4A3262E9, "invalid_killstreak_id" },
    { 0xF23987FC, "invalid_retreat_points" },
    { 0x0DC148AD, "invalid_selection_sound" },
    { 0x16921ECB, "invalid_space_fwd" },
    { 0xE9B848F6, "invalidate" },
    { 0xC290E3D0, "invalidate_attractor_pos" },
    { 0x3A36DD86, "invalidated" },
    { 0x2A67608A, "invalidatenode" },
    { 0x1C02D2E9, "invalidates" },
    { 0xD9DD333B, "invalide" },
    { 0x0DE185BB, "invalidlocationhintstring" },
    { 0x70DAA229, "invalidmodel" },
    { 0xB3D03677, "invalue" },
    { 0x96F1BC14, "invasion" },
    { 0x8873E427, "invasion_ambiance" },
    { 0x98DF5446, "invasion_church_bell" },
    { 0xF2B7D671, "invasion_flare" },
    { 0x8A13F965, "invasion_flare_swap_burst_test" },
    { 0xC1F0970F, "invasion_planes_think" },
    { 0xA1EE1809, "invasion_planes_think_internal" },
    { 0x7C4EE55A, "invasion_planes_think_internal_short" },
    { 0x3980E31B, "invasion_read" },
    { 0x67311281, "invasion_start" },
    { 0xDC8826E7, "invehicletime" },
    { 0x375068D7, "inventories" },
    { 0xA347CD23, "inventory" },
    { 0x34608831, "inventory_array" },
    { 0x45424673, "inventory_combat_robot_name" },
    { 0xB9C892B3, "inventory_count" },
    { 0x5D9A19C1, "inventory_cr" },
    { 0x890FB33A, "inventory_create" },
    { 0x345BB8AC, "inventory_destroy" },
    { 0x3CF38283, "inventory_helicopter_comlink" },
    { 0xCEBB2096, "inventory_helicopter_gunner_assistant_name" },
    { 0xFA8E4F4E, "inventory_hide" },
    { 0x6A0A04D9, "inventory_hud_elem" },
    { 0x7371C9E9, "inventory_item_ref" },
    { 0x20F77059, "inventory_ref" },
    { 0xC8A8EFF8, "inventory_sentinel_name" },
    { 0x826FB9ED, "inventory_show" },
    { 0xFBFD6ACA, "inventory_slot" },
    { 0x7B7AE7D6, "inventory_tag" },
    { 0x5B2A077F, "inventorybuttonpressed" },
    { 0xEC5CA05B, "inventorytype" },
    { 0x306BA826, "inventoryvariant" },
    { 0x08B10AD7, "inventoryweapon" },
    { 0xE7300DE5, "inventoryweaponammo" },
    { 0x54B8A7D5, "inventroy" },
    { 0xE85F4FDB, "inventroy_update" },
    { 0xD26BB1BB, "inverse" },
    { 0x29A42B57, "inverse_gear_ratio" },
    { 0x76188DD8, "inversion" },
    { 0xDC66534D, "invert" },
    { 0x432A95FA, "inverted" },
    { 0x1BB82308, "invertmode" },
    { 0xF7ED9D76, "invertthermal" },
    { 0xDB5B33A6, "investigate" },
    { 0xEC89932E, "investigate_crash" },
    { 0xFC5593CD, "investigate_plane" },
    { 0xCF8A1F56, "investigated" },
    { 0x36B1815F, "investigating" },
    { 0x94D9A06A, "investigating_bear_trap" },
    { 0xA1959599, "investigation_guards_alert" },
    { 0x6B327EB6, "investing" },
    { 0x23324B7A, "investment" },
    { 0x4137BF17, "inview" },
    { 0x41E11F5A, "invinc" },
    { 0x99846EEE, "invincible" },
    { 0xFD72D11A, "invincible_hind" },
    { 0x5C1FC796, "invincible_huey" },
    { 0xCE5361FD, "invis_to_any" },
    { 0xBB418CB8, "invisibility" },
    { 0x62DBF522, "invisible" },
    { 0xD57535E9, "invisible_blocker" },
    { 0xCBB9C2CA, "invisible_player_killed" },
    { 0xCAD20B7E, "invisibly" },
    { 0x17A5DEBE, "invite" },
    { 0x4725D3AC, "invnt" },
    { 0x815E6068, "invoke_sprint_time" },
    { 0x01FF6D8C, "invokes" },
    { 0x46696600, "involved" },
    { 0x9B4F7418, "involvement" },
    { 0xB0A2656F, "involves" },
    { 0xE16E6D15, "involving" },
    { 0xCCFBD4C2, "invtype" },
    { 0xABC1F56D, "invul" },
    { 0x06BE0304, "invulend" },
    { 0xDD3D7EF6, "invulerability" },
    { 0x3F1A2572, "invulnerability" },
    { 0x7D9D2C38, "invulnerable" },
    { 0xB1F3BEB9, "invulnerable_against_these_ents" },
    { 0x3ACA524B, "invulnerable_against_this_attacker" },
    { 0x03818159, "invulnerable_convoy" },
    { 0x33F77C05, "invulnerable_ptboat" },
    { 0xAC7CE67C, "invulnerable_time" },
    { 0xDBA50F36, "invulnerabletimedefault" },
    { 0x1BB5DFEF, "invulnerabletimeseaknight" },
    { 0x9BFC79C4, "invulnerablility" },
    { 0x2CE8450A, "invultime" },
    { 0xAB8639E9, "invultime_onshield" },
    { 0xF2FB4D01, "invultime_onshield_multiplier" },
    { 0x8BBBC490, "invultime_postshield" },
    { 0x75DC8BA7, "invultime_preshield" },
    { 0x07A2A169, "invulworthyhealthdrop" },
    { 0xA66C842E, "invunerable" },
    { 0x15664E9A, "inward" },
    { 0x29883079, "inwater" },
    { 0xA4DB11B6, "inzone" },
    { 0x0DE3F025, "io" },
    { 0x4AE34AAF, "ioffset" },
    { 0x0DEA17B1, "ion" },
    { 0xC5589A21, "iopentime" },
    { 0x2658F52F, "ip1" },
    { 0x86AAAD26, "ipercentage" },
    { 0x5D0A40FB, "iphase" },
    { 0xD040B84E, "iplayerprojectilehits" },
    { 0x835CD6C2, "iprintbold" },
    { 0xD52B076D, "iprintln" },
    { 0x2E4B8C78, "iprintlnbold" },
    { 0x700E7400, "ipritnlnbold" },
    { 0x8273C535, "iprojectilehits" },
    { 0xF521EF7E, "ips_to_kts" },
    { 0x03CEAD1B, "iquakeradius" },
    { 0x04197C36, "iquaketime" },
    { 0x7FBCB901, "iquantity" },
    { 0xBF9C1240, "ir" },
    { 0x9C5B3275, "ir_heat_shimmer" },
    { 0xEE30B6B6, "ir_start_heat_shimmer" },
    { 0x5B78C2C4, "ir_stop_heat_shimmer" },
    { 0x9846D4AB, "ir_stop_heat_shimmer_on_death" },
    { 0x7303E1D0, "ir_strobe_watch" },
    { 0x27770CED, "ir_watch_scope_use" },
    { 0x4DD5BC00, "iradius" },
    { 0x397126E5, "iran" },
    { 0x4C45B92F, "iran_safe" },
    { 0x7A659DFB, "irand" },
    { 0x2489FF38, "iris" },
    { 0x5753E33C, "irisamount" },
    { 0xB1DD64CB, "iron" },
    { 0x96D7AB19, "ironclad" },
    { 0x7A95D196, "irpgs" },
    { 0x90E3F6CE, "irrational" },
    { 0x231980E3, "irrelevant" },
    { 0xEEBBF51F, "irrelevantdist" },
    { 0xA0D5C77D, "irrelevantpoplimit" },
    { 0xA5FAA31B, "irstrobe" },
    { 0xE59E8CA9, "is" },
    { 0x81BF149B, "is0" },
    { 0x35BA1FC9, "is2" },
    { 0xB559402F, "is2d" },
    { 0xEC0889DD, "is_2h_rappel" },
    { 0x120DA72A, "is_2x" },
    { 0xB0AEB60D, "is_4wheel" },
    { 0xE36E0C5F, "is_a_sound_only_scene" },
    { 0x1549A8FC, "is_aat_exempt" },
    { 0xF3995442, "is_about_to_talk" },
    { 0xC73DD5E2, "is_about_to_traverse" },
    { 0x0312A62E, "is_accelerating" },
    { 0xCA6CE919, "is_activated" },
    { 0x5BA633FC, "is_activated_in_afterlife" },
    { 0x444AEA32, "is_active" },
    { 0xEABAB9FF, "is_active_ai" },
    { 0x552BA2E2, "is_ads" },
    { 0x9850B963, "is_after_skipto" },
    { 0x356DE4BA, "is_ai_boss" },
    { 0xD0C92841, "is_ai_facing_player" },
    { 0x0A6917EC, "is_ai_in_revive" },
    { 0xECB1F1C7, "is_ai_using_minigun" },
    { 0x9D922FD9, "is_aiming" },
    { 0x8D0B3AD6, "is_aircraft" },
    { 0x54C2E9E0, "is_alias" },
    { 0x8D4C7E9F, "is_alive" },
    { 0x3B1EEC9C, "is_alive_sentient" },
    { 0x8076336F, "is_all_broken" },
    { 0xBC434D68, "is_all_filled" },
    { 0xD4814794, "is_alt_weapon" },
    { 0xF5828E4F, "is_ambient_turret_target" },
    { 0xD8BB7231, "is_ambient_vehicle" },
    { 0x739BBDD0, "is_ambush_round_spawning_active" },
    { 0x9F16E206, "is_an_a_killstreak" },
    { 0x6D6C104C, "is_analyzing_voice_match" },
    { 0x21A43C20, "is_anim_loop" },
    { 0x42BBEA65, "is_animscripted" },
    { 0xE119A123, "is_any_new_strikeforce_maps" },
    { 0xF6F9FB05, "is_any_pers_upgrade_stat_updated" },
    { 0xBACBB57C, "is_any_player_near_point" },
    { 0xD6CE24E5, "is_area_legal" },
    { 0xABCD8CBF, "is_arena_boss_available" },
    { 0x797EE9FE, "is_argus_enabled" },
    { 0x16969ADD, "is_armed" },
    { 0x884820DB, "is_arms_enabled" },
    { 0x80731436, "is_artillery" },
    { 0x051E22F9, "is_assault" },
    { 0xEA6CFCE3, "is_asset_of_type" },
    { 0xB2FFE75E, "is_at_attackable" },
    { 0x3924E4FF, "is_at_goal" },
    { 0x3D1158C0, "is_attached" },
    { 0x0C49C010, "is_attachment_excluded" },
    { 0xA4B35668, "is_attack_button_pressed" },
    { 0xD949C47B, "is_attacker_player_controller_boat" },
    { 0xB84CEE45, "is_attacking_zone" },
    { 0x932110C0, "is_auto_melee" },
    { 0x2607CD45, "is_available" },
    { 0x8822463E, "is_avenger" },
    { 0x9051D8CD, "is_avogadro" },
    { 0x3621D485, "is_ballistic_knife_variant" },
    { 0xCCA82655, "is_banzai" },
    { 0xDA808466, "is_bar_open" },
    { 0x220A688B, "is_barricade_ent" },
    { 0xB08B743E, "is_beam_raygun" },
    { 0xC4197AC8, "is_behind" },
    { 0xD1227033, "is_being_used_as_spawner" },
    { 0x70B333B8, "is_being_used_as_spawnpoint" },
    { 0x9DE8B6D8, "is_being_zapped" },
    { 0xB5D3FA9D, "is_big_door" },
    { 0x470242B3, "is_bike" },
    { 0x70818211, "is_bink_playing" },
    { 0xD701F00C, "is_blocked" },
    { 0x893FC5CD, "is_blocker_valid" },
    { 0x337B6BA0, "is_blue_on" },
    { 0xE33339B6, "is_boat" },
    { 0x1374C1D3, "is_body_undamaged" },
    { 0xF5C8805E, "is_bonuszm" },
    { 0x49AF3CDB, "is_boosting" },
    { 0xDE60610B, "is_bot" },
    { 0xC0D531D9, "is_bot_comp_stomp" },
    { 0x0B45D4A5, "is_bot_ranked_match" },
    { 0x34E6A594, "is_bot_soak" },
    { 0x6AA5170B, "is_bp2_heli" },
    { 0x06B66B00, "is_braking" },
    { 0x09FE364F, "is_breadcrumb" },
    { 0x3F859255, "is_bridge_brutus" },
    { 0x53AADA4C, "is_briggs_alive" },
    { 0xAE66BB62, "is_briggs_linked" },
    { 0xDB63B647, "is_brutus" },
    { 0x6E683213, "is_btr_rail" },
    { 0xA6BF1E54, "is_buffel" },
    { 0xC5819C04, "is_buildable" },
    { 0xD9781917, "is_buildable_included" },
    { 0xEE9A331C, "is_bullet_damage" },
    { 0xAFC5A6D7, "is_bullet_kill" },
    { 0x3B2A2143, "is_bulletcam_hitloc" },
    { 0xD866B82D, "is_burning" },
    { 0x7F9797C6, "is_called_out" },
    { 0x592A24D4, "is_calling_fireteam" },
    { 0x85BFAC87, "is_camera_on" },
    { 0xCEDC2F48, "is_campaign_complete" },
    { 0x9BF75390, "is_candy_store_open" },
    { 0x6CB51741, "is_capture_area_occupied" },
    { 0xC168D9CC, "is_capture_mode" },
    { 0x33F7DFA0, "is_capturing_own_supply_drop" },
    { 0x108CCD4B, "is_carpenter_boards_upgraded" },
    { 0x4D0808A8, "is_challenge_active" },
    { 0x50BF030A, "is_challenge_stat_complete" },
    { 0x55F62409, "is_chamber_occupied" },
    { 0xDDD0628F, "is_character_streamed" },
    { 0xEB5DCD14, "is_charged" },
    { 0xC35D55BB, "is_charged_shot" },
    { 0xEECB28E1, "is_charging_at_player" },
    { 0x6E5DB04D, "is_cheap" },
    { 0x6FA66FDF, "is_cheating" },
    { 0x5642CAF4, "is_chest_active" },
    { 0x0B3DB7C9, "is_chicken" },
    { 0x8AADA0A4, "is_church_occupied" },
    { 0x1CADE5C2, "is_cinematic_kill_guy" },
    { 0x492C9CAB, "is_civilian" },
    { 0x9E243C8B, "is_claimed" },
    { 0x4D275F1C, "is_classic" },
    { 0x745E5EA4, "is_classtype_available" },
    { 0xF1B878CB, "is_claw_fire_direction_active" },
    { 0xCB85F44A, "is_claw_flamethrower_unlocked" },
    { 0x23008729, "is_claw_walking" },
    { 0x8A695BDB, "is_clear" },
    { 0x30E847F8, "is_clienthud" },
    { 0xDBBDF96D, "is_clone_touching_crate" },
    { 0x9183E3C2, "is_collision_imminent" },
    { 0xAB2C35FE, "is_color_ai" },
    { 0x14C375BB, "is_color_frame" },
    { 0x1B9FF1A4, "is_combat" },
    { 0x503A85E6, "is_combat_bro" },
    { 0x4BF7851A, "is_comms_clear_top_trig" },
    { 0x9EAFA0F6, "is_comms_clear_trig" },
    { 0xABEA3011, "is_complete" },
    { 0x3A5681B1, "is_connected" },
    { 0x329ED8DF, "is_contract_active" },
    { 0x4CA26FE5, "is_convoy_plane" },
    { 0x7F034E97, "is_cooldown" },
    { 0xE5C87D0B, "is_coop" },
    { 0xED0C8CD8, "is_corpse" },
    { 0x6E4087A8, "is_countup_timer" },
    { 0xB908BE96, "is_courthouse_open" },
    { 0x30B74486, "is_craftable" },
    { 0x099F027C, "is_craftable_table_valid" },
    { 0x7B7E657E, "is_crawler_alive" },
    { 0xC6AF5C17, "is_createfx_active" },
    { 0x5B24D5A1, "is_crystal_raised" },
    { 0x6650DD3E, "is_curr_in_view" },
    { 0x37C4D581, "is_current_ball_location" },
    { 0x0DCABBBC, "is_current_skipto_dev" },
    { 0x62AD7A67, "is_current_user" },
    { 0x0EA1FD6D, "is_daily_challenge" },
    { 0x844AD499, "is_damaged" },
    { 0xE4308CB6, "is_damaged_by_god_rod" },
    { 0x71449320, "is_damaged_by_grenade" },
    { 0xF5713E10, "is_day_off" },
    { 0x4E686039, "is_dds_enabled" },
    { 0xA832C76F, "is_dead_sentient" },
    { 0xA336DE99, "is_decreasing" },
    { 0xF17871EA, "is_defalco_alive" },
    { 0x9B36D3BB, "is_default" },
    { 0x237EE0D8, "is_default_skipto" },
    { 0xC09E163E, "is_default_start" },
    { 0xA7007BA6, "is_delayable_killstreak" },
    { 0xE3B61C66, "is_deposit" },
    { 0x13B68862, "is_descending" },
    { 0xA83EC3ED, "is_destructed" },
    { 0xF1C19FEE, "is_destructible" },
    { 0x93B5A824, "is_disabled" },
    { 0xEBD2FFEA, "is_dog" },
    { 0x7018A1DF, "is_dogfight_plane" },
    { 0xC4B48F04, "is_door" },
    { 0xEA4D7242, "is_double_grenades_allowed" },
    { 0x9CBA2842, "is_doubletap" },
    { 0xC123D926, "is_draining" },
    { 0x0DF3872E, "is_drinking" },
    { 0x9824B7EE, "is_driver" },
    { 0x4CFB5B9A, "is_drone" },
    { 0x6FACAAC1, "is_drone_corpse" },
    { 0xB41B0676, "is_drowning" },
    { 0xB8D2E34C, "is_dtp" },
    { 0x3A0BE8E7, "is_dying" },
    { 0x252D95DE, "is_eating" },
    { 0xC117EC6A, "is_eland" },
    { 0x82EB847B, "is_electrocuted" },
    { 0x6C653628, "is_elemental_zombie" },
    { 0x1F3F5E92, "is_elevator" },
    { 0x1DEE32EC, "is_elevator_clear" },
    { 0x56A7483F, "is_enabled" },
    { 0x67D38EAB, "is_encounter" },
    { 0x31646987, "is_end_tanker" },
    { 0xCB8B2163, "is_enemy_valid" },
    { 0xD791A8C6, "is_entity_valid" },
    { 0x999797FC, "is_entity_weapon" },
    { 0x2DC0B9B4, "is_equal" },
    { 0x0C8A173B, "is_equal_fn" },
    { 0x52A59A0C, "is_equipment" },
    { 0x2518CBA9, "is_equipment_active" },
    { 0x204FB683, "is_equipment_ignored" },
    { 0xD127A46F, "is_equipment_included" },
    { 0xD585526D, "is_equipment_that_blocks_purchase" },
    { 0x72B8E1BC, "is_equipment_touching_crate" },
    { 0x12955B00, "is_even" },
    { 0x120E83C3, "is_exact_string" },
    { 0x611FC33A, "is_excluded" },
    { 0x786B4314, "is_exempt_weapon" },
    { 0xF971E847, "is_exit_open" },
    { 0x6A063A1E, "is_exploding" },
    { 0xC2E385F1, "is_explosive_car_death" },
    { 0xD76D4D07, "is_explosive_damage" },
    { 0xF23EDD25, "is_explosive_ragdoll" },
    { 0xC4D6B977, "is_f35_fast" },
    { 0x273EE236, "is_f35_vtol" },
    { 0xA449518A, "is_facing" },
    { 0xCC703272, "is_facing_target" },
    { 0x3DF17F41, "is_falling" },
    { 0xE0875655, "is_false" },
    { 0x5E5953AA, "is_farid_alive" },
    { 0x068E7429, "is_fatal_shot" },
    { 0x653BD3F3, "is_favorite_weapon" },
    { 0xB7279894, "is_female" },
    { 0x1AC63CD3, "is_fire_direction_active" },
    { 0xD8F04A6D, "is_fire_direction_weapon" },
    { 0x821CB119, "is_firing" },
    { 0x7F3B8669, "is_firing_beam" },
    { 0xC7EA08DD, "is_firing_rocket_barrage" },
    { 0xEC6181D8, "is_first_ghost_round_finished" },
    { 0xCE95617A, "is_first_player" },
    { 0xD2C2AF67, "is_first_round" },
    { 0x16762677, "is_first_skipto" },
    { 0x8D00B0AA, "is_first_time" },
    { 0x7D83FF4F, "is_flashbanged" },
    { 0x46299416, "is_fling" },
    { 0x28B426CD, "is_flip" },
    { 0xEF37244C, "is_flipped" },
    { 0xFE72ED42, "is_float" },
    { 0x704309D9, "is_following_room_path" },
    { 0x363785EC, "is_footchop" },
    { 0x22125902, "is_forever_solo_game" },
    { 0x9F606E47, "is_freezegun_damage" },
    { 0xE2446379, "is_freezegun_shatter_damage" },
    { 0x9B62B911, "is_friendly" },
    { 0x612A9998, "is_friendly_fire_on" },
    { 0x96E19357, "is_friendly_team" },
    { 0x05AA9671, "is_from_animsound" },
    { 0x4C13B45A, "is_frozen" },
    { 0x95FAE7C0, "is_fxanim_grass_user" },
    { 0xBCC07BB2, "is_game_mode_object" },
    { 0xCDC9E17C, "is_game_solo" },
    { 0xF6859577, "is_gametype_active" },
    { 0xC9D30E04, "is_gate_toggled" },
    { 0x4CD63631, "is_general_store_open" },
    { 0x7BBAF52B, "is_generator" },
    { 0x053C927B, "is_german_build" },
    { 0x4BC16609, "is_ghost" },
    { 0xB2200C7C, "is_ghost_round" },
    { 0xB8B08686, "is_ghost_round_started" },
    { 0x7B846142, "is_giant_robot" },
    { 0x179773FF, "is_gib_restricted_build" },
    { 0x3DFF4977, "is_gibbed" },
    { 0x54B7EC05, "is_glove_shown" },
    { 0xCEE7CBC1, "is_god_rod_active" },
    { 0xCB468B5B, "is_godmode" },
    { 0xE2BD8715, "is_goto" },
    { 0x57A24EAF, "is_gravity_trap_fx_on" },
    { 0x703B284E, "is_greenlight_build" },
    { 0x56D05FD6, "is_grenade" },
    { 0x274612AD, "is_grenade_launcher" },
    { 0x199F5092, "is_group_dead" },
    { 0xFA650DA1, "is_gun_gadget" },
    { 0x1752BE7E, "is_guy_past_coord" },
    { 0x96119FFC, "is_hacked" },
    { 0xFCCF6969, "is_hacking" },
    { 0xD596A02B, "is_hard_mode" },
    { 0xD8E23996, "is_hardcore" },
    { 0x129F0964, "is_harper_alive" },
    { 0xE9F90777, "is_harper_scarred" },
    { 0x0978F323, "is_hat" },
    { 0x1136E6E2, "is_head" },
    { 0xA2FFEE41, "is_headbutt" },
    { 0xF952DCDE, "is_headchop" },
    { 0x1F9E3A2A, "is_headshot" },
    { 0xA78F2003, "is_healthy" },
    { 0x8660B621, "is_heavy" },
    { 0xEF2E22F8, "is_heavy_machine_gun" },
    { 0xD3E3643F, "is_helicopter" },
    { 0xD3426ABC, "is_hero" },
    { 0xC2D7ABDE, "is_hero_armblade_and_active" },
    { 0x9B69B9D6, "is_hero_score_event_restricted" },
    { 0x00A894B7, "is_hero_weapon" },
    { 0xF3451C9F, "is_hero_weapon_in_use" },
    { 0xD1FF4078, "is_hidden" },
    { 0xC19F3E2B, "is_hill_contested" },
    { 0x5FFD8E31, "is_hitloc_chest" },
    { 0x33D20A74, "is_hitloc_head" },
    { 0x69444F1C, "is_hitloc_hips" },
    { 0xC7A1710E, "is_hitloc_left_arm" },
    { 0xC08C0214, "is_hitloc_left_leg" },
    { 0x8FCC9955, "is_hitloc_legs" },
    { 0x1116ECD7, "is_hitloc_right_arm" },
    { 0xC50030FD, "is_hitloc_right_leg" },
    { 0x1769137D, "is_hitloc_shield" },
    { 0x2981CC05, "is_holding" },
    { 0xA024622A, "is_holding_candybooze" },
    { 0x6F17E5D2, "is_holding_card" },
    { 0xD8F2A087, "is_holding_part" },
    { 0xDC5D8EB3, "is_horse" },
    { 0xBE17CAE1, "is_host_migrating" },
    { 0x11ABC6CD, "is_hotjoin" },
    { 0x7C66D3DB, "is_hotjoining" },
    { 0x82AD572E, "is_hovering" },
    { 0x72F09E03, "is_hq_contested" },
    { 0x93CC5372, "is_hud_hidden" },
    { 0xA02A4357, "is_human" },
    { 0xCD3FFB73, "is_husk" },
    { 0xEA8D6D0D, "is_idgun_damage" },
    { 0x78937D4A, "is_idle" },
    { 0x9A88551B, "is_idling" },
    { 0x4D47318B, "is_igc" },
    { 0x9407FE2C, "is_igc_active" },
    { 0x59ABF163, "is_image" },
    { 0xD9858B13, "is_immune" },
    { 0x6F905818, "is_immune_to_knockdown" },
    { 0x3E6C2603, "is_in_acid" },
    { 0x61F97D13, "is_in_array" },
    { 0x44F051FF, "is_in_box" },
    { 0xB54970B9, "is_in_close_rooms" },
    { 0x5AEC065C, "is_in_combat" },
    { 0xBB8B29B8, "is_in_exclusive_area" },
    { 0x444A3773, "is_in_fountain_transport_trigger" },
    { 0xF5D9AE9D, "is_in_fov" },
    { 0xB2E1D15E, "is_in_ghost_zone" },
    { 0x584F7028, "is_in_giant_robot_footstep_safe_spot" },
    { 0x8B854B49, "is_in_jet" },
    { 0x536414FD, "is_in_memory" },
    { 0xCFA680C6, "is_in_next_rooms" },
    { 0xC0B53925, "is_in_place" },
    { 0xABAC40B6, "is_in_playable_area" },
    { 0xBC4F71FA, "is_in_player_arc" },
    { 0x18D9A2D7, "is_in_process_of_humanify" },
    { 0xC9A5A6DA, "is_in_process_of_zombify" },
    { 0x2E8EE7F5, "is_in_room" },
    { 0xAD78C3C4, "is_in_rooms" },
    { 0x076B1481, "is_in_rts" },
    { 0x0D67F164, "is_in_start_area" },
    { 0x010CDD31, "is_in_water" },
    { 0x19B732E0, "is_in_zombie_stink" },
    { 0x073850FC, "is_included" },
    { 0x383382AC, "is_inert" },
    { 0xE8D994E1, "is_infrared_on" },
    { 0x1029FAF1, "is_inner_gate_toggleable" },
    { 0x2D46DEE8, "is_inserted" },
    { 0x99320980, "is_inside" },
    { 0x941CA245, "is_inside_volume" },
    { 0x14E7E125, "is_insta_kill_active" },
    { 0x4332A58A, "is_insta_kill_upgraded_and_active" },
    { 0x896B19F4, "is_instate" },
    { 0x13CE51DD, "is_int_in_range" },
    { 0xF9CF574A, "is_integer" },
    { 0x8514FC69, "is_interacting_with_object" },
    { 0xC8B5D8B0, "is_inventory" },
    { 0x8C4F48C0, "is_it_foreshadowing" },
    { 0xF985C2B2, "is_item_excluded" },
    { 0xA7708F26, "is_item_locked" },
    { 0x6313F2AB, "is_item_purchased" },
    { 0x40E5DE05, "is_item_tokenlocked" },
    { 0xA8FC0D4B, "is_item_unlocked" },
    { 0x1270D73E, "is_jail_state" },
    { 0x336B543B, "is_jetgun_damage" },
    { 0x4F452D2D, "is_jetgun_firing" },
    { 0x066EAFE8, "is_jugger" },
    { 0xC491D118, "is_juggernaut_used" },
    { 0x4F749468, "is_jumping" },
    { 0xE2B6ACE6, "is_karma_alive" },
    { 0x522F1D1C, "is_kill" },
    { 0x9060F2B9, "is_killcam" },
    { 0x124328C2, "is_killstreak_start_blocked" },
    { 0xC288EFD1, "is_killstreak_weapon" },
    { 0xDF4BA28C, "is_killstreak_weapon_assist_allowed" },
    { 0x7A527D23, "is_killstreaks_enabled" },
    { 0xBF74A81E, "is_knocked_down" },
    { 0xFFBDDBA9, "is_lane_occupied" },
    { 0x1AF72186, "is_lapd_member" },
    { 0xCC194C1D, "is_last_stand" },
    { 0x770E3409, "is_last_zombie" },
    { 0x6DC57672, "is_lastblast" },
    { 0x43686C3C, "is_lastround" },
    { 0x7688372C, "is_laststand" },
    { 0xED9235B6, "is_later_in_alphabet" },
    { 0x5B732DAF, "is_leader" },
    { 0xD9AEA46F, "is_leader_riotshield" },
    { 0xDFDABEA3, "is_leaper" },
    { 0x23A1D5A7, "is_leaper_outside_playable_space" },
    { 0xFE10607E, "is_leaping" },
    { 0x27F19831, "is_leapyear" },
    { 0x0973F569, "is_lethal_grenade" },
    { 0x991CB8A2, "is_limited" },
    { 0x2C566B4F, "is_limited_equipment" },
    { 0x31FDBE41, "is_limited_weapon" },
    { 0x1F50ACDF, "is_linked" },
    { 0xF22A0D8B, "is_loaded" },
    { 0x9B877C7F, "is_local_player" },
    { 0x59189D4B, "is_location_good" },
    { 0xFEDB40BE, "is_locked" },
    { 0x12552FD4, "is_look_trigger" },
    { 0x4CCC8EC5, "is_looking_at" },
    { 0x3358646A, "is_looking_at_me" },
    { 0xD166E9EF, "is_looking_at_tower" },
    { 0x37004B6E, "is_loop" },
    { 0x0107A392, "is_looping" },
    { 0x78CE4DF9, "is_lvt_drone" },
    { 0x5013B6B6, "is_machete_mpla" },
    { 0x90590B28, "is_macv_start" },
    { 0xC7E98C18, "is_magic_box_in_inverted_building" },
    { 0xA842D63C, "is_magic_box_valid" },
    { 0x56BCE50A, "is_magic_bullet_shield_enabled" },
    { 0xD11C15EC, "is_marked" },
    { 0x2AABD548, "is_mason_stealth_crouched" },
    { 0x2B376AAC, "is_master_key_west" },
    { 0x193D7D1C, "is_mature" },
    { 0x2D8C82FC, "is_max_complete" },
    { 0xAADF44F6, "is_max_sign" },
    { 0xC4766AD4, "is_maze_open" },
    { 0x100734CD, "is_meat" },
    { 0x0EED3D75, "is_meat_object" },
    { 0x0694FD71, "is_mechanical" },
    { 0x18C16E5B, "is_mechz" },
    { 0x6E017BF0, "is_melee" },
    { 0x37BFB0FB, "is_melee_weapon" },
    { 0x4C41F091, "is_menendez_los" },
    { 0xC2925D0D, "is_microwavegun_damage" },
    { 0x652D52D3, "is_microwavegun_dw_damage" },
    { 0xD0D16C69, "is_mig" },
    { 0xC0D97D5D, "is_minigun" },
    { 0xB08707C2, "is_misc_model" },
    { 0x4EA51E52, "is_missile_looking_at" },
    { 0x4F7F8883, "is_model" },
    { 0x4B845696, "is_model_attached" },
    { 0xFC76DAD3, "is_motorcycle" },
    { 0xD9A518E6, "is_moving" },
    { 0xDC2F95DD, "is_moving_to_spot" },
    { 0x088B697D, "is_multiple_drinking" },
    { 0xD37C35E9, "is_navy_member" },
    { 0x2063A4D2, "is_near_another_player" },
    { 0x5C9BAA31, "is_near_another_sentinel" },
    { 0x80B5711C, "is_near_ground" },
    { 0x9770094C, "is_near_wisp" },
    { 0x02DACBB7, "is_new_cp_map" },
    { 0x0FD77A14, "is_next_stat" },
    { 0xD50B20D1, "is_nighttime" },
    { 0xD73E1993, "is_no_game_skipto" },
    { 0x8E09A3C0, "is_node" },
    { 0xE3DD05DC, "is_node_group_used" },
    { 0x784A6F3B, "is_node_script_origin" },
    { 0x7E879792, "is_node_script_struct" },
    { 0x80403C48, "is_not_intro" },
    { 0xE4D019F7, "is_not_looking_at_friendly" },
    { 0x796AC00A, "is_not_upgraded" },
    { 0x79AD7723, "is_null" },
    { 0xD0D90422, "is_obama_supporting" },
    { 0x600EA969, "is_object" },
    { 0xF7DB212D, "is_object_away_from_home" },
    { 0x242E52D7, "is_object_hackable" },
    { 0xE906999E, "is_objective_game" },
    { 0xAD5B6FD3, "is_objective_on" },
    { 0xF68C6F63, "is_objective_pos_the_same" },
    { 0xDD1C8260, "is_occupied" },
    { 0x4F2B0105, "is_occupying" },
    { 0x0F36AD03, "is_odd" },
    { 0x14BBDAA7, "is_offhand_weapon" },
    { 0xD7629940, "is_ok_to_zipline" },
    { 0xA8FCF257, "is_on" },
    { 0xA2A25E06, "is_on_dryland" },
    { 0x5041D45E, "is_on_fire" },
    { 0x2E53F04C, "is_on_gondola" },
    { 0x5C0CE6A3, "is_on_goo" },
    { 0x9E7D33AB, "is_on_ground" },
    { 0x4BDA6B21, "is_on_horse" },
    { 0x03CC9C9C, "is_on_horseback" },
    { 0xFA9F3027, "is_on_ice" },
    { 0x680EDE5D, "is_on_minecart" },
    { 0xEBA9EF7E, "is_on_nav_volume" },
    { 0x6597982E, "is_on_navmesh" },
    { 0x4339826F, "is_on_surface" },
    { 0x96ABFB4E, "is_on_vehicle" },
    { 0x147B8776, "is_on_waterslide" },
    { 0x7E983921, "is_one_round" },
    { 0x3DF205A3, "is_oneinch_punch_damage" },
    { 0x8A47A759, "is_oob_kill_target" },
    { 0xA7546AAC, "is_open" },
    { 0x96EB2FA1, "is_open_table" },
    { 0x133A4A3F, "is_optic" },
    { 0x77A1B2EA, "is_orange_on" },
    { 0x9958F944, "is_overlap_another_sentinel" },
    { 0x91352D05, "is_overlook_or_earlier_start" },
    { 0x63EEA844, "is_override" },
    { 0x5BFD1634, "is_overriding_swim_movement" },
    { 0xFCFD5C86, "is_pack_splatting" },
    { 0x129258F0, "is_packroom_clear" },
    { 0xF9448E44, "is_pain" },
    { 0x3DFA9FCD, "is_panic" },
    { 0x63D2BCAF, "is_pap" },
    { 0xCB7546B2, "is_pap_trigger" },
    { 0x8A1AD3BB, "is_parasite" },
    { 0xAD26D97F, "is_part_crafted" },
    { 0x57D57E75, "is_part_of_name" },
    { 0x43D40270, "is_party_gamemode" },
    { 0x6B40D125, "is_path_guy" },
    { 0xF135845F, "is_pathing" },
    { 0xAC12972A, "is_pause" },
    { 0xC354B28D, "is_pbr_firing_disabled" },
    { 0x75A08FA0, "is_pegasus" },
    { 0x7D0C4385, "is_perk_machine_valid" },
    { 0xDC08B4AF, "is_pers_double_points_active" },
    { 0x69F37D91, "is_pers_system_active" },
    { 0x4AB3F2AB, "is_pers_system_disabled" },
    { 0x9CDEB40A, "is_phrase_in_history" },
    { 0x11970EF4, "is_placeable_equipment" },
    { 0x3687D5BD, "is_placeable_mine" },
    { 0x180A3342, "is_plane" },
    { 0x75C5E07A, "is_plane_ramp_valid" },
    { 0x550AB23B, "is_player" },
    { 0x979A9287, "is_player_accessible_to_raps" },
    { 0x7731633D, "is_player_anim_ending_early" },
    { 0x89940DD9, "is_player_breaking_stealth_mainconvoy" },
    { 0xB74B44F3, "is_player_character_present" },
    { 0xB90C40F6, "is_player_climbing_tree" },
    { 0x098E378F, "is_player_clinging" },
    { 0x4F7A354A, "is_player_close" },
    { 0x70005FF1, "is_player_close_enough" },
    { 0xAD4DB205, "is_player_control" },
    { 0xD588D7BE, "is_player_down" },
    { 0x4439CFED, "is_player_down_and_out" },
    { 0x4142E518, "is_player_drowning" },
    { 0xC6EC9246, "is_player_equipment" },
    { 0xA8EC9424, "is_player_facing" },
    { 0x6F6AFA9D, "is_player_firing_during_boom" },
    { 0xCD513164, "is_player_fully_claimed" },
    { 0x8135C125, "is_player_hero_weapon" },
    { 0xCD5B3A70, "is_player_in_chamber" },
    { 0x62833FE0, "is_player_in_drone" },
    { 0xC275052A, "is_player_in_fog" },
    { 0xF1C7B863, "is_player_in_gather_position" },
    { 0x3CF1EF37, "is_player_in_ghost_room" },
    { 0xEDB6676E, "is_player_in_ghost_rooms" },
    { 0x0B3CF778, "is_player_in_ghost_zone" },
    { 0x2432FB4F, "is_player_in_inverted_elevator_shaft" },
    { 0xBC2607DF, "is_player_in_override_trigger" },
    { 0x67AAFCDF, "is_player_in_sam" },
    { 0x9E012A8D, "is_player_in_screecher_zone" },
    { 0x6A210E4F, "is_player_in_stealth_mode" },
    { 0xD636134A, "is_player_in_zombie_stink" },
    { 0x31546D38, "is_player_in_zone" },
    { 0x9F36C606, "is_player_inside_arena" },
    { 0x467D0A9E, "is_player_killable" },
    { 0xC29A8B03, "is_player_lethal_grenade" },
    { 0xD61B846F, "is_player_looking_at" },
    { 0x8BE04E6D, "is_player_looking_at_soct" },
    { 0x4114632D, "is_player_melee_weapon" },
    { 0x008B2A5D, "is_player_model" },
    { 0x81E47FD4, "is_player_near" },
    { 0x73212CD1, "is_player_offhand_weapon" },
    { 0xA9407C8A, "is_player_on_gondola" },
    { 0xE61901A6, "is_player_on_lander" },
    { 0x5ED166AB, "is_player_on_sniper_tree_logic" },
    { 0x0E4FAAC7, "is_player_over_wall" },
    { 0x8777C066, "is_player_over_wall_thread" },
    { 0x2B96B96F, "is_player_placeable_mine" },
    { 0xCC1537BE, "is_player_revive_tool" },
    { 0x2F4A5472, "is_player_scoped" },
    { 0x262A5E46, "is_player_slowed" },
    { 0x9FB2805A, "is_player_tactical_grenade" },
    { 0x80EFA8E9, "is_player_target" },
    { 0xF46A2050, "is_player_teleport_valid" },
    { 0xCCB570CA, "is_player_touching_volume" },
    { 0x9D6E4C61, "is_player_using_thumbstick" },
    { 0xF0B11CBC, "is_player_valid" },
    { 0x4D88C69D, "is_player_valid_afterlife" },
    { 0xB0725253, "is_player_valid_override" },
    { 0x99D55485, "is_player_view_linked_to_entity" },
    { 0x40391E30, "is_player_zombie" },
    { 0x367F8966, "is_playing" },
    { 0x8CCC35E9, "is_playing_audio" },
    { 0x2FD24204, "is_playing_custom_anim" },
    { 0xA07E7154, "is_point_in_build_trigger" },
    { 0x34B281AF, "is_point_in_chamber" },
    { 0x1C548F02, "is_point_in_craft_trigger" },
    { 0xD16E8674, "is_point_in_view" },
    { 0xE256DF5C, "is_point_inside_enabled_zone" },
    { 0xA3DD3906, "is_point_inside_volume" },
    { 0xCB4BD6BD, "is_point_vulnerable" },
    { 0xB630900D, "is_police_car" },
    { 0x25A66F9F, "is_police_member" },
    { 0xA773DD7E, "is_police_motorcycle" },
    { 0x66AADCFF, "is_position_frame" },
    { 0x0C53AD7D, "is_power_on" },
    { 0xF9FE1878, "is_powerup" },
    { 0xC6FC7880, "is_prefix" },
    { 0x99C6004D, "is_prev_in_view" },
    { 0xAD92A7B2, "is_primary_damage" },
    { 0x0AFC1125, "is_primary_weapon" },
    { 0xBD107C44, "is_prisoner" },
    { 0x144743EF, "is_ps3_flipped" },
    { 0x58C7426D, "is_pyramid_spawner" },
    { 0x8FBDC781, "is_quad" },
    { 0x3573A5AF, "is_quadrotor" },
    { 0x4DF20F51, "is_radio_available" },
    { 0x7A22438F, "is_rage_image_on" },
    { 0x9092D05F, "is_rage_mode_high_active" },
    { 0x06A21B14, "is_rage_mode_low" },
    { 0x7E9A1F1D, "is_rage_on" },
    { 0x67B901BC, "is_rail" },
    { 0x58962891, "is_random" },
    { 0x4C170C74, "is_rappel_or_earlier_start" },
    { 0x70EE46F4, "is_rat_test" },
    { 0x92591589, "is_ready" },
    { 0x70EF79C6, "is_ready_to_change" },
    { 0x43465C48, "is_recapture_zombie" },
    { 0x2C8E6B79, "is_reflected_over_y" },
    { 0x1B2E397C, "is_registered" },
    { 0xFCD3CD10, "is_relative_team" },
    { 0x242E0FA4, "is_remote_override_weapon" },
    { 0x1187E4E7, "is_repeating" },
    { 0x27C51658, "is_replaced" },
    { 0x46597E1F, "is_revive" },
    { 0xABEA309A, "is_reviving" },
    { 0xE56DC52B, "is_reviving_afterlife" },
    { 0x0EAE9BF9, "is_reviving_any" },
    { 0x58AD74BE, "is_reviving_via_override" },
    { 0x4E3ABB88, "is_ric_complete" },
    { 0xD675C0C2, "is_ric_sign" },
    { 0xC86C3F40, "is_ricochet_protected" },
    { 0x527A0EEC, "is_rider" },
    { 0x0C1F85B3, "is_rifle_mpla" },
    { 0x50876FFA, "is_right" },
    { 0xBFBF57F5, "is_riotshield" },
    { 0x467A783B, "is_riotshield_damage" },
    { 0x695DB7B4, "is_robot" },
    { 0xBD559A6C, "is_rotating" },
    { 0xB8A26AD8, "is_round_based" },
    { 0x317F255B, "is_rusher" },
    { 0xFF8B2BC3, "is_safe" },
    { 0x3DA0C335, "is_safehouse" },
    { 0xE649C57B, "is_same_trigger" },
    { 0x70CABDBA, "is_scene_defined" },
    { 0xEA552CCA, "is_scene_deleted" },
    { 0xA777D848, "is_scene_selected" },
    { 0x90C74118, "is_scene_shared" },
    { 0x0E308028, "is_scene_shared_sequence" },
    { 0xF845CAC9, "is_scene_skipped" },
    { 0x9AE16F3B, "is_sco_supporting" },
    { 0xB77944BE, "is_script_model_door" },
    { 0x49FAC4FF, "is_scripted_melee" },
    { 0x16A184D0, "is_seal_member" },
    { 0xEA08D46F, "is_seat_available" },
    { 0x10B913BF, "is_security_member" },
    { 0x5EF9081B, "is_self_on_elevator" },
    { 0x154F146D, "is_sequential" },
    { 0xAE2C29E3, "is_sergei" },
    { 0x6DD4B013, "is_shared" },
    { 0x9683C869, "is_shared_player" },
    { 0x65322B67, "is_shoot_button_pressed" },
    { 0x9B57A95C, "is_shortcut_plane_built" },
    { 0x5D253ABA, "is_shotgun" },
    { 0x2E9C1177, "is_shoutcaster" },
    { 0x323BB27F, "is_shoutcaster_using_team_identity" },
    { 0xC198A8D1, "is_shutting_down" },
    { 0x7E589A1E, "is_side_arm" },
    { 0x1337B040, "is_sidequest_allowed" },
    { 0xA0B5C74C, "is_sidequest_previously_completed" },
    { 0x08C5CA62, "is_simple_prop" },
    { 0x692D36C1, "is_skeleton" },
    { 0xB1F75EE9, "is_skipping_in_progress" },
    { 0x8F5906CA, "is_skipping_player_scene" },
    { 0xAC6DC3E8, "is_skipping_scene" },
    { 0x83024F22, "is_sleight" },
    { 0x0BE75F0B, "is_slicing" },
    { 0xEF7ABB84, "is_slick" },
    { 0x040D43CE, "is_sliding" },
    { 0x2866C9C8, "is_slipgun_damage" },
    { 0x21D08D0C, "is_slipgun_explosive_damage" },
    { 0x03233850, "is_sloth" },
    { 0x7C0FA1E3, "is_slow" },
    { 0xB2CC2ACC, "is_slow_raygun" },
    { 0x4C0E3535, "is_slowgun_damage" },
    { 0x2158A2BD, "is_sniper" },
    { 0x1DF1BAEC, "is_sniper_weapon" },
    { 0x6AD7480A, "is_snowcat_event" },
    { 0xC908FBDE, "is_soct_behind_the_player" },
    { 0x27E27928, "is_soct_dead" },
    { 0xAF8E9C83, "is_soct_in_front_of_player" },
    { 0xCBC6400E, "is_soct_salazar_distance_warning_active" },
    { 0x0E2D91DB, "is_soct_speed_warning_active" },
    { 0x0030177A, "is_solo_ranked_game" },
    { 0x33CF0F73, "is_source" },
    { 0x31887A50, "is_spawn_manager_cleared" },
    { 0x4A90B211, "is_spawn_manager_complete" },
    { 0xD7FFFE3F, "is_spawn_manager_enabled" },
    { 0xD8FBC0FF, "is_spawn_manager_killed" },
    { 0x5E880626, "is_spawn_protected" },
    { 0xCE996AE4, "is_spawn_trapped" },
    { 0xA4266149, "is_spawned_in_ghost_zone" },
    { 0x85B99176, "is_spawned_in_ghost_zone_actual" },
    { 0x944A8CC8, "is_spawner" },
    { 0x8C5C2E62, "is_spawner_targeted_by_blocker" },
    { 0x577895A7, "is_spawning" },
    { 0xD6972E9E, "is_spawning_allowed" },
    { 0x3D5B2DDA, "is_speaking" },
    { 0x70A31FE4, "is_special_agent_member" },
    { 0x551B3248, "is_specops_level" },
    { 0x46F61ECB, "is_spectator" },
    { 0xDE503584, "is_springpad_in_place" },
    { 0x03D40C59, "is_sprint_allowed" },
    { 0xC9EC4F5B, "is_squad_enemy" },
    { 0x3837465D, "is_staff_air_damage" },
    { 0x81557BFF, "is_staff_fire_damage" },
    { 0xE958695F, "is_staff_lightning_damage" },
    { 0x61C85F8E, "is_staff_water_damage" },
    { 0xEA6110CB, "is_standard" },
    { 0x36F7184B, "is_started" },
    { 0x0B523D12, "is_stat" },
    { 0x78783533, "is_stat_modifiable" },
    { 0x2ACC042E, "is_stat_updated" },
    { 0xC399B2D2, "is_stationary" },
    { 0x605BA1EF, "is_still_valid_target_for_stinger_override" },
    { 0x11A2F018, "is_stink_zombie" },
    { 0x33895E18, "is_stomped" },
    { 0xC86C610F, "is_struct" },
    { 0x20F4E16F, "is_suffix" },
    { 0x10991141, "is_suiciding" },
    { 0xB1D6DE04, "is_sullivan" },
    { 0xB5356CBB, "is_sumpf" },
    { 0xEF9C09EE, "is_survival" },
    { 0x30AC3554, "is_survival_object" },
    { 0xC34DFB26, "is_suv" },
    { 0xED89B363, "is_swimming" },
    { 0xA3902425, "is_swimming_enabled" },
    { 0x85AEC44F, "is_system_running" },
    { 0x6311BEF8, "is_tactical_grenade" },
    { 0x47897989, "is_tag_crowded" },
    { 0x86517D78, "is_tagged" },
    { 0xFE2C8DDA, "is_talking" },
    { 0x0E805B5C, "is_tank" },
    { 0xD5391B17, "is_target" },
    { 0x9B15926C, "is_target_in_turret_view" },
    { 0xCBE3A901, "is_target_in_view" },
    { 0x248D1688, "is_target_valid" },
    { 0xF6999F70, "is_target_valid_cb" },
    { 0xE5397838, "is_target_visible" },
    { 0x537626DC, "is_targeted" },
    { 0x75FE5BDF, "is_team" },
    { 0x92F0BDB8, "is_team_active" },
    { 0x918904AF, "is_team_based" },
    { 0x6DF64B11, "is_team_enabled" },
    { 0x16677D79, "is_team_on_golden_gate_bridge" },
    { 0x5D25078A, "is_team_winning" },
    { 0x4E2F7254, "is_teamgather_complete" },
    { 0x27E20A4D, "is_teleport" },
    { 0xC2A1C70A, "is_teleport_landing_valid" },
    { 0x42A1AA7D, "is_teleported_in_bad_zone" },
    { 0x947F1A5B, "is_teleporting" },
    { 0x5177AE69, "is_temporary_zombie_weapon" },
    { 0x53E27B27, "is_tesla_damage" },
    { 0x55D8D818, "is_testing" },
    { 0xD5C0F057, "is_the_player" },
    { 0xF0146CF6, "is_theconspiracytheorist" },
    { 0x3E042D43, "is_thedouche" },
    { 0xA54A5964, "is_theelectricalengineer" },
    { 0xA50C1A87, "is_thefarmersdaughter" },
    { 0xE838B502, "is_there_a_choperstrike" },
    { 0xAF33B31C, "is_there_a_player_in_seat" },
    { 0xF50948DF, "is_this_a_challenge_round" },
    { 0xB8C1EC1C, "is_thundergun_damage" },
    { 0x01400D1E, "is_time_bomb_round_change" },
    { 0x8AE3D381, "is_time_left" },
    { 0x61ED2AF6, "is_too_dense" },
    { 0x02CCD329, "is_torsochop" },
    { 0x89135FA7, "is_touching" },
    { 0xD3AE4CB9, "is_touching_any_trigger" },
    { 0x8E6BFF27, "is_touching_any_trigger_key_value" },
    { 0xCB8EA6DC, "is_touching_color_trig" },
    { 0x7B3ED4FF, "is_touching_crate" },
    { 0xECE5BBF7, "is_touching_distance" },
    { 0x841EB063, "is_touching_instakill" },
    { 0xE9954E62, "is_towneast_open" },
    { 0xBE65516D, "is_transition" },
    { 0x3C587A30, "is_trap_registered" },
    { 0x969389F6, "is_trap_valid" },
    { 0xF17ACDBC, "is_trapped" },
    { 0xB310252F, "is_traversing" },
    { 0x0BE65A58, "is_trigger" },
    { 0x129597DC, "is_trigger_once" },
    { 0x1DB5876C, "is_true" },
    { 0x3F340B82, "is_true_placeable_mine" },
    { 0x26BE3EDD, "is_tunnel_open" },
    { 0x13B9AB5B, "is_tunnelguy" },
    { 0xE6C0B171, "is_turbine_powering_item" },
    { 0x03F88AE7, "is_turning" },
    { 0x70C5462A, "is_turret" },
    { 0x99FBD1E2, "is_turret_current_user" },
    { 0x12434548, "is_turret_enabled" },
    { 0xD742F7D2, "is_turret_target" },
    { 0x8D7B2984, "is_type" },
    { 0x7ADB3929, "is_type_currently_default" },
    { 0x6D2CEFED, "is_type_exclusive" },
    { 0x22D34155, "is_uber_prize" },
    { 0x2B1A7826, "is_unclaimed_staff_weapon" },
    { 0x4B6F37C2, "is_undamaged" },
    { 0x5EA9C8B7, "is_underwater" },
    { 0x307184F4, "is_unload_node" },
    { 0xB4F6527A, "is_updating" },
    { 0xF9F5D998, "is_upgrade" },
    { 0xEEFD5B4C, "is_upgraded" },
    { 0xB51C3346, "is_using_any_gadget" },
    { 0xBD108E58, "is_using_offhand_equipment" },
    { 0xA7E2D982, "is_valid" },
    { 0xA0307E7B, "is_valid_airstrike_target" },
    { 0x136EEDCA, "is_valid_ammo_bonus_weapon" },
    { 0xF2229678, "is_valid_ent" },
    { 0x45093AB0, "is_valid_exit_path_found" },
    { 0xC67DEF4E, "is_valid_hitloc" },
    { 0xAE926497, "is_valid_piece_number" },
    { 0x0F7C913A, "is_valid_player_for_sentinel_drone" },
    { 0x2630E5EB, "is_valid_powerup_location" },
    { 0x1C0B57DB, "is_valid_spawner" },
    { 0x918DD53D, "is_valid_stance" },
    { 0x139E3A4A, "is_valid_target" },
    { 0x0BC3C534, "is_valid_target_for_stinger_override" },
    { 0x69DCB06B, "is_valid_teleport_node" },
    { 0xA0710FA5, "is_valid_type_for_callback" },
    { 0x107ADFE1, "is_valid_weapon" },
    { 0xB7DF5F2C, "is_valid_zombie_spawn_point" },
    { 0x039B8E87, "is_value" },
    { 0x8E547704, "is_vehicle" },
    { 0xF88E9EF8, "is_vfxspot_linked" },
    { 0x506572B2, "is_visible" },
    { 0xED7B90FF, "is_vtol" },
    { 0x614B2431, "is_walking" },
    { 0xF99C8CE7, "is_wall_rappel" },
    { 0x387B8580, "is_wallbuy" },
    { 0xF219FA8E, "is_warlord_perk" },
    { 0x05C80578, "is_weapon" },
    { 0x4251CE01, "is_weapon_associated_with_killstreak" },
    { 0xA0A21508, "is_weapon_attachment" },
    { 0xE0F23D6D, "is_weapon_available_in_chugabud_corpse" },
    { 0x4FA57ACA, "is_weapon_available_in_tombstone" },
    { 0x771465B7, "is_weapon_gadget" },
    { 0x9519B54B, "is_weapon_included" },
    { 0xA6270B78, "is_weapon_locker_available_in_game" },
    { 0xBF92CE67, "is_weapon_or_base_included" },
    { 0xCF8B1E89, "is_weapon_or_variant_same_as_gadget" },
    { 0x00455FC3, "is_weapon_registered" },
    { 0x1ACB147F, "is_weapon_shotgun" },
    { 0x658A7FAF, "is_weapon_toggle" },
    { 0xADA4725B, "is_weapon_upgraded" },
    { 0x9441E538, "is_weapon_upgraded_staff" },
    { 0xE5246E53, "is_weapon_valid" },
    { 0x73872259, "is_within_capsule" },
    { 0x0D8362E5, "is_within_fov" },
    { 0x690399F8, "is_within_view_2d" },
    { 0x3B60A7C2, "is_within_volume" },
    { 0xC4054B34, "is_wonder_weapon" },
    { 0xEA932A77, "is_yemeni" },
    { 0x6E36E5BA, "is_zak" },
    { 0xC5918487, "is_zcleansed" },
    { 0x043EC786, "is_ziplining" },
    { 0xC47FB4CA, "is_zombie" },
    { 0xC14269DA, "is_zombie_gibbed" },
    { 0xCDE888E9, "is_zombie_level" },
    { 0x4323919C, "is_zombie_perk_bottle" },
    { 0x1D50F62B, "is_zombie_round" },
    { 0x7CB482E5, "is_zombieteam" },
    { 0x1AC0EF06, "isaac" },
    { 0x39DCF804, "isaac_cabinet_nag" },
    { 0x7285F42D, "isaac_celerium" },
    { 0x079750B4, "isaac_defend_scene" },
    { 0xC48B3965, "isaac_vo_before_door" },
    { 0x1E2CBFB9, "isaacs" },
    { 0xB5CBA406, "isacorpse" },
    { 0xF4CCCF41, "isacquired" },
    { 0x1ECF49FF, "isactionslotpressed" },
    { 0x6BDB4E67, "isactive" },
    { 0x33C6E418, "isactivecontractcomplete" },
    { 0x8D0347B8, "isactor" },
    { 0x51E3F0A4, "isactorspawner" },
    { 0x3010541C, "isadestructable" },
    { 0x73B274B4, "isadestructible" },
    { 0xB5EEA1ED, "isads" },
    { 0xE70AB977, "isai" },
    { 0x652A93FE, "isaiclone" },
    { 0x8BCDBD96, "isaidamagefatal" },
    { 0x81C21D0A, "isaikillstreakdamage" },
    { 0xF0D4E1F8, "isaiming" },
    { 0xD021EE69, "isaimingatenemy" },
    { 0xC5C28EE1, "isaioldreviver" },
    { 0xB0395C1B, "isairborne" },
    { 0xAF9FAE08, "isaisquadleader" },
    { 0x5B49D38C, "isalive" },
    { 0x516BD893, "isallies" },
    { 0xA383DB61, "isalliesline" },
    { 0x9ACA891F, "isallowed" },
    { 0x7BE49328, "isallowedtosprint" },
    { 0xCB2F9B37, "isally" },
    { 0x4FCEED32, "isalone" },
    { 0x2C891A0E, "isalreadyrunningbackwards" },
    { 0xF7C17BAF, "isaltmode" },
    { 0x829BD485, "isambush" },
    { 0xD0C66805, "isambushnode" },
    { 0x3150D36D, "isambushroundactive" },
    { 0x26F1E6DA, "isanimleaf" },
    { 0xAA3C5FA0, "isanimlooping" },
    { 0xCB7B7167, "isanyonetalking" },
    { 0x4DA76FBB, "isanyplayernearby" },
    { 0x06676F71, "isapproach" },
    { 0x6A0DC40D, "isarchetypeloaded" },
    { 0xC818AD93, "isarenamode" },
    { 0x6E2770D8, "isarray" },
    { 0x67966C88, "isarrival" },
    { 0xACE7E979, "isarrivalpending" },
    { 0x37C4DA85, "isarrivingfour" },
    { 0x1CCD4DE3, "isarrivingone" },
    { 0xB5888FEB, "isarrivingsix" },
    { 0x98C89303, "isarrivingthree" },
    { 0xA3AE1841, "isarrivingtwo" },
    { 0x7257BE73, "isasd" },
    { 0x350E6980, "isassetloaded" },
    { 0xE1BE98A6, "isassistedflying" },
    { 0x2D2AA6EB, "isatattackobject" },
    { 0xB51D137D, "isatbrinkofdeath" },
    { 0xF09741FA, "isatcovercondition" },
    { 0xC85D95B8, "isatcovermodenone" },
    { 0x0ADF8920, "isatcovermodeover" },
    { 0xC7A3D044, "isatcovernodestrict" },
    { 0xAC227CE3, "isatcoverstrictcondition" },
    { 0x94F77BF8, "isatcrouchnode" },
    { 0x91D044D4, "isatentrance" },
    { 0x0B88235B, "isatgoal" },
    { 0x9FE8AEA2, "isatscriptgoal" },
    { 0xEFD485CD, "isattached" },
    { 0xFE0CAE0E, "isattackervalid" },
    { 0xC28717B7, "isattacking" },
    { 0x1B6A027A, "isaxis" },
    { 0xFE8201A3, "isbadguy" },
    { 0x9D1CB1FB, "isbalconydeath" },
    { 0x1DD38CEB, "isbalconynode" },
    { 0xD0734562, "isbalconynodenorailing" },
    { 0x88D5FBD5, "isballisticknife" },
    { 0xCF47BC71, "isbamfing" },
    { 0x62AF29EC, "isbanzai" },
    { 0x03DA9834, "isbatonguard" },
    { 0x8FBA457A, "isbehaviortreeinrunningstate" },
    { 0xC0D5CD5D, "isbehind" },
    { 0x60BA6F1C, "isbeingwatched" },
    { 0x28557CF7, "isbflag" },
    { 0x63E980E9, "isbigdog" },
    { 0xF912CBCD, "isbigdoglegmissing" },
    { 0xDBDEE8C3, "isblackjack" },
    { 0x4578D846, "isbleeder" },
    { 0x1883C7E7, "isbleedingorfalling" },
    { 0x2D7158D4, "isbodyhit" },
    { 0x8ED95C32, "isboltaction" },
    { 0x334FBE53, "isbombcarrier" },
    { 0x846AF2A2, "isbonuscardactive" },
    { 0xC2F22476, "isboss" },
    { 0xFA880C75, "isbounding" },
    { 0x9792090E, "isbreachingfirewall" },
    { 0xF8D3D9CF, "isbuggingplayer" },
    { 0x6C5BEA09, "isbullet" },
    { 0x0AD3D706, "isbulletdamage" },
    { 0x9B876DC5, "isbulletimpactmod" },
    { 0xFEBF2C99, "isbulletweapon" },
    { 0x827E7632, "isburning" },
    { 0x7C6EA1CD, "iscamanimlooping" },
    { 0x87C3001C, "iscamera" },
    { 0x6951D046, "iscameraspiketoggled" },
    { 0x26577C6D, "iscarried" },
    { 0x80B7978B, "iscarriedkillstreak" },
    { 0x916B5A46, "iscarrying" },
    { 0x54829484, "iscarryingturret" },
    { 0x8EABD6C8, "iscellphoneon" },
    { 0x05300C80, "ischargedshotsniperrifle" },
    { 0x4EB8AC19, "ischargeshot" },
    { 0xD88DDD22, "ischeap" },
    { 0xE70D7BE5, "ischunkvalidcondition" },
    { 0x473902E4, "iscinematicinprogress" },
    { 0xA78008DE, "iscinematicplaying" },
    { 0x0EBC1F15, "iscinematicpreloading" },
    { 0xE244CCCF, "iscinematicwebm" },
    { 0x9D912D01, "isclaimednodecover" },
    { 0xDA94C684, "isclaimednodewindow" },
    { 0xE84B7554, "isclear" },
    { 0x64CE7385, "iscliponly" },
    { 0x0893896F, "iscloseenough" },
    { 0xF568CEF7, "iscloseenoughforaivsaimelee" },
    { 0xA764FCD8, "iscloseexplosive" },
    { 0x271329AD, "iscollectors" },
    { 0xA1EFC436, "iscolor" },
    { 0x2B5FD1C0, "iscombatscriptnode" },
    { 0x9604F378, "iscontested" },
    { 0x9CB131C2, "iscooked" },
    { 0xE5257A7F, "iscooldownready" },
    { 0x06B92DC3, "iscoopepd" },
    { 0xB2DB24E8, "iscore" },
    { 0x3D1BF78B, "iscoughing" },
    { 0xA9E98D3F, "iscounter" },
    { 0x4978CBBD, "iscounteruav" },
    { 0xC5133856, "iscoverconcealed" },
    { 0x38CEE3A2, "iscovernode" },
    { 0x0E407564, "iscovervalid" },
    { 0xD4DFD439, "iscqb" },
    { 0xE59CCBC6, "iscqbwalking" },
    { 0xFB4B537B, "iscrawler" },
    { 0xEA0B057D, "iscrossbow" },
    { 0x7F5FB0E2, "iscrossbowexplosive" },
    { 0x05F8D2C6, "iscrouchingatnodeallowed" },
    { 0x3E40F8AE, "iscurrentbtactionlooping" },
    { 0x47756CE5, "iscurrentsidearm" },
    { 0xCF2F58CE, "iscurrentspeakerabletotalk" },
    { 0xCFBB8CE6, "iscurve" },
    { 0xE7B1ACA8, "iscustomclass" },
    { 0xCA952626, "iscustomgame" },
    { 0x190F65ED, "iscutscene" },
    { 0x60AA31A1, "isdamagebybigdog" },
    { 0x8ACE0C56, "isdamaged" },
    { 0xB2783D6B, "isdamagedbyasd" },
    { 0x8962BD6E, "isdamagedtread" },
    { 0x6782C7C9, "isdamagefromplayercontrolledaitank" },
    { 0x81CBAB6E, "isdamagefromplayercontrolledsentry" },
    { 0x1B11DAC3, "isdangerous" },
    { 0xC109009F, "isdead" },
    { 0x31F20C1C, "isdebugdrawing" },
    { 0xDB636009, "isdebugon" },
    { 0xD9630298, "isdedicated" },
    { 0x6A4CEA01, "isdedicatedbotsoak" },
    { 0x082F1E3C, "isdefaulthero" },
    { 0x6B2B4E68, "isdefine" },
    { 0x74486FFC, "isdefined" },
    { 0xED581F61, "isdeflected" },
    { 0x2D43A50A, "isdefusing" },
    { 0x4401FB50, "isdelayablekillstreak" },
    { 0x163C7D3F, "isdeltaallowed" },
    { 0xC2709328, "isdemo" },
    { 0x12814395, "isdemoclient" },
    { 0xFBF3E84B, "isdemoenabled" },
    { 0x94A21952, "isdemoplaying" },
    { 0xF3B1BFE9, "isdemorecording" },
    { 0x3293151E, "isdestroyed" },
    { 0x061B5800, "isdestructed" },
    { 0xD9335DF3, "isdestructible" },
    { 0x198CD533, "isdirectexplosive" },
    { 0xBE30BD79, "isdirecthitweapon" },
    { 0xCEC6BDC3, "isdistanceshown" },
    { 0x25C9898F, "isdofdefault" },
    { 0xFEB2BA91, "isdog" },
    { 0xAE66B441, "isdoinganim" },
    { 0x3743A0BE, "isdoublejumping" },
    { 0x8B7EFE33, "isdrivableplayervehicle" },
    { 0x6D970A73, "isdriver" },
    { 0xCC377BBA, "isdriverfiring" },
    { 0x29F2048E, "isdriving" },
    { 0x6A42CA00, "isdualwield" },
    { 0x70BC3864, "isdud" },
    { 0xA65B7505, "isdumbrocketlauncherweapon" },
    { 0x4AFC8576, "isdupephrase" },
    { 0x1E045B7C, "isdying" },
    { 0x4A338DF5, "isdynentvalid" },
    { 0x25E502B5, "iseconds" },
    { 0xAA6E549F, "isect" },
    { 0x5DE06C62, "iselite" },
    { 0x83023915, "isemp" },
    { 0xB81A735F, "isempdetonated" },
    { 0xA6805242, "isemped" },
    { 0xA5F053B3, "isempjammed" },
    { 0xC942C123, "isempkillstreak" },
    { 0x1F345ED7, "isempkillstreakweapon" },
    { 0x4F30FD35, "isempweapon" },
    { 0x8A39C33B, "isenemy" },
    { 0xA352C107, "isenemyempkillstreakactive" },
    { 0xB4F3C2AE, "isenemyinexplodablevolume" },
    { 0xB074C98C, "isenemyplayer" },
    { 0x900E2038, "isenemyscrambler" },
    { 0x54978BB4, "isenemytoolowtoattack" },
    { 0x2C088B81, "isenemyvehicle" },
    { 0x36045A39, "isenemyvisiblefromexposed" },
    { 0x4ABD259D, "isenemyvulnerablebyrpg" },
    { 0x16A49083, "isentbelowmap" },
    { 0xFD096044, "isentity" },
    { 0xED76D589, "isentityfriendly" },
    { 0x9A76C76C, "isentityhackablecarepackage" },
    { 0x56ED7F3A, "isentityhackableweaponobject" },
    { 0x8BC7895C, "isentitylinkedtotag" },
    { 0x0CA7262E, "isentitypreviouslyhacked" },
    { 0xB067AC27, "isequipment" },
    { 0x1C374FC1, "isequipmentallowed" },
    { 0x7067DF2B, "isexcluded" },
    { 0x39F24F33, "isexecuting" },
    { 0xFC183413, "isexerting" },
    { 0x3B9CBC39, "isexit" },
    { 0x24DDFD8E, "isexpanded" },
    { 0x2D960B9E, "isexplosive" },
    { 0x9AA69002, "isexplosivebulletweapon" },
    { 0x261A5DC5, "isexplosivedamage" },
    { 0x352D365F, "isexplosivedamagemod" },
    { 0x7B1B445F, "isexposed" },
    { 0xE4B16C7B, "isexposedapproach" },
    { 0x7C5B343C, "isexposedatcovercondition" },
    { 0xFBC95C22, "isextracam" },
    { 0xABC15F78, "isfacingeight" },
    { 0x5BBF8029, "isfacingenemy" },
    { 0x65EE8AC7, "isfacingfour" },
    { 0xBE8AB5ED, "isfacingmotion" },
    { 0x085A1057, "isfacingnine" },
    { 0xB2582712, "isfacingseven" },
    { 0x1B0F2599, "isfacingsix" },
    { 0x8C9514D7, "isfallerinceiling" },
    { 0xEEFE21D3, "isfavoriteenemy" },
    { 0x0204C5EC, "isfilesharepreview" },
    { 0x446027EC, "isfiltered" },
    { 0xD0F10B73, "isfinalrender" },
    { 0x50B9F000, "isfir" },
    { 0x7B1FF84A, "isfiredamage" },
    { 0x8B6E8518, "isfiring" },
    { 0xA3A6D526, "isfiringturret" },
    { 0x9B54CDDE, "isfirstperson" },
    { 0xBD0811ED, "isfirstplane" },
    { 0xD992AB0F, "isfirstround" },
    { 0x78052149, "isfirstshake" },
    { 0xB4C96FE2, "isfirsttime" },
    { 0x893D17FD, "isflagcarrier" },
    { 0x3B93FBA6, "isflankedatcovernode" },
    { 0x81A2C6DD, "isflankedbyenemyatcover" },
    { 0xFF5FA0E3, "isflare" },
    { 0x3DA6479D, "isflared" },
    { 0x5FC2FC71, "isflash" },
    { 0x3BAA3FF4, "isflashbanged" },
    { 0xF152131E, "isflashed" },
    { 0x5268F5D7, "isflashing" },
    { 0x4CF0410D, "isflashorstundamage" },
    { 0x8BC6D976, "isflashorstunweapon" },
    { 0x6B18365D, "isflickering" },
    { 0x2DF9DA95, "isfloat" },
    { 0x9C8EF065, "isflourishweapon" },
    { 0xEE96878F, "isfmjdamage" },
    { 0xA8DA7F0F, "isfocus" },
    { 0x887C99A7, "isfollowingsquadleader" },
    { 0xE1D9CDEE, "isforcedcqbstopidle" },
    { 0x1BB0C45D, "isfrag" },
    { 0xABF8DDB8, "isfriendly" },
    { 0x15125E43, "isfriendlyteam" },
    { 0xDF1F4563, "isfrominventory" },
    { 0x6B365F0F, "isfrozen" },
    { 0x65267ADF, "isfrustrated" },
    { 0x508479ED, "isfunctionptr" },
    { 0xE78A1124, "isfurious" },
    { 0x2FD9ADDF, "isfxplaying" },
    { 0xC3F34B41, "isgadget" },
    { 0xE363521E, "isgadgetmeleecharging" },
    { 0xA6B88255, "isgameplayweapon" },
    { 0xF1537717, "isgamerepenabled" },
    { 0x0BAD1086, "isgamerepinitialized" },
    { 0xE1F1D00A, "isgamerepparamignoredforreporting" },
    { 0xE558867B, "isgamerepparamvalid" },
    { 0xD3FECE80, "isgasweapon" },
    { 0xE04ABDCA, "isgibbed" },
    { 0x8E2CB318, "isglobal" },
    { 0x27E14F8D, "isglobalscrambler" },
    { 0x0A2A0DB8, "isglobalstatsserver" },
    { 0x29E06050, "isgodmode" },
    { 0xBBB5424B, "isgrappling" },
    { 0xDF254319, "isgrenade" },
    { 0xBA8F1D94, "isgrenadedud" },
    { 0x67198DB1, "isgrenadelauncherweapon" },
    { 0x04BE845A, "isgrenadepossafe" },
    { 0x5B62FB69, "isgrenadeweapon" },
    { 0xDBB766FD, "isguidedrocketlauncherweapon" },
    { 0x52EDE9F5, "isgunnerfiring" },
    { 0xCFE7F205, "isgunnerpath" },
    { 0x915BF433, "ish" },
    { 0xA29689AE, "ishackable" },
    { 0x70E5DD95, "ishacked" },
    { 0x5D65A85C, "ishacktoolweapon" },
    { 0xD4D6E552, "ishackweapon" },
    { 0xC73A01DE, "ishardpointsenabled" },
    { 0x001B2A8C, "isheaddamage" },
    { 0x7874F1AB, "isheadshot" },
    { 0x2AFEB75B, "isheat" },
    { 0x4346B759, "isheatwavestunned" },
    { 0xC82524CE, "isheldinventorykillstreakweapon" },
    { 0x9D05A3AA, "isheldkillstreakweapon" },
    { 0xC71A72DE, "ishelicopter" },
    { 0x93B2FFFD, "ishero" },
    { 0x84690DFD, "isheroweapon" },
    { 0xEE1F5A49, "ishidden" },
    { 0x16A4C2BF, "ishidinghud" },
    { 0xE168D854, "ishigherpriority" },
    { 0xC002AEE1, "ishighestscoringplayer" },
    { 0x3BD7A46C, "isholdinggrenade" },
    { 0x7F3BCCC0, "ishome" },
    { 0xE025DAA7, "ishost" },
    { 0xF7343DD6, "ishostforbots" },
    { 0xDD399151, "ishots" },
    { 0x6B5979CA, "isi" },
    { 0x3E383E97, "isi_kneecpd_both" },
    { 0xB36B11DC, "isi_kneecpd_lft" },
    { 0x4E3D9B0A, "isi_leader" },
    { 0xCC5C4AB6, "isigcactive" },
    { 0x7F41C8E7, "isinarray" },
    { 0xF062E74B, "isinchain" },
    { 0x2645FF90, "isincombat" },
    { 0x8CBD3DF4, "isincontact" },
    { 0x59CD9A4A, "isinfantry" },
    { 0x0DEC4D89, "isinfected" },
    { 0x58D10529, "isingoal" },
    { 0xEA35ED6B, "isinhelicopter" },
    { 0xCADFB3FD, "isinhub" },
    { 0xA4DFB690, "isinitiator" },
    { 0xD434E3FA, "isinlava" },
    { 0xFAACD783, "isinmantleaction" },
    { 0xB6B4F2AE, "isinmovemode" },
    { 0x74839CF4, "isinnodehistory" },
    { 0x61B3B9AE, "isinphalanx" },
    { 0x5B5F1AD2, "isinphalanxstance" },
    { 0x666E1BDA, "isinremotenodeploy" },
    { 0x4B6D4A6D, "isinsafezone" },
    { 0xB7F9B625, "isinscriptedstate" },
    { 0xF88429C9, "isinscritpedanim" },
    { 0x12A4A290, "isinset" },
    { 0xAAB890F1, "isinsideheightlock" },
    { 0xD5605529, "isinsideheliheightlock" },
    { 0xC7ECC8F3, "isinsmokegrenade" },
    { 0x0520A934, "isint" },
    { 0x613CF4F4, "isinteractingwithobject" },
    { 0x568FF75A, "isintermissionspawn" },
    { 0xBB48E571, "isintermmissionspawn" },
    { 0x923C72FB, "isinthemoney" },
    { 0x080A63C1, "isintop" },
    { 0x1C1EA239, "isinuse" },
    { 0xCB8DF3D0, "isinvehicle" },
    { 0x1570F297, "isinventory" },
    { 0xADD145FD, "isinwater" },
    { 0x07687F14, "isinweaponlist" },
    { 0x41B09805, "isis" },
    { 0x21461E10, "isisoldier" },
    { 0xE0460B3C, "isitem" },
    { 0xE709594E, "isitemlocked" },
    { 0x1C4CC403, "isitempurchased" },
    { 0x7A159F2F, "isitemrestricted" },
    { 0x864927E3, "isitemunlocked" },
    { 0x5CAD7ECB, "isjosefinasmouldering" },
    { 0xDE72A03F, "isjuking" },
    { 0xDC650D8B, "isjumping" },
    { 0xB00A13A9, "iskill" },
    { 0x11064C6E, "iskillboosting" },
    { 0x0E49F0CF, "iskillcamentityweapon" },
    { 0x8A62214C, "iskillcamgrenadeweapon" },
    { 0x44AAC1D7, "iskillstreak" },
    { 0x1D88C2B1, "iskillstreakallowed" },
    { 0xCFADCC80, "iskillstreakavailable" },
    { 0xEA0EDE5B, "iskillstreakregistered" },
    { 0xDB509629, "iskillstreakremoteoverrideweapon" },
    { 0x056E2EB5, "iskillstreaksenabled" },
    { 0x5052081F, "iskillstreaksstreakcountsenabled" },
    { 0xC9D1364B, "iskillstreaktimerrunning" },
    { 0x61DC9D2B, "iskillstreakweapon" },
    { 0xBE7EAB12, "iskillstreakweaponassistallowed" },
    { 0xF83DDE00, "isknife" },
    { 0x63EEB515, "isknownenemyinradius" },
    { 0x11118413, "isknownenemyinradius_tmp" },
    { 0xE4401699, "isknownenemyinvolume" },
    { 0xEEC1C22A, "island" },
    { 0x8131CD62, "island_1" },
    { 0x5B2F52F9, "island_2" },
    { 0x5F2E42F1, "island_blocker" },
    { 0x1D2B4ADD, "island_guys" },
    { 0x41420DA8, "island_guys_function" },
    { 0x65B1E023, "island_guys_killed" },
    { 0xC1170B16, "island_guys_left_done" },
    { 0xC99FD099, "island_guys_right_done" },
    { 0xBF6CEB7A, "island_guys_spawned" },
    { 0xBA805D71, "island_guys_spawned_rpgs" },
    { 0xEFFE961E, "island_hut_encounter" },
    { 0xBF0456A6, "island_seed_pickedup" },
    { 0x46608BD2, "island_target" },
    { 0x3A874BCD, "islaseron" },
    { 0xAFAAF647, "islastflag" },
    { 0xBD57E807, "islastknownenemypositionapproachable" },
    { 0xABBA90D9, "islastnode" },
    { 0x3D7E4BBB, "islastrank" },
    { 0x796334FB, "islastround" },
    { 0xAB10AF31, "islauncher" },
    { 0x32B696BC, "islauncherkweapon" },
    { 0x859FED81, "islauncherweapon" },
    { 0xA79647DA, "isleader" },
    { 0x9AFB7CE8, "isleagueitemrestricted" },
    { 0xDBF58F1E, "isleaper" },
    { 0x87BED413, "isleaving" },
    { 0xE9E94054, "isleftarm" },
    { 0x1D89DC26, "isleghit" },
    { 0xEEE64FA2, "islinked" },
    { 0xC7E339D1, "islinkedto" },
    { 0xD555ECB8, "isloadingcinematicplaying" },
    { 0xB61AA2B1, "islocalclientdead" },
    { 0x84F89A39, "islocalclientdriver" },
    { 0xF9566050, "islocalgame" },
    { 0x5D749438, "islocalized" },
    { 0xB80A9A41, "islocalplayer" },
    { 0x8DF017D3, "islocalplayerenemy" },
    { 0x08510FE0, "islocalplayerenemyteam" },
    { 0x07A0E505, "islocalplayerviewlinked" },
    { 0xAE8CA5BB, "islocalplayerweaponviewonlylinked" },
    { 0x15CAAAB3, "islocaltohost" },
    { 0x3C50CA0B, "islocationgood" },
    { 0xEAFC9C17, "islookingat" },
    { 0x56457375, "islookingatorigin" },
    { 0x05C53922, "islookingorg" },
    { 0x025927CD, "islooping" },
    { 0x07C95FC4, "islouder" },
    { 0x06A8CFD8, "isluienabled" },
    { 0xF5220EFE, "ismagicbullet" },
    { 0xDF991E41, "ismantling" },
    { 0x59C8A979, "ismature" },
    { 0x45E7DC7F, "ismaturecontentenabled" },
    { 0x49946B62, "ismedal" },
    { 0x507B9A81, "ismeleeing" },
    { 0x29E60F99, "ismeleemod" },
    { 0xAEF8DB65, "ismeleepathclear" },
    { 0x58689C33, "ismeleeweapon" },
    { 0xDBC3726C, "ismembersaying" },
    { 0x766ADCC5, "ismg" },
    { 0xB44D1E14, "ismger" },
    { 0x78779921, "ismgtargeted" },
    { 0xE3AB716D, "ismilestonevalid" },
    { 0x38CF4247, "ismissiledroneweapon" },
    { 0x53A75F5B, "ismissileincoming" },
    { 0x0116C45F, "ismissileinsideheightlock" },
    { 0x973B3A23, "ismissileinsideheightlockbackupcheck" },
    { 0x3D03F302, "ismixerlightbehaviorhardcoded" },
    { 0x476A1E44, "ismodelattached" },
    { 0x35601825, "ismovable" },
    { 0xD020CF47, "ismoving" },
    { 0xC51DBE03, "ismovingpowerloss" },
    { 0xA43BC6FA, "ismp" },
    { 0xE158CFCB, "ismultiplayer" },
    { 0xC1F5DCBD, "isnavvolumeloaded" },
    { 0x6D152AC7, "isneardeath" },
    { 0xC9A3A619, "isnew" },
    { 0x72E4CE05, "isnewsecondary" },
    { 0xF51247F6, "isnewsidearm" },
    { 0x6ECB9A5E, "isnodecover" },
    { 0xBDD94A56, "isnodedontcrouch" },
    { 0x713F6507, "isnodedontleft" },
    { 0x12FF31DE, "isnodedontprone" },
    { 0x45663582, "isnodedontright" },
    { 0xC74D8E04, "isnodedontstand" },
    { 0x0B160BCB, "isnodedoublewide" },
    { 0x4EB15419, "isnodeoccupied" },
    { 0x70650610, "isnodequadrotor" },
    { 0x9996F388, "isnonbarehandsmelee" },
    { 0x8F454113, "isnotarget" },
    { 0x0CFD265D, "isnotdroppable" },
    { 0x25A460CF, "isnp" },
    { 0xB0D64298, "isnp_f" },
    { 0x76779326, "isnpc" },
    { 0x8D9A772B, "isnt" },
    { 0x77EA4076, "isnumber" },
    { 0xB75E6E9C, "iso" },
    { 0x05C88B4B, "isobjectawayfromhome" },
    { 0x2E9CECAD, "isofficer" },
    { 0x35A76BE7, "isoffspring" },
    { 0x6EF66493, "isoktolookatentity" },
    { 0x956341C8, "isolate" },
    { 0xE8C916AA, "ison" },
    { 0xB284503D, "isonakillstreak" },
    { 0x6E932630, "isonbus" },
    { 0xFC3EA99A, "isonbusroof" },
    { 0x13D99D27, "isoneawayfromkillstreak" },
    { 0x5B94904D, "isoneround" },
    { 0x26D6948C, "isonezmround" },
    { 0x8029A253, "isonground" },
    { 0x4FD05CD2, "isonladder" },
    { 0x7333335D, "isonland" },
    { 0x659A9809, "isonlyoneleftaliveonteam" },
    { 0x6511F34D, "isonnav" },
    { 0xC724C45D, "isonrightside" },
    { 0x1FCD5B38, "isonturret" },
    { 0xFB197C56, "isonvehicle" },
    { 0x982269ED, "isopen" },
    { 0xEC1A5314, "isotherteamlastflag" },
    { 0x97762D5B, "isound" },
    { 0xB99692EB, "isoutofbounds" },
    { 0x3E502824, "isoverwatch" },
    { 0x3DCE5212, "isowner" },
    { 0x15006CDD, "ispacked" },
    { 0x59178A08, "ispartiallysuppressedwrapper" },
    { 0x7ADFEA70, "ispartygamemode" },
    { 0xCA5D7D0B, "ispathclear" },
    { 0x242B7AF4, "ispathfinder" },
    { 0x95825770, "ispathnode" },
    { 0x92CFA617, "ispaused" },
    { 0x2AED6335, "ispawn_teammask" },
    { 0x691C3CEA, "ispawn_teammask_allies" },
    { 0x040D8EFB, "ispawn_teammask_axis" },
    { 0x643946D2, "ispawn_teammask_free" },
    { 0x8810FF0A, "ispc" },
    { 0x42360855, "ispeekoutposclear" },
    { 0x0D92F00F, "ispeelingout" },
    { 0xD629DEB1, "ispenultimateround" },
    { 0x39891E81, "isperk" },
    { 0x6B956925, "isperkbottle" },
    { 0x0FC32096, "isperkgroup" },
    { 0xFC184608, "isphysicsvehicle" },
    { 0x31CFE8A4, "ispistol" },
    { 0xB24CD1DF, "ispistoltacticalwalkaim" },
    { 0x2D1C66A6, "isplaceconditional" },
    { 0xC4A12B2B, "isplanted" },
    { 0x5E95BB00, "isplanting" },
    { 0x65F192A6, "isplayer" },
    { 0xB8F5F3DA, "isplayercorpse" },
    { 0x13602D78, "isplayerdead" },
    { 0x62C59BC7, "isplayerdoublejumping" },
    { 0xC760A7D2, "isplayereliminated" },
    { 0xC7459E87, "isplayerexplosiveweapon" },
    { 0x6EB2E8F3, "isplayerfiring" },
    { 0x0F698740, "isplayerimmunetokillstreak" },
    { 0xEC9A398E, "isplayerinfected" },
    { 0xE55FC9B2, "isplayerjumping" },
    { 0x1155D72A, "isplayeronsamemachine" },
    { 0xC9A16B03, "isplayerreloading" },
    { 0xA38F74A0, "isplayersliding" },
    { 0xF173009A, "isplayersprinting" },
    { 0x9640027D, "isplayerswimming" },
    { 0xE9649FD8, "isplayertracked" },
    { 0xA747F90A, "isplayertrackedfunc" },
    { 0x8213DF59, "isplayerunderwater" },
    { 0xC4D8FD84, "isplayerviewlinkedtoentity" },
    { 0x1CB019EB, "isplayerwallrunning" },
    { 0x7A5914A3, "isplayerwallrunningright" },
    { 0x5CE49D35, "isplaying" },
    { 0x2DD3CE23, "isplaying_fake_bc" },
    { 0x67F028CC, "isplayinganimscripted" },
    { 0xB34981D0, "isplayingidleanim" },
    { 0x149386D4, "isplayingloopsound" },
    { 0x911F13AA, "isplayingsound" },
    { 0x8FC61F94, "isplayingspeakinganim" },
    { 0x318A4EE3, "isplayingticker" },
    { 0x89D97232, "ispoient" },
    { 0xB62BB1C5, "ispointinnavvolume" },
    { 0x12EDEE4E, "ispointonnavmesh" },
    { 0x479A5F79, "ispointvulnerable" },
    { 0x5C10667A, "ispoisoned" },
    { 0x41A0382B, "isposatgoal" },
    { 0x0E56C90A, "isposinclaimedlocation" },
    { 0x4FCA0E0F, "ispowered" },
    { 0x17624902, "isprecached" },
    { 0x06CA0290, "ispredictedspawn" },
    { 0xC6D22622, "ispregame" },
    { 0xC86ACCF9, "ispregameenabled" },
    { 0xEBE935E3, "ispregamegamestarted" },
    { 0xFC70911A, "ispregameplaylevel" },
    { 0x61719AE3, "isprematchrequirementconditionmet" },
    { 0xF5152296, "ispressbuild" },
    { 0x8CC64649, "isprimary" },
    { 0xDD0F4246, "isprimarydamage" },
    { 0xF92781D5, "isprimarydest" },
    { 0xBEED3E44, "isprimaryroll" },
    { 0x5331A1D9, "isprimaryweapon" },
    { 0x698160D8, "isprocedural" },
    { 0x21924A4C, "isprojectileweapon" },
    { 0xDDDB2281, "isprone" },
    { 0x887B7435, "isps3" },
    { 0xB80A8807, "ispunch" },
    { 0x29ECA31F, "ispuppet" },
    { 0x742B54C0, "ispurchased" },
    { 0x4B4E095F, "isradar" },
    { 0x10FE46AA, "isragdoll" },
    { 0xB5F836DA, "isramboing" },
    { 0x838A0CC2, "isrambopathclear" },
    { 0xC166C976, "isrankenabled" },
    { 0x2BEEF3FD, "isreactoriginfront" },
    { 0xCACB820E, "isready" },
    { 0x1DC91823, "isreallyalive" },
    { 0x20BA751C, "isrechambering" },
    { 0x9846750A, "isreducedteamkillweapon" },
    { 0xD85F549F, "isregisteredevent" },
    { 0x454B050D, "isregularai" },
    { 0xDF0699F6, "isrelativeteam" },
    { 0x3C641C13, "isreloadablealtweapon" },
    { 0x7D4A8AF2, "isreloading" },
    { 0x445E3712, "isremotecontrolling" },
    { 0xCA548511, "isrepack" },
    { 0x2FD4A44A, "isresetting" },
    { 0x3245A8D2, "isresetting_grief" },
    { 0xBF39F5A0, "isresponse" },
    { 0xDCE636CD, "isreviveonsafeterrain" },
    { 0xDCD94FC8, "isreviver" },
    { 0x3447C808, "isreviverorbleeder" },
    { 0x90358EA7, "isreviving" },
    { 0x1AA2DB0A, "isridingvehicle" },
    { 0x3B34EB55, "isright" },
    { 0xF74E02E5, "isrightarm" },
    { 0x788E9BB0, "isriotshield" },
    { 0xF4016999, "isrocketlauncher" },
    { 0xD729EDE9, "isrocketlauncherweapon" },
    { 0x587D73F9, "isrockettype" },
    { 0xAE83289D, "isroulette" },
    { 0x2393C33B, "isround" },
    { 0x29F4D680, "isroundbased" },
    { 0xA913A63A, "isroundend" },
    { 0x42FEB78D, "isrunningforward" },
    { 0x89D5652C, "isrusherwounded" },
    { 0x80D24EED, "isrushing" },
    { 0xEE1CBF70, "issac" },
    { 0x8405C6DA, "issafe" },
    { 0xF77E0760, "issafefromgrenade" },
    { 0x8DE3FF0B, "issafefromgrenades" },
    { 0x9BBD16B8, "issamantha" },
    { 0x40B03D70, "issatellite" },
    { 0xCC0F68C5, "issaverecentlyloaded" },
    { 0x23818174, "issavesuccessful" },
    { 0x497454CC, "issawdude" },
    { 0x9147EF5A, "isscavengable" },
    { 0x688C00FA, "isscoreboosting" },
    { 0x4B4F3777, "isscoreevent" },
    { 0x516299A4, "isscoreroundbased" },
    { 0x540BB275, "isscreecher" },
    { 0x2147FFA6, "isselected" },
    { 0xB11CE8EA, "issemiauto" },
    { 0x5CFB84BB, "issentient" },
    { 0x9320BDFA, "issentryturret" },
    { 0x79A827DC, "issetup" },
    { 0x4C76C908, "isshaking" },
    { 0xCCD9AB33, "issharpshooterround" },
    { 0x5923E6A6, "isshooting" },
    { 0xEE93E137, "isshootingflame" },
    { 0x5F4A67DD, "isshootingownclone" },
    { 0xC1A97A12, "isshortcircuiting" },
    { 0x1268C990, "isshoutcaster" },
    { 0x20F6DBEA, "isshowgibsenabled" },
    { 0x0FCE7DA8, "isshown" },
    { 0xB0036D5D, "isshufflecovernode" },
    { 0xE976CD43, "isshuffledirectionvalid" },
    { 0xB9119AA6, "issidearm" },
    { 0xE89BD882, "issiege" },
    { 0x46EF8559, "isskeletonwalking" },
    { 0x945169CD, "isslamming" },
    { 0x5B77CA95, "issliding" },
    { 0x2F158010, "issmallmapversion" },
    { 0xD0056018, "issniper" },
    { 0x75CA17FA, "issniperrifle" },
    { 0x6BFD78A7, "issniperspotted" },
    { 0x36735694, "issniperweapon" },
    { 0xEDDAD593, "isspawner" },
    { 0x5A8347DE, "isspawnpointvisible" },
    { 0x3A8F6E6C, "isspeakerinrange" },
    { 0x91782C1F, "isspeaking" },
    { 0xF11D369D, "isspeaking_cb" },
    { 0x1AAD8D00, "isspeakingfailsafe" },
    { 0xB8ED881E, "isspecial" },
    { 0xD329F851, "isspecialistunlocked" },
    { 0x94DA34AA, "isspecificuse" },
    { 0x2017FED1, "isspectating" },
    { 0xDE8DD0AA, "issplitarrival" },
    { 0x33D0D4D7, "issplitscreen" },
    { 0x02246035, "issplitscreenhost" },
    { 0x1648A52B, "isspotting_player" },
    { 0xF3B38C23, "issprinting" },
    { 0x870BCD89, "isspyplane" },
    { 0x612CD005, "issquad" },
    { 0x467A75FD, "issquadalreadycreated" },
    { 0x64D0BC56, "issquadleader" },
    { 0xE697199F, "issquadmember" },
    { 0xC7ACA64B, "issquadmoving" },
    { 0xC8F5C53D, "isstaff" },
    { 0x50B996B3, "isstanceallowed" },
    { 0x121BEA08, "isstanceallowedatnode" },
    { 0xE4AE79C8, "isstanceallowedwrapper" },
    { 0xF5A47289, "isstarterpack" },
    { 0xDED40FF6, "isstartingclassdefault" },
    { 0x9CB55290, "isstartingclasseraappropriate" },
    { 0x93D9267F, "isstationary" },
    { 0x3FA64FC9, "isstatmodifiable" },
    { 0x275EE30C, "isstillbesttarget" },
    { 0x01FD1FBD, "isstillvaliddartmissiletarget" },
    { 0xD02638DA, "isstillvalidtarget" },
    { 0x376FDCFD, "isstopping" },
    { 0x502C7925, "isstrafingbackwards" },
    { 0xE1BF9B4E, "isstreamed" },
    { 0xAEBF191D, "isstreamerready" },
    { 0x02477AC2, "isstring" },
    { 0x09210836, "isstrstart" },
    { 0x9268C10D, "isstuhlingeringame" },
    { 0xFB58CD4D, "isstun" },
    { 0xFF381006, "isstunned" },
    { 0x1E9A4A8D, "isstunweapon" },
    { 0x5DBF7ECA, "issubstr" },
    { 0xFB87F07B, "issubstr_match_any" },
    { 0x8C1DCC7A, "issue" },
    { 0xBC2A2A42, "issue_color_order_to_ai" },
    { 0x00D8F28A, "issue_color_orders" },
    { 0x5501D85F, "issue_leave_node_order_to_ai_and_get_ai" },
    { 0xC66F75F5, "issues" },
    { 0x04A47532, "issuffix" },
    { 0xFEBA5816, "issuperenemy" },
    { 0xD21481D1, "issupplydropgrenadeallowed" },
    { 0x0787B5C3, "issupplydropweapon" },
    { 0x2EB94967, "issuppressed" },
    { 0x15D43F74, "issuppressedatcovercondition" },
    { 0x38F9DB24, "issuppressedwrapper" },
    { 0x3BA6FFDD, "issurpressed" },
    { 0x5103B05A, "isswimming" },
    { 0xD5770832, "isswitchingweapons" },
    { 0xA971958F, "istacspawntouchingcrates" },
    { 0x9E573CA3, "istacticalhitmarker" },
    { 0xE386575D, "istacticalinsertion" },
    { 0x05C8E267, "istacticalwalking" },
    { 0x2CC534DD, "istalking" },
    { 0xF8B4869B, "istalkingnow" },
    { 0xB2D0360E, "isteam" },
    { 0x5B9DA701, "isteamalldead" },
    { 0x7375F7D0, "isteamlastflag" },
    { 0xFBA7D4E1, "isteamsaying" },
    { 0xC8F9C80C, "isteamspeaking" },
    { 0x042BDF8E, "isteamwinning" },
    { 0xFCA18E04, "isteleporting" },
    { 0x26CE3B38, "istestclient" },
    { 0x5D9EA963, "isthief" },
    { 0xC6F2A133, "isthirdperson" },
    { 0xC0DF66B1, "isthreat" },
    { 0xFB0B4C26, "isthrowback" },
    { 0x3B370451, "isthrowinggrenade" },
    { 0x4BA892AB, "isthrowngrenade" },
    { 0x0E67A315, "istimeddetonation" },
    { 0x3F165F6A, "istombstonepowered" },
    { 0xD226E7B4, "istoparm" },
    { 0x0A47DD7E, "istopbarrage" },
    { 0x9DAB4F8E, "istopscoringplayer" },
    { 0x64744812, "istorsoshot" },
    { 0x32FA5072, "istouching" },
    { 0x37B1B5D8, "istouchinganyoobtrigger" },
    { 0xCEE1473D, "istouchingignorewindowsvolume" },
    { 0x7363DB39, "istouchingswept" },
    { 0xB5016508, "istouchingvolume" },
    { 0x87FA1E6F, "istr" },
    { 0xD1A2BB6A, "istracesafeforrapsdronedropfromhelicopter" },
    { 0xA52CA3A9, "istransportavailable" },
    { 0x460CB1B3, "istraveling" },
    { 0xDC71A8E6, "istraversing" },
    { 0xD8065187, "istrigger" },
    { 0xC5637452, "istriggerenabled" },
    { 0x483C3C51, "istring" },
    { 0xDA74C6A7, "istrophydownpain" },
    { 0x609C2CAD, "istrue" },
    { 0xF78AF410, "isturning" },
    { 0xA25B19D6, "isturningright" },
    { 0x28009DF5, "isturretactive" },
    { 0x4C142596, "isturretfiring" },
    { 0x2C167FE7, "isturretinplacedturretlist" },
    { 0xFF87DDC4, "isturretready" },
    { 0x10C8F3CD, "isunarmed" },
    { 0xCA0811E9, "isundamaged" },
    { 0x90656392, "isunderwater" },
    { 0x2455E1FC, "isusabilityenabled" },
    { 0x5D4C4CCF, "isusingcustomgamemodeclasses" },
    { 0x74C0E46E, "isusingheropower" },
    { 0x1D3A01DD, "isusingoffhand" },
    { 0x5EE70D43, "isusingoffhandequipment" },
    { 0x1C050A49, "isusingremote" },
    { 0xC6FA3AE8, "isusingt7melee" },
    { 0xAA780AFD, "isvalid" },
    { 0x4E4AA634, "isvalidattacker" },
    { 0xD0B6ABA3, "isvalidclass" },
    { 0xB9D837BF, "isvaliddamagecause" },
    { 0xAE78D0A9, "isvaliddartmissiletarget" },
    { 0x3DBB5017, "isvalidenemy" },
    { 0x0508F397, "isvalidevent" },
    { 0xD0164FE4, "isvalidgibref" },
    { 0xA785886E, "isvalidhackertooltarget" },
    { 0x3EEB6A15, "isvalidhitlocation" },
    { 0xE33165D8, "isvalidlocation" },
    { 0xBA063CC9, "isvalidnonshieldweapon" },
    { 0xBAF49D65, "isvalidpoint" },
    { 0x39CD1E17, "isvalidsoundcause" },
    { 0x4451C715, "isvec" },
    { 0x85E4C3B3, "isvehicle" },
    { 0x29C29613, "isvehicleattached" },
    { 0x6BCE5B2C, "isvehicleimmunetodamage" },
    { 0x1D0110F7, "isvehicleinwater" },
    { 0x76E47DE0, "isvehicleseatoccupied" },
    { 0xB7AB1931, "isvehiclespawner" },
    { 0xBAEF232B, "isvehicleturretoverheating" },
    { 0x2DB6FA07, "isvehicleusable" },
    { 0xDE7299E4, "isvoxoncooldown" },
    { 0x455E3F40, "iswagermatch" },
    { 0x8FCD4A42, "iswaitingonsound" },
    { 0xDB5FCB76, "iswalking" },
    { 0x4F41D2E0, "iswallmount" },
    { 0xAD7E8C32, "iswallrunning" },
    { 0x5F432BB4, "iswallrunnode" },
    { 0xDE3D0669, "iswatersheeting" },
    { 0xE35E6D94, "iswaypoint" },
    { 0x2D525639, "isweapon" },
    { 0xAA4E5A55, "isweaponassociatedwithkillstreak" },
    { 0x16ED79D5, "isweaponcliponly" },
    { 0x6EF7513B, "isweapondetonationtimed" },
    { 0x842B26FF, "isweapondisallowedatmatchstart" },
    { 0x31827FE8, "isweaponenabled" },
    { 0x863D0697, "isweaponequipment" },
    { 0x25C7DFD5, "isweaponinitialized" },
    { 0xAF18733B, "isweaponoverheating" },
    { 0xE8008E79, "isweaponprimary" },
    { 0x8014E1F5, "isweaponregistered" },
    { 0xC33EE25D, "isweaponscopeoverlay" },
    { 0x9686D7DA, "isweaponspecificuse" },
    { 0x818DE253, "isweaponviewonlylinked" },
    { 0x62BC9F3D, "iswheelcolliding" },
    { 0x0AE6F22C, "iswheelpeelingout" },
    { 0x006A5FB0, "iswheelsliding" },
    { 0xDEFB2C44, "iswinner" },
    { 0x5243B0D3, "iswinning" },
    { 0x8B7A97D2, "iswinter" },
    { 0x527A02E4, "iswithinhackertoolreticle" },
    { 0x2A6FBFFD, "iswounded" },
    { 0x9FE9197E, "iszbarrier" },
    { 0xF33788B1, "iszombieleaderboardavailable" },
    { 0x41473004, "iszombiewalking" },
    { 0xA3AAF0B6, "it" },
    { 0xACC5CC2D, "it_manager_dialog" },
    { 0xAED9CB79, "iteam" },
    { 0xC5B0E858, "item" },
    { 0x82104B62, "item_array" },
    { 0xDFB86757, "item_attack" },
    { 0x677FFB32, "item_attract_zombies" },
    { 0x3A5D81A5, "item_choke" },
    { 0xA26F8365, "item_choke_count" },
    { 0x508B0F50, "item_damage" },
    { 0xD4A2EC15, "item_dmg" },
    { 0xD9FF227E, "item_ent" },
    { 0xD59039E2, "item_is_banned" },
    { 0xEFB47DD9, "item_is_claimed" },
    { 0x58D6FAF4, "item_is_on_corpse" },
    { 0xAD5E7123, "item_list" },
    { 0xD4F769A6, "item_meat" },
    { 0xD5E1E8BD, "item_meat_caught" },
    { 0x31558328, "item_meat_clear" },
    { 0x8A23733A, "item_meat_drop" },
    { 0x833789EC, "item_meat_name" },
    { 0xB71B8815, "item_meat_on_pickup" },
    { 0xC13A6934, "item_meat_on_spawn_retrieve_trigger" },
    { 0x3C23AAE3, "item_meat_pick_up_trigger" },
    { 0x7C0FD855, "item_meat_pickup" },
    { 0x9445CF12, "item_meat_reset" },
    { 0x680D6606, "item_meat_spawn" },
    { 0x7F286789, "item_meat_spawned" },
    { 0xA0877772, "item_meat_volley" },
    { 0x89D3F3E1, "item_meat_watch_bounce" },
    { 0x8E7F5A37, "item_meat_watch_for_throw" },
    { 0x0BC4842B, "item_meat_watch_shutdown" },
    { 0xACC6DABF, "item_meat_watch_stationary" },
    { 0x09EBE1C7, "item_meat_watch_trigger" },
    { 0xBE7F0562, "item_name" },
    { 0x2CFDA5BD, "item_quick_trigger" },
    { 0xC1EDD5F6, "item_ref" },
    { 0x3932CF58, "item_string" },
    { 0x5D227B90, "item_struct" },
    { 0xE964D160, "item_watch_damage" },
    { 0x81F512EB, "item_watch_explosions" },
    { 0xF5653FC5, "itemcount" },
    { 0x590F3E1D, "itemdef" },
    { 0x7F0CE65C, "itemdefs" },
    { 0x5D7694D7, "itemexclusions" },
    { 0x04896271, "itemgroup" },
    { 0xD234E568, "itemhacked" },
    { 0xC94804A9, "itemheight" },
    { 0x1630584C, "itemindex" },
    { 0xBA461E9C, "iteminserted" },
    { 0x3869DEF1, "itemname" },
    { 0x4B4E3C3E, "itemorigin" },
    { 0x9480EA67, "itempadding" },
    { 0xCF9F6A1F, "itemreference" },
    { 0xF243EC2D, "itemremoveammofromaltmodes" },
    { 0xC04D8F24, "itemrow" },
    { 0x9F5D8B33, "items" },
    { 0xF3041E41, "items_array" },
    { 0x21DF88E9, "items_shuffle" },
    { 0x031EFE29, "items_string" },
    { 0x855B6B60, "itemtype" },
    { 0x4445660E, "itemweaponsetammo" },
    { 0xD169729E, "itemweaponsetoptions" },
    { 0x6BEAEA2C, "itemwidth" },
    { 0x15B37F75, "iterate" },
    { 0x46386E6B, "iterated" },
    { 0x0C134244, "iterates" },
    { 0xA0F1CD40, "iterating" },
    { 0xD0C9EB8A, "iteration" },
    { 0x77748338, "iteration_move_distance" },
    { 0xB2F0DDC5, "iterations" },
    { 0xFB92ACF8, "iterationwaitseconds" },
    { 0x86B758CA, "iterative" },
    { 0x9068256F, "iterator" },
    { 0x4CBA6F89, "itime" },
    { 0xDE3D871F, "itimeout" },
    { 0x611B3747, "itimestofire" },
    { 0x963E1AA9, "its" },
    { 0x4FE7E633, "its_a_trap_main" },
    { 0xECED87E2, "its_curtains_for_ya" },
    { 0xCD2AB08F, "itsbeenawhile" },
    { 0xD350BB2C, "itself" },
    { 0x73D508E2, "itstime_anim" },
    { 0x4C504906, "itstime_dialogue_thread" },
    { 0xDFB8ADC3, "itubenumber" },
    { 0x43C7FD05, "iunblocked" },
    { 0x57A5FBE4, "iv" },
    { 0x7DA8764D, "iw" },
    { 0xC64B5B7A, "iw_best" },
    { 0xBBD2E7AB, "iw_deck" },
    { 0x10A900CA, "iwidth" },
    { 0x4943A10C, "iwin" },
    { 0xE0EDAC55, "iwlauncher" },
    { 0x91240FCD, "iwmap" },
    { 0xA3557C4D, "j" },
    { 0xDBB9BCE1, "j125_1" },
    { 0x27BEB1B3, "j125_3" },
    { 0x4DC12C1C, "j125_4" },
    { 0xC6433E33, "j156" },
    { 0xE149C0D6, "j162" },
    { 0x4C1148D7, "j163_1" },
    { 0xDA09D99C, "j163_2" },
    { 0x8896C28E, "j_gun" },
    { 0x2A396777, "j_mainroot" },
    { 0x126DDE99, "j_neck" },
    { 0x1EC49363, "j_shield_extend_attach_tag" },
    { 0xCA6203B6, "j_spine1" },
    { 0xCA5F8EFB, "j_time" },
    { 0xA38E7F03, "j_wrist_ri" },
    { 0xB60596D0, "jack" },
    { 0xACAC3D63, "jacked" },
    { 0x0CD3E3F3, "jacket" },
    { 0x536CF4EC, "jackson" },
    { 0x62BB788E, "jacob" },
    { 0x3406BF31, "jacobs" },
    { 0x77404D57, "jae" },
    { 0x4D575045, "jail_barricade" },
    { 0xDEB6893C, "jail_barricade_down" },
    { 0x76C22119, "jail_cell_volume" },
    { 0x680697C9, "jail_cell_watcher" },
    { 0x13354DDF, "jail_chest" },
    { 0x839F1B39, "jail_close_cower" },
    { 0xE3AD7777, "jail_close_door" },
    { 0xB8771BF5, "jail_close_idle" },
    { 0x0EA634F0, "jail_door" },
    { 0x09F74A98, "jail_open" },
    { 0xFF10E5FB, "jail_open_door" },
    { 0x4FACE17E, "jail_open_jumpback" },
    { 0xE45B5D94, "jail_start" },
    { 0x502A0D86, "jail_traversal_fix" },
    { 0xB3F579C9, "jailuseanimtree" },
    { 0xEC7D14DF, "jakatdar" },
    { 0xD2F2AE36, "jake" },
    { 0xFF789C22, "jake_tools" },
    { 0x472C7A0F, "jam" },
    { 0x554C2272, "jam_done" },
    { 0x705C6CB2, "jam_heli" },
    { 0xA6F701CF, "jamb" },
    { 0x3F196D5B, "james" },
    { 0xB6CFE17A, "jamess" },
    { 0x0AFD164B, "jammed" },
    { 0xF6DA648D, "jammer" },
    { 0xA89AC3A0, "jamming" },
    { 0x20CCE0D6, "jams" },
    { 0xD5250AD4, "jan" },
    { 0x2AF94F61, "jane" },
    { 0x3FCACEBD, "jankiness" },
    { 0x748228CC, "janky" },
    { 0x4834300B, "janssen" },
    { 0x6B09FADC, "janxed_end_shot" },
    { 0x590C42BA, "jap" },
    { 0xE2027800, "japanese" },
    { 0x0F453AC5, "japanese_names" },
    { 0xA310D135, "japs" },
    { 0x229E8296, "japs1" },
    { 0xFC9C082D, "japs2" },
    { 0xD6998DC4, "japs3" },
    { 0xE307AD3E, "japs_first_wave" },
    { 0x1EAEDED5, "japs_on_hut" },
    { 0x0D074DE8, "jar" },
    { 0xAB332BFB, "jared" },
    { 0xE7D8DA56, "jarring" },
    { 0x3309C851, "jas" },
    { 0x7DD85661, "jas2" },
    { 0x504968D2, "jason" },
    { 0x83D7E07B, "jasone" },
    { 0xF644F13E, "jatodo" },
    { 0xA511378C, "jav" },
    { 0xB8C07112, "javelin" },
    { 0x908E0A89, "javelin_briefing" },
    { 0xAF70C3DC, "javelin_clu_cleartarget" },
    { 0xFEAB3883, "javelin_clu_off" },
    { 0x7B05871A, "javelin_guy" },
    { 0x23527423, "javelin_guy_runs_in" },
    { 0x1B9C18AD, "javelin_guy_spawns" },
    { 0xDD99C1DD, "javelin_helper" },
    { 0xA189263F, "javelin_init" },
    { 0xE8B93D1B, "javelin_losetargetatrighttime" },
    { 0x26A32873, "javelin_min_use_distance" },
    { 0x35E1C37A, "javelinchance" },
    { 0x99B0B5FE, "javelincluloop" },
    { 0xC73F719E, "javeline_incoming" },
    { 0x769175C7, "javelinlockfinalized" },
    { 0x44DF2A06, "javelinlockstarted" },
    { 0x195CF58E, "javelinlockstarttime" },
    { 0x44672A95, "javelintarget" },
    { 0x76756F5C, "javelintoggleloop" },
    { 0x5166A5A3, "javmodel" },
    { 0x7AF92BE7, "javweap" },
    { 0x118CD98A, "jawanim" },
    { 0x25094731, "jawanimenabled" },
    { 0x2F5BF44E, "jawbase" },
    { 0x1282C1C4, "jaws" },
    { 0x4EFAE9DB, "jay" },
    { 0x0E9C912A, "jazz" },
    { 0x617B9FC5, "jb" },
    { 0xD06383B0, "jbw" },
    { 0x3B79255C, "jc" },
    { 0xF6574910, "je_1st_battle_advance_nag_lines" },
    { 0xFF6233DA, "je_battle1_jungle_chasers" },
    { 0xB444CCFC, "je_battle1_start_trigger" },
    { 0x33786FC3, "je_battle1_wave2_trigger" },
    { 0xBC9A05AA, "je_battle1_wave3_trigger" },
    { 0x752C9349, "je_battle2_chasers" },
    { 0xC6874602, "je_battle2_dog_attack_trigger" },
    { 0x3C6A9652, "je_battle2_stealth_patrol_setup" },
    { 0x45113FFF, "je_battle2_wave1_trigger" },
    { 0x73E67AD8, "je_battle2_wave2_trigger" },
    { 0x30716A71, "je_battle2_wave3_trigger" },
    { 0xE0624664, "je_battle3_chasers" },
    { 0x2B6C9479, "je_battle3_mortar_attack" },
    { 0xD6FE574E, "je_battle3_wave1_trigger" },
    { 0x7C50F129, "je_battle3_wave2_trigger" },
    { 0xF5818630, "je_battle3_wave3_trigger" },
    { 0x2336A7B3, "je_battle3_wave4_trigger" },
    { 0x812EFFD1, "je_battle3_wave_drones_trigger" },
    { 0x98554F43, "je_end_scene_started" },
    { 0xDB9E7B61, "je_goto_defend3_dog_attack_trigger" },
    { 0xF73A1EBA, "je_hudson_heads_to_battle_2" },
    { 0x1D3C9923, "je_hudson_heads_to_battle_3" },
    { 0x057EC79E, "je_retreat_and_delete" },
    { 0x1E091C96, "je_skip_battle1" },
    { 0xF806A22D, "je_skip_battle2" },
    { 0xD20427C4, "je_skip_battle3" },
    { 0x79B1E1C5, "je_trigger_hind_beach_evacuation" },
    { 0x803E1D20, "jeanne" },
    { 0x4365758F, "jedi" },
    { 0xAB9740E9, "jeep" },
    { 0x42405AF2, "jeep1" },
    { 0xB9006BF8, "jeep1_end" },
    { 0x1F6E3E35, "jeep1_guys" },
    { 0x1E07631B, "jeep1_start" },
    { 0x1C3DE089, "jeep2" },
    { 0xFA3D41FB, "jeep2_end" },
    { 0xA1C59A58, "jeep2_start" },
    { 0x13F1C133, "jeep2_starts" },
    { 0xC441B9FA, "jeep4_guys" },
    { 0x5503691D, "jeep_1" },
    { 0x7B05E386, "jeep_2" },
    { 0x01F414FA, "jeep_ai_anim" },
    { 0xDC0113E1, "jeep_ai_anim_bowman" },
    { 0xB85925A5, "jeep_ai_anim_brooks" },
    { 0x72358170, "jeep_ai_anim_spetz1" },
    { 0xE43CF0AB, "jeep_ai_anim_spetz2" },
    { 0x20FED79D, "jeep_back" },
    { 0x79A5B997, "jeep_crash_moments" },
    { 0xDEA624AE, "jeep_death_damage" },
    { 0x32ECB864, "jeep_drive" },
    { 0x8A7B9BAD, "jeep_drive_idle" },
    { 0x0BE8AA4B, "jeep_forward" },
    { 0xE2A231CB, "jeep_intro_ride" },
    { 0x0D876034, "jeep_intro_setup" },
    { 0x79477446, "jeep_jump_gravel" },
    { 0x7482501F, "jeep_left" },
    { 0xFB1ACB74, "jeep_linkspot" },
    { 0x6970382C, "jeep_mount_hands" },
    { 0x7C5557EC, "jeep_org_offset" },
    { 0x34ADA8FE, "jeep_origin_debug" },
    { 0x64B74D69, "jeep_path" },
    { 0x0C9C033A, "jeep_right" },
    { 0xC89C90E3, "jeep_save_invulnerability" },
    { 0x6A4974E4, "jeep_start_death_hint_watcher" },
    { 0x5BF9FC67, "jeep_start_node" },
    { 0x5E8840AD, "jeep_stop_idle" },
    { 0xC5C235E3, "jeep_stuck_done" },
    { 0xF2B00F54, "jeep_tank_damage" },
    { 0xFBC2559B, "jeep_tank_nag" },
    { 0xBA3233C2, "jeep_tire_anim" },
    { 0x5FBCA74A, "jeep_tow" },
    { 0x39341A8D, "jeep_tow_arclight_vo" },
    { 0xA477BE56, "jeep_tow_hint" },
    { 0x3E97BB02, "jeep_tow_radio" },
    { 0x8C7632FF, "jeep_tow_think" },
    { 0x66B97B03, "jeep_turret_event" },
    { 0xCEB7AB5F, "jeep_unload_player" },
    { 0xD03676E4, "jeep_vo_done" },
    { 0x75420748, "jeep_window" },
    { 0x15E0893A, "jeepmortar" },
    { 0x820C6513, "jeepride" },
    { 0xC0AFDA56, "jeepride_amb" },
    { 0x4BF6F639, "jeepride_anim" },
    { 0x252B5CC5, "jeepride_art" },
    { 0xF5E40615, "jeepride_code" },
    { 0xAB7CC59D, "jeepride_crash_anim" },
    { 0x7DEFBB29, "jeepride_crash_animtree" },
    { 0xDE89ACF9, "jeepride_crash_model" },
    { 0x014B082B, "jeepride_flares_fire_burst" },
    { 0x45970D4C, "jeepride_fx" },
    { 0xD06F8742, "jeepride_fxline" },
    { 0xC2CEC8ED, "jeepride_grg_tankabouttoblow" },
    { 0x69D15B8C, "jeepride_intro" },
    { 0x819AF648, "jeepride_linked_weapon" },
    { 0xF7AD3803, "jeepride_passbytimings" },
    { 0xD8683F93, "jeepride_start_dump" },
    { 0xAA360AFD, "jeepride_start_dumphandle" },
    { 0x502E8829, "jeepride_veh_ref" },
    { 0x76DA0060, "jeeps" },
    { 0xF83C852D, "jeeps_all_unloaded" },
    { 0xB3737F5E, "jeeps_unload" },
    { 0x0C12B65A, "jeers" },
    { 0x3765027E, "jeesh" },
    { 0x3456E08E, "jeff" },
    { 0x7AF60819, "jeopardizing" },
    { 0x8C2D0EBF, "jeopardy" },
    { 0xC817B50B, "jeremy" },
    { 0x4ECB6E6A, "jeremys" },
    { 0xDC694677, "jerk" },
    { 0x2170D015, "jerkiness" },
    { 0xE6B65454, "jess" },
    { 0x52B003E1, "jesse" },
    { 0xFA365288, "jesses" },
    { 0x415E85CD, "jesus" },
    { 0x86F40D8A, "jet" },
    { 0x42AABE57, "jet1" },
    { 0xF2454056, "jet1end" },
    { 0xD0A34F1C, "jet2" },
    { 0x6A07BE6B, "jet2end" },
    { 0xF6A5C985, "jet3" },
    { 0xE9C5737C, "jet3end" },
    { 0x775C78C6, "jet_afterburn" },
    { 0x4EFE77D7, "jet_boost_watcher" },
    { 0x1B0A6E19, "jet_col" },
    { 0x215FB1C6, "jet_color" },
    { 0x6AA106B9, "jet_down_transition" },
    { 0xD8BBAEB1, "jet_exp_audio" },
    { 0x7A7539ED, "jet_idle_run_transition" },
    { 0x65D3DABA, "jet_stick_down" },
    { 0x37BA3C1B, "jet_stick_down_rate" },
    { 0x622DA4AE, "jet_stick_move_pitch" },
    { 0xF99307C5, "jet_stick_movement" },
    { 0x129FD00C, "jet_stick_pitch" },
    { 0xF43CCB08, "jet_stick_pitch_down_rate" },
    { 0x6A8DDF6B, "jet_stick_pitch_turn_rate" },
    { 0x30326669, "jet_stick_pitch_up_rate" },
    { 0xF35BEF27, "jet_stick_turn" },
    { 0xA335FC2C, "jet_stick_turn_rate" },
    { 0x13E936D1, "jet_stick_up" },
    { 0x65025C0A, "jet_stick_up_rate" },
    { 0x07CC0C99, "jet_stick_vol" },
    { 0x83D22D95, "jet_stream_launch" },
    { 0x44EAB70C, "jet_stream_launch_start" },
    { 0x92866FB2, "jet_transistion_watcher" },
    { 0xC4D41AB1, "jet_turn_rattle_transition" },
    { 0x4069AFF6, "jet_turn_transition" },
    { 0x04555250, "jet_turn_whine" },
    { 0x3BFB6B53, "jet_up_rattle_transition" },
    { 0xB71D5AAC, "jet_up_transition" },
    { 0x6A594E0F, "jet_wind" },
    { 0xEC56D6E7, "jet_wing_breathing" },
    { 0x48DF4B04, "jet_wing_helmet_futz_off" },
    { 0xC7A2B46E, "jet_wing_helmet_futz_on" },
    { 0xEB5EFB5C, "jet_wing_helmet_futz_on_flying" },
    { 0xF8B470D2, "jet_wing_radio_chatter" },
    { 0x6FD5CE94, "jetgun" },
    { 0x64B6F065, "jetgun_activation_watcher_thread" },
    { 0xE928C32C, "jetgun_blow_suck" },
    { 0xECD9DDD9, "jetgun_buildable" },
    { 0x890CAB14, "jetgun_check_enemies_in_range" },
    { 0x965ACC44, "jetgun_death_effects" },
    { 0xB4021AF4, "jetgun_debug_print" },
    { 0x2D600E62, "jetgun_debug_print_on_ent" },
    { 0x544AF65A, "jetgun_devgui_dvar_think" },
    { 0xE4F52BA0, "jetgun_drag_enemies" },
    { 0x8D9C8D3A, "jetgun_drag_func" },
    { 0xCB349FE8, "jetgun_drag_set" },
    { 0x6CCC0C07, "jetgun_drag_state" },
    { 0xFC1AF72E, "jetgun_drag_zombie" },
    { 0xE0D92B0D, "jetgun_end_drag_state" },
    { 0xBE22FBA5, "jetgun_engine" },
    { 0x3EB19751, "jetgun_fired" },
    { 0xD3854BB2, "jetgun_firing" },
    { 0xDAEEAA3F, "jetgun_fling" },
    { 0xAF7C4516, "jetgun_fling_enemies" },
    { 0x9AA22BB8, "jetgun_fling_func" },
    { 0x99CD489C, "jetgun_fling_zombie" },
    { 0x98FCD2FC, "jetgun_fx_fire" },
    { 0xD5249F18, "jetgun_fx_listener" },
    { 0x7764FC16, "jetgun_fx_power_cell" },
    { 0x96730357, "jetgun_gauges" },
    { 0x5B05C184, "jetgun_get_enemies_in_range" },
    { 0x69B7905A, "jetgun_gib_enemies" },
    { 0xBBC6A6F0, "jetgun_gib_refs" },
    { 0xBF63DD8B, "jetgun_grind" },
    { 0x4D983C3A, "jetgun_grind_death_ending" },
    { 0x26239D42, "jetgun_grind_enemies" },
    { 0xB1E94460, "jetgun_grind_zombie" },
    { 0x8377E815, "jetgun_handle" },
    { 0x5A4A3CD5, "jetgun_handle_death_notetracks" },
    { 0x8F97BD4F, "jetgun_handle_pain_notetracks" },
    { 0xD828C45A, "jetgun_heatval" },
    { 0xC3E283B3, "jetgun_inner_range" },
    { 0xEA8FE1E0, "jetgun_knockdown_enemies" },
    { 0xBF4D6D7A, "jetgun_knockdown_func" },
    { 0x3D8F243E, "jetgun_knockdown_gib" },
    { 0x746E976E, "jetgun_knockdown_zombie" },
    { 0x1B9FD9F6, "jetgun_network_choke" },
    { 0x0CBD7EAA, "jetgun_network_choke_count" },
    { 0x96873BB1, "jetgun_notetrack_think" },
    { 0xF8003247, "jetgun_on_player_connect" },
    { 0xA308FAFC, "jetgun_outer_edge" },
    { 0x8E495968, "jetgun_overheated" },
    { 0x4907E92D, "jetgun_overheating" },
    { 0x622FD250, "jetgun_owner" },
    { 0x905AAB8B, "jetgun_play_fx_power_cell" },
    { 0xB4526D13, "jetgun_play_power_cell_fx" },
    { 0xB3AA1022, "jetgun_power_cell_fx_handles" },
    { 0x348BEF7B, "jetgun_pulled_in_range" },
    { 0xC7C3F6B6, "jetgun_pulling_in_range" },
    { 0xF91C4474, "jetgun_steam_vents" },
    { 0x6D6B75E7, "jetgun_wires" },
    { 0x2A44CBA4, "jetgun_zm_taken" },
    { 0x6515AB8C, "jetgunbuildable" },
    { 0x1FD9BB95, "jetpack" },
    { 0x61F0C9D7, "jetpack_arrival" },
    { 0x69028F55, "jetpack_deploy_chute_guy0" },
    { 0x430014EC, "jetpack_deploy_chute_guy1" },
    { 0xBD412B32, "jetpack_go" },
    { 0xCDB59E48, "jetpack_guy_killed_midair" },
    { 0xA60DB978, "jetpack_respawners" },
    { 0x27B1C3B1, "jetpack_snd" },
    { 0x66E4FE22, "jetpack_wind" },
    { 0xA6E282E4, "jetpacks" },
    { 0x774463C5, "jets" },
    { 0x02C3DD5B, "jets_flyby_hangar_stairs" },
    { 0x3DEF8959, "jetsound_ent" },
    { 0x7C6EF7E6, "jetting" },
    { 0x433A4FAE, "jettisoned" },
    { 0xA9CD5AE7, "jetwash" },
    { 0x8A5E9FE7, "jetwing" },
    { 0x34D61B0C, "jetwing_ai" },
    { 0x0033F5FC, "jetwing_ai_chinese" },
    { 0xE61C671B, "jetwing_ai_fire_offset" },
    { 0xEB5432E3, "jetwing_ai_groups" },
    { 0xEB1B04B5, "jetwing_ai_offsets" },
    { 0x4B1E8A3C, "jetwing_ai_usa" },
    { 0x34AF8840, "jetwing_audio" },
    { 0xB06FE741, "jetwing_audio_fade" },
    { 0x2DB6ECD4, "jetwing_barrel_roll" },
    { 0x8A617292, "jetwing_collision" },
    { 0x1DDAA7F4, "jetwing_damage_override" },
    { 0xCC722754, "jetwing_damage_watcher" },
    { 0xB92E4654, "jetwing_deathwatcher" },
    { 0xEC17618A, "jetwing_done" },
    { 0x02B154F8, "jetwing_fx" },
    { 0xE4007F8B, "jetwing_fx_anims" },
    { 0xA0E4F104, "jetwing_guys_explode" },
    { 0xEF06D6F8, "jetwing_harper" },
    { 0xA3AF6FAE, "jetwing_harper_offset" },
    { 0x3967CFB4, "jetwing_init" },
    { 0xBC95C891, "jetwing_instructions" },
    { 0x43894BDC, "jetwing_land_start" },
    { 0x81D0F932, "jetwing_landed" },
    { 0x8EF3FC35, "jetwing_landing_rumble" },
    { 0xEAF72FDF, "jetwing_manager" },
    { 0x3DF12453, "jetwing_offset" },
    { 0xC268E799, "jetwing_rumble" },
    { 0x0BB8B151, "jetwing_sound_ent" },
    { 0xD843F1E8, "jetwing_strafe_controls" },
    { 0xBF813F5E, "jetwings" },
    { 0x2DA34CBB, "jetwings_regroup" },
    { 0xF6AA5660, "jetwings_spread" },
    { 0x5BF88C10, "jfk" },
    { 0x53D8138A, "jfk_dof" },
    { 0x9D794768, "jfk_mon1" },
    { 0x2D747508, "jfk_mon10" },
    { 0x5376EF71, "jfk_mon11" },
    { 0x0F80B6A3, "jfk_mon2" },
    { 0xE97E3C3A, "jfk_mon3" },
    { 0x5B85AB75, "jfk_mon4" },
    { 0x3583310C, "jfk_mon5" },
    { 0xA78AA047, "jfk_mon6" },
    { 0x818825DE, "jfk_mon7" },
    { 0x9367EE89, "jfk_mon8" },
    { 0x6D657420, "jfk_mon9" },
    { 0x969320A1, "jfk_movie_1" },
    { 0xBC959B0A, "jfk_movie_2" },
    { 0x07441EA8, "jfk_movie_done" },
    { 0xE030589E, "jfk_movie_play" },
    { 0x9D8B2FF5, "jfk_pull_gun" },
    { 0x16A5E2A2, "jfk_pulse" },
    { 0x23B26051, "jfk_room_screen" },
    { 0xC92FEC81, "jfk_time_start" },
    { 0x75CF6DEB, "jfk_time_stop" },
    { 0x722E93D5, "jgun_snd" },
    { 0x58A2DB22, "jiesang" },
    { 0xC05B6F31, "jiggle" },
    { 0x4D148671, "jimmy" },
    { 0x7CC91139, "jinan" },
    { 0x3A205B5A, "jingle" },
    { 0x7054D602, "jingle_is_playing" },
    { 0x63DE2F95, "jingle_playing" },
    { 0x4E739B24, "jinky" },
    { 0xD22850EF, "jitter" },
    { 0xAA6F9726, "jitter_amount" },
    { 0x26337D1F, "jitter_distance" },
    { 0x401EAA59, "jitter_enemies_bad_breadcrumbs" },
    { 0x47185611, "jitter_ent" },
    { 0xF8C3B588, "jitter_func" },
    { 0x666C38E9, "jitter_shield" },
    { 0x25F4ECE0, "jittericon" },
    { 0xB01487D1, "jittering" },
    { 0x4AA18936, "jitters" },
    { 0x2EB067AC, "jittery" },
    { 0xD790860A, "jivko" },
    { 0xF792666B, "jkatz" },
    { 0xE562D7AB, "jl" },
    { 0x4499119C, "jluyties" },
    { 0xBF605D42, "jm" },
    { 0x6BC761EF, "jma" },
    { 0xBC616DD2, "jmccawley" },
    { 0x5E01644B, "jmorelli" },
    { 0xDAADDCE0, "jmself" },
    { 0x78FD6FB2, "joannal" },
    { 0x949B1002, "job" },
    { 0xBDE9946E, "jobindex" },
    { 0x2C3F5F4D, "jobs" },
    { 0x06A27F3D, "joe" },
    { 0x52A7740F, "jog" },
    { 0xA334C585, "jog_anim" },
    { 0x57727A18, "jog_idle" },
    { 0x4D41DF09, "jog_internal" },
    { 0x40ADFD08, "jog_look_alternate" },
    { 0x5163F1E8, "jog_run_thread" },
    { 0xAEFDF22A, "jog_sprint" },
    { 0x73E5C10A, "jog_start" },
    { 0x2FCBB4E2, "jog_stop" },
    { 0x181CFC6B, "jog_waittill_stop" },
    { 0x49A66662, "jogger_node" },
    { 0x9BB87BC2, "joggers" },
    { 0x6E1EEA2E, "jogging" },
    { 0x33646ED6, "jogs" },
    { 0x0617E6EC, "jogs_forward" },
    { 0xFA146B1A, "jogs_left" },
    { 0xCF65DB69, "jogs_right" },
    { 0xDFCCBF36, "john" },
    { 0x07F0EDE2, "john_woo_achievement" },
    { 0x90E18B23, "johnny_node_chaser" },
    { 0x4831542A, "johnson" },
    { 0x86A988DD, "join" },
    { 0x02E54896, "join_squad" },
    { 0x7808888A, "joined" },
    { 0xA948754F, "joined_spectators" },
    { 0x48E2DEBE, "joined_team" },
    { 0x21EE204F, "joiners" },
    { 0xD511BBCB, "joining" },
    { 0x4D315089, "joining_team" },
    { 0x07B35E1C, "joins" },
    { 0x54A31631, "joinsquad" },
    { 0xE1B0E3B3, "joint" },
    { 0x42F8B2C1, "joint_array" },
    { 0xF8AFFE8A, "joint_index" },
    { 0x41B2AC62, "joints" },
    { 0x595008A4, "joke" },
    { 0x28DAE86E, "joker" },
    { 0x532ED7ED, "jokes_on_u" },
    { 0x08D4F612, "jolie" },
    { 0x8B302F35, "jolie_fail" },
    { 0x0432F17A, "jolie_pass" },
    { 0x2DFDBC80, "jolt" },
    { 0x7872BA64, "joltbody" },
    { 0x25D18A55, "jolter" },
    { 0x4E0830AA, "joltonend" },
    { 0x5CB8CCEE, "jon" },
    { 0x1D926FCE, "jones" },
    { 0xB19C4EFB, "jonesy" },
    { 0x3E0E8583, "jordan" },
    { 0x6DA10E98, "josefina" },
    { 0xAD78A778, "josefina_burned1" },
    { 0x1A216D38, "josefina_grave_state" },
    { 0xAFFF8E84, "joseph" },
    { 0x4E284812, "josephina" },
    { 0x76A10C98, "joug" },
    { 0x42EC4CDB, "journey" },
    { 0x42DFCC02, "joyal" },
    { 0xDBF60447, "joyclick" },
    { 0x1BAB059F, "joystick" },
    { 0x15701861, "jpark" },
    { 0x4843CDDF, "jqprof" },
    { 0x0153F935, "jr" },
    { 0x83841D5B, "jr_alive" },
    { 0xBAF02004, "jrs" },
    { 0xDB517ECC, "js" },
    { 0xBD2EFA37, "js_hudson_lookout_for_child_soldiers" },
    { 0xD92A9B30, "js_hudson_mason_rock_climb_start" },
    { 0xA503DE11, "js_mason_in_cover_behind_log" },
    { 0x51A718E2, "js_mason_in_position_in_building" },
    { 0x82F72CBA, "js_mason_in_position_in_woods_drop_off_area" },
    { 0x1CC33E2D, "js_moving_to_stealth_house_enter" },
    { 0x1D61A11B, "js_player_enters_stealth_house" },
    { 0x870A6CB7, "js_treeguys" },
    { 0x32792737, "json" },
    { 0x8FF0396F, "jsut" },
    { 0xB54F0463, "jt" },
    { 0xC558438D, "jtt" },
    { 0xDE992033, "jttd" },
    { 0x57E6C89E, "judge" },
    { 0x11218361, "jug" },
    { 0xD9EF65EF, "jug_boss" },
    { 0x2F5D6120, "jug_spawner" },
    { 0x3F13993C, "jugg" },
    { 0xA8DFD91D, "jugg_ents" },
    { 0x26D18C3C, "jugg_used" },
    { 0x012514A9, "juggenaut" },
    { 0x8B6FED39, "jugger" },
    { 0xB3214AD3, "jugger_jingle" },
    { 0x99EE8FA7, "jugger_on" },
    { 0xFA1D88C9, "juggernaut" },
    { 0x91C6167D, "juggernaut_abandon_shield" },
    { 0x36E95C83, "juggernaut_abandon_shield_low_health" },
    { 0xDDF4F425, "juggernaut_client_field_func" },
    { 0xD46101A0, "juggernaut_code_callback_func" },
    { 0xA593037A, "juggernaut_damage_override" },
    { 0x500EB91E, "juggernaut_died" },
    { 0x7E119990, "juggernaut_goalheight" },
    { 0x956DB577, "juggernaut_goalradius" },
    { 0x49296DD6, "juggernaut_health" },
    { 0x94151459, "juggernaut_hunt_immediately_behavior" },
    { 0x23325851, "juggernaut_jumpedout" },
    { 0xA91AF3C2, "juggernaut_machine_active_model" },
    { 0x03DC5F54, "juggernaut_machine_disabled_model" },
    { 0xACD99FB7, "juggernaut_machine_light_fx" },
    { 0xF854749B, "juggernaut_mindamage" },
    { 0x79EBEBBE, "juggernaut_perk_bottle_weapon" },
    { 0xAE3B1730, "juggernaut_perk_cost" },
    { 0xD5821244, "juggernaut_perk_machine_setup" },
    { 0x9E164B07, "juggernaut_precache" },
    { 0x9CBCE143, "juggernaut_precache_override_func" },
    { 0xA4041D9A, "juggernaut_protect_behavior" },
    { 0xC00EAC33, "juggernaut_radiant_machine_name" },
    { 0xD361C845, "juggernaut_register_clientfield" },
    { 0xEA578652, "juggernaut_set_clientfield" },
    { 0x0E181BEF, "juggernaut_shader" },
    { 0xF46E3E8D, "juggernaut_sound_when_player_close" },
    { 0x5A6F4E2E, "juggernaut_spawned" },
    { 0x37060600, "juggernaut_sprintdistsq" },
    { 0xD33457DF, "juggernaut_sprintttime" },
    { 0x31616E6C, "juggernaut_vip_protect_spot_manager" },
    { 0x739E8BC0, "juggernauts" },
    { 0xDCBED8A7, "juggernog" },
    { 0x59B030B9, "juggernog_off" },
    { 0xCE46A7CD, "juggernog_on" },
    { 0xEAE3BAF3, "juggernog_sumpf_on" },
    { 0x5E2CB91A, "juke" },
    { 0x48DBD4B4, "juke_direction" },
    { 0xAD058604, "juke_distance" },
    { 0x7C5D60E7, "juke_distance_max" },
    { 0xC4452FDE, "juke_end_reason_collision" },
    { 0x19CD25B4, "juke_end_reason_enviormental" },
    { 0xBB04962F, "juke_end_reason_exceeded_time" },
    { 0x1FD58A40, "juke_end_reason_none" },
    { 0xB1BFCA82, "juke_end_reason_requested" },
    { 0x619DF818, "juke_end_reason_scripted" },
    { 0xEE4A08E4, "juke_initial_pause" },
    { 0xB895864E, "juke_min_anim_rate" },
    { 0xB3C1E0A0, "juke_offset" },
    { 0xC620EBAA, "juke_speed" },
    { 0x296ED07C, "jukeaction" },
    { 0x4DAF9B71, "jukeactionterminate" },
    { 0x59868845, "jukeanim" },
    { 0x414EE8C3, "jukeanimalias" },
    { 0xF1E8C5D9, "jukedirection" },
    { 0x9CC1DE3F, "jukedistance" },
    { 0xF88B5A01, "jukeevents" },
    { 0x780CA7DA, "jukeinfo" },
    { 0xA7E9532D, "jukelandpos" },
    { 0x7BA11DE1, "jukemaxdistance" },
    { 0x4B27A1B7, "jukenavmeshthreshold" },
    { 0xB0F22C23, "jukeprobability" },
    { 0x948C9015, "jukes" },
    { 0xE3935316, "jukestartangles" },
    { 0x11B475F9, "jukestate" },
    { 0xC6B82DC9, "jukevaliddistancetype" },
    { 0xE7C0926F, "jukevector" },
    { 0xF77C852B, "juking" },
    { 0x5FF0C27A, "julian" },
    { 0x56B0DEE7, "july" },
    { 0x3477DD92, "jumbled" },
    { 0x7F31F761, "jump" },
    { 0xC4B33175, "jump_across_120" },
    { 0x2D69B6A1, "jump_across_72" },
    { 0xD0776F44, "jump_angles" },
    { 0xD1CD3D53, "jump_anim" },
    { 0x5AEBAFD4, "jump_anim_trig" },
    { 0x6C7056B7, "jump_blocker_clip" },
    { 0xBAA0D8EB, "jump_button_monitor" },
    { 0xF41B40F8, "jump_chance" },
    { 0xA0671F59, "jump_complete" },
    { 0x93EBB0DF, "jump_cooldown" },
    { 0xDA820D69, "jump_count" },
    { 0x765FE08B, "jump_debris_align" },
    { 0xA16DE164, "jump_detonate" },
    { 0x0375BE24, "jump_done" },
    { 0x3AC79028, "jump_down" },
    { 0x48FDFD76, "jump_down_56" },
    { 0x8C592BF2, "jump_down_96" },
    { 0xC2179EA7, "jump_down_attack_player_started" },
    { 0x0AEA92F5, "jump_down_crawler" },
    { 0xD688D413, "jump_down_director" },
    { 0x23203D03, "jump_down_done" },
    { 0xA2DEA53E, "jump_down_end" },
    { 0xC15DC6AE, "jump_down_human" },
    { 0x71E42FB8, "jump_down_monkey" },
    { 0xAA41339B, "jump_down_player_done" },
    { 0x8D790CC2, "jump_down_player_started" },
    { 0xCAAF41EA, "jump_down_quad" },
    { 0xAA1716AD, "jump_down_start" },
    { 0xE42C4609, "jump_down_tag" },
    { 0x5B232E63, "jump_down_traversal" },
    { 0xF636962D, "jump_down_zombie" },
    { 0x5A04A583, "jump_during_running" },
    { 0xEEDE9A73, "jump_end" },
    { 0x4BA1ECCD, "jump_fail_check" },
    { 0xD5B1EEE7, "jump_fall_fail_think" },
    { 0x48269E0E, "jump_finished" },
    { 0x8B08668C, "jump_from_bridge" },
    { 0x983097E0, "jump_goggles" },
    { 0xEFC43431, "jump_goggles_cleanup" },
    { 0xFC09318B, "jump_goggles_listener" },
    { 0x8ABCFBDD, "jump_guy" },
    { 0xFEE913F7, "jump_hud" },
    { 0x22AD0C33, "jump_id" },
    { 0x9AE26370, "jump_info" },
    { 0x6841A4C1, "jump_land_heavy_triggers" },
    { 0x611BEB98, "jump_landing_thread" },
    { 0x08F3CBDD, "jump_node_start" },
    { 0x17F037A3, "jump_obj" },
    { 0xE861433E, "jump_off_trigger" },
    { 0x70E1F142, "jump_origin" },
    { 0x350F4550, "jump_out" },
    { 0x2D6E1DA0, "jump_out_of_truck" },
    { 0x3761EF99, "jump_outcome_set" },
    { 0x4EECA6AC, "jump_over_high_wall" },
    { 0x26F93F31, "jump_pad_activate" },
    { 0xD2DFA728, "jump_pad_cancel" },
    { 0x714696B1, "jump_pad_current" },
    { 0x3BE678D7, "jump_pad_enemy_follow_or_ignore" },
    { 0xECD679E4, "jump_pad_ignore_poi_cleanup" },
    { 0x9C135600, "jump_pad_init" },
    { 0x971DF385, "jump_pad_move" },
    { 0xB6B9CA67, "jump_pad_player_overrides" },
    { 0x354A4277, "jump_pad_player_variables" },
    { 0x262CDE6D, "jump_pad_previous" },
    { 0xE47389F6, "jump_pad_start" },
    { 0x9CB39753, "jump_pad_start_fx" },
    { 0xEB21D469, "jump_pad_store_movement_anim" },
    { 0xA26AF6C2, "jump_pad_think" },
    { 0x6094CD88, "jump_pad_throttle_anim_changes" },
    { 0x919A5041, "jump_pad_triggers" },
    { 0x4338DCB2, "jump_pads" },
    { 0x3D5D7A66, "jump_pitch" },
    { 0xB075E3E2, "jump_platform_force_death" },
    { 0x6B20A6A2, "jump_pos" },
    { 0xA755B8AE, "jump_pos_used_cooldown" },
    { 0x1AA41B34, "jump_requested" },
    { 0xCCB9EDB2, "jump_scare_lookat_point" },
    { 0x5E24C4CC, "jump_tag" },
    { 0xCE3D44F8, "jump_tag_radius_sq" },
    { 0x277B8C4E, "jump_the_gun" },
    { 0x7F90785E, "jump_through_window" },
    { 0x938566B2, "jump_through_window_angle" },
    { 0x478A50DC, "jump_through_window_human" },
    { 0x44D80E77, "jump_time" },
    { 0x02C1A9C4, "jump_time_2" },
    { 0x3FD3C9FF, "jump_to" },
    { 0x2FC5EF59, "jump_to_effect" },
    { 0xF423CB23, "jump_to_train_snapshot" },
    { 0xA2D6E5F0, "jump_trigger" },
    { 0x7C981392, "jump_up_crawler" },
    { 0x4EE7DBBD, "jump_up_monkey" },
    { 0xC648691B, "jump_up_quad" },
    { 0x2CF0EBA8, "jump_up_traversal" },
    { 0xDACA63F8, "jump_up_zombie" },
    { 0xF8773F65, "jump_velocity" },
    { 0x8F9486BD, "jump_was_enabled" },
    { 0xEE3A8D7E, "jumpangle" },
    { 0xF17AF0DC, "jumpback" },
    { 0xECD44E51, "jumpbuttonpressed" },
    { 0x96529AB1, "jumpchance" },
    { 0x2425991A, "jumpcut_to_space" },
    { 0x04A0CD4E, "jumpdir" },
    { 0xC66E16FC, "jumpdirection" },
    { 0x6584C7D4, "jumpdistancesq" },
    { 0x3490B495, "jumpdown" },
    { 0x699B3F2D, "jumpdown_96" },
    { 0x40CB364E, "jumped" },
    { 0xA4B552F3, "jumped_gap" },
    { 0x6B8AD7E0, "jumped_to_barge" },
    { 0x1421D44A, "jumpedout" },
    { 0x9FC40448, "jumpent" },
    { 0xFC94B148, "jumper" },
    { 0xEEE90693, "jumper_kill_trigger_think" },
    { 0xBF0AE55C, "jumperd" },
    { 0x059A3DB2, "jumpforce" },
    { 0x0DBE18CC, "jumpgoal" },
    { 0xB1F01B1C, "jumpheight" },
    { 0x04300B27, "jumping" },
    { 0x050E2F8A, "jumping_down" },
    { 0xC9A7E03E, "jumping_out" },
    { 0xADE159C6, "jumpingtoelev" },
    { 0x423E7790, "jumpingtowindow" },
    { 0x041B1985, "jumplandingrumble" },
    { 0x8BE96F5B, "jumpnum" },
    { 0x8FA2541B, "jumpoff_monitor" },
    { 0xB00F38B7, "jumpout" },
    { 0xBFF080A8, "jumpout_fx" },
    { 0x24DD62D4, "jumppad" },
    { 0x08402A17, "jumppipe_anim" },
    { 0x7559CD79, "jumppoint" },
    { 0x8AC8A508, "jumps" },
    { 0xD3EF7FFB, "jumpstart" },
    { 0xBCE3FCAA, "jumpstartposition" },
    { 0xB389BB4B, "jumptag" },
    { 0xE2706CB6, "jumptime" },
    { 0xD7C02302, "jumpto" },
    { 0x34ED03BB, "jumpto_boat" },
    { 0xEB450247, "jumpto_check" },
    { 0x33D8C1C8, "jumpto_complete" },
    { 0xCAA2AACC, "jumpto_e1_intro" },
    { 0xBB72A9AF, "jumpto_e2_trenchbattle" },
    { 0x0702FF36, "jumpto_e3_trenchdefense" },
    { 0x59978F71, "jumpto_e3b_law_battle" },
    { 0xB451CCF2, "jumpto_e4_hillbattle" },
    { 0x381A3CF3, "jumpto_e4b_uphillbattle" },
    { 0xE3837B73, "jumpto_e4c_woods_jam" },
    { 0x4B4184B4, "jumpto_e5_airfieldbattle" },
    { 0x3167E358, "jumpto_e5_siegeofkhesahn" },
    { 0xF7C3B26A, "jumpto_e5b_towbattle" },
    { 0x640F96ED, "jumpto_e6_siegeofkhesahn" },
    { 0xCF168D83, "jumpto_event2" },
    { 0x071C642E, "jumpto_event2_media" },
    { 0xBE8569EB, "jumpto_event2_strafe_boats" },
    { 0xA914131A, "jumpto_event3" },
    { 0x1B1B8255, "jumpto_event4" },
    { 0x6DCA8DEE, "jumpto_event4_part3" },
    { 0xF51907EC, "jumpto_event5" },
    { 0x67207727, "jumpto_event6" },
    { 0x7B06A432, "jumpto_fix" },
    { 0xEB185D6C, "jumpto_initial_zeroes" },
    { 0x9EA275B2, "jumpto_objective" },
    { 0xFF8F9149, "jumpto_override" },
    { 0x7901DC1C, "jumpto_snapshot_override" },
    { 0xE9CF5A62, "jumpto_speed" },
    { 0x5A1FF10A, "jumpto_string" },
    { 0xCBA8530D, "jumptoactor" },
    { 0xE63CF284, "jumptoinit" },
    { 0x689FC245, "jumptorandomtrig" },
    { 0xD540BA63, "jumptorandomtrigthink" },
    { 0xACA10E9B, "jumptorandomtype" },
    { 0xDF9C484D, "jumptos" },
    { 0x0028F2BB, "jumptosection" },
    { 0xA9A77F2E, "jumptothink" },
    { 0x0B846BAF, "jumpwaiter" },
    { 0xBB0B35B0, "jun" },
    { 0xDA803A99, "junction" },
    { 0xD79AACC6, "junctioned" },
    { 0x3F4BC350, "junctions" },
    { 0x002C3891, "juncture" },
    { 0x219FCF7D, "june" },
    { 0x1A03263C, "junes" },
    { 0x11DB4A8E, "jungle" },
    { 0xE22512BD, "jungle_approach" },
    { 0x905EEAD6, "jungle_approach_begins" },
    { 0xEF1F9380, "jungle_escape" },
    { 0x684EB134, "jungle_escape_accuracy" },
    { 0xEA7CFE93, "jungle_escape_anims" },
    { 0xA1627362, "jungle_escape_beartrap_animations" },
    { 0x68565215, "jungle_escape_begins_vo" },
    { 0x5678C1A2, "jungle_escape_can_do_autosave" },
    { 0x461C7DC0, "jungle_escape_enemy_chatter_battle_1" },
    { 0xB823ECFB, "jungle_escape_enemy_chatter_battle_2" },
    { 0xAD3D2B4A, "jungle_escape_enemy_chatter_battle_3_part_1" },
    { 0x873AB0E1, "jungle_escape_enemy_chatter_battle_3_part_2" },
    { 0x00ADD1CE, "jungle_escape_enemy_chatter_mg_truck" },
    { 0x2E6C0A07, "jungle_escape_enemy_chatter_retreat_1" },
    { 0xBC649ACC, "jungle_escape_enemy_chatter_retreat_2" },
    { 0xE2671535, "jungle_escape_enemy_chatter_retreat_3" },
    { 0x0C9407E1, "jungle_escape_enemy_vo" },
    { 0xAC97736D, "jungle_escape_spawn_func" },
    { 0xA4568F93, "jungle_escape_wave_2_vo" },
    { 0xC8F630B0, "jungle_escape_wave_3_vo" },
    { 0x1A6F8D1D, "jungle_explosions" },
    { 0x24A2E61A, "jungle_helicopter_support" },
    { 0xB0200E96, "jungle_patrol_function" },
    { 0x57F7916A, "jungle_stealth" },
    { 0x591FFF61, "jungle_stealth_anims" },
    { 0x4AC26F7A, "jungle_stealth_ent_clean_up" },
    { 0x63AF1CEC, "jungle_stealth_fails" },
    { 0x48F37838, "jungle_stealth_house_spawn_func" },
    { 0x8544F437, "jungle_stealth_log_ent_clean_up" },
    { 0x3C7A42E3, "jungle_stealth_log_main" },
    { 0xDA32D868, "jungle_stealth_log_skipto_clean_up" },
    { 0x5366694F, "jungle_stealth_skipto_clean_up" },
    { 0x12D18B52, "jungle_stealth_spawn_funcs" },
    { 0x05AEADF3, "junk" },
    { 0xBF60BC80, "junk purchased" },
    { 0x5ED1B490, "junk1" },
    { 0xD0D923CB, "junk2" },
    { 0xAAD6A962, "junk3" },
    { 0x37953C0E, "junk_2_falls_down" },
    { 0xE3E3700E, "junk_throw" },
    { 0xB9938DE4, "junk_to_dummy" },
    { 0xB396B094, "junkies" },
    { 0xAE0145F7, "junkyard" },
    { 0xFC3AE9D3, "junkyard_assault" },
    { 0xAD708CDB, "just" },
    { 0x24119685, "just_completed" },
    { 0xA8A0AD98, "just_day_number" },
    { 0xE29F65B0, "just_given_new_inventory_killstreak" },
    { 0xCBDCF259, "just_had_four_bombers" },
    { 0xFE86C0D0, "just_loop" },
    { 0x64EC1616, "just_max_stack_removed_inventory_killstreak" },
    { 0xDB4D1E9B, "just_removed_used_killstreak" },
    { 0x1F182CED, "just_setup" },
    { 0x84005C31, "just_switched" },
    { 0xBC4F15DE, "just_turned_off" },
    { 0x38E58B10, "just_turned_on" },
    { 0x6CE8764C, "just_used_dtp" },
    { 0x4FF9F2F7, "justchecking" },
    { 0x15B27AFA, "justdelete" },
    { 0xE9D7A68C, "justice" },
    { 0xEBFF79F3, "justify" },
    { 0xFF8FBF09, "justlooked" },
    { 0xA4E6111B, "justpulledgunout" },
    { 0x9B3340FF, "justspawned" },
    { 0x103364C6, "juststoredweapon" },
    { 0xF13DCA8C, "justtriggers" },
    { 0x5B9A6F5F, "justwaited" },
    { 0x694A0F91, "jv" },
    { 0xD14025ED, "jz" },
    { 0x7D5301E4, "k" },
    { 0x74256805, "k1" },
    { 0x9A27E26E, "k2" },
    { 0xAD1376F0, "k_allow_initial_spawn_logic_duration_milliseconds" },
    { 0xC31336FF, "k_button_a" },
    { 0x510BC7C4, "k_button_b" },
    { 0x6552EC2F, "k_button_back" },
    { 0xA0BAD07F, "k_button_lshldr" },
    { 0xAE6B52B2, "k_button_lstick" },
    { 0xA78F8AB0, "k_button_ltrig" },
    { 0xE1DA467D, "k_button_rshldr" },
    { 0xCBCE6654, "k_button_rstick" },
    { 0x47957E62, "k_button_rtrig" },
    { 0xC2AA2EB2, "k_button_start" },
    { 0x2D4C366E, "k_button_x" },
    { 0x534EB0D7, "k_button_y" },
    { 0xD91AEED6, "k_current_time" },
    { 0x14C3C675, "k_depth_test" },
    { 0x8D4F134F, "k_dpad_down" },
    { 0x5A297190, "k_dpad_left" },
    { 0x04D3DFBF, "k_dpad_right" },
    { 0x222C78A0, "k_dpad_up" },
    { 0x00229837, "k_draw_duration_server_frames" },
    { 0x3DF4900D, "k_favored_spawn_point_bonus" },
    { 0x288C781A, "k_getup" },
    { 0x817DBC8F, "k_mild_damage_health_percentage" },
    { 0xBDCC5BB2, "k_mild_damage_index" },
    { 0x0867C9F4, "k_moderate_damage_health_percentage" },
    { 0xE2B20EED, "k_moderate_damage_index" },
    { 0x052C7D02, "k_player_height" },
    { 0xED173ABE, "k_rotation_delta" },
    { 0x6454DD0A, "k_segment_count" },
    { 0x9DE57939, "k_severe_damage_health_percentage" },
    { 0x7A41CD44, "k_severe_damage_index" },
    { 0x05111B79, "k_total_damage_health_percentage" },
    { 0xEB23FA84, "k_total_damage_index" },
    { 0x949C5BB5, "ka" },
    { 0x940C2510, "kaboom" },
    { 0x11BD4312, "kabul" },
    { 0x59B4CE4A, "kabul_up" },
    { 0x828720B2, "kalashnikov" },
    { 0x5A19B48A, "kam" },
    { 0x8269FBCF, "kam_and_price_chat" },
    { 0xAD1D5EC2, "kam_gaz_fight" },
    { 0xA35687E9, "kam_node" },
    { 0xCAB23DC0, "kamarov" },
    { 0x30EA07A4, "kamarov_and_price" },
    { 0xB0626814, "kamikaze" },
    { 0x54CA1A88, "kamikaze_1" },
    { 0xC6D189C3, "kamikaze_2" },
    { 0x02C3A275, "kamikaze_dialogue" },
    { 0x6BD59FBE, "kamikaze_explode" },
    { 0xC771EEC0, "kamikaze_plane_go" },
    { 0x371661F0, "kamikaze_plane_splines" },
    { 0xD59B215A, "kamikaze_planes" },
    { 0xD29F35A0, "kamikaze_sound" },
    { 0xEC2E8A2D, "kamikaze_trigger" },
    { 0x67CDD538, "kamikazed" },
    { 0x020EFF75, "kar98k_scoped_zombie" },
    { 0xBF469D15, "kar98s" },
    { 0x89BC6A29, "kar_01" },
    { 0x8C8DE94C, "kar_01_render" },
    { 0xAFBEE492, "kar_02" },
    { 0xE87993BD, "kar_02_render" },
    { 0xD5C15EFB, "kar_03" },
    { 0x4E54F162, "kar_03_render" },
    { 0x8B7587B4, "karama" },
    { 0x39E16670, "karama_friendly_freewatch" },
    { 0xCA71A120, "karambit" },
    { 0x0B0F0666, "karambit_attack_guard1" },
    { 0xE50C8BFD, "karambit_attack_guard2" },
    { 0xF6DEB23F, "karambit_attack_in_progress" },
    { 0xD3158C94, "karambit_attack_woods" },
    { 0xD3C7861D, "karambit_dead" },
    { 0x069FFBA0, "karambit_drag_guard1" },
    { 0x318A0AF2, "karambit_drag_woods" },
    { 0x2B173C3A, "karambit_guard_1" },
    { 0x2C75EF7C, "karambit_guard_1_drag_fx" },
    { 0x0514C1D1, "karambit_guard_2" },
    { 0x20AC4E04, "karambit_guard_2_back_to_ai_to_kill_woods" },
    { 0xD21CF35D, "karambit_guard_2_gets_killed" },
    { 0x6C05F37A, "karambit_guard_killed_by_player" },
    { 0xEE8D594D, "karambit_guard_killed_by_player_before_woods_starts" },
    { 0x522BC2DF, "karambit_guard_player_fires_gun" },
    { 0x8A43731A, "karambit_intro_guard1" },
    { 0x6440F8B1, "karambit_intro_guard2" },
    { 0x7D1EC498, "karambit_intro_woods" },
    { 0x53044919, "karambit_melee_message" },
    { 0x8AD42148, "karambit_melee_message_cleanup" },
    { 0x801CFFBA, "karambit_melee_message_cleanup2" },
    { 0xFDCC616F, "karambit_music_stinger" },
    { 0x6DA15309, "karambit_stand_blood_now" },
    { 0x7138E7FB, "karambit_woods" },
    { 0x2B7E3BC0, "karambit_woods_should_die" },
    { 0x5E92AF13, "kard" },
    { 0x5823DEB4, "karez" },
    { 0x23807A8F, "karma" },
    { 0x1E6D8A7F, "karma2" },
    { 0x6261F21D, "karma2_hide_tower_and_shell" },
    { 0xC3455F42, "karma2_show_tower_and_shell" },
    { 0xE0B2D28F, "karma_1_enter_club" },
    { 0x669C72C0, "karma_1_intro" },
    { 0x927FA0AC, "karma_2" },
    { 0x8155753D, "karma_2_amb" },
    { 0x34C863F4, "karma_2_anim" },
    { 0x9048F492, "karma_2_art" },
    { 0x90788F05, "karma_2_fx" },
    { 0x00894721, "karma_2_gump_mall" },
    { 0xA61ED79C, "karma_2_gump_sundeck" },
    { 0xC040797A, "karma_2_gump_the_end" },
    { 0x1A5F2DE2, "karma_2_transition" },
    { 0xC906A83A, "karma_9_1_gate_lift_civ_run_to_path" },
    { 0xF319B614, "karma_9_1_gate_lift_hero_run_to_path" },
    { 0xFD9201F5, "karma_alive" },
    { 0xE014C811, "karma_alive_or_not" },
    { 0x970551D2, "karma_amb" },
    { 0x26D23905, "karma_anim" },
    { 0xC327ACD9, "karma_arrival" },
    { 0xB24B0481, "karma_art" },
    { 0x5D9DD758, "karma_captured" },
    { 0xE8E5A2C3, "karma_checkin" },
    { 0x8439854C, "karma_civilians" },
    { 0x14F0C045, "karma_closeup" },
    { 0x6AF0AD99, "karma_construction" },
    { 0x1540C58C, "karma_crc" },
    { 0xB11DCB48, "karma_crc_cam" },
    { 0x64B59CC7, "karma_cut_throat" },
    { 0xC215C924, "karma_death" },
    { 0x0B9ABB4D, "karma_dropdown" },
    { 0x7CBA293D, "karma_elevator_scene" },
    { 0x24FAABD1, "karma_enter_mall" },
    { 0x489E7B01, "karma_exit_club" },
    { 0x242C0953, "karma_fake_tracer" },
    { 0x6D33F7EB, "karma_fog_sunset" },
    { 0xF3D209B0, "karma_fx" },
    { 0x2A702596, "karma_gump_checkin_images" },
    { 0x551BFBFD, "karma_gump_club_images" },
    { 0xF9DD0EA8, "karma_gump_construction_images" },
    { 0x4A53408B, "karma_head_bruised" },
    { 0x5F773C6F, "karma_head_shot" },
    { 0x39BB6648, "karma_head_throat_cut" },
    { 0x7B7E0AA9, "karma_helpme" },
    { 0x6170CA9D, "karma_init_rusher_distances" },
    { 0xFD858924, "karma_inner_solar" },
    { 0xA4BD68A4, "karma_little_bird" },
    { 0x48A5FE1C, "karma_located" },
    { 0x2FAC863D, "karma_loop_aftermath" },
    { 0x98E67376, "karma_no_death_challenge" },
    { 0xD309BD6D, "karma_outer_solar" },
    { 0xC7AAF3B1, "karma_outro_begin" },
    { 0x0C891F06, "karma_poi" },
    { 0x27DC36B6, "karma_punch" },
    { 0x331D6394, "karma_remove_name" },
    { 0x248178C4, "karma_restore" },
    { 0x7809E5A5, "karma_sayswhoareyou" },
    { 0xBC67F73F, "karma_shot_blood" },
    { 0x78B5F454, "karma_spiderbot" },
    { 0x6A102418, "karma_stage" },
    { 0x4CC79288, "karma_sunset" },
    { 0xD268A44D, "karma_takeover" },
    { 0x265378B1, "karma_the_end" },
    { 0xD2D2E652, "karma_trigger" },
    { 0xA11A383E, "karma_util" },
    { 0x0D0B555E, "karma_utility" },
    { 0x3A14E3C2, "karma_vision" },
    { 0x8C3E4143, "karma_vitals_cam" },
    { 0x8A2ED3F3, "karmaatsmoke" },
    { 0x2CADD1AD, "karmahealth" },
    { 0x5ED3C5D3, "karmasquad" },
    { 0xFE6B0883, "kart" },
    { 0x911459FC, "kashmir" },
    { 0xEFE0B51B, "kat" },
    { 0xF3E245A8, "kat1" },
    { 0x65E9B4E3, "kat2" },
    { 0x955F990B, "katana" },
    { 0x76F75A6A, "katanas" },
    { 0x8F3C5CC3, "katy_rocket_run_sign" },
    { 0x0B713F3D, "katyusha" },
    { 0x890B34B7, "katyusha_id" },
    { 0x9081E8C3, "katyusha_intro_truck_center_trigger" },
    { 0x3661FAB7, "katyusha_intro_truck_left_trigger" },
    { 0x902622F9, "katyusha_intro_trucks" },
    { 0x46F0AD12, "katyusha_monitor" },
    { 0xF7BD7213, "katyusha_rocket_fire" },
    { 0xC0D4F690, "katyusha_trucks" },
    { 0xFE20D9D3, "katyusha_trucks_fire" },
    { 0xED78DCFC, "katyushas" },
    { 0xD7B4D31D, "kaylor" },
    { 0x74CC4B8B, "kb_locked" },
    { 0xEDEE1422, "kbkeys" },
    { 0x9CBC5FAE, "kbse" },
    { 0x5885DAA8, "kbss" },
    { 0xE0A15087, "kc" },
    { 0x7723AF09, "kc_icon" },
    { 0x211281D9, "kc_othertext" },
    { 0x60DC2732, "kc_skiptext" },
    { 0x8103B294, "kc_skiptext2" },
    { 0x9747CBB5, "kc_timer" },
    { 0xD68FF7A8, "kd" },
    { 0x78239021, "kdratio" },
    { 0x664F1166, "kdrew" },
    { 0xDA647636, "keating" },
    { 0x876FCDA4, "keen" },
    { 0xCBA652AA, "keep" },
    { 0x624FEE1A, "keep_ammo_full_down_zipline" },
    { 0x427C2819, "keep_angles" },
    { 0x5B57285F, "keep_asd_alive_challenge" },
    { 0x54078617, "keep_away" },
    { 0xC951FAC1, "keep_checking" },
    { 0x5FE5DF59, "keep_colors" },
    { 0x0A2E0910, "keep_commando_acog" },
    { 0x71A3DEA6, "keep_count" },
    { 0x1A04CF9A, "keep_deathcam" },
    { 0xF1E809A8, "keep_firing" },
    { 0xAA59BB11, "keep_firing_loop" },
    { 0xF9E4E2B6, "keep_firing_rockets" },
    { 0x11619444, "keep_flametank_alive" },
    { 0xBDF3F568, "keep_flying" },
    { 0xDF98850F, "keep_giving_the_player_ammo_till_sniper_over" },
    { 0x48A20304, "keep_grenade_bags_from_spawning" },
    { 0xD573FAFE, "keep_griefing" },
    { 0x8E145805, "keep_mason_in_lab" },
    { 0xC811BE96, "keep_max_ammo" },
    { 0x02B90C57, "keep_moving" },
    { 0x0303B9FD, "keep_moving_time" },
    { 0x6AF0092D, "keep_on_looping" },
    { 0x941EF148, "keep_other_gunners_target" },
    { 0x7489D9AD, "keep_pacing" },
    { 0xC227C556, "keep_perfect_aim" },
    { 0x52801498, "keep_perks" },
    { 0xCF0AE12D, "keep_player_in_boat" },
    { 0x7A665F99, "keep_playing_wake_fx" },
    { 0x38ABC8CB, "keep_power_constant" },
    { 0xC309CE2B, "keep_rain_fx_playing" },
    { 0xA5F22A1F, "keep_rushing_player" },
    { 0x59E86365, "keep_safe_til_flag" },
    { 0x23C9B617, "keep_scanner_on" },
    { 0x06566A1A, "keep_setting_water_fog" },
    { 0xF5F142D6, "keep_shooting_at_truck" },
    { 0x08ADDA14, "keep_some_light_on" },
    { 0x32A56DEB, "keep_tank_alive" },
    { 0xAAA5392D, "keep_the_red_flash" },
    { 0x27EC0531, "keep_thread" },
    { 0x05BEF24E, "keep_time" },
    { 0xC1B97A4E, "keep_track_of_achievement" },
    { 0x7E88E5B8, "keep_track_of_guys_hitting_me" },
    { 0x617CFB89, "keep_track_of_player_centroid" },
    { 0x208E5337, "keep_trigger" },
    { 0xAFA6E40B, "keep_trying_find_enemy" },
    { 0xC3688252, "keep_waiting" },
    { 0xBFFF2BA0, "keep_waveleader_in_check" },
    { 0xA52112E9, "keep_weapon" },
    { 0x4ACF9660, "keep_weapons" },
    { 0x2B1DE326, "keepaimingon45degturn" },
    { 0x5CE98A65, "keeparraykeys" },
    { 0xC7D2E1E9, "keepclaimednode" },
    { 0x416C7833, "keepclaimednodeandchoosecoverdirection" },
    { 0xE700239E, "keepclaimednodeifvalid" },
    { 0x2F83F469, "keepclaimednodeingoal" },
    { 0x10ECC88A, "keepclaimnode" },
    { 0x09A510B2, "keependyaw" },
    { 0xA38ED91B, "keepentityheadiconspositioned" },
    { 0x844796DB, "keeper" },
    { 0x2BC08A2E, "keepfiring_length" },
    { 0xB17FA286, "keeping" },
    { 0x72617AA8, "keepmodels" },
    { 0x527B9FF4, "keepmoving" },
    { 0xE19A8820, "keepnodeduringscriptedanim" },
    { 0x3A0B6665, "keeps" },
    { 0x18CC11B4, "keeptryingtomelee" },
    { 0x83CB8D29, "keeptryingtostrafe" },
    { 0x9116E7A1, "keepupwithnode" },
    { 0x1E27A005, "keepviewoncameradummy" },
    { 0xF32B8506, "keepwatchinglefttread" },
    { 0xCE3952BB, "keepwatchingrighttread" },
    { 0x222FCA7A, "keepweapon" },
    { 0x04C24FF5, "keepweapons" },
    { 0xA8C391E0, "keepwhileskipping" },
    { 0x1C6FEAB3, "kennedy" },
    { 0x3DCC8333, "kentucky" },
    { 0xFD5D6D79, "kepp" },
    { 0x9567571D, "kept" },
    { 0xC6966CE4, "kevin" },
    { 0x08F68F50, "kevin_is_tired" },
    { 0x2BB168A8, "kevind" },
    { 0x95EA6817, "kevins" },
    { 0xF54B9C82, "key" },
    { 0xAD92E75F, "key1" },
    { 0x3B8B7824, "key2" },
    { 0x831665B0, "key_chain" },
    { 0xCC5A1AD7, "key_door_trigger_visibility" },
    { 0x0020175E, "key_drop_timeout" },
    { 0xDA2EF742, "key_hint_print" },
    { 0x86361253, "key_index" },
    { 0x3F19708C, "key_local_offset" },
    { 0xA2813AD0, "key_name" },
    { 0xA7E476F0, "key_process_timeout" },
    { 0x05C6136A, "key_pulley" },
    { 0xAAD75EB2, "key_start_angles" },
    { 0xE494ECCC, "key_start_origin" },
    { 0x61817E94, "keyaction" },
    { 0x65A7F307, "keyactions" },
    { 0xB3ADC1D1, "keybinding" },
    { 0x71B4300A, "keyboard" },
    { 0x29C16C56, "keyboard_switched" },
    { 0x515F89F6, "keyboard_to_use" },
    { 0x94F1699B, "keyboard_use_trigger" },
    { 0x5644208C, "keycard" },
    { 0xDB716251, "keycard_attach_tag" },
    { 0x274F6726, "keycounts" },
    { 0x30424FFB, "keyframed" },
    { 0x28F23AD9, "keyhint" },
    { 0xFEA22974, "keyline" },
    { 0x1541FD0F, "keyname" },
    { 0x8CAA19D6, "keynames" },
    { 0x8F70512F, "keyobject" },
    { 0x4B3C0495, "keypad" },
    { 0xBEA16A02, "keypair" },
    { 0x38DEBB74, "keypressed" },
    { 0xB2B49A7B, "keypresses" },
    { 0xE22C8CCD, "keys" },
    { 0x1346D2DE, "keys1" },
    { 0xED445875, "keys2" },
    { 0x0CE80080, "keys_angles" },
    { 0x97601BA6, "keys_origin" },
    { 0xACD5E65F, "keysbuildable" },
    { 0x16282A47, "keyscreateglint" },
    { 0xBA1C38F8, "keysenable" },
    { 0xF9E34E5C, "keysrouteselectionzone" },
    { 0x58C6DC25, "keystring" },
    { 0x2964EC7F, "keytext" },
    { 0xC9D28E95, "keyvalue" },
    { 0x9112C586, "keyword" },
    { 0xE1016B39, "keywords" },
    { 0xB4978438, "khaaaaaaaaaaaaaan" },
    { 0x01169625, "khaaaaaaaaaaaaan" },
    { 0xBE12B9B1, "khe" },
    { 0xC084D016, "khe_sanh" },
    { 0x4A382A57, "khe_sanh_amb" },
    { 0xE1385FEA, "khe_sanh_anim" },
    { 0xF45D91A4, "khe_sanh_art" },
    { 0x2A69A125, "khe_sanh_base_snapshot" },
    { 0xC78D78A3, "khe_sanh_c130_snapshot" },
    { 0xBB7C9240, "khe_sanh_default" },
    { 0xF1CB02ED, "khe_sanh_die" },
    { 0x241ECAA2, "khe_sanh_e1b_set_fog_jeep" },
    { 0x6841D5EF, "khe_sanh_e1b_set_fog_vision_jeep_sequence" },
    { 0x5782151F, "khe_sanh_e3_end" },
    { 0xD5A30D66, "khe_sanh_end_cinematic" },
    { 0xFC3871E4, "khe_sanh_event1" },
    { 0x6E3FE11F, "khe_sanh_event2" },
    { 0x483D66B6, "khe_sanh_event3" },
    { 0x8A3102A9, "khe_sanh_event4" },
    { 0x27D2EE19, "khe_sanh_event4b" },
    { 0x642E8840, "khe_sanh_event5" },
    { 0xB04015B3, "khe_sanh_fx" },
    { 0x77251DE0, "khe_sanh_intro_snapshot" },
    { 0x2F85666F, "khe_sanh_obj_3d_detonator" },
    { 0x9C02B396, "khe_sanh_obj_3d_use" },
    { 0xE5FB264F, "khe_sanh_obj_fougasse_traps" },
    { 0xD1F2C793, "khe_sanh_obj_repel_assault" },
    { 0x91F2C129, "khe_sanh_obj_retake_hill" },
    { 0xAF7952C9, "khe_sanh_objectives" },
    { 0x7AC9B4E9, "khe_sanh_util" },
    { 0xD6EF41B8, "khe_sanh_woods_scene" },
    { 0x7B85432F, "khesanh" },
    { 0x77674FB0, "khesanh_barrel_01" },
    { 0xE96EBEEB, "khesanh_barrel_02" },
    { 0xC36C4482, "khesanh_barrel_03" },
    { 0x3573B3BD, "khesanh_barrel_04" },
    { 0x0F713954, "khesanh_barrel_05" },
    { 0xAC32F106, "khz" },
    { 0x48FE61CE, "kia" },
    { 0x1BAFBA97, "kick" },
    { 0xAB53E89F, "kick_ac_unit" },
    { 0x97447ABA, "kick_anime" },
    { 0xFCC9B23B, "kick_barrel_instruction" },
    { 0x2EC8E0B1, "kick_brooks_door" },
    { 0x3A3E1E9F, "kick_count" },
    { 0x07248AE9, "kick_damage" },
    { 0xD9BDCEFE, "kick_dist" },
    { 0xED0DA3B3, "kick_door1" },
    { 0x7B063478, "kick_door2" },
    { 0x1698C204, "kick_door_hangar" },
    { 0x090C2409, "kick_door_open" },
    { 0x9BC32636, "kick_door_opened" },
    { 0x1869C794, "kick_ent_door" },
    { 0xFE71B78D, "kick_face" },
    { 0x8113AF8C, "kick_gun" },
    { 0x05EBB352, "kick_harris_door" },
    { 0x2C569B3C, "kick_meat_monitor" },
    { 0x781E197F, "kick_meat_timeout" },
    { 0x2FF3A173, "kick_mortar_boards" },
    { 0x63E28926, "kick_node" },
    { 0x24B40F3D, "kick_off_betrayal_event" },
    { 0x7EFB142A, "kick_off_end_event" },
    { 0x807586F0, "kick_off_first_village_on_trigger" },
    { 0xB5EAAE8A, "kick_office_door1" },
    { 0x8FE83421, "kick_office_door2" },
    { 0x7D9AF997, "kick_open_comms_door" },
    { 0xFD162273, "kick_open_hut_door" },
    { 0x6185D68C, "kick_open_vent" },
    { 0x574E51CB, "kick_the_meat" },
    { 0xF82D7AD9, "kick_weaver_door" },
    { 0xCAAE8BF8, "kick_windshield_fx" },
    { 0xFC921077, "kickable" },
    { 0x0786C71B, "kickangles" },
    { 0xD53C844E, "kickback" },
    { 0x1E799D23, "kickdoor" },
    { 0x0120925C, "kicked" },
    { 0x0403A76A, "kicked_in_the_face" },
    { 0x426D652D, "kicked_someone" },
    { 0x54F3F6FA, "kicker" },
    { 0x6F945D75, "kickers" },
    { 0xA418F7CC, "kickifdontspawn" },
    { 0xE0811328, "kickifidontspawninternal" },
    { 0x807F7A49, "kicking" },
    { 0x43022B06, "kickness" },
    { 0x0D8008EF, "kicknode" },
    { 0x364CAA16, "kickoff" },
    { 0x71DEF54E, "kicks" },
    { 0xB66C4F78, "kickup" },
    { 0x58062728, "kickwait" },
    { 0xD6F6F293, "kid" },
    { 0x50B4AFFB, "kidding" },
    { 0xC0D7E5C2, "kids" },
    { 0x279694DB, "kilable" },
    { 0x521F8495, "kiling" },
    { 0x2992720D, "kill" },
    { 0x4B67B1F5, "kill_aa_gun" },
    { 0x81B648F5, "kill_aa_gun_sound" },
    { 0x26C957FF, "kill_accuracy" },
    { 0x6383FFF3, "kill_action_flag" },
    { 0x30658B92, "kill_admin_ai" },
    { 0x1B6A8580, "kill_advancer" },
    { 0xB1D9933A, "kill_after_bbison" },
    { 0xAE564DB7, "kill_after_resupply" },
    { 0x10B3AEEA, "kill_ai" },
    { 0x7D676CBA, "kill_ai_along_path" },
    { 0x260282AD, "kill_ai_array_by_targetname" },
    { 0x59C3EBC8, "kill_ai_claw" },
    { 0x18A1A64C, "kill_ai_close_to_btr" },
    { 0x8DB6FBD6, "kill_ai_engagement_distance_debug" },
    { 0x6A76C78E, "kill_ai_group" },
    { 0x83E5746D, "kill_ai_if_not_in_view_and_player_hit_trigger" },
    { 0x33CD42DF, "kill_ai_roof_claw" },
    { 0x7A70621C, "kill_ai_spread" },
    { 0x0C54DCAA, "kill_ai_street_claw" },
    { 0x97CDA392, "kill_ai_target" },
    { 0x726900D8, "kill_ai_target_pip" },
    { 0xB5732613, "kill_ai_with_flak_jacket" },
    { 0x82E58773, "kill_aigroup" },
    { 0xAD8CBC48, "kill_aigroup_ai" },
    { 0x48C4A946, "kill_aigroup_at_flag" },
    { 0x8FEECA04, "kill_aigroup_at_trigger" },
    { 0xB9035C86, "kill_all_ai" },
    { 0x48D79597, "kill_all_ai_of_deathflag" },
    { 0xC8DC3D4F, "kill_all_axis" },
    { 0x97FC6F84, "kill_all_axis_ai" },
    { 0xDFEF2D6A, "kill_all_axis_ai_bloody" },
    { 0xD0D5148A, "kill_all_capture_zombies" },
    { 0xEE12BCA4, "kill_all_enemies" },
    { 0x6CE1482C, "kill_all_engage_dist_debug" },
    { 0x1A0A64E2, "kill_all_living_enemies" },
    { 0x85CF85AB, "kill_all_ms_guys" },
    { 0x17F6173F, "kill_all_nazis" },
    { 0x27AE4550, "kill_all_on_turret" },
    { 0xE293F3BF, "kill_all_other_ai" },
    { 0x9C1C29F1, "kill_all_parkinglot" },
    { 0xC98D62E0, "kill_all_pending_dialog" },
    { 0x2171CF83, "kill_all_recapture_zombies" },
    { 0xFDC6C20D, "kill_all_relay_power" },
    { 0x4D505059, "kill_all_the_mfn_zombies" },
    { 0x552A0A27, "kill_all_visible_enemies" },
    { 0xE4C10557, "kill_all_visible_enemies_forever" },
    { 0xBF65E9E5, "kill_all_zombies" },
    { 0x520C4316, "kill_alley_tank" },
    { 0x7D35F75B, "kill_allies_near_dock" },
    { 0x33AB515A, "kill_ally" },
    { 0x41ABBB4B, "kill_ambient_drone_spawn_manager" },
    { 0x22811169, "kill_ambient_models" },
    { 0xEE748F2E, "kill_ambient_rockets" },
    { 0xB2BF2B02, "kill_ambient_tanks" },
    { 0x0478A554, "kill_ambient_vehicles" },
    { 0x9ABAB357, "kill_and_cleanup_ents" },
    { 0x691761BE, "kill_animscript" },
    { 0xBA938EBD, "kill_anteup_overclock_scorestreak_specialist" },
    { 0x6B9C1B4E, "kill_any_touching" },
    { 0xEA2C0E1D, "kill_anyone_touching_blocker" },
    { 0xFEBB3517, "kill_ar_target" },
    { 0x55225D02, "kill_ar_target_" },
    { 0x0017865D, "kill_area01_spawns" },
    { 0xDFB44AF0, "kill_area02_spawns" },
    { 0x5FB3B150, "kill_arena_vehicle" },
    { 0xA69F2794, "kill_argue_vo" },
    { 0x2B68F3C7, "kill_array" },
    { 0x41C200E5, "kill_assist" },
    { 0xBEF7612D, "kill_at_end_of_spline" },
    { 0xCF860171, "kill_attacker" },
    { 0xA694497E, "kill_attacking_drones" },
    { 0xCF92A874, "kill_audio_ent" },
    { 0x9BBEFB4B, "kill_auto_timer" },
    { 0x724BD662, "kill_axis_in_trigger" },
    { 0x27517A7B, "kill_axis_near_spot" },
    { 0x5ACE6D77, "kill_axis_tank_reminder" },
    { 0xC3737F5E, "kill_badplace" },
    { 0x1930518E, "kill_badplace_forever" },
    { 0x4FFEEFF9, "kill_base_horse" },
    { 0xB03947BF, "kill_beach_vehicles" },
    { 0xDEAD76C8, "kill_beginning_guys" },
    { 0x32B4E3AC, "kill_behind_player" },
    { 0x06DE0B09, "kill_bg" },
    { 0x59C709BA, "kill_binoculars" },
    { 0xB0D5FC53, "kill_bodyguard" },
    { 0x96FB7925, "kill_bomb_arming_guy" },
    { 0xD396BD74, "kill_bombers" },
    { 0x9731916D, "kill_bonuses" },
    { 0x5071497A, "kill_boost_if_active" },
    { 0x08E07117, "kill_bot" },
    { 0x558E40CE, "kill_bots" },
    { 0xDE7B0E84, "kill_bottom_arc" },
    { 0xCEA43C77, "kill_box_light_threads_" },
    { 0x00550794, "kill_breadcrumbs_at_goal" },
    { 0x715FC6C6, "kill_bridge_ambience" },
    { 0xAD9B9B91, "kill_bridge_threads" },
    { 0xF9ACE600, "kill_brush" },
    { 0x576E156C, "kill_brushes" },
    { 0x1F64531F, "kill_buttons" },
    { 0x0579526B, "kill_buzz" },
    { 0x8D696134, "kill_c4_equip_hint" },
    { 0x412AA4F0, "kill_c4_throw_hint" },
    { 0x90CE53EA, "kill_car" },
    { 0xA57F76AA, "kill_challenge_watch_think" },
    { 0xD21FCDA7, "kill_chamber_occupants" },
    { 0xC2EF17E6, "kill_chest_think" },
    { 0x50411E95, "kill_choose_open_craftable" },
    { 0x98FEB289, "kill_chopper" },
    { 0xE2ED6545, "kill_claw" },
    { 0x10FC4C1B, "kill_claymore_equip_hint" },
    { 0x0FDCF177, "kill_claymore_throw_hint" },
    { 0xF03FDE35, "kill_color" },
    { 0xD3F001EF, "kill_color_replacements" },
    { 0x17C55AF0, "kill_combat" },
    { 0xC3D501F0, "kill_confirm" },
    { 0xB32598EC, "kill_confirmed_cone_aware" },
    { 0x347664BB, "kill_confirmed_radius_aware" },
    { 0x020979AE, "kill_consume_player" },
    { 0xC87DF652, "kill_converg_time" },
    { 0xA2E9F135, "kill_convoy_guys" },
    { 0x04BAC27E, "kill_corpse_control" },
    { 0xDE8D541D, "kill_count" },
    { 0x314AA101, "kill_countdown" },
    { 0x198B8E77, "kill_countdown_timer" },
    { 0x873D40AE, "kill_counter_hud" },
    { 0x9799B6D8, "kill_crawler" },
    { 0x6987B59E, "kill_crouch_hint" },
    { 0x5CD45008, "kill_cry" },
    { 0x49B79F63, "kill_damage" },
    { 0x620C9292, "kill_damage_vo_duration" },
    { 0xC5A77B9B, "kill_damagetype" },
    { 0xED7BA92F, "kill_data_stream" },
    { 0xE80BC6B9, "kill_debris_prompt_thread" },
    { 0xE5254825, "kill_debug" },
    { 0xDADAF5FC, "kill_debug_print_emp_points" },
    { 0xF4F70330, "kill_deck_dialogue" },
    { 0x0E9EEC65, "kill_del_ai_array_thread" },
    { 0x8426F037, "kill_del_scr_array_thread" },
    { 0xF882795D, "kill_delay" },
    { 0x1C0AB3A4, "kill_detect_tracker" },
    { 0xEA8BCD30, "kill_dialog" },
    { 0xDD702319, "kill_dials" },
    { 0x29544327, "kill_digital_billboards" },
    { 0xEEBD3BDB, "kill_dirt" },
    { 0x6C8128CB, "kill_disconnect_failsafe_pad_poi_clean" },
    { 0xA2DED463, "kill_disconnect_paths_forever" },
    { 0xBC9105A2, "kill_disobedient_horse" },
    { 0x5F647E93, "kill_dist_sq" },
    { 0x97DEA133, "kill_dodamage_onhit" },
    { 0x41F7EE8E, "kill_dog" },
    { 0xCB0D208E, "kill_dog_spawners" },
    { 0x5AE30339, "kill_door_think" },
    { 0xA5C19C5A, "kill_driver" },
    { 0xBA2A94F8, "kill_drone_random" },
    { 0x4716906B, "kill_drone_trigger" },
    { 0xFA3E8939, "kill_drones" },
    { 0xBC0C5B53, "kill_drones_at_spawn" },
    { 0x3606392D, "kill_drones_challenge_spawnfunc" },
    { 0xE56DFAEB, "kill_duration_ms" },
    { 0x9403A665, "kill_during_breach" },
    { 0xE094D006, "kill_during_breach1" },
    { 0xBA92559D, "kill_during_breach2" },
    { 0xA2C0AEEC, "kill_dust" },
    { 0x3C2C79AA, "kill_e1_ambient_street_battle_drones" },
    { 0x7BDE35C6, "kill_e4_trans_drones" },
    { 0x2C29A692, "kill_e_01_apc_digbat_alley" },
    { 0x8BEEBC76, "kill_earlier_sections_now" },
    { 0x8A8C5499, "kill_edge_players_func" },
    { 0xBE3602B1, "kill_emergency_lights" },
    { 0x44BF1ABA, "kill_emp_challenge_spawnfunc" },
    { 0x0C4FCCF8, "kill_enemies" },
    { 0x10629997, "kill_enemies_in_dome_after_flag_pickup" },
    { 0xC9960660, "kill_enemies_triggers" },
    { 0x9AB1F6DE, "kill_enemy_in_tubes" },
    { 0x1A528696, "kill_enemy_scot_speed_control" },
    { 0xC10C5C42, "kill_engage_dist_debug_toggle_watcher" },
    { 0x05E5ADE6, "kill_engage_dists_watcher" },
    { 0xA0AAE6CC, "kill_entity_headicon_thread" },
    { 0xA896439E, "kill_equipment_slot_watcher" },
    { 0x63354FC2, "kill_event1_backtrack" },
    { 0x39DFD4F3, "kill_events" },
    { 0x258E7165, "kill_everyone_in_10" },
    { 0x3F536CA5, "kill_everyone_obj" },
    { 0x64BF99FC, "kill_everyone_you_can" },
    { 0x6505C1E4, "kill_excess_enemies" },
    { 0x49A7BB3B, "kill_exhaust_watcher" },
    { 0xB28BE2EE, "kill_expire_time_ms" },
    { 0xDFC351DF, "kill_exploder" },
    { 0xCDC2C7D7, "kill_exterior_guards" },
    { 0x352C7F42, "kill_fade" },
    { 0x2FC0BBE8, "kill_falling_to_death" },
    { 0x824A94F8, "kill_fanout_guys" },
    { 0x57B71A41, "kill_far_bridge" },
    { 0xB8508F14, "kill_farmer_thread" },
    { 0x43F54034, "kill_fasthands_gungho_sprint" },
    { 0x8D08601B, "kill_fighter" },
    { 0x596F2AD1, "kill_firefly_mover" },
    { 0x71426EF6, "kill_flag" },
    { 0x5005AC0B, "kill_flagcarry" },
    { 0x0CE3625A, "kill_flak88" },
    { 0x87D96AEC, "kill_flicker" },
    { 0xA8EA3F0A, "kill_flight_helmet" },
    { 0x1C7233D5, "kill_flybys_remotely" },
    { 0x8EBA4F92, "kill_force_behavior" },
    { 0xF41888A6, "kill_force_move_weaver" },
    { 0xA9F339E2, "kill_friendly_quadrotors" },
    { 0xF9A4B3D6, "kill_ft" },
    { 0x91AE9D7A, "kill_fx" },
    { 0xD8A8209F, "kill_fx_cleanup" },
    { 0x85D873A0, "kill_fx_if_target_revive" },
    { 0xFE7E2587, "kill_fx_on_demo_jump" },
    { 0x948DBB6E, "kill_fx_struct" },
    { 0xAFEF9B81, "kill_fx_thread" },
    { 0x0904DE0C, "kill_fxanim_catwalk1" },
    { 0xE4D312A5, "kill_gadget_camo_render_doreveal" },
    { 0xEC5041A3, "kill_gasmask" },
    { 0x80215010, "kill_gazebo_vo" },
    { 0xD86A0E59, "kill_get_gun_back_on_killanimscript_thread" },
    { 0xF9BD335A, "kill_getwet_spawnfunc" },
    { 0x6F365905, "kill_glasshouse_ai" },
    { 0x6C290F2D, "kill_globe_marker_fx" },
    { 0x56177132, "kill_globe_satellite_fx" },
    { 0xBC6BDF89, "kill_goal" },
    { 0x534D37CB, "kill_gunner_once_at_motel" },
    { 0xC68161B1, "kill_guy" },
    { 0xAD9EB9E2, "kill_guy_if_path_ends" },
    { 0xDD1C4E18, "kill_guys" },
    { 0xA81A9668, "kill_guys_in_array" },
    { 0xA512C6BA, "kill_guys_in_bunker" },
    { 0x7D45A73F, "kill_guys_in_local_column" },
    { 0x7F7153DA, "kill_guys_in_vol_119" },
    { 0x2E334414, "kill_hardwired_coldblooded" },
    { 0x88D8CF94, "kill_heart" },
    { 0x1CA6C6D0, "kill_heartbeat" },
    { 0xF0C4F861, "kill_heli_index" },
    { 0x5C982676, "kill_heli_last_warning_refresh_time" },
    { 0xDC101C13, "kill_heli_logic" },
    { 0xD587BE68, "kill_heli_progression" },
    { 0x122B9D50, "kill_heli_progression_triggers" },
    { 0xA14AAE5C, "kill_heli_progression_warnings" },
    { 0x5E2B0460, "kill_heli_triggers" },
    { 0xB0D2CC44, "kill_helicopters_challenge" },
    { 0x76825AC5, "kill_helis_with_truck_mg" },
    { 0x4E2D8DD4, "kill_helper_message" },
    { 0xEDE015C0, "kill_hill_rpgs" },
    { 0xEBB1B2FB, "kill_hint_text" },
    { 0x31F1133A, "kill_hitmarker_fade" },
    { 0x59DC87FF, "kill_horse" },
    { 0xBA665006, "kill_horses" },
    { 0x7B4928CB, "kill_hud_message" },
    { 0xAF2F521D, "kill_hud_message_in_time" },
    { 0xD6E8D4C8, "kill_hut_patrol" },
    { 0x18906C55, "kill_idle_thread" },
    { 0x5812B53E, "kill_ied" },
    { 0xE0026855, "kill_ied_total" },
    { 0xBB3CA813, "kill_if_fall" },
    { 0xB14C710D, "kill_if_falling" },
    { 0x3E3508CB, "kill_if_my_boat_dies" },
    { 0x9DA46DB6, "kill_if_path_ends" },
    { 0x6BBEE67F, "kill_in_cover_checks" },
    { 0x228FED7D, "kill_in_ten" },
    { 0x8A726FDF, "kill_inside_guys" },
    { 0xEA7D0979, "kill_insta_kill_upgrade_hud_icon" },
    { 0x040F8DB1, "kill_interrogation_room" },
    { 0xD96509D1, "kill_jolt" },
    { 0x517EC5C4, "kill_jump" },
    { 0x1EF0DDE9, "kill_jump_goggles" },
    { 0xF1194CEC, "kill_jungle_ais_later" },
    { 0x0D7458B0, "kill_karma" },
    { 0x06C89816, "kill_larry" },
    { 0xA7ED1AAB, "kill_launchtube_steam_fx" },
    { 0x7A4632F1, "kill_lines" },
    { 0x84DF1971, "kill_local_animcustoms" },
    { 0x27D88F21, "kill_lockon_screen_message" },
    { 0x680A64E5, "kill_long_death" },
    { 0xD0852C39, "kill_lowreadywatcher" },
    { 0x152EF843, "kill_magic_bullet_shield_town_friendlies" },
    { 0xDE771283, "kill_manager_first_arena_on_flag" },
    { 0x39A5E726, "kill_market_vo" },
    { 0x18E3C98A, "kill_mason_intro_pdf" },
    { 0x02D817F2, "kill_match_start_message" },
    { 0xBC04F3C2, "kill_me" },
    { 0xDE574B9C, "kill_me_after_this_trigger_with_delay" },
    { 0x455175E1, "kill_me_if_i_live" },
    { 0xB14A80D0, "kill_me_timer" },
    { 0x5DFA1C25, "kill_mechz_tag_in_use_cleanup" },
    { 0x918ECF5B, "kill_mgs" },
    { 0x6B9DFEB7, "kill_middle_mger" },
    { 0x2C3FE648, "kill_missile" },
    { 0xB2682202, "kill_monitor" },
    { 0xEA13C8BB, "kill_monkeys_with_gas" },
    { 0x17F4A4C1, "kill_my_guys" },
    { 0xB9D3E8DE, "kill_myself_shortly" },
    { 0xA8530106, "kill_nade_hint" },
    { 0xE30C3AB9, "kill_name" },
    { 0x2331D743, "kill_near_plant_engineer_hardwired_close_enough_distance" },
    { 0x13E2C41E, "kill_near_zombies" },
    { 0x2950D2FA, "kill_nixie_input" },
    { 0x368D1D64, "kill_node" },
    { 0x53CBB264, "kill_non_visable_parkinglot" },
    { 0x31C86391, "kill_noteworthy_group" },
    { 0x74205F09, "kill_objective" },
    { 0xE1FBC584, "kill_objects" },
    { 0x9E9143A9, "kill_off_rooftop_germans" },
    { 0x99DED03C, "kill_off_sampan" },
    { 0x9D2AA6BA, "kill_off_standoff_seals" },
    { 0x28B51BDD, "kill_off_tanks" },
    { 0x62259AF2, "kill_off_village_vignettes" },
    { 0xE3F7F899, "kill_off_young_soldier" },
    { 0x3039565A, "kill_old_dialog" },
    { 0x4FD962EF, "kill_on_boat_death" },
    { 0x2EB9B547, "kill_on_goal" },
    { 0x8105F589, "kill_on_hit" },
    { 0x9E583CDD, "kill_on_notify" },
    { 0x9AD87666, "kill_on_player_vehicle_swap" },
    { 0x3A01D19F, "kill_on_wine_coccon" },
    { 0x1E05EFE6, "kill_origin" },
    { 0xAD0B25BD, "kill_other_gun_anim_threads" },
    { 0xA1E9D8D7, "kill_overlap_time" },
    { 0x21CF6C90, "kill_overlay_at_match_end" },
    { 0x5B8AB799, "kill_pa" },
    { 0xBDF5DCA5, "kill_passengers_notify" },
    { 0xC5400502, "kill_patrol" },
    { 0x5405DDD9, "kill_pby_running_lights" },
    { 0x3962EC94, "kill_pending_dialog" },
    { 0x8599D7D2, "kill_persist_damaged_tanker" },
    { 0x9DD1A839, "kill_phalanx_cannons" },
    { 0x4006096F, "kill_player" },
    { 0x4A4CDD78, "kill_player_after_time" },
    { 0x1B193088, "kill_player_battle_1_for_not_advancing" },
    { 0x5E6478E7, "kill_player_battle_2_for_not_advancing" },
    { 0xF2E5FA87, "kill_player_carry" },
    { 0x5B4A0BDF, "kill_player_dog_logic" },
    { 0x671BCF3C, "kill_player_door_guard" },
    { 0xE6A7EA60, "kill_player_driver" },
    { 0x3D517AEF, "kill_player_early" },
    { 0x798D473D, "kill_player_for_delaying" },
    { 0x7BDA3FDF, "kill_player_hut_enabled" },
    { 0xDD896FD9, "kill_player_hut_for_not_advancing" },
    { 0xD87C5893, "kill_player_if_linger" },
    { 0x8811CCBF, "kill_player_if_not_escaped" },
    { 0xD9474732, "kill_player_if_run_over" },
    { 0x1D983946, "kill_player_if_standing_inside_volume" },
    { 0x35066A4E, "kill_player_if_under_crane" },
    { 0xD2E5E17A, "kill_player_in_huey_if_he_waits" },
    { 0x86BCF333, "kill_player_in_tubes" },
    { 0xF3F98124, "kill_player_in_x_sec" },
    { 0x54575C31, "kill_player_on_timeout" },
    { 0xC33DD5FD, "kill_player_on_touch" },
    { 0x723C0314, "kill_player_outside_volume" },
    { 0xD015D519, "kill_player_regular_logic" },
    { 0xD8370958, "kill_player_rpg_logic" },
    { 0x617587B6, "kill_player_timer_flag" },
    { 0x69CE3934, "kill_player_wave1_enabled" },
    { 0xEA66C083, "kill_player_wave2_enabled" },
    { 0x62892CE6, "kill_player_with_mortar" },
    { 0x510DD348, "kill_players_under_pillar" },
    { 0x8F35D364, "kill_poi" },
    { 0x8BEBA4A3, "kill_power_cell_fx" },
    { 0x22C239BA, "kill_pre_building_collapse_drones" },
    { 0x015CFC4A, "kill_press_monitor" },
    { 0x8EAB6E9F, "kill_previous_show_equipment_hint_thread" },
    { 0x089F3AB6, "kill_prone_hint" },
    { 0x858D4899, "kill_radio" },
    { 0xE32B3612, "kill_radius" },
    { 0x1336EFA2, "kill_ragdoll_corpse_control" },
    { 0x864C4983, "kill_raise_model_fx" },
    { 0xD8CC9713, "kill_ramp_in_out_thread_hold_func" },
    { 0x33DEEEE7, "kill_realtime_engagement_distance_debug" },
    { 0xECE82330, "kill_rebel" },
    { 0xF58BA2BD, "kill_remaining_enemies" },
    { 0x8F349ADF, "kill_remaining_hill_enemies" },
    { 0xD244D92B, "kill_remaining_outside_guys" },
    { 0x6A46050F, "kill_resonate" },
    { 0xAA29F573, "kill_respin_respin_think_thread" },
    { 0x06075285, "kill_respin_think_thread" },
    { 0x2C22882A, "kill_rest" },
    { 0x36FE7898, "kill_rider" },
    { 0x3DB4D473, "kill_riders" },
    { 0xA27A1098, "kill_riders_counted" },
    { 0xDC6C2D7C, "kill_riders_total" },
    { 0xC2A8017E, "kill_roof_ais" },
    { 0x9C90EB03, "kill_rooftop_ignore_groups" },
    { 0x2D9696E8, "kill_round" },
    { 0x09D92CE1, "kill_rpg_guy" },
    { 0x5123CF5C, "kill_rpgs" },
    { 0xE522D116, "kill_rts_squad" },
    { 0x1BC5426F, "kill_rumble_forever" },
    { 0xF1451D69, "kill_russian_chatter" },
    { 0x4476B212, "kill_satellites" },
    { 0x7BE398C7, "kill_save" },
    { 0xF02C947A, "kill_scanner_gun_logic" },
    { 0xC01B8CFA, "kill_scavenger_tracker_resupply" },
    { 0x88C8B425, "kill_scene_subs_thread" },
    { 0x8D804A8E, "kill_self" },
    { 0x6A92A4B7, "kill_self_if_falls" },
    { 0xB77F2846, "kill_shielded_price" },
    { 0xCF531220, "kill_shoot_thread" },
    { 0x3F8F39A0, "kill_shot" },
    { 0x007B4C2F, "kill_shovelers" },
    { 0x8EFFB98D, "kill_sign_completed" },
    { 0xCEF326BF, "kill_siren" },
    { 0x68907BB0, "kill_sliding_doors" },
    { 0x14487A73, "kill_smoker" },
    { 0x4ED16A61, "kill_sndvonotifydtp" },
    { 0xF33456B9, "kill_sndvonotifyplain" },
    { 0xCD69CDFD, "kill_sound" },
    { 0x6CA625AC, "kill_spawner" },
    { 0x01E8A5C5, "kill_spawner_trigger" },
    { 0x0847149C, "kill_spawnernum" },
    { 0xADD0841F, "kill_spawners_with_destructible" },
    { 0xA4FEFA59, "kill_speed_manager" },
    { 0x1B674532, "kill_spinning_ambulence_fx" },
    { 0x82A860AB, "kill_spot_circle" },
    { 0xB54CFA04, "kill_spotlight" },
    { 0x40B3E6F7, "kill_spotlight_circle" },
    { 0x1845B775, "kill_spotlight_sc" },
    { 0xFD6EC2B7, "kill_spotlights" },
    { 0x0DB8B96C, "kill_sprint_hint" },
    { 0x7097EDC6, "kill_squad" },
    { 0xDF275550, "kill_staircase_spawn_trig" },
    { 0x75B81800, "kill_stand_hint" },
    { 0xF63F64B9, "kill_stand_think" },
    { 0xDB1CD916, "kill_start_chest" },
    { 0xECB58189, "kill_stats" },
    { 0xD17010D6, "kill_streak" },
    { 0x442E4749, "kill_streaks" },
    { 0xBC89931E, "kill_streakstime" },
    { 0x1071F3FA, "kill_stupid_vehicle_threads" },
    { 0x9A571CE0, "kill_substation_guard" },
    { 0xBC01CBC3, "kill_sundial_monitor" },
    { 0x4C9734E7, "kill_supress_time" },
    { 0x857BE6D8, "kill_sway" },
    { 0x3D1C8160, "kill_tank" },
    { 0x265E0D0B, "kill_tanks" },
    { 0xA2C7E7B7, "kill_target_detection" },
    { 0x4951E2C3, "kill_teargas" },
    { 0x1CDEFCEF, "kill_teargas_after_duration" },
    { 0x9527A62B, "kill_temp_dialogue" },
    { 0x9AE21595, "kill_the_radio" },
    { 0x5BFCBDE6, "kill_them_all" },
    { 0x01A27FAA, "kill_third_timeout_fail" },
    { 0x95C4B80F, "kill_this_thread" },
    { 0x4AA8FC8B, "kill_thrasher_on_auto_revive" },
    { 0xFC2828D7, "kill_thread_test_mode" },
    { 0xB77C78F6, "kill_three_enemies_with_motar_beartrap_challenge" },
    { 0x741ADEBB, "kill_time" },
    { 0xA3285CA9, "kill_timeout" },
    { 0x2D793BC3, "kill_timer" },
    { 0x18E8DC1F, "kill_toucher_until_msg" },
    { 0x2BF2E0AC, "kill_toucher_until_stop" },
    { 0x5A911F90, "kill_track_staff_weapon_respawn" },
    { 0x4036BE34, "kill_tracker" },
    { 0xF6B5F3AD, "kill_tracker_sixthsense" },
    { 0xF39FB9AF, "kill_transport" },
    { 0xB85E3AF6, "kill_transports" },
    { 0x95B38A64, "kill_trapped_zombies" },
    { 0x9E238E7B, "kill_treads_forever" },
    { 0x41EE9095, "kill_tree_behavior" },
    { 0x07D1709D, "kill_tree_snipers" },
    { 0xEC612C4E, "kill_trig" },
    { 0x70844583, "kill_trig1" },
    { 0xFE7CD648, "kill_trig2" },
    { 0xEF2A55B4, "kill_trig_name" },
    { 0x01A504D3, "kill_trig_watcher" },
    { 0xDE006674, "kill_trigger" },
    { 0x3494FBDC, "kill_trigger_spawn" },
    { 0xA51DEAF1, "kill_trigs" },
    { 0xFE475D14, "kill_truck_gunners" },
    { 0xA56D577B, "kill_turret_detach_thread" },
    { 0x43131AC4, "kill_typing_thread" },
    { 0x2C3AADA9, "kill_underground_grenade_scene" },
    { 0x00AA0D85, "kill_units" },
    { 0x30C0C5C3, "kill_unload_que" },
    { 0x3A1B8E87, "kill_unload_que_single_vehicle" },
    { 0x5888B234, "kill_upper_bridge" },
    { 0xA61F83C8, "kill_upper_house_enemies" },
    { 0x543527B0, "kill_vehicle" },
    { 0x1B94ECC5, "kill_vehicle_on_flag" },
    { 0x0D055046, "kill_vig_guy_1" },
    { 0xE702D5DD, "kill_vig_guy_2" },
    { 0x049419E0, "kill_visionset_triggers" },
    { 0x29967F0B, "kill_vo_spacing" },
    { 0x298789A4, "kill_waitfortimeouthacked_thread" },
    { 0x7C3E3014, "kill_warroom_bink" },
    { 0x6786257C, "kill_wave2_trig" },
    { 0x6C68B3D5, "kill_wave_one_rpgs" },
    { 0xB984997C, "kill_weapon" },
    { 0x5BB7B7EC, "kill_weapon_movement" },
    { 0xEC307CA1, "kill_wrapper" },
    { 0x6F16C68A, "kill_z" },
    { 0x524C7139, "kill_zapper_proximity_warning" },
    { 0x840DC7BA, "kill_ziptie_scene_threads" },
    { 0xB9478E82, "kill_zombies_depot" },
    { 0x95B239D2, "kill_zone" },
    { 0x0740E851, "killable" },
    { 0x01EA538D, "killaionuse" },
    { 0x11910D89, "killambientelementthread" },
    { 0x3509C6FF, "killanimscript" },
    { 0xC2A07D06, "killanimscripts" },
    { 0x00B9ED5D, "killasd_challenge" },
    { 0x00BE5F75, "killatend" },
    { 0x416C0D45, "killbloodoverlay" },
    { 0x080ED027, "killbrush" },
    { 0x7B95F79A, "killbrusharray" },
    { 0xB4D6E013, "killbrushes" },
    { 0x5DB6C055, "killbrushwatcher" },
    { 0xE13674DB, "killbushes" },
    { 0x27E266D0, "killby_interdimensional_gun_hole" },
    { 0x367908B2, "killcam" },
    { 0xA15DF744, "killcam_begin" },
    { 0xCB59A5B8, "killcam_end" },
    { 0x8974848C, "killcam_entity" },
    { 0xFD74E6DB, "killcam_entity_info" },
    { 0xFB9130F4, "killcam_entity_info_cached" },
    { 0x72013E26, "killcam_hud_off" },
    { 0xB9F3F3C6, "killcam_move" },
    { 0xA4B9BC06, "killcam_shared" },
    { 0xA4DE6FCC, "killcam_visionset_player_mismatch" },
    { 0x5BF01B99, "killcam_visionset_vehicle_mismatch" },
    { 0x7A4E142F, "killcamcount" },
    { 0xEC9E5B09, "killcament" },
    { 0x50C4B1D7, "killcamentai" },
    { 0xD96E388B, "killcamentindex" },
    { 0xC4A9D40B, "killcamentities" },
    { 0x96359B6F, "killcamentity" },
    { 0x3096B681, "killcamentityindex" },
    { 0x6D42C33A, "killcamentitystarttime" },
    { 0x9B2871BE, "killcamfalltime" },
    { 0xE96D785E, "killcamindex" },
    { 0x98975AC9, "killcamkilledbyent" },
    { 0xB1B54096, "killcamlength" },
    { 0x7374E1CE, "killcammod" },
    { 0x796447DA, "killcammoveto" },
    { 0x8111B9B3, "killcamoffset" },
    { 0xEC5E8F3D, "killcams" },
    { 0x37A32CC9, "killcamsettings" },
    { 0x8AE7E707, "killcamsskipped" },
    { 0x11162F4D, "killcamstarttime" },
    { 0xEE059A50, "killcamtargetentity" },
    { 0xD9DD0142, "killcamweapon" },
    { 0xE6CAF80C, "killcarrierbonus" },
    { 0xD5D6F166, "killclaw_challenge" },
    { 0x8511D33A, "killclientradiantexploder" },
    { 0x758B65C7, "killclones" },
    { 0xF926D425, "killcloudcover" },
    { 0x1901B952, "killcount" },
    { 0x7DBBCD03, "killcounter" },
    { 0x24FDFFEA, "killdamage" },
    { 0xDD9C91F1, "killdialog" },
    { 0x03DF3E8D, "killdist" },
    { 0x6AAED0C8, "killdistance" },
    { 0x21CA82D2, "killdrones_challenge" },
    { 0x7155C0B3, "killdtpmonitor" },
    { 0x48F5BB3A, "kille_ridge_vcs_quickly" },
    { 0x39D3D8BA, "killed" },
    { 0x9696A8AD, "killed all targets" },
    { 0x12B3B846, "killed_50cal" },
    { 0x6ECC9F0E, "killed_a_player" },
    { 0x404982D1, "killed_a_zombie_player" },
    { 0xB9654341, "killed_attacker_index" },
    { 0x9AA7A86A, "killed_by" },
    { 0x8EFB93B9, "killed_by_a_blundersplat" },
    { 0xAE0E5A53, "killed_by_decoy" },
    { 0x1E7AE0AF, "killed_by_harper" },
    { 0xF5B2B614, "killed_by_horse" },
    { 0x815DE198, "killed_by_human" },
    { 0x262F04F6, "killed_by_player" },
    { 0x2914615F, "killed_by_player_func" },
    { 0x98ECC8BB, "killed_by_player_only" },
    { 0x07BF6E27, "killed_by_rainfire" },
    { 0xF7D1459E, "killed_by_shield" },
    { 0x1FD8EEA8, "killed_by_sniper" },
    { 0x0DC66F60, "killed_by_sword" },
    { 0xABE71657, "killed_by_turret" },
    { 0xAB661CB9, "killed_by_woods" },
    { 0x65088DA3, "killed_by_zombie" },
    { 0x7B9C6516, "killed_count" },
    { 0x021BBCB5, "killed_defender_index" },
    { 0x30F300D1, "killed_enemy_player" },
    { 0x30544593, "killed_heli_with_truck_mg" },
    { 0x0E306718, "killed_helis" },
    { 0xB9BC51D8, "killed_hud" },
    { 0xC3851653, "killed_menendez" },
    { 0x5B910B26, "killed_player" },
    { 0xC667A059, "killed_players" },
    { 0x4D972819, "killed_pos" },
    { 0xFF3848F9, "killed_rusky" },
    { 0xFDB1ED13, "killed_something_thq" },
    { 0x80AC2219, "killed_stragglers" },
    { 0x4DC63EEF, "killed_this_wave" },
    { 0x40633A09, "killed_total" },
    { 0xC8F88EC3, "killed_while_rappelling" },
    { 0xDDA811A7, "killed_with_only_tomahawk" },
    { 0xA5B03FA4, "killed_with_trespasser" },
    { 0xAAB66249, "killedaxis" },
    { 0xE3472B9C, "killedbasedefender" },
    { 0xCB44EBA2, "killedbaseoffender" },
    { 0x9EE22DCF, "killedbestenemyplayer" },
    { 0x5BD36376, "killedbombcarrier" },
    { 0xC9945215, "killedby" },
    { 0x5D2AD1EF, "killedbyenemy" },
    { 0x459D379C, "killedbyname" },
    { 0x03706BDF, "killedbynames" },
    { 0xDCC270C4, "killedbysniper" },
    { 0x609A27EF, "killedcustomtraversallistener" },
    { 0xEFBB1F74, "killeddog" },
    { 0xC080B7F5, "killedexplosionfx" },
    { 0xF67D22C4, "killedflagcarrier" },
    { 0x233AD5AB, "killedguy" },
    { 0x002A6156, "killedheroweaponenemy" },
    { 0x350DCBB8, "killedinuse" },
    { 0xE4230FE3, "killedlastcontester" },
    { 0xD415B847, "killedname" },
    { 0xAA1E043E, "killednames" },
    { 0x6D27A2F6, "killednemesis" },
    { 0xF25C29C5, "killedplayer" },
    { 0x79E6AB54, "killedplayers" },
    { 0xB75DFE9B, "killedplayerscurrent" },
    { 0x29461593, "killedplayerwithgungho" },
    { 0xFF848CBB, "killedsofar" },
    { 0xB73F6D0B, "killedstunnedvictim" },
    { 0x745A90A1, "killedzoneattacker" },
    { 0x5FD65323, "killee" },
    { 0x12440B07, "killemp_challenge" },
    { 0xC7A6AB51, "killempmonitor" },
    { 0xF668BD18, "killentity" },
    { 0xE600741C, "killer" },
    { 0xAF469288, "killer_fail_init" },
    { 0x8F0D2EA8, "killer_spawners" },
    { 0x284CF0A5, "killerheropoweractive" },
    { 0xAD65BA46, "killerinvictimfov" },
    { 0x74580782, "killerkillstreakeventindex" },
    { 0xB17272FE, "killerkillstreakweaponindex" },
    { 0x4FFBFC28, "killerloadoutindex" },
    { 0xA92E1ABA, "killerorigin" },
    { 0xFFA8A95F, "killers" },
    { 0xC226B8EF, "killershearvictim" },
    { 0xDC4295F7, "killerwasads" },
    { 0x84DAC78F, "killerweaponpickedup" },
    { 0x185B2806, "killexplodertridgers" },
    { 0x15683A6D, "killflashmonitor" },
    { 0x835A2F7B, "killfx" },
    { 0x6A45E8B4, "killfxstruct" },
    { 0x29A51BCE, "killguy" },
    { 0x4F52065B, "killhackermonitor" },
    { 0xAB1FAFAB, "killhouse" },
    { 0xF948188E, "killhouse_amb" },
    { 0xB1258B21, "killhouse_anim" },
    { 0x2FA7B36D, "killhouse_art" },
    { 0xDE61981D, "killhouse_code" },
    { 0xFC1CB0D4, "killhouse_fx" },
    { 0xFA52AB58, "killhouse_introscreen" },
    { 0x84984C12, "killhurtcheck" },
    { 0xAC197C3F, "killindex" },
    { 0x80B0111B, "killing" },
    { 0xF8D76693, "killingsuicideattackers" },
    { 0xCFB1B9E6, "killit" },
    { 0x4CF00AE9, "killlinkhash" },
    { 0x751AE461, "killlinklist" },
    { 0x2D735040, "killlinks" },
    { 0xAF94A42D, "killlinkstrings" },
    { 0x1E58F74D, "killllll" },
    { 0x0363839E, "killmantlemonitor" },
    { 0xE93F530B, "killme" },
    { 0x6459A793, "killme_ontrig" },
    { 0x6A1DF1A4, "killme_reminder" },
    { 0x2BACE8CE, "killmeonscriptinterrupt" },
    { 0xB994D80C, "killmestring" },
    { 0x69A47D0B, "killminemover" },
    { 0x803BCBD8, "killminemoveronpickup" },
    { 0x54BB13DD, "killmonitorreloads" },
    { 0x9A0F462E, "killnotify" },
    { 0x14D60444, "killoff" },
    { 0x7156AD3A, "killondeathmonitor" },
    { 0xB5FB9E18, "killonimpact_speed" },
    { 0x28D1A014, "killonimpact_time" },
    { 0x2D60A838, "killonpainmonitor" },
    { 0x20BEA989, "killorg" },
    { 0x46A6757A, "killplayer" },
    { 0xA8F85FB0, "killplayersprintmonitor" },
    { 0xE0B56725, "killradiantexploder" },
    { 0x23671B0C, "killreplaygunmonitor" },
    { 0xD9986A69, "killroomtonefadeouttimer" },
    { 0xEC0B278C, "kills" },
    { 0xFB1C13E3, "kills_after_sprint_fasthands" },
    { 0x02855FEB, "kills_as_claw" },
    { 0xA1FE2D84, "kills_as_claw_total" },
    { 0x56495B92, "kills_counteruav_emp_hardline" },
    { 0xC49A2012, "kills_end" },
    { 0x550C05EF, "kills_enemies_then_wounds_price_then_leaves" },
    { 0xB9EC65AD, "kills_for_powerup" },
    { 0xC326A9FA, "kills_in_ten" },
    { 0x1C55E915, "kills_index" },
    { 0x2C668070, "kills_killstreak_index" },
    { 0x7DC056AD, "kills_remaining" },
    { 0xCD6DE8EA, "kills_specialist_weapon_index" },
    { 0x75CA41C9, "kills_start" },
    { 0xEC2F6FE4, "kills_to_achieve" },
    { 0x0AB25387, "kills_weapon" },
    { 0x19FBA777, "killsconfirmed" },
    { 0x475C83ED, "killsdenied" },
    { 0xBD9FC423, "killself" },
    { 0xB2E858FC, "killserver" },
    { 0x0EDE26A7, "killserverpc" },
    { 0xF82BE36E, "killspawn" },
    { 0x35BA9D0D, "killspawn_player_spawns" },
    { 0xC74B9FB1, "killspawned" },
    { 0x0B8224B7, "killspawner" },
    { 0xC645A484, "killspawner_2" },
    { 0x4EC3516D, "killspawner_after_trig" },
    { 0x236815ED, "killspawner_bridge" },
    { 0x9EE4D0B0, "killspawner_intro" },
    { 0xD341319A, "killspawner_num" },
    { 0x1D155F44, "killspawner_on_trigger" },
    { 0x3354ACBE, "killspawner_onspawn" },
    { 0x03EB7681, "killspawner_seal_support" },
    { 0x841AC818, "killspawner_security" },
    { 0xA518B780, "killspawner_smoketown_house" },
    { 0x5F5C6108, "killspawner_trig" },
    { 0x9ABA9FEE, "killspawners" },
    { 0x80C60F54, "killspawnmonitor" },
    { 0xD5DACC91, "killspawns" },
    { 0x4113B817, "killsrequired" },
    { 0x463E2EBB, "killstreak" },
    { 0x086A2248, "killstreak1" },
    { 0x7A719183, "killstreak2" },
    { 0x546F171A, "killstreak3" },
    { 0x3784B5C4, "killstreak_30_noscorestreaks" },
    { 0x094D33AD, "killstreak_achieved" },
    { 0xF220157B, "killstreak_action_slot" },
    { 0xB70C9E47, "killstreak_assist" },
    { 0x5D4AED21, "killstreak_bundles" },
    { 0x51479B36, "killstreak_counter" },
    { 0x5C07B2E6, "killstreak_data" },
    { 0xB8026F53, "killstreak_data_dump" },
    { 0x91390AE7, "killstreak_debug_text" },
    { 0xC4DFA3B6, "killstreak_debug_think" },
    { 0x1CEEBE63, "killstreak_delay_killcam" },
    { 0x4F1BF8AF, "killstreak_detect" },
    { 0x5C2C87A2, "killstreak_dialog_on_player" },
    { 0xF278076A, "killstreak_dialog_queued" },
    { 0x9271A18E, "killstreak_done" },
    { 0x6C46CD6A, "killstreak_duration" },
    { 0x2E1B89BB, "killstreak_end_time" },
    { 0xF23B28A6, "killstreak_hacked" },
    { 0xDED5782F, "killstreak_hackedcallback" },
    { 0xE5F5C973, "killstreak_hackedprotection" },
    { 0x8AB50F8F, "killstreak_hacking" },
    { 0xCCB88044, "killstreak_icon_width" },
    { 0x91A6484D, "killstreak_id" },
    { 0x50893BE8, "killstreak_init" },
    { 0x10BDD81B, "killstreak_name" },
    { 0x8C7F3F6F, "killstreak_points" },
    { 0x19F0EA25, "killstreak_purchased" },
    { 0x9C9F1576, "killstreak_ready_" },
    { 0xBCDEE6A1, "killstreak_ref" },
    { 0xF6478494, "killstreak_rule_debug" },
    { 0x41A89BF1, "killstreak_score_index" },
    { 0x3B9B660D, "killstreak_setup" },
    { 0x2581195D, "killstreak_start_" },
    { 0x2C6CAE3E, "killstreak_start_inventory_" },
    { 0xF2EE8681, "killstreak_started" },
    { 0x7ACF3BE1, "killstreak_stop_and_assert" },
    { 0x83DE144B, "killstreak_stop_think" },
    { 0x3EA35ABA, "killstreak_switch_team" },
    { 0x5C6AB1E0, "killstreak_switch_team_end" },
    { 0xAB555108, "killstreak_switch_team_singleton" },
    { 0xE4FA855C, "killstreak_timer_start_using_hacked_time" },
    { 0x8AAFC26B, "killstreak_timer_started" },
    { 0xD2A6991C, "killstreak_timer_x" },
    { 0xF8A91385, "killstreak_timer_y" },
    { 0x642D2680, "killstreak_timers" },
    { 0xD4523449, "killstreak_used" },
    { 0x814158B9, "killstreak_waitamount" },
    { 0xAFD201F4, "killstreak_waiter" },
    { 0xA9F13576, "killstreak_weapon" },
    { 0xA09E2AB5, "killstreak_weapon_switch" },
    { 0xE5D03FCA, "killstreak_weapon_taken" },
    { 0x359F2069, "killstreak_weapons" },
    { 0x14421F07, "killstreakbasevalue" },
    { 0xCBF74083, "killstreakbuilding" },
    { 0x9B0B43E3, "killstreakbundle" },
    { 0x33DBC6A0, "killstreakconfigureteampostfunction" },
    { 0xB0F2446D, "killstreakconfigureteamprefunction" },
    { 0x1DB2038E, "killstreakcorebundle" },
    { 0x6B15CA00, "killstreakcount" },
    { 0xC61E13D5, "killstreakcounter" },
    { 0x9143715F, "killstreakdamagemodifier" },
    { 0x5A4840CB, "killstreakdata" },
    { 0xEF0ADB1A, "killstreakdelaystreak" },
    { 0xD8453A10, "killstreakdialogqueue" },
    { 0xAFBBF9BE, "killstreakendevent" },
    { 0x42A93B55, "killstreakendtime" },
    { 0xBB010ECA, "killstreakentity" },
    { 0x1F90C8C9, "killstreakevent" },
    { 0x680C4BC0, "killstreakevents" },
    { 0xA7CD4B8F, "killstreakforcurrentweapon" },
    { 0x985A6C06, "killstreakgiven" },
    { 0x3D0DAD46, "killstreakhackfx" },
    { 0x8A398C74, "killstreakhackloopfx" },
    { 0x409E06C7, "killstreakhacklostlineofsightlimitms" },
    { 0x86102F09, "killstreakhacklostlineofsighttimems" },
    { 0x3DDB9976, "killstreakhackscoreevent" },
    { 0x90AD337C, "killstreakicon" },
    { 0x8F75BC3F, "killstreakicons" },
    { 0x8F1266B4, "killstreakid" },
    { 0xBEE98EA7, "killstreakids" },
    { 0xC270693D, "killstreakindex" },
    { 0x8C9C8482, "killstreakindices" },
    { 0xF8F6A82E, "killstreakinfluencertype" },
    { 0xFD5D0997, "killstreakishacked" },
    { 0xF9375DCE, "killstreakkills" },
    { 0x5CC85C83, "killstreaklevel" },
    { 0xD41420BC, "killstreakloophackfx" },
    { 0x610257E5, "killstreakmaxhealthfunction" },
    { 0x82877477, "killstreakmenuname" },
    { 0x5E58F9B7, "killstreakmonitor" },
    { 0xBDE6D496, "killstreakname" },
    { 0x41E73A09, "killstreaknames" },
    { 0xCDE2E49D, "killstreaknotifyqueue" },
    { 0x29B40335, "killstreaknum" },
    { 0x33573A4D, "killstreakoriginalteam" },
    { 0x25BE2576, "killstreakposthackfunction" },
    { 0x1061E791, "killstreakprehackfunction" },
    { 0x86BACF82, "killstreakpurchased" },
    { 0x4023298A, "killstreakref" },
    { 0x72736182, "killstreakreference" },
    { 0xD0C441F3, "killstreakreferencetoindex" },
    { 0x56962E52, "killstreakrounddelay" },
    { 0xEFD54D6C, "killstreakrules" },
    { 0xD50DB15A, "killstreaks" },
    { 0xCF44CEBE, "killstreaks_shared" },
    { 0x6DF7D5AC, "killstreaks_triggered" },
    { 0x1C350D86, "killstreakscountsdisabled" },
    { 0x338951E1, "killstreaksenabled" },
    { 0x64DB604C, "killstreaksettings" },
    { 0xD0BAED9F, "killstreaksgivegamescore" },
    { 0x264588E7, "killstreakslot" },
    { 0xF7119ED9, "killstreakslotindex" },
    { 0xFBD936C1, "killstreakstart" },
    { 0x85A1D721, "killstreakstatsname" },
    { 0x19092C2B, "killstreakstop" },
    { 0x3B7015AC, "killstreakstr" },
    { 0x822FE8DC, "killstreakstring" },
    { 0x5C4ADB05, "killstreaksused" },
    { 0xD0420496, "killstreaktablenumber" },
    { 0xE249B873, "killstreaktargetclear" },
    { 0x34B815CC, "killstreaktargetset" },
    { 0x69C56E08, "killstreakteamconfigured" },
    { 0xC7A32438, "killstreakten" },
    { 0x0FDDEFE0, "killstreaktimedout" },
    { 0x0C707E3C, "killstreaktimeout" },
    { 0x24ABAFD2, "killstreaktimer" },
    { 0x080E7423, "killstreaktype" },
    { 0x5990E6CE, "killstreaktypearray" },
    { 0xDAD39865, "killstreaktypeindex" },
    { 0xEAE25C01, "killstreakusagekey" },
    { 0xAA79B028, "killstreakusefunction" },
    { 0x32FBE559, "killstreakwaiter" },
    { 0x87B4AD2F, "killstreakweapon" },
    { 0xE81EAB22, "killstreakweaponname" },
    { 0x55598D76, "killstreakweapons" },
    { 0xF8C7E604, "killstreakweaponsallowedscore" },
    { 0x214725BE, "killstring" },
    { 0x92FFCD93, "killswithbothawarded" },
    { 0x111F4AAE, "killswithprimary" },
    { 0x16981932, "killswithsecondary" },
    { 0x16BB66B9, "killtank" },
    { 0x135A1038, "killtext" },
    { 0xE18D6BAE, "killthreshold" },
    { 0xD820B2D3, "killthrow" },
    { 0x2E9EA4AA, "killtime" },
    { 0x70C0A8F3, "killtimedelay" },
    { 0x6F0502B2, "killtimemsec" },
    { 0xE0F201FC, "killtimer" },
    { 0x6957BEDD, "killtimerscript" },
    { 0x44BB49FA, "killtimescount" },
    { 0xBE0741DD, "killtrackerfx" },
    { 0xA182A2E0, "killtrackerfx_on_death" },
    { 0x49983795, "killtrackerfx_track" },
    { 0x7259E308, "killtrackerfxenable" },
    { 0xBDE9BDAF, "killtrig" },
    { 0x7FD4BE0C, "killtrig_loop" },
    { 0x318C56B3, "killtrigger" },
    { 0x3DEB7408, "killtriggercount" },
    { 0x2AE286F6, "killtrigs" },
    { 0xF27C1C01, "killturret_audio_safely" },
    { 0xF6B9EB4C, "killunderwaterfx" },
    { 0x5E85A135, "killus" },
    { 0xE37E96BB, "killvolume" },
    { 0x085D484D, "killweapon" },
    { 0x0316DBC8, "killwhilecontesting" },
    { 0x6BEF1CB3, "killwhiledamagingwithhpm" },
    { 0x3636023A, "killwithdrones_challenge" },
    { 0x4E5A42F2, "killwrapper" },
    { 0x869A8756, "killzombiesinpowerstation" },
    { 0x2086F6F7, "killzone" },
    { 0x25EB401C, "killzone1" },
    { 0x30779C1E, "killzone1point" },
    { 0x97F2AF57, "killzone2" },
    { 0xD50AC7BB, "killzone2point" },
    { 0x0CB455A9, "killzone_detonation" },
    { 0x585366FA, "killzone_trigger" },
    { 0x3CE5499D, "killzone_trigger_extra" },
    { 0x3028904D, "killzonebigexplosion_fx" },
    { 0x9AA5C0FA, "killzonedirtexplosion_fx" },
    { 0x86C17F71, "killzonefuelexplosion_fx" },
    { 0x252CFF77, "killzonefxprogram" },
    { 0x786F2E3D, "killzonemudexplosion_fx" },
    { 0xF28ECF2E, "killzones" },
    { 0x2DA0286C, "killzonesfx" },
    { 0xC4CF3069, "killzonetrig" },
    { 0x902017F0, "killzonewatch" },
    { 0x4F94EC76, "kilo" },
    { 0xB9CDEBE5, "kilt" },
    { 0xDD3F8120, "kimmel" },
    { 0x5C7778FF, "kind" },
    { 0x282317A4, "kinda" },
    { 0xD44FB306, "kinds" },
    { 0x0E50FB78, "kinematic" },
    { 0x47CD1852, "kinetic" },
    { 0xEA7009C4, "king" },
    { 0x9FCE0838, "kingdom" },
    { 0x1A83DD0C, "kino" },
    { 0x8D524482, "kiparis" },
    { 0x524580CE, "kiri" },
    { 0x76CF4C03, "kit" },
    { 0x483B225B, "kitchen" },
    { 0xBD0CCAD4, "kite" },
    { 0x82A0F45D, "kiting" },
    { 0x59E92E34, "klaxon" },
    { 0x38B2D855, "klaxon_speakers" },
    { 0x41E7D094, "klaxon_struct" },
    { 0xAF23C6F2, "klaxxon" },
    { 0x14BF0F73, "klaxxon_audio_notify" },
    { 0x0C3C16B3, "klaxxon_close" },
    { 0x506F6F1B, "klaxxon_start" },
    { 0x88CE0F2B, "klick" },
    { 0x4E79E90A, "klicks" },
    { 0x65EDD460, "knc_" },
    { 0x5E74B0EB, "knc_on" },
    { 0x2EE417AB, "knc_on_snd" },
    { 0xB4C3FCDC, "knee" },
    { 0xF46E0A6C, "kneecap" },
    { 0xCA1D46A4, "kneecap_sequence" },
    { 0x3B1F024F, "kneecap_woods" },
    { 0x9092ADF4, "kneecapping" },
    { 0xE82A24DE, "kneedeep" },
    { 0x47D01D00, "kneeling" },
    { 0x3EB6241F, "knees" },
    { 0x87817AF5, "knees_execution_guys_array" },
    { 0xA0A14B1E, "knew" },
    { 0xFABAC8FE, "knfie" },
    { 0x7A076104, "knife" },
    { 0xC2A914DE, "knife_attack_fx_name" },
    { 0x1E723705, "knife_attack_fx_tag" },
    { 0x62981C45, "knife_attack_model" },
    { 0xE065C3B3, "knife_attack_sound" },
    { 0x7A5A34B6, "knife_attack_tag" },
    { 0x06BE03B8, "knife_ballistic_endgame_1" },
    { 0x78C572F3, "knife_ballistic_endgame_2" },
    { 0x52C2F88A, "knife_ballistic_endgame_3" },
    { 0x2B42B656, "knife_ballistic_endgame_array" },
    { 0x91686875, "knife_ballistic_lobby" },
    { 0x22AF7DF9, "knife_bash_shoot" },
    { 0xFEA9CAF0, "knife_endgame_1" },
    { 0x70B13A2B, "knife_endgame_2" },
    { 0x4AAEBFC2, "knife_endgame_3" },
    { 0x0EF3F97E, "knife_endgame_array" },
    { 0xB3C06C25, "knife_enemy" },
    { 0x9367D4E6, "knife_event_finished" },
    { 0x11AD3956, "knife_guard" },
    { 0x4821C6A5, "knife_guy_init" },
    { 0xB379486A, "knife_kill_done" },
    { 0xACF9EF6E, "knife_kill_enemy" },
    { 0x973064D8, "knife_kill_fx" },
    { 0xED84AB77, "knife_kill_point_of_no_return" },
    { 0x1DD44009, "knife_kill_setup" },
    { 0x8EB4252D, "knife_lobby" },
    { 0x593F619A, "knife_model" },
    { 0x0525124B, "knife_mp_test" },
    { 0xB33B8405, "knife_planted" },
    { 0x10C119E7, "knife_pos" },
    { 0xE944146A, "knife_pullout" },
    { 0xE37FA0A9, "knife_throw" },
    { 0x048DAEA4, "knife_throw_blood" },
    { 0x914E4416, "knife_throw_prompt" },
    { 0x791D72E1, "knife_throw_vo" },
    { 0xE65C83DC, "knife_to_owner" },
    { 0x44A5E848, "knifed" },
    { 0x23E90368, "knifekillnode" },
    { 0xC576209B, "knifemodel" },
    { 0x879BBF2A, "kniferang" },
    { 0xD3ECA525, "kniferang_launch_speed_unitspersecond" },
    { 0x3A2D2240, "kniferang_launch_time" },
    { 0xE34110F5, "kniferang_retrieve_max_dist" },
    { 0x927CDCFB, "kniferang_retrieve_min_dist" },
    { 0x10DBDD97, "kniferangprojectile" },
    { 0x45320E33, "kniferangprojectileretrieve" },
    { 0xF3BD7951, "kniferangretrievemaxdistance" },
    { 0x39B4FC85, "kniferangspeedunitspersecond" },
    { 0xBB5CE82A, "knifeweaponoptions" },
    { 0xE375A976, "knight" },
    { 0xBA3E6D6E, "kninebangempradius" },
    { 0xF9109E47, "knives" },
    { 0x701FCC91, "knob" },
    { 0xFB440DD4, "knob_shot" },
    { 0x40DFF278, "knobs" },
    { 0xD66B3E0B, "knock" },
    { 0x6B3EFC1C, "knock_on_door" },
    { 0xBA476A48, "knock_player_down" },
    { 0xD5B14D3C, "knock_trig" },
    { 0xF367CD72, "knockback" },
    { 0x80B8B4BB, "knockdown" },
    { 0x92B4BB45, "knockdown_direction" },
    { 0xC3CB3962, "knockdown_dist" },
    { 0x780BEA21, "knockdown_dist_sq" },
    { 0xFD36D312, "knockdown_iterations" },
    { 0xC36CDE13, "knockdown_range_squared" },
    { 0xE1CDEECC, "knockdown_rockets_fired" },
    { 0x170D2A5F, "knockdown_shoved" },
    { 0xE72314AE, "knockdown_stun" },
    { 0xE6377CE6, "knockdown_type" },
    { 0x713B91B0, "knockdown_zombie" },
    { 0x60897A18, "knockdown_zombie_animate" },
    { 0x38561712, "knockdown_zombie_animate_state" },
    { 0x0204A458, "knockdown_zombie_damage" },
    { 0xAE47BF31, "knockdown_zombies_slam" },
    { 0xE3EEA35A, "knockdowns" },
    { 0xED739740, "knocked" },
    { 0xA440C1C5, "knocked_out" },
    { 0x6AA1D8B7, "knocked_out_snapshots" },
    { 0x9D2CAAE3, "knockeddownsequence" },
    { 0x31AA1C46, "knocker" },
    { 0x2E897555, "knocking" },
    { 0x7B6D2819, "knockout" },
    { 0xDC4C196A, "knocks" },
    { 0xF0AC73DB, "knot_color" },
    { 0xC01EAA4E, "knots" },
    { 0x424EE25C, "know" },
    { 0xE0BCB0AC, "knowing" },
    { 0xB03F36E7, "knowledge" },
    { 0x628C826A, "known" },
    { 0x905D6C9F, "knows" },
    { 0xAAE5C8FB, "knowwheretoshoot" },
    { 0xB376EF7C, "knuckle" },
    { 0x5308B03F, "knuckles" },
    { 0x164979CB, "knuckles_endgame_1" },
    { 0xA4420A90, "knuckles_endgame_2" },
    { 0xCA4484F9, "knuckles_endgame_3" },
    { 0xE7CD4E79, "knuckles_endgame_array" },
    { 0xD0ED6949, "knuckles_extinguish_flames" },
    { 0x3A9FEAC2, "knuckles_lobby" },
    { 0x5FC810C2, "kong" },
    { 0x301D3E6F, "kosher" },
    { 0x8BA31DD7, "koth" },
    { 0x02E3A4E4, "koth_gamemodespawndvars" },
    { 0xDDC2F0D9, "koth_goal_time" },
    { 0xBF915DEE, "koth_initial_spawns_influencer_radius" },
    { 0xCC1C94AA, "koth_initial_spawns_influencer_score" },
    { 0x3A8706D6, "koth_initial_spawns_influencer_score_curve" },
    { 0x99BAA863, "koth_objective_influencer_inner_radius" },
    { 0xF27E42AD, "koth_objective_influencer_inner_score" },
    { 0x71F8C601, "koth_objective_influencer_inner_score_curve" },
    { 0x46AE0EA4, "koth_objective_influencer_radius" },
    { 0x680F61A4, "koth_objective_influencer_score" },
    { 0x928D9DD8, "koth_objective_influencer_score_curve" },
    { 0xE110010A, "koth_playerspawnedcb" },
    { 0x0426057B, "koth_rules" },
    { 0x5E1665E2, "koth_wins_index" },
    { 0xBFB9630C, "koth_zone_center" },
    { 0x06404E0E, "kothcapteam" },
    { 0xBBE520B5, "kothcaptureloop" },
    { 0x8849B9DA, "kothmainloop" },
    { 0xC635206E, "kothmode" },
    { 0xB04393D4, "kothplayerspawngenerateinfluencers" },
    { 0xFE2BD3D2, "kothstarttime" },
    { 0x5BC9F4A5, "kothtotalsecondsinzone" },
    { 0x4B35A726, "kowloon" },
    { 0xB0D696C7, "kowloon_amb" },
    { 0x15AB4CBA, "kowloon_anim" },
    { 0xC050B094, "kowloon_art" },
    { 0x61D2F9EB, "kowloon_cache_run" },
    { 0x36CB5909, "kowloon_defend" },
    { 0xC6FB74F5, "kowloon_defend_objective" },
    { 0x6D649963, "kowloon_fx" },
    { 0xAD05ACE2, "kowloon_gas_leak" },
    { 0x2C539C8D, "kowloon_interrogate" },
    { 0x9769D283, "kowloon_introscreen_redact_delay" },
    { 0xC7811839, "kowloon_objectives" },
    { 0x2D059DAB, "kowloon_onsaverestored" },
    { 0xD52140A8, "kowloon_platform" },
    { 0xDAC4DAED, "kowloon_rooftop_battle" },
    { 0x05833761, "kowloon_slide_in_and_out" },
    { 0xB70F7B49, "kowloon_thundergun" },
    { 0x51DC7839, "kowloon_util" },
    { 0x20E8A4EE, "kozin" },
    { 0x21340BF5, "krail1" },
    { 0x4736865E, "krail2" },
    { 0xD72B778D, "krail_btm_01_jnt" },
    { 0xEBE4D4AA, "krail_mid_01_jnt" },
    { 0x2D4BB55C, "krail_upper_01_jnt" },
    { 0xEDD79B07, "krails" },
    { 0x146FAE47, "kraken" },
    { 0x825C6E49, "kramer" },
    { 0xEFC928C8, "kraut" },
    { 0xC588F6EF, "krav" },
    { 0xEE86D4EA, "krav_blood" },
    { 0xC24F946A, "krav_buddy" },
    { 0xD1DC4E06, "krav_destnode" },
    { 0x74ACCEA2, "krav_dummy" },
    { 0x42545D4E, "krav_face_impact" },
    { 0xB47CC4A6, "krav_fake_head" },
    { 0xC2561FD5, "krav_gives_all_intel" },
    { 0x3B798801, "krav_guard_1" },
    { 0x617C026A, "krav_guard_2" },
    { 0x877E7CD3, "krav_guard_3" },
    { 0x16F87D74, "krav_guards" },
    { 0x897CF190, "krav_guards_spawners" },
    { 0x9CD0BE36, "krav_horse_max" },
    { 0xBA36F42D, "krav_sanity_check" },
    { 0x50BE6D7E, "krav_scene_jumpto" },
    { 0x6F0C46A9, "krav_strangle_muj" },
    { 0x83553732, "krav_tag_head_angles" },
    { 0xBD12C54C, "krav_tag_head_origin" },
    { 0xD306C0A2, "krav_tank" },
    { 0xEAD0EECA, "krav_tank_cannon" },
    { 0x75ECAE85, "krav_tank_fire" },
    { 0x98153BD6, "krav_tank_machinegun" },
    { 0xD0A7395F, "krav_vo_lines" },
    { 0xFCB6A495, "kravchenko" },
    { 0xED4A12A7, "kravchenko_door_node" },
    { 0x7F2BB0EB, "kravchenko_eyepoke_node" },
    { 0x4606FDD8, "kravchenko_intel" },
    { 0xD1712000, "kravchenko_pacing" },
    { 0x8613A7D8, "kravchenko_punches_face" },
    { 0x5F8DFC69, "kravchenko_recording" },
    { 0x88495725, "kravchenko_spawnfunction" },
    { 0x838105C1, "kravckenko_vo_trigger" },
    { 0x25A5FA62, "kravechenko" },
    { 0x2842E14E, "kraven" },
    { 0x8C5E6E38, "krazy" },
    { 0x9E270561, "kremlin" },
    { 0x15F3B5EC, "kriegler" },
    { 0xBDD3CD77, "kristen" },
    { 0xB9DA6EB0, "kristina" },
    { 0x49870F70, "krme" },
    { 0xCD6E4756, "krms" },
    { 0x40C8F717, "ks" },
    { 0xA09C3070, "ks_allies" },
    { 0x4D53E971, "ks_axis" },
    { 0x566E0401, "ks_contested" },
    { 0xD3F824BE, "ks_enemy" },
    { 0xF2334EAB, "ks_friendly" },
    { 0x9EE0A10C, "ks_level" },
    { 0xC2137A73, "ks_neutral" },
    { 0x773A85D2, "ks_weapon" },
    { 0xBA98DEA6, "ksacceltimepercentage" },
    { 0x9320B23E, "ksairdropaitankradius" },
    { 0x527772D8, "ksairdroprobotradius" },
    { 0x232DFBDE, "ksairdropsupplydropradius" },
    { 0x4917D15F, "ksbladeenddistance" },
    { 0xD2719F69, "ksbladeendspreadradius" },
    { 0x6340D1BC, "ksbladestartdistance" },
    { 0xA46C2CB6, "ksbladestartspreadradius" },
    { 0xA0B6A377, "ksbundle" },
    { 0xB483F357, "ksclipstokill" },
    { 0x68299ED5, "kscombatrobotpatrolfx" },
    { 0x3A652831, "ksd" },
    { 0x621C1EAC, "ksdartacceleration" },
    { 0xE6D917A3, "ksdartbladecount" },
    { 0x2DB36947, "ksdartcamerawatchdistance" },
    { 0xAFE4622E, "ksdartcamerawatchduration" },
    { 0xA3E8E834, "ksdartexplosioninnerdamage" },
    { 0xE568E2DD, "ksdartexplosioninnerradius" },
    { 0x9EA38199, "ksdartexplosionmagnitude" },
    { 0x3A83172D, "ksdartexplosionouterdamage" },
    { 0x38798540, "ksdartexplosionouterradius" },
    { 0x51F4719D, "ksdartinitialspeed" },
    { 0xD18187ED, "ksdartshotcount" },
    { 0xA12ADB58, "ksdartstokill" },
    { 0xD9038040, "ksdartvehicle" },
    { 0x35BBCBDA, "ksdartwaittimeafterlastshot" },
    { 0xADA330CC, "ksdropdeploylandfx" },
    { 0x05E90A53, "ksdropdeploylandsurfacefxtable" },
    { 0x63C25105, "ksempgrenadestokill" },
    { 0x9A9A3332, "ksexplosionfx" },
    { 0xCF7848DB, "ksexplosioninnerdamage" },
    { 0x02DC7E8A, "ksexplosioninnerradius" },
    { 0x955196C2, "ksexplosionmagnitude" },
    { 0xE92FB0FE, "ksexplosionouterdamage" },
    { 0x7D3BDB6B, "ksexplosionouterradius" },
    { 0x48EF1427, "ksexplosionrumble" },
    { 0x68041075, "ksgrenadedamagemultiplier" },
    { 0x00EBE2B9, "kshackedhealth" },
    { 0x29E13E2A, "kshackfx" },
    { 0x0B905A40, "kshackloopfx" },
    { 0x846DB821, "kshackprotection" },
    { 0x29E5BCBA, "kshackscoreevent" },
    { 0xA7F67D79, "kshacktimeout" },
    { 0x85D7B028, "kshacktoolinnerradius" },
    { 0xC8196C61, "kshacktoolinnertime" },
    { 0x6BBF93A1, "kshacktoollostlineofsightlimitms" },
    { 0xC912B68E, "kshacktoolnolineofsighttime" },
    { 0x425C5155, "kshacktoolouterradius" },
    { 0xA34FDD40, "kshacktooloutertime" },
    { 0xFAACF0C5, "kshealth" },
    { 0x3FAA47C7, "kshero_annihilator" },
    { 0x92E74142, "kshero_armblade" },
    { 0x3EFCC74E, "kshero_bowlauncher" },
    { 0x412FA2B4, "kshero_firefly_swarm" },
    { 0xB867E64D, "kshero_gravityspikes" },
    { 0xF1E89767, "kshero_heatwave" },
    { 0x62A15BF6, "kshero_lightninggun" },
    { 0x8622E61F, "kshero_minigun" },
    { 0xD7F8F06A, "kshero_pineapplegun" },
    { 0x6024214B, "ksherwood" },
    { 0xC5C4E632, "ksinvalidlocationsound" },
    { 0x2C7DC2FE, "ksinvalidlocationstring" },
    { 0xF9F8CE9D, "kslandingvelocity" },
    { 0x2ABFD5A1, "kslowhealth" },
    { 0xD699C445, "ksmainturretrecoilforce" },
    { 0xCAA93007, "ksmainturretrecoilforcecontrolled" },
    { 0x64A5D354, "ksmainturretrecoilforcezoffset" },
    { 0x51FA2D38, "ksmaxairdroptargetrange" },
    { 0x8399A60F, "ksmeleedamagemultiplier" },
    { 0x7C34E8BA, "ksminairdroptargetrange" },
    { 0x8256D5BF, "ksplaceablehint" },
    { 0x793F0323, "ksplaceableinvalidlocationhint" },
    { 0x85BCAD00, "ksprojectilespashmultiplier" },
    { 0x126D2C1D, "ksremote_missile_missile" },
    { 0xC464F105, "ksricochetdistance" },
    { 0x54C34959, "ksricochetpostlandduration" },
    { 0x5B06704D, "ksrocketstokill" },
    { 0x45C70EC4, "ksshotgunenergytokill" },
    { 0xCE17F98A, "ksshotgunmultiplier" },
    { 0xD199B4FE, "ksstartcratekillheightfromground" },
    { 0x164C7A62, "ksthrusterfx" },
    { 0x67AA8837, "ksthrustersoffheight" },
    { 0x7BC228F8, "kstimeoutbeepalias" },
    { 0xD8565E3C, "kstimeoutbeepduration" },
    { 0x1715FF7E, "kstimeoutfastbeepduration" },
    { 0x34DCA7A7, "kstotaldroptime" },
    { 0xC130DF6D, "ksvalidaitanklocationsound" },
    { 0xCEAF7012, "ksvalidcarepackagelocationsound" },
    { 0x95C0BDAD, "ksvalidcombatrobotlocationsound" },
    { 0x34069215, "ksvehicle" },
    { 0x76C36C2B, "ksweaponreloadtime" },
    { 0xC64CC62A, "ktr" },
    { 0x403553E6, "kubel" },
    { 0x406C812B, "kubel1" },
    { 0x9EDCF108, "kubel1_pos" },
    { 0x466DF6AE, "kubel1_rollback" },
    { 0x3B61DAA6, "kubel1_watcher" },
    { 0xCE6511F0, "kubel2" },
    { 0x2D65DB93, "kubel2_pos" },
    { 0xC0960855, "kubel2_watcher" },
    { 0x24631658, "kubelwagen" },
    { 0xBE52D169, "kubelwagons" },
    { 0x82BC930A, "kv" },
    { 0x79F106AE, "kvp" },
    { 0x731BAD92, "kvp_key" },
    { 0xE176A07C, "kvp_value" },
    { 0x5DF415D1, "kvps" },
    { 0xA8BF0D73, "kw" },
    { 0xA36208D1, "kwai" },
    { 0x076AAC31, "kyrgyzstan" },
    { 0x3EC5D5B7, "kzmb" },
    { 0xFB3FEA57, "kzmb_key" },
    { 0xB5BBDD6F, "kzmb_name" },
    { 0x5750877B, "l" },
    { 0xA84BD888, "l1" },
    { 0x1A5347C3, "l2" },
    { 0x6BAA897B, "l33t" },
    { 0x8C5AB6FE, "l7" },
    { 0xCB91D0C2, "l_angles" },
    { 0x198B4899, "l_animlength" },
    { 0xB0C7CF73, "l_cover" },
    { 0x93F6EE27, "l_in" },
    { 0xEC444C52, "l_out" },
    { 0x4898E1FE, "l_stick" },
    { 0x9A7CC7B6, "l_stick_input_min" },
    { 0x8FD52498, "l_strings" },
    { 0x87D4E4D8, "la" },
    { 0xCC9B33B8, "la0" },
    { 0x18A0288A, "la2" },
    { 0x84559637, "la2_setup_fullscreen_postfx" },
    { 0x8B71C146, "la2_turn_off_sonar" },
    { 0xB46F0D24, "la_1" },
    { 0x03E25615, "la_1_amb" },
    { 0xDF21333C, "la_1_anim" },
    { 0x232D6C3A, "la_1_art" },
    { 0xC2CE5FED, "la_1_fx" },
    { 0xB4220227, "la_1_vehicle_damage" },
    { 0xBA87575E, "la_1b" },
    { 0xFA62929F, "la_1b_amb" },
    { 0x7FC29B82, "la_1b_anim" },
    { 0xD2A3E17C, "la_1b_art" },
    { 0xD17FF48B, "la_1b_fx" },
    { 0x5AB1CC45, "la_1b_fxanim_deconstruct" },
    { 0xCD8A9ED9, "la_1b_intersection_vehicle_damage" },
    { 0xD8EE7091, "la_1b_util" },
    { 0x26767C5F, "la_2" },
    { 0x1071F042, "la_2_amb" },
    { 0x9BD0EB55, "la_2_anim" },
    { 0x0B78E931, "la_2_art" },
    { 0x9E3340C0, "la_2_convoy" },
    { 0xEDE8B85B, "la_2_debug" },
    { 0x92C1C112, "la_2_drones_ambient" },
    { 0x5DDD5BAD, "la_2_fly" },
    { 0x8E9B3C20, "la_2_fx" },
    { 0x1D0BC413, "la_2_ground" },
    { 0x791FF552, "la_2_objectives" },
    { 0x7A9CF64E, "la_2_player_f35" },
    { 0x2CCCD16F, "la_2_transition" },
    { 0x04B914FD, "la_argus" },
    { 0xA6E65205, "la_drive" },
    { 0x2A3FB22B, "la_drone_control_tones" },
    { 0xB26629B4, "la_drones_setup" },
    { 0xF31FB281, "la_fire_direction_inited" },
    { 0x89A0C528, "la_intersection" },
    { 0x7BD19813, "la_intro" },
    { 0xF95C7CE8, "la_low_road" },
    { 0x2D0638DF, "la_plaza" },
    { 0x297FD3E4, "la_sam" },
    { 0x6FAE8F6A, "la_street" },
    { 0xE2396E3D, "la_utility" },
    { 0x37D9E7BA, "lab" },
    { 0xD08552FA, "lab_1_1" },
    { 0x9C98C5BD, "lab_2_1" },
    { 0xE6CDA9F2, "lab_2_1_left_door" },
    { 0x6DBF8A7D, "lab_2_1_right_door" },
    { 0xC29B4026, "lab_2_2" },
    { 0x09A6997B, "lab_alarms" },
    { 0x983D18F1, "lab_approach" },
    { 0x046CE67C, "lab_approach_event" },
    { 0x91C6388C, "lab_approach_reznov" },
    { 0x15D4A002, "lab_approach_vignette" },
    { 0x05DD5343, "lab_battle_dead_bodies" },
    { 0xA24E3618, "lab_battle_enemy_vo" },
    { 0xDA8C6FE9, "lab_battle_main" },
    { 0xB17FD93C, "lab_civ_idle_react_spawnfunc" },
    { 0x9F6006A4, "lab_civs" },
    { 0x27D6BE76, "lab_civs_spawnfunc" },
    { 0xF4299240, "lab_clean_up" },
    { 0x382E60BA, "lab_color_triggers" },
    { 0x0913BC58, "lab_cover_flip_1" },
    { 0x0B507603, "lab_cower_civs" },
    { 0xC1B17E36, "lab_defend_anims" },
    { 0x0BB4F780, "lab_defend_done" },
    { 0x03D46F72, "lab_defend_enemy_vo" },
    { 0xFC3682A6, "lab_defend_event_timer" },
    { 0x19C7A267, "lab_defend_main" },
    { 0x69549F92, "lab_defend_waves" },
    { 0xB928151D, "lab_difficulty_balance_spawnfunc" },
    { 0xE5049EA0, "lab_doors" },
    { 0xB45C7941, "lab_enemy_deck" },
    { 0x228DDBCB, "lab_entrance" },
    { 0xDEB0A828, "lab_entrance_anims" },
    { 0x1EF094FD, "lab_entrance_setup" },
    { 0x7FD682AB, "lab_escape_ambience" },
    { 0x4F1DF5D7, "lab_exterior" },
    { 0x8627D5FA, "lab_exterior_fog" },
    { 0x80FED98D, "lab_guys" },
    { 0xB5DD2065, "lab_hazmat_enemies" },
    { 0x339CC721, "lab_interior" },
    { 0x269BE5B9, "lab_lights_spin" },
    { 0x9E3310A6, "lab_main" },
    { 0x761302B2, "lab_monkey_manager" },
    { 0x4A2E75C4, "lab_monkeys_hide" },
    { 0xF3471E6E, "lab_monkeys_hide_old" },
    { 0x7100BCDF, "lab_monkeys_show" },
    { 0x7CEE4F71, "lab_monkeys_show_old" },
    { 0x57B3BF38, "lab_observ_civs" },
    { 0x2EC16BAA, "lab_observ_civs_spawnfunc" },
    { 0x624432D6, "lab_pigs" },
    { 0x302A2CC6, "lab_scientist_screams" },
    { 0x98070984, "lab_shutters_init" },
    { 0x8AC9B42E, "lab_shutters_think" },
    { 0xE9048542, "lab_spawn_funcs" },
    { 0x5B6BE842, "lab_spawners" },
    { 0x08004078, "lab_spets_spawnfunc" },
    { 0x9CEEFBEB, "lab_trig" },
    { 0xAF69F207, "lab_trigger" },
    { 0x4418C3D5, "lab_vision" },
    { 0x25BC7A50, "lab_vo" },
    { 0xE58A6929, "lab_vo_ended" },
    { 0x74EE41F3, "labe" },
    { 0x8E7EDB95, "label" },
    { 0x1EED7608, "labelled" },
    { 0xD4D3E2E4, "labels" },
    { 0x74985C06, "labelstring" },
    { 0x64439AF9, "labor" },
    { 0xE17DF1FA, "laboratories" },
    { 0x3B1F8726, "labored" },
    { 0xFD3DE030, "labors" },
    { 0x60CB9035, "labs" },
    { 0x894CA8AF, "lacf" },
    { 0xFB5417EA, "lack" },
    { 0x85D743C6, "lacking" },
    { 0x032287B6, "lacw" },
    { 0x83DEDC8C, "lad" },
    { 0x89B4B033, "ladded" },
    { 0x7591FE75, "ladder" },
    { 0x1CD5DE16, "ladder_ai_drop" },
    { 0x7622A746, "ladder_blocker" },
    { 0x2236B124, "ladder_climb_strat" },
    { 0x02C55F4C, "ladder_down" },
    { 0xD2CAE869, "ladder_hatch_pdf" },
    { 0x8F927A99, "ladder_ignore_strat" },
    { 0x88FF0AB3, "ladder_land_dust_one" },
    { 0x4850AB91, "ladder_land_dust_two" },
    { 0x3C48760D, "ladder_local_offset" },
    { 0x0C17492E, "ladder_nag" },
    { 0xD0A33684, "ladder_nva_spawner" },
    { 0xE99C7409, "ladder_obj_breadcrumb" },
    { 0x8E884171, "ladder_objective" },
    { 0x6B7DE376, "ladder_pos" },
    { 0x25D9EA2A, "ladder_spawn_loc" },
    { 0x6973B483, "ladder_struct" },
    { 0x370ED269, "ladder_top" },
    { 0xE3CBF746, "ladder_trig" },
    { 0x7F87ADBF, "ladder_up" },
    { 0x2BA6B7A7, "ladder_wait_hudson" },
    { 0x60559936, "ladder_wait_lewis" },
    { 0x61EA9A59, "ladder_wait_timer" },
    { 0x13C21B8E, "ladder_wait_weaver" },
    { 0xF8C2833F, "ladderkick" },
    { 0xF7552F44, "ladders" },
    { 0x0FFF707E, "laddie" },
    { 0x731C18CD, "ladies" },
    { 0x19C3D785, "lady" },
    { 0xA9E156F5, "lae" },
    { 0xF5E64BC7, "lag" },
    { 0x5DE2639E, "lag_index" },
    { 0x51CB940D, "lag_time" },
    { 0x344C2E0C, "lagacy" },
    { 0x9CAC60FA, "laggers" },
    { 0x2FB0CD86, "lagging" },
    { 0xC7077E6F, "laid" },
    { 0xA0AE395C, "lake" },
    { 0x574EFD03, "lake_stop" },
    { 0xA7A0C6B4, "lambs" },
    { 0x6DC9326A, "lame" },
    { 0xDF4A51AF, "lameness" },
    { 0xCBADEFE7, "lamp" },
    { 0x67C84784, "lamp_action" },
    { 0x73000859, "lamp_condition" },
    { 0xC9C33083, "lamp_gone" },
    { 0x89191C5E, "lamp_light" },
    { 0xC1011178, "lamp_post" },
    { 0xE0960215, "lamp_pulse_points" },
    { 0x59DC0693, "lamp_swap" },
    { 0xD7E4520F, "lamppost_01_fall" },
    { 0x7C4BAF0A, "lamppost_01_fall_start" },
    { 0x7415570B, "lamppost_01_hit" },
    { 0x6190E22E, "lamppost_01_hit_start" },
    { 0x8F5C2F5E, "lamps" },
    { 0x9FCFFE16, "lan" },
    { 0x82279926, "land" },
    { 0x12789372, "land_crush" },
    { 0xF7B7682D, "land_heli" },
    { 0xC2BB845B, "land_origin" },
    { 0xC17ED4B0, "land_path" },
    { 0x8F91EB46, "land_section" },
    { 0x8BA01983, "land_wingsuit" },
    { 0x82892A81, "landanim" },
    { 0x8DB76081, "landanimdelta" },
    { 0xFCACC675, "landdirection" },
    { 0x10D00CA9, "landed" },
    { 0x746AF676, "landed_animation" },
    { 0x1E79B523, "landed_drop" },
    { 0xECFD7257, "landed_on" },
    { 0xEC78171F, "landed_scene_done" },
    { 0xB0F4AE38, "landed_start" },
    { 0xCF852794, "landed_to_basement_handler" },
    { 0xBADF314E, "landedearly" },
    { 0x550691AF, "lander" },
    { 0xC4585A90, "lander_at_station" },
    { 0x756DB0F9, "lander_base" },
    { 0x09BB302F, "lander_buy_think" },
    { 0xAF727DE5, "lander_callboxes" },
    { 0x31B150FD, "lander_clean_up_corpses" },
    { 0x9BE6C7D0, "lander_cooldown_think" },
    { 0xBE7278AD, "lander_cost" },
    { 0x4A1067C7, "lander_count" },
    { 0x4BD2AE84, "lander_death" },
    { 0x5FBB9FF3, "lander_dest_station" },
    { 0x5DD9DF7D, "lander_engine_fx" },
    { 0xC914FBAD, "lander_flight_stop_wobble" },
    { 0x9AED2B6C, "lander_flight_wobble" },
    { 0x554E8590, "lander_fx" },
    { 0xE027C869, "lander_fx1" },
    { 0x062A42D2, "lander_fx2" },
    { 0x2C2CBD3B, "lander_fx3" },
    { 0x522F37A4, "lander_fx4" },
    { 0x5B309E56, "lander_fx_ent" },
    { 0xC68C0D82, "lander_goto_dest" },
    { 0xFDDCB958, "lander_grounded" },
    { 0xFA20B471, "lander_hover_idle" },
    { 0x69CDDB72, "lander_hud_message_active" },
    { 0xFB331FC7, "lander_in_use" },
    { 0x5F3ADFA1, "lander_intro_think" },
    { 0x1474DA36, "lander_knockdown" },
    { 0x4C38D0BD, "lander_landing_wobble" },
    { 0x5366A903, "lander_launch_prep" },
    { 0x8F27DCF0, "lander_launched" },
    { 0xA608434D, "lander_lights_green" },
    { 0x1632D739, "lander_lights_red" },
    { 0xEF97B179, "lander_link_spot" },
    { 0xE2E3906F, "lander_location" },
    { 0x7E8DEFE6, "lander_location_angles" },
    { 0xB201E6E4, "lander_logic" },
    { 0x576CC7E6, "lander_move_fx" },
    { 0xE55BEF66, "lander_poi" },
    { 0x15B83963, "lander_poi_init" },
    { 0x7C569FB4, "lander_remove_corpses" },
    { 0xD7241B58, "lander_ridden" },
    { 0x85394CA5, "lander_rumble_and_quake" },
    { 0xE8642B8B, "lander_station1" },
    { 0x9C5F36B9, "lander_station3" },
    { 0x5A6B9AC6, "lander_station4" },
    { 0x77FB17E6, "lander_station_baseentry" },
    { 0x71849475, "lander_station_baseentry_mon" },
    { 0x3BA34EEC, "lander_station_catwalk" },
    { 0xFCF7F257, "lander_station_catwalk_mon" },
    { 0x5E13DAEB, "lander_station_centrifuge" },
    { 0xB29D4D18, "lander_station_centrifuge_mon" },
    { 0xDDF62718, "lander_station_move_lander_marker" },
    { 0xC9D1F754, "lander_station_storage" },
    { 0xD4C6409F, "lander_station_storage_mon" },
    { 0xF93F2EA3, "lander_station_think" },
    { 0x8A350795, "lander_status_light" },
    { 0xB5CC0771, "lander_struct" },
    { 0xF0C6D0E1, "lander_take_off" },
    { 0x6FBFB6AE, "lander_takeoff_wobble" },
    { 0x6C4C1630, "lander_trig" },
    { 0x96EED5AC, "lander_use_trig" },
    { 0x0D4442F6, "landers" },
    { 0x038BBE02, "landfunctionoverride" },
    { 0x27BD23BA, "landing" },
    { 0xB1F74D46, "landing_aa_fire" },
    { 0x9FF84BE8, "landing_air_battle_manager" },
    { 0xEF7BDB4D, "landing_done" },
    { 0x2BD32388, "landing_door_docks_left" },
    { 0xB5602CD7, "landing_door_docks_right" },
    { 0x213B64D2, "landing_door_roof_left" },
    { 0x04272A41, "landing_door_roof_right" },
    { 0xC36A6182, "landing_dust_fx" },
    { 0xC61CC063, "landing_gate_docks_left" },
    { 0x2D6033D6, "landing_gate_docks_right" },
    { 0x6EFD083F, "landing_gate_roof_left" },
    { 0x41F63DDA, "landing_gate_roof_right" },
    { 0x5DF66B7F, "landing_gears" },
    { 0xDAF7B4DD, "landing_lods" },
    { 0x81EDC4A6, "landing_main" },
    { 0x588FE899, "landing_node" },
    { 0x1B98704B, "landing_pad_asd_idle_think" },
    { 0xD11BDA51, "landing_pad_watcher" },
    { 0x74606583, "landing_pilot_scenes" },
    { 0x3A1E08FA, "landing_player_scene_start" },
    { 0x6DF1B926, "landing_player_scenes" },
    { 0xC8ECA702, "landing_rumble_on_player" },
    { 0xD3F019C7, "landing_rumble_start" },
    { 0xD85141A1, "landing_spot" },
    { 0x69D21B60, "landing_spot_found" },
    { 0x15CD5348, "landing_spots" },
    { 0x5813A868, "landing_vtol_flock_manager" },
    { 0xEEC37B7B, "landing_zone" },
    { 0xF669EDDF, "landingdistance" },
    { 0x9F4C9669, "landingfx1" },
    { 0x03830435, "landings" },
    { 0xFB532E19, "landingstate" },
    { 0x2886D9DC, "landingthresh" },
    { 0x5CBC8AE1, "landmark" },
    { 0xF17FBAC8, "landmarkent" },
    { 0xCBEED788, "landmarks" },
    { 0x44E18268, "landpos" },
    { 0x0C23F776, "landposonground" },
    { 0x85692A59, "lands" },
    { 0x024B987C, "landscape" },
    { 0xA82A138F, "lane" },
    { 0x4663A113, "lane2trucks" },
    { 0xDEC9B250, "laneid" },
    { 0x50058556, "lanes" },
    { 0x39969C94, "lanfing" },
    { 0x4885B9F0, "lang_english" },
    { 0x0C42ECE3, "language" },
    { 0xA86EB8CD, "languished" },
    { 0x88F7E6C3, "lantern" },
    { 0xB91E5A92, "lantern01" },
    { 0x1FF39D39, "lantern_crashing" },
    { 0xE6B75026, "lantern_hang_on" },
    { 0x121C6889, "lantern_teleporting" },
    { 0x68090032, "lanterns" },
    { 0x1C6000A6, "laong" },
    { 0x2E8FE986, "laos" },
    { 0x4BFC9978, "lap" },
    { 0x6EFECEAC, "lapd" },
    { 0x07F019A8, "lapd_ai_hotel_turn" },
    { 0x3F635CBB, "lapd_escort" },
    { 0x17CEEA79, "laptop" },
    { 0xCB67820E, "laptopwait" },
    { 0xCAA40D1E, "large" },
    { 0x7EAB19C4, "large_array" },
    { 0x0A47D6E0, "large_concrete_1" },
    { 0xF9A39584, "large_crowd" },
    { 0xF3165B2D, "large_goal_radius_with_enemy" },
    { 0xE661D172, "large_search_radius" },
    { 0x713F3DC3, "largely" },
    { 0xF2B2A518, "larger" },
    { 0xDEF0C287, "largest" },
    { 0xBDF7A86C, "largest_radius" },
    { 0xCC11904E, "largestcomparefunc" },
    { 0x6F62EC74, "largestcount" },
    { 0x935D1EC8, "largestcountindex" },
    { 0x7BCE1F56, "largstr" },
    { 0x77CEC4D5, "larry" },
    { 0xEEE8FF82, "larry_ai" },
    { 0x5D79797E, "larry_ai_damage" },
    { 0xA3678697, "larry_ai_health" },
    { 0xDE3F36B9, "larry_ai_thread" },
    { 0x36CB859C, "larry_hud_destroy" },
    { 0x28DEE610, "larry_hud_init" },
    { 0x64AFD89E, "larry_init" },
    { 0x199EFE7B, "larry_the_limper" },
    { 0xA32DF3AA, "larry_the_limper_tweaktech" },
    { 0xAB98BF97, "larry_the_limper_tweaktech_fast" },
    { 0xC0938265, "larry_the_limper_tweaktech_halved" },
    { 0xDE893D08, "larry_thread" },
    { 0x047339A4, "lase" },
    { 0x50B88A46, "lase_goal" },
    { 0x565DAAC6, "lase_points" },
    { 0xB39FFFD7, "lase_points_loop" },
    { 0x91410B6E, "laser" },
    { 0x9603D750, "laser_awareness" },
    { 0x120B1E9B, "laser_death_thread_stop" },
    { 0x735CBC74, "laser_death_watcher" },
    { 0xCACD80E4, "laser_doors" },
    { 0xC6DE68A0, "laser_hint_ent" },
    { 0x6862F525, "laser_hint_on_mg" },
    { 0xFBAE4662, "laser_movement" },
    { 0xA420FA6E, "laser_on" },
    { 0x286BCE6C, "laser_should_be_on" },
    { 0x83DBA80D, "laser_sight_loop" },
    { 0x8A6732C9, "laser_turret_challenge" },
    { 0x5EEBB602, "laser_turret_fire" },
    { 0xDC3B0E9C, "laser_turret_idle" },
    { 0xCB355315, "laser_turret_killed" },
    { 0x4BD2729A, "laser_turret_think" },
    { 0xF60907B1, "lasered" },
    { 0xA28838AC, "laserfx" },
    { 0xE01FF155, "laseroff" },
    { 0x062A7329, "laseron" },
    { 0xD228C491, "lasers" },
    { 0x9321C02D, "lasing" },
    { 0x1895EB62, "lass" },
    { 0x8A9D5A9D, "last" },
    { 0x66746253, "last_aa_defense" },
    { 0x1D772614, "last_aa_guns" },
    { 0x1697ABC4, "last_aa_guns_objective" },
    { 0xB93E0EFE, "last_action" },
    { 0x4A84F147, "last_active_round" },
    { 0x868464BB, "last_ahead" },
    { 0xDDC0A71D, "last_ai_down" },
    { 0x1414F4E7, "last_ai_origin" },
    { 0x86F1EE86, "last_ai_spawn_time" },
    { 0xA971B4AF, "last_airstrike_counter" },
    { 0xA98C2B47, "last_ais_spawners" },
    { 0xD1B5C153, "last_alive" },
    { 0x9360848B, "last_ambient_vo_convoy" },
    { 0x7BDEEF39, "last_angle" },
    { 0x6800B570, "last_angles" },
    { 0x326DB9B5, "last_anim_time" },
    { 0x5E3B7560, "last_anim_time_check" },
    { 0xA3375F3D, "last_arena" },
    { 0x217A0A61, "last_attacker" },
    { 0x4CBB8D8F, "last_bad_path_time" },
    { 0x3AF5560D, "last_badplace_pos" },
    { 0x241F0FBE, "last_bar_width" },
    { 0xB95C4675, "last_barracks_group" },
    { 0x97D0352E, "last_battle_phase_1" },
    { 0x327C4863, "last_battle_trigger" },
    { 0x9B8F8B0E, "last_blackjack_consumable_time" },
    { 0x2FEE58CB, "last_bleed_out_time" },
    { 0xD17B0D74, "last_board_torn" },
    { 0xFDECE0B8, "last_boat_hit_time" },
    { 0x250B8C36, "last_box_weapon" },
    { 0x840930A6, "last_brutus_down" },
    { 0xD27FB413, "last_brutus_on_bridge" },
    { 0x573CB084, "last_brutus_on_bridge_custom_func" },
    { 0xBF3A56E4, "last_brutus_origin" },
    { 0xB851A352, "last_callout_direction" },
    { 0xFF3BAD0F, "last_calvary_target_done" },
    { 0x5A9E7F7D, "last_cam" },
    { 0xB4333F50, "last_camp_loc" },
    { 0x43159258, "last_change" },
    { 0x27A41FDD, "last_charge_set" },
    { 0xCBBCF80F, "last_chosen_index" },
    { 0xB0D416A3, "last_claw_time" },
    { 0xE851A942, "last_clip" },
    { 0x314B454B, "last_closest_player" },
    { 0xCCC7AD0F, "last_closest_time" },
    { 0x72E92099, "last_cmd_send_chopper" },
    { 0xC242A0DB, "last_completed" },
    { 0xC5D90674, "last_completed_stage" },
    { 0xF1E7A76F, "last_cougar" },
    { 0x27021DC0, "last_counterattack" },
    { 0x0E318ABE, "last_counterattack_vo" },
    { 0x2E05FCE6, "last_crack_time" },
    { 0x5BD961DC, "last_crew_member" },
    { 0x43004333, "last_crouched_time" },
    { 0xB89C46E9, "last_crumb" },
    { 0x9BA28AED, "last_custom_sound_played" },
    { 0x0510741A, "last_custom_zombie_sound_time" },
    { 0x2EF23937, "last_daily_mp_contract_index" },
    { 0xCFED58F3, "last_damage" },
    { 0xCE47EEE7, "last_damage_from_zombie_or_player" },
    { 0xE440B4D1, "last_damage_hit_armor" },
    { 0xA794E2E8, "last_damage_line" },
    { 0xA00BE1FA, "last_damage_mod" },
    { 0x2F9CC55D, "last_damage_state" },
    { 0xE3454D01, "last_damage_time" },
    { 0x0FA9935F, "last_damaged_at" },
    { 0xEE2BD231, "last_days" },
    { 0xF7C31A9B, "last_debug_zone_index" },
    { 0x38EF25B8, "last_defend_axis_killed" },
    { 0x4E2E6132, "last_defend_tanks_killed" },
    { 0x6FA52431, "last_defenders_cleared" },
    { 0xED26DB19, "last_defenders_trig" },
    { 0x801004D0, "last_destination" },
    { 0x1EAE073B, "last_dialog_done" },
    { 0x7578FCBB, "last_dialogue_line" },
    { 0x247131D7, "last_dialogue_line_played" },
    { 0x40A970C0, "last_dist" },
    { 0xB22651AC, "last_distance_from_goal_squared" },
    { 0x45D215C1, "last_dog_down" },
    { 0xAD1233D3, "last_dog_origin" },
    { 0x2FD857BD, "last_drop_wave" },
    { 0x0D28C57C, "last_emergency_crack_time" },
    { 0x48CF0E4F, "last_emotion" },
    { 0x9C3E8184, "last_enemy" },
    { 0xC8AC5068, "last_enemy_sighting_position" },
    { 0x451F1171, "last_ent_moved_to" },
    { 0x7D760698, "last_exit_moved" },
    { 0xFEBAF565, "last_explosion" },
    { 0xF6B5BC23, "last_failsafe_count" },
    { 0x82E95B01, "last_failsafe_time" },
    { 0x40D97BDF, "last_fire_pos" },
    { 0x7E0BBCBA, "last_firefight_teamtrigger" },
    { 0x039E35A7, "last_flag_set" },
    { 0x507C7576, "last_flamethrower_time" },
    { 0x5D6D5C20, "last_frac" },
    { 0x20E45127, "last_frame" },
    { 0x0139825B, "last_fx_index" },
    { 0x36F61699, "last_gear" },
    { 0x73542680, "last_get_time" },
    { 0xF3433D29, "last_goalpos" },
    { 0xA3188C23, "last_goalradius" },
    { 0xD22FC442, "last_grazed_line" },
    { 0xDC7C4951, "last_ground" },
    { 0x4BAB4E61, "last_guy" },
    { 0x69FDE2C9, "last_hacked_round" },
    { 0xAE98D500, "last_hash" },
    { 0x973E5962, "last_health" },
    { 0x8BC8AC71, "last_heavy_damage_time" },
    { 0x864F68B1, "last_height" },
    { 0xD52C5150, "last_hero" },
    { 0x8D9CB2D2, "last_hider" },
    { 0x93D35B85, "last_hit_team" },
    { 0x2AB11965, "last_hit_time" },
    { 0xF3252FBF, "last_hit_vo" },
    { 0x2D23E49E, "last_human_standing" },
    { 0x8662BEA1, "last_hurt_time" },
    { 0xE4130457, "last_id" },
    { 0x914693C4, "last_index" },
    { 0x886CD3AD, "last_item" },
    { 0xC3EFFA35, "last_jump_chance_time" },
    { 0x60722328, "last_kill_method" },
    { 0x10348BEE, "last_kill_vo" },
    { 0x0B67C291, "last_killed_time" },
    { 0xBD2D7466, "last_layer_of_death" },
    { 0xFBE9F792, "last_leaper_down" },
    { 0xAE8E70D8, "last_leaper_origin" },
    { 0xB856F814, "last_left_clip" },
    { 0xF77B1AB0, "last_left_ladder_climb" },
    { 0xC15ECF6B, "last_lerp" },
    { 0xD5F16802, "last_level" },
    { 0x1B9ADFCB, "last_level_num" },
    { 0x5D6B2C9E, "last_line" },
    { 0xE54189CC, "last_line_played" },
    { 0xA1384F4E, "last_look_trig_time" },
    { 0x978A14D2, "last_man_standing_group_one" },
    { 0x2DB480BE, "last_man_standing_group_one_count" },
    { 0x0C03EB77, "last_man_standing_group_one_watcher" },
    { 0x186ACEB4, "last_man_standing_group_two" },
    { 0x7ED9DAA0, "last_man_standing_group_two_count" },
    { 0x2D6913D9, "last_man_standing_group_two_watcher" },
    { 0x80F3CA12, "last_map" },
    { 0xE78E6563, "last_map_index" },
    { 0x04CEDE2A, "last_mechz_down" },
    { 0xCF82E110, "last_mechz_origin" },
    { 0x44A25C2F, "last_microwave_turret_fx_trace" },
    { 0xB7CF3433, "last_minute_sight_traces" },
    { 0xC212D6D2, "last_mission_sound_time" },
    { 0x30CF082E, "last_mix_val" },
    { 0x6992729D, "last_modelfunc" },
    { 0x63287EAC, "last_mortar_nag" },
    { 0x4D21D2F8, "last_mortar_point" },
    { 0xEEF97627, "last_move" },
    { 0xA6992F3F, "last_movement" },
    { 0x445840BB, "last_music_state" },
    { 0x88F7E1D6, "last_nearby_trig_time" },
    { 0x8337B6F4, "last_node" },
    { 0x40925D18, "last_node_dir" },
    { 0x3B7E3F9E, "last_node_update_position" },
    { 0x358C3104, "last_not_here" },
    { 0xC21143FD, "last_num_plates_active" },
    { 0x9F2F22EF, "last_obj" },
    { 0x202F7579, "last_objective" },
    { 0x75AE2E9E, "last_oob_duration_ms" },
    { 0x9E2D7C86, "last_oob_timekeep_ms" },
    { 0x00DEFB5A, "last_org" },
    { 0xF7E6B316, "last_origin" },
    { 0xAB3CD200, "last_outside_warning_time" },
    { 0x3F60B964, "last_pain_time" },
    { 0xC9D3332B, "last_participation" },
    { 0x5FCC28AC, "last_patrol_goal" },
    { 0x96653785, "last_perk_index" },
    { 0x9F14A3A5, "last_phase" },
    { 0xDEE52FE1, "last_pistol_swap" },
    { 0x990DCBF9, "last_placeable_mine_uimodel" },
    { 0xBF31CCFE, "last_plane_crash" },
    { 0x94DCB64E, "last_plate_state" },
    { 0xA7495E87, "last_player_attacker" },
    { 0x011D1FD1, "last_player_avoid_offset" },
    { 0xC25D7874, "last_player_died" },
    { 0x12AC343C, "last_player_rammed_time" },
    { 0x671AF523, "last_player_speed" },
    { 0xC7EEA834, "last_player_z" },
    { 0x1E1A0574, "last_poi" },
    { 0xB2BD4432, "last_point" },
    { 0x3A0B26FE, "last_pos" },
    { 0x8C62A64F, "last_pos_x" },
    { 0x66602BE6, "last_pos_y" },
    { 0x817D32BE, "last_price_kill" },
    { 0x8EAA4D84, "last_price_line" },
    { 0xCAEA1B29, "last_progress" },
    { 0xE0F0923B, "last_queue_time" },
    { 0xC9B37D3B, "last_rain_round" },
    { 0x44FAD35D, "last_rand" },
    { 0xA8684792, "last_reminder" },
    { 0x4A59EB3A, "last_repaired_chunk" },
    { 0x412ADFB6, "last_reverse_time" },
    { 0x474ED377, "last_right_ladder_climb" },
    { 0x49D97E38, "last_robot" },
    { 0xB00CDF14, "last_rocket_count" },
    { 0xE9CFA030, "last_round_number" },
    { 0x492E480D, "last_round_restored" },
    { 0x7E43D2E2, "last_run_kill_player" },
    { 0xB4737E2F, "last_safety_volume" },
    { 0xCB3433ED, "last_sam" },
    { 0x17911606, "last_score" },
    { 0x560FA114, "last_screen_dirt" },
    { 0x24D7883E, "last_seen_loss_latency" },
    { 0x2307A65F, "last_selected_entity_has_changed" },
    { 0xE62C655A, "last_selection" },
    { 0x902A07DA, "last_sent_notify" },
    { 0x0D092B11, "last_set_goalent" },
    { 0xF255BAFE, "last_set_goalnode" },
    { 0x746FEE8C, "last_set_goalpos" },
    { 0xBAE2F7EB, "last_signal_node" },
    { 0x966267A2, "last_slide_heli" },
    { 0x5D843B44, "last_snow_round" },
    { 0xCD9580BB, "last_song" },
    { 0xB94B298D, "last_spawn" },
    { 0x82DBB8F4, "last_spawn_index" },
    { 0x5793DA66, "last_spawn_origin" },
    { 0xDD33253B, "last_spawn_time" },
    { 0x4F0762D9, "last_special_mp_contract_index" },
    { 0x64595781, "last_speed" },
    { 0xF0410FE9, "last_speed_penalty_time" },
    { 0x920CA5B9, "last_speed_val" },
    { 0x27C35F33, "last_spline" },
    { 0x60A2D680, "last_stand" },
    { 0x91BC7CB5, "last_stand_ai" },
    { 0x84B1EC62, "last_stand_attacker_failed" },
    { 0x91D3B895, "last_stand_best_pistol" },
    { 0x21A82999, "last_stand_compare_pistols" },
    { 0x96F0C535, "last_stand_conscience_vo" },
    { 0xD92356C9, "last_stand_enemies" },
    { 0xE3426AA9, "last_stand_enemy" },
    { 0x43AA4FF0, "last_stand_grenade_save_and_return" },
    { 0x9BE4CD20, "last_stand_main" },
    { 0x8F1A41EA, "last_stand_meat_nudge" },
    { 0x89A56458, "last_stand_minimum_pistol_override" },
    { 0xFFEBEE93, "last_stand_monitor" },
    { 0xE7CFA7B8, "last_stand_pistol_rank_init" },
    { 0xA47DC1DC, "last_stand_pistol_swap" },
    { 0x2387420C, "last_stand_player_failed" },
    { 0x0024F27C, "last_stand_restore_pistol_ammo" },
    { 0xEC58B9B8, "last_stand_revive" },
    { 0x49522263, "last_stand_save_pistol_ammo" },
    { 0xCE27FD80, "last_stand_take_thrown_grenade" },
    { 0xFF0745CB, "last_stand_thread" },
    { 0x58AC4D7E, "last_stand_vo" },
    { 0x2A86B8D9, "last_stand_vo_nag" },
    { 0xCDED3455, "last_stander" },
    { 0x71EC613A, "last_start_node_index" },
    { 0x2CF9599F, "last_state" },
    { 0x1B906A77, "last_stink_zombie_spawned" },
    { 0x63D31D2A, "last_stock" },
    { 0x9179A550, "last_tank" },
    { 0x3FFE7B06, "last_tank_deaths" },
    { 0x231772C2, "last_tank_fires" },
    { 0xF729E47C, "last_tank_shoot_strat_2" },
    { 0x498D7A47, "last_tank_strat" },
    { 0x6837DC18, "last_tanks_skipto_debug" },
    { 0x4C9BCE9F, "last_task" },
    { 0x86CF9A6B, "last_team" },
    { 0x489E477C, "last_teammate" },
    { 0x8E3989AA, "last_thief_give_flip_time" },
    { 0x7638AAFB, "last_thing_to_hit_me" },
    { 0xCE1F7160, "last_threat_debug" },
    { 0xCAF26BAB, "last_time" },
    { 0x849F4207, "last_time_played" },
    { 0xA7099739, "last_timeout" },
    { 0x7A28C85E, "last_total" },
    { 0x393FBBCA, "last_tree_attacker" },
    { 0x28F5C650, "last_trench_banzai" },
    { 0xED082D24, "last_trench_chain" },
    { 0x9A251104, "last_trigger" },
    { 0x48287CA0, "last_trigger_time" },
    { 0x634787F9, "last_truck" },
    { 0xF8164522, "last_truck_strat" },
    { 0x7512D2AC, "last_undo_state" },
    { 0xE97D2823, "last_update" },
    { 0x3762F295, "last_used_time" },
    { 0x7613B96C, "last_valid_position" },
    { 0xDDB622E3, "last_valid_position_override" },
    { 0x4B4AE1B6, "last_variable_offset" },
    { 0xFB0D7AA8, "last_visionset" },
    { 0xC2667465, "last_vo" },
    { 0x50078D17, "last_vo_played_time" },
    { 0x78A9DA73, "last_vo_time" },
    { 0xA0873B03, "last_wait_spread" },
    { 0x731104EA, "last_wall_normal" },
    { 0x83406C70, "last_warning_time" },
    { 0x977CECEB, "last_water_check_pos" },
    { 0xFF02D5FD, "last_wave_forced" },
    { 0x561401CF, "last_wave_position" },
    { 0xDEEA3953, "last_wave_vo" },
    { 0x091B780C, "last_weapon" },
    { 0xF6B5FAC2, "last_weapon_hit" },
    { 0x5D855A8E, "last_weapon_name" },
    { 0x5C896DF9, "last_weekly_mp_contract_index" },
    { 0xF37F331C, "last_x_axis" },
    { 0x08B50997, "last_y_axis" },
    { 0xD23DB1AF, "last_zone_captured" },
    { 0xC26D3B77, "lastactiveweapon" },
    { 0xF062352D, "lastalivecount" },
    { 0xC740680C, "lastammocount" },
    { 0x34485B92, "lastangle" },
    { 0x9C73E6E2, "lastanim" },
    { 0x57613FC5, "lastanimframe" },
    { 0xEC78C712, "lastanimspot" },
    { 0x1D761012, "lastanimtype" },
    { 0xE9339DAA, "lastarena" },
    { 0x386DE34E, "lastattackedshieldplayer" },
    { 0x2C5D4906, "lastattackedshieldtime" },
    { 0x1F2BEFD4, "lastattacker" },
    { 0x81C42B72, "lastattackerorigin" },
    { 0x47331425, "lastattackweapon" },
    { 0xCAA6DC14, "lastattempt" },
    { 0x72CFFD50, "lastautosavetime" },
    { 0xA10B2F82, "lastbattlechatter" },
    { 0x30B9EACC, "lastbcattempttime" },
    { 0x40D87185, "lastblast" },
    { 0x048BA472, "lastbleedouttime" },
    { 0xD297F6C0, "lastbloodupdate" },
    { 0xD7C2E234, "lastbombexplodebyteam" },
    { 0xAEE31363, "lastbombexplodetime" },
    { 0x117F7EA6, "lastburnedby" },
    { 0x39F92A0D, "lastcall" },
    { 0xD08F7AE9, "lastcameramode" },
    { 0x070D7750, "lastcanplacecarryqrdrone" },
    { 0x21FBE15E, "lastcapkiller" },
    { 0xD41A6802, "lastcaptureteam" },
    { 0x3945CBF4, "lastcarexplosiondamagelocation" },
    { 0x5ACE139F, "lastcarexplosionlocation" },
    { 0x6F6595C1, "lastcarexplosionrange" },
    { 0x03EC0685, "lastcarexplosiontime" },
    { 0xD0362086, "lastcenter" },
    { 0x710F1063, "lastcheckedtime" },
    { 0xC4F702B6, "lastcheckstate" },
    { 0x21BFC489, "lastchunk_destroy_time" },
    { 0x0CA22EA0, "lastclaimteam" },
    { 0x636C4728, "lastclaimtime" },
    { 0x9C42D2C3, "lastclass" },
    { 0x0DBCD490, "lastclipcount" },
    { 0x55B7F1BA, "lastcolor" },
    { 0xB8C2C0A9, "lastcolorforced" },
    { 0xEAFF45DC, "lastcolorforced_exists" },
    { 0xD69BADF8, "lastcompleted" },
    { 0x6B3778A9, "lastconcussedby" },
    { 0x2C7F48FB, "lastcontact" },
    { 0x0EC0AF01, "lastcough" },
    { 0xF14CE542, "lastcount" },
    { 0x75E74B2F, "lastdamagelocation" },
    { 0x1F7AA415, "lastdamagetime" },
    { 0xF5649D63, "lastdamagewasfromenemy" },
    { 0xE39AA65F, "lastdarkline" },
    { 0xA3BE9036, "lastdeathicon" },
    { 0x894CBF99, "lastdeathpos" },
    { 0x75CF4F7F, "lastdebugheight" },
    { 0xA94EFE9B, "lastdebugprint" },
    { 0x5C7FFA28, "lastdebugprint1" },
    { 0x55488891, "lastdest" },
    { 0x1113E5DE, "lastdhplayer" },
    { 0xC2A60B96, "lastdialogtime" },
    { 0xEF12F64A, "lastdir" },
    { 0xDA068F78, "lastdirection" },
    { 0x7EE7B150, "lastdistancesq" },
    { 0xF61FC61A, "lastdistcalc" },
    { 0x0857DC89, "lastdisttoenemysquared" },
    { 0x98F69FD5, "lastdisttype" },
    { 0x7382642F, "lastdogmeleeplayertime" },
    { 0x26DC3219, "lastdoublejumpstarttime" },
    { 0x93A4EF87, "lastdroplocation" },
    { 0x5ACBF4E2, "lastdroppableweapon" },
    { 0x8562914E, "lastdvar" },
    { 0xE9B33A6F, "lastencountertime" },
    { 0x06CD0E37, "lastenemy" },
    { 0x1B42B343, "lastenemypos" },
    { 0xFFEC2E60, "lastenemyshotat" },
    { 0xF6D1FB14, "lastenemysightpos" },
    { 0x8F059793, "lastenemysightposold" },
    { 0x2E19B8D8, "lastenemysightposselforigin" },
    { 0x5BBBA01D, "lastenemysighttime" },
    { 0x3DD502E4, "lastenemytime" },
    { 0x1D27D465, "lastexecutedat" },
    { 0x6572D801, "lastexplodingbarrel" },
    { 0x472159DB, "lastfastreloadtime" },
    { 0xD723DBD7, "lastfavoriteenemy" },
    { 0x0C74CBF6, "lastfiretime" },
    { 0x244AC024, "lastflagbearer" },
    { 0xEF23ADB9, "lastflamehurtaudio" },
    { 0x491FBCE2, "lastflaredby" },
    { 0x3D2DAAFA, "lastflashed" },
    { 0xA7873455, "lastflashedby" },
    { 0xB6532634, "lastflinchtime" },
    { 0x7455C95B, "lastfoughttime" },
    { 0xEAFBFB38, "lastfpspoint" },
    { 0xFCAAFB95, "lastfrac" },
    { 0x09C738AE, "lastfragcount" },
    { 0xF268FB6F, "lastfraggrenadetoplayerstart" },
    { 0x08E1994C, "lastfriendlyproximitywarningplayed" },
    { 0x9C280160, "lastfriendlytrigger" },
    { 0x67D28AEB, "lastfx" },
    { 0x6B1A589E, "lastgibtime" },
    { 0xC5684149, "lastgoalrad" },
    { 0x6533DE6E, "lastgoodang" },
    { 0x238733FA, "lastgoodspot" },
    { 0x4D08BA4B, "lastgrenadelandednearplayertime" },
    { 0x686F75E4, "lastgrenadesuicidetime" },
    { 0xF3D2B0B8, "lastgrenadethrowtime" },
    { 0xE92E2D7A, "lastgrenadetime" },
    { 0x6B85CB18, "lastgroundtype" },
    { 0xC7180621, "lastgroupsightspot" },
    { 0x840AF47E, "lastguy" },
    { 0x24B049EB, "lasthastargettime" },
    { 0x42048A5B, "lasthighlightedent" },
    { 0xBE4B5B50, "lasthit" },
    { 0x633CA1F4, "lasthitmarkeroffsettime" },
    { 0x9FA6D031, "lasthitmarkertime" },
    { 0x33094198, "lasthitmarkertimes" },
    { 0x90B686B5, "lasthitstamp" },
    { 0x95CA4DA0, "lasthostmigrationstate" },
    { 0x96D2E5E8, "lastidleanim" },
    { 0x20BA71CF, "lastindex" },
    { 0xF65FD18B, "lasting" },
    { 0x05B474A5, "lastinhierarchy" },
    { 0xD80FBB0E, "lastinvulratio" },
    { 0x05841BE5, "lastitemcount" },
    { 0xC4140F42, "lastjukeinfoupdatetime" },
    { 0xF0D65155, "lastjuketime" },
    { 0x5BAE0AD2, "lastkillcam" },
    { 0xD88E62FD, "lastkillconfirmedcount" },
    { 0xCDAB9B1B, "lastkillconfirmedtime" },
    { 0xFCA544B5, "lastkilledby" },
    { 0x22645F65, "lastkilledplayer" },
    { 0x6D121592, "lastkilledvictim" },
    { 0x5128F38F, "lastkilledvictimcount" },
    { 0x61AF974A, "lastkilltime" },
    { 0x1F225890, "lastkillwheninjured" },
    { 0xD0491528, "lastknownenemypos" },
    { 0x1D3D63FC, "lastknownpos" },
    { 0x78D7CF6F, "lastknownpostime" },
    { 0x8F7ACC8A, "lastknownspot" },
    { 0xF11F2FD9, "lastknowntargetloc" },
    { 0x5AE20C85, "lastknowntime" },
    { 0xF11F9DDC, "lastlastside" },
    { 0x4FBEA8E4, "lastlefttreadhealth" },
    { 0x90A6A9EB, "lastlegitimateattacker" },
    { 0x48E8C129, "lastlightline" },
    { 0x85F415E0, "lastlighttime" },
    { 0xD9448919, "lastlink" },
    { 0x0C4769D6, "lastlookedattheplayer" },
    { 0x08188FA0, "lastly" },
    { 0x4DB51A46, "lastmagical_armory" },
    { 0xF2108348, "lastmagical_exit_taken" },
    { 0x73012CB2, "lastmansd" },
    { 0xD5FF02FA, "lastmansddefeat3enemies" },
    { 0xDDC6AB3B, "lastmanstanding" },
    { 0xA9B0A714, "lastmeleegiveuptime" },
    { 0xBD1DCA20, "lastmenu" },
    { 0xCA23FC25, "lastmessagetime" },
    { 0x1AAD45D7, "lastmicrowavedby" },
    { 0xEB0B0486, "lastminutesighttraces" },
    { 0xC470E2B2, "lastmissedenemy" },
    { 0x368B0AB6, "lastmortar" },
    { 0x73694131, "lastmortarincomingtime" },
    { 0x6D3ADEDC, "lastmultiplier" },
    { 0x2E25458E, "lastnagtime" },
    { 0xEB07BFE4, "lastname" },
    { 0xC20D34EB, "lastnewgoaltime" },
    { 0x2FEFD27D, "lastnode" },
    { 0xF6645C44, "lastnonkillstreakweapon" },
    { 0xDF2CF4E9, "lastnonshieldweapon" },
    { 0xF25FA35F, "lastnonuseweapon" },
    { 0xBA4964EA, "lastnotetrack" },
    { 0x757AC9D5, "lastnotetrackanim" },
    { 0x1312C012, "lastnotetrackanimtime" },
    { 0xA090E9FE, "lastnotify" },
    { 0x87F1BE9F, "lastobituaryplayer" },
    { 0xB4442B9C, "lastobituaryplayercount" },
    { 0x420A01BC, "lastoffset" },
    { 0x3B73CF59, "lastorg" },
    { 0xE090FC93, "lastorigin" },
    { 0x9308ECFF, "lastoutwatertimestage" },
    { 0xD8744F4E, "lastowner" },
    { 0x3A9CC6A1, "lastownerteam" },
    { 0x7613F43C, "lastpage" },
    { 0x45F27FE1, "lastparticlelight" },
    { 0x59414F11, "lastphasetime" },
    { 0x54FEEAF6, "lastpit_trap" },
    { 0x06B190D8, "lastplacedturret" },
    { 0x80E56FF5, "lastplane" },
    { 0x945241EF, "lastplayedfaultvocheckpoint" },
    { 0x6656A4F2, "lastplayedfaultvotime" },
    { 0x76365FAA, "lastplayer" },
    { 0x2233B605, "lastplayeralive" },
    { 0x9E565708, "lastplayerorigin" },
    { 0xE775EC6E, "lastplayersighted" },
    { 0xDF390185, "lastpoint" },
    { 0xA98734A1, "lastpoisonedby" },
    { 0xD4E6735D, "lastpos" },
    { 0xFAC7DB84, "lastposition" },
    { 0x6124BC10, "lastprogress" },
    { 0xB2A4F49F, "lastpromotiontime" },
    { 0xFBBB8006, "lastradiotransmission" },
    { 0x26708C3D, "lastrambotime" },
    { 0x8D7A9BAE, "lastrandomline" },
    { 0xC4FEA20F, "lastrate" },
    { 0xD4A63ABE, "lastratio" },
    { 0x85B83697, "lastreactiontime" },
    { 0xA55F84ED, "lastreloadtime" },
    { 0x7965D00C, "lastrelpos" },
    { 0x0FF0BD41, "lastrescuedby" },
    { 0x81891059, "lastrescuedtime" },
    { 0x54C0F395, "lastrighttreadhealth" },
    { 0xD9649D76, "lastrocketfiretime" },
    { 0x5F9DD7D7, "lastround" },
    { 0xC2663C3E, "lastrunrate" },
    { 0x01C3C3DC, "lasts" },
    { 0x9E7945E1, "lastsavetime" },
    { 0xFB22345F, "lastsawenemytime" },
    { 0x7A46C519, "lastsaytime" },
    { 0xB319EA8D, "lastselect" },
    { 0x1CC1EDC4, "lastselectablestate" },
    { 0x72F07198, "lastselectentity" },
    { 0xA2146582, "lastsequence" },
    { 0x2E89419F, "lastservertime" },
    { 0xA0A1B70D, "lastshockedby" },
    { 0x00790801, "lastshoottime" },
    { 0x4D77A79E, "lastshotby" },
    { 0xCB86569A, "lastshottime" },
    { 0x1D44023C, "lastside" },
    { 0x339DBF0D, "lastsidestepanim" },
    { 0xE9E7350D, "lastsidesteptime" },
    { 0x9F498097, "lastsightposwatch" },
    { 0xE0C5D87C, "lastsighttracetime" },
    { 0xFE13BC2F, "lastsightupdater" },
    { 0x6E42EC17, "lastslidestarttime" },
    { 0x86D75230, "lastslowprocessframe" },
    { 0x38BCDABC, "lastsoundtime_recover" },
    { 0x4D721869, "lastspawneddog" },
    { 0x4D1E065E, "lastspawnedplayer" },
    { 0x40952794, "lastspawnpoint" },
    { 0xF5190531, "lastspawntime" },
    { 0x858124FA, "lastspeaktime" },
    { 0x0F5BCCAE, "lastsprinttime" },
    { 0x6D6B10F1, "lastsquad" },
    { 0x2F83EEE0, "lastsquadchecksum" },
    { 0xE24030DE, "lastsquadselected" },
    { 0x564407FB, "laststand" },
    { 0xCD4CED7A, "laststand_allowed" },
    { 0x53795DC2, "laststand_bleedout" },
    { 0x14DFC20F, "laststand_bleedout_init" },
    { 0xF10C3F61, "laststand_breach" },
    { 0x414929FF, "laststand_can_pick_self_up" },
    { 0x56D93A9E, "laststand_clean_up_on_disconnect" },
    { 0x9E43F7F9, "laststand_clean_up_on_interrupt" },
    { 0xEEF372CB, "laststand_clean_up_reviving_any" },
    { 0x44C0F2C1, "laststand_clear" },
    { 0x8447FC1B, "laststand_count" },
    { 0x30312660, "laststand_disable_player_weapons" },
    { 0x80F9CB89, "laststand_elev_zombies_away" },
    { 0xB308F533, "laststand_enable_player_weapons" },
    { 0x7672E2CF, "laststand_enemies1" },
    { 0x046B7394, "laststand_enemies2" },
    { 0x2A6DEDFD, "laststand_enemies3" },
    { 0xF7ACEBFE, "laststand_enemies_common" },
    { 0x29B66A87, "laststand_enemyspawn" },
    { 0x38C5DA09, "laststand_getup" },
    { 0xBD607C95, "laststand_getup_bar_damage" },
    { 0x19E72B40, "laststand_getup_count_start" },
    { 0x5D050FCA, "laststand_getup_damage_watcher" },
    { 0x942D2586, "laststand_getup_fast" },
    { 0x5006C91F, "laststand_getup_hud" },
    { 0xFED0EE90, "laststand_getup_hud_destroy" },
    { 0xD5007AFE, "laststand_give_grenade" },
    { 0x38EC1891, "laststand_give_pistol" },
    { 0x7568E30A, "laststand_giveback_player_perks" },
    { 0xB446F0E6, "laststand_giveback_player_weapons" },
    { 0x72C619A4, "laststand_global_init" },
    { 0x5A4516C2, "laststand_grenade_safe_dist_sq" },
    { 0x2CA92803, "laststand_has_players_weapons_returned" },
    { 0x684FFC63, "laststand_hero_think" },
    { 0x8739D28D, "laststand_hud" },
    { 0xC8F463F9, "laststand_hud_lives" },
    { 0x9C12843E, "laststand_ignoreme" },
    { 0x5AD7FF7E, "laststand_info" },
    { 0xB623B4CB, "laststand_lander_link" },
    { 0xE4B1BF1F, "laststand_lives_updated" },
    { 0x311E9401, "laststand_main" },
    { 0xA75C3365, "laststand_msg" },
    { 0xE8063C0B, "laststand_nudge" },
    { 0x4EA33925, "laststand_perks" },
    { 0x34F20BB5, "laststand_shared" },
    { 0x3BD22D6B, "laststand_take_player_weapons" },
    { 0xAC9D6CE9, "laststand_time" },
    { 0x1F6BAE66, "laststand_update_clientfields" },
    { 0x3D8E2702, "laststandallowsuicide" },
    { 0xF4E55BAB, "laststandbleedout" },
    { 0x83A18A40, "laststandcount" },
    { 0x65C15BFA, "laststandend" },
    { 0xE94CB558, "laststandendonforcecrouch" },
    { 0x177599F1, "laststandexitalias" },
    { 0xDA98BF76, "laststandgetupallowed" },
    { 0x06982BBB, "laststandhealthoverlay" },
    { 0x321B592C, "laststandkeepoverlay" },
    { 0xE3F4954D, "laststandparams" },
    { 0x3A87BD96, "laststandpistol" },
    { 0x33339D4C, "laststandplayer" },
    { 0x7E00777A, "laststandprimaryweapons" },
    { 0x4D057C9A, "laststands" },
    { 0xC86DBF56, "laststandstarttime" },
    { 0x34FE11D7, "laststandtargets" },
    { 0x18ED0905, "laststandthislife" },
    { 0xBAD31D90, "laststandtime" },
    { 0x56842512, "laststandtimer" },
    { 0x0C4A87BE, "laststandvox" },
    { 0xB2FA302D, "laststandwaittilldeath" },
    { 0x490CBF60, "laststate" },
    { 0x9F0CF45B, "laststatus" },
    { 0x89AA8AF0, "laststatustime" },
    { 0x3C1AC3D0, "laststolengadget" },
    { 0xB06D15AB, "laststolengadgettime" },
    { 0x965C96D7, "laststoppedtime" },
    { 0x1C4CD292, "laststoptime" },
    { 0xE2E6A75D, "laststunnedby" },
    { 0xD964B64D, "laststunnedtime" },
    { 0x1D564A08, "lastsubxcam" },
    { 0x41FDC145, "lastsuppressiontime" },
    { 0x9D3DB171, "lastswimmingstarttime" },
    { 0xDC7E9F8C, "lastswitchsidestime" },
    { 0x574916E9, "lasttacticalinsertionangles" },
    { 0x70B57587, "lasttacticalinsertionorigin" },
    { 0x89152A2E, "lasttacticalscantime" },
    { 0xCB41542C, "lasttacticalspawntime" },
    { 0xCB72C93D, "lasttankthatattacked" },
    { 0xA64EABB9, "lasttarg" },
    { 0xB1619617, "lasttargetposition" },
    { 0x718021E5, "lastteamalive" },
    { 0x714ABA23, "lastteamspeaktime" },
    { 0x817A6BAC, "lasttell" },
    { 0xFD86BA9A, "lasttime" },
    { 0x6CB1484F, "lasttimechangeposition" },
    { 0x1A393187, "lasttimedamaged" },
    { 0x9DFAEFD6, "lasttimefired" },
    { 0x0D475D13, "lasttimejuked" },
    { 0xDDF4AFCF, "lasttimetargetinsight" },
    { 0x56A63339, "lasttoggle" },
    { 0x95231942, "lasttold_time" },
    { 0x1BD0C9FE, "lasttouching" },
    { 0xE50FC7C2, "lasttracepos" },
    { 0xC3AB8AEC, "lasttravelled" },
    { 0xF86E667F, "lasttrig" },
    { 0x1FF8EDC4, "lastturn" },
    { 0x245080DB, "lasttutorialvoplayed" },
    { 0x9ADC67D5, "lasttype" },
    { 0x59B4E455, "lastupdatetime" },
    { 0x9877B5CC, "lastupwardsdeathtime" },
    { 0x4231BEC2, "lastusedweapon" },
    { 0x33995C0C, "lastuserate" },
    { 0x655FDC52, "lastval" },
    { 0x341FA04F, "lastvalidenemypos" },
    { 0xC00DFCA9, "lastvalidpimary" },
    { 0x68D8B22C, "lastvalue" },
    { 0x8D4EEC98, "lastvelocity" },
    { 0xA6B677DD, "lastvictim" },
    { 0xD9D24B9E, "lastvisibletime" },
    { 0x9F83B80B, "lastvisionset" },
    { 0x5DFDECA3, "lastvoiceover" },
    { 0xDF6E9FFB, "lastwagplayer" },
    { 0x7090B5DB, "lastwallrunstarttime" },
    { 0x875EEC46, "lastwaterdamagetime" },
    { 0x15016852, "lastwave" },
    { 0x5CD8CBB8, "lastwavescompleted" },
    { 0x8982436D, "lastwavetime" },
    { 0x56AAAFA2, "lastweap" },
    { 0x7D33CD9D, "lastweapon" },
    { 0xA3AD44AB, "lastweaponbeforedroppingintolaststand" },
    { 0xCD71D6DD, "lastweaponbeforetoss" },
    { 0x1C8D3C71, "lastweaponchange" },
    { 0x81270AD5, "lastweapontype" },
    { 0xE66369D4, "lastxcam" },
    { 0x4834DF2D, "lastxp" },
    { 0x3AA8C4BB, "lastxpos" },
    { 0x882D5851, "lastyawtime" },
    { 0x038EEAA8, "lastypos" },
    { 0x68A70D45, "lastzeropoi" },
    { 0xE406831C, "lat" },
    { 0xE5F31CA5, "latch" },
    { 0x5F4B0E79, "late" },
    { 0xA4F7536B, "late_cops_driveup" },
    { 0x09BC639B, "late_stop_magic_bullet" },
    { 0x0C6EBC24, "lately" },
    { 0x0CF19D2D, "latency" },
    { 0xCFFB2D19, "later" },
    { 0x8E8CA6B5, "later_dogs" },
    { 0x987F1B28, "later_raps" },
    { 0x5447D82F, "later_rounds" },
    { 0xC19371F9, "later_wasp" },
    { 0x06C1219A, "lateral" },
    { 0x0F50BC87, "laterally" },
    { 0x319A3F0B, "lateraloffset" },
    { 0xBB517584, "latest" },
    { 0x19377444, "latestangles" },
    { 0xB9A1F642, "latestorigin" },
    { 0x7B4C71F1, "latin" },
    { 0x3179577D, "latitude" },
    { 0x7A960AC5, "latlongstruct" },
    { 0x8858C524, "lauch" },
    { 0xD1B1BE90, "laufer" },
    { 0xEE22D308, "laugh" },
    { 0x784C2E50, "laughing" },
    { 0x7683A369, "laughlin" },
    { 0x3A62B123, "laughs" },
    { 0xDBC82B90, "launch" },
    { 0xBA045483, "launch_abort" },
    { 0x851C60A6, "launch_alarm" },
    { 0x2239EEEB, "launch_angles" },
    { 0xC920C1F9, "launch_arena_uaz" },
    { 0x5286107B, "launch_barrel" },
    { 0x8C19005C, "launch_buoy" },
    { 0xB98AA69F, "launch_buoys" },
    { 0xF326006A, "launch_car_on_deah" },
    { 0xF3114F24, "launch_dir" },
    { 0x1E7175B7, "launch_dynent" },
    { 0x79443513, "launch_escape_vehicle" },
    { 0x5A240267, "launch_facial_recognition" },
    { 0xA8B28418, "launch_fake_huey_riders" },
    { 0x22266781, "launch_flag_management" },
    { 0xB73D25F4, "launch_force" },
    { 0x65D30EF9, "launch_gib_up" },
    { 0x18D52777, "launch_guys_near_point" },
    { 0x1A8BC7E0, "launch_lid_alarm" },
    { 0xBCD2560C, "launch_lid_setup" },
    { 0xE8543726, "launch_lid_sound" },
    { 0x9F1BE2FF, "launch_lid_think" },
    { 0x409BC39D, "launch_me" },
    { 0x5C488D0C, "launch_me_baby" },
    { 0xA073738E, "launch_meat" },
    { 0x58A2634B, "launch_missile_muj_tank" },
    { 0x1E691078, "launch_missiles" },
    { 0x25748D83, "launch_monitor" },
    { 0xE7AF9290, "launch_monkey" },
    { 0xD341F576, "launch_offset" },
    { 0xDAD35A90, "launch_panel_baseentry_status" },
    { 0x9685A78A, "launch_panel_catwalk_status" },
    { 0xAEFE04DD, "launch_panel_centrifuge_status" },
    { 0x418C677A, "launch_panel_storage_status" },
    { 0x1CF66C5B, "launch_pitch" },
    { 0xFED7F2DF, "launch_points_targetname" },
    { 0xEC8C0873, "launch_pos" },
    { 0xBF54AC63, "launch_ragdoll_based_on_damage_type" },
    { 0xB63BA9D7, "launch_ragdoll_on_death" },
    { 0x6D5FE051, "launch_sa2_and_react" },
    { 0x6864CF5F, "launch_spot" },
    { 0x7CCA7AE6, "launch_spots" },
    { 0xD3BE12A5, "launch_start" },
    { 0x020C6597, "launch_start_spawners" },
    { 0xB55F615B, "launch_the_rocket" },
    { 0xACFE2022, "launch_tube_dialogue" },
    { 0x38362D04, "launch_tubes" },
    { 0xAE5850BC, "launch_vehicle_destruction" },
    { 0x25E1B21E, "launch_velocity" },
    { 0x98428E60, "launch_yaw" },
    { 0x80709230, "launchangles" },
    { 0x5E5CDBC0, "launchbomb" },
    { 0x1C0E3885, "launchdir" },
    { 0x024F4960, "launchdynent" },
    { 0xFFFB3123, "launched" },
    { 0xE7C3786A, "launchedcorrectly" },
    { 0xAC27CC85, "launcher" },
    { 0xC038BB4D, "launcher_alt_endgame_1" },
    { 0xE63B35B6, "launcher_alt_endgame_2" },
    { 0x0C3DB01F, "launcher_alt_endgame_3" },
    { 0x255890AB, "launcher_alt_endgame_array" },
    { 0xFD26A21C, "launcher_alt_lobby" },
    { 0xD5EDA85F, "launcher_ammoitem" },
    { 0x5EC5DB7A, "launcher_b" },
    { 0x84C855E3, "launcher_c" },
    { 0x17CB68A0, "launcher_cooloff_min_easy" },
    { 0xD6D4A013, "launcher_cooloff_min_hardened" },
    { 0x226E2827, "launcher_cooloff_min_normal" },
    { 0x1A2F641F, "launcher_cooloff_min_veteran" },
    { 0x86E28806, "launcher_defender_logic" },
    { 0xC7015739, "launcher_endgame_1" },
    { 0xED03D1A2, "launcher_endgame_2" },
    { 0x13064C0B, "launcher_endgame_3" },
    { 0x02607BE7, "launcher_endgame_array" },
    { 0x14873500, "launcher_guys" },
    { 0xE569678C, "launcher_index" },
    { 0x6E294430, "launcher_list" },
    { 0xC205AAE0, "launcher_lobby" },
    { 0x4B4F9839, "launcher_min_distance_sqr" },
    { 0x7351CB08, "launcher_min_distance_suppressed_sqr" },
    { 0x5715DA2E, "launcher_min_hit_count" },
    { 0xAA11BD7E, "launcher_origin" },
    { 0xAD17581C, "launcher_start" },
    { 0x4D50D15D, "launcher_trigger_think" },
    { 0x7B3583D0, "launcherclasscount" },
    { 0xCA749222, "launchercoolofftime" },
    { 0xB6B51414, "launchers" },
    { 0xF0E60FFB, "launchertraining" },
    { 0x8C03E115, "launchertraining_begin" },
    { 0xD7B7904D, "launchertraining_end" },
    { 0x8625521C, "launches" },
    { 0x559D379F, "launchfacility_a" },
    { 0xF1722682, "launchfacility_a_amb" },
    { 0xF716D195, "launchfacility_a_anim" },
    { 0xEEF38871, "launchfacility_a_art" },
    { 0xA725DE60, "launchfacility_a_fx" },
    { 0x9C4C5F33, "launchfacility_a_grg_getdownvents" },
    { 0x14D870B3, "launchfacility_a_intro_dvars" },
    { 0x75E16621, "launchfacility_a_price_bmp_nag_max" },
    { 0x4CE97896, "launchfacility_a_price_bmp_nag_number" },
    { 0xF52EA939, "launchfacility_a_price_ropenag_max" },
    { 0x764536FE, "launchfacility_a_price_ropenag_number" },
    { 0x83D370E8, "launchfacility_a_sas2_bloodyhell" },
    { 0xE395C864, "launchfacility_b" },
    { 0xD1B61555, "launchfacility_b_amb" },
    { 0x08ED5B7C, "launchfacility_b_anim" },
    { 0xF37B947A, "launchfacility_b_art" },
    { 0xEBD0F52D, "launchfacility_b_fx" },
    { 0xCF08B80F, "launchfacility_b_intro" },
    { 0x709A30C8, "launchfacility_b_intro_dvars" },
    { 0xB7822A79, "launchforce" },
    { 0x07E98988, "launching" },
    { 0xB3F03E06, "launching_claw" },
    { 0x78827FC2, "launchlevel" },
    { 0xBC20D669, "launchoffset" },
    { 0x523C80D6, "launchorigin" },
    { 0x196AB06F, "launchpad" },
    { 0x8FD14C28, "launchpad_blocker" },
    { 0x74798D80, "launchpad_chopper_battle" },
    { 0x7C2730D2, "launchpad_heli" },
    { 0x0A34395B, "launchpad_heli_crash_start" },
    { 0x0ADCFFD7, "launchpad_heli_dead" },
    { 0x70CDFD3B, "launchpad_heli_start" },
    { 0xB92B5AA4, "launchpad_moveinto_trig" },
    { 0x13009395, "launchpad_reinforce_01" },
    { 0x39030DFE, "launchpad_reinforce_02" },
    { 0x9A3F4ECC, "launchpad_spawn_guards" },
    { 0x3237F760, "launchpad_worker" },
    { 0x7433A02B, "launchpad_worker_takes_damage" },
    { 0xB7D968BE, "launchpos" },
    { 0x507AFDB5, "launchprojectile" },
    { 0x8461D2B1, "launchragdoll" },
    { 0xC1A5C96B, "launchtime" },
    { 0x9D13496E, "launchtube" },
    { 0x3D6EBB69, "launchtube_steamfx" },
    { 0x13261783, "launchtubes_clear" },
    { 0x3A6B36C6, "launchtubes_effects" },
    { 0xDE108101, "launchtubes_grigsby" },
    { 0xCFE85F0F, "launchtubes_hatch_close_sound" },
    { 0xDC5FE80A, "launchtubes_missile_alarm" },
    { 0x7D3EB103, "launchtubes_player" },
    { 0x497E404B, "launchtubes_price" },
    { 0xA95CE0BD, "launchtubes_teleport_friendlies" },
    { 0x69DB1EDD, "launchtubes_teleport_grigsby" },
    { 0xDADF235F, "launchtubes_teleport_price" },
    { 0x3DB45B86, "launchvec" },
    { 0x5782470D, "launchvector" },
    { 0x07D4FB40, "launchvehicle" },
    { 0xAFBBCAC1, "launchvel" },
    { 0x293D1868, "launchvision" },
    { 0x65D67060, "laundry_power_switch_afterlife" },
    { 0x1078ABD2, "laundrymat" },
    { 0x74B66493, "laundryroom_saw_gunner" },
    { 0xF6FE2D73, "lava" },
    { 0xA1D23DF6, "lava_damage_depot" },
    { 0x90EF221E, "lava_damage_init" },
    { 0x9819DD30, "lava_damage_think" },
    { 0x48E4D2FB, "lava_trigger_init" },
    { 0x8E2C9A1E, "lavaarray" },
    { 0x560DF257, "law" },
    { 0x605C5BCC, "law_nag" },
    { 0x493C082C, "law_woods" },
    { 0x156DED0E, "laws" },
    { 0x41EB4099, "lay" },
    { 0x8394B050, "lay_down_target" },
    { 0x4F5C22C6, "layed" },
    { 0x0B259DC0, "layer" },
    { 0x85041CCF, "layer_of_death" },
    { 0x11E96C12, "layer_of_death_ai_mode" },
    { 0x94BED185, "layer_of_death_getlayer" },
    { 0xD2B7AC22, "layer_of_death_timed_kill" },
    { 0x30CCB106, "layera_transparency" },
    { 0xCE48C35F, "layerb_transparency" },
    { 0xFAF73F88, "layerc_transparency" },
    { 0x1C0241A1, "layerd_transparency" },
    { 0xD29AE5BA, "layere_transparency" },
    { 0xEF6583E3, "layerf_transparency" },
    { 0x5E171DEB, "layers" },
    { 0xDF8A1F2F, "laying" },
    { 0x044FFD4F, "layout" },
    { 0x0CC63550, "lays" },
    { 0x537B5867, "lazy" },
    { 0xF9DC5413, "lb" },
    { 0x634CD330, "lb1" },
    { 0xEAC174F7, "lb1_dest" },
    { 0xD554426B, "lb2" },
    { 0x651EB0F6, "lb2_dest" },
    { 0x40217669, "lb_checkpoint_destination" },
    { 0x073CB139, "lb_checkpoint_flyto" },
    { 0x2992F324, "lb_checkpoit_goal" },
    { 0x9BEA251A, "lb_destination" },
    { 0x0512923C, "lb_lookat" },
    { 0x67E6AC72, "lb_missile" },
    { 0xC9145549, "lb_string" },
    { 0x5F72BC36, "lbexplode" },
    { 0x2FF06242, "lbs" },
    { 0x44BB0287, "lbspin" },
    { 0x415D9771, "lbstrike" },
    { 0x75115563, "lc_debug_arc" },
    { 0x57BD58A6, "lc_do_damage" },
    { 0x0DF456DF, "lc_end_arc_damage" },
    { 0xB0B0BE05, "lc_flag_hit" },
    { 0x68528BA8, "lc_get_enemies_in_area" },
    { 0x42A605D7, "lc_play_arc_fx" },
    { 0x0B1AF811, "lc_play_death_fx" },
    { 0x68C72756, "lc_shock_fx" },
    { 0xDEF2665F, "lci" },
    { 0x3E91CAF5, "lclip" },
    { 0xD4E10D80, "lcn" },
    { 0xF40328C0, "lcount" },
    { 0x492B65CE, "lcp" },
    { 0x45E148E5, "ld" },
    { 0x0EEB23FB, "ldd" },
    { 0x5978B43F, "ldoor" },
    { 0x951544F4, "lds" },
    { 0x43711BC3, "lead" },
    { 0x58E34E9F, "lead_bodyguard_setup" },
    { 0xB0ACBBCF, "lead_gunner" },
    { 0xB81D8697, "lead_guy" },
    { 0x0A3D24E3, "lead_market_ai" },
    { 0xDEBB5194, "lead_plane" },
    { 0x6F81C1B9, "lead_player" },
    { 0xEE10BEF6, "lead_turret_stopped" },
    { 0x86201A0E, "leadbodyguard" },
    { 0x3A27DC9E, "leader" },
    { 0x77496723, "leader_class" },
    { 0x3FD013F5, "leader_create" },
    { 0xB997C521, "leader_dialog" },
    { 0x4DEC8459, "leader_dialog_for_other_teams" },
    { 0x5A6C4285, "leader_dialog_on_player" },
    { 0xB0A3477D, "leader_dist" },
    { 0x1F34C245, "leader_ent_num" },
    { 0x0E00D637, "leader_follower_count" },
    { 0xD2ED462A, "leader_hilltop_org" },
    { 0xEF7EEA70, "leader_saw_player" },
    { 0xD2F06B07, "leader_spawner" },
    { 0xC4384A4B, "leader_think" },
    { 0x2ECBB97E, "leaderboard" },
    { 0x1B95D20A, "leaderboard_number" },
    { 0xA28AE061, "leaderboards" },
    { 0x3BE79BE7, "leaderbonus" },
    { 0x8CD2E72E, "leaderdialog" },
    { 0x1A2F1204, "leaderdialogactive" },
    { 0xCBD911CB, "leaderdialogallteams" },
    { 0xD62E5BDB, "leaderdialogbothteams" },
    { 0x089D56D3, "leaderdialogforotherteams" },
    { 0xAA29D3B7, "leaderdialoggroup" },
    { 0x5CB31CEE, "leaderdialoggroups" },
    { 0x05B8D0E6, "leaderdialogonplayer" },
    { 0xFDBDC097, "leaderdialogqueue" },
    { 0x04C52832, "leadernode" },
    { 0x2534C601, "leaders" },
    { 0x4CE51653, "leadersound" },
    { 0xDE5AA4BC, "leaderturret" },
    { 0x826077FD, "leaderwait" },
    { 0xC10D0FA3, "leaderwatch" },
    { 0x7C0497F6, "leadin" },
    { 0x6254C01D, "leading" },
    { 0xC9AE28B3, "leadplane" },
    { 0xA9FFF0D0, "leadplane1" },
    { 0xF4D76F32, "leads" },
    { 0x89C7375E, "leadshowstuff" },
    { 0xE4A112B8, "leadshowstuff_path" },
    { 0x39AC9A2F, "leadtank" },
    { 0x792A769C, "leadturretstate" },
    { 0x98EBDCF8, "leadup_time" },
    { 0xF76C26F1, "leaf" },
    { 0xA13EB1B9, "leafmed" },
    { 0x82A9F52D, "leafsm" },
    { 0x3964BEE2, "leafy" },
    { 0xBB9B39AD, "leaguematch" },
    { 0x395FC2E4, "leak" },
    { 0xA5BF7141, "leak_barrel_setup" },
    { 0xD20DA2C9, "leak_calc_assert" },
    { 0x321E9AE8, "leak_calc_ballistic" },
    { 0x79372A64, "leak_calc_nofx" },
    { 0x1F8CF01A, "leak_calc_splash" },
    { 0x54BDF5FF, "leak_drain" },
    { 0x193353FE, "leak_setup" },
    { 0xFE322465, "leak_think" },
    { 0x48DCCA17, "leaks" },
    { 0xCCC401FD, "leaky" },
    { 0xC75853A9, "lean" },
    { 0x82EEA265, "lean_and_smoke" },
    { 0x65C03BB5, "leanamount" },
    { 0xFCFE526D, "leanfire" },
    { 0xE892BEDF, "leaning" },
    { 0xD1E3818C, "leaning_guy_idle" },
    { 0x1CA4D1ED, "leaning_guy_smoking_idle" },
    { 0x7EA289A2, "leaning_guy_smoking_twitch" },
    { 0x84672874, "leaning_guy_talk" },
    { 0x2FEAAC94, "leaning_guy_trans2idle" },
    { 0xB109A879, "leaning_guy_trans2smoke" },
    { 0x294930B3, "leaning_guy_twitch" },
    { 0x907136EA, "leaningguard" },
    { 0xE68D5020, "leans" },
    { 0x3BA2ABF7, "leap" },
    { 0xD77D407D, "leap_anim" },
    { 0x47A9B200, "leap_anim_done" },
    { 0xE55B419C, "leap_delay_max" },
    { 0x626FFF92, "leap_delay_min" },
    { 0xA2589A7E, "leap_delay_override" },
    { 0x3455F03B, "leap_in" },
    { 0xD0139244, "leap_loop" },
    { 0xA32A650C, "leap_node_array" },
    { 0xBD320686, "leap_of_faith_started" },
    { 0x39AB102E, "leap_out" },
    { 0x910416BA, "leap_weight" },
    { 0x182794DC, "leapdown_actors" },
    { 0x05C8955A, "leaper" },
    { 0x437286EE, "leaper_anim" },
    { 0xE7020938, "leaper_array" },
    { 0x8A57AA5C, "leaper_building_jump" },
    { 0x4138BA03, "leaper_calc_anim_offsets" },
    { 0x30CF96E3, "leaper_can_use_anim" },
    { 0xFE206C3A, "leaper_check_no_jump" },
    { 0x26DF248A, "leaper_check_wall" },
    { 0xCAA7F270, "leaper_check_zone" },
    { 0xA39929BF, "leaper_cleanup" },
    { 0xAE5509E2, "leaper_combat_animmode" },
    { 0x1CABAFF6, "leaper_count" },
    { 0xD697B345, "leaper_death" },
    { 0xAB6BC8B9, "leaper_death_ragdoll" },
    { 0x190ABAFB, "leaper_death_wait" },
    { 0x51D86ABE, "leaper_emerge" },
    { 0x5A9D4725, "leaper_failsafe_start_time" },
    { 0x7DD94035, "leaper_friend" },
    { 0x2FCE67D7, "leaper_handle_fx_notetracks" },
    { 0x548A939F, "leaper_health" },
    { 0xC1315AA2, "leaper_health_increase" },
    { 0x690764D7, "leaper_init" },
    { 0x373F5FE1, "leaper_intermission" },
    { 0x288EBF0A, "leaper_land" },
    { 0xC7C0CC8F, "leaper_locations" },
    { 0x05DE0BEC, "leaper_locs" },
    { 0x470C6CA9, "leaper_notetracks" },
    { 0x8F15CD74, "leaper_outside_playable_space" },
    { 0x9BBC6530, "leaper_outside_playable_space_time" },
    { 0x98F00E81, "leaper_play_anim" },
    { 0xC02B656B, "leaper_playable_area_failsafe" },
    { 0x99400783, "leaper_round_accuracy_tracking" },
    { 0x62456307, "leaper_round_accurate_players" },
    { 0x054F11B2, "leaper_round_aftermath" },
    { 0x8A893D7B, "leaper_round_count" },
    { 0x011CD43B, "leaper_round_ending" },
    { 0x52258E05, "leaper_round_spawning" },
    { 0x5610B3DE, "leaper_round_start" },
    { 0x733FBCB1, "leaper_round_start_audio" },
    { 0xAC633862, "leaper_round_starting" },
    { 0x346447BE, "leaper_round_stop" },
    { 0x772D8E4E, "leaper_round_tracker" },
    { 0x4BDA04C5, "leaper_round_wait" },
    { 0xA9A01B38, "leaper_rounds_enabled" },
    { 0x7BA68722, "leaper_spawn" },
    { 0xE2072546, "leaper_spawn_failsafe" },
    { 0xBDEB5D27, "leaper_spawn_fx" },
    { 0x2E51A1FD, "leaper_spawn_logic" },
    { 0x710EAB8F, "leaper_spawn_logic_old" },
    { 0x212C12A0, "leaper_spawn_points" },
    { 0x005DF410, "leaper_spawner_init" },
    { 0xBE5289D9, "leaper_spawner_zone_check" },
    { 0xB81A8BA2, "leaper_spawners" },
    { 0x8BEB048F, "leaper_start_trail_fx" },
    { 0x71E9ECA1, "leaper_stop_trail_fx" },
    { 0x162FE4ED, "leaper_targets" },
    { 0x00F5EF0F, "leaper_think" },
    { 0x7709F8DE, "leaper_traverse_watcher" },
    { 0x3B01F9EF, "leaper_watch_enemy" },
    { 0xADAB1455, "leapers" },
    { 0xDB709A7F, "leapers_per_player" },
    { 0x8C384C0D, "leapfrog" },
    { 0x6F2BC0E6, "leapfrog_ai_count" },
    { 0x3DC2982B, "leapfrog_completed" },
    { 0x4C0E9E76, "leapfrog_future_ai_count" },
    { 0xF4638186, "leapfrog_masterthread" },
    { 0xC7716326, "leapfrog_max_node_ai" },
    { 0xAB7173D0, "leapfrog_on_death" },
    { 0x8FD855EB, "leapfrog_random_int" },
    { 0xBE963129, "leaping" },
    { 0x9F2CBE2E, "leaps" },
    { 0xE1205A21, "leapt" },
    { 0xEF9DB725, "lear" },
    { 0xC7666906, "lear_exp_audio" },
    { 0x426DC0F2, "learjet" },
    { 0x037DA475, "learjet_audio" },
    { 0x5C6DD9D7, "learjet_audio_explode" },
    { 0xB9F9E192, "learjet_back_door_open" },
    { 0xEA374E74, "learjet_back_left" },
    { 0xDC85D02B, "learjet_back_right" },
    { 0x069EEB9E, "learjet_battle_seal_vs_pdf" },
    { 0x9273C0ED, "learjet_challenge_think" },
    { 0xA0FBBDBD, "learjet_damage_override" },
    { 0x8F0644E6, "learjet_destroyed" },
    { 0xFF0538B5, "learjet_dialog" },
    { 0x860B3484, "learjet_explode_snd" },
    { 0x231E3EC0, "learjet_far_color" },
    { 0xF965BF88, "learjet_frontline_color" },
    { 0x34E80195, "learjet_garage_guys_vo" },
    { 0x71F70536, "learjet_intro_ai_retreat" },
    { 0x002FAE6E, "learjet_main" },
    { 0x931AD690, "learjet_main_old" },
    { 0xC7F8F459, "learjet_middle_move_up_mason" },
    { 0x804EB40A, "learjet_multiple_enemy_vo" },
    { 0xAE31AF96, "learjet_pdf_death_count" },
    { 0xAB2C51AA, "learjet_pdf_with_rpg_vo" },
    { 0xF06A0AD6, "learjet_retreat" },
    { 0x9C0406E7, "learjet_rolling_door" },
    { 0xB3545E1D, "learjet_side_battle" },
    { 0x335FBCC5, "learjet_turret_challenge_count" },
    { 0x1B898113, "learjet_turret_truck" },
    { 0x655E5CB1, "learn" },
    { 0xFC877E5E, "learned" },
    { 0xB8107A9C, "learning_rate" },
    { 0xF2FB6F18, "learns" },
    { 0xFD0CC7F7, "learnt" },
    { 0x8B25221C, "leash" },
    { 0x62DFBEA0, "least" },
    { 0x923C2E67, "least_hunted" },
    { 0x833E5B9C, "leastalpha" },
    { 0xA328F577, "leastcomparefunc" },
    { 0x11A1D8AE, "leave" },
    { 0xFDE40565, "leave_anim_done" },
    { 0xA04D2DC0, "leave_by_damage_initiated" },
    { 0x1BFC3BEB, "leave_cart" },
    { 0x366ECBDB, "leave_convoy" },
    { 0xEFA95BD2, "leave_dart" },
    { 0xF1A0AD10, "leave_ground" },
    { 0x42A6B7F3, "leave_gun_and_run_to_new_spot" },
    { 0x31E3E7AC, "leave_nodes" },
    { 0x8271E3EE, "leave_one_think" },
    { 0x2DEED7AA, "leave_time" },
    { 0xE3B447B3, "leave_trigger" },
    { 0x46343D89, "leave_water_traversal" },
    { 0x60C5E4D9, "leaveanim" },
    { 0x4D6542E0, "leavecheckpointtrigger" },
    { 0xD3BE04C3, "leavecoverandshoot" },
    { 0x2BB816F3, "leavedir" },
    { 0x34B002AD, "leavehelicopter" },
    { 0x1FEF8D2B, "leavelocation" },
    { 0x67964F4C, "leavemap" },
    { 0xEC211392, "leavenexttime" },
    { 0xEA782782, "leavenode" },
    { 0x5ACB1E24, "leavepoint" },
    { 0x294EABD1, "leaves" },
    { 0x2D772244, "leavesquad" },
    { 0x58DC35E9, "leaviiing" },
    { 0x50FA0CC7, "leaving" },
    { 0x7CCE91AD, "leaving_bp1" },
    { 0x72B5F27C, "leaving_level" },
    { 0x9350F96C, "leaving_play_area" },
    { 0x7668ED31, "leaving_sound_ent" },
    { 0xDC37327D, "leaving_team" },
    { 0x23D2ACC8, "leavingbattlefieldsound" },
    { 0x60340DC8, "leavingcover" },
    { 0x50A30AF0, "led" },
    { 0xDA4FDD70, "ledge" },
    { 0x7BE13DE0, "ledge0" },
    { 0xA1E3B849, "ledge1" },
    { 0xC7E632B2, "ledge2" },
    { 0xEDE8AD1B, "ledge3" },
    { 0xA45DB030, "ledge_break" },
    { 0x47242BF1, "ledge_cleared" },
    { 0xB903589B, "ledge_gap_timer" },
    { 0x58689898, "ledge_guy" },
    { 0x4685CEDF, "ledge_hide" },
    { 0x02BAA52B, "ledge_new" },
    { 0xFB365DA3, "ledge_org" },
    { 0xD427B25C, "ledge_redshirt" },
    { 0x0B747648, "ledge_slowmo" },
    { 0x1CBD922D, "ledge_squad_setup" },
    { 0xF3A443D9, "ledge_trig" },
    { 0xC9FF4189, "ledgebottom" },
    { 0x6D4A12DB, "ledges" },
    { 0x1DE4E6B1, "ledgetop" },
    { 0x76A58559, "lee" },
    { 0x9DBF910E, "leerjet" },
    { 0xEFF5998E, "leeway" },
    { 0x255826D2, "left" },
    { 0xA0528245, "left0_wind_ent" },
    { 0x619FF06F, "left1" },
    { 0x0005DCD2, "left1_wind_ent" },
    { 0xEF988134, "left2" },
    { 0x5BF96D5C, "left_aa_gun" },
    { 0x566D7DFB, "left_aa_owner" },
    { 0x2E93785F, "left_ai" },
    { 0x467DD8BE, "left_angle" },
    { 0x89A5C416, "left_anim" },
    { 0x8B788E92, "left_anim_time" },
    { 0xCF21F7FA, "left_approach_warehouse_soct_trigger" },
    { 0x8D08894F, "left_arc" },
    { 0x4D13E006, "left_arena" },
    { 0x91EAF79F, "left_arm_gibbed" },
    { 0x98333A80, "left_arm_retracted" },
    { 0xBD7091E0, "left_balcony_ai" },
    { 0x1F7C2681, "left_barrel" },
    { 0x03748CC0, "left_behind_guys" },
    { 0x428FE8DF, "left_behind_nodes" },
    { 0x70ACC0B2, "left_boards" },
    { 0xCB08C4EE, "left_camo_squad" },
    { 0x69D03827, "left_cart" },
    { 0xE02B5A07, "left_clip" },
    { 0x570F77CC, "left_clip_amt" },
    { 0xF33DE82D, "left_color_node" },
    { 0x21F30228, "left_constraint" },
    { 0x2012FA23, "left_crouch" },
    { 0xE63E3E2E, "left_defend_squad" },
    { 0x03205C3C, "left_direction" },
    { 0x7E7A1316, "left_displacement_vector" },
    { 0x03EFDD1C, "left_distance" },
    { 0x3F458E61, "left_door" },
    { 0x0AC7894C, "left_door_balcony" },
    { 0xCC5D3618, "left_end" },
    { 0xD9B729A2, "left_final_node" },
    { 0x622BC36B, "left_front_l" },
    { 0x7E38A78C, "left_front_prisoners" },
    { 0x86D19977, "left_fx" },
    { 0x7330A763, "left_gate_nag" },
    { 0x233F1A0C, "left_goal" },
    { 0xD361E2C6, "left_gun_active" },
    { 0xCD1C2819, "left_horch" },
    { 0x0E12C5F8, "left_in" },
    { 0x6341CAE0, "left_initial_island_guys" },
    { 0x378E5D09, "left_island_guys" },
    { 0x0BB5AAF7, "left_jump_pad" },
    { 0xEC94E7B9, "left_knee_armor_health" },
    { 0xDFF45211, "left_knee_index" },
    { 0x4FB1B178, "left_lane_pullovers" },
    { 0x10ADBDE8, "left_large_end" },
    { 0xA7F2528D, "left_large_mid" },
    { 0x2240A079, "left_launcher" },
    { 0xF381FC9F, "left_lever" },
    { 0xC21EA722, "left_lever_trigger" },
    { 0xF2B4CDDF, "left_light" },
    { 0x5ECD1CB2, "left_lobby_door" },
    { 0x77333BF3, "left_look_at_pt" },
    { 0x7A8A7D76, "left_loop_trigger" },
    { 0xCD5B0B08, "left_mantle" },
    { 0xB04EA7CD, "left_mg" },
    { 0xAB322C7D, "left_mid" },
    { 0xC9F59C17, "left_mutex_trigger" },
    { 0x3D4FDDED, "left_nomans_land" },
    { 0x942992A1, "left_or_right" },
    { 0xCAC372B5, "left_org" },
    { 0xA81C474A, "left_org_b" },
    { 0x95CD78F7, "left_out" },
    { 0xE3C8E21A, "left_outside_speed_up" },
    { 0x74D4D82F, "left_path_pdf_truck" },
    { 0x1F0F9D27, "left_path_picked" },
    { 0x649EAB72, "left_path_vo" },
    { 0xBB1CC296, "left_pipe1" },
    { 0x951A482D, "left_pipe2" },
    { 0x5D056691, "left_pos" },
    { 0x2958D129, "left_pressed" },
    { 0x9C4BF702, "left_prop" },
    { 0xE93E28E5, "left_rappel" },
    { 0x0192C57B, "left_rear" },
    { 0x931D5D5D, "left_right" },
    { 0x619E4200, "left_right_arc" },
    { 0x364016B5, "left_rooftop_enemies" },
    { 0x149C6C35, "left_rooftop_enemies_d_trigger" },
    { 0x15960D15, "left_score" },
    { 0x2F98AEA9, "left_sg_area" },
    { 0x51A5FB0A, "left_shoulder_armor_health" },
    { 0x570B1D24, "left_shoulder_index" },
    { 0x6552ECBC, "left_shudder" },
    { 0x7DFCFA60, "left_side" },
    { 0x47869F75, "left_side_cave_spawner" },
    { 0x4BCED443, "left_side_guys" },
    { 0xB15B540A, "left_side_setup" },
    { 0x85836DB2, "left_side_teleport" },
    { 0x1BA58950, "left_side_truck" },
    { 0x1E226E08, "left_spawn_points" },
    { 0x5E34CDCB, "left_spawner" },
    { 0x1F466172, "left_sq_area_watcher" },
    { 0xECC7433B, "left_start" },
    { 0xC8512D59, "left_structs" },
    { 0xB483A07A, "left_surround_l" },
    { 0x7FFB468B, "left_tag" },
    { 0xCCC5437A, "left_target" },
    { 0xE75A2F58, "left_to_right_ramp" },
    { 0x8B7551DB, "left_top_trigger" },
    { 0xE5803746, "left_triggers" },
    { 0x87D6B19A, "left_truck" },
    { 0x45BACE47, "left_turn_driver_anim" },
    { 0x952747B3, "left_turn_passenger2_anim" },
    { 0x00567FE3, "left_turn_passenger_anim" },
    { 0x6081963F, "left_turret" },
    { 0xFE53115E, "left_turret_defend" },
    { 0xBC155824, "left_turret_health" },
    { 0x305DD763, "left_turret_owner" },
    { 0xF240324D, "left_turret_target" },
    { 0x0848DDD9, "left_type" },
    { 0xA4A245ED, "left_upgraded" },
    { 0x45ABFA98, "left_vector" },
    { 0x52E6948B, "left_vehicle" },
    { 0x69379AB5, "left_weight" },
    { 0xC32C04CF, "left_wind0_id" },
    { 0x73CECCEC, "left_wind1_id" },
    { 0x9A657239, "left_wind_vol" },
    { 0xDF33011C, "left_wing" },
    { 0x546CC7B9, "left_wing_origin" },
    { 0xBDCB0D22, "left_wing_position" },
    { 0x60EEC03B, "left_x" },
    { 0x4DE0B71F, "left_zombie_menu" },
    { 0xF1C85FA2, "leftaimlimit" },
    { 0xD39DE2ED, "leftanim" },
    { 0x9CAAEA66, "leftarc" },
    { 0x76577D8B, "leftarmgibbed" },
    { 0x574C563A, "leftarmlost" },
    { 0x66A3D14F, "leftarmor" },
    { 0x6B7AF67B, "leftarmorhudelem" },
    { 0x74D3322F, "leftatt" },
    { 0x8ACD7F5F, "leftclawambientfx" },
    { 0x15533ADD, "leftclawchargefx" },
    { 0xEEC914E2, "leftclick" },
    { 0xD03F2186, "leftdooropen" },
    { 0x4368F9D0, "leftdraw" },
    { 0x9386D132, "leftenant" },
    { 0x5C423852, "leftermost" },
    { 0xD64BC33B, "leftgate" },
    { 0xC848921F, "leftglowfx" },
    { 0x06B3EB0D, "leftguard" },
    { 0xD2FCC053, "leftgunmodel" },
    { 0xC3A00A91, "lefthand" },
    { 0x5C5FCA7F, "leftheld" },
    { 0x08C7EC93, "lefthitfx" },
    { 0x1C1D7429, "lefticon" },
    { 0x2A476AFE, "leftindex" },
    { 0xF680A4F5, "leftleggibbed" },
    { 0x8234EDF4, "leftlooklimit" },
    { 0x51059F76, "leftnode" },
    { 0x3AC1FE69, "leftnodes" },
    { 0xBB8989D3, "leftoffset" },
    { 0x296D8DB4, "leftover" },
    { 0xC3EBDBDE, "leftover_drones" },
    { 0xBC67F3A7, "leftovers" },
    { 0xB06C8E63, "leftposition" },
    { 0x156B7EE4, "leftright" },
    { 0x5025AAB6, "leftroofguys_setup" },
    { 0x963995DD, "lefts" },
    { 0xDBD108EA, "leftscanarea" },
    { 0x17D1817C, "leftscore" },
    { 0x1B789F8C, "leftshutters" },
    { 0x420432E0, "leftswing" },
    { 0xC012A92C, "lefttentacle" },
    { 0xA4E4FEC4, "lefttreadhealth" },
    { 0x418D56F7, "leftturn" },
    { 0xEACB4ACC, "leftvec" },
    { 0x48FC7DEA, "leftweight" },
    { 0xEC4FE38E, "leftx" },
    { 0xC2AA7A2B, "leg" },
    { 0x52FA99E0, "leg_gib" },
    { 0xF3222D3D, "leg_left" },
    { 0xC8012E0E, "leg_pain_time" },
    { 0x6F3464A0, "leg_right" },
    { 0x6BDF7878, "legacy" },
    { 0x7B9AFDDB, "legacy_cymbal_monkey" },
    { 0x22FE4F04, "legacy_hint_system" },
    { 0x81DE3C21, "legacy_spawn_index" },
    { 0xE0AAC782, "legacy_spawn_points" },
    { 0xEC5C85F4, "legal" },
    { 0xA8631EBF, "legalaim" },
    { 0x15FF91C3, "legalaimpitch" },
    { 0x35DDCBD8, "legalaimyaw" },
    { 0xF2F884C2, "legalrightdirectionyaw" },
    { 0x3FC1C4E2, "legdamagedmap" },
    { 0x41B1528A, "legdmg1" },
    { 0x6E0A396C, "legdmg1_defined" },
    { 0x1BAED821, "legdmg2" },
    { 0x59ED27D3, "legdmg2_defined" },
    { 0xF5AC5DB8, "legdmg3" },
    { 0xB3B9A2F6, "legdmg3_defined" },
    { 0xFFBDB697, "legdmg4" },
    { 0x702EE7B5, "legdmg4_defined" },
    { 0xC8737061, "legged" },
    { 0xC494DE3B, "leghealthmod" },
    { 0x7CA69E14, "leghierarchy" },
    { 0x14C7E3EA, "leghit" },
    { 0xACDFE453, "legible" },
    { 0x85626574, "legit" },
    { 0x0C3558D6, "legit_weapons" },
    { 0xDAE063F4, "legless" },
    { 0x5FEEF828, "legless_sprint_anims" },
    { 0xF9B6DC47, "legless_walk_anims" },
    { 0x894A0ADA, "legmodel" },
    { 0x64765A0A, "legs" },
    { 0xE37712F5, "legsanim" },
    { 0x94F373DD, "legshit" },
    { 0x6E032709, "leif" },
    { 0x3242FFD3, "leipzig" },
    { 0xF42D4802, "leiu" },
    { 0xCCBBD30A, "len" },
    { 0x7B1163B5, "lenght" },
    { 0x73B84F4D, "length" },
    { 0xBE48511F, "length_head_to_toe" },
    { 0x4CDB8457, "length_head_to_toe_25_percent" },
    { 0x8FC294EA, "length_of_rope" },
    { 0x31A7F5CF, "length_range" },
    { 0x2F4EB1E1, "length_to_player" },
    { 0x5A50AA6F, "lengthfromhole" },
    { 0x4E1B08A6, "lengthofcheck" },
    { 0xEEE0EDFB, "lengthofclientanimation" },
    { 0x0A4CA672, "lengthofflyby" },
    { 0x8DD2246B, "lengthofsound" },
    { 0xE6E3A7CC, "lengths" },
    { 0xF781860C, "lengthsquared" },
    { 0x42E186E7, "lenianancy" },
    { 0xD0C04C45, "lens" },
    { 0xC609C704, "lens_flare" },
    { 0xE6A754CA, "lens_flare_off" },
    { 0x0674A54C, "lens_index" },
    { 0x8BA63CBF, "lensflare" },
    { 0xE7A72540, "lensflare_fx" },
    { 0xBBB845EA, "lensflare_tag" },
    { 0xDC2B0EC6, "lensflares" },
    { 0xF2BE4D73, "leo" },
    { 0x4C6D77B2, "lerp" },
    { 0xA22DA0DD, "lerp_amount" },
    { 0xCC93C915, "lerp_angle_over_time" },
    { 0xA22B39DE, "lerp_bit_count" },
    { 0x06B2B8A2, "lerp_cam_fov" },
    { 0x3D0F3AE0, "lerp_camera_time" },
    { 0xEFB22FDA, "lerp_cb" },
    { 0xB64D795E, "lerp_cougar_speed" },
    { 0xCAF86D8C, "lerp_crash_soct_to_position" },
    { 0xC86EAB33, "lerp_dof_over_time" },
    { 0x090EFFC0, "lerp_dof_over_time_pass_out" },
    { 0xB92FBCC5, "lerp_done" },
    { 0xCC0C8134, "lerp_down_generator_light_levels" },
    { 0xF6BF06E2, "lerp_dvar" },
    { 0xB599CD9C, "lerp_enginesound" },
    { 0x11C81ED5, "lerp_exposure_over_time" },
    { 0x7F5B33FE, "lerp_fov" },
    { 0xAEC70835, "lerp_fov_over_time" },
    { 0x00F330BC, "lerp_fov_overtime" },
    { 0x53940854, "lerp_generator_lights" },
    { 0x805DE608, "lerp_intensity" },
    { 0x7EDC1F36, "lerp_interval" },
    { 0x68E0A055, "lerp_my_dvar" },
    { 0x98BAA731, "lerp_node" },
    { 0x4D44B698, "lerp_nodes" },
    { 0x5555EB5E, "lerp_player" },
    { 0x73C323DE, "lerp_player_speed" },
    { 0x394D23C4, "lerp_player_view_at_ent" },
    { 0xD0FD2C6D, "lerp_player_view_to_angles" },
    { 0xB9F0F204, "lerp_player_view_to_moving_position_oldstyle" },
    { 0x585C62E1, "lerp_player_view_to_moving_tag_oldstyle_internal" },
    { 0xC396F2D4, "lerp_player_view_to_position" },
    { 0x1F698A4D, "lerp_player_view_to_position_oldstyle" },
    { 0x7E2CBA22, "lerp_player_view_to_position_oldstyle_loc" },
    { 0x2A4CA6EF, "lerp_player_view_to_tag" },
    { 0x1BD4C805, "lerp_player_view_to_tag_and_hit_geo" },
    { 0xD8C38DA9, "lerp_player_view_to_tag_internal" },
    { 0xCED89CB4, "lerp_player_view_to_tag_oldstyle" },
    { 0x9EFBC914, "lerp_player_view_to_tag_oldstyle_internal" },
    { 0xC0E002BE, "lerp_pos_over_time" },
    { 0x418CF3C8, "lerp_position" },
    { 0x0C81CE0D, "lerp_shader_constant" },
    { 0x945334DE, "lerp_sky_transition" },
    { 0x4A92266D, "lerp_squad" },
    { 0xA126F79B, "lerp_step" },
    { 0x5BAB4E7B, "lerp_step_count" },
    { 0x69D08A69, "lerp_sun_color" },
    { 0xC00492C6, "lerp_sun_color_over_time" },
    { 0x9FE4AF87, "lerp_sun_direction" },
    { 0x485A5DC7, "lerp_t" },
    { 0x48D0CA2B, "lerp_tag" },
    { 0x03E6EDA9, "lerp_thread" },
    { 0x0B100DB7, "lerp_thread_per_player_wrapper" },
    { 0x9FD384D5, "lerp_thread_wrapper" },
    { 0x59FAF216, "lerp_time" },
    { 0x09AD6874, "lerp_time_in" },
    { 0xC0A5AEAB, "lerp_time_out" },
    { 0x7A7CDEE7, "lerp_to_pos_orient" },
    { 0xC65B9F99, "lerp_to_stop" },
    { 0x13890AAB, "lerp_to_tag_sync" },
    { 0xC5BE880F, "lerp_trigger_dvar_value" },
    { 0x2B2F7B8B, "lerp_value_over_time" },
    { 0x1648296F, "lerp_vehicle_speed" },
    { 0x5BFAE42D, "lerp_vision" },
    { 0xC6365077, "lerp_wind" },
    { 0x9BA36EAE, "lerpamount" },
    { 0x8C041224, "lerpdofvalue" },
    { 0xF7142C9E, "lerpduration" },
    { 0x1EC239C5, "lerped" },
    { 0xAC406E74, "lerped_light_color" },
    { 0x0061B5CE, "lerped_light_exponent" },
    { 0x03434F2D, "lerped_light_inner_fov" },
    { 0xE7227BEA, "lerped_light_intensity" },
    { 0xCCE9425C, "lerped_light_outer_fov" },
    { 0xE0597625, "lerped_light_radius" },
    { 0xF8BFBF5C, "lerpee" },
    { 0x72959E63, "lerper" },
    { 0x2EBD5084, "lerpfloat" },
    { 0xD24E1C3E, "lerping" },
    { 0x6DFC7B0E, "lerping_dvar" },
    { 0x19685990, "lerporigin" },
    { 0x4B175804, "lerppos" },
    { 0x80F41E43, "lerpposition" },
    { 0x35EB6D67, "lerpratio" },
    { 0x7C294C3D, "lerps" },
    { 0xFD691225, "lerpshadowdetail" },
    { 0x7FF8F4E9, "lerpstruct" },
    { 0xB359A233, "lerpsundirection" },
    { 0xFEF19835, "lerptarget" },
    { 0x6B7E11CD, "lerptime" },
    { 0x8D0B588A, "lerptoorient" },
    { 0x2A06BAF1, "lerptopos" },
    { 0x081EF2A5, "lerpvalue" },
    { 0x5980D579, "lerpvar" },
    { 0xC7118D57, "lerpvector" },
    { 0x3A8DC32F, "lerpviewangleclamp" },
    { 0xF1075846, "less" },
    { 0x6BFB56B8, "less_than" },
    { 0xCFAFFF26, "less_than_normal" },
    { 0xFC8FF30F, "less_than_or_equal_to" },
    { 0x01BCF2A2, "less_time" },
    { 0x01B957CF, "lesser" },
    { 0xB605E9FF, "lesser_dot" },
    { 0xADC73AF9, "lesss" },
    { 0xD57A055B, "lessthan" },
    { 0x0DF77120, "lessthanequals" },
    { 0x962D29D7, "lessthanthis" },
    { 0x32FAF439, "lest" },
    { 0xF07B6460, "let" },
    { 0x1108CF5A, "let_go_molotov" },
    { 0x97833FF9, "let_player_leave_boat" },
    { 0x3AD5102F, "lethal" },
    { 0x9B272142, "lethal_chance" },
    { 0x6AC322AC, "lethal_grenade" },
    { 0x4674D4C8, "lethal_grenade_count" },
    { 0x8ABD8CEE, "lethal_grenade_name" },
    { 0xF7534537, "lethal_nade_amt" },
    { 0xDA7F9CFC, "lethaldistancemax" },
    { 0x706015F4, "lethaldistancemaxsq" },
    { 0x57945AF2, "lethaldistancemin" },
    { 0x8190D80E, "lethaldistanceminsq" },
    { 0x803C4DD7, "lethalgrenade" },
    { 0x973DCAB3, "lethalgrenadekill" },
    { 0x51556676, "lethals" },
    { 0xA819FE0B, "lethalweight" },
    { 0x84BD660B, "lets" },
    { 0x2775F311, "letter" },
    { 0x2A221D0A, "letter1" },
    { 0x041FA2A1, "letter2" },
    { 0xDE1D2838, "letter3" },
    { 0xD9A23831, "letter_a_reticle_index" },
    { 0xA8B9DC20, "letter_alpha" },
    { 0x0B3E9F5B, "letter_code" },
    { 0x8C90E025, "letter_e_reticle_index" },
    { 0xBCD6C287, "letter_time" },
    { 0xAF42F9B4, "letterbox" },
    { 0x5D7E8DF8, "letters" },
    { 0x5C526234, "letting" },
    { 0x3C805932, "lev" },
    { 0x3DB5AD5B, "leve" },
    { 0x28E3E3FD, "level" },
    { 0xAF934BE5, "level2" },
    { 0x0ED44160, "level_0" },
    { 0x34D6BBC9, "level_1" },
    { 0x5AD93632, "level_2" },
    { 0x80DBB09B, "level_3" },
    { 0xE87FAE64, "level_ai_boss_respond" },
    { 0x46178C30, "level_ai_respond" },
    { 0x7BF4936E, "level_alleyguys_dead_increment" },
    { 0xCEE16CEF, "level_anim" },
    { 0x400101FE, "level_anim_stack_ready" },
    { 0x22089D36, "level_anims" },
    { 0x0AD3C34D, "level_auto_complete" },
    { 0x134A6765, "level_complete" },
    { 0x02903295, "level_complete_achievement" },
    { 0x6C811DCF, "level_complete_delete_everyone" },
    { 0x78C1BE30, "level_create_turrets" },
    { 0xA3868F03, "level_createfx_callback_thread" },
    { 0x1FF089CB, "level_damage_trigger_cleanup" },
    { 0x43126B48, "level_default_fps_pos" },
    { 0x595EBF4F, "level_end" },
    { 0xB48CCF64, "level_end_fadeout" },
    { 0x3FA2F6E2, "level_end_rocket" },
    { 0x99212D83, "level_end_rocket_amb" },
    { 0xCF7CDC41, "level_end_save" },
    { 0x1D196932, "level_ender" },
    { 0x8118CCB1, "level_ending" },
    { 0x90DF35A0, "level_endon" },
    { 0x1F1B8CCA, "level_enemy_spotted" },
    { 0xB2CEAECB, "level_ent_updated" },
    { 0x291D4DB2, "level_fade" },
    { 0x546FAE18, "level_fade_in" },
    { 0xFAAD7D97, "level_fade_out" },
    { 0xD59CB866, "level_fade_to_black" },
    { 0x7D9053DC, "level_fail" },
    { 0x5867B863, "level_flag_init" },
    { 0x51352561, "level_fog_init" },
    { 0xC6070320, "level_for_briefing" },
    { 0x16494975, "level_function_stack_ready" },
    { 0xDC6B2A39, "level_goal" },
    { 0xADC89AC2, "level_has_callback" },
    { 0xF170BFD5, "level_has_skipto_points" },
    { 0xB3F8F264, "level_index" },
    { 0x83C7FF16, "level_init" },
    { 0x128F8A0A, "level_init_flags" },
    { 0x9E60BFE6, "level_init_spawn_funcs" },
    { 0x105E7B3F, "level_intro_announcements" },
    { 0x66410208, "level_list" },
    { 0x5FF681DD, "level_load_fade" },
    { 0xEC0FB4F3, "level_msg" },
    { 0x9BB9A029, "level_name" },
    { 0x80208660, "level_notification_to_send" },
    { 0x5811AA7B, "level_notify" },
    { 0x5FFCA060, "level_notify_claws_survival_status" },
    { 0xED844F1A, "level_notify_listener" },
    { 0x4A65D5F7, "level_notify_pilot_shot" },
    { 0xD1CEA602, "level_notify_player_grabs_pilot" },
    { 0xAF0A180D, "level_notify_player_move_forward" },
    { 0x0DDECDD0, "level_num" },
    { 0x5F88138F, "level_obj" },
    { 0x8DBA03E5, "level_objects_init" },
    { 0x56E1F50E, "level_over" },
    { 0x2F94C460, "level_override" },
    { 0x486B69FC, "level_player_init" },
    { 0xFC7851DB, "level_precache" },
    { 0xACC07D24, "level_prefix" },
    { 0xFDAFF185, "level_progression" },
    { 0x949DC275, "level_progression_achievement" },
    { 0x8A6534D0, "level_progression_csv" },
    { 0xF1309589, "level_progression_dostat" },
    { 0x0B46BB50, "level_progression_function" },
    { 0x99D2110B, "level_progression_level_index" },
    { 0x1F05E728, "level_progression_level_name" },
    { 0x187B909A, "level_progression_maptype" },
    { 0x6DDB67A2, "level_progression_mission" },
    { 0x06C0A9EF, "level_progression_root_level" },
    { 0xF25A913C, "level_progression_rtsend" },
    { 0x6572D68A, "level_progression_rtshub" },
    { 0xDC47BA17, "level_progression_rtsstart" },
    { 0x05EDEFC7, "level_progression_rtsstat" },
    { 0x6C45347D, "level_progression_rtsterritory" },
    { 0xDB24A4D1, "level_progression_vet_achievement" },
    { 0x0DBD0750, "level_radio_stack_ready" },
    { 0xF5683C50, "level_scripted_unloadnode" },
    { 0xD500353B, "level_selected" },
    { 0xC67DBC87, "level_settings" },
    { 0xD446A137, "level_setup" },
    { 0x67750095, "level_spawner_cleanup" },
    { 0x8E854C22, "level_specific_dof" },
    { 0xE34D2C13, "level_specific_init_powerups" },
    { 0x7A4E6515, "level_specific_stats_init" },
    { 0x50196384, "level_start" },
    { 0x298DE77C, "level_start_fadein" },
    { 0xA59EC1DE, "level_start_solar_duck" },
    { 0x871DEE4E, "level_start_vox" },
    { 0x71BFAA15, "level_state_machine" },
    { 0x386A977E, "level_struct_array_free" },
    { 0x8CBDB58B, "level_team" },
    { 0xB51968CB, "level_time" },
    { 0xAC29C3F6, "level_use_unified_spawning" },
    { 0xB71FA8F3, "level_var_name" },
    { 0xDB81CD62, "level_vars" },
    { 0x63661409, "level_vet_achievement" },
    { 0xEE2E5B85, "level_veteran_achievement" },
    { 0xDA745516, "level_waittill" },
    { 0xE678919E, "level_watch_for_fake_fire" },
    { 0x79951330, "level_weapon_stats" },
    { 0x4FFD72A3, "level_weapon_times" },
    { 0xEA7927AB, "levelalias" },
    { 0x2ABEED42, "levelanim" },
    { 0x42C8D7F9, "levelchallengename" },
    { 0x345E8574, "levelend" },
    { 0xAF3D68B1, "levelfadeout" },
    { 0x53964FC1, "levelfail" },
    { 0xD81A3503, "levelflag" },
    { 0x06DF5868, "levelfriendstargetsize" },
    { 0x7BEC1F44, "levelhasvehicles" },
    { 0x0036E0AF, "levelindex" },
    { 0x43587C06, "levelintrosnapandloop" },
    { 0xE9175013, "levelkillbrushes" },
    { 0x010543A1, "levelkothdisable" },
    { 0x069D01F8, "levellookukp" },
    { 0x48EE6780, "levelmenu" },
    { 0x76D85D44, "levelname" },
    { 0xD9F69FCD, "levelname_fx" },
    { 0x4DF3D56D, "levelnote" },
    { 0xD0D4DA5E, "levelnotify" },
    { 0x2E683BB6, "levelnotifyhandler" },
    { 0x30DB8757, "levelnum" },
    { 0x460EE11C, "leveloffset" },
    { 0x7EF255EA, "leveloverridetime" },
    { 0x0A2F6BBC, "levels" },
    { 0xFFCE59B4, "levels_left" },
    { 0x370BC2A0, "levelscoreindices" },
    { 0xF02BB394, "levelspawndvars" },
    { 0x49005A5E, "levelspecifickillcam" },
    { 0x71A37B45, "levelspecifickillcament" },
    { 0x6C56C842, "levelspecificspawnercallbackthread" },
    { 0x879EEBA6, "levelstart_breath_ent" },
    { 0x0E1BE1E8, "levelstart_breath_id" },
    { 0x147BB0EC, "levelstart_heartbeat_ent" },
    { 0x19276F7E, "levelstart_heartbeat_id" },
    { 0xA6149DC2, "levelstart_heartbeat_rumble" },
    { 0x7D1BB2A5, "levelstart_moment_sounds" },
    { 0xB48C84B1, "levelstart_vol" },
    { 0xF7CC0377, "levelstartsnapshot" },
    { 0x6ED90DF5, "levelstuff" },
    { 0x8BD1C0FA, "leveltime" },
    { 0x682D63C6, "leveltoload" },
    { 0x426B2CDC, "levelvar" },
    { 0x3CE6B41F, "levelvars" },
    { 0x8A003B10, "levelwatchforfakefire" },
    { 0xA9B015BC, "levelweapons" },
    { 0xACCB1BE3, "lever" },
    { 0x50F15D93, "leverdown" },
    { 0x6BFCA09C, "leverup" },
    { 0x5DDFACD6, "levitating" },
    { 0xA991A19B, "lewis" },
    { 0x8B59267B, "lewis_after_ladder" },
    { 0xA8B2C8B7, "lewis_breachroom_after" },
    { 0xA2940E7B, "lewis_bridge_anim" },
    { 0x2149AFFA, "lewis_distraction" },
    { 0x8E424EA6, "lewis_sniper_spot" },
    { 0xB2F81EDE, "lewis_start" },
    { 0xE61775E8, "lfe" },
    { 0x44135EF9, "lft_dir" },
    { 0x03684BB7, "lfx_save" },
    { 0x4682B28F, "lfxhudelements" },
    { 0x9C153E40, "lfxprintln" },
    { 0x6BE3C34E, "lg" },
    { 0x14776D32, "lght" },
    { 0xD29EE6EB, "lgun" },
    { 0x6AEB9BCC, "lh_clipammotogive" },
    { 0x21A64330, "lhs" },
    { 0x9B9992D3, "lhsvalue" },
    { 0x57C11190, "li" },
    { 0x9B406D39, "lia" },
    { 0xF47C89D9, "liar" },
    { 0xDCCFE7E1, "liberate" },
    { 0xEEBF21B3, "liberator" },
    { 0x2B61DE26, "liberty" },
    { 0x11776955, "libra" },
    { 0x098D9D16, "library" },
    { 0x7A995D3C, "libya" },
    { 0x8540F462, "license" },
    { 0xE0C7482D, "licenses" },
    { 0x0D47DC74, "lid" },
    { 0xBEF0D20B, "lid_closed" },
    { 0x445FE8F7, "lid_kill" },
    { 0xD7F4E984, "lidclosed" },
    { 0xB85A7324, "lidloopplaying" },
    { 0xC5229FD4, "lidopen" },
    { 0xD1D54977, "lidopened" },
    { 0x2E4F2067, "lids" },
    { 0xC8D7A81C, "lies" },
    { 0x7CD2B34A, "lieu" },
    { 0x570BEDDF, "life" },
    { 0x0457BE33, "life_bonus" },
    { 0x0BFD07EA, "life_brush" },
    { 0x734CCDB2, "life_brushes" },
    { 0xA469CF2C, "life_flak88" },
    { 0x2A7855B2, "life_link" },
    { 0xD64D2488, "lifeboats" },
    { 0x1C453223, "lifecycle" },
    { 0x50B4F760, "lifeid" },
    { 0x179D204A, "liferaft" },
    { 0x88E9C168, "liferaftexpsound" },
    { 0xF02FB385, "liferafts" },
    { 0x35997C93, "lifespan" },
    { 0x941C77AC, "lifetime" },
    { 0xF996C9F1, "lifetimebuyin" },
    { 0x6D350521, "lifetimeearnings" },
    { 0x3B1ACC55, "lifo" },
    { 0x91311A06, "lift" },
    { 0xDF1CBA4F, "lift_auto_lower_think" },
    { 0x45558538, "lift_control" },
    { 0xCE7B22B7, "lift_destruction" },
    { 0x4CDFE590, "lift_door_dist" },
    { 0x2710469B, "lift_door_time" },
    { 0xD211194B, "lift_drop_trig" },
    { 0x608AC6E7, "lift_drop_trigger" },
    { 0x7E8BAA34, "lift_hack_visor_text" },
    { 0xBC0FDA15, "lift_interior_m" },
    { 0x497A3727, "lift_lowered" },
    { 0x80FC47FC, "lift_model_broken" },
    { 0x33266AD9, "lift_move_dist" },
    { 0x4AEF036F, "lift_move_think" },
    { 0xDB61D73E, "lift_move_time" },
    { 0x07E78B25, "lift_nag_lines" },
    { 0x6A064D3C, "lift_off" },
    { 0xCDB6B54D, "lift_raised" },
    { 0x1732A7A8, "lift_start_trig" },
    { 0xC6ED88DA, "lift_start_trigger" },
    { 0xFADFC3E3, "lift_think" },
    { 0xCFF23BA6, "lift_time_auto_lower" },
    { 0x7C3074AA, "lift_time_cooldown" },
    { 0x65C30966, "lift_time_movement" },
    { 0xCA953B89, "lifted" },
    { 0xAA6393C7, "liftedorigin" },
    { 0xDF3A9F1A, "lifting" },
    { 0x1BC87B6D, "liftoff" },
    { 0xC3133A1F, "liftoff_begin" },
    { 0x1756B24C, "liftoff_fail" },
    { 0xD5CDD9F9, "liftoff_success" },
    { 0x90C070B9, "lifts" },
    { 0x7C14D90B, "light" },
    { 0x4BAEFA93, "light2" },
    { 0x3FD99590, "light_action" },
    { 0xD6D1676F, "light_activated" },
    { 0x8392A50A, "light_actor_with_entity" },
    { 0x20BFFEBF, "light_arty_flicker" },
    { 0x040B6235, "light_celerium_wall_01" },
    { 0x4F0F8BCF, "light_color" },
    { 0x63E38817, "light_color_is_dirty" },
    { 0xA538648E, "light_disable" },
    { 0x65F2169E, "light_discs_bottom_to_top" },
    { 0x8C2F9044, "light_dragon_fireworks" },
    { 0x80672A4C, "light_drone" },
    { 0xEA4B7FB4, "light_drone_spawn" },
    { 0x39737B3D, "light_effect" },
    { 0x42CDFB2D, "light_ent" },
    { 0x2770BED3, "light_entity" },
    { 0x9633EF4C, "light_exploders" },
    { 0x4F37080F, "light_exponent" },
    { 0xDA472957, "light_exponent_is_dirty" },
    { 0x99471346, "light_flicker" },
    { 0x68D3A399, "light_flicker_change" },
    { 0xF621FC43, "light_flicker_fx" },
    { 0xD95027F5, "light_flicker_fx_exploder" },
    { 0x4789EAEC, "light_flicker_model" },
    { 0x9BD9F9EF, "light_fov_is_dirty" },
    { 0x46695CF4, "light_fx" },
    { 0xED5CCF2A, "light_fx_ent" },
    { 0x527FB904, "light_fx_handles" },
    { 0x1AC459DD, "light_fx_handles_heli_comlink" },
    { 0x66AE5A5D, "light_id" },
    { 0x80FB7022, "light_inner_fov" },
    { 0x7F420069, "light_intensity" },
    { 0x65B97DC5, "light_intensity_is_dirty" },
    { 0x3E4E7CEA, "light_keys" },
    { 0x9686A2DD, "light_left" },
    { 0x34DF1033, "light_lens_flare" },
    { 0xF800CF60, "light_loop" },
    { 0x0C4E2067, "light_loop_stop" },
    { 0xE5EC9979, "light_match" },
    { 0x2FE71ECD, "light_model" },
    { 0xF06C8AD5, "light_model_init_pause" },
    { 0x875D0CE6, "light_model_scale" },
    { 0x30E2D0B9, "light_model_swap" },
    { 0x49293EE4, "light_model_switch" },
    { 0xA4944E4C, "light_models" },
    { 0x7BE55875, "light_mover" },
    { 0x7C65EF2B, "light_name" },
    { 0x75D8D1FC, "light_night" },
    { 0xE11DCBDD, "light_notify" },
    { 0x307E89FE, "light_num" },
    { 0x7F752CCD, "light_off" },
    { 0xE4D50290, "light_off_on_death" },
    { 0x17D831E1, "light_on" },
    { 0xD89ED14C, "light_origin" },
    { 0x2CCEEBAF, "light_outer_fov" },
    { 0x5419F76D, "light_overwrite" },
    { 0xF3045B32, "light_player_with_entity" },
    { 0x8FB844F6, "light_playfx" },
    { 0x7CDA1E4F, "light_plinth" },
    { 0xDC6DBC5A, "light_race_arrows" },
    { 0xCB100710, "light_radius" },
    { 0xED83B862, "light_radius_is_dirty" },
    { 0x4200DBC0, "light_right" },
    { 0xF4072799, "light_setintensity" },
    { 0x8859F58A, "light_show_morse" },
    { 0x6D37BC01, "light_smoke" },
    { 0x07268E97, "light_snow" },
    { 0x08867B9F, "light_solid" },
    { 0xCB4B07AB, "light_sound" },
    { 0x26DB0029, "light_spots" },
    { 0x8F8A0A85, "light_struct" },
    { 0xAA5CAE14, "light_structs" },
    { 0xAC6F206F, "light_swap" },
    { 0x43541959, "light_target" },
    { 0xAC9F40B5, "light_tower" },
    { 0x25648046, "light_tower_audio" },
    { 0xDD655CD6, "light_type" },
    { 0x950D54C9, "light_zort" },
    { 0xEEEC4068, "lightarmorhp" },
    { 0x2906D723, "lightarmorpercent" },
    { 0x6045B018, "lightbuzz" },
    { 0xEF2EDED6, "lightcollisionrumble" },
    { 0x5E3B21CA, "lightcollisionspeed" },
    { 0x65FAF25A, "lighten" },
    { 0x2E18AF46, "lighter" },
    { 0x10FC5E00, "lightest_node" },
    { 0x2DC619AD, "lightfx" },
    { 0x63F14C84, "lightfx_high" },
    { 0x5B5853D6, "lightfx_low" },
    { 0xC2C58442, "lightfx_med" },
    { 0x68183FAD, "lightfx_points" },
    { 0x9AB06344, "lightfx_slot" },
    { 0xB8ABD19D, "lightfxgroups" },
    { 0x0DAD17F6, "lightfxid" },
    { 0xE04B1E23, "lightfxnamearray" },
    { 0xE46E1882, "lightfxtagarray" },
    { 0xF7B5F8DB, "lightglows" },
    { 0x798A7092, "lightglows_create" },
    { 0xAC032D8F, "lightgrid" },
    { 0xE7BF257D, "lightgridcontrast_transition" },
    { 0xD21F5A60, "lightgroup" },
    { 0xB9D9A80B, "lightgroups" },
    { 0xC015426B, "lightgroups_1_always_on" },
    { 0xE03A3D35, "lightgroups_1_fx1" },
    { 0x063CB79E, "lightgroups_1_fx2" },
    { 0x2C3F3207, "lightgroups_1_fx3" },
    { 0x222DD928, "lightgroups_1_fx4" },
    { 0xFE34ABC5, "lightgroups_1_numslots" },
    { 0x7E835403, "lightgroups_1_tag1" },
    { 0x0C7BE4C8, "lightgroups_1_tag2" },
    { 0x327E5F31, "lightgroups_1_tag3" },
    { 0xF08AC33E, "lightgroups_1_tag4" },
    { 0xAB037D4C, "lightgroups_2_always_on" },
    { 0xF6FFEA3A, "lightgroups_2_fx1" },
    { 0xD0FD6FD1, "lightgroups_2_fx2" },
    { 0xAAFAF568, "lightgroups_2_fx3" },
    { 0xB50C4E47, "lightgroups_2_fx4" },
    { 0x096C37B4, "lightgroups_2_numslots" },
    { 0x9DBC8CDA, "lightgroups_2_tag1" },
    { 0x77BA1271, "lightgroups_2_tag2" },
    { 0x51B79808, "lightgroups_2_tag3" },
    { 0x5BC8F0E7, "lightgroups_2_tag4" },
    { 0x890E80F9, "lightgroups_3_always_on" },
    { 0xF4564AD3, "lightgroups_3_fx1" },
    { 0x824EDB98, "lightgroups_3_fx2" },
    { 0xA8515601, "lightgroups_3_fx3" },
    { 0x665DBA0E, "lightgroups_3_fx4" },
    { 0x92BF77A3, "lightgroups_3_numslots" },
    { 0x378FA355, "lightgroups_3_tag1" },
    { 0x5D921DBE, "lightgroups_3_tag2" },
    { 0x83949827, "lightgroups_3_tag3" },
    { 0x79833F48, "lightgroups_3_tag4" },
    { 0x82B56112, "lightgroups_4_always_on" },
    { 0x386CFC80, "lightgroups_4_fx1" },
    { 0xAA746BBB, "lightgroups_4_fx2" },
    { 0x8471F152, "lightgroups_4_fx3" },
    { 0xF679608D, "lightgroups_4_fx4" },
    { 0xA1783F62, "lightgroups_4_numslots" },
    { 0xE710B4FC, "lightgroups_4_tag1" },
    { 0x59182437, "lightgroups_4_tag2" },
    { 0x3315A9CE, "lightgroups_4_tag3" },
    { 0x750945C1, "lightgroups_4_tag4" },
    { 0x1655D03E, "lightgroups_numgroups" },
    { 0x9927774D, "lighthouse" },
    { 0x19A57947, "lighthouse1_zone" },
    { 0xA4344E63, "lighthouse_owned" },
    { 0x909ADE55, "lighting" },
    { 0xB9719584, "lighting_alignment_cleanup_for_plane_exit" },
    { 0x6E229965, "lighting_flash_cycle" },
    { 0x00AEF287, "lighting_state" },
    { 0xFB5C3415, "lightingnode" },
    { 0x7BDB4209, "lightline" },
    { 0xF00BF700, "lightlines" },
    { 0x93FDD2D6, "lightly" },
    { 0xDFAA0B46, "lightmaps" },
    { 0xE93B3DA6, "lightname" },
    { 0xAF6BACA1, "lightning" },
    { 0x77413782, "lightning_audio" },
    { 0xB980EAAA, "lightning_ball_created" },
    { 0x2B45619D, "lightning_ball_wait" },
    { 0x0AFF02BD, "lightning_bolt_fx_toggle" },
    { 0x6E76848F, "lightning_chain" },
    { 0xABC6E31D, "lightning_chain_immune" },
    { 0xFAB0EED4, "lightning_change" },
    { 0xA12E48AF, "lightning_effect" },
    { 0xEDE2418A, "lightning_flash" },
    { 0x802DE14B, "lightning_flash_func" },
    { 0x0AD2497D, "lightning_normal" },
    { 0xB9D081D2, "lightning_normal_func" },
    { 0x47753CE2, "lightning_pos" },
    { 0xE4034283, "lightning_state" },
    { 0x79AD3AF2, "lightning_states" },
    { 0xBB8D01E2, "lightning_strike" },
    { 0xE9C3B48A, "lightning_strike_guy" },
    { 0x3B82ACF4, "lightning_vision" },
    { 0xB3D9E25D, "lightning_vision_set" },
    { 0x4E88AD8E, "lightningdir" },
    { 0x2AAB908E, "lightningexploder" },
    { 0x5C87002A, "lightningexploderindex" },
    { 0x3C42DCFE, "lightningexposure" },
    { 0x299926D9, "lightningflash" },
    { 0x3E0F236B, "lightningflashfunc" },
    { 0x2C46C1A5, "lightninggun" },
    { 0x377840F8, "lightninggun_arc" },
    { 0xED58F0B0, "lightninggun_arc_damage" },
    { 0x1B435038, "lightninggun_arc_delay" },
    { 0x97409D19, "lightninggun_arc_fx" },
    { 0xBF593BE6, "lightninggun_arc_fx_min_range" },
    { 0xF6FCE615, "lightninggun_arc_fx_min_range_sq" },
    { 0x1E67F6E0, "lightninggun_arc_killcam" },
    { 0x1D978A46, "lightninggun_arc_range" },
    { 0x08966935, "lightninggun_arc_range_sq" },
    { 0x6728F810, "lightninggun_arc_speed" },
    { 0x4AE41DB3, "lightninggun_arc_speed_sq" },
    { 0x08EEB60F, "lightninggun_damage_response" },
    { 0x9B016025, "lightninggun_elec_duration_max" },
    { 0xC40E18A7, "lightninggun_find_arc_targets" },
    { 0x27F91F7B, "lightninggun_fx_tag" },
    { 0xB3D1A13B, "lightninggun_start_damage_effects" },
    { 0x7EBE2EEC, "lightninggun_victim_rumble" },
    { 0x71E9DE68, "lightningintensity" },
    { 0xFAFEE936, "lightningnormalfunc" },
    { 0x3E5AB7C3, "lightningstrike" },
    { 0x5BC73DD7, "lightningthink" },
    { 0xD627F2D9, "lightningwaittime" },
    { 0xAF6F1EE3, "lightoriginoffs" },
    { 0x00BA363F, "lightouse" },
    { 0xDCDF6BBD, "lightpole" },
    { 0x1DE3BE76, "lightpole_death" },
    { 0x0F8181CD, "lightrain" },
    { 0x9D2EEECF, "lightregistered" },
    { 0xA64B1A6A, "lights" },
    { 0xA552312C, "lights_are_dirty" },
    { 0x4145DA32, "lights_arty_init" },
    { 0x56741F1C, "lights_back_on" },
    { 0xE8C2A798, "lights_delayfxforframe" },
    { 0x0E4826EE, "lights_drop" },
    { 0x0E9DAA3B, "lights_falling_over" },
    { 0x4297B829, "lights_group_toggle" },
    { 0x58372B59, "lights_kill" },
    { 0xC9163BEC, "lights_limo" },
    { 0xEC354F84, "lights_mode" },
    { 0x5DDF1272, "lights_motorcycle" },
    { 0x3762FC40, "lights_off" },
    { 0xC33D5D18, "lights_off_internal" },
    { 0xE103651A, "lights_on" },
    { 0x2DC403E6, "lights_on_internal" },
    { 0x777F4BCD, "lights_org" },
    { 0x4289520F, "lights_out" },
    { 0x155C1D1C, "lights_police_car" },
    { 0x4F72AD95, "lights_tinhatlamp_on" },
    { 0x6309866A, "lights_with_models" },
    { 0xCE243C2F, "lightsfxent" },
    { 0xED68E6C9, "lightsstate" },
    { 0xB7B4EF3D, "lightstarttime_max" },
    { 0xF518FA53, "lightstarttime_min" },
    { 0x918CD097, "lightstructs" },
    { 0x083AF1F3, "lightswitch_response" },
    { 0x3C6CAF1D, "lighttag" },
    { 0x368C23EE, "lighttag1" },
    { 0x4597DC64, "lighttagname" },
    { 0xBC1BF80A, "lighttower" },
    { 0x3417C363, "lighttower_start" },
    { 0xBEB32A27, "lightweight" },
    { 0xECBC7E94, "lignts_on" },
    { 0xC62713C4, "like" },
    { 0xDBC98108, "liked" },
    { 0xA1DF4BAB, "likelihood" },
    { 0x04EF2C61, "likely" },
    { 0x74488230, "likelyenemydir" },
    { 0x46028077, "likes" },
    { 0xF6739A55, "lil_shit" },
    { 0x2B4BF676, "lima" },
    { 0x05497C0D, "limb" },
    { 0x31A54918, "limb_data" },
    { 0xF7EA3399, "limb_tags_array" },
    { 0x6539CF30, "limbo" },
    { 0xCD2FE58C, "limbs" },
    { 0xCEEA0DAE, "limit" },
    { 0x9F29121A, "limit_boat_speed_for_drive" },
    { 0x16C5B293, "limit_equipment" },
    { 0xB5A3AE4E, "limit_pipe_fx" },
    { 0x68C89ED2, "limit_zombie_equipment" },
    { 0xFD212B38, "limitations" },
    { 0xDDD102F1, "limited" },
    { 0xDBE2C362, "limited_equipment_in_use" },
    { 0xAA21D53D, "limited_in_use" },
    { 0xECC089C0, "limited_info" },
    { 0x4A24E550, "limited_pickup" },
    { 0xC3C13940, "limited_weapon" },
    { 0x59842AFF, "limited_weapon_below_quota" },
    { 0x7B0CE86B, "limited_weapons" },
    { 0x60D71F0E, "limitedambushspawn" },
    { 0x8B449EE9, "limitedpickup" },
    { 0x220787F7, "limiter" },
    { 0x701FE9D2, "limiting" },
    { 0x21FA1AD1, "limits" },
    { 0x7750EB48, "limo" },
    { 0x64A905C8, "limo_burn" },
    { 0x16FCAA1A, "limo_clean" },
    { 0xFF57B4CD, "limo_crash_start" },
    { 0xB8486CD0, "limo_crashing" },
    { 0x03D4AC24, "limo_destroyed" },
    { 0x90E7448D, "limo_driver" },
    { 0xB332A7B2, "limo_escaped" },
    { 0x017C0FD3, "limo_fail_crash" },
    { 0x4106CAD5, "limo_final_damage_state" },
    { 0xFFCE5272, "limo_flashback" },
    { 0xA9F4719E, "limo_half_damage_state" },
    { 0x2F256B32, "limo_health_monitor" },
    { 0xA36810CF, "limo_interior_lights_on" },
    { 0x813A53A9, "limo_passenger" },
    { 0x65D4F7CF, "limo_ride_bumps" },
    { 0x5F2A5C8E, "limo_room" },
    { 0x893A3AE4, "limo_start_node" },
    { 0x2BCD4036, "limousine" },
    { 0xB176176F, "limp" },
    { 0x5EEFD8CC, "limp_loop" },
    { 0x87A588FC, "limp_when_hit" },
    { 0x8D2153F0, "limp_when_hit_hard" },
    { 0x725D644A, "limpin" },
    { 0xD4A92F51, "limping" },
    { 0xB0032926, "limping_guy_group_b" },
    { 0xD605A38F, "limping_guy_group_c" },
    { 0xB0DE1CE9, "limpset" },
    { 0x4E418837, "line" },
    { 0x629DE7DC, "line1" },
    { 0xD4A55717, "line2" },
    { 0xAEA2DCAE, "line3" },
    { 0xF09678A1, "line4" },
    { 0xCA93FE38, "line5" },
    { 0x3C9B6D73, "line6" },
    { 0x9537E33F, "line_1" },
    { 0x23307404, "line_2" },
    { 0x62F49477, "line_2_vc_shooter" },
    { 0x4932EE6D, "line_3" },
    { 0xD72B7F32, "line_4" },
    { 0x3F082FD4, "line_4_vc" },
    { 0x3B550E36, "line_5_active_vc" },
    { 0x0E9E157B, "line_5_window_shooter" },
    { 0x287468AC, "line_6_flavor_end_node" },
    { 0x4AC20532, "line_6_vc" },
    { 0x4AE53A6A, "line_a_cleared" },
    { 0xFEEE9E2A, "line_a_sm" },
    { 0x386348D6, "line_alias" },
    { 0x0608B7FA, "line_b_ai_killed_watcher" },
    { 0xC97515F2, "line_b_kill_watcher" },
    { 0x4990313B, "line_color" },
    { 0xA9BAF8DE, "line_dist" },
    { 0x074A731C, "line_emitter" },
    { 0x7A1DCA69, "line_end" },
    { 0x9E48243D, "line_ent_to_player" },
    { 0x1BAEF87E, "line_fire" },
    { 0xF445A6BF, "line_fire_start" },
    { 0x775A5C91, "line_flag01" },
    { 0x9D5CD6FA, "line_flag02" },
    { 0xC35F5163, "line_flag03" },
    { 0x908ED89D, "line_for_time" },
    { 0xE5008AE8, "line_frequency" },
    { 0x13790806, "line_frequency_s" },
    { 0x0B0EC9E6, "line_length" },
    { 0x9953B66F, "line_manager" },
    { 0x75734D1A, "line_num" },
    { 0x3923A439, "line_number" },
    { 0xE70B8843, "line_of_sight" },
    { 0xE127AD63, "line_play_chance" },
    { 0x1A1A0EAB, "line_played" },
    { 0x3767FCD0, "line_please" },
    { 0x5158B813, "line_points" },
    { 0xA889DCD3, "line_position" },
    { 0x188F7223, "line_queue" },
    { 0xB55A4019, "line_rval" },
    { 0xC4E765BD, "line_segment" },
    { 0xE8E01EEA, "line_select" },
    { 0x4BC6E495, "line_sound_player" },
    { 0x7D032C08, "line_spoken" },
    { 0x2626DB42, "line_start" },
    { 0x20FCC95A, "line_switch" },
    { 0xA59189ED, "line_to_guy" },
    { 0xE5C52796, "line_to_me" },
    { 0x87FCE052, "line_to_play" },
    { 0x0154CC03, "line_to_player" },
    { 0x546FEB7C, "line_to_tag" },
    { 0x3DA48107, "line_vectorlength" },
    { 0x032A32EB, "line_vectorscale" },
    { 0x5E594626, "linear" },
    { 0xE4EF4645, "linear_map" },
    { 0xD846D48F, "linear_movement_behavior" },
    { 0x2D7C9104, "linear_movement_behavior_adjusted" },
    { 0xEB05D23A, "linear_movement_behavior_adjusted_hit_react" },
    { 0x0E11200B, "linearly" },
    { 0x879A63E6, "linearscalar" },
    { 0x457A02AB, "linearvelocity" },
    { 0x52D43A37, "linebacker" },
    { 0x72896920, "linecolor" },
    { 0x1EF10AFB, "linedone" },
    { 0xFB940241, "linedraw" },
    { 0x7102B206, "lineemitters" },
    { 0x207ED3B6, "lineend" },
    { 0x7C947B7B, "linefeed_delay" },
    { 0x1DE0A133, "linefight" },
    { 0x899FA18B, "linelist" },
    { 0xAF3E0A76, "linemagsqrd" },
    { 0xAF5F7111, "linenum" },
    { 0x7D214D86, "lineorloop" },
    { 0xFFCC8170, "linequeue" },
    { 0xCB1C5EB2, "linequeue2" },
    { 0x5406BCD7, "liner" },
    { 0x6414B48E, "liners" },
    { 0x2E04426E, "lines" },
    { 0xD59B2C44, "lines_ogsize" },
    { 0x2416309A, "linesegment" },
    { 0x6663E0CC, "linesize" },
    { 0x07998C75, "linestart" },
    { 0x09ED7580, "linestring" },
    { 0x437CE98B, "linethread" },
    { 0x9E971CE4, "linetime" },
    { 0x2CBC1B67, "linetime_proc" },
    { 0xFB4B2169, "lineuntilnotified" },
    { 0x29811356, "lineuntilnotify" },
    { 0x058CAB44, "lineveh" },
    { 0x636A49B4, "linger" },
    { 0x0BCE4974, "lingering" },
    { 0x300EC9B9, "lingeringsmokefx" },
    { 0x0543E7A7, "lingers" },
    { 0x86BBF532, "lining" },
    { 0x3A1ED679, "link" },
    { 0xB91FA34D, "link_ai_to_plane" },
    { 0x5DA2AABC, "link_angles" },
    { 0x0B22C011, "link_cable_off" },
    { 0x5E7E13E5, "link_cable_on" },
    { 0xA67EA366, "link_cardboard_box_to_barge" },
    { 0x84CF4DBF, "link_carlos_to_plane" },
    { 0x851FFCE9, "link_changes_internal" },
    { 0x08AC2557, "link_changes_internal_internal" },
    { 0xE013B01E, "link_corpses_to_gondola" },
    { 0x2090266B, "link_effect_to_ents_tag" },
    { 0x932A7F6F, "link_enabled" },
    { 0x81BEF34B, "link_end" },
    { 0x21974CBB, "link_ent" },
    { 0x2257EB5A, "link_ents" },
    { 0x37439DED, "link_goal" },
    { 0xF8276995, "link_hero_boat" },
    { 0x3EF32B56, "link_loc" },
    { 0x49F111DE, "link_loop" },
    { 0xA6D33733, "link_model" },
    { 0x200A3EE0, "link_model_to_tag" },
    { 0xF7EDBF89, "link_model_update" },
    { 0x5BF9797B, "link_nodes" },
    { 0x4A32253E, "link_nodes_for_blocker_location" },
    { 0xCA1C2FBF, "link_nodes_wrapper" },
    { 0xD398804B, "link_obj" },
    { 0x3E44109D, "link_offset" },
    { 0x6D09FC78, "link_one" },
    { 0x7EB305BB, "link_one_dist" },
    { 0x655C2BFE, "link_org" },
    { 0x673D7E7F, "link_orig" },
    { 0x426C0A1A, "link_origin" },
    { 0xB559AEB4, "link_parent" },
    { 0x0CA951CD, "link_pieces" },
    { 0xC53799A1, "link_pilot_and_copilot" },
    { 0x534F8206, "link_pilot_to_sr71" },
    { 0x04256CDF, "link_platform_nodes" },
    { 0x1B4EC02B, "link_player" },
    { 0x095F3833, "link_player_and_woods_together" },
    { 0x5CED73BC, "link_player_to_btr" },
    { 0x58827A62, "link_player_to_car" },
    { 0xD2404EC6, "link_player_to_gondola" },
    { 0xEC6C005E, "link_player_to_plane" },
    { 0x69E4AA93, "link_player_to_sr71" },
    { 0x1D626638, "link_player_to_sullivan" },
    { 0xE7A9FC4C, "link_players_to_camera" },
    { 0xFD7B44F9, "link_players_to_train" },
    { 0x7C3FFBB4, "link_spot" },
    { 0x326ADA68, "link_start" },
    { 0xAAB71954, "link_tag" },
    { 0x05E98867, "link_to" },
    { 0x01CD28E8, "link_to_car" },
    { 0x2A2124A9, "link_to_ent" },
    { 0xA1E7E64D, "link_to_obj_name" },
    { 0xAFF685B0, "link_to_origin" },
    { 0x4D59B088, "link_to_point" },
    { 0x3F818D60, "link_train_cars" },
    { 0x8BF0B925, "link_traversals" },
    { 0x7104A095, "link_turrets" },
    { 0x8DE4A335, "link_turrets_fireall" },
    { 0x29F5D12A, "link_two" },
    { 0x23640DC9, "link_two_dist" },
    { 0x0D840E34, "link_type" },
    { 0xB42CB602, "link_vehicle_nodes" },
    { 0xE64EB037, "linkall_2d" },
    { 0xE365EEA6, "linked" },
    { 0xAA9B68F8, "linked_deaths" },
    { 0x6240198C, "linked_ent" },
    { 0x7EC40184, "linked_light_ents" },
    { 0xAA541BC2, "linked_lights" },
    { 0x5578900C, "linked_model" },
    { 0xAAAA8B8F, "linked_models" },
    { 0x8E3054DA, "linked_move" },
    { 0x9A132F34, "linked_nodes" },
    { 0x3D75DF0C, "linked_object" },
    { 0xE51358DB, "linked_origin" },
    { 0x68612A53, "linked_scene_str" },
    { 0x109C74A6, "linked_scenes" },
    { 0x84F532CE, "linked_scenes_timeout" },
    { 0x588ED497, "linked_tag" },
    { 0x84FA6D26, "linked_things" },
    { 0xAAF13C76, "linked_to" },
    { 0x61D512E5, "linked_to_bus" },
    { 0x0845BBCF, "linked_to_elevator" },
    { 0x15C6BD77, "linked_vehicle" },
    { 0xF262A5ED, "linkedent" },
    { 0x298B6093, "linkedgrenades" },
    { 0xB15C9715, "linkedgrenadesindex" },
    { 0xE637A99B, "linkedobject" },
    { 0x967D08D0, "linkedtargets" },
    { 0xBC2B3175, "linkedto" },
    { 0x0968690F, "linkee" },
    { 0xDFBF6B80, "linkent" },
    { 0x60E352CD, "linkentitiestocoremover" },
    { 0xCD7337AB, "linkents" },
    { 0x9F2F69A0, "linker" },
    { 0x23809522, "linker2" },
    { 0xD4DF691A, "linker_delete_watch" },
    { 0x73E964A6, "linker_object" },
    { 0x4C911DE3, "linker_pos" },
    { 0x43455F91, "linkfakeplayer" },
    { 0xADE38926, "linkguidedmissilecamera" },
    { 0xFD4E10B9, "linkhash" },
    { 0xBE6A2249, "linkhashes" },
    { 0x414DAC3A, "linki" },
    { 0xA0CA1C7B, "linkindex" },
    { 0x310AC18F, "linking" },
    { 0xF464F6F9, "linkinplace" },
    { 0x8A00C789, "linkmap" },
    { 0x8208F918, "linkname" },
    { 0xDF3D1DF3, "linknames" },
    { 0x681FB820, "linknodes" },
    { 0xA4134E6D, "linkorg" },
    { 0x255C8AB0, "links" },
    { 0xC2E37451, "linkspot" },
    { 0xFF066372, "linkstring" },
    { 0x462A7173, "linktag" },
    { 0x4DB3E032, "linktarget" },
    { 0x37F7858A, "linkto" },
    { 0x1506D113, "linkto_elevator" },
    { 0x78A96668, "linkto_enabled" },
    { 0x078CF9C0, "linkto_ent" },
    { 0xF096ED60, "linkto_model" },
    { 0x16652634, "linkto_model_update" },
    { 0x1F7E8BEE, "linkto_parent_boat" },
    { 0x23B7F15E, "linkto_struct" },
    { 0x84CA4BB3, "linkto_tag" },
    { 0x359FB6C9, "linkto_trigger_off" },
    { 0x59A8AEBD, "linkto_trigger_on" },
    { 0x4A5AF2C8, "linktoblade" },
    { 0x7949A3CC, "linktoblendtotag" },
    { 0x9535B9C7, "linktocamera" },
    { 0x1C470DB0, "linktocustomcharacter" },
    { 0xF5FC12BB, "linktoer" },
    { 0xD9CE7E0E, "linktomissile" },
    { 0x1FBA4BC5, "linktos" },
    { 0x11293224, "linktoupdateoffset" },
    { 0x47D28A09, "linktraversal" },
    { 0x9AD1643E, "linkxcamtooneplayer" },
    { 0xFC3211F3, "linot" },
    { 0xD4DEDE1B, "lion" },
    { 0x06107348, "lion_ball_enable_pickup" },
    { 0x15164C40, "lip" },
    { 0xA59B2F0D, "liquid" },
    { 0x2F98A797, "liquidattop" },
    { 0xA71DFABB, "liquidclip" },
    { 0xB7D9D6E0, "liquiddamagetrig" },
    { 0xCFA2F89E, "liquidfiredamage" },
    { 0x1DCFD5B5, "liquidfiredone" },
    { 0x916F8C67, "liquidfirefx" },
    { 0xCDFB32E0, "liquidfirepoints" },
    { 0x31BDAEED, "liquidreadyforignite" },
    { 0x25C27E55, "list" },
    { 0x5E9C8971, "list_add" },
    { 0xAA8C411C, "list_index" },
    { 0xFB835FED, "list_menu" },
    { 0x9E465F82, "listed" },
    { 0x82553DF8, "listen" },
    { 0xA06F4E4A, "listen_for_campaign_state_change" },
    { 0x68F6F63E, "listen_for_end_of_banzai_announce" },
    { 0x697343D9, "listen_for_end_of_banzai_yell" },
    { 0xFA0C376F, "listen_for_hatchet_fail" },
    { 0xBC0DD61B, "listen_for_launchlevel_messages" },
    { 0x7E8D0617, "listen_for_luisystem_messages" },
    { 0x92C83D1E, "listen_to_the_doctor" },
    { 0xB6A1A062, "listen_to_the_doctor_endgame" },
    { 0xEF7D064A, "listen_to_the_doctor_human_deaths" },
    { 0x6A26795D, "listen_to_the_doctor_monkeys" },
    { 0x2E65ED7E, "listen_to_the_doctor_pregame" },
    { 0x383D3DA4, "listen_to_the_doctor_started" },
    { 0x332CD797, "listen_to_the_doctor_zombie_deaths" },
    { 0x8BE9364D, "listener" },
    { 0xFBDF4CCC, "listeners" },
    { 0xDADAD686, "listenforgameend" },
    { 0xC8F84FEA, "listenformove" },
    { 0x2978DE60, "listening" },
    { 0xB6AEF053, "listens" },
    { 0x9DBE4D82, "listings" },
    { 0xF2EC6EDF, "listnum" },
    { 0x0BEBE26C, "listoff" },
    { 0x63B38816, "liston" },
    { 0xB30FE2A4, "lists" },
    { 0xAE042D8A, "listsize" },
    { 0xA7AA5299, "listweaponattachments" },
    { 0xAD2035E4, "lit" },
    { 0x9E71F2A3, "lit_discs" },
    { 0x23ABF98C, "lit_icon" },
    { 0x5F842D3A, "lit_model" },
    { 0xF34C64C5, "lit_num" },
    { 0x97CE4CA8, "lit_sign" },
    { 0x3C9B4E11, "lite" },
    { 0xE4E90753, "lite_settings" },
    { 0x7D3B9CF8, "liteent" },
    { 0xAFEBD8F8, "liteintensity" },
    { 0x92C4D0D8, "litemodel" },
    { 0xC1BB484D, "litle" },
    { 0xAEBB1793, "littel" },
    { 0x50089524, "littl" },
    { 0xEF2C0B51, "little" },
    { 0xB12223ED, "little_bird" },
    { 0x717CC696, "little_bird_attack_drinks_area" },
    { 0xA285BF8A, "little_bird_checkpoint" },
    { 0x837D9EBF, "little_bird_checkpoint_hovering" },
    { 0xCBB4A0C3, "little_bird_investigate_water_tower" },
    { 0xBE0C65A0, "little_bird_objectives" },
    { 0xB42F4CCA, "little_bird_pilot" },
    { 0x63360B53, "little_bird_start_node" },
    { 0xE0898539, "little_girl_lost_step_1_over" },
    { 0xDC144054, "little_girl_lost_step_2_over" },
    { 0x972E03EF, "little_girl_lost_step_3_over" },
    { 0xF397975A, "little_girl_lost_step_4_over" },
    { 0x5FFF9BFD, "little_girl_lost_step_5_over" },
    { 0x9130E1D8, "little_girl_lost_step_6_over" },
    { 0x26F53C83, "little_girl_lost_step_7_over" },
    { 0x0011477E, "little_girl_lost_step_8_over" },
    { 0xC4FCF738, "littlebird" },
    { 0xC7BE20FB, "littlebird_circle" },
    { 0xE77AA895, "littlebird_debug_line" },
    { 0xD6F925AA, "littlebird_debug_text" },
    { 0xC6BFA62B, "littlebird_fire" },
    { 0x320324FE, "littlebird_fire_indiscriminately" },
    { 0x9C4D47F3, "littlebird_fire_until_flag" },
    { 0x54177E4A, "littlebird_fireat_cessna" },
    { 0x56E16704, "littlebird_fireat_truck" },
    { 0x3A9AE139, "littlebird_kill_troops" },
    { 0x2D0C0E85, "littlebird_parking_lot" },
    { 0x97BF1934, "littlebird_strafe_parkinglot" },
    { 0x1BA106C7, "littlebirdguard" },
    { 0x88A4923E, "littlebirdhackertoolradius" },
    { 0x9971B473, "littlebirdhackertooltimems" },
    { 0x0042C355, "litttle" },
    { 0xD322B04D, "liu" },
    { 0x69DDEDAF, "live" },
    { 0xBDFEE3C3, "live_anticheat" },
    { 0xF7572119, "live_character_spawn_target" },
    { 0x1E8D4D1B, "live_leaderboard" },
    { 0x03F51E01, "liveccdata" },
    { 0x7E655979, "lived" },
    { 0x87989E3C, "liveevents" },
    { 0x46E7373C, "liverobots" },
    { 0xDC4A16F6, "lives" },
    { 0xB9085EC3, "lives_remaining" },
    { 0x226B2AE5, "livesdonotreset" },
    { 0x8D1979FC, "livesentients" },
    { 0x2605D30D, "livesleft" },
    { 0xE49AAC3F, "livestock" },
    { 0x2BA71F3F, "livesypos" },
    { 0x8F85844C, "liveupdate" },
    { 0x262CED2A, "living" },
    { 0x8870239C, "living_actor_count" },
    { 0x7146EEA7, "living_ai" },
    { 0x69DD256B, "living_ai_prethink" },
    { 0x1B1AC1A1, "living_battlefield" },
    { 0x5AC9142C, "living_battlefield_amb" },
    { 0x44DAEA93, "living_battlefield_anim" },
    { 0x4EAE16C1, "living_battlefield_cam" },
    { 0xE9B67FF6, "living_battlefield_fx" },
    { 0x6FB3681F, "living_enemies" },
    { 0xB1B1CF41, "living_rpg_guys" },
    { 0xDC4F1F5A, "livingguys" },
    { 0x1119476D, "livingtarget" },
    { 0x15CD759D, "ll" },
    { 0xB0236842, "llbe" },
    { 0xE3442432, "llcf" },
    { 0x696E452B, "llcw" },
    { 0xAEF57C1F, "llss" },
    { 0x6AFD4CC2, "lm_script_area" },
    { 0xE80AE44F, "lm_script_area_origin" },
    { 0x49991113, "lmg" },
    { 0x50CDD09F, "lmg_endgame_1" },
    { 0xDEC66164, "lmg_endgame_2" },
    { 0x04C8DBCD, "lmg_endgame_3" },
    { 0x02E0866D, "lmg_endgame_array" },
    { 0xB860D69B, "lmg_kill_index" },
    { 0xE856E15E, "lmg_lobby" },
    { 0xB60DE942, "lmgs" },
    { 0x9582F039, "lnd" },
    { 0x3BCFF006, "lo" },
    { 0xD7916D65, "load" },
    { 0x06731692, "load_ai" },
    { 0x872149EF, "load_ai_goddriver" },
    { 0x7B0451B3, "load_bldg02" },
    { 0x147C6623, "load_bombs" },
    { 0xD2A29F68, "load_buffel" },
    { 0x51A1CC4D, "load_bunker_gump" },
    { 0x4E0C6723, "load_convoy_vehicle" },
    { 0xF4E8F798, "load_crew_anims" },
    { 0x450AF4B6, "load_default_loadout" },
    { 0xEA08F195, "load_default_loadout_raw" },
    { 0xF290C7E9, "load_e2_truck" },
    { 0xE82AF00E, "load_ending_gump_trigger" },
    { 0xC449CAA9, "load_flak_anims" },
    { 0xEF27CB17, "load_flak_fx" },
    { 0x2BB4D3C7, "load_fletcher_ship_names" },
    { 0xF0A8B5AD, "load_friendlies" },
    { 0x47BD5242, "load_fx" },
    { 0xC9CD3552, "load_gaz66" },
    { 0x07FCFCD7, "load_gump" },
    { 0x482E1B9D, "load_gump_c" },
    { 0xE30253AB, "load_gump_escape" },
    { 0x8D8C180D, "load_gump_for_player" },
    { 0xBC321AF0, "load_gump_in_two" },
    { 0xB0BB748E, "load_gumps" },
    { 0x0A1D0B31, "load_gumps_afghanistan" },
    { 0x6C58835E, "load_gumps_blackout" },
    { 0xC988337F, "load_gumps_karma" },
    { 0x27E7F424, "load_gumps_monsoon" },
    { 0x3E41AB7A, "load_gumps_nicaragua" },
    { 0x069D7380, "load_gumps_pakistan" },
    { 0x21053E99, "load_gumps_panama" },
    { 0x22F8CD1F, "load_landing_troops" },
    { 0x0851BB8F, "load_main_complete" },
    { 0xFC58B949, "load_movie_async" },
    { 0x83CD84F5, "load_pathstructs" },
    { 0x00E009AA, "load_roof_gump" },
    { 0x4A91BD2F, "load_shared" },
    { 0xA4B0B3B5, "load_snowcat_spots" },
    { 0x1DE0E607, "load_story_stats" },
    { 0x8AED5710, "load_triple25_anims" },
    { 0x3BB361C4, "load_triple25_gunner_anims" },
    { 0xCE089C8F, "load_up_fake_huey_ais" },
    { 0x0BF9D6E2, "load_up_fake_huey_ais_l" },
    { 0x4FD15D44, "load_up_fake_huey_ais_lr" },
    { 0x27EAF86C, "load_up_fake_huey_ais_r" },
    { 0x5E279751, "load_up_huey" },
    { 0x841366AC, "load_up_sampan" },
    { 0xB7EBE1B6, "load_up_sampan_drones" },
    { 0x72560A4C, "load_vfx_fill_settings" },
    { 0xD3F94DE5, "load_vfx_spot_settings" },
    { 0x4106479C, "load_vfxspot_settings" },
    { 0x0B7158F9, "load_vo_alias_arrays" },
    { 0xB8CB5AC8, "load_weapon_spec_from_table" },
    { 0xC27ABC84, "load_zpu_anims" },
    { 0x65995AAD, "load_zpugunner_anims" },
    { 0x478D992C, "loadcharacteronmodel" },
    { 0xF29740C5, "loadcustomgamemodeclasses" },
    { 0x5AEF1852, "loaded" },
    { 0x8221909A, "loaded_gump" },
    { 0x52A5BA2D, "loaded_weapon_kill_index" },
    { 0xCDA66FF8, "loadedfx" },
    { 0x23F52199, "loadeffects" },
    { 0x0D79D6D7, "loadequippedcharacteronmodel" },
    { 0x071BB3B4, "loader" },
    { 0x2DC0B813, "loadfilter" },
    { 0x049D15A3, "loadfx" },
    { 0x16CC0958, "loadgamerules" },
    { 0x4232CDAC, "loadgamestats" },
    { 0x449C07C6, "loadgump" },
    { 0x7F629186, "loadguy" },
    { 0x39CCD589, "loadguy_done" },
    { 0xB1AE87C9, "loadguy_starting" },
    { 0x10A27CC3, "loading" },
    { 0x070341E2, "loading_dock_dialog" },
    { 0xCA359D42, "loading_movie_1_main" },
    { 0x7A452F57, "loading_movie_2_main" },
    { 0xB28E9639, "loading_movie_done" },
    { 0x7455A686, "loading_truck_enemies" },
    { 0x58961188, "loading_truck_spawner_array" },
    { 0x7C04BD42, "loadingdock" },
    { 0xBE80D90B, "loadingdock_dialogue" },
    { 0xD41F1B85, "loadmap" },
    { 0x9B63907F, "loadmod" },
    { 0x61B7B1CC, "loadmodel" },
    { 0x91796B4F, "loadmultiplayer" },
    { 0xA249D1DB, "loadout" },
    { 0x5DE30B6C, "loadout_curweapon" },
    { 0xB996F5CD, "loadout_gadgets_count" },
    { 0x200CD6DB, "loadout_gadgets_hero_weapon" },
    { 0x523C8B03, "loadout_gadgets_offhand_primary" },
    { 0xABB0B18B, "loadout_gadgets_offhand_secondary" },
    { 0x215FE168, "loadout_gadgets_offhand_special" },
    { 0x88342612, "loadout_get_class_num" },
    { 0x358BC963, "loadout_get_offhand_count" },
    { 0x64DF9F6E, "loadout_get_offhand_weapon" },
    { 0x84404952, "loadout_offhand" },
    { 0xA6FD168A, "loadout_perk" },
    { 0xE8E04DD0, "loadout_perks_remove" },
    { 0xC03680B4, "loadout_perks_removed" },
    { 0x96FB483E, "loadout_perks_restore" },
    { 0x605EE2F8, "loadout_perks_set" },
    { 0xBF8B6A2B, "loadout_perks_store" },
    { 0x3C1FA12C, "loadout_primary" },
    { 0x27F95F48, "loadout_primary_count" },
    { 0x8657DCD4, "loadout_secondary" },
    { 0x4F025780, "loadout_secondary_count" },
    { 0x94C7F2D5, "loadout_shared" },
    { 0x26FCD0F0, "loadout_slot_name" },
    { 0x0B1FB572, "loadout_table" },
    { 0x4A1DCB64, "loadout_table_default" },
    { 0x91EFCA88, "loadout_weapons_info" },
    { 0xC63EC2C4, "loadout_weapons_list" },
    { 0xF476C14A, "loadout_weapons_restore" },
    { 0xF42BCDCF, "loadout_weapons_store" },
    { 0xD79BC619, "loadout_weapons_stored" },
    { 0xC77C87C9, "loadoutclasses" },
    { 0x528E7872, "loadoutcomplete" },
    { 0x1A47407B, "loadoutkillstreaksenabled" },
    { 0x5BFE16FA, "loadouts" },
    { 0x18DD6007, "loadoutslot" },
    { 0xDB67AC14, "loadoutweaponstats" },
    { 0x14AAFDF2, "loadplayer" },
    { 0x7AA0AA1C, "loadplayervoicecategories" },
    { 0xD78B333B, "loadpresets" },
    { 0x6D5EBA74, "loads" },
    { 0xA00E90D1, "loadscreen" },
    { 0x3C8268F1, "loadsmoothing" },
    { 0xD3E74030, "loadspec" },
    { 0x099520F6, "loadstring" },
    { 0xA72F1F02, "loadtime" },
    { 0x0B35F5AD, "loadtreadfx" },
    { 0x479584BA, "lob_factor" },
    { 0xE28DD889, "lob_them_nades" },
    { 0x54EFE8F3, "lobbies" },
    { 0x0175C097, "lobby" },
    { 0xCED6EC1C, "lobby_anims" },
    { 0x3AC2D9D2, "lobby_cleanup" },
    { 0xA0F1FD82, "lobby_dialog" },
    { 0x9CE9674D, "lobby_naglines" },
    { 0xD8B00F15, "lobby_upstairs_doors" },
    { 0xC8A3AC29, "loc" },
    { 0x3CCD30B2, "loc1" },
    { 0x16CAB649, "loc2" },
    { 0x46828519, "loc_c4" },
    { 0xA9E6BD44, "loc_comm" },
    { 0x1BF43433, "loc_compound" },
    { 0x90479773, "loc_current" },
    { 0x1688B8EB, "loc_facility" },
    { 0xBCCDDF81, "loc_gantry" },
    { 0x112F3AC5, "loc_random_offset" },
    { 0x066C0F5B, "loc_ref" },
    { 0xD01F133F, "loc_string" },
    { 0xAB44438F, "loc_struct" },
    { 0xA50B290A, "loc_trig" },
    { 0xEDF70B18, "loc_weaver" },
    { 0xF61B40EA, "local" },
    { 0x3ED726C2, "local_cam_movement" },
    { 0x6EFF929C, "local_client" },
    { 0x1094988D, "local_client_num" },
    { 0x0739E44C, "local_clientnum" },
    { 0xD3CFC2E1, "local_console_input" },
    { 0x29326FFB, "local_doors_stay_open" },
    { 0x6C2DD670, "local_drone_animontag" },
    { 0x3A1986F0, "local_end" },
    { 0xC0689217, "local_hit_point" },
    { 0x8909CAFC, "local_location" },
    { 0x4D8E5315, "local_ltgun" },
    { 0xEA06AE85, "local_mid" },
    { 0x3EB952B0, "local_offset" },
    { 0x3F95C4A2, "local_owner" },
    { 0xFDD38A76, "local_player" },
    { 0xFA5641DB, "local_player_entity_thread" },
    { 0xDBABB196, "local_player_spawn" },
    { 0xB67A86AD, "local_player_trigger_thread_always_exit" },
    { 0x42EAEF69, "local_players" },
    { 0xC6073B50, "local_players_entity_thread" },
    { 0x3043A19C, "local_power" },
    { 0x2E59DBC2, "local_power_off" },
    { 0x74EB2F34, "local_power_on" },
    { 0x4C4774F1, "local_power_only" },
    { 0x73872B2F, "local_rtgun" },
    { 0xBCB60BDB, "local_tail" },
    { 0x31FF5F8E, "local_time" },
    { 0xCB4842E1, "local_weapon_paintshop_class" },
    { 0xD3BB5E2F, "local_wind" },
    { 0x3979868E, "local_zombies_killed" },
    { 0x4FF76836, "localangles" },
    { 0x101A16B7, "localclient" },
    { 0xD92565A5, "localclientactive" },
    { 0x8C67CB49, "localclientchanged" },
    { 0x6018F79D, "localclientchanged_callback" },
    { 0x80BC4653, "localclientconnect" },
    { 0x982CEEC7, "localclientconnect_callback" },
    { 0xCD611C09, "localclientdisconnect" },
    { 0x01D8CDE9, "localclientindex" },
    { 0xEC74B091, "localclientnum" },
    { 0x1FB41218, "localclientnumber" },
    { 0x4E564316, "localclientnumm" },
    { 0x5E99C247, "localclientspawned_callback" },
    { 0xC947BD8A, "localdeltahalfvector" },
    { 0xF9A63885, "localdeltavector" },
    { 0x964F094C, "localenemyonly" },
    { 0x4E98CDB7, "localentity" },
    { 0x3B7015EA, "locality" },
    { 0xB4D36202, "localization" },
    { 0x83C88088, "localize" },
    { 0xD45CF29C, "localized" },
    { 0xFB6FC324, "localized_string" },
    { 0x3F5650DA, "localized_text_size" },
    { 0x8B4732B7, "locally" },
    { 0x58D743C3, "localowner" },
    { 0xEAD32655, "localplayer" },
    { 0x58C8343A, "localplayer_duplicate_render_bundle_init" },
    { 0x2DCA7A10, "localplayer_postfx_bundle_init" },
    { 0xCD071852, "localplayer_spawned" },
    { 0x216AE60D, "localplayeranglestoforward" },
    { 0x581E1A40, "localplayeranglestoright" },
    { 0x9E4E9E56, "localplayerbit" },
    { 0x4445A6DF, "localplayernum" },
    { 0xEC485AA4, "localplayers" },
    { 0xDA52BCD2, "localplayerteam" },
    { 0x6392268D, "localpower" },
    { 0xC8EAFD69, "localradarenabled" },
    { 0x28FE13BE, "localrainfx" },
    { 0xCF478564, "localrotatetime" },
    { 0xFB004304, "localshootvolley" },
    { 0x678D2F60, "localtopplayerindex" },
    { 0xD3197299, "localtoworldcoords" },
    { 0x771B4F61, "localvar" },
    { 0x534AEF58, "locarray" },
    { 0xBE510ABB, "locate" },
    { 0x865E4AB7, "locate_contested_twar_flag" },
    { 0xACED1B25, "located" },
    { 0x0C396B2B, "locatin" },
    { 0x685E001E, "locating" },
    { 0x35940ED8, "location" },
    { 0x768CCC21, "location1" },
    { 0x9C8F468A, "location2" },
    { 0xC291C0F3, "location3" },
    { 0x65DB4724, "location_1" },
    { 0xD7E2B65F, "location_2" },
    { 0xB1E03BF6, "location_3" },
    { 0x40E25A20, "location_egg_vox" },
    { 0x94A3E305, "location_estimate" },
    { 0x7DEBE77D, "location_for_skipto" },
    { 0x344E9C36, "location_is_allowed" },
    { 0x049244A3, "location_list" },
    { 0x75D9FD0A, "location_num_until_repeat" },
    { 0x6164D131, "location_removed" },
    { 0xB6C00A69, "location_set" },
    { 0xC1714E3F, "locational" },
    { 0xAB59BEDF, "locationarray" },
    { 0x6376EE77, "locationend" },
    { 0x034F47E7, "locationent" },
    { 0x6D642BCC, "locationindex" },
    { 0x52783C1C, "locationinfo" },
    { 0x279D8218, "locationobjid" },
    { 0x41F326B3, "locations" },
    { 0x4AA0BFA2, "locations3" },
    { 0x1BC5675C, "locationstart" },
    { 0x9612CF9D, "locationstingersetup" },
    { 0x6ECECFD5, "locationstingerwait" },
    { 0x77EA79E0, "locationtype" },
    { 0x18AB2848, "locatoin" },
    { 0xA26E1701, "locator" },
    { 0x00651B78, "lock" },
    { 0x273A85E1, "lock_additional_player_spawner" },
    { 0x1838AD0C, "lock_breaker_perk" },
    { 0x2303D64C, "lock_breaker_perk_used" },
    { 0x8BEA60BA, "lock_doors" },
    { 0xD70762DE, "lock_ent" },
    { 0x7F6FD169, "lock_evade_acceleration_boost" },
    { 0x7FA98EEF, "lock_evade_dist_half_height" },
    { 0xF700F96E, "lock_evade_dist_max" },
    { 0x49D86830, "lock_evade_dist_min" },
    { 0xD79D52EB, "lock_evade_enemy_line_of_sight_directness" },
    { 0x296EFA1F, "lock_evade_now" },
    { 0xA2EACE43, "lock_evade_point_spacing_factor" },
    { 0x043119FA, "lock_evade_speed_boost" },
    { 0x28E812B3, "lock_evading" },
    { 0x0A5A269B, "lock_frac" },
    { 0x606C2099, "lock_fx" },
    { 0x0CF8CD0E, "lock_in_place" },
    { 0x58AA601F, "lock_length" },
    { 0x6CA843AD, "lock_light" },
    { 0xF4D44E8F, "lock_light_run" },
    { 0x48A47184, "lock_light_switch" },
    { 0xA7A13047, "lock_lost_time" },
    { 0xB5F1D3FE, "lock_model" },
    { 0x61459718, "lock_obj_location" },
    { 0x3B1FE177, "lock_on_acquired" },
    { 0x64081AE6, "lock_on_ent" },
    { 0xFEE4D60B, "lock_on_missile_turret_start" },
    { 0x6A70C8D8, "lock_on_player" },
    { 0x98FC8AFE, "lock_on_player_ent" },
    { 0x6F98A66E, "lock_on_player_off" },
    { 0xA487BDA8, "lock_on_reset" },
    { 0xAAECEF64, "lock_on_steps" },
    { 0xC07E7F7D, "lock_player_controls" },
    { 0xC71FBC13, "lock_player_on_team_score" },
    { 0xCB5AD6BB, "lock_players" },
    { 0xA81835B4, "lock_players_intro" },
    { 0x95A9B9A2, "lock_sound_ent" },
    { 0xC0D6CB9C, "lock_spawner_for_awhile" },
    { 0x9FFF05BC, "lock_time" },
    { 0x77114417, "lock_view_clamp_over_time" },
    { 0x85CBBAC5, "lock_weapon_model" },
    { 0x9287EE54, "lock_weapon_models" },
    { 0x45F0265F, "lock_zombie_spawners" },
    { 0xB1F313F6, "lockaction" },
    { 0xA4BEEF01, "lockalertstate" },
    { 0x74536312, "lockbreak_mason" },
    { 0x89C0CBB4, "lockbreaker" },
    { 0x1B7AF6AE, "lockbreaker_challenge" },
    { 0x81A1F19F, "lockbreaker_door" },
    { 0xDA3F4D2A, "lockbreaker_door_open" },
    { 0x95AAE2DD, "lockbreaker_machete_picked_up" },
    { 0x21E5095B, "lockbreaker_perk" },
    { 0x087D2CD1, "lockbreaker_perk_anim" },
    { 0x5D1BABB8, "lockbreaker_perk_anims" },
    { 0xB59595A6, "lockbreaker_perk_scene" },
    { 0xC3522CD5, "lockbreaker_planted" },
    { 0xE6FD455C, "lockdown" },
    { 0x1F7AAC18, "lockdown_track" },
    { 0x9585EF15, "locke" },
    { 0x9F1CC18B, "locked" },
    { 0xE8BD0C39, "locked_cost" },
    { 0x5143A83F, "locked_magic_box_cost" },
    { 0x084FC4D2, "locked_missile_min_distsq" },
    { 0x166BC34D, "locked_model" },
    { 0xC5BACF61, "locked_on" },
    { 0x5E8A2BC8, "locked_on_cleared" },
    { 0x3C0887DF, "locked_on_notify" },
    { 0x6EC48068, "locked_on_to_me_just_changed" },
    { 0x3F5AAC86, "locked_spawner" },
    { 0x78A804BC, "lockedon" },
    { 0xA28E7490, "lockedsound" },
    { 0xF77D0C07, "lockent" },
    { 0x8AFA0FCD, "locker" },
    { 0x0365B14C, "lockers" },
    { 0xFB301981, "lockheliheight" },
    { 0x30FF42E0, "locking" },
    { 0xB081980B, "locking on" },
    { 0xE1494B46, "locking on hacking" },
    { 0xAE1DF088, "locking_on" },
    { 0xEE40CEC9, "locking_on_cleared" },
    { 0xA6523740, "locking_on_hacking" },
    { 0x1B586941, "locking_on_hacking_cleared" },
    { 0x9CAB2334, "locking_on_notify" },
    { 0x73AB1B67, "locking_on_to_me_just_changed" },
    { 0x76DDAEFB, "locking_sound_playing" },
    { 0xD444036B, "lockingon" },
    { 0xCCBBC5DD, "lockingsound" },
    { 0x5BABA0BC, "locklength" },
    { 0xD941D388, "locklengthms" },
    { 0x212EBBA3, "lockon" },
    { 0x332C422A, "lockon_changed" },
    { 0xF1C96773, "lockon_msg_killed" },
    { 0x5001B74F, "lockon_owner" },
    { 0xEE0166A1, "lockonaliaslist" },
    { 0x0DC18D5C, "lockonanglehorizontal" },
    { 0xE26F7F42, "lockonanglevertical" },
    { 0x5130A217, "lockoncanceledmessage" },
    { 0x92F5D6D3, "lockoncloseradiusscaler" },
    { 0x8A9C6B3C, "lockoncloserange" },
    { 0xDD02CA2C, "lockondelay" },
    { 0xD69B92C3, "lockondisabled" },
    { 0x0533D7A2, "lockonentity" },
    { 0x94B347A3, "lockonlossanglehorizontal" },
    { 0x8D1411C9, "lockonlossanglevertical" },
    { 0xA1B9CF66, "lockonmaxrange" },
    { 0x7A620480, "lockonminrange" },
    { 0x1067B1FB, "lockonmissileturret" },
    { 0xCB120510, "lockonmissilezoom" },
    { 0x65BB8292, "lockons" },
    { 0x27EAACC9, "lockonscreenradius" },
    { 0xDAB5E2CD, "lockonseekerlockedsound" },
    { 0x1E03EF56, "lockonseekerlockedsoundloops" },
    { 0x088FF717, "lockonseekersearchsound" },
    { 0x6A4B54D0, "lockonseekersearchsoundloops" },
    { 0xB99062A4, "lockonspeed" },
    { 0x0CBE906C, "lockontarget" },
    { 0x3CC35884, "lockontargetfiredonsound" },
    { 0x71358349, "lockontargetfiredonsoundloops" },
    { 0x1E3C6373, "lockontargetlockedsound" },
    { 0x4D6E741C, "lockontargetlockedsoundloops" },
    { 0xFE4D02D8, "lockontime" },
    { 0x1B63F6DB, "lockontype" },
    { 0xD58A355E, "lockorigin" },
    { 0x92E30C84, "lockout" },
    { 0x5EA5C74D, "lockpath" },
    { 0xC1286713, "lockpick" },
    { 0xCFB2F478, "lockplayerforqrdronelaunch" },
    { 0xA9A8A0D3, "locks" },
    { 0x27F7300B, "locksighttest" },
    { 0xC6FB32D4, "locksounds" },
    { 0xCD0876D0, "lockspot" },
    { 0xC88F0F0E, "locksquad" },
    { 0x28116EEF, "lockstarttime" },
    { 0x418D9A7C, "lockswitch" },
    { 0x9A245BC3, "locktarget" },
    { 0x67FADDB3, "locktime" },
    { 0xCE29B4CB, "locktimer" },
    { 0xE5FD40CB, "lockview" },
    { 0x1EDBF0D3, "locmotion" },
    { 0x986F051C, "loco" },
    { 0x14FA3E25, "loco_idle" },
    { 0x5DAC11D1, "loco_motion" },
    { 0x60057D0F, "loco_trans" },
    { 0x7A02AA3A, "locomotion" },
    { 0x3F6D1106, "locomotion_arrival_distance" },
    { 0x6D3CC978, "locomotion_arrival_yaw" },
    { 0x26B7077D, "locomotion_exit_yaw" },
    { 0x30A2E5BF, "locomotion_face_enemy_back" },
    { 0xA9013BE3, "locomotion_face_enemy_front" },
    { 0xDA27E6C9, "locomotion_face_enemy_left" },
    { 0xA79091D4, "locomotion_face_enemy_none" },
    { 0xCD7EB352, "locomotion_face_enemy_quadrant" },
    { 0x5D96A35A, "locomotion_face_enemy_quadrant_previous" },
    { 0xB9C3A5F4, "locomotion_face_enemy_right" },
    { 0xDA5D9A1B, "locomotion_func" },
    { 0x4840D204, "locomotion_inplace_pain" },
    { 0xC5D4AF7B, "locomotion_motion_angle" },
    { 0x9B3E1CFA, "locomotion_moving_pain_dist_long" },
    { 0x3CD49D22, "locomotion_moving_pain_dist_med" },
    { 0x3D3DE356, "locomotion_moving_pain_dist_short" },
    { 0xD91C150B, "locomotion_moving_pain_long" },
    { 0x012E1455, "locomotion_moving_pain_med" },
    { 0x57A78095, "locomotion_moving_pain_short" },
    { 0x76C81860, "locomotion_pain_type" },
    { 0x2B8CDD76, "locomotion_should_turn" },
    { 0x64585E82, "locomotion_speed_1" },
    { 0x3E55E419, "locomotion_speed_2" },
    { 0x185369B0, "locomotion_speed_3" },
    { 0x014D4421, "locomotion_speed_burned" },
    { 0x99D13C3A, "locomotion_speed_jump_pad_super_sprint" },
    { 0x5A34642C, "locomotion_speed_run" },
    { 0xB2846CFC, "locomotion_speed_slide" },
    { 0x24B84D55, "locomotion_speed_sprint" },
    { 0xBC9E9775, "locomotion_speed_super_sprint" },
    { 0xA802E2E1, "locomotion_speed_type" },
    { 0x61D2FA6A, "locomotion_speed_walk" },
    { 0x59D0CA33, "locomotion_start" },
    { 0x21C70142, "locomotion_target" },
    { 0xF83B7FB8, "locomotion_turn_yaw" },
    { 0x6D9627B7, "locomotionbehaviorcondition" },
    { 0xF05AD42B, "locomotionisonstairs" },
    { 0xFC2A8F93, "locomotionpainbehaviorcondition" },
    { 0x06F5BFB5, "locomotions" },
    { 0x02A5A8DC, "locomotionshouldlooponstairs" },
    { 0x0B48D0BD, "locomotionshouldpatrol" },
    { 0xAD5176F0, "locomotionshouldskipstairs" },
    { 0x7BE4DC40, "locomotionshouldstealth" },
    { 0x9C8A0725, "locomotionshouldtraverse" },
    { 0x827CD453, "locomotionspeed" },
    { 0xB5CF0B69, "locomotionstairloopstart" },
    { 0xDCE7C37F, "locomotionstairsend" },
    { 0x78F007B4, "locomotionstairsstart" },
    { 0x585D8B75, "locomotiontypes" },
    { 0xE3B6EC5F, "locos" },
    { 0x7029A1A0, "locs" },
    { 0x628D75CB, "locs_valid" },
    { 0xDEE7CB1E, "locspam" },
    { 0x63CAC94E, "loctaion" },
    { 0x86B01036, "lod" },
    { 0xBB85362F, "lode" },
    { 0x9FF81EE1, "lodestar_time" },
    { 0x71CC1DC1, "lodestarhackertoolradius" },
    { 0xC4E7C650, "lodestarhackertooltimems" },
    { 0x774EB129, "lods" },
    { 0x2A1A0EB0, "loftier" },
    { 0x487FEDF9, "lofty" },
    { 0x60AD95CD, "log" },
    { 0x73307464, "log_crows" },
    { 0x28214FE3, "log_finished_event" },
    { 0xA4BCD62C, "log_qualifier" },
    { 0x15AA99EB, "log_string" },
    { 0x53A5577B, "log_struct" },
    { 0xB4899714, "log_trap_thread" },
    { 0xA42B7B34, "log_trigger" },
    { 0x15DF8486, "logclasschoice" },
    { 0x2055EE00, "loghit" },
    { 0x74454A09, "logic" },
    { 0x4DFE0D36, "logic_func" },
    { 0x58D1BF74, "logic_function_progression" },
    { 0x32E7EFAE, "logic_function_starting_index" },
    { 0xECAA1597, "logically" },
    { 0xFEF68F00, "logics" },
    { 0xDC6C8F99, "logkillstreakevent" },
    { 0x050B8CF0, "logo" },
    { 0x9E7332F1, "logo_fade" },
    { 0x32BF595B, "logos" },
    { 0x014EB892, "logprint" },
    { 0x895A501C, "logregen" },
    { 0x6D01A34C, "logs" },
    { 0x55A8267E, "logstring" },
    { 0x0CA399F3, "logteamwinstring" },
    { 0x8DFB0773, "logxpgains" },
    { 0xE767A7FC, "loiter" },
    { 0x8BD8E2D5, "loiter_trigger" },
    { 0xB6C3E37E, "lol" },
    { 0xB7D87ECB, "london" },
    { 0x04D996A9, "lone" },
    { 0xD2B7F974, "lonely" },
    { 0x50DE8B7B, "long" },
    { 0x67794C15, "long_01_cacheside" },
    { 0x779724D0, "long_01_towerside" },
    { 0x91924D86, "long_02_cacheside" },
    { 0xA7AFEA97, "long_02_towerside" },
    { 0xE178EF00, "long_death" },
    { 0x30F14666, "long_row_b4_security_room" },
    { 0xFA115A11, "long_sink_time" },
    { 0xF6564B0F, "long_spark_wire" },
    { 0x33481769, "long_time" },
    { 0x6E3DF803, "longdeath" },
    { 0xDA10BF35, "longdeathallowed" },
    { 0x552B552F, "longdeathstarting" },
    { 0x02A3239B, "longdistancehatchetkill" },
    { 0xCBFA9A8E, "longdistancekill" },
    { 0x6D7D60CD, "longdistancekillmp" },
    { 0xE5B1E6D6, "longer" },
    { 0x34622039, "longest" },
    { 0x24424892, "longest_anim_length" },
    { 0x3A46B1E1, "longestapproachdist" },
    { 0x03983DD7, "longestexposedapproachdist" },
    { 0x1D94E3CE, "longestwait" },
    { 0x00D1FBE8, "longitude" },
    { 0xE1405EF7, "longjinglewait" },
    { 0x7D50020D, "longregentime" },
    { 0x4E427F1A, "longs" },
    { 0x8EC8835A, "longshots" },
    { 0x73D41D3C, "look" },
    { 0x9A1A418C, "look now" },
    { 0x3F16A0D6, "look2" },
    { 0x02D6B2F4, "look2alert_cornerl" },
    { 0x5B07C260, "look4" },
    { 0xA70CB732, "look6" },
    { 0x23257F4C, "look8" },
    { 0xECCD9928, "look_aa_fire" },
    { 0x5A2EDC36, "look_ahead" },
    { 0x8BF29684, "look_at" },
    { 0xA605411A, "look_at_and_use" },
    { 0x8BAD1386, "look_at_begin" },
    { 0x14A4940F, "look_at_door" },
    { 0x920A238A, "look_at_end" },
    { 0x31E27CFA, "look_at_ent" },
    { 0xCED35FBA, "look_at_position" },
    { 0xF6BBA05D, "look_at_trig" },
    { 0x5559A9DD, "look_at_trigger" },
    { 0x621597B2, "look_at_water_tower" },
    { 0xB434BB7A, "look_back" },
    { 0x06534C00, "look_dir" },
    { 0xACD781BF, "look_dist" },
    { 0x77CFEA33, "look_down" },
    { 0xA4762FB4, "look_down_numbers" },
    { 0xB4C7E22A, "look_down_stand" },
    { 0xE6256C12, "look_ent" },
    { 0x69F6F51A, "look_ent_1" },
    { 0x43F47AB1, "look_ent_2" },
    { 0x1DF20048, "look_ent_3" },
    { 0xCFF375B4, "look_for_taco" },
    { 0x204A55F3, "look_forward_on_boat" },
    { 0x4AEA8958, "look_foward_on_boat_single" },
    { 0x492FFCD3, "look_loc" },
    { 0xEC5627FB, "look_node" },
    { 0xB1B8039B, "look_node_1" },
    { 0x3FB09460, "look_node_2" },
    { 0x33538619, "look_origin" },
    { 0x95B40D50, "look_outside" },
    { 0x6EFF2CBF, "look_pos" },
    { 0xB88F2B6D, "look_salazar" },
    { 0xD7B5C85C, "look_struct" },
    { 0x1279FE4C, "look_target" },
    { 0x95BB9A89, "look_training" },
    { 0x98382865, "look_trig" },
    { 0xE3906615, "look_trigger" },
    { 0xD0A87DF0, "look_trigger_think" },
    { 0x62E764AD, "look_up_stand" },
    { 0x22238F57, "look_wait_max" },
    { 0x072E63A9, "look_wait_min" },
    { 0x282D2475, "look_with_player" },
    { 0xB9A5DE8F, "lookahead" },
    { 0xA7DDDD3F, "lookahead_angle" },
    { 0xF158BEAD, "lookahead_value" },
    { 0x88FF21D8, "lookaheadangle" },
    { 0x93820FB3, "lookaheadangles" },
    { 0xFA8537AC, "lookaheaddir" },
    { 0x12BB13FB, "lookaheaddist" },
    { 0x422C1E46, "lookaheaddistancefromnode" },
    { 0x3E8CFE6C, "lookaheadnextnode" },
    { 0xF0AD86A7, "lookaheadnode" },
    { 0x684EBC53, "lookaheadpoint" },
    { 0xA0CA1EFC, "lookaheadtime" },
    { 0x5DFCA848, "lookaheadyaw" },
    { 0x9D3FAC50, "lookaheadyawchange" },
    { 0x07A9AEFD, "lookaheadyawcolor" },
    { 0xA0BBDCBD, "lookangle" },
    { 0x71EECD7C, "lookangles" },
    { 0x96F7B31B, "lookanim" },
    { 0x537B3E3D, "lookanimationleft" },
    { 0x1B6A27A0, "lookanimationright" },
    { 0x54D4AFBE, "lookanimyawmax" },
    { 0x8A037F77, "lookaround" },
    { 0xA3A6B513, "lookat" },
    { 0x3D85FDEE, "lookat_2_ent" },
    { 0xD6F86033, "lookat_3_ent" },
    { 0x87DB1F84, "lookat_4_ent" },
    { 0x251651A9, "lookat_5_ent" },
    { 0x317FBB69, "lookat_breach" },
    { 0xF5D79CB0, "lookat_bridge_trigger" },
    { 0x78E773B3, "lookat_dot" },
    { 0x45E71A35, "lookat_ent" },
    { 0xCF65CFAC, "lookat_flag" },
    { 0xFD8B98B5, "lookat_hut" },
    { 0xE0577593, "lookat_name" },
    { 0x4A6D31F6, "lookat_notetracks" },
    { 0xBFE91D85, "lookat_notify" },
    { 0xC74C558B, "lookat_on_off" },
    { 0x7E3AAF69, "lookat_player" },
    { 0x22246504, "lookat_point" },
    { 0x657C9AF0, "lookat_pos" },
    { 0xE2723260, "lookat_safety" },
    { 0xEED0D694, "lookat_set_in_anim" },
    { 0x262BA9CC, "lookat_structs" },
    { 0x2F4CA85E, "lookat_thug_leader" },
    { 0xA7F54861, "lookat_time" },
    { 0xF8EAF3B7, "lookat_timeout" },
    { 0x2DC627AE, "lookat_trigger" },
    { 0x2BD5404D, "lookat_trigger_while_not_in_trigger" },
    { 0x0E9123D7, "lookatangles" },
    { 0x4EA4048A, "lookatanimations" },
    { 0xE3E8E4C4, "lookatbase" },
    { 0x16BAA03A, "lookatbase_camera_movement" },
    { 0xE960DF92, "lookatend" },
    { 0x873AD9F2, "lookatentity" },
    { 0x50E38984, "lookatexplosion" },
    { 0x86CFA787, "lookatorg" },
    { 0xAEE73189, "lookatorigin" },
    { 0xBCF9BEAE, "lookatpath" },
    { 0x35C9C384, "lookatplayer" },
    { 0x0FBB2CEF, "lookatpos" },
    { 0x5063E932, "lookatposition" },
    { 0x79871542, "lookats" },
    { 0xB6344B0B, "lookatspot" },
    { 0xC191CD49, "lookatstart" },
    { 0x88740F13, "lookatstop" },
    { 0xFE6520BC, "lookattarget" },
    { 0xF56EC7CE, "lookaway_player" },
    { 0x815A8429, "lookaway_structs" },
    { 0xB46941B2, "lookblendtime" },
    { 0xA4C9AD31, "lookdir" },
    { 0xBA20FE94, "lookduration" },
    { 0x7935491F, "looked" },
    { 0x72484F91, "looked_at" },
    { 0x72294AC0, "lookendtime" },
    { 0x2F680C7B, "lookent" },
    { 0x4F00EC76, "lookfast" },
    { 0x04B461E8, "lookforbettercover" },
    { 0xB003BA63, "lookforenemy" },
    { 0x9967F759, "lookfornewcovertime" },
    { 0x1DE4135B, "lookforward" },
    { 0xCAA7FDD6, "lookfrompoint" },
    { 0x5187AA0C, "looking" },
    { 0xA67481F4, "looking_at" },
    { 0xA0D1B22A, "looking_at_entity" },
    { 0x9E0CDD8D, "looking_at_poi" },
    { 0xAE9F0D9A, "looking_at_price" },
    { 0x7D503A5D, "looking_down_midstreet" },
    { 0x573524C2, "lookingatentity" },
    { 0xB00FA78C, "lookingattarget" },
    { 0x6F6FB0D6, "lookingfornext" },
    { 0xC847DCA1, "lookingfornextthisplayer" },
    { 0xE3BF3FC0, "lookknob" },
    { 0xDFAC1F32, "lookline" },
    { 0x40EA36F3, "lookmodel" },
    { 0x12A7F6C8, "lookout" },
    { 0x19D917A3, "lookout_guy1_setup" },
    { 0x7C077AC4, "lookout_guy2_setup" },
    { 0x2ED8B99A, "lookpos" },
    { 0x9F87D525, "lookposeset" },
    { 0xC0393EBC, "lookrecenter" },
    { 0xE47A80FF, "looks" },
    { 0x56BACF0D, "lookspeed" },
    { 0xD0DBFA74, "lookspot" },
    { 0xBBAE5D3F, "lookstruct" },
    { 0x46D1E387, "looktarget" },
    { 0x22BA4C26, "looktargetentity" },
    { 0xD07D1873, "looktargetpos" },
    { 0xA2100398, "looktargetspeed" },
    { 0x49133E0F, "looktargettype" },
    { 0x66A37184, "lookthread" },
    { 0x32444CAF, "looktime" },
    { 0x8AAFAC5A, "looktrig" },
    { 0x915B4FBB, "lookup" },
    { 0x64C8C48E, "lookup_done" },
    { 0x17EE7721, "lookup_value" },
    { 0x13E8A45A, "lookups" },
    { 0xA25B82CA, "lookvec" },
    { 0xBBA19AE9, "lookvector" },
    { 0x3C40F1AC, "lookweight" },
    { 0x07666772, "lookweight_end" },
    { 0xCA0BDB29, "lookweight_start" },
    { 0x2E0EE35D, "lookweight_t" },
    { 0x451213DD, "lookweight_transframes" },
    { 0x66E3E26C, "looky_loo_end" },
    { 0x1A704E2E, "lookyawlimit" },
    { 0xB8796A05, "loooking" },
    { 0x3864C638, "looop" },
    { 0x55A0129F, "loop" },
    { 0x7565CAD4, "loop_after_anim" },
    { 0xD6E3D4B6, "loop_after_wall_hug" },
    { 0xA100A295, "loop_anim" },
    { 0x4605F0D7, "loop_anim_control" },
    { 0x119E101C, "loop_animname" },
    { 0xF72027E4, "loop_anims" },
    { 0x06E496FC, "loop_barnes_anim_at_gap" },
    { 0x8E8A4F6D, "loop_camera_anim_to_set_up_for_capture" },
    { 0x81C3CEE1, "loop_cinematic" },
    { 0xFF58A56C, "loop_clark_death_idle_animation" },
    { 0x7797DFAA, "loop_cleanup" },
    { 0xD2A9D5A6, "loop_cond" },
    { 0xA8C380D7, "loop_count" },
    { 0x8EDC88BB, "loop_delete" },
    { 0xEEE57AD0, "loop_earthquakes" },
    { 0x56345338, "loop_ender" },
    { 0x34895B01, "loop_ent" },
    { 0x3722F285, "loop_ent_1" },
    { 0x5D256CEE, "loop_ent_2" },
    { 0x6969EF65, "loop_fire_katyusha" },
    { 0x6C0B8A90, "loop_fx_on_vehicle_tag" },
    { 0xA90AF7A4, "loop_fx_sound" },
    { 0x43CE9F35, "loop_guard" },
    { 0x2267E449, "loop_id" },
    { 0x79D63C07, "loop_idle_animation" },
    { 0x4617F9EC, "loop_in_space" },
    { 0x17BE94EA, "loop_jeep" },
    { 0x0C84F086, "loop_katyusha" },
    { 0x6C043DE7, "loop_local_sound" },
    { 0x3D1A53FE, "loop_movement_behavior" },
    { 0xEE224B37, "loop_name" },
    { 0xD6E016AE, "loop_node" },
    { 0xBBE88F5B, "loop_npc_idle_animation" },
    { 0x380D3D92, "loop_num" },
    { 0x9589F23D, "loop_obstacle" },
    { 0xEECBF9A5, "loop_on_client" },
    { 0x70F40069, "loop_on_entity" },
    { 0x9DCA65A8, "loop_on_tag" },
    { 0x9BDCA745, "loop_player_idle_animation" },
    { 0xA8EB5FC7, "loop_reznov_search_anim" },
    { 0xAEDA34E7, "loop_rotor_fx" },
    { 0xB46CD437, "loop_rumble_on_object" },
    { 0x8D71BD71, "loop_search_anims" },
    { 0x52BC9DFD, "loop_size" },
    { 0x695C4DF7, "loop_sound" },
    { 0xA11B7A23, "loop_sound_delete" },
    { 0x08193DF4, "loop_sound_in_space" },
    { 0x5191AA6D, "loop_sound_on_client" },
    { 0xB01D5D6E, "loop_spark_fx" },
    { 0xA14E89FA, "loop_start" },
    { 0x927CD5FE, "loop_startnode" },
    { 0xC857B992, "loop_stop" },
    { 0x450A600E, "loop_thread" },
    { 0x3C42BCA5, "loop_time" },
    { 0x99A43900, "loop_tracers" },
    { 0xA7265E0F, "loopable" },
    { 0x18F75C75, "loopalias" },
    { 0xB22E4A70, "loopanim" },
    { 0x911BC533, "loopanim_sound_exists" },
    { 0xEC9C453D, "loopanime" },
    { 0x2480C87E, "loopbotspawns" },
    { 0x855A279C, "loopcount" },
    { 0xAAD97788, "loopdelay" },
    { 0x163A0F54, "loopdelayendtime" },
    { 0x17580612, "loopdriveranim" },
    { 0x668981A4, "looped" },
    { 0xDF1770BC, "looped_anim" },
    { 0xBC998DAE, "loopent" },
    { 0x7AAC3362, "looper" },
    { 0x9C22336D, "looper_test" },
    { 0x0E7D3E28, "looperfx" },
    { 0x2D124A35, "looperfxcount" },
    { 0x389B752D, "loopers" },
    { 0x7CD406C9, "loopfx" },
    { 0x0244B6F1, "loopfx_ontag" },
    { 0x48979164, "loopfx_tag" },
    { 0xBA3461F2, "loopfxchangedelay" },
    { 0x3B2252AE, "loopfxchangeid" },
    { 0x9D3291F1, "loopfxchangeorg" },
    { 0x509AEDE7, "loopfxdeletion" },
    { 0x131708A0, "loopfxrotate" },
    { 0xD39D3CE1, "loopfxstop" },
    { 0xF3821561, "loopfxthread" },
    { 0xE2F7D266, "loopheight" },
    { 0x874CE04B, "loopheightrand" },
    { 0x13649AD7, "loophide" },
    { 0xA9E4B020, "loopid" },
    { 0xA522D8B1, "loopindex" },
    { 0x8AE5C6A1, "looping" },
    { 0x4C658294, "looping_anim_ender" },
    { 0xA4020693, "looping_movement" },
    { 0x8B6A00F9, "looping_targeting_sound" },
    { 0xFDEFA795, "loopingeffects" },
    { 0x9CB4DB6E, "loopingrumble" },
    { 0xFA7BAC28, "loopingshots" },
    { 0x1782849E, "loopingsound" },
    { 0x69366F75, "loopingsoundstopnotifies" },
    { 0x0417F3F5, "loopingstage" },
    { 0x0A0C56B0, "loopit" },
    { 0xBD0F2C8F, "looplength" },
    { 0xCDDAEEB2, "looplocallocksound" },
    { 0x7F46761D, "looplocalseeksound" },
    { 0xCEF9AB90, "looplocaltrackingsound" },
    { 0xE46ABCD6, "looplocaltrackingsoundrealloop" },
    { 0x83EBF20A, "loopmatches" },
    { 0xC5C76BF7, "loopnode" },
    { 0xDA29F3DD, "looporigin" },
    { 0x37AE3123, "looppacket" },
    { 0x33AEAF0E, "looppassengeranim" },
    { 0x05A8C3A5, "looprate" },
    { 0x17D0F956, "loopreflectoreffect" },
    { 0x2FD82426, "loops" },
    { 0x09DFF5AD, "loops_stop" },
    { 0x41972A60, "loopsnd" },
    { 0x71BC387C, "loopsound" },
    { 0x849D779C, "loopsound_end_ondeath" },
    { 0x7B7ED64B, "loopsound_for_time_or_death" },
    { 0x21375870, "loopsoundalias" },
    { 0x5D2452D5, "loopsoundcause" },
    { 0x7A7E76BB, "loopsoundent" },
    { 0xD9CA5DBE, "loopsoundfx" },
    { 0xE4B47475, "loopsoundtagname" },
    { 0xE63344C4, "loopsoundthread" },
    { 0xB4B65EC2, "loopsynch" },
    { 0x8FE2F56C, "looptime" },
    { 0x3A4C7C8A, "looptoidle" },
    { 0x796F539B, "loopwaittime" },
    { 0x7C2FAE91, "loose" },
    { 0x0C56900F, "loose_boards" },
    { 0x534C9517, "loosejunk" },
    { 0xBD9628FB, "loot" },
    { 0x31FA6DE7, "loot6" },
    { 0x4716D266, "loot_class" },
    { 0xD2BD2069, "loot_config_table" },
    { 0x9A33E075, "loot_cryptokeycost" },
    { 0x9C441649, "loot_drop_killstreak_on_death" },
    { 0xC6F97D5B, "loot_drop_perk_on_death" },
    { 0xA405F36C, "loot_drop_special_on_death" },
    { 0xFA03E81B, "loot_drop_weapon_on_death" },
    { 0xE83F5834, "loot_drops" },
    { 0x3BB2334D, "loot_end_idx" },
    { 0x73B1DB58, "loot_index_end" },
    { 0x2456647B, "loot_index_start" },
    { 0xB8D626E4, "loot_info_array" },
    { 0x3E8C0E28, "loot_init" },
    { 0x70096EEB, "loot_item" },
    { 0xFE3CD4F9, "loot_item_array" },
    { 0x58622787, "loot_item_exist" },
    { 0x077B3B1D, "loot_model" },
    { 0xFC46415B, "loot_name" },
    { 0x33E8F776, "loot_offset_x" },
    { 0x59EB71DF, "loot_offset_y" },
    { 0xE7E402A4, "loot_offset_z" },
    { 0x9ADA850F, "loot_perk_watcher" },
    { 0xFEFBFE30, "loot_populate" },
    { 0x07968488, "loot_postload" },
    { 0x7B2D0CE1, "loot_preload" },
    { 0x74F200E1, "loot_ref" },
    { 0x9CD32027, "loot_roll" },
    { 0xF08230C9, "loot_roll_compare_type_wave_dropped" },
    { 0x351041E2, "loot_roll_type" },
    { 0xCF6E9CD6, "loot_special_watcher" },
    { 0x706120CA, "loot_start_idx" },
    { 0x373499B1, "loot_string" },
    { 0x7EB6B5D2, "loot_table" },
    { 0xE141D426, "loot_type" },
    { 0x8F9CAB3A, "loot_version" },
    { 0x87A5A4D8, "loot_version_array" },
    { 0x3B3FE51D, "loot_version_index_end" },
    { 0xAC34E28E, "loot_version_index_start" },
    { 0x33894D1E, "loot_xp" },
    { 0xE5BDCDC9, "looters" },
    { 0xF34F6F9A, "loots" },
    { 0xA94F4263, "loottype" },
    { 0x4AB6A29B, "lootxp" },
    { 0xCD431A69, "lootxpbeforematch" },
    { 0x3CBB5A4E, "lootxpmultiplier" },
    { 0xA34528AB, "lopez" },
    { 0xDA41310E, "loping" },
    { 0x6355FE7B, "loppsound" },
    { 0x28CB52B9, "los" },
    { 0x10987CBC, "los05_main" },
    { 0xC5ED1652, "los_00_01" },
    { 0xC7C1A07D, "los_00_01_render" },
    { 0x9FEA9BE9, "los_00_02" },
    { 0xCA7C8C0C, "los_00_02_render" },
    { 0xD2468CA5, "los_01" },
    { 0x431F05F6, "los_01a" },
    { 0x47A6DA41, "los_01a_render" },
    { 0x1D1C8B8D, "los_01b" },
    { 0x09333390, "los_01b_render" },
    { 0xF849070E, "los_02" },
    { 0xD3DD5E49, "los_02_render" },
    { 0x1E4B8177, "los_03" },
    { 0x0A9CC0AE, "los_03_render" },
    { 0x3A3CA301, "los_05" },
    { 0x94EADEB4, "los_05_render" },
    { 0x9C1499B4, "los_check" },
    { 0x395FD7A7, "los_checks" },
    { 0x551D094D, "los_delete" },
    { 0xC92E730F, "los_flyover_01_activate" },
    { 0xADCF7983, "los_flyover_01_setup" },
    { 0x19787AAC, "los_flyover_01_think" },
    { 0xAA6CB112, "los_flyover_02_activate" },
    { 0xFB40D224, "los_flyover_02_setup" },
    { 0xC8FC9557, "los_flyover_02_think" },
    { 0xA4088FD6, "lose" },
    { 0x7FE59DFA, "lose_accuracy" },
    { 0xEF63D2FD, "lose_goal_volume" },
    { 0x2D6637A4, "lose_goal_volume_trigger" },
    { 0x16A0CECC, "lose_perk_powerup" },
    { 0x480E8429, "lose_points_team_powerup" },
    { 0xCA6C3B47, "lose_random_perk" },
    { 0xE1E191F1, "loseanim" },
    { 0x7C50EF06, "losepatienttime" },
    { 0xA43BB9E0, "loser" },
    { 0x43DCE702, "loser_text" },
    { 0xFC83FE8B, "losers" },
    { 0x2CE3AC06, "loserscale" },
    { 0x2F23A336, "loserscore" },
    { 0xCA3E3449, "loses" },
    { 0xA11DDF1F, "losest" },
    { 0x618BC849, "losexists" },
    { 0x7DF6FFCF, "losing" },
    { 0x55B7A495, "losing_team" },
    { 0xC85867E5, "losingfinal" },
    { 0x70A44234, "losingteam" },
    { 0xE3D4AC88, "losingteamindex" },
    { 0x7C7C393C, "losingtime" },
    { 0xCD367BFC, "lospenalty" },
    { 0xDE685074, "losradiusdamage" },
    { 0x202157F0, "loss" },
    { 0x6C52D87C, "losses" },
    { 0xA4064BBA, "losses_value" },
    { 0x2A32B0CF, "lost" },
    { 0x1C765B0A, "lost_hand_2_hand" },
    { 0x0C685517, "lost_perk_index" },
    { 0x229A2615, "lost_perk_override" },
    { 0x80E9337A, "lost_perk_override_func" },
    { 0xE6E7FC30, "lost_perk_override_func_always_run" },
    { 0x837DB533, "lost_salvation" },
    { 0xD612A58D, "lost_sight_limit" },
    { 0xD1A08D4C, "lost_streak" },
    { 0x7A1759AF, "lostlineofsighttimelimitmsec" },
    { 0xE6D7B6C6, "lot" },
    { 0x856CFCB2, "lot_right_flank" },
    { 0x24CBFE79, "lots" },
    { 0x3865B85F, "lots_of_height" },
    { 0x86F4E07B, "lotta" },
    { 0x65B3ED36, "lotus" },
    { 0x91839BF9, "loud" },
    { 0x2486937D, "loud_alarm_off" },
    { 0x6BE7B9B1, "loud_alarm_on" },
    { 0x8ABC7B7F, "loudenemies" },
    { 0xD1058411, "loudenemies_off" },
    { 0xDADABFE5, "loudenemies_on" },
    { 0x08A36B20, "louder" },
    { 0x2169AD4C, "loudness" },
    { 0x494EFBC0, "loudspeaker" },
    { 0x6290BB25, "loudspeaker_event" },
    { 0xD07BBB98, "loudspeaker_struct" },
    { 0x393617EB, "loudspeakers" },
    { 0x86FB21CF, "lounge" },
    { 0xE44E5676, "lounge_door" },
    { 0xFC0F3101, "love" },
    { 0xA5E1F597, "loved" },
    { 0xAC1A678C, "lovely" },
    { 0x7AF226FC, "loverly" },
    { 0xC0D53C5D, "low" },
    { 0x23D241D0, "low_alt_warning" },
    { 0x2AEB3184, "low_dmg" },
    { 0xA6003EF4, "low_enough" },
    { 0x12CFAA6B, "low_ext_amb_snapshot" },
    { 0x71FE1D8A, "low_flyby_path_1" },
    { 0x4BFBA321, "low_flyby_path_2" },
    { 0x74F9C7E0, "low_frac" },
    { 0x4C8E9AAF, "low_g" },
    { 0xC44B2BFB, "low_g_zones" },
    { 0x36F7E82A, "low_grav" },
    { 0xA483BE2A, "low_gravity" },
    { 0x4941FAFC, "low_gravity_default" },
    { 0x59D3503C, "low_gravity_variant" },
    { 0x76584B46, "low_gravity_watch" },
    { 0xC48E38D7, "low_gravity_watch_start" },
    { 0x3A4C8222, "low_health" },
    { 0x1CB1F77C, "low_health_callback" },
    { 0xEC7FFC8A, "low_health_cb" },
    { 0xDF8A1B68, "low_health_percent" },
    { 0xD1DCBD1B, "low_health_sparks" },
    { 0x168B1A66, "low_level_instant_kill_charge" },
    { 0x45BDDA63, "low_ready_for_time" },
    { 0x69D20576, "low_road_bigrig_enter" },
    { 0xFFA26AF9, "low_road_bus_rpg" },
    { 0x39868798, "low_road_choke_group1" },
    { 0xC48DDBD2, "low_road_clear_vo" },
    { 0x0E9CF6A2, "low_road_fail_logic" },
    { 0xCEE8DAD5, "low_road_first_rpg" },
    { 0xDD27B11A, "low_road_g20_saved" },
    { 0x1E1F14E4, "low_road_group_2_cleared" },
    { 0xF825ECD6, "low_road_snipers_cleared" },
    { 0x5CD3DD3A, "low_road_truck_1" },
    { 0x5BF34B7F, "low_road_warning" },
    { 0x16988EEF, "low_road_warning_sniper_vo" },
    { 0x08681AB1, "low_rumble_range" },
    { 0x8221D0BD, "low_rumble_string" },
    { 0x7CA527CD, "low_val" },
    { 0x2C44EA63, "low_wait" },
    { 0xB0D5828C, "low_wall" },
    { 0xE29BEC19, "low_wall_crawler" },
    { 0xB712FE77, "low_wall_director" },
    { 0x7BCCF982, "low_wall_human" },
    { 0x408A9CC9, "low_wall_zombie" },
    { 0xA7FBAFBE, "lowalertanim" },
    { 0xBDED27A8, "lowalertanimdeath" },
    { 0xB8F17412, "lowalertanimdeathloop" },
    { 0x973661FE, "lowbuzz" },
    { 0x7A5D764C, "lower" },
    { 0xD7F8D353, "lower_" },
    { 0xB67895CA, "lower_accuracy_for_event_2" },
    { 0xE8CAFE9A, "lower_attacker_accuracy" },
    { 0x2159F0CD, "lower_bound" },
    { 0x731C5EE9, "lower_boundary" },
    { 0x99DC167F, "lower_btr_jeeps" },
    { 0x528718C5, "lower_door_breach" },
    { 0xFCBD0708, "lower_freeway_jeep_moveup" },
    { 0xBFEE510A, "lower_friendlies_accuracy" },
    { 0xA19F63A8, "lower_friendly_for_aicount" },
    { 0x71E3FB9E, "lower_gear" },
    { 0x184B0B08, "lower_group" },
    { 0x2DAFBDC9, "lower_house_gunner" },
    { 0x58F418D9, "lower_lab_area_fog" },
    { 0x59B37541, "lower_lab_enemy_vo" },
    { 0xE5F6E3AF, "lower_lab_level_vo" },
    { 0x8B3590A7, "lower_level_entry_battle" },
    { 0xF81EE759, "lower_message_set" },
    { 0xA643B290, "lower_movie_screen" },
    { 0x7F62C8CE, "lower_name" },
    { 0x49396D04, "lower_number" },
    { 0x1C2C032F, "lower_old_perm_blockers" },
    { 0x39AEC87A, "lower_scaffolding_guys" },
    { 0x0A9FC8CC, "lower_shaft_cap" },
    { 0xF29C40C1, "lower_veteran_nade_count" },
    { 0x2BAA6B13, "lower_water_level" },
    { 0xDC4F7447, "lower_weapon" },
    { 0x801631C8, "lowercase" },
    { 0x43E82EDC, "lowercased" },
    { 0x2176162F, "lowered" },
    { 0xBEEBDFFC, "lowering" },
    { 0x32951111, "lowerlevels" },
    { 0x354A1679, "lowermessage" },
    { 0xFC558BD1, "lowermessageoverride" },
    { 0xC50AAAEC, "lowermessagetext" },
    { 0x5FEDEAFF, "lowermessagethink" },
    { 0x7CCA2E19, "lowerplywoodwalls" },
    { 0x003E36CF, "lowers" },
    { 0xF63408D9, "lowertargetdummies" },
    { 0x6A604E59, "lowertextfontsize" },
    { 0x3B1544E6, "lowertextfontsize_ss" },
    { 0x62695A3A, "lowertexty" },
    { 0x9A6812CB, "lowertexty_ss" },
    { 0xAD8D6F2D, "lowertextyalign" },
    { 0xA9BD506A, "lowertextyalign_ss" },
    { 0x3594C84F, "lowertimer" },
    { 0x74C4441B, "lowest" },
    { 0x768C194B, "lowest_current_skill" },
    { 0xD32A16FB, "lowest_dot" },
    { 0xF9E6C0EF, "lowest_dot_guy" },
    { 0x8C132AF2, "lowest_index" },
    { 0xC6D2C7F5, "lowest_indices" },
    { 0x3621F3D0, "lowest_pitch" },
    { 0xCDF80739, "lowest_team" },
    { 0x8946C57F, "lowest_use" },
    { 0x83E35114, "lowestcost" },
    { 0xBD2FE714, "lowestid" },
    { 0x1F6A6D7F, "lowestpassengerindex" },
    { 0x09B9E486, "lowestskill" },
    { 0xE771645B, "lowestz" },
    { 0x1B5B8330, "lowexitheight" },
    { 0xF24E92F3, "lowgrav" },
    { 0x2B1C6805, "lowgravity" },
    { 0x44D87DB5, "lowground_history" },
    { 0xCD9405CB, "lowhealth" },
    { 0xA2E08AC5, "lowhealth_warning_playing" },
    { 0x9953D541, "lowhealthenteralias" },
    { 0x9446A781, "lowhealthexitalias" },
    { 0x8FB381B0, "lowheight" },
    { 0x9E27D825, "lowhum" },
    { 0x80A7F031, "lowmask" },
    { 0x0FC9B076, "lowpass" },
    { 0xC5A60CAB, "lowplaneflyby" },
    { 0xD79EC5FA, "lowready" },
    { 0x9FA8AE4A, "lowreadywatcher" },
    { 0x8BF6E1BD, "lowres" },
    { 0x423CBA73, "lowshelf" },
    { 0x106D97BD, "lowz" },
    { 0x2A56FB53, "loyalists" },
    { 0x4A79E2F1, "loyalty" },
    { 0xBDE0F6D0, "lozano" },
    { 0x4DAFB8B1, "lp" },
    { 0x6C88DBF6, "lpattackerorigin" },
    { 0x7BE9724B, "lpattackerteam" },
    { 0x98AF58B2, "lpattackguid" },
    { 0x62C01908, "lpattackname" },
    { 0xE2304BD3, "lpattacknum" },
    { 0x51ED50A7, "lpattackorigin" },
    { 0x86D8C0CE, "lpattackteam" },
    { 0x9F5B154A, "lpguid" },
    { 0x4B494164, "lpselfguid" },
    { 0x3E663292, "lpselfname" },
    { 0xDC172949, "lpselfnum" },
    { 0xA78C1B64, "lpselfteam" },
    { 0x7AA87B9B, "lpxuid" },
    { 0x4FF9F55E, "lr_buttuncheck_for_chair" },
    { 0x09FF7F03, "lr_look_angle" },
    { 0x836294F2, "lrdirection" },
    { 0x782A3C26, "lrg" },
    { 0x8A0A04D1, "lrx" },
    { 0x69C4D542, "lrxy" },
    { 0x64078A68, "lry" },
    { 0x73B2331A, "ls" },
    { 0x4B587AF7, "ls_pio" },
    { 0xFA9E273E, "ls_taken" },
    { 0x4E8ABF6B, "lsat_purchased" },
    { 0x15D49475, "lsat_trigger_tweak" },
    { 0xEA68F26A, "lsgsar_has_lethal_nade" },
    { 0xAA7D5089, "lsgsar_has_tactical_nade" },
    { 0x9DD17162, "lsgsar_lethal" },
    { 0x0FE8189C, "lsgsar_lethal_nade_amt" },
    { 0x9A62D273, "lsgsar_tactical" },
    { 0x82EE7A0B, "lsgsar_tactical_nade_amt" },
    { 0x740E7249, "lslooper" },
    { 0x59BA7C8B, "lsm" },
    { 0x3FDC671F, "lsmn" },
    { 0xE7B30D50, "lsn" },
    { 0x67D5EAC3, "lspot" },
    { 0x03A42EDA, "lst" },
    { 0x64CB5631, "lstick" },
    { 0x96F03D58, "lstick_down" },
    { 0x95F095C7, "lstrap" },
    { 0xE5B9A255, "lt" },
    { 0x9C2C88D9, "ltgun" },
    { 0x749087ED, "ltrig" },
    { 0xBFB727EC, "lu" },
    { 0x9E686B8D, "lua" },
    { 0x4F06C8C4, "lua_cod_enumdefinitions" },
    { 0x0A658437, "lucas" },
    { 0x0032EA9E, "luck" },
    { 0x048CF18B, "lucky" },
    { 0x10B7E74F, "luggage" },
    { 0xCE7C3ED5, "lui" },
    { 0xA53D11E1, "lui_black" },
    { 0xAD141330, "lui_hudelem_alignment_center" },
    { 0x6E302AC4, "lui_hudelem_alignment_left" },
    { 0xFC93663B, "lui_hudelem_alignment_right" },
    { 0x7B9AF0F9, "lui_hudelem_textsize_default" },
    { 0x6EEC12BB, "lui_hudelem_textsize_large" },
    { 0xF2C132CF, "lui_hudelem_textsize_medium" },
    { 0xB3D8F027, "lui_hudelem_textsize_small" },
    { 0xE60334CF, "lui_main_landing_menu" },
    { 0x98E4816D, "lui_menu" },
    { 0xA8BD6038, "lui_menu_data" },
    { 0x49C8F1C0, "lui_script_globals" },
    { 0x5BCF1460, "lui_script_menus" },
    { 0x2EAEAE9F, "lui_shared" },
    { 0x2744EE28, "lui_vehicle_hind" },
    { 0x614F827B, "lui_vehicle_tank" },
    { 0xB9B5ECBB, "luidisable" },
    { 0xD5F0E8A0, "luienable" },
    { 0x59C094FD, "luiload" },
    { 0xF0A31618, "luimenu" },
    { 0xE5ADC7B0, "luimodal" },
    { 0x346AB365, "luinote" },
    { 0x5B7E454A, "luinotifyevent" },
    { 0xF027E4DF, "luinotifyeventtospectators" },
    { 0x50F96694, "lull" },
    { 0x5F6A2B07, "lulls" },
    { 0xB5B3C737, "lumberjack_challenge" },
    { 0x1AE42997, "lunar" },
    { 0x9F222C27, "lunch" },
    { 0xE1D3BB33, "lurch" },
    { 0x970EE81F, "lure" },
    { 0xDE5806CF, "lure_distance" },
    { 0x10854C4D, "lure_zombies_to_tower_hint" },
    { 0x0307B73A, "luxury" },
    { 0x074A1C73, "luxurysedan" },
    { 0x1037652C, "luyties" },
    { 0xEED81CD9, "lvl" },
    { 0x27568390, "lvl_index" },
    { 0xEB0B2324, "lvl_visionset" },
    { 0x7CD0AD9E, "lvs" },
    { 0xBEC44991, "lvt" },
    { 0xDA74488A, "lvt1" },
    { 0xFFF6537D, "lvt1_guys" },
    { 0xD9DCB960, "lvt1_nodes" },
    { 0xB7D6BCBA, "lvt1guys" },
    { 0xB471CE21, "lvt2" },
    { 0x1A6C37DC, "lvt2_guys" },
    { 0x3A8350D3, "lvt2_nodes" },
    { 0x7FD23955, "lvt2guys" },
    { 0x79B95C4D, "lvt_deleter" },
    { 0xCFFAAC34, "lvt_dialog" },
    { 0x47D95B06, "lvt_driver" },
    { 0xB28C7F40, "lvt_explosions" },
    { 0x2AFE71DF, "lvt_goal_nodes" },
    { 0xEDB51C8C, "lvt_linkspot" },
    { 0xAE273932, "lvt_linkspot_ref" },
    { 0x88B8D514, "lvt_num" },
    { 0x0D593E0F, "lvt_pass" },
    { 0xD34A4327, "lvt_play_ride_in" },
    { 0x292614EE, "lvt_remover" },
    { 0x253C2409, "lvt_splash" },
    { 0xD9031C27, "lvt_stopped" },
    { 0x67122B68, "lvt_test" },
    { 0x9A4AC4C4, "lvt_think" },
    { 0xD16CCD21, "lvt_tipover" },
    { 0xD2DC5114, "lvt_unload_test" },
    { 0xA143F762, "lvt_unloaded" },
    { 0x6B131127, "lvt_wait" },
    { 0x0DD0B978, "lvts" },
    { 0x1D9BE569, "lx" },
    { 0xF7996B00, "ly" },
    { 0x33E88E18, "lying" },
    { 0x91B46DBB, "lynch" },
    { 0x69A0DA3B, "lz" },
    { 0x5F3897DC, "lz_origin" },
    { 0xBEA0141E, "lz_patroller_2" },
    { 0x1A2AF340, "lz_reached" },
    { 0xADF1E449, "lz_spawners" },
    { 0x314E0D12, "m" },
    { 0x75B9672F, "m1" },
    { 0xF4EBC9D7, "m113" },
    { 0xC95C91A9, "m14" },
    { 0x1561867B, "m16" },
    { 0x09A325D2, "m16_gl_upgraded_zm" },
    { 0x6786153B, "m16_sp" },
    { 0xA873A01A, "m16s" },
    { 0xA4857401, "m16weaponindex" },
    { 0xBC678A14, "m1911_sp" },
    { 0x9CB74F95, "m1a1" },
    { 0x41CA8C07, "m1carbine" },
    { 0x3F2A5D72, "m1garand" },
    { 0xFA4327FD, "m1garand_gl_zombie" },
    { 0x03B1F7F4, "m2" },
    { 0x9CACAB46, "m202" },
    { 0x845A52F7, "m202_anim_version" },
    { 0x0AE6749A, "m202_drop" },
    { 0x55BE9661, "m202_on_mg" },
    { 0xE308E3F9, "m202s" },
    { 0xC2AF25AF, "m203" },
    { 0x5D82150F, "m203_icon_hint" },
    { 0x45202FA0, "m220_tow_lowered" },
    { 0xC7655249, "m2_flamethrower" },
    { 0xD8820745, "m32" },
    { 0x8DDC3CDB, "m32active" },
    { 0x43EA5D3E, "m32id" },
    { 0xB25BBD17, "m32start" },
    { 0xA9179440, "m60" },
    { 0xF271FE16, "m60_audio_start" },
    { 0xE2203356, "m60_audio_stop" },
    { 0x75477546, "m60_ent" },
    { 0xAB58710B, "m60_ent1" },
    { 0x395101D0, "m60_ent2" },
    { 0x14FE848E, "m60_turret_audio" },
    { 0x17E5AD5D, "m60_turret_audio_thread" },
    { 0x91AA88B9, "m7" },
    { 0xE92AF77C, "m_18_wheeler_clip" },
    { 0x78C1F068, "m_active_spawn_volume" },
    { 0x7F7811D0, "m_actor" },
    { 0x4AF5EBBB, "m_actors" },
    { 0x7AB1F668, "m_aim" },
    { 0x9636C118, "m_aim_shader" },
    { 0x66F7522A, "m_aimpoint" },
    { 0xFA8B47E0, "m_align" },
    { 0x44B53B17, "m_align_plane" },
    { 0x0520BEE1, "m_align_scene" },
    { 0x12E46A20, "m_ammo_cache" },
    { 0x94F8DD8A, "m_amplifier" },
    { 0x593AE356, "m_anim" },
    { 0xD02B913D, "m_anim_body" },
    { 0x2BFE069C, "m_anim_model" },
    { 0x9B098674, "m_aquarium" },
    { 0x2B4B7352, "m_ar_01" },
    { 0x0548F8E9, "m_ar_02" },
    { 0xDF467E80, "m_ar_03" },
    { 0x92C9CCC5, "m_arch" },
    { 0x57D56BBB, "m_asd" },
    { 0xA99EDF85, "m_asd_defend_panel_1" },
    { 0xCFA159EE, "m_asd_defend_panel_2" },
    { 0x298057E1, "m_asd_intro_tile_fall" },
    { 0x12B50E22, "m_attachment" },
    { 0x19EBCC51, "m_b_hacking" },
    { 0xEF4AF137, "m_b_is_open" },
    { 0xEA569504, "m_back_cover" },
    { 0xC6D726C7, "m_back_door" },
    { 0x5EC49F70, "m_back_door_clip" },
    { 0xCF289D3A, "m_ball" },
    { 0xC710C50E, "m_ball_anim" },
    { 0x243BC52A, "m_bandana" },
    { 0xC8E62E96, "m_barn_door_clip" },
    { 0x23332D71, "m_barrel_fxanim" },
    { 0xBDFA842C, "m_barrel_parent" },
    { 0x5FC7C802, "m_bartender" },
    { 0x9C6E6029, "m_bdog" },
    { 0x61BB264B, "m_bear" },
    { 0x5B344FC0, "m_big_screen" },
    { 0xDDB8B281, "m_bigdog" },
    { 0xEF5D00C1, "m_bigrig" },
    { 0x950915DA, "m_billboard" },
    { 0xDC2A494F, "m_binoculars" },
    { 0x6DAA9564, "m_blades" },
    { 0xC7786EB4, "m_blockade" },
    { 0x89580319, "m_blocker" },
    { 0xC24595B6, "m_blocker_clip" },
    { 0x4BB4B1C9, "m_blocker_linker" },
    { 0x5D4E3783, "m_board" },
    { 0x4FEA10EB, "m_boat" },
    { 0xDA903A6D, "m_boat_model" },
    { 0xC4574A19, "m_bodies" },
    { 0x22C286F9, "m_body" },
    { 0x42B5860B, "m_body_double" },
    { 0xE8463385, "m_bottle" },
    { 0xE32CD584, "m_box" },
    { 0x9625CD06, "m_bridge" },
    { 0x295C944B, "m_bridge1" },
    { 0xA7C1817C, "m_bridge1_clip" },
    { 0xB7552510, "m_bridge2" },
    { 0xA7BB46C9, "m_bridge2_clip" },
    { 0xDD579F79, "m_bridge3" },
    { 0xA9297856, "m_bridge3_clip" },
    { 0x9B640386, "m_bridge4" },
    { 0x52138E73, "m_bridge4_clip" },
    { 0x85128AF3, "m_bridge_clip" },
    { 0xA3949332, "m_bridge_destroyed" },
    { 0x043967DE, "m_bridge_whole" },
    { 0xB361BBC6, "m_bridge_workers" },
    { 0x1A242267, "m_briggs" },
    { 0xA59BB5D1, "m_brute_force_cougar" },
    { 0x1E4AD4B8, "m_bruteforce_cougar" },
    { 0x9A541BF0, "m_buddy_springpad" },
    { 0x876AD45D, "m_buffel" },
    { 0xEDE1622E, "m_buffel_flipper" },
    { 0xA4948359, "m_buffel_windshield" },
    { 0xD9A694A1, "m_building_destroyed" },
    { 0xCD0F0AB1, "m_building_whole" },
    { 0xB386AD81, "m_bus" },
    { 0x253A5FFB, "m_bus_model" },
    { 0x7936F5F9, "m_button" },
    { 0xE009811C, "m_c4" },
    { 0x75353FDD, "m_cache" },
    { 0xDD25F009, "m_cage" },
    { 0xB14533F8, "m_caller" },
    { 0x5B281216, "m_cam" },
    { 0x98AE4864, "m_camera" },
    { 0x77E06E05, "m_camo" },
    { 0x2D5727E1, "m_car" },
    { 0xCEB16F7E, "m_car_clip" },
    { 0x2FDC6632, "m_car_corner_vehicle" },
    { 0x39655767, "m_cart" },
    { 0x86082E83, "m_cart_dyn_path" },
    { 0x49E6F44F, "m_ce_bike_1" },
    { 0xD7DF8514, "m_ce_bike_2" },
    { 0xFDE1FF7D, "m_ce_bike_3" },
    { 0xF7AAE589, "m_ce_cop_car" },
    { 0x88D91B79, "m_center_door" },
    { 0x2F59644B, "m_chains" },
    { 0x83BD821C, "m_chair" },
    { 0x465174F9, "m_cheap_car" },
    { 0xD15C4DF7, "m_check" },
    { 0xADF0DE4B, "m_checklist" },
    { 0x9653ACFA, "m_chicken" },
    { 0xEC998CC9, "m_child" },
    { 0xDEFA1324, "m_chute" },
    { 0xCA1B67B0, "m_citadel_elevator" },
    { 0x8E7AC44D, "m_civ" },
    { 0x19CBB780, "m_claw" },
    { 0x3CC92AD9, "m_claw_damage_trigger" },
    { 0xBADC4069, "m_claymore" },
    { 0x611D5710, "m_clean" },
    { 0x6346AC28, "m_clean_room_door_01_l" },
    { 0x7E077441, "m_clean_room_door_01_l_clip" },
    { 0x77695DE6, "m_clean_room_door_01_r" },
    { 0x5C8EC213, "m_clean_room_door_01_r_clip" },
    { 0x7236738F, "m_clean_room_door_02_l" },
    { 0xC27E9558, "m_clean_room_door_02_l_clip" },
    { 0x5E13C1D1, "m_clean_room_door_02_r" },
    { 0x5AA8148E, "m_clean_room_door_02_r_clip" },
    { 0x2A0487AA, "m_cliff_clip" },
    { 0xCCEEA9D9, "m_clinic_stairs_blocker" },
    { 0xAD461047, "m_clip" },
    { 0xA81766C4, "m_clip_after" },
    { 0xC7710B5A, "m_clip_arch" },
    { 0xDF28E063, "m_clip_before" },
    { 0x8024718C, "m_clip_cart" },
    { 0x17273600, "m_clip_tv" },
    { 0xA007A2A6, "m_code" },
    { 0x0C8D49DF, "m_coll" },
    { 0x8E32BF40, "m_collapse" },
    { 0x8081C2D9, "m_collapse_clip" },
    { 0x8A1D0531, "m_collectible" },
    { 0xCFDB3B07, "m_collision" },
    { 0x4D7F7140, "m_console" },
    { 0x4EA29485, "m_console_bink" },
    { 0xA3C94D47, "m_console_dark" },
    { 0xF2C63A92, "m_convert" },
    { 0x8550DF43, "m_converter" },
    { 0xA224E6BA, "m_cop_car" },
    { 0x543AF5B2, "m_cop_car_1" },
    { 0x2E387B49, "m_cop_car_2" },
    { 0xF7941A23, "m_corner_collision" },
    { 0x89AC1609, "m_corpse" },
    { 0x7C6D4212, "m_corpse1" },
    { 0x566AC7A9, "m_corpse2" },
    { 0x30684D40, "m_corpse3" },
    { 0x3A79A61F, "m_corpse4" },
    { 0x640332B6, "m_cougar_crawl" },
    { 0xDD49887A, "m_cougar_destroyed" },
    { 0xBC874B45, "m_cougar_interior" },
    { 0x909B18AB, "m_cougar_shadow_prop" },
    { 0x5B4A35C6, "m_cover" },
    { 0x9D015C34, "m_cracked_window01" },
    { 0x0F08CB6F, "m_cracked_window02" },
    { 0xE9065106, "m_cracked_window03" },
    { 0x26A8D2AC, "m_crane" },
    { 0x5D9F588C, "m_cratercharge" },
    { 0xD3F8F758, "m_cratercharge_glow" },
    { 0xDBD22998, "m_crc_door" },
    { 0xA2BBFD54, "m_cutter" },
    { 0x10641ACE, "m_damage" },
    { 0xA4724E92, "m_data_glove_attached" },
    { 0x6DEBBB6E, "m_dead_body_1" },
    { 0x47E94105, "m_dead_body_2" },
    { 0x21E6C69C, "m_dead_body_3" },
    { 0x9E491B90, "m_dead_drone" },
    { 0xED477D3C, "m_dead_pilot" },
    { 0xB5209A70, "m_dead_turret" },
    { 0x5A24A894, "m_debris" },
    { 0x9E0FC275, "m_debris_clip" },
    { 0x5ED976B6, "m_debug_phase" },
    { 0x85FB652B, "m_defalco" },
    { 0x28716214, "m_defend_crash_hide" },
    { 0x72469946, "m_defend_door_01l" },
    { 0x5E23E788, "m_defend_door_01r" },
    { 0x6373B943, "m_defend_door_02l" },
    { 0xDF8C815D, "m_defend_door_02r" },
    { 0xDEE5576D, "m_dest" },
    { 0x6199D446, "m_destroyed" },
    { 0x5531B311, "m_destroyed_dome_clip" },
    { 0x7488AB6D, "m_destroyed_door" },
    { 0x2EC61A03, "m_dig" },
    { 0x6C6AE458, "m_disconnector" },
    { 0x5B5A48C4, "m_docks_elevator" },
    { 0xFA5CB07E, "m_docks_puzzle" },
    { 0xBFF84677, "m_docks_shockbox" },
    { 0x998D6409, "m_dog" },
    { 0x69EE3774, "m_dome" },
    { 0x0EDAADA1, "m_door" },
    { 0x8280BA6B, "m_door_bash_clip" },
    { 0xA4C4215F, "m_door_block" },
    { 0x54DD5E3E, "m_door_clip" },
    { 0xCFB53E5D, "m_door_destroyed" },
    { 0x3F37DFF1, "m_door_hinge" },
    { 0x6C2EF787, "m_door_left" },
    { 0x2364E2BC, "m_door_north_l" },
    { 0x47247412, "m_door_north_r" },
    { 0x34A71CA0, "m_door_open_delay_time" },
    { 0xA23973AC, "m_door_pristine" },
    { 0xCC89D502, "m_door_right" },
    { 0x7977C1BA, "m_door_south_l" },
    { 0xF59089D4, "m_door_south_r" },
    { 0xF0225748, "m_doors" },
    { 0x0634AE39, "m_doors_trigger" },
    { 0xCDB48681, "m_drama_spot" },
    { 0x284849FB, "m_driver" },
    { 0xE7F71B05, "m_drone" },
    { 0x253EB620, "m_drone_collision" },
    { 0x3A8CC0D5, "m_drone_gantry" },
    { 0x13E6600A, "m_drum_burner" },
    { 0xEC6E403A, "m_duffle_bag" },
    { 0x6A8F50F7, "m_dumpster" },
    { 0x946379EE, "m_e_container" },
    { 0xE1B87675, "m_e_door" },
    { 0x133DF857, "m_e_hint_trigger" },
    { 0x525802A7, "m_e_interact_entity" },
    { 0xC79B817A, "m_e_player_leader" },
    { 0xA237A649, "m_e_securitylight" },
    { 0xF8A8D143, "m_e_securitynode" },
    { 0xA345DAD3, "m_e_trigger" },
    { 0x5FAB2429, "m_e_trigger_player" },
    { 0xF478BAFC, "m_each_fxanim" },
    { 0x6F917D39, "m_eland" },
    { 0x5D57C17E, "m_electric_chair" },
    { 0x0A6A73DB, "m_elevator" },
    { 0xFD520882, "m_elevator_bottom_gate_l" },
    { 0x19432A0C, "m_elevator_bottom_gate_r" },
    { 0x347233D9, "m_elevator_light_attach_point" },
    { 0xBCE45EE8, "m_eleveator" },
    { 0xA211A5D9, "m_emergence_hole" },
    { 0x9BDC7324, "m_endgame_machine" },
    { 0x73DA525A, "m_endgame_machine_ent" },
    { 0x978477A5, "m_escape_door_01l" },
    { 0x742C06AA, "m_escape_door_01l_clip" },
    { 0xBB4408FB, "m_escape_door_01r" },
    { 0xA9CEFA8C, "m_escape_door_01r_clip" },
    { 0x796B82B4, "m_escape_door_02l" },
    { 0xDBC47E55, "m_escape_door_02l_clip" },
    { 0xFD52BA9A, "m_escape_door_02r" },
    { 0x5CE2130F, "m_escape_door_02r_clip" },
    { 0x82D5D7CE, "m_exist" },
    { 0x4D154F0E, "m_exit_clip" },
    { 0x450A316C, "m_exit_door" },
    { 0xF40A8984, "m_explode" },
    { 0x57595DB1, "m_f35" },
    { 0x994CF9A4, "m_f38" },
    { 0x20ACCB6E, "m_fake" },
    { 0xF9896975, "m_fake_plane_steering" },
    { 0xFAB8007C, "m_fan" },
    { 0x5288764F, "m_fhj" },
    { 0x1340E3CA, "m_fire_hydrant" },
    { 0xA3105B0E, "m_fireball" },
    { 0x53585AEF, "m_first_person" },
    { 0x41DCFD20, "m_flare_gun" },
    { 0xF9A5546F, "m_flareguy_door" },
    { 0xD52E3FF7, "m_flashlight" },
    { 0x7BF7EDA5, "m_floor" },
    { 0x627285AA, "m_fnp45" },
    { 0x91488299, "m_freeway1" },
    { 0xB74AFD02, "m_freeway2" },
    { 0x8CA4A979, "m_front_door_open_clip" },
    { 0x7D397D41, "m_front_gate_clip" },
    { 0xBC888D16, "m_fuel_can" },
    { 0xB157B6B7, "m_fx" },
    { 0x2879F5BF, "m_fx_1" },
    { 0xB6728684, "m_fx_2" },
    { 0xDC7500ED, "m_fx_3" },
    { 0xE9D474E9, "m_fx_left" },
    { 0x1818BAA0, "m_fx_origin" },
    { 0x7121B338, "m_fx_point" },
    { 0x0705FC94, "m_fx_right" },
    { 0x312A9C12, "m_fx_spot" },
    { 0x86659F12, "m_fx_tag" },
    { 0x441BFA78, "m_fxanim" },
    { 0xA3C2AFB3, "m_fxanim_drone" },
    { 0x8861FF80, "m_fxanim_learjet" },
    { 0x4289ADD3, "m_fxanims" },
    { 0xC0BF48FF, "m_garage_back_door" },
    { 0xE6EE57DC, "m_garage_back_door_2" },
    { 0x8E1C74DA, "m_garage_back_door_player_clip" },
    { 0xF495036F, "m_garage_clip" },
    { 0xA9D604DD, "m_garage_door_back" },
    { 0x2F9B3252, "m_garage_door_back_2" },
    { 0x59FEA12F, "m_garage_door_segment_1" },
    { 0xE7F731F4, "m_garage_door_segment_2" },
    { 0x0DF9AC5D, "m_garage_door_segment_3" },
    { 0x9BF23D22, "m_garage_door_segment_4" },
    { 0xC1F4B78B, "m_garage_door_segment_5" },
    { 0xDA0F5392, "m_garage_front_door_clip" },
    { 0x9959D621, "m_gas_bucket" },
    { 0x5622C570, "m_gas_can1" },
    { 0xC82A34AB, "m_gas_can2" },
    { 0xA227BA42, "m_gas_can3" },
    { 0xEA687282, "m_gascan" },
    { 0xC12C7B04, "m_gate" },
    { 0xDA91FB5A, "m_gate_01" },
    { 0xB48F80F1, "m_gate_02" },
    { 0xA32C0585, "m_gate_clip" },
    { 0x039D548C, "m_gate_left" },
    { 0x8EFEF8A3, "m_gate_right" },
    { 0x97E89E39, "m_gather_fx" },
    { 0xD4CBEA90, "m_generator" },
    { 0x57124697, "m_generator_panel" },
    { 0x9DE4979C, "m_generic" },
    { 0xEF10A2B3, "m_glass" },
    { 0x3779839A, "m_glass_shard" },
    { 0x43A12F00, "m_globe" },
    { 0xACA4967A, "m_globe_shown" },
    { 0x6E2F5682, "m_glow" },
    { 0xC695284C, "m_goal" },
    { 0x6EAC9BAF, "m_god_rays" },
    { 0xE25DF873, "m_godray" },
    { 0x8EEDC1B9, "m_gondola" },
    { 0x097B8905, "m_grass" },
    { 0x442555F1, "m_grenade" },
    { 0xBB06AFF8, "m_gringo_graffiti" },
    { 0x5D916A32, "m_ground_ref" },
    { 0x6C556091, "m_guard1" },
    { 0x9257DAFA, "m_guard2" },
    { 0xB85A5563, "m_guard3" },
    { 0xDE5CCFCC, "m_guard4" },
    { 0xF7FFF8E5, "m_gun" },
    { 0xB26C7810, "m_gun_spot" },
    { 0xA41E7D1D, "m_gun_tag_origin" },
    { 0x94059BE6, "m_gunsmith" },
    { 0x0E9E3F97, "m_gurney" },
    { 0xAA74FF20, "m_gurney_clip" },
    { 0x25D0E31A, "m_guy" },
    { 0x128200F5, "m_handcuffs" },
    { 0xCB24A51D, "m_hangar_door_left" },
    { 0xDA788000, "m_hangar_door_right" },
    { 0x8C8D65DE, "m_harper_briefcase" },
    { 0x88BF448C, "m_hat" },
    { 0x1CFE4072, "m_hat_linker" },
    { 0xA611CFF3, "m_head" },
    { 0x14B72928, "m_headphones" },
    { 0xCFF0DDD0, "m_helis" },
    { 0x5169A6DA, "m_helmet" },
    { 0x3B3F53C2, "m_hillary" },
    { 0xB8317212, "m_hoist" },
    { 0xF1A2D387, "m_horde_timer" },
    { 0xAAEE970C, "m_horse" },
    { 0x681135FD, "m_horse1" },
    { 0x8E13B066, "m_horse2" },
    { 0xB4162ACF, "m_horse3" },
    { 0xAA04D1F0, "m_horse4" },
    { 0xFEDCD274, "m_hostage" },
    { 0x8CC1CFD0, "m_hotel_light" },
    { 0xC6E9ECAB, "m_humvee" },
    { 0xE7FA7BE1, "m_hydrant" },
    { 0xE64D825E, "m_icon" },
    { 0x8D387008, "m_ied_warning_time" },
    { 0x3FBE02A3, "m_ignore" },
    { 0x3D122900, "m_image" },
    { 0xCE29476C, "m_in_radiant" },
    { 0x6ABD10D9, "m_infirmary_case" },
    { 0xE03483FC, "m_infirmary_case_door_left" },
    { 0x7C1321D3, "m_infirmary_case_door_right" },
    { 0x72433B14, "m_inner_exit_gate" },
    { 0xCBFE9903, "m_interact" },
    { 0xD5F9A4C1, "m_jetpack" },
    { 0x1E7ABF8D, "m_jumpto_spot" },
    { 0x4323731F, "m_kard" },
    { 0xFA31DED0, "m_key_lock" },
    { 0xDD2D2BF8, "m_knife" },
    { 0xF60DFA93, "m_knuckles" },
    { 0x59C9A84B, "m_lab_door_left" },
    { 0xBEF17038, "m_lab_door_left_rear" },
    { 0xD3E5353E, "m_lab_door_right" },
    { 0xEB43C36F, "m_lab_door_right_rear" },
    { 0x3104D1E9, "m_ladder" },
    { 0xFAA8B8EB, "m_lamp" },
    { 0xF9472DEB, "m_landing_door_left" },
    { 0x5FD5675E, "m_landing_door_right" },
    { 0xF922EBF0, "m_landing_gate_left" },
    { 0x26F0EA9F, "m_landing_gate_right" },
    { 0xF8C265D0, "m_landing_gear" },
    { 0x29BD0EF7, "m_lantern" },
    { 0x97EE402A, "m_laser" },
    { 0x1BE9D5F7, "m_laser1" },
    { 0xA9E266BC, "m_laser2" },
    { 0x1C813B66, "m_last_touched" },
    { 0x6CEEBAC5, "m_ledge_clip" },
    { 0x05D074AD, "m_left_door" },
    { 0xD104EA01, "m_left_org" },
    { 0x7EFC47DF, "m_lever" },
    { 0x0635A652, "m_lift" },
    { 0x80A9821F, "m_light" },
    { 0x305C4CB1, "m_lightboard" },
    { 0x81D5C249, "m_lightfx" },
    { 0x66076AD2, "m_lightfx1" },
    { 0x4004F069, "m_lightfx2" },
    { 0x1A027600, "m_lightfx3" },
    { 0xFC5E7626, "m_lighting_org" },
    { 0x216251ED, "m_link" },
    { 0x606899FC, "m_linker" },
    { 0xEA13CAB5, "m_linkpoint" },
    { 0xAE17F0E5, "m_linkspot" },
    { 0x0B80386E, "m_linkto" },
    { 0x49E36A67, "m_lion" },
    { 0x1E7596E0, "m_lit" },
    { 0x521A3578, "m_lit_icon" },
    { 0x2DFB577C, "m_lock" },
    { 0xE36491B5, "m_lock_breaker_door_clip" },
    { 0xECFC3DF7, "m_lookat" },
    { 0x31522065, "m_lookout1" },
    { 0x57549ACE, "m_lookout2" },
    { 0x5FA765D6, "m_lost_objectives" },
    { 0x85763632, "m_lounge_door" },
    { 0x76AB6CA7, "m_lounge_door_clip" },
    { 0x10FED79B, "m_macguffin" },
    { 0x0FDDE069, "m_map_monitors" },
    { 0x38D6CBBB, "m_marker" },
    { 0x673751FE, "m_mason_elevator" },
    { 0x20D85839, "m_mason_height" },
    { 0xC3B7CD2B, "m_master_key" },
    { 0x4954E8B5, "m_master_key_pulley" },
    { 0x953CEE58, "m_maxis_vo_spot" },
    { 0x1AFCB90B, "m_menendez" },
    { 0x85DDB478, "m_menendez_elevator" },
    { 0xEBFB48E3, "m_menendez_height" },
    { 0x28068B17, "m_menendez_magenta" },
    { 0x5A8A832C, "m_metal_storm" },
    { 0x0CA11D97, "m_mg_model" },
    { 0xC2543FBF, "m_missile_1" },
    { 0x3788A837, "m_mission_team" },
    { 0x730A4D48, "m_model" },
    { 0x2AB107EF, "m_mortar1" },
    { 0xB8A998B4, "m_mortar2" },
    { 0xCFC2A41B, "m_motel_door" },
    { 0x65F7E1EC, "m_motel_door_clip" },
    { 0x6E43210F, "m_motel_tv_broken" },
    { 0xFFD7BD40, "m_motel_tv_pristine" },
    { 0xF9ABB8B0, "m_mover" },
    { 0x798564EA, "m_n_door_connect_paths" },
    { 0x1A084273, "m_n_hack_pct" },
    { 0x6A19803A, "m_n_trigger_height" },
    { 0x6F8FABB2, "m_new_grass" },
    { 0xF6F720D5, "m_next_node" },
    { 0xCE870111, "m_nixie_brush" },
    { 0x7F4646F0, "m_nixie_clue" },
    { 0x66AB93D3, "m_nixie_door" },
    { 0x366F7175, "m_nixie_door_left" },
    { 0x8F4FE058, "m_nixie_door_right" },
    { 0x3C472095, "m_nixie_tube" },
    { 0xB34F76DE, "m_nixie_tube_weaponclip" },
    { 0x8233C6CB, "m_nocap_hair" },
    { 0x3FA2036B, "m_noriega_bookshelf_door" },
    { 0x16F3D507, "m_noriega_bookshelf_floor" },
    { 0x57F01756, "m_noriega_door_close" },
    { 0x67FD6F82, "m_noriega_door_open" },
    { 0x406C1837, "m_num_horses_spawned" },
    { 0x89CA7C83, "m_num_nearby_ieds" },
    { 0x352F3198, "m_num_players" },
    { 0x9166AA4C, "m_num_players_ready" },
    { 0x030A2F82, "m_num_tile" },
    { 0x62FFB18E, "m_numbers_base_link" },
    { 0xFD7C14A5, "m_o_secsystem" },
    { 0x13D96978, "m_objective_model" },
    { 0x0FF6747F, "m_origin" },
    { 0xE91F5538, "m_original_exposure" },
    { 0xE6896AF6, "m_ospreys" },
    { 0xFC61DFBE, "m_outer_left" },
    { 0x997165F5, "m_outer_right" },
    { 0xB4D34742, "m_override_swing_angle" },
    { 0x41CF8669, "m_panel" },
    { 0x3E6EF049, "m_parent" },
    { 0x88ABA599, "m_parent_fxanim" },
    { 0x322CAC42, "m_part" },
    { 0x54160325, "m_path_clip" },
    { 0x47A4495D, "m_pendant" },
    { 0xC0917955, "m_pendant_magenta" },
    { 0x56342532, "m_phase_stats" },
    { 0x192A09EB, "m_phone" },
    { 0xCC4603C1, "m_piece" },
    { 0x4D9C4775, "m_pipe" },
    { 0xBB6495FD, "m_pipe_stages" },
    { 0xE98D6A21, "m_plane_about_to_crash" },
    { 0x928082B6, "m_plane_craftable" },
    { 0x0623DA1F, "m_plane_flyable" },
    { 0x4F141A98, "m_plane_hideable_clothes_pile" },
    { 0xC5FF2595, "m_plane_hideable_engine" },
    { 0x4FF65302, "m_plane_piece" },
    { 0x28023A01, "m_plane_steering" },
    { 0xF3CF0A6C, "m_platform" },
    { 0xA6193F7E, "m_player" },
    { 0x53D4D565, "m_player_body" },
    { 0x60A5C847, "m_player_briefcase" },
    { 0xE8E7BD2B, "m_player_clip" },
    { 0x0F490E7D, "m_player_hands" },
    { 0x9D68E184, "m_player_model" },
    { 0x66E87CD5, "m_player_rig" },
    { 0x6F8FBFCC, "m_player_spoon" },
    { 0x17345BF5, "m_player_spot" },
    { 0x80EE51C0, "m_plinth" },
    { 0xD8D444FA, "m_poster" },
    { 0x0CA64183, "m_powerup" },
    { 0xD619304F, "m_primary_charmodel" },
    { 0x24F675A1, "m_pristine" },
    { 0xADA7A110, "m_pristine_window" },
    { 0x6BE11642, "m_prop" },
    { 0xE4BEB65C, "m_prop_horse" },
    { 0x9EE87A1D, "m_prop_link" },
    { 0x3F93B408, "m_quadrotor" },
    { 0xD4507BFF, "m_quads_killed_by_mz" },
    { 0x0DEC9A3A, "m_radio" },
    { 0xB9C8BA38, "m_radio_tower" },
    { 0x5248F0E6, "m_ready" },
    { 0x622BCB11, "m_rebar" },
    { 0xDA19DC06, "m_reflection_cougar" },
    { 0x12947AD1, "m_restore" },
    { 0xA003A924, "m_reward" },
    { 0x51E6C27A, "m_reward_model" },
    { 0x0F630843, "m_rider" },
    { 0xD222B614, "m_rigging" },
    { 0x73934F00, "m_right_door" },
    { 0x80532E5A, "m_right_org" },
    { 0xB06C6285, "m_right_path_train_car" },
    { 0x2B8FB919, "m_rocket" },
    { 0x6829330A, "m_roofstairs_clip" },
    { 0x71C922BE, "m_rooftop_array" },
    { 0x45AD5D79, "m_rope" },
    { 0x7AE59E81, "m_rts_city_tag" },
    { 0x0205EC09, "m_rts_map_angle" },
    { 0xB9C5BA07, "m_rts_map_id" },
    { 0x39F97F18, "m_rts_map_list" },
    { 0x6A2C9EF6, "m_rts_stats" },
    { 0xE48D2F65, "m_rts_territory" },
    { 0xFFEF16D5, "m_rts_warmap_offset" },
    { 0xE6F9E59F, "m_s_bundle" },
    { 0xA2AD7C7F, "m_s_container_bundle" },
    { 0xA931D176, "m_s_container_instance" },
    { 0xE9212725, "m_s_fxanim_bundle" },
    { 0xF9E50DFF, "m_safe_volume" },
    { 0xF928D493, "m_safe_volume_delay" },
    { 0x05B14E7D, "m_scene_model" },
    { 0x4A5B2A06, "m_scorch_marks" },
    { 0x9F11DCC4, "m_script" },
    { 0x3AA1AF5A, "m_script_model" },
    { 0x4CBAE38B, "m_secondary_charmodel" },
    { 0xC5A3C5B5, "m_secretary" },
    { 0xAF332486, "m_shards" },
    { 0x4C0A30B5, "m_shed_door_extra" },
    { 0x42426E95, "m_sheets" },
    { 0x1455F837, "m_shelf" },
    { 0x46DDADF6, "m_shield" },
    { 0x86D42203, "m_ship" },
    { 0xF28056DC, "m_shockbox" },
    { 0x22A0863A, "m_shotty_01" },
    { 0x9D6FA779, "m_shoulder_bash_door" },
    { 0x72842580, "m_shovel" },
    { 0xE9D5C3CA, "m_shower_door" },
    { 0x8C08A132, "m_sign" },
    { 0xDCB7FFC0, "m_sliding_door" },
    { 0x6669C040, "m_sm_done" },
    { 0x8C73AB64, "m_soct_01" },
    { 0xFE7B1A9F, "m_soct_02" },
    { 0x4FB770CE, "m_sole" },
    { 0x87791EBA, "m_spawn" },
    { 0x06AEBC0A, "m_spiderbot_temp" },
    { 0x0675DAB0, "m_spit_fx" },
    { 0x13407F40, "m_spoon" },
    { 0x7195AF77, "m_spoon_pickup" },
    { 0xCC9BFB29, "m_spot" },
    { 0x4D5E8BC4, "m_spot_override" },
    { 0x66387DC7, "m_spotlight" },
    { 0xD64DE3E9, "m_springpad" },
    { 0x244FE0BE, "m_sq_bp_active_light" },
    { 0xFDE08D34, "m_sq_start_sign" },
    { 0x06226D45, "m_staff" },
    { 0x5AF1C7BF, "m_stand" },
    { 0xD6EF8C9D, "m_str_script_flag" },
    { 0x1484043E, "m_str_target" },
    { 0x7E16E483, "m_str_targetname" },
    { 0x9A71CF53, "m_strikeforce_open_all" },
    { 0x9663C29E, "m_strikeforce_override_list" },
    { 0x1E9C0FF9, "m_strobe_grenade" },
    { 0x551FE492, "m_success" },
    { 0x17CB9B47, "m_table" },
    { 0xF689E321, "m_table_exploder" },
    { 0x8365F931, "m_tablet" },
    { 0xA0FD3B0C, "m_tag_origin" },
    { 0xC6F3988D, "m_tank" },
    { 0x63D78536, "m_tank_path_blocker" },
    { 0x0C323E9C, "m_tanker" },
    { 0x2BFAC30C, "m_tanks" },
    { 0xB038FBBA, "m_target" },
    { 0xD2DC3DD2, "m_tarp" },
    { 0xF8C39D09, "m_tarp_parent" },
    { 0x88796C43, "m_teamgather_complete" },
    { 0x3B4A6A07, "m_temp" },
    { 0x7EE0F570, "m_temple_doors_destroyed" },
    { 0x653F787C, "m_terrain" },
    { 0x79076E68, "m_to_delete" },
    { 0xEC15D3A7, "m_tomahawk" },
    { 0x3DFC50DD, "m_torch" },
    { 0x9EF30D70, "m_tower" },
    { 0x1BB982D1, "m_train" },
    { 0xA765F9EC, "m_train_door" },
    { 0x876DC212, "m_traversal_blocker" },
    { 0x07D10D5E, "m_tree_1_loc" },
    { 0x43B0648D, "m_tree_2_loc" },
    { 0xE98C54DA, "m_truck" },
    { 0x70345F7F, "m_turret" },
    { 0xCD8EF483, "m_turret_callback" },
    { 0x406880C7, "m_turret_deaths" },
    { 0x894301AF, "m_unit_usage" },
    { 0x32E6C617, "m_unlit" },
    { 0x83786EE9, "m_upgrade_machine" },
    { 0x21D906A7, "m_v_close_pos" },
    { 0xF27D9FF9, "m_v_gather_position" },
    { 0xD97AFE29, "m_v_interact_angles" },
    { 0x0CB45BE0, "m_v_interact_position" },
    { 0xB9E6E4E3, "m_v_open_pos" },
    { 0x1F69A56C, "m_vfxspot_origin" },
    { 0xBF3D1C37, "m_vo_spot" },
    { 0x3AC1107E, "m_vtol" },
    { 0x58CD05F7, "m_vtol_elevator" },
    { 0x8A2E92E4, "m_vtol_look_at" },
    { 0xC465A737, "m_walkway" },
    { 0x9F1C136D, "m_wall" },
    { 0x7498C931, "m_wall_destroyed" },
    { 0xCCA0B2C9, "m_wall_phys_clip" },
    { 0x7E8BD0E0, "m_wall_pristine" },
    { 0x08E1495D, "m_wall_weapon_clip" },
    { 0xE5F26EB8, "m_walltop_dudes" },
    { 0x9B0871BE, "m_water" },
    { 0xB4B29194, "m_water_tower" },
    { 0x8B88AFB1, "m_weapon" },
    { 0xBD1E23B5, "m_weapon_name" },
    { 0xC1E132EF, "m_weapon_script_model" },
    { 0x6F05C26F, "m_weapons_cache" },
    { 0xA3978676, "m_wind_tile" },
    { 0xA8033D39, "m_window" },
    { 0xA6B3E25C, "m_wisp" },
    { 0xA1102711, "m_woods" },
    { 0x7DDFDD39, "m_woods_magenta" },
    { 0x213D64FA, "m_xm8_01" },
    { 0xFB3AEA91, "m_xm8_02" },
    { 0xD5387028, "m_xm8_03" },
    { 0xDF49C907, "m_xm8_04" },
    { 0xB9474E9E, "m_xm8_05" },
    { 0x9344D435, "m_xm8_06" },
    { 0x6D4259CC, "m_xm8_07" },
    { 0x172C0C1B, "m_xm8_08" },
    { 0xF12991B2, "m_xm8_09" },
    { 0xC8A87938, "m_xm8_10" },
    { 0xEEAAF3A1, "m_xm8_11" },
    { 0x14AD6E0A, "m_xm8_12" },
    { 0x3AAFE873, "m_xm8_13" },
    { 0x60B262DC, "m_xm8_14" },
    { 0x86B4DD45, "m_xm8_15" },
    { 0xACB757AE, "m_xm8_16" },
    { 0xD2B9D217, "m_xm8_17" },
    { 0x9894A5F0, "m_xm8_18" },
    { 0xBE972059, "m_xm8_19" },
    { 0x855C9319, "m_xm8_20" },
    { 0x5F5A18B0, "m_xm8_21" },
    { 0xD16187EB, "m_xm8_22" },
    { 0xAB5F0D82, "m_xm8_23" },
    { 0x1D667CBD, "m_xm8_24" },
    { 0x0ED1AFD9, "m_xm8_harper" },
    { 0xA421B6A5, "m_xm8_salazar" },
    { 0x0DC0B1D8, "m_zeppelin" },
    { 0x94F3265F, "ma" },
    { 0x40B5C956, "mac" },
    { 0x918F3ECD, "mac_proud" },
    { 0x3ABEEFB3, "mac_think" },
    { 0x2DEE2C3B, "mace_endgame_1" },
    { 0xBBE6BD00, "mace_endgame_2" },
    { 0xE1E93769, "mace_endgame_3" },
    { 0x32118069, "mace_endgame_array" },
    { 0x3DCDB20C, "macey" },
    { 0x52B0943F, "macguffin" },
    { 0xA52DAD0A, "mach" },
    { 0x4FBF444A, "machete" },
    { 0x4BEFD8C8, "machete_blackscreen_end" },
    { 0x8763DF72, "machete_blackscreen_on" },
    { 0x28C1076B, "machete_blackscreen_start" },
    { 0x4027BE81, "machete_dude" },
    { 0xD6BD4858, "machete_gib_" },
    { 0x483F79B2, "machete_guy" },
    { 0xCBE3C7F7, "machete_guy_dead" },
    { 0xB5FD845E, "machete_held_sp" },
    { 0x392CF7D3, "machete_hunter" },
    { 0xFD0A7848, "machete_kill_recorded" },
    { 0x06BB8527, "machete_mpla_get_ready_for_melee" },
    { 0x0106CDDA, "machete_notify" },
    { 0xB6775637, "machete_punch" },
    { 0xA352FD4F, "machete_scripted" },
    { 0x4DEE5F85, "machetes" },
    { 0x1FF19094, "machine" },
    { 0x8973345E, "machine2" },
    { 0xDC56B160, "machine_activated" },
    { 0xA526FC66, "machine_array" },
    { 0x40A38F14, "machine_assets" },
    { 0x34E0FF6C, "machine_available" },
    { 0x757C7A75, "machine_clip" },
    { 0x23ABC63F, "machine_done" },
    { 0xEF4F8C27, "machine_light_effect" },
    { 0x7CE187CA, "machine_model" },
    { 0x1FB67304, "machine_monkey_struct" },
    { 0xBCFB537A, "machine_off" },
    { 0x145834D7, "machine_power_indicators" },
    { 0xEE7A4EF1, "machine_powered" },
    { 0x8A7E8138, "machine_selector" },
    { 0x084D4ECB, "machine_sounds" },
    { 0x6AB50E55, "machine_think" },
    { 0x462A42AD, "machine_trigger" },
    { 0x0FA72DAC, "machine_triggers" },
    { 0xA87ABD52, "machine_user" },
    { 0x2E443E79, "machine_watcher" },
    { 0xB6F9FED6, "machine_watcher_factory" },
    { 0x8D6C7BA2, "machinegun" },
    { 0xFE8A666D, "machineguns" },
    { 0x77F13BA5, "machinelocal" },
    { 0x472BA7F4, "machinelocalstorage" },
    { 0x9681B625, "machineoffset" },
    { 0x0A11CE9E, "machiner" },
    { 0x8E6DDD8B, "machinery" },
    { 0x8C3430E4, "machinery_glow_setting" },
    { 0x30144907, "machines" },
    { 0xC81EE809, "machines_setup" },
    { 0x6BF68566, "maching" },
    { 0x8661A97B, "mackey" },
    { 0x01632199, "macmillan" },
    { 0x5358C6D4, "macmillan_proud_hook" },
    { 0xA7EDAA67, "macro" },
    { 0xC7AEC6DE, "macros" },
    { 0x7ED9DD00, "macroze" },
    { 0x60F72804, "macv" },
    { 0x7A162540, "macv_chopper_explosion_effect" },
    { 0x6C081AEF, "macv_demo_over" },
    { 0x440BE9F3, "macv_end_of_summeet_section" },
    { 0x01FA0B2E, "macv_fire_locations" },
    { 0x97F501B3, "macv_fire_trigs" },
    { 0x9ECBFD13, "macv_skydemon" },
    { 0x82A96549, "mad" },
    { 0x8F3B5673, "madam" },
    { 0x1FBFD364, "madame" },
    { 0x28FDA542, "madatoryarg" },
    { 0xB0AED80E, "madden" },
    { 0xAD38EA7C, "maddock" },
    { 0xAE7B749C, "maddock_capture_anims" },
    { 0xB59FAA31, "maddock_captured" },
    { 0x16B3C631, "maddock_out" },
    { 0x2C012E46, "made" },
    { 0xF82135FD, "made_it_inside" },
    { 0xBF6FD44F, "madeittogoal" },
    { 0x45E16A1C, "madness" },
    { 0xA8ABDFB2, "mag" },
    { 0x1D8E97A9, "mag_scale" },
    { 0x1537EBD8, "magadan" },
    { 0xBCB5143B, "magazine" },
    { 0xD238F9DA, "magazines" },
    { 0x2BA23462, "magenta" },
    { 0x80D80B4E, "magic" },
    { 0xBA6A0F54, "magic_alley_movement" },
    { 0x7A9CC532, "magic_alley_vo" },
    { 0x859922D3, "magic_ang" },
    { 0x02E43120, "magic_box" },
    { 0x4831FB0D, "magic_box_arrives" },
    { 0x8D454908, "magic_box_check_equipment" },
    { 0xFE30A0C8, "magic_box_closes" },
    { 0xE8E4D28B, "magic_box_do_teddy_flyaway" },
    { 0x50470D41, "magic_box_do_weapon_rise" },
    { 0x55051E0D, "magic_box_first_move" },
    { 0x2A9E7D9C, "magic_box_grab_by_anyone" },
    { 0x2A476331, "magic_box_init" },
    { 0xFEA04511, "magic_box_initial" },
    { 0xFD5F77B3, "magic_box_leaves" },
    { 0x5CD58375, "magic_box_light" },
    { 0x3AD9B52C, "magic_box_light_switch" },
    { 0x96995B13, "magic_box_limit_location_init" },
    { 0x4FEABD8E, "magic_box_lock" },
    { 0x95705E31, "magic_box_locks" },
    { 0x386448D3, "magic_box_map_lights_update" },
    { 0xE0C48214, "magic_box_open_idle" },
    { 0x63E09F12, "magic_box_opens" },
    { 0xA5E9D88F, "magic_box_screen_swap" },
    { 0x31BFB6D2, "magic_box_stub_update_prompt" },
    { 0x7496CC77, "magic_box_teddy_twitches" },
    { 0xB4D20169, "magic_box_tracker" },
    { 0xA2B30C04, "magic_box_trigger_update_prompt" },
    { 0x189489FA, "magic_box_tv_base_entry" },
    { 0x47A76E8E, "magic_box_tv_catwalks" },
    { 0x7B911622, "magic_box_tv_centrifuge" },
    { 0x3DEFB850, "magic_box_tv_labs_1" },
    { 0xAFF7278B, "magic_box_tv_labs_2" },
    { 0x89F4AD22, "magic_box_tv_labs_3" },
    { 0xA6DAD52C, "magic_box_tv_lobby_1" },
    { 0x18E24467, "magic_box_tv_lobby_2" },
    { 0x2F68EB7F, "magic_box_tv_north_pass" },
    { 0xDDAF0687, "magic_box_tv_off" },
    { 0x6E0C0273, "magic_box_tv_on" },
    { 0x8565FCFD, "magic_box_tv_random" },
    { 0xABAC8222, "magic_box_tv_roof_connector" },
    { 0x7A6412D0, "magic_box_tv_start_1" },
    { 0x0205F3BB, "magic_box_tv_storage" },
    { 0xFF7AA211, "magic_box_tv_warehouse" },
    { 0x12533083, "magic_box_tv_warroom_1" },
    { 0x4841821E, "magic_box_unlocks" },
    { 0x145AA1F4, "magic_box_update" },
    { 0x50DD3717, "magic_box_uses" },
    { 0xA2460F7F, "magic_box_weapon_toggle_init_callback" },
    { 0x0AC70868, "magic_box_zbarrier_leave" },
    { 0x6747467B, "magic_box_zbarrier_state_func" },
    { 0x22C1478C, "magic_boxes" },
    { 0xDE5AD2A3, "magic_buddies" },
    { 0xEE5AA996, "magic_bullet_active" },
    { 0xC2808C3A, "magic_bullet_death_detection" },
    { 0x85892B5C, "magic_bullet_enemy" },
    { 0x7FA3EB63, "magic_bullet_hitting_water" },
    { 0x5901535D, "magic_bullet_pistol" },
    { 0x904B246A, "magic_bullet_rifle" },
    { 0x958C7633, "magic_bullet_shield" },
    { 0x18B65D79, "magic_bullet_shield_for_time" },
    { 0xA4C001A9, "magic_bullet_shield_on" },
    { 0x7E6ECFD5, "magic_bullet_shield_safe" },
    { 0xA840BE28, "magic_bullet_thread" },
    { 0x4AC2ABCF, "magic_bullet_titus" },
    { 0x71BC28F2, "magic_bullet_to_keep_guys_alive" },
    { 0x8A18E4A3, "magic_bullets_on_mansion_entrance" },
    { 0x2C1FA528, "magic_distance" },
    { 0xFD18F4D1, "magic_door_flags" },
    { 0xF72B734A, "magic_door_monitor" },
    { 0x340407B3, "magic_door_power_up_grabbed" },
    { 0x20E0C9A7, "magic_door_used" },
    { 0x4293C8ED, "magic_exit" },
    { 0x970DCEB4, "magic_grenade_trigger" },
    { 0x761EE2B5, "magic_grenade_trigger_think" },
    { 0x045F422C, "magic_grenades_at_player" },
    { 0x07413383, "magic_grenades_from_hell" },
    { 0x8A05E73E, "magic_grenades_orgs" },
    { 0xA7A724BD, "magic_kill" },
    { 0x65947224, "magic_missile_drone" },
    { 0x28ED324C, "magic_missile_fa38" },
    { 0x269A5B47, "magic_missile_guy" },
    { 0x3C56144C, "magic_missile_turret" },
    { 0x567FC4A2, "magic_missileguy_magiccrouch" },
    { 0x792CF7CC, "magic_missileguy_rpg" },
    { 0x8D1DD021, "magic_missileguy_spawner" },
    { 0x9D9AA970, "magic_missileguy_takehits" },
    { 0x92B0F769, "magic_org" },
    { 0x3CE93D1D, "magic_rgp_fired" },
    { 0xF6782391, "magic_rpg_2" },
    { 0xFD63CF03, "magic_rpg_2_end" },
    { 0xD075A928, "magic_rpg_3" },
    { 0xB7954E3E, "magic_rpg_3_end" },
    { 0xDA870207, "magic_rpg_4" },
    { 0x46283A19, "magic_rpg_4_end" },
    { 0xB484879E, "magic_rpg_5" },
    { 0xC239BCF4, "magic_rpg_5_end" },
    { 0x8E820D35, "magic_rpg_6" },
    { 0x4A644047, "magic_rpg_6_end" },
    { 0x687F92CC, "magic_rpg_7" },
    { 0xCD5AC952, "magic_rpg_7_end" },
    { 0x1269451B, "magic_rpg_8" },
    { 0x37A5C62D, "magic_rpg_8_end" },
    { 0xEC66CAB2, "magic_rpg_9" },
    { 0xBAE187B8, "magic_rpg_9_end" },
    { 0x38657A02, "magic_rpg_shoot" },
    { 0xDD8A52DF, "magic_rpg_trigger" },
    { 0x66D87D66, "magic_rpg_triggers" },
    { 0x455B8460, "magic_rpg_truck_end" },
    { 0x32FF4D33, "magic_rpg_truck_start" },
    { 0x72A397F7, "magic_rpgs_fire_randomly" },
    { 0x17080B1C, "magic_sniper" },
    { 0x9C275B75, "magical" },
    { 0xDC421EC5, "magical_exit_armory" },
    { 0xDE844DA8, "magical_exit_taken" },
    { 0x2AB3C0D8, "magically" },
    { 0xE89D8DA5, "magicbox" },
    { 0x5EB1F58E, "magicbox_closed_glow_callback" },
    { 0x57580E2B, "magicbox_face_spawn" },
    { 0x7CEEE06F, "magicbox_glow_callback" },
    { 0x19F866E3, "magicbox_host_migration" },
    { 0x4B0B155E, "magicbox_leave_sounds_callback" },
    { 0xF900AE76, "magicbox_open_glow_callback" },
    { 0x0A7FF6F6, "magicbox_should_upgrade_weapon_override" },
    { 0x38DF1B2C, "magicbox_show_sounds_callback" },
    { 0xBB7FC01F, "magicbox_unitrigger_think" },
    { 0x87F3C622, "magicbullet" },
    { 0x2331FAC1, "magicbullet_weapon" },
    { 0x6C7D3666, "magicglassbullet" },
    { 0x46DA7BFC, "magicgreande_scripted_death" },
    { 0xDAFE90E0, "magicgrenade" },
    { 0xFDDD8F7A, "magicgrenademanual" },
    { 0xCAC7AECF, "magicgrenadeplayer" },
    { 0xECF27A98, "magicgrenadetype" },
    { 0xB22A93D1, "magiclose" },
    { 0x91C60ABA, "magicreloadwhenreachenemy" },
    { 0xE1A36061, "magicsnipertalk" },
    { 0x0E649FE6, "magicwhatevertime_wheretheheckdidwegetthisnumberanyway" },
    { 0x4AF0D09E, "magnet_endon" },
    { 0x257CFFC2, "magnetometrist" },
    { 0xB3AF3636, "magnify" },
    { 0x8DFA7311, "magnitude" },
    { 0x4DF3BA17, "magnitude_squared" },
    { 0x2F2D32AA, "magnum" },
    { 0xB267043D, "mags" },
    { 0x4AC72235, "mah" },
    { 0xC72E5631, "mahjong_tiles_setup" },
    { 0x24C4A7CC, "mai" },
    { 0xD290EBFA, "main" },
    { 0x88462C4C, "main2" },
    { 0x5697EDAA, "main_alt" },
    { 0xCA8D83CE, "main_anim" },
    { 0xC0B25C8C, "main_area_pa_vox_setup" },
    { 0x56E71278, "main_baddie" },
    { 0xAB6CFEC4, "main_barge" },
    { 0xBB023E16, "main_barge_guard" },
    { 0x8B4FAD9E, "main_breakable" },
    { 0x4E3C8BF2, "main_building_blown_up" },
    { 0xE68C6FBB, "main_convoy2_awaken" },
    { 0x57F15D5A, "main_convoy_past" },
    { 0xE1C0AB9F, "main_convoy_wakes_by_shoot" },
    { 0x16E72E1E, "main_convoy_wakesup" },
    { 0x075DFDF1, "main_convoy_wakeup" },
    { 0x8195A6F6, "main_dir" },
    { 0x3C882CD9, "main_dist" },
    { 0xB3182B65, "main_door_guy" },
    { 0xEAD4E420, "main_end" },
    { 0x4AFC8AB0, "main_ent" },
    { 0x33E2D67A, "main_entrance_claw_think" },
    { 0x42E85206, "main_entrance_dialog" },
    { 0xE971EAD1, "main_entrance_main" },
    { 0xA8BE4DD0, "main_entrance_shutters" },
    { 0xD819CDDB, "main_func" },
    { 0x6C00FD60, "main_guard" },
    { 0x3FCEFE82, "main_guy" },
    { 0xBE2BCCC9, "main_hut_regroup" },
    { 0xACE159F6, "main_icon" },
    { 0x2C2B7CE7, "main_marine" },
    { 0x8C2FD29E, "main_music_egg_hit" },
    { 0xB8C301C9, "main_obj_num" },
    { 0xD184878A, "main_objective" },
    { 0xA574AFB6, "main_objective_updated" },
    { 0xC6BF5A6A, "main_part" },
    { 0x55B409A2, "main_precache" },
    { 0x0D0EF4F2, "main_quest_init" },
    { 0x947ECA53, "main_spawner" },
    { 0xBC6BB6C5, "main_squad" },
    { 0x8A5375F3, "main_start" },
    { 0x6A899FB9, "main_street_battle" },
    { 0xAD0185E6, "main_street_drones" },
    { 0x97E069CA, "main_street_drones_cover" },
    { 0xBF54C15C, "main_street_drones_end" },
    { 0x738BF71C, "main_street_fakefire" },
    { 0x964A7F0D, "main_street_fakefire_think" },
    { 0x04556556, "main_street_friendlies" },
    { 0x1BA46D91, "main_street_friendlies_strat" },
    { 0x16E33A97, "main_street_retreaters_strat" },
    { 0x2C0B2A67, "main_street_tank_1" },
    { 0xBA03BB2C, "main_street_tank_2" },
    { 0x282D5512, "main_street_tank_2_mg_fire" },
    { 0x0C00E9E6, "main_street_tank_fire" },
    { 0x3E3E2C02, "main_target" },
    { 0x11937976, "main_task" },
    { 0x0FD3696F, "main_think" },
    { 0x4AEFF52B, "main_trig" },
    { 0x780CBB6E, "main_turret_dist" },
    { 0x1AFE4935, "main_turret_target" },
    { 0x427B3CFD, "main_vtol_landing_render" },
    { 0x4F05FB7D, "main_vtol_landing_test" },
    { 0x8A9EB4ED, "main_window_guy" },
    { 0x710391BB, "main_zone" },
    { 0xF88D411B, "main_zone_name" },
    { 0x8C05E725, "mainanim" },
    { 0x61FA8991, "mainanimdeath" },
    { 0xFB5E2BAB, "mainanimdeathloop" },
    { 0xF98153D8, "mainatin" },
    { 0x7F08E977, "mainblend" },
    { 0x77C06E36, "mainclientent" },
    { 0xDB1001C1, "mainclientnum" },
    { 0x047AB76B, "maindebug" },
    { 0x2FFE394F, "maindelaymax" },
    { 0xC2865AF1, "maindelaymin" },
    { 0x7FF632FD, "mainframe" },
    { 0x64134974, "mainframe_link_all" },
    { 0xF8549F93, "mainframe_linked" },
    { 0xFA56F92B, "mainframe_links" },
    { 0xD567EA14, "mainframe_poi" },
    { 0x1BA830A9, "mainframe_room" },
    { 0x3E20CD4D, "maingun_fx" },
    { 0x420C679F, "mainkey" },
    { 0x2F3E3218, "mainloopstart" },
    { 0x487110E7, "mainly" },
    { 0x6CDE9AE3, "mainmenu" },
    { 0x7D4B8A70, "mainpiece" },
    { 0xFA9C1662, "mainshot" },
    { 0x74B644C7, "mainstreet" },
    { 0xB253FB3C, "mainstreet_car_spawners" },
    { 0x7A4FD45B, "mainstreet_car_spawners_strat" },
    { 0x526BE472, "maintain" },
    { 0x43267691, "maintain_mg_guy" },
    { 0x7F629310, "maintain_player_eye_target" },
    { 0xDDFEE4DB, "maintaincouteruaventities" },
    { 0x9F8CC585, "maintained" },
    { 0x39189AFE, "maintaining" },
    { 0x9D8AC543, "maintance" },
    { 0xEE129262, "maintenance" },
    { 0x614727C9, "mainturretdestroyed" },
    { 0xB8901DEA, "majg" },
    { 0x126AC904, "major" },
    { 0xF9B1A778, "major_axis" },
    { 0x75E16DB7, "major_threat" },
    { 0x0EBA8AEE, "major_threats" },
    { 0xE325BD82, "major_value" },
    { 0x02FDE488, "majority" },
    { 0x70C99C9E, "mak" },
    { 0x40007BDF, "mak_amb" },
    { 0x3F494AC2, "mak_anim" },
    { 0x1ABC33BC, "mak_art" },
    { 0xE7F33796, "mak_base" },
    { 0x4644ACE6, "mak_bunker" },
    { 0x607F7CC4, "mak_deepforest" },
    { 0x3CD8F196, "mak_endonremoveanimactive" },
    { 0xCD11F7CB, "mak_fx" },
    { 0xF5668E74, "mak_indoor" },
    { 0xD531E5E6, "mak_net" },
    { 0x8362BB94, "makarov" },
    { 0xED587EF1, "makarov_origin" },
    { 0xA9BD3DE7, "make" },
    { 0x1997987E, "make3d" },
    { 0x5C81C5D7, "make_a_tag_origin" },
    { 0x5F4A557B, "make_aa_crew_ignored" },
    { 0x2969AFCA, "make_aa_crew_ignored_think" },
    { 0x3229AF75, "make_aa_crew_last_longer" },
    { 0xC0620366, "make_aa_crew_last_longer_strat" },
    { 0x2E14C96C, "make_aa_gun_team_change" },
    { 0x07F00B97, "make_ai_aggressive" },
    { 0xB3DC9DF6, "make_ai_aware_of_turret" },
    { 0xA49653E8, "make_ai_ignore_all_to_stop_firing" },
    { 0x87F0E134, "make_ai_model_and_animate" },
    { 0x6A8E39E0, "make_ai_move" },
    { 0x6DDC7E2A, "make_ai_normal" },
    { 0xB573DC8F, "make_ai_shoot_at_targets" },
    { 0xA495D28F, "make_all_dogs_leave" },
    { 0x65266961, "make_all_enemy_aggressive" },
    { 0x256F37E3, "make_animated_character_model" },
    { 0x9435327D, "make_array" },
    { 0x6B1D3490, "make_barbwire_digbat" },
    { 0xE1E8DA2E, "make_baton_guard" },
    { 0xD3698530, "make_breadcrumbs" },
    { 0x9F651D29, "make_broken_peices" },
    { 0x1839E455, "make_casual" },
    { 0x45E42B6F, "make_choice" },
    { 0x047D72F5, "make_civilian" },
    { 0x03885A0C, "make_claw_ai" },
    { 0xE6AB4096, "make_crawler" },
    { 0xCEB7711B, "make_dam_bus" },
    { 0x064D0D50, "make_dead_civs_at_motel" },
    { 0x2B88010E, "make_default_mpla" },
    { 0x0F4E790D, "make_effective" },
    { 0x82C597C6, "make_ent_a_battle_target" },
    { 0x8E3CCF7B, "make_ent_ignore_battle" },
    { 0x0E0959C7, "make_evasion_path" },
    { 0x5F2BBB2C, "make_event_param" },
    { 0xBC50D0E1, "make_exit_magical" },
    { 0x1682E666, "make_fake_blackhawk" },
    { 0x9E93FB0C, "make_flash_guy_leave" },
    { 0xDA1FD6A4, "make_flash_guy_target_player" },
    { 0xBC57C46D, "make_flicker_change" },
    { 0xC7FF12FB, "make_floating_body" },
    { 0x4BF7D298, "make_friendies_cqb" },
    { 0xDB0A6419, "make_friendies_deadly" },
    { 0x923DC9DC, "make_friendies_ignored" },
    { 0xBD2FD65E, "make_friendies_not_cqb" },
    { 0x8DCEF3B6, "make_friendlies_ignore_grenades" },
    { 0x034AF7F4, "make_gpr_opcode" },
    { 0x692C5362, "make_guards_fire_on_boat" },
    { 0xCD9D3CC2, "make_hero" },
    { 0x6371042E, "make_horse_unuseable" },
    { 0x8B518C40, "make_horse_usable" },
    { 0x9F1D24EE, "make_it_easy" },
    { 0x47D332DD, "make_it_quick_a" },
    { 0xAFC94939, "make_it_quick_e" },
    { 0xC2756B8B, "make_it_quick_player" },
    { 0x598790C2, "make_juggernaut" },
    { 0x168EDAEB, "make_machete_digbat" },
    { 0x15A7FCF5, "make_machete_guard" },
    { 0x0B8A8444, "make_machete_mpla" },
    { 0x4F1831A6, "make_mature_safe_nova_body" },
    { 0xC7744040, "make_me_a_rusher" },
    { 0xF1CA7DE1, "make_me_active" },
    { 0x39CFC493, "make_model_not_cheap" },
    { 0x1953B24A, "make_oblivious" },
    { 0xE84B2CF7, "make_pip_fullscreen" },
    { 0x125C083C, "make_player_controlled_claw" },
    { 0x4A7B2E30, "make_player_copilot" },
    { 0x987C477A, "make_player_prone" },
    { 0x522369CD, "make_player_unusable" },
    { 0x1018B6B4, "make_player_usable" },
    { 0x7DEB054E, "make_prisoner" },
    { 0x3018767F, "make_real_ai" },
    { 0x697029FC, "make_reznov_come_down_early" },
    { 0xAECAD8A2, "make_reznov_invisible" },
    { 0xE20C7529, "make_reznov_visible" },
    { 0x7956CBBB, "make_richtofen_zombie" },
    { 0xC3A18ED6, "make_russian_squad" },
    { 0xB86E86FA, "make_safe_spot_trigger_box_at_point" },
    { 0xA3F1966A, "make_shotgunners_agressive" },
    { 0xDA54F24B, "make_solid" },
    { 0xC80460FD, "make_sp_player_invulnerable" },
    { 0x6D8C2126, "make_spawn_function" },
    { 0x61545FA7, "make_super_zombies" },
    { 0x2F0D2B6A, "make_supersprinter" },
    { 0x6A7D9849, "make_sure_damage_is_not_zero" },
    { 0xF4DE0180, "make_sure_end_synchronized_melee_on_killanimscript" },
    { 0x8A7FF235, "make_sure_goal_is_well_above_ground" },
    { 0xBA184B69, "make_sure_only_have_8_guys" },
    { 0x2019BFE4, "make_sure_player_drops" },
    { 0xEDC3CAB9, "make_sure_player_shot_during_event_3" },
    { 0x489384FD, "make_walk" },
    { 0xA4D39D09, "make_zeroes_earlier" },
    { 0xB14B6E1D, "make_zombie_blood_entity" },
    { 0x0C86D092, "make_zombie_craftable_open" },
    { 0x6BF0ADDD, "make_zone_adjacent" },
    { 0x01E49A9B, "makeallboltsdud" },
    { 0x57E6EA96, "makecopteractive" },
    { 0x640FC4B7, "makecopterpassive" },
    { 0x8C73340D, "makedvarserverinfo" },
    { 0xEC30FA7E, "makefakeai" },
    { 0x0D1CFF26, "makefindfleshstructs" },
    { 0xF9376476, "makegrenadedud" },
    { 0xDA937091, "makegrenadedudanddestroy" },
    { 0x7A18E585, "makelight" },
    { 0x5C8C8601, "makelocalizedstring" },
    { 0x2A983768, "makeminspec" },
    { 0xC43031E2, "makemixerlight" },
    { 0x669C8D64, "makenmlranknumbersolo" },
    { 0xCD1EE2DA, "makeranknumber" },
    { 0xC2ADCA6D, "makerealai" },
    { 0x59144DC6, "makeroom" },
    { 0x57F7408A, "makerunsounds" },
    { 0x2173F95E, "makes" },
    { 0x0D1D5545, "makesentient" },
    { 0x7EFA7C9D, "makeshift" },
    { 0x9BC8D5A4, "makesolid" },
    { 0xC7796988, "makesure" },
    { 0xB2EAD944, "makesure_stone_blows" },
    { 0x01CA09CB, "makesureswitchtoweapon" },
    { 0x91AA9639, "makesureturnworks" },
    { 0xB02F1F84, "maketurretunusable" },
    { 0x926C1AD9, "maketurretusable" },
    { 0x8B83CD6F, "maketype" },
    { 0x347CC9B2, "makeunusable" },
    { 0xA2B96083, "makeusable" },
    { 0x9ED72B0C, "makevehicleunusable" },
    { 0x991AD231, "makevehicleusable" },
    { 0x5CA4E21B, "makevisible" },
    { 0xDD705111, "makevisibletoall" },
    { 0x773EC097, "makezombiecrawler" },
    { 0x9C252EEF, "makin" },
    { 0xDE93AE18, "makin_raft_rubber" },
    { 0x0BD0C022, "making" },
    { 0x8726AEB3, "mal_pad" },
    { 0xA2982E5E, "male" },
    { 0x90BBC3C7, "male_spawner" },
    { 0x456B0E86, "malebundle" },
    { 0x157DE124, "malee_camo_challenge" },
    { 0x4CC842C1, "males" },
    { 0xA2CFC971, "malfunction" },
    { 0x68991048, "malfunctionreaction" },
    { 0x6B4C6CD8, "malfunctions" },
    { 0xDA7A7172, "mali" },
    { 0x9886D57F, "mall" },
    { 0xAB3275D9, "mall_ambient_effects" },
    { 0x151E2004, "mall_anims" },
    { 0x0FC0AE17, "mall_cleanup_trigger" },
    { 0x67C1FC82, "mall_precache_anims" },
    { 0x4164AFF5, "mall_save_1" },
    { 0x67672A5E, "mall_save_2" },
    { 0x8D69A4C7, "mall_save_3" },
    { 0x83584BE8, "mall_save_4" },
    { 0xB11C1916, "mall_save_point" },
    { 0x94552E25, "malloc" },
    { 0xFEC22D63, "man" },
    { 0x056CA2B7, "man_01" },
    { 0x9365337C, "man_02" },
    { 0xB967ADE5, "man_03" },
    { 0xBC213264, "man_mg42" },
    { 0x9EFB340A, "man_the_mg" },
    { 0x55428816, "manacur" },
    { 0x5EF8A490, "manage" },
    { 0x55E32205, "manage_ai" },
    { 0xC07D425D, "manage_ai_go_to_player_node" },
    { 0xA2E2EFF6, "manage_ai_player_found" },
    { 0x087E66FF, "manage_ai_player_invalid" },
    { 0xA29E4A27, "manage_ai_poll_player_state" },
    { 0xA4AA8B70, "manage_ai_relative" },
    { 0xA8C2FDDC, "manage_ai_relative_to_player" },
    { 0x0E8CA01A, "manage_ai_stop_polling_player_state" },
    { 0x02480DAE, "manage_ambient_monkeys" },
    { 0x10FF6B3A, "manage_anim_timescale" },
    { 0xFDAC9755, "manage_arena_enemy_squads" },
    { 0xD03A0319, "manage_arena_muj_squads" },
    { 0x96360BA0, "manage_barge_bend" },
    { 0xB837D89A, "manage_barnes_color_chain" },
    { 0x048B2B24, "manage_billboard" },
    { 0xF9BF78AD, "manage_blizzard" },
    { 0x20B3E6C8, "manage_building_zone" },
    { 0x9DD5A74B, "manage_corpse_delete" },
    { 0x2AAB92B8, "manage_damage_blur" },
    { 0x341BC1AF, "manage_electric_chairs" },
    { 0x854F1F48, "manage_electric_chairs_custom_func" },
    { 0x45A8D4EA, "manage_employee_door" },
    { 0x85C1CD2F, "manage_exploders" },
    { 0x9A702F5B, "manage_extra_cam" },
    { 0x9881DA0F, "manage_flying_dialog_triggers" },
    { 0xAFFC84EC, "manage_fxanim_grass_animating" },
    { 0xB35BF3D5, "manage_gunfire_hint" },
    { 0x01288BBB, "manage_hip3_troops_spawn" },
    { 0x1F5D590D, "manage_hudson_blocker" },
    { 0x16997D67, "manage_multiple_pieces" },
    { 0x239D3899, "manage_outside_zone" },
    { 0xAE65771E, "manage_pilots_suggested_seat" },
    { 0x9B9C863B, "manage_plaza_truck" },
    { 0xA0BDA48B, "manage_ptboat_target" },
    { 0x55BA2D3D, "manage_russian_dialog" },
    { 0x9F1CE454, "manage_spawners" },
    { 0xDE9254F3, "manage_spawners_nogoal" },
    { 0x069319FB, "manage_tree_damage_state" },
    { 0xA56EC4A8, "manage_triggers" },
    { 0xDBC930AC, "manage_vehicle_trigger" },
    { 0xBD1AD094, "manage_vehicles" },
    { 0xFF709674, "manage_vehicles_low_road" },
    { 0x4565AFF7, "manage_wall_fxanim" },
    { 0x33CBC551, "manage_water_sheeting_fx" },
    { 0x0E231D85, "manage_zombie_spawn_delay" },
    { 0x91A1FBBD, "manage_zone" },
    { 0xAC319A7C, "manage_zones" },
    { 0xA61A1A28, "manageable" },
    { 0x69C44574, "managed" },
    { 0x2D41E2DC, "managed_spawn" },
    { 0xEE3097C3, "manageface" },
    { 0x63EBDF0C, "management" },
    { 0xBD97AA12, "manager" },
    { 0xD50E154D, "manageractivecount" },
    { 0xD82333C2, "managerpotentialspawncount" },
    { 0x80F7FF1D, "managers" },
    { 0xE39A247B, "manages" },
    { 0x70680711, "managing" },
    { 0xE21FA495, "managing_pieces" },
    { 0xE951B3EE, "mandatory" },
    { 0xEFC1BBFE, "mandatoryarg" },
    { 0xFBE24DA6, "manditoryarg" },
    { 0x2489CAF4, "mandown_reverse_spawn" },
    { 0xD9C548F4, "maneuver" },
    { 0x19AF510C, "maneuverable" },
    { 0x9E5B5615, "maneuvername" },
    { 0x2468702D, "maneuvernamelist" },
    { 0x97C0EDE7, "maneuvers" },
    { 0x0050628C, "maneuvers_heli_audio_trig_var" },
    { 0xEBCBEF86, "mang" },
    { 0xFC4E12D6, "mangaer" },
    { 0x9FEBFB41, "mangled" },
    { 0xFC74BF24, "mangrove" },
    { 0x65D4F55E, "mangrove_ambush_2_heroes_sneak" },
    { 0x6E13B5A5, "mangrove_ambush_2_heroes_sneak_2" },
    { 0x5F8BDC91, "mangrove_ambush_beat_2" },
    { 0x40CB0BF5, "mangrove_ambush_beat_2_timeout" },
    { 0x39896228, "mangrove_ambush_beat_3" },
    { 0x04CB683A, "mangrove_ambush_guys" },
    { 0x013A98C9, "mangrove_ambush_guys_2" },
    { 0x5AD257E5, "mangrove_ambush_guys_2a_strat" },
    { 0xED327BE2, "mangrove_ambush_guys_2b_strat" },
    { 0x36E01837, "mangrove_ambush_guys_3_strat" },
    { 0xE0E78A0D, "mangrove_ambush_guys_strat" },
    { 0x071660FD, "mangrove_ambush_timer" },
    { 0xB0BFB64A, "mangrove_bend_guy" },
    { 0x7477F8D2, "mangrove_corsair_trap" },
    { 0xB322F413, "mangrove_custom_transitions" },
    { 0x6268BA87, "mangrove_custom_transitions_delay" },
    { 0x5381AC17, "mangrove_drop_gun" },
    { 0xE7498F69, "mangrove_extra_redshirt" },
    { 0x2644A6B2, "mangrove_extra_redshirt_strat" },
    { 0x8D5725BE, "mangrove_extra_redshirt_trap_strat" },
    { 0xA9A3A3A2, "mangrove_grenades" },
    { 0xC71037BA, "mangrove_intro_positions" },
    { 0x3836FEF6, "mangrove_throw_grenade" },
    { 0x9C6DDAD1, "mangrove_vo_2" },
    { 0x766B6068, "mangrove_vo_3" },
    { 0xF321AF65, "mangrove_vo_intro" },
    { 0x11FCA224, "mangrove_vo_trap" },
    { 0xBDB18E1C, "mangrove_walk" },
    { 0xA1A8AE57, "mangroves" },
    { 0xFE30E872, "manhy" },
    { 0x52B62BF1, "maniac_l" },
    { 0x66D8DDAF, "maniac_r" },
    { 0xCEF8B50E, "manifest" },
    { 0x77191B31, "manipulate" },
    { 0x4591F273, "manipulate_createfx_ents" },
    { 0x05DF04E7, "manipulated" },
    { 0xD4A8332E, "manipulation" },
    { 0xDE9B5D32, "manipulators" },
    { 0xBB2969FC, "manned" },
    { 0xE9467E5F, "mannequin" },
    { 0xB63E66DE, "mannequin_ang" },
    { 0xEBAA0197, "mannequin_count" },
    { 0x946C8083, "mannequin_damage_control" },
    { 0x203C3641, "mannequin_fall" },
    { 0x4608FD9A, "mannequin_force_cleanup" },
    { 0x8603EAB3, "mannequin_headless" },
    { 0x70352FB0, "mannequin_headspot" },
    { 0x264D4FAC, "mannequin_melee_dist_sq" },
    { 0x3890D7CC, "mannequin_melee_height" },
    { 0xC430C272, "mannequin_melee_yaw" },
    { 0x43F4D5B4, "mannequin_org" },
    { 0xC6519C65, "mannequin_time" },
    { 0x554460A5, "mannequinbehavior" },
    { 0xE01EF536, "mannequincollisionservice" },
    { 0x31F92A00, "mannequindamage" },
    { 0x9B9DEDD0, "mannequininterface" },
    { 0xBDF5B563, "mannequinn" },
    { 0x6010F7E6, "mannequins" },
    { 0x50F88726, "mannequinshouldmelee" },
    { 0x4C7F577C, "mannequinspawn_music" },
    { 0x69D37FFF, "mannequinspawnsetup" },
    { 0xD35BE85B, "mannequinwaittime" },
    { 0x0EFCCE9A, "manner" },
    { 0x61426769, "manning" },
    { 0x8ADA8C17, "manoeuver" },
    { 0x3B875AC9, "manoeuvering" },
    { 0xC3625C08, "manor" },
    { 0xF39A5F52, "mans" },
    { 0x21368118, "mansion" },
    { 0x96B3CF46, "mansion_building_bomb" },
    { 0x7FFBBB30, "mansion_ceiling" },
    { 0x91FABD98, "mansion_ceiling_broken" },
    { 0x37D63BED, "mansion_core_extra" },
    { 0xE6D9F7FD, "mansion_core_strat" },
    { 0x7B321B23, "mansion_defend" },
    { 0xCE38531C, "mansion_dialogue_think" },
    { 0xCCBADBD3, "mansion_door_animate" },
    { 0x756FEC98, "mansion_door_bash" },
    { 0x30A357E1, "mansion_door_breach" },
    { 0xF7225B44, "mansion_door_breach_bowman" },
    { 0x5AB7E6EE, "mansion_door_breach_cabinet_guard" },
    { 0x3A190B38, "mansion_door_breach_node" },
    { 0x6CDE2742, "mansion_door_breach_window_guard" },
    { 0x881E1122, "mansion_door_breach_woods" },
    { 0xA93DE741, "mansion_door_kick_timing" },
    { 0x805058F1, "mansion_door_opened" },
    { 0x17D2377E, "mansion_exit_falling_fire" },
    { 0x5B765B46, "mansion_exit_fire" },
    { 0x59CBA07E, "mansion_exp_hit" },
    { 0xFC536906, "mansion_fan_1" },
    { 0x353FD999, "mansion_fans" },
    { 0xD290527B, "mansion_friendly_movement_think" },
    { 0x42E35F79, "mansion_front_cleared" },
    { 0xE50333EE, "mansion_front_enemies_ai" },
    { 0x7C36432A, "mansion_ghost_plays_piano" },
    { 0x3DEEE412, "mansion_goal" },
    { 0x10ED0661, "mansion_hole" },
    { 0xA3D1DB43, "mansion_left_door" },
    { 0xDE2F3579, "mansion_lobby" },
    { 0x9B7D6468, "mansion_main" },
    { 0xFEB13047, "mansion_menendez_meets_mason" },
    { 0xEE9204A5, "mansion_mg_threatbias" },
    { 0x5C7520BE, "mansion_mgs" },
    { 0xA21100D5, "mansion_nag_array" },
    { 0x03A65395, "mansion_pen_ai" },
    { 0xBEC7D519, "mansion_player_movement_think" },
    { 0xAF3964B7, "mansion_portals_hide" },
    { 0x39777BD4, "mansion_portals_show" },
    { 0xAE433296, "mansion_right_door" },
    { 0x52DC4CCD, "mansion_roof" },
    { 0x467E39CC, "mansion_vision_trig" },
    { 0x38F83B0C, "mantle" },
    { 0x2E47C094, "mantle_anim" },
    { 0xC1C1D907, "mantle_anims" },
    { 0x7670C485, "mantle_check_height" },
    { 0x0273FA46, "mantle_disable_gaz" },
    { 0x7FA52895, "mantle_disabler" },
    { 0x22E017BC, "mantle_guy" },
    { 0x7B6FAE53, "mantle_over_40_move_speed_override" },
    { 0xCC7AC313, "mantle_pressed" },
    { 0x7FB2B949, "mantle_start" },
    { 0x0D96A4C4, "mantle_wait" },
    { 0xE731383C, "mantlebrush" },
    { 0x626BBD20, "mantled" },
    { 0x7B02D9DF, "mantleenabled" },
    { 0xCF33E710, "mantleendtime" },
    { 0x109D7A86, "mantler_spawn" },
    { 0xCF7F171F, "mantletime" },
    { 0x947F05AA, "mantletrig" },
    { 0xB308E3B5, "mantling" },
    { 0x40859133, "manual" },
    { 0xC3382908, "manual_ai" },
    { 0x3DD77B38, "manual_drop_think" },
    { 0x276BD005, "manual_fire_mg" },
    { 0x4BE3A2C5, "manual_linkto" },
    { 0x84475918, "manual_lui_add" },
    { 0x77084325, "manual_mg_fire" },
    { 0x6D922A96, "manual_override" },
    { 0x3E41B22D, "manual_taglinkto" },
    { 0x48F910C1, "manual_target" },
    { 0x0E96FCE8, "manual_targets" },
    { 0x687D2C32, "manual_think" },
    { 0x55A5F7CD, "manual_wait" },
    { 0xE443D0A0, "manualdropthink" },
    { 0x4CF622F4, "manualluiadd" },
    { 0x97A9D23E, "manually" },
    { 0x6170BF4A, "manualscriptdummies" },
    { 0xADBB4A4F, "manualsecuritydummies" },
    { 0xF4D17FDC, "manualtarget" },
    { 0x83500B00, "manualtraversemode" },
    { 0x1614253F, "manuel" },
    { 0x6E076794, "manuever" },
    { 0xB5096838, "manufacture" },
    { 0xBECB6279, "manufacturing" },
    { 0x62850F65, "manuvering" },
    { 0xD7A93DC8, "many" },
    { 0x7ADAF57D, "map" },
    { 0x0BF98168, "map_amb" },
    { 0x523F87F8, "map_change" },
    { 0xE3E07515, "map_collectibles" },
    { 0x0BE20176, "map_default_sun_direction" },
    { 0x59CE2411, "map_delete" },
    { 0xC83D9100, "map_done" },
    { 0xCAD10114, "map_down" },
    { 0xF8F570F7, "map_id" },
    { 0x2ABC6C8F, "map_is_early_in_the_game" },
    { 0xF6E1290C, "map_light_receiver_on" },
    { 0xC5CDD688, "map_list" },
    { 0x4ABB8255, "map_location" },
    { 0x1895E941, "map_location_name" },
    { 0x728ED071, "map_logic_exists" },
    { 0xD73FF2F0, "map_logic_started" },
    { 0xEFC3146B, "map_material" },
    { 0x1B6C5A02, "map_material_helper" },
    { 0xF9A4BF15, "map_material_helper_by_localclientnum" },
    { 0x82237E4E, "map_material_if_undefined" },
    { 0xDA1E2BE7, "map_model" },
    { 0xF034F934, "map_monitor_run" },
    { 0xFB4674A9, "map_name" },
    { 0xA66B4320, "map_names" },
    { 0x6404F13D, "map_navcard" },
    { 0xE4BA1254, "map_objective_list" },
    { 0x764C8221, "map_restart" },
    { 0xCEE23C34, "map_room_scene" },
    { 0x8F14EB3A, "map_room_wait_scene" },
    { 0x0206D556, "map_scale" },
    { 0xBEF926B7, "map_setup" },
    { 0x78706E2F, "map_source" },
    { 0x3ACBE904, "map_start" },
    { 0x7A808BC8, "map_start_fog_trigger" },
    { 0xB426F65E, "map_start_setup" },
    { 0x796B1808, "map_type" },
    { 0x16BDDEE7, "map_up" },
    { 0x4105FE4B, "map_vehicles" },
    { 0xE7C3178E, "map_vehicles_cleanup" },
    { 0x056CE1CF, "map_x_percentage" },
    { 0xDE119754, "map_y_percentage" },
    { 0x6C0FCE4A, "mapaspectratio" },
    { 0xD45A4A66, "mapcenter" },
    { 0x340A5678, "mapcenterz" },
    { 0x53B16EE1, "mapenter" },
    { 0x46E11D4C, "maperrors" },
    { 0x4E5CD5B1, "mapevent_player_enters_last_stand" },
    { 0xF23BEC74, "mapevent_unknown" },
    { 0xBCC35C13, "mapfile" },
    { 0x34BF0601, "mapfloat" },
    { 0x165DEC2A, "mapholes" },
    { 0x34D994C6, "mapid" },
    { 0x5FC3B52F, "mapindex" },
    { 0xC28E59FE, "mapleaderboard" },
    { 0x465B96F1, "maplocationname" },
    { 0x3D6D06AE, "mapmaterialindex" },
    { 0xB78F06C4, "mapname" },
    { 0xA604F4CE, "mapname2" },
    { 0xCC076F37, "mapname3" },
    { 0x41D78E20, "mapped_const" },
    { 0x8C34C654, "mapped_material_id" },
    { 0xC1939FA9, "mapping" },
    { 0xD1E5F420, "mappings" },
    { 0xF9BB7FD0, "mapreader" },
    { 0xF7B5BB29, "mapreader1" },
    { 0x1DB83592, "mapreader2" },
    { 0x02FC8494, "mapreader_spawners" },
    { 0xC31C15BB, "mapreaders" },
    { 0x64C96C52, "maprestart" },
    { 0x921FF83C, "maps" },
    { 0xE7F6DC4E, "mapshaderconstant" },
    { 0x03D8F672, "mapsize" },
    { 0x593A90B8, "mapstable" },
    { 0xC2BFB6DB, "mapstartaudio" },
    { 0x99DCBF93, "maptable" },
    { 0x72DEFD13, "mapuniqueid" },
    { 0x29BE5023, "mapversion" },
    { 0xD413942F, "mapx" },
    { 0xAE1119C6, "mapy" },
    { 0xC6DFEA4F, "mar" },
    { 0xE83B439B, "marathon" },
    { 0x786D4ABD, "marathon_off" },
    { 0xEC4676F1, "marathon_on" },
    { 0x9686EA26, "march_origin_inside" },
    { 0xEF93F48B, "march_origin_outside" },
    { 0x06656D8D, "marched" },
    { 0x54857CAA, "marchers" },
    { 0x32166F36, "marchers_in_position" },
    { 0x5B24191B, "margin" },
    { 0x50F42F82, "margwa" },
    { 0xBDD66F4C, "margwa_anim_head_left_closed" },
    { 0x4C8679FC, "margwa_anim_head_left_open" },
    { 0x3962B050, "margwa_anim_head_left_smash" },
    { 0x52CEE4A3, "margwa_anim_head_mid_closed" },
    { 0xA2536097, "margwa_anim_head_mid_open" },
    { 0x713D60A9, "margwa_anim_head_mid_smash" },
    { 0xEFB2117B, "margwa_anim_head_right_closed" },
    { 0x7436190F, "margwa_anim_head_right_open" },
    { 0x98BF5411, "margwa_anim_head_right_smash" },
    { 0x213DFDAB, "margwa_anim_tentacle_left_base" },
    { 0xCA8BB974, "margwa_anim_tentacle_right_base" },
    { 0x73978B41, "margwa_damage_override_callback" },
    { 0x81B29893, "margwa_footstep_earthquake_max_radius" },
    { 0x0D44C1B0, "margwa_fx_clientfield_bits" },
    { 0xB21B6130, "margwa_fx_clientfield_type" },
    { 0x1CC9BEA1, "margwa_fx_in_clientfield" },
    { 0xD70DD804, "margwa_fx_out_clientfield" },
    { 0x54DDF2ED, "margwa_fx_spawn_clientfield" },
    { 0x23FF33B8, "margwa_fx_spawn_clientfield_bits" },
    { 0xCDAD37D8, "margwa_fx_spawn_clientfield_type" },
    { 0x6636A0A4, "margwa_fx_travel_clientfield" },
    { 0xFAFC0F9A, "margwa_fx_travel_tell_clientfield" },
    { 0x4182A531, "margwa_gore_left_model_override" },
    { 0x7FF16E00, "margwa_gore_mid_model_override" },
    { 0xB9C5D5F0, "margwa_gore_right_model_override" },
    { 0xEC78B7A3, "margwa_head" },
    { 0x841BA889, "margwa_head_clear" },
    { 0xF3525C8C, "margwa_head_clientfield_bits" },
    { 0x456DFAF4, "margwa_head_clientfield_type" },
    { 0x5D726D19, "margwa_head_close_max" },
    { 0xB8184BA7, "margwa_head_close_min" },
    { 0xEEE36822, "margwa_head_closed" },
    { 0x63B08D07, "margwa_head_damage_range" },
    { 0x65931203, "margwa_head_explode_clientfield" },
    { 0xFC4DEE16, "margwa_head_explode_clientfield_bits" },
    { 0xD495C85E, "margwa_head_explode_clientfield_type" },
    { 0xB378EA29, "margwa_head_explosion_range" },
    { 0xB59E3EE0, "margwa_head_health_base" },
    { 0x5373C806, "margwa_head_hit_fx" },
    { 0x64A92274, "margwa_head_kill_weapon_check" },
    { 0xF1B7C223, "margwa_head_killed_clientfield" },
    { 0x571FFFB3, "margwa_head_killed_left" },
    { 0xC4F5176E, "margwa_head_killed_mid" },
    { 0x3C0DC8A6, "margwa_head_killed_right" },
    { 0x0C572965, "margwa_head_left" },
    { 0x568F745B, "margwa_head_left_clientfield" },
    { 0xA1B90E05, "margwa_head_left_hit_clientfield" },
    { 0x2C028BBA, "margwa_head_left_model_override" },
    { 0xB923E9D6, "margwa_head_mid_clientfield" },
    { 0xBB6905EC, "margwa_head_mid_hit_clientfield" },
    { 0x72374095, "margwa_head_mid_model_override" },
    { 0xC8FE870D, "margwa_head_middle" },
    { 0x31694ED6, "margwa_head_open" },
    { 0xA8F9652D, "margwa_head_open_max" },
    { 0x260E2323, "margwa_head_open_min" },
    { 0x4B1C3908, "margwa_head_right" },
    { 0x98D6207E, "margwa_head_right_clientfield" },
    { 0x249C9B44, "margwa_head_right_hit_clientfield" },
    { 0x0C9A18BD, "margwa_head_right_model_override" },
    { 0xEAD4DA5D, "margwa_head_smash_attack" },
    { 0xAF6FFA56, "margwa_head_tag" },
    { 0x2E01A903, "margwa_headshot" },
    { 0x47D008EC, "margwa_impact_fx" },
    { 0xD19768A5, "margwa_impact_fx_file" },
    { 0xBAA1A736, "margwa_jaw_base_l" },
    { 0xE0A4219F, "margwa_jaw_base_m" },
    { 0x66CE4298, "margwa_jaw_base_r" },
    { 0x4F80D6FB, "margwa_jaw_clear" },
    { 0x8A6E16D7, "margwa_jaw_clientfield" },
    { 0xA14E44E9, "margwa_jaw_head_l_explode" },
    { 0xECEC2FB8, "margwa_jaw_head_m_explode" },
    { 0xE322FCF3, "margwa_jaw_head_r_explode" },
    { 0x9E3E35EA, "margwa_jaw_idle" },
    { 0xE3FCE533, "margwa_jaw_react_idgun" },
    { 0xAC3A4DB6, "margwa_jaw_react_idgun_packed" },
    { 0x8690C434, "margwa_jaw_react_stun" },
    { 0x6D1CC9B3, "margwa_jaw_run" },
    { 0xD05EAE0E, "margwa_jaw_run_charge" },
    { 0x6A6EF7CF, "margwa_jaw_smash_attack" },
    { 0xFD22CAE2, "margwa_jaw_swipe" },
    { 0x4A0F2B2E, "margwa_jaw_swipe_player" },
    { 0x03C6814D, "margwa_jaw_teleport_in" },
    { 0x21E0E82C, "margwa_jaw_teleport_out" },
    { 0xE020047B, "margwa_jaw_trv_jump_across_256" },
    { 0xB4DF95EC, "margwa_jaw_trv_jump_down_128" },
    { 0x78AA874E, "margwa_jaw_trv_jump_down_36" },
    { 0x76D54980, "margwa_jaw_trv_jump_down_96" },
    { 0xC71D4787, "margwa_jaw_trv_jump_up_128" },
    { 0x051AB8AB, "margwa_jaw_trv_jump_up_36" },
    { 0xA58B1B69, "margwa_jaw_trv_jump_up_96" },
    { 0xCDEF60D1, "margwa_kill" },
    { 0xD48ADBBB, "margwa_large_radius" },
    { 0x76398C1E, "margwa_melee_dist" },
    { 0x97D88BAD, "margwa_melee_dist_sq" },
    { 0x23D4EF5B, "margwa_melee_yaw" },
    { 0xE0EAF99F, "margwa_model_body" },
    { 0x0CE386F2, "margwa_model_gore_left" },
    { 0xA44A4E41, "margwa_model_gore_mid" },
    { 0xB7C031E1, "margwa_model_gore_right" },
    { 0x8AFF5FFF, "margwa_model_head_left" },
    { 0x4C7E6472, "margwa_model_head_mid" },
    { 0x7A25299A, "margwa_model_head_right" },
    { 0x72A431D6, "margwa_mouth_blend_time" },
    { 0xF595C1FB, "margwa_navmesh_boundary_dist" },
    { 0x1AB76290, "margwa_navmesh_radius" },
    { 0xB2AD06B7, "margwa_num_heads" },
    { 0xF0DAD84B, "margwa_num_tentacles_per_side" },
    { 0x75BE2A08, "margwa_pain_close_time" },
    { 0xD903A525, "margwa_play_spawn_effect" },
    { 0xE0754620, "margwa_riotshield_damage" },
    { 0x62BC200D, "margwa_riotshield_facing_tolerance" },
    { 0x6EABA533, "margwa_roar_effect" },
    { 0xE884EEEA, "margwa_roar_fx" },
    { 0x1BD7A9E7, "margwa_roar_fx_file" },
    { 0x4C5C50F4, "margwa_single_head_close_max" },
    { 0x76EE5C3A, "margwa_single_head_close_min" },
    { 0x65FAAB46, "margwa_smash_attack_damage" },
    { 0xFE8B3514, "margwa_smash_attack_height" },
    { 0xBF443FA0, "margwa_smash_attack_offset" },
    { 0x1AAA1798, "margwa_smash_attack_range" },
    { 0xA1AC898D, "margwa_smash_attack_range_light" },
    { 0xCD4A0753, "margwa_smash_attack_start" },
    { 0xBB45D8F1, "margwa_smash_clientfield" },
    { 0x803F7C54, "margwa_smash_clientfield_bits" },
    { 0xF562151C, "margwa_smash_clientfield_type" },
    { 0xD8750101, "margwa_smash_damage_callback" },
    { 0x12C4E9D2, "margwa_spawn_effect" },
    { 0xEC2BC13F, "margwa_spawn_fx" },
    { 0x5148F198, "margwa_spawn_fx_file" },
    { 0x05B80F1A, "margwa_super_roar_fx" },
    { 0x7D305597, "margwa_super_roar_fx_file" },
    { 0x48C0DF2C, "margwa_swipe_dist" },
    { 0xA60FA13F, "margwa_swipe_dist_sq" },
    { 0x23028F6B, "margwa_tag_chunk_left" },
    { 0xE8B85A26, "margwa_tag_chunk_mid" },
    { 0x91CFE3DE, "margwa_tag_chunk_right" },
    { 0xA004C99C, "margwa_tag_head_left" },
    { 0x9478EAC3, "margwa_tag_head_mid" },
    { 0x2FD359F3, "margwa_tag_head_right" },
    { 0xA030FB74, "margwa_tag_jaw_left" },
    { 0xAF6A453B, "margwa_tag_jaw_mid" },
    { 0x5491272B, "margwa_tag_jaw_right" },
    { 0xA25A9BAF, "margwa_tag_teleport" },
    { 0x66503DEC, "margwa_teleport" },
    { 0xBBCE6745, "margwa_teleport_fx" },
    { 0x292C873A, "margwa_teleport_fx_file" },
    { 0x1E74ABE6, "margwa_teleport_in" },
    { 0xA937D532, "margwa_teleport_off" },
    { 0xFFD2F604, "margwa_teleport_on" },
    { 0xE69E06C1, "margwa_teleport_out" },
    { 0x0EA7C154, "margwa_teleport_speed" },
    { 0x660F64A0, "margwa_teleport_travel_fx" },
    { 0xA4E011D1, "margwa_teleport_travel_fx_file" },
    { 0xD7E4F73C, "margwa_teleport_travel_tell_fx" },
    { 0x9BD5D8B5, "margwa_teleport_travel_tell_fx_file" },
    { 0x0A5D9303, "margwa_tell_dist" },
    { 0xC9425E9A, "margwa_tell_dist_sq" },
    { 0xFF3C5FD8, "margwa_traveler_height_offset" },
    { 0x777B34A4, "margwa_traveler_speed" },
    { 0x534228D8, "margwa_traveler_time" },
    { 0x6C6FD2B0, "margwabehavior" },
    { 0x6FB4C3F9, "margwacandamageanyhead" },
    { 0xD7D05B41, "margwacandamagehead" },
    { 0x8E0E686A, "margwaclientutils" },
    { 0xB09C53B4, "margwacloseallheads" },
    { 0x5ADC4B54, "margwaclosehead" },
    { 0xB59AE4E9, "margwadamage" },
    { 0xCBFBF8AC, "margwadeath" },
    { 0x0D663D52, "margwadeathaction" },
    { 0xD357CDCE, "margwadestroyhead" },
    { 0x69913A5A, "margwadisablestun" },
    { 0x21573F43, "margwaenablestun" },
    { 0x08869A77, "margwaforcesprint" },
    { 0xF6E2BD30, "margwafxincallback" },
    { 0x2DA4E7B5, "margwafxoutcallback" },
    { 0x540E4B20, "margwafxspawncallback" },
    { 0x7DBD5705, "margwafxtravelcallback" },
    { 0x584A8FB0, "margwafxtraveltellcallback" },
    { 0xA509FA6E, "margwaheadcanopen" },
    { 0x78A5758C, "margwaheaddamagedelay" },
    { 0xE758BEB5, "margwaheadexplosion" },
    { 0xDB2D5DEF, "margwaheadhit" },
    { 0x42DFC6E6, "margwaheadkilledcallback" },
    { 0xC0E0C646, "margwaheadleftcallback" },
    { 0x7E5D3087, "margwaheadmidcallback" },
    { 0xD87D3CCF, "margwaheadrightcallback" },
    { 0x41D4A9E4, "margwaheadsmash" },
    { 0x6D2D2AD3, "margwaheadupdate" },
    { 0xED69D034, "margwaidlestart" },
    { 0xBA853ECA, "margwainithead" },
    { 0x5D887BA9, "margwajawcallback" },
    { 0xA614F89C, "margwakillhead" },
    { 0x00E9B7FD, "margwalefthitcallback" },
    { 0xF83117AE, "margwamidhitcallback" },
    { 0x03ABDF83, "margwamovestart" },
    { 0xC2A638DC, "margwanotetrackbodyfall" },
    { 0x13E0502D, "margwanotetrackpainmelee" },
    { 0xF28BE431, "margwanotetracksmashattack" },
    { 0xE4944A56, "margwapainstart" },
    { 0xE263E387, "margwapainterminate" },
    { 0xD53EE8D8, "margwapainterminatecb" },
    { 0x4B9DE733, "margwaprocessfootstep" },
    { 0xBD904C32, "margwareactidgunstart" },
    { 0x8219CE43, "margwareactidgunterminate" },
    { 0xE09EF1A5, "margwareactstunaction" },
    { 0x8A3CBD45, "margwareactstunstart" },
    { 0x81B13674, "margwareactstunterminate" },
    { 0x78A5C7D6, "margwareactswordstart" },
    { 0x976FB907, "margwareactswordterminate" },
    { 0xCD7A8132, "margwaresetheadtime" },
    { 0x5A1F5466, "margwarighthitcallback" },
    { 0xC96301EE, "margwaserverutils" },
    { 0x30C7C3D3, "margwasetgoal" },
    { 0x053CE09A, "margwasetheadhealth" },
    { 0x41769342, "margwashouldfreeze" },
    { 0x177FFB7F, "margwashouldreactidgun" },
    { 0x5C67A270, "margwashouldreactstun" },
    { 0xF779AEA3, "margwashouldreactsword" },
    { 0x6A0C7C6C, "margwashouldreset" },
    { 0x57301FC0, "margwashouldshowpain" },
    { 0x061A32A9, "margwashouldsmashattack" },
    { 0xA342F9CC, "margwashouldspawn" },
    { 0x5ECD6297, "margwashouldswipeattack" },
    { 0x9782FB97, "margwashouldteleportin" },
    { 0xEE830C62, "margwashouldteleportout" },
    { 0x8526BC6C, "margwashouldwait" },
    { 0x244B1616, "margwasmashattackstart" },
    { 0x79895C47, "margwasmashattackterminate" },
    { 0xBE725723, "margwasmashcallback" },
    { 0x6A6776CF, "margwaspawn" },
    { 0xEAC87E92, "margwaspawnsetup" },
    { 0xF28D441D, "margwaspawnstart" },
    { 0x6CED7DB8, "margwastopsmashfx" },
    { 0xE23BF4DE, "margwaswipeattackaction" },
    { 0x43D6F899, "margwaswipeattackactionupdate" },
    { 0xF8720744, "margwaswipeattackstart" },
    { 0xDC4154BD, "margwaswipeattackterminate" },
    { 0xD2A961FE, "margwatargetservice" },
    { 0xF4326D46, "margwateleportinstart" },
    { 0xD6861357, "margwateleportinterminate" },
    { 0xA3B5ED13, "margwateleportoutstart" },
    { 0x9BF18B02, "margwateleportoutterminate" },
    { 0xE9C9B15B, "margwatell" },
    { 0x201BC8E4, "margwatraveltellupdate" },
    { 0xDB1F89D2, "margwatraverseactionstart" },
    { 0x3133A8CB, "margwaupdatemovespeed" },
    { 0x11BA7521, "margwawait" },
    { 0xD5065A83, "marine" },
    { 0x1625A860, "marine1" },
    { 0x882D179B, "marine2" },
    { 0xD4320C6D, "marine4" },
    { 0xAE2F9204, "marine5" },
    { 0x83A5E91A, "marine_actor1" },
    { 0x5DA36EB1, "marine_actor2" },
    { 0xF737EBF4, "marine_rubble" },
    { 0x72C63DDB, "marine_search_party" },
    { 0x9260B3D2, "marine_trap_door" },
    { 0xCA1FEDA4, "marine_vic" },
    { 0x90029FF4, "marine_yell" },
    { 0xE18C02F2, "marines" },
    { 0x7ABAAF93, "mario" },
    { 0xF744DAEE, "mark" },
    { 0xB58EC5A3, "mark1" },
    { 0x43875668, "mark2" },
    { 0xD42D0A9F, "mark_ac_block" },
    { 0xE8CF7988, "mark_ai_for_death" },
    { 0xB5B1FA3F, "mark_as_target" },
    { 0x0BEE9E49, "mark_my_words" },
    { 0x08CF0229, "mark_nearby_enemies" },
    { 0xF02CB87B, "mark_past_nodes" },
    { 0x6B514DFB, "mark_piece_gibbed" },
    { 0x3BEE6032, "mark_sound" },
    { 0x4A8E5F4E, "mark_stop_idle" },
    { 0xB5BD9226, "mark_target" },
    { 0xBA802559, "mark_targets" },
    { 0x9E1C0058, "mark_targetted_enemies_as_targets" },
    { 0x42691232, "markasdirty" },
    { 0xD6B927F9, "markdestructibledestroyed" },
    { 0x3D7C2331, "marked" },
    { 0x04377AF2, "marked_for_death" },
    { 0x8C4C4AF7, "marked_for_insta_upgraded_death" },
    { 0x018290E3, "marked_for_recycle" },
    { 0xB1F09A66, "marked_targets" },
    { 0xD86832DD, "marked_zombies" },
    { 0x8482AC51, "markedplayers" },
    { 0x4648B525, "markenemyposinvisible" },
    { 0x81B2A837, "marker" },
    { 0xA04B535D, "marker_on" },
    { 0x9C395968, "marker_state_changed" },
    { 0x8C8E4DDA, "marker_toggle" },
    { 0x741E7779, "markercleanupthread" },
    { 0x0676DE71, "markerfx" },
    { 0x334B1B27, "markerfxhandle" },
    { 0x85F102C6, "markermodel" },
    { 0xDAAA34F6, "markerobj" },
    { 0x0334D143, "markerpos" },
    { 0x302ABE06, "markerposition" },
    { 0x2919A26E, "markers" },
    { 0xBE5B5ACC, "markerupdatethread" },
    { 0x9DA3C9C1, "market" },
    { 0xFBEAB42E, "market_2" },
    { 0x233CF56E, "market_ai" },
    { 0x32E398E0, "market_ai_setup" },
    { 0x017F3FA2, "market_anims" },
    { 0x426D2E55, "market_battle_flow" },
    { 0x08B740DA, "market_claw_targets_update" },
    { 0xA67C2EC2, "market_corpse_control" },
    { 0x930E376D, "market_dome_guy_callback" },
    { 0xA5C10953, "market_dome_guy_spawnfunc" },
    { 0xA8689313, "market_doors_explosion" },
    { 0x60E43906, "market_drone_ambush_drone" },
    { 0x3E7BA15D, "market_drone_logic" },
    { 0xE8183CF8, "market_drones_think" },
    { 0x8B80EC06, "market_enemy_force_goal" },
    { 0x24698A74, "market_exit" },
    { 0x42C82F58, "market_fake_missile_breaks_window" },
    { 0x0C2093CC, "market_fallback_01" },
    { 0xB38BA80A, "market_fallback_10" },
    { 0x33B70D5F, "market_fallback_20" },
    { 0x8C237FB5, "market_fallback_max" },
    { 0xB6B58AFB, "market_fallback_min" },
    { 0x58685858, "market_friendly_handler" },
    { 0x0908D02C, "market_fx_anim_setup" },
    { 0x1D0CC41E, "market_gump_cleanup" },
    { 0x0044E1EF, "market_heroes_shot" },
    { 0xAD22C49D, "market_position" },
    { 0xB57D08DA, "market_rolling_door" },
    { 0xC2F1C32D, "market_sm_func" },
    { 0x851F9EC4, "market_update_spawner_aigroup" },
    { 0x820CDBB2, "market_vehicle_in_place" },
    { 0x2D33B686, "market_vehicle_setup" },
    { 0xAED19B33, "market_vtol_crash" },
    { 0x7B9B0467, "market_vtol_crash_callback" },
    { 0x7117EE15, "market_vtol_crash_damage" },
    { 0xD10329BC, "market_vtol_crash_shake" },
    { 0x70A3A871, "market_vtol_exploder" },
    { 0xC7CC18CC, "market_wounded_anims_think" },
    { 0x5C3EE11F, "market_yemeni_spawner_think" },
    { 0x32742E12, "marking" },
    { 0xFE4B1CCF, "markm" },
    { 0x62AB685B, "marknovehiclenavmeshfaces" },
    { 0xEA286B11, "marks" },
    { 0x183D0073, "marksmen" },
    { 0x49D93898, "marlton" },
    { 0x17560B19, "marlton_bunker_trig" },
    { 0xABA9ED8F, "marlton_sound_pos" },
    { 0x36F95946, "marlton_vo" },
    { 0x7203331F, "marlton_vo_inside_bunker" },
    { 0x4B44DB15, "marriage" },
    { 0x396BA94F, "married" },
    { 0x5C92FB8B, "marshemellow" },
    { 0x2CF32159, "martial" },
    { 0xBEEE1480, "martian_weapon_owned" },
    { 0x77EF3AAC, "martyr" },
    { 0x301B5390, "martyrdom" },
    { 0xD40415A9, "martyrdom_go" },
    { 0xA0DD6FE6, "mas" },
    { 0x58B2A9EA, "mashers" },
    { 0x34664DF1, "masiclat" },
    { 0x6C5932D1, "mask" },
    { 0x5BDF784A, "mask1" },
    { 0x35DCFDE1, "mask2" },
    { 0x10073A9C, "mask_and_gun" },
    { 0x1095E921, "mask_crack_stage" },
    { 0xCED5847E, "mask_damage_snapshot_1" },
    { 0xA8D30A15, "mask_damage_snapshot_2" },
    { 0x82D08FAC, "mask_damage_snapshot_3" },
    { 0x704A1A8E, "mask_detached" },
    { 0x6C573DB6, "mask_on_snapshot" },
    { 0x3AFC13EF, "mask_smoke" },
    { 0x4B23C826, "mask_smoke_amount" },
    { 0xBD77DA5D, "mask_smoke_clear" },
    { 0x09FFFE7E, "masked" },
    { 0xD00643B8, "maskent" },
    { 0xB06D244F, "maskentid" },
    { 0x90791DB8, "masks" },
    { 0xD8C6D536, "masnion" },
    { 0x25572555, "maso_shit_gotta_hurt_0" },
    { 0xE8BB73E1, "mason" },
    { 0xD39B82B1, "mason2" },
    { 0xBBDAF561, "mason_animations" },
    { 0xE5B1778B, "mason_arrives_at_cctv_room" },
    { 0x0067EBE3, "mason_ba" },
    { 0xCE1DD8C5, "mason_bashes_door" },
    { 0xB859FEEE, "mason_binoculars" },
    { 0x0A8ED69C, "mason_bp2" },
    { 0x74CEF333, "mason_breach" },
    { 0x9C169A72, "mason_bridge_ambience" },
    { 0x7092DBBB, "mason_bridge_animations" },
    { 0x5C58E045, "mason_bunker_cokeworkers" },
    { 0x208478C3, "mason_bunker_fake_mortar" },
    { 0x4C8140D1, "mason_bunker_make_shotgunners_agressive" },
    { 0x35DA8A39, "mason_bunker_paperburners" },
    { 0xCE465EA6, "mason_bunker_point_of_no_return_cleanup" },
    { 0x98414E98, "mason_carrier" },
    { 0x7E9B0BCF, "mason_carry_button_pressed" },
    { 0x5710C2D0, "mason_carry_by_ai" },
    { 0x167A8B25, "mason_carry_crouch_button" },
    { 0xC64ED9A6, "mason_carry_crouch_speed" },
    { 0x682C8EA2, "mason_carry_woods" },
    { 0x755ECDAC, "mason_contextual_kill" },
    { 0xFF190722, "mason_courtyard_end_trigger" },
    { 0xA355FB80, "mason_courtyard_fight_complete" },
    { 0x46B54337, "mason_courtyard_splitup" },
    { 0x59E55759, "mason_damage_events" },
    { 0x39A77C62, "mason_damage_override" },
    { 0x8F92BBA6, "mason_dead" },
    { 0x5BF6C711, "mason_deals" },
    { 0xAC95CCFB, "mason_donkeykong" },
    { 0x66659B41, "mason_donkeykong_player_uses_turret" },
    { 0x54E86181, "mason_door_bash" },
    { 0x2C6E96E1, "mason_door_kick" },
    { 0x882D7F39, "mason_door_model_blocker" },
    { 0x4E80611C, "mason_door_model_blocker_open" },
    { 0x58B66832, "mason_drain" },
    { 0xFA57584A, "mason_elevator" },
    { 0x403E35E1, "mason_elevator_move_down" },
    { 0xA9E4ED53, "mason_entered_bunker" },
    { 0xDEFC8BEB, "mason_enters_control_room" },
    { 0x35BAB596, "mason_exits_server_terminal" },
    { 0xF3E72DA2, "mason_fail_condition" },
    { 0x5F029CD3, "mason_fail_kill" },
    { 0x921A2FC4, "mason_failed_to_find_cover_in_house" },
    { 0x4BBECDF6, "mason_final_push_point_of_no_return_cleanup" },
    { 0x52A86D65, "mason_final_push_setup" },
    { 0x0F818B60, "mason_fire" },
    { 0xF7942F3E, "mason_fire_damage_off" },
    { 0xBBE42182, "mason_front_gate_nag" },
    { 0x7B9E8AE4, "mason_gate_break_open" },
    { 0x67186CC8, "mason_hallway_started" },
    { 0x41C65BC8, "mason_hangar_ambience" },
    { 0xDD9865B4, "mason_hero" },
    { 0x527BFEE6, "mason_hill_blood_pool_deathfunction" },
    { 0x95999168, "mason_hill_blood_pool_deathfunction_setup" },
    { 0xC0307468, "mason_hill_blood_pools" },
    { 0xB20AE86F, "mason_hill_chicken_setup" },
    { 0x2191D137, "mason_hill_civilian_executions" },
    { 0xC75507BE, "mason_hill_civilians" },
    { 0xB94A1094, "mason_hill_cleanup" },
    { 0x4CE11C11, "mason_hill_end_infinite_sprint" },
    { 0xAEB9951A, "mason_hill_fire_deaths" },
    { 0xA17341F7, "mason_hill_first_molotov_building_on_fire" },
    { 0xE9FE0516, "mason_hill_first_wave" },
    { 0x5D6C3A93, "mason_hill_guy_on_fire_fx" },
    { 0x567A0502, "mason_hill_initial_building_fire" },
    { 0x303E6525, "mason_hill_initial_colorgroup" },
    { 0xD687E469, "mason_hill_initial_lookat_trigger_watcher" },
    { 0x3A96E15B, "mason_hill_initial_molotov_toss" },
    { 0x1FD4EF48, "mason_hill_kill_civs_with_magicbullets" },
    { 0x250FB9C3, "mason_hill_magic_grenade_scripted" },
    { 0x4EB7B549, "mason_hill_magic_grenades" },
    { 0x87106286, "mason_hill_mg_turrets_started" },
    { 0x6BDA0F38, "mason_hill_molotov_toss" },
    { 0xC9120FEB, "mason_hill_pdf_reinforcements" },
    { 0x4A532300, "mason_hill_river_height" },
    { 0xDE3FEFB3, "mason_hill_river_trigger" },
    { 0xDD52C992, "mason_hill_scripted_mg_kill_complete" },
    { 0x57C7688A, "mason_hill_second_building_fire" },
    { 0xE3FFC7C0, "mason_hill_second_wave" },
    { 0x26FFC6A7, "mason_hill_setup" },
    { 0xD51D3CD0, "mason_hill_spawn_molotov_toss_guy" },
    { 0xD2F01207, "mason_hill_stop_exploders" },
    { 0xCC66C9CE, "mason_hill_wave1_enemy_on_fire" },
    { 0x5344F8A2, "mason_hill_wave1_fire_window" },
    { 0xF5C1C220, "mason_hill_wave1_lasthouse_shotgunners" },
    { 0x59AFDF37, "mason_hill_wave1_mg_gunners_dead" },
    { 0x39E142D2, "mason_hill_wave1_mid_cleanup" },
    { 0x06595C87, "mason_hill_wave1_mid_spawnmanagers" },
    { 0x3238312D, "mason_hill_wave1_player_push_past_river" },
    { 0xA2F73D7F, "mason_hill_wave1_scripted_mg_kill" },
    { 0xC2CAD7BC, "mason_hill_wave1_start_cleanup" },
    { 0xB97B1BEE, "mason_hill_wave1_vo" },
    { 0x5509F930, "mason_hill_wave2_early_enemies_dieoff" },
    { 0xE44A0D8D, "mason_hill_wave2_enemy_on_fire" },
    { 0x0AD57756, "mason_hill_wave2_molotov_toss" },
    { 0x3D30B820, "mason_hill_wave2_molotov_toss_prep" },
    { 0xCC1DDE61, "mason_hill_wave2_mortar" },
    { 0xC69DDF59, "mason_hill_wave2_pdf_reinforcements" },
    { 0x4D1CADAE, "mason_hill_wave2_start" },
    { 0x53E372EB, "mason_hill_wave2_vo" },
    { 0x155EEFA0, "mason_hill_wave_mortars" },
    { 0x7537C97B, "mason_horse" },
    { 0x39FC2679, "mason_horse_return_bp2" },
    { 0x13F9AC10, "mason_horse_return_bp3" },
    { 0xEF3A172A, "mason_hummer" },
    { 0xF25E1BC4, "mason_in_snipertower" },
    { 0xD80B8DD8, "mason_index" },
    { 0x4AACD52F, "mason_int" },
    { 0xEA6DB437, "mason_interrogation_streamer_hint" },
    { 0x9AB3177A, "mason_intro" },
    { 0x347FA0D8, "mason_intro_animations" },
    { 0xF7A078F1, "mason_intro_anims" },
    { 0xF4F4E574, "mason_intro_cinematic" },
    { 0xE581DA9F, "mason_intro_cleanup" },
    { 0x74D4DC5E, "mason_intro_end_vo" },
    { 0x07EEE53A, "mason_intro_mortar" },
    { 0x71D6A0B5, "mason_intro_mortars" },
    { 0xCAD85D32, "mason_intro_move_pdf_down_hill" },
    { 0xA9E2C2B6, "mason_intro_rain_overlay" },
    { 0x000FDF7E, "mason_intro_rundown_vo" },
    { 0xE521751C, "mason_intro_setup" },
    { 0xF9214E2F, "mason_intro_window_view_complete" },
    { 0x0D20006D, "mason_intro_window_view_fade_out" },
    { 0x1D31B1E1, "mason_intro_window_view_fade_to_menendez" },
    { 0xB5F6D738, "mason_intruder_perk" },
    { 0x61E72CF0, "mason_is_camping" },
    { 0xD5B26B08, "mason_jump" },
    { 0x091BECFD, "mason_killspawners_bunker" },
    { 0xF38C9909, "mason_killspawners_donkeykong" },
    { 0xA3198F72, "mason_killspawners_finalpush" },
    { 0x2C7727BF, "mason_killspawners_hill" },
    { 0x37032514, "mason_killspawners_intro" },
    { 0x70B8DBDC, "mason_killspawners_mission" },
    { 0x2A9EEF2B, "mason_killspawners_outro" },
    { 0xC4A9E327, "mason_killspawners_truck" },
    { 0xCB221862, "mason_knife_blood" },
    { 0xC01ED5A2, "mason_knife_weapon" },
    { 0x05BB704B, "mason_lab_chair" },
    { 0x8BEDBAC0, "mason_lab_clean_ents" },
    { 0x1FDE24B6, "mason_lab_extra" },
    { 0xB4CB5A5A, "mason_lab_flash_guy" },
    { 0x3F597A60, "mason_lab_flash_guy_spawnfunc" },
    { 0xED17A839, "mason_lab_hudson_vo" },
    { 0x0AC9E18B, "mason_lab_obj" },
    { 0x4355F354, "mason_lab_objectives" },
    { 0x0F3A2823, "mason_lab_save" },
    { 0xE31BE5AA, "mason_lab_steiner" },
    { 0xEDBA42D0, "mason_lab_steiner_spawnfunc" },
    { 0x6E5C1D16, "mason_lookat" },
    { 0xEEF14337, "mason_mcknight_wait_at_gate" },
    { 0xB131F0F1, "mason_meatshield_weapon" },
    { 0x0802008F, "mason_mission_bruteforce_perk" },
    { 0x7746E2DB, "mason_mission_cleanup" },
    { 0x588080B4, "mason_mission_complete" },
    { 0x413B5D6A, "mason_mission_courtyard" },
    { 0xCB4D01DB, "mason_mission_lockbreaker_perk" },
    { 0x6332A710, "mason_mission_main_vo" },
    { 0x977636D9, "mason_mission_precourtyard" },
    { 0x62B63008, "mason_mission_rpg_vo" },
    { 0x866D8170, "mason_mission_setup" },
    { 0xEF84E638, "mason_mission_sniper_tower_vo" },
    { 0x51BB0A14, "mason_mission_vo" },
    { 0xF6D5CF9B, "mason_model" },
    { 0x170FCB78, "mason_molotov_kills" },
    { 0x3CD3DB25, "mason_mortar_kills" },
    { 0x20009AD3, "mason_movement" },
    { 0x4CE4038D, "mason_movement_on_beach" },
    { 0x5FA06FF8, "mason_movement_rotation" },
    { 0x8D5B2D5F, "mason_movement_translation" },
    { 0xB0587A48, "mason_near_courtyard_gate" },
    { 0x82C34A9C, "mason_no_snipe_fail" },
    { 0x683A5F38, "mason_node" },
    { 0xDD251393, "mason_nodes" },
    { 0xC16DF0E3, "mason_non_fatal_blood" },
    { 0x69D33AF7, "mason_noreiga_wall_hug" },
    { 0xD70F9C02, "mason_not_on_my_watch" },
    { 0x245BC0CC, "mason_nvec" },
    { 0x00CA325B, "mason_objectives_hide" },
    { 0x94165AF8, "mason_objectives_show" },
    { 0x72D409D0, "mason_out" },
    { 0x447AD871, "mason_outro" },
    { 0xEDCD1250, "mason_outro_cleanup" },
    { 0x467B845D, "mason_outro_heli_endspline" },
    { 0xC2C65B6B, "mason_outro_heli_fadeout" },
    { 0x122300C7, "mason_outro_helicopter" },
    { 0x92F17400, "mason_outro_white_screen_vo" },
    { 0x6BF0E3DB, "mason_part_1_animations" },
    { 0x644B9BA6, "mason_part_2_animations" },
    { 0xCFDA8101, "mason_pistol" },
    { 0x75CE5160, "mason_point_of_no_return_cleanup" },
    { 0xA8E56B22, "mason_pos" },
    { 0xDD5E7B8C, "mason_prisoner" },
    { 0x7D95AF87, "mason_prisoner_weapon" },
    { 0xC7B2200C, "mason_protect_dist" },
    { 0x16D34D3B, "mason_protect_ent" },
    { 0x0F280A1D, "mason_protect_nag1_time" },
    { 0xFCF6CB78, "mason_protect_nag2_time" },
    { 0x8C588F73, "mason_protect_nag3_time" },
    { 0xBD698AF0, "mason_protect_nag_end" },
    { 0xA9434BDF, "mason_protect_nag_think" },
    { 0xF55ECB5C, "mason_punch_player" },
    { 0xA4E4F879, "mason_ready_to_enter_hud_window" },
    { 0x1DC88462, "mason_run_to_log_cover" },
    { 0xCE19F096, "mason_said_to_get_over_here" },
    { 0x9E3C3FB2, "mason_salazar_exit_ambience" },
    { 0x16AFD17F, "mason_shadow_body" },
    { 0xB5995FE9, "mason_shadow_head" },
    { 0x485C8CAC, "mason_shadow_head_hide" },
    { 0xDD0603C7, "mason_shadow_head_show" },
    { 0xD9AC883B, "mason_shadow_rig" },
    { 0x4B874506, "mason_shattered_parttwo" },
    { 0x288435A4, "mason_shot" },
    { 0xFBA8A87F, "mason_sniper_tower_vo" },
    { 0x8FB6DC0E, "mason_spit" },
    { 0x4519E75C, "mason_split_up" },
    { 0x75E65749, "mason_stealth_checkpoints" },
    { 0xFB0BD87C, "mason_stealth_fog" },
    { 0xAF5F7FAC, "mason_stealth_objective_visibility" },
    { 0x93D27574, "mason_stealth_objectives" },
    { 0xD3D6EB19, "mason_stealth_water" },
    { 0x0E469835, "mason_transition" },
    { 0x59A6EE5D, "mason_trigs" },
    { 0x68A2D595, "mason_truck" },
    { 0xC194B490, "mason_truck_add_occupants" },
    { 0xD0CF21F7, "mason_truck_begin" },
    { 0x481A8796, "mason_truck_check_for_enemies_dead" },
    { 0x9B44884C, "mason_truck_cleanup" },
    { 0x867F0E4D, "mason_truck_colorgroups" },
    { 0x9D0A37B8, "mason_truck_combat" },
    { 0x02CD6BCD, "mason_truck_complete" },
    { 0xD01B6369, "mason_truck_crash_vo" },
    { 0x0F78C44E, "mason_truck_crashed" },
    { 0xC2F8097E, "mason_truck_damage_override" },
    { 0xC45C8A71, "mason_truck_decision_point" },
    { 0xF6865152, "mason_truck_driver" },
    { 0xA70914E7, "mason_truck_end" },
    { 0xD1015F69, "mason_truck_end_failsafe" },
    { 0x4D923DF9, "mason_truck_gunner" },
    { 0x6B287271, "mason_truck_move_up_vo" },
    { 0x31A90400, "mason_truck_passenger" },
    { 0xC3AF8376, "mason_truck_passengers_getout" },
    { 0x1E416F2F, "mason_truck_player_uses_turret" },
    { 0xE08D899F, "mason_truck_setup" },
    { 0x42465AF4, "mason_truck_shoots" },
    { 0x1BB382AB, "mason_truck_turnout" },
    { 0x287F5175, "mason_truck_turnout_explode" },
    { 0xCD96FB4B, "mason_truck_turnout_vo" },
    { 0xBED98B2D, "mason_truck_vo" },
    { 0x85BD3302, "mason_vec" },
    { 0xA8BF242C, "mason_victim" },
    { 0xC415C846, "mason_viewarms" },
    { 0xB73FFB5F, "mason_viewbody" },
    { 0x34D61C1B, "mason_viewhands" },
    { 0x5D39D2E9, "mason_vo" },
    { 0x3A7BB08E, "mason_vo_stairs" },
    { 0x700413C3, "mason_waiting_for_player_vo" },
    { 0x2F130833, "mason_wakeup" },
    { 0xDFCB1F20, "mason_woods_backbreaker" },
    { 0xA8944162, "mason_woods_freakout" },
    { 0x06048754, "mason_woods_freakout_begin" },
    { 0x74611ADD, "mason_woods_freakout_objectives" },
    { 0x8F9E42D8, "mason_woods_freakout_precleanup" },
    { 0x0CAFA3D4, "mason_woods_freakout_setup" },
    { 0xA67A5A04, "mason_woods_goto_jungle_fight1_anim" },
    { 0xB552FDBD, "mason_woods_goto_jungle_fight2_anim" },
    { 0x1A449E72, "mason_woods_goto_jungle_fight3_anim" },
    { 0xCA6DA102, "masonintrosnapandloop" },
    { 0xD4C1C2D9, "masonjr" },
    { 0x32765B8A, "masonjr_gun" },
    { 0x3128D2CE, "masonroom_challenge" },
    { 0x2E37A288, "masons" },
    { 0x33FB933D, "masons_personal_effects_found" },
    { 0x7522DD3A, "masonsr" },
    { 0x9C6D0619, "mass" },
    { 0x7A1CA402, "massacre" },
    { 0x20090DF6, "massage_string" },
    { 0xD1B52446, "massed" },
    { 0xB38119A9, "masses" },
    { 0x866836AD, "massiah" },
    { 0x91A77BAF, "massing" },
    { 0xCF0B86C5, "massive" },
    { 0xBFC9C9B2, "massnodeinitfunctions" },
    { 0x5A796A26, "mast" },
    { 0x417BCA5F, "mast01" },
    { 0x1ADAECAC, "mast01_hits_deck" },
    { 0xCF745B24, "mast02" },
    { 0x01C99653, "mast02_hits_deck" },
    { 0xAE2F4AAF, "master" },
    { 0x0D9839CB, "master_base_control" },
    { 0x2A1BA20E, "master_electric_switch" },
    { 0xB8C247DE, "master_key_door_opened" },
    { 0x9DF4F7C2, "master_key_door_trigger_thread" },
    { 0xADAE907C, "master_key_pulley_" },
    { 0x0AD6D557, "master_recording" },
    { 0x535AFAD2, "master_switch" },
    { 0xE60E72D2, "master_switch_activated" },
    { 0x881594B2, "master_trigger" },
    { 0x86F395B4, "mastergroup" },
    { 0x3EBBABC2, "masterhud" },
    { 0xB79AF994, "masterkey" },
    { 0xC6BE0D7E, "masterreverbroomtype" },
    { 0x4C6E5C6C, "mastery" },
    { 0x46F92978, "mastery_perk_2" },
    { 0x0E352D59, "masts" },
    { 0xE2D10BD9, "mat" },
    { 0x1F83184F, "matach" },
    { 0x78048D5A, "matal" },
    { 0x12DFAAA8, "match" },
    { 0xCAA20D55, "match_attach_tag" },
    { 0x78FDE7BE, "match_end" },
    { 0x85541057, "match_end_func" },
    { 0xBE4EC03E, "match_end_notify" },
    { 0x7B0712A1, "match_ending_pretty_soon" },
    { 0xA0446B30, "match_ending_soon" },
    { 0x825D3371, "match_ending_very_soon" },
    { 0x9D59B680, "match_ending_vox" },
    { 0x797A6439, "match_finished" },
    { 0x29963420, "match_flame" },
    { 0x246830F7, "match_hide" },
    { 0x39A98F8D, "match_ignite" },
    { 0x7271F827, "match_is_ending" },
    { 0x1C4B591A, "match_kicked" },
    { 0x1B7638A2, "match_lit" },
    { 0x15165FB2, "match_name" },
    { 0x2E8229FD, "match_origin" },
    { 0x26F59D88, "match_player_speed" },
    { 0xAA7B5AED, "match_player_zone" },
    { 0x19236CD9, "match_pool" },
    { 0xC6D6FDA2, "match_quit" },
    { 0x691A8214, "match_show" },
    { 0x6B35D0A2, "match_start_func" },
    { 0x22676015, "match_start_msg_hud" },
    { 0xB9D23EAF, "match_start_timer_beginning" },
    { 0xBDE1F0C8, "match_string" },
    { 0x90FB1718, "match_string_plus_space" },
    { 0x0DA8550D, "matchbonus" },
    { 0x684176EE, "matchdraw" },
    { 0xD8C127BB, "matched" },
    { 0x1457DE2F, "matchedweapon" },
    { 0x92F5E72C, "matchendutctime" },
    { 0x5EEB48B4, "matches" },
    { 0x88026FA1, "matches_me" },
    { 0x6D3C4B65, "matchesplayed" },
    { 0x8AB40C94, "matcheswon" },
    { 0x057F6B70, "matching" },
    { 0x676F6043, "matchlose" },
    { 0xD10AAB9F, "matchmaking" },
    { 0x98857581, "matchname" },
    { 0x8E5B7D6F, "matchrecorddeath" },
    { 0xEA498744, "matchrecorderincrementheaderstat" },
    { 0x887E3A53, "matchrecorderkillstreakkills" },
    { 0x9B5C7A8F, "matchrecordgetweaponindex" },
    { 0x077F280E, "matchrecordlogadditionaldeathinfo" },
    { 0x5B34EFB3, "matchrecordlogchallengecomplete" },
    { 0x8DA990C2, "matchrecordlogspecialmovedataforlife" },
    { 0xD6E665CC, "matchrecordnewplayer" },
    { 0x3CD6B78A, "matchrecordovertimeround" },
    { 0xA1AD0D00, "matchrecordroundend" },
    { 0xCA9ED7D3, "matchrecordroundstart" },
    { 0xB0C6F02D, "matchrecordsetleveldifficultyforindex" },
    { 0x05706656, "matchrules_damagemultiplier" },
    { 0x5B4ABA3A, "matchrules_enemyflagradar" },
    { 0xB87CC52E, "matchrules_vampirism" },
    { 0xEA08959E, "matchstartblacscreen" },
    { 0xA2CEAF69, "matchstarttext" },
    { 0x2A5AFB0F, "matchstarttimer" },
    { 0xA9EB0409, "matchstarttimer_internal" },
    { 0x2A3BFC4E, "matchstarttimerconsole" },
    { 0xB4083D02, "matchstarttimerconsole_internal" },
    { 0xBA0BF416, "matchstarttimerskip" },
    { 0xD9D034D0, "matchtype" },
    { 0x8660F225, "matchutctime" },
    { 0xD3695582, "matchwin" },
    { 0x3765D8A3, "matchwonteam" },
    { 0x192F2E76, "mate" },
    { 0x2E2BA100, "mater" },
    { 0xED9416C2, "material" },
    { 0xA002E710, "material_name" },
    { 0xC6E7AD8D, "material_test" },
    { 0x4559A451, "materialid" },
    { 0x74F0D8CF, "materialism" },
    { 0x75FB4B4F, "materialname" },
    { 0xFB07CB0D, "materials" },
    { 0x59E46583, "materialtrigs" },
    { 0x542E1B69, "mates" },
    { 0xD73B9283, "math" },
    { 0x1584EA0D, "math_shared" },
    { 0xC526DD60, "mathmagic" },
    { 0x656483D1, "mathx" },
    { 0x3F620968, "mathy" },
    { 0xD3C64994, "matid_overlay_rccarcam" },
    { 0x873AC080, "matress" },
    { 0xAF7BEB56, "matrix" },
    { 0x89A5BABA, "matrix4x4" },
    { 0xFF9D3C51, "matrix4x4_build_from_rotation_and_translation" },
    { 0x7AB7B0F8, "matrix4x4_build_identity" },
    { 0x60DC973D, "matrix4x4_build_rotation_from_axes" },
    { 0xD7E7C0B7, "matrix4x4_build_rotation_from_axis_and_angle" },
    { 0x81410841, "matrix4x4_build_rotation_from_forward_and_up" },
    { 0x76CF2878, "matrix4x4_build_scale" },
    { 0xEB43F407, "matrix4x4_build_translation" },
    { 0xED2ED041, "matrix4x4_multiply" },
    { 0xC3F9E035, "matrix4x4_transform_point3d" },
    { 0xCD3A74FA, "matrix4x4_transform_points3d" },
    { 0x6A025F56, "matrix4x4_transform_vector3d" },
    { 0xC599A193, "matrix4x4transformpoints" },
    { 0xBC1EA746, "matrix_a" },
    { 0x961C2CDD, "matrix_b" },
    { 0x519ECA52, "matter" },
    { 0xC96CF85D, "matters" },
    { 0xB8A70436, "mattesenabled" },
    { 0x39C44E3B, "mattress_jump_clark" },
    { 0xB02D138C, "mattress_jump_weaver" },
    { 0x7EC0EF9D, "mature" },
    { 0x822AE349, "mature_settings_changes" },
    { 0x4FF15BC9, "maturegib" },
    { 0xB8D37F71, "maturemask" },
    { 0xCBE444FF, "mauled" },
    { 0x773E7BC5, "maverick" },
    { 0x8853158B, "mavis" },
    { 0x97C0E589, "mavnesh" },
    { 0xAAEEC8C5, "max" },
    { 0x90807D51, "max_a" },
    { 0x8A2C3340, "max_accel" },
    { 0x18EB9CDC, "max_activation_time" },
    { 0xF5DEF6ED, "max_active_arty" },
    { 0x8933E7A6, "max_active_events" },
    { 0xD8537545, "max_additional_time" },
    { 0xB61CE032, "max_ai" },
    { 0x441385BB, "max_ai_num" },
    { 0x038C499A, "max_ai_spawn" },
    { 0x9E5B0054, "max_ai_spawn_current" },
    { 0xDFD8BA72, "max_allocation" },
    { 0x7393AD15, "max_allowed_missed_frames" },
    { 0x42B87924, "max_alpha" },
    { 0x7153F88F, "max_ambient_anim_groups" },
    { 0xC6F5F1D2, "max_ammo" },
    { 0x8D78CDDD, "max_ammo_on_change" },
    { 0x048FB627, "max_ammo_on_legit_sniper_escape_weapon" },
    { 0xD5142ADC, "max_amount" },
    { 0x1C23C371, "max_angle" },
    { 0x20175A37, "max_angle_left" },
    { 0x8C49EE9F, "max_angle_per_interval" },
    { 0x4DF42172, "max_angle_right" },
    { 0x8FA133AC, "max_angluar_vel" },
    { 0xA9B98BB6, "max_anim_length" },
    { 0xB8832979, "max_anim_playback" },
    { 0x4C487828, "max_ape_zombies" },
    { 0x93B5E5B3, "max_arcs" },
    { 0xCAA82D0D, "max_armor_points" },
    { 0xD5F518B8, "max_astro_round_wait" },
    { 0xDFD7BFE1, "max_astro_zombies" },
    { 0x4F1E5A96, "max_attachments" },
    { 0x67ADF3D8, "max_attack_time" },
    { 0x30266E50, "max_attackers" },
    { 0x155ADD32, "max_attempts" },
    { 0x7A6CE3D2, "max_attract_dist" },
    { 0xEBA7F373, "max_attractor_dist" },
    { 0x1002D56A, "max_auto_turrets_active" },
    { 0xE6E94A0B, "max_axis" },
    { 0xB682F7BA, "max_b" },
    { 0x815F3EA6, "max_barrier_search_dist_override" },
    { 0x9F27CE0C, "max_base_health" },
    { 0x90A6045A, "max_bike_aim_angle_delta" },
    { 0x9563802A, "max_bike_aim_pitch_angle" },
    { 0xCF2BD351, "max_bike_aim_yaw_angle" },
    { 0x7038B3D3, "max_bike_roll_angle" },
    { 0x836BCD3B, "max_bike_side_yaw_angle" },
    { 0xF6FC73B8, "max_bike_total_yaw_angle" },
    { 0x61C063C3, "max_blur" },
    { 0x6F2FAC05, "max_blurring" },
    { 0xAE260EBC, "max_breadcrumb_ents" },
    { 0xDA1B9C4F, "max_breadcrumb_points" },
    { 0xCF21261A, "max_burst" },
    { 0x2FE8031E, "max_burst_time" },
    { 0x5872B404, "max_button_presses" },
    { 0x26B32CD4, "max_cam_move_scale" },
    { 0x9807FB5D, "max_cars" },
    { 0xE15FBA65, "max_chance_at_round" },
    { 0x8B930408, "max_charge_time" },
    { 0x5095DCCC, "max_claim" },
    { 0x9739DF02, "max_client_objective_ids" },
    { 0x2B1417D4, "max_clients_zm" },
    { 0xC6268370, "max_close_time" },
    { 0x1BC3475D, "max_color_count" },
    { 0xAE915CE0, "max_contract_slots" },
    { 0x4D802545, "max_count" },
    { 0xF72BFF71, "max_crumb" },
    { 0x38756ED8, "max_crumbs" },
    { 0xE261F37D, "max_cutoff_time" },
    { 0xFCFA8F0B, "max_damage" },
    { 0x280FD5DD, "max_damage_range" },
    { 0x95FEFA45, "max_damage_state" },
    { 0x2F16539F, "max_damage_taken" },
    { 0x5C5BAA69, "max_dead_bodies" },
    { 0x9ADDBB44, "max_dead_drones" },
    { 0xCCDDBCCE, "max_death_scenes" },
    { 0xE91B3285, "max_delay" },
    { 0x5FF9B16F, "max_delta_t" },
    { 0xB963ECD3, "max_depthdist" },
    { 0x82F7A10D, "max_dev" },
    { 0x8EB3F7AF, "max_dev_per_frame" },
    { 0xA8FF2471, "max_difficulty_report_index" },
    { 0xF6C0DA04, "max_director_zombies" },
    { 0xFAB2060A, "max_display_reminders" },
    { 0x027DD898, "max_dist" },
    { 0x95D150AA, "max_dist_behind_node" },
    { 0x96BFDACB, "max_dist_from_hudson" },
    { 0xCB2524BF, "max_dist_from_location" },
    { 0x1E6D61BB, "max_dist_sq" },
    { 0x2CE017E2, "max_dist_squared" },
    { 0xA9653199, "max_distance" },
    { 0xD485A4C4, "max_distance_for_flyby" },
    { 0xD2268B6F, "max_distance_squared" },
    { 0xFCE5B796, "max_distance_to_shoot_sq" },
    { 0x362E364C, "max_dmg" },
    { 0xAADCDCE9, "max_dmg_states" },
    { 0x723D36F9, "max_dogs" },
    { 0x87D015E3, "max_doors" },
    { 0x453CCB4D, "max_dot" },
    { 0xB1F2E459, "max_drone_mortars" },
    { 0x03F59FF1, "max_drones" },
    { 0x0D219E93, "max_drones_per_frame" },
    { 0x2C1A9668, "max_duration" },
    { 0xCA9F8318, "max_enemies_killed" },
    { 0x8066A596, "max_eq" },
    { 0xB8F2C2F1, "max_equipment_attack_range" },
    { 0x04639D17, "max_escaped_zombies" },
    { 0x3227B8CC, "max_exposed_time" },
    { 0x93A11207, "max_exposure" },
    { 0x8C0F95D2, "max_exposure_flicker" },
    { 0x209A02F2, "max_extra_score_dist2" },
    { 0x0D2E38F2, "max_face_dist" },
    { 0x0D78E60E, "max_face_distsq" },
    { 0x37A67044, "max_facing_angle_degrees" },
    { 0x85BFAE40, "max_fail_time" },
    { 0xE5694D17, "max_fall_speed" },
    { 0xCC08E38A, "max_fallbackers" },
    { 0x0B5F6B12, "max_fighters" },
    { 0xDA4FF2DB, "max_fill" },
    { 0xDE5A091B, "max_fill_lantern_watcher" },
    { 0x9C2D4A14, "max_filter_intensity" },
    { 0x4DF37CBB, "max_filter_intensity_celerium" },
    { 0x404B8A90, "max_fire_time" },
    { 0x44511742, "max_fireballs" },
    { 0xDACCAF07, "max_fires" },
    { 0xBF35BEB8, "max_flag_target_height" },
    { 0x345C4A1C, "max_flag_target_points" },
    { 0x9573BC8B, "max_flash_alpha" },
    { 0x0844221F, "max_flash_grenade_throw_distsq" },
    { 0x70157D32, "max_flash_time" },
    { 0xAFF62CE4, "max_flicker_delay" },
    { 0x57C64235, "max_flickerless_time" },
    { 0xD6EEBF82, "max_fog_opacity" },
    { 0xAA743861, "max_force" },
    { 0x567ECE2F, "max_forward" },
    { 0xAF81DAFB, "max_forward_launch" },
    { 0x3C60ACD1, "max_fov" },
    { 0x679C9D95, "max_fov_speed" },
    { 0x6C195805, "max_friendly" },
    { 0xDAD64F9D, "max_frustration" },
    { 0x4BEEAD24, "max_goal_dist" },
    { 0xF160F5F5, "max_goal_dist_away" },
    { 0x82CFC5BD, "max_goal_height" },
    { 0x5509BE84, "max_grenade_animscripted_time" },
    { 0xBC630482, "max_grenade_team_time" },
    { 0x187E160D, "max_grenade_throw_dist_sq" },
    { 0xC5A7C09A, "max_grenade_throw_distsq" },
    { 0xE5CDD87D, "max_grenade_throw_time" },
    { 0xE5390257, "max_group_tanks" },
    { 0x2E340460, "max_gunners" },
    { 0x2C4ED2A8, "max_gunners_killed" },
    { 0x19A47E6E, "max_head_gibs_per_frame" },
    { 0x43703E7A, "max_health" },
    { 0xA6ADDFFE, "max_health_wait" },
    { 0xFB9F4D29, "max_height" },
    { 0x51E44236, "max_height_delta" },
    { 0xFCD847A6, "max_helo_speed" },
    { 0x7831DA4E, "max_hit_distance_sq" },
    { 0x1B885DA8, "max_horizontal" },
    { 0x51BEC3C3, "max_horse_active_dist" },
    { 0x96E8C78F, "max_horse_active_distsq" },
    { 0xF2EC484A, "max_horse_aim_angle_delta" },
    { 0x335C873A, "max_horse_aim_pitch_angle" },
    { 0xAA52E621, "max_horse_aim_yaw_angle" },
    { 0x2DF9BC4B, "max_horse_side_yaw_angle" },
    { 0xDF709648, "max_horse_total_yaw_angle" },
    { 0xB462B810, "max_hp" },
    { 0x91CB51AD, "max_hunters" },
    { 0xB7E903E5, "max_idle_ticks" },
    { 0xD842417B, "max_idle_time_millis" },
    { 0xACB986EA, "max_impulse_v" },
    { 0xEB2CF169, "max_inactive_time" },
    { 0x6E4B3DCC, "max_index" },
    { 0xCBBC4341, "max_inf_active_dist" },
    { 0x71BDC431, "max_inf_active_distsq" },
    { 0x1F11A800, "max_instances" },
    { 0x5ED2B7EB, "max_intensity" },
    { 0x60475AC3, "max_interval" },
    { 0x48983798, "max_intro_cam_aim_vel" },
    { 0xF83BD20C, "max_kill_count" },
    { 0xAB4A6FDC, "max_kill_time" },
    { 0xAAB1AC7E, "max_kills_with_one_shot" },
    { 0xC22BD5D0, "max_lag" },
    { 0x89D6FC83, "max_lantern_zombie_death_watcher" },
    { 0x9F1CF6E5, "max_launch_angle" },
    { 0x68722D53, "max_leave_time" },
    { 0x03C6F01C, "max_length" },
    { 0xB4205F25, "max_lightfx_groups" },
    { 0x24BC5C10, "max_local_clients" },
    { 0x6B90412A, "max_local_players" },
    { 0x01FF3B22, "max_loop" },
    { 0x018DDCED, "max_loops" },
    { 0x01DCBCF8, "max_lower_fx" },
    { 0x59059625, "max_market_ai" },
    { 0xEC12CB02, "max_melee_damage_from_behind" },
    { 0x1DDF33B1, "max_melee_player_attackers" },
    { 0xA73FC83F, "max_metalstorms" },
    { 0x698EBE0E, "max_miss_distance" },
    { 0x9CBC463B, "max_missiles" },
    { 0x53F54656, "max_models" },
    { 0xC52153BE, "max_momentum" },
    { 0xCBA964D2, "max_monkeys" },
    { 0x2DA6C846, "max_move_dist" },
    { 0xB33F719F, "max_move_distance" },
    { 0x90EE5227, "max_movement" },
    { 0x601CCD71, "max_nag_per_swing" },
    { 0x2A1F1091, "max_nearby_friendlies" },
    { 0xFF0F69C1, "max_node_ai" },
    { 0xB4B6D150, "max_node_wait_time" },
    { 0x30E2AD48, "max_num" },
    { 0xEED8F5AF, "max_num_beartraps" },
    { 0x0CB5079C, "max_num_fading" },
    { 0xD3066185, "max_num_quads" },
    { 0x4AAFCF41, "max_num_removed" },
    { 0x1FC548BD, "max_number_of_dead_bodies" },
    { 0x6309C63A, "max_obj_arty" },
    { 0x165D1AA2, "max_objective_ids" },
    { 0x1CAEA2CB, "max_occupy_no_target_time" },
    { 0x06F21742, "max_ocean_speed" },
    { 0x5F58E301, "max_offset" },
    { 0x34E933D5, "max_offset_angle" },
    { 0xDC2B4672, "max_online_players" },
    { 0x017E7B4A, "max_online_players_per_team" },
    { 0xC9730F9A, "max_outro_ai" },
    { 0xA1609E3D, "max_packobjects" },
    { 0x808918AD, "max_panzerschreck_eng_distsq" },
    { 0xF08CFC3B, "max_param_count" },
    { 0x24043BF9, "max_passenger_index" },
    { 0x99F90368, "max_path_fail_count" },
    { 0x0F96EBEB, "max_patrol_routes" },
    { 0x2BE5E057, "max_per_frame" },
    { 0xC791689B, "max_percent" },
    { 0xEE65459E, "max_perk_slots" },
    { 0xA854D307, "max_perks" },
    { 0x2206F215, "max_pipe_fx" },
    { 0x9099572A, "max_pitch" },
    { 0x7D1CF43E, "max_players" },
    { 0xD3D6B124, "max_poi_infantry" },
    { 0x2C773448, "max_positions" },
    { 0x56274985, "max_power_hud" },
    { 0xF4B26439, "max_power_value" },
    { 0xF6316340, "max_projectile_weaponobjects" },
    { 0x5D47EC79, "max_pts_shooting" },
    { 0x5E3D9A47, "max_push_dist" },
    { 0x56F6D37E, "max_push_side_vel" },
    { 0x62A93B84, "max_push_vel" },
    { 0x53576845, "max_pzrsk_dist" },
    { 0xCBEFF69A, "max_radius" },
    { 0x4B38E814, "max_radius_min_static" },
    { 0x2D848270, "max_ragdolls" },
    { 0xB5657B07, "max_range" },
    { 0xB67B87B3, "max_rangesq" },
    { 0x0F97F8FE, "max_rate" },
    { 0xC2DACF9F, "max_reaction_dist_sq" },
    { 0xA59D3649, "max_recalc_pos_time" },
    { 0x8058A38E, "max_recursion_depth" },
    { 0xC0BC0144, "max_respawn_delay" },
    { 0xDA45C7A0, "max_respawn_time" },
    { 0xB4E80251, "max_river_heli_speed" },
    { 0xB0C320F3, "max_rot_vel" },
    { 0xEE76EC0F, "max_run_n_gun_angle" },
    { 0x6755BE5E, "max_safety_wait" },
    { 0x97664B21, "max_sam_hud_strength" },
    { 0x192262EE, "max_score" },
    { 0x3148757F, "max_screen_fx_range" },
    { 0x2DF79022, "max_search_locs" },
    { 0x9CC83755, "max_self_destruct_time" },
    { 0x528F6A39, "max_self_duration" },
    { 0x5229BCF8, "max_set" },
    { 0x40D136CF, "max_simultaneous_lockons" },
    { 0x3E428ABE, "max_slow_dist" },
    { 0x8D8DBA76, "max_sniper_burst_delay_time" },
    { 0x8E7446C1, "max_solo_lives" },
    { 0xFF26B3F5, "max_spawn_count" },
    { 0x6FCFCD4B, "max_spawn_wait" },
    { 0x001617EC, "max_spawned_per_frame" },
    { 0x9FEBDB24, "max_spawns" },
    { 0xAC9C33D9, "max_speed" },
    { 0x82590101, "max_speed_mph" },
    { 0xD18B074E, "max_speed_pitch" },
    { 0xE9D0865F, "max_speed_vol" },
    { 0x502F4D6F, "max_speed_vtol" },
    { 0x68C4CCCE, "max_speed_vtol_dogfight" },
    { 0xD451A2EC, "max_speed_x" },
    { 0xFA541D55, "max_speed_y" },
    { 0x205697BE, "max_speed_z" },
    { 0x3F2AE47C, "max_sprint_speed" },
    { 0xAAA75D68, "max_start_dev" },
    { 0x5B5A1B98, "max_start_time" },
    { 0x1FB95030, "max_static_value" },
    { 0x28F26B95, "max_strafe_steps" },
    { 0x21095E85, "max_strafe_vel" },
    { 0xCCF0A6B3, "max_struct" },
    { 0x1C60BD09, "max_target_rating" },
    { 0x495C8212, "max_targets" },
    { 0xD9F512FB, "max_territory_index" },
    { 0x57933145, "max_thief_health" },
    { 0x07E70E20, "max_thief_portals" },
    { 0x2C8A23B4, "max_thief_zombies" },
    { 0x2E0C78E8, "max_threat" },
    { 0x13DAF36C, "max_threat_bias" },
    { 0xE066CC51, "max_threshold" },
    { 0x48006B13, "max_time" },
    { 0xD1E7A40A, "max_time_before_shift" },
    { 0x7EF6A625, "max_time_between_waves" },
    { 0x0E4D5282, "max_time_till_fullspeed" },
    { 0x31A05D4C, "max_time_to_fire" },
    { 0x15A968EE, "max_time_to_report" },
    { 0x58C311AB, "max_timer" },
    { 0xD527C916, "max_total" },
    { 0x04247A53, "max_total_health" },
    { 0xD8CD35D3, "max_trail_iterations" },
    { 0x3E9229F2, "max_trait_value" },
    { 0x153AE8B7, "max_tries" },
    { 0x2426C06D, "max_turn_dot" },
    { 0x474516C9, "max_turret_burst" },
    { 0x1782C8A6, "max_turret_engage_dist_sq" },
    { 0xDB8FFCFA, "max_turret_wait" },
    { 0xEE5CC819, "max_turrets" },
    { 0x1822DBAB, "max_twitch_time" },
    { 0x2FD931C1, "max_unique_perk_machines" },
    { 0xF2ED6233, "max_up_speed" },
    { 0x25F9408D, "max_usage" },
    { 0x94544298, "max_use_index" },
    { 0x0F9B33BD, "max_vehicle_health" },
    { 0xB8BC940E, "max_vehicle_spawn_current" },
    { 0xFEB82343, "max_vehicles" },
    { 0xDCA844E9, "max_vel" },
    { 0x947D40A3, "max_view_angle" },
    { 0xB465E3C9, "max_voices" },
    { 0x68E2787B, "max_vol" },
    { 0xAB0F8C99, "max_vox_id" },
    { 0x04D69B7B, "max_wait" },
    { 0xCD37EFD2, "max_wait_distance_sq" },
    { 0xDC95B015, "max_wait_seconds" },
    { 0x85AC4769, "max_wait_time" },
    { 0x47C38C35, "max_weapon_num" },
    { 0x635B33C7, "max_weapons" },
    { 0xC2621E6D, "max_wetness" },
    { 0xD4C2AC5B, "max_wingsuit_accel" },
    { 0xABF3FF07, "max_wingsuit_x" },
    { 0x43BA493D, "max_wins" },
    { 0x9A91D630, "max_x" },
    { 0x52991556, "max_x_offset" },
    { 0xC0945099, "max_y" },
    { 0xF11DE87D, "max_y_offset" },
    { 0xE696CB02, "max_z" },
    { 0xE80061C1, "max_zeros" },
    { 0x689CB617, "max_zombie_func" },
    { 0x728EAA61, "max_zombies" },
    { 0x00C281C2, "max_zombies_flung" },
    { 0x79DFF26D, "max_zone_drone_count" },
    { 0x50FF78D9, "max_zoom" },
    { 0xD6DF3824, "maxactivecontracts" },
    { 0x31321EB3, "maxai" },
    { 0xA82883B7, "maxaiperframe" },
    { 0x7EB6E786, "maxairstrikedamage" },
    { 0x6185B767, "maxallies" },
    { 0x97E6F46B, "maxallocation" },
    { 0x55552EB8, "maxallowable" },
    { 0x0643C93A, "maxallowableperteam" },
    { 0x453C0F47, "maxammo" },
    { 0x3961CF4A, "maxangle" },
    { 0xCD6D7AD8, "maxangledelta" },
    { 0x18CF3085, "maxangles" },
    { 0x863BE8CA, "maxarmor" },
    { 0xB66724E6, "maxattach" },
    { 0x2631576F, "maxattackers" },
    { 0x70659116, "maxaxis" },
    { 0xD0FAE622, "maxaxppcusage" },
    { 0xD21A7A75, "maxbmpexplosiondmg" },
    { 0xAB2EBD2B, "maxbonuscards" },
    { 0xE7F68F4A, "maxbouncetime" },
    { 0x995B52CB, "maxbrokenpieces" },
    { 0x256C2758, "maxc4" },
    { 0x79E4F0C7, "maxchainwait" },
    { 0xA9602859, "maxchange" },
    { 0x4E149A13, "maxclients" },
    { 0x02757450, "maxclipsize" },
    { 0xCF052520, "maxcompleted" },
    { 0x3883BFD8, "maxconsumedistancesq" },
    { 0x8E5390BA, "maxcorner" },
    { 0x81EA9B2B, "maxcorneroffset" },
    { 0xBFC2B280, "maxcornerpredictions" },
    { 0xA586F6DA, "maxcount" },
    { 0xAFBD0FF2, "maxdamage" },
    { 0x91AC5ADC, "maxde" },
    { 0x80134C02, "maxdelay" },
    { 0xB3CCF314, "maxdetpackdamage" },
    { 0xCE21D03B, "maxdirections" },
    { 0xE8E5CDB5, "maxdist" },
    { 0x2527CF00, "maxdistance" },
    { 0x840FB265, "maxdistancerandom" },
    { 0x50E99CBF, "maxdistawayfromarenacenter" },
    { 0xA41F505C, "maxdists2rd" },
    { 0xB453C865, "maxdistsq" },
    { 0x195675DD, "maxdistsqr" },
    { 0x67C25423, "maxdistsqrd" },
    { 0xB81B3F04, "maxdistsquared" },
    { 0x19BE1C96, "maxdisttonodesq" },
    { 0x8619FB99, "maxdisttotarget" },
    { 0xB5CA856A, "maxdogsattackingperplayer" },
    { 0xF39CF6EC, "maxdrawtime" },
    { 0xA5277B69, "maxduration" },
    { 0x5C8A5CF2, "maxe" },
    { 0x48B44EB2, "maxed" },
    { 0x6A91B716, "maxed_time" },
    { 0xA790BE5A, "maxempdowntime" },
    { 0x1AE3647D, "maxes" },
    { 0x4E04E342, "maxfaceenemydist" },
    { 0xDC8417DE, "maxfaceenemydistsq" },
    { 0xB6B4A809, "maxflashedseconds" },
    { 0xDCB90BC6, "maxfogopacity" },
    { 0x04192665, "maxfogopacity_new" },
    { 0xA8D8C844, "maxfontscale" },
    { 0x7032CF84, "maxframe" },
    { 0xB53DDB37, "maxframes" },
    { 0x659FC640, "maxframestillstationary" },
    { 0x4F8B807F, "maxfree" },
    { 0xD9ADCAA0, "maxfriendlies" },
    { 0xF3F9D173, "maxfriendlieskilled" },
    { 0x64EDA5A8, "maxgear" },
    { 0xACBF1FF1, "maxgibdist" },
    { 0x83FE11EC, "maxgibdistance" },
    { 0x38D5C558, "maxgibs" },
    { 0xFC9D1E61, "maxgoaltimeout" },
    { 0x47C252E3, "maxhealth" },
    { 0x8F1D2EC5, "maxhealth_modifier" },
    { 0x7AB529C8, "maxheight" },
    { 0xA821FD7C, "maxhitlocations" },
    { 0x3EEA3245, "maxhitpoints" },
    { 0x33944095, "maxhudy" },
    { 0x59E29C84, "maxi_near_corn_hint" },
    { 0x5460E5EB, "maxi_terminal_vox" },
    { 0xE9BCBABE, "maxid" },
    { 0x963E4F00, "maximal" },
    { 0x6FB3E645, "maximally" },
    { 0x712ADE6B, "maximportance" },
    { 0xBFEB4505, "maximum" },
    { 0x58F70EFE, "maximum_survival_time" },
    { 0xAD10E623, "maximumhealth" },
    { 0x536BC594, "maximums" },
    { 0xE3AAD65B, "maximus" },
    { 0x2758EEF7, "maxindex" },
    { 0x94385E88, "maxinitialdelay" },
    { 0xA9261119, "maxinstancesallowed" },
    { 0xAE4C47C6, "maxinum" },
    { 0x8A40537C, "maxinventoryscorestreaks" },
    { 0x8BD7FD41, "maxis" },
    { 0x7EA8A854, "maxis_audio_log_think" },
    { 0x7480CE48, "maxis_audio_logs" },
    { 0x11250C06, "maxis_balls_placed" },
    { 0x48013E79, "maxis_complete" },
    { 0x75E514E3, "maxis_generator_vo" },
    { 0x37BEEEA1, "maxis_minigame_opens_barricade" },
    { 0x28CAB30E, "maxis_minigame_start" },
    { 0x3C579D25, "maxis_pts_instructions" },
    { 0x5B87B611, "maxis_pts_placed" },
    { 0x0461E417, "maxis_quadrotor" },
    { 0x0BB81BD5, "maxis_sidequest" },
    { 0xDD542B41, "maxis_sidequest_a" },
    { 0x0356A5AA, "maxis_sidequest_b" },
    { 0x29592013, "maxis_sidequest_c" },
    { 0xDCB63B0D, "maxis_sidequest_complete" },
    { 0x99EEC928, "maxis_sidequest_complete_check" },
    { 0x6CE247C5, "maxis_sq_intro_said" },
    { 0xCB18C055, "maxis_stage_b" },
    { 0xBBFBA519, "maxis_story_vox" },
    { 0x5F669091, "maxis_street" },
    { 0x5B70B522, "maxis_talking" },
    { 0xAC314B21, "maxis_turbine_pickedup_vox" },
    { 0xD469B8FF, "maxis_turbine_vox_played" },
    { 0x7DC74A72, "maxissay" },
    { 0xBE243129, "maxissay_vo_finished" },
    { 0x03BEAB91, "maxissayvoplay" },
    { 0xCA01C20D, "maxiterations" },
    { 0xD877C682, "maxkilled" },
    { 0x76935A62, "maxkillstreaks" },
    { 0xD7CB9225, "maxlength" },
    { 0xA64EF174, "maxlifetime" },
    { 0x89273A50, "maxlightarmorhp" },
    { 0x8D79C3D6, "maxlocalclients" },
    { 0xB51DD33B, "maxmeshheight" },
    { 0xABC34EBB, "maxnodehistory" },
    { 0x20C4C2E8, "maxnodesperframe" },
    { 0xE15C1794, "maxoffset" },
    { 0x480F2380, "maxox" },
    { 0x6E119DE9, "maxoy" },
    { 0xA7540D95, "maxpause" },
    { 0x49709CFD, "maxperteam" },
    { 0x9ECDAA59, "maxpitch" },
    { 0x5227E725, "maxpitchdeltachange" },
    { 0x7AF77B4F, "maxplayercount" },
    { 0x83941B3C, "maxplayerz" },
    { 0xDD0C66B6, "maxplays" },
    { 0x6AA86FC5, "maxpos" },
    { 0x5FF90BA2, "maxprestige" },
    { 0xBAA4306C, "maxpreventdistancefeet" },
    { 0x14621B80, "maxpreventdistanceinchessq" },
    { 0x8193C675, "maxpreventvisibilityfeet" },
    { 0x4F2ACCC1, "maxpreventvisibilityinchessq" },
    { 0xFD3C94FC, "maxprob" },
    { 0x277DE3EF, "maxradius" },
    { 0xCC834F54, "maxrange" },
    { 0xB6AC04EC, "maxrangesq" },
    { 0xE80A7386, "maxrangesqr" },
    { 0xF4B99BDF, "maxrank" },
    { 0x52E3D4CF, "maxrankstarterpack" },
    { 0x54DF33D7, "maxrate" },
    { 0x1E3B613D, "maxrecentstats" },
    { 0x67E35660, "maxrespawndelay" },
    { 0x40C45D40, "maxreward" },
    { 0xD678E0A8, "maxroll" },
    { 0x3557910E, "maxroundswon" },
    { 0x08B6F854, "maxs" },
    { 0x4F488658, "maxsatchels" },
    { 0x1449F905, "maxscale" },
    { 0x45CB70EF, "maxsearchradius" },
    { 0x1D3AEA38, "maxsecondstowait" },
    { 0xE4B79094, "maxshots" },
    { 0xA9FB6535, "maxsightdistance" },
    { 0x2A373326, "maxsightdistsqrd" },
    { 0xC10237BB, "maxsightdstsqrd" },
    { 0x17715028, "maxsighttracednodes" },
    { 0xC424646B, "maxsighttracedspawnpoints" },
    { 0x69D87352, "maxsim" },
    { 0x1FBE5BFA, "maxsize" },
    { 0x08C371C7, "maxspeakers" },
    { 0xBC56AD43, "maxspecialties" },
    { 0xD2D32A36, "maxspeed" },
    { 0x4F3C6593, "maxsprintrate" },
    { 0x04BE6530, "maxstages" },
    { 0x8595249D, "maxstatchallenges" },
    { 0xB34798E0, "maxstatesounddistance" },
    { 0x8BFAA195, "maxsuicidesbeforekick" },
    { 0x3C731641, "maxtargets" },
    { 0xE205100B, "maxteammembers" },
    { 0xCC9DC92A, "maxtiersize" },
    { 0x6F31AE62, "maxtime" },
    { 0x18720B6E, "maxtimeallowed" },
    { 0xA3579DEB, "maxtimebeforedestroy" },
    { 0x448B4BDF, "maxtraces" },
    { 0x8A73D7B4, "maxunbalance" },
    { 0x3292DD9A, "maxval" },
    { 0x37B8B994, "maxvalue" },
    { 0x0C1AD4C3, "maxviewangle" },
    { 0x4A393B31, "maxvisibledist" },
    { 0xA8D31308, "maxvol" },
    { 0x20C5AADA, "maxwait" },
    { 0xD7F88B1F, "maxwaitbetweentrains" },
    { 0x44179775, "maxwaittime" },
    { 0xE73EC788, "maxwaittimebeforeleaving" },
    { 0x634DC800, "maxwaittimeenabledistinches" },
    { 0x05CA90F5, "maxwaves" },
    { 0xF0B98674, "maxweapons" },
    { 0x17D7B8F9, "maxweight" },
    { 0x26104BA5, "maxweightchange" },
    { 0x6946868B, "maxwidth" },
    { 0xAAD23AD7, "maxx" },
    { 0xFD628C63, "maxxpos" },
    { 0x84CFC06E, "maxy" },
    { 0x03B3A046, "maxyaw" },
    { 0xC988C3E2, "maxyawchange" },
    { 0xE4BF6E72, "maxyawchangeperframe" },
    { 0x0CCD653C, "maxyawdelta" },
    { 0x3EF37CEC, "maxyawdeltachange" },
    { 0xE65D3E97, "maxyawrandom" },
    { 0x60F3FFD0, "maxypos" },
    { 0x5ECD4605, "maxz" },
    { 0x84EC4E5C, "may" },
    { 0x38CD4F99, "may_banzai_attack" },
    { 0x161785C8, "may_drop" },
    { 0xB59EAA8D, "may_knockdown" },
    { 0xE00E968F, "mayapplyscreeneffect" },
    { 0x3EBE485F, "maybe" },
    { 0x02AF2354, "maybe_dont_drop_weapon" },
    { 0xA76D70E0, "maybee" },
    { 0xF651876D, "maychangecoverwarningalpha" },
    { 0xF1D1584A, "mayday" },
    { 0x1066D0ED, "maydolaststand" },
    { 0xF98EB965, "maydoupwardsdeath" },
    { 0x0355E787, "maydropweapon" },
    { 0xAAD58EB5, "maygenerateafteractionreport" },
    { 0x2A772FFE, "mayhem" },
    { 0xAF1ACFE8, "maymovecheckenabled" },
    { 0xA0CBEF1E, "maymovefrompointtopoint" },
    { 0xC99498FA, "maymovetargetorigin" },
    { 0xDD4EF762, "maymovetopoint" },
    { 0xCDF817C9, "maymovetopointtopoint" },
    { 0xA9B47B30, "mayonlydie" },
    { 0xEC5F4661, "mayprocesschallenges" },
    { 0x75E5CB36, "mayshootwhilemoving" },
    { 0xCC406C51, "mayspawn" },
    { 0xADDE7E2B, "maythrowdoublegrenade" },
    { 0xD9AD108D, "maze_achievement_watcher" },
    { 0x486E1D7A, "maze_arrive" },
    { 0xCB6054C3, "maze_blocker_fix" },
    { 0xB4128313, "maze_blocker_rises_thread" },
    { 0x56A08E35, "maze_blocker_sinks_thread" },
    { 0x526839EE, "maze_can_change" },
    { 0xBEA96CAD, "maze_chests" },
    { 0xA5E01018, "maze_debug_print" },
    { 0xCFCA9FF9, "maze_depart" },
    { 0xBC03B0C0, "maze_do_perm_change" },
    { 0x958D480B, "maze_do_zombie_rise" },
    { 0xB8891651, "maze_do_zombie_spawn" },
    { 0xBFE7237E, "maze_floor_controller_rumble" },
    { 0x4E4DDED2, "maze_fountain_collmap" },
    { 0x6A0A9196, "maze_fountain_think" },
    { 0xC7C9EFAF, "maze_hedge_spawnpoints" },
    { 0x7FB6EBBF, "maze_nodes_link_unlink_internal" },
    { 0x61D1546C, "maze_precache" },
    { 0x7DDF62E1, "maze_rumble_while_floor_shakes" },
    { 0x6BECCDFC, "maze_spawners" },
    { 0xF2218349, "maze_switch_anim" },
    { 0x668DB6C1, "maze_think" },
    { 0x7240D7C2, "maze_to_mansion" },
    { 0x469B0955, "maze_trap_move_wall" },
    { 0x98CA8BD1, "maze_wall_move" },
    { 0x8CCD42D4, "maze_zones" },
    { 0x9AB8B237, "mazimum" },
    { 0x22EBB724, "mb" },
    { 0x8FB9B4DF, "mb_hostmigration" },
    { 0xA9960146, "mb_orgs" },
    { 0x33D20A0A, "mbettelman" },
    { 0x2EF11657, "mbs" },
    { 0x046724C1, "mbs_anim_nextstandinghitdying" },
    { 0x58D9A00F, "mbs_oldhealth" },
    { 0x82FF990E, "mbss" },
    { 0x6431E132, "mccaul" },
    { 0x91975AF8, "mcg" },
    { 0xF8FFFF21, "mchackerson" },
    { 0xA6CDCB66, "mcknight" },
    { 0xF1C98B19, "mcknight_clear_pool" },
    { 0x874C63B2, "mcknight_close_the_door_argument_vo" },
    { 0x876169B4, "mcknight_sniper" },
    { 0xF55C35A1, "mcknight_sniping_clear_vo" },
    { 0x40CE86FF, "mcnamara" },
    { 0x7B31FEA6, "mcomp_done0" },
    { 0x2F2D09D4, "mcomp_done2" },
    { 0x552F843D, "mcomp_done3" },
    { 0x97232030, "mcomp_done6" },
    { 0xD6E6C252, "md" },
    { 0xF4335F7A, "mdbg_att_getinposition" },
    { 0x228F2C6A, "mdbg_def_getinposition" },
    { 0xF79D1DDA, "mdl" },
    { 0x39DA15AC, "mdl2" },
    { 0xF6CBD0C1, "mdl_body" },
    { 0xD8A0C5FD, "mdl_dish_animate" },
    { 0x3CFC28CF, "mdl_fx" },
    { 0xF4E7DF2C, "mdl_fx_pos" },
    { 0xCA24C5E5, "mdl_gravity_trap" },
    { 0xFE38A6AA, "mdl_gravity_trap_fx_source" },
    { 0x1D3186B5, "mdl_gravity_trap_spikes" },
    { 0xECD8678C, "mdl_octobomb" },
    { 0x0A64BCC9, "mdl_piece" },
    { 0x8FCB4B32, "mdl_shield_recharge" },
    { 0x957CDC8F, "mdl_spike_source" },
    { 0x3DCEBFA2, "mdl_trap_mover" },
    { 0x20F81239, "mdl_vortex" },
    { 0xDC55E899, "mdl_weapon" },
    { 0xFCE93CBB, "me" },
    { 0xA8371791, "me_ac_window" },
    { 0x5A25045F, "me_dumpster_fire" },
    { 0x01E6C8CB, "me_plastic_crate1" },
    { 0x69267101, "me_plastic_crate10" },
    { 0xB5E1D3F9, "me_plastic_crate3" },
    { 0x73EE3806, "me_plastic_crate4" },
    { 0x27E94334, "me_plastic_crate6" },
    { 0x31FA9C13, "me_plastic_crate9" },
    { 0xD7C83C7F, "me_streetlight_on" },
    { 0xCCE65F64, "me_streetlight_on_scaleddown80" },
    { 0x36B024D0, "me_to_missile" },
    { 0xAD85CF3E, "me_to_origin" },
    { 0xBC1152C7, "me_to_player" },
    { 0xB0E9AF56, "mean" },
    { 0x9296D94A, "meaning" },
    { 0x7DF11335, "meaningless" },
    { 0x90A2CAC9, "means" },
    { 0x86C449C4, "means_of_death" },
    { 0x773640E9, "meansofdamage" },
    { 0x597CACAC, "meansofdeath" },
    { 0x4EAF2ED6, "meant" },
    { 0x34843429, "meantime" },
    { 0xE6B9187A, "meanx" },
    { 0x0CBB92E3, "meany" },
    { 0x9AB423A8, "meanz" },
    { 0xC3D2A5C7, "measure" },
    { 0x32A32741, "measured" },
    { 0x9087E4BE, "measures" },
    { 0xF520345C, "meat" },
    { 0x2656A52E, "meat_bounce_override" },
    { 0xC58A601D, "meat_create_hint_message" },
    { 0x21E6D990, "meat_custom_think_logic" },
    { 0x9DD42C02, "meat_end" },
    { 0xDB8C2D24, "meat_end_match" },
    { 0x0CC82E71, "meat_farm_nodes" },
    { 0x2C55D7A6, "meat_grabbed" },
    { 0xCC3CEF95, "meat_hold_counter" },
    { 0xC10274C2, "meat_hub_start_func" },
    { 0xDABB7F0C, "meat_id" },
    { 0x7C2D5727, "meat_intro" },
    { 0x7AC8336F, "meat_is_flying" },
    { 0x9C59F160, "meat_is_moving" },
    { 0xAEC38CF1, "meat_is_rolling" },
    { 0x41FC1D0E, "meat_kicked" },
    { 0xAFA47FD0, "meat_last_stand_callback" },
    { 0x5291A37B, "meat_lost_time" },
    { 0x8A658823, "meat_lost_time_limit" },
    { 0xC8347560, "meat_manager" },
    { 0x45E0FC9E, "meat_name" },
    { 0x44066045, "meat_objects" },
    { 0x6F8A677E, "meat_on_ground" },
    { 0x7AF86ACF, "meat_on_player_connect" },
    { 0x0FB33C15, "meat_on_player_disconnect" },
    { 0x25B53CFF, "meat_pickup_trigger_radius" },
    { 0xE5B8C580, "meat_pickupsound" },
    { 0x4C0B716F, "meat_pickupsoundplayer" },
    { 0x555A1715, "meat_player_initial_spawn" },
    { 0x8388F0AE, "meat_player_setup" },
    { 0xF1701625, "meat_poi" },
    { 0x005AE225, "meat_poi_override_func" },
    { 0x3BFC9314, "meat_reset" },
    { 0x3DFF9963, "meat_screen_message_delete" },
    { 0x22AACB62, "meat_screen_message_delete_on_death" },
    { 0x9D262BEB, "meat_shield_last_guy" },
    { 0x83820C44, "meat_shield_sequence" },
    { 0x59538F25, "meat_shield_start_idles" },
    { 0xAAC152E8, "meat_spawners" },
    { 0x0CB008F9, "meat_spike_dist_sq" },
    { 0x99BFFE43, "meat_spike_dot" },
    { 0xA31E4F36, "meat_splitter" },
    { 0x05B3FF79, "meat_start" },
    { 0xF8121122, "meat_stink" },
    { 0x45EFECBD, "meat_stink_1st_person" },
    { 0xDE989AB8, "meat_stink_3p" },
    { 0xFC287F6A, "meat_stink_3rd_person" },
    { 0xD5B10EAC, "meat_stink_on_ground" },
    { 0xC21BA55E, "meat_stink_pickedup" },
    { 0x1D129A6E, "meat_stink_player" },
    { 0x5784758B, "meat_stink_player_cleanup" },
    { 0x9386AA45, "meat_stink_player_create" },
    { 0xC4BB6548, "meat_stink_powerup_grab" },
    { 0xFA947410, "meat_team" },
    { 0xDF3474CD, "meat_thrown" },
    { 0xE916C11D, "meat_town_nodes" },
    { 0x9ED50063, "meat_trigger_time" },
    { 0x824597AB, "meat_tunnel_nodes" },
    { 0xE1607B00, "meat_weaponidx" },
    { 0xA243A32F, "meat_zombie_post_spawn_init" },
    { 0x3D6183FA, "meatballs" },
    { 0x65F7D050, "meatd" },
    { 0x6B908F5E, "meatorg" },
    { 0x0FE1829F, "meats" },
    { 0x0B7C88CF, "meats2" },
    { 0x347ED631, "meatshied" },
    { 0x9F329A31, "meatshied_alerted" },
    { 0xB66D65CF, "meatshield" },
    { 0x72C2F7E8, "meatshield_active" },
    { 0x13D4CD04, "meatshield_ai" },
    { 0x317BD71E, "meatshield_ai_attacker" },
    { 0x0F6E3279, "meatshield_ai_speaking" },
    { 0x9433C57D, "meatshield_ai_targets_vox" },
    { 0x2BBAC5C7, "meatshield_alerted" },
    { 0x6CFD901E, "meatshield_attacker_attack_target" },
    { 0x583B6734, "meatshield_attacker_scene_fails" },
    { 0xBA4B34F9, "meatshield_audio_init" },
    { 0xF125D2BD, "meatshield_audio_start" },
    { 0xDC237617, "meatshield_blend" },
    { 0x58AB9787, "meatshield_boats" },
    { 0x0B943903, "meatshield_check_for_player_rotation" },
    { 0x1F998B4F, "meatshield_conversation" },
    { 0x85549B18, "meatshield_custom_audio" },
    { 0x57E17CD1, "meatshield_damage" },
    { 0xC50E8DEC, "meatshield_damage_override" },
    { 0x99E1C59E, "meatshield_event" },
    { 0xB73098FA, "meatshield_fail" },
    { 0x575B618D, "meatshield_failed" },
    { 0x15076375, "meatshield_fails" },
    { 0x34E27494, "meatshield_fake_ai_conversation" },
    { 0xA9C95380, "meatshield_finished" },
    { 0x9382616C, "meatshield_grab_guy" },
    { 0x3AC00284, "meatshield_grenade_explosion" },
    { 0xCDC096D3, "meatshield_imps" },
    { 0xC1377AA7, "meatshield_infinite_ammo" },
    { 0xE86A05C6, "meatshield_input" },
    { 0x8EFBE06E, "meatshield_player_damage_override" },
    { 0xE2AAC847, "meatshield_player_movement" },
    { 0x00DDB396, "meatshield_process_proximity_speed_scalar" },
    { 0x26B128B2, "meatshield_random_attacker_index" },
    { 0xF6449B6D, "meatshield_rot" },
    { 0x8474460C, "meatshield_sampan" },
    { 0x3BD89802, "meatshield_screen_message" },
    { 0xD4CD4095, "meatshield_snapshot_override" },
    { 0x5FBF1416, "meatshield_special_death_vox" },
    { 0x4CB2C2F9, "meatshield_state" },
    { 0xDB56BFFD, "meatshield_struggle_vox" },
    { 0xDF92D60E, "meatshield_threat" },
    { 0xD121634E, "meatshield_trigger_used" },
    { 0xDC38B07B, "meatshield_trigs" },
    { 0x2E6FB2FA, "meatshield_v2" },
    { 0x9CBB1BB5, "meatshield_vox" },
    { 0xA6201A44, "meatshield_whizbys" },
    { 0x0F5DC235, "meatshild_ai_try_and_shoot_target" },
    { 0x19EE46E9, "meatshiled" },
    { 0xCA099D36, "mech" },
    { 0x192B8AD3, "mech_start_round_num" },
    { 0x0D8D82E7, "mech_zombie_hole_search" },
    { 0x0C4A4017, "mech_zombie_hole_valid" },
    { 0xBB8BFE7F, "mechanic" },
    { 0x019DDB86, "mechanics" },
    { 0x5DC22D38, "mechanism" },
    { 0xA6B87E31, "mechanized" },
    { 0x7D47A829, "mechs" },
    { 0x7D317A5E, "mechtank" },
    { 0x8FC76D75, "mechtank_bundle" },
    { 0x79DAF63F, "mechtank_initialize" },
    { 0x457469F5, "mechtankcallback_vehicledamage" },
    { 0x87590108, "mechz" },
    { 0xB942C9EC, "mechz_115_gun_muzzle_flash" },
    { 0x68C16B45, "mechz_115_gun_muzzle_flash_fx" },
    { 0xE864933A, "mechz_115_gun_muzzle_flash_fx_file" },
    { 0x37B4FE8D, "mechz_aggro_dist_sq" },
    { 0x1514648E, "mechz_aim_max_pitch" },
    { 0x6B18119D, "mechz_aim_max_yaw" },
    { 0xC61638E2, "mechz_aim_pitch_max" },
    { 0xAB649E06, "mechz_aim_yaw_cos" },
    { 0xDE2F92CB, "mechz_armor_info" },
    { 0x747D963B, "mechz_armor_knee_left_health" },
    { 0xB6E6617A, "mechz_armor_knee_right_health" },
    { 0x8A36F864, "mechz_armor_off_sparks_fx" },
    { 0xB8E8BDFD, "mechz_armor_off_sparks_fx_file" },
    { 0xC24FBCEA, "mechz_armor_shoulder_left_health" },
    { 0x1A049FED, "mechz_armor_shoulder_right_health" },
    { 0x19B28B12, "mechz_array" },
    { 0xCC2D32D5, "mechz_attach_objects" },
    { 0xF1419B9D, "mechz_base_health" },
    { 0x8D7FBC38, "mechz_behavior_dist" },
    { 0xE2CE241B, "mechz_behavior_orient" },
    { 0x9CEE1DDD, "mechz_berserk_time" },
    { 0x01DB0DC2, "mechz_body_damage_scale" },
    { 0x12EF8878, "mechz_check_in_arc" },
    { 0xC9E3A76C, "mechz_claw_aim" },
    { 0xAB64B953, "mechz_claw_cleanup" },
    { 0xBE0EAC62, "mechz_claw_cooldown_time" },
    { 0x65FCFC0E, "mechz_claw_damage_trigger_thread" },
    { 0x37F4FE98, "mechz_claw_detach" },
    { 0xFB36573F, "mechz_claw_explosive_watcher" },
    { 0x8151A09D, "mechz_claw_notetracks" },
    { 0xED85A2B5, "mechz_claw_off_fx" },
    { 0x39C5602A, "mechz_claw_off_fx_file" },
    { 0xC41BC414, "mechz_claw_release" },
    { 0xBE7AE09E, "mechz_claw_shot_pain_reaction" },
    { 0x296EBA09, "mechz_cleanup" },
    { 0x20775399, "mechz_clear_spawns" },
    { 0xB89ED656, "mechz_custom_goalradius" },
    { 0xFEAC9945, "mechz_custom_goalradius_sq" },
    { 0x0A8588FF, "mechz_damage_override" },
    { 0xA47EACA6, "mechz_damage_percent" },
    { 0x9FF7F577, "mechz_death" },
    { 0xC1E2974C, "mechz_death_ee" },
    { 0x4AB7FB88, "mechz_debug" },
    { 0xE8615C47, "mechz_delayed_item_delete" },
    { 0xE3453E34, "mechz_detach_claw" },
    { 0xED6989AB, "mechz_detach_claw_override" },
    { 0xB6D242C2, "mechz_detach_faceplate" },
    { 0xC74D1856, "mechz_detach_lknee_armor" },
    { 0x8BC31CD3, "mechz_detach_lshoulder_armor" },
    { 0xDCBBEEE0, "mechz_detach_powercap" },
    { 0xDC89A738, "mechz_detach_rknee_armor" },
    { 0x7BA558F1, "mechz_detach_rshoulder_armor" },
    { 0x5F19A438, "mechz_direct_hit_impact_damage_check" },
    { 0x01107D5E, "mechz_dist_for_sprint" },
    { 0x0818FA51, "mechz_dist_for_stop_sprint" },
    { 0x9B5999EB, "mechz_do_claw_grab" },
    { 0x641D3C68, "mechz_do_flamethrower_attack" },
    { 0x5FC0B16B, "mechz_do_jump" },
    { 0xEB17E7F2, "mechz_explode" },
    { 0xB1861FB2, "mechz_exploded" },
    { 0x78FAFA94, "mechz_explosive_damage_reaction_callback" },
    { 0xF849D7D9, "mechz_explosive_dmg_head_scaler" },
    { 0x46B8E412, "mechz_explosive_dmg_to_cancel_claw" },
    { 0x27D34CC9, "mechz_explosive_dmg_to_cancel_claw_percentage" },
    { 0xED875F13, "mechz_face_attack" },
    { 0xCF8E734A, "mechz_face_clear" },
    { 0x274524E2, "mechz_face_clientfield" },
    { 0x935ED783, "mechz_face_death" },
    { 0x2744C89D, "mechz_face_idle" },
    { 0x963C20D3, "mechz_face_pain" },
    { 0xCC79DF2F, "mechz_faceplate_damage_override" },
    { 0x82E55FE9, "mechz_faceplate_detached" },
    { 0xDF387CCD, "mechz_faceplate_health" },
    { 0xC6113AFB, "mechz_faceplate_off_fx" },
    { 0x1D0438BC, "mechz_faceplate_off_fx_file" },
    { 0x53823C42, "mechz_failed_paths_to_jump" },
    { 0xEA37FFB9, "mechz_find_flesh" },
    { 0x424CA259, "mechz_find_flesh_override_func" },
    { 0xD1AAAB68, "mechz_flame_damage" },
    { 0x749152C4, "mechz_flamethrower_ai_callback" },
    { 0x94AD496B, "mechz_flamethrower_aim" },
    { 0x4C7EDE65, "mechz_flamethrower_arc_watcher" },
    { 0x1E65E2C4, "mechz_flamethrower_cleanup" },
    { 0x94DCDC41, "mechz_flamethrower_cooldown_time" },
    { 0x6E66AFE5, "mechz_flamethrower_dist_watcher" },
    { 0x71D919F6, "mechz_flamethrower_initial_setup" },
    { 0x9C0601A3, "mechz_flamethrower_player_callback" },
    { 0x7F341311, "mechz_flamethrower_tank_sweep" },
    { 0xC80EE9E2, "mechz_flogger_stun_time" },
    { 0x4A8EE41D, "mechz_footstep_earthquake_max_radius" },
    { 0xDA735C3E, "mechz_footstep_fx" },
    { 0x21F5BEF3, "mechz_footstep_fx_file" },
    { 0xE7900A0D, "mechz_footstep_steam_fx" },
    { 0xA8CB6D22, "mechz_footstep_steam_fx_file" },
    { 0x4A0CBBD1, "mechz_force_behavior" },
    { 0x2EA8E401, "mechz_force_claw_attack" },
    { 0x11A3F8C0, "mechz_force_damage_armor" },
    { 0xBF60F134, "mechz_force_damage_faceplate" },
    { 0x49CB5821, "mechz_force_flamethrower" },
    { 0x5EF444E7, "mechz_force_jump_in" },
    { 0x539DC612, "mechz_force_jump_out" },
    { 0xCAC57525, "mechz_force_melee" },
    { 0xDCF3DCB7, "mechz_force_spawn_pos" },
    { 0xDD3ED94F, "mechz_ft_blend_time" },
    { 0xE1832F6B, "mechz_ft_clientfield" },
    { 0xC7F328F5, "mechz_ft_delay" },
    { 0x5D15B6AC, "mechz_ft_dist_sq_max" },
    { 0x9A79C1C2, "mechz_ft_dist_sq_min" },
    { 0xB2C037F2, "mechz_ft_fx" },
    { 0x1563E46F, "mechz_ft_fx_file" },
    { 0xB0F55247, "mechz_ft_off" },
    { 0x6EBBA933, "mechz_ft_on" },
    { 0x1156CC0B, "mechz_ft_player_burn_time" },
    { 0xEB9B0169, "mechz_ft_player_damage" },
    { 0x0F9E4689, "mechz_ft_player_damage_delay" },
    { 0x8BCC7CC1, "mechz_ft_player_damage_jugg" },
    { 0x604BCA3C, "mechz_ft_right_offset" },
    { 0x67385B6E, "mechz_ft_run_duration" },
    { 0xE03A516B, "mechz_ft_sweep_chance" },
    { 0x0DBBDC92, "mechz_ft_sweep_player_dist_sq" },
    { 0x005D8A58, "mechz_ft_tag" },
    { 0x90E56BD9, "mechz_get_aim_anim" },
    { 0xD67D5196, "mechz_get_closest_valid_player" },
    { 0xD8BEB489, "mechz_grab_released_friendly" },
    { 0x648BBAEA, "mechz_grab_released_self" },
    { 0x6DB0C472, "mechz_grabbed_by" },
    { 0x6647F386, "mechz_grabbed_played_vo" },
    { 0xCAC00620, "mechz_grenade_burst_size" },
    { 0x2B597EAB, "mechz_grenade_delay" },
    { 0xDC3613C3, "mechz_grenade_deviation_pitch_max" },
    { 0x9ED208AD, "mechz_grenade_deviation_pitch_min" },
    { 0xF87AABD0, "mechz_grenade_deviation_radius" },
    { 0x1258A660, "mechz_grenade_deviation_yaw_max" },
    { 0xBF81379E, "mechz_grenade_deviation_yaw_min" },
    { 0xFF4991FA, "mechz_grenade_dist_sq_max" },
    { 0xC1E586E4, "mechz_grenade_dist_sq_min" },
    { 0x1FE025C8, "mechz_grenade_max" },
    { 0x8CEFA9E2, "mechz_grenade_tag" },
    { 0x11D4AFBD, "mechz_grenade_target_prediction_time" },
    { 0x47807D02, "mechz_grenade_type" },
    { 0x19EEDB70, "mechz_gun_detached" },
    { 0x26D19227, "mechz_gun_off_sparks_fx" },
    { 0x0F1CC000, "mechz_gun_off_sparks_fx_file" },
    { 0x136E80D5, "mechz_half_front_arc" },
    { 0x53592FD0, "mechz_headlamp_destroyed_fx" },
    { 0x9D558681, "mechz_headlamp_destroyed_fx_file" },
    { 0xD719D0C5, "mechz_headlamp_off" },
    { 0xA6259248, "mechz_headlight_fx" },
    { 0xAAC779F9, "mechz_headlight_fx_file" },
    { 0x53CC405D, "mechz_health" },
    { 0xA1748A68, "mechz_health_increase" },
    { 0x6367C303, "mechz_health_increases" },
    { 0x2C998EB8, "mechz_helmet_health_percentage" },
    { 0x1E9EB9FB, "mechz_hidden" },
    { 0x362CFFF6, "mechz_hint_vo" },
    { 0x7C9BB9A9, "mechz_hit_by_tank" },
    { 0x09EA4ECF, "mechz_in_range_for_jump" },
    { 0x67582ABB, "mechz_init_end" },
    { 0x6CD65D18, "mechz_init_start" },
    { 0x81BEF5D7, "mechz_instakill_override" },
    { 0xF73B1530, "mechz_interrupt" },
    { 0x129B1DB2, "mechz_jump_cleanup" },
    { 0x2750D45B, "mechz_jump_delay" },
    { 0xB8CF93DE, "mechz_jump_dist_threshold" },
    { 0x31F6468B, "mechz_jump_stuck_watcher" },
    { 0xF96F598E, "mechz_jump_think" },
    { 0xCE2E05A7, "mechz_jump_vo" },
    { 0xD1893096, "mechz_kill_claw_watcher" },
    { 0x730EBBA9, "mechz_kill_flamethrower_watcher" },
    { 0x807B9A63, "mechz_kill_jump_watcher" },
    { 0xF3F6AC90, "mechz_killed" },
    { 0xCD720676, "mechz_knee_armor_off_sparks_fx" },
    { 0x93B2646B, "mechz_knee_armor_off_sparks_fx_file" },
    { 0x44BCA3D6, "mechz_last_spawn_round" },
    { 0x7A47D165, "mechz_launch_armor_piece" },
    { 0xCA204E3D, "mechz_left_arm_damage_callback" },
    { 0xB0B2114C, "mechz_left_to_spawn" },
    { 0x1B182917, "mechz_lknee_armor_off_fx" },
    { 0xDF61AEF0, "mechz_lknee_armor_off_fx_file" },
    { 0x20D6379D, "mechz_locations" },
    { 0xF47757E8, "mechz_lshoulder_amor_off_fx" },
    { 0x9491AD59, "mechz_lshoulder_amor_off_fx_file" },
    { 0xC79E9C30, "mechz_max_extra_spawn" },
    { 0x7FDEEFC2, "mechz_max_round_fq" },
    { 0x4534E4C4, "mechz_max_round_fq_solo" },
    { 0xBBE3EDE4, "mechz_melee_dist" },
    { 0xEADC5AF7, "mechz_melee_dist_sq" },
    { 0x6F76D887, "mechz_melee_knockdown_function" },
    { 0xD614F425, "mechz_melee_yaw" },
    { 0x8F59E902, "mechz_min_extra_spawn" },
    { 0x0BE18040, "mechz_min_round_fq" },
    { 0xCCFF5B86, "mechz_min_round_fq_solo" },
    { 0x3A4E21E0, "mechz_model_armor_knee_left" },
    { 0x33AB70CF, "mechz_model_armor_knee_right" },
    { 0x1C167CD3, "mechz_model_armor_shoulder_left" },
    { 0xAD47D446, "mechz_model_armor_shoulder_right" },
    { 0xA6B15435, "mechz_model_body" },
    { 0x5AEF319C, "mechz_model_claw" },
    { 0xC6F2C63A, "mechz_model_faceplate" },
    { 0x85E675C9, "mechz_model_powersupply" },
    { 0xB00482D5, "mechz_navmesh_boundary_dist" },
    { 0xF42A7EF6, "mechz_navmesh_radius" },
    { 0x85533D71, "mechz_non_attacker_damage_override" },
    { 0x73A0EB7F, "mechz_nuke_override" },
    { 0xB7ECD5BC, "mechz_part" },
    { 0x0D83866C, "mechz_part_faceplate" },
    { 0x4474DAB3, "mechz_part_gun" },
    { 0xE4529B3F, "mechz_part_powercore" },
    { 0x0E70D6B4, "mechz_play_flamethrower_aim" },
    { 0xC79A7E57, "mechz_play_pain_audio" },
    { 0x9588BA05, "mechz_player_flame_dmg" },
    { 0xDC73A7DE, "mechz_players_in_zone_spawn_point_cap" },
    { 0x27E4DD92, "mechz_points_for_helmet" },
    { 0x77FAA810, "mechz_points_for_killer" },
    { 0xF680427B, "mechz_points_for_powerplant" },
    { 0x49FE662E, "mechz_points_for_team" },
    { 0x79D56F1B, "mechz_powercap_cover_health" },
    { 0x48D0C948, "mechz_powercap_destroyed_callback" },
    { 0xC31F5C1F, "mechz_powercap_health" },
    { 0xC42E91E1, "mechz_powercap_off_fx" },
    { 0x52929F6E, "mechz_powercap_off_fx_file" },
    { 0x7E2478A6, "mechz_powercore_damage_scale" },
    { 0x2B7DDA84, "mechz_powercore_fx" },
    { 0x6354BDDD, "mechz_powercore_fx_file" },
    { 0x0D10CD77, "mechz_powerplant_destroy_dmg" },
    { 0xA74F8CE1, "mechz_powerplant_destroy_dmg_base" },
    { 0xB97389FA, "mechz_powerplant_destroy_dmg_increase" },
    { 0x2A704D19, "mechz_powerplant_destroyed_health_percentage" },
    { 0x05FFBF55, "mechz_powerplant_expose_base_dmg" },
    { 0x8D42C5F5, "mechz_powerplant_expose_dmg" },
    { 0xF8EB93C7, "mechz_powerplant_expose_dmg_base" },
    { 0x2C529C00, "mechz_powerplant_expose_dmg_increase" },
    { 0x21DD9210, "mechz_powerplant_expose_health_percentage" },
    { 0xA921CD80, "mechz_powerplant_stun_time" },
    { 0xDA89751F, "mechz_prespawn" },
    { 0x90255061, "mechz_projectile_damage_scale" },
    { 0x45E7F70B, "mechz_projectile_splash_damage_scale" },
    { 0xDF063043, "mechz_react_elemental_bow" },
    { 0x47A3251E, "mechz_react_elemental_bow_charged" },
    { 0xDDF31707, "mechz_remove_helmet_head_dmg" },
    { 0xD7A57E91, "mechz_remove_helmet_head_dmg_base" },
    { 0xC26AFF0A, "mechz_remove_helmet_head_dmg_increase" },
    { 0xC15A3DAA, "mechz_reset_dist_sq" },
    { 0xE17AE679, "mechz_rknee_armor_off_fx" },
    { 0xE834F806, "mechz_rknee_armor_off_fx_file" },
    { 0xBA970BFC, "mechz_robot_knockdown_time" },
    { 0x3F19350B, "mechz_robot_stomp_callback" },
    { 0x65863F29, "mechz_round_count" },
    { 0x5639DBA0, "mechz_round_tracker" },
    { 0x1E3DA86B, "mechz_round_tracker_loop_end" },
    { 0xFD00C088, "mechz_round_tracker_loop_start" },
    { 0x2E039E15, "mechz_round_tracker_start" },
    { 0x21BD82BA, "mechz_rounds_enabled" },
    { 0x4C9F7336, "mechz_rshoulder_amor_off_fx" },
    { 0x5ACCAA2B, "mechz_rshoulder_amor_off_fx_file" },
    { 0xA820CA5B, "mechz_set_locomotion_speed" },
    { 0x617738F5, "mechz_set_starting_health" },
    { 0x6F839D44, "mechz_setup_armor_pieces" },
    { 0x5611DE07, "mechz_setup_fx" },
    { 0x9A84F886, "mechz_setup_snd" },
    { 0x9EAF8820, "mechz_shotgun_damage_mod" },
    { 0xD9D8F8B3, "mechz_should_drop_powerup" },
    { 0xC3BABDA1, "mechz_should_jump" },
    { 0xEABB03E4, "mechz_should_stun_override" },
    { 0x461A1E88, "mechz_spawn" },
    { 0x6C15F1BC, "mechz_spawners" },
    { 0xFC89CCD0, "mechz_spawning" },
    { 0xFD272A6B, "mechz_spawning_logic" },
    { 0x1694F167, "mechz_spawning_logic_override_func" },
    { 0xC8CF79A8, "mechz_staff_damage_override" },
    { 0x800D8BD4, "mechz_staff_piece_failsafe" },
    { 0xC12F1467, "mechz_start_basic_find_flesh" },
    { 0x3FE5DA38, "mechz_sticky_dist_sq" },
    { 0xACD73632, "mechz_stomped_by_giant_robot_vo" },
    { 0x5DF429FD, "mechz_stop_basic_find_flesh" },
    { 0xBB1A39CA, "mechz_stop_firing_watcher" },
    { 0x0CC6B879, "mechz_stumble_time" },
    { 0x1E0CC633, "mechz_stun" },
    { 0x020C73FC, "mechz_stun_stumble_cooldown" },
    { 0xAB72D841, "mechz_stun_time" },
    { 0x45C16F7F, "mechz_tag_armor_knee_left" },
    { 0xF9A3901A, "mechz_tag_armor_knee_right" },
    { 0xC3D8AAD4, "mechz_tag_armor_shoulder_left" },
    { 0x54EBA10B, "mechz_tag_armor_shoulder_right" },
    { 0x3658B28D, "mechz_tag_array_setup" },
    { 0x69046591, "mechz_tag_claw" },
    { 0xAC4AAD49, "mechz_tag_faceplate" },
    { 0x9A1C451C, "mechz_tag_in_use_cleanup" },
    { 0x835169E2, "mechz_tag_powercore" },
    { 0x4E33E922, "mechz_tag_powersupply" },
    { 0xB6C80EBD, "mechz_tank_hit_callback" },
    { 0x68F2C2CE, "mechz_tank_knockdown_time" },
    { 0x820EDC73, "mechz_targets" },
    { 0x0B024A4C, "mechz_track_faceplate_damage" },
    { 0x068A38E0, "mechz_track_lknee_armor_damage" },
    { 0x75493757, "mechz_track_lshoulder_armor_damage" },
    { 0x00FF3F6E, "mechz_track_powercap_cover_damage" },
    { 0x81C30BAA, "mechz_track_powercap_damage" },
    { 0x1F360652, "mechz_track_rknee_armor_damage" },
    { 0xB7934265, "mechz_track_rshoulder_armor_damage" },
    { 0x378D99AF, "mechz_turn_off_headlamp" },
    { 0x718F77A3, "mechz_unlink_on_laststand" },
    { 0xD329A507, "mechz_visionset_burn" },
    { 0x02A1A0BB, "mechz_watch_for_flamethrower_damage" },
    { 0x563ED797, "mechz_z" },
    { 0x153FF43D, "mechz_zombie_flamethrower_gib" },
    { 0x2E26F510, "mechz_zombie_per_round" },
    { 0x9FD43ABD, "mechzaddattachments" },
    { 0x5988C718, "mechzattackstart" },
    { 0x648C84B6, "mechzbehavior" },
    { 0xA33AAC03, "mechzberserkknockdownservice" },
    { 0x65B0F653, "mechzcheckinarc" },
    { 0x46498900, "mechzclientutils" },
    { 0x2670D89E, "mechzdamagecallback" },
    { 0xB04D6DE6, "mechzdeathstart" },
    { 0x98EBDDAE, "mechzdelayflame" },
    { 0x30B61B5F, "mechzendberserk" },
    { 0x62673BDE, "mechzfacecallback" },
    { 0xC823934D, "mechzfiltergrenadesbyowner" },
    { 0x9E0F068E, "mechzflamedamage" },
    { 0x02FB5243, "mechzflamethrowercallback" },
    { 0x5CD35D77, "mechzflamewatcher" },
    { 0xBD447F24, "mechzgoberserk" },
    { 0x1590F705, "mechzgrenadecheckinarc" },
    { 0xF51DE927, "mechzgrenadeservice" },
    { 0x26921796, "mechzidlestart" },
    { 0xBB8F6697, "mechznotetrackmelee" },
    { 0x7DC77A24, "mechznotetrackshootgrenade" },
    { 0x08AE701C, "mechzpainstart" },
    { 0x84566B25, "mechzpainterminate" },
    { 0xC528F97D, "mechzplayedberserkintro" },
    { 0xE2126C69, "mechzprocessfootstep" },
    { 0xE907CF54, "mechzserverutils" },
    { 0x2D0F439E, "mechzshootflame" },
    { 0xBEE98BB7, "mechzshootflameactionend" },
    { 0x82A18C9C, "mechzshootflameactionstart" },
    { 0x00993E2B, "mechzshootflameactionupdate" },
    { 0xF4E4ED65, "mechzshootgrenade" },
    { 0xDD564387, "mechzshootgrenadeaction" },
    { 0x41737DC4, "mechzshootgrenadeactionupdate" },
    { 0x5182D33F, "mechzshouldmelee" },
    { 0xBA8AB8D3, "mechzshouldshootflame" },
    { 0xF13166DD, "mechzshouldshootflamesweep" },
    { 0x125C087C, "mechzshouldshootgrenade" },
    { 0xEFF2A22E, "mechzshouldshowpain" },
    { 0x82464E19, "mechzshouldstumble" },
    { 0x61BF428D, "mechzshouldstun" },
    { 0xFDC19A72, "mechzshouldturnberserk" },
    { 0xF4421436, "mechzsndcontext" },
    { 0xCDA3F485, "mechzspawn" },
    { 0x13EA5D88, "mechzspawnsetup" },
    { 0x67763009, "mechzstopflame" },
    { 0xBCD1C0B9, "mechzstumbleend" },
    { 0x48571752, "mechzstumblestart" },
    { 0x76B932DD, "mechzstumbleupdate" },
    { 0x7561480F, "mechzstunend" },
    { 0x5EA3A844, "mechzstunstart" },
    { 0xC65C7003, "mechzstunupdate" },
    { 0xCD318530, "mechztargetservice" },
    { 0x03B4E0A4, "mechzupdateflame" },
    { 0x601FF508, "mechzweapondamagemodifier" },
    { 0x42500ED0, "mechzzombieeligibleforberserkknockdown" },
    { 0x3683D125, "med" },
    { 0x5022FBB8, "med_dist" },
    { 0xD5F1F461, "med_spark_wire" },
    { 0xFFCC504E, "medal" },
    { 0x697B427C, "medal_kills" },
    { 0xD53C57BE, "medalcallbacks" },
    { 0xE59ADBEF, "medalearned" },
    { 0xBA3ED635, "medalgiven" },
    { 0x564B33EA, "medalindex" },
    { 0x31849566, "medalinfo" },
    { 0x68E6ADD3, "medalname" },
    { 0x6FBB9DAA, "medalnotifyqueue" },
    { 0x36C796F1, "medals" },
    { 0xD60AC5AB, "medals_shared" },
    { 0x9655A631, "medals_specialist_abilities_index" },
    { 0xA111CE90, "medalsenabled" },
    { 0x4BAD4EAD, "medalsettings" },
    { 0x6C3BFC0A, "medaltable" },
    { 0x4EE4C220, "medevac" },
    { 0x0224AEB9, "medfire" },
    { 0x076D5969, "media_control_room" },
    { 0x022656EE, "medians" },
    { 0x8ABD8211, "medic" },
    { 0x10B48E28, "medic_death_align" },
    { 0x4770772C, "medic_focus" },
    { 0x82BEEF1C, "medic_groups" },
    { 0xA135CA6C, "medic_guys" },
    { 0xFD878B6B, "medic_huey" },
    { 0x1D3AA88B, "medic_soldier_names" },
    { 0x1EEB80C2, "medical" },
    { 0xDC533825, "medicine" },
    { 0xA724AAF8, "medics" },
    { 0xB2190A80, "medium" },
    { 0x23E4F599, "medium1" },
    { 0x2F682831, "medium_fans" },
    { 0x2C9604A4, "medium_fans_think" },
    { 0x822EA49F, "medium_rare" },
    { 0xAB3DAD3F, "mediumweapons" },
    { 0xDFAD2374, "meesage" },
    { 0xFF1AACA0, "meet" },
    { 0x7D67BC53, "meet_hero" },
    { 0x29C95F2B, "meet_hero2" },
    { 0x356CCA45, "meet_hero_in_forest" },
    { 0x1AF72E50, "meet_menendez_objectives" },
    { 0x881D78D9, "meet_second_squad_handler" },
    { 0x1765FD38, "meet_up" },
    { 0x132B7D2E, "meet_up_end" },
    { 0x9DE3431E, "meet_up_obj" },
    { 0x9685C838, "meeting" },
    { 0xBABA5900, "meeting_catchup_org" },
    { 0xF5C55AF1, "meeting_clip" },
    { 0xC9A535CE, "meeting_door_open" },
    { 0x11A7E34C, "meeting_sound" },
    { 0x34A6965D, "meeting_start" },
    { 0xC83EEE4B, "meets" },
    { 0xA4F41497, "meetup" },
    { 0xE466C828, "meetup_with_bowman_brooks" },
    { 0xBD5CFE6F, "meetupwithothercharacters" },
    { 0x1A7D8393, "mega" },
    { 0xCDA98D04, "megaexplosion" },
    { 0x18D2A221, "megaphone" },
    { 0x15EF6E12, "megaphone_vignette" },
    { 0x6E661439, "meh" },
    { 0x80CD1C21, "mehzors" },
    { 0x7D06DF0A, "mekes" },
    { 0x8432FFF3, "melee" },
    { 0xFC3980DC, "melee_01_terrorist" },
    { 0xD6FA15DD, "melee_01_terrorist_cancel" },
    { 0x8BDA8341, "melee_01_yemeni" },
    { 0xC2D8F7AA, "melee_01_yemeni_cancel" },
    { 0xCE173E78, "melee_able_timer" },
    { 0x3B1F6CFB, "melee_acquiremutex" },
    { 0x7B19EBFC, "melee_actor_bounds_radius" },
    { 0x2719217A, "melee_actor_bounds_radius_minus_epsilon" },
    { 0x0FA82629, "melee_aivsai_animcustominterruptionmonitor" },
    { 0x526D47F7, "melee_aivsai_chooseaction" },
    { 0xFA34AF27, "melee_aivsai_execute" },
    { 0xF729A482, "melee_aivsai_exposed_chooseanimationandposition" },
    { 0xEB88DAB5, "melee_aivsai_exposed_chooseanimationandposition_behind" },
    { 0xBE1F66DD, "melee_aivsai_exposed_chooseanimationandposition_buildexposedlist" },
    { 0xE96760A8, "melee_aivsai_exposed_chooseanimationandposition_flip" },
    { 0x1A8F35B7, "melee_aivsai_exposed_chooseanimationandposition_wrestle" },
    { 0x6683753E, "melee_aivsai_getinposition" },
    { 0x86C0F647, "melee_aivsai_getinposition_finalize" },
    { 0x1B906973, "melee_aivsai_getinposition_issuccessful" },
    { 0x01F40534, "melee_aivsai_getinposition_updateandvalidatetarget" },
    { 0x8C10DD85, "melee_aivsai_main" },
    { 0x5A04ADF6, "melee_aivsai_schedulenotetracklink" },
    { 0x26949FB8, "melee_aivsai_specialcover_canexecute" },
    { 0xD7B8A25C, "melee_aivsai_specialcover_chooseanimationandposition" },
    { 0x37386689, "melee_aivsai_targetlink" },
    { 0x05334031, "melee_align" },
    { 0x3CD114F1, "melee_and_grenade_spawns" },
    { 0xAF611FD9, "melee_anim" },
    { 0xABD5A426, "melee_anim_func" },
    { 0x1CFF43AB, "melee_anim_state" },
    { 0x031B63E0, "melee_attach_knife_harper" },
    { 0x8EBA5EF5, "melee_attach_knife_player" },
    { 0x90D71E42, "melee_attack" },
    { 0x7E384F06, "melee_attack_anim" },
    { 0x64F288EC, "melee_attack_dist_thread" },
    { 0xF1003174, "melee_attack_msg" },
    { 0x374B5D6F, "melee_bloodfx_knife_harper" },
    { 0xA335E7B6, "melee_bloodfx_knife_player" },
    { 0x4C4C86C6, "melee_cb_radio_audio" },
    { 0xB2D40D1A, "melee_changed" },
    { 0xBAD004FB, "melee_chooseaction" },
    { 0xB4549AFD, "melee_comabt_1_vignette" },
    { 0x8DB4EDCC, "melee_comabt_2_vignette" },
    { 0xA6542123, "melee_count" },
    { 0x2FC4C698, "melee_death" },
    { 0xC0D9C7DF, "melee_deathhandler_delayed" },
    { 0x68D80AB1, "melee_deathhandler_regular" },
    { 0x2BEC7B4C, "melee_decide_winner" },
    { 0xEC4422CE, "melee_detach_knife_harper" },
    { 0x5093064F, "melee_detach_knife_player" },
    { 0xE886FADE, "melee_did_not_happen" },
    { 0xA9859B34, "melee_digbat_init" },
    { 0xA0219ADD, "melee_digbat_pain_override" },
    { 0xF304F8AE, "melee_disableinterruptions" },
    { 0xDE8C4C8A, "melee_dist" },
    { 0x45F54989, "melee_dist_sq" },
    { 0xA7D66D93, "melee_distance" },
    { 0xCFF4BFA6, "melee_done" },
    { 0x6BA43E9E, "melee_droppedweaponmonitorthread" },
    { 0x733E2EFE, "melee_droppedweaponrestore" },
    { 0x520EC71D, "melee_early_end" },
    { 0x372DA1E5, "melee_end" },
    { 0xFF2F1480, "melee_endscript" },
    { 0x685A2E99, "melee_endscript_checkdeath" },
    { 0x282BF4D0, "melee_endscript_checkpositionandmovement" },
    { 0x49F85873, "melee_endscript_checkstatechanges" },
    { 0xD2A4730D, "melee_endscript_checkweapon" },
    { 0x75D8900C, "melee_enemy_distance_prediction_time" },
    { 0x231EE9D9, "melee_enemy_type" },
    { 0x1C370753, "melee_enemy_type_firefly" },
    { 0x252036F0, "melee_ever_released" },
    { 0xCB976471, "melee_failed" },
    { 0x350A1F3A, "melee_fire" },
    { 0x87BAD954, "melee_ger" },
    { 0xB36E5130, "melee_grace_period_given_time" },
    { 0x157CE55E, "melee_guard_02" },
    { 0x3B7F5FC7, "melee_guard_03" },
    { 0x5973B48C, "melee_guy1" },
    { 0x758FE684, "melee_handlenotetracks" },
    { 0x79CAFDF3, "melee_handlenotetracks_death" },
    { 0x69D9DA52, "melee_handlenotetracks_shoulddieafterunsync" },
    { 0x2B474EB7, "melee_handlenotetracks_unsync" },
    { 0x212C1228, "melee_hatchet_init" },
    { 0xBE453360, "melee_height_sav" },
    { 0x2FBEFA48, "melee_hits" },
    { 0x3EE82DAC, "melee_hits_half" },
    { 0x94E21A75, "melee_id" },
    { 0x27538EEB, "melee_in_position" },
    { 0xBD305CC6, "melee_info" },
    { 0x2C34A210, "melee_init" },
    { 0x2B836209, "melee_inner_radius_damage" },
    { 0x74EDDA17, "melee_instakill" },
    { 0x18D3C1E0, "melee_isvalid" },
    { 0x20EF86CA, "melee_kill" },
    { 0x1CE70F05, "melee_kills" },
    { 0xAFBE3F56, "melee_kills_total" },
    { 0x26F4A5A3, "melee_machete" },
    { 0x94277CD3, "melee_mainloop" },
    { 0xD7BC49AF, "melee_miss_func" },
    { 0x6A169509, "melee_mpla_init" },
    { 0x25C5951A, "melee_mpla_pain_override" },
    { 0xDB45C033, "melee_name" },
    { 0xD700D0FA, "melee_near_range" },
    { 0xEDC279B9, "melee_near_range_sq" },
    { 0x59B76664, "melee_needsweaponswap" },
    { 0xE251A85D, "melee_normal_end" },
    { 0xCBC34D49, "melee_notify_wrapper" },
    { 0xD708A40F, "melee_num_variations" },
    { 0xB8FB4894, "melee_origin" },
    { 0xE1C66828, "melee_outer_radius_damage" },
    { 0x04F44272, "melee_pain" },
    { 0x7C49B602, "melee_partnerendedmeleemonitorthread" },
    { 0x07E2F467, "melee_partnerendedmeleemonitorthread_shouldanimsurvive" },
    { 0x00AE1D32, "melee_path_blocked" },
    { 0xD814CBCD, "melee_playchargesound" },
    { 0x701167F1, "melee_player_attach_knife" },
    { 0x68A1DF6F, "melee_player_detach_knife" },
    { 0xD1696E57, "melee_points" },
    { 0x4C4FD3E9, "melee_pos1" },
    { 0x72524E52, "melee_pos2" },
    { 0x9854C8BB, "melee_pos3" },
    { 0x77CEC220, "melee_pressed" },
    { 0x8842D2C8, "melee_radius" },
    { 0x45F8EB45, "melee_range" },
    { 0x18765211, "melee_range_max_sq" },
    { 0x8C0EB6E6, "melee_range_sav" },
    { 0xB1CCC210, "melee_range_sq" },
    { 0x972FF182, "melee_range_z" },
    { 0xCC18CB0A, "melee_releasemutex" },
    { 0xE0C10085, "melee_resetaction" },
    { 0x9AE44564, "melee_run_dialog" },
    { 0x6DA84E57, "melee_russ" },
    { 0x183709B4, "melee_sampan_bubbles" },
    { 0x865278C9, "melee_sampan_neck_stab" },
    { 0x9B25D38E, "melee_sampan_water_hit" },
    { 0x8CACE6E0, "melee_score" },
    { 0xD679D389, "melee_sequence" },
    { 0x9D8C287A, "melee_sequence_begins" },
    { 0xFB882711, "melee_standard_checktimeconstraints" },
    { 0xA5ACBCA5, "melee_standard_chooseaction" },
    { 0x3FF7893E, "melee_standard_delaystandardcharge" },
    { 0xB9AECDEC, "melee_standard_getinposition" },
    { 0x3ED58BFB, "melee_standard_main" },
    { 0x61C97400, "melee_standard_playattackloop" },
    { 0xA27DC53A, "melee_standard_resetgiveuptime" },
    { 0x35C4E38B, "melee_standard_updateandvalidatetarget" },
    { 0x737EEFF9, "melee_startmovement" },
    { 0x84793039, "melee_stealthcheck" },
    { 0x90A74B46, "melee_stop" },
    { 0x749B86F9, "melee_stopmovement" },
    { 0x66C86675, "melee_succeeded" },
    { 0x11E36150, "melee_swipe" },
    { 0x7C04AE7A, "melee_thread" },
    { 0x76A48201, "melee_time" },
    { 0xFB2152BE, "melee_todo" },
    { 0xD0151ED8, "melee_trace_z_offset" },
    { 0x429AF530, "melee_training" },
    { 0x42025771, "melee_triggers" },
    { 0xE2695EE3, "melee_tryexecuting" },
    { 0x6E3CD007, "melee_unlink" },
    { 0xE194E8E8, "melee_unlinkinternal" },
    { 0xC7BF9810, "melee_updateandvalidatestartpos" },
    { 0xD23CC771, "melee_variant" },
    { 0xC4190CDE, "melee_victim" },
    { 0x42085BF1, "melee_view_dot" },
    { 0x44109998, "melee_vignette" },
    { 0x89B6098F, "melee_vomit_fx_chance" },
    { 0x5B86FE2E, "melee_weapon" },
    { 0xBA4BB334, "melee_weapon_ent" },
    { 0x25FC5C36, "melee_weapon_show" },
    { 0x71B5D175, "melee_weapon_structs" },
    { 0x031E7D5B, "melee_weapon_think" },
    { 0x79ABB0E2, "melee_weapon_triggers" },
    { 0x75DC7ED5, "melee_width_sav" },
    { 0xCE71FBF7, "melee_wnd" },
    { 0xCCFFF6E5, "melee_wrestle_logic" },
    { 0x23645C43, "melee_yaw_threshold" },
    { 0x7A9DFE31, "melee_yaw_thresholdnear" },
    { 0x5AB10B26, "meleeacquiremutex" },
    { 0xACA4340A, "meleealwayswin" },
    { 0xE0B9D374, "meleeanim" },
    { 0xCBF7B430, "meleeanimtraveldist" },
    { 0xA8F12405, "meleeanimvarientindex" },
    { 0x8C721467, "meleeattackdist" },
    { 0x07A8C549, "meleeattackdist_old" },
    { 0x85C35CC9, "meleeattackers" },
    { 0x9B636808, "meleeattackwhilemoving" },
    { 0x45625EC6, "meleebiteattackplayer" },
    { 0x53AE9650, "meleebiteattackplayer2" },
    { 0xA211833B, "meleebundle" },
    { 0xE2BBB6DA, "meleebundles" },
    { 0xF645AF0F, "meleebuttonpressed" },
    { 0xEBF990DF, "meleechargedistsq" },
    { 0xC71CFF0F, "meleecombat" },
    { 0x639F38EA, "meleecompleted" },
    { 0xA1B5430C, "meleecoverchargegraceendtime" },
    { 0x171CA86F, "meleecoverchargemintime" },
    { 0x67A2224D, "meleed" },
    { 0x9BA55DE4, "meleedamage" },
    { 0xBD7A4EBB, "meleedeath" },
    { 0x01FCE5F1, "meleedebugprint" },
    { 0x5DF72119, "meleedebugprintthread" },
    { 0x6346C1B6, "meleedebugprintthreadwrapper" },
    { 0xA055C01C, "meleedebugthread" },
    { 0xFBE247AF, "meleedist" },
    { 0xEE3BFBBB, "meleedistsq" },
    { 0xB895948C, "meleedontrestoreweapon" },
    { 0xD7047444, "meleedot" },
    { 0x96206110, "meleeendfunc" },
    { 0x5288FE83, "meleeendposition" },
    { 0x847323F8, "meleeface" },
    { 0x3D7354E8, "meleeforcedexposedbehind" },
    { 0xFA57D9ED, "meleeforcedexposedflip" },
    { 0xDABFAD30, "meleeforcedexposedwrestle" },
    { 0xBEF59285, "meleefx" },
    { 0xFA8830C1, "meleeglobals" },
    { 0x0FEFC75D, "meleeignoreslightarmor" },
    { 0xC149076D, "meleeing" },
    { 0xF2122428, "meleekilltarget" },
    { 0x7EBC305B, "meleelength" },
    { 0x8EBC01EF, "meleelink" },
    { 0x31454524, "meleenotetrackhandler" },
    { 0x71D9AF0F, "meleepartner" },
    { 0x79802527, "meleepoint" },
    { 0xC6C324AA, "meleerange" },
    { 0xE5EF01C3, "meleerangemultiplier" },
    { 0x1E4CCC46, "meleerangesq" },
    { 0x52E9FD3C, "meleereach" },
    { 0x517AA123, "meleereleasemutex" },
    { 0x55C259A2, "melees" },
    { 0xDF942D38, "meleeseq" },
    { 0x103A67C7, "meleeseqanim" },
    { 0xD7DE4ABE, "meleeseqanims" },
    { 0xBF845D93, "meleeseqs" },
    { 0x711039FC, "meleesequenceoverride" },
    { 0x182DA8D6, "meleestarted" },
    { 0x5A2EB000, "meleestartposition" },
    { 0xE021CA16, "meleestate" },
    { 0x146A1141, "meleestrugglevsai" },
    { 0x9205D9DF, "meleestrugglevsdog" },
    { 0xFE0C8AB1, "meleestrugglevsdog_end" },
    { 0x8D175D67, "meleestrugglevsdog_endcheck" },
    { 0x7222DBA0, "meleestrugglevsdog_interruptedcheck" },
    { 0xFC1E100F, "meleethreat" },
    { 0x696D22F4, "meleetimeout" },
    { 0x3D0CA08B, "meleetraining_end" },
    { 0x6ADE90E7, "meleeweapon" },
    { 0x28E9A25E, "meleeweapons" },
    { 0x84D43A8E, "meleewithoffset" },
    { 0x71CA1376, "meleing" },
    { 0x2AF08549, "melissa" },
    { 0xAFF2F75C, "melle" },
    { 0x137E513E, "melon" },
    { 0x36376544, "melon_model" },
    { 0xCAC562AB, "melon_think" },
    { 0x071B12B3, "melt" },
    { 0xEDF75305, "mem_courtyard_enemies" },
    { 0xA146ED1D, "mem_courtyard_kill_optional_spawns" },
    { 0x434F0B4C, "mem_truck_road_warning" },
    { 0xD606ED47, "mem_truck_target_logic" },
    { 0xBAF391D7, "member" },
    { 0x8C2F9009, "member_ahead" },
    { 0x1A29137E, "memberaddfunc" },
    { 0x267F8E61, "memberaddfuncs" },
    { 0x6A4005CE, "memberaddstrings" },
    { 0x9970A069, "membercombatwaiter" },
    { 0x961A8B64, "membercount" },
    { 0x952BD485, "memberdeathwaiter" },
    { 0x1EB360A8, "memberid" },
    { 0xE79F7A05, "memberremovefunc" },
    { 0xD41B3494, "memberremovefuncs" },
    { 0x6E6606C3, "memberremovestrings" },
    { 0x6AE8038E, "members" },
    { 0xF6427A59, "meme_courtyard_spawn_truck_target_center_early" },
    { 0xF4D11EA3, "memebers" },
    { 0x2A9EEF0B, "memo" },
    { 0xC20D38F4, "memories" },
    { 0xAC2A0078, "memory" },
    { 0x5274F2AF, "men" },
    { 0xDC56AEBE, "men_node" },
    { 0xB2F76069, "menacing" },
    { 0xB25B29BD, "mendendez" },
    { 0x929A8549, "menedez" },
    { 0x85404300, "menedez_ambush" },
    { 0x80F35F65, "menende_plane_elevator" },
    { 0x45236E7D, "menendex" },
    { 0x9128634F, "menendez" },
    { 0xCDDC67B5, "menendez_alive" },
    { 0x630F5037, "menendez_animations" },
    { 0x2DB3DC5C, "menendez_at_door" },
    { 0xFEE02B52, "menendez_blink_end" },
    { 0xFCDA3596, "menendez_bloody_body" },
    { 0x39A0ACC8, "menendez_bloody_head" },
    { 0xC41A4BC6, "menendez_bloody_version" },
    { 0x1426913A, "menendez_caps_hudsons_left_knee" },
    { 0x6DF87FBB, "menendez_caps_hudsons_right_knee" },
    { 0x82753674, "menendez_capture" },
    { 0x4F628897, "menendez_chickens_cleanup" },
    { 0xB601C3B4, "menendez_chickens_setup" },
    { 0x02CB347A, "menendez_cleanup" },
    { 0x5A7AE953, "menendez_cleanup_after_anim" },
    { 0x574D0FF6, "menendez_combat_actor_callback" },
    { 0x69F93048, "menendez_combat_setup" },
    { 0xD0D6BA32, "menendez_control_room_combat_spawnfunc" },
    { 0xEC72E5DE, "menendez_control_room_navy_cine_spawnfunc" },
    { 0xE2801E7E, "menendez_control_room_navy_spawnfunc" },
    { 0x0582DF87, "menendez_crew_pathing" },
    { 0x0988E68C, "menendez_elevator" },
    { 0x12BAF406, "menendez_enter_mission_fail" },
    { 0x0F6387BF, "menendez_enter_plane" },
    { 0xBC1978CD, "menendez_execution_after_rage_vo" },
    { 0xF7D96757, "menendez_execution_intro_vo" },
    { 0x4724D272, "menendez_execution_near_stables_vo" },
    { 0x93FA791A, "menendez_execution_vo" },
    { 0xB2A13F4C, "menendez_exit_opendoors" },
    { 0xF09125C5, "menendez_exited" },
    { 0x695D0F26, "menendez_fire" },
    { 0x1CD1C287, "menendez_fly_into_sunset" },
    { 0xB76A879C, "menendez_give_weapon" },
    { 0x6A814F95, "menendez_grabs_player" },
    { 0x44641D6B, "menendez_greeters_animate" },
    { 0x30C0058A, "menendez_greeters_defalco_animate" },
    { 0x586839E4, "menendez_gun" },
    { 0x9FE1574D, "menendez_hack" },
    { 0xDD346DB6, "menendez_hallway_vo" },
    { 0x03A71D46, "menendez_hangar_ambience" },
    { 0x3A71770A, "menendez_hangar_cleanup" },
    { 0x0CE66A3C, "menendez_hangar_navy_spawnfunc" },
    { 0x65E4EA8C, "menendez_hangar_pmc_spawnfunc" },
    { 0xC9DD08F1, "menendez_hangar_setup" },
    { 0x13F30468, "menendez_headshot" },
    { 0xF13007A6, "menendez_hijack_scene_check" },
    { 0x17A1E6E4, "menendez_hill_ai_behaviors" },
    { 0x6FF638B7, "menendez_hill_ai_vs_ai" },
    { 0xFB918D53, "menendez_hill_animations" },
    { 0xE902290F, "menendez_hill_brutality_scene" },
    { 0xAB2D2E55, "menendez_hill_civ_fleeing" },
    { 0x08C8D73C, "menendez_hill_compelete" },
    { 0x67C5AA07, "menendez_hill_door_back_logic" },
    { 0x4A0279B9, "menendez_hill_door_front_logic" },
    { 0xBB63A49A, "menendez_hill_intro_vo" },
    { 0x16679149, "menendez_hill_retreat_2nd_floor" },
    { 0xE7B1A464, "menendez_hill_retreat_intro" },
    { 0xCD190393, "menendez_hill_slide_to_cover" },
    { 0xF1EDA947, "menendez_hill_spawn_funcs" },
    { 0x25996ED5, "menendez_hill_stair_ai_logic" },
    { 0xD838F664, "menendez_hill_stair_trigger" },
    { 0x468CAF73, "menendez_hill_vo" },
    { 0x853DCA02, "menendez_in_jail" },
    { 0xE47DEE48, "menendez_intro" },
    { 0x5B96AFDB, "menendez_intro_anims" },
    { 0x69C4872A, "menendez_intro_bloody_viewbody" },
    { 0xF11D21C8, "menendez_intro_blur" },
    { 0x034DE749, "menendez_intro_cleanup" },
    { 0x8C67133C, "menendez_intro_glass_stab" },
    { 0x8C17555B, "menendez_intro_hallway" },
    { 0x026689B7, "menendez_intro_hallway_animate_group" },
    { 0x45A0D5E0, "menendez_intro_not_mature_black_screen" },
    { 0x9E0CC556, "menendez_intro_opendoors" },
    { 0x3A3EB71E, "menendez_intro_part1_fade_notetrack" },
    { 0x943283C7, "menendez_intro_part1_rage_notetrack" },
    { 0x80BFAF9B, "menendez_intro_part2_rage_start" },
    { 0xD3C820EA, "menendez_intro_player_setup" },
    { 0xE9997569, "menendez_intro_scene" },
    { 0xE9E10B82, "menendez_intro_unlink_player" },
    { 0xB238C172, "menendez_kill_player" },
    { 0x4A775C16, "menendez_killspawners_execution" },
    { 0xF2837A45, "menendez_killspawners_hill" },
    { 0x6B748132, "menendez_killspawners_intro" },
    { 0xC861F025, "menendez_killspawners_mission_approach" },
    { 0x30E92CD2, "menendez_killspawners_mission_courtyard" },
    { 0x3D930191, "menendez_killspawners_mission_hallway" },
    { 0x89EFBBEC, "menendez_killspawners_stables" },
    { 0x79FD189A, "menendez_mask_on" },
    { 0xEA6293C7, "menendez_meatshield_anims" },
    { 0xB3CC35CF, "menendez_meatshield_part_2" },
    { 0x0781FF91, "menendez_model" },
    { 0xC6A984AA, "menendez_movie" },
    { 0xDCFFD70B, "menendez_near_mission_vo" },
    { 0xD3A3981F, "menendez_near_plane" },
    { 0xFAE33F01, "menendez_nodes" },
    { 0x4792B881, "menendez_old" },
    { 0x5F3FEA5B, "menendez_opens_stables_door" },
    { 0xEE5FF02B, "menendez_pendant_switch" },
    { 0x2BC756DD, "menendez_performed_cinematic_melee" },
    { 0xF115E491, "menendez_pip" },
    { 0x7316B283, "menendez_pip_started" },
    { 0x8FA11C1E, "menendez_riding_elevator" },
    { 0x950850C6, "menendez_section_done" },
    { 0xCFC6EF02, "menendez_shot" },
    { 0x1B4C65C8, "menendez_shot_complete" },
    { 0xF54D82AF, "menendez_slits_hudsons_throat" },
    { 0xF8730705, "menendez_spawners_clean_up" },
    { 0xF611747C, "menendez_speech" },
    { 0xBCAD4C25, "menendez_speech_defalco" },
    { 0xA8A7A937, "menendez_speech_done_player_setup" },
    { 0xB6342702, "menendez_speech_opendoors" },
    { 0x8A3B0294, "menendez_speech_player" },
    { 0xD3A18059, "menendez_speech_start" },
    { 0xB1DA0E1E, "menendez_stables_explosion" },
    { 0x22BC5FE7, "menendez_standing_viewheight" },
    { 0x3F7F0D37, "menendez_surrenders" },
    { 0x92D64313, "menendez_surveillance_bypass_fail" },
    { 0x6F92C3CC, "menendez_surveillance_event" },
    { 0xE6269B4D, "menendez_title_card" },
    { 0x322FC1FB, "menendez_trigs" },
    { 0xA6622E8F, "menendez_turret_down" },
    { 0xF67DAE1E, "menendez_turret_end" },
    { 0xA1F606D0, "menendez_turret_left" },
    { 0x4AA59EFF, "menendez_turret_right" },
    { 0x39BD0A8D, "menendez_turret_start" },
    { 0x889C71E0, "menendez_turret_up" },
    { 0xA199F3DC, "menendez_viewarms" },
    { 0x0E58B135, "menendez_viewbody" },
    { 0xB9BBF5ED, "menendez_viewhands" },
    { 0x997B66A5, "menendez_vtol" },
    { 0x4EDDE563, "menendez_vtol_engines_off" },
    { 0x6A87C7AF, "menendez_vtol_engines_on" },
    { 0x432292EE, "menendez_vtol_engines_on_final" },
    { 0x5CFF680A, "menendez_vtol_turret_manager" },
    { 0x2D166AA5, "menendez_weapons" },
    { 0x0166B060, "menendezchangedvar" },
    { 0x3439078B, "menendezendrecording" },
    { 0x3E362111, "menendezglasses" },
    { 0xCA1FA5DE, "menendezstartrecording" },
    { 0x43FA91E9, "ment" },
    { 0xBD8BA152, "mental_guy" },
    { 0x53518820, "mental_guy_align" },
    { 0x18A9CC92, "mentioned" },
    { 0x7C4A13B4, "mentions" },
    { 0x1DF81780, "menu" },
    { 0x94A80495, "menu_action" },
    { 0xE05CB503, "menu_auto_start" },
    { 0xEFF0D149, "menu_bayonet_aim_range" },
    { 0xA87D1468, "menu_bayonet_charge_anim" },
    { 0xD849EAB4, "menu_bayonet_charge_time" },
    { 0xC637100F, "menu_bayonet_damage" },
    { 0x699B1BA8, "menu_bayonet_melee_anim" },
    { 0xC5A702F4, "menu_bayonet_melee_time" },
    { 0x0D284CEB, "menu_bayonet_range" },
    { 0x5A68F038, "menu_bayonet_weapon" },
    { 0x53E6DF8D, "menu_bkg" },
    { 0x69C6C918, "menu_button_pressed" },
    { 0x57A2471F, "menu_change" },
    { 0xB49445EA, "menu_change_class" },
    { 0x11C841DA, "menu_change_class_barebones" },
    { 0x2A2FACF0, "menu_change_class_custom" },
    { 0x243AE695, "menu_change_class_wager" },
    { 0x71878212, "menu_change_selected_fx" },
    { 0x2BA98ADB, "menu_changeclass_team" },
    { 0x7A8B2ABE, "menu_choose_attachment_model" },
    { 0xBF9F5454, "menu_choose_light_slot" },
    { 0x039ABACB, "menu_choose_lightfx" },
    { 0x6F589725, "menu_class" },
    { 0x44BD0483, "menu_class_team" },
    { 0xD15693D7, "menu_closed" },
    { 0x29D9838D, "menu_controls" },
    { 0xC076B585, "menu_cursor" },
    { 0x94E8D9A8, "menu_damage" },
    { 0xBB7F7C57, "menu_data" },
    { 0x85E80D04, "menu_edit_choose_class" },
    { 0xA2B21F98, "menu_freerun_restart" },
    { 0x1C90BBDF, "menu_fx_creation" },
    { 0x13A05942, "menu_fx_option_set" },
    { 0x5DB53DDC, "menu_fx_type" },
    { 0xA07BF581, "menu_handler" },
    { 0xC9176F25, "menu_health" },
    { 0x31EADFFC, "menu_hitloc" },
    { 0xDFCFCEA9, "menu_index" },
    { 0xC5DE8BD1, "menu_init" },
    { 0x73594C70, "menu_init_team_allies" },
    { 0xBC6CA571, "menu_init_team_axis" },
    { 0xA0EF74A9, "menu_input" },
    { 0xE821356E, "menu_leavegame" },
    { 0x0D0D5BE4, "menu_limit" },
    { 0x4CF25151, "menu_list_selected" },
    { 0xDFDC5020, "menu_main" },
    { 0xE8C48624, "menu_message" },
    { 0xA467390A, "menu_name" },
    { 0x88870964, "menu_onmenuresponse" },
    { 0xF527D153, "menu_onplayerconnect" },
    { 0x41EC59A7, "menu_options" },
    { 0xC2285616, "menu_perks" },
    { 0x7CCB2C2E, "menu_range" },
    { 0xFE62A8E7, "menu_resetstate" },
    { 0x6EA16F87, "menu_response_queue_pump" },
    { 0x694DD811, "menu_restart_game" },
    { 0x3DB3A8F9, "menu_scoreboard" },
    { 0x1F1EDD77, "menu_selection" },
    { 0x623D6F42, "menu_snapshot_amb" },
    { 0x605C3E41, "menu_snapshot_noamb" },
    { 0xB2483A6D, "menu_snapshot_sets" },
    { 0x2E05DE46, "menu_spectate" },
    { 0x6E8EC88D, "menu_start_menu" },
    { 0x3415BD7A, "menu_sys" },
    { 0x46EDDB0C, "menu_team" },
    { 0x8BB034B3, "menu_video_mapping" },
    { 0xA56FF43B, "menu_wager_side_bet" },
    { 0xD5D15751, "menu_wager_side_bet_player" },
    { 0x45F02CCB, "menu_weapon" },
    { 0xFF218DEB, "menu_weapon_name" },
    { 0x122667B2, "menuallies" },
    { 0x6A501517, "menuallieszombies" },
    { 0x007EC49A, "menuautoassign" },
    { 0x3EDD7B93, "menuaxis" },
    { 0x6EDE0F48, "menuclass" },
    { 0x86BBCF1A, "menucreatesquad" },
    { 0x6782F115, "menudef" },
    { 0xC3CA2373, "menudefinition" },
    { 0xC2DC2B72, "menuhandle" },
    { 0x93731541, "menuheight" },
    { 0x8443A316, "menujoinsquad" },
    { 0xF27BCD61, "menuleavesquad" },
    { 0x21FF3CA0, "menuloadout" },
    { 0x6BC72CE9, "menulocksquad" },
    { 0x5F8BD4B9, "menuname" },
    { 0x3CCC81F6, "menunone" },
    { 0x0D112EBE, "menureferenceforkillstreak" },
    { 0xD2C577ED, "menuresponse" },
    { 0x7518209D, "menuresponse_queue" },
    { 0x06CF9542, "menuresponsequeue" },
    { 0x188D6288, "menuresponsequeuepump" },
    { 0xC0A9FBAB, "menus" },
    { 0xD692C707, "menushowsquadinfo" },
    { 0xB62ABD87, "menuspectator" },
    { 0x6253C308, "menustack" },
    { 0x2DCB748F, "menustate" },
    { 0x37F382F0, "menustate_credits" },
    { 0xB266EAC2, "menustate_disabled" },
    { 0xDA106D89, "menustate_lockout" },
    { 0xE1131A55, "menustate_main" },
    { 0xDFD9E41C, "menustate_none" },
    { 0xD131C8E2, "menustate_secret" },
    { 0x44D2A765, "menustate_strikeforce" },
    { 0x80AE63BB, "menuteam" },
    { 0xF39FA238, "menutype" },
    { 0x4A73E932, "menuunlocksquad" },
    { 0xF13A03C2, "merc" },
    { 0xFC9A3C2F, "mercenaries" },
    { 0x6F79D64E, "merch" },
    { 0x4A22A89F, "merch_first_pass" },
    { 0xF7FA6131, "merchant" },
    { 0x08809A4D, "merchant_boat_1_sounds" },
    { 0xA50B653F, "merchant_boat_1_sounds_off" },
    { 0x9164CF43, "merchant_boat_3_sounds" },
    { 0x360F4E45, "merchant_boat_3_sounds_off" },
    { 0x0A8E1CFC, "merchant_boat_alarm" },
    { 0xC4EE547C, "merchant_boat_pa" },
    { 0xBCF0AC5D, "merchant_boat_sink_me" },
    { 0x63837DC0, "merchant_boat_siren" },
    { 0x1160DE94, "merchant_boat_spots" },
    { 0x223B2010, "merchant_boat_spots_track" },
    { 0xE28B3E96, "merchant_boat_track_damage" },
    { 0x47EF34FB, "merchant_boat_trip25" },
    { 0xF533FC70, "merchant_boat_trip25_lead_target" },
    { 0x472F9D33, "merchant_boat_trip25_track" },
    { 0xCF63F898, "merchant_boats_alarmed" },
    { 0xBEA84CBF, "merchant_boats_spots_break" },
    { 0xDE7E3CBF, "merchant_drone_light" },
    { 0x8AC91D83, "merchant_old_count" },
    { 0x32457A1E, "merchant_ship_count" },
    { 0x6B2E442D, "merchant_ship_death_count" },
    { 0xA2FB78C0, "merchant_ship_death_thread" },
    { 0x3CF028DF, "merchant_ship_init" },
    { 0x34D1234E, "merchant_ship_number" },
    { 0x5398A99B, "merchant_ship_x" },
    { 0xBEB269C7, "merchant_start_deck_gun" },
    { 0x51595BB1, "merchant_start_tower_gun" },
    { 0xCF487D95, "merchantability" },
    { 0xBC56FBC2, "merchantships" },
    { 0x0C54B360, "merciful" },
    { 0xB93BE20D, "mercs" },
    { 0x3554AA27, "mercy" },
    { 0xE3C4AB51, "merely" },
    { 0x770F0BA2, "mergable" },
    { 0x79ABCE7F, "merge" },
    { 0x0B95FEA0, "merge_point" },
    { 0xC49A929D, "merge_size" },
    { 0x434D221A, "merge_sort" },
    { 0x55993B38, "merge_squad" },
    { 0x7508CA56, "merge_squad_member_max" },
    { 0x39EB4A9D, "merge_sunbrightness" },
    { 0xB0A9C2CD, "merge_suncolor" },
    { 0x251C7B23, "merge_sunsingledvar" },
    { 0xFEEE2E09, "merge_to" },
    { 0x111BF76A, "merge_truck_destruction" },
    { 0xDCA55415, "merge_weapons" },
    { 0x2F7E40E9, "merged" },
    { 0xED378F63, "mergesort" },
    { 0x9BE9E3FA, "merging" },
    { 0x75F09426, "mermaid" },
    { 0x5A4227A0, "merry" },
    { 0x166D2C4A, "merry_go_round_bottom" },
    { 0x41DAF70B, "merry_grass_delete" },
    { 0xDA613406, "mesh" },
    { 0x1C7F5B12, "meshdist" },
    { 0x0DE7F026, "meshes" },
    { 0x844AE655, "mess" },
    { 0x63050B0A, "message" },
    { 0x71C996D3, "message_about_helicopters" },
    { 0x38663968, "message_array" },
    { 0x873AEA5B, "message_catcher" },
    { 0xA5B4EB80, "message_complete" },
    { 0x6D3FEA0F, "message_created" },
    { 0x901DDCB6, "message_delay" },
    { 0x373B2DDE, "message_delay_quick" },
    { 0x95906EE0, "message_delete" },
    { 0xAAB7C164, "message_deleted" },
    { 0x26AC6F16, "message_displayed" },
    { 0xC5F30AE8, "message_hud" },
    { 0x49B42998, "message_shown" },
    { 0x37BDC232, "message_string" },
    { 0x2BDA763A, "messagegeneratedtime" },
    { 0x4C9E757E, "messagenotifyqueue" },
    { 0x66037445, "messages" },
    { 0xF03267F7, "messagetext" },
    { 0x6158EA14, "messagetexty" },
    { 0x07921EDB, "messaging" },
    { 0x35C90782, "messed" },
    { 0x47A8D02D, "messes" },
    { 0x537C9FD1, "messiah" },
    { 0x7E657B5B, "messiah_exploder" },
    { 0x6BBD254B, "messiah_mode_on" },
    { 0xC5B60553, "messing" },
    { 0xFFE462BE, "messy" },
    { 0xD65C2A95, "met" },
    { 0xA263DB46, "meta" },
    { 0x1CB9D5E3, "metagame_sq_complete" },
    { 0x69BEB05A, "metagame_sq_maxis_complete" },
    { 0x9C83C604, "metagame_sq_richtofen_complete" },
    { 0x706204BE, "metal" },
    { 0xA66C756B, "metal_clip" },
    { 0x673E79AE, "metal_deleter" },
    { 0x6F68CFC5, "metal_door" },
    { 0x1529DC4E, "metal_grate" },
    { 0x3283CA90, "metal_horse" },
    { 0x47A7B435, "metal_list" },
    { 0x18913299, "metal_org" },
    { 0x8756C502, "metal_origins" },
    { 0x94CCAFB0, "metal_storm" },
    { 0x4BDD326F, "metal_storm_calc_path_from_start_node" },
    { 0x5388F66A, "metal_storm_check_for_direction_change" },
    { 0x35A98AA1, "metal_storm_cleanup" },
    { 0x4CC7D76F, "metal_storm_damage_effects" },
    { 0xBCEB17B9, "metal_storm_death_effect" },
    { 0xD01EDDB6, "metal_storm_firing" },
    { 0xB2FE68CB, "metal_storm_intro" },
    { 0xEF56B8C6, "metal_storm_intro_dialog" },
    { 0x1DEC1BB8, "metal_storm_killed" },
    { 0xEADA058D, "metal_storm_moving" },
    { 0xE974491A, "metal_storm_previous_goal" },
    { 0x035DBFD5, "metal_storm_set_speed" },
    { 0x7FBEFAC0, "metal_storm_target" },
    { 0x37EE9C58, "metal_storm_target_practice" },
    { 0x21245D69, "metal_storm_target_think" },
    { 0xD8CA6899, "metal_storm_tree_fall" },
    { 0x68DABC78, "metal_storms_anims" },
    { 0x008407FE, "metal_storms_cleanup" },
    { 0x7B918567, "metal_storms_intruder" },
    { 0xA5CC882D, "metal_storms_setup" },
    { 0x35320AF9, "metalhat" },
    { 0xD32E6C5C, "metalpiece" },
    { 0xF9A295F6, "metalpiece2" },
    { 0x1FA5105F, "metalpiece3" },
    { 0x1593B780, "metalpiece4" },
    { 0x23608AA1, "metals" },
    { 0x1CBDC0B4, "metalsheet1" },
    { 0xCDEC5483, "metalsquadid" },
    { 0xAA2B1709, "metalstorm" },
    { 0x62D1629E, "metalstorm_attack_range" },
    { 0x1A02018A, "metalstorm_blink_lights" },
    { 0x1D9A2318, "metalstorm_check_move" },
    { 0x0FE0591F, "metalstorm_crash_movement" },
    { 0x5A201912, "metalstorm_death" },
    { 0x21783079, "metalstorm_debug" },
    { 0xA8ABFE6D, "metalstorm_emped" },
    { 0x9203A429, "metalstorm_exit_vehicle" },
    { 0x08618C78, "metalstorm_find_new_position" },
    { 0x5976A104, "metalstorm_fire_for_time" },
    { 0xC9EC27FE, "metalstorm_freeze_blink_lights" },
    { 0xD9FEDF26, "metalstorm_freeze_death" },
    { 0x11B4BC1B, "metalstorm_grenade_watcher" },
    { 0xEFDB8FF3, "metalstorm_main" },
    { 0x98F75D60, "metalstorm_mms_charge_watch" },
    { 0xA3BC3D28, "metalstorm_movementupdate" },
    { 0x09A86FCB, "metalstorm_off" },
    { 0x4F760977, "metalstorm_on" },
    { 0xB794780D, "metalstorm_player_bullet_shake" },
    { 0xF8E6ECEC, "metalstorm_player_enter" },
    { 0xDA5AF77F, "metalstorm_player_hit_dudes_sound" },
    { 0x90A84197, "metalstorm_player_rocket_recoil" },
    { 0x820CE329, "metalstorm_rocket_recoil" },
    { 0x8A55405A, "metalstorm_scripted" },
    { 0xE14EA788, "metalstorm_set_team" },
    { 0x8A4525E3, "metalstorm_setup" },
    { 0xFBA0135D, "metalstorm_start_ai" },
    { 0xF142CEB9, "metalstorm_stop_ai" },
    { 0xDA27090C, "metalstorm_think" },
    { 0xE3EF2666, "metalstorm_think2" },
    { 0x8755C479, "metalstorm_turret_on_target_thread" },
    { 0x0C5189E6, "metalstorm_turret_on_vis_target_thread" },
    { 0xD4D55046, "metalstorm_turret_scan" },
    { 0x8D85B536, "metalstorm_update_damage_fx" },
    { 0x6BFB88F1, "metalstorm_update_rumble" },
    { 0xD8A8D391, "metalstorm_weapon_think" },
    { 0x3168770E, "metalstorm_worker_scenes" },
    { 0xBC71E1FE, "metalstormcallback_vehicledamage" },
    { 0xD7B84600, "metalstorms" },
    { 0xA075D806, "metat" },
    { 0x0A59F1A2, "mete" },
    { 0x716C22B1, "meteor" },
    { 0xF9896140, "meteor_counter" },
    { 0x7A006714, "meteor_dialog" },
    { 0x743920AB, "meteor_egg" },
    { 0xE8C300A4, "meteor_egg_play" },
    { 0x464B78E6, "meteor_fx" },
    { 0xFB33B1A2, "meteor_trig" },
    { 0x49B61680, "meteor_trigger" },
    { 0x27752613, "meteor_triggered" },
    { 0x3DE6066B, "meteorite" },
    { 0x4B08D9B7, "meteors_stop_falling" },
    { 0x8258AE04, "meter" },
    { 0x21773E8E, "meter2" },
    { 0xB2772867, "metered" },
    { 0x4008FFA0, "metered_allies" },
    { 0x121B3FB2, "meterors" },
    { 0xC6DB1EB7, "meters" },
    { 0xA7CED472, "method" },
    { 0x17AB82FD, "methods" },
    { 0x3DB749AB, "methodsinit" },
    { 0xC1436AEB, "methodstr" },
    { 0xD0FFE36D, "meticulous" },
    { 0x3EC1CA8A, "metre" },
    { 0xD024EAC5, "metres" },
    { 0x73254289, "metric" },
    { 0xC2A90270, "metro" },
    { 0x1F0E13C8, "metro_ai_wetness_change" },
    { 0xC719FBC3, "metro_arty" },
    { 0x3592B493, "metro_arty_emitters" },
    { 0x7A9003D9, "metro_exitdoor_anim" },
    { 0xB3CA2BA7, "metro_flicker_lights" },
    { 0xF5010A25, "metrogate" },
    { 0x76033143, "metrogate_abort_throw" },
    { 0x270BF8D6, "metrogate_assign_regroupnode" },
    { 0x24CD7C2B, "metrogate_axis" },
    { 0x009C9148, "metrogate_axis_deathwatcher" },
    { 0x5BFA320A, "metrogate_execution" },
    { 0x79C92217, "metrogate_execution_player_close" },
    { 0x08620DBD, "metrogate_notifying" },
    { 0x26DC9A3E, "metrogate_playerchoice_wait" },
    { 0x3D4D38D2, "metrogate_print_animname" },
    { 0x770D0609, "metrogate_reach" },
    { 0x0E456BF0, "metrogate_reach_notifysafe" },
    { 0x70857624, "metrogate_reach_watcher" },
    { 0xE9D3D836, "metrogate_reached" },
    { 0x3D5B4E32, "metrogate_redshirt_think" },
    { 0xCF6B1223, "metrogate_scene_abort" },
    { 0x18A9406B, "metrogate_scene_heroes_reset" },
    { 0x843F1B7D, "metrogate_scene_segment_done" },
    { 0x124217E3, "metrogate_throw_molotov" },
    { 0x028457E6, "metrogate_woodbeam" },
    { 0xA179EF18, "metrogateextras" },
    { 0x42AF88DA, "metrogateregroupnodes" },
    { 0x9FF4FE23, "metrowave" },
    { 0x161D1388, "metrowave_approach_quake" },
    { 0xF1EC649A, "metrowave_approach_rumble" },
    { 0xF4C35ACD, "metrowave_blackout" },
    { 0xB372CA16, "metrowave_door_anim" },
    { 0x25E09EBB, "metrowave_force_camera" },
    { 0x5C483218, "metrowave_friends_reactions" },
    { 0xDC1DA635, "metrowave_impact_ai" },
    { 0x266B7704, "metrowave_impact_ais" },
    { 0x339E90C4, "metrowave_init_lights" },
    { 0x5E6DCA32, "metrowave_kill_all_axis" },
    { 0x7EBE5F25, "metrowave_move" },
    { 0x3FCFC811, "metrowave_player_bubbles" },
    { 0xE4FA8049, "metrowave_quake" },
    { 0xD8FB9E2D, "metrowave_rat_anim_splash" },
    { 0x9331C4DC, "metrowave_rat_anims" },
    { 0x43593BC4, "metrowave_rat_init" },
    { 0x32650358, "metrowave_rat_runpath" },
    { 0xABE6310E, "metrowave_rats" },
    { 0xB06F4D4E, "metrowave_rats_notify" },
    { 0x9FB4FE35, "metrowave_rumble" },
    { 0xBF159372, "metrowave_runner_killpoints" },
    { 0xAD41715E, "metrowave_runner_spawnfunc" },
    { 0x706E491C, "metrowave_turnoff_lightgroup" },
    { 0xA32157EE, "metrowave_turnoff_lights" },
    { 0x8E2695C9, "metrowavelightgroups" },
    { 0xBC713378, "mexico" },
    { 0xB0E447E9, "mg" },
    { 0x9A825FF2, "mg1" },
    { 0x747FE589, "mg2" },
    { 0x4E7D6B20, "mg3" },
    { 0x539BD8AF, "mg42" },
    { 0x06DCAD64, "mg421" },
    { 0x78E41C9F, "mg422" },
    { 0x52E1A236, "mg423" },
    { 0x94D53E29, "mg424" },
    { 0x1EA7AB94, "mg42_burst" },
    { 0x86085932, "mg42_burst_range" },
    { 0xF11285C3, "mg42_delay" },
    { 0x85437815, "mg42_delay_range" },
    { 0xB10168C1, "mg42_enabled" },
    { 0x715C83FF, "mg42_firing" },
    { 0xB78CC503, "mg42_gunner" },
    { 0xFF0BFE35, "mg42_gunner_manual_think" },
    { 0x80B00482, "mg42_gunner_think" },
    { 0x374E1364, "mg42_hide_distance" },
    { 0xE22682CE, "mg42_set_threatgroup" },
    { 0x8F7BD3C1, "mg42_setdifficulty" },
    { 0x1DD2425F, "mg42_suppressionfire" },
    { 0xFA9DC909, "mg42_target_drones" },
    { 0x63018F16, "mg42_think" },
    { 0xF1C5E2B2, "mg42_trigger" },
    { 0x6AE982BB, "mg42_turret_audio" },
    { 0xAB39A672, "mg42_turret_audio_thread" },
    { 0x5B49A8F1, "mg42badplace_maxtime" },
    { 0x3F118F1B, "mg42badplace_mintime" },
    { 0xEA35BF92, "mg42modelreplace" },
    { 0xF7F661C7, "mg42node" },
    { 0x69FA35BF, "mg42pain" },
    { 0xD24307F6, "mg42s" },
    { 0x9BE31885, "mg42setup_gun" },
    { 0x5CCF20F6, "mg42timer" },
    { 0x7D753B55, "mg62" },
    { 0x44F1481D, "mg_1" },
    { 0x6AF3C286, "mg_2" },
    { 0x5AEDBD66, "mg_ai" },
    { 0x3B44FC21, "mg_ai_targ" },
    { 0xF26FA72D, "mg_anim_ent" },
    { 0xCBF96563, "mg_animmg" },
    { 0x2EFEDE7B, "mg_array" },
    { 0x9B4EB336, "mg_bunker_damage_states" },
    { 0xF1DB3D7D, "mg_bunker_fires" },
    { 0x9A027ED2, "mg_check_for_friends" },
    { 0x4273C090, "mg_cleared" },
    { 0x5EB84713, "mg_clipper" },
    { 0x28135E44, "mg_damage1" },
    { 0xC5310177, "mg_engaged" },
    { 0x83DF26B8, "mg_fake_tracers" },
    { 0x0CB0ED18, "mg_fire" },
    { 0xE5FBEF58, "mg_fire_at_truck" },
    { 0xEF7C960A, "mg_firing_states" },
    { 0x533C3402, "mg_flankers" },
    { 0xF354524D, "mg_focus_both_berm_delay" },
    { 0x1AAE443F, "mg_geo_delete" },
    { 0x0BEBFD6C, "mg_guide" },
    { 0x64685B1A, "mg_gun" },
    { 0x23CD2B45, "mg_gunner" },
    { 0x4D862D46, "mg_gunner_behavior" },
    { 0x2500685E, "mg_gunner_death_notify" },
    { 0x65929810, "mg_gunner_function" },
    { 0xF86165B8, "mg_gunner_shot" },
    { 0x82CBFFE3, "mg_gunner_team" },
    { 0xCC3B7856, "mg_gunner_trig" },
    { 0x369770E5, "mg_guy" },
    { 0xC9AB8162, "mg_guy_dead" },
    { 0xDCF498FE, "mg_guy_death" },
    { 0xBB4E062A, "mg_guy_reminder" },
    { 0xF056CE90, "mg_house_retreat" },
    { 0x6AA575C9, "mg_intact" },
    { 0x505D68E2, "mg_is_firing" },
    { 0xD980DF34, "mg_kill_player" },
    { 0x62B0ABF3, "mg_killspawners" },
    { 0x6C1FA51F, "mg_left" },
    { 0xA4BC167A, "mg_nag_lines" },
    { 0x06F1D40D, "mg_name" },
    { 0x55BF8100, "mg_node" },
    { 0x4BC87A85, "mg_not_used" },
    { 0x0E7AE16B, "mg_off" },
    { 0x15322DCF, "mg_on_ridge" },
    { 0xB842C314, "mg_overlook_targets" },
    { 0xC0F314D9, "mg_owner" },
    { 0x79C71C32, "mg_player_kill" },
    { 0x2964221C, "mg_playerdamage" },
    { 0x07413C67, "mg_prop" },
    { 0xE37FF983, "mg_reveal_finishes" },
    { 0xD948D23A, "mg_right" },
    { 0xFB05AA3C, "mg_room_cleared" },
    { 0xC44F59C4, "mg_room_popnrun" },
    { 0x0C5A5A50, "mg_room_spawners_trig" },
    { 0x37DF1991, "mg_sandbag_cleanup" },
    { 0x91E46775, "mg_sandbags_explode" },
    { 0x1FE1783A, "mg_sandbags_explode_2" },
    { 0xE77F91E5, "mg_script_noteworthy" },
    { 0x02854183, "mg_setup" },
    { 0xBDB3C17F, "mg_shooting" },
    { 0x557B64A6, "mg_spawn_room_trig" },
    { 0x399C5678, "mg_start" },
    { 0xE0124E4F, "mg_struct" },
    { 0x07837E50, "mg_t" },
    { 0xB86CB5EA, "mg_targetname" },
    { 0x43E84B0E, "mg_targets" },
    { 0x6E2E42AC, "mg_think" },
    { 0xD2303B1D, "mg_truck" },
    { 0xB4E45F6A, "mg_turret" },
    { 0x27F6AD25, "mg_turrets" },
    { 0x3BE451C4, "mg_type" },
    { 0xBCB8AB7D, "mg_vc" },
    { 0x527A7EC0, "mg_weapontype" },
    { 0x82743BBF, "mg_window_reminder_in_sight_guy" },
    { 0x7E0012B8, "mga_ent" },
    { 0x6252EC2D, "mgads" },
    { 0xB3606716, "mgangle" },
    { 0xACC3A14E, "mganim" },
    { 0x9A6D110A, "mgcurtainfront" },
    { 0xD157CAF4, "mgcurtainside" },
    { 0xC2F471E3, "mgcurtainside_2" },
    { 0x24C34330, "mger" },
    { 0x6230749B, "mgers" },
    { 0x0C68290C, "mgexplode" },
    { 0x2C333749, "mgexplode_start" },
    { 0xC74525AD, "mgfire" },
    { 0x6A12C3B4, "mggeo" },
    { 0x543CFBE0, "mggunner" },
    { 0x0E7EE48B, "mggunners" },
    { 0x1068DB02, "mgguy" },
    { 0xB087D837, "mghouse" },
    { 0xB136851D, "mghouse_retreater_strat" },
    { 0xFE979037, "mginit" },
    { 0x37610CE9, "mgkill" },
    { 0x6968D817, "mgl" },
    { 0x5A61226C, "mglocation" },
    { 0x923A7E53, "mgnest" },
    { 0x188CE5F0, "mgoff" },
    { 0xEEB63DEA, "mgon" },
    { 0x928F8A41, "mgordon" },
    { 0x8F850309, "mgpair" },
    { 0xF51E7FC9, "mgr" },
    { 0x72E3F6B8, "mgrange" },
    { 0x8DA5D014, "mgrangeclose" },
    { 0xCF1C0560, "mgs" },
    { 0xDACF8AA1, "mgs_cleared" },
    { 0xB4B5CEE4, "mgs_focus_on_ai" },
    { 0x57C243BB, "mgs_focus_on_flamer" },
    { 0x23E6DC13, "mgs_focus_on_origins" },
    { 0xCBD9D25D, "mgs_targets_move" },
    { 0x7FB2F54E, "mgteam" },
    { 0xE7F94005, "mgteam_take_turns_firing" },
    { 0xFDB1CEF5, "mgtoggle" },
    { 0xBF40E307, "mgturret" },
    { 0xD14CB09B, "mgturret_auto" },
    { 0x13F9ADA0, "mgturretsettings" },
    { 0xF175639B, "mgunner" },
    { 0x56920B66, "mh_door_guy_hide_and_show" },
    { 0x1F72B322, "mh_ransack_pdf_2" },
    { 0x45752D8B, "mh_ransack_pdf_3" },
    { 0xC42A0DE6, "mh_ransack_pdf_anims" },
    { 0xF369FB01, "mh_shot_in_the_back_civs" },
    { 0x3329DC8A, "mhp" },
    { 0xC506F9A7, "mi" },
    { 0x8A1CF62B, "mi17" },
    { 0xE2100541, "mi17_death_fx" },
    { 0x59F115A1, "mi17_noai" },
    { 0x93DBB971, "mi24" },
    { 0xFBD1CFCD, "mi28" },
    { 0xB2320960, "mi_17_01" },
    { 0xEBE66EDC, "mia" },
    { 0x419956D1, "mic_test" },
    { 0x290AA8BC, "michael" },
    { 0x086967EF, "micro" },
    { 0x1C743E8D, "microchip" },
    { 0xAA48384E, "microseconds" },
    { 0x55221A14, "microtask" },
    { 0x9CD1564C, "microwave" },
    { 0x20E80E91, "microwave_audio_end" },
    { 0xB76DC51A, "microwave_audio_start" },
    { 0x8EF31B4F, "microwave_close_anim" },
    { 0x2B9784C1, "microwave_destroy_anim" },
    { 0x2E236377, "microwave_end_fx" },
    { 0x6BDC37E5, "microwave_fx" },
    { 0x761FEB68, "microwave_fx_hash" },
    { 0xEB6000BB, "microwave_fx_size" },
    { 0x8EA39B5F, "microwave_init_anim" },
    { 0x0B8D1B57, "microwave_open" },
    { 0x68FEAC9D, "microwave_open_anim" },
    { 0x0E0C6D92, "microwave_play_fx" },
    { 0xFB16BECD, "microwave_radius" },
    { 0x21127ED9, "microwave_radius_1" },
    { 0x4714F942, "microwave_radius_2" },
    { 0x6D1773AB, "microwave_radius_3" },
    { 0x9319EE14, "microwave_radius_4" },
    { 0xB825A589, "microwave_turret" },
    { 0xFDE9F96D, "microwave_turret_angle" },
    { 0x69B064B9, "microwave_turret_cone_angle" },
    { 0xC1926E65, "microwave_turret_cone_dot" },
    { 0xECA62AEF, "microwave_turret_damage" },
    { 0x7A7B2210, "microwave_turret_delete_on_death_delay" },
    { 0x3CF4EC84, "microwave_turret_duration" },
    { 0x48C32586, "microwave_turret_emp_damage" },
    { 0x671C5DAE, "microwave_turret_fx" },
    { 0x35201891, "microwave_turret_fx_check_time" },
    { 0xCE47DEA6, "microwave_turret_fx_half" },
    { 0x4C7C7CDA, "microwave_turret_fx_half_size" },
    { 0x0275E25A, "microwave_turret_fx_half_size_threshold" },
    { 0x390B3602, "microwave_turret_fx_size" },
    { 0xB542C04B, "microwave_turret_fx_start_offset" },
    { 0x13255574, "microwave_turret_fx_trace" },
    { 0xC728CADC, "microwave_turret_fx_trace_angle" },
    { 0xCF15B7BD, "microwave_turret_headicon_offset" },
    { 0x2C7E4F96, "microwave_turret_health" },
    { 0xECF1EC63, "microwave_turret_initial_damage_delay_max" },
    { 0xAF8DE14D, "microwave_turret_initial_damage_delay_min" },
    { 0xE3C77217, "microwave_turret_invalid_placement_model" },
    { 0x82F9D54F, "microwave_turret_killcam_forward_offset" },
    { 0x53420DBD, "microwave_turret_killcam_offset" },
    { 0x08B2E9A3, "microwave_turret_model" },
    { 0x96A3E06D, "microwave_turret_name" },
    { 0x18B57171, "microwave_turret_on_target_angle" },
    { 0xEDFFF2DA, "microwave_turret_pickup_text" },
    { 0x0D26B42E, "microwave_turret_radius" },
    { 0xD83B59E2, "microwave_turret_row_spread" },
    { 0x9228EA0A, "microwave_turret_shutdown" },
    { 0xCFF9B92C, "microwave_turret_start_sound" },
    { 0xC8922E30, "microwave_turret_stop_sound" },
    { 0xE60A8035, "microwave_turret_stun_fx" },
    { 0x0DA19DE3, "microwave_turret_target_offset" },
    { 0x3508A13C, "microwave_turret_valid_placement_model" },
    { 0x15E653E6, "microwave_turret_vehicle_name" },
    { 0x2D81B222, "microwave_turret_weapon_name" },
    { 0x7E2828AD, "microwaveable_objects" },
    { 0xEB30CDD7, "microwavecloseanim" },
    { 0xD26ED760, "microwaved" },
    { 0xB7C0B766, "microwavedamageinitialdelay" },
    { 0x49E53B2A, "microwavedestroyedanim" },
    { 0x590515B7, "microwaveeffect" },
    { 0xA86E75ED, "microwaveentity" },
    { 0x3F606FE3, "microwaveentitypostshutdowncleanup" },
    { 0x966ED415, "microwavefxent" },
    { 0xF48EF46A, "microwavefxhash" },
    { 0x711BCA21, "microwavefxhashleft" },
    { 0x853F958C, "microwavefxhashright" },
    { 0x1690E0BA, "microwavegun" },
    { 0xA5B034E9, "microwavegun_bloat" },
    { 0xD2C42BF0, "microwavegun_create_hit_response_fx" },
    { 0x1DE1D865, "microwavegun_death" },
    { 0x5724B132, "microwavegun_debug_print" },
    { 0x3A02FF65, "microwavegun_delete_hit_response_fx" },
    { 0xBAC7B83D, "microwavegun_dw_death" },
    { 0x0895F6A7, "microwavegun_dw_zombie_hit_response_internal" },
    { 0x50D51913, "microwavegun_fired" },
    { 0xD87E2D1A, "microwavegun_get_enemies_in_range" },
    { 0xDB28A1E3, "microwavegun_handle_death_notetracks" },
    { 0x73A5B7B1, "microwavegun_initial_hit_response" },
    { 0xD570A914, "microwavegun_network_choke" },
    { 0x3337C3C0, "microwavegun_network_choke_count" },
    { 0xE862B441, "microwavegun_on_player_connect" },
    { 0x0E06FCD0, "microwavegun_sizzle" },
    { 0x51641B77, "microwavegun_sizzle_death_ending" },
    { 0xC42D5619, "microwavegun_sizzle_enemies" },
    { 0x0BB3019D, "microwavegun_sizzle_func" },
    { 0xF422510E, "microwavegun_sizzle_vecs" },
    { 0x7E749C35, "microwavegun_sizzle_zombie" },
    { 0x972820F5, "microwavegun_sound_thread" },
    { 0x9FA6BE5E, "microwavegun_zap" },
    { 0xB05E6BBB, "microwavegun_zap_damage_func" },
    { 0x83DAADEE, "microwavegun_zap_death_fx" },
    { 0x24F24C2E, "microwavegun_zap_get_shock_eyes_fx" },
    { 0x2275C601, "microwavegun_zap_get_shock_fx" },
    { 0x208FA6F4, "microwavegun_zap_head_gib" },
    { 0x35112F59, "microwavegun_zap_head_gib_func" },
    { 0x6590A495, "microwavegun_zombie_damage_response" },
    { 0xA663C32A, "microwavegun_zombie_death_response" },
    { 0xC1551B70, "microwavegun_zombie_expand_response" },
    { 0xCE6B9071, "microwavegun_zombie_hit_response" },
    { 0x40068206, "microwavegun_zombie_initial_hit_response" },
    { 0x3D22D8EA, "microwavehackertoolradius" },
    { 0x6944333F, "microwavehackertooltimems" },
    { 0x4D5C4EEB, "microwaveopenanim" },
    { 0x9534F37C, "microwavepoisonedby" },
    { 0x943CB58C, "microwavepoisoning" },
    { 0x70CF93AD, "microwaveshellshockandviewkicktime" },
    { 0x2E511215, "microwaveturretaffectsentity" },
    { 0x6F147CD1, "mics" },
    { 0x79DEFFA1, "mid" },
    { 0x3105EE40, "mid_air_detonation_hint" },
    { 0x458151AE, "mid_color_chain_think" },
    { 0x5A4C20F7, "mid_flashpoint_2" },
    { 0x9C67E95D, "mid_flight_restore" },
    { 0x4EEAC355, "mid_goal" },
    { 0x0FD36C5C, "mid_guys" },
    { 0xA8555AC1, "mid_guys_spawner" },
    { 0x192A3B03, "mid_igc" },
    { 0xD6DD602D, "mid_igc_begin" },
    { 0xED176F57, "mid_level_transition_snapshot" },
    { 0x7CF7F184, "mid_mg_guy" },
    { 0x9428D2CE, "mid_ocean_speed" },
    { 0x601FECA6, "mid_org" },
    { 0x8F0F8B8B, "mid_repair" },
    { 0x90607813, "mid_resistance" },
    { 0x7F206A5E, "mid_rpg_guys_spawnfunc" },
    { 0x962E940B, "mid_spawners" },
    { 0xFF4097B1, "mid_street" },
    { 0x8B204D5E, "mid_street_2" },
    { 0xD6D5D5D3, "mid_street_mg_strat" },
    { 0xFD3AD5C8, "mid_street_mg_strat_2" },
    { 0xC6341E47, "mid_street_reinforce" },
    { 0xE803F21E, "mid_street_reinforcers" },
    { 0xF9DD1BC9, "mid_street_reinforcers_strat" },
    { 0x8EC39937, "mid_street_spawners_2_strat" },
    { 0xEB0EAEF8, "mid_thing" },
    { 0xF251C75A, "midair_collision" },
    { 0x3CE658B6, "midair_collision_notetrack" },
    { 0x4DAC2348, "midair_collision_started" },
    { 0xFE8EBF5F, "midcavefog_enter_settings" },
    { 0x54035785, "midday" },
    { 0x89821234, "middel" },
    { 0xDB448406, "middle" },
    { 0x77DF75B8, "middle_backup_trig" },
    { 0x43D12865, "middle_bm21" },
    { 0x10E10218, "middle_door_open" },
    { 0xDEDAF245, "middle_island_guys" },
    { 0x2C02985A, "middle_island_guys_logic" },
    { 0x19407EA1, "middle_mg" },
    { 0x35623988, "middle_mger" },
    { 0xCA4D923B, "middle_of_the_light" },
    { 0xA89ACBEE, "middle_path_vo" },
    { 0xE48817E4, "middlecar" },
    { 0xB4AF7908, "middlefraction" },
    { 0x78B69CE9, "middleframe" },
    { 0xD5F1D02A, "middleman" },
    { 0x604F3AFC, "middlevisblock1" },
    { 0x096553D3, "midflight" },
    { 0xB8CE565E, "midfov" },
    { 0x12AC0A08, "midglowfx" },
    { 0xC68C79C1, "midguard_spawn_think" },
    { 0xD6045666, "midhitfx" },
    { 0x9E828D40, "midigc" },
    { 0x93DD242E, "midlanding" },
    { 0x21DE7101, "midlevel" },
    { 0x52475AB9, "midpoint" },
    { 0xA446BB3B, "midpoint_axial_distance" },
    { 0x46015791, "midpos" },
    { 0xA3FB15CA, "midsection" },
    { 0xAA86E9F5, "midspawns" },
    { 0xEDE24FE9, "midspot" },
    { 0x5EB932CC, "midst" },
    { 0xC2CA9C94, "midstreet" },
    { 0xBC8DD0F6, "midtime" },
    { 0xB85F5496, "midway" },
    { 0x9FE17A0A, "mig" },
    { 0x86836A8E, "mig17_setup_bombs" },
    { 0xE6563E9C, "mig1_strafe_logic" },
    { 0x236CE1B3, "mig23_arena_strafe" },
    { 0x70547619, "mig23_flyby_logic" },
    { 0x942E09D8, "mig23_overbase_logic" },
    { 0xFACB6395, "mig29" },
    { 0x5CB650BB, "mig_array_audio" },
    { 0x1DB87C7D, "mig_audio" },
    { 0x25CDFDD6, "mig_bomb_entrance" },
    { 0x014F00B9, "mig_cave_gun_strafe" },
    { 0xF2EE8F5B, "mig_cave_strafe_logic" },
    { 0x412589B4, "mig_destroy_tank" },
    { 0x23A253B3, "mig_destroy_tower" },
    { 0x7EECB019, "mig_fake_audio" },
    { 0x3B6C9BF9, "mig_fake_audio2" },
    { 0x8BC1F735, "mig_fly_over" },
    { 0x451C937A, "mig_fly_over_2" },
    { 0x555C756C, "mig_flyover_01" },
    { 0x9A54DCEB, "mig_flyover_01_node" },
    { 0xC763E4A7, "mig_flyover_02" },
    { 0x09C3E6B6, "mig_flyover_02_node" },
    { 0xC2115F40, "mig_flyover_goal" },
    { 0x512DD1D9, "mig_gun_strafe" },
    { 0xEBEE3075, "mig_morter_" },
    { 0xA514051B, "mig_morter_4" },
    { 0x98A9941C, "mig_scares_horse" },
    { 0x14AEF26E, "mig_setup_bombs" },
    { 0xF258B24C, "mig_shoot_down_challenge_spawn_func" },
    { 0x758A1320, "mig_shot_down" },
    { 0xFE8B8A36, "mig_victim_logic" },
    { 0x8FD59E56, "might" },
    { 0xBD024268, "migrated" },
    { 0xD61EB42D, "migrating" },
    { 0x870CD6B3, "migration" },
    { 0xB07E45DC, "migration_getindexforplayer" },
    { 0x2BB9A780, "migration_onplayerconnect" },
    { 0x3DFAAF0F, "migration_setupgametype" },
    { 0x6574EA82, "migration_setupplayerdata" },
    { 0x7DADF57D, "migration_writegamedata" },
    { 0x5AD81958, "migration_writeplayerdata" },
    { 0xDCFAAC7C, "migration_writeteamdata" },
    { 0x4C381FB8, "migrationawarewait" },
    { 0x22148743, "migrationtimerpausetime" },
    { 0x35063145, "migs" },
    { 0x92318E7D, "migs2" },
    { 0x95791729, "migs_fly_by" },
    { 0x1EB4B009, "migs_flyby1" },
    { 0x44B72A72, "migs_flyby2" },
    { 0x6F9B9791, "migs_flyover_arena" },
    { 0x058FDF03, "migs_flyover_base" },
    { 0xB9BEF2EC, "migs_trigger" },
    { 0xBC15677F, "mike" },
    { 0x521F03F7, "mike_count" },
    { 0x48CDEAE2, "mike_test" },
    { 0x2DC18B24, "mikea" },
    { 0xBBBA1BE9, "miked" },
    { 0xA91F1BF2, "miked1" },
    { 0x831CA189, "miked2" },
    { 0x5D1A2720, "miked3" },
    { 0x672B7FFF, "miked4" },
    { 0xAF6A4820, "mikhail" },
    { 0x49CB2C59, "mil" },
    { 0xDAF2D25F, "mild" },
    { 0xB4F057F6, "mile" },
    { 0x05426FE9, "miles" },
    { 0x4342ABD6, "miles_per_hour" },
    { 0x5E2528B8, "miles_per_second" },
    { 0xE5C00260, "milesperhour" },
    { 0x2E628209, "milespersec" },
    { 0xFB8315DD, "milestone" },
    { 0x227EDCED, "milestoneanims" },
    { 0xE370E13E, "milestonenotify" },
    { 0xFA2C551C, "milestones" },
    { 0xF652BC15, "milestonetype" },
    { 0x0BE55021, "milestonevalid" },
    { 0x08DA0A21, "miliseconds" },
    { 0x026A0EF4, "military" },
    { 0xD3198A74, "militia" },
    { 0x9EC36A58, "militia_leader" },
    { 0x00F54CC8, "milk" },
    { 0xF3026064, "mill_scanner" },
    { 0x8D39F72A, "miller" },
    { 0xED4E5F94, "milli" },
    { 0x88019ECB, "millibar" },
    { 0x3E475467, "millibar_fov" },
    { 0x1817E290, "millibar_meeting_event" },
    { 0xC070A68D, "millibar_off" },
    { 0xAD72B2A1, "millibar_on" },
    { 0x373D21CE, "millibar_scanner_off" },
    { 0x1872EA20, "millibar_scanner_on" },
    { 0xECC71D0E, "millibar_stop" },
    { 0x9A0A247B, "millibar_toggle_think" },
    { 0x471D71CB, "millibar_visor" },
    { 0x7E84366B, "millibar_zoom" },
    { 0xEC07621F, "millimeter" },
    { 0x885FAB79, "milling" },
    { 0xBB299CBF, "million" },
    { 0x5060F698, "millisecond" },
    { 0x33C12E73, "milliseconds" },
    { 0xD8A4DD4F, "millisecs_remaining" },
    { 0xFD8B1D98, "mimic" },
    { 0xCD1C9373, "mimics" },
    { 0x95D0212B, "min" },
    { 0x16FA993B, "min_a" },
    { 0x09A8E492, "min_activation_time" },
    { 0xB091D62E, "min_alpha" },
    { 0x2B695EA3, "min_angle" },
    { 0xFDE5EE73, "min_arrival_dist_sq" },
    { 0xD2761852, "min_astro_round_wait" },
    { 0xC0417A85, "min_axis" },
    { 0xCB80B06B, "min_axis_alive" },
    { 0x42949F7B, "min_axis_left" },
    { 0xA4F32A00, "min_b" },
    { 0x3F9FE75F, "min_black_hole_dist" },
    { 0x06602855, "min_blindspot_time" },
    { 0x83B50A79, "min_blur" },
    { 0x17F75248, "min_burst" },
    { 0x224EC36C, "min_burst_time" },
    { 0xBE53708E, "min_cam_move_scale" },
    { 0x039C1587, "min_chance_at_round" },
    { 0x64F7B7C5, "min_charge_shotlevel" },
    { 0x2C19D456, "min_charges_in_level" },
    { 0x774B9FA7, "min_close_infantry_for_warning" },
    { 0x45CC3B28, "min_control_weight" },
    { 0xE6722E7D, "min_damage" },
    { 0x95BF0F68, "min_damage_for_gibbing" },
    { 0xB573AEBF, "min_damage_state" },
    { 0x899144A9, "min_damage_to_hunker_up" },
    { 0x04E2B3CF, "min_delay" },
    { 0x54419D3C, "min_delta" },
    { 0xF4DADBF6, "min_delta_squared" },
    { 0x8CA0CB41, "min_depthdist" },
    { 0x66B98099, "min_diff_for_anim" },
    { 0x2ECB9497, "min_difficulty_report_index" },
    { 0x09333A52, "min_dist" },
    { 0x704B2F3B, "min_dist_from_goal_to_turnsq" },
    { 0x88F40F11, "min_dist_sq" },
    { 0xD3C4FEBA, "min_dist_sq_to_tag" },
    { 0xDBA50240, "min_dist_squared" },
    { 0x501633BE, "min_dist_to_turn_a_cronersq" },
    { 0xBF8E7AAB, "min_distance" },
    { 0x3587DC32, "min_distance_for_close_infantry" },
    { 0x0E4B9D82, "min_distance_sq" },
    { 0x8F74AF5D, "min_distance_squared" },
    { 0x94388A78, "min_distsq_120" },
    { 0x27A6D6BA, "min_dmg" },
    { 0xF06AD3CA, "min_dogfight_fly_height_player" },
    { 0x649D368B, "min_dot" },
    { 0x77AFE3BA, "min_duration" },
    { 0x8086D3A2, "min_enemies" },
    { 0x6C0C7490, "min_enemies_killed_during_sniper" },
    { 0xDE2D1894, "min_eq" },
    { 0x4F0C298F, "min_equipment_attack_range" },
    { 0x9A3E69AE, "min_exityaw_distance_sq" },
    { 0x1C55F154, "min_exposed_grenade_dist" },
    { 0x0158B30C, "min_exposed_grenade_dist_player" },
    { 0x194476EC, "min_exposed_grenade_distsq" },
    { 0xEA49BD96, "min_exposed_time" },
    { 0x55244911, "min_exposure" },
    { 0xA6F37180, "min_exposure_flicker" },
    { 0x673E978A, "min_filter_intensity" },
    { 0x82A0C42C, "min_flash_time" },
    { 0x39FACEE2, "min_flicker_delay" },
    { 0x556EAC97, "min_flickerless_time" },
    { 0xC84219EB, "min_force" },
    { 0xD0539E87, "min_fov" },
    { 0x4830FA97, "min_friendly" },
    { 0xC721979F, "min_frustration" },
    { 0xFEAEB5A2, "min_fx_distance" },
    { 0x33A6997A, "min_gap" },
    { 0x1F2FE5CE, "min_goal_dist" },
    { 0xBDA68B97, "min_goal_height" },
    { 0x5A28DF42, "min_grenade_animscripted_time" },
    { 0x715F12D0, "min_grenade_team_time" },
    { 0x5D539A93, "min_grenade_throw_dist_sq" },
    { 0x3514B8BC, "min_grenade_throw_distance_sq" },
    { 0xAA5AB2BB, "min_grenade_throw_time" },
    { 0xCD78D74F, "min_hand_model" },
    { 0xFF8D1118, "min_health" },
    { 0x4B4B8143, "min_height" },
    { 0xF3352F74, "min_height_delta" },
    { 0x5F9C77E3, "min_height_diff" },
    { 0x04F3CC1D, "min_heli_kill" },
    { 0xD4A02280, "min_humans" },
    { 0xFB7DB626, "min_idle_dist_sq" },
    { 0x383E23E8, "min_impulse_v" },
    { 0x9CAF599E, "min_instances" },
    { 0xBE40B749, "min_intensity" },
    { 0xDE504C65, "min_interval" },
    { 0x0766065F, "min_launch_angle" },
    { 0x845ADB5D, "min_launch_intensity" },
    { 0xAD43DDC2, "min_length" },
    { 0x1D2E463E, "min_length_to_player" },
    { 0x8AACDC6C, "min_lookat_dot" },
    { 0x782FEEAC, "min_max" },
    { 0x87592498, "min_miss_distance" },
    { 0x5956D314, "min_nearby_player_dist_for_crawl" },
    { 0x5AC458BA, "min_node_wait_time" },
    { 0x1CD302DE, "min_num" },
    { 0xFC4DF9FF, "min_offset" },
    { 0x077ED37E, "min_pain_interval" },
    { 0x185C7DA3, "min_panzerschreck_eng_distsq" },
    { 0x423A246D, "min_participation" },
    { 0x95612467, "min_path_dist_for_arrival_prediction_sq" },
    { 0x2D3FE229, "min_percent" },
    { 0x98E80580, "min_pitch" },
    { 0x0D86B1D9, "min_player_teleport_distance" },
    { 0xC72AAF89, "min_power" },
    { 0xABB1100B, "min_pzrsk_dist" },
    { 0x55FB0B70, "min_radius" },
    { 0x0374ED58, "min_radius_max_static" },
    { 0xF2AF12BD, "min_range" },
    { 0xCE335B6D, "min_rangesq" },
    { 0xE40BF775, "min_rappel_dist" },
    { 0x99115222, "min_rappel_time" },
    { 0xD7F17830, "min_rate" },
    { 0x93CEB661, "min_reach_dist_sq" },
    { 0x74889AF5, "min_reaction_dist_sq" },
    { 0xE5BD306F, "min_recalc_pos_time" },
    { 0x8AAA15D0, "min_reload_distsq" },
    { 0x188FD8CA, "min_respawn_delay" },
    { 0xACC35EDA, "min_respawn_time" },
    { 0x745860C5, "min_rot_vel" },
    { 0xF1B95286, "min_round_requirement" },
    { 0x409D9BAC, "min_run_dist" },
    { 0xE52DA79C, "min_running_pain_dist_sq" },
    { 0x2C82FB9B, "min_sam_hud_strength" },
    { 0x88211096, "min_set" },
    { 0x72849931, "min_size" },
    { 0xF129AADC, "min_slow_dist" },
    { 0x2399E80C, "min_sniper_burst_delay_time" },
    { 0xE36FBC2B, "min_spawn_distance" },
    { 0x0A639FD5, "min_spawn_wait" },
    { 0x94421E83, "min_spawn_wait_time" },
    { 0x09848503, "min_spec_drones" },
    { 0xADAFC5F3, "min_spec_kill_fx" },
    { 0x034B1F6F, "min_speed" },
    { 0xAA7A843F, "min_speed_for_animated_damage" },
    { 0x2D755E64, "min_speed_for_motion" },
    { 0x48DC2D44, "min_speed_z" },
    { 0xE6F53A16, "min_sprint_speed" },
    { 0x3609124B, "min_sprint_start_speed" },
    { 0xC9C151CA, "min_start_time" },
    { 0x20864756, "min_static_value" },
    { 0xA9A3EA83, "min_strafe_steps" },
    { 0x17FAA5E5, "min_struct" },
    { 0xFCF500E3, "min_target_rating" },
    { 0xEA1C54B7, "min_threshold" },
    { 0x97C660B9, "min_time" },
    { 0xE62834DA, "min_time_before_direction_change" },
    { 0xAB821D3C, "min_time_before_shift" },
    { 0x20A689DC, "min_time_between_give_flip_audio_ms" },
    { 0x6692782B, "min_time_between_waves" },
    { 0x822822CF, "min_time_left" },
    { 0xB51F2710, "min_time_remaining" },
    { 0x0F1BB38E, "min_time_to_fire" },
    { 0x8A3FF9D0, "min_trait_value" },
    { 0x89AAEA97, "min_turret_burst" },
    { 0x802AD68C, "min_turret_wait" },
    { 0x9F3CE4B1, "min_twitch_time" },
    { 0xA9020B51, "min_up_speed" },
    { 0xCB19F747, "min_usage" },
    { 0x21F1D543, "min_val" },
    { 0xB2EBE9B5, "min_vehicles" },
    { 0x75A49A8F, "min_vel" },
    { 0x571C8A85, "min_view_angle" },
    { 0x2FD31F8C, "min_visible" },
    { 0x7B9DCC8D, "min_vol" },
    { 0xBD3B7655, "min_wait" },
    { 0x8C80CAA4, "min_wait_distance_sq" },
    { 0x98A80203, "min_wait_time" },
    { 0x813398AA, "min_x" },
    { 0xA7361313, "min_y" },
    { 0x352EA3D8, "min_z" },
    { 0x21C8360B, "min_zoom" },
    { 0x61EA62B6, "min_zoomed_in_time" },
    { 0x545C95B9, "minai" },
    { 0x339FE74A, "minaithreshold" },
    { 0x626A158B, "minamountdist" },
    { 0xE949070C, "minangle" },
    { 0x37CBD25E, "minanglediffcos" },
    { 0x5BD5E08F, "minangles" },
    { 0xD4AB3BD0, "minatt" },
    { 0x2356C9A6, "minawarenessdistsq" },
    { 0x830546F7, "minbmpexplosiondmg" },
    { 0xF43AA30D, "minchainwait" },
    { 0xAB3B9F24, "mincorner" },
    { 0x104B7A75, "mincorneroffset" },
    { 0xA272AE50, "mincos" },
    { 0xCB74B390, "mincount" },
    { 0xDA9C07B5, "mind" },
    { 0x3252ABB7, "mind_control" },
    { 0x5F5ABDCC, "mindamage" },
    { 0xEB2A37EC, "mindamagerequiredfornapalmburn" },
    { 0xE4E30A67, "mindcontrolstate" },
    { 0x4E015084, "mindelay" },
    { 0x6C0CBCAA, "mindetpackdamage" },
    { 0x587C5717, "mindist" },
    { 0x4E9A6777, "mindist2" },
    { 0x4BA97F52, "mindistance" },
    { 0x50C2B953, "mindistancerandom" },
    { 0x0007166E, "mindistancesq" },
    { 0x1E5D41A4, "mindistawayfromhighground" },
    { 0xDA0C53A7, "mindistinchessq" },
    { 0xA7F952CE, "mindists" },
    { 0xC1A77B43, "mindistsq" },
    { 0x4A72401B, "mindistsqr" },
    { 0x24DE073A, "mindistsquared" },
    { 0x95923FAC, "mindistteam" },
    { 0xE235A09F, "mindisttotarget" },
    { 0x475EF384, "minds" },
    { 0x398572EB, "minduration" },
    { 0xB4998D4C, "mine" },
    { 0x3E2FFDB1, "mine_activation_time" },
    { 0x13E40886, "mine_ai_planting_death" },
    { 0x484C6234, "mine_ai_remove_busy" },
    { 0x9F9CEC1F, "mine_ai_types" },
    { 0xDF11EB29, "mine_array_remove" },
    { 0x3C4A4020, "mine_cart_push" },
    { 0x397ED5D5, "mine_clean_up_2" },
    { 0x7A6D2A5E, "mine_control_guy" },
    { 0x488FA8AC, "mine_countdown" },
    { 0x1D7E4AB9, "mine_create_guard" },
    { 0x84709322, "mine_create_prisoner" },
    { 0xDF0DC444, "mine_damage" },
    { 0x2D1D84FD, "mine_delete_on_death" },
    { 0xDE819B5E, "mine_equip_players" },
    { 0x7D422A76, "mine_explode" },
    { 0x143807EC, "mine_hint" },
    { 0x24D39243, "mine_loc" },
    { 0x94CAE74E, "mine_loc_adjust_weight" },
    { 0xDD9E5962, "mine_loc_valid_plant" },
    { 0x3C32E9C6, "mine_locs_attempt_plant" },
    { 0x27373F30, "mine_locs_get_valid" },
    { 0x635A2D1E, "mine_locs_manage_planting" },
    { 0x00AF561E, "mine_locs_manage_weights" },
    { 0x11AED90F, "mine_locs_populate" },
    { 0x68ECE429, "mine_locs_sorted_by_weight" },
    { 0x84555C6B, "mine_melee_damage" },
    { 0x623B21C2, "mine_model" },
    { 0x86894DCE, "mine_name" },
    { 0x8546F74B, "mine_off_on_loop" },
    { 0x3BA83CD3, "mine_on_death" },
    { 0x16AD1274, "mine_passengers" },
    { 0x2EE6BEB4, "mine_placed" },
    { 0x0F25C92F, "mine_plant_ai_1" },
    { 0x9D1E59F4, "mine_plant_ai_2" },
    { 0x9A897B93, "mine_plant_in_yard" },
    { 0x317D4A71, "mine_russians" },
    { 0x5001E310, "mine_selected" },
    { 0x8FF68C82, "mine_setup_player" },
    { 0x5542FDA5, "mine_setup_prisoner" },
    { 0x402041B5, "mine_setup_reznov" },
    { 0x47340F27, "mine_so_detonated_recently" },
    { 0x4F3982D0, "mine_spawn_funcs" },
    { 0x25CBDC75, "mine_trig" },
    { 0x47E0C6AB, "mine_type" },
    { 0xF0156AD4, "mine_watch" },
    { 0x536346DE, "minecart" },
    { 0xDA2EEC00, "minecart_force_zone_active" },
    { 0x429D6C60, "mined" },
    { 0x04B5259B, "mineexplode" },
    { 0x18A39B08, "minefield" },
    { 0x5A62432B, "minefield_function" },
    { 0x5543921B, "minefield_kill" },
    { 0x1C378981, "minefield_think" },
    { 0x231D8923, "minefields" },
    { 0x9B0A759B, "minemover" },
    { 0xBB219078, "minempdowntime" },
    { 0x05BD4A55, "minenemydist" },
    { 0xDB825B3C, "minerals" },
    { 0xACD66BCF, "mines" },
    { 0x10D0FA90, "mines_trig" },
    { 0xA4ECD493, "minetriggers" },
    { 0x8A5D424B, "mineup" },
    { 0xA3D029BF, "minflyheight" },
    { 0xB1137442, "mingibs" },
    { 0x1DFCDEC2, "mingrenadedistsquared" },
    { 0x0DD9E81B, "mingun" },
    { 0x127E4AC9, "minh" },
    { 0xEDB3CBB1, "minhealth" },
    { 0xB9848C3A, "minheight" },
    { 0xE38BD07A, "minheightoverride" },
    { 0xEC7BD060, "mini" },
    { 0xA2926E8C, "mini_boss" },
    { 0x233638F5, "mini_boss_spawn_think" },
    { 0xBABF6817, "mini_gun" },
    { 0xC8A47E07, "mini_heli" },
    { 0x555578E4, "mini_hero_drone" },
    { 0x86D19FCD, "mini_turret" },
    { 0x22ABBB57, "mini_turret_model" },
    { 0xD991E3C5, "mini_turret_orgs" },
    { 0x77BD614C, "mini_turrets" },
    { 0xDC84ABF7, "miniarrivalnode" },
    { 0x60CF9673, "miniboss" },
    { 0xAC162258, "minibossspawners" },
    { 0x2544B84D, "minie" },
    { 0x456D1B26, "minigame" },
    { 0xDB9703DD, "minigame_blockers_disable" },
    { 0xB073ABAE, "minigame_blockers_enable" },
    { 0x76C331E0, "minigame_blockers_precache" },
    { 0x222CC515, "minigame_disabled" },
    { 0xB41AABAE, "minigun" },
    { 0xB4538934, "minigun_alley_main" },
    { 0xF4B28826, "minigun_arming_check" },
    { 0xBF708782, "minigun_barbed_wire_detonate" },
    { 0xA0FA9D22, "minigun_breach_baglimit" },
    { 0x3E8F910D, "minigun_breach_deathmonitor" },
    { 0x9A52696E, "minigun_const" },
    { 0x4DF7AA30, "minigun_control" },
    { 0x3970134A, "minigun_countdown" },
    { 0x176EFF04, "minigun_damage_adjust" },
    { 0x3308F21B, "minigun_damage_adjust_override" },
    { 0xADEA04A7, "minigun_fallback" },
    { 0x882A9E3B, "minigun_fallback_shouting" },
    { 0x7C6DD320, "minigun_fallback_shouting_cancel" },
    { 0x05FD3E03, "minigun_firstuse_check" },
    { 0x4F80295F, "minigun_gatling_spindown1" },
    { 0xDD78BA24, "minigun_gatling_spindown2" },
    { 0x037B348D, "minigun_gatling_spindown3" },
    { 0x9173C552, "minigun_gatling_spindown4" },
    { 0xBC8DEC5C, "minigun_gatling_spinloop" },
    { 0x0413DC62, "minigun_gatling_spinup1" },
    { 0xDE1161F9, "minigun_gatling_spinup2" },
    { 0xB80EE790, "minigun_gatling_spinup3" },
    { 0xC220406F, "minigun_gatling_spinup4" },
    { 0x316847E4, "minigun_hud" },
    { 0xB7CB3231, "minigun_last_damage_time" },
    { 0x7F1827B6, "minigun_mp" },
    { 0xFFF4B1D8, "minigun_no_drop" },
    { 0x246A5C92, "minigun_orders" },
    { 0x717EF473, "minigun_overheat_bar" },
    { 0xDA969122, "minigun_pickedup" },
    { 0xA93BA521, "minigun_player_override" },
    { 0x9218BE3B, "minigun_powerup_last_stand" },
    { 0x1BF4BF94, "minigun_primary_attack" },
    { 0x92B8384F, "minigun_prize" },
    { 0xEF081DF6, "minigun_prop" },
    { 0xA2796A04, "minigun_prop_3" },
    { 0x6C18334A, "minigun_rumble" },
    { 0x825D14EB, "minigun_session" },
    { 0xD8436386, "minigun_session_check" },
    { 0x0DB6C28F, "minigun_smokescreens" },
    { 0x694780C0, "minigun_snd_ent" },
    { 0x62FD48F2, "minigun_sound" },
    { 0x447F8659, "minigun_sound_spindown" },
    { 0xA807BCC7, "minigun_sound_spinloop" },
    { 0x756FA986, "minigun_sound_spinup" },
    { 0x2E47B303, "minigun_spin_fx_handle" },
    { 0x42A8BEDB, "minigun_think" },
    { 0xAA12B973, "minigun_time_over" },
    { 0x3325D628, "minigun_toss_cooldown" },
    { 0x454C2DC2, "minigun_use" },
    { 0xFFF43762, "minigun_used" },
    { 0x23BE7554, "minigun_watch_gunner_downed" },
    { 0x789FA314, "minigun_weapon_powerup" },
    { 0x58AFF384, "minigun_weapon_powerup_countdown" },
    { 0xA5180DFA, "minigun_weapon_powerup_off" },
    { 0x1586432B, "minigun_weapon_powerup_remove" },
    { 0xF73ADC95, "minigun_weapon_powerup_replace" },
    { 0xCC14B284, "minigunactive" },
    { 0xE79B3E8A, "minigunbreachbaglimit" },
    { 0x02B2A275, "minigunid" },
    { 0x198529BA, "miniguninventoryweapon" },
    { 0x77448A3A, "minigunnagdelaytime" },
    { 0xED82D4D1, "miniguns" },
    { 0xB79BCD70, "miniguns_cleanup" },
    { 0x2579FB71, "miniguns_firing" },
    { 0xD98AEC1F, "miniguns_on" },
    { 0xAC519580, "miniguns_overheating" },
    { 0x31441875, "minigunsessions" },
    { 0x0D3A6C46, "minigunstart" },
    { 0x43D62A67, "minigunuser" },
    { 0x57D8062E, "minigunweapon" },
    { 0xBA642779, "miniguun" },
    { 0x8E1FCDBE, "minimal" },
    { 0x2629B762, "minimap" },
    { 0x8CCDDE1E, "minimap_corner" },
    { 0x9E4A2DCA, "minimap_lowerr" },
    { 0x8CEC66D9, "minimap_upperl" },
    { 0x40E77207, "minimap_upperr" },
    { 0x5C82A807, "minimapheight" },
    { 0x1A29AA20, "minimaporigin" },
    { 0xE0D7FECB, "minimaporigins" },
    { 0x97FDE3ED, "minimapplayer" },
    { 0xEB800B12, "minimapwarn" },
    { 0xA42E88ED, "minimize" },
    { 0x4F248FEC, "minimizes" },
    { 0x9A087303, "minimum" },
    { 0x4B25E927, "minimum_delta_sqr" },
    { 0x2938A56D, "minimum_distance_for_sniper_glint_sq" },
    { 0x67BF3635, "minimum_fly_height" },
    { 0x75B09FF1, "minimum_health_on_checkpoint_restart" },
    { 0xC1955CA1, "minimum_jav_distance" },
    { 0x1F7597E2, "minimum_sti_distance" },
    { 0x05AB9AC0, "minimum_tac_arrive_angle" },
    { 0x46BE32AE, "minimum_tac_arrive_distance" },
    { 0x0BF124C6, "minimumallowedsuicides" },
    { 0xFB0ABB41, "minimumallowedteamkills" },
    { 0xD964C3B1, "minimumautosavefriendlycount" },
    { 0xCE2ED0EA, "minimumdistance" },
    { 0xC4296386, "minimumdistancesq" },
    { 0x3031FF6B, "minimumfriendlycount" },
    { 0x1DCC8AF1, "minimummovedistance" },
    { 0xB4BFD084, "minimumpopandtime" },
    { 0xC0678E4D, "minimumsafedistance" },
    { 0x4633931E, "minimumscoreprocessing" },
    { 0xADF9BC84, "minimumspeed" },
    { 0x37C2C799, "minimumtacarrivalangle" },
    { 0x3CFCD661, "minimumtimebetweenautosaves" },
    { 0x143DA134, "minimumwait" },
    { 0xAE2681D2, "mininitialdelay" },
    { 0x4D4EF92C, "miniraps" },
    { 0x39676A0B, "minis" },
    { 0x5CBDD3F4, "minister" },
    { 0x205C0F34, "minkillcount" },
    { 0xD7160F18, "minnagtime" },
    { 0x20F2E0C2, "minoffset" },
    { 0xB51286E0, "minor" },
    { 0x99286854, "minor_axis" },
    { 0x923FDC4B, "minor_breaks" },
    { 0xA0DCB656, "minor_value" },
    { 0xFEFB4AC1, "minorigin" },
    { 0xE2570ED4, "minority" },
    { 0xACF5EB63, "minpain" },
    { 0xEE8B2014, "minpaindamage" },
    { 0x44EAB67E, "minplayerz" },
    { 0x3E83CA7A, "minpopulationandtime" },
    { 0xE03474A4, "minprestige" },
    { 0xFC4796F5, "minradius" },
    { 0xAC6D7162, "minrange" },
    { 0x5CBA5221, "minrange_sq" },
    { 0x4F439178, "minrangesqr" },
    { 0x55123CE1, "minrate" },
    { 0x0C020CEE, "minroll" },
    { 0xC8BC3F0A, "mins" },
    { 0x29532927, "minscale" },
    { 0x98FCD032, "minscavengerkillcount" },
    { 0x772EA244, "minscorepercentageleft" },
    { 0x5C5C4E19, "minsearchradius" },
    { 0x54E5B61B, "minsparkspeed" },
    { 0x8C4FE99C, "minspeed" },
    { 0x502BE594, "minspeedsq" },
    { 0xF3107012, "minstage1health" },
    { 0x06DF294B, "minstickinput" },
    { 0x3F7A898E, "mintalktime" },
    { 0xAD8451E0, "mintime" },
    { 0x54FE221F, "minumum" },
    { 0x5A53B91F, "minus" },
    { 0x41C81025, "minus_time" },
    { 0x6A0A9B48, "minus_to_player_score" },
    { 0x14D73EF4, "minus_to_team_score" },
    { 0x963A9BAD, "minute" },
    { 0x729E1923, "minute_hand" },
    { 0x5EA47431, "minute_hand_array" },
    { 0xB2CBF412, "minute_values" },
    { 0x196348AC, "minutes" },
    { 0x409DB10D, "minutes_remaining" },
    { 0x4C3EB45B, "minutes_tens" },
    { 0xC87325B9, "minutesandsecondsstring" },
    { 0xECECA8EC, "minutespassed" },
    { 0x29B14C5D, "minutesplayed" },
    { 0x5304D22F, "minutestimer" },
    { 0x17E3ED48, "minval" },
    { 0x1724CACF, "minvalidlength" },
    { 0x5B9BADC2, "minvalue" },
    { 0xB3432CDD, "minviewangle" },
    { 0x7E13C74C, "minwait" },
    { 0xF877F15F, "minwaittime" },
    { 0xFCF1D4CD, "minwalkdistance" },
    { 0x3FB7D29D, "minweaponsleft" },
    { 0x1E624547, "minweight" },
    { 0x72A5F159, "minx" },
    { 0x4CA376F0, "miny" },
    { 0x8C23E074, "minyaw" },
    { 0xCD9508A9, "minyawrandom" },
    { 0xBEAAE62B, "minz" },
    { 0x2E45CCE5, "minz_struct" },
    { 0xF6FAD484, "mips" },
    { 0x997E05CE, "miracle" },
    { 0xADAEACE4, "mirror" },
    { 0xADDFA379, "mirror_menendez" },
    { 0xF8ABCB6A, "mirror_off" },
    { 0x61172817, "mirrors" },
    { 0xD7C3BD1E, "mis" },
    { 0x87373F82, "misattributed" },
    { 0x616F88F1, "misc" },
    { 0xD0102DD0, "misc_dummy" },
    { 0xC6C36F2F, "misc_floorlight_fx" },
    { 0x61B67474, "misc_fx_handler_trig" },
    { 0x86D67BE2, "misc_fx_handlers" },
    { 0x9708F6D1, "misc_hidesea" },
    { 0x85101CF5, "misc_light_flicker" },
    { 0xA1C3BA33, "misc_light_sway" },
    { 0x675FA62B, "misc_main" },
    { 0xE158240B, "misc_model" },
    { 0xF628C6AE, "misc_model_z_offset" },
    { 0x0F3A2B6A, "misc_models" },
    { 0xDE95DF09, "misc_precacheinit" },
    { 0x03945338, "misc_radar" },
    { 0xEB491B67, "misc_rail_guys" },
    { 0x7A3F9A1B, "misc_setup" },
    { 0xF15B4B5F, "misc_setup_waterlevel" },
    { 0x1055C274, "misc_showsea" },
    { 0x9FFB96C9, "misc_spotlight_fx" },
    { 0x72097512, "misc_turret" },
    { 0x901A901D, "misc_turrets" },
    { 0x318EFA3E, "misc_tv" },
    { 0x1DF0A63A, "misc_tv_damage" },
    { 0xF400C96F, "misc_tv_damage_fx" },
    { 0xC59A5734, "misc_tv_off" },
    { 0xD4DC15E5, "misc_tv_stairs_on" },
    { 0x46458D04, "misc_vision" },
    { 0xA05B8AFC, "miscaclculation" },
    { 0x79589909, "miscdata" },
    { 0x191556DB, "miscellaneous" },
    { 0x6600DC93, "miscmodels" },
    { 0x5B08333A, "miscprecache" },
    { 0x2429A51D, "misdirection" },
    { 0x924D6C24, "misery" },
    { 0x3CC514AB, "misisle" },
    { 0xB6E92C40, "misleading" },
    { 0xBA434FC1, "mismatch" },
    { 0x805AE0E6, "misnaming" },
    { 0xBDE60371, "misnomer" },
    { 0xC1972F81, "miss" },
    { 0xCB7F6458, "miss_chance" },
    { 0x897EECC4, "miss_dist" },
    { 0x490D2082, "miss_pos" },
    { 0x93F15525, "miss_rocket_trig" },
    { 0xDC8756E7, "miss_struct" },
    { 0x1599545E, "miss_structs" },
    { 0x42A4172A, "miss_time_constant" },
    { 0x31B4C6E3, "miss_time_distance_factor" },
    { 0x5017455F, "miss_time_reset_delay" },
    { 0x2399E86E, "missed" },
    { 0x1BEE1CAA, "missed_by_far_distance" },
    { 0xAAC73318, "missed_rooftop" },
    { 0xED18DD9F, "misseddistancesq" },
    { 0xDB6D9FE2, "missedsightchecks" },
    { 0x0565DDD1, "misses" },
    { 0x4A93C703, "missile" },
    { 0xB0C5EA03, "missile fired" },
    { 0x2FF1AD5E, "missile ready" },
    { 0x737DC418, "missile01_end" },
    { 0x18CD813B, "missile01_start" },
    { 0x349D8C9B, "missile02_end" },
    { 0x7864D4F8, "missile02_start" },
    { 0x983668A0, "missile_ai_guy" },
    { 0x11EE42B4, "missile_ammo" },
    { 0x1265E12A, "missile_angles" },
    { 0x1D14D0E9, "missile_attack_drones_group1" },
    { 0x43174B52, "missile_attack_drones_group2" },
    { 0x4EEF7AB1, "missile_audio_watcher" },
    { 0x6FF6B410, "missile_base_d_1" },
    { 0xE1FE234B, "missile_base_d_2" },
    { 0xBBFBA8E2, "missile_base_d_3" },
    { 0xCBEEC38B, "missile_boost" },
    { 0x95B34FD5, "missile_box" },
    { 0x00C315AD, "missile_boxes" },
    { 0xBBE8998F, "missile_brake" },
    { 0x19FFF0CB, "missile_brake_timeout_watch" },
    { 0x1F91979D, "missile_createattractorent" },
    { 0x62CFB35C, "missile_createattractororigin" },
    { 0x41346CF7, "missile_createrepulsorent" },
    { 0xD2326EBF, "missile_cross_shot_range" },
    { 0x94041790, "missile_damage_watcher" },
    { 0x5E31AC20, "missile_death_earthquake" },
    { 0x3A18E1AA, "missile_death_set_flag" },
    { 0x83A4908B, "missile_deathwait" },
    { 0x89191F29, "missile_deleteattractor" },
    { 0x91B530AB, "missile_deploy" },
    { 0x9B0D15EB, "missile_deploy_watch" },
    { 0x2B72F94C, "missile_destroy" },
    { 0xEFBD574F, "missile_destroy_before_impact" },
    { 0xCA392AF6, "missile_done" },
    { 0x81AB3E94, "missile_drone" },
    { 0x756E3661, "missile_drone_active" },
    { 0x5AAF9517, "missile_drone_active_cb" },
    { 0x4EA12BEC, "missile_drone_anim" },
    { 0xA48CAE2F, "missile_drone_flyheight" },
    { 0x544BEABD, "missile_drone_fx" },
    { 0xF550D2F1, "missile_drone_killstreak" },
    { 0xCC84EFF1, "missile_drone_origin" },
    { 0x55E898DD, "missile_drone_projectile_active_cb" },
    { 0xBBCBF54A, "missile_drone_projectile_animate_cb" },
    { 0x9EECBEF1, "missile_drone_target_active" },
    { 0xF52CF50B, "missile_drone_target_disabled" },
    { 0x4C1815E6, "missile_drone_target_enabled" },
    { 0x94299F68, "missile_drones_group1" },
    { 0x06310EA3, "missile_drones_group2" },
    { 0x3F994742, "missile_dronesetvisible" },
    { 0xD63319AF, "missile_emp_death" },
    { 0x5A27AD15, "missile_end" },
    { 0xD73659A4, "missile_end_sounds" },
    { 0x8DD2647E, "missile_fail" },
    { 0x238DCCCE, "missile_fail_blackout" },
    { 0x7EB7322A, "missile_fire" },
    { 0x1A31C226, "missile_fire_count" },
    { 0xDA927A76, "missile_fire_manager" },
    { 0x56F7EEE8, "missile_fire_range" },
    { 0xE615B0CE, "missile_fire_time" },
    { 0xCB6C271A, "missile_fired" },
    { 0xBCA656BF, "missile_fired_at_convoy" },
    { 0xA293762A, "missile_fired_notify" },
    { 0xD4B2D417, "missile_follow_ent" },
    { 0xF175F855, "missile_gettarget" },
    { 0xBB91DE6B, "missile_height" },
    { 0x9A589F6E, "missile_hide" },
    { 0xE6DBB14E, "missile_highlight_on_heli_lookat" },
    { 0xA7E246B1, "missile_hit" },
    { 0xD12467E3, "missile_hit_player" },
    { 0xB45727F5, "missile_hud" },
    { 0xFC12C3A7, "missile_impact_push_boats" },
    { 0xB7E1F945, "missile_impact_watcher" },
    { 0x9E697ACB, "missile_incoming_watcher" },
    { 0x371B6656, "missile_info" },
    { 0x17361D77, "missile_launch" },
    { 0xF9E0E326, "missile_launch01" },
    { 0xD3DE68BD, "missile_launch02" },
    { 0xAE4DD796, "missile_launched_warning_playing" },
    { 0x54C254D4, "missile_launcher_engagement" },
    { 0x1DE3F19A, "missile_launcher_guy_engagement_distance" },
    { 0x1038D691, "missile_launcher_guy_min_wait" },
    { 0x4F94736E, "missile_launcher_guys_max_wait" },
    { 0xD1292DAA, "missile_launcher_objective" },
    { 0x1339D4D5, "missile_launchers" },
    { 0x4808A505, "missile_left" },
    { 0xFE5FD6B2, "missile_list" },
    { 0xB48C121F, "missile_lock" },
    { 0xB6AB8E9E, "missile_lock_ended" },
    { 0xDB8AB4CF, "missile_lock_loop_audio" },
    { 0x9FD3CF07, "missile_lock_on_range" },
    { 0x511C46AE, "missile_lock_sounds" },
    { 0x43423E18, "missile_lrx" },
    { 0x6944B881, "missile_lry" },
    { 0x37821F0F, "missile_mig_explosion" },
    { 0xA7055C45, "missile_move" },
    { 0x99AD0F56, "missile_offshoot" },
    { 0x5C41D8A7, "missile_oob_check" },
    { 0xB1C98097, "missile_out_of_bounds_watcher" },
    { 0x706A3AA6, "missile_pbr_delay_time" },
    { 0x9D195C54, "missile_point" },
    { 0x5ECE1C40, "missile_pos" },
    { 0xDD6938F0, "missile_radius_damage" },
    { 0x3AB5B78C, "missile_repulsor" },
    { 0x940489CA, "missile_reticle" },
    { 0x80EB8964, "missile_reticle_bottom" },
    { 0x2D44DACE, "missile_reticle_left" },
    { 0x40E8A085, "missile_reticle_right" },
    { 0x9B1918AE, "missile_reticle_top" },
    { 0xBCD8AD28, "missile_right" },
    { 0xB86F88C8, "missile_rocks" },
    { 0x1095CD55, "missile_rumble" },
    { 0xC2A0DD07, "missile_scale_down" },
    { 0x8FC6B398, "missile_scale_up" },
    { 0x7847C931, "missile_settarget" },
    { 0x27A58A2F, "missile_snow" },
    { 0x30D06F1B, "missile_sound_boost" },
    { 0x6C7C683C, "missile_sound_deploy_bomblets" },
    { 0xAE186A90, "missile_sound_impact" },
    { 0xA15AB4AC, "missile_sound_play" },
    { 0x23A8DBC6, "missile_sound_stop" },
    { 0xED13E222, "missile_sounds" },
    { 0xA6149155, "missile_source" },
    { 0x5D821503, "missile_sp" },
    { 0x9E4ACF77, "missile_speed" },
    { 0x33F1F2B6, "missile_start" },
    { 0x1EABCA0D, "missile_steering_hint" },
    { 0x8CCD4E0B, "missile_support" },
    { 0xE3643ECA, "missile_swarm" },
    { 0xD6655A86, "missile_swarm_count" },
    { 0x4234E2C0, "missile_swarm_flydist" },
    { 0x80D52AB1, "missile_swarm_flyheight" },
    { 0xC2416C9F, "missile_swarm_fx" },
    { 0xFE56F251, "missile_swarm_max" },
    { 0xFD3EE717, "missile_swarm_origin" },
    { 0x37312B42, "missile_swarm_owner" },
    { 0xE45D62A6, "missile_swarm_sound" },
    { 0xB7B23E71, "missile_swarm_stop" },
    { 0x086DAAFE, "missile_swarm_team" },
    { 0x34A199F1, "missile_target" },
    { 0x6E79A70E, "missile_target_icons" },
    { 0x9F313F0A, "missile_target_other" },
    { 0xE246B342, "missile_target_sight_check" },
    { 0x71F18432, "missile_targeting_watcher" },
    { 0xEF6EF682, "missile_think" },
    { 0x01322624, "missile_think2" },
    { 0x2C78017F, "missile_timeout_watch" },
    { 0xCF531BD6, "missile_tracker" },
    { 0xCC6A2E65, "missile_tracking" },
    { 0x850A5272, "missile_truck_steam" },
    { 0xBD9AB9DD, "missile_turret_firing_done" },
    { 0xDD7B7BFD, "missile_turret_left_index" },
    { 0x0C5B5461, "missile_turret_lock_lost_time" },
    { 0xA7971950, "missile_turret_lock_off" },
    { 0xAF07082D, "missile_turret_locked" },
    { 0x1C7DE8A2, "missile_turret_right_index" },
    { 0x24456F63, "missile_ulx" },
    { 0xFE42F4FA, "missile_uly" },
    { 0x9DA9C435, "missile_unlocked" },
    { 0x973995E5, "missile_up" },
    { 0x913274E1, "missile_valid_target_check" },
    { 0x64A4B2D3, "missile_vector" },
    { 0x85AC62D3, "missile_vo" },
    { 0xDA012E42, "missile_warning" },
    { 0x4AA503C0, "missile_warning_range" },
    { 0xB03FEED9, "missileammo" },
    { 0x2D234715, "missilecleanupthread" },
    { 0xEC9CEC69, "missilecompassicons" },
    { 0x74573F6C, "missiledamagewatcher" },
    { 0x6457074B, "missiledeath" },
    { 0x3EF02049, "missiledeathwatcher" },
    { 0x5E839D1A, "missiledebugdraw" },
    { 0x9141F17F, "missiledetonate" },
    { 0xE8B86C9C, "missiledronesound" },
    { 0xFF23BF08, "missiledronesoundstart" },
    { 0x263BF8ED, "missiledronewatcher" },
    { 0x62AA3473, "missiledroneweapon" },
    { 0xACB1AFA4, "missileduddeletedelay" },
    { 0x908940BA, "missileentities" },
    { 0xD8A2A8A5, "missileeyes" },
    { 0xF6A9A4DA, "missilefirednotify" },
    { 0xDBE63D5D, "missilefirewatcher" },
    { 0xE492B75E, "missilegoal" },
    { 0x0D6C9638, "missilegroup" },
    { 0xD7F37C01, "missilehintindicator_arrow" },
    { 0xB02D63F6, "missilehintindicator_missile" },
    { 0x68554DB5, "missilehintindicator_missile_flash" },
    { 0x43AABD90, "missilehintindicator_missile_offscreen" },
    { 0x5EABD1A8, "missileiconindex" },
    { 0x6AB79A3F, "missileimpactwatcher" },
    { 0x473ABAB6, "missileindicator" },
    { 0xD18446D3, "missileindicator_missiledeath" },
    { 0x2CC23FFF, "missileindicator_missileflash" },
    { 0x0B7200D8, "missileindicator_missileflashnotifies" },
    { 0xCA745CF4, "missileinterval" },
    { 0x3731C5A7, "missilelaunchnexttag" },
    { 0x3FFDAC69, "missilelockplayspacecheckenabled" },
    { 0xEA03CB26, "missilelockplayspacecheckextraradius" },
    { 0xAC23E1AE, "missilelockplayspacecheckradiussqr" },
    { 0xD7402669, "missilelockturret_cleared" },
    { 0x7175E549, "missilelockturret_locked" },
    { 0xFE1C918A, "missilelockwatcher" },
    { 0xEB7BCB5F, "missilelosetarget" },
    { 0xA3BA63D2, "missilemodel" },
    { 0x8354394C, "missileoldownerteam" },
    { 0x8E78A0D9, "missileoldteam" },
    { 0xD6B99AF9, "missileoldwatcherteam" },
    { 0xEF53F5A0, "missilepredictedlocation" },
    { 0xDB5E9A6A, "missileproximitydetonate" },
    { 0x52718808, "missileready" },
    { 0xD2D38BD6, "missileremotedeployfx" },
    { 0x61679ECF, "missileremotelaunchhorz" },
    { 0x1509906F, "missileremotelaunchtargetdist" },
    { 0x30C4F9B1, "missileremotelaunchvert" },
    { 0x6F2DD072, "missiles" },
    { 0xF9EB37D1, "missiles_disabled" },
    { 0xC6ED7A6B, "missiles_fired" },
    { 0xDA5295CC, "missiles_fired_at_start" },
    { 0x52D9C775, "missiles_headed_at_me" },
    { 0x6091C9D1, "missiles_incoming" },
    { 0x2827A0AE, "missiles_loaded" },
    { 0x4038FEE1, "missiles_shot" },
    { 0x32B94D29, "missilesenabled" },
    { 0xD21A45E8, "missilesforsighttraces" },
    { 0xEBCF6D32, "missilesremaining" },
    { 0xD6EC6BA5, "missiletagangles" },
    { 0xB8ECCE1B, "missiletagorigin" },
    { 0xDB89A3F4, "missiletags" },
    { 0x29975BCC, "missiletarget" },
    { 0xB45BF801, "missiletarget_deployflares" },
    { 0xE62DAE7B, "missiletarget_handleincomingmissile" },
    { 0x360BA185, "missiletarget_ismissileincoming" },
    { 0x01A52130, "missiletarget_isotherplayermissileincoming" },
    { 0xE97F1FF5, "missiletarget_lockonmonitor" },
    { 0x4DB10219, "missiletarget_playflarefx" },
    { 0x48A51EBA, "missiletarget_proximitydetonate" },
    { 0x3492826E, "missiletarget_proximitydetonateincomingmissile" },
    { 0xB7A9D8D2, "missiletargetdeath" },
    { 0x146FAC8D, "missiletargetmissdistance" },
    { 0x3385DDB0, "missileteam" },
    { 0xD9227A47, "missilethreatlevel" },
    { 0xA7AA4C7E, "missiletodestroy" },
    { 0x9A1D316B, "missiletrackdamage" },
    { 0xC4BA90F5, "missiletrucklaunch" },
    { 0x3AF25119, "missileturret" },
    { 0x3BE2B2FC, "missileturret_fired" },
    { 0x1AACC7B1, "missileturret_fired_at_me" },
    { 0x22DD063B, "missileturret_off" },
    { 0x6682DF47, "missileturret_on" },
    { 0xA7271125, "missileturretclientflags" },
    { 0x711E9028, "missileturretfiring" },
    { 0xA9EACAA6, "missileturretkillshotsound" },
    { 0x1FCF3482, "missileturretlockfinalized" },
    { 0xA0B78B39, "missileturretlockloststarttime" },
    { 0x7134E369, "missileturretlocksound" },
    { 0x70A6EB73, "missileturretlockstarted" },
    { 0x9223071B, "missileturretlockstarttime" },
    { 0x73FB0B63, "missileturretloop" },
    { 0x0295F0FB, "missileturretlostsightlinetime" },
    { 0xA84B1565, "missileturretmaxtargets" },
    { 0x34DF48AB, "missileturretmultilockloop" },
    { 0x781EBFD2, "missileturrettarget" },
    { 0x73954CFC, "missileturrettargetdeathtread" },
    { 0xF6939AB6, "missileturrettargetlist" },
    { 0xBE39363B, "missiletype" },
    { 0x2E930BB2, "missilevelocity" },
    { 0x2745F5B7, "missileweapon" },
    { 0xC97DC2C7, "missing" },
    { 0xEA677EA1, "missing_ai_footstep_callback" },
    { 0x538EECFD, "missing_dds" },
    { 0x0F12F5EA, "missing_steam" },
    { 0xA7F77D7C, "missinglegs" },
    { 0x1A443EBD, "mission" },
    { 0xF141939B, "mission_banister_jumpdown" },
    { 0x82D8BAE5, "mission_bonus" },
    { 0xAB0E1625, "mission_complete" },
    { 0xFCF10CC3, "mission_complete_clear_entities" },
    { 0x228F7A67, "mission_complete_clear_entity" },
    { 0x5D378D58, "mission_control_abort" },
    { 0x432AB5BA, "mission_dialogue" },
    { 0xB56F5B58, "mission_dialogue_array" },
    { 0x4E8EB003, "mission_dialogue_array_proc" },
    { 0x58DF0F29, "mission_dialogue_kill" },
    { 0xAC6EF741, "mission_dialogue_kill_sound" },
    { 0x86CA88EF, "mission_dialogue_kill_wait" },
    { 0x64DF6440, "mission_done" },
    { 0x4164E02D, "mission_end_timer" },
    { 0x4B05819C, "mission_fail" },
    { 0x5F6028F5, "mission_fail_casualties" },
    { 0x9F93AA96, "mission_fail_if_boat_flips" },
    { 0x04FFCCFE, "mission_fail_if_not_inside_info_volumes" },
    { 0x4A2DC7BC, "mission_fail_on_car_death" },
    { 0xE4FC93D2, "mission_fail_vehicle_death" },
    { 0x14C1C77F, "mission_failed" },
    { 0x1B458892, "mission_failed_disabled" },
    { 0x11195AA8, "mission_failed_during_laststand" },
    { 0x30555D9A, "mission_failed_out_of_time" },
    { 0x61C0955A, "mission_finished" },
    { 0x4229F1ED, "mission_guard_rightside" },
    { 0x5F490C79, "mission_lockdown" },
    { 0xB3E177A8, "mission_lockdown_guys_impervious" },
    { 0x15986D0B, "mission_lose" },
    { 0x827B82E9, "mission_name" },
    { 0x956ADB1B, "mission_pdf_reinforcements" },
    { 0xB34BD956, "mission_pdf_reinforcements_sprint" },
    { 0xCBFCA656, "mission_precourtyard_rightside" },
    { 0xD6CB7AD3, "mission_precourtyard_sniper_dead" },
    { 0x32DCB81B, "mission_precourtyard_spawnmanager_goalvolume" },
    { 0x20598BB3, "mission_sniper_tower" },
    { 0x21462DA9, "mission_success" },
    { 0xC2FB2142, "mission_time_out" },
    { 0x69E48D91, "mission_timer_expired" },
    { 0xD5FACBC7, "missionary_patroller" },
    { 0x59618957, "missionary_patroller_vo" },
    { 0xBB4B8883, "missioncallbacks" },
    { 0x4ABCFB8F, "missioncompletemsg" },
    { 0xB84DAB6E, "missiondvar" },
    { 0xAF8A4434, "missionend" },
    { 0x12F4F087, "missionendfailsafe" },
    { 0xFAB0CC81, "missionfail" },
    { 0xF114FB25, "missionfail_church" },
    { 0xFDED4D6E, "missionfailed" },
    { 0xE475A2C2, "missionfailedquote" },
    { 0xBD4FE667, "missionfailedwrapper" },
    { 0x207F8667, "missionfailedwrapper_nodeath" },
    { 0xCF5A053B, "missionfailsndspecial" },
    { 0xDA297178, "missionfailuremenu" },
    { 0x016292D7, "missionfailwatcher" },
    { 0x2FAB2042, "missiongoalvolumedummyfunction" },
    { 0x6BF0116F, "missionindex" },
    { 0x739EF396, "missionlose" },
    { 0xC3A1137C, "missions" },
    { 0xBA6476BC, "missionscoreypos" },
    { 0x2BC49AE6, "missionsettings" },
    { 0x7B0DD07B, "missionstatus" },
    { 0x592A2F8E, "missionstring" },
    { 0x5CFCDEB6, "missionsuccess" },
    { 0xB652C26F, "missionsuccessmenu" },
    { 0x17251FBA, "missiontime" },
    { 0x1534B3B0, "missle" },
    { 0xE3AC2976, "missledeath" },
    { 0x64C48E1B, "missles" },
    { 0x2A203198, "misssile" },
    { 0xC8A628D6, "misstime" },
    { 0xCA9A6896, "misstimeconstant" },
    { 0xE3C75EE7, "misstimedebounce" },
    { 0xE5A1F666, "misstimedistancefactor" },
    { 0x5491E588, "misstimeresetdelay" },
    { 0x7FA3938E, "mist" },
    { 0x9489EAB3, "mistake" },
    { 0xD15A61BB, "misty" },
    { 0xD2D90E34, "misunderstanding" },
    { 0x1A3B6410, "mitch" },
    { 0x790B27BF, "mitch_beatstick_hit" },
    { 0x5134C8C8, "mitton" },
    { 0x81AD6F6D, "mix" },
    { 0x3EDD2864, "mix_down" },
    { 0x8F37D5AE, "mix_pos" },
    { 0x37BA7B97, "mix_up" },
    { 0x5F93A89D, "mix_val" },
    { 0x1177B461, "mix_vox_id" },
    { 0x3A1A181A, "mixed" },
    { 0x454D5E9A, "mixed_lines" },
    { 0x5DB928F8, "mixed_rounds_enabled" },
    { 0xFDE243AD, "mixed_spawns" },
    { 0xE646B37C, "mixer" },
    { 0x34A15F48, "mixer_activated" },
    { 0x61753E11, "mixer_event" },
    { 0x546AF8D6, "mixer_event_monitor" },
    { 0x40AB78FC, "mixer_get_ramp" },
    { 0x1DB21E59, "mixer_level_activate" },
    { 0x39CC5284, "mixer_robot_think" },
    { 0xEB29E867, "mixer_self_activate" },
    { 0x93B8F64F, "mixer_thread" },
    { 0x501A3C3F, "mixers" },
    { 0x0C492DE5, "mixes" },
    { 0xCEA73AFB, "mixing" },
    { 0xA3996324, "mixmeup" },
    { 0xA6ED68BC, "mixthreadcore" },
    { 0x8778305C, "mixthreadenabled" },
    { 0x2C462037, "mixture" },
    { 0x3B4F1700, "mjd" },
    { 0x916564B1, "mjm" },
    { 0x790204D5, "mk" },
    { 0x496F071E, "mkornkven" },
    { 0xCE092EE9, "mkv" },
    { 0x9C050827, "ml1" },
    { 0x29FD98EC, "ml2" },
    { 0x72B9F018, "mlf" },
    { 0x68A89739, "mlo" },
    { 0x2CFD1003, "mm" },
    { 0x3A0D6760, "mmaestas" },
    { 0x2A94B369, "mmddyy" },
    { 0xF3A4C6C1, "mmmm" },
    { 0x7AE7AFFC, "mmoving" },
    { 0xDAEBBB72, "mms" },
    { 0x7D96A2F5, "mn_move_along_cafe_wall" },
    { 0x031DE7B0, "mn_move_from_bottleneck_to_bottom_of_stairs" },
    { 0x4E02BD33, "mn_move_passed_the_library" },
    { 0xF3DC5FA0, "mn_moveup_after_apache_attack" },
    { 0xDC7898AB, "mn_moveup_after_digbat_parking" },
    { 0x4B963228, "mn_moveup_after_mg_nest" },
    { 0x7A03882B, "mn_moveup_church" },
    { 0xF0ED91E8, "mn_moveup_from_dumpster_to_wall" },
    { 0xD23E6E09, "mn_moveup_into_bottleneck_right" },
    { 0xA6D71DE4, "mn_moveup_to_digbat_parking" },
    { 0xA40A2139, "mn_moveup_to_library" },
    { 0x615DF507, "mn_warp_after_intruder_hallway" },
    { 0x93F42970, "mn_warp_before_digbat_beatdown" },
    { 0x7FC1A06C, "mn_warp_move_around_parking_lot" },
    { 0x6024E47A, "mn_warp_straight_passed_apc" },
    { 0xC07DB86C, "mn_warp_upper_left_corner" },
    { 0xE0F81B31, "mo" },
    { 0x4EACB4CA, "mo_fastrope" },
    { 0x857B69A0, "mo_globals" },
    { 0xCC58F65D, "mo_tools" },
    { 0x10175AFC, "moab" },
    { 0x6B114EA5, "moab_gunners" },
    { 0x47F99E10, "moan" },
    { 0x2C759508, "moaning" },
    { 0x3022E8FB, "moans" },
    { 0x86874813, "mobile" },
    { 0xA3B56E3A, "mobility" },
    { 0xA1F54539, "mobilizing" },
    { 0xEF64B24E, "mobu" },
    { 0x86F44FC3, "mocap" },
    { 0x4961825D, "mocap_ar_ent" },
    { 0x3F04F1F6, "mocapped" },
    { 0xB2E19EFF, "mocappos" },
    { 0xA0E11F6B, "mock" },
    { 0xEDA95AA0, "mocked" },
    { 0x733F494A, "mocks" },
    { 0x1946F258, "mocomp" },
    { 0xB8F96586, "mocomp_barricade_offset" },
    { 0xE4B6D28D, "mocompadjusttocoverinit" },
    { 0x6D076798, "mocompadjusttocoverterminate" },
    { 0x15C49A60, "mocompadjusttocoverupdate" },
    { 0x661F7C20, "mocompanglestarttime" },
    { 0xCD9635E7, "mocompanim" },
    { 0x5C6790FF, "mocompanimblendouttime" },
    { 0xBE2200CD, "mocompanimflag" },
    { 0x07E253D5, "mocompapothiconfurybamfinit" },
    { 0x2DBBD110, "mocompapothiconfurybamfterminate" },
    { 0x320356B8, "mocompapothiconfurybamfupdate" },
    { 0xF7B15804, "mocompapothiconfuryjukeinit" },
    { 0x7DB60953, "mocompapothiconfuryjuketerminate" },
    { 0x9A6BDBED, "mocompapothiconfuryjukeupdate" },
    { 0xADA7C6A6, "mocompapothiconfuryteleportinit" },
    { 0xC5C85A6D, "mocompapothiconfuryteleportterminate" },
    { 0x1CDD0AB1, "mocompceilingdeath" },
    { 0x9ACE23E8, "mocompduration" },
    { 0xDCAA5C5D, "mocompfallerdrop" },
    { 0x30AE91CC, "mocompflankstandinit" },
    { 0xA9009B71, "mocompidlespecialfactorystart" },
    { 0x3574D810, "mocompidlespecialfactoryterminate" },
    { 0xD2E641C1, "mocompignorepainfaceenemyinit" },
    { 0x965BF254, "mocompignorepainfaceenemyterminate" },
    { 0xC3B41944, "mocompignorepainfaceenemyupdate" },
    { 0xCB0ACF50, "mocomplocoexplosioninit" },
    { 0x405168CA, "mocompmargwateleporttraversalinit" },
    { 0x8BDD20C9, "mocompmargwateleporttraversalterminate" },
    { 0x95847DE7, "mocompmargwateleporttraversalupdate" },
    { 0x69D688F1, "mocompname" },
    { 0x09779AF3, "mocomprobotproceduraltraversalinit" },
    { 0x3A35C9D6, "mocomprobotproceduraltraversalterminate" },
    { 0xC7991C52, "mocomprobotproceduraltraversalupdate" },
    { 0x5C863814, "mocomprobotstarttraversalinit" },
    { 0xC007B743, "mocomprobotstarttraversalterminate" },
    { 0x81204251, "mocomprobotstartwallruninit" },
    { 0xF1B69444, "mocomprobotstartwallrunterminate" },
    { 0xC62ED314, "mocomprobotstartwallrunupdate" },
    { 0x348F4933, "mocomps" },
    { 0xCC9D849E, "mocompstatus" },
    { 0xAFEC04E7, "mod" },
    { 0x54AA3452, "mod_" },
    { 0xCCB5C17D, "mod_array" },
    { 0xEEC3A87A, "mod_burned" },
    { 0xE97F2392, "mod_button" },
    { 0x33AA545F, "mod_crush" },
    { 0xE240695F, "mod_explosive" },
    { 0x6B7160C7, "mod_explosive_splash" },
    { 0xCDFCC13F, "mod_falling" },
    { 0xE4ABA0E4, "mod_grenade" },
    { 0xDED331C6, "mod_grenade_splash" },
    { 0xB9205777, "mod_head_shot" },
    { 0xF9118484, "mod_impact" },
    { 0xB7F9AD1A, "mod_melee" },
    { 0x74F70ECA, "mod_num" },
    { 0x221F9306, "mod_pistol_bullet" },
    { 0x5537B29C, "mod_pitch" },
    { 0xC5EFBA3F, "mod_projectile" },
    { 0x0AD62F67, "mod_projectile_splash" },
    { 0x9A90F313, "mod_rifle_bullet" },
    { 0xB9B681AA, "mod_suicide" },
    { 0xCDEE3DDA, "mod_telefrag" },
    { 0x31B025BE, "mod_trigger_hurt" },
    { 0x151607A2, "mod_type" },
    { 0xD66B6064, "mod_unknown" },
    { 0x53D9C958, "moddamage" },
    { 0x958A9BCE, "modded" },
    { 0x515416C8, "modder" },
    { 0x2E3AC271, "modderhelp" },
    { 0xDD0B57FA, "modderhelphud_createtext" },
    { 0x7019B994, "modderhelptext" },
    { 0x59300678, "mode" },
    { 0x4EC892E5, "mode_flag" },
    { 0xA5B52BE1, "mode_index" },
    { 0x1A3529A4, "mode_logic_func" },
    { 0xDCB8BDC5, "mode_main_func" },
    { 0xE58A6642, "mode_name" },
    { 0xDC485BA0, "mode_on" },
    { 0xB841AC58, "mode_render_options" },
    { 0x06DF9264, "model" },
    { 0xA26F5BEE, "model2" },
    { 0xC871D657, "model3" },
    { 0x216B163E, "model3_fired" },
    { 0x283C9EA0, "model3_new" },
    { 0xC4254F95, "model3_tracerfire" },
    { 0x031909EA, "model5a" },
    { 0x0D6617C7, "model6a" },
    { 0x8921656D, "model_ang" },
    { 0xF1695EEF, "model_angles" },
    { 0x2728397C, "model_anim" },
    { 0x494680EF, "model_anim_audio" },
    { 0x1F6E8BD3, "model_animation" },
    { 0x1CA815F6, "model_array" },
    { 0xE99617F0, "model_at4" },
    { 0xD804C5DC, "model_base" },
    { 0xD7ECEDD5, "model_btr" },
    { 0xE3186C84, "model_by_team" },
    { 0xD39C8125, "model_clip" },
    { 0x30146224, "model_convert" },
    { 0xDD65A480, "model_convert_area" },
    { 0x1A1EF2AB, "model_convert_areas" },
    { 0x88D4C70F, "model_convert_copy_kvps" },
    { 0x68C2BF70, "model_count" },
    { 0x389DE6C0, "model_damaged" },
    { 0x578714AA, "model_delete_area" },
    { 0xC9F29492, "model_detcord" },
    { 0x9582AC25, "model_direction_change" },
    { 0x8684A655, "model_disable" },
    { 0x7B9F972E, "model_dummy_death" },
    { 0x7F80D140, "model_dw" },
    { 0x0C4ACE17, "model_error" },
    { 0x99FBFFB1, "model_event4_tower" },
    { 0xA68DF0AD, "model_export" },
    { 0xFE478E57, "model_fly_away" },
    { 0x23A2FD22, "model_gore" },
    { 0xC8114DFB, "model_group_map" },
    { 0xB805D9B7, "model_hidden" },
    { 0xD9BCCA4D, "model_index" },
    { 0xEAB4B679, "model_info_update" },
    { 0x70447495, "model_init" },
    { 0xA09B7F85, "model_intro_anim" },
    { 0x957E41AF, "model_list" },
    { 0xB9D41AFD, "model_locks" },
    { 0xDD852326, "model_name" },
    { 0x59A96859, "model_names" },
    { 0x9DB1E878, "model_off_name" },
    { 0xB73A33CE, "model_old" },
    { 0x1CC5D93E, "model_on_name" },
    { 0x0E316979, "model_or_models" },
    { 0x4AD73A7F, "model_org" },
    { 0x02B3CB21, "model_origin" },
    { 0x685876D2, "model_original" },
    { 0xECA0B177, "model_removal_through_model_convert_system" },
    { 0xFA4E1887, "model_restore" },
    { 0x40748AF9, "model_restore_area" },
    { 0xBD9B7799, "model_sampan_for_landing" },
    { 0x5D2B07BA, "model_saw" },
    { 0xD5649655, "model_scene" },
    { 0x18953C8E, "model_scene_anim_keys" },
    { 0x2F3BAAA4, "model_scenes" },
    { 0x98BDC058, "model_shield_recharge" },
    { 0x4070417C, "model_speed" },
    { 0xB40DB851, "model_spotlight" },
    { 0x071F6F2E, "model_swap" },
    { 0xF0C82A1E, "model_swap_1" },
    { 0xCAC5AFB5, "model_swap_2" },
    { 0x865BB677, "model_swap_after_anim" },
    { 0xFADB4616, "model_tag_origin" },
    { 0xD2F4F6E0, "model_to_struct" },
    { 0xC9CC7A13, "model_type" },
    { 0x1E63AB47, "model_type_bones" },
    { 0xC1FEAA97, "model_undamaged" },
    { 0x261C4D53, "modelarray" },
    { 0xAEF0C735, "modelattachtag" },
    { 0xF384CD5A, "modelbadplacement" },
    { 0x9CA59A4F, "modelbadplacementanimate" },
    { 0xF974ECDB, "modelbase" },
    { 0xB78DB780, "modeldummy" },
    { 0xCBD1860B, "modeldummyon" },
    { 0x0BD4183C, "modelgoodplacement" },
    { 0x7D100099, "modelgoodplacementanimate" },
    { 0xFE139B49, "modelhasphyspreset" },
    { 0x9C967CA3, "modelhit" },
    { 0xAE725CB8, "modelindex" },
    { 0x0F10F645, "modelname" },
    { 0xF72827E6, "modelname1" },
    { 0xD125AD7D, "modelname2" },
    { 0xAB233314, "modelname3" },
    { 0x8520B8AB, "modelname4" },
    { 0x5F1E3E42, "modelname5" },
    { 0xB3103D24, "modelnameobj" },
    { 0x2A8498D4, "modelnames" },
    { 0xDA15FF44, "modelnum" },
    { 0x649960C3, "modeloff" },
    { 0xAE515F8F, "modelon" },
    { 0x830F8B02, "modelpos" },
    { 0x49107097, "models" },
    { 0xF700FB92, "modelscale" },
    { 0x66CF2FEB, "modelsthread" },
    { 0xBF28CB01, "modelstodetach" },
    { 0x2B05D6B5, "modelswap" },
    { 0xEB5D4F32, "modelswapdelay" },
    { 0x649C0A9F, "modelvehicles" },
    { 0x68F1E111, "modename" },
    { 0x68E1069E, "moderate" },
    { 0xC85B0FA5, "moderate_number_of_beartraps" },
    { 0x0957CC42, "moderenderoptions" },
    { 0x49F37740, "modern" },
    { 0x711891D3, "modes" },
    { 0x839BD13E, "modetokens" },
    { 0x93B9015D, "modifed" },
    { 0x4246546F, "modifiable" },
    { 0x17C5BDB9, "modification" },
    { 0x5457C8F0, "modifications" },
    { 0xD80E0704, "modified" },
    { 0xB60718F7, "modifieddamage" },
    { 0xEC30B8C2, "modifier" },
    { 0xCB9AD10D, "modifiers" },
    { 0x1233332B, "modifies" },
    { 0x4F2A0B8F, "modify" },
    { 0xFED43545, "modify_debug_hud2" },
    { 0x6F3BD547, "modify_objective_destination_babystep" },
    { 0x5ACC3FED, "modify_param" },
    { 0x03CFCBEB, "modify_player_damage" },
    { 0xBA34D203, "modify_player_damage_friendlyfire" },
    { 0x0EDDAA07, "modify_player_damage_meansofdeath" },
    { 0xA8E6E4AE, "modify_run_rate" },
    { 0x362F45F1, "modifying" },
    { 0x6169B833, "modifyplayerdamage" },
    { 0x0E19727A, "modname" },
    { 0x6595C7F5, "modnames" },
    { 0xBB3FB99B, "modprvcurrentanim" },
    { 0xDE4C7273, "modprvcurrentmodel" },
    { 0xDD173E5E, "mods" },
    { 0x529A1E3B, "modstrings" },
    { 0x4E6D099C, "modtools" },
    { 0xAB98046F, "modtype" },
    { 0x5680245D, "modular" },
    { 0x3D42942C, "modulate" },
    { 0x20C14F20, "modulate_laser" },
    { 0xC414A4C0, "modulated" },
    { 0xDED831CB, "modulation" },
    { 0x0CE08641, "module" },
    { 0x98952D0D, "module_drones" },
    { 0x0D0383BC, "module_hud_connecting" },
    { 0xFBF6C2A0, "module_hud_create_team_name" },
    { 0xFC190175, "module_hud_full_screen_overlay" },
    { 0x0DA46DD0, "module_hud_round_end" },
    { 0x766224A3, "module_hud_round_num" },
    { 0xA4EAF9BA, "module_hud_team_1_score" },
    { 0xE39C3145, "module_hud_team_2_score" },
    { 0xFE1945C8, "module_hud_team_winer_score" },
    { 0x0E0BBE85, "module_name" },
    { 0xE9F19D2A, "module_skipto" },
    { 0x462393C2, "module_turret" },
    { 0xF3F4F568, "modules" },
    { 0x80F452BF, "modulous" },
    { 0x4677A818, "modulus" },
    { 0xD305E57F, "modz" },
    { 0xE1B7C582, "moffat" },
    { 0x40101898, "mofo" },
    { 0x89BC1319, "mohammad" },
    { 0x408E5ADD, "moive" },
    { 0xD8570513, "molitov" },
    { 0xA051F85D, "molotov" },
    { 0x8029B709, "molotov_1_detach" },
    { 0xB7D2D01A, "molotov_1_explodes" },
    { 0x7FFED0D8, "molotov_1_light" },
    { 0x80D7427C, "molotov_2_detach" },
    { 0x98E43BF7, "molotov_2_explodes" },
    { 0xF85A60DF, "molotov_2_light" },
    { 0x3B4E5310, "molotov_brush" },
    { 0x020E6405, "molotov_circus" },
    { 0x575D15FF, "molotov_flamefx" },
    { 0x2459D0D3, "molotov_flametag" },
    { 0xABB799F4, "molotov_fxorg" },
    { 0x9CCD5CC9, "molotov_guys_stopidle" },
    { 0x84175F94, "molotov_hurt_trig" },
    { 0xC28C59D8, "molotov_intro_van" },
    { 0xEA890985, "molotov_kill_ai" },
    { 0xCD3C56DF, "molotov_kill_recorded" },
    { 0x6E709C40, "molotov_linktag" },
    { 0xF7AF3AA4, "molotov_start" },
    { 0xA31D765B, "molotov_target" },
    { 0x744BF43B, "molotov_target_1" },
    { 0x292A0C7A, "molotov_targets" },
    { 0x6F432620, "molotov_threadkill" },
    { 0xF3142878, "molotov_throw" },
    { 0xB9D88F8C, "molotov_throw_sound" },
    { 0x84A8341B, "molotov_tosser_fall_down" },
    { 0x169E6979, "molotov_waitforputaway" },
    { 0x59B05AF4, "molotov_waitforthrow" },
    { 0xBAC47C69, "molotovdeath" },
    { 0x2241440A, "molotoved" },
    { 0x34210CB5, "molotoves" },
    { 0xF2E830EF, "molotovgrenadeindex" },
    { 0xEBDAE49C, "molotovs" },
    { 0x9623D39D, "molotovs_cancel" },
    { 0x044D9871, "molotovs_throw" },
    { 0xFC7E17D9, "molotovtargeted" },
    { 0xE92F77E8, "molotv" },
    { 0x59D5B736, "mom" },
    { 0xEDFA33E7, "momement" },
    { 0x21A4FB7D, "moment" },
    { 0x2BFAD36F, "moment_anim" },
    { 0x38B442C7, "moment_move" },
    { 0xD4D2FB7A, "moment_org" },
    { 0x9A872EE3, "moment_stair_shoot" },
    { 0xC4982334, "moment_stairfall" },
    { 0xE56BCCA7, "moment_stairfall_die" },
    { 0xAE53F024, "moment_trigger" },
    { 0x22276A3C, "moments" },
    { 0xA072E07B, "momentum" },
    { 0xD33855F2, "momentum_at_spawn_or_game_end" },
    { 0xFED1B46C, "momentum_popup" },
    { 0x3AFD7C74, "momentumcost" },
    { 0x24992177, "momentummax" },
    { 0x1720991A, "momentummaxmultiplier" },
    { 0x1F095397, "momentummultiplierbonus" },
    { 0x09623384, "momentummultiplierbonuslimit" },
    { 0x494EAC5D, "momentumnotifyqueue" },
    { 0x001DFEFC, "momentumnotifywaitlasttime" },
    { 0xA8845208, "momentumnotifywaittime" },
    { 0x3F87EBD2, "momentumpercent" },
    { 0xDBB44AA2, "mon_01a" },
    { 0x834C1F0D, "mon_01a_render" },
    { 0xB5B1D039, "mon_01b" },
    { 0x537CA4DC, "mon_01b_render" },
    { 0x42B53853, "monastary" },
    { 0xC73D92CF, "money" },
    { 0x92762A54, "money_dump" },
    { 0xD872D4D4, "money_dump_delay" },
    { 0x85093CF8, "money_dump_size" },
    { 0x8C15B1C7, "money_fx_on_death" },
    { 0x03C3355C, "money_grab" },
    { 0xC3EA9849, "money_grabbed" },
    { 0x95776571, "money_precache" },
    { 0x878B8D35, "money_required" },
    { 0xB6F0F96B, "money_showers" },
    { 0x1F3A78C7, "money_spawn" },
    { 0x13AE09A1, "money_wobble" },
    { 0xD3104935, "moneydump" },
    { 0x99654538, "mong" },
    { 0xF9E758E5, "moniter_debug_hud2" },
    { 0x102E276D, "monitor" },
    { 0x9F2EA27E, "monitor1" },
    { 0x792C2815, "monitor2" },
    { 0x5329ADAC, "monitor3" },
    { 0x2D273343, "monitor4" },
    { 0x0724B8DA, "monitor5" },
    { 0xE1223E71, "monitor6" },
    { 0xBB1FC408, "monitor7" },
    { 0x951D499F, "monitor8" },
    { 0x6F1ACF36, "monitor9" },
    { 0xAFFB8BD1, "monitor__drop_landing_changed" },
    { 0x16521215, "monitor_aa_guy_death" },
    { 0xDC26E7C6, "monitor_ai_count" },
    { 0x2E5FDC6E, "monitor_ai_group" },
    { 0x53F36833, "monitor_ambient_rapellers" },
    { 0x45B55FD4, "monitor_arena_horse_death" },
    { 0x0E6800C0, "monitor_arena_kill" },
    { 0xFE9C4E4A, "monitor_arena_soviet" },
    { 0xD98E92F2, "monitor_arena_truck_death" },
    { 0x73EDF9B2, "monitor_assasination_scenario" },
    { 0xA2D34211, "monitor_backtrack_fail" },
    { 0x8832D6A5, "monitor_banzai_chargers" },
    { 0xD06BA3F4, "monitor_base_ai" },
    { 0x1D263B24, "monitor_base_health" },
    { 0xE6EBE863, "monitor_bigrig_guys" },
    { 0x2F055258, "monitor_boat_damage_state" },
    { 0xAD1290F7, "monitor_bookshelf_interuption" },
    { 0xFF27D2C3, "monitor_bot_population" },
    { 0xFAE9588D, "monitor_bot_team_population" },
    { 0xA796AB2C, "monitor_bp1exit_soviet" },
    { 0x753D0552, "monitor_bp1wave3_muj" },
    { 0xA7696399, "monitor_bp2_defenders" },
    { 0x9CC13399, "monitor_bp2_enemies" },
    { 0x8423D0A9, "monitor_bp2_horseriders" },
    { 0xB2903FA9, "monitor_bp3_soviets" },
    { 0xB649ED7C, "monitor_bp3uaz_soviet" },
    { 0xF8C0CB58, "monitor_btr_chase_death" },
    { 0x2CC92FE8, "monitor_btr_chase_over" },
    { 0xA3114219, "monitor_bunker_damage" },
    { 0xB483187E, "monitor_bunkers" },
    { 0x0E67174B, "monitor_bus_kill_player" },
    { 0x92EB6044, "monitor_cache_bp1" },
    { 0x583F8194, "monitor_cache_bp1exit" },
    { 0x0BEF202E, "monitor_capture_zombies" },
    { 0xD2DE394C, "monitor_castle_stairs_defenders" },
    { 0x28F123AD, "monitor_chamber_death_trigs" },
    { 0xF2BA3400, "monitor_charge_time" },
    { 0xAD1494E0, "monitor_control_tower_fail" },
    { 0xCB60A598, "monitor_crater_charge" },
    { 0x42AFF8C0, "monitor_damage_as_occupant" },
    { 0x952800B0, "monitor_death_stop_door" },
    { 0x56447D67, "monitor_defend_spawns" },
    { 0xCFAB5FA8, "monitor_detectnearbyenemies" },
    { 0x70B09E20, "monitor_distance_to_convoy" },
    { 0xB4EBFE8C, "monitor_distance_to_failure" },
    { 0x49BBD420, "monitor_dog_special_grenades" },
    { 0x35ECE9DD, "monitor_drone_attack" },
    { 0xA0D12A91, "monitor_drone_death" },
    { 0x0014E40A, "monitor_drone_stealth_section" },
    { 0x943CEE13, "monitor_drop_landing" },
    { 0x38871899, "monitor_drop_landing_entity_singleton" },
    { 0xABCFA802, "monitor_e1_mgguy" },
    { 0x6B792EB2, "monitor_emp_killstreaks" },
    { 0x5BE7206C, "monitor_end_game" },
    { 0xED5D1FA2, "monitor_enemy_bp1" },
    { 0x83400EAC, "monitor_enemy_bp1_bottom" },
    { 0xEB725902, "monitor_engine_damage" },
    { 0x663B2AC1, "monitor_engineer_damage" },
    { 0x916A796C, "monitor_enter_exit_vehicle" },
    { 0x1F11E44B, "monitor_enter_vehicle" },
    { 0x7EF147D4, "monitor_escape_enemies" },
    { 0xAF113893, "monitor_f35_health" },
    { 0xA01AB915, "monitor_factory_objectives" },
    { 0x55CDE903, "monitor_first_claw_switch" },
    { 0xB0B6386E, "monitor_first_group" },
    { 0x9D281CB3, "monitor_flag_fx" },
    { 0x9F8E6C2D, "monitor_footsteps" },
    { 0xA6F9605A, "monitor_footsteps_fx" },
    { 0x8C51559A, "monitor_for_player_leave_trigger" },
    { 0xC240F189, "monitor_fueler" },
    { 0x8BAC2AA6, "monitor_g20_1_health" },
    { 0x742E22B7, "monitor_g20_2_health" },
    { 0x97710140, "monitor_gaz_gate" },
    { 0xFD983319, "monitor_gaz_guys" },
    { 0x8D6912EC, "monitor_glass_room_color_chain" },
    { 0x1E435237, "monitor_goalvolume" },
    { 0x476A8AC3, "monitor_grapple_grenade_ammo" },
    { 0xF2DA2121, "monitor_grass_guys" },
    { 0x73D64914, "monitor_guard_death" },
    { 0xCC4B37EE, "monitor_gun" },
    { 0x723B9831, "monitor_gunner" },
    { 0x3317DF1A, "monitor_gunner_death" },
    { 0xC1AC4ED3, "monitor_harper_color_chains" },
    { 0xB5EF4BEA, "monitor_hip3" },
    { 0x27F6BB25, "monitor_hip4" },
    { 0x73673B3E, "monitor_killspawner_151" },
    { 0x5F0998A5, "monitor_lab_1_1" },
    { 0x12F13B47, "monitor_lab_1_1_frontline" },
    { 0x84CF2578, "monitor_lab_2_1_frontline" },
    { 0xADE192D9, "monitor_lab_2_2" },
    { 0x45EED925, "monitor_lantern_dmg" },
    { 0xE6494A5B, "monitor_lead_vehicle" },
    { 0x7F56E8B3, "monitor_leader" },
    { 0xC406A6D3, "monitor_left_path_turret_death" },
    { 0xB692322A, "monitor_lift_guys" },
    { 0x5A8A27F8, "monitor_list" },
    { 0x03ACAF26, "monitor_lobby_frontline" },
    { 0xF0770773, "monitor_low_road_group" },
    { 0x558F4034, "monitor_lower_level_ai_groups" },
    { 0xE081D2F2, "monitor_lvt" },
    { 0xA21B920A, "monitor_mansion_exit" },
    { 0x281E1827, "monitor_mason_motel_sprint" },
    { 0xD59DF0B2, "monitor_mason_on_truck" },
    { 0x585CB26F, "monitor_meat_on_side" },
    { 0xC0D4CD4D, "monitor_meat_on_team" },
    { 0x3208147F, "monitor_melee_swipe" },
    { 0x21E41BE0, "monitor_mg_bunker_damage" },
    { 0xA083179D, "monitor_missiles_locked_on_to_me" },
    { 0x386855A0, "monitor_mortar_ammo" },
    { 0xCB2C2152, "monitor_mortar_guys" },
    { 0x129C2140, "monitor_mortarteams_pod1" },
    { 0xCA1DBF73, "monitor_movement_speed" },
    { 0x6FF3F6A8, "monitor_muj_group" },
    { 0x25DFE57C, "monitor_nitrogen_asd_death" },
    { 0xD5CD4E51, "monitor_nitrogen_guys" },
    { 0x9F7C27F2, "monitor_other_guys_death" },
    { 0xD6E4E0D4, "monitor_other_guys_death2" },
    { 0x309B1016, "monitor_panther_1_tanks" },
    { 0x1FDAA9E5, "monitor_panther_2_tanks" },
    { 0xC2307838, "monitor_passenger" },
    { 0xC5C1B782, "monitor_pdf_assaulters" },
    { 0x143D4BBE, "monitor_perk_on_zipline" },
    { 0x133BD7FC, "monitor_pers_headshot_upgrade" },
    { 0x5313DD3B, "monitor_plane_flyby" },
    { 0x288D3A82, "monitor_planter" },
    { 0xE5218CCB, "monitor_planter_scene" },
    { 0x3A1E1BFA, "monitor_planter_spawners" },
    { 0x7DD38B59, "monitor_player_asd_death" },
    { 0xB1137CB9, "monitor_player_bullets" },
    { 0xE9AD0B91, "monitor_player_damage" },
    { 0x58F840EA, "monitor_player_death_invulnerability_eligibility" },
    { 0x94FBD9FF, "monitor_player_distance" },
    { 0x0EDF16D7, "monitor_player_failure_after_stealth" },
    { 0x2C4C5D9E, "monitor_player_hangar_threat" },
    { 0xB5E02C0C, "monitor_player_has_tow_missile" },
    { 0xF7D8B67F, "monitor_player_mortar_run" },
    { 0xFF86CA1D, "monitor_player_movement" },
    { 0x1D5B3C45, "monitor_player_parking_lot_threat" },
    { 0x172D2F2D, "monitor_player_runway_fire" },
    { 0x6E5E3EAA, "monitor_player_sprint" },
    { 0xF24CC1A0, "monitor_player_status" },
    { 0x52901331, "monitor_player_stealth_state" },
    { 0x6B390E72, "monitor_player_vehicle_difficulty" },
    { 0xCD592316, "monitor_player_weaponfire" },
    { 0xB62DD35D, "monitor_player_zipline" },
    { 0x630F39BF, "monitor_pod1_enemies" },
    { 0xEE882824, "monitor_pod1_patroller" },
    { 0xB636F957, "monitor_pod1_patrollers" },
    { 0xDAE1197E, "monitor_potus_health" },
    { 0x1EFEDA5D, "monitor_puzzle_portal" },
    { 0xDC69142B, "monitor_radar_installation" },
    { 0x02BB7D81, "monitor_radio_usage" },
    { 0x55AB7569, "monitor_rappel_gap" },
    { 0xB6BE5F5D, "monitor_raygun_mark3" },
    { 0xF9115AE8, "monitor_recapture_zombie_count" },
    { 0x1819168F, "monitor_recapture_zombies" },
    { 0x41515F38, "monitor_rider" },
    { 0x0A986A32, "monitor_right_path_asd_death" },
    { 0x26CDE875, "monitor_salazar_color_chains" },
    { 0x6971C08A, "monitor_scraper" },
    { 0xA7A2160C, "monitor_second_hall_color_chain" },
    { 0xF6FF773B, "monitor_shadow_notetracks" },
    { 0x1D9D3449, "monitor_shed_guys" },
    { 0x9D3E266B, "monitor_shield_deployment" },
    { 0x936B9EBD, "monitor_shoveler1" },
    { 0xB96E1926, "monitor_shoveler2" },
    { 0x600F2DCF, "monitor_shovelers" },
    { 0xFBA4BD1B, "monitor_skylight_damage" },
    { 0x62818693, "monitor_smoker" },
    { 0x715D414A, "monitor_snowcat_passenger" },
    { 0xA59D600E, "monitor_soviet_group" },
    { 0x2C637EA4, "monitor_spawn_first_color_chain" },
    { 0x734B2ACF, "monitor_spawners" },
    { 0x23518B94, "monitor_spiderhole_ambush" },
    { 0x24B3FAC6, "monitor_spiderhole_death" },
    { 0xEBEA49AB, "monitor_spiderhole_lid" },
    { 0x35C95399, "monitor_squads" },
    { 0x5FB6115E, "monitor_street_battle" },
    { 0x6ECA60FB, "monitor_surveillance_zoom" },
    { 0x5CD54EBF, "monitor_takeoff_node" },
    { 0xAF74C3C3, "monitor_threat_sniper_threat_bias" },
    { 0xF949F4DB, "monitor_time" },
    { 0x0307FBD3, "monitor_tracker_existing_players" },
    { 0xDB8CDEBB, "monitor_tracker_perk" },
    { 0x57C10A2F, "monitor_tracker_perk_killcam" },
    { 0xAF635A20, "monitor_train_depot_guys" },
    { 0xBF3C8AF4, "monitor_truck_gunners" },
    { 0x8741DBD6, "monitor_truck_health" },
    { 0xE9C1E9C0, "monitor_trucks" },
    { 0xF3BE8827, "monitor_vehicle_counts" },
    { 0x241685D1, "monitor_vig_death" },
    { 0xFEBF787B, "monitor_volume_for_enemies" },
    { 0xDCE5654F, "monitor_weapon_fire" },
    { 0xDDC6A164, "monitor_weapons_cache" },
    { 0x8A1729E5, "monitor_welder" },
    { 0xF296D7C7, "monitor_when_player_acquires_perk" },
    { 0xDE427E40, "monitor_wire_disconnect" },
    { 0x1A5F5580, "monitor_xc1" },
    { 0x8C66C4BB, "monitor_xc2" },
    { 0x66644A52, "monitor_xc3" },
    { 0xD86BB98D, "monitor_xc4" },
    { 0xB2693F24, "monitor_xc5" },
    { 0x5A68004B, "monitor_zombie_groans" },
    { 0x8C536CBA, "monitorbombuse" },
    { 0xADD8A139, "monitorcurtain" },
    { 0xA346A44A, "monitordamage" },
    { 0x7E33B3F2, "monitordestroyedtank" },
    { 0x7BB6F128, "monitordistance" },
    { 0xD395C106, "monitordrivedistance" },
    { 0xAC20C6E4, "monitored_entity" },
    { 0x5639DBC1, "monitorempgrenade" },
    { 0xEEE6059F, "monitorfalldistance" },
    { 0xB54308AD, "monitorflaredortabuned" },
    { 0xE1DE60DD, "monitorflash" },
    { 0x8E149BC3, "monitorflash_internal" },
    { 0x5C187C52, "monitorflashorstun" },
    { 0xD1E2E07F, "monitorflight" },
    { 0x6490AA31, "monitorgameended" },
    { 0xBB0BF92B, "monitorgpsjammer" },
    { 0x5855FAF1, "monitorgrenadefire" },
    { 0xC102D545, "monitorgrenadethrowbacks" },
    { 0x6F9BA87E, "monitorimmobilizedtank" },
    { 0xDF0522FB, "monitoring" },
    { 0x7CE0FB4C, "monitorlivetime" },
    { 0x9F852841, "monitormisc" },
    { 0xB603CACC, "monitormisccallback" },
    { 0x96D54E39, "monitormiscsingle" },
    { 0x7E33176A, "monitorperkusage" },
    { 0xDE4F854A, "monitorrcbombflash" },
    { 0x6FB41BCD, "monitorreloads" },
    { 0xD28B136C, "monitors" },
    { 0x8F35236F, "monitorsengrenjammer" },
    { 0xFCFE6A8E, "monitorsingledrivedistance" },
    { 0xFBFB168C, "monitorsinglesprintdistance" },
    { 0xEF068F2E, "monitorspeed" },
    { 0xE7F2B584, "monitorsprintdistance" },
    { 0x12202A3A, "monitorstreaks" },
    { 0x8F8E6DD9, "monitorstun" },
    { 0x8CE50095, "monitortankdeath" },
    { 0x0BA1B8FA, "monitortearusage" },
    { 0x2BD7975F, "monitorvehiclecounts" },
    { 0x23CF0719, "monitorziphint" },
    { 0x7DFF0629, "monk_scream_trig" },
    { 0xFCFBF2C2, "monk_scream_vox" },
    { 0xA9E85E52, "monkey" },
    { 0x61E8EC1D, "monkey_achievement_got" },
    { 0x4707AF51, "monkey_ambient_can_make_sound" },
    { 0x5830565E, "monkey_ambient_drops_add_array" },
    { 0xEDC97D0D, "monkey_ambient_drops_remove_array" },
    { 0x00F413C7, "monkey_ambient_excited_noise" },
    { 0xFB89EF58, "monkey_ambient_gib_all" },
    { 0xD7A5F860, "monkey_ambient_idle" },
    { 0x316B0A64, "monkey_ambient_init" },
    { 0x1CAA925B, "monkey_ambient_level_set_next_sound" },
    { 0x3A013570, "monkey_ambient_noise" },
    { 0x5FE491EC, "monkey_ambient_play_sound" },
    { 0x102D51D2, "monkey_ambient_set_next_sound" },
    { 0x733D4A3D, "monkey_ambient_shrink" },
    { 0x36E5F7C2, "monkey_ambient_sound_choke" },
    { 0x39BB6CAF, "monkey_ambient_spawn" },
    { 0x7D49834C, "monkey_ambient_wait_for_remove" },
    { 0x5E0DC8CC, "monkey_ambient_wait_to_be_shot" },
    { 0x9C52F817, "monkey_ambient_wait_to_spawn" },
    { 0x810A4827, "monkey_ambient_watch_for_power_up" },
    { 0x97B548FD, "monkey_anim_spot" },
    { 0x3BD5290B, "monkey_attack_player" },
    { 0xBE4DA6F5, "monkey_attack_player_wait" },
    { 0x4F048499, "monkey_attack_player_wait_wrapper" },
    { 0x3541A163, "monkey_attract_dist" },
    { 0x9FF5C2C3, "monkey_attract_dist_diff" },
    { 0x63246C47, "monkey_blown_up" },
    { 0x07E84184, "monkey_bolt" },
    { 0xB2C413ED, "monkey_bolt_cleanup" },
    { 0x1AD70549, "monkey_bolt_holder" },
    { 0x6781049A, "monkey_bolt_on_back" },
    { 0x1B022F6C, "monkey_bolt_taunts" },
    { 0x0387B9C7, "monkey_cleanup" },
    { 0x9DDB51FD, "monkey_cosmodrome_enter_level" },
    { 0xF5562F17, "monkey_cosmodrome_failsafe" },
    { 0xBF828621, "monkey_cosmodrome_lander_death" },
    { 0x3CC4D318, "monkey_cosmodrome_prespawn" },
    { 0x716F0611, "monkey_cosmodrome_round_start" },
    { 0x96A65A63, "monkey_crowd_noise" },
    { 0x27212857, "monkey_dead" },
    { 0x90C5919D, "monkey_death" },
    { 0x8757475E, "monkey_death_total" },
    { 0xBF9B3D0E, "monkey_dir" },
    { 0xDBB86BF2, "monkey_do" },
    { 0xD0DE9539, "monkey_drops" },
    { 0x5567BB80, "monkey_escape_count" },
    { 0x1147282A, "monkey_escape_with_powerup_count" },
    { 0x490217D0, "monkey_getmonkeyspawnlocation" },
    { 0x145F2CC2, "monkey_glow" },
    { 0x6F24F931, "monkey_grenade" },
    { 0xCA38DF4C, "monkey_grenade_watcher" },
    { 0xF4FBD6B0, "monkey_grenade_watcher_temple" },
    { 0xD6A3CC98, "monkey_grenades" },
    { 0x2606F0A3, "monkey_index" },
    { 0x728A0DCE, "monkey_killed" },
    { 0x3EFD3298, "monkey_land_off" },
    { 0x674A05D2, "monkey_land_on" },
    { 0x4C54BCEE, "monkey_lander_delay_fx_off" },
    { 0x5FCC9C4C, "monkey_lander_fx" },
    { 0xBE051852, "monkey_lander_fx_off" },
    { 0x657048A4, "monkey_lander_fx_on" },
    { 0x886BE33D, "monkey_lander_get_closest_dest" },
    { 0x7DD4D988, "monkey_model" },
    { 0x7E4D7B7E, "monkey_obvious_vox" },
    { 0x8EAE2284, "monkey_pathing" },
    { 0xC557073A, "monkey_portal_think" },
    { 0xDE6FC78A, "monkey_portals" },
    { 0xF3707167, "monkey_powerup_escape" },
    { 0xFD927951, "monkey_prespawn" },
    { 0xD5E87EE0, "monkey_remove_from_pack" },
    { 0x15768556, "monkey_round_start" },
    { 0x84C16C72, "monkey_see" },
    { 0xA4BBAB98, "monkey_see_monkey_dont_achieved" },
    { 0xA56F5145, "monkey_song_override" },
    { 0x77E0DEAA, "monkey_spawners" },
    { 0xF40CB975, "monkey_spawns" },
    { 0x7019BEBB, "monkey_start" },
    { 0x71A4687C, "monkey_start_monitor" },
    { 0xE0A20669, "monkey_stop" },
    { 0x1A75C26D, "monkey_stop_attck_player" },
    { 0x2AC1782E, "monkey_stop_loop" },
    { 0x7599F76E, "monkey_stop_monitor" },
    { 0xEB00D4D9, "monkey_structs" },
    { 0x187AFB04, "monkey_temple_custom_damage" },
    { 0x6D81EFCA, "monkey_templethink" },
    { 0xF9B8C18A, "monkey_thrower" },
    { 0x25B03476, "monkey_time" },
    { 0x0BA38F77, "monkey_tracker" },
    { 0x3C009502, "monkey_trigs" },
    { 0xA727FEAE, "monkey_update" },
    { 0x9375B409, "monkey_zombie_choose_run_temple" },
    { 0x5D40EA94, "monkey_zombie_choose_sprint_temple" },
    { 0x7D9E6C11, "monkey_zombie_default_enter_level" },
    { 0x7DEB01DB, "monkey_zombie_enter_level" },
    { 0x1498342D, "monkey_zombie_failsafe" },
    { 0x9924E38F, "monkey_zombie_grenade_pickup" },
    { 0x9CA2294A, "monkey_zombie_grenade_response" },
    { 0x536415CD, "monkey_zombie_grenade_throw" },
    { 0x4334C398, "monkey_zombie_grenade_throw_watcher" },
    { 0xA6670DD8, "monkey_zombie_health" },
    { 0x7E34A7D9, "monkey_zombie_spawners" },
    { 0x48BE06EE, "monkeybomb" },
    { 0x7DD36E4C, "monkeydead" },
    { 0xC540F45D, "monkeys" },
    { 0x38C8C7C0, "monkeys_are_defined" },
    { 0xC4B3BF54, "monkeys_starting_crate" },
    { 0xC3F9D91B, "monkeysspawnedthisround" },
    { 0xBDAF8138, "monkeyzone" },
    { 0xC745F6F9, "monolingustic_prompt_format" },
    { 0x02A55A40, "monologue" },
    { 0xE9CBBF74, "monsoon" },
    { 0x55685245, "monsoon_amb" },
    { 0xE46E988C, "monsoon_anim" },
    { 0x11D91EEA, "monsoon_art" },
    { 0x63DF061C, "monsoon_celerium_chamber" },
    { 0xF167140D, "monsoon_custom_introscreen" },
    { 0xD379B95D, "monsoon_fx" },
    { 0x98F02177, "monsoon_fxanim_deconstruct" },
    { 0xBDC8FF78, "monsoon_heavy_rumble" },
    { 0x95DECF7F, "monsoon_hero_rampage" },
    { 0xD5B5607F, "monsoon_intro" },
    { 0x6F575628, "monsoon_lab" },
    { 0xA898ACF3, "monsoon_lab_defend" },
    { 0xBFE548DB, "monsoon_light_rumble" },
    { 0xEB7EEB97, "monsoon_objectives" },
    { 0xA474DFB0, "monsoon_ruins" },
    { 0x654138DF, "monsoon_screen_tap_rumble" },
    { 0xEADBF66F, "monsoon_util" },
    { 0x11A23A62, "monsoon_vo" },
    { 0xCDD5A629, "monsoon_wingsuit" },
    { 0x34148EE5, "monster" },
    { 0x8CEFE8EA, "monster_clip" },
    { 0x25882113, "monsterclip" },
    { 0xC1876DD7, "monsterclip_debug" },
    { 0x6FDAC841, "month" },
    { 0x5223F3FD, "month_days" },
    { 0x20FB6984, "month_num" },
    { 0xC3EADB68, "months" },
    { 0x0DD0C264, "moo" },
    { 0x9A726DA5, "moo_loop" },
    { 0xCC860128, "mood" },
    { 0xE87722B2, "moon" },
    { 0x388B30FB, "moon_access_granted" },
    { 0x9FE406E5, "moon_airlock_occupied" },
    { 0x9C835776, "moon_astro_enter_level" },
    { 0xE2A8A405, "moon_astro_get_spawn_struct" },
    { 0xF81A004E, "moon_bad_jolie" },
    { 0x6CCABECE, "moon_be_activate" },
    { 0x050917E4, "moon_be_anim_swap" },
    { 0x5480BBE2, "moon_be_move" },
    { 0xDC66B274, "moon_be_resume_anim" },
    { 0xC247B014, "moon_be_start_capture" },
    { 0x33193BA7, "moon_be_stop_anim" },
    { 0x68AE41FB, "moon_be_think" },
    { 0x08E51FEB, "moon_bhb_choice" },
    { 0x2DF5F66C, "moon_bhb_poi_control" },
    { 0xCD5ED146, "moon_biodome_array" },
    { 0x01DECDDC, "moon_biodome_fog_change" },
    { 0xE9CB7A5D, "moon_biodome_powerup_temptation" },
    { 0x299AA71A, "moon_biodome_random_pad_temptation" },
    { 0x2C80B547, "moon_biodome_temptation_active" },
    { 0xC9EB60D7, "moon_biodome_temptation_init" },
    { 0xD4687193, "moon_black_hole_bomb_poi" },
    { 0x219C9642, "moon_create_life_trigs" },
    { 0x836F39E7, "moon_devgui" },
    { 0x1E86CE02, "moon_digger_respawn" },
    { 0xCFD32447, "moon_door_opened" },
    { 0x59554EBD, "moon_exterior_fog_change" },
    { 0xBBC51C7E, "moon_fog_triggers_init" },
    { 0x33B91CD2, "moon_glass_breach_init" },
    { 0x8D6A3BB2, "moon_good_jolie" },
    { 0xE4824CEA, "moon_hit_reaction" },
    { 0xF7D8BBAB, "moon_interior_array" },
    { 0xFAF77143, "moon_interior_fog_change" },
    { 0x62F051E9, "moon_intermission" },
    { 0xED044ADF, "moon_jolie_access" },
    { 0xDFA37980, "moon_jolie_greet" },
    { 0x185A3C3E, "moon_jolie_timer_vox" },
    { 0x63E4F806, "moon_jolie_work" },
    { 0x8C6BCC04, "moon_jump_pad_cushion_play_sound" },
    { 0xFAB72764, "moon_jump_pad_cushion_sound_init" },
    { 0xFDC20E4D, "moon_jump_pad_overrides" },
    { 0x10C9B4ED, "moon_jump_pad_progression_end" },
    { 0xB73035D4, "moon_jump_pad_run_switch" },
    { 0xA383038E, "moon_jump_pads" },
    { 0xCA918B3A, "moon_jump_pads_low_gravity" },
    { 0x9FD107A8, "moon_jump_pads_malfunctions" },
    { 0xBFADA798, "moon_keyhole" },
    { 0xAF409AC8, "moon_low_gravity_velocity" },
    { 0xE4BA5F07, "moon_nml_bhb_present" },
    { 0x2931CECE, "moon_nml_fog_change" },
    { 0x16C2A574, "moon_nml_transition" },
    { 0xFDFA7AF5, "moon_offhand_weapon_overrride" },
    { 0x83BC978E, "moon_open_access" },
    { 0x6BC191D6, "moon_pad_malfunction_think" },
    { 0xF38C9936, "moon_perk_lost" },
    { 0x69173D89, "moon_player_connect" },
    { 0xDF33ECAA, "moon_pois" },
    { 0x9095441B, "moon_pool" },
    { 0x857F2827, "moon_pool_room_entered" },
    { 0x9BAA92FC, "moon_pool_wires" },
    { 0xC27DAAD9, "moon_pool_wires_start" },
    { 0x02412214, "moon_post_respawn_callback" },
    { 0x02757495, "moon_push_zombies_when_astro_explodes" },
    { 0x73D82859, "moon_quad_exit_align" },
    { 0x1FE01B05, "moon_quad_fastsprint" },
    { 0xFBBA43B2, "moon_quad_gas_immune" },
    { 0x4474334D, "moon_quad_phase_fx" },
    { 0xE23E8D13, "moon_quad_prespawn" },
    { 0x11B04BF0, "moon_quad_sidestep" },
    { 0x734565F2, "moon_quad_wait_phase_end" },
    { 0x5654BC55, "moon_rb_dist_think" },
    { 0x38A6761C, "moon_reset_respawn_overide" },
    { 0x761C17E6, "moon_respawn_override" },
    { 0x07E0513B, "moon_rocket_follow_path" },
    { 0x465AA1D3, "moon_round_think_func" },
    { 0x68A9F436, "moon_sidequest_achieved" },
    { 0x08AFEA16, "moon_sidequest_big_bang_achieved" },
    { 0xF12241B2, "moon_sidequest_of_awesome" },
    { 0x120CF7BE, "moon_sidequest_reveal_achieved" },
    { 0x452ADE48, "moon_sidequest_swap_achieved" },
    { 0xEBF1A310, "moon_sky" },
    { 0x357AA92A, "moon_speed_up" },
    { 0x07468F0F, "moon_startmap" },
    { 0x9894AEFB, "moon_stop_running_to_catch" },
    { 0x52D0C9D3, "moon_transmission_struct" },
    { 0xEAC1D81D, "moon_transmission_vo" },
    { 0x06A3198A, "moon_tunnels_fog_change" },
    { 0xFDF7BB6A, "moon_vertical_jump" },
    { 0x3C54D0D0, "moon_vision_set" },
    { 0x13BF8D1A, "moon_vision_set_choice" },
    { 0xE5B5DA3A, "moon_zmb_and_bhb_touching_trig" },
    { 0x90B54B22, "moon_zombie_death_response" },
    { 0x17A5D12C, "moon_zombie_run_change" },
    { 0xFEF75520, "moon_zombieland_ignore_poi" },
    { 0xF382C360, "moon_zone_init" },
    { 0x4C254811, "moonbase" },
    { 0x457CA4B3, "mooncomp_is_speaking" },
    { 0x37315F3E, "moonlight" },
    { 0x6C871A24, "moonpool" },
    { 0x44691B21, "moonpool_climbout_done" },
    { 0x7BB8029B, "moonpool_clip_left" },
    { 0xDCE8BDCE, "moonpool_clip_right" },
    { 0xCABF20D1, "moonpool_door_left" },
    { 0xA66C37FC, "moonpool_door_right" },
    { 0x40C26030, "moonpool_move_player" },
    { 0x7809C1D3, "mop" },
    { 0x2F25872F, "mopping" },
    { 0xE81942B2, "moral" },
    { 0x42359B3D, "moral_achievements" },
    { 0x9C880BC9, "moral_choice_scene" },
    { 0x3FDF936E, "moral_event_start" },
    { 0x881AF46E, "moral_rail_player_body_anim" },
    { 0xAAAB8811, "moral_terrorist_group" },
    { 0x7758A39A, "moral_vtol_crash_anim" },
    { 0x8B99DD3D, "morals" },
    { 0x34103BE6, "morals_ambient_qrotor_delete" },
    { 0x836B5276, "morals_anims" },
    { 0xDDDED8B4, "morals_arm_light_fx" },
    { 0x27D98CBD, "morals_arms_fov_in" },
    { 0x3F54CD3C, "morals_arms_fov_out" },
    { 0xE3956E31, "morals_call_farid" },
    { 0x12C35CBA, "morals_capture_approach_handle_player_anim" },
    { 0x591BCB0B, "morals_capture_punch" },
    { 0x36E693CF, "morals_capture_start_choice" },
    { 0x0D3BD0D8, "morals_choice_outcome" },
    { 0x265929CD, "morals_clean_up" },
    { 0x7810C559, "morals_disable_camo_suit" },
    { 0xACA76207, "morals_dof" },
    { 0x9A338430, "morals_dof_shoot_harper" },
    { 0x1A151023, "morals_intro_ambient" },
    { 0xB5F706DD, "morals_mason_intro" },
    { 0xE9B21CD8, "morals_outcome_farid_shot" },
    { 0x7C341694, "morals_rail_allies_cleanup" },
    { 0x9AAC1E5B, "morals_rail_anims" },
    { 0x6A4C2F27, "morals_rail_count_terrorist_deaths" },
    { 0xD75948E3, "morals_rail_done" },
    { 0x2A884A11, "morals_rail_go" },
    { 0xC072CAF3, "morals_rail_ground_spawner" },
    { 0x4580CF27, "morals_rail_player_damage_override" },
    { 0xA30F3658, "morals_rail_rpg" },
    { 0x58194002, "morals_rail_setup" },
    { 0x3A4EE00D, "morals_rail_start" },
    { 0x03934001, "morals_rail_terrorist_spawnfunc" },
    { 0x3823BF77, "morals_setup" },
    { 0x2CE05C92, "morals_shoot_harper_explosion" },
    { 0xBECCD8E0, "morals_shoot_harper_fov_in" },
    { 0x6036897F, "morals_shoot_harper_fov_out" },
    { 0x0401D00E, "morals_shoot_harper_slowmo" },
    { 0xE4148615, "morals_shoot_harper_speedup" },
    { 0x6AD4382D, "morals_shoot_harper_vtol_fire" },
    { 0x723F04B5, "morals_shoot_menendez_fire" },
    { 0xBC145677, "morals_shoot_vtol_camera_in" },
    { 0xE130E9C2, "morals_shoot_vtol_camera_out" },
    { 0x2FAB07E1, "morals_shoot_vtol_fire_rocket" },
    { 0xB17C18C4, "morals_start" },
    { 0xA8FA2305, "morals_streamer_hint_off" },
    { 0x0EB8E3F9, "morals_streamer_hint_on" },
    { 0xB9A2F585, "morals_vtol_setup" },
    { 0xFF840F2E, "more" },
    { 0x1369D1B3, "more_booms" },
    { 0xBF1897F7, "more_dialogue" },
    { 0x144D27F1, "more_guys" },
    { 0x7284E634, "more_planes" },
    { 0xB943E926, "more_plant_claymores" },
    { 0xABDBDB2A, "more_time" },
    { 0xF6FDDF31, "more_trash" },
    { 0xB7A2D3E2, "more_triggers" },
    { 0x3E68F2B0, "more_veh_array" },
    { 0xAB7DA0FB, "morefriendlies" },
    { 0xF1D8E4A6, "morgue" },
    { 0x8146F05A, "morgue_heartbeat_set" },
    { 0x4CBA1F0F, "morgue_lamp" },
    { 0x109910F0, "morigin" },
    { 0x1D4163EB, "morning" },
    { 0x3E9D3BA8, "morot" },
    { 0xAEEA82C1, "morph" },
    { 0x53E4B05C, "morph_fog_settings" },
    { 0xC347C57E, "morpheus" },
    { 0xBB815DE8, "morpheus_2nd_floor" },
    { 0x39C65AE6, "morpheus_2nd_floor_clear" },
    { 0x2711AB86, "morpheus_2nd_floor_complete" },
    { 0x09136F54, "morpheus_alley" },
    { 0x9F9C690A, "morpheus_alley_clear" },
    { 0x0DFD2A52, "morpheus_alley_complete" },
    { 0xB77EDAEF, "morpheus_allies" },
    { 0x220CA2A3, "morpheus_completion" },
    { 0x13600D6B, "morpheus_dumpster" },
    { 0xD519D271, "morpheus_dumpster_clear" },
    { 0x37BC09AB, "morpheus_dumpster_complete" },
    { 0xC5E19E92, "morpheus_flags" },
    { 0x7A2280A4, "morpheus_flanker" },
    { 0x9A264ADA, "morpheus_flanker_clear" },
    { 0x9F66A2A2, "morpheus_flanker_complete" },
    { 0x22B20099, "morpheus_iron_fence" },
    { 0xA6A81986, "morpheus_iron_fence_fight" },
    { 0x675C120C, "morpheus_iron_fence_spawn_function" },
    { 0x40B24F47, "morpheus_quick_start" },
    { 0xA5E2A0C2, "morpheus_rpg" },
    { 0xC47DC8DC, "morpheus_rpg_clear" },
    { 0x8E136388, "morpheus_rpg_complete" },
    { 0x62BFCB8B, "morpheus_rpg_dialogue" },
    { 0x63288216, "morpheus_sets" },
    { 0x04989B85, "morpheus_single" },
    { 0x452BFCCF, "morpheus_single_clear" },
    { 0xB2AB497D, "morpheus_single_complete" },
    { 0xA9381552, "morpheus_single_dialogue" },
    { 0x1DFDB456, "morpheus_target" },
    { 0x0919A15B, "morphine_revive" },
    { 0x36F93A6A, "morphine_revive_think" },
    { 0x81BE44A8, "morphine_shot" },
    { 0xB03B0661, "morphine_shot_think" },
    { 0x385C51D0, "morphine_think" },
    { 0x816C2E25, "morse" },
    { 0x64023B97, "morse_code" },
    { 0x98C7BB0D, "morse_code_additional_enemies_think" },
    { 0x02726CB3, "morse_code_guy" },
    { 0x57E0AD61, "morse_code_guy_animate_chair" },
    { 0x71272BB2, "morse_code_guy_think" },
    { 0xD310BD96, "morse_code_helper" },
    { 0xD603AB1E, "morse_code_room_think" },
    { 0xB36D8D25, "morse_delay" },
    { 0x23458E28, "morse_guy_sounds" },
    { 0xBC3C03E1, "morse_guy_sounds_think" },
    { 0x9CA1B14A, "morse_guy_track_death" },
    { 0x91158ABE, "morse_interrupted" },
    { 0xB81C6603, "morse_letters" },
    { 0x3F7B1F4C, "morse_messages" },
    { 0xA7DBC8E0, "mort_structs" },
    { 0xADE27CFC, "mortality" },
    { 0xC5A82B16, "mortar" },
    { 0xC3E5F49B, "mortar1" },
    { 0x2D4F8F88, "mortar1_destroyed_fx" },
    { 0x4DC84EFD, "mortar1cleared" },
    { 0x51DE8560, "mortar2" },
    { 0x4DEBA8A5, "mortar2_destroyed_fx" },
    { 0xDA3FAD3C, "mortar2cleared" },
    { 0x77E0FFC9, "mortar3" },
    { 0x93A56DA4, "mortar_4_explo" },
    { 0x758F7306, "mortar_a" },
    { 0x51C18278, "mortar_aigroup" },
    { 0x3E2FB949, "mortar_and_smoke_grenade" },
    { 0x59C13C60, "mortar_area_clear" },
    { 0xC58FB81C, "mortar_array" },
    { 0x72C06D32, "mortar_attack_2_objective" },
    { 0x4F8CF89D, "mortar_b" },
    { 0x7F1BF7B0, "mortar_boom" },
    { 0xBCEAC96A, "mortar_buffel_blocker" },
    { 0x298A7E34, "mortar_c" },
    { 0x23D3C9C6, "mortar_challenge_complete" },
    { 0x7BD8087B, "mortar_check" },
    { 0xD758CE2B, "mortar_color_chains" },
    { 0xF052E30A, "mortar_congrats" },
    { 0xF15C74FE, "mortar_crew_destroyed" },
    { 0x78644BD5, "mortar_crews" },
    { 0x038803CB, "mortar_d" },
    { 0x8A317181, "mortar_death" },
    { 0x7B947FA8, "mortar_deaths" },
    { 0x79EC7E62, "mortar_destroyed" },
    { 0x622BE6D9, "mortar_done" },
    { 0xD3422351, "mortar_dropped" },
    { 0x2D7049A5, "mortar_drops" },
    { 0x0B987B26, "mortar_dudes_setup" },
    { 0xDD858962, "mortar_e" },
    { 0xAEA68E06, "mortar_earthquake" },
    { 0xB7830EF9, "mortar_f" },
    { 0x97B076B9, "mortar_fail" },
    { 0x96B31F95, "mortar_fail_trig_logic" },
    { 0x8C7CD3AF, "mortar_fired" },
    { 0x51F78653, "mortar_fx_anim_setup" },
    { 0xECE8D634, "mortar_fxanim" },
    { 0x91809490, "mortar_g" },
    { 0x4CDBC585, "mortar_gun_destroyed" },
    { 0x48A52090, "mortar_guns" },
    { 0x31463756, "mortar_guy" },
    { 0x789C5551, "mortar_guy_alert" },
    { 0xFCEF6CC2, "mortar_guy_damage" },
    { 0x71EEA761, "mortar_guy_objective_remove" },
    { 0xA24CE2C9, "mortar_guys" },
    { 0x018F9452, "mortar_guys1" },
    { 0xDB8D19E9, "mortar_guys2" },
    { 0xB58A9F80, "mortar_guys3" },
    { 0xC062A23B, "mortar_guys_clear" },
    { 0x3393C16E, "mortar_guys_dead" },
    { 0x3D1F81B5, "mortar_guys_objective" },
    { 0xCBA5C0B7, "mortar_h" },
    { 0x9E03DBF9, "mortar_helper_message" },
    { 0x1DA68EE2, "mortar_hint" },
    { 0x4CB85C4C, "mortar_hint_given" },
    { 0xDD1391E6, "mortar_hit1_point" },
    { 0x39672F91, "mortar_hit2_point" },
    { 0x9E994D73, "mortar_hit_point" },
    { 0xD9CD249A, "mortar_inc_done" },
    { 0x00128762, "mortar_inits" },
    { 0x97F69459, "mortar_intro" },
    { 0x459D894C, "mortar_kill_recorded" },
    { 0x8D4C2C4B, "mortar_kill_timer" },
    { 0x5D7F9734, "mortar_kills" },
    { 0xB76ACCC5, "mortar_last_sound" },
    { 0x09112ADF, "mortar_line" },
    { 0xD47C74D1, "mortar_location_callout" },
    { 0x910E4F87, "mortar_loop" },
    { 0x4B5E85D0, "mortar_max_dist" },
    { 0x3418617A, "mortar_min_dist" },
    { 0x73D320E9, "mortar_missile_firing_update" },
    { 0xDC6BAE9D, "mortar_model_init" },
    { 0x2A4ED3DC, "mortar_name" },
    { 0x7D08B3F6, "mortar_node1" },
    { 0x5706398D, "mortar_node2" },
    { 0x3103BF24, "mortar_node3" },
    { 0x3D3CFA36, "mortar_notify" },
    { 0x3363BA56, "mortar_objective" },
    { 0x660E73EA, "mortar_pacing_audio" },
    { 0x3026BE91, "mortar_pit_damage_think" },
    { 0x82BC2F5B, "mortar_pits" },
    { 0x6981975D, "mortar_point" },
    { 0xEAD59C59, "mortar_push" },
    { 0xD7232DB3, "mortar_pwn_thread" },
    { 0x032A56DF, "mortar_radius" },
    { 0x25714B11, "mortar_rattle_setup" },
    { 0xB433AAFE, "mortar_react" },
    { 0x500CC3E8, "mortar_ref" },
    { 0x870A413C, "mortar_refill_think" },
    { 0xF6A57D9E, "mortar_riverbed" },
    { 0x5F9810BD, "mortar_rocks" },
    { 0x0A09F6ED, "mortar_rocks_clips" },
    { 0x75BBFBFF, "mortar_round" },
    { 0xE57265E6, "mortar_round_think" },
    { 0x9E209449, "mortar_rumble_on_all_players" },
    { 0xFB63A7E9, "mortar_run_flyby" },
    { 0x6259E231, "mortar_run_vehicles_blow_up" },
    { 0xB70AD829, "mortar_savannah" },
    { 0xABFD1DB8, "mortar_savannah_start" },
    { 0xF3D42EE9, "mortar_setup_finished" },
    { 0x8D66466D, "mortar_sniper_cleanup" },
    { 0x67F1DB4A, "mortar_sound" },
    { 0xD00F7DFD, "mortar_sp_radius" },
    { 0xF9414F9F, "mortar_spawner" },
    { 0xEA3C0A7D, "mortar_spot" },
    { 0xB35A61CE, "mortar_spot1" },
    { 0x8D57E765, "mortar_spot2" },
    { 0x67556CFC, "mortar_spot3" },
    { 0x450B4E40, "mortar_spotter_setup" },
    { 0x51F0F6CA, "mortar_status_change" },
    { 0xECEC66C2, "mortar_struct" },
    { 0xF30DBB0D, "mortar_structs" },
    { 0x35FF99F1, "mortar_targets" },
    { 0x7AAF7053, "mortar_team_trig" },
    { 0xE1A9BB2B, "mortar_team_trig2" },
    { 0x2C3904DD, "mortar_teams" },
    { 0x6F8A1E85, "mortar_threshold_reached" },
    { 0x348669BB, "mortar_trigger" },
    { 0x9AD92C3C, "mortar_victim_bp3_bp2" },
    { 0x1F919B3B, "mortar_victim_left" },
    { 0xC132F45A, "mortar_victim_logic" },
    { 0xD3C5E6EE, "mortar_victim_right" },
    { 0xFB60C0D4, "mortar_victims" },
    { 0x4AE6F9A5, "mortar_vo_index" },
    { 0xDDE196F1, "mortar_vo_line" },
    { 0xC1E1FB3C, "mortar_warning_intro" },
    { 0x73795520, "mortar_within_player_fov" },
    { 0x649A2E1C, "mortarammo" },
    { 0x0C291588, "mortarcanoncount" },
    { 0x03E72CA4, "mortarcanonshellcount" },
    { 0xD02B616C, "mortarcrews" },
    { 0xCB36ACCD, "mortardamagedents" },
    { 0x8F099E12, "mortardamagedentscount" },
    { 0x785F34FF, "mortardamagedentsindex" },
    { 0x4D6E0BBB, "mortardangercenters" },
    { 0x4979D372, "mortardangerforwardpush" },
    { 0xB0A8D409, "mortardangermaxradius" },
    { 0x6DD2BF59, "mortardangermaxradiussq" },
    { 0xEA63F15B, "mortardangerminradius" },
    { 0x4FF464B7, "mortardangerovalscale" },
    { 0x33573EAB, "mortardeaths" },
    { 0x807F518D, "mortareffect" },
    { 0xDBEAA7DD, "mortarent" },
    { 0x211A5E44, "mortarfx" },
    { 0xBF90E7FF, "mortargroup" },
    { 0xCC9CD8E1, "mortarhut_pieces" },
    { 0xE17C9C1A, "mortarimpacteffects" },
    { 0x1EDE4B9A, "mortarinprogess" },
    { 0x56F81DEA, "mortarinprogress" },
    { 0xC911FEE2, "mortarkillcammodelcounts" },
    { 0x199BD3B3, "mortarmaprange" },
    { 0x7EE16C4F, "mortarmaxinterval" },
    { 0x2A3AEAC9, "mortarmininterval" },
    { 0xD0222C65, "mortarmsg" },
    { 0x0D586758, "mortarpits" },
    { 0x9BFC4F3E, "mortarpits_fake_launch" },
    { 0x00775160, "mortarpits_shoot_boards" },
    { 0x00E56E78, "mortarpos" },
    { 0x04A76631, "mortarradarused" },
    { 0xF7426589, "mortars" },
    { 0xFF33164C, "mortars_done" },
    { 0xA97DF861, "mortars_falling" },
    { 0x28D1BE98, "mortars_inc" },
    { 0xA3A86E1D, "mortars_launch" },
    { 0x6B82BF1A, "mortars_nag" },
    { 0x2101303C, "mortars_out_too_long" },
    { 0x0120BF41, "mortarselectioncount" },
    { 0xBE19389F, "mortarselectorradius" },
    { 0x96BA524D, "mortarsetup" },
    { 0x22226BBA, "mortarshellshock" },
    { 0x5B1C6B9E, "mortarshellsinair" },
    { 0x90ECDA85, "mortarsinfront" },
    { 0x35A20D96, "mortarspawner" },
    { 0x279177D9, "mortarteam" },
    { 0x1A4BFD71, "mortarteam_exp_sound" },
    { 0x1B6F1728, "mortarteam_fire" },
    { 0x55FEA624, "mortarteam_incoming_sound" },
    { 0x9C7C6897, "mortarteamactive" },
    { 0xD031FA90, "mortarteams" },
    { 0x636419F2, "mortarteamspawn" },
    { 0x95DEEF4A, "mortarthink" },
    { 0x65FE59B2, "mortarthread" },
    { 0x831378AC, "mortartrig" },
    { 0x1EF454D6, "mortartrigger" },
    { 0x962559AF, "mortartrigs" },
    { 0x0EF2EC34, "mortarwaiter" },
    { 0x87130D88, "mortarwithinfov" },
    { 0xDA4E5A44, "mortarzone" },
    { 0xE1994CA0, "mortat" },
    { 0xB9D87504, "mortor" },
    { 0xDE7BC448, "mortor_explosion_sound" },
    { 0x47BDACB7, "mortor_incoming_sound" },
    { 0x040A0B17, "mortor_model_init" },
    { 0x5E8BC85F, "mortor_point" },
    { 0xFC2475E6, "mortor_points" },
    { 0x480977A9, "mortor_strike" },
    { 0x6EF4E244, "mortor_struct" },
    { 0x81FE93F7, "mortor_structs" },
    { 0x250163B7, "mortors" },
    { 0xD6A01F2C, "morttar" },
    { 0x06025298, "mos" },
    { 0xD57DD295, "moscow" },
    { 0xE21CBAA5, "mosin" },
    { 0x01464587, "mosque" },
    { 0x6BFC41F8, "mosquito" },
    { 0x20C50273, "moss" },
    { 0xA7E31932, "moss_death_martyrdom" },
    { 0x39FB5439, "moss_proximity_watch" },
    { 0x4DC11A10, "moss_spawn_init" },
    { 0x2C7E4103, "moss_spawn_init_big" },
    { 0x46C77CDC, "most" },
    { 0x24723086, "most_kills" },
    { 0x82566A77, "most_spawns" },
    { 0x62396055, "mostheadshots" },
    { 0xD5C6A4DF, "mostheadshotsnum" },
    { 0x38708B8A, "mostkilleby" },
    { 0x185B47AF, "mostkilled" },
    { 0x587AF6AC, "mostkilledby" },
    { 0xD2D122FF, "mostkillsleastdeaths" },
    { 0xB07C9D1E, "mostley" },
    { 0x2A8079D9, "mostly" },
    { 0x700EED4D, "mostrecent" },
    { 0x4F46EA36, "mostrevives" },
    { 0x50885BCE, "mostrevivesnum" },
    { 0x06C76AC8, "motar_pit_damage" },
    { 0x928E8E99, "motars" },
    { 0x6EDAEA11, "motd" },
    { 0x7CFD28F4, "motel" },
    { 0x17540A8F, "motel_anims" },
    { 0x768F12C1, "motel_anims_old" },
    { 0xF78B1F9C, "motel_breach_main" },
    { 0xC6DFE86C, "motel_fade_out" },
    { 0x03B4BCBD, "motel_fail_condition" },
    { 0x51E6B397, "motel_scene_end" },
    { 0xE10AC7CB, "motel_snapshot" },
    { 0x3EE2D81D, "motel_tv_swap" },
    { 0xE822E9B5, "motel_vo_afghanistan" },
    { 0xFF06E6EE, "motel_vo_nicaragua" },
    { 0x935ABD4D, "motetrack" },
    { 0x4DF4EFA0, "mothafucka" },
    { 0xE6F72C7C, "mother" },
    { 0xD4D7E75C, "motherfucker" },
    { 0x74EB4C73, "motherland" },
    { 0xF2E2599A, "mothership" },
    { 0x5A98EA62, "mothership_cb" },
    { 0x1DC12CD6, "mothership_lod_bias" },
    { 0xEAA96CE1, "mothership_team_change" },
    { 0x0F32ABD6, "mothership_visionset_alias" },
    { 0xD615E450, "mothership_visionset_file" },
    { 0x3C45AE2F, "motion" },
    { 0x91F6F85B, "motion_angle_offset" },
    { 0x941B0CF8, "motionangle" },
    { 0x2C996EF0, "motionbuilder" },
    { 0xF4D9EB11, "motioning" },
    { 0x0D2505E4, "motionpulse_enable" },
    { 0x959E2076, "motions" },
    { 0x15AFC6AD, "motivation" },
    { 0xC66D4BA7, "motivation_array" },
    { 0xDAB9C24C, "motivational_array" },
    { 0xB1016B52, "motivational_struct" },
    { 0x64C99132, "moto" },
    { 0xC6228FA8, "moto_ent" },
    { 0x75019387, "moto_gear_trans" },
    { 0x040B1622, "moto_id" },
    { 0xD2D66C15, "moto_stage" },
    { 0xA6446EAB, "motocops" },
    { 0x2F22F654, "motor" },
    { 0x8121257C, "motor_left" },
    { 0x47741B7D, "motor_pool" },
    { 0x50955E53, "motor_right" },
    { 0xD1716614, "motorbike_max_damage" },
    { 0xE5C23CAD, "motorcade" },
    { 0x3C93F5C6, "motorcycle" },
    { 0xBD0A8715, "motorcycle_anims" },
    { 0x7A11955F, "motorcycle_enemy" },
    { 0x2D2EA772, "motorcycle_fov" },
    { 0xC991C350, "motorcycle_gunmodel" },
    { 0x647C6D83, "motorcycle_init" },
    { 0x6CCA8B70, "motorcycle_magicgun" },
    { 0x800C4810, "motorcycle_room" },
    { 0x71A57E01, "motorcycle_room_entry" },
    { 0xEFE7E5C0, "motorcycle_wipeout" },
    { 0xCA83BF01, "motorcycleammocount" },
    { 0x1C232B79, "motorcycles" },
    { 0x17FCD7E9, "motorcyle_escape" },
    { 0xD693D695, "motorycle" },
    { 0xC9F1502D, "motorycle_weapon_fx" },
    { 0xBFA689D8, "mound" },
    { 0x9D0AC7B3, "mounds" },
    { 0x5F7EE348, "mount" },
    { 0xF1148B70, "mount_anim" },
    { 0xEAFD639B, "mount_org" },
    { 0x3BC789EF, "mount_soct_harper_started" },
    { 0x6FCBE134, "mount_soct_player_rumble" },
    { 0x33D114D4, "mount_turret_dof1" },
    { 0xA5D8840F, "mount_turret_dof2" },
    { 0x7FD609A6, "mount_turret_dof3" },
    { 0xC1C9A599, "mount_turret_dof4" },
    { 0x9BC72B30, "mount_turret_dof5" },
    { 0x54DDB82D, "mount_world_flakcrew" },
    { 0x75A1F178, "mountain" },
    { 0x644FFFA1, "mountain_fxanims" },
    { 0xF5445BE2, "mountain_tops_no_cull" },
    { 0x386D82D3, "mountains" },
    { 0x1DCCBD59, "mountainside" },
    { 0x92970E5B, "mounted" },
    { 0xC8AA5F90, "mounting" },
    { 0x25B537EA, "mounting_horse" },
    { 0xEF8D7A63, "mounts" },
    { 0x30103B32, "mouth" },
    { 0xC40EB6A5, "mov" },
    { 0x2E863E24, "mov_0_test_masonjr_run_01" },
    { 0x4D0D8AF7, "mov_afghanistan_chinese_fleet" },
    { 0xDD9932DA, "mov_afghanistan_chinese_fleet_amb" },
    { 0x38BE1D7D, "mov_afghanistan_chinese_fleet_anim" },
    { 0x5B8A806B, "mov_afghanistan_chinese_fleet_eventname" },
    { 0x7FB152E8, "mov_afghanistan_chinese_fleet_fx" },
    { 0xA43A6B66, "mov_afghanistan_chinese_fleet_util" },
    { 0xE8489CFA, "mov_angola" },
    { 0xAD03689B, "mov_angola_amb" },
    { 0xBE9056CE, "mov_angola_anim" },
    { 0x4637A02E, "mov_angola_eventname" },
    { 0x4C45A52F, "mov_angola_fx" },
    { 0xB6815C95, "mov_angola_util" },
    { 0x60C31010, "mov_av7" },
    { 0x1B23BC81, "mov_av7_amb" },
    { 0xC75932C8, "mov_av7_anim" },
    { 0xF5999961, "mov_av7_fx" },
    { 0x9AB4CF21, "mov_bfroom" },
    { 0x0F5679AC, "mov_bfroom_amb" },
    { 0xFF71B313, "mov_bfroom_anim" },
    { 0x94419D2D, "mov_bfroom_eventname" },
    { 0x2448F476, "mov_bfroom_fx" },
    { 0xB2AF50A7, "mov_cam_cinematic" },
    { 0xD486D7B1, "mov_cell_phone" },
    { 0x2CABA004, "mov_character_test" },
    { 0x85351D35, "mov_character_test_amb" },
    { 0x150F44DC, "mov_character_test_anim" },
    { 0xB907BC38, "mov_character_test_eventname" },
    { 0xC4510B8D, "mov_character_test_fx" },
    { 0x754EE2FF, "mov_character_test_util" },
    { 0x62CC413D, "mov_command_center" },
    { 0x2A02FF28, "mov_command_center_amb" },
    { 0x51E9202F, "mov_command_center_anim" },
    { 0x29B0698F, "mov_command_center_art" },
    { 0x510DBDC1, "mov_command_center_eventname" },
    { 0x4B36DB4A, "mov_command_center_fx" },
    { 0x308CB764, "mov_command_center_util" },
    { 0x72AC3290, "mov_dan_test" },
    { 0x991C8701, "mov_dan_test_amb" },
    { 0x95FFFA48, "mov_dan_test_anim" },
    { 0xD5E486DC, "mov_dan_test_eventname" },
    { 0x370634E1, "mov_dan_test_fx" },
    { 0x02DE3933, "mov_dan_test_util" },
    { 0xA55F545F, "mov_haiti" },
    { 0xEB104842, "mov_haiti_amb" },
    { 0xC3157355, "mov_haiti_anim" },
    { 0x6E365553, "mov_haiti_eventname" },
    { 0x9BDA8420, "mov_haiti_fx" },
    { 0x25DEF058, "mov_haiti_ny_streets" },
    { 0x7D402C49, "mov_haiti_ny_streets_amb" },
    { 0x4A0D8B80, "mov_haiti_ny_streets_anim" },
    { 0x99F06A84, "mov_haiti_ny_streets_eventname" },
    { 0x306202B9, "mov_haiti_ny_streets_fx" },
    { 0xE359303B, "mov_haiti_ny_streets_util" },
    { 0x59C690A3, "mov_haiti_prom_night" },
    { 0x221D24C6, "mov_haiti_prom_night_amb" },
    { 0xE0B7B789, "mov_haiti_prom_night_anim" },
    { 0x08EBFFBF, "mov_haiti_prom_night_eventname" },
    { 0x5679F6BC, "mov_haiti_prom_night_fx" },
    { 0xFF9600CA, "mov_haiti_prom_night_util" },
    { 0xC92A9575, "mov_haiti_skyline_dc" },
    { 0x4D2213C0, "mov_haiti_skyline_dc_amb" },
    { 0x0CE4E297, "mov_haiti_skyline_dc_anim" },
    { 0xF0739259, "mov_haiti_skyline_dc_eventname" },
    { 0x54D1CAF2, "mov_haiti_skyline_dc_fx" },
    { 0xE2753F5C, "mov_haiti_skyline_dc_util" },
    { 0x7155EA91, "mov_haiti_skyline_ny" },
    { 0x6A96177C, "mov_haiti_skyline_ny_amb" },
    { 0xBC278343, "mov_haiti_skyline_ny_anim" },
    { 0xBC2164FD, "mov_haiti_skyline_ny_eventname" },
    { 0xC4C8D806, "mov_haiti_skyline_ny_fx" },
    { 0x7FD17A00, "mov_haiti_skyline_ny_util" },
    { 0x21A65779, "mov_haiti_skyline_shanghai" },
    { 0xBFD2FF24, "mov_haiti_skyline_shanghai_amb" },
    { 0x5A59F75B, "mov_haiti_skyline_shanghai_anim" },
    { 0x17D84B65, "mov_haiti_skyline_shanghai_eventname" },
    { 0x8091BABE, "mov_haiti_skyline_shanghai_fx" },
    { 0xAFC60668, "mov_haiti_skyline_shanghai_util" },
    { 0x986CE74E, "mov_haiti_util" },
    { 0x6F80CAFE, "mov_intro" },
    { 0x28CB7FFF, "mov_intro_amb" },
    { 0x5504FA62, "mov_intro_anim" },
    { 0x038737DC, "mov_intro_art" },
    { 0x7E67A9CA, "mov_intro_eventname" },
    { 0x9095926B, "mov_intro_fx" },
    { 0xDA6FE071, "mov_intro_util" },
    { 0x584F4B35, "mov_la" },
    { 0xC3ED2F80, "mov_la_amb" },
    { 0xCD645D57, "mov_la_anim" },
    { 0x5A761919, "mov_la_eventname" },
    { 0x5E2B61B2, "mov_la_fx" },
    { 0x4A87FA45, "mov_la_supermarket" },
    { 0xA05377F0, "mov_la_supermarket_amb" },
    { 0xCC53B4E7, "mov_la_supermarket_anim" },
    { 0x2C04FF09, "mov_la_supermarket_eventname" },
    { 0x4D6AB362, "mov_la_supermarket_fx" },
    { 0xFB85BD2C, "mov_la_supermarket_util" },
    { 0x5D68F41C, "mov_la_util" },
    { 0xAD273B2B, "mov_loading_test" },
    { 0xF11CDC0E, "mov_loading_test_amb" },
    { 0x55154DA1, "mov_loading_test_anim" },
    { 0x2BBB7747, "mov_loading_test_eventname" },
    { 0x2FDD0F54, "mov_loading_test_fx" },
    { 0x694FF6F2, "mov_loading_test_util" },
    { 0xD6C9D3F1, "mov_myanmar" },
    { 0x0F92681C, "mov_myanmar_amb" },
    { 0x95F90963, "mov_myanmar_anim" },
    { 0xAE062D9D, "mov_myanmar_eventname" },
    { 0xB077C426, "mov_myanmar_fx" },
    { 0x72EFB520, "mov_myanmar_util" },
    { 0x8B490BC5, "mov_nicaragua" },
    { 0x72742170, "mov_nicaragua_amb" },
    { 0x15BE8967, "mov_nicaragua_anim" },
    { 0x58D45C89, "mov_nicaragua_eventname" },
    { 0xFE3753E2, "mov_nicaragua_fx" },
    { 0x44F091AC, "mov_nicaragua_util" },
    { 0x04B19B76, "mov_obama_bridge" },
    { 0x11197CF7, "mov_obama_bridge_amb" },
    { 0x168C0C0A, "mov_obama_bridge_anim" },
    { 0x1C3A2BC2, "mov_obama_bridge_eventname" },
    { 0x2E1F37D3, "mov_obama_bridge_fx" },
    { 0xC96A1609, "mov_obama_bridge_util" },
    { 0xA777139C, "mov_obama_sinking" },
    { 0x2AB214CD, "mov_obama_sinking_amb" },
    { 0x1B446664, "mov_obama_sinking_anim" },
    { 0xC15FB955, "mov_obama_sinking_fx" },
    { 0xDFB2ED97, "mov_obama_sinking_util" },
    { 0xA8A920BB, "mov_obama_winning" },
    { 0x15B17D3E, "mov_obama_winning_amb" },
    { 0x8123BCF1, "mov_obama_winning_anim" },
    { 0x6C210D77, "mov_obama_winning_eventname" },
    { 0x3A3B7E04, "mov_obama_winning_fx" },
    { 0x3B8C2602, "mov_obama_winning_util" },
    { 0x3025D486, "mov_omwroom" },
    { 0x11CF6B67, "mov_omwroom_amb" },
    { 0xF74D53DA, "mov_omwroom_anim" },
    { 0x1ECF1C34, "mov_omwroom_art" },
    { 0x835016B2, "mov_omwroom_eventname" },
    { 0xAB8D0883, "mov_omwroom_fx" },
    { 0x337E7F59, "mov_omwroom_util" },
    { 0x8C23825B, "mov_outro_arlington_cemetery" },
    { 0xD377909E, "mov_outro_arlington_cemetery_amb" },
    { 0x38A257D1, "mov_outro_arlington_cemetery_anim" },
    { 0x78AD50D7, "mov_outro_arlington_cemetery_eventname" },
    { 0xACCD8AE4, "mov_outro_arlington_cemetery_fx" },
    { 0xF30AC0E2, "mov_outro_arlington_cemetery_util" },
    { 0x88790ECC, "mov_outro_data_center" },
    { 0xE124741D, "mov_outro_data_center_amb" },
    { 0x4DB84F54, "mov_outro_data_center_anim" },
    { 0x6C266640, "mov_outro_data_center_eventname" },
    { 0x7F00C565, "mov_outro_data_center_fx" },
    { 0x911CF747, "mov_outro_data_center_util" },
    { 0x5B56C8E4, "mov_outro_nicaragua_cemetery" },
    { 0x5AA69DD5, "mov_outro_nicaragua_cemetery_amb" },
    { 0x1B943CFC, "mov_outro_nicaragua_cemetery_anim" },
    { 0x858F4ED8, "mov_outro_nicaragua_cemetery_eventname" },
    { 0x67B59AAD, "mov_outro_nicaragua_cemetery_fx" },
    { 0x979AF91F, "mov_outro_nicaragua_cemetery_util" },
    { 0x5EF4A557, "mov_outro_oval_office" },
    { 0x8F0BB37A, "mov_outro_oval_office_amb" },
    { 0xAE22CA9D, "mov_outro_oval_office_anim" },
    { 0x4B81990B, "mov_outro_oval_office_eventname" },
    { 0x9BAF4F08, "mov_outro_oval_office_fx" },
    { 0x199F1886, "mov_outro_oval_office_util" },
    { 0x20AAF6E9, "mov_outro_prison" },
    { 0x66F61D34, "mov_outro_prison_amb" },
    { 0x4D94120B, "mov_outro_prison_anim" },
    { 0xAAC00BF5, "mov_outro_prison_eventname" },
    { 0xE841E14E, "mov_outro_prison_fx" },
    { 0x35E099D8, "mov_outro_prison_util" },
    { 0xA029C789, "mov_pakistan" },
    { 0x58B4AE14, "mov_pakistan_amb" },
    { 0x3BF3886B, "mov_pakistan_anim" },
    { 0xB094E0D5, "mov_pakistan_eventname" },
    { 0xD01853AE, "mov_pakistan_fx" },
    { 0x40072E38, "mov_pakistan_util" },
    { 0x7429C5F4, "mov_panama" },
    { 0xC74040C5, "mov_panama_amb" },
    { 0x9B5B0C0C, "mov_panama_anim" },
    { 0x90CD6D48, "mov_panama_eventname" },
    { 0xF29120DD, "mov_panama_fx" },
    { 0xA1C869EF, "mov_panama_util" },
    { 0x89169C3B, "mov_playback" },
    { 0x8A0A524A, "mov_playback_common_init" },
    { 0x0760D71A, "mov_playback_full_coverage" },
    { 0x784CBC41, "mov_playback_main" },
    { 0xD3A03CA2, "mov_playback_render" },
    { 0x320094E8, "mov_playback_temp_main" },
    { 0xB7D98F46, "mov_previs_common_init" },
    { 0xE9E0228C, "mov_suburban_flashback" },
    { 0x52EB84DD, "mov_suburban_flashback_amb" },
    { 0x44A19714, "mov_suburban_flashback_anim" },
    { 0x0308EC00, "mov_suburban_flashback_eventname" },
    { 0xB7FA2025, "mov_suburban_flashback_fx" },
    { 0x6EB98A07, "mov_suburban_flashback_util" },
    { 0xA340D509, "mov_t6_wpn_ar_m14_view" },
    { 0x48DE67FC, "mov_t6_wpn_pistol_b23r_view" },
    { 0x3F35CD01, "mov_talkshow" },
    { 0xF5E0884C, "mov_talkshow_amb" },
    { 0x24B20833, "mov_talkshow_anim" },
    { 0x7C88D9CD, "mov_talkshow_eventname" },
    { 0x2F41EA96, "mov_talkshow_fx" },
    { 0x5561F120, "mov_utility" },
    { 0x9A59BEA0, "mov_v78_vtol_fb" },
    { 0x953255C6, "mov_v78_vtol_marine_one_fb" },
    { 0xC1254273, "mov_vault_day_ext" },
    { 0x787EAAF6, "mov_vault_day_ext_amb" },
    { 0xADDB4759, "mov_vault_day_ext_anim" },
    { 0xE33C996F, "mov_vault_day_ext_eventname" },
    { 0x80BB0C6C, "mov_vault_day_ext_fx" },
    { 0xB6C0149A, "mov_vault_day_ext_util" },
    { 0x36772AB9, "mov_vault_day_int" },
    { 0xA015AE64, "mov_vault_day_int_amb" },
    { 0xA4910D9B, "mov_vault_day_int_anim" },
    { 0x593B06A5, "mov_vault_day_int_eventname" },
    { 0x8CF875FE, "mov_vault_day_int_fx" },
    { 0xF9FD1CA8, "mov_vault_day_int_util" },
    { 0xAF2971DC, "mov_vault_day_omwroom" },
    { 0x755CE10D, "mov_vault_day_omwroom_amb" },
    { 0xE4E6BAA4, "mov_vault_day_omwroom_anim" },
    { 0x24D38FF0, "mov_vault_day_omwroom_eventname" },
    { 0x8C0B2D95, "mov_vault_day_omwroom_fx" },
    { 0x63C97BD7, "mov_vault_day_omwroom_util" },
    { 0x1EB3EBA7, "mov_vault_night_ext" },
    { 0xD6F24EEA, "mov_vault_night_ext_amb" },
    { 0xCEC8162D, "mov_vault_night_ext_anim" },
    { 0x5D5E10FB, "mov_vault_night_ext_eventname" },
    { 0x4E28DDB8, "mov_vault_night_ext_fx" },
    { 0xAD32C496, "mov_vault_night_ext_util" },
    { 0xF90B68BD, "mov_vault_night_int" },
    { 0x78ED1EA8, "mov_vault_night_int_amb" },
    { 0x0C78B6AF, "mov_vault_night_int_anim" },
    { 0x6CAAE141, "mov_vault_night_int_eventname" },
    { 0xF555EDCA, "mov_vault_night_int_fx" },
    { 0xEB1C4DE4, "mov_vault_night_int_util" },
    { 0xF26BF6CE, "mov_whiteroom" },
    { 0x1EDE9AEF, "mov_whiteroom_amb" },
    { 0x25B6FC72, "mov_whiteroom_anim" },
    { 0x754549FA, "mov_whiteroom_eventname" },
    { 0x3B3FB95B, "mov_whiteroom_fx" },
    { 0xD1A90401, "mov_whiteroom_util" },
    { 0x60608C52, "mov_yemen_server_room" },
    { 0x30692FD3, "mov_yemen_server_room_amb" },
    { 0x0BB19496, "mov_yemen_server_room_anim" },
    { 0xA8E84EC6, "mov_yemen_server_room_eventname" },
    { 0xE23FD5F7, "mov_yemen_server_room_fx" },
    { 0x472784AD, "mov_yemen_server_room_util" },
    { 0xBF467B19, "movable" },
    { 0x492F3A52, "move" },
    { 0x5D765C17, "move1_chest0" },
    { 0x3773E1AE, "move1_chest1" },
    { 0xBE79E68F, "move_accel" },
    { 0x9638AEDF, "move_ai" },
    { 0xD93C6D8C, "move_ai_for_skipto" },
    { 0x2431399D, "move_ai_for_skipto_on_boat" },
    { 0xF67AE1B2, "move_ai_single" },
    { 0x569C2515, "move_ai_to_pre_elevator_positions" },
    { 0xA08F8E77, "move_allowed" },
    { 0x0FCBB4F0, "move_along_ground_position" },
    { 0x2C3D07B2, "move_along_path" },
    { 0xC1903311, "move_along_road" },
    { 0x9B7262A1, "move_along_road2" },
    { 0x7F59A7BB, "move_along_with" },
    { 0xCBE6253D, "move_amount" },
    { 0x7323AF69, "move_and_fade_name" },
    { 0x9964D55A, "move_and_rotate_to" },
    { 0x35621E96, "move_anim" },
    { 0x3AD05508, "move_anim_end_time" },
    { 0x919CC546, "move_anim_string" },
    { 0x704217D1, "move_away_from_edges" },
    { 0xC9B31BBB, "move_away_points" },
    { 0x9FC5F09C, "move_back" },
    { 0x8A00F42A, "move_backward_along_path" },
    { 0x714A81A1, "move_balcony_breach" },
    { 0x6B5FDC14, "move_banzai" },
    { 0xD1B3FD78, "move_barnes_when_group_cleared" },
    { 0xE8288F5B, "move_between_points" },
    { 0x6434D05E, "move_blocker_slowly" },
    { 0xA2C51BA5, "move_boat_armada_for_skipto" },
    { 0xFCBBE150, "move_boat_for_skipto" },
    { 0x147EDC43, "move_boats_with_player" },
    { 0x1AB0E039, "move_body" },
    { 0xB303BCE8, "move_body_trigger_spawn" },
    { 0x31912A52, "move_bowman_brooks_forward" },
    { 0x1DA2AA30, "move_breakoff_group_to_roof" },
    { 0x4E2D0F42, "move_btr_cleared" },
    { 0xDACC23A1, "move_bullet" },
    { 0x8DF36A80, "move_cache_door" },
    { 0xF9D93213, "move_cache_fridge" },
    { 0xA2470E3E, "move_charging_tanks" },
    { 0x55048698, "move_chunk" },
    { 0x54A146CF, "move_close_to_player" },
    { 0xCD1D372F, "move_cqb_downhill_until_guys_spawn" },
    { 0x23DB143F, "move_crane_thread" },
    { 0x12224900, "move_decel" },
    { 0x69ACA18E, "move_delay" },
    { 0x7D2B9794, "move_delete_zipline_gate" },
    { 0x7D2801A1, "move_delta" },
    { 0xB22F9E33, "move_delta_array" },
    { 0x9373D90E, "move_dir" },
    { 0x762BF25B, "move_disable_b4_if_b5_is_hit" },
    { 0x642C91AD, "move_disable_node_on_b22" },
    { 0x755108A1, "move_dist" },
    { 0x8A6B76DC, "move_dist_sq" },
    { 0x53B75F9C, "move_distance" },
    { 0xD6A38225, "move_done" },
    { 0xC98EFF55, "move_down" },
    { 0xB66C88E1, "move_down_hill" },
    { 0x97A7E7E7, "move_downstairs" },
    { 0xA90B39AA, "move_drone_bank_target" },
    { 0xF274EBCB, "move_drop1" },
    { 0x436DF3DE, "move_e3_start_gate" },
    { 0xD92FD9A8, "move_effects_ent_here" },
    { 0x355CCB6E, "move_elevator_gates" },
    { 0x154A5B08, "move_ent" },
    { 0x41D45206, "move_ev2" },
    { 0x5DC57390, "move_ev4" },
    { 0x5C605209, "move_explosion_oneye" },
    { 0x201627E5, "move_fade_time" },
    { 0x383FCCE5, "move_failsafe_override" },
    { 0xE453BC59, "move_fake_buidling_and_sign" },
    { 0x7A0B831C, "move_faster_into_last_room" },
    { 0x541B6CD9, "move_flank" },
    { 0x47C2EFAE, "move_flankleft" },
    { 0xF308E5E5, "move_flankright" },
    { 0x91E5702A, "move_follow" },
    { 0xF1AD8460, "move_forward" },
    { 0x987B8EC0, "move_forward_along_path" },
    { 0x02F8B84C, "move_friendlies" },
    { 0x4AEA6D64, "move_friendlies_to_upper_house_left" },
    { 0x3C30FE81, "move_friendlies_up_to_mid_bunker" },
    { 0x1641D3D0, "move_friendly_boats" },
    { 0x5F75E9AD, "move_friendly_into_position" },
    { 0x4E59EBA8, "move_from_halftrack" },
    { 0xD7F0D183, "move_from_time" },
    { 0xC992C744, "move_gate" },
    { 0xF3E514AB, "move_gaz_fake" },
    { 0x84978898, "move_gaz_once_player_past" },
    { 0x005FBC21, "move_gazebo_target" },
    { 0xA52D06DC, "move_generic" },
    { 0x492DC958, "move_ghettotags_here" },
    { 0x15F2D1F9, "move_gondola" },
    { 0x1D2FF5B4, "move_group_to_nodes" },
    { 0x8DC820D2, "move_here_l" },
    { 0x6A088F7C, "move_here_r" },
    { 0xB4AC5DAF, "move_heroes_after_closer" },
    { 0x2108CC11, "move_heroes_interrogation_room" },
    { 0xD9A0A51C, "move_heroes_to_player_drum" },
    { 0xB8C49144, "move_heroes_to_security" },
    { 0x3557C2F0, "move_hud" },
    { 0x3AB85B5B, "move_huds" },
    { 0xE020A232, "move_hut_ais_back" },
    { 0x4E613228, "move_imminent" },
    { 0x75B7FC78, "move_in" },
    { 0xB2E753DE, "move_in_ent" },
    { 0x1A77F755, "move_in_func" },
    { 0xCDF9E4FA, "move_in_on_goal" },
    { 0x1303BE0A, "move_in_to_office_trigger" },
    { 0x47A26903, "move_in_trigger_used" },
    { 0x1931EA07, "move_into_building_trigger" },
    { 0x8D684A30, "move_into_portal" },
    { 0xBAAFF603, "move_intro_vehicles" },
    { 0x718B66E9, "move_length" },
    { 0xC4E1EE95, "move_lift_down" },
    { 0x2E9251C3, "move_lights_here" },
    { 0xB0545121, "move_limbo_state_to_redo" },
    { 0x951DA0EB, "move_limbo_state_to_undo" },
    { 0x7B7C3571, "move_list_menu" },
    { 0x5CC75AD5, "move_little_bird_in_position" },
    { 0x925B2F60, "move_little_bird_to_checkpoint" },
    { 0x0324C820, "move_local_power" },
    { 0x692E1FAA, "move_mac" },
    { 0x468F6A6E, "move_mac_triggers" },
    { 0x45769FFB, "move_mannequin" },
    { 0x0F1C6B17, "move_menus" },
    { 0x534CD358, "move_mid_lobby" },
    { 0x8C7668FE, "move_mid_ship" },
    { 0xCA8530AC, "move_mode" },
    { 0xD404D588, "move_model" },
    { 0x00BA83A3, "move_model_thread" },
    { 0x0DA453AD, "move_motorcade_back" },
    { 0x29B7382F, "move_now" },
    { 0xAAC90BE2, "move_on" },
    { 0xCBE8CC60, "move_on_top_of_metro" },
    { 0x54AE6797, "move_opel" },
    { 0xF1BD7445, "move_or_attack" },
    { 0x73D83E35, "move_org" },
    { 0x5D57EB53, "move_other_tanks" },
    { 0x9C9FF539, "move_out_ent" },
    { 0x78A3B3E0, "move_out_func" },
    { 0xE93CB18A, "move_out_of_rr_room" },
    { 0x43D60C85, "move_out_of_turn" },
    { 0xDBD8AA39, "move_override" },
    { 0xA55F2E89, "move_parent" },
    { 0x135123A4, "move_path" },
    { 0x3CD89969, "move_perk" },
    { 0xFEA7AA3C, "move_pickup_to_score" },
    { 0x9D50F6AC, "move_platform" },
    { 0x529543BE, "move_player" },
    { 0x325410AA, "move_player_around_map_fast" },
    { 0xCABBA6C1, "move_player_down" },
    { 0x7AD05253, "move_player_spot_with_rig" },
    { 0xA000F8F9, "move_player_to_eject_tube" },
    { 0xA202EDA1, "move_player_to_next_same_effect" },
    { 0xAA917962, "move_player_to_safe_checkpoint_spot" },
    { 0x3A0CB7A1, "move_players" },
    { 0x036A1EDA, "move_players_to_start" },
    { 0x65717370, "move_points" },
    { 0x14F385E3, "move_points_randomly" },
    { 0xC5246B0F, "move_points_sequentially" },
    { 0xD51E26C3, "move_powerup" },
    { 0x133C5C4B, "move_pre_balcony_breach" },
    { 0x9C832FFB, "move_pub_ai" },
    { 0x828C95BF, "move_radio_tower_blocker" },
    { 0x1A8F05DF, "move_redo_state_to_limbo" },
    { 0x781FA006, "move_redo_state_to_undo" },
    { 0x1D4E995A, "move_request_complete" },
    { 0x36B099D7, "move_reznov_to_ridge" },
    { 0x171A9AFF, "move_riders_here" },
    { 0x0F48B097, "move_ring" },
    { 0x897D2710, "move_rts_camera" },
    { 0xB9162E34, "move_run" },
    { 0xEE30AE29, "move_sarge" },
    { 0x5E2D3D89, "move_scale" },
    { 0x31B25B00, "move_script_model_to_position" },
    { 0x958E7F34, "move_selected_object" },
    { 0x6F86CDB0, "move_selection_to_cursor" },
    { 0xE311279C, "move_shell_inside" },
    { 0x84433114, "move_shot_destination" },
    { 0x8599ED0A, "move_slower_down_last_tunnel" },
    { 0x88C06CE1, "move_sound_along_line" },
    { 0x1B0204E4, "move_sound_ent" },
    { 0x62AB3EDB, "move_spawn_func" },
    { 0x2AA565E1, "move_spawn_point" },
    { 0xA4D14740, "move_spawner_to_spot" },
    { 0x7469C992, "move_speed" },
    { 0x85BA41C9, "move_speed_scale" },
    { 0xD5024769, "move_spot" },
    { 0x21B00749, "move_squad_into_precourtyard" },
    { 0xB95C49EB, "move_squad_into_village" },
    { 0xF40F2F0C, "move_squad_outside_precourtyard" },
    { 0x6F827B60, "move_squad_to_boat" },
    { 0x8A5D3ADB, "move_squad_to_nose" },
    { 0xE05DE9DC, "move_squad_to_ridge_hut_trigger" },
    { 0x6F987879, "move_squad_up_when_civiliians_dead" },
    { 0xB10FFD75, "move_stage" },
    { 0x40EEC146, "move_stern_ship" },
    { 0x0DA8D8DE, "move_street_tanks" },
    { 0x4BF9F8BD, "move_stretcher" },
    { 0xD1D44DCD, "move_tank" },
    { 0xA8F825D9, "move_tank_1" },
    { 0xCEFAA042, "move_tank_2" },
    { 0xF112C050, "move_tank_3_2" },
    { 0x41020F7D, "move_tank_5" },
    { 0xB5E2E334, "move_tank_5_for_real" },
    { 0x0E7792D9, "move_tank_in_position" },
    { 0x44AFEEE6, "move_tank_on_trigger" },
    { 0x8CF54B4C, "move_tanks" },
    { 0x3BF676C2, "move_tanks_3" },
    { 0xCAA6938C, "move_tanks_up" },
    { 0xB892257B, "move_target_pos_to_new_turrets_visibility" },
    { 0xC9D805ED, "move_team_icons" },
    { 0xA635579C, "move_the_box" },
    { 0x96DC1FBE, "move_through_end_tunnel_when_room_clear" },
    { 0x2AC786B5, "move_through_launchpad" },
    { 0x43554A9F, "move_through_right_room_when_mostly_clear" },
    { 0xA3ADC876, "move_time" },
    { 0x820EBE44, "move_time_s" },
    { 0xCC20DFC2, "move_to" },
    { 0x78BBCCD1, "move_to_dist" },
    { 0x0E057B0B, "move_to_driver" },
    { 0x87B59B28, "move_to_end" },
    { 0xC170FC56, "move_to_endpos" },
    { 0x25484BEA, "move_to_house_dialog" },
    { 0xF3249F81, "move_to_node" },
    { 0xDEA382DD, "move_to_node_then_teleport" },
    { 0xAC9223EA, "move_to_oldbase01" },
    { 0x868FA981, "move_to_oldbase02" },
    { 0xBC252350, "move_to_pilots_suggested_seat" },
    { 0xE65707CE, "move_to_player" },
    { 0xC4165109, "move_to_point" },
    { 0x1605FEE1, "move_to_pos" },
    { 0x08BC2F7B, "move_to_position_over_time" },
    { 0xA0151DE6, "move_to_required_seat" },
    { 0x8950F067, "move_to_run_pos" },
    { 0xC64AC6D5, "move_to_safe_landing_spot" },
    { 0x75F413CB, "move_to_start" },
    { 0xD9523347, "move_to_startpos" },
    { 0x44CD1136, "move_to_struct" },
    { 0xAC09CF2D, "move_to_struct_2" },
    { 0x84C38F55, "move_to_struct_pos" },
    { 0x63F6C33A, "move_to_the_door_trig" },
    { 0x7ACBB986, "move_to_time" },
    { 0x293B12D9, "move_to_z" },
    { 0x9AC07F16, "move_tractor" },
    { 0x9600C011, "move_train" },
    { 0x516DC5BF, "move_trigger" },
    { 0x40B6ABD2, "move_tunnel_player_clip" },
    { 0x26762963, "move_turrets_here" },
    { 0xBABFDE99, "move_undo_state_to_limbo" },
    { 0x2A7983D2, "move_undo_state_to_redo" },
    { 0xD8C1567B, "move_unit_in_position" },
    { 0xA1B12865, "move_unoccupied_elevator" },
    { 0x8F7D158A, "move_up" },
    { 0xB1230E48, "move_up_and_blowup_in_small_room" },
    { 0xC8715221, "move_up_mg_hill" },
    { 0x2A1E72DF, "move_up_on_hallway_clear" },
    { 0x77D85C77, "move_up_script_logic" },
    { 0x7B362BD7, "move_up_trigger" },
    { 0xCA2B4740, "move_up_vo" },
    { 0x8B5EECB1, "move_upper_path_cartel_into_house" },
    { 0x54CD82EB, "move_use_turret" },
    { 0x11C66679, "move_valid_poi_to_navmesh" },
    { 0xDF77B43D, "move_vec" },
    { 0x2E0E1918, "move_vector" },
    { 0x702B15E8, "move_visuals_to_base" },
    { 0x677A55FF, "move_volume" },
    { 0xCE7A61A4, "move_wall_down" },
    { 0x6780A3D7, "move_wall_up" },
    { 0x2ADB901E, "move_wave" },
    { 0x9991555D, "move_wave_1_towards_vtol" },
    { 0xC2F31981, "move_wave_2_1" },
    { 0xE8F593EA, "move_wave_2_2" },
    { 0x5F9E7454, "move_weaver_up_timout" },
    { 0xCAFA8F5A, "move_when_enemy_hides" },
    { 0x4DA43FB9, "move_with" },
    { 0x7C5B0CD3, "move_woods_forward" },
    { 0xBA70BFBB, "move_x" },
    { 0xE581B29D, "move_x_ent" },
    { 0x7C2F1608, "move_y_ent" },
    { 0x68C49762, "move_zeppelin_down_new_path" },
    { 0x6020F793, "move_zombie_spawn_location" },
    { 0x8A2C0853, "move_zombies_elevator" },
    { 0x8574F4AB, "moveaccelratio" },
    { 0xC821B35A, "moveagain" },
    { 0xF6424F4E, "moveamount" },
    { 0x9B686C07, "moveangle" },
    { 0x7CB2AE6D, "moveanim" },
    { 0xEAAFA4C5, "moveanimtype" },
    { 0x1CDB377D, "moveby" },
    { 0xE7A3D1E9, "movechain" },
    { 0xBAE8703D, "movecovertocover" },
    { 0xEE2D8934, "movecovertocover_checkendpose" },
    { 0x75121453, "movecovertocover_checkstartpose" },
    { 0xA1B2C1B9, "movecovertocover_getshuffleendanim" },
    { 0xA49CAB16, "movecovertocover_getshuffleloopanim" },
    { 0x15442302, "movecovertocover_getshufflestartanim" },
    { 0xABE3D418, "movecovertocoverfinish" },
    { 0x4B20BB88, "movecqb" },
    { 0xAA04FA22, "movecrouchrunnormal" },
    { 0x1421E19B, "movecrouchrunoverride" },
    { 0x6FEA66BB, "movecurtains" },
    { 0xAF9E3292, "moved" },
    { 0x34B27AC4, "moved_distance_during_interval" },
    { 0xBC9F714B, "moved_to_driver" },
    { 0x80C85E3A, "movedecoy" },
    { 0x549CB8CB, "movedelay" },
    { 0x5FBA5C47, "movedelaymax" },
    { 0x05147DB9, "movedelaymin" },
    { 0x0A3B0B80, "movedelta" },
    { 0xDCF43DC7, "movedeltaarray" },
    { 0x26689E5D, "movedeltavector" },
    { 0xCEF6F39A, "movedest" },
    { 0x49849907, "movedir" },
    { 0x70E8B921, "movedirection" },
    { 0x3C57100E, "movedist" },
    { 0xDCA8A7D2, "movedistinches" },
    { 0x2B36A3E4, "movedistmax" },
    { 0x1617FC4A, "movedistmin" },
    { 0xA21DB68A, "movedone" },
    { 0x5F02A8D9, "movedoorsidetoside" },
    { 0x5D5A0D45, "movedowntime" },
    { 0x5C2F5E0A, "movedrecently" },
    { 0x8BFA23B9, "moveelectricleverdown" },
    { 0x5DDEBDE6, "moveelectricleverup" },
    { 0xCAD6B7EB, "moveelem" },
    { 0x19C18746, "movefinal" },
    { 0x9519D2D8, "movefinished" },
    { 0xD7C04462, "moveglobals" },
    { 0xBBC8A7E4, "moveglobalsinit" },
    { 0x8273961B, "movegoal" },
    { 0xAF0CAA14, "movegravity" },
    { 0x77BBEF7E, "moveh" },
    { 0x12589446, "movein_trigger" },
    { 0x3B43325E, "moveing" },
    { 0xEF6E24B4, "moveinit" },
    { 0x89B7EB02, "moveintobus" },
    { 0x8F5FB55F, "moveit_trig1" },
    { 0x1D584624, "moveit_trig2" },
    { 0x435AC08D, "moveit_trig3" },
    { 0x005B8D87, "movelen" },
    { 0x6CF74B36, "movelength" },
    { 0xC3DDA1AA, "moveleverdown" },
    { 0x60843DE1, "moveleverup" },
    { 0x03F13720, "moveloc" },
    { 0xE7628854, "moveloop" },
    { 0xDFA220F1, "movelooper" },
    { 0xEE71E27F, "movemainloop" },
    { 0x413F93D2, "movement" },
    { 0xB9864F65, "movement_floor" },
    { 0x0DEC48D1, "movement_last" },
    { 0x8C13897C, "movement_max_dist" },
    { 0x01462CF0, "movement_process" },
    { 0x53492B89, "movement_thread" },
    { 0xD19E6907, "movement_thread_stayindistance" },
    { 0xEF0B7DB5, "movement_thread_unaware" },
    { 0x52951BDF, "movement_thread_wander" },
    { 0xFDBFD998, "movement_vector" },
    { 0x9012A730, "movement_vox" },
    { 0xBC79FFFD, "movementarray" },
    { 0x515234AF, "movementarrayindex" },
    { 0xC18B8BD6, "movementchange" },
    { 0x5689D881, "movementmanagerthink" },
    { 0x838A2CDD, "movements" },
    { 0x704997F4, "movementspeedmodifier" },
    { 0x827568CE, "movementspeedmultiplier" },
    { 0x5C4ACA1E, "movementstatesound" },
    { 0xEDD32051, "movementtracking" },
    { 0xF781DF22, "movementtype" },
    { 0x318D3B5D, "movementupdate" },
    { 0xC8367302, "movementupdatecount" },
    { 0x76886986, "movementupdatedenom" },
    { 0xD9A07A8E, "movementx" },
    { 0xFFA2F4F7, "movementy" },
    { 0x9857F617, "movemode" },
    { 0x1ED32230, "movemodeattributecallback" },
    { 0x293A45C2, "movenextbestnode_time_max" },
    { 0xFC2DD17C, "movenextbestnode_time_min" },
    { 0xA4A4A7B8, "movenlink" },
    { 0xC7D16D30, "moveorigin" },
    { 0xBB23ADFE, "moveout" },
    { 0x1FB31534, "moveout_cornerr" },
    { 0x9B81E487, "moveovertime" },
    { 0x091380C2, "movepath_now" },
    { 0x20BE5297, "moveplanetopoint" },
    { 0xF2939212, "moveplanetowaypoint" },
    { 0x709951EB, "moveplaybackrate" },
    { 0xC5479196, "moveplayebackrate" },
    { 0x1084CCE8, "moveplayerdownzipline" },
    { 0xE99D3B25, "moveplayerdownzipline_beta" },
    { 0x216B90FB, "moveplayertolocation" },
    { 0x7661DB08, "movepoint" },
    { 0x5BCACDF4, "mover" },
    { 0x79CDBDD5, "mover1" },
    { 0x9FD0383E, "mover2" },
    { 0xBFA4502A, "mover_ent" },
    { 0x5D08DABD, "mover_l" },
    { 0xE0F012A3, "mover_r" },
    { 0xBC6CCBA9, "moverange" },
    { 0xB6BEC6EC, "moverate" },
    { 0x17401808, "moveredshirts" },
    { 0x8E2F29D3, "moverent" },
    { 0x46714CE7, "movers" },
    { 0x2CF7160D, "moverun" },
    { 0x81CD485D, "moves" },
    { 0xAA2371E1, "moveslide" },
    { 0xE148E13E, "movesoundent" },
    { 0x09A272AD, "movespawners" },
    { 0xB431F09B, "movespeed" },
    { 0xBC71829F, "movespeed_multiplier" },
    { 0xD84487F8, "movespeed_scale" },
    { 0x20A7D744, "movespeedattributecallback" },
    { 0x166D8617, "movespeedscale" },
    { 0x3D92170A, "movespinleverdown" },
    { 0x2F390041, "movespinleverup" },
    { 0xC7A3D3E2, "movespot" },
    { 0xA880BDD2, "movespot_around" },
    { 0x4E5E505E, "movesquadmarker" },
    { 0x2579885F, "movestandcombatnormal" },
    { 0x57E0FF62, "movestandcombatoverride" },
    { 0xB736B21A, "movestandnoncombatnormal" },
    { 0x2A9D01F3, "movestandnoncombatoverride" },
    { 0x0D06E6A1, "movestate" },
    { 0xD4992AD5, "movetarget" },
    { 0x0F97A6D3, "movetargetdummy" },
    { 0xE4FF1B2A, "movetells" },
    { 0x5F3B356D, "movetime" },
    { 0x10BBAC7E, "movetime1" },
    { 0xEAB93215, "movetime2" },
    { 0x44181D6C, "movetimes" },
    { 0xA96A2721, "moveto" },
    { 0x8B16F903, "moveto_and_delete" },
    { 0xB3172CA3, "moveto_ent" },
    { 0x5B258BDD, "moveto_new_pos" },
    { 0xD3E32C67, "moveto_orig" },
    { 0x7C3D08C5, "moveto_place" },
    { 0x8F80DF62, "moveto_pos" },
    { 0xC7B9386C, "moveto_spot" },
    { 0x1E2F6FAD, "movetodest" },
    { 0x35025F30, "movetointruder" },
    { 0x8B9C33B5, "movetonearbycover" },
    { 0x66703304, "movetonextbestnode" },
    { 0x50A697D2, "movetonexttable" },
    { 0x836F983A, "movetooriginovertime" },
    { 0xC6FC9479, "movetoplayerupdate" },
    { 0xFD646A11, "movetopos" },
    { 0x1ED86F69, "movetospot" },
    { 0xD9B2C0CE, "movetospotanim" },
    { 0x000B3AEA, "movetrigger" },
    { 0x50BE9E0B, "moveturnglobalsinit" },
    { 0x16656DA2, "movetype" },
    { 0x24614805, "moveup_lines" },
    { 0x612D4CF3, "moveup_nodes" },
    { 0x9F8006D0, "moveup_trigger" },
    { 0x6C30C26A, "moveup_vo_trig" },
    { 0x974DF0D6, "moveuptime" },
    { 0x5270814C, "movevec" },
    { 0x757AA0F7, "movevector" },
    { 0xC9B57FFD, "movewalk" },
    { 0x8B7923E6, "movewith" },
    { 0xA87F38F0, "movewithai" },
    { 0x49A33341, "movewithplayer" },
    { 0xDD2F84D0, "movewithrate" },
    { 0xD7E3960E, "movex" },
    { 0xFDE61077, "movey" },
    { 0x8BDEA13C, "movez" },
    { 0x5C502929, "movezoneaftertime" },
    { 0x79238207, "movie" },
    { 0x3F5C9AF9, "movie2_end" },
    { 0xEDEFBB92, "movie2_start" },
    { 0x38416232, "movie_" },
    { 0x11B46B6A, "movie_done" },
    { 0x520CBA19, "movie_end" },
    { 0xE8CDD602, "movie_fade_in" },
    { 0xD0A589C6, "movie_fade_in_time" },
    { 0x583447D5, "movie_fade_out" },
    { 0x50CA1683, "movie_fade_out_time" },
    { 0x1B5BAEF2, "movie_graveyard_return" },
    { 0x13A9CCF0, "movie_hide_hud" },
    { 0x3DA71351, "movie_hud" },
    { 0x33B664BF, "movie_name" },
    { 0x6A294474, "movie_projector_reel_change" },
    { 0xAE207A39, "movie_reels" },
    { 0xFDB6BD42, "movie_reels_init" },
    { 0xA746B881, "movie_reels_random" },
    { 0x9D8A2279, "movie_rumble" },
    { 0xC775059F, "movie_sign_fall" },
    { 0xEB820967, "movie_skip" },
    { 0x3BC8436E, "movie_snapshot" },
    { 0x184569B2, "movie_start" },
    { 0x87A87BC5, "movie_started" },
    { 0x8946244D, "movie_time" },
    { 0xCBE7E63A, "movie_trans_in" },
    { 0xDD7D6E0D, "movie_trans_out" },
    { 0x2611FC11, "movie_wait" },
    { 0xA4A3FA1E, "moviedefined" },
    { 0x400FD1FE, "movies" },
    { 0x5D3BF276, "movies_on_tvs" },
    { 0xC7DE78D4, "moviesign_hit_ground" },
    { 0x35D43A28, "moviiiing" },
    { 0x9F0B9B03, "moving" },
    { 0x01F2B8EA, "moving_badpath" },
    { 0x3E1E93A9, "moving_civilian" },
    { 0x75679B91, "moving_cloud_delete" },
    { 0x7DCDD84B, "moving_cloud_struct" },
    { 0x33CD461B, "moving_cover" },
    { 0xE189B3B4, "moving_diggers_init" },
    { 0x0789083E, "moving_diggers_think" },
    { 0x437067A5, "moving_ent" },
    { 0x552969CC, "moving_firing_behavior" },
    { 0xFDAFA3A3, "moving_from_start" },
    { 0xFA1D4EB6, "moving_parent" },
    { 0xE73F63A7, "moving_parent_start" },
    { 0x94D99C5C, "moving_path_disconnect" },
    { 0x482BC15B, "moving_ships" },
    { 0xD0FE3623, "moving_tram_init" },
    { 0x58DFD7C3, "moving_tram_think" },
    { 0x599ADFB6, "moving_trucks" },
    { 0x58524300, "moving_trucks2" },
    { 0x2343E3B9, "moving_view" },
    { 0x8CC8AFEA, "movinghorizontally" },
    { 0x1F22FB78, "movingvertically" },
    { 0x5D2EBC31, "movment" },
    { 0xB5BF4A80, "mowdown" },
    { 0x50BD1C9E, "mowdown_civs" },
    { 0x39D932D0, "mowdown_minigun" },
    { 0xCE19C83F, "mowdown_nvas" },
    { 0x82487484, "mowdown_starts" },
    { 0xD58703BE, "mowdown_stops" },
    { 0xC700001F, "mowed" },
    { 0x5AD34DFF, "mows" },
    { 0xCF185286, "mp" },
    { 0xBE61A6E2, "mp40" },
    { 0xE72EA66F, "mp5" },
    { 0x0C2B6C45, "mp_" },
    { 0x28A34939, "mp_airfield" },
    { 0xCE8534E4, "mp_airfield_amb" },
    { 0x84FCCF8B, "mp_airfield_art" },
    { 0xC038E57E, "mp_airfield_fx" },
    { 0xC911BB4F, "mp_amontgomery" },
    { 0xACAC5F92, "mp_amontgomery_amb" },
    { 0x109D9370, "mp_amontgomery_fx" },
    { 0x5AC94CCC, "mp_array" },
    { 0x3FBA921D, "mp_array_amb" },
    { 0x4EAE1172, "mp_array_art" },
    { 0xEBDCEF65, "mp_array_fx" },
    { 0x450729D4, "mp_asylum" },
    { 0x3B44E965, "mp_asylum_amb" },
    { 0xFA301F0A, "mp_asylum_art" },
    { 0x0FAEE7FD, "mp_asylum_fx" },
    { 0x021A8150, "mp_atoll_amb" },
    { 0xB1BFA207, "mp_atoll_art" },
    { 0x3865AE42, "mp_atoll_fx" },
    { 0xBD20C78F, "mp_backlot_art" },
    { 0xB137C54A, "mp_backlot_fx" },
    { 0x802646F1, "mp_beachhead_amb" },
    { 0xF613E6C6, "mp_beachhead_art" },
    { 0x17787851, "mp_beachhead_fx" },
    { 0xA23F1588, "mp_bgate" },
    { 0x8FD69AD9, "mp_bgate_amb" },
    { 0xB34187FE, "mp_bgate_art" },
    { 0x56E48109, "mp_bgate_fx" },
    { 0x5F45D98B, "mp_bloc_art" },
    { 0x6919F37E, "mp_bloc_fx" },
    { 0x169F29A1, "mp_bog_art" },
    { 0x0C209F50, "mp_bog_fx" },
    { 0x23A7F8D7, "mp_bots" },
    { 0x1A80BEFA, "mp_bots_amb" },
    { 0xA49B4588, "mp_bots_fx" },
    { 0x6BCA7AE2, "mp_brandenburg_amb" },
    { 0x694BDCD1, "mp_brandenburg_art" },
    { 0xBB8AD940, "mp_brandenburg_fx" },
    { 0x281F4053, "mp_bridge_amb" },
    { 0xC7DDD377, "mp_bridge_fx" },
    { 0x28519E20, "mp_broadcast_art" },
    { 0x7E7B3CB7, "mp_broadcast_fx" },
    { 0x1373CB73, "mp_broadside_amb" },
    { 0xE0822B17, "mp_broadside_fx" },
    { 0xB9DA25CF, "mp_cairo" },
    { 0x4A30F212, "mp_cairo_amb" },
    { 0x62FC3BC1, "mp_cairo_art" },
    { 0x6CCC46F0, "mp_cairo_fx" },
    { 0xE326A331, "mp_carentan" },
    { 0x95947B93, "mp_carentan_art" },
    { 0x72C89E66, "mp_carentan_fx" },
    { 0x401444DF, "mp_cargoship_art" },
    { 0xF4AE7BDA, "mp_cargoship_fx" },
    { 0xDAB5BAF7, "mp_carrier" },
    { 0xE99462DA, "mp_carrier_amb" },
    { 0x371E0E79, "mp_carrier_art" },
    { 0xB98762E8, "mp_carrier_fx" },
    { 0xD45502E7, "mp_castaway_amb" },
    { 0xC0ADC303, "mp_castaway_fx" },
    { 0x9EB99D51, "mp_castle" },
    { 0xA7D92F3C, "mp_castle_amb" },
    { 0xF0842F73, "mp_castle_art" },
    { 0x6A30D8C6, "mp_castle_fx" },
    { 0x76A8C14F, "mp_cavern_amb" },
    { 0x9755473B, "mp_cavern_fx" },
    { 0xB1A442B8, "mp_character_customization" },
    { 0x94D98FAA, "mp_citystreets_art" },
    { 0x37B1C71D, "mp_citystreets_fx" },
    { 0x5C36D580, "mp_cledesma_test" },
    { 0x0D5E30D1, "mp_cledesma_test_amb" },
    { 0x94788EB1, "mp_cledesma_test_fx" },
    { 0x1EF1E711, "mp_combine_fx" },
    { 0x7E540264, "mp_combine_sound" },
    { 0xD0B28514, "mp_concert_amb" },
    { 0xE7E580AE, "mp_concert_fx" },
    { 0x4EED92E4, "mp_contract_daily_slot" },
    { 0xD4AF640A, "mp_contract_special_slot" },
    { 0x37A5E54A, "mp_contract_table" },
    { 0xD998BF1E, "mp_contract_weekly_slot_a" },
    { 0xB39644B5, "mp_contract_weekly_slot_b" },
    { 0xA0F4F541, "mp_contracttable" },
    { 0xBBB09985, "mp_convoy_art" },
    { 0x11669F0C, "mp_convoy_fx" },
    { 0x95E230CD, "mp_cosmodrome" },
    { 0x09291E18, "mp_cosmodrome_amb" },
    { 0xED8CA0BF, "mp_cosmodrome_art" },
    { 0x91746E3A, "mp_cosmodrome_fx" },
    { 0xE302B8E0, "mp_countdown_art" },
    { 0x224B0E77, "mp_countdown_fx" },
    { 0x00C5DA42, "mp_courtyard" },
    { 0x5C421823, "mp_courtyard_amb" },
    { 0x200BF930, "mp_courtyard_art" },
    { 0xACBAD607, "mp_courtyard_fx" },
    { 0x52D797A2, "mp_cracked" },
    { 0x264A4D43, "mp_cracked_amb" },
    { 0xEA142E50, "mp_cracked_art" },
    { 0xEAD4B2A7, "mp_cracked_fx" },
    { 0xF6FE948C, "mp_crash_art" },
    { 0x39BA6CDB, "mp_crash_fx" },
    { 0xE4A2C5CA, "mp_crash_snow_art" },
    { 0x5465A7BD, "mp_crash_snow_fx" },
    { 0x8DDF8D34, "mp_creek_fx" },
    { 0x090B29E6, "mp_crisis" },
    { 0x87440687, "mp_crisis_amb" },
    { 0x9443B754, "mp_crisis_art" },
    { 0xA9DB1023, "mp_crisis_fx" },
    { 0x0D7BF7FD, "mp_crossfire_art" },
    { 0x259841A4, "mp_crossfire_fx" },
    { 0xD9E81518, "mp_cruise" },
    { 0xCBD45C09, "mp_cruise_amb" },
    { 0x5493FBAE, "mp_cruise_art" },
    { 0x79CAB579, "mp_cruise_fx" },
    { 0x7D774A0F, "mp_ctf_spawn_allies" },
    { 0xAD86E70A, "mp_ctf_spawn_allies_start" },
    { 0x92646BEE, "mp_ctf_spawn_axis" },
    { 0xB5D222CF, "mp_ctf_spawn_axis_start" },
    { 0xB54DE695, "mp_dem_spawn_attacker" },
    { 0x587AAE01, "mp_dem_spawn_attacker_a" },
    { 0x7E7D286A, "mp_dem_spawn_attacker_b" },
    { 0x32C0A80C, "mp_dem_spawn_attacker_start" },
    { 0x8695CF9D, "mp_dem_spawn_defender" },
    { 0x63451279, "mp_dem_spawn_defender_a" },
    { 0x89478CE2, "mp_dem_spawn_defender_b" },
    { 0xD3F3D1E4, "mp_dem_spawn_defender_start" },
    { 0x0B5B1573, "mp_devgui" },
    { 0x6010F252, "mp_dig_amb" },
    { 0x127E3730, "mp_dig_fx" },
    { 0xF375873C, "mp_dm_spawn" },
    { 0x5DF5BA33, "mp_docks" },
    { 0xFBE15FB6, "mp_docks_amb" },
    { 0x605CE225, "mp_docks_art" },
    { 0xAA80B32C, "mp_docks_fx" },
    { 0xFD053039, "mp_dockside" },
    { 0xB4DE8BE4, "mp_dockside_amb" },
    { 0x6B56268B, "mp_dockside_art" },
    { 0x1C8A40DB, "mp_dockside_crane" },
    { 0xF76C927E, "mp_dockside_fx" },
    { 0x3698C6BF, "mp_dom_spawn" },
    { 0xD3C5AE2D, "mp_dom_spawn_allies_start" },
    { 0xCCF77548, "mp_dom_spawn_axis_start" },
    { 0x85ABBCCC, "mp_dom_spawn_flag_a" },
    { 0xF7B32C07, "mp_dom_spawn_flag_b" },
    { 0xD1B0B19E, "mp_dom_spawn_flag_c" },
    { 0x30D66358, "mp_dome" },
    { 0xE0FBCF49, "mp_dome_amb" },
    { 0x674105EE, "mp_dome_art" },
    { 0xBE49B3B9, "mp_dome_fx" },
    { 0xDF8C0BEE, "mp_downfall" },
    { 0x4E112ACF, "mp_downfall_amb" },
    { 0x088E28EC, "mp_downfall_art" },
    { 0x899327BB, "mp_downfall_fx" },
    { 0x6BF52661, "mp_downhill_amb" },
    { 0xA7F38C60, "mp_downhill_cablecar" },
    { 0xA90498C1, "mp_downhill_fx" },
    { 0xA7F95A01, "mp_drone" },
    { 0x468FE54C, "mp_drone_amb" },
    { 0xEF9AC603, "mp_drone_art" },
    { 0x21B50B3F, "mp_drone_doors" },
    { 0x4A233996, "mp_drone_fx" },
    { 0x3E646109, "mp_drum" },
    { 0xA85F5F94, "mp_drum_amb" },
    { 0x4112A97B, "mp_drum_art" },
    { 0x0D97CC2E, "mp_drum_fx" },
    { 0x2A8047F8, "mp_duga" },
    { 0x9E500E29, "mp_duga_amb" },
    { 0x249544CE, "mp_duga_art" },
    { 0xB17FAA19, "mp_duga_fx" },
    { 0x50C732DA, "mp_encampment_amb" },
    { 0x9E50DE79, "mp_encampment_art" },
    { 0x748B52E8, "mp_encampment_fx" },
    { 0x567DC01A, "mp_ents_cleanup" },
    { 0x093C3A43, "mp_erdman_test" },
    { 0x9FD09726, "mp_erdman_test_amb" },
    { 0xEF021B9C, "mp_erdman_test_fx" },
    { 0x23D8F4EB, "mp_express" },
    { 0xCA853ECE, "mp_express_amb" },
    { 0x00E4D9AD, "mp_express_art" },
    { 0xFBC70C14, "mp_express_fx" },
    { 0xDB501730, "mp_express_train" },
    { 0x933ADE5B, "mp_farm_art" },
    { 0x527BB48E, "mp_farm_fx" },
    { 0xF8500B8B, "mp_firingrange" },
    { 0x0FF583AE, "mp_firingrange_amb" },
    { 0x43DAB58D, "mp_firingrange_art" },
    { 0x6F10A874, "mp_firingrange_fx" },
    { 0x9876D2C6, "mp_frostbite_amb" },
    { 0xD8FE50BC, "mp_frostbite_fx" },
    { 0x1C313F23, "mp_gametypetestmap" },
    { 0x4A243B46, "mp_gametypetestmap_amb" },
    { 0xAABE963C, "mp_gametypetestmap_fx" },
    { 0x9D0AD563, "mp_global_intermission" },
    { 0x8A6D158F, "mp_golfcourse_amb" },
    { 0xCC96137B, "mp_golfcourse_fx" },
    { 0x1140FBCC, "mp_gridlock" },
    { 0x356D674C, "mp_hangar" },
    { 0xB525D49D, "mp_hangar_amb" },
    { 0xC41953F2, "mp_hangar_art" },
    { 0x877832E5, "mp_hangar_fx" },
    { 0x827A136A, "mp_hanoi" },
    { 0xEC6908AB, "mp_hanoi_amb" },
    { 0x5DB03708, "mp_hanoi_art" },
    { 0x44E6B2FF, "mp_hanoi_fx" },
    { 0x7DEB8B28, "mp_havoc" },
    { 0xC3B8C5B9, "mp_havoc_amb" },
    { 0xE723B2DE, "mp_havoc_art" },
    { 0x923DF269, "mp_havoc_fx" },
    { 0x7D50BFBA, "mp_hijacked" },
    { 0x3BBBC15B, "mp_hijacked_amb" },
    { 0x1257A238, "mp_hijacked_art" },
    { 0xFFFCC1EF, "mp_hijacked_fx" },
    { 0xD79C79BD, "mp_hotel" },
    { 0x1194D9E4, "mp_hydro_amb" },
    { 0x0E85CC7E, "mp_hydro_fx" },
    { 0x65EEFF35, "mp_killhouse_art" },
    { 0xBF70597C, "mp_killhouse_fx" },
    { 0x941459C6, "mp_kneedeep" },
    { 0x83091CA7, "mp_kneedeep_amb" },
    { 0x92833674, "mp_kneedeep_art" },
    { 0x4F9123C3, "mp_kneedeep_fx" },
    { 0x7D120CF9, "mp_kwai" },
    { 0x85A48CA4, "mp_kwai_amb" },
    { 0x3C1C274B, "mp_kwai_art" },
    { 0xAA08673E, "mp_kwai_fx" },
    { 0x7F0380D0, "mp_la" },
    { 0x62838041, "mp_la_amb" },
    { 0xBD273856, "mp_la_art" },
    { 0x2594E821, "mp_la_fx" },
    { 0xA66B583D, "mp_labc" },
    { 0xC23C8628, "mp_labc_amb" },
    { 0xC1E9F08F, "mp_labc_art" },
    { 0x01E7984A, "mp_labc_fx" },
    { 0xC2D07BB0, "mp_lagoon_amb" },
    { 0x72759C67, "mp_lagoon_art" },
    { 0x49D344CC, "mp_light_lamp" },
    { 0x5B12555E, "mp_lobby_data_struct" },
    { 0xE9094569, "mp_loot_xp_due" },
    { 0xD8BF9ED9, "mp_magma_amb" },
    { 0xD109ED09, "mp_magma_fx" },
    { 0xB19F0007, "mp_makin" },
    { 0x51BA2F8A, "mp_makin_amb" },
    { 0x3C6991A9, "mp_makin_art" },
    { 0x0DAB763C, "mp_makin_day" },
    { 0x6D4A1B2D, "mp_makin_day_amb" },
    { 0xDF17E402, "mp_makin_day_art" },
    { 0x779D7A35, "mp_makin_day_fx" },
    { 0x7E57F9D8, "mp_makin_fx" },
    { 0xBB48A3EC, "mp_match_record" },
    { 0xE15DCECB, "mp_meltdown" },
    { 0xC9D107EE, "mp_meltdown_amb" },
    { 0x0030A2CD, "mp_meltdown_art" },
    { 0x9D1B84B4, "mp_meltdown_fx" },
    { 0x5FB34161, "mp_meltdown_lift" },
    { 0x19BC4745, "mp_mirage_amb" },
    { 0x4B63105D, "mp_mirage_fx" },
    { 0x88F48CDB, "mp_mobile_spawn" },
    { 0x7DB47DAC, "mp_modetest" },
    { 0x1E3B223D, "mp_modetest_amb" },
    { 0xFD7C4E05, "mp_modetest_fx" },
    { 0x5C45E4F0, "mp_mountain" },
    { 0x896E4F21, "mp_mountain_amb" },
    { 0xE1979E36, "mp_mountain_art" },
    { 0xC5327B81, "mp_mountain_fx" },
    { 0xA2D38DB4, "mp_multi_team_spawn" },
    { 0xC731497B, "mp_murad_test" },
    { 0xC3E396FE, "mp_murad_test_amb" },
    { 0xF2674BC4, "mp_murad_test_fx" },
    { 0xF7CFAF36, "mp_nachtfeuer" },
    { 0xF7219CB7, "mp_nachtfeuer_amb" },
    { 0xA3C16D04, "mp_nachtfeuer_art" },
    { 0x367A3A93, "mp_nachtfeuer_fx" },
    { 0xEB460ABD, "mp_nightclub" },
    { 0xD4AFE0A8, "mp_nightclub_amb" },
    { 0xD45D4B0F, "mp_nightclub_art" },
    { 0x77C963CA, "mp_nightclub_fx" },
    { 0x14FD6946, "mp_nuked" },
    { 0x1753A427, "mp_nuked_amb" },
    { 0x40410E3F, "mp_nuked_amb_platform" },
    { 0x26CDBDF4, "mp_nuked_art" },
    { 0xF6AF2E43, "mp_nuked_fx" },
    { 0x0F611A88, "mp_nuked_platform" },
    { 0x4B451AF8, "mp_nuketown_2020_amb" },
    { 0x2FA89D9F, "mp_nuketown_2020_art" },
    { 0xBD98059A, "mp_nuketown_2020_fx" },
    { 0x88A44567, "mp_outskirts" },
    { 0xC0E351AA, "mp_outskirts_amb" },
    { 0xAE0D1CC9, "mp_outskirts_art" },
    { 0xE4D15178, "mp_outskirts_fx" },
    { 0x1914DD57, "mp_overflow" },
    { 0x78F76B7A, "mp_overflow_amb" },
    { 0xC6811719, "mp_overflow_art" },
    { 0xFA47B708, "mp_overflow_fx" },
    { 0x9297AE32, "mp_overgrown_art" },
    { 0xDCF10E25, "mp_overgrown_fx" },
    { 0x942CE81D, "mp_paintball_amb" },
    { 0xD3EF0165, "mp_paintball_fx" },
    { 0xF6EEF7D9, "mp_pier" },
    { 0x72B965C4, "mp_pier_amb" },
    { 0x6ED3F8DE, "mp_pier_fx" },
    { 0x27BF8605, "mp_pipeline_art" },
    { 0x1341D08C, "mp_pipeline_fx" },
    { 0x14C18B61, "mp_player_join" },
    { 0x4579441B, "mp_pod_amb" },
    { 0x2BEF8BAF, "mp_pod_fx" },
    { 0x76D00BEA, "mp_post_combat" },
    { 0xAFF9CBCB, "mp_pre_combat" },
    { 0x1B0B5AA6, "mp_radiation" },
    { 0xEF340247, "mp_radiation_amb" },
    { 0xFEAE1C14, "mp_radiation_art" },
    { 0x0282AFE3, "mp_radiation_fx" },
    { 0x07CB2C05, "mp_raid" },
    { 0x3D3495B0, "mp_raid_amb" },
    { 0xECD9B667, "mp_raid_art" },
    { 0x7919E922, "mp_raid_fx" },
    { 0x046FF33A, "mp_res_spawn_allies" },
    { 0x61812282, "mp_res_spawn_allies_a" },
    { 0x3B7EA819, "mp_res_spawn_allies_b" },
    { 0xAC8BCB33, "mp_res_spawn_allies_start" },
    { 0x7A7895AB, "mp_res_spawn_axis" },
    { 0x109761BB, "mp_res_spawn_axis_a" },
    { 0xB2EC678E, "mp_res_spawn_axis_start" },
    { 0xF9F8C4EA, "mp_robtest" },
    { 0x8B81522B, "mp_robtest_amb" },
    { 0x5621337F, "mp_robtest_fx" },
    { 0xFEA4A8D1, "mp_roundhouse" },
    { 0xD84972BC, "mp_roundhouse_amb" },
    { 0x20F472F3, "mp_roundhouse_art" },
    { 0x3217B746, "mp_roundhouse_fx" },
    { 0xDD5B051B, "mp_russianbase" },
    { 0x7BFA3B5E, "mp_russianbase_amb" },
    { 0xD01E26FD, "mp_russianbase_art" },
    { 0xB646B6A4, "mp_russianbase_fx" },
    { 0x4F868AE2, "mp_sab_spawn_allies" },
    { 0x52AA71AB, "mp_sab_spawn_allies_start" },
    { 0x5F5539A3, "mp_sab_spawn_axis" },
    { 0x661DF096, "mp_sab_spawn_axis_start" },
    { 0x62D1CB5A, "mp_sd_spawn_attacker" },
    { 0x0244DEDE, "mp_sd_spawn_defender" },
    { 0x76F1ACC0, "mp_seelow" },
    { 0xF1DF6111, "mp_seelow_amb" },
    { 0x67CD00E6, "mp_seelow_art" },
    { 0x68FB64F1, "mp_seelow_fx" },
    { 0x66E7AB2A, "mp_sentosa" },
    { 0xCE8EF861, "mp_shipment_art" },
    { 0x5A3E9710, "mp_shipment_fx" },
    { 0x913E40A4, "mp_showdown_art" },
    { 0xFEC60AB3, "mp_showdown_fx" },
    { 0x8AF54B81, "mp_shrine_amb" },
    { 0xE31E9A96, "mp_shrine_art" },
    { 0x77772E61, "mp_shrine_fx" },
    { 0xCE1CEE99, "mp_side_step" },
    { 0xF2F909A7, "mp_silo_amb" },
    { 0x02732374, "mp_silo_art" },
    { 0x3CC9A2C3, "mp_silo_fx" },
    { 0xBD299890, "mp_skate_amb" },
    { 0x67B68B82, "mp_skate_fx" },
    { 0x7FF90A2D, "mp_slums" },
    { 0xD6075EB8, "mp_slums_amb" },
    { 0xB7F0785F, "mp_slums_art" },
    { 0xE6AFAA5A, "mp_slums_fx" },
    { 0x431657C4, "mp_socotra" },
    { 0xB6636BF5, "mp_socotra_amb" },
    { 0xD5AE821A, "mp_socotra_art" },
    { 0x1546834D, "mp_socotra_fx" },
    { 0x317304DB, "mp_stalingrad_amb" },
    { 0x080EE5B8, "mp_stalingrad_art" },
    { 0x15E0A06F, "mp_stalingrad_fx" },
    { 0x7147DFA2, "mp_standoff" },
    { 0x2D771543, "mp_standoff_amb" },
    { 0xF140F650, "mp_standoff_art" },
    { 0x0811CAA7, "mp_standoff_fx" },
    { 0xAF9C54BE, "mp_stats" },
    { 0x16DAADBA, "mp_statstable" },
    { 0x9985FDF9, "mp_strike_art" },
    { 0x5C136568, "mp_strike_fx" },
    { 0xDD1244BD, "mp_struggle_amb" },
    { 0x34E83185, "mp_struggle_fx" },
    { 0x360D8D0A, "mp_studio_amb" },
    { 0x5BA79658, "mp_studio_fx" },
    { 0xC36ED5CE, "mp_suburban_amb" },
    { 0xF9CE70AD, "mp_suburban_art" },
    { 0xC1517914, "mp_suburban_fx" },
    { 0xC1687087, "mp_subway_amb" },
    { 0xCE682154, "mp_subway_art" },
    { 0x220F3E23, "mp_subway_fx" },
    { 0xD3CC5CD7, "mp_t5_weapontest" },
    { 0xF18762FA, "mp_t5_weapontest_amb" },
    { 0x89309188, "mp_t5_weapontest_fx" },
    { 0x4C03CE8A, "mp_t6_weapontest" },
    { 0x43FF358B, "mp_t6_weapontest_amb" },
    { 0x293FC35F, "mp_t6_weapontest_fx" },
    { 0xA3F686D4, "mp_takeoff_fx" },
    { 0x43595A92, "mp_tdm_spawn" },
    { 0x9F2A527E, "mp_tdm_spawn_allies_start" },
    { 0xD701A81B, "mp_tdm_spawn_axis_start" },
    { 0xF8E1D9FE, "mp_tdm_spawn_team1_start" },
    { 0xFF24D575, "mp_tdm_spawn_team2_start" },
    { 0xCCC4F638, "mp_tdm_spawn_team3_start" },
    { 0xA4C5BDA7, "mp_tdm_spawn_team4_start" },
    { 0x26A2E67A, "mp_tdm_spawn_team5_start" },
    { 0x9EA6CCB1, "mp_tdm_spawn_team6_start" },
    { 0x1D4CB3E1, "mp_tommy" },
    { 0x36A5696C, "mp_tommy_amb" },
    { 0x443E5036, "mp_tommy_fx" },
    { 0xDF500CE3, "mp_tool" },
    { 0x761722AC, "mp_train_test" },
    { 0x3F63173D, "mp_train_test_amb" },
    { 0xF9C1A505, "mp_train_test_fx" },
    { 0xE6ADEC3E, "mp_trenches_amb" },
    { 0x748EB304, "mp_trenches_fx" },
    { 0x09EDD1DA, "mp_turbine" },
    { 0xBE20C2BB, "mp_turbine_amb" },
    { 0x94BCA398, "mp_turbine_art" },
    { 0xC07CE4CF, "mp_turbine_fx" },
    { 0xB49FF74B, "mp_twar_spawn" },
    { 0x5EED3579, "mp_twar_spawn_allies_start" },
    { 0x1B14653C, "mp_twar_spawn_axis_start" },
    { 0xA0C6705F, "mp_uplink_amb" },
    { 0x77DF014B, "mp_uplink_fx" },
    { 0xB4C3827B, "mp_uspawn_influencer" },
    { 0xD75C5790, "mp_uspawn_point" },
    { 0x450100DE, "mp_vacant_art" },
    { 0xB7F42C69, "mp_vacant_fx" },
    { 0xB949D622, "mp_veiled" },
    { 0x830CAA12, "mp_vertigo_amb" },
    { 0x9BD7F3C1, "mp_vertigo_art" },
    { 0x89CF6F69, "mp_vertigo_doors" },
    { 0x56B4AEF0, "mp_vertigo_fx" },
    { 0x950330C7, "mp_villa" },
    { 0xA8F8C44A, "mp_villa_amb" },
    { 0x93A82669, "mp_villa_art" },
    { 0xD5BFD398, "mp_villa_fx" },
    { 0x88EF2B03, "mp_village" },
    { 0xD55109E6, "mp_village_amb" },
    { 0x1C083B95, "mp_village_art" },
    { 0xA1BC355C, "mp_village_fx" },
    { 0x9CB39D41, "mp_vodka_amb" },
    { 0xF7575556, "mp_vodka_art" },
    { 0xD46A7721, "mp_vodka_fx" },
    { 0x3C88B739, "mp_wager_spawn" },
    { 0x4F138BAD, "mp_weapontest_share" },
    { 0x38A45348, "mp_weekly_challenge_complete" },
    { 0x8F6E94AE, "mp_wetlands_amb" },
    { 0x21E1F374, "mp_wetlands_fx" },
    { 0x29347CF9, "mp_yemen" },
    { 0xAD7DFCA4, "mp_yemen_amb" },
    { 0x63F5974B, "mp_yemen_art" },
    { 0xCC6F373E, "mp_yemen_fx" },
    { 0xE13733AC, "mp_zombie_temp" },
    { 0x2CB3383D, "mp_zombie_temp_amb" },
    { 0xAFD2E332, "mp_zoo_amb" },
    { 0x49656090, "mp_zoo_fx" },
    { 0xBEE2C30E, "mpai_peter_todo" },
    { 0xB7F362F2, "mpbody" },
    { 0xCA9C7F6E, "mpboostresponse" },
    { 0x18F585F6, "mpcustommatch" },
    { 0xAFFF28A6, "mpdialog" },
    { 0xFC14D9F4, "mpdialog_value" },
    { 0xE924714B, "mpdialogkey" },
    { 0x79AD095A, "mph" },
    { 0x78E9D02C, "mph2" },
    { 0xF3557BA3, "mph_to_inches_per_sec" },
    { 0xE1EFD6BD, "mph_to_ups" },
    { 0x84F10764, "mphead" },
    { 0x929312C8, "mpintro_visionset_activate_func" },
    { 0x9A1B89C0, "mpintro_visionset_alias" },
    { 0x33A66327, "mpintro_visionset_deactivate_func" },
    { 0xD0623F2D, "mpintro_visionset_name" },
    { 0x62A605A4, "mpintro_visionset_priority" },
    { 0x18B2CC84, "mpintro_visionset_ramp_hold" },
    { 0x1B101F89, "mpintro_visionset_ramp_hold_func" },
    { 0xD59B3B86, "mpintro_visionset_ramp_in" },
    { 0x9E6AC078, "mpintro_visionset_ramp_notify" },
    { 0x58F0B9E1, "mpintro_visionset_ramp_out" },
    { 0x514CDE6D, "mpintro_visionset_steps" },
    { 0x11B6F2FE, "mpl" },
    { 0x46B3B323, "mpla" },
    { 0xC65C3385, "mpla_attach_machete_notetrack" },
    { 0x113A7F16, "mpla_disable_aim_assist" },
    { 0x9AB068C5, "mpla_drop_baton_on_death" },
    { 0x42BC0C7E, "mpla_drop_rifle_notetrack" },
    { 0x858BA23F, "mpla_get_closer_if_melee_blocked" },
    { 0x1F8B2B2B, "mpla_hunt_immediately_behavior" },
    { 0xFE7D73FB, "mpla_machete_melee_charge_dist_sq" },
    { 0x2E0682E0, "mpla_melee_aivsai" },
    { 0x9E40ABA0, "mpla_melee_aivsai_canexecute" },
    { 0x1F2D6A8A, "mpla_melee_aivsai_setmeleeseqanims" },
    { 0x58A1BDCB, "mpla_melee_charge_dist_sq" },
    { 0x07C478E6, "mpla_melee_endfunc" },
    { 0xA4A4E826, "mpla_melee_extra_long_range_dist_sq" },
    { 0x08EA0F7B, "mpla_melee_long_range_dist_sq" },
    { 0x3414D3E1, "mpla_melee_mid_range_dist_sq" },
    { 0xBC2EC9A2, "mpla_melee_notetrackhandler" },
    { 0x9A5ACDC5, "mpla_melee_short_range_dist_sq" },
    { 0x6897D685, "mpla_melee_weapon" },
    { 0x5485EBC3, "mpla_rpg_hudson" },
    { 0xEA62D070, "mpla_scripted_attach_machete" },
    { 0x5D118878, "mpla_scripted_drop_machete" },
    { 0xA3FE2B67, "mpla_shoot_hudson" },
    { 0xAF0E4EFD, "mplayer" },
    { 0x7D68BAAD, "mpsaylocalsound" },
    { 0xE4659F0B, "mpsaylocationallocalsound" },
    { 0x6A4EB452, "mptakeoffrocket" },
    { 0x9FB18376, "mptype" },
    { 0x3E393BCC, "mptype_ally_cqb" },
    { 0xE602CBE5, "mptype_ally_engineer" },
    { 0x54824D40, "mptype_ally_rifleman" },
    { 0x98811B23, "mptype_ally_sniper" },
    { 0xC2F6234B, "mptype_ally_support" },
    { 0x0FD02722, "mptype_ally_urban_assault" },
    { 0x444450FA, "mptype_ally_urban_recon" },
    { 0x9042E4C8, "mptype_ally_urban_sniper" },
    { 0xC17D90D0, "mptype_ally_urban_specops" },
    { 0x198797AA, "mptype_ally_urban_support" },
    { 0x7DF76A72, "mptype_ally_woodland_assault" },
    { 0x6BCF57EA, "mptype_ally_woodland_recon" },
    { 0xCF2BA758, "mptype_ally_woodland_sniper" },
    { 0x9DF1C360, "mptype_ally_woodland_specops" },
    { 0xA6C005BA, "mptype_ally_woodland_support" },
    { 0xF915FE4D, "mptype_axis_cqb" },
    { 0x7D7E1F16, "mptype_axis_engineer" },
    { 0xA043CB83, "mptype_axis_rifleman" },
    { 0xC4CB5DD4, "mptype_axis_sniper" },
    { 0x9C307466, "mptype_axis_support" },
    { 0x18467E73, "mptype_axis_urban_assault" },
    { 0xDC465F78, "mptype_axis_urban_cqb" },
    { 0x112003C9, "mptype_axis_urban_engineer" },
    { 0x1CA933E7, "mptype_axis_urban_sniper" },
    { 0xBCD942DF, "mptype_axis_urban_support" },
    { 0xB12B0872, "mptype_axis_woodland_cqb" },
    { 0x67093E07, "mptype_axis_woodland_engineer" },
    { 0xB95B2946, "mptype_axis_woodland_rifleman" },
    { 0x1FEB5F29, "mptype_axis_woodland_sniper" },
    { 0xBACF437D, "mptype_axis_woodland_support" },
    { 0x68379331, "mptype_ger_hnrgrd_assault" },
    { 0xD5726A16, "mptype_ger_hnrgrd_cqb" },
    { 0x2BCD6D30, "mptype_ger_hnrgrd_lmg" },
    { 0x16D5F7F6, "mptype_ger_hnrgrd_rifle" },
    { 0x85D5CC1F, "mptype_ger_hnrgrd_smg" },
    { 0x834C0F7E, "mptype_jap_impinf_assault" },
    { 0x46006D4D, "mptype_jap_impinf_cqb" },
    { 0xA46F07AB, "mptype_jap_impinf_lmg" },
    { 0xC30F109D, "mptype_jap_impinf_rifle" },
    { 0x05597524, "mptype_jap_impinf_smg" },
    { 0xC5EA01F3, "mptype_rus_guard_assault" },
    { 0x20B0AAF8, "mptype_rus_guard_cqb" },
    { 0xABC92B8E, "mptype_rus_guard_lmg" },
    { 0x7F1251B0, "mptype_rus_guard_rifle" },
    { 0xD7EEA339, "mptype_rus_guard_smg" },
    { 0x54A6FEB8, "mptype_usa_raider_assault" },
    { 0x169C111F, "mptype_usa_raider_cqb" },
    { 0xBDA39101, "mptype_usa_raider_lmg" },
    { 0xDFCE9387, "mptype_usa_raider_rifle" },
    { 0xC2407EA6, "mptype_usa_raider_smg" },
    { 0x44CBEE43, "mpui_callsign_" },
    { 0x83135DB4, "mr" },
    { 0x11080915, "mr1" },
    { 0xDBE5EF8F, "mr_get_magic_target_position" },
    { 0xF81BF68D, "mr_spawn_salazar" },
    { 0x39DBA1AF, "mrap" },
    { 0x4C29159F, "mrkr" },
    { 0xD57B34EC, "mroe" },
    { 0x9B2C750E, "mrpukey" },
    { 0xDC6E63A7, "mrs" },
    { 0xA915D81D, "ms" },
    { 0x551BC72C, "ms_death_vox" },
    { 0x323C46C9, "ms_guys_init" },
    { 0x0E12FCDB, "ms_idle_fail_player" },
    { 0x600A1E2F, "ms_rumble" },
    { 0x7D8BED2A, "ms_soldier_cover_shoot" },
    { 0xA44818A9, "ms_soldier_deaththread" },
    { 0xEC7B35C9, "ms_soldier_run_and_rail" },
    { 0xB51A12E2, "ms_soldier_triple_25_add_gunners" },
    { 0xABBC88A0, "ms_soldier_triple_25_idle" },
    { 0xA3829273, "ms_timer" },
    { 0xC6285AE5, "ms_timer_hud" },
    { 0xF3473363, "msd" },
    { 0x36DD6A05, "msec" },
    { 0x813FC428, "msg" },
    { 0xA4ED51B1, "msg1" },
    { 0xCAEFCC1A, "msg2" },
    { 0xF0F24683, "msg3" },
    { 0x16F4C0EC, "msg4" },
    { 0x3CF73B55, "msg5" },
    { 0x2B8D5606, "msg_base_under_attack" },
    { 0x7E2E88F4, "msg_displayed" },
    { 0x369508F9, "msg_endon" },
    { 0xDE6C5F69, "msg_num" },
    { 0xDA2D5490, "msg_on" },
    { 0xEE47322D, "msg_parm" },
    { 0xBCA952D4, "msg_player_needs_new_weapon" },
    { 0x95FC5930, "msg_t3" },
    { 0x7190E0C3, "msgs" },
    { 0x6806E01F, "msgup" },
    { 0xE2E21EC9, "mslone" },
    { 0xEEDD7CD7, "mstimedifference" },
    { 0x1BDF24F7, "mswaitlen" },
    { 0x8D8E5D82, "mta_amp_amplified" },
    { 0x323E3F38, "mta_amp_broken" },
    { 0xFF9873C5, "mta_amp_found" },
    { 0xD0EDA157, "mta_amp_found_by_sam" },
    { 0x01213E71, "mta_amplifier_damage_watch" },
    { 0x84B22EFF, "mta_amplifier_filled_fx" },
    { 0x76E9025F, "mta_amplifier_found_watcher" },
    { 0xB2058408, "mta_amplifier_init" },
    { 0x99A1FBE4, "mta_amplifier_subwoofer_watch" },
    { 0xF86092CF, "mta_check_all_amplifier_states" },
    { 0x66DBAD9D, "mteam" },
    { 0x4C3EA569, "mtoff" },
    { 0x8CC6D7DD, "mton" },
    { 0x3DD249B0, "mtower_object_planted" },
    { 0xFB30B8DB, "mtu" },
    { 0x6C6E2881, "mu0" },
    { 0xB8731D53, "mu2" },
    { 0x5973E8C6, "much" },
    { 0x8661A69C, "mucks" },
    { 0x23B1D155, "mud" },
    { 0x5281EA58, "mud_overlay" },
    { 0xAF080872, "mud_slowdown_cleared" },
    { 0xD960C610, "muddy" },
    { 0xE9A162F8, "mudslide" },
    { 0xA8DAD8C2, "muffled" },
    { 0x49B44BBE, "mug" },
    { 0xA799093B, "muj" },
    { 0x82350E1D, "muj_bridge1_logic" },
    { 0xE4A2C2AE, "muj_bridge2_logic" },
    { 0x895AD0D6, "muj_bridge_crosser_logic" },
    { 0xB811C968, "muj_celeb_ent_l" },
    { 0xCC347B26, "muj_celeb_ent_r" },
    { 0x4DA3F412, "muj_celebration" },
    { 0xB7F95AE6, "muj_dismount_behavior" },
    { 0xC6C0FAF9, "muj_encircling_node" },
    { 0xA5FA4B41, "muj_guard" },
    { 0xC617788D, "muj_horse" },
    { 0x33B6D0F5, "muj_horse_lineup" },
    { 0x9502F542, "muj_horse_logic" },
    { 0xD174630C, "muj_horses" },
    { 0x0A3F0875, "muj_initial_logic" },
    { 0xDAE700B8, "muj_kill_btr_chase" },
    { 0x82B5CF66, "muj_men" },
    { 0x9E3EF393, "muj_retreat" },
    { 0x5771E525, "muj_rider_base_logic" },
    { 0x0F6249E5, "muj_riders" },
    { 0x62032ED6, "muj_spawner" },
    { 0x5C7DDD7E, "muj_tank" },
    { 0x5B4527EB, "muj_tank_behavior" },
    { 0xB405961D, "muj_tank_exit" },
    { 0xDF8D65C1, "mujahideen" },
    { 0xA2ED1721, "mujihadeen" },
    { 0xF39DFE0D, "mul" },
    { 0x105B3D4A, "mule" },
    { 0x4977B087, "mule_kick_allows_4_weapons" },
    { 0x472625E6, "mulit" },
    { 0x69460FC3, "mulitple" },
    { 0xE940D690, "mullah" },
    { 0x41BAACA6, "muller" },
    { 0x56CEBB6B, "muller_transform" },
    { 0xD6361123, "mult" },
    { 0x247DA018, "multi" },
    { 0x1C9BF80C, "multi_detonation_get_cluster_launch_dir" },
    { 0x630ABC90, "multi_extracam" },
    { 0x0FE4D4B5, "multi_extracam_active" },
    { 0x7735D541, "multi_extracam_init" },
    { 0x6866D982, "multi_launch" },
    { 0x9063887A, "multi_lmg_smg_kill" },
    { 0xEE3684EC, "multi_mgl_kill" },
    { 0x5EEDD669, "multi_objective_set" },
    { 0x2B4A7CC1, "multi_rcbomb_kill" },
    { 0x09DC38B6, "multi_remotemissile_kill" },
    { 0xB7B30BDC, "multiattack" },
    { 0x69063516, "multiblastweapon" },
    { 0xD38BC7E8, "multibomb" },
    { 0xD52DC7C6, "multicam1" },
    { 0xAF2B4D5D, "multicam2" },
    { 0xCF1860F2, "multicams_trigger_enter" },
    { 0x5902704D, "multicams_trigger_leave" },
    { 0x91B53010, "multicams_trigger_thread" },
    { 0x4A58AFE7, "multidetonation" },
    { 0x5B67D150, "multidetonationfragmentspeed" },
    { 0xE677FBD0, "multifunction" },
    { 0x45A7BD4E, "multigrenadekill" },
    { 0xCAE0E706, "multiheroabilitykill" },
    { 0x82EACC98, "multikill" },
    { 0xFC5B5C6A, "multikillmedalachievement" },
    { 0xE0CA4F4B, "multilockap_guidance" },
    { 0x021B6110, "multilockapguidance" },
    { 0x7605B1A5, "multilocklist" },
    { 0xBB8842FF, "multilockmissilefire" },
    { 0x87E09214, "multimedia_up" },
    { 0x5B5806ED, "multipath" },
    { 0x871B069D, "multipath_trigger_cleanup" },
    { 0x3E6EFB5E, "multiplay" },
    { 0x3AD55F87, "multiplayer" },
    { 0x7C3580D1, "multiple" },
    { 0x251A6961, "multiple_c4" },
    { 0x9F8D2FC6, "multiple_targets" },
    { 0x21D91485, "multiple_targets_pos" },
    { 0x5BF3E2A8, "multiple_trigger_wait" },
    { 0x3B1CE443, "multiple_trigger_waits" },
    { 0xCC05DC67, "multiple_wait" },
    { 0x99C57CDE, "multiple_waits" },
    { 0xF3B39C9A, "multipledialogkey" },
    { 0x77E4B295, "multipledialogkeys" },
    { 0x8847E7B8, "multiples" },
    { 0x02E0BFDA, "multiplied" },
    { 0xAF0D5B3C, "multiplier" },
    { 0x1F971AFF, "multipliers" },
    { 0xD50FD5A5, "multiplies" },
    { 0x44533DBD, "multiply" },
    { 0x4018F0F9, "multipy" },
    { 0x5030C092, "multirank" },
    { 0x14CBB7B2, "multirocketacquisitiontime" },
    { 0x563F95F7, "multirocketfireinterval" },
    { 0x7DDB046E, "multirocketfirepowerloss" },
    { 0x4497D707, "multirocketrange" },
    { 0x779672D4, "multirockettargetnumber" },
    { 0x79851E7D, "multirockettargetradius" },
    { 0x57E8ED78, "multishot" },
    { 0xC906D2A3, "multiteam" },
    { 0x05CE9320, "multithreading" },
    { 0xA07F4DB4, "multitrackperlife" },
    { 0x128F28F0, "multitude" },
    { 0x0AF3E055, "multival" },
    { 0xF5BEE1F6, "multuiple" },
    { 0x1C088D08, "muppet" },
    { 0x5EF39ADF, "murdered" },
    { 0x6DC52B44, "murdering_player" },
    { 0x634D97F2, "murderline" },
    { 0xB1619BA9, "murray" },
    { 0x9A8E2C39, "mus_stinger_explosion" },
    { 0x5ABAC937, "mus_trigger" },
    { 0x3057C8D5, "musarray" },
    { 0xAAEB6DE8, "muscstate" },
    { 0x46A1E8F6, "mush" },
    { 0xCCB8D056, "music" },
    { 0x0AA8B9D3, "music_alias" },
    { 0x62776857, "music_barrel_state" },
    { 0xAFCBD2AA, "music_boss" },
    { 0x33029558, "music_box" },
    { 0xC89ABAEE, "music_box_off" },
    { 0xA84ABBC0, "music_box_on" },
    { 0xF79940AA, "music_cobraflight" },
    { 0xA098E5ED, "music_combat" },
    { 0x35BC8228, "music_control" },
    { 0xA6E69B11, "music_controller" },
    { 0xD23069E2, "music_countdown" },
    { 0x53B86279, "music_defend" },
    { 0x49A07B92, "music_delay" },
    { 0xC0A17F24, "music_egg" },
    { 0x2BAE103D, "music_egg_trig" },
    { 0x93BD926C, "music_egg_wait" },
    { 0xEAF7D56C, "music_end" },
    { 0xC685F63D, "music_end_first_pass" },
    { 0x0A3D2629, "music_end_second_pass" },
    { 0x083BB60E, "music_end_third_pass" },
    { 0x4B1F7BFC, "music_ent" },
    { 0x921AC036, "music_fade_test" },
    { 0x208E8B6B, "music_fairground_battle" },
    { 0x1C2A72ED, "music_fairgrounds" },
    { 0x2BCBE3E2, "music_fairgrounds_fade" },
    { 0xAE7482A1, "music_flagged" },
    { 0xCFBC6286, "music_for_event_8" },
    { 0xD8CF7E9D, "music_for_swing" },
    { 0xD7141766, "music_helicrash" },
    { 0xCA2C871D, "music_horse_watcher" },
    { 0x528D00F3, "music_init" },
    { 0xC2DB9099, "music_intro" },
    { 0xD589E2C1, "music_killhouse_price" },
    { 0x2D709DD8, "music_launch" },
    { 0xD13A6AC7, "music_loop" },
    { 0xC087A3F0, "music_loop_fade" },
    { 0x638DA7BE, "music_loop_proc" },
    { 0xD09BC62A, "music_loop_stop" },
    { 0x7F5F9C6A, "music_notify_continue" },
    { 0xA390B594, "music_notify_continue_trigger_pressed" },
    { 0x7F7AEA26, "music_nuke" },
    { 0x63D4E91F, "music_num" },
    { 0x5738E0E5, "music_override" },
    { 0x992A847F, "music_play" },
    { 0x35FE3224, "music_playa" },
    { 0x444E8766, "music_playback" },
    { 0x14A8A442, "music_player" },
    { 0x4B4AAD2E, "music_rescue" },
    { 0xFFAD36EA, "music_round_override" },
    { 0x587C37BA, "music_shared" },
    { 0x90A0D13C, "music_smoketown" },
    { 0xF9C8E407, "music_start" },
    { 0x5CCD71FF, "music_start_countdown" },
    { 0x7D4270A8, "music_state" },
    { 0x58D08227, "music_state_change" },
    { 0xFE059E9E, "music_state_changes" },
    { 0x456202CC, "music_state_fate_round" },
    { 0xFB4D907D, "music_stop" },
    { 0x2A930AD5, "music_switch" },
    { 0x22101A95, "music_switch_delay" },
    { 0xFFA24E44, "music_switcher" },
    { 0x61E1683E, "music_tension_loop" },
    { 0x40035967, "music_to_turret_front" },
    { 0x1FD4FC05, "music_to_turret_left" },
    { 0x7385A228, "music_to_turret_right" },
    { 0xA73E1529, "music_tracks_qr" },
    { 0x3C9ED65B, "music_vents" },
    { 0x5A211222, "music_zak_timing" },
    { 0xEE105C6D, "musical" },
    { 0x5DDD761A, "musicalias" },
    { 0xBE838B6C, "musicaliasloop" },
    { 0xB2CC51F6, "musiccmdhandler" },
    { 0xEED68EBE, "musiccontroller" },
    { 0xC453176D, "musicdeclarename" },
    { 0x3DF9BFEB, "musicendingoverride" },
    { 0x2A5F801D, "musicent" },
    { 0xF78F394F, "musicfadetime" },
    { 0x488E5172, "musiclength" },
    { 0xB04FE7B4, "musicplay" },
    { 0x2D666DCD, "musicplaywrapper" },
    { 0xF7BF9B52, "musicsavewait" },
    { 0xEC90EBBE, "musicstart" },
    { 0x7B2EA7B5, "musicstate" },
    { 0x0E2C7174, "musicstate_create" },
    { 0xAB721FE1, "musicstate_name" },
    { 0x0E30D384, "musicstates" },
    { 0x99044488, "musicstinger" },
    { 0x11D86A1E, "musicstop" },
    { 0x2AC8EFE1, "musicsystem" },
    { 0x4BEA8BF9, "musicsystemoverride" },
    { 0xB510A5AC, "musictimesout" },
    { 0x91088E73, "musictrack" },
    { 0x402291D5, "musicwaittilldelay" },
    { 0xF6D904B8, "musicwaittilldone" },
    { 0xC7CBE70E, "musicwaittillstingerdone" },
    { 0x649CB8DC, "musname1" },
    { 0xD6A42817, "musname2" },
    { 0xB0A1ADAE, "musname3" },
    { 0xF29549A1, "musname4" },
    { 0xCC92CF38, "musname5" },
    { 0x3E9A3E73, "musname6" },
    { 0x3ED3792A, "must" },
    { 0x67B75C93, "must_maintain_claim" },
    { 0x953749E2, "must_stop_at_next_point" },
    { 0x468E50C5, "mustering" },
    { 0xE5B939CF, "mustfaceenemy" },
    { 0xB716A4E2, "mustjump" },
    { 0x74FD6AEB, "mustmaintainclaim" },
    { 0x2723302B, "mustoplay" },
    { 0xA49F9383, "mustrenderheight" },
    { 0x52BC743B, "mutator_s" },
    { 0x275BC15C, "mutators" },
    { 0xAE52C613, "mute_amb" },
    { 0x96C1CA4E, "mutex" },
    { 0x407D2F6C, "mutually" },
    { 0x30DC6C2B, "muzak" },
    { 0x1B69874A, "muzzle" },
    { 0xDE263FF7, "muzzle_ang" },
    { 0x63CA0C11, "muzzle_flash_dynamic_fill" },
    { 0x6386F66D, "muzzle_org" },
    { 0x737052F4, "muzzleflash" },
    { 0x4D636F28, "muzzleflashes" },
    { 0x00B4ECD7, "muzzlename" },
    { 0xC896CDA0, "muzzlepoint" },
    { 0xEAF5D885, "muzzles" },
    { 0xD61AE7F7, "mv_noriega_right_of_church" },
    { 0x5ABEF2C4, "mvoement" },
    { 0x110BEE79, "mw" },
    { 0x233A6759, "mw2" },
    { 0xFD37ECF0, "mw3" },
    { 0x495ABB5C, "mw_warp_end_failsafe" },
    { 0x252EA037, "my" },
    { 0xF4F6665C, "my_ai" },
    { 0x9BCE5853, "my_air_clear_done" },
    { 0x6D3228BD, "my_anim" },
    { 0xB7F865B7, "my_anim_array" },
    { 0x6B74F28B, "my_anim_time" },
    { 0xA8C4E90D, "my_array" },
    { 0x6862AB74, "my_autosave" },
    { 0x4BC1A0A0, "my_boat_destroyed" },
    { 0x1054893B, "my_color" },
    { 0x9C6B76DA, "my_crate_landed" },
    { 0xE0C9F4F9, "my_crew" },
    { 0x32CCD827, "my_current_node_delays" },
    { 0xC9FC40DE, "my_dist" },
    { 0xA289C66D, "my_dist_sq" },
    { 0xF8C20AE7, "my_dist_sqreturn" },
    { 0x08F03278, "my_driver" },
    { 0xD4BD3E6D, "my_driver_died" },
    { 0xAB421C6A, "my_endon" },
    { 0x9D2A189E, "my_enemy" },
    { 0x08A8F1ED, "my_fall_speed" },
    { 0x4E368F68, "my_flag" },
    { 0xB62CA5C4, "my_flak" },
    { 0xE1813C05, "my_forward_speed" },
    { 0x8F68A7A0, "my_func" },
    { 0x70C17ACB, "my_group" },
    { 0xB15E47DA, "my_gump_func" },
    { 0xC8208AE1, "my_guy_array" },
    { 0xBEC3A442, "my_guys" },
    { 0x99EE1147, "my_guys_dead" },
    { 0x087AC008, "my_hands" },
    { 0xFA688B80, "my_head" },
    { 0x331E98C1, "my_horse" },
    { 0xF5E82D4E, "my_index" },
    { 0x2C76BACD, "my_level_init" },
    { 0x8C3EC4B3, "my_level_init_difficulty" },
    { 0x77FE0C2C, "my_level_init_ocean_debris" },
    { 0x279E11EA, "my_level_init_ocean_ships" },
    { 0x62C820E9, "my_local_notify" },
    { 0xD6C0B099, "my_look_ent" },
    { 0xEAEBEFC6, "my_look_ent_b" },
    { 0xD6FD50F4, "my_meatshield" },
    { 0xD21BB3DD, "my_mg_stop" },
    { 0xB475CE0A, "my_name_is_daletski" },
    { 0x6D6DB006, "my_node" },
    { 0xB30CA019, "my_notify" },
    { 0x71479FD9, "my_obj" },
    { 0xB71B7D3C, "my_objective_onentity" },
    { 0x307C6007, "my_path" },
    { 0xC831CA78, "my_plane" },
    { 0x3D97A4D3, "my_position" },
    { 0x62208609, "my_random_int" },
    { 0x619CBC2E, "my_rider" },
    { 0x8013D722, "my_scene" },
    { 0x0FEDA0A2, "my_sm" },
    { 0xFC04F972, "my_soul_catcher" },
    { 0x5A93691F, "my_sound" },
    { 0x34BDAE0B, "my_speed" },
    { 0x992C9A40, "my_squad" },
    { 0x74406005, "my_target" },
    { 0xC55FE1BA, "my_target_point" },
    { 0x4B19B454, "my_targeting_delta" },
    { 0xCBC64D40, "my_tb_group" },
    { 0xC875CF40, "my_textbrightness_85" },
    { 0x07EACD22, "my_textbrightness_90" },
    { 0x6DCF6B28, "my_textbrightness_default" },
    { 0x576D3A1D, "my_time" },
    { 0x98F6C880, "my_total_damage" },
    { 0xCAF5544E, "my_tree" },
    { 0x547EF388, "my_trig" },
    { 0x332DA75E, "my_trig_hit" },
    { 0x47D52067, "my_vector" },
    { 0xDC62ECEE, "my_vehicle" },
    { 0x3DF26F9F, "my_velocity" },
    { 0x615F7C66, "my_velocity_with_lift" },
    { 0x87515201, "my_wait" },
    { 0x7FC6E232, "my_weapon" },
    { 0x6F5A4FFD, "myalphahigh" },
    { 0x6A2FA429, "myalphalow" },
    { 0x5CEA64BB, "myangles" },
    { 0xFAD7FBF8, "myanim" },
    { 0xAC83AE91, "myanimname" },
    { 0x6C800A53, "myanims" },
    { 0xBD3C1EDA, "myanmar" },
    { 0x8BAE08C9, "myboat" },
    { 0x92CAB120, "mycolor" },
    { 0x066B942D, "mydog2_setup" },
    { 0x2EF3E86B, "mydrone" },
    { 0x1579E269, "myenemy" },
    { 0xCFE48246, "myent" },
    { 0x1EE2971B, "myerror" },
    { 0xA16C4666, "myeye" },
    { 0xD3DEA61F, "myeyeoffset" },
    { 0x591ACCD3, "myfadeintime" },
    { 0x6C0D141D, "myflag" },
    { 0x41BEEB08, "myflashtime" },
    { 0x7739C6AD, "myfunc" },
    { 0x187F9671, "myfx" },
    { 0x009A0E5F, "mygetenemysqdist" },
    { 0x836316DA, "mygoal" },
    { 0x25557804, "mygoalradius" },
    { 0x71B44630, "mygrenadecooldownelapsed" },
    { 0x71BEAD04, "mygroundpos" },
    { 0xEF76A39C, "mygroup" },
    { 0x3EA1DDC3, "mygunpos" },
    { 0x206C7E48, "myguy" },
    { 0xA5987B63, "myguys" },
    { 0x07D7D391, "myhintback" },
    { 0x42F4C79B, "myhintstring" },
    { 0x75200A69, "myindex" },
    { 0xDA068962, "myint" },
    { 0xA5C4988A, "myitem" },
    { 0x85EA8737, "mylength" },
    { 0x9EB12B6D, "myline" },
    { 0x82C009E3, "mylink" },
    { 0x3C3C7CD2, "mylinks" },
    { 0x67781F30, "mylinkto" },
    { 0x64528DF1, "mylookent" },
    { 0xC7671F54, "mymagicbullet" },
    { 0xBEA340E5, "mymapents" },
    { 0x3726EAC6, "mymodel" },
    { 0x3CF6C3B4, "mymove" },
    { 0x0260C6CA, "myname" },
    { 0x501CCA8F, "mynode" },
    { 0x1508E5D8, "mynodeangle" },
    { 0x90057787, "mynodetype" },
    { 0x71D832AC, "mynotify" },
    { 0xFE9D7911, "mynum" },
    { 0x6CB74473, "myorg" },
    { 0x2B88B595, "myorigin" },
    { 0x53A262B8, "myplayer" },
    { 0x66EE7943, "mypos" },
    { 0xC5390EED, "mypost" },
    { 0x1DB53AA5, "myprogressbar" },
    { 0x3A01811E, "myqueuepos" },
    { 0xB06B2351, "myradius" },
    { 0x25C26C6E, "myref" },
    { 0x3444AC71, "myrunanim" },
    { 0x2C41127D, "myself" },
    { 0xD580B938, "mysnd" },
    { 0x686F2395, "myspawner" },
    { 0xF1DC37E8, "myspeed" },
    { 0x3EF406AF, "myspot" },
    { 0x4E1371F6, "myspots" },
    { 0xA9EFD9A4, "mysquadid" },
    { 0x3C894FBF, "mysterious" },
    { 0x867359A4, "mystery" },
    { 0xD2FD4C32, "mystery_box" },
    { 0xB1D64C7A, "mystery_boxes" },
    { 0xD0B1CD80, "mystring" },
    { 0x2948C523, "mytank" },
    { 0x38F68E30, "mytarget" },
    { 0xF6939569, "mytargetname" },
    { 0xA761D1CC, "myteam" },
    { 0xF8CF6C35, "mytextsize" },
    { 0x5D3DB4E4, "mytime" },
    { 0x993E45AE, "mytimer" },
    { 0xDF3BE8F1, "mytrigger" },
    { 0x22F38020, "mytrigs" },
    { 0x2D61F49F, "mytype" },
    { 0xE45AC5F1, "myundefined" },
    { 0x36AD8942, "myvar" },
    { 0x711810B5, "myvehicle" },
    { 0x99684C05, "myvolume" },
    { 0x9DFD6434, "myvsentfovbuffer" },
    { 0x2B9DA968, "mywalk" },
    { 0x955DE4EA, "myweapons" },
    { 0x49F0D317, "myweaponscount" },
    { 0x01328BAF, "myyawfromplayer" },
    { 0xDE5002CD, "myzone" },
    { 0x33B33A4C, "myzones" },
    { 0xB32730FC, "mz" },
    { 0x0B4B92A9, "n" },
    { 0xD29B3EAA, "n_2d_distance_squared" },
    { 0x28E5D02F, "n_aat_index" },
    { 0x18FE791E, "n_aat_turned_zombie_kills" },
    { 0x121CA190, "n_above_head" },
    { 0x9CE70A6F, "n_acc" },
    { 0x2E1EEBFC, "n_accel" },
    { 0xA1CC6C78, "n_accel_time" },
    { 0x0D7A55A8, "n_acceleration" },
    { 0x6DABFFA8, "n_acceleration_base" },
    { 0xDDD7178C, "n_acceleration_time" },
    { 0x7849D76F, "n_acceltime" },
    { 0xDDD07A6E, "n_accumulated" },
    { 0x2F7B5053, "n_accuracy" },
    { 0x6117CC32, "n_active" },
    { 0x2503CCCC, "n_active_links" },
    { 0x897F4B09, "n_active_max" },
    { 0x37838C3F, "n_active_mounds" },
    { 0xF2EB9C0D, "n_active_ragdolls" },
    { 0xCF42E0A0, "n_active_timer" },
    { 0xE9E711FD, "n_adjusted_movement_duration" },
    { 0x981DAA82, "n_aggressivecullradius" },
    { 0xA972BAF6, "n_ahead_dist" },
    { 0x2E3E8126, "n_ai" },
    { 0x9D16F6BA, "n_ai_count" },
    { 0x10995DFD, "n_ai_max" },
    { 0x0E4BB919, "n_ai_rushing" },
    { 0xAF14581B, "n_aim_assist_distance" },
    { 0x4E78CB89, "n_aim_range" },
    { 0x88F706CD, "n_aim_time" },
    { 0xCB0A667E, "n_airspeed_max" },
    { 0x62ADD316, "n_aitype" },
    { 0xDA476226, "n_alert_cooldown" },
    { 0x5B23F2D5, "n_alert_level" },
    { 0xF3016251, "n_alert_remaining_cooldown" },
    { 0x17C602A5, "n_alive_time" },
    { 0x40FEE566, "n_allies" },
    { 0x9552542E, "n_allowed_fights" },
    { 0xBCA1F59B, "n_allowed_z_diff" },
    { 0x25F54188, "n_alpha" },
    { 0x39586F54, "n_alpha_1" },
    { 0xAB5FDE8F, "n_alpha_2" },
    { 0xD32FC1AB, "n_alpha_amount" },
    { 0x4E241F07, "n_alpha_high" },
    { 0xFF73E8D3, "n_alpha_low" },
    { 0x16680B1B, "n_alpha_max" },
    { 0xA4043C45, "n_alpha_max_forced" },
    { 0xE1866581, "n_alpha_none" },
    { 0x7181D4B8, "n_alpha_previous" },
    { 0x6E1E4300, "n_alpha_reset" },
    { 0xC721DF13, "n_alpha_step_size" },
    { 0x6D937805, "n_alt" },
    { 0x01BA4994, "n_alt_weapon" },
    { 0x6BF2EC5E, "n_ammo" },
    { 0x87912A01, "n_ammo_amount" },
    { 0x1BF470CB, "n_ammo_clip" },
    { 0x8BBBD342, "n_ammo_cost" },
    { 0x24D1C37C, "n_ammo_count_current" },
    { 0xFE11ABB9, "n_ammo_count_max" },
    { 0xB567DB0C, "n_ammo_diff" },
    { 0x0BC8B6FA, "n_ammo_give" },
    { 0x5A890987, "n_ammo_giveback" },
    { 0x487FB74B, "n_ammo_less_than_max" },
    { 0x1BA56805, "n_ammo_max" },
    { 0xFD196C54, "n_ammo_refunded" },
    { 0xFD13BB8B, "n_ammo_reserve" },
    { 0x36F016D2, "n_ammo_used" },
    { 0x45E53FB5, "n_ammount" },
    { 0xA8D029B8, "n_amount" },
    { 0xE70C6B6D, "n_amount_scaled" },
    { 0x1E38B896, "n_amp_1" },
    { 0xF8363E2D, "n_amp_2" },
    { 0xD233C3C4, "n_amp_3" },
    { 0xAC31495B, "n_amp_4" },
    { 0xFBD3A8CF, "n_ang_pitch" },
    { 0xF202DDD4, "n_ang_yaw" },
    { 0x933FA84D, "n_angle" },
    { 0x72B2E9E5, "n_angle_diff" },
    { 0x88F4C2CC, "n_angles" },
    { 0x2AE9E58B, "n_anim_count" },
    { 0x292EBBAF, "n_anim_delay" },
    { 0x41A5DD1D, "n_anim_id" },
    { 0xA32B7422, "n_anim_index" },
    { 0xDA5DB022, "n_anim_length" },
    { 0x69A6667F, "n_anim_length1" },
    { 0xF79EF744, "n_anim_length2" },
    { 0x44531090, "n_anim_rate" },
    { 0x0E323776, "n_anim_set" },
    { 0x0427F919, "n_anim_time" },
    { 0xB5148CEF, "n_anim_time_left" },
    { 0xAC3DC270, "n_anim_time_push" },
    { 0x32613E03, "n_animlength" },
    { 0xF15F2959, "n_arg_index" },
    { 0x80AB40DC, "n_argus_id" },
    { 0xBCB27CB6, "n_array_counter" },
    { 0xFC82CEF1, "n_asd_freeze_test" },
    { 0x74CE0AC0, "n_attached" },
    { 0x896E8574, "n_attack_limit" },
    { 0xA532888F, "n_attractors" },
    { 0xD9BFB82C, "n_audiolog_id" },
    { 0x86F3B68A, "n_av_models" },
    { 0x5B72A44C, "n_available_index" },
    { 0xC94E6802, "n_avenger_count" },
    { 0x3EC45921, "n_avengers" },
    { 0xE2F413BA, "n_avengers_active" },
    { 0x76DD4FF3, "n_avengers_ideal" },
    { 0xCFF2B09D, "n_award_challenge" },
    { 0xC13F1308, "n_axe_pickup_distance_max" },
    { 0x67F03BEF, "n_axis" },
    { 0x7A5104F6, "n_b" },
    { 0xD9955B28, "n_barrel" },
    { 0xE11894D4, "n_barriers_rebuilt" },
    { 0x459DD265, "n_base_damage" },
    { 0xC93DCD6B, "n_base_height" },
    { 0x280F1C8E, "n_base_non_wallbuy_cost" },
    { 0xF0EE45C9, "n_base_value" },
    { 0xA60C0EBE, "n_base_weapon" },
    { 0x0B05B8C5, "n_baseindex" },
    { 0x1383869B, "n_battleship_length" },
    { 0xC2481B85, "n_bdogs_killed" },
    { 0x8F70923A, "n_beartrap_index" },
    { 0x4D295EBF, "n_best_target_index" },
    { 0xA7930833, "n_between_round_time" },
    { 0x7E03D6A7, "n_bgb_cost" },
    { 0x57DC6776, "n_bgb_uimodel_cancel" },
    { 0xCC922A39, "n_bgb_uimodel_purchase" },
    { 0x8D4F5F7E, "n_bink_id" },
    { 0x30BD916E, "n_bink_id_1" },
    { 0x0ABB1705, "n_bink_id_2" },
    { 0x35C45034, "n_bink_id_virus_1" },
    { 0xA7CBBF6F, "n_bink_id_virus_2" },
    { 0x69BD6F0D, "n_birth_time" },
    { 0x7527C9BC, "n_bits" },
    { 0x14387244, "n_black_screen" },
    { 0x67FC1A58, "n_blacken" },
    { 0x27C975EC, "n_bleedout_time" },
    { 0x03FA4EB6, "n_bleedout_time_multiplier" },
    { 0x2A9E4785, "n_blend" },
    { 0x2BB94F9C, "n_blend_amount" },
    { 0x187B51A5, "n_blend_in" },
    { 0x46061024, "n_blend_out" },
    { 0x88B82CD3, "n_blend_time" },
    { 0xA66AD8F6, "n_blend_time_to_idle" },
    { 0xA97A56AF, "n_blink_rate" },
    { 0xF65E32C1, "n_blinks" },
    { 0xD7861B3F, "n_blood_amount" },
    { 0x708865B7, "n_blood_dist" },
    { 0xE423CB92, "n_blood_dist_inverse" },
    { 0xF4120B38, "n_blood_dist_max" },
    { 0xDF7EE245, "n_blood_hits" },
    { 0xE144C878, "n_blue" },
    { 0x8B2E7AC7, "n_blur" },
    { 0xB5D0610D, "n_blur_time" },
    { 0xF7DA0EE7, "n_blur_val" },
    { 0x0E1E06C8, "n_body_id" },
    { 0x410CBFFD, "n_bottom" },
    { 0xDC0C47E0, "n_bottom_arc" },
    { 0xD0EF9002, "n_boxes_filled" },
    { 0xC00969BB, "n_bp1_veh_destroyed" },
    { 0xD343F6D9, "n_bp1_vehicles" },
    { 0xAAC0D0F6, "n_bp1wave1_soviet_killed" },
    { 0xC1FB5F6D, "n_bp1wave3_boss" },
    { 0xC56FAA5B, "n_bp1wave3_veh_destroyed" },
    { 0x449B07B9, "n_bp1wave3_vehicles" },
    { 0xC867ACDC, "n_bp1wave4_boss" },
    { 0x596697F4, "n_bp1wave4_vehicles" },
    { 0xB126E514, "n_bp2_mortar_destroyed" },
    { 0x92ED148C, "n_bp2_veh_destroyed" },
    { 0xFBAFA1C7, "n_bp2wave4_boss" },
    { 0x101B7717, "n_bp2wave4_vehicles" },
    { 0x228FB576, "n_bp3_bridges" },
    { 0x73F74504, "n_bp3_muj_killed" },
    { 0x1AD7B4D6, "n_bp3_soviet_killed" },
    { 0x6808DA39, "n_bp3_veh_destroyed" },
    { 0xB9E4750E, "n_bp3wave4_boss" },
    { 0xFD1825FA, "n_bp3wave4_vehicles" },
    { 0x43F4CDCD, "n_brainwash_count" },
    { 0xC837DAC6, "n_brake_anim_length" },
    { 0x8EA4449D, "n_brake_frames_max" },
    { 0xCC084FB3, "n_brake_frames_min" },
    { 0xE0B55374, "n_brake_time_max" },
    { 0x0B475EBA, "n_brake_time_min" },
    { 0x3361F24F, "n_break_left" },
    { 0x451EC723, "n_break_middle" },
    { 0xA810542A, "n_break_right" },
    { 0x3FECC333, "n_bridge_brutuses_killed" },
    { 0xE2824BDD, "n_briggs_anim_length" },
    { 0x662D8267, "n_brutus_damage_percent" },
    { 0xA6512258, "n_brutus_headshot_modifier" },
    { 0x37880853, "n_brutuses_on_bridge_count" },
    { 0xDA06DBF4, "n_bryce_cake" },
    { 0xB71BA8A9, "n_buffel_x" },
    { 0x91192E40, "n_buffel_y" },
    { 0x4381714D, "n_bulb_tint_all_off" },
    { 0x4B77AB61, "n_bulb_tint_all_on" },
    { 0xD7D16794, "n_bulb_tint_one_off" },
    { 0xB28EF5E6, "n_bulb_tint_two_off" },
    { 0xD6B3C91C, "n_bullet_damage" },
    { 0xD2BF8BEE, "n_bulletpowerloss" },
    { 0xE6882287, "n_bullets" },
    { 0xDB8D628F, "n_bullets_refunded" },
    { 0x119042DD, "n_bullets_used" },
    { 0x84350E76, "n_buoyancy" },
    { 0x6F41EDC1, "n_burn_time" },
    { 0xE0E30096, "n_burst" },
    { 0xECF5040A, "n_burst_count" },
    { 0x06D90F91, "n_burst_count_max" },
    { 0x71D684EF, "n_burst_count_min" },
    { 0x450E4402, "n_burst_damage" },
    { 0x6AF1EFE9, "n_burst_delay_max" },
    { 0x88618497, "n_burst_delay_min" },
    { 0x88EB1F56, "n_burst_fire_max" },
    { 0x6DF5F3A8, "n_burst_fire_min" },
    { 0x5F00B9DF, "n_burst_fire_time" },
    { 0x72652412, "n_burst_time" },
    { 0x4B551A6A, "n_burst_wait" },
    { 0xDFDDE331, "n_burst_wait_max" },
    { 0x4D55C18F, "n_burst_wait_min" },
    { 0xE09FFB17, "n_burstcountmax" },
    { 0xC3306669, "n_burstcountmin" },
    { 0xD59B0BCC, "n_burstpowerloss" },
    { 0x54E07E09, "n_bursts" },
    { 0x526761F2, "n_bursts_total" },
    { 0x9DB25102, "n_burstwaittime" },
    { 0x5BF47702, "n_bus_event_success_wait_max" },
    { 0xF67BFF9F, "n_cache_health" },
    { 0x21A70CE1, "n_callout_index" },
    { 0x69065BA9, "n_camera_tween" },
    { 0x1D1F5F18, "n_camera_tween_out" },
    { 0xB6A8220D, "n_camerapitch" },
    { 0xFC3C6E0A, "n_camo_aigroup_size" },
    { 0xEC4DB586, "n_camo_kills" },
    { 0xCAD6FFDF, "n_capture_zombie_points" },
    { 0xE705192A, "n_capture_zombie_spawns" },
    { 0xE587E522, "n_capture_zombies_needed" },
    { 0x09D31ED7, "n_capture_zombies_needed_per_zone" },
    { 0xDF02F4B3, "n_cf_val" },
    { 0xABFCCCE1, "n_chaff_max" },
    { 0x84F29F11, "n_chaff_scale" },
    { 0xACFACB5E, "n_chaff_time" },
    { 0x64E4415E, "n_chairs_wait" },
    { 0x501607D3, "n_challenge_games_played" },
    { 0xA3E0F446, "n_challenge_index" },
    { 0x4F6A936E, "n_challenge_start_time" },
    { 0x3584C667, "n_challenge_time_ingame" },
    { 0xB9B4B136, "n_chamber_wall_active" },
    { 0x10FCB680, "n_chance" },
    { 0x5C801785, "n_chance_ammo" },
    { 0xFEBFE87A, "n_chance_points" },
    { 0xCDA6AC4E, "n_chance_stink" },
    { 0xC7518B5C, "n_change" },
    { 0xC26D94DA, "n_change_per_frame" },
    { 0xBFDA8BA4, "n_change_per_update" },
    { 0xE08BDAB9, "n_change_rate" },
    { 0x9C27EC02, "n_change_speed_timer" },
    { 0x3D38182D, "n_change_this_frame" },
    { 0x041718F9, "n_change_wall_time" },
    { 0x9040A059, "n_char_index" },
    { 0x29EE5768, "n_character_index" },
    { 0x266DA916, "n_characters_defined" },
    { 0x4140BFB0, "n_charge" },
    { 0x311057AF, "n_charge_anim_length" },
    { 0x2609AF7F, "n_charge_level" },
    { 0x638487F4, "n_charge_time" },
    { 0x453B1A80, "n_charge_time_full" },
    { 0x9780EB62, "n_chargelevel" },
    { 0xBBBB721B, "n_charges" },
    { 0x0F8E63A0, "n_check_time" },
    { 0xAE68034B, "n_check_times" },
    { 0xDDC6F2FA, "n_cin_id" },
    { 0xE8D008A5, "n_cipher_offset" },
    { 0x70F872D1, "n_ciphered_letter" },
    { 0x862A3469, "n_circling" },
    { 0xB95FA1BB, "n_civilians_can_be_saved" },
    { 0x1EA8328A, "n_civilians_saved" },
    { 0xCDE077C5, "n_claimed_center" },
    { 0x70ADBF5D, "n_claimed_left" },
    { 0x2D92B940, "n_claimed_right" },
    { 0x3E87E125, "n_clamp_bottom" },
    { 0x3D420807, "n_clamp_left" },
    { 0x6D8CCE82, "n_clamp_right" },
    { 0x66AE145D, "n_clamp_top" },
    { 0xAF2CF132, "n_claw_fire_kills" },
    { 0xF55581F9, "n_cleanup_age_min" },
    { 0x29DDC94C, "n_cleanup_age_timeout" },
    { 0x732A77D2, "n_cleanup_dist_sq" },
    { 0x00315597, "n_cleanup_dist_sq_min" },
    { 0xCDB4BFF2, "n_cleanup_dist_sq_min_aggressive" },
    { 0xB9B9C035, "n_cleanup_dist_sq_round_end" },
    { 0x5D726451, "n_cleanup_evals_per_frame_max" },
    { 0x8E427990, "n_cleanup_fov_cos" },
    { 0x2BF4CA45, "n_cleanup_interval_min" },
    { 0x8256DF54, "n_cleanup_manager_restart_time" },
    { 0x4D836853, "n_cleanups_processed_this_frame" },
    { 0xA7DC2DC9, "n_client" },
    { 0x3FB6E21A, "n_client_flag" },
    { 0x80BEA535, "n_clientbits" },
    { 0x68B874B7, "n_clientfield" },
    { 0x17F90D17, "n_clientfield_val" },
    { 0xAB4B3766, "n_clip" },
    { 0x5CE6D9E8, "n_clip_current" },
    { 0x2030053D, "n_clip_max" },
    { 0xC316EA9A, "n_clip_size" },
    { 0x8C73C81E, "n_close_offset" },
    { 0x2D3BE1DF, "n_close_time_max" },
    { 0x296B5CD0, "n_closest_dist" },
    { 0x1D0DE873, "n_closest_dist_sq" },
    { 0x184AB935, "n_closest_dot" },
    { 0x628CACA3, "n_code" },
    { 0x371F8487, "n_coke_origin" },
    { 0x0CE81E91, "n_color" },
    { 0x9165CF87, "n_complete_time" },
    { 0x48707D47, "n_completed" },
    { 0x9B8415DE, "n_completed_trips" },
    { 0xEDCDB612, "n_contrast" },
    { 0xB2BA3568, "n_contrast_increment" },
    { 0xCAA43A4C, "n_contrast_increment_time" },
    { 0xCF47B2B8, "n_contrast_transition_time" },
    { 0xDFA17482, "n_convert_from_seconds" },
    { 0xA06B845B, "n_convoy_health" },
    { 0xFF9D6A30, "n_cookedtime" },
    { 0x4753F602, "n_cooldown_ms" },
    { 0x6C72543D, "n_cooldown_time" },
    { 0xC82F6665, "n_cooldown_timer" },
    { 0xB2755F01, "n_corpses_to_delete" },
    { 0x84C76EB6, "n_correct" },
    { 0xB6549A33, "n_cos_player_fov" },
    { 0xAAAB70DB, "n_cost" },
    { 0xA7E254C4, "n_cougar_origin" },
    { 0x03E671A1, "n_count" },
    { 0x4E19FE4E, "n_count_allies" },
    { 0x252FDD47, "n_count_axis" },
    { 0x204C0C5C, "n_count_per_network_frame" },
    { 0x79FB99D5, "n_countdown" },
    { 0x6F40E488, "n_counter" },
    { 0x958ADE1B, "n_counter_max" },
    { 0x464F5528, "n_counter_threshold" },
    { 0xE3701D8B, "n_crane" },
    { 0xEC26F890, "n_crash_duration" },
    { 0x28C01B1F, "n_crystals_pickedup" },
    { 0x6C323C3C, "n_cur_height" },
    { 0xC3AC1F4F, "n_cur_leg" },
    { 0x25D3F3A5, "n_cur_pitch" },
    { 0x68FB7869, "n_cur_scale" },
    { 0xF96C8999, "n_cur_second" },
    { 0xB4ADA9BA, "n_curr_obj" },
    { 0x001E00C9, "n_curr_sp_civ" },
    { 0xEA2003D9, "n_curr_step" },
    { 0x189B3218, "n_curr_val" },
    { 0x4CF5CDF3, "n_current" },
    { 0x04E609D9, "n_current_anim" },
    { 0x3411368A, "n_current_dist" },
    { 0x433FF793, "n_current_distance" },
    { 0xCFAC9039, "n_current_exposure" },
    { 0xDA76FDCF, "n_current_flags" },
    { 0xEDA40C90, "n_current_health" },
    { 0x627CF50C, "n_current_heat" },
    { 0x907901E8, "n_current_line" },
    { 0x92F5C2E5, "n_current_obj" },
    { 0x69FD3882, "n_current_path_index" },
    { 0x31B4FC98, "n_current_pitch" },
    { 0x2EFEEE1F, "n_current_progress" },
    { 0xE1CDDA47, "n_current_speed" },
    { 0x60852CD2, "n_current_strafing_wave" },
    { 0xCC296C01, "n_current_time" },
    { 0xB55D3040, "n_current_time_ms" },
    { 0x42603CD8, "n_current_tube" },
    { 0x52A0EBA1, "n_current_wave" },
    { 0x6E3FB8E7, "n_currtime" },
    { 0xD5FBAA8D, "n_curtime" },
    { 0x34E307F4, "n_custom_index" },
    { 0x0FA7A494, "n_cutoff_ammo" },
    { 0xA56841A7, "n_cutoff_points" },
    { 0x18763F91, "n_cycles" },
    { 0x74D0774F, "n_damage" },
    { 0x82EF9527, "n_damage_1" },
    { 0x10E825EC, "n_damage_2" },
    { 0x36EAA055, "n_damage_3" },
    { 0x00C776F4, "n_damage_amt" },
    { 0xE5775FB6, "n_damage_before_trigger" },
    { 0xCCA27CD2, "n_damage_cap" },
    { 0xA1B019C7, "n_damage_closest" },
    { 0xA0D94DFB, "n_damage_farthest" },
    { 0xE9A83A8E, "n_damage_frac" },
    { 0x7BBF2FB7, "n_damage_frac_cap" },
    { 0xEE17AEC9, "n_damage_frac_kill_1" },
    { 0x141A2932, "n_damage_frac_kill_2" },
    { 0x3A1CA39B, "n_damage_frac_kill_3" },
    { 0x601F1E04, "n_damage_frac_kill_4" },
    { 0xFBDACB94, "n_damage_level" },
    { 0x6ECC72A0, "n_damage_max" },
    { 0x1BF503DE, "n_damage_min" },
    { 0x52773B5D, "n_damage_needed" },
    { 0x6040A358, "n_damage_origin" },
    { 0x1A444565, "n_damage_per_pulse" },
    { 0xC4C62085, "n_damage_per_sec" },
    { 0x9C5671C4, "n_damage_radius" },
    { 0xB42A0A97, "n_damage_radius_sq" },
    { 0xB0A541CB, "n_damage_threshold" },
    { 0x6AA3F504, "n_damage_times" },
    { 0x50E19896, "n_damage_to_change_state" },
    { 0x9B41D770, "n_damage_total" },
    { 0xDFB28A5A, "n_damage_type" },
    { 0xF16193D7, "n_data_stream_speed" },
    { 0x74476BEE, "n_dc_barriers_rebuilt" },
    { 0xCA192165, "n_death_anim_dist" },
    { 0xE4E6E8AC, "n_death_blossom_cooldown" },
    { 0x99265DAF, "n_death_blossom_cooldown_ms" },
    { 0x5490BA83, "n_death_blossom_time_last" },
    { 0x736D7757, "n_death_fx" },
    { 0x9D9574FD, "n_deaths" },
    { 0x44C0A952, "n_debug_display_count" },
    { 0x928A307C, "n_dec" },
    { 0xD8B57BE5, "n_decay_button_held" },
    { 0x054ADAAF, "n_decay_not_pressed" },
    { 0xDFC49688, "n_decceleration" },
    { 0x1FBFF2A7, "n_decel" },
    { 0x61DBAEB4, "n_deceltime" },
    { 0x9C0ED2EA, "n_decoration_count" },
    { 0xC0856107, "n_decrement" },
    { 0x21B36F46, "n_default_bleedout_time" },
    { 0xD3845717, "n_default_fov" },
    { 0xFB299B95, "n_default_last_stand_pistol_value" },
    { 0xBF018FD4, "n_default_shock_effect" },
    { 0x2B6C4BA5, "n_default_wait" },
    { 0x418E8F74, "n_degree" },
    { 0xAEDA699E, "n_degrees_from_center" },
    { 0xEE7DBBC9, "n_delay" },
    { 0x0874A4EF, "n_delay_before_movement" },
    { 0xC2F5C3D6, "n_delay_between_fake_shots" },
    { 0xCFC51C56, "n_delay_max" },
    { 0xB4CFF0A8, "n_delay_min" },
    { 0x683EA5D4, "n_delay_wave_2" },
    { 0x02AF725C, "n_delete_counter" },
    { 0xCFBD1E2D, "n_delete_delay" },
    { 0xB98DFD51, "n_delete_distance" },
    { 0x2081DCF1, "n_delete_height" },
    { 0xA668D6E3, "n_delete_wait" },
    { 0x80BA6B34, "n_delete_wait_max" },
    { 0xC7B84307, "n_delete_wait_max_ms" },
    { 0x9135DE66, "n_delete_wait_ms" },
    { 0xB91AF423, "n_deleted" },
    { 0x3F45151C, "n_deletes" },
    { 0xDB025BB6, "n_delta" },
    { 0xA63755F2, "n_delta_time" },
    { 0xAF412D0A, "n_delta_val" },
    { 0x727EEEC4, "n_denominator" },
    { 0x689BE0DB, "n_depth" },
    { 0x9294CE0E, "n_desired_spawn_count" },
    { 0xC44EF410, "n_dest" },
    { 0xF215083E, "n_dest_height" },
    { 0x31D360DC, "n_destination" },
    { 0x010F44B5, "n_destroyed" },
    { 0xEE0FEC16, "n_detect_radius" },
    { 0xD22B6922, "n_detector_count" },
    { 0x6AEE7FE9, "n_dflags" },
    { 0xF0A00FEA, "n_diff_scale" },
    { 0x46D53376, "n_difference_in_score" },
    { 0x62111087, "n_different_boats" },
    { 0xCA84B44F, "n_difficulty" },
    { 0x270D6825, "n_dig_spots_cur" },
    { 0x59FF1FB1, "n_dig_spots_max" },
    { 0x982815DA, "n_display_time" },
    { 0xC7C18751, "n_dissolve" },
    { 0xCCD4343C, "n_dist" },
    { 0xA71E78EB, "n_dist_between_player" },
    { 0xFD6B1CE0, "n_dist_clamp" },
    { 0xF41CF130, "n_dist_closest" },
    { 0x5A0DC6EA, "n_dist_current" },
    { 0xF09A7637, "n_dist_defend" },
    { 0x24A64EAA, "n_dist_diff" },
    { 0x33084DFE, "n_dist_for_path" },
    { 0x38D4AE07, "n_dist_frac" },
    { 0x168261B1, "n_dist_from_beartrap" },
    { 0xD66A07E7, "n_dist_horizontal" },
    { 0x49B8A3FA, "n_dist_in_front" },
    { 0x17888AE7, "n_dist_invert" },
    { 0x065EA83D, "n_dist_lowest" },
    { 0xED52CACF, "n_dist_max" },
    { 0xA3D56D14, "n_dist_max_for_warp" },
    { 0x2FBD5B36, "n_dist_max_sq" },
    { 0x7FDAEC71, "n_dist_min" },
    { 0x44D52EEC, "n_dist_min_sq" },
    { 0xA7AAF941, "n_dist_mult" },
    { 0x28C34CCC, "n_dist_normalized" },
    { 0xC5FE8243, "n_dist_other" },
    { 0xF212A55A, "n_dist_percent" },
    { 0xC4D50054, "n_dist_player" },
    { 0x36B8634F, "n_dist_sq" },
    { 0xBC7CF10A, "n_dist_sq_between" },
    { 0x953CA4C8, "n_dist_sq_longest" },
    { 0x9F6FAFDE, "n_dist_sq_min" },
    { 0x95DF5151, "n_dist_sq_range" },
    { 0x1CC952F6, "n_dist_squared" },
    { 0xDA9610BE, "n_dist_tank_min" },
    { 0xE9DAB90A, "n_dist_to_menendez_max" },
    { 0x6CC5FB14, "n_dist_to_menendez_min" },
    { 0x457A4D4F, "n_dist_to_menendez_range" },
    { 0xA9CD2CA0, "n_dist_to_target" },
    { 0xDCFD5BA8, "n_dist_to_v_right" },
    { 0x6C9D6A96, "n_dist_too_close" },
    { 0x4EF52AF9, "n_dist_too_far" },
    { 0x65BFEF95, "n_dist_vertical" },
    { 0x2D4F8FF9, "n_dist_warning" },
    { 0x6389AB3D, "n_distance" },
    { 0xDEF04F89, "n_distance_1" },
    { 0x04F2C9F2, "n_distance_2" },
    { 0xBB768749, "n_distance_2nd_warning_message" },
    { 0xF0DCB2EF, "n_distance_2nd_warning_time" },
    { 0x2AF5445B, "n_distance_3" },
    { 0xFE552D90, "n_distance_3rd_warning_message" },
    { 0xC58C8370, "n_distance_3rd_warning_time" },
    { 0xF5E0833F, "n_distance_after_frames" },
    { 0xD8B7AD59, "n_distance_auto_delete" },
    { 0xB4162514, "n_distance_auto_delete_sq" },
    { 0xD554F7E4, "n_distance_behind" },
    { 0x531F7EB9, "n_distance_closest" },
    { 0x305F90CF, "n_distance_current" },
    { 0xA6ED5D36, "n_distance_current_sq" },
    { 0x679686BF, "n_distance_explode" },
    { 0x49799426, "n_distance_explode_sq" },
    { 0x095779AC, "n_distance_fail_checkpoint_helper" },
    { 0x1BFAC935, "n_distance_farthest" },
    { 0xD1C6A6D1, "n_distance_for_guns" },
    { 0x1AE0DE8C, "n_distance_for_guns_sq" },
    { 0x0ED9FE43, "n_distance_for_missiles" },
    { 0xBFBA7054, "n_distance_for_missiles_max" },
    { 0x9E7E8C27, "n_distance_for_missiles_max_sq" },
    { 0x9836A1DA, "n_distance_for_missiles_sq" },
    { 0x4DC98A94, "n_distance_from_last_max" },
    { 0x85C91467, "n_distance_from_last_max_sq" },
    { 0x5AD9541A, "n_distance_from_last_sq" },
    { 0x79C0B1CD, "n_distance_from_spotlight" },
    { 0x9BA63279, "n_distance_goal" },
    { 0x8028958F, "n_distance_ideal" },
    { 0xFB2CAFF6, "n_distance_ideal_sq" },
    { 0x3ACAA798, "n_distance_left_to_stop" },
    { 0xAF50563A, "n_distance_max" },
    { 0xC042F1F9, "n_distance_max_sq" },
    { 0x54AF6F01, "n_distance_moved" },
    { 0xB7705509, "n_distance_offset" },
    { 0xCA9CD559, "n_distance_ok_to_spawn_guys" },
    { 0xC3493F8D, "n_distance_ok_to_spawn_heli" },
    { 0x1DBD7B3F, "n_distance_range" },
    { 0x39192389, "n_distance_recover_time_allowed" },
    { 0x60051816, "n_distance_scale" },
    { 0xBC290021, "n_distance_side" },
    { 0x8B2E2838, "n_distance_side_bottom_addition" },
    { 0x6E4DFFE8, "n_distance_sq" },
    { 0x37B9411A, "n_distance_sqr" },
    { 0x7F4006E3, "n_distance_squared" },
    { 0x5B250039, "n_distance_threshold" },
    { 0x3B96142C, "n_distance_to_bus" },
    { 0x6C9037CA, "n_distance_to_cover_sq" },
    { 0xD9F11B10, "n_distance_to_fallback" },
    { 0x4DFF5EB3, "n_distance_to_fallback_sq" },
    { 0x27B402B7, "n_distance_to_ground" },
    { 0x95BE5C9A, "n_distance_to_next_max" },
    { 0x657F5D19, "n_distance_to_next_max_sq" },
    { 0xA8C77F51, "n_distance_to_player" },
    { 0x9BADF0F3, "n_distance_to_red" },
    { 0x74E586E9, "n_distance_to_target" },
    { 0x3A19B387, "n_distance_to_threshold" },
    { 0xE2735294, "n_distance_warning" },
    { 0xEF6A2B1B, "n_distance_warning_percentage" },
    { 0xB39B8B57, "n_distance_warning_start_time" },
    { 0x4CB4DE80, "n_disttoplayersq" },
    { 0x7391AFF0, "n_dmg" },
    { 0xA2BA9865, "n_door_close_delay" },
    { 0x9788E274, "n_door_closes" },
    { 0x0813106E, "n_door_connect_paths" },
    { 0x88E3572D, "n_door_index" },
    { 0xC0DBD2B9, "n_door_move_accel" },
    { 0x4C816DEE, "n_door_move_decel" },
    { 0x74ACF97C, "n_door_move_time" },
    { 0x82A044F1, "n_dot" },
    { 0x84CCC8FE, "n_dot_best" },
    { 0x72587DDC, "n_dot_check" },
    { 0xC489CB0E, "n_dot_directions" },
    { 0x4C73C969, "n_dot_forward_view" },
    { 0x06C47AF1, "n_dot_front" },
    { 0x8EE628CE, "n_dot_max" },
    { 0xE1BD9790, "n_dot_min" },
    { 0xFE0AAD23, "n_dot_player" },
    { 0xCC9FF513, "n_dot_range" },
    { 0x4A0B59F3, "n_dot_ref" },
    { 0x1D8096F2, "n_dot_right" },
    { 0x2AEEB6DA, "n_dot_self" },
    { 0x161E97F4, "n_dot_to_boat" },
    { 0xB94842F3, "n_dot_to_drones" },
    { 0x20595352, "n_dot_to_heli" },
    { 0xBB9E4860, "n_dot_to_interact" },
    { 0x2D272D05, "n_dot_to_player" },
    { 0x1AB6E9B1, "n_dot_to_struct" },
    { 0xD6F743E9, "n_dot_tolerance" },
    { 0x834CFEF3, "n_dot_up" },
    { 0x66713ACC, "n_dpad_right" },
    { 0xCD4D8559, "n_dpad_up" },
    { 0xE110319A, "n_drone" },
    { 0xDA190CA4, "n_drone_immediate_speed" },
    { 0x57349EC6, "n_drone_wave" },
    { 0x23849E99, "n_drones_available" },
    { 0xA53832B5, "n_drones_count" },
    { 0xD574CCC6, "n_drones_total" },
    { 0x02A59841, "n_drop_from_gravity" },
    { 0xA943EED7, "n_drop_speed" },
    { 0x71A9040E, "n_drop_speed_before_fail" },
    { 0x14DD2C4C, "n_drop_this_frame" },
    { 0x4CA335D1, "n_drop_time" },
    { 0x99D6D9BC, "n_dryer_cycle_duration" },
    { 0xF05509E4, "n_duration" },
    { 0xC9985587, "n_duration_max" },
    { 0xEB63B597, "n_duration_ms" },
    { 0x608D58E3, "n_dvar" },
    { 0x6718954E, "n_dynents_index" },
    { 0xF36CE2BA, "n_earthquake_duration" },
    { 0x1A7F1F34, "n_earthquake_duration_catastrophic" },
    { 0xF06D53E8, "n_earthquake_duration_major" },
    { 0xD2AEDDEC, "n_earthquake_duration_minor" },
    { 0xC5447104, "n_earthquake_magnitude" },
    { 0x39A2071E, "n_earthquake_scale_catastrophic" },
    { 0x670A61C6, "n_earthquake_scale_major" },
    { 0xC462A3EA, "n_earthquake_scale_minor" },
    { 0xCDF7DD02, "n_eating_anim" },
    { 0x65B9544F, "n_ee_medallions" },
    { 0xCAD4B3AA, "n_ee_portal_souls" },
    { 0x1D9D8A6E, "n_ee_punch_souls" },
    { 0x5EC263FE, "n_ee_robot_staffs_planted" },
    { 0x102FA6CF, "n_ee_step" },
    { 0xCA75BEC1, "n_effects_duration" },
    { 0x7CC047FA, "n_effects_wait_1" },
    { 0x56BDCD91, "n_effects_wait_2" },
    { 0x30BB5328, "n_effects_wait_3" },
    { 0x3ACCAC07, "n_effects_wait_4" },
    { 0x956C65B3, "n_eject_offset" },
    { 0xF48065FD, "n_elem" },
    { 0xDF79D9D7, "n_elem_prev" },
    { 0xB5F6F4E4, "n_element" },
    { 0x5D35229C, "n_element_enum" },
    { 0x6C0518CD, "n_element_index" },
    { 0x0CA44CBD, "n_elemental_round_fx_id" },
    { 0x50F8CB29, "n_elevator_drop_duration" },
    { 0x948F352E, "n_elevator_number" },
    { 0xE0D83045, "n_emp_duration" },
    { 0x60512635, "n_emp_filter_intensity" },
    { 0x77D40FDB, "n_end" },
    { 0xB669EEB0, "n_end_anim_length" },
    { 0xB6445B43, "n_end_limit" },
    { 0x2EE0B423, "n_end_pct" },
    { 0xB864A890, "n_end_pitch" },
    { 0xACCBAB09, "n_end_time" },
    { 0x0B85BF73, "n_end_val" },
    { 0xA8A7DE70, "n_endtime" },
    { 0xF340B259, "n_enemies_attracted" },
    { 0x936A575A, "n_enemies_deleted" },
    { 0x8CE578A7, "n_enemies_max" },
    { 0xBE8FC8DE, "n_enemies_to_delete" },
    { 0xB0A4A6D0, "n_enemy_detect_dist_sq" },
    { 0xDAF0E08E, "n_enemy_encounter" },
    { 0xDEB3C61E, "n_enemy_end" },
    { 0x4D0AFA1C, "n_enemy_numerator" },
    { 0x6F5CE28D, "n_enemy_start" },
    { 0xE44CC719, "n_enemy_t" },
    { 0x19852D1E, "n_ent_num" },
    { 0xB298E01C, "n_ent_pool_size" },
    { 0x809D8027, "n_entitynum" },
    { 0x3B62DEA5, "n_entnum" },
    { 0xABB52853, "n_enum" },
    { 0x035767A9, "n_escape_distance" },
    { 0xE8D1A696, "n_estimate_metro_height" },
    { 0x0A0FD816, "n_executioners" },
    { 0x40C04FC3, "n_exploder" },
    { 0xB1AC3EC5, "n_exploder_id" },
    { 0xD3F992DA, "n_exploder_index" },
    { 0xC1991B6E, "n_explosion_magnitude" },
    { 0xB5CE7131, "n_explosionpowerloss" },
    { 0x543513DB, "n_exposure" },
    { 0xA30B38DC, "n_exposure_change_per_frame" },
    { 0x7D99FD11, "n_exposure_change_total" },
    { 0x9ACFEE89, "n_exposure_current" },
    { 0x0528752D, "n_exposure_default" },
    { 0x809F3E4A, "n_exposure_final" },
    { 0x630E2D13, "n_extra_ai" },
    { 0x5F586507, "n_extra_tokens" },
    { 0x2440CFCA, "n_extra_veh" },
    { 0xDD328129, "n_f35_dist" },
    { 0xFEC74335, "n_facial_recognition_time_start" },
    { 0xABDC4F00, "n_facing_diff" },
    { 0x12694A90, "n_facing_offset" },
    { 0x18F7C986, "n_fade" },
    { 0x1F5CEF16, "n_fade_blur" },
    { 0xA42BC190, "n_fade_out_step" },
    { 0x7B473F29, "n_fade_out_time" },
    { 0xC697186F, "n_fade_radius" },
    { 0xCAADAEE2, "n_fade_time" },
    { 0x65A9EEBD, "n_fadein_time" },
    { 0xBF9583E6, "n_fadeout_time" },
    { 0xD26D25E8, "n_fail_delay" },
    { 0x44006C6B, "n_fail_dist" },
    { 0x3440FBA6, "n_fail_distance" },
    { 0x3FCC7F60, "n_fail_speed" },
    { 0xE83B2889, "n_fail_time_start" },
    { 0x91FB38E8, "n_faildist" },
    { 0xB969AD13, "n_fall_death_length" },
    { 0xEA823ED6, "n_fall_dist" },
    { 0xA28EF885, "n_fall_time" },
    { 0x0006FA6F, "n_fallback_num" },
    { 0x3A8C675D, "n_far_blur" },
    { 0x614F89AF, "n_far_blur_current" },
    { 0xC6648896, "n_far_blur_step" },
    { 0xD0F0659B, "n_far_blur_to" },
    { 0x3DF90301, "n_far_end" },
    { 0xBF32E94B, "n_far_end_current" },
    { 0x1932C3FA, "n_far_end_step" },
    { 0x2F6CEFDF, "n_far_end_to" },
    { 0x235439C3, "n_far_rush_chance" },
    { 0x127E048A, "n_far_start" },
    { 0x7BDEAD64, "n_far_start_current" },
    { 0x52C06713, "n_far_start_step" },
    { 0x81EEA8CA, "n_far_start_to" },
    { 0x61C71098, "n_farthest_index" },
    { 0x34AA2DEC, "n_fearless_start" },
    { 0xDC2CE7B9, "n_feedback_delay_catastrophic" },
    { 0xAED6A42B, "n_feedback_delay_major" },
    { 0x78DA5BE7, "n_feedback_delay_minor" },
    { 0x64CC3FB4, "n_female_index_body" },
    { 0x46DAA9F6, "n_female_index_head" },
    { 0xD830E610, "n_female_num_bodies" },
    { 0x751F2481, "n_female_num_heads" },
    { 0xC2BF3D58, "n_fh_dist_from_player" },
    { 0xAE90586C, "n_fh_range" },
    { 0xA174A43B, "n_fight_counter" },
    { 0x5DED4C4F, "n_fill_count" },
    { 0x3D509DC2, "n_filter_id" },
    { 0x9F000088, "n_filter_id_droplets" },
    { 0x15433F1A, "n_filter_id_splats" },
    { 0xA2E0A063, "n_filter_index" },
    { 0x3C25C1A1, "n_find_menendez_start_time" },
    { 0xACD8BFA3, "n_fire_count_down" },
    { 0x0013CFD8, "n_fire_delay" },
    { 0x4B01992D, "n_fire_direction_kill_count" },
    { 0xD8504BEB, "n_fire_max" },
    { 0xADBE40A5, "n_fire_min" },
    { 0xEF84E919, "n_fire_num" },
    { 0xEB200A5C, "n_fire_time" },
    { 0x53D97BD8, "n_fire_time_bullet_max" },
    { 0x6ECEA786, "n_fire_time_bullet_min" },
    { 0xD427299A, "n_fire_time_missile_max" },
    { 0x993D8784, "n_fire_time_missile_min" },
    { 0x80E40D54, "n_fire_wait_bullet_max" },
    { 0xAB76189A, "n_fire_wait_bullet_min" },
    { 0x19F8C68E, "n_fire_wait_missile_max" },
    { 0x6CD03550, "n_fire_wait_missile_min" },
    { 0x07931611, "n_fireball_exploder" },
    { 0x47A5F045, "n_firecount" },
    { 0xC77E8019, "n_firerunners" },
    { 0x7ACE5413, "n_firetime" },
    { 0x7DC18ADF, "n_firing_wait" },
    { 0x965585D5, "n_first_right_or_left" },
    { 0x28DDF1B5, "n_flags" },
    { 0xB9E732F6, "n_flamethrower_id" },
    { 0x6E8F42AF, "n_flash_fast" },
    { 0xE915E81C, "n_flash_medium" },
    { 0x66BC469E, "n_flash_slow" },
    { 0xD8EB7E06, "n_flash_time" },
    { 0x01167A96, "n_flash_wait" },
    { 0x75DB6F3A, "n_flight_time" },
    { 0x899BEC46, "n_fling_force" },
    { 0x2C256AF7, "n_fling_range_sq" },
    { 0xBB2AE183, "n_flip_number" },
    { 0x451519F4, "n_floor_offset" },
    { 0xD062D262, "n_flung_zombies" },
    { 0x2710C3B8, "n_flyby_count" },
    { 0x9CB1B450, "n_fog_blend_time" },
    { 0xC0EA5D0C, "n_fog_transition_height" },
    { 0x8B95A126, "n_fog_transition_time" },
    { 0x10586D69, "n_follow_dist_sq" },
    { 0x494D0C8E, "n_follower" },
    { 0x58308C20, "n_font_scale" },
    { 0x19A442F8, "n_foot" },
    { 0xB80DC895, "n_force" },
    { 0x1553AD62, "n_force_max" },
    { 0xEAC1A21C, "n_force_min" },
    { 0xEFCD6F18, "n_found" },
    { 0x199C7FE5, "n_fov" },
    { 0xC0C72581, "n_fov_1" },
    { 0xE6C99FEA, "n_fov_2" },
    { 0xDA483F7F, "n_fov_default" },
    { 0xCB84C83E, "n_fov_f35" },
    { 0xD811D271, "n_fov_normal" },
    { 0x7A3E97BC, "n_fov_start" },
    { 0x8538398B, "n_fov_vtol" },
    { 0x5CFBCCE6, "n_fov_zoomed" },
    { 0x60ABD92A, "n_fraction" },
    { 0x54C5C053, "n_frame" },
    { 0x568A8143, "n_frame_count" },
    { 0xF4F17E1E, "n_frame_counter" },
    { 0xEBEEC873, "n_frame_counter_collision" },
    { 0x2DC275EF, "n_frame_counter_collision_threshold" },
    { 0x56DB7D14, "n_frame_counter_forward" },
    { 0x06087BD4, "n_frame_counter_forward_threshold" },
    { 0x8C289682, "n_frames" },
    { 0xB0187D08, "n_frames_before_detection" },
    { 0xBEE62CD7, "n_frames_detected" },
    { 0x64404558, "n_frames_since_jump" },
    { 0xCCB6B42E, "n_frames_to_detection" },
    { 0x9DAD9BA9, "n_frames_to_stop" },
    { 0x7788EFF6, "n_frames_to_stop_max" },
    { 0x5C93C448, "n_frames_to_stop_min" },
    { 0x8F83F302, "n_frames_to_threshold" },
    { 0x03B4C054, "n_free_position" },
    { 0xA79E61C5, "n_frost_filter_intensity" },
    { 0xC293837A, "n_fuel_refunded" },
    { 0x56398C87, "n_fuel_total" },
    { 0xC0E81F50, "n_fuel_used" },
    { 0x703C21F7, "n_full_fadein_time" },
    { 0xA21EEE54, "n_fuse_max" },
    { 0xCCB0F99A, "n_fuse_min" },
    { 0x174A3101, "n_fuse_timer" },
    { 0xD87AC90E, "n_fx" },
    { 0xFEC933F2, "n_fx_count" },
    { 0xAC46DE76, "n_fx_id" },
    { 0x756F86D0, "n_fx_id_papers" },
    { 0xE6870C37, "n_fx_id_player_consumed" },
    { 0xA1E9C985, "n_fx_type" },
    { 0x28D3C89B, "n_fxanim_id" },
    { 0x084995BB, "n_g" },
    { 0x6E47F563, "n_gameplay_start_time" },
    { 0x1C72981A, "n_gameskill_easy" },
    { 0xEDE5003F, "n_gameskill_hard" },
    { 0xF54EABE1, "n_gameskill_normal" },
    { 0x2582E490, "n_gameskill_realistic" },
    { 0x3135F7AD, "n_gameskill_veteran" },
    { 0xF0E1F9F2, "n_gate_move_duration" },
    { 0xBCC8C4AC, "n_generator_panels_active" },
    { 0x888CF125, "n_generator_state" },
    { 0x6FDBC659, "n_giant_robot_z" },
    { 0x9C36C002, "n_gib_speed" },
    { 0x68DD3025, "n_glove_time" },
    { 0x96EE9E5D, "n_goal" },
    { 0x7AD850D5, "n_goal_ents_occupied" },
    { 0xB4268A02, "n_goal_radius" },
    { 0x94B4C941, "n_goal_speed" },
    { 0xA0CC3EC7, "n_godrod_kills" },
    { 0x84FB2CDE, "n_good_chance" },
    { 0x682A92CD, "n_grabs" },
    { 0xFF1F3466, "n_gravity" },
    { 0x6B2DA3FA, "n_gravity_melee_lift_height_max" },
    { 0x2DC998E4, "n_gravity_melee_lift_height_min" },
    { 0xAB759228, "n_gravity_melee_max_lift_speed" },
    { 0x1F063C62, "n_gravity_melee_min_lift_speed" },
    { 0x8335BB0C, "n_gravity_spike_melee_radius_sq" },
    { 0x247F8B61, "n_gravity_trap_fx" },
    { 0xA9CF8E3E, "n_gravity_trap_height" },
    { 0x288A6819, "n_gravity_trap_lift_height_max" },
    { 0x833046A7, "n_gravity_trap_lift_height_min" },
    { 0x481103DD, "n_gravity_trap_max_lift_speed" },
    { 0x36100C3F, "n_gravity_trap_max_lift_time" },
    { 0xF9681D03, "n_gravity_trap_min_lift_speed" },
    { 0x3F2E84D4, "n_gravity_trap_push_away" },
    { 0x990A3981, "n_gravity_trap_radius" },
    { 0xF609F4FC, "n_gravity_trap_radius_sq" },
    { 0x72E6F19B, "n_gravity_trap_seperation" },
    { 0xE682AF02, "n_gravityspike_hint_timer" },
    { 0xF3EC3CD4, "n_gravityspikes_active_time" },
    { 0x669239F7, "n_gravityspikes_knockdown_radius" },
    { 0x0393169C, "n_gravityspikes_los_height_offset" },
    { 0x696DEA94, "n_gravityspikes_melee_height" },
    { 0xF0596D6E, "n_gravityspikes_melee_kill_radius" },
    { 0x93A36AC6, "n_gravityspikes_melee_push_away" },
    { 0x09284DD5, "n_gravityspikes_power" },
    { 0x4C9E7621, "n_gravityspikes_state" },
    { 0x8291C21D, "n_green" },
    { 0xE3F927F3, "n_grenade_charge_power" },
    { 0x44BA4442, "n_grenade_damage" },
    { 0x7C98E68C, "n_grenade_impact_radius" },
    { 0xA051D7EF, "n_grenade_max_range" },
    { 0x228AF4A4, "n_grenade_range" },
    { 0xD3D6F6A5, "n_grenade_speed_scale" },
    { 0xE3983DF4, "n_grenade_timer" },
    { 0xFD259D91, "n_ground_offset" },
    { 0xF2EE2B89, "n_groundvec" },
    { 0xBDA430D5, "n_group" },
    { 0xC1F6248A, "n_group_radius" },
    { 0xB6EF2E05, "n_gunner" },
    { 0x9D62A785, "n_gunner_count" },
    { 0x1FE9BD0C, "n_gunner_index" },
    { 0x531B88B4, "n_guys" },
    { 0x47475A5D, "n_guys_chosen" },
    { 0x2423D611, "n_guys_sent" },
    { 0xE03AD4FB, "n_guys_to_load" },
    { 0x2B02756F, "n_half_count" },
    { 0x192D3AFB, "n_half_group_count" },
    { 0x81DF3E77, "n_half_height" },
    { 0x8DF80694, "n_halfway" },
    { 0xBEE44F67, "n_halfway_dist" },
    { 0x043A9A2A, "n_halfway_height" },
    { 0xE12DBF3C, "n_harper_goal" },
    { 0x607D7C52, "n_header_row" },
    { 0x9EC3BA7B, "n_headshot_kills_in_a_row" },
    { 0x49E142F7, "n_headshot_kills_in_a_row_goal" },
    { 0x1CCAB1F6, "n_health" },
    { 0x267E9243, "n_health_after_damage" },
    { 0x6CA64F9A, "n_health_after_damage_min" },
    { 0xB256C78D, "n_health_max" },
    { 0x2F6B8583, "n_health_min" },
    { 0x5AA73493, "n_health_restored" },
    { 0x8D089076, "n_heat_time" },
    { 0x0AA62308, "n_heat_value" },
    { 0xCB9ADFDD, "n_heavy_threshold" },
    { 0x5B1EBB35, "n_height" },
    { 0x30AAB1C9, "n_height_above_player" },
    { 0xCE2A583D, "n_height_diff" },
    { 0x25991031, "n_height_difference" },
    { 0x528C3CAA, "n_height_from_ground" },
    { 0xA9BFACE9, "n_height_ground" },
    { 0x04CD203B, "n_height_mesh_max_dist" },
    { 0xF38A3A95, "n_height_mesh_min_dist" },
    { 0x61402ACB, "n_height_next" },
    { 0xB55746B1, "n_height_offset" },
    { 0x1E572FA4, "n_heli" },
    { 0x7A9588B0, "n_heli_count" },
    { 0x71832C6C, "n_heli_damage" },
    { 0xDEC8398D, "n_heli_runs" },
    { 0xFC09E4FF, "n_helmet_roll" },
    { 0x6A4541A2, "n_hero_maxpower" },
    { 0xF53DA574, "n_hero_minpower" },
    { 0xF4307D63, "n_hex" },
    { 0x921FF559, "n_high_num" },
    { 0xEB588AF4, "n_highest_group" },
    { 0x7C2EBDE2, "n_hint_remove_delay" },
    { 0x965E309C, "n_hint_text_fade_time" },
    { 0xF6133E3E, "n_hints" },
    { 0x544C99C9, "n_hold_time" },
    { 0x73452B85, "n_hookup_anim_length" },
    { 0x3219A5F4, "n_hookup_control_delay" },
    { 0x19134EE3, "n_horse_count" },
    { 0x6580426C, "n_hover_height" },
    { 0x50C43801, "n_hud_damage" },
    { 0x61AFE629, "n_hud_state" },
    { 0x62E1E54B, "n_id" },
    { 0x16C721EB, "n_ideal" },
    { 0x90790912, "n_ideal_dist" },
    { 0x9674C9D1, "n_ideal_dist_sq" },
    { 0x12090F4A, "n_idle" },
    { 0x2DC9773B, "n_idle_guards" },
    { 0x1131582E, "n_idle_time" },
    { 0x7AB9C3DA, "n_idle_to_max_frames" },
    { 0x9B879487, "n_idle_to_max_time" },
    { 0xBD6A8378, "n_image_cycle_time" },
    { 0x959FAFBA, "n_image_index" },
    { 0xA8B0DC25, "n_image_left" },
    { 0x15FE10D9, "n_image_offset_left" },
    { 0xABA7CF84, "n_image_offset_right" },
    { 0x18210CC8, "n_image_right" },
    { 0x94351942, "n_impact" },
    { 0x8606BB0C, "n_impact_catastrophic" },
    { 0x6346DFF0, "n_impact_major" },
    { 0xCA7EBA8D, "n_impacts" },
    { 0x63E199DA, "n_impulse_max" },
    { 0x267D8EC4, "n_impulse_min" },
    { 0x42C8409B, "n_increment" },
    { 0x6BFA4F7B, "n_increment_count" },
    { 0x2B6980C9, "n_increment_time" },
    { 0x4BC288A0, "n_index" },
    { 0xD0AFCFFF, "n_index_change" },
    { 0x2BD17003, "n_index_max" },
    { 0xA2AD7BA3, "n_infection_half_time" },
    { 0x501D1E91, "n_infection_time" },
    { 0xEA7E78D5, "n_initial_dmg" },
    { 0x957BA1F3, "n_initial_spawns" },
    { 0x1221D0F0, "n_initial_speed" },
    { 0xB66CA26D, "n_inner_radius" },
    { 0x296B7790, "n_input_per_press" },
    { 0xE4B5106D, "n_intel_index" },
    { 0x1DB83AEF, "n_intensity" },
    { 0xE0645488, "n_intensity_change_per_frame" },
    { 0xB1D79BF5, "n_intensity_change_total" },
    { 0x670FB115, "n_intensity_current" },
    { 0x4283202E, "n_intensity_final" },
    { 0x0A4611BE, "n_intensity_min" },
    { 0x3D5DC0DF, "n_interval" },
    { 0x7B4A2690, "n_iterations" },
    { 0x97054A66, "n_jetpack_anim" },
    { 0x54494E63, "n_jetpack_far_spawned" },
    { 0x6A261DCA, "n_jetpack_mid_spawned" },
    { 0xA700FA77, "n_jetpack_variants" },
    { 0xCD9A14D7, "n_jugga_dmg" },
    { 0x983C9E79, "n_key" },
    { 0x8DFBDE7D, "n_kick_strength_max" },
    { 0xC8E58093, "n_kick_strength_min" },
    { 0xEBA4AF1C, "n_kill" },
    { 0x3B508DD8, "n_kill_count" },
    { 0xEC5AC250, "n_kill_limit" },
    { 0x0BA77331, "n_killcount" },
    { 0x2CBA70FF, "n_killed" },
    { 0xBB41233B, "n_killed_to_final_push" },
    { 0xC3C1701C, "n_killed_to_spawn_wave_2" },
    { 0xE1318A5F, "n_kills" },
    { 0xD2FDCFCE, "n_kills_before_disable" },
    { 0xCDB130C5, "n_kills_required" },
    { 0x9B654146, "n_laser_movement_duration" },
    { 0x74DA3060, "n_last_damage_time" },
    { 0xF4444AA5, "n_last_fire_time" },
    { 0x1FC6CD58, "n_last_gameskill" },
    { 0xBA9CF05F, "n_last_get_time" },
    { 0x668C40DE, "n_last_progress" },
    { 0x538242CB, "n_last_spot" },
    { 0x388127A6, "n_launch_angle_max" },
    { 0xDDDB4918, "n_launch_angle_min" },
    { 0xFFBD18D9, "n_launch_force" },
    { 0x9767C856, "n_launch_scale" },
    { 0x4C180E52, "n_launched_zombies" },
    { 0xA722496F, "n_launchers" },
    { 0x46C94DC0, "n_layer_transparency" },
    { 0x54B1A5DF, "n_left" },
    { 0xECD1354E, "n_left_arc" },
    { 0x75697E6B, "n_leftover_time" },
    { 0x52972751, "n_len" },
    { 0x64284EDF, "n_len_int" },
    { 0x2D6836F8, "n_length" },
    { 0xE8DF902E, "n_length_fwd" },
    { 0x66FD0B37, "n_lerp" },
    { 0xA95283D4, "n_lerp_frames" },
    { 0x8455BB1D, "n_lerp_time" },
    { 0xE0B7400E, "n_level" },
    { 0x2C970C6A, "n_level_exposure" },
    { 0xA01DD863, "n_level_sunlight" },
    { 0x3D81480D, "n_lever_order" },
    { 0x83A6B229, "n_life_new" },
    { 0x19894DAE, "n_life_time" },
    { 0x1BE8D0C5, "n_lifetime" },
    { 0xA3BEC14A, "n_lifetime_after_move" },
    { 0x75B5E0D2, "n_lifetime_max" },
    { 0x8AD4886C, "n_lifetime_min" },
    { 0x64A5F747, "n_lifetime_sec" },
    { 0xC298D4CB, "n_lift_height" },
    { 0xA2BBA357, "n_lift_speed" },
    { 0xA20F7F51, "n_lift_time" },
    { 0x3BB2135E, "n_light_current" },
    { 0xA8CDC112, "n_light_goal" },
    { 0x6AE542F3, "n_lights" },
    { 0xC8761762, "n_lights_found" },
    { 0xCB4BCFD8, "n_line_choice" },
    { 0xEB553AC9, "n_lines_played" },
    { 0x6E1F7ECB, "n_living_count" },
    { 0xD7AFD8D7, "n_loc_index" },
    { 0x6575414D, "n_local_client" },
    { 0x4DC7B703, "n_local_client_number" },
    { 0xE0AD73A3, "n_localclientnumber" },
    { 0x93C52A20, "n_location_index" },
    { 0xC9080F02, "n_lod_scale_rigid" },
    { 0x3BBB2C0F, "n_lod_scale_skinned" },
    { 0xDD733128, "n_look_stick_strength" },
    { 0xE6639A6A, "n_loop_time" },
    { 0x524F5A91, "n_loops" },
    { 0xD51946F0, "n_los_angle_constraint" },
    { 0x74E1D841, "n_los_angle_max" },
    { 0x220A697F, "n_los_angle_min" },
    { 0x51080638, "n_los_angle_range" },
    { 0xA9107563, "n_los_angle_step" },
    { 0xB0D9E51F, "n_lower_to_player" },
    { 0x382E9DC9, "n_lower_to_qr" },
    { 0xEB9FF9DB, "n_lowest_rate" },
    { 0xE9D6E94B, "n_lowest_unit" },
    { 0x8994F83B, "n_macguffins_collected" },
    { 0x802DFF58, "n_macguffins_total" },
    { 0xE4FE6CC1, "n_mag" },
    { 0x86BB0546, "n_magnitude" },
    { 0xF8500149, "n_male_index_body" },
    { 0xF0EBD0A3, "n_male_index_head" },
    { 0x8030F70D, "n_male_num_bodies" },
    { 0x47E4C496, "n_male_num_heads" },
    { 0xEDBAADB9, "n_mana" },
    { 0x86FDC826, "n_manual" },
    { 0xB779EFBD, "n_mapped_mana" },
    { 0x803BD5BA, "n_margwa_dist" },
    { 0x13804B27, "n_margwa_head_damage_scale" },
    { 0x12CF56F6, "n_max" },
    { 0xD901A187, "n_max_ai_on_deck" },
    { 0xD15481E4, "n_max_cover_distance" },
    { 0xC76C1022, "n_max_damage" },
    { 0x35342F72, "n_max_delay" },
    { 0xD59F2B65, "n_max_dist" },
    { 0x41666FF0, "n_max_dist_sq" },
    { 0x78DEF9F0, "n_max_distance" },
    { 0xE1A00D9D, "n_max_distance_to_trigger" },
    { 0x30CADB6B, "n_max_flyby_count" },
    { 0xFF9967E7, "n_max_heat" },
    { 0x82303694, "n_max_intrvl" },
    { 0x31C2F2CC, "n_max_jetpacks_per_group" },
    { 0x60DFA60C, "n_max_launchers" },
    { 0xFFD58BB3, "n_max_movetime_s" },
    { 0xC9A2F369, "n_max_objectives" },
    { 0x113D72D7, "n_max_occupants" },
    { 0xE1BE604C, "n_max_opacity" },
    { 0x69F11483, "n_max_other_weapons" },
    { 0x6B94CBCE, "n_max_per_player" },
    { 0x8326E1FB, "n_max_raps_alive" },
    { 0x0A47B0BF, "n_max_raps_per_player" },
    { 0x87F75EAA, "n_max_reply_dist" },
    { 0x2BCB0452, "n_max_spawn_delay" },
    { 0x15AEA289, "n_max_spawns" },
    { 0x82EFAE08, "n_max_target_distance" },
    { 0x4695D932, "n_max_target_distance_squared" },
    { 0x8D2CB132, "n_max_time" },
    { 0x74F58142, "n_max_total_health" },
    { 0x2658584A, "n_max_val" },
    { 0x39DD968A, "n_max_wait" },
    { 0x90356F3B, "n_max_wasps" },
    { 0xFCE25C99, "n_max_wasps_per_player" },
    { 0x48D2AF39, "n_max_wounded" },
    { 0xD3D67347, "n_max_x" },
    { 0xADD3F8DE, "n_max_y" },
    { 0x6DCA6F95, "n_max_zombies_lifted_for_ragdoll" },
    { 0x7A38CA82, "n_maxdist" },
    { 0xB84BAF7D, "n_meatshield_arch" },
    { 0xEC7C92E3, "n_mechz_damage_percent" },
    { 0x8A8CE110, "n_mechz_damage_percentage" },
    { 0x15D24742, "n_mechz_dist" },
    { 0xC2D37EF4, "n_mechz_headshot_modifier" },
    { 0x549197AE, "n_medals_held" },
    { 0x021651F0, "n_melee" },
    { 0xA904111D, "n_melee_element" },
    { 0x1017CD7A, "n_menendez_spas_ammo_lowest" },
    { 0xEF41AFC3, "n_metagame_machine_lights_on" },
    { 0x664BC00C, "n_middle_door_height" },
    { 0xF7DA2B48, "n_min" },
    { 0x657C5DA1, "n_min_big_explosion_interval" },
    { 0x12575340, "n_min_damage" },
    { 0x5F76C18B, "n_min_dist" },
    { 0xECB6FF5A, "n_min_dist_behind" },
    { 0x78726E22, "n_min_dist_sq" },
    { 0x0E531AEA, "n_min_intrvl" },
    { 0x85B946CA, "n_min_last_stand_pistol_value" },
    { 0x214F3508, "n_min_spawn_delay" },
    { 0x6550FBA4, "n_min_target_distance_squared" },
    { 0x25490E6C, "n_min_time" },
    { 0xEE5515C6, "n_min_time_alive" },
    { 0x776867B4, "n_min_val" },
    { 0x0EC24660, "n_min_wait" },
    { 0x68517B06, "n_miscpowerloss" },
    { 0x4AB8AE4C, "n_missile_pct" },
    { 0xAB59042E, "n_missiles_fired" },
    { 0x13748228, "n_mod" },
    { 0x46C49625, "n_mode" },
    { 0x79E649B9, "n_mode_switch_frames" },
    { 0xDDDF9A78, "n_mode_switch_time" },
    { 0xC103B46C, "n_model_anims_size" },
    { 0x0269779A, "n_model_index" },
    { 0x341DD75C, "n_models_array_size" },
    { 0xCB6E468F, "n_modifier" },
    { 0x93A96750, "n_molotov_kills" },
    { 0xDE3417AC, "n_monkey_pulse_damage_max" },
    { 0x1B9822C2, "n_monkey_pulse_damage_min" },
    { 0x962832BA, "n_monkey_pulse_radius" },
    { 0x5F048CDD, "n_mortar_kills" },
    { 0x0387F863, "n_move" },
    { 0xA0D51D60, "n_move_scale" },
    { 0x224C23EB, "n_move_scale_delta" },
    { 0x08401F86, "n_move_stick_strength" },
    { 0xC26EFE11, "n_move_time" },
    { 0x39CE8BAE, "n_move_time_max" },
    { 0x8CA5FA70, "n_move_time_min" },
    { 0x9FA271E0, "n_movement_crouch_speed" },
    { 0xF31783EA, "n_movement_duration" },
    { 0x3C3B0F09, "n_movement_strength" },
    { 0x0CD5B6E3, "n_movement_y" },
    { 0x6740BD9D, "n_movescale_delta_no_perk" },
    { 0x73D7F182, "n_movescale_delta_staminup" },
    { 0x7800BB98, "n_movetime" },
    { 0x8701A1F6, "n_movetime_s" },
    { 0x75EB9DF4, "n_moveto_time" },
    { 0xF671FAE6, "n_moving" },
    { 0x10E09814, "n_msec" },
    { 0x32CFD1CD, "n_msg_time" },
    { 0x1C864FC1, "n_multiplier" },
    { 0x6178AA0B, "n_multiplier_slowdown" },
    { 0x360E130C, "n_my_int" },
    { 0x57CA5226, "n_my_turret_index" },
    { 0xBB0297F9, "n_my_z" },
    { 0x80D8D5FA, "n_nag" },
    { 0xB5EFF06C, "n_nag_line_frequency" },
    { 0xC6BD4D72, "n_near_blur" },
    { 0x799F70EC, "n_near_blur_current" },
    { 0xE75AE05B, "n_near_blur_step" },
    { 0x8747B822, "n_near_blur_to" },
    { 0x5DC37D2C, "n_near_dist_sq" },
    { 0xA8A15588, "n_near_end" },
    { 0x9843DAEE, "n_near_end_current" },
    { 0xB560D15D, "n_near_end_step" },
    { 0x3EBE3C6C, "n_near_end_to" },
    { 0xB0F5E95F, "n_near_goal_dist" },
    { 0x1FD8B3F2, "n_near_goal_dist_suicide" },
    { 0x60C19026, "n_near_goal_draw_red_line" },
    { 0x71AC042B, "n_near_start" },
    { 0xB8C0FC39, "n_near_start_current" },
    { 0xC9A1CE20, "n_near_start_step" },
    { 0x902D9715, "n_near_start_to" },
    { 0x3E52D4D8, "n_nearby_enemies" },
    { 0x6D256C19, "n_nearby_zombies" },
    { 0xB8F30F64, "n_nearest_dist_sq" },
    { 0x7B86B4AB, "n_network_sent" },
    { 0x143C4E26, "n_new" },
    { 0x81D631F5, "n_new_array_index" },
    { 0xE2F54060, "n_new_distance" },
    { 0x19D9B011, "n_new_move_scale" },
    { 0x43CB7E16, "n_new_speed" },
    { 0x04A37B70, "n_next_big_explosion" },
    { 0x3383AC18, "n_next_eval" },
    { 0x8D7245F6, "n_next_node" },
    { 0x69AF9C08, "n_next_point" },
    { 0xFE8C915F, "n_next_raps_round" },
    { 0xC45B88EC, "n_next_recapture_round" },
    { 0xAC4E322A, "n_nightingale_dist_max" },
    { 0xDEA779E9, "n_nightingale_dist_max_sq" },
    { 0x3DAC2E6D, "n_no_end_game_check_count" },
    { 0x277F35C0, "n_node" },
    { 0xB5BDB66B, "n_node1_end" },
    { 0x43327E88, "n_node1_start" },
    { 0x9C2EDE1F, "n_node_corpse" },
    { 0xDA995C1A, "n_nonfatal_shock_effect" },
    { 0xDAA11C6E, "n_notetrack_fade_time" },
    { 0xD7497623, "n_notetrack_time" },
    { 0x5130DAEB, "n_notify_delay" },
    { 0xC7E489AE, "n_notify_dist" },
    { 0x086C9814, "n_now" },
    { 0x5BAE05D7, "n_nuke_spawn_delay" },
    { 0xAAF585DC, "n_num" },
    { 0x90765A75, "n_num_defenders" },
    { 0x03500C7B, "n_num_fireworks" },
    { 0x6BFA3B38, "n_num_heli_runs" },
    { 0xC046C4A1, "n_num_intel" },
    { 0xECB43F9C, "n_num_missiles" },
    { 0x3ED15201, "n_num_raps_per_round_1player" },
    { 0x8AD4F54A, "n_num_raps_per_round_2player" },
    { 0x52356723, "n_num_raps_per_round_3player" },
    { 0xF166679C, "n_num_raps_per_round_4player" },
    { 0x3F8FFB79, "n_num_streamers_ready" },
    { 0x22CA7C1C, "n_num_wasps_per_round" },
    { 0xB239D90E, "n_number_to_display" },
    { 0x1DC885AD, "n_obj_id" },
    { 0xF07569B2, "n_obj_index" },
    { 0x8F945C55, "n_objective" },
    { 0xB34C51E4, "n_objective_counter" },
    { 0x38F149E8, "n_objective_dist" },
    { 0xCADF2F1C, "n_objective_index" },
    { 0x634A75C8, "n_objective_takeoff_delay" },
    { 0x82136D02, "n_objective_targets" },
    { 0x95137472, "n_odds" },
    { 0x79AEEED0, "n_off_tube" },
    { 0xAF38510D, "n_offset" },
    { 0xD37A39FD, "n_offset_from_final" },
    { 0x47DB02D5, "n_offset_multiplier" },
    { 0xBE6048B8, "n_offset_x" },
    { 0xE462C321, "n_offset_y" },
    { 0x0A653D8A, "n_offset_z" },
    { 0xA53F7C1B, "n_old" },
    { 0xAD64657C, "n_old_ammo" },
    { 0x4C76C9A0, "n_old_attackeraccuracy" },
    { 0x3321B2A6, "n_old_charge" },
    { 0xBD3E30F1, "n_old_goalradius" },
    { 0x88E21F7E, "n_old_maxvisibledist" },
    { 0x787567C0, "n_old_radius" },
    { 0x7585EAFF, "n_old_spawn_delay" },
    { 0x92E96F41, "n_oldhealth" },
    { 0x868EA283, "n_opacity" },
    { 0xB1119733, "n_opacity_1" },
    { 0x3F0A27F8, "n_opacity_2" },
    { 0x0D930687, "n_open_craftable_choice" },
    { 0xD6628508, "n_open_time" },
    { 0xD675B0A9, "n_orange_and_red_orange" },
    { 0xAD876322, "n_orbit_direction" },
    { 0xEB5490A8, "n_orbit_time" },
    { 0x9F168B74, "n_order_id" },
    { 0xF480CCEA, "n_origin" },
    { 0xF53D7A5B, "n_origin_index" },
    { 0xBC5FA1E4, "n_original_letter" },
    { 0x4A0DC197, "n_original_size" },
    { 0x035E941E, "n_outer_door_height" },
    { 0x9871C932, "n_outer_radius" },
    { 0x90378CFD, "n_outer_ruins_turrets" },
    { 0x7A9F8A10, "n_override_cleanup_dist" },
    { 0x12B6E3B3, "n_override_cleanup_dist_sq" },
    { 0x64AA50CC, "n_override_damage" },
    { 0x0F501CF2, "n_pandora_fx" },
    { 0x6A7E06C7, "n_panel_index" },
    { 0x2BFD0090, "n_pap_fx" },
    { 0x0A65A351, "n_parallel_dot" },
    { 0xF7C2AE5F, "n_param" },
    { 0x44DFDB55, "n_parasite_round_fx_id" },
    { 0xA2DFBA93, "n_partial_fadein_time" },
    { 0x1107FA55, "n_passenger_index" },
    { 0x01D54629, "n_path" },
    { 0x2ABBFBCB, "n_path_id" },
    { 0x8D62A020, "n_path_index" },
    { 0x41041BB8, "n_path_start" },
    { 0xE440BC1B, "n_pathing_fov" },
    { 0x126D8980, "n_pathoffset" },
    { 0xC31D6FDF, "n_patrol_guards" },
    { 0xA31B1B25, "n_patroller_pass" },
    { 0x6AF3A0BD, "n_patroller_spawners" },
    { 0x1A25E293, "n_pause_before_attack" },
    { 0xFFFF4375, "n_pause_between_shots" },
    { 0x49F24B7A, "n_pdf_killed" },
    { 0x303D88F7, "n_pdf_line" },
    { 0xD6D1D177, "n_pdf_reactions" },
    { 0xCC2855A0, "n_pegasus" },
    { 0x60D67FE4, "n_pegasus_count" },
    { 0x68C03477, "n_percent" },
    { 0xEE328009, "n_percent_damage" },
    { 0xF31990F9, "n_percentage_to_change_state" },
    { 0x97301E07, "n_period" },
    { 0x61372010, "n_perk_cost" },
    { 0xADC6861A, "n_perk_factor" },
    { 0x2617A24D, "n_perk_purchase_limit_override" },
    { 0xDBEE3979, "n_phase_in" },
    { 0xC744382F, "n_physis_pulse_radius" },
    { 0x10266032, "n_piece" },
    { 0x65828643, "n_piece_index" },
    { 0x06D5323E, "n_pitch" },
    { 0xB10C5575, "n_pitch_delta" },
    { 0xE110AF2C, "n_pitch_range" },
    { 0x9A6E64A7, "n_pitch_step" },
    { 0xA27AA7E3, "n_placeholder" },
    { 0x15A58330, "n_placement_chance" },
    { 0x683BC12D, "n_plane_fuel_count" },
    { 0x2FB3369D, "n_plane_pieces_found" },
    { 0x6FC38A8D, "n_planes" },
    { 0x71F9DD1B, "n_plant" },
    { 0xC4EB681C, "n_playback_rate" },
    { 0xA751DD44, "n_playbacktime" },
    { 0x71D7943B, "n_player" },
    { 0x60DCA8B5, "n_player1_stat" },
    { 0x840C4740, "n_player2_stat" },
    { 0x2E3EA490, "n_player_anim_length" },
    { 0xF9C713E2, "n_player_body" },
    { 0x712F7104, "n_player_controlled_zones" },
    { 0xBBAD5C5B, "n_player_count" },
    { 0xCACBF7E2, "n_player_dist" },
    { 0x7FC95BB0, "n_player_dist_squared" },
    { 0xE58AF7AA, "n_player_dmg" },
    { 0x8779A88D, "n_player_end" },
    { 0xC19F66A0, "n_player_far_dist" },
    { 0x88D27997, "n_player_fov" },
    { 0x5FEB5A44, "n_player_health_boost" },
    { 0xCA8F84CD, "n_player_id" },
    { 0xECC65052, "n_player_index" },
    { 0x659ABF42, "n_player_input" },
    { 0x918E61FD, "n_player_modifier" },
    { 0xE66B2AA7, "n_player_near_dist" },
    { 0x8C78610D, "n_player_number" },
    { 0xB240E137, "n_player_numerator" },
    { 0x96D51930, "n_player_pitch" },
    { 0x5529CCA0, "n_player_radius" },
    { 0xAC5E0BEC, "n_player_safe_distance_sq" },
    { 0x7843EB15, "n_player_spawn_selection_index" },
    { 0xE498E200, "n_player_squad_size" },
    { 0x8734D2BE, "n_player_start" },
    { 0xDFE398D6, "n_player_t" },
    { 0x5542F3B4, "n_player_total" },
    { 0x5F2BDFF5, "n_player_view_angle" },
    { 0x8C4B2A82, "n_player_view_angle_max" },
    { 0x61B91F3C, "n_player_view_angle_min" },
    { 0x77ED827A, "n_player_x" },
    { 0x9DEFFCE3, "n_player_y" },
    { 0x6687F71F, "n_player_yaw" },
    { 0x629D3FB5, "n_playernum" },
    { 0xF78879DA, "n_players" },
    { 0xF864AF82, "n_players_in_igc" },
    { 0xE320A74F, "n_players_in_igc_field" },
    { 0x57AFC146, "n_players_in_position" },
    { 0x55013575, "n_players_in_robot" },
    { 0x809DD70D, "n_players_in_zone" },
    { 0xDC8E0F0A, "n_players_on" },
    { 0x44C33132, "n_players_on_bridge_count" },
    { 0x6ACB4269, "n_players_total" },
    { 0xFA246F31, "n_points" },
    { 0xC11EDC1D, "n_points_earned" },
    { 0x04EB24B0, "n_points_found" },
    { 0x02E7C57C, "n_points_spent" },
    { 0xDFCB261D, "n_points_to_add_to_currency" },
    { 0xC64DC3F9, "n_poll_time" },
    { 0xC5A3FEB5, "n_polling_delay" },
    { 0x308C67AA, "n_pos" },
    { 0x07A4EE97, "n_possible_damage" },
    { 0x830C2B5E, "n_possible_health" },
    { 0x2F188B32, "n_post_burst_delay_max" },
    { 0x443732CC, "n_post_burst_delay_min" },
    { 0x2D08C90C, "n_post_eject_time" },
    { 0xAA5C13EE, "n_power_index" },
    { 0x44105F7D, "n_power_on" },
    { 0x8C51632E, "n_powerup_default_time" },
    { 0x4C08D4CF, "n_presses_required" },
    { 0x8EA0F46D, "n_prev_num_hinds" },
    { 0xC10AA678, "n_prev_num_tanks" },
    { 0x1D4E9637, "n_prev_speed" },
    { 0x903279DB, "n_previous_damage_time" },
    { 0x9EB94556, "n_prize_roll" },
    { 0xE1DF95C4, "n_progress_amount" },
    { 0x2886616B, "n_projection" },
    { 0x4F2446C1, "n_pulse_damage" },
    { 0x22C28A99, "n_purchase_limit" },
    { 0xE18233C9, "n_push_away" },
    { 0x69F695A4, "n_push_count" },
    { 0xFDA7D5D6, "n_push_frames_total" },
    { 0xB9492DE8, "n_push_strength" },
    { 0x627EB86B, "n_push_time_total" },
    { 0x8704E8FE, "n_pushed_counter" },
    { 0x0679F264, "n_pushing_hard" },
    { 0xC0998566, "n_pushing_normal" },
    { 0x565ED77B, "n_pushing_weak" },
    { 0x95BA8515, "n_qr_to_lower" },
    { 0x3E380882, "n_qr_to_upper" },
    { 0xF83BB0DF, "n_qrotors_dead" },
    { 0xE65836B0, "n_qrotors_dead_max" },
    { 0x2BD2F824, "n_quake_scale" },
    { 0xBE405BE5, "n_quake_time" },
    { 0xA57B47A2, "n_quest_iteration_count" },
    { 0xDA78AB86, "n_r" },
    { 0x562B538E, "n_radius" },
    { 0x0A4A2E2F, "n_radius_ai_swap" },
    { 0x26C1C66B, "n_radius_crouch_foliage" },
    { 0xA838580A, "n_radius_crouch_open" },
    { 0x4A271051, "n_radius_prone_foliage" },
    { 0x345867A0, "n_radius_prone_open" },
    { 0xD9315CDD, "n_radius_sq" },
    { 0x19889485, "n_radius_sqr" },
    { 0x2251A3EC, "n_radius_squared" },
    { 0x38164E6B, "n_radius_stand" },
    { 0x71E1797A, "n_radius_vtol" },
    { 0xF4CBDA5E, "n_rage_amount" },
    { 0xB3221352, "n_rage_high" },
    { 0x0B4F6304, "n_rage_image_position_index" },
    { 0x790190F1, "n_rage_kills" },
    { 0xEC699DE4, "n_rage_low" },
    { 0xEC4682B5, "n_rage_value" },
    { 0x87E512DC, "n_rage_value_high" },
    { 0xAB92F0C7, "n_rage_value_previous" },
    { 0xF3507F22, "n_rage_values_diff" },
    { 0x8DF4EB59, "n_rage_warp_final" },
    { 0x5CDEE3FC, "n_rage_warp_previous" },
    { 0xBCD99C49, "n_rail_terrorist_kills" },
    { 0x2626CBF8, "n_raise_time" },
    { 0x905C0F23, "n_ramp_duration" },
    { 0xFD319A94, "n_rampdown_time" },
    { 0xD542F25E, "n_rampdown_time2" },
    { 0x5955D439, "n_rand" },
    { 0x8A935C72, "n_rand_goal_radius" },
    { 0xFFB35E3F, "n_rand_wait" },
    { 0x75630A91, "n_random" },
    { 0x5E5FC1DA, "n_random_line" },
    { 0x5116E02E, "n_random_max" },
    { 0x2A8C7046, "n_random_perks_assigned" },
    { 0x09DD52CA, "n_random_spoken" },
    { 0x74871427, "n_random_wait" },
    { 0x9F108924, "n_random_x" },
    { 0xC513038D, "n_random_y" },
    { 0xE8EA412B, "n_range" },
    { 0xAEFA4502, "n_range_sq" },
    { 0xE3B7AF42, "n_raps_alive" },
    { 0x142B7351, "n_raps_drop_height_max" },
    { 0xC1D8BFAC, "n_raps_drop_speed" },
    { 0x0026944D, "n_raps_health" },
    { 0x09FC0858, "n_raps_health_increase" },
    { 0xEBFEA28A, "n_raps_health_max" },
    { 0x664D9D3F, "n_raps_kill_points" },
    { 0xA4EF1D01, "n_raps_shellshock_hit_limit" },
    { 0xD2620ADC, "n_raps_spawn_delay_1p" },
    { 0x8DD8F03D, "n_raps_spawn_delay_2p" },
    { 0x0F418A12, "n_raps_spawn_delay_3p" },
    { 0x54216F5B, "n_raps_spawn_delay_4p" },
    { 0x1CF2609C, "n_raps_spawn_dist_max" },
    { 0x9A071E92, "n_raps_spawn_dist_min" },
    { 0xBD132462, "n_rate" },
    { 0x52607092, "n_ratio_avenger" },
    { 0x224345B4, "n_ratio_pegasus" },
    { 0xC4562C3E, "n_raygun_mark3_vortex_enter_duration" },
    { 0xA3DE1836, "n_raygun_mark3_vortex_exit_duration" },
    { 0x1E37880C, "n_raygun_mark3_vortex_loop_duration" },
    { 0x67E9894E, "n_raygun_mark3_vortex_overlay_blur_amount" },
    { 0x987F6F4D, "n_raygun_mark3_vortex_overlay_inner_radius" },
    { 0xFF621512, "n_raygun_mark3_vortex_overlay_outer_radius" },
    { 0x34DA80EB, "n_raygun_mark3_vortex_visionset_lerp_count" },
    { 0x323889F8, "n_raygun_mark3_vortex_visionset_priority" },
    { 0x4E1E5D13, "n_raygun_mark3_vortex_z_offset" },
    { 0x232FC2DE, "n_raygun_mark3lh_slowdown_duration" },
    { 0x5705A48C, "n_raygun_mark3lh_slowdown_rate" },
    { 0xF5D91E0B, "n_raygun_mark3lh_upgraded_slowdown_duration" },
    { 0xAA451901, "n_raygun_mark3lh_upgraded_slowdown_rate" },
    { 0x902AF332, "n_raygun_mark3lh_upgraded_vortex_duration" },
    { 0x040432D1, "n_raygun_mark3lh_upgraded_vortex_pulse_damage_lg" },
    { 0x2BA244A2, "n_raygun_mark3lh_upgraded_vortex_pulse_damage_sm" },
    { 0x7A8E6E73, "n_raygun_mark3lh_vortex_duration" },
    { 0x366FE6FA, "n_raygun_mark3lh_vortex_pulse_damage_lg" },
    { 0xF76AA2F5, "n_raygun_mark3lh_vortex_pulse_damage_sm" },
    { 0xC4791F0A, "n_raygun_mark3lh_vortex_pulse_interval" },
    { 0xD967CB7A, "n_raygun_mark3lh_vortex_range_lg" },
    { 0x9A628775, "n_raygun_mark3lh_vortex_range_sm" },
    { 0x1CA36DE2, "n_raz_dist" },
    { 0xB91FA361, "n_reached_round_10" },
    { 0x2B27129C, "n_reached_round_15" },
    { 0x3C1C3C60, "n_reached_round_20" },
    { 0xFA28A06D, "n_reached_round_25" },
    { 0xBAB3A28B, "n_reached_round_30" },
    { 0xB6124CCF, "n_rebuild_time" },
    { 0x44D96A41, "n_recapture_zombies_needed" },
    { 0x1746E909, "n_red" },
    { 0x558FF600, "n_red_orange_and_red" },
    { 0x40D08447, "n_reduction" },
    { 0xBA2BCFCB, "n_refresh_time" },
    { 0x3C1C5605, "n_refund_amount" },
    { 0x539FD719, "n_relax_duration" },
    { 0x09319F19, "n_reload_time" },
    { 0x4B785980, "n_remaining" },
    { 0x79069097, "n_remaining_leapers_this_round" },
    { 0x05F6AD07, "n_remove_follow_dist" },
    { 0x4A9B908C, "n_required_distance_to_stop" },
    { 0x165C642C, "n_required_players" },
    { 0x3729471B, "n_respawn_delay_max" },
    { 0x4C47EEB5, "n_respawn_delay_min" },
    { 0xB9FD55C3, "n_respawn_wait_max" },
    { 0x7C994AAD, "n_respawn_wait_min" },
    { 0xD426D15B, "n_respawned" },
    { 0xBBB1E95C, "n_respawned_max" },
    { 0x33EEF0DB, "n_response_range" },
    { 0xD433358D, "n_rest_angle_pitch" },
    { 0xC0DE8E7A, "n_rest_angle_yaw" },
    { 0x097361BB, "n_restart_time" },
    { 0x693E8A0E, "n_restore_time" },
    { 0x01146F59, "n_resttime" },
    { 0x79B53A67, "n_result" },
    { 0xEA75B306, "n_revive_visibility_delay" },
    { 0xFA4424A6, "n_revives" },
    { 0xE49C45FA, "n_right" },
    { 0x8F33CBC7, "n_right_arc" },
    { 0xB1C5FA89, "n_rise_time" },
    { 0x9A1BFDD4, "n_robot_id" },
    { 0x27F11BD5, "n_robot_num" },
    { 0x7758971D, "n_rod_damage" },
    { 0x9F7417DC, "n_rod_damage_bigdog_kill_radius" },
    { 0x8243F6CF, "n_rod_damage_depth" },
    { 0xE35A21DA, "n_rod_damage_max" },
    { 0xA5F616C4, "n_rod_damage_min" },
    { 0x3E4FA2C2, "n_rod_damage_radius" },
    { 0x1695ED41, "n_rod_damage_radius_sq" },
    { 0x475B3075, "n_roll" },
    { 0x02E1126D, "n_roof_nag_max_times" },
    { 0x2C1A703F, "n_roof_nag_wait" },
    { 0x15A53179, "n_rotate" },
    { 0x0EE28BFD, "n_rotate_angle" },
    { 0xB53C9EEF, "n_rotate_time" },
    { 0x5FADDB59, "n_rotations" },
    { 0x9F831CDC, "n_round" },
    { 0xBA7C9D31, "n_round_gap" },
    { 0x2A9BE8D4, "n_round_on_bridge" },
    { 0x34B12618, "n_round_time" },
    { 0x945C45A5, "n_round_weather" },
    { 0x17167D70, "n_round_zombies" },
    { 0xD53757F9, "n_rounds_completed" },
    { 0x3F1EA140, "n_row" },
    { 0x64BEBD5B, "n_rpg_range" },
    { 0x3B1A958B, "n_rumble_count" },
    { 0xAD454077, "n_rumble_count_catastrophic" },
    { 0xCA63EDE5, "n_rumble_count_major" },
    { 0x68A8F771, "n_rumble_count_minor" },
    { 0x395F6BAF, "n_rumble_delay" },
    { 0x83AE2DC3, "n_rumble_delay_catastrophic" },
    { 0x1A088AB1, "n_rumble_delay_major" },
    { 0xBEF12E95, "n_rumble_delay_minor" },
    { 0xD886C10B, "n_rumble_distance" },
    { 0x1A79F1E9, "n_rumble_enum" },
    { 0x6BD691D0, "n_rumble_level" },
    { 0xADB49669, "n_rumble_threshold_squared" },
    { 0x00628919, "n_rumble_time" },
    { 0x36289945, "n_runners" },
    { 0x86A71926, "n_rush_far_distance" },
    { 0x283146A8, "n_rush_group_distance" },
    { 0x982C2835, "n_rush_time_max" },
    { 0xC1A49238, "n_rusher_cooldown_ms" },
    { 0xD4600BAA, "n_safe_strafes" },
    { 0xBDAA552C, "n_safe_zone_pass" },
    { 0xB17BAF7F, "n_safe_zones" },
    { 0xBBC7D5DE, "n_salazar_goal" },
    { 0xBA0AE4DE, "n_sam_missiles_fired" },
    { 0xA9585493, "n_save" },
    { 0x499C19BA, "n_scale" },
    { 0x9C70B1D4, "n_scale_back" },
    { 0xD873E116, "n_scale_bullet_max" },
    { 0xBD7EB568, "n_scale_bullet_min" },
    { 0xDD67B2C5, "n_scale_explosive_max" },
    { 0xC8490B2B, "n_scale_explosive_min" },
    { 0x1FD63B68, "n_scale_forward" },
    { 0x5353D3FE, "n_scale_time" },
    { 0x7ECA1D78, "n_scale_timer" },
    { 0xBB9DAA50, "n_scan_rotationperframe" },
    { 0xB637C209, "n_scan_rotationpersecond" },
    { 0x0D6416E0, "n_scanangle_left" },
    { 0x7F3C1FCF, "n_scanangle_right" },
    { 0x6AA2197B, "n_scanlefttime" },
    { 0xB333B0D4, "n_scanpausetime" },
    { 0x3CAC311C, "n_scanrighttime" },
    { 0xE1006C1C, "n_scantime" },
    { 0x687222B4, "n_scene" },
    { 0x4C068EA0, "n_scene_count" },
    { 0xB2211170, "n_scene_time" },
    { 0x50C5AC64, "n_scoped" },
    { 0x875F1CCA, "n_score" },
    { 0x29759C0D, "n_score_addition" },
    { 0x6F71F124, "n_script_anim_rate" },
    { 0x02B40DC3, "n_script_int" },
    { 0xA00B8896, "n_scripted_count" },
    { 0x8B449B0F, "n_seat" },
    { 0xA377FBEF, "n_secondary_shock_effect" },
    { 0x517DD7E1, "n_seconds_alive" },
    { 0x9039D61B, "n_seconds_to_wait" },
    { 0xD16B36B9, "n_section" },
    { 0xB374F365, "n_security_node_count" },
    { 0xFD9D94F0, "n_sensitive_room_fog_bank" },
    { 0x3835349A, "n_sequences" },
    { 0x1DF461E9, "n_server_frames_per_second" },
    { 0x38D54F1C, "n_server_length" },
    { 0x41BDB9A4, "n_set" },
    { 0x3161C6C6, "n_shader_index" },
    { 0x618883EF, "n_shader_val" },
    { 0x4362CE2D, "n_shader_value" },
    { 0x2CD77474, "n_shake_decrement" },
    { 0x09D453BC, "n_shake_value" },
    { 0xB1977FCE, "n_shells_to_reload_lowest" },
    { 0x60BF9013, "n_shellshock_duration" },
    { 0xBF1EDCD4, "n_shelves" },
    { 0xBA9F2909, "n_shield_kills" },
    { 0x26156B43, "n_shift_amount" },
    { 0x7692597F, "n_shift_high" },
    { 0x25D4ACCB, "n_shift_low" },
    { 0x1B93DFE8, "n_shock_eyes_fx" },
    { 0x2886D0CF, "n_shock_fx" },
    { 0x95809637, "n_shoot_cooldown" },
    { 0xEADCBD84, "n_shoot_duration" },
    { 0x6B5AF140, "n_shoot_revtime" },
    { 0xDB25489F, "n_shoot_time" },
    { 0xA1ED885E, "n_shoottime" },
    { 0xB6F44F8A, "n_shot_range" },
    { 0x8C1EF6CF, "n_shots" },
    { 0xD81CA156, "n_shots_fired" },
    { 0xF9CB9F20, "n_shots_in_burst" },
    { 0x6FDA3808, "n_shots_to_fire" },
    { 0xF85A2ECD, "n_show_time" },
    { 0x83C971FF, "n_show_ui_duration" },
    { 0x939AEA7D, "n_side" },
    { 0xCACA961B, "n_side_modifier" },
    { 0xA9BFBBE9, "n_sight_trace" },
    { 0xA0F8809E, "n_signal_indicator_blink_speed_max" },
    { 0x6A42DC7A, "n_signal_indicator_blink_speed_step" },
    { 0xF8E1C729, "n_signal_indicator_color_red_max" },
    { 0xDE417DBB, "n_signal_indicator_color_red_step" },
    { 0x93F1B527, "n_size" },
    { 0x87BE9B45, "n_slam_wait" },
    { 0xAAED4F8A, "n_slide_amount" },
    { 0xFAD8628D, "n_slide_up" },
    { 0xD17DD9C9, "n_slope" },
    { 0xC59A5F80, "n_slot_number" },
    { 0x1D33C503, "n_slow_distance" },
    { 0x8253D091, "n_slow_time" },
    { 0xF2B0C437, "n_slowdown_timeout" },
    { 0x54E52A03, "n_slowgun_count" },
    { 0xBA71F907, "n_small_spawn_size" },
    { 0xDE143EC0, "n_small_spawns" },
    { 0xFFDC3F68, "n_snipe_dist_sq_mid" },
    { 0x1BCD60F2, "n_snipe_dist_sq_min" },
    { 0xA544261A, "n_snipe_multiplier_max" },
    { 0xE6734C1E, "n_snipe_multiplier_mid" },
    { 0x6A5A8404, "n_snipe_multiplier_min" },
    { 0x55AE88BF, "n_sniper_range" },
    { 0x0718F01F, "n_soct_speed" },
    { 0xFFAC5E6A, "n_soldier" },
    { 0xC2A14D5C, "n_sole_origin" },
    { 0x61ACB1A0, "n_sort" },
    { 0x814954E1, "n_soul_boxes_completed" },
    { 0x286A167F, "n_souls_absorbed" },
    { 0xF94733DC, "n_souls_required" },
    { 0xCD10D90E, "n_space" },
    { 0x444AB4E1, "n_sparky_fx" },
    { 0x339F5CE1, "n_spawn" },
    { 0xD4984E64, "n_spawn_cap" },
    { 0x995846E9, "n_spawn_count" },
    { 0xA77574A6, "n_spawn_count_allies" },
    { 0x40B1892F, "n_spawn_count_axis" },
    { 0x898354B1, "n_spawn_delay" },
    { 0xAB4CED6D, "n_spawn_group" },
    { 0xE425EE64, "n_spawn_height_min" },
    { 0xAD7B939D, "n_spawn_limit" },
    { 0x1B655864, "n_spawn_num" },
    { 0xC45EE422, "n_spawn_pos" },
    { 0xE7F88525, "n_spawn_yaw" },
    { 0x2F08D7CE, "n_spawned" },
    { 0xEAD252C8, "n_spawner" },
    { 0x940E6E1C, "n_spawner_count" },
    { 0xBFE3D416, "n_spawnflags" },
    { 0x6F76009C, "n_spawns_needed" },
    { 0xA6B1619D, "n_speed" },
    { 0x290D1F00, "n_speed_based_on_drone" },
    { 0x4C9A2AB5, "n_speed_based_on_soct" },
    { 0x1C8591A6, "n_speed_change_per_frame" },
    { 0x515388DA, "n_speed_clamped" },
    { 0xED0FCEEF, "n_speed_current" },
    { 0xAC5A9FBE, "n_speed_damp" },
    { 0xBC3A2627, "n_speed_drop" },
    { 0xD969C1DA, "n_speed_fast" },
    { 0x15CA8548, "n_speed_final" },
    { 0x9CE0B87A, "n_speed_intercept" },
    { 0xB015145A, "n_speed_max" },
    { 0x72B10944, "n_speed_min" },
    { 0x7BDC7165, "n_speed_multiplier" },
    { 0x187C2C0A, "n_speed_new" },
    { 0xA51BBA5F, "n_speed_range" },
    { 0x53545039, "n_speed_resume" },
    { 0xAC81F325, "n_speed_run_time" },
    { 0xE9DDC036, "n_speed_scale" },
    { 0x5276BDCD, "n_speed_scale_max" },
    { 0xCF8B7BC3, "n_speed_scale_min" },
    { 0x26F92059, "n_speed_threshold" },
    { 0x8C244C33, "n_speed_wave_1" },
    { 0x1A1CDCF8, "n_speed_wave_2" },
    { 0x401F5761, "n_speed_wave_3" },
    { 0x4FF5DA97, "n_spikes_autokill_damage" },
    { 0xE41C3DDE, "n_spoon_kill_count" },
    { 0xB84DA6B3, "n_spore_val" },
    { 0x3A450F08, "n_spotlighttype" },
    { 0x3AF6D0B9, "n_spread" },
    { 0x190AA042, "n_sprint_dist_sq" },
    { 0x329B95AE, "n_sprint_speed_units_per_sec" },
    { 0xB3A3770B, "n_sq_energy" },
    { 0xB3BCF41A, "n_sq_max_energy" },
    { 0xF78C0EF6, "n_squad_size" },
    { 0xF66E6973, "n_squad_spawn_index" },
    { 0xC01C54CD, "n_staffs_crafted" },
    { 0xC88BBD58, "n_staffs_inserted" },
    { 0xFF640438, "n_start" },
    { 0xFCBCD4A1, "n_start_alpha" },
    { 0xB97C1DD7, "n_start_anim_length" },
    { 0x06CC637B, "n_start_dist" },
    { 0xB0CFB3A1, "n_start_index" },
    { 0x49A209E0, "n_start_pct" },
    { 0x2F70FFF3, "n_start_pitch" },
    { 0xE04460FB, "n_start_pos" },
    { 0x67D107D5, "n_start_rate" },
    { 0x3E9A6813, "n_start_scale" },
    { 0x94DB6E7C, "n_start_time" },
    { 0xC04CD164, "n_start_val" },
    { 0xEF6768CE, "n_start_value" },
    { 0x270EEB32, "n_start_w" },
    { 0x80A0B314, "n_start_wait_time" },
    { 0xC92A2DB5, "n_start_x" },
    { 0xA327B34C, "n_start_y" },
    { 0x152F2287, "n_start_z" },
    { 0xD3086530, "n_starter_dist" },
    { 0x638EC873, "n_starttime" },
    { 0xA4C7CF12, "n_stat" },
    { 0xF724473A, "n_stat_nav_value" },
    { 0x135982C8, "n_stat_value" },
    { 0xC595A2BB, "n_state" },
    { 0x1F2997A9, "n_state_current" },
    { 0x9DBAD9F2, "n_state_last" },
    { 0x795A6D42, "n_step" },
    { 0x97057CDE, "n_step_size" },
    { 0xB2610206, "n_step_time" },
    { 0xADBBAC18, "n_step_value" },
    { 0x8441F68D, "n_steps" },
    { 0x2BC4D9D5, "n_stepsize" },
    { 0x31A56D60, "n_stinger_range" },
    { 0xE40B810E, "n_stock" },
    { 0xF8CFEA22, "n_stock_size" },
    { 0xA2213D0D, "n_stop_index" },
    { 0x2120343B, "n_stop_on_track_dist" },
    { 0x869382FF, "n_stopped" },
    { 0x203C7C05, "n_strafe_height_offset" },
    { 0xD869851A, "n_stream_request_id" },
    { 0x4375FE70, "n_stream_time" },
    { 0xB7B2A4C7, "n_streamer_time" },
    { 0x0EEBCF38, "n_streamer_time_total" },
    { 0x41229005, "n_strikes" },
    { 0x16F76538, "n_sun_angle_end" },
    { 0x857E705B, "n_sun_angle_start" },
    { 0x2AB62BA1, "n_sun_blue" },
    { 0xF385E013, "n_sun_dir_x" },
    { 0xCD8365AA, "n_sun_dir_y" },
    { 0xA780EB41, "n_sun_dir_z" },
    { 0x0BD84F72, "n_sun_green" },
    { 0x21EB16D2, "n_sun_red" },
    { 0x9EC97685, "n_sun_sample_size" },
    { 0xD0895737, "n_surprise_anim" },
    { 0x49DE2784, "n_swarm_size" },
    { 0xDE1E634F, "n_sweet_spot" },
    { 0x47620996, "n_tablet_state" },
    { 0x6E8B3EDA, "n_tablets_remaining" },
    { 0xBBFCA32B, "n_target_alert_level" },
    { 0xD59DB90A, "n_target_alpha" },
    { 0x122F1948, "n_target_damage_alpha" },
    { 0x14AE7523, "n_target_flags" },
    { 0x060B35A7, "n_target_height" },
    { 0x4E066691, "n_target_id" },
    { 0xBFACA251, "n_target_kills" },
    { 0xDDEAF026, "n_target_leading_factor" },
    { 0xC936938A, "n_target_round" },
    { 0xB34929BD, "n_target_time" },
    { 0x1190D3D4, "n_target_zombie" },
    { 0x22A6B0FD, "n_targetable_player_count" },
    { 0x66FD728B, "n_targeting_range" },
    { 0xF4DE3A31, "n_targetradius" },
    { 0x5BA9A4CE, "n_targets" },
    { 0x3CEC56C1, "n_targets_marked" },
    { 0x3DC5460E, "n_targets_objective" },
    { 0xFEAF6EC5, "n_targets_total" },
    { 0x484FBC43, "n_teleport_cooldown" },
    { 0xBCADBC9D, "n_teleport_delay" },
    { 0xE65E1347, "n_teleport_enum" },
    { 0x46EB4EFB, "n_teleport_time" },
    { 0x20FD5DA9, "n_teleport_time_sec" },
    { 0x70AE6AE6, "n_temp" },
    { 0xD65805D5, "n_temp_dist" },
    { 0xE3DACC67, "n_temp_stat" },
    { 0x0BF0D8B9, "n_tesla_tube_fx_id" },
    { 0x23433266, "n_test_chair" },
    { 0x240A3804, "n_test_count" },
    { 0x65BFD953, "n_test_mode_active" },
    { 0x15C9B09B, "n_test_woods" },
    { 0x0E7DDFF6, "n_tests_passed" },
    { 0xD87270B3, "n_tests_to_do" },
    { 0xB46F9F72, "n_tethermax" },
    { 0x9F24F08E, "n_tethermaxsq" },
    { 0xC98E470C, "n_tethermin" },
    { 0x585B8784, "n_tetherminsq" },
    { 0xC0B783C8, "n_think_time" },
    { 0x7D8DDCAF, "n_thrasher_charge_health_threshold_pct" },
    { 0x3BF61FBA, "n_thrasher_dist" },
    { 0x5BACB434, "n_thread_delay" },
    { 0xA2607595, "n_threshold" },
    { 0x33C7A219, "n_threshold_height" },
    { 0x2EA055DE, "n_throttle_forward" },
    { 0x9AA9B73E, "n_throttle_threshold_forward" },
    { 0x25C8B98F, "n_throttle_threshold_reverse" },
    { 0xED6D2407, "n_throw_scale" },
    { 0x4DD605EA, "n_tick_duration" },
    { 0x78962FFF, "n_time" },
    { 0xD77628A5, "n_time_alive" },
    { 0x81676784, "n_time_before_return" },
    { 0x5D22719A, "n_time_between" },
    { 0x51173993, "n_time_between_reminder" },
    { 0x7A26C7A0, "n_time_between_shots" },
    { 0x9320F5B6, "n_time_briggs_started" },
    { 0x85BD9919, "n_time_completed" },
    { 0x5B8E207E, "n_time_created" },
    { 0x2E4C6485, "n_time_current" },
    { 0xDDE12958, "n_time_delta" },
    { 0x16F675E2, "n_time_done" },
    { 0x80D7AF0A, "n_time_elapsed" },
    { 0x09CF7911, "n_time_end" },
    { 0x281300B5, "n_time_exposure" },
    { 0x2BFAD974, "n_time_flash" },
    { 0x2B258C00, "n_time_floor" },
    { 0xBB745F9E, "n_time_frac" },
    { 0x531DA369, "n_time_id" },
    { 0x5E2D6ADD, "n_time_increment" },
    { 0xC98DE1BC, "n_time_init" },
    { 0x884ED5B4, "n_time_last_base_vo" },
    { 0x48F00981, "n_time_left" },
    { 0x7F1C09E4, "n_time_left_on_briggs_anim" },
    { 0x79DE874D, "n_time_left_until_fade" },
    { 0x02029FC7, "n_time_limit" },
    { 0x915AAB53, "n_time_lose_sight" },
    { 0xD8D7C010, "n_time_max" },
    { 0x61FA95F2, "n_time_menendez_started" },
    { 0x464F9E6E, "n_time_min" },
    { 0x3743627A, "n_time_ms" },
    { 0x2950A4FA, "n_time_now" },
    { 0x31BD831A, "n_time_passed" },
    { 0x189FBAF3, "n_time_played" },
    { 0xED8567B5, "n_time_player_anim_started" },
    { 0x7E2826F9, "n_time_prev" },
    { 0x658460AA, "n_time_remaining" },
    { 0x9C693484, "n_time_scale" },
    { 0x5AE5C992, "n_time_since_death_ms" },
    { 0x26B684BE, "n_time_since_last_shot" },
    { 0x1E668C5A, "n_time_since_player_anim_started" },
    { 0x5C19739A, "n_time_start" },
    { 0x0F12872E, "n_time_start_anim" },
    { 0xA298BA2D, "n_time_started" },
    { 0x6ABD7DE7, "n_time_started_generator" },
    { 0xEE2FA48A, "n_time_strafing" },
    { 0xC25AE67E, "n_time_to_die" },
    { 0xF638BD9B, "n_time_to_fade_out" },
    { 0xF428C008, "n_time_to_fail" },
    { 0x75E91B78, "n_time_to_fire" },
    { 0xCEA4EA27, "n_time_to_show" },
    { 0x313DB2C4, "n_time_to_stop" },
    { 0x5682AB83, "n_time_to_wait_for_explosion" },
    { 0xB57F6680, "n_time_total" },
    { 0x637636ED, "n_timeout" },
    { 0x9C927CEE, "n_timeout_frames" },
    { 0xE5F977B4, "n_timeout_length" },
    { 0xF7281ECB, "n_timeout_s" },
    { 0x3501C4DF, "n_timeout_sec" },
    { 0x3EAC426F, "n_timer" },
    { 0xABE12DCE, "n_timer_length" },
    { 0xE52A8000, "n_timer_max" },
    { 0xC90E88AA, "n_timer_start" },
    { 0x2D1A144E, "n_timer_start_time" },
    { 0xD510B32A, "n_times_attacked" },
    { 0x47386FB4, "n_times_played" },
    { 0xE484E9FB, "n_times_to_check" },
    { 0xA8DDA6BF, "n_times_to_play" },
    { 0x0BCE6643, "n_timescale" },
    { 0x851796DB, "n_timescale2" },
    { 0xDC2580DE, "n_timescale_blend_out_time" },
    { 0x7BD0A4F6, "n_timescale_kill_slow" },
    { 0x2EF39F6A, "n_timescale_length" },
    { 0x7DAC51C1, "n_timescale_slow" },
    { 0xDCCA39F9, "n_timescale_transition_time" },
    { 0x9F82E17A, "n_timing" },
    { 0xC45F6FD3, "n_tint" },
    { 0xCCE899F5, "n_titus_kills" },
    { 0xCAE9C1A3, "n_titus_watch" },
    { 0xEE6F3253, "n_to_hudson" },
    { 0xC4F84FCE, "n_to_kill" },
    { 0x0DF5826F, "n_to_spawn" },
    { 0x94D542A1, "n_tolerance" },
    { 0x56B674DC, "n_tolerance_sq" },
    { 0xE7924325, "n_tomahawk_cooking_time" },
    { 0xEDA3F12A, "n_tomahawk_damage" },
    { 0x2A209A10, "n_tomahawk_power" },
    { 0x309AF7F3, "n_too_close" },
    { 0xA4AF3445, "n_top" },
    { 0x3F755758, "n_top_arc" },
    { 0xF1AA5AF2, "n_topper" },
    { 0xA1451CF8, "n_torches_lit" },
    { 0x6C291417, "n_torso_targetting_offset" },
    { 0x9228C252, "n_total" },
    { 0xA6F1C23E, "n_total_count" },
    { 0xDFE16093, "n_total_interact_count" },
    { 0x67B06388, "n_total_kills" },
    { 0x3C4AA6B7, "n_total_path_dist" },
    { 0x9A0023FC, "n_total_tiles" },
    { 0x26786076, "n_total_time" },
    { 0xB3221135, "n_total_weight" },
    { 0x565BC40F, "n_touching_count" },
    { 0xF9033DD7, "n_trace_fudge" },
    { 0x80D700E9, "n_trail_fx" },
    { 0xA1BA564C, "n_trails_fx_id" },
    { 0xB417A5F6, "n_trans_time" },
    { 0xD3FFAE20, "n_trans_time_w" },
    { 0x0E24DA47, "n_trans_time_x" },
    { 0xE8225FDE, "n_trans_time_y" },
    { 0xC21FE575, "n_trans_time_z" },
    { 0x7F50295C, "n_transition_light" },
    { 0x93FC5EA5, "n_transition_off_time" },
    { 0x6086ECB9, "n_transition_on_time" },
    { 0xEFEF78DB, "n_transition_time" },
    { 0x1CE32B8C, "n_travel_time" },
    { 0xDE6F8272, "n_traverse_time" },
    { 0x9F00C8E1, "n_trenchrun_planes" },
    { 0x4B3A1513, "n_tries" },
    { 0xFED4EDF9, "n_trigger_radius" },
    { 0xF1954E83, "n_tube_index" },
    { 0xA3BF5005, "n_turn_speed" },
    { 0x19C9FB9B, "n_turret_index" },
    { 0x26F0BB84, "n_type" },
    { 0x59088081, "n_units" },
    { 0xA0C345AA, "n_unused" },
    { 0xDCE3A9AB, "n_up_force" },
    { 0x498DD4C5, "n_update_time" },
    { 0xE31956BD, "n_update_timer" },
    { 0x01BE3BB3, "n_upgraded_non_wallbuy_cost" },
    { 0x87E7A8F0, "n_upgraded_weapon_ammo_cost" },
    { 0x37A09764, "n_upper_to_player" },
    { 0x8BEB0052, "n_upper_to_qr" },
    { 0xA1709437, "n_using_thumbstick" },
    { 0x529F54A1, "n_val" },
    { 0x3A04FA7E, "n_val_new" },
    { 0xD5FA7963, "n_val_old" },
    { 0xFAFDFAD3, "n_val_w" },
    { 0xF0ECA1F4, "n_val_x" },
    { 0x16EF1C5D, "n_val_y" },
    { 0x3CF196C6, "n_val_z" },
    { 0x953C5F4C, "n_valid_dist_sq" },
    { 0x97B06487, "n_value" },
    { 0x36ABCE96, "n_variable_offset_time" },
    { 0x80932861, "n_vec_length" },
    { 0x78EA1717, "n_veh_near_counter" },
    { 0xC42F311D, "n_veh_wave2bp2" },
    { 0x9A8B13B2, "n_vehicle_gun_index" },
    { 0x132AD7E8, "n_vehicle_size" },
    { 0xDBF53BB7, "n_vehicles" },
    { 0x5DC4D2E1, "n_vehicles_stopped" },
    { 0x90E14FC8, "n_version" },
    { 0x19A0608B, "n_vfx_amount" },
    { 0x661B3B28, "n_view_angle_max" },
    { 0xC0C119B6, "n_view_angle_min" },
    { 0x5BE77A34, "n_view_fraction" },
    { 0x9454E572, "n_view_percentage" },
    { 0x97CDBCEA, "n_viewcone_left" },
    { 0xED926339, "n_viewcone_right" },
    { 0x3A0E8C3E, "n_viewrange" },
    { 0xCB545630, "n_vo_counter" },
    { 0x4B7C4AD8, "n_vo_index" },
    { 0x45D2EBFC, "n_vo_priority" },
    { 0xC3ECC4D6, "n_vo_promises" },
    { 0x7AC4F1BA, "n_volleys" },
    { 0x2711CFA9, "n_vortex_explosion_radius" },
    { 0x1622D891, "n_vortex_radius" },
    { 0x9B22F824, "n_vortex_time" },
    { 0x55D2DB22, "n_vortex_time_cl" },
    { 0x87376058, "n_vortex_time_sv" },
    { 0xC4397E1B, "n_vs_time" },
    { 0xA5658BFF, "n_wagon_fires_out" },
    { 0x506B336F, "n_wait" },
    { 0x5BF7103C, "n_wait_frames" },
    { 0xED3FC9BC, "n_wait_grab" },
    { 0xF05D819F, "n_wait_loop_max" },
    { 0x4334F061, "n_wait_loop_min" },
    { 0x7C278100, "n_wait_max" },
    { 0x2950123E, "n_wait_min" },
    { 0x05C20815, "n_wait_time" },
    { 0xBB89068F, "n_wait_time_default" },
    { 0x83EC64E2, "n_wait_time_max" },
    { 0x595A599C, "n_wait_time_min" },
    { 0xDD9528DC, "n_waittime" },
    { 0xB4EB5F3F, "n_wallbuy_upgrade_cost" },
    { 0x8F6A9D1F, "n_warn1_time" },
    { 0xC3CB30D6, "n_warn2_time" },
    { 0x4582C009, "n_warn3_time" },
    { 0x5D4656F9, "n_warn_time_step" },
    { 0x06704C28, "n_warning" },
    { 0x24BCF266, "n_warning_distance" },
    { 0xEA7A47AD, "n_warning_distance_percentage" },
    { 0x83955433, "n_warning_frequency" },
    { 0xDFBF5D96, "n_warning_frequency_ms" },
    { 0x07ECD881, "n_warp_amount" },
    { 0xC746D299, "n_warp_high" },
    { 0xA903571D, "n_warp_low" },
    { 0x86E5A3BA, "n_warp_time" },
    { 0xBDC1F530, "n_wasp_created_time" },
    { 0x231511B3, "n_wasp_has_move_dist" },
    { 0x2213B225, "n_wasp_health_increase" },
    { 0xE23B4BCD, "n_wasp_health_max" },
    { 0x365A6D2E, "n_wasp_kill_points" },
    { 0x0D560853, "n_wasp_max_life_timeout" },
    { 0xA59CC743, "n_wasp_not_moved_timeout" },
    { 0xB208F216, "n_wasp_player_scalar" },
    { 0xF747E67A, "n_wasps_alive" },
    { 0x104D5676, "n_water_fx_id" },
    { 0xD14DA335, "n_water_height" },
    { 0x58CF314C, "n_water_level_offset" },
    { 0x5ACF21E7, "n_wave" },
    { 0xF210009F, "n_wave3_bp" },
    { 0x6294BADA, "n_wave4_bp" },
    { 0x1BE2E614, "n_wave_1_delay_max" },
    { 0x4674F15A, "n_wave_1_delay_min" },
    { 0x02B57E17, "n_wave_2_delay_max" },
    { 0xE545E969, "n_wave_2_delay_min" },
    { 0x4FC9044F, "n_wave_count" },
    { 0x6000CFA0, "n_wave_count_max" },
    { 0x0D2960DE, "n_wave_count_min" },
    { 0xAE2EFBCA, "n_wave_num" },
    { 0x8034E3E5, "n_wave_size" },
    { 0x31BB1F32, "n_wave_size_max" },
    { 0x46D9C6CC, "n_wave_size_min" },
    { 0xE09DE55E, "n_waves" },
    { 0xB09D3636, "n_waves_until_fail" },
    { 0xCCB968EC, "n_weap_beacon_zombie_thrown_count" },
    { 0xEE5AD949, "n_weapon_counter" },
    { 0x92EB04E1, "n_weapon_index" },
    { 0xCE5A3407, "n_weapon_select" },
    { 0x05780DE5, "n_weight_idle" },
    { 0x2D5187D3, "n_weight_push" },
    { 0xF0B5F217, "n_which" },
    { 0x5CD5B4A0, "n_width" },
    { 0x9763271A, "n_wind_time" },
    { 0x11B8A6EA, "n_windshield_bink_id" },
    { 0xEB3F2EB8, "n_wrong_torches" },
    { 0xBE8789FC, "n_x" },
    { 0xB535978F, "n_x_max" },
    { 0x47BDB931, "n_x_min" },
    { 0xCD83FC0C, "n_x_objective" },
    { 0x550AE1AA, "n_x_vector" },
    { 0x9540241D, "n_xoffset" },
    { 0xCC247884, "n_xp" },
    { 0xE48A0465, "n_y" },
    { 0x6461C7B2, "n_y_max" },
    { 0x79806F4C, "n_y_min" },
    { 0x1C6987C5, "n_y_vector" },
    { 0xF99CBB4D, "n_yaw" },
    { 0xF6621652, "n_yaw_delta" },
    { 0x89F01FF1, "n_yaw_vel" },
    { 0xEA63EB6F, "n_yellow_and_orange" },
    { 0x13886C34, "n_yoffset" },
    { 0x0A8C7ECE, "n_z" },
    { 0xCB9EC651, "n_z_correct" },
    { 0x78CD61FC, "n_z_diff" },
    { 0x510F260C, "n_z_offset" },
    { 0x9229C9C4, "n_z_offset_base" },
    { 0xB32BEFC9, "n_z_spots_found" },
    { 0x51457C2E, "n_zero_1st_warning_message" },
    { 0x6E8421FE, "n_zero_1st_warning_time" },
    { 0x2401E4A6, "n_zero_2nd_warning_message" },
    { 0xC416D6F6, "n_zero_2nd_warning_time" },
    { 0x6F9AC236, "n_zero_speed_max_time_allowed" },
    { 0x4FAEEB0A, "n_zm_weap_rgm3_slow_vortex_lg" },
    { 0x6E1EAAA5, "n_zm_weap_rgm3_slow_vortex_sm" },
    { 0x9731CEF6, "n_znear_old" },
    { 0x52460FF7, "n_zoffset" },
    { 0x324AF286, "n_zombie_count" },
    { 0x621858B3, "n_zombie_count_min" },
    { 0x8113BFE3, "n_zombie_custom_goal_radius" },
    { 0x6A1912FA, "n_zombie_limit" },
    { 0xEF673F05, "n_zombies" },
    { 0x67932CB7, "n_zombies_hit" },
    { 0x9E4A39CC, "n_zombies_lifted_for_ragdoll" },
    { 0x0530E140, "n_zombies_needed_per_zone" },
    { 0x7D372786, "n_zone" },
    { 0x4E53E908, "n_zone_attacker_count" },
    { 0x2D0DC4A6, "n_zone_caps" },
    { 0x6CF55AA8, "n_zones_missing_spawners" },
    { 0x407C81C7, "n_zones_required" },
    { 0x541B0481, "n_zones_using_objective_index" },
    { 0x8D41B4B0, "n_zpos" },
    { 0x8AA61882, "na" },
    { 0xC44F7561, "nacht_exploit" },
    { 0xEDBDF822, "nad" },
    { 0x32F415AB, "nade" },
    { 0x03FA5DB4, "nade_explo" },
    { 0x37CEF639, "nade_target" },
    { 0x8A126C2F, "nade_targs_left" },
    { 0xC147AA54, "nadehint" },
    { 0xA856248A, "nades" },
    { 0x3E9DDEC2, "nadespots" },
    { 0xFAAECA0E, "nading" },
    { 0xC7BB7DB9, "nag" },
    { 0x459DDDEB, "nag0" },
    { 0xD007E979, "nag0_time" },
    { 0x1F9B6382, "nag1" },
    { 0xC96CB995, "nag1_done" },
    { 0x2FEB7576, "nag1_message" },
    { 0xDFF6D246, "nag1_time" },
    { 0xF998E919, "nag2" },
    { 0xE4B983DC, "nag2_done" },
    { 0x136EC729, "nag2_message" },
    { 0x9E2B6C4F, "nag2_time" },
    { 0xD3966EB0, "nag3" },
    { 0x6DC7182B, "nag3_done" },
    { 0x0C29BA74, "nag3_message" },
    { 0xC751D4F4, "nag3_time" },
    { 0x60E56301, "nag_additional_time" },
    { 0x6925B64B, "nag_array" },
    { 0x784790D0, "nag_blow_it" },
    { 0x509802E0, "nag_castle" },
    { 0xF770B10D, "nag_clear_bunker" },
    { 0x33D12A84, "nag_crater_charge" },
    { 0x400193CA, "nag_crouch_time" },
    { 0x921281CB, "nag_destroy_vehicle" },
    { 0x091DBEEC, "nag_dialog" },
    { 0x3A404656, "nag_direction_after_aigroup" },
    { 0xA10EAECC, "nag_dist" },
    { 0x5000E08D, "nag_distance" },
    { 0x87425AFB, "nag_ent" },
    { 0x44A8FF4A, "nag_flag" },
    { 0x89A7F343, "nag_follow" },
    { 0x35E95274, "nag_groups" },
    { 0xAA709837, "nag_hint" },
    { 0xAC55B2B2, "nag_line" },
    { 0x76BE2D3D, "nag_lines" },
    { 0x2C397765, "nag_mason_to_get_to_the_beach" },
    { 0x37BF64B5, "nag_move_forward" },
    { 0x350143FD, "nag_move_foward" },
    { 0x966404FE, "nag_targets" },
    { 0xF008260B, "nag_throw_satchel" },
    { 0xFEEDE02F, "nag_time" },
    { 0x35239391, "nag_units" },
    { 0xAA98E8B8, "nag_until_notify" },
    { 0x390DEFDE, "naganim" },
    { 0x40E4C589, "nagchance" },
    { 0xC4F1F667, "nagged" },
    { 0xEFA24164, "nagging" },
    { 0x0C75B1AB, "nagline" },
    { 0x819C29B0, "nagline_overkill" },
    { 0xF97DAD56, "nagplayer" },
    { 0x543508F0, "nags" },
    { 0x5860A26E, "nagtime" },
    { 0xB5DBB50E, "nah" },
    { 0x0E94E2C9, "nail" },
    { 0x7B5D53F6, "nailed" },
    { 0x4BE20D44, "name" },
    { 0x7EB5B5E5, "name1" },
    { 0xA4B8304E, "name2" },
    { 0xCABAAAB7, "name3" },
    { 0xDEB87E16, "name_array" },
    { 0x27359887, "name_array_index" },
    { 0xFFC6E999, "name_field" },
    { 0xC80C436D, "name_index" },
    { 0x9BE2E160, "name_key" },
    { 0x216ED302, "name_loader" },
    { 0x49E84D85, "name_of_scene" },
    { 0x8D1A5F39, "name_of_spawner" },
    { 0x98203824, "name_of_target" },
    { 0xE4599375, "name_or_spawner" },
    { 0x5B84BE44, "name_or_spawners" },
    { 0xC3B40F75, "name_scene" },
    { 0x53BCE3A8, "name_shared" },
    { 0xCB5977EB, "name_shot" },
    { 0x0D4797DC, "name_str" },
    { 0xC729C99F, "name_string_col" },
    { 0x94267718, "name_view_time" },
    { 0x7667F0E8, "namealias" },
    { 0xE1204588, "named" },
    { 0x4193B1A7, "namedirection" },
    { 0x7A116499, "namedirectionindex" },
    { 0xE0DA0318, "nameindex" },
    { 0x803B38C1, "namekey" },
    { 0x038C8DFC, "namelist" },
    { 0xEC8681E1, "namely" },
    { 0x4B5944F7, "names" },
    { 0x37FB6A71, "names_copies" },
    { 0x53652A18, "namesake" },
    { 0xCFE7FB29, "namesindex" },
    { 0xE22ECE1F, "namesize" },
    { 0xAD6F4136, "namespace" },
    { 0x124AC697, "namestring" },
    { 0xF9A857AA, "nametokens" },
    { 0x6B48EECD, "naming" },
    { 0x28751187, "nang" },
    { 0x78479149, "nangles" },
    { 0xF8613E3F, "nano" },
    { 0x921DD1DD, "nano_glove_left_off" },
    { 0x158C6291, "nano_glove_left_on" },
    { 0x811B9CC4, "nano_glove_right_off" },
    { 0xEADFFD2E, "nano_glove_right_on" },
    { 0x73C574FA, "nano_gloves_off" },
    { 0xEB3FB2CB, "nanoglove_impact" },
    { 0x1566D520, "nanoglove_left_hand_plant" },
    { 0xB07C75C5, "nanoglove_right_hand_plant" },
    { 0x86FA3F8C, "nanotubes" },
    { 0xDF998842, "napalm" },
    { 0xA9CC5A70, "napalm_chain" },
    { 0x1A72A54D, "napalm_death" },
    { 0x90FD8C73, "napalm_destruction" },
    { 0xB0A60821, "napalm_incoming" },
    { 0xA848CC29, "napalm_influencer_radius" },
    { 0xE1BDE86F, "napalm_influencer_score" },
    { 0xC2140723, "napalm_influencer_score_curve" },
    { 0x6ECB5257, "napalm_locations" },
    { 0x04BC7337, "napalm_plane_1_release" },
    { 0xDC7C7094, "napalm_plane_2_release" },
    { 0xC86BC265, "napalm_plane_3_release" },
    { 0xB6EFE7C2, "napalm_plane_4_release" },
    { 0xF72BFCE0, "napalm_planes" },
    { 0x92B51103, "napalm_planes_bomb_ridge" },
    { 0xB5E06C28, "napalm_reaction" },
    { 0xAFE89B56, "napalm_reaction_extra_hero" },
    { 0x3A2DD2CA, "napalm_reaction_polonsky" },
    { 0x49BEB38E, "napalm_reaction_roebuck" },
    { 0xB31CCE74, "napalm_release_1" },
    { 0xB14DE13F, "napalm_spawn_locations" },
    { 0x7614DB57, "napalm_spawnprotection" },
    { 0x2AF0C209, "napalm_zombie_spawners" },
    { 0xEF2A86A9, "napalmblob_mp" },
    { 0x4D1CAA65, "napalmburndist2" },
    { 0xA4BD3181, "napalmdamagedents" },
    { 0xFAED4C1E, "napalmdamagedentscount" },
    { 0x86664483, "napalmdamagedentsindex" },
    { 0x990402D7, "napalmdamageentsthread" },
    { 0x49F81545, "napalmdangermaxradius" },
    { 0x53D9D375, "napalmdangermaxradiussq" },
    { 0x44976441, "napalmexplode" },
    { 0xB7917310, "napalmflamemaxangle" },
    { 0x96A50A76, "napalmflameminangle" },
    { 0x9C207177, "napalmgroundburnarea" },
    { 0xA10A574C, "napalmgrounddamage" },
    { 0x8C2CE279, "napalmgroundflamecount" },
    { 0x63F88982, "napalmgroundflameents" },
    { 0x04983221, "napalmimpactdamageradius" },
    { 0x32650A5C, "napalmlastburntby" },
    { 0x368E7BD9, "napalmlosradiusdamage" },
    { 0x2BCC49D8, "napalmplane" },
    { 0xDD0DEA95, "napalmrewindwatcher" },
    { 0x48E84796, "napalmselectorsize" },
    { 0xF808FD37, "napalmstrikedamage" },
    { 0x2CF7476D, "napalmstrikeinited" },
    { 0x543DD399, "napalmzombiecount" },
    { 0xF9BCE152, "napalmzombiesenabled" },
    { 0xA8E392CC, "naplam" },
    { 0x23430CD1, "narration" },
    { 0xB0DCA5DF, "narration_post_dogsled" },
    { 0xC0108C31, "narrative" },
    { 0x04686991, "narrative_straps" },
    { 0xB3E70C5D, "narrator_pentagon_pool_dialog" },
    { 0x395C028B, "narrator_player_dialog_helipad" },
    { 0xDD5D9F88, "narrator_player_dialog_pentagon" },
    { 0x7A121D58, "narrow" },
    { 0x97B431AD, "narrow_spawner" },
    { 0x9463FA33, "narrows" },
    { 0x775C5EFC, "narrows_blocker" },
    { 0xF23492C8, "narrows_non_rush" },
    { 0x09BED8C2, "narrows_set_rusher" },
    { 0xF63AC8F8, "narrtive" },
    { 0x0AE6A0AA, "nashorn" },
    { 0x3FDC09C9, "nastiness" },
    { 0x0AA8CB48, "nasty" },
    { 0xC2AD123B, "nate" },
    { 0x670D4F96, "nate_test" },
    { 0x54A807B7, "nathan" },
    { 0xE9E62258, "nation" },
    { 0x49E4535C, "nationalites" },
    { 0xC1875611, "nationalities" },
    { 0x06548031, "nationality" },
    { 0x5799B5B4, "native" },
    { 0xEBB10898, "nattacker" },
    { 0x9478702C, "natural" },
    { 0x611BE409, "naturally" },
    { 0xC5913F04, "nature" },
    { 0xF8877320, "nausea" },
    { 0x620EC3B2, "nautical" },
    { 0x41915CC0, "nav" },
    { 0x3E2D9BCA, "nav_display_toggle" },
    { 0xB94AB50C, "nav_mesh" },
    { 0x391CC6C0, "nav_objective" },
    { 0xB447474A, "nav_points_objective" },
    { 0x238C99E3, "nav_points_objective_num" },
    { 0xCF9B2629, "nav_trig" },
    { 0x4D92AA37, "naval" },
    { 0xCDB03D1A, "navcard" },
    { 0x8336CBB5, "navcard_bits" },
    { 0x3D88E938, "navcard_grabbed" },
    { 0x5A333CD2, "navcard_needed" },
    { 0xF0F0371E, "navcard_needed_for_computer" },
    { 0x37133489, "navcard_on_map" },
    { 0x81ABA672, "navcard_pickup_trig" },
    { 0x20955C15, "navcards" },
    { 0x07F323A8, "navcomputer_spawned" },
    { 0xFB610B58, "navcomputer_use_trig" },
    { 0xD28A00BA, "navcomputer_waitfor_navcard" },
    { 0x655ED5AA, "navgation" },
    { 0xF42A3D7E, "navguardposition" },
    { 0x70D096FF, "naviagtion" },
    { 0xEF4E9954, "navigate" },
    { 0xB4622878, "navigated" },
    { 0x5E4BDAC7, "navigates" },
    { 0x49572F23, "navigation" },
    { 0x17215929, "navigationtraining" },
    { 0xFADFBE5B, "navigationtraining_end" },
    { 0xAD5796B8, "navigationtraining_start" },
    { 0xFD098D4F, "navmesh" },
    { 0x307512CA, "navmesh_check" },
    { 0xDEDCE7EB, "navmesh_material_default" },
    { 0xC72C1112, "navmesh_material_none" },
    { 0xC62D1C13, "navmesh_material_novehicle" },
    { 0x0AA9E9AB, "navmesh_material_staircase" },
    { 0xB153704F, "navmesh_material_wallrun" },
    { 0xC08A50F9, "navmesh_material_water" },
    { 0x632D277C, "navmesh_points_visible" },
    { 0x2E1B3E51, "navmesh_wander" },
    { 0xA469775B, "navmesh_zones" },
    { 0xBC052CCE, "navmeshposition" },
    { 0xA36D6FBF, "navugation" },
    { 0xAD441E56, "navvolume" },
    { 0x1F752EDC, "navvolumeorigin" },
    { 0xEDC3A961, "navy" },
    { 0x39896712, "navy_hacker_react" },
    { 0xFA11ADC6, "navy_hacker_wait" },
    { 0x03FF7174, "navy_names" },
    { 0x159615EC, "navyseal_01" },
    { 0x879D8527, "navyseal_02" },
    { 0x619B0ABE, "navyseal_03" },
    { 0xA38EA6B1, "navyseal_04" },
    { 0x7D8C2C48, "navyseal_05" },
    { 0xEF939B83, "navyseal_06" },
    { 0xC991211A, "navyseal_07" },
    { 0x0B84BD0D, "navyseal_08" },
    { 0xE58242A4, "navyseal_09" },
    { 0xBD012A2A, "navyseal_10" },
    { 0xE303A493, "navyseal_11" },
    { 0x70FC3558, "navyseal_12" },
    { 0x96FEAFC1, "navyseal_13" },
    { 0x550B13CE, "navyseal_14" },
    { 0x7B0D8E37, "navyseal_15" },
    { 0x09061EFC, "navyseal_16" },
    { 0x2F089965, "navyseal_17" },
    { 0x8CED56E2, "navyseal_18" },
    { 0xB2EFD14B, "navyseal_19" },
    { 0x3E69C3FF, "navyseal_20" },
    { 0x18674996, "navyseal_21" },
    { 0xF264CF2D, "navyseal_22" },
    { 0xCC6254C4, "navyseal_23" },
    { 0xA65FDA5B, "navyseal_24" },
    { 0x010B0495, "nazi" },
    { 0xDA2DF04C, "nazi_zombie_asylum" },
    { 0xA2996CF2, "nazi_zombie_asylum_art" },
    { 0x81AB55E5, "nazi_zombie_asylum_fx" },
    { 0xB5D7B571, "nazi_zombie_factory" },
    { 0x54A7E1D3, "nazi_zombie_factory_art" },
    { 0x573554A6, "nazi_zombie_factory_fx" },
    { 0xD008B384, "nazi_zombie_factory_teleporter" },
    { 0x3E58B8E3, "nazi_zombie_farm_art" },
    { 0x0C2798F6, "nazi_zombie_farm_fx" },
    { 0xFE796E01, "nazi_zombie_heroes" },
    { 0x505CCE3B, "nazi_zombie_prototype_art" },
    { 0xA63FD5EE, "nazi_zombie_prototype_fx" },
    { 0x69726D11, "nazi_zombie_prototype_points" },
    { 0x2485DCBE, "nazi_zombie_prototype_waves" },
    { 0xD92C28A8, "nazi_zombie_sumpf" },
    { 0x714FE2FB, "nazi_zombie_sumpf_ammo_box" },
    { 0xEF30A85E, "nazi_zombie_sumpf_art" },
    { 0xCE66D536, "nazi_zombie_sumpf_blockers" },
    { 0xFA9825FF, "nazi_zombie_sumpf_bouncing_betties" },
    { 0x0E66D6D0, "nazi_zombie_sumpf_bridge" },
    { 0xFD4C96E9, "nazi_zombie_sumpf_fx" },
    { 0xBAB54252, "nazi_zombie_sumpf_magic_box" },
    { 0xAAA51D7E, "nazi_zombie_sumpf_perks" },
    { 0xD5677015, "nazi_zombie_sumpf_trap_barrel" },
    { 0x46CAC75C, "nazi_zombie_sumpf_trap_electric" },
    { 0x1F127247, "nazi_zombie_sumpf_trap_pendulum" },
    { 0xDBDB950D, "nazi_zombie_sumpf_trap_perk_electric" },
    { 0x7815A74A, "nazi_zombie_sumpf_trap_propeller" },
    { 0xE8B4DF72, "nazi_zombie_sumpf_zipline" },
    { 0xE1149F99, "nazi_zombie_sumpf_zone_management" },
    { 0x8EC80B31, "nazibase_end_start" },
    { 0xF38C799B, "nazibase_firsthill_vips" },
    { 0xD77911C1, "nazibase_hangar_start" },
    { 0xAA9025F4, "nazibase_mortarcycle" },
    { 0x267B438F, "nazibase_outro_weapon_model" },
    { 0xC99DA94F, "nazibase_outrocinema" },
    { 0x51D974F6, "nazibase_retreat1_thread" },
    { 0x8605E72F, "nazibase_retreat2_thread" },
    { 0x9A948069, "nazibase_retreat_guy_thread" },
    { 0x14553B74, "nazibase_stopmortar1_checkpoint" },
    { 0xCC65B6B8, "nazibase_stopmortar2" },
    { 0x3CD97B18, "nazibase_surrender_thread" },
    { 0x27786DE4, "nazis" },
    { 0xC07706A4, "nazizombies_checking_for_cheats" },
    { 0xE8B7C839, "nazizombies_set_new_zombie_stats" },
    { 0x96EA8E55, "nazizombies_upload_highscore" },
    { 0x9ABEAB5F, "nazizombies_upload_solo_highscore" },
    { 0x64A39E19, "nb" },
    { 0x13820196, "ncount" },
    { 0xC06E9537, "ncreases" },
    { 0x8529FAEC, "ncurrent_speed" },
    { 0x48B27C8F, "nd" },
    { 0x1EFDE1E7, "nd_1" },
    { 0xACF672AC, "nd_2" },
    { 0xD2F8ED15, "nd_3" },
    { 0x60F17DDA, "nd_4" },
    { 0x4C82C4D9, "nd_after_table_flip_hall" },
    { 0xECF2DF80, "nd_after_table_flip_open" },
    { 0x86E448BA, "nd_anim_point" },
    { 0xC70C0973, "nd_apc_death" },
    { 0xA5DD8912, "nd_approach" },
    { 0x0A70C872, "nd_arch" },
    { 0x71F6480E, "nd_attack" },
    { 0xCAC8B56E, "nd_balcony" },
    { 0x605A0CE8, "nd_belltower" },
    { 0x2104BFE4, "nd_best" },
    { 0x9D79A8B1, "nd_best_start" },
    { 0xDA21E3E0, "nd_box_truck_stop" },
    { 0xDAB3DDA7, "nd_buffel_start" },
    { 0x46CD1CB4, "nd_cache" },
    { 0x8A625FDA, "nd_car_goal" },
    { 0x4A60979D, "nd_cartel_target" },
    { 0x16B5F27E, "nd_chopper_path_start" },
    { 0xE6DCB217, "nd_claw_1" },
    { 0x74D542DC, "nd_claw_2" },
    { 0x8F736B07, "nd_closest" },
    { 0x3B0B2C66, "nd_coke_2nd_floor" },
    { 0x97D8EBB9, "nd_cougar_path" },
    { 0x0974CC07, "nd_cover" },
    { 0x26968AFC, "nd_cover_patrol" },
    { 0x8DB9A64F, "nd_cover_patrol_passed" },
    { 0xBD41CB98, "nd_cover_sewer_dropdown" },
    { 0x2788F791, "nd_crew" },
    { 0x3125600C, "nd_crosby_briggs_scene" },
    { 0xFA4823A2, "nd_crosby_chamber_node" },
    { 0x7CA89133, "nd_crosby_defend" },
    { 0x84DC7ED2, "nd_crosby_escape" },
    { 0xC6D18F6C, "nd_crosby_first_floor" },
    { 0x98987405, "nd_crosby_lab_entrance" },
    { 0x3C814D13, "nd_crosby_lift_node" },
    { 0x881235B6, "nd_crosby_pre_ddm" },
    { 0xD42BC7E7, "nd_crosby_pre_lab_entrance" },
    { 0xC3406072, "nd_crosby_pre_lift" },
    { 0x5093129B, "nd_crosby_pre_stairs" },
    { 0x8C6D27F1, "nd_crosby_top_stairs" },
    { 0xA027B47E, "nd_crosby_wall_node" },
    { 0xC12B9C4E, "nd_curr" },
    { 0xC90B5E20, "nd_curr_goal" },
    { 0x979DA375, "nd_current" },
    { 0xD9A7BB24, "nd_death" },
    { 0x80BAAA8B, "nd_delete" },
    { 0xC19AAC3C, "nd_delete_fire_civs" },
    { 0x63CEADAE, "nd_delete_fire_civs_array" },
    { 0xEC4D05C2, "nd_delete_kill" },
    { 0x5695413C, "nd_delete_learjet_seals" },
    { 0x0CD5628D, "nd_delete_seal_group_1" },
    { 0x32D7DCF6, "nd_delete_seal_group_2" },
    { 0x0EC7DCCC, "nd_delete_seals" },
    { 0x5BD22E42, "nd_dest" },
    { 0xFF260E54, "nd_detour_entry" },
    { 0x5C7E0F60, "nd_die" },
    { 0x36332336, "nd_door" },
    { 0x8F42A208, "nd_door_goal" },
    { 0xE3233366, "nd_driver_exit_node" },
    { 0x28A7F546, "nd_drone_intro_start" },
    { 0x7860E981, "nd_dynamic" },
    { 0xCBE4132F, "nd_e_goal" },
    { 0xD39ADF95, "nd_eland_start" },
    { 0x4139A742, "nd_elevator_exit_node" },
    { 0xA8015C01, "nd_end" },
    { 0x8F468751, "nd_end2" },
    { 0x69440CE8, "nd_end3" },
    { 0xCD3295F2, "nd_entry" },
    { 0xB6C832FB, "nd_escape_path" },
    { 0x77200B30, "nd_eval" },
    { 0x368248F2, "nd_exit" },
    { 0x5BDD8D01, "nd_exit_club" },
    { 0xE798B184, "nd_exit_path" },
    { 0xD2B632E3, "nd_explosion" },
    { 0x9A8D35E4, "nd_exterior_left" },
    { 0x9FE994DB, "nd_exterior_right" },
    { 0x2589A452, "nd_f_goal" },
    { 0x90D54B71, "nd_fall" },
    { 0xB56ABDAC, "nd_fallback" },
    { 0xE202953B, "nd_farthest" },
    { 0xE700B161, "nd_final_push" },
    { 0xA398226F, "nd_final_push_eland1" },
    { 0x3190B334, "nd_final_push_eland2" },
    { 0x57932D9D, "nd_final_push_eland3" },
    { 0xCC6B2C66, "nd_fire" },
    { 0x83645974, "nd_first" },
    { 0x15D322B3, "nd_first_node" },
    { 0x135EF31B, "nd_flareguy" },
    { 0xCD7D07DF, "nd_flyby_start" },
    { 0x9CA38D5A, "nd_front_door" },
    { 0xC1BFF67A, "nd_gaz_start1" },
    { 0x9DE10FE3, "nd_goal" },
    { 0x350C27EF, "nd_goto" },
    { 0x2AA96F24, "nd_goto1" },
    { 0x9CB0DE5F, "nd_goto2" },
    { 0xB2B61FC5, "nd_guard" },
    { 0xB52D8F45, "nd_gunner_exit_node" },
    { 0x03449AD0, "nd_harper" },
    { 0x8629F666, "nd_harper_celerium_door" },
    { 0x9B9ED1AB, "nd_harper_defend" },
    { 0x68363C92, "nd_harper_defend_cover_node" },
    { 0x88BEC81A, "nd_harper_defend_node" },
    { 0x876D1B9A, "nd_harper_escape" },
    { 0xAF7C5227, "nd_harper_exit" },
    { 0x731D4534, "nd_harper_first_floor" },
    { 0xBBD06B2E, "nd_harper_pre_ddm" },
    { 0x67DCE00D, "nd_harper_pre_defend" },
    { 0x2463D732, "nd_harper_pre_garage" },
    { 0xA3E7FEAA, "nd_harper_pre_lift" },
    { 0x87ECCD23, "nd_harper_pre_stairs" },
    { 0xE65588D9, "nd_harper_titus_node" },
    { 0xEA56F469, "nd_harper_top_stairs" },
    { 0xDF15EB46, "nd_harper_wall_node" },
    { 0x175AE032, "nd_hill_buffel" },
    { 0xCA80ED94, "nd_hill_buffel2" },
    { 0x0A66A9DC, "nd_hill_eland" },
    { 0xCAE00C31, "nd_hind" },
    { 0xEEBC6A58, "nd_horse_path_start" },
    { 0x6FFC8E0E, "nd_interior_left" },
    { 0xE20D3FC5, "nd_interior_right" },
    { 0xD587A688, "nd_intro" },
    { 0xC827CB9F, "nd_intro_building_boom" },
    { 0xD8F14CFD, "nd_intro_convoy_boom" },
    { 0xC0C46578, "nd_join_path" },
    { 0x36EE6492, "nd_jump" },
    { 0x19123395, "nd_knockoff" },
    { 0x5576DC56, "nd_last" },
    { 0x6DD115E0, "nd_last_path" },
    { 0x29057281, "nd_leaper_cover" },
    { 0x02466CF9, "nd_leaper_goal" },
    { 0xE8E34082, "nd_lift_crosby" },
    { 0x7C18E7E0, "nd_lift_salazar" },
    { 0x776D98F5, "nd_linked" },
    { 0xA29256DF, "nd_mantler_cover" },
    { 0xC910613B, "nd_mantler_goal" },
    { 0x70921CD4, "nd_mason_beach" },
    { 0x336EBF22, "nd_mason_catwalk" },
    { 0xD94F285D, "nd_mason_gauntlet" },
    { 0x76E1FB06, "nd_mason_hangar" },
    { 0x17CBF1A8, "nd_mason_post_hangar_door" },
    { 0xA355A827, "nd_mason_post_knife" },
    { 0xC1D34925, "nd_mason_post_learjet" },
    { 0x20CAFDB3, "nd_mason_pre_bash" },
    { 0xBED64511, "nd_mason_roof" },
    { 0xDF6D9F51, "nd_mason_stairs" },
    { 0x2F5351A1, "nd_mason_start" },
    { 0xF08F69FC, "nd_motel_door" },
    { 0x1735B049, "nd_next" },
    { 0x1F81C420, "nd_next_node" },
    { 0x2616E589, "nd_next_path" },
    { 0x22752FDE, "nd_node" },
    { 0xE1E8EDBE, "nd_node_a" },
    { 0xBBE67355, "nd_node_b" },
    { 0x95E3F8EC, "nd_node_c" },
    { 0x5AA827F9, "nd_node_org" },
    { 0x55AD3F54, "nd_noriega_start" },
    { 0x93E2A4C1, "nd_old" },
    { 0x77739C8F, "nd_path" },
    { 0x236C92AC, "nd_path_2" },
    { 0x2F708FDE, "nd_path_node" },
    { 0xAC0CA58A, "nd_path_start" },
    { 0xED1293B3, "nd_patrol_b_special" },
    { 0xEE6B0808, "nd_pause" },
    { 0xE0A7C591, "nd_pause1" },
    { 0x06AA3FFA, "nd_pause2" },
    { 0x2CACBA63, "nd_pause3" },
    { 0xAA6E19BE, "nd_pickup" },
    { 0xC5CB440A, "nd_pillar" },
    { 0x3702644A, "nd_plane_about_to_crash_1" },
    { 0x10FFE9E1, "nd_plane_about_to_crash_2" },
    { 0xA4DA3E05, "nd_player_shooting_end" },
    { 0x90EAFBD0, "nd_point" },
    { 0xAF4078EC, "nd_pos" },
    { 0x6E090630, "nd_post_rpg" },
    { 0x22436C69, "nd_prev" },
    { 0xA11ED6A9, "nd_previous" },
    { 0x4CFBBF16, "nd_previous_x2" },
    { 0x72FE397F, "nd_previous_x3" },
    { 0xBDD10BF3, "nd_radio_antenna_boom" },
    { 0x93E3EAC7, "nd_ready" },
    { 0xDA6FEDDB, "nd_redshirt1_vent_node" },
    { 0x2E9A4B30, "nd_redshirt2_vent_node" },
    { 0x43204A4E, "nd_rejoin_convoy" },
    { 0x1E63D44F, "nd_retreat" },
    { 0xDB42A932, "nd_rooftop_pdf_engager" },
    { 0xB6FAD313, "nd_rpg" },
    { 0x64D2A24E, "nd_rpg_spot" },
    { 0xBEA85066, "nd_runto" },
    { 0x02467EFC, "nd_safe_spot" },
    { 0xC93295FE, "nd_sal" },
    { 0x1054B8F2, "nd_salazar" },
    { 0x8BD1D0F2, "nd_salazar_briggs_scene" },
    { 0x69DBB41C, "nd_salazar_celerium_door" },
    { 0xA0CCFD65, "nd_salazar_defend" },
    { 0x23C1E0A3, "nd_salazar_entrance" },
    { 0x16AD65B4, "nd_salazar_escape" },
    { 0x509E74D2, "nd_salazar_first_floor" },
    { 0x0EF82FE9, "nd_salazar_post_clean" },
    { 0x784832EE, "nd_salazar_pre_clean" },
    { 0xEA7A711C, "nd_salazar_pre_ddm" },
    { 0x0F0DDED0, "nd_salazar_pre_lift" },
    { 0x10168289, "nd_salazar_pre_stairs" },
    { 0x6C88D11B, "nd_salazar_start" },
    { 0x7887B3A7, "nd_salazar_top_stairs" },
    { 0xE49283E4, "nd_salazar_wall_node" },
    { 0xCF4BA7CE, "nd_seal_2" },
    { 0x0388A07D, "nd_second_node" },
    { 0x541961C6, "nd_shack_center" },
    { 0x49284157, "nd_shoot" },
    { 0xF1412674, "nd_side_reinforcement_node" },
    { 0x1E3C8556, "nd_slide_guy1" },
    { 0xF83A0AED, "nd_slide_guy2" },
    { 0xB19268F4, "nd_sniper_death" },
    { 0xC3564E6E, "nd_sniper_node" },
    { 0x83D82B37, "nd_soct_intro_start" },
    { 0xC44BCB87, "nd_spawn" },
    { 0x8D6B971C, "nd_spawn_container_pdf" },
    { 0xF9ABC1FB, "nd_spawnpt" },
    { 0xB0DA087C, "nd_spline_start" },
    { 0x2657B0E6, "nd_stairwell_entrance" },
    { 0x3C54858A, "nd_start" },
    { 0xC987A657, "nd_start1" },
    { 0x5780371C, "nd_start2" },
    { 0x7D82B185, "nd_start3" },
    { 0x0B7B424A, "nd_start4" },
    { 0xF17913FB, "nd_start_first_wave" },
    { 0x9D1ABAE9, "nd_start_node" },
    { 0xCCF4D32C, "nd_start_path" },
    { 0xA3B225D1, "nd_start_point" },
    { 0x350EAE62, "nd_stop" },
    { 0x3AEDBB09, "nd_street_middle" },
    { 0xA3ACD2E6, "nd_swerve" },
    { 0xC6342F3D, "nd_target" },
    { 0x01B82554, "nd_temp" },
    { 0xA365BC92, "nd_test" },
    { 0xEE22D3A2, "nd_tether" },
    { 0xA212EE30, "nd_train_top" },
    { 0xC2C49B4C, "nd_traversal" },
    { 0x51A35D76, "nd_truck_start" },
    { 0xDD609388, "nd_turret" },
    { 0x79E40FC7, "nd_v_start_array" },
    { 0xA4C3D6BC, "nd_vtol_start" },
    { 0x9A3EA5BF, "nd_vtol_stop_spot" },
    { 0x5DC95129, "nd_wait" },
    { 0x5ECC80EF, "nd_warp_point" },
    { 0x00D7FE94, "nd_woods" },
    { 0x4902B718, "nd_zhao" },
    { 0x15BE74C2, "nd_zhao_horse" },
    { 0x6EA8BB94, "ndirection" },
    { 0xBF745945, "nduration" },
    { 0x22B00226, "ne" },
    { 0xC47AEE23, "near" },
    { 0xDA151787, "near_barricade" },
    { 0x9B7C9BA1, "near_blur" },
    { 0xAAFC7465, "near_blur_1" },
    { 0xD0FEEECE, "near_blur_2" },
    { 0x3F0FBB11, "near_bridge" },
    { 0xEB6680E9, "near_building_dist" },
    { 0x43E1A401, "near_camp" },
    { 0x3179E48E, "near_catwalk_drone" },
    { 0x4A682285, "near_circle_pos" },
    { 0x8B3E766E, "near_convoy_fail_watcher" },
    { 0xFCA699E9, "near_cover_node_sq" },
    { 0xE5681A07, "near_cover_node_wide_sq" },
    { 0x1DB6B82F, "near_default_path_end" },
    { 0xB446893A, "near_dist" },
    { 0x2C0CE2F9, "near_dist_sq" },
    { 0x1CEAD675, "near_end" },
    { 0xEE6884D1, "near_end_1" },
    { 0x146AFF3A, "near_end_2" },
    { 0xC17A1B82, "near_fork" },
    { 0x48A3D97F, "near_goal" },
    { 0xDA9D1E96, "near_goal_dist" },
    { 0xE6513C01, "near_goal_notify" },
    { 0x442DF244, "near_goal_notify_dist" },
    { 0xCEB2C8D6, "near_miss" },
    { 0x12C05516, "near_node_dist_sqr" },
    { 0x69E0D43D, "near_nodes" },
    { 0x6E5855CF, "near_owner" },
    { 0x98ABE1DE, "near_pipes_drone" },
    { 0x485821D9, "near_player" },
    { 0x07B8CE1B, "near_player_nodes" },
    { 0x68EF9890, "near_players" },
    { 0xFDD1B44A, "near_poi" },
    { 0xA0B9D9CE, "near_points_dist" },
    { 0x8C60693A, "near_rope" },
    { 0x1BF45F34, "near_shore_trigger" },
    { 0x17720116, "near_start" },
    { 0xFDCB2CB6, "near_start_1" },
    { 0xD7C8B24D, "near_start_2" },
    { 0xC5328F76, "near_town" },
    { 0xE66CFD21, "near_town_axis_alert" },
    { 0xAC0328B2, "near_town_axis_damage" },
    { 0x75FEA77C, "near_town_crouch_alert" },
    { 0xF0BF265E, "near_town_dmg_trigger" },
    { 0x7AB14199, "near_town_grenade_watch" },
    { 0x7E4F166C, "near_tv" },
    { 0x25F5FF53, "near_zombies" },
    { 0x0190BAF9, "nearactive" },
    { 0x052EC890, "nearaiarray" },
    { 0x988627C0, "nearairushesplayer" },
    { 0x52F1798C, "nearblur" },
    { 0x76411425, "nearboat" },
    { 0x715ED0FF, "nearbus" },
    { 0x5F32D050, "nearby" },
    { 0x59C939C5, "nearby_ai" },
    { 0xF3AB8B69, "nearby_ai_react_to_mortar" },
    { 0x51A6527B, "nearby_destry_at_end_vehicle" },
    { 0x619204FD, "nearby_distance_sq" },
    { 0xCCD62E6D, "nearby_distance_z" },
    { 0x8BECF125, "nearby_enemy_threshold" },
    { 0xE44689EF, "nearby_enemy_time" },
    { 0xE2D67B4B, "nearby_guys_rush_plane" },
    { 0xC0B1FB8F, "nearby_non_hero" },
    { 0x136A5A79, "nearby_trig" },
    { 0x52EB95E5, "nearbybadamount" },
    { 0x7A313521, "nearbydogs" },
    { 0x203000AA, "nearbyenemyminorpenalty" },
    { 0x0E52D754, "nearbyenemyouterrange" },
    { 0xAB9ACCEC, "nearbyenemyouterrangesq" },
    { 0x8571A09B, "nearbyenemypenalty" },
    { 0x2E3C2533, "nearbyfriendlycheck" },
    { 0x04525162, "nearbyfriendlycount" },
    { 0x2783A826, "nearbyplayers" },
    { 0x111B688C, "nearbyspawns" },
    { 0xB0CD6F41, "nearbyspeakeractive" },
    { 0x6EAB0407, "nearcanoe" },
    { 0xCACE146D, "nearclaimnodeandangle" },
    { 0x35D7129B, "neardest" },
    { 0x3004755F, "neardist" },
    { 0xF8BC42C2, "nearend" },
    { 0x7FE578FE, "nearer" },
    { 0xDAA34DD1, "nearest" },
    { 0x8685793E, "nearest_ai" },
    { 0xB61B1754, "nearest_dist" },
    { 0x6B947927, "nearest_dist_sq" },
    { 0x6B3D0CEC, "nearest_distsq" },
    { 0x3870EEE8, "nearest_enemy_sqrd_dist" },
    { 0x9176F47C, "nearest_friend" },
    { 0xAD0C6168, "nearest_node" },
    { 0xB6938543, "nearest_player" },
    { 0x101BC408, "nearest_puddle" },
    { 0xE0EF3A4B, "nearest_puddle_dist" },
    { 0xEB460541, "nearestdistsq" },
    { 0xBEE6C5A3, "nearestenemy" },
    { 0x5AB0759A, "nearestenemyscramblercent" },
    { 0x3951DAE0, "nearestfriendly" },
    { 0x145B83A7, "nearestpane" },
    { 0x6BCEAA8F, "nearestpanedistsq" },
    { 0x1FE1E0CE, "nearestplayer" },
    { 0xF365B3A2, "nearestplayernode" },
    { 0xB8CBB409, "nearestpoint" },
    { 0xCD8F2BEC, "nearestpointonline" },
    { 0x60C5E9E1, "nearestpos" },
    { 0xDEA3BA93, "nearestzombienode" },
    { 0xBF24FF53, "neargun" },
    { 0xF46104FD, "nearing" },
    { 0x5ABB83F1, "nearish" },
    { 0xF7A8043D, "nearlosing" },
    { 0x3320434E, "nearly" },
    { 0xEFEFD787, "nearmiss" },
    { 0x71FD849B, "nearnode" },
    { 0x4576E793, "nearplane" },
    { 0x1EF3F3DF, "nearpos" },
    { 0xF6AF0212, "nears" },
    { 0x23302EB7, "nearspawns" },
    { 0x384CDA39, "nearstart" },
    { 0xD72D78D0, "nearteam" },
    { 0x62668495, "nearwinning" },
    { 0xB2CA99BB, "neccessary" },
    { 0xC685456D, "necesary" },
    { 0xA71B8083, "necessaey" },
    { 0xE7EB04A7, "necessarily" },
    { 0x4FEE274A, "necessary" },
    { 0x4EA82B04, "necessity" },
    { 0x997B3798, "neck" },
    { 0x12B36C1B, "neck_pos" },
    { 0x1611D670, "necklace_mod" },
    { 0xCC54A54F, "necrosis" },
    { 0x1351169F, "nect" },
    { 0x9A0B32D6, "ned" },
    { 0xBCCD1DA9, "need" },
    { 0x7B17F7F1, "need_all_pieces" },
    { 0x47337A8F, "need_closest_player" },
    { 0x02D0EB42, "need_deletion" },
    { 0x868BE7CA, "need_device" },
    { 0x2BE69209, "need_left_hand" },
    { 0x27F59598, "need_more_allies_or_axis" },
    { 0x3E224F6E, "need_more_enemies" },
    { 0x2F62182D, "need_more_enemies_of_type" },
    { 0x55D0D260, "need_new_solution" },
    { 0x674B7335, "need_notetrack" },
    { 0x6DDB1BF7, "need_script_move" },
    { 0x3EE0D4E8, "need_to_die" },
    { 0x3280BEF3, "need_to_rebuild" },
    { 0xB20DB4BD, "need_to_run" },
    { 0x876A2D83, "need_to_see" },
    { 0xE2E8C664, "need_to_spawn_ai" },
    { 0x0182EC87, "need_to_strafe" },
    { 0xEA2D819A, "need_to_switch" },
    { 0xB8B02F10, "need_to_switch_weapons" },
    { 0x3F2A53A7, "need_to_turn" },
    { 0x64C20421, "need_to_turn_around" },
    { 0x20A5146F, "need_wait" },
    { 0x3A6B35D6, "needed" },
    { 0x2ECB02E3, "needed_dmg" },
    { 0xF46FD87B, "neededgoodtraces" },
    { 0xF707ECDF, "needing" },
    { 0x5731452F, "needledrop" },
    { 0xE9593D9F, "needlessly" },
    { 0x995991EC, "needrecalculategoodshootpos" },
    { 0xFE6C16CF, "needrecalculatesuppressspot" },
    { 0x4D674E20, "needs" },
    { 0xE6C223F5, "needs_action" },
    { 0x21591787, "needs_fixup" },
    { 0xD7B559D8, "needs_left" },
    { 0x5610D818, "needs_revive" },
    { 0xFC000B32, "needs_run_update" },
    { 0xA0F55ABD, "needs_sprint_release" },
    { 0x77317C95, "needs_start" },
    { 0xAA20DD12, "needs_to_run" },
    { 0x60E37F3E, "needscol" },
    { 0x0BBF24F5, "needsdelayedupdate" },
    { 0xC7AE07C2, "needspawn" },
    { 0x7FFF272E, "needsprecaching" },
    { 0x17CAEE11, "needsrestart" },
    { 0x3C3100E3, "needsrevive" },
    { 0x32D08CA2, "needstorechamber" },
    { 0x60D85753, "needsupdate" },
    { 0x8FA32339, "needswitch" },
    { 0x0B830CB9, "needteleportin" },
    { 0x3993B370, "needteleportout" },
    { 0x95B2B202, "needtochangecovermode" },
    { 0x68032B45, "needtopauseatstart" },
    { 0x5C1991C5, "needtorechamber" },
    { 0xFE9CC249, "needtoreload" },
    { 0x026D8B4F, "needtoturn" },
    { 0xA0A04847, "needtovisit" },
    { 0xBB6AFFA7, "neeeded" },
    { 0x7408B86D, "neg" },
    { 0xEFCA051F, "neg_end" },
    { 0x928D7361, "neg_height" },
    { 0xE146DC54, "neg_start" },
    { 0xB66F7247, "negate" },
    { 0xFD5DD23E, "negates" },
    { 0x323F5D8C, "negation" },
    { 0xC069E498, "negative" },
    { 0xE5520404, "negative_lines" },
    { 0xEBA10EE9, "negative_t" },
    { 0xB3BECBD5, "negative_x" },
    { 0xFFC3C0A7, "negative_z" },
    { 0xD70BD623, "negativehud" },
    { 0x6BA0079D, "negatively" },
    { 0x91CFD873, "negatives" },
    { 0xBCACAE6B, "negcos45" },
    { 0xA7A61BB7, "negligible" },
    { 0x01F3F90C, "negotiation" },
    { 0x2A8AE29E, "negotiation_begin" },
    { 0x86D7DC0B, "neighbor" },
    { 0x9748D36A, "neighbors" },
    { 0x17525CE5, "neil" },
    { 0xB8CA7DF2, "neither" },
    { 0xD6497423, "nemesis" },
    { 0x13DFCD67, "nemesisamount" },
    { 0xCD81E6CE, "nemesisarray" },
    { 0x08923763, "nemesisarraykey" },
    { 0x661A1D52, "nemesisarraykeys" },
    { 0x29B07E5E, "nemesisname" },
    { 0x4A4628F4, "nemesisplayer" },
    { 0x6EF3D2D3, "nemesisplayerent" },
    { 0x9AE2CA21, "neon" },
    { 0xD1E50857, "neon_sign" },
    { 0xE1C07E11, "neon_sign_alley" },
    { 0x0DDBE870, "neon_sign_alley_start" },
    { 0x2170B7A2, "neon_sign_start" },
    { 0x714D7881, "nepal" },
    { 0x408D2BC7, "nerds" },
    { 0x4479E6D7, "nero" },
    { 0x7C1BF90F, "nerve" },
    { 0xB6BD0B10, "ness" },
    { 0xC0CE63EF, "nest" },
    { 0xCC0AB34C, "nest_2" },
    { 0xFA117236, "nests" },
    { 0xFA32D966, "net" },
    { 0x772913B7, "netfriendly" },
    { 0xBDE21A99, "nets" },
    { 0xD099D565, "network" },
    { 0xEF682305, "network_choke_action" },
    { 0x8E01EBC1, "network_choke_init" },
    { 0x50622110, "network_choke_safe" },
    { 0xFE830B5B, "network_choke_thread" },
    { 0x723E3503, "network_death_choke" },
    { 0xB5A37462, "network_entity_valid" },
    { 0x2DFD48AF, "network_frame" },
    { 0x30AF7D2D, "network_intruder" },
    { 0x4BFF34CC, "network_safe_init" },
    { 0x85B9AB21, "network_safe_play_fx" },
    { 0x3544631A, "network_safe_play_fx_on_tag" },
    { 0xE02C9BE7, "network_safe_spawn" },
    { 0x9C507E5D, "network_safe_stalingrad_spawn" },
    { 0x247216C3, "network_stall_counter" },
    { 0x50F1C052, "networked" },
    { 0x56D0F4C3, "networking" },
    { 0x25646C5C, "networkintruder" },
    { 0x5AD86703, "networkintruder_watchgunuse" },
    { 0x6F459FFC, "networkintruderdetonate" },
    { 0x0B45AA9F, "networkintruders" },
    { 0xA69F0AAF, "networksafereset" },
    { 0xFBC863AA, "neutral" },
    { 0x30AE2627, "neutral_ai" },
    { 0x882D39E3, "neutral_flag_influencer" },
    { 0xFE56D020, "neutralflag" },
    { 0x614F0886, "neutralflagorigin" },
    { 0x514AD748, "neutralize" },
    { 0x19C8B75C, "neutralized" },
    { 0x5131B949, "neutralizing" },
    { 0xFFAC2965, "neutrals" },
    { 0xBE544E22, "neutraltrigger" },
    { 0xFD9DE831, "never" },
    { 0xCF49ABB8, "never_overheat" },
    { 0x18747F71, "never_power_off" },
    { 0xE452D7C5, "never_power_on" },
    { 0x37B0C52A, "never_spawned_count" },
    { 0x2B489F08, "neverdelete" },
    { 0x755D5CC5, "neverlean" },
    { 0xF196B941, "nevermind" },
    { 0x0AC2CF41, "neversprintforvariation" },
    { 0xDC63F433, "nevksi" },
    { 0x8B45CE83, "nevski" },
    { 0x7F522B2D, "nevski_barricade_anim" },
    { 0xACD302F8, "nevski_dialogue" },
    { 0x893CBBF1, "nevski_door_node" },
    { 0xEB6D7513, "nevsky" },
    { 0xD4305EFD, "new" },
    { 0x3790D3C8, "new debug_vehiclesetspeed" },
    { 0x58F8ECE5, "new2" },
    { 0x67E94495, "new_aatarget" },
    { 0x4FFCA9E2, "new_ability" },
    { 0x3DBF2592, "new_accel_state" },
    { 0x49D4F506, "new_actor_moveto" },
    { 0xF526B7A1, "new_after_death_vo" },
    { 0x311799AC, "new_alpha" },
    { 0xE728627D, "new_ammo_stock" },
    { 0x4A2E7664, "new_amount" },
    { 0xA54785D0, "new_ang" },
    { 0xF6EEA5D9, "new_angle" },
    { 0x3FE16490, "new_angles" },
    { 0xC03292FE, "new_anim_node" },
    { 0x1B19FB5F, "new_anim_reach" },
    { 0x2FE0C15A, "new_animation" },
    { 0x94FA12E5, "new_area_struct" },
    { 0x262C63F7, "new_array" },
    { 0x4401C6D3, "new_attack_spot" },
    { 0x4E47E6AB, "new_attack_spot2" },
    { 0xC5F559E5, "new_ballistic" },
    { 0x32D5CA61, "new_bink_monitor_randomize" },
    { 0x97B57AD6, "new_black_hole_struct" },
    { 0x2A1365BB, "new_blur_manager" },
    { 0x4BC32D34, "new_body" },
    { 0x040AAE89, "new_bomb_index" },
    { 0x34F4EC6D, "new_bomber_track" },
    { 0x95E3EE4A, "new_bucket" },
    { 0x42B7D4CF, "new_bunker_name" },
    { 0xA4006D9A, "new_bus" },
    { 0x1693A15A, "new_c4count" },
    { 0x6ED6321D, "new_cam" },
    { 0x26ADFFF0, "new_cam_angles" },
    { 0x24C555E9, "new_cam_position" },
    { 0xE637892D, "new_camera" },
    { 0x08ED1881, "new_camera_switcher" },
    { 0xCCBAEF9A, "new_car" },
    { 0x3969D098, "new_category" },
    { 0x94FEB7AC, "new_category_axis" },
    { 0x5F6F7978, "new_change_hint_string" },
    { 0x3B4E02D0, "new_chopper_findpath" },
    { 0x2684EA73, "new_cigar_rotation" },
    { 0xA71892F1, "new_claw_ai_angles" },
    { 0xFBE8840F, "new_claw_ai_origin" },
    { 0x3398DB73, "new_claw_vehicle_angles" },
    { 0xA184E86D, "new_claw_vehicle_origin" },
    { 0x7DD42B19, "new_cliff_dist" },
    { 0xC0D75762, "new_clip" },
    { 0x9CC30125, "new_color" },
    { 0xAB232870, "new_color_being_set" },
    { 0xF0A9F497, "new_color_code" },
    { 0xB5B497E9, "new_color_guy" },
    { 0x6AEDA806, "new_configuration" },
    { 0x310AEE47, "new_cover_on_death_thread" },
    { 0xC2677C5F, "new_cpoint" },
    { 0xB87E240F, "new_createfx_centerprint" },
    { 0xD40D1913, "new_damage" },
    { 0xC60B724A, "new_death_anim" },
    { 0x6C9DF4E5, "new_debouce" },
    { 0xF0603B8D, "new_delay" },
    { 0x3B01140C, "new_dest" },
    { 0xE1705870, "new_destination" },
    { 0x0092578F, "new_dests" },
    { 0xE301F3FA, "new_dialogue" },
    { 0x913A2725, "new_difficulty_request" },
    { 0x34F63CE0, "new_dist" },
    { 0x62FC7A4B, "new_dist_to_next_node" },
    { 0xF271CB31, "new_distance" },
    { 0x5F56E37E, "new_dof_focus" },
    { 0xB2A47085, "new_dot" },
    { 0xE657B9B6, "new_drone" },
    { 0xA675AA9A, "new_drone_queue" },
    { 0xEE958039, "new_dropoff_guys" },
    { 0xEA4688AF, "new_e1_start" },
    { 0x9390FC75, "new_effect_ent" },
    { 0x9307E961, "new_elem" },
    { 0x03FF4059, "new_emergency_light_playing" },
    { 0xAFB7EA4F, "new_end" },
    { 0x09FE38AC, "new_end_pos" },
    { 0x9F59FE47, "new_ending_hud" },
    { 0x543F5724, "new_enemy" },
    { 0x4139E905, "new_enemy_callout" },
    { 0xF9B311A7, "new_enemy_squad" },
    { 0x4F9043BF, "new_ent" },
    { 0xAB90ED88, "new_ent_selection" },
    { 0x2988E938, "new_equipment" },
    { 0xBE3D3770, "new_escort_debug" },
    { 0x1553D8B1, "new_escort_trigger" },
    { 0x34692C70, "new_expo" },
    { 0xB45FBDB2, "new_face_event" },
    { 0x0508D48A, "new_face_processor" },
    { 0x53C8136F, "new_facing_cmd" },
    { 0x644485DD, "new_ff_reset_counter" },
    { 0x4FB2D30D, "new_firesale" },
    { 0x02743566, "new_flag" },
    { 0x53E0EF9B, "new_flak_gunners" },
    { 0xFA51BEC5, "new_fletcher" },
    { 0x64A3FC26, "new_follow_node" },
    { 0x5E4A0B5C, "new_followed" },
    { 0x2CFC2214, "new_force_color_being_set" },
    { 0xCD72468D, "new_force_goal" },
    { 0x7531B549, "new_fov" },
    { 0x20D4D197, "new_fov_lerp" },
    { 0x6B0C8EDE, "new_friendly_apc_movement" },
    { 0x8C2BDB44, "new_friendly_trigger" },
    { 0x33E290B3, "new_friends" },
    { 0x3AF16252, "new_func" },
    { 0x3370BE4B, "new_gas_explosion" },
    { 0x7154544B, "new_gear_state" },
    { 0xD5410A58, "new_gib_ref" },
    { 0xCAC9DB39, "new_goal" },
    { 0xA98AB234, "new_goal_at_scene_end" },
    { 0xEF6E674C, "new_goal_dist" },
    { 0xE8371B50, "new_goal_node" },
    { 0x0CA303C7, "new_goalvolume" },
    { 0x7BF3E2B3, "new_ground_ent" },
    { 0x1FDB7F09, "new_group" },
    { 0xC042277E, "new_gun" },
    { 0x625D6A01, "new_guy" },
    { 0x8551CA27, "new_guy_left" },
    { 0x7EFA0122, "new_guy_right" },
    { 0x48CCB128, "new_guys" },
    { 0xAF1DFF97, "new_hacker_pool" },
    { 0x71997182, "new_health" },
    { 0x53DC022B, "new_health_overlay" },
    { 0x050FBEE1, "new_health_tier" },
    { 0x60AA80D1, "new_height" },
    { 0x5AF92168, "new_heli" },
    { 0x483567C5, "new_heli_behavior" },
    { 0xA7F8EBC7, "new_heli_moveto" },
    { 0xA0007798, "new_heli_scan" },
    { 0x0B53927B, "new_hero_weapon" },
    { 0xA47C4918, "new_highest_wave" },
    { 0xFB312E3B, "new_hud" },
    { 0x071901B7, "new_human_suviving" },
    { 0x2516560C, "new_ignore_attacker" },
    { 0x45F94BC3, "new_intensity" },
    { 0xB434F12F, "new_introscreen_element" },
    { 0xDC6FE171, "new_jetgun_debug_print_on_ent" },
    { 0x317924B3, "new_jug_behavior" },
    { 0x6395DBA2, "new_killstreak_quantity" },
    { 0x21A92C45, "new_lander_intro" },
    { 0x7B168FCE, "new_lander_used" },
    { 0xACF728E3, "new_leader" },
    { 0xB10249D2, "new_leaders" },
    { 0x13002D2D, "new_lethal_grenade" },
    { 0x62E7C87F, "new_levelend_hud" },
    { 0x51530778, "new_lightmerge" },
    { 0x0BE036E9, "new_lights_delayfxforframe" },
    { 0x09B1C9BE, "new_line" },
    { 0xA222D1B7, "new_line_num" },
    { 0x549FB308, "new_list" },
    { 0x86DAAD04, "new_lite_settings" },
    { 0x94DC3043, "new_look_training_handler" },
    { 0xE887AB58, "new_look_training_setup" },
    { 0xF3F1FCBD, "new_look_wait_for_target" },
    { 0x88BE76AF, "new_machine" },
    { 0xE1A5ABE6, "new_magnet" },
    { 0x01597B03, "new_match" },
    { 0x067753D9, "new_max_dist" },
    { 0x7E9566D5, "new_max_falloff" },
    { 0x6C9FB2F9, "new_meat" },
    { 0xEDA0A489, "new_meat_stink_player" },
    { 0xCBBCBE7F, "new_melee_weapon" },
    { 0x414D66D5, "new_menu" },
    { 0x9091ECE2, "new_mg_firing_team" },
    { 0x8F204B35, "new_mger" },
    { 0x7DDC990C, "new_mgfire" },
    { 0x0100E2F7, "new_min_dist" },
    { 0x1CB6D7A3, "new_min_falloff" },
    { 0x2E7C4967, "new_model" },
    { 0x06F89F5F, "new_model_name" },
    { 0x49EDE2E6, "new_momentum" },
    { 0xE14E4D32, "new_morpheus_set" },
    { 0x7744CF60, "new_move_between_points" },
    { 0xBDB589D8, "new_move_list_menu" },
    { 0xD4035B3B, "new_move_speed" },
    { 0x4268DFF3, "new_msg" },
    { 0x605A9149, "new_music" },
    { 0x826D6B9B, "new_music_state" },
    { 0xFAC960A0, "new_names" },
    { 0x5E37CE14, "new_node" },
    { 0xFEDE10E8, "new_node_selected" },
    { 0xB5E13E8F, "new_obj" },
    { 0x35AFAF85, "new_object" },
    { 0xB61B3AA6, "new_object_of_type" },
    { 0x5E2D8BB0, "new_objective_once_up_ladder" },
    { 0xED9B9A5C, "new_offset_x" },
    { 0x139E14C5, "new_offset_y" },
    { 0x39A08F2E, "new_offset_z" },
    { 0xE99287F8, "new_on_water_fx" },
    { 0x179116FA, "new_org" },
    { 0x8E5103E3, "new_orient" },
    { 0xD241CB36, "new_origin" },
    { 0xACFC7895, "new_owner" },
    { 0xE92ABF40, "new_panzerschrek" },
    { 0xD65C9515, "new_path" },
    { 0x214719D7, "new_path_point_ang" },
    { 0xA6A7D04D, "new_path_point_org" },
    { 0x0EBF03B3, "new_percent" },
    { 0x7688FB91, "new_perm_list" },
    { 0xEDF07BB1, "new_phone_rotation" },
    { 0x7ED3C907, "new_pilot_light" },
    { 0x4A0A7192, "new_pitch" },
    { 0x333EEA01, "new_placeable_mine" },
    { 0xA780F045, "new_plane_vals" },
    { 0xC2B32856, "new_player_angles" },
    { 0x921BFC46, "new_players" },
    { 0x6ABE19D2, "new_point" },
    { 0xD5B71EDD, "new_points" },
    { 0x6A09F79E, "new_pos" },
    { 0xB4EB40E1, "new_pos_vec" },
    { 0x6A72BC60, "new_pos_vec_length" },
    { 0xFF4D832F, "new_pos_x" },
    { 0xD94B08C6, "new_pos_y" },
    { 0x09AA5D89, "new_position" },
    { 0xF8FF1FFA, "new_primary" },
    { 0xE2EA8549, "new_progress" },
    { 0x8C4D2EC8, "new_prop_rotation" },
    { 0x4021BD14, "new_quote_string" },
    { 0xC69D1162, "new_radius" },
    { 0x7360A3D6, "new_rate" },
    { 0xB3883F27, "new_rechamber" },
    { 0x8561C8CF, "new_record" },
    { 0x3EB92B5E, "new_reflection_button_running" },
    { 0x9AAB3AFA, "new_relationship_said" },
    { 0xC591CFD5, "new_rescue_scene_node" },
    { 0xF1EA3445, "new_respawn_trig" },
    { 0xDBD3878F, "new_retreat_wave" },
    { 0xBAE48939, "new_rgb" },
    { 0xF8982BCB, "new_rock" },
    { 0x0FC7C631, "new_roll" },
    { 0x9D5E1EB8, "new_round" },
    { 0x5664F2D6, "new_scale" },
    { 0x7AB7D6F2, "new_scene_name" },
    { 0x795417A6, "new_score" },
    { 0x2292DAAA, "new_scripted_anim" },
    { 0x46124F20, "new_searchlight_target" },
    { 0x983302FA, "new_selection" },
    { 0x026D8573, "new_self_origin" },
    { 0x583E20B3, "new_sentinel_pos" },
    { 0xA59BFFD7, "new_sequence" },
    { 0xCBB76A2F, "new_shark" },
    { 0x65A91476, "new_sharks" },
    { 0x9B0D404B, "new_shoot_target" },
    { 0xD9E89CF9, "new_side_dir" },
    { 0x346686CD, "new_sound" },
    { 0x54840F3C, "new_spawner" },
    { 0x997476FF, "new_spawners" },
    { 0xDF690E21, "new_speed" },
    { 0xCD80B6A0, "new_speed_pickup" },
    { 0xF76D8D25, "new_spinners_pickup" },
    { 0xD7C34D98, "new_spot" },
    { 0x9437DB2E, "new_spot_position" },
    { 0x3F6C73DC, "new_spotlight_chopper" },
    { 0xA6475A64, "new_spotlight_target" },
    { 0xC8F035A5, "new_spotlight_target_loop" },
    { 0x53902373, "new_spots" },
    { 0xC63EBA61, "new_squad_logic" },
    { 0xFBAB760A, "new_squad_orders" },
    { 0xC59620D7, "new_squadmembers" },
    { 0x2B5AE343, "new_start_node" },
    { 0x44AC84E3, "new_starting_node" },
    { 0x74697037, "new_starts" },
    { 0x8EBC5B3F, "new_state" },
    { 0xDEE2D3CA, "new_stock" },
    { 0xC24FA40D, "new_stock_amt" },
    { 0x7338D4ED, "new_str" },
    { 0x3B76777B, "new_string" },
    { 0xB9CA9319, "new_stuck_watcher" },
    { 0x1E7AAA3F, "new_stun_pickup" },
    { 0x8DDEC31D, "new_style_health_overlay" },
    { 0x48D7D8E0, "new_style_health_overlay_done" },
    { 0x3A420BD6, "new_support_pos" },
    { 0x9350F66E, "new_swim_state" },
    { 0x859D07D7, "new_switch_ventral" },
    { 0xD26F5274, "new_tactical_grenade" },
    { 0x6C79BC70, "new_tank" },
    { 0xC119D7BB, "new_target" },
    { 0x12A6666A, "new_target_node" },
    { 0xC796B108, "new_target_vec" },
    { 0x01140D96, "new_targetname" },
    { 0x3CD8BC5A, "new_targets" },
    { 0x7D0AB293, "new_targs" },
    { 0x619D865C, "new_tesla_pickup" },
    { 0xE2DD87D0, "new_threat" },
    { 0xA37819CB, "new_time" },
    { 0x1849BD3B, "new_time_bomb_set" },
    { 0x8C4F4E93, "new_timer" },
    { 0x3EED4BDB, "new_trace" },
    { 0x656402D1, "new_transformer" },
    { 0x9FB843A4, "new_trigger" },
    { 0x2B35ABE9, "new_trigger_func" },
    { 0x38066760, "new_trysidestepthread" },
    { 0xCCEDADF2, "new_tutorial_message" },
    { 0x097369F7, "new_unit_init" },
    { 0xCC865DA8, "new_user_think_time" },
    { 0x350084AD, "new_val" },
    { 0xB4BF3A93, "new_value" },
    { 0xEFE4EA66, "new_vec" },
    { 0x615DB8C6, "new_vec_dot" },
    { 0xC0B5456D, "new_vector" },
    { 0x6F8A7620, "new_vehicle" },
    { 0x8311A40A, "new_vehicle_array" },
    { 0xDF6F6273, "new_vehicle_spawned" },
    { 0x61EC59A1, "new_vel" },
    { 0x002401D9, "new_velocity" },
    { 0x01FA9FC8, "new_vision" },
    { 0xBB3F8048, "new_visionset" },
    { 0x9910FC8C, "new_vo_index" },
    { 0xDF163506, "new_volume" },
    { 0x0A27E3BC, "new_volume_command" },
    { 0x713FF349, "new_vomit" },
    { 0xF1F1C0A3, "new_wave" },
    { 0xD30A5D2C, "new_weapon" },
    { 0x04496A4B, "new_weapon_pickup" },
    { 0x8921E8B0, "new_weight" },
    { 0x0A6DC440, "new_word" },
    { 0x6945ED68, "new_x" },
    { 0x8F4867D1, "new_y" },
    { 0x94E75FD1, "new_yaw" },
    { 0xE5C01D40, "new_zombie_eye_cb" },
    { 0x34A497DB, "newai" },
    { 0xC4B201E1, "newairstrike" },
    { 0x622F648B, "newallotment" },
    { 0x3ADD4043, "newalpha" },
    { 0x051BE7A5, "newambientpackage" },
    { 0x1F16DF42, "newambientroom" },
    { 0x3B63EDCF, "newammo" },
    { 0xBE7F57EC, "newammocount" },
    { 0x934E93C3, "newang" },
    { 0x02237B72, "newangle" },
    { 0xEAE3A720, "newangledelta" },
    { 0xAD3D7C8F, "newanglerangecheck" },
    { 0x4AEE67FD, "newangles" },
    { 0x81181842, "newanim" },
    { 0xF258AC40, "newanimactive" },
    { 0x02E4CC6D, "newanimarray" },
    { 0x001DE4CF, "newanimname" },
    { 0xC6A2685D, "newanimstarttime" },
    { 0x8ABA0ABC, "newanimstarttime_l" },
    { 0xAE799C12, "newanimstarttime_r" },
    { 0x0FA036FD, "newanimtime" },
    { 0x14B5ADC4, "newarray" },
    { 0xEA397A34, "newattacker" },
    { 0x796FE095, "newb" },
    { 0xE618CC4F, "newbhater_setup" },
    { 0x4C3D61E5, "newbomb" },
    { 0x3A61F7C7, "newbs_deathpoint" },
    { 0x8D4502A5, "newbs_runnin" },
    { 0x99225AFE, "newbs_setup" },
    { 0x1D72ACC2, "newcam" },
    { 0x8F73D6F9, "newcastle" },
    { 0x5CE2813C, "newcastle_think" },
    { 0x836AA7A3, "newclass" },
    { 0xEB82EE3A, "newclaymorecount" },
    { 0xAD13099A, "newclienthudelem" },
    { 0xDE9AE57B, "newclosestdistance" },
    { 0xA7F48CF4, "newcodpoints" },
    { 0x691ED79A, "newcolor" },
    { 0xDF023D37, "newcornermode" },
    { 0x0683F282, "newcover" },
    { 0xDCBFA607, "newcovermode" },
    { 0xDEB66742, "newcrew" },
    { 0x4953296B, "newcurtain_anim" },
    { 0xD96C02DA, "newdamage" },
    { 0x71DF8D81, "newdamageindicatorhudelem" },
    { 0x156470D4, "newdamagelevel" },
    { 0x1C39C516, "newdeathicon" },
    { 0x13188FA2, "newdeathspawners" },
    { 0x84C0E150, "newdebughudelem" },
    { 0x5B5ED18C, "newdebugline" },
    { 0xC75F70EF, "newdefenderforward" },
    { 0x51F04EA1, "newdialog" },
    { 0x50AEBB3E, "newdif" },
    { 0x18CC782A, "newdir" },
    { 0x04E37B30, "newdir2d" },
    { 0xD7D5EE58, "newdirection" },
    { 0xABE754FD, "newdist" },
    { 0xC6A20DF8, "newdistance" },
    { 0x0C7578AD, "newdistsq" },
    { 0x5E0FAA15, "newdistsqr" },
    { 0x9E88EDDE, "newdot" },
    { 0xEB2653C4, "newelem" },
    { 0xDBD5F7C7, "newendtime" },
    { 0xF06F4C17, "newenemy" },
    { 0x5C5596C6, "newenemyreaction" },
    { 0x49B37621, "newenemyreactionanim" },
    { 0x84C05A3E, "newenemyreactiondone" },
    { 0x0F8DD088, "newenemyreactionpos" },
    { 0x41A37BAF, "newenemyreacttime" },
    { 0x6D889EEF, "newenemysurprisedreaction" },
    { 0xFF9FE7E4, "newent" },
    { 0x8A486FE8, "newentity" },
    { 0x8D144F5B, "newentry" },
    { 0x5FD70917, "newents" },
    { 0x931374E3, "newequipment" },
    { 0x164FEDEC, "newer" },
    { 0x119AC63B, "newest" },
    { 0x5F62D52A, "neweventname" },
    { 0xEA34311D, "newfaketarget" },
    { 0x6D40B204, "newfallback_overmind" },
    { 0x2E736003, "newflag" },
    { 0xECBDF589, "newfriend" },
    { 0xC1F0AD6C, "newfxhandlearray" },
    { 0x306ED443, "newgap" },
    { 0xC32125F0, "newgoal" },
    { 0x8E2D0689, "newgoalposition" },
    { 0x54DB5262, "newgoalradius" },
    { 0x692C6DE1, "newgun" },
    { 0xC7112B5E, "newguy" },
    { 0xB73E89C1, "newguys" },
    { 0x91650F31, "newheading" },
    { 0x1AC8646B, "newhealth" },
    { 0xF2C9AFE1, "newhero" },
    { 0xFC26DF3B, "newhero_by_plunger" },
    { 0xB475D369, "newhero_plunge" },
    { 0x941B10D9, "newheroabilitymask" },
    { 0xFB74664D, "newheroweaponmask" },
    { 0x0C49DDE5, "newhudelem" },
    { 0xEE9591AF, "newindex" },
    { 0xEB6B43A4, "newintensity" },
    { 0x47006358, "newitem" },
    { 0xAF4D3780, "newjolt" },
    { 0xE0A96A52, "newkillcount" },
    { 0x53EFC24D, "newlength" },
    { 0x246F2529, "newloc" },
    { 0x7F2039D8, "newlocation" },
    { 0xDFF276D1, "newlookatbehavior" },
    { 0x93CD8687, "newlooktarget" },
    { 0x53EFAE00, "newly" },
    { 0x173B9994, "newmachine" },
    { 0x68EF3F5B, "newmaterialelem" },
    { 0x1C8F8983, "newmeleeendposition" },
    { 0x96FE3364, "newmodel" },
    { 0xCC9BB602, "newmodelpos" },
    { 0xE9FF0B7B, "newmomentum" },
    { 0xCA7EB552, "newmove" },
    { 0x8ACBBED2, "newmovement" },
    { 0xCD318844, "newname" },
    { 0x12199ADD, "newnode" },
    { 0x2FC0C8C5, "newnode2" },
    { 0xAABD8024, "newnodename" },
    { 0x5C449057, "newnum" },
    { 0xEA1BC8A4, "newobject" },
    { 0x6E25613E, "newobjective" },
    { 0x67C37532, "newoldradius" },
    { 0x7E7A0639, "neworg" },
    { 0x525FF8F3, "neworigin" },
    { 0xEE559E2E, "newowner" },
    { 0x0EA48C5F, "newpackage" },
    { 0x5AF39778, "newpath" },
    { 0xA35B8ADC, "newperks" },
    { 0xEA862479, "newplayermethod" },
    { 0x1ADFF245, "newplayers" },
    { 0x6DA89965, "newpoint" },
    { 0xFE9FF53D, "newpos" },
    { 0x8CA4EE0E, "newpos1" },
    { 0x66A273A5, "newpos2" },
    { 0x409FF93C, "newpos3" },
    { 0x1A9D7ED3, "newpos4" },
    { 0xF49B046A, "newpos5" },
    { 0x13D4C39A, "newpose" },
    { 0x114313E4, "newposition" },
    { 0x107FDB12, "newqueue" },
    { 0x6379D136, "newradialmaterialelem" },
    { 0xDE00934C, "newrange" },
    { 0x74E68017, "newrank" },
    { 0x10CABEE8, "newrankid" },
    { 0xFFB4EDAA, "newrankname" },
    { 0xA7286A6F, "newrate" },
    { 0x5EC02C25, "newresumespeedmsag" },
    { 0x5D0ABA78, "newroom" },
    { 0xA807E6A2, "newrpg" },
    { 0x61DE2DA3, "newrule" },
    { 0xB3950CBC, "news" },
    { 0x44AFB7A4, "news_room_clear" },
    { 0xB2D4240F, "newsanchor" },
    { 0x012DDCD9, "newsatchel" },
    { 0x8142C539, "newscore" },
    { 0x11306159, "newscorehudelem" },
    { 0xFC8D1B62, "newseat" },
    { 0xACBBCC70, "newshootpos" },
    { 0x23D3AE82, "newsound" },
    { 0x5E7A027E, "newspawners" },
    { 0x7540A717, "newspawnlocs" },
    { 0x01B379C1, "newspawns" },
    { 0xDD03BC4F, "newspeakers" },
    { 0x60267B9E, "newspeed" },
    { 0x62AD17A0, "newspeedscale" },
    { 0xD298BB2A, "newsporesexploded" },
    { 0x62DCD355, "newspot" },
    { 0xE383B1A4, "newspots" },
    { 0x5492E5D1, "newsquad" },
    { 0xF84F3497, "newsquadcreated" },
    { 0x453A4EF1, "newstance" },
    { 0xDC42B02B, "newstartpos" },
    { 0x16E7DF40, "newstate" },
    { 0x805AF99F, "newstatemachine" },
    { 0xBF7E71D5, "newstoppos" },
    { 0x560E19E2, "newstr" },
    { 0x5F98D58D, "newstrarray" },
    { 0xC03ED5CE, "newstring" },
    { 0xF4EB9E8A, "newstruct" },
    { 0x9F8857F0, "newstyle" },
    { 0xD8803DC2, "newsuncolor" },
    { 0xB0D624F0, "newsundirection" },
    { 0xF610F1C9, "newtank" },
    { 0x90A99BB6, "newtarget" },
    { 0x3DA9B568, "newtargetvec" },
    { 0xBFE39B6A, "newteam" },
    { 0xEDB2E310, "newteamhudelem" },
    { 0xD993C8A8, "newtestposition" },
    { 0x7AFC7079, "newtextelem" },
    { 0xDFC144E6, "newtextline" },
    { 0x2A95E0AD, "newthread" },
    { 0x8ABD873D, "newthreat" },
    { 0xE22AEBFA, "newtime" },
    { 0x9715920C, "newtimer" },
    { 0x92C2BD34, "newtimescale" },
    { 0x195D297A, "newtrack" },
    { 0xDA982EDF, "newtrig" },
    { 0x450943E3, "newtrigger" },
    { 0x7F809935, "newtype" },
    { 0xF568A224, "newusepos" },
    { 0x56536D6D, "newusetime" },
    { 0x9193C732, "newval" },
    { 0xB9446820, "newvalf" },
    { 0x1209E5C8, "newvalidposition" },
    { 0x23875B0C, "newvalue" },
    { 0x7B3AE6E4, "newvector" },
    { 0xE695A6F8, "newvelocity" },
    { 0x0C838072, "newvillers" },
    { 0xC00374FD, "newweapon" },
    { 0x56E33F15, "newweapondata" },
    { 0xE1181707, "newweaponparams" },
    { 0x18C93BCE, "newweaponstring" },
    { 0xB78A5CD7, "newworld" },
    { 0xF588A8AF, "newx" },
    { 0x940BFD8D, "newxp" },
    { 0xCF862E46, "newy" },
    { 0x9739D87E, "newyaw" },
    { 0xA983B3DD, "newz" },
    { 0xFFDC8207, "newzone" },
    { 0xF1160435, "newzoneactive" },
    { 0x554AD1FE, "newzones" },
    { 0x923CC30A, "nex" },
    { 0x97E8265F, "nexposed" },
    { 0x48B2AD0A, "next" },
    { 0x74542AD7, "next2dcalc" },
    { 0x2FFD43E3, "next_action" },
    { 0xDA6C9BED, "next_addon" },
    { 0x0CAA25B9, "next_angles" },
    { 0x9C5899D5, "next_anim_delta" },
    { 0x2243CADE, "next_anim_speed" },
    { 0x86D09422, "next_ape_round" },
    { 0x2CB75E0D, "next_armor_piece" },
    { 0xF599D702, "next_asad_sound" },
    { 0x466CB1BF, "next_astro_round" },
    { 0x6873BFB7, "next_attack_time" },
    { 0x05D92FB5, "next_avogadro_round" },
    { 0x9B45C6EC, "next_boom" },
    { 0x9602CC8F, "next_brutus_round" },
    { 0x678FA15D, "next_chain_start" },
    { 0x0F9D78F4, "next_charge_melee_time" },
    { 0x943CCBC7, "next_cin_id" },
    { 0xB11B5546, "next_cockpit_damage_state" },
    { 0xC83FB52B, "next_color_trigger" },
    { 0xD1F78789, "next_color_trigger_triggered" },
    { 0x7B1B733F, "next_crawl_leg_pain_time_min" },
    { 0x4F09AC0A, "next_crawl_pain_time_min" },
    { 0xEED91BE6, "next_crawler_round" },
    { 0x22FC19EE, "next_crumb" },
    { 0x66170088, "next_damage_state" },
    { 0x4BACCE4F, "next_defend_state" },
    { 0x74194643, "next_dialogue" },
    { 0xADBAA6EC, "next_dmg_alert" },
    { 0x912D6708, "next_dmg_fx" },
    { 0x64E337C4, "next_dog_round" },
    { 0x5173AE19, "next_door" },
    { 0x2757C2C7, "next_drop_round" },
    { 0xF32A5A44, "next_encouragement" },
    { 0x65C0968B, "next_enemy" },
    { 0x102521D7, "next_enemy_call_out" },
    { 0x91753F39, "next_enemy_spawners" },
    { 0xFCB31940, "next_ent" },
    { 0x8422631F, "next_event_after_gas_trig" },
    { 0xCF2D0896, "next_extra_life" },
    { 0x00262B08, "next_far_blur" },
    { 0x97B0CD5E, "next_far_end" },
    { 0x85F438CD, "next_far_start" },
    { 0x47E62A75, "next_flight_state" },
    { 0xD47B04DD, "next_floor" },
    { 0x928A7FB2, "next_genocide_audio" },
    { 0x5FF2250D, "next_ghost_round_number" },
    { 0x1FCE59FF, "next_grenade_time" },
    { 0x8EE1D008, "next_headbutt_time" },
    { 0x62F0FE0F, "next_health_drop_time" },
    { 0x6BB60313, "next_heartbeat" },
    { 0xEF1AC5BB, "next_in_list" },
    { 0x47DE8E3B, "next_index" },
    { 0x9CBF2B32, "next_juke_time" },
    { 0x8C9BF7C1, "next_leap_time" },
    { 0xB68A9D27, "next_leaper_round" },
    { 0x4B933229, "next_level" },
    { 0xB8FC874D, "next_level_name" },
    { 0xBE5B4BDF, "next_life_steal" },
    { 0x63101E2A, "next_logic_func" },
    { 0x7F46321D, "next_mechz_round" },
    { 0x07271F49, "next_mission" },
    { 0xE73CD8E0, "next_model" },
    { 0x175C18A7, "next_monkey_round" },
    { 0x83F16A41, "next_move_to_new_cover" },
    { 0x6B98E42C, "next_music_state" },
    { 0x08D4AB56, "next_music_track" },
    { 0x518B07ED, "next_near_blur" },
    { 0x4CAA98F1, "next_near_end" },
    { 0xB4F49A80, "next_near_player_check" },
    { 0x7D19427A, "next_near_start" },
    { 0x1888AF0B, "next_nearby_enemy_time" },
    { 0xEA475169, "next_node" },
    { 0x183D9CA1, "next_node_dir" },
    { 0xBF66D219, "next_node_noteworthy" },
    { 0xE85ECB02, "next_node_plane" },
    { 0xE3169ECF, "next_node_struct" },
    { 0xA603F9E0, "next_nodes" },
    { 0x7042D757, "next_origin" },
    { 0x5926FBDA, "next_overheat_fx" },
    { 0x57BF1B28, "next_page" },
    { 0x15207123, "next_pain_time" },
    { 0x1A2169AC, "next_path" },
    { 0x6CD29484, "next_patrol_point" },
    { 0x94BF149F, "next_play_delay" },
    { 0xA0E31151, "next_point" },
    { 0xBE7BCF95, "next_point_name" },
    { 0xCFE13BC9, "next_pos" },
    { 0x19958C36, "next_pos_dist2" },
    { 0xBAE5DAF0, "next_position" },
    { 0xE0BCE5F0, "next_proceed_trigger" },
    { 0x4CED942E, "next_protect" },
    { 0xC43942C2, "next_radio" },
    { 0xDA842065, "next_retreat_node2" },
    { 0xB68C821C, "next_room" },
    { 0x8E14545E, "next_room_name" },
    { 0x013814C1, "next_room_names" },
    { 0xEBC056F9, "next_round_time" },
    { 0x34C21A9C, "next_samantha_clue_time" },
    { 0xEB561410, "next_signal_node" },
    { 0xF4E65308, "next_smoke_time" },
    { 0x3D58BDCE, "next_song" },
    { 0x420359E6, "next_sound" },
    { 0x76586D82, "next_sound_time" },
    { 0x04C8D211, "next_spot" },
    { 0xDEE09A7C, "next_state" },
    { 0xEAE9ABDE, "next_struct" },
    { 0x0E2C5204, "next_struct_name" },
    { 0xA262F2BF, "next_stumble_time" },
    { 0x578CFF1A, "next_tango_timer" },
    { 0x3E1EE8F2, "next_target" },
    { 0xA7597F64, "next_terrain" },
    { 0xA60CAD7E, "next_thief_round" },
    { 0x74238040, "next_token" },
    { 0x0E56AE26, "next_torpedo_time" },
    { 0xECD1F33B, "next_trig" },
    { 0x25D73357, "next_trigger" },
    { 0x000AE107, "next_tutorial_message" },
    { 0x967C3B16, "next_tv_round" },
    { 0x82E8AA36, "next_tv_round_notify" },
    { 0x9ECF1441, "next_victim" },
    { 0x80889969, "next_war_name" },
    { 0x7A7DAFA7, "next_warning_countdown" },
    { 0xEF0C0BFD, "next_wasp_round" },
    { 0x6571BE94, "next_wave_timer" },
    { 0x29C34A89, "next_weapon" },
    { 0xA78E356B, "next_zone" },
    { 0xF6C9F9CC, "nextaction" },
    { 0xE118717B, "nextaimreactiontime" },
    { 0xD0BA53A8, "nextallowedblindfiretime" },
    { 0xC485DDFC, "nextallowedexposedblindfiretime" },
    { 0x354DD038, "nextallowedlooktime" },
    { 0x8691C814, "nextallowedreacttime" },
    { 0xBF5F100C, "nextallowedsuppresstime" },
    { 0xD0D31FD5, "nextallowedswitchsidestime" },
    { 0x3F34D256, "nextangles" },
    { 0x27E595F5, "nextanim" },
    { 0x474D25AF, "nextavail" },
    { 0x84AD2D97, "nextavailattack" },
    { 0xE629FB97, "nextbamfmeleetime" },
    { 0xA7AFD943, "nextbamfmeleetimemax" },
    { 0x6A4BCE2D, "nextbamfmeleetimemin" },
    { 0xBD1EF938, "nextblocker" },
    { 0xB28E5CDF, "nextbusstate" },
    { 0x057A66B4, "nextcheattime" },
    { 0x48570C76, "nextcornergrenadedeathtime" },
    { 0x1BC24146, "nextcrawlingpaintime" },
    { 0x5513AE4D, "nextcrawlingpaintimefromlegdamage" },
    { 0xD87D1A60, "nextcycle" },
    { 0x6C33E0DA, "nextdialog" },
    { 0x204E9AE1, "nextent" },
    { 0x2670A60A, "nextenterpoint" },
    { 0xE8932FF8, "nexteventinxsec" },
    { 0x3F375A0B, "nextexploderindex" },
    { 0xE8F03EDF, "nextfacenum" },
    { 0xFF7E5368, "nextfacestate" },
    { 0xD1DBCA29, "nextfindbestcovertime" },
    { 0x8F49B5C9, "nextfiretime" },
    { 0x168EF080, "nextflag" },
    { 0x43025CE8, "nextflametime" },
    { 0x8220DC7B, "nextgatebug" },
    { 0x868FC95B, "nextgear" },
    { 0x7CEBCFB0, "nextgiveuponenemytime" },
    { 0x04FA2DD3, "nextgoal" },
    { 0x222C2EC0, "nextgoalupdate" },
    { 0x1AE09A4B, "nextgpr" },
    { 0xDF5FFC33, "nextgrenadedrop" },
    { 0x6CFEFF6F, "nextgrenadetime" },
    { 0x9B5CD1CD, "nextgrenadetimetouse" },
    { 0x0F4D0414, "nextgrenadetrytime" },
    { 0x051A4BE2, "nextgroundhit" },
    { 0x38C2B1F9, "nextguncycletime" },
    { 0x96512CBF, "nextheight" },
    { 0xD44D75A9, "nextid" },
    { 0xD25C2426, "nextidlestrafetime" },
    { 0x038E2184, "nextinanim" },
    { 0x64239C08, "nextjukemeleetime" },
    { 0x01437A42, "nextjukemeleetimemax" },
    { 0xD43705FC, "nextjukemeleetimemin" },
    { 0x0B948F7A, "nextjuketime" },
    { 0xD8979D12, "nextkillstreakfree" },
    { 0xCC02AF2D, "nextlevel_index" },
    { 0x506F5086, "nextlevel_name" },
    { 0xE7BE66D8, "nextlevelindex" },
    { 0x6173E44C, "nextlightning" },
    { 0xE5F55BF0, "nextloopalias" },
    { 0x940F81CF, "nextmeleechargesound" },
    { 0x1DFA6EF5, "nextmeleechargetarget" },
    { 0x669DC68D, "nextmeleechargetime" },
    { 0xCBC25A25, "nextmeleechecktarget" },
    { 0x17B27A3D, "nextmeleechecktime" },
    { 0xF230599E, "nextmeleestandardchargetarget" },
    { 0x0734FF22, "nextmeleestandardchargetime" },
    { 0x060DAC86, "nextmissiletag" },
    { 0xD91E30A0, "nextmission" },
    { 0xC91FBAF1, "nextmission_cleanup" },
    { 0x7C4B2777, "nextmission_fade_time" },
    { 0xA86E9CE8, "nextmission_wait" },
    { 0x51F8A74A, "nextmonkeystealround" },
    { 0x4BB2CFB1, "nextmover" },
    { 0x1FDCFE7F, "nextmovetonextbestcovernodetime" },
    { 0x2B4479CA, "nextmovetoplayerupdate" },
    { 0xB38A3921, "nextmsg" },
    { 0xA3DE7292, "nextmusicstate" },
    { 0xBC016BAA, "nextnapalmspawnround" },
    { 0x5DC50A0E, "nextnode" },
    { 0x02309FF4, "nextnode_array" },
    { 0x7A102B3B, "nextnodeangle" },
    { 0x9C210CAA, "nextnodeindex" },
    { 0x70177312, "nextnodeisstop" },
    { 0xD17A4A93, "nextnodename" },
    { 0x42832779, "nextnotifydata" },
    { 0x95EA7549, "nextobjpoint" },
    { 0xD95DCB9E, "nextoneshotalias" },
    { 0xF2FC1DD4, "nextorg" },
    { 0x9AD32068, "nextorigin" },
    { 0x33459751, "nextoutanim" },
    { 0xFF1B76EF, "nextpage" },
    { 0xB585196B, "nextpeekoutattempttime" },
    { 0xC9C3F0E2, "nextplayerrenderoption" },
    { 0x0022F060, "nextpoint" },
    { 0xD3BE17C6, "nextpointorigin" },
    { 0xC788AD7C, "nextpos" },
    { 0xEDC49278, "nextpreemptivejuke" },
    { 0x84653E9E, "nextpreemptivejukeads" },
    { 0x0E2B9F51, "nextradioindex" },
    { 0x71A2A56F, "nextreactiontimeforaimax" },
    { 0x06A53011, "nextreactiontimeforaimin" },
    { 0x7CAB6A63, "nextreacttimeinterval" },
    { 0x98EAA924, "nextrevivesequenceplayertimemax" },
    { 0x86466A8A, "nextrevivesequenceplayertimemin" },
    { 0x38653F91, "nextrevivesequencetime" },
    { 0xC6D1B519, "nextrevivesequencetimemax" },
    { 0x217793A7, "nextrevivesequencetimemin" },
    { 0xC5AF3448, "nextrolltime" },
    { 0x6DDC90E3, "nextroundisovertime" },
    { 0xF395D5D7, "nextsam" },
    { 0x60D12CD8, "nextsaytime" },
    { 0x532960B3, "nextsaytimes" },
    { 0x3ED29A0A, "nextscenebundle" },
    { 0x6E2E368F, "nextscenemode" },
    { 0x72A509F4, "nextshoottime" },
    { 0xF33A16D5, "nextskill" },
    { 0xC56DA471, "nextsonicspawnround" },
    { 0xBD88B697, "nextspecial" },
    { 0x23FF810A, "nextspot" },
    { 0x73EAD4F8, "nextsquad" },
    { 0xEB01A88F, "nextsquadid" },
    { 0x7AC32170, "nextstandinghitdying" },
    { 0xDDD562E9, "nextstate" },
    { 0xB3CC1ECC, "nextstrike" },
    { 0x94E74EE1, "nextstruct" },
    { 0x4FE99EA4, "nextswapavail" },
    { 0x62DC55BD, "nextswitchtime" },
    { 0x9F4DD40C, "nexttagaimchecktime" },
    { 0x78049D4D, "nexttarget" },
    { 0x98E3C701, "nexttargetserviceupdate" },
    { 0xEF66C105, "nexttime" },
    { 0xDF20504C, "nexttopplayer" },
    { 0xDDAE7C36, "nexttoupdate" },
    { 0xA118D993, "nexttypesaytimes" },
    { 0x46E091AF, "nextvalidstate" },
    { 0x15EB6708, "nextzmhud" },
    { 0x78ED8CB4, "nextzoneindex" },
    { 0x00A68822, "nexus" },
    { 0xF601D78A, "nflareoffset" },
    { 0x254DA59D, "nfz" },
    { 0xE8D77244, "nh_clip" },
    { 0x79AF87A2, "nh_found" },
    { 0x8CD610B4, "nhu" },
    { 0x1EE74254, "nic1_01" },
    { 0x0819D8B3, "nic1_01_render" },
    { 0x858F8129, "nic2_01" },
    { 0xF3C9764C, "nic2_01_render" },
    { 0xE8D66371, "nic_01" },
    { 0xA105C824, "nic_01_render" },
    { 0x938E291A, "nic_01a" },
    { 0x794B3B35, "nic_01a_render" },
    { 0x6D8BAEB1, "nic_01b" },
    { 0x0C8BBF64, "nic_01b_render" },
    { 0x0ED8DDDA, "nic_02" },
    { 0xA9831DF5, "nic_02_render" },
    { 0x5ADDD2AC, "nic_04" },
    { 0x2AB6725B, "nic_04_render" },
    { 0x80E04D15, "nic_05" },
    { 0xD3702268, "nic_05_render" },
    { 0x04377A2A, "nicaragua" },
    { 0xFAAC939B, "nicaragua1_01" },
    { 0x1D2AE86B, "nicaragua_amb" },
    { 0x0371D63E, "nicaragua_anim" },
    { 0x8E7216C8, "nicaragua_art" },
    { 0x3D0DE577, "nicaragua_custom_introscreen" },
    { 0xB4312C0D, "nicaragua_enter_mission_objectives" },
    { 0xF1E0B39F, "nicaragua_enter_mission_spawn_second_wave" },
    { 0x574ACCD6, "nicaragua_enter_mission_spawning" },
    { 0xA1097F78, "nicaragua_enter_mission_vo" },
    { 0xE70811B4, "nicaragua_execution_objectives" },
    { 0x7DA17519, "nicaragua_final_push_objectives" },
    { 0xE5335EBF, "nicaragua_fx" },
    { 0xF5DCA33B, "nicaragua_gump_menendez" },
    { 0x8867CFE8, "nicaragua_hallway_objectives" },
    { 0xA345B32E, "nicaragua_hill_complete" },
    { 0x2A19368B, "nicaragua_hill_objectives" },
    { 0x908E49F8, "nicaragua_hill_spawning" },
    { 0x11D1EC07, "nicaragua_interstial_movie" },
    { 0xED7C35BD, "nicaragua_intro" },
    { 0xCCD978BD, "nicaragua_introscreen_custom" },
    { 0xECD82A27, "nicaragua_mason_bunker" },
    { 0xC0F388C7, "nicaragua_mason_bunker_complete" },
    { 0xD167C72A, "nicaragua_mason_bunker_objectives" },
    { 0x83673E1F, "nicaragua_mason_donkeykong" },
    { 0x5630932F, "nicaragua_mason_donkeykong_complete" },
    { 0x3E423212, "nicaragua_mason_donkeykong_objectives" },
    { 0xA50DE717, "nicaragua_mason_final_push" },
    { 0xAF69D6F9, "nicaragua_mason_hill" },
    { 0xC9E4F9A1, "nicaragua_mason_hill_complete" },
    { 0x09479394, "nicaragua_mason_hill_objectives" },
    { 0x573EB9E6, "nicaragua_mason_intro" },
    { 0x67DFF52C, "nicaragua_mason_intro_complete" },
    { 0xF71547F9, "nicaragua_mason_intro_objectives" },
    { 0x25A65475, "nicaragua_mason_outro" },
    { 0x613CC6D8, "nicaragua_mason_outro_objectives" },
    { 0xD4245EC8, "nicaragua_mason_shattered" },
    { 0xD14FC1C3, "nicaragua_mason_shattered_objectives" },
    { 0xE524CE4C, "nicaragua_mason_to_mission" },
    { 0x210EE4BF, "nicaragua_mason_to_mission_objectives" },
    { 0xC6C22FE9, "nicaragua_mason_truck" },
    { 0x2816B0E4, "nicaragua_mason_truck_objectives" },
    { 0x9B41A6DE, "nicaragua_mason_woods_freakout" },
    { 0xA08E18F7, "nicaragua_menendez_enter_mission" },
    { 0xBEE8EF88, "nicaragua_menendez_execution" },
    { 0x1088C40C, "nicaragua_menendez_hallway" },
    { 0x6B273E67, "nicaragua_menendez_hill" },
    { 0xDC9FDAC9, "nicaragua_menendez_rage" },
    { 0xEBE1D89E, "nicaragua_menendez_stables" },
    { 0x180D0E1A, "nicaragua_menendez_to_mission" },
    { 0xE86D7967, "nicaragua_stables_animations" },
    { 0x900166B2, "nicaragua_stables_objectives" },
    { 0x9E42B629, "nicaragua_stables_spawning" },
    { 0xDBF2641F, "nicaragua_stables_vo" },
    { 0xF4A4ACA4, "nicaragua_to_mission_objectives" },
    { 0xB94DA8E1, "nicaragua_to_mission_vo" },
    { 0x68B67844, "nicaragua_to_misssion_animations" },
    { 0x083C8BC5, "nicaragua_util" },
    { 0x485755C5, "nicaragua_vision" },
    { 0x7844B700, "nicaraguan" },
    { 0x0B7D81C5, "nicaraguan_names" },
    { 0xB8C945A9, "nicargua" },
    { 0x6A1B2C02, "nice" },
    { 0x0580D37F, "nice_timing" },
    { 0x0AF8D22F, "nicely" },
    { 0x1EE8F8E4, "nicer" },
    { 0x3D499F03, "nicknamed" },
    { 0xF73C4BA3, "nickolai" },
    { 0xBCFCA908, "niebel" },
    { 0xF84DCC75, "night" },
    { 0x7092D576, "night_vision_off" },
    { 0x3596F768, "night_vision_on" },
    { 0x3BC463E5, "nightclub" },
    { 0x0DBF6009, "nightingale" },
    { 0x221A0629, "nightingale_challenge_completed" },
    { 0x38040E38, "nightingale_grab_enemy_attention" },
    { 0x71F00867, "nightingale_hint" },
    { 0xD770E90C, "nightingale_marked" },
    { 0x7D084F86, "nightingale_react_logic" },
    { 0x1613A9D7, "nightingale_selected" },
    { 0x04D10A0C, "nightingale_think" },
    { 0x1A3DF916, "nightingale_threw" },
    { 0x275F93B5, "nightingale_watch" },
    { 0xE86AD0ED, "nighttime_blue" },
    { 0x74FF7C4E, "nighttime_green" },
    { 0x3B49C5FE, "nighttime_red" },
    { 0x4F8986B9, "nightvision" },
    { 0x13412DB4, "nightvision_check" },
    { 0xDBB3B4AC, "nightvision_dlight" },
    { 0x78608F88, "nightvision_dlight_effect" },
    { 0x26620A45, "nightvision_effectsoff" },
    { 0x410E1E39, "nightvision_effectson" },
    { 0x7600DBAF, "nightvision_enabled" },
    { 0xABB92D9B, "nightvision_off" },
    { 0xDCC30827, "nightvision_on" },
    { 0xB57E4504, "nightvision_reflector_effect" },
    { 0xEB568C12, "nightvision_shellshock_off" },
    { 0x674B8EBB, "nightvision_started" },
    { 0x09124800, "nightvision_toggle" },
    { 0xD315F511, "nightvisionforceoff" },
    { 0x6696AA6F, "niice" },
    { 0x9252CBC1, "niiiice" },
    { 0xEB1B17FB, "nikita" },
    { 0x113EEB36, "nikolai" },
    { 0xA024E6A4, "nikolai_char_index" },
    { 0xD4358993, "nikolai_char_index_r" },
    { 0x33DE3F0D, "nine" },
    { 0x3A93D5A6, "ninebang_doempdamage" },
    { 0xDDEBC273, "ninebang_doninebang" },
    { 0x04C3BEE5, "ninebang_empcandamage" },
    { 0x3BB8B559, "ninebang_getsubexplosionpos" },
    { 0x476158F5, "niner" },
    { 0x2295C6FD, "nineteen" },
    { 0x3FAAA288, "ninety" },
    { 0xD4B08977, "ninja" },
    { 0x0617D3EB, "nitorgen_gas_explosion" },
    { 0x54C2C733, "nitrogen" },
    { 0x52E1B038, "nitrogen_asd_fallback_2" },
    { 0x2C72B526, "nix" },
    { 0xFFE2D15B, "nixie_" },
    { 0xE9B4868E, "nixie_115" },
    { 0x4EB54DE1, "nixie_115_audio" },
    { 0xC2F65DFC, "nixie_935" },
    { 0xD87F816F, "nixie_935_audio" },
    { 0xD86ADA90, "nixie_code" },
    { 0xA4CECED4, "nixie_final_" },
    { 0xED14D6C6, "nixie_final_audio_cue_code" },
    { 0x52F2BC9A, "nixie_final_codes" },
    { 0x6F3448AE, "nixie_reset_control" },
    { 0x83373B75, "nixie_scramble_stop" },
    { 0xC76D4A1E, "nixie_tube_2" },
    { 0x7A970037, "nixie_tube_add_code" },
    { 0x983206E9, "nixie_tube_elevator_door" },
    { 0x44602361, "nixie_tube_elevator_drops" },
    { 0x03904FDD, "nixie_tube_elevator_rises" },
    { 0xC1926162, "nixie_tube_notifier" },
    { 0x7ECE1793, "nixie_tube_off" },
    { 0xB3D8E620, "nixie_tube_remove_code" },
    { 0x0A91DB91, "nixie_tube_scramble_protected_effects" },
    { 0x60A9CC4C, "nixie_tube_thread" },
    { 0x856A6C39, "nixie_tube_thread_play_countdown" },
    { 0x1A4746B7, "nixie_tube_trigger_" },
    { 0x298BF929, "nixie_tube_win_effects" },
    { 0xE534BCE1, "nixie_tube_win_effects_all_tubes" },
    { 0x64D22DAC, "nixie_tube_win_effects_all_tubes_final" },
    { 0xF7882CE6, "nixie_tube_win_effects_ee" },
    { 0xCB0C3521, "nixon" },
    { 0x52C3D56E, "nm" },
    { 0x1870A2BA, "nm0" },
    { 0x62D8DE9D, "nmagnitude" },
    { 0x1B472E35, "nmaxdamagebase" },
    { 0x47A72146, "nmaxwait" },
    { 0x36D179FF, "nmindamagebase" },
    { 0xE0B0A380, "nminwait" },
    { 0x612CF9E6, "nml" },
    { 0x48BFF2EC, "nml_array" },
    { 0xF6E04283, "nml_attack_wave" },
    { 0x78821AF9, "nml_best_time" },
    { 0xB309808F, "nml_bhb" },
    { 0xE37869C6, "nml_cansidestep" },
    { 0x63A990B5, "nml_didteleport" },
    { 0x6967F2D5, "nml_dist" },
    { 0xF74EBAB2, "nml_dog_health" },
    { 0xEFEBDFD9, "nml_dog_health_increase" },
    { 0xD0368F1E, "nml_dogs_enabled" },
    { 0xEAA8B4ED, "nml_dogs_init" },
    { 0xDA9789B7, "nml_electric_barriers" },
    { 0xF6997064, "nml_fx_monitor" },
    { 0x73D54F14, "nml_jugg" },
    { 0x4DCF5944, "nml_kills" },
    { 0x267B8FC0, "nml_last_round" },
    { 0xE7251657, "nml_max_reaction_dist_sq" },
    { 0xDCE9C91D, "nml_min_reaction_dist_sq" },
    { 0xB4A328EC, "nml_pap" },
    { 0xE5E0B495, "nml_poi_array" },
    { 0xC8582F65, "nml_pos" },
    { 0x212A84D3, "nml_position_helper" },
    { 0x020B120F, "nml_radius" },
    { 0x5BDE87B7, "nml_ramp_up_zombies" },
    { 0x73779694, "nml_reaction_interval" },
    { 0xA1461BD7, "nml_round_manager" },
    { 0x69673721, "nml_round_never_ends" },
    { 0xBF0089E1, "nml_score" },
    { 0xD3906307, "nml_set" },
    { 0x1B79FC40, "nml_setup_round_spawner" },
    { 0xD94D6B87, "nml_shouldsidestep" },
    { 0x5BC2E0BD, "nml_show_hide" },
    { 0xA3FAF371, "nml_side_stepping_zombies" },
    { 0x150BEA26, "nml_spark_pull" },
    { 0x4E4D43D6, "nml_speed" },
    { 0xE55CD01D, "nml_start_time" },
    { 0xFACBCBCD, "nml_teleporter_dest_index" },
    { 0x7AB869D9, "nml_teleporter_dest_names" },
    { 0x7C33B564, "nml_timer" },
    { 0x6ACA492C, "nml_trip_is_over" },
    { 0x210401F1, "nml_wave_attack" },
    { 0xBE5F691D, "nml_zombie_spawners" },
    { 0x4198889B, "nmmf_all" },
    { 0xF59985E9, "nmmf_novehicle" },
    { 0x730CC291, "nms" },
    { 0x2CC15B05, "nn" },
    { 0xE39956D0, "nnodes" },
    { 0x10667DF0, "nnw" },
    { 0x06BEE09C, "no" },
    { 0x46D36511, "no valid boards" },
    { 0x3DA5BD09, "no3d" },
    { 0xE931BC28, "no_accuracy" },
    { 0x32A28D44, "no_airstrike_ammo" },
    { 0xCFD19EBB, "no_alt_detonate" },
    { 0x9B5BF7DF, "no_ambient_earthquake" },
    { 0x53D08D64, "no_anim" },
    { 0xAA7C8545, "no_assert" },
    { 0x493D11F0, "no_attach" },
    { 0x9A9E71A6, "no_autoswitch" },
    { 0x5989E69A, "no_back" },
    { 0xEFA1DCD9, "no_banzai_attack" },
    { 0x700E3F94, "no_barrier_target" },
    { 0x124DC4CF, "no_board_repair" },
    { 0xEFA29E53, "no_br" },
    { 0xEB969D79, "no_breath" },
    { 0x39787651, "no_bullet_trace" },
    { 0x0A002B28, "no_burning_sfx" },
    { 0x78F38827, "no_challenge_stat" },
    { 0xC20F8A07, "no_charge" },
    { 0x3D1CDD87, "no_check_wave" },
    { 0x8B2F8CB6, "no_clean_up_needed" },
    { 0x5C5CF235, "no_cleanup" },
    { 0x124E4A56, "no_color_respawners_sm" },
    { 0x5C03F44A, "no_complete" },
    { 0x81809CB4, "no_cooldown" },
    { 0x83387BC3, "no_corpse_announce" },
    { 0xB57D76A4, "no_corpse_caring" },
    { 0x5C8525C5, "no_crouch_or_prone_think" },
    { 0xA453023B, "no_cull" },
    { 0xF7DB1E54, "no_damage" },
    { 0x9F9763C2, "no_damage_gravityspikes_slam" },
    { 0x923B2996, "no_damage_points" },
    { 0xD4F572D2, "no_damage_timer" },
    { 0x046AE86B, "no_death" },
    { 0x568E3EB7, "no_death_detection" },
    { 0x98CBE294, "no_death_fx" },
    { 0x6EA9CEF3, "no_death_sink" },
    { 0xEDD6931A, "no_deathmodel" },
    { 0x98DE202C, "no_delay" },
    { 0xF0E794A2, "no_detect" },
    { 0xC7E50B48, "no_dog_clip" },
    { 0x6D3ADB66, "no_dogs" },
    { 0x2312DD3B, "no_double_shake" },
    { 0xC7B578B9, "no_driver" },
    { 0xC1A88497, "no_drone_death_thread" },
    { 0x115F5CB3, "no_drone_ragdoll" },
    { 0xB5AE794E, "no_dupes" },
    { 0x91CCC458, "no_effects_pitch" },
    { 0x50A71706, "no_end_game_check" },
    { 0x2A59FF05, "no_enemies" },
    { 0x1531951D, "no_enemy" },
    { 0xE7C65AE4, "no_enemy_info" },
    { 0x0CCE7626, "no_explode" },
    { 0x012E581A, "no_explosion_physics" },
    { 0x0DE5AA65, "no_explosive_death_anim" },
    { 0x58F7AEF0, "no_ext_amb_snapshot" },
    { 0x39E5165A, "no_eye_glow" },
    { 0x557BDDF2, "no_fade2black" },
    { 0x1DCB796F, "no_fly_away" },
    { 0xD2685ADE, "no_force_back" },
    { 0x137FB210, "no_free_on_death" },
    { 0xE17349FD, "no_free_on_end" },
    { 0x37B92239, "no_friendly_fire" },
    { 0xBB4F67F3, "no_friendly_fire_penalty" },
    { 0x8D991D07, "no_fronds" },
    { 0x0DBFC855, "no_fx" },
    { 0xB34F6381, "no_game" },
    { 0xD6DB8224, "no_generic_pulse" },
    { 0x62C3AE6B, "no_gib" },
    { 0x2C7B1306, "no_gib_in_wolf_area" },
    { 0xD07A5E81, "no_godmoderiders" },
    { 0x63558ACA, "no_gore" },
    { 0x947D7E0B, "no_grenade" },
    { 0x59ECA790, "no_grenade_bag_drop" },
    { 0x9D0F2980, "no_grenade_death_hack" },
    { 0x1306D96A, "no_grenades" },
    { 0xEA719658, "no_group" },
    { 0x41E7DB99, "no_group_commands" },
    { 0x621E5F51, "no_guys_going_to_stairs_nearby" },
    { 0xDAD0E5C1, "no_highlight" },
    { 0xE51F0A7E, "no_hud" },
    { 0x722EF0A5, "no_idle" },
    { 0xC25DA5BD, "no_intro_vox" },
    { 0x8BDB3F05, "no_ir_beacon" },
    { 0x61DA0D0B, "no_jump" },
    { 0x60684259, "no_jump_triggers" },
    { 0x831FDAA8, "no_key" },
    { 0xA5905C5C, "no_kill_time_warning" },
    { 0xD04E621A, "no_killing_civ" },
    { 0xD312235D, "no_laststandmissionfail" },
    { 0xB09EFE10, "no_leadoff" },
    { 0x6B8C9154, "no_left" },
    { 0xE0129EA0, "no_legs" },
    { 0x46096B41, "no_limited_weapons" },
    { 0xB06FCA5F, "no_link" },
    { 0x1AE283DA, "no_lock" },
    { 0x3022B326, "no_long_death" },
    { 0xB7064C6F, "no_longer_ignore_player" },
    { 0x77937E15, "no_longer_selecting" },
    { 0xBF351F34, "no_look_delete" },
    { 0xE86B282D, "no_loop" },
    { 0x3FC15575, "no_magic_bullet_damage" },
    { 0x0B34642F, "no_magic_death" },
    { 0xE4758B38, "no_magicbullet_damage" },
    { 0xFEF25C86, "no_mans_land_power" },
    { 0x44479E8E, "no_mans_land_sky" },
    { 0x110259BE, "no_mantle" },
    { 0xC2989A44, "no_manual_switch" },
    { 0x584B7E5C, "no_mod_button" },
    { 0x5130A665, "no_more_barnes_fx" },
    { 0x33902F35, "no_more_flashlight" },
    { 0xF6477201, "no_more_heartbeat" },
    { 0x9CBD70BE, "no_mortar_physics" },
    { 0xDC56A4F1, "no_move_commands" },
    { 0xEF1A694D, "no_multiple_overrides" },
    { 0xB68B22DE, "no_nades_oneasy" },
    { 0x7B8B229B, "no_nag" },
    { 0x4B2DB940, "no_nag_dialogue" },
    { 0x4227CFDE, "no_name" },
    { 0x5A503052, "no_node_to_go_to" },
    { 0xDC7E5248, "no_notify" },
    { 0xE2B17C4A, "no_offset" },
    { 0x3D2DA21C, "no_one_to_talk_count" },
    { 0x9D362644, "no_pack" },
    { 0x43A7533E, "no_path" },
    { 0x5D41F3DD, "no_pathnodes" },
    { 0x88BF901B, "no_pickup" },
    { 0x9ABE4F2D, "no_pistol_switch" },
    { 0x3FB46F02, "no_player_clinging" },
    { 0x8DB837D3, "no_player_damage_override" },
    { 0x0D26D8DC, "no_powerups" },
    { 0x67A10886, "no_prone_and_crouch_zones" },
    { 0x555E49A2, "no_prone_think" },
    { 0xF48158DF, "no_prone_zones" },
    { 0x36E9517F, "no_regen_health" },
    { 0x1B7965E8, "no_restart" },
    { 0x445A566D, "no_revive_trigger" },
    { 0x3EC6A8FC, "no_rise" },
    { 0x0E7A889D, "no_save_prompt" },
    { 0x72A8A2EB, "no_shoot_increase" },
    { 0x5197E4B5, "no_show_marker" },
    { 0xB85AE18C, "no_shrink" },
    { 0xDDF60C0F, "no_sight_brush" },
    { 0x9AA3BE3B, "no_sight_check" },
    { 0x8C9AF5D0, "no_slowmo_vehicles" },
    { 0x7F2B8EB3, "no_sniper_backtracking" },
    { 0x1862E5E8, "no_sonar" },
    { 0x062830DA, "no_spectator" },
    { 0xA05B6772, "no_spider_lid_drop" },
    { 0x8EC4BAAB, "no_standing_in_tunnels" },
    { 0xF5A7705B, "no_stick_movement" },
    { 0xCF5BFF6D, "no_switch_on" },
    { 0x92CBF242, "no_switch_weapon" },
    { 0x3F2CC19D, "no_sympathy_anims" },
    { 0xEAE539E1, "no_sympathy_weaver" },
    { 0x206837D5, "no_sympathy_woods" },
    { 0x5A52E820, "no_takeover" },
    { 0x091D033C, "no_target_delay" },
    { 0x67E0F7BF, "no_target_dialog" },
    { 0x27553DE3, "no_target_override" },
    { 0x3FD5683F, "no_target_start_time" },
    { 0x2DE88FBE, "no_teleport" },
    { 0x983A88DE, "no_terrain" },
    { 0x6CDFA5EA, "no_threat_update_on_first_frame" },
    { 0x0AE10F09, "no_touch_check" },
    { 0xE34EA4F0, "no_track_player" },
    { 0xCB4B1340, "no_tracking" },
    { 0x4C0E5CB5, "no_trigger" },
    { 0x415F9379, "no_tube" },
    { 0x70070281, "no_turret_trigger_created" },
    { 0x56EDA11A, "no_unlink" },
    { 0x673160C3, "no_valid_repairable_boards" },
    { 0x4CFA07D4, "no_wait" },
    { 0xAE1E1779, "no_waittill" },
    { 0x57450719, "no_warp" },
    { 0xCF29228C, "no_water_trigs" },
    { 0x3934E757, "no_weapon" },
    { 0x86CB0A3A, "no_weapon_switch" },
    { 0x65EDA69A, "no_widows_wine" },
    { 0xCE7243C6, "no_zombie_left_behind" },
    { 0x7D8952C3, "no_zone_mover" },
    { 0x37C788D6, "noai" },
    { 0x7188DC1B, "noammo_warning" },
    { 0xC7C95DCD, "noanimscripts" },
    { 0x1B57F4F4, "noautostartlevelsave" },
    { 0x3C6A580D, "noback" },
    { 0x6245A147, "noble" },
    { 0x6DBC26B7, "nobloodlightbarchange" },
    { 0xAC88E58C, "nobloodoverlay" },
    { 0xF861CED0, "nobody" },
    { 0x0F03E855, "nochangeduringmelee" },
    { 0x00C87A86, "noclearance" },
    { 0x21887B76, "noclip" },
    { 0x87515A95, "nocloseenemyservice" },
    { 0xC5E89E24, "nocompass" },
    { 0xCED835D3, "nocompile" },
    { 0x664253E4, "nocrawler" },
    { 0x7B998CE8, "nocull" },
    { 0xAE645C1E, "nocull_for_3d" },
    { 0x342D9E3A, "nocybercom" },
    { 0x6183C490, "nod" },
    { 0x96472406, "nodamagefeedback" },
    { 0x0B581934, "nodding" },
    { 0x90CA1FDD, "node" },
    { 0xEBA71C97, "node0" },
    { 0xC5A4A22E, "node1" },
    { 0x9FA227C5, "node2" },
    { 0x799FAD5C, "node3" },
    { 0x539D32F3, "node4" },
    { 0x4E95CAE9, "node_1" },
    { 0xF26E5047, "node_1_pre" },
    { 0x74984552, "node_2" },
    { 0xFBA5945C, "node_2_pre" },
    { 0x9A9ABFBB, "node_3" },
    { 0xEA1802DC, "node_add_connection" },
    { 0x24F0E402, "node_after_anim" },
    { 0x941A59C7, "node_align" },
    { 0x23759979, "node_angle" },
    { 0x78F183B0, "node_angles" },
    { 0xB21ECD79, "node_arr" },
    { 0x28EEAF97, "node_array" },
    { 0x809449BC, "node_array1" },
    { 0xF29BB8F7, "node_array2" },
    { 0xB794150F, "node_array_name" },
    { 0x88EDE76C, "node_array_targetname" },
    { 0x098F647A, "node_backup" },
    { 0x8AB5072D, "node_barrel1" },
    { 0xB0B78196, "node_barrel2" },
    { 0x9F95374E, "node_blocker" },
    { 0x5A292AEF, "node_bridge" },
    { 0xD7350D18, "node_brooks" },
    { 0xB30EB03A, "node_btr_end" },
    { 0xFE73EE41, "node_btr_start" },
    { 0x507CCDEA, "node_calvary_after_heli" },
    { 0x1B44064C, "node_changed" },
    { 0xF91B0D98, "node_check" },
    { 0x3E787C01, "node_chernov" },
    { 0x6CCDE751, "node_chernov2" },
    { 0x15A11AA7, "node_claimed" },
    { 0x7432CA19, "node_closest" },
    { 0xF0D52E2C, "node_concealed" },
    { 0x6A02557C, "node_concealment_crouch" },
    { 0xA4C261B4, "node_connect_to_path" },
    { 0x6A295561, "node_cover" },
    { 0x1E3E7996, "node_cover_crouch" },
    { 0x30BFC847, "node_cover_left" },
    { 0x62630080, "node_cover_pillar" },
    { 0x29FEB8C2, "node_cover_right" },
    { 0xE8D73044, "node_cover_stand" },
    { 0x48F861C8, "node_debug_render" },
    { 0xC73F95B1, "node_delete" },
    { 0x5EEE442C, "node_dest" },
    { 0x23512859, "node_disconnect_from_path" },
    { 0xA3D5F2C1, "node_disconnects" },
    { 0x3C561B97, "node_dragovich" },
    { 0x687B94F0, "node_exposed" },
    { 0xB8E408A5, "node_extra_hero" },
    { 0xEB2D153A, "node_fight" },
    { 0x1A1BE15C, "node_fire" },
    { 0x7B6F4A8D, "node_fire1" },
    { 0xA171C4F6, "node_fire2" },
    { 0x96176F87, "node_forward" },
    { 0xDFFF46E4, "node_get" },
    { 0xE877A20F, "node_guard" },
    { 0x3D7949C4, "node_guard1" },
    { 0xAF80B8FF, "node_guard2" },
    { 0x797213DD, "node_harris" },
    { 0xCD213B8E, "node_has_animations" },
    { 0x693C8E59, "node_has_radius" },
    { 0xCA545E2E, "node_have_delay" },
    { 0xD2BC7A11, "node_heli1" },
    { 0x3F180470, "node_heli1_start" },
    { 0xDF64979F, "node_hit" },
    { 0x91E8B212, "node_hudson_comms_attack" },
    { 0x220AF204, "node_index" },
    { 0xEFC6BADD, "node_key" },
    { 0x80A9141C, "node_keys" },
    { 0xD7C5BCCB, "node_krak" },
    { 0x88037F44, "node_length" },
    { 0x740EEA25, "node_lewis_comms_attack" },
    { 0x7E851AC4, "node_locations" },
    { 0x81C67049, "node_name" },
    { 0x69215727, "node_name_captor" },
    { 0x28D3DF20, "node_name_prisonerl" },
    { 0x9D1E376E, "node_name_prisonerr" },
    { 0xF6EC4D15, "node_not_safe" },
    { 0x4313ED64, "node_note" },
    { 0xE75AFE55, "node_noteworthy" },
    { 0xAB16EFB7, "node_notifies_on_arrival" },
    { 0xF268EC70, "node_num" },
    { 0x161E68D3, "node_number" },
    { 0xB4A1C7E9, "node_offset" },
    { 0x4E7CA30C, "node_or_org" },
    { 0xECC1C8A5, "node_or_string" },
    { 0x89FAEC9A, "node_org" },
    { 0x4ABD7256, "node_origin" },
    { 0x231DB7B9, "node_others" },
    { 0xEF6BD1F4, "node_out_of_water" },
    { 0xDBFDD535, "node_owner" },
    { 0x13967A35, "node_path" },
    { 0x29135AF5, "node_polonksy" },
    { 0x8EC586B3, "node_pos1" },
    { 0x1CBE1778, "node_pos2" },
    { 0x0C20F753, "node_post_throw" },
    { 0x90688282, "node_radius" },
    { 0x95258D18, "node_reznov" },
    { 0x0C1918D6, "node_right" },
    { 0xAD65ED6F, "node_roebuck" },
    { 0x6E263F27, "node_safe" },
    { 0xDE965E39, "node_script_noteworthy" },
    { 0x9205CEF6, "node_scripted" },
    { 0xEAB90B74, "node_snaked" },
    { 0x64A83EC1, "node_speed" },
    { 0xE82A2624, "node_start" },
    { 0xB7BCDAD2, "node_start_gas" },
    { 0x00C4AF56, "node_steiner" },
    { 0xFEEF5F8D, "node_str" },
    { 0x5DFA259B, "node_string" },
    { 0xD4E07F6B, "node_struct" },
    { 0x2FF6C580, "node_supports_stance_crouch" },
    { 0x2252DE88, "node_supports_stance_prone" },
    { 0xDBEAD38A, "node_supports_stance_stand" },
    { 0x136DC835, "node_taken" },
    { 0xB5F87928, "node_target_org" },
    { 0xFF79FAB6, "node_targetname" },
    { 0x36CFA3FA, "node_targets" },
    { 0xB1B125AC, "node_think_time" },
    { 0x197A90F3, "node_to_fight_from" },
    { 0x00E84060, "node_to_go" },
    { 0x8B195777, "node_to_run_to" },
    { 0x7C426822, "node_trigger_process" },
    { 0x8EA91102, "node_truck1" },
    { 0x68A69699, "node_truck2" },
    { 0x7B0AD47D, "node_truck_flame" },
    { 0xAF826EA0, "node_type_cover" },
    { 0x34DC4D87, "node_up" },
    { 0x91FFBE2F, "node_used" },
    { 0xE3C09733, "node_value" },
    { 0xE766B4E3, "node_wait" },
    { 0x36CCA1E5, "node_wait_inside_hammock_hut" },
    { 0xCA9263FC, "node_weaver" },
    { 0xC2510F66, "node_woods4" },
    { 0xBC621365, "node_woods_comms_start" },
    { 0x68802087, "node_work" },
    { 0x4317AA33, "node_zeitzev" },
    { 0xBD1E3C8B, "node_zeitzev2" },
    { 0xE4DE615E, "nodea" },
    { 0x53E7C708, "nodeaftervehiclewalk" },
    { 0x7C8BD0D3, "nodeangleoffset" },
    { 0x85F0C2DD, "nodeangles" },
    { 0x69A054EE, "nodeapproachyaw" },
    { 0x6FC69824, "nodearray" },
    { 0x7416FB22, "nodeath" },
    { 0x2E98700C, "nodeath_challenge" },
    { 0xD1935899, "nodeath_thread" },
    { 0xB8C1F77D, "nodeathanim" },
    { 0xC0171CE8, "nodeathfx" },
    { 0x5E04B0AB, "nodeathragdoll" },
    { 0xBEDBE6F5, "nodeb" },
    { 0xC6AA2AFA, "nodecolor" },
    { 0x71683975, "nodecolors" },
    { 0xD31918F6, "nodecolortable" },
    { 0x46780082, "nodecount" },
    { 0xF1186153, "nodecounter" },
    { 0xDE6479D1, "nodedest" },
    { 0x2213D18A, "nodedir" },
    { 0x2AB9A1D8, "nodedistance" },
    { 0xCFEA4A1C, "nodedists" },
    { 0xAAA8A1A9, "nodedrone" },
    { 0xC39470AF, "nodefinalstance" },
    { 0x082CFCE6, "nodefindticker" },
    { 0xAB430F74, "nodeforward" },
    { 0xD8DCC3CD, "nodehash" },
    { 0xF48AD045, "nodehashes" },
    { 0xA5E54930, "nodeheight" },
    { 0x2CFF4B83, "nodehistory" },
    { 0x49A67C0F, "nodeindex" },
    { 0x4E0F1661, "nodeinfo" },
    { 0x57E405E2, "nodekey" },
    { 0x8B36F4F9, "nodelay" },
    { 0x61315524, "nodename" },
    { 0x631180B7, "nodenum" },
    { 0xA6D529FC, "nodeoffset" },
    { 0x8CB5B77D, "nodeoffsetangle" },
    { 0xAD7F5E3C, "nodeoffsetangles" },
    { 0x0EECA31B, "nodeoffsetforward" },
    { 0x9248BD9A, "nodeoffsetorigin" },
    { 0xC58E2D65, "nodeoffsetposition" },
    { 0xF05EC7BF, "nodeoffsets" },
    { 0x4966888E, "nodeowner" },
    { 0x015AB83D, "nodeprimary" },
    { 0x98746B58, "noderun" },
    { 0xF901131C, "nodes" },
    { 0x443F1636, "nodes2" },
    { 0x60B20FC4, "nodes_cover" },
    { 0x6209285D, "nodes_of_my_color" },
    { 0x9DC74EED, "nodesarelinked" },
    { 0x0DE9E5C7, "nodescanpath" },
    { 0xDC53AF99, "nodescore" },
    { 0xBBCBE18D, "nodesearch" },
    { 0x9FAA8011, "nodesecondary" },
    { 0xF7D138CA, "nodeshield" },
    { 0x7B222BA6, "nodesmax" },
    { 0xF7DDC9D9, "nodesmaxs" },
    { 0x207C4D18, "nodesmin" },
    { 0x4ECA59F3, "nodesmins" },
    { 0xC7B716F5, "nodespresent" },
    { 0x84B2C279, "nodesrc" },
    { 0xA5035CAE, "nodestring" },
    { 0xD7EF9B02, "nodesvisible" },
    { 0xF47521E8, "nodetargetname1" },
    { 0x667C9123, "nodetargetname2" },
    { 0x2DE4DE2B, "nodethink" },
    { 0xACFF2C27, "nodetn" },
    { 0x6E22391A, "nodeturnrate" },
    { 0x13806615, "nodetype" },
    { 0xA3B8C6FA, "nodeupdate" },
    { 0x90E0C047, "nodeusers" },
    { 0x9860B792, "nodeval" },
    { 0xFE605906, "nodisconnectpaths" },
    { 0xE163608E, "nododgemove" },
    { 0x475AE0F0, "nododgemove_old" },
    { 0xA7F94B42, "nodraw" },
    { 0xE49D847B, "nods" },
    { 0x270C22BC, "noenemyinfo" },
    { 0x7F260C30, "noes" },
    { 0xF941E3F6, "noexceptions" },
    { 0x86B33682, "noexplosivedeathanim" },
    { 0x05AB7F0F, "nofailsafe" },
    { 0x815B7595, "nofakeai" },
    { 0x19F289F7, "nofir" },
    { 0x52B0B328, "nofire" },
    { 0x319D1024, "nofirecrosshair" },
    { 0xB3317CBB, "nofirecrosshair_remove" },
    { 0x6A67A487, "nofirstframemelee" },
    { 0x5133F1D5, "noflyzone" },
    { 0x67D1DEB8, "noflyzoneheight" },
    { 0x96A8B524, "noflyzones" },
    { 0xA4A963F8, "nofour" },
    { 0x04086175, "nofriendlyfire" },
    { 0xD38B33CB, "nog" },
    { 0x9FF3CD7B, "nogibdeathanim" },
    { 0xAC542AB6, "nogravity" },
    { 0xC161DA67, "nogunshoot" },
    { 0xCBC3ADAE, "noharper_open_cougar_door" },
    { 0xD3C22D53, "nohat" },
    { 0x87FC1570, "nohatclassname" },
    { 0xA5D08426, "nohealthoverlay" },
    { 0x3582223C, "noheatanims" },
    { 0x01887E60, "nohintstring" },
    { 0x23606DB1, "nohitmarker" },
    { 0x103C3218, "nohitmarkers" },
    { 0xC587D412, "noifies" },
    { 0xA73F271A, "nointruderzones" },
    { 0x22ECD501, "noise" },
    { 0xC6F2E076, "noise_level" },
    { 0x67331E94, "noise_maker" },
    { 0x66FC21C2, "noisemakers" },
    { 0x6A922228, "noises" },
    { 0x5299CB6A, "noisytime" },
    { 0x706B1BE0, "nojump" },
    { 0x1BE8CE78, "nojumping" },
    { 0x63ECBF81, "noldvo" },
    { 0x6EE7DFAA, "nolivesleft" },
    { 0x7E784BC1, "nolock" },
    { 0x7A6F5E2F, "nolonger" },
    { 0x06FA39ED, "nolonger_spotted" },
    { 0xEB2FDA6A, "nomansland_kills" },
    { 0x69713B1F, "nomansland_score" },
    { 0xEA3F1473, "nomanslandtime" },
    { 0x954C05A1, "nomaxmortardist" },
    { 0xD536FF31, "nomeleechargedelay" },
    { 0x24743E96, "nomeleehits" },
    { 0xA8E1984A, "nomortars" },
    { 0xA89AF090, "nomsky" },
    { 0xDD9C8CAA, "non" },
    { 0x19E36857, "non_active" },
    { 0x33AD327E, "non_array_value" },
    { 0x8AC3A8DF, "non_attack_func_takes_attacker" },
    { 0x8F8163E5, "non_attacker_func" },
    { 0xAB2BF954, "non_default_turret_type" },
    { 0xE257CEB4, "non_destroyed_bar_board_order" },
    { 0x242E2EF3, "non_destroyed_grate_order" },
    { 0xAA232374, "non_destroyed_variant1_order" },
    { 0x43486867, "non_destroyed_variant2_order" },
    { 0x9F1A49A1, "non_destroyed_variant4_order" },
    { 0x0E9134E8, "non_destroyed_variant5_order" },
    { 0xBAE32054, "non_fire_idle_percent" },
    { 0xB1A47088, "non_fx_ents" },
    { 0x294A91BD, "non_ghost_round_failsafe" },
    { 0x937C6D27, "non_headshot_kill_counter" },
    { 0x2DF3F4E2, "non_mature_intro" },
    { 0x5261DA30, "non_mortar_guys_deathtally" },
    { 0xEEA7EC36, "non_player" },
    { 0x87F0EF62, "non_player_damage" },
    { 0xF79E579A, "non_ragdoll" },
    { 0x735DCF4E, "non_ripped_awning" },
    { 0x590F3370, "non_round_logic" },
    { 0xAD7C6680, "non_solid_pieces" },
    { 0xAF50710B, "non_solo_death" },
    { 0x3337CFF3, "non_squelched" },
    { 0xED105E30, "non_stowed_weapon" },
    { 0xE8C4B849, "non_wet_model" },
    { 0x68CDC694, "nonai" },
    { 0x01EA30B4, "nonai_bosses" },
    { 0x00086C8B, "nonanimatedpositions" },
    { 0xE38903A5, "nonbarragesize" },
    { 0x5AC17359, "noncolliding" },
    { 0x0B0A9776, "noncombat" },
    { 0xB423AC14, "noncombatlocomotioncondition" },
    { 0x8436293E, "noncombatlocomotionupdate" },
    { 0xA1984C32, "nondummy" },
    { 0xD47C1903, "none" },
    { 0xAB5BB7B7, "noneweapon" },
    { 0x2B5CEC7D, "nonexitant" },
    { 0x9094D398, "nonfatal" },
    { 0x0F661029, "nonflagobjective" },
    { 0x903562EF, "nonholders" },
    { 0xC4EE6515, "nonlinear" },
    { 0x3175F96C, "nonmovements" },
    { 0x4187EDB7, "nonotify" },
    { 0xB3CFBDFD, "nonplayerdamagetime" },
    { 0xB8CB26CA, "nonpredicted_local_player" },
    { 0x609F09F8, "nonpredictedlocalplayer" },
    { 0x3A3FE834, "nonsense" },
    { 0x082F1603, "nonsolid" },
    { 0x1638CC1C, "nonspawned" },
    { 0x62C90C54, "nonstatic" },
    { 0x0C66FC62, "nonstatictrig" },
    { 0x78324592, "nonstop" },
    { 0x712AF40E, "nonstopfire" },
    { 0x80590D07, "nonstopfireguy" },
    { 0x19B90ACA, "nonstowedweapon" },
    { 0x1ABBB975, "nontalkdelay" },
    { 0x02C09491, "nonteambasedteam" },
    { 0xB23A1DB1, "nonteleportinvalidcount" },
    { 0x039F0713, "noo" },
    { 0x534AFF1B, "noob" },
    { 0xD67D6094, "nooise" },
    { 0x5D5C57FA, "nook" },
    { 0x2F22E818, "noone" },
    { 0xF566419E, "nooo" },
    { 0xF03C34CD, "noooo" },
    { 0x028FD9F0, "nooooo" },
    { 0x7249F3D7, "noooooo" },
    { 0x6DFB0100, "nooooooooooooooooooooo" },
    { 0xED474AD1, "nope" },
    { 0xAD198B19, "nopersistence" },
    { 0x914A6497, "nophysics" },
    { 0x4F634943, "noplayermeleeblood" },
    { 0x9C5D19A6, "noprone" },
    { 0xE7050410, "nopronerotation" },
    { 0xE56AFC76, "nor" },
    { 0x919D41D5, "norad" },
    { 0x9F0B9641, "noradscreen" },
    { 0x9630436D, "noragdoll" },
    { 0x9CF7FC8D, "norambo" },
    { 0xEBBC02E8, "noreiga" },
    { 0xFAE69F5B, "noreload" },
    { 0xDAAD1B7A, "norestore" },
    { 0x170B1730, "noriega" },
    { 0x6EA710C4, "noriega4" },
    { 0xA5CF6560, "noriega_arrives_cuffs_logic" },
    { 0x3FFC5475, "noriega_arrives_head_switch" },
    { 0x00F9CEB0, "noriega_arrives_high_rage" },
    { 0x0692FD04, "noriega_arrives_look_at_mission" },
    { 0xE7747322, "noriega_arrives_low_rage" },
    { 0x5BDCE988, "noriega_arrives_menendez_vo" },
    { 0x49582E9D, "noriega_arrives_muddy_viewbody" },
    { 0x33918557, "noriega_arrives_pdf_blood" },
    { 0xEB0064A8, "noriega_arrives_scene" },
    { 0xE6E077C1, "noriega_arrives_spas_swap" },
    { 0xE8C4576E, "noriega_betrayed_weapon" },
    { 0xAAE31CED, "noriega_blood" },
    { 0xEA69677D, "noriega_idle_watch" },
    { 0x1A6E9CA8, "noriega_intro_anims" },
    { 0x692FFD9F, "noriega_jump" },
    { 0x66D1283D, "noriega_moves_up_to_ledge" },
    { 0x8A9949BF, "noriega_node" },
    { 0x1E562294, "noriega_pistol_animation_done" },
    { 0xDEED7053, "noriega_punched_blood" },
    { 0xAF2276E1, "noriega_rescue_event" },
    { 0x9CCAEB3A, "noriega_rescue_timer" },
    { 0xE41945C0, "noriega_rescued" },
    { 0xAFBAEF1C, "noriega_saved_player" },
    { 0x4A9DBDB7, "norm" },
    { 0x07344A1E, "norm_enemy" },
    { 0x44847698, "norm_facing" },
    { 0x195CCE39, "norm_move" },
    { 0x9EC7DF8B, "norm_speed" },
    { 0x288785E8, "normal" },
    { 0x932E6F97, "normal_baseaccuracy" },
    { 0x957E7A97, "normal_death" },
    { 0x0E5726B4, "normal_fov" },
    { 0xF30C3C0F, "normal_friendly_fire_penalty" },
    { 0xCFC6D9D7, "normal_game_end" },
    { 0x8C9654D9, "normal_spawn_trigger" },
    { 0xC07AFCC1, "normal_speed_fraction" },
    { 0x77773371, "normal_sunlight" },
    { 0x3F630206, "normal_vector" },
    { 0x46FC32A1, "normalangle" },
    { 0x5F7FB13A, "normalfunc" },
    { 0x4F505259, "normalheight" },
    { 0x9C4BCE8E, "normalize" },
    { 0xF0722BCE, "normalized" },
    { 0xE754F76D, "normalized_dist" },
    { 0xBA7381B1, "normalized_test" },
    { 0xA2BBB4CC, "normalized_wave_height" },
    { 0xBE6BE71A, "normalizedlength" },
    { 0x7100CE21, "normalizedtime" },
    { 0xD23E2131, "normalizes" },
    { 0x73F18C0D, "normally" },
    { 0x7FA6EE54, "normalnagdelaytime" },
    { 0x05F38A54, "normalnagonly" },
    { 0x8649AD83, "normals" },
    { 0x2EAA1809, "normalspeed" },
    { 0xA5C9DA0E, "normalvec" },
    { 0x837B9E4F, "normandy" },
    { 0xC6F4963B, "normangles" },
    { 0x934BC025, "normframes" },
    { 0x8327C5C6, "normgoalangles" },
    { 0x7E022CCF, "noroundnumber" },
    { 0xF7F010AA, "north" },
    { 0xEEA97CF7, "north_buildings_targeted" },
    { 0x3CD891C7, "north_ext_goals" },
    { 0x022A4E77, "north_light" },
    { 0x194E13ED, "north_of_house_clear" },
    { 0xD1E11D14, "north_pass_drones" },
    { 0x14FA26A9, "north_pos" },
    { 0x769A9621, "north_structs" },
    { 0x55E013EC, "north_vol" },
    { 0x6EC4038E, "north_zapper_light_green" },
    { 0xD5D3C03E, "north_zapper_light_red" },
    { 0x196578D2, "northbound" },
    { 0xE3F3CE81, "northboundvehicles" },
    { 0xBC3D26F5, "northeast" },
    { 0x4A10174F, "northern" },
    { 0xD0657566, "northernmost" },
    { 0x64E59DEB, "northportion" },
    { 0x5C2EE49F, "northvector" },
    { 0x9EC88FD7, "northwest" },
    { 0x3CC33343, "northyaw" },
    { 0x2B5D7537, "norunngun" },
    { 0x033E183D, "norusheryell" },
    { 0x0B6D76DF, "nos" },
    { 0x08CC5E3C, "noscavenger" },
    { 0x7FE5C91D, "noscope_line" },
    { 0x5F33A460, "nose" },
    { 0x2407B699, "nose_knockdown" },
    { 0xDFEF0EA3, "nose_pos" },
    { 0x20534B51, "nose_trigger" },
    { 0xB16DF5FB, "nosepick" },
    { 0x19348759, "noshoot" },
    { 0xE307E62F, "nosight" },
    { 0x8343B454, "nosmgpistolweaponanims" },
    { 0xAE60BA91, "nosound" },
    { 0xCAA08F91, "nospawn" },
    { 0xBE03C4BE, "nostatic" },
    { 0x39A7C8FE, "nostepout" },
    { 0x55169B9D, "nosympathy" },
    { 0xC57FFD39, "nosympathy_scene_woods_at_goal" },
    { 0x015C1E00, "not" },
    { 0x4D05453D, "not_abandoned" },
    { 0xC0F6846C, "not_absolute" },
    { 0x84DDE07A, "not_chain" },
    { 0x418040BE, "not_close_enough_to_ground" },
    { 0x9A9C983D, "not_dead" },
    { 0x6248B357, "not_emp" },
    { 0x2DA7DCE8, "not_flashed" },
    { 0x2D51228F, "not_for_bonuszm" },
    { 0x1C70B2D9, "not_here" },
    { 0x858985CF, "not_in_building_rating" },
    { 0x160D5242, "not_in_bunker" },
    { 0xD0EA20C0, "not_interruptable" },
    { 0x63BBE4CE, "not_move_in_guy" },
    { 0xB1ABBF62, "not_on_nav_mesh_count" },
    { 0x92FF7E78, "not_player" },
    { 0xC55F8367, "not_prone" },
    { 0x02F0BAF0, "not_quite_dead" },
    { 0xC1E49050, "not_silenced" },
    { 0xC215AE0E, "not_so_smart_now" },
    { 0x409E71A6, "not_so_smart_now_control_room" },
    { 0x3D5B5A35, "not_start" },
    { 0xFA8E1E14, "not_stunned" },
    { 0xB3D67A93, "not_talking" },
    { 0x98616ED3, "not_usable" },
    { 0xB03F6AC8, "not_used" },
    { 0xA8768F64, "notably" },
    { 0x3A0CE4B5, "notake" },
    { 0x6535EBAF, "notanksquish" },
    { 0xEA866B2E, "notatrackhandler" },
    { 0x816BCB94, "notavailabletext" },
    { 0x9533955D, "notcrouchingcondition" },
    { 0x01C0DF90, "notdone" },
    { 0x22FD856D, "note" },
    { 0x159D2215, "note2" },
    { 0x1DAC295C, "note_elapsed_time" },
    { 0xC412CBB4, "note_t" },
    { 0xA9213993, "noted" },
    { 0x790D664B, "notel" },
    { 0x07E08AAE, "notemomentumongameended" },
    { 0x0EDB8FE3, "notequals" },
    { 0xB1DD0AA8, "notequipment" },
    { 0x79D2A1F8, "noterack" },
    { 0x51135C53, "noteracks" },
    { 0x6EFC0D6C, "notes" },
    { 0xE5FAEE32, "notetack" },
    { 0x804CD50A, "notetime" },
    { 0x4298E0CA, "notetrack" },
    { 0x1D16323B, "notetrack_aftermath_karma_uses_computer" },
    { 0x8C3B9774, "notetrack_anim_end" },
    { 0xD3DD2B28, "notetrack_array" },
    { 0x96A6404B, "notetrack_attach_chip" },
    { 0x276E71C6, "notetrack_attach_crate" },
    { 0xC43A1B30, "notetrack_attach_knife" },
    { 0xBF3BBCEF, "notetrack_attach_ropes_to_woods" },
    { 0xE9B18895, "notetrack_attachknife" },
    { 0xA89A79B1, "notetrack_bandana_hide" },
    { 0xB2BAD9EA, "notetrack_bandana_show" },
    { 0xA45CD227, "notetrack_blink_end" },
    { 0xCADA1B4C, "notetrack_blink_start" },
    { 0xF9177418, "notetrack_blood_fx" },
    { 0xF0CE59DB, "notetrack_blood_guy_falling" },
    { 0x6E5EE9FD, "notetrack_briggs_exits" },
    { 0xA79DE09A, "notetrack_briggs_transmission" },
    { 0xD5B09DED, "notetrack_camo_shoot" },
    { 0xB52C5757, "notetrack_cctv_bink_start" },
    { 0x26F618F4, "notetrack_chopper_hit_explosion" },
    { 0xAD1969A2, "notetrack_code_move" },
    { 0x3438E384, "notetrack_crosby_gets_shot" },
    { 0xDEC52527, "notetrack_customfunction_exists" },
    { 0x8B7860F5, "notetrack_death" },
    { 0x08DA9AC3, "notetrack_defalco_drops_gun" },
    { 0x4A3141E5, "notetrack_defalco_drops_gun_setup" },
    { 0x5703EE1B, "notetrack_defalco_shoot" },
    { 0xE6F38870, "notetrack_defalco_uses_pistol" },
    { 0x4981B174, "notetrack_detach_crate" },
    { 0x8925094A, "notetrack_detach_knife" },
    { 0x7B823BAB, "notetrack_detactknife" },
    { 0x951CB57D, "notetrack_drone_shoot" },
    { 0x41DB3955, "notetrack_drop_gun_1" },
    { 0x9F0DD2FA, "notetrack_drop_shield" },
    { 0x7E159638, "notetrack_dropgun" },
    { 0x865EF63C, "notetrack_enable_player" },
    { 0x2F5F3398, "notetrack_enemy_fires_at_crosby" },
    { 0xCEF71B03, "notetrack_exit_align" },
    { 0xA9AED017, "notetrack_eye_candy01" },
    { 0x4515CE56, "notetrack_eyeball_smash" },
    { 0x1AE3EA90, "notetrack_f38_add_exhaust_fx" },
    { 0x240BA71E, "notetrack_fade_to_mason_section" },
    { 0xC0EEE50E, "notetrack_fade_to_menendez_section" },
    { 0x6725F6D2, "notetrack_farid_shot" },
    { 0x4EB7DAA0, "notetrack_fire_bullet" },
    { 0x28CAECAA, "notetrack_flash_on_camera_cut" },
    { 0x4FEA30EC, "notetrack_function_end_mission" },
    { 0x491082E6, "notetrack_fxanim_f38_fires_guns" },
    { 0xD6CDB442, "notetrack_fxanim_f38_stops_firing" },
    { 0xE98442F6, "notetrack_geton_pbr_grab_m202" },
    { 0x6A87BBCD, "notetrack_geton_pbr_spawn_fake_m202" },
    { 0x1CC89B82, "notetrack_geton_pbr_weapon_on_back" },
    { 0xF871ACEA, "notetrack_gib_arm_left" },
    { 0x0FA53339, "notetrack_gib_arm_right" },
    { 0x718883DC, "notetrack_gib_disable" },
    { 0x37CC162E, "notetrack_gib_head" },
    { 0x12E56D04, "notetrack_gib_leg_left" },
    { 0xB366F67B, "notetrack_gib_leg_right" },
    { 0x1C6653FF, "notetrack_give_exit_enemy_weapon" },
    { 0x02AE2224, "notetrack_grenade_throw" },
    { 0xDF2BD67D, "notetrack_harper_hides_pistol" },
    { 0xC687398F, "notetrack_harper_shoots_salazar" },
    { 0x414B59E4, "notetrack_harper_uses_pistol" },
    { 0x7DCDE986, "notetrack_hide_ai" },
    { 0x9B105AD8, "notetrack_hide_weapon" },
    { 0x7ECC1E5B, "notetrack_interact" },
    { 0xAC34C972, "notetrack_interrogation_explosion" },
    { 0x80BB07B1, "notetrack_intro_dof_arm_to_menendez" },
    { 0xDFB83D5E, "notetrack_intro_dof_arm_to_menendez_2" },
    { 0x96F719DB, "notetrack_intro_dof_eye_scan" },
    { 0x0D9C2D50, "notetrack_intro_dof_hands_up" },
    { 0xB5285229, "notetrack_intro_dof_hit_ground" },
    { 0x01BF5DD6, "notetrack_intro_dof_look_at_menendez" },
    { 0x7C90E28D, "notetrack_intro_dof_look_at_menendez_2" },
    { 0x568E6824, "notetrack_intro_dof_look_at_menendez_3" },
    { 0x308BEDBB, "notetrack_intro_dof_look_at_menendez_4" },
    { 0x8A5A3660, "notetrack_intro_dof_look_at_wall" },
    { 0xC13C8403, "notetrack_intro_dof_menendez_to_arm" },
    { 0xF0D2A578, "notetrack_intro_dof_menendez_to_arm_2" },
    { 0x09023AA1, "notetrack_intro_dof_open_door" },
    { 0xB2C2DE3D, "notetrack_intro_dof_pick_up_chair" },
    { 0x5323481D, "notetrack_intro_dof_place_gun_on_table" },
    { 0xFF042875, "notetrack_intro_dof_point_at_menendez" },
    { 0xE2074D1F, "notetrack_intro_dof_put_on_hand_cuffs" },
    { 0xF87F0FC5, "notetrack_intro_dof_shoot_guard" },
    { 0x1677626E, "notetrack_intro_dof_stand_up" },
    { 0x3B24C30D, "notetrack_intro_dof_talk_to_briggs" },
    { 0xCAF9E1AC, "notetrack_intro_dof_turn_to_door" },
    { 0xBC2CBEA2, "notetrack_light_flicker" },
    { 0x802C34CE, "notetrack_lights_on" },
    { 0xB68EC0A3, "notetrack_lights_out" },
    { 0x79DA69B5, "notetrack_meat_shield_briggs_back" },
    { 0x16CB781C, "notetrack_meat_shield_distant_guard" },
    { 0xD56B6B92, "notetrack_meat_shield_guard_1" },
    { 0xAF68F129, "notetrack_meat_shield_guard_2" },
    { 0x896676C0, "notetrack_meat_shield_guard_3" },
    { 0x9377CF9F, "notetrack_meat_shield_guard_4" },
    { 0xA41EF967, "notetrack_meat_shield_gun_1" },
    { 0x2F044A64, "notetrack_meat_shield_see_all" },
    { 0xCC57DFE8, "notetrack_meat_shield_start_reactions" },
    { 0xEFAAC826, "notetrack_melee_unsync" },
    { 0xD9BBE2CC, "notetrack_menendez_mask_off" },
    { 0x95583FAF, "notetrack_menendez_punched_in_the_face" },
    { 0x119CD095, "notetrack_menenedez_mask_on" },
    { 0xFB6FAB4A, "notetrack_motel_nextmission" },
    { 0x19E80828, "notetrack_movement_run" },
    { 0x50428A65, "notetrack_movement_stop" },
    { 0x427E1D98, "notetrack_name" },
    { 0xAA6439B0, "notetrack_outro_lookat_ship_1" },
    { 0x1C6BA8EB, "notetrack_outro_lookat_ship_2" },
    { 0xF6692E82, "notetrack_outro_lookat_ship_3" },
    { 0xE907FC5F, "notetrack_outro_spawn_deck_enemies" },
    { 0x59774E2E, "notetrack_pbr_hit_fx_1" },
    { 0x3374D3C5, "notetrack_pbr_hit_fx_2" },
    { 0x0D72595C, "notetrack_pbr_hit_fx_3" },
    { 0x891C6A49, "notetrack_play_vent_anim" },
    { 0x7ABC387E, "notetrack_player_leaves_monitor" },
    { 0x9D24764F, "notetrack_pmc_shoot" },
    { 0x67A92F80, "notetrack_prestige_sailor_shot" },
    { 0x56E5147A, "notetrack_ragdoll" },
    { 0x62AC8D2E, "notetrack_ragdoll_nodeath" },
    { 0x296D38E7, "notetrack_remove_blend_time" },
    { 0xE036F843, "notetrack_sacrifice_grenade" },
    { 0xF1A7675A, "notetrack_salazar_runs_into_hallway" },
    { 0xDF153C0A, "notetrack_server_room_door_guy_torch_fx_start" },
    { 0xA6372DE2, "notetrack_server_room_door_guy_torch_fx_stop" },
    { 0x621AA36A, "notetrack_set_blend_time_zero" },
    { 0x540C0FA8, "notetrack_set_blend_times" },
    { 0xB6A8DC49, "notetrack_set_blend_times_long" },
    { 0xE55B138C, "notetrack_setup" },
    { 0xDB848041, "notetrack_setup_table" },
    { 0x2E5B300F, "notetrack_show_ai" },
    { 0x38FBC6A1, "notetrack_show_weapon" },
    { 0x0BA0229D, "notetrack_stab" },
    { 0x52136681, "notetrack_stairs_step1" },
    { 0x7815E0EA, "notetrack_stairs_step2" },
    { 0x1DAE8FAA, "notetrack_stance_crouch" },
    { 0xD6D4C4EC, "notetrack_stance_prone_back" },
    { 0xC20F991E, "notetrack_stance_prone_front" },
    { 0x7FC48518, "notetrack_stance_stand" },
    { 0x06624CF9, "notetrack_start_camera_cuts" },
    { 0xC4EF918B, "notetrack_start_turn" },
    { 0xEA4D2B03, "notetrack_start_virus_2_bink" },
    { 0xBA06883A, "notetrack_start_virus_bink" },
    { 0x85158C99, "notetrack_stop_turn" },
    { 0xCDB165E6, "notetrack_super_kill_alive_a_defalco_react" },
    { 0x13826486, "notetrack_super_kill_alive_a_dof_10_salazar" },
    { 0x3F6D4C82, "notetrack_super_kill_alive_a_dof_5_salazar_pistol" },
    { 0xD000FFDF, "notetrack_super_kill_alive_a_dof_6_karma" },
    { 0x221C0EF4, "notetrack_super_kill_alive_a_dof_7_farid_pistol" },
    { 0x5D81E229, "notetrack_super_kill_alive_a_dof_8_defalco" },
    { 0xAB4D8640, "notetrack_super_kill_alive_a_dof_9_farid" },
    { 0xF3713BDA, "notetrack_super_kill_alive_a_farid_react" },
    { 0x9747D44E, "notetrack_super_kill_alive_a_karma_react" },
    { 0x562EE522, "notetrack_super_kill_alive_b_8_defalco_pistol" },
    { 0x0F02E405, "notetrack_super_kill_alive_b_defalco_react" },
    { 0x28D63087, "notetrack_super_kill_alive_b_dof_10_farid" },
    { 0xC50C320E, "notetrack_super_kill_alive_b_dof_11_salazar" },
    { 0xFBCC8BC7, "notetrack_super_kill_alive_b_dof_5_farid" },
    { 0x6B1D15FA, "notetrack_super_kill_alive_b_dof_6_farid_pistol" },
    { 0x07221599, "notetrack_super_kill_alive_b_dof_7_defalco" },
    { 0x88AAF6AB, "notetrack_super_kill_alive_b_dof_9_farid" },
    { 0x3073834B, "notetrack_super_kill_alive_b_farid_cough_blood" },
    { 0xBF7B2A05, "notetrack_super_kill_alive_b_farid_react" },
    { 0xEB8AF8F2, "notetrack_super_kill_alive_c_defalco_knife" },
    { 0x3CA7C182, "notetrack_super_kill_alive_c_dof_5_karma" },
    { 0x5488A9F1, "notetrack_super_kill_alive_c_dof_6_defalco" },
    { 0x976FA0A4, "notetrack_super_kill_alive_c_karma_react" },
    { 0x3C51E5EE, "notetrack_super_kill_dead_a_8_karma" },
    { 0xDE2BE23D, "notetrack_super_kill_dead_a_dof_10_karma" },
    { 0x009A736C, "notetrack_super_kill_dead_a_dof_11_salazar" },
    { 0xDA187DE5, "notetrack_super_kill_dead_a_dof_5_salazar" },
    { 0x1F4CC31E, "notetrack_super_kill_dead_a_dof_6_karma" },
    { 0x09194F63, "notetrack_super_kill_dead_a_dof_7_farid" },
    { 0x1B602A39, "notetrack_super_kill_dead_a_dof_9_salazar" },
    { 0x83329269, "notetrack_super_kill_dead_a_farid_cough_blood" },
    { 0xB7566217, "notetrack_super_kill_dead_a_farid_react" },
    { 0xE9EE54F3, "notetrack_super_kill_dead_a_karma_react" },
    { 0x15D2777E, "notetrack_super_kill_dead_b_dof_5_farid" },
    { 0xCCBB1279, "notetrack_super_kill_dead_b_dof_6_farid" },
    { 0x8D56A8C4, "notetrack_super_kill_dead_b_dof_7_salazar" },
    { 0x2DCC8B4A, "notetrack_super_kill_dead_b_farid_cough_blood" },
    { 0x2ACC6228, "notetrack_super_kill_dead_b_farid_react" },
    { 0x877B88D3, "notetrack_super_kill_dead_c_dof_5_karma" },
    { 0x31F1E2AC, "notetrack_super_kill_dead_c_dof_6_salazar" },
    { 0x5FAE347D, "notetrack_super_kill_dead_c_dof_7_karma" },
    { 0x8F66A766, "notetrack_super_kill_dead_c_dof_8_karma" },
    { 0x61EA1491, "notetrack_super_kill_dead_c_karma_react" },
    { 0xE1AB0984, "notetrack_super_kill_dead_d_dof_5_salazar" },
    { 0x8188AA96, "notetrack_super_kill_dof_1_salazar" },
    { 0xC3C71549, "notetrack_super_kill_dof_2_salazar" },
    { 0x4492F8E2, "notetrack_super_kill_dof_3_guard01" },
    { 0x8C1877B6, "notetrack_super_kill_dof_4_guard02" },
    { 0x658B2DF2, "notetrack_super_kill_duel_achievement" },
    { 0xCAB8841D, "notetrack_super_kill_flash_on_camera_cut" },
    { 0x6C64C24E, "notetrack_super_kill_ground_impact" },
    { 0x6AB6A687, "notetrack_super_kill_guard_1_react" },
    { 0xC466573C, "notetrack_super_kill_guard_2_react" },
    { 0x564D249F, "notetrack_super_kill_gun_fx" },
    { 0x7AB553C9, "notetrack_super_kill_player_loop_think" },
    { 0xBC339CFF, "notetrack_switch_to_sidearm" },
    { 0x791603BC, "notetrack_sync" },
    { 0xC1032148, "notetrack_table_shake" },
    { 0x5B15A376, "notetrack_taser_knuckle_spark" },
    { 0xF5709054, "notetrack_time_array" },
    { 0x86B9A7D1, "notetrack_times" },
    { 0x8A3F14DC, "notetrack_torch_guy_takes_cover" },
    { 0x0068DAE8, "notetrack_torch_guy_torch_off" },
    { 0x7CEE9302, "notetrack_torch_guy_torch_on" },
    { 0x185AA1C5, "notetrack_unsync" },
    { 0x611856B3, "notetrack_video_start" },
    { 0x0E3F528E, "notetrack_wait" },
    { 0x67694C37, "notetrack_window_throw_attach_gun" },
    { 0xEB44B40F, "notetrack_window_throw_drop_gun" },
    { 0x424B21A6, "notetrack_zombies_board_melee" },
    { 0xAB1026E6, "notetrack_zombies_board_tear" },
    { 0xBE3143DC, "notetrackalertnessaiming" },
    { 0xDD9A3621, "notetrackalertnessalert" },
    { 0xA14CD192, "notetrackalertnesscasual" },
    { 0xC2ECCE12, "notetrackanimmovementstop" },
    { 0x9802A675, "notetrackarray" },
    { 0x1AB5E3BC, "notetrackattachknife" },
    { 0xE8F0E805, "notetrackbecomecorpse" },
    { 0xC5E3B4DA, "notetrackboardmelee" },
    { 0xF628891A, "notetrackboardtear" },
    { 0xC6DB2835, "notetrackbodyfall" },
    { 0x1A5F834B, "notetrackchesttoback" },
    { 0x7AACD9A3, "notetrackclearlookat" },
    { 0x5C8F821A, "notetrackdetachknife" },
    { 0x7535DFAF, "notetrackdropclip" },
    { 0xFD40F92D, "notetrackdropgun" },
    { 0x8662ADC2, "notetrackdropguninternal" },
    { 0xABC1874E, "notetrackdropshield" },
    { 0xA8372A5D, "notetracked" },
    { 0xBFB3B4FE, "notetracked_clientnotifies" },
    { 0xFC0A8EFB, "notetracker" },
    { 0xD5ACBDB6, "notetrackfire" },
    { 0x0F581F6A, "notetrackfirebullet" },
    { 0x499846F1, "notetrackfirespray" },
    { 0x2FFB7DD6, "notetrackfootscrape" },
    { 0x6BB167B4, "notetrackfootstep" },
    { 0x83D10E78, "notetrackfunc" },
    { 0x102ED1B6, "notetrackfuncptr" },
    { 0x00D0B768, "notetrackgibdisable" },
    { 0x77AAC8DC, "notetrackgravity" },
    { 0x8116F4F4, "notetrackgrenadethrow" },
    { 0xBA08C8DB, "notetrackgundrop" },
    { 0xA2CE99C7, "notetrackgunhand" },
    { 0x8D7AE616, "notetrackguntoback" },
    { 0x30D85C92, "notetrackguntochest" },
    { 0x0BDFFB7A, "notetrackhandler" },
    { 0xBDD633C5, "notetrackheadlookatplayer" },
    { 0x76CFA24A, "notetrackhide" },
    { 0xBA20E934, "notetrackhideai" },
    { 0xF2DE851A, "notetrackhideweapon" },
    { 0x52E16F36, "notetrackindex" },
    { 0x76B29E8A, "notetrackinfo" },
    { 0x396AA17D, "notetrackland" },
    { 0x50BDAB4F, "notetracklaser" },
    { 0xD75627C0, "notetrackloadshell" },
    { 0x18C50987, "notetracklookatplayer" },
    { 0x8858A2FE, "notetrackmeleeunsync" },
    { 0x291565A8, "notetrackmovementrun" },
    { 0xB4ACBAE5, "notetrackmovementstop" },
    { 0x766AA3AE, "notetrackmovementwalk" },
    { 0xA3E05E57, "notetrackname" },
    { 0xA7D10937, "notetrackpistolpickup" },
    { 0xF2A7142C, "notetrackpistolputaway" },
    { 0x5E73071E, "notetrackpistolrechamber" },
    { 0xDD6690C4, "notetrackposeback" },
    { 0xD65987DA, "notetrackposecrawl" },
    { 0x2CF4F7BB, "notetrackposecrouch" },
    { 0x98973851, "notetrackposeprone" },
    { 0x81D67177, "notetrackposestand" },
    { 0xCB1434CC, "notetrackrefillclip" },
    { 0x1A7FBD05, "notetracks" },
    { 0x26D9FCA7, "notetracks_in_range" },
    { 0x0C853D8F, "notetracksfunc" },
    { 0xFAB51049, "notetrackshow" },
    { 0x498C6317, "notetrackshowai" },
    { 0xB75A1BD9, "notetrackshowweapon" },
    { 0x6502FCBC, "notetrackstaircasestep1" },
    { 0xD70A6BF7, "notetrackstaircasestep2" },
    { 0xA4DB6FE3, "notetrackstartragdoll" },
    { 0x992A665C, "notetrackstartragdollnodeath" },
    { 0x58BA05CD, "notetrackstopanim" },
    { 0xE4295599, "notetrackwait" },
    { 0x15A359B2, "notetrackweaponswitch" },
    { 0x690871E2, "notetrackweaponswitchglint" },
    { 0x5C58434C, "notetraclk" },
    { 0xA24A133B, "notetrak" },
    { 0xD60046C0, "noteworhty" },
    { 0x90159F04, "noteworthies" },
    { 0x11C15888, "noteworthy" },
    { 0xEA607185, "noteworthy_check" },
    { 0xEBBD23AB, "noteworthy_function" },
    { 0x14CE9CD2, "noteworthy_name" },
    { 0x484139E4, "noteworthy_to_wait_for" },
    { 0xE824F2CC, "noteworthynode" },
    { 0x9D5F4E91, "noteworthyortargetname" },
    { 0xCCEED9A3, "noteworthys" },
    { 0x9FF3F417, "notfies" },
    { 0xB40E32E5, "notfirsttime" },
    { 0x844C86CC, "notfirsttimedogs" },
    { 0xC5BDC490, "notforcedcover" },
    { 0xF7DC4C63, "notfy" },
    { 0x367E9AB5, "nothin" },
    { 0xB52A1970, "nothing" },
    { 0x6D5C5047, "nothreatupdate" },
    { 0x251AB910, "noticable" },
    { 0x88B0A165, "notice" },
    { 0xF7734AD9, "noticeable" },
    { 0xBB53757B, "noticed" },
    { 0x416F24A8, "noticely" },
    { 0x417D9674, "notices" },
    { 0xC2AFBDCA, "notifcations" },
    { 0x90DA82A2, "notifed" },
    { 0x76911730, "notification" },
    { 0x08608307, "notification_on_death" },
    { 0x2935309B, "notifications" },
    { 0x82DFE931, "notified" },
    { 0xC7166E37, "notifier" },
    { 0xA113F3CE, "notifies" },
    { 0x890842C6, "notifiesdone" },
    { 0x55619495, "notifify" },
    { 0x2FAE0A5E, "notify" },
    { 0x0CD2AB6A, "notify0" },
    { 0xB46639C7, "notify_after_anim" },
    { 0x6090276B, "notify_after_damage" },
    { 0xBDEFB659, "notify_after_patrol_b" },
    { 0xC9D224AE, "notify_all" },
    { 0x8118324A, "notify_and_set_flag" },
    { 0x030C75A4, "notify_at_certain_spot" },
    { 0xA8D21D9C, "notify_at_range" },
    { 0x10F17506, "notify_bb_stealthbreak" },
    { 0xC3CFD335, "notify_binoc_change" },
    { 0x7E76C518, "notify_bowman_hit_hb" },
    { 0x1D63CFA4, "notify_check_quickrevive_for_hotjoin" },
    { 0xE96E9B88, "notify_clearing_truck" },
    { 0x21A7D762, "notify_count" },
    { 0x54F47D82, "notify_crew" },
    { 0x202A8E81, "notify_damage_or_death" },
    { 0x1464B9AA, "notify_delay" },
    { 0x966559BE, "notify_delay_with_ender" },
    { 0xCDCAB292, "notify_door_kick" },
    { 0xA2A6AC8A, "notify_end_position" },
    { 0x485A0C24, "notify_ent" },
    { 0x7BF8BED7, "notify_event" },
    { 0xAE15C8AA, "notify_from_flag" },
    { 0xB4D18E7E, "notify_from_level" },
    { 0x2AB40F37, "notify_from_notify" },
    { 0x140F1DA2, "notify_fuelguy" },
    { 0x9E11B7B1, "notify_gastrap_door_kick" },
    { 0xAB00BA6A, "notify_gastrap_mask_off" },
    { 0xC7F6E049, "notify_grenade_danger" },
    { 0x9A769B7B, "notify_grid_off" },
    { 0x4F247387, "notify_grid_on" },
    { 0xDE61FBC8, "notify_group_gone" },
    { 0x947C5EFB, "notify_if_either_interrupted" },
    { 0x65B3426F, "notify_if_interrupted" },
    { 0x3D6ABC87, "notify_if_patroller_has_pass_player" },
    { 0x9D5FD46F, "notify_impact" },
    { 0xA530DD0A, "notify_interval" },
    { 0x34B5CBB6, "notify_leaper_on_damage" },
    { 0x7D3E543D, "notify_level" },
    { 0xE7ACBDF3, "notify_mode_switch" },
    { 0x25C56168, "notify_msg" },
    { 0x8B75CD84, "notify_name" },
    { 0xCB665E56, "notify_next_tv_round" },
    { 0x33289855, "notify_next_wave_if_no_targets" },
    { 0xF25AE8CE, "notify_nuke" },
    { 0x3E7F085C, "notify_offset" },
    { 0x2C96B624, "notify_on_advance_trigger" },
    { 0x3FC211BE, "notify_on_detonation" },
    { 0xB43D55F4, "notify_on_end" },
    { 0xAF14BD2E, "notify_on_lookat_trigger" },
    { 0x65E56FDE, "notify_on_notify" },
    { 0x5D2FF0D9, "notify_on_sprint" },
    { 0x50013D5F, "notify_on_trig" },
    { 0x26F40363, "notify_on_trigger" },
    { 0x42E2D0C8, "notify_on_trigger_death" },
    { 0x6E0794D4, "notify_param" },
    { 0xDE5E25C7, "notify_perimeter_on_trig" },
    { 0x54158E25, "notify_pilot_and_radioman" },
    { 0x544BC7C7, "notify_play" },
    { 0xE4B0584A, "notify_player" },
    { 0x06237D74, "notify_player_landing_animation_start" },
    { 0x000AF174, "notify_player_lock_crossbow_pos" },
    { 0x54B22A86, "notify_playitcool_dialog" },
    { 0xAFF13540, "notify_rack_fall" },
    { 0x64950A10, "notify_raise_gun" },
    { 0x07E975A9, "notify_rats" },
    { 0x7F0DDA40, "notify_respawner_on_death_or_leap" },
    { 0xD430C447, "notify_roof_guard_when_player_shoots" },
    { 0x93E2F138, "notify_sniperfire" },
    { 0x28F3D51A, "notify_special" },
    { 0xB21E1844, "notify_start_guards" },
    { 0xCFAB9865, "notify_start_run" },
    { 0x02E5AAA8, "notify_start_soldier_anim" },
    { 0x20C20CF5, "notify_stop" },
    { 0xA142A722, "notify_str" },
    { 0x92EB0F0E, "notify_string" },
    { 0x8EF0AAB1, "notify_strings" },
    { 0x52973C07, "notify_swap_to_reznov" },
    { 0x1D946C00, "notify_tanks" },
    { 0xAD1FABA8, "notify_targeted_trigger" },
    { 0x8B54C1D6, "notify_tarp" },
    { 0x1F1745A2, "notify_tent" },
    { 0x80409246, "notify_timeout" },
    { 0xA357904C, "notify_timer" },
    { 0xB518D8B3, "notify_to_self" },
    { 0x3C70592A, "notify_to_wait_for" },
    { 0x701FABC7, "notify_truckguy" },
    { 0x3B4A7575, "notify_type" },
    { 0x0C5096F6, "notify_unit_has_arived" },
    { 0x7FF7F902, "notify_wait" },
    { 0x479F8EA3, "notify_weaver_rescue_door_bash" },
    { 0x9C01A1CF, "notify_weaver_rescue_door_close" },
    { 0xED6CE229, "notify_weaver_rescue_door_open" },
    { 0xDFA16769, "notify_weaver_rescue_start_woodsbowman" },
    { 0x7BAFDA75, "notify_weaverstab" },
    { 0xFC5A2AE0, "notify_when_2nd_group_only_has_1_guy" },
    { 0xD701013B, "notify_when_both_ai_groups_are_dead" },
    { 0x499CE25C, "notify_when_done" },
    { 0x11B172E5, "notify_when_melee_over" },
    { 0x767387F1, "notify_when_player_can_melee" },
    { 0x85484C22, "notify_when_player_turns_around" },
    { 0x8DB6F29E, "notify_when_trigger_hit" },
    { 0x2525DBAD, "notify_when_within_distance" },
    { 0x9A111C9D, "notify_window_break" },
    { 0xB318D838, "notify_wolf_intro_anim_complete" },
    { 0x8C052930, "notify_zip_end_when_move_done" },
    { 0x4F503EFA, "notify_zone_whendone" },
    { 0x0D9404EB, "notifyaftertime" },
    { 0xDFCEDFB1, "notifyarrived" },
    { 0xD4B3868B, "notifyavail" },
    { 0xB9F48D20, "notifyconnecting" },
    { 0x20E1FD85, "notifydamage" },
    { 0xA709427C, "notifydamageafterframe" },
    { 0x01C88568, "notifydamagenotdone" },
    { 0xB444826E, "notifydata" },
    { 0x1C834DC8, "notifydeath" },
    { 0x5E657F62, "notifyduration" },
    { 0xEF3FF29E, "notifyendofgameplay" },
    { 0x98960B45, "notifyent" },
    { 0x44CB7FCF, "notifyfinish" },
    { 0x4C8ECFE4, "notifygrenadepickup" },
    { 0x7692DD85, "notifyicon" },
    { 0x27F70FE2, "notifying" },
    { 0xADC8AE52, "notifylevelondelete" },
    { 0xD1686F4C, "notifymeinnsec" },
    { 0xA73C3A23, "notifymessage" },
    { 0x7F4CD48E, "notifymessagebegin" },
    { 0xEBCDDA07, "notifymessagedone" },
    { 0x3221A62D, "notifymsg" },
    { 0xF8C88BA3, "notifyname" },
    { 0x3D4978F2, "notifynode" },
    { 0xA735C315, "notifyonanimend" },
    { 0x067688BB, "notifyonbulletimpact" },
    { 0x2592FEF0, "notifyoncommand" },
    { 0x6EB01069, "notifyonplayercommand" },
    { 0xCC9464C6, "notifyonstartaim" },
    { 0xE695A3CA, "notifyontimeout" },
    { 0x326F772F, "notifyprogress" },
    { 0x43348C07, "notifyqueue" },
    { 0xF003322C, "notifyroundendtoui" },
    { 0x663196C1, "notifys" },
    { 0x5AB06387, "notifysquadmembersofneworders" },
    { 0x4FC1DF56, "notifystart" },
    { 0xD7D3E895, "notifystartaim" },
    { 0xB652AE82, "notifystopshootingaftertime" },
    { 0x3AF96527, "notifystr" },
    { 0x5D6445F9, "notifystring" },
    { 0xF84EA042, "notifystring1" },
    { 0xD24C25D9, "notifystring2" },
    { 0x3461A893, "notifyteamwavespawn" },
    { 0xDA258253, "notifytext" },
    { 0x2888112B, "notifytext2" },
    { 0x028596C2, "notifytext3" },
    { 0xD0781507, "notifytimeout" },
    { 0x6A60DE54, "notifytitle" },
    { 0xB2CD8CC1, "notifytitleghost" },
    { 0xAC91077E, "notifytype" },
    { 0xE723D9BD, "notifywait" },
    { 0x5EE51496, "notkillstreak" },
    { 0x847D5C21, "notlastguy" },
    { 0xFC302842, "notme" },
    { 0x10C88FBE, "notourwar_conversation" },
    { 0x49B34742, "notplayedboost" },
    { 0x2AD005EF, "notplayer" },
    { 0xB1B6209A, "notrealdeath" },
    { 0x422037F5, "notsolid" },
    { 0x4EFFFFA7, "notstandingcondition" },
    { 0x499A142F, "notstunnedhandler" },
    { 0xF3BECE95, "nottargettedai_underminspeedtimer" },
    { 0x687A1A7D, "notti" },
    { 0x1FC5FF08, "nottop3" },
    { 0x654BC6BE, "nottopplayer" },
    { 0x222ABEBA, "noturret" },
    { 0xF0DECB7C, "noturretplacementtriggers" },
    { 0x380D0431, "notusabletext" },
    { 0x0B89939F, "notused" },
    { 0xB64168ED, "nounload" },
    { 0x8822681F, "nova" },
    { 0x419BE7AB, "nova6" },
    { 0x260B9430, "nova6_death" },
    { 0x3210612E, "nova6_heli_spawners" },
    { 0xB9FF6EE1, "nova6_helicopter_1" },
    { 0xE001E94A, "nova6_helicopter_2" },
    { 0x254B924B, "nova6_vo" },
    { 0x26E90B74, "nova_org" },
    { 0x00FD009E, "nova_seis" },
    { 0xE00D5F82, "nova_six" },
    { 0x9792BEEB, "novehiclefacethread" },
    { 0xDA189F97, "november" },
    { 0x73638D3B, "now" },
    { 0xE94F6B74, "now_playing" },
    { 0x27019484, "now_zone" },
    { 0x22AE299F, "nowait" },
    { 0x4435D4D2, "nowcomplete" },
    { 0x548B63BD, "noweapontoss" },
    { 0xE298B3A0, "nownotify" },
    { 0x7D83FE20, "nowoundedrushing" },
    { 0x712EA5A0, "nowrap" },
    { 0x3B7B8F59, "nowrite" },
    { 0x360D60B4, "noxp" },
    { 0xCA6E3996, "nozone" },
    { 0x5080EC5B, "np" },
    { 0xA3BAC75C, "npath" },
    { 0x7CE4750A, "npc" },
    { 0xEC1DACD7, "npc1" },
    { 0xD195F275, "npc_damage_scale" },
    { 0x10B7038C, "npc_damage_scale_breakoff" },
    { 0x3903423F, "npc_pipe_slide" },
    { 0x9F268A2F, "npc_pipe_slide_reach" },
    { 0x3B19A68E, "npc_soct_rams_player_soct" },
    { 0xF06B2DF8, "npc_vox" },
    { 0x7298313C, "npcclassinit" },
    { 0x923B21B7, "npccount" },
    { 0x22129F1B, "npcdelete" },
    { 0x86087DA9, "npcid" },
    { 0x9916C3FF, "npcidtracker" },
    { 0x20B75245, "npcs" },
    { 0x4DA6740D, "npcs_ready" },
    { 0x87EF8B31, "npcsoundonuse" },
    { 0x047BF789, "nr" },
    { 0xE31EB813, "nradius" },
    { 0xD6E875FC, "nrandamagebase" },
    { 0x15EA3178, "nrange" },
    { 0xE53A5BC1, "nscriptthreadedrandoms" },
    { 0xDB0D5DEC, "nsecondsbetweenmelee" },
    { 0x4106F38A, "nspeed" },
    { 0xB1228AD1, "ntr_02a" },
    { 0x874A2FCE, "ntr_02a_fxanim_2" },
    { 0x052EB3C4, "ntr_02a_render" },
    { 0xD725053A, "ntr_02b" },
    { 0x71EE2F95, "ntr_02b_render" },
    { 0xFD277FA3, "ntr_02c" },
    { 0xE9E7399A, "ntr_02c_render" },
    { 0x2329FA0C, "ntr_02d" },
    { 0xE7BA5BFB, "ntr_02d_render" },
    { 0x56CB1A06, "nts" },
    { 0xC2885B96, "nu" },
    { 0xB8568541, "nuclear" },
    { 0x8226DBAA, "nudge" },
    { 0x21F990BF, "nudge_collision" },
    { 0xCE8E468E, "nuke" },
    { 0x7EA3E732, "nuke_anim" },
    { 0x0A72CFCE, "nuke_chopper_crash" },
    { 0x4BE9C108, "nuke_chopper_spin_and_fx" },
    { 0x6871F3FC, "nuke_choppers_think" },
    { 0xB77D2825, "nuke_clock_moved" },
    { 0x0141C6A4, "nuke_complete" },
    { 0x91AEB016, "nuke_crash" },
    { 0xA22D6E4B, "nuke_damage_func" },
    { 0xBA34D1CE, "nuke_delay_spawning" },
    { 0xA807A3EE, "nuke_detonation" },
    { 0x0E3F7498, "nuke_dist_sq" },
    { 0x7EDD269E, "nuke_earthquake" },
    { 0x666223AE, "nuke_effect" },
    { 0x36DF3982, "nuke_exploder_trigs" },
    { 0xB1A1A188, "nuke_exploders_think" },
    { 0x32D95C1D, "nuke_flash" },
    { 0x8E399ABF, "nuke_flight" },
    { 0x2816676F, "nuke_loop" },
    { 0x601FC483, "nuke_origin" },
    { 0xB1C5E6C2, "nuke_pickedup" },
    { 0xD6143667, "nuke_powerup" },
    { 0x3F8F8AE6, "nuke_react" },
    { 0x70EF2702, "nuke_seaknight_02" },
    { 0x584AFC48, "nuke_seaknight_spin" },
    { 0x578D220F, "nuke_section_start" },
    { 0xFE76EAEA, "nuke_server_room" },
    { 0xF7719E3A, "nuke_shockwave_blur" },
    { 0xFC1903E3, "nuke_sunlight" },
    { 0x9E19804A, "nuke_time" },
    { 0xCE80484F, "nuke_tree_fall" },
    { 0x3E76CE30, "nuke_trees" },
    { 0xAA077088, "nuke_triggered" },
    { 0x0F1513CE, "nuked" },
    { 0x75010EFF, "nuked_bomb_drop_dev" },
    { 0xD5D0EAB6, "nuked_bomb_drop_think" },
    { 0x923DF850, "nuked_collision_patch" },
    { 0x9EB664EB, "nuked_doomsday_clock_init" },
    { 0x63073365, "nuked_doomsday_clock_seconds_think" },
    { 0x2EB30E0B, "nuked_doomsday_clock_think" },
    { 0x0F506479, "nuked_end_game" },
    { 0xEE12385B, "nuked_fx" },
    { 0xC13D35CF, "nuked_fxanims" },
    { 0x98C43A45, "nuked_intermission" },
    { 0x6B1120E8, "nuked_mannequin_filter" },
    { 0x8AD13F8C, "nuked_mannequin_init" },
    { 0x1299850C, "nuked_perks" },
    { 0xFF541811, "nuked_player_fake_death" },
    { 0x6BB07EB0, "nuked_player_fake_death_cleanup" },
    { 0xEB480985, "nuked_population_sign_think" },
    { 0x674C39E7, "nuked_powerlevel_think" },
    { 0xFC19AFBD, "nuked_special_weapon_magicbox_check" },
    { 0x0BDFF631, "nuked_standard_intermission" },
    { 0x4C739E7D, "nuked_treasure_chest_init" },
    { 0x7B9C00F6, "nuked_update_player_zones" },
    { 0xE95F1660, "nuked_update_traversals" },
    { 0xB728EB44, "nuked_zone_init" },
    { 0xF54D7C76, "nukedetonated" },
    { 0xDF2DB0F6, "nukeincoming" },
    { 0xCADE8EC8, "nuker" },
    { 0xF0E10931, "nukes" },
    { 0xC6091134, "nukesun" },
    { 0xD58723F8, "nuketown_spawn_mannequin_fx" },
    { 0x723E3352, "nuketownmannequin" },
    { 0xD823A3AE, "nukevisionset" },
    { 0x4277BBA7, "nuking" },
    { 0x7F9D0866, "null" },
    { 0x76931E6B, "null_ai_face_anims_func" },
    { 0x106E8AEF, "nullcallback" },
    { 0x964EE55C, "nullprimaryoffhand" },
    { 0x45F49824, "nullsecondaryoffhand" },
    { 0x31C204F4, "nullzone" },
    { 0x00791757, "num" },
    { 0x8F759CFC, "num1" },
    { 0xAED63040, "num_active" },
    { 0x47FBEB07, "num_ads_uses" },
    { 0xB6788584, "num_ai_hit_by_trap" },
    { 0x8D635E04, "num_ai_passengers" },
    { 0xC45F134F, "num_ai_to_remove" },
    { 0x557DDBED, "num_alive" },
    { 0x0138C4EC, "num_alive_raps" },
    { 0xABE6BB44, "num_alive_wasps" },
    { 0xCFA3A09D, "num_anim" },
    { 0x70181BF2, "num_ape_zombies" },
    { 0xE9F3B86D, "num_array" },
    { 0xDA7BF547, "num_assigned_sprint_anim" },
    { 0x107AB7D7, "num_astro_zombies" },
    { 0xC45E8180, "num_attachments" },
    { 0x32A126D7, "num_attract_dists" },
    { 0xBFDAEEA1, "num_attractors" },
    { 0x30F1F02F, "num_attracts_per_dist" },
    { 0x12C24EB1, "num_axis" },
    { 0x939AA107, "num_banzai" },
    { 0x282903D7, "num_banzai_chargers" },
    { 0x1D249A72, "num_banzai_guys" },
    { 0x7565C7D2, "num_barriers_broken" },
    { 0x8B73E039, "num_battle_chatters" },
    { 0x9D4CE622, "num_beacon_attractors" },
    { 0x55CFB8BD, "num_beartrap_catches" },
    { 0xAA98D1BD, "num_beartrap_challenge_kills" },
    { 0xDD82DF4E, "num_big_jumps" },
    { 0x7A98F7A2, "num_bits" },
    { 0xDCA24065, "num_black_hole_bomb_attractors" },
    { 0x947D2805, "num_boards" },
    { 0x8CB8444F, "num_boats" },
    { 0x3E4228C6, "num_boosts" },
    { 0xC47C989D, "num_cam_shots" },
    { 0x03FC0F4B, "num_chinese" },
    { 0x8143244A, "num_chunks_checked" },
    { 0x297098B7, "num_civs" },
    { 0xF8A28DB1, "num_claimed" },
    { 0x2B39128D, "num_claymores" },
    { 0xBA5B6763, "num_clinging" },
    { 0xA59B1CE4, "num_clips_scavenged" },
    { 0xECA5173F, "num_closest" },
    { 0x7EA71451, "num_completed" },
    { 0x6D80217E, "num_con" },
    { 0xE3CA425E, "num_consts" },
    { 0xE4121C40, "num_convoy_members" },
    { 0xFE57F41A, "num_convoy_members_alive" },
    { 0x456FC679, "num_corpses" },
    { 0xC66954F2, "num_current_floor" },
    { 0x8EC7C4A9, "num_damage" },
    { 0x7276535A, "num_damage_states" },
    { 0xFFD8F29A, "num_director_zombies" },
    { 0x4F01EC6F, "num_displayed" },
    { 0x0ACCCAA7, "num_distance" },
    { 0xF759844F, "num_dog_targets" },
    { 0xB795297F, "num_dogs" },
    { 0x5355D147, "num_drone_areas" },
    { 0xF0BB3257, "num_drone_missile_kills" },
    { 0x3095E970, "num_drone_wave_count" },
    { 0x57A7FE97, "num_drone_waves" },
    { 0xC96B9118, "num_drops" },
    { 0xED2F53EE, "num_end_point" },
    { 0x0410616E, "num_enemies" },
    { 0xBA6D1157, "num_enemy_falls_off" },
    { 0x0671EB59, "num_ent" },
    { 0x6428F322, "num_entries" },
    { 0x2B87CD10, "num_ents" },
    { 0x7D23C775, "num_exits" },
    { 0x1241A16B, "num_exp" },
    { 0xE9916FE4, "num_extra" },
    { 0x0D2AE30F, "num_extra_spawns" },
    { 0x6195EE5C, "num_fallen" },
    { 0x38B143CB, "num_fights" },
    { 0xD3098286, "num_flame_groups" },
    { 0x4F0CEF56, "num_flaming_zombies" },
    { 0x347CF7DA, "num_flipped" },
    { 0xFF4FC681, "num_floor1" },
    { 0x338B25D4, "num_floor1_laststand" },
    { 0x255240EA, "num_floor2" },
    { 0x066A6B77, "num_floor2_laststand" },
    { 0x4B54BB53, "num_floor3" },
    { 0x00CA0726, "num_floor3_laststand" },
    { 0xB77E6675, "num_floor_laststand" },
    { 0xA16E9241, "num_follow_points" },
    { 0xF65D2FDC, "num_fort_positions" },
    { 0xFDF0CF86, "num_found" },
    { 0x03DA29B4, "num_frames" },
    { 0x9BEC6E9B, "num_frames_for_claw_sparks" },
    { 0xE1F29C4E, "num_frames_woods_behind" },
    { 0x1DE314E4, "num_frames_woods_leading" },
    { 0x159E3047, "num_grenades" },
    { 0xF504B63A, "num_grenades_acquired" },
    { 0x112362D8, "num_grenadesuicide" },
    { 0xB23C4A2A, "num_gunners" },
    { 0x250774CF, "num_guns" },
    { 0x07E86722, "num_guys" },
    { 0xD7D301C5, "num_guys_to_rappel" },
    { 0xB85B95D4, "num_hacked_locs" },
    { 0x306A0884, "num_hacks" },
    { 0xE0A32265, "num_halo_jumpers" },
    { 0xF59B6A89, "num_hatchet_kills" },
    { 0x623FFA82, "num_headshot_kills" },
    { 0xF7CFE7CF, "num_heli_runs" },
    { 0xF5D9B9FF, "num_helos" },
    { 0x87BF4149, "num_hero_catch_up_dist" },
    { 0xF21FEE9A, "num_history" },
    { 0x60A5FF25, "num_hit" },
    { 0xF782F734, "num_hits" },
    { 0x8D7D3D8B, "num_hits_to_kill" },
    { 0x83DB0F5C, "num_horses_per_rpg" },
    { 0x7D2508CB, "num_hudson_vo_helos" },
    { 0xF82DFDF9, "num_hudson_vo_tanks" },
    { 0x1DAC46EC, "num_idle_lines" },
    { 0xA4DD74EC, "num_in_bucket" },
    { 0xE6CBE94C, "num_in_elev" },
    { 0xF2E71509, "num_in_wave" },
    { 0x72CA83E4, "num_in_zone" },
    { 0x569C6944, "num_int_damage_states" },
    { 0x732B182A, "num_intel" },
    { 0xD7E41408, "num_its" },
    { 0x31048C6E, "num_keys" },
    { 0x96BC24B1, "num_killed" },
    { 0x00099FE7, "num_launch_multiplier" },
    { 0x78B6B249, "num_left" },
    { 0x5B44CFC6, "num_length" },
    { 0x294B95FC, "num_local_players" },
    { 0xE9C11897, "num_loops" },
    { 0x526E7996, "num_managers" },
    { 0xE3AC11BB, "num_max_seals" },
    { 0x771263FA, "num_mechz_spawned" },
    { 0x3A09F6D0, "num_melee_kills" },
    { 0x8274A852, "num_melee_loops" },
    { 0x5A5517C5, "num_missed" },
    { 0x882601FA, "num_misses" },
    { 0xCD0D0389, "num_missiles" },
    { 0xE03111AC, "num_missiles_fired" },
    { 0xBA2F8DAC, "num_model_swaps" },
    { 0x603D2C17, "num_monkey_attractors" },
    { 0x9617890F, "num_monkeys_to_kill" },
    { 0xEA656F50, "num_moves" },
    { 0xE7B4FCE6, "num_nag_squads" },
    { 0x3A61AE4F, "num_nags" },
    { 0xFF45F8B5, "num_needed" },
    { 0xF2FAA64E, "num_next_floor" },
    { 0x9C6D1A03, "num_nix" },
    { 0x5BC8EB7B, "num_nml_dog_targets" },
    { 0x82D4F919, "num_nodes" },
    { 0xF033BAE1, "num_octobomb_attractors" },
    { 0x41028055, "num_of_fades" },
    { 0x2EEF5AC7, "num_of_obj" },
    { 0x0704C76F, "num_of_seconds" },
    { 0x0C003643, "num_offset" },
    { 0x17C744B2, "num_on_floor" },
    { 0x4469B8C0, "num_outro_horses" },
    { 0x97BBB395, "num_overheats" },
    { 0x7A2E65F5, "num_passengers" },
    { 0x38F6675E, "num_paths" },
    { 0xEB1FF99C, "num_per_loop" },
    { 0x3CB84D41, "num_perks" },
    { 0x3228A25E, "num_phases" },
    { 0x0B8F9813, "num_pieces" },
    { 0xBEBE99B6, "num_pieces_to_destruct" },
    { 0xE072AA53, "num_pipe_fx" },
    { 0x99FF9BB3, "num_planes" },
    { 0x8E4D0726, "num_planes_shot" },
    { 0x10C6A35E, "num_planted" },
    { 0xF0FAEC36, "num_plates_active" },
    { 0x5869D5C7, "num_plates_needed" },
    { 0x286FEA20, "num_player_drone_soct_kills" },
    { 0xE55C16CB, "num_player_soct_soct_kills" },
    { 0x23D4FC06, "num_player_valid" },
    { 0xE5315A4C, "num_players" },
    { 0x15A6C4A3, "num_players_inside" },
    { 0xFCB42941, "num_players_touching_volume" },
    { 0x742707F2, "num_players_trophy_health_modifier" },
    { 0x72D4030F, "num_poi_attracts" },
    { 0xA40926F3, "num_points" },
    { 0xED973DD4, "num_police" },
    { 0xBDDDC9C7, "num_pools" },
    { 0x9DF4AC62, "num_positions" },
    { 0x2772D916, "num_positios" },
    { 0x68F8B13B, "num_presses" },
    { 0xA18A9043, "num_pulls_since_brutus_spawn" },
    { 0x15FE134E, "num_regular_guys_to_kill" },
    { 0x9BC56167, "num_reload_calls" },
    { 0x57800922, "num_reps" },
    { 0x20358798, "num_river_boats" },
    { 0xC74BF2E5, "num_rockets" },
    { 0x1CD01EEE, "num_rockets_per_ship" },
    { 0x3E28AEFB, "num_roll" },
    { 0x59F8619A, "num_rolls" },
    { 0x55B8B905, "num_rounds" },
    { 0xDF5D5C2A, "num_sacrifices_received" },
    { 0xD814F282, "num_scene" },
    { 0x8FC17E22, "num_seagulls" },
    { 0x213383B0, "num_seals" },
    { 0x2E705B84, "num_seals_saved" },
    { 0xC4081679, "num_seconds" },
    { 0x03F7A1C5, "num_shots" },
    { 0x3E3C402F, "num_sliquifier_kills" },
    { 0x598CF4CE, "num_sm1_spawns" },
    { 0xA2C2484F, "num_sm2_spawns" },
    { 0x79EFE155, "num_smoke_grenades" },
    { 0xAA5AF848, "num_smoke_grenades_at_last_comment" },
    { 0x5A6714AA, "num_sniper_misses" },
    { 0xBEBE62CB, "num_snipertree_challenge_kills" },
    { 0x13513BF1, "num_snipertree_kills" },
    { 0x5AE7D2A5, "num_solved" },
    { 0x0A72CAFD, "num_spawners" },
    { 0x5A9A16FD, "num_spots" },
    { 0xC3EB9BC8, "num_squad_in_position" },
    { 0xDC36194B, "num_squads" },
    { 0xA133A800, "num_staffpieces_picked_up" },
    { 0x5940EEBB, "num_stages" },
    { 0xCD3771B5, "num_standard" },
    { 0xCCFDA2A9, "num_start_point" },
    { 0x79816BAC, "num_step" },
    { 0x853AE2AF, "num_steps" },
    { 0x918923F4, "num_strings" },
    { 0x0A300B16, "num_subwoofer_deaths" },
    { 0xEBA90F39, "num_sweeps" },
    { 0x77B66025, "num_tanks" },
    { 0x6802472C, "num_teams" },
    { 0xEBAE526E, "num_territories_claimed" },
    { 0x01EC4439, "num_that_lives" },
    { 0x97EE38BA, "num_thief_zombies" },
    { 0x71263625, "num_tiers" },
    { 0x14693D0D, "num_til_moved" },
    { 0x2E9C3F36, "num_tile" },
    { 0x353DC20F, "num_time_used" },
    { 0xE15857CD, "num_times_locked" },
    { 0x0AA7624B, "num_times_to_scale" },
    { 0xEAA88D05, "num_to_add" },
    { 0x98E1D684, "num_to_kill" },
    { 0x1940FDAC, "num_to_letter" },
    { 0x67F63389, "num_to_spawn" },
    { 0x9B8B52B0, "num_tokens" },
    { 0x39ECCD68, "num_total_rounds" },
    { 0x531D8673, "num_treesniper" },
    { 0x9D0A41B5, "num_tries" },
    { 0x66F2B40C, "num_turned" },
    { 0x2440B095, "num_turret_states" },
    { 0x8EFD8CC8, "num_valid" },
    { 0x6C8138F4, "num_variants" },
    { 0x4778E6F1, "num_vehicles" },
    { 0x2BAF6D9A, "num_vo_callout" },
    { 0xAED6A38B, "num_vo_lines_played" },
    { 0x84BFEA90, "num_volleys" },
    { 0x4532CC6C, "num_vtols" },
    { 0x740BC788, "num_waits" },
    { 0x14DC6D61, "num_warnings" },
    { 0x6F3E006D, "num_wave" },
    { 0x787DAE6C, "num_waves" },
    { 0x520512B7, "num_waves_spawned" },
    { 0xA668C670, "num_wires" },
    { 0x803CEEC0, "num_worker_scenes" },
    { 0x85F998FA, "num_zombie_hit" },
    { 0x677B0487, "num_zombies" },
    { 0x78FC3CB0, "num_zombies_flung" },
    { 0x0C8E8BB9, "num_zombs" },
    { 0x37967545, "numactive" },
    { 0xD365BDC2, "numactivecontracts" },
    { 0xB3CD5995, "numai" },
    { 0x2F46C4BA, "numaliveplayersnear" },
    { 0x7C9D94DF, "numaliveplayersridingbus" },
    { 0xC4798295, "numallies" },
    { 0xCB109731, "numallowed" },
    { 0x14EF4964, "numambushrounds" },
    { 0xABB85EF8, "numamericanvoices" },
    { 0x6B8EB6F3, "numanims" },
    { 0xA296AFF6, "numarabvoices" },
    { 0x7361CA77, "numattached" },
    { 0xAF719A4B, "numattachments" },
    { 0x3A334610, "numattachtable" },
    { 0xB8DC407D, "numattackers" },
    { 0x6E6D434D, "numattempts" },
    { 0xA8007514, "numaxis" },
    { 0x8A211E10, "numbad" },
    { 0xD3FA0A6A, "number" },
    { 0xC5B08BB8, "number_before_decimal" },
    { 0x5B9E73D8, "number_cycles" },
    { 0x0E9E7AC8, "number_for_this_circle" },
    { 0x054FD5AA, "number_lines" },
    { 0x4EC3407E, "number_looper" },
    { 0x0E016032, "number_miss_structs" },
    { 0x7F566780, "number_nodes" },
    { 0x62E294A0, "number_of_bombs" },
    { 0x60BAC261, "number_of_bombs_counter" },
    { 0x0CE9F0B0, "number_of_circles" },
    { 0x6433B012, "number_of_lines" },
    { 0x8D9E33BB, "number_of_men_rescued" },
    { 0xE2DBD7F0, "number_of_planes" },
    { 0xC89F4FAC, "number_of_ptboats_sunk" },
    { 0x86183C30, "number_of_ships_sunk" },
    { 0x24B115A0, "number_of_slices" },
    { 0x07DF2246, "number_of_sweeps" },
    { 0xCA172083, "number_of_times_used" },
    { 0x0FCD0536, "number_of_vortices" },
    { 0x53C2E4CF, "number_of_zeroes_destroyed" },
    { 0xED8A282C, "number_revives_per_round" },
    { 0x9ECBC9AC, "number_sound_ent" },
    { 0x298430A5, "number_station_wait" },
    { 0x33F11DD2, "number_to_add" },
    { 0xC0440659, "number_to_kill" },
    { 0x168AA63A, "numberbotsadded" },
    { 0xE472E9FD, "numbered" },
    { 0x08E11166, "numberfired" },
    { 0xE604CF46, "numbering" },
    { 0x4DE57EBB, "numberminigun" },
    { 0x4D3C08DE, "numberofdoublejumpsinlife" },
    { 0x0E9CEF8D, "numberoffootnotetracks" },
    { 0x17F3B781, "numberofguys" },
    { 0x9CA22942, "numberofimportantpeopletalking" },
    { 0x5086BD7C, "numberofshots" },
    { 0x161CBA50, "numberofslidesinlife" },
    { 0x14D3FABD, "numberrockets" },
    { 0x1712DE25, "numbers" },
    { 0xA23C987F, "numbers_array" },
    { 0x6A371218, "numbers_hit_players_face" },
    { 0x9086766B, "numbers_stopped_early" },
    { 0xF94EB3B0, "numbers_vision" },
    { 0x9CF3DA03, "numbits" },
    { 0x0439A060, "numbombevents" },
    { 0x806CB804, "numbones" },
    { 0x10C938CC, "numboss" },
    { 0x4920DD40, "numbosses" },
    { 0xDD42C809, "numbritishvoices" },
    { 0x332DD79A, "numbursts" },
    { 0xDAF77E74, "numbusstopssincelastambushround" },
    { 0xC9DE64A0, "numcaps" },
    { 0x2EF03765, "numchallengetiers" },
    { 0x202BCFBE, "numchallengetiersmp" },
    { 0xD158D12C, "numchecks" },
    { 0x7CFD4C5F, "numchickens" },
    { 0xBBF25ACB, "numchoppers" },
    { 0xF016AB05, "numchopperstospawn" },
    { 0x4951E03B, "numclaimants" },
    { 0xE53D853D, "numclasses" },
    { 0x59073F8D, "numclients" },
    { 0xC6D61D9C, "numcolumns" },
    { 0xDF68935E, "numcommanders" },
    { 0xE97B4818, "numcontracts" },
    { 0x4F4DCDCA, "numcoughs" },
    { 0x316D3313, "numcrawls" },
    { 0x032D2281, "numcut" },
    { 0x74BF3E2A, "numcycles" },
    { 0x3929E437, "numdata" },
    { 0xCE7BD79D, "numdead" },
    { 0x7ABC6EE8, "numdeathloops" },
    { 0xE2BF07D6, "numdeaths" },
    { 0x88F94ADD, "numdeathsuntilcornergrenadedeath" },
    { 0x379EDA8D, "numdeathsuntilcrawlingpain" },
    { 0x2D1A8306, "numdelete" },
    { 0x18656105, "numdigits" },
    { 0xEAA87392, "numdogs" },
    { 0x75187A66, "numdogsatlastupdate" },
    { 0xFD487D1B, "numdone" },
    { 0xDFD0E07E, "numdynents" },
    { 0x20AA8E29, "numenemies" },
    { 0x349AECBD, "numerical" },
    { 0xD094E0C0, "numerically" },
    { 0xEDE228B9, "numerous" },
    { 0xDBED6161, "numescrows" },
    { 0x158B5A10, "numexclusions" },
    { 0x453FADCE, "numexecutions" },
    { 0x8D781CFC, "numflags" },
    { 0x92C0770C, "numflares" },
    { 0x0073A76F, "numflattires" },
    { 0x266EB8EE, "numfloggervox" },
    { 0x7541ABC5, "numframes" },
    { 0x551E1161, "numframespertrace" },
    { 0x32FB4E7B, "numframesstationary" },
    { 0x5AA53BD6, "numfriends" },
    { 0x6F5B1F91, "numfx" },
    { 0xC863ABE2, "numgamerules" },
    { 0x3D447A81, "numgametypereservedobjectives" },
    { 0xCBAC24A2, "numgear" },
    { 0x756668A8, "numglobs" },
    { 0xE6C5EA20, "numgood" },
    { 0xFEC53CFD, "numgrenadesinprogresstowardsplayer" },
    { 0x5453392A, "numguncycles" },
    { 0xC2CEEC83, "numguys" },
    { 0x0870623A, "numhardpointreservedobjectives" },
    { 0x7C9111D1, "numhelo" },
    { 0x7A06DAC3, "numids" },
    { 0xED2A66BB, "numinfluences" },
    { 0x0C8DC9DB, "numintervals" },
    { 0xEA52C50D, "numiter" },
    { 0x5ACDD08C, "numiters" },
    { 0x4919B9EF, "numkeys" },
    { 0xC54D0E03, "numkillcams" },
    { 0xA560A2EA, "numkilldistanceentries" },
    { 0x0B324DE2, "numkills" },
    { 0x0A667839, "numkillstreakreservedobjectives" },
    { 0x7799B88C, "numkillstreaks" },
    { 0xDA9642BF, "numkillstreaktimers" },
    { 0x960264AD, "numlaunched" },
    { 0x134BE458, "numleft" },
    { 0xBABAC6B6, "numlevels" },
    { 0x1858CBC4, "numlights" },
    { 0x6F64D20C, "numlines" },
    { 0xE782FB64, "numlives" },
    { 0x66E8687B, "numlivesdvar" },
    { 0x7E624F72, "numliveslivesleft" },
    { 0xCA794D1E, "numlivesmax" },
    { 0x5D016EC0, "numlivesmin" },
    { 0x7D11BE26, "numlocalplayers" },
    { 0xA5E5A910, "numloops" },
    { 0x8E8C012D, "nummeleestage" },
    { 0xB01BB582, "nummetrogateextras" },
    { 0xC460E823, "numobjectivesadded" },
    { 0x7D25F928, "numobjectivesdisplayed" },
    { 0x226828A5, "numofcarts" },
    { 0xE4CA448A, "numofspikeassigned" },
    { 0xF1882F55, "numok" },
    { 0x708CEB07, "numoptions" },
    { 0x31BE3AB7, "numother" },
    { 0x77D298B5, "numotherclaim" },
    { 0xD6823597, "numotherdata" },
    { 0xCB5141EE, "numothers" },
    { 0x1E0DF196, "numoutsteps" },
    { 0x5D950BC3, "numownedflags" },
    { 0x0C9A7297, "numowners" },
    { 0x62F39186, "numpad" },
    { 0x968C2431, "numparams" },
    { 0xF4CB4176, "numperks" },
    { 0x64DA676E, "numpieces" },
    { 0x87BED64A, "numpilots" },
    { 0xFA9EC3B3, "numplayers" },
    { 0xA5F53B97, "numplayersatlastupdate" },
    { 0xA1A73C5F, "numplayersinsidebus" },
    { 0xA472F081, "numplayersnear" },
    { 0x85DA7A04, "numplayerson" },
    { 0xE4B1EBF6, "numplayersonroof" },
    { 0x54CAC8A8, "numplayerswaitingtoenterkillcam" },
    { 0x8235B45A, "numpoints" },
    { 0x9AE125C1, "numpoiswithcapturetime" },
    { 0x09D98CFF, "numpoor" },
    { 0xA8D01AE7, "numraised" },
    { 0xD64A1D93, "numreached" },
    { 0x9C24F16C, "numreaches" },
    { 0x022B548F, "numrecords" },
    { 0x74BFA911, "numremaining" },
    { 0x56C1D507, "numremoteclients" },
    { 0xAEF9B849, "numrepeats" },
    { 0x7E9A2D5B, "numrequirements" },
    { 0x87E0A07E, "numrockets" },
    { 0x985CEC26, "numroundssincelastambushround" },
    { 0xD5C75D9B, "numrussianvoices" },
    { 0x5C192C0E, "nums" },
    { 0xDF84A3C0, "numsafe" },
    { 0x784091EF, "numsecondaries" },
    { 0x743BACA6, "numseconds" },
    { 0x34FE0735, "numsent" },
    { 0x68849B5E, "numshots" },
    { 0x8E8658CD, "numsightchecks" },
    { 0x97BF429A, "numslots" },
    { 0x3672102D, "numspawnpoints" },
    { 0x44B4DF0B, "numspawns" },
    { 0x7E5B4141, "numspeakers" },
    { 0x79296152, "numspecialai" },
    { 0x1B6C203D, "numspecialties" },
    { 0xB6C19F2F, "numspeedswhenmovingentries" },
    { 0xBE064EED, "numstatsmilestonetiers" },
    { 0xF1596664, "numsteps" },
    { 0x6A761CED, "numstrafes" },
    { 0x36CB528B, "numsubstrings" },
    { 0x76BB5878, "numtags" },
    { 0x9A358019, "numtakensteps" },
    { 0xD450CE86, "numtankdrones" },
    { 0x7141903B, "numtargets" },
    { 0xFC8F4C75, "numteamlives" },
    { 0xB372F90D, "numteamlivesmax" },
    { 0x3087B703, "numteamlivesmin" },
    { 0x9F5383FF, "numthere" },
    { 0x629351F1, "numtimers" },
    { 0xEF540020, "numtobalance" },
    { 0x5AE33D5D, "numtoskippast" },
    { 0xD680A049, "numtospawn" },
    { 0x76294D4F, "numtotal" },
    { 0x2637536C, "numtotalsteps" },
    { 0x0F6BADA3, "numtouched" },
    { 0xD5FD8708, "numtouching" },
    { 0x98A37E7D, "numtraces" },
    { 0xA473348F, "numtracks" },
    { 0x0DD56F0A, "numtransportsinboundforteam" },
    { 0xC768B170, "numtraverses" },
    { 0xE379F3BA, "numtries" },
    { 0x77FAA278, "numtriggers" },
    { 0x1409CF50, "numturnsthisframe" },
    { 0x3D9B0B8C, "numturrets" },
    { 0x20271C1C, "numunits" },
    { 0xA975C5CB, "numvalid" },
    { 0x2FC08616, "numvalue" },
    { 0xC3B5DF07, "numvolleys" },
    { 0xBABCCCCC, "numvtol" },
    { 0xBBD35656, "numwagerwins" },
    { 0x2F3906E7, "numwaves" },
    { 0x1CBAD0DA, "numwavespassedearliestspawntime" },
    { 0x1572AB08, "numweaponidkeys" },
    { 0xEF735E0A, "numwithgrenades" },
    { 0xCC6D2465, "numzombsmeleethisframe" },
    { 0x96410383, "nunchucks_endgame_1" },
    { 0x24399448, "nunchucks_endgame_2" },
    { 0x4A3C0EB1, "nunchucks_endgame_3" },
    { 0x41C08321, "nunchucks_endgame_array" },
    { 0x00211AFA, "nunchucks_lobby" },
    { 0x8FD1FFEC, "nurse" },
    { 0x728161A2, "nurse_model" },
    { 0x75C90605, "nurse_trigger" },
    { 0x4A3B2316, "nut" },
    { 0xD1E94E86, "nutjobs" },
    { 0xAA9ECD89, "nuts" },
    { 0xC400164C, "nutshell" },
    { 0x9C85E12D, "nv" },
    { 0x2E0E4C8E, "nva" },
    { 0xB516BF44, "nva_actor" },
    { 0x1CA9EBE5, "nva_actor1" },
    { 0x42AC664E, "nva_actor2" },
    { 0xE94D7AF7, "nva_actors" },
    { 0x5EEC3249, "nva_ambush" },
    { 0xCFED0237, "nva_attackers" },
    { 0x98BA08F8, "nva_boom" },
    { 0xF675AAEB, "nva_cleanup" },
    { 0x6883F0E7, "nva_diver" },
    { 0x16D22AF7, "nva_go_to_target" },
    { 0x176CAA11, "nva_guys" },
    { 0x6603D478, "nva_jump_down" },
    { 0x29E69410, "nva_loudspeaker" },
    { 0x17214572, "nva_med_boat" },
    { 0xC58F1170, "nva_med_boat_basic_fire" },
    { 0xDF6C5EF6, "nva_med_boat_shoot_in_range" },
    { 0xB7710F03, "nva_med_boat_spawnfuncs" },
    { 0x25311C60, "nva_patrol_approaches_shore" },
    { 0x0D28B692, "nva_patrol_gunners" },
    { 0x5021D7C7, "nva_pbr_target_player" },
    { 0x0B305A7D, "nva_qte_timescale" },
    { 0x1AC85A8E, "nva_spawners" },
    { 0xC3BA9486, "nva_target" },
    { 0xD7F68870, "nvas_jeep" },
    { 0xAD348915, "nvec" },
    { 0x0B194692, "nvel" },
    { 0x49FF6E18, "nvg" },
    { 0xA8374CF3, "nvgs" },
    { 0x19EB9AD0, "nvo" },
    { 0x768366C4, "nw" },
    { 0xED20DF71, "nwaittime" },
    { 0x5A92453A, "ny" },
    { 0x49C8FD6D, "ny_streets_activate" },
    { 0x2E3961A5, "ny_streets_main" },
    { 0xC8834711, "ny_streets_setup" },
    { 0xE92E6745, "nyc" },
    { 0x051F88CF, "nyi" },
    { 0xE5491840, "o" },
    { 0x035D6EBC, "o_af_01_01_gunbox" },
    { 0x445CC8E3, "o_af_01_01_photo" },
    { 0x80222715, "o_af_01_03_pulwar_crowbar" },
    { 0xEC44DAA4, "o_af_01_03_pulwar_pulwar" },
    { 0x9B8DA058, "o_af_01_05_gunbox" },
    { 0x41B40D96, "o_af_02_01_cooking_muj_pipe" },
    { 0xFFB4D957, "o_af_02_01_gun_stackers_ak1_carry" },
    { 0x5286A7FA, "o_af_02_01_gun_stackers_ak1_endidl" },
    { 0xAEC5A674, "o_af_02_01_gun_stackers_ak2_carry" },
    { 0x414960D7, "o_af_02_01_gun_stackers_ak2_endidl" },
    { 0xEA32AA6D, "o_af_02_01_gun_stackers_ak3" },
    { 0xF0F15C42, "o_af_02_01_smoker_hookah" },
    { 0x62CEEF7A, "o_af_02_01_stingers_crate_endidl" },
    { 0x021FBB21, "o_af_02_01_stingers_crate_move" },
    { 0x3B28D86B, "o_af_04_06_reunion_mortar_run2tank" },
    { 0xE223D90A, "o_af_04_06_reunion_mortar_tankfight" },
    { 0xA88F91F9, "o_af_05_02_interrog_all_tests_succeed_pistol" },
    { 0xB58BC97A, "o_af_05_02_interrog_first_intel_chair" },
    { 0x49D2C977, "o_af_05_02_interrog_first_intel_woods_karambit" },
    { 0x1E46EFD9, "o_af_05_02_interrog_first_intel_wristrope_l" },
    { 0xD241FB07, "o_af_05_02_interrog_first_intel_wristrope_r" },
    { 0xB7E4805E, "o_af_05_02_interrog_second_intel_chair" },
    { 0xAF7B6BAB, "o_af_05_02_interrog_second_intel_woods_karambit" },
    { 0x7331694D, "o_af_05_02_interrog_second_intel_wristrope_l" },
    { 0xB767EE53, "o_af_05_02_interrog_second_intel_wristrope_r" },
    { 0xD5478C3D, "o_af_05_02_interrog_start_chair" },
    { 0xE6A9A647, "o_af_05_02_interrog_start_pistol" },
    { 0x30F6135A, "o_af_05_02_interrog_start_woods_karambit" },
    { 0x38F0DBDE, "o_af_05_02_interrog_start_wristrope_l" },
    { 0x84F5D0B0, "o_af_05_02_interrog_start_wristrope_r" },
    { 0xD2FFDE6D, "o_af_05_02_interrog_succeed_chair" },
    { 0x3897F82A, "o_af_05_02_interrog_succeed_woods_karambit" },
    { 0xE76D9AE6, "o_af_05_02_interrog_succeed_woods_pistol" },
    { 0x68DA7B4E, "o_af_05_02_interrog_succeed_wristrope_l" },
    { 0xF4902300, "o_af_05_02_interrog_succeed_wristrope_r" },
    { 0x1ED263A7, "o_af_05_02_interrog_test1_fail_chair" },
    { 0x3CF6D208, "o_af_05_02_interrog_test1_fail_woods_karambit" },
    { 0x71B4F9D0, "o_af_05_02_interrog_test1_fail_wristrope_l" },
    { 0x25B004FE, "o_af_05_02_interrog_test1_fail_wristrope_r" },
    { 0x1F419334, "o_af_05_02_interrog_test1_pistol" },
    { 0x4DDE7EED, "o_af_05_02_interrog_test1_pistol_succeed" },
    { 0xA23DAD06, "o_af_05_02_interrog_test2_fail_chair" },
    { 0x921B1AF5, "o_af_05_02_interrog_test2_fail_wristrope_l" },
    { 0x7629F96B, "o_af_05_02_interrog_test2_fail_wristrope_r" },
    { 0x03E65561, "o_af_05_02_interrog_test2_pistol" },
    { 0x15BD6B00, "o_af_05_02_interrog_test2_pistol_succeed" },
    { 0xBAE4C5A5, "o_af_05_02_interrog_test3_fail_chair" },
    { 0x14D7D5A6, "o_af_05_02_interrog_test3_fail_wristrope_l" },
    { 0x00B523E8, "o_af_05_02_interrog_test3_fail_wristrope_r" },
    { 0x12B77B12, "o_af_05_02_interrog_test3_pistol" },
    { 0xC07B8A9B, "o_af_05_02_interrog_test3_pistol_succeed" },
    { 0x73CE31BF, "o_af_05_02_interrog_third_intel_chair" },
    { 0x984C90D0, "o_af_05_02_interrog_third_intel_woods_karambit" },
    { 0x46F163C8, "o_af_05_02_interrog_third_intel_wristrope_l" },
    { 0x5B141586, "o_af_05_02_interrog_third_intel_wristrope_r" },
    { 0x4853C2C7, "o_af_05_02_interrog_threat_chair" },
    { 0xB0088BE5, "o_af_05_02_interrog_threat_pistol" },
    { 0x3BBAE7E8, "o_af_05_02_interrog_threat_woods_karambit" },
    { 0xCB107A30, "o_af_05_02_interrog_threat_wristrope_l" },
    { 0x7F0B855E, "o_af_05_02_interrog_threat_wristrope_r" },
    { 0x8D5BA460, "o_af_05_04_betrayal_chair" },
    { 0x1BE027B7, "o_af_05_04_betrayal_rope_player" },
    { 0xE318F98E, "o_af_05_04_betrayal_rope_woods" },
    { 0xB2AE68D1, "o_af_05_04_betrayal_woods_karambit" },
    { 0xF982EA86, "o_afghan_cratercharge_plant" },
    { 0x021F6AB6, "o_afghan_cratercharge_plant_from_stairs" },
    { 0x5E4344D1, "o_ai_rappel_rope02" },
    { 0x98EF5A33, "o_ang_01_01_intro_black_card" },
    { 0x77A3D6B0, "o_ang_01_01_intro_shovel" },
    { 0x1000865A, "o_ang_01_05_riverbed_vignettes_a_crates" },
    { 0xF8230DC9, "o_ang_06_01_crate_push_box" },
    { 0x19E55AF1, "o_ang_06_04_hind_aftermath_barrel" },
    { 0xDCED32F1, "o_ang_08_01_radio_room_encounter_door" },
    { 0x4CF932B5, "o_ang_08_01_radio_room_escape_grenade" },
    { 0x7F4D83E1, "o_ang_08_01_radio_room_part1_pistol" },
    { 0x69EE81B9, "o_ang_08_01_radio_room_part2_door" },
    { 0x99626EC9, "o_ang_08_01_radio_room_part2_grenade" },
    { 0x9AA8C1B4, "o_ang_08_01_radio_room_part2_pistol" },
    { 0x98C8D1ED, "o_av7_mv_chair_intro_part1" },
    { 0xBECB4C56, "o_av7_mv_chair_intro_part2" },
    { 0x539C9800, "o_av7_mv_christ_bassguitar_part1" },
    { 0xC5A4073B, "o_av7_mv_christ_bassguitar_part2" },
    { 0x9FA18CD2, "o_av7_mv_christ_bassguitar_part3" },
    { 0x11A8FC0D, "o_av7_mv_christ_bassguitar_part4" },
    { 0xEBA681A4, "o_av7_mv_christ_bassguitar_part5" },
    { 0x5DADF0DF, "o_av7_mv_christ_bassguitar_part6" },
    { 0x081E5AF9, "o_av7_mv_drumkit_part1" },
    { 0x2E20D562, "o_av7_mv_drumkit_part2" },
    { 0x54234FCB, "o_av7_mv_drumkit_part3" },
    { 0x7A25CA34, "o_av7_mv_drumkit_part4" },
    { 0xA028449D, "o_av7_mv_drumkit_part5" },
    { 0xC62ABF06, "o_av7_mv_drumkit_part6" },
    { 0xBB49E100, "o_av7_mv_gates_guitar_part1" },
    { 0x2D51503B, "o_av7_mv_gates_guitar_part2" },
    { 0x074ED5D2, "o_av7_mv_gates_guitar_part3" },
    { 0x7956450D, "o_av7_mv_gates_guitar_part4" },
    { 0x5353CAA4, "o_av7_mv_gates_guitar_part5" },
    { 0xC55B39DF, "o_av7_mv_gates_guitar_part6" },
    { 0xB78FF5D6, "o_av7_mv_menendez_guitar_part1" },
    { 0x918D7B6D, "o_av7_mv_menendez_guitar_part2" },
    { 0x6B8B0104, "o_av7_mv_menendez_guitar_part3" },
    { 0x4588869B, "o_av7_mv_menendez_guitar_part4" },
    { 0x1F860C32, "o_av7_mv_menendez_guitar_part5" },
    { 0xF98391C9, "o_av7_mv_menendez_guitar_part6" },
    { 0xE1677F71, "o_av7_mv_vengence_guitar_part1" },
    { 0x0769F9DA, "o_av7_mv_vengence_guitar_part2" },
    { 0x2D6C7443, "o_av7_mv_vengence_guitar_part3" },
    { 0x536EEEAC, "o_av7_mv_vengence_guitar_part4" },
    { 0x79716915, "o_av7_mv_vengence_guitar_part5" },
    { 0x9F73E37E, "o_av7_mv_vengence_guitar_part6" },
    { 0x605A21E7, "o_blocker" },
    { 0xE3530697, "o_bundle" },
    { 0x0E2FC28F, "o_command_01_01_observation_cctv_handcuffs" },
    { 0x4F469059, "o_command_01_02_returntointerrogation_door" },
    { 0xBC11DF81, "o_command_01_02_theprestige_door" },
    { 0x1F998F51, "o_command_01_03_returntointerrogation_chair" },
    { 0x28999B50, "o_command_01_03_returntointerrogation_handcuffs" },
    { 0x26963058, "o_command_01_03_returntointerrogation_handcuffs_wait" },
    { 0x67F9072E, "o_command_01_03_theprestige_table" },
    { 0x0BA86E75, "o_command_01_05_monolouge_end_handcuffs" },
    { 0x6C6C97AF, "o_command_01_05_monolouge_handcuffs" },
    { 0x4E0952F0, "o_command_01_05_theprestige_gun_fiveseven" },
    { 0x3B7CABA2, "o_command_01_05_theprestige_handcuffs" },
    { 0x8B31AD9C, "o_command_01_05_theprestige_table" },
    { 0x0B85853B, "o_command_02_01_wake_up_pressuredoor_closed" },
    { 0x2F4D1EBB, "o_command_02_01_wake_up_pressuredoor_dooropen" },
    { 0xFCD421A0, "o_command_02_04_up_the_staircase" },
    { 0x8201E13E, "o_command_02_07_salazar_exit_door" },
    { 0xBDA1D11C, "o_command_03_01_sexy_woman_door" },
    { 0xE791E922, "o_command_03_06_door_break_door_01_bashopen" },
    { 0x9FC3BC77, "o_command_03_06_door_break_door_02_bashopen" },
    { 0xA89479A3, "o_command_03_08_cctv_access_chair" },
    { 0xA60FD5B8, "o_command_03_08_cctv_menendez_door" },
    { 0x3D7DC3E9, "o_command_03_08_torch_vent_idle" },
    { 0x35D3C7EB, "o_command_03_08_torch_vent_open" },
    { 0x601C0F24, "o_command_03_08_vent_kick_vent" },
    { 0xB43E8E04, "o_command_04_01_salazar_pip_chair" },
    { 0x6522CE43, "o_command_04_02_grab_briggs_gun" },
    { 0xFE104E07, "o_command_04_02_grabbed_briggs_chair" },
    { 0x6A140C71, "o_command_04_06_kneecap_fight_gun_loop" },
    { 0xE47E1CD7, "o_command_04_06_kneecap_letgo_gun" },
    { 0xBD4312CF, "o_command_04_07_eyeball_broken_eyeball" },
    { 0x613BEE03, "o_command_04_07_eyeball_chip" },
    { 0x959A220B, "o_command_04_07_eyeball_eyeball" },
    { 0x99886741, "o_command_04_07_eyeball_rewind_eyeball" },
    { 0xD7DC9C7F, "o_command_06_03_aftermath_chair_karma_sit_loop" },
    { 0x6CB605DD, "o_command_06_04_cctv_cutter" },
    { 0x3B4111C0, "o_command_06_04_cctv_cutter_exit" },
    { 0x706CA7FB, "o_command_06_04_cctv_door_enter" },
    { 0x8B1296DB, "o_command_06_04_cctv_door_exit" },
    { 0xC44C6635, "o_command_06_04_cctv_door_loop" },
    { 0x5086366B, "o_command_06_04_cctv_torch2_enter" },
    { 0xFD9ACCAB, "o_command_06_04_cctv_torch2_exit" },
    { 0x742D8225, "o_command_06_04_cctv_torch2_loop" },
    { 0xE4D4B3A9, "o_command_06_04_cctv_vent" },
    { 0x4F72CE1C, "o_command_06_04_cctv_vent_exit" },
    { 0xE66EBE3A, "o_command_06_06_betrayal_pistol_shot" },
    { 0xB0995371, "o_contextual_melee_pakistan_neckstab_knife" },
    { 0xD7BFA6DB, "o_dichotomy" },
    { 0xDD46EBAD, "o_door_open_masons_room_door" },
    { 0xA0E7B4F0, "o_drone_tank_missile_fire_sp" },
    { 0x90665D53, "o_exclude" },
    { 0xDAA1CDB4, "o_fake_target" },
    { 0x71655D3D, "o_flash_ev06_stilltime_door1" },
    { 0x4B32D6FC, "o_flash_ev06_stilltime_door1_close" },
    { 0x26D548C8, "o_flash_ev06_stilltime_door1_open" },
    { 0x9767D7A6, "o_flash_ev06_stilltime_door2" },
    { 0xF5D0B779, "o_full_interstitial_01_camera" },
    { 0x167E3004, "o_full_interstitial_02_camera" },
    { 0x2CF41CA3, "o_full_interstitial_03_camera" },
    { 0x9628EA46, "o_full_interstitial_04_camera" },
    { 0x2050DFE8, "o_groan_location" },
    { 0xB1B09063, "o_guys" },
    { 0x1D898323, "o_ht_01_01_intro_harper_helmet" },
    { 0xA43D98BC, "o_ht_04_02_boobytrap_soldier02_02_chair" },
    { 0x820D85D2, "o_ht_04_02_boobytrap_soldier03_chair" },
    { 0x9368C155, "o_ht_04_02_stop_transmission_computerguy_chair_cycle" },
    { 0x05EF1E61, "o_ht_04_02_stop_transmission_computerguy_chair_death" },
    { 0x1FB22141, "o_ht_04_02_stop_transmission_computerguy_chair_transitiontoai" },
    { 0x6181FD50, "o_ht_06_02_end03_inside_rebar" },
    { 0x102DA75E, "o_ht_06_02_end05_inside_rebar" },
    { 0xDA9F7A0D, "o_ht_06_03_end04_outside_part_1_player_gun" },
    { 0xF897B89D, "o_ht_06_03_end04_outside_part_2_bandana" },
    { 0x7A04499C, "o_ht_06_03_end04_outside_part_2_player_gun" },
    { 0x80C8D3B2, "o_karma_1_1_final_approach_briefcase" },
    { 0x4A17FAF4, "o_karma_1_1_final_approach_harper" },
    { 0xC8679728, "o_karma_1_1_final_approach_landing_harper" },
    { 0x8140834A, "o_karma_1_1_final_approach_landing_salazar" },
    { 0x6555A2FE, "o_karma_1_1_final_approach_salazar" },
    { 0xC1773A9B, "o_karma_2_1_blockers_enter_toolbox" },
    { 0xA26EB76A, "o_karma_2_1_blockers_picking_up_items_hammer" },
    { 0xEC8D66A5, "o_karma_2_1_blockers_picking_up_items_toolbox" },
    { 0xCADBB55B, "o_karma_2_1_blockers_picking_up_items_wrench" },
    { 0xD2827CAE, "o_karma_2_1_idle_scanner_01" },
    { 0x607B0D73, "o_karma_2_1_idle_scanner_04" },
    { 0xD84903CD, "o_karma_2_1_intr_squad_01" },
    { 0x1A3C9FC0, "o_karma_2_1_intr_squad_04" },
    { 0x3DA0A1D0, "o_karma_2_1_intr_squad_pt2_01" },
    { 0xFBAD05DD, "o_karma_2_1_intr_squad_pt2_04" },
    { 0x71C35470, "o_karma_2_1_intr_walkin_sunglasses" },
    { 0x6D2A33F0, "o_karma_2_1_tarmac_worker_forklift" },
    { 0x59947151, "o_karma_2_1_tarmac_worker_forklift_idle" },
    { 0x8C0D42DF, "o_karma_2_1_tarmac_worker_metalstorm" },
    { 0x3BB8BC68, "o_karma_2_1_tarmac_worker_metalstorm_idle" },
    { 0xB7B3D9DD, "o_karma_2_2_security_03_alert_idle_metalstorm" },
    { 0xF8CC8A18, "o_karma_2_2_security_03_alert_metalstorm" },
    { 0xA3FA1E29, "o_karma_2_2_security_metalstorm" },
    { 0x1F368750, "o_karma_3_1_going_down_enter_harp" },
    { 0xC782120E, "o_karma_3_1_going_down_enter_sala" },
    { 0x6E0A6449, "o_karma_3_1_going_down_harp" },
    { 0xDE2E99E3, "o_karma_3_1_going_down_sala" },
    { 0xEF6EA0BE, "o_karma_3_1_going_down_wait1_harp" },
    { 0x64FADF54, "o_karma_3_1_going_down_wait1_sala" },
    { 0x960E0F9F, "o_karma_3_1_going_down_wait2_harp" },
    { 0x4DA5BC99, "o_karma_3_1_going_down_wait2_sala" },
    { 0x29FBCC1C, "o_karma_3_4_eleveator_exit_harper" },
    { 0x05B12386, "o_karma_3_4_eleveator_exit_salazar" },
    { 0xA800C27E, "o_karma_3_elevator_1_door_close" },
    { 0x4CEF2F9A, "o_karma_3_elevator_1_door_open" },
    { 0x99AA2471, "o_karma_4_1_hotel_room_set_bot_briefcase" },
    { 0x360AC2B2, "o_karma_4_1_hotel_room_set_bot_briefcase_idle" },
    { 0x8FA1FA26, "o_karma_4_1_hotel_room_set_bot_pad" },
    { 0xAD19D8D7, "o_karma_4_1_hotel_room_set_bot_spiderbot" },
    { 0x0AF94202, "o_karma_4_1_hotel_room_set_bot_vent" },
    { 0x505D2A8B, "o_karma_4_7_itmanager_loop_tablet" },
    { 0x3C678353, "o_karma_4_7_itmanager_walkin_tablet" },
    { 0xA9748157, "o_karma_4_8_crc_manager_loop_guy1_tablet" },
    { 0x1FCD047A, "o_karma_4_8_crc_manager_walkin_tablet" },
    { 0x6DD6EFE9, "o_karma_4_8_spiderbotdrop_vent" },
    { 0x57FC2D78, "o_karma_5_3_crc_enter_breach_flashbang" },
    { 0x40191E77, "o_karma_7_explosion_aftermath_armorydoor" },
    { 0xAE6E83EA, "o_karma_7_explosion_aftermath_doubledoor_left" },
    { 0x287A188F, "o_karma_9_1_gate_lift" },
    { 0x6FCDC2FC, "o_la_01_01_110_intro_explosionfx" },
    { 0xBD1C04DD, "o_la_01_01_110_intro_gun" },
    { 0xD41FE5DA, "o_la_01_01_110_intro_krailfx" },
    { 0x81E749B4, "o_la_01_01_110_intro_missile1" },
    { 0x1ECDEC04, "o_la_01_01_110_intro_missletarget1" },
    { 0x90D55B3F, "o_la_01_01_110_intro_missletarget2" },
    { 0x6AD2E0D6, "o_la_01_01_110_intro_missletarget3" },
    { 0xACC67CC9, "o_la_01_01_110_intro_missletarget4" },
    { 0x3A170E20, "o_la_01_01_110_intro_phone1" },
    { 0xAC1E7D5B, "o_la_01_01_110_intro_phone2" },
    { 0x861C02F2, "o_la_01_01_110_intro_phone3" },
    { 0x9BAFAE29, "o_la_03_04_cougarfalls_f35intro_debris01" },
    { 0xC1B22892, "o_la_03_04_cougarfalls_f35intro_debris02" },
    { 0xF1976C2D, "o_la_03_06_ai_rappel_left_rope01" },
    { 0x1799E696, "o_la_03_06_ai_rappel_left_rope02" },
    { 0x3D9C60FF, "o_la_03_06_ai_rappel_left_rope03" },
    { 0x338B0820, "o_la_03_06_ai_rappel_left_rope04" },
    { 0x1F011FBA, "o_la_03_08_ai_rappel_rope02" },
    { 0x45039A23, "o_la_03_08_ai_rappel_rope03" },
    { 0x6B06148C, "o_la_03_08_ai_rappel_rope04" },
    { 0xAC9256FA, "o_la_03_09_exitsniper_car1" },
    { 0x868FDC91, "o_la_03_09_exitsniper_car2" },
    { 0x757250CC, "o_la_03_09_exitsniper_platform" },
    { 0xEC7FF5F1, "o_la_03_09_exitsniper_rebar" },
    { 0x70CD82B6, "o_la_03_09_exitsniper_rpg" },
    { 0xDD08DC00, "o_la_03_09_exitsniper_rpg2" },
    { 0x030B5669, "o_la_03_09_exitsniper_rpg3" },
    { 0x12BF0339, "o_la_03_10_grouprappel_bill_rope" },
    { 0x927923C5, "o_la_03_10_grouprappel_hilary_rope" },
    { 0xDC7C5A53, "o_la_03_10_grouprappel_jack_rope" },
    { 0xD67E823B, "o_la_03_10_grouprappel_sniper_bill_rope" },
    { 0xD2D3450F, "o_la_03_10_grouprappel_sniper_hilary_rope" },
    { 0xF92EE4ED, "o_la_03_10_grouprappel_sniper_jack_rope" },
    { 0xFE32BBB2, "o_la_05_02_entries_cartpush_cart" },
    { 0x7635AA80, "o_la_05_03_bruteforce_jaws" },
    { 0x4A76B5AD, "o_la_06_02_plaza_cart01" },
    { 0x70793016, "o_la_06_02_plaza_cart02" },
    { 0xE55D38D9, "o_la_06_02_plaza_planter01" },
    { 0x24808B08, "o_la_06_02_plaza_table_flip_chair_01" },
    { 0x9687FA43, "o_la_06_02_plaza_table_flip_chair_02" },
    { 0x70857FDA, "o_la_06_02_plaza_table_flip_chair_03" },
    { 0xBC8A74AC, "o_la_06_02_plaza_table_flip_chair_05" },
    { 0xC215CC3D, "o_la_06_02_plaza_table_flip_table_01" },
    { 0xE81846A6, "o_la_06_02_plaza_table_flip_table_02" },
    { 0xAEED325B, "o_la_08_02_f35enter_helmet" },
    { 0x3026F89A, "o_la_10_01_f35eject_parachute" },
    { 0x8F0DEDBE, "o_link_spot" },
    { 0x77D20D7A, "o_mon_01_01_intro_turret_turret" },
    { 0xB17EB13A, "o_mon_04_06_riot_shield_plant" },
    { 0x3C4AB223, "o_mon_05_06_ammo_carry_left_crate" },
    { 0x20D983CA, "o_mon_05_06_ammo_carry_right_crate" },
    { 0x4BF52648, "o_mon_05_06_turret_plant_turret" },
    { 0xF15A4821, "o_mon_09_01_defend_intro_crate" },
    { 0xCAA5E659, "o_mon_09_04_codes_player_shield" },
    { 0x5BB4DCEB, "o_mon_09_04_codes_shield" },
    { 0x2D232D77, "o_mon_10_02_celerium_chamber_chip" },
    { 0xE360B6C4, "o_mon_10_02_celerium_chamber_chip_loop" },
    { 0xAB94749B, "o_mon_11_01_ending_celerium" },
    { 0x4BD0679B, "o_mon_11_01_ending_chair01" },
    { 0xD9C8F860, "o_mon_11_01_ending_chair02" },
    { 0x1A49B341, "o_monsoon_squirrelsuit_landing_helmet" },
    { 0xF2B9D476, "o_mov_a1d_02_pendant" },
    { 0x54E67D94, "o_mov_a1d_02_wheelchair" },
    { 0x6BD06FC2, "o_mov_a1m_02b_keycard" },
    { 0xB6D60F07, "o_mov_a1m_02b_menendezglasses" },
    { 0x394CDD4B, "o_mov_a1m_02b_woodsdoor" },
    { 0x98C56C43, "o_mov_a1m_03a_menendezglasses" },
    { 0x5A4DA6EF, "o_mov_a1m_03a_pendant" },
    { 0xACB58A3B, "o_mov_a1m_03a_wheelchair" },
    { 0xD61397BC, "o_mov_a1m_03b_menendezglasses" },
    { 0x7D0D79BC, "o_mov_a1m_03b_pendant" },
    { 0x801F6C32, "o_mov_a1m_03b_wheelchair" },
    { 0x78DED4ED, "o_mov_a1m_03c_menendezglasses" },
    { 0xA4086A8D, "o_mov_a1m_03c_pendant" },
    { 0xB7A0E3B9, "o_mov_a1m_03c_wheelchair" },
    { 0x930A74A6, "o_mov_a1m_03d_menendezglasses" },
    { 0xCE9FD802, "o_mov_a1m_03d_pendant" },
    { 0x8FED8280, "o_mov_a1m_03d_wheelchair" },
    { 0x87563AFB, "o_mov_a1m_04_pendant" },
    { 0x4D8913E7, "o_mov_a1m_04_wheelchair" },
    { 0x9DC5CED0, "o_mov_a2j_03_wheelchair" },
    { 0x93B8A4AA, "o_mov_a2s_02_wheelchair" },
    { 0x06B37491, "o_mov_a2s_03_wheelchair" },
    { 0x1C344033, "o_mov_a3a_02_wheelchair" },
    { 0xEFA67E0D, "o_mov_a3a_02a_m1911" },
    { 0x285B0D84, "o_mov_a3a_02a_wheelchair" },
    { 0xAA160F9A, "o_mov_a3a_02b_m1911" },
    { 0xF75F0DC1, "o_mov_a3a_02b_wheelchair" },
    { 0x181B7C8E, "o_mov_afg1_01_cigarette" },
    { 0xC3C80C2A, "o_mov_afg1_01_picture_frame_large" },
    { 0x5777B2CA, "o_mov_afg1_01_wheelchair" },
    { 0xDFAE709B, "o_mov_afg2_01_cigarette" },
    { 0x1CD74407, "o_mov_afg2_01_picture_frame_large" },
    { 0x82780691, "o_mov_afg2_01_wheelchair" },
    { 0x2DE79A3A, "o_mov_afg_06_cigarette" },
    { 0xFD7BFAB6, "o_mov_afg_06_picture_frame_large" },
    { 0xAC15B036, "o_mov_afg_06_wheelchair" },
    { 0x634D934A, "o_mov_ang_02_wheelchair" },
    { 0xE1F860B1, "o_mov_ang_03_wheelchair" },
    { 0x07A49294, "o_mov_b1a_02_consolechair" },
    { 0x28C43304, "o_mov_b1a_03_cell_phone" },
    { 0x333B82AF, "o_mov_b1a_03_consolechair" },
    { 0xE43674E4, "o_mov_b2d_02_consolechair" },
    { 0x3671F3C9, "o_mov_bfr_01_pendant" },
    { 0x8119ADE8, "o_mov_c1d_01_prison_cell_door" },
    { 0x2FA63236, "o_mov_c2a_a_01_coffin_lid" },
    { 0x92316E69, "o_mov_c2a_a_01_gas_can" },
    { 0x5D375BA5, "o_mov_c2a_b_01_coffin_lid" },
    { 0xCAE025DC, "o_mov_c2a_b_01_gas_can" },
    { 0x9B1518CA, "o_mov_c2d_01_cell_phone_fb" },
    { 0x6BFFD542, "o_mov_hai_01_chair_01" },
    { 0x45FD5AD9, "o_mov_hai_01_chair_02" },
    { 0xCE8C5823, "o_mov_los_02_chair" },
    { 0xA62431DF, "o_mov_los_03_smaw_01" },
    { 0x341CC2A4, "o_mov_los_03_smaw_02" },
    { 0x3580A94F, "o_mov_mon_01a_cell_phone" },
    { 0xF8CE26D2, "o_mov_mon_01a_wheelchair" },
    { 0x60079C32, "o_mov_mon_01b_cell_phone" },
    { 0x8C916ADB, "o_mov_mon_01b_wheelchair" },
    { 0xD9B53F54, "o_mov_nic1_01_cigarette" },
    { 0xC6C702AC, "o_mov_nic1_01_wheelchair" },
    { 0x481CEBAF, "o_mov_nic2_01_wheelchair" },
    { 0x8C3751B2, "o_mov_nic_01a_boxing_ring_ropes" },
    { 0x2393ACB5, "o_mov_nic_01b_boxing_ring_ropes" },
    { 0x96C0A5F8, "o_mov_nic_02_boxing_ring_ropes" },
    { 0x7D637AAA, "o_mov_nic_04_cigarette" },
    { 0x0D844EE6, "o_mov_nic_04_wheelchair" },
    { 0xAF277967, "o_mov_nic_05_cigarette" },
    { 0x897F9EFD, "o_mov_nic_05_wheelchair" },
    { 0x37C5CCE5, "o_mov_ntr_02a_door_left" },
    { 0xA3182655, "o_mov_ntr_02a_door_left_warped" },
    { 0x2A479B88, "o_mov_ntr_02a_door_right" },
    { 0x89B1E55F, "o_mov_ntr_02a_pendant" },
    { 0x5FC53ABF, "o_mov_ntr_02b_burnt_beam_01" },
    { 0xEDBDCB84, "o_mov_ntr_02b_burnt_beam_02" },
    { 0x13C045ED, "o_mov_ntr_02b_burnt_beam_03" },
    { 0xDE8FFAC8, "o_mov_ntr_02b_door_left_warped" },
    { 0xB3F039EC, "o_mov_ntr_02b_pendant" },
    { 0xF3E4D61E, "o_mov_ntr_02c_ceiling_collapse_01" },
    { 0xCDE25BB5, "o_mov_ntr_02c_ceiling_collapse_02" },
    { 0xA7DFE14C, "o_mov_ntr_02c_ceiling_collapse_03" },
    { 0x81DD66E3, "o_mov_ntr_02c_ceiling_collapse_04" },
    { 0xA4D962CF, "o_mov_ntr_02c_column_cracked" },
    { 0xA60E5CDD, "o_mov_ntr_02c_column_explode" },
    { 0x3ACA36E7, "o_mov_ntr_02c_conchunk_11" },
    { 0xC8C2C7AC, "o_mov_ntr_02c_conchunk_12" },
    { 0xA9FD3E40, "o_mov_ntr_02c_fall_on_josefina" },
    { 0x4609FBBD, "o_mov_ntr_02c_pendant" },
    { 0x550ED532, "o_mov_ntr_02d_pendant" },
    { 0xF0BE2232, "o_mov_pak_01_remington_870" },
    { 0x03FDC1E5, "o_mov_pan1_01_wheelchair" },
    { 0x6A03F68E, "o_mov_pan2_01_wheelchair" },
    { 0x839E79C3, "o_mov_pan3_01_wheelchair" },
    { 0x9D319F44, "o_mov_pan4_01_wheelchair" },
    { 0x1A0E0E49, "o_mov_pan5_01_wheelchair" },
    { 0x1B25A4E2, "o_mov_pan6_01_wheelchair" },
    { 0x9693228E, "o_mov_pan_01_a_wheelchair" },
    { 0x2F1E5DE7, "o_mov_pan_01_b_wheelchair" },
    { 0xFA58791F, "o_mov_pan_02_wheelchair" },
    { 0x949CB9EB, "o_mov_pro_00_door_int" },
    { 0x11B0CF7C, "o_mov_pro_02_door1" },
    { 0x83B83EB7, "o_mov_pro_02_door2" },
    { 0x5DB5C44E, "o_mov_pro_02_door3" },
    { 0x9FA96041, "o_mov_pro_02_door4" },
    { 0x79A6E5D8, "o_mov_pro_02_door5" },
    { 0xEBAE5513, "o_mov_pro_02_door6" },
    { 0xC5ABDAAA, "o_mov_pro_02_door7" },
    { 0xAB4D5F1D, "o_mov_pro_02b_wheelchair" },
    { 0x82DE29D6, "o_mov_pro_03_fish" },
    { 0x592869EA, "o_mov_pro_03_pendant" },
    { 0xE71AD1F8, "o_mov_pro_03_wheelchair" },
    { 0x2351973D, "o_mov_revealtrailer02_vault_shot_01_wheelchair" },
    { 0x5787B1F0, "o_mov_revealtrailer02_vault_shot_02_wheelchair" },
    { 0xC14E4923, "o_mov_revealtrailer02_vault_shot_03_pendant" },
    { 0xF685E47F, "o_mov_revealtrailer02_vault_shot_03_wheelchair" },
    { 0x010D9922, "o_mov_revealtrailer02_vault_shot_04_wheelchair" },
    { 0xF50D9F2D, "o_mov_yem_03a_consolechair" },
    { 0x42CF4768, "o_mov_yem_03b_consolechair" },
    { 0xBAAE224B, "o_nic_01_01_intro_pendant" },
    { 0xBFEA611F, "o_nic_01_01_intro_picture" },
    { 0x9ECFD672, "o_nic_01_02_intro_door" },
    { 0x7F83194A, "o_nic_01_02_intro_shard" },
    { 0x8835AA41, "o_nic_01_02_intro_syringe" },
    { 0xB7B41AD7, "o_nic_02_01_noriega_arrives_cuffs" },
    { 0xD6E174E4, "o_nic_02_01_noriega_arrives_cuffs_loop" },
    { 0x420BDFCE, "o_nic_02_01_noriega_arrives_handcuffs" },
    { 0x76E0A432, "o_nic_02_01_noriega_arrives_spas_idle" },
    { 0xCB35E242, "o_nic_03_01_dynamic_cover_haycart" },
    { 0x8BC209B2, "o_nic_03_02_pitchfork_impale_pillar_idle" },
    { 0x813FCA10, "o_nic_03_02_pitchfork_impale_pillar_start" },
    { 0x281E3D11, "o_nic_03_02_pitchfork_impale_pitchfork_grab_pitchfork" },
    { 0xEA900141, "o_nic_03_02_pitchfork_impale_pitchfork_ignore_pitchfork" },
    { 0x688953DF, "o_nic_03_02_pitchfork_impale_pitchfork_prompt_idle" },
    { 0x8C05E5F8, "o_nic_03_02_pitchfork_impale_pitchfork_start" },
    { 0x72BB696C, "o_nic_03_1_axe_hack_grab_axe" },
    { 0xF9CD8B7F, "o_nic_03_1_execution_idle_molotv" },
    { 0xF5A0727D, "o_nic_03_1_execution_react_molotov" },
    { 0xF52DF850, "o_nic_04_01_shattered2_door" },
    { 0x38D5B6EA, "o_nic_04_01_shattered2_grenade" },
    { 0xBB5F97F8, "o_nic_04_01_shattered_door" },
    { 0x94AAB015, "o_nic_04_01_shattered_door_02" },
    { 0x913E87B8, "o_nic_05_01_recon_binoculars" },
    { 0x567136A1, "o_nic_05_01_recon_scope_door" },
    { 0xEA4C83DE, "o_nic_05_02_recon_go_binoculars" },
    { 0x4D34464C, "o_nic_06_08_balcony_doors" },
    { 0x8887B589, "o_nic_06_08_balcony_doors_start" },
    { 0x4D18C7E6, "o_nic_06_08_balcony_fence_strugle_menendez" },
    { 0xB33DB025, "o_nic_06_14_split_up_door_open" },
    { 0x38728AEC, "o_nic_06_14_split_up_door_start_idle" },
    { 0x9E053619, "o_nic_06_14_split_up_hatch_close" },
    { 0x59C06577, "o_nic_06_14_split_up_hatch_enter" },
    { 0xD3C6C216, "o_nic_06_14_split_up_hatch_start_idle" },
    { 0xB948F70C, "o_nic_06_16_bunker_cartel_tablel_01_idle" },
    { 0x440CF227, "o_nic_06_16_bunker_cartel_tablel_01_react" },
    { 0x15348EE1, "o_nic_06_16_bunker_cartel_tablel_02_idle" },
    { 0x1CD0515C, "o_nic_06_16_bunker_cartel_tablel_02_react" },
    { 0x9C5069F6, "o_nic_06_16_evidence_cartel01_idle" },
    { 0x13A2003D, "o_nic_06_16_evidence_cartel01_react" },
    { 0x93035C9F, "o_nic_06_16_evidence_cartel02_idle" },
    { 0x685C3D7E, "o_nic_06_16_evidence_cartel02_react" },
    { 0x3C175222, "o_nic_06_18_bunker_exit_door" },
    { 0x5A0C3D15, "o_nic_08_02_outro_body_bag" },
    { 0xED0F91B3, "o_nic_08_02_outro_ghaz_cargo" },
    { 0x999A28DA, "o_nic_08_02_outro_ghaz_truck" },
    { 0x98F85CF1, "o_nic_08_02_outro_helicopter" },
    { 0x9BC99AC1, "o_nic_08_02_outro_rubble01" },
    { 0xC1CC152A, "o_nic_08_02_outro_rubble02" },
    { 0xE7CE8F93, "o_nic_08_02_outro_rubble03" },
    { 0x0DD109FC, "o_nic_08_02_outro_rubble04" },
    { 0x33D38465, "o_nic_08_02_outro_rubble05" },
    { 0x59D5FECE, "o_nic_08_02_outro_rubble06" },
    { 0x48AF7F51, "o_nicaragua_barn_door_open_door" },
    { 0xC28C93F6, "o_obj" },
    { 0x20EEB586, "o_object" },
    { 0x7248B730, "o_pakistan_1_1_market_intro_doors" },
    { 0x9BFBF24E, "o_pakistan_1_6_brute_force_gate" },
    { 0x5E07C1ED, "o_pakistan_2_3_gate_push_left_door" },
    { 0x3A8BE440, "o_pakistan_2_3_gate_push_right_door" },
    { 0x76DBD26D, "o_pakistan_2_3_gate_push_success_left_door" },
    { 0xD061DDC0, "o_pakistan_2_3_gate_push_success_right_door" },
    { 0xE30ECA29, "o_pakistan_3_1_ambient_civilians_door" },
    { 0xFFB567E9, "o_pakistan_3_1_floating_debris" },
    { 0xF91572E8, "o_pakistan_3_5_manhole_cover_manhole" },
    { 0x6C778D50, "o_pakistan_3_5_sewer_entry_lockbreaker" },
    { 0x5C85BC2D, "o_pakistan_3_5_sewer_entry_sewer_gate" },
    { 0xB0AA6B9C, "o_pakistan_5_11_approach_door_door" },
    { 0x09D6A9E8, "o_pakistan_5_11_close_door_door" },
    { 0xDA7845DB, "o_pakistan_5_13_get_closer_avcart" },
    { 0x1622CD3A, "o_pakistan_5_13_get_closer_cart" },
    { 0x61AEB9F1, "o_pakistan_5_4_station_approach_door1" },
    { 0x772FB66A, "o_pakistan_5_4_station_exit_door2" },
    { 0x7F073C2D, "o_pakistan_5_4_station_idle_chair" },
    { 0x5BB53582, "o_pakistan_5_4_station_wait_door1" },
    { 0xFD6F0F6B, "o_pakistan_5_7_meeting_defalco" },
    { 0xBEAF6EF9, "o_pakistan_6_1_grenades_door1" },
    { 0xE4B1E962, "o_pakistan_6_1_grenades_door2" },
    { 0x2DDB0308, "o_pakistan_6_1_grenades_grenade_01" },
    { 0x9FE27243, "o_pakistan_6_1_grenades_grenade_02" },
    { 0xC6EF71BF, "o_pakistan_6_5_defend_area_door" },
    { 0x60A78DE5, "o_pakistan_6_9_climb_out_door" },
    { 0xE01A2F81, "o_pakistan_7_1_drone_tutorial_glass_building_table" },
    { 0x328584D6, "o_pan_01_01_intro_drinking_idle_beer" },
    { 0x827C5CEA, "o_pan_01_01_intro_end_gate_b" },
    { 0x5A1AED7B, "o_pan_01_01_intro_frontdoor_frontdoor" },
    { 0x2A4247FA, "o_pan_01_01_intro_frontyard_door" },
    { 0xF8A5ADE1, "o_pan_01_01_intro_frontyard_hat" },
    { 0x44F8A89E, "o_pan_01_01_intro_get_bag_bag" },
    { 0xB690FC32, "o_pan_01_01_intro_get_bag_beer" },
    { 0x5B46B807, "o_pan_01_01_intro_get_bag_coke1" },
    { 0xE93F48CC, "o_pan_01_01_intro_get_bag_coke2" },
    { 0x8D15D1F5, "o_pan_01_01_intro_get_bag_mirrorbag" },
    { 0x049E0F7F, "o_pan_01_01_intro_get_bag_pajamas" },
    { 0xFC4C7CC1, "o_pan_01_01_intro_get_bag_shed_door" },
    { 0xE66F113D, "o_pan_01_01_intro_get_bag_shed_door_mirror" },
    { 0xAB3164B1, "o_pan_01_01_intro_hat" },
    { 0x346BD793, "o_pan_01_01_intro_hat_reflection" },
    { 0x3A644ACD, "o_pan_01_01_intro_tobackyard_beer" },
    { 0x2152DD8E, "o_pan_01_01_intro_tobackyard_gate_a" },
    { 0x33EF62F8, "o_pan_01_02_intro_gate_wait_hat" },
    { 0x0F662DA3, "o_pan_01_03_intro_backyard_enter_beer" },
    { 0x8B3BE5D9, "o_pan_01_03_intro_backyard_enter_beer_can01" },
    { 0xB13E6042, "o_pan_01_03_intro_backyard_enter_beer_can02" },
    { 0xC87C4828, "o_pan_01_03_intro_backyard_enter_gate" },
    { 0xC67B3368, "o_pan_01_03_intro_backyard_enter_hat" },
    { 0x5A14F795, "o_pan_01_04_intro_backyard_wait_beer" },
    { 0x85D4DE97, "o_pan_01_04_intro_backyard_wait_beer_can01" },
    { 0x13CD6F5C, "o_pan_01_04_intro_backyard_wait_beer_can02" },
    { 0x96B7ABA6, "o_pan_01_04_intro_backyard_wait_hat" },
    { 0x5E216FB6, "o_pan_01_05_intro_get_bag_beer" },
    { 0x70EE0F50, "o_pan_01_05_intro_get_bag_beer_can01" },
    { 0xE2F57E8B, "o_pan_01_05_intro_get_bag_beer_can02" },
    { 0x36D9AD0E, "o_pan_01_05_intro_get_bag_cocaine02" },
    { 0xDCA214B7, "o_pan_01_05_intro_get_bag_coke01" },
    { 0xF349E910, "o_pan_01_05_intro_get_bag_door" },
    { 0x1E990674, "o_pan_01_05_intro_get_bag_door_reflection" },
    { 0xCB9AB0A8, "o_pan_01_05_intro_get_bag_duffle" },
    { 0xEAFECD07, "o_pan_01_05_intro_get_bag_hat" },
    { 0x9531FE3D, "o_pan_01_05_intro_get_bag_hat_reflection" },
    { 0xF894AF23, "o_pan_01_05_intro_get_bag_pajamas" },
    { 0x1C18BA9F, "o_pan_01_06_intro_backyard_leave_beer" },
    { 0xE3014E7E, "o_pan_01_06_intro_backyard_leave_beer_can02" },
    { 0x7AAC3354, "o_pan_01_06_intro_backyard_leave_hat" },
    { 0x416A4E79, "o_pan_01_07_gringos_beer" },
    { 0xB3A64002, "o_pan_01_07_gringos_beer_can" },
    { 0xE7981A5A, "o_pan_01_07_gringos_hat" },
    { 0xA2905C04, "o_pan_01_07_intro_backyard_leave_wait_beer" },
    { 0xCABC7B41, "o_pan_01_07_intro_backyard_leave_wait_beer_can02" },
    { 0x4641A369, "o_pan_01_07_intro_backyard_leave_wait_hat" },
    { 0xF161A34F, "o_pan_02_01_beach_approach_zodiac" },
    { 0x2172A127, "o_pan_02_01_beach_approach_zodiac_1" },
    { 0xAF6B31EC, "o_pan_02_01_beach_approach_zodiac_2" },
    { 0xD56DAC55, "o_pan_02_01_beach_approach_zodiac_3" },
    { 0xF2606353, "o_pan_02_03_guards_flaregun_killed" },
    { 0x0FD0974D, "o_pan_02_03_guards_flaregun_not_killed" },
    { 0x53DC4201, "o_pan_02_03_guards_flaregun_walkout" },
    { 0x12F01817, "o_pan_02_03_guards_mason_kills_knife" },
    { 0x329376C4, "o_pan_02_03_guards_player_kills_knife" },
    { 0x0894C11D, "o_pan_02_04_unloading_box_loop" },
    { 0x2683EA62, "o_pan_02_07_hangar_ladder_door_hatch" },
    { 0xB900779E, "o_pan_02_07_seal_encounter_door" },
    { 0xE3B92F96, "o_pan_02_08_skylight_entry_door" },
    { 0x38B513F0, "o_pan_02_12_door_bash_door" },
    { 0xA62C1BB4, "o_pan_02_12_door_close_door" },
    { 0x1DC22EA4, "o_pan_03_01_noriegas_room_bag" },
    { 0x28E3439C, "o_pan_03_01_noriegas_room_breach_door" },
    { 0x4164D804, "o_pan_03_01_noriegas_room_breach_flashbang" },
    { 0xA37DAB71, "o_pan_03_01_noriegas_room_chair" },
    { 0x16E2F5AF, "o_pan_03_01_noriegas_room_cocaine01" },
    { 0xA4DB8674, "o_pan_03_01_noriegas_room_cocaine02" },
    { 0xB90C0C85, "o_pan_03_01_noriegas_room_pajamas" },
    { 0x3E9EE4B7, "o_pan_03_01_xcool_bag" },
    { 0xA2D3A506, "o_pan_03_01_xcool_pajamas" },
    { 0xC95C4158, "o_pan_04_03_to_building_hat" },
    { 0x1BAE58D2, "o_pan_04_03_to_building_noriega_hat_wait" },
    { 0x2CA4121E, "o_pan_04_03_to_building_noriega_pistol_wait" },
    { 0x1C205390, "o_pan_04_03_to_building_pistol" },
    { 0x673804EA, "o_pan_05_01_noriega_pistol_hat" },
    { 0xA32B916E, "o_pan_05_01_noriega_pistol_hat_wait" },
    { 0x3F44408E, "o_pan_05_01_noriega_pistol_pistol" },
    { 0xFCF78E32, "o_pan_05_01_noriega_pistol_pistol_wait" },
    { 0xC9AE2EE0, "o_pan_05_15_dumpster_push_dumpster" },
    { 0x54B138C7, "o_pan_06_02_clinic_walkthru_stretcher" },
    { 0x0AE9EBD3, "o_pan_06_04_digbat_tackle_machette" },
    { 0xFA15120D, "o_pan_06_07_hallway_flashlight1_enter" },
    { 0x562E2D13, "o_pan_06_07_hallway_flashlight1_searchloop" },
    { 0x245D0636, "o_pan_06_07_hallway_flashlight2_enter" },
    { 0x590B4C62, "o_pan_06_07_hallway_flashlight2_searchloop" },
    { 0xD38357E6, "o_pan_07_01_help_noriega_strobe" },
    { 0x6DABCCFE, "o_pan_07_09_checkpoint_wheelbarrow" },
    { 0x06D7C1A7, "o_pan_07_09_checkpoint_wheelbarrow_idle" },
    { 0x59153B12, "o_pan_08_01_gatecrash_gate" },
    { 0x4873B6F9, "o_pan_08_01_jeep_rifle_grab_rifle" },
    { 0x6B20A1D0, "o_pan_08_05_elevator_defend_elevator_closedoors" },
    { 0xDA13FBF6, "o_pan_08_05_elevator_defend_elevator_opendoors" },
    { 0xCB3F69C0, "o_pan_08_05_elevator_defend_elevator_openidl" },
    { 0xCE485D8D, "o_pan_08_06_elevator_ride_elevator_closedoors" },
    { 0x554B3159, "o_pan_08_06_elevator_ride_elevator_opendoors" },
    { 0xDBB745CE, "o_pan_08_06_take_the_shot_rifle" },
    { 0x75EC7C1B, "o_pan_08_07_sniper_loop_sack" },
    { 0x12D6898E, "o_pan_08_07_sniper_sack_injured_last_shot" },
    { 0x40BCE84F, "o_pan_08_07_sniper_sack_injured_shot" },
    { 0x20E6B652, "o_pan_08_07_sniper_sack_secondidl" },
    { 0xDB51E261, "o_pan_08_07_sniper_sack_shot" },
    { 0xDD6A6452, "o_pan_08_07_sniper_sack_walk" },
    { 0xE0EC67F5, "o_pan_09_01_betrayed_1_leftdoor" },
    { 0x94600900, "o_pan_09_01_betrayed_1_rightdoor" },
    { 0x38998A24, "o_pan_09_01_betrayed_1_sack" },
    { 0xE76F4046, "o_pan_09_01_betrayed_1_woodsgun" },
    { 0x806F89A8, "o_pan_09_01_betrayed_2_leftdoor" },
    { 0x2D6762B3, "o_pan_09_01_betrayed_2_rightdoor" },
    { 0xEBCA0955, "o_pan_09_01_betrayed_2_sack" },
    { 0x0337F64B, "o_pan_09_01_betrayed_2_woodsgun" },
    { 0xC9ADB776, "o_pan_10_01_end_1_chair" },
    { 0x645CAB97, "o_pan_10_01_end_1_shotgun" },
    { 0xDC352FC1, "o_pan_10_01_end_2_chair" },
    { 0xE2FF5688, "o_pan_10_01_end_2_shotgun" },
    { 0xFF1C08EC, "o_pan_10_01_end_3_chair" },
    { 0x4103BF15, "o_pan_10_01_end_3_shotgun" },
    { 0x50C7FB11, "o_panama_player_kick_door" },
    { 0x9F601544, "o_panama_pull_power_lever" },
    { 0x7EF011DD, "o_player_start" },
    { 0x58378409, "o_railturret" },
    { 0xB06B5E5D, "o_sacotra_karma_rescue_chair" },
    { 0x76013BD6, "o_sacotra_karma_rescue_tablet" },
    { 0xD96A9E01, "o_scene" },
    { 0xE9438781, "o_scene_object" },
    { 0x3114A589, "o_secsystem" },
    { 0xD4625AA9, "o_singapore_1_player_outro_pda" },
    { 0x22C390D3, "o_specialty_afghanistan_intruder_boltcutter" },
    { 0x75588230, "o_specialty_afghanistan_intruder_grabbed_mine" },
    { 0xF1A863BD, "o_specialty_afghanistan_intruder_strongbox" },
    { 0x46B4B3E1, "o_specialty_afghanistan_lockbreaker_device" },
    { 0xF4D8F773, "o_specialty_afghanistan_lockbreaker_door" },
    { 0x803B548D, "o_specialty_afghanistan_lockbreaker_mortar1" },
    { 0xA63DCEF6, "o_specialty_afghanistan_lockbreaker_mortar2" },
    { 0x50C21D1B, "o_specialty_angola_bruteforce_buffel" },
    { 0x7925D8D1, "o_specialty_angola_bruteforce_crowbar" },
    { 0xE7679330, "o_specialty_angola_bruteforce_filler_mortar1" },
    { 0x596F026B, "o_specialty_angola_bruteforce_filler_mortar2" },
    { 0x8B8638B3, "o_specialty_angola_bruteforce_grabbed_mortar1" },
    { 0x197EC978, "o_specialty_angola_bruteforce_grabbed_mortar2" },
    { 0x86CD4E0B, "o_specialty_angola_intruder_boltcutter" },
    { 0x0C3F11C5, "o_specialty_angola_intruder_strongbox" },
    { 0xC82854A9, "o_specialty_angola_intruder_vest" },
    { 0xE35D08B7, "o_specialty_angola_intruder_vest_filler1" },
    { 0x7155997C, "o_specialty_angola_intruder_vest_filler2" },
    { 0x975813E5, "o_specialty_angola_intruder_vest_filler3" },
    { 0x2550A4AA, "o_specialty_angola_intruder_vest_filler4" },
    { 0x09A06099, "o_specialty_angola_lockbreaker_device" },
    { 0x715CB7DB, "o_specialty_angola_lockbreaker_door" },
    { 0x9F6DFB36, "o_specialty_angola_lockbreaker_trap" },
    { 0x4A7FEF47, "o_specialty_blackout_bruteforce_debris" },
    { 0x7173F407, "o_specialty_blackout_bruteforce_jaws" },
    { 0x1155A58F, "o_specialty_blackout_intruder_cutter" },
    { 0xC105E130, "o_specialty_blackout_intruder_panel" },
    { 0xF2975985, "o_specialty_blackout_lockbreaker_crate" },
    { 0x152907AF, "o_specialty_blackout_lockbreaker_dongle" },
    { 0x764ECCEB, "o_specialty_blackout_lockbreaker_filler_knuckles_1" },
    { 0x04475DB0, "o_specialty_blackout_lockbreaker_filler_knuckles_2" },
    { 0x2A49D819, "o_specialty_blackout_lockbreaker_filler_knuckles_3" },
    { 0xE8563C26, "o_specialty_blackout_lockbreaker_filler_knuckles_4" },
    { 0x0E58B68F, "o_specialty_blackout_lockbreaker_filler_knuckles_5" },
    { 0x9C514754, "o_specialty_blackout_lockbreaker_filler_knuckles_6" },
    { 0x97ABFE86, "o_specialty_blackout_lockbreaker_knuckles" },
    { 0xC6F7B63F, "o_specialty_haiti_bruteforce_jaws" },
    { 0xB222AC22, "o_specialty_haiti_bruteforce_tablet" },
    { 0x7A263471, "o_specialty_haiti_bruteforce_vtol" },
    { 0xC532D0B3, "o_specialty_haiti_intruder_crate" },
    { 0xFC25BC67, "o_specialty_haiti_intruder_cutter" },
    { 0xBCF4B347, "o_specialty_haiti_lockbreaker_dongle" },
    { 0xC0B78FD0, "o_specialty_karma_bruteforce_jaws" },
    { 0x00AA027A, "o_specialty_karma_bruteforce_leftdoor" },
    { 0x79F85705, "o_specialty_karma_bruteforce_rightdoor" },
    { 0x511F0C44, "o_specialty_karma_intruder_cutter" },
    { 0xC6911F31, "o_specialty_karma_intruder_door" },
    { 0x6C12FBCE, "o_specialty_karma_intruder_fillerknuckles1" },
    { 0x46108165, "o_specialty_karma_intruder_fillerknuckles2" },
    { 0x200E06FC, "o_specialty_karma_intruder_fillerknuckles3" },
    { 0xFA0B8C93, "o_specialty_karma_intruder_fillerknuckles4" },
    { 0x40F55503, "o_specialty_karma_intruder_knuckles" },
    { 0x4921857A, "o_specialty_karma_lockbreaker_dongle" },
    { 0x071D76E1, "o_specialty_la_intruder_cutter" },
    { 0x7BF28035, "o_specialty_la_intruder_gate" },
    { 0x339321F9, "o_specialty_la_lockbreaker_dongle" },
    { 0x288924DA, "o_specialty_monsoon_bruteforce_door" },
    { 0x8CFBCC8F, "o_specialty_monsoon_bruteforce_jaws" },
    { 0xF044F0F7, "o_specialty_monsoon_intruder_cutter" },
    { 0xB543CABD, "o_specialty_monsoon_intruder_helicopter" },
    { 0x4EFEE66F, "o_specialty_monsoon_lockbreaker_camosuit" },
    { 0x444F35CD, "o_specialty_monsoon_lockbreaker_crate" },
    { 0xA2724F37, "o_specialty_monsoon_lockbreaker_dongle" },
    { 0xC73D08FC, "o_specialty_nicaragua_bruteforce_crowbar" },
    { 0x69E3BFA4, "o_specialty_nicaragua_bruteforce_door" },
    { 0x241E4637, "o_specialty_nicaragua_bruteforce_filler_mortar1" },
    { 0xB216D6FC, "o_specialty_nicaragua_bruteforce_filler_mortar2" },
    { 0xD8195165, "o_specialty_nicaragua_bruteforce_filler_mortar3" },
    { 0x3DFE35C6, "o_specialty_nicaragua_bruteforce_grabbed_mortar1" },
    { 0x17FBBB5D, "o_specialty_nicaragua_bruteforce_grabbed_mortar2" },
    { 0xC0E5BC3C, "o_specialty_nicaragua_intruder_boltcutter" },
    { 0x62082D09, "o_specialty_nicaragua_intruder_filler_molotov_1" },
    { 0x880AA772, "o_specialty_nicaragua_intruder_filler_molotov_2" },
    { 0x028FD6B8, "o_specialty_nicaragua_intruder_grabbed_molotov" },
    { 0xD0F7AF08, "o_specialty_nicaragua_intruder_strongbox" },
    { 0x5FE4ECC0, "o_specialty_nicaragua_lockbreaker_device" },
    { 0xCE3D1116, "o_specialty_nicaragua_lockbreaker_door" },
    { 0xD014E259, "o_specialty_nicaragua_lockbreaker_grabbed_machete" },
    { 0xAD8590BB, "o_specialty_pakistan_brute_force_fusebox" },
    { 0x4EA8CC9A, "o_specialty_pakistan_brute_force_jaws" },
    { 0xBE6DDDED, "o_specialty_pakistan_intruder_cutter" },
    { 0xCA90DD84, "o_specialty_pakistan_intruder_door" },
    { 0x18F8EA7F, "o_specialty_panama_bruteforce_crowbar" },
    { 0x6ECC8428, "o_specialty_panama_bruteforce_gate" },
    { 0x5302919E, "o_specialty_panama_bruteforce_strobe" },
    { 0x16712D21, "o_specialty_panama_intruder_boltcutter" },
    { 0x4A3D2D3B, "o_specialty_panama_intruder_grabbed_nightingale" },
    { 0xD9CBE120, "o_specialty_panama_intruder_grabbed_nightingale_2" },
    { 0xC1830570, "o_specialty_panama_intruder_lock" },
    { 0x5F69705B, "o_specialty_panama_intruder_strongbox" },
    { 0xB7FF9F4B, "o_specialty_panama_lockbreaker_device" },
    { 0x230F0C5C, "o_specialty_panama_lockbreaker_door_open" },
    { 0xC8A6753F, "o_specialty_war_mode_lockbreaker_device" },
    { 0xED8AADC9, "o_specialty_yemen_bruteforce_cabinet" },
    { 0x858AD37A, "o_specialty_yemen_bruteforce_jaws" },
    { 0x4D3260E2, "o_specialty_yemen_bruteforce_sword" },
    { 0x6DAE1766, "o_specialty_yemen_intruder_cutter" },
    { 0x915B77FA, "o_specialty_yemen_intruder_rightgate" },
    { 0x7BFB8A40, "o_specialty_yemen_lockbreaker_camosuit" },
    { 0x163810FC, "o_specialty_yemen_lockbreaker_crate" },
    { 0x9C565124, "o_specialty_yemen_lockbreaker_dongle" },
    { 0x4B0C1BAF, "o_spot" },
    { 0x8718AD0E, "o_sunglasses_on_frontend" },
    { 0xD2D92B30, "o_target" },
    { 0xBA8F4BD5, "o_thing" },
    { 0xB101E079, "o_war_drones_outro_fail_emp" },
    { 0xDAE0CCC7, "o_war_pak_intro_sc2_launcher_1" },
    { 0x68D95D8C, "o_war_pak_intro_sc2_launcher_2" },
    { 0xD79DE6C5, "o_war_pak_intro_sc2_launcher_player" },
    { 0xD8A6A4D8, "o_windowview" },
    { 0x8DE51B1C, "o_yemen_01_02_menendez_intro_door_l" },
    { 0xB1A4AC72, "o_yemen_01_02_menendez_intro_door_r" },
    { 0xD3005653, "o_yemen_01_02_menendez_intro_outside_door_left" },
    { 0x1F6938C6, "o_yemen_01_02_menendez_intro_outside_door_right" },
    { 0x1A46F2C0, "o_yemen_01_03_menendez_speech_tower_door" },
    { 0x286A59B5, "o_yemen_01_03_menendez_speech_tower_door_defalco_alt" },
    { 0xDDC82C1F, "o_yemen_02_02_pushcart_cart" },
    { 0xCD34CB62, "o_yemen_02_02_pushcart_right_cart" },
    { 0xB0DC7E27, "o_yemen_02_02_table_flip_table" },
    { 0x506E8609, "o_yemen_05_01_call_farid_fhj18" },
    { 0x8907189A, "o_yemen_05_01_call_farid_idle_fhj18" },
    { 0xF1A162E8, "o_yemen_05_01_shoot_vtol_door" },
    { 0x05E1A0AF, "o_yemen_05_01_shoot_vtol_fhj18" },
    { 0x6C8212F5, "o_yemen_05_01_waiting_fhj18" },
    { 0x6ED144B7, "o_yemen_05_03_capture_approach_fhj18" },
    { 0xA404C104, "o_yemen_05_03_capture_approach_fn57" },
    { 0xAFEF7EB1, "o_yemen_05_03_capture_fn57" },
    { 0xFEEAF302, "o_yemen_05_04_shoot_harper_fn57" },
    { 0xB86468D6, "o_yemen_05_04_shoot_menendez_fn57" },
    { 0x4AE9BB93, "o_yemen_05_05_mason_intro_hpr_lives_rope" },
    { 0x58051EC7, "o_yemen_08_02_surrender_handcuffs" },
    { 0x292A0AC9, "o_zod_train" },
    { 0x8C295A62, "oaa" },
    { 0xCA20CAF8, "oasis" },
    { 0x4B4147FC, "oaziz" },
    { 0x7A398961, "obama" },
    { 0x27F94F2F, "obama_activate_camera" },
    { 0x4D29EEAC, "obama_player_controls" },
    { 0x85A10484, "obama_render_main" },
    { 0xABC5E0D5, "obama_scene_play" },
    { 0x007C4B16, "obama_scene_setup" },
    { 0x18D0C768, "obama_test_main" },
    { 0xE9027A22, "obama_test_slide" },
    { 0xEA3E5B7C, "obama_winning_main" },
    { 0x705E739C, "obejctive" },
    { 0x8FF157A0, "obey" },
    { 0xC8A43E33, "obeyed" },
    { 0x2680EB5A, "obfuscation" },
    { 0x68CB2CB0, "obituary" },
    { 0x4CB78A5B, "obituary_squad" },
    { 0x2E9D0261, "obituarymeansofdeath" },
    { 0x2BEFEFEC, "obituaryweapon" },
    { 0x56FD354C, "obj" },
    { 0x831454BD, "obj1" },
    { 0xEF7B3DC5, "obj10_string" },
    { 0x57793B74, "obj10a_string" },
    { 0x01461675, "obj10b_string" },
    { 0x6929984E, "obj10c_string" },
    { 0x2CB9F15E, "obj11_string" },
    { 0x2BE0C243, "obj12_string" },
    { 0xD6F1283B, "obj1_string" },
    { 0x9CB05813, "obj1b_string" },
    { 0x0753B054, "obj1c_string" },
    { 0xA916CF26, "obj2" },
    { 0x578692B6, "obj2_string" },
    { 0xAA06E560, "obj2b_string" },
    { 0xCF19498F, "obj3" },
    { 0xD7951E1D, "obj3_string" },
    { 0x350CE79C, "obj3a_string" },
    { 0x8F455DDD, "obj3b_string" },
    { 0x52482F76, "obj3c_string" },
    { 0xC8B9C08F, "obj3d_string" },
    { 0xD2BE4210, "obj3e_string" },
    { 0xC507F0B0, "obj4" },
    { 0xD7FCA550, "obj4_string" },
    { 0x036F4F8F, "obj4a_string" },
    { 0x2042E54A, "obj4b_string" },
    { 0xEB0A6B19, "obj5" },
    { 0x68E0E4CF, "obj5_string" },
    { 0x67939ABA, "obj5a_string" },
    { 0x823F3CBF, "obj5b_string" },
    { 0xE2BF9480, "obj5c_string" },
    { 0x110CE582, "obj6" },
    { 0xB2C8A48A, "obj6_string" },
    { 0xC3840981, "obj7_string" },
    { 0xD2676088, "obj7a_string" },
    { 0x17438139, "obj7b_string" },
    { 0xE25BD1C2, "obj7c_string" },
    { 0x2A0DED73, "obj7d_string" },
    { 0x62731C24, "obj8_string" },
    { 0x7C6C3C63, "obj9_string" },
    { 0xC8F056D8, "obj_13_pos" },
    { 0xE70DCD3E, "obj_1_complete" },
    { 0x20B13802, "obj_1_updatepos" },
    { 0x85FD296B, "obj_2_complete" },
    { 0x59FAD388, "obj_3_complete" },
    { 0x42F4B062, "obj_3d" },
    { 0xC30D9B65, "obj_4_complete" },
    { 0xB742987F, "obj_4_updatepos" },
    { 0xB3DE8C92, "obj_5_complete" },
    { 0x1057219A, "obj_aa_gun" },
    { 0xDBB5B59A, "obj_aaguns_complete" },
    { 0x5066480A, "obj_actor" },
    { 0x0A1A69D5, "obj_advance_past_rocks" },
    { 0xE1570E61, "obj_afghan_bc1" },
    { 0x075988CA, "obj_afghan_bc2" },
    { 0x2D5C0333, "obj_afghan_bc3" },
    { 0x33E8A780, "obj_afghan_bc3a" },
    { 0xA34BB1A0, "obj_afghan_bp1" },
    { 0x89FA06A4, "obj_afghan_bp1_vehicles" },
    { 0x0D6425DA, "obj_afghan_bp1wave3_vehicles" },
    { 0x155320DB, "obj_afghan_bp2" },
    { 0x61C9801A, "obj_afghan_bp2wave2_vehicles" },
    { 0x9AFBC5B5, "obj_afghan_bp2wave3_vehicles" },
    { 0xEF50A672, "obj_afghan_bp3" },
    { 0x655FED83, "obj_afghan_bp3wave2_vehicles" },
    { 0x27A7BBC0, "obj_afghan_bp3wave3_vehicles" },
    { 0x352A6199, "obj_afghan_bridges" },
    { 0xF6A671E1, "obj_afghan_wave3" },
    { 0xE85A305F, "obj_airfield" },
    { 0x220BD46F, "obj_airfield_complete" },
    { 0xD796B565, "obj_airfield_tanks_complete" },
    { 0xA7ACFEE9, "obj_ammo" },
    { 0xA1BB0DF9, "obj_anderson" },
    { 0x70461EA4, "obj_arena" },
    { 0x0538BA7E, "obj_array" },
    { 0x71B6EB97, "obj_arty" },
    { 0xC0BFDE6B, "obj_assault_airfield_complete" },
    { 0x818A8CA5, "obj_assault_builidng" },
    { 0x2F6BFD66, "obj_assault_complete" },
    { 0xCF6160FD, "obj_assist_seals" },
    { 0x9BD46E92, "obj_avoid_collisions" },
    { 0x0A0629F0, "obj_avoid_drones" },
    { 0x64AF48EC, "obj_basin_1_complete" },
    { 0x322FDBA5, "obj_basin_2_complete" },
    { 0x19CA449F, "obj_battle_forest_1" },
    { 0xA7C2D564, "obj_battle_forest_2" },
    { 0xCDC54FCD, "obj_battle_forest_3" },
    { 0xBCE40E87, "obj_big_dogs" },
    { 0x69A81058, "obj_big_dogs_harper" },
    { 0xB60B01E5, "obj_big_dogs_noharper" },
    { 0x4A277ED6, "obj_blockade" },
    { 0x13096D96, "obj_board_plane" },
    { 0x90EA22E9, "obj_bp1_wave3" },
    { 0x9008DABC, "obj_bp2_arch" },
    { 0xB051EA13, "obj_bp2_mortar" },
    { 0x8AD5E8E6, "obj_bp2_wave3" },
    { 0xFEEB1BF7, "obj_bp3_secure_cache" },
    { 0x6A5F4BAF, "obj_bp3_wave3" },
    { 0x5839CCA6, "obj_breach_control" },
    { 0x746DF9D8, "obj_breadcrumb" },
    { 0xB6F48695, "obj_brute" },
    { 0xFE0468F1, "obj_brute_force" },
    { 0x1E5C3764, "obj_brute_perk" },
    { 0x1B30F586, "obj_bruteforce" },
    { 0x64A8701B, "obj_building_complete" },
    { 0x04DBCFCD, "obj_bunker_regroup_complete" },
    { 0x7B6ED1BF, "obj_bunkers_complete" },
    { 0x90D9BB83, "obj_bus_escape" },
    { 0xB885FFB8, "obj_capture_menendez" },
    { 0xC4CB7C65, "obj_capture_noriega" },
    { 0x8F61D62F, "obj_car" },
    { 0x3FAB55FF, "obj_cctv" },
    { 0x69E0780A, "obj_celerium_drive" },
    { 0x42AF13C1, "obj_chase_russian_complete" },
    { 0x71320D72, "obj_check_obj_remove" },
    { 0x95DB56F7, "obj_cia_easter_egg" },
    { 0x1DFFDA87, "obj_clear_bldgs" },
    { 0xEDAFA292, "obj_clear_mansion_complete" },
    { 0x0C4A6E49, "obj_clear_railyard" },
    { 0x2BCE0B74, "obj_commandeer_complete" },
    { 0x07E786FA, "obj_complete" },
    { 0x94A867B8, "obj_compound" },
    { 0x28851F78, "obj_control_room" },
    { 0x4FE03E7D, "obj_counterattack_complete" },
    { 0x71C14833, "obj_crc_guy" },
    { 0xAF8FEE26, "obj_defeat_the_tanks_complete" },
    { 0xAFD6C3C7, "obj_defend" },
    { 0xA06BC1DF, "obj_defend_all" },
    { 0x7DCEA9FC, "obj_defend_bp" },
    { 0x57A655BD, "obj_defend_cache1" },
    { 0x7DA8D026, "obj_defend_cache2" },
    { 0xA3B0811A, "obj_defend_comm" },
    { 0x0D6DB727, "obj_defend_complete" },
    { 0x3108DF71, "obj_defend_computer" },
    { 0x2168C975, "obj_defend_power" },
    { 0xF4B9C5F8, "obj_defend_sarge" },
    { 0xE951A8BA, "obj_defend_tank" },
    { 0xD870B169, "obj_defensive_pos" },
    { 0x2F54C18B, "obj_destroy" },
    { 0x4D08713E, "obj_destroy_btr" },
    { 0x7CE3B02E, "obj_destroy_cargo" },
    { 0x8BB923B3, "obj_destroy_dome" },
    { 0xEC6F14DA, "obj_destroy_door" },
    { 0x6B3B884F, "obj_destroy_drones" },
    { 0x23DEE086, "obj_destroy_final_wave" },
    { 0xE94B374C, "obj_destroy_first_wave" },
    { 0xD331358E, "obj_destroy_heli" },
    { 0x1E80727C, "obj_destroy_hellads1" },
    { 0x9087E1B7, "obj_destroy_hellads2" },
    { 0xEF225718, "obj_destroy_helo" },
    { 0xEC268F0D, "obj_destroy_hind" },
    { 0x824CE118, "obj_destroy_ied" },
    { 0xAF7820FA, "obj_destroy_missile" },
    { 0xDB45E617, "obj_destroy_mortar_crew" },
    { 0x17079776, "obj_destroy_second_wave" },
    { 0x06127D2E, "obj_destroy_tank" },
    { 0x76A1A151, "obj_destroy_tanks" },
    { 0xF3796A4F, "obj_destroy_technical" },
    { 0x6C77B702, "obj_disable_zapper" },
    { 0x6F183E8D, "obj_docks_kill_menendez" },
    { 0xEDF8E141, "obj_docks_sniper" },
    { 0x8A37555A, "obj_dogfights" },
    { 0xD1BA7349, "obj_dogfights_last" },
    { 0x76E3ECB0, "obj_dogfights_strafe" },
    { 0xBB8D8C77, "obj_done" },
    { 0x03382674, "obj_dont_get_discovered" },
    { 0xF659CC69, "obj_drive" },
    { 0x356C8C83, "obj_drone_control_bridge" },
    { 0x60B05F8A, "obj_e5_tow_tanks_complete" },
    { 0x7CB013D2, "obj_end" },
    { 0x1A1C9853, "obj_end_trig" },
    { 0x52B52965, "obj_enemy_armor" },
    { 0x827CFD1D, "obj_enemy_armor_complete" },
    { 0xAA14E7F7, "obj_enemy_armor_vehicle_death" },
    { 0xCDC4947E, "obj_enemy_armor_vehicle_position" },
    { 0xB82EB201, "obj_enemy_armor_vehicle_think" },
    { 0x7B7732EB, "obj_enemy_hind" },
    { 0x6DD4A22B, "obj_enemy_hind_complete" },
    { 0xDCD7BA62, "obj_ent" },
    { 0x5FD641F0, "obj_ent_name" },
    { 0xB664F133, "obj_enter" },
    { 0xBBEC2F88, "obj_enter_crc" },
    { 0x74B7D9C6, "obj_escape" },
    { 0x8BDA0086, "obj_escape_jungle" },
    { 0x9EDAC622, "obj_escape_lab" },
    { 0x2C46939B, "obj_escort" },
    { 0xFA46F863, "obj_escort2" },
    { 0xB2E3706E, "obj_evac" },
    { 0x338A9BCD, "obj_evac_face_burn_point" },
    { 0x4CF6AD15, "obj_evac_point" },
    { 0xA9C8A22C, "obj_execute" },
    { 0xF6C41972, "obj_exit_club" },
    { 0xC06FFD1A, "obj_extract_team" },
    { 0xD8AC650B, "obj_extract_to_lz" },
    { 0x229CDC1E, "obj_fail_if_truck_takes_damage" },
    { 0x761827F7, "obj_fake_interrogate" },
    { 0x92BD6F65, "obj_fake_restore_control" },
    { 0xB9CED029, "obj_field_complete" },
    { 0x2283C50B, "obj_fight_thru_metro" },
    { 0xCD71F59D, "obj_find_crc" },
    { 0x1226736F, "obj_find_false_profit" },
    { 0x84B379DA, "obj_find_menen" },
    { 0x5BC5FCA3, "obj_find_menendez" },
    { 0xA2931BE2, "obj_find_radio" },
    { 0xCA8BD7DB, "obj_find_salazar" },
    { 0xD0D51739, "obj_find_woods" },
    { 0x6C846941, "obj_flag" },
    { 0x1469E037, "obj_flag_carry_string" },
    { 0xB2BD2318, "obj_flag_retrieve_string" },
    { 0x112DB7DA, "obj_flame_complete" },
    { 0x60D3968D, "obj_flank_struct" },
    { 0x0DD170A2, "obj_fly" },
    { 0xA2393F92, "obj_fly_to_base" },
    { 0xE5D3CEE4, "obj_follow" },
    { 0xE97B0AE3, "obj_follow_ambulance" },
    { 0xD20EB9D2, "obj_follow_bp1" },
    { 0x8609C500, "obj_follow_bp3" },
    { 0xE2626773, "obj_follow_buffel" },
    { 0xC4453347, "obj_follow_mason_1" },
    { 0xE5A5812A, "obj_follow_price" },
    { 0xDF1C62D4, "obj_follow_salazars_soct" },
    { 0x307E5C7A, "obj_follow_van" },
    { 0x345E3017, "obj_follow_woods" },
    { 0xDC1FFCF2, "obj_forest_complete" },
    { 0xADA955BB, "obj_fougasse_one" },
    { 0x4E3284A9, "obj_fougasse_two" },
    { 0xB104C65C, "obj_frontyard" },
    { 0xFDA38CE5, "obj_fx" },
    { 0x66364ECC, "obj_g20_cougar" },
    { 0x2EDF6422, "obj_g20_street" },
    { 0x8054DE07, "obj_gain_access" },
    { 0x861FEC67, "obj_gain_access_complete" },
    { 0x883DF83B, "obj_get_clear" },
    { 0x333DF072, "obj_get_on_mark_19" },
    { 0x7B555C81, "obj_get_to_base" },
    { 0x1E3C5110, "obj_get_to_base_again" },
    { 0xCEF1332E, "obj_get_to_buffel" },
    { 0xF13F7E96, "obj_get_to_club" },
    { 0x74035F09, "obj_get_to_metro" },
    { 0x85C0CA18, "obj_glow" },
    { 0x910A8AA3, "obj_goatpath" },
    { 0x90ACAF2E, "obj_goto_control_room" },
    { 0x8D3426AA, "obj_grab_briggs" },
    { 0x3E3E6040, "obj_grapple" },
    { 0x86EE1574, "obj_graveyard_complete" },
    { 0xB1A33500, "obj_hack_perk1" },
    { 0x23AAA43B, "obj_hack_perk2" },
    { 0xBEA3B879, "obj_hack_zhao" },
    { 0x7EB80E95, "obj_head_for_chinook" },
    { 0x2381D2D3, "obj_heli" },
    { 0x24DACAAB, "obj_heli2" },
    { 0x8E39A4D1, "obj_help_seals" },
    { 0x6042E89B, "obj_hide" },
    { 0x21DDE160, "obj_highway" },
    { 0x5A15E5B6, "obj_hill_struct" },
    { 0xA09C672D, "obj_hold_the_line_complete" },
    { 0x912F49BE, "obj_horse" },
    { 0x6A3CD3EB, "obj_house_empty" },
    { 0x4B1514B7, "obj_hudson_lookout_for_child_soldiers" },
    { 0xD11B16AF, "obj_hudson_moves_to_beach_evac" },
    { 0x11B973BB, "obj_hudson_stealth_orders1_objective" },
    { 0x09367CD9, "obj_id_karma" },
    { 0x32B99B31, "obj_id_menendez" },
    { 0xC09C20A6, "obj_ind_far_dist_close" },
    { 0x30D7FE70, "obj_ind_far_dist_closer" },
    { 0xCA629B49, "obj_ind_far_dist_far" },
    { 0x721421D5, "obj_index" },
    { 0x2168E5F7, "obj_infiltrate_lab" },
    { 0x3B45A239, "obj_infiltrate_lower_lab" },
    { 0xC5F18F28, "obj_info1" },
    { 0x37F8FE63, "obj_info2" },
    { 0x11F683FA, "obj_info3" },
    { 0xFE50DC5B, "obj_info_complete" },
    { 0xE497A593, "obj_info_incomplete1" },
    { 0x72903658, "obj_info_incomplete2" },
    { 0x1D08739D, "obj_initial" },
    { 0xD24F6101, "obj_interact" },
    { 0xB97D59E0, "obj_interact_brute_force" },
    { 0xE19BC351, "obj_interact_intruder" },
    { 0xEF136970, "obj_interact_lock_breaker" },
    { 0x255D1663, "obj_interrogate" },
    { 0xF6B87CE0, "obj_interrogate_krav" },
    { 0x9CA205C0, "obj_intro_leap" },
    { 0x8D4A266C, "obj_intru_perk" },
    { 0x4A851DAE, "obj_intruder" },
    { 0x6EC1C8AD, "obj_intruder_perk" },
    { 0xEA26AA21, "obj_iterator" },
    { 0xCD93BD47, "obj_kill_club_guards" },
    { 0x616B3047, "obj_kill_hind_crew" },
    { 0x664B0468, "obj_kill_hvt" },
    { 0x44B893E6, "obj_kill_rpg_one" },
    { 0x629C6808, "obj_kill_rpg_two" },
    { 0x9356B0FB, "obj_lab_defend" },
    { 0x40523399, "obj_large_boat" },
    { 0x267145CB, "obj_law_struct" },
    { 0xDA4198E0, "obj_law_struct_b" },
    { 0x00441349, "obj_law_struct_c" },
    { 0x53C9BA43, "obj_loc" },
    { 0xA6788551, "obj_lock_perk" },
    { 0xF55BA9C2, "obj_lockbreaker" },
    { 0xDA08FC24, "obj_mangrove_complete" },
    { 0xFCC6C3B9, "obj_marker" },
    { 0x453F3210, "obj_market_meet_menendez" },
    { 0x140AC352, "obj_mason_bruteforce_perk" },
    { 0xE31E2A71, "obj_mason_bunker" },
    { 0x6762F306, "obj_mason_bunker_entrance" },
    { 0xC11393E4, "obj_mason_bunker_exit" },
    { 0x778A1F36, "obj_mason_clear_the_mission" },
    { 0xB8919F7D, "obj_mason_enter_the_village" },
    { 0xD3DA3B38, "obj_mason_exit_village_enter_forest" },
    { 0x8ADB796C, "obj_mason_find_menendez" },
    { 0x496482F1, "obj_mason_follow_hudson" },
    { 0x7FCB2E2A, "obj_mason_follow_woods" },
    { 0x2A89FFC0, "obj_mason_goto_hut_window" },
    { 0xE4DCC9F9, "obj_mason_grab_menendez" },
    { 0xB891609E, "obj_mason_hide_behind_log_objective" },
    { 0xB2D0A8E7, "obj_mason_in_cover2_position" },
    { 0xE31A0978, "obj_mason_in_cover3_position" },
    { 0x8BDB338A, "obj_mason_intruder_perk" },
    { 0xF5C43799, "obj_mason_lockbreaker_machete" },
    { 0x24C22760, "obj_mason_lockbreaker_perk" },
    { 0x9D627A3F, "obj_mason_observe_menendez" },
    { 0x4F9300A7, "obj_mason_remove_rubble" },
    { 0x4BC40FAF, "obj_mason_run_to_cover2_objective" },
    { 0xFB9991B2, "obj_mason_run_to_cover3_objective" },
    { 0x756ECCF3, "obj_mason_run_to_safety_rocks_objective" },
    { 0xD1F0EC78, "obj_mason_splitup_start" },
    { 0xA443628E, "obj_mason_to_mission" },
    { 0x5494431D, "obj_mason_up_hill" },
    { 0x7C32FE76, "obj_max_dist" },
    { 0x1DF513EC, "obj_mdl" },
    { 0xE75F2B46, "obj_meet" },
    { 0x3F179227, "obj_meet_karma" },
    { 0x20DAC97E, "obj_meet_mcknight" },
    { 0xBA9EB8BA, "obj_menendez_approach_mission_part1" },
    { 0x949C3E51, "obj_menendez_approach_mission_part2" },
    { 0x6E99C3E8, "obj_menendez_approach_mission_part3" },
    { 0x78AB1CC7, "obj_menendez_approach_mission_part4" },
    { 0x59ED6DC5, "obj_menendez_approach_stables" },
    { 0xDA2C8EF8, "obj_menendez_axe" },
    { 0x8224D1F6, "obj_menendez_center_village" },
    { 0x581C4E8A, "obj_menendez_elevator" },
    { 0x1B5C04DD, "obj_menendez_enter_mission" },
    { 0xB853583B, "obj_menendez_enter_village" },
    { 0x021A0A89, "obj_menendez_exit_stables" },
    { 0x2EB001E1, "obj_menendez_find_josefina" },
    { 0x4A5E782F, "obj_menendez_get_to_mission" },
    { 0xC90EB692, "obj_menendez_meatshield" },
    { 0x913BE56D, "obj_menendez_observe_menendez" },
    { 0xBA61C183, "obj_menendez_save_josefina" },
    { 0x52BF57B4, "obj_menendez_shoot_stables_gate_lock" },
    { 0x2E5DCDCA, "obj_menendez_stables_exit_door" },
    { 0x75216967, "obj_misc" },
    { 0x76C58887, "obj_misc2" },
    { 0x444189C2, "obj_model" },
    { 0x09A0D646, "obj_morals_rail" },
    { 0xBD62C8C6, "obj_move_thru_street" },
    { 0x3EF42461, "obj_mrkr" },
    { 0x58C437D7, "obj_mz_follow_salazar" },
    { 0x740A45CE, "obj_name" },
    { 0x0DAFFAC8, "obj_name2" },
    { 0x04934775, "obj_north_tarmac" },
    { 0x6F31B8FD, "obj_num" },
    { 0x6D7DB204, "obj_number" },
    { 0xF2B31CDA, "obj_object" },
    { 0x24817123, "obj_obtain_celerium" },
    { 0x497B5BAF, "obj_open_container" },
    { 0x4B7BA2B3, "obj_open_steiner_door" },
    { 0x5C684C3E, "obj_open_vault" },
    { 0x336B90C7, "obj_org" },
    { 0xCBF04DC9, "obj_origin" },
    { 0x2AEA2882, "obj_outside_steiner_door" },
    { 0xFF10F593, "obj_parent" },
    { 0xD7A3E00A, "obj_perk_brute_force" },
    { 0x01141D0F, "obj_perk_intruder" },
    { 0xE2D225BD, "obj_perk_lockbreaker" },
    { 0x2956FA19, "obj_pickup_weapons" },
    { 0x6F901A03, "obj_plane" },
    { 0xF31EE1A7, "obj_plant_betties" },
    { 0x35FB861C, "obj_plant_the_c4" },
    { 0xD11C851C, "obj_player_does_drop_early" },
    { 0x59D0B21A, "obj_player_does_not_drop_early" },
    { 0xF5706D2A, "obj_player_in_hind" },
    { 0xF9100E55, "obj_player_reached_control_room" },
    { 0x96A56AE3, "obj_plaza" },
    { 0x24862FC9, "obj_plaza_clear" },
    { 0x6BE8D707, "obj_point" },
    { 0xA584CA2F, "obj_pos" },
    { 0xC05B6CF1, "obj_pos_struct" },
    { 0x32840472, "obj_position" },
    { 0xAC0E468C, "obj_potus" },
    { 0x6339FF20, "obj_pows_complete" },
    { 0x73B42646, "obj_prom_night" },
    { 0xE9543C90, "obj_protect" },
    { 0x1086B34F, "obj_protect_hudson_and_woods_on_way_to_beach" },
    { 0x70047D98, "obj_protect_hvc" },
    { 0x2E760D07, "obj_protect_plane" },
    { 0xFB624DE8, "obj_radio_for_extraction" },
    { 0x933679C3, "obj_rally_bunker" },
    { 0xE8C12693, "obj_rally_bunker_complete" },
    { 0xD1B9BB1D, "obj_ram" },
    { 0x57161503, "obj_rappel" },
    { 0xC6EFAF1B, "obj_rappel2" },
    { 0x1B9CA2D3, "obj_rappel_complete" },
    { 0x643117C6, "obj_rappel_down" },
    { 0x9A566B01, "obj_reach_checkpoint" },
    { 0xB5F82090, "obj_reach_lab" },
    { 0x7FF3E420, "obj_reacquire" },
    { 0xA6DF2965, "obj_reacquire_again" },
    { 0xC928F92E, "obj_ready_to_suppress_bunker" },
    { 0x91C7CC57, "obj_reaquire" },
    { 0x65CC372A, "obj_reaquire_again" },
    { 0xCE1A2D5D, "obj_record_menendez" },
    { 0xFE31D2F4, "obj_record_menendez_again" },
    { 0xAA2055C0, "obj_refill_ammo" },
    { 0x668F3D75, "obj_regroup" },
    { 0x4E92C870, "obj_rescue" },
    { 0x24C82F9B, "obj_rescue_pilot" },
    { 0xAC2B2A5B, "obj_rescue_pilot_complete" },
    { 0x08F8E278, "obj_rescue_vip" },
    { 0x7F68DDE9, "obj_restore_control" },
    { 0xDE7BA6DD, "obj_retake_the_hill_complete" },
    { 0xA310B16A, "obj_retreat_complete" },
    { 0x0AC77C1B, "obj_return_base" },
    { 0x794CC95E, "obj_return_pilot" },
    { 0xE7A4F474, "obj_return_pilot_complete" },
    { 0x9C5CDD38, "obj_roadblock" },
    { 0xE1B5CB01, "obj_rooftops" },
    { 0x172481EF, "obj_russian_start" },
    { 0x94A29BDA, "obj_safe_distance" },
    { 0x596A2C7D, "obj_salazar" },
    { 0x4806C9F2, "obj_salazar_crosby" },
    { 0xA3C4D32F, "obj_salazar_unlock_door" },
    { 0x19273723, "obj_satchel_complete" },
    { 0x747988DF, "obj_scientist" },
    { 0x9A29F4C7, "obj_search" },
    { 0x29AB94DC, "obj_secure" },
    { 0x331B168A, "obj_secure_the_barge" },
    { 0x32B4BB5D, "obj_security" },
    { 0xDEFBD472, "obj_server" },
    { 0x7934A651, "obj_shed" },
    { 0x6747E49D, "obj_shoot_briggs" },
    { 0x7750889E, "obj_shoot_drones" },
    { 0xCE086DFC, "obj_snipe" },
    { 0x4AE3631D, "obj_sonar_out" },
    { 0x9A9B6D29, "obj_speech" },
    { 0xC159A24B, "obj_spot" },
    { 0xFE36ACCF, "obj_star" },
    { 0x46912C89, "obj_start" },
    { 0x88B605B2, "obj_stay_with_tank" },
    { 0xA28BF04D, "obj_stop_control" },
    { 0xBEAC4ACA, "obj_stop_defalco" },
    { 0xB5B75EDB, "obj_stop_menen" },
    { 0xFF157106, "obj_stop_transmission" },
    { 0xA0C18D9E, "obj_street" },
    { 0x5A681BFB, "obj_street_regroup" },
    { 0x8A8DE914, "obj_strela" },
    { 0x1399EBF4, "obj_string" },
    { 0xDD05070C, "obj_struct" },
    { 0x1B610B94, "obj_struct0" },
    { 0x416385FD, "obj_struct1" },
    { 0x67660066, "obj_struct2" },
    { 0x8D687ACF, "obj_struct3" },
    { 0xD816478E, "obj_struct_name" },
    { 0xCEA26FB0, "obj_surveil_menendez" },
    { 0xBD546FC2, "obj_take_hind" },
    { 0xFF585CB9, "obj_tall_grass_stealth" },
    { 0x37F86CDF, "obj_tank" },
    { 0xA6EEE1FC, "obj_target" },
    { 0xC88DDE36, "obj_text" },
    { 0xDC0F983A, "obj_tiger_complete" },
    { 0x0794C24E, "obj_to_steiner_office" },
    { 0x7780793F, "obj_town_assault_complete" },
    { 0x0516AB43, "obj_town_complete" },
    { 0xF98A2A41, "obj_town_hold_complete" },
    { 0x3300099F, "obj_trenches_with_woods_complete" },
    { 0xCF958718, "obj_trenchrun_1" },
    { 0x419CF653, "obj_trenchrun_2" },
    { 0x1B9A7BEA, "obj_trenchrun_3" },
    { 0x8DA1EB25, "obj_trenchrun_4" },
    { 0x340CCE5F, "obj_trespasser" },
    { 0x134CD475, "obj_trig" },
    { 0x05E72D25, "obj_trigger" },
    { 0x1D1E6134, "obj_triggers" },
    { 0xD557E7EB, "obj_truck_depot" },
    { 0x2DE0712B, "obj_truck_depot_complete" },
    { 0x7D7F2A99, "obj_tutorial" },
    { 0x9CC13DE0, "obj_upload_the_abort_codes" },
    { 0xAD87864B, "obj_war_room" },
    { 0x0093B947, "obj_weapon" },
    { 0xAC7205D6, "obj_which_way_to_control_room" },
    { 0x5619F30B, "obj_wingsuit_land" },
    { 0x471AA8B7, "obj_yard_complete" },
    { 0x361BE786, "obj_zipline" },
    { 0x2D6866B2, "obj_zoff" },
    { 0xAA908C02, "objecive" },
    { 0x09E455A4, "object" },
    { 0x7CEC3F45, "object1" },
    { 0xA2EEB9AE, "object2" },
    { 0xC847F113, "object_animation" },
    { 0x295B277F, "object_anims" },
    { 0x5DF82689, "object_fire_notify" },
    { 0x115B4279, "object_highlight" },
    { 0x91757A6E, "object_is_on_bus" },
    { 0x1E452B6A, "object_is_on_elevator" },
    { 0x455DAF61, "object_origin" },
    { 0xB7331FBD, "object_touching_lava" },
    { 0xAD3FE293, "objectarray" },
    { 0xFEFA1259, "objectarray_size" },
    { 0x38D7CA88, "objectdest" },
    { 0x948D9343, "objectforward" },
    { 0x917C55D5, "objectified" },
    { 0x4AEA09BE, "objectifying" },
    { 0xA67DB03E, "objective" },
    { 0x060F5B45, "objective_2" },
    { 0xFA67BBE8, "objective_aa_gun" },
    { 0x123CE586, "objective_aa_gun_complete" },
    { 0x42BD3D1E, "objective_add" },
    { 0xA667DFE1, "objective_add_done" },
    { 0x2ADC93FD, "objective_add_new" },
    { 0xAFAB8F6A, "objective_add_team" },
    { 0x9C420285, "objective_additionalcurrent" },
    { 0xB608E4EB, "objective_additionalposition" },
    { 0xE81BC454, "objective_approach_radar" },
    { 0x70A5BF52, "objective_bp2_exit" },
    { 0x6FFF75B6, "objective_breadcrumb" },
    { 0xDF0F0B7E, "objective_breadcrumb_area" },
    { 0x12C988B7, "objective_breadcrumb_to_salazar" },
    { 0xFE83F62E, "objective_check_objectives" },
    { 0xB0E6A9FE, "objective_choose" },
    { 0xF8D43909, "objective_clearall" },
    { 0xDC9790A1, "objective_clearentity" },
    { 0x38BF5CF5, "objective_clearplayerusing" },
    { 0x51A1C394, "objective_complete" },
    { 0x576B9760, "objective_control" },
    { 0x92DEB709, "objective_controller" },
    { 0x414BBE4B, "objective_created" },
    { 0x3C3FF060, "objective_current" },
    { 0x0E80212D, "objective_damage_snd_loopers" },
    { 0x175537EF, "objective_damage_warning" },
    { 0xC5705764, "objective_delete" },
    { 0xA749D662, "objective_detonators" },
    { 0x41028877, "objective_event" },
    { 0x318C9324, "objective_event_init" },
    { 0x7D9AFF43, "objective_f35_hint" },
    { 0x452F5127, "objective_facing_bonus" },
    { 0x8ABA317F, "objective_flag_at_base" },
    { 0xB6E16DB0, "objective_flag_away" },
    { 0x4747DA8C, "objective_flag_defused" },
    { 0x2985A6FB, "objective_flag_normal" },
    { 0xA61686FA, "objective_flag_planted" },
    { 0x183CA8D2, "objective_flag_return_score_dist" },
    { 0x35754311, "objective_flag_target" },
    { 0x9DA54B6C, "objective_follow_barnes_custom" },
    { 0xCDA5A5DC, "objective_follow_ent" },
    { 0x65F3C1A3, "objective_follow_me" },
    { 0x9F33DE30, "objective_follow_salazar_active" },
    { 0x12D791EE, "objective_follow_target" },
    { 0xAF0E4A8D, "objective_getgamemodeflags" },
    { 0xF3A5ED10, "objective_goto_obstacle_course" },
    { 0xD16790C4, "objective_goto_oc_or_tents" },
    { 0x53352F2B, "objective_goto_wall" },
    { 0x4414CE1A, "objective_grab_thompson" },
    { 0x615A6F07, "objective_ground_attack_add" },
    { 0x8D855DAF, "objective_hallway_breadcrumb" },
    { 0x1577FD55, "objective_hints" },
    { 0x98125A5A, "objective_icon" },
    { 0x46805BA6, "objective_id" },
    { 0x1D2359D9, "objective_ids" },
    { 0xD093678F, "objective_index" },
    { 0xB665D952, "objective_is_active" },
    { 0x2CC73A2F, "objective_is_inactive" },
    { 0x86FE7680, "objective_lab_3" },
    { 0x910FCF5F, "objective_lab_4" },
    { 0x7271D4D9, "objective_laptop" },
    { 0x867C5E0A, "objective_laptop_nag" },
    { 0xE306EC38, "objective_location" },
    { 0xAEC9079B, "objective_lz" },
    { 0xB61FDB5A, "objective_main" },
    { 0xDC559297, "objective_marker" },
    { 0x2C9AD68F, "objective_marker_all" },
    { 0xA3292374, "objective_marker_all_safety" },
    { 0x9CA191BF, "objective_markers_set" },
    { 0xEA1C4E11, "objective_minigun_baglimit_done" },
    { 0x2043CC44, "objective_model" },
    { 0x0A74DA86, "objective_monitor_death" },
    { 0xF01FE910, "objective_monitor_endon" },
    { 0xF9DCB832, "objective_mortar_update" },
    { 0x2F3892B2, "objective_move" },
    { 0x599F69C1, "objective_move_" },
    { 0x0331EBA4, "objective_name" },
    { 0x2ECD493D, "objective_node" },
    { 0xD766A037, "objective_num" },
    { 0xD62A92CA, "objective_number" },
    { 0xCE23D7D2, "objective_obstacle_course" },
    { 0xD9AD82C5, "objective_on_door" },
    { 0x85A7D234, "objective_on_friendly" },
    { 0xECD04E5B, "objective_onentity" },
    { 0x7E1DE7BD, "objective_player_uses_minigun" },
    { 0x79C2051D, "objective_pos" },
    { 0x2C3653A3, "objective_pos_update" },
    { 0x0E8FF844, "objective_position" },
    { 0xD0762A18, "objective_position_update" },
    { 0xC32235F7, "objective_positions" },
    { 0x064CD038, "objective_price" },
    { 0xED0D7E34, "objective_price_orders_minigun" },
    { 0x4C8A081F, "objective_printtext" },
    { 0x8078BEF2, "objective_queue" },
    { 0xCFAAC4C6, "objective_register" },
    { 0x4FA40DE3, "objective_ring" },
    { 0x4F2C1302, "objective_run_endurance" },
    { 0x4CCBE3A6, "objective_set3d" },
    { 0x13F53F98, "objective_set3d_prethink" },
    { 0xBFEAC9B8, "objective_setcolor" },
    { 0x47646DA5, "objective_setflag" },
    { 0x73ACA9B9, "objective_setgamemodeflags" },
    { 0xDB6CC700, "objective_seticon" },
    { 0x15ED5F43, "objective_seticonsize" },
    { 0xDAEBB750, "objective_setinvisibletoall" },
    { 0xE09B765C, "objective_setinvisibletoplayer" },
    { 0xF76ABA7C, "objective_setplayerusing" },
    { 0x2AC014C2, "objective_setprogress" },
    { 0x18B56CF9, "objective_setvisibletoall" },
    { 0xFE955F9F, "objective_setvisibletoplayer" },
    { 0x27DA9846, "objective_shoot_canister" },
    { 0x0123643E, "objective_shutdown_thread" },
    { 0x4F7BDB52, "objective_size" },
    { 0x1D4406B1, "objective_squad" },
    { 0x4A508D0A, "objective_stars_on_tanks" },
    { 0x9B109821, "objective_start_tower" },
    { 0x2524C620, "objective_state" },
    { 0xC0074F6D, "objective_stinger" },
    { 0x5BC63373, "objective_stop_following_ent" },
    { 0x18A2B50A, "objective_stopwatch" },
    { 0x8BFA172E, "objective_string" },
    { 0x630E0DD9, "objective_string_nomessage" },
    { 0x59EA7416, "objective_target" },
    { 0xF5E3FECA, "objective_team" },
    { 0x43F9E668, "objective_text" },
    { 0x6FF13C71, "objective_text1" },
    { 0x95F3B6DA, "objective_text2" },
    { 0x27146CB2, "objective_text_array" },
    { 0x46CF12C3, "objective_trigger" },
    { 0x57F79696, "objective_triggered_complete" },
    { 0xD8CAA012, "objective_triggered_update_position" },
    { 0xB580FC95, "objective_type" },
    { 0x14B488A2, "objective_update_player_armed" },
    { 0x1EADD247, "objective_updatenextwaypoints" },
    { 0x83AC4011, "objective_visibleteams" },
    { 0x0F3509C1, "objectiveanchor" },
    { 0xF593CC56, "objectiveclackers" },
    { 0xC5A0C988, "objectivecompassfx" },
    { 0x3332E802, "objectivecreator" },
    { 0xA980D95C, "objectivefx" },
    { 0x840F75D4, "objectivehintcapturehq" },
    { 0x3D31C207, "objectivehintcapturezone" },
    { 0xE26708B0, "objectivehintdefendhq" },
    { 0xE749F90C, "objectivehintdestroyhq" },
    { 0x11F436F7, "objectivehintpreparehq" },
    { 0x739D2E64, "objectivehintpreparezone" },
    { 0x79F5C705, "objectiveid" },
    { 0x76D1EC1A, "objectiveindex" },
    { 0x402CB287, "objectiveindicatornodrawdistance" },
    { 0x659BCAE6, "objectiveisallowed" },
    { 0x52A5FB13, "objectivekey" },
    { 0x30FF5083, "objectivename" },
    { 0x512855A6, "objectivenum" },
    { 0xE46D6CEC, "objectiveonvisuals" },
    { 0x30B871EF, "objectivepingdelay" },
    { 0xB950C57E, "objectivepositionentity" },
    { 0xD0EF8521, "objectives" },
    { 0xFE6C2C97, "objectives_bp1" },
    { 0x8C64BD5C, "objectives_bp2" },
    { 0x8673C4F3, "objectives_bp2_cache" },
    { 0xB26737C5, "objectives_bp3" },
    { 0x00D4E67A, "objectives_capture" },
    { 0x1218E0F4, "objectives_drone_control" },
    { 0xDF23F99F, "objectives_firehorse" },
    { 0xB53ABF33, "objectives_for_attacker_and_victim_only" },
    { 0x25654C93, "objectives_hijacked" },
    { 0x1C2AE7BA, "objectives_intro" },
    { 0x190FEDF9, "objectives_lab" },
    { 0x78EBBF0C, "objectives_morals" },
    { 0x611AA607, "objectives_morals_rail" },
    { 0x9A0F10A2, "objectives_morals_rail_skipped" },
    { 0x93AECC8D, "objectives_ruins" },
    { 0x9179FFB9, "objectives_skip" },
    { 0xFC36CD5D, "objectives_tunnels" },
    { 0xA29D1E66, "objectives_wave3" },
    { 0xE490BA59, "objectives_wave4" },
    { 0x8EA607A0, "objectives_zhao_bp1" },
    { 0xCB7B175E, "objectivetype" },
    { 0x22967858, "objectivs" },
    { 0x485299D7, "objects" },
    { 0xF31B013C, "objects_fullahead" },
    { 0x976714D8, "objects_to_vectors" },
    { 0xCCBC569E, "objectsinworld" },
    { 0x09AE0A79, "objectsolid" },
    { 0x442FF0A3, "objectve" },
    { 0xCD72549C, "objectwatcher" },
    { 0x1C435CED, "objentity" },
    { 0x4745778B, "objetive" },
    { 0xA93433B5, "objgroup" },
    { 0x815C9BAB, "objid" },
    { 0x16CAAA11, "objidallies" },
    { 0xD4A30838, "objidaxis" },
    { 0x506ECD99, "objidpingenemy" },
    { 0x68089D22, "objidpingfriendly" },
    { 0xCC445ED1, "objidstart" },
    { 0xA707AD06, "objloc" },
    { 0x1A25982D, "objname" },
    { 0x9ED0B9BC, "objnum" },
    { 0x25C5C441, "objpingdelay" },
    { 0x3611766E, "objpoint" },
    { 0xEA01BD85, "objpoint_alpha_default" },
    { 0xE3C881A2, "objpointnames" },
    { 0x46413591, "objpoints" },
    { 0x1E60668B, "objpoints_shared" },
    { 0x7C955370, "objpointscale" },
    { 0xE15D7D39, "objpointsize" },
    { 0xF1EFF360, "objremaining" },
    { 0x4FB7E3CF, "objs" },
    { 0xB125A59B, "objstate" },
    { 0x6969101F, "objstring" },
    { 0x82B5F8A9, "objtext" },
    { 0xBA0A3F5F, "objtime" },
    { 0x3D09EB33, "oblivious" },
    { 0xAD1382FD, "obs" },
    { 0x2FF8BEF6, "obscure" },
    { 0xB37C94E9, "obscures" },
    { 0x4ADBA605, "observation" },
    { 0xD5B6F487, "observation_gaz_convoy_delete" },
    { 0x1AD4DCEE, "observation_gaz_convoy_start" },
    { 0x46B8476B, "observe" },
    { 0x96D309F5, "observed" },
    { 0xEB7922CE, "observing" },
    { 0xE50FB6CE, "obsession" },
    { 0xD07C3C0D, "obsolesence" },
    { 0x20610E60, "obsolete" },
    { 0x009B83D7, "obsolete_prompt_format_needed" },
    { 0x663F523A, "obstacle" },
    { 0x6EE83233, "obstacle_start" },
    { 0xC1A251BF, "obstacle_training" },
    { 0xEA7237B5, "obstacles" },
    { 0x171756D5, "obstacletraining_buddies" },
    { 0x3B85766F, "obstacletraining_dialog" },
    { 0x4A0CF242, "obstacletraining_end" },
    { 0x6507D5B9, "obstacletraining_start" },
    { 0x638CF30D, "obstacletrainingcoursethink" },
    { 0xC70C6AD6, "obstructed" },
    { 0x672A7D74, "obstructions" },
    { 0x731FEA4A, "obtain" },
    { 0xFD210FDD, "obtained" },
    { 0x1F8BD4A6, "obtaining" },
    { 0xFF13B185, "obtains" },
    { 0x4B8A3ED8, "obvious" },
    { 0xA94B1ADD, "obviously" },
    { 0xE3C94EDB, "oc" },
    { 0x393AD4D3, "oc_aa_targ" },
    { 0xD5E35F8D, "oc_accuracy" },
    { 0x986DC89B, "oc_complete" },
    { 0xAD768505, "oc_completed_str" },
    { 0xC65ACD0A, "oc_death_array" },
    { 0xC3DB3F5A, "oc_end_results" },
    { 0xEB670D5B, "oc_end_time" },
    { 0x55203AA1, "oc_move_trigs" },
    { 0xA22002AC, "oc_nade_str" },
    { 0x5C876296, "oc_nade_target_penalty" },
    { 0xBF8B2CC2, "oc_nade_targets_remaining" },
    { 0xEA33426C, "oc_nade_triggers" },
    { 0xA2B72428, "oc_node_array" },
    { 0x8D1B2308, "oc_od_node_array" },
    { 0x91A253F0, "oc_p_targ_angles" },
    { 0x14E1F4C8, "oc_pop_targets" },
    { 0xFD7E6BF5, "oc_prev_str" },
    { 0x222D9D1C, "oc_ready_to_start" },
    { 0x7248872F, "oc_restart" },
    { 0x406758A3, "oc_running" },
    { 0x01632BFA, "oc_start_time" },
    { 0xDE052A6A, "oc_targ_str" },
    { 0xF8DADFC3, "oc_target_penalty" },
    { 0x60B06CC0, "oc_targets" },
    { 0x5023D0F1, "oc_targets_remaining" },
    { 0x0613A809, "oc_time" },
    { 0xFA06F5E7, "oc_time_completed" },
    { 0xACD70369, "oc_timer" },
    { 0x35B636BF, "oc_timer_time" },
    { 0x7848AA6C, "oc_total_str" },
    { 0xDBE94057, "oc_total_targets" },
    { 0x1CC91910, "oc_total_time" },
    { 0xDEC91F8D, "occasianal" },
    { 0xA9737D0B, "occasional" },
    { 0x91F716D6, "occasionally" },
    { 0x7C6AF01C, "occational_reaction" },
    { 0x22A95382, "occlude" },
    { 0x09C576D8, "occlude_off" },
    { 0xB7AD2212, "occlude_on" },
    { 0x3AD3D922, "occluded" },
    { 0x26B12764, "occluder" },
    { 0x5FFDFF97, "occluders" },
    { 0xD65C9E73, "occluding" },
    { 0x22943AD0, "occlusion" },
    { 0xCD2D5000, "occlusion_loop_test" },
    { 0x5C344967, "occlusion_test" },
    { 0x7CF3F240, "occulded" },
    { 0x694104EC, "occupant" },
    { 0x4363F9C0, "occupant_team" },
    { 0xF2BDBE6B, "occupantent" },
    { 0x6DB0FAB0, "occupantkeys" },
    { 0x2E9BEDEF, "occupants" },
    { 0x14742EE8, "occupation" },
    { 0x1049238D, "occupied" },
    { 0xF3B76717, "occupied_nodes" },
    { 0xC895EE52, "occupied_zone" },
    { 0xA8A6E324, "occupiedpoints" },
    { 0xFE695AE2, "occupies" },
    { 0x2DD95085, "occupies_colorcode" },
    { 0x3C3EE173, "occuppied" },
    { 0xEA24EECC, "occupy_no_target_time" },
    { 0xB8DC2A6E, "occupy_time" },
    { 0xAD6E5A47, "occupy_volume" },
    { 0x602756E6, "occupying" },
    { 0xF659600B, "occur" },
    { 0xBECAAB46, "occurance" },
    { 0xC6538940, "occured" },
    { 0x97136B55, "occuring" },
    { 0x4F003988, "occurred" },
    { 0x47495405, "occurrences" },
    { 0x62D60ACD, "occurring" },
    { 0x202B9F6A, "occurs" },
    { 0xD21ED605, "occurs_on_death" },
    { 0xA946BC89, "ocean" },
    { 0x0620FD17, "ocean_emitter_start" },
    { 0x950AF6AB, "ocean_ent_1" },
    { 0x23038770, "ocean_ent_2" },
    { 0x0858A671, "ocean_sound_emitters" },
    { 0x76325AC2, "oclock" },
    { 0x1A8C5DC7, "octo_gib" },
    { 0x15C31508, "octobomb" },
    { 0xA579E2FB, "octobomb_attack_callback" },
    { 0xBC88D0F9, "octobomb_attract_dist" },
    { 0x9D3F923D, "octobomb_attract_dist_custom" },
    { 0x76874E09, "octobomb_cleanup" },
    { 0x115C6695, "octobomb_damage_growth_duration" },
    { 0xCD0FD710, "octobomb_damage_interval" },
    { 0x4AE85511, "octobomb_damage_radius" },
    { 0xE7051B24, "octobomb_damage_tick" },
    { 0x749000A4, "octobomb_damage_time" },
    { 0x60DF0CFD, "octobomb_devgui" },
    { 0x4FFAEBC7, "octobomb_exists" },
    { 0x0736DB89, "octobomb_fx" },
    { 0xE53A7954, "octobomb_give" },
    { 0x297AC88E, "octobomb_grab_max_time" },
    { 0xEE688EB0, "octobomb_grab_min_time" },
    { 0xE5ED6332, "octobomb_grab_radius" },
    { 0x0E653671, "octobomb_index" },
    { 0xFDA76A9B, "octobomb_infected" },
    { 0x3C64BC4B, "octobomb_parasite_attract_radius" },
    { 0x04C8FEF6, "octobomb_spit_fx" },
    { 0xA034A6B1, "octobomb_spit_fx_and_cleanup" },
    { 0xF9535D61, "octobomb_spore_fx_on" },
    { 0x24497E56, "octobomb_spores_fx" },
    { 0xCF277073, "octobomb_targets" },
    { 0x2CF689F4, "octobomb_tentacle_hit_fx" },
    { 0x8DDC7BE3, "octobomb_ug_damage_tick" },
    { 0x82B66F15, "octobomb_ug_grab_max_time" },
    { 0x13D7CA87, "octobomb_ug_grab_min_time" },
    { 0x2378F850, "octobomb_zombie_explode_fx" },
    { 0x9BAA9723, "octobombs" },
    { 0x160F0A93, "octos" },
    { 0x09CBC944, "od" },
    { 0xF45327EC, "od_green_aug" },
    { 0x982ED323, "odamage" },
    { 0xD8133988, "odd" },
    { 0xD4C7EA51, "oddlike" },
    { 0xFFD40CA3, "odds" },
    { 0x2F5AC19C, "odysseus" },
    { 0xB97AB101, "odyssey" },
    { 0x2FCE43AD, "oe" },
    { 0xB16B83D6, "oed_sitrepscan_enable" },
    { 0x6C501BF0, "oed_sitrepscan_setdesat" },
    { 0x13F17361, "oed_sitrepscan_setfalloff" },
    { 0x449E9025, "oed_sitrepscan_setlinewidth" },
    { 0x9B098331, "oed_sitrepscan_setoutline" },
    { 0x4DCDAE87, "oed_sitrepscan_setradius" },
    { 0x137C01BE, "oed_sitrepscan_setsolid" },
    { 0xF7D3B1A0, "oerlikon_1" },
    { 0xA59CF3CB, "oerlikon_1_barrel" },
    { 0x69DB20DB, "oerlikon_2" },
    { 0xA309C72E, "oerlikon_2_barrel" },
    { 0x43D8A672, "oerlikon_3" },
    { 0x63C3C061, "oerlikon_3_barrel" },
    { 0xB5E015AD, "oerlikon_4" },
    { 0xD07E8B4C, "oerlikon_4_barrel" },
    { 0x8FDD9B44, "oerlikon_5" },
    { 0xFFC9FC0F, "oerlikon_5_barrel" },
    { 0x01E50A7F, "oerlikon_6" },
    { 0x56CAD932, "oerlikon_6_barrel" },
    { 0xDBE29016, "oerlikon_7" },
    { 0x88F5E965, "oerlikon_7_barrel" },
    { 0x4DE9FF51, "oerlikon_8" },
    { 0xE2D39CE0, "oerlikon_8_barrel" },
    { 0x27E784E8, "oerlikon_9" },
    { 0x87A0F4E3, "oerlikon_9_barrel" },
    { 0xBF2057BF, "oerlikons" },
    { 0x55D0BE16, "of" },
    { 0xB950E454, "off" },
    { 0x94819135, "off1" },
    { 0x4FF88DFE, "off1_dialog_and_sound" },
    { 0x3C07CE79, "off_after_seconds" },
    { 0x2462F31F, "off_cliff" },
    { 0xF6D0BD7A, "off_frst_walla" },
    { 0xF59666B6, "off_horse" },
    { 0x51D0008A, "off_model" },
    { 0xEAA97957, "off_pos" },
    { 0x5128735E, "off_screens" },
    { 0x51AA299B, "off_the_bus" },
    { 0xC4567D7E, "off_the_hook" },
    { 0x5EB6CE6C, "off_triggers" },
    { 0x3CC913F9, "off_version" },
    { 0xB9E5B708, "offchance" },
    { 0x0A7407FE, "offendedflag" },
    { 0x2F77DAFE, "offender" },
    { 0x57D14AFD, "offending" },
    { 0xDE585812, "offends" },
    { 0xD28AC879, "offense" },
    { 0xFA0BE675, "offenseglobalcount" },
    { 0x282E839B, "offenseorderdialog" },
    { 0xC6AD4950, "offenseorderdialogkey" },
    { 0xF67F7F4F, "offenseradiussq" },
    { 0x174A80B0, "offenses" },
    { 0x4A3DDCF1, "offer" },
    { 0x6DB5279E, "offered" },
    { 0xA2623B57, "offering" },
    { 0x7D951F58, "offers" },
    { 0x090F120C, "offest" },
    { 0x63A84902, "offfset" },
    { 0xE18C3B47, "offhand" },
    { 0xA0A06075, "offhand_weapon_give_override" },
    { 0x3FAACE81, "offhand_weapon_overrride" },
    { 0x872E164D, "offhand_weapons" },
    { 0x25B081B2, "offhand_weapons_and_alts" },
    { 0x83C62455, "offhandclass" },
    { 0xC4BD3923, "offhandprimary" },
    { 0x5CB4556B, "offhandslot" },
    { 0xC5A628F6, "offhandspecialbuttonpressed" },
    { 0x3626F470, "offhigh" },
    { 0x18E75869, "office" },
    { 0x2781C54C, "office_building" },
    { 0x60215925, "office_building_entry_vo" },
    { 0x877362E8, "office_crawler_1" },
    { 0xF97AD223, "office_crawler_2" },
    { 0xD37857BA, "office_crawler_3" },
    { 0xEF50DAA7, "office_crawlers" },
    { 0x58DED6CE, "office_double_door_left" },
    { 0xE4505485, "office_double_door_right" },
    { 0xBE9BAD3D, "office_ending_vo" },
    { 0x6D56B484, "office_fog_settings" },
    { 0x117C0BBB, "office_guys_retreat_inside" },
    { 0xF17FFD02, "office_intro" },
    { 0xCAD81E81, "office_light_models" },
    { 0xC0457CA2, "office_line" },
    { 0xF9B15EAF, "office_line_ai" },
    { 0x3799505A, "office_line_spawners" },
    { 0x43796856, "office_mason" },
    { 0x15A4508D, "office_mgs_threatbias" },
    { 0x0F35BC1B, "office_objective_update" },
    { 0x715C82EF, "office_panzers_target_tanks" },
    { 0x803DD5A2, "office_player_body" },
    { 0x031C749F, "office_redshirt2" },
    { 0x5C7B5FF6, "office_redshirts" },
    { 0x8AF35603, "office_single_door" },
    { 0xC753B5FE, "office_success_hudson_vo1" },
    { 0xA1513B95, "office_success_hudson_vo2" },
    { 0x7B4EC12C, "office_success_hudson_vo3" },
    { 0x554C46C3, "office_success_hudson_vo4" },
    { 0x45B9E44A, "office_trig" },
    { 0xFFD5D718, "office_trigger" },
    { 0x6FBA4685, "office_wall_crumble" },
    { 0x31F17949, "officer" },
    { 0xD71C7233, "officer_2tank_safely" },
    { 0x883BFBB6, "officer_assistant_setup" },
    { 0x712FE4EE, "officer_dead" },
    { 0xBCF87352, "officer_death" },
    { 0xFB8A9828, "officer_enemy" },
    { 0x33E895C0, "officer_health_back" },
    { 0x9973C821, "officer_incar" },
    { 0x947E43CA, "officer_last_run" },
    { 0xE3EFA7BA, "officer_ride" },
    { 0x39D23E7A, "officer_roof_destroyed" },
    { 0xA61660E4, "officer_roof_intact" },
    { 0x46742673, "officer_run" },
    { 0x6A5AD28F, "officer_run_cycles" },
    { 0x5A5324B9, "officer_running" },
    { 0x5499E538, "officer_runto_cover" },
    { 0x45D5BD23, "officer_setup" },
    { 0xC9DE3704, "officer_shot_incar" },
    { 0x8579489A, "officer_sr_dialog" },
    { 0x169A6AB6, "officercount" },
    { 0x269F8493, "officerfrozen_spawnfunction" },
    { 0x15D43CDA, "officerid" },
    { 0xBA3F2617, "officeronly" },
    { 0xD6422540, "officers" },
    { 0x72CB1A5A, "officers_sniper" },
    { 0xB0221A0E, "officers_sniper_move" },
    { 0x05CA8F5C, "officers_sniper_run" },
    { 0x3616773C, "officers_sniper_setup" },
    { 0x2C13C6DB, "officers_sniper_shoot_atyou" },
    { 0x5B1F12D7, "officers_sniper_snipeu" },
    { 0xFC760D96, "officersonly" },
    { 0x3DDC0B87, "officerwaiter" },
    { 0x0BEEFEE0, "offices" },
    { 0x06183421, "offices_cleared" },
    { 0x3916C5B2, "offidle" },
    { 0xE55B717A, "offline" },
    { 0x1314CE1F, "offline_class" },
    { 0x5E1CE9E6, "offline_class_datatable" },
    { 0x124E730D, "offline_classtable" },
    { 0x4E8DB52D, "offload_muj" },
    { 0x21CF1255, "offload_spawner" },
    { 0x16BDC8DB, "offloadfadein" },
    { 0xC149454E, "offloadfadeout" },
    { 0xB8A903A5, "offloadprint" },
    { 0x8170D72A, "offlow" },
    { 0x9A90882A, "offmid" },
    { 0x8BCA9C8B, "offmodel" },
    { 0xB9906C98, "offnote" },
    { 0x78834624, "offramp" },
    { 0xFF7CDA4A, "offramp_lapd" },
    { 0x4B405E3C, "offramp_speed" },
    { 0xE923A0DE, "offramp_speed_decel_time" },
    { 0x69E44A72, "offramp_vo" },
    { 0x5FE7EBC7, "offs" },
    { 0x45296D68, "offscreen" },
    { 0x9EA7EA88, "offscreen_filter_set" },
    { 0x8B1C6E18, "offscreen_shader" },
    { 0xEDF6AF2B, "offscreenshader" },
    { 0xA4E8111C, "offset" },
    { 0xBADE75CD, "offset1" },
    { 0xE0E0F036, "offset2" },
    { 0x90735BC6, "offset2d" },
    { 0x1EA7A189, "offset3d" },
    { 0xEA0EFFD1, "offset_3d_pos" },
    { 0x96F7C867, "offset_amount" },
    { 0x5C8881A5, "offset_ang" },
    { 0x99DF81D4, "offset_angle" },
    { 0x6185CF20, "offset_dir" },
    { 0xA17F95C2, "offset_end" },
    { 0x4157EF32, "offset_ent" },
    { 0x3A2367AF, "offset_f" },
    { 0xE1F2A35A, "offset_forward" },
    { 0x41C130A3, "offset_fx_struct" },
    { 0xFFA64A1A, "offset_noteworthy" },
    { 0xFAC60F17, "offset_org" },
    { 0x8EB377B9, "offset_origin" },
    { 0x5036E311, "offset_point_generator" },
    { 0x41F1D77B, "offset_r" },
    { 0x837B290B, "offset_right" },
    { 0xDF73CFFF, "offset_scale" },
    { 0x2BF7E539, "offset_start" },
    { 0x26D3BE7E, "offset_struct_name" },
    { 0x67F451E4, "offset_u" },
    { 0x2AB277DC, "offset_up" },
    { 0x984A99BB, "offset_vec" },
    { 0x7BA7578A, "offset_vector" },
    { 0xFE96C785, "offset_world" },
    { 0x2600B5F1, "offset_x" },
    { 0xFFFE3B88, "offset_y" },
    { 0x7205AAC3, "offset_z" },
    { 0x854E631D, "offsetangle" },
    { 0x2674255C, "offsetangles" },
    { 0x1186F791, "offsetdir" },
    { 0xE1C2962C, "offsetdist" },
    { 0x5DA9529F, "offsetdw" },
    { 0x089879D1, "offsetfactorpitch" },
    { 0xA2C1ED4E, "offsetfactoryaw" },
    { 0xB7C50181, "offsetfrommodelorigin" },
    { 0xF75994C5, "offsetheight" },
    { 0x23C0A1C8, "offsetinc" },
    { 0x7E34FA53, "offsetmodel" },
    { 0x09CA73CC, "offsetnum" },
    { 0xF1F0CFBA, "offsetorigin" },
    { 0x6001CF1E, "offsetpoint" },
    { 0x9B9603FA, "offsetpos" },
    { 0xE8F904B7, "offsetreduction" },
    { 0x8644D05F, "offsets" },
    { 0xE4B16157, "offsetsize" },
    { 0x5F1BEF13, "offsetted" },
    { 0xC88582D4, "offsetthrow" },
    { 0x852D8D8F, "offsettime" },
    { 0x3C7E9356, "offsettimes" },
    { 0xFEC7B798, "offsetting" },
    { 0xD9981A85, "offsettoorigin" },
    { 0x0C9E642A, "offsetvec" },
    { 0x4451346C, "offsetx" },
    { 0x6A90DF3C, "offsetx_pass" },
    { 0x6A53AED5, "offsety" },
    { 0x28665EE3, "offsety_pass" },
    { 0x9056293E, "offsetz" },
    { 0xF77D0D76, "offsetz_pass" },
    { 0xA5857BD1, "offshoot" },
    { 0x4F8055D3, "offshoot_ent" },
    { 0x589846B7, "offshooting" },
    { 0xC3B11211, "ofplayer" },
    { 0xEFE21873, "often" },
    { 0x7BD3387F, "og" },
    { 0xB19F22D1, "og_aimspot" },
    { 0x77E5903E, "og_ang" },
    { 0xE6478996, "og_angles" },
    { 0x326EEFBC, "og_animname" },
    { 0x3EA4C03F, "og_clamp" },
    { 0x52647B7B, "og_delaytime_max" },
    { 0x67832315, "og_delaytime_min" },
    { 0xACE64438, "og_forcecolor" },
    { 0x13D0597B, "og_fov" },
    { 0x0D6E3272, "og_goalheight" },
    { 0xAE6BBB8D, "og_goalradius" },
    { 0xE03552AE, "og_grenadeammo" },
    { 0xAD1F4643, "og_grenadeawareness" },
    { 0x24469E48, "og_grenadeweapon" },
    { 0xABFB5B64, "og_health" },
    { 0x470AEEF1, "og_interval" },
    { 0xE2E591F2, "og_jog_anim" },
    { 0x08166814, "og_org" },
    { 0x04F4B8A8, "og_origin" },
    { 0x0F2C2C31, "og_pathenemyfightdist" },
    { 0x1AD22193, "og_pathenemylookahead" },
    { 0xDD2EC694, "og_radius" },
    { 0x7879F904, "og_scale" },
    { 0xD7C8A3D7, "og_shoottime_max" },
    { 0xBCD37829, "og_shoottime_min" },
    { 0xC8021DD5, "og_spawners" },
    { 0x10A17D87, "og_start_origin" },
    { 0x1F17548D, "og_target" },
    { 0x265B3B19, "og_target_fov" },
    { 0x0C8036E4, "og_time_inc" },
    { 0x81F8531A, "og_weapon" },
    { 0x9C911AA6, "og_x" },
    { 0xC293950F, "og_y" },
    { 0x9A0F9863, "og_yaw" },
    { 0x508C25D4, "og_z" },
    { 0x7F05EF89, "oganimname" },
    { 0xF24F5BFB, "oggrenadeweapon" },
    { 0x5537719E, "ogintensity" },
    { 0x7DFD269A, "ogtimescale" },
    { 0xA1D5B2E8, "oh" },
    { 0x0B207829, "oh_shit" },
    { 0xF5232ADF, "oh_shit_vo_cooldown" },
    { 0xFB267AFB, "oh_shit_vox" },
    { 0xC7D82D51, "oi" },
    { 0x421EC2C0, "oic_rules" },
    { 0x9333543F, "oil" },
    { 0xDCE368D2, "oil_lamp_power" },
    { 0x1652DD54, "oil_spill_burn" },
    { 0x33440057, "oil_spill_burn_after" },
    { 0xC2B49EE8, "oil_spill_burn_section" },
    { 0x355F8945, "oil_spill_think" },
    { 0x4BAB9A1D, "oil_tanks" },
    { 0x6B1DF401, "oillamp" },
    { 0x819875D7, "oilspill" },
    { 0x53346443, "oiltank_small" },
    { 0x433A7AA9, "oiltankexpsound" },
    { 0x3171FE2A, "oiltanks" },
    { 0x4EB2C502, "oiltanksmallexpsound" },
    { 0x13DD2223, "ok" },
    { 0xD94C930A, "ok_remove" },
    { 0xC8A2D3A9, "ok_talking_now" },
    { 0xE94608A6, "ok_to_gib" },
    { 0xEDE5CA18, "ok_to_possess" },
    { 0x46BE430D, "ok_to_spawn" },
    { 0x2ACB5F6C, "ok_to_trigger_spawn" },
    { 0x512E2431, "okay" },
    { 0xF140A725, "okay_if_friendlies_in_line_of_fire" },
    { 0xABCAA5B1, "okclasses" },
    { 0x9A737974, "oke" },
    { 0xD9DC6CE1, "oki1" },
    { 0xE6B7B26C, "oki1_amb" },
    { 0xCEBB3DD3, "oki1_anim" },
    { 0x6DBD7C94, "oki1_callbacks" },
    { 0x36B48336, "oki1_fx" },
    { 0x576D6182, "oki1_status" },
    { 0xFFDEE74A, "oki2" },
    { 0x69FC214B, "oki2_amb" },
    { 0x52AA2D9E, "oki2_anim" },
    { 0xDDBDB8A8, "oki2_art" },
    { 0xEAD8C76A, "oki2_base" },
    { 0x77431587, "oki2_callbacks" },
    { 0x78F47A2E, "oki2_cam" },
    { 0x735A88AA, "oki2_cave" },
    { 0x8A10364F, "oki2_cave_bigroom_pkg" },
    { 0x7469F5C2, "oki2_cave_bigroom_room" },
    { 0x41024A1F, "oki2_fx" },
    { 0x3FE335D1, "oki2_geo_callbacks" },
    { 0x50B53019, "oki2_gunbunkers" },
    { 0x2BD61B5D, "oki2_high" },
    { 0x4221F85F, "oki2_high_alt_int_room" },
    { 0x780527BE, "oki2_highalt_bunker" },
    { 0x78E3B95D, "oki2_highalt_bunker_pkg" },
    { 0xBD324CC3, "oki2_highalt_int_pkg" },
    { 0x885EDB02, "oki2_highalt_smallcave_pkg" },
    { 0x7328674D, "oki2_highalt_smallcave_room" },
    { 0xCF0742E7, "oki2_init" },
    { 0x2632F0B5, "oki2_objectives" },
    { 0x65CA7EEA, "oki2_radio_deadair_loop" },
    { 0xC2222795, "oki2_radio_transmission" },
    { 0x54FA7A25, "oki2_util" },
    { 0x25E161B3, "oki3" },
    { 0x88685715, "oki3_achievement_setup" },
    { 0x0ABFFF36, "oki3_amb" },
    { 0x42C26899, "oki3_anim" },
    { 0x6F3B81A5, "oki3_art" },
    { 0xC952EB35, "oki3_base" },
    { 0x1BD7AF5E, "oki3_callbacks" },
    { 0x66E62E13, "oki3_courtyard" },
    { 0xCB2BA51C, "oki3_dpad_asset" },
    { 0x7FA945AC, "oki3_fx" },
    { 0x396B7F79, "oki3_give_achievement" },
    { 0xE5A9A420, "oki3_grass_guy_achievement" },
    { 0xD3BEA611, "oki3_helmet_launch" },
    { 0xF260FE60, "oki3_indoor_pkg" },
    { 0xEFF5E823, "oki3_indoor_room" },
    { 0x5DFC9C99, "oki3_indooroutdoor" },
    { 0xA8C39ED0, "oki3_init" },
    { 0xB73E9C68, "oki3_outro_2" },
    { 0xDDB90D6D, "oki3_pop_helmet" },
    { 0x472D4CAB, "oki3_tree_snipers" },
    { 0x4E219EDA, "oki3_util" },
    { 0x3529DA33, "okinawa" },
    { 0x145D2E8D, "okiprint" },
    { 0xFEDCBFF1, "okish" },
    { 0x128322A4, "oktocleanup" },
    { 0x45E1F8BC, "oktofire" },
    { 0xE8B5F9E4, "oktomelee" },
    { 0x6AFFF6AD, "oktospawn" },
    { 0x39DF9C8C, "ol" },
    { 0x4EAA39A0, "old" },
    { 0xCC062603, "old_accel_state" },
    { 0xE8932214, "old_accuracy" },
    { 0x26C8F213, "old_aim_assist_min_target_distance" },
    { 0xD6C7F278, "old_aim_target_sentient_radius" },
    { 0x5CEB2BE7, "old_ambient_packages" },
    { 0xBF97EDB3, "old_amount" },
    { 0x38A1D6DB, "old_angles" },
    { 0x4A47F418, "old_anim" },
    { 0xFA5EF8CA, "old_anim_alertness" },
    { 0x0538CF98, "old_anim_movement" },
    { 0x1335C1B1, "old_animname" },
    { 0x18174B8A, "old_array" },
    { 0xE7632782, "old_awareness" },
    { 0x4689B75F, "old_baseaccuracy" },
    { 0xE13DA47A, "old_bg_viewkickmax" },
    { 0xA3D99964, "old_bg_viewkickmin" },
    { 0xBC170FF5, "old_bg_viewkickrandom" },
    { 0x82BB8A56, "old_bg_viewkickscale" },
    { 0x0E302494, "old_bias" },
    { 0xD329DC2C, "old_bias_number" },
    { 0xE89B5570, "old_bike" },
    { 0x62289EF4, "old_blend_time" },
    { 0xFE3533C1, "old_camera_angles" },
    { 0x85B85268, "old_camera_offset" },
    { 0x85EA03EB, "old_chest_index" },
    { 0x2C5792C1, "old_claimed_node" },
    { 0x6C547429, "old_color_trig" },
    { 0x2505DA3D, "old_combatrunanim" },
    { 0x313F9550, "old_cost" },
    { 0x582943E4, "old_count" },
    { 0x421ABB58, "old_curr_point" },
    { 0x0DB9CFCB, "old_cycle" },
    { 0x61C1DF88, "old_damage" },
    { 0xD2F5D11F, "old_destruct_state" },
    { 0x5E3FA3B3, "old_dist" },
    { 0x7AF1123E, "old_distance" },
    { 0xA19044A3, "old_dog_spawn" },
    { 0x8820FD0E, "old_dontfreeme" },
    { 0xF0D357C0, "old_dvar" },
    { 0xEE92EBEB, "old_dvars" },
    { 0xEF9B2809, "old_enemy" },
    { 0xF8697702, "old_far_blur" },
    { 0x3AF7DA78, "old_far_end" },
    { 0x342CB59B, "old_far_start" },
    { 0x082F0542, "old_fc" },
    { 0x36BFD9C9, "old_forcecolor" },
    { 0x4263AF8C, "old_fov" },
    { 0x2C94ABD4, "old_free_vehicle" },
    { 0xC3F087CA, "old_friendlies" },
    { 0x4F5EC328, "old_friendly_fire_dist" },
    { 0xA38167B3, "old_friendly_name_dist" },
    { 0x97D70A63, "old_friendly_wave_trigger" },
    { 0xB0EBEF4B, "old_friendlynamedist" },
    { 0xB218B791, "old_fx" },
    { 0xA9F44364, "old_gear_state" },
    { 0xE2782999, "old_gib_state" },
    { 0x8D4748FA, "old_goal" },
    { 0x48D23AD3, "old_goal_radius" },
    { 0xECB63C8C, "old_goalpos" },
    { 0x461BC424, "old_goalradius" },
    { 0xC377E166, "old_goalraidus" },
    { 0xC0A885E7, "old_gravity" },
    { 0x2320ED1D, "old_grenadeammo" },
    { 0xEA63132A, "old_grenadeawareness" },
    { 0xF611153C, "old_group" },
    { 0xAD024483, "old_guys" },
    { 0x79E37C05, "old_health" },
    { 0xC309DAC8, "old_health_overlay" },
    { 0xEA7330F4, "old_health_tier" },
    { 0xAEE11F71, "old_heat" },
    { 0x0ACD5B35, "old_heat_1" },
    { 0x30CFD59E, "old_heat_2" },
    { 0xE2DB2353, "old_hero" },
    { 0x3FDB7C64, "old_high_score" },
    { 0x5FFF6421, "old_huey1" },
    { 0x8601DE8A, "old_huey2" },
    { 0xAC0458F3, "old_huey3" },
    { 0x37105DDA, "old_ignoreall" },
    { 0x6A7B0A9F, "old_ignoreme" },
    { 0x0D8C340A, "old_infog" },
    { 0x2BAC4D16, "old_intensity" },
    { 0x18FC8270, "old_interval" },
    { 0xD91CA025, "old_inventory" },
    { 0xC6CE170F, "old_killstreak_quantity" },
    { 0x77F5DA98, "old_leaper_spawn" },
    { 0xB321CEE9, "old_lethal" },
    { 0xFF33B72B, "old_light_effect" },
    { 0xD5E45EAE, "old_light_status" },
    { 0xA32F9CBE, "old_man_woods" },
    { 0xEC453559, "old_man_woods_waittill_end" },
    { 0xA418911A, "old_manage_zones" },
    { 0xE4120FAC, "old_maxfaceenemydist" },
    { 0x9B1A5440, "old_maxfloattime" },
    { 0x9F94D419, "old_maxhealth" },
    { 0xA09DBF8C, "old_maxsightdistsqrd" },
    { 0x1A81B3AA, "old_mine" },
    { 0xE5091F66, "old_model" },
    { 0xB400A535, "old_moveplaybackrate" },
    { 0x2D51D815, "old_mult" },
    { 0x02D86CBE, "old_music_state" },
    { 0x7E43B78E, "old_n_znear" },
    { 0x44805B63, "old_near_blur" },
    { 0xAF438497, "old_near_end" },
    { 0xAA0C2D7C, "old_near_start" },
    { 0x2CF90378, "old_node_origin" },
    { 0x821D84B1, "old_num" },
    { 0xF0375013, "old_org" },
    { 0xB1482EB5, "old_origin" },
    { 0x38605884, "old_origins" },
    { 0x26C60357, "old_overheat" },
    { 0x2F36AE9F, "old_overheat_1" },
    { 0xBD2F3F64, "old_overheat_2" },
    { 0xFACA5064, "old_owner" },
    { 0x5E357874, "old_pacifist" },
    { 0xFCDFD103, "old_packs" },
    { 0x365C252A, "old_path" },
    { 0x91C80114, "old_pathenemyfightdist" },
    { 0xD5902839, "old_patrol" },
    { 0xEE0CC89B, "old_pefectaim" },
    { 0x6D7F8A86, "old_percent" },
    { 0xDA504C51, "old_perfectaim" },
    { 0xC3A78605, "old_play_anim_end_early" },
    { 0x029D8814, "old_player_move_speed" },
    { 0x8E318BB3, "old_players" },
    { 0xECE8EDE3, "old_pos" },
    { 0x17210226, "old_position" },
    { 0xF2FAD529, "old_power_level" },
    { 0x52874FF0, "old_powerups" },
    { 0xB1ABBFFA, "old_progress" },
    { 0x4CB70D71, "old_radius" },
    { 0x061873BD, "old_rate" },
    { 0x5F8B251C, "old_rgb" },
    { 0xF1C63D06, "old_roof_trig" },
    { 0x3BBB6369, "old_round" },
    { 0x549AE8D2, "old_run_combatanim" },
    { 0xD4E83C1B, "old_scale" },
    { 0x24495FA7, "old_score" },
    { 0x5D52C76B, "old_screen" },
    { 0x01879298, "old_script_int" },
    { 0x14501E84, "old_selected" },
    { 0xAAD2AE02, "old_sight" },
    { 0xE499FF7E, "old_sightdist" },
    { 0x45C0F6EC, "old_size" },
    { 0xE56FA26B, "old_sort" },
    { 0x52492F60, "old_spawn" },
    { 0xA27C338D, "old_spawn_func" },
    { 0x1609B915, "old_spawn_manager_index" },
    { 0xC49044DF, "old_speaking_player" },
    { 0x24B5BA88, "old_speed" },
    { 0x7B41314A, "old_state" },
    { 0x7E593B38, "old_struct" },
    { 0xD5D4620F, "old_stuff" },
    { 0x7FC6D0D2, "old_style_health_overlay" },
    { 0x1EA89F19, "old_swim_state" },
    { 0xCC86C745, "old_sync_node" },
    { 0xA7578AF4, "old_tactical" },
    { 0xBBF5C350, "old_target" },
    { 0x1000D471, "old_threat_bias_group" },
    { 0xE9D11348, "old_threatbias" },
    { 0x28C3B3A0, "old_threatbiasgroupname" },
    { 0xACADAD04, "old_time" },
    { 0xF41AA6C9, "old_trig" },
    { 0xB79B2491, "old_trigger" },
    { 0xDE52C980, "old_turnrate" },
    { 0x52E2A60E, "old_turret_pos" },
    { 0x638537BF, "old_type" },
    { 0xDE940E16, "old_value" },
    { 0xF55D0572, "old_vc" },
    { 0xAC3D475B, "old_vehicle_damage" },
    { 0xB34940C7, "old_vfx_ent" },
    { 0x48E0AD25, "old_volume" },
    { 0xA4F024CC, "old_vtol" },
    { 0x5A16A8E5, "old_wait_func" },
    { 0xFCBB2608, "old_walkdist" },
    { 0xDD2B81B2, "old_wasp_spawn" },
    { 0xBC8B5EAB, "old_weapon" },
    { 0x452B6BF4, "old_y" },
    { 0xB732DB2F, "old_z" },
    { 0x83970C9C, "oldalpha" },
    { 0xB4D6B68A, "oldammo" },
    { 0x18A3F1A0, "oldang" },
    { 0x88FC2F69, "oldangle" },
    { 0x7CBD73E0, "oldangles" },
    { 0x27BDD65F, "oldanim" },
    { 0xB9268852, "oldanimname" },
    { 0x59026767, "oldarray" },
    { 0x039E3939, "oldatt" },
    { 0x5E6EF291, "oldattacker" },
    { 0xB13E596E, "oldattackeraccuracy" },
    { 0x6778C478, "oldattackers" },
    { 0xA5AD4BAE, "oldblackhawk" },
    { 0x4627D82A, "oldchains" },
    { 0x9ED69F39, "oldclaymorecount" },
    { 0xAAFEA5B0, "oldconvergencetime" },
    { 0xDFE7B6BD, "oldcount" },
    { 0xCBFEF241, "olddeathanim" },
    { 0x3BC9C460, "olddefenders" },
    { 0x8C840235, "olddescendingent" },
    { 0x0F1E3601, "olddif" },
    { 0x47007915, "olddir" },
    { 0xC7A77033, "olddir2d" },
    { 0xAC8C4553, "olddirection" },
    { 0x2444F2D0, "olddist" },
    { 0xF317338D, "olde" },
    { 0x833BFCAF, "oldent" },
    { 0xCE0A3E75, "older" },
    { 0x98080EB0, "oldest" },
    { 0xC3965A81, "oldest_allowed" },
    { 0xB5E540D9, "oldest_index" },
    { 0x8B6FB99C, "oldest_killstreak_removed" },
    { 0x4D3EB4F4, "oldest_time" },
    { 0xBFC60B37, "oldestclone" },
    { 0x3C904424, "oldestindex" },
    { 0x3BBD8B0F, "oldexposure" },
    { 0x148E820F, "oldeye" },
    { 0xBF38539A, "oldfacetimer" },
    { 0xD7E622D6, "oldfightdist" },
    { 0xC11D1AD7, "oldforward" },
    { 0xC22A2339, "oldfov" },
    { 0x60915E99, "oldgoalpos" },
    { 0xBF12D213, "oldgoalradius" },
    { 0x8735DFC8, "oldgrenadeammo" },
    { 0xAC17DDB9, "oldgrenadeawareness" },
    { 0x0004FF9A, "oldgrenadeweapon" },
    { 0xDB7AAC25, "oldgrenawareness" },
    { 0x5192D82D, "oldgunhand" },
    { 0x49430D5D, "oldheadicon" },
    { 0x285DADCA, "oldheadiconteam" },
    { 0xFBFEE00D, "oldheadmodel" },
    { 0xC8C76C92, "oldhealth" },
    { 0xB8C64396, "oldheat" },
    { 0x55F62E61, "oldheight" },
    { 0x46157418, "oldheli" },
    { 0x8E7A2AE7, "oldid" },
    { 0xBF3E3114, "oldindex" },
    { 0x3A5DBBDB, "oldinterval" },
    { 0x49207EBB, "oldkeepnode" },
    { 0x6800246F, "oldkeepnodeingoal" },
    { 0x3AF27F1A, "oldlerps" },
    { 0x3EF427E9, "oldlifetime" },
    { 0x75549F5C, "oldlight" },
    { 0xF22E3225, "oldlocation" },
    { 0x02BDBA3E, "oldloopalias" },
    { 0x008F752C, "oldman" },
    { 0x6EAFCBDA, "oldmanwoods" },
    { 0xA5A21D36, "oldmaxdist" },
    { 0x64CA2DC1, "oldmaxsight" },
    { 0xFAC562A5, "oldmenu" },
    { 0xA8700C10, "oldmissiletype" },
    { 0x793C44D6, "oldmomentum" },
    { 0xBBE51902, "oldmoveplaybackrate" },
    { 0x4436A5CE, "oldmovespeedscale" },
    { 0x03F8EF84, "oldnode" },
    { 0x02BB1FC0, "oldnotifymessage" },
    { 0x68EC4683, "oldobjpoint" },
    { 0x6259F0A0, "oldoneshotalias" },
    { 0xAE17196A, "oldorg" },
    { 0x04BB2606, "oldorigin" },
    { 0xA50C6517, "oldpathenemyfightdist" },
    { 0xB47C1CA9, "oldpathenemylookahead" },
    { 0x155A70CF, "oldperks" },
    { 0xDD88FFAE, "oldpos" },
    { 0x6A6795D7, "oldpose" },
    { 0xD993490A, "oldprimary" },
    { 0x3562D259, "oldrad" },
    { 0xD780BFF4, "oldradar" },
    { 0xA01BC432, "oldradius" },
    { 0xEEF9BDDA, "oldrank" },
    { 0x3D0925A9, "oldratio" },
    { 0xF7D97D5A, "oldrevivers" },
    { 0xABBCBE39, "oldroom" },
    { 0x52BF79C4, "oldschool" },
    { 0x3FFD4EDC, "oldschoolloadout" },
    { 0x3201581D, "oldschoolpickupsound" },
    { 0x4E87B9BD, "oldschoolrespawnsound" },
    { 0x71E78C66, "oldseaknight" },
    { 0x947B4EA3, "oldseat" },
    { 0xAB5DA9E3, "oldsize" },
    { 0x129E7875, "oldspawndata" },
    { 0x7D1C9E6C, "oldspawnkills" },
    { 0xD0EC9BD4, "oldspawnpoints" },
    { 0x61ED08B1, "oldspeed" },
    { 0x759CB721, "oldsporesinflated" },
    { 0x6931BAE8, "oldspot" },
    { 0xD45C1470, "oldstance" },
    { 0xF75C1554, "oldstart" },
    { 0x30BCD9C1, "oldstartdelay" },
    { 0x0B860EC7, "oldstarts" },
    { 0xB73DB72F, "oldstate" },
    { 0xFE5AD27B, "oldstatname" },
    { 0x7C96FE26, "oldstatus" },
    { 0xBF3F959F, "oldstyle" },
    { 0x4DF6063F, "oldsundir" },
    { 0x33A83DC5, "oldsuppression" },
    { 0xFCBCC79C, "oldsuppressionthresold" },
    { 0xC2822480, "oldtank" },
    { 0xDDC9648B, "oldtarget" },
    { 0x8C0ED5DB, "oldteam" },
    { 0x9976785F, "oldthreatbias" },
    { 0x49D8C19C, "oldtimeleft" },
    { 0x3F398514, "oldtrigger" },
    { 0xECB002AD, "oldtriggerweaponslockerthink" },
    { 0xEA03F059, "olduser" },
    { 0xADE4D29D, "oldval" },
    { 0x6BC69CE3, "oldvalue" },
    { 0xBC63B629, "oldvelocity" },
    { 0x588FC985, "oldverticlespeed" },
    { 0xE0CBC7CF, "oldwalkdist" },
    { 0xE90F64C2, "oldwaves" },
    { 0xFB6C759C, "oldweapon" },
    { 0xB088C2D4, "oldweapondata" },
    { 0x76A49DB6, "oldweaponparams" },
    { 0xC5464958, "oldx" },
    { 0xEB48C3C1, "oldy" },
    { 0x114B3E2A, "oldz" },
    { 0x1D9245F2, "oldzone" },
    { 0x9536CC86, "olive" },
    { 0x3098E798, "olympia" },
    { 0xC11FEB57, "omaha" },
    { 0x7F9E75B2, "omaha_drone_vox" },
    { 0x2F3BFDBB, "omaha_drones" },
    { 0xD7E9A8F0, "omar" },
    { 0x1B897DB0, "omg" },
    { 0xF2DED49E, "omit" },
    { 0x0DF63C58, "omit_location" },
    { 0x6480C733, "omit_locations" },
    { 0x74A97CB7, "omit_radius" },
    { 0xED3D2E01, "omits" },
    { 0xD488A151, "omitted" },
    { 0xB50A09B2, "omitting" },
    { 0xBB61D720, "omw" },
    { 0x85E4915E, "on" },
    { 0x21AFF4B5, "on_a_plane" },
    { 0x5E1777FC, "on_actor_damage" },
    { 0x6ACEAE7C, "on_actor_killed" },
    { 0x7BB100AD, "on_ai_damage" },
    { 0xDE1A6D25, "on_ai_killed" },
    { 0x87F30E90, "on_ai_spawned" },
    { 0x7E9BF0F5, "on_argus_notify" },
    { 0xF09D162F, "on_argus_notify_default" },
    { 0xE716502E, "on_argus_notify_intro" },
    { 0x7EAB4EC7, "on_argus_notify_off" },
    { 0x535B5A1D, "on_barrel" },
    { 0x50531B15, "on_barricade_mg" },
    { 0x7AAC5797, "on_boat" },
    { 0xEE4B17BF, "on_bot_connect" },
    { 0x70856B44, "on_bot_killed" },
    { 0x03981DE7, "on_bot_spawned" },
    { 0x2B61E086, "on_break" },
    { 0x9EB322CB, "on_bridge_trig" },
    { 0x03A4A378, "on_buy_weapon_riotshield" },
    { 0x0DD7EECE, "on_challenge_complete" },
    { 0x63B8786E, "on_clear_squad_advance_fc" },
    { 0xF32AFE03, "on_collectibles_change" },
    { 0xEB99DA89, "on_connect" },
    { 0x6BFE94E8, "on_connect_func_for_gravityspikes" },
    { 0x83731A3F, "on_connecting" },
    { 0x1A61261A, "on_damage" },
    { 0x602B5D20, "on_damage_firefly_pod" },
    { 0x5DF309B9, "on_damage_lightninggun" },
    { 0xB8689FDC, "on_damage_special_discgun" },
    { 0x0C66ECC9, "on_death" },
    { 0xF14DE7EB, "on_defender_kill" },
    { 0x95670DEF, "on_disconnect" },
    { 0x5E1C958E, "on_drop_common" },
    { 0x41D94A0C, "on_dry_land" },
    { 0x7CE47BDF, "on_dryland" },
    { 0x8FECF6CE, "on_enter_payload" },
    { 0x23ACB131, "on_entity_shutdown" },
    { 0x6F5E61E8, "on_entity_spawn" },
    { 0xE248348D, "on_error" },
    { 0xD39426BA, "on_exit_payload" },
    { 0x7777E8A1, "on_exit_side" },
    { 0xFAEB731E, "on_finalize_initialization" },
    { 0xE1F88228, "on_finalize_initialization_callback" },
    { 0xE069C441, "on_fire" },
    { 0xCE811066, "on_fire_scientist" },
    { 0xDC0A4B06, "on_fire_scientist_1" },
    { 0xB607D09D, "on_fire_scientist_2" },
    { 0x90055634, "on_fire_scientist_3" },
    { 0x6A02DBCB, "on_fire_scientist_4" },
    { 0x199A7CA5, "on_fire_timeout" },
    { 0xD8521E18, "on_first_player_connect" },
    { 0x885081E7, "on_flicker" },
    { 0x5CC8A462, "on_free_player_connect" },
    { 0xBC64B336, "on_fridge" },
    { 0xA8C317E7, "on_fully_crafted" },
    { 0x5901F2D4, "on_gib_event" },
    { 0x769C65FA, "on_give" },
    { 0xCA878900, "on_ground" },
    { 0x41CF1636, "on_headshot_kill" },
    { 0x97E9791D, "on_hero_ability_kill" },
    { 0x97CA91FE, "on_hero_ability_medal" },
    { 0x40A4D808, "on_hero_ability_multikill" },
    { 0xA997AF9A, "on_hero_weapon_multikill" },
    { 0x98E1F0D1, "on_hillary_death" },
    { 0xBFB58070, "on_horse" },
    { 0xF10E0BE0, "on_joined_spectate" },
    { 0xD2B6D98F, "on_joined_spectators" },
    { 0xF6076BFE, "on_joined_team" },
    { 0xF4746D43, "on_killed_hero_ability_enemy" },
    { 0x62A41CAD, "on_killed_hero_weapon_enemy" },
    { 0x2EF87FC8, "on_killstreak_score" },
    { 0xA93359D3, "on_lander_last_stand" },
    { 0xDF3CB43B, "on_laststand" },
    { 0xC788A33D, "on_level" },
    { 0x51ECF31B, "on_load_wait" },
    { 0xAA179D1B, "on_loadout" },
    { 0x73CEA1FF, "on_local_client_connect" },
    { 0xF16A3399, "on_local_player_spawned" },
    { 0x828AEA2C, "on_localclient_connect" },
    { 0xDED1B718, "on_localclient_shutdown" },
    { 0xA94B174A, "on_localplayer_connect" },
    { 0xA5129E56, "on_localplayer_shutdown" },
    { 0x67E71792, "on_localplayer_spawned" },
    { 0x9A5D1E10, "on_me_to_building" },
    { 0xF44A9D12, "on_menu_response" },
    { 0xA58451A4, "on_model" },
    { 0x7E9D5868, "on_msg" },
    { 0x676FA284, "on_name" },
    { 0x90004D9E, "on_notify" },
    { 0xB928E194, "on_off" },
    { 0x88A1D86D, "on_offender_kill" },
    { 0x86ABDC98, "on_or_off" },
    { 0x314A523B, "on_pickup_common" },
    { 0xBA774310, "on_platform" },
    { 0xFB4F96B5, "on_player_connect" },
    { 0x9F789B54, "on_player_connect_crypt" },
    { 0x888CB133, "on_player_connecting" },
    { 0x4D1D6B36, "on_player_damage" },
    { 0x4C579175, "on_player_death" },
    { 0x7D27AACB, "on_player_disconnect" },
    { 0x0178D800, "on_player_disconnected" },
    { 0x1B292FA6, "on_player_killed" },
    { 0x7ECEC4BC, "on_player_last_stand" },
    { 0x654CE454, "on_player_near_explodable" },
    { 0x6C38274D, "on_player_score" },
    { 0x73D6C43B, "on_player_shutdown" },
    { 0x72A45412, "on_player_spawn" },
    { 0xAEBCF025, "on_player_spawned" },
    { 0x7A194D5A, "on_player_suicide_or_team_kill" },
    { 0xBBF92E7D, "on_pos" },
    { 0x3363E7F6, "on_primed" },
    { 0x0F9E0A43, "on_radar" },
    { 0x9EEE015A, "on_ready" },
    { 0xA8AA9413, "on_same_side" },
    { 0xF31C2285, "on_save_restore" },
    { 0xE32E551B, "on_save_restored" },
    { 0x089BA5DB, "on_saved_restored" },
    { 0x577034A9, "on_saved_restored_monsoon" },
    { 0x94C20045, "on_saved_restored_surveillance" },
    { 0x0B38B56F, "on_shutdown" },
    { 0x558A7130, "on_slide" },
    { 0x55EBB79E, "on_spawn" },
    { 0x048CF902, "on_spawn_claymore_fx" },
    { 0x545B9A44, "on_spawn_firefly_pod" },
    { 0xF860848A, "on_spawn_player" },
    { 0x91EACC3B, "on_spawn_retrievable_weapon_object" },
    { 0x3554B37C, "on_spawn_retrieve_trigger" },
    { 0x356A4EE1, "on_spawned" },
    { 0x1035735F, "on_stairs" },
    { 0x50B7E974, "on_stairs_strat" },
    { 0xC61B24C4, "on_start_gametype" },
    { 0x8E0AD9EC, "on_stealth_spotted" },
    { 0x1BC2F82E, "on_sundeck" },
    { 0x812EC594, "on_take" },
    { 0x53D5C8F6, "on_target" },
    { 0x9AC87FB2, "on_target_killed" },
    { 0xA78CA3AE, "on_target_mortar" },
    { 0xFB4CF24F, "on_the_go" },
    { 0x5F225972, "on_the_moon" },
    { 0x5023C1C1, "on_the_run_enemies" },
    { 0x2226CBFC, "on_threader" },
    { 0x0060F946, "on_timeout" },
    { 0x01EF7E92, "on_touch" },
    { 0xC1833BCB, "on_touch_ammo" },
    { 0x52F8634E, "on_touch_damage" },
    { 0xFDCE2CC7, "on_touch_health" },
    { 0x03589DA9, "on_touch_perk" },
    { 0xCE1CF831, "on_touch_weapon" },
    { 0x065F06B5, "on_train" },
    { 0xC4D47A12, "on_triggers" },
    { 0x76487701, "on_use_function" },
    { 0x0EEDD9EF, "on_vehicle" },
    { 0xD38F54B1, "on_vehicle_damage" },
    { 0x5CF145C9, "on_vehicle_killed" },
    { 0x82C5E7EC, "on_vehicle_spawned" },
    { 0x25EC24CB, "on_warroom_floor" },
    { 0x2D5CB824, "on_zipline" },
    { 0x432AD707, "on_zombie_spawn" },
    { 0xB46782EE, "onactordamage" },
    { 0x37EBAEB8, "onactordamage_callback" },
    { 0x3A8762B0, "onactordamage_callbackremove" },
    { 0xF491B267, "onactordamagecallback" },
    { 0xBEE2E8AE, "onactorkilled" },
    { 0x84797D78, "onactorkilled_callback" },
    { 0x76022E70, "onactorkilled_callbackremove" },
    { 0x3BEB2727, "onactorkilledcallback" },
    { 0x91704999, "onaddvehiclehusks" },
    { 0x8A94D3C2, "onalivecountchange" },
    { 0x74AE7DA4, "onallplayersready" },
    { 0xB1D70AE3, "onalltiresplaced" },
    { 0xA610F7B5, "onargusnotify" },
    { 0xD96C1445, "onbe" },
    { 0xCFCE9B82, "onbeginuse" },
    { 0x15F09945, "onbeginuse_bushatch" },
    { 0xC82298B9, "onbeginuse_busladder" },
    { 0xB7B072B4, "onbeginuse_cattlecatcher" },
    { 0xE0BAE046, "onbeginuse_chalk" },
    { 0x6B3BF4E1, "onbeginuse_electrictrap" },
    { 0xC3B88EF0, "onbeginuse_jetgun" },
    { 0x2EF9D689, "onbeginuse_packapunch" },
    { 0x5A3732B8, "onbeginuse_powerswitch" },
    { 0x290CAA68, "onbeginuse_riotshield" },
    { 0x1E22B1CE, "onbeginuse_turbine" },
    { 0xD538444F, "onbeginuse_turret" },
    { 0xAD88CAF4, "onbeginusecandybooze" },
    { 0x00DE0824, "onbeginuseuts" },
    { 0xB5E1D6B3, "onblockerplaced" },
    { 0x3CDC2A3E, "onboard" },
    { 0x84CBFC05, "onbotconnect" },
    { 0x694F5886, "onbotdamage" },
    { 0x8048B0B6, "onbotkilled" },
    { 0xC2754C0D, "onbotremove" },
    { 0x8C6E9535, "onbotspawned" },
    { 0x8173E91B, "onbought" },
    { 0xF2256059, "onbouncingbettyfizzleout" },
    { 0x3C6F87A2, "onbusturret" },
    { 0x67FB64D0, "onbuswindow" },
    { 0xBD64338B, "onbuttona" },
    { 0x4B5CC450, "onbuttonb" },
    { 0x71A0CC1E, "onbuyweapon" },
    { 0x16D98A94, "onbuyweapon_jetgun" },
    { 0x131C85D5, "onbuyweapon_plane" },
    { 0x516AEE6C, "onbuyweapon_riotshield" },
    { 0xB8A55DCB, "onbuyweapon_slipgun" },
    { 0xD5E96608, "oncancel" },
    { 0x4443DBD9, "oncancelcallback" },
    { 0x48CB58DD, "oncancelplacement" },
    { 0xA1EF92F5, "oncantreach" },
    { 0xB44F2F45, "oncantuse" },
    { 0xE5AD913C, "oncantuse_bushatch" },
    { 0x5D699E0A, "oncantuse_busladder" },
    { 0xE816B773, "oncantuse_cattlecatcher" },
    { 0xEC23E1F5, "oncantuse_chalk" },
    { 0x097BEFE8, "oncantuse_electrictrap" },
    { 0xE842F379, "oncantuse_jetgun" },
    { 0x12B78960, "oncantuse_packapunch" },
    { 0xDB8C9E57, "oncantuse_powerswitch" },
    { 0x1827E2C9, "oncantuse_riotshield" },
    { 0xB8BF767D, "oncantuse_turbine" },
    { 0x036A6566, "oncantuse_turret" },
    { 0xAA161003, "oncantusecandybooze" },
    { 0xB7A4981D, "oncantuseuts" },
    { 0x5E816EB8, "oncapture" },
    { 0x4BAF387E, "once" },
    { 0x6F97D0A3, "once_only" },
    { 0xC9749C0B, "oncepercache" },
    { 0x1CABCD61, "onces" },
    { 0x44F42C50, "oncheckpointtrigger" },
    { 0x772B64D7, "oncombatrobottimeout" },
    { 0xC21928FF, "oncoming" },
    { 0xA8B9C5B8, "onconnect" },
    { 0x2ACFA549, "onconsole" },
    { 0x5E999E7D, "oncontested" },
    { 0x8308120F, "oncrafted" },
    { 0xC6EC4BBA, "oncrafted_fuel" },
    { 0x4F2B3AC0, "oncrafted_plane" },
    { 0x6B2C4C85, "ondamage" },
    { 0x6F8E21C2, "ondamageperweapon" },
    { 0xE0DB18E8, "ondeadevent" },
    { 0xF87D22C8, "ondeath" },
    { 0xE525F360, "ondeathafterframeend" },
    { 0xD8D90799, "ondeathcallback" },
    { 0x5D4055DD, "ondec20message" },
    { 0xC482A0EC, "ondestroy" },
    { 0xA9DCF3CF, "ondestroyed" },
    { 0xEA1AF2DF, "ondetonatecallback" },
    { 0x7BA1AF66, "ondetonated" },
    { 0xD23BDA1B, "ondetonationhandle" },
    { 0x4AA43684, "ondisconnect" },
    { 0x38173E90, "ondisconnect_common" },
    { 0x05DAB9B5, "ondpaddown" },
    { 0xB6C0A026, "ondpadleft" },
    { 0x7CC365BD, "ondpadright" },
    { 0x363454EA, "ondpadup" },
    { 0x8B3759B3, "ondrivingfxcollision" },
    { 0x6A5DA12E, "ondrivingfxjumplanding" },
    { 0x5AACB6FD, "ondrop" },
    { 0x5C80788A, "ondrop_aircrystal" },
    { 0x12117F4F, "ondrop_booze" },
    { 0x1AAB61C3, "ondrop_candy" },
    { 0xF5F448AD, "ondrop_chalk" },
    { 0x31EDD14B, "ondrop_common" },
    { 0x318B7336, "ondrop_crystal" },
    { 0x8EBA867A, "ondrop_firecrystal" },
    { 0x001DC75C, "ondrop_fuel" },
    { 0xB1DAEBFC, "ondrop_keys" },
    { 0x2E9C07F4, "ondrop_lightningcrystal" },
    { 0x93AEC5B6, "ondrop_plane" },
    { 0xB9D0D134, "ondrop_switch" },
    { 0x543ED0C1, "ondrop_watercrystal" },
    { 0x43646525, "ondroputs" },
    { 0xA1EF53A7, "one" },
    { 0x372631AB, "one_at_a_time" },
    { 0xD0D4C796, "one_at_a_time_hero" },
    { 0x985E805E, "one_at_a_time_rival" },
    { 0xFCFA5CB8, "one_attachment_perc" },
    { 0xE00D553D, "one_challenge_achievement" },
    { 0xED27E090, "one_clip" },
    { 0x0BC13A70, "one_direction_trigger" },
    { 0x0DD92BF7, "one_emo_at_a_time" },
    { 0xD43AD9C5, "one_execution_pdf_left" },
    { 0xEF86CC20, "one_exhaust" },
    { 0x8B9551FA, "one_for_four" },
    { 0x8FCEE73F, "one_for_ten" },
    { 0xC36D2B1E, "one_giant_leap" },
    { 0x8ED6517D, "one_handed_node" },
    { 0xF78F6C31, "one_handed_push" },
    { 0x2F25D774, "one_handed_push_first_frame" },
    { 0x5754E57F, "one_handed_trig" },
    { 0xBBA46808, "one_hit_kill" },
    { 0x48AE0C6E, "one_inch_precache" },
    { 0x5FC3C5C7, "one_inch_punch_flag_has_been_init" },
    { 0x3898D995, "one_inch_punch_melee_attack" },
    { 0xD4260E2A, "one_inch_punch_take_think" },
    { 0xF1627038, "one_inch_punch_watch_for_death" },
    { 0xCEC9BE7D, "one_less_bullet_check" },
    { 0x12A32BB7, "one_lines" },
    { 0xE2FD64A4, "one_minus_c" },
    { 0xDAFBB59B, "one_over_magnitude" },
    { 0x55CA02FD, "one_player" },
    { 0x689CB84E, "one_player_coopenemyaccuracyscalar" },
    { 0xE6BA970D, "one_player_coopfriendlyaccuracyscalar" },
    { 0x84DBF919, "one_player_coopfriendlythreatbiasscalar" },
    { 0x17D30E79, "one_player_coopplayerdifficultyhealth" },
    { 0x4B093797, "one_player_deathinvulnerabletimemodifier" },
    { 0x08DFA5BA, "one_player_enemy_pain_chance_modifier" },
    { 0xC58523A1, "one_player_hit_invulnerability_modifier" },
    { 0x14CCC0A2, "one_red_to_orange" },
    { 0xB39410C8, "one_remote_use" },
    { 0x9806570C, "one_shot_event5_color_triggers" },
    { 0xC89F5995, "one_still_near" },
    { 0x3FA3971F, "one_tank_dead_vo" },
    { 0x3BDA9860, "one_time_build" },
    { 0x7944CFCF, "one_time_cost" },
    { 0x6693CD26, "one_time_craft" },
    { 0x3E81C961, "one_time_on_player" },
    { 0x60B9F437, "one_use_and_fly" },
    { 0xE627ECF5, "one_valid_zone" },
    { 0xAA19D497, "one_way" },
    { 0xA72F1830, "one_way_blocker" },
    { 0xE2370B99, "oneaway" },
    { 0x70143657, "oneexhaust" },
    { 0x6D4B0C7C, "oneflagtimer" },
    { 0xF127E9C3, "onefoot" },
    { 0x7043CF9B, "onehanded" },
    { 0x70500300, "onehanded_ai" },
    { 0xF5C5C2B9, "oneinchpunch" },
    { 0x65EBB880, "oneinchpunch_air" },
    { 0xDDD6F548, "oneinchpunch_fire" },
    { 0xC7E18931, "oneinchpunch_ice" },
    { 0xBB50721A, "oneinchpunch_lightning" },
    { 0xEC3166FC, "oneinchpunch_upgraded" },
    { 0x4892CC47, "onejectoccupants" },
    { 0x2EAA1320, "onemp" },
    { 0x5A1F4F41, "onempcallback" },
    { 0x719030FC, "onempchanged" },
    { 0x670B5BA5, "onempdcallback" },
    { 0xED0EC079, "onempmonitordistancechanged" },
    { 0xBF7AF70D, "onempty" },
    { 0x257D1C47, "onendgame" },
    { 0x921739BB, "onendtouchuse" },
    { 0xBD93975E, "onendtracking" },
    { 0xA454A59A, "onenduse" },
    { 0xE713D5BD, "onenduse_bushatch" },
    { 0x8C171B91, "onenduse_busladder" },
    { 0xE02CD53C, "onenduse_cattlecatcher" },
    { 0x861931FE, "onenduse_chalk" },
    { 0x0960AE59, "onenduse_electrictrap" },
    { 0xF4EF7C08, "onenduse_jetgun" },
    { 0x2DFE0851, "onenduse_packapunch" },
    { 0x83C6AA70, "onenduse_powerswitch" },
    { 0x6D0C25D0, "onenduse_riotshield" },
    { 0x4F91DE19, "onenduse_sidequestcommon" },
    { 0x73E7B276, "onenduse_turbine" },
    { 0x53B13DE7, "onenduse_turret" },
    { 0x2004123C, "onendusecandybooze" },
    { 0x0BC83D6C, "onenduseuts" },
    { 0xC3739525, "oneorigin" },
    { 0x99896B1E, "ones" },
    { 0xC1BE0D64, "ones_model" },
    { 0xF4F40077, "oneshot" },
    { 0x54F01A3B, "oneshot_destroyed_comms_spark" },
    { 0x486F5B90, "oneshot_lockon_sound" },
    { 0x60BBF840, "oneshot_then_loop" },
    { 0xE26C48D6, "oneshot_thread" },
    { 0xFCA1F9BD, "oneshotalias" },
    { 0x12EF01B1, "oneshotfx" },
    { 0x22C4FDD9, "oneshotfxthread" },
    { 0x8E97B405, "oneshotmultikills" },
    { 0x71F56D4D, "oneshotmultikillsdamagetime" },
    { 0xDA34C3AE, "oneshots" },
    { 0x51A95A78, "oneshotsnd" },
    { 0x24F2E882, "onetimeonly" },
    { 0x0C161D20, "onextralowhealth" },
    { 0x0F9AE3D5, "onfarm_enter" },
    { 0x76D585CE, "onfinalizeinitialization_callback" },
    { 0x2524B4EE, "onfindvalidspawnpoint" },
    { 0xF7464AAC, "onfinishedfunction" },
    { 0xBEC86311, "onfirescream" },
    { 0x8CF3AADB, "onfirstplayerconnect" },
    { 0xFC43BBBF, "onfirstplayerconnect_callback" },
    { 0x080B5BE7, "onfirstplayerconnect_callbackremove" },
    { 0x709690FC, "onfirstplayerready" },
    { 0x53632D50, "onfizzleout" },
    { 0x794747FC, "onflag" },
    { 0x876044B7, "onflakdronedestroyed" },
    { 0x0F5732EF, "onforfeit" },
    { 0x2205E82A, "onfrac" },
    { 0x56F0946B, "onfreeplayerconnect" },
    { 0x2722B673, "onfullycrafted" },
    { 0x6696AEA2, "onfullycrafted_packasplat" },
    { 0x804E9744, "onfullycrafted_plane" },
    { 0xE2076525, "onfullycrafted_quadrotor" },
    { 0x1B5C270E, "onfullycrafted_refueled" },
    { 0x2EAF6E7B, "onfullycrafted_refueled_think" },
    { 0xF5C67B17, "ongameend" },
    { 0x646F3340, "ongoing" },
    { 0xDAB1F598, "ongrenadethrow" },
    { 0xA512387F, "onground" },
    { 0x194F1816, "onhigh" },
    { 0x696061CE, "onhumankilled" },
    { 0x9EE3C3E1, "onintensity" },
    { 0x3C6A7D4B, "onjoinedspectators" },
    { 0x99B59332, "onjoinedteam" },
    { 0xC128E1A5, "onkeysplaced" },
    { 0x80385C0D, "onkeysused" },
    { 0x42BA2B3A, "onkill" },
    { 0xE5C1A46C, "onkillstreak" },
    { 0x09A7ACC3, "onkillstreakused" },
    { 0xA8CF0CA0, "onlastteamaliveevent" },
    { 0xB11E4598, "online" },
    { 0xAE964654, "online_class_datatable" },
    { 0xEC551FD5, "online_game" },
    { 0x5EEE5D0E, "onlinegame" },
    { 0x3E5BBD46, "onload" },
    { 0x05C8C761, "onloadfadein" },
    { 0xEEED5538, "onloadfadeout" },
    { 0x97FB53EF, "onloadprint" },
    { 0x4C92C0D0, "onlow" },
    { 0x4A622862, "onlowhealth" },
    { 0x11A52203, "only" },
    { 0xF0E69A4C, "only_affects_grabber" },
    { 0xD952B7F5, "only_arrival" },
    { 0x18C6A955, "only_default" },
    { 0x2E575126, "only_exit" },
    { 0xEBCD0FDF, "only_fire_in_range_of_boat" },
    { 0xE61528B0, "only_for_bonuszm" },
    { 0xA716172B, "only_one_blood" },
    { 0xDE74A2B5, "only_one_fight_in_bp_tracking_thread" },
    { 0x68B26C4C, "only_one_gasmask_removed_thread" },
    { 0x498EB0F7, "only_one_heartbeat" },
    { 0xECA2A826, "only_one_icon_think_thread" },
    { 0x85F334E1, "only_one_pap_watcher" },
    { 0x574BC388, "only_one_path_required" },
    { 0xC6168B3E, "only_one_powerup_thread" },
    { 0xC4BDDF2B, "only_one_woods_follow_behavior_thread" },
    { 0x664A20EC, "only_player_kill" },
    { 0x162D70DA, "only_player_window_broke" },
    { 0x4C7F0830, "only_players" },
    { 0x308B148D, "only_track_targeted_players" },
    { 0xF8871D8A, "only_turns" },
    { 0x3E141E90, "only_use_turret" },
    { 0x53923A70, "only_z" },
    { 0x9B4E321D, "onlyallowfrags" },
    { 0xABAA8FBF, "onlycroucharrivals" },
    { 0x4F5B9EB4, "onlydamage" },
    { 0x605A22FD, "onlyenemy" },
    { 0x5BAC319D, "onlyents" },
    { 0x32807BAC, "onlyheadshots" },
    { 0x834653D4, "onlyplayer" },
    { 0xEC0CD550, "onlywithmembers" },
    { 0x25965F23, "onlyz" },
    { 0xC724D824, "onmaksavegamerestored" },
    { 0x65A938A7, "onmark19" },
    { 0x5E615357, "onme2_exposed" },
    { 0x448F7FDA, "onme_cornerr" },
    { 0x04A30341, "onmedalawarded" },
    { 0x76B2B504, "onmenumessage" },
    { 0x168BE332, "onmenuresponse" },
    { 0x60A90DE0, "onmid" },
    { 0xDD27DFA5, "onmodel" },
    { 0x07549565, "onmove" },
    { 0xD38EF7C0, "onmovecallback" },
    { 0x693A19EF, "onmovefunc" },
    { 0x6B65B917, "onnavvolume" },
    { 0xB387A1A8, "onnnn" },
    { 0xA8F36FC2, "onnote" },
    { 0x12A9FC55, "onnotify" },
    { 0x2142C024, "onode" },
    { 0x7EB013A5, "onoff" },
    { 0x4ABE31C7, "ononeleftevent" },
    { 0x2A30EC71, "onoutcomenotify" },
    { 0x8201B00A, "onoutofboundschange" },
    { 0x5E994BD3, "onovertime" },
    { 0x8E900A8A, "onpickup" },
    { 0xA0621A83, "onpickup_aircrystal" },
    { 0x52586F04, "onpickup_booze" },
    { 0xB5C7D3A0, "onpickup_candy" },
    { 0x66A9CB86, "onpickup_common" },
    { 0xD69DC795, "onpickup_crystal" },
    { 0x15F35EF1, "onpickup_firecrystal" },
    { 0xC0EB9875, "onpickup_fuel" },
    { 0x39C054CE, "onpickup_key" },
    { 0xF1EAAC71, "onpickup_keys" },
    { 0xF138EBA9, "onpickup_lightningcrystal" },
    { 0xC91B3101, "onpickup_plane" },
    { 0xA58E2875, "onpickup_staffpiece" },
    { 0xACFF0BA9, "onpickup_switch" },
    { 0x4D965F64, "onpickup_watercrystal" },
    { 0xA0A50D3D, "onpickupfailed" },
    { 0xA13A7C12, "onpickupmusicstate" },
    { 0x5E504518, "onpickupturret" },
    { 0x7711C41C, "onpickuputs" },
    { 0xF5CF8A8F, "onplace" },
    { 0x18109EE2, "onplacecallback" },
    { 0xB5DA3F4F, "onplaceemp" },
    { 0xB21F66A5, "onplaceturret" },
    { 0x08101ADE, "onplayconnect" },
    { 0x0B758219, "onplayer" },
    { 0x23120857, "onplayerclasschange" },
    { 0x603848D5, "onplayerconnect" },
    { 0x0A33E45B, "onplayerconnect_bank_deposit_box" },
    { 0x4B2E8FB9, "onplayerconnect_callback" },
    { 0x5C6DA03D, "onplayerconnect_callbackremove" },
    { 0x4CAB5DBC, "onplayerconnect_check_for_hotjoin" },
    { 0xAC81A059, "onplayerconnect_clientdvars" },
    { 0xE5597DE0, "onplayerconnect_ee_jump_scare" },
    { 0x1655FA4D, "onplayerconnect_ee_oneinchpunch" },
    { 0x130B9AC2, "onplayerconnect_sq_fc" },
    { 0x7E4F2D0D, "onplayerconnect_sq_final" },
    { 0xFA54ACB6, "onplayerconnect_sq_wth" },
    { 0xAF2160D3, "onplayerconnecting" },
    { 0xF459C6D6, "onplayerdamage" },
    { 0x46A24AF0, "onplayerdamage_callback" },
    { 0x2FB94308, "onplayerdamage_callbackremove" },
    { 0x1F7A1595, "onplayerdeath" },
    { 0x2163426B, "onplayerdisconnect" },
    { 0x30C4930F, "onplayerdisconnect_callback" },
    { 0xDF7CCA37, "onplayerdisconnect_callbackremove" },
    { 0x439A4D15, "onplayereliminated" },
    { 0x070160C9, "onplayerjoinedteam" },
    { 0xC2658B46, "onplayerkilled" },
    { 0x54A9AC60, "onplayerkilled_callback" },
    { 0xD2E8E378, "onplayerkilled_callbackremove" },
    { 0xEC081406, "onplayerkilled_strobe" },
    { 0xC79586A8, "onplayerkilledextraunthreadedcbs" },
    { 0x21190027, "onplayerkillstreak" },
    { 0xA33896BC, "onplayerkillstreakactivated" },
    { 0x62D4F7AA, "onplayerkillstreakearned" },
    { 0x920996B7, "onplayerlaststand" },
    { 0x1D25492B, "onplayerlaststand_callback" },
    { 0x9260579B, "onplayerlaststand_callbackremove" },
    { 0xC9CEE9D9, "onplayernearexplodable" },
    { 0x3C04DC48, "onplayerrevived_callback" },
    { 0x03B683C0, "onplayerscompass" },
    { 0xB15F9D6D, "onplayerscore" },
    { 0xCABE2632, "onplayerspawn" },
    { 0xBE02CC45, "onplayerspawned" },
    { 0x20616529, "onplayerspawned_callback" },
    { 0x97FCE621, "onplayerspawned_chooseclass" },
    { 0xD2439E04, "onplayerspawned_restore_previous_weapons" },
    { 0x001AF4F4, "onplayerspawnedweapons" },
    { 0xA4249FBF, "onplayersuicideorteamkill" },
    { 0x3EEDE873, "onplayertakedamage" },
    { 0xF37B575A, "onplayerteamchange" },
    { 0xF583E4EC, "onplayerweaponswap" },
    { 0x6ACE7F84, "onpostinitgametype" },
    { 0xE9339FA6, "onpostspawnplayer" },
    { 0xE0477CC2, "onpoweron" },
    { 0x90F0668F, "onprecachegametype" },
    { 0xAC86DEF5, "onpreinitgametype" },
    { 0xFB860CAF, "onradiocapture" },
    { 0x4F3687B3, "onradiodestroy" },
    { 0x0D6F609C, "onradioplaced" },
    { 0x65F32632, "onramp" },
    { 0x1732E573, "onrapstimeout" },
    { 0x94DB5553, "onreach" },
    { 0xC989902F, "onreadyfunction" },
    { 0x81253537, "onreset" },
    { 0x9FCABF9F, "onrespawndelay" },
    { 0x30A29E89, "onrobotkilled" },
    { 0x683ED2DD, "onroundbegin" },
    { 0xBEC86885, "onroundend" },
    { 0x3FCD5617, "onroundendgame" },
    { 0x66508D39, "onroundscorelimit" },
    { 0xE4E885E6, "onroundswitch" },
    { 0x1E081BC1, "ons" },
    { 0xD78FC5B3, "onsaverestored" },
    { 0x3BFD5BE7, "onsaverestored_callback" },
    { 0xDB355A6F, "onsaverestored_callbackremove" },
    { 0x5CEE117D, "onscoreclosemusic" },
    { 0x67D7B8A9, "onscorelimit" },
    { 0x7AC16242, "onscreen" },
    { 0xDF2B84E6, "onscreen_stopwatch" },
    { 0x64BD371E, "onset" },
    { 0x6C415344, "onshutdown" },
    { 0xBF4F0E45, "onshutdowncallback" },
    { 0x4724A8D7, "onslope" },
    { 0x99CDB03A, "onsomethingevent" },
    { 0xE0E5C163, "onspawn" },
    { 0xCA272462, "onspawn_keys" },
    { 0x559C19D6, "onspawn_switch" },
    { 0xED275B60, "onspawnacousticsensor" },
    { 0xAC7CFCDE, "onspawnbouncingbetty" },
    { 0xB0F868CC, "onspawncameraspike" },
    { 0x3AF5CF19, "onspawnclaymorefx" },
    { 0xB6C262A2, "onspawncrossbowbolt" },
    { 0x70A82CEE, "onspawncrossbowbolt_internal" },
    { 0x1A472054, "onspawncrossbowboltimpact" },
    { 0x0F02B1F4, "onspawncrossbowboltimpact_internal" },
    { 0x85974429, "onspawndecoy" },
    { 0x6ECBB2B1, "onspawnfunc" },
    { 0x644BF115, "onspawnfx" },
    { 0x4FA3D60C, "onspawnhatchet" },
    { 0x3DC685F8, "onspawnhatchettrigger" },
    { 0x7B3FB2DB, "onspawnintermission" },
    { 0x870FF5BE, "onspawnnetworkintruder" },
    { 0x19BC9234, "onspawnplayer" },
    { 0xA326DCF3, "onspawnplayer_unified" },
    { 0xCC747D7A, "onspawnplayerunified" },
    { 0xF70C9ADD, "onspawnproximitygrenadeweaponobject" },
    { 0xF5A951E7, "onspawnproximityweaponobject" },
    { 0x26F3AD87, "onspawnretrievableweaponobject" },
    { 0xCADED721, "onspawnretrievetrigger" },
    { 0x6AAFABC8, "onspawnretrievetriggers" },
    { 0xFD7F52D0, "onspawnscrambler" },
    { 0xBDECB8FD, "onspawnsensorgrenade" },
    { 0x9D76F10C, "onspawnspecialcrossbowtrigger" },
    { 0x62209E9A, "onspawnspectator" },
    { 0x8A24ECFD, "onspawnthreatdetector" },
    { 0x6A6B24E1, "onspawnuseweaponobject" },
    { 0x6539D9B9, "onspawnzombie" },
    { 0x381FB54F, "onsquadleaderchange" },
    { 0x153C7E7D, "onstartcleansedgametype" },
    { 0x34685338, "onstartgametype" },
    { 0x7FCD8975, "onstartwagersidebets" },
    { 0xB433957C, "onstopfunc" },
    { 0x930C3EE6, "onstun" },
    { 0x8393B7BC, "onstunfinished" },
    { 0x5BA4DAF0, "onsuimessage" },
    { 0xF83B1F41, "onsupplementaldetonatecallback" },
    { 0x454462CE, "ontargetpausetime" },
    { 0x4383D23D, "onteamchange" },
    { 0xAC8C2503, "onteamchanged" },
    { 0x76317440, "onteamoutcomenotify" },
    { 0x9ED78565, "onteamscore" },
    { 0xBCCF8ABF, "onteamscore_incrementscore" },
    { 0xE3B726FD, "onteamscore_postprocess" },
    { 0xEFEA8A44, "onteamwageroutcomenotify" },
    { 0x6809E640, "onteleportplaced" },
    { 0x5173DEAB, "onthe" },
    { 0xB4D06AAB, "ontill" },
    { 0x04731447, "ontimecheck" },
    { 0xFB734762, "ontimelimit" },
    { 0xC3727207, "ontimeout" },
    { 0xAA45E2EA, "ontimeoutcallback" },
    { 0x226906DB, "ontireplaced" },
    { 0x44881A5D, "onto" },
    { 0xDF19D9D7, "ontop" },
    { 0xC055EC64, "ontouchuse" },
    { 0x43983387, "ontowdoorbar" },
    { 0xE4F734DA, "ontowdoorbarber" },
    { 0x4541C4FA, "ontrophysystemsmashed" },
    { 0x922071D0, "ontrophysystemspawn" },
    { 0x3574C1DF, "onturretdamage" },
    { 0xFD39F182, "onturretdeath" },
    { 0x397DE1FE, "onturretdeathpostgame" },
    { 0x3953B856, "onuncontested" },
    { 0xECF0EF17, "onunoccupied" },
    { 0xD87A269C, "onunspawn" },
    { 0x747662C0, "onupdateuserate" },
    { 0x3A499692, "onupgradefunction" },
    { 0x3C8EA097, "onuse" },
    { 0x2FC89BB6, "onuse_thread" },
    { 0x2D2BBEDE, "onuseclear" },
    { 0x468A3A44, "onusedefuseobject" },
    { 0x33EF5A91, "onusedfunction" },
    { 0xA97D0945, "onusedogtag" },
    { 0x339C6254, "onusegameobject" },
    { 0x3FA7F3E6, "onuseobject" },
    { 0x55654DB3, "onuseplantobject" },
    { 0x5B5ED459, "onuseplantobject_booze_and_candy" },
    { 0x9A2305C6, "onuseplantobject_bushatch" },
    { 0x13F50930, "onuseplantobject_busladder" },
    { 0xEC382F05, "onuseplantobject_cattlecatcher" },
    { 0x533B7CCF, "onuseplantobject_chalk" },
    { 0x79F30D96, "onuseplantobject_electrictrap" },
    { 0x5081A1ED, "onuseplantobject_elevatorkey" },
    { 0x9ED75629, "onuseplantobject_escapepodkey" },
    { 0x77839F43, "onuseplantobject_jetgun" },
    { 0x55F97283, "onuseplantobject_key" },
    { 0x8D8613F6, "onuseplantobject_mtower" },
    { 0x8EA69F8E, "onuseplantobject_packapunch" },
    { 0xBBD97A01, "onuseplantobject_powerswitch" },
    { 0x81CB74EB, "onuseplantobject_riotshield" },
    { 0x8DD7D1FF, "onuseplantobject_rtower" },
    { 0xD15A79C2, "onuseplantobject_slipgun" },
    { 0x97594206, "onuseplantobject_sloth" },
    { 0x53298086, "onuseplantobject_switch" },
    { 0x18D4ED4B, "onuseplantobject_turbine" },
    { 0xD8CC896C, "onuseplantobject_turret" },
    { 0xB507EC29, "onuseplantobjectcandybooze" },
    { 0xB7C96663, "onuseplantobjectuts" },
    { 0x76E87FB4, "onuseupdate" },
    { 0x77561C51, "onusewithneutralizingflag" },
    { 0x5C292BCB, "onusewithoutneutralizingflag" },
    { 0xEC419ED9, "onvehicledamage" },
    { 0x3B88326D, "onvehicledamage_callback" },
    { 0x5D69AB39, "onvehicledamage_callbackremove" },
    { 0x2BC18574, "onvehicledamagecallback" },
    { 0xB5C6DDE1, "onvehiclekilled" },
    { 0x285B856C, "onvehiclekilledcallback" },
    { 0x8619115E, "onwagerawards" },
    { 0xE4F4BBB2, "onwagerfinalizeround" },
    { 0xB60AC87B, "onwageroutcomenotify" },
    { 0x92FF1CAF, "onwagerplayerante" },
    { 0x3D7F4144, "onward" },
    { 0xA5D220F7, "onwards" },
    { 0x49A7A889, "onwaterfx" },
    { 0xC3C3C7A2, "onwaterripplefxdelete" },
    { 0x49607B4A, "onwaterripplefxdeletewhendone" },
    { 0xB3819134, "onwaterripplefxspawn" },
    { 0x777747C8, "onwaterwakefxdelete" },
    { 0xEDD8E580, "onwaterwakefxdeletewhendone" },
    { 0xA9782F8A, "onwaterwakefxspawn" },
    { 0xF8768805, "onweapondamage" },
    { 0x1D0C8B2A, "onxpevent" },
    { 0x38B6CC07, "onzombifyplayer" },
    { 0xFECD2202, "onzonecapture" },
    { 0xCBDB006F, "onzonecontested" },
    { 0xB016B8F2, "onzonedestroy" },
    { 0x8FB70C34, "onzoneuncontested" },
    { 0x1AADB4B5, "onzoneunoccupied" },
    { 0xABE70BC7, "oo" },
    { 0x6ECE97B7, "oob" },
    { 0xA140D83F, "oob_active_duration" },
    { 0xF0DC299B, "oob_damage_default" },
    { 0xA98D5705, "oob_damage_default_mp" },
    { 0x0F770EBA, "oob_damage_interval_ms" },
    { 0xC6D9046D, "oob_damage_interval_sec" },
    { 0xD5BBC5CA, "oob_damage_ms_default" },
    { 0x648D332A, "oob_damage_ms_default_mp" },
    { 0xE97B1577, "oob_damage_per_interval" },
    { 0xE434C297, "oob_effect_enabled" },
    { 0xE65F0D2E, "oob_effect_max_distance_before_black" },
    { 0xA24D3836, "oob_effect_max_distance_before_black_mp" },
    { 0xBFB17DC0, "oob_effect_time_remaining_before_black" },
    { 0x79653110, "oob_effect_time_remaining_before_black_mp" },
    { 0x9F86FDD8, "oob_effectvalue" },
    { 0x9256823F, "oob_end_time" },
    { 0xD24E5BA0, "oob_enter" },
    { 0xBD034A9A, "oob_exit" },
    { 0xC8513E5C, "oob_host_migration_exit" },
    { 0xD97A9A55, "oob_invalid_time" },
    { 0x9E105294, "oob_lasteffectvalue" },
    { 0xBD209970, "oob_lastvalidplayerdir" },
    { 0x56804923, "oob_lastvalidplayerloc" },
    { 0x69D983A4, "oob_max_distance_before_black" },
    { 0x28B9CB6C, "oob_players" },
    { 0xEDC80D01, "oob_sound_ent" },
    { 0xF86BA686, "oob_start_time" },
    { 0xBA08243A, "oob_time_remaining_before_black" },
    { 0xCBE1D4AA, "oob_timekeep_mp" },
    { 0xA5DF5A41, "oob_timekeep_ms" },
    { 0x67968F2D, "oob_timelimit_ms" },
    { 0x4F37A667, "oob_timelimit_ms_default" },
    { 0x099584C9, "oob_timelimit_ms_default_mp" },
    { 0x29D8C635, "oob_triggers" },
    { 0x41917C7A, "oob_warning_time" },
    { 0x9140E797, "oobdisabled" },
    { 0x1E24F146, "oobmodel" },
    { 0x80AE6062, "ooo" },
    { 0x47889AA3, "ooomph" },
    { 0xA639DC61, "oooo" },
    { 0xA6E33CA4, "oops" },
    { 0xFC7F9FEA, "oopsie" },
    { 0x85B3283C, "oorah" },
    { 0xC3798960, "ooze" },
    { 0xD1E98630, "op" },
    { 0x5600D7F4, "opacity" },
    { 0x82E2AC6D, "opacity_stage_1_begin" },
    { 0x601EA355, "opacity_stage_1_end" },
    { 0x76F74F9A, "opacity_stage_2_begin" },
    { 0x08510DDE, "opacity_stage_2_end" },
    { 0x3C547E93, "opacity_stage_3_begin" },
    { 0xA1C37023, "opacity_stage_3_end" },
    { 0x8F441EF0, "opacity_stage_4_begin" },
    { 0x12F57C94, "opacity_stage_4_end" },
    { 0x98EC4A46, "opactiy" },
    { 0x0B29945C, "opaque" },
    { 0x20F3F965, "opcolor" },
    { 0x8F50155C, "opcon" },
    { 0x5851367B, "opel" },
    { 0x3C5F5588, "opel1" },
    { 0xAE66C4C3, "opel2" },
    { 0x07C5B01A, "opels" },
    { 0x324EBC12, "opem" },
    { 0x0C4C41A9, "open" },
    { 0xCCAAD592, "open_all_gramophone_doors" },
    { 0x845DE7D3, "open_all_teleporters" },
    { 0xFC9632D6, "open_all_zbarriers" },
    { 0x1CA0F842, "open_and_close_that_one_door" },
    { 0x50C2DF4D, "open_angle" },
    { 0x81F507AF, "open_area" },
    { 0xDED73D89, "open_barricade" },
    { 0x1575CFBF, "open_base_gate" },
    { 0x3E6A307D, "open_bash_door" },
    { 0x2AB49022, "open_bay_doors" },
    { 0x49B04DCB, "open_bottom_doors" },
    { 0xD155CCCD, "open_bottom_elevator_door" },
    { 0x139222F7, "open_box" },
    { 0x1ADF56FA, "open_catwalk_door" },
    { 0x243452FB, "open_chest_location" },
    { 0x32EEF138, "open_cleanup" },
    { 0x19C45067, "open_closed_door" },
    { 0xD3CE0CEB, "open_craftablespawn" },
    { 0xB4D529EF, "open_craftablestub_update_prompt" },
    { 0x8DFD6228, "open_crate_door" },
    { 0x16A1750D, "open_crc_door" },
    { 0xAE9C0561, "open_custom_door_master_key" },
    { 0x8E79D1B8, "open_donkeykong_balcony_doors" },
    { 0x7B386E04, "open_door" },
    { 0x4DB90473, "open_door_2" },
    { 0x916C92FE, "open_door_climbout" },
    { 0xC3B353A0, "open_door_time" },
    { 0x3FD2F15D, "open_door_trigger" },
    { 0xA634DCC2, "open_door_when_exit" },
    { 0x63585534, "open_drone_traincar_door" },
    { 0x90F1D74F, "open_electric_doors" },
    { 0xA49D7CF4, "open_elev_doors" },
    { 0xD18BBDA8, "open_end05_gate" },
    { 0x29E5F81C, "open_exit" },
    { 0xE1F7755F, "open_exits" },
    { 0x160D986D, "open_factory_door" },
    { 0x12513AD8, "open_fire" },
    { 0x38FB880C, "open_fire_fake" },
    { 0x2C731366, "open_fire_fake2" },
    { 0x02234A0A, "open_firing_range_door" },
    { 0xA98680D4, "open_flareguy_door" },
    { 0xB16C7F98, "open_flash_doors" },
    { 0x2282FD06, "open_front_gate_clip" },
    { 0x4C527401, "open_gantry" },
    { 0xA05061A2, "open_gantry_audio" },
    { 0x5B209832, "open_garage_door" },
    { 0x527DAAB9, "open_gate" },
    { 0xC7825A26, "open_generic_script_dialog" },
    { 0x0C13A25C, "open_grate_check" },
    { 0x045514A1, "open_hallway_door" },
    { 0x54824DB0, "open_hangar_door" },
    { 0x7D174BAE, "open_hatch" },
    { 0x762BEB52, "open_huey_door" },
    { 0xC345EFBE, "open_huey_door_button_pressed" },
    { 0xD6C7C417, "open_internal" },
    { 0x024A83BB, "open_it" },
    { 0x01B75AC4, "open_jail" },
    { 0xA46FFC7B, "open_ladder_door" },
    { 0x6787344D, "open_lander_bay_doors" },
    { 0x22B4FD16, "open_lander_bay_doors_only" },
    { 0xE71897C5, "open_lander_door" },
    { 0xE8434A58, "open_lander_gate" },
    { 0x7BA28CA7, "open_laundrymat" },
    { 0xD27FB578, "open_left_curtain" },
    { 0xF02E6026, "open_left_door" },
    { 0x7B49B95F, "open_lid" },
    { 0x042E9718, "open_light" },
    { 0x395A9D5E, "open_light_model" },
    { 0xC47A2101, "open_menu" },
    { 0x999C5895, "open_morgue_doors" },
    { 0x986B71E2, "open_motel_door" },
    { 0x448D82C0, "open_node" },
    { 0x7C77034A, "open_ocean_waterfog_settings" },
    { 0xDE8306FD, "open_planter_door" },
    { 0xA97BB174, "open_player_path_into_water" },
    { 0x73AF3E35, "open_pool_door" },
    { 0x35A36D2B, "open_portal_rooms" },
    { 0x80A906AA, "open_pos" },
    { 0x64E2C096, "open_pow_door1" },
    { 0x3EE0462D, "open_pow_door2" },
    { 0x18DDCBC4, "open_pow_door3" },
    { 0x2E915265, "open_right_curtain" },
    { 0x9A85CD69, "open_right_door" },
    { 0x3E352422, "open_rocket_gantry" },
    { 0x3A55F6A7, "open_rocket_gantry_quickly" },
    { 0xB58E49A0, "open_rocket_stabilizer" },
    { 0x500E8D79, "open_rocket_stabilizer_quickly" },
    { 0x979762B0, "open_script_dialog" },
    { 0x0BD3D62A, "open_sesame" },
    { 0xDD777FD9, "open_skylight" },
    { 0x42D4CA84, "open_sliding_doors" },
    { 0x088B3A33, "open_sloth_barricades" },
    { 0x0C70BA92, "open_slow_door" },
    { 0x23A649B1, "open_spiderhole" },
    { 0x48AED379, "open_stinger_truck_door" },
    { 0x196C462B, "open_subway_gate" },
    { 0xE7DFF50C, "open_suv_doors" },
    { 0x411881A8, "open_table" },
    { 0x30FB7E18, "open_the_door" },
    { 0x47047CF3, "open_the_doors" },
    { 0x95A47CFF, "open_time" },
    { 0xE35A8655, "open_top_elevator_door" },
    { 0x778CECB5, "open_tower_trap_upgrade_panel" },
    { 0xEE40BFA3, "open_traincar_door" },
    { 0x1375AF58, "open_trigger" },
    { 0x686CFF59, "open_tunnel_door" },
    { 0x056AF8E2, "open_vault_doors" },
    { 0x3D6DEAB9, "open_water_gate" },
    { 0x5F08959D, "openable" },
    { 0x49762BD6, "openangle" },
    { 0xA0D46E58, "openangle_opp" },
    { 0xC0D08929, "opencraftablehudelem" },
    { 0x1D8ED894, "opendirection" },
    { 0x0E5CCEA9, "opendoor" },
    { 0xB4B8F9D6, "opened" },
    { 0x0B264324, "opened_exits" },
    { 0x30D1C1F0, "opener" },
    { 0x02C4C144, "opener_move" },
    { 0x5F2D88F7, "openfile" },
    { 0x7F7378DF, "opening" },
    { 0xCAE5E317, "opening_attach_book" },
    { 0x9010854A, "opening_attach_detach_player_weapon" },
    { 0x378041F9, "opening_attach_watch" },
    { 0xE7AC0119, "opening_book" },
    { 0xC2744B69, "opening_brooks_door" },
    { 0x80269CEA, "opening_cleanup" },
    { 0xC65CBF48, "opening_clip" },
    { 0x29655F75, "opening_detach_book" },
    { 0x7F98E4F1, "opening_detach_player" },
    { 0xB4E66F3B, "opening_detach_watch" },
    { 0xC5DFD32B, "opening_dialog_index" },
    { 0x1D9056E0, "opening_dialogs_list" },
    { 0x8492F961, "opening_end_path" },
    { 0x1CF53BEE, "opening_fake_german" },
    { 0x20FF5648, "opening_flashes" },
    { 0xACA5C27B, "opening_guy" },
    { 0x726F9E3B, "opening_hallway_door" },
    { 0x56BAAF1A, "opening_harris_door" },
    { 0xB1462191, "opening_hide_hands" },
    { 0x82634DDE, "opening_house_explosion" },
    { 0x5A95828A, "opening_init_complete" },
    { 0x48599D24, "opening_kick_face" },
    { 0x37A77135, "opening_knife" },
    { 0xC9A7136F, "opening_loop_fire_at_target" },
    { 0xC879CE65, "opening_main" },
    { 0xC20185F0, "opening_molotov_instructions" },
    { 0xADE72BCF, "opening_molotov_tossers_think" },
    { 0xC8646602, "opening_name_hide" },
    { 0xABD11ED2, "opening_objectives" },
    { 0x5A6F8127, "opening_outside_reaction" },
    { 0x9C6299C3, "opening_plane_flash" },
    { 0xFBBE96FC, "opening_player_speed_change" },
    { 0x8C54AA3A, "opening_player_straight" },
    { 0x251877FA, "opening_punch_face" },
    { 0x3A2AB893, "opening_react_to_tank_fire" },
    { 0x8385ADD4, "opening_russian_corpse" },
    { 0x845C352F, "opening_screen_dialogue_complete" },
    { 0xFE9ACB0D, "opening_sequence" },
    { 0x56B71030, "opening_sequence_dialog" },
    { 0x285A5BDA, "opening_sequence_flashlight" },
    { 0xBA2FEE00, "opening_sequence_notetracks" },
    { 0xDDB3E1E6, "opening_show_hands" },
    { 0x488309F8, "opening_spawn_fake_tank" },
    { 0x1FABD36F, "opening_spawn_germans" },
    { 0x3D0967D6, "opening_spawn_germans_think" },
    { 0x312C2572, "opening_spawn_molotov_tossers" },
    { 0x3D193003, "opening_spawn_more_tanks" },
    { 0x0D79246C, "opening_spawn_move_tank" },
    { 0xBC883B65, "opening_spawn_tanks" },
    { 0x7E49F2CA, "opening_tag" },
    { 0x3B8A1ABA, "opening_tank_1" },
    { 0x1587A051, "opening_tank_2" },
    { 0xE8D05AE7, "opening_tank_2_wait" },
    { 0x1323DFB0, "opening_timing" },
    { 0xBA281E3F, "opening_vo" },
    { 0x9D1FC017, "opening_watch" },
    { 0x7A4926E1, "opening_weaver_door" },
    { 0x0E2703A5, "opening_zeitzev_explosion" },
    { 0xA6CEE784, "opening_zeitzev_gunshotfx" },
    { 0x4A8CCB10, "openingleft" },
    { 0xF139C43F, "openingright" },
    { 0x48DF4F66, "openings" },
    { 0xD562CEA0, "openingtags" },
    { 0xA03E6A04, "openintrodoors" },
    { 0x9DF069DE, "openintroleftdoor" },
    { 0x99CB41F1, "openintrorightdoor" },
    { 0x25FF62C1, "openlist" },
    { 0xCBA427A2, "openlistid" },
    { 0x2F6B6A4C, "openluimenu" },
    { 0x862B4FBF, "openmainmenu" },
    { 0x4AA9CAAC, "openmenu" },
    { 0x5C0BCAE3, "openning" },
    { 0x08D25F94, "openpopupmenu" },
    { 0x236F9599, "openpos" },
    { 0x5BB5B8A4, "openroll" },
    { 0x728CFA20, "opens" },
    { 0xAA9146E4, "opensumpfammoboxlid" },
    { 0x0E8F4E83, "opentablecraftable" },
    { 0x8077B17E, "opentime" },
    { 0xF3AE1154, "opentimemax" },
    { 0x1E401C9A, "opentimemin" },
    { 0xB9021DF0, "operand" },
    { 0x2569346F, "operate" },
    { 0x7BE2EE39, "operated" },
    { 0xD9C7ABB6, "operates" },
    { 0xF41B4BEA, "operating" },
    { 0x432D2964, "operation" },
    { 0xEC696273, "operational" },
    { 0x37352597, "operations" },
    { 0xCDADF09B, "operatives" },
    { 0xA177BD5D, "operator" },
    { 0xBA50039C, "operators" },
    { 0x54680B30, "opforce_more_accurate" },
    { 0x89BE0D69, "opname" },
    { 0x010971CF, "opp_death" },
    { 0x31DAA07A, "opponent" },
    { 0xAEB131F5, "opponents" },
    { 0x94E00D6B, "opportunists" },
    { 0xB428CF14, "opportunities" },
    { 0x2BF07C98, "opportunity" },
    { 0xBABEDF21, "opposed" },
    { 0x6A918962, "opposing" },
    { 0xAAC6C822, "opposite" },
    { 0xF033A126, "opposite_team" },
    { 0x05FCAADC, "opposite_walls" },
    { 0xB274FC28, "oppositejukestate" },
    { 0xF1BF6E83, "oppositeperpendiculargoalpos" },
    { 0x8105B7C9, "opposition" },
    { 0x98DC30B8, "oppotunity" },
    { 0xEF1DC9F2, "oppposite" },
    { 0x28FCD515, "oppressors" },
    { 0xA0565DC2, "oppurtunities" },
    { 0x87E04711, "oprerate" },
    { 0xF56BED9B, "ops" },
    { 0xE8B1794D, "opsrey" },
    { 0x1B6E6804, "opt" },
    { 0x8E134DBE, "opt_in" },
    { 0x187EF442, "opt_on_off" },
    { 0x3B12F5DA, "opt_param_1" },
    { 0x15107B71, "opt_param_2" },
    { 0xEF0E0108, "opt_param_3" },
    { 0x3706EABF, "optential" },
    { 0xC4B9B21C, "optic" },
    { 0xDC77071B, "optical" },
    { 0x9D45435F, "optics" },
    { 0x0C620DC1, "optimal" },
    { 0x3A8E2004, "optimal_dist" },
    { 0xBFE820D1, "optimisation" },
    { 0xD960A2B6, "optimise_for_splitscreen" },
    { 0x1EA16F3A, "optimization" },
    { 0x2CE5DEB5, "optimizations" },
    { 0xE8D09A30, "optimize" },
    { 0xE49AEF7D, "optimize_for_splitscreen" },
    { 0x895A8A94, "optimized" },
    { 0x0330699B, "optimizes" },
    { 0xE167BEB1, "optimizing" },
    { 0x3E68681A, "optinal" },
    { 0x2E9393AE, "option" },
    { 0x867B9BE3, "option1" },
    { 0x14742CA8, "option2" },
    { 0x3A76A711, "option3" },
    { 0x1579C87A, "option_number" },
    { 0x26A8B438, "option_text" },
    { 0x53849DD5, "optional" },
    { 0x79946B19, "optional_arrived_at_node_func" },
    { 0xB9E20DF5, "optional_count" },
    { 0x0804F282, "optional_dialogue" },
    { 0x8BE17B3A, "optional_func" },
    { 0xCA167C68, "optional_glow_delete_flag" },
    { 0xEB7A8672, "optional_leader_dist" },
    { 0x588606A2, "optional_max" },
    { 0x2DF3FB5C, "optional_min" },
    { 0x0C1C8E05, "optional_player_target" },
    { 0x66B8998D, "optional_score_override" },
    { 0x0F40DCF2, "optional_useless_string" },
    { 0x9717990C, "optional_wait_max" },
    { 0xD47BA422, "optional_wait_min" },
    { 0x45CE856D, "optionalanimation" },
    { 0x4B67EFEF, "optionalarg" },
    { 0x3D142D8D, "optionalarmorvalue" },
    { 0x64D7AE3F, "optionalfunc" },
    { 0x5E84B638, "optionally" },
    { 0x3BA77924, "optionals" },
    { 0x889A14D4, "optionalstepeffectfunction" },
    { 0x97E54D7F, "optionalstepeffects" },
    { 0x4D4DC97C, "optionalweaponname" },
    { 0xB9D80CD1, "options" },
    { 0xF32AA5B4, "optionsmenu" },
    { 0xD0E2F6EE, "optiontype" },
    { 0xC40EECB7, "opts" },
    { 0xFB4143D2, "opulence" },
    { 0x1DEE7B02, "or" },
    { 0x2D74C54F, "orange" },
    { 0x316DB76A, "orange_guys" },
    { 0x518067B9, "orange_outro_obj" },
    { 0x94B5FC74, "orb" },
    { 0x29080AD0, "orb_height_offset" },
    { 0xFD20CECC, "orb_spinning_out" },
    { 0x9369EBBF, "orb_travel_velocity" },
    { 0x3C34401C, "orbis" },
    { 0xD166D7FC, "orbish" },
    { 0x1631C5B3, "orbit" },
    { 0x2D437253, "orbit_distance" },
    { 0xE711565E, "orca" },
    { 0x106CFA73, "order" },
    { 0x28120F45, "order_new_allysquad" },
    { 0xDA02E3FE, "order_new_allysquadcb" },
    { 0xFF70447F, "order_new_squad" },
    { 0x40B522E9, "orderaction" },
    { 0x17DF2374, "ordercover" },
    { 0x0DA69E8E, "orderdisplace" },
    { 0xF5620828, "ordered" },
    { 0xD0492875, "orderindex" },
    { 0x1D3CBC40, "ordermove" },
    { 0x9507B122, "orders" },
    { 0x032BD8A7, "ordersquadattack" },
    { 0x64B12633, "ordersquaddefend" },
    { 0xBFB90C1A, "ordersquadfollowai" },
    { 0x6D2356FF, "ordersquadfollowplayer" },
    { 0x2528A1C2, "ordersquadmanaged" },
    { 0x1DA161C7, "ordersquadmoveto" },
    { 0xFA7E17E1, "ordersquadpatrol" },
    { 0x7F5B7920, "orderto" },
    { 0x05F919F6, "ordinance" },
    { 0x4BBF6C4F, "ordinary" },
    { 0x80D07BB9, "ordinate" },
    { 0xB040E2F0, "ordinates" },
    { 0x6C0F7239, "ordnance" },
    { 0xD2F6D1BF, "ordnance_disposal_mp" },
    { 0x22AE8D39, "org" },
    { 0xCC3CCA02, "org1" },
    { 0xA63A4F99, "org2" },
    { 0x8037D530, "org3" },
    { 0x8A492E0F, "org4" },
    { 0x6446B3A6, "org5" },
    { 0x5DB58C6D, "org_1" },
    { 0x83B806D6, "org_2" },
    { 0x06297F7C, "org_angles" },
    { 0x78471D99, "org_animate" },
    { 0x270A6DF6, "org_breach_push" },
    { 0x17C29CFD, "org_closest" },
    { 0xE896C48F, "org_coord" },
    { 0xE4478537, "org_dudes" },
    { 0x6C5E890B, "org_end" },
    { 0x0C36E27B, "org_ent" },
    { 0x446D8A8F, "org_fall" },
    { 0x62571A2F, "org_hand" },
    { 0x63A0349C, "org_heli_spawn" },
    { 0x1B7B7023, "org_humanshield_playerview" },
    { 0x9D37292B, "org_mover" },
    { 0x66C8B150, "org_node" },
    { 0xA3B9885D, "org_offset" },
    { 0x2657EA2B, "org_physics_pusher" },
    { 0x0BA78F9A, "org_pos" },
    { 0x8A10F0B8, "org_rpg_plaza_01" },
    { 0x1F7902B1, "org_sound" },
    { 0xDB0C9587, "org_target" },
    { 0xB70D261A, "org_targetname" },
    { 0x4766BD28, "org_trigger" },
    { 0xA7284097, "org_view" },
    { 0xFCF66E3B, "org_view_roll" },
    { 0xECB3BDB2, "orga" },
    { 0x0F9E10B7, "organg" },
    { 0xA9DFC5A0, "organic" },
    { 0x6222598E, "organize" },
    { 0x612EFCCE, "organized" },
    { 0x607DE268, "orgarray" },
    { 0xC6B14349, "orgb" },
    { 0x6B8BE934, "orgbefore" },
    { 0xB9D89840, "orgent" },
    { 0xFE3F62EF, "orghealth" },
    { 0x73B73AB0, "orgin" },
    { 0xD1E30035, "orginal_chaffcount" },
    { 0xC0E5963C, "orginator" },
    { 0x57C7A010, "orgoffset" },
    { 0x7BB2122D, "orgorg" },
    { 0x7AD9EE91, "orgoverride" },
    { 0x00D66F70, "orgs" },
    { 0xFCE61CC6, "orgsuncolor" },
    { 0xBC931744, "orgsundirection" },
    { 0xE58C7F89, "orgweapon" },
    { 0xA2F1B1F3, "orgx" },
    { 0x7CEF378A, "orgy" },
    { 0x56ECBD21, "orgz" },
    { 0xC86540FD, "oriantation" },
    { 0x58453E06, "orient" },
    { 0x2B8E73AC, "orient_model" },
    { 0xB74F5600, "orient_to_normal" },
    { 0x41718FE2, "orientate" },
    { 0x31DF9689, "orientation" },
    { 0x2E5259E0, "orientationoffset" },
    { 0xF07A2E7E, "orientdone" },
    { 0x52FFFF89, "oriented" },
    { 0x19C0A4F9, "orientedpos" },
    { 0x9F4D2B1A, "orienting" },
    { 0x13FFB22B, "orientmode" },
    { 0x1F7E6A18, "orientmodehack_axis" },
    { 0x2258491F, "orientmodehack_axis_2" },
    { 0x759E8500, "orienttonormal" },
    { 0x2EB9125E, "orienttoplayerdeadreckoning" },
    { 0x31FC3BF2, "orienttoplayeryrot" },
    { 0x114C96FA, "orig" },
    { 0x42A71A72, "orig_1" },
    { 0x1CA4A009, "orig_2" },
    { 0x080F1EC7, "orig_alpha_entity" },
    { 0x1D7C6909, "orig_angles" },
    { 0x6FAC3158, "orig_attacker" },
    { 0x30F2D1F6, "orig_color" },
    { 0xE37E60CC, "orig_ent_1" },
    { 0x5585D007, "orig_ent_2" },
    { 0xB43DE32F, "orig_fx" },
    { 0x21A92679, "orig_gren_3" },
    { 0xA721906B, "orig_index" },
    { 0x6F7EAD2B, "orig_lighttweaksunlight" },
    { 0xDBC47108, "orig_name" },
    { 0x3FC3F51D, "orig_nightvisionfadeinouttime" },
    { 0xDC06D930, "orig_nightvisionpowerontime" },
    { 0xB6A568A7, "orig_origin" },
    { 0x880DB4D3, "orig_radius" },
    { 0x027D5EE1, "orig_spot" },
    { 0xF8B2D502, "orig_target" },
    { 0xAD50362B, "orig_trig" },
    { 0xDCF4E68F, "origcorner0" },
    { 0xB6F26C26, "origcorner1" },
    { 0x90EFF1BD, "origcorner2" },
    { 0x6AED7754, "origcorner3" },
    { 0x75C15B8F, "origheight" },
    { 0x722885F3, "origin" },
    { 0x48A336F9, "origin0" },
    { 0x22A0BC90, "origin1" },
    { 0x94A82BCB, "origin2" },
    { 0x6EA5B162, "origin3" },
    { 0xE0AD209D, "origin4" },
    { 0xBAAAA634, "origin5" },
    { 0xA05401E3, "origin_1" },
    { 0x2E4C92A8, "origin_2" },
    { 0x85937B33, "origin_add" },
    { 0x42D8B92B, "origin_animate" },
    { 0x6AB46326, "origin_animate_jnt" },
    { 0xC3A67627, "origin_animate_jnt_aligned" },
    { 0x1EA73401, "origin_array" },
    { 0xCE06072D, "origin_at_water" },
    { 0x3D321175, "origin_base" },
    { 0x25003025, "origin_below_water" },
    { 0x9473321A, "origin_body" },
    { 0x6839FC52, "origin_closed" },
    { 0x99A9A9FE, "origin_counter" },
    { 0xE50AAB37, "origin_explosion" },
    { 0xD5A3766B, "origin_firstframe_jnt_aligned" },
    { 0xDD8B07D5, "origin_forward" },
    { 0x49E252EC, "origin_fx" },
    { 0x742290CD, "origin_fx_init" },
    { 0x31655F0F, "origin_heli_target_8" },
    { 0xB8B0AB55, "origin_left" },
    { 0x15528EBF, "origin_linker" },
    { 0x52B20AA9, "origin_main" },
    { 0xF123EAD5, "origin_model" },
    { 0x9F74D233, "origin_name" },
    { 0xFD427482, "origin_node" },
    { 0x4D694EEC, "origin_norm" },
    { 0xAB7E1BD7, "origin_offset" },
    { 0x7C5575A8, "origin_offset_2d" },
    { 0x82A07122, "origin_old_z" },
    { 0xAC9A7989, "origin_opened" },
    { 0x161DC447, "origin_or_ent" },
    { 0x9351FE46, "origin_parent" },
    { 0xEF425524, "origin_point" },
    { 0x37E36210, "origin_pos" },
    { 0x64DE02CD, "origin_prev" },
    { 0x9767C97A, "origin_pt" },
    { 0x569207B8, "origin_right" },
    { 0xEFA559E0, "origin_sight_check_rating" },
    { 0xB823EA46, "origin_start" },
    { 0x675B9F72, "origin_straightline" },
    { 0x9D55EEE9, "origin_string" },
    { 0x0CB67B26, "origin_tag" },
    { 0xD33A7B80, "origin_targetname" },
    { 0x597F7512, "origin_to_next_node" },
    { 0xE81764D5, "origin_up" },
    { 0x54039011, "origin_up_offset" },
    { 0x79BD9510, "origin_vec" },
    { 0x504C3188, "origin_with_offset" },
    { 0xE618E48C, "original" },
    { 0x18A48B42, "original_aatarget" },
    { 0x5FEF3D83, "original_ai_array" },
    { 0xB45A2D24, "original_angle" },
    { 0x1FD4D857, "original_angles" },
    { 0x51C53F7C, "original_cost" },
    { 0xB44A2A68, "original_count" },
    { 0x8BC614ED, "original_drop_origin" },
    { 0xC04DB564, "original_exposure" },
    { 0x0A648A08, "original_goalradius" },
    { 0xBB7DD354, "original_group_size" },
    { 0xB60400C9, "original_health" },
    { 0x04C2962A, "original_killcam_ent" },
    { 0x3BB87FF3, "original_letter" },
    { 0x613F0017, "original_list" },
    { 0xD2F6FB2E, "original_location" },
    { 0xD868841D, "original_melee_miss_func" },
    { 0x0C740802, "original_model" },
    { 0x65F45AE7, "original_model_name_length" },
    { 0xCA0C926B, "original_node_name" },
    { 0xDA757507, "original_org" },
    { 0xC02AE609, "original_origin" },
    { 0x24961C78, "original_owner" },
    { 0xEAFC3F2E, "original_path" },
    { 0xD60A2BE7, "original_pitch" },
    { 0xB7E6C75F, "original_player_org" },
    { 0xA6204747, "original_point" },
    { 0x6360FA6F, "original_pos" },
    { 0x122DF1B2, "original_position" },
    { 0x8F02CD57, "original_prompt_and_visibility_func" },
    { 0x45BB513E, "original_pusher" },
    { 0xE01C74AF, "original_scale" },
    { 0xE436CB8B, "original_spot" },
    { 0xC38D2458, "original_suncolor" },
    { 0xF46535FD, "original_t" },
    { 0x945351A0, "original_team" },
    { 0xEB1D6A28, "original_time" },
    { 0x62690EB5, "original_trig" },
    { 0x307F94E1, "original_trig_name" },
    { 0x74ABEC6A, "original_trigger_func" },
    { 0xC03E16CB, "original_units_per_second" },
    { 0x739DEE2A, "original_value" },
    { 0x19AC5A79, "original_vehicle" },
    { 0xB1EB9A34, "original_vehicle_type" },
    { 0xE716A287, "original_weapon" },
    { 0xCB717C6D, "originalangle" },
    { 0x9D89E26C, "originalangles" },
    { 0x0908BC5C, "originalbombangles" },
    { 0xD48566BA, "originalbomborigin" },
    { 0x7AAC2C88, "originalenterpos" },
    { 0xD409A82D, "originalentity" },
    { 0xC86C17D5, "originalheight" },
    { 0x41D5F269, "originally" },
    { 0xA9D4588A, "originalorigin" },
    { 0x6B5F7EC4, "originaloverrideplayerdamage" },
    { 0x152A6AB9, "originalowner" },
    { 0x57F7D1A0, "originalownerentnum" },
    { 0x1B1AB5FD, "originalratio" },
    { 0x543918A9, "originalration" },
    { 0x2FD92415, "originalroll" },
    { 0x26456B01, "originalspawn" },
    { 0x99748464, "originalspot" },
    { 0x8B926AB7, "originaltarget" },
    { 0xF7F1E17F, "originalteam" },
    { 0x183DCE67, "originalvy" },
    { 0x951BF51C, "originalx" },
    { 0xBB1E6F85, "originaly" },
    { 0x307DC360, "originalyvelocity" },
    { 0xD979839E, "originarray" },
    { 0x8A0EA661, "originate" },
    { 0xA4302208, "originates" },
    { 0x84118528, "originendpoint" },
    { 0x8D6E6F61, "originfunc" },
    { 0x9D270D53, "originheightoffset" },
    { 0x3137E795, "originl" },
    { 0xCCFB34C4, "originoffets" },
    { 0x3B72491A, "originoffset" },
    { 0x82D7EE75, "originoffset_right" },
    { 0x4E482D12, "originoffset_up" },
    { 0x84B24C17, "originonterrain" },
    { 0x489C8D9E, "originpoints" },
    { 0x36713E11, "originprintstr" },
    { 0x0F6AC54F, "originrightpoint" },
    { 0xEF444BA2, "origins" },
    { 0xD0AD30FF, "origins1" },
    { 0x5EA5C1C4, "origins2" },
    { 0x84A83C2D, "origins3" },
    { 0x12A0CCF2, "origins4" },
    { 0x52A2D854, "originstr" },
    { 0xEF81D894, "originstring" },
    { 0x5C9266CF, "origintextoffset" },
    { 0xCBEA974B, "origintostring" },
    { 0x985E37F6, "origintrace" },
    { 0x5B7415CE, "originuppoint" },
    { 0xF955A481, "originx" },
    { 0xD3532A18, "originy" },
    { 0x611FACB0, "orign" },
    { 0xC1A80EB2, "orignr" },
    { 0xEF183D75, "origs" },
    { 0xBA203E3A, "origs_2" },
    { 0x0F127513, "origspeed" },
    { 0xD39C9BE8, "origweapname" },
    { 0x3B9A144E, "origwidth" },
    { 0xE506E496, "origx" },
    { 0x0B095EFF, "origy" },
    { 0x43E19808, "ornate" },
    { 0x33E582A0, "orphaned" },
    { 0x5A90D04D, "ors" },
    { 0xDD0754DC, "orthogonal" },
    { 0xE30FD83F, "ortiz" },
    { 0xC58FDFC6, "osamanendez" },
    { 0xC50584BA, "osc" },
    { 0x0B32891C, "osc_begin" },
    { 0x87D7E93F, "osc_button_cover_setup" },
    { 0x40993CC2, "osc_target" },
    { 0x56A0B7B7, "oscar" },
    { 0xE528761A, "oscillation" },
    { 0x25E1C563, "osp_ent" },
    { 0xB5350588, "ospot" },
    { 0x8AEBC107, "ospree" },
    { 0xAC9F0548, "ospree_ambient_room" },
    { 0x22F5AAAB, "osprey" },
    { 0x49CDA03E, "osprey_done" },
    { 0xB4AC2E9A, "osprey_name_list" },
    { 0x1531B761, "osprey_vtol" },
    { 0xBD49A58B, "oswald" },
    { 0x69F36FD4, "ot" },
    { 0x6B360568, "otgherwise" },
    { 0x05A952F1, "other" },
    { 0x030E5F81, "other_ais" },
    { 0x2511B638, "other_alias" },
    { 0xCC8DE865, "other_angle" },
    { 0x1299397C, "other_destnode" },
    { 0x4FD6EB25, "other_dials" },
    { 0xD3BE019C, "other_door_opened" },
    { 0x5A95683C, "other_dude" },
    { 0xE4536C33, "other_ent" },
    { 0x5374A166, "other_flamers_setup" },
    { 0xB019AA79, "other_friendlies" },
    { 0xCBBEF926, "other_fx" },
    { 0x82E4708D, "other_guy" },
    { 0xD4C25A1E, "other_guy1" },
    { 0xAEBFDFB5, "other_guy2" },
    { 0x88BD654C, "other_guy3" },
    { 0xAF969639, "other_guy_name" },
    { 0xE63769A8, "other_index" },
    { 0xFE5F9D07, "other_leader" },
    { 0xD2A4DFBE, "other_loc" },
    { 0x1F906ECA, "other_local_player_still_alive" },
    { 0x6DE60D7F, "other_lootxp_uploadstat_waittime" },
    { 0x7E3BF063, "other_nodes" },
    { 0x96F7F82F, "other_notify" },
    { 0x486F2FBA, "other_piece" },
    { 0x4857919A, "other_plane" },
    { 0x5EF36723, "other_player" },
    { 0xFE08805C, "other_players_close_to_light" },
    { 0xFA355456, "other_point" },
    { 0xF5C60A20, "other_rocket_pod" },
    { 0x33BBD9B0, "other_slot" },
    { 0x945129E6, "other_tank_name" },
    { 0xCFBDB557, "other_tanks" },
    { 0xF5C7299F, "other_target" },
    { 0x8363F9F7, "other_team" },
    { 0x060AF072, "other_team_mask" },
    { 0x28FB162B, "other_team_pickup_trigger" },
    { 0xB54E3CE2, "other_trig" },
    { 0xA4627FEB, "other_triggers" },
    { 0x0928ADBA, "other_turret_target" },
    { 0x1AE4F24F, "other_vehicles" },
    { 0x754097E6, "other_worker" },
    { 0x2AA1C04B, "other_zero_no_flash" },
    { 0x4E66BB2E, "otherangle" },
    { 0x700127F6, "otherangleinc" },
    { 0x771CBDB2, "otheravoidpoint" },
    { 0x4F2D618B, "otherbetty" },
    { 0x1E807E4A, "otherbombzones" },
    { 0x224B1B43, "otherclientent" },
    { 0x55BB4244, "otherclientnum" },
    { 0x7B464078, "otherclosestpoint" },
    { 0x51E50309, "otherdata" },
    { 0x343CE632, "otherdesc" },
    { 0x915BECD1, "otherdoor" },
    { 0x7457C458, "otherent" },
    { 0x1E4CA7F2, "othergrenadetrackingstart" },
    { 0x74D1F94A, "otherguy" },
    { 0xAA614E85, "otherguys" },
    { 0x02300E6D, "otherhelicopterforward" },
    { 0x8191A1CF, "otherhelicopterreforigin" },
    { 0x318AE2C0, "otherhud" },
    { 0x5A06A793, "otherhudtodestroy" },
    { 0xE204C833, "otherindex" },
    { 0x42DB037D, "otherinfront" },
    { 0xFA057837, "otheritems" },
    { 0xC1BE8170, "otherlocalplayerstillalive" },
    { 0x7A73F1EB, "othermannequin" },
    { 0x07BBF038, "othermodel" },
    { 0x6506D950, "otherpillars" },
    { 0xD940D5EE, "otherplayer" },
    { 0x3B277D0A, "otherplayerindex" },
    { 0x53E8D298, "otherplayersspectate" },
    { 0x3879C8E5, "otherplayersspectateclient" },
    { 0x87BFE158, "others" },
    { 0xAC1D9D46, "others_hijack_start" },
    { 0x8A6507C5, "otherscore" },
    { 0xE5746B50, "otherside" },
    { 0xE361B94F, "othersideanim" },
    { 0xA4EA707E, "othersize" },
    { 0x907BAD5A, "otherspawners" },
    { 0x868E64B4, "othersquadfriendly" },
    { 0xEE61CC9D, "otherstance" },
    { 0x707231AA, "othertarget" },
    { 0x370D2BA6, "otherteam" },
    { 0x2952248B, "otherteammessage" },
    { 0x9F9262D9, "otherteammomentummultiplier" },
    { 0xAA574D4A, "otherteampickuptrigger" },
    { 0x3B0F5078, "otherteamscore" },
    { 0xA6F940A6, "othertime" },
    { 0x02A498E3, "othertrig" },
    { 0xBE091F8D, "othervec" },
    { 0xAE607634, "othervisuals" },
    { 0xD4247EE1, "otherwise" },
    { 0x06CF11C4, "otvnt" },
    { 0x2DB57EC4, "ought" },
    { 0x9F085615, "oughta" },
    { 0x3D5EEEEE, "ounteruav" },
    { 0xB0548865, "our" },
    { 0x00A9BAC3, "our_team" },
    { 0xA8823B74, "ours" },
    { 0x9388D8EB, "ourself" },
    { 0x70F9711F, "ourselves" },
    { 0x0DE1AB42, "ourteam" },
    { 0x3AE34ADC, "ouside" },
    { 0x644F9393, "out" },
    { 0x33DAF95A, "out_angles" },
    { 0xF7DD43F6, "out_of_ammo" },
    { 0x2CAFF16A, "out_of_ammo_sound" },
    { 0xD0D9F6B2, "out_of_bounds_watcher" },
    { 0x2508E4C1, "out_of_chair_idle_check" },
    { 0xD6576F26, "out_of_chair_idle_control" },
    { 0x322F1A4E, "out_of_chair_vision" },
    { 0x447D5C65, "out_of_chopper" },
    { 0xC605E00E, "out_of_cqb_until_near_goal" },
    { 0xDC7CA880, "out_of_fountain" },
    { 0xF52DE2ED, "out_of_fountain_conditions" },
    { 0x2C1F89B1, "out_of_macv" },
    { 0x5449D781, "out_of_mana" },
    { 0x7354C584, "out_of_market" },
    { 0x304B81E5, "out_of_range_hud" },
    { 0xECDBD158, "out_of_range_prompt" },
    { 0x25512AC9, "out_of_range_update" },
    { 0xA8D322D9, "out_of_spiderhole" },
    { 0x55924F84, "out_point" },
    { 0x541FA73B, "out_this_bitch" },
    { 0x63CC43E1, "out_time" },
    { 0xEE368ED7, "out_truck_and_run" },
    { 0x0EC70BA0, "outage" },
    { 0x7960EB0D, "outbound" },
    { 0x8734136C, "outcolor" },
    { 0x97390CCF, "outcome" },
    { 0x787E2EA4, "outcomenotify" },
    { 0xE35AB096, "outcomes" },
    { 0xC95B906A, "outcometext" },
    { 0x9CDC61FB, "outcometitle" },
    { 0xDB7C1717, "outdoor" },
    { 0x1B397F2E, "outdoor_think" },
    { 0xE09492CE, "outdoors" },
    { 0xC8939F4E, "outer" },
    { 0xF45CBC01, "outer_ambience" },
    { 0x6C628DFE, "outer_bar_aligned_anims" },
    { 0x1D65544A, "outer_damage" },
    { 0x1C88A835, "outer_door" },
    { 0x7FF5EE2E, "outer_edge" },
    { 0x7382F5D1, "outer_guys" },
    { 0x7CC9D668, "outer_radii" },
    { 0x1E1D68C7, "outer_radius" },
    { 0xD027CBFC, "outer_range" },
    { 0xDA1FB34E, "outer_ruins_advance_destroy_turrets" },
    { 0x35F36308, "outer_ruins_ammo_carry_right" },
    { 0x79C44AB6, "outer_ruins_main" },
    { 0x81589015, "outer_ruins_plant_turret" },
    { 0xE80DA635, "outer_ruins_turret_activate" },
    { 0xAD277D1E, "outer_ruins_turret_lasers" },
    { 0x41256A4E, "outer_ruins_turret_think" },
    { 0x27F96A00, "outer_ruins_vo" },
    { 0x40AB5F31, "outer_solar_cleanup" },
    { 0x3BBA3BD1, "outer_solar_fx" },
    { 0x0F9694CB, "outer_solar_objectives" },
    { 0x48F0619A, "outer_zigzag_radius" },
    { 0x0D0DE9A5, "outerbox" },
    { 0xEFC62D47, "outerdetect" },
    { 0x9A3EE827, "outerdif" },
    { 0x8A10CB8B, "outermost" },
    { 0x6811BA30, "outerpos" },
    { 0xB8B74568, "outerradius" },
    { 0x7A187465, "outerspacing" },
    { 0x84E557C2, "outerspawns" },
    { 0x44014640, "outerzigzagradius" },
    { 0x43354744, "outfitindex" },
    { 0x80E98F09, "outframes" },
    { 0x729C385C, "outgunned" },
    { 0x3267B125, "outhouse" },
    { 0x8B77927B, "outident" },
    { 0x0981EF8D, "outing" },
    { 0x73B8F1BD, "outlaw" },
    { 0x1D1E77FB, "outlength" },
    { 0x6E7F10AE, "outliers" },
    { 0x13A84661, "outline" },
    { 0x672B25B8, "outline_ally_disrupt" },
    { 0xA434E468, "outline_ally_normal" },
    { 0x48BD40F6, "outline_enemy_disrupt" },
    { 0xCAE60B8E, "outline_enemy_normal" },
    { 0x37516FF1, "outline_predator" },
    { 0x08E8DC41, "outline_predator_break" },
    { 0xAB400177, "outlined" },
    { 0x46309EA7, "outnumbered" },
    { 0xDB2D616A, "outofally_watch" },
    { 0x86A74E60, "outofboundsmaxtime" },
    { 0x64CD401C, "outofboundstime" },
    { 0xF215355D, "outofboundswatcher" },
    { 0xDAD0D5B8, "outofenemy_watch" },
    { 0x75017E6B, "outofrange" },
    { 0x240F261D, "outoftruck" },
    { 0xE2551C09, "outorigin" },
    { 0x12BDBFA9, "outpost" },
    { 0xAE116BA4, "outpost_objectives" },
    { 0x180A8C46, "output" },
    { 0xB611A24C, "output_name" },
    { 0x1695CA61, "output_props" },
    { 0xD764D8C1, "outputstring" },
    { 0x695FD32B, "outr" },
    { 0xDBBFE4D6, "outro" },
    { 0x2BE6C417, "outro_amb" },
    { 0xFF23E9AA, "outro_anim" },
    { 0xEEA994D4, "outro_animate_radio_model" },
    { 0xBE407071, "outro_cachenpcs" },
    { 0x470714EE, "outro_cacheplayer" },
    { 0x8465963A, "outro_cachevehicles" },
    { 0x2B6F2471, "outro_camera_shutdown" },
    { 0x41B328D4, "outro_claw" },
    { 0xED35E11E, "outro_claw2" },
    { 0x5459FBF8, "outro_claw_exploder" },
    { 0x5632CCEE, "outro_claws_fire" },
    { 0x3DD8D2A3, "outro_convoy" },
    { 0x2C6B96FE, "outro_damage_watch" },
    { 0x170EF5DF, "outro_deadguys" },
    { 0x7FEB2B7B, "outro_delete_grenade" },
    { 0x8C85042F, "outro_dialogue" },
    { 0xC250B59D, "outro_door" },
    { 0xE462B661, "outro_emp_explosion" },
    { 0x9EC80C03, "outro_emp_lights" },
    { 0x132495EF, "outro_event" },
    { 0x868EC8B2, "outro_fade_out" },
    { 0x0E85C6AD, "outro_fade_white" },
    { 0x3142897E, "outro_fading" },
    { 0x6665A345, "outro_flag_notify_unlink" },
    { 0xA947CC73, "outro_fx" },
    { 0x51AE3032, "outro_guy0" },
    { 0x77B0AA9B, "outro_guy1" },
    { 0x346CCA69, "outro_hands_callback" },
    { 0x3576FAD3, "outro_harper" },
    { 0x76D7336C, "outro_hud" },
    { 0x36A05A61, "outro_kill_treesniper" },
    { 0x131C781C, "outro_knife_blood_drips" },
    { 0xC33773A2, "outro_launcher_logic" },
    { 0xA153563F, "outro_launchers_fire" },
    { 0x9E314C2E, "outro_mg_guy_strat" },
    { 0xF248C15F, "outro_models" },
    { 0x2C836902, "outro_movie_done" },
    { 0x5FA70F79, "outro_narration" },
    { 0x0078A24D, "outro_narration_callback" },
    { 0xCC792E54, "outro_pip" },
    { 0x1F0A3D90, "outro_player_claw" },
    { 0xE562C7B1, "outro_player_destroyed_targets" },
    { 0x8264A208, "outro_player_escaped" },
    { 0x0298A260, "outro_player_succeeded" },
    { 0x9E624333, "outro_president" },
    { 0x5290A0E4, "outro_prevent_bleedout" },
    { 0xD5B1A8ED, "outro_pullout_fx" },
    { 0xDA492019, "outro_push" },
    { 0xE608B899, "outro_remotemissile" },
    { 0xD12CC55E, "outro_retreaters_2_extra" },
    { 0xD0DAB609, "outro_retreaters_2_extra_strat" },
    { 0xE4038AFB, "outro_retreaters_3_extra" },
    { 0x141750A4, "outro_retreaters_4_extra" },
    { 0x5D2B00D9, "outro_retreaters_5_extra" },
    { 0xFAEB590A, "outro_retreaters_6_extra" },
    { 0x31711975, "outro_rocket" },
    { 0x1182BB8B, "outro_samuels" },
    { 0x45939BCF, "outro_scene" },
    { 0xC0B4DFB5, "outro_set_truck_animtree" },
    { 0x6F2BF6A1, "outro_skipto_setup" },
    { 0xEADE8BCC, "outro_soldiers" },
    { 0x05EE9F3D, "outro_spot" },
    { 0xF9C9FD26, "outro_stab_fx" },
    { 0x3AF35487, "outro_start" },
    { 0x0B36C04B, "outro_startpoint" },
    { 0xC0F6715B, "outro_tank_move_1" },
    { 0xF90CB4C2, "outro_target_watch" },
    { 0x3D3B8DFF, "outro_vtol1" },
    { 0xCB341EC4, "outro_vtol2" },
    { 0xCC0C1EF3, "outro_wind_snd" },
    { 0xFB61A7F7, "outroally_squadquantityupdate" },
    { 0x86290007, "outroblack" },
    { 0x02DB076C, "outroloc" },
    { 0x46E2C98A, "outroscreen" },
    { 0xD146D0EA, "outrun" },
    { 0x435D58C2, "outs" },
    { 0x572F581E, "outside" },
    { 0xAC36CEFB, "outside_arena_fail_time" },
    { 0x913E77F3, "outside_cleared" },
    { 0xCF4FC2C5, "outside_courtyard_mortars" },
    { 0x5FBB0C5B, "outside_dead" },
    { 0x67A0BE07, "outside_fov_ai" },
    { 0xAE996914, "outside_ghost_zone_spawning_think" },
    { 0x7C6E0EC1, "outside_guys" },
    { 0x9E616D56, "outside_joins_in" },
    { 0x1E824FDD, "outside_lab_alarms_off" },
    { 0xCDD5EBC3, "outside_lift_init" },
    { 0x014758DD, "outside_lift_move_down" },
    { 0xCAE7F732, "outside_lift_move_up" },
    { 0x16B47270, "outside_march_off" },
    { 0xD7491FDD, "outside_node" },
    { 0x6B8380B5, "outside_of_map" },
    { 0x66F54820, "outside_plane_sweep" },
    { 0x0DB97C3D, "outside_pos" },
    { 0xCDD4F704, "outside_reaction" },
    { 0x06AF7597, "outside_scene" },
    { 0x952A0EF7, "outside_scene_civs" },
    { 0x045CD77E, "outside_spawners" },
    { 0x1A1C3D94, "outside_vo" },
    { 0xBF1930FE, "outside_zones" },
    { 0x6EBC2635, "outsidebox" },
    { 0x1D77B529, "outsidegoalradius" },
    { 0x93D7A1B5, "outsiderange" },
    { 0xA2048CB8, "outsidetargets" },
    { 0xF3F69784, "outsidevisionfile" },
    { 0xA52F9A7F, "outskirts" },
    { 0xD501470A, "outskirts_fall_death" },
    { 0x90A8A3CB, "outstanding" },
    { 0x24F3A5FE, "outta" },
    { 0x58BD82A7, "outta_sight_outta_mind" },
    { 0x4C81BF74, "outtahere" },
    { 0x40D8FEEC, "outter" },
    { 0x44AFE241, "outter_x" },
    { 0x55133028, "outtime" },
    { 0xBE276348, "outtro" },
    { 0xCDD3D08B, "outtro2_viewhands_anim_done" },
    { 0x626C2A61, "outtro_hide_hud" },
    { 0x09EF3E8D, "outtro_start" },
    { 0x4184A02A, "outvalue" },
    { 0x3BC7FB5E, "outvar" },
    { 0xF8CAB55C, "outwards" },
    { 0x1B00BCBF, "ove" },
    { 0x9DC5C8B2, "ovens" },
    { 0xADA5092F, "over" },
    { 0xDBB7E165, "over_anim" },
    { 0x7C5145CB, "over_black" },
    { 0xA189AE50, "over_here" },
    { 0x221920AF, "over_ledge_obj" },
    { 0x29C7D4EC, "over_pipe_obj" },
    { 0x8BA6E0BE, "over_wall_anim" },
    { 0xD6A6539F, "over_wall_think" },
    { 0x85550EBC, "overall" },
    { 0x8337E28D, "overall_counter" },
    { 0x672F2701, "overall_width" },
    { 0x023D5275, "overallocation" },
    { 0x2C99498D, "overallsuccess" },
    { 0x0F977723, "overbed_spot" },
    { 0x6F87F4AE, "overbrightness" },
    { 0xCE4D7F57, "overclock" },
    { 0x00DEE146, "overcoming" },
    { 0xFF094AF3, "overcorrection" },
    { 0x8FF46145, "overdrive" },
    { 0x6AA70F72, "overdrive_blur_amount" },
    { 0x6CE108A7, "overdrive_blur_inner_radius" },
    { 0x76D1B4B0, "overdrive_blur_outer_radius" },
    { 0x9F632B40, "overdrive_blur_velocity_scale" },
    { 0x7EA2EDCB, "overdrive_blur_velocity_shouldscale" },
    { 0x2C5E9AC1, "overdrive_boost_fx_duration" },
    { 0x2E0C658B, "overdrive_boost_fx_interrupt_handler" },
    { 0x33ADB1A3, "overdrive_show_boost_speed_tolerance" },
    { 0x8E10AA46, "overdrive_shutdown" },
    { 0x1847BDE0, "overdrive_visionset" },
    { 0xD0C4075D, "overdrive_visionset_alias" },
    { 0x7808F743, "overdrive_visionset_priority" },
    { 0x9C24FA19, "overdrive_visionset_ramp_hold" },
    { 0x04A0D07F, "overdrive_visionset_ramp_in" },
    { 0x67BAD3AA, "overdrive_visionset_ramp_out" },
    { 0x66DC50A4, "overdrive_visionset_steps" },
    { 0x6A76C0BF, "overflow" },
    { 0x644D46AE, "overflow_ai_takeover_off" },
    { 0xC3838F80, "overflow_ai_takeover_on" },
    { 0xBC8CB3C9, "overflow_ai_takeover_trigger" },
    { 0x975D8912, "overflow_aigrenadeget" },
    { 0x6AE28EF4, "overflow_custom_introscreen" },
    { 0x8D919F63, "overflow_geo_changes" },
    { 0xC84B3395, "overflow_introsetupbinoculars" },
    { 0xB4BB1A64, "overflow_intruderwatch" },
    { 0xCCEDFF1E, "overflow_level_player_startfps" },
    { 0xA662F258, "overflow_level_precache" },
    { 0xD8DD92D0, "overflow_level_scenario_one" },
    { 0x9B2D67DE, "overflow_level_setup" },
    { 0xA99E8952, "overflow_missile_oob_check" },
    { 0xC59967AE, "overflow_mission_complete" },
    { 0x9196CF7D, "overflow_mission_complete_s1" },
    { 0xA9AEA18F, "overflow_movie_think" },
    { 0xA9801172, "overflow_outro_fail" },
    { 0x83BA0D5C, "overflow_outro_player_fire" },
    { 0xFF0C80D2, "overflow_outro_player_switchtopistol" },
    { 0x1C8A0853, "overflow_outro_player_takes_picture" },
    { 0x5C8E1F43, "overflow_outro_success" },
    { 0x01B57286, "overflow_outro_zhao_hit_slowmo" },
    { 0x76EE9935, "overflow_player_oobwatch" },
    { 0xC7BA7EFA, "overflow_scene_outro" },
    { 0xD74936A2, "overflow_setstart" },
    { 0xC6167232, "overflow_setup_devgui" },
    { 0x5E359808, "overflow_startintro" },
    { 0xEBDABEA0, "overflow_startintro_fadein" },
    { 0x85A42698, "overflow_watch_devgui" },
    { 0x7263D9F8, "overflowcodespawner" },
    { 0x981D99C4, "overflowed" },
    { 0x352BF241, "overflowing" },
    { 0x40AEC7EB, "overhang" },
    { 0x409A05CE, "overhang_start" },
    { 0x83FF8ACA, "overhangs" },
    { 0xD5CE76D1, "overhaul" },
    { 0xE5BD9DC9, "overhead" },
    { 0xBA6255AE, "overhead_fire_end" },
    { 0xE488EFDD, "overhead_fire_start" },
    { 0x1DDACD9C, "overhead_flyby" },
    { 0xD94FB198, "overhead_german_firing" },
    { 0x0FB0816D, "overhead_planes" },
    { 0x45E54459, "overheat" },
    { 0x1CB3A8CD, "overheat_1" },
    { 0x42B62336, "overheat_2" },
    { 0x3248DD83, "overheat_bar" },
    { 0xA1CE8C4D, "overheat_bg" },
    { 0x09010AD0, "overheat_disable" },
    { 0xFE48D3A9, "overheat_enable" },
    { 0x543ECDBE, "overheat_flashing" },
    { 0x8379E25E, "overheat_fx" },
    { 0x3C14B819, "overheat_fx_playing" },
    { 0x914D82AF, "overheat_fx_rate" },
    { 0x9062F8AF, "overheat_hud" },
    { 0x789E561C, "overheat_hud_drain" },
    { 0x36F34BE5, "overheat_hud_update" },
    { 0xD888F0D3, "overheat_overheated" },
    { 0x90ABE679, "overheat_setcolor" },
    { 0x9725A1BA, "overheat_status" },
    { 0xBE60498C, "overheat_status2" },
    { 0x55D0B30D, "overheat_status_rampdown" },
    { 0x134C7E8F, "overheat_time" },
    { 0x1B9F25D1, "overheat_val" },
    { 0x299A5286, "overheated" },
    { 0x14E560EF, "overheating" },
    { 0x0E1CE810, "overheats" },
    { 0xA04326BD, "overide" },
    { 0xB3E84B7C, "overides" },
    { 0xF04BCF50, "overidevehicledamage" },
    { 0x94D0B92B, "overkill" },
    { 0x9B34206E, "overlap" },
    { 0x81292BB6, "overlapping" },
    { 0x7BD2D391, "overlaps" },
    { 0x95EF5D1C, "overlapsqr" },
    { 0x9122C78F, "overlay" },
    { 0x048AA7A0, "overlay_coords" },
    { 0xE50E6C5F, "overlay_cpr" },
    { 0x35CFC2B9, "overlay_id" },
    { 0x4C3E4A0F, "overlay_lerp_cb" },
    { 0xE2DC8426, "overlay_slot_cb" },
    { 0x842EA94B, "overlay_update_cb" },
    { 0xF41F5505, "overlayclients" },
    { 0xE1479B80, "overlayicon" },
    { 0x5A938650, "overlayid" },
    { 0xED3ED80E, "overlaypointer" },
    { 0x0F88E156, "overlays" },
    { 0x7C768C22, "overlaysmoke" },
    { 0xD9650F1B, "overload" },
    { 0x7AC1EF90, "overloaded" },
    { 0x89110E5D, "overloaded_func" },
    { 0x50AA869C, "overloaded_funcs" },
    { 0x58306085, "overloading" },
    { 0xF11D6A72, "overlook" },
    { 0x9452B618, "overlook_alarm" },
    { 0x13C04FCA, "overlook_attack_begins" },
    { 0x51FC239D, "overlook_attention" },
    { 0x7B7B9713, "overlook_badguys_pour_in" },
    { 0xAFC273F6, "overlook_enemy_leaves_stealth" },
    { 0x254FF104, "overlook_enemy_waits_for_player" },
    { 0x64C6F77D, "overlook_mortars" },
    { 0x39724C76, "overlook_player_mortarvision" },
    { 0x01338501, "overlook_price_tells_you_to_shoot_mgs" },
    { 0xDA843352, "overlook_runner_think" },
    { 0x628525C2, "overlook_runners" },
    { 0x2545A6BF, "overlook_sniping" },
    { 0x43D7EFC6, "overlook_turret_think" },
    { 0x3BCCDCFE, "overlooking" },
    { 0xD818923E, "overlord" },
    { 0xD9F979F2, "overly" },
    { 0xC16AE4F8, "overpass" },
    { 0x0554CEB4, "overpass_baddies_attack" },
    { 0xE0312968, "overpass_baddies_flee" },
    { 0xE55E3AE4, "overpasses" },
    { 0xD7C68047, "overridded" },
    { 0x5BADB82D, "overridden" },
    { 0x687CD74D, "override" },
    { 0x16D03066, "override_abort" },
    { 0xFCA5F00D, "override_actor_killed" },
    { 0x6D0B4D0A, "override_aitype" },
    { 0x24CE057F, "override_anim" },
    { 0x27B0D886, "override_back_five_to_nodes" },
    { 0x7C306EC8, "override_back_two_to_nodes" },
    { 0xE8D33C86, "override_balcony_vo" },
    { 0xC7AAF2B0, "override_board_repair_sound" },
    { 0xCAED70FB, "override_board_teardown_sound" },
    { 0x70188051, "override_bridge_bloodbath" },
    { 0x61455688, "override_class" },
    { 0x7A5584A3, "override_damage" },
    { 0x2B9B8DE9, "override_direction_change_chance" },
    { 0x4D9432F0, "override_dist" },
    { 0x09E6C1B4, "override_enemy" },
    { 0x519A74F1, "override_entity_camera_in_demo" },
    { 0xA5A92A08, "override_friend" },
    { 0xD23A64D1, "override_friendlyfire" },
    { 0x54FD71A4, "override_front_two_to_nodes" },
    { 0x5E664F57, "override_hacked_killstreak_reference" },
    { 0x309A2F81, "override_height" },
    { 0x38E543B4, "override_index" },
    { 0x0E4D2D4C, "override_keys" },
    { 0x18656254, "override_length" },
    { 0xDAB54D20, "override_max_speed_ahead" },
    { 0x410DBB8B, "override_notify" },
    { 0xC76817FD, "override_perk_targetname" },
    { 0x843B4F71, "override_player_damage" },
    { 0x15FF2F9D, "override_player_horse_speed" },
    { 0xB8213F66, "override_player_look_at_me" },
    { 0x7018BC1C, "override_player_scot_node" },
    { 0x4003BADD, "override_quad_explosion" },
    { 0x26F59252, "override_radius" },
    { 0x86DB50C0, "override_riotshield_damage_func" },
    { 0x399657A6, "override_roto_anim" },
    { 0xEEBFE6B6, "override_rumble_dist" },
    { 0x494A424A, "override_rumble_type" },
    { 0xAF1C0C46, "override_russian_names" },
    { 0xE61A6A48, "override_spawned_aitype_func" },
    { 0xC96B57E4, "override_squad_to_nodes" },
    { 0xD1BC6F9F, "override_start_angles" },
    { 0xFC046FB4, "override_swim_movement" },
    { 0x02172F1A, "override_target_node" },
    { 0x76846F3D, "override_thundergun_damage_func" },
    { 0xB32BF891, "override_transition_in" },
    { 0xB6DD2D8E, "override_trig" },
    { 0x8E77AD87, "override_use_solo_revive" },
    { 0x773B18B9, "override_vip_to_nodes" },
    { 0xC3F272C9, "override_weapon_drop_weights_by_level" },
    { 0xF622FAC4, "override_width" },
    { 0x44A68A57, "overrideactordamage" },
    { 0xD4F64EB5, "overrideactordamage_fakefight" },
    { 0x87A5B3A8, "overrideactordamageorig" },
    { 0x2B9436F7, "overrideactorkilled" },
    { 0x67018EF4, "overrideaicharacter" },
    { 0x2D59B8C0, "overrideammodropheroweapon" },
    { 0x47D114D2, "overrideanim" },
    { 0xC54DACF9, "overrideblendoutanim" },
    { 0x7AEEBC2A, "overridedamage" },
    { 0x2EF8C823, "overridedropposition" },
    { 0xDD7ACE3E, "overridedvar" },
    { 0x5D9D35E5, "overrideentitycamera" },
    { 0x7C99BE19, "overrideentitycameraindemo" },
    { 0x78175C63, "overrideglobalspawnfunc" },
    { 0x24F30BDF, "overrideidleanimarray" },
    { 0xF65223D9, "overriden" },
    { 0x1554F271, "overrideplayerdamage" },
    { 0x60578D52, "overrideplayerdeadstatus" },
    { 0x23A0975C, "overrideplayerdeathwatchtimer" },
    { 0x82EFC589, "overrideplayerkilled" },
    { 0x077299E4, "overrideplayerscore" },
    { 0x3845BFCC, "overrides" },
    { 0x962EB8AE, "overridespawn" },
    { 0x5397B478, "overridespectator" },
    { 0xEDEBA204, "overrideteamscore" },
    { 0xDC29A320, "overridevehicledamage" },
    { 0x7BAE2253, "overridevehicledamageorig" },
    { 0x60BDC617, "overridevehicledeath" },
    { 0x65A4362F, "overridevehicledeathpostgame" },
    { 0x5FBDA1B0, "overridevehiclekilled" },
    { 0xADBBF126, "overridevehicleradiusdamage" },
    { 0xA11526E7, "overrideweaponfunc" },
    { 0xD3B54168, "overridezombiespawn" },
    { 0xDCCDE6F8, "overriding" },
    { 0xA4184623, "overrode" },
    { 0xE56C43E1, "overrridegetoutrig" },
    { 0x8D04F615, "overrridewhenindemo" },
    { 0x123CC96E, "overrun" },
    { 0x0EBA6176, "overs" },
    { 0xC281B2C9, "oversees_camp" },
    { 0xA10A4440, "overshoot" },
    { 0x01F02970, "overshootdist" },
    { 0xCB5CDC58, "overshooting" },
    { 0xD509396B, "overshoots" },
    { 0xAE047C0A, "oversight" },
    { 0x326B8C00, "overspawning" },
    { 0x49F9A412, "overtake" },
    { 0x52E6A4F2, "overtakenow" },
    { 0x49DA09C3, "overtaking" },
    { 0x3B9EB29C, "overtime" },
    { 0x5278D6AF, "overtimeinterval" },
    { 0x37A3664C, "overtimetimelimit" },
    { 0xBFBA2A64, "overtop" },
    { 0xFECD0441, "overturned" },
    { 0x810FD21E, "overun" },
    { 0x61CA5C38, "overview" },
    { 0xC983733F, "overwall" },
    { 0xEF4ECB68, "overwatch" },
    { 0x8DD05F42, "overwatch_drop_offset" },
    { 0x8CB8599D, "overwatch_spawner" },
    { 0x753D845E, "overwhelm" },
    { 0xB0EE58A1, "overwhelmed" },
    { 0x774DCDE2, "overwhelming" },
    { 0xDCC62101, "overwites" },
    { 0x54C136A4, "overwrite" },
    { 0xE5CC28BF, "overwrite_anim_playerview" },
    { 0xDBA9E2A2, "overwrite_anim_playerview_down" },
    { 0x10E68A41, "overwrite_anim_playerview_left" },
    { 0x6C7EDC2C, "overwrite_anim_playerview_right" },
    { 0x7849B839, "overwrite_anim_playerview_up" },
    { 0xEBB0BB18, "overwrite_detect_ranges_2" },
    { 0xA7B0852D, "overwriting" },
    { 0xF32A464A, "overwritted" },
    { 0x77117E30, "overwritten" },
    { 0x71170A70, "ovr" },
    { 0xBDA12D2E, "ovrride" },
    { 0xDDCEA7F0, "owe" },
    { 0x7FE9EA73, "own" },
    { 0xA2F9D58B, "own_player_hard" },
    { 0x17A1EE00, "ownage" },
    { 0x1A007828, "owned" },
    { 0xFBA8DEFD, "owned_flag_influencer" },
    { 0x5E36FD2E, "owner" },
    { 0x04BAB063, "owner1" },
    { 0x92B34128, "owner2" },
    { 0x2E41CD5B, "owner_cent" },
    { 0x3CD767E1, "owner_change" },
    { 0x0071BDF7, "owner_changed" },
    { 0x0BBCA234, "owner_ent" },
    { 0x2C25ABFE, "owner_in_line_of_fire" },
    { 0xE179F69A, "owner_team" },
    { 0x188B928E, "owneradsatlaunch" },
    { 0x544A3985, "ownerdeathcount" },
    { 0x929473D5, "ownerent" },
    { 0xAEA70E9A, "ownerentenum" },
    { 0x0644F3EB, "ownerentity" },
    { 0x3417DB5F, "ownerentnum" },
    { 0x88484255, "ownerforward" },
    { 0x1A6B5A89, "ownerforwardvec" },
    { 0x5A5C7F74, "ownergetsassist" },
    { 0x4AAE4772, "ownerhadactivedogs" },
    { 0xB5C94AD5, "ownerleft" },
    { 0x9C8D71B3, "ownername" },
    { 0xBED2FBE5, "ownernumber" },
    { 0x8CFA1614, "ownerorigin" },
    { 0x22CABD0A, "ownerrequireddeathcount" },
    { 0x38172151, "owners" },
    { 0xA1969E7F, "ownersameteam" },
    { 0x794D3850, "ownersattacker" },
    { 0x84E19D60, "ownership" },
    { 0x86BAFE71, "ownertargetpos" },
    { 0xDF5A9B81, "ownerteam" },
    { 0x809A4BD3, "ownerteamchangewatcher" },
    { 0x913C7C61, "ownerteamchangewatcher_singleton" },
    { 0x34288773, "ownerwassprinting" },
    { 0x6E1AA5B0, "ownerweaponatlaunch" },
    { 0xDC3D7761, "ownflag" },
    { 0x14D73AED, "owning" },
    { 0x16B58122, "owns" },
    { 0x07644283, "ownsandusingperk" },
    { 0xB3EA3E9B, "ows_fountain_wait" },
    { 0xD8FE0112, "ows_target_delete_timer" },
    { 0xCBFDC962, "ows_target_move" },
    { 0x028A827B, "ows_target_think" },
    { 0xBD57E6F6, "ows_target_timeout" },
    { 0x5E460B45, "ows_targets_get_cur_spots" },
    { 0x285D21C9, "ows_targets_spawn" },
    { 0xAF440A50, "ows_targets_start" },
    { 0x01FD5978, "ox" },
    { 0x960EF54D, "oxygen" },
    { 0xD6096AC8, "oxygen_mask_blur" },
    { 0x5909DE33, "oxygen_mask_crack" },
    { 0x38A9FE8E, "oxygen_mask_crack_watcher" },
    { 0x6936DDF2, "oxygen_mask_smoke" },
    { 0x2E80920C, "oxygen_mask_smoke_clear" },
    { 0xDE545954, "oxygenmask_condensation_filter_id" },
    { 0xD3B0CA2C, "oxygenmask_overlay_id" },
    { 0x5C714725, "oxygenmask_warp_filter_id" },
    { 0x27FFD3E1, "oy" },
    { 0xE97A4D1B, "oyxgen" },
    { 0x7F95EAF7, "p" },
    { 0xF077D685, "p0" },
    { 0xCA755C1C, "p1" },
    { 0x229D0A17, "p1_org" },
    { 0x3C7CCB57, "p2" },
    { 0xE62CB54C, "p2_org" },
    { 0x9063AFB4, "p2dogsled_cleanup" },
    { 0xF9676AC4, "p2nazibase_barricade_destroyed" },
    { 0x920F8617, "p2nazibase_exit" },
    { 0x2D56A5B9, "p2nazibase_firstbuilding_clear" },
    { 0xAC5A75C1, "p2nazibase_outro_fade" },
    { 0x8A34CBFD, "p2nazibase_secondbuilding_clear" },
    { 0x4D94ACD7, "p2shiparrival_door1_safetycheck" },
    { 0x0AFE3DA9, "p2shiparrival_entryway_blocker" },
    { 0x59CF6459, "p2shipcargo_cinema_triggered" },
    { 0xE8F4957D, "p2shipfirefight_armed" },
    { 0x7E25C9C6, "p2shipfirefight_arming" },
    { 0x361BE23C, "p2shipfirefight_exit" },
    { 0x3649C4DD, "p2shipfirefight_on_deck" },
    { 0x5EA470B3, "p2shipfirefight_rocketfell" },
    { 0x768F072C, "p2wrapup_narration_finished" },
    { 0x167A50EE, "p3" },
    { 0x586DECE1, "p4" },
    { 0xBC9F3F6D, "p4bak" },
    { 0x326B7278, "p5" },
    { 0x9D0006C1, "p51" },
    { 0x13F641CB, "p6_ammo_" },
    { 0xCEA17372, "p6_light_ad_03_crnr" },
    { 0xDBE738BC, "p6_light_ad_05_crnr" },
    { 0xE8B7E03E, "p6_light_ad_07_crnr" },
    { 0x855346C8, "p6_light_ad_09_crnr" },
    { 0x7B63E416, "p6_light_ad_10_crnr" },
    { 0xCF1A684D, "p6_weapon_" },
    { 0xAC7E9C81, "p_af_01_01_intro_player_start" },
    { 0x4950044D, "p_af_01_03_pulwar_player" },
    { 0x3E051732, "p_af_01_05_zhaointro_player" },
    { 0x358D8885, "p_af_02_01_enter_cave_player" },
    { 0xA891A7F7, "p_af_02_01_map_room_conversation_player" },
    { 0x4AFDFCE2, "p_af_03_01_base_leave_player_intro" },
    { 0x5B0600F4, "p_af_04_01_return_base_player_charge" },
    { 0xF99733C5, "p_af_04_01_return_base_player_lineup" },
    { 0x646E7462, "p_af_04_01_return_base_player_speech" },
    { 0xC6C36F57, "p_af_04_03_through_binoculars_player" },
    { 0x4B639209, "p_af_04_05_thrown_player_fall" },
    { 0xDFFDCCEA, "p_af_04_05_thrown_player_push" },
    { 0x5296C71A, "p_af_04_05_thrown_player_push_success" },
    { 0xD81BF3DC, "p_af_04_05_thrown_player_pushloop" },
    { 0x7532C016, "p_af_04_06_reunion_player_run2tank" },
    { 0xA312AEFD, "p_af_04_06_reunion_player_tankfight" },
    { 0x6A4B6B5C, "p_af_04_09_reunion_player_strangle" },
    { 0xC8882B18, "p_af_05_01_victory_player_walk" },
    { 0xE6D6E6A2, "p_af_05_02_interrog_all_tests_succeed_player" },
    { 0xA37CB3A0, "p_af_05_02_interrog_start_player" },
    { 0x9CAF46C0, "p_af_05_02_interrog_test1_fail_player" },
    { 0xB466EC5B, "p_af_05_02_interrog_test1_player" },
    { 0xFFC031DA, "p_af_05_02_interrog_test1_player_succeed" },
    { 0xDF22E637, "p_af_05_02_interrog_test2_fail_player" },
    { 0x56528B1E, "p_af_05_02_interrog_test2_player" },
    { 0x1D98408F, "p_af_05_02_interrog_test2_player_succeed" },
    { 0x537EB442, "p_af_05_02_interrog_test3_fail_player" },
    { 0x0A9C0931, "p_af_05_02_interrog_test3_player" },
    { 0xA85A81F0, "p_af_05_02_interrog_test3_player_succeed" },
    { 0x18D4584C, "p_af_05_02_interrog_threat_player" },
    { 0x9E8375E3, "p_af_05_04_betrayal_player" },
    { 0x4DA6F072, "p_af_06_01_deserted_player_offtruck" },
    { 0xE44111BE, "p_af_06_01_deserted_player_ontruck" },
    { 0xDDB807D9, "p_af_06_02_deserted_player_view01" },
    { 0x03BA8242, "p_af_06_02_deserted_player_view02" },
    { 0x29BCFCAB, "p_af_06_02_deserted_player_view03" },
    { 0xEBD37994, "p_afghan_intro_player" },
    { 0x66A59434, "p_afghan_outroplayer" },
    { 0xFD1E86E3, "p_ang_04_01_player_landing" },
    { 0x77D098E1, "p_ang_06_04_hind_aftermath_player" },
    { 0x6084A51E, "p_ang_06_04_rescue_player" },
    { 0x959482CF, "p_ang_07_03_village" },
    { 0x6B2A768A, "p_ang_10_01_escape" },
    { 0xDF3C7588, "p_brf_good_bad_job" },
    { 0x2312DDF2, "p_brf_phase1_drone_player" },
    { 0xA5DC5052, "p_brf_phase1_intro_player" },
    { 0xC8F99C42, "p_brf_phase2_afghan_end_player" },
    { 0x80C70B5B, "p_brf_phase2_afghanistan_player" },
    { 0x9B367023, "p_brf_phase2_iran_danger_india_danger_player" },
    { 0xB6D74435, "p_brf_phase2_iran_danger_india_safe_player" },
    { 0x362BDCD1, "p_brf_phase2_iran_safe_india_danger_player" },
    { 0x698730B7, "p_brf_phase2_iran_safe_india_safe_player" },
    { 0x137EE067, "p_brf_phase3_0_territory_player" },
    { 0x99DADAA0, "p_brf_phase3_1_territory_player" },
    { 0x1F601B3D, "p_brf_phase3_2_territory_player" },
    { 0x92482196, "p_brf_phase3_3_territory_player" },
    { 0xFC947C2D, "p_brf_phase3_ending_player" },
    { 0x7C93A37C, "p_brf_phase3_socotra_briefing_player" },
    { 0xDB15F766, "p_brf_phase3_socotra_intro_player" },
    { 0xBD4159F1, "p_brf_phase4_intro_player" },
    { 0x4896F5DC, "p_brf_phase4_pak_briefing_player" },
    { 0xF781C6E9, "p_brf_phase4_pak_end_player" },
    { 0x2905EB34, "p_brf_phase4_pak_intel_player" },
    { 0x9A585E8A, "p_command_01_02_observation_loop" },
    { 0xEE8DCB3D, "p_command_01_02_observation_playerturnaround" },
    { 0x0C2BD877, "p_command_01_03_returntointerrogation_player_enter_room" },
    { 0x1771D313, "p_command_01_05_monolouge_end_player" },
    { 0xADF9FBA5, "p_command_01_05_monolouge_player" },
    { 0xE8A6002E, "p_command_01_05_theprestige_player" },
    { 0x7EE62891, "p_command_02_01_wake_up_mason_dooropen" },
    { 0x7680877F, "p_command_02_01_wake_up_mason_helpaccepted" },
    { 0x8B634055, "p_command_02_01_wake_up_mason_helpdenied" },
    { 0xF327BBA5, "p_command_02_01_wake_up_mason_idleb4makedecision" },
    { 0x2E928D2C, "p_command_03_01_sexy_woman_player" },
    { 0x09CEDF87, "p_command_03_03_cic_player_hack" },
    { 0x06738EFA, "p_command_03_08_cctv_access_player" },
    { 0x2DB6F916, "p_command_03_08_cctv_menendez_player" },
    { 0x90143595, "p_command_03_08_vent_kick_in" },
    { 0x2D049564, "p_command_04_02_grabbed_briggs" },
    { 0x74694693, "p_command_04_04_alive_a_player" },
    { 0xA19C2536, "p_command_04_04_alive_b_player" },
    { 0xC11F4E69, "p_command_04_04_alive_c_player" },
    { 0x862DD0D0, "p_command_04_04_dead_a_player" },
    { 0x956D8DC9, "p_command_04_04_dead_b_player" },
    { 0xCEC29116, "p_command_04_04_dead_c_player" },
    { 0x7078E307, "p_command_04_04_dead_d_player" },
    { 0xA6BCB2B1, "p_command_04_06_kneecap_fight_loop" },
    { 0x0C737A27, "p_command_04_06_kneecap_letgo" },
    { 0x1A20ECA7, "p_command_04_07_eyeball_player" },
    { 0x15800878, "p_command_06_03_aftermath_briggs" },
    { 0x1ABFDD7A, "p_command_06_03_aftermath_computer_karma_alive" },
    { 0x4E8ACCAD, "p_command_06_03_aftermath_end" },
    { 0x3358DE4E, "p_command_06_03_aftermath_end_harper" },
    { 0x4246E590, "p_command_06_03_aftermath_loop" },
    { 0x9AFF50DE, "p_command_06_03_aftermath_start" },
    { 0x08A0A34F, "p_command_06_03_aftermath_start_karma" },
    { 0x1EA3B35B, "p_command_06_04_cctv_player_exit" },
    { 0x67049DAD, "p_command_06_06_betrayal_player_shot" },
    { 0x43782F57, "p_command_06_06_betrayal_player_speach" },
    { 0x458C419A, "p_command_07_07_anderson_take_off_alt_player" },
    { 0x15DDE222, "p_command_07_07_anderson_take_off_player" },
    { 0x81416417, "p_frontend_mapchoice_enter" },
    { 0x4E081E80, "p_frontend_mapchoice_enter_idle" },
    { 0x5B08A7C8, "p_frontend_mapchoice_exit_idle" },
    { 0x42B677C3, "p_frontend_player_debrief2_table_positive" },
    { 0xA33C5FA1, "p_gc_signpost_short" },
    { 0x56E1F1EE, "p_heli_face" },
    { 0x7197F427, "p_ht_01_01_intro_player" },
    { 0x2F732F06, "p_ht_01_05_coming_in_hot_player" },
    { 0x09C6A471, "p_ht_01_05_coming_in_hot_player_harperdead" },
    { 0xEE517333, "p_ht_04_02_boobytrap_01_player" },
    { 0x6A77E556, "p_ht_04_02_boobytrap_02_player" },
    { 0xBFFEC909, "p_ht_04_02_boobytrap_03_player" },
    { 0x5BE10034, "p_ht_04_02_boobytrap_04_player" },
    { 0x731AF367, "p_ht_06_01_entry_floor_collapse_player" },
    { 0x5E58C87C, "p_ht_06_01_slide_01_fail01_defalco" },
    { 0x76E7B42C, "p_ht_06_01_slide_01_fail01_pmc" },
    { 0x22734D1E, "p_ht_06_01_slide_01_success_grabs_gun" },
    { 0x3010D4D8, "p_ht_06_01_slide_01_success_grabs_gun_harper_dead" },
    { 0xD6053786, "p_ht_06_01_slide_01_success_killmenendez" },
    { 0x57C77D8A, "p_ht_06_01_slide_01_success_slide01" },
    { 0x31C50321, "p_ht_06_01_slide_01_success_slide02" },
    { 0xFA5C3DF7, "p_ht_06_01_slide_01_success_stab_menedez_success" },
    { 0x2DD9CF0E, "p_ht_06_02_end01_inside_player" },
    { 0xB2BC7685, "p_ht_06_02_end02_inside_player" },
    { 0x973BD3C8, "p_ht_06_02_end03_inside_player" },
    { 0xFB86CB27, "p_ht_06_02_end04_inside_player" },
    { 0x8F4D8E6A, "p_ht_06_02_end05_inside_player" },
    { 0xDB2791D3, "p_ht_06_03_end04_outside_part_1_player" },
    { 0xF8CF1676, "p_ht_06_03_end04_outside_part_2_player" },
    { 0xF57DCDA9, "p_ht_06_03_end04_outside_part_3_player" },
    { 0xB28E0AC6, "p_ht_06_03_end05_outside_part_1_player" },
    { 0x7BA8F169, "p_ht_06_03_end06_outside_part_1_player" },
    { 0x4C85E1FD, "p_intersect" },
    { 0x372FF154, "p_intro_wm_fastrope_player" },
    { 0x1227AA84, "p_karma_10_3_defalco_dead_ending_player" },
    { 0x6944B9E8, "p_karma_10_3_escape_ending_player" },
    { 0x07D9F83A, "p_karma_1_1_final_approach" },
    { 0xC4850E06, "p_karma_1_1_final_approach_landing" },
    { 0xFE4CE9FD, "p_karma_2_3_grab_railing" },
    { 0xA74F1779, "p_karma_4_1_hotel_room_set_bot" },
    { 0xE7B121E0, "p_karma_4_8_it_manager_eyescan_spiderbot" },
    { 0x9362DAE3, "p_karma_4_8_spiderbot_smash_spiderbot" },
    { 0x2DF8ABC2, "p_karma_5_1_breach_player" },
    { 0x2FD4CF8C, "p_karma_5_3_crc_enter_scan_player" },
    { 0x13ABA5D6, "p_karma_5_4_construction_intro_player" },
    { 0x7BE98B47, "p_karma_5_4_construction_intro_player_loop" },
    { 0x6A8C4465, "p_karma_6_3_clubsolar_barfight_player" },
    { 0x05E6ACDC, "p_karma_6_3_player_enters_club_player" },
    { 0x24257C63, "p_karma_6_7_shoot_out_player_part1" },
    { 0xB21E0D28, "p_karma_6_7_shoot_out_player_part2" },
    { 0xD8208791, "p_karma_6_7_shoot_out_player_part3" },
    { 0x7C235763, "p_karma_6_7_shoot_out_player_slowmo_part1" },
    { 0x0A1BE828, "p_karma_6_7_shoot_out_player_slowmo_part2" },
    { 0x301E6291, "p_karma_6_7_shoot_out_player_slowmo_part3" },
    { 0xEE2AC69E, "p_karma_6_7_shoot_out_player_slowmo_part4" },
    { 0x133B131B, "p_karma_7_explosion_aftermath_player" },
    { 0xC4843BC4, "p_karma_9_1_gate_lift" },
    { 0x066E6A86, "p_la_01_01_110_intro_harperdead_player" },
    { 0xB8C4D785, "p_la_01_01_110_intro_player" },
    { 0x9485962D, "p_mon_01_01_cliffintro_player" },
    { 0x27145789, "p_mon_01_01_cliffswing1_fail_player" },
    { 0xC583ABDF, "p_mon_01_01_cliffswing1_idle_player" },
    { 0x23B6880C, "p_mon_01_01_cliffswing1_player" },
    { 0x55243626, "p_mon_01_01_cliffswing2_fail_player" },
    { 0x20C31130, "p_mon_01_01_cliffswing2_idle_player" },
    { 0xB8DE78E5, "p_mon_01_01_cliffswing2_player" },
    { 0x61CDE7DB, "p_mon_01_01_cliffswing3_fail_player" },
    { 0x9B50EFC5, "p_mon_01_01_cliffswing3_idle_player" },
    { 0xC38490B2, "p_mon_01_01_cliffswing3_player" },
    { 0x07E69670, "p_mon_01_01_cliffswing4_fail_player" },
    { 0x6C3FF0A6, "p_mon_01_01_cliffswing4_idle_player" },
    { 0xAD8FD08B, "p_mon_01_01_cliffswing4_player" },
    { 0xC2DA4535, "p_mon_01_01_cliffswing5_fail_player" },
    { 0x0A113B83, "p_mon_01_01_cliffswing5_idle_player" },
    { 0x6485A708, "p_mon_01_01_cliffswing5_player" },
    { 0x86D3EA14, "p_mon_01_01_cliffswing6_idle_player" },
    { 0xC861AB61, "p_mon_01_01_cliffswing6_player" },
    { 0x9657B844, "p_mon_01_01_cliffswing_flight" },
    { 0x9159C414, "p_mon_01_01_cliffswing_putsonsuit" },
    { 0xB443DF60, "p_mon_01_01_player_swing_success_idle" },
    { 0x8591FE7E, "p_mon_01_01_player_swing_success_raise" },
    { 0x002EFFEC, "p_mon_02_04_landing" },
    { 0x5ACF02C4, "p_mon_07_01_asd_intro" },
    { 0xD9DC653F, "p_mon_09_01_isaac_defend_player_end" },
    { 0xFFFD3387, "p_mon_09_02_nitrogen_death" },
    { 0x9B6A58FF, "p_mon_09_04_codes_grab_riotshield" },
    { 0xCAE48C50, "p_mon_10_01_celerium_door_player" },
    { 0xD1E64760, "p_mon_10_02_celerium_chamber_player_approach" },
    { 0x4D6B1833, "p_mon_10_02_celerium_chamber_player_end" },
    { 0x00C3D353, "p_mon_11_01_ending_player" },
    { 0x35D566A4, "p_mov_0_test_01_01" },
    { 0xA7DCD5DF, "p_mov_0_test_01_02" },
    { 0xF5BEED3E, "p_mov_a1d_02_01" },
    { 0xCFBC72D5, "p_mov_a1d_02_02" },
    { 0xA9B9F86C, "p_mov_a1d_02_03" },
    { 0x83B77E03, "p_mov_a1d_02_04" },
    { 0x5DB5039A, "p_mov_a1d_02_05" },
    { 0x37B28931, "p_mov_a1d_02_06" },
    { 0x11B00EC8, "p_mov_a1d_02_07" },
    { 0xEBAD945F, "p_mov_a1d_02_08" },
    { 0xC5AB19F6, "p_mov_a1d_02_09" },
    { 0x9D2A017C, "p_mov_a1d_02_10" },
    { 0xC32C7BE5, "p_mov_a1d_02_11" },
    { 0xE92EF64E, "p_mov_a1d_02_12" },
    { 0x0F3170B7, "p_mov_a1d_02_13" },
    { 0x052017D8, "p_mov_a1d_02_14" },
    { 0x2B229241, "p_mov_a1d_02_15" },
    { 0x51250CAA, "p_mov_a1d_02_16" },
    { 0x51164142, "p_mov_a1m_01_01" },
    { 0xDF36C53B, "p_mov_a1m_02b_01" },
    { 0xB7FD4377, "p_mov_a1m_03a_01" },
    { 0x45F5D43C, "p_mov_a1m_03a_02" },
    { 0x6BF84EA5, "p_mov_a1m_03a_03" },
    { 0xF9F0DF6A, "p_mov_a1m_03a_04" },
    { 0x1FF359D3, "p_mov_a1m_03a_05" },
    { 0xADEBEA98, "p_mov_a1m_03a_06" },
    { 0xD3EE6501, "p_mov_a1m_03a_07" },
    { 0xBC346D8A, "p_mov_a1m_03a_07a" },
    { 0x61E6F5C6, "p_mov_a1m_03a_08" },
    { 0x87E9702F, "p_mov_a1m_03a_09" },
    { 0x51801699, "p_mov_a1m_03a_10" },
    { 0x2B7D9C30, "p_mov_a1m_03a_11" },
    { 0x9D850B6B, "p_mov_a1m_03a_12" },
    { 0x700242E6, "p_mov_a1m_03b_09" },
    { 0x4643F5EC, "p_mov_a1m_03b_10" },
    { 0xB84B6527, "p_mov_a1m_03b_13" },
    { 0x427DB0B6, "p_mov_a1m_03c_11" },
    { 0xD076417B, "p_mov_a1m_03c_14" },
    { 0x7112EE67, "p_mov_a1m_03d_15" },
    { 0xFF0B7F2C, "p_mov_a1m_03d_16" },
    { 0x250DF995, "p_mov_a1m_03d_17" },
    { 0x2D70CCBD, "p_mov_a1m_04_01" },
    { 0x53734726, "p_mov_a1m_04_02" },
    { 0x7975C18F, "p_mov_a1m_04_03" },
    { 0x6F6468B0, "p_mov_a1m_04_04" },
    { 0x9459F48A, "p_mov_a2j_01b_01" },
    { 0x6E577A21, "p_mov_a2j_01b_02" },
    { 0x4854FFB8, "p_mov_a2j_01b_03" },
    { 0x7BB83D99, "p_mov_a2j_01c_01" },
    { 0xA1BAB802, "p_mov_a2j_01c_02" },
    { 0xD7F987C5, "p_mov_a2j_02_01" },
    { 0xFDFC022E, "p_mov_a2j_02_02" },
    { 0x23FE7C97, "p_mov_a2j_02_03" },
    { 0x19ED23B8, "p_mov_a2j_02_04" },
    { 0x3FEF9E21, "p_mov_a2j_02_05" },
    { 0x65F2188A, "p_mov_a2j_02_06" },
    { 0x1A2C6916, "p_mov_a2j_03_01" },
    { 0xF429EEAD, "p_mov_a2j_03_02" },
    { 0xCE277444, "p_mov_a2j_03_03" },
    { 0x28CB47D0, "p_mov_a2s_02_01" },
    { 0x9AD2B70B, "p_mov_a2s_02_02" },
    { 0x74D03CA2, "p_mov_a2s_02_03" },
    { 0xE6D7ABDD, "p_mov_a2s_02_04" },
    { 0xC0D53174, "p_mov_a2s_02_05" },
    { 0x32DCA0AF, "p_mov_a2s_02_06" },
    { 0x0CDA2646, "p_mov_a2s_02_07" },
    { 0xFCB7EEFF, "p_mov_a2s_03_01" },
    { 0x73A32EEA, "p_mov_a2s_04_01" },
    { 0xDE5318DC, "p_mov_a3a_01_01" },
    { 0x5B1AE031, "p_mov_a3a_02_01" },
    { 0x811D5A9A, "p_mov_a3a_02_02" },
    { 0xA71FD503, "p_mov_a3a_02_03" },
    { 0xCD224F6C, "p_mov_a3a_02_04" },
    { 0xF324C9D5, "p_mov_a3a_02_05" },
    { 0x1927443E, "p_mov_a3a_02_06" },
    { 0x3F29BEA7, "p_mov_a3a_02_07" },
    { 0x05049280, "p_mov_a3a_02_08" },
    { 0x175EFA6D, "p_mov_a3d_01_01" },
    { 0x851DD0F2, "p_mov_afg1_01_01" },
    { 0x5F1B5689, "p_mov_afg1_01_02" },
    { 0x3918DC20, "p_mov_afg1_01_03" },
    { 0xD98129BD, "p_mov_afg2_01_01" },
    { 0xFF83A426, "p_mov_afg2_01_02" },
    { 0x25861E8F, "p_mov_afg2_01_03" },
    { 0x9D4B9CD4, "p_mov_afg_06_01" },
    { 0x0F530C0F, "p_mov_afg_06_02" },
    { 0xE95091A6, "p_mov_afg_06_03" },
    { 0x2B442D99, "p_mov_afg_06_04" },
    { 0x0541B330, "p_mov_afg_06_05" },
    { 0x51E2D21A, "p_mov_ang1_01_01" },
    { 0x2B8CDA9F, "p_mov_ang1_01_wheelchair" },
    { 0x5A5B42AD, "p_mov_ang_01_01" },
    { 0x805DBD16, "p_mov_ang_01_02" },
    { 0xA660377F, "p_mov_ang_01_03" },
    { 0x9C4EDEA0, "p_mov_ang_01_04" },
    { 0xC2515909, "p_mov_ang_01_05" },
    { 0xE853D372, "p_mov_ang_01_06" },
    { 0x0E564DDB, "p_mov_ang_01_07" },
    { 0x646C9B8C, "p_mov_ang_01_08" },
    { 0x8A6F15F5, "p_mov_ang_01_09" },
    { 0xB2F02E6F, "p_mov_ang_01_10" },
    { 0x8CEDB406, "p_mov_ang_01_11" },
    { 0x66EB399D, "p_mov_ang_01_12" },
    { 0x40E8BF34, "p_mov_ang_01_13" },
    { 0x1AE644CB, "p_mov_ang_01_14" },
    { 0xF4E3CA62, "p_mov_ang_01_15" },
    { 0xCEE14FF9, "p_mov_ang_01_16" },
    { 0xA8DED590, "p_mov_ang_01_17" },
    { 0x4D1BF939, "p_mov_ang_01_17a" },
    { 0xE30401B7, "p_mov_ang_01_18" },
    { 0xBD01874E, "p_mov_ang_01_19" },
    { 0x3187949A, "p_mov_ang_01_20" },
    { 0x578A0F03, "p_mov_ang_01_21" },
    { 0xE5829FC8, "p_mov_ang_01_22" },
    { 0x0B851A31, "p_mov_ang_01_23" },
    { 0xC9917E3E, "p_mov_ang_01_24" },
    { 0xEF93F8A7, "p_mov_ang_01_25" },
    { 0x0997A5B8, "p_mov_ang_02_01" },
    { 0x239C9387, "p_mov_ang_03_01" },
    { 0x74B71244, "p_mov_b1a_02_01" },
    { 0xE6BE817F, "p_mov_b1a_02_02" },
    { 0xC0BC0716, "p_mov_b1a_02_03" },
    { 0x02AFA309, "p_mov_b1a_02_04" },
    { 0xDCAD28A0, "p_mov_b1a_02_05" },
    { 0x83AC3BD3, "p_mov_b1a_03_01" },
    { 0x11A4CC98, "p_mov_b1a_03_02" },
    { 0x37A74701, "p_mov_b1a_03_03" },
    { 0xE750D060, "p_mov_b2d_02_01" },
    { 0x59583F9B, "p_mov_b2d_02_02" },
    { 0x3355C532, "p_mov_b2d_02_03" },
    { 0xA55D346D, "p_mov_b2d_02_04" },
    { 0xE9B310CF, "p_mov_b3r_00_01" },
    { 0xC39C10E0, "p_mov_b3r_01_01" },
    { 0xCF48B83F, "p_mov_bfr_01_01" },
    { 0x5D414904, "p_mov_bfr_01_02" },
    { 0x8343C36D, "p_mov_bfr_01_03" },
    { 0x113C5432, "p_mov_bfr_01_04" },
    { 0x373ECE9B, "p_mov_bfr_01_05" },
    { 0xC5375F60, "p_mov_bfr_01_06" },
    { 0xEB39D9C9, "p_mov_bfr_01_07" },
    { 0xD95A111E, "p_mov_bfr_01_08" },
    { 0xFF5C8B87, "p_mov_bfr_01_09" },
    { 0x27DDA401, "p_mov_bfr_01_10" },
    { 0x01DB2998, "p_mov_bfr_01_11" },
    { 0x73E298D3, "p_mov_bfr_01_12" },
    { 0x1CB2A9A8, "p_mov_c1a_01_01" },
    { 0x8EBA18E3, "p_mov_c1a_01_02" },
    { 0x68B79E7A, "p_mov_c1a_01_03" },
    { 0xDABF0DB5, "p_mov_c1a_01_04" },
    { 0xB4BC934C, "p_mov_c1a_01_05" },
    { 0x26C40287, "p_mov_c1a_01_06" },
    { 0x00C1881E, "p_mov_c1a_01_07" },
    { 0x8EA5935D, "p_mov_c1a_02_01" },
    { 0xB4A80DC6, "p_mov_c1a_02_02" },
    { 0x2AD227D1, "p_mov_c1d_01_01" },
    { 0x50D4A23A, "p_mov_c1d_01_02" },
    { 0x76D71CA3, "p_mov_c1d_01_03" },
    { 0xC2DC1175, "p_mov_c1d_01_05" },
    { 0x0EE10647, "p_mov_c1d_01_07" },
    { 0xD4BBDA20, "p_mov_c1d_01_08" },
    { 0xFABE5489, "p_mov_c1d_01_09" },
    { 0x83671393, "p_mov_c1d_01_10" },
    { 0x5D64992A, "p_mov_c1d_01_11" },
    { 0x0A0748FC, "p_mov_c1d_02_01" },
    { 0x8ACCF75D, "p_mov_c2a_01_01" },
    { 0xB0CF71C6, "p_mov_c2a_01_02" },
    { 0xD6D1EC2F, "p_mov_c2a_01_03" },
    { 0xCCC09350, "p_mov_c2a_01_04" },
    { 0xF2C30DB9, "p_mov_c2a_01_05" },
    { 0x18C58822, "p_mov_c2a_01_06" },
    { 0x3EC8028B, "p_mov_c2a_01_07" },
    { 0x94DE503C, "p_mov_c2a_01_08" },
    { 0xBAE0CAA5, "p_mov_c2a_01_09" },
    { 0xE361E31F, "p_mov_c2a_01_10" },
    { 0xBD5F68B6, "p_mov_c2a_01_11" },
    { 0x975CEE4D, "p_mov_c2a_01_12" },
    { 0x715A73E4, "p_mov_c2a_01_13" },
    { 0x4B57F97B, "p_mov_c2a_01_14" },
    { 0x25557F12, "p_mov_c2a_01_15" },
    { 0xFF5304A9, "p_mov_c2a_01_16" },
    { 0xD9508A40, "p_mov_c2a_01_17" },
    { 0x1375B667, "p_mov_c2a_01_18" },
    { 0x5B8DC58C, "p_mov_c2d_01_01" },
    { 0xCD9534C7, "p_mov_c2d_01_02" },
    { 0xA792BA5E, "p_mov_c2d_01_03" },
    { 0xE9865651, "p_mov_c2d_01_04" },
    { 0xC383DBE8, "p_mov_c2d_01_05" },
    { 0x358B4B23, "p_mov_c2d_01_06" },
    { 0x0F88D0BA, "p_mov_c2d_01_07" },
    { 0x517C6CAD, "p_mov_c2d_01_08" },
    { 0x27417E91, "p_mov_com_01a_01" },
    { 0x4D43F8FA, "p_mov_com_01a_02" },
    { 0x73467363, "p_mov_com_01a_03" },
    { 0x9948EDCC, "p_mov_com_01a_04" },
    { 0x32B5B0BC, "p_mov_com_01b_01" },
    { 0xA4BD1FF7, "p_mov_com_01b_02" },
    { 0x7EBAA58E, "p_mov_com_01b_03" },
    { 0x4CC84123, "p_mov_com_02_01" },
    { 0xDAC0D1E8, "p_mov_com_02_02" },
    { 0x00C34C51, "p_mov_com_02_03" },
    { 0xBECFB05E, "p_mov_com_02_04" },
    { 0xE4D22AC7, "p_mov_com_02_05" },
    { 0x72CABB8C, "p_mov_com_02_06" },
    { 0x98CD35F5, "p_mov_com_02_07" },
    { 0xF6B1F372, "p_mov_com_02_08" },
    { 0x1CB46DDB, "p_mov_com_02_09" },
    { 0xB9735E5E, "p_mov_evd_01_01" },
    { 0xC29DAC4D, "p_mov_fovtest_20mm_100mm" },
    { 0x131F1DB6, "p_mov_fovtest_35mm_150frms" },
    { 0x147C8D6B, "p_mov_hai1_01a_01" },
    { 0x1C877862, "p_mov_hai1_01b_01" },
    { 0x02D68E77, "p_mov_hai_01_01" },
    { 0x90CF1F3C, "p_mov_hai_01_02" },
    { 0xB6D199A5, "p_mov_hai_01_03" },
    { 0x44CA2A6A, "p_mov_hai_01_04" },
    { 0x6ACCA4D3, "p_mov_hai_01_05" },
    { 0xF8C53598, "p_mov_hai_01_06" },
    { 0x1EC7B001, "p_mov_hai_01_07" },
    { 0xEAEF612E, "p_mov_hai_02_01" },
    { 0x5AC48A5D, "p_mov_hai_03_01" },
    { 0x9493293F, "p_mov_kar_01_01" },
    { 0x228BBA04, "p_mov_kar_01_02" },
    { 0x488E346D, "p_mov_kar_01_03" },
    { 0xD686C532, "p_mov_kar_01_04" },
    { 0xFC893F9B, "p_mov_kar_01_05" },
    { 0x8A81D060, "p_mov_kar_01_06" },
    { 0xB0844AC9, "p_mov_kar_01_07" },
    { 0x9EA4821E, "p_mov_kar_01_08" },
    { 0xC4A6FC87, "p_mov_kar_01_09" },
    { 0xED281501, "p_mov_kar_01_10" },
    { 0xC2EFFAC5, "p_mov_kar_03_01" },
    { 0xF2DA5389, "p_mov_longplaceholdercam" },
    { 0x2A08DF62, "p_mov_los_01a_01" },
    { 0x040664F9, "p_mov_los_01a_02" },
    { 0xDE03EA90, "p_mov_los_01a_03" },
    { 0xE815436F, "p_mov_los_01a_04" },
    { 0x21FDF46B, "p_mov_los_01b_01" },
    { 0xAFF68530, "p_mov_los_01b_02" },
    { 0xD5F8FF99, "p_mov_los_01b_03" },
    { 0x940563A6, "p_mov_los_01b_04" },
    { 0x9F1AC392, "p_mov_los_02_01" },
    { 0x79184929, "p_mov_los_02_02" },
    { 0x5315CEC0, "p_mov_los_02_03" },
    { 0x5D27279F, "p_mov_los_02_04" },
    { 0x3724AD36, "p_mov_los_02_05" },
    { 0x112232CD, "p_mov_los_02_06" },
    { 0xBA5CE5E1, "p_mov_los_03_01" },
    { 0xE05F604A, "p_mov_los_03_02" },
    { 0xD15CFA67, "p_mov_los_05_01" },
    { 0x1708660E, "p_mov_mon_01a_01" },
    { 0x302CC7D7, "p_mov_mon_01b_01" },
    { 0xD71760B0, "p_mov_nic1_01_01" },
    { 0x491ECFEB, "p_mov_nic1_01_02" },
    { 0x231C5582, "p_mov_nic1_01_03" },
    { 0x9523C4BD, "p_mov_nic1_01_04" },
    { 0x6F214A54, "p_mov_nic1_01_05" },
    { 0xE128B98F, "p_mov_nic1_01_06" },
    { 0x9DE3E4BF, "p_mov_nic2_01_01" },
    { 0x2BDC7584, "p_mov_nic2_01_02" },
    { 0x51DEEFED, "p_mov_nic2_01_03" },
    { 0xDFD780B2, "p_mov_nic2_01_04" },
    { 0x05D9FB1B, "p_mov_nic2_01_05" },
    { 0xEA3E6D9F, "p_mov_nic_01_01" },
    { 0x7836FE64, "p_mov_nic_01_02" },
    { 0x9E3978CD, "p_mov_nic_01_03" },
    { 0x2C320992, "p_mov_nic_01_04" },
    { 0x523483FB, "p_mov_nic_01_05" },
    { 0xE02D14C0, "p_mov_nic_01_06" },
    { 0x062F8F29, "p_mov_nic_01_07" },
    { 0xF44FC67E, "p_mov_nic_01_08" },
    { 0x1A5240E7, "p_mov_nic_01_09" },
    { 0x44108DE1, "p_mov_nic_01_10" },
    { 0x1E0E1378, "p_mov_nic_01_11" },
    { 0x901582B3, "p_mov_nic_01_12" },
    { 0x6A13084A, "p_mov_nic_01_13" },
    { 0xDC1A7785, "p_mov_nic_01_14" },
    { 0xB617FD1C, "p_mov_nic_01_15" },
    { 0x281F6C57, "p_mov_nic_01_16" },
    { 0x021CF1EE, "p_mov_nic_01_17" },
    { 0x13FCBA99, "p_mov_nic_01_18" },
    { 0xEDFA4030, "p_mov_nic_01_19" },
    { 0xC70D26E0, "p_mov_nic_01_20" },
    { 0xED0FA149, "p_mov_nic_01_21" },
    { 0x13121BB2, "p_mov_nic_01_22" },
    { 0x185E4C8E, "p_mov_nic_01a_01" },
    { 0xF25BD225, "p_mov_nic_01a_02" },
    { 0xCC5957BC, "p_mov_nic_01a_03" },
    { 0xA656DD53, "p_mov_nic_01a_04" },
    { 0x805462EA, "p_mov_nic_01a_05" },
    { 0x5A51E881, "p_mov_nic_01a_06" },
    { 0x344F6E18, "p_mov_nic_01a_07" },
    { 0x0E4CF3AF, "p_mov_nic_01a_08" },
    { 0x016EDB0F, "p_mov_nic_01b_09" },
    { 0xC9C84CF9, "p_mov_nic_01b_10" },
    { 0xA3C5D290, "p_mov_nic_01b_11" },
    { 0x15CD41CB, "p_mov_nic_01b_12" },
    { 0xEFCAC762, "p_mov_nic_01b_13" },
    { 0x61D2369D, "p_mov_nic_01b_14" },
    { 0x3BCFBC34, "p_mov_nic_01b_15" },
    { 0xADD72B6F, "p_mov_nic_01b_16" },
    { 0x87D4B106, "p_mov_nic_01b_17" },
    { 0xF9DC2041, "p_mov_nic_01b_18" },
    { 0xD3D9A5D8, "p_mov_nic_01b_19" },
    { 0x0D143318, "p_mov_nic_01b_20" },
    { 0x3316AD81, "p_mov_nic_01b_21" },
    { 0x591927EA, "p_mov_nic_01b_22" },
    { 0xBB3569F6, "p_mov_nic_02_01" },
    { 0x9532EF8D, "p_mov_nic_02_02" },
    { 0x6F307524, "p_mov_nic_02_03" },
    { 0x492DFABB, "p_mov_nic_02_04" },
    { 0x232B8052, "p_mov_nic_02_05" },
    { 0xFD2905E9, "p_mov_nic_02_06" },
    { 0x3F19D4C4, "p_mov_nic_04_01" },
    { 0xB12143FF, "p_mov_nic_04_02" },
    { 0x4E0EFE53, "p_mov_nic_05_01" },
    { 0xDC078F18, "p_mov_nic_05_02" },
    { 0x020A0981, "p_mov_nic_05_03" },
    { 0xC0166D8E, "p_mov_nic_05_04" },
    { 0xE618E7F7, "p_mov_nic_05_05" },
    { 0x6D7F71EF, "p_mov_ntr_02a_01" },
    { 0xBCDFD806, "p_mov_ntr_02b_01" },
    { 0x96DD5D9D, "p_mov_ntr_02b_02" },
    { 0xE2F6D7F5, "p_mov_ntr_02c_01" },
    { 0x08F9525E, "p_mov_ntr_02c_02" },
    { 0x2EFBCCC7, "p_mov_ntr_02c_03" },
    { 0x24EA73E8, "p_mov_ntr_02c_04" },
    { 0x4AECEE51, "p_mov_ntr_02c_05" },
    { 0x70EF68BA, "p_mov_ntr_02c_06" },
    { 0x96F1E323, "p_mov_ntr_02c_07" },
    { 0xB2E304AD, "p_mov_ntr_02c_09" },
    { 0xC25AD914, "p_mov_ntr_02d_01" },
    { 0x44A3251A, "p_mov_pak1_01_01" },
    { 0xF21CEE45, "p_mov_pak2_01_01" },
    { 0xFED983AD, "p_mov_pak_01_01" },
    { 0x7970711E, "p_mov_pak_01c_01" },
    { 0x1F8E082B, "p_mov_pak_02a_01" },
    { 0xAD8698F0, "p_mov_pak_02a_02" },
    { 0xD3891359, "p_mov_pak_02a_03" },
    { 0x91957766, "p_mov_pak_02a_04" },
    { 0xB797F1CF, "p_mov_pak_02a_05" },
    { 0x4FA1DB73, "p_mov_pak_02a_09" },
    { 0x7822F3ED, "p_mov_pak_02a_10" },
    { 0x52207984, "p_mov_pak_02a_11" },
    { 0x2798F322, "p_mov_pak_02b_01" },
    { 0x019678B9, "p_mov_pak_02b_02" },
    { 0xDB93FE50, "p_mov_pak_02b_03" },
    { 0xE5A5572F, "p_mov_pak_02b_04" },
    { 0xBFA2DCC6, "p_mov_pak_02b_05" },
    { 0x99A0625D, "p_mov_pak_02b_06" },
    { 0x739DE7F4, "p_mov_pak_02b_07" },
    { 0x7DAF40D3, "p_mov_pak_02b_08" },
    { 0xB0CC09A9, "p_mov_pan1_01_01" },
    { 0xD6CE8412, "p_mov_pan1_01_02" },
    { 0xFCD0FE7B, "p_mov_pan1_01_03" },
    { 0x22D378E4, "p_mov_pan1_01_04" },
    { 0x48D5F34D, "p_mov_pan1_01_05" },
    { 0xA02715FE, "p_mov_pan2_01_01" },
    { 0x7A249B95, "p_mov_pan2_01_02" },
    { 0x5422212C, "p_mov_pan2_01_03" },
    { 0x2E1FA6C3, "p_mov_pan2_01_04" },
    { 0x081D2C5A, "p_mov_pan2_01_05" },
    { 0xA841E2EB, "p_mov_pan3_01_01" },
    { 0x363A73B0, "p_mov_pan3_01_02" },
    { 0x5C3CEE19, "p_mov_pan3_01_03" },
    { 0x1A495226, "p_mov_pan3_01_04" },
    { 0x404BCC8F, "p_mov_pan3_01_05" },
    { 0xB2747F00, "p_mov_pan4_01_01" },
    { 0x247BEE3B, "p_mov_pan4_01_02" },
    { 0xFE7973D2, "p_mov_pan4_01_03" },
    { 0x7080E30D, "p_mov_pan4_01_04" },
    { 0xCF4BDE8D, "p_mov_pan5_01_01" },
    { 0xF54E58F6, "p_mov_pan5_01_02" },
    { 0x1B50D35F, "p_mov_pan5_01_03" },
    { 0x3459E6C2, "p_mov_pan6_01_01" },
    { 0x0E576C59, "p_mov_pan6_01_02" },
    { 0xE854F1F0, "p_mov_pan6_01_03" },
    { 0x849276BC, "p_mov_pan_01_a_01" },
    { 0xF699E5F7, "p_mov_pan_01_a_02" },
    { 0xD0976B8E, "p_mov_pan_01_a_03" },
    { 0x128B0781, "p_mov_pan_01_a_04" },
    { 0xEC888D18, "p_mov_pan_01_a_05" },
    { 0x5E8FFC53, "p_mov_pan_01_a_06" },
    { 0x388D81EA, "p_mov_pan_01_a_07" },
    { 0x7A811DDD, "p_mov_pan_01_a_08" },
    { 0x547EA374, "p_mov_pan_01_a_09" },
    { 0x2BFD8AFA, "p_mov_pan_01_a_10" },
    { 0x52000563, "p_mov_pan_01_a_11" },
    { 0x490A7149, "p_mov_pan_01_b_09" },
    { 0xD1B33053, "p_mov_pan_01_b_10" },
    { 0xABB0B5EA, "p_mov_pan_01_b_11" },
    { 0x85AE3B81, "p_mov_pan_01_b_12" },
    { 0x5FABC118, "p_mov_pan_01_b_13" },
    { 0x69BD19F7, "p_mov_pan_01_b_14" },
    { 0x43BA9F8E, "p_mov_pan_01_b_15" },
    { 0x1DB82525, "p_mov_pan_01_b_16" },
    { 0x97F26471, "p_mov_pan_02_01" },
    { 0xBDF4DEDA, "p_mov_pan_02_02" },
    { 0xE3F75943, "p_mov_pan_02_03" },
    { 0x09F9D3AC, "p_mov_pan_02_04" },
    { 0x2A376E60, "p_mov_pro_01_01" },
    { 0x9C3EDD9B, "p_mov_pro_01_02" },
    { 0x763C6332, "p_mov_pro_01_03" },
    { 0xE843D26D, "p_mov_pro_01_04" },
    { 0x674E82D5, "p_mov_pro_02_01" },
    { 0x8D50FD3E, "p_mov_pro_02_02" },
    { 0xB35377A7, "p_mov_pro_02_03" },
    { 0xA9421EC8, "p_mov_pro_02_04" },
    { 0xB5CE5CE6, "p_mov_pro_03_01" },
    { 0x8FCBE27D, "p_mov_pro_03_02" },
    { 0x69C96814, "p_mov_pro_03_03" },
    { 0x43C6EDAB, "p_mov_pro_03_04" },
    { 0x1DC47342, "p_mov_pro_03_05" },
    { 0xF7C1F8D9, "p_mov_pro_03_06" },
    { 0xD1BF7E70, "p_mov_pro_03_07" },
    { 0x0BE4AA97, "p_mov_pro_03_08" },
    { 0xE5E2302E, "p_mov_pro_03_09" },
    { 0x5BFC3CA4, "p_mov_pro_03_10" },
    { 0x81FEB70D, "p_mov_pro_03_11" },
    { 0xA8013176, "p_mov_pro_03_12" },
    { 0xCE03ABDF, "p_mov_pro_03_13" },
    { 0xC3F25300, "p_mov_pro_03_14" },
    { 0xE9F4CD69, "p_mov_pro_03_15" },
    { 0x0FF747D2, "p_mov_pro_03_16" },
    { 0x35F9C23B, "p_mov_pro_03_17" },
    { 0x8C100FEC, "p_mov_pro_03_18" },
    { 0x837D5F2D, "p_mov_revealtrailer02_vault_shot_01_01" },
    { 0xA97FD996, "p_mov_revealtrailer02_vault_shot_01_02" },
    { 0x32B9C238, "p_mov_revealtrailer02_vault_shot_02_01" },
    { 0x4CBEB007, "p_mov_revealtrailer02_vault_shot_03_01" },
    { 0xA722D3B2, "p_mov_revealtrailer02_vault_shot_04_01" },
    { 0xE64270F0, "p_mov_tst_01_vtol_01" },
    { 0xA2AF1A7B, "p_mov_yem_03a_01" },
    { 0x30A7AB40, "p_mov_yem_03a_02" },
    { 0x56AA25A9, "p_mov_yem_03a_03" },
    { 0x14B689B6, "p_mov_yem_03a_04" },
    { 0xB706FE32, "p_mov_yem_03b_01" },
    { 0x910483C9, "p_mov_yem_03b_02" },
    { 0x6B020960, "p_mov_yem_03b_03" },
    { 0x7513623F, "p_mov_yem_03b_04" },
    { 0x417CF9E4, "p_mov_yem_04a_01" },
    { 0xB384691F, "p_mov_yem_04a_02" },
    { 0x8D81EEB6, "p_mov_yem_04a_03" },
    { 0xCF758AA9, "p_mov_yem_04a_04" },
    { 0xA9626D39, "p_mov_yem_04b_01" },
    { 0xCF64E7A2, "p_mov_yem_04b_02" },
    { 0xF567620B, "p_mov_yem_04b_03" },
    { 0x1B69DC74, "p_mov_yem_04b_04" },
    { 0xE014BE11, "p_mov_yem_04bb_01" },
    { 0x3961BCFF, "p_nic_03_02_pitchfork_impale_grab_pitchfork" },
    { 0x90A16CAB, "p_nic_03_02_pitchfork_impale_ignore_pitchfork" },
    { 0x9B1D4AB1, "p_nic_03_02_pitchfork_impale_prompt_idle" },
    { 0x2298C30E, "p_nic_03_02_pitchfork_impale_start" },
    { 0xBFCC37F3, "p_nic_03_04_banister_jump_player" },
    { 0x7A80A1F5, "p_nic_03_1_axe_hack_grab_axe" },
    { 0xEDB063D3, "p_nic_04_01_shattered2_mason" },
    { 0xE041D4DF, "p_nic_04_01_shattered_menendez" },
    { 0x7B136DC7, "p_nic_06_18_backbreaker_player" },
    { 0x586663C8, "p_pakistan_1_1_market_intro_loop_player_1stperson" },
    { 0x2579CBED, "p_pakistan_1_1_market_intro_loop_player_3rdperson" },
    { 0x762CDB2D, "p_pakistan_1_1_market_intro_player_1stperson" },
    { 0x6ABCA6C4, "p_pakistan_1_1_market_intro_player_3rdperson" },
    { 0xC58BF20E, "p_pakistan_1_2_lockbreaker_player" },
    { 0x47633B6F, "p_pakistan_1_6_brute_force_player" },
    { 0x3996A68A, "p_pakistan_2_3_bus_dam_pushed_player" },
    { 0x2FFCCE00, "p_pakistan_2_3_gate_push_failure_player" },
    { 0x35138519, "p_pakistan_2_3_gate_push_player" },
    { 0x3068FC47, "p_pakistan_2_3_gate_push_setup_player" },
    { 0x00634E9D, "p_pakistan_2_3_gate_push_success_player" },
    { 0x4BDFE7D9, "p_pakistan_3_1_corpse_alley_player_jump" },
    { 0x28F05452, "p_pakistan_3_5_manhole_cover_player" },
    { 0x4963770A, "p_pakistan_5_11_jump_down_attack_player_kill" },
    { 0x5F0F6353, "p_pakistan_5_11_jump_down_attack_player_mantle" },
    { 0xD9451473, "p_pakistan_5_14_millibar_approach_player" },
    { 0x89292CD6, "p_pakistan_5_14_millibar_player" },
    { 0x22613650, "p_pakistan_5_1_grapple_device_player" },
    { 0x8C6A2E71, "p_pakistan_5_1_grapple_device_player_idle" },
    { 0x6867E0DA, "p_pakistan_5_1_grapple_device_player_setup" },
    { 0x4B013377, "p_pakistan_6_11_mount_soct_player" },
    { 0xA7BB7A8B, "p_pakistan_6_1_grenades_b_player" },
    { 0x49C5BBA6, "p_pakistan_6_1_grenades_player" },
    { 0xF885CE7D, "p_pakistan_7_3_land_to_water_player" },
    { 0x0B5B5CAD, "p_pakistan_8_3_hangar_event_player" },
    { 0xEEBFD564, "p_pakistan_9_4_standoff_approach_burned_player" },
    { 0x5757140B, "p_pakistan_9_4_standoff_approach_success_player" },
    { 0x725223AA, "p_pakistan_9_4_standoff_player" },
    { 0x968078BE, "p_pan_01_01_intro_get_bag_player" },
    { 0x8175BA2F, "p_pan_01_01_intro_grab_hat" },
    { 0xFC34CCA5, "p_pan_01_01_intro_grab_hat_reflection" },
    { 0xD1A16213, "p_pan_02_01_beach_approach_player" },
    { 0x79A4637D, "p_pan_02_01_beach_approach_player_dismount" },
    { 0xD43D58D7, "p_pan_02_03_guards_player_button_loop" },
    { 0xDBE36152, "p_pan_02_03_guards_player_grab_gaurd" },
    { 0xE233249F, "p_pan_02_03_guards_player_in" },
    { 0xA8C34725, "p_pan_02_03_guards_player_kills" },
    { 0x21FD1E78, "p_pan_02_03_guards_player_loop" },
    { 0x9F056342, "p_pan_02_03_guards_player_no_kill" },
    { 0x2AF1CCC6, "p_pan_02_03_guards_player_wistle" },
    { 0x3376E759, "p_pan_02_07_hangar_ladder_door_exit_player" },
    { 0x6B70623D, "p_pan_02_07_hangar_ladder_door_open_player" },
    { 0x00DA530C, "p_pan_03_01_old_friends_player_intro" },
    { 0x3966A97D, "p_pan_03_01_old_friends_player_intro_loop" },
    { 0xAD113301, "p_pan_03_01_xcool_player" },
    { 0x8F46F934, "p_pan_04_01_intro_player_approach" },
    { 0xD9EBA9B4, "p_pan_06_04_digbat_tackle_player" },
    { 0x171339BA, "p_pan_07_01_fight_player" },
    { 0x45753CC5, "p_pan_07_03_apache_attack_player" },
    { 0x1F89A671, "p_pan_07_04_jump_player" },
    { 0xAD10FF22, "p_pan_08_01_gate_crash_player" },
    { 0x46E504D6, "p_pan_08_01_jeep_exit_player" },
    { 0x5DFCD427, "p_pan_08_01_jeep_rifle_grab_player" },
    { 0xE0D2C039, "p_pan_08_01_jeep_stage_two_player" },
    { 0x980F0EF5, "p_pan_08_01_jeepride" },
    { 0x8DF10612, "p_pan_08_01_jeepride_cycle" },
    { 0x3D8ED407, "p_pan_08_01_jeepride_end" },
    { 0x60F845BE, "p_pan_08_06_take_the_shot_player_pickup_gun" },
    { 0x2C797A2E, "p_pan_09_01_betrayed_1_player" },
    { 0xF803AD2B, "p_pan_09_01_betrayed_2_player" },
    { 0xED6CF365, "p_pent_control_console" },
    { 0x62C51265, "p_pent_telephone_board" },
    { 0x425C6820, "p_phase4_pakistan_no_intel_player" },
    { 0xCF54B484, "p_r" },
    { 0x3FCB1B49, "p_rus_data_computer" },
    { 0x304176B6, "p_rus_eletricmeter" },
    { 0x16EE4EB6, "p_rus_office_table_wood" },
    { 0x21B8A815, "p_rus_panel_pent" },
    { 0x08787808, "p_sacotra_intro_player" },
    { 0x6F23532A, "p_sacotra_karma_rescue_player" },
    { 0x482CC945, "p_sacotra_outro_player" },
    { 0xB6766A85, "p_singapore_1_player_intro_player" },
    { 0x10AE4EE4, "p_singapore_1_player_outro_player" },
    { 0x366240A3, "p_singapore_brf" },
    { 0x6A2A64F5, "p_singapore_fail_player" },
    { 0x64CBA5B1, "p_trace" },
    { 0xC725143C, "p_war_drones_intro_player_new" },
    { 0xE627E8D2, "p_war_drones_outro_fail_cameraview" },
    { 0x78B7C328, "p_war_drones_outro_succeed_cameraview" },
    { 0x0E73ABA4, "p_war_pak_fail_player" },
    { 0x845B11F4, "p_war_pak_intro_sc1_player" },
    { 0x7DFF43CD, "p_war_pak_intro_sc2_player" },
    { 0x7E20783C, "p_war_pak_succeed_player" },
    { 0xF923C9B5, "p_weasel" },
    { 0x59BEFDE1, "p_yemen_01_02_menendez_intro_player" },
    { 0xFBAE72F1, "p_yemen_01_03_menendez_speech_player_talk" },
    { 0x7E251934, "p_yemen_01_03_menendez_speech_player_vtol_react" },
    { 0x8953CEB3, "p_yemen_01_03_menendez_speech_player_walk_no_defalco" },
    { 0x876ECECE, "p_yemen_01_03_menendez_speech_player_walk_with_defalco" },
    { 0xC6A2241B, "p_yemen_03_03_xm25_reaction_to_drawing_gun" },
    { 0x69883F1C, "p_yemen_05_01_shoot_vtol_player" },
    { 0x2D6B97A0, "p_yemen_05_03_capture_approach_player" },
    { 0x85600F3B, "p_yemen_05_03_capture_player" },
    { 0xDC7E593A, "p_yemen_05_04_shoot_harper_player" },
    { 0xD2BCB67E, "p_yemen_05_04_shoot_menendez_player" },
    { 0xBDAC2C89, "p_yemen_05_05_farid_alive_player" },
    { 0x8F25A84C, "p_yemen_05_05_mason_intro_hpr_lives_mason" },
    { 0xE2D78042, "p_yemen_07_01_menendez_hack_pilot" },
    { 0x6AACC55B, "p_yemen_08_02_surrender_plyr" },
    { 0xEAEC4FCC, "pa" },
    { 0xE9723115, "pa_announcement_dialog" },
    { 0x69DF9AFF, "pa_audio" },
    { 0x34F1F481, "pa_audio_notify" },
    { 0x295D9BD0, "pa_cooldown_count" },
    { 0x58B4BF2C, "pa_countdown" },
    { 0xB8D8A64C, "pa_countdown_success" },
    { 0xA921C85F, "pa_dialog" },
    { 0xA0F451B0, "pa_dock_vox" },
    { 0xDBFE35FC, "pa_dude_talk" },
    { 0x2B9827E8, "pa_electric_trap" },
    { 0xB3C19866, "pa_elevator_kill_vox" },
    { 0x9060C5C9, "pa_elevator_slide_vox" },
    { 0xA0DC0DF5, "pa_explo_vox" },
    { 0x40E0DFD6, "pa_explode_notify" },
    { 0x5B1F7B9F, "pa_fire" },
    { 0xD45E806C, "pa_fire_b" },
    { 0xA6CF8005, "pa_go" },
    { 0x90629615, "pa_guy_shot_notify" },
    { 0x99ECF37C, "pa_id" },
    { 0x07EA5CED, "pa_init" },
    { 0x9F89137C, "pa_is_speaking" },
    { 0x60935D2E, "pa_level_start" },
    { 0x973C5F24, "pa_on" },
    { 0x09D79FD5, "pa_play" },
    { 0x0C56B408, "pa_play_dialog" },
    { 0x891ED3C6, "pa_power_on" },
    { 0x44FFB95D, "pa_rail_vox" },
    { 0xEA3BB1BC, "pa_single_init" },
    { 0xCD93E0D2, "pa_speaker" },
    { 0xC59E4F34, "pa_speaker2" },
    { 0xA9337309, "pa_start" },
    { 0xA27A028C, "pa_struct" },
    { 0xB2B93ADE, "pa_sys" },
    { 0x24E459E0, "pa_system" },
    { 0x01B95ADC, "pa_takeover_notify" },
    { 0x421DB7AE, "pa_teleport" },
    { 0x4BEC78BD, "pa_think" },
    { 0x5F31069A, "pa_timer" },
    { 0x5B89E466, "pa_vox" },
    { 0x7F8F129B, "paarray" },
    { 0x2AF47A56, "pab" },
    { 0x50F6F4BF, "pac" },
    { 0xB57D10D6, "pacafist" },
    { 0x360631C0, "pace" },
    { 0xA37AEDC4, "paced" },
    { 0x22C829FA, "paceholder" },
    { 0xDDA019EB, "paces" },
    { 0xFE23EEAC, "paci" },
    { 0xB9EB7D8D, "pacifc" },
    { 0xD3DF4ACC, "pacifictour" },
    { 0x25BFBF8E, "pacifist" },
    { 0xB000E263, "pacifist_enemies" },
    { 0x648BB600, "pacifist_guy_goal" },
    { 0x55C3BD4A, "pacifist_rubble_guys" },
    { 0x7FE51570, "pacifist_state" },
    { 0xE51A197A, "pacifist_till_goal" },
    { 0xD2253140, "pacifist_to_goal" },
    { 0xE17651D3, "pacifist_trigger" },
    { 0xA6424B32, "pacifist_wait" },
    { 0x33C28431, "pacifists" },
    { 0x140D186D, "pacifistwait" },
    { 0x962BEC37, "pacify" },
    { 0x19172E41, "pacing" },
    { 0x31AB343A, "pacing1_2man_melee" },
    { 0xF858BCB5, "pacing1_fallbacker_kill" },
    { 0xEF72A10C, "pacing1_fallbackers_kill" },
    { 0xAEB6667C, "pacing1_friendly_doorbreach" },
    { 0x6FDCD9D3, "pacing1_friendly_doorbreach_dooropen" },
    { 0xDF4B45A5, "pacing1_friendly_doorbreach_enemies" },
    { 0xBC7EAE03, "pacing1_melees_init" },
    { 0x8053AF41, "pacing_alert_guys" },
    { 0x2073FBFB, "pacing_attach_radio" },
    { 0xECBC2EE4, "pacing_dialog" },
    { 0x66CD5A15, "pacing_distance" },
    { 0x3CF16B5C, "pacing_enemies" },
    { 0x5401F863, "pacing_get_on_tank_1" },
    { 0xE1FA8928, "pacing_get_on_tank_2" },
    { 0x07FD0391, "pacing_get_on_tank_3" },
    { 0x17F85B51, "pacing_get_on_tank_3b" },
    { 0x9E7A3E31, "pacing_guard_spawners" },
    { 0x21C1D708, "pacing_moment" },
    { 0x971B77E5, "pacing_planes" },
    { 0x6B54C821, "pacing_ready" },
    { 0x85C7273D, "pacing_tank1_3_wait" },
    { 0x8A9F3400, "pacing_tank4_wait" },
    { 0x9C5D6666, "pacing_throw_smoke" },
    { 0x97806872, "pacing_vignette" },
    { 0xE4DE5B44, "pacing_vignette_in_place" },
    { 0xFAF1BE05, "pacing_vignette_in_place_think" },
    { 0x0522A110, "pacing_vignette_started" },
    { 0x294091B8, "pacing_vignette_vo" },
    { 0x4A28E37E, "pack" },
    { 0x8DF79D23, "pack_a_punch" },
    { 0xFFA162E7, "pack_a_punch_camo_index" },
    { 0x7500D976, "pack_a_punch_camo_index_number_variants" },
    { 0xDA067FB6, "pack_a_punch_disable" },
    { 0x4A8FD3EB, "pack_a_punch_dummy_init" },
    { 0x1A72E37B, "pack_a_punch_enable" },
    { 0x3129BF4E, "pack_a_punch_hide" },
    { 0x168CCDA0, "pack_a_punch_init" },
    { 0x88D56C01, "pack_a_punch_machine_trigger_think" },
    { 0x011434D9, "pack_a_punch_main" },
    { 0xC1D9E265, "pack_a_punch_off" },
    { 0x4B87A7D9, "pack_a_punch_on" },
    { 0x21952A4A, "pack_a_punch_round_time" },
    { 0xB90B29ED, "pack_a_punch_show" },
    { 0xDC3777DB, "pack_a_punch_stone_timer" },
    { 0xBAA501C2, "pack_a_punch_stone_timer_dist" },
    { 0x8DC678E2, "pack_a_punch_think" },
    { 0xC29EF16B, "pack_a_punch_trigger_think" },
    { 0xD2B2D051, "pack_a_punch_weapon_options" },
    { 0xB2031A42, "pack_audio_trig" },
    { 0x7DE9450A, "pack_clock_init" },
    { 0xCB983F5B, "pack_clock_run" },
    { 0x1CF6CE10, "pack_clock_start" },
    { 0x4D04821D, "pack_cooldown_listener" },
    { 0xA888872E, "pack_door_init" },
    { 0xEC05D970, "pack_door_open" },
    { 0x661532A7, "pack_door_slam" },
    { 0x30154010, "pack_door_solid_thread" },
    { 0x01D9E87E, "pack_effect" },
    { 0xFC6A819F, "pack_enclosure" },
    { 0xBE89C100, "pack_gate_activate" },
    { 0x60EB630F, "pack_gate_closed" },
    { 0x2AE641F7, "pack_gate_poi_activate" },
    { 0x3E813E5A, "pack_gate_poi_init" },
    { 0x29D7A4F3, "pack_gates" },
    { 0x6FB5A4B0, "pack_hideaway_init" },
    { 0xB7A14A0A, "pack_icon_split_x" },
    { 0x97CDAF43, "pack_icon_x" },
    { 0x71CB34DA, "pack_icon_y" },
    { 0x622064AA, "pack_player" },
    { 0x451598A6, "pack_portal_fx_off" },
    { 0x3DDB80B8, "pack_portal_fx_on" },
    { 0x5702C7D0, "pack_room_reset" },
    { 0x3572D871, "pack_room_trig" },
    { 0xB4926D2A, "pack_struct" },
    { 0xD955A37F, "pack_trig" },
    { 0x13393D82, "pack_trigger_think" },
    { 0x0C7CFD72, "pack_triggers" },
    { 0xC6D330E4, "pack_zombieland" },
    { 0x89FFF8FD, "pack_zombieland_poi" },
    { 0xAC5B8A1B, "packa_door_reminder" },
    { 0xCB489AF1, "packa_jingle" },
    { 0x183CFDED, "packa_rollers" },
    { 0xA074AAA1, "packa_timer" },
    { 0x175A835F, "package" },
    { 0xC69A83DA, "package_buyunitpressed" },
    { 0x3DABF3F0, "package_commandunitfps" },
    { 0x046AF178, "package_commandunitfps_cb" },
    { 0x14CF0C17, "package_commandunitpressed" },
    { 0x214BF9D8, "package_commandunitrts" },
    { 0x2E9BBF8C, "package_contents_id" },
    { 0x8E94CE34, "package_dialogue" },
    { 0xB9BD90FD, "package_doorsetup" },
    { 0xA66587A8, "package_enter" },
    { 0xCE5701D4, "package_generateavailable" },
    { 0x6BF5C57C, "package_getnumteamresources" },
    { 0x16298709, "package_getpackagebytype" },
    { 0x84766870, "package_grigs" },
    { 0xA29303B2, "package_grigs2" },
    { 0xD072F09F, "package_highlightunits" },
    { 0xE5A89F56, "package_index" },
    { 0x6AE04DE5, "package_main" },
    { 0x560F938F, "package_music" },
    { 0x380F51F7, "package_name" },
    { 0x41852AF0, "package_open_doors" },
    { 0xB15B2D7C, "package_populate" },
    { 0x4F1C7E6F, "package_radiation" },
    { 0xF6682E89, "package_secure" },
    { 0x3237D802, "package_select" },
    { 0xF1198725, "package_setpackagecost" },
    { 0x53AE1027, "package_takeoverunitpressed" },
    { 0x7CD6A812, "packagearray" },
    { 0x954417F5, "packagecollidercent" },
    { 0xED210552, "packagename" },
    { 0xE994D6E6, "packages" },
    { 0xDC8D6426, "packages_avail" },
    { 0x5C820A25, "packapunch" },
    { 0xE9BEC753, "packapunch_hack" },
    { 0xD48FA212, "packapunch_hack_think" },
    { 0xB3066308, "packapunch_hacked" },
    { 0x3E874B8F, "packapunch_legs" },
    { 0xB85F3427, "packapunch_machine" },
    { 0xA1BDB971, "packapunch_see" },
    { 0xD3F3FF41, "packapunch_timeout" },
    { 0x9F0F50CD, "packasplat" },
    { 0x06A35C40, "packasplat_blood" },
    { 0x39ED0D84, "packasplat_case" },
    { 0x23A1D99F, "packasplat_fuse" },
    { 0xA103D675, "packasplatcraftable" },
    { 0xE6DEA0C1, "packed" },
    { 0xACAD7BAA, "packed_attachments" },
    { 0xFE613E1E, "packedval" },
    { 0x86B6FA31, "packet" },
    { 0xE2C29A22, "packetbase" },
    { 0xF17B5F98, "packets" },
    { 0xB4D74AA5, "packicon" },
    { 0xE7E13D82, "packing" },
    { 0x09C83F8E, "packing_player" },
    { 0x5DBAE07F, "packing_self" },
    { 0x1B051313, "packobject" },
    { 0xAEF21231, "packtime" },
    { 0xCEB89A25, "packup" },
    { 0x46E59BE0, "pad" },
    { 0xFED66CF3, "pad_dist" },
    { 0xD11BA2F6, "pad_hook" },
    { 0xA45EF40C, "pad_manager" },
    { 0x9444E7C7, "padded" },
    { 0xB8D4FEA5, "padded_int" },
    { 0x2E95A144, "padding" },
    { 0x46054A78, "paddling" },
    { 0xD400D368, "paddtodvar" },
    { 0x67AB1A7D, "paddy" },
    { 0xFB26CBE5, "padlock" },
    { 0xF1827DF4, "padlocks" },
    { 0x0DF2C48B, "pads" },
    { 0x23414C61, "padsite" },
    { 0xE9E09D9C, "page" },
    { 0xA2AB4568, "pagechangecounter" },
    { 0xEFA04B90, "paged" },
    { 0x9989FDDF, "pages" },
    { 0xEB5BCD4D, "pageside" },
    { 0x742A767F, "pagesideindex" },
    { 0x523B3485, "paging" },
    { 0x3A1E58A1, "pain" },
    { 0x6477EF93, "pain_anim" },
    { 0xC423E168, "pain_canenter" },
    { 0x1673C138, "pain_chance" },
    { 0xEA5C768A, "pain_death" },
    { 0x7FB7E527, "pain_direction" },
    { 0x6C5BC864, "pain_done" },
    { 0x5B4AC0FE, "pain_enter" },
    { 0xA3BF4514, "pain_exit" },
    { 0xCF954790, "pain_out" },
    { 0x7D3A2615, "pain_protection" },
    { 0xD9B23600, "pain_protection_check" },
    { 0x2D363D97, "pain_pulse" },
    { 0x29A9FAAC, "pain_set" },
    { 0xFE4ADE58, "pain_test" },
    { 0xD0CF2F66, "pain_time_length" },
    { 0xA533A2FE, "pain_time_window" },
    { 0xD56305C8, "pain_toggle" },
    { 0xF71FC8B7, "pain_update" },
    { 0xFF55A1A3, "pain_vox" },
    { 0xCAC92641, "pain_when_damagelevel_change" },
    { 0xC387E45F, "painai" },
    { 0xF55E1016, "painanim" },
    { 0xA7B72849, "painanimarray" },
    { 0x1299E489, "painanims" },
    { 0x17269AF0, "painarray" },
    { 0x8589E5C2, "paincausedhunkeringup" },
    { 0x70DF4D7E, "paindeathnotify" },
    { 0xF453D7D6, "painface" },
    { 0xD6FB508A, "painful" },
    { 0xB4D1812A, "paingloabalsinit" },
    { 0x2A49248B, "painglobals" },
    { 0xE5D848E7, "painhelmetpop" },
    { 0x41CEBF4B, "painoverridefunc" },
    { 0x0BA88848, "pains" },
    { 0xEA3BA9D0, "painstarttime" },
    { 0x43F5D838, "painstopaiming" },
    { 0x15B9E127, "paint" },
    { 0xAF045305, "paint_spray" },
    { 0x09B04134, "paintadd" },
    { 0xBDF5ACEC, "painted" },
    { 0x734B5F76, "paintent" },
    { 0xC376E207, "painter_init" },
    { 0x10E8EB7D, "painter_initvars" },
    { 0x63A9B9F6, "paintime" },
    { 0x91D23C8C, "paintjob" },
    { 0x083DAFC0, "paintjobindex" },
    { 0xC6C4DC48, "paintjobslot" },
    { 0x61662B9E, "paints" },
    { 0x840A9907, "paintshop_bg" },
    { 0x29FDA0AC, "paintshop_light_exploder_name" },
    { 0x02AE0AE2, "paintshop_light_zoom_exploder_name" },
    { 0x6776E365, "paintshop_weapon_kick_exploder_name" },
    { 0xBF609991, "paintshopcameracloseup" },
    { 0xAB7E5449, "paintshopclasstype" },
    { 0x80BCC14E, "paintshophiddenposition" },
    { 0x8C650A82, "paintshops" },
    { 0x82A76E30, "painvox" },
    { 0xF292A585, "painwaitinterval" },
    { 0xA6BF43D1, "painwaitintervalremove" },
    { 0x41ECC86D, "pair" },
    { 0xF67F991A, "paired" },
    { 0x21A2866C, "pairs" },
    { 0x810AC807, "pak" },
    { 0x79137002, "pak1_01" },
    { 0x305FCF2D, "pak1_01_render" },
    { 0x5686E427, "pak2" },
    { 0x85EAD90B, "pak2_01" },
    { 0xB0998CF2, "pak2_01_render" },
    { 0x308469BE, "pak3" },
    { 0x1B0D3DD0, "pak3_kill_vehicle" },
    { 0xA3E98D51, "pak3_new_ending" },
    { 0xF132BE94, "pak3_timescale" },
    { 0x7544614E, "pak3_water_sheeting" },
    { 0x11C1DFD8, "pak43" },
    { 0x686FA8AB, "pak_01" },
    { 0xD98C3FD2, "pak_01_render" },
    { 0x79B6E6FA, "pak_01c" },
    { 0xE62B7755, "pak_01c_render" },
    { 0xBBC59899, "pak_02a" },
    { 0xF65182FC, "pak_02a_render" },
    { 0xE1C81302, "pak_02b" },
    { 0xE30FA02D, "pak_02b_render" },
    { 0x33981DC9, "pak_crew" },
    { 0x066BFF44, "pak_scaffold_collapse_02_volume" },
    { 0x4FC32D69, "pak_struct" },
    { 0xD392A3B0, "pakistan" },
    { 0x9206C3DB, "pakistan3" },
    { 0x3779BE07, "pakistan_2" },
    { 0xB202CD8A, "pakistan_2_amb" },
    { 0xCA5E064D, "pakistan_2_anim" },
    { 0x9CB22FA9, "pakistan_2_art" },
    { 0x5C47A3D8, "pakistan_2_fx" },
    { 0x1177439E, "pakistan_3" },
    { 0x5BA192DF, "pakistan_3_amb" },
    { 0xBDE07FC2, "pakistan_3_anim" },
    { 0x365D4ABC, "pakistan_3_art" },
    { 0x55B6E4CB, "pakistan_3_fx" },
    { 0x79CB34A0, "pakistan_3_gump_escape" },
    { 0xFB604656, "pakistan_3_gump_escape_end" },
    { 0x4077709B, "pakistan_3_gump_escape_intro" },
    { 0xEA65B8E1, "pakistan_amb" },
    { 0xEE154CA8, "pakistan_anim" },
    { 0xD83DD298, "pakistan_anthem" },
    { 0xF1F8C3AB, "pakistan_anthem_approach" },
    { 0x428F07F6, "pakistan_art" },
    { 0x17986D9E, "pakistan_claw" },
    { 0xEDB01BC7, "pakistan_claw_fire_direction" },
    { 0xBDC89F3A, "pakistan_deconstruct_ents" },
    { 0xFD9DA1C2, "pakistan_deconstruct_models" },
    { 0x80BBDADC, "pakistan_dronespawn" },
    { 0x0C323EBA, "pakistan_escape" },
    { 0x5D03D5E0, "pakistan_escape_end" },
    { 0xE0ECABB8, "pakistan_escape_end_triggers" },
    { 0x5A387F7D, "pakistan_escape_fx_triggers" },
    { 0xC2FBD2ED, "pakistan_escape_intro" },
    { 0x978C4CB2, "pakistan_evac" },
    { 0xCEE531C0, "pakistan_fade_out" },
    { 0xE4174C41, "pakistan_fx" },
    { 0x274C5AB3, "pakistan_gump_alley_fx" },
    { 0xC0681786, "pakistan_gump_street" },
    { 0xB7BD6F0B, "pakistan_market" },
    { 0x0ED5E912, "pakistan_move_mode" },
    { 0x6D3BD57B, "pakistan_objectives" },
    { 0x052AC850, "pakistan_reconstruct_ents" },
    { 0x5057A3C5, "pakistan_reset_movemode" },
    { 0x46310D1B, "pakistan_roof_meeting" },
    { 0xBE3C0470, "pakistan_s3_util" },
    { 0xDE75AD12, "pakistan_shared_gcm_offline" },
    { 0x7F19E802, "pakistan_street" },
    { 0xFCA015E2, "pakistan_title_screen" },
    { 0x58792293, "pakistan_util" },
    { 0x5BAFA184, "pakistan_warehouse" },
    { 0x56DBE321, "pakistani" },
    { 0xFDED7434, "pakistani_names" },
    { 0x6AE29A23, "pakour" },
    { 0x7E5E48D5, "palace" },
    { 0xC0F1D9DD, "palm" },
    { 0xE5F50021, "palm_style_door_open" },
    { 0xB2405323, "palm_trees" },
    { 0x64290FCC, "palmer" },
    { 0xC915A9EA, "palmtree_anims" },
    { 0x569593E0, "palmtrees" },
    { 0xC2FE63FA, "pan" },
    { 0x35B3172B, "pan1_01" },
    { 0x06DF9752, "pan1_01_render" },
    { 0x3DBE0222, "pan2_01" },
    { 0x0E45098D, "pan2_01_render" },
    { 0x4CB32BB1, "pan3_01" },
    { 0x8A2F4E64, "pan3_01_render" },
    { 0x34CBFE68, "pan4_01" },
    { 0xFFB6FDD7, "pan4_01_render" },
    { 0x4ED0EC37, "pan5_01" },
    { 0x72CD156E, "pan5_01_render" },
    { 0x6328CFEE, "pan6_01" },
    { 0x5CC79569, "pan6_01_render" },
    { 0x8D8B0A51, "pan_00" },
    { 0xC90F1D41, "pan_01a" },
    { 0x7874DFF4, "pan_01a_render" },
    { 0xEF1197AA, "pan_01b" },
    { 0x57BE3545, "pan_01b_render" },
    { 0xD98FFF23, "pan_02" },
    { 0xE7AE3C1A, "pan_02_render" },
    { 0xE063EC02, "pan_truck" },
    { 0xCABF80F7, "pan_volume" },
    { 0xBA81F109, "panama" },
    { 0x6B95F460, "panama1_01" },
    { 0xA8AD08D5, "panama2_01" },
    { 0xF72CE2E6, "panama3_01" },
    { 0xDFCFFA66, "panama3_art" },
    { 0x9EBC5566, "panama_2" },
    { 0x8BBC6A07, "panama_2_amb" },
    { 0x0800C3FA, "panama_2_anim" },
    { 0xB9402D59, "panama_2_dialog" },
    { 0x7B2D4EA3, "panama_2_fx" },
    { 0xC4BECFCF, "panama_3" },
    { 0x81363C12, "panama_3_amb" },
    { 0x2C5CE545, "panama_3_anim" },
    { 0x3CA814F0, "panama_3_fx" },
    { 0xE2D06094, "panama_airfield" },
    { 0xECC5EF94, "panama_amb" },
    { 0xD31DA4EB, "panama_anim" },
    { 0x8579397B, "panama_art" },
    { 0xAB96BFAC, "panama_building" },
    { 0x2791F0D6, "panama_chase" },
    { 0x6C37267A, "panama_custom_introscreen" },
    { 0x4D7F7650, "panama_docks" },
    { 0x75F0FC2E, "panama_fx" },
    { 0xCFCF0348, "panama_house" },
    { 0x023B24B3, "panama_motel" },
    { 0xEEAF7DC6, "panama_slums" },
    { 0xC06D4D3C, "panama_utility" },
    { 0x34F01D26, "panama_wind_settings" },
    { 0x4B8C0177, "panamanian" },
    { 0xBDE11676, "panamanian_names" },
    { 0xED5991C2, "pandora" },
    { 0x36B021D0, "pandora_fx_func" },
    { 0xB964180F, "pandora_light" },
    { 0x3911197B, "pandora_show_func" },
    { 0x3ADE0D09, "pandoraboxes" },
    { 0xBE20A633, "pane" },
    { 0x079577D5, "panel" },
    { 0xC275DE3E, "panel2_rattle" },
    { 0xB1D2AB89, "panel_delete_in_container" },
    { 0xC965BEE3, "panel_fall_splash" },
    { 0x50435F12, "panel_fx" },
    { 0x3E64B976, "panel_rattle" },
    { 0xAFBF70F8, "panel_tag" },
    { 0xB22EA724, "panels" },
    { 0x6C4B097B, "pangles" },
    { 0xEBBB36E6, "panic" },
    { 0x771F59A4, "panic_no" },
    { 0x76A684EE, "panic_yes" },
    { 0x72E9DC29, "panlooper" },
    { 0xF061E343, "panned" },
    { 0x337F4128, "panning" },
    { 0x6E5DF536, "pansoundent" },
    { 0xDA9C0EEF, "panther" },
    { 0xF90A3023, "panther_activated" },
    { 0x32320134, "panther_dead" },
    { 0x62410486, "panther_fire" },
    { 0x9C6638BB, "panther_first_shot" },
    { 0x7469003C, "panther_in_sights" },
    { 0xD147FD84, "panther_patrol" },
    { 0x2B84887D, "panther_second_shot" },
    { 0x6DBF2964, "panther_strat" },
    { 0x72DE585E, "panther_tanks_1_dead" },
    { 0x27311867, "panther_tanks_2_dead" },
    { 0x2E2EC418, "panther_third_shot" },
    { 0x98D5A336, "panthers" },
    { 0x568E0BCF, "pantherwaves" },
    { 0xA8651FF4, "pants01" },
    { 0x285BE841, "panzer" },
    { 0x03D3CA7A, "panzer1" },
    { 0xDDD15011, "panzer2" },
    { 0x78F564D1, "panzer_delay" },
    { 0x7283F983, "panzer_ent" },
    { 0x752B0127, "panzer_ent_offset" },
    { 0xF3578D00, "panzer_fire" },
    { 0x3D559931, "panzer_killer" },
    { 0x4C1060D8, "panzer_node" },
    { 0x6AB4CA42, "panzer_pos" },
    { 0x2D35C08F, "panzer_target" },
    { 0x724D3971, "panzer_target_ent" },
    { 0x3A094DC0, "panzeriv" },
    { 0x37303B68, "panzers" },
    { 0xD7902040, "panzerscheck" },
    { 0x97222AB0, "panzerschreck" },
    { 0xED96E31B, "panzerschrecks" },
    { 0x033308F9, "panzerschrek" },
    { 0x27612D38, "panzerschrek_info" },
    { 0x1B289C38, "panzerschrek_respawn" },
    { 0x3D8A217A, "panzerschrek_zombie" },
    { 0x30280A30, "panzerschreks" },
    { 0xBF7CD1EC, "panzershot_spot" },
    { 0x94BF1F4D, "panzershreck" },
    { 0x9C460958, "panzershreck_guys" },
    { 0xE49D17CC, "panzershrecks" },
    { 0x90E07022, "panzershrek" },
    { 0x509527F2, "panzershrek_1_spawn" },
    { 0x135CD5D9, "panzershrek_2_spawn" },
    { 0xB0ACD4D2, "panzershrek_hits_wall" },
    { 0x3F172C14, "pap" },
    { 0xEBA48475, "pap1" },
    { 0xD31A12E1, "pap_active" },
    { 0x7EC580F7, "pap_active_time" },
    { 0xDB43BBE6, "pap_array" },
    { 0x6A09ED4F, "pap_arriving" },
    { 0xA61C0755, "pap_camo_to_use" },
    { 0x0DC26CF5, "pap_clip" },
    { 0x465AF671, "pap_eject_gun" },
    { 0x194C7462, "pap_flag_piece" },
    { 0x90E7ACA6, "pap_flush_done" },
    { 0xC838C205, "pap_flush_screen_shake" },
    { 0x0D3C8728, "pap_grab_by_anyone" },
    { 0x80630CA5, "pap_initial" },
    { 0x2885E566, "pap_initial_piece" },
    { 0x5AF67E89, "pap_interaction_height" },
    { 0xCDF46D6A, "pap_is_buildable" },
    { 0x298BA891, "pap_is_on" },
    { 0x14AEB384, "pap_jingle_struct" },
    { 0x52AA32CD, "pap_leaving" },
    { 0x043C5DB6, "pap_machine" },
    { 0x0E0ACF2A, "pap_machine_sound" },
    { 0x775D8B87, "pap_machine_trig" },
    { 0x1C80C669, "pap_moving" },
    { 0x0A35326B, "pap_packing_piece" },
    { 0x0C57EAB2, "pap_pieces" },
    { 0xEDE10A11, "pap_plates_active" },
    { 0x5186807E, "pap_plates_state" },
    { 0x581C3E2A, "pap_play_fx" },
    { 0x7D9937E2, "pap_player_disconnected" },
    { 0xFBF5FA31, "pap_player_flush_temp_trig" },
    { 0x1F60FC46, "pap_playerclip" },
    { 0x2F78CDC4, "pap_power_off" },
    { 0x1A50A82E, "pap_power_on" },
    { 0x5287DA71, "pap_powered" },
    { 0xBF1D7B3A, "pap_powered_piece" },
    { 0xDC829F8F, "pap_ramp" },
    { 0x51F7D5B2, "pap_range" },
    { 0xF6B6A2CA, "pap_reset_complete" },
    { 0xB1DA75B1, "pap_stairs" },
    { 0xA0F4492E, "pap_stairs_clip" },
    { 0xD87A0841, "pap_take_gun" },
    { 0x84DD0A04, "pap_taken" },
    { 0xE18AA4BD, "pap_teleport_piece" },
    { 0x9938B710, "pap_time" },
    { 0x9DCDFEFC, "pap_timeout" },
    { 0x0397FE29, "pap_timer_length" },
    { 0x1310959D, "pap_timers" },
    { 0x25B72B5F, "pap_trigger_hintstring_monitor" },
    { 0x28497573, "pap_trigger_hintstring_monitor_reset" },
    { 0x10F9C82C, "pap_triggers" },
    { 0xECED4B34, "pap_used" },
    { 0x9251C9F9, "pap_watcher" },
    { 0x2DDA81A9, "pap_weapon_grabbed" },
    { 0x165DA7EE, "pap_weapon_knuckle_crack" },
    { 0x3FE26769, "pap_weapon_move_in" },
    { 0xF65AC400, "pap_weapon_move_out" },
    { 0x03696070, "pap_weapon_piece" },
    { 0xA6C3814C, "pap_working_fx_handler" },
    { 0xEACF814F, "pap_zbarrier_state_func" },
    { 0xF2416C0C, "papbuildable" },
    { 0x285F3BB1, "paper" },
    { 0xB8C0D6AA, "paper1" },
    { 0x92BE5C41, "paper2" },
    { 0x648B1111, "paper_burner_1_deathfunction" },
    { 0x61FD2B72, "paper_burner_2_deathfunction" },
    { 0xD52C000B, "paper_burner_dropped_gascan" },
    { 0x2D172BC8, "paper_burner_gas_can_fx" },
    { 0x47E4C461, "paper_burners_react" },
    { 0xD7E19777, "paper_left" },
    { 0xBB9D58D7, "paper_left2" },
    { 0x89D784B2, "paper_right" },
    { 0x84B7E314, "paper_right2" },
    { 0x16F86FE9, "paper_toss" },
    { 0xED5A7C18, "papers" },
    { 0xA6E58EA9, "papers_please" },
    { 0x8DB932B2, "paporigin" },
    { 0x29C1382B, "par1" },
    { 0xB7B9C8F0, "par2" },
    { 0xDDBC4359, "par3" },
    { 0x9BC8A766, "par4" },
    { 0x48FAF75B, "para" },
    { 0x54B3659E, "para_start" },
    { 0x2B96867E, "para_stop" },
    { 0x77825FD6, "parachute" },
    { 0xC3DE19D4, "parachute_01" },
    { 0x35E5890F, "parachute_02" },
    { 0x0FE30EA6, "parachute_03" },
    { 0x456ED4BD, "parachute_anim_done" },
    { 0xC5CDA105, "parachute_first_guy" },
    { 0x60F0D2D9, "parachute_into_base" },
    { 0x6C0F3947, "parachute_loop" },
    { 0x9D5A56C2, "parachute_player" },
    { 0x5E58B6D9, "parachute_shake" },
    { 0xE3FAE7E7, "parachute_trig" },
    { 0x52FC6CD8, "parachuteaway" },
    { 0xB300A449, "parachutes" },
    { 0x864C9E0A, "parachutethink" },
    { 0xB008CDF8, "parachuuuuuuute" },
    { 0x1EED18EE, "paradise" },
    { 0x09CAD16D, "paragoniconid" },
    { 0x87F99CBB, "paragonrank" },
    { 0xD11B2030, "parallax" },
    { 0x35E93838, "parallel" },
    { 0xEB77E081, "paralyzer_callback" },
    { 0xF2647405, "paralyzer_damaged_multiplier" },
    { 0x5339A933, "paralyzer_hit_callback" },
    { 0x310E8519, "paralyzer_score_time_ms" },
    { 0xF628B5CC, "paralyzer_slowtime" },
    { 0xED1F8021, "paralyzer_time_per_frame" },
    { 0xC0F4E794, "param" },
    { 0xB5B0348C, "param0" },
    { 0xDBB2AEF5, "param1" },
    { 0x2F71123F, "param10" },
    { 0x096E97D6, "param11" },
    { 0xE36C1D6D, "param12" },
    { 0xBD69A304, "param13" },
    { 0x9767289B, "param14" },
    { 0x7164AE32, "param15" },
    { 0x01B5295E, "param2" },
    { 0x27B7A3C7, "param3" },
    { 0x1DA64AE8, "param4" },
    { 0x43A8C551, "param5" },
    { 0x69AB3FBA, "param6" },
    { 0x8FADBA23, "param7" },
    { 0x859C6144, "param8" },
    { 0xAB9EDBAD, "param9" },
    { 0xF0A36608, "param_1" },
    { 0x62AAD543, "param_2" },
    { 0x3CA85ADA, "param_3" },
    { 0xAEAFCA15, "param_4" },
    { 0x88AD4FAC, "param_5" },
    { 0xFAB4BEE7, "param_6" },
    { 0x9FA60E40, "param_count" },
    { 0x70590F26, "paramater" },
    { 0x0045E727, "paramcb" },
    { 0x876C53D1, "paramenters" },
    { 0xC20BB32A, "parameter" },
    { 0x6845DEF7, "parameter1" },
    { 0xF63E6FBC, "parameter2" },
    { 0xE499A1C8, "parameterize" },
    { 0x7ED17EDC, "parameterized" },
    { 0x9BA24FE5, "parameters" },
    { 0xB6FC4FB5, "paramname" },
    { 0xA8563E07, "params" },
    { 0x7101F8C1, "paramstr" },
    { 0x6453C19D, "paramter" },
    { 0x0FD9D2A4, "paranoia" },
    { 0x9DD26369, "paranoid" },
    { 0x9231E1C6, "parasite" },
    { 0x729653C3, "parasite_attractor" },
    { 0x77D36058, "parasite_attractor_grab" },
    { 0x5F8A3880, "parasite_attractor_init" },
    { 0x4CAE603E, "parasite_away_from_character" },
    { 0x34795E6E, "parasite_belly_glow_max" },
    { 0x8750CD30, "parasite_belly_glow_min" },
    { 0xF99CC169, "parasite_change_position_toattack_target_delay" },
    { 0x5F6CF4B2, "parasite_damage" },
    { 0xF6527CA9, "parasite_damage_thread" },
    { 0x7297D7DC, "parasite_drop_item" },
    { 0x21B16690, "parasite_enemy_too_close_dist" },
    { 0x5BA206F0, "parasite_fire_chance" },
    { 0x6031F729, "parasite_firing_rate" },
    { 0x4C31BB81, "parasite_fog_on" },
    { 0x41BA5057, "parasite_initialize" },
    { 0xD01BD332, "parasite_juke_move_dist_max" },
    { 0x4AE22008, "parasite_max_time_at_same_position" },
    { 0x3DD47CBE, "parasite_melee_chance" },
    { 0xF0AEDE92, "parasite_melee_dist" },
    { 0x326BC1E6, "parasite_move_dist_max" },
    { 0x405238AF, "parasite_radius" },
    { 0x31DCB191, "parasite_repath_range" },
    { 0x2DAF7170, "parasite_round_fx" },
    { 0xC9063F15, "parasite_round_ring_fx" },
    { 0xEC393181, "parasite_target_selection" },
    { 0x3DAA9D01, "parasite_targets" },
    { 0x8F13D538, "parasite_too_close_to_self_dist" },
    { 0xFD0D2DC8, "parasite_variables" },
    { 0x51482ECA, "parasiteenemy" },
    { 0xE3BDAF79, "parasites" },
    { 0xA6B394F4, "parasitesecondarydeathfxhandler" },
    { 0xEFB89EFF, "parasitetellfxhandler" },
    { 0x94AFBC2D, "parent" },
    { 0x3C71A59A, "parent_boat" },
    { 0xD054F708, "parent_elem_index" },
    { 0x6725D265, "parent_menu" },
    { 0xDDA114F7, "parent_model" },
    { 0xADA33152, "parent_model_tag" },
    { 0x56FF8C95, "parent_object" },
    { 0x2970944F, "parent_player" },
    { 0xB210981F, "parent_script_struct" },
    { 0xC826139B, "parent_struct" },
    { 0xFAE9AE9B, "parent_team" },
    { 0xFC68C62E, "parent_trig" },
    { 0x016A34D4, "parent_trigger" },
    { 0xA5B9D3B2, "parent_zone" },
    { 0xFA1B840A, "parentdamage" },
    { 0x7F7C86DA, "parentdef" },
    { 0x267EF3A5, "parentdistancetogoalsquared" },
    { 0xACB5ECDA, "parented" },
    { 0x7F431D54, "parentent" },
    { 0x0D68E9B4, "parententities" },
    { 0xB859CA38, "parententity" },
    { 0xCF4FFAFB, "parenthesis" },
    { 0x5B439434, "parentmodel" },
    { 0x79E39BCD, "parentnode" },
    { 0x3F8A0826, "parentpredictedlocation" },
    { 0x5E17F4EE, "parentspeed" },
    { 0x9A0EAF9A, "parentstruct" },
    { 0xEF895CC8, "parentvelocity" },
    { 0x1ADBC7B4, "parentweaponname" },
    { 0xBB731F92, "paris" },
    { 0xEF9EBFD6, "parity" },
    { 0x2D09D5D1, "park" },
    { 0x7BC226D3, "park_movement_vo" },
    { 0x26AFDA27, "park_reinforce" },
    { 0x4023D862, "parked_b17_logic" },
    { 0xE22A61D1, "parked_courtyard_sedans" },
    { 0x734CA4B7, "parking" },
    { 0xFE85010B, "parking_breach_door_open" },
    { 0xA7B598B0, "parking_breach_enemies" },
    { 0x34580AFA, "parking_breach_enemies_setup" },
    { 0x7F30CC62, "parking_door_breach" },
    { 0x1C582C61, "parking_door_breach_node" },
    { 0x39A69097, "parking_door_friendly_kill" },
    { 0x73D97D2A, "parking_door_nag_timing" },
    { 0xECF06EAE, "parking_door_node_reached" },
    { 0x57C37B56, "parking_door_opened" },
    { 0x7210EA58, "parking_lot_backup" },
    { 0x26170DEC, "parking_lot_enemy_vo" },
    { 0x9D2FB4C2, "parking_lot_exit" },
    { 0x2C8C403F, "parking_lot_gone_hot" },
    { 0xCBCA252A, "parking_lot_scene" },
    { 0x8389385E, "parking_nag_array" },
    { 0xA0C9692B, "parking_structure_destroy_roof" },
    { 0xCD400B58, "parking_structure_roof_collapse" },
    { 0x9BAFCC76, "parkinglot_heli_attack" },
    { 0x44D95008, "parkinglotdummies" },
    { 0xA08AE0FB, "parkinglotvehicles" },
    { 0xD842AA51, "parkour" },
    { 0x9488B694, "parliament" },
    { 0x708DD95E, "parliament_aa_tracers" },
    { 0x02BEBA11, "parliament_doors_open" },
    { 0x84186F53, "parliament_eagle_anim" },
    { 0xD960148F, "parliament_enemy_spawnfunc" },
    { 0xF1723312, "parliament_room" },
    { 0x18F679CC, "parlour" },
    { 0x1118B447, "parm" },
    { 0xEA6A5DAC, "parm1" },
    { 0x5C71CCE7, "parm2" },
    { 0x366F527E, "parm3" },
    { 0xB5D0B83E, "parms" },
    { 0x820C2E4E, "parrallel" },
    { 0xE107EEB6, "parse" },
    { 0x8E1EC5B3, "parse_script_parameters" },
    { 0xD97E2EED, "parse_structs" },
    { 0x6F8CBA90, "parse_vo_and_play_them" },
    { 0x9FA7FD68, "parseclassstat" },
    { 0xC26D7970, "parsecs" },
    { 0x4DD5FF46, "parsed" },
    { 0x60C8C100, "parsedfootstepnotetracks" },
    { 0x32342C1E, "parselink" },
    { 0x7669214A, "parsenode" },
    { 0x2FA1F4A9, "parses" },
    { 0xB0C39598, "parseweaponstat" },
    { 0xF9603CAF, "parsing" },
    { 0x1B2A0D26, "part" },
    { 0x2FAC20EB, "part1" },
    { 0x04006F7E, "part1_done" },
    { 0xBDA4B1B0, "part2" },
    { 0xE3A72C19, "part3" },
    { 0x64D5B0BD, "part_destroyed_ui_model" },
    { 0x2D046033, "part_has_physics_exposion" },
    { 0x4DF0A025, "part_hlth" },
    { 0x7EEB947A, "part_key" },
    { 0x3264E7A8, "part_links" },
    { 0xC122676D, "part_modelname" },
    { 0xAFA2946C, "part_name" },
    { 0xFC739125, "part_of_plane" },
    { 0xE2E9862D, "part_type" },
    { 0x1C545167, "partdestroyed" },
    { 0xD0183EF6, "parters" },
    { 0x8D81E6F8, "parthealth" },
    { 0xF5D064BC, "partial" },
    { 0x7C1BD8B4, "partial_damage" },
    { 0x091CE7B9, "partially" },
    { 0xE8ADEDF5, "partialy" },
    { 0x0B97030B, "participants" },
    { 0xDC80306F, "participate" },
    { 0x47B28564, "participation" },
    { 0xD3B6AEC2, "participation_point_cap" },
    { 0xBD017349, "participation_point_flattenovertime" },
    { 0x702DE8A3, "particle" },
    { 0x2A474ACA, "particle_light" },
    { 0x677624C1, "particlelight" },
    { 0xC16F5992, "particles" },
    { 0x45A70A78, "particular" },
    { 0x89B04C7D, "particularly" },
    { 0x39F00927, "parties" },
    { 0x2D86DEA2, "partindex" },
    { 0x86AF3F2A, "partkeys" },
    { 0xF105C26B, "partname" },
    { 0x80EB5D29, "partner" },
    { 0x1FE672C2, "partner_dial" },
    { 0x981814AE, "partner_end_melee" },
    { 0x2E15CEB6, "partnerdir" },
    { 0x890544A0, "partners" },
    { 0xBC613B3E, "partnum" },
    { 0x103441F3, "partol" },
    { 0x288FF2CE, "partone" },
    { 0x6445C659, "parts" },
    { 0x2386259F, "partstr" },
    { 0x228B6951, "parttags" },
    { 0x153F98BF, "parttags_btm" },
    { 0x299432ED, "parttags_chips" },
    { 0x7D732BD8, "parttags_dmg" },
    { 0xB3E67CCA, "parttags_mid" },
    { 0xC4FC3780, "parttags_upper" },
    { 0x07E9D180, "parttwo" },
    { 0xE05E8E73, "party" },
    { 0xA9764259, "partyprivacy" },
    { 0xA3D2CC30, "pase" },
    { 0x27BA0416, "pass" },
    { 0xF3F6F1CE, "pass_attributes" },
    { 0x0D43DF50, "pass_distance" },
    { 0x1FFAEE87, "pass_index" },
    { 0x7B5FE66F, "pass_notify_params" },
    { 0x1DECD482, "pass_on_damage" },
    { 0x06B1B950, "pass_through_clean_room" },
    { 0xD98C8527, "passage" },
    { 0xB9743D12, "passage_beatdown_earlyout" },
    { 0x0828E2F2, "passangers" },
    { 0x68EBC631, "passanim" },
    { 0x19A2E791, "passby" },
    { 0xA8097706, "passbytimings" },
    { 0x43F93DD9, "passed" },
    { 0x15C282BF, "passed_dist_sq" },
    { 0xDFED150F, "passed_failsafe" },
    { 0x46DF529E, "passed_introscreen" },
    { 0x1457B0C4, "passed_safe_point" },
    { 0x6A6F155F, "passenger" },
    { 0x45736014, "passenger2_anims" },
    { 0x51314AA4, "passenger_anims" },
    { 0x0EC6FCF4, "passenger_death" },
    { 0xC23238CE, "passenger_event" },
    { 0xBD349871, "passenger_events" },
    { 0x9FD6D55C, "passenger_pos" },
    { 0x4F436F4E, "passenger_side_far_rear" },
    { 0x6758B5DC, "passenger_side_rear" },
    { 0x62AEA6E7, "passenger_targetnames" },
    { 0x4F5D525F, "passenger_working" },
    { 0x2A391571, "passengerindex" },
    { 0x442B245F, "passengerlookback" },
    { 0xB2F6ACE6, "passengers" },
    { 0xC7E075BF, "passer" },
    { 0xF23BD319, "passerby_timing" },
    { 0x21F62AF3, "passerby_timing_record" },
    { 0xA1DDFB56, "passes" },
    { 0xEDCC0F8D, "passid" },
    { 0x2925F40A, "passing" },
    { 0x0522A607, "passing_by_house_vo" },
    { 0x37EA5AE0, "passing_in_front" },
    { 0x53B7FF50, "passive" },
    { 0x8F2DBEDA, "passnote" },
    { 0x88C09E67, "passnoteback" },
    { 0x401B84F7, "passnotifyparams" },
    { 0x03A5BB95, "passthrough_surrender_thread" },
    { 0x06D09B92, "password" },
    { 0x69ADA009, "past" },
    { 0x6928D32F, "past_dist_sq" },
    { 0x8841DE23, "past_investigation_guards" },
    { 0x8B88AAB5, "past_wing" },
    { 0x966C7606, "paste" },
    { 0xF519E02F, "paste_ents" },
    { 0x9514426F, "paste_ents_onto_ents" },
    { 0x2B170236, "pasted" },
    { 0xB75676BF, "pasting" },
    { 0xA70D4270, "pat" },
    { 0x650DD03A, "patalking" },
    { 0xEA743009, "patch" },
    { 0x5F4354B9, "patches" },
    { 0xA832A6BF, "patching" },
    { 0xD9A41C78, "path" },
    { 0xDF5908AC, "path start" },
    { 0xC8B618B8, "path1end" },
    { 0xB5410FDB, "path1start" },
    { 0x1951E3F1, "path2end" },
    { 0xBD75057A, "path2start" },
    { 0x451B31E5, "path2startarray" },
    { 0x05B069D4, "path_a" },
    { 0x0772F57C, "path_activatebutton" },
    { 0xD9ACCC73, "path_angles" },
    { 0x47A6878D, "path_anim_func" },
    { 0x8806A4C2, "path_array" },
    { 0x70D83874, "path_array_setup" },
    { 0x9260F51B, "path_array_setup_loc" },
    { 0xBA088CD9, "path_blocked" },
    { 0x3DEFC4BF, "path_blocker" },
    { 0x033F510A, "path_blocking" },
    { 0x08255DFC, "path_center" },
    { 0x54915C31, "path_clip" },
    { 0xCBAA002A, "path_clip1" },
    { 0xA5A785C1, "path_clip2" },
    { 0x4ED29B56, "path_complete" },
    { 0x463B7D20, "path_connectlines" },
    { 0x4CF88828, "path_createid" },
    { 0x141DDD8E, "path_delete" },
    { 0xBDE4BD6E, "path_depth" },
    { 0xBA547C7F, "path_dest" },
    { 0xD431FB44, "path_detour" },
    { 0x488686E2, "path_detour_get_detourpath" },
    { 0xB7DC795F, "path_detour_script_origin" },
    { 0x6AF8806C, "path_dir" },
    { 0x19F3AFF6, "path_distance" },
    { 0x72D8D294, "path_drop" },
    { 0x82B3B367, "path_drop_dist" },
    { 0x11FB15B5, "path_dump" },
    { 0x6CC883BA, "path_editmode" },
    { 0x3AA99E96, "path_editmode_update" },
    { 0x440093BA, "path_enable" },
    { 0x519D1A6E, "path_end" },
    { 0x5149252D, "path_end_reached" },
    { 0xA904A778, "path_enemy_fight_distance" },
    { 0x46767ED4, "path_exploit_fix" },
    { 0x294129E9, "path_finished" },
    { 0x19C24F3F, "path_fixed_offset" },
    { 0x88544DAE, "path_fwd" },
    { 0x21B6A8F1, "path_gate_open" },
    { 0x14B5D37F, "path_gate_wait_till_open" },
    { 0x34C9B0FB, "path_getcurrentview" },
    { 0xA5446791, "path_getvisible" },
    { 0x4E29202B, "path_guys" },
    { 0xAE59C3DE, "path_halt" },
    { 0x014C146B, "path_handleselectindex" },
    { 0x6C4CD29E, "path_help" },
    { 0x2BE89FC1, "path_hudshow" },
    { 0xE6F46210, "path_id" },
    { 0x4654BC1E, "path_image" },
    { 0xE5D891E1, "path_index" },
    { 0xF87DC4E0, "path_left" },
    { 0x52CC5B1F, "path_length" },
    { 0xDE96DBF7, "path_length_1" },
    { 0x6C8F6CBC, "path_length_2" },
    { 0x706E8FF0, "path_lenth" },
    { 0x449722AD, "path_math" },
    { 0x4A112842, "path_name" },
    { 0x71DA7B67, "path_node" },
    { 0x93335DAB, "path_node_start_boat" },
    { 0x32CA92D9, "path_node_start_heli" },
    { 0xA77BC9DE, "path_nodes" },
    { 0x163B11F9, "path_num" },
    { 0x89D84DA3, "path_offset_t" },
    { 0xF1CE63FF, "path_offset_x" },
    { 0xCBCBE996, "path_offset_y" },
    { 0xA5C96F2D, "path_offset_z" },
    { 0x152C3913, "path_point" },
    { 0x2EB5E142, "path_points" },
    { 0x365BC533, "path_ready_" },
    { 0x327A67CC, "path_refresh" },
    { 0x9918AC2E, "path_resume" },
    { 0x98A909CF, "path_right" },
    { 0x9B6E6ED0, "path_select_new" },
    { 0x37689721, "path_select_next" },
    { 0xD49F2341, "path_select_prev" },
    { 0xF4077B18, "path_selectid" },
    { 0xE4BC6979, "path_selectindex" },
    { 0xD8F90190, "path_selectrad" },
    { 0x85677EDA, "path_setid" },
    { 0x1CF1F862, "path_setview" },
    { 0x0DF1B3E4, "path_setvieworgang" },
    { 0xDFE6F604, "path_size" },
    { 0xDB08859D, "path_start" },
    { 0x5D84C0ED, "path_start_delay" },
    { 0x8AC677F4, "path_start_node" },
    { 0x89635976, "path_start_targetname" },
    { 0x9A7874DC, "path_starts" },
    { 0xA1CCFC70, "path_struct" },
    { 0x7741DFDB, "path_structs" },
    { 0x6A76E8D9, "path_timer_done" },
    { 0x09DACC20, "path_timer_extension" },
    { 0x1F0A2676, "path_to_point_in_trigger" },
    { 0xA5D97B55, "path_to_trigger" },
    { 0xEE0F886D, "path_trigger_setvieworgang" },
    { 0x3CBE5747, "path_type" },
    { 0xFDEA5610, "path_up" },
    { 0x4891E8B4, "path_update_interrupt" },
    { 0x7725A97A, "path_update_interrupt_by_attacker" },
    { 0xCB06AA1D, "path_update_interrupt_melee" },
    { 0xEB5C8F4C, "path_viewindex" },
    { 0xC9A1FDC1, "path_viewmode" },
    { 0xB9245233, "path_views" },
    { 0x81F8F3FB, "path_viewwait" },
    { 0xBA75162D, "path_waittill_enable" },
    { 0x47A405C7, "path_z" },
    { 0x090772A0, "pathable" },
    { 0x01CAB79B, "pathablematerial" },
    { 0x6EF33B74, "pathbreaks" },
    { 0xA802DF2F, "pathclear" },
    { 0x3CE65C38, "pathdist" },
    { 0x90DCE513, "pathdist_approximate" },
    { 0x2A8929DC, "pathdist_cornerpredicted" },
    { 0xBF3B2786, "pathdist_original" },
    { 0x1ACE2307, "pathdist_type" },
    { 0x2A1FAE39, "pathdistance" },
    { 0x65BB1261, "pathdistancetype" },
    { 0xC26E2A8B, "pathed" },
    { 0xF0CCFD97, "pathend" },
    { 0x2ACCA602, "pathenemyfightdist" },
    { 0xD165C15C, "pathenemylookahead" },
    { 0x561711F6, "pathenemylookahead_old" },
    { 0xC3B41CB4, "pathenemylookahead_prev" },
    { 0x90A55707, "pathent" },
    { 0x3713CDE9, "pathfailcount" },
    { 0x6794B90E, "pathfilter" },
    { 0x41FB1619, "pathfind" },
    { 0xC7762BAF, "pathfinding" },
    { 0x101109DA, "pathfinding_override_fix" },
    { 0xF374D9EF, "pathfixedoffset" },
    { 0x22804E16, "pathfixedoffsetclear" },
    { 0xFA6DE1C1, "pathgoal" },
    { 0x039ABF31, "pathgoalpos" },
    { 0x9483E5C9, "pathheight" },
    { 0xCA278DE0, "pathing" },
    { 0xDE09A6D0, "pathing_fix" },
    { 0xC8EA99BC, "pathlength" },
    { 0x998BEAE6, "pathlengthreverse" },
    { 0x32B40421, "pathlookpos" },
    { 0xFA88BB54, "pathmod" },
    { 0x86E828E1, "pathmode" },
    { 0xECD8796F, "pathmodsize" },
    { 0x465E2E0F, "pathmove" },
    { 0x4A115711, "pathname" },
    { 0x9AC91FBC, "pathnode" },
    { 0xDEF9A76E, "pathnodehints" },
    { 0xB82D707F, "pathnodes" },
    { 0x66A07A68, "pathnum" },
    { 0x8A3DD89A, "pathpoint" },
    { 0x448D6758, "pathpointorigin" },
    { 0x73812695, "pathpoints" },
    { 0xCD2E0946, "pathpos" },
    { 0xC0879560, "pathrandomness" },
    { 0x52C8BF39, "pathrunners" },
    { 0xA7D733D3, "paths" },
    { 0x554447A8, "paths_selectid_list" },
    { 0xE5C84AE2, "pathsdisconnected" },
    { 0x18EB9201, "pathspeedscale" },
    { 0xE77687D0, "pathspot" },
    { 0x0118CE7C, "pathstart" },
    { 0xFD6B7EDA, "pathstartpos" },
    { 0x6A3F1CA1, "pathsuccess" },
    { 0x7C2455A1, "pathvariableoffset" },
    { 0x546ACB2C, "pathvariableoffsetclear" },
    { 0x19D2FE5E, "pathvec" },
    { 0xAF163045, "pathway" },
    { 0x12BEE6D4, "pathways" },
    { 0xAAEC8DCC, "pathwidth" },
    { 0x96F03F68, "patience" },
    { 0x1A753EC8, "patient" },
    { 0x30247C35, "patollers" },
    { 0xDF4CA6BD, "patrenko" },
    { 0x97112417, "patrenko_barricade_anim" },
    { 0x6A303443, "patrenko_building_1_holdouts" },
    { 0xC65EBD72, "patrenko_building_2_holdouts" },
    { 0x1FFADD83, "patrenko_check_thread_1" },
    { 0xADF36E48, "patrenko_check_thread_2" },
    { 0xD3F5E8B1, "patrenko_check_thread_3" },
    { 0xA0E36CEF, "patrenko_door_node" },
    { 0x4F05DCFC, "patrenko_hangar_door" },
    { 0x45CD5EA6, "patrenko_open_first_door_anim" },
    { 0xC821492C, "patrenko_reminder_finish" },
    { 0x84447A69, "patrenko_reminder_thread" },
    { 0xBF69EEED, "patrenko_setup_checks" },
    { 0x5636E9ED, "patrenko_spawn" },
    { 0x8C0AF1FC, "patrenko_spawner" },
    { 0x4F73D04D, "patrenko_spawnfunction" },
    { 0x99E190FF, "patrol" },
    { 0x28F48FAF, "patrol2" },
    { 0x4546B67C, "patrol_a_logic" },
    { 0xA9D6A4B4, "patrol_alert" },
    { 0xC6E40B1C, "patrol_alerted_find_player_quickly" },
    { 0x32C6FF84, "patrol_anims" },
    { 0x4511D975, "patrol_array" },
    { 0x2C4F8897, "patrol_b_logic" },
    { 0xF46B3276, "patrol_b_started" },
    { 0xC1A355B8, "patrol_balcony_vc_movement" },
    { 0x1145CE47, "patrol_blocker_fail" },
    { 0x124AE5A4, "patrol_boat" },
    { 0xE07F6E2F, "patrol_boat_angles" },
    { 0x4061C47E, "patrol_boat_damage_control" },
    { 0x30F6CD59, "patrol_boat_dead" },
    { 0x93F6707E, "patrol_boat_death_check" },
    { 0x707E4928, "patrol_boat_destroyed" },
    { 0xF56662C0, "patrol_boat_disability_check" },
    { 0x5708720B, "patrol_boat_disabled" },
    { 0x561D73C8, "patrol_boat_fires_guns" },
    { 0x6C7F8285, "patrol_boat_goal_node" },
    { 0x56C1BD12, "patrol_boat_gunner" },
    { 0xC18DBF18, "patrol_boat_gunner_death_check" },
    { 0x426F4573, "patrol_boat_gunner_locality_check" },
    { 0xABDD56AE, "patrol_boat_gunner_number" },
    { 0x9E33E81D, "patrol_boat_gunners" },
    { 0x0DE83CEF, "patrol_boat_harassment" },
    { 0x68A36795, "patrol_boat_hint_dialogue" },
    { 0x487F8666, "patrol_boat_name" },
    { 0x9F03A15F, "patrol_boat_rail" },
    { 0x8C0C5958, "patrol_boat_runner_think" },
    { 0x8681EF4B, "patrol_bored_2_combat_alarm_short" },
    { 0x51061AD1, "patrol_bored_idle" },
    { 0x8301BBEF, "patrol_bored_idle_smoke" },
    { 0x6E60EFBA, "patrol_bored_patrolwalk" },
    { 0x5635A841, "patrol_bored_twitch_bug" },
    { 0xBC9FE6EC, "patrol_bored_twitch_stretch" },
    { 0x3C9DD6BE, "patrol_c_dummy_about_to_spawn" },
    { 0x3D5E4CE4, "patrol_check_for_player_firing" },
    { 0x9298EB59, "patrol_claimed" },
    { 0x41C11AAD, "patrol_clear" },
    { 0xFC2E95A0, "patrol_death_notify" },
    { 0x32C662EA, "patrol_director" },
    { 0x7B91CD12, "patrol_disabled" },
    { 0xADA80211, "patrol_distance_life_check" },
    { 0xFC13C1C5, "patrol_dont_check_player_fire" },
    { 0xB0BC0A39, "patrol_dont_claim_node" },
    { 0x32DB3071, "patrol_enabled" },
    { 0x5CA48B93, "patrol_goal" },
    { 0x9FE6B2FB, "patrol_gone" },
    { 0xF91974DB, "patrol_guy" },
    { 0x04DBAFFA, "patrol_guys" },
    { 0x54DFC4BC, "patrol_init" },
    { 0x36E51EDE, "patrol_init_custom" },
    { 0x8D1875DC, "patrol_lase_goal_waiter" },
    { 0x1B9E35BC, "patrol_loop" },
    { 0xA2D2DAEA, "patrol_loop_then_retreat" },
    { 0x04776A45, "patrol_main" },
    { 0x7015CDE7, "patrol_manager" },
    { 0x58E14C90, "patrol_next_node" },
    { 0x6FE3A1CE, "patrol_node" },
    { 0xF4B0B3E5, "patrol_passes" },
    { 0x80B9387F, "patrol_path" },
    { 0x357D1EB9, "patrol_path_start_node" },
    { 0x4BF3A85D, "patrol_route_complete" },
    { 0x188343B4, "patrol_routes" },
    { 0xB5D98C2E, "patrol_search_for_player" },
    { 0x144D201B, "patrol_set_ground_visibility_distance" },
    { 0xC08E5ADD, "patrol_setanim" },
    { 0xF9AD716C, "patrol_sight_check" },
    { 0xA4A95313, "patrol_soon" },
    { 0x0F609F3E, "patrol_spawn_function" },
    { 0x76001F55, "patrol_spawners" },
    { 0xD6C0BC39, "patrol_start_node" },
    { 0xC0FA4295, "patrol_starts" },
    { 0xFE9E21D7, "patrol_stealth_damage_notify" },
    { 0xA13C0705, "patrol_stealth_track_player" },
    { 0x9014BEB2, "patrol_stop" },
    { 0x21761A0D, "patrol_target" },
    { 0x45D66DF1, "patrol_track_enemy_fire" },
    { 0xE1997FC0, "patrol_trig" },
    { 0xEE639AE6, "patrol_wait_max" },
    { 0x91435358, "patrol_wait_min" },
    { 0xE4155CB7, "patrol_walk_anim" },
    { 0xC8347F0D, "patrol_walk_twitch" },
    { 0xE68887DA, "patrol_walk_twitch_loop" },
    { 0xCCC6AB13, "patroler_kills_squad" },
    { 0x6EC0B50D, "patrolers" },
    { 0x81AAE93B, "patrolguys" },
    { 0xD377FEC6, "patrolheight" },
    { 0xDA57BB81, "patroling" },
    { 0xF2090578, "patroller" },
    { 0x420E6FC1, "patroller1" },
    { 0xC7221758, "patroller1_node" },
    { 0x6810EA2A, "patroller2" },
    { 0x60E85649, "patroller2_node" },
    { 0x03F8B03F, "patroller_a_logic" },
    { 0xE616AC0B, "patroller_anims" },
    { 0x339113FE, "patroller_delete_on_path_end" },
    { 0xB47ED33E, "patroller_deleted_on_path_end" },
    { 0x69B448EA, "patroller_detects_squad" },
    { 0xB36EBBEC, "patroller_goalradius" },
    { 0xDEA59B2B, "patroller_guys" },
    { 0x45195693, "patroller_logic" },
    { 0x9F79FE82, "patroller_look_around" },
    { 0x0256F667, "patroller_node" },
    { 0x3E0CD9F6, "patroller_sightdist" },
    { 0xAD2F4451, "patroller_stop_looking" },
    { 0x8835EC50, "patroller_wait" },
    { 0x0EB1FED3, "patrollers" },
    { 0x0E5C27A6, "patrollers_cleared" },
    { 0x70DD17D5, "patrollers_setup" },
    { 0x58A2AD17, "patrolling" },
    { 0x172AD20E, "patrolnodes" },
    { 0xA51B2EA3, "patrolpoint" },
    { 0x82537B06, "patrols" },
    { 0x7A65741F, "patrolstartindex" },
    { 0x8EB4636C, "patrolstarts" },
    { 0x0A3365EF, "patrolwalk_bounce" },
    { 0x78703EFD, "patrolwalk_swagger" },
    { 0x72319197, "patrolwalk_tired" },
    { 0xAD6A122C, "patrons" },
    { 0xEC7A2F3D, "pattern" },
    { 0x2E8AACFC, "patterns" },
    { 0x2FF61F27, "paul" },
    { 0xC895F85C, "paulsen_end_fire" },
    { 0x46871A86, "paulsen_end_standdeath" },
    { 0x7FDCD423, "paulsen_start_backdeath1" },
    { 0x0DD564E8, "paulsen_start_backdeath2" },
    { 0x64B56EDD, "pause" },
    { 0x078F8A8F, "pause3dcinematic" },
    { 0x39964277, "pause_all_traffic" },
    { 0x0B17D76A, "pause_ambient_drones" },
    { 0x19537B0F, "pause_anim" },
    { 0x35FFB0FA, "pause_animation" },
    { 0xDB26D7E1, "pause_before_text" },
    { 0xA305BDF0, "pause_dialog_queue" },
    { 0x52420E5C, "pause_fire" },
    { 0x2FCE1886, "pause_flag" },
    { 0xA6FD1561, "pause_jfk_anim" },
    { 0x8B91B134, "pause_node" },
    { 0x4BBCA735, "pause_path" },
    { 0xB1417BD8, "pause_rpg_guys" },
    { 0x1B231700, "pause_start_time" },
    { 0x18D82BEB, "pause_time" },
    { 0x06A3A186, "pause_time_after_line1" },
    { 0x2DAD6D9F, "pause_time_after_other_lines" },
    { 0x609B30F4, "pause_toggle" },
    { 0xEDAB3A5E, "pause_turret" },
    { 0x407B0F8A, "pause_zombie_spawning" },
    { 0x876E2E66, "pauseactionbuttonslottimer" },
    { 0xAA8CC145, "pauseanimation" },
    { 0xC099719E, "pauseartystrikes" },
    { 0x0E444F23, "paused" },
    { 0x371DCDD1, "paused_time" },
    { 0x8ACA8717, "pausedattime" },
    { 0x610AECBE, "pauseeffect" },
    { 0x8BAB3894, "pausefiring" },
    { 0x7FED5701, "pauselightning" },
    { 0x8C67A225, "pausemax" },
    { 0x7748FA8B, "pausemin" },
    { 0x1BDDF1BD, "pausenode" },
    { 0xA9ECB85E, "pauseplayabletimer" },
    { 0x6C4BB192, "pauserandomshake" },
    { 0x0BB9AEFE, "pauseratio" },
    { 0x946E701C, "pauses" },
    { 0xD92C58DE, "pausestatusslottimer" },
    { 0xEBEF42DA, "pausetime" },
    { 0x4931C3E7, "pausetime1" },
    { 0xD72A54AC, "pausetime2" },
    { 0xFD2CCF15, "pausetime3" },
    { 0x568BBA6C, "pausetimer" },
    { 0x2DBCAD2C, "pausetrackloop" },
    { 0x7FA658B0, "pauseuntiltime" },
    { 0x8503C388, "pausing" },
    { 0xF3123742, "pav" },
    { 0x6A10B580, "pavelow_tailor_rotor_fire_on_death" },
    { 0x1B7CA2BF, "pawn" },
    { 0xDF88CFE0, "pawn_point" },
    { 0x9CCAE17B, "pawn_supplies" },
    { 0x952D79C5, "pay" },
    { 0xC8C7F67C, "pay_out_winnings" },
    { 0x32C9EE7A, "pay_turret_cost" },
    { 0x1ECA9D83, "pay_turret_think" },
    { 0x75209919, "pay_turrets" },
    { 0xB2282D30, "payback" },
    { 0x4AF18314, "payer" },
    { 0xD2E60BA3, "paying" },
    { 0x75AF15ED, "payload" },
    { 0x94B257FD, "payload_clamp" },
    { 0x0AED623E, "payload_col" },
    { 0xB105F91A, "payload_fx" },
    { 0xB0C4BF0F, "payload_movement" },
    { 0x5AC11A10, "payload_not_moving" },
    { 0x765F4131, "payload_speed" },
    { 0x52707798, "payload_think" },
    { 0x0411D04A, "payload_trig_update" },
    { 0xC31CBE4B, "payload_zombiemode" },
    { 0xBAA465A7, "payload_zombiemode_blockers" },
    { 0x81DE323D, "payload_zombiemode_powerups" },
    { 0x62973223, "payload_zombiemode_radio" },
    { 0xE016F4F8, "payload_zombiemode_score" },
    { 0xFBE46246, "payload_zombiemode_spawner" },
    { 0x682BF642, "payload_zombiemode_utility" },
    { 0xABA621F9, "payload_zombiemode_weapons" },
    { 0xA9EEEA35, "payloadfxthink" },
    { 0xFA2AE88F, "payloadtrig" },
    { 0x21B0BDFA, "payoutpercentages" },
    { 0x3EFEB748, "payoutwagerwinnings" },
    { 0x5CF3BF07, "pb" },
    { 0x06E25367, "pbr" },
    { 0x6EF8D1C2, "pbr_attach_props" },
    { 0xB2E92B3C, "pbr_board_left_side" },
    { 0x5903D549, "pbr_board_right_side" },
    { 0x664847EE, "pbr_debris_start" },
    { 0x64372FCF, "pbr_grenade_launcher" },
    { 0x300B3F12, "pbr_guys" },
    { 0x287C01F9, "pbr_here_dialogue" },
    { 0x88256BFA, "pbr_hit_fx_1" },
    { 0x6222F191, "pbr_hit_fx_2" },
    { 0x3C207728, "pbr_hit_fx_3" },
    { 0x6A5F06B2, "pbr_hits_boat_2" },
    { 0x2A3990E2, "pbr_magic_bullet_shield" },
    { 0x4F3ACDF9, "pbr_prep_model" },
    { 0x29615E85, "pbr_prep_model_special" },
    { 0xA4DEE454, "pbr_props" },
    { 0x42D4D1DE, "pbrs" },
    { 0x1A0C13B0, "pbrs_setup" },
    { 0x22D374F1, "pbt" },
    { 0x7D4C00E5, "pbt_cp_female_body_01_prologue" },
    { 0x68999144, "pbt_cp_male_body_01_prologue" },
    { 0x78E1D724, "pbto" },
    { 0xAEA62C5C, "pbuzz" },
    { 0x64C710E4, "pby" },
    { 0xE19448CF, "pby1_igd_043a_laug" },
    { 0x27DE3957, "pby_a_stop_1" },
    { 0xDBD94485, "pby_a_stop_3" },
    { 0x43939AC7, "pby_b_explosion" },
    { 0x80C07F4E, "pby_b_first_shots" },
    { 0x00399B21, "pby_b_hit_water" },
    { 0x2BA1EF4E, "pby_b_pass_2" },
    { 0x87DF9465, "pby_b_pass_2_b" },
    { 0xB6ED7194, "pby_blackcat" },
    { 0xD4D17733, "pby_bullet_hole_left_gun" },
    { 0xBB31F3E8, "pby_bullet_hole_manager" },
    { 0xF9A367B8, "pby_bullet_hole_right_gun" },
    { 0x87C436C5, "pby_bullet_hole_tail" },
    { 0xB0402614, "pby_callback_saverestored" },
    { 0x2CE6FA58, "pby_compass_red_background" },
    { 0xAA9BA90C, "pby_crew_idles" },
    { 0x2180F075, "pby_crew_init" },
    { 0xC4E5B3FD, "pby_custom_introscreen" },
    { 0xBDD491AC, "pby_damage" },
    { 0x9311C965, "pby_damage_blister_glass_left" },
    { 0x62E61908, "pby_damage_blister_glass_right" },
    { 0x4E2B063D, "pby_damage_counter" },
    { 0x018A8DBB, "pby_damage_fx_left_wing" },
    { 0xF594EFD5, "pby_damage_fx_manager" },
    { 0xE8C73CB0, "pby_damage_fx_right_wing" },
    { 0x5BABB2EB, "pby_damage_nose_glass" },
    { 0x2FB0F8FF, "pby_damage_thread" },
    { 0x85E37BCC, "pby_explosion" },
    { 0xAF67FA6A, "pby_fly" },
    { 0x280E5FAB, "pby_fly_amb" },
    { 0x8210797E, "pby_fly_anim" },
    { 0x511E5FFF, "pby_fly_fx" },
    { 0x563555F4, "pby_fly_merchant_destruction" },
    { 0x9641E5DC, "pby_fly_ms_guys" },
    { 0xBCD33776, "pby_fly_zeros" },
    { 0x40DBB322, "pby_forward" },
    { 0x18239EC3, "pby_gun_left_damage" },
    { 0xCDC589B8, "pby_gun_right_damage" },
    { 0x1E044C78, "pby_land" },
    { 0x04C1DA8B, "pby_landed" },
    { 0xED29D335, "pby_ltgun_damage" },
    { 0xCF079396, "pby_ltwing_damage" },
    { 0x8EA388E3, "pby_node" },
    { 0x6C0EDA3E, "pby_nose_damage" },
    { 0x1D17AC97, "pby_ok_to_spawn" },
    { 0x25453CC8, "pby_out_of_ammo" },
    { 0xEBDB7356, "pby_path" },
    { 0x18371D58, "pby_plane_init" },
    { 0x5275D9A4, "pby_player_crash" },
    { 0x1CFA28EC, "pby_player_take_off" },
    { 0x7469C567, "pby_pontoons_up" },
    { 0x65D607B5, "pby_prop_fx" },
    { 0x5321BE01, "pby_regenerating_health" },
    { 0x1213F037, "pby_rtgun_damage" },
    { 0x4402FF68, "pby_rtwing_damage" },
    { 0x44D1C7E4, "pby_running_lights" },
    { 0x107F59AD, "pby_spin_prop" },
    { 0x05479BFB, "pby_tail_damage" },
    { 0xA957BBD5, "pby_takeoff" },
    { 0xDC265493, "pby_veh_fire_guns" },
    { 0xDE79BB71, "pby_veh_idle" },
    { 0x88829172, "pby_ventral_open" },
    { 0x169E008D, "pby_wait_for_free_spawn" },
    { 0x58F1A405, "pby_window_cloud" },
    { 0x75DACC64, "pby_window_fx" },
    { 0x0323D892, "pby_wing_left_damage" },
    { 0x263BC413, "pby_wing_right_damage" },
    { 0x36F1449E, "pc" },
    { 0xC30809B3, "pc_binds" },
    { 0xBED90931, "pc_buttoncheck_for_chair" },
    { 0x45AD35A5, "pclass" },
    { 0x2D3F8A99, "pclip" },
    { 0x66E19426, "pcms" },
    { 0xED5E4AB8, "pcnt" },
    { 0x4D076F04, "pcount" },
    { 0x39745DE7, "pcserver" },
    { 0xC9232AA6, "pcserverupdateplaylist" },
    { 0xD44FE20E, "pct" },
    { 0x1E503342, "pct_angle" },
    { 0x1DD6BD1D, "pct_chance" },
    { 0xCA8E270A, "pct_damage" },
    { 0xF8740CAD, "pct_dist" },
    { 0x70416937, "pct_from_center" },
    { 0xFE081C98, "pct_per_frame" },
    { 0x95C5EF8B, "pct_sacrifices_received" },
    { 0x01C477F3, "pd0" },
    { 0xB5BF8321, "pd2" },
    { 0x6D032BF5, "pdf" },
    { 0xB8F7D0DD, "pdf_01_split_up_loop" },
    { 0xA40A177A, "pdf_02_split_up_loop" },
    { 0xC43D233F, "pdf_03_split_up_loop" },
    { 0x83210552, "pdf_add_to_threatbiasgroup" },
    { 0x07A19369, "pdf_chase_after_cartel" },
    { 0x01D99A12, "pdf_death_count_timeout" },
    { 0x7520CB6E, "pdf_door_reaction" },
    { 0x8F67AA7B, "pdf_hangar_assaulters" },
    { 0xF7B5DED6, "pdf_hangar_fallback" },
    { 0x53C13F47, "pdf_killed_with_turret" },
    { 0xFE7FCFC4, "pdfs" },
    { 0x32251794, "pdir" },
    { 0xBA53A5D5, "peace" },
    { 0x8C86ED1E, "peaceful" },
    { 0xD60D1DC3, "peacefully" },
    { 0x5A6AB7F0, "peak" },
    { 0xE4A1DA05, "pebble" },
    { 0xACEF69BB, "pedal" },
    { 0x34515CEC, "peek" },
    { 0x4162E3B6, "peek_over_wall_while_player_climbs_ladder" },
    { 0x49EA6FCB, "peekanim" },
    { 0xE9CB261C, "peeking" },
    { 0x7654D618, "peekout" },
    { 0xFE70C30E, "peekout_offset" },
    { 0x72AA04F3, "peekouts" },
    { 0x0E4EE283, "peel" },
    { 0x7F1577DC, "peel_fx" },
    { 0xFDFAE131, "peel_off_angle" },
    { 0x26CCDBD6, "peel_out_sound" },
    { 0x34D7CF78, "peeled" },
    { 0xA74DB14B, "peelfxnamearray" },
    { 0x523D8BDD, "peeling" },
    { 0x32B709F3, "peelingout" },
    { 0xB91C8A21, "peeloff_node" },
    { 0x68485812, "peeloff_notify" },
    { 0xF7F0D6E3, "peeloff_rail_started" },
    { 0x4C9E8BF1, "peelout" },
    { 0x82291CB6, "peeps" },
    { 0xB96BB54B, "pegasus" },
    { 0x4161EF0B, "pegasus_count" },
    { 0x52CD551F, "pegasus_influencer" },
    { 0xF0070274, "pegasus_influencer_radius" },
    { 0xF178B4F4, "pegasus_influencer_score" },
    { 0xABAA80E8, "pegasus_influencer_score_curve" },
    { 0xEE1B1F1E, "pegasus_missile_turret_index" },
    { 0x3A2EE1CD, "peice" },
    { 0xD38C474C, "peices" },
    { 0x197311D9, "peir" },
    { 0x86A21955, "pel1" },
    { 0x0F2215E0, "pel1_amb" },
    { 0x2A592137, "pel1_anim" },
    { 0x21A18017, "pel1_art" },
    { 0x2877D13C, "pel1_atsea" },
    { 0xD84A42CF, "pel1_bunker" },
    { 0xD7F59895, "pel1_cam" },
    { 0xDA8FE795, "pel1_concrete_bldg" },
    { 0x76E32F92, "pel1_fx" },
    { 0x471D4012, "pel1_int_001b_roeb" },
    { 0x2FCF6FF5, "pel1_int_003a_sull" },
    { 0x6934E11A, "pel1_int_004a_roeb" },
    { 0x8B7E0CA0, "pel1_int_006a_roeb" },
    { 0xD15525F3, "pel1_int_009a_roeb_a" },
    { 0xB000217C, "pel1_int_011a_roeb_a" },
    { 0xE3515AE0, "pel1_int_012a_psou" },
    { 0xD1204D2E, "pel1_int_015a_lvtd" },
    { 0xE14DF366, "pel1_int_017a_polo" },
    { 0xFDADB304, "pel1_int_019a_sull" },
    { 0xC5E1B3B1, "pel1_int_021a_sull" },
    { 0x6E4378B3, "pel1_int_100a_roeb" },
    { 0x1058DFDE, "pel1_int_101a_polo" },
    { 0x5C221BBD, "pel1_metal_cone" },
    { 0xEF6766CF, "pel1_outdoors" },
    { 0x375A11CE, "pel1_status" },
    { 0x64195F63, "pel1_underground" },
    { 0xE7B03533, "pel1_wd_bunker" },
    { 0xD3573DE7, "pel1a_amb" },
    { 0x201DB35A, "pel1a_anim" },
    { 0xE056EEB4, "pel1a_art" },
    { 0xB2B37C03, "pel1a_fx" },
    { 0x016F84E3, "pel1a_status" },
    { 0xB93B049D, "pel1b" },
    { 0x28383148, "pel1b_amb" },
    { 0x06F8EDCF, "pel1b_anim" },
    { 0x2A6004AF, "pel1b_art" },
    { 0x0CCDF9E7, "pel1b_cave" },
    { 0x9DF11486, "pel1b_custom_introscreen" },
    { 0xEE5711FA, "pel1b_event2" },
    { 0xA8F77B95, "pel1b_event2_util" },
    { 0x423DE2EA, "pel1b_fx" },
    { 0x4E05B9E7, "pel1b_outdoors" },
    { 0xB410C805, "pel1b_outro" },
    { 0xACA493BE, "pel2" },
    { 0xFB7E8841, "pel2_airfield" },
    { 0x52FAFCBF, "pel2_amb" },
    { 0x98504622, "pel2_anim" },
    { 0x2B3C4B9C, "pel2_art" },
    { 0xDA8B2323, "pel2_callbacks" },
    { 0xE04D1A95, "pel2_counted" },
    { 0x2CFB8B1F, "pel2_firelight" },
    { 0xAC1EC45E, "pel2_forest" },
    { 0xAA0AE8C1, "pel2_friendly_fire_shield" },
    { 0xFFF2BA2B, "pel2_fx" },
    { 0xB29F7E03, "pel2_going_towards_ladder" },
    { 0x06429AD1, "pel2_igd_083a_roeb" },
    { 0x56850F54, "pel2_igd_083b_roeb" },
    { 0x3F867643, "pel2_merge_sunsingledvar" },
    { 0x7E57E32F, "pel2_objective_index" },
    { 0xD4752B76, "pel2_old_target_ent" },
    { 0x2BEA337F, "pel2_on_stairs" },
    { 0xF978F6AE, "pel2_real_health" },
    { 0x2752D620, "pel2_rhythm_stop" },
    { 0x5F801FB0, "pel2_staircase_wait" },
    { 0x9F600D5E, "pel2_startled" },
    { 0x1B40C331, "pel2_util" },
    { 0xB37D5369, "peleliu" },
    { 0x9B1BEAB6, "pelvis" },
    { 0x16B12946, "pen" },
    { 0x35DD4EFF, "pen_brush" },
    { 0xF75B2A0C, "penactive" },
    { 0xE6A2A6E5, "penalize" },
    { 0x1F521DFB, "penalized" },
    { 0x14722EE9, "penalized_time" },
    { 0xDEFC5258, "penalty" },
    { 0xE9C79962, "penalty_points" },
    { 0xB5FF1030, "penalty_speed" },
    { 0xEDB717DC, "penalty_time" },
    { 0x3D5F2E06, "penbuytrigger" },
    { 0xF58571B2, "pencil" },
    { 0xFF47477D, "pendamage" },
    { 0x50551F5F, "pendamagetrig" },
    { 0xE325C7D9, "pendant" },
    { 0xC535A6EA, "pending" },
    { 0xF0F3CC92, "pending_notifies" },
    { 0x42CAFB41, "pendingnotifies" },
    { 0xF64CBE4E, "pendown" },
    { 0x33B6BE4F, "pendulum" },
    { 0x5AB41569, "pendulum_killed" },
    { 0x56636E4B, "penetrate" },
    { 0xA0A2A255, "penetrated" },
    { 0x3F21D0AE, "penetrating" },
    { 0x8E33AE28, "penetration" },
    { 0xD58A3EC3, "penetrations" },
    { 0xF81B3DF9, "pens" },
    { 0xB627A206, "pent" },
    { 0xFC41FB89, "pentagon" },
    { 0x5B1C2214, "pentagon_amb" },
    { 0x04CF246B, "pentagon_anim" },
    { 0xF3CF6BFB, "pentagon_art" },
    { 0x9CDB860E, "pentagon_bonfire_init" },
    { 0x009F2748, "pentagon_brush_lights" },
    { 0x5BBF7889, "pentagon_brush_lights_init" },
    { 0x8FFE8875, "pentagon_client_flags" },
    { 0xB262C043, "pentagon_code" },
    { 0x50A9E23F, "pentagon_delay_update" },
    { 0x8C42697B, "pentagon_exit_level" },
    { 0x830CF2F3, "pentagon_find_exit_point" },
    { 0xECEC6E81, "pentagon_fix_electric_trap" },
    { 0x1203587A, "pentagon_fix_electric_trap_init" },
    { 0x6F8B8FAE, "pentagon_fx" },
    { 0x8AEC81CE, "pentagon_have_battery_hud" },
    { 0x4D49B729, "pentagon_hide_piece_triggers" },
    { 0x515C870B, "pentagon_ignore_spawner" },
    { 0x6AC8C0BF, "pentagon_office_light_model_swap" },
    { 0x40533B7C, "pentagon_office_light_model_swap_init" },
    { 0xF2392235, "pentagon_packapunch_init" },
    { 0x72766EC7, "pentagon_precache" },
    { 0x927F3B8F, "pentagon_reels" },
    { 0x97DC9EC4, "pentagon_remove_battery_hud" },
    { 0xA688E3A9, "pentagon_remove_hud_on_death" },
    { 0x9077A36B, "pentagon_screen_switch" },
    { 0xFDC1E0F0, "pentagon_show_piece_triggers" },
    { 0x835932A2, "pentagon_tlo_listener" },
    { 0x315ACDB4, "pentagon_trap_cover_remove" },
    { 0xD68B0373, "pentagon_tv_init" },
    { 0x093E9849, "pentagon_tvs" },
    { 0x5D752B55, "pentagon_unlock_doa" },
    { 0x46EBF39E, "pentagon_validate_enemy_path_length" },
    { 0x69A8E923, "pentagon_zone_init" },
    { 0xFFE7BACC, "pentagon_zpo_listener" },
    { 0x2057720F, "pentann_is_speaking" },
    { 0x394ABD66, "pentest" },
    { 0x46E4B0BA, "penthink" },
    { 0xA4040B0C, "people" },
    { 0x503D2C8F, "peoples" },
    { 0xDCDB11FA, "peoplespeaking" },
    { 0x21A58CDD, "pepper" },
    { 0x4E936C5A, "per" },
    { 0x43C217B1, "per_minute" },
    { 0x45E25986, "per_player" },
    { 0xF0FFC3A5, "per_zpu_init" },
    { 0x554AEE7E, "perameter" },
    { 0xA5232FE5, "perc" },
    { 0xBD650658, "perceived" },
    { 0x4E4F22CC, "percent" },
    { 0x49317B64, "percent_angle" },
    { 0x91E54BC7, "percent_chance_ragdoll_drone_spawned" },
    { 0x0BE1937A, "percent_distance" },
    { 0xD3E4D2D9, "percent_dmg" },
    { 0x881DB737, "percent_flash" },
    { 0xB0EC8DF8, "percent_full" },
    { 0xDBA24D54, "percent_life_at_checkpoint" },
    { 0x2F82580A, "percent_range" },
    { 0x017AAEF5, "percentage" },
    { 0x2E3EDFF6, "percentage_along_rope" },
    { 0xE45F9A83, "percentage_health_lost" },
    { 0x4EE9C7A8, "percentageint" },
    { 0x65BCA966, "percentagemark" },
    { 0xB6A308C4, "percentages" },
    { 0xD6304260, "percentchance" },
    { 0x5B0DD9FB, "percentincrement" },
    { 0x2660CA88, "percentmod" },
    { 0x9D52903C, "percentnotcharred" },
    { 0x0AE452BE, "percentofplayersonroof" },
    { 0x629D6625, "percenttimemoving" },
    { 0xC453EF87, "percenttodestroy" },
    { 0x9F75209E, "percievedmovementvector" },
    { 0x518FB8E8, "perfect" },
    { 0x92448AA2, "perfect_aim" },
    { 0x97BC806C, "perfect_aim_dist_sq" },
    { 0x22BE44A1, "perfect_aim_fortimeoruntilnotify" },
    { 0xDC4437B8, "perfect_aim_off" },
    { 0xFE263B72, "perfect_aim_on" },
    { 0xBFB9DE35, "perfect_enemy_yaw" },
    { 0x5ED2F6D3, "perfectaim" },
    { 0x8AD63D05, "perfectattackstartvector" },
    { 0x8D660AB4, "perfectinfothread" },
    { 0x969C770D, "perfectly" },
    { 0xBEE3F991, "perfefctly" },
    { 0x166392A4, "perferred_crash_location" },
    { 0x3D4DB0DA, "perforance" },
    { 0xCA9DBA98, "perform" },
    { 0x69F9CF6A, "perform_evasion_reaction_wait" },
    { 0x03C618EC, "perform_physics_trace" },
    { 0xF6DAE745, "perform_recoil" },
    { 0x926D969D, "perform_recoil_missile_turret" },
    { 0x2C95C5E8, "perform_save" },
    { 0xB21DB50A, "perform_visor_wipe" },
    { 0x5E95D165, "performace" },
    { 0xA4213399, "performance" },
    { 0xCF1ED634, "performce" },
    { 0x0668E7FF, "performclientsideeffect" },
    { 0xC4B6B2AB, "performed" },
    { 0xB9677033, "performhudeffects" },
    { 0x007A0980, "performing" },
    { 0x52090C5F, "performing_activation" },
    { 0xDBCD0C5D, "performleavehelicopterfromdamage" },
    { 0x32959A94, "performplayerkillstreakend" },
    { 0xA169BA73, "performs" },
    { 0xA1616D94, "performvehicleprespawn" },
    { 0x0A2C6598, "perhaps" },
    { 0x95871B35, "perime" },
    { 0xE628D7F6, "perimeter" },
    { 0xC5DDC81D, "perimeter_breached" },
    { 0xBFC827C7, "perimeter_guard_logic" },
    { 0xE5902CCB, "perimeter_patroller_logic" },
    { 0x1C18CD0E, "perimeter_patrols" },
    { 0x870F3AC7, "perimeter_trig" },
    { 0x3C9F99DA, "period" },
    { 0x4ECAB8E7, "period1" },
    { 0x13FBA2C6, "periodic" },
    { 0x490E816D, "periodic_charger" },
    { 0xD4A07A46, "periodic_damage_from_russians" },
    { 0x746489CB, "periodic_firing_back_from_target" },
    { 0x30B92CD1, "periodic_firing_behavior" },
    { 0x35034883, "periodic_firing_mg_at_target" },
    { 0xA2E68875, "periodic_lightning_strikes" },
    { 0xAD1A32AB, "periodic_trigger" },
    { 0x6298EFE0, "periodically" },
    { 0x7B4AAA5F, "periodicallyglanceattheplayer" },
    { 0x822729D5, "periods" },
    { 0xA7A7ACA6, "periscope_org" },
    { 0x750F5C9D, "perk" },
    { 0xDEA3446E, "perk1" },
    { 0xB8A0CA05, "perk2" },
    { 0x929E4F9C, "perk3" },
    { 0x6D039A5D, "perk_2_tally" },
    { 0x5F12B357, "perk_abort_drinking" },
    { 0x1A6FC730, "perk_acquired" },
    { 0xD5252E73, "perk_additional_primary_weapon" },
    { 0xD741EBC8, "perk_altmeleedamage" },
    { 0x98DB7B96, "perk_anims" },
    { 0x3A75AB4C, "perk_area_origin" },
    { 0x4E197025, "perk_armory_launcher" },
    { 0x5DEE9F57, "perk_array" },
    { 0x3E829586, "perk_arrival_vehicle" },
    { 0x6C558342, "perk_arrive_fx" },
    { 0x2C6930FC, "perk_attack_anim" },
    { 0xF670BC43, "perk_award" },
    { 0x5F2F19DF, "perk_blind_eye" },
    { 0xB15D49C0, "perk_bottle" },
    { 0xA7629CAD, "perk_bottle_motion" },
    { 0x83389A0B, "perk_bottle_weapon" },
    { 0xCB1F3059, "perk_bottle_weapon_array" },
    { 0xA4508F81, "perk_bought" },
    { 0x7B162F9E, "perk_bought_func" },
    { 0x4E67271C, "perk_brute_force" },
    { 0xCD5B5584, "perk_brute_force_prop" },
    { 0x7156262F, "perk_chugabud_activated" },
    { 0xB61B2829, "perk_clientfield_additional_primary_weapon" },
    { 0x7C512707, "perk_clientfield_dead_shot" },
    { 0xC12D8FEC, "perk_clientfield_dive_to_nuke" },
    { 0xB0F24957, "perk_clientfield_double_tap" },
    { 0x6FF8087A, "perk_clientfield_doubletap2" },
    { 0xA34E95D5, "perk_clientfield_electric_cherry" },
    { 0xC3EE3656, "perk_clientfield_juggernaut" },
    { 0xB8609140, "perk_clientfield_marathon" },
    { 0x93D08192, "perk_clientfield_phdflopper" },
    { 0x5BE32B99, "perk_clientfield_quick_revive" },
    { 0xDA222868, "perk_clientfield_sleight_of_hand" },
    { 0x09C8523F, "perk_clientfield_staminup" },
    { 0x5EE964FB, "perk_clientfield_tombstone" },
    { 0x38E6D4AD, "perk_clientfield_vultureaid" },
    { 0xF9EF6907, "perk_clientfield_whoswho" },
    { 0x2E6449E1, "perk_clientfield_widows_wine" },
    { 0xCA8FC50D, "perk_count" },
    { 0x14133456, "perk_damage_override" },
    { 0xD4879D89, "perk_dead_shot" },
    { 0x1A384E29, "perk_default_slots" },
    { 0x2A9CDFED, "perk_delay" },
    { 0x020F8A09, "perk_dev_gui" },
    { 0xC4A494C4, "perk_dmg" },
    { 0xFFEF4560, "perk_done" },
    { 0x73D1B7D8, "perk_doubletap2" },
    { 0xB5EBB546, "perk_drink_tracking" },
    { 0x2AF2730F, "perk_electric_cherry" },
    { 0xA78D5BFA, "perk_elevators_anims" },
    { 0x8CA44B87, "perk_elevators_door_close_state" },
    { 0x5E98569E, "perk_elevators_door_movement_state" },
    { 0xE0D65D09, "perk_elevators_door_open_state" },
    { 0x2125F4A0, "perk_end_power_thread" },
    { 0x31581AA8, "perk_expire_watcher" },
    { 0x50CD2641, "perk_fast_hands" },
    { 0x0DD4DEF9, "perk_flags" },
    { 0xBB54E4D1, "perk_flash_audio" },
    { 0xBB5E9047, "perk_follow_path" },
    { 0xD2FBAAEA, "perk_fx" },
    { 0x5448246B, "perk_fx_func" },
    { 0xCB7EC458, "perk_give_bottle_begin" },
    { 0x938ED54C, "perk_give_bottle_end" },
    { 0xD5C5DC2E, "perk_guy1_anim" },
    { 0x012144A3, "perk_guy2_anim" },
    { 0xB4D7CA0B, "perk_hack" },
    { 0x194E8DFE, "perk_hack_qualifier" },
    { 0x3EE78846, "perk_hacker" },
    { 0x61510598, "perk_history" },
    { 0x3CC6F2B6, "perk_hostmigration" },
    { 0xDF099D9B, "perk_hud" },
    { 0xE107C952, "perk_hud_create" },
    { 0x36084434, "perk_hud_destroy" },
    { 0x3FC45DF8, "perk_hud_flash" },
    { 0x99589D97, "perk_hud_grey" },
    { 0x6885EAED, "perk_hud_start_flash" },
    { 0x06869A8D, "perk_hud_stop_flash" },
    { 0xE91AF67A, "perk_hum" },
    { 0x62788269, "perk_icon_size" },
    { 0x49A3D108, "perk_incoming_sound" },
    { 0x441885C4, "perk_index" },
    { 0x188C1EF6, "perk_init" },
    { 0xA745ACDF, "perk_init_code_callbacks" },
    { 0xE7CD42C5, "perk_intruder" },
    { 0x6434396F, "perk_intruder_setup" },
    { 0x2CB2C5DA, "perk_is_bought" },
    { 0x537928B0, "perk_jingle_playing" },
    { 0x02FF1584, "perk_juggernog" },
    { 0x274432E8, "perk_list" },
    { 0x5AF0C804, "perk_lock_breaker" },
    { 0x3D708932, "perk_lost" },
    { 0xA72D0823, "perk_lost_func" },
    { 0x7429240F, "perk_machine" },
    { 0x36DB1E4F, "perk_machine_arrival_update" },
    { 0x270791D0, "perk_machine_flag" },
    { 0x119AA847, "perk_machine_knockdown_zombie" },
    { 0x815A5E9B, "perk_machine_lock" },
    { 0x29D8E0AB, "perk_machine_power_override_thread" },
    { 0x1AC8C6F2, "perk_machine_removal" },
    { 0x2985AC7D, "perk_machine_set_kvps" },
    { 0xEE0803E7, "perk_machine_show_selected" },
    { 0x20943EC7, "perk_machine_sound" },
    { 0x77C41094, "perk_machine_spawn_init" },
    { 0x942C1336, "perk_machine_think" },
    { 0x28FF94BE, "perk_machine_thread" },
    { 0xF28C7ED6, "perk_machines" },
    { 0x423BD7A2, "perk_machines_always_on" },
    { 0x3F01A0A4, "perk_machines_bought" },
    { 0xD7A504C5, "perk_machines_hide" },
    { 0x75009E68, "perk_machines_random" },
    { 0x3E7A2311, "perk_meteor_fx" },
    { 0x307DC009, "perk_name" },
    { 0xF8653126, "perk_pause" },
    { 0x5A284AC4, "perk_pause_all_perks" },
    { 0x00FE8958, "perk_phdflopper" },
    { 0x8C482FBD, "perk_points" },
    { 0x1D76E92D, "perk_power_off" },
    { 0x236F24C1, "perk_power_on" },
    { 0x75976D4D, "perk_purchase_limit" },
    { 0xE90A2FBF, "perk_purchase_tracking" },
    { 0xE4F0DC47, "perk_purchased" },
    { 0x08C480BB, "perk_quick_revive" },
    { 0x42FD4742, "perk_radius" },
    { 0xD0CB610D, "perk_random_arrive" },
    { 0xCF0E2298, "perk_random_devgui_callback" },
    { 0x1AAA6FFE, "perk_random_idle" },
    { 0x3CE1C79C, "perk_random_idle_effects_override" },
    { 0x8F853C44, "perk_random_initial" },
    { 0xC2D537E0, "perk_random_leaving" },
    { 0x6959E916, "perk_random_loop_anim" },
    { 0x25E4ADF7, "perk_random_machine" },
    { 0xD616C9BF, "perk_random_machine_count" },
    { 0xE63193E8, "perk_random_machine_fx" },
    { 0xB8B5A3A4, "perk_random_machine_init" },
    { 0x441FFCBE, "perk_random_machine_locations" },
    { 0xE2849EB9, "perk_random_machine_play_fx" },
    { 0xEA5F319D, "perk_random_machine_rock_emissive" },
    { 0x0BC5E6EE, "perk_random_machine_state_func" },
    { 0x1EA32D23, "perk_random_machine_stub_update_prompt" },
    { 0xB2A08797, "perk_random_machine_trigger_update_prompt" },
    { 0x6515E42E, "perk_random_machines" },
    { 0x5D53A80F, "perk_random_unitrigger_think" },
    { 0xE3EEB875, "perk_random_vend_sfx" },
    { 0xCA22A513, "perk_random_vending" },
    { 0xDC015239, "perk_random_vo_func_usemachine" },
    { 0x62B1DD5F, "perk_range" },
    { 0xDBAADA77, "perk_reference" },
    { 0x3984276E, "perk_refs" },
    { 0xB51B785F, "perk_script_string" },
    { 0x78F42790, "perk_set_max_health_if_jugg" },
    { 0xDD68DFAA, "perk_sleight_of_hand" },
    { 0xFA2082A7, "perk_slots" },
    { 0x2D648C25, "perk_sp_bruteforce" },
    { 0xDDDE060D, "perk_sp_fastreload" },
    { 0x4796E181, "perk_sp_intruder" },
    { 0x6EFEA612, "perk_sp_lockpick" },
    { 0x6A370345, "perk_sp_steadyaim" },
    { 0x0AEC1DD8, "perk_specialties" },
    { 0x1CFDDC71, "perk_staminup" },
    { 0x31EE02C4, "perk_start_up" },
    { 0x052A0B98, "perk_state_deactivated" },
    { 0xE301ACB7, "perk_state_not_owned" },
    { 0xD766ACE5, "perk_state_owned" },
    { 0xB8C85C0C, "perk_state_paused" },
    { 0x5496DB4D, "perk_str" },
    { 0xE19B555B, "perk_string" },
    { 0x5AFC182B, "perk_struct" },
    { 0x2CF2140A, "perk_structs" },
    { 0x3D086B48, "perk_think" },
    { 0x87472B05, "perk_tombstone" },
    { 0xAEA26368, "perk_type" },
    { 0x1C897671, "perk_unpause" },
    { 0x400B3FE7, "perk_unpause_all_perks" },
    { 0x69FD1E23, "perk_update" },
    { 0x1477FCEF, "perk_used" },
    { 0xF5330A65, "perk_vo" },
    { 0xB4E423F7, "perk_vox" },
    { 0x5F1E57E3, "perk_vulture" },
    { 0xD5471F02, "perk_vulture_custom_scripts" },
    { 0xAA285694, "perk_vulture_drank" },
    { 0xEC672434, "perk_vulture_models" },
    { 0x90701B17, "perk_vultureaid" },
    { 0x1D8976E8, "perk_watcher" },
    { 0xC1B505D9, "perk_whoswho" },
    { 0x8AE14C6B, "perk_widows_wine" },
    { 0x6B84DA80, "perk_wire_fx" },
    { 0xF5F47A62, "perk_wire_fx_client" },
    { 0xACADC10D, "perk_x_start" },
    { 0x707723D0, "perk_y_start" },
    { 0xDD1C11B5, "perkdata" },
    { 0x416C3D83, "perkelevatordoor" },
    { 0x349CFC3B, "perkelevatoruseanimtree" },
    { 0xC7F39120, "perkfactor" },
    { 0x9F31B29C, "perkfeedback" },
    { 0xC3FBF0C2, "perkgroup" },
    { 0x5848E78D, "perkhash" },
    { 0x154C7505, "perkhudelem" },
    { 0x8ECA9C9A, "perkicon" },
    { 0x9D19B295, "perkicons" },
    { 0x8F4D4019, "perkids" },
    { 0xA21FF7CF, "perkindex" },
    { 0x5A4B166E, "perkindexarraykeys" },
    { 0x6F1FB6AC, "perkkills" },
    { 0x8FD8905D, "perkmachinerattles" },
    { 0xE317E1E4, "perkname" },
    { 0x75B59717, "perknames" },
    { 0x9362EE93, "perkorigin" },
    { 0x04F63425, "perkpickuphints" },
    { 0x6E81CA9D, "perkpickupkeys" },
    { 0xFCDA2160, "perkref" },
    { 0x9007B121, "perkreferencetoindex" },
    { 0x133CE9DC, "perks" },
    { 0x9766ADE8, "perks_a_cola_jingle" },
    { 0x1026FCE6, "perks_a_cola_jingle_timer" },
    { 0x9DC0D2B9, "perks_active" },
    { 0xAAF69E78, "perks_all" },
    { 0x17E13F7F, "perks_before_vehicle" },
    { 0x4AE863FE, "perks_behind_door" },
    { 0xD721C112, "perks_can_respawn_player" },
    { 0xA15F2597, "perks_chance" },
    { 0x4CE1275D, "perks_changed" },
    { 0x5897F203, "perks_disabled" },
    { 0x40E73EB7, "perks_drank" },
    { 0xE1EC8CE1, "perks_from_the_sky" },
    { 0x69A76EDF, "perks_hidden" },
    { 0x1DB1E6BE, "perks_hud" },
    { 0xBABAEE44, "perks_in_space_list" },
    { 0xA375F562, "perks_in_space_purchased_list" },
    { 0x53BFA71D, "perks_init" },
    { 0xBBCFF942, "perks_register_clientfield" },
    { 0xB2872664, "perks_string" },
    { 0xB5609476, "perksacola" },
    { 0x24DF6D12, "perksacola_jingle" },
    { 0x5F58C846, "perksacola_probability" },
    { 0xB65CC8D5, "perksacola_stinger" },
    { 0x421F82EE, "perksacola_wait_time" },
    { 0xCF1BE84F, "perksenabled" },
    { 0x5B008A57, "perksindexarray" },
    { 0x207E77BB, "perkslotindex" },
    { 0x90D0EB31, "perkspawntime" },
    { 0x7CDF1A1B, "perkspecialties" },
    { 0xD61B52FE, "perkspecificbattlechatter" },
    { 0x45D47902, "perkstr" },
    { 0xDE59156D, "perksusageduration" },
    { 0x3CFD645A, "perm_list" },
    { 0x97CA07AD, "permanent" },
    { 0x6EB637AE, "permanent_fire_sale" },
    { 0xFB463FD0, "permanently" },
    { 0x6526927C, "permanentlyremoved" },
    { 0xF4C5FE10, "permission" },
    { 0x35DE08FB, "permissions" },
    { 0xED2FFDBB, "permitted" },
    { 0x188779D7, "permutation" },
    { 0xBABE3B8E, "permutations" },
    { 0x6AFE03BE, "perp" },
    { 0x3C3C4F13, "perpendicular" },
    { 0x33D9F34B, "perpendicular_normal" },
    { 0x3182E3D0, "perpendiculargoalpos" },
    { 0xFCB86188, "perpendicularpart" },
    { 0x996F57E3, "perpenticular" },
    { 0xB73B85A7, "perpindicular" },
    { 0x3E6D1B65, "perplayer" },
    { 0x44FB8955, "pers" },
    { 0x0D83E4CA, "pers_abilities_init_globals" },
    { 0xE146CF60, "pers_boarding_number_of_boards_required" },
    { 0xD81E1548, "pers_boarding_round_start" },
    { 0x66DCADFF, "pers_boards_updated" },
    { 0xBF349207, "pers_box_weapon_awarded" },
    { 0xEFB7C0B3, "pers_box_weapon_counter" },
    { 0x21500B7F, "pers_box_weapon_lose_round" },
    { 0xCFFF4E41, "pers_box_weapons" },
    { 0x2D4F1F79, "pers_carpenter_boards_active" },
    { 0x7B43D46F, "pers_carpenter_kill" },
    { 0xB8CCB8B1, "pers_carpenter_zombie_check_active" },
    { 0x1A219DBF, "pers_carpenter_zombie_kills" },
    { 0xA8F683D7, "pers_cash_back_failed_prones" },
    { 0x82949E7A, "pers_cash_back_money_reward" },
    { 0xDB62F146, "pers_cash_back_num_perks_required" },
    { 0xC434D051, "pers_cash_back_perk_buys_prone_required" },
    { 0x56DA3688, "pers_check_for_pers_headshot" },
    { 0xBD49BE0C, "pers_double_points_active" },
    { 0x537193E6, "pers_double_points_counter" },
    { 0x2CE89398, "pers_double_points_score" },
    { 0xAC759FC9, "pers_flopper_active" },
    { 0x64A7ACFD, "pers_flopper_counter" },
    { 0x6CFB9425, "pers_flopper_damage_counter" },
    { 0xFDB683BD, "pers_flopper_damage_network_optimized" },
    { 0xD2001C76, "pers_flopper_divetonuke_func" },
    { 0x3FA4B677, "pers_flopper_dtn" },
    { 0x7CD059D6, "pers_flopper_explode" },
    { 0x9D2F3A1D, "pers_flopper_lost" },
    { 0x20174B8F, "pers_flopper_min_fall_damage_activate" },
    { 0x7C0A20CE, "pers_flopper_min_fall_damage_deactivate" },
    { 0x95BE5FC5, "pers_flopper_network_optimized" },
    { 0xEAC49A00, "pers_get_player_accuracy" },
    { 0x9C80877A, "pers_increment_revive_stat" },
    { 0x19D853AE, "pers_insta_kill_melee_swipe" },
    { 0x004CF213, "pers_insta_kill_num_required" },
    { 0x2A6E5316, "pers_insta_kill_upgrade_active_time" },
    { 0xDADEDDE6, "pers_jugg_active" },
    { 0x34BE9153, "pers_jugg_hit_and_die_round_limit" },
    { 0xF6BE23F9, "pers_jugg_hit_and_die_total" },
    { 0x5A4F8BE0, "pers_jugg_round_lose_target" },
    { 0x64717F34, "pers_jugg_round_reached_max" },
    { 0xEB469FD1, "pers_jugg_upgrade_health_bonus" },
    { 0x8AA76743, "pers_magic_box_firesale" },
    { 0xBC64F9A1, "pers_magic_box_set_teddy_location" },
    { 0x85E94769, "pers_magic_box_teddy_bear" },
    { 0x2D6526B6, "pers_magic_box_weapon_count" },
    { 0x4DB55A5C, "pers_magix_box_teddy_bear" },
    { 0x35C06A37, "pers_melee_swipe" },
    { 0x7B63C6AF, "pers_melee_swipe_zombie_swiper" },
    { 0x2F3A2D06, "pers_mulit_kill_headshot_active" },
    { 0xA121F145, "pers_multikill_headshots_required" },
    { 0x9B1B9C4B, "pers_multikill_headshots_upgrade_reset_counter" },
    { 0x57DDE7C7, "pers_nube_ammo_cost" },
    { 0x6DDEAE49, "pers_nube_ammo_hint_string" },
    { 0xB3A19BD1, "pers_nube_counter" },
    { 0xEA5B9BD9, "pers_nube_lose_round" },
    { 0x3C5B1E58, "pers_nube_override_ammo_cost" },
    { 0x50235F20, "pers_nube_player_ranked_as_nube" },
    { 0xE8007B34, "pers_nube_should_we_give_raygun" },
    { 0x830C8552, "pers_nube_unlock_watcher" },
    { 0x8C231229, "pers_nube_weapon_ammo_check" },
    { 0x11390813, "pers_nube_weapon_upgrade_check" },
    { 0x50A5FA2A, "pers_num_flopper_damages" },
    { 0xCCA71F51, "pers_num_nube_kills" },
    { 0xF9BB9C1F, "pers_num_zombies_killed_in_game" },
    { 0x8D9746CC, "pers_numb_num_kills_unlock" },
    { 0xC2B8652D, "pers_perk_lose_counter" },
    { 0x5C51868D, "pers_perk_lose_lost" },
    { 0x5F32DF0C, "pers_perk_lose_start_round" },
    { 0x1D4251AD, "pers_perk_round_reached_max" },
    { 0x5D181FAF, "pers_pistol_points_accuracy" },
    { 0x1A14EE1C, "pers_pistol_points_counter" },
    { 0x5E5BB250, "pers_pistol_points_kill" },
    { 0xA4AFE255, "pers_pistol_points_num_kills_in_game" },
    { 0x6D159F37, "pers_player_zombie_kill" },
    { 0x8562A0F6, "pers_register_upgrade" },
    { 0xD3C7EE5C, "pers_revive_active" },
    { 0x7E0C4364, "pers_revivenoperk_number_of_chances_to_keep" },
    { 0xCF93F24F, "pers_revivenoperk_number_of_revives_required" },
    { 0xB33490F8, "pers_sniper_counter" },
    { 0x441AD7BA, "pers_sniper_kill_distance" },
    { 0x4355968F, "pers_sniper_kills" },
    { 0xD83E52C6, "pers_sniper_lost" },
    { 0x4DE1C840, "pers_sniper_misses" },
    { 0xCEC61A4D, "pers_sniper_player_fires" },
    { 0xF1BC926C, "pers_sniper_round" },
    { 0x98B6D77B, "pers_sniper_round_kills_counter" },
    { 0xC055872C, "pers_sniper_score_reward" },
    { 0x90DC1354, "pers_stats_end_of_round" },
    { 0xEF89461C, "pers_treasure_chest_choosespecialweapon" },
    { 0x7F93D5D8, "pers_treasure_chest_get_weapons_array" },
    { 0x4F25B87C, "pers_treasure_chest_get_weapons_array_buried" },
    { 0x680950F5, "pers_treasure_chest_get_weapons_array_func" },
    { 0x7D49226C, "pers_treasure_chest_get_weapons_array_transit" },
    { 0x3ED63B1C, "pers_upgrade" },
    { 0xA2FE812C, "pers_upgrade_boards" },
    { 0x8726ED89, "pers_upgrade_boards_active" },
    { 0x55D2EA99, "pers_upgrade_box_weapon" },
    { 0xF7FB14E2, "pers_upgrade_box_weapon_active" },
    { 0x61BE7933, "pers_upgrade_box_weapon_used" },
    { 0x57F7A081, "pers_upgrade_carpenter" },
    { 0x03737E5A, "pers_upgrade_carpenter_active" },
    { 0xBAC53324, "pers_upgrade_cash_back" },
    { 0xC29EB071, "pers_upgrade_cash_back_active" },
    { 0x7C0A5256, "pers_upgrade_do_nothing" },
    { 0x10626B86, "pers_upgrade_double_points" },
    { 0xB8B4FCDB, "pers_upgrade_double_points_active" },
    { 0x4EF410DA, "pers_upgrade_double_points_cost" },
    { 0xBB9A6B2C, "pers_upgrade_double_points_pickup_start" },
    { 0x9B3073FC, "pers_upgrade_double_points_set_score" },
    { 0x828EB3F1, "pers_upgrade_flopper" },
    { 0x5775894A, "pers_upgrade_flopper_active" },
    { 0xB4BF3A92, "pers_upgrade_flopper_damage_check" },
    { 0xBCE2B00C, "pers_upgrade_flopper_watcher" },
    { 0x8D6E7587, "pers_upgrade_force_test" },
    { 0x045DC571, "pers_upgrade_func" },
    { 0x29534A7E, "pers_upgrade_headshot_active" },
    { 0x76226B65, "pers_upgrade_index" },
    { 0x432F925D, "pers_upgrade_init" },
    { 0x6E4E78C7, "pers_upgrade_insta_kill" },
    { 0x744187F0, "pers_upgrade_insta_kill_active" },
    { 0xA312B387, "pers_upgrade_insta_kill_upgrade_check" },
    { 0x70E80676, "pers_upgrade_jugg" },
    { 0x7F74D80B, "pers_upgrade_jugg_active" },
    { 0x3699CFB6, "pers_upgrade_jugg_player_death_stat" },
    { 0x7698EECD, "pers_upgrade_multi_kill_headshots" },
    { 0xF4735DD3, "pers_upgrade_nube" },
    { 0xE69589A4, "pers_upgrade_nube_active" },
    { 0x52F5A971, "pers_upgrade_perk_lose" },
    { 0x30223DCA, "pers_upgrade_perk_lose_active" },
    { 0x1425FC15, "pers_upgrade_perk_lose_bought" },
    { 0xAC62ADF2, "pers_upgrade_perk_lose_restore" },
    { 0xB725835B, "pers_upgrade_perk_lose_save" },
    { 0x0CFCE124, "pers_upgrade_pistol_points" },
    { 0x27BE4A71, "pers_upgrade_pistol_points_active" },
    { 0xB0F6B767, "pers_upgrade_pistol_points_kill" },
    { 0xE4398B36, "pers_upgrade_pistol_points_set_score" },
    { 0x4D91D5D4, "pers_upgrade_revive" },
    { 0x26EDDBA1, "pers_upgrade_revive_active" },
    { 0x2EAFD286, "pers_upgrade_sniper" },
    { 0x729CF9DB, "pers_upgrade_sniper_active" },
    { 0x8D1310C0, "pers_upgrade_sniper_kill_check" },
    { 0x061EEBB3, "pers_upgrade_vo_spoken" },
    { 0xD830EE5F, "pers_upgrades" },
    { 0x00698F7E, "pers_upgrades_awarded" },
    { 0x2CD32F16, "pers_upgrades_keys" },
    { 0x4F17AF50, "pers_upgrades_monitor" },
    { 0x290A4934, "pers_zombie_death_location_check" },
    { 0x375DEF18, "perseasonwins" },
    { 0x15F301FE, "persecond" },
    { 0x121E2A30, "persecution" },
    { 0x967BE837, "persist" },
    { 0x3CAF7D7A, "persistant" },
    { 0xFE5E4926, "persistence" },
    { 0xC2C8160A, "persistence_shared" },
    { 0xBAE09A46, "persistent" },
    { 0x0CE147D1, "persistent_carpenter_ability_check" },
    { 0x00C49A50, "persistent_fires" },
    { 0xCE5E5A73, "persistent_fires_max" },
    { 0x82EF301E, "persistentdatainfo" },
    { 0x0334EA05, "persistentdebugline" },
    { 0x3B82032B, "persistently" },
    { 0x77570B16, "person" },
    { 0xD1DF1B2D, "personal" },
    { 0xDD6639D9, "personal_instakill" },
    { 0x2A160C2E, "personal_pdf_battle_dialog" },
    { 0x2229AE63, "personal_use_bar" },
    { 0xA1978CCA, "personal_wait_index" },
    { 0xE8E75631, "personalcoldbreath" },
    { 0x2FC7EBFB, "personalcoldbreathspawner" },
    { 0x00363F50, "personally" },
    { 0x129B22FA, "personalsightpos" },
    { 0xE23D5A8F, "personalsighttime" },
    { 0xC624967D, "personalusebar" },
    { 0xFECAF021, "personel" },
    { 0x3A5CE0E8, "personimmeleeing" },
    { 0xEA2D7CF4, "personmeleeingme" },
    { 0xEDCE4FC7, "personnel" },
    { 0xAD8D0589, "persons" },
    { 0xBC97C8E2, "persp_switch" },
    { 0x313ECE29, "perspective" },
    { 0x9428C193, "persrefstring" },
    { 0xB92CCADE, "pertaining" },
    { 0xFAA20CDD, "pertains" },
    { 0x787F019C, "perticular" },
    { 0x9353BF1C, "peshawar" },
    { 0x9A98612C, "pet" },
    { 0x04CD3A09, "peter" },
    { 0x1F4231B7, "peterl" },
    { 0x84F55F00, "peters" },
    { 0xDC69F000, "petraeus" },
    { 0xFE393869, "petrenko" },
    { 0xA1CEA7AA, "petrenko_vo_line" },
    { 0x2036DB01, "petrenko_wp" },
    { 0x0D0498E9, "petrov" },
    { 0xD5CE63B1, "petty" },
    { 0x87AF6626, "peye" },
    { 0xC4E9D563, "pf" },
    { 0x9D0EC586, "pfwd" },
    { 0xA73C2419, "pfx_fire_incendiary" },
    { 0xDA4558D5, "pfx_igc_off" },
    { 0xFC4E1DA9, "pfx_igc_on" },
    { 0x9EE75AFA, "pg" },
    { 0xB23C4A1F, "pg_loopanim_sound_exists" },
    { 0x16920075, "pg_sound_exists" },
    { 0x851D037A, "pg_soundalias" },
    { 0x5E6893C7, "pgetintdvar" },
    { 0x41B0DFD1, "pgw" },
    { 0xE0DAF6ED, "ph" },
    { 0x854BE406, "phalanc" },
    { 0x2F359655, "phalanx" },
    { 0xB0B09F63, "phalanx_cannon_target_update" },
    { 0x6CC8CC63, "phalanx_cannons_override_target" },
    { 0xF72D3E06, "phalanx_column" },
    { 0x7B2F0F39, "phalanx_column_right" },
    { 0x14AFF58D, "phalanx_column_right_tier_one" },
    { 0x4A003A49, "phalanx_column_right_tier_three" },
    { 0xB4462F5B, "phalanx_column_right_tier_two" },
    { 0x8D74E3A4, "phalanx_column_tier_one" },
    { 0x146E1A00, "phalanx_column_tier_three" },
    { 0x62D11156, "phalanx_column_tier_two" },
    { 0x3DD066BB, "phalanx_diagonal_left" },
    { 0x1F497257, "phalanx_diagonal_left_tier_one" },
    { 0xA401EFA7, "phalanx_diagonal_left_tier_three" },
    { 0x14E55AA5, "phalanx_diagonal_left_tier_two" },
    { 0xF0A0416E, "phalanx_diagonal_right" },
    { 0xDD70210C, "phalanx_diagonal_right_tier_one" },
    { 0x8873FDD8, "phalanx_diagonal_right_tier_three" },
    { 0xED0144AE, "phalanx_diagonal_right_tier_two" },
    { 0xE8DA22BF, "phalanx_forward" },
    { 0x3634F8BB, "phalanx_forward_tier_one" },
    { 0x6FBCD94B, "phalanx_forward_tier_three" },
    { 0xD6BE27A9, "phalanx_forward_tier_two" },
    { 0xE394D6A8, "phalanx_kill" },
    { 0x279ECCFF, "phalanx_max_tier_size" },
    { 0x3BF1218D, "phalanx_min_tier_size" },
    { 0xD3D891A4, "phalanx_navmesh_tolerance" },
    { 0x5244A6C3, "phalanx_reverse_wedge" },
    { 0xFD06983F, "phalanx_reverse_wedge_tier_one" },
    { 0xAACBBD9F, "phalanx_reverse_wedge_tier_three" },
    { 0xD15FA59D, "phalanx_reverse_wedge_tier_two" },
    { 0x69796D00, "phalanx_rotation_offset" },
    { 0x48A6B939, "phalanx_tier_one" },
    { 0x44F9F2D5, "phalanx_tier_three" },
    { 0xF72B4097, "phalanx_tier_two" },
    { 0x3FE90677, "phalanx_tiers" },
    { 0x1B97841E, "phalanx_update_rate_sec" },
    { 0x3A467A3C, "phalanx_wedge" },
    { 0x489ADC42, "phalanx_wedge_tier_one" },
    { 0x4C85D6FA, "phalanx_wedge_tier_three" },
    { 0x7FCB6564, "phalanx_wedge_tier_two" },
    { 0x5B277A2C, "phalanxposition" },
    { 0xF722327D, "phalanxtype" },
    { 0x2E768F70, "phalanxtype_" },
    { 0xCD9654B8, "phantom" },
    { 0x403377DD, "phantom_building_rockets" },
    { 0x41A4EDD4, "phantom_drop" },
    { 0xB81BD502, "phantom_drop_vo" },
    { 0xBF3CA466, "phantom_fire_rocket" },
    { 0x5D49A5D3, "phantom_hangar_stair_logic" },
    { 0x3FBA8272, "phantom_path" },
    { 0x1AA4354B, "phantom_rooftop_entrance" },
    { 0x85D05EB5, "phantom_rooftop_logic" },
    { 0x4B8A179C, "phantom_squadron" },
    { 0xE7B3383E, "phantom_squadron_path" },
    { 0x9A170D76, "phantom_truck_killer" },
    { 0xA5134C26, "phantom_vo" },
    { 0xECE88C13, "phantoms" },
    { 0xA72C3713, "phantoms_a" },
    { 0x3524C7D8, "phantoms_b" },
    { 0xB996323E, "phase" },
    { 0x8FF27AF5, "phase_anim_done" },
    { 0xBA8A1B92, "phase_failsafe" },
    { 0xC78B6DD6, "phase_from_bus" },
    { 0xEBE6D699, "phase_from_bus_done" },
    { 0x238FA9AB, "phase_fx" },
    { 0x54864F3D, "phase_node" },
    { 0x87693820, "phase_state" },
    { 0xDBE488CB, "phase_states" },
    { 0x1ED4909C, "phase_substate" },
    { 0xF59186DF, "phase_substates" },
    { 0x2497A05A, "phase_time" },
    { 0x3E68E89E, "phased" },
    { 0xE0842B21, "phases" },
    { 0x2D5B0E57, "phasing" },
    { 0x9BDD6EED, "phatoms" },
    { 0x0CBAE613, "phd" },
    { 0xC0AC1920, "phd_flopper_damage_callback" },
    { 0x1B8C5BB9, "phd_flopper_execute_cluster" },
    { 0x949783BD, "phd_flopper_init_watchers" },
    { 0x641E6257, "phd_flopper_kill_watchers" },
    { 0xCE140702, "phd_flopper_watch_cluster_grenade" },
    { 0xF3FD5109, "phd_flopper_watch_slider_grenade" },
    { 0x37E61E22, "phd_ignore_means_of_death" },
    { 0x71CECEE9, "phd_slide_grenade_weapon" },
    { 0x2E29A021, "phdflopper" },
    { 0x9285038A, "phdflopper_callback_func" },
    { 0x20562C8D, "phdflopper_client_field_func" },
    { 0x9E430BB9, "phdflopper_cluster_grenade_count" },
    { 0xA3AC477A, "phdflopper_machine_active_model" },
    { 0x0F74915C, "phdflopper_machine_disabled_model" },
    { 0x184A80FE, "phdflopper_machine_fx_file_machine_light" },
    { 0xE1170CEF, "phdflopper_machine_light_fx" },
    { 0x1B9EE3CE, "phdflopper_mus_sting_alias" },
    { 0x9F84248D, "phdflopper_mus_sting_jingle" },
    { 0xA5837B46, "phdflopper_perk_bottle_weapon" },
    { 0xBEEDF3C8, "phdflopper_perk_cost" },
    { 0xC0B8CD0C, "phdflopper_perk_machine_setup" },
    { 0x3C435D4F, "phdflopper_precache" },
    { 0x16756D7B, "phdflopper_precache_override_func" },
    { 0x9005ED2B, "phdflopper_radiant_machine_name" },
    { 0xE03020ED, "phdflopper_register_clientfield" },
    { 0x797B8993, "phdflopper_script_string" },
    { 0x38DE471A, "phdflopper_set_clientfield" },
    { 0xEB4ECE29, "phdflopper_slide_grenade_consecutive_time" },
    { 0x1E004BC0, "phdflopper_slide_grenade_cooldown" },
    { 0x33EEF564, "phdflopper_slide_grenade_count" },
    { 0xB4E6C7E4, "phdflopper_slide_grenade_use" },
    { 0x34C1CB2B, "phdflopper_slide_grenade_weapon" },
    { 0xE4503842, "phds" },
    { 0x3F7ED7C1, "phew" },
    { 0x6AAA1111, "philip" },
    { 0x411F6A37, "phone" },
    { 0xAD683210, "phone_attach_tag" },
    { 0x80815DC2, "phone_counter" },
    { 0x7E0E91C9, "phone_damage" },
    { 0xCFD80C55, "phone_egg" },
    { 0x6D9F72F9, "phone_ent" },
    { 0x8A4FFADA, "phone_inst" },
    { 0x2BC06584, "phone_loop" },
    { 0x22AC94B7, "phoneguy_death" },
    { 0x814F086E, "phones" },
    { 0x349FF49C, "phono_counter" },
    { 0xD2A44824, "phono_egg_init" },
    { 0xD051CD96, "phono_origin" },
    { 0x57F3649E, "phono_trig" },
    { 0xF405A9D3, "phosphorous" },
    { 0x4B6A519B, "photo" },
    { 0x548AB5A8, "photographer" },
    { 0xC2E77D14, "photographer_notify" },
    { 0xFA0867F5, "photographer_path_done" },
    { 0x7595102D, "photographer_start" },
    { 0x7F1BEF61, "photographer_think" },
    { 0x4EBD656C, "photosource" },
    { 0x3D323BCC, "photosource_main" },
    { 0x14204FA8, "photosourcemod" },
    { 0xA7005DEB, "photosourcemodsize" },
    { 0xBA191FD6, "phrase" },
    { 0xBD0E42FC, "phrase_convert_to_cipher" },
    { 0xA484EEE6, "phrased" },
    { 0x679815DD, "phy_blast" },
    { 0x1055E7BF, "phy_lamp" },
    { 0x8FAE98A9, "phy_weaver" },
    { 0x058D712F, "phyexpmagnitude" },
    { 0x2D337269, "phys" },
    { 0x264105AA, "phys_origin" },
    { 0xF13306FF, "phys_pulse" },
    { 0x1EA41202, "phys_ragdoll_buoyancy" },
    { 0x12D6C796, "phys_structs" },
    { 0x29759CD9, "physdist" },
    { 0x18F484C4, "physexplosionforragdoll" },
    { 0xF32F8735, "physic" },
    { 0xB0C2AF5E, "physical" },
    { 0xBD0B7003, "physically" },
    { 0xD461A162, "physiced" },
    { 0xB4755B86, "physicjolt_proximity" },
    { 0x7790AA04, "physics" },
    { 0x5BA1152C, "physics_explosion" },
    { 0x75C1521A, "physics_explosion_and_rumble" },
    { 0xE5F5D8F8, "physics_force" },
    { 0x2EF6E7A6, "physics_launch" },
    { 0x2021B50D, "physics_launch_door" },
    { 0xADA61653, "physics_launch_me" },
    { 0x1E116043, "physics_launch_think" },
    { 0x78F7F838, "physics_move" },
    { 0xCD322365, "physics_object_remove" },
    { 0x97205AC6, "physics_pulse_effect" },
    { 0x3E9CD944, "physics_struct" },
    { 0x676868F7, "physics_structs" },
    { 0xC348F08E, "physics_trace_mask_clip" },
    { 0x0ED02F4F, "physics_trace_mask_physics" },
    { 0xCE577D43, "physics_trace_mask_player" },
    { 0x9200CD6C, "physics_trace_mask_vehicle" },
    { 0xAEBF76CD, "physics_trace_mask_vehicle_clip" },
    { 0x76086EC1, "physics_trace_mask_water" },
    { 0xCBF9275A, "physics_vehicle_death" },
    { 0xA45FEE8B, "physicsexplosioncylinder" },
    { 0x534B3CBA, "physicsexplosionsphere" },
    { 0x7E9FC59B, "physicsjetthrust" },
    { 0xBF99DC8E, "physicsjitter" },
    { 0x8F0C1EED, "physicsjolt" },
    { 0xF87FFD8B, "physicsjolt_proximity" },
    { 0x822F0CC5, "physicslaunch" },
    { 0x47FFF7AA, "physicslaunch_loc" },
    { 0xC1EEBF19, "physicslaunchdeathscale" },
    { 0xD5BDA221, "physicsobject" },
    { 0x781EE8B0, "physicsonexplosion" },
    { 0xDD6A0C16, "physicsshake" },
    { 0xD8FA1AF0, "physicssphereforce" },
    { 0xEAE624BD, "physicssphereradius" },
    { 0xFAFCD7F7, "physicstrace" },
    { 0x59072665, "physicstracecontentsvehicleclip" },
    { 0x56A3D940, "physicstraceex" },
    { 0xD9417FBD, "physicstracemaskclip" },
    { 0xE266E382, "physicstracemaskphysics" },
    { 0x64C556A9, "physicstracemaskvehicle" },
    { 0x7527E654, "physicstracemaskwater" },
    { 0x33D5883C, "physpreset" },
    { 0x025BFBD3, "physradius" },
    { 0xEB5CEDE8, "phystrace" },
    { 0x6EE558F9, "physweapon" },
    { 0xF2300014, "phyzl" },
    { 0xBAD87C84, "pi" },
    { 0x5A19248B, "pi_change" },
    { 0xA13C9005, "pi_change_begin" },
    { 0x69D3253D, "pi_change_end" },
    { 0x5DD2E901, "pi_origin" },
    { 0xBF5FBFA5, "piano_init" },
    { 0xFBAD02CF, "piano_key_note" },
    { 0x969E75CE, "piano_key_played" },
    { 0x96E839A6, "piano_key_run" },
    { 0x3A803777, "piano_key_shot" },
    { 0x434BC0FE, "piano_keys_stop" },
    { 0xBD6CE99D, "piano_play" },
    { 0x6132B1A8, "piano_run_chords" },
    { 0x4B4AEF39, "pianodamagethink" },
    { 0x0E58FD64, "pianothink" },
    { 0xC044C793, "pices" },
    { 0xBC376666, "pick" },
    { 0x6EDC7781, "pick_a_civ" },
    { 0x8A4A316F, "pick_a_powerup" },
    { 0xC0064C09, "pick_a_target_from" },
    { 0x27D1F357, "pick_and_play_pa_vox" },
    { 0x4D42A313, "pick_axe" },
    { 0xA111614A, "pick_boost_number" },
    { 0x5EB511A5, "pick_boost_players" },
    { 0xAB35326F, "pick_classes" },
    { 0xEE3F9083, "pick_death_anim" },
    { 0x6599164E, "pick_delayed_selection_sound" },
    { 0xF02336DB, "pick_fire_anim" },
    { 0x231EE79F, "pick_firing_targets" },
    { 0x17DF3A86, "pick_hero_ability" },
    { 0xAD0DB880, "pick_hero_gadget" },
    { 0xB92705F8, "pick_hero_weapon" },
    { 0x97160A80, "pick_item" },
    { 0x2169B982, "pick_killstreaks" },
    { 0x0CC9448C, "pick_new_ai_table_kick_1" },
    { 0x7ED0B3C7, "pick_new_ai_table_kick_2" },
    { 0x5F46243F, "pick_one" },
    { 0x3A43CDC8, "pick_proper_plane" },
    { 0x7C386318, "pick_random" },
    { 0xB6369D51, "pick_random_goal_node" },
    { 0x6F957E3E, "pick_random_nodes" },
    { 0xB3D79BA3, "pick_random_weapon" },
    { 0x4A25B161, "pick_targets" },
    { 0x6F9992D6, "pick_up" },
    { 0xCD4417A5, "pick_up_keys" },
    { 0x68B88193, "pick_up_nova6" },
    { 0xD071F72F, "pick_your_targets" },
    { 0xB0FBF89E, "pick_zombie_melee_anim" },
    { 0xF243DBEE, "pickcargotospawn" },
    { 0xD88D274B, "pickcount" },
    { 0x0F04E1E9, "picked" },
    { 0xBDEABA4E, "picked_fx" },
    { 0x478C4F15, "picked_fxid" },
    { 0xBF37372B, "picked_up" },
    { 0xC5CED03F, "pickeditems" },
    { 0x1C0E14B2, "pickedup" },
    { 0xA3FC97EA, "pickedup_wire" },
    { 0x29C97116, "pickedupballisticknife" },
    { 0x1E60CE62, "pickedupontouch" },
    { 0xF269AD42, "pickedupweapon" },
    { 0x9BB7E691, "pickedupweaponkills" },
    { 0x1743B68D, "pickedupweapons" },
    { 0x7CD956FA, "picking" },
    { 0x3976E750, "pickingsides_challenge" },
    { 0x7AB1AC37, "picknextdroplocation" },
    { 0x60882FED, "pickradiotospawn" },
    { 0xEFBCD98A, "pickrandompath" },
    { 0xAA4AE528, "pickrandomradiotospawn" },
    { 0x06D42B0B, "pickrandomweapon" },
    { 0x98050513, "pickrandomzonetospawn" },
    { 0x2B0C1199, "picks" },
    { 0xE84E9A49, "picksafezonetospawn" },
    { 0xDBF75E83, "pickside" },
    { 0xC81D9A50, "pickteamfromscores" },
    { 0xB72E286D, "pickup" },
    { 0x0E4AD1B9, "pickup_1" },
    { 0x344D4C22, "pickup_2" },
    { 0x3E488E48, "pickup_add_occupants" },
    { 0x198145C4, "pickup_alias" },
    { 0x0154A35F, "pickup_anim" },
    { 0xD3FD9DE4, "pickup_asd" },
    { 0x68B4CF85, "pickup_bob_distance" },
    { 0xEFF90E10, "pickup_bomb_on_player" },
    { 0xE6347F27, "pickup_claymores" },
    { 0xF96C5DC1, "pickup_claymores_trigger_listener" },
    { 0x658A55C8, "pickup_claymores_trigger_listener_disable" },
    { 0x2E3CB6B1, "pickup_claymores_trigger_listener_enable" },
    { 0xA72CAF40, "pickup_damage_scale" },
    { 0xB992CEE4, "pickup_damage_scale_time" },
    { 0xAE80A3FD, "pickup_delay" },
    { 0xE99C11D8, "pickup_disable_turret_on_gunner_death" },
    { 0xE133E973, "pickup_dist_sq" },
    { 0xC40ADB14, "pickup_drive_by_after_mason" },
    { 0x986FF8B1, "pickup_driver_climb_out" },
    { 0x34E59F7F, "pickup_dropped_equipment" },
    { 0x6CA112C8, "pickup_equipment" },
    { 0x065C7FFC, "pickup_fn" },
    { 0x15EB00AE, "pickup_from_mover" },
    { 0x0F8A48EE, "pickup_gun" },
    { 0xE7E1EA74, "pickup_gunners_dont_take_cougar_damage" },
    { 0x6AD23838, "pickup_guys" },
    { 0x9135C8F3, "pickup_indicator" },
    { 0xCF00065D, "pickup_item" },
    { 0x498FF3B6, "pickup_item_init" },
    { 0x0F630825, "pickup_item_object" },
    { 0x40E0FDF8, "pickup_item_respawn_time" },
    { 0xAC86562D, "pickup_item_respawn_time_ammo" },
    { 0x8BF63FB0, "pickup_item_respawn_time_damage" },
    { 0x405F0FED, "pickup_item_respawn_time_health" },
    { 0x91AE20D7, "pickup_item_respawn_time_perk" },
    { 0x23325443, "pickup_item_respawn_time_weapon" },
    { 0xAE303EF4, "pickup_item_sound_pickup" },
    { 0xD9D2F4C1, "pickup_item_sound_pickup_ammo" },
    { 0xCCBA36BC, "pickup_item_sound_pickup_damage" },
    { 0x9F3B9341, "pickup_item_sound_pickup_health" },
    { 0xDC8F109B, "pickup_item_sound_pickup_perk" },
    { 0xE2CB628F, "pickup_item_sound_pickup_weapon" },
    { 0x3FCC0CEC, "pickup_item_sound_respawn" },
    { 0xBFAC4449, "pickup_item_sound_respawn_ammo" },
    { 0x3C2439A4, "pickup_item_sound_respawn_damage" },
    { 0xCE86C6E9, "pickup_item_sound_respawn_health" },
    { 0xAB075983, "pickup_item_sound_respawn_perk" },
    { 0xE64CB3A7, "pickup_item_sound_respawn_weapon" },
    { 0x67DAEE9C, "pickup_items" },
    { 0xA1E52AA8, "pickup_last_shield" },
    { 0xCEB15C3B, "pickup_last_weapon" },
    { 0xCAEB5B36, "pickup_loop_sound" },
    { 0x5D12A955, "pickup_message" },
    { 0xF012DD6E, "pickup_models" },
    { 0xCDB7CAF5, "pickup_mutual_exlusion_list" },
    { 0x08854DCE, "pickup_mutual_exlusive" },
    { 0x15142449, "pickup_new_piece" },
    { 0x74928720, "pickup_notetracks" },
    { 0xF05BE288, "pickup_nova6" },
    { 0x0D50B5D5, "pickup_object" },
    { 0x73886D95, "pickup_object_delay" },
    { 0xBB473B06, "pickup_origin" },
    { 0xC9EF1A23, "pickup_passenger_climb_out" },
    { 0x2E6274AA, "pickup_passenger_rl_climb_out" },
    { 0x7A5E3732, "pickup_passenger_rl_idle" },
    { 0x556C9944, "pickup_passenger_rr_climb_out" },
    { 0xB7753178, "pickup_passenger_rr_idle" },
    { 0x21CB7831, "pickup_placeable_mine" },
    { 0x31D9AAEB, "pickup_placeable_mine_trigger_listener" },
    { 0xA5142F2E, "pickup_placeable_mine_trigger_listener_disable" },
    { 0xF58385A3, "pickup_placeable_mine_trigger_listener_enable" },
    { 0xC6FDCD02, "pickup_placed_equipment" },
    { 0x19736B21, "pickup_riotshield" },
    { 0x210795C6, "pickup_rotate_rate" },
    { 0x8D4B02D8, "pickup_scene" },
    { 0xE81B995A, "pickup_smoke_grenades_thread" },
    { 0x2C64534C, "pickup_spawner" },
    { 0x1B9F528A, "pickup_stretcher" },
    { 0xF55AA334, "pickup_tear_down_monitor" },
    { 0xD591B7DB, "pickup_time" },
    { 0x62E68A49, "pickup_timeout" },
    { 0x6323CA72, "pickup_trap_piece" },
    { 0x4DD8056E, "pickup_trig" },
    { 0x9DBE9414, "pickup_trigger" },
    { 0x92D66167, "pickup_trigger_listener" },
    { 0xB9D0CB87, "pickup_triggers" },
    { 0x5CB6489F, "pickup_turret_index" },
    { 0x78B13B33, "pickup_types" },
    { 0xB1F88A9C, "pickup_weapon" },
    { 0x973414DF, "pickup_weapons" },
    { 0x6235C32D, "pickupammoevent" },
    { 0xE8F64079, "pickupavailableeffect" },
    { 0xF5C0B7DC, "pickupcrossbowbolt" },
    { 0x04C9A9B9, "pickupfrombus" },
    { 0x08ACA4A3, "pickupfromelevator" },
    { 0x832DCDA8, "pickupfrommover" },
    { 0x5E1EF84D, "pickupgrenade" },
    { 0x8CA9CD98, "pickupheadchopper" },
    { 0x81E3DEF4, "pickupitemrespawn" },
    { 0x2EB2AC04, "pickupjetgun" },
    { 0x11305131, "pickupkniferangretrievemodel" },
    { 0xDB6C4D74, "pickupmodel" },
    { 0x47FFB3FE, "pickupnewgunnotetrack" },
    { 0x6A06B861, "pickupobjectdelay" },
    { 0x5EEFDC3C, "pickupperkrespawntime" },
    { 0xB78CA66C, "pickups" },
    { 0x4F4E62BA, "pickupshield" },
    { 0x6792DC08, "pickupsitems" },
    { 0x27DA483B, "pickupslipgun" },
    { 0x0EC82FD2, "pickupsound" },
    { 0x2B74A6BD, "pickupsoundplayer" },
    { 0xA86AAF65, "pickupspot" },
    { 0xE467B3D5, "pickupspringpad" },
    { 0xF7BD7E1E, "pickupstring" },
    { 0x126F16C1, "pickupsubwoofer" },
    { 0x1935FE46, "pickuptarget" },
    { 0xA9618A36, "pickuptimeout" },
    { 0x5DC2F3BE, "pickuptimeoutoverride" },
    { 0x93D5F0D8, "pickuptrap" },
    { 0x1C7F8993, "pickuptrigger" },
    { 0x249F6412, "pickupturbine" },
    { 0x4D17DF6B, "pickupturret" },
    { 0xA6F5E87A, "pickupunavailableeffect" },
    { 0xC86FDC27, "pickupweaponevent" },
    { 0x5559A25C, "pickupweaponrespawntime" },
    { 0x24389478, "pickzonetospawn" },
    { 0x2C8A897B, "picnic" },
    { 0x8C23931E, "pics" },
    { 0x9460CB25, "picture" },
    { 0x455BAEDB, "picture_frame_large" },
    { 0x66921B34, "pictures" },
    { 0xEAB20581, "picukp" },
    { 0xCDD432C8, "pid" },
    { 0x7DBE5E60, "pidx" },
    { 0x0FD7C985, "piece" },
    { 0x7026B5A6, "piece1" },
    { 0x4A243B3D, "piece2" },
    { 0x2421C0D4, "piece3" },
    { 0xE40DC60C, "piece_alias" },
    { 0xB7D0EF99, "piece_allocate_cyclic" },
    { 0x71B117BD, "piece_allocate_spawn" },
    { 0x2DDFCDB3, "piece_allocated" },
    { 0x815BC354, "piece_counter" },
    { 0x6E2654A2, "piece_cycle" },
    { 0xBC606418, "piece_deallocate_spawn" },
    { 0xA1103996, "piece_destroy" },
    { 0x32A3EB80, "piece_destroy_booze" },
    { 0xC4790B04, "piece_destroy_candy" },
    { 0x61F9A50A, "piece_destroy_chalk" },
    { 0xB33B7437, "piece_header" },
    { 0x9DC8B238, "piece_hide" },
    { 0xA9B17C8C, "piece_index" },
    { 0xC86D2AC9, "piece_instance" },
    { 0xDD177410, "piece_maker_prompts" },
    { 0x8C9A39D3, "piece_maker_structs" },
    { 0xECE361C9, "piece_maker_think" },
    { 0x83338C85, "piece_maker_unitrigger" },
    { 0x098138C5, "piece_maker_update_prompt" },
    { 0x0B53268B, "piece_makers" },
    { 0x186FE44F, "piece_model" },
    { 0x90757D31, "piece_name" },
    { 0x3AE53E08, "piece_num" },
    { 0xE42B787B, "piece_number" },
    { 0x305B961A, "piece_numbers" },
    { 0x77A0498D, "piece_owner" },
    { 0x97B60807, "piece_pick_random_spawn" },
    { 0xA4B5301E, "piece_pickup_conversation" },
    { 0x964EEDE9, "piece_released" },
    { 0x7D44CE8C, "piece_remaining" },
    { 0xACDD19F8, "piece_set_spawn" },
    { 0x044BAC33, "piece_show" },
    { 0x6ED580DC, "piece_slot" },
    { 0x6E606195, "piece_spawn" },
    { 0x695B1F07, "piece_spawn_at" },
    { 0x9147A4C2, "piece_spawn_at_with_delay" },
    { 0x1C0C9E62, "piece_spawn_at_with_notify_delay" },
    { 0xED9FEC87, "piece_spawn_booze" },
    { 0xCF3D908B, "piece_spawn_candy" },
    { 0x0BECE225, "piece_spawn_chalk" },
    { 0xE9E39B8B, "piece_spawn_chalk_internal" },
    { 0xB65C09B5, "piece_spawn_in" },
    { 0x4DA9AB3A, "piece_to_remove" },
    { 0x755DFC2C, "piece_trigger" },
    { 0x00DC3C50, "piece_unitrigger_offset" },
    { 0xCB87EBFF, "piece_unitrigger_think" },
    { 0xEDAECB6A, "piece_unspawn" },
    { 0xB9F2E724, "piece_unspawn_booze" },
    { 0x392969C0, "piece_unspawn_candy" },
    { 0x98499059, "piece_vox_id" },
    { 0xBD958CCD, "piece_vox_timer" },
    { 0x0389570E, "piece_wait_and_return" },
    { 0x7F0BDD9A, "piececount" },
    { 0xA6AC52CC, "piecename" },
    { 0x76F0C072, "piecenumber" },
    { 0xA4C05B14, "pieces" },
    { 0xF5177119, "pieces_collision" },
    { 0xBBBC0068, "pieces_move" },
    { 0xC4DABE58, "pieces_needed" },
    { 0x59B984D5, "pieces_think" },
    { 0x5B55E566, "piecespawn" },
    { 0x395116EB, "piecespawn_check" },
    { 0xDA5B715D, "piecestub" },
    { 0xB80130FA, "piecestub_get_unitrigger_origin" },
    { 0x7BB3B408, "piecestub_update_prompt" },
    { 0xA561DC8E, "piecetrigger_update_prompt" },
    { 0xE064A301, "pier" },
    { 0xDDBAA13D, "pier_guy" },
    { 0x3F4075F9, "pier_trigger_think" },
    { 0xC1E4F455, "pierce" },
    { 0xCAE15044, "pierro" },
    { 0x3FDBA203, "pig" },
    { 0x9AAE8A8C, "pig_audio" },
    { 0x3C72A4E7, "pig_random_animations" },
    { 0xF43B9B22, "pig_sounds" },
    { 0x73571270, "pig_wait_to_be_shot" },
    { 0xE22AD54C, "piggbybacking" },
    { 0xE727D3F3, "piggy" },
    { 0x4C28200E, "piggy_forward_vec" },
    { 0xB62B3C6F, "piggy_right_vec" },
    { 0x7C48CDEA, "piggyback" },
    { 0xCC08AD92, "piggyback_guy" },
    { 0xFCEC197D, "piggybacked" },
    { 0xECCA95C6, "piggybacking" },
    { 0x8F4B9172, "pigs" },
    { 0xDA67F554, "pigs2" },
    { 0xF7E31106, "pigs_struct" },
    { 0x91426B10, "pikedweapon" },
    { 0xD4D0A1ED, "pile" },
    { 0x18771713, "piled" },
    { 0xDEE1FACC, "pill" },
    { 0xD75E4A84, "pill_base" },
    { 0x71BC7532, "pill_height" },
    { 0x5B06084D, "pill_radius" },
    { 0x421C8255, "pillar" },
    { 0x2167BDB6, "pillar1" },
    { 0xFB65434D, "pillar2" },
    { 0x00D5AB20, "pillar_area_battle" },
    { 0x2CF12EE3, "pillarclip" },
    { 0xDC541815, "pillarnode" },
    { 0x54C42EA4, "pillars" },
    { 0x2E8FA5F1, "pilot" },
    { 0xDCFA93D3, "pilot0" },
    { 0xB6F8196A, "pilot1" },
    { 0x90F59F01, "pilot2" },
    { 0x140DAD8C, "pilot_and_radio_go" },
    { 0xE0B4914A, "pilot_drag" },
    { 0x2AA35DA3, "pilot_drag_ended" },
    { 0xB11A7153, "pilot_drag_over" },
    { 0x70491CBF, "pilot_drag_play_harper_anims" },
    { 0x0015400C, "pilot_drag_setup" },
    { 0x961BC698, "pilot_drag_started" },
    { 0x969A670D, "pilot_drag_van_idle" },
    { 0x323B765E, "pilot_drag_van_setup" },
    { 0xEF69358B, "pilot_dragged_here" },
    { 0x5272F9BE, "pilot_hands" },
    { 0x57BBBA42, "pilot_headshot" },
    { 0x1EC0C311, "pilot_loop_logic" },
    { 0x28460A79, "pilot_pre_drag_idle" },
    { 0x356CD583, "pilot_put_down_in_seaknight" },
    { 0x4F12EE98, "pilot_reply" },
    { 0xD3EBD826, "pilot_rescue_event" },
    { 0xA76DFCCF, "pilot_said_front" },
    { 0x6AF22860, "pilot_says_no_to_cp" },
    { 0x0EF5B99F, "pilot_shot_in_head" },
    { 0x4FC1D650, "pilot_spawner" },
    { 0xD2DC31AA, "pilot_taken_from_cockpit" },
    { 0xFBEEBBB4, "pilot_takes_damage" },
    { 0xB7B30660, "pilot_vals" },
    { 0x10545640, "pilotarray" },
    { 0x64BD5658, "pilotbundles" },
    { 0x727FD664, "pilotcobra" },
    { 0x619C6D79, "pilotdialogarraykey" },
    { 0xB2EF75FA, "pilotdialogwait" },
    { 0x0F7B0133, "pilotindex" },
    { 0x742EBC2B, "pilotisspeaking" },
    { 0x73301259, "pilotistalking" },
    { 0xEA548A58, "pilots" },
    { 0x0CEE2951, "pilots_alternate_seat" },
    { 0xD8E9C605, "pilots_only" },
    { 0xB7ABD774, "pilots_suggested_seat" },
    { 0xB9818E95, "pilottalking" },
    { 0x95B86D1A, "pilotvoicenumber" },
    { 0xE9C55452, "pin" },
    { 0x73425F14, "pin_check_rotation" },
    { 0x030ECB08, "pin_first_three_spikes_to_ground" },
    { 0x7B1A1F88, "pin_model" },
    { 0xC739C926, "pin_move" },
    { 0xAB984A0F, "pin_spike_to_ground" },
    { 0xB10C5F57, "pin_think" },
    { 0xD9CDF83C, "pin_to_ground" },
    { 0x3E2886CB, "pindelay" },
    { 0xB6246D29, "pindex" },
    { 0x26789122, "pineapple_gun" },
    { 0x441EB319, "pineapplegun_effect_cb" },
    { 0x3A397E87, "pineapplegunactorkilleffect" },
    { 0xCCE84825, "pineapplegunplayerkilleffect" },
    { 0xE9B91D80, "piney" },
    { 0x55E6A629, "ping" },
    { 0xF0B78A1D, "ping_fx_sounds" },
    { 0x35821D66, "pingdelay" },
    { 0x10B06499, "pingdist" },
    { 0xB47DCC0C, "pingdisttext" },
    { 0xBE09FA70, "pinger" },
    { 0x4EF46A5F, "pinging" },
    { 0xA42CE026, "pingplayer" },
    { 0xD0992FA0, "pings" },
    { 0x1E046315, "pink" },
    { 0x41C5B601, "pink_reticle_color_index" },
    { 0x0AA949D5, "pink_tank_blow_up" },
    { 0x10347C79, "pink_tank_wait_here" },
    { 0x2CF626E7, "pinktrig" },
    { 0xC0E07F1B, "pinned" },
    { 0x67841250, "pinning" },
    { 0x5FEDA908, "pinpoint" },
    { 0x23A7391B, "pinpointed" },
    { 0x4E18365D, "pins" },
    { 0xA197A5F5, "pioson" },
    { 0x255CF2EE, "piotential" },
    { 0xC605C2FC, "pip" },
    { 0xE689CE94, "pip_ai_think" },
    { 0x64C62ABA, "pip_bottom" },
    { 0x58F9D762, "pip_dogfights_1" },
    { 0xE9E4E12A, "pip_filterid" },
    { 0xDD448A24, "pip_karma_event" },
    { 0xCE1CBEF4, "pip_left" },
    { 0x54EC80F4, "pip_material" },
    { 0x908B77A3, "pip_materialid" },
    { 0x8E8001DE, "pip_opacity" },
    { 0xB0C653CB, "pip_passid" },
    { 0x1EB5E9AB, "pip_right" },
    { 0x478B0621, "pip_security_feed_start" },
    { 0x108DC352, "pip_snd_ent" },
    { 0xA1BED6CF, "pip_sound_bink_ent" },
    { 0xE852D1DE, "pip_sound_ent" },
    { 0x6D2F6C48, "pip_squash" },
    { 0xE07F5AD9, "pip_start" },
    { 0x6B42FC40, "pip_top" },
    { 0x85F86AD9, "pipe" },
    { 0xD55D9558, "pipe0_boss_damage_volume" },
    { 0x38E612A2, "pipe1" },
    { 0x0252BE07, "pipe1_boss_damage_volume" },
    { 0x2B82FCBA, "pipe_blocker" },
    { 0x9D05DFDF, "pipe_breaking" },
    { 0xCC794920, "pipe_breaks" },
    { 0xF817B778, "pipe_bump" },
    { 0x59FEA8F8, "pipe_calc_assert" },
    { 0xFCA2B87B, "pipe_calc_ballistic" },
    { 0xB4E15995, "pipe_calc_nofx" },
    { 0xE6EAA95B, "pipe_calc_splash" },
    { 0x1AA5E8FD, "pipe_chopper" },
    { 0x9F56AF62, "pipe_chopper_02" },
    { 0xEA5E899A, "pipe_chopper_02_start_node" },
    { 0xC2C81143, "pipe_chopper_start_node" },
    { 0x8212E7EF, "pipe_fall" },
    { 0x10E4CB12, "pipe_fall_done" },
    { 0x9CE162FB, "pipe_fog_level" },
    { 0x4401A9DE, "pipe_fx" },
    { 0x3E1711BA, "pipe_fx_time" },
    { 0x30257A53, "pipe_heavy_rumble" },
    { 0xBD895247, "pipe_heli_danger_over" },
    { 0x8A84E365, "pipe_heli_spotted_danger_over" },
    { 0xE70FDE8B, "pipe_jumpto" },
    { 0x334276F5, "pipe_return_blocker" },
    { 0x41E40EA1, "pipe_ruptured" },
    { 0xAE1EE4EC, "pipe_safe_zone" },
    { 0xABAD8B05, "pipe_safe_zone_trigger" },
    { 0xD4FC2DDB, "pipe_slide" },
    { 0x94A16CAD, "pipe_slide_save" },
    { 0xDB32B24D, "pipe_tank_init" },
    { 0x50E7B9ED, "pipe_zone_player_damage_override" },
    { 0x804C3A88, "pipearray" },
    { 0xF91C09C8, "pipebombs" },
    { 0x3E278D22, "pipebreak" },
    { 0x5FBBCB5E, "pipebreak_damage" },
    { 0x242C86A4, "pipebreakinit" },
    { 0x29ADDBCE, "pipebreakthink" },
    { 0xFE351CC8, "pipebreakthink2" },
    { 0x24379731, "pipebreakthink3" },
    { 0xE243FB3E, "pipebreakthink4" },
    { 0x44DA172C, "pipebridge_01" },
    { 0x5DAFD4A9, "pipebridge_01_start" },
    { 0xB6E18667, "pipebridge_02" },
    { 0x1B7373D2, "pipebridge_02_start" },
    { 0x90DF0BFE, "pipebridge_03" },
    { 0xCC591E3F, "pipebridge_03_start" },
    { 0xF840A07F, "pipefx" },
    { 0x35460C1B, "pipeimpact" },
    { 0xB3C746CB, "pipeline" },
    { 0xD507888D, "pipemasterinit" },
    { 0x5E42B2FB, "pipemasteriterate" },
    { 0x4DC25E1A, "pipeobjective" },
    { 0x6C428390, "pipes" },
    { 0xB3D92D98, "pipes_bosses_chopper1_trigger" },
    { 0x08BCCE8B, "pipes_burst" },
    { 0x63BCC9A7, "pipes_dropped" },
    { 0xC5E36A41, "pipes_init" },
    { 0x91CA22EC, "pipesetup" },
    { 0xB5004802, "pipesndloopfx" },
    { 0x5AC6FADF, "pipethink" },
    { 0x32B8D58F, "pipethink2" },
    { 0x3ADB0EF4, "pipethink_logic" },
    { 0x09DFA2BF, "pips" },
    { 0x0ACF879E, "pisces" },
    { 0x39A0E06E, "piss" },
    { 0x5AD964B1, "pissed" },
    { 0x3CC81578, "pissedoff" },
    { 0xEEA85050, "pistol" },
    { 0x483BB18D, "pistol_achievement_check" },
    { 0x1FEB723A, "pistol_array" },
    { 0x154237AB, "pistol_array_index" },
    { 0x94076EB8, "pistol_dw_endgame_1" },
    { 0x060EDDF3, "pistol_dw_endgame_2" },
    { 0xE00C638A, "pistol_dw_endgame_3" },
    { 0x0277D156, "pistol_dw_endgame_array" },
    { 0x09212375, "pistol_dw_lobby" },
    { 0x8F4DBAEC, "pistol_endgame_1" },
    { 0x01552A27, "pistol_endgame_2" },
    { 0xDB52AFBE, "pistol_endgame_3" },
    { 0x991ED5FA, "pistol_endgame_array" },
    { 0xE5C34415, "pistol_event" },
    { 0xA892F67A, "pistol_kill_index" },
    { 0x51D3FD11, "pistol_lobby" },
    { 0x667A1EFD, "pistol_pullout_distsq" },
    { 0x883D17B2, "pistol_putback_distsq" },
    { 0x3903D6A7, "pistol_rank_setup" },
    { 0xB0924CAF, "pistol_todo" },
    { 0xD3C37E6B, "pistol_value_solo_replace_below" },
    { 0x17643659, "pistol_values" },
    { 0xC6ECAD86, "pistolads" },
    { 0xEA95749C, "pistolfire" },
    { 0xAA1E0FD0, "pistolonlyai" },
    { 0xDB430EDF, "pistolrange" },
    { 0x8987A1D9, "pistolrangeclose" },
    { 0xD3E84F3B, "pistols" },
    { 0x13ABDF0D, "pistolshoot" },
    { 0x70DC04E7, "pistolswitchtime" },
    { 0x3AAD4522, "piston" },
    { 0x2DFBD958, "pit" },
    { 0x01F093A1, "pit1" },
    { 0x8F23B0C2, "pit2_attacker_setup" },
    { 0xAC991146, "pit2_defender_setup" },
    { 0x0A5DFCD8, "pit2_threatbias_setup" },
    { 0x5526AA2C, "pit_move" },
    { 0x109C0D6F, "pit_stop" },
    { 0x74D0E601, "pitch" },
    { 0x89805508, "pitch_down" },
    { 0x2EC9F490, "pitch_run_rate" },
    { 0xC5ECA60B, "pitch_to_use" },
    { 0x2B26F803, "pitch_up" },
    { 0x7B0E0C70, "pitch_vals" },
    { 0x27721465, "pitch_vel" },
    { 0x84BD8B34, "pitch_weight" },
    { 0x6DD1DEB2, "pitchaccelerationtime" },
    { 0x2FE6B4CA, "pitchadd" },
    { 0x56B78048, "pitchaimweight" },
    { 0x8983D19E, "pitchangle" },
    { 0x0C738707, "pitchangleoffset" },
    { 0xEBA264CD, "pitchdecelerationthreshold" },
    { 0x4FDBB301, "pitchdelta" },
    { 0x2E9ECEED, "pitchdeltachange" },
    { 0x28D0523C, "pitchdifference" },
    { 0x943EC2EE, "pitched" },
    { 0x91502959, "pitcherror" },
    { 0xBC6B4FDD, "pitchfork" },
    { 0x24D59772, "pitchfork_decision_made" },
    { 0xF1473A45, "pitchfork_logic_done" },
    { 0x3940E763, "pitchfork_prop" },
    { 0xED202B88, "pitchfork_think" },
    { 0x9D01BA47, "pitching" },
    { 0xBF6937C9, "pitchmax" },
    { 0xDA5E6377, "pitchmin" },
    { 0x0EB7FBF0, "pitchrange" },
    { 0x621E2952, "pitchsensitivity" },
    { 0x1ADE69F2, "pitchspeed" },
    { 0xDE2A5EA0, "pitchspeedads" },
    { 0x861663DB, "pitchstep" },
    { 0x6C8FE2DE, "pitchtoenemy" },
    { 0x472259EF, "pitchtoenemyposition" },
    { 0x86883630, "pitchvar" },
    { 0xA8F01D29, "pitchvibrateamplitude" },
    { 0x72D81AB2, "pitiful" },
    { 0xCD56EE33, "pits" },
    { 0xE941867F, "pitted" },
    { 0xF57E66BF, "pivot" },
    { 0x6D7B9441, "pivoting" },
    { 0x95F1EFB4, "pix" },
    { 0xC22BFA61, "pixbeginevent" },
    { 0x396F36D6, "pixels" },
    { 0x7905CB51, "pixendevent" },
    { 0x97A88AB2, "pixmarker" },
    { 0xBBD95471, "pjl" },
    { 0xA6F161AF, "pk_dialogue" },
    { 0xD78EC0FD, "pkg" },
    { 0x98898779, "pkg_exist" },
    { 0xD464E764, "pkg_index" },
    { 0x3389AAD7, "pkg_ref" },
    { 0x27455C15, "pkg_ref_checkmaxspawn" },
    { 0x3F315E8E, "pkg_refs" },
    { 0xB2E0BFA3, "pkg_types" },
    { 0x012952BC, "pkgs" },
    { 0xCAE31B35, "pkgtype" },
    { 0x48D10D49, "pl" },
    { 0xC9A0F63B, "pl0" },
    { 0xA39E7BD2, "pl1" },
    { 0xE807CBBC, "pl_num" },
    { 0x27805FFD, "plac" },
    { 0x69EF9341, "placable" },
    { 0x2E5A045A, "place" },
    { 0x7DDBF71A, "place_additionalprimaryweapon_machine" },
    { 0xE0326EC7, "place_ball_think" },
    { 0xA95E052B, "place_carryqrdrone" },
    { 0xA18827EE, "place_copy" },
    { 0x08CD1F5D, "place_cvg" },
    { 0x0AA233D3, "place_destructible" },
    { 0x23B89845, "place_destructible_copy" },
    { 0xB0A2C4BD, "place_dummy_target" },
    { 0xD0D64F3B, "place_dyn_ents" },
    { 0xC157F4F1, "place_dynent" },
    { 0x84D06953, "place_dynent_copy" },
    { 0x2E48AB49, "place_fn" },
    { 0xF0F1A117, "place_loadout_item" },
    { 0x78BBE11C, "place_miscmodel" },
    { 0x20A41E68, "place_miscmodel_copy" },
    { 0xE9E262A6, "place_navcard" },
    { 0x6D7E89E3, "place_player_loadout" },
    { 0x6CCD41F6, "place_player_loadout_camo" },
    { 0xF53126F5, "place_player_loadout_old" },
    { 0xB22A5BF8, "place_player_loadout_old_camo" },
    { 0x6EF19E3A, "place_prop" },
    { 0xB545510E, "place_prop_copy" },
    { 0xB86D2843, "place_qualifier" },
    { 0x64B76301, "place_rifle" },
    { 0x29435FCA, "place_smoke_grenades" },
    { 0x8A213FA0, "place_spawn_points" },
    { 0xB56ABF9D, "place_staff" },
    { 0x4C21D2DE, "place_staff_in_charger" },
    { 0x0BFED2BE, "place_staffs_encasement" },
    { 0xDC864328, "place_target_cp" },
    { 0x7DC03A4C, "place_track_cp" },
    { 0x9AD63D40, "place_victory_bodies" },
    { 0x7A491C47, "place_weapon_on" },
    { 0xA5A5E916, "placeable" },
    { 0x96E483BB, "placeable_equipment" },
    { 0x0100F35B, "placeable_equipment_destroy_fn" },
    { 0xF8FF29E6, "placeable_equipment_type" },
    { 0x93A655B4, "placeable_mine" },
    { 0x47141FD8, "placeable_mine_can_buy_weapon_extra_check_func" },
    { 0x490A8D7C, "placeable_mine_damage" },
    { 0xF967A857, "placeable_mine_detonate" },
    { 0x5DF17CF0, "placeable_mine_planted_callbacks" },
    { 0xF3CACBA7, "placeable_mines" },
    { 0xEDDBBFEC, "placeable_mines_in_name_only" },
    { 0x4783CDC4, "placeable_mines_max_per_player" },
    { 0x6161FD23, "placeable_mines_on_damage" },
    { 0x9A6A8DD8, "placeable_moveable_timeout_extension" },
    { 0x0EC6689B, "placeable_moveable_timeout_extension_tu1" },
    { 0x38A40F24, "placeable_offset" },
    { 0x93B47F89, "placeables" },
    { 0x78BD08AA, "placed" },
    { 0x972AA3A9, "placed_buildable_vo_timer" },
    { 0x1D556407, "placed_craftable_vo_timer" },
    { 0xA400CA6D, "placed_cvg" },
    { 0x5934854E, "placed_equipment_think" },
    { 0x5358CCC1, "placed_equipment_unitrigger_think" },
    { 0xB387C56E, "placed_explosive" },
    { 0x96F05E4E, "placed_turrets" },
    { 0xC4F3A989, "placed_weapon_on_left" },
    { 0xEB0AF4B4, "placed_weapon_on_right" },
    { 0xD8CE7632, "placed_wire" },
    { 0x3DC00C81, "placedmodel" },
    { 0x5FDC0271, "placeent_vector" },
    { 0x9B3F86A5, "placefacethread" },
    { 0x13D02EC8, "placeglows" },
    { 0x5BAFDE61, "placeheadchopper" },
    { 0xBB0BF51A, "placehintstring" },
    { 0xBADC0BBC, "placeholder" },
    { 0xE51043E1, "placeholder_puzzle_delete_ent" },
    { 0xF7140E8C, "placeholder_puzzle_spin_model" },
    { 0x35F6F47F, "placeholders" },
    { 0xCF05A9F7, "placememt" },
    { 0x1D893CDA, "placement" },
    { 0x40FE1B06, "placement_hint" },
    { 0xC642208B, "placement_index" },
    { 0x0BBADF37, "placementall" },
    { 0xCBDBA7CC, "placementallsize" },
    { 0xA1BED546, "placementindex" },
    { 0x91F2C2D5, "placements" },
    { 0xBE087437, "placementscores" },
    { 0xAB3442FA, "placementtag" },
    { 0xF43A8455, "placementteam" },
    { 0x9BF84BD8, "placenextimage" },
    { 0x8A9CD155, "places" },
    { 0xCD32EE19, "places_before_decimal" },
    { 0xFD666449, "placeshield" },
    { 0x2D9878CB, "placespawnpoint" },
    { 0xD742612A, "placespawnpoints" },
    { 0xD8BEA024, "placespringpad" },
    { 0xDE6FDB68, "placesubwoofer" },
    { 0x024F23CA, "placetalon" },
    { 0x75A6BC07, "placetrap" },
    { 0xA0EB3E7F, "placeturbine" },
    { 0xAE9C6F08, "placeturret" },
    { 0xBF349186, "placevehicle" },
    { 0x22A1BF45, "placeweaponon" },
    { 0x65EDF403, "placeweapononrightoninterrupt" },
    { 0x7889536B, "placing" },
    { 0x3F839D22, "plackback_finished" },
    { 0x9B643773, "plaer" },
    { 0x1ACBF0B6, "plahyer" },
    { 0xE4136CBB, "plain" },
    { 0xC53EF223, "plain_reticle_index" },
    { 0x9987CF38, "plan" },
    { 0x22AF38CF, "plan_b" },
    { 0xF3E2429A, "planb" },
    { 0x1AB2EFEC, "planb2" },
    { 0xCEADFB1A, "planb4" },
    { 0x2474C56E, "planb_bowman_endguard" },
    { 0x856A3101, "planb_bowman_giveidle" },
    { 0x5CE04D78, "planb_bowman_guard2give" },
    { 0xB01F0CFD, "planb_bowman_guardloop" },
    { 0x772391BE, "planb_computer" },
    { 0xFA4A0698, "planb_enterc4" },
    { 0x925CE1D4, "planb_exitc4" },
    { 0x646D1910, "planb_launcher_wait_idle" },
    { 0xE08B2EDD, "planb_weaver_computer_work" },
    { 0xA8670179, "planb_weaver_endidle" },
    { 0x4D3E8B42, "planb_weaver_startidle" },
    { 0x7D871F49, "planb_woods" },
    { 0x65E9B1D5, "plane" },
    { 0x236BFE9F, "plane0" },
    { 0xFD698436, "plane1" },
    { 0xD76709CD, "plane2" },
    { 0xB1648F64, "plane3" },
    { 0xC99DA4F1, "plane_1" },
    { 0xEFA01F5A, "plane_2" },
    { 0x15A299C3, "plane_3" },
    { 0x3BA5142C, "plane_4" },
    { 0xA926B141, "plane_a" },
    { 0x64002808, "plane_apple" },
    { 0xF6C34D2C, "plane_attack" },
    { 0xE9B8E136, "plane_attack_drones" },
    { 0x9CEB8BC4, "plane_attack_failsafe" },
    { 0x463A05AD, "plane_attack_sampan" },
    { 0x1C7CF358, "plane_attack_sampan_think" },
    { 0xD8871D2A, "plane_attack_vo" },
    { 0xCF292BAA, "plane_b" },
    { 0x50E946B6, "plane_b_fake" },
    { 0x9B13898E, "plane_b_is_crashed" },
    { 0x5D2BA937, "plane_begin" },
    { 0x1A7CBE5F, "plane_blocker_02" },
    { 0x6A6B58BA, "plane_blocker_02_start" },
    { 0x30656FBB, "plane_boarding_thread" },
    { 0xEBADAC9C, "plane_boarding_thread_custom_func" },
    { 0xFC1B0A87, "plane_bomb_cluster" },
    { 0x217685D0, "plane_bomb_explosion" },
    { 0xAFC53119, "plane_bomb_fx" },
    { 0x0E93297E, "plane_bomb_model" },
    { 0xF4FA7CE7, "plane_bomb_node" },
    { 0xCFAB400C, "plane_bomb_sound" },
    { 0x08A83EBE, "plane_capture" },
    { 0xBB6B49B2, "plane_capture_face" },
    { 0x60337441, "plane_capture_gun" },
    { 0x4322EF77, "plane_capture_kick" },
    { 0xA9CFB4AC, "plane_capture_obj" },
    { 0x76A1AAEE, "plane_capture_shoot" },
    { 0x0AD2488C, "plane_chance" },
    { 0x34D9F52F, "plane_cleanupondeath" },
    { 0x77F04904, "plane_close" },
    { 0x74E3605C, "plane_cloth" },
    { 0x55EE3B30, "plane_controller" },
    { 0xE486D764, "plane_counter" },
    { 0xB00D2D4A, "plane_craftable" },
    { 0xD41319A1, "plane_crash" },
    { 0x6E634373, "plane_crash_move_shockwave" },
    { 0x8E154382, "plane_crash_origin" },
    { 0xB34BB84B, "plane_crate_anim" },
    { 0x735D1CCD, "plane_crate_anim_obj" },
    { 0x53BDD81A, "plane_crate_anim_think" },
    { 0x2B304FAB, "plane_crate_anim_vo" },
    { 0x5A1369DB, "plane_damage" },
    { 0x73C5548B, "plane_damage_lines" },
    { 0x84A4DF5C, "plane_damage_monitor" },
    { 0x05C30D64, "plane_damage_states" },
    { 0xC48F8D2D, "plane_dest_fx" },
    { 0x41F59824, "plane_dist_a" },
    { 0xB3FD075F, "plane_dist_b" },
    { 0xD1B16B5D, "plane_dot" },
    { 0xFAF1342C, "plane_drive_highway" },
    { 0x7D173784, "plane_drive_highway_follow" },
    { 0xDBF9FA01, "plane_drones" },
    { 0x71AEAAEE, "plane_engine" },
    { 0x2CD856F5, "plane_engine_2" },
    { 0x06D5DC8C, "plane_engine_3" },
    { 0xE0D36223, "plane_engine_4" },
    { 0xE49A3621, "plane_escape" },
    { 0x149E0DF7, "plane_escape_failsafe" },
    { 0x2DDD4186, "plane_f35_player_vtol" },
    { 0xD4F55A53, "plane_fake_fire_loop" },
    { 0x3F5983B3, "plane_fall" },
    { 0x1C2073DD, "plane_fall_blackout" },
    { 0xFA0467A6, "plane_fire_weapons" },
    { 0x8F190014, "plane_flare" },
    { 0x90492BC1, "plane_flight_thread" },
    { 0x680D6D0A, "plane_flight_thread_custom_func" },
    { 0x2CBE0D60, "plane_fly_away" },
    { 0x800C10BD, "plane_fly_trigger_thread" },
    { 0x91D45920, "plane_flyby" },
    { 0x63EE38BC, "plane_flyby_group" },
    { 0x1F0F1039, "plane_flyby_offsets" },
    { 0x0DC79C78, "plane_flyby_special" },
    { 0x365D8C07, "plane_fueltanks" },
    { 0xC499EAB0, "plane_go_path_wrapper" },
    { 0x596530C3, "plane_groups_done" },
    { 0x138B6CBB, "plane_gun1" },
    { 0xA183FD80, "plane_gun2" },
    { 0xC78677E9, "plane_gun3" },
    { 0x8592DBF6, "plane_gun4" },
    { 0xAB95565F, "plane_gun5" },
    { 0x398DE724, "plane_gun6" },
    { 0x48251229, "plane_guns" },
    { 0x956F032A, "plane_health" },
    { 0x3B4160C3, "plane_hind" },
    { 0x5F7C2B42, "plane_hind_think" },
    { 0x11B40E32, "plane_hinds" },
    { 0x696E0B7F, "plane_id" },
    { 0x426E71DA, "plane_inuse" },
    { 0x8DF38A8C, "plane_is_damaged" },
    { 0x08D25395, "plane_leave" },
    { 0x62F53852, "plane_loop" },
    { 0x34209C1E, "plane_loop_sound" },
    { 0x9259C54B, "plane_midair_deathfx" },
    { 0x8566E511, "plane_mode" },
    { 0xBBB129D5, "plane_mode_speed" },
    { 0x4F13390D, "plane_mortar_aim_assist_radius_sq" },
    { 0xE0CDF2EC, "plane_mortar_bda_dialog" },
    { 0xF2CD4583, "plane_mortar_delay" },
    { 0xB8155705, "plane_mortar_flight_radius" },
    { 0xB19ADFEC, "plane_mortar_flight_speed" },
    { 0x38971770, "plane_mortar_flight_time" },
    { 0xA3D30181, "plane_mortar_location_selector" },
    { 0xA9645E84, "plane_mortar_location_selector_done" },
    { 0xC9C8E3F1, "plane_mortar_model" },
    { 0x09714FF0, "plane_mortar_model_enemy" },
    { 0xE9B99A4C, "plane_mortar_selection_count" },
    { 0x841A8039, "plane_mortar_selection_radius" },
    { 0x987097C1, "plane_name" },
    { 0x6253B62F, "plane_nodes" },
    { 0xB24E5DE4, "plane_nodes1" },
    { 0x2455CD1F, "plane_nodes2" },
    { 0xFE5352B6, "plane_nodes3" },
    { 0x9CB4A881, "plane_normal" },
    { 0x66F04527, "plane_nose_fall" },
    { 0xADC8F2C1, "plane_nose_section" },
    { 0x4D3EF058, "plane_nose_section_friendlies_start" },
    { 0x5538767D, "plane_noteworthy" },
    { 0x6F6F47E0, "plane_nva_guys" },
    { 0xACB43233, "plane_nva_guys_monitor" },
    { 0x5DDF8A57, "plane_nva_guys_monitor_rpg" },
    { 0xA22707C9, "plane_nva_guys_think" },
    { 0x6ECA5DF8, "plane_objectives" },
    { 0x1C1B6957, "plane_on_curve" },
    { 0xD1DAF2FD, "plane_path" },
    { 0x071C08BC, "plane_paths" },
    { 0x0093976C, "plane_pieces_picked_up" },
    { 0x7938BABF, "plane_player_shoot" },
    { 0xFB17248E, "plane_pole" },
    { 0xE4118D16, "plane_pos" },
    { 0xCF355FA7, "plane_position_updater" },
    { 0x431DD331, "plane_prop_fx_timing" },
    { 0x02A3C0A4, "plane_push" },
    { 0x2EDBA507, "plane_radii" },
    { 0x51D662D0, "plane_ramp" },
    { 0x020B243E, "plane_ramp_lock" },
    { 0x846F93AF, "plane_rigging" },
    { 0x43790607, "plane_rumble" },
    { 0x7DE7B72C, "plane_search" },
    { 0x9F6E5049, "plane_search_warp" },
    { 0xB5E0AF5A, "plane_search_wing" },
    { 0xF91DC23D, "plane_section" },
    { 0xCDB25C18, "plane_seperation" },
    { 0xF0793E56, "plane_shake_player" },
    { 0x3C308429, "plane_shockwave" },
    { 0x0112E9F8, "plane_slines" },
    { 0xA413636C, "plane_sound_node" },
    { 0x50EF9CE5, "plane_spawn" },
    { 0x1B378A09, "plane_speed" },
    { 0x7D23E33B, "plane_spline" },
    { 0xC0A8D6DA, "plane_splines" },
    { 0x8E973485, "plane_steering" },
    { 0x070C54D1, "plane_strafe" },
    { 0x72225030, "plane_strafe_start" },
    { 0x80B92CA3, "plane_struct" },
    { 0xA59D4AF8, "plane_tag" },
    { 0x8CE9ED08, "plane_takeoff" },
    { 0x5898AA9B, "plane_takeoff_monitor" },
    { 0x7568A49C, "plane_taking_damage" },
    { 0x635B55FD, "plane_tilt" },
    { 0x13AEA47C, "plane_too_far" },
    { 0x702EFBA5, "plane_too_far_to_warp" },
    { 0x3ADEEEBF, "plane_tower" },
    { 0xAF0FEFC3, "plane_tower_aa_direct_fire" },
    { 0x1C7E9F57, "plane_tower_sound" },
    { 0x3C5A9398, "plane_tracer_burst" },
    { 0x59B1FE95, "plane_trap_click_fx" },
    { 0x068413E6, "plane_trap_fx" },
    { 0xE8EBC86E, "plane_trap_pilot" },
    { 0x507CC2C2, "plane_trap_vignette" },
    { 0xADD0BFBC, "plane_trigger" },
    { 0xAD2E507F, "plane_triggers" },
    { 0x2E470D82, "plane_truck_gunner_logic" },
    { 0x942F9110, "plane_type" },
    { 0x291071FB, "plane_types" },
    { 0xF50313DF, "plane_up" },
    { 0xFCFCE0F4, "plane_vals" },
    { 0xEFEAC211, "plane_vc" },
    { 0xC6218211, "plane_vc_rpg" },
    { 0x93434CA5, "plane_warped" },
    { 0x9C26B961, "plane_warpto" },
    { 0x20D3830F, "plane_whizby" },
    { 0x8081D73B, "plane_wingman_delay" },
    { 0x69A84343, "plane_wingman_offset" },
    { 0x6941AE59, "planeairstrikesounds" },
    { 0x268773CE, "planeawardscoreevent" },
    { 0x3D11390C, "planeawardscoreevent_singleton" },
    { 0x76761521, "planebombexplodedistance" },
    { 0x73E85838, "planecanfly" },
    { 0x7207931D, "planecraftable" },
    { 0x6D5F5EC2, "planedir" },
    { 0xA80DD2AD, "planeendingdistance" },
    { 0xAA5A7C95, "planeexit" },
    { 0x2C683A9D, "planeflyheight" },
    { 0x98AB0265, "planeflyspeed" },
    { 0xFC961815, "planefuelable" },
    { 0xBFF09FF0, "planefuelable_think" },
    { 0xC4001DFD, "planegostraight" },
    { 0x831DE2B3, "planehalfdistance" },
    { 0x33CF41DC, "planemodel" },
    { 0xFA29B58E, "planemortar" },
    { 0x3D63AF51, "planemortar_contrail" },
    { 0x9C8D119B, "planemortar_killstreakstop" },
    { 0xCB1D32CD, "planemortar_watchforendnotify" },
    { 0xC945E72D, "planemortarbda" },
    { 0x5C2FBFE3, "planemortarcomplete" },
    { 0x871AB78E, "planemortarexhaustfx" },
    { 0x1A13C41C, "planemortarpilotindex" },
    { 0x9690C631, "planemortars" },
    { 0x9C1E0E9F, "planenames" },
    { 0xF6BBBCEE, "planenapalmsounds" },
    { 0x2A1385AC, "planeposition" },
    { 0x56C86F8D, "planer" },
    { 0xCC066769, "planerewindobject" },
    { 0x3DB5E729, "planeright" },
    { 0x30C5F524, "planes" },
    { 0xB26C6D21, "planes_flying_strat" },
    { 0xC0B0F982, "planes_inited" },
    { 0x0DCC3A98, "planes_move" },
    { 0x358C82CD, "planeshadow" },
    { 0xBBC950CA, "planesound" },
    { 0xE1C00D05, "planesounds" },
    { 0xE2187C7C, "planespacing" },
    { 0xAD373CFF, "planespawncallback" },
    { 0x648E6DB9, "planespawnedfunction" },
    { 0xE32EB4D4, "planestartingdistance" },
    { 0x89C44B54, "planestarttime" },
    { 0xB341675F, "planestoploop" },
    { 0x90EDE4A7, "planestrike" },
    { 0x0AC37ABB, "planet" },
    { 0xDB9A496C, "planeturn" },
    { 0xC9ED4A5F, "planeturnleft" },
    { 0xF1803B7A, "planeturnright" },
    { 0x7447BF72, "planeturnsimple" },
    { 0xA5DC85FD, "planetype" },
    { 0xE29ECFDF, "planewatchforemp" },
    { 0x08C409DE, "planhumanarrivalatcover" },
    { 0xE9D0E9BB, "plank" },
    { 0x88668348, "plank1" },
    { 0xFA6DF283, "plank2" },
    { 0xD46B781A, "plank3" },
    { 0xBAF0B1F1, "plankb_cost" },
    { 0xC6B09646, "plankb_done" },
    { 0x550A125A, "planks" },
    { 0x103F370E, "planks_struct" },
    { 0xC85160B9, "planned" },
    { 0x4C38989F, "planner" },
    { 0xC5F98B6A, "planning" },
    { 0x7A0C6393, "plans" },
    { 0xA00EDDFC, "plant" },
    { 0x8C5F9458, "plant_all" },
    { 0x08028574, "plant_angle" },
    { 0xE2272B67, "plant_angles" },
    { 0xDA42A0DE, "plant_attempt" },
    { 0x0EC6B79E, "plant_bg" },
    { 0xF82E07A7, "plant_bomb" },
    { 0xFD017C5D, "plant_bomb_buttons" },
    { 0xD82A1A33, "plant_bomb_detach" },
    { 0xDD146CB1, "plant_bomb_hud" },
    { 0x93889315, "plant_bomb_power" },
    { 0xDDF9F8CC, "plant_bomb_radius" },
    { 0xAE7540FC, "plant_bomb_z" },
    { 0x1864DB92, "plant_c4" },
    { 0x999BE7DD, "plant_c4_death" },
    { 0xF5CCF8CE, "plant_c4_notetrack" },
    { 0x107681C7, "plant_c4_on_roof" },
    { 0xDE65793A, "plant_c4_spawn" },
    { 0x02635097, "plant_c4_think" },
    { 0xF2A92DE6, "plant_c4_trigger_think" },
    { 0xB82B6F3D, "plant_charge_animation_think" },
    { 0xCE06042D, "plant_charge_bar" },
    { 0x59DD1CF0, "plant_charge_bar_thread" },
    { 0x87375CFE, "plant_charge_think" },
    { 0x8354D2B4, "plant_charge_ticker_sound" },
    { 0x74A3A676, "plant_charge_trigger_hint" },
    { 0xDBDD5206, "plant_explosive_dome" },
    { 0x806B38BF, "plant_explosive_dome_scene" },
    { 0x61DA0BC2, "plant_explosive_dome_stairs_scene" },
    { 0xD9107D02, "plant_fg" },
    { 0x3646E4D7, "plant_first_sound" },
    { 0xFAC29271, "plant_flag" },
    { 0x8D6B0843, "plant_gravity_trap" },
    { 0xCB17A3E9, "plant_indicators" },
    { 0x692903D9, "plant_origin" },
    { 0x560DC263, "plant_parent" },
    { 0x533F7C02, "plant_price" },
    { 0x9B71E237, "plant_semtex" },
    { 0x352FDD78, "plant_sound" },
    { 0x530DF178, "plant_sound_interval" },
    { 0x1C6666BE, "plant_the_c4" },
    { 0x7F843D07, "plant_title" },
    { 0xF984E17C, "plantbomb_button_pressed" },
    { 0x10C648DF, "planted" },
    { 0xE65CE746, "planted_bomb" },
    { 0x0F4168F3, "planted_buildables_pickedup" },
    { 0x2BF1FD2A, "planted_claymore" },
    { 0x384C9041, "planted_ent" },
    { 0x74E2FA23, "planted_intruder" },
    { 0xCC984AC1, "planted_model" },
    { 0x6E9358A7, "planted_on_ent" },
    { 0xA4527930, "planted_wallmount_on_a_zombie" },
    { 0x8CDF10F9, "planter" },
    { 0xB69C3142, "planter1" },
    { 0x9099B6D9, "planter2" },
    { 0xE485F61A, "planter_battle" },
    { 0x35612080, "planter_battle_end" },
    { 0x2EC6EF97, "planter_battle_finished" },
    { 0xE9F8A230, "planters" },
    { 0x3293B926, "planters_fall_back" },
    { 0xAF7D74C6, "planters_left_back" },
    { 0x9E68AA3F, "planters_left_mid" },
    { 0xFF9285BF, "planters_right_back" },
    { 0xA7999F0C, "planters_right_rear" },
    { 0xAC0779CC, "planting" },
    { 0x5F9FE2BC, "planting_beartrap_mortar" },
    { 0x0ADF39F7, "planting_done" },
    { 0x29358D9E, "planting_dynamite" },
    { 0xED532CFB, "planting_ied" },
    { 0xDFE1935F, "plantingnetworkintruder" },
    { 0x9031E005, "plantingteamdead" },
    { 0x463523BF, "plants" },
    { 0xADC6E96F, "planttime" },
    { 0xF919F008, "plantweapon" },
    { 0x25F2A7DE, "plaster" },
    { 0x4EA1105B, "plate" },
    { 0xEE840995, "plate_state" },
    { 0x5334A352, "plate_thread" },
    { 0x29557A7A, "plates" },
    { 0xC4A4DEA7, "plates_active" },
    { 0x298023D0, "platform" },
    { 0x2A43E729, "platform1" },
    { 0x50466192, "platform2" },
    { 0x7648DBFB, "platform3" },
    { 0xF8128932, "platform_collapse" },
    { 0xC7A31E8D, "platform_death_triggers" },
    { 0x20EE2AB3, "platform_dialog" },
    { 0xEE97CF63, "platform_force_death" },
    { 0xA8AA10F7, "platform_hits_deck" },
    { 0xD4E5568C, "platform_jumpto" },
    { 0x8B70705A, "platform_name" },
    { 0xCCB74DE5, "platform_start" },
    { 0x985798EA, "platform_start_first_target" },
    { 0xE9A8AF4F, "platform_switches" },
    { 0x3823BC4B, "platform_targets" },
    { 0x1564576C, "platform_targets_ents" },
    { 0x0B116754, "platform_targets_structs" },
    { 0xA383AEE8, "platform_triggers" },
    { 0x57EE9F2E, "platformbuttonpressed" },
    { 0x03AC7754, "platformers" },
    { 0x6E2DA1C8, "platforming" },
    { 0xF5AA41BB, "platforms" },
    { 0xACA656DD, "platforms_non_switched" },
    { 0x6E143534, "platforms_total" },
    { 0xA6C83352, "platoon" },
    { 0xBC6BB542, "platoon_leader" },
    { 0x43718187, "play" },
    { 0xEA1BEEAC, "play_2d_on_team" },
    { 0x382C8F67, "play_2nd_fx" },
    { 0x6B81D75E, "play_a_word" },
    { 0x85DF5696, "play_acknowledge_anim" },
    { 0xACFCB580, "play_action_music" },
    { 0x2FCF8008, "play_activate_done" },
    { 0xAA572593, "play_added_ambience" },
    { 0xB637D37F, "play_additional_crowd" },
    { 0x8D23F2B6, "play_additive_anim" },
    { 0xA28E0413, "play_afterburner_fx" },
    { 0x9F796690, "play_air_raid_scene" },
    { 0xD0C124B1, "play_alarm" },
    { 0x3CA752D2, "play_alarm_audio" },
    { 0x675D2710, "play_alarm_sounds" },
    { 0x29B88E0E, "play_alarms_offset" },
    { 0x29299F97, "play_aligned_fx" },
    { 0xEACC839F, "play_all" },
    { 0x48D1A117, "play_all_deck_effects_snipe_skipto" },
    { 0x849EB4C6, "play_alouette_sounds" },
    { 0x353341F8, "play_amb_vox" },
    { 0x1402B05C, "play_ambient_alarm" },
    { 0x98197B8F, "play_ambient_brutus_vocals" },
    { 0xAE3FD797, "play_ambient_leaper_vocals" },
    { 0x3B04BA85, "play_ambient_mechz_vocals" },
    { 0xB5CB1394, "play_ambient_planes" },
    { 0xEA763FE4, "play_ambient_vo" },
    { 0x5F6586CC, "play_ambient_zombie_vocals" },
    { 0x2E92A65E, "play_ambulence_light_fx" },
    { 0x9F4EC9CC, "play_and_loop_cheer_anim" },
    { 0x27D070CD, "play_anim" },
    { 0x0B961AF7, "play_anim_at_cover" },
    { 0xD27F5E1F, "play_anim_end_early" },
    { 0xB44D61F5, "play_anim_generic_human" },
    { 0xCFFE25B3, "play_anim_internal" },
    { 0xA7E31915, "play_anim_mychanges" },
    { 0x9CE82F98, "play_anim_on_civ" },
    { 0xC93898CE, "play_anim_pause_and_zoom" },
    { 0xC734122F, "play_anim_player" },
    { 0x6631A5F8, "play_anim_scene" },
    { 0x803009D0, "play_anim_thread" },
    { 0x7A95D6DB, "play_anim_vehicles" },
    { 0x5F70476C, "play_animation" },
    { 0x17F64113, "play_apache_sounds" },
    { 0x6EE27B39, "play_aquarium_breach" },
    { 0xEB49005D, "play_armory_alarm_audio" },
    { 0x05F0CB2B, "play_arrive_sound" },
    { 0x3E9E6AF6, "play_arty_sound" },
    { 0x84F521C2, "play_attack_ai_sounds" },
    { 0x75AE4F3E, "play_attack_impacts" },
    { 0x8024A295, "play_attacker_anim" },
    { 0xD7801B3D, "play_attacker_banzai_failed" },
    { 0x157E3179, "play_attacker_banzai_succeeded" },
    { 0x891887DC, "play_attacker_impact" },
    { 0xD2D34778, "play_attacker_intro" },
    { 0x481B7666, "play_attacker_knockdown" },
    { 0x0956FEB8, "play_audio_one_shot" },
    { 0xB70F4C34, "play_avalanch_sound" },
    { 0x5358B9AD, "play_avalanche_close_loop" },
    { 0xF8F4ACDE, "play_backwards_children" },
    { 0x6D2865DA, "play_banzai_ai_attacker_anim" },
    { 0xEAC89946, "play_banzai_ai_attacker_anim_custom_script" },
    { 0x7E4E846E, "play_banzai_ai_defender_anim" },
    { 0x4FCDCDD2, "play_banzai_ai_defender_anim_custom_script" },
    { 0x774E1209, "play_banzai_rumble" },
    { 0x705A263A, "play_barge_explosion_fx" },
    { 0x9D2CC3D5, "play_barrel_push" },
    { 0x441D54A0, "play_barrel_push_first_frame" },
    { 0xD62A02FC, "play_base_amb" },
    { 0x43E3AFC9, "play_base_explosion" },
    { 0x33E66E86, "play_base_fx" },
    { 0x76C5725A, "play_bat_sounds" },
    { 0x2BB6005C, "play_battle_convo" },
    { 0x86B69901, "play_battle_convo_from_array_until_flag" },
    { 0x17385F5A, "play_battle_convo_until_flag" },
    { 0xF8E059F3, "play_bayonet_death_anim" },
    { 0x30D9D7C4, "play_bda_dialog" },
    { 0x1BD9F9D1, "play_be_hit_vox" },
    { 0xEBE1C485, "play_bear_fx" },
    { 0xF1007AC5, "play_beeps" },
    { 0x01133F8D, "play_bell_rings" },
    { 0xF8263BF9, "play_bell_sound" },
    { 0x85A78B27, "play_bell_toll_sound" },
    { 0x9D474027, "play_big_splash_fx" },
    { 0x65A10074, "play_bink_for_time" },
    { 0x629DC25A, "play_bink_on_hud" },
    { 0xCA69EDB3, "play_bleed_loop" },
    { 0x8CD909B3, "play_blended_death" },
    { 0x6EB00F47, "play_blood_fx" },
    { 0x446FB2ED, "play_blood_on_machete_dude" },
    { 0x2E744872, "play_blood_screen_fx" },
    { 0x447A44CD, "play_boat_wake_effect" },
    { 0x9EA86239, "play_bonfiresale_audio" },
    { 0x2D842FCF, "play_boost" },
    { 0x309B34F0, "play_boost_fx" },
    { 0x4310A812, "play_boost_start_response_vox" },
    { 0x5C7B36B8, "play_boost_start_vox" },
    { 0xD8F485B5, "play_boost_vox" },
    { 0x78FC5FCD, "play_bootup" },
    { 0x3E4D9D56, "play_bowie_pickup_dialog" },
    { 0x2ED28D8D, "play_branch_break_audio" },
    { 0xA7489792, "play_breach_fx" },
    { 0x2DCB0420, "play_breathing" },
    { 0x4D42589E, "play_breathing_aparatus" },
    { 0x5B8B2E3E, "play_bridge_audio" },
    { 0x8E5151DB, "play_bubbles" },
    { 0xC57A7325, "play_bullet_hitting_water_fx" },
    { 0x01C55DD6, "play_bullet_impacts" },
    { 0xFFCAC97A, "play_bulletgibbed_death_anim" },
    { 0xD85F8FB3, "play_burst_fake_fire" },
    { 0x4832CB1D, "play_camera_mark_sound" },
    { 0xD88A9A9D, "play_camo_dialog" },
    { 0xF642C252, "play_canister_fx" },
    { 0x7E69DE0F, "play_cap_fx" },
    { 0x8BBCC1DC, "play_car_radio" },
    { 0xB9916EAF, "play_cart_movement_audio" },
    { 0xB70C8395, "play_cart_randoms" },
    { 0x2FDCBF84, "play_category_on_player_character_if_present" },
    { 0x64BAD762, "play_cave_stinger" },
    { 0x1DF4D35B, "play_cb_chatter" },
    { 0x3FE1D5B3, "play_ceiling_water_splash" },
    { 0x9D2BCFD7, "play_center_car_anims_middle" },
    { 0x87FC37E9, "play_center_car_anims_side" },
    { 0x358C9E8F, "play_chair_distress_anim" },
    { 0x56A9AF50, "play_chandelier_fx" },
    { 0x49CA7D28, "play_chandelier_fx_internal" },
    { 0x2FE3F174, "play_characters_skits_etc" },
    { 0xF4F51F07, "play_charge_fx" },
    { 0x38396CE8, "play_charge_vo" },
    { 0x3AF8396F, "play_cheer_vox" },
    { 0x9FAAFA56, "play_children_chant" },
    { 0x9CDE5206, "play_chinook_sounds" },
    { 0xB4D26376, "play_chinook_spark_fx" },
    { 0x723AD690, "play_choking_loop" },
    { 0xFD8C740A, "play_chopper_accel" },
    { 0x9669D1D0, "play_civ_lines" },
    { 0x5E4822E9, "play_civilian_yells" },
    { 0xFB3C3FB5, "play_claymore_effects" },
    { 0xE64C30FD, "play_climb_into_boat_anim" },
    { 0x641E7993, "play_clock_gongs" },
    { 0x527BF5DF, "play_clock_sounds" },
    { 0x635B0540, "play_closedamage_dialog" },
    { 0xBFA5B985, "play_closekill_dialog" },
    { 0xB15C4514, "play_club_lowend_until_door" },
    { 0x776B850A, "play_coming_out_of_water_wake_fx" },
    { 0xFE9CFC9E, "play_comp_sounds" },
    { 0xF67998E8, "play_concrete_fx" },
    { 0x046C51B6, "play_concussion_sound" },
    { 0x63802792, "play_confirm" },
    { 0xF6F4048A, "play_cooldown_fx" },
    { 0x3CF7B8C9, "play_cosmo_announcer_vox" },
    { 0x706227EC, "play_cougar_heartbeat" },
    { 0xA61EC42F, "play_count" },
    { 0x7A7A6059, "play_counter_attack" },
    { 0x0E371AFB, "play_crane_hit" },
    { 0xFE77C3EA, "play_crashing_loop" },
    { 0x7E3FE9E1, "play_crazi_sound" },
    { 0x0530FBF7, "play_credit_song" },
    { 0x58BB3908, "play_credits" },
    { 0xD13CBFFC, "play_credits_music" },
    { 0xDA86FBD6, "play_creek_object_anim_firstframe" },
    { 0x784C87F1, "play_creek_object_anim_loop" },
    { 0x64B8344B, "play_creek_object_anim_single" },
    { 0x894586F8, "play_creek_object_anim_single_frameskip" },
    { 0x73E7E72E, "play_creek_uw_raining" },
    { 0x7D778A4F, "play_crow_flyaway_delay" },
    { 0x568D5BD9, "play_crowd_sound" },
    { 0x6F42F629, "play_custom_events" },
    { 0xFBFC2B97, "play_damage_fx_on_boat" },
    { 0x9D75B156, "play_damage_fx_on_chase_boat" },
    { 0x3A51499C, "play_damage_state_effects" },
    { 0x715415C5, "play_dbltap_shout" },
    { 0x620DFD64, "play_death_anim" },
    { 0xA4177C2D, "play_death_anim_fx" },
    { 0x59870A4F, "play_death_audio" },
    { 0x4D5564EC, "play_death_fire_loop" },
    { 0x7937BBCC, "play_death_fx_on_turret" },
    { 0x7057553A, "play_death_vo" },
    { 0xC42D97D6, "play_death_vox" },
    { 0xDFB4AAF7, "play_defcon5_alarms" },
    { 0xF7A44B0C, "play_delayed_activate_sound" },
    { 0xE2291272, "play_delayed_breach_vox" },
    { 0xA1E4F8B6, "play_delayed_cheer" },
    { 0xE76160F8, "play_delayed_explode_vox" },
    { 0x8A07C80B, "play_delayed_first_time_vox" },
    { 0xCCEAA87D, "play_delayed_impact_sound" },
    { 0xE04DE05E, "play_delayed_opening_audio" },
    { 0xFE17AB24, "play_delayed_sound" },
    { 0x46FCFF2F, "play_delayed_stop_sound" },
    { 0x67EAF329, "play_delayed_tank_land" },
    { 0x97AB305C, "play_demo_intro_anim" },
    { 0x8FEA8FD5, "play_deploy_anim" },
    { 0xA120A37A, "play_deploy_anim_after_wait" },
    { 0x3F4C5116, "play_destroyed_dialog_on_owner" },
    { 0x78562587, "play_detonator_light" },
    { 0xA1AE6973, "play_devil_dialog" },
    { 0x3001A972, "play_dialog" },
    { 0x541DB26E, "play_digbat_dialog" },
    { 0x88E64937, "play_digger_start_vox" },
    { 0xAEF41382, "play_distant_battle" },
    { 0xE88C2C60, "play_distant_battle_bg_until_jump" },
    { 0xA87FB0EE, "play_distant_battle_sound" },
    { 0xAC11A9FE, "play_distant_battle_track" },
    { 0x17F41477, "play_distant_bombs" },
    { 0x76F8EF9C, "play_distant_chaos" },
    { 0xFEFBDC7F, "play_dks_must_die" },
    { 0xF62EB7FD, "play_dog_round" },
    { 0x565B80E8, "play_dog_sound" },
    { 0x306809DF, "play_door_alarms" },
    { 0xE63D4E2B, "play_door_bang" },
    { 0xADB8C32F, "play_door_beating" },
    { 0x059F0611, "play_door_dialog" },
    { 0x9FEEC41E, "play_door_kill_audio" },
    { 0xE50654D2, "play_door_looper" },
    { 0x932B7724, "play_dradis_bink" },
    { 0x8A80EC40, "play_drag_wake_fx" },
    { 0x1E818FA9, "play_dragging_sound" },
    { 0x3BC47F8C, "play_drive_particle_fx" },
    { 0x789B5418, "play_driving_fx" },
    { 0x8185750C, "play_driving_fx_firstperson" },
    { 0xC7EDD6E9, "play_driving_fx_thirdperson" },
    { 0xF568DAB9, "play_driving_rumble" },
    { 0x99F36CEB, "play_driving_screen_fx" },
    { 0x04EC6854, "play_drone_control_tones" },
    { 0x16851917, "play_drone_control_tones_single" },
    { 0xCCF8860D, "play_drone_reply" },
    { 0x0E0BEEC5, "play_drone_swarm" },
    { 0xE76FCFE7, "play_drone_swarm_old" },
    { 0xB5C45468, "play_drone_yells" },
    { 0x554562DF, "play_dust_fx" },
    { 0x750D1B2B, "play_dust_fx_near_players" },
    { 0x57002D83, "play_eagle_slip_sound" },
    { 0x321F0D6F, "play_egg_vox" },
    { 0x335CFF03, "play_elec_room_sweets" },
    { 0x31CF6D6A, "play_elec_vocals" },
    { 0x13E561C8, "play_electrical_sound" },
    { 0x69710B56, "play_elevator1_audio" },
    { 0x2FF3B941, "play_elevator2_audio" },
    { 0x59BE7950, "play_elevator_03_anim" },
    { 0xF51445AC, "play_emitter" },
    { 0x3175AF58, "play_end_lines_in_order" },
    { 0xA4076C1D, "play_end_music" },
    { 0xA4DFA04B, "play_end_sequence" },
    { 0x0EFC82AD, "play_end_street_music" },
    { 0x680F9D36, "play_endfight_animation" },
    { 0x8B0436E2, "play_endfight_animation_player" },
    { 0x6C55ACF1, "play_endfight_animation_props" },
    { 0x64B88A2B, "play_endlevel_igc" },
    { 0x3230FC15, "play_enemies_at_the_door" },
    { 0xB187134F, "play_engine_audio" },
    { 0xE1E5B23B, "play_engineer_anim" },
    { 0xB2A378ED, "play_environmental_fire" },
    { 0x26C397F6, "play_environmental_sound" },
    { 0xD0C1F3EA, "play_equipment_destroyed_on_player" },
    { 0x4BD6BE09, "play_equipment_hacked_on_player" },
    { 0x96DF13AF, "play_escape_anim_watch_for_hit" },
    { 0x25E49F31, "play_evil_generator_audio" },
    { 0x7837E02A, "play_evt_1_screams" },
    { 0x574D5930, "play_evt_4_civs_run" },
    { 0x184FEC40, "play_exhaust" },
    { 0xFF742961, "play_exploder" },
    { 0x72FD5B08, "play_exploders" },
    { 0xE4303B10, "play_explosion_death" },
    { 0x376DF3C8, "play_explosion_death_anim" },
    { 0xD02BB246, "play_explosion_dialog" },
    { 0x86DD97B9, "play_explosion_on_cougar_climb" },
    { 0xCC5F3103, "play_extra_dust" },
    { 0x2FBDBD40, "play_extra_lines_and_end" },
    { 0xEAE3F784, "play_eye_scan_fx" },
    { 0x1DE420DE, "play_f35_fire_sounds" },
    { 0x604980D7, "play_f35_la2_sounds" },
    { 0x49D22C4D, "play_f35_loop" },
    { 0xFDD54B53, "play_f35_sounds" },
    { 0x1D1DB2DF, "play_f35_vtol_sounds" },
    { 0xEA28B68E, "play_face_water_drops" },
    { 0xF472B8DA, "play_fade_ending" },
    { 0x4C6CC99C, "play_fade_getting_out" },
    { 0x044A54E6, "play_fade_in_helicopter" },
    { 0xFF664FD8, "play_fade_map_picture" },
    { 0xB9EF4F98, "play_fade_woods_dead" },
    { 0x2D2E3F78, "play_fail_vo" },
    { 0xDF6BC926, "play_fake_battle" },
    { 0x711BFD3D, "play_fake_battlechatter" },
    { 0x127EA09D, "play_fake_conversation" },
    { 0x745C5BB4, "play_fake_death_vox" },
    { 0xE88A6C20, "play_fake_flyby" },
    { 0x60BC848D, "play_fake_japanese_battlechatter" },
    { 0xF0872875, "play_fake_rpg_sound" },
    { 0xAC906D5F, "play_fake_vox" },
    { 0x5E911701, "play_fall_sound" },
    { 0x170DAAB1, "play_fallingdebris_fire" },
    { 0xA9F33918, "play_fallingdebris_fires" },
    { 0x619D054E, "play_far_loop" },
    { 0x7AEDE28C, "play_fast_rope_fx" },
    { 0xF0B248D4, "play_fault_vo" },
    { 0x4ADE9F9C, "play_feather_fx" },
    { 0xCCD443BA, "play_final_killcam" },
    { 0xB4C5C31D, "play_final_numbers" },
    { 0xFF2E8AFB, "play_fire_fx" },
    { 0xA05FA742, "play_fire_left" },
    { 0x613A1384, "play_fire_loopers_on_fx" },
    { 0x240E2616, "play_fire_loops" },
    { 0xFC13E367, "play_fire_on_enemy" },
    { 0xE81675B1, "play_fire_right" },
    { 0x850EC45A, "play_fire_rocket_loop" },
    { 0xC5D41372, "play_fire_sound" },
    { 0x59EDAFFD, "play_fire_sounds" },
    { 0xB7CD0832, "play_fired_sound" },
    { 0x0FB5DD17, "play_firedeath_screams" },
    { 0xFDEE5C24, "play_firesale_audio" },
    { 0xC0F41BCB, "play_firescout_sounds" },
    { 0x4B69BB09, "play_flak_field" },
    { 0x28944B88, "play_flame_death_anim" },
    { 0xD1437B73, "play_flame_tree_loop" },
    { 0x5076A473, "play_flamethrower_dialog" },
    { 0x2E0E852A, "play_flare_effect" },
    { 0x21138B3A, "play_flares_fx" },
    { 0x846D3F59, "play_flashlight_fx" },
    { 0x91234BCB, "play_flashlight_fx_player" },
    { 0x4ECE7552, "play_flicker" },
    { 0xF0FEB98C, "play_flinger_dialog" },
    { 0xA71D2546, "play_floor2_walla" },
    { 0x75CDE2E7, "play_flux_whispers" },
    { 0x77AF6B09, "play_footfx_up_tree_left" },
    { 0xC89C9134, "play_footfx_up_tree_right" },
    { 0x18889160, "play_fridge_dust" },
    { 0x5C13E9EB, "play_fuselage_water_hit_0" },
    { 0x36116F82, "play_fuselage_water_hit_1" },
    { 0x100EF519, "play_fuselage_water_hit_2" },
    { 0x61C0E984, "play_futz_or_not_moonvox" },
    { 0xC0906A58, "play_fx" },
    { 0x05B4DC81, "play_fx_anim_bush" },
    { 0xA0BA4999, "play_fx_anim_on_trigger" },
    { 0x10A4C81A, "play_fx_at_ground" },
    { 0xE1990E2A, "play_fx_dive_under" },
    { 0x95D83389, "play_fx_for_all_clients" },
    { 0x33518439, "play_fx_idle" },
    { 0x15F9F00B, "play_fx_idle_end" },
    { 0x35A00B28, "play_fx_idle_start" },
    { 0x26BC4EA2, "play_fx_on_destructible_death" },
    { 0x46F185E1, "play_fx_on_impact_point_not_joint" },
    { 0x92F40071, "play_fx_on_tag" },
    { 0x5F325D5C, "play_fx_on_tag_check" },
    { 0xDF3BDBAB, "play_fx_prop_anims" },
    { 0x829D1F88, "play_fx_rise_up" },
    { 0x67D93956, "play_fx_splash_left" },
    { 0x8AB33E2D, "play_fx_splash_right" },
    { 0x6C1C55B9, "play_fx_wake_end" },
    { 0xE2F03452, "play_fx_wake_start" },
    { 0x59B12EE1, "play_fx_when_shown" },
    { 0x6F2A9227, "play_fxanim_building_rubble" },
    { 0x628A3486, "play_gadget_activate" },
    { 0x4E06C732, "play_gadget_ready" },
    { 0x0419D3DE, "play_gadget_success" },
    { 0x7FD6AA3A, "play_gas_death_anim" },
    { 0xAA7723D8, "play_general_chatter" },
    { 0x101E3E61, "play_generator" },
    { 0xD2D0090C, "play_giant_mythos_lines" },
    { 0x422374F2, "play_giant_waterfall" },
    { 0xBCBC0ABE, "play_glass_break_effect" },
    { 0x3F66D3E7, "play_glint_fx" },
    { 0xE988F4D2, "play_go_go_go" },
    { 0x05E145F3, "play_going_down_vo" },
    { 0x8F9AB8F5, "play_gr_eject_impact_player_fx" },
    { 0x62377910, "play_gramophone_place_vo" },
    { 0xF88C3289, "play_grenade_light" },
    { 0xB2180F88, "play_groan_sounds" },
    { 0x4297CFD3, "play_group_vox_on_guy" },
    { 0xE25531C0, "play_gun_shot_fx_rumble" },
    { 0xED5233CA, "play_gun_shot_fx_rumble_farid_death" },
    { 0x196B6DD4, "play_gunner_audio" },
    { 0xB71EA01A, "play_gunner_sounds" },
    { 0x0D528B5C, "play_guy_falling_water_death" },
    { 0xC7EA2615, "play_guy_falling_water_death_fx" },
    { 0xE5BAD3A2, "play_hacking_sounds" },
    { 0x630C2F19, "play_halftrackhack" },
    { 0x34CC2CF7, "play_harper_blood_pool_fx" },
    { 0x5CC98E64, "play_hatch_anim" },
    { 0xEFE30CAF, "play_hatch_anim_open" },
    { 0xF35EAD93, "play_headshot_dialog" },
    { 0x46E626A5, "play_headshot_response_hero" },
    { 0x138211D7, "play_headshot_response_rival" },
    { 0xF8A30C61, "play_heart_beat" },
    { 0x25E5980E, "play_heartbeat" },
    { 0xF1C05C79, "play_heartbeat_drone" },
    { 0xE507B136, "play_heli_crash_sound" },
    { 0x15EF1579, "play_heli_ext_sounds" },
    { 0xF133650C, "play_heli_fires" },
    { 0x35B9B823, "play_heli_future_sounds" },
    { 0x605975F7, "play_heli_guard_sounds" },
    { 0xB011BF0D, "play_heli_intro" },
    { 0x67654D1F, "play_heli_intro_rumble" },
    { 0x851AC552, "play_heli_osprey_rts_sounds" },
    { 0xC826A546, "play_heli_osprey_sounds" },
    { 0xEF692989, "play_heli_sounds" },
    { 0x06CAF2F2, "play_heli_sounds_blackhawk" },
    { 0x6CC13439, "play_heli_sounds_huey_player" },
    { 0x32ED069F, "play_heli_sounds_vtol" },
    { 0x6F72401D, "play_heli_spin" },
    { 0xDF73E063, "play_helo_ambient_elements" },
    { 0x5FCE19AF, "play_hind_enemy_sounds" },
    { 0xBFC58458, "play_hind_sounds" },
    { 0x19E51901, "play_hind_sounds_vorkuta" },
    { 0x4E02DA5C, "play_hind_sounds_zombietron" },
    { 0x1F444E50, "play_hip_sounds" },
    { 0xBF8862FA, "play_hit_by_vehicle_anim" },
    { 0xEF06A663, "play_horse_anim" },
    { 0x28888B50, "play_horse_sounds" },
    { 0xBA5A371B, "play_hospital_ambience" },
    { 0xAD80469B, "play_house_debris_sounds" },
    { 0x0702A1B6, "play_hudson_punch_special" },
    { 0x5668E740, "play_hudson_rock_climb_anims" },
    { 0x52A3D628, "play_huey_sounds" },
    { 0x80CB37A9, "play_huey_toda_sounds" },
    { 0x956FDA56, "play_huey_woods_sound" },
    { 0x87118343, "play_hurt_vox" },
    { 0xF83A6D88, "play_hut_vc_dialog" },
    { 0x47CF8841, "play_id" },
    { 0xBC002970, "play_idle" },
    { 0x7F528EEF, "play_idle_bink_on_bridge_console" },
    { 0x652D5510, "play_idle_wake_fx" },
    { 0x1F23A4F1, "play_il2_flying" },
    { 0xFD3389E0, "play_im_watching_anim" },
    { 0x8B02A798, "play_images" },
    { 0x6A5BEB44, "play_imp_sound" },
    { 0x0C985410, "play_impact_sound" },
    { 0x9270409F, "play_in_3d" },
    { 0x2B67C264, "play_in_space" },
    { 0x3FC9044E, "play_incoming_sound" },
    { 0xB50A3AB4, "play_initial_alarm" },
    { 0x13BEB242, "play_initial_water_ripples" },
    { 0x2C76F1C8, "play_insane_scream" },
    { 0xB53DA50D, "play_insta_melee_dialog" },
    { 0x2E35A6B5, "play_instrument" },
    { 0x1980F285, "play_int_dmg_fx" },
    { 0xEA41CDFE, "play_interrogation_player_anims" },
    { 0x246D1176, "play_intro_alarm" },
    { 0xCCCC34A1, "play_intro_and_animation" },
    { 0xDC11B8CA, "play_intro_blockout_pa_vox" },
    { 0x98CFE052, "play_intro_cinematic" },
    { 0x44CB0BF8, "play_intro_dialog_line" },
    { 0xE1EAB8DD, "play_intro_guy_death_anim" },
    { 0x5712E4E2, "play_intro_igc" },
    { 0x999BD015, "play_intro_movie" },
    { 0x3757C044, "play_intro_music" },
    { 0x58014E37, "play_intro_on_all_players" },
    { 0xDB60FE80, "play_intro_on_player" },
    { 0x02EE4424, "play_intro_radio" },
    { 0x1C1C2A80, "play_intro_sequence" },
    { 0x1994CB5E, "play_intro_vo" },
    { 0x2A38CD5F, "play_it_cool" },
    { 0xF8B22E69, "play_item_meat_on_spawn_retrieve_trigger" },
    { 0x6AA65829, "play_jeep_ride_hack" },
    { 0xDAE947FD, "play_jetwing_sounds" },
    { 0x3DBA9E04, "play_jingle_or_stinger" },
    { 0x4931F09E, "play_jugga_shout" },
    { 0xD3EE6A1E, "play_jump_anim" },
    { 0xE37740DA, "play_jump_land_heavy" },
    { 0xE084D524, "play_jumping_into_water_fx" },
    { 0x45E0E10E, "play_killstreak_being_hacked_dialog" },
    { 0xB0BF60E3, "play_killstreak_dialog" },
    { 0x73EC0919, "play_killstreak_firewall_being_hacked_dialog" },
    { 0x85AC4F09, "play_killstreak_firewall_hacked_dialog" },
    { 0x2B9B5D0E, "play_killstreak_hacked_dialog" },
    { 0x20BEF117, "play_killstreak_ready_dialog" },
    { 0x16E832F0, "play_killstreak_ready_sfx" },
    { 0x40EA8068, "play_killstreak_start_dialog" },
    { 0x97264E7B, "play_killstreak_threat" },
    { 0xAE821CBE, "play_killstreak_vo" },
    { 0x1E4C332E, "play_knife_stinger" },
    { 0xDEE07B82, "play_land_fx" },
    { 0x4E86097F, "play_land_pby" },
    { 0x08AA1C99, "play_landed_animation" },
    { 0x620357EE, "play_landed_woods_animation" },
    { 0xA69792CC, "play_landing_shake" },
    { 0xB11472C1, "play_landing_shake_only" },
    { 0x71F10E60, "play_launch_unlock_vox" },
    { 0x2CBD9403, "play_lava_audio" },
    { 0x8FD33DFA, "play_leaving_base" },
    { 0xACADD7E3, "play_leaving_battlefield_alarm" },
    { 0x728A4ECB, "play_legs_anim" },
    { 0xB2937D36, "play_level_easteregg_vox" },
    { 0x9FF3778E, "play_level_ending" },
    { 0xEAFC3FB4, "play_level_start_vox_delayed" },
    { 0x2CBFF77A, "play_lift_screams" },
    { 0xA8490EAB, "play_light_fx" },
    { 0xE4955A1A, "play_light_rumble" },
    { 0xBCF7E962, "play_light_sound" },
    { 0xF377C62F, "play_light_sound_alias" },
    { 0x84B2CEB9, "play_line_if_player_can_see" },
    { 0x23CA73D1, "play_line_now" },
    { 0x73E47EAE, "play_line_on_nearby_player" },
    { 0xE365E60A, "play_line_on_player_character_if_present" },
    { 0x47AA98CE, "play_littlebird_sounds" },
    { 0x55D9D3A1, "play_loading_test" },
    { 0xFC6333AC, "play_locked_sound" },
    { 0x212D1D6B, "play_lockon_sounds" },
    { 0x6C74449E, "play_lockout_bink" },
    { 0x908278FE, "play_loop_on_machine" },
    { 0xD19396E1, "play_loop_sound_on_destructible" },
    { 0x58AB438E, "play_loop_sound_on_entity" },
    { 0xAD851849, "play_loop_sound_on_tag" },
    { 0x5B847BC2, "play_loop_spark" },
    { 0x09224AE1, "play_looped_fx_on_tag" },
    { 0x63739AAD, "play_looping_alarms" },
    { 0xFF0BA1BD, "play_looping_fx_on_ent" },
    { 0x437C853E, "play_looping_fx_on_tag" },
    { 0xF67CA891, "play_looping_visor_text_audio" },
    { 0x867135BD, "play_loops_for_player" },
    { 0x1C5941A9, "play_loopsound_on_ent" },
    { 0x045A7678, "play_loopsound_while_resonating" },
    { 0xB9E4D616, "play_low_health_fx" },
    { 0xE700A33A, "play_low_plane_sounds" },
    { 0x80D366EC, "play_lwing_water_hit_0" },
    { 0xA6D5E155, "play_lwing_water_hit_1" },
    { 0xCCD85BBE, "play_lwing_water_hit_2" },
    { 0xDE7E0F01, "play_m202_guy_drop_m202" },
    { 0xBF6FD15A, "play_m202_guy_kill_blood_fx" },
    { 0x4F70148A, "play_machete_melee_gib_death_anim" },
    { 0x49995A21, "play_magic_box_tv_audio" },
    { 0x9AAC0F42, "play_magic_rpgs" },
    { 0x0C1C154A, "play_main_area_pa_muzak" },
    { 0x07070DF7, "play_maskon_vox" },
    { 0x2E257F00, "play_massive_rumble" },
    { 0x2B96EB30, "play_maxis_audio_log" },
    { 0x3070C48D, "play_meat_glow" },
    { 0x9EBA6BEE, "play_melee_attack_animation" },
    { 0xC0E427D0, "play_meleefx" },
    { 0x31AD6633, "play_meteor_loop" },
    { 0xC09F0854, "play_metro_arty_sound" },
    { 0x70D6CFC0, "play_metro_rats_sound" },
    { 0x723D843C, "play_midlevel_igc" },
    { 0xB04100A8, "play_minigun_loop" },
    { 0x4375B877, "play_mode" },
    { 0xC750BDCC, "play_moon_jolie_access_vox" },
    { 0xEB271A5D, "play_moon_pass_vox" },
    { 0x5E318772, "play_mooncomp_vox" },
    { 0xF929BE12, "play_mortar_fx" },
    { 0x5EE4135C, "play_moto_sounds" },
    { 0x8F7BD062, "play_movie" },
    { 0xBAFA5227, "play_movie_async" },
    { 0xC5F79C06, "play_movie_async_thread" },
    { 0x8077C3A2, "play_movie_on_surface" },
    { 0xF3562567, "play_movie_on_surface_async" },
    { 0x4F05EE19, "play_movie_on_surface_thread" },
    { 0xBE38D8CD, "play_movie_with_timeout" },
    { 0xFB6F9C2D, "play_movies" },
    { 0xB6604233, "play_multiple_bullet_impact_fx" },
    { 0x21F41BA9, "play_music_box" },
    { 0xB2305B86, "play_music_easter_egg" },
    { 0x7EF400C5, "play_music_egg" },
    { 0xA23760DC, "play_music_stinger" },
    { 0x020096AD, "play_music_stinger_manual" },
    { 0x0B5C901F, "play_music_stingers" },
    { 0x0979EFB3, "play_muzak_lobby" },
    { 0x997D0B03, "play_muzzle_flash_shoot_menendez" },
    { 0x9D7AF531, "play_nag_line" },
    { 0x1B35866D, "play_next_killstreak_dialog" },
    { 0x13BC2102, "play_next_leader_dialog" },
    { 0xDD33E90B, "play_nicaragua_outro" },
    { 0x8B7DDDB4, "play_no_money_perk_dialog" },
    { 0xD6BB87CF, "play_no_money_purchase_dialog" },
    { 0xF422B6A2, "play_no_money_turret_dialog" },
    { 0x29D6F863, "play_notetrack" },
    { 0xF3B3B074, "play_notify_music_start" },
    { 0x7515B785, "play_numbers_bink" },
    { 0xA7771B73, "play_numbers_flash" },
    { 0xDF9398CF, "play_occluded_construction" },
    { 0x6EF7B8D9, "play_off" },
    { 0x4672C81F, "play_oh_shit_dialog" },
    { 0x71B08934, "play_omaha_drone_death_vox" },
    { 0x81B066DF, "play_omaha_drone_vox" },
    { 0x0210E3DD, "play_on_client" },
    { 0x148DEA01, "play_on_entity" },
    { 0x53C92656, "play_on_players" },
    { 0xF9B4F940, "play_on_tag" },
    { 0x662A1ED9, "play_once" },
    { 0xEF279C85, "play_one_left_underscore" },
    { 0x5D2EBF02, "play_one_second_increments" },
    { 0x2D66D560, "play_oneshot_sparks_loop" },
    { 0x8D40E0FF, "play_osprey_sounds" },
    { 0x907A257F, "play_other_maproom_idle" },
    { 0x9D72FBF9, "play_outro_claw_exploder" },
    { 0xBCE32A14, "play_outro_dialogue" },
    { 0x29762927, "play_outro_on_player" },
    { 0xC13EC69F, "play_outro_vo" },
    { 0x874F3028, "play_outside_rain_emitter_intro" },
    { 0x298B07BF, "play_overheat_fx" },
    { 0xDB428301, "play_pa_system" },
    { 0xD10296D6, "play_packa_get_dialog" },
    { 0x4035141C, "play_packa_see_vox" },
    { 0x0BB227BE, "play_packa_special_looper" },
    { 0x853526F5, "play_packa_wait_dialog" },
    { 0xEE0F4E72, "play_pain_sound" },
    { 0x077EB083, "play_pap_anim" },
    { 0x8D673F04, "play_pap_shake_fxanim" },
    { 0xF80CF0A5, "play_paused_animation_nev" },
    { 0x601D75F1, "play_paused_animation_pat" },
    { 0xA94CFB75, "play_pavelow_sounds_la2" },
    { 0x30E8CA50, "play_pentagon_announcer_vox" },
    { 0xBB87E627, "play_per_client" },
    { 0xE21255D6, "play_periodic_splash_fx" },
    { 0xC6EFF3E1, "play_perk_fx_on_client" },
    { 0x7673AA2C, "play_petrenko_conversation" },
    { 0x4384865E, "play_petrenko_conversation_animation_done" },
    { 0x9FE5E1E1, "play_petrenko_player_snowcat_idle" },
    { 0x39CDC8BD, "play_phase_anim" },
    { 0x1D4E5030, "play_phase_intro" },
    { 0x2209A7E2, "play_phono_egg" },
    { 0x0890C49F, "play_pilot_dialog" },
    { 0xDB72084D, "play_pilot_dialog_on_owner" },
    { 0x8F5609A6, "play_pilot_light_fx" },
    { 0x3B913CE9, "play_pip" },
    { 0x3E7C2035, "play_pip_dradis" },
    { 0x5B65D74D, "play_plane_audio_plane1" },
    { 0x9F39561E, "play_plane_boom" },
    { 0x3186EE3C, "play_plane_flyaway_sound" },
    { 0x6A08D914, "play_plane_land" },
    { 0x3D85D54F, "play_plane_passby" },
    { 0x6FD513D8, "play_plane_piece_call_and_response_vo" },
    { 0x6B01747C, "play_plane_sound" },
    { 0x0BD0E25B, "play_plane_sound_short" },
    { 0xDD84ADEC, "play_plane_sound_special" },
    { 0x1645A29F, "play_plane_x78_sounds" },
    { 0xB96F10D9, "play_plant_mortar_anim" },
    { 0x97755DC9, "play_plant_sound" },
    { 0xD1587ACF, "play_player_anim" },
    { 0xDD5C956C, "play_player_anim_2" },
    { 0x035F0FD5, "play_player_anim_3" },
    { 0x877149C8, "play_player_anim_intro" },
    { 0x215B0318, "play_player_anim_on_vehicle" },
    { 0x69B08757, "play_player_anim_outro" },
    { 0xA44487C6, "play_player_anim_using_tags" },
    { 0x2C206CF1, "play_player_body_anim_on_vehicle" },
    { 0x724B963D, "play_player_controlled_sounds" },
    { 0x6E00C9B5, "play_player_damaged_vo" },
    { 0xDAF8294A, "play_player_death_sound" },
    { 0x6D926985, "play_player_drone_sounds" },
    { 0xCB3CEC7E, "play_player_drone_sounds_so" },
    { 0xBBB89DBD, "play_player_finish_hook_up_anim" },
    { 0xFF56F453, "play_player_fullbody_anim_lerp" },
    { 0x546862B6, "play_player_fullbody_anim_simple" },
    { 0xE1852259, "play_player_fullbody_anim_special" },
    { 0x3916DB07, "play_player_hands_anim_simple" },
    { 0xCD762EAA, "play_player_intro_anim" },
    { 0x5E907946, "play_player_is_almost_awesome_line" },
    { 0xF34656F9, "play_player_is_awesome_line" },
    { 0x71828796, "play_player_lerp_to_pos" },
    { 0x8E86DE33, "play_player_pre_hook_up_anim" },
    { 0xD75E3D15, "play_player_setting_bomb_anim" },
    { 0x0CA3621A, "play_player_setting_bomb_anim_2" },
    { 0xFED3C27C, "play_player_snowcat_anims" },
    { 0xBCD0BB52, "play_playerview_anim" },
    { 0xACD81B2C, "play_playerview_banzai_failed" },
    { 0xD69E3526, "play_playerview_banzai_succeeded" },
    { 0xA97C33D1, "play_playerview_intro" },
    { 0x2C31594B, "play_playerview_knockdown" },
    { 0x278B00F5, "play_police_pullup" },
    { 0xB933EC95, "play_pontoon_animations" },
    { 0x622E4F1F, "play_pos_neg_response_on_closest_player" },
    { 0x139E9CDB, "play_post_airfield" },
    { 0x829984BC, "play_post_cougar_blend" },
    { 0x32E83E1E, "play_prisoner_crowd_vox" },
    { 0xB2E85F85, "play_projecter_loop" },
    { 0xC5B92EF5, "play_projecter_soundtrack" },
    { 0x9790547A, "play_projectile_dialog" },
    { 0x70E74D83, "play_projector_loop" },
    { 0x1BB4A951, "play_promotion_reaction" },
    { 0xF1813C82, "play_prop_fx" },
    { 0xECADF192, "play_ptboat_chatter" },
    { 0xD48CA6CB, "play_puddle_fx" },
    { 0x704B77B2, "play_pullup_arrival_sound" },
    { 0x64FE48BE, "play_punches" },
    { 0x6E8CEDB8, "play_push_vox" },
    { 0x95F226B8, "play_puzzle_stinger_on_all_players" },
    { 0x55813A6B, "play_quad_first_sounds" },
    { 0x414C495D, "play_quad_fly" },
    { 0x38913340, "play_quad_start_vo" },
    { 0xD65BFB45, "play_radar_alert" },
    { 0x7F439417, "play_radio" },
    { 0xF4D91D5D, "play_radio_anim" },
    { 0xCB50E039, "play_radio_chatter" },
    { 0x3E6DE5F2, "play_radio_eastereggs" },
    { 0x4E682575, "play_radio_egg" },
    { 0xC74773FF, "play_radio_garble" },
    { 0xC75B449C, "play_radio_nav_switch" },
    { 0xE87B4B46, "play_radio_sounds" },
    { 0xCDBC1EAD, "play_rain_fx" },
    { 0x0E4966AC, "play_rando_perk_dialog" },
    { 0x4D2D5D09, "play_random_beeps" },
    { 0x41EDE340, "play_random_broken_sounds" },
    { 0x14B58F72, "play_random_crow_sounds" },
    { 0x49434148, "play_random_dialogue" },
    { 0x1D24C761, "play_random_dist_explosions" },
    { 0xA2639CD1, "play_random_distant_pa" },
    { 0xF2730CEE, "play_random_gauntlet_vo" },
    { 0x21212316, "play_random_generator_sparks" },
    { 0x81B4D9C6, "play_random_gun_shots" },
    { 0xF9850A27, "play_random_monkey_vox" },
    { 0xD0920805, "play_random_return_fire_anim" },
    { 0xF9E42221, "play_random_roars" },
    { 0xD4265247, "play_random_russian_chatter" },
    { 0x6A32C97D, "play_random_russian_pa" },
    { 0xF7D88740, "play_random_shocking" },
    { 0xC624BA07, "play_random_turning_anim" },
    { 0xCE8F0031, "play_random_vox" },
    { 0xC8B8FCA3, "play_rappel_2_anim" },
    { 0xC6A489E8, "play_rappel_ambient_fx" },
    { 0xF2FED4D6, "play_rappel_anim" },
    { 0x493A8F7F, "play_raps_round" },
    { 0x6A00BF6B, "play_rattle_sounds" },
    { 0x0C312173, "play_rattle_sounds_when_mortar_hits" },
    { 0x8079704B, "play_raygun_dialog" },
    { 0x44122484, "play_rb_cover_player_vox" },
    { 0x16360F96, "play_regroup_fx_for_scene" },
    { 0xDD7E212D, "play_reinforcement_arrive_vo" },
    { 0x74819DD1, "play_reinforcement_coming_vo" },
    { 0x50198CE0, "play_reload_sounds" },
    { 0xEF5B0137, "play_reloading_vo" },
    { 0x38CC28B5, "play_remote_fx" },
    { 0x0C99339E, "play_rescue_animation" },
    { 0xD2BBE668, "play_resolution_music" },
    { 0x76660D10, "play_response_line" },
    { 0x6BCF9F5B, "play_revive_shout" },
    { 0x1E377762, "play_reznov_anim" },
    { 0x4966A6BB, "play_reznov_blinded_anim" },
    { 0x32FA6FFB, "play_reznov_speech" },
    { 0x35A46924, "play_reznov_vox" },
    { 0x4FE62ED0, "play_rice_bowl_drop_anim" },
    { 0xB023C162, "play_rice_stinger" },
    { 0x4ABB0657, "play_ride_dialog" },
    { 0xADA3C538, "play_riot_outside" },
    { 0xC4ED83DC, "play_robot_crush_player_vo" },
    { 0x2325980D, "play_robot_stomp_warning_vo" },
    { 0x98A5888C, "play_rocket_fires" },
    { 0x680D7BB7, "play_rocket_flyby" },
    { 0xFF301CFB, "play_rocket_muzzle_flash_guy0" },
    { 0xD92DA292, "play_rocket_muzzle_flash_guy1" },
    { 0x23E92E87, "play_rocket_muzzle_flash_player" },
    { 0x68A2FA96, "play_rocket_sound" },
    { 0xA37363DD, "play_roof_debris_fire" },
    { 0xD1FA88C0, "play_roof_fall_sound" },
    { 0x42CBB8E7, "play_roof_footsteps_audio" },
    { 0x634FF802, "play_roof_ground_sound" },
    { 0xADF36833, "play_rope_taut_sound" },
    { 0xD35290CF, "play_rotor_fx" },
    { 0xF7A1C408, "play_rotor_fx_stationary" },
    { 0x89EC76C7, "play_rumble_effect" },
    { 0x5A503BB6, "play_rumble_on_raps" },
    { 0xF522904A, "play_rumble_on_spinning_barge" },
    { 0xCA5EC371, "play_rumble_sound" },
    { 0x45114A09, "play_russian_radio" },
    { 0x629E64FE, "play_rwing_water_hit_0" },
    { 0xCBCCEBC0, "play_sal_punched" },
    { 0x9F636D46, "play_sam_ambience" },
    { 0xCAC351A9, "play_sam_creaking_sounds" },
    { 0xB0DEC68A, "play_sam_furnace" },
    { 0x203A8F5E, "play_sam_promises_conversation" },
    { 0x251FC83F, "play_sam_radio" },
    { 0x343F8E54, "play_sam_then_response_line" },
    { 0xAF89FEDF, "play_sam_vo" },
    { 0xE02BC7DD, "play_sampan_motor_audio" },
    { 0xA6251049, "play_scan_and_alarm" },
    { 0x61AEC161, "play_scary_lightning" },
    { 0x0B319DF2, "play_scene" },
    { 0xD7539B35, "play_scene_controller" },
    { 0x131AD549, "play_scene_flare_guy_killed" },
    { 0x1AEFE698, "play_scene_transition_effect" },
    { 0x0C2EB77D, "play_scenes" },
    { 0x843A329B, "play_scream_sounds_during_fight" },
    { 0xE3996AA0, "play_screams" },
    { 0x414EF434, "play_screecher_breathing_audio" },
    { 0x35762AA0, "play_screecher_damaged_yelps" },
    { 0x4B3FDBD1, "play_screecher_fx" },
    { 0x3E13E5C5, "play_screen_fx_dirt" },
    { 0xBA7B10A6, "play_screen_fx_dust" },
    { 0xF33D45F7, "play_screen_fx_snow" },
    { 0xCBD0881A, "play_screen_fx_snow_dust" },
    { 0xDD0938ED, "play_scripted_fx" },
    { 0xFAE33B5A, "play_scripted_getup" },
    { 0x37973F5F, "play_second_line" },
    { 0xFD7FDDE0, "play_selected_shot" },
    { 0x43464E25, "play_selected_track" },
    { 0xE3DACE5C, "play_sergei_hold_loop" },
    { 0xAFD3C387, "play_shake_lights_audio" },
    { 0xA14CE2AA, "play_shock_loop_manual" },
    { 0x368DC30E, "play_shoot_arm_hint_vo" },
    { 0x472A07A5, "play_short_movie" },
    { 0x914E6E3A, "play_shot" },
    { 0xE48A5A46, "play_shot_internal" },
    { 0xAC2D60DC, "play_shutter_sounds" },
    { 0x468623AB, "play_siege" },
    { 0x777AAA23, "play_sig_splash_effect" },
    { 0x2E064464, "play_signature_boat_fx_launch" },
    { 0x1292CF78, "play_single_spark" },
    { 0x9F77D4F9, "play_siren" },
    { 0xA9DEC108, "play_siren2_after_freeway" },
    { 0xF61CADFB, "play_siren_on_cop_car" },
    { 0xE9F98A60, "play_siren_on_cop_car_2" },
    { 0x30752E30, "play_sirens" },
    { 0x87628125, "play_sitdown_animation" },
    { 0x6289121A, "play_slam_fx" },
    { 0x496DA2F3, "play_slide_anim" },
    { 0x85321A91, "play_slightly_delayed_fake_rocket_audio" },
    { 0xB8F8950F, "play_small_reznov_movie" },
    { 0x7F9DA23D, "play_smaller_waterfall" },
    { 0x90592ED6, "play_snake_anim" },
    { 0x2B1E20D3, "play_snow_puff" },
    { 0x2BEC9BF2, "play_snowcat_audio" },
    { 0x20BE2286, "play_snowcat_fx" },
    { 0x1778230F, "play_sound" },
    { 0x7A8F2FC0, "play_sound_2d" },
    { 0xEA64EF22, "play_sound_at_pos" },
    { 0x39CCDD72, "play_sound_done" },
    { 0x10FC4D7C, "play_sound_in_space" },
    { 0xC843B4B5, "play_sound_on_client" },
    { 0xEAB7C097, "play_sound_on_ent" },
    { 0xD6A0FEB3, "play_sound_on_ent_and_wait" },
    { 0x2362BC39, "play_sound_on_entity" },
    { 0x9EA07716, "play_sound_on_entity_loc" },
    { 0xF93ABB97, "play_sound_on_player" },
    { 0x51A5B6DF, "play_sound_on_price" },
    { 0x6BCE9D13, "play_sound_on_speaker" },
    { 0x481BCAD8, "play_sound_on_tag" },
    { 0x12CADC52, "play_sound_on_tag_endon_death" },
    { 0x377E44B0, "play_sound_on_trap_pickup" },
    { 0x70A23288, "play_sound_over_radio" },
    { 0xB4118B4C, "play_sound_ridge_1_when_dying" },
    { 0x955BE791, "play_sound_ridge_2_when_dying" },
    { 0x56D6E377, "play_sound_vox_push_last" },
    { 0x4D04A4A9, "play_sound_wait" },
    { 0x423B1A11, "play_spark" },
    { 0xE5244286, "play_spark_fx" },
    { 0x81DAF2F8, "play_sparks" },
    { 0x45619995, "play_sparky_beam_fx" },
    { 0xA13F3859, "play_spawn_alarm" },
    { 0x99146007, "play_specialized_shot_audio" },
    { 0x73B76D44, "play_specific_vo_on_notify" },
    { 0x3CDE19A1, "play_speech_warning" },
    { 0xB8C335A1, "play_speed_shout" },
    { 0x8F137B8F, "play_spinning_plane_sound" },
    { 0x4D1C12E9, "play_splash_effect" },
    { 0x1C2D8FAA, "play_sq_audio_log" },
    { 0x63E0744E, "play_sq_bg_collected_vo" },
    { 0xDCD0465C, "play_sr71_interior_loops" },
    { 0xF284F1C6, "play_sr71_surround_track" },
    { 0xEEA7A1E1, "play_start_stop_sound" },
    { 0x54A8C6E4, "play_starting_vox" },
    { 0x78805A81, "play_state" },
    { 0x090B5EFD, "play_static_loop" },
    { 0x8318B801, "play_static_when_up" },
    { 0x47B5F3FE, "play_steiner_feedback_1" },
    { 0x21B37995, "play_steiner_feedback_2" },
    { 0x4AA18FE1, "play_steiner_idle" },
    { 0x70EE7450, "play_stinger_a" },
    { 0xE2F5E38B, "play_stinger_b" },
    { 0xBCF36922, "play_stinger_c" },
    { 0x4025D345, "play_stinger_dead_a" },
    { 0x66284DAE, "play_stinger_dead_b" },
    { 0x8C2AC817, "play_stinger_dead_c" },
    { 0x82196F38, "play_stinger_dead_d" },
    { 0xED36216B, "play_stinger_drown" },
    { 0x7481262B, "play_stopmoving_sounds" },
    { 0x7F532516, "play_stuka_flying" },
    { 0x8B1557CD, "play_stunned_fx_handler" },
    { 0xF4293484, "play_stylized_impact_audio" },
    { 0xF379331C, "play_super_egg_radio_pa_sounds" },
    { 0xF6E33B96, "play_supply_sounds" },
    { 0x4D82A419, "play_survivor_yell" },
    { 0x6C39EEAE, "play_suspension_audio" },
    { 0x97D011BA, "play_swaying_lights" },
    { 0x136B9C18, "play_swift_kill_blood_fx" },
    { 0xC4A7EBAD, "play_swimming_wake_fx" },
    { 0x653E605C, "play_sword_melee_gib_death_anim" },
    { 0x5F3253EE, "play_taacom_dialog" },
    { 0x673EA3DE, "play_taacom_dialog_on_owner" },
    { 0x7C03B4C4, "play_taacom_dialog_response" },
    { 0x231A9F68, "play_taacom_dialog_response_on_owner" },
    { 0x381E0AE2, "play_tag" },
    { 0xAD645F2F, "play_tail_water_hit_0" },
    { 0xDDD5CF61, "play_target_destroyed_vo" },
    { 0x2464918E, "play_targeted_sound" },
    { 0x8C4A19C3, "play_targeting_sound" },
    { 0x0234283C, "play_tazer_melee_death_anim" },
    { 0x9C2F8BC2, "play_tele_help_vox" },
    { 0x8029B5DA, "play_telephone" },
    { 0x0B1EC674, "play_teleport_fx" },
    { 0xD65163BC, "play_teleporter_samantha_chamber_line" },
    { 0x288468D5, "play_teleporter_sounds" },
    { 0x2B38EC79, "play_temp_rain_fx_in_village" },
    { 0x790922C9, "play_temp_russian_voice" },
    { 0xB7046BC4, "play_terrain_sounds" },
    { 0x8B68363A, "play_tesla_dialog" },
    { 0xA7F8C5B7, "play_tesla_sound" },
    { 0xF291309D, "play_test_sound_priority" },
    { 0x09F38170, "play_the_numbers" },
    { 0x7DACD422, "play_the_scene" },
    { 0x6F53C3F9, "play_third_cover_vo" },
    { 0xB23CDD12, "play_throw_hatchet" },
    { 0xFCCECF2C, "play_thrust_sound" },
    { 0xF10C42CD, "play_time" },
    { 0x92772DA8, "play_timeout_warning_vo" },
    { 0xC3FD2AFF, "play_timer_vox" },
    { 0x5B4EA37C, "play_tinnitus" },
    { 0x1CB2D366, "play_tow_futz" },
    { 0xFD5AB771, "play_tow_highlight" },
    { 0x6BB22463, "play_tower_creaks" },
    { 0x3586198C, "play_town_distant" },
    { 0x11350CA6, "play_trail" },
    { 0xC53017D4, "play_train" },
    { 0x075C2857, "play_train_audio" },
    { 0x547BE6BF, "play_train_horn_audio" },
    { 0xFE944289, "play_traincar_audio" },
    { 0x4E04FED2, "play_traincar_horn" },
    { 0x239CBFAC, "play_trans_ai_crew_member" },
    { 0x522D8BB5, "play_trans_ai_distress" },
    { 0x26D59FAD, "play_trans_ai_distress2" },
    { 0x9EC1E6E3, "play_trans_ai_ftol" },
    { 0x1ADAAEFD, "play_trans_ai_ftor" },
    { 0x82D0C559, "play_trans_ai_ftov" },
    { 0xD3DD4483, "play_trans_ai_ltof" },
    { 0xFAC11395, "play_trans_ai_rtof" },
    { 0xA062629E, "play_trans_gunner" },
    { 0x897FB04C, "play_transition_animation" },
    { 0x45B0CEC1, "play_transition_to_front" },
    { 0x698734C7, "play_transition_to_left" },
    { 0x83215EE6, "play_transition_to_rear" },
    { 0x0BEE8642, "play_transition_to_right" },
    { 0xB18B045A, "play_trap_dialog" },
    { 0x36F4021A, "play_tree_crash_anim" },
    { 0xA881A02F, "play_trig_sounds" },
    { 0xA6CB088D, "play_trippy_reznov" },
    { 0x1A8DE17E, "play_truck_arrival_audio" },
    { 0x154FCD34, "play_truck_audio" },
    { 0x168C3BB5, "play_truck_crash_anim" },
    { 0xCA75EE20, "play_truck_death" },
    { 0x58AD0ABC, "play_truck_driving_audio" },
    { 0xCAECF972, "play_tunnel_enter_choppers" },
    { 0xE14A04CE, "play_tunnel_hatch_open" },
    { 0xD07CB2F7, "play_tunnel_shelf_fall" },
    { 0x6EDC6E5E, "play_tutorial_vo" },
    { 0x81CA9CF3, "play_tutorial_vo_with_hint" },
    { 0x59943B40, "play_tv" },
    { 0xA9479917, "play_tv_2" },
    { 0xC1833002, "play_type" },
    { 0x223AD219, "play_underground_vo" },
    { 0xD5BD108C, "play_up_the_stairs_run" },
    { 0xD2F98743, "play_up_the_stairs_start" },
    { 0x5E55498A, "play_uphill_stingers" },
    { 0x261ACFBF, "play_uwb_creaking" },
    { 0xC73DED3B, "play_vc1_kill_blood_fx" },
    { 0xC7222458, "play_vc2_kill_blood_fx" },
    { 0x9B982882, "play_vc_rice_kill_blood_fx" },
    { 0x028C72A9, "play_veh_drive_audio" },
    { 0x13B52124, "play_veh_skid_audio" },
    { 0x94807CE2, "play_vehicle_anim" },
    { 0xB3DA6D4F, "play_vehicle_anim_loop_solo" },
    { 0xEBD71C91, "play_vehicle_anim_single_solo" },
    { 0xA913F721, "play_vehicle_anim_single_solo2" },
    { 0x40684C04, "play_vehicle_animloop" },
    { 0x0213D8D7, "play_vehicle_arrival_audio" },
    { 0x055961B8, "play_vehicle_drone_swarm" },
    { 0xBD0AF061, "play_vehicle_effects" },
    { 0xD3AB4C59, "play_vending_vo" },
    { 0x36C76DB1, "play_vendor_stings" },
    { 0x1B68AF06, "play_ventral_animations" },
    { 0x936EFF6D, "play_vid_flashback" },
    { 0x9D4FB605, "play_viewhands" },
    { 0x9D257691, "play_village_ambience" },
    { 0x20CA9078, "play_village_ambiences" },
    { 0x9202A322, "play_village_explosion" },
    { 0xF3242F8A, "play_village_vignettes" },
    { 0xDAC12017, "play_vo" },
    { 0xDEB7D236, "play_vo_category_on_closest_player" },
    { 0xB8D8C716, "play_vo_helper" },
    { 0xDF376A37, "play_vo_in_section" },
    { 0xCC5E5B79, "play_vo_when_generator_is_attacked" },
    { 0x211C5741, "play_vox_on_closest_player" },
    { 0xAB669CA2, "play_vox_on_fake_head" },
    { 0x1F6243B1, "play_vox_to_player" },
    { 0xA12A1BC6, "play_vtol_exhaust" },
    { 0x2BC03D0F, "play_vtol_lights" },
    { 0xA064EF67, "play_wake_fx" },
    { 0x34303ADF, "play_walla_vignettes" },
    { 0xF7CE6FB2, "play_walldebris_fire" },
    { 0x45CFB43D, "play_walldebris_fires" },
    { 0x42C1414A, "play_warmup_cooldown" },
    { 0xA3961ADE, "play_warning_lines" },
    { 0xFBC53914, "play_warning_vox" },
    { 0xDDEDDB8A, "play_wasp_round" },
    { 0x7FE2952C, "play_water_fx" },
    { 0x4BA4C49F, "play_water_fx_audio" },
    { 0x428D4EB4, "play_water_fx_on_everyone" },
    { 0xEBE04E84, "play_water_fx_then_delete" },
    { 0xE432A018, "play_water_loop" },
    { 0xEE58FD84, "play_water_rush" },
    { 0x5139AB30, "play_waterfx_ptboat_box1_jnt" },
    { 0x8D4B37D3, "play_waterfx_ptboat_box2_jnt" },
    { 0x6539BC36, "play_waterfx_ptboat_radar_jnt" },
    { 0xF28100B1, "play_waterfx_ptboat_tower_jnt" },
    { 0x0DBE63C8, "play_waterfx_ptboat_vent1_jnt" },
    { 0xEEB2B98B, "play_waterfx_ptboat_vent2_jnt" },
    { 0x49C4A7E6, "play_waterfx_ptboat_vent3_jnt" },
    { 0xF18988C8, "play_wave_arty_sound" },
    { 0xCA209D6D, "play_wave_sound" },
    { 0x483840E8, "play_weapon_vo" },
    { 0x2EAEC116, "play_weaver_hotwire_audio" },
    { 0x8A10B9F1, "play_weaver_stinger" },
    { 0x9B98EE75, "play_welding_audio" },
    { 0xEF1F65EC, "play_win_seq" },
    { 0x781CD6F4, "play_wind" },
    { 0x58A06AEB, "play_wind_sounds" },
    { 0x6FB9572A, "play_window_break_sound" },
    { 0x62B6338E, "play_window_shot_audio" },
    { 0xD51C8AC1, "play_wing_center_splash" },
    { 0x0B496B6C, "play_wing_center_wake" },
    { 0x9F14403F, "play_woman_crying" },
    { 0xF40C7F27, "play_wood_land_sound" },
    { 0xD2B4D18A, "play_woods_ambulence_dialog" },
    { 0x05DECA65, "play_woods_anim_at_camera_point" },
    { 0x13C4DE05, "play_woods_idle" },
    { 0x415D99F0, "play_woods_run_up_hill_anim" },
    { 0x23B2BF7D, "play_woods_water_fx" },
    { 0x239FA779, "play_woods_wtf_line" },
    { 0x74168563, "play_zero_sounds" },
    { 0xF2352CD7, "play_zeros_track" },
    { 0xE44BF9A8, "play_zipline_dialog" },
    { 0xAF474B1D, "play_zombie_groans" },
    { 0xAF1CD912, "play_zombie_slide_looper" },
    { 0x67AFCB21, "play_zone_alarms" },
    { 0x64E4CC06, "play_zone_shakes" },
    { 0x4CFBBA3C, "playa" },
    { 0x0D5F7467, "playable" },
    { 0x8A79CC19, "playable_area" },
    { 0xC52BCFD0, "playable_areas" },
    { 0xEC904CEE, "playable_hind_climbin" },
    { 0x373DD349, "playable_hind_climbout" },
    { 0xE52D8DDD, "playableally" },
    { 0xA43147A5, "playabletimerstopped" },
    { 0xA6D362B8, "playadditiveaiminganims" },
    { 0xCE5EF739, "playafterburner" },
    { 0x8E5DD1DF, "playafterburnerfx" },
    { 0x3EBC4867, "playaifootstep" },
    { 0x753314FC, "playaliasoverradio" },
    { 0x1ACBAFDF, "playambientyellsaroundvillage" },
    { 0xE2555348, "playanim" },
    { 0x68DDB2FE, "playback" },
    { 0x1E8415CB, "playback_controls" },
    { 0x9569FB43, "playback_paused" },
    { 0x8BAC6D8F, "playback_rate" },
    { 0xCA972237, "playback_scene" },
    { 0x9A0C313F, "playback_scene_subs" },
    { 0xE8C5B06E, "playback_scenes" },
    { 0xBA1B983E, "playback_speed" },
    { 0x497658B4, "playback_title_screen" },
    { 0x0809F6C5, "playbackid" },
    { 0x6FFC5637, "playbackspeed" },
    { 0xE20459B1, "playbacktime" },
    { 0xC25625CC, "playbattlechatter" },
    { 0xBC66B7EC, "playbattlechattertoteam" },
    { 0xACE11305, "playbettyeffects" },
    { 0x3CB93295, "playbink" },
    { 0x060188F9, "playblendtransition" },
    { 0x7780F176, "playblendtransitionstandrun" },
    { 0xCAF2FE08, "playblendtransitionstandwalk" },
    { 0xFF3606F2, "playbodydamagefx" },
    { 0xD157FE29, "playbombdefuse" },
    { 0xF704912D, "playbombfx" },
    { 0xB8E85D12, "playbombplant" },
    { 0x0181C324, "playboy_vignette" },
    { 0xFF1B755A, "playbundlename" },
    { 0xC53AD884, "playc4effects" },
    { 0x18136030, "playcarsound" },
    { 0xB5C07C2F, "playchugabudtimeraudio" },
    { 0x3D0CDD71, "playchugabudtimerout" },
    { 0x66BB4113, "playclaymoreeffects" },
    { 0x20CD53D8, "playclientairstrike" },
    { 0x531213C1, "playclientnapalm" },
    { 0x6E7CAC34, "playconcussionsound" },
    { 0x968AAA7B, "playcontrail" },
    { 0x9BECD091, "playcounterspyplaneafterburnerfx" },
    { 0x70A8EA77, "playcounterspyplanefx" },
    { 0xB4791D77, "playcredits" },
    { 0x6C2F415E, "playcrouchanim" },
    { 0x206FF6CA, "playcurrenttaunt" },
    { 0xB01FADFB, "playcustomdeathanim" },
    { 0x40560356, "playcustomevent" },
    { 0x074E1002, "playdamagefx" },
    { 0x15986C10, "playdeathanim" },
    { 0x259A389C, "playdeathsound" },
    { 0x9EB8FEDF, "playdeathsounds" },
    { 0xEEB86B8C, "playdestroyeddialog" },
    { 0xD67EF81E, "playdestructiblebattlechatter" },
    { 0x8505AD73, "playdialog" },
    { 0x0A69D38A, "playdialogondeath" },
    { 0xFF477691, "playdogstep" },
    { 0xFFA7847A, "playdriveranim" },
    { 0xC6CF998D, "playdrivesounds" },
    { 0x5584F24E, "playduprenderbundle" },
    { 0xB4F1D098, "playe" },
    { 0x49A3304C, "played" },
    { 0x8F86E1C6, "played120sec" },
    { 0x4EDF5E50, "played180sec" },
    { 0x52E687B0, "played30sec" },
    { 0xC4B9B009, "played60sec" },
    { 0xE79E42AD, "played_camera_anims" },
    { 0xC99DE5DF, "played_dialog" },
    { 0x8F0E8EEC, "played_extra_song_a7x" },
    { 0xA4C515E5, "played_fx" },
    { 0x7892737F, "played_mud_vo" },
    { 0xF246C89B, "played_note" },
    { 0xA011D528, "played_sound" },
    { 0xD95E09CE, "played_splash" },
    { 0x309E7783, "played_trans_in" },
    { 0xC2EC6217, "played_used_ads" },
    { 0x86B0E679, "playeddamaged" },
    { 0x8A2D096E, "playedfx" },
    { 0x34210CB9, "playedgadgetsuccess" },
    { 0xF2616070, "playednearendvo" },
    { 0x94261DB6, "playedorhosted" },
    { 0xBF196079, "playedstartingmusic" },
    { 0xD9D625CF, "playeffectshortly" },
    { 0xE12E5901, "playempfx" },
    { 0x9774A4E6, "playend" },
    { 0xEB8CDF14, "playepictauntscene" },
    { 0xC427E742, "playequipmentdestroyedonplayer" },
    { 0x9C5723B5, "playequipmenthackedonplayer" },
    { 0x5DC5E20A, "player" },
    { 0xC8F9C96E, "player0" },
    { 0xEEFC43D7, "player1" },
    { 0x7CF4D49C, "player2" },
    { 0x9B28DF39, "player_" },
    { 0x9ACE5A6B, "player_0" },
    { 0xA226160C, "player_0_distance_traveled_info" },
    { 0x74CBE002, "player_1" },
    { 0xF31088DD, "player_1_link" },
    { 0x4EC96599, "player_2" },
    { 0x28C6EB30, "player_3" },
    { 0x32D8440F, "player_4" },
    { 0x6ACB7F9A, "player_4_override" },
    { 0x05074018, "player_4_vox_override" },
    { 0x6D0F3A46, "player_abandons_seaknight_protection" },
    { 0x9FE5D93F, "player_accessed_perk" },
    { 0x89306B22, "player_acid_damage" },
    { 0x4B705D6A, "player_acid_damage_cooldown" },
    { 0x0A11DBD6, "player_actionslots" },
    { 0x786DF66F, "player_activated_air_support" },
    { 0x618E1B27, "player_activates_timebomb" },
    { 0x0160D01E, "player_activity_checker" },
    { 0x05985C90, "player_add_points" },
    { 0x79DBC36F, "player_add_points_cheats" },
    { 0x3DDBD9A7, "player_add_points_kill_bonus" },
    { 0x17BFF235, "player_add_score" },
    { 0x57C462AB, "player_ads_damage_ratio" },
    { 0xD1420BCB, "player_ads_time" },
    { 0xBE99A3D0, "player_ahead" },
    { 0x316E69FD, "player_ahead_of_me" },
    { 0x0C9CC080, "player_aim_debug" },
    { 0x6F700656, "player_aim_ent" },
    { 0xE2A83002, "player_aim_entity_update" },
    { 0xA4011739, "player_aim_think" },
    { 0x1C2D01CC, "player_air_raid_timer" },
    { 0xF600AF18, "player_align" },
    { 0xF69EF150, "player_align_struct" },
    { 0x3F6656EC, "player_all_players_in_laststand" },
    { 0x086EAA3F, "player_ambiance_effect" },
    { 0xEEF2BEA0, "player_ammo_low" },
    { 0x0B68A8EA, "player_ammo_out" },
    { 0x6D372A0A, "player_and_weaver_safehouse_fps_scene" },
    { 0x8ECA16B7, "player_ang" },
    { 0x3824EDEB, "player_ang_vel" },
    { 0x98973E06, "player_angle" },
    { 0x368B1CB9, "player_angles" },
    { 0xF04FE95E, "player_anim" },
    { 0xC8FB62AC, "player_anim_clamp_bottom" },
    { 0xE0843136, "player_anim_clamp_left" },
    { 0x1EA4618D, "player_anim_clamp_right" },
    { 0xB81F76E6, "player_anim_clamp_top" },
    { 0x4D27AE8D, "player_anim_length" },
    { 0x289141F4, "player_anim_loader" },
    { 0xA2EC592E, "player_anim_look_enabled" },
    { 0x67F26F30, "player_anim_setup" },
    { 0xBAB9A9C1, "player_animation" },
    { 0xACC47C80, "player_animation_length" },
    { 0x7395F27F, "player_animation_notify" },
    { 0x20C7D7E8, "player_animations" },
    { 0xA503A3C1, "player_anims" },
    { 0x653360B2, "player_animtree" },
    { 0x979C8C7A, "player_any_player_in_laststand" },
    { 0x3FE92245, "player_approach_carnage" },
    { 0xAF1A5ADE, "player_approach_convoy_fail_logic" },
    { 0x654C846C, "player_approach_convoy_vo" },
    { 0xA10337B1, "player_approaches" },
    { 0xAFCF9043, "player_approaches_porch_house" },
    { 0xCAA92738, "player_arena_mode" },
    { 0x729A2232, "player_arena_overlook" },
    { 0xE9F543A8, "player_arm_explosives" },
    { 0x06D2807B, "player_arm_explosives_monitor" },
    { 0x373DB61F, "player_armor_changed" },
    { 0x692EC98E, "player_armor_changed_event" },
    { 0xCBA18602, "player_armor_shield" },
    { 0x3057829E, "player_arms_transition" },
    { 0x90685868, "player_array" },
    { 0x0D4DDFDD, "player_arrived_upstairs_thread" },
    { 0x3D22D344, "player_arriving_2nd_floor_armory" },
    { 0xB39C3E9C, "player_asd_intro" },
    { 0x8E030555, "player_asd_rumble" },
    { 0x76361AD3, "player_asd_vo" },
    { 0xB0460885, "player_at_board_range" },
    { 0x79645E56, "player_at_bridge" },
    { 0x3A537E41, "player_at_bus_gate" },
    { 0x5B9EED8C, "player_at_celerium_door" },
    { 0x145D3186, "player_at_chinook" },
    { 0xF8E79B56, "player_at_clean_room" },
    { 0x24992ECE, "player_at_crate" },
    { 0x1D3F4D24, "player_at_dock" },
    { 0xB31D2E50, "player_at_dogs" },
    { 0xCAC34372, "player_at_final_ramp" },
    { 0x7F340598, "player_at_front_gate" },
    { 0xB097A485, "player_at_hatch" },
    { 0x269ABA22, "player_at_isaac" },
    { 0xCFA1B445, "player_at_shore_aa" },
    { 0x4EE9CC2A, "player_at_strela" },
    { 0x2D490BFB, "player_at_torch_door_thread" },
    { 0x35B188EC, "player_at_wing" },
    { 0xD8EB148E, "player_attacked" },
    { 0x94B48F88, "player_attacker" },
    { 0xBCEF73EC, "player_attacker_accuracy" },
    { 0x0878F8B6, "player_attacker_accuracy_multiplier" },
    { 0xD8E4D367, "player_attacking" },
    { 0xCB45F8B1, "player_attacks_enemy" },
    { 0xF742C9A0, "player_attacks_exchange" },
    { 0xEC2FC024, "player_attacks_from_seaknight" },
    { 0x8BC94D04, "player_attribs" },
    { 0xC4B4BE4B, "player_automatic_respawn" },
    { 0xEC02AD12, "player_avoid_drones" },
    { 0x3F798350, "player_avoid_missiles" },
    { 0x123156DE, "player_avoid_offset" },
    { 0x867BF9C7, "player_avoid_vtols" },
    { 0x6A94FC62, "player_awake" },
    { 0x980BEE80, "player_awesome_thread_done" },
    { 0x059960A2, "player_ba" },
    { 0xB456160D, "player_backward_vec" },
    { 0x91B3854D, "player_ball_outline" },
    { 0x300ED4D7, "player_bar_fight" },
    { 0x0CA4F0C3, "player_bar_node" },
    { 0x474D8423, "player_basic_needs" },
    { 0xB2F54A83, "player_battles_towards_power_plant" },
    { 0x6E9EA00C, "player_bb_jumpout" },
    { 0x75F7C48F, "player_beam_anims" },
    { 0x5DB6D874, "player_beartrap_toolshed_pickup" },
    { 0xC50BE4AC, "player_beat_down" },
    { 0xC0824198, "player_beating_mason" },
    { 0x23725CB9, "player_becomes_invul_on_pickup" },
    { 0xAD132232, "player_becomes_zombie" },
    { 0xB995D6A3, "player_becoming_invulnerable" },
    { 0x3098FF52, "player_behaviors_to_alert_drone" },
    { 0x94CE6D90, "player_behind_mg" },
    { 0x16F82A94, "player_behind_trigger" },
    { 0x53798C69, "player_being_fired_on" },
    { 0xAD554D2E, "player_being_revived" },
    { 0x1273A935, "player_being_targeted" },
    { 0x9B7272C5, "player_being_targetted" },
    { 0xB34BEB30, "player_below_water" },
    { 0xDC376E0A, "player_bike" },
    { 0x1178A34B, "player_bike_in_jump_position" },
    { 0x3AC0C608, "player_bike_invulnurablility_interval" },
    { 0x938B8D7B, "player_bike_invulnurablility_interval_thread_running" },
    { 0x04832003, "player_bike_override_end" },
    { 0x61E1E948, "player_binoculars_point" },
    { 0x792E1C61, "player_bird_fx_during_antenna_reveal" },
    { 0xE9840562, "player_blackscreen" },
    { 0x2940D375, "player_blew_up_truck" },
    { 0xEFD4BE44, "player_blizzard_loop" },
    { 0x27B318F4, "player_block" },
    { 0xC1251F91, "player_blocker" },
    { 0x0A5F93AC, "player_blocker_0" },
    { 0x59E7837D, "player_blocking_lander" },
    { 0xF924AEAA, "player_blur" },
    { 0x183C045C, "player_boarded_vtol" },
    { 0xCED70D65, "player_boarding" },
    { 0xBA2F25E9, "player_boards_f35" },
    { 0xA703EA31, "player_boards_seaknight" },
    { 0x2C37BC5A, "player_boat_angles" },
    { 0xF942A64D, "player_boat_collision_thread" },
    { 0x93B9ACCA, "player_boat_damage_effects" },
    { 0xD178C9B5, "player_boat_ent" },
    { 0xA279AA35, "player_boat_forward" },
    { 0x4C886D7D, "player_boat_intro_scene" },
    { 0x747C5E62, "player_boat_node" },
    { 0x5B2054B7, "player_boat_offset" },
    { 0xEA8D3683, "player_boat_sim" },
    { 0x8F1CE930, "player_bod" },
    { 0xB15FA511, "player_body" },
    { 0xFD166AB4, "player_body_jam" },
    { 0x1EFB3EEB, "player_body_model" },
    { 0x1D9722FE, "player_body_params" },
    { 0x9A93F748, "player_bought" },
    { 0x6997BF16, "player_breach" },
    { 0xEE4884DD, "player_breach_button_press" },
    { 0x8109B7E5, "player_breach_fake_fire" },
    { 0x9065E64F, "player_breach_into_room" },
    { 0xBEDEDF39, "player_breach_jump" },
    { 0x7041B4AC, "player_breach_vox" },
    { 0x76002C60, "player_breachroom_after" },
    { 0xF8F1C1AE, "player_breadcrumb_reset" },
    { 0x57E3623E, "player_breadcrumb_update" },
    { 0x5EE3B056, "player_breaks_ignore" },
    { 0x2811EDBF, "player_breaks_stealth_base" },
    { 0xC3A3CA1B, "player_breaks_stealth_by_greande_throw" },
    { 0xB56D9C98, "player_breaks_stealth_heli" },
    { 0xBA2E2D41, "player_breaks_stealth_karambit_by_being_spotted" },
    { 0xABD64D50, "player_breaks_stealth_karambit_by_firing_gun" },
    { 0xB59F7315, "player_breaks_stealth_vo" },
    { 0x62F7DBEC, "player_breaks_stealth_vo_leaves_cover" },
    { 0x43E2DE70, "player_breaks_stealth_vo_stand_up" },
    { 0x92EF43E1, "player_breathing_sound" },
    { 0x5CE6AC11, "player_briefing" },
    { 0xE87D8F27, "player_broke_bb_stealth" },
    { 0x9AF37094, "player_broke_stealth" },
    { 0x161C5522, "player_broke_stealth_inshop" },
    { 0x4E0C9425, "player_brokestealth_onroad" },
    { 0xAA66B90F, "player_btr" },
    { 0x54619F38, "player_btr_anim_thread" },
    { 0x18B0EE78, "player_btr_anim_thread_left_hand" },
    { 0x2AAB9DC7, "player_btr_ending" },
    { 0xC247DE27, "player_btr_grenade_launcher" },
    { 0x5805320F, "player_btr_path" },
    { 0x659E22F7, "player_btr_start_moving" },
    { 0xAD4E081B, "player_btr_weapon_overheating" },
    { 0x34EC196B, "player_build" },
    { 0xD4C472DB, "player_built" },
    { 0x23586527, "player_burn_defalco" },
    { 0x8DD4328F, "player_burn_menendez" },
    { 0x0CB368A1, "player_burned" },
    { 0xEFA0BD65, "player_burning_audio" },
    { 0x3462B8E7, "player_burning_fx" },
    { 0x69673589, "player_buys_perk" },
    { 0xDFE36E2B, "player_buys_perk_machine" },
    { 0xFAEF9E31, "player_c4_ready_go_vo" },
    { 0x6E1436C3, "player_called_air_support" },
    { 0x7FFF608F, "player_called_bombers" },
    { 0xD0D0C9C8, "player_cam_lock" },
    { 0x89B45FB5, "player_cam_unlock" },
    { 0xE345720C, "player_camera" },
    { 0xEF7BA9DE, "player_camera_control" },
    { 0x243DE5D9, "player_camera_idle_drift" },
    { 0x1BD4EF61, "player_camera_moving" },
    { 0x450A6FA2, "player_camera_movment_tracker" },
    { 0xC709A3D4, "player_camera_restrain_smooth" },
    { 0x006ED2D8, "player_camera_shake_loop" },
    { 0x2F6BA61B, "player_camo_suit" },
    { 0x7ECA462D, "player_camo_suit_damage_fall_off" },
    { 0x3C4876F1, "player_camo_suit_damage_watch" },
    { 0x2E49251C, "player_camo_suit_tutorial" },
    { 0xC675A522, "player_camo_viewmodel" },
    { 0xA3E432FD, "player_can_be_grabbed" },
    { 0x8AD7D3C8, "player_can_build" },
    { 0xC3B9F88E, "player_can_craft" },
    { 0x6837A98A, "player_can_dump" },
    { 0x30851F27, "player_can_fire_turret_time" },
    { 0x6AD9D509, "player_can_interact_with_ghost_piano_player" },
    { 0x5660FA7C, "player_can_melee" },
    { 0x177DFC6A, "player_can_say_line" },
    { 0xBB892CA5, "player_can_score_from_zombies" },
    { 0xC2273850, "player_can_see_enemy" },
    { 0x6F990596, "player_can_see_me" },
    { 0x4E521F18, "player_can_see_sloth" },
    { 0x7BC24A99, "player_can_see_weapon_prompt" },
    { 0x49C44532, "player_can_see_woods" },
    { 0x295C63BA, "player_can_take_piece" },
    { 0xA0A25FDB, "player_can_use_content" },
    { 0xB061219E, "player_can_use_ghost_piano_trigger" },
    { 0xDEE9B243, "player_can_use_m202" },
    { 0xC192EF20, "player_candy" },
    { 0x4D963C04, "player_cant_die" },
    { 0x609781F7, "player_captured" },
    { 0x9D371857, "player_captured_transition" },
    { 0x52FF2786, "player_carjack_setup" },
    { 0xCFF7C845, "player_carries_price_until_he_drops_him" },
    { 0xC07C9DFA, "player_carry" },
    { 0x190DE759, "player_caught" },
    { 0x58B2B9F2, "player_caught_impact" },
    { 0xE7BFEC32, "player_causes_point_to_move" },
    { 0x58EC6AC9, "player_celerium" },
    { 0xAEB4F38A, "player_center_view" },
    { 0xFDDD6743, "player_change_seat_handler_t" },
    { 0xD3D0C055, "player_changed_seat" },
    { 0x2F672D06, "player_character" },
    { 0x08561E0C, "player_character_name" },
    { 0x7D5068D9, "player_character_util" },
    { 0x3CC2B5D1, "player_chute_deployed" },
    { 0xF2317562, "player_chute_height" },
    { 0x30A34B79, "player_claimed_fully" },
    { 0xDE6A4E4F, "player_class" },
    { 0x74FF8A9B, "player_classes" },
    { 0x30E7D9F2, "player_claw_idle_death_timeout" },
    { 0x8002EFAA, "player_cleanupongameended" },
    { 0xF7B4287B, "player_cleanuponteamchange" },
    { 0x482D9F5A, "player_cleared_bunker1" },
    { 0x86E0F3FC, "player_client" },
    { 0x8CF6EF47, "player_climbs_first_ladder" },
    { 0x33D11D50, "player_climbs_tree_confuses_ai" },
    { 0xB0DDE48B, "player_climbs_up_started" },
    { 0x6FEC201F, "player_clip" },
    { 0x58282D02, "player_clip_exit" },
    { 0x5BCA0486, "player_clip_opening" },
    { 0xA000E134, "player_clone_activated" },
    { 0x759ADC5B, "player_close" },
    { 0x202274A6, "player_close_enough_to_riders" },
    { 0x278C4087, "player_close_enough_to_sampan" },
    { 0x72BB9CBA, "player_closest" },
    { 0xBB2A118B, "player_cmd" },
    { 0x36F550DF, "player_collision" },
    { 0xF0F3F1D3, "player_collision_fix" },
    { 0x6D697E85, "player_color_node" },
    { 0x8BC902C3, "player_combatdismountanimloop" },
    { 0x8614141E, "player_combatidleanimloop" },
    { 0x32CDFF3E, "player_comitted" },
    { 0x920B1537, "player_commands_ai_to_fire" },
    { 0x294E5688, "player_committed_suicide" },
    { 0xC074D0B7, "player_completed_cycle" },
    { 0x6C472D75, "player_connect" },
    { 0x93D89F67, "player_connect_gump" },
    { 0x56A6E91E, "player_context" },
    { 0x47EDB35B, "player_contextual_button_press" },
    { 0x53DE28FB, "player_contextual_kill" },
    { 0xBA7644AD, "player_contextual_start" },
    { 0x4BBAA6B1, "player_continue_building" },
    { 0x2948B557, "player_continue_crafting" },
    { 0x29731E06, "player_contract_event" },
    { 0x40ACBCB9, "player_contract_events" },
    { 0x455A2C41, "player_control_during_ride" },
    { 0x77A4879D, "player_control_ends" },
    { 0xC65BEA3C, "player_control_hind" },
    { 0x5C22094F, "player_control_of_boat_starts" },
    { 0x9B247F7D, "player_control_of_boat_weapon_overheating" },
    { 0x0867FCC7, "player_controllable_rappel" },
    { 0xF7B7FE22, "player_controlled_20mm_cannon" },
    { 0x1D93E614, "player_controlled_20mm_cannon_msg" },
    { 0xC0954590, "player_controlled_boat" },
    { 0xB0E677BE, "player_controlled_heli" },
    { 0x3B73B483, "player_controls_activated" },
    { 0x4D233761, "player_controls_for_f38" },
    { 0x8D51BC6F, "player_convoy_watch" },
    { 0x183F3DCE, "player_cost" },
    { 0x7E2762A3, "player_cougar_init" },
    { 0xF66A95AD, "player_cough" },
    { 0x693245C6, "player_count" },
    { 0x8A1ADF37, "player_count_actual" },
    { 0x595B1B79, "player_counts" },
    { 0xFB3DE6FE, "player_cover" },
    { 0xB1AA6C11, "player_cover_blown" },
    { 0x921A0DF2, "player_cover_blown_flag" },
    { 0xFD265B7E, "player_cover_fire_kills_think" },
    { 0x82383060, "player_cover_fire_start" },
    { 0x84EBD65E, "player_covertrigger" },
    { 0x7317301E, "player_covertype" },
    { 0x70234985, "player_craft" },
    { 0x24350E72, "player_crafted" },
    { 0x971BA6C9, "player_crawling_stage" },
    { 0x1DE51339, "player_crossbow_position" },
    { 0xFDC4AECD, "player_current_index" },
    { 0x0AC9E66F, "player_current_stat_value" },
    { 0x846AF699, "player_current_zone" },
    { 0x0B637ECF, "player_cut_grigs_loose" },
    { 0x4BD130F6, "player_damage" },
    { 0xBA502149, "player_damage_ads" },
    { 0x4EC66AD0, "player_damage_callback" },
    { 0xA34C06BB, "player_damage_callbacks" },
    { 0x96491168, "player_damage_dealt_per_minute" },
    { 0x417BAE51, "player_damage_dealt_ratio" },
    { 0x6A9A46FE, "player_damage_difficulty_modifier" },
    { 0x5A53278D, "player_damage_does_friendly_fire_damage_attacker" },
    { 0x35DC792C, "player_damage_does_friendly_fire_damage_victim" },
    { 0xEEC936DB, "player_damage_equipment" },
    { 0xB168504F, "player_damage_figure_out_weapon" },
    { 0x6CD577A9, "player_damage_helicopter_override" },
    { 0xD71741F0, "player_damage_is_friendly_fire_at_round_start" },
    { 0x4C74C235, "player_damage_log" },
    { 0xF1A84CBB, "player_damage_only" },
    { 0x37246A45, "player_damage_override" },
    { 0xC1CA5F29, "player_damage_override_callback" },
    { 0xED07539D, "player_damage_override_cheat" },
    { 0xCD28D5C6, "player_damage_override_for_apache" },
    { 0xC3E5E4BA, "player_damage_riotshield_hit" },
    { 0xFDF3C1F2, "player_damage_rocketshield" },
    { 0x5AD54F92, "player_damage_shield" },
    { 0x9F789DA5, "player_damage_taken_per_minute" },
    { 0xFFE76B92, "player_damage_taken_ratio" },
    { 0xEE8F35AC, "player_damage_through_huey" },
    { 0xB30BBF32, "player_damage_time" },
    { 0x6CBA068C, "player_damage_type_changed" },
    { 0x1A949060, "player_damage_update_attacker" },
    { 0x19A0A019, "player_damage_update_explosive_info" },
    { 0x99C0A49B, "player_damage_watcher" },
    { 0x7C90079F, "player_damagemultiplier" },
    { 0xFBB60276, "player_datapad_claw_anim" },
    { 0x51A0D4EF, "player_dead" },
    { 0xAC593263, "player_deadshot_perk_handler" },
    { 0xF1C5BA35, "player_death" },
    { 0xE96899F3, "player_death_blur" },
    { 0x8BFA6AD9, "player_death_detection" },
    { 0xEF7A956B, "player_death_effect" },
    { 0xDD7AE6B2, "player_death_fx" },
    { 0x23FE4143, "player_death_invulnerability_time" },
    { 0x5BFC6BC0, "player_death_off_turret" },
    { 0x3F62F90D, "player_death_vo" },
    { 0x55B8CC10, "player_death_watch_on_giant_robot" },
    { 0x6374B9A0, "player_death_watcher" },
    { 0x18F5CE73, "player_death_watcher_custom_func" },
    { 0xD4E4151B, "player_deathinvulnerabletime" },
    { 0x6AB88489, "player_deathinvulnerabletimeout" },
    { 0x1408377F, "player_deathshieldwatch" },
    { 0xA3D318DC, "player_deck_callback" },
    { 0xDE5289F0, "player_defend_dialog" },
    { 0xF8E8B8D9, "player_delta" },
    { 0x5A3CC6FE, "player_dest_origin" },
    { 0xDFD94B3B, "player_destination" },
    { 0xBD6B1A58, "player_destroy_door_time" },
    { 0xBAE7D22A, "player_destroy_piece" },
    { 0xA8BCE73F, "player_detected" },
    { 0x56A9B894, "player_detected_logic" },
    { 0x169FE2C9, "player_detection_collect" },
    { 0xD3050FF1, "player_detection_logic" },
    { 0x762D5EB7, "player_detection_loop" },
    { 0xC9BC7300, "player_detection_volume_init" },
    { 0x3CC244B2, "player_dialog_over_black" },
    { 0xB8F68724, "player_did_a_revive" },
    { 0xD73561CB, "player_did_ads" },
    { 0x885D2FEF, "player_did_attack" },
    { 0x4D4E780A, "player_did_most_damage" },
    { 0x353E1942, "player_die_in_chamber" },
    { 0x5264698F, "player_died" },
    { 0x08D97EE9, "player_died_penalty" },
    { 0x02EA52E2, "player_died_recently" },
    { 0x396ABB7C, "player_died_recently_degrades" },
    { 0xC3484AA3, "player_difficulty_health" },
    { 0x29D71BA8, "player_digger_instant_kill" },
    { 0xB72E1C46, "player_dir" },
    { 0x63A5EC34, "player_directional_monitor" },
    { 0x3E1A04B2, "player_directional_warning" },
    { 0xDD3096AF, "player_dis" },
    { 0x317EB8F7, "player_disable_invulnerability" },
    { 0xEDD8D1B5, "player_disable_weapons" },
    { 0x274675EF, "player_disconnect_callback" },
    { 0x60A98C86, "player_disconnect_counter" },
    { 0xA6478F46, "player_disconnect_watcher" },
    { 0x5D43A9F1, "player_disconnect_watcher_custom_func" },
    { 0x413E02C0, "player_disconnected" },
    { 0x98B402A2, "player_dismount_anim" },
    { 0x2424D8B3, "player_dismounted_from_gun" },
    { 0xA95DBDE9, "player_dist" },
    { 0x9F0AD974, "player_distance" },
    { 0xBC07A7DF, "player_distsqrd" },
    { 0x76E22D2B, "player_dive" },
    { 0xF0A687BE, "player_dive_done" },
    { 0xFC1BE86A, "player_dive_text_instruction" },
    { 0x03391A97, "player_dmg_reducerfps" },
    { 0xCC5811FB, "player_do_knuckle_crack" },
    { 0x3169A65D, "player_done" },
    { 0x8CFD3ACD, "player_done_with_meatshield" },
    { 0x8FACCBC7, "player_door_breack_effects" },
    { 0x38660766, "player_door_kick" },
    { 0xF6926C9F, "player_door_opened" },
    { 0xE6AC5EBA, "player_door_pos" },
    { 0xE8D0B7FB, "player_door_rumble" },
    { 0xD6FF7CCD, "player_down" },
    { 0x5CC39B7A, "player_downed" },
    { 0x0E6B122C, "player_downed_penalty" },
    { 0xCADF8EF6, "player_drained" },
    { 0xD80E6D7F, "player_draw_chalk" },
    { 0x6A8549BC, "player_drift_linker" },
    { 0x86E291CF, "player_driven" },
    { 0xBEC4D4E3, "player_driver" },
    { 0x40A0E7BE, "player_driving" },
    { 0xE11B15CA, "player_driving_boat_again" },
    { 0x578D6154, "player_drone_chopper_damage_scale" },
    { 0xEE6A79CC, "player_drone_crashes_with_boss_chopper_update" },
    { 0x01C0FF64, "player_drone_damage_ignore" },
    { 0x691D5406, "player_drone_damage_override" },
    { 0xA4EA2EAC, "player_drone_damage_states" },
    { 0x36C773E3, "player_drone_fatal_collision" },
    { 0xE28EE149, "player_drone_fatal_collision_starts" },
    { 0x0ABA4173, "player_drone_speed_control" },
    { 0xF733C1C2, "player_drone_speed_scale" },
    { 0x33D243A3, "player_drone_vehicle_kill" },
    { 0x441E3EF5, "player_drop_piece" },
    { 0x987A9C58, "player_drop_piece_on_death" },
    { 0x2CEEDA59, "player_drop_piece_on_downed" },
    { 0xCBB2BCCF, "player_dropdown_scaffold" },
    { 0x7AF49131, "player_dropdown_scaffolding" },
    { 0x15CD2764, "player_dropped_down" },
    { 0xF3D80C6A, "player_drops_tesla_gun" },
    { 0xF75FEE4A, "player_drown_fx" },
    { 0x27D0E46C, "player_duplicaterender" },
    { 0x913FAB8D, "player_dynents_start" },
    { 0x390A8DC1, "player_dynents_think" },
    { 0x89EB445C, "player_eaten_by_thrasher" },
    { 0xFF308D4D, "player_eject_watcher" },
    { 0x99423ADB, "player_ejected" },
    { 0x724EBDFA, "player_elec_damage" },
    { 0xE191D9F6, "player_electrify" },
    { 0x10A2E0F5, "player_eligible_for_death_invulnerability" },
    { 0x51039135, "player_eliminated" },
    { 0x43FA71D7, "player_emp_off" },
    { 0xDAF80563, "player_emp_on" },
    { 0xFF636228, "player_enable_invulnerability" },
    { 0xB95B0446, "player_enable_weapons" },
    { 0x9456178B, "player_end_point" },
    { 0xFA39B568, "player_end_slowmo" },
    { 0x043D96E1, "player_end_water_clip" },
    { 0x26AE4CC8, "player_ending" },
    { 0x322C895B, "player_endon" },
    { 0x0DA0B71C, "player_engaged" },
    { 0x979C1EDB, "player_enraged_thrasher" },
    { 0x39049E40, "player_ent" },
    { 0x5CB86F69, "player_ent_index" },
    { 0xC49D3115, "player_enter" },
    { 0x7F900DA2, "player_enter_animation" },
    { 0x8AB6A218, "player_enter_exit" },
    { 0x316DFD8E, "player_enter_f35" },
    { 0xCC4664A8, "player_enter_jetwing" },
    { 0x0086A70F, "player_enter_the_hut" },
    { 0xBA920C56, "player_enter_tow" },
    { 0xB7D8C85F, "player_enter_van_ending" },
    { 0x6949B848, "player_enter_van_trig" },
    { 0x7270C83F, "player_enter_zipline" },
    { 0x59400A42, "player_entered" },
    { 0x393C2433, "player_entered_bank" },
    { 0xE00750FC, "player_entered_dept" },
    { 0x6506F989, "player_entered_heli" },
    { 0xD2B8F44D, "player_entered_mission_courtyard" },
    { 0x8B6F8E4E, "player_entered_safety_light" },
    { 0x099C8488, "player_entered_safety_zone" },
    { 0x0C28346F, "player_entered_trigger" },
    { 0x9BCF1C47, "player_entered_tunnel" },
    { 0x721EDA13, "player_entering" },
    { 0xBAD64F7C, "player_enters_apartment_rubble_area" },
    { 0x1282610A, "player_enters_hanger" },
    { 0x251A44D0, "player_enters_laundrymat" },
    { 0xA100F37C, "player_enters_second_floor" },
    { 0xB23421B4, "player_entity" },
    { 0xDD5EA220, "player_entnum" },
    { 0x190C907B, "player_eq_count" },
    { 0xEFCA0EE1, "player_equip_suit" },
    { 0x7E8226C6, "player_erik_neckshot" },
    { 0x26E6FA15, "player_escaped_gondola_failsafe" },
    { 0x82FE415A, "player_escapes_war_room" },
    { 0x80BCEE34, "player_evac" },
    { 0x51EE4ECF, "player_exert_id" },
    { 0x8798F0C9, "player_exists" },
    { 0x1FEF4EC9, "player_exit" },
    { 0x45A5CED6, "player_exit_animation" },
    { 0xC73CE603, "player_exit_base_on_horse" },
    { 0xC7FC181B, "player_exit_gas_room" },
    { 0x6117716E, "player_exit_level" },
    { 0x6CDAE46A, "player_exit_tow" },
    { 0xB0343563, "player_exit_zipline" },
    { 0x88EB9FF6, "player_exited" },
    { 0x71504C3D, "player_exited_heli" },
    { 0xFC239683, "player_exited_truck_turret" },
    { 0xBDA4B8CB, "player_exits_f35" },
    { 0x256B8200, "player_exits_giant_robot_head_trigger_think" },
    { 0x52828809, "player_exits_house" },
    { 0xAEE49E21, "player_exits_hummer" },
    { 0x30FA6501, "player_explode_buildable" },
    { 0x0232B4DF, "player_explode_craftable" },
    { 0xED5B12AB, "player_explosion_fx" },
    { 0x31DB38EF, "player_exposed" },
    { 0x74AE8134, "player_eye" },
    { 0x55E6FF0A, "player_eye_color_clientfield_cb" },
    { 0x73F54EB8, "player_eye_fake" },
    { 0xA1573577, "player_eye_pos" },
    { 0xCE64916D, "player_eyeinthesky" },
    { 0x52D3DF9B, "player_eyes_clientfield_cb" },
    { 0x5D2AD9FC, "player_f38" },
    { 0x59972FE4, "player_face_forward" },
    { 0xE2231FDE, "player_fade_out_drown_fx" },
    { 0x1E484ACD, "player_fail_if_two_zsus_are_alive" },
    { 0xB03B617A, "player_failed" },
    { 0xBFDD7AD7, "player_failed_clearing_runway" },
    { 0xDA1CF4FC, "player_failed_mortar_run" },
    { 0x40009ECE, "player_failed_revive" },
    { 0x1B52140F, "player_fails_blocker_repair_trigger_preamble" },
    { 0xE69C3B79, "player_fails_mission_if_stealth_broken" },
    { 0x9CA3877F, "player_fails_to_jump_to_barge" },
    { 0x68DB3F30, "player_fake_corpse_created" },
    { 0xCF62D8C1, "player_fake_death" },
    { 0x923D51EF, "player_fallback_points" },
    { 0x812B298B, "player_fallen" },
    { 0x03FD0EC6, "player_fan_trap_damage" },
    { 0xA57BF4E4, "player_fastrope_go" },
    { 0xA74EF5DB, "player_favourate_enemy" },
    { 0x30E56009, "player_finish_buildable" },
    { 0xF481B8A7, "player_finish_craftable" },
    { 0xA258EAD7, "player_finish_dist" },
    { 0xA81F62F8, "player_finished_drag_anim" },
    { 0x9D4D52F3, "player_fire_damage" },
    { 0xB9BAD748, "player_fire_think" },
    { 0x9D3D995E, "player_fire_update_rocket" },
    { 0xBF3C27F8, "player_fire_update_side_turret_1" },
    { 0x31439733, "player_fire_update_side_turret_2" },
    { 0x222FC2E8, "player_fire_watcher" },
    { 0x0D5BECE3, "player_fired" },
    { 0x77281866, "player_fired_detonator" },
    { 0x059E0281, "player_fired_rockets" },
    { 0x93860DDC, "player_fires" },
    { 0x14609F97, "player_fires_weapon" },
    { 0x418D9B9F, "player_first_frame" },
    { 0x39660817, "player_flag" },
    { 0x98FDFD8C, "player_flag0_handler" },
    { 0x64583805, "player_flag_clear" },
    { 0x13AC8584, "player_flag_init" },
    { 0x4ECFBA8A, "player_flag_set" },
    { 0xEEFB7AF9, "player_flag_set_delayed" },
    { 0x3DA1B3A1, "player_flag_wait" },
    { 0x15C06DF7, "player_flag_wait_either" },
    { 0xFBC36F45, "player_flag_waitopen" },
    { 0x25E48773, "player_flag_wet_handler" },
    { 0x2330C03F, "player_flak_jacket_override" },
    { 0x9BD0CCA6, "player_flakjacket_damage_override" },
    { 0x4A043C0A, "player_flame_bunker" },
    { 0x357F7286, "player_flame_damage" },
    { 0xD5513B97, "player_flanks_right_or_goes_straight" },
    { 0x77BEA641, "player_flash" },
    { 0x312E8BBC, "player_flashback" },
    { 0xA3C4AC2E, "player_flashed" },
    { 0xA587A257, "player_flashlight_enable" },
    { 0x69F422F7, "player_flashlight_pistol" },
    { 0xC38A9A9E, "player_flashlight_remove" },
    { 0xDBE26715, "player_fling" },
    { 0x5EF59A64, "player_fly_rumble" },
    { 0x42BE3C08, "player_flying" },
    { 0xE09BEBD2, "player_fog_switch" },
    { 0xE41D02E4, "player_follow_struct_chain" },
    { 0x7B594312, "player_for" },
    { 0xD17B808A, "player_force_from_prone" },
    { 0xACFF40AA, "player_force_walk" },
    { 0x687EA2E4, "player_forced_out_tow" },
    { 0x344CF538, "player_forward" },
    { 0x0782C3EF, "player_forward_vec" },
    { 0x13632CB6, "player_fov" },
    { 0x3FB409CD, "player_frag" },
    { 0xCC58CDA2, "player_freeze_in_place" },
    { 0xFADA9406, "player_friendly_fire_callbacks" },
    { 0x4BA474DD, "player_from_touchlist" },
    { 0xF07FBD3B, "player_front_trigger" },
    { 0xBF8645AC, "player_fudge_move_rotate_to" },
    { 0x2C439E81, "player_fudge_moveto" },
    { 0x570AD2CF, "player_fudge_rotateto" },
    { 0x1D37D5B1, "player_fullahead" },
    { 0x554EFC51, "player_fvec" },
    { 0x008F1553, "player_gas_death" },
    { 0x49A756C2, "player_gas_room" },
    { 0xFE52E78C, "player_gasmask_anim" },
    { 0x53C62160, "player_gasp_rumble" },
    { 0x8B0A36DC, "player_get_bazooka_reminder" },
    { 0x2CE8A34D, "player_get_buildable_piece" },
    { 0x6DF7E3CC, "player_get_buildable_pieces" },
    { 0x43F48DC7, "player_get_craftable_piece" },
    { 0x5F7B8D96, "player_get_equipment_damage" },
    { 0x9E79E1CE, "player_get_loadout" },
    { 0x5895EC05, "player_getout" },
    { 0xBC458665, "player_getout_sound" },
    { 0xE044D857, "player_getout_sound_end" },
    { 0xDB8B3182, "player_getout_sound_loop" },
    { 0x396F27DC, "player_gets_ahead" },
    { 0xD2B9B6D6, "player_gets_ambushed" },
    { 0xE60A40EB, "player_gets_captured" },
    { 0x1A048A6B, "player_gets_commando" },
    { 0x42A7296F, "player_gets_flamethrower" },
    { 0x1B06F945, "player_gets_on_barret" },
    { 0xC4D7B1E5, "player_gets_on_heli" },
    { 0xD8E050CA, "player_gets_weapons_back" },
    { 0xDB0C55C6, "player_getting_close" },
    { 0x9754987C, "player_getting_on_ladder" },
    { 0x935A9CDA, "player_getting_on_sampan" },
    { 0x590A49B2, "player_getup_setup" },
    { 0xB1E9228E, "player_getvelocity_pc" },
    { 0xE7C975F0, "player_geyser_move" },
    { 0x26A12238, "player_geyser_move_wait" },
    { 0x5726BDA1, "player_give_beacon" },
    { 0x5ED4FD4E, "player_give_black_hole_bomb" },
    { 0xF5EA9985, "player_give_cymbal_monkey" },
    { 0x6E1D44A0, "player_give_cymbal_monkey_upgraded" },
    { 0x33B15174, "player_give_emp_bomb" },
    { 0x034F8C1C, "player_give_grenades" },
    { 0xF575195B, "player_give_loadout" },
    { 0x95BBC121, "player_give_lsat" },
    { 0xF2E5F766, "player_give_nesting_dolls" },
    { 0x82E4A388, "player_give_octobomb" },
    { 0xAE90088B, "player_give_octobomb_upgraded" },
    { 0x43DFE2F7, "player_give_quantum_bomb" },
    { 0x1DD629F1, "player_give_time_bomb" },
    { 0x79FD2A17, "player_giveachievement_wrapper" },
    { 0x2FA16464, "player_given" },
    { 0x5CDDC9DA, "player_gives_sloth_candy" },
    { 0x90FC72BB, "player_go" },
    { 0x46AAD104, "player_go_straight" },
    { 0x712F8C97, "player_god_off" },
    { 0xE2396E23, "player_god_on" },
    { 0x748FB38A, "player_goes_back_to_heat_area" },
    { 0x8D2D5311, "player_goes_middle" },
    { 0x2C458884, "player_goes_prone" },
    { 0x44381BEC, "player_goes_right" },
    { 0xC3CA6EC4, "player_got_close" },
    { 0x89425EB4, "player_got_craftable_piece_for_" },
    { 0x3AC86013, "player_got_flamethrower_after_obj" },
    { 0x07C96EBF, "player_got_m202" },
    { 0x81B58A4D, "player_got_machete" },
    { 0x72259AEC, "player_got_strela_first" },
    { 0x3730B06F, "player_goto_cache" },
    { 0xA202781E, "player_goto_drums" },
    { 0x824FB8D4, "player_grab_pitchfork" },
    { 0x25F443A8, "player_grabbed" },
    { 0xEF722FB7, "player_grabbed_pitchfork" },
    { 0x76356E3D, "player_grabs_crossbow" },
    { 0xA181672F, "player_grabs_crossbow_anim" },
    { 0xC90BBE94, "player_grabs_menendez_in_meatshield_hold" },
    { 0xDF79183D, "player_grabs_pilot" },
    { 0x454D9E69, "player_grabs_woods" },
    { 0xF8BEF5A9, "player_grenade" },
    { 0xEC106904, "player_grenade_check" },
    { 0x8DB29F8E, "player_grenade_check2" },
    { 0xF7F5E75B, "player_grenade_multiattack_bookmark_watcher" },
    { 0xA961B784, "player_grenade_watcher" },
    { 0xDFFCC19B, "player_group_think" },
    { 0x2D6B9312, "player_hack" },
    { 0xD646D3EE, "player_hack_disconnect_watcher" },
    { 0x1000E524, "player_hacker_tool_breaching" },
    { 0x2F7A676F, "player_hacker_tool_hacked" },
    { 0x10F4FC3C, "player_hacker_tool_hacking" },
    { 0xE5F6C41E, "player_hacking" },
    { 0x42766528, "player_hacking_callback" },
    { 0xB684BC2C, "player_half_height" },
    { 0x96588EBE, "player_handle_beacon" },
    { 0xEF1268C3, "player_handle_black_hole_bomb" },
    { 0xBD419AA0, "player_handle_cymbal_monkey" },
    { 0x1355F94F, "player_handle_emp_bomb" },
    { 0x964187BF, "player_handle_octobomb" },
    { 0xD6EB881C, "player_handle_quantum_bomb" },
    { 0x7EF475F1, "player_hands" },
    { 0xC33CD4F6, "player_hands_waco" },
    { 0xB1BAC18D, "player_has_all_available_perks" },
    { 0x44E0AD1C, "player_has_ammo" },
    { 0x7E7D78D9, "player_has_ball" },
    { 0xCEE94F3F, "player_has_bazooka" },
    { 0xB633F4E0, "player_has_bowie" },
    { 0xCB3885A5, "player_has_charge_weapon" },
    { 0x71F8D934, "player_has_chugabud_corpse" },
    { 0x60DE05CE, "player_has_explosive_weapon_equipped" },
    { 0xE7728193, "player_has_javelin" },
    { 0xD5B543C1, "player_has_jumped" },
    { 0x8AA55A3B, "player_has_key" },
    { 0x3AAB49E2, "player_has_launcher" },
    { 0x3B55F2E7, "player_has_meat" },
    { 0xAD088D18, "player_has_mortars" },
    { 0xC06C2A8E, "player_has_mule_kick" },
    { 0x5CC59155, "player_has_olympia" },
    { 0xA28473C4, "player_has_raygun" },
    { 0xEA3833AF, "player_has_rpg" },
    { 0x16548F8E, "player_has_shot" },
    { 0x7796F358, "player_has_silenced_weapon" },
    { 0xE44CAA36, "player_has_sniper_weapon" },
    { 0xCEB44F18, "player_has_staff" },
    { 0xEAC22C48, "player_has_stinger" },
    { 0xE30512DD, "player_has_strela" },
    { 0xAA1A2ED4, "player_has_unclaimed_team_reward" },
    { 0x4B40DA02, "player_has_used_ads" },
    { 0xF2546479, "player_has_used_primary_fire" },
    { 0x5F9117B6, "player_has_weapon" },
    { 0xEEB24F26, "player_has_weapon_substr" },
    { 0xE8DBD7E1, "player_hater" },
    { 0x61350E88, "player_haters" },
    { 0x3C111823, "player_head_look" },
    { 0x5058B267, "player_heading_to_dock" },
    { 0xC34B1E0D, "player_heading_upstairs" },
    { 0x20DE21EC, "player_heads_towards_apartment" },
    { 0xAB71137F, "player_headsci_start" },
    { 0x1AFE453D, "player_headset" },
    { 0x6C5724EF, "player_health" },
    { 0x2DC30019, "player_health_hud" },
    { 0x33A8ABED, "player_health_packets" },
    { 0x28C29E3D, "player_health_regen" },
    { 0xCA8614E9, "player_health_shield" },
    { 0x8F07D3EA, "player_health_visionset" },
    { 0xE3A8CE69, "player_hearbeat" },
    { 0xE7536013, "player_heartbeat" },
    { 0x4F4F83E3, "player_heartbeat_sound" },
    { 0x7A2A0624, "player_height" },
    { 0x571186AB, "player_height_increase" },
    { 0x829CE667, "player_height_kill" },
    { 0x8FD31EC1, "player_height_times_10" },
    { 0xAB660F01, "player_heli" },
    { 0x0CCECABA, "player_heli1" },
    { 0x616BA1D6, "player_heli_avoidance" },
    { 0xBB961F4C, "player_heli_cross" },
    { 0x392980C0, "player_heli_fire" },
    { 0xCAC2A389, "player_heli_leave" },
    { 0x76A814E1, "player_heli_reset" },
    { 0x4D005A3F, "player_heli_ropeanimoverride" },
    { 0x0F2C4C88, "player_heli_ropeanimoverride_idle" },
    { 0x2F4F0C41, "player_helicopter_crashing_anims" },
    { 0xCD920185, "player_helicopter_player_crashing_anims" },
    { 0x8F74ED77, "player_helo" },
    { 0x6151F8EA, "player_hero_power_event" },
    { 0x2BB37724, "player_hide_craftable_parts_ui_after_duration" },
    { 0x63FCE014, "player_hide_turrets_from_other_players" },
    { 0x4728ABA7, "player_hides_body" },
    { 0xB5DBEEBC, "player_hiding" },
    { 0x4FEBCD9C, "player_hit" },
    { 0x9FFC6014, "player_hit_breakout_1" },
    { 0x1203CF4F, "player_hit_breakout_2" },
    { 0xEC0154E6, "player_hit_breakout_3" },
    { 0x1874EB7D, "player_hit_by_frogger_debris" },
    { 0x75C3ED54, "player_hit_debug" },
    { 0xE8EB7286, "player_hit_ground" },
    { 0x4ECCB619, "player_hit_me" },
    { 0x43CDB604, "player_hit_rock_1" },
    { 0xB5D5253F, "player_hit_rock_2" },
    { 0x8FD2AAD6, "player_hit_rock_3" },
    { 0xE400D7E0, "player_hit_rumble" },
    { 0x4540356D, "player_hit_with_chair" },
    { 0x3151CB8A, "player_hits_sustained" },
    { 0x852D7E41, "player_hits_tower" },
    { 0x148E2C15, "player_holding_time_bomb" },
    { 0xDDB49869, "player_horse_behavior" },
    { 0xA1D04D5D, "player_horse_fx" },
    { 0x3B9DD42B, "player_hotel_collision_effects" },
    { 0x619B8BC2, "player_hotjoin" },
    { 0x304A31E9, "player_hud_init" },
    { 0x9E006C7C, "player_hud_update" },
    { 0xB9618193, "player_hunter" },
    { 0xADD24D88, "player_hunter_go" },
    { 0x2E9702C2, "player_hunters" },
    { 0xBFDC5901, "player_hurt_fire" },
    { 0xB0C6821B, "player_idle" },
    { 0x8BD0DA91, "player_idle_anim" },
    { 0x3D64F026, "player_idx" },
    { 0x831961CE, "player_ignores_triggers" },
    { 0xCC65D046, "player_immunity_override" },
    { 0xAA567A62, "player_in_alley" },
    { 0x2FEB29DE, "player_in_alley_watch" },
    { 0xDB4B151D, "player_in_balcony" },
    { 0x7CCF00BD, "player_in_blastradius" },
    { 0xC4ACCF59, "player_in_boat" },
    { 0x2FA8B940, "player_in_bounds" },
    { 0xAD575991, "player_in_btr" },
    { 0xD9BCE31C, "player_in_building1" },
    { 0x371F9885, "player_in_c4bunker" },
    { 0x3AA8D58B, "player_in_car" },
    { 0xFD78CF4B, "player_in_chamber" },
    { 0xD2AFC09E, "player_in_cockpit" },
    { 0x4E362392, "player_in_control" },
    { 0x9BA9E977, "player_in_control_controls" },
    { 0x9C7563AC, "player_in_cougar" },
    { 0x8ECB149B, "player_in_drone" },
    { 0x9A65BF58, "player_in_exploit_area" },
    { 0x46D9F65B, "player_in_f35" },
    { 0x0E3944E0, "player_in_front" },
    { 0x9F0F37BE, "player_in_gas" },
    { 0x7B1A60E5, "player_in_ghost_zone" },
    { 0xC8C9DDDA, "player_in_ghost_zone_monitor" },
    { 0x6BEFFB32, "player_in_hangar" },
    { 0x664D93DE, "player_in_hanger" },
    { 0x02895158, "player_in_helicopter" },
    { 0x62F51719, "player_in_house" },
    { 0x4DF7D0BC, "player_in_kill_zone" },
    { 0xD65089D6, "player_in_last_stand_within_range" },
    { 0x4905E77E, "player_in_minefield" },
    { 0xF15335E6, "player_in_office_trigger" },
    { 0xA65AB493, "player_in_open" },
    { 0x8F402C19, "player_in_or_out" },
    { 0x081D9498, "player_in_pack" },
    { 0x0CCAD6E7, "player_in_plane" },
    { 0xB4C9998F, "player_in_position_for_drag" },
    { 0x5A09845C, "player_in_screecher_zone" },
    { 0xF33E0A9E, "player_in_secondroom" },
    { 0x5A61E700, "player_in_soct" },
    { 0x6D51CCBC, "player_in_soct_keep_moving_fail" },
    { 0x3C781571, "player_in_soct_keep_up_with_salazar_fail" },
    { 0x92F6A7F0, "player_in_swroom" },
    { 0xC33CB673, "player_in_tank" },
    { 0x7F435C47, "player_in_the_open" },
    { 0xD9022C60, "player_in_view" },
    { 0x2CCD041C, "player_in_vtol" },
    { 0x43A02284, "player_in_warehouse" },
    { 0x98D86E28, "player_in_water" },
    { 0x498A7A1D, "player_in_zone" },
    { 0xE8B01B3B, "player_index" },
    { 0xB8689E82, "player_infinite_ammo" },
    { 0x284CE393, "player_inflicted_damage" },
    { 0x5997F521, "player_influencer_radius" },
    { 0x5B1A1917, "player_influencer_score" },
    { 0x8B8B26C2, "player_influencers_set_team" },
    { 0x49DA0773, "player_info_string" },
    { 0xF0675715, "player_infront" },
    { 0x536049A7, "player_init" },
    { 0x65934191, "player_init_color_grouping" },
    { 0x5CC9485D, "player_init_drown_values" },
    { 0xEB52B46E, "player_init_shield_health" },
    { 0x70C25EA1, "player_init_shield_location" },
    { 0x2603896C, "player_inited" },
    { 0x5CE22BD9, "player_initial_prep_time" },
    { 0xAB0E62D5, "player_initialized" },
    { 0x3C337245, "player_inopen_check" },
    { 0xC96C6D29, "player_inopen_dialogue" },
    { 0xB4264F33, "player_input_bleed_out" },
    { 0x5D1409A5, "player_input_revive" },
    { 0xCBDF5176, "player_input_suicide" },
    { 0x5BA70769, "player_insta_kill_upgrade_check" },
    { 0xE091024D, "player_intemission_spawn_callback" },
    { 0x73E6300A, "player_interact_flag_detach" },
    { 0x256742BB, "player_interaction" },
    { 0x9C660E30, "player_interactive_hands" },
    { 0xA2B79791, "player_interactive_model" },
    { 0xD642EF92, "player_interior_detect_init" },
    { 0x333F42D1, "player_intermission" },
    { 0x3BFA5A5B, "player_intermission_bridge" },
    { 0x94BC582E, "player_intermission_ee" },
    { 0xC13330AD, "player_intermission_prison" },
    { 0x811E07D6, "player_intermission_spawned" },
    { 0xEE2D35A0, "player_interruption" },
    { 0x6B564FBA, "player_intersection_tracker_override" },
    { 0xB17CC69F, "player_into_character" },
    { 0x0F666C3A, "player_into_character_counter" },
    { 0x8D12CC6F, "player_intro_rumble" },
    { 0x256E2BA4, "player_intro_start" },
    { 0x90AF7371, "player_invul_forever" },
    { 0x54877D91, "player_invulnerable_during_gravityspike_slam" },
    { 0x3A1F23C0, "player_invulnerable_for_time" },
    { 0x5B760625, "player_invulnerable_time_tweak" },
    { 0x140934EE, "player_is_ads" },
    { 0xC6622001, "player_is_camping" },
    { 0x99496180, "player_is_close_enough_to_melee" },
    { 0x64E68872, "player_is_driver" },
    { 0xE4777A1C, "player_is_enemy" },
    { 0x38A9AFF8, "player_is_in_laststand" },
    { 0x3F9D7999, "player_is_looking_at" },
    { 0x5735719A, "player_is_menendez" },
    { 0x0AFC273A, "player_is_moving" },
    { 0x3EF127DC, "player_is_near_live_grenade" },
    { 0x5F4A2230, "player_is_near_pad" },
    { 0xF681FD95, "player_is_nikolai" },
    { 0x0683A7BD, "player_is_occupant_invulnerable" },
    { 0xFB542A82, "player_is_on_mg" },
    { 0x2490F8EC, "player_is_on_turret" },
    { 0x712437D5, "player_is_outside" },
    { 0xCEA6D981, "player_is_over_pipe" },
    { 0x8D5CC5DF, "player_is_safe" },
    { 0xC4F6F66D, "player_is_spawn_protected_from_explosive" },
    { 0x0C371D2E, "player_is_speaking" },
    { 0x610FB7DE, "player_is_talking" },
    { 0x335C9E2B, "player_is_wimp" },
    { 0x11EAAFD0, "player_is_wimp_2" },
    { 0x028DC52A, "player_isaac_container" },
    { 0x4B02E090, "player_jam_window_end" },
    { 0x98C129E0, "player_janxed_end_shot" },
    { 0x20D9D1B5, "player_jeep" },
    { 0x37FE27B9, "player_jetwing_land" },
    { 0x89E0B4AC, "player_jolt_view" },
    { 0x58316C2D, "player_jump" },
    { 0xF38BB206, "player_jump_down_gaz_melee" },
    { 0x5E807A6A, "player_jump_into_water" },
    { 0x07ACF3E0, "player_jump_on_boat" },
    { 0xFFC929C6, "player_jump_origin" },
    { 0xA9C6E9AF, "player_jump_punishment" },
    { 0xC85BE32F, "player_jump_water_anim" },
    { 0x0AC71CDA, "player_jumped" },
    { 0xCB1AC125, "player_jumped_first" },
    { 0xBD7E3C09, "player_jumped_in_boat" },
    { 0x94496F13, "player_jumped_off_tank" },
    { 0xC6918D9F, "player_jumped_out" },
    { 0xF0ED822C, "player_jumps" },
    { 0x4E642DD0, "player_jumps_into_heli" },
    { 0xFD682A22, "player_just_got_upstairs" },
    { 0x8D559E46, "player_keep_moving_fail" },
    { 0x970FBC68, "player_keyline_dvar" },
    { 0x3DCB4DE0, "player_keyline_material" },
    { 0x0F86E24D, "player_keyline_material_laststand" },
    { 0x7AFD0443, "player_kick" },
    { 0x6C295369, "player_kick_anim" },
    { 0x279DE446, "player_kick_barrel" },
    { 0x5E652187, "player_kick_grate" },
    { 0x2552CE81, "player_kicks_door" },
    { 0xC0488639, "player_kill" },
    { 0xC0E7487A, "player_kill_bridgebomber" },
    { 0xE9087098, "player_kill_counter" },
    { 0x668E6E98, "player_kill_enemy" },
    { 0x87F3B7CD, "player_kill_ratio" },
    { 0x1C575E66, "player_killed" },
    { 0x81FDC08F, "player_killed_asd" },
    { 0xED9AB3FC, "player_killed_bomber" },
    { 0xB3760D31, "player_killed_civ" },
    { 0x4298D0C4, "player_killed_claw" },
    { 0x104312BF, "player_killed_enemy" },
    { 0xA54513EC, "player_killed_guard" },
    { 0x11A9A99B, "player_killed_helo" },
    { 0x7FEF6BCB, "player_killed_minigun_breach_enemy" },
    { 0x4CFCA215, "player_killed_override" },
    { 0x13CD2718, "player_killed_quad" },
    { 0x7D2C0552, "player_killed_russian_vo" },
    { 0x00AE34B0, "player_killed_sentry" },
    { 0xB66CDF49, "player_killed_shellshock" },
    { 0x63C1EF9C, "player_killed_southern_hill_enemy" },
    { 0x9C4FC391, "player_killed_tank" },
    { 0xF3C7F84D, "player_killed_total" },
    { 0xDDF3B0DA, "player_killed_yemeni" },
    { 0xE6ABB0B4, "player_kills_both_guards_cleanly" },
    { 0xAFC057C8, "player_kills_player" },
    { 0x165DB73E, "player_killstreak_threat_tracking" },
    { 0x9C297E75, "player_killstreak_timer" },
    { 0x5E32252B, "player_knocked_down" },
    { 0xE06C6B33, "player_knocked_down2" },
    { 0xA7D0A065, "player_knuckle_crack_begin" },
    { 0x88A94B9D, "player_knuckle_crack_end" },
    { 0x84F18931, "player_ladder" },
    { 0x8A70A3AE, "player_ladder_clip" },
    { 0x769F2544, "player_landed_rappel" },
    { 0x8062D0CE, "player_lander_fog" },
    { 0x7A944D35, "player_lands" },
    { 0x81195CEF, "player_lands_huey" },
    { 0xD2DB80DA, "player_last_pos" },
    { 0xBF9245E0, "player_last_stand_stats" },
    { 0x4E4DAB57, "player_laststand" },
    { 0x65464684, "player_launch" },
    { 0x0C720BC1, "player_lava_damage" },
    { 0x19CEEA6E, "player_leaper" },
    { 0x2836205E, "player_learns_to_zoom" },
    { 0x087A60A3, "player_leave_vehicle_cleanup_t" },
    { 0xFFB83D8A, "player_leaves_e1_early" },
    { 0x9A4CADEA, "player_leaving_bp2_onfoot" },
    { 0x5D3967E1, "player_leaving_bp3_onfoot" },
    { 0x4094FCD6, "player_left_bunker" },
    { 0x6603886B, "player_left_docks" },
    { 0x92742617, "player_left_zone" },
    { 0x56712266, "player_leftstick" },
    { 0x00CA94F7, "player_leftstick_x" },
    { 0xDAC81A8E, "player_leftstick_y" },
    { 0xA2AB0AFE, "player_legs" },
    { 0xACE6E535, "player_lightning_manager" },
    { 0x794A67E2, "player_line_thread" },
    { 0x7B2E0A3A, "player_lingers_by_nearmiss" },
    { 0x3FD07345, "player_link" },
    { 0x0D8886A8, "player_link_tag" },
    { 0xB593D26B, "player_link_update" },
    { 0xAD18C27C, "player_link_update_delta" },
    { 0xDE90ACB2, "player_linked_absolute" },
    { 0xE5B0D894, "player_linker" },
    { 0xD82BEFED, "player_linkto_delta" },
    { 0x2F179D4C, "player_linkto_flagbearer" },
    { 0x0081C115, "player_linkto_function" },
    { 0x1EA0C33F, "player_linkto_remote" },
    { 0xFF1D0ECF, "player_loadout" },
    { 0x123ABCBA, "player_loadout_jeep" },
    { 0xBE13B5D0, "player_loadout_options" },
    { 0xD934C571, "player_loadout_slots" },
    { 0x48D90B5C, "player_location" },
    { 0x7D553AC6, "player_lock_control" },
    { 0x55AEC5A4, "player_lock_in_position" },
    { 0xFB1FEAF3, "player_lock_stance" },
    { 0x5CD37890, "player_look" },
    { 0x592D1963, "player_look_at_door" },
    { 0x836BCDAD, "player_look_at_me" },
    { 0x25D029FD, "player_look_check" },
    { 0x50B0B0B7, "player_look_down" },
    { 0x07AC5A28, "player_look_wait_timeout" },
    { 0xED719931, "player_lookat_ent" },
    { 0xF1BC8C34, "player_lookdown" },
    { 0x99DAB1D8, "player_looking_at" },
    { 0xC5523745, "player_looking_at_burning_man" },
    { 0x7A4A59BB, "player_looking_at_mechz_watcher" },
    { 0x07EA109A, "player_looking_at_savimbi" },
    { 0x6EF0E952, "player_looking_at_savimbi_reveal" },
    { 0xF5F8E848, "player_looking_at_target" },
    { 0x2E851EBA, "player_looks_away_from_spawner" },
    { 0xBC01F41D, "player_looks_up" },
    { 0x35040907, "player_lookup" },
    { 0xB5DD9633, "player_loses_if_price_dies" },
    { 0xAD25CAAB, "player_lost_blundersplat_watcher" },
    { 0x3094D4A4, "player_lost_time_bomb" },
    { 0x19F976DD, "player_lost_weapon_" },
    { 0xE13222FA, "player_lower_weapons" },
    { 0x41BA5350, "player_lowready_state" },
    { 0xA8AE7953, "player_m202_aim_dialog" },
    { 0xD80E1E2A, "player_made_it" },
    { 0xAC2F50A1, "player_made_it_to_seaknight" },
    { 0xAD7B0C3D, "player_mansion_clip" },
    { 0x7740C520, "player_mashing_buttons" },
    { 0x00333B97, "player_mask_ent" },
    { 0x78359E3A, "player_mason_current_weapon" },
    { 0xEF203CF6, "player_max_ammo" },
    { 0xA188064E, "player_max_health" },
    { 0x5DC8CE55, "player_max_speed" },
    { 0x818602B8, "player_meatshield_anims" },
    { 0x1B0FB7E8, "player_meatshield_facing_rumble" },
    { 0x28BDF3A3, "player_meatshield_move_and_rotate" },
    { 0xC408157B, "player_meatshield_ready" },
    { 0xB8A1392F, "player_melee" },
    { 0xE9982E12, "player_melee_camo" },
    { 0x9976AC16, "player_melee_down_time" },
    { 0xB2749C1E, "player_message" },
    { 0xCD7EE53D, "player_metalstorm" },
    { 0xC2BD4584, "player_mg_fire" },
    { 0x0BCFFD5F, "player_mg_laser_hint" },
    { 0x1CA1D01A, "player_mg_reminder" },
    { 0x9881DEEA, "player_millibar_scene" },
    { 0x8CCF4263, "player_mine_dist" },
    { 0xCAE8F2A8, "player_minigun_invulnurablility_interval" },
    { 0xCF274C07, "player_minigun_max_damage" },
    { 0x2991C17C, "player_minigun_proximity_damage" },
    { 0x68A7DCDC, "player_minigun_proximity_watch" },
    { 0x84C3231F, "player_missile" },
    { 0x6CC54CF1, "player_missile_end" },
    { 0x2EAC00A7, "player_missile_end_singleton" },
    { 0x880E65E0, "player_model" },
    { 0xCF1CF1B3, "player_monitor_doublejump" },
    { 0x6CACBB16, "player_monitor_inactivity" },
    { 0x9E98F49B, "player_monitor_slide" },
    { 0x64AA4793, "player_monitor_swimming" },
    { 0xA4F924C3, "player_monitor_time_played" },
    { 0xEDAC583B, "player_monitor_travel_dist" },
    { 0x716B3FD6, "player_monitor_wall_run" },
    { 0xE08A1F6D, "player_mortar_fail" },
    { 0x93D1EA88, "player_motorcycle_model" },
    { 0x13BA7291, "player_mounted_horse" },
    { 0x619076F6, "player_move_gap_done" },
    { 0x59C4615E, "player_move_speed" },
    { 0xC2305D2A, "player_move_to_huey_front" },
    { 0x0990FBBE, "player_moved" },
    { 0x071C19C4, "player_moved_recently_think" },
    { 0xAD7AA235, "player_moved_spot" },
    { 0x74B189EE, "player_movement" },
    { 0x7679CCBB, "player_movement_suppressed" },
    { 0xABAC3E41, "player_moves" },
    { 0xE602E0D0, "player_moves_again" },
    { 0x67BCF5E1, "player_moves_camera" },
    { 0x9776225C, "player_movespeed_scale" },
    { 0xABDE8961, "player_moving_speed_scale_think" },
    { 0x423FB4B6, "player_mph" },
    { 0xE7E3728A, "player_music_state_switcher_middle" },
    { 0x9A39EC35, "player_music_state_switcher_right" },
    { 0xD6166195, "player_must_die" },
    { 0x0D831256, "player_nades" },
    { 0xB4442F7E, "player_name_directive" },
    { 0x6955E3CB, "player_name_fade_control" },
    { 0x3E44525F, "player_napalm_radius_overlay_fade" },
    { 0xDB289FD0, "player_navigates_burnt_apartment" },
    { 0x17241C3F, "player_near_crow" },
    { 0x1D6B9FCF, "player_near_gravity_vortex" },
    { 0xF6455B13, "player_near_skylight" },
    { 0x9ACB8A32, "player_near_tank" },
    { 0x2740A5FC, "player_nearby" },
    { 0xA4751D0B, "player_nearby_reaction_animcustom" },
    { 0x09757725, "player_nearby_trig" },
    { 0x3335CC30, "player_needs_control_back" },
    { 0x060BB727, "player_needs_to_get_strela" },
    { 0x47B053FF, "player_needs_to_switch_turrets" },
    { 0xBDE39350, "player_next_to_van" },
    { 0x047FC6C9, "player_nextavailunit" },
    { 0x4BEFAF62, "player_nextavailunitcb" },
    { 0x39887FC4, "player_nitrogen_death" },
    { 0xA207C8C0, "player_no_headlook" },
    { 0x312978F1, "player_no_headlook_during_scene" },
    { 0x7D815773, "player_no_seek" },
    { 0xDE9BB069, "player_node" },
    { 0xDFE25C74, "player_noinput" },
    { 0x12DA2512, "player_noprone" },
    { 0x1F73C9BE, "player_noprone_water" },
    { 0x38AE7EEC, "player_not_in_alley" },
    { 0x9B6256DA, "player_not_in_kill_zone" },
    { 0xE6E68BB2, "player_not_looking" },
    { 0xD651DE3F, "player_not_move_fail" },
    { 0x152CEA71, "player_not_moving" },
    { 0x93CB0D8C, "player_not_on_triple25" },
    { 0xE24C0A76, "player_not_using_boat" },
    { 0xA5C8D702, "player_nuke" },
    { 0x515DD0C7, "player_nuke_fx" },
    { 0x01E9FBA3, "player_num" },
    { 0xF8B09D72, "player_num_in_laststand" },
    { 0x64D87DC6, "player_number" },
    { 0x624E6A75, "player_obtained_acidgat" },
    { 0x9D9D0AE6, "player_obtained_tomahawk" },
    { 0x98583BD7, "player_off_plane" },
    { 0x4EDE125D, "player_off_sniper_tree" },
    { 0x98198581, "player_off_the_streets" },
    { 0x93B59391, "player_off_trigger" },
    { 0xD8BDCB0D, "player_off_turret" },
    { 0xC5DF6210, "player_offset" },
    { 0xAB096978, "player_old_move_speed" },
    { 0x8F4D77C4, "player_on_aa_gun" },
    { 0x39592B3A, "player_on_bike" },
    { 0xE3031B65, "player_on_connect" },
    { 0x8AEECDA0, "player_on_conveyer" },
    { 0x6A653A4E, "player_on_escort_boat" },
    { 0x4A1FA3F8, "player_on_foot_dmg" },
    { 0xDA896914, "player_on_ground" },
    { 0x1CD2E99D, "player_on_horse_trigger" },
    { 0x5BAB9B8E, "player_on_island" },
    { 0xBDF17A45, "player_on_jeep" },
    { 0x6A47B307, "player_on_me_vo" },
    { 0x420D63B1, "player_on_plane" },
    { 0xDB97BFDF, "player_on_roof" },
    { 0x68759ABC, "player_on_slingshot" },
    { 0xEAA5B495, "player_on_spawned" },
    { 0xBA004D47, "player_on_trigger" },
    { 0xCAD37002, "player_on_truck" },
    { 0xEA013D87, "player_on_turret" },
    { 0xCE9D2385, "player_on_waterslide" },
    { 0xCFD45F75, "player_one_setup" },
    { 0x097A9D04, "player_onhorse_bp2exit" },
    { 0xEDF3085D, "player_onhorse_bp3exit" },
    { 0x2207510E, "player_only_enemy" },
    { 0xE2812FD7, "player_onroof_point" },
    { 0x7E9C6E6C, "player_oobwatch" },
    { 0x8D5B2C00, "player_open_door" },
    { 0x02EFC52A, "player_opened_afterlife_door" },
    { 0x9373423F, "player_opened_rolling_door" },
    { 0x37AE3FCB, "player_opened_shed" },
    { 0x838E0A98, "player_or_random" },
    { 0xB64D3635, "player_ordinal_inc" },
    { 0xFADE182D, "player_org" },
    { 0x9A23CE57, "player_origin" },
    { 0x7FA8DA7D, "player_origin_current" },
    { 0x717B4BB1, "player_origin_previous" },
    { 0x9B58F504, "player_out_of_bb" },
    { 0xE4FDCD38, "player_out_of_bound" },
    { 0x44CB3D93, "player_out_of_bounds" },
    { 0x7A776443, "player_out_of_copter" },
    { 0x45A6F457, "player_out_of_gas" },
    { 0xD3FAEDEB, "player_out_of_hind" },
    { 0x3CC4D342, "player_out_of_playable_area" },
    { 0x4FCC9411, "player_out_of_playable_area_monitor" },
    { 0xA44C4A35, "player_out_of_playable_area_monitor_callback" },
    { 0x5C478789, "player_out_of_playable_area_override" },
    { 0x1147B986, "player_out_of_tall_grass" },
    { 0x2256BA20, "player_out_of_tank" },
    { 0x815DA09D, "player_out_of_water" },
    { 0x72E8DA46, "player_out_window" },
    { 0x4836FD68, "player_outro_started" },
    { 0x191752D1, "player_outta_car" },
    { 0x7D1694DC, "player_over_sniper_blocker" },
    { 0x4DB4A2E7, "player_over_sniper_wall_trig" },
    { 0x4B0FCF96, "player_over_wall" },
    { 0x6C1D8418, "player_overdrive_handler" },
    { 0x0F893667, "player_override_damage" },
    { 0xDA760982, "player_owner" },
    { 0x159AD835, "player_pain" },
    { 0x80CC467F, "player_pain_vox" },
    { 0xC21440CD, "player_panics" },
    { 0x83FCF3C7, "player_paralyzed" },
    { 0xC7587CE6, "player_passed_dumpster" },
    { 0xCC00F895, "player_passed_fuel_depot_area" },
    { 0x0932988A, "player_past_prone" },
    { 0x2A451C71, "player_past_turrets" },
    { 0xBB733409, "player_pby_init" },
    { 0x20DC182C, "player_pc_velocity" },
    { 0x823046D6, "player_performed_kill" },
    { 0x53690301, "player_perk_purchase_limit" },
    { 0x850E30BB, "player_perk_slots" },
    { 0x30C1C6B8, "player_perks" },
    { 0x9A5CF1EB, "player_phsych_thread" },
    { 0xAC915166, "player_physents_think" },
    { 0xB848892E, "player_physpulses_start" },
    { 0x64D49FAC, "player_piano_starts" },
    { 0x6D6B8949, "player_picked_up_m202" },
    { 0xED7BDB69, "player_pickedup_gun" },
    { 0xBA106865, "player_picks_up_price" },
    { 0xFA800991, "player_pickup" },
    { 0xA7E65076, "player_pickup_flamethrower" },
    { 0x9734113F, "player_pipe_slide" },
    { 0x741545AE, "player_place" },
    { 0x79D3970D, "player_plane_inited" },
    { 0xACB80B3A, "player_plane_spawn_origin" },
    { 0x4EBC2B88, "player_plant" },
    { 0xA183BF23, "player_plant_network_intruder" },
    { 0xD1CB40B1, "player_play_anim" },
    { 0xAB6B804E, "player_play_slomo" },
    { 0xABBCD447, "player_player_last_anim" },
    { 0xEF635838, "player_points" },
    { 0x874FB49F, "player_points_kill_bonus" },
    { 0xCD2010A5, "player_portal_clue_vo" },
    { 0x0C32C0C9, "player_pos" },
    { 0xF3B767CB, "player_pos_ent" },
    { 0xFAD31049, "player_pos_search_radius" },
    { 0xD5A3D26B, "player_position_located" },
    { 0x970FD49B, "player_position_valid" },
    { 0xD62E65D1, "player_post_breachroom_trig" },
    { 0x64344010, "player_postgas_room" },
    { 0x6C81F3B5, "player_prefix" },
    { 0x08181A9A, "player_pressed_ads" },
    { 0x2F4BDA5E, "player_pressed_button_this_round" },
    { 0xA2428F48, "player_pressed_melee" },
    { 0x0425E376, "player_presses_plunger" },
    { 0x3355AD07, "player_pressing_forward_on_throttle" },
    { 0x4107B8C0, "player_prevent_bleedout" },
    { 0xCED740F7, "player_prevent_damage" },
    { 0x9F5EF85C, "player_previous_max_x" },
    { 0xC56172C5, "player_previous_max_y" },
    { 0xEB63ED2E, "player_previous_max_z" },
    { 0xE29BE91E, "player_previous_min_x" },
    { 0x089E6387, "player_previous_min_y" },
    { 0x9696F44C, "player_previous_min_z" },
    { 0xD7ACFCEF, "player_printer" },
    { 0x45618002, "player_progress_bar" },
    { 0xD31CB67E, "player_progress_bar_update" },
    { 0xA1CCD56C, "player_prone_damage_radius" },
    { 0xF6A918DB, "player_prone_dof" },
    { 0x8F680DE5, "player_pull_glass" },
    { 0x8CF20CC1, "player_pulled_chute" },
    { 0xA80C03C3, "player_purchase_" },
    { 0x7E9BAB4C, "player_push_toggle" },
    { 0x428E8A00, "player_put_on_helmet" },
    { 0xBD604B68, "player_puts_down_price" },
    { 0x02930F0B, "player_puts_on_helmet" },
    { 0x945B65F3, "player_qualifier" },
    { 0xE7931CD8, "player_quest_vfx" },
    { 0xE9B99701, "player_radio_emitter" },
    { 0x2F312343, "player_radius" },
    { 0x0DB896AF, "player_railing" },
    { 0x5C196BEB, "player_rain" },
    { 0x96D319DF, "player_raising_flag" },
    { 0xE1D94CCD, "player_ram_boat_start" },
    { 0x280FAC45, "player_rammed_time_delay" },
    { 0x7E8A08BC, "player_random_blur" },
    { 0x45929770, "player_random_response_to_theft" },
    { 0xB3CF212D, "player_rappel" },
    { 0x3936F0F0, "player_rappel_done" },
    { 0xD9DF9E5F, "player_rappel_land" },
    { 0x095077FF, "player_rappel_rumble" },
    { 0x09FCC891, "player_rappel_rumble_off" },
    { 0x44C33965, "player_rappel_rumble_on" },
    { 0xB18D32D8, "player_rappel_think" },
    { 0x2A31712C, "player_rappels" },
    { 0x54ABFA03, "player_rappels_down" },
    { 0x241C132B, "player_rate" },
    { 0x9519F6C9, "player_reached" },
    { 0xD3D0B5C4, "player_reached_balcony" },
    { 0x0C4C2D0B, "player_reached_dragovich" },
    { 0x19D2C040, "player_reached_goatpath" },
    { 0xC14DD4C3, "player_reached_intersection" },
    { 0xDC0BEE8F, "player_reached_kill_max" },
    { 0xDBDBFE31, "player_reached_outer_ruins" },
    { 0x486FB87B, "player_reached_snowcat" },
    { 0xBBD58374, "player_reached_temple_entrance" },
    { 0xEC0C4FAE, "player_reaches_bunker" },
    { 0x6C425A1F, "player_reaches_cliff_area" },
    { 0xA122A2F8, "player_reaches_hanger" },
    { 0x52D86DCF, "player_react_security_room" },
    { 0xC5BF3FD5, "player_read" },
    { 0x8A0D473E, "player_ready" },
    { 0xC2EDE772, "player_ready_for_anim" },
    { 0x225A412E, "player_ready_for_synch_shots" },
    { 0x6E9C478A, "player_rearback" },
    { 0xDF146601, "player_received_ghost_round_free_perk" },
    { 0x9858ABAB, "player_reduce_points" },
    { 0x9C631B01, "player_reigns_model" },
    { 0xFFBF9BDE, "player_relink" },
    { 0xE6A6FC3E, "player_reload" },
    { 0x095AB081, "player_remove_craftable_piece" },
    { 0xEC15C9DE, "player_remove_piece" },
    { 0x3C0AC35A, "player_rescued" },
    { 0xCCA5BC21, "player_reset_score" },
    { 0x4511ED1B, "player_respawn" },
    { 0xF9E28ECF, "player_respawn_fix" },
    { 0xB5D2BD19, "player_respawn_if_extra_life" },
    { 0x866A6AC6, "player_respawn_now" },
    { 0xA113780F, "player_respawn_points" },
    { 0xC274FD90, "player_respawned" },
    { 0x63592A35, "player_responder" },
    { 0xC82B7E5A, "player_restore_clip_size" },
    { 0x2EA60193, "player_restore_weapons" },
    { 0x5563C64B, "player_resurrect_changed" },
    { 0x294DFC4D, "player_resurrect_state_changed" },
    { 0xA0487A3E, "player_return_piece_to_original_spawn" },
    { 0xFCCA6018, "player_returning_to_seaknight" },
    { 0x686E53E7, "player_reverse_anim" },
    { 0x60BDFA4D, "player_revive_monitor" },
    { 0x90831B9E, "player_revived" },
    { 0x2B6E2894, "player_revived_cleanup_chugabud_corpse" },
    { 0x508D988B, "player_rez_dist" },
    { 0x81108B4C, "player_rice_melee_successful" },
    { 0x66CC5287, "player_richtofen" },
    { 0xFB55EE01, "player_rig" },
    { 0xE41A31C5, "player_right" },
    { 0x36E3EE42, "player_rightstick_x" },
    { 0x588249E0, "player_riotshield" },
    { 0xBDFC7633, "player_rocket_rumble" },
    { 0xB544CF94, "player_roll" },
    { 0xEC38D037, "player_rolled" },
    { 0x04BED6C8, "player_rooftop_claw_death_think" },
    { 0x4C3BE2C1, "player_rope" },
    { 0x6A32923F, "player_rope_scroll" },
    { 0x2DB3BA1A, "player_rotation_inc" },
    { 0xDF9E1589, "player_rumble_exit_sniper" },
    { 0x974A20D9, "player_rumbles" },
    { 0x8BFC6F1B, "player_run_2_convoy_fail" },
    { 0xA17BC6F4, "player_run_anim" },
    { 0x87FCAC66, "player_runs_off_wrong_way_fail" },
    { 0x3F07135B, "player_rus_guard" },
    { 0x749D598A, "player_rus_guard_wet" },
    { 0x86B08BBE, "player_rusher" },
    { 0x061EC161, "player_rusher_damage_override" },
    { 0x968A37E0, "player_rusher_fight_dist" },
    { 0x6E6D752B, "player_rusher_jumper_dist" },
    { 0x2F502E73, "player_rusher_medium_dist" },
    { 0xCB346A79, "player_rusher_player_busy_dist" },
    { 0xF04425EA, "player_rusher_vclose_dist" },
    { 0xC7D5180A, "player_safe" },
    { 0x4B32BDEE, "player_safe_time" },
    { 0x01A3622E, "player_save_struct" },
    { 0x6E0927A9, "player_save_woods" },
    { 0xF152F66E, "player_saved_from_dog" },
    { 0xAC001002, "player_saved_tracked_friendly_f35" },
    { 0xE8A2E9B5, "player_saves" },
    { 0x070D2C77, "player_saw_kill" },
    { 0xD843FC97, "player_saw_this" },
    { 0x4E22131D, "player_say_dialog" },
    { 0xCF7FAAA6, "player_scene_animation_skip" },
    { 0xD305F41D, "player_scene_skip_completed" },
    { 0x67E4240D, "player_score" },
    { 0xB4334090, "player_score_override" },
    { 0x975EAF74, "player_score_sort" },
    { 0x6E1FC178, "player_score_think" },
    { 0x9284DBB3, "player_score_update" },
    { 0xD858BC2A, "player_score_win" },
    { 0x40CB89B3, "player_scored" },
    { 0xFF37C511, "player_scream_thread" },
    { 0x7F3680BF, "player_screams_while_falling" },
    { 0xD78B322E, "player_screen_shake_rumble" },
    { 0xFAD68B54, "player_searched_entire_room" },
    { 0x15F4AF8F, "player_secondaryoffhand" },
    { 0xC43503DD, "player_seek" },
    { 0x82E46D21, "player_seek_no_cover" },
    { 0x68055E33, "player_seek_timer" },
    { 0xE5EFC4CB, "player_seeking" },
    { 0xC25E9BCB, "player_seen_tesla_gun" },
    { 0x22806C7F, "player_sees_my_scope" },
    { 0x06B242F4, "player_sees_spawner" },
    { 0xD897B071, "player_set_buildable_piece" },
    { 0x9155D925, "player_set_chyron_menu" },
    { 0x835C4833, "player_set_down_ball_watcher" },
    { 0x34E5195A, "player_set_equipment_damage" },
    { 0x70C029FA, "player_set_shield_health" },
    { 0x47178AF9, "player_set_threatbias" },
    { 0xA48E2A50, "player_set_viewmodel" },
    { 0x59254AEF, "player_set_viewmodel_override" },
    { 0x8B13F4CC, "player_setup" },
    { 0x57630A63, "player_shake_view" },
    { 0x5A91032E, "player_shared" },
    { 0x5A043E2D, "player_shellshock" },
    { 0x1636C976, "player_shield_absorb_damage" },
    { 0x8EE2F5F5, "player_shield_apply_damage" },
    { 0xCDCBB4E3, "player_shield_facing_attacker" },
    { 0x8CAC0F5F, "player_shield_reset_health" },
    { 0xAF8FF2CC, "player_shield_reset_location" },
    { 0x281E2B38, "player_shock_changed" },
    { 0x48B14D9D, "player_shock_fx_fade_off" },
    { 0xCBD93CAF, "player_shock_fx_fade_off_end" },
    { 0xFDE81EC3, "player_shock_fx_handler" },
    { 0xE65B6EEA, "player_shockbox_glowfx" },
    { 0xCEA9E032, "player_shook_me" },
    { 0xE6E8C37A, "player_shoot" },
    { 0xEA051836, "player_shooting" },
    { 0x9D81A8D5, "player_shoots_left_start_building_1" },
    { 0xC384233E, "player_shoots_left_start_building_2" },
    { 0xC70DB21A, "player_shoots_menendez" },
    { 0x7301EB7A, "player_shoots_right_of_base_island" },
    { 0xBB17DD33, "player_shoots_vorkuta_building" },
    { 0x83A75406, "player_shoots_vorkuta_building_nextto" },
    { 0xC143A419, "player_shot" },
    { 0xDD183E45, "player_shot_at_hind" },
    { 0x7DFDBB51, "player_shot_at_timer" },
    { 0x8FB0E08B, "player_shot_down_drone" },
    { 0x576E962F, "player_shot_down_from_nose" },
    { 0xED1E5632, "player_shot_plane" },
    { 0xFDDDDBEE, "player_shot_terrorist" },
    { 0x0A09F360, "player_shotat_sniper" },
    { 0x0DA16CC7, "player_shotme" },
    { 0x3F430127, "player_should_get_m202" },
    { 0xA0EC6DAD, "player_shove_glass" },
    { 0x97BE99B3, "player_show_craftable_parts_ui" },
    { 0xB02B86BF, "player_show_first_person" },
    { 0xAA100703, "player_show_hide_rain_fx" },
    { 0x80D40DA4, "player_show_third_person" },
    { 0x282F2F37, "player_show_wristband" },
    { 0x3A3ECE9E, "player_shrug_off_horse" },
    { 0xD29511FB, "player_shutdown" },
    { 0xCD046FAA, "player_single50" },
    { 0x5359832A, "player_skip_igc" },
    { 0x2607F8A4, "player_skip_igc_confirmed" },
    { 0xB04C293A, "player_skipped_claws" },
    { 0xCD66D9D1, "player_skipping_scene" },
    { 0x73D2EFC1, "player_skipto_spots" },
    { 0xBE868608, "player_slid_first" },
    { 0x5E142200, "player_slide_rumble" },
    { 0x90CB7489, "player_slow_down" },
    { 0x247B7EB2, "player_slow_for_time" },
    { 0xB8710279, "player_slow_movement_speed_monitor" },
    { 0x62C580D6, "player_slow_speed_in_vent" },
    { 0x42193965, "player_slow_stop_flying" },
    { 0x353087E5, "player_slowmo_audio" },
    { 0x27417E18, "player_snap_glass" },
    { 0x99640365, "player_snipe_spot" },
    { 0x94DA57A1, "player_sniper_trig" },
    { 0x6EF64F18, "player_snow" },
    { 0xA05A976E, "player_soct" },
    { 0xDCA3EF5D, "player_soct_anims" },
    { 0x53815B3E, "player_soct_collision_ending_check" },
    { 0x296AE04B, "player_soct_damage_ignore" },
    { 0x3758C3F1, "player_soct_damage_override" },
    { 0xBB76B09F, "player_soct_damage_states" },
    { 0x75C640D9, "player_soct_damaged_frac" },
    { 0x0E13CC96, "player_soct_driving_rumble" },
    { 0x59298229, "player_soct_is_damaged" },
    { 0xCB107CDB, "player_soct_keepup_salazar_fail" },
    { 0xF60886D5, "player_soct_monitor_boost_tags_update" },
    { 0x04B5FB31, "player_soct_monitor_tags_update" },
    { 0xBBAB259F, "player_soct_slowdown_collision" },
    { 0x30EDF353, "player_soct_sprint_fx_active" },
    { 0x5F51E607, "player_soct_switch_setup" },
    { 0xCD622889, "player_soct_test_for_water" },
    { 0x3953AD32, "player_soct_world_collision" },
    { 0x63FB1AF2, "player_sound_context_hack" },
    { 0x55039BD2, "player_spawn" },
    { 0x5513ECA7, "player_spawn_2d" },
    { 0x6D94F982, "player_spawn_fix" },
    { 0x6F40BD83, "player_spawn_func" },
    { 0xB1370BF0, "player_spawn_points" },
    { 0x2BE01924, "player_spawn_protection" },
    { 0x719F4EE5, "player_spawned" },
    { 0x351BDB18, "player_spawnproc_ents_collect" },
    { 0xA122C4DD, "player_spawns" },
    { 0xCEBDCDF7, "player_special_death_hint" },
    { 0x1B1F04F5, "player_specific" },
    { 0xFC0B6C3A, "player_speed" },
    { 0x0D6B43CB, "player_speed_changed" },
    { 0xA2F3B59C, "player_speed_control" },
    { 0x3377C071, "player_speed_over_time" },
    { 0xEC0D84D6, "player_speed_reset" },
    { 0xE1E81C23, "player_speed_set" },
    { 0x0286AE75, "player_speed_within_coords" },
    { 0xC4B2C29B, "player_speed_within_coords_internal" },
    { 0xF27FD123, "player_spin_damage" },
    { 0xC5199A7D, "player_splash_think" },
    { 0xB75D876E, "player_spline" },
    { 0xFEAD71FF, "player_spline_original_pos" },
    { 0x31D355F1, "player_spline_right" },
    { 0xF91D3111, "player_spot" },
    { 0x67C527F8, "player_spots" },
    { 0x501ED39C, "player_spotted" },
    { 0xBB5391C0, "player_sprint_check" },
    { 0x89E95077, "player_squad_movement" },
    { 0xB9604E9C, "player_squad_rappel" },
    { 0x95FE54D5, "player_stance" },
    { 0x1A0CE1E7, "player_stand_max_z" },
    { 0xF1E0BBDE, "player_standing_viewheight" },
    { 0x511C85A8, "player_standing_viewheight_normal" },
    { 0x4FD73888, "player_standing_viewheight_tall" },
    { 0x82D1926A, "player_stands_too_long" },
    { 0x15225D63, "player_start" },
    { 0x55D1F398, "player_start_2" },
    { 0xF084244A, "player_start_angles" },
    { 0x072B0B9E, "player_start_charge" },
    { 0x65AD6AA3, "player_start_name" },
    { 0xA69B3C30, "player_start_org" },
    { 0x0D15164D, "player_start_path_hint" },
    { 0x9452394C, "player_start_pipe_slide" },
    { 0xF4308DE0, "player_start_pos" },
    { 0x141D670D, "player_start_raise_gun" },
    { 0xA86E7315, "player_start_slowmo" },
    { 0xBF5DF380, "player_start_stealth_battle" },
    { 0x5BED15F2, "player_start_stealth_event" },
    { 0xE00CED11, "player_start_time" },
    { 0xE40FC3C4, "player_started_landing" },
    { 0x957EE1F1, "player_started_saving_pows" },
    { 0x8499471D, "player_starting_points" },
    { 0xA4C29D1F, "player_startpos" },
    { 0x2D05EF52, "player_starts" },
    { 0x22498E97, "player_stats_init" },
    { 0x66C3A258, "player_stayed_in_maze_for_entire_high_level_round" },
    { 0xFD95D4DB, "player_steal_life" },
    { 0xD0026405, "player_stealth_carry_anims" },
    { 0x15EDD981, "player_stealth_fail" },
    { 0x09B3FD4C, "player_stealth_override_spotted_params" },
    { 0x169FF177, "player_stick" },
    { 0x3F449960, "player_stick_origin" },
    { 0x7FD87F60, "player_still_on_road" },
    { 0xC3FF696C, "player_stole_power_up" },
    { 0x4380977B, "player_stomp_death" },
    { 0x43E5F9CF, "player_stomp_fake_death" },
    { 0x2985B126, "player_stood_up" },
    { 0xDDB51EB1, "player_stop" },
    { 0xB8F3CC75, "player_stop_burning" },
    { 0xEBA9ABCE, "player_stop_moving" },
    { 0x64076928, "player_stop_sprinting" },
    { 0x20A3F763, "player_strafe_burst_firing" },
    { 0x4D9CF890, "player_street_claw_death_think" },
    { 0x14CAA2DE, "player_struct" },
    { 0x451C2882, "player_stunned_thrasher" },
    { 0xFEA8A90E, "player_sub_score" },
    { 0x74EB42FA, "player_sucks_atjumping" },
    { 0x0C0D64B3, "player_suicide" },
    { 0xC46D20C1, "player_suicides_total" },
    { 0xBC23CC3D, "player_summary_challenge" },
    { 0x9381983D, "player_summary_match" },
    { 0x755E457C, "player_summary_score" },
    { 0x6995769A, "player_summary_xp" },
    { 0x1BB32BDA, "player_surfaced" },
    { 0x61A1D65C, "player_surfaced_visuals" },
    { 0xA97D7AE5, "player_survival_time" },
    { 0x73D0606F, "player_survival_time_in_mins" },
    { 0x4CAE8774, "player_swapvehicle" },
    { 0xFA013947, "player_swim_damage" },
    { 0xF9E80709, "player_swim_damage_interval" },
    { 0x7100629E, "player_swim_death_time" },
    { 0xE7798AE7, "player_swim_time" },
    { 0xBDBB5629, "player_switch" },
    { 0x4C38AF6C, "player_switch_" },
    { 0x780D3DD9, "player_switch_camera" },
    { 0xF86313B9, "player_switch_dragons_breath" },
    { 0xA2EA5624, "player_switch_explosive_bolts" },
    { 0x58618A41, "player_switch_in" },
    { 0xA8F12A15, "player_switch_invultime" },
    { 0xD45AAF81, "player_switch_lockswitch" },
    { 0x54C98198, "player_switch_out" },
    { 0x940D6256, "player_switched" },
    { 0x91420924, "player_switched_to_claw" },
    { 0x32E587EA, "player_switched_to_left" },
    { 0x0F3CD3B9, "player_switchweapon" },
    { 0x4E802CCE, "player_swtiched_to_claw" },
    { 0x92935184, "player_t5_carter" },
    { 0x96D18859, "player_t5_vorkuta" },
    { 0xEBA03218, "player_t5_zm" },
    { 0x67E6C68F, "player_t5_zm_coast" },
    { 0x54CC02D0, "player_t5_zm_moon" },
    { 0xA167CBCB, "player_t5_zm_pentagon" },
    { 0x5A6A7B76, "player_t5_zm_theater" },
    { 0x816732A9, "player_t5_zt" },
    { 0x109CB5B4, "player_tackle_player_control_logic" },
    { 0xB641F033, "player_tag" },
    { 0xCACAD8D4, "player_tag_origin" },
    { 0x1835B0FC, "player_take_key" },
    { 0x8FE40BC1, "player_take_loadout" },
    { 0xD1AFF147, "player_take_piece" },
    { 0x5B189BA2, "player_take_riotshield" },
    { 0x6BBBCAF1, "player_takedown_sampan_vc" },
    { 0xA587F78E, "player_takeover" },
    { 0x10E74907, "player_takeover_random_dude" },
    { 0x3580EB6D, "player_takes_damage" },
    { 0xCA7782AE, "player_takes_shot" },
    { 0x21A949D1, "player_takes_shots" },
    { 0xB2771078, "player_takes_wave2_sidepath" },
    { 0xCC89F96D, "player_talking" },
    { 0xB11178A5, "player_tank" },
    { 0x9C7306C1, "player_tank_1" },
    { 0xC18F8440, "player_tank_hud_init" },
    { 0x37A8BC79, "player_tank_hud_update" },
    { 0x10B33BB4, "player_tanks" },
    { 0x67FFDFF2, "player_target" },
    { 0xB8062506, "player_target_move" },
    { 0x24E09D7D, "player_targets" },
    { 0xB4D5BD3E, "player_teach_ammo_cache" },
    { 0x2E708B3E, "player_team" },
    { 0x15A1F331, "player_team_mask" },
    { 0x8082414B, "player_teargas_duration" },
    { 0xC8D5B94C, "player_teleport_blackscreen_on" },
    { 0x62857917, "player_teleported" },
    { 0xF3EEF534, "player_teleporting" },
    { 0xA460948A, "player_test_point" },
    { 0x32721687, "player_thread_give" },
    { 0xC5956C1D, "player_thread_take" },
    { 0x236A6361, "player_threat" },
    { 0x8D099C9A, "player_threat_detector_material" },
    { 0xA90E3756, "player_threw_nade" },
    { 0xAB35B894, "player_through_wnd" },
    { 0xBAD2CFEE, "player_throw_beacon" },
    { 0x8BCE3190, "player_throw_cymbal_monkey" },
    { 0x41720BCC, "player_throw_grenade" },
    { 0xF2EE3A8F, "player_throw_octobomb" },
    { 0x1212A0D0, "player_throw_piece" },
    { 0x64DA1045, "player_throwgrenade_timer" },
    { 0x1A629658, "player_throws_nightingale_distraction" },
    { 0x265D1BE9, "player_thunder" },
    { 0x8AE8E865, "player_time_frac" },
    { 0x0B294249, "player_titus_tutorial" },
    { 0x78FAE09F, "player_to_check" },
    { 0x8200A010, "player_to_end" },
    { 0x8D3D04EC, "player_to_headbutt" },
    { 0x8366DC41, "player_to_heli" },
    { 0x718695A0, "player_to_respond" },
    { 0x09B31173, "player_to_return" },
    { 0x9F83EC12, "player_to_spawn" },
    { 0x30E933A3, "player_to_start" },
    { 0x3C4A2F1E, "player_to_struct" },
    { 0x82F2D3B1, "player_toggle_cloak_handler" },
    { 0x5237EEFB, "player_token_vehicle_damage" },
    { 0xDA69A3C8, "player_too_close" },
    { 0x8F6F1CC0, "player_too_eager" },
    { 0x87164E37, "player_too_far_behind_salazar" },
    { 0x83C33F17, "player_too_many_players_check" },
    { 0x79BBDD40, "player_too_many_players_check_func" },
    { 0x67A71CEC, "player_too_many_weapons_monitor" },
    { 0x9ABDCF26, "player_too_many_weapons_monitor_callback" },
    { 0xA3E1B821, "player_too_many_weapons_monitor_func" },
    { 0xB730D298, "player_too_many_weapons_monitor_takeaway_sequence" },
    { 0x826EA773, "player_too_many_weapons_monitor_takeaway_sequence_done" },
    { 0x7CBF152C, "player_too_many_weapons_monitor_takeaway_simultaneous" },
    { 0x266D0703, "player_too_slow" },
    { 0xDCF5D1B4, "player_tooeager_toface_sniper" },
    { 0xB84C04AC, "player_took_radio" },
    { 0xDB1A4DA4, "player_took_super_radiation_dose" },
    { 0x26D05BEF, "player_touch_head" },
    { 0x2E413CD7, "player_touched_eq_trigger" },
    { 0xA5C3D5B2, "player_touches_wounded_blocker" },
    { 0xE3EE1B02, "player_touching" },
    { 0xD3F3BEA1, "player_touching_2" },
    { 0x0C472167, "player_touching_left_trig" },
    { 0x504D432E, "player_touching_right_trig" },
    { 0xDF3ECED8, "player_trace" },
    { 0x16CDFCEF, "player_track_ammo_count" },
    { 0x160ADF1A, "player_tracking" },
    { 0xD2D4771A, "player_trackmissile" },
    { 0x14EC3DA8, "player_trampled_ai_with_horse" },
    { 0xD6B4AFE2, "player_transfer_location" },
    { 0x47A189A4, "player_transition" },
    { 0x628CD169, "player_transition_into_robot_head_finish" },
    { 0x52E2BB38, "player_transition_into_robot_head_start" },
    { 0xC8D7B80C, "player_tries_toskip_mg" },
    { 0xE126523B, "player_trig" },
    { 0x12FC0857, "player_trigger" },
    { 0x90924198, "player_trigger_checkpoint" },
    { 0xB99F3700, "player_trigger_origin" },
    { 0xEAAC0CDC, "player_trigger_radius" },
    { 0x5A16671C, "player_triggered" },
    { 0x1036D612, "player_truck" },
    { 0x25ABD65D, "player_truck_damage_override" },
    { 0xB9D41990, "player_truck_invulnurablility_interval" },
    { 0x46C9237E, "player_trying_to_plant" },
    { 0x56805678, "player_turn" },
    { 0x78A4CC11, "player_turn180" },
    { 0xB57A7960, "player_turn_anim" },
    { 0xC04431C6, "player_turn_off_sonar" },
    { 0x8BE7B5BD, "player_turns_around" },
    { 0xC934014B, "player_turns_back" },
    { 0xB4B9B237, "player_turret" },
    { 0x021B1990, "player_turret_audio" },
    { 0xE2DCF67E, "player_turret_fire" },
    { 0xAE5686BE, "player_umbrahotfixes" },
    { 0x70F9196A, "player_unblocker" },
    { 0xA04C899C, "player_under_attack_bridge" },
    { 0xB48C7158, "player_under_door" },
    { 0xF666430F, "player_under_door_gun" },
    { 0xE5B15D3A, "player_underwater_flag_handler" },
    { 0x16A3DF7B, "player_unlimited_ammo" },
    { 0xEDCDB132, "player_unlimited_ammo_thread" },
    { 0x1F8FF1FF, "player_unlinked" },
    { 0xF7BEB173, "player_unlock_control" },
    { 0x63486B6C, "player_unlock_stance" },
    { 0x72F4D03C, "player_unstick" },
    { 0x8F92EDB4, "player_unstoppableforce_handler" },
    { 0x34119C82, "player_up" },
    { 0xFC1DDBF2, "player_up_after_tankblast" },
    { 0x412573AC, "player_update_model" },
    { 0x8996C8A1, "player_update_vehicle_hud" },
    { 0x84E63F52, "player_upgraded_lsat_from_wall" },
    { 0xF6A22CF8, "player_upstairs" },
    { 0x8F3D5F6F, "player_usa_marine" },
    { 0xC7D4A78E, "player_usa_marine_wet" },
    { 0x544C98A0, "player_usa_raider" },
    { 0x6D2969B6, "player_use" },
    { 0x8B30C8C2, "player_use_can_pack_now" },
    { 0xE68AA046, "player_used" },
    { 0x6EDFCF19, "player_used_ads" },
    { 0xCCA303C0, "player_used_fountain_teleporter" },
    { 0x76EB91BE, "player_used_outside_lift" },
    { 0x69743979, "player_uses_pistol" },
    { 0x5DB9AFAF, "player_using" },
    { 0x2FD436B4, "player_using_boat" },
    { 0x26A7D5BB, "player_using_hi_score_weapon" },
    { 0x1F6E9D3C, "player_using_truck_turret" },
    { 0x161A3F68, "player_using_turret" },
    { 0x10ECFD0D, "player_valid" },
    { 0xB7FF526B, "player_valid_target" },
    { 0x535CDD65, "player_vec" },
    { 0xCF68055A, "player_vec_2d" },
    { 0xB1DA861B, "player_veh_btr" },
    { 0x7E596503, "player_vehicle" },
    { 0x1C0CCCF8, "player_vehicle_destructable_damage" },
    { 0x9ECF45B5, "player_vehicle_position_will_telefrag" },
    { 0xEAE3531C, "player_velocity" },
    { 0x066B612D, "player_velocity_tracker" },
    { 0x5FCFCD3A, "player_vh_state_drone" },
    { 0xBD70B5E2, "player_vh_state_none" },
    { 0xB7DF309B, "player_vh_state_soct" },
    { 0x392465D2, "player_view" },
    { 0xDD1D46F1, "player_view_chance" },
    { 0x25F449BE, "player_view_count" },
    { 0xFD993949, "player_view_lerped" },
    { 0x767702F0, "player_view_trace" },
    { 0x1D1C2F6B, "player_viewhand_model" },
    { 0x07BD6469, "player_viewmodel" },
    { 0x9DB28BCE, "player_viewmodel_noleft" },
    { 0xDCA5DD4C, "player_viewshift_lock" },
    { 0x5B698D80, "player_vision_change" },
    { 0xDB7CB0C0, "player_vo" },
    { 0xF724CABE, "player_volumes" },
    { 0xFC4DE08D, "player_vomit_anims" },
    { 0x55A5024B, "player_vortex_rumble" },
    { 0x5AE11BD4, "player_vortex_visionset" },
    { 0x15366AF8, "player_vox" },
    { 0x41471193, "player_vox_done" },
    { 0xECF793E6, "player_vs_sniper" },
    { 0x447385F6, "player_vtol" },
    { 0x1967B240, "player_vtol_exit_scene" },
    { 0xFD095808, "player_vtol_go_on_rail" },
    { 0x5EA65FE7, "player_vtol_start" },
    { 0xADC892CE, "player_wait" },
    { 0x47B66C6D, "player_wait_dist" },
    { 0x810AA38C, "player_wait_enter_vehicle" },
    { 0xDE55DF31, "player_wait_exit_vehicle_t" },
    { 0x3C6BE216, "player_wait_land" },
    { 0x25C52CD1, "player_wait_on_mortar_death" },
    { 0x5BAFCAFA, "player_wait_take_meat" },
    { 0xF13E7CB2, "player_waitfor_vehicleentry" },
    { 0xEFE148D8, "player_wakes_up" },
    { 0xB511C356, "player_wakes_up_afghan" },
    { 0x77065819, "player_wakes_up_la_2" },
    { 0x774E07D2, "player_wakeup" },
    { 0x24B86D60, "player_walk_speed_adjustment" },
    { 0x10F04EF4, "player_warpto" },
    { 0xDEC00354, "player_warpto_struct" },
    { 0xF18F0ACF, "player_was_turned_by" },
    { 0x9FDB0CD6, "player_watch_ammo_change" },
    { 0xFF801C5B, "player_watch_blood" },
    { 0xD707564C, "player_watch_blood_shutdown" },
    { 0x69E18152, "player_watch_drown_shutdown" },
    { 0xA2CF8C75, "player_watch_for_shot" },
    { 0x7B902970, "player_watch_grenade_throw" },
    { 0x071CE393, "player_watch_laststand" },
    { 0x3FBC315A, "player_watch_max_ammo" },
    { 0x9A2CED9D, "player_watch_shellshock_accumulation" },
    { 0xAACE298E, "player_watch_shield_juke" },
    { 0x49873617, "player_watch_shield_melee" },
    { 0x5344CC85, "player_watch_shield_melee_power" },
    { 0x8F39C1C3, "player_watch_spectate_change" },
    { 0x1A3DED76, "player_watch_upgraded_pickup_from_table" },
    { 0xBF0AFF60, "player_watch_weapon_change" },
    { 0xA2B1FA6F, "player_watcher" },
    { 0x7ED0EBE3, "player_water_fx" },
    { 0x950A38DB, "player_water_origin" },
    { 0xB7EFC0AA, "player_water_visor" },
    { 0xE23F0A66, "player_wave3_loc" },
    { 0x53A44189, "player_weapon" },
    { 0x61D62CC3, "player_weapon_drop" },
    { 0x21762D80, "player_weapons" },
    { 0x6414F01C, "player_weather_loop" },
    { 0xCDF666D5, "player_went_left" },
    { 0xEA3A6B5D, "player_went_middle" },
    { 0x53583238, "player_went_right" },
    { 0x4E6E1116, "player_wetness" },
    { 0xF401030B, "player_whizby_think" },
    { 0xB396EBC0, "player_whizbys_start" },
    { 0x5187BA42, "player_who_fired" },
    { 0x522D07A9, "player_win" },
    { 0x23D84D73, "player_window_breach" },
    { 0xD9655869, "player_window_break_len" },
    { 0x26999F42, "player_window_bullet_hit" },
    { 0x05FA224B, "player_window_exploder" },
    { 0xAA02DB79, "player_window_unlink" },
    { 0x22ABFB38, "player_wingsuit_tutorial" },
    { 0xA0001721, "player_with_back_bolt" },
    { 0xAB12D7C5, "player_with_meat" },
    { 0x6FD4BDCE, "player_withdraw_fee" },
    { 0x75C67A3D, "player_woke_up" },
    { 0x0EF07094, "player_wokeup" },
    { 0x49ACF40C, "player_woods_dialog" },
    { 0x511EECF6, "player_world_icon_init" },
    { 0x305F9C23, "player_world_icon_update" },
    { 0x1FD3C8A7, "player_wrong_stall" },
    { 0x6C5FB85A, "player_yaw" },
    { 0xFF7BD321, "player_z" },
    { 0x5F8FE5CC, "player_z_height_inc" },
    { 0x09147F4F, "player_zipline_1hand" },
    { 0xF6374E13, "player_zipline_2hands" },
    { 0x48F06F14, "player_zipline_crashwindow" },
    { 0xE6B601C7, "player_zipline_effects" },
    { 0xA2014364, "player_zipline_time" },
    { 0xF1B33B8B, "player_zipline_windfx" },
    { 0x64DBDE15, "player_zombie_awareness" },
    { 0x67B28746, "player_zombie_blood" },
    { 0x39D714B5, "player_zombie_breadcrumb" },
    { 0x3E67D968, "player_zombie_kill_vox" },
    { 0x9BE2946B, "player_zone" },
    { 0x1F0E178A, "player_zone_found" },
    { 0x968A784A, "player_zones" },
    { 0x254B5D44, "player_zpu" },
    { 0x4EDF8F72, "playeractivatedairsupport" },
    { 0xC9BA1954, "playeraddupgradehud" },
    { 0x07C08A28, "playerads" },
    { 0x23D42B4D, "playeraffectedarray" },
    { 0x7CB442B9, "playeraim" },
    { 0xA4DBAD39, "playeraimatcharactercheck" },
    { 0xDF7F78FE, "playeraimsuppression" },
    { 0xE0065F56, "playerangles" },
    { 0x5A0D3A48, "playeranimscriptevent" },
    { 0x0DC73EB5, "playerarray" },
    { 0x50DFF783, "playerassist" },
    { 0xC71487E4, "playerat_exit" },
    { 0x72A9637E, "playerattachupgrademodel" },
    { 0xAB75CEAC, "playerattackingautomaton" },
    { 0x9FA9A2E3, "playerbasepoi" },
    { 0x6F0B4E64, "playerbegincallback" },
    { 0xDC213294, "playerbeingrevived" },
    { 0x92DD352E, "playerbeingspectated" },
    { 0xA58262E8, "playerblizzard" },
    { 0xC9CD0366, "playerbody" },
    { 0x5AEDD2FA, "playerbody_firstperson" },
    { 0xBB95A10F, "playerbody_thirdperson" },
    { 0x9B5F1886, "playerbodyspawner" },
    { 0x4D326F25, "playerbreathingsound" },
    { 0x3712DB17, "playerbugtime" },
    { 0x91E0C24A, "playerbundle" },
    { 0xB8FE1940, "playercalledairsupport" },
    { 0x3F292EE0, "playercamlinkto" },
    { 0xF9324BCE, "playercamunlink" },
    { 0x39654D6A, "playercanafford" },
    { 0x4C967C3D, "playercansee" },
    { 0xAD758DFB, "playercanseeme" },
    { 0xCAE3FA05, "playercapturelpm" },
    { 0x4EEBAC3E, "playercapturemax" },
    { 0x4BBAB714, "playercard" },
    { 0x769AD13B, "playercausedactordamage" },
    { 0x54BBAB1C, "playerchangeweaponwaiter" },
    { 0x06B05D4A, "playerclass" },
    { 0xE4871968, "playerclip" },
    { 0xC55E1AE3, "playerclip_restore" },
    { 0xCD0157F1, "playerclone" },
    { 0xA52350A9, "playercolor0" },
    { 0x7F20D640, "playercolor1" },
    { 0xF128457B, "playercolor2" },
    { 0xCB25CB12, "playercolor3" },
    { 0x61020B6C, "playercolumn" },
    { 0xA266524C, "playercontrolled" },
    { 0xE0EC1030, "playercoordinate" },
    { 0x7E2C28B7, "playercount" },
    { 0x1C5EEBEE, "playercounts" },
    { 0x6C73B74A, "playercphudelems" },
    { 0xC6883BAD, "playercrossed" },
    { 0x3155D7E3, "playercurrenthealth" },
    { 0x9A4CAE44, "playercursor" },
    { 0x2F25A48E, "playercursorai" },
    { 0x9E0D1578, "playercursornode" },
    { 0xC6A3B5C1, "playerdamage" },
    { 0x4C71BB57, "playerdamaged" },
    { 0xF9CCB08E, "playerdamagerumble" },
    { 0x9F8FD3F5, "playerdamageshellshock" },
    { 0x1A9421AE, "playerdamagewrapper" },
    { 0xB697AE14, "playerdeath" },
    { 0xD794B987, "playerdeaths" },
    { 0xC31D0C47, "playerdeathtimer" },
    { 0x10520E70, "playerdefensepos" },
    { 0x77C2B015, "playerdefensivemax" },
    { 0x473CF305, "playerdeleted" },
    { 0xF8791B2A, "playerdettachupgrademodel" },
    { 0x0D056DDA, "playerdialog" },
    { 0xAC9B02B5, "playerdialogbundles" },
    { 0x4798FF54, "playerdied" },
    { 0xD989066F, "playerdifficultyhealth" },
    { 0xBE8EC63F, "playerdir" },
    { 0xC4E4E51E, "playerdisconnectwaiter" },
    { 0xCB08E508, "playerdisconnectwatcher" },
    { 0x73AB8C56, "playerdist" },
    { 0xB46FA2AF, "playerdistance" },
    { 0xFE37BA16, "playerdistancetoai" },
    { 0x431366CD, "playerdistancetoaisquared" },
    { 0xB2400B92, "playerdistsq" },
    { 0x8E1E08EE, "playerdoublegrenadetime" },
    { 0xF9805D76, "playerdrivablevehicles" },
    { 0xF86FC308, "playerdrivenversion" },
    { 0x33AC1699, "playereffect" },
    { 0x8FF2EA21, "playerelectrictrapdamage" },
    { 0x86F83F5C, "playerendcallback" },
    { 0x97161916, "playerenemies" },
    { 0x9575EA98, "playerenemyvec" },
    { 0x4B7162DB, "playerentnum" },
    { 0xA1653832, "playereventslpm" },
    { 0x78582099, "playereventsmax" },
    { 0xB98CC33C, "playerexert" },
    { 0xA96FE1C5, "playereye" },
    { 0xA64C5A7A, "playerfaceangle" },
    { 0x81E4C8C9, "playerfakedeath" },
    { 0x49F720A3, "playerfalldamagesound" },
    { 0x58121B44, "playerflamedamage" },
    { 0x1E9A5EEB, "playerfoliage" },
    { 0x3DA75A23, "playerfollowers" },
    { 0x5E17F7AE, "playerfootsounds" },
    { 0x8FAD61F4, "playerfootstep" },
    { 0xD87E5CBD, "playerforcerespawn" },
    { 0x49E0EA09, "playerforward" },
    { 0xE9F210F5, "playerforwardvec" },
    { 0x7FAE3FFE, "playerfound" },
    { 0x3765963B, "playerfov" },
    { 0xEE3EDCD4, "playergibbundle" },
    { 0x4196B217, "playergibleftarm" },
    { 0xC455C000, "playergibleftarmvel" },
    { 0x0C52423D, "playergibleftleg" },
    { 0x031C8D66, "playergibleftlegvel" },
    { 0x310472B3, "playergiblegs" },
    { 0xDC0D46FC, "playergiblegsvel" },
    { 0x5B9D57E8, "playergibrightarm" },
    { 0x9CE428B9, "playergibrightarmvel" },
    { 0xD8B718A6, "playergibrightleg" },
    { 0x918FB16F, "playergibrightlegvel" },
    { 0xA45E2BCC, "playergibtag" },
    { 0x8A712B5B, "playerglancedistancesq" },
    { 0xAFE75BA6, "playergotheadshot" },
    { 0x1C847748, "playergrenadebasetime" },
    { 0x862B6C50, "playergrenaderangetime" },
    { 0x14B34F0F, "playergroundpos" },
    { 0x60011013, "playergroup" },
    { 0x40DFA7E9, "playerhasengineerperk" },
    { 0xA9AF412A, "playerhasseenmi17crash" },
    { 0x2360E435, "playerhastacticalmask" },
    { 0xDA8C6521, "playerheadoffset" },
    { 0xE2AB5024, "playerhealth" },
    { 0xB9CFECFD, "playerhealth_regularregendelay" },
    { 0x0610DFE1, "playerhealthdebug" },
    { 0xD1591847, "playerhealthregen" },
    { 0xB5FBA254, "playerhealthregentime" },
    { 0xFDA24C07, "playerhealthsystemoverride" },
    { 0x7D69A720, "playerheartbeatloop" },
    { 0xBA92A26B, "playerheartbeatsound" },
    { 0x39551811, "playerhelicopterswitch" },
    { 0x7FDDB648, "playerhelidetector" },
    { 0x6B584BDD, "playerhit" },
    { 0x92D2EF21, "playerhitable" },
    { 0x712B29BA, "playerhitdamage" },
    { 0x57C6120E, "playerhitinvulntime" },
    { 0x0FABC32F, "playerhurtcheck" },
    { 0xDF5F643F, "playeri" },
    { 0x948FAF68, "playeri_origin" },
    { 0x3B614730, "playerignoredist" },
    { 0xD88E93A5, "playerignoredisttext" },
    { 0x3B088B87, "playerincrementalrespawndelay" },
    { 0xD91DFA76, "playerindex" },
    { 0x4E80399E, "playerindoors" },
    { 0x6DC3C3B0, "playerinhabited" },
    { 0x342A662B, "playerinhelitargetsights_orrandom" },
    { 0x634B93FC, "playerinit" },
    { 0x976F7B3A, "playerinrange" },
    { 0xEB3B831F, "playerinseaknight" },
    { 0xBD76F2FC, "playerinvul" },
    { 0x76F0070E, "playerinvultimeend" },
    { 0x0A43F2F3, "playerinvultimescale" },
    { 0x387F7F81, "playerinzone" },
    { 0x28A43D46, "playeris" },
    { 0xC07F2C44, "playerisaboveground" },
    { 0xDFC2EB06, "playerisclingingtobus" },
    { 0x5C4344BA, "playerisclose" },
    { 0xCB5D1C56, "playerisfavoriteenemy" },
    { 0x5760AB70, "playerisinfront" },
    { 0x6262BC62, "playerisinside" },
    { 0x82EA14DF, "playerisonturret" },
    { 0xC5BFC9B9, "playeristarget" },
    { 0xB76D0DE6, "playeristargeted" },
    { 0xB769099B, "playeriswinner" },
    { 0x329C0E81, "playerj_origin" },
    { 0xE375F1B3, "playerjavelinads" },
    { 0x2E13C5C2, "playerjump" },
    { 0xB72C1399, "playerjustgotredflashing" },
    { 0xAAD6BD0B, "playerkicked" },
    { 0x7E7D9816, "playerkill" },
    { 0x36B8F1D9, "playerkilled" },
    { 0x3F735E1D, "playerkilled_awardassists" },
    { 0x489D248C, "playerkilled_kill" },
    { 0xDA9B1ACD, "playerkilled_killstreaks" },
    { 0xCAA6D8D5, "playerkilled_obituary" },
    { 0x41055C90, "playerkilled_suicide" },
    { 0xD7A6CC2B, "playerkilled_teamkill" },
    { 0xD7EADE4E, "playerkilled_updatemeansofdeath" },
    { 0xF9DAE37E, "playerkilled_watch_death" },
    { 0x6C73FCE1, "playerkilled_weaponstats" },
    { 0x19612A29, "playerkilledchallengesprocessed" },
    { 0x19801FE1, "playerkillsmax" },
    { 0x215EDF3B, "playerknockback" },
    { 0x1AA3F5BD, "playerland" },
    { 0x001BBD62, "playerlaststand" },
    { 0xA6179873, "playerlaststand_func" },
    { 0x89EF31AD, "playerlevelendchallengeprocess" },
    { 0x7C58F7E5, "playerlinked" },
    { 0x291AB381, "playerlinkedoffsetenable" },
    { 0x2DDBF95F, "playerlinkedsetusebaseangleforviewclamp" },
    { 0xE6ADC1CB, "playerlinkinfluence" },
    { 0x304D0969, "playerlinkmodel" },
    { 0x50E60929, "playerlinkobj" },
    { 0xA5E408D7, "playerlinkobj_defaultpos" },
    { 0xD9C7FACE, "playerlinkobj_getforwardvector" },
    { 0x5E5DC9D0, "playerlinkobj_gettargetgroundpos" },
    { 0x21740798, "playerlinkobj_moveincforward" },
    { 0x1343BF25, "playerlinkobj_moveincright" },
    { 0xAD675DB2, "playerlinkobj_moveobj" },
    { 0xEC2F4FBF, "playerlinkobj_orient" },
    { 0x2F2D60F9, "playerlinkobj_rotate" },
    { 0x6E7E112C, "playerlinkobj_viewclamp" },
    { 0xE36EFFD5, "playerlinkobj_zoom" },
    { 0x60CDE61C, "playerlinkorg" },
    { 0x87B6CDA1, "playerlinkto" },
    { 0xF7477112, "playerlinktoabsolute" },
    { 0x62C42724, "playerlinktocamera" },
    { 0xED594D21, "playerlinktodelta" },
    { 0x9297504C, "playerlinkweaponviewtodelta" },
    { 0xD945E7AD, "playerliquidfiredamage" },
    { 0x70D9F547, "playerlives" },
    { 0xFAAF1C9F, "playerlocationscenebtargetname" },
    { 0xCB23B9E9, "playerlook_trace" },
    { 0x8CEA2E62, "playermaskputon" },
    { 0x49F8ACF6, "playermaxdistancefrombmp" },
    { 0xE7ECDC2D, "playermaxdistancefrombmpsquared" },
    { 0xF54CF62A, "playermaxdistancetobmpc4" },
    { 0x479D2BC1, "playermaxdistancetobmpc4squared" },
    { 0x6DA13EE2, "playermaxhealth" },
    { 0xAB51103B, "playermaxs" },
    { 0xCD3E4F52, "playermayspawn" },
    { 0x460E754B, "playermeshorigin" },
    { 0x4598CED1, "playermins" },
    { 0xA6333ACA, "playermodelforweapon" },
    { 0xAC9F474D, "playermortar" },
    { 0xF99C660B, "playermortarfovoffset" },
    { 0xA8D8BD6F, "playermovedrecently" },
    { 0xB3D32C97, "playername" },
    { 0xDA7E1972, "playernamehudelems" },
    { 0x9A168F0E, "playernode" },
    { 0x046835F9, "playernormalized" },
    { 0x23231BC1, "playernotify" },
    { 0x5C820472, "playernum" },
    { 0x2C3D1587, "playerobjectiveheldrespawndelay" },
    { 0x92A60C6F, "playeroffensivemax" },
    { 0xA839C852, "playerone" },
    { 0xD5704777, "playeronvehicle" },
    { 0x2BABA4D4, "playerorg" },
    { 0x3BA4AD68, "playerorigin" },
    { 0x4921A2F3, "playeroutside" },
    { 0xE50496BA, "playerparticipationcontainer" },
    { 0x98FF91CC, "playerparticipationgate" },
    { 0x7D258B1C, "playerpendamage" },
    { 0x188FA221, "playerpersistent" },
    { 0x2B8164FC, "playerphysicstrace" },
    { 0xB8E5D33B, "playerpiggyback" },
    { 0x6DCA7C12, "playerplaces" },
    { 0x0038347C, "playerpos" },
    { 0x7A435FDF, "playerpositionvalid" },
    { 0xC5939C40, "playerpositionvalidignoreent" },
    { 0x43543A49, "playerpreviousweapon" },
    { 0xE6680965, "playerprevorigin0" },
    { 0xC0658EFC, "playerprevorigin1" },
    { 0x75A07A9F, "playerprimaryweapons" },
    { 0x7006A736, "playerpulledfromcar" },
    { 0xFF86885E, "playerpushable" },
    { 0x38A6BF87, "playerqueuedrespawn" },
    { 0xB4899509, "playerrangemax" },
    { 0xF31AF15C, "playerrangemaxtext" },
    { 0xCF7EC0B7, "playerrangemin" },
    { 0xC58FD822, "playerrangemintext" },
    { 0xC7BBB4D8, "playerrank" },
    { 0x8E2656EB, "playerrankings" },
    { 0xCCFBAE17, "playerready" },
    { 0x9430342D, "playerremoveupgradehud" },
    { 0x6831CBA4, "playerrenderoptions" },
    { 0x2E53984B, "playerrespawndelay" },
    { 0x2395E945, "players" },
    { 0x2DEB732B, "players_alive" },
    { 0x999C4A7D, "players_are_in_perk_area" },
    { 0x12A3DBCB, "players_can_damage_riotshields" },
    { 0xF95C4135, "players_can_see_maze_volume" },
    { 0x175F5F97, "players_capture_zone" },
    { 0x0D55F2F4, "players_cleared_bunker" },
    { 0xD3ABBCBB, "players_connect_opening" },
    { 0xB2EA41C5, "players_count" },
    { 0xB054A36C, "players_counter_str" },
    { 0x4A80CB25, "players_disable_rain" },
    { 0xEC694885, "players_done_connecting" },
    { 0x956C0441, "players_drops_down_early" },
    { 0x5C631731, "players_emped" },
    { 0x363407A2, "players_enable_rain" },
    { 0xF8C00AC8, "players_expected" },
    { 0xE6036AA7, "players_eye" },
    { 0x9FF55C5B, "players_far" },
    { 0xF7C1232D, "players_grenades" },
    { 0xE5AD4BEB, "players_has_weapon" },
    { 0x77EFE5C3, "players_ignoreall" },
    { 0x4740721D, "players_in_escape_pod" },
    { 0x92EEB0AE, "players_in_game" },
    { 0x23EBE337, "players_in_jeeps" },
    { 0xA169D1CD, "players_in_maze" },
    { 0x7B684AD6, "players_in_maze_volume" },
    { 0xBFC58301, "players_in_position" },
    { 0x95684EF5, "players_in_proj_room" },
    { 0x8770BAB8, "players_in_start_area" },
    { 0x4C48C1C8, "players_in_town_area" },
    { 0x3B0E5465, "players_in_water_count" },
    { 0xEE0A7F49, "players_in_zombieland" },
    { 0xAC3B3FBA, "players_in_zone" },
    { 0x5D6E2E58, "players_jump_from_cliff" },
    { 0x0355C4DF, "players_jumped" },
    { 0xFD602E5C, "players_landed" },
    { 0x89A0E53E, "players_linked_to_train" },
    { 0x802AAEEA, "players_lvt" },
    { 0xA1321609, "players_nearby" },
    { 0x115E13FC, "players_off_lvt" },
    { 0xF288A25B, "players_okayed" },
    { 0x40621D42, "players_on_tank_update" },
    { 0xC10AAB71, "players_on_team" },
    { 0x4D7B5AD9, "players_over_wall" },
    { 0x51F2B017, "players_part1_done" },
    { 0x20A33622, "players_playing" },
    { 0xBA01DDA6, "players_reached_rounds_counter_watcher" },
    { 0x5280054C, "players_remaining" },
    { 0xB8F2C8EE, "players_reviving" },
    { 0x7D62A0D2, "players_rifle_gren_pickup" },
    { 0xD5E8112E, "players_rifle_gren_pickup_watch" },
    { 0x9FB66D33, "players_s" },
    { 0x8CDACDD4, "players_safe_belowground" },
    { 0xC7A07E6E, "players_satchel_hint" },
    { 0x12065059, "players_speed" },
    { 0x8DAD0CF4, "players_speed_set" },
    { 0xBF143EBF, "players_speed_set_gradual" },
    { 0x21DF45B0, "players_spot" },
    { 0x18A644AC, "players_stillthere" },
    { 0x444B6D7A, "players_that_can_respond" },
    { 0xA1B54A81, "players_this_inc" },
    { 0x3AE5E627, "players_to_teleport" },
    { 0x3A91E596, "players_total" },
    { 0x2277269B, "players_touching" },
    { 0x535AFF84, "players_viscache" },
    { 0x5E90B2FC, "players_water_drops_off" },
    { 0x1CA40F46, "players_water_drops_on" },
    { 0x13435D22, "playersafetyblocker" },
    { 0xDA55562B, "playersclass" },
    { 0x1EEA6B54, "playerscore" },
    { 0xA6ADBE78, "playerscored" },
    { 0x07D48F94, "playerscorelimitsoon" },
    { 0x0FF266E7, "playersdrivingvehiclesbecomeinvulnerable" },
    { 0xCBA28672, "playerse" },
    { 0x020DF502, "playerseek" },
    { 0x411EA9D3, "playerseeker" },
    { 0xE2683259, "playerseliminated" },
    { 0xFF57A1A9, "playersetgroundreferenceent" },
    { 0xE496B8F9, "playershoottracker" },
    { 0x4294BBB0, "playersighttrace" },
    { 0xD383DDD5, "playersinlocal" },
    { 0x0C6F4B6A, "playersleft" },
    { 0xA07403D4, "playersndhearbeatoneshots" },
    { 0xED20CFAC, "playersniperkillsafterbigrig" },
    { 0x8AAAF089, "playersonbridge" },
    { 0x005ECEE9, "playersonteam" },
    { 0x559540E9, "playersonwinningteam" },
    { 0xAA78E031, "playersoundonuse" },
    { 0x5E92B6FC, "playerspawned" },
    { 0x47E8B476, "playerspawned_callback" },
    { 0x6A46230F, "playerspawnedcb" },
    { 0xB318AF43, "playerspawnpos" },
    { 0x8331AD83, "playerspeed" },
    { 0x57B63AE2, "playersplace" },
    { 0x6051060A, "playerspot" },
    { 0xC2F2426F, "playerspread" },
    { 0x2595CC35, "playersprinttime" },
    { 0x14E29F8F, "playersquadid" },
    { 0xAED2445F, "playersrank" },
    { 0x40F68013, "playersremaining" },
    { 0xF2C2D11F, "playersride" },
    { 0x77CF21D4, "playerss" },
    { 0x8555E6A6, "playerstance" },
    { 0xCF6F6EDA, "playerstart" },
    { 0x3DA616B8, "playerstart_array" },
    { 0xC1270BA3, "playerstatslist" },
    { 0x3F580A4A, "playerstingerads" },
    { 0xE1FAE7BA, "playerstoattack" },
    { 0xE187D686, "playerstouching" },
    { 0xEDE2AC9E, "playersuicideallowed" },
    { 0xE234C979, "playersupportindex" },
    { 0xE5A98ECA, "playersviewingheadicons" },
    { 0x4030F0E4, "playertargetedtimes" },
    { 0xD4E368CC, "playertargets" },
    { 0xAE273D25, "playerteam" },
    { 0xC5CEBCF2, "playerteamsflag" },
    { 0x7DF1272D, "playerteamtoallow" },
    { 0x1BFF7C15, "playerthrownincar" },
    { 0x43BF7B60, "playertobanzaiunitvec" },
    { 0x07B39F5A, "playertobanzaivec" },
    { 0x6102DB35, "playertoenemyunitvec" },
    { 0x35F73E63, "playertoenemyvec" },
    { 0xC94BEEDB, "playertoignore" },
    { 0x6509124E, "playertomove" },
    { 0xC00DB8AE, "playertorevive" },
    { 0xBAD791BD, "playertouching" },
    { 0xEE0CF9C7, "playertrack" },
    { 0x569F288C, "playertracked" },
    { 0xD1CABC02, "playertrigger" },
    { 0xC982B8DA, "playertriggerdistsq" },
    { 0xE63F9715, "playertriggered" },
    { 0x52CD1AB5, "playertweaks" },
    { 0x46D6659F, "playerunitforwardvec" },
    { 0xBAD56045, "playerunlimitedammothread" },
    { 0x5E5B7B7D, "playervalue" },
    { 0x7DF05D36, "playervehicle" },
    { 0x27A3E72B, "playervehicle_fov_start" },
    { 0xC2CD09FC, "playervehicle_fov_zoom" },
    { 0x7B6A5879, "playervehicle_healthleakincrement" },
    { 0xB36ACBD8, "playervehicle_healthleakrate" },
    { 0xCD28555D, "playervehicle_healthregenincrement" },
    { 0x805FD1E4, "playervehicle_healthregenrate" },
    { 0x17475FA7, "playervehicle_healthwarning_value" },
    { 0x27BA5C35, "playervehicle_infront_of_honkingvehicle_vehicle" },
    { 0x5F5B2CA6, "playervehicle_starting_health" },
    { 0xAB578AFC, "playervehicledamagerange" },
    { 0x11F5848F, "playervehicledamagerangesquared" },
    { 0x894A2D38, "playervehiclenone" },
    { 0x4B09EE3D, "playerview" },
    { 0xB1756EA5, "playerview2" },
    { 0x264DFED0, "playerview_angles" },
    { 0x4323C8FE, "playerview_checkinterrupted" },
    { 0xBBE06588, "playerview_endsequence" },
    { 0xF086DA00, "playerview_forceinterruption" },
    { 0x6E307CB0, "playerview_hide" },
    { 0x1413F7B7, "playerview_knockdownanim" },
    { 0x56FFF70B, "playerview_show" },
    { 0x7ECDF56D, "playerview_spawn" },
    { 0xBB528AA3, "playerview_startsequence" },
    { 0x1E3D2DC9, "playerviewlockentity" },
    { 0xB9DC1790, "playervisdist" },
    { 0x510718D2, "playervisdist2" },
    { 0x858FF905, "playervisdisttext" },
    { 0x5593CD18, "playervisiontrig" },
    { 0xC0915AF8, "playerwasnearby" },
    { 0x62E3B2A6, "playerwastouching" },
    { 0x0C727ADA, "playerweapon" },
    { 0xF8F87CAD, "playerweapongive" },
    { 0xAB1F5CD5, "playerweapons" },
    { 0x6C640BCF, "playerweapontake" },
    { 0xAC60F313, "playerweapontakelogic" },
    { 0xC21F6BC4, "playerweapontempremove" },
    { 0x9603D2A2, "playerweather" },
    { 0x29320441, "playerweatherlooprunning" },
    { 0xB7209495, "playerweatherstarted" },
    { 0xC91BEFCE, "playerwhobuilt" },
    { 0xBBA194DC, "playerwithincharactersview" },
    { 0x9FA270D0, "playerxuid" },
    { 0xD6F18A23, "playeryaw" },
    { 0x396566A8, "playerzipdamage" },
    { 0x2D08BDF2, "playerzombie_downed_hud" },
    { 0x4025D282, "playerzombie_downed_state" },
    { 0x60A84695, "playerzombie_downed_state_done" },
    { 0xA67E26A0, "playerzombie_infinite_health" },
    { 0x6E7C83C5, "playerzombie_play_sound" },
    { 0x7A55253C, "playerzombie_player_damage" },
    { 0x3541C898, "playerzombie_soundboard" },
    { 0x49AA2CE9, "playerzombie_soundboard_disable" },
    { 0xC10DE607, "playerzombie_waitfor_buttonrelease" },
    { 0xE8F03276, "playerzombiestatget" },
    { 0xBFE31D2A, "playerzombiestatset" },
    { 0x67253DC0, "playerzone" },
    { 0x7D73DCA0, "playerzonenum" },
    { 0x83C85C73, "playes" },
    { 0xA9CAD6DC, "playet" },
    { 0x7E2596A8, "playexitanim" },
    { 0x9BA26EB3, "playexplodedeathanim" },
    { 0xDBF7494E, "playexploderfx" },
    { 0xD25F0A56, "playexposedanim" },
    { 0xE438EAAD, "playextracamxcam" },
    { 0x07AF9459, "playey" },
    { 0x028549AA, "playface_waitfornotify" },
    { 0xC2D68D9E, "playface_waitfortime" },
    { 0xA8624D04, "playfacethread" },
    { 0x03B6F223, "playfastfx" },
    { 0x74004E0B, "playflarefx" },
    { 0x125A6838, "playflashsound" },
    { 0x69E73361, "playfootstep" },
    { 0x8094635A, "playfootstepeffect" },
    { 0xFD4BA5E1, "playfx" },
    { 0xB4260CC7, "playfx_blinking_light" },
    { 0x67AD0248, "playfx_for_all_local_clients" },
    { 0x1080DEC7, "playfx_on_array_angled" },
    { 0x82462B91, "playfx_on_tower" },
    { 0x77882D28, "playfx_spot_over_table_and_delete" },
    { 0x054DE015, "playfx_write_all" },
    { 0x099D2801, "playfxbundle" },
    { 0x0B944AA2, "playfxon" },
    { 0x2E9C26EF, "playfxoncamera" },
    { 0xF3D89C3A, "playfxondynent" },
    { 0xDA6ACFD2, "playfxontag" },
    { 0xCD5F8B0E, "playfxontag_delay" },
    { 0x87C9C4C6, "playfxtimed" },
    { 0x89174380, "playgadgetactivate" },
    { 0xB670824C, "playgadgetready" },
    { 0x3B192E60, "playgadgetsuccess" },
    { 0xE954F8D4, "playgesture" },
    { 0x2794F71C, "playgesturetype" },
    { 0x91DDA0B6, "playglassexploder" },
    { 0x6371BDAC, "playgrenaderumble" },
    { 0xE0CCE682, "playground" },
    { 0xAF4F39D8, "playground_off" },
    { 0x5DE23312, "playground_on" },
    { 0x75614DDF, "playguardwalla" },
    { 0xD83EFA92, "playhackertoolsoundloop" },
    { 0xEA36FC27, "playheadchopperresetaudio" },
    { 0x5B3150E3, "playhero" },
    { 0xC4200231, "playhitanim" },
    { 0xC6D09900, "playhitanimation" },
    { 0x6CECEEF8, "playhitmarker" },
    { 0x624A623B, "playhitsound" },
    { 0xE26F43B1, "playidle" },
    { 0xAD26D669, "playidleanimation" },
    { 0x52969FE6, "playidleface" },
    { 0xB9471722, "playin" },
    { 0xF9A1CB78, "playinformevent" },
    { 0x4FCAEDD9, "playing" },
    { 0x3DB9E930, "playing_alarm_loop" },
    { 0x3CAC46D7, "playing_animation_index" },
    { 0x3A53B942, "playing_attack_vox" },
    { 0x6EA670CD, "playing_backstroke" },
    { 0xE3B4C1E9, "playing_crew_prefire" },
    { 0x50F2E700, "playing_custom_pain" },
    { 0x594BB274, "playing_damage_animation" },
    { 0x48470ADE, "playing_fx" },
    { 0x0350C5E8, "playing_gas_loop" },
    { 0xCFC190FA, "playing_idle" },
    { 0xF3A353D6, "playing_intro_anim" },
    { 0x675493FE, "playing_loop" },
    { 0xF88FE4F9, "playing_movement_vox" },
    { 0xCCCF685A, "playing_reznov_yes_vo" },
    { 0x9385D78F, "playing_scream" },
    { 0x25D604FD, "playing_sp" },
    { 0xE0EB72B5, "playing_turned_kill_vo" },
    { 0x582E32CA, "playing_tutorial" },
    { 0xB03F681C, "playing_wake" },
    { 0x5225FAD5, "playing_wake_fx" },
    { 0x5BE487DE, "playing_water_fx" },
    { 0x5086DC70, "playing_wingtip" },
    { 0xEC683748, "playingactionmusic" },
    { 0x856DD99D, "playingdialog" },
    { 0x33B1DE58, "playingduprenderbundle" },
    { 0x90B0E1D6, "playinggadgetreadydialog" },
    { 0x1E465BA6, "playinggesture" },
    { 0x034ADAB9, "playingmovementanim" },
    { 0xE08C5209, "playingpostfxbundle" },
    { 0x7C39DE06, "playingsound" },
    { 0x7CA854A3, "playingtaunt" },
    { 0x16292043, "playinguidecodeloop" },
    { 0xA1F39C46, "playitcool_dialog" },
    { 0x57F41AD8, "playkillbattlechatter" },
    { 0xD2013B94, "playkillstreakenddialog" },
    { 0xB219DA4E, "playkillstreakreadyandinformdialog" },
    { 0xF088D14A, "playkillstreakreadydialog" },
    { 0x8AC95F5B, "playkillstreakstartdialog" },
    { 0x319B8AE4, "playleaderdialog" },
    { 0xE529FD90, "playleaderdialogonplayer" },
    { 0x5BBF1727, "playlength" },
    { 0x27EBDA3C, "playlightloopexploder" },
    { 0x7EF945BC, "playlines" },
    { 0xCE7F9355, "playlinkedsound" },
    { 0xE0D39F5B, "playlist" },
    { 0x34D81D05, "playlistbanpenalty" },
    { 0xA8F31C2D, "playlistbanquantum" },
    { 0x5B484B7E, "playlobbywalla" },
    { 0x988C023D, "playlocalkillshotsound" },
    { 0x8A20E55D, "playlocalsound" },
    { 0xE72C395D, "playlocalteamfx" },
    { 0xC4DE2999, "playlockonsounds" },
    { 0x3DEBA031, "playlockonsoundsthread" },
    { 0xFF3317D4, "playlookanimation" },
    { 0xF191E169, "playloop" },
    { 0x11908F52, "playloopat" },
    { 0x5D7ADFC4, "playloopedfx" },
    { 0x21CC5E39, "playloopedfxontag" },
    { 0x58642805, "playloopedfxontag_originupdate" },
    { 0xC2931A36, "playloopsound" },
    { 0x74B350B9, "playloopsoundforseeking" },
    { 0xC7C08DD4, "playmaincamxcam" },
    { 0xFFCDBBFA, "playmallmusic" },
    { 0x9453DE26, "playmeleesound" },
    { 0x7C219D34, "playmicrowavefx" },
    { 0x3A76C1AC, "playmovementsounds" },
    { 0x3A841DBB, "playmultiple" },
    { 0x4FD2D547, "playmusicpackage_backlot" },
    { 0x7BC51764, "playneardeathbodydamagefx" },
    { 0x0536EBBF, "playnextleaderdialog" },
    { 0x90ABD124, "playnonteambasedenemysounds" },
    { 0x92E50464, "playnotetrack" },
    { 0x18E0F0DE, "playnotifyloop" },
    { 0x78492F2F, "playnumbersaudio" },
    { 0x843607B8, "playon" },
    { 0xE1ACA047, "playonent" },
    { 0x4E5770C1, "playonenttag" },
    { 0x4391BB56, "playonself" },
    { 0x27163AD7, "playorderevent" },
    { 0x27B46775, "playout" },
    { 0x2479FD18, "playpainanim" },
    { 0xE70FCA17, "playpainsounds" },
    { 0xB284AA26, "playpassengeranim" },
    { 0x4C1F75F9, "playpavox" },
    { 0xE290D6D0, "playphrase" },
    { 0xCE371B97, "playpilotdialog" },
    { 0xE20B76BF, "playpilottalking" },
    { 0x3280A661, "playplanefx" },
    { 0xDCCE074B, "playpoint" },
    { 0xBCA12B73, "playpostfxbundle" },
    { 0x2429C67F, "playpromotionreaction" },
    { 0x345E285B, "playradiantexploder" },
    { 0x2F3C746D, "playradiationsound" },
    { 0x080490D9, "playradiosound" },
    { 0xBC336078, "playre" },
    { 0xCA4C9BAB, "playreactanim" },
    { 0x7563778A, "playreactionevent" },
    { 0xB6600428, "playreloadsounds" },
    { 0x424BBC66, "playresponseevent" },
    { 0xD46E05E9, "playrival" },
    { 0x8DEDCA9C, "playrumblelooponentity" },
    { 0xE2AF603E, "playrumbleonentity" },
    { 0x5E09918E, "playrumbleonposition" },
    { 0x38D9087E, "plays" },
    { 0x11079394, "playsatellitefx" },
    { 0x1D096391, "playscene" },
    { 0xB5684206, "playscrapeforframes" },
    { 0x14A9A98E, "playscriptedmeleeanimations" },
    { 0xACCFED0D, "playsemtexfx" },
    { 0x35CD071B, "playsidestepanim" },
    { 0xF0BFA760, "playsmokeeffects" },
    { 0x1A821727, "playsmokesound" },
    { 0x921A1574, "playsound" },
    { 0xFAD0F305, "playsound2dent" },
    { 0x4CB0CDA9, "playsound_generic_facial" },
    { 0x9F960D84, "playsound_on_players_in_zone" },
    { 0xA0A00CB3, "playsound_on_zapped" },
    { 0x3193A83D, "playsoundaftertime" },
    { 0x1BCF910E, "playsoundasmaster" },
    { 0xC8EF91BF, "playsoundatpoint" },
    { 0x37CBCF1A, "playsoundatposition" },
    { 0x94AAA05E, "playsoundatposition_wait" },
    { 0x6F69E521, "playsoundforlocalplayer" },
    { 0xFD0D11AD, "playsoundinspace" },
    { 0xA56C9EAB, "playsoundonplayers" },
    { 0x8B51B0E9, "playsoundontag" },
    { 0x74C3B44F, "playsoundoverradio" },
    { 0x4D103DB2, "playsoundoverradio_done" },
    { 0xFB80E981, "playsounds_gasmask" },
    { 0xA6B3F466, "playsoundtoallbutplayer" },
    { 0xB8862210, "playsoundtoplayer" },
    { 0x1CDD7BF4, "playsoundtoteam" },
    { 0xCA265377, "playsoundwithnotify" },
    { 0xEF8E7F54, "playspacecenter" },
    { 0x60496ECD, "playspecificdialogue" },
    { 0xAF11516D, "playspeech" },
    { 0x66775D98, "playspeed" },
    { 0x81615E10, "playspinnerfx" },
    { 0xE030828A, "playspringpadresetaudio" },
    { 0x5A785A87, "playspyplaneafterburnerfx" },
    { 0xEE28BFA9, "playspyplanefx" },
    { 0x12BCA2D8, "playstartconversation" },
    { 0x5E95D4BA, "playstate" },
    { 0x31687243, "playstinger" },
    { 0x215B9EE3, "playstingerstop" },
    { 0xDEA8B878, "playswipesound" },
    { 0xF98E3F3A, "playtabunsound" },
    { 0x20084601, "playtag" },
    { 0x0A520F61, "playtagfxset" },
    { 0xF84E8B03, "playtankexhaust" },
    { 0x930520D5, "playtargetmissilesound" },
    { 0xF2A89D41, "playtaunt" },
    { 0x495E6027, "playtest" },
    { 0xC386F119, "playthreatevent" },
    { 0x0E2987F6, "playthrough" },
    { 0xA2ECB6A6, "playthrowhatchet" },
    { 0x182137C4, "playthundergunpainanim" },
    { 0x8267B719, "playtickingsound" },
    { 0x149C9294, "playtime" },
    { 0xBF067E90, "playtimems" },
    { 0x330009DF, "playtombstonetimeraudio" },
    { 0xF9CE4C41, "playtombstonetimerout" },
    { 0x2BBB7BBF, "playtop3sounds" },
    { 0xA836D03C, "playtoweraudio" },
    { 0x9665E95E, "playtransition" },
    { 0xF7B75149, "playtransitionanim" },
    { 0x1A2E8B78, "playtransitionanimation" },
    { 0x9B22DC2A, "playtransitionanimation2" },
    { 0x01DFB7AA, "playtransitionanimationfunc" },
    { 0x8286D4CC, "playtransitionanimationthread_withoutwaitsetstates" },
    { 0x19A5A3C1, "playtransitions" },
    { 0x78451025, "playtransitionstandwalk" },
    { 0xA9AA6A8A, "playturnedmusic" },
    { 0x7F8EBC0F, "playtype" },
    { 0x2530B62B, "playtype_gameend" },
    { 0xF4EDDA9C, "playtype_none" },
    { 0x9F1EFDEB, "playtype_queue" },
    { 0x68BCBA87, "playtype_reject" },
    { 0x5C92C552, "playtype_round" },
    { 0x82ABEE07, "playtype_special" },
    { 0xE37AC6D6, "playtypes" },
    { 0xB0E881AD, "playuavpilotdialog" },
    { 0x9757AA67, "playvehiclefootstep" },
    { 0x138D4551, "playviewmodelfx" },
    { 0x6E02632E, "playvo" },
    { 0x7255501F, "playvo_proper" },
    { 0x4D52A6F9, "playvo_proper_adhoc" },
    { 0x5D19FF0E, "playvoforsquadcommand" },
    { 0x5D381EDE, "playvoxtoplayer" },
    { 0x44870653, "playwarninglight" },
    { 0x91F8EF73, "playweapondeatheffects" },
    { 0x13575242, "playwhenoff" },
    { 0x8EFD00A3, "playwinnerteamfx" },
    { 0xDFA05374, "playwoodsindisgiuseanim" },
    { 0x5CEB2F6D, "plaza" },
    { 0xEEC96BE5, "plaza_and_intersect_transition" },
    { 0x0577FFD2, "plaza_at4_impact" },
    { 0x5611E5EB, "plaza_at4_sequence" },
    { 0x78EAA274, "plaza_building_assault" },
    { 0xA3538234, "plaza_deathposes" },
    { 0x7CFC5CE2, "plaza_decision_made" },
    { 0x961CEC1F, "plaza_end" },
    { 0x61D6E611, "plaza_flyover" },
    { 0xBB49A861, "plaza_grate_01" },
    { 0xE14C22CA, "plaza_grate_02" },
    { 0x46727031, "plaza_gunner" },
    { 0x706B8AC2, "plaza_harper_movement" },
    { 0x1E9D925A, "plaza_harper_movement_center" },
    { 0x0D061B16, "plaza_harper_movement_left" },
    { 0x91035BED, "plaza_harper_movement_right" },
    { 0xC8A3818B, "plaza_left_path" },
    { 0xB034E0AE, "plaza_middle_right_path" },
    { 0x3AE34282, "plaza_planter" },
    { 0xF9049695, "plaza_planter_done" },
    { 0xEF98F646, "plaza_right" },
    { 0xCC21EEAA, "plaza_right_color_1" },
    { 0xEC569501, "plaza_right_color_1_inside" },
    { 0x629ED9CA, "plaza_right_color_1_outside" },
    { 0xA61F7441, "plaza_right_color_2" },
    { 0xC175CE3D, "plaza_right_color_logic" },
    { 0x9CAB4890, "plaza_right_path" },
    { 0x83EDA4BD, "plaza_rpg" },
    { 0x3190564B, "plaza_sam_time" },
    { 0x834DA25A, "plaza_shop_ai_anims" },
    { 0x385FC8F4, "plaza_tank_move" },
    { 0x204D7095, "plaza_vo" },
    { 0x3C2956AC, "plaza_vo_pmc_callouts" },
    { 0x17176E5B, "plaza_vo_save_french_iav" },
    { 0x3DAFC421, "plazatown" },
    { 0xC382D293, "please" },
    { 0x69576BBE, "pleasedont" },
    { 0xA8EABFAB, "pleasurable" },
    { 0x62E59A5C, "pleasure" },
    { 0x2D3F9871, "plenty" },
    { 0xE417AED4, "plinth" },
    { 0x61210044, "plop" },
    { 0x63595A8C, "plopping" },
    { 0x8AD6DDA3, "plot_circle" },
    { 0x57E53630, "plot_circle_fortime" },
    { 0xB8E2C919, "plot_circle_star_fortime" },
    { 0x425D7B5A, "plot_points" },
    { 0x3576B76D, "plotpoints" },
    { 0xBD5A6874, "plotting" },
    { 0x3B1E85DB, "plow" },
    { 0xFA294FD6, "plow_attach_point" },
    { 0x762757AC, "plow_clip" },
    { 0xB60C9DCC, "plow_trig" },
    { 0xA0885D76, "plow_trigger" },
    { 0xFE3A9BA9, "plr" },
    { 0x9ACE0AF8, "plr_pushing" },
    { 0xF4BAABFF, "plr_stopped" },
    { 0x1FBAE273, "plr_van" },
    { 0xA6CA18AD, "plr_vel" },
    { 0xA89F567B, "plr_vox" },
    { 0xBD83FDFF, "plr_vtol" },
    { 0xBAE5A03C, "pluhr" },
    { 0xE51513C3, "plumes" },
    { 0xB9E260D2, "plummets" },
    { 0xC39C6825, "plunder" },
    { 0x5C5A8A8C, "plunge" },
    { 0xDA6568A6, "plunger" },
    { 0xB27DABCC, "plunger_use_text" },
    { 0x1106EB0C, "plunger_vo" },
    { 0xEAC8BEB7, "plural" },
    { 0x53E9B7A9, "plus" },
    { 0x73A44126, "pluse" },
    { 0x7F7C93F8, "plusside" },
    { 0x5450E95A, "ply" },
    { 0x2844D5EC, "plyr" },
    { 0x310A326F, "plyr_dist" },
    { 0x80448C85, "plywood" },
    { 0x57577B50, "plywoodwalls" },
    { 0x2E4E6EF1, "plz" },
    { 0x22CE92E0, "pm" },
    { 0x4B099010, "pm0" },
    { 0x970E84E2, "pm2" },
    { 0xDD87F2FB, "pmc" },
    { 0x4384DF0A, "pmc_alljuggernauts" },
    { 0x884995F5, "pmc_asd_alert" },
    { 0xB0A7BC93, "pmc_assault_guy" },
    { 0x58EF0102, "pmc_balcony_guy" },
    { 0xB3630ED0, "pmc_chatter_dialog" },
    { 0x1B12D1D1, "pmc_civ_no_fire" },
    { 0x5F186898, "pmc_defalco_extract" },
    { 0xA663E6B9, "pmc_defalco_extract_init" },
    { 0x1091EB91, "pmc_defalco_extract_think" },
    { 0x7D176F2A, "pmc_defalco_extract_vocal" },
    { 0x7808F04B, "pmc_give_headmodel_without_mask" },
    { 0x4803E38A, "pmc_launcher_guy" },
    { 0xBEFFA0E9, "pmc_match" },
    { 0x7014A901, "pmc_orders" },
    { 0xC20D673B, "pmc_plant_convo_end" },
    { 0xD47258AA, "pmc_rappeling" },
    { 0x3CF06D9A, "pmcs" },
    { 0x7570D252, "pmcs_approach_plane_scenes" },
    { 0x4F8F6236, "pmf" },
    { 0xE8E903AF, "pmf_jumping" },
    { 0x218C5AD7, "pmmove" },
    { 0xA5A5AFE7, "pmo" },
    { 0x3DAF998B, "pms" },
    { 0x88E6268F, "pmsao" },
    { 0x49D6B428, "pmstop" },
    { 0xA3D33273, "pmstrt" },
    { 0x199D729C, "pne" },
    { 0xCA89F4A2, "pneumatic_tube" },
    { 0x4779344F, "pnode" },
    { 0x121B9582, "pobws" },
    { 0xCA64C0FE, "pockets" },
    { 0xD0A56672, "pod" },
    { 0x2CD9B38F, "pod1" },
    { 0x863DBF5F, "pod1_complete" },
    { 0x6D45363B, "pod1_enemies_cleared" },
    { 0x49D0BCB0, "pod1_fx" },
    { 0xB716E0F7, "pod1_mortarteam1" },
    { 0x450F71BC, "pod1_mortarteam2" },
    { 0x978A3E84, "pod1_patrollers" },
    { 0xBAD24454, "pod2" },
    { 0x462434B6, "pod3_stuff" },
    { 0xBE7EA63A, "pod_1" },
    { 0x987C2BD1, "pod_2" },
    { 0x7279B168, "pod_3" },
    { 0xBAA79083, "pod_index" },
    { 0x78859906, "pod_key" },
    { 0x918873FB, "pod_num" },
    { 0xD13B8F3D, "podium" },
    { 0x4AF4CCFC, "podiums" },
    { 0x617358FD, "pods" },
    { 0x84A071A0, "pof" },
    { 0x7C21C319, "poffsettime" },
    { 0xBEC59DC7, "poi" },
    { 0xD19DF22C, "poi1" },
    { 0x43A56167, "poi2" },
    { 0x735ECEF0, "poi_active" },
    { 0x7E375838, "poi_addobjective" },
    { 0xE3E42C49, "poi_ai_attempttakeover" },
    { 0x3B9FB200, "poi_ai_takeoverclearwatch" },
    { 0x492D399D, "poi_array" },
    { 0x3A3EE781, "poi_arrival" },
    { 0xEC4F110C, "poi_attempt_done" },
    { 0x45467BFD, "poi_capture_radius" },
    { 0xE08A2887, "poi_captured_" },
    { 0x8B1E1DE5, "poi_captured_allies" },
    { 0xDE794144, "poi_captured_axis" },
    { 0xB590B765, "poi_capturewatch" },
    { 0xF236B331, "poi_contested" },
    { 0x9632CC04, "poi_damagepulse" },
    { 0x906228A5, "poi_deathwatch" },
    { 0x8E81FC60, "poi_deleted_" },
    { 0x07855678, "poi_deps" },
    { 0xE6C713AE, "poi_dist" },
    { 0x10D9233F, "poi_dominationwatch" },
    { 0x62445C26, "poi_end_func" },
    { 0x8BDC6149, "poi_ent" },
    { 0x101106FB, "poi_expire" },
    { 0x0A177BD5, "poi_ideal" },
    { 0xADFBFEDA, "poi_inc" },
    { 0x85F48BD6, "poi_list" },
    { 0x834A593F, "poi_locations_equal" },
    { 0x5A8AF186, "poi_max_distance" },
    { 0x7F07A67F, "poi_name" },
    { 0xBCE5D2E1, "poi_next" },
    { 0xFB8B0C62, "poi_nolonger_contested" },
    { 0x6057F752, "poi_override" },
    { 0xA7935584, "poi_populate" },
    { 0x28E5B572, "poi_positioning_func" },
    { 0x740FBFAC, "poi_radius" },
    { 0xD59A39E5, "poi_ref" },
    { 0xD538A7F4, "poi_refs" },
    { 0x42F39B24, "poi_setobjectivenumber" },
    { 0x58C72282, "poi_spot" },
    { 0x0A88D35E, "poi_squad_presence_dist_sq" },
    { 0xBBF87C63, "poi_start_func" },
    { 0xBB4F2DD8, "poi_state_changed" },
    { 0x41CF5598, "poi_status" },
    { 0x53943F75, "poi_status_ally" },
    { 0x4B3BC7C1, "poi_status_enemy" },
    { 0x09A36A18, "poi_status_neutral" },
    { 0x8A7DA57D, "poi_team" },
    { 0x60260D3A, "poi_think_time" },
    { 0x8FE0908D, "poi_types" },
    { 0x482BB81F, "poi_watch" },
    { 0x169B6590, "poi_weight_belongs_to_enemy" },
    { 0x0F60F23F, "poi_weight_dist_to_player_base" },
    { 0x620ED8C0, "poi_weight_dist_to_squad" },
    { 0xC6E1A0D3, "poi_weight_enemies_present" },
    { 0xFB7B49FA, "poi_weight_objective" },
    { 0x3469A770, "poi_weight_vacancy" },
    { 0x78CC42D0, "poicaps" },
    { 0x19405D55, "poicaptured" },
    { 0x306F4B55, "poinames" },
    { 0xDD89F865, "point" },
    { 0x9F07E606, "point1" },
    { 0x79056B9D, "point2" },
    { 0x7F22105D, "point2scale" },
    { 0x5302F134, "point3" },
    { 0x08A9E3D8, "point3d" },
    { 0xF2B0B396, "point3d_distance" },
    { 0x8BA32BA4, "point3d_distance_squared" },
    { 0x03F149FF, "point3d_translate" },
    { 0x2D0076CB, "point4" },
    { 0x06FDFC62, "point5" },
    { 0xE0FB81F9, "point6" },
    { 0x167FEE5A, "point_2d" },
    { 0x9263F9D8, "point_abs" },
    { 0x047431CE, "point_added" },
    { 0xFBADE8F5, "point_at_triggers" },
    { 0xD4CAC1ED, "point_average" },
    { 0xF5D7BAC0, "point_class" },
    { 0xA61759F8, "point_dist" },
    { 0x272E7683, "point_doubler_on_hud" },
    { 0x85DE6A57, "point_end" },
    { 0xB0D6FCA1, "point_in_goal" },
    { 0x664E5BAC, "point_index" },
    { 0xB0E5980F, "point_intersect" },
    { 0xE7F3A9EC, "point_is_in_danger_area" },
    { 0x5AAEACF3, "point_is_in_front_of_me" },
    { 0xD22AFBD6, "point_line" },
    { 0x5CE4B9BE, "point_list_s" },
    { 0x4949168A, "point_loc" },
    { 0xB34254D1, "point_name" },
    { 0x5BCACAF8, "point_of_interest" },
    { 0xDB624A94, "point_removed" },
    { 0x112580CE, "point_score" },
    { 0x95D1E79E, "point_split_keep_percent" },
    { 0x8A40F870, "point_split_receiver" },
    { 0x2DFC4C3C, "point_start" },
    { 0x6CFB0313, "point_struct" },
    { 0x526E0AC3, "point_team" },
    { 0x13263D40, "point_type" },
    { 0xBF7ED9B6, "pointa" },
    { 0x53F3C7C0, "pointabovenavmesh" },
    { 0x76D64225, "pointangles" },
    { 0x39BBA06C, "pointarray" },
    { 0x997C5F4D, "pointb" },
    { 0x9CA96F54, "pointbarinc" },
    { 0x0C1FB870, "pointdirection" },
    { 0x561E1B52, "pointed" },
    { 0x35C506DC, "pointend" },
    { 0xA5DB94CF, "pointents" },
    { 0x024AB6B4, "pointer" },
    { 0x0C3B286D, "pointer_vignette" },
    { 0x208F7EA7, "pointers" },
    { 0x3C11C13C, "pointforward" },
    { 0xD54BD5EF, "pointidle" },
    { 0x93CEB617, "pointindex" },
    { 0x28F5B33D, "pointinfov" },
    { 0x7BA435C3, "pointing" },
    { 0xD6B697B9, "pointisinairstrikearea" },
    { 0x043F8DB1, "pointisinartilleryarea" },
    { 0xE263F412, "pointisindangerarea" },
    { 0xC73F16FE, "pointless" },
    { 0x6AB55AFD, "pointlist" },
    { 0x3985988F, "pointonnavvolume" },
    { 0xC8B79B9C, "pointonsegmentnearesttopoint" },
    { 0x2F11CB63, "pointontrack" },
    { 0x477B5F30, "pointpulse" },
    { 0x907380ED, "pointpulsecount" },
    { 0x603A15A4, "pointpulseindex" },
    { 0xD3A18B74, "points" },
    { 0xA0DA0E55, "points1" },
    { 0xC6DC88BE, "points2" },
    { 0xECDF0327, "points3" },
    { 0xC7730378, "points_a" },
    { 0x04F0D786, "points_array" },
    { 0x397A72B3, "points_b" },
    { 0x1377F84A, "points_c" },
    { 0x2B55C4A2, "points_current" },
    { 0x631777D7, "points_per_second" },
    { 0x65EB0ACB, "points_to_drain" },
    { 0x3D9CD992, "pointsadded" },
    { 0x24CBB6A3, "pointsarray" },
    { 0xA7A2C98E, "pointsb" },
    { 0xCDA543F7, "pointsc" },
    { 0x9CE1C39C, "pointsforsurvivalbonus" },
    { 0xA123E59B, "pointspermeleekill" },
    { 0xE28D4999, "pointsperprimarygrenadekill" },
    { 0x4EC32629, "pointsperprimarykill" },
    { 0xEAD04DC5, "pointspersecondarykill" },
    { 0x45C93499, "pointsperweaponkill" },
    { 0x0FF6A0B0, "pointstosteal" },
    { 0x246BF1CB, "pointstowin" },
    { 0xE190B1F2, "pointstruct" },
    { 0x83DB337D, "pointstructs" },
    { 0xE5459F21, "poinum" },
    { 0x23232ED0, "poiobjectivenum" },
    { 0x0009B737, "poioptions" },
    { 0x0DA9B441, "poiradius" },
    { 0x9D044CBE, "pois" },
    { 0xD45761B7, "poiscore" },
    { 0xFE59C47E, "poiscorecomparefunc" },
    { 0x47C32879, "poison" },
    { 0x04BB8616, "poison_max_blur" },
    { 0x22C35BB8, "poison_min_blur" },
    { 0x2B44DB36, "poisondamage" },
    { 0x316FAB70, "poisondamagehardcore" },
    { 0xB32C49B5, "poisonduration" },
    { 0x2953F277, "poisonfxduration" },
    { 0x931EE179, "poithink" },
    { 0x1BEE4882, "poke" },
    { 0xC864028B, "pokee" },
    { 0xDA671B73, "poking" },
    { 0x00B939BA, "pol" },
    { 0xA963A5E4, "pol_distance" },
    { 0x3CE70D56, "polanski" },
    { 0xAC7C57F3, "pole" },
    { 0xF4945290, "pole1" },
    { 0x819DE1FC, "pole_falls" },
    { 0x577E4B5F, "pole_fx_audio" },
    { 0x29BB7A5C, "pole_fx_audio_init" },
    { 0x71F30F0D, "pole_mover" },
    { 0x1907AD34, "pole_sparks" },
    { 0x1FBF3BDF, "pole_sparks_logic" },
    { 0x93F352ED, "pole_struct" },
    { 0xC137E1A2, "poles" },
    { 0xE32979BF, "police" },
    { 0xC8F13F30, "police_car" },
    { 0x09F09989, "police_car1" },
    { 0x2FF313F2, "police_car2" },
    { 0xEFE27C8F, "police_car_13" },
    { 0x28628587, "police_car_2" },
    { 0x02600B1E, "police_car_3" },
    { 0x4453A711, "police_car_4" },
    { 0x1E512CA8, "police_car_5" },
    { 0x37D43257, "police_car_5_death" },
    { 0x2770ECC3, "police_car_5_driver_damage" },
    { 0xA272FD00, "police_car_5_enable_nodes" },
    { 0x66F05404, "police_car_5_kill_driver" },
    { 0x79E506CE, "police_car_5_nodes" },
    { 0x3617B5C5, "police_car_add_occupants" },
    { 0x043A0593, "police_car_audio" },
    { 0x17E73928, "police_car_cheap" },
    { 0x3AF88FDA, "police_car_flip" },
    { 0xEFB0A233, "police_car_guys" },
    { 0xD694289B, "police_cars" },
    { 0x12688763, "police_cars2" },
    { 0x3B40BE57, "police_cars_noteworthy" },
    { 0xCD7EA961, "police_chatter" },
    { 0x104A0DFD, "police_motorcycle" },
    { 0x3A4B0ACE, "police_names" },
    { 0x60A04308, "police_sirens" },
    { 0xE31183F6, "police_spotlight" },
    { 0x21D69C35, "policecar_lights" },
    { 0xDB5B09F3, "policy" },
    { 0x65887FCA, "polish" },
    { 0xE004C327, "polissia" },
    { 0x086F5724, "politics" },
    { 0x56660A42, "poll" },
    { 0x5318332D, "pollallowedstancesthread" },
    { 0x4A7499AE, "polling" },
    { 0x7D8A1D8D, "polls" },
    { 0x30638FD9, "polo" },
    { 0x922FB27C, "polonsky" },
    { 0x73116846, "polonsky_finds_tunnel" },
    { 0x02E58E3D, "polonsky_goal_pos" },
    { 0x0AFE6FD7, "polonsky_point" },
    { 0x7B169983, "polonsky_prone" },
    { 0xAF1BD700, "polonsky_saved" },
    { 0x7C09259E, "polonsky_supplies" },
    { 0xD731DFC6, "polys" },
    { 0xD9D40337, "ponces" },
    { 0xB6E47B7C, "pond" },
    { 0x5A69D957, "pond_abort" },
    { 0x9F72AB2A, "pond_betterview" },
    { 0x000B97CA, "pond_card_game" },
    { 0xDC6DB519, "pond_create_body_pile" },
    { 0xC8239AD0, "pond_create_body_piles" },
    { 0x4B473884, "pond_create_drone" },
    { 0xA93DE268, "pond_dump_2nd" },
    { 0x67B518E4, "pond_dump_bodies" },
    { 0x76A5D6BF, "pond_dump_bodies_abort" },
    { 0x71EE5CEF, "pond_dump_bodies_abort2" },
    { 0x2F66ED8B, "pond_dump_bodies_abort_thrower" },
    { 0x15E54013, "pond_dump_bodies_abort_thrower2" },
    { 0xB800F9B2, "pond_dump_bodies_check_abort" },
    { 0x364352DC, "pond_dump_createbody" },
    { 0x73897176, "pond_dump_createbody2" },
    { 0x45C0AB22, "pond_enemies_dead" },
    { 0x9660B5CA, "pond_handle_backup" },
    { 0x3E89918E, "pond_handle_backup_wait" },
    { 0x6AB58E71, "pond_handle_behavior_change" },
    { 0xB2F8F937, "pond_handle_clear" },
    { 0x45CB750B, "pond_handle_kills" },
    { 0x517C4FB7, "pond_inposition" },
    { 0x995B5097, "pond_inposition_takeshot" },
    { 0xDE3F6814, "pond_kill_patrol" },
    { 0x10305EEB, "pond_kill_thrower" },
    { 0xE11B9D9C, "pond_main" },
    { 0x8BDCDCE7, "pond_moveup" },
    { 0x82D4192D, "pond_patrol" },
    { 0x58BA810A, "pond_patrol_dead" },
    { 0xCF642DCA, "pond_price_hack" },
    { 0x5B65D2EA, "pond_sneakup" },
    { 0x3599A6D8, "pond_thrower" },
    { 0x758D8535, "pond_thrower_dead" },
    { 0xEDCC32E1, "pontoon_status" },
    { 0x5A693461, "pontoons_up" },
    { 0x2BA208B5, "poof" },
    { 0x47932A3F, "pool" },
    { 0x0021C8D8, "pool_active" },
    { 0xB4F105E5, "pool_dog_think" },
    { 0xEA7A4557, "pool_guy1_death" },
    { 0x2A04B848, "pool_guy2_death" },
    { 0x03994AAF, "pool_have_body" },
    { 0x5B67ECA2, "pool_heli" },
    { 0xA853D269, "pool_of_goo" },
    { 0x16EB9A5D, "pool_size" },
    { 0x1EB4FED7, "pool_sound" },
    { 0xA60BDF44, "pooled" },
    { 0x38647ED8, "pooled_buildable_place_think" },
    { 0x1A849F26, "pooledbuildable_has_piece" },
    { 0xEC30CD44, "pooledbuildable_stub_for_piece" },
    { 0x2B4CF905, "pooledbuildablestub_update_prompt" },
    { 0x76FDAECD, "pooledbuildabletrigger_update_prompt" },
    { 0x00019232, "poolname" },
    { 0x3224EF46, "pools" },
    { 0x3FC4BA73, "poop" },
    { 0xF3BFC5A1, "poor" },
    { 0xDAA959B6, "poor_friend_setup" },
    { 0xA733BF2C, "poorly" },
    { 0xC8D6F6A6, "pop" },
    { 0x541174C9, "pop_down" },
    { 0x50C2BCDB, "pop_foliage_trigger" },
    { 0x20B382CA, "pop_front" },
    { 0x829A5A13, "pop_goes_the_weasel_achieved" },
    { 0xFB7BEA6C, "pop_interference_trigger" },
    { 0xA2ACF20D, "pop_off_head" },
    { 0x98E6F8B6, "pop_threshold" },
    { 0xD1118042, "pop_time" },
    { 0xE0AEB320, "pop_time_array" },
    { 0x43AC7C9D, "pop_trig_on_leave" },
    { 0x6F3E4416, "pop_up" },
    { 0xEE840693, "pop_up_and_hide_speed" },
    { 0x58E981C8, "pop_up_and_wait" },
    { 0xA9A67699, "pop_vec" },
    { 0xFF00399C, "popcorn" },
    { 0x5C4C6629, "poped" },
    { 0x3795699A, "popevent" },
    { 0x59F97BDF, "popheadnotify" },
    { 0x7C7E083A, "poping" },
    { 0xC2EDEA3F, "popmenu" },
    { 0xE78C18F3, "popnrun" },
    { 0xCEA8D96E, "poppable" },
    { 0x09D49855, "popped" },
    { 0xD8C812AE, "popping" },
    { 0x4B795AD9, "pops" },
    { 0x797FD63C, "popular" },
    { 0x50B8B7C3, "populate" },
    { 0xF2A21F0F, "populate_and_fire_lci_rockets" },
    { 0xA7B2BC20, "populate_bots" },
    { 0x5A89B9E2, "populate_club" },
    { 0x16DDC933, "populate_dead_bodies" },
    { 0x9771DDF0, "populate_dying_bodies" },
    { 0xF1E76883, "populate_extra_trucks" },
    { 0x6D72FA45, "populate_huey" },
    { 0xE1597261, "populate_katyusha_crews" },
    { 0x013F151C, "populate_map" },
    { 0xBB52D7A6, "populate_pbr" },
    { 0x04158A94, "populate_river_boats" },
    { 0xAEC118FD, "populated" },
    { 0xDC920332, "populates" },
    { 0xD762FB1A, "populatescriptdebugmenu" },
    { 0x5F18CC46, "populating" },
    { 0xCEA19D70, "population" },
    { 0x204FA914, "population_count" },
    { 0x0D98F86D, "popultate" },
    { 0x01FB43AD, "popup" },
    { 0x8117B00B, "popup_box" },
    { 0x49AF2E32, "popupanim" },
    { 0xB9ABC0AC, "popups" },
    { 0x4296BB00, "popups_shared" },
    { 0x2E0473EF, "popupsfromconsole" },
    { 0xCD2235D8, "popvec" },
    { 0xB2C0874C, "por0" },
    { 0xD8C301B5, "por1" },
    { 0xFEC57C1E, "por2" },
    { 0x24C7F687, "por3" },
    { 0x1AB69DA8, "por4" },
    { 0x32C2F24D, "porch" },
    { 0x0FECD0A7, "porch_house_move_near_barrels" },
    { 0x9504D8EB, "porchhouse" },
    { 0x9CEB3255, "porigin" },
    { 0x9A180368, "port" },
    { 0x4E1163DD, "port_light" },
    { 0x3E9C2110, "portable" },
    { 0x2BA4D718, "portable_mg_behavior" },
    { 0xA4E73E3D, "portable_mg_gun_tag" },
    { 0x6281335A, "portable_mg_spot" },
    { 0xD927C020, "portable_mgguy" },
    { 0xE714BCD9, "portable_radar" },
    { 0x6D8B4537, "portablemg42guy" },
    { 0x6A806C6C, "portablemg42waiter" },
    { 0x6C53360F, "portal" },
    { 0x6FB040BF, "portal_bottom" },
    { 0xD3768DE7, "portal_count" },
    { 0x9DAC0CF5, "portal_current" },
    { 0x58909F7F, "portal_distance" },
    { 0x80A2E709, "portal_effect" },
    { 0x75542D81, "portal_end" },
    { 0x36B5A9B8, "portal_enter" },
    { 0x71DABFCB, "portal_entered" },
    { 0xEFE21572, "portal_exit" },
    { 0x17A97830, "portal_fx" },
    { 0x6E6B55CA, "portal_fx_location" },
    { 0x0ED6A8D6, "portal_last" },
    { 0xD0E40E84, "portal_mid" },
    { 0x64815562, "portal_order" },
    { 0x9CAFB005, "portal_pack" },
    { 0xB4C2CC90, "portal_player_watcher" },
    { 0x7C934A6C, "portal_pos" },
    { 0xCAE0233D, "portal_power" },
    { 0x8E23730A, "portal_start" },
    { 0x3B9947D9, "portal_stopped" },
    { 0x86759536, "portal_think" },
    { 0x3F326C2B, "portal_top" },
    { 0x5AC546D0, "portal_trig" },
    { 0x6D510D3F, "portal_trig_enter" },
    { 0x3A335627, "portal_trig_exit" },
    { 0x85B55C1B, "portal_use" },
    { 0x6F3A9B05, "portal_used" },
    { 0x427A3319, "portal_zone_trig" },
    { 0x45B9E259, "portalfx" },
    { 0x9CC6D4D6, "portals" },
    { 0xE88C9D7B, "ported" },
    { 0xBAD94930, "porting" },
    { 0x6A12CD3A, "portion" },
    { 0xF05CD8B5, "portions" },
    { 0x515E0A61, "portiz" },
    { 0xD83EFCA0, "portrait_egg_vox" },
    { 0x0DEA8633, "portraits" },
    { 0xA2D47C3D, "pos" },
    { 0x0B55730E, "pos1" },
    { 0x678514D5, "pos1_dist2" },
    { 0xE552F8A5, "pos2" },
    { 0xCF097C6A, "pos2_dist2" },
    { 0xBF507E3C, "pos3" },
    { 0x994E03D3, "pos4" },
    { 0xF4960AEB, "pos_1_sec" },
    { 0xF7C40FA4, "pos_2_sec" },
    { 0xA2F4A4C9, "pos_3_sec" },
    { 0x2AEF38D0, "pos_angles" },
    { 0x3AEC1D37, "pos_array" },
    { 0xE2B3BF6F, "pos_bl_best" },
    { 0xD6B67D31, "pos_br_best" },
    { 0x307A8538, "pos_brooks" },
    { 0x7EE19FD4, "pos_charge" },
    { 0x65B92320, "pos_dist" },
    { 0xF72D2267, "pos_east" },
    { 0x6D836B08, "pos_ext_l" },
    { 0x81A61CC6, "pos_ext_r" },
    { 0xD2B78BFD, "pos_harris" },
    { 0xD9028F3D, "pos_idx" },
    { 0x7C8774A6, "pos_int_l" },
    { 0x6864C2E8, "pos_int_r" },
    { 0x55B91D83, "pos_left" },
    { 0xA7E8DB69, "pos_name" },
    { 0x92D42FD8, "pos_now" },
    { 0xD5357710, "pos_num" },
    { 0x0F78FDB3, "pos_num_hidden" },
    { 0x0DE74009, "pos_offset" },
    { 0x0F057E3A, "pos_on_navmesh" },
    { 0x9AF105D0, "pos_or_neg" },
    { 0xBA227B7F, "pos_player" },
    { 0x5B9F1017, "pos_ref" },
    { 0xB26BED76, "pos_right" },
    { 0xBD1EE325, "pos_streamer" },
    { 0x9D6AA58B, "pos_struct" },
    { 0xFF40A9AD, "pos_vector" },
    { 0xB8B6CCC0, "pos_victim" },
    { 0x4D90C41C, "pos_weaver" },
    { 0xA8E9FBA8, "pos_x" },
    { 0xE66D7729, "pos_xy" },
    { 0xCEEC7611, "pos_y" },
    { 0x9285489A, "pose" },
    { 0x650A6678, "pose_array" },
    { 0x6A16ADEA, "posed" },
    { 0x481ED206, "poseindex" },
    { 0x1B149BC6, "posekeys" },
    { 0x6DA52224, "posent" },
    { 0x4F6BED82, "posenum" },
    { 0x58052E0B, "poseoffset" },
    { 0x55F3FC2C, "poser" },
    { 0x777B333E, "poser_guys_group_a_scene" },
    { 0x7A2E0986, "poser_guys_group_a_start" },
    { 0x11E56119, "poser_guys_group_b_scene" },
    { 0x8470361D, "poser_guys_group_b_start" },
    { 0x7BF67695, "poses" },
    { 0x98EF5C90, "posheight" },
    { 0xE462DE63, "poshistory" },
    { 0xC1D21521, "posibility" },
    { 0x76EEC419, "posible" },
    { 0xC7B6E8E4, "position" },
    { 0x8F6A0D05, "position1" },
    { 0xB56C876E, "position2" },
    { 0xDB6F01D7, "position3" },
    { 0xD15DA8F8, "position4" },
    { 0xF7602361, "position5" },
    { 0x40D85652, "position_before_fall" },
    { 0x39363F1A, "position_ent" },
    { 0xB90F3BE8, "position_ent_name" },
    { 0x44F69028, "position_foward" },
    { 0x81D70703, "position_info" },
    { 0xE80986A6, "position_name" },
    { 0x3DF66BA2, "position_offset" },
    { 0x5A904D19, "position_one" },
    { 0xF764203B, "position_override" },
    { 0xC68EBEEF, "position_query_drop_location_count" },
    { 0x70F41F0C, "position_string" },
    { 0xD713A364, "position_struct" },
    { 0xFCE51626, "position_struct_name" },
    { 0xC44950D9, "position_to_play" },
    { 0xC3FB313F, "position_valid" },
    { 0x6D2BEDF3, "positional" },
    { 0xE83D2B05, "positionandrotation" },
    { 0x6C989D92, "positionandrotationstruct" },
    { 0xFF78760E, "positiondelta" },
    { 0x7053EC47, "positioned" },
    { 0x53515354, "positionhistory" },
    { 0xD6ABF528, "positionhistoryindex" },
    { 0xB8F6C038, "positionindex" },
    { 0x1A39B6C4, "positioning" },
    { 0x8867314E, "positionisbl" },
    { 0x141CD900, "positionisbr" },
    { 0x859E35CC, "positionisupgraded" },
    { 0x2C77F035, "positionoffset" },
    { 0xBB928A71, "positiononnavmesh" },
    { 0xDD3A131F, "positiononwall" },
    { 0x10428FF5, "positionptm" },
    { 0x629AB2B1, "positionquery_debugscores" },
    { 0xDCCCE89A, "positionquery_filter_directness" },
    { 0x9D329E33, "positionquery_filter_distancetogoal" },
    { 0x3E9D24F5, "positionquery_filter_distawayfromtarget" },
    { 0xD6E12A11, "positionquery_filter_engagementdist" },
    { 0xC807F3AC, "positionquery_filter_engagementheight" },
    { 0x282D20F5, "positionquery_filter_inclaimedlocation" },
    { 0xDC90001D, "positionquery_filter_outofgoalanchor" },
    { 0x45F024ED, "positionquery_filter_random" },
    { 0x088B06E3, "positionquery_filter_sight" },
    { 0xEE78923E, "positionquery_pointarray" },
    { 0x272864E7, "positionquery_postprocess_sortscore" },
    { 0x54F69DE9, "positionquery_source_navigation" },
    { 0x5C0D9C17, "positions" },
    { 0x29357447, "positionsecure" },
    { 0x3DA580AC, "positiontag" },
    { 0x51B4E0FD, "positionthreshold" },
    { 0x4858D570, "positiontoswitchto" },
    { 0x0BA336B7, "positionwouldtelefrag" },
    { 0xA33716B0, "positive" },
    { 0x73896FC3, "positive_kill" },
    { 0xC7C5CD9C, "positive_lines" },
    { 0xFBEAF48F, "positive_value_func" },
    { 0xBF59C615, "positively" },
    { 0xF286671B, "positives" },
    { 0xE19EF2F1, "positon" },
    { 0x459431A3, "posityion" },
    { 0xEACE6298, "posoverrideentity" },
    { 0x0E164763, "posoverrideorigin" },
    { 0x2A64DC7B, "possess" },
    { 0x3E7BE7F0, "possessed" },
    { 0x656BDB87, "possibile" },
    { 0x7B8AA54E, "possibilities" },
    { 0x18C9FFDE, "possibility" },
    { 0x5153F4AC, "possible" },
    { 0x3F0E645A, "possible_alt_weapons" },
    { 0x3B3622E7, "possible_anims" },
    { 0x235E0FB7, "possible_bike_tag_array" },
    { 0x2126CCA8, "possible_fov" },
    { 0xBCC53C68, "possible_lines" },
    { 0x50F11A0A, "possible_nodes" },
    { 0x6B06F1E4, "possible_player" },
    { 0x6A64DED5, "possible_slowgun_targets" },
    { 0x9CA01058, "possible_spawners" },
    { 0x4304D3EF, "possible_tag_array" },
    { 0x77C61287, "possible_tag_array_1" },
    { 0x05BEA34C, "possible_tag_array_2" },
    { 0xD402D606, "possible_tanks" },
    { 0xE0176F5F, "possible_targets" },
    { 0xD9415C95, "possible_trig" },
    { 0x8504F5E4, "possible_trigs" },
    { 0x97F5F720, "possible_turrets" },
    { 0x402C86E4, "possiblegibrefs" },
    { 0xAD67B5D9, "possiblehitlocations" },
    { 0xAD84AB76, "possiblejukes" },
    { 0xCEFABC1B, "possiblemelees" },
    { 0x57217880, "possiblenode" },
    { 0x08A75F2F, "possiblepaintypes" },
    { 0x0B36C77D, "possiblepieces" },
    { 0x45A88DAF, "possibles" },
    { 0x5AB272A3, "possiblespawners" },
    { 0x88AA4D8E, "possibletargets" },
    { 0xC855723E, "possiblevalues" },
    { 0xEFF5A9AD, "possiblity" },
    { 0xE95DDE50, "possibly" },
    { 0x18AF6993, "post" },
    { 0xA668DB48, "post_all_players_connected" },
    { 0x02E492DB, "post_ambush_backup_retreat" },
    { 0xC5B91EED, "post_ambush_backup_retreat_notify" },
    { 0x26CB9A37, "post_ambush_panel_fall" },
    { 0x2D38B3A5, "post_ambush_squad" },
    { 0xC0478DE6, "post_anderson_reveal_fires" },
    { 0xE1D50347, "post_apc_fake_combat" },
    { 0x38117479, "post_assasination_open_door" },
    { 0xF432BEF5, "post_assasination_player_response" },
    { 0xE697CB39, "post_basejump" },
    { 0x31259938, "post_bosses_trigger" },
    { 0x0066B4E9, "post_breach" },
    { 0x480CEB5C, "post_bridge_guys" },
    { 0xC8261D99, "post_car_movie" },
    { 0x122897E8, "post_carpenter_callback" },
    { 0xB8DDC26E, "post_carry_backtrack_block" },
    { 0xB0E58407, "post_delay" },
    { 0xA4EB08F7, "post_door_bash" },
    { 0xBF9AD7FB, "post_drown_lookat_player" },
    { 0x7E03297B, "post_effects_disabled" },
    { 0x1939AC04, "post_entity_creation_function" },
    { 0x0AC8A647, "post_fight_stinger" },
    { 0xBDC5C971, "post_first_init" },
    { 0xBAF6CFD7, "post_fix" },
    { 0x58509FBD, "post_flashbang_rush_player" },
    { 0xCC0ADE28, "post_game" },
    { 0xCB968E30, "post_gametype_main" },
    { 0xEF7E3A1E, "post_hit_health" },
    { 0x4C8D44CC, "post_hit_health_percent" },
    { 0x0DE827FD, "post_init_func" },
    { 0xBA9EC055, "post_init_gametype" },
    { 0x8C6308AA, "post_init_zombie_spawn_func" },
    { 0x48FB166E, "post_intro_blocker_trigger" },
    { 0x3D8E0032, "post_intro_position" },
    { 0x90732D7D, "post_jump_snapshot" },
    { 0xE9E99781, "post_knife_savegame" },
    { 0xCE657D75, "post_lights" },
    { 0xE2C5AB89, "post_main" },
    { 0xA142EA08, "post_mainframe" },
    { 0xFAF37C08, "post_match_snapshot" },
    { 0xDE3B188D, "post_match_snapshot_watcher" },
    { 0x9FA77949, "post_migration_become_vulnerable" },
    { 0x3250E5B2, "post_migration_invulnerability" },
    { 0x1B133980, "post_mortar_ambush" },
    { 0xC7C1B2EE, "post_mortar_fx" },
    { 0x8F1153C0, "post_mortars" },
    { 0x71EE8E38, "post_move_delta_array" },
    { 0xD5DD5AF3, "post_pacing_positions" },
    { 0xA40F8B03, "post_pain_func" },
    { 0x919D9C0F, "post_pipes_elevated_soct_trigger" },
    { 0xB0D0185A, "post_pipes_soct_trigger" },
    { 0x7C598118, "post_rappel_backtrack_check" },
    { 0x902FD045, "post_rappel_rope" },
    { 0x6E092453, "post_round_final_killcam" },
    { 0xFDF4C650, "post_round_side_bet" },
    { 0x42121A74, "post_script_func" },
    { 0xC90119FA, "post_security_room" },
    { 0x46417FD3, "post_selection_wait_duration" },
    { 0x20FFDA77, "post_slide_move" },
    { 0xC1E5F400, "post_sniper_mortars" },
    { 0xCCA8F786, "post_spiderhole_floodspawner" },
    { 0xB1F41C46, "post_spiderhole_think" },
    { 0x13B177C2, "post_tank_retreat" },
    { 0x86C23330, "post_teleport_func" },
    { 0x1DA16B91, "post_trap_chain_1" },
    { 0x43A3E5FA, "post_trap_chain_2" },
    { 0x69A66063, "post_trap_chain_3" },
    { 0x7251B7F8, "post_traverse" },
    { 0x0484EAB2, "post_traverse_old" },
    { 0xD5030174, "postdeathdelay" },
    { 0x295BF11C, "postdelay" },
    { 0x84A093B7, "postdone" },
    { 0xD7A7E048, "posted" },
    { 0xEBBBC2CF, "postenterpos" },
    { 0x2D98EF3C, "postfix" },
    { 0xF661C401, "postfunc" },
    { 0xE9C7ED9F, "postfunction" },
    { 0xBDDE9225, "postfx" },
    { 0xFF7F3757, "postfx_igc" },
    { 0xB5E0BD3D, "postfx_igc_on" },
    { 0x64A4D1C0, "postfx_igc_short" },
    { 0xAD252487, "postfx_igc_zombies" },
    { 0x1D1A34EF, "postfx_shared" },
    { 0xE8EADD9B, "postfxbundelsinited" },
    { 0xCDB4CA31, "postgame" },
    { 0xB04BACB6, "postgamecontracts" },
    { 0xEAF615A8, "postgamemilestones" },
    { 0xAE0FD448, "postgamepromotion" },
    { 0x5F0A17A4, "posthackfunction" },
    { 0x1721877A, "postiion" },
    { 0x86D6C922, "postinit_func" },
    { 0x83E96E7B, "postinitialized" },
    { 0xD925C413, "postion" },
    { 0x13F80967, "postload" },
    { 0xE65B086E, "postload_function" },
    { 0x5E04A4D5, "postloadout" },
    { 0xBA0CAC68, "postmessage" },
    { 0x4DAEDB72, "postmovedelta" },
    { 0x616C951D, "postmovedeltaarray" },
    { 0x392BAE89, "postpainfunc" },
    { 0xD477559F, "postpatch" },
    { 0xAD2655C8, "postprocessteamscores" },
    { 0x8F4E9ECE, "postroundevents" },
    { 0xACE407C0, "postroundfinalkillcam" },
    { 0x8EF7B199, "postroundsidebet" },
    { 0xFD96027A, "postroundtime" },
    { 0x363B3AC2, "posts" },
    { 0xC4AEEB58, "postscriptfunc" },
    { 0xC984A501, "postship" },
    { 0x58F79F2B, "postshipstatsfix" },
    { 0xAEEF5CDB, "postshootlaserandglintoff" },
    { 0x6E716287, "postspawncb" },
    { 0xC63EDBEC, "postsquadmessage" },
    { 0xCFC62AE6, "posttraversedeathanim" },
    { 0x274E0E80, "posttutmission" },
    { 0xFE692AE7, "posture" },
    { 0x116C2408, "postwave_wakeup" },
    { 0xAE34AE4D, "postwave_wakeup_start" },
    { 0x30CD0D02, "pot" },
    { 0xEA099A09, "potential" },
    { 0x699E3746, "potential_ai" },
    { 0x61F36349, "potential_crumb_position" },
    { 0x42DDD4BC, "potential_deletes" },
    { 0x3B160657, "potential_doors" },
    { 0x084C6B3E, "potential_sizes" },
    { 0x97820103, "potential_spawners" },
    { 0x041DEB37, "potential_target" },
    { 0x77F41B6E, "potential_targets" },
    { 0xFE01FAA4, "potential_traverse_nodes" },
    { 0xE91017D7, "potential_victims" },
    { 0xD8E1D786, "potentialbestdistance" },
    { 0x9D1E694F, "potentialenemies" },
    { 0x5ABEE0F9, "potentialexploders" },
    { 0xC179AED4, "potentially" },
    { 0x05AD545F, "potentially_visible" },
    { 0xC400223A, "potentiallyvisible" },
    { 0x63007F00, "potentials" },
    { 0xE268EE81, "potentialspot" },
    { 0x99FE996D, "potentialtargets" },
    { 0xDD70E1F8, "potentialthreats" },
    { 0xDFC3728F, "potentialweaponitems" },
    { 0xABBD0D64, "pottentially" },
    { 0xD8F5511A, "potus" },
    { 0x57591E14, "potus_convoy_interior_setup" },
    { 0x0EEACDEE, "potus_cover" },
    { 0x47432305, "potus_death" },
    { 0xB6088ADD, "potus_fail" },
    { 0x865E5E3C, "potus_health_low" },
    { 0xB7F0CD17, "potus_protect_fail_time" },
    { 0xE399E665, "potus_protect_fail_time_frame" },
    { 0x36200BB9, "pounced" },
    { 0x3EE1E7E9, "pound" },
    { 0x5CC0501F, "pounding" },
    { 0x70416345, "pourfx" },
    { 0xC7559001, "pourfxorg" },
    { 0x9A65712D, "pouring" },
    { 0xE4C81830, "pov" },
    { 0x0ACA9299, "pow" },
    { 0xE9B82B79, "pow2" },
    { 0x600AE584, "pow_amb" },
    { 0x8B07BB3B, "pow_anim" },
    { 0x9E55DEDA, "pow_anims" },
    { 0x1682802B, "pow_art" },
    { 0xDE3D87CC, "pow_bleed" },
    { 0xF5A9B501, "pow_clean_up" },
    { 0xD2FAC923, "pow_compound" },
    { 0x3ECD2C2A, "pow_default_snapshot" },
    { 0xE9BE00D1, "pow_demo" },
    { 0x9B3732E9, "pow_dialog_with_wait" },
    { 0xB944AF94, "pow_door" },
    { 0x8DEE1607, "pow_doors" },
    { 0x7EC9C2F6, "pow_empty_function" },
    { 0x787A729D, "pow_flame_achievement" },
    { 0xE094F19E, "pow_fx" },
    { 0x0702B885, "pow_group" },
    { 0x0B566AF3, "pow_hind_clearing" },
    { 0x7EA5F3A5, "pow_hind_fly" },
    { 0xBEDC29BE, "pow_loop" },
    { 0xF9E305D0, "pow_maddock_strat" },
    { 0x1FD5D576, "pow_meatshield_damage" },
    { 0x1DE8017D, "pow_meatshield_success_fail" },
    { 0x8E4D67FB, "pow_misc_strat" },
    { 0xBBCD00F4, "pow_objectives" },
    { 0x551DE5A7, "pow_objectives_tunnel_breadcrumb" },
    { 0x93309D84, "pow_rocket_achievement" },
    { 0xCFC5961A, "pow_rr_intro_snapshot" },
    { 0x532B2D42, "pow_spawnfuncs" },
    { 0xEE3FDF75, "pow_tunnels" },
    { 0x9D34DD5C, "pow_turn_truck_into_model" },
    { 0xFB985862, "pow_update_objectives" },
    { 0x822A4D2C, "pow_utility" },
    { 0xBE24707C, "pow_vehicle_damage" },
    { 0x7FD23FC0, "power" },
    { 0xD2C78C56, "power_alarm" },
    { 0x29400737, "power_armor_last_took_damage_time" },
    { 0x4C205B4A, "power_armor_took_damage" },
    { 0x679AE70C, "power_audio_2d" },
    { 0x2B6719CD, "power_bar_scaler" },
    { 0x02C3A81C, "power_buzz" },
    { 0x2C47945A, "power_callback" },
    { 0x85F659BD, "power_clangs" },
    { 0x238C013C, "power_consume_timer_think" },
    { 0xDC853F6C, "power_controlled_light" },
    { 0x2304056F, "power_controlled_lights" },
    { 0x1CC9B9F7, "power_controlled_or_turbine" },
    { 0x8C21FDB0, "power_cost" },
    { 0xA9DAF535, "power_cycled" },
    { 0x2A8C0BEA, "power_dist_sq" },
    { 0x7767A5EF, "power_door_ignore_flag_wait" },
    { 0x99ED8C07, "power_down" },
    { 0x7B5970FE, "power_drain_completely" },
    { 0x96405FB1, "power_electric_switch" },
    { 0x10B8A8BF, "power_electric_switch_on" },
    { 0x58FA5951, "power_empty_fn" },
    { 0x21E158C6, "power_ent" },
    { 0x3143EBDD, "power_event_complete" },
    { 0xD576C6C1, "power_event_in_progress" },
    { 0x6250BA8B, "power_event_rumble_and_quake" },
    { 0x166FD5C1, "power_event_rumble_and_quake_player" },
    { 0x1B143833, "power_event_time" },
    { 0xCC569A11, "power_event_vision_set" },
    { 0x9800954F, "power_event_vision_set_lerp" },
    { 0x1FAD067B, "power_event_vision_set_post_event" },
    { 0xFD12BF9D, "power_flag" },
    { 0x42862D23, "power_full_fn" },
    { 0xB2849C8B, "power_gain_event" },
    { 0x393D0E93, "power_gain_event_damage_actor" },
    { 0xF20E7ECB, "power_gain_event_killed_actor" },
    { 0x89E84A38, "power_gain_event_score" },
    { 0x4BEBD1C5, "power_is_hero_ability" },
    { 0x36CA440A, "power_item" },
    { 0xC57C2F45, "power_items" },
    { 0x52670624, "power_lights" },
    { 0xC6F54749, "power_lights_flicker" },
    { 0x9AA7674C, "power_lights_flicker_think" },
    { 0x2222BBA5, "power_lights_think" },
    { 0xB2607075, "power_local_doors_globally" },
    { 0x477F2AB9, "power_loop" },
    { 0x837BA346, "power_loss" },
    { 0xE121567F, "power_loss_event" },
    { 0x4111B469, "power_loss_event_took_damage" },
    { 0xE122760F, "power_node" },
    { 0x48F2CA23, "power_occupied" },
    { 0x5E20D7B6, "power_off" },
    { 0xB5078790, "power_off_callback" },
    { 0x5060BE39, "power_off_done" },
    { 0xB012591F, "power_off_func" },
    { 0xE22A8AA8, "power_on" },
    { 0xAC043BAC, "power_on_all" },
    { 0x53134F12, "power_on_callback" },
    { 0x6C3215A5, "power_on_func" },
    { 0xDBA1E8F1, "power_on_fxanims" },
    { 0x5926794C, "power_on_perk_machines" },
    { 0xE7F5550B, "power_on_spinning_lights" },
    { 0x51C2768C, "power_on_time" },
    { 0x5DEA1EE3, "power_origin_struct" },
    { 0x0D0A62AE, "power_pap_hint" },
    { 0x525E7BBE, "power_plant" },
    { 0x9DD04853, "power_plant_cleared" },
    { 0xAF9E1999, "power_plant_org" },
    { 0x9680F1E7, "power_plant_spawner" },
    { 0x7EBF6C31, "power_pole_fxanim" },
    { 0xB8EB4FC3, "power_pos" },
    { 0x36C5CF21, "power_room_screen" },
    { 0xDF7EFF61, "power_rumble_active" },
    { 0xEBD3B0DB, "power_sources" },
    { 0xFB07F42A, "power_state" },
    { 0xD783F08E, "power_station_dialogue" },
    { 0x2C9E29D9, "power_station_exploit" },
    { 0x3062E5B1, "power_station_zones" },
    { 0x73EA4985, "power_stations_guards" },
    { 0x343F1BFE, "power_stubs" },
    { 0xFF9E6C95, "power_surge_exploder" },
    { 0xEEE07AA0, "power_trigs" },
    { 0x4BE315DB, "power_turned_off" },
    { 0x208F7860, "power_turnedoff" },
    { 0xE36AA7BA, "power_turnedon" },
    { 0xDD820A98, "power_up" },
    { 0xC80DFB5F, "power_up_grab_player" },
    { 0x806BAEC2, "power_up_hud" },
    { 0xF1AA36CD, "power_up_origin" },
    { 0x5ED3AA73, "power_ups" },
    { 0x7FC981D5, "power_visionset_in" },
    { 0xB341A234, "power_visionset_out" },
    { 0x2DD0C8B0, "power_watch" },
    { 0x6F55AE4D, "power_zone" },
    { 0xFFA034CC, "power_zones" },
    { 0x9978656B, "powerbox" },
    { 0xA59D71F5, "powercap_cover_health" },
    { 0x41505D43, "powercap_covered" },
    { 0x88B6008D, "powercap_health" },
    { 0xC6C73658, "powercell_precache" },
    { 0xB13DA1F7, "powercellhud" },
    { 0xE7DD8D08, "powerchange" },
    { 0x2B8E81B8, "powercmd" },
    { 0x472928C6, "powerconsumpted" },
    { 0x9FFED7BB, "powerdoors" },
    { 0xBBC66584, "powerdown" },
    { 0x250E2053, "powered" },
    { 0xA18FE143, "powered_count" },
    { 0x6EDC5DB2, "powered_items" },
    { 0x6510E142, "powered_list" },
    { 0xB825CC09, "powered_on" },
    { 0x100E3BB2, "powered_perk" },
    { 0x6CC46A58, "powerevent" },
    { 0xDD896A31, "powerful" },
    { 0xA4DE0FF3, "powerleft" },
    { 0x9407BFF4, "powerless_look_at_pt" },
    { 0xFCCBE49D, "powerloss" },
    { 0xB4C50E4B, "poweron" },
    { 0x5B243D64, "poweron_audio" },
    { 0xD647DAD9, "poweron_vox" },
    { 0x11642256, "powerplant_cover_dmg" },
    { 0x8DE29F93, "powerplant_cover_dmg_for_removal" },
    { 0x274D193C, "powerplant_covered" },
    { 0xCF9D383E, "powerplant_dmg" },
    { 0xF09990BD, "powerplant_dmg_for_destroy" },
    { 0x06D2CC52, "powerradius" },
    { 0x80A51114, "powerremaining" },
    { 0x09DA23EB, "powers" },
    { 0xF9FB18C4, "powerstation" },
    { 0x13D9FAD7, "powersups" },
    { 0xB4A05E64, "powerswitch" },
    { 0x8E2FD82B, "powerswitch_arm" },
    { 0xA505B7F2, "powerswitch_box" },
    { 0x5602950D, "powerswitch_lever" },
    { 0x993BA41C, "powerswitchbuildable" },
    { 0xB53B9BA3, "powerswitchstate" },
    { 0x7CBED04F, "powertap" },
    { 0x568A1EF0, "powertoadd" },
    { 0x366C6CDB, "powertoremove" },
    { 0x0A6DB0B7, "powerup" },
    { 0xAB83A4DB, "powerup bonfire sale" },
    { 0x3B3C2756, "powerup fire sale" },
    { 0x6E291DA5, "powerup instakill_" },
    { 0x041C2BF1, "powerup points scaled_" },
    { 0x39F3CA14, "powerup_any_team" },
    { 0x9211EE00, "powerup_areas" },
    { 0xF687758D, "powerup_array" },
    { 0x33816B4E, "powerup_blue_monkey" },
    { 0xB0979406, "powerup_bus_range" },
    { 0xAD6C63C9, "powerup_can_player_grab" },
    { 0x1040F0A6, "powerup_change" },
    { 0x52FBF591, "powerup_clientfield_name" },
    { 0x71A3A588, "powerup_cycle" },
    { 0xD727DD2D, "powerup_cycle_action" },
    { 0xC314FDDA, "powerup_cycle_condition" },
    { 0xC45C7EE3, "powerup_delete" },
    { 0xC64F649C, "powerup_delete_delayed" },
    { 0x39F68C51, "powerup_drop" },
    { 0xAFFC3779, "powerup_drop_count" },
    { 0xD2A904C7, "powerup_drop_time" },
    { 0x63E7D728, "powerup_dropped" },
    { 0x09BEA5BC, "powerup_emp" },
    { 0x808CB1A3, "powerup_flashing_stage_one_delta_time" },
    { 0xE6F6889A, "powerup_flashing_stage_one_time" },
    { 0xF3DC1C69, "powerup_flashing_stage_two_delta_time" },
    { 0x6C9DAB34, "powerup_flashing_stage_two_time" },
    { 0xC50B1696, "powerup_for_specific_player" },
    { 0xBF10C912, "powerup_fx_callback" },
    { 0xE7EBEFA5, "powerup_fx_func" },
    { 0x042F72C4, "powerup_grab" },
    { 0x661E1459, "powerup_grab_get_players_override" },
    { 0x25D151C1, "powerup_grabbed" },
    { 0xC5255C2D, "powerup_green_monkey" },
    { 0x2D16EF55, "powerup_hack" },
    { 0x7D653D01, "powerup_hud" },
    { 0x554F4053, "powerup_hud_array" },
    { 0x7E306A35, "powerup_hud_cover" },
    { 0x80200026, "powerup_hud_monitor" },
    { 0x7E14D93C, "powerup_hud_overlay" },
    { 0x255B493A, "powerup_infinite_time" },
    { 0x5213FCB0, "powerup_intro" },
    { 0xC4AD9252, "powerup_intro_vox" },
    { 0x1695340F, "powerup_item" },
    { 0x5AF930AE, "powerup_key_index" },
    { 0xAEB0260E, "powerup_keys" },
    { 0xF02CE287, "powerup_location" },
    { 0x6627E739, "powerup_move" },
    { 0x31658B4C, "powerup_move_dist" },
    { 0x4154AE6F, "powerup_name" },
    { 0x190850DD, "powerup_on" },
    { 0x5FD7FA23, "powerup_only_affects_grabber" },
    { 0x68B2B022, "powerup_override" },
    { 0x4E72D206, "powerup_pickup" },
    { 0x6F4D246B, "powerup_pickup_watcher" },
    { 0xD651126D, "powerup_player" },
    { 0xBEF244E6, "powerup_player_valid" },
    { 0xCC42DB90, "powerup_popup" },
    { 0xF481D194, "powerup_pos" },
    { 0xF45C0393, "powerup_random_count" },
    { 0x9AA553CF, "powerup_range_squared" },
    { 0xC5463BA7, "powerup_red" },
    { 0x499A86BF, "powerup_remove_from_regular_drops" },
    { 0x1A427EDB, "powerup_reset" },
    { 0x8011F55F, "powerup_rotate" },
    { 0xB6D98483, "powerup_round_start" },
    { 0x63897F08, "powerup_score_count" },
    { 0xED72F319, "powerup_set_can_pick_up_in_last_stand" },
    { 0x77440261, "powerup_set_player_specific" },
    { 0xBA625DCE, "powerup_set_prevent_pick_up_if_drinking" },
    { 0x8D73D5E5, "powerup_set_statless_powerup" },
    { 0x5878D499, "powerup_setup" },
    { 0x8A6E02C1, "powerup_show" },
    { 0x9408C924, "powerup_special_drop_override" },
    { 0xCC23CAD5, "powerup_state_callback" },
    { 0xB8EC5AF9, "powerup_struct" },
    { 0x7FC44CCD, "powerup_team" },
    { 0x9DF7D7D1, "powerup_timedout" },
    { 0x590270B3, "powerup_timeout" },
    { 0x60C5A145, "powerup_timer" },
    { 0x325043EA, "powerup_to_grab" },
    { 0x4A7BB0C9, "powerup_var" },
    { 0x1177A4A7, "powerup_vo" },
    { 0x9440D0E7, "powerup_vo_available" },
    { 0x74D493F9, "powerup_widows_wine_timeout" },
    { 0x70FD8269, "powerup_wobble" },
    { 0x7CFB3FCE, "powerup_wobble_fx" },
    { 0xE30B4A61, "powerup_zombie_grab" },
    { 0xD67981E1, "powerup_zombie_grab_trigger_cleanup" },
    { 0x69612225, "powerup_zombie_grabbable" },
    { 0xB61359F6, "powerupdropmax" },
    { 0x553D1BE9, "powerupindex" },
    { 0xDC85D20B, "poweruplist" },
    { 0x1743FC46, "powerupmodel" },
    { 0x96A05F4A, "powerupname" },
    { 0x794B4215, "poweruporigin" },
    { 0xE78803EE, "powerups" },
    { 0x9C923982, "powerupspacing" },
    { 0x69D965DE, "powerupstarty" },
    { 0x44544B50, "pows" },
    { 0xA30E22A3, "ppl" },
    { 0x97F9B3D4, "ppsh" },
    { 0xBD1B6597, "pr" },
    { 0xCC5FF452, "practice" },
    { 0x5ED19903, "practice_nade_toss" },
    { 0x28AE4B14, "pratio" },
    { 0x5A742E64, "pratt" },
    { 0x0EE9EF4E, "prayerflags1" },
    { 0xE8E774E5, "prayerflags2" },
    { 0x1F4B80A7, "prayers" },
    { 0x7A6037C3, "praying" },
    { 0xA7E48194, "prb_init_missiles" },
    { 0x4A26A148, "pre" },
    { 0x88FA0551, "pre1" },
    { 0xAEFC7FBA, "pre2" },
    { 0xD4FEFA23, "pre3" },
    { 0x978E2C8B, "pre_4th_attack_death_count" },
    { 0xC1B4448C, "pre_4th_attack_death_max" },
    { 0x0E182588, "pre_4thattack_enemy_death_count_reached" },
    { 0xC2CBCD27, "pre_4thattack_enemy_spawner_death_counter" },
    { 0x7D394F16, "pre_4thattack_squad" },
    { 0xB409F0F0, "pre_5" },
    { 0x44045A8B, "pre_aggro_pathfinding_func" },
    { 0x0F4F2D2B, "pre_base_fight" },
    { 0xB5A92F62, "pre_black_hole_bomb_run_combatanim" },
    { 0xEC409848, "pre_breach" },
    { 0x6E4AE072, "pre_building_collapse_event" },
    { 0xD0CEC247, "pre_cut_effect" },
    { 0x571BF18E, "pre_disabled_by_emp" },
    { 0x9471E92D, "pre_drag_docking_sequence" },
    { 0xE2DEF419, "pre_drag_grab_rope" },
    { 0x647C1817, "pre_drag_preparation" },
    { 0x2B5B868C, "pre_drive_cleanup" },
    { 0x370E735F, "pre_end_game" },
    { 0xF27EF0D5, "pre_end_snapshot" },
    { 0xF2316BB4, "pre_event4_chains" },
    { 0xB76A31D7, "pre_event4_trigs" },
    { 0xFA1EACC9, "pre_event4_trigs_off" },
    { 0xCA2C801B, "pre_fire" },
    { 0x4FD7FE83, "pre_highest_wave" },
    { 0x148142B6, "pre_init_func" },
    { 0x3E210163, "pre_init_zombie_spawn_func" },
    { 0x606A124B, "pre_load" },
    { 0xD461D7D5, "pre_meat_weapon" },
    { 0x7679D7A7, "pre_mortars" },
    { 0x43D01CB5, "pre_move_delta_array" },
    { 0xC100A1EA, "pre_mowdown_cowers" },
    { 0x5453E6DD, "pre_origin" },
    { 0x9EECF8B5, "pre_populate_drones" },
    { 0x951B8D68, "pre_power_off" },
    { 0x428AA682, "pre_power_on" },
    { 0x7DC62C09, "pre_rappel_backtrack_check" },
    { 0x8C50AAB9, "pre_snipe_flameguy" },
    { 0x4E178ACF, "pre_standoff_fail" },
    { 0x7602EE2C, "pre_suicide_weapon" },
    { 0x4F5C6866, "pre_surf_type" },
    { 0x2177273B, "pre_teleport_func" },
    { 0xAD926B8A, "pre_terrain" },
    { 0x0EB4631A, "pre_time_in_wave" },
    { 0x31CEEDC3, "pre_total_points" },
    { 0x5806C6EF, "pre_trace_real_ent" },
    { 0x5B187641, "pre_traverse" },
    { 0x9E242EC3, "pre_traverse_old" },
    { 0x42383839, "pre_trigger" },
    { 0xB705BF64, "pre_turret_weapon" },
    { 0xEDBA2860, "pre_wait" },
    { 0xA6E0E7F7, "pre_wave1_control_1" },
    { 0x34D978BC, "pre_wave1_control_2" },
    { 0x5ADBF325, "pre_wave1_control_3" },
    { 0x05C1311D, "preacache" },
    { 0x13F9B40D, "preache" },
    { 0x26BD39B3, "preached" },
    { 0x8765445A, "preanouncetime" },
    { 0xF13F91F9, "prearmed" },
    { 0x53A5ACA4, "prearranged" },
    { 0xA219FC50, "precaced" },
    { 0xF7046C76, "precache" },
    { 0xDD61E9C7, "precache_actor_anims" },
    { 0xDA0A6E49, "precache_ai_death_fx" },
    { 0x5312CC36, "precache_all" },
    { 0x6F77FCFC, "precache_ambient_fx" },
    { 0xC39787B6, "precache_ambient_monkey_anims" },
    { 0x7EAFFBD7, "precache_animated_objects" },
    { 0x02BE5045, "precache_anims" },
    { 0xF6D0DA34, "precache_ape_fx" },
    { 0x4BE4B562, "precache_assets" },
    { 0x93D02715, "precache_chandelier_fx" },
    { 0x915137B2, "precache_corpse_pose_characters" },
    { 0x14BD5ACB, "precache_crash_fx" },
    { 0xF6452D17, "precache_crash_models" },
    { 0xE6258024, "precache_createfx_fx" },
    { 0x5522EDE5, "precache_critter_anims" },
    { 0x027301A7, "precache_damage_fx" },
    { 0xD61261DF, "precache_death_model_wrapper" },
    { 0x90337649, "precache_default_brutus_barrier_fx" },
    { 0xBCB16E90, "precache_destruct_fx" },
    { 0xFB17E638, "precache_destructible_fx" },
    { 0x8FA5679E, "precache_destructibles" },
    { 0xACC5D8BD, "precache_dock_actor_anims" },
    { 0xE07F17CA, "precache_dog_fx" },
    { 0xDAF10612, "precache_drone_anims" },
    { 0x12158F18, "precache_drones" },
    { 0xD79214EA, "precache_dyn_ent_debris" },
    { 0xC4BC9D3B, "precache_dyn_ent_market_debris" },
    { 0xFFFCC509, "precache_effects" },
    { 0x4F994BC4, "precache_endings_anims" },
    { 0x8F64AEA3, "precache_engineer_fx" },
    { 0xD0AAEC8D, "precache_event1_fx" },
    { 0x07F281AE, "precache_everything" },
    { 0x2A76C81A, "precache_extra_models" },
    { 0xEFD6B7DF, "precache_func" },
    { 0xDA8572D3, "precache_fx" },
    { 0x8A899530, "precache_fx_anims" },
    { 0x75BDA74A, "precache_fx_prop_anims" },
    { 0x0ED3F18F, "precache_fxanim_props" },
    { 0xB96BA34D, "precache_fxanim_props_dlc" },
    { 0x1F92498C, "precache_fxanim_props_dlc3" },
    { 0xF98FCF23, "precache_fxanim_props_dlc4" },
    { 0x21A5DBEB, "precache_generic_anims" },
    { 0x297D5CD6, "precache_gib_fx" },
    { 0x788ACBED, "precache_global_fx" },
    { 0x9C831B38, "precache_grenade_offsets" },
    { 0xDCBFEB4C, "precache_hud" },
    { 0x421C5B91, "precache_instruments" },
    { 0x7CC3F5FA, "precache_intro_anims" },
    { 0xFD42E71B, "precache_items" },
    { 0x81F135FE, "precache_level_anims" },
    { 0x39A1F553, "precache_level_assets" },
    { 0xBF5DA104, "precache_level_items" },
    { 0x0650DA63, "precache_loadout_item" },
    { 0x7C3F45A5, "precache_materials" },
    { 0x32534BB7, "precache_model_anims" },
    { 0x0F1FB4BF, "precache_models" },
    { 0xC04BE819, "precache_mp_anticheat_leaderboards" },
    { 0xA9A7C7C3, "precache_mp_custom_leaderboards" },
    { 0xB88A23D8, "precache_mp_friend_leaderboards" },
    { 0xDE82AE91, "precache_mp_leaderboards" },
    { 0xAAD14DF1, "precache_mp_public_leaderboards" },
    { 0xA0EDA4BF, "precache_names" },
    { 0x01070655, "precache_non_mature_nova_bodies" },
    { 0x457FB35E, "precache_nova_body" },
    { 0x3B561EF7, "precache_object_anims" },
    { 0xE91A665C, "precache_patrol_anims" },
    { 0x181565BE, "precache_perk_anims" },
    { 0x1742F3D6, "precache_personality_characters" },
    { 0x65014159, "precache_player_anims" },
    { 0x98929457, "precache_player_model_override" },
    { 0x12DC9113, "precache_player_models" },
    { 0x56E4FD0A, "precache_player_weapon_drops" },
    { 0x75D0D7BD, "precache_prop_anims" },
    { 0xB5DC7264, "precache_rage_mode_overlays" },
    { 0xD7F6F532, "precache_rumble" },
    { 0xA599DCBD, "precache_rumbles" },
    { 0x9B441951, "precache_scene_assets" },
    { 0xA3D28CB7, "precache_screenfx" },
    { 0x82BDA5A9, "precache_script_models" },
    { 0x2193DF00, "precache_scripted_anims" },
    { 0x0F45953C, "precache_scripted_fx" },
    { 0xF6E80EB3, "precache_scripted_vo" },
    { 0xD043327B, "precache_scripts" },
    { 0x45E56119, "precache_shaders" },
    { 0x7D61BAAD, "precache_shock" },
    { 0x11E71D56, "precache_sidequest_assets" },
    { 0x9EBCFF25, "precache_sq" },
    { 0x351DFEE6, "precache_string" },
    { 0xFE0E2319, "precache_strings" },
    { 0x26038223, "precache_submodels" },
    { 0x350022EE, "precache_super_kill_models" },
    { 0xCA71B941, "precache_survival_barricade_assets" },
    { 0x06C1A891, "precache_team_characters" },
    { 0x46C824FE, "precache_team_whos_who_characters" },
    { 0xCDCEBE53, "precache_trophy" },
    { 0x633A3836, "precache_upgrades" },
    { 0x8D0EC42E, "precache_util_fx" },
    { 0xFC8F39CC, "precache_vehicle_anims" },
    { 0x7E6704FE, "precache_vehicles" },
    { 0xB0B7DD7C, "precache_vo" },
    { 0xC4187A12, "precache_wake_fx" },
    { 0x9F623ED2, "precache_weapon_fx" },
    { 0x850C47E4, "precache_weapons" },
    { 0xFC265C3C, "precache_zipline_assets" },
    { 0x4006ED2C, "precache_zombie_gametype" },
    { 0xFA782BB2, "precache_zombie_leaderboards" },
    { 0xA70E9709, "precacheanimstatedef" },
    { 0x5653DC0E, "precacheclipfx" },
    { 0xC2EB9077, "precachecustomcharacters" },
    { 0xA912C006, "precached" },
    { 0xF873B278, "precachedlc3" },
    { 0x31F4E8F1, "precacheeverything" },
    { 0x7F4BBC89, "precacheextrazombies" },
    { 0xDF8D81A4, "precachefx" },
    { 0x46D28A17, "precacheheadicon" },
    { 0xA06CB7D5, "precachehelicopter" },
    { 0x9285C1EA, "precacheing" },
    { 0x12C32D4B, "precacheitem" },
    { 0x48BF7696, "precacheleaderboards" },
    { 0x62647B66, "precachelevelstuff" },
    { 0xC89CC760, "precachelocationselector" },
    { 0x4DD5912F, "precachemenu" },
    { 0x98B508FD, "precachemodel" },
    { 0x76E92BC4, "precachemodelarray" },
    { 0x6A25E335, "precachemodeltype" },
    { 0xBF25E82C, "precachenightvisioncodeassets" },
    { 0xF94431D7, "precachenotetrack" },
    { 0x68DD5277, "precacherevivemodels" },
    { 0xF35A208D, "precacherumble" },
    { 0x8ADEB569, "precaches" },
    { 0x7B2132E1, "precaches_anim_string" },
    { 0x2B4E4DFB, "precachescript" },
    { 0x3511AC2D, "precachesetup" },
    { 0xD921EFC1, "precacheshader" },
    { 0xD50DE11A, "precacheshellshock" },
    { 0x87B92F77, "precachestatusicon" },
    { 0xE5BFB611, "precachestring" },
    { 0x9B064064, "precachestuff" },
    { 0x9DD4D494, "precacheturret" },
    { 0x85C96FAA, "precachevehicle" },
    { 0x675D7F0C, "precacheweaponswitchfx" },
    { 0x3F79C16F, "precaching" },
    { 0x90A0B284, "precahce" },
    { 0xE0FFBACC, "precahce_front_door_anims" },
    { 0x4A2A31E0, "precahce_interior_anims" },
    { 0x580134C8, "precahced" },
    { 0xB4C896A0, "precalcdone1" },
    { 0x26D005DB, "precalcdone2" },
    { 0xA0421235, "precamera" },
    { 0x08A2EDA5, "precede" },
    { 0x99C43C85, "precedence" },
    { 0x09ADF170, "preceding" },
    { 0x1B3B6E8B, "precious" },
    { 0x53D901F4, "precise" },
    { 0x507E12A6, "precisedroplocation" },
    { 0xC0F49510, "precisegoallocation" },
    { 0xA9DED6B1, "precisely" },
    { 0x15E37C5B, "precisepositioning" },
    { 0x4783C5C3, "precision" },
    { 0x364CD7F2, "precombatrunenabled" },
    { 0xFB54631D, "precomputed" },
    { 0xE8D4C659, "precourtyard" },
    { 0xD007CF54, "precourtyard_enemies_retreat" },
    { 0xBBE7A938, "precourtyard_enemy_movement" },
    { 0x71499F75, "precourtyard_guy_wait_and_retreat" },
    { 0x9508BE92, "precourtyard_guys_invulnerable" },
    { 0xC0B38E17, "precourtyard_pdf_reinforcements" },
    { 0xB5A3AF59, "precourtyard_spawn_manager" },
    { 0x2D0DE13B, "predamage" },
    { 0x721479B8, "predator" },
    { 0x0D77FD09, "predator_intro_started" },
    { 0xE7DE760F, "predefined" },
    { 0x50E17B75, "predelay" },
    { 0x907DE4D3, "predeltayaw" },
    { 0x767BA9A1, "predestructed" },
    { 0x74C450E2, "predestructing" },
    { 0xB468A819, "predetermined" },
    { 0x08611526, "predicate_argument" },
    { 0xAD7262D0, "predicated" },
    { 0xD8963601, "predicitedposition" },
    { 0xCBA6A978, "predict" },
    { 0x52AB0C57, "predict_floor" },
    { 0x43502FBC, "predict_time" },
    { 0xA403B84B, "predict_vehicle_movement_offset" },
    { 0xF7E5CFA0, "predictable" },
    { 0x70705007, "predictanim" },
    { 0x56ABFF8B, "predicted" },
    { 0xC57440F1, "predicted_local_player" },
    { 0x452790CC, "predicted_origin" },
    { 0xB70926A8, "predicted_pos" },
    { 0xB87BF1BD, "predictedarrivaldirectionvalid" },
    { 0xA5BC823E, "predictedcollisiontime" },
    { 0x8C229977, "predicteddist" },
    { 0x306E013B, "predictedenemydistsqafterraisegun" },
    { 0xA5628045, "predictedenemypos" },
    { 0x9B82611B, "predictedenemyposafterraisegun" },
    { 0xCEF12E27, "predictedexitpos" },
    { 0xCEDFF883, "predictedlocalplayer" },
    { 0xEDA59085, "predictedlookahead" },
    { 0xE97DEC19, "predictedlookaheadinfo" },
    { 0x2241E707, "predictedpos" },
    { 0x7AFAD6DA, "predictedposition" },
    { 0x615CE3AE, "predictedrevivepoint" },
    { 0xB530240C, "predictedspawn" },
    { 0x8C6ED681, "predictedyawtoenemy" },
    { 0x07113FD6, "predictedyawtoenemytime" },
    { 0x19457D68, "predictexit" },
    { 0x6FBE8AC5, "predictgetnotetrack" },
    { 0x0390C402, "predictgrenade" },
    { 0x54DB922A, "prediction" },
    { 0xBA6AD0CE, "prediction_time" },
    { 0x04D5848B, "prediction_trace_max" },
    { 0xDA437945, "prediction_trace_min" },
    { 0xB8DE5CE5, "predictions" },
    { 0x4BA72625, "predictiontime" },
    { 0xF5EDCBD1, "predictoriginandangles" },
    { 0x67F2354D, "predictpath" },
    { 0x47743C41, "predictposition" },
    { 0xA1DB2AD3, "predicts" },
    { 0xC2EA5E7D, "predictspawnpoint" },
    { 0x71474BB3, "predicttime" },
    { 0xABBAC391, "predominantly" },
    { 0x0B842AD8, "predone" },
    { 0xCD7A0759, "predumpvehicles" },
    { 0x877B3D7C, "preemption" },
    { 0xF27C2DE8, "preemptive" },
    { 0x2563A95D, "preendgamefunction" },
    { 0x0DB8D307, "preexisting" },
    { 0x427706D7, "preexisting_init_dog" },
    { 0x9AC2EA46, "preexplode_fx_played" },
    { 0x718F103B, "prefab" },
    { 0xE79CC36C, "prefabbike" },
    { 0x0786BCCA, "prefabbikeents" },
    { 0x4FED1492, "prefablimo" },
    { 0xD09A82E0, "prefablimoents" },
    { 0x8560ADDA, "prefabs" },
    { 0xCE8EB877, "prefer" },
    { 0x0322A5DB, "preferably" },
    { 0x984D3F06, "prefereddirectness" },
    { 0x451313CC, "prefereddistawayfromorigin" },
    { 0x7AD04DF4, "preferedheightrange" },
    { 0x1B84D666, "preference" },
    { 0x69921D9C, "preferential" },
    { 0xCF5C4E78, "preferleft" },
    { 0x975C69DC, "preferred" },
    { 0x02EC685A, "preferred_value" },
    { 0x6C9CD397, "preferred_weapon" },
    { 0x09C0D86B, "preferredactivity" },
    { 0xAF055CE3, "preferrednextpos" },
    { 0xA909A3F3, "preferredpose" },
    { 0xB9B2FE27, "preferredtarget" },
    { 0x80B3B8C9, "preferring" },
    { 0x6246DF10, "prefetch_next" },
    { 0xE2281793, "prefetched" },
    { 0xB4B1E832, "prefetchlevel" },
    { 0x480983C3, "prefetchnext" },
    { 0xDF06EE99, "prefix" },
    { 0x4CA280C6, "prefixed" },
    { 0x2E6E7629, "prefixes" },
    { 0x2F67C39A, "prefunc" },
    { 0x8980687E, "pregame" },
    { 0xD0F1977A, "pregame_damage" },
    { 0x4EF93D0B, "pregame_health" },
    { 0xD35C963F, "pregame_minplayers" },
    { 0xC5224F97, "pregameclassresponse" },
    { 0x1E4A8839, "pregamemain" },
    { 0xABF47C11, "pregameoutcomenotify" },
    { 0xCCE09234, "pregameplay_exposure" },
    { 0x06D91135, "pregameplay_fx" },
    { 0x20A2483C, "pregameplay_missiles" },
    { 0xEAA3A5C6, "pregameplayercount" },
    { 0x0B227302, "pregameresetoutcomenotify" },
    { 0xEA4A3B20, "pregamestartgame" },
    { 0x1AD6773A, "pregamesubtitle" },
    { 0x594490F4, "pregametitle" },
    { 0x293ACEE9, "pregrappel_drone_flyby" },
    { 0x141A8A5E, "pregrappel_drone_flyby_logic" },
    { 0xD94750B1, "pregrappel_osprey_flyby" },
    { 0x6ABC88EF, "prehackfunction" },
    { 0x8F46C397, "preinit_func" },
    { 0x18B894FA, "preinitialized" },
    { 0xF4E9C45F, "preliminary" },
    { 0xF9BE663C, "preload" },
    { 0xF8949BCF, "preload_function" },
    { 0x496F3AEA, "preload_weapon_changing_" },
    { 0xDDC5D4D7, "preload_weapon_complete" },
    { 0x34190CC2, "preload_weapon_complete_" },
    { 0x8DA2C299, "preload_weapon_model" },
    { 0x3CE289D2, "preload_weapon_watcher" },
    { 0x4A0CDB6E, "preload_weapons" },
    { 0x0217BFDF, "preloadingenabled" },
    { 0xBF0A6F3E, "preloadtreadfx" },
    { 0x82673EA8, "premain_func" },
    { 0x7624714B, "prematch" },
    { 0x5F6F3990, "prematch_over" },
    { 0xFDDA44F9, "prematch_period" },
    { 0x650BF6E0, "prematchperiod" },
    { 0x18C6815F, "prematchperiodend" },
    { 0xC06DA184, "prematchrequirement" },
    { 0x1C44C691, "prematchwaitingforplayers" },
    { 0xA039A2F8, "premature" },
    { 0x32683E6F, "prematurecornergrenadedeath" },
    { 0xBD7DD8FD, "prematurely" },
    { 0x7012456C, "premaxhealth" },
    { 0x75F5AE93, "premovedelta" },
    { 0x00E141BE, "premovedeltaarray" },
    { 0xE3962528, "prep" },
    { 0x1EB3F1F4, "prep_and_play_idle" },
    { 0xF28EEF60, "prep_base_vignettes" },
    { 0xB47A69B4, "prep_beatdown_guards" },
    { 0x043E1CB9, "prep_brim_start_models" },
    { 0x36CEBC03, "prep_done" },
    { 0x6662C5DB, "prep_drone_path" },
    { 0x6F6F0644, "prep_for_new_quest" },
    { 0x17E3FC9E, "prep_for_rappel_think" },
    { 0x9ADE9BF4, "prep_interrogation" },
    { 0xD308519C, "prep_intro_fx" },
    { 0x6FF90707, "prep_push" },
    { 0x65906D5D, "prep_rolling_door" },
    { 0x5DFB4867, "prep_savimbi_nag_array" },
    { 0xB26A4E44, "prep_scene_heli" },
    { 0xF2FD1ACF, "prep_spiderbot" },
    { 0xBC5104DE, "prep_start_buffel_unload" },
    { 0x0812A60C, "prep_time" },
    { 0xE19BED79, "prep_trip_wires" },
    { 0x84121A62, "prep_victory_shot" },
    { 0x04061A2D, "prep_victory_shots" },
    { 0x8895DB6F, "prep_wave_two" },
    { 0xDC755436, "prep_window_breach1" },
    { 0xB672D9CD, "prep_window_breach2" },
    { 0x59D9CDCC, "prepackaged" },
    { 0x5CBAEFD7, "prepairs" },
    { 0xC50F1360, "preparation" },
    { 0x2939E30B, "preparations" },
    { 0xEC9EBEDE, "prepare" },
    { 0x08F79AF3, "prepare_2nd_pass_tuning" },
    { 0x86A0254D, "prepare_anims" },
    { 0x1DF966B3, "prepare_attack_time" },
    { 0xF707CDEC, "prepare_chalk_weapon_list" },
    { 0xB4E3AE49, "prepare_death" },
    { 0x2A5D4F75, "prepare_death_threshold" },
    { 0x975D9D5F, "prepare_death_update" },
    { 0xF310EF00, "prepare_escape_truck" },
    { 0x01F26D88, "prepare_flame_bunker_aiming_origins" },
    { 0x68FCA864, "prepare_for_death_collision" },
    { 0xB6B91E14, "prepare_for_hangar" },
    { 0xE529280A, "prepare_generic_model_anim" },
    { 0x380E1CB1, "prepare_option_for_change" },
    { 0xFE8E1418, "prepare_player_model_anim" },
    { 0x57F3A005, "prepare_players" },
    { 0x1B35EFF5, "prepare_stub" },
    { 0x8EE153B3, "prepare_tankride" },
    { 0xB72BD855, "prepare_to_die" },
    { 0x29909315, "prepare_water_gate_idle" },
    { 0x900195DD, "prepareattackplayer" },
    { 0xB30279BE, "prepared" },
    { 0x8FE3E582, "prepareforadjusttocover" },
    { 0x1A1EFBF3, "prepareforexposedmelee" },
    { 0x95C138E4, "prepareformovement" },
    { 0xC1C319ED, "preparefortraverse" },
    { 0xA17C285A, "preparegrenadeammo" },
    { 0x551DBC41, "prepares" },
    { 0x0867C5F0, "preparetochangestancetocrouch" },
    { 0x7813CDDA, "preparetochangestancetostand" },
    { 0xD6BE3A53, "preparetomelee" },
    { 0x2D8FEC1F, "preparetomoveawayfromnearbyenemy" },
    { 0x6B822CB1, "preparetopthreeplayers" },
    { 0x4E0FE9BF, "preparetoreacttoenemy" },
    { 0x2BFABA05, "preparetostopnearenemy" },
    { 0x426C68F7, "preparing" },
    { 0x80561D92, "preparing_rocket_launch_vo" },
    { 0x89AF95C3, "preparing_to_breach" },
    { 0x1E52D367, "preparing_to_drop_vc" },
    { 0x90F05967, "prepend" },
    { 0xD1046BD2, "prepickeddroplocation" },
    { 0x200CAF07, "preplaced" },
    { 0x56445927, "preplaced_post_script_func" },
    { 0x9329E73A, "preplacedpostscriptfunc" },
    { 0xC43AE09B, "prepped" },
    { 0x2ECB8ED0, "prepping" },
    { 0x08EBDDDD, "prepree_trigger" },
    { 0x3F8B93C3, "preps" },
    { 0xB1379C4D, "preptext" },
    { 0x36F765C3, "preptime" },
    { 0x886C7E04, "prereqindex" },
    { 0x3D5A25FB, "prereqs" },
    { 0xA2330253, "prerequisite" },
    { 0xDDE44B38, "prerunanim" },
    { 0x7F81CD34, "prescedence" },
    { 0xF030A09A, "presence" },
    { 0x0302A06A, "presense" },
    { 0xAAC3AE72, "present" },
    { 0x81C8BA95, "presentation" },
    { 0xC8F5480E, "presentation_rate" },
    { 0x4BDA8048, "presentation_stage_1_started" },
    { 0xB73D7C23, "presentation_stage_2_started" },
    { 0x8C92447A, "presentation_stage_3_started" },
    { 0xFBDE9D7F, "presently" },
    { 0x1B3AC1B9, "preserve" },
    { 0x56361FB5, "preserve_asd_substates" },
    { 0x5F3A247C, "preserve_equipment" },
    { 0xC3D4484B, "preserve_state" },
    { 0x66F09360, "preserve_turbines" },
    { 0x6F76C73F, "preserved" },
    { 0xEB8F8F59, "preserver" },
    { 0xC58D14F0, "preserves" },
    { 0xB48C85AC, "preserving" },
    { 0x8C4A3FD1, "preserving_equipment" },
    { 0xA9F4FA63, "preserving_turbines" },
    { 0xFE3070C8, "preset" },
    { 0x410F3AE3, "presets" },
    { 0x67075D44, "preshootlaserandglinton" },
    { 0xC6759D0B, "president" },
    { 0x405F7D37, "presidential" },
    { 0xBC9FA66A, "presidents" },
    { 0x9DFE057C, "preslide_death" },
    { 0xBCD1F7C5, "prespawn" },
    { 0xE7B64F77, "prespawn_end" },
    { 0x4FFE305C, "prespawn_start" },
    { 0x414895B2, "prespawned" },
    { 0xAEFD8452, "press" },
    { 0xF1371FE4, "press_ads_button" },
    { 0xD31799D0, "press_attack_button" },
    { 0xD4DF1076, "press_crouch_button" },
    { 0xE13A6BE0, "press_demo" },
    { 0xDA09AD92, "press_demo_fadeout_watcher" },
    { 0xDC2A7991, "press_doublejump_button" },
    { 0xD757764D, "press_fadeout" },
    { 0x9F451AA4, "press_frag_button" },
    { 0xC4FDFD68, "press_grenade_button" },
    { 0xE25B77E4, "press_jump_button" },
    { 0x2326A267, "press_melee" },
    { 0xEDC9063E, "press_offhand_button" },
    { 0xE497AC2C, "press_sprint_button" },
    { 0x6755B4BB, "press_start" },
    { 0x9DABEA00, "press_swim_down" },
    { 0x5E7EBA3B, "press_swim_up" },
    { 0xBA2F76A1, "press_the_button" },
    { 0x39EDB972, "press_throw_button" },
    { 0xAC562676, "press_time" },
    { 0x8FA389FD, "press_use_button" },
    { 0x5F5119BB, "press_x" },
    { 0x43D0844D, "press_x_hud" },
    { 0xD4D4577B, "press_x_to_continue" },
    { 0xAF9D0780, "pressads" },
    { 0xF784534E, "pressattackbutton" },
    { 0x51FE1E4E, "pressdtpbutton" },
    { 0x42ECAB65, "pressed" },
    { 0xC9989794, "pressed_button" },
    { 0x70BD959A, "presses" },
    { 0xC870E05E, "pressing" },
    { 0x920ACA01, "pressing_ads" },
    { 0x0432F141, "pressing_fire" },
    { 0x04A3E11C, "pressingbuttonfunc" },
    { 0xD09F9D1A, "pressmelee" },
    { 0x80FF296D, "pressstarttime" },
    { 0x580556C4, "pressure" },
    { 0x8EC9D665, "pressurized" },
    { 0x5B8CB97F, "pressusebutton" },
    { 0x9693E22A, "prestige" },
    { 0x96D5A1C9, "prestigeid" },
    { 0x27BA7BE4, "prestigelb" },
    { 0xB49C26A1, "prestigenumber" },
    { 0x1CC38CC9, "prestine" },
    { 0x8010A292, "prestine_piece" },
    { 0x84E8C52E, "preston" },
    { 0x5A79C811, "presumably" },
    { 0x0C604206, "presume" },
    { 0x6E797C3B, "pretend" },
    { 0x203E4751, "pretty" },
    { 0x52E8B626, "prettyslowdown" },
    { 0x44E3D451, "prettyspeedup" },
    { 0x3FBDA8A8, "preturn_angles" },
    { 0x67847C28, "preunawarebehaviorsightdistsqrd" },
    { 0xC7A5039E, "prev" },
    { 0x960D7618, "prev_ammo_clip" },
    { 0xE1678378, "prev_ammo_stock" },
    { 0x896CFE43, "prev_ang" },
    { 0x49CD2BD1, "prev_anim_delta" },
    { 0x1C19988E, "prev_anim_pose" },
    { 0xAB43B522, "prev_anim_speed" },
    { 0x0BC0D9C4, "prev_anim_state" },
    { 0xAF7ABB0E, "prev_ape_round" },
    { 0x4AEE79A2, "prev_count" },
    { 0x7F582B31, "prev_disc_pos" },
    { 0x9DC8FC7D, "prev_dist" },
    { 0xFBA0490B, "prev_drops_on" },
    { 0x3DABDDF3, "prev_enemy_position" },
    { 0x340A3294, "prev_forward" },
    { 0xFCC38424, "prev_forward_vel" },
    { 0x2CA0C211, "prev_gump_info" },
    { 0x292917EB, "prev_health" },
    { 0xDE7397A9, "prev_heli_kill_streak" },
    { 0x44EF9187, "prev_in_list" },
    { 0xABF0F101, "prev_info" },
    { 0x78DAA244, "prev_last_index" },
    { 0xBF9E9A32, "prev_lerp" },
    { 0xCCC4D8FD, "prev_map" },
    { 0x8D1AFB59, "prev_max_speed" },
    { 0x5BFDD812, "prev_move_speed" },
    { 0x03FB425D, "prev_node" },
    { 0x749870B9, "prev_org" },
    { 0x60C0AC73, "prev_origin" },
    { 0xD074477D, "prev_pap_index" },
    { 0xF56B8FF2, "prev_player_horse_forward" },
    { 0xF4BE5FBD, "prev_pos" },
    { 0x7377B364, "prev_position" },
    { 0xF128BA27, "prev_round_zombies" },
    { 0x0E0D2C53, "prev_run_cycle" },
    { 0x40D80905, "prev_shield_damage_level" },
    { 0x2D36A980, "prev_shield_model" },
    { 0x87CD50BE, "prev_shield_placement" },
    { 0x9BED67D3, "prev_shield_tag" },
    { 0xA0177009, "prev_shield_viewmodel" },
    { 0xA0431699, "prev_slot" },
    { 0x26B3F88A, "prev_thief_round" },
    { 0xD40C937A, "prev_time" },
    { 0xB2239DA6, "prev_vel" },
    { 0xCE64287D, "prev_weapon" },
    { 0xA880517B, "prev_weapon_before_equipment_change" },
    { 0x6D11F108, "prev_weapon_type" },
    { 0x8D5842FE, "prev_yaw" },
    { 0x13987A5D, "prev_z" },
    { 0xF1BE2987, "prev_zone" },
    { 0xFB4A1B35, "prevaim2" },
    { 0x48F52281, "prevallowdeath" },
    { 0xC9443414, "prevammo" },
    { 0xDF10D78A, "prevangles" },
    { 0x3C8A5F89, "prevanim" },
    { 0x4F4E88A9, "prevanimdelta" },
    { 0xDD3D8FB2, "prevattack" },
    { 0x7A24B1C8, "prevbikerpitchaimweight" },
    { 0x37BAFAE1, "prevbikeryawaimweight" },
    { 0xFDC38756, "prevcargospot" },
    { 0xE4F0BE20, "prevcargospot2" },
    { 0x1AAD98D0, "prevcarryiconalpha" },
    { 0xBC465522, "prevcase" },
    { 0xF2828905, "prevclientnum" },
    { 0xC7F195C5, "prevdamage" },
    { 0x49825080, "prevdeathfunction" },
    { 0x370B42E2, "prevdelayeddeath" },
    { 0x4AF44A2E, "prevdest" },
    { 0xC44778BA, "prevdist" },
    { 0xDB66D6C2, "prevenemy" },
    { 0xD610F5F4, "prevenemypos" },
    { 0xDF417F85, "prevent" },
    { 0x7E581D5F, "prevent_balcony_advance" },
    { 0x84BC65C9, "prevent_dupe_rb_cover_vox" },
    { 0x7B35FF11, "prevent_gun_death" },
    { 0x383F23D6, "prevent_hazmat_in_flash" },
    { 0x8584B72D, "prevent_long_death" },
    { 0xDA8DEDB3, "prevent_near_origin" },
    { 0x8A147C83, "prevent_other_vox_while_here" },
    { 0x62097B82, "prevent_pick_up_if_drinking" },
    { 0xAE5D9899, "prevent_player_damage" },
    { 0xA20D219F, "prevent_player_damage_if_the_player_is_sprinting" },
    { 0xA701CEB8, "prevent_riders_from_unloading" },
    { 0x5B2F22DA, "prevent_round_ending" },
    { 0x2B343B10, "prevent_round_switch_animation" },
    { 0x2DE18D1C, "prevent_stuck" },
    { 0x8AC925EF, "prevent_theater_mode_spoilers" },
    { 0xF434BB31, "prevent_weapon_kill_credit" },
    { 0x89553472, "prevented" },
    { 0xBBFF5D63, "preventing" },
    { 0x0CC5D959, "prevention" },
    { 0x357D0D6C, "preventpainforashorttime" },
    { 0x2829DD14, "prevents" },
    { 0x785F554F, "preventteamswitchexploit" },
    { 0x314FEADE, "prevfaceanim" },
    { 0xC17AEBB0, "prevflagindex" },
    { 0x316C7294, "prevfunc" },
    { 0x743AC02B, "prevheadanim" },
    { 0x3E482EA0, "prevhealth" },
    { 0x644DC4A9, "prevhealthratio" },
    { 0x181A561B, "preview" },
    { 0x28F32758, "preview_anim_single" },
    { 0x260B4630, "previewaccuracy" },
    { 0xF8B7AEA8, "previewgesture" },
    { 0x8DC25F25, "previewmodels" },
    { 0x888B76C0, "previewsightpos" },
    { 0xB5457A9D, "previewtaunt" },
    { 0xB481A500, "previnanim" },
    { 0x00BC1670, "previnnerpos" },
    { 0x4CEAC8F6, "previous" },
    { 0xEA229ADA, "previous_accuracy" },
    { 0x686DB095, "previous_angles" },
    { 0xA438348A, "previous_anim" },
    { 0x81D74BFB, "previous_best" },
    { 0xD24DD494, "previous_charges" },
    { 0xA638F5AA, "previous_count" },
    { 0xDDAB0614, "previous_cover_direction" },
    { 0xC5653294, "previous_cover_mode" },
    { 0x70F71731, "previous_cover_type" },
    { 0x6CB204D2, "previous_crumb" },
    { 0x744F6323, "previous_crumb_index" },
    { 0x83BA14CD, "previous_damage_state_index" },
    { 0x0B177DE8, "previous_drone_index" },
    { 0x3F3F577D, "previous_exit_taken" },
    { 0x2CF8EEF3, "previous_health" },
    { 0xBC804AAE, "previous_health_percentage" },
    { 0x32FC22E0, "previous_location" },
    { 0x372CF164, "previous_locked_on_to_me" },
    { 0xC4B23401, "previous_locking_on_to_me" },
    { 0x475F1838, "previous_menu" },
    { 0x5E362E0F, "previous_menu_info" },
    { 0xD5A8EE7C, "previous_name" },
    { 0x7ACF1EB5, "previous_node" },
    { 0x446E6B0B, "previous_origin" },
    { 0xE2AAFCE8, "previous_quad" },
    { 0xA80281A1, "previous_redshirts" },
    { 0x7E2390A2, "previous_restorable_points" },
    { 0x42582825, "previous_room_names" },
    { 0xA9066509, "previous_selection" },
    { 0x41B8264E, "previous_shield_damage" },
    { 0x02FB0F2A, "previous_size" },
    { 0xA4EBD652, "previous_spawn_delay" },
    { 0x8F0C2389, "previous_stage" },
    { 0x6EC51788, "previous_state" },
    { 0xCAB28732, "previous_time" },
    { 0x2C4703DF, "previous_vehiclenode" },
    { 0x8012B415, "previous_weapon" },
    { 0x0A50C6C7, "previous_winner_score" },
    { 0x4806DAC7, "previous_zone_name" },
    { 0x1FDB8FEE, "previousacousticsensorcount" },
    { 0xE66F62D6, "previousammoclip" },
    { 0x20B662FE, "previousammostock" },
    { 0x2B747A3A, "previouscovermode" },
    { 0x828FB0AD, "previousend" },
    { 0x6D1387DF, "previousenemydetectedbitfield" },
    { 0x661DD512, "previousgadget" },
    { 0xE25F8363, "previousgivefliptime" },
    { 0xAAE56113, "previousheight" },
    { 0xCDC20AF0, "previoushighscore" },
    { 0x386121FB, "previously" },
    { 0xA6ABA0BC, "previously_run_logic_functions" },
    { 0x5AF008D7, "previouslyhacked" },
    { 0x3A125F9F, "previousmultiplier" },
    { 0x2E41E08A, "previousnode" },
    { 0x39C9347C, "previousorigin" },
    { 0xEF92AF17, "previousowner" },
    { 0x456E4EA2, "previouspitchdelta" },
    { 0x4460880C, "previouspoint" },
    { 0xEF04E3B7, "previousposition" },
    { 0x54A2D6EC, "previousprimary" },
    { 0x2DAAA932, "previouspriority" },
    { 0x8BCDF141, "previousquantity" },
    { 0xB21DC67B, "previousscript" },
    { 0x3E1C7D21, "previoussize" },
    { 0x0DA8D4DE, "previousstart" },
    { 0x99CC27D5, "previousstate" },
    { 0xBB2AF1B9, "previousteam" },
    { 0xA0FA9AE2, "previousthrottle" },
    { 0x869B3C21, "previousweaponslist" },
    { 0xC08157EE, "previousweight" },
    { 0xAB18369A, "previs" },
    { 0x357110FF, "previs_controls" },
    { 0x25975646, "previs_main" },
    { 0x8CB06A84, "previs_typing" },
    { 0xF39CB355, "previs_visible" },
    { 0xC7D778F2, "previuos" },
    { 0x50920BF3, "prevjawanim" },
    { 0x357C7E27, "prevlookaheadyaw" },
    { 0xC3F54143, "prevlooptime" },
    { 0x8DFC3952, "prevmovedir" },
    { 0x0773A431, "prevmovement" },
    { 0xEAADBF32, "prevnode" },
    { 0x85C9ED67, "prevnodeangle" },
    { 0x04D2C695, "prevnotify" },
    { 0x38A55F70, "prevorg" },
    { 0x0C039F64, "prevorigin" },
    { 0x2B5ABAE5, "prevoutanim" },
    { 0xAB8C6087, "prevouterpos" },
    { 0x1FD15C4F, "prevowner" },
    { 0xF49DD0BA, "prevpitchdelta" },
    { 0x8ACAAE34, "prevpoint" },
    { 0x83C04820, "prevpos" },
    { 0x04D0070D, "prevpose" },
    { 0x6E4EB56F, "prevprogress" },
    { 0xEDEAE190, "prevputguninhandtime" },
    { 0x5B1EAE4B, "prevradio" },
    { 0xA829AE53, "prevradio2" },
    { 0xCEFB450D, "prevradioindex" },
    { 0x50BD06B3, "prevrelativedir" },
    { 0xBAED4310, "prevrelval" },
    { 0x20ADC653, "prevriderpitchaimweight" },
    { 0xC7DE80D6, "prevrideryawaimweight" },
    { 0xED1838BF, "prevsafezone" },
    { 0xE7FEA2EF, "prevsafezone2" },
    { 0xF1FA8EB9, "prevscoreplace" },
    { 0xACF15BD3, "prevscript" },
    { 0xB97A06FA, "prevshootent" },
    { 0x4C5807A0, "prevshootfrompitchangle" },
    { 0x91710EBD, "prevshootfromyawangle" },
    { 0xDD21B167, "prevshootpos" },
    { 0x9B0E6C4E, "prevshootstyle" },
    { 0x4AF30BCC, "prevsideanimweight" },
    { 0x42F13237, "prevspawnpoint" },
    { 0x3343E457, "prevspeed" },
    { 0x550E5A8D, "prevstate" },
    { 0x473FB8FD, "prevstruct" },
    { 0xEE2482F3, "prevstructorigin" },
    { 0x99414251, "prevteam" },
    { 0x883B84E9, "prevthisplayer" },
    { 0xF1D2DA51, "prevtime" },
    { 0x30B693BC, "prevturret" },
    { 0x647C803B, "prevval" },
    { 0xFA5A6167, "prevvel" },
    { 0x0A74FFBD, "prevweap" },
    { 0x285FD21E, "prevweapon" },
    { 0xB6760C56, "prevxp" },
    { 0xC173BE47, "prevyaw" },
    { 0xB0BF471B, "prevyawdelta" },
    { 0x5CF1BE5C, "prevzone" },
    { 0xD81CABF6, "prevzone2" },
    { 0xC58FF650, "prevzoneindex" },
    { 0xC127FCAB, "prewait" },
    { 0xD984CC49, "prey" },
    { 0xB21CB7A4, "pri" },
    { 0x6576DF58, "price" },
    { 0x92F8CEAF, "price_aims_at" },
    { 0x8A66B073, "price_aims_at_his_enemy" },
    { 0x109B125D, "price_and_gaz_arrive_at_fight_check" },
    { 0x917C87B2, "price_and_gaz_catchup_to_bridge" },
    { 0x5F4114B4, "price_and_gaz_flash_hut" },
    { 0x2AFA27A3, "price_anim_start_time" },
    { 0xD68C64B6, "price_approaches_door" },
    { 0xE91B70F4, "price_asks_to_be_picked_up" },
    { 0x4326EC20, "price_asks_to_be_picked_up_when_its_safe" },
    { 0x681615B2, "price_asks_to_be_put_down" },
    { 0x3A2A4F85, "price_attack_hunt" },
    { 0x45709399, "price_attacks_door_guy" },
    { 0x6830D28A, "price_blends_into_run" },
    { 0xFA6B65CB, "price_bridge_crawl_anims" },
    { 0xA754809E, "price_calls_out_a_kill" },
    { 0x26DEACDB, "price_calls_out_guy" },
    { 0x905BB544, "price_calls_out_kill_if_he_should" },
    { 0xD69EAA49, "price_calls_out_kills" },
    { 0x41A45E4F, "price_can_be_left" },
    { 0x1D78D710, "price_checks_goal_for_noteworthy" },
    { 0xA309F54A, "price_circle_node" },
    { 0x6754C586, "price_clears_dialogue" },
    { 0xA69989E2, "price_climbs_until_player_rappels" },
    { 0x683CEBC4, "price_complains_until_he_is_picked_up" },
    { 0x4B90291D, "price_congrates" },
    { 0x9DBD5CE4, "price_cqb_aims_at_target" },
    { 0x6327E1C7, "price_death" },
    { 0xB977AC64, "price_death_failure" },
    { 0xC22904BC, "price_death_org" },
    { 0x8778909E, "price_decides_if_he_can_be_picked_up" },
    { 0x3CC4B3C7, "price_defends_his_spot_until_he_is_picked_up" },
    { 0x829DE666, "price_dialogue_master" },
    { 0x5F3C00E2, "price_dies" },
    { 0x4018CE88, "price_dies_if_player_goes_too_far" },
    { 0xEB44092E, "price_directs_players_upstairs" },
    { 0x8C4F6351, "price_dog_death_trigger" },
    { 0xDFE38358, "price_door_flash" },
    { 0x2BFE0A6F, "price_drop_point" },
    { 0xBADB104F, "price_dropped" },
    { 0xCE3B30CD, "price_end_node" },
    { 0x24576C39, "price_enter_barn" },
    { 0x2DB5556B, "price_evac_idle" },
    { 0x0CA13EC0, "price_fair_defendspot" },
    { 0x9CE62B0F, "price_fends_off_attacker" },
    { 0x61C1754F, "price_fights_enemies" },
    { 0x09688686, "price_fights_until_enemies_leave" },
    { 0x5F15E289, "price_finishes_farm" },
    { 0x154924EA, "price_fires" },
    { 0x516C9A18, "price_flees_grenades" },
    { 0xDDCD4161, "price_floats_up_out_of_solid" },
    { 0x113595D4, "price_followup_line" },
    { 0xD93047FE, "price_forward" },
    { 0x6CB0DC7B, "price_gets_new_cqb_targ" },
    { 0x8ED19006, "price_gets_ready_to_open_door" },
    { 0xA0C5D57F, "price_gnoll" },
    { 0xCD641296, "price_gnoll_dist" },
    { 0xA1B56D86, "price_goes_to_window_to_shoot" },
    { 0xFE3EFFD3, "price_grigs" },
    { 0xAD915C6F, "price_heli" },
    { 0x998E0271, "price_heli_hit_detection" },
    { 0x86B18E41, "price_intro_route" },
    { 0xB3D9C37D, "price_is_put_down_near_wheel" },
    { 0x2BFDC3FE, "price_is_safe_after_wounding" },
    { 0xCD4B2AB0, "price_is_talking" },
    { 0x0A5D2F06, "price_kill_check" },
    { 0x1525D0B3, "price_left_behind" },
    { 0xCB07D8F5, "price_line" },
    { 0x87D59221, "price_loop" },
    { 0x436753F9, "price_meeting_org" },
    { 0xF9C55CCC, "price_moves_behind_concrete_barrier" },
    { 0x1AB55BC5, "price_moves_to_position" },
    { 0x0D5FE526, "price_moves_to_sniping_position" },
    { 0x0384ACD4, "price_moves_up_and_waves_player_on" },
    { 0xED8C7794, "price_next_shoot_time" },
    { 0xA50EE687, "price_node" },
    { 0x55B78B9B, "price_nvg_spawner" },
    { 0xA444B469, "price_opens_door" },
    { 0x595C6E6A, "price_opens_door_and_goes_in" },
    { 0x587E4DEB, "price_org" },
    { 0x7980808D, "price_picked_up" },
    { 0x972D22C1, "price_picks_target" },
    { 0x401F78AD, "price_pickup_elements" },
    { 0x03642521, "price_placement_trigger" },
    { 0xB453AF33, "price_putdown_hint_trigger" },
    { 0x0154F99E, "price_reaches_signal_node" },
    { 0x8251AEA7, "price_react_and_loop" },
    { 0xA074D573, "price_reminds_player_about_javelin" },
    { 0x84E5CD7D, "price_reminds_player_about_shooting_javelin" },
    { 0x40CDB393, "price_rescue_node" },
    { 0xB8ECA2D1, "price_rescue_room_node" },
    { 0x51279A2B, "price_responds_to_overpass" },
    { 0x50EEBF4F, "price_runs_for_woods_on_contact" },
    { 0x114E1074, "price_says_a_bit_farther" },
    { 0xD4F8EFE4, "price_says_this_is_fine" },
    { 0x8BF385DA, "price_sees_enemy" },
    { 0x3CE48067, "price_sets_stance" },
    { 0xBC474E55, "price_signals_moveup" },
    { 0xE83EDF38, "price_signals_on_arrival" },
    { 0xBCB01D61, "price_slides_into_proper_putdown_position" },
    { 0xFDAD746B, "price_snipes_heli_until_player_does" },
    { 0xD5AF33AD, "price_spawner" },
    { 0xFDEE90AC, "price_spawners" },
    { 0xA38B0EF2, "price_sticky_target_time" },
    { 0x5EB0FB38, "price_stop_idle" },
    { 0xECCEB14D, "price_stops_thinking" },
    { 0x92FB18BA, "price_swap" },
    { 0x3A2783CC, "price_talks" },
    { 0x18E8B2BF, "price_talks_as_he_is_picked_up" },
    { 0x4AA56411, "price_talks_if_enemies_are_near" },
    { 0x95FC1617, "price_talks_if_enemies_get_near" },
    { 0x09F5C71D, "price_talks_if_player_takes_damage" },
    { 0x2E68E23E, "price_talks_to_hq" },
    { 0x691C2DF0, "price_target_guy" },
    { 0x36EABAEC, "price_target_time" },
    { 0x33EBA0F7, "price_targets_guy" },
    { 0x50D3A5A5, "price_teleports" },
    { 0x84357C00, "price_teleports_to_org" },
    { 0x7BBD5F49, "price_teleports_to_player" },
    { 0x88C90A2E, "price_teleports_to_spot" },
    { 0x035EAE75, "price_tells_player_to_come_over" },
    { 0xA6775502, "price_tells_squad_to_flank_right" },
    { 0xDD6D3251, "price_think" },
    { 0xC4620910, "price_thinks_you_are_insane" },
    { 0xB1DEA69A, "price_trace" },
    { 0x80C19C07, "price_turns_left" },
    { 0xAF62CA82, "price_turns_right" },
    { 0x15063DA8, "price_turns_towards_guy" },
    { 0x764A70D0, "price_updates_objective_pos" },
    { 0x98027165, "price_wait_at_stairs" },
    { 0xFA71968D, "price_waits_at_node_and_waves" },
    { 0x80FB05ED, "price_waits_for_enemies_to_walk_past" },
    { 0x39743529, "price_waits_for_enemy_death_or_new_enemy" },
    { 0x26141E02, "price_wants_apartment_cleared" },
    { 0xD93B052D, "price_warning" },
    { 0x890D5C23, "price_was_hit_by_heli" },
    { 0x34FB8CB4, "price_watches" },
    { 0xC7ED6BD0, "price_wounded_logic" },
    { 0x6E80CB2E, "price_wounding_kill_trigger" },
    { 0x7A713ED7, "pricecigardelete" },
    { 0xD7B3DD83, "pricecigarexhalefx" },
    { 0x70719065, "pricecigarpufffx" },
    { 0xC8F74E9F, "pricecopy" },
    { 0xF32D4B18, "pricedist" },
    { 0x334341FC, "pricedummy" },
    { 0x3455FFC0, "priceguys" },
    { 0xD27C7D4C, "priceindex" },
    { 0xFBA9F1EE, "priceinit" },
    { 0x37C3599C, "pricenode" },
    { 0x9F5712A2, "priceorg" },
    { 0xE0D973B9, "pricerpgdialog" },
    { 0x24016033, "prices" },
    { 0x80DDB8DC, "pricestart" },
    { 0xC400C807, "pried" },
    { 0xD4633AC5, "primaries" },
    { 0xEC008070, "primarily" },
    { 0x43C330DD, "primary" },
    { 0x907788C7, "primary acquired" },
    { 0xDFB9CC32, "primary_ai_switchtarget" },
    { 0x0CBE7357, "primary_alarm" },
    { 0x175A80F7, "primary_attachment" },
    { 0x049BE628, "primary_attachment_flag" },
    { 0x2B44C572, "primary_attachment_mask" },
    { 0x5EE1D415, "primary_attachment_ref" },
    { 0xAC1C402A, "primary_attachment_set" },
    { 0xECA008B8, "primary_category" },
    { 0x33959F17, "primary_category_total" },
    { 0x8DA04ABA, "primary_grenade" },
    { 0x19754716, "primary_grenade_count" },
    { 0x682C3C1E, "primary_gun" },
    { 0xE7D88B93, "primary_msg" },
    { 0x0C220D70, "primary_num" },
    { 0x447E9E2F, "primary_obj" },
    { 0xF62CEE3E, "primary_pos" },
    { 0x90113D77, "primary_ref" },
    { 0x6CC854ED, "primary_spot_light" },
    { 0xECD5AF4C, "primary_weapon" },
    { 0x52952FFB, "primary_weapon_alts" },
    { 0x247D647E, "primary_weapon_array" },
    { 0x81F6417F, "primary_weapon_attachments" },
    { 0xD6EAE42F, "primary_weapon_pos" },
    { 0x26E6A9A5, "primary_weapon_pos_array" },
    { 0x337FF1CF, "primary_weapons" },
    { 0xDC42646C, "primary_weapons_2" },
    { 0x383B61DB, "primary_weapons_returned" },
    { 0xF67834F6, "primary_weapons_that_can_be_taken" },
    { 0x02DBC495, "primary_weapons_to_take" },
    { 0x0CCE8DD7, "primaryattachmentsallowed" },
    { 0x49C719B1, "primaryattachmentstotal" },
    { 0x78B72D22, "primarybuttonpressedlocal" },
    { 0xAA0EABA3, "primarycamoindex" },
    { 0x4B76A28A, "primarydeltaanim" },
    { 0x36A0E73E, "primarydeltaanimlength" },
    { 0x7136EC77, "primaryenemy" },
    { 0x8FA696D2, "primaryflags" },
    { 0xD2A98EBD, "primarygrenade" },
    { 0xFADE74E2, "primarygrenadecount" },
    { 0x1974E800, "primarygrenaderef" },
    { 0xC8156F0F, "primaryindex" },
    { 0x367EA154, "primaryloadoutaltweapon" },
    { 0x5AB868C9, "primaryloadoutgunsmithvariantindex" },
    { 0x3EC4EAAF, "primaryloadoutweapon" },
    { 0xBE3C63A7, "primaryoffhand" },
    { 0x4D474C14, "primaryoffhandcount" },
    { 0xEDA0D83A, "primaryoffhandname" },
    { 0x799B4CD3, "primaryprogressbarfontsize" },
    { 0x76F2DA86, "primaryprogressbarheight" },
    { 0x96814F47, "primaryprogressbarheight_ss" },
    { 0xE5041BD6, "primaryprogressbartextx" },
    { 0x8CF56A97, "primaryprogressbartextx_ss" },
    { 0x0B06963F, "primaryprogressbartexty" },
    { 0x271FA9D4, "primaryprogressbartexty_ss" },
    { 0x96A7EEED, "primaryprogressbarwidth" },
    { 0xE63A55A5, "primaryprogressbarx" },
    { 0xBAE86E02, "primaryprogressbarx_ss" },
    { 0xC037DB3C, "primaryprogressbary" },
    { 0xF0AA5B7D, "primaryprogressbary_ss" },
    { 0x7B9C4296, "primarytarget" },
    { 0x847D0E6F, "primarytokens" },
    { 0x466F7BAC, "primaryturretanim" },
    { 0x03AE58DD, "primaryweapon" },
    { 0x6CFDE6EF, "primaryweapon_accuracy" },
    { 0x1DB5A41D, "primaryweapon_fightdist_max" },
    { 0xA45499CD, "primaryweapon_fightdist_maxsq" },
    { 0x5B19AF33, "primaryweapon_fightdist_min" },
    { 0x27C75C7F, "primaryweapon_fightdist_minsq" },
    { 0x34D26C37, "primaryweaponattachstr" },
    { 0xDD21FD03, "primaryweaponclass" },
    { 0xBF3E36ED, "primaryweaponkill" },
    { 0xF8601E24, "primaryweaponname" },
    { 0xD5C933B7, "primaryweaponnum" },
    { 0x33C03031, "primaryweaponoptions" },
    { 0xD646CE1C, "primaryweapons" },
    { 0x86166A51, "primaryweight" },
    { 0x24ECE486, "prime" },
    { 0x2222CD4F, "prime_movie" },
    { 0xFF44F5B6, "primed" },
    { 0xBC2BFF80, "primed_beartrap_explode" },
    { 0x04E7331F, "primed_func" },
    { 0x3636769E, "primemovie" },
    { 0x6C6C004C, "primerily" },
    { 0x3BACC93F, "priming" },
    { 0x21BD7BCC, "primitive" },
    { 0xFC66DF4F, "primitives" },
    { 0xBF282C33, "primlightfrac" },
    { 0x3EBF3874, "princess" },
    { 0xB59B9349, "pring" },
    { 0x3BC5B442, "print" },
    { 0x8F3E0F73, "print3d" },
    { 0x9268A7FE, "print3d_at_pos" },
    { 0x9A032305, "print3d_breadcrumb" },
    { 0xF59282D5, "print3d_ent" },
    { 0x8F1D1749, "print3d_group_sight" },
    { 0x9D2866AB, "print3d_on_ent" },
    { 0x934BF4A4, "print3d_ran_already" },
    { 0x0DDDD081, "print3d_time" },
    { 0x272DF3BD, "print3ddraw" },
    { 0x3046595F, "print3dfortime" },
    { 0x433EF2C8, "print3dmessage" },
    { 0xFF5649CF, "print3dpos" },
    { 0xE157098C, "print3drise" },
    { 0x382BC022, "print3ds" },
    { 0x3D25A5B3, "print3dspace" },
    { 0x2B2CFCFF, "print3dthread" },
    { 0x4B9969BC, "print3dthreadzip" },
    { 0x3AB86808, "print3dtime" },
    { 0xF573927D, "print3duntilnotified" },
    { 0xF8D9B82C, "print_3d" },
    { 0x83EAE51A, "print_aliases_to_file" },
    { 0x4885FBBD, "print_ambient_fx_inventory" },
    { 0x62643EB1, "print_angles" },
    { 0xE5745254, "print_boat_controls" },
    { 0x9BC7B128, "print_dds" },
    { 0xCC62F5CF, "print_debug_boat_path" },
    { 0x4EC36599, "print_debug_info" },
    { 0x57FBD212, "print_debug_message" },
    { 0xC0DDE77D, "print_duration" },
    { 0x56FE972C, "print_ent_count" },
    { 0x734F1BA0, "print_entities" },
    { 0x0EEA4AFB, "print_frames" },
    { 0xAB7B8A52, "print_fuel_point" },
    { 0x224AD8F8, "print_fx_options" },
    { 0xF1697C57, "print_health" },
    { 0x0AE797DE, "print_hint" },
    { 0x9C9AE65D, "print_info" },
    { 0xFA285B82, "print_it" },
    { 0x6DD04DEC, "print_killstreak_start_text" },
    { 0x0E38DB36, "print_message" },
    { 0x3B6ACBD1, "print_modelcsv_bykey" },
    { 0xB5DA12F1, "print_modellist_bykey" },
    { 0xC9C22774, "print_msg" },
    { 0xDAC9DE6F, "print_my_position" },
    { 0x7C0E73E1, "print_notetracks" },
    { 0x6FB3472D, "print_number_respawners" },
    { 0x7D09CB88, "print_on_ent" },
    { 0xE1F2A925, "print_org" },
    { 0xFF3A5ECF, "print_origin" },
    { 0x7253752C, "print_origin_pos" },
    { 0x4B2C3E14, "print_out_end_location_of_animation" },
    { 0x741CF065, "print_passerby_timing" },
    { 0xCA8FE3F8, "print_position" },
    { 0xED1B830D, "print_powerup_drop" },
    { 0x0EDBE139, "print_results" },
    { 0x3A42E698, "print_resume_speed" },
    { 0xD807A741, "print_resumespeed" },
    { 0x95A92A5C, "print_run_speed" },
    { 0xFA003DD1, "print_script_origin" },
    { 0xBA9E40B0, "print_speed_in_mph" },
    { 0xBDDBBDB8, "print_tag_pos" },
    { 0x81546E24, "print_targetname_when_triggered" },
    { 0xE583F374, "print_text" },
    { 0xF3D4C14F, "print_text_on_screen" },
    { 0x40053E1C, "print_this_" },
    { 0x0F4BE7D3, "print_trap_guy_overhead" },
    { 0x142688A5, "print_weapon_name" },
    { 0x7F7BF972, "print_what_killed_me" },
    { 0x894D4B0D, "print_when_firing" },
    { 0x16345BE7, "print_who_i_am_on_my_eye" },
    { 0x102D693A, "print_zombie_counts" },
    { 0xBF71A86E, "printable" },
    { 0xF5BFBEF7, "printabovehead" },
    { 0x23BA5D5E, "printandsoundoneveryone" },
    { 0xF5463828, "printanimdebugln" },
    { 0x28B86CF2, "printarg" },
    { 0xE42CE187, "printboldonteam" },
    { 0xA5C1053D, "printboldonteamarg" },
    { 0x478AB89B, "printcolor" },
    { 0xE7874AAD, "printcurspeed" },
    { 0x260C46E3, "printdebug" },
    { 0x99CDD6E6, "printdebugtext" },
    { 0x6C26F1CA, "printdebugtextproc" },
    { 0xB794957F, "printdisplaceinfo" },
    { 0xF4670F55, "printed" },
    { 0x80BBFA5C, "printedmodel" },
    { 0x56DD2CFE, "printenemy" },
    { 0x0889C113, "printer" },
    { 0x3F2B479E, "printerdebugger" },
    { 0xD5594888, "printeyeoffsetfromnode" },
    { 0xDF8ADD00, "printfakerpm" },
    { 0x1A48C4EB, "printfriendly" },
    { 0x1ACB4FFE, "printgrenadetimers" },
    { 0xE058A0A4, "printhashids" },
    { 0x94FC492C, "printhealth" },
    { 0x6227A919, "printhealthdebug" },
    { 0xF76A2779, "printhint2" },
    { 0xB215AAAE, "printindex" },
    { 0x1D5967AE, "printing" },
    { 0xF3F3B431, "printkillstreakstarttext" },
    { 0x00895B00, "println" },
    { 0xEB573E2B, "printlns" },
    { 0x328549E2, "printload" },
    { 0x9DDE8ADA, "printlongdeathdebugtext" },
    { 0x1F340097, "printloops" },
    { 0xEFB63B0D, "printmaperrors" },
    { 0xEF0940CF, "printname" },
    { 0xACCF4EB2, "printoffsets" },
    { 0xF8E95485, "printonplayers" },
    { 0xEA1242AA, "printonteam" },
    { 0x1C744A6A, "printonteamarg" },
    { 0x5A4887A5, "printpassengeranim" },
    { 0x67BC5A74, "printpos" },
    { 0x030190D1, "printqueueevent" },
    { 0x0A00E874, "printright" },
    { 0x9322BB8D, "prints" },
    { 0x9201841F, "printshoot" },
    { 0x2BC5F633, "printshootproc" },
    { 0xDB1C1821, "printslowmo" },
    { 0x6DBDDE54, "printspeech" },
    { 0xEF2885E5, "printstring" },
    { 0x48B7F63F, "printtext" },
    { 0xC66EA29F, "printtextstop" },
    { 0x96C58E6E, "printthrottle" },
    { 0xFE8B92FD, "printtime" },
    { 0xD0EAF029, "printtoprightln" },
    { 0xCCA0DB2D, "printtrackertoblackbox" },
    { 0x65F3C008, "printturnanim" },
    { 0x0F077EF1, "printup" },
    { 0x570EE047, "printvector" },
    { 0x3EB3B19F, "printweaponname" },
    { 0xC2642C1A, "printyaws" },
    { 0xCB77502C, "printyawtoenemy" },
    { 0x2D4D4032, "prio_index" },
    { 0xA7D9E95B, "prio_key" },
    { 0x9E6BF8E3, "prior" },
    { 0x56CE10B0, "priorites" },
    { 0x5F22B61D, "priorities" },
    { 0x8F9B9A64, "prioritization" },
    { 0x09460ED2, "prioritize" },
    { 0xD9D21895, "prioritize_colorcoded_nodes" },
    { 0x938EB812, "prioritized" },
    { 0xF2ADC383, "prioritizing" },
    { 0x61690ED5, "priority" },
    { 0x23E53791, "priority_board_bar_selection" },
    { 0x06D28908, "priority_dialog" },
    { 0x394CA8C5, "priority_dialog_ally" },
    { 0x739A9671, "priority_dialog_enemy" },
    { 0x4B7CDBBC, "priority_high" },
    { 0xBD00AB05, "priority_item" },
    { 0x60FB38CE, "priority_low" },
    { 0xD900D781, "priority_normal" },
    { 0x7C88CE2C, "priority_sort" },
    { 0x34017727, "priority_spawners" },
    { 0x4120A353, "priority_target" },
    { 0x067CBE21, "priority_target_array" },
    { 0x2D1F2EB8, "priority_target_death" },
    { 0x0B699B07, "priority_urgent" },
    { 0x94041024, "priorityeventcompfunc" },
    { 0x7B46F265, "prioritykeys" },
    { 0x4B18CD4E, "priorplayerhealth" },
    { 0xB7DDBD5A, "priorvalue" },
    { 0x54EFFB92, "prisoener" },
    { 0x41004B9D, "prisoeners" },
    { 0x19EE07C8, "prison" },
    { 0xE1B4672A, "prison_acid_trap_used" },
    { 0x02A6F22E, "prison_barge_event_start" },
    { 0x7AB0FE40, "prison_brutus_killed" },
    { 0x975ED844, "prison_door_controls" },
    { 0x18DBA09E, "prison_door_position_think" },
    { 0x1C659105, "prison_ee_bad_ending" },
    { 0x1E2B8E77, "prison_ee_good_ending" },
    { 0xADAC3042, "prison_ee_spoon_acquired" },
    { 0x5BFCB588, "prison_fan_trap_used" },
    { 0x75EDE425, "prison_open_craftablestub_update_prompt" },
    { 0xE7D19BBA, "prison_plane_update_prompt" },
    { 0x9AFA724B, "prison_script_think" },
    { 0x3A475028, "prison_sniper_tower_used" },
    { 0x04616E24, "prison_tomahawk_acquired" },
    { 0xB0729A5D, "prison_tv" },
    { 0x70C6FF59, "prison_tv_lcd" },
    { 0xF6BEA23D, "prisoner" },
    { 0x6B5F9E89, "prisoner_1" },
    { 0x47E0AA1A, "prisoner_dead" },
    { 0x98FE3F83, "prisoner_firstfloor_moveup" },
    { 0x565C9716, "prisoner_guard_think" },
    { 0xCFFCF867, "prisoner_head_index" },
    { 0xFB9E0F83, "prisoner_left" },
    { 0x6AA4F8A7, "prisoner_model" },
    { 0xD9D4E376, "prisoner_right" },
    { 0x584BB5FC, "prisoners" },
    { 0xBF3DCBF5, "pristine" },
    { 0x2E8D96E7, "pristine_state" },
    { 0x95104A2E, "pristine_targetname" },
    { 0xB9F85D7E, "private" },
    { 0x30E95E82, "privilege" },
    { 0x1BBA5D3F, "prize" },
    { 0x14C42408, "prize_models" },
    { 0x8F7B5A9A, "prize_spawner" },
    { 0xA173EFE3, "prizepoint" },
    { 0x6617C2D2, "pro" },
    { 0xFE196489, "pro_00" },
    { 0xD816EA20, "pro_01" },
    { 0x00C7B71F, "pro_01_render" },
    { 0x4A1E595B, "pro_02" },
    { 0x3C0ADD02, "pro_02_render" },
    { 0x95B98673, "pro_02b" },
    { 0xD41CB4AA, "pro_02b_render" },
    { 0x241BDEF2, "pro_03" },
    { 0x4834715D, "pro_03_render" },
    { 0x96234E2D, "pro_04" },
    { 0x54E9B146, "pro_cost" },
    { 0x256B70F1, "pro_tip_death_card_round" },
    { 0x68701BDC, "pro_tips_initialize" },
    { 0xBA144DAE, "pro_tips_start_time" },
    { 0xFDB208E4, "prob" },
    { 0xFA708EBE, "probabilities" },
    { 0xA269268E, "probability" },
    { 0xB4B3A377, "probability_skipped" },
    { 0x97D21E9C, "probability_value" },
    { 0xC0F395FC, "probable" },
    { 0x98AE3280, "probably" },
    { 0x0BF7393B, "probation" },
    { 0xAEDF80EB, "probe_model" },
    { 0xD7AA59F8, "probes" },
    { 0xBCE25242, "problem" },
    { 0xD32F758D, "problems" },
    { 0x23B4834D, "proc" },
    { 0x461BB45B, "proccess" },
    { 0xF51728C4, "procedural" },
    { 0xD969C961, "procedurally" },
    { 0xB353E0FC, "procedure" },
    { 0xFB84DE1D, "proceed" },
    { 0xC4E3F332, "proceed_to_vents" },
    { 0x65498484, "proceed_trigger" },
    { 0x893B70CA, "proceeded" },
    { 0x1025D80B, "proceeding" },
    { 0x3E37C65C, "proceeds" },
    { 0xA90004F4, "procent" },
    { 0xEA1D1460, "procentscontainer" },
    { 0x3E726154, "process" },
    { 0xE749087E, "process_assist" },
    { 0x7AD968EA, "process_audience_structs" },
    { 0x28E07853, "process_button_held_and_clicked" },
    { 0x88055051, "process_challenge_asd_rundown" },
    { 0x6B152D87, "process_challenge_explosive_car_kills" },
    { 0x2AEAEA28, "process_challenge_explosive_kills" },
    { 0x8232CE96, "process_challenge_headshots" },
    { 0xCE5357A4, "process_challenge_kill_claws" },
    { 0x87F67BE9, "process_challenge_kill_ied_planter" },
    { 0x0C642C83, "process_challenge_kill_riders" },
    { 0x82C4E2C5, "process_challenge_kills_as_chloe" },
    { 0x7ECC719B, "process_challenge_kills_as_claw" },
    { 0x2404BD95, "process_challenge_melee_kills" },
    { 0x112B9742, "process_challenge_quad_kills" },
    { 0xB522E40A, "process_challenge_sentry_kills" },
    { 0x65C9D1CF, "process_challenge_stun_kills" },
    { 0x3AC0BEE0, "process_challenge_vtol_kills" },
    { 0xC27B6E13, "process_character_body_item_extracam_request" },
    { 0x8131D674, "process_character_extracam" },
    { 0xBC334E1A, "process_character_extracam_request" },
    { 0x7639CBC1, "process_character_head_item_extracam_request" },
    { 0xB345C4D8, "process_character_helmet_item_extracam_request" },
    { 0x3D3D6824, "process_color_order_to_ai" },
    { 0x8CBCAAA5, "process_contracts_on_add_stat" },
    { 0x31E3B27B, "process_cover_node" },
    { 0x2A35E131, "process_cover_node_with_last_in_mind_allies" },
    { 0x65439558, "process_cover_node_with_last_in_mind_axis" },
    { 0x5C4B8768, "process_current_hero_headshot_extracam_request" },
    { 0xBE3BADD8, "process_deathflags" },
    { 0xA99FB6C9, "process_event" },
    { 0x22340213, "process_event_aipath" },
    { 0x8E7F4074, "process_friendly_fire_callbacks" },
    { 0xD33DFD45, "process_fx_rotater" },
    { 0x2985FDD0, "process_gem_shooting" },
    { 0x11EA21AA, "process_globe_glow" },
    { 0x34D8F8A5, "process_hint_trigger_message" },
    { 0xBFE18D92, "process_killstreak_assist_score" },
    { 0xCDC26129, "process_lobby_client_character_extracam_request" },
    { 0x87181B04, "process_magic_box_zbarrier_state" },
    { 0x25AA300B, "process_outfit_preview_extracam_request" },
    { 0x8B443F5C, "process_pap_zbarrier_state" },
    { 0x103AD145, "process_path_node" },
    { 0x70A93F70, "process_pending_gpr_sets" },
    { 0xC5123BCF, "process_perk_random_machine_state" },
    { 0xADB1D857, "process_queue_packet" },
    { 0x0440D9E1, "process_rusher_spawner" },
    { 0x45E4B97E, "process_siegebot_kill" },
    { 0xF0BAA16B, "process_stop_short_of_node" },
    { 0x856425FB, "process_vehicles_spawned" },
    { 0x72F112A4, "process_wc_icon_extracam_" },
    { 0x382E8168, "process_wc_paintjobicon_extracam_request" },
    { 0xEFE1CCDE, "process_wc_varianticon_extracam_request" },
    { 0x43256951, "processassist" },
    { 0x03BD5527, "processchallenge" },
    { 0x5A2B41F8, "processchallengebit" },
    { 0x8D2F662F, "processclientfieldsasifnew" },
    { 0x3722ECC9, "processclonescoreevent" },
    { 0x0E3B8E45, "processcontracts" },
    { 0x435D9261, "processcontractsonaddstat" },
    { 0x157D657A, "processcopterassist" },
    { 0x18C2A6F7, "processed" },
    { 0x3017D522, "processed_" },
    { 0xE83CFABF, "processed_count" },
    { 0x2E5516FA, "processed_trigger" },
    { 0x628B1B0E, "processedbundles" },
    { 0x0720AEB1, "processedtrigger" },
    { 0xAE89A788, "processes" },
    { 0xF1986074, "processfaceevents" },
    { 0x1BE904D7, "processgamestats" },
    { 0x3819FB94, "processing" },
    { 0xDBE9DE24, "processinterrupteddeath" },
    { 0x61ACEC8B, "processkillschallengeforweapon" },
    { 0x3D0F3512, "processkillstreakassists" },
    { 0x541C0245, "processkillstreakchallenge" },
    { 0x460E3EED, "processlimit" },
    { 0x1A81A220, "processlimit_" },
    { 0x1D3A50DD, "processmedal" },
    { 0x32DE8AB3, "processor" },
    { 0x0C909162, "processors" },
    { 0x4C970571, "processplayerevent" },
    { 0xEA11CFD6, "processscoreevent" },
    { 0x1E129E72, "processshieldassist" },
    { 0x237BD34A, "processspecialistchallenge" },
    { 0xF0900AE5, "processteamevent" },
    { 0xADE6268C, "processtourchallenges" },
    { 0xAA8AE540, "processtrigger" },
    { 0xCA86AC6B, "processtriggers" },
    { 0xB1AD1412, "prod" },
    { 0xC6BC03AD, "produced" },
    { 0xB4DC3B02, "produces" },
    { 0xE91238DA, "product" },
    { 0x67AA3B40, "production" },
    { 0x09099FA1, "production_build" },
    { 0xE7E167E2, "prof_begin" },
    { 0x10EE09B6, "prof_end" },
    { 0x9488ACD8, "professional" },
    { 0xCEF73E37, "profiing" },
    { 0x52CC9540, "profile" },
    { 0x1BA58CE5, "profiledebug" },
    { 0xBEF6A4E6, "profilelog_begintiming" },
    { 0x506BA7EA, "profilelog_endtiming" },
    { 0x1779A3B3, "profileloggedin" },
    { 0x5C50A588, "profilestop" },
    { 0x38E0FDC1, "profiling" },
    { 0x21BEAD17, "profit" },
    { 0x5988FA6B, "profs" },
    { 0x8BAA99A9, "prog" },
    { 0xE1CCCAC2, "progession" },
    { 0xAFF105B3, "program" },
    { 0xD7CC1776, "programatically" },
    { 0x71D04B68, "programed" },
    { 0x727A5ECF, "programmed" },
    { 0x8295831C, "programming" },
    { 0x49DAE770, "progress" },
    { 0xDFA808A2, "progress2nextbonus_disconnect_threat" },
    { 0xE4099F06, "progress_bar" },
    { 0xFDC4B79F, "progress_bar_ended" },
    { 0xA77E1F00, "progress_bar_text" },
    { 0x862FDD26, "progress_to_next_state" },
    { 0x0FE7C7A5, "progress_width" },
    { 0x23123D5F, "progressbar" },
    { 0x90A79303, "progressed" },
    { 0x16D1B3FC, "progresses" },
    { 0xBEB2EC8C, "progressinc" },
    { 0x26A902E8, "progressing" },
    { 0xF6597AA2, "progression" },
    { 0x989F61BE, "progressive_damaged" },
    { 0x7BD503CF, "progressively" },
    { 0x95F6C4E5, "progresstext" },
    { 0x131F3D10, "progvalue" },
    { 0xE30CE88F, "prohibits" },
    { 0x2DC5DC2C, "proj" },
    { 0x7BE6B610, "proj_explosion_sound" },
    { 0xEC092063, "proj_loc" },
    { 0x644FE094, "proj_speed" },
    { 0x7BD96E0C, "projangles" },
    { 0x2DBB1104, "project" },
    { 0x95186518, "project3dto2d" },
    { 0xA6FFC367, "projected" },
    { 0xA72CA1B7, "projected_distance" },
    { 0x68B3B8B3, "projected_grid_radius" },
    { 0x1D5A282E, "projected_pip_radius" },
    { 0x05E61388, "projected_point" },
    { 0x23188B81, "projecter" },
    { 0x148FB98C, "projectile" },
    { 0x99EE789E, "projectile_abort_think" },
    { 0x0367FF48, "projectile_cam" },
    { 0x652745EA, "projectile_death_think" },
    { 0x5C932767, "projectile_delete_think" },
    { 0x7E5527E4, "projectile_find_random_player" },
    { 0xFA451BD2, "projectile_find_target" },
    { 0x4E3960BF, "projectile_find_target_killstreak" },
    { 0xAF935C3E, "projectile_find_target_player" },
    { 0x806AB3B7, "projectile_fired_at_bp1btr" },
    { 0x270202C6, "projectile_fired_at_btr" },
    { 0x0FA213E6, "projectile_fired_at_tank" },
    { 0xC8A5E382, "projectile_goal_move" },
    { 0x76D29A19, "projectile_impact" },
    { 0x39699ECB, "projectile_impact_explode" },
    { 0x77B05B49, "projectile_move_think" },
    { 0xDCA338F4, "projectile_spawn" },
    { 0x98093641, "projectile_spawn_utility" },
    { 0xA81B38B4, "projectile_speed" },
    { 0x69193977, "projectile_target_search" },
    { 0x24D263DD, "projectiledistance" },
    { 0x463884DB, "projectileexplode" },
    { 0x22D1ABA3, "projectilemodel" },
    { 0xFC20E00F, "projectiles" },
    { 0x95EF3F36, "projectiles_should_ignore_world_pause" },
    { 0xFF3B63BD, "projectilespeed" },
    { 0x7C6638D4, "projectilespeedforward" },
    { 0xC9455A9E, "projectilespeedrelativeup" },
    { 0x0EFE31CE, "projectilespeedup" },
    { 0x86ADD0C8, "projectiletrail" },
    { 0x73A43CE2, "projectilewhizbydistancecheck" },
    { 0xFB3416AE, "projection" },
    { 0xDA8645D1, "projections" },
    { 0x816AF443, "projector" },
    { 0x1295DB7A, "projector_ang" },
    { 0x0C849C25, "projector_forward" },
    { 0x4C75814E, "projector_reel_change_init" },
    { 0x66ACA41C, "projector_reel_swap" },
    { 0xC27E0DAB, "projector_room" },
    { 0x65E53362, "projector_screen" },
    { 0xD0AFE567, "projector_screen_fx" },
    { 0x3C94EADD, "projector_struct" },
    { 0xD80866DE, "projector_trigger" },
    { 0xE86AAF25, "projector_up" },
    { 0x92BCF7B7, "projects" },
    { 0x942DD184, "projeted" },
    { 0x4877B9AE, "projexplosionsound" },
    { 0x0FA7D969, "projexplosiontype" },
    { 0xAB3C96F5, "projposition" },
    { 0x3960452B, "projsmokeendsound" },
    { 0x1377FBB6, "projsmokeloopsound" },
    { 0x5BB4D1FA, "projsmokestartsound" },
    { 0xB2CF28C4, "projtype" },
    { 0x8B04603C, "projx" },
    { 0x4E8C9E44, "prolog" },
    { 0x51242CAE, "prologue" },
    { 0x8C4A4B92, "prologue_anim" },
    { 0x0C8BB436, "prologue_net" },
    { 0x5718CCB0, "prolong" },
    { 0x6A9A0428, "prolonging" },
    { 0x07C361C3, "prom" },
    { 0xFC29C604, "promise" },
    { 0x20CAE748, "promised" },
    { 0x8B03E6B7, "promises" },
    { 0xC856F4B1, "promises_vo_end_early" },
    { 0x2AA104AE, "promo" },
    { 0xC3198327, "promote" },
    { 0x3B8FBE22, "promote_nearest_friendly" },
    { 0x9C754585, "promote_nearest_friendly_with_classname" },
    { 0x936ECC26, "promote_to_corpse_model" },
    { 0x75765699, "promote_to_explosive" },
    { 0xF10D7421, "promoted" },
    { 0xBBD5D086, "promoted_cyan_guy_leads_player_to_apartment" },
    { 0x470C1548, "promoteplayer" },
    { 0x977F9C6C, "promotion" },
    { 0xA1899E9F, "prompt" },
    { 0xB24FB8D1, "prompt_and_visibility_func" },
    { 0xFFA39066, "prompt_fn" },
    { 0x2C2CB3D2, "prompt_gate_unlock" },
    { 0x83A614E3, "prompt_player_save_pows" },
    { 0x68388922, "prompt_trigger" },
    { 0xEE0BEDA4, "prompted" },
    { 0x180B7942, "promptly" },
    { 0xB07F8826, "prompts" },
    { 0x3C9BE305, "prone" },
    { 0xE6E805A7, "prone_anim" },
    { 0x2D09A11E, "prone_anims" },
    { 0x10301D09, "prone_back" },
    { 0x031EEF6D, "prone_front" },
    { 0xFCB1D880, "prone_guys" },
    { 0xAFAC257C, "prone_model_swap_monitor" },
    { 0xE3A924E3, "prone_modifier" },
    { 0xA6EA7DBA, "prone_monitor" },
    { 0x2F73B141, "prone_offset" },
    { 0x5A3827C6, "prone_over" },
    { 0xB8D3357E, "prone_till_flag" },
    { 0x03861F53, "prone_time" },
    { 0xB1A7C782, "prone_to_stand_1" },
    { 0x8BA54D19, "prone_to_stand_2" },
    { 0x65A2D2B0, "prone_to_stand_3" },
    { 0xBEB690AF, "prone_triggers" },
    { 0x79AFB499, "prone_under_garage_door_exploit" },
    { 0xEF67C2CC, "pronecombatmainloop" },
    { 0xE37A632D, "pronecombatthread" },
    { 0xAC10991E, "pronecrawl" },
    { 0xE63EE7A5, "pronecrawltoprone" },
    { 0x174A5E9B, "proned" },
    { 0x9092DFB2, "pronehint" },
    { 0x6415D080, "pronelegsstraighttree" },
    { 0xA05E9DAC, "pronerangecombat" },
    { 0x06D0172C, "pronerangesq" },
    { 0xA4B16C5A, "pronereload" },
    { 0x3FA5A095, "proneshootvolley" },
    { 0x9D128F39, "pronestill" },
    { 0x168070A2, "pronetime" },
    { 0x02649AD6, "proneto" },
    { 0x5207DC68, "pronetocrouch" },
    { 0xD09EE517, "pronetocrouchrun" },
    { 0xE4C4ED1B, "pronetocrouchwalk" },
    { 0x7EED58F7, "pronetopronemove" },
    { 0x04ACBB2F, "pronetopronerun" },
    { 0xDBEDE252, "pronetostand" },
    { 0x6A4A4E0D, "pronetostandrun" },
    { 0x53B6A7FD, "pronetostandwalk" },
    { 0x97091414, "proneturningthread" },
    { 0xF02EE8D0, "proning" },
    { 0x88DC8CD5, "proof" },
    { 0xA9DEA446, "prop" },
    { 0x75576E0B, "prop1" },
    { 0x034FFED0, "prop2" },
    { 0x29527939, "prop3" },
    { 0xE75EDD46, "prop4" },
    { 0x0D6157AF, "prop5" },
    { 0x9B59E874, "prop6" },
    { 0x768C85DE, "prop_and_vehicle_anims" },
    { 0xE5F30CC5, "prop_angles" },
    { 0x098BC195, "prop_anims" },
    { 0x6AAA31BE, "prop_base" },
    { 0xBD159609, "prop_building" },
    { 0x9EDE3300, "prop_buildings" },
    { 0xB213A3FA, "prop_button_pressed" },
    { 0xFE318B84, "prop_buttons" },
    { 0x51C03479, "prop_comms_floor2_blue_idle_chair" },
    { 0xD66A9319, "prop_comms_floor3_green_idle_2_alert_chair" },
    { 0xB90A2071, "prop_comms_floor3_green_idle_chair" },
    { 0xAE24BAE1, "prop_contextual_melee_comms_floor3_green_chair" },
    { 0x79918E62, "prop_copy" },
    { 0xEB07C6D9, "prop_copy_thread" },
    { 0x20C0465C, "prop_delete" },
    { 0xE7346456, "prop_desc" },
    { 0x5B868089, "prop_enter_path" },
    { 0x15829AAD, "prop_exit_path" },
    { 0x12EC7743, "prop_fx" },
    { 0x15AEB31C, "prop_hud" },
    { 0x58B557C6, "prop_jnt_04" },
    { 0x8E62E420, "prop_mode" },
    { 0x7E07FFCA, "prop_mode_hud" },
    { 0xD4004C89, "prop_mode_input" },
    { 0x0115A22B, "prop_mode_thread" },
    { 0xCC52345E, "prop_mortar" },
    { 0xB54F07F8, "prop_mortar_ammunition" },
    { 0xFF00B23A, "prop_move" },
    { 0xBF49C641, "prop_move_thread" },
    { 0x4547EA4C, "prop_name" },
    { 0x1E31433B, "prop_origin" },
    { 0xA6180AA2, "prop_raise_amount" },
    { 0xBEEEF942, "prop_rock" },
    { 0x6AB83BD0, "prop_to_match" },
    { 0xD744CD0C, "propactive" },
    { 0x3C2D27EB, "propagating" },
    { 0x9B9E6290, "propane" },
    { 0x0B134EE9, "propanetank1" },
    { 0x3115C952, "propanetank2" },
    { 0x571843BB, "propanetank3" },
    { 0x9F000106, "propbuytrigger" },
    { 0xB1F5F25F, "propdamagetrig" },
    { 0x1522BDD8, "propeler" },
    { 0xECCDEC8D, "propellants" },
    { 0x1A53A404, "propelled" },
    { 0x2E7655C2, "propeller" },
    { 0x0EAD4D99, "propeller_death_trig_logic" },
    { 0xE17EACC0, "propeller_death_trig_setup" },
    { 0x98FF13BE, "propeller_killed" },
    { 0x1F30F80D, "propellers" },
    { 0x043F83CF, "proper" },
    { 0xE30DD39B, "proper_position" },
    { 0xC10EA934, "proper_tree_sniper" },
    { 0x66980C5E, "properkcallbacks" },
    { 0xBFB8EFC5, "properkkills" },
    { 0x58D38A56, "properkmelee" },
    { 0x9CF8055D, "properkmeleetimedout" },
    { 0xED517292, "properly" },
    { 0xFE965CC2, "propername" },
    { 0xC67BA189, "propert" },
    { 0xBA3361F2, "properties" },
    { 0x669B159A, "property" },
    { 0x4A8EBE03, "propfxid" },
    { 0xF15AF98B, "propname" },
    { 0xC3B043EA, "propnames" },
    { 0x792CEF38, "proportioned" },
    { 0x407A2833, "propper" },
    { 0xA8B3DEF9, "props" },
    { 0xDD39BF8B, "props_array" },
    { 0x05B009D8, "props_berlin" },
    { 0xC73FF7C9, "props_running" },
    { 0x5268891E, "props_spawned" },
    { 0x83DC29DD, "pros" },
    { 0xC7CC6306, "prosthetic_endgame_1" },
    { 0xA1C9E89D, "prosthetic_endgame_2" },
    { 0x7BC76E34, "prosthetic_endgame_3" },
    { 0xC58AED6C, "prosthetic_endgame_array" },
    { 0x66AE908B, "prosthetic_lobby" },
    { 0xDF9A4C61, "protal" },
    { 0x1E59EEBA, "protect" },
    { 0xCA5A86B3, "protect_action" },
    { 0x96ACCF1C, "protect_condition" },
    { 0xEDAC43E7, "protect_convoy" },
    { 0x1A033BFB, "protect_from_dying" },
    { 0x28688345, "protect_gaz" },
    { 0x3BBFD908, "protect_location_1_struct" },
    { 0xC9A69E2C, "protect_location_struct" },
    { 0xE8F09D26, "protect_player" },
    { 0x9DE79602, "protect_progress_complete" },
    { 0x82C9C3DD, "protect_reznov_lines" },
    { 0x9B0CE2A1, "protect_spot" },
    { 0x2449EAB3, "protect_start" },
    { 0xF90012FE, "protect_time" },
    { 0x1DB18796, "protect_update" },
    { 0xD2022CBA, "protectcarrier" },
    { 0x1446A022, "protectdest" },
    { 0xFA43E74D, "protected" },
    { 0x71E7FB4F, "protected_ent" },
    { 0xB7F96DC1, "protected_entities" },
    { 0x46733276, "protecting" },
    { 0x708489B4, "protecting_obj" },
    { 0xB5FC03A0, "protection" },
    { 0xDE23EFE4, "protection_on_fly_in" },
    { 0xF799A56F, "protectlocation" },
    { 0x5C659421, "protectobj" },
    { 0x001C79F9, "protector" },
    { 0xB5A5ABF4, "protector_leader_logic" },
    { 0xAB19824F, "protector_obj_group" },
    { 0x53A4ED30, "protectors" },
    { 0xF4A836E4, "protectradius" },
    { 0x3C569535, "protects" },
    { 0x6FE82D66, "protesting" },
    { 0x1E4F0965, "protip" },
    { 0x9541A906, "protip1" },
    { 0x6F3F2E9D, "protip2" },
    { 0x587F667A, "protipwait" },
    { 0xC9D98531, "protocol" },
    { 0xA0DC3098, "protocols" },
    { 0xCA3BA4D9, "prototype" },
    { 0xA1490732, "prototype_eggs" },
    { 0xA562BCB0, "prototype_scout_hp_mod" },
    { 0xB18D6DE3, "prototype_secsystems" },
    { 0xD64055D1, "prototype_wind_effects" },
    { 0x1E834933, "prototype_zone_init" },
    { 0x8C0083DF, "prototyped" },
    { 0xA8B25ACC, "prototyping" },
    { 0x27CF565B, "protracted" },
    { 0x4B21B715, "proud" },
    { 0xB332E31D, "prove" },
    { 0x360D4208, "provide" },
    { 0xC71492BD, "provide_ammo" },
    { 0xEA0BD453, "provide_m72_law_ammo" },
    { 0xEBDF778B, "providecoveringfire" },
    { 0xF6998F1C, "provided" },
    { 0x706F6E23, "provides" },
    { 0x936B7309, "providing" },
    { 0xFCD0B28A, "prowler" },
    { 0xB1BE43F9, "prowlercallback_vehicledamage" },
    { 0xCEE803E9, "prox_detect_radius" },
    { 0xD6254A67, "prox_effect_radius" },
    { 0x3357FC4C, "prox_grenade_test" },
    { 0x6DDFFEB2, "prox_max_spawned" },
    { 0xB9BAD092, "prox_trigger_think" },
    { 0x0754A738, "proxalertdist" },
    { 0x37660F21, "proxbar" },
    { 0xBF383364, "proxbartext" },
    { 0x4DC8393E, "proxcheck" },
    { 0x13B79C6A, "proxdist" },
    { 0xA6D9FCEF, "proxies" },
    { 0x54CFC3A8, "proximity" },
    { 0x0E043557, "proximity_alarm_changed" },
    { 0xD57E9E3F, "proximity_alarm_deployed" },
    { 0x075F4A24, "proximity_alarm_off" },
    { 0xF667DB0E, "proximity_alarm_on" },
    { 0x18A86A12, "proximity_callback" },
    { 0xAF50CDE9, "proximity_cleanup" },
    { 0x71E2F78D, "proximity_deployed" },
    { 0xE35EBAC3, "proximity_detonate" },
    { 0xBDB94467, "proximity_grenade" },
    { 0x6E6513D7, "proximity_grenade_ai_reaction_fx" },
    { 0xEB571939, "proximity_grenade_damage" },
    { 0x5AA333FE, "proximity_grenade_damage_radius" },
    { 0x9A9A3ECD, "proximity_grenade_damage_radius_sq" },
    { 0x5D8A5B72, "proximity_grenade_delete_on_death" },
    { 0x76BAFD37, "proximity_grenade_detonate_think" },
    { 0x82109619, "proximity_grenade_detonation" },
    { 0x3A450678, "proximity_grenade_fx" },
    { 0xAD95AB13, "proximity_grenade_player_effect" },
    { 0xD6B05702, "proximity_grenade_postfx" },
    { 0xED58F67B, "proximity_spawned" },
    { 0x0DE7A52F, "proximity_speed_scalar" },
    { 0x0265F210, "proximityalarmactivate" },
    { 0x1EF0506D, "proximityalarmactivatesound" },
    { 0x253FAB80, "proximityalarmactivationdelay" },
    { 0x14A2AA4F, "proximityalarminnerradius" },
    { 0xC4F5BC31, "proximityalarmloop" },
    { 0x72BCE01E, "proximityalarmouterradius" },
    { 0x88FA2A8B, "proximityalarmweaponobjectdebug" },
    { 0x697EFFF3, "proximityamlarment" },
    { 0xFC72AA73, "proximitychain" },
    { 0x73142787, "proximitychainboltspeed" },
    { 0x72BE2E24, "proximitychaindebug" },
    { 0x3F73A302, "proximitychainent" },
    { 0xB6F7DB3A, "proximitychaingraceperiod" },
    { 0x21FBC122, "proximitychains" },
    { 0x5E3105CD, "proximitydeathwait" },
    { 0x7C4BCF20, "proximitydetonate" },
    { 0xEC0AA577, "proximitydetonation" },
    { 0x328E54F2, "proximitygrenade" },
    { 0xAFC6AC95, "proximitygrenadeactivationtime" },
    { 0x99B6329B, "proximitygrenadeaireactionfx" },
    { 0x873AD709, "proximitygrenadechain" },
    { 0xB94747F6, "proximitygrenadedamageplayer" },
    { 0xD2C37F63, "proximitygrenadedamageradius" },
    { 0x82B84003, "proximitygrenadedamagestart" },
    { 0x7457ABED, "proximitygrenadedetectionradius" },
    { 0xF144A74C, "proximitygrenadedotdamageamount" },
    { 0x8F058CF6, "proximitygrenadedotdamageamounthardcore" },
    { 0x5A9E5E30, "proximitygrenadedotdamageinstances" },
    { 0x3FD1A7E3, "proximitygrenadedotdamagetime" },
    { 0x6291BBDE, "proximitygrenadeduration" },
    { 0x78343BF6, "proximitygrenadeeffectdebug" },
    { 0x4EA25155, "proximitygrenadegraceperiod" },
    { 0xA0886182, "proximitygrenadehitplayer" },
    { 0x6E311A02, "proximitygrenadeinfo" },
    { 0xD3D291F0, "proximitygrenademaxinstances" },
    { 0x8A40B17F, "proximitygrenadeprotectedtime" },
    { 0xC3255DB7, "proximitysphere" },
    { 0x854E75E1, "proximitytrackingstart" },
    { 0x2FD7A2B9, "proximityweaponobject_activationdelay" },
    { 0xE045E030, "proximityweaponobject_createdamagearea" },
    { 0x4B1DE1E0, "proximityweaponobject_dodetonation" },
    { 0xE6CBF6B9, "proximityweaponobject_isspawnprotected" },
    { 0x1AFFF695, "proximityweaponobject_removespawnprotectondeath" },
    { 0x3648E04E, "proximityweaponobject_spawnprotect" },
    { 0x5117A0DF, "proximityweaponobject_validtriggerentity" },
    { 0x0A57D05B, "proximityweaponobject_waittillframeendanddodetonation" },
    { 0x94230436, "proximityweaponobjectdebug" },
    { 0x8446A762, "proximityweaponobjectdetonation" },
    { 0x830CAAE9, "proximityweaponobjectdetonation_override" },
    { 0xAFB62972, "proxtriggerthink" },
    { 0xFB8B4DBB, "proxy" },
    { 0xB41AE89D, "proxy_player_not_tazered" },
    { 0x3096E783, "proxy_player_tazered" },
    { 0x451875C9, "proxyhackertoolradius" },
    { 0x40D99898, "proxyhackertooltimems" },
    { 0xDCF139AB, "proxyidlefx" },
    { 0x6739C369, "prperties" },
    { 0x72B2553C, "prrint_this_" },
    { 0x6B21AE8F, "prune" },
    { 0xD75963AB, "prvious" },
    { 0x12445E34, "pry" },
    { 0xBDF03019, "pry_open_doors" },
    { 0x9718EB2E, "ps" },
    { 0x00810E63, "ps1_spawn" },
    { 0x445F6591, "ps3" },
    { 0x90115184, "ps3_flipped" },
    { 0x026BC99E, "ps4" },
    { 0xA395941F, "pschrek" },
    { 0x2123133D, "pself" },
    { 0xE9763822, "psetdvar" },
    { 0xA5CF2304, "psoffsettime" },
    { 0xDBC49013, "psotion" },
    { 0x38EEACB0, "psource" },
    { 0xB5578DA4, "psource_activatebutton" },
    { 0xFE8897EF, "psource_create" },
    { 0x12969D36, "psource_delete" },
    { 0xF91C331D, "psource_dump" },
    { 0x42D2E7E2, "psource_editmode" },
    { 0x235CE49E, "psource_editmode_update" },
    { 0x779E2B72, "psource_enable" },
    { 0x5791DBF3, "psource_getcurrentview" },
    { 0x84A83BD9, "psource_getvisible" },
    { 0x224022A3, "psource_handleselectindex" },
    { 0x8EDE8AD6, "psource_help" },
    { 0x5AA9673F, "psource_hud_preview" },
    { 0x5E6A0119, "psource_hudshow" },
    { 0x6FA42166, "psource_image" },
    { 0x717D8042, "psource_image_update" },
    { 0x8831461C, "psource_newview" },
    { 0x5C8F36E4, "psource_refresh" },
    { 0xFFAF1EF8, "psource_select_new" },
    { 0x82836449, "psource_select_next" },
    { 0x8D912069, "psource_select_prev" },
    { 0xDA185950, "psource_select_template" },
    { 0xED4B9B21, "psource_selectindex" },
    { 0x85FDF628, "psource_selectrad" },
    { 0x8C3F223A, "psource_setview" },
    { 0x75DA9A5C, "psource_setvieworgang" },
    { 0x106F61D4, "psource_viewindex" },
    { 0x8CEB4249, "psource_viewmode" },
    { 0xBEA38E0B, "psource_views" },
    { 0xF23108F3, "psource_viewwait" },
    { 0x3BD182E5, "psource_waittill_enable" },
    { 0xC8792E49, "psourceposition" },
    { 0xE9C345BA, "psp" },
    { 0x6F505EAB, "psquad" },
    { 0x4717FDFC, "pssst" },
    { 0x81CD2F5E, "pst" },
    { 0x8E418E6F, "pstfx_world_construction" },
    { 0xEEF38CD8, "pstruct" },
    { 0x4C24C954, "psudo" },
    { 0x42B42902, "psychological" },
    { 0xD90C8721, "pt" },
    { 0x9A0B4BBE, "pt_boat" },
    { 0xA94D07B4, "pt_boat_death_thread" },
    { 0xB62C3B8B, "pt_boat_init" },
    { 0x2244B6DB, "pt_boat_skim_control" },
    { 0x530FC32B, "ptarg" },
    { 0x4D16EF89, "ptasker" },
    { 0x3116F22B, "ptboat" },
    { 0x6E6DE9AB, "ptboat_count" },
    { 0x02F6BCC0, "ptboat_damage_thread" },
    { 0x15EB4854, "ptboat_death_count" },
    { 0xDA8F6979, "ptboat_delete_at_end_of_path" },
    { 0x9F2596D3, "ptboat_destructible_damage_thread" },
    { 0x627481F0, "ptboat_dialogue" },
    { 0x3AA545C8, "ptboat_died" },
    { 0xC9AAB1BB, "ptboat_engine_fx_control" },
    { 0xCC9FC62B, "ptboat_kill_driver" },
    { 0x9A448285, "ptboat_l_to_r" },
    { 0xDEB9F8BD, "ptboat_number" },
    { 0x46EFB23D, "ptboat_old_count" },
    { 0x5AD76282, "ptboat_paths" },
    { 0xB92EE04A, "ptboat_setup_driver" },
    { 0x51879C4B, "ptboat_stage1_damage" },
    { 0x496163AA, "ptboat_stage2_damage" },
    { 0x2E2911A0, "ptboat_test_run" },
    { 0xAF4C76E3, "ptboat_torpedo_watch" },
    { 0x92D951AA, "ptboat_x" },
    { 0x3937420A, "ptboats" },
    { 0x76732B4D, "ptrs41" },
    { 0xFFAC40C6, "ptrs41_zombie" },
    { 0xBC9BBBC8, "pts" },
    { 0xA10391F0, "pts1_say_next_line" },
    { 0x4570C532, "pts_putdown_trigs" },
    { 0x2B7D8B04, "pts_putdown_trigs_create_for_spot" },
    { 0x55EA98F7, "pts_putdown_trigs_remove_for_player" },
    { 0xB4A58AA0, "pts_putdown_trigs_remove_for_spot" },
    { 0x843B6548, "pts_putdown_trigs_springpad_delete_watcher" },
    { 0x533B00A4, "pts_reset_ball" },
    { 0x4438E445, "pts_should_player_create_trigs" },
    { 0x15A7B29C, "pts_should_springpad_create_trigs" },
    { 0x5BBB49AB, "pts_springpad_anim_ball" },
    { 0x541EDEB0, "pts_springpad_fling" },
    { 0xAEAC29FF, "pts_springpad_removed_watcher" },
    { 0xB49BEFF9, "pts_springpad_waittill_removed" },
    { 0x90822927, "pts_watch_springpad_use" },
    { 0x6B0BDA58, "ptt_dial" },
    { 0xA63B1E99, "ptt_dial_handler" },
    { 0xC4F2F172, "ptt_lever" },
    { 0x114A0A12, "ptt_start" },
    { 0x3DA38A8C, "ptt_story_reminder_vox" },
    { 0x43B76DEB, "ptt_story_vox" },
    { 0x9CB2BEAD, "pturret" },
    { 0xB30A0CB8, "pu" },
    { 0x9BE9131A, "pub" },
    { 0x3A319DD6, "pub_bookcase" },
    { 0xBBDAE211, "pub_bookcase_strat" },
    { 0x81AE5AAD, "pub_guys" },
    { 0x9B3AD53C, "pub_retreater_strat" },
    { 0x1028D0BE, "public" },
    { 0x75FF5AB5, "published" },
    { 0x8A220C73, "publisher" },
    { 0x38944B61, "puch" },
    { 0x3C37B185, "puddle_origins" },
    { 0x1276BB4C, "puff" },
    { 0xBFC3A7EE, "puff_the_magic_dragon" },
    { 0x7005D5CF, "puffs" },
    { 0x03F0E73C, "puke" },
    { 0x8813D420, "pull" },
    { 0x4E895E72, "pull_chute" },
    { 0xE30F2DB3, "pull_chute_instruction" },
    { 0xDF1BD927, "pull_down" },
    { 0x3A614A2C, "pull_down_dialogue" },
    { 0xD53A9E58, "pull_down_failed_shot" },
    { 0x050EAACD, "pull_down_guard" },
    { 0xA3EAE77D, "pull_down_player" },
    { 0xDD5894DE, "pull_down_reznov" },
    { 0xCAFFADEC, "pull_down_scale" },
    { 0xF31EAA92, "pull_down_start" },
    { 0x4859A052, "pull_down_success_listener" },
    { 0x1FCC1554, "pull_down_vignette" },
    { 0x0B7716AA, "pull_downer" },
    { 0xA8F0C6D3, "pull_out_sword" },
    { 0x68FBE5BA, "pull_player_off_turret_when_destroyed" },
    { 0x7C49D295, "pull_start" },
    { 0xEC030FB8, "pull_up" },
    { 0xE3AB08E4, "pulldown" },
    { 0xF71E4EB3, "pulled" },
    { 0x5A755F75, "pulled_in_anim" },
    { 0xB9F361C1, "pulled_in_range" },
    { 0xEE018BC1, "pulledout" },
    { 0xD8EA4416, "pulley" },
    { 0x484FC089, "pulleys" },
    { 0x6B22DAB8, "pulling" },
    { 0x0D03EC86, "pullorigin" },
    { 0x17A9A82C, "pullout" },
    { 0x846C4D7F, "pullout_dialog" },
    { 0x72124F17, "pullout_done" },
    { 0x03F3280B, "pulloutanim" },
    { 0x28CE9753, "pullovercount" },
    { 0xDA137B9D, "pulloverwait" },
    { 0xE8781CCB, "pulls" },
    { 0x22A82A99, "pulls_since_last_ray_gun" },
    { 0x5DA290DC, "pulls_since_last_tesla_gun" },
    { 0x5703AD5B, "pulltime" },
    { 0xDEF84817, "pullup" },
    { 0x75BAF0D2, "pullup_weapon" },
    { 0xF7698D88, "pulse" },
    { 0x44FA3A58, "pulse_bounds" },
    { 0xF0FE84DC, "pulse_count" },
    { 0x64A32180, "pulse_damage" },
    { 0x1E878B37, "pulse_duration" },
    { 0x7978681D, "pulse_locations" },
    { 0xD06B0B31, "pulse_loop" },
    { 0xB5A047C7, "pulse_powerup_icon" },
    { 0xDE094864, "pulse_scale_big" },
    { 0x2FED1A5B, "pulse_scale_loop_big" },
    { 0x3FA55EB6, "pulse_scale_loop_normal" },
    { 0x2FFCD23B, "pulse_scale_normal" },
    { 0x3618D2BC, "pulse_sound" },
    { 0x2A533F6A, "pulse_start_big" },
    { 0x276DA620, "pulse_struct" },
    { 0xB29FDBAC, "pulse_time" },
    { 0x6EA440DD, "pulse_time_loop" },
    { 0xBD35E7E2, "pulsealert" },
    { 0xCF7C78F2, "pulsefadevision" },
    { 0xB074CC5C, "pulsemaxradius" },
    { 0x1C0D85F3, "pulseon" },
    { 0x245CAF8B, "pulsepercent" },
    { 0x779F6CEF, "pulsepowerupicon" },
    { 0x0BAEDC2A, "pulseradius" },
    { 0xF7F12BEE, "pulserate" },
    { 0x54BA48A3, "pulses" },
    { 0x446099A4, "pulsesinglebullet" },
    { 0x9003D223, "pulsetime" },
    { 0x8530687B, "pulsetimer" },
    { 0x75416A89, "pulsing" },
    { 0x92CAE19F, "pulsing_hud" },
    { 0x97746893, "pulsing_lights" },
    { 0xAE970107, "pulwar_fx" },
    { 0x2627CFEA, "pulwar_sword_challenge" },
    { 0x8C0577DE, "pulwar_victim_logic" },
    { 0x2EF09DC7, "pump" },
    { 0xA7E81F42, "pump_distance_check" },
    { 0xFB73FE6D, "pump_ent_a" },
    { 0x217678D6, "pump_ent_b" },
    { 0x4778F33F, "pump_ent_c" },
    { 0xB8256C8C, "pumped" },
    { 0x30B54CBE, "pumps" },
    { 0x6190D423, "punch" },
    { 0x9DEA2B61, "punch_cooldown" },
    { 0x717B0B39, "punch_face" },
    { 0x5F42068E, "punch_handle_pain_notetracks" },
    { 0xB1C8BDA6, "punch_into_screens" },
    { 0x6EE22959, "punch_machine" },
    { 0xADA29996, "punch_out_rumble" },
    { 0x81DD881E, "punch_prompt_end" },
    { 0xC5F1748D, "punch_prompt_start" },
    { 0xB3FCBBF5, "punch_sign" },
    { 0xD8BF91D6, "punch_switches" },
    { 0x47F2E49B, "punch_timescale_off" },
    { 0x4C50D527, "punch_timescale_on" },
    { 0x317617AB, "punch_timescale_snapshots" },
    { 0x313DF083, "punch_to_face" },
    { 0x7493CBFE, "punch_trigger" },
    { 0xA5959718, "punched" },
    { 0x4F7F4967, "punches" },
    { 0xED9D66FD, "punching" },
    { 0xEF8964E8, "punck" },
    { 0x745448CE, "punish" },
    { 0xAE77BBDA, "punishable" },
    { 0xC71BF011, "punished" },
    { 0xFED25A3E, "punishment" },
    { 0xF3E79647, "punk_buster" },
    { 0xF9FBB439, "punted" },
    { 0xD4D768FB, "puppet" },
    { 0x3F05CE6F, "puppeteer_hud_goto" },
    { 0x28DC7148, "puppeteer_hud_lookat" },
    { 0x92AD9BB2, "puppeteer_hud_select" },
    { 0x7D295CD7, "puppeteer_hud_shoot" },
    { 0x8F072F9A, "puppets" },
    { 0xFC10B9AA, "pur" },
    { 0x67248E13, "pur_endgamewithkillcam" },
    { 0x71EBB03F, "pur_spawnmessage" },
    { 0x53843970, "purchase" },
    { 0xE9548347, "purchase_bouncing_betties" },
    { 0x067A9A90, "purchase_trigs" },
    { 0xC0E107D4, "purchased" },
    { 0x14B46C72, "purchaser" },
    { 0x720F69F1, "purchasing" },
    { 0xC55EF003, "pure" },
    { 0x4578C42E, "purely" },
    { 0x557D40AA, "purgatory" },
    { 0x6BFD2A7E, "purge" },
    { 0xF75FC361, "purges" },
    { 0xAE52DBAE, "purhudteam" },
    { 0xD5FAA65F, "purple" },
    { 0x3E2B6910, "purple_2_red" },
    { 0x59FF4A28, "purple_2_red_triggers" },
    { 0xDDF43C9A, "purple_guys" },
    { 0x7DC1A939, "purple_redshirt" },
    { 0x3D700652, "purple_respawners" },
    { 0xD255CB7B, "purple_reticle_color_index" },
    { 0x04E0EBA5, "purple_smoke" },
    { 0xFFABEFE6, "purples" },
    { 0x813794E3, "purplesquad" },
    { 0xE654BEF9, "purpose" },
    { 0xF6F1560F, "purposefully" },
    { 0x6E8520A4, "purposely" },
    { 0xBE398C30, "purposes" },
    { 0x518255EC, "purposing" },
    { 0x5E316EB1, "purpurgatorycountelem" },
    { 0x9A027C8E, "pursuing" },
    { 0xEC99C074, "pursuing_tank_tag" },
    { 0x54556CC1, "pursuit" },
    { 0x283CB491, "push" },
    { 0xA2B362F1, "push_barricade" },
    { 0x77808A26, "push_car" },
    { 0xA7DA72F9, "push_car_guys" },
    { 0x29F5D6B9, "push_chasers_forward_as_defend1_develops" },
    { 0x25AB29B7, "push_direction" },
    { 0x63E0EAA4, "push_foliage_trigger" },
    { 0xC3545E51, "push_front" },
    { 0x3A0CEE04, "push_garage_roof_vehicles" },
    { 0xA80298C2, "push_horse_off_logic" },
    { 0x77995A12, "push_idle" },
    { 0x41C3FC3D, "push_interference_trigger" },
    { 0x6DF01977, "push_origin_out" },
    { 0x5A76A173, "push_out_dist" },
    { 0xADF0324F, "push_over_shelf" },
    { 0xB3EF0303, "push_player" },
    { 0x2748CACF, "push_player_downwards" },
    { 0xB6DDCB05, "push_player_off" },
    { 0x32085815, "push_player_towards_point" },
    { 0xF1409F5C, "push_players_standing_in_trigger_volumes" },
    { 0xDB6EDBF2, "push_pos" },
    { 0xC1D18792, "push_score" },
    { 0x479C17C6, "push_technical_trig" },
    { 0xEDFC4746, "push_through_village_part_1" },
    { 0xAE66A707, "push_time" },
    { 0xEB357B7D, "push_trig_on_enter" },
    { 0x1C70322F, "push_vehicles" },
    { 0xA7B5ACF1, "push_vehicles_damage" },
    { 0x3BAFEB75, "push_vel" },
    { 0x6BF32F62, "push_warp_ready" },
    { 0x095B4324, "push_x" },
    { 0x2F5DBD8D, "push_y" },
    { 0x556037F6, "push_z" },
    { 0x023E78BA, "pusha" },
    { 0x217E16B5, "pushable" },
    { 0x1762804B, "pushactors" },
    { 0x37AD6D02, "pushcart_guy01" },
    { 0x11AAF299, "pushcart_guy02" },
    { 0x3BF5E2A4, "pushcart_right_guy" },
    { 0xD973F591, "pushdist" },
    { 0x950EDC3E, "pushed" },
    { 0x1127A458, "pusher" },
    { 0x5B10E658, "pusher_spawn" },
    { 0x6B477F33, "pushers" },
    { 0x372A1EC1, "pushes" },
    { 0x95A7033B, "pushevent" },
    { 0x55A400A5, "pushign" },
    { 0x9BEB7877, "pushing" },
    { 0xECF57974, "pushmenu" },
    { 0x133BE7D0, "pushpathstart" },
    { 0xB4AECD8E, "pushplayer" },
    { 0x5BF852E4, "pushplayerclip" },
    { 0x7E530242, "puss" },
    { 0xD3AD4DA7, "pussy" },
    { 0x92A6E9BB, "pustule" },
    { 0xBBFFA533, "pustuleinfo" },
    { 0x1DEC125A, "pustules" },
    { 0x4815AE7C, "put" },
    { 0x62754A24, "put_actor_in_drivers_seat" },
    { 0x9CFAD120, "put_actor_on_bow_gun" },
    { 0xA14C5A14, "put_ai_on_lvt" },
    { 0x8262F1C9, "put_away_radio" },
    { 0x15287896, "put_away_reznov_gun_lair" },
    { 0x4E6A5A3D, "put_back_reznov_gun_lair" },
    { 0xE8C6C047, "put_bowman_on_bow_gun" },
    { 0xAF61C179, "put_fx_on_truck_wait" },
    { 0x1F6DFB9C, "put_me_down_1" },
    { 0x91756AD7, "put_me_down_2" },
    { 0xCE0CCB02, "put_on_hat" },
    { 0x5C9BE53A, "put_on_oxygen_mask" },
    { 0x75BB3F7A, "put_player_on_aa_gun" },
    { 0x7C9461E7, "put_player_on_rail" },
    { 0xD0C617AA, "put_players_back_on_lander" },
    { 0x5F56393A, "put_players_in_tutorial_mode" },
    { 0x67D73472, "put_players_on_lvt" },
    { 0x52DE2227, "put_reznov_in_spot_8" },
    { 0x9F542DF3, "put_reznov_on_player_controlled_gun" },
    { 0xBF799224, "put_stinger_guy_here" },
    { 0xCEFE5BE1, "put_timed_out_zombies_back_in_queue" },
    { 0x72075060, "put_weapon_back_in_right_hand" },
    { 0x98556002, "putaway" },
    { 0x0B9F8F15, "putaway_done" },
    { 0x4A88D308, "putaway_knife" },
    { 0x223D8C0F, "putaway_knife_2" },
    { 0x4F0B808A, "putbacktime" },
    { 0xA898D3C0, "putdown" },
    { 0xDE0592ED, "putdown_line" },
    { 0xCDE170D9, "putgunaaway" },
    { 0xF6AD9534, "putgunaway" },
    { 0x40C59D9C, "putgunbackinhandonkillanimscript" },
    { 0x2D3C4864, "putguninhand" },
    { 0x2D99ABF7, "putgunontag" },
    { 0x422CBDFA, "putout_fires" },
    { 0xBF2603A3, "putouttime" },
    { 0x48EF5D3F, "puts" },
    { 0xD3246BF8, "putting" },
    { 0x9D7027B5, "putweaponbackinrighthand" },
    { 0xC4DA8C65, "puzzle" },
    { 0xE70C2202, "puzzle_completion_lines" },
    { 0x9717334E, "puzzle_completion_lines_count" },
    { 0x5DE0D079, "puzzle_debug_position" },
    { 0xBFEC48B1, "puzzle_orb_chamber_to_crypt" },
    { 0x7AC77501, "puzzle_orb_follow_path" },
    { 0xCD40EBB0, "puzzle_orb_follow_return_path" },
    { 0x9B31D651, "puzzle_orb_move" },
    { 0x159AAC02, "puzzle_orb_pillar_show" },
    { 0x48F494C9, "puzzle_orb_ready_to_leave" },
    { 0xF77A8774, "puzzles" },
    { 0x25117BF3, "pv" },
    { 0x700296BF, "pvd_melee_done" },
    { 0x218EDD8F, "pvd_melee_interrupted" },
    { 0x6DFD1339, "pvp" },
    { 0x0606FCDD, "pvt" },
    { 0x2D25B04B, "pweapon" },
    { 0xA290BFAA, "pweapons" },
    { 0x165A10A0, "pwn_joyal" },
    { 0x73DD0C73, "pwned" },
    { 0xA3771078, "pwning" },
    { 0x616D1C49, "pwo" },
    { 0x63B0055C, "pwr" },
    { 0x35389D53, "pwtcbt" },
    { 0x41029D7D, "px" },
    { 0xC2F2917B, "pylon" },
    { 0xA074343B, "pyramid" },
    { 0x8BF68B99, "pyramid_death_report" },
    { 0xC456667B, "pyramid_spawn" },
    { 0xF465E055, "pyramid_spawner_reports_death" },
    { 0x8D07924F, "pz" },
    { 0x5993708E, "q" },
    { 0xBE41E00D, "q_rotor_up" },
    { 0x27ADA6E2, "q_shared" },
    { 0x57AE7E4A, "q_time" },
    { 0xF1DAB7E6, "qattached" },
    { 0x0C4A31C2, "qbagofbarrels" },
    { 0x5EE5311B, "qbagofcrates" },
    { 0xBF204909, "qbarrels" },
    { 0x2E57A622, "qbool" },
    { 0xDEDEFC02, "qbreakables" },
    { 0x7B6434A2, "qcrates" },
    { 0x63C70391, "qdestroyedbyjavelin" },
    { 0xC6FAE249, "qdestroyedbyrpg" },
    { 0x7740D296, "qdrotor" },
    { 0xDF835929, "qdrotor_amount" },
    { 0x874AA142, "qdrotor_struct" },
    { 0x0975B32B, "qenable" },
    { 0xAF8449D4, "qerror" },
    { 0x38CC828D, "qfakedeath" },
    { 0xC9AE4F53, "qfalse" },
    { 0x91570814, "qinfov" },
    { 0xA4718D95, "qliferaft" },
    { 0xD1DEADB6, "qoiltank" },
    { 0x3A9A5D53, "qoiltanksmall" },
    { 0x5442385C, "qos" },
    { 0xA3FFACC8, "qr" },
    { 0x1B5154C1, "qr_drones_fly_away" },
    { 0xECE3F946, "qr_drones_move" },
    { 0x03EEA6F5, "qr_drones_move_and_change_team" },
    { 0x1AEE8E22, "qr_ent_angle" },
    { 0x1838714B, "qr_ent_cleanup" },
    { 0x235B15D1, "qr_ent_down" },
    { 0x7F8C9EFE, "qr_ent_either" },
    { 0xAD4D971E, "qr_ent_up" },
    { 0x0D09A9FE, "qr_offset" },
    { 0xADC98B43, "qr_theater_think" },
    { 0xD7B93BB8, "qrate" },
    { 0x083A6827, "qrcode" },
    { 0x66C26E58, "qrdone" },
    { 0x558B7BFE, "qrdrone" },
    { 0x39EBF576, "qrdrone_blowup" },
    { 0x949D36FB, "qrdrone_cleanup" },
    { 0x4CC3C913, "qrdrone_collision" },
    { 0x52AB526B, "qrdrone_crash_accel" },
    { 0xBB4AA25A, "qrdrone_crash_movement" },
    { 0xF0148BD2, "qrdrone_cylinder_influencer_length" },
    { 0x606C5100, "qrdrone_cylinder_influencer_radius" },
    { 0xBF9B5BE8, "qrdrone_cylinder_influencer_score" },
    { 0x8A9734DC, "qrdrone_cylinder_influencer_score_curve" },
    { 0x2763FE4A, "qrdrone_damagewatcher" },
    { 0xCA8E5B29, "qrdrone_death" },
    { 0x4A934307, "qrdrone_delaylaunchdialog" },
    { 0x74EADFEF, "qrdrone_detonatewaiter" },
    { 0xDD4BF4C1, "qrdrone_dialog" },
    { 0x1BDDA36B, "qrdrone_dmg_snd" },
    { 0x6048E392, "qrdrone_endride" },
    { 0x7E259AD3, "qrdrone_exit_button_pressed" },
    { 0xC16309B7, "qrdrone_explode_on_game_end" },
    { 0x4DD5D374, "qrdrone_explode_on_notify" },
    { 0xB24622CF, "qrdrone_fire_for_time" },
    { 0xE4E67334, "qrdrone_fireguns" },
    { 0x807AF09D, "qrdrone_force_destroy" },
    { 0x0B225AFE, "qrdrone_freezebuffer" },
    { 0x757A6D6B, "qrdrone_fx" },
    { 0x375EF550, "qrdrone_fx_blink" },
    { 0x80FD52F0, "qrdrone_fx_death" },
    { 0x837BE95D, "qrdrone_fx_default" },
    { 0x2B8D9EE5, "qrdrone_fx_final_blink" },
    { 0xB8316073, "qrdrone_get_damage_effect" },
    { 0xA7693370, "qrdrone_height" },
    { 0x39273ADA, "qrdrone_in_range" },
    { 0x3A7F625D, "qrdrone_influencer_radius" },
    { 0xCD1A773B, "qrdrone_influencer_score" },
    { 0x228241EF, "qrdrone_influencer_score_curve" },
    { 0x096562B6, "qrdrone_lastdialogtime" },
    { 0x6E6E064E, "qrdrone_leave" },
    { 0xD89767F6, "qrdrone_leave_on_timeout" },
    { 0x102C9FD0, "qrdrone_leave_on_timeout_callback" },
    { 0xBA3AEBD4, "qrdrone_light_fx" },
    { 0xEB517DDA, "qrdrone_max_health" },
    { 0x7D349DDD, "qrdrone_minigun_flash" },
    { 0x200B4E76, "qrdrone_nodeployzones" },
    { 0x4FE20EE8, "qrdrone_play_single_fx_on_tag" },
    { 0xBD2BA602, "qrdrone_playerexit" },
    { 0x6D6AF4D5, "qrdrone_rangecountdown" },
    { 0xDD291787, "qrdrone_ride" },
    { 0x1991F54E, "qrdrone_ridelifeid" },
    { 0x841E8489, "qrdrone_staticfade" },
    { 0xE3295C36, "qrdrone_staticstopondeath" },
    { 0xBFDAC369, "qrdrone_stun" },
    { 0x170356F0, "qrdrone_unlink" },
    { 0x1BC1C4E5, "qrdrone_unlock" },
    { 0xD144F0E3, "qrdrone_update_damage_fx" },
    { 0x4A9DE94F, "qrdrone_vehicle" },
    { 0x710766C1, "qrdrone_vision" },
    { 0xC2477ADC, "qrdrone_watch_distance" },
    { 0xA8258779, "qrdrone_watch_for_exit" },
    { 0x74C0A471, "qrdrone_watchheliproximity" },
    { 0x24F1A6B9, "qrdrone_z_difference" },
    { 0xE2F4B710, "qrdronehackertoolradius" },
    { 0xEF8A0921, "qrdronehackertooltimems" },
    { 0xEBC8EC62, "qrdroneonblowup" },
    { 0x84541E76, "qrdroneondamage" },
    { 0x226A0FE1, "qrdrones" },
    { 0x1879C4AE, "qrf" },
    { 0x64F5B44C, "qrotor_delete" },
    { 0x02B48803, "qrotor_dmg_snd" },
    { 0x879AF766, "qrotor_fire_direction_think" },
    { 0xE0E9339B, "qrotors_dead_think" },
    { 0x487DDE99, "qrtrs" },
    { 0x0C3D6CFB, "qsetgoalpos" },
    { 0xFEB66A64, "qsighttrace" },
    { 0xC544F3D8, "qslower" },
    { 0x880E8B3E, "qt" },
    { 0xD3B09C2E, "qtarpcrate" },
    { 0x6BDF7E07, "qte" },
    { 0xB283DEBD, "qte_duck" },
    { 0x2D02A092, "qtrue" },
    { 0x03E967AB, "qty" },
    { 0x55855F5E, "qtytext" },
    { 0xD6DCD3D0, "quad" },
    { 0xB48B8947, "quad50" },
    { 0x13ACD68F, "quad50_1" },
    { 0xA1A56754, "quad50_2" },
    { 0x07B9F8EA, "quad50_2_aim_at_player" },
    { 0x1CF6C8BA, "quad50_2_end" },
    { 0xAB68F243, "quad50_2_moves" },
    { 0x3B52FAC1, "quad50_2_start" },
    { 0xC7A7E1BD, "quad50_3" },
    { 0x86A8889A, "quad50_3_dead" },
    { 0x530CAEFE, "quad50_3_moves" },
    { 0x6EB03093, "quad50_burst_duration" },
    { 0xBEF6A0A9, "quad50_burst_max_wait" },
    { 0x25CC3D07, "quad50_burst_min_wait" },
    { 0x07028DFC, "quad50_bursts_to_kill" },
    { 0x80B74F0D, "quad50_fires_guns" },
    { 0xCDC06E02, "quad50_rounds_per_burst" },
    { 0xC8E8C69B, "quad50_truck" },
    { 0x06D502A8, "quad_50" },
    { 0x41630D46, "quad_50_before_fuel_depot" },
    { 0x7F6D244D, "quad_attack_player_until_flag" },
    { 0x1DDFF0B9, "quad_bhb_attract_run" },
    { 0x53AECEE1, "quad_bhb_attract_walk" },
    { 0x660329FA, "quad_bhb_horizon_death" },
    { 0xDB45B5D1, "quad_close" },
    { 0x49A05D4F, "quad_crumble_triggers" },
    { 0xDEDCE615, "quad_damage_func" },
    { 0x30937CB8, "quad_death_explo" },
    { 0x34E51315, "quad_dining_roof_break" },
    { 0x2AEE8A85, "quad_end_traverse_anim" },
    { 0x0EB9A1DA, "quad_explode" },
    { 0x51ED3977, "quad_finish_leap" },
    { 0xD977D1F2, "quad_fire_randomly" },
    { 0x21FEF442, "quad_first_drop_fx" },
    { 0x9EDEE58F, "quad_first_drop_fx_init" },
    { 0x8D8E0DAE, "quad_gas_area_of_effect" },
    { 0xD6BAC202, "quad_gas_explo_death" },
    { 0x087A7ECF, "quad_gas_immune_func" },
    { 0x03CDE9B3, "quad_idle_run_transition" },
    { 0x9CD32EE8, "quad_kill_counted" },
    { 0x542E4C77, "quad_killed_override" },
    { 0x1957F292, "quad_kills" },
    { 0xAD1B0491, "quad_kills_total" },
    { 0x6E20C6B8, "quad_leap_attack" },
    { 0x370931AE, "quad_lobby_roof_break" },
    { 0x99B7D8E5, "quad_locations" },
    { 0x19F030FC, "quad_move_speed" },
    { 0xF5554921, "quad_num" },
    { 0x29E11D76, "quad_phase_direction" },
    { 0x4BF2144E, "quad_phase_distance" },
    { 0x288C8616, "quad_phase_forward" },
    { 0x12594E48, "quad_phase_left" },
    { 0x2A5FF681, "quad_phase_long" },
    { 0x2F598197, "quad_phase_right" },
    { 0x1701FE87, "quad_phase_short" },
    { 0x17D5D016, "quad_post_death" },
    { 0x298BE061, "quad_post_teleport" },
    { 0x5B8FBCB4, "quad_pre_teleport" },
    { 0x6109F077, "quad_prespawn" },
    { 0x80440E11, "quad_roof_crumble_fx" },
    { 0x55842BD2, "quad_roof_crumble_fx_play" },
    { 0xAF6285A2, "quad_roof_fx" },
    { 0xB4D97D33, "quad_roof_fx_play" },
    { 0x6D78942F, "quad_roof_triggers" },
    { 0xF8D81A41, "quad_rotor" },
    { 0xB16DFD04, "quad_rotor_squadinit" },
    { 0x69490D68, "quad_round_can_end" },
    { 0x413BE39D, "quad_round_name" },
    { 0x889F4094, "quad_spawners" },
    { 0x4FEBCEDC, "quad_stage_roof_break" },
    { 0x2127BE6F, "quad_stage_roof_break_single" },
    { 0x7E31E980, "quad_stop_leap" },
    { 0x6859AB68, "quad_tank_radius" },
    { 0x49AE2BAC, "quad_thrower_headmodel" },
    { 0xCAC40CFA, "quad_thrower_model" },
    { 0x1326B20B, "quad_thundergun_disintegrate" },
    { 0x962C408A, "quad_thundergun_knockdown" },
    { 0x299E94F1, "quad_trail" },
    { 0xE9B9BA37, "quad_traverse_death_fx" },
    { 0x65F011B2, "quad_vox" },
    { 0x63F5B9D8, "quad_wait" },
    { 0xB16B2C6B, "quad_wall_crawl" },
    { 0x0B4F464E, "quad_wall_crawl_start" },
    { 0x9E1F3A51, "quad_wall_crawl_theater" },
    { 0xA92F7295, "quad_wave_init" },
    { 0xBACF1D82, "quad_zombie_anim_override" },
    { 0xDBCFBEF0, "quad_zombie_idle_setup" },
    { 0x82E647D0, "quad_zombie_think" },
    { 0x9320E6CD, "quadrant" },
    { 0xA835E525, "quadrantanimweights" },
    { 0xBA9F2A92, "quadrantanimweightsdebuginfo" },
    { 0xD88A264C, "quadrants" },
    { 0x8F03BBE5, "quadratic" },
    { 0x28C00C94, "quadrotor" },
    { 0xE8FD2F7D, "quadrotor_adjust_goal_for_enemy_height" },
    { 0x04F2421D, "quadrotor_ambient_vo" },
    { 0x7A47BDD7, "quadrotor_attack_player_target" },
    { 0xC2C9E6F9, "quadrotor_blink_lights" },
    { 0x0B0E1F6B, "quadrotor_body" },
    { 0x35FAB2B5, "quadrotor_brain" },
    { 0x1F42066B, "quadrotor_check_move" },
    { 0x3C1543FE, "quadrotor_claimed" },
    { 0x6F4DE6EA, "quadrotor_cleanup_fx" },
    { 0xF92A6E99, "quadrotor_collision" },
    { 0x6C50DD0B, "quadrotor_collision_player" },
    { 0xAE140B95, "quadrotor_control_thread" },
    { 0xB07608F5, "quadrotor_crash_accel" },
    { 0xBE2B424C, "quadrotor_crash_movement" },
    { 0xA581C69A, "quadrotor_crash_tree_think" },
    { 0x789C3E33, "quadrotor_custom_behavior" },
    { 0x64AE4F9C, "quadrotor_damage" },
    { 0x41A5C9D5, "quadrotor_dealt_no_damage_to_player" },
    { 0x41E1CE83, "quadrotor_death" },
    { 0x2AA9031E, "quadrotor_death_watcher" },
    { 0xC5069B29, "quadrotor_debug_send_home" },
    { 0xB238A66D, "quadrotor_doing_fire_direction" },
    { 0x6E014EF8, "quadrotor_emped" },
    { 0x88CAB67D, "quadrotor_enemies" },
    { 0xD015C5A5, "quadrotor_engine" },
    { 0x8427D796, "quadrotor_escape_into_air" },
    { 0xAF791E2A, "quadrotor_exit_vehicle" },
    { 0x2351B762, "quadrotor_fails" },
    { 0x1BFE5CCD, "quadrotor_find_new_position" },
    { 0xD930B61D, "quadrotor_fire_for_time" },
    { 0x1353E6D4, "quadrotor_fireupdate" },
    { 0x8DBB407D, "quadrotor_fly_back_to_table" },
    { 0x58326159, "quadrotor_fly_back_to_table_timeout" },
    { 0x03D664C2, "quadrotor_forcegoal_if_closer" },
    { 0x51C0B62C, "quadrotor_get_closest_node" },
    { 0x06979E11, "quadrotor_get_damage_effect" },
    { 0x4F8F1A26, "quadrotor_glove_on" },
    { 0x5D58AF43, "quadrotor_go_on_path" },
    { 0x08E1E797, "quadrotor_instance_watcher" },
    { 0x2750FCE9, "quadrotor_left_foreshadow" },
    { 0xCBB6895E, "quadrotor_level_out_for_landing" },
    { 0xBBC7D544, "quadrotor_main" },
    { 0x409F85A3, "quadrotor_medallion_found" },
    { 0xA1A0A601, "quadrotor_medallions" },
    { 0x420E2949, "quadrotor_medallions_vo" },
    { 0xC29F99F7, "quadrotor_movementupdate" },
    { 0x73358F7A, "quadrotor_off" },
    { 0x7DF5862C, "quadrotor_on" },
    { 0x336253F6, "quadrotor_perk_dialog" },
    { 0xA01ACCF2, "quadrotor_pickup_think" },
    { 0xCDA1939E, "quadrotor_play_single_fx_on_tag" },
    { 0xA42C41A8, "quadrotor_predicted_collision" },
    { 0x80357B3A, "quadrotor_reinforce" },
    { 0x8A194E9E, "quadrotor_reinforce_bridge" },
    { 0x408BEFDE, "quadrotor_return_condition_watcher" },
    { 0xD9FC32DC, "quadrotor_revive" },
    { 0x81F83D00, "quadrotor_right_foreshadow" },
    { 0xF9745615, "quadrotor_scripted" },
    { 0x1075562A, "quadrotor_self_destruct" },
    { 0x969DEAE1, "quadrotor_set_available" },
    { 0x530A674B, "quadrotor_set_team" },
    { 0xD37FCC8E, "quadrotor_set_unavailable" },
    { 0xA7EC51AE, "quadrotor_start_ai" },
    { 0xC2ABCC6A, "quadrotor_start_rockslide" },
    { 0x2FEE9022, "quadrotor_start_scripted" },
    { 0x3C3BF0E1, "quadrotor_status" },
    { 0x2FC8FE95, "quadrotor_stomp_death" },
    { 0xD4400A09, "quadrotor_table" },
    { 0x40B24410, "quadrotor_teleport_to_nearest_node" },
    { 0x03B87284, "quadrotor_temp_bullet_shield" },
    { 0x612FAA55, "quadrotor_think" },
    { 0xB0D2A612, "quadrotor_timer" },
    { 0x0EC54AF1, "quadrotor_update_damage_fx" },
    { 0xAB0B295C, "quadrotor_update_rumble" },
    { 0x18C37253, "quadrotor_watch_for_game_end" },
    { 0xECE63A79, "quadrotor_watcher" },
    { 0xBDC5186F, "quadrotor_weapon" },
    { 0x320E7A6B, "quadrotorcallback_vehicledamage" },
    { 0x69AC47EE, "quadrotorcraftable" },
    { 0x0D217D07, "quadrotors" },
    { 0x82E23637, "quadrotors_find_player_target" },
    { 0x4B248347, "quadrotors_go_spline_then_ai" },
    { 0xF3A4CBDF, "quadrotors_guard_bridge" },
    { 0x0F8C3B04, "quadrotors_guard_metalstorm" },
    { 0xDD1E110D, "quadrotors_kill_bigdog" },
    { 0x4EC286FD, "quadrotos" },
    { 0xDE9351BB, "quads" },
    { 0xCD4EE9CE, "quads_per_round" },
    { 0x591DD6A0, "quadspawnsetup" },
    { 0xEEA2C356, "quadsquad" },
    { 0x3FC75F50, "quadtank" },
    { 0x17B8332E, "quadtank_automelee_update" },
    { 0x5D474E87, "quadtank_bundle" },
    { 0x267A7AFF, "quadtank_death" },
    { 0xBF3A7A0D, "quadtank_destroyturret" },
    { 0x5D17667F, "quadtank_disabletrophy" },
    { 0x8EC0E22C, "quadtank_emped" },
    { 0xCE00E5C0, "quadtank_enabletrophy" },
    { 0x86FE5C5E, "quadtank_exit_vehicle" },
    { 0x58D90469, "quadtank_initialize" },
    { 0x350CCA63, "quadtank_movementupdate" },
    { 0x0A389866, "quadtank_off" },
    { 0xFEFA9078, "quadtank_on" },
    { 0x644777C8, "quadtank_player_fireupdate" },
    { 0xA093B43B, "quadtank_projectile_watcher" },
    { 0xCED547F7, "quadtank_set_team" },
    { 0xACB4F83C, "quadtank_side_turrets_forward" },
    { 0xBCD490EB, "quadtank_turret_scan" },
    { 0x28A3B4BC, "quadtank_update_difficulty" },
    { 0x4C6EE4CC, "quadtank_weakpoint_display" },
    { 0x7E50E8DA, "quadtank_weakpoint_trigger" },
    { 0x9196ECF2, "quadtank_weapon_think_cannon" },
    { 0xEFC2D52F, "quadtankcallback_vehicledamage" },
    { 0x45557EB8, "quadteleporttraversalmocompstart" },
    { 0x4ADC8462, "quagmire" },
    { 0x40077528, "quake" },
    { 0x719F80CE, "quake_ent" },
    { 0x65C5E0CB, "quake_players" },
    { 0x234D43D2, "quake_power" },
    { 0xDD43E5E9, "quake_radius" },
    { 0x82CE5352, "quake_ride_lander" },
    { 0xB2800D13, "quake_strength_max" },
    { 0x356B4F1D, "quake_strength_min" },
    { 0x184A7180, "quake_struct" },
    { 0x0F92960C, "quake_time" },
    { 0xDBAD56DF, "quake_time_max" },
    { 0x30FF2EA1, "quake_time_min" },
    { 0x4C16A4BC, "quaked" },
    { 0xAA2E7818, "quakeduration" },
    { 0x8EA33F63, "quakepower" },
    { 0x33EAECCA, "quakeradius" },
    { 0xC5EC83C3, "quakes" },
    { 0x7F0313AE, "quakescale" },
    { 0x413FC504, "quakescalemax" },
    { 0x2C211D6A, "quakescalemin" },
    { 0x6B24199B, "quakestrength" },
    { 0xFD2DB5C3, "quaketime" },
    { 0x724A2750, "quaketype" },
    { 0x237728F9, "quakevel" },
    { 0x67C9DFBF, "qualifier" },
    { 0x97F26C38, "qualifier_func" },
    { 0x628955DA, "qualifier_passed" },
    { 0x8FA351C2, "quantities" },
    { 0x197AB96A, "quantity" },
    { 0x50AE9C08, "quantity_array" },
    { 0x82299C0C, "quantum" },
    { 0xC2AD867B, "quantum_bomb_auto_revive_result" },
    { 0x21454729, "quantum_bomb_auto_revive_validation" },
    { 0x2C393010, "quantum_bomb_cached_closest_zombies" },
    { 0x4375AF8D, "quantum_bomb_cached_in_playable_area" },
    { 0x439BF2CD, "quantum_bomb_clear_cached_data" },
    { 0x8FC8C893, "quantum_bomb_debug_print_3d" },
    { 0x50184BD3, "quantum_bomb_debug_print_bold" },
    { 0x038E7D20, "quantum_bomb_debug_print_ln" },
    { 0x771FA9CD, "quantum_bomb_default_validation" },
    { 0xF94F76F0, "quantum_bomb_deregister_result" },
    { 0x833BF1FD, "quantum_bomb_deregister_result_func" },
    { 0x60E1D81A, "quantum_bomb_exists" },
    { 0x8913B6E9, "quantum_bomb_fling_zombie" },
    { 0xF595292F, "quantum_bomb_get_cached_closest_zombies" },
    { 0x20F748D8, "quantum_bomb_get_cached_in_playable_area" },
    { 0xF41C715B, "quantum_bomb_give_nearest_perk_result" },
    { 0xAC816709, "quantum_bomb_give_nearest_perk_validation" },
    { 0xC5BCB16E, "quantum_bomb_in_playable_area_validation" },
    { 0x2B504027, "quantum_bomb_in_playable_area_validation_func" },
    { 0xAAD5D1B5, "quantum_bomb_lethal_grenade_result" },
    { 0x1173D2D2, "quantum_bomb_notetrack_think" },
    { 0xD0F53EB4, "quantum_bomb_on_player_connect" },
    { 0x6671EC9C, "quantum_bomb_on_player_spawned" },
    { 0x97C87FB4, "quantum_bomb_open_nearest_door_result" },
    { 0x37E7A116, "quantum_bomb_open_nearest_door_validation" },
    { 0x209ED8D3, "quantum_bomb_pack_or_unpack_current_weapon_result" },
    { 0x33303FA1, "quantum_bomb_pack_or_unpack_current_weapon_validation" },
    { 0x30750878, "quantum_bomb_play_area_effect" },
    { 0x9ACC1B55, "quantum_bomb_play_area_effect_func" },
    { 0xE468BADA, "quantum_bomb_play_mystery_effect" },
    { 0xC5E1E17B, "quantum_bomb_play_mystery_effect_func" },
    { 0xA2DCF424, "quantum_bomb_play_player_effect" },
    { 0x3BDDB4F2, "quantum_bomb_play_player_effect_at_position" },
    { 0xA2CECAE3, "quantum_bomb_play_player_effect_at_position_func" },
    { 0xE09B9D69, "quantum_bomb_play_player_effect_func" },
    { 0xC56F285F, "quantum_bomb_player_teleport_result" },
    { 0x4AC5AFCE, "quantum_bomb_prevent_player_getting_teleported" },
    { 0x65DF3C5D, "quantum_bomb_prevent_player_getting_teleported_override" },
    { 0xC7DE061E, "quantum_bomb_random_bonus_or_lose_points_powerup_result" },
    { 0x4E88DE9E, "quantum_bomb_random_powerup_result" },
    { 0x0870382D, "quantum_bomb_random_weapon_powerup_result" },
    { 0x5E612CF3, "quantum_bomb_random_weapon_starburst_result" },
    { 0xA2D78638, "quantum_bomb_random_zombie_grab_powerup_result" },
    { 0xF2DF781B, "quantum_bomb_register_result" },
    { 0x234D935C, "quantum_bomb_register_result_func" },
    { 0x5E5934A9, "quantum_bomb_remove_digger_result" },
    { 0xBABE0DAB, "quantum_bomb_remove_digger_validation" },
    { 0xF8AAFD4C, "quantum_bomb_results" },
    { 0xEDFEC8BE, "quantum_bomb_select_result" },
    { 0xB980D19B, "quantum_bomb_slightly_delayed_player_response" },
    { 0x846D53B4, "quantum_bomb_spawned" },
    { 0xA2889EBB, "quantum_bomb_teleport" },
    { 0x76C682D1, "quantum_bomb_teleport_player" },
    { 0x57011E91, "quantum_bomb_zombie_add_to_total_result" },
    { 0xCE0A1513, "quantum_bomb_zombie_add_to_total_validation" },
    { 0xBAB27D85, "quantum_bomb_zombie_fling_result" },
    { 0x747FD3F4, "quantum_bomb_zombie_speed_buff_result" },
    { 0xFD6BCA8B, "quarrel" },
    { 0x4ADFEE5F, "quarter" },
    { 0xEA9BA02E, "quarterbar" },
    { 0x049C47E6, "quarters" },
    { 0x373F0E1C, "quarters_alavi" },
    { 0x99CC0AA9, "quarters_alavi_stairs" },
    { 0x120BF69F, "quarters_dialogue" },
    { 0x531E75D5, "quarters_drunk" },
    { 0xDE04EF18, "quarters_drunk_bottle" },
    { 0xBD77082E, "quarters_drunk_death" },
    { 0x8130B2F1, "quarters_drunk_earlydeath" },
    { 0xCA7F906A, "quarters_drunk_earlydeath1" },
    { 0xA47D1601, "quarters_drunk_earlydeath2" },
    { 0xCC025F14, "quarters_drunk_earlydeath_proc" },
    { 0xB96EFAED, "quarters_heli" },
    { 0xB97DBC72, "quarters_player_speed" },
    { 0x87EDB040, "quarters_price" },
    { 0x4773768D, "quarters_price_safety" },
    { 0x1B993AD9, "quarters_price_says_clear" },
    { 0x9A125A37, "quarters_redlightatstairs" },
    { 0x11DB7EE2, "quarters_sleeping" },
    { 0x0004C6AD, "quarters_sleeping_death" },
    { 0xBFD7A72E, "quarters_sleeping_player" },
    { 0x673D1018, "quartersdrunk" },
    { 0xB5E82D3D, "quaternion" },
    { 0x2F9F1FC4, "quckly" },
    { 0x2EAD6938, "que" },
    { 0xE2FBBA3F, "que_body" },
    { 0x1B464FF2, "quebec" },
    { 0x81C3A60B, "queries" },
    { 0xD6929D6F, "query" },
    { 0xE9D02C78, "query_ents" },
    { 0x642B5E53, "query_max_dist" },
    { 0x6CF3475D, "query_min_dist" },
    { 0x5BBB17FB, "query_position" },
    { 0x48F8D555, "query_result" },
    { 0x520CBD16, "queryheight" },
    { 0x09B67151, "querying" },
    { 0x40BD4EBD, "querymemberanimstate" },
    { 0x817FF5AC, "querymemberstate" },
    { 0x961B3962, "querymultiplier" },
    { 0x1075A48D, "queryorigin" },
    { 0xD5B210FC, "queryresult" },
    { 0x397061FD, "quest" },
    { 0xE1950593, "quest_clientfield" },
    { 0xA1AD4173, "quest_complete_time" },
    { 0x9B82FB76, "quest_progressed" },
    { 0x878F71B1, "question" },
    { 0xC63F7E18, "questions" },
    { 0x1759C5BC, "quests" },
    { 0x80613A12, "queue" },
    { 0x7C9EE5E1, "queue_" },
    { 0x41512A56, "queue_anim" },
    { 0xE40BF99D, "queue_anim_single_solo" },
    { 0xA321FE58, "queue_anim_single_solo_with_reach" },
    { 0x263130AD, "queue_checkpoint_save" },
    { 0x65DDCF95, "queue_dialog" },
    { 0xA57B8F12, "queue_dialog_ally" },
    { 0xC1A5287C, "queue_dialog_enemy" },
    { 0x1296BEC4, "queue_line_and_remove" },
    { 0xCB6B5E63, "queue_movie" },
    { 0xAAC1DB40, "queue_pipes_drop" },
    { 0xF32F0335, "queue_players_success_dialog_line" },
    { 0x972D1B69, "queue_popup" },
    { 0x9995C4C3, "queue_respawn" },
    { 0xB7D9B72D, "queueanim" },
    { 0x52169952, "queued" },
    { 0xDBBADB24, "queued_anim_threads" },
    { 0xE8E052AA, "queued_targeters" },
    { 0x732066A9, "queueevents" },
    { 0x7A4075E4, "queueeventstates" },
    { 0x54D6782D, "queuetime" },
    { 0xE2239846, "queuewagerpopup" },
    { 0x23D28FC3, "queuing" },
    { 0xB33BF176, "quick" },
    { 0x984B1EF7, "quick_close" },
    { 0x84B932F9, "quick_revive_callback_func" },
    { 0x061ACE5E, "quick_revive_client_field_func" },
    { 0x0C43DC47, "quick_revive_default_angles" },
    { 0x3A8D77B9, "quick_revive_default_origin" },
    { 0x30455692, "quick_revive_final_angles" },
    { 0xD28C6208, "quick_revive_final_pos" },
    { 0x656366E3, "quick_revive_game_type_watcher" },
    { 0x9A67A128, "quick_revive_linked_ent" },
    { 0x2BB8D9DF, "quick_revive_linked_ent_moves" },
    { 0x3C74191E, "quick_revive_linked_ent_offset" },
    { 0xC153DD20, "quick_revive_machine" },
    { 0xC55B698F, "quick_revive_machine_active_model" },
    { 0x4BD75D79, "quick_revive_machine_clip" },
    { 0x0366E819, "quick_revive_machine_disabled_model" },
    { 0xD54FC8F2, "quick_revive_machine_light_fx" },
    { 0xCEA7EB17, "quick_revive_perk_bottle_weapon" },
    { 0x6F330545, "quick_revive_perk_machine_setup" },
    { 0xA3CDCA72, "quick_revive_precache" },
    { 0xA7E576E6, "quick_revive_precache_override_func" },
    { 0x9F58D94A, "quick_revive_radiant_machine_name" },
    { 0xCEB820D0, "quick_revive_register_clientfield" },
    { 0xB7709269, "quick_revive_set_clientfield" },
    { 0x5675C82A, "quick_revive_shader" },
    { 0xA6B76531, "quick_revive_solo_leave_watcher" },
    { 0x57119BC4, "quick_revive_solo_watch" },
    { 0x825208D7, "quick_revive_trigger" },
    { 0x81F55766, "quick_revived_player" },
    { 0x0F30A5AF, "quick_scene" },
    { 0x763A21D7, "quick_show_models" },
    { 0x009E79D0, "quick_text" },
    { 0x16F0721B, "quick_text_thread" },
    { 0x9A6BA3BB, "quick_texts" },
    { 0x66A72BA0, "quickcommands" },
    { 0x4E54E1D3, "quickdogmeleerelease" },
    { 0xC3F0B553, "quicken" },
    { 0xCBBF251F, "quicker" },
    { 0x96324CB6, "quickest" },
    { 0x88D5133E, "quickload" },
    { 0x2DF7BE7B, "quickly" },
    { 0xF5C60B6E, "quickmelee" },
    { 0x92B30BB1, "quickmessagetoall" },
    { 0x25828E81, "quickreive" },
    { 0x19282906, "quickresponses" },
    { 0xBF162FDD, "quickrevive" },
    { 0xA4C77EAA, "quicksorting" },
    { 0x9D8242C1, "quickstarts" },
    { 0xF5DC7428, "quickstatements" },
    { 0x136E492E, "quickswitch" },
    { 0x1366C649, "quicktime" },
    { 0x918D49C9, "quickwave" },
    { 0x7BC759A7, "quiet" },
    { 0xFB8A0F04, "quiet_circling_helicopters" },
    { 0xCEEFD814, "quiet_on_the_set_achieved" },
    { 0x0FC9482A, "quietly" },
    { 0xD79B2458, "quinn" },
    { 0x001E2D28, "quit" },
    { 0xD5DCC725, "quite" },
    { 0x29B02BC3, "quits" },
    { 0xCFB9BE5C, "quitting" },
    { 0x8A2DD1CF, "quittypes_e" },
    { 0xD869FD7B, "quote" },
    { 0xAEC6F51A, "quotes" },
    { 0x2F0433E2, "qwe" },
    { 0x3390F625, "r" },
    { 0xF20BD5AF, "r0" },
    { 0xCC095B46, "r1" },
    { 0x3E95830B, "r11" },
    { 0xA606E0DD, "r2" },
    { 0x80046674, "r3" },
    { 0x0DFCF739, "r6" },
    { 0xFEBA5DF8, "r_angles" },
    { 0xC7485727, "r_animlength" },
    { 0x128F6054, "r_close" },
    { 0x367C24E9, "r_cover" },
    { 0xD9692AB8, "r_dist" },
    { 0x0E047BA3, "r_dof_viewmodelend" },
    { 0xCEDBF093, "r_dof_viewmodelend_1" },
    { 0x5CD48158, "r_dof_viewmodelend_2" },
    { 0x7FEB6590, "r_dof_viewmodelstart" },
    { 0x055FF96C, "r_dof_viewmodelstart_1" },
    { 0x776768A7, "r_dof_viewmodelstart_2" },
    { 0x4CE7F1F6, "r_fraction" },
    { 0xB4D25BBC, "r_graphiccontentblur" },
    { 0xBB036505, "r_in" },
    { 0x41F70FE4, "r_l" },
    { 0x847D7969, "r_lighttweaksundirection" },
    { 0x0097F262, "r_or_l" },
    { 0x04185F04, "r_out" },
    { 0x92DF6A54, "r_outdoor_feather" },
    { 0x862D94EA, "r_r" },
    { 0x5BA3BB5B, "r_rimintensity" },
    { 0x81B270EF, "r_rimintensity_debug" },
    { 0xCB905DE8, "r_stick" },
    { 0x886789A8, "r_stream" },
    { 0x80D0A88F, "r_watersim_curlamount" },
    { 0x4379F257, "r_watersim_curlmax" },
    { 0x075DD0B1, "r_watersim_curlreduce" },
    { 0xC78FF936, "r_watersim_debug" },
    { 0x89E7A100, "r_watersim_enabled" },
    { 0xFA581F01, "r_watersim_flatten" },
    { 0x92A7D86D, "r_watersim_foamappear" },
    { 0x1A8F3BC1, "r_watersim_foamdisappear" },
    { 0xBB2DA90B, "r_watersim_minshoreheight" },
    { 0xA812436F, "r_watersim_particlegravity" },
    { 0x752203DF, "r_watersim_particlelength" },
    { 0xBF4DA84C, "r_watersim_particlelimit" },
    { 0xFD47009D, "r_watersim_particlewidth" },
    { 0xC76ED9BE, "r_watersim_waveseeddelay" },
    { 0xEA00A493, "r_watersim_windamount" },
    { 0xF9F8B4D4, "r_watersim_winddir" },
    { 0x2D6DB563, "r_watersim_windmax" },
    { 0x9BC9A153, "r_zfeather" },
    { 0x818BD6D0, "r_znear" },
    { 0xEB431A76, "ra" },
    { 0x998878AC, "raaaargh" },
    { 0xB75525A7, "raahman" },
    { 0x2BB76A8A, "raargh" },
    { 0x41834B12, "raarrgh" },
    { 0x6D27A617, "rabid" },
    { 0x0E5C4916, "race" },
    { 0x66AA3F2C, "race_end" },
    { 0x9B44E9C7, "race_start" },
    { 0x907CD1AF, "racepoints" },
    { 0x6ACD9F89, "races" },
    { 0x5A613DE8, "rack" },
    { 0x00065583, "racks" },
    { 0x2ECC7A33, "racktapes" },
    { 0x27BEAA06, "rad" },
    { 0x7D773F74, "rad_squared" },
    { 0x28F31C03, "radar" },
    { 0x58A2763B, "radar01_start" },
    { 0x66288B26, "radar1_ent" },
    { 0xF4DFF50E, "radar_building_mortar_hits_thread" },
    { 0x18EFB556, "radar_crush_house" },
    { 0xBCC3D566, "radar_disabled" },
    { 0x63463246, "radar_dish" },
    { 0xC4880303, "radar_dish_init" },
    { 0x6F89184C, "radar_dish_rotate" },
    { 0x48148BCC, "radar_dish_sounds_start" },
    { 0x0D497700, "radar_dish_sounds_stop" },
    { 0x95377423, "radar_dish_think" },
    { 0xE624B536, "radar_engine_ent" },
    { 0x6B3B17CA, "radar_glass" },
    { 0x41C1D657, "radar_groan_ent" },
    { 0x94ACB5F9, "radar_main" },
    { 0x20AFD6EE, "radar_move_init" },
    { 0xC6FB9CD2, "radar_station" },
    { 0x258E6703, "radar_status_change" },
    { 0x11F1BF14, "radar_timer_kill" },
    { 0x1DF0727B, "radar_timer_kill_" },
    { 0xC6118BAD, "radar_tower" },
    { 0x09DC29AB, "radar_tower_notify" },
    { 0x75017794, "radar_tower_start" },
    { 0x8BF9CF9C, "radar_visionset_in" },
    { 0x1880DDF3, "radar_visionset_out" },
    { 0xCBEEC990, "radardestroyed" },
    { 0x23E3FDD1, "radarlongviewtime" },
    { 0x3496872A, "radarmode" },
    { 0xE87937A1, "radarmomentum" },
    { 0x7F409F72, "radars" },
    { 0x09C582B0, "radarteam" },
    { 0xB8F43AE5, "radartimers" },
    { 0x9478DB3B, "radartype" },
    { 0x16668177, "radarviewtime" },
    { 0x7B00A3AC, "radarviewtype" },
    { 0xAD8B4243, "radi" },
    { 0x61A3141C, "radial" },
    { 0x9C15B35E, "radial_damage_from_spot" },
    { 0x2A572118, "radial_edge" },
    { 0xCE2368B9, "radial_origin" },
    { 0x03565ACF, "radialcoef" },
    { 0xC656391E, "radiant" },
    { 0x32D9575D, "radiant_live_udpate" },
    { 0x12F393E5, "radiant_live_update" },
    { 0xE89FECD6, "radiant_machine_name" },
    { 0xCC657044, "radiant_name" },
    { 0x4660F1E4, "radiantexploders" },
    { 0xEA7405EE, "radiation" },
    { 0x7B90F119, "radiation_death" },
    { 0x7EB31E9D, "radiation_kill" },
    { 0x6C4555BF, "radiation_rate" },
    { 0x3DBA1ECE, "radiation_ratepercent" },
    { 0x8E4C3332, "radiation_sound" },
    { 0x362A9FA5, "radiation_total" },
    { 0xC8F7C0F4, "radiation_totalpercent" },
    { 0xEE16FEA2, "radiation_triggers" },
    { 0x04398FBB, "radiation_warning" },
    { 0xE2D069D2, "radient" },
    { 0xC0388FB8, "radii" },
    { 0xA4476E2E, "radio" },
    { 0x942B1627, "radio2_override" },
    { 0x4B89AECD, "radio4_override" },
    { 0x437F8B58, "radio7_override" },
    { 0xF38875FE, "radio9_override" },
    { 0x7A9A61A6, "radio_7_played" },
    { 0x533ECD6E, "radio_a" },
    { 0x667BADAE, "radio_activate" },
    { 0xE9F72165, "radio_anim_starting" },
    { 0x0F5519F2, "radio_antenna_explosion" },
    { 0x2D3C5305, "radio_b" },
    { 0x981488AC, "radio_chatter" },
    { 0xAF368383, "radio_counter" },
    { 0x68C47F6A, "radio_damage" },
    { 0x7F99F75A, "radio_damaged" },
    { 0x05BE153A, "radio_debug" },
    { 0x86E18AC1, "radio_delay_max" },
    { 0x340A1BFF, "radio_delay_min" },
    { 0x7D0EEC8A, "radio_destroyed" },
    { 0x63CBC4F7, "radio_dialogue" },
    { 0x80F6579A, "radio_dialogue_done" },
    { 0xA02775E3, "radio_dialogue_queue" },
    { 0x415DE2FA, "radio_dialogue_stop" },
    { 0x7F7F50DB, "radio_distance_max" },
    { 0x949DF875, "radio_distance_min" },
    { 0x19B58131, "radio_done" },
    { 0xF90A04E4, "radio_easter_eggs" },
    { 0x26782B67, "radio_ee_debug" },
    { 0x8BB9DEF9, "radio_ee_song" },
    { 0x632CCA62, "radio_ee_think" },
    { 0x2FD32A1D, "radio_egg_counter" },
    { 0x0E9CFDCA, "radio_egg_hanging_init" },
    { 0x43C36AED, "radio_egg_init" },
    { 0x3E7031A5, "radio_egg_trigger" },
    { 0xB962C94F, "radio_eggs" },
    { 0x2AA32334, "radio_ent" },
    { 0xD6B7D604, "radio_guard" },
    { 0x4F896A4E, "radio_guy" },
    { 0x61566200, "radio_guy_setup" },
    { 0x22EF8296, "radio_heavy_fire_dialogue" },
    { 0x5B9F9AD6, "radio_id" },
    { 0xA69221D8, "radio_in_use" },
    { 0xA126AEBF, "radio_index" },
    { 0x2C0B3DC8, "radio_location" },
    { 0xFACA3D4F, "radio_loop" },
    { 0xDCD70607, "radio_loop_sound" },
    { 0xFE4FCD13, "radio_man" },
    { 0xA8A0CA14, "radio_model" },
    { 0x3B4B2F3D, "radio_msg_stack" },
    { 0xC72E9DD8, "radio_msg_stack_proc" },
    { 0x6B7A21ED, "radio_nag_lines" },
    { 0xC18E82FE, "radio_not_in_use" },
    { 0x246D8227, "radio_num" },
    { 0x3ABA52C4, "radio_off" },
    { 0xA3F75C57, "radio_one" },
    { 0x4841FA68, "radio_one_trig" },
    { 0x5D772163, "radio_origin" },
    { 0xBE069DAD, "radio_pos" },
    { 0x78290F03, "radio_prec" },
    { 0x202159D9, "radio_queue_thread" },
    { 0x8718952D, "radio_sect_fx" },
    { 0x1ABC9BC1, "radio_set_new_goal_node" },
    { 0x9B02D8A0, "radio_setup" },
    { 0x01894DF5, "radio_songs" },
    { 0xE7496814, "radio_spots" },
    { 0x581A64E3, "radio_stack" },
    { 0x379199A9, "radio_start_wakeup" },
    { 0xDEF302FA, "radio_struct" },
    { 0x67BDA13D, "radio_thread" },
    { 0xC4DAE9A7, "radio_three" },
    { 0xBBC755B8, "radio_three_trig" },
    { 0xD5FF347C, "radio_timer" },
    { 0xFB506CC4, "radio_tower" },
    { 0xEB6821C6, "radio_tower_begin" },
    { 0xC98831EB, "radio_tower_blocker" },
    { 0x728A8E25, "radio_tower_close" },
    { 0xEC209633, "radio_tower_death" },
    { 0xC31BA488, "radio_tower_destroyed" },
    { 0x2F54AE47, "radio_tower_dialog" },
    { 0x1FCCD8B4, "radio_tower_goal_nodes" },
    { 0xA683C9FC, "radio_tower_infantry_evasion" },
    { 0xA338060A, "radio_tower_infantry_grenades" },
    { 0x103C47AF, "radio_tower_visible" },
    { 0xE451512F, "radio_trig" },
    { 0x63070D33, "radio_trigger" },
    { 0x999344A5, "radio_two" },
    { 0x2D7D2576, "radio_two_trig" },
    { 0x3D7DDEE2, "radio_used" },
    { 0xF2E4FB2D, "radio_waittime" },
    { 0x4FFA9273, "radio_watcher" },
    { 0x2BC76104, "radioactive" },
    { 0x32B7E41F, "radioautomovetime" },
    { 0xB022F226, "radiodone" },
    { 0x1E688ED5, "radioent" },
    { 0x35A564C6, "radioforcedtransmissionqueue" },
    { 0xAB9B9389, "radioguard" },
    { 0x1EB5FCA7, "radioguy" },
    { 0x014C0465, "radioguyspawner" },
    { 0x5AB07A42, "radioman" },
    { 0x188761F4, "radioman_setup" },
    { 0x08522387, "radioman_think" },
    { 0xFDC58F7E, "radioman_used" },
    { 0x3BA07F20, "radiomanwassetup" },
    { 0xEE13F26E, "radiomen" },
    { 0x78BFCEA3, "radioobject" },
    { 0x240BF237, "radioop" },
    { 0x199D6312, "radioop_spawner" },
    { 0x4AB251A5, "radioowningteam" },
    { 0xA9FB7EBA, "radiop" },
    { 0xA272F3DC, "radioplaying" },
    { 0x322C1C8A, "radiorevealtime" },
    { 0x83F90451, "radios" },
    { 0xC09FEA24, "radiospawnqueue" },
    { 0x662276DD, "radiotower" },
    { 0x8F59294E, "radiotrigger" },
    { 0xF8456B37, "radius" },
    { 0x06BC40DC, "radius1" },
    { 0x78C3B017, "radius2" },
    { 0x60E02CC8, "radius_big" },
    { 0xF043D1D4, "radius_decay" },
    { 0xBDC78701, "radius_for_this_circle" },
    { 0x6AEDD4B3, "radius_inner_stage_1_begin" },
    { 0xB794F743, "radius_inner_stage_1_end" },
    { 0x561EF69C, "radius_inner_stage_2_begin" },
    { 0x7C19CD60, "radius_inner_stage_2_end" },
    { 0x2B9ADF0D, "radius_inner_stage_3_begin" },
    { 0x224C48F5, "radius_inner_stage_3_end" },
    { 0x82D5CC9E, "radius_inner_stage_4_begin" },
    { 0xF990E392, "radius_inner_stage_4_end" },
    { 0x9AF6A05F, "radius_is_dirty" },
    { 0x7677E33B, "radius_of_effect" },
    { 0xDFCA441E, "radius_outer_stage_1_begin" },
    { 0xA847AF12, "radius_outer_stage_1_end" },
    { 0xC97AA981, "radius_outer_stage_2_begin" },
    { 0x21151FD9, "radius_outer_stage_2_end" },
    { 0x97B10D10, "radius_outer_stage_3_begin" },
    { 0x552073B4, "radius_outer_stage_3_end" },
    { 0xC7E24C33, "radius_outer_stage_4_begin" },
    { 0x664BC2C3, "radius_outer_stage_4_end" },
    { 0xB39E04C2, "radius_per_circle" },
    { 0xC0BEBB19, "radius_setup" },
    { 0xBD51752F, "radius_small" },
    { 0xA1822FFE, "radius_sq" },
    { 0x91C4F178, "radius_sqr" },
    { 0x90429CC9, "radius_squared" },
    { 0xA2F3A642, "radius_start" },
    { 0xD17F5D3A, "radius_trigger" },
    { 0x6DEF6F41, "radius_trigger_thread" },
    { 0xD7572CD3, "radiusartilleryshellshock" },
    { 0x3F7A574E, "radiusaxis_influencer" },
    { 0xBEE797C1, "radiuscounter" },
    { 0xEAC31668, "radiusdamage" },
    { 0xE38989E8, "radiusdamage_delay" },
    { 0xC8258E22, "radiusdamagemax" },
    { 0x9D9382DC, "radiusdamagemin" },
    { 0x89A8360A, "radiusdamageradius" },
    { 0xB5B258BD, "radiusinner" },
    { 0x8D2E5363, "radiusmax" },
    { 0x4FCA484D, "radiusmin" },
    { 0x9B016D3C, "radiusmortarshellshock" },
    { 0xB0095FDA, "radiusmultiplier" },
    { 0x678669E6, "radiusoffset" },
    { 0x9D0C1614, "radiusouter" },
    { 0x41436963, "radiussq" },
    { 0xCB0E4DBB, "radiussqr" },
    { 0x4E733FB8, "radiussqtocheck" },
    { 0x5D4270DA, "radiussquared" },
    { 0x1DC98108, "radomize" },
    { 0xFB85352E, "radoverride" },
    { 0x172F299D, "radsquared" },
    { 0x195C5079, "radtriggers" },
    { 0x5F94A9A2, "radus2rd" },
    { 0xE038C948, "raft" },
    { 0x279B06B2, "raft_drones" },
    { 0xE6E53C1A, "raft_drones_spawn" },
    { 0xBC3280E0, "raft_struct" },
    { 0x8E7EE67C, "rafters" },
    { 0x94328C63, "rafts" },
    { 0x01BC2F9D, "rag" },
    { 0x31FD0A6B, "rag_doll" },
    { 0x028307F0, "rag_doll_death" },
    { 0x99AC24C8, "rag_x" },
    { 0xBFAE9F31, "rag_y" },
    { 0xE5B1199A, "rag_z" },
    { 0x77DAA646, "ragdol" },
    { 0x7A6395BE, "ragdoll" },
    { 0xD1BE4127, "ragdoll_after_anim" },
    { 0x55D797C6, "ragdoll_at_target" },
    { 0xF25AE454, "ragdoll_attempt" },
    { 0x1DDF2D47, "ragdoll_bucket" },
    { 0xB7C4EF98, "ragdoll_burn_model" },
    { 0x1AB84237, "ragdoll_corpse_control" },
    { 0x1E97F40E, "ragdoll_corpse_control_think" },
    { 0xFB072D47, "ragdoll_dead_exit_rider" },
    { 0xA336B7E9, "ragdoll_death" },
    { 0x16F887B8, "ragdoll_direction" },
    { 0x0794AE7E, "ragdoll_directionscale" },
    { 0x82D853FE, "ragdoll_fall_anim" },
    { 0x26DAA875, "ragdoll_flies_past_player" },
    { 0x07124AE2, "ragdoll_getout_death" },
    { 0xC469BD50, "ragdoll_if_damaged" },
    { 0x39A748A7, "ragdoll_impact_watch" },
    { 0x92D29E12, "ragdoll_impact_watch_start" },
    { 0x64A5A080, "ragdoll_jib" },
    { 0xCFBA6D83, "ragdoll_limit_check" },
    { 0x648A3C9B, "ragdoll_now" },
    { 0x80B8F345, "ragdoll_on_grenade_explosion" },
    { 0x8097D3CF, "ragdoll_or_death_duringanimation" },
    { 0xC877B52D, "ragdoll_override" },
    { 0xA4C11CC5, "ragdoll_start_time" },
    { 0x2C008B53, "ragdoll_start_vel" },
    { 0xE022EADA, "ragdoll_time" },
    { 0xDDDB59A8, "ragdolldeath" },
    { 0x5D394DC2, "ragdolling" },
    { 0x99058C2B, "ragdollragdollragdollragdollragdollragdoll" },
    { 0xE3D7CDA1, "ragdolls" },
    { 0xDB20777A, "rage" },
    { 0x5CA1A1A4, "rage_ai_damage_override" },
    { 0x8DB3A2EE, "rage_ammo_check" },
    { 0x119AB683, "rage_ammo_fake_reload" },
    { 0x73DA8BEA, "rage_ammo_spas_reload_logic" },
    { 0x36ECD791, "rage_ammo_weapon_change" },
    { 0x0B7B96F5, "rage_amount" },
    { 0xE9909DA9, "rage_blood_enemy_death" },
    { 0xD6B05F12, "rage_chase_after_player" },
    { 0x1A21474F, "rage_disable" },
    { 0xC1F8FAAD, "rage_dive_to_prone_logic" },
    { 0x5A9ADB3E, "rage_end_by_kills" },
    { 0xDAB8C6CF, "rage_end_by_no_enemies" },
    { 0x210DB540, "rage_enemy_logic" },
    { 0xF828AF1E, "rage_enemy_override" },
    { 0x29F4561A, "rage_extra_gore_cool_down" },
    { 0xF442F211, "rage_fade_image" },
    { 0x09D4C16E, "rage_health_color_yellow" },
    { 0x5A97BB08, "rage_health_fade" },
    { 0x3E43FF1E, "rage_health_fade_end_notify" },
    { 0xB4D47F55, "rage_health_high_damage_to_low" },
    { 0x9D7F2E9D, "rage_health_hit" },
    { 0x8C4C6392, "rage_health_hit_fade" },
    { 0x8F7BE1C2, "rage_health_overlay" },
    { 0xBCFFB55C, "rage_health_state_change" },
    { 0xE29F7CCD, "rage_high" },
    { 0xA531F0BF, "rage_high_ammo_check" },
    { 0x48402582, "rage_high_logic" },
    { 0x82E278F1, "rage_high_player_damage" },
    { 0x1160BFCC, "rage_high_player_damage_override" },
    { 0x89AD1059, "rage_high_player_damage_vo" },
    { 0xE60E2533, "rage_high_take_weapons" },
    { 0x9F99EC5C, "rage_high_weapon_switch_logic" },
    { 0x7FAFADC2, "rage_josefina_vo" },
    { 0x736A1DB9, "rage_low" },
    { 0x38585220, "rage_low_player_damage_override" },
    { 0x18901CC8, "rage_low_player_fire_vo" },
    { 0x367A8BE4, "rage_medium" },
    { 0x2B9CE04D, "rage_melee_player_vo" },
    { 0xAC249EE4, "rage_mode_audio_loop" },
    { 0x5E55F221, "rage_mode_create_hud_elem" },
    { 0xCAE677C5, "rage_mode_disable" },
    { 0xE63FB8CD, "rage_mode_fade" },
    { 0x783C14E7, "rage_mode_fade_image" },
    { 0x795BB9CF, "rage_mode_fade_shift_to_high" },
    { 0xBB190BDB, "rage_mode_fade_shift_to_low" },
    { 0xEA1B348B, "rage_mode_high" },
    { 0xD35173B5, "rage_mode_high_cycle_images" },
    { 0xD4EE91C0, "rage_mode_high_warping" },
    { 0xF5084B96, "rage_mode_hud" },
    { 0x59937624, "rage_mode_hud_enabled" },
    { 0x563EE535, "rage_mode_images" },
    { 0xE01E65CB, "rage_mode_important_vo" },
    { 0xB94C4DEF, "rage_mode_low" },
    { 0x91C12139, "rage_mode_low_cycle_images" },
    { 0x22D826A0, "rage_mode_low_images" },
    { 0x73CC6E46, "rage_mode_medium" },
    { 0x99C3E95C, "rage_mode_reset" },
    { 0x326F0C1B, "rage_mode_time_to_high" },
    { 0x5C14457F, "rage_mode_time_to_low" },
    { 0x6AAE3235, "rage_mode_value_high" },
    { 0x44A7FEA1, "rage_mode_value_low" },
    { 0x26CFCCF0, "rage_off" },
    { 0x1A941AEA, "rage_on" },
    { 0xB28485A3, "rage_player_invulnerability_disable_based_on_kills" },
    { 0xCD986D55, "rage_ragdoll_death" },
    { 0xBADB3416, "rage_reset" },
    { 0xAB057B9A, "rage_sprint_logic" },
    { 0x29402FDE, "rage_sprint_play" },
    { 0xDEAF9E90, "rage_sprint_stop" },
    { 0xC8710DBD, "rage_sprint_vo" },
    { 0xAA9D2863, "rage_sprinting" },
    { 0xD7B20538, "rage_timer" },
    { 0x7CD07BF5, "rage_toggle" },
    { 0x401ECA56, "rage_weapon_fire_vo_on" },
    { 0xD97C24CB, "rageloopent" },
    { 0xCDF1072B, "rageloopid" },
    { 0xF85D0CAD, "rahmaan" },
    { 0xAA9EF8ED, "raid" },
    { 0xFD5E4988, "raid_farmhouse" },
    { 0xBB0204BF, "raiders" },
    { 0x58644615, "raidus" },
    { 0xDAB2CC35, "rail" },
    { 0xB69CA396, "rail1" },
    { 0x909A292D, "rail2" },
    { 0xC9FC98CC, "rail_attack" },
    { 0x2D333238, "rail_bikes2" },
    { 0xC9CD57BE, "rail_bomber_timing" },
    { 0x178B3ECD, "rail_enemy_boat_crew_setup" },
    { 0x9D75994F, "rail_enemy_spawn_logic" },
    { 0x4B2B8B6C, "rail_fork" },
    { 0xD0CF8E0E, "rail_gaz_spawn" },
    { 0xF578A869, "rail_guys1" },
    { 0x1B7B22D2, "rail_guys2" },
    { 0xED6A4E9D, "rail_path" },
    { 0x8026BA40, "rail_ready_exit" },
    { 0xA1A64653, "rail_roadside_guys_spawner" },
    { 0xF7C0DD37, "rail_seat_taken_1" },
    { 0x85B96DFC, "rail_seat_taken_2" },
    { 0xABBBE865, "rail_seat_taken_3" },
    { 0x39B4792A, "rail_seat_taken_4" },
    { 0xDE946B6A, "rail_section_a_ends" },
    { 0x3D8726E3, "rail_section_b_ends" },
    { 0xF5E2E87C, "rail_section_c_ends" },
    { 0x04375615, "rail_section_d_ends" },
    { 0xF041CC36, "rail_section_e_ends" },
    { 0x5BE3C59F, "rail_sequence" },
    { 0x9CBE679B, "rail_standard_response" },
    { 0xEC41F180, "rail_standard_vehicle_setup" },
    { 0xD125516C, "rail_start" },
    { 0x1D5870EB, "rail_start_node" },
    { 0x89F5346B, "rail_uaz_guys" },
    { 0xA86FD6D1, "railclimb_num" },
    { 0xAF1BC2B1, "railgun_sound" },
    { 0x6A05DDB3, "railing" },
    { 0x3B480D7C, "railpoints" },
    { 0xEB364904, "rails" },
    { 0xDD7BDF93, "railturret" },
    { 0x88A030CD, "railturret_struct" },
    { 0x5E734567, "railyard_style" },
    { 0x26B7C107, "rain" },
    { 0x0E474D36, "rain_change" },
    { 0xB6496402, "rain_controller" },
    { 0xE2905B2B, "rain_debris" },
    { 0xC83E4289, "rain_ent" },
    { 0xD2D77C30, "rain_fire_challenge" },
    { 0x818B84D8, "rain_fx" },
    { 0x4270D3C3, "rain_level_change" },
    { 0xC55E3A34, "rain_loop" },
    { 0x1A11C332, "rain_tracker" },
    { 0x26BFD732, "raincontrol" },
    { 0x508573FF, "raindrops" },
    { 0xB095A394, "raineffectchange" },
    { 0x931EF949, "rainfall_fx" },
    { 0x2E5EB161, "rainfx" },
    { 0x23B8520C, "rainhard" },
    { 0xDAF4B811, "rainier" },
    { 0x10C60859, "raining" },
    { 0xE8F7718A, "raining_audio" },
    { 0xB88CC7C1, "raininit" },
    { 0xD6B45A1F, "rainlevel" },
    { 0x2BD6B155, "rainlevelrandomwait" },
    { 0x534D6CE0, "rainlevelwait" },
    { 0x75D3C725, "rainlight" },
    { 0x3CDC98E9, "rainloop" },
    { 0xA2D9C17A, "rainmedium" },
    { 0x6ECE8819, "rainnone" },
    { 0xC873665A, "rainopacity" },
    { 0x4B5702C8, "rainwater" },
    { 0x0403A14B, "raise" },
    { 0x0A388626, "raise_" },
    { 0x61AF8D50, "raise_alert" },
    { 0xD5125F67, "raise_all_crystals" },
    { 0x2ACE273B, "raise_all_points_in_height" },
    { 0xEF86908B, "raise_crystal_" },
    { 0x15AB69D8, "raise_crystal_1" },
    { 0x87B2D913, "raise_crystal_2" },
    { 0x61B05EAA, "raise_crystal_3" },
    { 0xD3B7CDE5, "raise_crystal_4" },
    { 0xADB5537C, "raise_crystal_5" },
    { 0x1FBCC2B7, "raise_crystal_6" },
    { 0x0BB6CE07, "raise_gear" },
    { 0x2C58ECD0, "raise_gun" },
    { 0x9B5FBD23, "raise_height" },
    { 0x3D17B40D, "raise_model" },
    { 0x4D45FB31, "raise_new_perm_blockers" },
    { 0x580E2B33, "raise_riotshield" },
    { 0x052EBDFF, "raise_shaft_cap" },
    { 0xA56E791A, "raise_think" },
    { 0xE90E3AEC, "raise_water_level" },
    { 0x9B4DC646, "raise_weapon" },
    { 0xF3D2EB55, "raised" },
    { 0xCCA905BD, "raised_crystal_" },
    { 0xF2E27853, "raised_crystal_4" },
    { 0xBA62FC9A, "raised_pitch" },
    { 0x2FF72FAF, "raised_start_pos" },
    { 0x45422104, "raisedenemyentorigin" },
    { 0x8D71394A, "raisegate" },
    { 0x994D00E8, "raisegunanimtraveldist" },
    { 0xC934A33E, "raisegunfinishduration" },
    { 0xCD2E4940, "raisegunfullduration" },
    { 0x50471A76, "raisegunpredictduration" },
    { 0xAEAA8E16, "raisegunstarttime" },
    { 0x52E80992, "raiseplywoodwalls" },
    { 0x30C88863, "raisepowerplantgates" },
    { 0xAFFC314A, "raisereactordoors" },
    { 0xE1F322AA, "raises" },
    { 0x25E8AB6C, "raisetargetdummies" },
    { 0x3424BBAE, "raising" },
    { 0xF8D27ED8, "raisinggun" },
    { 0x745850DC, "ralley" },
    { 0x37E91AC7, "rallies" },
    { 0x3A343A13, "rally" },
    { 0x0BF416E4, "rally_final_room" },
    { 0xF6199AB7, "rally_points" },
    { 0xEA104C24, "rally_squad" },
    { 0x8AA445E2, "rally_stop_rumble" },
    { 0x0F668635, "rally_up" },
    { 0x2AEA370D, "rallying" },
    { 0x68DF4CC7, "rallypoint" },
    { 0x6372C9BE, "rallypoints" },
    { 0x7A4F7442, "rallys" },
    { 0xA46FB366, "rallysquadtoloc" },
    { 0x7DD4F7B7, "ram" },
    { 0xE3A92470, "ram_drag" },
    { 0x259D902C, "ram_dragovich_now" },
    { 0x5030B2D6, "ram_gate_magic_rpgs" },
    { 0x04EA1876, "ram_gate_uaz" },
    { 0x714C69AE, "ram_through_stuff" },
    { 0xE887A05C, "ramage" },
    { 0xF1C2A362, "rambo" },
    { 0xC49A93B8, "rambo_45" },
    { 0xF12DD597, "ramboaccuracymult" },
    { 0x6F27FBBD, "ramboanim" },
    { 0x8DC6CFED, "ramboanimsexist" },
    { 0x8E237C8A, "rambochance" },
    { 0xD146069A, "rambojamchance" },
    { 0x3B9E6E55, "rambooutnotetrackcheck" },
    { 0xD412AFD0, "rambooutpos" },
    { 0xE35B5A78, "rambostepout" },
    { 0x0F7BF9BF, "ramboswitchangle" },
    { 0xDAE17F33, "rammed" },
    { 0x6D1A4E85, "ramp" },
    { 0x7BB59216, "ramp_blocker" },
    { 0x35B25C1F, "ramp_dvar" },
    { 0x95C61C0F, "ramp_fog_in_out" },
    { 0x95B65EA5, "ramp_in" },
    { 0xD93126A7, "ramp_in_out_thread" },
    { 0xFC37493A, "ramp_in_out_thread_hold_func" },
    { 0xC2714A65, "ramp_in_out_thread_per_player" },
    { 0xD71A7DCF, "ramp_in_out_thread_per_player_death_shutdown" },
    { 0x38DE89CB, "ramp_in_out_thread_per_player_internal" },
    { 0xD79336F6, "ramp_in_out_thread_watch_player_shutdown" },
    { 0x82BF1DF4, "ramp_in_thread_per_player" },
    { 0x17F581D4, "ramp_lighting_dvar" },
    { 0x994E6C6D, "ramp_location" },
    { 0x69FB8724, "ramp_out" },
    { 0x95472A29, "ramp_out_visionset" },
    { 0xDC7793BF, "ramp_shack_dialog" },
    { 0x58220A8B, "ramp_shack_interior" },
    { 0xC4BD2AC3, "ramp_top_main" },
    { 0x9DCB6D37, "rampage_bookmark_kill_times" },
    { 0x773B2CFF, "rampage_bookmark_kill_times_count" },
    { 0x8F9B41DB, "rampage_bookmark_kill_times_delay" },
    { 0x592BEDBA, "rampage_bookmark_kill_times_msec" },
    { 0xE81BB683, "rampagebonus" },
    { 0x4010A8DF, "rampagebonusscale" },
    { 0x93ACC56B, "rampaging" },
    { 0x32D3C38F, "rampdn" },
    { 0xA7E81B72, "ramped" },
    { 0xDD410263, "ramping" },
    { 0xE4E53371, "ramping_water_movement_speed" },
    { 0xC4612EF7, "rampinshader" },
    { 0x7477BA14, "ramps" },
    { 0xE55A1422, "ramptime" },
    { 0x4D96F8F6, "rampup" },
    { 0x540DA371, "rampupdegrees" },
    { 0x4A9DEC5C, "rampupsun" },
    { 0x931CC8EE, "rams" },
    { 0x0AACCBCE, "ramses" },
    { 0x0BCD887C, "ran" },
    { 0xB971D8F0, "rand" },
    { 0xDC837AE8, "rand_anim" },
    { 0xC48B8F5B, "rand_chance" },
    { 0x2C11005F, "rand_death" },
    { 0x5DA59D5C, "rand_drop" },
    { 0x703F0A06, "rand_end" },
    { 0x9F49C6F3, "rand_f" },
    { 0xC08ECC18, "rand_guy" },
    { 0x3869B719, "rand_index" },
    { 0xD52371D2, "rand_int" },
    { 0xE84532DC, "rand_lines" },
    { 0x441C25AF, "rand_locs_num" },
    { 0x5C94AB01, "rand_num" },
    { 0x2DC80428, "rand_nums" },
    { 0xDE186E28, "rand_pct" },
    { 0xEB41B99F, "rand_region" },
    { 0xF3ACB0AB, "rand_scale" },
    { 0xC82B744C, "rand_spline" },
    { 0x6D8AA4FF, "rand_spot" },
    { 0xB57DF706, "rand_spots" },
    { 0x05A21D9D, "rand_sprint_anim" },
    { 0xE2005F21, "rand_tag" },
    { 0x0C505134, "rand_time" },
    { 0xCE37913C, "rand_val" },
    { 0xC39CF986, "rand_value" },
    { 0x22598B38, "rand_wait" },
    { 0x71A6C1E0, "rand_walk_anim" },
    { 0x5B1341ED, "rand_x" },
    { 0x3510C784, "rand_y" },
    { 0xD46FA444, "randchar" },
    { 0x01F81326, "randf" },
    { 0x2AEE3309, "randgroup" },
    { 0xFE1C4964, "randindex" },
    { 0x2DED5933, "randint" },
    { 0xBA5ACA14, "randnode" },
    { 0x47D18840, "random" },
    { 0x5AB24F9E, "random_50_cal_line" },
    { 0x9A7D6D75, "random_ai" },
    { 0xC8BFC749, "random_alarms" },
    { 0xBF4F53D0, "random_angle" },
    { 0x035D990D, "random_angle_x" },
    { 0xDD5B1EA4, "random_angle_y" },
    { 0x4F628DDF, "random_angle_z" },
    { 0xFBED60F8, "random_anim" },
    { 0xD47F0C47, "random_antinov_warn" },
    { 0x638E0B94, "random_around_player" },
    { 0x1EE315EA, "random_array" },
    { 0xAA3F540B, "random_arty_strikes" },
    { 0xAEBB3762, "random_arty_strikes_cleanup_soundspot" },
    { 0x8649AAAB, "random_arty_strikes_sound" },
    { 0xC0A20F80, "random_attachment" },
    { 0xEE914EB1, "random_attack_struct" },
    { 0x63FA2C5E, "random_banzai" },
    { 0x679F2EBC, "random_bullet_tracers" },
    { 0x2D105128, "random_burn_anim" },
    { 0xC420E8D5, "random_camo_id" },
    { 0xCCD6B893, "random_camo_name" },
    { 0xF38CC12B, "random_chance" },
    { 0xF9617F0A, "random_choice" },
    { 0x204C35F0, "random_cow_stampede" },
    { 0xF5613F80, "random_crash" },
    { 0x7FD5420A, "random_cycles" },
    { 0x951293C3, "random_damage_warn" },
    { 0xE281666F, "random_death" },
    { 0xC6ED7CA2, "random_death_at_end_node" },
    { 0x0510D3D0, "random_delay" },
    { 0x660307FA, "random_destroyed_chunk_show" },
    { 0x583CD98A, "random_destructdef" },
    { 0xE8ED395D, "random_direction_die" },
    { 0x5570D693, "random_dist" },
    { 0x6D9FBFFD, "random_dmg" },
    { 0xD9F3C182, "random_drone_index" },
    { 0xDE287E17, "random_dude" },
    { 0xE021ACB3, "random_earthquakes" },
    { 0x34721B8F, "random_elevator_perks" },
    { 0xDEDE1F9A, "random_friendly_target" },
    { 0x560B3371, "random_fx" },
    { 0x8A526756, "random_gibs" },
    { 0x1A5412F2, "random_grenade_chance" },
    { 0x3EDCE114, "random_gun_shots_behind_player" },
    { 0x2395974C, "random_height_offset" },
    { 0xBC444766, "random_human" },
    { 0x29CE0969, "random_index" },
    { 0xBCCEB062, "random_int" },
    { 0xE6D86064, "random_int_not_in_array" },
    { 0x70785118, "random_int_offset" },
    { 0x722F7011, "random_killspawner" },
    { 0x19A9ABA7, "random_leave_node" },
    { 0x9FC6906D, "random_line" },
    { 0xFF2BE6CA, "random_melee_anims" },
    { 0xE550902D, "random_mg_target" },
    { 0x03762BCA, "random_name" },
    { 0x51322F8F, "random_node" },
    { 0x2EE72C0B, "random_normal_distribution" },
    { 0xE165A011, "random_num" },
    { 0x772D77C7, "random_num_shots" },
    { 0x86C0BC98, "random_number" },
    { 0x9B234576, "random_offest" },
    { 0x1F6663E6, "random_offset" },
    { 0xD1997277, "random_offset_x" },
    { 0xAB96F80E, "random_offset_y" },
    { 0x85947DA5, "random_offset_z" },
    { 0x4F7F6B73, "random_org" },
    { 0x94F2DF22, "random_outer_box" },
    { 0x40208483, "random_pandora_box_start" },
    { 0x16BB0C0A, "random_path" },
    { 0x708CA82B, "random_path_up_stairs" },
    { 0xD6C1340F, "random_perk" },
    { 0xAB8A6005, "random_perk_machine" },
    { 0x86202AEE, "random_perk_move_max" },
    { 0xD8F799B0, "random_perk_move_min" },
    { 0x73E4EA04, "random_perk_moving" },
    { 0x19DE5BA0, "random_perk_start_machine" },
    { 0xE3D208F8, "random_perk_structs" },
    { 0xAEA0696B, "random_pitch" },
    { 0xC18ACFB8, "random_player" },
    { 0x68114CAD, "random_player_origin" },
    { 0x38FFA0F3, "random_player_seek" },
    { 0xAC19B81B, "random_point" },
    { 0xC96EC475, "random_radio_locations_after_first" },
    { 0xA15D6DEB, "random_radio_locations_off" },
    { 0x790C0217, "random_radio_locations_on" },
    { 0xCCD39AD2, "random_reels" },
    { 0xF2D7F9DB, "random_revive_structs" },
    { 0x7AEF779A, "random_right_spawner_2_strat" },
    { 0x15DCD975, "random_rockets_stop" },
    { 0xBFD3F2A2, "random_roll" },
    { 0x4CFEF181, "random_rpg_trails_behind_player" },
    { 0x0F1A5312, "random_shuffle" },
    { 0x261FDDCC, "random_size" },
    { 0x93511444, "random_sound" },
    { 0xD41DABC0, "random_spawn" },
    { 0x9C5BEFE4, "random_spawners" },
    { 0xA68A36E8, "random_speed" },
    { 0x3A85801C, "random_spline" },
    { 0x40096BAF, "random_spot" },
    { 0xC47B9502, "random_spread" },
    { 0x4D7A3D67, "random_sprint" },
    { 0xAE6C58ED, "random_sprint_time" },
    { 0x6351340A, "random_start_point" },
    { 0xAB88F040, "random_tan" },
    { 0xA6DEFB30, "random_target" },
    { 0x37A6047F, "random_target_vo_set" },
    { 0x6D1DA74A, "random_targs" },
    { 0x5E5319E4, "random_time" },
    { 0x250C720C, "random_time_in_range" },
    { 0xD24CEB31, "random_tire" },
    { 0x158E4F04, "random_turbulence" },
    { 0x7777F0C7, "random_underwater_tracers" },
    { 0x4E8104AE, "random_vector" },
    { 0xEC5610A3, "random_voice" },
    { 0xB28A99C8, "random_wait" },
    { 0xED6C08FE, "random_wait_offset" },
    { 0x5DD2B9EC, "random_wait_time" },
    { 0x2CB30E68, "random_walk" },
    { 0x229C1422, "random_weap_int" },
    { 0x8E27E18B, "random_weapon" },
    { 0xD7E1F621, "random_weapon_int" },
    { 0x1E58F7F2, "random_weapon_powerup" },
    { 0x3DEE5D59, "random_weapon_powerup_throttle" },
    { 0x3321657D, "random_weapon_powerups" },
    { 0x351DF91F, "random_weaver" },
    { 0x7BBC1333, "random_weight" },
    { 0xC9A3E270, "random_yaw" },
    { 0x01E53D4B, "random_z_offset" },
    { 0x2B6EC83C, "random_zone_locations_after_first" },
    { 0xB4F0F53A, "random_zone_locations_off" },
    { 0x5273EAEC, "random_zone_locations_on" },
    { 0x994818E6, "randomaditionaltime" },
    { 0xA07ED089, "randomangle" },
    { 0x157E8505, "randomanimrate" },
    { 0xAAF482F2, "randomattackidle" },
    { 0x03DA6324, "randomchance" },
    { 0xCA557CC1, "randomchoice" },
    { 0xCB3AD2DF, "randomconstantnumber" },
    { 0xE17D5221, "randomdelayfloat" },
    { 0x6C340CD8, "randomelement" },
    { 0x13CDD99F, "randomexploder" },
    { 0x7E819202, "randomfade" },
    { 0x14E67F9D, "randomfasteranimspeed" },
    { 0xBF98B9A9, "randomflags" },
    { 0xDDEA61DD, "randomflat" },
    { 0x62E4226E, "randomfloat" },
    { 0x72A94F05, "randomfloatrange" },
    { 0x0087B153, "randomfxorigins" },
    { 0xE11107CF, "randomgadgetnumber" },
    { 0x0FACC77C, "randomgibroguerobot" },
    { 0x645174A1, "randomgrenaderange" },
    { 0xC3A5E1E2, "randomhalfrange" },
    { 0x344BD24A, "randomhqspawn" },
    { 0x4F4F1B34, "randomindex" },
    { 0x26299103, "randomint" },
    { 0xDC99997A, "randomintrange" },
    { 0xF837DEF1, "randominttable" },
    { 0xE4D5BC7E, "randominttablesize" },
    { 0x9725A688, "randomization" },
    { 0x33D10DA3, "randomization_done" },
    { 0x8332F7F6, "randomize" },
    { 0x98483E3C, "randomize_array" },
    { 0xCDC13AEC, "randomize_craftable_spawns" },
    { 0xF79C58D9, "randomize_cyclic_index" },
    { 0x88AEB040, "randomize_dog_powerup_drop" },
    { 0x8B33296A, "randomize_goalradius" },
    { 0x7ADA93B1, "randomize_gongs" },
    { 0x5004C330, "randomize_maze_perms" },
    { 0x63868750, "randomize_mode" },
    { 0x3E85D2C7, "randomize_name_list" },
    { 0xC87A882B, "randomize_order" },
    { 0x94B78717, "randomize_perk_machine_location" },
    { 0x7F4EEEF4, "randomize_perks" },
    { 0x92917578, "randomize_pooled_buildables" },
    { 0xAE3B54F6, "randomize_powerups" },
    { 0xA3244C64, "randomize_side" },
    { 0x3D5B0A17, "randomize_start_location" },
    { 0x6A7EFEA7, "randomize_target_radius" },
    { 0x980B3CD5, "randomize_vending_machines" },
    { 0x3850C364, "randomize_weapons" },
    { 0xC0FE9173, "randomize_weapons_for_building" },
    { 0x07D685C3, "randomize_weather" },
    { 0xD6585A86, "randomized" },
    { 0x88D537D2, "randomizedangles" },
    { 0x293BE27A, "randomizeflashanimarray" },
    { 0x4A8B594E, "randomizeguardcharacter" },
    { 0x52F521A4, "randomizeidleset" },
    { 0x3E54CF63, "randomizelocation" },
    { 0xF8B4DBBC, "randomizemilitiaarray" },
    { 0x9221D580, "randomizer" },
    { 0xB8244FE9, "randomizes" },
    { 0x320CA138, "randomizetargetarray" },
    { 0x040BF8EF, "randomizing" },
    { 0x58512EAA, "randomlineindex" },
    { 0x3D8EEB6D, "randomlocs" },
    { 0xEC480785, "randomly" },
    { 0xD07C8891, "randomly_destroy_drone" },
    { 0x7FB8886D, "randomly_get_shot_from_behind" },
    { 0x91A61D0A, "randomminibosses" },
    { 0x86DBC849, "randomnavmeshpoints" },
    { 0x2A678981, "randomness" },
    { 0xF4713CE3, "randomness_range" },
    { 0xC5D96293, "randomoccurrance" },
    { 0xF25BD08D, "randomoffsetpitch" },
    { 0xD4E0F17A, "randomoffsetyaw" },
    { 0xD26996CC, "randomoneshot" },
    { 0xFAA71BA5, "randompath" },
    { 0x99339BAE, "randompiece" },
    { 0x7ABDAC02, "randompitch" },
    { 0xE55982C2, "randompoint" },
    { 0x4C15CF79, "randomposition" },
    { 0x2272154F, "randomrange" },
    { 0x4BFB8A61, "randomroll" },
    { 0x60B9456B, "randoms" },
    { 0x5EEAD8E6, "randomscale" },
    { 0x5EB06716, "randomscore" },
    { 0x5895E90B, "randomshots" },
    { 0x99A57E63, "randomsign" },
    { 0x8E0127AF, "randomsoundduringrunloop" },
    { 0xBC371E61, "randomstartdelay" },
    { 0xE1508EC7, "randomswingangle" },
    { 0x80FDDA2D, "randomswingtime" },
    { 0x111B13D1, "randomtestpoints" },
    { 0x4A553A8E, "randomthreatwaiter" },
    { 0x565BA2FF, "randomtries" },
    { 0xC7D1AAD3, "randomunitdelay" },
    { 0xD17DECBD, "randomval" },
    { 0x0BC3B836, "randomvec" },
    { 0x88128F1D, "randomvector" },
    { 0x33760424, "randomvibrateamplitude" },
    { 0x3843C956, "randomvibratetime" },
    { 0x6B9D0CD3, "randomwait" },
    { 0xF4A6AE3C, "randomweapon" },
    { 0xFBFE8F00, "randomweight" },
    { 0xBD9F58FF, "randomweightend" },
    { 0x454C3701, "randomyaw" },
    { 0x5AAD3F5F, "randomzonespawn" },
    { 0x8A7D1112, "randpointradiusaway" },
    { 0x3F793ACD, "randsound" },
    { 0x20CE2D4B, "randstruct" },
    { 0x267F1BAE, "randtireindex" },
    { 0x94037E66, "randvec" },
    { 0x1F9C80C3, "randwait" },
    { 0x417BB92C, "randweapon" },
    { 0xEDD56168, "randx" },
    { 0x13D7DBD1, "randy" },
    { 0x4DE1F24C, "range" },
    { 0x5E5B513B, "range_additive" },
    { 0x11CCF45B, "range_attack" },
    { 0xB0EF84C1, "range_func" },
    { 0x172BFE84, "range_inner_sq" },
    { 0xCEBBB65D, "range_mod" },
    { 0xFB942E9F, "range_sq" },
    { 0xBA478F26, "range_squared" },
    { 0x58868A25, "range_trigger" },
    { 0x7F09FC4B, "rangecountdownactive" },
    { 0x0FC5AB78, "rangehigh" },
    { 0xC2007BD2, "rangelow" },
    { 0x1C4F52D6, "rangemax" },
    { 0xC73AB6DB, "rangemaxtext" },
    { 0x015A2728, "rangemin" },
    { 0x3FB9BE4D, "rangemintext" },
    { 0xD8BA434A, "rangeorigin" },
    { 0xD3CAF066, "ranger" },
    { 0xF9CD6ACF, "ranges" },
    { 0xC6E5B5C4, "rangesq" },
    { 0x4C190C0E, "rangesqr" },
    { 0xE0B74138, "rangetrigger" },
    { 0x08D5FDF5, "ranging" },
    { 0x2F673B2A, "rangle" },
    { 0xC2B967E5, "rangles" },
    { 0x17BE0C6B, "ranit" },
    { 0xF3970517, "rank" },
    { 0x006E4FEE, "rank_char" },
    { 0x88283C84, "rank_init" },
    { 0x8A04B221, "rank_shared" },
    { 0x8E608CE9, "rankcap" },
    { 0x5D7F20DC, "ranked" },
    { 0x5D406297, "rankedmatch" },
    { 0x67EB0CC2, "rankenabled" },
    { 0x55417986, "rankicontable_name" },
    { 0x30934BE8, "rankid" },
    { 0x6959CDC9, "ranking" },
    { 0x152ED22F, "ranklevel" },
    { 0xB628C2AA, "rankname" },
    { 0x74E3ED71, "ranknotifyqueue" },
    { 0x7A142E78, "ranknumber" },
    { 0xD2F93CCE, "ranks" },
    { 0xE1F2C330, "ranksettings" },
    { 0x18B023E5, "ranktable" },
    { 0xB7E5F751, "ranktable_name" },
    { 0x709AF5CA, "rankupdatetotal" },
    { 0x5753F897, "rankxp" },
    { 0xA9FE6369, "rankxpcap" },
    { 0x80191F90, "rankxpcapped" },
    { 0xF48CC5AC, "ranom" },
    { 0xEA0CD492, "ransack_walla" },
    { 0xAC4036DA, "ransacking" },
    { 0x8F449CB3, "rap_enemy" },
    { 0xEAFC86F0, "rap_friendly" },
    { 0x65FC299D, "rapel" },
    { 0xD88C3406, "rapel_ref_node" },
    { 0x7E4D7DA2, "rapelled_in" },
    { 0x1B9F0505, "rapelling" },
    { 0x873C1B4D, "raphat" },
    { 0xD2E1BA39, "raphhat" },
    { 0xD96B2B61, "rapid" },
    { 0xDD7B91A2, "rapid_strike" },
    { 0x469A6BEC, "rapidly" },
    { 0x2B524F11, "rappel" },
    { 0x70DB1704, "rappel_1h_grab" },
    { 0x9E48F9D0, "rappel_1h_grab_notify" },
    { 0x9EEE9D7E, "rappel_ai" },
    { 0x52F631A6, "rappel_ai_move_around_underpass" },
    { 0xFB7A1C2C, "rappel_ai_temp_ignore" },
    { 0xF6C790C3, "rappel_anim" },
    { 0xEA0149CC, "rappel_brake_button" },
    { 0x7C533488, "rappel_brake_to_loop_anim" },
    { 0xB2ABC0A5, "rappel_break_success" },
    { 0x65445522, "rappel_buffer" },
    { 0xEA85B688, "rappel_button" },
    { 0x3C0847B4, "rappel_calulate_animation_points" },
    { 0x6CCB1E48, "rappel_charge" },
    { 0x5FECD37E, "rappel_dialogue" },
    { 0x7CCF9AD4, "rappel_done" },
    { 0x0F1C0778, "rappel_down" },
    { 0xE95784EA, "rappel_down_vent" },
    { 0x9944FC0C, "rappel_drop_signs" },
    { 0x71BBDEBA, "rappel_dropoff" },
    { 0x9733C907, "rappel_dropoff_trigger" },
    { 0xAA953283, "rappel_end" },
    { 0x925ABFC0, "rappel_end_pos" },
    { 0x18BA434D, "rappel_face_player" },
    { 0x672BE4DE, "rappel_gaz_ready" },
    { 0xF40EE471, "rappel_get_data_struct" },
    { 0x17DA4450, "rappel_glass_break" },
    { 0xBCB88BE9, "rappel_group_1" },
    { 0xE2BB0652, "rappel_group_2" },
    { 0x927B916D, "rappel_guy" },
    { 0x282E92AC, "rappel_guy_counter" },
    { 0x8A855FB8, "rappel_guy_function" },
    { 0xF268F16C, "rappel_guys" },
    { 0x55AE9AC8, "rappel_handle_ai_death" },
    { 0xC06DD0AB, "rappel_handle_rope_creation" },
    { 0x257BBA1E, "rappel_handle_rope_deletion" },
    { 0x37648DA7, "rappel_helicopter" },
    { 0x80505858, "rappel_helicopter_waits" },
    { 0xFF93219F, "rappel_hint" },
    { 0xCF80442A, "rappel_hookup" },
    { 0x1303713D, "rappel_hookup_done" },
    { 0x0A2392C9, "rappel_in" },
    { 0x64A00A42, "rappel_in_anim_length" },
    { 0x8B5BCA1C, "rappel_in_dist" },
    { 0x35AF58EA, "rappel_init" },
    { 0x230AFEAE, "rappel_init_1h" },
    { 0xE4244B63, "rappel_init_2h" },
    { 0xE0B18106, "rappel_initialized" },
    { 0xCEB8968F, "rappel_kamarov_ready" },
    { 0x12DC5730, "rappel_kickoff_to_loop_anim" },
    { 0x8DC06A8D, "rappel_kills_challenge" },
    { 0xB609BEC0, "rappel_left_origin" },
    { 0x3C85CC0B, "rappel_lookat_trigger" },
    { 0x1A7F667B, "rappel_move_ai_thread" },
    { 0x585C7FD8, "rappel_move_ent_think" },
    { 0xC2682680, "rappel_obj_org" },
    { 0x007DF75F, "rappel_option" },
    { 0xCD71D0D6, "rappel_org" },
    { 0x561A8FE0, "rappel_out" },
    { 0x6FD848F3, "rappel_out_dist" },
    { 0x2C54323F, "rappel_out_of_hotel" },
    { 0x00DFFF42, "rappel_pause" },
    { 0xB219BA00, "rappel_play_custom_anim" },
    { 0x9F8B25A0, "rappel_player_hookup" },
    { 0x5F0B7EA2, "rappel_point_struct" },
    { 0x9AE7457F, "rappel_precache" },
    { 0x819B1555, "rappel_prepare" },
    { 0xAC2586AD, "rappel_resume" },
    { 0xF90B5238, "rappel_rope" },
    { 0xA3D614CE, "rappel_set_can_fail" },
    { 0x7C064926, "rappel_set_clear_data_after_landing" },
    { 0x60DD0AA4, "rappel_set_control_scheme" },
    { 0xFE61506D, "rappel_set_data_struct" },
    { 0x5C2BDBB2, "rappel_set_depth_of_field_parameters" },
    { 0xDD28AAD8, "rappel_set_drop_and_stop_parameters" },
    { 0xD5DAB70A, "rappel_set_falling_death_quote" },
    { 0x7EB1655C, "rappel_set_ground_tolerance_height" },
    { 0x10B3E137, "rappel_set_hint_strings" },
    { 0x8F47D3B5, "rappel_set_viewcone" },
    { 0xC22D71DB, "rappel_set_viewmodel" },
    { 0xC24F8D26, "rappel_set_wall_rappel" },
    { 0xF8EC0D55, "rappel_shoot_glass_out" },
    { 0xF66A9B30, "rappel_spawner" },
    { 0xB2573170, "rappel_start" },
    { 0x3AE5ED03, "rappel_started" },
    { 0x6CEC3617, "rappel_struct" },
    { 0x14FE7A68, "rappel_struct_handle_rope_deletion" },
    { 0x42123D09, "rappel_struct_left" },
    { 0x622D2734, "rappel_struct_right" },
    { 0xD4155FCE, "rappel_structs" },
    { 0x9B94EAA0, "rappel_trigger" },
    { 0xE6D89CBD, "rappel_truck_explosion" },
    { 0xEC0A09E6, "rappel_unloading_done" },
    { 0x02D677B0, "rappel_update_anim_set" },
    { 0xB5916BAE, "rappel_viewmodel" },
    { 0xF660B284, "rappel_watch_heli_destroyed" },
    { 0x8BA771EC, "rappel_watcher" },
    { 0xF17AECF0, "rappel_window_breach" },
    { 0x24E6F474, "rappel_window_breech" },
    { 0xEC105E7B, "rappelcrash01" },
    { 0x7A08EF40, "rappelcrash02" },
    { 0x3F0B2C0B, "rappelcrash_start" },
    { 0xD5A502D8, "rappeler" },
    { 0x3CA342B3, "rappelers" },
    { 0x5336D4F3, "rappelers_name" },
    { 0x8CA79432, "rappelfix" },
    { 0xE2E6145B, "rappelfix_start" },
    { 0x6D473BF7, "rappeling" },
    { 0xEB3940FF, "rappell" },
    { 0xF0D07C1B, "rappeller_spawner" },
    { 0xB381450D, "rappellers" },
    { 0x1F184B81, "rappelling" },
    { 0x911632C1, "rappelnode" },
    { 0x2317E1B7, "rappelobjmodel" },
    { 0x716361F8, "rappels" },
    { 0xB3F02269, "rappels_finished" },
    { 0xA7941EDD, "raps" },
    { 0x8C5EE611, "raps_allowfriendlyfiredamage" },
    { 0x75D8E23B, "raps_audio_cleanup" },
    { 0x296D9B47, "raps_callback_damage" },
    { 0x66C4CAD4, "raps_can_reach_inaccessible_location" },
    { 0x70656985, "raps_complete" },
    { 0xAAB333E2, "raps_custom_player_shellshock" },
    { 0xAADB7D56, "raps_death" },
    { 0x9EE8F21C, "raps_drone_name" },
    { 0xA6025843, "raps_enabled" },
    { 0x977DFBE0, "raps_explode_fx" },
    { 0x83841B23, "raps_far_distance" },
    { 0x8C43583A, "raps_find_closest_in_global_pool" },
    { 0xA5AE5B79, "raps_force_get_enemies" },
    { 0x93E05B23, "raps_force_patrol_behavior" },
    { 0x70D73C6A, "raps_get_target_position" },
    { 0xDAE2C0A8, "raps_half_gravity" },
    { 0x2A8DF909, "raps_health_increase" },
    { 0xC62483B2, "raps_hedeps_avoid_radius" },
    { 0x919FA081, "raps_hedeps_avoid_radius_sqr" },
    { 0x73AB2413, "raps_hedeps_debug" },
    { 0x849F6B3C, "raps_hedeps_first_point_percent_of_total" },
    { 0xDCB7276E, "raps_hedeps_reduce_radius_retries" },
    { 0xCCCF132E, "raps_hedeps_unspecified_avoid_point" },
    { 0x93C5FDA6, "raps_helav" },
    { 0x1BAC810E, "raps_helav_always_pick_new_goal_post_back_off" },
    { 0x5AB630CB, "raps_helav_back_off_factor_max" },
    { 0x30242585, "raps_helav_back_off_factor_min" },
    { 0x0F3CBC9D, "raps_helav_cautious_mode_accel" },
    { 0x4477DBE2, "raps_helav_cautious_mode_decel" },
    { 0x3CF8B102, "raps_helav_debug" },
    { 0xC5301671, "raps_helav_drive_mode_cautious" },
    { 0xF0473DA8, "raps_helav_drive_mode_expedient" },
    { 0x553BCDDB, "raps_helav_drive_mode_more_cautious" },
    { 0xF369993C, "raps_helav_expedient_mode_accel" },
    { 0x3DC2DCE7, "raps_helav_expedient_mode_decel" },
    { 0xBB710B6A, "raps_helav_forward_offset" },
    { 0xE7B0E121, "raps_helav_full_stop_distance" },
    { 0xD3FD9836, "raps_helav_full_stop_distance_sqr" },
    { 0x1C4E15DC, "raps_helav_full_stop_mode_accel" },
    { 0x0DEF1C87, "raps_helav_full_stop_mode_decel" },
    { 0xDEC0A534, "raps_helav_in_front_dot" },
    { 0x6B4B9337, "raps_helav_min_pick_new_goal_time_ms" },
    { 0x9B91BFB5, "raps_helav_min_time_between_full_stops_ms" },
    { 0xED4D368E, "raps_helav_need_new_goal_distance" },
    { 0x7DA5A785, "raps_helav_need_new_goal_distance_sqr" },
    { 0x0C44211F, "raps_helav_other_forward_offset" },
    { 0xA4534501, "raps_helav_slow_down_distance" },
    { 0x2E2621D6, "raps_helav_slow_down_distance_sqr" },
    { 0xF0C1C9FA, "raps_helav_slow_down_more_scale_factor" },
    { 0xABE6BD2C, "raps_helav_slow_down_speed_scale_factor" },
    { 0x08D56997, "raps_helav_stop_wait_before_next_drop_point_ms" },
    { 0xC4D7C324, "raps_helav_time_between_updates" },
    { 0x6FB556E8, "raps_heli_death_fx" },
    { 0x38FFDDC9, "raps_heli_death_fx_tag" },
    { 0xDECE7F13, "raps_heli_death_trail_fx" },
    { 0x22D9D296, "raps_heli_death_trail_fx_tag_a" },
    { 0xFCD7582D, "raps_heli_death_trail_fx_tag_b" },
    { 0xD6D4DDC4, "raps_heli_death_trail_fx_tag_c" },
    { 0x3F9940F5, "raps_heli_first_explo_fx" },
    { 0xB595D6D8, "raps_heli_first_explo_fx_tag" },
    { 0x3DAFF2EF, "raps_heli_post_death_fx_ghost_delay" },
    { 0x5C38F076, "raps_helicopter_debug_auto_reactivate" },
    { 0x10E0FF48, "raps_helicopter_drop_duration" },
    { 0xD499B773, "raps_helicopter_drop_duration_delta" },
    { 0x116651DB, "raps_helicopter_drop_duration_last" },
    { 0xF19DADAC, "raps_helicopter_drop_duration_last_delta" },
    { 0xB95F40A3, "raps_helicopter_drop_interval" },
    { 0xC11AB49D, "raps_helicopter_drop_location_count" },
    { 0x156D71DA, "raps_helicopter_drop_location_tolerance_sqr" },
    { 0xDA6686E1, "raps_helicopter_drop_offset" },
    { 0x443EA6DD, "raps_helicopter_drop_tag_names" },
    { 0xC4573CCD, "raps_helicopter_fly_height" },
    { 0x868E7013, "raps_helicopter_hacks_to_destroy" },
    { 0x77FD5D48, "raps_helicopter_health" },
    { 0x599B653E, "raps_helicopter_info" },
    { 0xCEC68DE3, "raps_helicopter_leave_location_reached_sqr" },
    { 0x54CB7B36, "raps_helicopter_missile_damage" },
    { 0x3FC0FCBC, "raps_helicopter_missiles_to_destroy" },
    { 0xA98FD1DD, "raps_helicopter_model" },
    { 0x6FDEF2A1, "raps_helicopter_nav_additional_trace_height" },
    { 0xB85EB2E9, "raps_helicopter_nav_debug_visit_all" },
    { 0x23AC1D5F, "raps_helicopter_nav_debug_visit_all_fake_leave" },
    { 0x5981ADBC, "raps_helicopter_nav_end_point_trace_offset" },
    { 0x1F708251, "raps_helicopter_nav_map_center_max_offset" },
    { 0x49A30145, "raps_helicopter_nav_max_point_count" },
    { 0x171BC72C, "raps_helicopter_nav_point_spacing" },
    { 0x050FA534, "raps_helicopter_nav_point_trace_debug" },
    { 0x7DF98ACD, "raps_helicopter_nav_radius_max" },
    { 0xFB0E48C3, "raps_helicopter_nav_radius_min" },
    { 0x96A0F0E3, "raps_helicopter_nav_spacious_point_boundary" },
    { 0xD47ABE70, "raps_helicopter_nav_trace_box_width" },
    { 0xCE88150F, "raps_helicopter_remote_missile_damage" },
    { 0x780ABE03, "raps_helicopter_remote_missiles_to_destroy" },
    { 0x5E3F646C, "raps_helicopter_shutdown" },
    { 0x73DB071E, "raps_helicopter_z_offset" },
    { 0x43C5D011, "raps_helicopter_z_offset_per_heli" },
    { 0x5B16765A, "raps_helicopters" },
    { 0x77D69813, "raps_helicotper_hacker_tool_damage" },
    { 0x6B8375C8, "raps_hurt_trigger_immune_duration_ms" },
    { 0xFCDE5D10, "raps_impact_location" },
    { 0xE1DE20DF, "raps_in_air_audio" },
    { 0x50AA1D36, "raps_init" },
    { 0xD4BCED62, "raps_initialize" },
    { 0xE67270EB, "raps_iwus_force_timeout_test" },
    { 0x12C1D6DC, "raps_iwus_raps_radius" },
    { 0x82D8B216, "raps_iwus_settle_on_mesh_timeout" },
    { 0xF13175D8, "raps_iwus_wait_interval" },
    { 0xA38D4497, "raps_iwus_z_settle_timeout" },
    { 0xFFDBF15F, "raps_iwus_z_speed_threshold" },
    { 0x38FA43EA, "raps_jump_height" },
    { 0x0CD95522, "raps_melee_range" },
    { 0x0A367560, "raps_meteor" },
    { 0x70B7EA07, "raps_model" },
    { 0x5D6B4FEF, "raps_mp" },
    { 0x3C5CAD49, "raps_name" },
    { 0x55AFB930, "raps_recent_explosions" },
    { 0xF66C0B58, "raps_round" },
    { 0x3F53D4C9, "raps_round_aftermath" },
    { 0x8D723B0C, "raps_round_count" },
    { 0x4E5D77B2, "raps_round_ending" },
    { 0x0540E640, "raps_round_spawning" },
    { 0x6B56A03D, "raps_round_start" },
    { 0xD87EECAB, "raps_round_starting" },
    { 0x79F0236F, "raps_round_stop" },
    { 0x4800147B, "raps_round_track_override" },
    { 0x6A5700A1, "raps_round_tracker" },
    { 0x4A047C7D, "raps_round_wait_func" },
    { 0xE55EED95, "raps_rounds_enabled" },
    { 0x4485F406, "raps_run_think" },
    { 0xD90BE9A7, "raps_settings" },
    { 0x9A8C88D4, "raps_sleep_duration" },
    { 0x769680CD, "raps_spawn" },
    { 0xAC32A52E, "raps_spawn_audio" },
    { 0x51593182, "raps_spawn_func" },
    { 0x5A37DE3A, "raps_spawn_fx" },
    { 0x832F3A1D, "raps_spawner_init" },
    { 0xB15F9E1F, "raps_spawners" },
    { 0x49DDD1FA, "raps_stalk_audio" },
    { 0xBB7A82FA, "raps_targets" },
    { 0x584704F1, "raps_thundergun_knockdown" },
    { 0xB6EA838A, "raps_timeout_after_xsec" },
    { 0xCB7FBC50, "raps_updated_" },
    { 0x3F7C06C0, "raps_vehicle" },
    { 0xE7A67A87, "raps_whoosh_before_impact_time" },
    { 0xF7739DBB, "rapsai" },
    { 0xCEF064BA, "rapsdamage" },
    { 0xCAE74906, "rapsdetonatecountdown" },
    { 0x545E4541, "rapshelicopterdynamicavoidance" },
    { 0x680281CE, "rapshelicopterdynamicavoidanceupdate" },
    { 0xE316819A, "rapskilled" },
    { 0xBF238099, "rapsonburnraps" },
    { 0xA14D56DC, "rapsround_nomusic" },
    { 0xB57D481E, "rapturous" },
    { 0x2E4C8A6D, "rare" },
    { 0x9730BC13, "rare_door_audio" },
    { 0xBA977ED0, "rare_powerups_active" },
    { 0xFA068690, "rarely" },
    { 0xA18FC3A0, "rarhhhh" },
    { 0x37BC6812, "rasulka" },
    { 0xC7970376, "rat" },
    { 0x8D0199B4, "rat_01" },
    { 0x74726F61, "rat_01_start" },
    { 0xFF0908EF, "rat_02" },
    { 0xD9068E86, "rat_03" },
    { 0xBF77472C, "rat_delete" },
    { 0xE49CC179, "rat_hole_1_started" },
    { 0x12192E39, "rat_hole_lid_01" },
    { 0xFCDA6528, "rat_hole_lid_01_start" },
    { 0x381BA8A2, "rat_hole_lid_02" },
    { 0x5434296B, "rat_hole_lid_02_start" },
    { 0xAD2CBC9A, "rat_shared" },
    { 0x911F9756, "rat_stop_anims" },
    { 0x9B50CC78, "rat_tunnel_already_started" },
    { 0x25D8EF6F, "rate" },
    { 0xC6B26CD4, "rate_capture" },
    { 0xD3B639E2, "rate_capture_solo" },
    { 0xA84F030C, "rate_decay" },
    { 0x51274291, "rate_recapture" },
    { 0x68BB9272, "rate_recapture_players" },
    { 0xA06B79E1, "rateblendfactor" },
    { 0xBF787110, "rateofchange" },
    { 0xB2546E20, "rateofspin" },
    { 0x46CAB33E, "ratepercent" },
    { 0x89AB0CB6, "rates" },
    { 0x09CE82DB, "rather" },
    { 0x012B17C8, "rathole" },
    { 0xA63C6C2F, "rathole_open_timeout" },
    { 0xF1A41FE3, "ratholes" },
    { 0x2E29D79E, "ratio" },
    { 0x8CD073A5, "ratio_avenger" },
    { 0xA4D63FBB, "ratio_avenger_percent" },
    { 0xF5DD4B8A, "ratio_next" },
    { 0xA8BBA4CB, "ratio_pegasus" },
    { 0xDBB3C809, "ratio_pegasus_percent" },
    { 0x5098F394, "ratiodistancefromscreencenter" },
    { 0x74C5F25E, "ratmovespeed" },
    { 0x3B7C7DBA, "ratmovetime" },
    { 0xC5271A28, "ratrotatetime" },
    { 0xE1A26A69, "rats" },
    { 0xC7E851A6, "rats_moving" },
    { 0x9691776E, "rats_near_player" },
    { 0xE72ED041, "ratsmax" },
    { 0x4274C4C1, "ratstarts" },
    { 0xC8ABC6F7, "rattle" },
    { 0xD7DEB01C, "rattle1" },
    { 0x49E61F57, "rattle2" },
    { 0x58212750, "rattle_audio" },
    { 0x37BEE412, "rattle_audio2" },
    { 0x5DC15E7B, "rattle_audio3" },
    { 0xC81F1FB9, "rattle_ent" },
    { 0x09F0B7B1, "rattle_id" },
    { 0xEB9BAAAC, "rattle_org" },
    { 0xC16B3A78, "rattle_point" },
    { 0x49C98038, "rattle_volume" },
    { 0xA4823F2E, "rattles" },
    { 0x09C2137C, "ratwaittospawn_max" },
    { 0x86D6D172, "ratwaittospawn_min" },
    { 0xC098F711, "raul" },
    { 0xF453408D, "ravage_core" },
    { 0x827EAEED, "raven" },
    { 0xA194890D, "raw" },
    { 0x8ECFF5E8, "raw_round" },
    { 0xFEFCD1E3, "rawfile" },
    { 0xCFEB54D2, "rawfiles" },
    { 0x85A36783, "ray" },
    { 0x8CBC8C18, "ray_gun_death_effects" },
    { 0x9076C833, "raygun" },
    { 0x89DA768B, "raygun2" },
    { 0x86DC27D4, "raygun2_backport_enabled" },
    { 0x7EDC624D, "raygun2_backport_frequency" },
    { 0xD1F24AB6, "raygun2_included" },
    { 0x36B08357, "raygun_instakill" },
    { 0xAA1813BA, "raygun_mark3_damage_response" },
    { 0xD1BCF259, "raygun_mark3_vision_on" },
    { 0x4DC74FE3, "raygun_vortex_reposition" },
    { 0x147DD6F9, "rayme" },
    { 0xE8C779F2, "rays" },
    { 0x139BF848, "raz" },
    { 0x0826C20B, "raz_arm_detach" },
    { 0x43AFE834, "raz_armor_damage_modifier" },
    { 0x95095B77, "raz_armor_detach_fx" },
    { 0x26D33260, "raz_armor_detach_fx_cannon_tag" },
    { 0xF1B5BD88, "raz_armor_detach_fx_chest_tag" },
    { 0xDB626390, "raz_armor_detach_fx_file" },
    { 0x1344676C, "raz_armor_detach_fx_helmet_tag" },
    { 0x85EFCC91, "raz_armor_detach_fx_left_leg_tag" },
    { 0xEB7F57C5, "raz_armor_detach_fx_left_shoulder_tag" },
    { 0x24714B8C, "raz_armor_detach_fx_right_leg_tag" },
    { 0xAA383A18, "raz_armor_pain_none" },
    { 0xEECA913F, "raz_check_for_location_hit" },
    { 0x91FBB234, "raz_chest_armor_dynent_launch_tag" },
    { 0x1176264C, "raz_chest_armor_hide_tag_1" },
    { 0x837D9587, "raz_chest_armor_hide_tag_2" },
    { 0x5D7B1B1E, "raz_chest_armor_hide_tag_3" },
    { 0x9F6EB711, "raz_chest_armor_hide_tag_4" },
    { 0x796C3CA8, "raz_chest_armor_hide_tag_5" },
    { 0xEB73ABE3, "raz_chest_armor_hide_tag_6" },
    { 0x92DEE351, "raz_chest_armor_hit_radius" },
    { 0xFA48180C, "raz_chest_armor_hit_radius_sq" },
    { 0x5A1A56F1, "raz_chest_armor_hit_tag" },
    { 0xD85C9A94, "raz_chest_armor_model" },
    { 0x8CB9EC09, "raz_default_chest_armor_health" },
    { 0x528F66A7, "raz_default_helmet_health" },
    { 0x4A66292F, "raz_default_l_shoulder_armor_health" },
    { 0x1F7AC494, "raz_default_thigh_armor_health" },
    { 0xBD260BAE, "raz_detach_chest_armor_clientfield" },
    { 0x7D761EBC, "raz_detach_helmet_clientfield" },
    { 0x398A73BC, "raz_detach_l_shoulder_armor_clientfield" },
    { 0x55FB3348, "raz_detach_l_thigh_armor_clientfield" },
    { 0xBB9FE282, "raz_detach_r_thigh_armor_clientfield" },
    { 0x8352F87C, "raz_dir" },
    { 0xCD07225D, "raz_footstep_earthquake_max_radius" },
    { 0xD364487E, "raz_footstep_fx" },
    { 0xB5644133, "raz_footstep_fx_file" },
    { 0x3095556E, "raz_forward" },
    { 0x58BFA3F1, "raz_gun_core_dynent_launch_tag" },
    { 0x655D2A2F, "raz_gun_core_hide_tag" },
    { 0xE5E3CA85, "raz_gun_core_model" },
    { 0x766D9451, "raz_gun_detach_clientfield" },
    { 0x5D044F78, "raz_gun_detach_damage_health_percent" },
    { 0xD17BF09A, "raz_gun_detach_exp_plyr_damage_max" },
    { 0x96924E84, "raz_gun_detach_exp_plyr_damage_min" },
    { 0xF551456E, "raz_gun_detach_explosion_damage_max" },
    { 0x4828B430, "raz_gun_detach_explosion_damage_min" },
    { 0xF2763D44, "raz_gun_detach_explosion_radius" },
    { 0xAEC2AA84, "raz_gun_detach_fx" },
    { 0x266F2DDD, "raz_gun_detach_fx_file" },
    { 0xD96697D5, "raz_gun_detach_health_percent_max" },
    { 0x2FA13BE5, "raz_gun_dynent_launch_tag" },
    { 0x8443A5EE, "raz_gun_health_default" },
    { 0x31B2B233, "raz_gun_hide_tag" },
    { 0x1E6A16E1, "raz_gun_model" },
    { 0x7D24EB80, "raz_gun_ongoing_damage_fx" },
    { 0x5CB7FBF1, "raz_gun_ongoing_damage_fx_file" },
    { 0x15C22531, "raz_gun_ongoing_damage_fx_tag" },
    { 0xA416F15D, "raz_gun_tag_hit_radius" },
    { 0xA62E7E48, "raz_gun_tag_hit_radius_sq" },
    { 0x275FBB3C, "raz_gun_weakpoint_hit_clientfield" },
    { 0xAC0435D3, "raz_gun_weakpoint_hit_fx" },
    { 0x727C0C34, "raz_gun_weakpoint_hit_fx_file" },
    { 0x20CC98C6, "raz_gun_weakpoint_hit_fx_tag" },
    { 0xB7C91F0F, "raz_helmet_hit_radius" },
    { 0x10597876, "raz_helmet_hit_radius_sq" },
    { 0x294872D7, "raz_helmet_hit_tag" },
    { 0xE5F93FA6, "raz_helmet_model" },
    { 0x472EEFD1, "raz_helmet_tag" },
    { 0xFA559F96, "raz_invoke_sprint_time" },
    { 0x6C67D1E6, "raz_l_shoudler_armor_hit_radius_sq" },
    { 0x03D3C186, "raz_l_shoulder_armor_dynent_launch_tag" },
    { 0x91BC7EA2, "raz_l_shoulder_armor_hide_tag_1" },
    { 0x6BBA0439, "raz_l_shoulder_armor_hide_tag_2" },
    { 0x45B789D0, "raz_l_shoulder_armor_hide_tag_3" },
    { 0x080B79DF, "raz_l_shoulder_armor_hit_radius" },
    { 0x3E63DA87, "raz_l_shoulder_armor_hit_tag" },
    { 0x4586ECB6, "raz_l_shoulder_armor_model" },
    { 0xF23B640E, "raz_l_thigh_armor_dynent_launch_tag" },
    { 0x662A91DA, "raz_l_thigh_armor_hide_tag_1" },
    { 0x40281771, "raz_l_thigh_armor_hide_tag_2" },
    { 0xB4177A17, "raz_l_thigh_armor_hit_radius" },
    { 0x5FFE989E, "raz_l_thigh_armor_hit_radius_sq" },
    { 0xB2DA143F, "raz_l_thigh_armor_hit_tag" },
    { 0x773547CE, "raz_l_thigh_armor_model" },
    { 0x4DE460E7, "raz_mask_destroyed" },
    { 0x8B475FE5, "raz_max_torpedo_range" },
    { 0x41635170, "raz_max_torpedo_range_sq" },
    { 0xFB77D637, "raz_melee_damage" },
    { 0x21A5A924, "raz_melee_dist" },
    { 0x61559437, "raz_melee_dist_sq" },
    { 0xC0A4B465, "raz_melee_yaw" },
    { 0x7195E1CF, "raz_min_torpedo_range" },
    { 0x827A1836, "raz_min_torpedo_range_sq" },
    { 0x5B85BD15, "raz_navmesh_boundary_dist" },
    { 0x1D142A36, "raz_navmesh_radius" },
    { 0xCE8ACD84, "raz_r_shoulder_weakspot_tag" },
    { 0x8152B26C, "raz_r_thigh_armor_dynent_launch_tag" },
    { 0xB90647B4, "raz_r_thigh_armor_hide_tag_1" },
    { 0x2B0DB6EF, "raz_r_thigh_armor_hide_tag_2" },
    { 0x046002F9, "raz_r_thigh_armor_hit_radius" },
    { 0x8C6DF8F4, "raz_r_thigh_armor_hit_radius_sq" },
    { 0x5C58F1B9, "raz_r_thigh_armor_hit_tag" },
    { 0x5D328A9C, "raz_r_thigh_armor_model" },
    { 0x4E4661A2, "raz_torpedo_blast_inner_damage" },
    { 0x00500135, "raz_torpedo_blast_outer_damage" },
    { 0xB047AA90, "raz_torpedo_blast_radius" },
    { 0x37307048, "raz_torpedo_cooldown" },
    { 0x24CD38F6, "raz_torpedo_detonation_clientfield" },
    { 0x4CC053D3, "raz_torpedo_detonation_dist" },
    { 0x13363EAA, "raz_torpedo_detonation_dist_sq" },
    { 0x7813D521, "raz_torpedo_explosion_fx" },
    { 0xD5BACFAE, "raz_torpedo_explosion_fx_file" },
    { 0x73F5D910, "raz_torpedo_ground_offset" },
    { 0xE2D7D2FF, "raz_torpedo_max_launch_angle" },
    { 0xB43883B6, "raz_torpedo_max_yaw_per_second" },
    { 0x7BF5AB7E, "raz_torpedo_model" },
    { 0x780CB740, "raz_torpedo_move_interval_time" },
    { 0x37CD850C, "raz_torpedo_notetrack" },
    { 0x83FA4FC0, "raz_torpedo_origin_tag" },
    { 0x5429C84C, "raz_torpedo_owner" },
    { 0x3B99E5C2, "raz_torpedo_self_fx" },
    { 0x2C20FC70, "raz_torpedo_self_fx_clientfield" },
    { 0x9105283F, "raz_torpedo_self_fx_file" },
    { 0xC97CACBB, "raz_torpedo_self_fx_tag" },
    { 0x5130A703, "raz_torpedo_sight_horiz_range" },
    { 0x0FD2A3EB, "raz_torpedo_terrain_check_offset" },
    { 0xEAF0E157, "raz_torpedo_trail_clientfield" },
    { 0x6FD7ED2E, "raz_torpedo_trail_fx" },
    { 0xB0E19B63, "raz_torpedo_trail_fx_file" },
    { 0x6D591886, "raz_torpedo_velocity" },
    { 0xA39A7652, "raz_walk_rumble_distance" },
    { 0xA3101466, "razapplyplayerdetonationeffects" },
    { 0x3412C871, "razapplytorpedodetonationpushtoplayers" },
    { 0x8F7980F6, "razbehavior" },
    { 0x7F7FF86B, "razcanseetorpedotarget" },
    { 0x72BAA781, "razchestarmordetach" },
    { 0x87AB7C6E, "razchestarmorhealth" },
    { 0x18051440, "razclientutils" },
    { 0x776CFD62, "razcreatedynentandlaunch" },
    { 0xE43CF0DE, "razdamagecallback" },
    { 0x9235FE6A, "razdestroywindow" },
    { 0x5E763AA7, "razdetachgunfx" },
    { 0xC863523A, "razdetonategroundtorpedo" },
    { 0x258224C5, "raze" },
    { 0xD7B7ED6D, "razfinishgroundtorpedo" },
    { 0x80581C8B, "razfinishmelee" },
    { 0x86973C57, "razfinishtraversewindow" },
    { 0xAF55113B, "razgetnondestroyedchuncks" },
    { 0x6C4DDD98, "razgibzombiesonmelee" },
    { 0xC7854A25, "razgoneberserk" },
    { 0x52E55D88, "razgunhealth" },
    { 0x77178DCD, "razgunweakpointhitfx" },
    { 0xF881A5EC, "razhaschestarmor" },
    { 0x378298CD, "razhasgoneberserk" },
    { 0x827CE236, "razhasgunattached" },
    { 0xB6AD73BF, "razhashelmet" },
    { 0xE3D1A6F8, "razhasleftshoulderarmor" },
    { 0x4711C856, "razhasleftthigharmor" },
    { 0x229AE313, "razhasrightthigharmor" },
    { 0xE4D9298E, "razhelmetdetach" },
    { 0x1F5DD695, "razhelmethealth" },
    { 0x5DA90C65, "razinvalidategibbedarmor" },
    { 0x329D0429, "razknockdownzombies" },
    { 0xD9D44375, "razleftshoulderarmordetach" },
    { 0xBE1FDC52, "razleftshoulderarmorhealth" },
    { 0x714DF297, "razleftthigharmordetach" },
    { 0xB65CD277, "razleftthighhealth" },
    { 0x23B3DA6C, "razmaxhealth" },
    { 0x0ABC3E24, "raznotetrackshootgroundtorpedo" },
    { 0xC845CF7C, "razor_wire_collision" },
    { 0xBC1571DB, "razor_wire_setup" },
    { 0xCD99FC27, "razorwire_scrunched_clip" },
    { 0x568564AC, "razplayfireemissiveshader" },
    { 0x24F717D3, "razplayroarsound" },
    { 0x630145E6, "razplayselffx" },
    { 0x641F53CD, "razplaytaunts" },
    { 0x50A63DA9, "razprocessfootstep" },
    { 0x7528DA2A, "razrightthigharmordetach" },
    { 0xCF83FD38, "razrightthighhealth" },
    { 0x6A90A894, "razserverutils" },
    { 0xC5D7B1CD, "razshootgroundtorpedo" },
    { 0xB6B3F7AB, "razshouldgoberserk" },
    { 0x6E839B7F, "razshouldmelee" },
    { 0x1187FA6C, "razshouldshootgroundtorpedo" },
    { 0x05FC996E, "razshouldshowpain" },
    { 0xCC04346D, "razshouldshowshieldpain" },
    { 0xD89EBE9F, "razshouldshowspecialpain" },
    { 0x01017063, "razshouldtraversewindow" },
    { 0x7D543CC5, "razspawn" },
    { 0x8FE3F6C8, "razspawnsetup" },
    { 0x6A229F8D, "razsprintknockdownzombies" },
    { 0xD65E057D, "razsprintservice" },
    { 0x036948B2, "razstartdeath" },
    { 0x90FC2230, "razstartmelee" },
    { 0x364396BA, "razstarttraversewindow" },
    { 0xDA40A496, "razstoptauntsondeath" },
    { 0xABCC3970, "raztargetservice" },
    { 0x1B1E6D7B, "razthigharmorhealth" },
    { 0x60C76FB5, "raztookpain" },
    { 0xC8B09D11, "raztorpedodetonate" },
    { 0xB077C8B0, "raztorpedodetonateifclosetotarget" },
    { 0xD25D41E8, "raztorpedoknockdownzombies" },
    { 0x6A782133, "raztorpedolaunchdirection" },
    { 0x2E413EEA, "raztorpedomovetotarget" },
    { 0xC651415A, "raztorpedoplaytraileffect" },
    { 0x758EAD37, "raztorpedoplaytrailfx" },
    { 0xE48123BE, "raztrackchestarmordamage" },
    { 0x66B2E4FE, "raztrackgundamage" },
    { 0x5D00A425, "raztrackhelmetdamage" },
    { 0x9EDBAE6C, "raztrackleftshoulderarmordamage" },
    { 0x8EEAC160, "raztrackleftthigharmordamage" },
    { 0xE3CA16CF, "raztrackrightthigharmordamage" },
    { 0xECAF6B12, "razzombieeligibleforknockdown" },
    { 0xC540A00D, "rb" },
    { 0xF0DE8D24, "rb_ambient_trigger_listener" },
    { 0x3774B1BF, "rb_ambient_vignette_death_watcher" },
    { 0xC5206995, "rb_cleanup_all_ambient_vignettes" },
    { 0xF4D0B00E, "rb_cleanup_ambient_vignette" },
    { 0xFBFBE1D9, "rb_cover_sound" },
    { 0x6D049A9B, "rb_delete_after_scene" },
    { 0x224B6E7F, "rb_do_ambient_vignette" },
    { 0xC4FAC1C4, "rb_heli_adjust_goaldist" },
    { 0xEEBA070E, "rb_heli_delete" },
    { 0xCF30305A, "rb_heli_engage" },
    { 0x1660352C, "rb_heli_engage2" },
    { 0x90A14BF2, "rb_heli_face_object" },
    { 0x8ED9015F, "rb_heli_face_point" },
    { 0x49F2B3D9, "rb_heli_fire_rockets" },
    { 0x2F712DC8, "rb_heli_fire_side_gun" },
    { 0x291E9A99, "rb_heli_idle" },
    { 0x67C27DD9, "rb_heli_init" },
    { 0xC0F1C9B2, "rb_heli_path" },
    { 0x64F2DCFD, "rb_heli_set_speed" },
    { 0x8F913566, "rb_heli_spotlight_circle_enable" },
    { 0x97FE03FC, "rb_heli_spotlight_delete_on_death" },
    { 0xD765C94C, "rb_heli_spotlight_disable" },
    { 0x75BC7375, "rb_heli_spotlight_enable" },
    { 0x4BC8CC26, "rb_heli_spotlight_shadow_enable" },
    { 0x4707E519, "rb_heli_spotlight_static_angles" },
    { 0x02DF7063, "rb_heli_spotlight_target_object" },
    { 0xB3B7E164, "rb_heli_spotlight_target_point" },
    { 0x354259CB, "rb_helicopter" },
    { 0x9DBD4633, "rb_init_ambient_vignettes" },
    { 0x1AE3299D, "rb_monkey_kills" },
    { 0xE243AA6F, "rb_objective_breadcrumb" },
    { 0x1B1CD12F, "rb_portals_btr_rail" },
    { 0x750F41CB, "rb_portals_level_start" },
    { 0xE886713F, "rb_portals_strela" },
    { 0xEF8074BD, "rb_spawn_character" },
    { 0xFCA99FCD, "rb_vignette_structs" },
    { 0x218391F8, "rbs_sounddone" },
    { 0x9F3E25A4, "rc" },
    { 0x406EB38F, "rc_bomb" },
    { 0x040D6556, "rc_bombs" },
    { 0xBC26DFED, "rc_shutdown" },
    { 0xCB6C290C, "rca_node" },
    { 0x4E09BD9D, "rcb_node" },
    { 0x13416574, "rcbomb" },
    { 0x6968094F, "rcbomb_blur_amount" },
    { 0xCC842D0F, "rcbomb_blur_boost_duration" },
    { 0x70FD9266, "rcbomb_blur_inner_radius" },
    { 0x1355EDC1, "rcbomb_blur_outer_radius" },
    { 0xFB11875A, "rcbomb_death_hide_delay" },
    { 0xE48DD09A, "rcbomb_debug_box" },
    { 0xE5644671, "rcbomb_debug_line" },
    { 0xA857C5DF, "rcbomb_done" },
    { 0xCFBD057B, "rcbomb_duration" },
    { 0xD06CF10C, "rcbomb_earthquake" },
    { 0x75F8A6FB, "rcbomb_emp_death_hide_delay" },
    { 0x2F4B3612, "rcbomb_force_explode" },
    { 0x1D459C80, "rcbomb_hacked_health_update" },
    { 0x4081440D, "rcbomb_hide_compass_on_remote_control" },
    { 0x6F373B3B, "rcbomb_in_water_trace_mask" },
    { 0xFAC80E8A, "rcbomb_in_water_trace_maxs" },
    { 0xB1848074, "rcbomb_in_water_trace_mins" },
    { 0x81EDB6B0, "rcbomb_in_water_trace_wait" },
    { 0x951E8547, "rcbomb_influencer_radius" },
    { 0x5570BE89, "rcbomb_influencer_score" },
    { 0x72FFB2DD, "rcbomb_influencer_score_curve" },
    { 0x979F2976, "rcbomb_name" },
    { 0x6347E861, "rcbomb_placement_crouch_height" },
    { 0xABB6D4A3, "rcbomb_placement_prone_height" },
    { 0xE8A39429, "rcbomb_placement_stand_height" },
    { 0x29EB1DAA, "rcbomb_placment_from_player" },
    { 0xDC4432BD, "rcbomb_shutdown" },
    { 0xEE20234D, "rcbomb_shutdown_delay" },
    { 0x3F58FDEC, "rcbomb_shutdown_delay_abandoned" },
    { 0x09694A61, "rcbomb_vehicle" },
    { 0x44C9723F, "rcbomb_vision" },
    { 0xDB384BFA, "rcbomb_watch_death_duration" },
    { 0x0059D1E4, "rcbombbundle" },
    { 0x5E6F6FBA, "rcbombdetectid" },
    { 0x04B751AC, "rcbombonblowup" },
    { 0x87F9DBE1, "rcbombplacement" },
    { 0x9621CB67, "rcbombs" },
    { 0xB33BCE08, "rcbombsurfacetypeforscreenfx" },
    { 0x92553274, "rcbombsurfacetypefortreadfx" },
    { 0x59E927A3, "rccarallowfriendlyfiredamage" },
    { 0x49EB8043, "rccarcam" },
    { 0xAB87952F, "rcl_node" },
    { 0x9D53E153, "rclip" },
    { 0xFF77C3FF, "rcos_theta" },
    { 0x9B8C62BA, "rcount" },
    { 0x53BB9278, "rcxd" },
    { 0xB6DCAABC, "rcxd_time" },
    { 0xEECBE87E, "rcxdhackertoolradius" },
    { 0xE9F22AB3, "rcxdhackertooltimems" },
    { 0xA386858D, "rdoor" },
    { 0x18EF5186, "rdot" },
    { 0x5A97E842, "rdotabs" },
    { 0x533930D2, "re" },
    { 0x646BC5E2, "re_link_driver_to_truck" },
    { 0xBC9B5E94, "re_link_passenger_to_truck" },
    { 0x3F1914CA, "reach" },
    { 0xFBB0BBEB, "reach_aligned" },
    { 0xF6473F74, "reach_and_idle_relative_to_target" },
    { 0x4ACB510F, "reach_and_set_flag_aligned" },
    { 0x4D19561E, "reach_anim" },
    { 0xBF9B614A, "reach_container_area" },
    { 0x58AE2AF3, "reach_death_notify" },
    { 0x5F79991D, "reach_done" },
    { 0xCE0ECE3A, "reach_failed" },
    { 0x7CD8EE4C, "reach_for_pistol" },
    { 0x281D9944, "reach_goal" },
    { 0x0B1585DB, "reach_idle" },
    { 0x9AACA097, "reach_idle_goal" },
    { 0xDA97A0DD, "reach_node_1" },
    { 0x009A1B46, "reach_node_2" },
    { 0x269C95AF, "reach_node_3" },
    { 0x1DEF69F6, "reach_node_bloody_death" },
    { 0x2F843B5A, "reach_notify" },
    { 0xAB9FE4C6, "reach_queue" },
    { 0x8E1310D4, "reach_tarmac_halfwaypoint" },
    { 0x30ABA5D1, "reach_then_first_frame" },
    { 0x88578B11, "reach_then_loop" },
    { 0x5DF9E3E0, "reach_then_loop_aligned" },
    { 0x5291DE6B, "reach_then_single" },
    { 0x5272D856, "reach_then_single_aligned" },
    { 0x815DB635, "reach_wait_single" },
    { 0x4ACBC87C, "reach_with_arrivals_begin" },
    { 0xC105776D, "reach_with_planting" },
    { 0xD862CB34, "reach_with_standard_adjustments_begin" },
    { 0x627C4868, "reach_with_standard_adjustments_end" },
    { 0x7271F586, "reachable" },
    { 0xE9B9DE63, "reachableby_ent" },
    { 0xB9947E5D, "reached" },
    { 0x6B5ADCAA, "reached_anim_watcher" },
    { 0x24B2CEA8, "reached_balcony" },
    { 0xFD3DB802, "reached_blocking_point" },
    { 0x4F7B0195, "reached_bridge_flee_spot" },
    { 0x14148C3B, "reached_convoy_one" },
    { 0xBB3FBAD9, "reached_default_path_end" },
    { 0x36C9BFAC, "reached_dest" },
    { 0xC8DDDC90, "reached_destination" },
    { 0x80BEF90D, "reached_dynamic_path_end" },
    { 0xE2D3866F, "reached_end" },
    { 0x6CF6AC7E, "reached_end_node" },
    { 0x36DD5EB6, "reached_end_of_node_array" },
    { 0x729923A2, "reached_escape_corridor" },
    { 0x678D50AA, "reached_flak" },
    { 0xCCA67806, "reached_follow_node" },
    { 0xB3A02AD9, "reached_goal" },
    { 0xC93C44E2, "reached_hanger_floor" },
    { 0xD21826A9, "reached_hudson_distance" },
    { 0xD0845F95, "reached_last_node_in_chain" },
    { 0x50B3331F, "reached_menendez_elevator_top" },
    { 0x2B46FFB4, "reached_node" },
    { 0xFB74E95B, "reached_node_but_could_not_claim_it" },
    { 0x4A229747, "reached_node_dist" },
    { 0x768A30C7, "reached_path_end" },
    { 0x81347234, "reached_poi" },
    { 0x3D8A4A29, "reached_position" },
    { 0xBA555167, "reached_stop_node" },
    { 0x2E8B1B13, "reached_stop_point" },
    { 0xE5BFF21A, "reached_top_elevator" },
    { 0xB8F110F2, "reached_wait_node" },
    { 0x8F2E1517, "reached_wait_speed" },
    { 0x466D5186, "reached_whirlwind" },
    { 0x8E321F12, "reacheddescendingent" },
    { 0x9A773D9A, "reachers" },
    { 0xE7656892, "reaches" },
    { 0x8514DE48, "reachidle" },
    { 0x4942C826, "reaching" },
    { 0x40EB14CB, "reachingpreferedpoint" },
    { 0xCB7334CE, "reachnode" },
    { 0xC3BCCA7E, "reachpathend" },
    { 0x597947AA, "reacquire" },
    { 0x9047C026, "reacquire_maxtime" },
    { 0x91C6823C, "reacquire_mintime" },
    { 0xCA474536, "reacquire_player" },
    { 0x64AD0355, "reacquire_player_pos" },
    { 0x6ECF8406, "reacquire_reset" },
    { 0x797E2B5C, "reacquire_state" },
    { 0x0A0F2479, "reacquire_step_size" },
    { 0x434D6F88, "reacquire_timer" },
    { 0xCDB9CC3B, "reacquireguy" },
    { 0xEAC0C741, "reacquiremove" },
    { 0xB0FBCA92, "reacquirenum" },
    { 0x54B1FA9C, "reacquirepos" },
    { 0x61973174, "reacquirestep" },
    { 0x9BCAB3A5, "reacquiretime" },
    { 0x9457263F, "reacquirewhennecessary" },
    { 0xF5AEA97B, "reacquiring" },
    { 0xE6A507C3, "reacquisition" },
    { 0x46E78496, "react" },
    { 0x5DF75D6A, "react_anim" },
    { 0xF2B46B25, "react_door_explosion" },
    { 0x9233BAAB, "react_flag" },
    { 0xA94FAEF5, "react_grenade" },
    { 0x777A2933, "react_init" },
    { 0x91E2805C, "react_name" },
    { 0x7203BAB6, "react_notify" },
    { 0x90FB7F8F, "react_scene" },
    { 0xF0978F01, "react_scene_end" },
    { 0x3F13116C, "react_sword" },
    { 0xC967733B, "react_trigger" },
    { 0x8B7754FB, "react_trigger_1_name" },
    { 0xBE76B16A, "react_trigger_2_name" },
    { 0x5DED47F6, "react_yaw" },
    { 0xC390CEB1, "reactanim" },
    { 0x2B18A400, "reactanimarray" },
    { 0xE23A65C9, "reactarray" },
    { 0xBDDFF259, "reacted" },
    { 0x3DB18210, "reactglobalsinit" },
    { 0x843F1731, "reactidgun" },
    { 0x8F54198A, "reacting" },
    { 0x7781E584, "reacting_to_locking" },
    { 0x3ACA32D7, "reacting_to_locks" },
    { 0x9498A980, "reactingtoaim" },
    { 0xFAB857A8, "reactinit" },
    { 0xDE65F704, "reaction" },
    { 0x2BB789F4, "reaction_ai_todo" },
    { 0xE52089DC, "reaction_anim" },
    { 0xCF972528, "reaction_blendout" },
    { 0x9C25EA8C, "reaction_interval" },
    { 0x093694C3, "reaction_node" },
    { 0x9E2A02C1, "reaction_over" },
    { 0x09765A1B, "reaction_override" },
    { 0x545593D3, "reactionanim" },
    { 0xE91914FE, "reactionanimarray" },
    { 0x1F7AAA16, "reactionary" },
    { 0x88C99157, "reactionawarenessdist" },
    { 0xBA6CDD02, "reactioncasualty" },
    { 0x08B5F297, "reactioncb" },
    { 0xE622112C, "reactioncooldowntime" },
    { 0xE4A45775, "reactiondistance" },
    { 0xFA9400FE, "reactiondistancesquaredmax" },
    { 0x8D1C22A0, "reactiondistancesquaredmin" },
    { 0xD61ED29C, "reactioneventcallbacks" },
    { 0x6073A92C, "reactioneventinprogress" },
    { 0xAFC509B7, "reactions" },
    { 0x87B3F7AA, "reactions_groups" },
    { 0xC52302DE, "reactions_grp02_2" },
    { 0xEB257D47, "reactions_grp02_3" },
    { 0x2340CB93, "reactions_guy" },
    { 0x85730FE8, "reactiontaunt" },
    { 0x47CEB405, "reactivate" },
    { 0x24C5223B, "reactivate_all_in_array" },
    { 0x90EC99C5, "reactivate_detectors" },
    { 0xB849619B, "reactivated" },
    { 0x3E738294, "reactivates" },
    { 0x61A0A1D0, "reactivating" },
    { 0xE374C17D, "reactor" },
    { 0x5907BB0D, "reactor_core" },
    { 0x78421C6E, "reactor_core_audio" },
    { 0x9746F117, "reactor_core_mover" },
    { 0x1FC5721C, "reactorigin" },
    { 0xEDFC4A09, "reacts" },
    { 0x9E59B56E, "reactstun" },
    { 0x70E85A9D, "reactsword" },
    { 0x6A7FD969, "reacttime" },
    { 0xC9760205, "reactto" },
    { 0xB4C10009, "read" },
    { 0x157020FD, "readable" },
    { 0xEBEF106F, "readd" },
    { 0x47318EB4, "readded" },
    { 0xF0870580, "readhighscores" },
    { 0xF0999172, "readies" },
    { 0x822396BF, "reading" },
    { 0xE37FBCC6, "readings" },
    { 0xCD2A2A0B, "readjustmentanimtime" },
    { 0x20409AFC, "readjustmentdistthresholdsq" },
    { 0xDFD59AFA, "readjustmentstarted" },
    { 0x6B23A70F, "readlocations" },
    { 0xD9C870D7, "readonly" },
    { 0x81B61100, "reads" },
    { 0x9DF223EF, "readshirt" },
    { 0x5EBC3482, "readspawndata" },
    { 0x9D0E9A06, "readthistime" },
    { 0xFDCED91A, "ready" },
    { 0xAE3B4A76, "ready4ambush" },
    { 0x659D9A27, "ready_4_warehouse" },
    { 0xC59F0E41, "ready_after_revived" },
    { 0xDBDA984D, "ready_dialog" },
    { 0x45000713, "ready_door_breach2" },
    { 0x1EFD8CAA, "ready_door_breach3" },
    { 0x9104FBE5, "ready_door_breach4" },
    { 0x2A4B1FF1, "ready_explosions" },
    { 0x3E0B1BC2, "ready_for_boat_drive" },
    { 0x5AC23C4D, "ready_for_render" },
    { 0xA450F77B, "ready_for_score_events" },
    { 0xA0B827BB, "ready_func" },
    { 0xC7319BA4, "ready_horse" },
    { 0x29A6199E, "ready_hud_elem" },
    { 0xB13501F7, "ready_sfx_alias" },
    { 0xFAF4AFAA, "ready_to_activate" },
    { 0x5D226196, "ready_to_be_saved" },
    { 0x7890BA26, "ready_to_breach" },
    { 0xF06A076A, "ready_to_call_event_3" },
    { 0x2ACB97B9, "ready_to_charge" },
    { 0x3DFA55A8, "ready_to_count_deaths" },
    { 0x6C5732E0, "ready_to_die_already" },
    { 0x47210D53, "ready_to_embrace_numbers" },
    { 0xE2FF8DEC, "ready_to_end_final_push" },
    { 0xD4E0B7ED, "ready_to_fire" },
    { 0x1D0ABE43, "ready_to_mount_buffel" },
    { 0xA049C7F0, "ready_to_spawn_group2" },
    { 0xC64C4259, "ready_to_spawn_group3" },
    { 0xDFA50212, "ready_to_spawn_m202" },
    { 0x4B676173, "ready_to_spawn_panther" },
    { 0x7CFFE89A, "ready_to_spawn_swift" },
    { 0x5BF63224, "ready_to_spawn_wasp" },
    { 0x83694286, "ready_to_use" },
    { 0x38100BD9, "ready_weapon" },
    { 0x0CF43456, "readying" },
    { 0xE0C4F015, "readys" },
    { 0x2E028756, "readytobreach" },
    { 0x67868BDD, "readytofire" },
    { 0x8A3F2E51, "readytoreturntocover" },
    { 0xCA32A90F, "readyvo" },
    { 0x2490DA99, "reajustment" },
    { 0xE4D4D351, "real" },
    { 0x68F3067B, "real_bike" },
    { 0xA2D81D57, "real_body_hide" },
    { 0x2D163474, "real_body_show" },
    { 0x624DA944, "real_bomb" },
    { 0xEDA212D1, "real_camera" },
    { 0xB6A24BD3, "real_chair" },
    { 0x2858F6DB, "real_cougar" },
    { 0x144DA553, "real_ent" },
    { 0x43AFBAF0, "real_ent1" },
    { 0xB5B72A2B, "real_ent2" },
    { 0x1172BA6D, "real_gunner" },
    { 0x4B66F5E9, "real_lvts" },
    { 0x2471D145, "real_meat" },
    { 0xE3DC86CA, "real_mid" },
    { 0xC031FBDB, "real_spawners" },
    { 0x60832EB6, "real_z" },
    { 0xB5F76A9B, "realarrowtime" },
    { 0x86B49BDA, "realboat3" },
    { 0x8AEBFEF2, "realdetournode" },
    { 0x69B713A6, "realdialoguename" },
    { 0xC0B3C6D3, "realdropheight" },
    { 0xEEF35557, "realhealth" },
    { 0x1B30E1EC, "realheight" },
    { 0x358AF3D2, "realism" },
    { 0x974F1D53, "realistic" },
    { 0x5E22ECE7, "reality" },
    { 0x69F2A2F9, "realize" },
    { 0x99B12A7F, "realized" },
    { 0x1A82AED4, "reallevelscript" },
    { 0xBA1201BC, "really" },
    { 0xB8122B4E, "really_long_time_ms" },
    { 0xDCE51C76, "really_play_2d_sound" },
    { 0x38EFFD37, "realmelee" },
    { 0xC57C3549, "realmotorcade" },
    { 0x01AF1ECB, "reaload" },
    { 0xFCC437CF, "realorigin" },
    { 0xCFC294A5, "realscore" },
    { 0x00E8A74B, "realstart" },
    { 0xC5282017, "realt" },
    { 0xF60F0806, "realtime" },
    { 0x2A7D7893, "realtimeengagedist" },
    { 0xC8D0E3BD, "realtimeengagedist_middle" },
    { 0xC7552BA4, "realtimeengagedist_offvalue" },
    { 0xD1E66C79, "realtimeengagedist_value" },
    { 0x6379B96F, "realtrigger" },
    { 0x1E3A0496, "realwait" },
    { 0x4F486339, "realwaitsettime" },
    { 0xC5F956A0, "realweaponname" },
    { 0x0028A5F3, "realyawtoenemy" },
    { 0x76E1B62D, "reanchor_at_dist_sq" },
    { 0xF9D2302C, "reaper" },
    { 0x0040B8BA, "reaper_body3_hack" },
    { 0xBB6820F0, "reaperbulletglass" },
    { 0xDD189F38, "reappears" },
    { 0x2E3A2D9A, "reapply" },
    { 0xEC4C18C6, "reapplydestructedpieces" },
    { 0x1DE26EED, "reapplyhiddengibpieces" },
    { 0x337B75D6, "reapplying" },
    { 0x0C68D373, "reaquire_player" },
    { 0xF8F7850F, "rear" },
    { 0x64FC6CAB, "rear_angle_dif" },
    { 0x7D20F7C6, "rear_angles" },
    { 0x20636C83, "rear_bmp" },
    { 0x11C6BB71, "rear_convoy_boat_death_monitor" },
    { 0x8C7ABCCE, "rear_damage_clip" },
    { 0xDB6EDD3A, "rear_data" },
    { 0xBA807FA4, "rear_death" },
    { 0x4BC79C7F, "rear_distance" },
    { 0x51D6C255, "rear_gaurd" },
    { 0x938EE445, "rear_guard" },
    { 0xB5441EF1, "rear_gun_active" },
    { 0x544E78A3, "rear_gunner" },
    { 0x6C6948FD, "rear_gunner_struct" },
    { 0x9D44D65F, "rear_guy_offset" },
    { 0x6DB0E20C, "rear_guy_origin" },
    { 0xB393123C, "rear_hatch_offset_height" },
    { 0xB1F1E39E, "rear_hatch_offset_local" },
    { 0x397792A3, "rear_hatch_offset_world" },
    { 0xCBC1D529, "rear_katyushas" },
    { 0x2BE1E548, "rear_line_spawners" },
    { 0xD204FC9C, "rear_line_struct" },
    { 0x85B1AD21, "rear_line_volume" },
    { 0x3DC82896, "rear_max_turn" },
    { 0x21D7CEF2, "rear_melee" },
    { 0xAC5FFA9B, "rear_mortarpits_support" },
    { 0xAC0CE6CB, "rear_offset" },
    { 0xB2A91D18, "rear_origin" },
    { 0x7D4099D7, "rear_piece_damage_level" },
    { 0x71C3C050, "rear_point" },
    { 0x2B80DABE, "rear_sounds" },
    { 0x920AD711, "rear_struct" },
    { 0x9BFB7C43, "rear_truck" },
    { 0x3DDD9A50, "rearangoffset" },
    { 0x4D338336, "rearback" },
    { 0xFAEF4ECA, "rearback_anim" },
    { 0x7AA1D0F3, "rearc4location" },
    { 0x1943E801, "rearents" },
    { 0x150F1471, "rearguard_advance" },
    { 0xAF9BCD38, "rearm" },
    { 0x52CB7EA0, "rearming" },
    { 0x03CAE8A2, "rearorgoffset" },
    { 0x07A03A70, "rearpassengers" },
    { 0xE714A459, "rearrotor" },
    { 0xDE4046A1, "reason" },
    { 0xF511D6C5, "reasonable" },
    { 0xCCCC7349, "reasonably" },
    { 0x6D123248, "reasons" },
    { 0x1B34C188, "reasonvalue" },
    { 0x0BA85E69, "reasses" },
    { 0x31CB70E0, "reassess" },
    { 0xA3628644, "reassess_time" },
    { 0x14E8A699, "reat" },
    { 0x45C322AD, "reattach" },
    { 0x5983F75A, "reattached" },
    { 0xE7E29991, "rebar_blood_fx" },
    { 0xF327BD04, "rebatehp" },
    { 0xFE3572FF, "rebel" },
    { 0xB3078971, "rebel_base_clean_up" },
    { 0x88A14695, "rebel_camp" },
    { 0xDE89ADBD, "rebel_charge_audio" },
    { 0x924DC1AC, "rebel_entrance" },
    { 0x49E98909, "rebel_leader" },
    { 0x72604106, "rebels" },
    { 0x04519639, "rebirth" },
    { 0x6AB8E109, "rebirth_advance_level" },
    { 0x8BB625DA, "rebirth_advance_objective" },
    { 0x860B51E4, "rebirth_amb" },
    { 0x2641701B, "rebirth_anim" },
    { 0x3C82EC8B, "rebirth_art" },
    { 0x72E410B5, "rebirth_attacker" },
    { 0x109CECA3, "rebirth_btr_rail" },
    { 0x2EA1C1E9, "rebirth_button_prompt" },
    { 0xC7E6C19F, "rebirth_damage" },
    { 0xC21928CA, "rebirth_default_snapshot" },
    { 0x35CD0916, "rebirth_dialogue" },
    { 0x28A31C31, "rebirth_dir" },
    { 0x20CB3328, "rebirth_flag_array" },
    { 0x4E206082, "rebirth_flag_debug_print" },
    { 0xA7A1A767, "rebirth_flag_init" },
    { 0xBC011505, "rebirth_flags" },
    { 0x2A20747E, "rebirth_fx" },
    { 0xEED79703, "rebirth_gas" },
    { 0x8DCF8952, "rebirth_gas_attack" },
    { 0x04C668C0, "rebirth_gas_init" },
    { 0x52D7F36B, "rebirth_hitloc" },
    { 0x8DDB0049, "rebirth_hudson_lab" },
    { 0x541F84B0, "rebirth_index" },
    { 0xC05147E2, "rebirth_inflictor" },
    { 0x93848CFD, "rebirth_init_dvars" },
    { 0xFD70ABC1, "rebirth_iron_lung" },
    { 0x594A4E31, "rebirth_lab" },
    { 0xDC5A0573, "rebirth_level_order" },
    { 0x08E09FB3, "rebirth_mask_snapshot" },
    { 0xE65AAF02, "rebirth_mason_lab" },
    { 0x6145E8D2, "rebirth_mason_stealth" },
    { 0xF293DBFE, "rebirth_means" },
    { 0x79078350, "rebirth_movie" },
    { 0x09F1AC0A, "rebirth_objective_2" },
    { 0x55F6A0DC, "rebirth_objective_4" },
    { 0x327D2EE1, "rebirth_objective_on_actor" },
    { 0x72CF5B5D, "rebirth_offset" },
    { 0x851218BE, "rebirth_point" },
    { 0xC5924DB9, "rebirth_portals" },
    { 0x00D1046C, "rebirth_reset_vehicle_damage" },
    { 0x7120435D, "rebirth_run_events" },
    { 0xB7BBD46E, "rebirth_setup_characters" },
    { 0x19F3F48F, "rebirth_setup_flags" },
    { 0x27D1915E, "rebirth_setup_heroes" },
    { 0x422C04B7, "rebirth_setup_spawn_funcs" },
    { 0xC933B755, "rebirth_setup_variables" },
    { 0x0B9C2A18, "rebirth_steiners_office" },
    { 0x98D8D8B0, "rebirth_town" },
    { 0xB823048C, "rebirth_utility" },
    { 0x766EDF1C, "rebirth_vehicle_damage" },
    { 0x577A0348, "rebirth_weapon" },
    { 0xB41F89E1, "rebith" },
    { 0xC420B7E6, "reboot" },
    { 0x1948C0CB, "reboot_disable" },
    { 0x09C90782, "reboot_time" },
    { 0x2B30B77A, "rebooting" },
    { 0x77C2C2C5, "rebounds" },
    { 0xDD9BD165, "rebsp" },
    { 0x11AA5A3A, "rebuild" },
    { 0x475D8BD0, "rebuild_barrier_reward" },
    { 0xFBE43A58, "rebuild_barrier_reward_reset" },
    { 0xDC9F3413, "rebuild_barrier_think" },
    { 0xE50FF400, "rebuild_spawn_points" },
    { 0x3F6259F8, "rebuild_timer" },
    { 0x5F2D30F6, "rebuilding" },
    { 0x9241A38A, "rebuildspawnpoints" },
    { 0xAFFCD932, "rebuildtrigger" },
    { 0x71D200CA, "rebuilt" },
    { 0xA629774F, "rebulding" },
    { 0xBBE03358, "rec_anim_info_render_thread" },
    { 0xA4C41617, "rec_anim_origin_render" },
    { 0x2F0F3A49, "recalc" },
    { 0x020FDAC8, "recalc_zombie_array" },
    { 0xAEE5215A, "recalculate" },
    { 0xF97B38DB, "recalculate_zone" },
    { 0xD3BBAFAA, "recalculated" },
    { 0xB76A386B, "recalculating" },
    { 0xBFBF0C01, "recalibrate" },
    { 0x1D2F719E, "recall" },
    { 0x068E2661, "recall_gun" },
    { 0x62858B4E, "recallleverdone" },
    { 0xDB0B6487, "recallzipswitch" },
    { 0x0CDCBDFC, "recapture" },
    { 0x7B4EB003, "recapture_event_end" },
    { 0x1F24FD7D, "recapture_event_in_progress" },
    { 0xAF3AAAF0, "recapture_event_start" },
    { 0x84975DD9, "recapture_pbr" },
    { 0xD362F83C, "recapture_pbr_enemies_killed" },
    { 0xB9EF8ADB, "recapture_pbr_enemy_function" },
    { 0x153FE436, "recapture_pbr_sampan_east" },
    { 0x89B05A2D, "recapture_pbr_sampan_east_2" },
    { 0xB2B05D97, "recapture_round_audio_ends" },
    { 0xAC8E6F96, "recapture_round_audio_starts" },
    { 0x424D7C34, "recapture_round_start" },
    { 0x3CEE61B4, "recapture_round_tracker" },
    { 0xF777760C, "recapture_target" },
    { 0xDF4ED2F3, "recapture_zombie_death_func" },
    { 0x12003D06, "recapture_zombie_group_icon_hide" },
    { 0x28DAB345, "recapture_zombie_group_icon_show" },
    { 0x8DD3FA76, "recapture_zombie_icon_think" },
    { 0xBF0B2C19, "recapture_zombie_poi_think" },
    { 0x0E941C50, "recapture_zombies" },
    { 0x18E96311, "recapture_zombies_cleared" },
    { 0x9D32F018, "recapture_zombies_killed" },
    { 0xE4631170, "recaptured" },
    { 0x9124D82C, "receive" },
    { 0xD145B0C0, "received" },
    { 0x02528173, "received award" },
    { 0xF0FA2450, "received teammessage" },
    { 0xD8457870, "receiveddialog" },
    { 0x1565F655, "receivedtext" },
    { 0x157C35C6, "receiver" },
    { 0x3B7EB02F, "receives" },
    { 0x524799D5, "receiving" },
    { 0xDA3BB356, "receiving_bay_doors" },
    { 0xFF34E9F3, "receiving_bay_doors_init" },
    { 0x95762923, "receiving_power" },
    { 0x8A4A52F4, "recent" },
    { 0xB05305D1, "recent_death_time" },
    { 0x153C0F14, "recent_flashed" },
    { 0x01A96273, "recent_lmg_smg_killcount" },
    { 0x1B55E77A, "recent_singlefragmultikill" },
    { 0x253EC259, "recent_singlefragmultikillid" },
    { 0xD24E2AFA, "recentanihilatorcount" },
    { 0xF8A9CC0D, "recentarmbladecount" },
    { 0x4C6D5E1D, "recentattackerthreatscale" },
    { 0x33728105, "recentbowlaunchercount" },
    { 0x62127A3E, "recentc4killcount" },
    { 0xA5AE5296, "recentdomattackerkillcount" },
    { 0xAB08F1F9, "recentearnings" },
    { 0xB6CFE991, "recenter" },
    { 0x429F0EF2, "recenter_turret" },
    { 0xD228823B, "recentflamethrowercount" },
    { 0xAF119903, "recentgelguncount" },
    { 0xA0EA7E5C, "recentgravityspikescount" },
    { 0x51A95B67, "recentgrenadekillcount" },
    { 0xB652C437, "recentheroabilitykillcount" },
    { 0xF139455A, "recentheroabilitykillweapon" },
    { 0x93B3A434, "recentherokill" },
    { 0xC6B7E92D, "recentheroweaponkillcount" },
    { 0xC9DA93AB, "recentheroweaponvictims" },
    { 0xE1D6EA89, "recentkillcount" },
    { 0x16EFF98B, "recentkillcountsameweapon" },
    { 0x1B5E2919, "recentkillcountweapon" },
    { 0xA980EA2F, "recentkillvariables" },
    { 0xB3C3ECBF, "recentlethalcount" },
    { 0x402B4341, "recentlightningguncount" },
    { 0xA0F30FB1, "recently" },
    { 0x1368BAF2, "recently_deceased" },
    { 0xD4C855E3, "recently_skill" },
    { 0xDF24A6F8, "recentlysawenemy" },
    { 0x186C1D3E, "recentlystunned" },
    { 0x7488049D, "recentlysurvivedflak" },
    { 0x9F2F16DD, "recentmglkillcount" },
    { 0xB60D473A, "recentminiguncount" },
    { 0x9731C579, "recentpineappleguncount" },
    { 0x4DE151B5, "recentrcbombattackerkillcount" },
    { 0x70F77826, "recentrcbombcount" },
    { 0xBEC6A126, "recentrcbombkillcount" },
    { 0x5A43C920, "recentremotemissileattackerkillcount" },
    { 0x046A6F2F, "recentremotemissilecount" },
    { 0xA2706073, "recentremotemissilekillcount" },
    { 0xCD4C7EE7, "recentzonekillcount" },
    { 0x47D6DFEC, "reception" },
    { 0x8686E77C, "receptionist1_attach_head" },
    { 0x4F8CA81B, "receptionist2_attach_head" },
    { 0x8563ACE0, "receptionist_left" },
    { 0x84AE9BD3, "receptionists" },
    { 0x856A79F0, "rechamber" },
    { 0x8084CAEF, "rechamberanim" },
    { 0x482E705B, "rechambers" },
    { 0xC60B9762, "recharge" },
    { 0xDFC5E12D, "recharges" },
    { 0x3B77C853, "recharging" },
    { 0x51B0E732, "recheck" },
    { 0xADE44B6C, "recieve" },
    { 0x516AEA00, "recieved" },
    { 0x3D07526C, "recieved_notify" },
    { 0x8B9A859C, "recieveing" },
    { 0xBBA3E96F, "recieves" },
    { 0x34D13915, "recieving" },
    { 0xC83E80E1, "recive" },
    { 0x73BE18F7, "recived" },
    { 0x202A6E3F, "reckon" },
    { 0x0B61149E, "reclaim" },
    { 0x4ADF73E1, "reclaimed" },
    { 0x4CAB0438, "reclassify" },
    { 0xD62E11BE, "recloaking" },
    { 0x9BA621B6, "recognition" },
    { 0x2560E89B, "recognize" },
    { 0x4A48C885, "recognized" },
    { 0x7819B2BA, "recognizes" },
    { 0xFF1153FE, "recognizing" },
    { 0x0BB4D8AF, "recoil" },
    { 0x00E24F5A, "recoil_tag" },
    { 0xA170651E, "recoil_thread" },
    { 0xD72BA2A9, "recombine" },
    { 0xD032AD20, "recombines" },
    { 0x07668FA1, "recommend" },
    { 0x6D4FB78E, "recommended" },
    { 0x651DDEA5, "recommended_label" },
    { 0x26D8E25D, "recommended_label2" },
    { 0x9F75C375, "recompile" },
    { 0x2B162BA7, "recompling" },
    { 0x07BDE5EE, "recon" },
    { 0x67C7D921, "recon_1_done" },
    { 0x94D9F461, "recon_1_notify_done" },
    { 0xD52904D4, "recon_model" },
    { 0x45EF8A5D, "reconciled" },
    { 0x8A9B6712, "reconing" },
    { 0xF646F815, "reconmodel" },
    { 0x757EE530, "reconmodelentity" },
    { 0xFFA6E79C, "reconnect" },
    { 0xE1909D7F, "reconnected" },
    { 0xE0B07BDF, "reconnects" },
    { 0x7AF9CE03, "reconnectvehiclenodes" },
    { 0xE23698AC, "reconstitute" },
    { 0x9FD18C2D, "reconstruct" },
    { 0x169DB332, "reconstruct_fxanims_from_list" },
    { 0xE5995732, "record" },
    { 0x4C9624C6, "record3dtext" },
    { 0xBD2B98C3, "record_bread_crumbs_for_ambush" },
    { 0x5C64663D, "record_death" },
    { 0xB5C842CC, "record_early_attacks" },
    { 0x8BAFD46A, "record_enemy_sightings" },
    { 0x0619D0F4, "record_global_mp_stats_for_player_at_match_end" },
    { 0x83DC991F, "record_global_mp_stats_for_player_at_match_start" },
    { 0x785B46F3, "record_interruptions" },
    { 0x5680F8FB, "record_killanimscript" },
    { 0x541772FF, "record_late_attacks" },
    { 0xE4BE14FF, "record_misc_player_stats" },
    { 0xE8C2E0EA, "record_old_intensity" },
    { 0x0EB6C6BD, "record_pain" },
    { 0xB08D0F63, "record_positions" },
    { 0x96B5AF72, "record_settings" },
    { 0x461E8A20, "record_sighting" },
    { 0x93BE927A, "record_special_move_data_for_life" },
    { 0x290F5712, "record_stats" },
    { 0x5637DE0A, "recordactiveplayersendgamematchrecordstats" },
    { 0x6A33DA3C, "recordbbdataforplayer" },
    { 0x543E7299, "recordblackboxbreadcrumbdata" },
    { 0xEB5DDC51, "recordbreadcrumbdata" },
    { 0xEDA3E315, "recordbreadcrumbdataforplayer" },
    { 0x162E1B0A, "recordcircle" },
    { 0x59B5106B, "recordcomscoreevent" },
    { 0x9943E545, "recorded" },
    { 0x4B9C97F0, "recorded_data" },
    { 0xE5C98C62, "recorded_fx" },
    { 0xB7354230, "recorded_fx_timer" },
    { 0xEFD70C10, "recordendgamecomscoreevent" },
    { 0xC92849FA, "recordendgamecomscoreeventforplayer" },
    { 0x58F8DA89, "recordent" },
    { 0x32990EDC, "recordenttext" },
    { 0xED1749E3, "recorder" },
    { 0x1265F22C, "recordgameevent" },
    { 0x39DB4B22, "recordgameeventnonplayer" },
    { 0xE73290AF, "recordgameresult" },
    { 0x2C6F16BE, "recording" },
    { 0x2BF3E0A1, "recordings" },
    { 0xEA9FEC47, "recordkeeping" },
    { 0x5C5225DC, "recordkillcamsettings" },
    { 0x2D465945, "recordkillmodifier" },
    { 0xEE5FEDA5, "recordkillstreakassist" },
    { 0x050326B4, "recordkillstreakbegindirect" },
    { 0x301ADA3F, "recordkillstreakend" },
    { 0x6766BAB4, "recordkillstreakenddirect" },
    { 0xFB20B9ED, "recordkillstreakendevent" },
    { 0x93389DD8, "recordkillstreakevent" },
    { 0xCE78831B, "recordleaguepreloser" },
    { 0xC00DCB58, "recordleaguewinner" },
    { 0x8AFD7E24, "recordline" },
    { 0xFBE64BD0, "recordloadoutandperks" },
    { 0x0FA2221A, "recordloadoutindex" },
    { 0xCF0CED21, "recordloadoutperksandkillstreaks" },
    { 0xBFE21698, "recordmapevent" },
    { 0x875AC970, "recordmatchbegin" },
    { 0xD1039DDE, "recordmatchsummaryzombieendgamedata" },
    { 0x3897BC6D, "recordmultikill" },
    { 0x78D81502, "recordplayerdeathzombies" },
    { 0x819F012A, "recordplayerdownzombies" },
    { 0x98B36A07, "recordplayermatchend" },
    { 0xF562EC67, "recordplayerrevivezombies" },
    { 0xE01279AB, "recordplayerroundweapon" },
    { 0x6E910EE6, "recordplayerstats" },
    { 0x7CCB0167, "recordplaystyleinformation" },
    { 0x4B605DCC, "recordprimaryweaponsstats" },
    { 0x32CE3212, "recordroundendstats" },
    { 0xC1D136AF, "recordroundstartstats" },
    { 0x1C3A22BD, "records" },
    { 0xA1FD4E99, "recordsphere" },
    { 0x5CB41422, "recordstar" },
    { 0xC6BB0988, "recordstreakindex" },
    { 0xCD68694D, "recordtime" },
    { 0x240F8754, "recordusedspawnpoint" },
    { 0x72B3C387, "recordweaponstatkills" },
    { 0x69948487, "recordzmendgamecomscoreevent" },
    { 0xE20B6FC7, "recordzmendgamecomscoreeventforplayer" },
    { 0x58503FF3, "recordzombieroundend" },
    { 0x8106C620, "recordzombieroundstart" },
    { 0x2F6D758E, "recordzombiezone" },
    { 0xB9059385, "recored" },
    { 0xD2A31DBF, "recover" },
    { 0xAA7103AE, "recover_from_careful_disable" },
    { 0x5EDFC485, "recover_time" },
    { 0x8CC41D2F, "recoverable" },
    { 0x30A1BEC4, "recovered" },
    { 0x4D323141, "recovering" },
    { 0x6AB5F3F8, "recovering_from_goo" },
    { 0x8050203C, "recovery" },
    { 0x9DE832B8, "recovery_time" },
    { 0x48908F26, "recreate" },
    { 0x262F08DF, "recreating" },
    { 0x38963931, "recruit" },
    { 0xD5ED1E59, "recruit_db_switch" },
    { 0xF685EEDE, "recruited" },
    { 0x44491997, "recruiting" },
    { 0xE5C30C83, "recsat" },
    { 0xD8092763, "rect" },
    { 0x70099270, "recurse" },
    { 0xF3A219C7, "recursion" },
    { 0x89BA3366, "recursiondepth" },
    { 0xC851DC3B, "recursive" },
    { 0xD1FB1A26, "recursively" },
    { 0x4C807238, "recycle" },
    { 0xFD4FD06C, "recycled" },
    { 0xAD627C79, "recycling" },
    { 0xFD4D3E12, "red" },
    { 0xB9363CA8, "red_airplane_hide_and_show" },
    { 0xFF6469ED, "red_alert" },
    { 0x4611E73F, "red_barrel_detect_damage" },
    { 0x319B723B, "red_barrel_model" },
    { 0xB592D1A6, "red_barrel_porch" },
    { 0x08CD373A, "red_barrel_porch_failsafe" },
    { 0x0E3525CE, "red_damage" },
    { 0x194A00BB, "red_edge_overlay" },
    { 0xFCF40115, "red_guys" },
    { 0xE3F84A91, "red_new" },
    { 0xB3053B7B, "red_overlay" },
    { 0xCEDAB065, "red_plane_destroyed" },
    { 0x267D9B6E, "red_suncolor" },
    { 0xE60277D6, "redact" },
    { 0xB076A899, "redacted" },
    { 0x3A8C3676, "redacted_line_time" },
    { 0x980B16CA, "redacting" },
    { 0x0F0525FE, "redalert_intruder" },
    { 0x983454C7, "redangle" },
    { 0x7246B0B9, "redeemer_trigger" },
    { 0x312C16FB, "redefine" },
    { 0xBA842F65, "redefined" },
    { 0xE855199A, "redefines" },
    { 0xF234A9FF, "redeploy" },
    { 0x5360A7C6, "redeploy_on_poi_attemptedtakeover" },
    { 0x28C6179D, "redeploy_on_poi_lost" },
    { 0xBDBBF790, "redeploy_on_poi_takeover" },
    { 0x131503B4, "redflashingoverlay" },
    { 0x1798D8D0, "rediculous" },
    { 0xA9CDC735, "rediculously" },
    { 0x66FF550D, "redirect" },
    { 0x58CA9439, "redirect_zombies" },
    { 0x944F921B, "redirecting" },
    { 0x453DB4A1, "redirection" },
    { 0x9E74808C, "redirects" },
    { 0x9075F1CF, "redistribute" },
    { 0x6043B7C4, "redlight_spinner" },
    { 0xD8072E81, "redlights" },
    { 0x45C657F4, "redlights_think" },
    { 0x03B23E31, "redo" },
    { 0xB7A0CA63, "redo_clear" },
    { 0x49BCAA2A, "redo_link_changes" },
    { 0xDAFD9097, "redoing" },
    { 0xD322A878, "redomodel" },
    { 0x1E70950A, "redone" },
    { 0xCBCFFB1D, "reds" },
    { 0x2F32FCB0, "redscreenflash" },
    { 0x7128C406, "redshirt" },
    { 0xEF07694B, "redshirt1" },
    { 0xFA553F81, "redshirt1_anim" },
    { 0xB223C29C, "redshirt1_delta" },
    { 0x06488EF5, "redshirt1_group2_anim" },
    { 0xF5FEB7F2, "redshirt1_vent_think" },
    { 0x7CFFFA10, "redshirt2" },
    { 0x13D1AE85, "redshirt2_ai" },
    { 0xD4A570C8, "redshirt2_anim" },
    { 0xC3ACF7DB, "redshirt2_delta" },
    { 0xAA89789A, "redshirt2_group2_anim" },
    { 0xC0FA8F57, "redshirt2_vent_think" },
    { 0xA3027479, "redshirt3" },
    { 0x610ED886, "redshirt4" },
    { 0x019B8DC2, "redshirt_5" },
    { 0xDB991359, "redshirt_6" },
    { 0x44D2FBD5, "redshirt_assault_nogear" },
    { 0x0DFFB15F, "redshirt_checks_on_briggs" },
    { 0xBDEB3574, "redshirt_corpse_cleanup" },
    { 0x7DD36D50, "redshirt_cqb_nogear" },
    { 0x29174EB9, "redshirt_dialog" },
    { 0xD7931938, "redshirt_follow_hudson" },
    { 0x27E5E2D8, "redshirt_get_on_pbr" },
    { 0x6DF0E94C, "redshirt_intro_jetwing" },
    { 0x341AFC01, "redshirt_jeep" },
    { 0xE43F418A, "redshirt_jetwing_start" },
    { 0x6ED00816, "redshirt_leader" },
    { 0x995E46EE, "redshirt_lmg_nogear" },
    { 0x19ACC1D8, "redshirt_moveup_trigger" },
    { 0x7663F7E6, "redshirt_node1" },
    { 0x50617D7D, "redshirt_node2" },
    { 0xB2BC83F1, "redshirt_nva_push_vo" },
    { 0xD65CA596, "redshirt_pickup_gun" },
    { 0x0D20F684, "redshirt_putdownup_gun" },
    { 0xB9854365, "redshirt_route1" },
    { 0xDF87BDCE, "redshirt_route2" },
    { 0x8628D277, "redshirt_routes" },
    { 0x8078B54C, "redshirt_rushes_turret" },
    { 0xB2270507, "redshirt_setup_basic" },
    { 0x60601B29, "redshirt_setup_basic_old" },
    { 0xB923E38C, "redshirt_shotgun_nogear" },
    { 0x219C3D3B, "redshirt_sniper_nogear" },
    { 0x66A469A6, "redshirt_support" },
    { 0x510EBFA2, "redshirt_team" },
    { 0x42D1062A, "redshirt_team_members" },
    { 0xE5874558, "redshirt_y_to_g" },
    { 0x5C2F7C97, "redshirt_yell" },
    { 0x881B143D, "redshirtcopy" },
    { 0xFC2FEB12, "redshirtdist" },
    { 0x23A10EB9, "redshirts" },
    { 0xB51A4236, "redshirts_go_ashore_in_alcove" },
    { 0x97A1ACD9, "redshirtspawners" },
    { 0xFC527704, "redshirtsrunspot" },
    { 0x5086A7D3, "reduce" },
    { 0xDCF8908D, "reduce_accuracy_veteran" },
    { 0x0F604481, "reduce_ai_accuracy_before_the_jump" },
    { 0x98905FA2, "reduce_friendly_fire_damage" },
    { 0xB70BA876, "reduce_npc_pbr_damage" },
    { 0xAFA51EBD, "reduce_speed_amount_mpg" },
    { 0xEF533FA6, "reduce_to_1_health" },
    { 0x6C21125E, "reduce_vehicle_damage" },
    { 0x6EB4CDAD, "reduced" },
    { 0xE6F06B4F, "reduced_cost" },
    { 0x17A0F3C3, "reduced_damage" },
    { 0xDD476A75, "reduced_to_one_bowman" },
    { 0x4C510A59, "reduced_to_one_brooks" },
    { 0x0EA1E8BF, "reduced_to_one_doorkick" },
    { 0xE416E980, "reduced_to_one_doorkick_trans" },
    { 0x5BDB5DC5, "reduced_to_one_guard1" },
    { 0x81DDD82E, "reduced_to_one_guard2" },
    { 0xA26A7065, "reducedshock" },
    { 0xFFC8E9B0, "reducegiptponkillanimscript" },
    { 0x82D77F6B, "reducer" },
    { 0x2A18694A, "reducers" },
    { 0x5CD50502, "reduces" },
    { 0x1F5DB208, "reduceshownotetrackoffset" },
    { 0x5554C7F0, "reducetakecoverwarnings" },
    { 0xA1EA27F6, "reduceteamkillsovertime" },
    { 0x4F0FF070, "reduceval" },
    { 0x7609AA56, "reducing" },
    { 0x70F91540, "reduction" },
    { 0x1B9244DD, "reductionpersecond" },
    { 0xA1687335, "redudantly" },
    { 0x0FA71968, "redundancy" },
    { 0x8F76637C, "redundant" },
    { 0x19365579, "redundantly" },
    { 0xE7E8F02B, "reduse_speed_training_mpg" },
    { 0x689B6BE5, "reed" },
    { 0x9747B72D, "reeks" },
    { 0x3887989D, "reel" },
    { 0x25AEFCC0, "reel_0" },
    { 0x4BB17729, "reel_1" },
    { 0x71B3F192, "reel_2" },
    { 0x835FE44E, "reel_active" },
    { 0x8D6195C7, "reel_model" },
    { 0xDE8161E1, "reel_rack" },
    { 0x7E0AFB20, "reel_rack_start" },
    { 0x1937C9A0, "reel_set" },
    { 0x9F5178D6, "reel_trigger_array" },
    { 0xF98F4AB4, "reelhud" },
    { 0xC9835DDC, "reels" },
    { 0x83976E1F, "reenable" },
    { 0xF2ADD2FC, "reenable_battle_1_running" },
    { 0x47E15853, "reenable_battle_2_running" },
    { 0x85E79F78, "reenable_color_from_goalnode" },
    { 0x5ABDBC69, "reenable_hut_running" },
    { 0xC010140B, "reenable_kill_player_battle_1" },
    { 0x4E08A4D0, "reenable_kill_player_battle_2" },
    { 0xB51FFC90, "reenable_kill_player_hut" },
    { 0xBA808584, "reenable_quickrevive" },
    { 0x9EA78144, "reenable_react_at_node" },
    { 0xEE092409, "reenabled" },
    { 0x3BAA3DE6, "reenableexits" },
    { 0x2EB1A09A, "reenabling" },
    { 0x17F72EDC, "reenforce" },
    { 0x624C88E8, "reenforcement" },
    { 0x2D96B23B, "reenforcement_guys" },
    { 0xC82C6257, "reenforcement_node" },
    { 0xC5F10DF5, "reenforcement_special_ai_spawn" },
    { 0x7370D0C3, "reenforcement_squad_spawn" },
    { 0x776D6683, "reenforcements" },
    { 0xA3B7FEDB, "reenforcements_and_spawners" },
    { 0x06CD4AF0, "reenter" },
    { 0xFBE06DFD, "reenter_func" },
    { 0x34459F44, "reentered_battlefield" },
    { 0x8FC2153C, "reentrant" },
    { 0xE296020F, "reevaluate" },
    { 0x62EE6111, "reevaluate_reviver" },
    { 0x6A093B59, "reevaluated" },
    { 0xB1484940, "ref" },
    { 0xD50289A1, "ref_ang" },
    { 0xF49E0CBB, "ref_angles" },
    { 0x57220144, "ref_count" },
    { 0xB8571027, "ref_count_lerp_thread" },
    { 0x190E7A46, "ref_ent" },
    { 0x7D2E328F, "ref_node" },
    { 0x49319EE6, "ref_offset" },
    { 0xC33C5D95, "ref_origin" },
    { 0xE9D2711B, "ref_point" },
    { 0x8FD1842B, "ref_pt" },
    { 0xEE98DB2F, "ref_tok" },
    { 0x4D70A123, "refactor" },
    { 0xCAAE1DDD, "refcount" },
    { 0x2873D940, "refcountdecchopper" },
    { 0x2A62B32D, "refcountdecchopperondisconnect" },
    { 0xBDDC0120, "refect" },
    { 0xADDC5415, "refer" },
    { 0x60D36542, "refered" },
    { 0xC46C7654, "reference" },
    { 0x80F3AD3F, "reference_angles" },
    { 0x63E9F9BE, "reference_anims_from_animtree" },
    { 0x07202820, "reference_full" },
    { 0xA6620AD3, "reference_node" },
    { 0x44B255A2, "reference_object" },
    { 0x4D7E5C5A, "reference_s" },
    { 0xD1932600, "referencecounter" },
    { 0x32650F78, "referenced" },
    { 0x34F2D775, "referencename" },
    { 0xDC4EC1C7, "references" },
    { 0x77994BDD, "referencing" },
    { 0x74B2E831, "referneces" },
    { 0x06867D7A, "referred" },
    { 0xB4F89464, "refers" },
    { 0x8A2D30F1, "refill" },
    { 0x1581B116, "refill_ammo" },
    { 0xCEB8EBFF, "refill_max_ammo" },
    { 0x72919814, "refill_player_clip" },
    { 0xDFA37ED9, "refill_weapon_clip" },
    { 0x60E30D1B, "refillammo" },
    { 0xCFDABAD2, "refillammoandcleanupcovermode" },
    { 0x8158C177, "refillclip" },
    { 0x5CE69B9E, "refilled" },
    { 0x2D3BD757, "refilling" },
    { 0x23565B58, "refills" },
    { 0x3926472A, "refire_player_downed" },
    { 0xCE73E717, "refit" },
    { 0x50AF9CE4, "reflect" },
    { 0x25E666BE, "reflect_trace" },
    { 0x266D0759, "reflectbulletshandler" },
    { 0x08CA910E, "reflection" },
    { 0x923E1720, "reflection_height" },
    { 0xF3309EF0, "reflection_locs" },
    { 0x7AB70F5C, "reflection_scene_head_track" },
    { 0xF8697F43, "reflection_width" },
    { 0x1DCA50B1, "reflections" },
    { 0x92C31E79, "refname" },
    { 0x3FBA738A, "reforg" },
    { 0x115585C2, "refpoint" },
    { 0xE62A428A, "refrain" },
    { 0xA7D94DDE, "refrenence" },
    { 0xF914A0B6, "refresh" },
    { 0x76A0F40A, "refresh_all_map_shaders" },
    { 0x4734AD56, "refresh_attach" },
    { 0x267A1A79, "refresh_burst" },
    { 0xCF8B684A, "refresh_map_shaders" },
    { 0x53C7E831, "refresh_menu_values" },
    { 0x785A0AE4, "refresh_player_navcard_hud" },
    { 0x3CACE1FE, "refresh_war_map_shader" },
    { 0x81D8BF79, "refreshed" },
    { 0xDFBD7CF6, "refreshes" },
    { 0x5A214C39, "refreshhudammocounter" },
    { 0x9E095DE7, "refreshhudcompass" },
    { 0x94D67F2A, "refreshing" },
    { 0xF955959E, "refreshshieldattachment" },
    { 0x66AB186B, "refs" },
    { 0x660024D1, "refspeed" },
    { 0xFF40C9EB, "refstring" },
    { 0x802B53A2, "refuel" },
    { 0x2CF79302, "refuel_animate" },
    { 0x3219BA05, "refuelable_plane" },
    { 0x689867F4, "refuelable_plane_gas1" },
    { 0xDA9FD72F, "refuelable_plane_gas2" },
    { 0xB49D5CC6, "refuelable_plane_gas3" },
    { 0xF690F8B9, "refuelable_plane_gas4" },
    { 0xD08E7E50, "refuelable_plane_gas5" },
    { 0x9DAB74B5, "refueled" },
    { 0x8CB3188E, "refueling" },
    { 0xA81E695D, "refueltime" },
    { 0x2AD546CF, "refund" },
    { 0xA872F146, "refund_generator_cost_if_player_captured_it" },
    { 0xC318D6D9, "refuse" },
    { 0x50EFB2E5, "refuse_flags" },
    { 0xA64C8790, "refuses" },
    { 0x415D2661, "refwrapper" },
    { 0xD74AC3A9, "reg" },
    { 0x93A0329B, "regain" },
    { 0x52EE7F10, "regained" },
    { 0x26564705, "regaining" },
    { 0x05BB30BA, "regains" },
    { 0xD55A2828, "regard" },
    { 0x6622AFF0, "regarding" },
    { 0x4EA08443, "regardless" },
    { 0xAF1985CF, "regarless" },
    { 0x291F2A4C, "regen" },
    { 0x22EB0DB8, "regen_armor" },
    { 0x5EA9ACCA, "regen_boat_health" },
    { 0x28790CF0, "regen_front_armor" },
    { 0x6BB4BD24, "regen_interval" },
    { 0xC5FB7989, "regen_start" },
    { 0xBEA05FE9, "regen_start_delay" },
    { 0x01862BE6, "regen_vehicle_health" },
    { 0x749D1818, "regenamount" },
    { 0x86B0EA2F, "regened" },
    { 0xC9943DBB, "regenerate" },
    { 0x67B66425, "regenerated" },
    { 0x95874E5A, "regenerates" },
    { 0x733BEB1E, "regenerating" },
    { 0x4071F9D8, "regeneration" },
    { 0x62AC0A2B, "regeninctimer" },
    { 0xE9BAA036, "regenning" },
    { 0x83E2156E, "regenpoint" },
    { 0x53412CC2, "regenrate" },
    { 0x1B2C92CF, "regens" },
    { 0x2596845F, "regentime" },
    { 0x780CE44F, "regentimer" },
    { 0xA537F266, "reget" },
    { 0x5F6F8DDC, "regime" },
    { 0xF0BFAE6A, "regiment" },
    { 0x69D7B165, "region" },
    { 0x37E0D774, "region_check_time" },
    { 0x05247F6B, "region_empty" },
    { 0x5BC3B792, "region_size_sq" },
    { 0xBBF09C25, "region_str" },
    { 0x32DE208B, "region_timer" },
    { 0xB1FBC674, "regions" },
    { 0x50F16166, "register" },
    { 0x59435A8D, "register_aat_exemption" },
    { 0xC9E6CCDE, "register_actor_damage_callback" },
    { 0xA638807D, "register_allowed_gameobject" },
    { 0xCDA5F05D, "register_alt_weapon" },
    { 0x9CA4E7AA, "register_anim_dvar" },
    { 0xFC62B444, "register_argus_zone" },
    { 0xFA596AA5, "register_audio_skit" },
    { 0x194DD963, "register_burn_overlay" },
    { 0xE6630DC0, "register_candy_context" },
    { 0x07BA442E, "register_carpenter_node" },
    { 0x8D3B40D8, "register_challenge" },
    { 0xE00B088B, "register_character_line" },
    { 0xD200D50E, "register_cleansed_match" },
    { 0xB8CFF764, "register_client_fields" },
    { 0xEE785094, "register_client_flags" },
    { 0x4ECE4A2F, "register_clientfields" },
    { 0xB4C3E588, "register_clientflag_callback" },
    { 0x69F2D0A3, "register_clientflag_callbacks" },
    { 0x3A68AFCC, "register_custom_add_state_callback" },
    { 0xB6421974, "register_custom_ai_spawn_check" },
    { 0xA05AB380, "register_custom_spawner_entry" },
    { 0xAC86D63B, "register_default_actor_callbacks" },
    { 0x04B10F1C, "register_default_general_callbacks" },
    { 0x940C50BC, "register_default_mg42_callbacks" },
    { 0x826D7324, "register_default_missile_callbacks" },
    { 0x15A843DD, "register_default_na_callbacks" },
    { 0x193FD03A, "register_default_plane_callbacks" },
    { 0x44FFADBD, "register_default_player_callbacks" },
    { 0xE04BDF80, "register_default_scriptmover_callbacks" },
    { 0x2D1E8E00, "register_default_vehicle_callbacks" },
    { 0xB6F1DE2D, "register_dev_dvars" },
    { 0x7F92F159, "register_dialog" },
    { 0x0A0B95EF, "register_dyn_unitrigger" },
    { 0xF4769E1C, "register_dynamic_anim_dvar" },
    { 0xA0CBB2F2, "register_elements_powered_by_zone_capture_generators" },
    { 0xE7001AAB, "register_equipment" },
    { 0x0121E7B8, "register_equipment_for_level" },
    { 0xEF0D035F, "register_event" },
    { 0x0F5AC04C, "register_filter_materials" },
    { 0xC1F86B71, "register_flag_handlers" },
    { 0x59AEE0A5, "register_for_level" },
    { 0xFD376945, "register_gadget" },
    { 0xFBDAB78D, "register_gadget_activation_callbacks" },
    { 0xFBF59049, "register_gadget_failed_activate_callback" },
    { 0x15EDA291, "register_gadget_flicker_callbacks" },
    { 0xD2127DDE, "register_gadget_is_flickering_callbacks" },
    { 0xF04867AE, "register_gadget_is_inuse_callbacks" },
    { 0x0370B60F, "register_gadget_possession_callbacks" },
    { 0x714915A6, "register_gadget_primed_callbacks" },
    { 0x9931FC48, "register_gadget_ready_callbacks" },
    { 0x7F32DAD7, "register_gadget_should_notify" },
    { 0xF2922C86, "register_game_module" },
    { 0x87E0BAF8, "register_gibs" },
    { 0xD6503918, "register_grief_match" },
    { 0xCF413D9A, "register_hackable" },
    { 0xE6296C4E, "register_hackable_struct" },
    { 0xC3B299C0, "register_hero_ability_kill_event" },
    { 0x53B75765, "register_hero_ability_multikill_event" },
    { 0x3D766BF2, "register_hero_recharge_event" },
    { 0xD29010F8, "register_hero_weapon" },
    { 0x1E641D6F, "register_hero_weapon_for_level" },
    { 0x09AA1D93, "register_hero_weapon_give_take_callbacks" },
    { 0x6725C41B, "register_hero_weapon_multikill_event" },
    { 0xABE86C3F, "register_hero_weapon_power_callbacks" },
    { 0xE295A0C2, "register_hero_weapon_wield_unwield_callbacks" },
    { 0xC105A364, "register_ignore_player_handler" },
    { 0x0ABE6717, "register_immunity" },
    { 0x9BE319F9, "register_info" },
    { 0x7C80C2F5, "register_kill" },
    { 0x9A1DEE56, "register_killstreak_bundle" },
    { 0x4D0FC8B3, "register_lethal_grenade_for_level" },
    { 0xE14F1A56, "register_level_specific_client_fields" },
    { 0xFF5CAE8E, "register_light_type" },
    { 0x345B484D, "register_lost_perk_override" },
    { 0xB05241A5, "register_map_navcard" },
    { 0x9E3E3326, "register_meat_match" },
    { 0xF9F4B105, "register_melee_weapon_for_level" },
    { 0x2555A1A3, "register_mystery_box_for_zone" },
    { 0x30F32A58, "register_nml_match" },
    { 0x8829DAC6, "register_objective" },
    { 0xF1DED33F, "register_offhand_weapons_for_level_defaults" },
    { 0xF55453EA, "register_offhand_weapons_for_level_defaults_override" },
    { 0x42617574, "register_overlay_info_style_blur" },
    { 0xB4532004, "register_overlay_info_style_burn" },
    { 0x1ACE3093, "register_overlay_info_style_electrified" },
    { 0x2762FB91, "register_overlay_info_style_filter" },
    { 0xA6FCFB4D, "register_overlay_info_style_none" },
    { 0xD33F01F7, "register_overlay_info_style_poison" },
    { 0xE5C365C2, "register_overlay_info_style_postfx_bundle" },
    { 0xBAAF2F5C, "register_overlay_info_style_speed_blur" },
    { 0x9155A3BD, "register_overlay_info_style_transported" },
    { 0x27F83A05, "register_overloaded_func" },
    { 0xF6A97B55, "register_perk_basic_info" },
    { 0x16DFD0EA, "register_perk_clientfields" },
    { 0x7A4242D7, "register_perk_damage_override_func" },
    { 0x6429F7AA, "register_perk_effects" },
    { 0x8F04BD44, "register_perk_host_migration_func" },
    { 0x2BB2F938, "register_perk_host_migration_params" },
    { 0xE594A1AD, "register_perk_init_thread" },
    { 0x163232F7, "register_perk_machine" },
    { 0xD6A0DAE8, "register_perk_machine_for_zone" },
    { 0xB420E228, "register_perk_machine_power_override" },
    { 0x01F29D94, "register_perk_precache_func" },
    { 0x2EF05DA3, "register_perk_threads" },
    { 0xF03301A4, "register_perks" },
    { 0xC3DFEF94, "register_pers_upgrade" },
    { 0x8C4E5F2D, "register_pitted_match" },
    { 0x1297DEBB, "register_placeable_mine_for_level" },
    { 0xC33F910E, "register_player_contract_event" },
    { 0x63A43FB8, "register_player_damage_callback" },
    { 0xD4584807, "register_player_friendly_fire_callback" },
    { 0xE1B92EE4, "register_pooled_hackable" },
    { 0x66764564, "register_pooled_hackable_struct" },
    { 0x3D5F6A1F, "register_powerup" },
    { 0x18D592FA, "register_powerup_weapon" },
    { 0x4845347E, "register_race" },
    { 0x1E46D552, "register_random_perk_machine_for_zone" },
    { 0xB4044899, "register_remote_override_weapon" },
    { 0x17CBE4C3, "register_reroll" },
    { 0x84FF4B41, "register_revive_override" },
    { 0x6AEAF56E, "register_revive_success_perk_func" },
    { 0x45FDE98C, "register_score_event" },
    { 0xC486FC1B, "register_screecher_lights" },
    { 0x209B2B1A, "register_sidequest" },
    { 0x225A92D6, "register_sidequest_icon" },
    { 0xA8A1BB93, "register_slot_watcher_override" },
    { 0x7FC01EF5, "register_sloth_client_fields" },
    { 0x61D947E2, "register_slowdown" },
    { 0x583C0FF4, "register_standard_match" },
    { 0xD8F45568, "register_static_unitrigger" },
    { 0xF79FD1E9, "register_strings" },
    { 0xFF15A052, "register_system" },
    { 0x14B87192, "register_system_ex" },
    { 0x1BDDF246, "register_tactical_grenade_for_level" },
    { 0x32886674, "register_thief_shutdown_enemy_event" },
    { 0xE9877AF8, "register_time_bomb_enemy" },
    { 0x835BD4CA, "register_time_bomb_enemy_default" },
    { 0x2B17EA95, "register_time_bomb_enemy_save_filter" },
    { 0xE8D79063, "register_tos_dvar" },
    { 0x619AABBA, "register_trap_basic_info" },
    { 0xA1E81A78, "register_trap_damage" },
    { 0xCF734E85, "register_turned_match" },
    { 0xCB9F70F2, "register_tutorials" },
    { 0x64876F6D, "register_type" },
    { 0xD3555CC7, "register_unitrigger" },
    { 0xE9F5D0E1, "register_unitrigger_internal" },
    { 0xB36886CA, "register_unitrigger_system_func" },
    { 0x6CEF3437, "register_vehicle" },
    { 0x9C9DAD1D, "register_vehicle_damage_callback" },
    { 0x336B3C36, "register_visionset_info" },
    { 0xD39A7012, "register_visionsets" },
    { 0xA1561A9D, "register_zombie_damage_callback" },
    { 0xC4AF84AE, "register_zombie_damage_override_callback" },
    { 0x6A0E8009, "register_zombie_death_animscript_callback" },
    { 0x202D5265, "register_zombie_death_event_callback" },
    { 0x2492131D, "register_zombie_types" },
    { 0x75B0344C, "register_zombie_weapon_callback" },
    { 0x6251E803, "registeractionbinding" },
    { 0x15F695FB, "registeractions" },
    { 0x31EFA8FD, "registeractorblackboardattributes" },
    { 0xC805FB3D, "registeraitypefootstepcb" },
    { 0xEE769D5A, "registeraivsaimeleebehaviorfunctions" },
    { 0x20B2425D, "registeranimationmocomp" },
    { 0x3188449C, "registeranimationselectortableevaluator" },
    { 0xDBCEA833, "registerapothiconfuryinterfaceattributes" },
    { 0x2386B792, "registerastscriptfunctions" },
    { 0xA13B795C, "registerbehaviorscriptfunctions" },
    { 0x5BDC5952, "registerbehaviortreeaction" },
    { 0xD3AEC141, "registerbehaviortreeactioninternal" },
    { 0x19BD8D4F, "registerbehaviortreescriptapi" },
    { 0x2B3CF3B0, "registerbehaviortreescriptapiinternal" },
    { 0xB799D2BB, "registerblackboardattribute" },
    { 0x491A1A0E, "registerblackboardnotetrackhandler" },
    { 0x6B3DD6D8, "registerbsmscriptapiinternal" },
    { 0xF22A66A1, "registerchallengescallback" },
    { 0xBC1FCEA1, "registerclientfield" },
    { 0xB3F54A48, "registerclientfields" },
    { 0xCF2449EE, "registerclientsys" },
    { 0xDEEFA65E, "registercontractwinevent" },
    { 0xCA6C069A, "registercrates" },
    { 0x56447F63, "registercratetype" },
    { 0xBF1EDC0B, "registerdefaultanimationmocomps" },
    { 0xE777F469, "registerdefaultnotetrackhandlerfunctions" },
    { 0x2241187C, "registerdefaults" },
    { 0x9C3F9DAF, "registerdialoggroup" },
    { 0xF105374C, "registerdvars" },
    { 0xA6EAD4E9, "registered" },
    { 0x9F81BEEC, "registerfriendlyfiredelay" },
    { 0x96A406D2, "registergadgettype" },
    { 0x9B3B12A8, "registergrenadelauncherduddvar" },
    { 0x1F1DA765, "registerhumaninterfaceattributes" },
    { 0x8F5CBAFA, "registerhumanriotshieldinterfaceattributes" },
    { 0xDAC166C8, "registerhumanrpginterfaceattributes" },
    { 0x9BD6DFFA, "registering" },
    { 0xE86B9F80, "registerinterfaceattributes" },
    { 0x61281602, "registerinventory" },
    { 0x91A0F11A, "registerkeybinding" },
    { 0xE342C9E4, "registerkillstreak" },
    { 0x80E01DDD, "registerkillstreakaltweapon" },
    { 0xDDE54911, "registerkillstreakdelay" },
    { 0x751A6E7A, "registerkillstreakdevdvar" },
    { 0x25A56C24, "registerkillstreakdialog" },
    { 0xDC69FAE6, "registerkillstreakremoteoverrideweapon" },
    { 0x2EFF2B6E, "registerkillstreakstrings" },
    { 0x44B98E84, "registermannequininterfaceattributes" },
    { 0x113088FB, "registermatchedinterface" },
    { 0xC4D07F6E, "registermedalcallback" },
    { 0x69ECAF7D, "registermissioncallback" },
    { 0x0A522AF1, "registernotetrackhandlerfunction" },
    { 0x398DF63E, "registernotetracks" },
    { 0x1046D618, "registernumericinterface" },
    { 0x69229FBB, "registernumlives" },
    { 0x9EBC0494, "registernumlivesdvar" },
    { 0x89456F0F, "registerobjective" },
    { 0x3621A484, "registerotherlootxpawards" },
    { 0x10704124, "registerpostroundevent" },
    { 0xDD0DA2BE, "registerproperkcallback" },
    { 0xDD390964, "registerremoteweapon" },
    { 0xA12DF3FD, "registerrewindfx" },
    { 0x4FC8DA84, "registerrobotinterfaceattributes" },
    { 0x549DD2F3, "registerroundlimit" },
    { 0x3C7D50CC, "registerroundlimitdvar" },
    { 0x11E7DA81, "registerroundscorelimit" },
    { 0x4A3F3EBE, "registerroundswitch" },
    { 0x1E8D5A65, "registerroundswitchdvar" },
    { 0x779E30C5, "registerroundwinlimit" },
    { 0x9A328796, "registerroundwinlimitdvar" },
    { 0x4BD23299, "registers" },
    { 0xD48595D1, "registerscoreeventcallback" },
    { 0xD36E0F7C, "registerscoreinfo" },
    { 0xD094FB41, "registerscorelimit" },
    { 0x000EC162, "registerscorelimitdvar" },
    { 0xCA333919, "registersharedinterfaceattributes" },
    { 0x68ED15B1, "registersystem" },
    { 0x7A389DB2, "registerteamsets" },
    { 0x347A8745, "registerthrasherinterfaceattributes" },
    { 0xD4FA996A, "registerthrowngrenadeduddvar" },
    { 0xAA42B85A, "registertimelimit" },
    { 0xB8300F21, "registertimelimitdvar" },
    { 0x0FE7E3D2, "registertweakable" },
    { 0x89E1FC16, "registerutilityblackboardattributes" },
    { 0x5EF4F02C, "registervectorinterface" },
    { 0x4A9398AE, "registervehicleblackboardattributes" },
    { 0x50235B45, "registervehiclefootstepcallback" },
    { 0x65180251, "registerwarlordinterfaceattributes" },
    { 0x52BF8EEE, "registerweaponinfo" },
    { 0x7CE6CC1A, "registerwithhackertool" },
    { 0xCADA4DEE, "registerxp" },
    { 0xE102DB28, "registerzombiedoginterfaceattributes" },
    { 0x5C70724A, "registerzombieinterfaceattributes" },
    { 0x2E1C819E, "registration" },
    { 0x2F548501, "registrations" },
    { 0x50B4157B, "regourp" },
    { 0x4799E746, "regret" },
    { 0xBE3F0142, "regrop_woods_communication" },
    { 0x62FFB67B, "regroup" },
    { 0x9B89CDB1, "regroup_anim" },
    { 0x49D07B0C, "regroup_finished" },
    { 0x9928B97B, "regroup_invulnerability" },
    { 0x73B36A23, "regroup_land_obj" },
    { 0x2DD9189D, "regroup_obj" },
    { 0x8F88F108, "regroup_org" },
    { 0xB43A3241, "regroup_pre_ddm" },
    { 0x6EC75B86, "regroup_spot" },
    { 0xE947E92C, "regroup_trig" },
    { 0xCDFACA56, "regroup_trigger" },
    { 0xBD7A4D4B, "regroup_upriver_obj" },
    { 0xA870CC7B, "regroup_vo" },
    { 0xF5E351F0, "regrouped" },
    { 0x266C5865, "regrouping" },
    { 0xD879301A, "regroups" },
    { 0x1B9BB505, "regsquad" },
    { 0x14B3F648, "regualar" },
    { 0x3E17D015, "regualr" },
    { 0xB632E28B, "regular" },
    { 0x8DEE6CB0, "regular_guys_taken_off" },
    { 0xA80669F7, "regular_portal_fx_on" },
    { 0xC807EF19, "regular_variant" },
    { 0xB7C0BBE1, "regulargamemessages" },
    { 0xCDD6B856, "regularly" },
    { 0x93CFBB0A, "regulated" },
    { 0xE66A8423, "regulated_mbs" },
    { 0xA5AF83B5, "regulates" },
    { 0x61909B42, "reich" },
    { 0xEF64B498, "reich_fake_mg_fire" },
    { 0x50713180, "reich_flag_waving" },
    { 0x1417E84F, "reich_pillar_fall" },
    { 0x4E67386F, "reichstag" },
    { 0x93F097F1, "reichstag_dooranim" },
    { 0x3C8CFB35, "reincrement" },
    { 0xB82373F7, "reincrement_count_if_deleted" },
    { 0xACD3A3F8, "reinforce" },
    { 0x0B3D300C, "reinforce1_bp1_logic" },
    { 0x86B9AD23, "reinforce2_bp1_logic" },
    { 0x3A0B9DB6, "reinforce3_bp1_logic" },
    { 0x1FBA1ECD, "reinforce_bp1_green_logic" },
    { 0xBCFC20A9, "reinforce_bp1_logic" },
    { 0xA21C538A, "reinforce_bp2_logic" },
    { 0x7383813C, "reinforce_first_floor" },
    { 0x1A99B6B2, "reinforce_goal" },
    { 0xB707F135, "reinforce_goal_hero" },
    { 0x38FECFBD, "reinforce_horse_logic" },
    { 0xCA3AC12C, "reinforce_wave" },
    { 0x6184562C, "reinforced" },
    { 0x9D1BC2F4, "reinforcement" },
    { 0x6FD083B7, "reinforcement_dialog" },
    { 0x804EB23F, "reinforcement_spawned" },
    { 0x18E2FBE7, "reinforcements" },
    { 0xDCDBC890, "reinforcements_in_waves" },
    { 0xD6BBD898, "reinforcements_monitor" },
    { 0x3636C385, "reinforcements_needed" },
    { 0x39B0983E, "reinforcements_think" },
    { 0x216EE6A5, "reinforcements_triggers" },
    { 0x5CB9B38B, "reinforcemetns" },
    { 0x469AF339, "reinforcing" },
    { 0x74345C5B, "reinforments" },
    { 0x6BC10334, "reinit" },
    { 0x8C23EF43, "reinit_zone_spawners" },
    { 0x27B92D24, "reinitialize" },
    { 0x5428D8E8, "reinitialized" },
    { 0x1BCA134A, "reintating" },
    { 0xDF69CF27, "reise" },
    { 0xD132301C, "reissuesquadlastorders" },
    { 0xACAA65F7, "rejack" },
    { 0x2DE01560, "rejack_activate_requested" },
    { 0x7954730C, "rejack_activation_delay_seconds" },
    { 0x146812C3, "rejack_activation_window_seconds" },
    { 0x377254BC, "rejack_enter_power_penalty" },
    { 0xA59C632E, "rejack_reset_scorestreak" },
    { 0x09D55740, "rejack_smoke_fx_lifetime_after_rejack" },
    { 0x0B7EC48E, "rejack_smoke_fx_lifetime_seconds" },
    { 0x0E87B3FA, "rejack_smoke_sight_block_radius" },
    { 0x294B6473, "rejack_smoke_sight_block_time" },
    { 0x91D24DDA, "rejack_suicide" },
    { 0xF3809DE8, "rejack_ui_activate" },
    { 0x0F055F04, "reject" },
    { 0x59CEEDCC, "reject_angle" },
    { 0x2D6462A3, "reject_corpse" },
    { 0xE55EDAD7, "reject_dist" },
    { 0x80E8923C, "reject_dot" },
    { 0x3AB5C1B7, "rejects" },
    { 0xE6AC6602, "rejoice_at_end" },
    { 0x72ACE8DD, "rejoicing" },
    { 0x13597576, "rejoin" },
    { 0x739A7AC0, "rejoin_path" },
    { 0xDCABB6D9, "rejoin_squad" },
    { 0x91AC19B6, "rejoin_squad_2" },
    { 0x24BBE069, "rejoins" },
    { 0x00E6EE24, "rel_entity" },
    { 0xC51F2665, "relaease" },
    { 0xF9A7EDBE, "relaoding" },
    { 0x774D43CE, "related" },
    { 0x309B6D7D, "related_parent" },
    { 0x52EB4BA7, "relating" },
    { 0xA3B1C79D, "relation" },
    { 0x9468BF4F, "relationship" },
    { 0x2282BC4D, "relative" },
    { 0xDFFA9300, "relative_angles" },
    { 0x81E91F08, "relative_dir_" },
    { 0xEA247239, "relative_dir_back" },
    { 0xC2029B7D, "relative_dir_front" },
    { 0xD0BEF64B, "relative_dir_left" },
    { 0x3A2F064E, "relative_dir_none" },
    { 0x180EFF3E, "relative_dir_right" },
    { 0x9EBAE6E2, "relativeangle" },
    { 0xE9BEFD3A, "relativedir" },
    { 0x65D71E85, "relativediranimmap" },
    { 0x4AA80270, "relatively" },
    { 0xC306A06C, "relativeoffset" },
    { 0xE5715B95, "relativepoint" },
    { 0x4AA9326D, "relativepos" },
    { 0x34759367, "relativestarttimeinsecs" },
    { 0x98920C5A, "relativeteam" },
    { 0x5180DABF, "relativex" },
    { 0x2B7E6056, "relativey" },
    { 0x2DAA1E8E, "relavant" },
    { 0x75F0FF3D, "relax" },
    { 0xA400830D, "relax_ik_headtracking_limits" },
    { 0x9D3668EA, "relaxed" },
    { 0x3E25C1AB, "relaxing" },
    { 0x4FEE84D4, "relay" },
    { 0xCDDD4212, "relay_give_power" },
    { 0xA6E0C72C, "relay_station_cleared" },
    { 0x72E55888, "relay_station_sabotaged" },
    { 0xB15CFB65, "relay_switch_run" },
    { 0x20D54C0C, "relay_unitrigger_think" },
    { 0xB4983677, "relayed" },
    { 0x094AE214, "relaying" },
    { 0x2A36682C, "release" },
    { 0x89A214AA, "release_a_floater" },
    { 0xBAB54B42, "release_ads_button" },
    { 0x5EBBE90B, "release_all_objective_ids" },
    { 0x9AD6DA74, "release_anim" },
    { 0x2D6B01CE, "release_attack_button" },
    { 0x2496B415, "release_claimed_node" },
    { 0x55C3E89A, "release_complete" },
    { 0xF14E371A, "release_control_on_landing" },
    { 0xB7A982F9, "release_crawler" },
    { 0x41B866D3, "release_doublejump_button" },
    { 0x3722AC50, "release_flamethrower_trigger" },
    { 0x1DD17826, "release_frag_button" },
    { 0x0FF94B2E, "release_jump_button" },
    { 0x29718B4F, "release_limited_equipment_on_disconnect" },
    { 0xFBC8BDC7, "release_limited_equipment_on_equipment_taken" },
    { 0x35E7DF9A, "release_limited_on_disconnect" },
    { 0xAED082B1, "release_limited_on_taken" },
    { 0x3EC446A8, "release_new_horses" },
    { 0xE70334AB, "release_node" },
    { 0x6CDE6B52, "release_obj_id" },
    { 0x4605371C, "release_objective" },
    { 0x387CB668, "release_offhand_button" },
    { 0xF9F9BA87, "release_player_later" },
    { 0x4C9E0C2E, "release_spawner_target_node" },
    { 0x3449A9F6, "release_sprint_button" },
    { 0x3493B5D6, "release_started" },
    { 0x6174E2FE, "release_swim_down" },
    { 0x67A9A01D, "release_swim_up" },
    { 0xA9CE53D8, "release_throw_button" },
    { 0xD648E788, "release_time" },
    { 0xEEBAD573, "release_use_button" },
    { 0xB641C5E9, "release_use_trigger" },
    { 0xCAF58DBD, "releaseclaimedtrigger" },
    { 0xF9BA96FC, "releaseclaimnode" },
    { 0xC7EB60C0, "released" },
    { 0x5B55503C, "released_early" },
    { 0x8637F940, "releasedobjectives" },
    { 0xC2747FC8, "releaseflare" },
    { 0x40F9945C, "releaseing" },
    { 0x41C2610F, "releasenapalm" },
    { 0xADBF1314, "releaseobjid" },
    { 0x633436CE, "releasepoint" },
    { 0x8E468BAC, "releasepointdropped" },
    { 0x61FAEAF6, "releasepointlifted" },
    { 0x3224602F, "releases" },
    { 0x991BA9D5, "releasing" },
    { 0x43827949, "releaved" },
    { 0x86E28D92, "relevant" },
    { 0x043F211F, "reliable" },
    { 0xFC70B153, "reliably" },
    { 0xFACCD032, "reliant" },
    { 0xBEE76DBB, "relies" },
    { 0x7B2453EF, "relieve" },
    { 0xF17584B9, "relieved" },
    { 0x37A6413A, "relink" },
    { 0x5DC5195D, "relink_elev_doors" },
    { 0xCF83DF97, "relinktoturret" },
    { 0x6CD505E3, "relinquish" },
    { 0xF7BE0A32, "reload" },
    { 0x392F35F5, "reload_attack_cooldown_timer" },
    { 0x27002EB2, "reload_attack_max_damage" },
    { 0x07E572AF, "reload_attack_max_radius" },
    { 0xA80488F0, "reload_attack_min_damage" },
    { 0x66A07899, "reload_attack_min_radius" },
    { 0x2E14F021, "reload_attack_points" },
    { 0xDE4DAF71, "reload_chopper_sounds" },
    { 0xD42040D0, "reload_clip_on_stand" },
    { 0xFAFE036A, "reload_rocket_audio" },
    { 0x9178FEB0, "reload_rockets" },
    { 0xE598DA5B, "reload_start" },
    { 0x167E0B1A, "reload_string" },
    { 0xE35509A8, "reload_timer_reset" },
    { 0x714897E1, "reload_vo_index" },
    { 0xCE656811, "reload_weapon" },
    { 0x04A97A4D, "reloadanim" },
    { 0x205B8784, "reloadbuttonpressed" },
    { 0x3AA75872, "reloadclipinhand" },
    { 0xED9F5045, "reloaded" },
    { 0x1755EE18, "reloaded_rocket" },
    { 0x7769C8E6, "reloadfrac" },
    { 0x8646035E, "reloadifempty" },
    { 0xF85887BE, "reloading" },
    { 0xDA91F417, "reloading_vo_max" },
    { 0x27E346CC, "reloadrate" },
    { 0xABFFEBBD, "reloads" },
    { 0xD6230291, "reloadstandrun" },
    { 0xC0438E8E, "reloadstandruninternal" },
    { 0x81F67537, "reloadthenkill" },
    { 0x33251375, "reloadthenkillstart" },
    { 0x1DC38794, "reloadthenkilltimedout" },
    { 0xED2B9C30, "reloadthenkilltimeout" },
    { 0xCDE54C4D, "reloadtime" },
    { 0x10AC9515, "reloadtimemax" },
    { 0x3B3EA05B, "reloadtimemin" },
    { 0x6F12C543, "reloadtimeout" },
    { 0xAA8055B1, "reloadtracking" },
    { 0xE9EDF6C2, "reloadweapon" },
    { 0x3E942D90, "reloadweaponammo" },
    { 0xDE44A5B5, "reloc_origin" },
    { 0xAB55B238, "reloc_struct" },
    { 0x36871F40, "relocate" },
    { 0x2895FA6B, "relocates" },
    { 0x323A0103, "relock" },
    { 0xC2F72A6C, "relpos" },
    { 0x957B0FEF, "relval" },
    { 0x1EA769DF, "rely" },
    { 0x99B08013, "relyaw" },
    { 0xFDCA0FE1, "relying" },
    { 0x53638BC3, "rem" },
    { 0xCE16B76F, "remaimns" },
    { 0xCA07055D, "remain" },
    { 0x6FDAD97E, "remainder" },
    { 0x9BACCB68, "remaing" },
    { 0xCA82B54B, "remaining" },
    { 0xF2D6F743, "remaining_ai_afterstop" },
    { 0x1A53779F, "remaining_armor_points" },
    { 0xA2A440DD, "remaining_assets" },
    { 0xF303338C, "remaining_attempts" },
    { 0xEAC3C22C, "remaining_documents" },
    { 0x2748C7F3, "remaining_flags_to_process" },
    { 0xAD138DA6, "remaining_guys" },
    { 0x241D33F8, "remaining_health" },
    { 0x1A797BC0, "remaining_hits" },
    { 0xDE96C1AF, "remaining_lock_threats_to_evaluate" },
    { 0xAFF2B9D0, "remaining_locked_on_flags" },
    { 0x0CAC2C4F, "remaining_print" },
    { 0x6124EE45, "remaining_seconds" },
    { 0x30E0B999, "remaining_time" },
    { 0x50A065F1, "remaining_tries" },
    { 0x5506E176, "remainingangledelta" },
    { 0xB51A6886, "remaininganimdelta" },
    { 0x5977F237, "remainingdist" },
    { 0xE038CE72, "remainingdistance" },
    { 0xEF9622D1, "remaininghealth" },
    { 0x19384783, "remaininglength" },
    { 0xB1FC0EAA, "remainingmovedelta" },
    { 0x5ADED480, "remainingsteps" },
    { 0xDABEFE00, "remainingtime" },
    { 0xB167F113, "remainingvec" },
    { 0xF8539F80, "remainint" },
    { 0x93DE5B9C, "remains" },
    { 0x45DA21C5, "reman_mg_goto" },
    { 0x2E43ED44, "reman_mg_thread" },
    { 0xE51AD620, "remap" },
    { 0xABB2D02B, "remap_weapon" },
    { 0xF0260130, "remap_weapon_locker_weapons" },
    { 0xAFF36613, "remapkeybindingparam" },
    { 0x8E808F69, "remarkable" },
    { 0x1E884CA9, "rematerialize" },
    { 0xCC4D2977, "remeber" },
    { 0x9FAFD9B0, "remember" },
    { 0x6F441286, "remember_old_verb" },
    { 0xC95462A1, "remember_weaponsondeath" },
    { 0x19884943, "remembered" },
    { 0x64A1601B, "remembers" },
    { 0x58AE0A86, "remind" },
    { 0xD8820712, "remind_destroy_helicopters" },
    { 0xFB9F07D2, "remind_player" },
    { 0xFAA43E36, "remind_player_to_use_smoke_grenades" },
    { 0x9D0B9AD6, "remind_string" },
    { 0x0870E009, "reminded" },
    { 0x4CA7650F, "reminder" },
    { 0x956D29F7, "reminder_num_missiles_fired" },
    { 0xC14CD1D6, "reminders" },
    { 0x1A6F0A39, "reminds" },
    { 0xF4ABC690, "remmeber" },
    { 0x428419D5, "remnants" },
    { 0x0D85C50E, "remoce" },
    { 0xC0C6B449, "remodelling" },
    { 0x2DEA7D07, "remore_mortar_enhanced_vision" },
    { 0xE6A1FD64, "remore_mortar_infrared_vision" },
    { 0xA463D127, "remote" },
    { 0xF52DC901, "remote_control_player_can_trigger" },
    { 0x1B4E19A4, "remote_controlled" },
    { 0xE5ED1F3C, "remote_damage_think" },
    { 0x48556ECA, "remote_done" },
    { 0x58EFA9F9, "remote_end" },
    { 0xCFC52D71, "remote_explode" },
    { 0x8350B605, "remote_hack" },
    { 0xBE0BF659, "remote_hud_arrow_left" },
    { 0xB9881804, "remote_hud_arrow_right" },
    { 0x0BC6A498, "remote_hud_bracket_left" },
    { 0xDFDE5427, "remote_hud_bracket_right" },
    { 0x3FCDD32C, "remote_hud_reticle" },
    { 0xF6487F73, "remote_killstreak_abort" },
    { 0xBF2080C1, "remote_killstreak_copilot" },
    { 0xF6637D56, "remote_killstreak_end" },
    { 0x72152C7F, "remote_killstreak_game_end" },
    { 0xE632401F, "remote_leave" },
    { 0xF64649C6, "remote_missile" },
    { 0x748E5F0D, "remote_missile_bomblet_fired" },
    { 0x5446DCAD, "remote_missile_bomblets_number" },
    { 0x1845AF66, "remote_missile_brake_timeout" },
    { 0xD26A801F, "remote_missile_fired" },
    { 0x5D3BD2B6, "remote_missile_frames_between_target_scan" },
    { 0x235F168C, "remote_missile_game_end_think" },
    { 0x286650CE, "remote_missile_icon_size" },
    { 0xB563A727, "remote_missile_life" },
    { 0xB659E65F, "remote_missile_map_icon_delay" },
    { 0xD7BEAA97, "remote_missile_max_other_targets_hud" },
    { 0x2DA17ACC, "remote_missile_name" },
    { 0x16B35FA3, "remote_missile_player_detonated" },
    { 0xCEB3FB98, "remote_missile_singeton" },
    { 0x54184357, "remote_missile_start" },
    { 0xB8DEBFCB, "remote_missile_targeting_radius" },
    { 0x55CB812E, "remote_missile_timeout" },
    { 0xA3F9C98D, "remote_missile_type" },
    { 0x98DF50C9, "remote_missile_vision" },
    { 0x20849CD2, "remote_missile_visionset_alias" },
    { 0x75200F24, "remote_missile_visionset_file" },
    { 0x67421F32, "remote_mortar_fx" },
    { 0xD8F34579, "remote_mortar_height" },
    { 0xADE580CE, "remote_mortar_killstreak" },
    { 0x8A210D85, "remote_mortar_spawn" },
    { 0xFC0361FC, "remote_mortar_unlock" },
    { 0xE811B03C, "remote_mortar_visibility" },
    { 0xECC60F5E, "remote_owner_exit" },
    { 0x9FC62E58, "remote_owner_teamkillkicked" },
    { 0xD9FE0F6D, "remote_radiusoffset" },
    { 0xFFE1FFC9, "remote_revive" },
    { 0x4F798A75, "remote_revive_watch" },
    { 0x9E66E292, "remote_start" },
    { 0xA00ABCCA, "remote_stop" },
    { 0x4D6DF9C0, "remote_unlinked" },
    { 0x0531B331, "remote_use_hold_time_seconds" },
    { 0xB3C57E48, "remote_weapon_end" },
    { 0x345372B0, "remote_weapon_name" },
    { 0x12E4380D, "remote_weapon_ping" },
    { 0x16216103, "remote_weapon_shutdown" },
    { 0x84D207ED, "remote_weapons" },
    { 0x143D9C9D, "remote_zoffset" },
    { 0x39D84CED, "remotecontrolled" },
    { 0x2551BA6A, "remotecontroltrigger" },
    { 0x977E5A60, "remotecontrolturret" },
    { 0x2E12555F, "remotecontrolturretoff" },
    { 0xFD5DF1DB, "remotedrone" },
    { 0xB72D5480, "remoteexithint" },
    { 0x37E94BAA, "remotely" },
    { 0x818840B1, "remotemissile" },
    { 0xEA078AFE, "remotemissile_bda_dialog" },
    { 0xC4434C5F, "remotemissile_bomblets_launched" },
    { 0x4713F034, "remotemissile_done" },
    { 0x9B8242E6, "remotemissile_fx" },
    { 0x81FEC0AB, "remotemissile_kill_z" },
    { 0x63308343, "remotemissile_lod_bias" },
    { 0x5421D857, "remotemissile_override_angles" },
    { 0xF477E609, "remotemissile_override_origin" },
    { 0x43F5D53C, "remotemissile_override_target" },
    { 0x46D2CE5F, "remotemissile_target" },
    { 0x1A5F18DC, "remotemissilebda" },
    { 0x2815989E, "remotemissiledamage" },
    { 0x1856F911, "remotemissileinprogress" },
    { 0x146D3197, "remotemissilepilotindex" },
    { 0x48ED5B18, "remotemissiles" },
    { 0xBFF9D54A, "remotemissilespawn" },
    { 0x7C2C63F5, "remotemissilespawnarray" },
    { 0x2844BF4B, "remotemissilespawnpoints" },
    { 0xD8D08E22, "remotemissle_killstreak_done" },
    { 0xDCEF37FC, "remotemortar" },
    { 0x4BCA0936, "remotemortarrig" },
    { 0x09C5B007, "remotemotarviewdown" },
    { 0xCAB431B8, "remotemotarviewleft" },
    { 0xD1068FC7, "remotemotarviewright" },
    { 0xE52C8E98, "remotemotarviewup" },
    { 0xBC319DBA, "remotename" },
    { 0xC27E1D54, "remoteobjidfriendly" },
    { 0xAAE41743, "remoteoverrideweapon" },
    { 0x4ED959B2, "remoteoverrideweapons" },
    { 0xEF9D7794, "remoteowner" },
    { 0xACA023FB, "remoteweapon" },
    { 0x17BC6039, "remoteweaponallowmanualdeactivation" },
    { 0x03D55ED6, "remoteweaponname" },
    { 0x86BA00BC, "remoteweaponqueue" },
    { 0x4005909A, "remoteweapons" },
    { 0x4B85B20A, "remoteweaponshutdowndelay" },
    { 0x620E8454, "removable" },
    { 0x0071942B, "removablehat" },
    { 0x060D580B, "removal" },
    { 0x77213189, "remove" },
    { 0x332653E5, "remove_3d_objective" },
    { 0x30B17472, "remove_actor_from_drivers_seat" },
    { 0xED0CC3DB, "remove_adjacent_zone" },
    { 0x3551243D, "remove_airstrike_from_all" },
    { 0xCFA9A714, "remove_all_actors_that_are_squelched" },
    { 0xA6AFFB69, "remove_all_actors_with_same_characterid" },
    { 0x60F7F7A2, "remove_all_animnamed_guys_from_array" },
    { 0xBE5F5B6E, "remove_all_door_hackables_that_target_door" },
    { 0x3D4EC316, "remove_all_ents" },
    { 0x2A93057F, "remove_all_weapons" },
    { 0xD46AACFF, "remove_alley_seperation_clip" },
    { 0x18722106, "remove_allies" },
    { 0x465A586F, "remove_ammo_marker_on_reload" },
    { 0xA2809B7E, "remove_backpack" },
    { 0xC24C8F69, "remove_banzai_attacker" },
    { 0x7DF20A58, "remove_base_obj_on_death" },
    { 0x779CBD34, "remove_best_bot" },
    { 0x55D6888A, "remove_blade" },
    { 0x16D4F473, "remove_blend_times_for_scene" },
    { 0x8469D3AA, "remove_blockage_scaffolding_collision" },
    { 0xC64E85FB, "remove_blockage_scaffolding_upper_collision" },
    { 0x736529EA, "remove_blocker" },
    { 0xC143C167, "remove_blur" },
    { 0x4A7BA52B, "remove_bot" },
    { 0x32BD0B0A, "remove_bots" },
    { 0x3E48F111, "remove_breadcrumb_ent" },
    { 0xC14226A0, "remove_buffel_riders" },
    { 0x75CBBF9C, "remove_building_target" },
    { 0x76D8F0B9, "remove_c4" },
    { 0x724B62DD, "remove_callback" },
    { 0x1EEDF5E0, "remove_callback_on_death" },
    { 0xE54A6573, "remove_can_sighttrace" },
    { 0xCC1E0F8B, "remove_cart_clip" },
    { 0x09B61D6B, "remove_chunk" },
    { 0x64AC1B87, "remove_chunk_rotate_grate" },
    { 0x4A6D4915, "remove_clarke_set_friendname" },
    { 0xF43624BE, "remove_color_from_array" },
    { 0x8D49BA45, "remove_context" },
    { 0xE13D3137, "remove_corner_ai_blocker" },
    { 0x8DCF1A78, "remove_corpse" },
    { 0x9E410DC1, "remove_count" },
    { 0x8BC785B2, "remove_crawled" },
    { 0xDAC119C1, "remove_crew_model" },
    { 0x0B87262E, "remove_dead" },
    { 0x7D537427, "remove_dead_ents" },
    { 0x244E495B, "remove_dead_from_array" },
    { 0xEA7BBBA6, "remove_dead_turret_trigger" },
    { 0x5020FEB1, "remove_deadshot_bottle" },
    { 0xCC853740, "remove_detonator" },
    { 0xFC38B5B9, "remove_dog_spawn_point" },
    { 0xDF73E33E, "remove_drivers_from_array" },
    { 0xAEDDB9C8, "remove_drone_corpses" },
    { 0x5ACD49AE, "remove_drone_struct" },
    { 0x58B18ED1, "remove_drone_structs" },
    { 0xE0EE1EFE, "remove_drone_triggers" },
    { 0x583F490C, "remove_e1_friendlies" },
    { 0x406C498B, "remove_ent" },
    { 0x07C44052, "remove_exploders" },
    { 0x52E432FB, "remove_flamethrower_perk_option" },
    { 0x96DD0046, "remove_flash_bang_enemies" },
    { 0x7FA62DEE, "remove_flashlight" },
    { 0xDF8C2845, "remove_found_intel" },
    { 0xA881FBA0, "remove_friendly_fodder" },
    { 0xD82EDAE9, "remove_from_all_objects" },
    { 0x35E2B3C1, "remove_from_array_on_death" },
    { 0x6C924DBC, "remove_from_base_attackers_on_death" },
    { 0x559FF1B2, "remove_from_beartrap_array" },
    { 0x4855EDFA, "remove_from_ent" },
    { 0x6CA76A14, "remove_from_player_classes_on_death" },
    { 0x84A68001, "remove_from_spectate_list" },
    { 0x43648339, "remove_from_sync_list" },
    { 0x2E4F4A30, "remove_from_target_group" },
    { 0x970BF1E7, "remove_from_users_array" },
    { 0x05B261AE, "remove_fx" },
    { 0x9F0C6046, "remove_fx_cheap" },
    { 0x0EC63E67, "remove_gasmask_on_game_over" },
    { 0x86A7986E, "remove_gasmask_on_player_bleedout" },
    { 0x12A99905, "remove_gear" },
    { 0x6C504CD7, "remove_ghettotag" },
    { 0xF6D13C8B, "remove_gift_trigger" },
    { 0xD5E942A4, "remove_global_spawn_function" },
    { 0xD2EE85D4, "remove_grenades_from_everyone" },
    { 0x03A0DFFA, "remove_gun" },
    { 0x80787723, "remove_guy_from_squad" },
    { 0x67B0378F, "remove_hackable_object" },
    { 0x15EEC828, "remove_hallway_ai_clip" },
    { 0x4FA04DAA, "remove_helicopter_influencers" },
    { 0xCD25E94D, "remove_heroes_from_array" },
    { 0x44FD7697, "remove_highlighted" },
    { 0x830D1CE7, "remove_hint" },
    { 0xF8A0189F, "remove_hud" },
    { 0x90197DEB, "remove_id" },
    { 0xB6CD7C80, "remove_ignore_attacker" },
    { 0xEA6DA57B, "remove_ignore_on_poi" },
    { 0x8FDF50C0, "remove_index" },
    { 0x548CEE99, "remove_influencer" },
    { 0x614B1F50, "remove_influencers" },
    { 0xD5D5C169, "remove_invalid_scene_objects" },
    { 0x58149850, "remove_keys" },
    { 0x1ADE91F6, "remove_launchers_on_easy_difficulty" },
    { 0xFCA004D1, "remove_leap_node" },
    { 0xB9EDFAEB, "remove_legs" },
    { 0x86CCA5CB, "remove_level_first_frame" },
    { 0x2DB8394C, "remove_light_armor" },
    { 0x8F249704, "remove_list" },
    { 0x44D4107B, "remove_lmg_anims" },
    { 0xB3F3D7D1, "remove_lui_vehicle_icon" },
    { 0x8A98E297, "remove_machete_prop" },
    { 0xFA22D8D4, "remove_magic_bullet_shield_from_guy_on_unload_or_death" },
    { 0x2B7DA230, "remove_magic_bullet_shield_when_player_close" },
    { 0xB98E881E, "remove_maproom_personnel" },
    { 0x42D737B9, "remove_mason_gun" },
    { 0x412D9440, "remove_maxis_tower" },
    { 0xE178375A, "remove_metal_clip" },
    { 0x1EF3AD2B, "remove_microwaveable_object" },
    { 0x61FD5CA2, "remove_misc_model" },
    { 0xAE17E96C, "remove_mod_from_methodofdeath" },
    { 0xFB7215A3, "remove_model" },
    { 0x66927580, "remove_non_cinematic_tvs_from_array" },
    { 0x3D35371B, "remove_non_hero_shields" },
    { 0xED477C50, "remove_non_riders_from_array" },
    { 0x6D1EA3E6, "remove_noteworthy_from_array" },
    { 0x2A8A1F09, "remove_object" },
    { 0x93CABA84, "remove_objective_perk" },
    { 0x8F0A969B, "remove_old_targeters" },
    { 0xC783CD74, "remove_old_turret" },
    { 0x339BDDF9, "remove_oldest" },
    { 0x7F6AA1C3, "remove_on_actor_damage" },
    { 0xA09757B3, "remove_on_actor_killed" },
    { 0x840ED4D4, "remove_on_ai_damage" },
    { 0xFAD550C4, "remove_on_ai_killed" },
    { 0x3F5E6667, "remove_on_ai_spawned" },
    { 0xBCD31C2C, "remove_on_connect" },
    { 0x7EBE505C, "remove_on_connecting" },
    { 0xB61643CC, "remove_on_death" },
    { 0x1F1CF008, "remove_on_disconnect" },
    { 0x91A3F14E, "remove_on_loadout" },
    { 0x9335813B, "remove_on_localplayer_spawned" },
    { 0x529ABDC3, "remove_on_player_damage" },
    { 0x73C773B3, "remove_on_player_killed" },
    { 0xA0AC4434, "remove_on_spawned" },
    { 0x129F29EA, "remove_on_vehicle_damage" },
    { 0x9FCEF20A, "remove_on_vehicle_killed" },
    { 0xDC00BDB1, "remove_on_vehicle_spawned" },
    { 0x365AA357, "remove_option" },
    { 0x10882D16, "remove_outside_ai" },
    { 0xF084310A, "remove_perk_vo_delay" },
    { 0x1C36385A, "remove_planted_weapons" },
    { 0xDD51999B, "remove_player_from_boat" },
    { 0xDF497CB0, "remove_player_from_claw" },
    { 0xC1903731, "remove_player_from_rail" },
    { 0xA4C27CF6, "remove_player_influencers" },
    { 0xBAC0D34C, "remove_player_linked_scene" },
    { 0x63AFF349, "remove_player_weapons" },
    { 0xFA6A0EF1, "remove_plinth" },
    { 0xBA65A3F1, "remove_poi_attractor" },
    { 0x64D71A03, "remove_poi_from_ignore_list" },
    { 0x42532B36, "remove_portal" },
    { 0x126AFDA0, "remove_portal_beam" },
    { 0x3B80A7BE, "remove_powered_item" },
    { 0x3F42D69A, "remove_reflection_objects" },
    { 0xECBC696F, "remove_rejack_ui" },
    { 0x58E7B825, "remove_remote_weapon" },
    { 0x92E8DCFB, "remove_replace_on_death" },
    { 0xDD8D3882, "remove_repulsor" },
    { 0xD22A5EC4, "remove_ricky_tower" },
    { 0x462DE2AB, "remove_ricochet_protection" },
    { 0x86F1D254, "remove_rider_before_unloading" },
    { 0xB6910714, "remove_riders_after_wait" },
    { 0xBFE5D67F, "remove_riders_wait_time" },
    { 0x961296A7, "remove_rotate_highlighted" },
    { 0x7D509F09, "remove_rpg_firing" },
    { 0x5ECF9DA1, "remove_satchel_on_death" },
    { 0x949C0705, "remove_save_highlighted" },
    { 0x78F56650, "remove_save_stat" },
    { 0xC5DB9FD4, "remove_scene" },
    { 0xA5195379, "remove_scene_func" },
    { 0xB5AF8277, "remove_script_mover" },
    { 0xAC6E55E1, "remove_selected_option" },
    { 0x6AD485D6, "remove_shooter_model" },
    { 0x120C93EC, "remove_shot" },
    { 0xD705D94F, "remove_shrinkable_object" },
    { 0x9F2411A3, "remove_sidequest_icon" },
    { 0x2D93E378, "remove_sight_blocker" },
    { 0x5F10D4A9, "remove_skel" },
    { 0x081B8F7C, "remove_spawn_function" },
    { 0x1009AFED, "remove_spawn_function_ai_group" },
    { 0x63139CC1, "remove_spawner_values" },
    { 0xAE51290B, "remove_squad_influencers" },
    { 0x139AAF50, "remove_stub" },
    { 0xEEFD0543, "remove_tank_blocker" },
    { 0x85B21E56, "remove_target_on_death" },
    { 0x8F351962, "remove_targets_at_drone_intro" },
    { 0x809CA187, "remove_tarp_blockers" },
    { 0x0CBDBEE5, "remove_technical_enemies_from_array" },
    { 0x64792CBC, "remove_temp_chest" },
    { 0xEF5B7F92, "remove_the_dead" },
    { 0x47F3D425, "remove_trigger_from_debounce_lists" },
    { 0x628362E1, "remove_trigger_from_ent" },
    { 0x81190CB0, "remove_triggers_from_ent" },
    { 0x884A80E2, "remove_trophy" },
    { 0xF42F002D, "remove_turret_dangerous_nodes" },
    { 0xA9F4816C, "remove_turret_hint_hud" },
    { 0x8B64441B, "remove_tvmissile_influencers" },
    { 0x5C13FAE0, "remove_undefined" },
    { 0x455F209D, "remove_undefined_from_array" },
    { 0x81C22B4E, "remove_unit_from_blocking_point" },
    { 0x1DFF77D0, "remove_unused_spawn_entities" },
    { 0x80D5AAEC, "remove_used_killstreak" },
    { 0x23E65303, "remove_vehicle_corpse" },
    { 0x9294A2D2, "remove_vehicle_from_world" },
    { 0xFEEC8BA4, "remove_vent_collision" },
    { 0xF2F0A19C, "remove_vision" },
    { 0x34E4367D, "remove_visor_text" },
    { 0x4D49888B, "remove_visor_timer" },
    { 0x66882EE1, "remove_waypoint" },
    { 0x7AF06B94, "remove_waypoint_think" },
    { 0xFC828C18, "remove_weapon" },
    { 0xAC9F86F3, "remove_weapons" },
    { 0xEEA7CE95, "remove_weaver_set_friendname" },
    { 0xD6721097, "remove_when_done" },
    { 0xBCF72029, "remove_white_screen_flash" },
    { 0x3D12618C, "remove_without_classname" },
    { 0x31841B26, "remove_without_model" },
    { 0x78F3E969, "remove_woods_facemask_util" },
    { 0x6CA4335F, "remove_zombie_hats_for_grief" },
    { 0xB34C6E26, "remove_zone" },
    { 0x1EA8F098, "removeablehat" },
    { 0x98918D12, "removeacousticsensor" },
    { 0x05227C6F, "removeactivecounteruav" },
    { 0x2A11CE46, "removeactivesatellite" },
    { 0xE8B49185, "removeactivespawner" },
    { 0x3DA52755, "removeactiveuav" },
    { 0x42925285, "removeafterdone" },
    { 0x9FC8F065, "removeaieventlistener" },
    { 0xDA3135DE, "removeaifromcolornumberarray" },
    { 0xC6FA4043, "removeaifromsqaud" },
    { 0xF362B37B, "removeaifromsquad" },
    { 0x8153AB21, "removeaioverridedamagecallback" },
    { 0x0105C272, "removeall" },
    { 0xA2523773, "removeallfriendlyscramblers" },
    { 0xFED769AC, "removeandassignnewremotecontroltrigger" },
    { 0xFB8EB3B7, "removeargus" },
    { 0xA1BB36CA, "removebaseasthreat" },
    { 0x5837828D, "removeblackboardevents" },
    { 0xD34BD23D, "removeblade" },
    { 0x49ED4863, "removeblockedanims" },
    { 0x48500864, "removecallback" },
    { 0x5EDD018E, "removecameraspike" },
    { 0x8635C711, "removechild" },
    { 0xC0E7FDBA, "removechopper" },
    { 0x424C7D60, "removecliententonjump" },
    { 0xD1901738, "removeclone" },
    { 0x15EAA4F6, "removecrate" },
    { 0x695CFCEF, "removed" },
    { 0x3154D26F, "removed_early" },
    { 0x55A2A9EB, "removed_guy" },
    { 0xB0BAF2D9, "removed_id" },
    { 0x114E02E6, "removed_index" },
    { 0xD875A9EE, "removed_on_death" },
    { 0xEE7DA8D3, "removedeadfromsquad" },
    { 0xF81B6145, "removedisallowedstanceanims" },
    { 0x3CF22630, "removedisconnectedplayerfromplacement" },
    { 0xF9CA95DD, "removedkillstreaktype" },
    { 0x516DDFD5, "removedkillstreakweapon" },
    { 0xB638B1BD, "removedroneweapon" },
    { 0x9F16D982, "removeduplicateattachments" },
    { 0x435A8286, "removee" },
    { 0x8506FA3B, "removeents" },
    { 0x4424293C, "removeexpiredmessages" },
    { 0x79DAC91B, "removeexplodable" },
    { 0x282CAB60, "removefirstarrayindex" },
    { 0x26F6DEF7, "removeforcenocull" },
    { 0x87168E0D, "removefriendlyscrambler" },
    { 0xD61BCF03, "removefromlittlebirdlistondeath" },
    { 0x7A1A22F0, "removefromplacedturretlist" },
    { 0xF9D0BD71, "removefromsquad" },
    { 0xF6A905AA, "removefromsystem" },
    { 0xDB640D27, "removegametypeeventrule" },
    { 0x0905A46E, "removehealthregen" },
    { 0xA27F6840, "removeinfluencer" },
    { 0x2070E56B, "removeinfluencers" },
    { 0xB1233B4B, "removeinventoryweapon" },
    { 0x7F2B1417, "removekillstreakwhendone" },
    { 0x12080D97, "removelightarmorondeath" },
    { 0x500C4C09, "removelightarmoronmatchend" },
    { 0x1B43FC44, "removelittlebird" },
    { 0x33AE09AD, "removemefromunit" },
    { 0x454A43CF, "removenotetrack_dialogue" },
    { 0xBDB47B7F, "removeobjectsondemovertime" },
    { 0xACD2F6E5, "removeofficerfromsquad" },
    { 0x270D5923, "removeoldestclone" },
    { 0x5D500FCA, "removeoldestkillstreak" },
    { 0x169D7609, "removeotherdeathicons" },
    { 0xAC387373, "removeplayerondisconnect" },
    { 0x252677E9, "remover" },
    { 0xF6937C36, "removerankhud" },
    { 0xCE9CFF61, "removeremotecontrolledweapon" },
    { 0x398800D4, "removeremotetriggerondisconnect" },
    { 0xB8D21A8F, "removeremoteweapon" },
    { 0xFFF72C90, "removeriotshield" },
    { 0xFF23FD80, "removes" },
    { 0x27C054FD, "removesafetyhealth" },
    { 0x8ACDEF1B, "removeselffrom_squadlastseenenemypos" },
    { 0xA63CCF0C, "removesensorgrenadearea" },
    { 0x65ECC30A, "removespawnerfromcolornumberarray" },
    { 0x89E70222, "removespawnmessageshortly" },
    { 0x3DC62390, "removespeaker" },
    { 0xE4272965, "removesquad" },
    { 0x1AC8F3DF, "removesquadmarker" },
    { 0xE6FCFFF3, "removetestclients" },
    { 0x9B41B891, "removetype" },
    { 0x1E2594B4, "removeusedkillstreak" },
    { 0x07EA47B1, "removevehiclefromcompass" },
    { 0x8E1E3819, "removeweapon" },
    { 0xA69D07FA, "removeweaponfromplayer" },
    { 0xC5BD84A8, "removeweaponobject" },
    { 0x8101D3D0, "removeweapons" },
    { 0xB0A654BC, "removing" },
    { 0xEEE5840B, "removingfireshader" },
    { 0xFCFDCE30, "renable" },
    { 0x4C836694, "renabled" },
    { 0x6A37365F, "rename" },
    { 0xA50022B3, "rename_friendly" },
    { 0x3CCE9549, "renamed" },
    { 0x5B029FE6, "renames" },
    { 0x3BE49C99, "render" },
    { 0xA8804264, "render_complete_" },
    { 0xBC4CA4FB, "render_debug_sphere" },
    { 0x81397C7D, "render_name" },
    { 0x0078719A, "render_ny_streets_main" },
    { 0x4674435E, "render_options" },
    { 0x534BD96D, "render_shot1" },
    { 0x1E47EFC0, "render_shot_1_main" },
    { 0x61B07EE1, "render_shot_2_main" },
    { 0x27D8985F, "render_struct" },
    { 0x7E461C14, "render_type" },
    { 0x9B7F59E2, "render_watermark" },
    { 0x647ADEC6, "rendered" },
    { 0xAC312A99, "renderedthisframe" },
    { 0xDFE74629, "renderhealthoverlay" },
    { 0x124A433F, "renderhealthoverlayhealth" },
    { 0x1EEC132F, "rendering" },
    { 0x452E75C9, "rendernode" },
    { 0x90520950, "renders" },
    { 0x13CB64C1, "rendertype" },
    { 0xEA3C183C, "rendevous" },
    { 0x146BD554, "rendezvous" },
    { 0xAA372821, "rendezvous_ally" },
    { 0xFFB87713, "rendezvous_ally1_start" },
    { 0x1D002C10, "rendezvous_ally2_start" },
    { 0xB1A92B4D, "rendezvous_ally3_start" },
    { 0x4DF03352, "rendezvous_ally4_start" },
    { 0xA315F660, "rendezvous_ally_start" },
    { 0x6BEBCE53, "rendezvous_heroes" },
    { 0x816D4C19, "rendezvous_mason_107a" },
    { 0x503B844B, "rendezvous_mason_112a" },
    { 0x58AF1F49, "rendezvous_mason_114a" },
    { 0x55DDEB9F, "rendezvous_mason_116a" },
    { 0xFAE69317, "rendezvous_rpg_guys" },
    { 0x5C063BC7, "rendezvous_save_restore" },
    { 0x4BDDE6D8, "rendezvous_stop_machines" },
    { 0xA51080FF, "rendezvous_with_pilots" },
    { 0x7ADCA34A, "rendezvous_with_weaver" },
    { 0xCC98BD07, "reneanble" },
    { 0x71E24569, "renumber" },
    { 0x515BB225, "reoccupy" },
    { 0xF2443987, "reomved" },
    { 0xCF23ACD2, "reopen" },
    { 0xF2E047E5, "reopened" },
    { 0x44F03DDE, "reopening" },
    { 0x6D505CBA, "reorder" },
    { 0x750804C7, "reorder_ent_array_by_uniqueid" },
    { 0xA9C3054D, "reordered" },
    { 0x8A45BF35, "reorders" },
    { 0xDE70E997, "reorganized" },
    { 0x8DA77C19, "reorient" },
    { 0xF57ECE46, "rep" },
    { 0xA2D0154D, "repack" },
    { 0x6E837BD2, "repair" },
    { 0x44682143, "repair_board" },
    { 0x9CE998A0, "repair_far_boards" },
    { 0xE81B107E, "repairable" },
    { 0x97D22EE5, "repaired" },
    { 0xEDBEE2DE, "repairing" },
    { 0xC57064DD, "repairs" },
    { 0xD411D4B8, "repari" },
    { 0xF7431B77, "repath" },
    { 0x86444EF9, "repath_range" },
    { 0x332793D3, "repathdist" },
    { 0x118D5BA9, "repathing" },
    { 0x8D9C6E98, "repathnotifierstarted" },
    { 0xD250C6C0, "repay" },
    { 0x3C5753D8, "repeat" },
    { 0x4A4B4F4B, "repeat_dialog" },
    { 0x5370714E, "repeat_dialog_along_vec" },
    { 0xB5B75D18, "repeat_interval" },
    { 0x7E2576E2, "repeat_multiplier" },
    { 0xCE65A0F5, "repeat_scale_accuracy" },
    { 0x04B6AC10, "repeat_scale_health" },
    { 0x7E726CC7, "repeat_scale_speed" },
    { 0x643D368A, "repeat_text" },
    { 0x00E09A9F, "repeat_times" },
    { 0x1AC833EB, "repeated" },
    { 0xE0516BB6, "repeatedly" },
    { 0x984FC104, "repeatgap" },
    { 0xBF45B5C0, "repeating" },
    { 0xD455C515, "repeatkey" },
    { 0x87DAA7FE, "repeatrate" },
    { 0xE758C5B3, "repeats" },
    { 0x9D02DB56, "repeatthresholdkey" },
    { 0x9CD20C11, "repel" },
    { 0x89FC1292, "repel_anim_node" },
    { 0x660315BB, "repel_breach_guys_init" },
    { 0x9E9CD8AC, "repel_enemies" },
    { 0x09027FA8, "repel_node" },
    { 0x0B324CBF, "repel_nva_time" },
    { 0xFE6CB1FA, "repel_room_main_guys" },
    { 0x25C34938, "repel_rope" },
    { 0x846A95A2, "repel_rumbles" },
    { 0x93F42192, "repel_shatter_guy01" },
    { 0x6DF1A729, "repel_shatter_guy02" },
    { 0x47EF2CC0, "repel_shatter_guy03" },
    { 0xCCDA9AF7, "repeling" },
    { 0x86F9A204, "repelled" },
    { 0x9416D881, "repelling" },
    { 0xB0F0E92B, "repelsequnce" },
    { 0x045436D4, "repercussions" },
    { 0xF4C51CC0, "repetition" },
    { 0x7A7BFF02, "repetitious" },
    { 0xD2F7ED7C, "repetitive" },
    { 0xAF4A0AB2, "repiar" },
    { 0x7E2400EB, "replace" },
    { 0xB2943F05, "replace_chunk" },
    { 0xD57C8AF3, "replace_chunk_instant" },
    { 0xBC2283F9, "replace_coke_worker_with_enemy" },
    { 0x3B1625D9, "replace_existing" },
    { 0xE52926C3, "replace_gun_with_pistol" },
    { 0x60D70BE4, "replace_head" },
    { 0xF0DDF8AA, "replace_on_death" },
    { 0x9CE3EEDF, "replace_weapon_powerup" },
    { 0x55680E75, "replaced" },
    { 0xEB6B5D23, "replacement" },
    { 0xBE3EAB65, "replacement_model" },
    { 0x432DBF12, "replacements" },
    { 0x438845CA, "replaces" },
    { 0x700F384E, "replacing" },
    { 0x375F68B7, "replan" },
    { 0x36ABF090, "replannedcoverarrival" },
    { 0x45E36145, "replanning" },
    { 0xCD266948, "replay" },
    { 0x6BA28CBF, "replay_gun" },
    { 0xB2553817, "replay_gun_name" },
    { 0xDB9764C1, "replay_gun_settings" },
    { 0x1F593066, "replay_lock" },
    { 0xE7E7E2A1, "replay_outline_material" },
    { 0x06DBA9EC, "replay_single_mission" },
    { 0x798BF344, "replay_sticky_aim" },
    { 0x8D729605, "replay_sticky_aim_think" },
    { 0x266E7B67, "replay_sticky_aim_thread" },
    { 0x2AFD8F71, "replay_target_lost" },
    { 0x3FFA7DFB, "replaygun_target_locked" },
    { 0xDCD1B2B0, "replaygun_target_locking" },
    { 0x579DAEBF, "replaygun_target_lost" },
    { 0x5EB404AB, "replaygun_target_regain" },
    { 0x860270DF, "replaygun_target_suspend" },
    { 0x6F70A190, "replaying" },
    { 0x8E456C63, "replays" },
    { 0x08F0B3A0, "replenieshes" },
    { 0x0CC21909, "replenish" },
    { 0x9C76084A, "replenish_after_rounds" },
    { 0x39F5BF19, "replenish_arena_wave3bp1" },
    { 0x383C658F, "replenish_bp1" },
    { 0xD1F35D2F, "replenish_bp1wave3" },
    { 0xC634F654, "replenish_bp2" },
    { 0xEC3770BD, "replenish_bp3" },
    { 0xD6400B9A, "replenish_gl_ammo" },
    { 0xC7535B62, "replenish_loc_update" },
    { 0xD1DFA482, "replenish_loc_updated" },
    { 0xE4353E91, "replenish_wave3bp1" },
    { 0x6441E5B9, "replenishes" },
    { 0x5313B6BF, "replenishloadout" },
    { 0x132D572B, "reply" },
    { 0x02222564, "repopulate" },
    { 0xECC1F4D5, "repopulate_flak" },
    { 0x68A4DA28, "repopulated" },
    { 0xE19D80ED, "repopulating" },
    { 0x8357BB23, "report" },
    { 0x9A8818E3, "report_bgb_consumption" },
    { 0x70F4BFCB, "report_consumable" },
    { 0x73955945, "report_damage" },
    { 0xE3F8159F, "report_damage_if_player" },
    { 0xCD583EC4, "report_global_death" },
    { 0x245EDCD2, "report_global_vehicle_damage" },
    { 0x4DBF05B9, "report_light_counts" },
    { 0xB0768A15, "report_notify" },
    { 0x0428AF79, "report_num_effects" },
    { 0x9BE15DA7, "report_to_price" },
    { 0x25F092FE, "report_trigger" },
    { 0x9CE03F57, "reportclientdisconnected" },
    { 0x18405618, "reported" },
    { 0x9C278DFE, "reporter" },
    { 0x8A5B212E, "reportexploderids" },
    { 0xE680770D, "reportfilm" },
    { 0x706813FD, "reporting" },
    { 0xFBD79C1D, "reportmtu" },
    { 0x506F7EB1, "reportnumeffects" },
    { 0x6C45B912, "reports" },
    { 0x19DEEECB, "reporttotheater" },
    { 0xE724D863, "reposition" },
    { 0x8F2F08F2, "reposition_node" },
    { 0x55BD033D, "repositioning" },
    { 0xC6ED9052, "repositions" },
    { 0x846590E9, "repository" },
    { 0xDBD43DDB, "represent" },
    { 0xED30DE06, "representation" },
    { 0x6461FCB9, "representations" },
    { 0xC8BA7650, "represented" },
    { 0xF0F66A45, "representing" },
    { 0xF0E61AFA, "represents" },
    { 0xB1401C53, "reprint" },
    { 0xF46B01F7, "repro" },
    { 0x4D6B0AA2, "reprogram" },
    { 0x343AC628, "reprogrammed" },
    { 0xB5D5FCF9, "reps" },
    { 0xE8A8A71D, "repulser" },
    { 0x46FB0FDF, "repulsor" },
    { 0x4D94F2A0, "repulsor_fx" },
    { 0xB6976ACC, "repurpose" },
    { 0xE5411CE0, "repurposed" },
    { 0x8A967058, "reputation" },
    { 0x1B8148AF, "req" },
    { 0x4C6F3A1F, "req_dot" },
    { 0x9717AEF5, "reqcheck" },
    { 0x51E8F1EF, "reqdata" },
    { 0x33B859B0, "reqdot" },
    { 0x053901C1, "reqindex" },
    { 0xE73B447C, "reqor" },
    { 0x97FA36BF, "reqratios" },
    { 0xC21449AF, "reqroot" },
    { 0x807257F6, "reqs" },
    { 0x4A82B3E2, "reqslots" },
    { 0xBFA6ADA7, "reqtype" },
    { 0x6F1B4510, "request" },
    { 0x7373909E, "request_mode" },
    { 0xBEB10AE0, "request_target" },
    { 0xF083D114, "request_time" },
    { 0xFC89FC96, "request_to_move_ack" },
    { 0xC9528124, "requestarrivalnotify" },
    { 0x1944ECCD, "requestdialogkey" },
    { 0x3A37A6A3, "requested" },
    { 0x4C707002, "requested_note" },
    { 0x35168208, "requesting" },
    { 0xCA1CCDFB, "requests" },
    { 0x6E632EDF, "requeststate" },
    { 0x305D178E, "require" },
    { 0xEEB800E2, "require_flags" },
    { 0x48443494, "require_look_at" },
    { 0xCFAB185B, "require_look_from" },
    { 0x492AEF9E, "require_look_toward" },
    { 0x98DF604D, "require_perk" },
    { 0x2EED07B9, "require_player_dist" },
    { 0x1A4562B0, "require_players_by_point" },
    { 0x07A816CE, "required" },
    { 0x56704FF3, "required_alpha" },
    { 0x30E42203, "required_bot_counts" },
    { 0xE83A8FA8, "required_distance" },
    { 0x1604E9BA, "required_fov" },
    { 0x3B452EA8, "required_mode" },
    { 0x6A6A98D2, "required_seat" },
    { 0x3B047AF5, "required_systems" },
    { 0xD5144D8A, "required_time" },
    { 0xFFF9AC34, "required_vehicle_death" },
    { 0x2B359F25, "requireddeathcount" },
    { 0xC7A12646, "requireddistsq" },
    { 0xA5847E73, "requireddot" },
    { 0x0E50B227, "requiredflagproximity" },
    { 0x41A6ABEC, "requiredintime" },
    { 0x3F94C36D, "requiredmapaspectratio" },
    { 0x891BCCA0, "requiredplayers" },
    { 0x68EBEE47, "requiredreaches" },
    { 0x3A73378C, "requiredstructs" },
    { 0xCD52B2D7, "requiredyaw" },
    { 0xAC7576C7, "requirelockontofire" },
    { 0x7FA88AFE, "requirement" },
    { 0x6E28ACE1, "requirements" },
    { 0x39285D88, "requirementss" },
    { 0xD9A506FC, "requiremnts" },
    { 0xE9740C31, "requires" },
    { 0x58189190, "requires_pickup" },
    { 0x118B0C63, "requires_player" },
    { 0x38D198B5, "requireslos" },
    { 0x2758CB2E, "requiretrigger" },
    { 0x91E574A7, "requiring" },
    { 0x8BF0D4AB, "requisites" },
    { 0xED2E42D7, "requisition" },
    { 0x8AC9B153, "requried_time_scale" },
    { 0x623F75B2, "requsted" },
    { 0x72D5E6BD, "reregister" },
    { 0x2A1282B2, "reregister_unitrigger" },
    { 0x8B644BBB, "reregister_unitrigger_as_dynamic" },
    { 0x6014142B, "reregistering" },
    { 0xDDFC422B, "reroll" },
    { 0x1D9D6F7D, "reroll_icon" },
    { 0x2670F560, "rerolled" },
    { 0x6634320A, "rerolls" },
    { 0xE5A5110D, "reroute" },
    { 0x006BD4E6, "reroute_origin" },
    { 0xCF7C53DD, "res" },
    { 0x0E05A47F, "res_defends" },
    { 0xE9C2AC15, "res_endgame" },
    { 0x25BDF59E, "res_enemy_flag_influencer_radius" },
    { 0x307AF85A, "res_enemy_flag_influencer_score" },
    { 0xDD156346, "res_enemy_flag_influencer_score_curve" },
    { 0x04DEEF25, "res_flag_primary" },
    { 0xA4DC59A2, "res_gamemodespawndvars" },
    { 0x3DCC50B1, "res_offends" },
    { 0xDEEA85CF, "res_owned_flag_influencer_radius" },
    { 0xB1364CA1, "res_owned_flag_influencer_score" },
    { 0xC50E5085, "res_owned_flag_influencer_score_curve" },
    { 0xF66B67FE, "res_unowned_flag_influencer_radius" },
    { 0x6BE6B43A, "res_unowned_flag_influencer_score" },
    { 0x98EB81E6, "res_unowned_flag_influencer_score_curve" },
    { 0xFED695FC, "resample" },
    { 0x27C8E736, "rescue" },
    { 0xB28F0105, "rescue1_shark" },
    { 0x9B530F96, "rescue_1" },
    { 0x98377459, "rescue_1_done" },
    { 0x7550952D, "rescue_2" },
    { 0xE23EC534, "rescue_2_cleanup" },
    { 0x5D9F7FEC, "rescue_2_dialog_1" },
    { 0x31FE4CF0, "rescue_2_done" },
    { 0x4F4E1AC4, "rescue_3" },
    { 0x7E884CEF, "rescue_3_done" },
    { 0x4DD8E011, "rescue_anim_bowman" },
    { 0xCFEE4035, "rescue_anim_brooks" },
    { 0xD62F9390, "rescue_anim_doors" },
    { 0x6F67FED9, "rescue_anim_woods" },
    { 0x2F53BD8C, "rescue_breach_setup" },
    { 0x201B9A5E, "rescue_chopper" },
    { 0x1E25984F, "rescue_dialogue" },
    { 0xA4310CB9, "rescue_done" },
    { 0x7AD19F89, "rescue_doppel_spawn" },
    { 0xF691BDD8, "rescue_drones" },
    { 0x785F0D6A, "rescue_failsafe" },
    { 0xCD6BACD5, "rescue_guy_pos" },
    { 0xC1C7E17A, "rescue_heli_org" },
    { 0x0203AAFF, "rescue_music_start" },
    { 0xD624E4FA, "rescue_patroler" },
    { 0x5FDD5C18, "rescue_pows" },
    { 0xC1D125AF, "rescue_ride" },
    { 0x3116992F, "rescue_scenario" },
    { 0x1D2A888C, "rescue_scene_init" },
    { 0xFC1E7BB0, "rescue_scene_init_1" },
    { 0x6E25EAEB, "rescue_scene_init_2" },
    { 0x48237082, "rescue_scene_init_3" },
    { 0x83A7A7EB, "rescue_scene_offset" },
    { 0xCFBCC85A, "rescue_scene_patrol_01" },
    { 0x41AC73CA, "rescue_sequence" },
    { 0x85CA3827, "rescue_start" },
    { 0x6533B4ED, "rescue_start_spawners" },
    { 0x76D970E7, "rescue_tag" },
    { 0x9203E13A, "rescue_teleport_friendlies" },
    { 0x7F631494, "rescue_timer" },
    { 0x53726148, "rescue_weaver_counter" },
    { 0x513BBFBA, "rescue_weaver_counter2" },
    { 0x80552EFD, "rescue_weaver_counter_flash_when_low" },
    { 0xDE347D15, "rescue_weaver_counter_remove_when_done" },
    { 0x10C1D6C2, "rescueboat_drones_spawn" },
    { 0x2F9D30C6, "rescued" },
    { 0xA57FF257, "rescued_start" },
    { 0x5C6121CA, "rescuenode" },
    { 0xEB66ABC0, "rescuer" },
    { 0x648027EB, "rescuers" },
    { 0x11692629, "rescues" },
    { 0xE5F3292F, "rescuing" },
    { 0x7AA9DE52, "research" },
    { 0x655A804B, "reserve" },
    { 0x70BA6564, "reserve_turret" },
    { 0xB46288B1, "reserveammo" },
    { 0x2F93F855, "reserved" },
    { 0x1DB42FAA, "reserves" },
    { 0xB226A69B, "resest" },
    { 0x011424FA, "reset" },
    { 0x6DB9DBF6, "reset_accuracy" },
    { 0xCE3F3A19, "reset_actor_bookmark_kill_times" },
    { 0x19D7AC29, "reset_after_bleeding_out" },
    { 0x4975CFB6, "reset_ai_after_boat_drag" },
    { 0x3F98406F, "reset_ai_limit" },
    { 0x1D9EAFBB, "reset_alarms" },
    { 0xF41A3CD2, "reset_all" },
    { 0xC9A1DA27, "reset_all_afterlife_unitriggers" },
    { 0x913EA0F5, "reset_all_targets" },
    { 0xB17848E8, "reset_alouette_context_ext" },
    { 0x019EBAC5, "reset_ambient_packages" },
    { 0x8C3D7550, "reset_ammo_low" },
    { 0xCC50EECE, "reset_anim" },
    { 0xDEB6B453, "reset_animname" },
    { 0x7BDFF533, "reset_asd" },
    { 0x2476B77C, "reset_attack_spot" },
    { 0xC79EEA81, "reset_autosave_condition" },
    { 0x2DBE7F97, "reset_axis_of_selected_ents" },
    { 0x53AE5F5C, "reset_bar_left" },
    { 0x69D4A5B3, "reset_bar_right" },
    { 0xBAC1B8BE, "reset_basejump_fov" },
    { 0x3EBD0DCC, "reset_being_microwaved" },
    { 0x53627244, "reset_body_on_death" },
    { 0xCDBF511C, "reset_capture_walk_anims" },
    { 0xE3796B2F, "reset_client_dvars" },
    { 0xB5059BB2, "reset_clientdvars" },
    { 0x9AE00E36, "reset_closest_player" },
    { 0x7A85AE9B, "reset_commstat_color" },
    { 0xDB584F56, "reset_count" },
    { 0x9932A7E9, "reset_cqb_anim_array" },
    { 0x27375DD4, "reset_cuba_dof" },
    { 0xF73BAB8F, "reset_default_prisoner_anim_array" },
    { 0x0BF3C34E, "reset_default_rusher_anim_array" },
    { 0x0C6008B7, "reset_dialog_fields" },
    { 0x3D8C5730, "reset_disable_damage_overlay_on_notify" },
    { 0x3E4B97D9, "reset_dist" },
    { 0xE23876E8, "reset_dof" },
    { 0x3B3D3620, "reset_doublexp_timer" },
    { 0x2D454D8A, "reset_downed" },
    { 0x587B58DC, "reset_drone_throttle" },
    { 0x2C854A65, "reset_dvars" },
    { 0xCCF3D988, "reset_dynamite" },
    { 0x20C70C2C, "reset_elite_anim_array" },
    { 0xA1DECF8D, "reset_enemy_reticule" },
    { 0x5DE26E70, "reset_escape_pod" },
    { 0xFFA700FF, "reset_fog" },
    { 0x6C366A8D, "reset_followers_on_death" },
    { 0x39CC2D26, "reset_fov" },
    { 0xC36E12F4, "reset_friendlies" },
    { 0xA48EE398, "reset_friendly_reticule" },
    { 0x64EB8628, "reset_fx_hud_colors" },
    { 0x18898D40, "reset_fxanim" },
    { 0xE371E843, "reset_games_default_friendly_fire_state" },
    { 0xF53FCF84, "reset_generator_lerp_val" },
    { 0x58BE68F4, "reset_ghost_round_states" },
    { 0x0BCABD5A, "reset_goalvolume" },
    { 0x1D2E5A7B, "reset_gr_head_unitriggers" },
    { 0x05D850C2, "reset_grief" },
    { 0xD83691DE, "reset_group" },
    { 0x4DDDA1A5, "reset_hazmat_enemies" },
    { 0x1E3F557F, "reset_health" },
    { 0x6ADA5DE3, "reset_heat_anim_array" },
    { 0xBB548CB9, "reset_hero_run_anim_trigs" },
    { 0x33CF45E5, "reset_hit_trigger" },
    { 0x8CADC883, "reset_impact_animate" },
    { 0x64D37448, "reset_kill_counter" },
    { 0xAF32E0EF, "reset_killstreak_delay_killcam" },
    { 0x1C1EA59F, "reset_loadout" },
    { 0x271FF115, "reset_maxis_audiolog_unitrigger" },
    { 0xD00F67F2, "reset_maxsightdistsqrd" },
    { 0x721182D0, "reset_meat" },
    { 0xDB364E1D, "reset_meat_when_player_disconnected" },
    { 0x3485E7B3, "reset_meat_when_player_downed" },
    { 0xC8973188, "reset_meat_world_objects" },
    { 0x1011C55B, "reset_mechz_thinking" },
    { 0x67EB8100, "reset_meleesnd" },
    { 0xF2FBC28E, "reset_move_speed" },
    { 0x0555A073, "reset_movemode" },
    { 0x172F0B9F, "reset_my_group" },
    { 0xE6E30F20, "reset_near_plane" },
    { 0xF85A87D9, "reset_node" },
    { 0x17FE904A, "reset_notify" },
    { 0xCB4CF160, "reset_obituary_count" },
    { 0x00ED2B13, "reset_outcome" },
    { 0xE456FBE3, "reset_patrol" },
    { 0x05A4D6ED, "reset_plane_hint_string" },
    { 0xAA583F66, "reset_player" },
    { 0xE724831F, "reset_player_fv2vs_infos_on_respawn" },
    { 0xF8C4EE83, "reset_player_health" },
    { 0xD198A43F, "reset_player_horse_max_speed" },
    { 0x335113F8, "reset_player_melee_values" },
    { 0xCDC7D6D5, "reset_player_threat" },
    { 0x03F549C0, "reset_position" },
    { 0x290E4922, "reset_prisoner_anims" },
    { 0xFD1FF054, "reset_prisoner_run_cycle" },
    { 0x7906DBFF, "reset_prisoner_script_settings" },
    { 0x17297479, "reset_radius_at_goal" },
    { 0x57960C8B, "reset_rampage_bookmark_kill_times" },
    { 0xD3283AEC, "reset_room" },
    { 0x9746C63B, "reset_roulette_state_to_default" },
    { 0x675D667E, "reset_rso_focus" },
    { 0x90AE9DC4, "reset_run_anim" },
    { 0xE589E8DD, "reset_rusher_anims" },
    { 0x8C84ECD8, "reset_satchel_explode_this_frame" },
    { 0x0FC215DB, "reset_score_chain" },
    { 0xA1CC2BAD, "reset_security_system" },
    { 0xD938C7BF, "reset_self_elite_anim_array" },
    { 0x72341F5C, "reset_shakes" },
    { 0xFF72A80E, "reset_sidequest" },
    { 0xCED77189, "reset_snapshot" },
    { 0x608AE8CD, "reset_sound_blocker" },
    { 0x5262AA0D, "reset_specialty_slots" },
    { 0xAFB27710, "reset_spotlight_controls" },
    { 0x845D47A0, "reset_squad_ignore_state" },
    { 0xE2BE317F, "reset_sun_direction" },
    { 0x1AC5373B, "reset_sundial" },
    { 0xF93D0F52, "reset_tags" },
    { 0x8215CC4D, "reset_targets" },
    { 0xC4941C6C, "reset_textchange" },
    { 0xA7C746E6, "reset_threatbias" },
    { 0x31E40C8F, "reset_threatbiasgroup" },
    { 0x3AE7C694, "reset_tiles" },
    { 0xE687043E, "reset_time" },
    { 0x799C46B8, "reset_timer" },
    { 0x9A43C96C, "reset_turret_ai" },
    { 0xF8917D26, "reset_turret_drop_pitch" },
    { 0x6FBCDA35, "reset_turret_target" },
    { 0xC9C82F4D, "reset_tv_model" },
    { 0x1798D7FC, "reset_vending_hint_string" },
    { 0xDF8A7F05, "reset_village_vision_later" },
    { 0xB6988AC3, "reset_visionset_to_default" },
    { 0x42C87147, "reset_visionset_to_tunnel_flashlight" },
    { 0x4BA2B199, "reset_visionset_to_tunnel_flashlight_off" },
    { 0x01FBED10, "reset_vista_lights" },
    { 0xFDAB17CA, "reset_walk_speed" },
    { 0x535E4246, "reset_walkdist" },
    { 0xDB7EF269, "reset_wallbuy_internal" },
    { 0x200EE8F6, "reset_wallbuys" },
    { 0xD9B28D14, "reset_weapon_object_explode_this_frame" },
    { 0xB4E07B39, "reset_zombie_anim" },
    { 0xFF2A84B9, "resetaccuracy" },
    { 0xD14E103A, "resetaccuracyandpause" },
    { 0xABC0F0F9, "resetactionslottoaltmode" },
    { 0x1F451F8F, "resetactivecontractprogress" },
    { 0x730905B8, "resetactivecounteruav" },
    { 0x5AE5CC6B, "resetactivesatellite" },
    { 0x77040854, "resetactiveuav" },
    { 0xCCAEE9F8, "resetadswidthandlerp" },
    { 0x143071FD, "resetailimit" },
    { 0x3EE9BD9E, "resetallscores" },
    { 0xC2374312, "resetanimspecial" },
    { 0x71FB32A8, "resetattackerdamage" },
    { 0x2B8BC4CB, "resetattackerlist" },
    { 0x236569E7, "resetattackersthisspawnlist" },
    { 0x696889A0, "resetbettyexplodethisframe" },
    { 0x2A6A1143, "resetbombsite" },
    { 0x0F86AE84, "resetbombzone" },
    { 0x836F5986, "resetbrinkofdeathkillstreakshortly" },
    { 0x0C6450E1, "resetc4explodethisframe" },
    { 0xBF1B93EA, "resetcameraspikestate" },
    { 0x950BC93A, "resetcargo" },
    { 0xBB672DB8, "resetchallengeprogress" },
    { 0x6164C3B7, "resetcliponabort" },
    { 0xD087A14A, "resetcmd" },
    { 0x2A5DF5B1, "resetcondition" },
    { 0x11594A18, "resetconditions" },
    { 0xECDD3DEF, "resetcontrolinitiateduponownerrespawn" },
    { 0x0C8EDD93, "resetcoverparameters" },
    { 0x4316550D, "resetdoublejumprechargetime" },
    { 0x3E8AA3FE, "resetevent" },
    { 0x84E7C0BD, "resetfiredamage" },
    { 0xFAE90AF9, "resetfiretime" },
    { 0xB7DDF8EC, "resetflagbaseeffect" },
    { 0x0309D125, "resetflashback" },
    { 0x2BD7947A, "resetflashstartandend" },
    { 0x1208ECD9, "resetflashstartandendafterdelay" },
    { 0x368F616B, "resetfov" },
    { 0xFA936882, "resetgameoverhudrequired" },
    { 0x164E93C0, "resetgibcounter" },
    { 0xDC6088A0, "resetgiveuponenemytime" },
    { 0x02910711, "resetgiveuptime" },
    { 0x0359019E, "resetglass" },
    { 0xD48E525D, "resetgoalradius" },
    { 0x336EF288, "reseticons" },
    { 0x1C2CC7A3, "resetinactivitytimer" },
    { 0x82E728B6, "reseting" },
    { 0xB863BD01, "resetinterval" },
    { 0x2FEE0BA2, "resetkillcament" },
    { 0xA3F8BEC2, "resetkillcams" },
    { 0x72840288, "resetlookforbettercovertime" },
    { 0x8F990E50, "resetmissdebouncetime" },
    { 0x57903B52, "resetmissiledetonationtime" },
    { 0xAAE88325, "resetmisstime" },
    { 0x2D62A9A4, "resetnextsaytimes" },
    { 0xEFAC4CB1, "resetnotify" },
    { 0xB9356DE3, "resetoncancel" },
    { 0x0AC17AFB, "resetonclasschange" },
    { 0xBA8CD7C1, "resetondeath" },
    { 0x74F2C428, "resetondemojump" },
    { 0xCCEA565B, "resetonfirstround" },
    { 0x4FB0B003, "resetonroundswitch" },
    { 0x1E349226, "resetonteamchanged" },
    { 0x6D6BE069, "resetoobtimer" },
    { 0x2F937F8E, "resetorientmodeongoalchange" },
    { 0x3DE843E6, "resetoutcomeforallplayers" },
    { 0x7EBE2665, "resetoutcomenotify" },
    { 0x78A65FCA, "resetplayerkillcount" },
    { 0xCA6DFD0A, "resetplayermomentumondeath" },
    { 0x45C63AB9, "resetplayermomentumonspawn" },
    { 0x646DD4A9, "resetplayerscorechainandmomentum" },
    { 0x5C7930F2, "resetplayerscoreeveryround" },
    { 0x7D5864A8, "resetplayerscores" },
    { 0xF85DE266, "resetplayerscorestreaks" },
    { 0x1F619D76, "resetplayerviewratescale" },
    { 0xBA2E6507, "resetpregamedata" },
    { 0x8EA39A4F, "resetqosgamedatapayload" },
    { 0x187476B4, "resetreactiontoenemy" },
    { 0xAA3A87E2, "resetrecentkillvariables" },
    { 0x569A50FF, "resetreconmodelonevent" },
    { 0x70127CDA, "resetreconmodelvisibility" },
    { 0xA8BEEF04, "resetregularidle" },
    { 0x770AFC5B, "resetrespondtodeathtime" },
    { 0xB2444A71, "resetrevivesequencetimer" },
    { 0xBEF4D6CA, "resetrocketkillcament" },
    { 0x663CC775, "resets" },
    { 0xB98F43B3, "resetsafezone" },
    { 0xC7CBB166, "resetsatchelexplodethisframe" },
    { 0x33D815AD, "resetsatellitetypeonend" },
    { 0xDB123088, "resetsaytime" },
    { 0xB732E1A3, "resetsaytimes" },
    { 0x4FF2F46F, "resetscorechain" },
    { 0x14BB829D, "resetseekoutenemytime" },
    { 0x7230AE71, "resetsessionqosdata" },
    { 0xC609E445, "resetskill" },
    { 0x6036EF22, "resetsniperaim" },
    { 0x76CCF7AA, "resetspawner" },
    { 0xA7E12565, "resetspawners" },
    { 0x3C316267, "resetspreadoverride" },
    { 0x0B9AD514, "resetspyplanetypeonend" },
    { 0x13F46DF2, "resetsquadcommands" },
    { 0x20151B59, "resetstate" },
    { 0x30AB40CB, "resetsundirection" },
    { 0x7A1BC164, "resetsunlight" },
    { 0xF435583A, "resett" },
    { 0x701F2295, "resettags" },
    { 0xCA28855C, "resetteamoutcomenotify" },
    { 0xFCB59778, "resetteamscores" },
    { 0x4828A1F8, "resetteamvariables" },
    { 0x5254E3EB, "resettimeout" },
    { 0x217F9AF6, "resetting" },
    { 0xBEEA3758, "resetting_action_slot_to_alt_mode" },
    { 0xA0FC7939, "resetting_vision" },
    { 0x103937EC, "resetusability" },
    { 0xE3E867B0, "resetvehiclefromdropdeploy" },
    { 0xA944BC52, "resetviewclamp" },
    { 0xC7DFF00F, "resetwageroutcomenotify" },
    { 0xFFC27C85, "resetwatchers" },
    { 0x1ACD7B04, "resetweaponanims" },
    { 0x3382BF7C, "resetweaponcosts" },
    { 0x54709B25, "resetweaponobjectexplodethisframe" },
    { 0xA7681825, "resetweaponobjectwatcher" },
    { 0x3A4F19EA, "resetzombieboxweapons" },
    { 0xB772C0E3, "reseverd" },
    { 0xE5CE1AE3, "resflag" },
    { 0x2B613FD2, "resflags" },
    { 0x361B0234, "resflagsinit" },
    { 0x04741436, "reshirt_spawners" },
    { 0xFF22F379, "reshirts" },
    { 0xDD46AE3F, "reside" },
    { 0x172B0ECB, "residence" },
    { 0xA309401A, "residence_door" },
    { 0x8A45003A, "residence_door_fix" },
    { 0xF694456D, "resident" },
    { 0xDBBDBB46, "resides" },
    { 0x861F4830, "residual" },
    { 0x0553D0B0, "residue" },
    { 0xF7582D96, "resigned" },
    { 0x3380A332, "resilience" },
    { 0xF984723A, "resilient" },
    { 0x37EF1500, "resist_fail_value" },
    { 0x92C9BE0A, "resistance" },
    { 0x295E3A5D, "resistance_done" },
    { 0x4716B686, "resistance_guy_kill_me" },
    { 0xE9D86022, "resistant" },
    { 0x9C081064, "resisted" },
    { 0x6E62C8E6, "resists" },
    { 0x5E304B06, "resize_holographic_meeting" },
    { 0x63052132, "resnov" },
    { 0x503CABC0, "resnov_align" },
    { 0x9782AB59, "resnov_jumpout_time" },
    { 0x391999DF, "resnov_save_u_go" },
    { 0x41B3227B, "resnov_splain_stuff" },
    { 0x9AC15381, "resnov_wake" },
    { 0x9396FE47, "resolution" },
    { 0x3A69EBEB, "resolve" },
    { 0x7A85E618, "resolve_hatchet_after_wait" },
    { 0xB778FF75, "resolved" },
    { 0xA59936CA, "resolves" },
    { 0xD0BA9B4E, "resolving" },
    { 0x1689973E, "reson" },
    { 0xFBB30672, "resort" },
    { 0xE2F65E81, "resotred" },
    { 0xD385EAD8, "resources" },
    { 0x256D5E9F, "respawn" },
    { 0x9CB0E1C9, "respawn_all_pickups" },
    { 0xA1FBC7F6, "respawn_angles" },
    { 0x041FA8AB, "respawn_arena" },
    { 0xA1BF9B89, "respawn_asspectator" },
    { 0x88F2F8C9, "respawn_brutus" },
    { 0x86FFFC81, "respawn_brutus_after_gondola" },
    { 0x08118E5A, "respawn_cartel_after_intro_spawners_die" },
    { 0x96119491, "respawn_cleansed_player" },
    { 0x17C66CD7, "respawn_count" },
    { 0xE1D2043A, "respawn_counter" },
    { 0x1917EC97, "respawn_death_delay_max" },
    { 0xFBA857E9, "respawn_death_delay_min" },
    { 0x1978E8F3, "respawn_delay" },
    { 0xB2B40DA7, "respawn_friendlies" },
    { 0x23B65FC3, "respawn_from_spectator_new" },
    { 0x823B2A58, "respawn_func" },
    { 0x837C4520, "respawn_ghosts_outside_mansion" },
    { 0x62D88564, "respawn_go" },
    { 0x1D2162C7, "respawn_guys_now" },
    { 0x56C9DC51, "respawn_interval" },
    { 0x2E665CE9, "respawn_meat_player" },
    { 0xFC4E03B8, "respawn_mission_courtyard_rocket_soldier" },
    { 0xBB53DC61, "respawn_notify" },
    { 0x3CEC375A, "respawn_now" },
    { 0xB479B51E, "respawn_on_death" },
    { 0x19613408, "respawn_origin" },
    { 0x96B43D6A, "respawn_parameters" },
    { 0xDEB7C391, "respawn_path_nodes" },
    { 0x7651F8AE, "respawn_pickup" },
    { 0x2EE48B64, "respawn_players" },
    { 0x32DEED80, "respawn_point" },
    { 0xA80CDDAB, "respawn_points" },
    { 0x081008CB, "respawn_position" },
    { 0xC17A112A, "respawn_positions" },
    { 0x55D4F47D, "respawn_rifle_gren" },
    { 0x38A18756, "respawn_schrek" },
    { 0x11CBF8BA, "respawn_spawner" },
    { 0x79129BC0, "respawn_spawners_specific" },
    { 0xC657F013, "respawn_spectators_and_freeze_players" },
    { 0xFE50AEB5, "respawn_struct_fix" },
    { 0x09B7A0A5, "respawn_time" },
    { 0x73848C29, "respawn_trace" },
    { 0xCE04A9A0, "respawn_trig" },
    { 0xDA95F656, "respawn_vehicle" },
    { 0x29C28B63, "respawn_vehicle_now" },
    { 0x64A00EDE, "respawn_wait_loop" },
    { 0x097C6A0F, "respawnable" },
    { 0x3C68059C, "respawnatactivecheckpoint" },
    { 0x784E5B88, "respawndelay" },
    { 0x0FF5ADA4, "respawned" },
    { 0x4781EF37, "respawned_by_time_bomb" },
    { 0xEF1383AE, "respawned_friendly_spawners" },
    { 0x0C81C09B, "respawned_friendly_think" },
    { 0x24185F62, "respawner" },
    { 0x52FD4967, "respawner_controls" },
    { 0x62AE8267, "respawner_think" },
    { 0xEDE4B92D, "respawners" },
    { 0x2AD0F728, "respawnfromhack" },
    { 0x402F0AA1, "respawning" },
    { 0x5006C826, "respawns" },
    { 0xF239016C, "respawntime" },
    { 0xFA504F21, "respawntimerstarttime" },
    { 0x7B38789D, "respect" },
    { 0xAAE8A331, "respective" },
    { 0x0EB7979C, "respectively" },
    { 0x74F7F285, "respectnottargetedbyrobotperk" },
    { 0xC5F3FDDC, "respects" },
    { 0xFF6962B2, "respin" },
    { 0xBF34B3E4, "respin_box" },
    { 0x01358747, "respin_box_thread" },
    { 0xD804AFFA, "respin_hack" },
    { 0xA7222C18, "respin_respin_box" },
    { 0xB10DACCD, "respintime" },
    { 0x0D5EB4A2, "respirator" },
    { 0xA9D84355, "respite" },
    { 0xC34FA05C, "respond" },
    { 0x87259C0F, "respond_append" },
    { 0x02122A58, "respond_to_alert_level" },
    { 0x33BC1694, "respond_to_death_retry_interval" },
    { 0x6BFF8659, "responder" },
    { 0xE4CE5AAC, "responding" },
    { 0xC2E91DB6, "responding_drones" },
    { 0xCFB7A5D6, "responding_drones_spawn" },
    { 0xA488869F, "responds" },
    { 0x6372E447, "respondto" },
    { 0x9D148F49, "respondtodeadteammate" },
    { 0xBA1DFFCC, "respondtodeathtime" },
    { 0xD62110B4, "response" },
    { 0xE49426F6, "response_chances" },
    { 0x84AFFBE7, "response_distance_min" },
    { 0x61F49219, "response_line" },
    { 0x3B137055, "response_line_max_dist" },
    { 0xB9BF2EFB, "response_percentage" },
    { 0xDCF8ADF0, "response_to_air_raid_siren_vo" },
    { 0x5B36330D, "response_trigger" },
    { 0x7BAF307C, "response_wait" },
    { 0x1C6926B0, "response_wait_axis" },
    { 0x0F09CC68, "responseacknowledge" },
    { 0x5D4F4E8E, "responsefunc" },
    { 0x1E52CFBC, "responsekillconfirm" },
    { 0x9AFF2CA7, "responses" },
    { 0x0D6CB66E, "responsetok" },
    { 0x830A2EB3, "responsibilities" },
    { 0x128C6A57, "responsibility" },
    { 0x1A40F9CB, "responsible" },
    { 0x3995E897, "responsive" },
    { 0x0E026B50, "resprogress" },
    { 0x28E4E3EB, "resprogressteam" },
    { 0x858674B3, "rest" },
    { 0xBDF8631B, "rest_angle" },
    { 0x2E8F8A3A, "rest_angles" },
    { 0xF840B2D0, "rest_pos" },
    { 0x120843C1, "rest_time" },
    { 0xE651C66C, "rest_turret" },
    { 0x4A97A063, "rest_vector" },
    { 0xBDA7D3D2, "restart" },
    { 0x657CAD81, "restart_back_onpath" },
    { 0x5867D3D1, "restart_back_onpath2" },
    { 0xE3D9C24D, "restart_blink" },
    { 0x8D20FAAF, "restart_blink_player" },
    { 0x45B5B767, "restart_brutus_reaction_vo_watcher" },
    { 0x9CC9689A, "restart_effect" },
    { 0x4A204877, "restart_fx" },
    { 0x2B80F141, "restart_fx_looper" },
    { 0x844CE15D, "restart_maxis_audiolog_unitrigger" },
    { 0x8D951BDD, "restart_moving_to_goal" },
    { 0x95570049, "restart_path_watcher" },
    { 0x22F7AA0C, "restart_price" },
    { 0xBFBE2251, "restart_quickrevive" },
    { 0xADE0C7E3, "restart_round" },
    { 0x55F46748, "restart_show_timer" },
    { 0x9A9590A9, "restart_slowview" },
    { 0xC11347B4, "restart_sundial_monitor" },
    { 0xBCF9161A, "restartallmoveanims" },
    { 0x0FAA46E5, "restarted" },
    { 0xE0343F21, "restarteffect" },
    { 0xCBC65778, "restartfx" },
    { 0x96ECAADE, "restarting" },
    { 0x1F50DCD7, "restarting_satchel_hint" },
    { 0xD4F5B6A8, "restartmission" },
    { 0x49A803A0, "restartmissionlistener" },
    { 0xB0C6344E, "restartmissionluilistener" },
    { 0xEEBDC46E, "restartprefix" },
    { 0x5BA6ECDD, "restarts" },
    { 0xF8EE1BAF, "restartsound" },
    { 0x85486C60, "restaurant" },
    { 0x3FDB642D, "resting" },
    { 0xD6470CA2, "resting_pitch" },
    { 0xEDE58BA8, "resting_spot" },
    { 0x4BA8E020, "restock" },
    { 0x4EF83AB3, "restocked" },
    { 0x3DE68B1A, "restorable_points" },
    { 0x2B17A72F, "restoration" },
    { 0xDAB66DD5, "restore" },
    { 0xA20B6345, "restore_actor_traverse_callbacks" },
    { 0x4ECCD922, "restore_ammo" },
    { 0x82462F08, "restore_at_checkpoint" },
    { 0x02C3BE07, "restore_boat_health" },
    { 0x99A73082, "restore_body_model" },
    { 0x8D17EF3A, "restore_clip" },
    { 0x3E026F56, "restore_clip_size" },
    { 0x4740BEAE, "restore_default_drop_pitch" },
    { 0xF5D69B32, "restore_door_state" },
    { 0xDDBE4C81, "restore_flashlight_function" },
    { 0xB687A7E8, "restore_fog" },
    { 0x3CB1C8E1, "restore_fov" },
    { 0x3697B76B, "restore_ghost_failsafe" },
    { 0x3D787325, "restore_ik_headtracking_limits" },
    { 0xDE5BC4B2, "restore_lookspeed" },
    { 0x68F7C63C, "restore_magic_bullet_shield" },
    { 0x5504D6A2, "restore_max" },
    { 0x6F8C570B, "restore_msg" },
    { 0xDF253602, "restore_player_positions" },
    { 0x8CAB56B1, "restore_player_to_initial_loadout" },
    { 0x8FAA5298, "restore_player_view_angles" },
    { 0x72A9BC90, "restore_player_weapon_at_end" },
    { 0xEC0D4DBD, "restore_player_weapons" },
    { 0x79B012D9, "restore_rso_focus" },
    { 0xE8DAE820, "restore_share_screen" },
    { 0x559188D2, "restore_stock" },
    { 0x9C770883, "restore_time" },
    { 0x9C1107DC, "restore_timer_on_save_restored" },
    { 0x735E1EDF, "restore_timescale" },
    { 0x7D416364, "restore_weapon_for_chugabud" },
    { 0xEAA30C74, "restore_weapon_for_tombstone" },
    { 0x001931E1, "restore_weapons_for_chugabud" },
    { 0xEACA69CF, "restore_weapons_for_tombstone" },
    { 0x4A34C6DD, "restore_worldstate_for_minigame" },
    { 0xC7662675, "restoreangles" },
    { 0x4937154B, "restored" },
    { 0x121754CB, "restoredefaultdroppitch" },
    { 0x6DDAEB82, "restoredefaultpitch" },
    { 0x80398CEB, "restoredefaults" },
    { 0xFDD4E738, "restoreheadicon" },
    { 0xA138BB73, "restorelookent" },
    { 0xE0F92D96, "restorelookpoint" },
    { 0x69D8D265, "restorenote" },
    { 0x8FB89619, "restorepain" },
    { 0x8F2BF364, "restorepainonkillanimscript" },
    { 0xDF354A09, "restorepitch" },
    { 0x994D7C72, "restoreplayerweaponstatepersistent" },
    { 0x17EE9BBB, "restorereplacement" },
    { 0x76DD622E, "restoreriotshieldviewmodel" },
    { 0x0F11E924, "restores" },
    { 0x731F7A19, "restorevision" },
    { 0x9665587A, "restorewinstreaks" },
    { 0x9DE730A0, "restoring" },
    { 0x63B98322, "restoring_initialized_round" },
    { 0x250D3FD5, "restrain" },
    { 0xF636B882, "restrain_dialogue" },
    { 0xEFBC04BB, "restraint" },
    { 0xA625935A, "restraints" },
    { 0x55165D75, "restrict" },
    { 0xB88D90A2, "restricted" },
    { 0x640FBC4C, "restricted_solution" },
    { 0x50F713BC, "restrictedgib" },
    { 0x11E05EA9, "restriction" },
    { 0x3AB6A120, "restrictions" },
    { 0xD4B6BC44, "restricts" },
    { 0x559E8118, "restructuring" },
    { 0x2AE5EF62, "rests" },
    { 0x3C61BFC2, "result" },
    { 0x96BDDC01, "result_frac" },
    { 0xB366C093, "result_func" },
    { 0xEF89A210, "result_name" },
    { 0x241135F4, "result_text" },
    { 0x1BB94CBD, "resultant" },
    { 0xA8E2C6D5, "resulted" },
    { 0xBC1B462E, "resulting" },
    { 0x17839FB9, "resultobj" },
    { 0x7AFB8601, "resultpose" },
    { 0x08C8D60D, "results" },
    { 0xCFCC2D7B, "resultstr" },
    { 0x2532255C, "resume" },
    { 0x5ED03282, "resume_all_traffic" },
    { 0x4FCFF524, "resume_anim" },
    { 0x33F4759F, "resume_combat" },
    { 0x3D76B0FD, "resume_drone_speed_control" },
    { 0x0B42800F, "resume_fire" },
    { 0x4EFA4595, "resume_fire_at_goal" },
    { 0xE61C65CA, "resume_fire_in_a_moment" },
    { 0x41EF4765, "resume_idle" },
    { 0xD694CAF4, "resume_moon_rounds" },
    { 0x83D0CAD7, "resume_normal_ai" },
    { 0x1E64B908, "resume_notify" },
    { 0x422123FE, "resume_path" },
    { 0xFB40914F, "resume_path_vehicle" },
    { 0x7042BB38, "resume_player_stealth" },
    { 0x6048CBD6, "resume_power" },
    { 0xD06C8B64, "resume_speed" },
    { 0x7399E9E9, "resume_speed_flag" },
    { 0x1FE01F98, "resume_time" },
    { 0x1130B3A7, "resume_turret_power" },
    { 0xB4B5E429, "resume_weapon_cycling" },
    { 0x668ABB4A, "resumeadvance" },
    { 0x292F5CAD, "resumecover" },
    { 0x7C7013E8, "resumefire" },
    { 0xAB0FCF2E, "resumemsgs" },
    { 0x0D195B70, "resumenode" },
    { 0x82A89A99, "resumepath" },
    { 0xBC1FE59F, "resumes" },
    { 0x6AE7EEAD, "resumespeed" },
    { 0xE63CF1AC, "resumespeeds" },
    { 0xBBE04EFF, "resumetimer" },
    { 0xE7089A23, "resumetimerdiscardoverride" },
    { 0x9EC0F145, "resuming" },
    { 0xEEAEC2A0, "resuming speed" },
    { 0x810A3167, "resupply" },
    { 0x183E8A4C, "resurfacetime" },
    { 0xEEC6038F, "resurrct" },
    { 0x17924186, "resurrect" },
    { 0xB47C0D05, "resurrect_angles" },
    { 0xBF70FB06, "resurrect_available_time" },
    { 0x3C533375, "resurrect_body_dissappear_fx" },
    { 0xE8ED3D71, "resurrect_breadcrumbs" },
    { 0x8A4ECD82, "resurrect_delay" },
    { 0xE4115BCE, "resurrect_down_fx" },
    { 0xAB495FCB, "resurrect_drain_power" },
    { 0x04FC7F37, "resurrect_held_duration" },
    { 0xC0C9E063, "resurrect_not_allowed_by" },
    { 0x967C6F7B, "resurrect_origin" },
    { 0x46488267, "resurrect_outline_material" },
    { 0xE0E92019, "resurrect_postfx_bundle_close" },
    { 0xF27A4534, "resurrect_postfx_bundle_close_duration" },
    { 0x354DA06B, "resurrect_postfx_bundle_open" },
    { 0x58E188E5, "resurrect_postfx_bundle_pus" },
    { 0xF6C8A829, "resurrect_shellshock" },
    { 0x60BFA141, "resurrect_slot" },
    { 0x75DF7899, "resurrect_smoke_fx" },
    { 0xA545E343, "resurrect_smoke_weapon_name" },
    { 0xE9624163, "resurrect_spawn_fx" },
    { 0xDE3823FA, "resurrect_spawn_sound" },
    { 0x5FAB470B, "resurrect_state_bits" },
    { 0x753C763F, "resurrect_state_down" },
    { 0xE523DB51, "resurrect_state_none" },
    { 0x1D9253B0, "resurrect_state_up" },
    { 0xA3E5661A, "resurrect_taken" },
    { 0xD99F16E2, "resurrect_time" },
    { 0xD67928AE, "resurrect_time_or_activate" },
    { 0xEC525B13, "resurrect_up_fx" },
    { 0x54405383, "resurrect_visionset" },
    { 0x8BF3B992, "resurrect_visionset_alias" },
    { 0x5B006B5A, "resurrect_visionset_priority" },
    { 0xD574E3CE, "resurrect_visionset_ramp_hold" },
    { 0x1875C5B8, "resurrect_visionset_ramp_in" },
    { 0xAE68DFB7, "resurrect_visionset_ramp_out" },
    { 0x8382B4B3, "resurrect_visionset_steps" },
    { 0x4E043F65, "resurrect_visionset_up" },
    { 0x951AB42C, "resurrect_visionset_up_alias" },
    { 0x9C2FF900, "resurrect_visionset_up_priority" },
    { 0xE262FF90, "resurrect_visionset_up_ramp_hold" },
    { 0xA76141B2, "resurrect_visionset_up_ramp_in" },
    { 0xC0B93965, "resurrect_visionset_up_ramp_out" },
    { 0x8B97BFA1, "resurrect_visionset_up_steps" },
    { 0x01BE002D, "resurrect_watch_for_death" },
    { 0x6967CDE5, "resurrect_weapon" },
    { 0x09F27551, "resurrect_weapon_name" },
    { 0xAC156B36, "resurrect_world_hint_fx" },
    { 0x79002954, "resurrection" },
    { 0x80C783BF, "resync" },
    { 0x5D74E4A2, "ret" },
    { 0x19C24E40, "ret_array" },
    { 0x83D88109, "ret_list" },
    { 0x15F93733, "ret_stair_anims" },
    { 0xB113E18E, "ret_val" },
    { 0x5600A6D8, "retail" },
    { 0x0D50752C, "retailers" },
    { 0xA2059BAA, "retain" },
    { 0x1853233D, "retained" },
    { 0xB5750586, "retaining" },
    { 0x7BAC5697, "retake" },
    { 0x8A45A03B, "retaken" },
    { 0x970C3892, "retaking" },
    { 0x700E4006, "retaliate" },
    { 0xB72679AE, "retangles" },
    { 0xD14E7596, "retarded" },
    { 0x0D9F6D55, "retarget" },
    { 0xAF9BF30A, "retest" },
    { 0x1C9B2EBE, "rethink" },
    { 0x9B408AC9, "rethreaded" },
    { 0xB8F2CECF, "reticle" },
    { 0xEDE1C4CA, "reticle_color_index" },
    { 0x4D358760, "reticle_filter_id" },
    { 0x7586B6FC, "reticle_hud_think" },
    { 0x806D7186, "reticle_index" },
    { 0xFAC71696, "reticles" },
    { 0x97C92584, "reticlesize" },
    { 0x222AAEE6, "reticule" },
    { 0x3394B518, "retina" },
    { 0x1F14B548, "retract" },
    { 0x5C502497, "retract_left_arm" },
    { 0xD12A9AF0, "retract_right_arm" },
    { 0x24591C6F, "retract_times" },
    { 0x903F1AF0, "retractable" },
    { 0x311E305B, "retracted" },
    { 0x5764E590, "retracting" },
    { 0x88671063, "retracts" },
    { 0xCF8AC51A, "retreat" },
    { 0x14DDF2C7, "retreat_away_from_tank_3" },
    { 0x607DC5EB, "retreat_away_from_tank_3_delay" },
    { 0x2CA58183, "retreat_chains" },
    { 0x8259A406, "retreat_delay" },
    { 0x2CDF0B56, "retreat_dir" },
    { 0x2ABA2D6D, "retreat_done" },
    { 0x59C41030, "retreat_done_done" },
    { 0xC718CD02, "retreat_endpoint" },
    { 0x637A299B, "retreat_final" },
    { 0xC1C0546C, "retreat_gate" },
    { 0xEEBA8E3E, "retreat_group" },
    { 0xB00AA5F8, "retreat_group_kills_detection" },
    { 0xBD2105A4, "retreat_group_name" },
    { 0x2FEEB00A, "retreat_group_notify_detection" },
    { 0x4DCE3E45, "retreat_group_track_death" },
    { 0x88C0FF21, "retreat_groups" },
    { 0xE37FD4DA, "retreat_groups_init" },
    { 0xF4F73E17, "retreat_house" },
    { 0xED9A3962, "retreat_house_open" },
    { 0xB87288AA, "retreat_interrupt" },
    { 0x7A8185B9, "retreat_node" },
    { 0xDEAA78ED, "retreat_node_1" },
    { 0x04ACF356, "retreat_node_2" },
    { 0xC1F3A0F0, "retreat_nodes" },
    { 0x4BA7E186, "retreat_nodes_noteworthy" },
    { 0xF1C9A1F8, "retreat_planes" },
    { 0x1789E468, "retreat_points" },
    { 0x421060B9, "retreat_pos" },
    { 0xCD7006F2, "retreat_reference_points" },
    { 0x082BE17A, "retreat_runners" },
    { 0x66264962, "retreat_spawners" },
    { 0x8116BB24, "retreat_tanks" },
    { 0x38C1939C, "retreat_text" },
    { 0xC351639A, "retreat_threshold" },
    { 0x6D84B036, "retreat_tiger" },
    { 0xE67FA6BE, "retreat_trigger_flood_1" },
    { 0xC07D2C55, "retreat_trigger_flood_2" },
    { 0x9A7AB1EC, "retreat_trigger_flood_3" },
    { 0x74783783, "retreat_trigger_flood_4" },
    { 0x4E75BD1A, "retreat_trigger_flood_5" },
    { 0x9F15816A, "retreat_trigger_spawner_1" },
    { 0x79130701, "retreat_trigger_spawner_2" },
    { 0x53108C98, "retreat_trigger_spawner_3" },
    { 0xD4B35D1E, "retreat_triggers" },
    { 0x14FE3400, "retreat_truck_array" },
    { 0xD1EFFEE7, "retreat_truck_behavior" },
    { 0x7ACECFC5, "retreat_truck_behavior_node_kill" },
    { 0x598C560D, "retreat_truck_player_hit_me" },
    { 0x3791622D, "retreat_trucks" },
    { 0x35FB7946, "retreat_wave" },
    { 0x3A172DF9, "retreat_waves" },
    { 0x9FEA27AD, "retreated" },
    { 0xB40CD96B, "retreater" },
    { 0xAD745BDC, "retreater_trig" },
    { 0xA115174A, "retreaters" },
    { 0xBA99A5EA, "retreatguys" },
    { 0xED065856, "retreating" },
    { 0xA52CC806, "retreating_enemies_spawner" },
    { 0x3406EE33, "retreatlocs" },
    { 0x154D5563, "retreatnodename" },
    { 0xADE50481, "retreatnodes" },
    { 0xA43751D1, "retreatnotify" },
    { 0x9F296BCF, "retreatpath" },
    { 0xB836C4C2, "retreatpathname" },
    { 0xE00017E7, "retreatpathnode" },
    { 0x0B997415, "retreats" },
    { 0x92CC4B9D, "retreattriggers" },
    { 0x278A959F, "retreaty" },
    { 0x4F5081CE, "retreivedblades" },
    { 0x8C877F85, "retries" },
    { 0x0D3F176C, "retriesmodel" },
    { 0x080F61A0, "retrievable" },
    { 0xAE3B9669, "retrievable_changed" },
    { 0x30956FC6, "retrievable_knife" },
    { 0xBA14E572, "retrievable_knife_init_names" },
    { 0x1A050766, "retrievable_model" },
    { 0xA7C7BD14, "retrievabletrigger" },
    { 0xA5229C7C, "retrievableweaponnames" },
    { 0xA13D3DDF, "retrievableweapons" },
    { 0xA54ABFDF, "retrieval" },
    { 0x0227EF15, "retrieve" },
    { 0xD62C9165, "retrieve_bot_challenge" },
    { 0x6661A9F7, "retrieve_story_stats" },
    { 0x1910BBC2, "retrieve_trigger_height" },
    { 0x7FE3469D, "retrieve_trigger_radius" },
    { 0xD5A4B349, "retrieveable" },
    { 0xA222C18B, "retrieved" },
    { 0x662C7DA2, "retrievehint" },
    { 0x34CD8C6D, "retrievehints" },
    { 0x51133534, "retriever_trigger" },
    { 0x67FD9564, "retrieves" },
    { 0x3B3DF9DC, "retrievingweapon" },
    { 0x44E5EA6A, "retrigger" },
    { 0x5DF1C9FD, "retriggered" },
    { 0xFEE4A83E, "retrospect" },
    { 0x1E9E019D, "retry" },
    { 0xD155BE8B, "retrying" },
    { 0x66F500F7, "return" },
    { 0x81546DD1, "return_additionalprimaryweapon" },
    { 0x1FC6FF7D, "return_anim" },
    { 0x8A502DCD, "return_array" },
    { 0x17448517, "return_blocker_model_to_pool" },
    { 0xB4C5CCF5, "return_control_to_player" },
    { 0x69226CC7, "return_drum_type_array" },
    { 0xF99736A7, "return_false" },
    { 0xBB63D863, "return_fire_flag" },
    { 0x70F04C6C, "return_from_cloud" },
    { 0xB78EC1A4, "return_from_graveyard" },
    { 0x31CEA3FB, "return_home" },
    { 0x4F633C43, "return_music_state_player" },
    { 0x5F207017, "return_music_state_team" },
    { 0xFF3FD114, "return_of_the_jedi_drones" },
    { 0xFBF3B0D0, "return_of_the_jedi_feedback" },
    { 0x5CEE6223, "return_offset" },
    { 0xF38929C7, "return_path" },
    { 0xBE31E870, "return_path_clip" },
    { 0xE12F36F3, "return_pieces" },
    { 0x00DECCAC, "return_players" },
    { 0x0810E207, "return_prep" },
    { 0x36B1754C, "return_retained_perks" },
    { 0x7165EA2A, "return_round" },
    { 0x8F05AF31, "return_state" },
    { 0x9F239C39, "return_struct" },
    { 0x0A0210DD, "return_time" },
    { 0xF04900F3, "return_timeout" },
    { 0x65359525, "return_to_cover" },
    { 0xC15F8229, "return_to_spawn" },
    { 0xD29E0E53, "return_to_start_pos" },
    { 0x52AB61FA, "return_to_zero" },
    { 0xF78A8DA8, "return_trip_enemy_acc" },
    { 0x404F2026, "return_trip_enemy_acc_prep" },
    { 0x7B62B823, "return_trip_friendly_boost" },
    { 0x0FBD909E, "return_true" },
    { 0xB1F173CA, "return_unit_at_location" },
    { 0xD761F857, "return_val" },
    { 0x71F0BAB5, "return_value" },
    { 0xBC0B95F2, "return_weapon" },
    { 0x6834CA64, "return_when_defined" },
    { 0xE7EF6F68, "return_zone" },
    { 0xD86ED34B, "returnablecivilians" },
    { 0xC37AA1B8, "returnanim" },
    { 0xBF840AD3, "returnbarriers" },
    { 0x4C20A54D, "returncheck" },
    { 0x93D4C328, "returndamage" },
    { 0x9C8FE9D7, "returndata" },
    { 0x5D3C0DBC, "returned" },
    { 0x575F1756, "returned_threads" },
    { 0x03DE4334, "returned_to_owner" },
    { 0xC977AD60, "returnednote" },
    { 0xEF23F3DD, "returnflag" },
    { 0x2AFD3059, "returnflagaftertimemsg" },
    { 0x5BADCED4, "returnflaghudelems" },
    { 0xBAA70C81, "returnflight" },
    { 0x11DA64D2, "returnhome" },
    { 0x5F241829, "returning" },
    { 0x73545C79, "returning_home" },
    { 0x72FCE921, "returningtoarea" },
    { 0xE9CAA370, "returnkniferangtoowner" },
    { 0x5D0C9F44, "returnmessageelems" },
    { 0x49AB8CB6, "returnobj" },
    { 0x34EF7D07, "returnplayercontrol" },
    { 0x6DD914D9, "returnpowerup" },
    { 0xD1C88D2E, "returns" },
    { 0x3A680D6A, "returnstate" },
    { 0x9073CD58, "returnstr" },
    { 0xF726E0A4, "returntime" },
    { 0x73376A87, "returntobasepos" },
    { 0xAD2D4A65, "returntocover" },
    { 0x9BE83EB7, "returntrue" },
    { 0xA72AA46A, "returnturrettoinventory" },
    { 0x421F3C8C, "returnval" },
    { 0x262E1B02, "returnvar" },
    { 0x12FE08D7, "retval" },
    { 0x65D07F35, "retvalue" },
    { 0x254DEB72, "retweapon" },
    { 0x0467C177, "reunion" },
    { 0x69718E7D, "reunite" },
    { 0xA308B243, "reunited" },
    { 0x87C768C3, "reuse" },
    { 0x5AE1BBFD, "reused" },
    { 0x56796546, "reusing" },
    { 0x116FEFD0, "rev" },
    { 0x1C9AA823, "rev_per_second" },
    { 0x1885F1D4, "rev_time" },
    { 0x35813336, "reveal" },
    { 0x7DF0F71D, "reveal_anim_done" },
    { 0xA2EF1705, "reveal_anims" },
    { 0x0BC9B8FC, "reveal_clone" },
    { 0xF465F6E9, "reveal_dialog" },
    { 0x9ED74958, "reveal_dialog_ladder" },
    { 0x23C7A8E0, "reveal_dialog_starting" },
    { 0x3F371CBC, "reveal_glow_when_player_near" },
    { 0xF9ADEE87, "reveal_island_aa" },
    { 0xDBF26489, "reveal_lighting_swap" },
    { 0x22EAF56B, "reveal_material_enemy" },
    { 0x72C58B57, "reveal_material_self" },
    { 0xEA122A69, "reveal_meteor" },
    { 0xA052F9BE, "reveal_music" },
    { 0xEB602427, "reveal_start" },
    { 0xC8168052, "reveal_turret_think" },
    { 0x2D31D5F9, "revealed" },
    { 0xAA88CA29, "reveals" },
    { 0xB7E3CF70, "reveerse" },
    { 0x1604CC46, "revelation" },
    { 0xE6EDC881, "revenge" },
    { 0xB06C0F2D, "reverb" },
    { 0x682F9130, "reverbroomtype" },
    { 0x6449A8E1, "reverse" },
    { 0xA65CB173, "reverse_array" },
    { 0x4149432D, "reverse_blockers" },
    { 0x3ABF4D30, "reverse_fire_angle" },
    { 0x30973836, "reverse_flashlight" },
    { 0xBB841AB1, "reverse_grave_state" },
    { 0x18EFF544, "reverse_hero_rampage" },
    { 0xED67672C, "reverse_stop" },
    { 0x64076D97, "reverse_timer" },
    { 0xF44BDC15, "reverse_tram_node_array" },
    { 0x194E10F7, "reversed" },
    { 0xAF151188, "reverses" },
    { 0x1B49BF75, "reversespin" },
    { 0x1391D994, "reversing" },
    { 0xC48EC0EB, "revert" },
    { 0x012BB849, "revert_power" },
    { 0x6642D726, "revert_power_to_list" },
    { 0x9824D6E5, "revert_state" },
    { 0x59D2A4B5, "reverting" },
    { 0xDC27C12F, "revesre" },
    { 0x28FBA3B5, "review" },
    { 0xBCCCD0FB, "revised" },
    { 0xFE3CF835, "revisions" },
    { 0x4C8A7554, "revisited" },
    { 0x6EB4EC1E, "revival" },
    { 0x2A805A82, "revive" },
    { 0x45C5F54C, "revive_ammo_clip" },
    { 0x0774C936, "revive_ammo_counter" },
    { 0x0AC4510C, "revive_ammo_stock" },
    { 0xC2F22646, "revive_anim" },
    { 0x7D6637BF, "revive_clean_up_on_gameover" },
    { 0x05ED7048, "revive_complete" },
    { 0x72474405, "revive_cost_override" },
    { 0x2A439386, "revive_debug" },
    { 0xB61CB806, "revive_do_revive" },
    { 0xB755DE95, "revive_done" },
    { 0x0383F6C6, "revive_force_revive" },
    { 0xC5FD5C7F, "revive_from_rpg_attacks" },
    { 0x3AB14D53, "revive_func" },
    { 0x75F7F882, "revive_fx_clean_up_on_disconnect" },
    { 0x683104A7, "revive_get_revive_time" },
    { 0xB6BE6546, "revive_getup_process" },
    { 0xB6822E5A, "revive_give_back_weapons" },
    { 0x24B087AD, "revive_give_back_weapons_custom_func" },
    { 0x49E4169E, "revive_give_back_weapons_wait" },
    { 0x7464A290, "revive_give_back_weapons_when_done" },
    { 0xF6214561, "revive_hide" },
    { 0x313D90E0, "revive_hud" },
    { 0x6FF364DF, "revive_hud_create" },
    { 0xC5D6B106, "revive_hud_elem" },
    { 0x012793CF, "revive_hud_hide" },
    { 0x89C586EC, "revive_hud_show" },
    { 0xA1952490, "revive_hud_show_n_fade" },
    { 0x693B08C9, "revive_hud_think" },
    { 0x929A05CF, "revive_init" },
    { 0x7B823ABE, "revive_jingle" },
    { 0x70A121D1, "revive_kill" },
    { 0xC7E44D24, "revive_laststand_players" },
    { 0x77BC795B, "revive_machine_is_solo" },
    { 0xD627ADFB, "revive_machine_spawned" },
    { 0xA98676BE, "revive_main" },
    { 0xADC5EDD8, "revive_off" },
    { 0xA7912F12, "revive_on" },
    { 0x2C0B798B, "revive_perk_fx_think" },
    { 0xE7AC4A9F, "revive_perk_struct" },
    { 0x19144C26, "revive_perk_structs" },
    { 0x0F1E9B08, "revive_perk_trigger" },
    { 0x26BE8923, "revive_perk_triggers" },
    { 0x2B35AE8E, "revive_player" },
    { 0xCC69C131, "revive_players" },
    { 0xC035ACC9, "revive_point" },
    { 0xEDE08900, "revive_process" },
    { 0x73D85A3E, "revive_saved_player" },
    { 0x934DBE0D, "revive_solo_fx" },
    { 0x2B07E0C2, "revive_solo_fx_func" },
    { 0x71EF6085, "revive_strat" },
    { 0x0632C062, "revive_success" },
    { 0x9A3BB9E4, "revive_sumpf_on" },
    { 0x9367B54A, "revive_target" },
    { 0x4D73B787, "revive_team_progressbar" },
    { 0x670D761F, "revive_tool" },
    { 0x024F7F94, "revive_trigger_move_with_player" },
    { 0xEC84FEC3, "revive_trigger_noteworthy" },
    { 0x3E734EC2, "revive_trigger_should_ignore_sight_checks" },
    { 0xEFCDBEE7, "revive_trigger_spawn" },
    { 0x35062DCD, "revive_trigger_spawn_override_link" },
    { 0xFE6C9E16, "revive_trigger_think" },
    { 0xDC50CC67, "revive_watcher" },
    { 0x204015DD, "reviveanim" },
    { 0xD103650E, "reviveavg" },
    { 0x8854B4E3, "reviveavgtext" },
    { 0x55836860, "reviveavgtimecalculation" },
    { 0x9253DE22, "revived" },
    { 0x1242996E, "revived_player" },
    { 0x340AF45B, "revived_player_with_quadrotor" },
    { 0x981F818B, "revived_player_with_upgraded_staff" },
    { 0xB7A6B70C, "revivedebugprintthread" },
    { 0x32D95849, "revivedonce" },
    { 0xF4106F18, "revivedrawdata" },
    { 0x24109491, "revivedrawdebuglinecross" },
    { 0xB856588B, "revivee" },
    { 0xC6A0A598, "revivefeature" },
    { 0x470A00D1, "revivefromconsole" },
    { 0x7DCB33FF, "reviveiconalpha" },
    { 0x06964B90, "reviveicons" },
    { 0x56A1C811, "reviveid" },
    { 0x9F7EDCF8, "reviveids" },
    { 0x63DB1F44, "reviveme" },
    { 0x5654605F, "reviveobituary" },
    { 0x333D0D96, "reviveoldgoalradius" },
    { 0x9AD3560D, "reviveplayer" },
    { 0x45C55690, "revivepointdistancefromground" },
    { 0x30D551A2, "reviveprogressbar" },
    { 0x7E312C64, "reviver" },
    { 0x9D6728B9, "reviver_found" },
    { 0x78254E9A, "reviver_getup" },
    { 0xC82F7E8C, "reviver_revive" },
    { 0x97C740E2, "reviver_selection_think" },
    { 0x022C41E5, "reviver_think" },
    { 0xF704323C, "revivereaddvarchanges" },
    { 0x5F76A790, "revivergetupanim" },
    { 0x3012E872, "revivergun" },
    { 0x1FC6AC55, "reviverignoreplayerdist" },
    { 0x317F7A05, "reviverignoreplayerdistsq" },
    { 0x83AD7CFC, "reviverpingdist" },
    { 0x1E85DE97, "revivers" },
    { 0xA433A6CD, "revives" },
    { 0x8CA60010, "revivesequenceplayervisibledistsq" },
    { 0xFCA62492, "revivetexthud" },
    { 0x0A7B273D, "revivetime" },
    { 0xF34C2AF5, "revivetimestamps" },
    { 0x3280B628, "revivetotal" },
    { 0x947A3D4D, "revivetotaltext" },
    { 0x273F42DA, "revivetrigger" },
    { 0x90F04404, "revivetriggerradius" },
    { 0x20443BCA, "revivexp" },
    { 0x94E47D73, "reviving" },
    { 0x0CFD1C67, "reviving_bleeder" },
    { 0xD4D5C9BF, "revivingteammate" },
    { 0xCEC847E4, "revolution" },
    { 0x7C662917, "revolutions" },
    { 0xC14EDF6A, "revving" },
    { 0x77DA8EF8, "reward" },
    { 0x6CA14688, "reward_assist_points" },
    { 0xE506C54B, "reward_beacon" },
    { 0x4099D2EC, "reward_count" },
    { 0x25B41D3B, "reward_dist" },
    { 0x7BD2FE26, "reward_double_tap" },
    { 0x135BD5C3, "reward_grab_wait" },
    { 0x102D9CCB, "reward_maxis_vo" },
    { 0x6FA5CA25, "reward_one_inch_punch" },
    { 0xD1F64B7E, "reward_packed_weapon" },
    { 0x5FB3F076, "reward_pickups" },
    { 0x29276681, "reward_players_in_capture_zone" },
    { 0xE3BE24C2, "reward_points" },
    { 0x20D46FD1, "reward_powerup" },
    { 0x51587BA7, "reward_powerup_double_points" },
    { 0x702E0EDF, "reward_powerup_max_ammo" },
    { 0x2BD3EC4F, "reward_powerup_zombie_blood" },
    { 0xE44F9A35, "reward_richtofen_vo" },
    { 0xAEB6A22B, "reward_rise_and_grab" },
    { 0xBFB87DE6, "reward_sink" },
    { 0x7E3ACD2C, "reward_staff_piece" },
    { 0x1138D331, "reward_think" },
    { 0xDEFF7F43, "reward_weapon" },
    { 0xB90797C9, "rewardcp" },
    { 0x7E54210B, "rewarded" },
    { 0xD0F85DD3, "rewarded_lives" },
    { 0x378D7353, "rewards" },
    { 0x2C364B3D, "rewardsthink" },
    { 0x71AD4980, "rewardxp" },
    { 0x4951F314, "rewind" },
    { 0xC6687B74, "rewind_id" },
    { 0x74BC31BB, "rewind_plane" },
    { 0x2F875FB7, "rewinded" },
    { 0x29281EF8, "rewindobjects" },
    { 0xD2CF5887, "rewinds" },
    { 0x2404104C, "rewindwatcher" },
    { 0x268A341B, "rewindwatcherarray" },
    { 0x67BF4810, "rewindwatcherkeys" },
    { 0xAAA4BAD1, "rework" },
    { 0xA4E30E93, "rewrite" },
    { 0xD883C016, "rewriting" },
    { 0xE63E8C47, "rewritten" },
    { 0xC8DDB5D6, "rewritting" },
    { 0xE009585D, "rewrote" },
    { 0x2592A18E, "rex" },
    { 0xD98DACBC, "rez" },
    { 0xD46118D4, "rez_bike" },
    { 0x21DB30E0, "rez_bike_ready" },
    { 0x9BA52041, "rez_bike_start" },
    { 0xD8C259D4, "rez_carjack_open_door" },
    { 0x159AA320, "rez_carjack_setup" },
    { 0x70230532, "rez_e3_start" },
    { 0xA522832D, "rez_e4_start" },
    { 0x76407D70, "rez_e5_start" },
    { 0x984FEAD6, "rez_e7_start" },
    { 0x5BF01A22, "rez_end" },
    { 0xF156DE4D, "rez_eye_org" },
    { 0x3363C259, "rez_finish_dist" },
    { 0x6E600CD0, "rez_outside" },
    { 0xF33A2F84, "rez_speed" },
    { 0xF8F04699, "rez_start" },
    { 0xE9B77ADC, "rez_struct" },
    { 0x2EE64668, "rez_to_player" },
    { 0x82FC67D4, "rez_truck" },
    { 0x085F3082, "rez_truck_gunner" },
    { 0x5122F49D, "rez_truck_gunner_logic" },
    { 0x81EE39D8, "rez_truck_gunner_vacancy" },
    { 0xFA998A9D, "rez_truck_let_player_catchup" },
    { 0xD6141ABC, "rez_truck_tether_logic" },
    { 0xA1F7FA31, "rez_truck_warp" },
    { 0xBF31D9D0, "rez_truck_warp_start" },
    { 0x00DA2B0D, "rez_waited_for_player" },
    { 0x5A67B1D4, "rez_window_bullet_hit" },
    { 0xE2D0D6D0, "reznode" },
    { 0xFD148A0D, "reznov" },
    { 0x88780435, "reznov2" },
    { 0x676E95EC, "reznov_ai_setup" },
    { 0xB6CEC039, "reznov_anim_krav_near" },
    { 0x05AAC613, "reznov_anims_finished" },
    { 0x1585A51E, "reznov_arrived_second_cover" },
    { 0xD8D633FA, "reznov_at_shelf" },
    { 0x9170F9DE, "reznov_behavior" },
    { 0x8EEC1528, "reznov_bike_idle" },
    { 0x113B6851, "reznov_blinded_anim_done" },
    { 0x7EEE8463, "reznov_boat_start_vo" },
    { 0x0BDB96B5, "reznov_cellar_vo" },
    { 0x743FEF5F, "reznov_cheer" },
    { 0x5BC6B2D7, "reznov_close_door" },
    { 0x2A9F2F17, "reznov_closed_the_door" },
    { 0xF78491D3, "reznov_color_chain" },
    { 0x4918EBD9, "reznov_coming" },
    { 0xBD991B31, "reznov_cover" },
    { 0xA08CC7FF, "reznov_cutscene_lookat_update" },
    { 0x507AC34B, "reznov_cutscene_snow_to_fade" },
    { 0x4D5E89EC, "reznov_cutscene_stop_lookat_update" },
    { 0xCF571986, "reznov_dof_setting" },
    { 0x1C0C0190, "reznov_door" },
    { 0x6B5A7DC9, "reznov_door_breach_trig" },
    { 0x38C7E166, "reznov_down_alley" },
    { 0x93BD4786, "reznov_drone" },
    { 0xD0C418A3, "reznov_drown_vc_anim_done" },
    { 0x76AF9E87, "reznov_final_node" },
    { 0x87FC7708, "reznov_fire_at_fake_target" },
    { 0xB12DFCE9, "reznov_flags" },
    { 0xCEA2A058, "reznov_flash_color_chain" },
    { 0xF7C32989, "reznov_get_on_pbr_delay" },
    { 0x952C2789, "reznov_goal" },
    { 0x226B40AE, "reznov_hall_quickanim" },
    { 0x908DDFFF, "reznov_horse" },
    { 0xC8561574, "reznov_index" },
    { 0x1267E297, "reznov_intro_anim_in_lair" },
    { 0x5F52DE13, "reznov_intro_in_lair" },
    { 0x1A0918B9, "reznov_invisible" },
    { 0x50C65DB6, "reznov_is_defined" },
    { 0xBFAC39BB, "reznov_is_talking" },
    { 0x1E325287, "reznov_killed_streetguys" },
    { 0x4DCE670B, "reznov_lab_color_chain" },
    { 0x62B33752, "reznov_leaves_player_controlled_gun" },
    { 0x67A50C4E, "reznov_line" },
    { 0xB0F78AF1, "reznov_lines" },
    { 0x69F2F965, "reznov_mason_pow_vo" },
    { 0x2FC96B51, "reznov_move_up" },
    { 0x85EC2517, "reznov_movie_done" },
    { 0x8B3B88F5, "reznov_movie_play" },
    { 0x0F4D6564, "reznov_node" },
    { 0x1C84C4AE, "reznov_on_tank" },
    { 0xD6F8B65B, "reznov_open_door" },
    { 0x3BDB5E8E, "reznov_outro_anims" },
    { 0xDAFA1928, "reznov_outro_anims_finish" },
    { 0xC500A371, "reznov_outro_attach_book" },
    { 0xEA75F25F, "reznov_outro_detach_book" },
    { 0x1512ED98, "reznov_outro_done" },
    { 0xDE612002, "reznov_outro_speak" },
    { 0xF58C4AA3, "reznov_petrenko_dialog" },
    { 0xD5222936, "reznov_pinned" },
    { 0xB410FF3E, "reznov_pipe_goto" },
    { 0x13F54374, "reznov_pwn_stairdudes" },
    { 0xC38317A5, "reznov_reached_first_cover" },
    { 0xE546CF33, "reznov_ready_to_leave" },
    { 0x031F01AB, "reznov_ready_tojump" },
    { 0x71281DFB, "reznov_rescue" },
    { 0x74433465, "reznov_rescued" },
    { 0x5DFDA08F, "reznov_reveal" },
    { 0xE33415CD, "reznov_reveal_deadguy" },
    { 0x25C45A32, "reznov_reveal_vo_done" },
    { 0x2845102E, "reznov_runoff" },
    { 0x29A9CE6B, "reznov_runs_away" },
    { 0x803199E7, "reznov_setup" },
    { 0x66BFF0D0, "reznov_shore_point" },
    { 0xB8BB92FD, "reznov_slide_started" },
    { 0xB8426D1D, "reznov_spawnfunction" },
    { 0x91297012, "reznov_speech" },
    { 0x5B2EA058, "reznov_speech_end" },
    { 0xCC252852, "reznov_stinger_force_wait" },
    { 0xC2EDF6DB, "reznov_tag_angles" },
    { 0x3B944EB5, "reznov_tag_origin" },
    { 0xE5D784DB, "reznov_talk_trig" },
    { 0x81893577, "reznov_temporary_disappear" },
    { 0xC5552430, "reznov_to_armory" },
    { 0x8C0358C9, "reznov_to_bridge" },
    { 0x52B47220, "reznov_tunnel_setup" },
    { 0x0DBD4A6F, "reznov_unarmed_anims_setup" },
    { 0x337F297B, "reznov_wait_at_stair" },
    { 0xE1D6EF8C, "reznovs" },
    { 0xCDAD5BB4, "reznovtalky_spawnfunction" },
    { 0xEB81F4A1, "rezzed" },
    { 0x2D36B669, "rf" },
    { 0x8E23ACBA, "rfill" },
    { 0x2D255C5C, "rfo" },
    { 0x07343C00, "rg" },
    { 0xE42D5032, "rgb" },
    { 0xABCEACCF, "rgb1" },
    { 0x39C73D94, "rgb2" },
    { 0xE128D34E, "rgb_color" },
    { 0xDF2B1DBD, "rgbs" },
    { 0x075F2A44, "rgm3" },
    { 0xBCA128A9, "rgun" },
    { 0x89A078B8, "rhe" },
    { 0xEA2D5D75, "rhi1" },
    { 0x8D895BC0, "rhi1_amb" },
    { 0x6F7B3A97, "rhi1_anim" },
    { 0xA4217A47, "rhi1_base" },
    { 0x565CDE75, "rhi1_cam" },
    { 0xA27A62F2, "rhi1_fx" },
    { 0xA70D635D, "rhi1_indoor" },
    { 0x6615732E, "rhi1_status" },
    { 0x102FD7DE, "rhi2" },
    { 0x38329B1F, "rhi2_amb" },
    { 0x4E3FFD02, "rhi2_anim" },
    { 0xB3D88CD6, "rhi2_base" },
    { 0xABAAAB82, "rhi2_cam" },
    { 0xB3238B4D, "rhi2_event_bridge" },
    { 0x03F55E4F, "rhi2_event_church" },
    { 0x32845FCB, "rhi2_event_convoywalk" },
    { 0x0829D286, "rhi2_event_sweep" },
    { 0x2EB71A0B, "rhi2_fx" },
    { 0x517465B4, "rhi2_indoor" },
    { 0xB56D2C7B, "rhi2_status" },
    { 0xA76BD211, "rhi2_util" },
    { 0x36325247, "rhi3" },
    { 0xB8587DCA, "rhi3_amb" },
    { 0xE8B8918D, "rhi3_anim" },
    { 0x5DEFE2D1, "rhi3_base" },
    { 0x1BFB2418, "rhi3_fx" },
    { 0xF4977B2F, "rhi3_indoor" },
    { 0x58C24F18, "rhi3_status" },
    { 0x13563646, "rhi3_utility" },
    { 0x86E54C5F, "rhi_dialog_and_anim" },
    { 0x4782AA38, "rhineland" },
    { 0xB68F446A, "rhineland2" },
    { 0x8A9447A5, "rhino_deaths" },
    { 0x2EBCAADC, "rhobust" },
    { 0x0D87B09E, "rhs" },
    { 0x1B56EDBE, "ri" },
    { 0x3746F0E1, "ric_fail_heat" },
    { 0x00AC8815, "ric_fail_out" },
    { 0x2822776F, "ric_fill_lantern_watcher" },
    { 0xA211F4AE, "ric_lantern_ghost_death_watcher" },
    { 0xBCC4B9DE, "rice" },
    { 0xDC6DA37D, "rice_bowl_anim_setup" },
    { 0x9F106ABE, "rice_stop_looping" },
    { 0xB0088E3D, "rice_vc_action" },
    { 0xEC058CA5, "rice_vc_action_complete" },
    { 0x1AA9775B, "rich" },
    { 0xB1943A1B, "rich_complete" },
    { 0x5281316E, "rich_done" },
    { 0x001D26CD, "rich_jetgun_vox_played" },
    { 0x43AB663F, "rich_response" },
    { 0x5A050D9E, "rich_sq_player" },
    { 0x1C15B1B2, "richcompleted" },
    { 0x47E6BA99, "richest" },
    { 0x85A0B236, "richestplayer" },
    { 0x84D1CB8B, "richtofen" },
    { 0xC3D42E31, "richtofen_c_complete" },
    { 0x1EEE61B3, "richtofen_char_index" },
    { 0x9AF22928, "richtofen_char_index_r" },
    { 0x517804BB, "richtofen_pts_instructions" },
    { 0x18AD5EDF, "richtofen_pts_placed" },
    { 0x4F187653, "richtofen_sam_vo" },
    { 0x827D275B, "richtofen_sidequest" },
    { 0xEFABCE0B, "richtofen_sidequest_a" },
    { 0x7DA45ED0, "richtofen_sidequest_b" },
    { 0xA3A6D939, "richtofen_sidequest_c" },
    { 0x83844A1B, "richtofen_sidequest_complete" },
    { 0x50A7FD56, "richtofen_sidequest_complete_check" },
    { 0xAFEEBACB, "richtofen_sidequest_power_state" },
    { 0x6FD1E428, "richtofen_sq_complete" },
    { 0x6511BF57, "richtofen_sq_intro_said" },
    { 0xD2022A63, "richtofen_street" },
    { 0xA7522484, "richtofen_talking" },
    { 0x16C2BFD6, "richtofen_talking_to_samuel" },
    { 0x2EE3B75E, "richtofen_zombie_clear" },
    { 0xD69B353E, "richtofen_zombie_deathfunction_override" },
    { 0x680E6BA3, "richtofen_zombie_vo_watcher" },
    { 0x8F2C143F, "richtofen_zombie_watch_death" },
    { 0x4C165954, "richtofen_zombies_launched" },
    { 0x92121C7D, "richtofenrespondvoplay" },
    { 0x2152C044, "richtofensay" },
    { 0x0C62D741, "ricky" },
    { 0x9C536544, "ricochet_distance" },
    { 0x9C3B24EC, "ricochet_protection" },
    { 0xA0032D7F, "ricochetdistance" },
    { 0xA0D0131E, "rid" },
    { 0xF224D9CB, "ridden" },
    { 0x3B89F4D9, "riddled" },
    { 0x996EB256, "riddles" },
    { 0xC3E9C967, "ride" },
    { 0xE6EA6BCD, "ride_and_shoot" },
    { 0xC2991181, "ride_anim_custom" },
    { 0x62DC9E91, "ride_horse" },
    { 0xD7FC110B, "ride_in_sniper" },
    { 0x52731EDA, "ride_in_sniper_think" },
    { 0x0783AAF5, "ride_smoker" },
    { 0x00219ED2, "ride_start" },
    { 0x1BE37EF5, "ride_to_fight_two" },
    { 0xE97BAD1E, "ride_vehicle" },
    { 0x71CF8028, "rideanim" },
    { 0xC60A0370, "ridedeathanim" },
    { 0xD310AE4D, "rideins" },
    { 0xFB960E47, "rider" },
    { 0x0DBF0BAC, "rider1" },
    { 0x7FC67AE7, "rider2" },
    { 0xE6F6261D, "rider_array" },
    { 0xF61E81EF, "rider_count" },
    { 0x3DEF1200, "rider_died_make_horse_rideable" },
    { 0xA8C8C37E, "rider_drone_toai" },
    { 0x9005B4EA, "rider_droneai" },
    { 0x1B425382, "rider_info" },
    { 0x578CFD08, "rider_initialized" },
    { 0x6C7EA299, "rider_nextanimation" },
    { 0xB0C9327D, "rider_on_count" },
    { 0xDA395A8A, "rider_trigger" },
    { 0x29E2DF1A, "rider_victim" },
    { 0x6F026AD5, "rider_victim_logic" },
    { 0x66D47B17, "rider_walk_setup" },
    { 0xC91D1D56, "riderisaiming" },
    { 0x955801BC, "riderisarmed" },
    { 0x6E32462D, "riderisdead" },
    { 0x39196377, "riderispain" },
    { 0xD925663E, "riders" },
    { 0x75ECDD69, "riders_2_delete" },
    { 0x94557AD3, "riders_check" },
    { 0x1A96BF7A, "riders_godon" },
    { 0x10D185AC, "riders_unloadable" },
    { 0x5E80C93E, "ridershouldjump" },
    { 0x5890E921, "ridershouldland" },
    { 0x5FA8C314, "riderspawners" },
    { 0xD59393DE, "rides" },
    { 0x547D8FA2, "ridge" },
    { 0x29D33CFF, "ridge1" },
    { 0xD4BAF292, "ridge1_spawner_1" },
    { 0xAEB87829, "ridge1_spawner_2" },
    { 0xE23FB8D9, "ridge_flashes" },
    { 0x367E766C, "ridge_mg_cleared" },
    { 0xC8BEE974, "ridge_mg_node" },
    { 0xE6D68D6E, "ridge_rat_hole_closed" },
    { 0xAAC2FF47, "ridge_roof" },
    { 0x95BB427F, "ridge_rooftop_roller" },
    { 0xF307AD2E, "ridge_slider" },
    { 0xBFCD34EA, "ridge_stand_spawner" },
    { 0x54755094, "ridgeline" },
    { 0xE440DC52, "ridgelinepos" },
    { 0x5E6CE26D, "ridges" },
    { 0x36FC12F4, "ridiculous" },
    { 0xAB5ACFB1, "ridiculously" },
    { 0x1990F7A2, "riding" },
    { 0x70D89638, "riding_escape_pod" },
    { 0x8B90A9E4, "riding_geyser" },
    { 0xD7367285, "riding_guys" },
    { 0x5D7659C5, "riding_still" },
    { 0x01F4E9FD, "riding_tank" },
    { 0x4C62F2CA, "ridingtank" },
    { 0x1BF1D32E, "ridingvehicle" },
    { 0x33EB6147, "riese" },
    { 0x28D15FA5, "rifle" },
    { 0xD50E9E02, "rifle_grenade" },
    { 0xF0E47C53, "rifle_grenade_respawn" },
    { 0x5043AB85, "rifle_hip_shooting" },
    { 0x53A28B29, "rifle_penetration_shooting" },
    { 0x9BF4FF7C, "rifle_start" },
    { 0xF322CA8B, "rifle_timed_shooting" },
    { 0x04CBC1B4, "rifle_timed_start" },
    { 0x3E3D8939, "rifleads" },
    { 0xAD5CA539, "riflefire" },
    { 0xFFF4B71B, "rifleman" },
    { 0x93582F47, "riflemen" },
    { 0xF04149CD, "riflemen_spawners" },
    { 0xBD6449B4, "riflerange" },
    { 0xB84B40C0, "riflerangeclose" },
    { 0x93CBE0B4, "rifles" },
    { 0xE9683876, "rifleshoot" },
    { 0xC29D741B, "rifletraining" },
    { 0xD6ADE52D, "rifletraining_end" },
    { 0x5C115D5E, "rifletraining_start" },
    { 0x7ACD98B5, "rig" },
    { 0xF21C9D68, "rig_angles" },
    { 0xB8CDA29F, "rig_model" },
    { 0x28B57F03, "rigged" },
    { 0x8F559EB7, "rigged_watertank_leak" },
    { 0x77A91F97, "righ" },
    { 0x7D6C9041, "right" },
    { 0x11CAA56E, "right0_wind_ent" },
    { 0xED0C427A, "right1" },
    { 0xBF155001, "right1_wind_ent" },
    { 0xC709C811, "right2" },
    { 0xC4A0ED29, "right_aa_gun" },
    { 0x29258EC6, "right_aa_owner" },
    { 0x6CDA9CEE, "right_ai" },
    { 0xF5F551BC, "right_ang" },
    { 0xF32A3315, "right_angle" },
    { 0x7726F573, "right_anim" },
    { 0x560F0281, "right_anim_time" },
    { 0x727801AD, "right_approach_warehouse_soct_trigger" },
    { 0x73E5663C, "right_arc" },
    { 0x3C7E0A62, "right_arm_gibbed" },
    { 0x14670F4F, "right_arm_retracted" },
    { 0xA062CECA, "right_art_target_strat" },
    { 0x905B767A, "right_away" },
    { 0xB75B759B, "right_away_line" },
    { 0xAE211490, "right_barrel" },
    { 0x26C765FF, "right_boards" },
    { 0x87580E3C, "right_buffel" },
    { 0xC070C7B7, "right_camo_squad" },
    { 0xE4A73BEF, "right_chain" },
    { 0xAD84A51E, "right_clip" },
    { 0xB2D4AD31, "right_constraint" },
    { 0x1DCD77B6, "right_crouch" },
    { 0xE2D09319, "right_dir" },
    { 0xAA848F87, "right_direction" },
    { 0x60638EBC, "right_door" },
    { 0x487E6C29, "right_door_balcony" },
    { 0xD0831F29, "right_dot" },
    { 0x721EC813, "right_end" },
    { 0xDA7FAB8B, "right_final_node" },
    { 0xA0F5C500, "right_front_l" },
    { 0x1716E4D6, "right_fx" },
    { 0x8473F5B0, "right_gate_approach" },
    { 0x72899435, "right_goal" },
    { 0x4A3EA713, "right_gong" },
    { 0x8DBB160F, "right_gun_active" },
    { 0x1077927D, "right_guy" },
    { 0xD249ED9D, "right_guys_trig2" },
    { 0x765644D4, "right_house_blowup" },
    { 0x5DDCE702, "right_idle" },
    { 0xD80F9239, "right_in" },
    { 0xD6508D6E, "right_island_guys" },
    { 0xBF2B21CE, "right_knee_armor_health" },
    { 0x4FA265D8, "right_knee_index" },
    { 0xF6496A0D, "right_lane_pullovers" },
    { 0x30473353, "right_large_end" },
    { 0x9A49285A, "right_large_mid" },
    { 0xFA391DB4, "right_launcher" },
    { 0xC25BD567, "right_left" },
    { 0xAF60889D, "right_leg_start" },
    { 0x98705318, "right_lever" },
    { 0xD69B49C9, "right_lever_trigger" },
    { 0x26E699D0, "right_light" },
    { 0xE2B1A30F, "right_lobby_door" },
    { 0x9823C256, "right_look_at_pt" },
    { 0xE7867FDB, "right_loop_trigger" },
    { 0x155CBCB4, "right_mg" },
    { 0xF56D721A, "right_mid" },
    { 0xC170A8FC, "right_mutex_trigger" },
    { 0x10946BF5, "right_offset" },
    { 0xEFF60106, "right_org" },
    { 0xDE1CC12D, "right_org_b" },
    { 0xBAC9DBF0, "right_out" },
    { 0xAAF9D038, "right_path_asd" },
    { 0xE2C45D21, "right_path_blocker_stealth_logic" },
    { 0xEB0F8A5D, "right_path_kill_trig" },
    { 0x6072C054, "right_path_picked" },
    { 0x774FA3D9, "right_path_vo" },
    { 0x4AF32769, "right_pipe1" },
    { 0x70F5A1D2, "right_pipe2" },
    { 0xD8EC0606, "right_point" },
    { 0x0A27F242, "right_pos" },
    { 0x81A410D6, "right_pressed" },
    { 0x2549792F, "right_prop" },
    { 0x1F075C86, "right_rear" },
    { 0xDA4AC0E6, "right_rooftop_enemies" },
    { 0xC06D77D6, "right_rooftop_enemies_d_trigger" },
    { 0xFE07AF22, "right_score" },
    { 0x88897A65, "right_shoulder_armor_health" },
    { 0xB5B3C52D, "right_shoulder_index" },
    { 0x9238C28B, "right_shudder" },
    { 0x7BA2C8A5, "right_side" },
    { 0x0E527395, "right_side_flood_trigger" },
    { 0xD8B39BF9, "right_side_grass_guy_trap_think" },
    { 0xFF378B46, "right_side_pos" },
    { 0x2B19B08F, "right_side_setup" },
    { 0xF8BD82C1, "right_spawn_points" },
    { 0x106B1BC0, "right_spawner" },
    { 0xBA665940, "right_start" },
    { 0x5AA3CCB9, "right_step_chance" },
    { 0x34BBB31E, "right_structs" },
    { 0xC85B8CDF, "right_surround_l" },
    { 0xE164F26C, "right_tag" },
    { 0x58EA788F, "right_target" },
    { 0x285AB654, "right_to_left_ramp" },
    { 0x7C66A9A1, "right_tower_target" },
    { 0x571B657B, "right_triggers" },
    { 0xF050D847, "right_trigs_deleted" },
    { 0xB124B1B5, "right_truck" },
    { 0x91468E72, "right_turn_driver_anim" },
    { 0x367B79DA, "right_turn_passenger2_anim" },
    { 0xC061F574, "right_turn_passenger_anim" },
    { 0x450961C2, "right_turret" },
    { 0x27CB54F5, "right_turret_defend" },
    { 0xF49E98D7, "right_turret_health" },
    { 0x4497520A, "right_turret_owner" },
    { 0xC4B2428A, "right_turret_target" },
    { 0x4ECBE8CC, "right_type" },
    { 0x468C45E4, "right_upgraded" },
    { 0xCDB30522, "right_vec" },
    { 0x06F3C644, "right_vec2" },
    { 0x3B8D6BB2, "right_vect" },
    { 0x4AA649A1, "right_vector" },
    { 0x16D8F19C, "right_vehicle" },
    { 0x2AB5FC3F, "right_wall_destroy" },
    { 0x9E84EE74, "right_weight" },
    { 0xB0A62222, "right_wind0_id" },
    { 0x73FA436D, "right_wind1_id" },
    { 0x6E236698, "right_wind_vol" },
    { 0xFED3E9AD, "right_wing" },
    { 0x71B43646, "right_wing_origin" },
    { 0x264B9619, "right_wing_position" },
    { 0x0425BC54, "right_x" },
    { 0x4D99BA11, "rightaimlimit" },
    { 0x7F350C5D, "rightamount" },
    { 0xB16B4ADE, "rightangle" },
    { 0x4539F8B6, "rightanim" },
    { 0x6F3E816F, "rightarc" },
    { 0xBB437641, "rightarm" },
    { 0xAD23D932, "rightarmgibbed" },
    { 0xAC85D0EB, "rightarmlost" },
    { 0x1DF12B5E, "rightarmor" },
    { 0x44B4907C, "rightarmorhudelem" },
    { 0xC82602CA, "rightatt" },
    { 0x91A97691, "rightchance" },
    { 0x5EBBFF4A, "rightclawambientfx" },
    { 0x7C5A5896, "rightclawchargefx" },
    { 0xCF0F6EAE, "rightdir" },
    { 0xC7D211A5, "rightdooropen" },
    { 0xE7E9A7AB, "rightdraw" },
    { 0xA89553E5, "rightermost" },
    { 0x3C6B44AA, "rightful" },
    { 0x93DEDB64, "rightgate" },
    { 0x3AD36AA8, "rightglowfx" },
    { 0x9FE2FDE8, "rightguard" },
    { 0xD1FA66AC, "rightgunmodel" },
    { 0x0B12CFB6, "righthand" },
    { 0xD5943B86, "righthitfx" },
    { 0xD24C97BE, "righticon" },
    { 0x39E0F843, "rightindex" },
    { 0x20CF1323, "rightjukedistance" },
    { 0x09D818DB, "rightleftblend" },
    { 0x7A7F377C, "rightleggibbed" },
    { 0x38D9CDA1, "rightlooklimit" },
    { 0xE5C65358, "rightmost" },
    { 0xC60646B1, "rightnode" },
    { 0x1B50CD18, "rightnodes" },
    { 0xAAA13EE8, "rightoffset" },
    { 0x49D30B48, "rightposition" },
    { 0x2068B368, "rights" },
    { 0x9165C5FD, "rightscanarea" },
    { 0x057ACD35, "rightscore" },
    { 0x5D62C25F, "rightshutters" },
    { 0x8F14A30E, "rightsize" },
    { 0x853F37CB, "righttentacle" },
    { 0x5A670AF5, "righttreadhealth" },
    { 0xAF5BDA30, "rightturn" },
    { 0x1B1349DD, "rightvec" },
    { 0x0D232C3E, "rightvecdot" },
    { 0x2EE76355, "rightweight" },
    { 0x12F7DBD4, "rigin" },
    { 0x75663684, "rigs" },
    { 0xF39B01D2, "riight" },
    { 0xD4BC9303, "riiinnnggg" },
    { 0x96BEBA3F, "rim" },
    { 0xD402408B, "rimlighting" },
    { 0x699AB583, "ring" },
    { 0x69C72F01, "ring_cooldown" },
    { 0xCAF287C5, "ring_move" },
    { 0x20F572C0, "ring_pos" },
    { 0x9A862DF6, "ring_stop" },
    { 0xE48DA73F, "ring_toss" },
    { 0xFADF290E, "ring_toss_prize" },
    { 0xA7FD5CDD, "ringing" },
    { 0x80421322, "ringoff" },
    { 0x65FF6312, "rintln" },
    { 0xD6525303, "riot" },
    { 0x073969EF, "riot_shield_array" },
    { 0xFEE7726C, "riotshield" },
    { 0x2FEC294D, "riotshield_activation_watcher_thread" },
    { 0xCFEFD5C9, "riotshield_active" },
    { 0x374E1E29, "riotshield_at_node_dist_sq" },
    { 0x2368E975, "riotshield_bracket" },
    { 0xC6948090, "riotshield_clamp" },
    { 0x70A15DAF, "riotshield_craftable" },
    { 0x27FABE24, "riotshield_damage" },
    { 0x40FE6136, "riotshield_damage_absorb_callback" },
    { 0xDC21DB2E, "riotshield_damage_callback" },
    { 0x9366B9F4, "riotshield_damage_score_max" },
    { 0xFF9A425F, "riotshield_damage_score_threshold" },
    { 0xBB601BE8, "riotshield_damaged" },
    { 0x9FF8B6FB, "riotshield_death" },
    { 0xD2629EAC, "riotshield_debug_print" },
    { 0x05327682, "riotshield_deploy_anim" },
    { 0x2ED0DB61, "riotshield_destroy_anim" },
    { 0xC5395759, "riotshield_dolly" },
    { 0xB2C078B7, "riotshield_door" },
    { 0x9EF23668, "riotshield_fastwalk_off" },
    { 0x3866F982, "riotshield_fastwalk_on" },
    { 0x341306C3, "riotshield_flinch_count_to_stagger" },
    { 0x907602A7, "riotshield_flinch_reset_time" },
    { 0x1B4BB24E, "riotshield_fling_enemies" },
    { 0x7430D3E0, "riotshield_fling_func" },
    { 0x886F319F, "riotshield_fling_vecs" },
    { 0x9B9D9B74, "riotshield_fling_zombie" },
    { 0x205278EC, "riotshield_get_enemies_in_range" },
    { 0xDD62C0C2, "riotshield_get_juke_enemies_in_range" },
    { 0x32C99892, "riotshield_gib_enemies" },
    { 0xA88C7A68, "riotshield_gib_refs" },
    { 0x61CDF187, "riotshield_handle_pain_notetracks" },
    { 0xDF298077, "riotshield_health_clientfield" },
    { 0x0E42F4AF, "riotshield_hidden" },
    { 0x68EAC8A8, "riotshield_hint_message" },
    { 0xAC01EE54, "riotshield_hint_timeout" },
    { 0xE9F7883E, "riotshield_juke_distance" },
    { 0xAF4AA80B, "riotshield_juke_kill_halfwidth" },
    { 0x1CB275A2, "riotshield_juke_kill_halfwidth_sq" },
    { 0xC31BE847, "riotshield_juke_kill_vert_limit" },
    { 0xAFB27988, "riotshield_knockdown_enemies" },
    { 0x7EE63F72, "riotshield_knockdown_func" },
    { 0x28DE0466, "riotshield_knockdown_gib" },
    { 0x0550E076, "riotshield_knockdown_zombie" },
    { 0x1018AEC5, "riotshield_melee" },
    { 0xF9E0085B, "riotshield_melee_juke" },
    { 0x72C07C3F, "riotshield_melee_juke_callback" },
    { 0x3296B953, "riotshield_melee_power" },
    { 0x34574022, "riotshield_model" },
    { 0x57E54EB3, "riotshield_move_delay_max" },
    { 0xDAD090BD, "riotshield_move_delay_min" },
    { 0xBD59915B, "riotshield_move_dist_height" },
    { 0xFBECA124, "riotshield_move_dist_max" },
    { 0xE948628A, "riotshield_move_dist_min" },
    { 0x78607B65, "riotshield_move_dist_spacing" },
    { 0x06DB10AE, "riotshield_name" },
    { 0xCEA518EE, "riotshield_network_choke" },
    { 0x75BBA292, "riotshield_network_choke_count" },
    { 0x4A20B55A, "riotshield_offset" },
    { 0xF14D45FA, "riotshield_placement_zoffset" },
    { 0x4A21511D, "riotshield_planted" },
    { 0x445276A4, "riotshield_run_dist_sq" },
    { 0xC2C1DBA5, "riotshield_sprint_off" },
    { 0x192FC819, "riotshield_sprint_on" },
    { 0xA8E345F7, "riotshield_state_deployed" },
    { 0x07E2A6A2, "riotshield_state_destroyed" },
    { 0x5EBD48C7, "riotshield_supports_deploy" },
    { 0xB91D3B15, "riotshield_tag" },
    { 0x369FA450, "riotshield_top" },
    { 0x4864B65F, "riotshield_turn_into_regular_ai" },
    { 0xC43440F7, "riotshield_tutorial_hint" },
    { 0xD2233827, "riotshield_weapon" },
    { 0xA94AB46C, "riotshield_zm_taken" },
    { 0xCCBB71B3, "riotshield_zombie_damage_response" },
    { 0x8FF24C5C, "riotshieldadvanceonenemyservice" },
    { 0x93198A84, "riotshieldbuildable" },
    { 0x64075986, "riotshieldclearflinchcount" },
    { 0xFE4F3306, "riotshieldcraftable" },
    { 0x00B12197, "riotshielddamageoverride" },
    { 0x892FDA7A, "riotshielddeployanim" },
    { 0x1A2F547D, "riotshielddestroyanim" },
    { 0xED584961, "riotshielddistancetest" },
    { 0x172A610D, "riotshieldentity" },
    { 0x23FE9C46, "riotshieldincrementflinchcount" },
    { 0xF6B6CD67, "riotshieldkilledoverride" },
    { 0xF517BD96, "riotshieldmeleeanimback" },
    { 0xC4E85378, "riotshieldmeleeanimfront" },
    { 0xEF5BD70A, "riotshieldmovemode" },
    { 0x97D02621, "riotshieldnoncombatlocomotioncondition" },
    { 0xF7CC1E84, "riotshieldretrievetrigger" },
    { 0x439A4E6F, "riotshields" },
    { 0xB508C912, "riotshieldshotanimback" },
    { 0xBF1231DC, "riotshieldshotanimfront" },
    { 0xD32282D7, "riotshieldshouldflinch" },
    { 0x05E70F8D, "riotshieldshouldtacticalwalk" },
    { 0x32695B48, "riotshieldtacticalwalkstart" },
    { 0x7AC627C5, "riotshieldtakeweapon" },
    { 0x7FAC4805, "riotshieldtrackingstart" },
    { 0x27823C66, "riotshieldunarmedadvanceonenemyservice" },
    { 0xE8D37BCE, "riotshieldunarmedtargetservice" },
    { 0x68EDD00A, "rip" },
    { 0x8A69CFC8, "rip_vermin" },
    { 0xF46B02F1, "ripped" },
    { 0x6F9D1592, "ripped_awning" },
    { 0x048DE9D2, "ripping" },
    { 0x95039D3F, "ripple" },
    { 0x9E84C37C, "ripple_pos" },
    { 0x2A91544E, "rise" },
    { 0x0E16338F, "rise_anim_finished" },
    { 0x4D70C126, "rise_dust_fx" },
    { 0x73ADCF53, "rise_huey_think" },
    { 0x3061EC43, "rise_locations" },
    { 0x53A2EE22, "rise_struct_string" },
    { 0xDBC5824C, "rise_target_name" },
    { 0x23C78C6E, "rise_to_surface" },
    { 0x5DCBF489, "rise_to_surface_hueys" },
    { 0x2D082574, "risen" },
    { 0x2A8A27F7, "riseoverrun" },
    { 0x64EA6888, "riser" },
    { 0x54CA75DF, "riser_fx_on_client" },
    { 0x3347D5F7, "riser_type" },
    { 0xB69309A3, "risers" },
    { 0x73E65144, "risers_use_low_gravity_fx" },
    { 0x8AECE2F1, "rises" },
    { 0x9DA96E67, "rising" },
    { 0x49C8A67F, "rising_watch" },
    { 0x166EA290, "risk" },
    { 0x50F80023, "risked" },
    { 0xB258FE7B, "risks" },
    { 0x9667DCF1, "risky" },
    { 0x01DB59B8, "ritual" },
    { 0xBBB76D0D, "riv1" },
    { 0xE1B9E776, "riv2" },
    { 0x07BC61DF, "riv3" },
    { 0xAE6BA8DB, "rival" },
    { 0x4A858682, "rival_append" },
    { 0x8B94ED31, "rival_player" },
    { 0x3B37D8C8, "rivalry" },
    { 0x904E7ED9, "river" },
    { 0x51C486FD, "river1_spawner_array_1" },
    { 0x77C70166, "river1_spawner_array_2" },
    { 0x584A5CC4, "river_amb" },
    { 0x7EE0F47B, "river_anim" },
    { 0x0EC1F76B, "river_art" },
    { 0x376A11BF, "river_barge" },
    { 0x14A0742F, "river_boat_drag" },
    { 0x8E42E34B, "river_bunker" },
    { 0x4DC95344, "river_corpse_manager" },
    { 0x7096A6CC, "river_dialog" },
    { 0x476EF09C, "river_done" },
    { 0xAABEB54D, "river_drag_util" },
    { 0x5C517E34, "river_drive" },
    { 0xBD2DA0EC, "river_drones_trigger" },
    { 0x4C15FFF5, "river_exit_trig" },
    { 0x95E6A529, "river_features" },
    { 0x1DCFE9F1, "river_finale" },
    { 0xF87C0340, "river_friendly_fire" },
    { 0xD1211BB9, "river_friendly_fire_attacker_override" },
    { 0x733585DE, "river_fx" },
    { 0xEBAD7D67, "river_halfway_dialog" },
    { 0x0C2830E8, "river_heli_attack_animation" },
    { 0x79F42E1C, "river_heli_crash" },
    { 0xEC91721A, "river_heli_delete" },
    { 0x68030887, "river_hind" },
    { 0x4BCC3414, "river_hind_damage_override" },
    { 0x149DB49F, "river_hut" },
    { 0x13108D98, "river_hut_explo" },
    { 0x5B3C5B92, "river_intro" },
    { 0xA807FE6F, "river_jungle" },
    { 0xF0400A83, "river_main" },
    { 0x3B1F5E1B, "river_mortar_attack_boats_event" },
    { 0x6A19C33F, "river_mortar_objective_complete" },
    { 0x7A6BD7AF, "river_mortor_move" },
    { 0xB7351414, "river_pacing" },
    { 0x2C595E3D, "river_pacing_beat_begins_trigger" },
    { 0xDE1170BF, "river_pacing_done" },
    { 0xFA99AA81, "river_pacing_start" },
    { 0x1C2AE7F2, "river_plane" },
    { 0x758EE4CC, "river_rail" },
    { 0xD44D0388, "river_util" },
    { 0xA7842DF1, "river_vo" },
    { 0x2A17CFE8, "river_walk_underwater_fog" },
    { 0x28A8B296, "riverbed" },
    { 0xCF57E8F1, "riverbed_ambient_scenes" },
    { 0x8F244525, "riverbed_anims" },
    { 0x2978A5ED, "riverbed_blocker" },
    { 0xE85BB5D3, "riverbed_contrast" },
    { 0xD1840463, "riverbed_convoy" },
    { 0x3F18E6B4, "riverbed_convoy_buffel_savannah_start" },
    { 0xA3322522, "riverbed_convoy_think" },
    { 0x4B78FBEF, "riverbed_dialogue" },
    { 0x3D9B9532, "riverbed_exposure" },
    { 0xA7A41D2C, "riverbed_fail_kill" },
    { 0x4F7B2D18, "riverbed_fail_warning" },
    { 0x30AC9C85, "riverbed_fail_watch" },
    { 0xF1755D86, "riverbed_get_random_vehicle" },
    { 0x63B6DFD9, "riverbed_intro" },
    { 0xF7DD7024, "riverbed_intro_buffel" },
    { 0x2AAE269E, "riverbed_intro_convoy" },
    { 0x7AFF4C4A, "riverbed_intro_mortars" },
    { 0x3E81A94B, "riverbed_intro_player" },
    { 0xE55E3A73, "riverbed_lockbreaker_perk" },
    { 0x670C8C31, "riverbed_mortars" },
    { 0x16C7EDE8, "riverbed_savimbi" },
    { 0x75A60052, "riverbed_savimbi_intro_buffel" },
    { 0x17C5484F, "riverbed_skipto" },
    { 0x0DE3D9E9, "riverbed_sky_intensity_factor_0" },
    { 0xE7E15F80, "riverbed_sky_intensity_factor_1" },
    { 0x97EC3BF8, "riverbed_soldiers_move_up" },
    { 0x05B766C8, "riverside" },
    { 0x5949CF3F, "riverwalk_enemies" },
    { 0xF3D237FD, "rivulet1" },
    { 0x19D4B266, "rivulet2" },
    { 0x3FD72CCF, "rivulet3" },
    { 0xBF38928F, "rivulets" },
    { 0xC1CD85E2, "rkilled" },
    { 0xA94F7E83, "rl" },
    { 0x2B99244A, "rleft" },
    { 0xB28F3C77, "rma" },
    { 0x2D2F1B13, "rn0" },
    { 0xE12A2641, "rn2" },
    { 0xE5AFF867, "rnd" },
    { 0xE7AD802A, "rndprk_ent" },
    { 0xF3B962A5, "rnode" },
    { 0xF79334EF, "rnum" },
    { 0x37480F48, "ro" },
    { 0x56225FFB, "roach_fx_setup" },
    { 0xC17145D8, "roach_fx_single" },
    { 0x9490D78C, "roaches" },
    { 0xFEEC8637, "road" },
    { 0x167E9ED0, "road_allies" },
    { 0xD583C421, "road_allies_exposed" },
    { 0x40C108D1, "road_axis" },
    { 0x1051664D, "road_axis_interrupt" },
    { 0x963DA8DF, "road_axis_proximity" },
    { 0x7C635349, "road_block" },
    { 0xFE143133, "road_bridge_wait" },
    { 0x6C4283F6, "road_field" },
    { 0x6B183CE3, "road_field_cleanup" },
    { 0x46676478, "road_field_clear" },
    { 0xFDD4320B, "road_friendly" },
    { 0x82839013, "road_guy" },
    { 0x743587A2, "road_guy_attack" },
    { 0x4F33D642, "road_guys" },
    { 0xE7C01999, "road_helicopter" },
    { 0x588BA80B, "road_helicopter_clear" },
    { 0x9C359428, "road_idle_guy" },
    { 0xA85C7CBF, "road_reset_speed" },
    { 0xFF577AE7, "road_roadblock" },
    { 0xC1F82A6D, "road_roadblock_anim" },
    { 0x4A07FCA3, "road_roadblock_guy" },
    { 0xE91864AB, "road_roadblock_interrupt" },
    { 0xB4059BDB, "road_runners" },
    { 0x1CFBDFD9, "road_safe" },
    { 0x4D89E942, "road_start" },
    { 0x3B164957, "roadbloack" },
    { 0xBFAB93BE, "roadblock" },
    { 0x0442CA2B, "roadblock_behavior" },
    { 0xCD5422D6, "roadblock_vehicles" },
    { 0x97239C73, "roadblock_vehicles_dead" },
    { 0x94282D1B, "roadblock_wind" },
    { 0xF42CA7A1, "roadblocks" },
    { 0x5ECEC163, "roadguys" },
    { 0x4B321C6E, "roads" },
    { 0x978648CD, "roadzone" },
    { 0xA8D63886, "roam" },
    { 0x1300AF77, "roam_index" },
    { 0x0458906C, "roam_points" },
    { 0xA7EE0E9A, "roaming" },
    { 0xD7D0F5EA, "roaming_bmp" },
    { 0xBAB60131, "roar" },
    { 0x3623DF1F, "roar_effect" },
    { 0x2DC10F6C, "roated" },
    { 0x365CB5AF, "robbed" },
    { 0xA518A395, "robert" },
    { 0xCD69A81F, "robot" },
    { 0xDE9FC9A9, "robot_artillery_barrage" },
    { 0xFAEDA53B, "robot_backshot_multiplier" },
    { 0x13D93310, "robot_choose_cover_chance" },
    { 0x6D90C212, "robot_crawl_max_distance" },
    { 0xF0C77781, "robot_cycling" },
    { 0xD29B7DEE, "robot_destruct_death_chance" },
    { 0x18E24F52, "robot_destruct_max_death_pieces" },
    { 0x77F7C672, "robot_detonation_damage_type" },
    { 0x1C2FEC2C, "robot_detonation_inner_damage" },
    { 0x70840BAB, "robot_detonation_outer_damage" },
    { 0x551D7F63, "robot_detonation_range" },
    { 0x3605343F, "robot_diameter" },
    { 0x585EE8FF, "robot_emp_bits" },
    { 0xF3670DB2, "robot_emp_clientfield" },
    { 0xAE70A86D, "robot_emp_fx" },
    { 0x1E16FE42, "robot_emp_fx_file" },
    { 0xAB151340, "robot_emp_fx_tag" },
    { 0xE03FCD2A, "robot_emp_off" },
    { 0x02CCCDFC, "robot_emp_on" },
    { 0x5758875B, "robot_emp_shutdown_time" },
    { 0x0EE23053, "robot_emp_type" },
    { 0x35D088FE, "robot_escort_max_radius" },
    { 0xA8DA52AC, "robot_escort_min_radius" },
    { 0x1AF07B4F, "robot_fire_at_player_flag" },
    { 0xD1AAF42C, "robot_foot_stomp" },
    { 0x3268B420, "robot_fx_base" },
    { 0x912A2595, "robot_fx_base_flicker" },
    { 0x6B2E9B4F, "robot_fx_death" },
    { 0x4BA7FDE8, "robot_fx_rogue_level_1" },
    { 0xCA9F5D7D, "robot_fx_rogue_level_1_flicker" },
    { 0xBDAF6D23, "robot_fx_rogue_level_2" },
    { 0x91960A7E, "robot_fx_rogue_level_2_flicker" },
    { 0x97ACF2BA, "robot_fx_rogue_level_3" },
    { 0x5796DD83, "robot_fx_rogue_level_3_flicker" },
    { 0xDB1BB46D, "robot_gib_head_death_chance" },
    { 0x8A0CF954, "robot_gib_head_explosion_chance" },
    { 0xD3555195, "robot_gib_head_headshot_chance" },
    { 0x255992CD, "robot_gib_health_threshold" },
    { 0x102BE24E, "robot_gib_leg_health_threshold" },
    { 0xFCC6A6C3, "robot_gib_legs_chance" },
    { 0x31CCB8BA, "robot_gib_legs_death_chance" },
    { 0x4B4E903B, "robot_gib_legs_explosion_chance" },
    { 0x82DB0807, "robot_gib_limb_death_chance" },
    { 0xD702FE0E, "robot_gib_limb_explosion_chance" },
    { 0x30DDA878, "robot_head_gib_fx" },
    { 0xB76A5469, "robot_head_gib_fx_file" },
    { 0x70AA6D19, "robot_head_gib_fx_tag" },
    { 0x62339BCC, "robot_head_trigger_think" },
    { 0xA1E79842, "robot_headshot_multiplier" },
    { 0x696639DF, "robot_height" },
    { 0x3109438F, "robot_invalid_cover_distance" },
    { 0xA056C011, "robot_juke_distance" },
    { 0x077C7B44, "robot_juke_max_distance" },
    { 0xAC19E908, "robot_juke_preemptive_max_distance" },
    { 0x8D3B17EC, "robot_jump_direction" },
    { 0xDDCB9389, "robot_lights" },
    { 0x27806B5C, "robot_lights_bits" },
    { 0x0E2A38D7, "robot_lights_clientfield" },
    { 0xBFD8B192, "robot_lights_death" },
    { 0x45C39E18, "robot_lights_flicker" },
    { 0xFB123C9C, "robot_lights_hacked" },
    { 0x5BF4344B, "robot_lights_off" },
    { 0x818802F7, "robot_lights_on" },
    { 0xBD823F24, "robot_lights_type" },
    { 0x71B599F0, "robot_locomotion_type" },
    { 0xBF3C6E73, "robot_mind_control_bits" },
    { 0xD63F7F06, "robot_mind_control_clientfield" },
    { 0x6A5B906B, "robot_mind_control_explosion_bits" },
    { 0xECCDAA6E, "robot_mind_control_explosion_clientfield" },
    { 0x1FD17799, "robot_mind_control_explosion_fx" },
    { 0x3CCDB7E6, "robot_mind_control_explosion_fx_file" },
    { 0xA1035CB4, "robot_mind_control_explosion_fx_tag" },
    { 0x1378284E, "robot_mind_control_explosion_off" },
    { 0x93E9D9A0, "robot_mind_control_explosion_on" },
    { 0x1B804347, "robot_mind_control_explosion_type" },
    { 0x74ABE24E, "robot_mind_control_level_0" },
    { 0x9AAE5CB7, "robot_mind_control_level_1" },
    { 0x28A6ED7C, "robot_mind_control_level_2" },
    { 0x4EA967E5, "robot_mind_control_level_3" },
    { 0x7EFE7DCF, "robot_mind_control_type" },
    { 0xB1F2AD70, "robot_mini_raps_auto_detonate_max_time" },
    { 0xD70B763E, "robot_mini_raps_auto_detonate_min_time" },
    { 0x8BDB7634, "robot_mini_raps_link_to_bone" },
    { 0x4C0FB040, "robot_mini_raps_model" },
    { 0x3D3E3F56, "robot_mini_raps_offset_position" },
    { 0xE691FAE3, "robot_mini_raps_spawner" },
    { 0xF83235EF, "robot_mode" },
    { 0x55266EED, "robot_navmesh_max_tolerance_levels" },
    { 0x6581E182, "robot_navmesh_tolerance" },
    { 0x499B0EDF, "robot_off_cover_node_max_distance" },
    { 0x6A2A0965, "robot_off_cover_node_min_distance" },
    { 0x398D6364, "robot_pause_tactical_walk" },
    { 0x9CE34878, "robot_phalanx" },
    { 0x9C7F821A, "robot_position_query_move_dist_max" },
    { 0x88F253A3, "robot_position_query_radius" },
    { 0xCAF1CBD1, "robot_resume_cover_time" },
    { 0x31394C0C, "robot_rusher_distance_sq" },
    { 0x46CA48B2, "robot_rusher_max_enemy_distance_sq" },
    { 0x6AA39C33, "robot_rusher_max_radius" },
    { 0x4B04C735, "robot_rusher_min_radius" },
    { 0x9A3BAC1B, "robot_rusher_neighbor_distance_sq" },
    { 0x49D9C689, "robot_state" },
    { 0xBA5F7F2E, "robot_step_in" },
    { 0x287205B2, "robot_stomped" },
    { 0x876F5544, "robot_super_sprint_distance" },
    { 0xB8C44594, "robot_tactical_juke_radius" },
    { 0x0C4C9A9B, "robot_traversal_type" },
    { 0xF63FFB82, "robot_walk_animation" },
    { 0x80BD31AA, "robot_walk_min_distance" },
    { 0x44D2D469, "robot_walk_min_distance_sq" },
    { 0x3F2D4ECB, "robot_wallrun_direction" },
    { 0x1606F7EC, "robotabletoshootcondition" },
    { 0xE86E2430, "robotbecomecrawler" },
    { 0xC43DE971, "robotcalcproceduraltraversal" },
    { 0xEA3247AC, "robotcanjuke" },
    { 0x2ED3E6D5, "robotcanpreemptivejuke" },
    { 0x35881CBF, "robotcantacticaljuke" },
    { 0xF007A52C, "robotchoosecoverdirection" },
    { 0xD91B1D6A, "robotclaimed" },
    { 0xAF565AB7, "robotcleanupchargemeleeattack" },
    { 0x76183701, "robotclientutils" },
    { 0xEC68FA10, "robotcoveroverinitialize" },
    { 0xAC961AC7, "robotcoveroverterminate" },
    { 0xFDCCE33D, "robotcoverscaninitialize" },
    { 0xED94B640, "robotcoverscanterminate" },
    { 0x50E1258E, "robotcrawlercanshootenemy" },
    { 0xF4DF422E, "robotcrawlerservice" },
    { 0x060251D0, "robotdamageoverride" },
    { 0x7153EA3F, "robotdeathoverride" },
    { 0xE40E2997, "robotdelaymovement" },
    { 0xE2FDA40B, "robotdeployminiraps" },
    { 0x6F89AEDF, "robotdeploywasp" },
    { 0xF6B76749, "robotdestructdeathoverride" },
    { 0x543A4A79, "robotdestructrandompieces" },
    { 0xC4F96403, "robotdie" },
    { 0x89B67CC0, "robotdonttakecover" },
    { 0xF45ED894, "robotdropstartingweapon" },
    { 0xBC98E049, "robotemphandler" },
    { 0x785AD63B, "robotempidleinitialize" },
    { 0xF8D2F222, "robotempidleterminate" },
    { 0x2356A116, "robotempidleupdate" },
    { 0x312F4715, "robotendjumpdirection" },
    { 0x8494E898, "robotequipminiraps" },
    { 0x1BD4C3B2, "robotexplode" },
    { 0xA668D043, "robotexplodeterminate" },
    { 0x49486993, "robotexposedcoverservice" },
    { 0x6A7D7354, "robotforcecrawler" },
    { 0x4AB7AC39, "robotgetgibbedlimbs" },
    { 0x8F8AB878, "robotgibdamageoverride" },
    { 0xD6FF5077, "robotgibdeathoverride" },
    { 0x4F8DCBB1, "robotgivewasp" },
    { 0xDBD2BC7E, "robothascloseenemytomelee" },
    { 0xF8AE9BAC, "robothasenemytomelee" },
    { 0x11E35A7F, "robotic" },
    { 0xA5D273E5, "robotically" },
    { 0xADABFF90, "robotinterface" },
    { 0xCE18C301, "robotinvalidatecover" },
    { 0xD7D69A6C, "robotisatcovercondition" },
    { 0x253494F7, "robotisatcovermodescan" },
    { 0x467F7305, "robotiscrawler" },
    { 0x7B40DD18, "robotismarching" },
    { 0x8184B7D1, "robotismindcontrolled" },
    { 0xE33B1E75, "robotismoving" },
    { 0xF2DC2B1E, "robotjukeinitialize" },
    { 0x144D8A6B, "robotlighting" },
    { 0x84BC3EBC, "robotlights" },
    { 0xB2DCE1C8, "robotlightsflicker" },
    { 0x0A827DA8, "robotlightshandler" },
    { 0x6B67969B, "robotlightsoff" },
    { 0x3B409B27, "robotlightson" },
    { 0xCA2E3F4D, "robotlocomotionspeed" },
    { 0x0B6BA589, "robotmindcontrolexplosionhandler" },
    { 0x8EAA219E, "robotmindcontrolhandler" },
    { 0x9C869F88, "robotmovement" },
    { 0x9F706ADA, "robotmovemodeattributecallback" },
    { 0xA1A88C73, "robotnocloseenemyservice" },
    { 0x07F4D977, "robotnode" },
    { 0x07FD6AB7, "robotoutsidesprintrange" },
    { 0xBC2252D0, "robotoutsidesupersprintrange" },
    { 0x3339ADBB, "robotoutsidetacticalwalkrange" },
    { 0x3BC9E3B7, "robotphalanx" },
    { 0xB57C4AC3, "robotpositionservice" },
    { 0x213B7EB6, "robotpreemptivejuketerminate" },
    { 0xD5D87D50, "robotprepareforadjusttocover" },
    { 0x283C0CF4, "robotprocedurallandingupdate" },
    { 0xA442E283, "robotproceduraltraversalupdate" },
    { 0x0B7604A6, "robotroguehascloseenemytomelee" },
    { 0x421ED8A4, "robotroguehasenemytomelee" },
    { 0x3E0A8858, "robotrushenemyservice" },
    { 0xC00EC0A4, "robotrushermaxradius" },
    { 0xB4C72016, "robotrusherminradius" },
    { 0xBF253144, "robotrushneighborservice" },
    { 0x422E7CA6, "robots" },
    { 0xBA0B95E5, "robotscanexposedpainterminate" },
    { 0x67B49D31, "robotsetupwallrunjump" },
    { 0x51B0BAF6, "robotsetupwallrunland" },
    { 0x4B79E029, "robotshouldadjusttocover" },
    { 0xE7C6BBD3, "robotshouldbecomecrawler" },
    { 0x9FCECA26, "robotshouldchargemelee" },
    { 0x7B1BF82D, "robotshouldexplode" },
    { 0x032AB11E, "robotshouldgibdeath" },
    { 0xBEA02AE6, "robotshouldmelee" },
    { 0xB8CEEDC5, "robotshouldproceduraltraverse" },
    { 0x751AE449, "robotshouldreactatcover" },
    { 0x56495D04, "robotshouldshutdown" },
    { 0x846F2F66, "robotshouldtacticalwalk" },
    { 0x73B783D9, "robotshouldwallrun" },
    { 0x271FBEB5, "robotsoldierbehavior" },
    { 0x8509E91D, "robotsoldierserverutils" },
    { 0x23CFE26F, "robotsoldierspawnsetup" },
    { 0x7EAEE72C, "robotstartjumpdirection" },
    { 0xCA914469, "robotstartsprint" },
    { 0xEE1443A6, "robotstartsupersprint" },
    { 0xBA043E7E, "robotsupportsovercover" },
    { 0x1538394F, "robottacticalwalkactionstart" },
    { 0x32D4D3A1, "robottargetservice" },
    { 0x7D1A51F7, "robottookempdamage" },
    { 0x62AC19BC, "robottraversalattributecallback" },
    { 0x1D5E46FB, "robottraversaltype" },
    { 0xD4473CB8, "robottraverseend" },
    { 0xFEFDE9C9, "robottraverseragdollondeath" },
    { 0xE6F0D3DB, "robottraversestart" },
    { 0xD4856404, "robottryreacquireservice" },
    { 0xEF054A85, "robotwallrunend" },
    { 0xB41EA7E6, "robotwallrunstart" },
    { 0x74575538, "robotwallruntraverse" },
    { 0x55141515, "robotwithinsprintrange" },
    { 0x81C33582, "robotwithinsupersprintrange" },
    { 0x9BAC9CD5, "robuck" },
    { 0x09B0B732, "robust" },
    { 0x3C03855A, "rock" },
    { 0xD9167367, "rock1" },
    { 0x670F042C, "rock2" },
    { 0x8D117E95, "rock3" },
    { 0xA5054143, "rock_attack_mortar" },
    { 0xC4127AF6, "rock_break_anim_1" },
    { 0x9E10008D, "rock_break_anim_2" },
    { 0x780D8624, "rock_break_anim_3" },
    { 0x0B34A328, "rock_debris_sound" },
    { 0xF9DEBFF9, "rock_emissive_fade" },
    { 0x01D08AD1, "rock_emissive_think" },
    { 0xBC3B6D3B, "rock_ents" },
    { 0xDE5AFB4F, "rock_fx" },
    { 0x44ED484C, "rock_slide" },
    { 0xA2421DE5, "rock_slide_fx" },
    { 0xAE7FA2C2, "rock_the_base" },
    { 0xED35ECD5, "rock_wall" },
    { 0xC850302D, "rock_wall_barricade" },
    { 0x979AB77D, "rocket" },
    { 0x9F64B8CE, "rocket1" },
    { 0x79623E65, "rocket2" },
    { 0xE28F65B5, "rocket_aiming_at_target" },
    { 0x3AE4CFCE, "rocket_align_x" },
    { 0x50DD03CF, "rocket_ammo_think" },
    { 0x7DC13BE4, "rocket_amount" },
    { 0x8348F2CB, "rocket_arm_think" },
    { 0xEEAC9024, "rocket_barrage" },
    { 0x3C54B421, "rocket_barrage_ai_was_hit" },
    { 0xAEF0297D, "rocket_barrage_allowed" },
    { 0x6A62486A, "rocket_barrage_at_major_target" },
    { 0x167D96E4, "rocket_barrage_bunker_was_hit" },
    { 0xDB9AFEE0, "rocket_barrage_check_if_ai_hit" },
    { 0xB3600DF1, "rocket_barrage_confirm" },
    { 0x663EE467, "rocket_barrage_fire" },
    { 0xC6026C7F, "rocket_barrage_fire_watch" },
    { 0x8BE5B6A9, "rocket_barrage_fired_at_time" },
    { 0xF3C11573, "rocket_barrage_firing_positions" },
    { 0xEA39AE6A, "rocket_barrage_first_barrage" },
    { 0x149B1D59, "rocket_barrage_friendly_fire_count" },
    { 0x006BE865, "rocket_barrage_generic_fire_count" },
    { 0x4C7D20EF, "rocket_barrage_hit_ai_count" },
    { 0x7F5C42A2, "rocket_barrage_hud_elements_show" },
    { 0x765C915F, "rocket_barrage_hud_elements_think" },
    { 0xEDA61955, "rocket_barrage_init" },
    { 0x1BEE802E, "rocket_barrage_max_x" },
    { 0x41F0FA97, "rocket_barrage_max_y" },
    { 0x89641B0C, "rocket_barrage_min_x" },
    { 0xAF669575, "rocket_barrage_min_y" },
    { 0xA081DEDA, "rocket_barrage_no_zones" },
    { 0x69C17741, "rocket_barrage_ok" },
    { 0x665642FD, "rocket_barrage_player_init" },
    { 0x4E4ACBF8, "rocket_barrage_radio_guy" },
    { 0xC32AAA74, "rocket_barrage_ready_count" },
    { 0x37B4FA51, "rocket_barrage_recharging_count" },
    { 0xB8A3D308, "rocket_barrage_redshirts_go" },
    { 0x709D1467, "rocket_barrage_switch_back" },
    { 0xDE440094, "rocket_barrage_target" },
    { 0xC4D8EC4C, "rocket_barrage_target_player" },
    { 0xB8995CD4, "rocket_barrage_targeting" },
    { 0xCBDA9907, "rocket_barrage_targets" },
    { 0xC3F6D519, "rocket_barrage_vehicle_was_hit" },
    { 0x05430049, "rocket_barrage_watcher" },
    { 0xF0BD1682, "rocket_barrages_remaining" },
    { 0x9B4CDCEF, "rocket_base" },
    { 0xDCC396CE, "rocket_blast" },
    { 0xE256CA89, "rocket_bottom" },
    { 0xA87FEC85, "rocket_btn_x" },
    { 0x827D721C, "rocket_btn_y" },
    { 0x2BE8036C, "rocket_button" },
    { 0x7344C771, "rocket_cam_end_struct" },
    { 0x355EBF64, "rocket_cam_start_struct" },
    { 0x19CA4EAD, "rocket_camera" },
    { 0xA4A640EF, "rocket_camera_ent" },
    { 0x4AEC56EE, "rocket_can_be_destroyed" },
    { 0x72B8DBDC, "rocket_center_point" },
    { 0xC569E6CC, "rocket_clamps" },
    { 0x9D1851D2, "rocket_clamps_distant" },
    { 0x0E4A02A7, "rocket_cleanupondeath" },
    { 0xE69BFC58, "rocket_collision" },
    { 0xA3211E2D, "rocket_count" },
    { 0x1217BA3C, "rocket_counter" },
    { 0x079FDE93, "rocket_damage" },
    { 0xD0396826, "rocket_damage_stop" },
    { 0x92CDFF52, "rocket_damage_think" },
    { 0xFBC264E1, "rocket_damage_time" },
    { 0x67196D51, "rocket_damage_triggers" },
    { 0x28FBE4FD, "rocket_debris" },
    { 0x959ED43C, "rocket_debris_fire" },
    { 0x903C3219, "rocket_debris_fire_start" },
    { 0xEF628D65, "rocket_debris_fire_trig" },
    { 0x4E819DFF, "rocket_decal" },
    { 0x1BA6D542, "rocket_delta" },
    { 0x595C4D51, "rocket_delta_dist" },
    { 0x4F0DFD8C, "rocket_dest" },
    { 0x808D8661, "rocket_destroyed" },
    { 0xDE92CBF9, "rocket_destroyed_for_achievement" },
    { 0x48EDBB2B, "rocket_distant" },
    { 0xDB755DCD, "rocket_dyn_bottom" },
    { 0x37D58A51, "rocket_dyn_bottom_destroyed" },
    { 0xD46DC373, "rocket_dyn_bottom_orig" },
    { 0x490E106B, "rocket_dyn_bottom_s" },
    { 0xE1DFBF35, "rocket_dyn_top" },
    { 0x8BAFE429, "rocket_dyn_top_destroyed" },
    { 0x638BE57B, "rocket_dyn_top_orig" },
    { 0x6EDC89AF, "rocket_earthquake" },
    { 0xADFEAAD1, "rocket_end_struct" },
    { 0x3D3457B1, "rocket_entity" },
    { 0x55D00C75, "rocket_exp2" },
    { 0x7D1C58D9, "rocket_exp_1" },
    { 0xBA7D852B, "rocket_expl" },
    { 0x25731DFF, "rocket_explode" },
    { 0xB6309AC2, "rocket_fake_fire" },
    { 0xA866263B, "rocket_fall" },
    { 0xA0BED4BE, "rocket_fall_start" },
    { 0x1370380D, "rocket_fire_damage_trigger" },
    { 0x26C32230, "rocket_fired" },
    { 0x81E5578A, "rocket_fx" },
    { 0xD81DF8CD, "rocket_gantry" },
    { 0xCCA2BCA6, "rocket_guy_targets_bmp" },
    { 0x52FB9411, "rocket_hall" },
    { 0x8EFB7BC7, "rocket_hall_american_destruction" },
    { 0x08F48107, "rocket_hall_bypassed" },
    { 0x574B7AB0, "rocket_hall_cleanup" },
    { 0x17BAD016, "rocket_hall_play_death_anims" },
    { 0x6C382730, "rocket_hall_rpg_fire" },
    { 0x439EA0F8, "rocket_hall_rpgs" },
    { 0x452239FB, "rocket_hall_setup" },
    { 0xAB4301D4, "rocket_hall_switch_team" },
    { 0x56D85C5C, "rocket_hall_terrorist_spawnfunc" },
    { 0x24524853, "rocket_hall_terrorist_switch_team" },
    { 0xF373F5B9, "rocket_hall_vo" },
    { 0xA4389378, "rocket_hall_xm25_carrier_spawn_func" },
    { 0xEC18D485, "rocket_hall_yemeni_run_in" },
    { 0x936F7A4D, "rocket_hall_yemeni_spawnfunc" },
    { 0x08C9C690, "rocket_hall_zone_hit" },
    { 0xD464A462, "rocket_handle" },
    { 0xC657B97F, "rocket_hit" },
    { 0x6096EB88, "rocket_hits_ground" },
    { 0xD584E2A1, "rocket_horizalign" },
    { 0x57088EBB, "rocket_hud" },
    { 0x5A3E2582, "rocket_hud_elem_background" },
    { 0x5ABF1171, "rocket_hud_elem_foreground" },
    { 0x85B4DD11, "rocket_ice_1" },
    { 0xABB7577A, "rocket_ice_2" },
    { 0xD1B9D1E3, "rocket_ice_3" },
    { 0xF7BC4C4C, "rocket_ice_4" },
    { 0x0E12CC43, "rocket_icon" },
    { 0xB250F482, "rocket_icon_x" },
    { 0xD8536EEB, "rocket_icon_y" },
    { 0x035D29E4, "rocket_index" },
    { 0x67749464, "rocket_is_destroyed" },
    { 0x00145AA3, "rocket_is_destroyed_by_crossbow" },
    { 0x80A85F5B, "rocket_kills" },
    { 0x4F448FDF, "rocket_l_pos" },
    { 0xE8EAAC79, "rocket_launch" },
    { 0xA57F518A, "rocket_launch_abort" },
    { 0x46FAD70E, "rocket_launch_display" },
    { 0xF0280068, "rocket_launch_start" },
    { 0x5162D550, "rocket_launcher_min_dist" },
    { 0xB928652C, "rocket_left_most_point" },
    { 0xC2D4BD25, "rocket_migs_flyby" },
    { 0xDE0676C7, "rocket_move" },
    { 0x9E253AA9, "rocket_name" },
    { 0x6FF4D9C9, "rocket_normal" },
    { 0xC00F5950, "rocket_num" },
    { 0x7FE5BD33, "rocket_number" },
    { 0x9D163836, "rocket_ok" },
    { 0x7AA511A9, "rocket_on_target" },
    { 0x471B7F83, "rocket_orig" },
    { 0x05D490B6, "rocket_origin" },
    { 0xF31525D7, "rocket_panel_rattle_01" },
    { 0xA133E922, "rocket_panel_rattle_01_start" },
    { 0x810DB69C, "rocket_panel_rattle_02" },
    { 0x92C45EB9, "rocket_panel_rattle_02_start" },
    { 0xDC4EE729, "rocket_planes" },
    { 0x67FC9AA1, "rocket_pod" },
    { 0x9965AC84, "rocket_pod_angles" },
    { 0x9EC03315, "rocket_pod_offset" },
    { 0x5362BE82, "rocket_pod_origin" },
    { 0x408A6E48, "rocket_pods" },
    { 0xC5E1581E, "rocket_pos" },
    { 0x88B9CE1F, "rocket_powering_up" },
    { 0xD48513F4, "rocket_powering_up_dialogue" },
    { 0x4045C326, "rocket_prelaunch" },
    { 0x72AA24F1, "rocket_r_pos" },
    { 0x2C5C5990, "rocket_raise" },
    { 0xF15998BB, "rocket_regen" },
    { 0x03CF11AF, "rocket_reload" },
    { 0x476B863A, "rocket_reload_button" },
    { 0xDFAC9191, "rocket_reloading" },
    { 0x953AEF4F, "rocket_rumble" },
    { 0xEF84129B, "rocket_rumble_when_close" },
    { 0x48217C74, "rocket_runble_end" },
    { 0x6FB9F789, "rocket_salvo" },
    { 0x0ECEEE9F, "rocket_screens" },
    { 0x74DF048C, "rocket_separation" },
    { 0xED53639F, "rocket_shield_hint_shown" },
    { 0xA571CDA5, "rocket_shield_hint_text" },
    { 0x239A77D3, "rocket_shield_hint_timer" },
    { 0x44BA1B4D, "rocket_sound" },
    { 0xFC2BA42F, "rocket_source" },
    { 0xBBD50801, "rocket_stabilizer_distant" },
    { 0x9F7D9B04, "rocket_start" },
    { 0x8F892444, "rocket_start_struct" },
    { 0x18A494CB, "rocket_sticky_grenade_think" },
    { 0xEBF4CC20, "rocket_strike_user_notify" },
    { 0xB8C364D0, "rocket_tag" },
    { 0x848838E8, "rocket_tag_left" },
    { 0x0D590CB7, "rocket_tag_right" },
    { 0x7C8994BB, "rocket_tags" },
    { 0xEAD40880, "rocket_takeoff" },
    { 0xE2BFF0B5, "rocket_takeoff_start" },
    { 0x270BF37E, "rocket_takeoff_vo" },
    { 0xF4AC9D3B, "rocket_target" },
    { 0x204215C8, "rocket_target1" },
    { 0x92498503, "rocket_target2" },
    { 0x62C04B23, "rocket_targeting_on" },
    { 0x1975569C, "rocket_test" },
    { 0x9B6F5990, "rocket_text_x" },
    { 0xC171D3F9, "rocket_text_y" },
    { 0x1599C468, "rocket_think" },
    { 0xA728EBCF, "rocket_thrusters_initialize" },
    { 0xB785034B, "rocket_time" },
    { 0xB54D1570, "rocket_timer_init" },
    { 0xEC6CE1B1, "rocket_top" },
    { 0x2D94C947, "rocket_vo_obj" },
    { 0x94A7A823, "rocket_wall_angles_offset" },
    { 0x4AC3A295, "rocket_wall_blocked_count" },
    { 0x6A8FFA0D, "rocket_wall_origin_offset" },
    { 0x05FEAA23, "rocket_wave" },
    { 0x59CB4FD6, "rocket_wave_done" },
    { 0x67FDF15E, "rocket_wave_rocket" },
    { 0x069D22AC, "rocket_weapon" },
    { 0x20D9BC25, "rocket_workers" },
    { 0xB725AA62, "rocket_zone" },
    { 0x5C05FE94, "rocketaim" },
    { 0x5B41FC7D, "rocketangles" },
    { 0xF109F4B0, "rocketattachpos" },
    { 0x9165C02D, "rocketbarrage_tracelength" },
    { 0x01883FE0, "rocketcamera" },
    { 0x79E7FD2E, "rocketcooldown" },
    { 0x18C0B4A2, "rocketcount" },
    { 0xE9BF975A, "rocketdamage" },
    { 0xF063D0CA, "rocketdamageoneshot" },
    { 0x474DD144, "rocketdamagetwoshot" },
    { 0x205AFFB0, "rockethit" },
    { 0xF20E321B, "rockethits" },
    { 0x02A27B2F, "rocketindex" },
    { 0xA5C0E005, "rocketlauncher" },
    { 0xB3027019, "rocketlauncherads" },
    { 0xB2766C99, "rocketlauncherfire" },
    { 0xA6D4F494, "rocketlauncherrange" },
    { 0xFE2D7320, "rocketlauncherrangeclose" },
    { 0x799713E3, "rocketman" },
    { 0x0A8487D8, "rocketman_death_save" },
    { 0x317F1B13, "rocketman_open_shutters" },
    { 0x5B301361, "rocketman_remove_sightblockers" },
    { 0x8F832B04, "rocketman_target_tank" },
    { 0xCD49D92F, "rocketmen" },
    { 0x7B3B324C, "rocketmen_init" },
    { 0xA3961699, "rocketmen_spawntrig" },
    { 0x064B9D7C, "rocketmensn" },
    { 0xAB0B1CE4, "rocketmodel" },
    { 0x62B38D73, "rocketorigin" },
    { 0x7F765721, "rocketrefiretime" },
    { 0x919036DF, "rocketregentime" },
    { 0x47F94BCD, "rocketreloadtime" },
    { 0xD3FE5E3C, "rockets" },
    { 0xD39CED49, "rockets_are_out_times" },
    { 0xFB863F67, "rockets_done" },
    { 0xBAF940F9, "rockets_fired" },
    { 0xCB53A1CE, "rockets_launch" },
    { 0x23265884, "rockets_recharged" },
    { 0x3F27646A, "rocketshield" },
    { 0x1E8A8280, "rocketshield_model" },
    { 0x02BC9AF8, "rocketshield_name" },
    { 0x716307F9, "rocketshield_refill_on_max_ammo" },
    { 0x91A700A9, "rocketshield_weapon" },
    { 0x3203774C, "rocketshield_weapon_upgraded" },
    { 0xA77B3C1F, "rocketstart" },
    { 0xC0741E14, "rocketstart1" },
    { 0x327B8D4F, "rocketstart2" },
    { 0x0C7912E6, "rocketstart3" },
    { 0x9289B11B, "rocketstartorg" },
    { 0x03A84F03, "rocketstokill" },
    { 0x2DEF545F, "rockettag" },
    { 0x75D9D9E6, "rockettags" },
    { 0x42349216, "rockettarp" },
    { 0x07D7CA36, "rockettraveldelay" },
    { 0x8590EC29, "rocketvisible" },
    { 0xC9ED055D, "rocketz" },
    { 0x073E9E53, "rockin" },
    { 0x0C72E455, "rocks" },
    { 0x3CA95F7D, "rocks_failed_time" },
    { 0x780670E3, "rocks_pacing_start_time" },
    { 0x6C382499, "rockslide" },
    { 0xA3D12150, "rockslides" },
    { 0x02618B76, "rockx" },
    { 0x286405DF, "rocky" },
    { 0xB65C96A4, "rockz" },
    { 0x2767DF5C, "rod" },
    { 0x7EA19030, "rod_cooldown_time" },
    { 0x201FAE47, "rod_hint_cooldown_ms" },
    { 0xE9F78D40, "rod_precache" },
    { 0x18F63AEA, "rod_projectile" },
    { 0x69B2B94A, "rod_victims" },
    { 0xC9930817, "rod_weapon" },
    { 0xB2CC7BB9, "rode" },
    { 0xE0809B23, "rode_tank_around_map" },
    { 0x36B3B39F, "rods" },
    { 0x4D6A59C5, "roe" },
    { 0x06A460AC, "roebuck" },
    { 0x566F34F5, "roebuck_dialogue_cmon_time" },
    { 0xCD9ABE8D, "roebuck_goal_pos" },
    { 0xB34291AF, "roebucks" },
    { 0x736CD42E, "rof" },
    { 0x5D0FAAFA, "roger" },
    { 0x1C6CC0F5, "rogue" },
    { 0xA5521E9B, "rogue_allow_predestruct" },
    { 0x7E9528F7, "rogue_control" },
    { 0x6BCEFE9B, "rogue_control_force_goal" },
    { 0x22B937CB, "rogue_control_speed" },
    { 0xA7A8E487, "rogue_melee_weapon" },
    { 0xB8AFD119, "roguecontrolattributecallback" },
    { 0x31598E4D, "roguecontrolforcegoalattributecallback" },
    { 0x42F0CD77, "roguecontrolled" },
    { 0xBD55D65E, "roguecontrolspeedattributecallback" },
    { 0x3C357BA1, "role" },
    { 0xE61F2DF0, "roll" },
    { 0xB93F71C9, "roll1" },
    { 0xDF41EC32, "roll2" },
    { 0x237B85C3, "roll_amount" },
    { 0xB52B4205, "roll_anim_rate" },
    { 0x4876BF22, "roll_asm_state" },
    { 0x67DB1333, "roll_degree" },
    { 0x7FF21C44, "roll_dir" },
    { 0x10443A76, "roll_direction" },
    { 0xC9A8A34E, "roll_distance" },
    { 0x59AD086B, "roll_done" },
    { 0x3234ED48, "roll_left" },
    { 0x92709E6B, "roll_point" },
    { 0x5614CE97, "roll_right" },
    { 0x54763522, "roll_sea_entity" },
    { 0x485905B8, "roll_speed" },
    { 0x99EB1034, "roll_time" },
    { 0xE4133F3C, "roll_track" },
    { 0xAC1C4C4B, "roll_up_door" },
    { 0x73C75510, "roll_vel" },
    { 0x8F9C18D9, "rollangle" },
    { 0x789581CB, "rollanimweight" },
    { 0xBF417D83, "rolled" },
    { 0x6B6E18E5, "roller" },
    { 0x1E5AC3F4, "roller_deathfunc" },
    { 0x70148A5D, "rollin" },
    { 0x02F52A68, "rolling" },
    { 0xC1D418BE, "rolling_door1_01" },
    { 0x9BD19E55, "rolling_door1_02" },
    { 0x84C88FB6, "rolling_door_2_01" },
    { 0x5EC6154D, "rolling_door_2_02" },
    { 0x9DA8BB78, "rolling_door_2_guy" },
    { 0xCA8F2E10, "rolling_door_ai" },
    { 0x4B7749DE, "rolling_door_button" },
    { 0x9F6BC57F, "rolling_door_guy" },
    { 0x351EBFAE, "rollingdeath" },
    { 0xDCD1470E, "rollover" },
    { 0x84A5CC5B, "rolls" },
    { 0xADB731F3, "rollsign" },
    { 0x6F53EE98, "rollspot" },
    { 0x3B08BACB, "rolltime" },
    { 0xB2228D17, "rolltop_door_open" },
    { 0x09F5C067, "rollup" },
    { 0x6B235F41, "rollup_door_audio" },
    { 0xE22DF1B0, "rollweight" },
    { 0x8EB7253A, "rollz" },
    { 0x1D56867D, "rom" },
    { 0x325FD7C0, "romo" },
    { 0x1DAEDB6B, "roof" },
    { 0x6E1BB983, "roof_ai1_spawnfunc" },
    { 0x606D9208, "roof_ai2_spawnfunc" },
    { 0x0BA79C19, "roof_ai_stage1_dead" },
    { 0x2027D1A4, "roof_ai_stage2_dead" },
    { 0xD55DFF5B, "roof_ambient_runner" },
    { 0x17EB2383, "roof_ambient_runner_shoot" },
    { 0xD7F742DD, "roof_ambient_runner_spawners_delete" },
    { 0x1DB017B6, "roof_arty" },
    { 0xC2F48DC9, "roof_attack_node" },
    { 0x644B8438, "roof_battle" },
    { 0x03715058, "roof_connector_zone" },
    { 0xB462E263, "roof_coop_linkto_flagbearer" },
    { 0x55F94115, "roof_crawlers" },
    { 0x76DBC4FA, "roof_door" },
    { 0x35371A29, "roof_door_col" },
    { 0x818D84B8, "roof_fighters" },
    { 0x60B7B925, "roof_flag_init" },
    { 0xA3013739, "roof_flagbearer_plant" },
    { 0x54585342, "roof_flagbearer_shot" },
    { 0xB73B1D28, "roof_flagbearer_shot_reaction" },
    { 0xC5A76E91, "roof_guard" },
    { 0x4CC774FF, "roof_guy" },
    { 0x56D30C74, "roof_guy1" },
    { 0xC8DA7BAF, "roof_guy2" },
    { 0x46AD67C4, "roof_guy_fall_on_death" },
    { 0xAC38024B, "roof_guys1" },
    { 0x3A309310, "roof_guys2" },
    { 0x3093FABD, "roof_guys_die" },
    { 0x95D9374F, "roof_guys_wake_up" },
    { 0xA100F8CC, "roof_jumper_logic" },
    { 0x8EE7B815, "roof_katyusha_fire" },
    { 0xDF60185D, "roof_katyushas" },
    { 0x30D2E44F, "roof_mantle_debug" },
    { 0x65C0CBCA, "roof_mantle_think" },
    { 0x86D289AD, "roof_minigame" },
    { 0x3A269FA6, "roof_nag_vo" },
    { 0x97971652, "roof_no_death_last_stand" },
    { 0x8F5C235E, "roof_no_death_last_stand_internal" },
    { 0x9D48BCDA, "roof_node" },
    { 0x2917FEE6, "roof_outro_aianims" },
    { 0x36BC8EE4, "roof_outside_dialogue" },
    { 0x7167E7EE, "roof_panzer_behaviour" },
    { 0x17E51FAE, "roof_panzer_guy" },
    { 0x31738C0E, "roof_panzer_guy_behaviour" },
    { 0x8DF89230, "roof_parts" },
    { 0x4A9B68C2, "roof_paths" },
    { 0xB2751E65, "roof_planes_fire_guns_watcher" },
    { 0xC3BDF40E, "roof_shreks" },
    { 0x03B2C539, "roof_sniper_spawners" },
    { 0xC11304C3, "roof_spawner_think" },
    { 0xB565A4E6, "roof_statue_anim" },
    { 0x386A9DEB, "roof_statue_dialogue" },
    { 0x0CC4A67E, "roof_statue_dialogue_done" },
    { 0x21172756, "roof_statue_fall" },
    { 0x7B45EE2D, "roof_statue_hitground" },
    { 0xE01CB82B, "roof_stop_laststand" },
    { 0x8368930E, "roof_tag" },
    { 0xD8FA54DF, "roof_top" },
    { 0x81113CD4, "roof_top_ai" },
    { 0x6069E1DC, "roof_trig" },
    { 0x36FC0E46, "roof_trigger" },
    { 0x444E0316, "roofboard1" },
    { 0x1E4B88AD, "roofboard2" },
    { 0xF8490E44, "roofboard3" },
    { 0xD24693DB, "roofboard4" },
    { 0xD86143A1, "roofjoint" },
    { 0xEB1E3D4A, "roofs" },
    { 0x59A9CA49, "roofspawner" },
    { 0x7546BA88, "rooftop" },
    { 0x27F6DC6D, "rooftop_ai_individual_objective" },
    { 0x04DBE1E7, "rooftop_ai_setup" },
    { 0x127D5C55, "rooftop_battle" },
    { 0xB5C0345E, "rooftop_battle_advance" },
    { 0xAD148588, "rooftop_battle_dialog" },
    { 0x5894FFD7, "rooftop_battle_jumpto" },
    { 0x5F323984, "rooftop_blocker_logic" },
    { 0xDAE37923, "rooftop_claw_dead" },
    { 0xD8A74ADD, "rooftop_claw_death_watch" },
    { 0x90D06E46, "rooftop_clear" },
    { 0x4778D8C9, "rooftop_cleared" },
    { 0xD22CC52D, "rooftop_drone_killed" },
    { 0x2D79CF94, "rooftop_exploder" },
    { 0xFD95EB93, "rooftop_fail_timeout" },
    { 0xEFB621ED, "rooftop_fog" },
    { 0xB41FC1C8, "rooftop_germ_behaviour" },
    { 0x480A0720, "rooftop_germans" },
    { 0xBD136A45, "rooftop_guards_alerted" },
    { 0x24C1CCB0, "rooftop_guy" },
    { 0xFAAB8AB8, "rooftop_guy_killed" },
    { 0x5843A65C, "rooftop_guys_func" },
    { 0x13BF54A0, "rooftop_last_logic" },
    { 0x5C5D4BBD, "rooftop_light" },
    { 0x5BF4FD7E, "rooftop_meeting_convoy_start" },
    { 0x71E4E8A7, "rooftop_meeting_event" },
    { 0x40F32C7D, "rooftop_meeting_harper_pathing" },
    { 0x039B138C, "rooftop_meeting_scene_setup_think" },
    { 0x4AAD47B8, "rooftop_meeting_talkers_done" },
    { 0x1259BCBE, "rooftop_melee_bloodfx" },
    { 0xF3C82395, "rooftop_melee_knifeout" },
    { 0xF5A30579, "rooftop_objective_counter" },
    { 0x7E42952F, "rooftop_rappel" },
    { 0x9F11DFC2, "rooftop_setup" },
    { 0x433DFB1A, "rooftop_shooter_logic" },
    { 0x3BDD063C, "rooftop_spawners" },
    { 0x1C9C3B05, "rooftop_spotlight_target_move" },
    { 0x4C2C7D7A, "rooftop_timescale" },
    { 0xC907DABF, "rooftop_tracers" },
    { 0x70E2C388, "rooftop_traversal_logic" },
    { 0x78E06BA1, "rooftop_trig" },
    { 0x2E967BDD, "rooftopclaw" },
    { 0x1731BA35, "rooftoplocs" },
    { 0x77E81FA3, "rooftops" },
    { 0x90F7CEBB, "rooftops2" },
    { 0x17BCECF6, "rooftops_one" },
    { 0xC8492337, "rooker" },
    { 0xDBBB3F78, "room" },
    { 0x259FBDC1, "room1" },
    { 0x1D94DFC7, "room_1_guys" },
    { 0x206F21A9, "room_1_vc_death" },
    { 0x0C47F718, "room_breach" },
    { 0x18F846E2, "room_cams_cleanup" },
    { 0xB5B6A054, "room_cams_init" },
    { 0xD4C0FC07, "room_cams_left_on" },
    { 0x2E790F9C, "room_cams_right_on" },
    { 0x224DDBF6, "room_clear" },
    { 0x7B4374EC, "room_dir_struct" },
    { 0xC35FF84B, "room_enforcer" },
    { 0x2165D142, "room_name" },
    { 0x0E30628D, "room_names" },
    { 0xF4F65CF1, "room_runners_think" },
    { 0x42344A20, "room_spawning" },
    { 0x7A51BD90, "room_sweeper" },
    { 0x28102391, "room_trig" },
    { 0xEF7385FF, "roomarray" },
    { 0x7F57882F, "roomclear" },
    { 0xE0D56046, "roomcollidercent" },
    { 0xB5328E04, "roomkeys" },
    { 0x2337AA11, "roomname" },
    { 0xF2434CD3, "rooms" },
    { 0x215675B1, "roomtonefadeouttimerthread" },
    { 0x6DAECD80, "roomtype" },
    { 0x7B27C0DB, "rooom" },
    { 0x6B1F4496, "roost" },
    { 0x71824009, "root" },
    { 0xD742D1EB, "root_anim" },
    { 0x7B70DFAE, "root_level" },
    { 0x9478943F, "root_level_index" },
    { 0x2B61C398, "root_weapon" },
    { 0x44B65A6E, "rootanim" },
    { 0xD25E26BF, "rootbeer" },
    { 0xA5EDD100, "roots" },
    { 0x54136DEC, "rootslash" },
    { 0x8C02D299, "rootweapon" },
    { 0x6B326E38, "rootweaponname" },
    { 0xF8DA4D25, "rope" },
    { 0x5E7D5046, "rope1" },
    { 0x0ABB99FC, "rope1_end" },
    { 0x20428F23, "rope1_end_attached" },
    { 0xF16315D7, "rope1_start" },
    { 0x387AD5DD, "rope2" },
    { 0x12785B74, "rope3" },
    { 0xEC75E10B, "rope4" },
    { 0xC67366A2, "rope5" },
    { 0xA070EC39, "rope6" },
    { 0x6C172F41, "rope_1" },
    { 0x9219A9AA, "rope_2" },
    { 0xB81C2413, "rope_3" },
    { 0xDE1E9E7C, "rope_4" },
    { 0x7D130687, "rope_anim" },
    { 0x4103C4E1, "rope_assistant_think" },
    { 0xE24AF254, "rope_building_anchor" },
    { 0x9554312C, "rope_cut_failed" },
    { 0xE9A7C0A0, "rope_cut_success" },
    { 0x2BC9BE2A, "rope_dropped" },
    { 0xE321CC17, "rope_end" },
    { 0xA2950B34, "rope_end_pos" },
    { 0x4050C78B, "rope_glow" },
    { 0xBD28AE86, "rope_gun" },
    { 0x50DBBEAC, "rope_guy_think" },
    { 0x92DCD960, "rope_guys" },
    { 0x831C2505, "rope_hook" },
    { 0x1546038F, "rope_id" },
    { 0x130FDD7B, "rope_idle_finished" },
    { 0xCE81BEE4, "rope_l" },
    { 0x9B26993C, "rope_length" },
    { 0x1704394F, "rope_model_anim_setup" },
    { 0xC6F85B57, "rope_mover_1" },
    { 0x54F0EC1C, "rope_mover_2" },
    { 0x7AF36685, "rope_mover_3" },
    { 0x08EBF74A, "rope_mover_4" },
    { 0x8147279F, "rope_mover_chinook" },
    { 0xAA9E8EA7, "rope_obj" },
    { 0x12B843EA, "rope_r" },
    { 0x18C5B82D, "rope_ready" },
    { 0x0D6D88A0, "rope_seg1" },
    { 0x7F74F7DB, "rope_seg2" },
    { 0x59727D72, "rope_seg3" },
    { 0xCB79ECAD, "rope_seg4" },
    { 0xA5777244, "rope_seg5" },
    { 0x177EE17F, "rope_seg6" },
    { 0x3C134570, "rope_shoot_think" },
    { 0x06762B54, "rope_sounds" },
    { 0xBE6A69DB, "rope_spawn_and_animate" },
    { 0x6D4A80FC, "rope_start" },
    { 0x2347E77F, "rope_start_pos" },
    { 0x7DEA0233, "rope_time" },
    { 0x6754C6CE, "rope_vignette" },
    { 0x2EE79280, "ropeaddentityanchor" },
    { 0x4B589D8D, "ropeaddworldanchor" },
    { 0x8D423081, "ropecollide" },
    { 0x4FE12702, "ropegetposition" },
    { 0x2D5AC21E, "ropeid" },
    { 0xD7B2F9D8, "ropeid2" },
    { 0x603A054E, "ropeidleend" },
    { 0x196C3F8C, "ropemodel" },
    { 0x45849FB6, "roperemoveanchor" },
    { 0x91D9C134, "ropes" },
    { 0x3F2D85D2, "ropesdeployedanimtime" },
    { 0x80A6512D, "ropesetflag" },
    { 0xA4036CDE, "ropesetparam" },
    { 0xE4D44103, "ropesfallanimtime" },
    { 0xB2E71CF0, "roping" },
    { 0x79F05161, "rorg" },
    { 0x684C3DB4, "rose" },
    { 0xBC1FA252, "ross" },
    { 0xC74038CC, "rot" },
    { 0xBC92D73D, "rot1" },
    { 0x1FF744D3, "rot14" },
    { 0xE29551A6, "rot2" },
    { 0x9D88F66B, "rot21" },
    { 0x0897CC0F, "rot3" },
    { 0x4222D6FF, "rot32" },
    { 0xAA18ED5B, "rot36" },
    { 0xFE867330, "rot4" },
    { 0x47E053FF, "rot47" },
    { 0x4A8B6802, "rot6" },
    { 0x91141527, "rot69" },
    { 0x708DE26B, "rot7" },
    { 0xC6A4301C, "rot8" },
    { 0x89FE4DFB, "rot87" },
    { 0xECA6AA85, "rot9" },
    { 0x5FE93657, "rot98" },
    { 0xD5E9E164, "rot_angle" },
    { 0x938726EF, "rot_scale" },
    { 0x16D20F68, "rot_time" },
    { 0xD13D119C, "rot_vel" },
    { 0x3E539EE1, "rot_x" },
    { 0x18512478, "rot_y" },
    { 0x8A5893B3, "rot_z" },
    { 0x77512DCF, "rotacc" },
    { 0x76255044, "rotang" },
    { 0xF64FF055, "rotar" },
    { 0x01BA58A4, "rotars" },
    { 0x5E27103B, "rotary_styles" },
    { 0x48C21154, "rotate" },
    { 0x2E036F52, "rotate180time" },
    { 0x2EB6C796, "rotate_amount_per_second" },
    { 0xDEC2E17C, "rotate_angle" },
    { 0x580FDDB6, "rotate_barge" },
    { 0xB772BA96, "rotate_blades" },
    { 0xA9563834, "rotate_button_pressed" },
    { 0x916A7E0E, "rotate_buttons" },
    { 0x42B24477, "rotate_continuously" },
    { 0x914C1716, "rotate_crane_container" },
    { 0xBEDA45D2, "rotate_dead_piece" },
    { 0x7E6E9F7E, "rotate_dish_gears" },
    { 0xE671777F, "rotate_dish_top" },
    { 0x3EE83A86, "rotate_doors" },
    { 0x7887A607, "rotate_extra_cam" },
    { 0x980FB684, "rotate_forever" },
    { 0x991E90FA, "rotate_fwd" },
    { 0x6C0313AE, "rotate_highlight_loop" },
    { 0x3E8EC016, "rotate_highlighted" },
    { 0xE72C5D27, "rotate_indefinitely" },
    { 0x522FD170, "rotate_key_forever" },
    { 0x780BBEDD, "rotate_light_yaw" },
    { 0x61B5C310, "rotate_lights" },
    { 0xFA4FC58A, "rotate_model" },
    { 0xF27C1E47, "rotate_over_time" },
    { 0x7D28E149, "rotate_perk_upgrade_bottle" },
    { 0xC5985E27, "rotate_plane_roll" },
    { 0xFA2AD32E, "rotate_point_around_point" },
    { 0x823DD99F, "rotate_pos_1" },
    { 0x10366A64, "rotate_pos_2" },
    { 0xBC9C9A42, "rotate_pow_door" },
    { 0xE69E52FF, "rotate_prop_main_thread" },
    { 0xE5C382FA, "rotate_prop_mode" },
    { 0xD666A001, "rotate_prop_mode_thread" },
    { 0x9507BEAF, "rotate_punch_upgrade_tablet" },
    { 0xEB9DC7DC, "rotate_radar_dish" },
    { 0x0159C971, "rotate_rate" },
    { 0x20E39A1D, "rotate_ring" },
    { 0x8D1A98F4, "rotate_rocket_at_midpoint" },
    { 0xE185D43E, "rotate_rollers" },
    { 0x8E5302A0, "rotate_sam" },
    { 0xE7F56907, "rotate_script_model_to_angles" },
    { 0xF6127B3E, "rotate_siren" },
    { 0xFDF9DAB3, "rotate_skydome" },
    { 0x37F9414C, "rotate_speed" },
    { 0x2EF49AC9, "rotate_table" },
    { 0xB518D346, "rotate_the_clinic_door" },
    { 0x2F196F14, "rotate_threshold" },
    { 0x35651350, "rotate_time" },
    { 0x5DA55ABB, "rotate_while_moving" },
    { 0x75EBBA09, "rotate_wind_turbine" },
    { 0xB646C3F4, "rotateangles" },
    { 0x85281078, "rotated" },
    { 0x1F68CF5E, "rotated_forward" },
    { 0x6654E4F4, "rotatedone" },
    { 0x06750D50, "rotatedx" },
    { 0x2C7787B9, "rotatedy" },
    { 0xCAF9B0A5, "rotateelem" },
    { 0x61A0D5B3, "rotateent" },
    { 0xF3B9A42A, "rotatefans" },
    { 0x623F804E, "rotatemax" },
    { 0xB516EF10, "rotatemin" },
    { 0x788EC1D6, "rotatepitch" },
    { 0x645ED71A, "rotateplane" },
    { 0x163C99D6, "rotatepoint" },
    { 0x56BEDEB6, "rotatepointaroundaxis" },
    { 0x090F485E, "rotater" },
    { 0x48F7405E, "rotateradardishoncommsbuilding" },
    { 0xB407088E, "rotaterig" },
    { 0x5613042D, "rotateroll" },
    { 0x050AF88B, "rotateroll_box" },
    { 0x2F11C2C7, "rotates" },
    { 0xDCDCBA75, "rotatespeed" },
    { 0x9539921F, "rotatetarget" },
    { 0x8A00A6A7, "rotatetime" },
    { 0xC0B6566F, "rotateto" },
    { 0xED898531, "rotateto_struct" },
    { 0xC28A5562, "rotateuavrig" },
    { 0xA1B06555, "rotatevelocity" },
    { 0x991549A9, "rotatewheel" },
    { 0x21D0DA55, "rotateyaw" },
    { 0xFB14CF7A, "rotateyawangle" },
    { 0xC093DEDD, "rotating" },
    { 0xEFA64DA5, "rotating_object" },
    { 0x00218200, "rotating_object_think" },
    { 0x94FE8AB4, "rotating_objects" },
    { 0xF0E36723, "rotation" },
    { 0x4BD50076, "rotation_degree" },
    { 0xA21D54C1, "rotation_is_occuring" },
    { 0x7D609087, "rotation_offset" },
    { 0x731A29A3, "rotation_thread_spawner" },
    { 0xDF9F949B, "rotationaccelerationduration" },
    { 0x51D186FC, "rotational" },
    { 0xB6C8A98A, "rotationdecelerationduration" },
    { 0xD44D4C6D, "rotationdummy" },
    { 0xB92302A9, "rotationp" },
    { 0x0527F77B, "rotationr" },
    { 0xDF257D12, "rotations" },
    { 0x78B17090, "rotationstablizeparam" },
    { 0x9F88D954, "rotationwait" },
    { 0xC3345B88, "rotationy" },
    { 0xE7459428, "rotator" },
    { 0x49AD5E21, "rotator_x_offset" },
    { 0xC232EFAA, "rotator_y_offset" },
    { 0x0CB750C3, "rotators" },
    { 0x6CF453DC, "rotdec" },
    { 0x5D159261, "rotj_done" },
    { 0x07C20DBB, "rotor" },
    { 0xE05A4602, "rotor_angles" },
    { 0x75DB43F1, "rotor_anim" },
    { 0x5CFDEFA7, "rotor_blades" },
    { 0x7219E09D, "rotor_ent" },
    { 0xE357C37B, "rotor_hub" },
    { 0x998F1038, "rotor_pos" },
    { 0x917BE2FA, "rotoralternaterunningfx" },
    { 0x6AFBC250, "rotordamaged" },
    { 0xDB184BA4, "rotormainfxhandle" },
    { 0x16283758, "rotormainfxhandle_saved" },
    { 0x12944E28, "rotormainidlefx" },
    { 0x21C0D101, "rotormainidlefxname" },
    { 0x12458A57, "rotormainrunningfx" },
    { 0x64F243EA, "rotormainrunningfxname" },
    { 0x8587441A, "rotormainstartfx" },
    { 0x87BF57A7, "rotormainstartfxname" },
    { 0xD5CCBE4E, "rotormainstopfx" },
    { 0xA1FFFBD3, "rotormainstopfxname" },
    { 0xA93BFC3D, "rotoroldrunningfx" },
    { 0x77A5BE5A, "rotors" },
    { 0x26294F6D, "rotortailfxhandle" },
    { 0x3BF206E1, "rotortailfxhandle_saved" },
    { 0x858B2FD9, "rotortailidlefx" },
    { 0x9B8C6678, "rotortailidlefxname" },
    { 0xFA6C1428, "rotortailrunningfx" },
    { 0xA8CEF701, "rotortailrunningfxname" },
    { 0x1E5B7D11, "rotortailstartfx" },
    { 0x3E590C50, "rotortailstartfxname" },
    { 0x5C2E99FB, "rotortailstopfx" },
    { 0x035534D6, "rotortailstopfxname" },
    { 0x5FC3168B, "rotrange" },
    { 0xC074EF1A, "rotscale" },
    { 0x921460E9, "rotten" },
    { 0x4659FADF, "rottime" },
    { 0x8BC06FCF, "rottimer" },
    { 0x4F015C44, "rottweil72" },
    { 0x31F29FD5, "rouellet" },
    { 0xAC259DF8, "rough" },
    { 0x9DB73A57, "rough_note" },
    { 0x1C3C7AB6, "rough_vector" },
    { 0x0CE5CBFD, "roughly" },
    { 0xBE88C804, "roughout" },
    { 0xCE9CBA59, "roulette" },
    { 0xEC0D01DC, "roulette_activation_wait" },
    { 0x0ABC7905, "roulette_clientfield_cb" },
    { 0x7C7F99DF, "roulette_init_allow_spin" },
    { 0x2044D6C9, "roulette_pre_respin_wait_time" },
    { 0x0D1BF2E9, "roulette_respin_activate" },
    { 0x7968596A, "roulette_respin_activation_wait" },
    { 0x02C9BB8B, "roulette_respin_time_seconds" },
    { 0x4C8A0A2B, "roulette_state" },
    { 0xE956451D, "roulette_state_default" },
    { 0xC31B55E6, "roulette_state_respin_prompt" },
    { 0xD1234FE4, "roulette_state_spinning" },
    { 0x34F9ED57, "roulette_state_wait_for_respin" },
    { 0xDC121648, "roulettefog_enter_settings" },
    { 0x831841F2, "roulettefog_exit_settings" },
    { 0x2BAB83BE, "roulettestatusmodel" },
    { 0xC99967B7, "round" },
    { 0xD3B0988E, "round23" },
    { 0xB2DAA27A, "round_complete_num" },
    { 0xDBFFDBFD, "round_complete_time" },
    { 0xFBC5537F, "round_count" },
    { 0xB4F421E9, "round_end" },
    { 0x6843BE82, "round_end_custom_logic" },
    { 0x1C6F9DEC, "round_end_done" },
    { 0xF68EDDD6, "round_end_finished" },
    { 0x37E402EE, "round_end_monitor" },
    { 0x5CD9F23F, "round_end_time" },
    { 0x950EE516, "round_ended" },
    { 0xE5E8A747, "round_first_done" },
    { 0xBEF76D98, "round_initialized" },
    { 0x949AFAD3, "round_is_active" },
    { 0x5838354C, "round_logic" },
    { 0x22194151, "round_next" },
    { 0xF21DC6B9, "round_number" },
    { 0x097DDBC6, "round_number_max" },
    { 0x66B9C74C, "round_one_end_solo_vo" },
    { 0x96B6D19E, "round_one_end_vo" },
    { 0x24EAF6F2, "round_one_up" },
    { 0x7F6E1E04, "round_over" },
    { 0x20716522, "round_override" },
    { 0x6765CD60, "round_pause" },
    { 0xE9389B68, "round_prestart_func" },
    { 0x3EF097E0, "round_score_limit" },
    { 0x161F1CAF, "round_spawn" },
    { 0xF00C9AC7, "round_spawn_count" },
    { 0xA4D2B2D1, "round_spawn_failsafe" },
    { 0x1FDCB5F1, "round_spawn_failsafe_debug" },
    { 0x1DB01ABA, "round_spawn_failsafe_debug_draw" },
    { 0x1F27F648, "round_spawn_func" },
    { 0x16D0CA91, "round_spawning" },
    { 0x82E82D54, "round_spawning_done" },
    { 0x2C47DDCA, "round_spawning_fall_test" },
    { 0xC87FEB68, "round_spawning_starting" },
    { 0x175F6E68, "round_spawning_test" },
    { 0x1CC3BEC2, "round_start" },
    { 0xECCB9125, "round_start_custom_func" },
    { 0x8BB49686, "round_start_time" },
    { 0x629A5DD5, "round_started" },
    { 0xA0C413DF, "round_text" },
    { 0xE643ED8E, "round_think" },
    { 0x81704807, "round_think_func" },
    { 0xF81CC016, "round_this_number" },
    { 0x42DBA045, "round_timer" },
    { 0x45C6BA11, "round_to" },
    { 0xBE6EF2E9, "round_to_spawn" },
    { 0x360282A1, "round_tracking" },
    { 0xB59A9545, "round_two_end_narrative_vo" },
    { 0x997F9042, "round_two_end_solo_vo" },
    { 0x8B48B812, "round_type" },
    { 0xB27E5791, "round_up" },
    { 0xAEEE1292, "round_up_score" },
    { 0xC2EFBA0A, "round_up_to_five" },
    { 0xDEB49C87, "round_up_to_ten" },
    { 0x867BC881, "round_wait" },
    { 0xEDD19A9E, "round_wait_func" },
    { 0xAB7940C7, "round_winner" },
    { 0x8DE2C375, "round_zombie_counter" },
    { 0xF5DBD6FB, "round_zombie_total" },
    { 0x7CFBADD2, "roundabout" },
    { 0xEEF17944, "roundbased" },
    { 0xFDF40062, "roundbegin" },
    { 0x048AD87C, "rounded" },
    { 0x8183CE36, "roundend" },
    { 0xE9B1D7BF, "roundenddelay" },
    { 0xB1F3BC79, "roundenddof" },
    { 0x5BAC3F09, "roundendtime" },
    { 0xFC5AA905, "roundendwait" },
    { 0xD4E0F609, "roundhouse" },
    { 0x65A35AE9, "rounding" },
    { 0xB5C312B7, "roundlength" },
    { 0xFA404B24, "roundlimit" },
    { 0xF973FB3B, "roundlimitdvar" },
    { 0x427C87DE, "roundlimitmax" },
    { 0xD504A980, "roundlimitmin" },
    { 0xBB5FB444, "roundlives" },
    { 0xCAFF6F4F, "roundmgr" },
    { 0x10646B91, "roundnum" },
    { 0x1DEAF3B6, "roundoff" },
    { 0xD95918EE, "rounds" },
    { 0x86BCE82D, "rounds_kept" },
    { 0x74F28771, "rounds_per_second" },
    { 0xD78AB732, "rounds_since_rain" },
    { 0x0C1B3FD9, "rounds_since_snow" },
    { 0xB91C2287, "rounds_survived" },
    { 0xFF1F9B18, "roundscorecarry" },
    { 0x200DA4B4, "roundscorelimit" },
    { 0xB2CF052E, "roundscorelimitmax" },
    { 0x05A673F0, "roundscorelimitmin" },
    { 0x33B3A8C0, "roundscoretobeat" },
    { 0xA8CE2E4F, "roundsplayed" },
    { 0xA6AA36B3, "roundstartexplosivedelay" },
    { 0xD664F00C, "roundstartkillstreakdelay" },
    { 0xCC6DF7FB, "roundswitch" },
    { 0x210CB8D4, "roundswitchdvar" },
    { 0xFA8608E5, "roundswitching" },
    { 0xB59783F7, "roundswitchmax" },
    { 0x9AA25849, "roundswitchmin" },
    { 0x4A2C3D76, "roundswon" },
    { 0xD84178D0, "roundswonlosers" },
    { 0xD92CC672, "roundtonearestfive" },
    { 0xBC50FE98, "roundup" },
    { 0x483C59B0, "roundwinlimit" },
    { 0xE5B3B677, "roundwinlimitdvar" },
    { 0xA73AF3BA, "roundwinlimitmax" },
    { 0x69D6E8A4, "roundwinlimitmin" },
    { 0xAD9304BA, "roundwinner" },
    { 0x2004B764, "rousing" },
    { 0xBC621F1C, "route" },
    { 0x2EE8070E, "route1_trig" },
    { 0x9749749D, "route_changed" },
    { 0x35288F7B, "routeid" },
    { 0xDB183830, "routenode" },
    { 0x7B68DA5F, "routes" },
    { 0x64DBB0CC, "routestartnode" },
    { 0xB01546D7, "routine" },
    { 0x4EF7F28E, "routines" },
    { 0x64105205, "routing" },
    { 0x3947A807, "row" },
    { 0x6B787979, "rowboat" },
    { 0x6A70D032, "rowdy" },
    { 0xB8F7A3FE, "rows" },
    { 0x1301550A, "royal" },
    { 0x962D64BA, "roycewicz" },
    { 0x716D3B6F, "rp" },
    { 0xE4465746, "rpc" },
    { 0x2639F339, "rpd" },
    { 0x4C3C6DA2, "rpg" },
    { 0x2B4AB6FF, "rpg1" },
    { 0xB94347C4, "rpg2" },
    { 0xDF45C22D, "rpg3" },
    { 0xEF78609A, "rpg_aim_assist" },
    { 0x72F7E7DF, "rpg_aim_assist_attractor" },
    { 0xFF50C947, "rpg_ambient" },
    { 0xC21BC0CE, "rpg_at_the_player" },
    { 0xB60F6093, "rpg_btr_ownage" },
    { 0xCF5EED3B, "rpg_crate_clip" },
    { 0x3C733051, "rpg_crates" },
    { 0x465B92DA, "rpg_crew_attack_ai" },
    { 0xB0E487D1, "rpg_crew_get_target" },
    { 0xF9473216, "rpg_crew_shoot" },
    { 0xA7AF9A8D, "rpg_destabilization_distance" },
    { 0xFEABD755, "rpg_destroy_statue_entrance" },
    { 0x9E39BFC8, "rpg_end" },
    { 0xF16F6FAB, "rpg_end_pos" },
    { 0x5E4C703E, "rpg_fake" },
    { 0x2B5B7B47, "rpg_fire_prediction" },
    { 0xF19AFE1B, "rpg_fired" },
    { 0xFCCF8932, "rpg_gun_boat" },
    { 0xFEDB9B4A, "rpg_guy" },
    { 0x749F6263, "rpg_guy_animcustom" },
    { 0xC0B2A8C5, "rpg_guy_animcustom_setup" },
    { 0x8D702C23, "rpg_guy_fired" },
    { 0x5A8D87AD, "rpg_guy_left_shot" },
    { 0x1144B1DF, "rpg_guy_locations" },
    { 0xBBDB3278, "rpg_guy_right_shot" },
    { 0xF953B959, "rpg_guy_shot" },
    { 0x4488B642, "rpg_guy_tower_setup" },
    { 0xF78B5485, "rpg_guys" },
    { 0x6A07E0FF, "rpg_guys_spawnfunc" },
    { 0xBE383A64, "rpg_hallway_destruction" },
    { 0x2E4A19E4, "rpg_has_ammo" },
    { 0x0C5371B4, "rpg_horse_explosion" },
    { 0x62C1B1D1, "rpg_kills_first_wave" },
    { 0x4B67D26D, "rpg_kills_second_wave" },
    { 0x8DA225F7, "rpg_magnet" },
    { 0x56C65D05, "rpg_refill" },
    { 0x339488D0, "rpg_rollout_guy" },
    { 0x22B81947, "rpg_roof" },
    { 0x0A3AF583, "rpg_sampan" },
    { 0xCC1F0CAF, "rpg_seal_backup" },
    { 0x961BAE11, "rpg_shoot_pos" },
    { 0xE7CDD203, "rpg_shooter" },
    { 0xBD9E7ED6, "rpg_shot_at_uaz" },
    { 0x85C52CF8, "rpg_sp" },
    { 0xF51E8D40, "rpg_spawn_vo" },
    { 0xEA4784BB, "rpg_spawner" },
    { 0x0FC0135A, "rpg_spawners" },
    { 0xA4FBC799, "rpg_spot" },
    { 0xEF26C66B, "rpg_start" },
    { 0x0CA1644F, "rpg_take_out_support_huey" },
    { 0x6693423C, "rpg_tank_shooter" },
    { 0x298AA7AA, "rpg_target" },
    { 0xDFCF4C5F, "rpg_timing" },
    { 0x7148F414, "rpg_tower_damage_lines" },
    { 0x180E128F, "rpg_trigger" },
    { 0xD707ED7E, "rpg_trigger_0" },
    { 0x0A310BD2, "rpg_trigs" },
    { 0xD97C402A, "rpg_truck" },
    { 0x5822DEA4, "rpg_turret_ai" },
    { 0x94BA96A6, "rpg_turret_ai_set_anims" },
    { 0x3F117E14, "rpg_turret_ai_shoot_watch" },
    { 0x6EB631E4, "rpg_vc" },
    { 0xB1B3B1CC, "rpg_waterhut_node" },
    { 0x91CF3AB1, "rpg_waterhut_vc" },
    { 0xB542774C, "rpgdeath" },
    { 0xF2C24887, "rpgers_to_dummy" },
    { 0x5F6A754B, "rpgguyspot" },
    { 0x94A06F97, "rpgguyspotsecondary" },
    { 0x369AB82C, "rpgorg" },
    { 0x5FE45C6D, "rpgs" },
    { 0x88C730FF, "rpgshoot" },
    { 0x9E3EBAD9, "rpgshootexplodable" },
    { 0x7E78176F, "rpgspot1" },
    { 0x0C70A834, "rpgspot2" },
    { 0x3273229D, "rpgspot3" },
    { 0xCC80BAB3, "rpgtrg" },
    { 0x7691F4A3, "rpgwhizbywatcher" },
    { 0x02FEBDEE, "rpk_guy" },
    { 0xA23CC593, "rpk_or_rpg_died" },
    { 0xB665CDA4, "rpk_runout_guy" },
    { 0x304B4C18, "rpm" },
    { 0xD349D557, "rpmredline" },
    { 0x841EB0B6, "rps" },
    { 0x2568469D, "rr" },
    { 0xF284D330, "rr_1c" },
    { 0xEB7E780E, "rr_ai_ready" },
    { 0x3F58AB12, "rr_animate_ai" },
    { 0xC32F0C01, "rr_animate_bookie" },
    { 0xAD89926C, "rr_animate_objects" },
    { 0x4F697F27, "rr_animate_player" },
    { 0xAFFBD02F, "rr_jumpto" },
    { 0x0E7B5448, "rr_scene" },
    { 0x1C205F13, "rr_scene_a_1_done" },
    { 0xE5BE8AEF, "rr_scene_a_done" },
    { 0x276073FF, "rr_scene_b" },
    { 0x015DF996, "rr_scene_c" },
    { 0x43519589, "rr_scene_d" },
    { 0xEB541363, "rr_scene_done" },
    { 0x556C5ADB, "rr_scene_guys" },
    { 0x2E1BA78D, "rr_scene_start" },
    { 0xC6A6199B, "rr_temp_dialogue" },
    { 0xD77B77A9, "rrarrrgh" },
    { 0xD7924A76, "rratio" },
    { 0x290B26E3, "rrd" },
    { 0xDA56AC0E, "rreveal" },
    { 0x49AE5919, "rright" },
    { 0xFF65CC34, "rs" },
    { 0xAFFB23BE, "rs_juke_melee_damage_amount" },
    { 0x6207271C, "rs_juke_melee_damage_radius" },
    { 0xDCF8A65D, "rs_rotation_speed_multiplier" },
    { 0x6848A4D8, "rsd" },
    { 0x6F4ED286, "rsfx" },
    { 0xAFB4EA99, "rsh030110" },
    { 0x54B1E065, "rsh040711" },
    { 0xDD67AB1F, "rsh061411" },
    { 0x6F0F8402, "rsh071510" },
    { 0x824B890D, "rsh090710" },
    { 0x1D640DB6, "rsh091310" },
    { 0x59F16AFE, "rshldr" },
    { 0x19622F58, "rsin_theta" },
    { 0xAA3C40CB, "rso" },
    { 0x994A3BB6, "rso_operator" },
    { 0x95195165, "rso_setup_complete" },
    { 0x1901BB95, "rspns" },
    { 0x6FB16BB6, "rspns_cat_name" },
    { 0x955638AD, "rspot" },
    { 0x87E14A54, "rsquared" },
    { 0xC75A97E3, "rstick" },
    { 0x31BAE02A, "rstick_has_moved" },
    { 0x88DA4825, "rstrap" },
    { 0xD96351CB, "rt" },
    { 0xE8DF6F19, "rt_time" },
    { 0x0D70D003, "rtb" },
    { 0x33734A6C, "rte" },
    { 0xFBBF566F, "rtes" },
    { 0x7F783F3E, "rtg" },
    { 0x4B5ABE3B, "rtgun" },
    { 0x7C4481DB, "rtower_object_planted" },
    { 0x74637977, "rtrig" },
    { 0x4795FC2A, "rts" },
    { 0x9F48DEEB, "rts_afghan_fail" },
    { 0x542DE784, "rts_afghan_outro" },
    { 0xA9004EC8, "rts_array" },
    { 0xA5255F37, "rts_change_state" },
    { 0xC5A602A7, "rts_control_anims" },
    { 0xB3E93D8F, "rts_control_listener" },
    { 0xFF5BE270, "rts_data_table" },
    { 0x0607842B, "rts_def_table" },
    { 0xD36F7AAD, "rts_defend" },
    { 0x96F6CFA3, "rts_delay_gotopoint_ai" },
    { 0x68B302DB, "rts_delay_gotopoint_choke" },
    { 0x0FF02940, "rts_delay_gotopoint_choke_ai" },
    { 0x68F0B86B, "rts_delay_gotopoint_choke_ais" },
    { 0x2651F7CA, "rts_delay_gotopoint_choke_being_processed" },
    { 0x21B22E05, "rts_delay_gotopoint_choke_wait" },
    { 0x7CBEC424, "rts_delay_gotopoint_release" },
    { 0xCC1D58CA, "rts_delivery_column" },
    { 0x166BD05B, "rts_desc_column" },
    { 0x9996993D, "rts_done" },
    { 0xC3BE17FE, "rts_event_" },
    { 0x20417725, "rts_fadeout" },
    { 0x7AFB04F3, "rts_fd" },
    { 0x616B5C3D, "rts_floor" },
    { 0x463483FC, "rts_floors" },
    { 0x7E07ED9B, "rts_go" },
    { 0xD00A8087, "rts_go_rts" },
    { 0xC8558945, "rts_heroes" },
    { 0xD8CD2972, "rts_house_guys" },
    { 0xBC9CFF8C, "rts_house_patrollers" },
    { 0x57FF2998, "rts_idle_anims" },
    { 0xBC926611, "rts_ied_available" },
    { 0x74BCF9F4, "rts_ied_notavailable" },
    { 0x33A9A165, "rts_image_column" },
    { 0x0B291600, "rts_index_column" },
    { 0xD7545A87, "rts_init" },
    { 0x7DAD1DB8, "rts_is_pointok" },
    { 0xB43C76F8, "rts_last_enemy" },
    { 0xD285EF6D, "rts_level_name" },
    { 0x43597647, "rts_map_completed" },
    { 0xEA41FBFC, "rts_menu" },
    { 0xBAA82C4F, "rts_missile_sp" },
    { 0xD5C05244, "rts_mode" },
    { 0xAD0BC2B1, "rts_move_squadstocursor" },
    { 0x57D115F5, "rts_name_column" },
    { 0x3FE9E357, "rts_next_grenade_force_attempt" },
    { 0x74CC86CB, "rts_next_secondary_force_attempt" },
    { 0x5C825200, "rts_off" },
    { 0x2EC419DA, "rts_on" },
    { 0xF36AD34F, "rts_on_save_restored" },
    { 0x7AC01BF3, "rts_over" },
    { 0x130F1973, "rts_patrol" },
    { 0x8A4DA61D, "rts_pkgdep_column" },
    { 0x3E79C302, "rts_player_damaged" },
    { 0x8576BCC9, "rts_poimaterial_column" },
    { 0xB9373557, "rts_poiname_column" },
    { 0x79114733, "rts_poiref_column" },
    { 0x5ACA75BC, "rts_preptime_column" },
    { 0x76B45D9D, "rts_remove" },
    { 0x8EA2523A, "rts_rpg_available" },
    { 0x767DE1F1, "rts_rpg_notavailable" },
    { 0x247EB64E, "rts_species_column" },
    { 0xF96A9A92, "rts_terminated" },
    { 0x2CA55257, "rts_unit_base_id" },
    { 0xA504A69B, "rts_units_column" },
    { 0xA3CBBA8B, "rts_unloaded" },
    { 0x736CDA85, "rts_vehicle_damage" },
    { 0xA961BACE, "rtsambientpackage" },
    { 0x53CBD418, "rtsaudiotransitions" },
    { 0xA30B93E0, "rtsfloor" },
    { 0x1DB82C8B, "rtsfloors" },
    { 0x0ED2A93F, "rtshealthsystem" },
    { 0x908A48EF, "rtsmode" },
    { 0x239AB5D6, "ru0" },
    { 0x499D303F, "ru1" },
    { 0xD795C104, "ru2" },
    { 0xFD983B6D, "ru3" },
    { 0xD823F037, "rubber" },
    { 0x04C9042C, "rubber_raft_init" },
    { 0xC7055BFF, "rubberband_potential_soct" },
    { 0x43FA05B6, "rubberbanding" },
    { 0x46C88612, "rubbing" },
    { 0x3486057F, "rubble" },
    { 0xAFCFD324, "rubout_time" },
    { 0xBD223FF0, "ruined" },
    { 0x3ACB4A1A, "ruins" },
    { 0x0B2081D1, "ruins_anims" },
    { 0x112DB453, "ruins_battle" },
    { 0x884E1848, "ruins_battle_2" },
    { 0x96DD74B2, "ruins_chimney" },
    { 0x76C59695, "ruins_door_destroyed" },
    { 0x4AEE6E96, "ruins_fist_glow_monitor" },
    { 0xCD00C978, "ruins_gunners_strat" },
    { 0x7AF6F1E7, "ruins_guy_check" },
    { 0x5EC1234E, "ruins_hind_extra_dialogue" },
    { 0x276F1EFB, "ruins_interior_main" },
    { 0x3151582F, "ruins_interior_seal" },
    { 0x95AF3D89, "ruins_interior_vo" },
    { 0xE46DFBD4, "ruins_retreat_reaction" },
    { 0xC15A566F, "ruins_retreat_trig_early" },
    { 0xCCAD21E3, "ruins_split_color_squads" },
    { 0xEC0E25BF, "ruins_stealth_over" },
    { 0x36430C59, "ruins_tank_at_end" },
    { 0xA6C8D970, "ruins_vo" },
    { 0x22EE8790, "ruins_weapons" },
    { 0xE08EB2A3, "rule" },
    { 0x14E84C38, "ruledef" },
    { 0x1B58B3E5, "ruleindex" },
    { 0x88933D8D, "rulenum" },
    { 0x7AF2CD6D, "ruleround" },
    { 0xA9CD5792, "rules" },
    { 0xEE80A2AF, "rules_populate" },
    { 0xB09A5528, "rules_setgametimer" },
    { 0x7AB1B832, "rulescorepercent" },
    { 0x42A037C5, "rulestoremove" },
    { 0x869FEFBB, "ruletimeleft" },
    { 0x969229F8, "ruletocheck" },
    { 0x0A1ECA4D, "ruletoexecute" },
    { 0x713495B5, "ruleweaponsleft" },
    { 0xE2439CBA, "rumble" },
    { 0x2747B8E1, "rumble_all_players" },
    { 0xC4F4DDB3, "rumble_and_shake" },
    { 0x8EE6AB15, "rumble_basetime" },
    { 0xCD65CA66, "rumble_delay" },
    { 0xED7E2399, "rumble_dist" },
    { 0x61FF9EE4, "rumble_distance" },
    { 0x54B72A5E, "rumble_drone_turret" },
    { 0xECD90BC5, "rumble_duration" },
    { 0x6274BA70, "rumble_ent" },
    { 0x6B015806, "rumble_for_time" },
    { 0x7897D19B, "rumble_func" },
    { 0xEF592B49, "rumble_garrote" },
    { 0xA5481C7B, "rumble_hangars" },
    { 0x10476143, "rumble_heart" },
    { 0x827BEF7B, "rumble_hit_test" },
    { 0x83AA6AB5, "rumble_if_player_collision" },
    { 0x08464153, "rumble_loop" },
    { 0x0005CBE6, "rumble_loop_stop" },
    { 0x1F73A982, "rumble_loops" },
    { 0x2A5A26C8, "rumble_name" },
    { 0x83904557, "rumble_nearby_players" },
    { 0xA78D1399, "rumble_node" },
    { 0x46A3FF93, "rumble_num" },
    { 0x385599F6, "rumble_on_breach" },
    { 0x1D2214AD, "rumble_on_down" },
    { 0x07EE88FC, "rumble_on_hit" },
    { 0x171C1043, "rumble_on_hookup" },
    { 0xC78752BD, "rumble_on_stab" },
    { 0x58E4D11D, "rumble_org" },
    { 0xBF963726, "rumble_player" },
    { 0xD0DC88B2, "rumble_players_in_chamber" },
    { 0xA8AE8693, "rumble_radius" },
    { 0x899DC5FA, "rumble_randomaditionaltime" },
    { 0x3CD638F8, "rumble_range" },
    { 0x46D1E031, "rumble_scale" },
    { 0x2BFD530E, "rumble_screen_shake_player" },
    { 0x67F2FB0A, "rumble_speed" },
    { 0xF6B6B4D1, "rumble_structs" },
    { 0x85419CFE, "rumble_time" },
    { 0x181D8878, "rumble_timer" },
    { 0xCFA6DAEB, "rumble_trig" },
    { 0xA6D33E31, "rumble_type" },
    { 0xFFC0153E, "rumbleadditionaltime" },
    { 0xBD4CCDAE, "rumblebasetime" },
    { 0x9353B68A, "rumbled" },
    { 0x33AAE4B6, "rumbleduration" },
    { 0x7BD6EE55, "rumbleon" },
    { 0x7F3104CC, "rumbler" },
    { 0xBFD474E4, "rumbleradius" },
    { 0xA5337F35, "rumbles" },
    { 0x6E7994F4, "rumblescale" },
    { 0xDE291271, "rumblestruct" },
    { 0x5EA70CB2, "rumbletrigger" },
    { 0x54F86B7A, "rumbletype" },
    { 0xE19D3C15, "rummage" },
    { 0x89ACA013, "rumors" },
    { 0x4F28B6F8, "run" },
    { 0x80F556AA, "run2" },
    { 0xD1DD2C6C, "run2wall_allow_headlook" },
    { 0x8041363C, "run_accuracy" },
    { 0x7C6A27F3, "run_airstrike_planes" },
    { 0xEAAB05DC, "run_all" },
    { 0x53E954FE, "run_allied_cougar" },
    { 0x20C34C76, "run_ambient_effects" },
    { 0xE89AF9C8, "run_and_delete" },
    { 0x6E23CC21, "run_and_die" },
    { 0xC3FF7AE0, "run_anim" },
    { 0xF8969435, "run_anim_on_flag" },
    { 0x82B8D05D, "run_anim_to_idle" },
    { 0xFDACD18B, "run_anims" },
    { 0xC9C0DD41, "run_asd" },
    { 0x7FF9D031, "run_away" },
    { 0x617D527C, "run_away_guy_spawn_strafer_on_death" },
    { 0x11BC378F, "run_b" },
    { 0x221AC0F6, "run_back" },
    { 0x2F0581A5, "run_background_elements" },
    { 0xC8B1C9A7, "run_berserk" },
    { 0xA76022C1, "run_betrayal_redshirt_walkup_scene" },
    { 0x8B220A0D, "run_briefing_forceplay" },
    { 0xC9412981, "run_buddy_quad" },
    { 0x412533C3, "run_camera_scene" },
    { 0x8DB85F98, "run_chain_nodes" },
    { 0x5D4CE9FB, "run_chamber_entrance_teleporter" },
    { 0xDB713E86, "run_chamber_exit" },
    { 0xA8396E27, "run_cloak_effect" },
    { 0x12D0F044, "run_combatanim" },
    { 0xDE412A64, "run_control_room_anim" },
    { 0xDAF5EEC0, "run_courtyard_scenes" },
    { 0x025D1EF9, "run_cow_catcher" },
    { 0x9CEE4436, "run_cow_run" },
    { 0xBD335247, "run_craftables_devgui" },
    { 0xE99137C6, "run_crypt_gem_pos" },
    { 0x8C97E225, "run_custom_ai_spawn_checks" },
    { 0x4148357C, "run_custom_function_on_ai" },
    { 0x2D8E64D3, "run_cycle" },
    { 0xE1C83F04, "run_cycle_delta" },
    { 0xF508A3AA, "run_cycle_dist" },
    { 0xCC4D371A, "run_cycle_length" },
    { 0x742C4EE7, "run_cycle_speed" },
    { 0x50038C02, "run_cycles" },
    { 0x28E7910F, "run_data" },
    { 0x0C42FF96, "run_debug_timer" },
    { 0xF4DB314E, "run_dev_drones" },
    { 0xD2E01644, "run_digital_billboards" },
    { 0x6DD6C0A8, "run_dish_fx" },
    { 0x5634730E, "run_dissolve_effect" },
    { 0x45F5F60D, "run_dist_squared" },
    { 0x49665C85, "run_distant_explosions" },
    { 0xA927F273, "run_dont_jog" },
    { 0xD3B7CB22, "run_dontstop" },
    { 0xB273DF73, "run_door_fxanim" },
    { 0x775598B7, "run_down_street" },
    { 0x62416894, "run_end_array" },
    { 0x44ECF0D8, "run_end_script" },
    { 0x4122AE66, "run_escape_ending_friends" },
    { 0x4D6303EB, "run_escape_scene" },
    { 0xE0C3EDF2, "run_execution_watcher_scenes" },
    { 0x9A64E0C3, "run_extracam_primary" },
    { 0xB1CB794B, "run_extracam_secondary" },
    { 0x19490E5F, "run_facial_recognition" },
    { 0x46DFC215, "run_firehorse_anims" },
    { 0xDFBD0B26, "run_for_help" },
    { 0x98F8DF18, "run_func_after_wait_array" },
    { 0xBDAA3156, "run_germ_setup" },
    { 0x13087010, "run_glasses_input" },
    { 0x9A635B02, "run_gramophone_door" },
    { 0x0C9AFECA, "run_gramophone_teleporter" },
    { 0x20482A61, "run_groups_of_drones" },
    { 0x4E2C9646, "run_gump_functions" },
    { 0x5F7280FD, "run_hackable_turret" },
    { 0x09B6FD76, "run_height" },
    { 0x6C7666C4, "run_heli_path_logic" },
    { 0xE2A8F262, "run_horde_enemy" },
    { 0x8721E600, "run_horse_passed_player_then_away" },
    { 0xDBD52590, "run_id" },
    { 0xA615A869, "run_id1" },
    { 0xCC1822D2, "run_id2" },
    { 0xF21A9D3B, "run_id3" },
    { 0x181D17A4, "run_id4" },
    { 0x3F3D9E6E, "run_ignore_player_handler" },
    { 0x71645861, "run_index" },
    { 0x1B5EADF9, "run_instances" },
    { 0x59A394FB, "run_intro_cam" },
    { 0x47B06DE1, "run_kneepcap_scene_main_animations" },
    { 0x8655612B, "run_landing_squad_lighting_scene" },
    { 0x555E93ED, "run_locations" },
    { 0xA5F3CF73, "run_lock_fx" },
    { 0xCE0F495B, "run_lowready_f" },
    { 0xF3AEBCB8, "run_map_room_anims" },
    { 0x47F95CB1, "run_mason_bridge" },
    { 0xB1B41F25, "run_mason_catwalk" },
    { 0xA5FE3E62, "run_mason_cctv" },
    { 0x96BB1ED9, "run_mason_deck" },
    { 0xCBEA1B44, "run_mason_deck_final" },
    { 0xD9473401, "run_mason_deck_final_deck_attackers" },
    { 0x827E2F13, "run_mason_deck_final_fadeout" },
    { 0x62AC5B47, "run_mason_deck_final_fire" },
    { 0x715A0D05, "run_mason_deck_final_manual" },
    { 0x38909B5C, "run_mason_deck_final_player" },
    { 0x27042790, "run_mason_elevator" },
    { 0x2583356C, "run_mason_hallway" },
    { 0xD179D836, "run_mason_hallway_friendly" },
    { 0xFD052823, "run_mason_hangar" },
    { 0xE9F46B6B, "run_mason_interrogation_room" },
    { 0xAA216BBA, "run_mason_lower_level" },
    { 0xCF649E9D, "run_mason_salazar_caught" },
    { 0xF10D4E45, "run_mason_salazar_exit" },
    { 0x0FB39A1C, "run_mason_security" },
    { 0xE590A7D7, "run_mason_server_room" },
    { 0x6E4DD936, "run_mason_start" },
    { 0xF9D9C39B, "run_mason_vent" },
    { 0x79EBE535, "run_mason_wakeup" },
    { 0x2934C222, "run_masons_quarters" },
    { 0x9D84463E, "run_masons_quarters_rumble" },
    { 0x8F65A155, "run_maxis_earthquake" },
    { 0x5CB28D6C, "run_menendez_betrayal" },
    { 0xDCAE4538, "run_menendez_combat" },
    { 0x9BFB6A10, "run_menendez_combat_scenes" },
    { 0x8DEF28A3, "run_menendez_deck" },
    { 0x5FFC2AFC, "run_menendez_enemy" },
    { 0x0DC3DD79, "run_menendez_hangar" },
    { 0x2FD2F7B7, "run_menendez_hangar_scenes" },
    { 0x02664E67, "run_menendez_meat_shield" },
    { 0x39B5035E, "run_menendez_plane" },
    { 0xCE8FFF15, "run_menendez_plane_and_elevator" },
    { 0xC3E04B8C, "run_menendez_start" },
    { 0xF8136108, "run_mirror_camera" },
    { 0xD9E51B69, "run_missile_firing_drones_around_player" },
    { 0xAE228006, "run_mode" },
    { 0xDBECF832, "run_mode_special" },
    { 0x47F01763, "run_mortar_fail_manager" },
    { 0x61BCD537, "run_mortars" },
    { 0xCAD5328C, "run_muj_herder_animations" },
    { 0x040425FF, "run_muj_lookout_animations" },
    { 0xBAD1D3BD, "run_muj_runout_animations" },
    { 0x84533481, "run_muj_stacker_1_animations" },
    { 0x465AFEC8, "run_muj_stacker_2_animations" },
    { 0x27CC3C6C, "run_muj_stinger_animations" },
    { 0xF3530AE2, "run_muj_wall_animations" },
    { 0x47DA2C6A, "run_muj_window_animations" },
    { 0x51E979F5, "run_n_gun_anim_blend_out" },
    { 0xF1EFD0BE, "run_n_gun_forward" },
    { 0xAFF24532, "run_n_gun_strafe_1" },
    { 0x89EFCAC9, "run_n_gun_strafe_2" },
    { 0x56B739EA, "run_n_gun_variation" },
    { 0x5E6C57C2, "run_name" },
    { 0xB5DFCD68, "run_next" },
    { 0x8635AAE7, "run_node" },
    { 0xD210D69B, "run_noncombatanim" },
    { 0x938750D2, "run_noriega_scene_that_plays_bringout_vo" },
    { 0x187AE3CF, "run_objective_heli" },
    { 0xA61BBA6E, "run_off_and_delete" },
    { 0x142269D6, "run_offscreen_anddie" },
    { 0x456F62D8, "run_on_left" },
    { 0x60C7B967, "run_on_right" },
    { 0x1469CD68, "run_oob_trigger" },
    { 0x751A4B4D, "run_over" },
    { 0xE34F67D0, "run_over_override" },
    { 0x1D4E1FB8, "run_pain_long" },
    { 0xAEA95670, "run_pain_med" },
    { 0x796248F8, "run_pain_short" },
    { 0x4512F0FB, "run_pby_tracker" },
    { 0x974D67B3, "run_pitch" },
    { 0x5BB01DD0, "run_pitch1" },
    { 0xCDB78D0B, "run_pitch2" },
    { 0x65F47596, "run_pitch_down" },
    { 0xC7951015, "run_pitch_either" },
    { 0x44B61995, "run_pitch_up" },
    { 0xF7FC44BC, "run_planted_callbacks" },
    { 0x95F993AB, "run_player_intro" },
    { 0x2D31F8DA, "run_post_systems" },
    { 0x0C01BB49, "run_pre_systems" },
    { 0x3DF0FBCD, "run_reflection_scene" },
    { 0x90DBAF41, "run_retreat_scene" },
    { 0x7F6D2531, "run_retreat_trigger" },
    { 0x7403163F, "run_richtofen_earthquake" },
    { 0xCBC73B4C, "run_sacrifice_ignition" },
    { 0xFD8C0680, "run_sacrifice_plinth" },
    { 0xF4097719, "run_scene" },
    { 0x47F91F2B, "run_scene_and_delete" },
    { 0x699A8DA2, "run_scene_and_delete_0" },
    { 0x8F9D080B, "run_scene_and_delete_1" },
    { 0x1D9598D0, "run_scene_and_delete_2" },
    { 0x453A8DC7, "run_scene_clear_goal" },
    { 0xFDC704DC, "run_scene_first_frame" },
    { 0xEB533DBB, "run_scene_tests" },
    { 0x406D6EC6, "run_scene_then_loop" },
    { 0x512DA0A7, "run_sensitive_geo" },
    { 0xCF9A235B, "run_shoot_logic" },
    { 0xDD96BD45, "run_skipto" },
    { 0xFFED16E7, "run_skipto_bridge" },
    { 0x7361ECF7, "run_skipto_end" },
    { 0x9C463949, "run_skipto_hangar" },
    { 0x41E2D483, "run_sniper_idle" },
    { 0xF46CD9C6, "run_sparks_loop" },
    { 0xA49D8ABA, "run_spawn_functions" },
    { 0x85E94DA2, "run_special_debug_functions" },
    { 0xE1A5BE10, "run_speed" },
    { 0x3C0BE93A, "run_speed_state" },
    { 0x4E1CED4D, "run_spin_model" },
    { 0x5D9F4AFD, "run_split_up_hudson_scenes" },
    { 0x31C51CD6, "run_split_up_pdf_01_scenes" },
    { 0x48A4B8F3, "run_split_up_pdf_02_scenes" },
    { 0x6FEE7944, "run_split_up_pdf_03_scenes" },
    { 0xD66371AA, "run_split_up_pdf_enter_scene" },
    { 0x16539802, "run_split_up_woods_enter_scene" },
    { 0x0BAC1D40, "run_split_up_woods_scenes" },
    { 0xD755277F, "run_staff_crafted_vo" },
    { 0x0D7E6568, "run_subclass_spawn_function" },
    { 0x3AB52340, "run_swimming_sheeting" },
    { 0x85DE8386, "run_tank_scene" },
    { 0x881B89B9, "run_thread_on_noteworthy" },
    { 0xA63C6C0A, "run_thread_on_targetname" },
    { 0x4F9EF83C, "run_time" },
    { 0xBECEC796, "run_timer" },
    { 0x27A073FC, "run_to" },
    { 0x95FD36AF, "run_to_alert" },
    { 0xB1E54C45, "run_to_boat" },
    { 0x0D246FFD, "run_to_bridge_drones_drones_start" },
    { 0xB0C71A9F, "run_to_car" },
    { 0x1B3FE692, "run_to_clash" },
    { 0x44556A2D, "run_to_convoy" },
    { 0xDF053769, "run_to_cower" },
    { 0xFDD6C68F, "run_to_fake_grenade" },
    { 0xC8778842, "run_to_gate" },
    { 0x48C152BE, "run_to_goal_and_delete" },
    { 0x097C92F9, "run_to_jumper_damage_override" },
    { 0x2A6C3811, "run_to_new_spot_and_setup_gun" },
    { 0x7EE842BB, "run_to_node" },
    { 0x65A75ADE, "run_to_node_and_die" },
    { 0x03ECC0D6, "run_to_safe_volume_after_time" },
    { 0xABDFF79E, "run_to_snowcat" },
    { 0x31A47989, "run_to_steiners_office" },
    { 0x8CA77DB3, "run_to_the_door" },
    { 0xCD7BC5E9, "run_to_vehicle" },
    { 0x73A112B8, "run_to_vehicle_load" },
    { 0x7072D0CB, "run_to_vehicle_loaded" },
    { 0x0E8E2E0E, "run_to_vehicle_send_notify" },
    { 0xB97B00DB, "run_train" },
    { 0xD4FB00EB, "run_turret_damage" },
    { 0x361131C2, "run_turret_fx" },
    { 0x8584CBF4, "run_until_ambush" },
    { 0x62B5E7AA, "run_visibility_function_for_all_triggers" },
    { 0x0F28B00D, "run_volume" },
    { 0x2432509E, "run_volume1" },
    { 0xFE2FD635, "run_volume2" },
    { 0xD3266344, "run_volume_down" },
    { 0xEA8778EB, "run_volume_either" },
    { 0x552E2877, "run_volume_up" },
    { 0x4F7EBE9E, "run_volume_vertical" },
    { 0xA204C027, "run_volume_vertical_smooth" },
    { 0x280FC4D4, "run_wait_time" },
    { 0xE90438EC, "run_war_room_mixers" },
    { 0xC97AE4DE, "run_whole_ending" },
    { 0xE80AD188, "run_yaw" },
    { 0x7B69CFF1, "runa" },
    { 0x37A77605, "runaccuracymult" },
    { 0xAABDD376, "runaction" },
    { 0xCF20BD9F, "runandgundist" },
    { 0x89015310, "runanglerangethread" },
    { 0x7F65B587, "runanim" },
    { 0xA416B58B, "runanimationmocomp" },
    { 0x0FD8461A, "runanimname" },
    { 0x9A46E47E, "runanims" },
    { 0x7587A080, "runanimtranstime" },
    { 0x07020972, "runanimweights" },
    { 0x9AC98613, "runaround" },
    { 0x370E8DC6, "runaway" },
    { 0x739CDC26, "runaway_guy" },
    { 0xE53D3162, "runaway_update" },
    { 0x93DC90F4, "runback_guys" },
    { 0xA3E53855, "runbackwardanimname" },
    { 0x319E47AC, "runbackwards_cqb_distsq" },
    { 0x652E4C21, "runbackwards_distsq" },
    { 0xF6C42FD2, "runbamfreadjustmentanalysis" },
    { 0xC4DB8300, "runblendinduration" },
    { 0x6538531B, "runblendintime" },
    { 0x09B45D7F, "runblendout" },
    { 0x5C29A04C, "runblendouttime" },
    { 0x36CCF63E, "runblendtime" },
    { 0xB0EC4234, "runbreaker" },
    { 0xF394E568, "runcombat" },
    { 0x59C1B8D1, "rundebuginfo" },
    { 0x0B7E01BB, "rundecidewhatandhowtoshoot" },
    { 0x88FB49CD, "rundir" },
    { 0xE783E83B, "rundirection" },
    { 0xFF3F18DC, "rundown" },
    { 0xDBD5A32C, "runforcedbehaviors" },
    { 0xF8E75BE0, "runforwardanim" },
    { 0x9C95DD19, "runforwardanimname" },
    { 0x6CDFEAA9, "rungametypemain" },
    { 0x71149345, "rungametypeprecache" },
    { 0x1221411D, "rungather" },
    { 0x3B3EB55F, "runloopcount" },
    { 0xECABD1AE, "runloopindex" },
    { 0x63E6E981, "runloopisnearbeginning" },
    { 0x1DD12FFD, "runlooptime" },
    { 0x4323B75F, "runner" },
    { 0x0AAE23D4, "runner1" },
    { 0x7CB5930F, "runner2" },
    { 0x56B318A6, "runner3" },
    { 0xE47A2087, "runner_behaviour" },
    { 0x7EF32F9A, "runner_guys" },
    { 0xCEB7F786, "runner_kill_at_path_end" },
    { 0x2B62F11D, "runner_up_gesture_delay" },
    { 0xD751B2E6, "runners" },
    { 0x2B2364AF, "runners_group_cleanup" },
    { 0xE586B971, "runners_logic" },
    { 0x1DBB4AF6, "runnerupscore" },
    { 0x79A382A0, "runngun" },
    { 0x4DB203CB, "runngun120" },
    { 0xD1F2FB5E, "runngun_120_angle_threshold" },
    { 0x7109E536, "runngun_aim_angle_threshold" },
    { 0x37651185, "runngun_flr_angle_threshold" },
    { 0xBC137800, "runngun_parital_reload_time" },
    { 0xAA46AAAB, "runngunbackward" },
    { 0x931692AC, "runngunchooseaimanimnameprefix" },
    { 0x9D5C9774, "runngunchooserunanimname" },
    { 0xB6C3ADD7, "runngunforward" },
    { 0x86224A76, "runngunforwardtobackwardtransition" },
    { 0x670182C6, "runngunrate" },
    { 0x38DDBF2A, "running" },
    { 0x8ED96EBB, "running_at_poi" },
    { 0xA70BE060, "running_collectibles" },
    { 0x48B01FD1, "running_destroy_on_notify" },
    { 0x24D9DCF1, "running_flash_text" },
    { 0xAAF1A52E, "running_lights" },
    { 0x38F8FE8A, "running_on_fire_1_vignette" },
    { 0xECD7AF37, "running_on_fire_2_vignette" },
    { 0x92B71350, "running_on_fire_3_vignette" },
    { 0xBD08A40D, "running_on_fire_4_vignette" },
    { 0x6A9C4226, "running_on_fire_5_vignette" },
    { 0x506AA5ED, "running_terrorist" },
    { 0xAD7980FC, "runninglow" },
    { 0x8528E960, "runningtotal" },
    { 0x4B52B2F3, "runningtovehicle" },
    { 0x90E421C7, "runningtraverses" },
    { 0xFCB7D981, "runningtraveses" },
    { 0x3430375D, "runnodename" },
    { 0xC1DC8DB1, "runnormal" },
    { 0x7948E6B7, "runnotetrackhandler" },
    { 0x9C10604E, "runonly" },
    { 0xBA6B946F, "runonlyreact" },
    { 0x22D099A1, "runonshootbehaviorend" },
    { 0x20EC1B04, "runout" },
    { 0x3AEC24D6, "runout_array" },
    { 0x1782E585, "runout_clip" },
    { 0x16538002, "runover_by_horse_callback" },
    { 0x2890BFAF, "runpainblendout" },
    { 0x76E79ACD, "runpath" },
    { 0xC20ECCC6, "runpos" },
    { 0x561487CD, "runrules" },
    { 0x27966B53, "runs" },
    { 0x2E9C9222, "runs_up_stairs" },
    { 0x4A8C0FE3, "runsceneondmg0" },
    { 0x2489957A, "runsceneondmg1" },
    { 0xFE871B11, "runsceneondmg2" },
    { 0xD884A0A8, "runsceneondmg3" },
    { 0xE295F987, "runsceneondmg4" },
    { 0xA607B379, "runscriptonent" },
    { 0x7C85902D, "runsd" },
    { 0x135373EA, "runshootwhilemoving" },
    { 0x97912DF1, "runshootwhilemovingthreads" },
    { 0xD1A2C979, "runspeed" },
    { 0xAA1413B0, "runspeeds" },
    { 0x803CB133, "runtime" },
    { 0x2D73B2B3, "runto" },
    { 0xBF18B901, "runto_arrived" },
    { 0xA8143A0F, "runto_goal" },
    { 0x6590BCEB, "runto_sniper_cover" },
    { 0x1BDF68DA, "runtomeleeanim" },
    { 0xB77ED74A, "runtonodes" },
    { 0xD8DE02D2, "runtoposition" },
    { 0x4A42955C, "runtotarget" },
    { 0x781D5D19, "runtovehicle" },
    { 0x45B4C745, "runtovehicle_setgoal" },
    { 0xA7F16A71, "runtovehicleoverride" },
    { 0x5CD810BE, "runtrain" },
    { 0x61356EA1, "runtrains" },
    { 0x54D009C5, "runturn" },
    { 0x41D2196F, "runup" },
    { 0xA3F6F3C5, "runway" },
    { 0xDDF7D6B6, "runway_armada" },
    { 0xAED32600, "runway_armada_path" },
    { 0x0DAFA3DF, "runway_array" },
    { 0x8BBD3EF8, "runway_crate01" },
    { 0xCA44941D, "runway_crate01_start" },
    { 0x7D80B6B8, "runway_dialog" },
    { 0xA4DEECF6, "runway_hangar_mason" },
    { 0x338AD9C4, "runway_jets" },
    { 0xF4D29A22, "runway_org" },
    { 0x34A56C62, "runway_seals" },
    { 0x198D60F2, "runway_standoff_fail_timeout" },
    { 0x8A72BAD4, "runway_standoff_goes_hot" },
    { 0xFA95779D, "runway_standoff_main" },
    { 0x409D28A3, "runway_standoff_timeout" },
    { 0x04153062, "runway_structs" },
    { 0x3B9DE21F, "runway_uaz_damage_override" },
    { 0xC48917FD, "runway_vo" },
    { 0x99507524, "runway_zpu_aiming_logic" },
    { 0xD19D1AA6, "runway_zpus" },
    { 0xB71919D0, "rupture" },
    { 0x639FA4B4, "ruptured" },
    { 0x6D91024F, "rus_console_rad_break" },
    { 0x3F24A5F5, "rus_shreck_fired" },
    { 0xEA27C39A, "rusalka" },
    { 0x4606F0C2, "rusalka_bubbles" },
    { 0xB8B24600, "rusalka_end" },
    { 0xF6724371, "rusalka_explosions" },
    { 0x659E12A9, "rusalka_sinking_event" },
    { 0x2AED38D3, "rusalka_start" },
    { 0x0F0BE3C5, "rusedski" },
    { 0x7A3433AF, "rush" },
    { 0xB28E6B93, "rush_at_player" },
    { 0xEC9DC329, "rush_guys_die" },
    { 0x2CC698C5, "rush_player" },
    { 0xB8071AD7, "rush_potus" },
    { 0x9FBFBD19, "rush_to" },
    { 0x78374251, "rush_when_grouped" },
    { 0xE8BD12F4, "rushed" },
    { 0x3C907792, "rusher" },
    { 0x1F56AD50, "rusher_default_goalradius" },
    { 0x5DFFBB06, "rusher_default_pathenemydist" },
    { 0x7421C7DC, "rusher_distance" },
    { 0xB6BA0F01, "rusher_go_back_to_normal" },
    { 0x8B6F759A, "rusher_guy" },
    { 0xBAC7088E, "rusher_pistol_pathenemydist" },
    { 0x87DB16FE, "rusher_reset" },
    { 0x5588A564, "rusher_setup" },
    { 0x5C4E9293, "rusher_threatbias_check" },
    { 0xDDE58F85, "rusher_time_last" },
    { 0x349A45C5, "rusher_yelling" },
    { 0x8A064BB1, "rusherdesiredgunhand" },
    { 0x2EA9D6EF, "rusherdesiredstepdir" },
    { 0x6A9158CF, "rushergunhand" },
    { 0xB1ECA416, "rusherhadsidestepevent" },
    { 0x73E490BE, "rusherlastsidesteptime" },
    { 0x5CDF3FD6, "rushernexttime" },
    { 0xE2A37F9D, "rushers" },
    { 0x06BF614E, "rushers_active" },
    { 0x5ED6B8B5, "rushersidesteptype" },
    { 0x890CA764, "rushersteppeddir" },
    { 0x061C0DAD, "rushertime" },
    { 0xD692FAE2, "rushertype" },
    { 0x6292F1FB, "rushes" },
    { 0xD2138791, "rushing" },
    { 0xEA5AB2AC, "rushing_goalent" },
    { 0x06A23515, "russ01" },
    { 0x2CA4AF7E, "russ02" },
    { 0x3A892F04, "russ_melee_spawner" },
    { 0x9CC16CC6, "russia" },
    { 0xC5A91C6C, "russian" },
    { 0x5B1291DD, "russian1" },
    { 0x81150C46, "russian2" },
    { 0x51A34850, "russian_1" },
    { 0xC3AAB78B, "russian_2" },
    { 0x3BFA8DDE, "russian_array" },
    { 0xF3139C9F, "russian_base_train_dev" },
    { 0x11DCD1B6, "russian_color_chain" },
    { 0xE2D8993B, "russian_corpse" },
    { 0x1BD8D00D, "russian_diary_event" },
    { 0x5E903AF6, "russian_fire_kill_1" },
    { 0x388DC08D, "russian_fire_kill_2" },
    { 0x65C21A2E, "russian_flag_dropped" },
    { 0x8C1FD2B7, "russian_flag_hud" },
    { 0x95A4ECEC, "russian_flag_hud_fadeout" },
    { 0x9D971B64, "russian_flag_hud_init" },
    { 0xA3E72DDA, "russian_flag_init" },
    { 0x13CA4481, "russian_flag_mission_fail" },
    { 0xFF6F444C, "russian_flag_objectives" },
    { 0x48DB09E3, "russian_flag_player_carry" },
    { 0x1D8615ED, "russian_flag_proxcheck" },
    { 0xD0AEFFD8, "russian_flag_startthink" },
    { 0x64AB7585, "russian_flag_teleport" },
    { 0x928BE3D4, "russian_flag_think" },
    { 0x8EB30A61, "russian_flag_timer_hud" },
    { 0xBF176E80, "russian_leader" },
    { 0xE5191D29, "russian_leader_think" },
    { 0xD1C62DD1, "russian_names" },
    { 0xBC3B21C7, "russian_roulette" },
    { 0xB8B96013, "russian_soldiertype" },
    { 0x77C03DB2, "russian_speaker" },
    { 0x110597BA, "russianflag" },
    { 0x654449DF, "russianflaganglesoffset" },
    { 0xFAA78884, "russianflaghudfadetime" },
    { 0xC9E547A1, "russianflagoriginoffset" },
    { 0x2678EC6F, "russians" },
    { 0x69DC65D4, "russki" },
    { 0x82A03550, "russman" },
    { 0x1091B268, "russuan" },
    { 0x9B70F7B8, "rusted" },
    { 0xB804323A, "rustic_hanging" },
    { 0x05EECD8B, "rustic_sconce" },
    { 0x611445CF, "ruun" },
    { 0x8D5E5CF9, "rv" },
    { 0x9E3A9472, "rva" },
    { 0x612F807A, "rval" },
    { 0x9D80B519, "rvec" },
    { 0xED10AADA, "rw_attachments_allowed" },
    { 0xF9752152, "rw_enabled" },
    { 0x5D290600, "rw_ft_allowed" },
    { 0x7983D437, "rw_gl_allowed" },
    { 0xE9FDFEF2, "rw_mk_allowed" },
    { 0xA1810EB7, "rx" },
    { 0x7B7E944E, "ry" },
    { 0x25C48147, "ryan" },
    { 0x0D8E7BBC, "s" },
    { 0xAA369F1E, "s01aw1" },
    { 0xAE223212, "s01uw1" },
    { 0x881FB7A9, "s01uw2" },
    { 0x9976E9ED, "s1" },
    { 0xBF796456, "s2" },
    { 0xA34676E5, "s3_checkpoint_save_restored" },
    { 0xF665E0E9, "s3_fail_player_damage_override" },
    { 0xD76AD214, "s3_player_fail" },
    { 0xDB2F228B, "s4s" },
    { 0x34980903, "s_a_structs" },
    { 0x9338D2BD, "s_aat_blast_furnace_explosion" },
    { 0xFF43CB27, "s_activate_pos" },
    { 0xACFD7C30, "s_active_vortex" },
    { 0x0EB5481A, "s_actor" },
    { 0x06DF191E, "s_align" },
    { 0x88B44C61, "s_aligned" },
    { 0xCB13E1BA, "s_amp_spot" },
    { 0x6E9CFC40, "s_anchor" },
    { 0x46EB85C4, "s_anim" },
    { 0xE4517878, "s_anim_1" },
    { 0x5658E7B3, "s_anim_2" },
    { 0xD1445020, "s_animlength" },
    { 0xFB41F677, "s_anims" },
    { 0x9FD6EDB0, "s_apache_strafe_start" },
    { 0xA18567A7, "s_approach" },
    { 0x263CB2C3, "s_arch_goal" },
    { 0xB13322DA, "s_arena_delete" },
    { 0xF86009C1, "s_arena_start" },
    { 0xB076C749, "s_armory" },
    { 0x66A8012E, "s_array" },
    { 0x06E2B621, "s_ascent" },
    { 0x715DC4D1, "s_asd_2_spot" },
    { 0xC9CD43A6, "s_asd_elevator_target" },
    { 0x02A0D6B9, "s_asd_fallback_pos" },
    { 0xD1742C56, "s_asd_hallway_target" },
    { 0xEFBCC43D, "s_asd_player_defend_spot" },
    { 0x7D242894, "s_asd_player_rollout_spot" },
    { 0x848E68B7, "s_asd_rpg_end" },
    { 0xCCB58884, "s_asd_rpg_end_2" },
    { 0xF2B802ED, "s_asd_rpg_end_3" },
    { 0x80B093B2, "s_asd_rpg_end_4" },
    { 0xDE92319C, "s_asd_rpg_start" },
    { 0xBC9791BB, "s_asd_rpg_start_2" },
    { 0x96951752, "s_asd_rpg_start_3" },
    { 0x089C868D, "s_asd_rpg_start_4" },
    { 0x290B5BD4, "s_asd_turret_target_end" },
    { 0x71D91B35, "s_asd_tutorial_spot" },
    { 0x24333E9D, "s_ashtray" },
    { 0xBF0AE2A4, "s_asset_info" },
    { 0x0CD78025, "s_attached_model" },
    { 0x8388EBCC, "s_attachment" },
    { 0xC7F30F4D, "s_attack_generator" },
    { 0x6829D61C, "s_attack_point" },
    { 0x87DF6D87, "s_attackpt" },
    { 0x5B66C7FD, "s_away" },
    { 0x54C49027, "s_axe_obj" },
    { 0x6CE1475B, "s_back_celerium_door_rumble_dist" },
    { 0xF3A64933, "s_barn_door" },
    { 0x1DBD3E04, "s_barrier" },
    { 0x4F28EF54, "s_base" },
    { 0xB0E73DC5, "s_bathtub" },
    { 0x85D5470D, "s_battleship_end" },
    { 0xDA9B8022, "s_beam" },
    { 0x046CCB6B, "s_bigdog" },
    { 0x62BB4E65, "s_biplane_pos" },
    { 0xDCA972BC, "s_bird_fx_org" },
    { 0xB6D6D824, "s_blockade_obj" },
    { 0x38FCFB15, "s_blocker_end" },
    { 0x0AE29C44, "s_blow_up_horse_loc" },
    { 0x489BA94C, "s_bomb1" },
    { 0xBAA31887, "s_bomb2" },
    { 0x94A09E1E, "s_bomb3" },
    { 0xD6943A11, "s_bomb4" },
    { 0xE668FD3A, "s_box" },
    { 0xC78652EB, "s_bp1_entrance" },
    { 0xD92514D4, "s_bp1_goal" },
    { 0xC6E08546, "s_bp2_entrance" },
    { 0xEE50DD71, "s_bp2_exit_battle" },
    { 0x88A35EDF, "s_bp2_exit_divert" },
    { 0xC0FF7769, "s_bp3_entrance" },
    { 0x4E917FDF, "s_bp3_exit" },
    { 0xC6856E2C, "s_bridge" },
    { 0xE456769C, "s_bridge_target" },
    { 0x7B5BE92E, "s_briggs_origin" },
    { 0xD3F653C5, "s_brute" },
    { 0x9FB95AA2, "s_brute_force_pos" },
    { 0x6FFC869A, "s_btr1_spawnpt" },
    { 0x15158BB9, "s_btr2_spawnpt" },
    { 0x555C55B9, "s_btr_goal" },
    { 0x2738E251, "s_btr_spawnpt" },
    { 0x0638D529, "s_buffel_target" },
    { 0x82203972, "s_building_end_point" },
    { 0xC783F095, "s_building_fall" },
    { 0x5E8393B7, "s_bullet" },
    { 0xC9550DE9, "s_bullet_end" },
    { 0xC248E0AB, "s_bundle" },
    { 0xCC938433, "s_bus_goal" },
    { 0xEB98D76A, "s_bus_spot" },
    { 0xD704343F, "s_button" },
    { 0xCBCA6502, "s_c" },
    { 0xCFDFB913, "s_cache" },
    { 0x4AA4D230, "s_cache1" },
    { 0xBCAC416B, "s_cache2" },
    { 0x96A9C702, "s_cache3" },
    { 0x08B1363D, "s_cache4" },
    { 0x88A1B736, "s_callback" },
    { 0xB5F70D8D, "s_cam_origin" },
    { 0x865F8B0E, "s_camera" },
    { 0x8D6BEE03, "s_camera_origin" },
    { 0x4E58DC06, "s_camera_target" },
    { 0x76D0C1EC, "s_candle" },
    { 0xA6A4E5B8, "s_cannon" },
    { 0x93A3CA72, "s_capture_spot" },
    { 0x26EF0DF7, "s_category" },
    { 0xFA0703BC, "s_cave" },
    { 0xE3C6E92B, "s_cell" },
    { 0x75CA3CC2, "s_centerpoint" },
    { 0x649A5B47, "s_chair_origin" },
    { 0x43A65086, "s_challenge" },
    { 0xA2BF8BD9, "s_chamber_center" },
    { 0xF1F293FF, "s_chamber_path" },
    { 0x93E5965C, "s_chase_window_impulse_position" },
    { 0xA9191369, "s_check" },
    { 0x3182C9B3, "s_child" },
    { 0x6C504C8C, "s_child_zone" },
    { 0x6B1A5B5B, "s_chord" },
    { 0x0BE7D462, "s_church" },
    { 0x3AFF59ED, "s_claw_ai_startup_position" },
    { 0x19B12328, "s_claw_target_end" },
    { 0x44EEDBCB, "s_claw_target_start" },
    { 0xCA71B815, "s_cleanup" },
    { 0xDB57F972, "s_clear" },
    { 0xFABF9B60, "s_clone_plant" },
    { 0x0428A8B0, "s_closest" },
    { 0x19E27631, "s_club_elevator_left_close" },
    { 0xD395C753, "s_club_elevator_left_open" },
    { 0x67DC012E, "s_club_elevator_right_close" },
    { 0x7BBF2CAA, "s_club_elevator_right_open" },
    { 0x9C9048BC, "s_club_origin" },
    { 0x9201078F, "s_column_target" },
    { 0xB8B3F0F8, "s_common" },
    { 0xF5A38D8A, "s_container_instance" },
    { 0x6B5D618C, "s_convoy_dust" },
    { 0xB20671C5, "s_cougar_spawner" },
    { 0xEA009D9F, "s_courtyard_defend" },
    { 0x6B61D46B, "s_courtyard_fountain" },
    { 0x304B3696, "s_courtyard_goal" },
    { 0xDECDA663, "s_courtyard_spot" },
    { 0x3111271F, "s_craftable" },
    { 0x6C5BBB3F, "s_crash_point" },
    { 0x8BE32968, "s_crosby_speed_up_pos" },
    { 0xCF0FAE46, "s_crowd_center" },
    { 0x6A6F05C3, "s_crumb_pos" },
    { 0x30C2E117, "s_crystal" },
    { 0x701C98E6, "s_cur_bundle" },
    { 0x6A197E6A, "s_current" },
    { 0x1536E431, "s_current_spot" },
    { 0x80C98DFE, "s_current_struct" },
    { 0x8B09305D, "s_custom_perk" },
    { 0x4BE6612A, "s_dancer" },
    { 0xCE265AB3, "s_data" },
    { 0x167090B7, "s_defend" },
    { 0xC1646F09, "s_defend_area" },
    { 0x4D8EAA12, "s_defend_spot" },
    { 0x83E3D172, "s_delete" },
    { 0x973997CC, "s_delete_door_spot" },
    { 0x8DF19276, "s_descend_start" },
    { 0x1EDB317B, "s_dest" },
    { 0x6EAC3A5A, "s_dest_bigdog" },
    { 0xB8B02E0B, "s_dest_hoist" },
    { 0xAD12CB15, "s_dest_struct" },
    { 0xBAA5BCB1, "s_destination" },
    { 0x0561989D, "s_detachpoint_origin" },
    { 0x495593A0, "s_detonate_point" },
    { 0x49A9DDF8, "s_dig_spot" },
    { 0x77B2D567, "s_door" },
    { 0xD10A1092, "s_door_bundle" },
    { 0x039216D3, "s_door_instance" },
    { 0x1202C509, "s_door_struct" },
    { 0x1392138C, "s_drama_struct" },
    { 0x4BDED2FE, "s_drive_point" },
    { 0x0A2C38BD, "s_drive_point_last" },
    { 0xA11BBB3F, "s_drone" },
    { 0x8D9095E4, "s_drone_archway_pos" },
    { 0x2C96E51F, "s_drone_fallback_pos" },
    { 0x8380C17C, "s_drone_pos" },
    { 0x9BAF60A6, "s_drone_rooftop_pos" },
    { 0x595245C7, "s_drone_spotlight_target_balcony" },
    { 0xACB32FD9, "s_drone_spotlight_target_balcony_end" },
    { 0x6B7D1798, "s_drone_spotlight_target_helipad" },
    { 0xF7AE794D, "s_drone_target" },
    { 0x95C7CA68, "s_drop" },
    { 0xA072ACF3, "s_drop_pt" },
    { 0x40224D67, "s_dropoff" },
    { 0xD33732A6, "s_dummy_origin" },
    { 0x39EBF31B, "s_dyn_ents_center" },
    { 0x17CF59D4, "s_e" },
    { 0x67F2D5D8, "s_e3_left_close" },
    { 0xDEBCBE3C, "s_e3_left_open" },
    { 0x1EAA41A5, "s_e3_right_close" },
    { 0xDCF7E04F, "s_e3_right_open" },
    { 0x783C9782, "s_effect_array" },
    { 0xD6DB3FDA, "s_elec_spark" },
    { 0xAE344069, "s_element" },
    { 0x455AD94D, "s_elemental_staff" },
    { 0x1449B1C9, "s_elevator_light_attach_marker" },
    { 0x51829EB4, "s_elevator_spotight_struct" },
    { 0xFA927B2B, "s_emergence_hole" },
    { 0x96EED922, "s_end" },
    { 0x5AE1BD2F, "s_end_asd_lift_target" },
    { 0x424F32DC, "s_end_goal" },
    { 0x87523001, "s_end_pos" },
    { 0xA5E4FD0D, "s_entry" },
    { 0x3C96A936, "s_escape" },
    { 0x13E0BE3E, "s_evac" },
    { 0xE59C9AE3, "s_exit" },
    { 0x3C22D900, "s_exit_battle" },
    { 0x091C61BE, "s_exit_spot" },
    { 0x1E829B3C, "s_exp" },
    { 0xC9C4806D, "s_exp1" },
    { 0xEFC6FAD6, "s_exp2" },
    { 0x15C9753F, "s_exp3" },
    { 0xECE82E06, "s_explode" },
    { 0x98A6A952, "s_explode_struct" },
    { 0x569BB3F4, "s_explosion" },
    { 0x54204CDD, "s_explosion01" },
    { 0xCA6058AF, "s_explosion_point" },
    { 0xA7E86F6E, "s_extinguisher" },
    { 0x1792AFF7, "s_eye_origin" },
    { 0x71FEDFAB, "s_f35_position" },
    { 0xE81DD48A, "s_facing_pos" },
    { 0xE426F21E, "s_fake_mirror" },
    { 0x7E0C21CA, "s_farthest" },
    { 0x95309F22, "s_female_bundle" },
    { 0x28815999, "s_final" },
    { 0xA45A39CD, "s_final_goal" },
    { 0x025E10AF, "s_fire" },
    { 0x229AD564, "s_fire1" },
    { 0x94A2449F, "s_fire2" },
    { 0x37636EAE, "s_fire_from" },
    { 0x6D868536, "s_fire_missile_target" },
    { 0x3DF09ECA, "s_first_spot" },
    { 0x782AB731, "s_flank_physics" },
    { 0x4E29603D, "s_flare_sky_effect" },
    { 0x31D80C55, "s_flash_target" },
    { 0xE4E23BA9, "s_flight_goal" },
    { 0x8CB35C1C, "s_float_point" },
    { 0x9BE44398, "s_footprint" },
    { 0x394335E1, "s_found" },
    { 0x91517C73, "s_fountain" },
    { 0x42AE5784, "s_fountain_clip" },
    { 0x6A9C686E, "s_fountain_spot" },
    { 0xFE564112, "s_freeway" },
    { 0x09776925, "s_front_celerium_door_rumble_dist" },
    { 0x6E9ED630, "s_front_lab_door_rumble_dist" },
    { 0xBA154E51, "s_func" },
    { 0xEC9F55FA, "s_func_filter" },
    { 0x21A29E0E, "s_furthest" },
    { 0x1CF896B5, "s_fx" },
    { 0xEFF8C94A, "s_fxanim" },
    { 0x04571551, "s_fxloc" },
    { 0x1BACE747, "s_game_difficulty" },
    { 0x5F06EA62, "s_garage_back_door_fx" },
    { 0xDB21EE9F, "s_garage_spot" },
    { 0xBF8AA41F, "s_garage_window_target_end" },
    { 0x47655DBC, "s_garage_window_target_end_2" },
    { 0xA1622E92, "s_generator" },
    { 0x8346708C, "s_glass_hallway_damage_pulse" },
    { 0x713E715E, "s_goal" },
    { 0x4324D06A, "s_goal0" },
    { 0xE2CEEAB7, "s_goal01" },
    { 0x70C77B7C, "s_goal02" },
    { 0x96C9F5E5, "s_goal03" },
    { 0x24C286AA, "s_goal04" },
    { 0x4AC50113, "s_goal05" },
    { 0xD8BD91D8, "s_goal06" },
    { 0xFEC00C41, "s_goal07" },
    { 0x8CB89D06, "s_goal08" },
    { 0xB2BB176F, "s_goal09" },
    { 0x69274AD3, "s_goal1" },
    { 0x7C51BDD9, "s_goal10" },
    { 0x564F4370, "s_goal11" },
    { 0xC856B2AB, "s_goal12" },
    { 0xA2543842, "s_goal13" },
    { 0x145BA77D, "s_goal14" },
    { 0xEE592D14, "s_goal15" },
    { 0xF71FDB98, "s_goal2" },
    { 0x1D225601, "s_goal3" },
    { 0xDB2EBA0E, "s_goal4" },
    { 0x01313477, "s_goal5" },
    { 0x8F29C53C, "s_goal6" },
    { 0xB52C3FA5, "s_goal7" },
    { 0xA5748677, "s_goal_0" },
    { 0x7F720C0E, "s_goal_1" },
    { 0x596F91A5, "s_goal_2" },
    { 0x336D173C, "s_goal_3" },
    { 0x0D6A9CD3, "s_goal_4" },
    { 0xE768226A, "s_goal_5" },
    { 0xC165A801, "s_goal_6" },
    { 0x9B632D98, "s_goal_7" },
    { 0x7560B32F, "s_goal_8" },
    { 0x15B746B9, "s_goal_curr" },
    { 0xC1125E89, "s_goal_dropoff" },
    { 0xEDC209DE, "s_goal_prev" },
    { 0xB14C266F, "s_goal_set" },
    { 0x4FB08D95, "s_goal_spot" },
    { 0x40AC56F5, "s_goalfar" },
    { 0x0DB4B5E0, "s_goalpos" },
    { 0x8BF9F6A6, "s_goto" },
    { 0xA98D552B, "s_grapple_point" },
    { 0xCB00AB3B, "s_grass" },
    { 0x0C2B234B, "s_grenade_1" },
    { 0x9A23B410, "s_grenade_2" },
    { 0x3301085D, "s_grenade_end" },
    { 0x1C310D56, "s_grenade_spot" },
    { 0x222AAFCE, "s_grenade_start" },
    { 0x8C342044, "s_groundref_x" },
    { 0xB2369AAD, "s_groundref_y" },
    { 0xD8391516, "s_groundref_z" },
    { 0x49F598D0, "s_gun1" },
    { 0xEF911DA0, "s_gun1_target" },
    { 0xBBFD080B, "s_gun2" },
    { 0xF7DE2E59, "s_gun2_target" },
    { 0x95FA8DA2, "s_gun3" },
    { 0x6A7407AA, "s_gun3_target" },
    { 0x54F0F697, "s_gunfire_1" },
    { 0xE2E9875C, "s_gunfire_2" },
    { 0x08EC01C5, "s_gunfire_3" },
    { 0xA7C62984, "s_hallway_rockets_start" },
    { 0x61FFD7CC, "s_harper_speed_up_pos" },
    { 0x87142229, "s_harper_titus_target" },
    { 0xEE1EC63C, "s_haycart_dest" },
    { 0xE3E32271, "s_hind1_spawnpt" },
    { 0xE8288A92, "s_hind2_spawnpt" },
    { 0xE8A2C038, "s_hinge" },
    { 0xC2AE7725, "s_hint_tag" },
    { 0x1B8E7657, "s_hip1_spawnpt" },
    { 0x537F57A0, "s_hip2" },
    { 0x24CD3127, "s_hip2_dest" },
    { 0xFB7B5507, "s_hip2_mid" },
    { 0x15290624, "s_hip2_spawnpt" },
    { 0xBD3D3A15, "s_hip2_start" },
    { 0x7981D209, "s_hip3" },
    { 0x1A098590, "s_hip3_air" },
    { 0x6E0EE075, "s_hip3_app" },
    { 0x662ECB7B, "s_hip3_end" },
    { 0xF17BBA2F, "s_hip3_far" },
    { 0x633D0703, "s_hip3_land" },
    { 0xE8D95372, "s_hip3_mid" },
    { 0x20D4B081, "s_hip3_spawn" },
    { 0x165DFFD8, "s_hip3_start" },
    { 0x65F3743C, "s_hip3_takeoff" },
    { 0xE63DDEDB, "s_hip_air" },
    { 0x972F10E5, "s_hip_approach" },
    { 0x2B96A48B, "s_hip_away" },
    { 0xB040EEFF, "s_hip_bank" },
    { 0xA9C9AFCD, "s_hip_descent" },
    { 0xC4DE96BF, "s_hip_dive" },
    { 0xFB2BADE0, "s_hip_dustoff" },
    { 0xAC5159A5, "s_hip_hover" },
    { 0x417202C5, "s_hip_liftoff" },
    { 0x27F61409, "s_hip_mid" },
    { 0x26BE19F7, "s_hip_over" },
    { 0xE47FD1B6, "s_hip_spawn" },
    { 0xBF64C9E2, "s_hip_spawnpt" },
    { 0x8BBFBFAC, "s_hip_turn" },
    { 0x56FC1AA3, "s_hitchpt" },
    { 0x10675F80, "s_hoist" },
    { 0xED8510F9, "s_horse_goal1" },
    { 0xC01D9E1A, "s_horse_player" },
    { 0x16096C5A, "s_horse_spawnpt" },
    { 0xAB7C46F5, "s_horse_woods" },
    { 0x634CDD6B, "s_horse_zhao" },
    { 0x1909D9E3, "s_hotel" },
    { 0x46AFDF8B, "s_info" },
    { 0xA8EA877F, "s_inst" },
    { 0x54BCF42A, "s_instance" },
    { 0x2F342185, "s_intro_align" },
    { 0x989F57CE, "s_intro_drone_spotlight_pos" },
    { 0xCAD7395E, "s_intruder" },
    { 0x7FCFF18C, "s_intruder_obj" },
    { 0xE76E567D, "s_intruder_pos" },
    { 0x9291CB2E, "s_jetpack_entries" },
    { 0x3E60DEBE, "s_jetpack_entry" },
    { 0xF363E429, "s_jetwing" },
    { 0x0091949F, "s_kill" },
    { 0x9E1D71C3, "s_kill_01" },
    { 0x2C160288, "s_kill_02" },
    { 0xB3AE8562, "s_killer" },
    { 0x1005F1BF, "s_ladder" },
    { 0xC574FEC8, "s_landing" },
    { 0xF0D03B43, "s_landing_point" },
    { 0xA866A38E, "s_last_recapture_zone" },
    { 0x669D5BAA, "s_last_stand_magicbullet" },
    { 0x84EAA5B0, "s_last_stand_magicbullet_end" },
    { 0xD1BA8E4E, "s_launch" },
    { 0x50D3442F, "s_leaper_spawn_point" },
    { 0x5EA789B4, "s_left" },
    { 0x71A3F8B7, "s_left_asd_attack_pos" },
    { 0x33652A6E, "s_left_door_closed" },
    { 0x3CBEFB2A, "s_left_door_open" },
    { 0x814338A2, "s_left_mirror" },
    { 0x269D72DF, "s_lift_asd_target_1" },
    { 0xB49603A4, "s_lift_asd_target_2" },
    { 0xDA987E0D, "s_lift_asd_target_3" },
    { 0xA668582F, "s_liftoff" },
    { 0xC579D343, "s_lightboard" },
    { 0xA6E65677, "s_lightfx" },
    { 0x2E0E969C, "s_lightfx1" },
    { 0x95B14F5E, "s_limpspeed" },
    { 0x57210FD1, "s_limpspeedsettime" },
    { 0x2149D354, "s_lion_spot" },
    { 0x99D1C353, "s_loc" },
    { 0x3F048B05, "s_loc_end" },
    { 0x6DFDE1FE, "s_location" },
    { 0x5D5EB2E3, "s_lock_breaker" },
    { 0x91C414CE, "s_look" },
    { 0xD29ECEE5, "s_look_spot" },
    { 0x4C92143D, "s_lookat" },
    { 0x0C1D58CC, "s_lookat_car_slide" },
    { 0xDD891766, "s_lookat_stat" },
    { 0x28580147, "s_m203_end_1" },
    { 0xB650920C, "s_m203_end_2" },
    { 0xCBD2AED8, "s_m203_start_1" },
    { 0x3DDA1E13, "s_m203_start_2" },
    { 0x169FED5D, "s_m_each_fxanim_with_name" },
    { 0xB79AD3E5, "s_magic_bullet_end" },
    { 0xFCA81646, "s_magic_bullet_start" },
    { 0x3EAEDC4B, "s_male_bundle" },
    { 0xE0499942, "s_market_exit" },
    { 0xC5A9F533, "s_market_goal" },
    { 0x17542231, "s_mason_horse" },
    { 0xE7647955, "s_mason_horse_spawnpt" },
    { 0x5B4A0A4F, "s_max" },
    { 0x875A7DF1, "s_menendez" },
    { 0x1E84A0A3, "s_menendez_end" },
    { 0xEFCDA772, "s_menu" },
    { 0xBB4ABD3D, "s_metal_storms_meet" },
    { 0x94325F0B, "s_mg_spawn" },
    { 0x5E864562, "s_midair_nade_explosion" },
    { 0x030E3ECD, "s_mig23" },
    { 0x7CB8A43F, "s_mig23_end" },
    { 0x6D5A7F2E, "s_mig23_mid" },
    { 0xC71F86E6, "s_mig_delete" },
    { 0x5F08FD84, "s_mig_spawnpt" },
    { 0x3E707975, "s_mig_start" },
    { 0x2A464606, "s_militia_leader" },
    { 0xF6A95EBC, "s_militia_leader_end" },
    { 0xEDD22BF1, "s_min" },
    { 0x7017BDFA, "s_missile_org" },
    { 0x161031D2, "s_model" },
    { 0x61406E20, "s_mortar" },
    { 0x3FD59E0B, "s_mortar1_obj" },
    { 0x72416C80, "s_mortar2_obj" },
    { 0x58ED2D0C, "s_mortar_drop" },
    { 0xC9AE8ACB, "s_mortars" },
    { 0x27322294, "s_morter" },
    { 0x5C119772, "s_moveloc" },
    { 0xDBC68FDB, "s_moveto_1" },
    { 0x69BF20A0, "s_moveto_2" },
    { 0x163C36D8, "s_mystery_box" },
    { 0x0903B73E, "s_name" },
    { 0x8339D654, "s_nearest_staff" },
    { 0x4DB59340, "s_new_loc" },
    { 0x74ADB9B4, "s_next" },
    { 0x7932BF03, "s_next_bundle" },
    { 0x1046BFBA, "s_next_female_bundle" },
    { 0x263175F7, "s_next_pos" },
    { 0x9DA14418, "s_nextdest" },
    { 0xD2A56C8F, "s_nextscriptclientid" },
    { 0xADFF5097, "s_nextstruct" },
    { 0xAE49FA42, "s_nitrogen_asd_elevator_pos" },
    { 0x5B01A37B, "s_node" },
    { 0xE33CB740, "s_nook" },
    { 0x93E821EE, "s_o" },
    { 0xD5F66652, "s_obj" },
    { 0xB54CFCB8, "s_obj_alley" },
    { 0x36A89846, "s_obj_bridge" },
    { 0xC1E5C4DC, "s_obj_escape_jungle_1" },
    { 0x33ED3417, "s_obj_escape_jungle_2" },
    { 0x27931071, "s_obj_execution" },
    { 0xC4FA77D3, "s_obj_gauntlet" },
    { 0xF3281E11, "s_obj_pos" },
    { 0xD8650B77, "s_objdef" },
    { 0x06FDC1AA, "s_object" },
    { 0x1DC69BCC, "s_objective" },
    { 0x4D944339, "s_objective_marker" },
    { 0xB2A4C654, "s_old_rappel_data" },
    { 0xD6E89D77, "s_org" },
    { 0x47842D99, "s_origin" },
    { 0x47E3798D, "s_origin_1" },
    { 0x6DE5F3F6, "s_origin_2" },
    { 0xD1AD01B9, "s_original_pos" },
    { 0x60AD6229, "s_over" },
    { 0xD7594E96, "s_pap" },
    { 0x37293023, "s_parent" },
    { 0x4D06071B, "s_parent_fxanim" },
    { 0xB6B42D20, "s_parent_stat" },
    { 0x0CFDA39E, "s_path" },
    { 0xEF3CA11F, "s_path_start" },
    { 0x02E51213, "s_phys" },
    { 0x39118B7C, "s_physics_pulse" },
    { 0xB1028D0B, "s_piece" },
    { 0xA5D579D7, "s_pillar" },
    { 0x67D5DCA2, "s_planes" },
    { 0xEAAB1AD4, "s_player" },
    { 0x4CE6C635, "s_player_asd_emp_pos" },
    { 0x5DF1C2F1, "s_player_asd_fallback_pos" },
    { 0xDDB2274B, "s_player_data" },
    { 0x196AE936, "s_player_horse" },
    { 0x63AD3382, "s_player_horse_spawnpt" },
    { 0xFEABAE31, "s_player_origin" },
    { 0x83C587DE, "s_player_origin_2" },
    { 0xC31097D7, "s_player_pos" },
    { 0xA062895A, "s_player_rotated" },
    { 0x361752FD, "s_player_set" },
    { 0x5B8F1241, "s_player_start" },
    { 0x7506F721, "s_player_stat" },
    { 0x47DA0BC8, "s_player_stats" },
    { 0x906065C3, "s_playerattach" },
    { 0x84ED7C81, "s_pmc" },
    { 0x03D77845, "s_poi" },
    { 0x87F1DBF0, "s_poi_list" },
    { 0x4B51AB17, "s_point" },
    { 0x0101A76D, "s_portal" },
    { 0xBFA0F33F, "s_pos" },
    { 0x6B203CA0, "s_pos_tomahawk" },
    { 0x37435102, "s_pos_trigger" },
    { 0x086B0A02, "s_position" },
    { 0xC5BB2B7D, "s_powerup" },
    { 0xF05DFE32, "s_powerup_loc" },
    { 0xB70E80D3, "s_prev_node" },
    { 0x5136FF7C, "s_prop_anim" },
    { 0xFB7DC5BC, "s_pullout_pulwar_obj" },
    { 0x6A2491D7, "s_purple_smoke" },
    { 0x91A538DB, "s_r" },
    { 0xF840605D, "s_radius" },
    { 0x22727387, "s_rage_settings_high" },
    { 0x57531253, "s_rage_settings_low" },
    { 0x5710B87E, "s_rappel_data" },
    { 0xF3CD2385, "s_rappel_end" },
    { 0xD09F13C4, "s_rappel_point" },
    { 0x9980A8E6, "s_rappel_start" },
    { 0x6D70B40D, "s_rappel_struct" },
    { 0xC4C75608, "s_ready" },
    { 0x075ED73F, "s_real_mirror" },
    { 0x6BA5F527, "s_rear_lab_door_rumble_dist" },
    { 0x9C45216B, "s_recapture_target_zone" },
    { 0xD1BE77D3, "s_recapture_zone" },
    { 0xE0795CEA, "s_reference" },
    { 0x42B04582, "s_relay" },
    { 0xE6B1130C, "s_retreat" },
    { 0x161A6C71, "s_return" },
    { 0x89AAF0AB, "s_return_base" },
    { 0x0B607E2B, "s_revive_override" },
    { 0x41B4E079, "s_revive_override_used" },
    { 0x69250AE7, "s_reward_origin" },
    { 0x1E9EDE88, "s_rideoff" },
    { 0x43355771, "s_rider" },
    { 0x4EA92C6B, "s_right" },
    { 0x594C47C2, "s_right_asd_attack_pos" },
    { 0x19CFE2D5, "s_right_door_closed" },
    { 0x94C7FAAD, "s_right_door_open" },
    { 0x85792D6F, "s_right_mirror" },
    { 0x8AB5FE6A, "s_right_path_asd_attack_pos" },
    { 0x78E847A3, "s_right_path_asd_fallback" },
    { 0x67B3F281, "s_robot_path" },
    { 0xD25F1258, "s_rock" },
    { 0xECC482DE, "s_rooftop_claw_goal" },
    { 0x5639185B, "s_rot_origin" },
    { 0x7B5DE48C, "s_rpg" },
    { 0x219BAD12, "s_rpg_end" },
    { 0x032328D1, "s_rpg_end_pos" },
    { 0x729F16C9, "s_rpg_start" },
    { 0x73D1830A, "s_rpg_start_pos" },
    { 0x364FD53C, "s_rpg_target" },
    { 0x63A5B940, "s_rumble" },
    { 0xF75B96FA, "s_run" },
    { 0x68EA5EE1, "s_run_spot" },
    { 0x52BDCC21, "s_runoff" },
    { 0x0692BB1E, "s_runto_point" },
    { 0x4C341F54, "s_runto_spot" },
    { 0x6BA2BE72, "s_s" },
    { 0x6F4B9F81, "s_safety" },
    { 0x5693D150, "s_salazar_speed_up_pos" },
    { 0xC6919C9B, "s_scan_loc" },
    { 0x1CBCB46D, "s_scene" },
    { 0x0ABC7134, "s_scene_info" },
    { 0x525AEA1A, "s_scenedef" },
    { 0x505E4807, "s_script_origin" },
    { 0x49DA6202, "s_search_start" },
    { 0x0662CA06, "s_second_spot" },
    { 0x32A4016D, "s_security" },
    { 0x5425DA88, "s_select_stat" },
    { 0x6EC888F5, "s_set" },
    { 0xF5DE1B54, "s_settings" },
    { 0x32371C13, "s_shoot_spot" },
    { 0x81D1DF7B, "s_shootat" },
    { 0x580F3CEE, "s_shot_dest" },
    { 0x3EC0D756, "s_shot_start" },
    { 0x3FD86715, "s_shovel_pos" },
    { 0xB8B84A40, "s_sign" },
    { 0x71CD3619, "s_skipto" },
    { 0x1A79C3DD, "s_sky_cowbell" },
    { 0xC99B0356, "s_smoke" },
    { 0x5FA5BB35, "s_smoke_pos" },
    { 0x86EBB042, "s_snipe_obj" },
    { 0x5B130E66, "s_sniper" },
    { 0xF4C073ED, "s_sniper_spot" },
    { 0x3FA4CBC4, "s_source" },
    { 0x80F26C64, "s_spawn" },
    { 0xA81A0F85, "s_spawn1" },
    { 0xEB3A1C3C, "s_spawn_drone1" },
    { 0x5D418B77, "s_spawn_drone2" },
    { 0x373F110E, "s_spawn_drone3" },
    { 0x7932AD01, "s_spawn_drone4" },
    { 0x0FE8786B, "s_spawn_loc" },
    { 0xE6B4A27F, "s_spawn_point" },
    { 0xEBA88E07, "s_spawn_pos" },
    { 0x4980A3E1, "s_spawner" },
    { 0x941C095A, "s_spawner_hole" },
    { 0x2584347D, "s_spawner_position" },
    { 0x68EA4AC0, "s_spawnpt" },
    { 0x2F4D1A59, "s_spawnpt1" },
    { 0x554F94C2, "s_spawnpt2" },
    { 0x7B520F2B, "s_spawnpt3" },
    { 0x3C31865B, "s_spot" },
    { 0x695711DA, "s_spotlight_pos" },
    { 0x23BF3C7A, "s_spots" },
    { 0x38D5BBF1, "s_squib" },
    { 0x9FD2C0E7, "s_staff" },
    { 0xBCDA0488, "s_staff_piece" },
    { 0x8B745A2B, "s_stage" },
    { 0x6727A089, "s_stairs" },
    { 0x10729D99, "s_start" },
    { 0x47003FB6, "s_start_loc" },
    { 0x26DB055E, "s_start_point" },
    { 0x2B8F773A, "s_start_pos" },
    { 0x1081F4C5, "s_start_position" },
    { 0xDE73CC94, "s_start_spot" },
    { 0x4D6F50A9, "s_stat" },
    { 0x02694CFA, "s_static_loc" },
    { 0x51DB4A77, "s_stinger" },
    { 0xDE640C82, "s_stinger_start" },
    { 0xE78B281A, "s_stone" },
    { 0xE5BAED87, "s_street2_spot" },
    { 0x0BB3FCBE, "s_street_claw_archway_goal" },
    { 0x4E480925, "s_street_spot" },
    { 0xEBE66FDC, "s_struct" },
    { 0xD85D2756, "s_struct_1_spark" },
    { 0x0F537E6D, "s_struct_2_spark" },
    { 0x2FAB1060, "s_struct_3_spark" },
    { 0xBD42E257, "s_struct_4_spark" },
    { 0x7FC27E32, "s_struct_5_spark" },
    { 0x3000F2C9, "s_struct_6_spark" },
    { 0x1EDE6C2C, "s_support" },
    { 0x4CF986E7, "s_switch" },
    { 0x4E9A9A88, "s_switch_piece" },
    { 0x6B34EF2F, "s_tablet_spawn" },
    { 0xDCF46BE5, "s_tag" },
    { 0xFDD5D4A4, "s_takeoff_start" },
    { 0xE5CC4269, "s_tanker_spot" },
    { 0x26AAA5CC, "s_target" },
    { 0xF11C6E3D, "s_target1" },
    { 0x171EE8A6, "s_target2" },
    { 0x4BE40C52, "s_target_end" },
    { 0x8C85CDF2, "s_target_position" },
    { 0x870A4FF2, "s_target_relay" },
    { 0x7029D3CB, "s_target_spot" },
    { 0xF84F1909, "s_target_start" },
    { 0xC03197B0, "s_team" },
    { 0xA1A51311, "s_team_set" },
    { 0x0AAD70FC, "s_team_stats" },
    { 0x5840D41E, "s_teleport" },
    { 0xDB836AEB, "s_teleport_harper" },
    { 0x2967BA9F, "s_teleport_salazar" },
    { 0xB5C1CC55, "s_teleport_spot" },
    { 0xB9D1954C, "s_tell_location" },
    { 0xDABB26B1, "s_temp" },
    { 0xF1053612, "s_temp_grass" },
    { 0xDE593BA5, "s_theater_defend" },
    { 0x491EE06D, "s_third_spot" },
    { 0xA5360B2A, "s_timer" },
    { 0x7029104F, "s_torch" },
    { 0x03FD60E6, "s_tower_top" },
    { 0x18B78E20, "s_tp_loc" },
    { 0x7BDEC8E2, "s_tp_spot" },
    { 0xF3539266, "s_trace" },
    { 0x4113E78D, "s_tracker" },
    { 0x5E44C2A7, "s_traps_array" },
    { 0x06E3A3E5, "s_trig" },
    { 0x2C281495, "s_trigger" },
    { 0xF0FAFED0, "s_trigger_type" },
    { 0x56617858, "s_truck_spawnpt" },
    { 0x99E9E0A1, "s_truck_spawnpt1" },
    { 0xBFEC5B0A, "s_truck_spawnpt2" },
    { 0x0AB5E3D9, "s_tube" },
    { 0x38059B19, "s_turret" },
    { 0x4D823AC2, "s_uaz1_spawnpt" },
    { 0x9671D8E1, "s_uaz2_spawnpt" },
    { 0x41C16F28, "s_uaz3_spawnpt" },
    { 0xEF5BBBF7, "s_uaz4_spawnpt" },
    { 0x64E52321, "s_unitrigger" },
    { 0xA9442628, "s_unitrigger_stub" },
    { 0x7ED4443D, "s_unused" },
    { 0x5B7C5A14, "s_upgraded_staff" },
    { 0x28995340, "s_vehicle_damage_effects" },
    { 0xE5984C79, "s_vehicle_damage_state" },
    { 0x8D884702, "s_vfxspot_origin" },
    { 0x09E8B5CD, "s_vo_slot" },
    { 0x4E03B768, "s_vtol" },
    { 0x906B7BE3, "s_waitttime" },
    { 0x0B672153, "s_wall_blast_pos" },
    { 0x72E4191D, "s_wallbuy" },
    { 0x1E20EE79, "s_warp" },
    { 0xEB0D1205, "s_warp_claw_1" },
    { 0x110F8C6E, "s_warp_claw_2" },
    { 0xA20D3F0C, "s_warp_salazar" },
    { 0x4A5E5E21, "s_watcher" },
    { 0x56A3C91D, "s_wave_origin" },
    { 0x7C312B95, "s_window_end" },
    { 0x9FFDC516, "s_window_entries" },
    { 0x0E270C5D, "s_window_jumper_target" },
    { 0xF980F46F, "s_window_jumper_target_end" },
    { 0xAD1FD536, "s_window_start" },
    { 0x871A6A80, "s_window_table_flip" },
    { 0x3EA947FF, "s_woods" },
    { 0xF58F0735, "s_woods_bp1" },
    { 0x1B91819E, "s_woods_bp2" },
    { 0x4193FC07, "s_woods_bp3" },
    { 0x7E84B119, "s_woods_horse" },
    { 0xF04DA0DD, "s_woods_horse_spawnpt" },
    { 0x1FE7EB28, "s_woods_origin" },
    { 0x52603452, "s_woods_tele" },
    { 0x5010922D, "s_woods_wave2" },
    { 0x1DB46544, "s_woods_wave2_approach" },
    { 0x19925AFE, "s_z_spot" },
    { 0xB7791AC9, "s_zhao" },
    { 0xF57956E3, "s_zhao_base" },
    { 0xC1EED2CF, "s_zhao_bp1" },
    { 0x4FE76394, "s_zhao_bp2" },
    { 0x75E9DDFD, "s_zhao_bp3" },
    { 0x49564974, "s_zhao_bp3_approach" },
    { 0xACF5C513, "s_zhao_horse" },
    { 0xC65695AF, "s_zhao_horse_spawnpt" },
    { 0xF8DB14BC, "s_zhao_tele" },
    { 0xC3C25A67, "s_zhao_wave2" },
    { 0x6FA3CA0A, "s_zhao_wave2_approach" },
    { 0xDB0B56C1, "s_zone" },
    { 0x117CAA1A, "s_zone_capture_area" },
    { 0xC4DE655B, "s_zone_nml_18" },
    { 0x9EDBEAF2, "s_zone_nml_19" },
    { 0x73BA1D01, "sa6" },
    { 0xC2510437, "saaarge" },
    { 0x2AFDC5D5, "sab" },
    { 0x5980173F, "sab_carrier_influencer_radius" },
    { 0x185BE6D1, "sab_carrier_influencer_score" },
    { 0x1F4135F5, "sab_carrier_influencer_score_curve" },
    { 0x1B9E53A7, "sab_enemy_base_influencer_radius" },
    { 0x9A249769, "sab_enemy_base_influencer_score" },
    { 0x7DE7627D, "sab_enemy_base_influencer_score_curve" },
    { 0x251FB768, "sab_friendly_base_influencer_radius" },
    { 0xBD5DAC00, "sab_friendly_base_influencer_score" },
    { 0x96B69C04, "sab_friendly_base_influencer_score_curve" },
    { 0x9A40C07A, "sab_gamemodespawndvars" },
    { 0x4A99D290, "sabarish" },
    { 0xB3F3E65D, "sabbomb" },
    { 0x158500A5, "sabotage" },
    { 0x4878F17C, "sabotage_glass_break" },
    { 0x9F0C517E, "sabotage_relay_trigger" },
    { 0x6F896CC0, "sabotage_squad_setup" },
    { 0x6538819D, "sabotage_vo" },
    { 0xAC6832BB, "sabotaged" },
    { 0x329253B4, "sabotages" },
    { 0x9B9D7C70, "saboteur" },
    { 0x40AE906C, "sabotge" },
    { 0xD11FCFC6, "sabplayerspawngenerateinfluencers" },
    { 0x3D023D17, "sachel" },
    { 0xA4C51627, "sack" },
    { 0x67E71889, "sacred" },
    { 0x659FD2F1, "sacred_cow" },
    { 0x3453D350, "sacrifical" },
    { 0x9B982850, "sacrifice" },
    { 0xA1FBF52A, "sacrifice_denied" },
    { 0x6CC4FF94, "sacrifice_puzzle_zombie_killed" },
    { 0x4DC9502E, "sacrifice_received" },
    { 0x286A5424, "sacrifice_volumes" },
    { 0x1179573B, "sacrifices" },
    { 0xA056433B, "sacrificial" },
    { 0x6587B6D1, "sacrificing" },
    { 0xDEF8D103, "sad" },
    { 0xB3E887BC, "saddle" },
    { 0xB93A5D7E, "safe" },
    { 0x9AFF49DA, "safe_delete_ent" },
    { 0x6B46073E, "safe_forced_save" },
    { 0xD77465D7, "safe_line" },
    { 0xDEF15E2C, "safe_place_for_buildable_piece" },
    { 0x510E575A, "safe_place_for_craftable_piece" },
    { 0xC2BD73BA, "safe_point_snw" },
    { 0x4A98B3D7, "safe_radius" },
    { 0xB039D58E, "safe_save" },
    { 0xE793E59A, "safe_time" },
    { 0xA377C9A0, "safe_to_explode" },
    { 0x537B65D8, "safe_to_explode_player" },
    { 0x3DEC6CAD, "safe_to_kill" },
    { 0xE39FB71C, "safe_to_plant" },
    { 0x638F6F62, "safe_to_print" },
    { 0x4159901A, "safe_to_snipe" },
    { 0x9A9A8063, "safe_to_warp" },
    { 0x04FEC003, "safe_trigger" },
    { 0xBD86357D, "safearea" },
    { 0x13A36E9A, "safedist" },
    { 0x1D2F8D1C, "safeflag" },
    { 0xA6816CDE, "safehouse" },
    { 0xC1993553, "safehouse1" },
    { 0x4F91C618, "safehouse2" },
    { 0x75944081, "safehouse3" },
    { 0x33A0A48E, "safehouse4" },
    { 0x59A31EF7, "safehouse5" },
    { 0x8CAD8500, "safehouse_block" },
    { 0x167C365F, "safehouse_breach_ai_in_position" },
    { 0x88851ED7, "safehouse_cairo" },
    { 0x635E7C1A, "safehouse_capturewatch" },
    { 0xCBD60320, "safehouse_clear" },
    { 0xA390E9C4, "safehouse_delete" },
    { 0xFD645282, "safehouse_fps" },
    { 0x5CC3C695, "safehouse_fps_done" },
    { 0xBF4AC4D3, "safehouse_mobile" },
    { 0xA40D9474, "safehouse_pathbreaker" },
    { 0x13455DD1, "safehouse_singapore" },
    { 0xE465469F, "safehouse_trig" },
    { 0xF4F5A641, "safehouses" },
    { 0xA7A66668, "safehouses_cleared" },
    { 0x380CE9A5, "safeloc1" },
    { 0x5E0F640E, "safeloc2" },
    { 0x8411DE77, "safeloc3" },
    { 0x7A008598, "safeloc4" },
    { 0xA0030001, "safeloc5" },
    { 0x95A88823, "safely" },
    { 0x9BA1510E, "safely_spawn_dynent" },
    { 0x6CE3866A, "safemod" },
    { 0x5D5CCB44, "safeorigin" },
    { 0x68B491F8, "safer" },
    { 0xFA5B75B2, "safespawnmsg" },
    { 0x21F1DA72, "safespawns" },
    { 0x035A0CE7, "safest" },
    { 0x43246F3E, "safestdangerdist" },
    { 0x9962A192, "safestspawnpoint" },
    { 0x11A245B4, "safetochangescript" },
    { 0x1C5EE51B, "safety" },
    { 0xBD78267E, "safety_elapsed" },
    { 0x99A0423A, "safety_light_power_off" },
    { 0x450B89EC, "safety_light_power_on" },
    { 0x84F55EC0, "safety_light_range" },
    { 0x1CA7528D, "safety_lights" },
    { 0xA8F37440, "safety_times" },
    { 0xCB001FBF, "safety_volumes" },
    { 0xD6651751, "safetycheck" },
    { 0xE7A326D2, "safetyrange" },
    { 0x3BA14932, "safetyrangecheck" },
    { 0xD88CC53C, "safezone" },
    { 0x8C381E10, "safezone_destroyed" },
    { 0xA23FD6B4, "safezone_reset" },
    { 0x0DB60E15, "safezone_trigger" },
    { 0x28C6F4E6, "safezoneautodestroytime" },
    { 0x5EB04249, "safezonedestroyedbytimer" },
    { 0x891C8BAD, "safezonedestroytime" },
    { 0x00A07599, "safezoneobject" },
    { 0x49E7F1EF, "safezoneowningteam" },
    { 0x894B62B0, "safezonerevealtime" },
    { 0x732AF8FF, "safezones" },
    { 0x3D829E29, "saftey" },
    { 0x8D325594, "safty" },
    { 0x2E130063, "sahn" },
    { 0x214B8986, "said" },
    { 0x51DE2658, "said_noscope" },
    { 0x326BC8A2, "saidfoundus" },
    { 0x0E0F8DC2, "saidhighbalcony" },
    { 0x161B8A05, "sailor" },
    { 0x1A0B6451, "sake" },
    { 0xAEE4FDBB, "sal" },
    { 0xAFA629E2, "sal_exit_explosion" },
    { 0xE071D40A, "sal_think" },
    { 0x818E933D, "salarzar" },
    { 0x18EDBE9F, "salazar" },
    { 0xCD0EF08E, "salazar_and_han_run_to_evac_point" },
    { 0x00F23925, "salazar_brute_force_anims" },
    { 0x19D30C42, "salazar_celerium" },
    { 0xB07676C8, "salazar_crosby_speed_up" },
    { 0xDBA7A137, "salazar_defend_scene" },
    { 0xCE9A8696, "salazar_destroyed_heli" },
    { 0x23EAB52E, "salazar_door_breach_anim" },
    { 0x3E070593, "salazar_door_breach_event" },
    { 0xEADFB161, "salazar_elevator_ride" },
    { 0x5955AED7, "salazar_enter_club" },
    { 0xB718B4C0, "salazar_exit_started" },
    { 0xCDF8E7DE, "salazar_exit_update_objective" },
    { 0x82DDDD91, "salazar_finish_level_color_trigger" },
    { 0x629D4355, "salazar_get_into_door_open_position" },
    { 0x2C1A79BE, "salazar_hit_briggs" },
    { 0x18302F4C, "salazar_kill_animations" },
    { 0xB59EE418, "salazar_lab_intro" },
    { 0xF6187C81, "salazar_pip" },
    { 0x3B60A8B1, "salazar_reacts_to_briggs_killed" },
    { 0x05CA2F38, "salazar_reacts_to_briggs_knocked_out" },
    { 0xF820B810, "salazar_reacts_to_briggs_wounded" },
    { 0x54C59ED1, "salazar_run_into_scaffolding" },
    { 0x747A0A07, "salazar_shoot" },
    { 0xFE7E14FB, "salazar_soct_end_chase_logic" },
    { 0xE015E401, "salazar_soct_speed" },
    { 0xEFB27423, "salazar_soct_speed_control" },
    { 0x03F3EF59, "salazar_start_pos" },
    { 0x18FE8DCA, "salazar_take_down_scenes" },
    { 0xA4C93E46, "salazar_think" },
    { 0xDB36E7F8, "salazar_unholster_sidearm" },
    { 0x29ECEBB1, "salazar_vent_wait" },
    { 0xDE6EAF34, "salazar_walk_to_plane" },
    { 0xA31DE826, "salazars" },
    { 0x6E497424, "salazr" },
    { 0x3FD229BC, "sale" },
    { 0xD802C141, "saloon" },
    { 0x877B657A, "saloon1" },
    { 0x6178EB11, "saloon2" },
    { 0xDA90129D, "salute" },
    { 0xF62268D4, "saluters" },
    { 0xDCDB6BDC, "salutes" },
    { 0xCFC9A8E1, "salvadorian" },
    { 0x1C25806C, "salvage" },
    { 0x9FB60882, "salvo" },
    { 0x27B490CD, "salvos" },
    { 0x5BDE27A8, "salybacks" },
    { 0x88E28352, "sam" },
    { 0x3995F821, "sam_angles" },
    { 0x7E564242, "sam_attack_exploders" },
    { 0x0E71CEFC, "sam_chamber_line_played" },
    { 0x91A38743, "sam_close_vo" },
    { 0x5C3CBF34, "sam_clue_biplane" },
    { 0x7F066517, "sam_clue_dig" },
    { 0xD7B83FDC, "sam_clue_giant" },
    { 0x96C38598, "sam_clue_mechz" },
    { 0x2DDBA539, "sam_clue_tank" },
    { 0x709021C9, "sam_clue_zonecap" },
    { 0x6B027E98, "sam_complete" },
    { 0xF8B4643E, "sam_cougar" },
    { 0x03B7943A, "sam_cougar_damage" },
    { 0x443B005A, "sam_cougar_mount_started" },
    { 0xE3A57C7B, "sam_cougar_player_damage_watcher" },
    { 0x37B2DDAB, "sam_cougar_think" },
    { 0x3817580E, "sam_damage" },
    { 0x5F492C9D, "sam_damage_override" },
    { 0x81322ABE, "sam_direction_vo_left" },
    { 0xAD5776F5, "sam_direction_vo_right" },
    { 0xE8C79645, "sam_drone" },
    { 0x3876251E, "sam_drone_death" },
    { 0x29130CFC, "sam_drones_left" },
    { 0x3264CCD3, "sam_drones_right" },
    { 0xFDB0552B, "sam_event" },
    { 0x067C869E, "sam_event_ally_mover" },
    { 0x746A7FFB, "sam_event_ally_nexttarget" },
    { 0xE4C6FFBE, "sam_event_done" },
    { 0x98F337B0, "sam_event_over" },
    { 0xE8D826CB, "sam_event_vo" },
    { 0x1FBF7782, "sam_explosion_struct" },
    { 0x27F56E76, "sam_filter_index" },
    { 0x15DA344A, "sam_fired_listener" },
    { 0x26AC0BB7, "sam_heavy_resistance_num" },
    { 0x17C4166B, "sam_heavy_resistance_num_destroyed" },
    { 0x26DA0D8E, "sam_hint" },
    { 0x658FD4CF, "sam_hint_drone_killed" },
    { 0xD02C2298, "sam_hud_damage" },
    { 0x9AEA3670, "sam_hud_damage_heavy" },
    { 0xCE6EAE6E, "sam_hud_damage_intensity" },
    { 0xEDB0E522, "sam_hud_fade_in_rate" },
    { 0xC280A5BF, "sam_hud_fade_in_time" },
    { 0xAEE5B65D, "sam_hud_fade_out_rate" },
    { 0x39B3D1A4, "sam_hud_fade_out_time" },
    { 0x39A1D07F, "sam_init" },
    { 0x66669ECD, "sam_intro_skip" },
    { 0xD2323E15, "sam_jump" },
    { 0x0DD497B8, "sam_jump_done" },
    { 0xE7F66DF9, "sam_launcher" },
    { 0x9698603C, "sam_launcher_think" },
    { 0x4FC00930, "sam_launchers" },
    { 0x04F3CCA3, "sam_line" },
    { 0xFF575347, "sam_locations" },
    { 0x7ADA718E, "sam_main" },
    { 0x12BB8FAE, "sam_missile_bow" },
    { 0xE76C8ED6, "sam_missile_launcher_track_player" },
    { 0xF148559C, "sam_missile_mid" },
    { 0x09667624, "sam_missile_stern" },
    { 0x26E8435D, "sam_missile_tags" },
    { 0x1ABA8A31, "sam_missiles_fire" },
    { 0xDAC6A3AD, "sam_nag_vo" },
    { 0xB12165E0, "sam_next_beratement" },
    { 0x74956248, "sam_off" },
    { 0x465A6EE2, "sam_on" },
    { 0x9965AEBF, "sam_origin" },
    { 0x7BB16F80, "sam_out_anim_done" },
    { 0x29B1FF3B, "sam_promises_conversation" },
    { 0xED60A84E, "sam_promises_conversation_ended_early" },
    { 0x6E96B671, "sam_promises_cooldown" },
    { 0x8FCD12F3, "sam_promises_watch" },
    { 0x159F49CD, "sam_reveal_richtofen_vox" },
    { 0x1E7E25E0, "sam_rise_and_bob" },
    { 0xD79E9F85, "sam_screen" },
    { 0x46FB9EE2, "sam_shoot" },
    { 0x75558A50, "sam_site" },
    { 0xD33148B7, "sam_sites_destroyed" },
    { 0xEC22D724, "sam_staff_line_played" },
    { 0x444E70B2, "sam_stole_it" },
    { 0xBE610FD2, "sam_success" },
    { 0x8C80BD85, "sam_talking" },
    { 0xD52BF4FA, "sam_target" },
    { 0x0071A85C, "sam_turret_aquire_dist" },
    { 0x3CC525B9, "sam_turret_disable_breakoff_vo" },
    { 0x393D18ED, "sam_turret_disable_nag_vo" },
    { 0x2956FF98, "sam_turret_disable_vo" },
    { 0xE5108859, "sam_turret_instructions" },
    { 0xEB49070E, "sam_turret_snapshot_and_verb_off" },
    { 0xB78AEE60, "sam_turret_snapshot_and_verb_on" },
    { 0x21185DDF, "sam_turret_vo" },
    { 0x3D9924D9, "sam_turret_waitforoff" },
    { 0xD0AA926D, "sam_turret_waitforon" },
    { 0xBD11915F, "sam_visionset" },
    { 0x3026CA58, "sam_vo" },
    { 0xDCFDED2C, "sam_vo_rumble" },
    { 0x877EE8FF, "sam_volume" },
    { 0x3FEC0E94, "sam_wave_vo" },
    { 0x83FC3A54, "samantha" },
    { 0xD37A5BFF, "samantha_discourage_reset" },
    { 0x189B086A, "samantha_discourage_think" },
    { 0x19CEDDA7, "samantha_encourage_think" },
    { 0x23B8BB3A, "samantha_encourage_watch_good_lines" },
    { 0xF2840CF7, "samantha_intro_1" },
    { 0x807C9DBC, "samantha_intro_2" },
    { 0xA67F1825, "samantha_intro_3" },
    { 0x10D15BB5, "samanthasay" },
    { 0xB1AC884A, "samanthasay_vo_finished" },
    { 0x53CBFB1A, "samanthasayvoplay" },
    { 0x1CDC97FB, "same" },
    { 0x7CE8EC15, "same_color_code_as_last_time" },
    { 0x1709A876, "same_enemy_count" },
    { 0xDD9F5411, "same_player" },
    { 0x7E102CD9, "same_team" },
    { 0xA6A7B66E, "same_team_placed_equipment" },
    { 0x2389F10A, "sameentity" },
    { 0x9B2FDE1C, "samephrase" },
    { 0x5F618C8E, "samestate" },
    { 0xAF13BDC2, "samity" },
    { 0x78D471AF, "sampan" },
    { 0x9EF58864, "sampan1" },
    { 0x10FCF79F, "sampan2" },
    { 0x78F30DFB, "sampan6" },
    { 0xC341A0C7, "sampan_1" },
    { 0x513A318C, "sampan_2" },
    { 0xB9B1E4A9, "sampan_ai_meatshield" },
    { 0x2F65B9CF, "sampan_anim_setup" },
    { 0x8C664439, "sampan_arrival" },
    { 0xD1A789A0, "sampan_driver" },
    { 0xFBFBF64C, "sampan_fake_bullet_whizbies" },
    { 0x9BC7E362, "sampan_guy_function" },
    { 0x99AAB58A, "sampan_guys" },
    { 0x33817BF7, "sampan_kill_index" },
    { 0x55FD167F, "sampan_landers" },
    { 0x9F9BC441, "sampan_landing_death_counter" },
    { 0xDB901732, "sampan_landing_function" },
    { 0x62A71E09, "sampan_landing_guy_killed" },
    { 0x9B054F1B, "sampan_large" },
    { 0xA7CB5231, "sampan_model" },
    { 0x0571FEE6, "sampan_searches_for_player" },
    { 0xB84E76EE, "sampan_spawn_function" },
    { 0x7F9387F8, "sampan_spawner_name" },
    { 0xED72EE6C, "sampan_spawner_setup" },
    { 0xA9A38486, "sampan_spotlight" },
    { 0x77CC787E, "sampan_stealth_fail_detection" },
    { 0x3115ADF2, "sampan_stealth_fail_shoot" },
    { 0xEDE6985E, "sampan_stealth_fail_shoot_water" },
    { 0x52A2785A, "sampan_tag" },
    { 0x5AAF8B6C, "sampan_to_dock_done" },
    { 0x5B04C153, "sampan_vc" },
    { 0xD9BBDC83, "sampan_vc_1" },
    { 0x67B46D48, "sampan_vc_2" },
    { 0x8DB6E7B1, "sampan_vc_3" },
    { 0xD8A22A4E, "sampan_vc_spawner" },
    { 0x6A5BE2F6, "sampans" },
    { 0x77B0F994, "sampans_arrive" },
    { 0xC5D2D198, "sampans_go_into_alcove_and_kill_friendlies" },
    { 0xAC4AC1E6, "sampans_land_on_west_shore" },
    { 0xC17443C8, "sampans_medium" },
    { 0x858E2D92, "sampans_small" },
    { 0xB76E1907, "sample" },
    { 0x57FE44C5, "sample_size" },
    { 0x4F7B86FE, "samples" },
    { 0x01DC8B3D, "samplescale_default" },
    { 0x91DB124D, "samplescale_dvar" },
    { 0xC0DD8557, "samplescale_parliament" },
    { 0xFBAB2214, "sampletime" },
    { 0xC909335D, "sams" },
    { 0x1A5F0F9D, "samturret_destroyturret" },
    { 0xC8ADB0FC, "samturret_disable_watcher" },
    { 0xB9F13C8B, "samturret_firingpointprocedure" },
    { 0xE109B71B, "samturret_targetingsystem" },
    { 0x6DE97DB8, "samturretwatcher" },
    { 0xF7060E38, "samu_sniper_nag" },
    { 0x5D859F08, "samuel" },
    { 0x92E9D523, "samuels" },
    { 0x68A5D7CF, "sand" },
    { 0xB1CE8873, "sandbag" },
    { 0x65CF65A3, "sandbag_count" },
    { 0x4AE8D0DF, "sandbagger" },
    { 0xA19A3B22, "sandbags" },
    { 0xBF49CA9B, "sandbags01" },
    { 0x1FA6FFDE, "sandbags01_start" },
    { 0x4D425B60, "sandbags02" },
    { 0xC29D6AD5, "sandbags02_start" },
    { 0x344C1ED1, "sandbags_apc" },
    { 0x1313CA30, "sandbags_apc_start" },
    { 0x814D09E6, "sandbox" },
    { 0xBF882CE9, "sanddune" },
    { 0xA0EAC27C, "sandparticles" },
    { 0xE45CE312, "sandstorm" },
    { 0x044139E2, "sandwich" },
    { 0x42A35D66, "sane" },
    { 0x00AFC173, "sanh" },
    { 0xE799799B, "sanim" },
    { 0x6BBF9B28, "sanim1" },
    { 0x3CF6D8ED, "sanim_rappel_setup_to_stand" },
    { 0x12A45FE4, "sanim_rappel_stand_idle" },
    { 0x334B50FC, "sanimbreach" },
    { 0xFFBF7E4F, "sanimflash" },
    { 0x1EB0483D, "sanimidle" },
    { 0xF7CFEEAF, "sanimload" },
    { 0xEEA92776, "sanimname" },
    { 0xF35E6B21, "sanimstart" },
    { 0x14109CBA, "sanimunload" },
    { 0x6F58BFCF, "sanity" },
    { 0xD4EA7C96, "sanpan_fallback_drones_start" },
    { 0xFE6CD860, "sans" },
    { 0xA55238CB, "sapwns" },
    { 0x9C4F62F9, "sar_distance" },
    { 0x4D1E6DEA, "sarah" },
    { 0xE290AA8D, "sarah_minigun_spin" },
    { 0x1AF24CF2, "sarah_rumble_on_landing" },
    { 0xE11030AD, "sarge" },
    { 0x8D00B7D5, "sarge2" },
    { 0xC92B5EA6, "sarge_animref" },
    { 0xE7518061, "sarge_at_e3_door" },
    { 0x1C1FB341, "sarge_balcony_playerhint_anim" },
    { 0xEDAF5629, "sarge_bash_door" },
    { 0xA500630C, "sarge_cqb_control" },
    { 0xBB1C5E90, "sarge_dialog" },
    { 0x43ED2776, "sarge_dialog_and_sound" },
    { 0xD982EB03, "sarge_fight_dialogue" },
    { 0xE90AB751, "sarge_getup_xcoord" },
    { 0xB1C6A711, "sarge_give_knife" },
    { 0x909DD8C1, "sarge_giveorder" },
    { 0xBA871217, "sarge_giveorder_soundonly" },
    { 0xE6D854BE, "sarge_idle_animate" },
    { 0x9E89DFD9, "sarge_kick_door" },
    { 0x8882F59D, "sarge_kill_bridgebomber" },
    { 0x9D4B349B, "sarge_killed_bomber" },
    { 0xF828936C, "sarge_knife_that_nazi" },
    { 0xF15A5B18, "sarge_knifed_nazi" },
    { 0x5283DA95, "sarge_movement_main" },
    { 0x31628BC4, "sarge_node" },
    { 0x6DFF53CE, "sarge_node2" },
    { 0x59AB9131, "sarge_oc_dialog" },
    { 0x51DE2A60, "sarge_oc_setup" },
    { 0xECD48E38, "sarge_outro_notetracks" },
    { 0xC9462DE2, "sarge_point" },
    { 0x7DC8A971, "sarge_reaction" },
    { 0xB52A4021, "sarge_saved" },
    { 0x9FC7B828, "sarge_say_again" },
    { 0x2A193B2F, "sarge_say_hah" },
    { 0x4465A0D4, "sarge_spiderhole_ambush" },
    { 0x30E2F494, "sarge_start" },
    { 0xA2091FB3, "sarge_startup" },
    { 0x5F000AD9, "sarge_supplies" },
    { 0xFAEED1C6, "sarge_tell_reposition" },
    { 0xFC65EB32, "sargeanim" },
    { 0x4EF6D84D, "sargenode" },
    { 0x59CF3FA5, "sargespot" },
    { 0xF00E2C46, "sargewavenode" },
    { 0x8C88D5CB, "saritch" },
    { 0x6522F1FC, "sas" },
    { 0xB82D10AD, "sas1" },
    { 0xDE2F8B16, "sas2" },
    { 0x0432057F, "sas3" },
    { 0x7E0249CF, "sas_blackkits" },
    { 0xC11C44CC, "sas_handle_farm" },
    { 0xB270990D, "sas_main_think" },
    { 0xB3332F74, "sas_rules" },
    { 0x8FB75C18, "sas_spectator_hud" },
    { 0x416541ED, "sasaki" },
    { 0xD72E4715, "sasgunner" },
    { 0xCECD43D5, "sasgunnernode" },
    { 0xE2A9F65D, "sasha" },
    { 0x3B942605, "sasseaknightboarded" },
    { 0x3F207793, "sat" },
    { 0x09E3D3D9, "satchel" },
    { 0x0624F140, "satchel_charge" },
    { 0xC59C553C, "satchel_charge_prepare" },
    { 0x85D7CBFF, "satchel_damage" },
    { 0xA1ACF31F, "satchel_defenders_monitor" },
    { 0x503EC9DB, "satchel_earthquake" },
    { 0x22447495, "satchel_exploded" },
    { 0x5F47B641, "satchel_explosion" },
    { 0x8B86D609, "satchel_max_spawned" },
    { 0x1E157D9F, "satchel_orig" },
    { 0xB0D4D993, "satchel_setup" },
    { 0xDCD6D73E, "satchel_spawned" },
    { 0x3D8079F1, "satchel_thrower" },
    { 0xC5BC3588, "satchelarray" },
    { 0x5179D696, "satcheldamage" },
    { 0x3543DDB5, "satcheldetonate" },
    { 0x2FCBA4C7, "satchelexplodethisframe" },
    { 0x17D8CE90, "satchels" },
    { 0xA3A42DF2, "satchelspawn" },
    { 0xA6119304, "sate" },
    { 0xA5A61CAE, "satelitte" },
    { 0xF96DFB9C, "satellite" },
    { 0x4C419483, "satellite_data_1" },
    { 0xDA3A2548, "satellite_data_2" },
    { 0x003C9FB1, "satellite_data_3" },
    { 0xA32BD073, "satellite_duration" },
    { 0x1F399BD6, "satellite_duration_ms" },
    { 0x6D24175B, "satellite_filter_id" },
    { 0xB8CA0EE0, "satellite_finished_" },
    { 0xA4CAE7B9, "satellite_health" },
    { 0x42D2DECD, "satellite_killstreak_name" },
    { 0xE608173C, "satellite_low_health" },
    { 0x48330F77, "satellite_missiles_to_destroy" },
    { 0xF4A0C1F2, "satellite_model" },
    { 0x82E260E9, "satellite_model_scale" },
    { 0x4B0660DE, "satellite_name" },
    { 0x1ACF6EC4, "satellite_rotation_duration" },
    { 0xE8668EFC, "satellite_spawn_from_angle_max" },
    { 0x657B4CF2, "satellite_spawn_from_angle_min" },
    { 0x4A290CEA, "satellite_streams" },
    { 0xB60A8564, "satellite_timeout" },
    { 0x64A5B052, "satellite_transition" },
    { 0xB57F2B24, "satellite_travel_distance_scale" },
    { 0x812D92F0, "satellite_update" },
    { 0x3D8CB5AA, "satellite_watchfor_gamerules_destruction" },
    { 0x0AA959E7, "satellite_z_offset" },
    { 0x1D2AF322, "satelliteactive" },
    { 0x0AF0E9E7, "satellitedamageoverride" },
    { 0x2DEFD336, "satelliteflydistance" },
    { 0x3F5C2B45, "satelliteheight" },
    { 0x908943E3, "satelliteinbound" },
    { 0x1514F7DF, "satellites" },
    { 0x64C7A00F, "satellitetime" },
    { 0xD3974478, "satellitetracker" },
    { 0x665FABA2, "satellitetransisionactive" },
    { 0xADF01554, "satellitetype" },
    { 0x2D616099, "satety" },
    { 0x211EC3D5, "satirs" },
    { 0xC153A8FF, "satisfied" },
    { 0x1769F6B0, "satisfies" },
    { 0x20E5A73C, "satisfying" },
    { 0x2EC6E23D, "satnum" },
    { 0x80EB8068, "satsound" },
    { 0x581B856D, "sattachtag" },
    { 0x96133235, "sattacker" },
    { 0x4069E5AA, "saturate" },
    { 0x587F6308, "saturday" },
    { 0xF9E29F62, "sauce" },
    { 0xF31B82C1, "sav" },
    { 0x1ACD09DE, "sav_func" },
    { 0xF2CB8D1E, "savage" },
    { 0xAF5151A2, "savannah_anims" },
    { 0x585E6A57, "savannah_attack_mortars" },
    { 0x2C74EB60, "savannah_base_reached" },
    { 0xD3DCD37B, "savannah_board_buffel" },
    { 0xE15B48B6, "savannah_board_buffel_fail" },
    { 0x3FDB46C1, "savannah_board_buffel_savimbi" },
    { 0x5C40E48C, "savannah_brim_fights" },
    { 0x2555E1E2, "savannah_buffel_tip" },
    { 0x6ED09346, "savannah_destroy_buffel1" },
    { 0x48CE18DD, "savannah_destroy_buffel2" },
    { 0x1A23D081, "savannah_destroy_eland" },
    { 0xF08F1EFE, "savannah_destroy_eland_fight" },
    { 0xF8E32DF4, "savannah_drone_setup" },
    { 0xFE56FCF0, "savannah_end_anims" },
    { 0x6812EA23, "savannah_final_push" },
    { 0x6DB0B275, "savannah_final_push_kills" },
    { 0xAE9CA9CA, "savannah_final_wave_kills" },
    { 0x90E7E0C1, "savannah_finish" },
    { 0x18AD28A0, "savannah_first_wave_kills" },
    { 0x2BC99A3C, "savannah_first_wave_rpg_kills" },
    { 0x3C2599ED, "savannah_hill" },
    { 0xD6410389, "savannah_hill_deform_terrain" },
    { 0x63E37A45, "savannah_hill_fights" },
    { 0x251C8981, "savannah_mortar_team" },
    { 0xDC515147, "savannah_mortar_team_kills" },
    { 0x19290122, "savannah_mortars" },
    { 0xD972444C, "savannah_player_boarded_buffel" },
    { 0x29BF7F58, "savannah_player_damage_override" },
    { 0x28AB12A6, "savannah_second_wave_kills" },
    { 0x55714D36, "savannah_second_wave_rpg_kills" },
    { 0x1DE9D8C0, "savannah_start" },
    { 0x31700056, "savannah_start_hill" },
    { 0x0ECB3FA6, "savannah_start_hudson" },
    { 0x058C43AF, "savannah_start_mortars" },
    { 0x4CA952BA, "savannah_start_savimbi_buffel_go" },
    { 0xF5DC724E, "savannah_tank_kills" },
    { 0x53698009, "savannah_tank_safety" },
    { 0xB2F498BF, "savannah_technical_gunner_kills" },
    { 0x1339C7E8, "savannah_wave_one_fights" },
    { 0x2706F7EE, "save" },
    { 0x1A80EB9E, "save_all" },
    { 0x3D508E51, "save_all_as_shooter_models" },
    { 0x35201F6F, "save_all_dyn_ents" },
    { 0x0EE466EA, "save_all_misc_models" },
    { 0x691358D2, "save_anim" },
    { 0xDE4EAB94, "save_array" },
    { 0x6CBB085D, "save_asylum_entry" },
    { 0xC77D995F, "save_at_stairs" },
    { 0x98462E12, "save_button_pressed" },
    { 0xBC6E0C9C, "save_buttons" },
    { 0x75F1DEB9, "save_claw_start" },
    { 0xCC43CD44, "save_complete" },
    { 0x8958A859, "save_destructible_highlighted" },
    { 0xBA0CED06, "save_destructibles" },
    { 0x39AEF831, "save_dialog" },
    { 0x987D1BCE, "save_dyn_ent_highlighted" },
    { 0x2ADBC633, "save_dynent_highlighted" },
    { 0x4F45B45C, "save_dynents" },
    { 0x5C82B24C, "save_fail_on_rpgguy" },
    { 0x02B3C9BE, "save_failed" },
    { 0x43680168, "save_friendlies" },
    { 0xEFC02C13, "save_game_on_notify" },
    { 0xCA739785, "save_ghost_data" },
    { 0x5BC46834, "save_highlight_loop" },
    { 0xE05E05CC, "save_highlighted" },
    { 0x4E271EF9, "save_hud_x" },
    { 0x2824A490, "save_hud_y" },
    { 0xB98D2296, "save_huey" },
    { 0xBD1CDF70, "save_if_ready" },
    { 0x1500420F, "save_loop" },
    { 0x28EDBADF, "save_master" },
    { 0x10125FBD, "save_mid_ruins" },
    { 0x5C970F62, "save_mid_tankride" },
    { 0x7EA89FFC, "save_mid_yard" },
    { 0xE47D73DD, "save_misc_model_highlighted" },
    { 0x1C635412, "save_miscmodel_highlighted" },
    { 0x717E3DA3, "save_miscmodels" },
    { 0x999DBEF8, "save_msg" },
    { 0xE6E2DA94, "save_name" },
    { 0x04641F27, "save_near_corsair_trap" },
    { 0xB7ACD4F8, "save_near_first_bunker" },
    { 0x1F81A9CE, "save_no_hud" },
    { 0xE8B469A1, "save_player_first_position" },
    { 0xABF09080, "save_player_position" },
    { 0x23088CE0, "save_player_safe_position" },
    { 0xA6E3CF31, "save_point_1" },
    { 0xCCE6499A, "save_point_2" },
    { 0xD8F4DFCB, "save_point_number" },
    { 0xDEF9928A, "save_ready" },
    { 0x02693B45, "save_restore" },
    { 0x18DCC229, "save_restore_callback" },
    { 0x0962E433, "save_restore_ent_delete" },
    { 0x636B5D82, "save_restore_gravity" },
    { 0xB84F16DB, "save_restored" },
    { 0x150B3FBF, "save_restored_callback" },
    { 0x584C8033, "save_restored_cctv_bink" },
    { 0xD9ED8012, "save_restored_function" },
    { 0x111FC59D, "save_restored_mason_server_room_bink" },
    { 0xA7403973, "save_restored_menendez_console_bink" },
    { 0xAE07E254, "save_sate" },
    { 0xEC8A979E, "save_scenes" },
    { 0x6BD6126A, "save_selected" },
    { 0x466A0F0E, "save_selected_group" },
    { 0xBBA830C2, "save_selector" },
    { 0xD3267D0C, "save_shots" },
    { 0xDA4EBF90, "save_state" },
    { 0xDDF234BA, "save_struct" },
    { 0xA23C4BE6, "save_success" },
    { 0xE1873BA8, "save_target_links" },
    { 0x41054C78, "save_text" },
    { 0xE9A2744E, "save_text_off" },
    { 0x17DD12D2, "save_that_item_is_found" },
    { 0xBA9FB0AF, "save_the_game" },
    { 0xCDD0E2C0, "save_the_pows" },
    { 0x166F0422, "save_the_pows_text" },
    { 0x3B2A2961, "save_turret_sharing_info" },
    { 0xE4682866, "save_vip" },
    { 0x10DFA9CC, "save_vip_vo" },
    { 0x72FE279B, "save_visionset" },
    { 0x97BB37AB, "save_weapon_for_chugabud" },
    { 0x03F43665, "save_weapon_for_tombstone" },
    { 0x63BCAB5C, "save_weapons_for_chugabud" },
    { 0x8325C22C, "save_weapons_for_tombstone" },
    { 0xA53890EE, "save_when_dead" },
    { 0x0FAB5AFA, "save_when_movie_is_done" },
    { 0x1E2692B1, "save_when_near_aa_bunker" },
    { 0x216B818F, "save_when_near_cinch_point" },
    { 0xDCF213D6, "save_woods_swim_started" },
    { 0x6954B72C, "save_yes_hud" },
    { 0xE60E13B8, "savecommit_aftergrenade" },
    { 0x36F01CAE, "saved" },
    { 0x582B696D, "saved_angles" },
    { 0x87A2BE7F, "saved_attacking_spot_index" },
    { 0xE55702E2, "saved_by_armor" },
    { 0x0CBB7E1B, "saved_health" },
    { 0x629298A7, "saved_num" },
    { 0xB81038E3, "saved_origin" },
    { 0x55AFE32C, "saved_spawn_functions" },
    { 0xB5D7EE7F, "saved_spike_power" },
    { 0x51DAD171, "saved_vision" },
    { 0xA6BCDF4D, "saved_weapon" },
    { 0xE8449B3D, "savedaimpos" },
    { 0x0C4D79B4, "savedescription" },
    { 0x7DB45725, "savednotify" },
    { 0xD51F2B51, "savedpower" },
    { 0x438E3D44, "savedvis" },
    { 0x8A99814E, "savedvisionset" },
    { 0x9F824288, "savegame" },
    { 0x059FE1A3, "savegame_done" },
    { 0x350A8FC7, "savegame_redundancy_check" },
    { 0xD71C288A, "savegamenocommit" },
    { 0x4B554541, "savegamestats" },
    { 0x4850C9CF, "saveheadicon" },
    { 0x1C710604, "savehere" },
    { 0x4F0B42B5, "saveid" },
    { 0x1E435BD8, "savekeepclaimed" },
    { 0x77F1B573, "savemode" },
    { 0xCCEDAE15, "savemodel" },
    { 0x31B95173, "savename" },
    { 0x728CF5F2, "saveoffallplayersammo" },
    { 0x3A7EF7A5, "saveplayerspregameinfo" },
    { 0xB2D64E43, "saveplayerweaponstatepersistent" },
    { 0x13470500, "saverestore" },
    { 0x18BC1211, "saves" },
    { 0xF842AF55, "savetrig1" },
    { 0x1E4529BE, "savetrig2" },
    { 0x4447A427, "savetrig3" },
    { 0xC4E63E67, "savetrigs" },
    { 0x849663F0, "savimbi" },
    { 0x9D0F3397, "savimbi_buffel" },
    { 0x63790660, "savimbi_buffel_drop_mgl" },
    { 0xE822A536, "savimbi_buffel_spawn_enemy" },
    { 0xD2D1CAAA, "savimbi_fire_mgl" },
    { 0xE0B36F18, "savimbi_fire_mgl_forward" },
    { 0x71E8876E, "savimbi_fire_mgl_left" },
    { 0x6F2FFAA5, "savimbi_fire_mgl_right" },
    { 0xA25ED3C9, "savimbi_goal_pos" },
    { 0x14FF1C6F, "savimbi_intro_swap" },
    { 0x1E35D8F7, "savimbi_nag" },
    { 0x4AEB327D, "savimbi_rally" },
    { 0x90870800, "savimbi_rally_done" },
    { 0x3C545DD2, "savimbi_return_fight" },
    { 0xB7775E88, "savimbi_reveal" },
    { 0xE67F2F51, "savimbi_ride_along_off" },
    { 0x48033925, "savimbi_ride_along_on" },
    { 0x7E4F730E, "savimbi_ride_anims" },
    { 0x2654836C, "savimbi_riders" },
    { 0x65D63DD1, "savimbi_riders_rally" },
    { 0xC35D62FD, "savimbi_riders_rally_prep" },
    { 0x6AB8A608, "savimbi_say_convoy_warning" },
    { 0x1B46C53A, "savimbi_setup" },
    { 0xE21C0D33, "savimbi_setup_start" },
    { 0xBA199638, "savimbi_shoot" },
    { 0xB17A9A1C, "savimbi_start_node" },
    { 0x29C9C3EE, "savimbi_stop_mgl" },
    { 0x0D20492F, "savimbi_strafe1" },
    { 0x7B6F3807, "saving" },
    { 0xCE836FB2, "saving_start" },
    { 0xDD3F53FE, "savings" },
    { 0x0417F711, "savior" },
    { 0x14834BDE, "savor" },
    { 0xCD190858, "saw" },
    { 0xA7BFF3C0, "saw_ac_unit" },
    { 0xE5153F2B, "saw_amtank_blowup" },
    { 0x0CBE0587, "saw_corpse" },
    { 0x7281E481, "saw_enemy" },
    { 0xC5B5562E, "saw_gunner" },
    { 0x4565F3D5, "saw_gunner_aim_down_center" },
    { 0x985770AC, "saw_gunner_chatter" },
    { 0x0713F7E4, "saw_gunner_friendly" },
    { 0x41FB7059, "saw_mgturretlink" },
    { 0x167D9351, "saw_notify_start" },
    { 0xFAE344FB, "saw_notify_stop" },
    { 0xBDB84B6F, "saw_notify_switch" },
    { 0x2C3AE8F0, "saw_player" },
    { 0xF3DAE5AB, "saw_sound_and_fx" },
    { 0xAAD46411, "saw_sparks" },
    { 0x33403C6B, "sawed" },
    { 0xD52C7BAC, "sawenemy" },
    { 0x71C43223, "sawenemymove" },
    { 0x17B0CFA6, "sawgunner_moving" },
    { 0xF7A695EC, "sawsomeone" },
    { 0x81141386, "say" },
    { 0xBAE04139, "say_dialog" },
    { 0x43D581C3, "say_dialog_and_waittill_death" },
    { 0x346269CA, "say_dialog_flag" },
    { 0x7BF86D11, "say_dialog_flex" },
    { 0xE90383C6, "say_dialog_func" },
    { 0x0797C717, "say_dialog_health_lost" },
    { 0xEAB4621A, "say_dialog_targetname" },
    { 0x8B9AF128, "say_dialog_trigger" },
    { 0x0154556A, "say_dialog_waittill" },
    { 0xFA9C8BA0, "say_dialog_with_cam" },
    { 0x888B0A61, "say_dialog_with_cam_manual" },
    { 0xBCE18BFF, "say_dialogue" },
    { 0x59227952, "say_dialogue_bullet_shield" },
    { 0x37958FF9, "say_dialogue_notsarge" },
    { 0x6E7410FF, "say_dialogue_notsarge_soundonly" },
    { 0x144F4813, "say_dialogue_randomfriend" },
    { 0x2E826799, "say_dialogue_wait" },
    { 0x72B3AFE7, "say_final_vo" },
    { 0x86D47DEC, "say_first_dialog" },
    { 0xB0D27BF2, "say_hint" },
    { 0xF5F0B2A9, "say_intro" },
    { 0x089EB644, "say_kill_battle_chatter" },
    { 0x4CAA627A, "say_move" },
    { 0xE956B05E, "say_pickup_buildable_vo" },
    { 0xC47389A0, "say_pickup_craftable_vo" },
    { 0x2F94708B, "say_player_attack_vox" },
    { 0x869E1255, "say_player_dialog" },
    { 0x2AF394FB, "say_puzzle_completion_line" },
    { 0xB7B08940, "say_revived_vo" },
    { 0x0BDD192B, "say_reviving_vo" },
    { 0xCC608E71, "say_shoot_targets" },
    { 0xCAE97F64, "say_shoot_through_wood" },
    { 0x968AC53B, "say_something" },
    { 0x9D65CB1C, "say_squad_dialog" },
    { 0x36CE6F66, "say_vo_fake_ent" },
    { 0x1552AC9B, "sayall" },
    { 0x206C3483, "saydamaged" },
    { 0x7E79E930, "saydialogue" },
    { 0x6B97F8BB, "saygenericdialogue" },
    { 0x135967F5, "saygenericdialoguewithimportance" },
    { 0x042E379A, "saying" },
    { 0xE5186437, "saykillbattlechatter" },
    { 0xE1C7F360, "saylocalsound" },
    { 0x8FE4336A, "saylocalsounddelayed" },
    { 0xB30F3539, "says" },
    { 0xEB490E88, "sayspecificdialogue" },
    { 0x0CFECD69, "sayteam" },
    { 0x1C5DE96B, "saytext" },
    { 0x9F0270A6, "sb" },
    { 0xF451296B, "sb41" },
    { 0x8249BA30, "sb42" },
    { 0xA84C3499, "sb43" },
    { 0xDBE77429, "sb_model_column_collapse" },
    { 0xCB98742F, "sbadplacename" },
    { 0x25E57407, "sbm" },
    { 0x8C6ED38D, "sbmodel" },
    { 0xCE59B789, "sbmodelprefix" },
    { 0x0CF8A40C, "sbmodels" },
    { 0x18420BC0, "sbmodeltnstring" },
    { 0xE6C55480, "sbpv" },
    { 0x83F52043, "sbreachtype" },
    { 0x6BF6CE2C, "sbrush" },
    { 0x536EEEA3, "sbrush_office_ceiling_lights_off" },
    { 0xA9CEA3D0, "sbtimeplayed" },
    { 0xCF993603, "sc4tag" },
    { 0x402E1698, "sc_guy1" },
    { 0xB23585D3, "sc_guy2" },
    { 0x4D3C687D, "sc_set_hero_run_anim" },
    { 0x6AC3DF09, "scaffolding" },
    { 0x1053CF8F, "scaffolding_damage_trigger1" },
    { 0x9E4C6054, "scaffolding_damage_trigger2" },
    { 0x7849E5EB, "scaffolding_damage_trigger5" },
    { 0x0B5C4B41, "scaffolding_trigger1" },
    { 0x315EC5AA, "scaffolding_trigger2" },
    { 0xA36634E5, "scaffolding_trigger5" },
    { 0x579C9408, "scalable" },
    { 0x7BA95BEE, "scalable_model" },
    { 0x545F7E11, "scalable_models" },
    { 0x1EDAE8B9, "scalar" },
    { 0x23A9B9D3, "scalar_hud_elem" },
    { 0x22599277, "scalar_value" },
    { 0xD737DC14, "scalding" },
    { 0x5C21AD3D, "scale" },
    { 0x99D71BA5, "scale2" },
    { 0x73D4A13C, "scale3" },
    { 0x4DD226D3, "scale4" },
    { 0xF96254BA, "scale_big" },
    { 0xC2B66602, "scale_delta" },
    { 0xEB1C7620, "scale_dist" },
    { 0xB43CB583, "scale_dist_max" },
    { 0x7953136D, "scale_dist_min" },
    { 0x0FC916D4, "scale_down" },
    { 0xC097F48F, "scale_end" },
    { 0xBA2701A9, "scale_factor" },
    { 0x2B170727, "scale_forward" },
    { 0x2DB41361, "scale_helmet_damage" },
    { 0xA7006619, "scale_lerp_time" },
    { 0x424343C6, "scale_model_lods" },
    { 0x1DC8CF16, "scale_multipler" },
    { 0xEBC1940A, "scale_over_time" },
    { 0xADC79676, "scale_right" },
    { 0xCC9354D0, "scale_rocket" },
    { 0xC8CABBE5, "scale_small" },
    { 0x1BC38161, "scale_speed" },
    { 0x55BB1D19, "scale_speed_in_water" },
    { 0x9F4568C4, "scale_start" },
    { 0x4926600B, "scale_time" },
    { 0x7B6DDCA7, "scale_up" },
    { 0x799FBE03, "scale_wait" },
    { 0xD4ED14A8, "scale_x" },
    { 0xFAEF8F11, "scale_y" },
    { 0x20F2097A, "scale_z" },
    { 0x2398BB37, "scalebuoyancy" },
    { 0x6D0BE603, "scaled" },
    { 0x21D61FCB, "scaled_angle" },
    { 0x79DC4865, "scaled_damage" },
    { 0x653570F2, "scaled_dmg" },
    { 0x59E43429, "scaled_exposure" },
    { 0x721DF945, "scaled_move" },
    { 0xBDD05434, "scaledangle" },
    { 0x8E3DCE30, "scaledby" },
    { 0xBC1A4954, "scaleforward" },
    { 0xA8812F6B, "scalemin" },
    { 0xFF9C38DC, "scaleovertime" },
    { 0x996F020D, "scaleperincrement" },
    { 0x19388165, "scaler" },
    { 0xAD73818C, "scalerange" },
    { 0xF33606FC, "scales" },
    { 0xF30AF63A, "scaletime" },
    { 0x3529A2EF, "scalex" },
    { 0x0F272886, "scaley" },
    { 0x1897ABE8, "scaling" },
    { 0xFC778D9F, "scamerastatus" },
    { 0xBEAB112C, "scamerastyle" },
    { 0x53993742, "scan" },
    { 0x40D9AFB1, "scan_angles" },
    { 0x1CA32355, "scan_done" },
    { 0xDCF15942, "scan_forever" },
    { 0x2A5F4B10, "scan_forward" },
    { 0x19510FDA, "scan_height_offset" },
    { 0xC4F45E80, "scan_points" },
    { 0x08BAF533, "scan_points_randomly" },
    { 0xB453257F, "scan_points_sequentially" },
    { 0xE2953CF8, "scan_position" },
    { 0x520A6BAE, "scan_sound" },
    { 0x3BB635AA, "scan_tuning_funcs" },
    { 0x54F4E4A8, "scan_vector" },
    { 0xBD4DA997, "scanangle" },
    { 0x3470F459, "scanent" },
    { 0xD590D3CA, "scanline_intensity" },
    { 0xB1C45E6C, "scanline_speed" },
    { 0xD5E50E6B, "scanned" },
    { 0xC1C25CAD, "scanner" },
    { 0x193AD286, "scanner_backdrop" },
    { 0xBFA5BAC4, "scanner_guy_think" },
    { 0x72BC3A83, "scanner_model_swap" },
    { 0x40BCC4C9, "scanner_ping_fx" },
    { 0x1417A6B1, "scanner_prep" },
    { 0x8FB808F3, "scanner_scenes" },
    { 0x488CEEA8, "scannerdirection" },
    { 0x845C3483, "scannerorigin" },
    { 0xA0181BAC, "scanners" },
    { 0xCDB1AD40, "scanning" },
    { 0x62787EC9, "scanning_arc" },
    { 0x7257666B, "scanning_pitch" },
    { 0xBF0F706E, "scanning_speedscale" },
    { 0xF94CBB74, "scanpos" },
    { 0x1519F48D, "scans" },
    { 0x5EF2E0E7, "scare" },
    { 0x06FED4E1, "scared" },
    { 0x6ABBC5B1, "scared_into_mowdown_guys_setup" },
    { 0x689B2A55, "scaredofplayer" },
    { 0x97BEEBEE, "scareshots" },
    { 0xECEB71AC, "scarf" },
    { 0x081146AB, "scarred" },
    { 0xF6FCCA8B, "scary" },
    { 0x87239A14, "scary_eyes_reticle_index" },
    { 0xDCB08EFE, "scary_lighting" },
    { 0x94EDC270, "scary_lightning" },
    { 0x5914883C, "scary_voice" },
    { 0xB99B620F, "scatted" },
    { 0x7564DD09, "scatter" },
    { 0xC6510736, "scattered" },
    { 0x2A209035, "scattered_" },
    { 0x0DA4B4A9, "scatterphalanx" },
    { 0xD018C0E3, "scavenge" },
    { 0xD113A79D, "scavenged" },
    { 0x29CC2379, "scavenged_primary_grenade" },
    { 0x6104077D, "scavengedgrenade" },
    { 0x24E70C3B, "scavenger" },
    { 0xF0D23C5C, "scavenger_bag_mp" },
    { 0x613A1BAC, "scavenger_hud_create" },
    { 0xE5ED7D9B, "scavenger_hud_destroyondisconnect" },
    { 0xFABE214D, "scavenger_icon" },
    { 0x9FE1FA37, "scavenger_lethal_proc" },
    { 0xAB681ED8, "scavenger_tactical_proc" },
    { 0x74EF6E8A, "scavenger_think" },
    { 0x82F62181, "sccramble" },
    { 0x86675D99, "sccs" },
    { 0xDEA20659, "scd" },
    { 0x1E40760D, "sceintist" },
    { 0x9B723547, "scenario" },
    { 0x55902FEA, "scenario_one" },
    { 0x569954EE, "scenario_table" },
    { 0xCB744532, "scenario_three" },
    { 0x52AE5F5C, "scenario_two" },
    { 0x80B6CB3E, "scenarios" },
    { 0x54A98A2A, "scenarios_fov" },
    { 0xB7276EE3, "scenarious" },
    { 0x0CC27597, "scene" },
    { 0x26F4FBBC, "scene1" },
    { 0xEA8CE682, "scene_" },
    { 0x63F4FA91, "scene_0_v1_rebar" },
    { 0x2947D827, "scene_0_v3_rebar" },
    { 0xC35A655F, "scene_1" },
    { 0xFDC98DC6, "scene_abbrev" },
    { 0xD7C7020C, "scene_actors" },
    { 0xB6132D37, "scene_afghanistan_briefing" },
    { 0x41ADFF23, "scene_afghanistan_fail" },
    { 0x68A28905, "scene_afghanistan_fail_animated" },
    { 0x8EDFA215, "scene_afghanistan_models" },
    { 0x57890D7C, "scene_ai" },
    { 0x31ACF948, "scene_ai_properties" },
    { 0x534C4EB5, "scene_align" },
    { 0xDC31FA0A, "scene_allow_death" },
    { 0x81EE287A, "scene_and_loop" },
    { 0x04F35855, "scene_and_node_targetname" },
    { 0x9A43A660, "scene_animate_origin" },
    { 0x00C83125, "scene_auto_center" },
    { 0xE51193E2, "scene_being_skipped" },
    { 0xACC26322, "scene_black_screen" },
    { 0xEC6FD78D, "scene_bridge" },
    { 0x9449F73C, "scene_bridge_entry" },
    { 0x6D555FC9, "scene_catwalk" },
    { 0x3150306C, "scene_cctv_end" },
    { 0xA1E61055, "scene_cctv_exit" },
    { 0xEA55DB3C, "scene_cctv_taunt_mason" },
    { 0x21391446, "scene_change" },
    { 0xB267A76C, "scene_cic_bodies" },
    { 0x26CA1275, "scene_cic_custom_entrances" },
    { 0xEFB2B1E5, "scene_cic_hackers" },
    { 0x9E23C46F, "scene_clear_ai_goals" },
    { 0x5C6AD1C2, "scene_collision" },
    { 0xF2CE92F7, "scene_complete" },
    { 0xAC09E3EC, "scene_complete_on_signal" },
    { 0x6039DB1C, "scene_control_room_defalco" },
    { 0x78B4E958, "scene_control_room_salazar" },
    { 0x10FCE933, "scene_debug_align_nodes" },
    { 0x764AF9E5, "scene_debug_enabled" },
    { 0xED1BFA6D, "scene_debug_shared" },
    { 0x672FA083, "scene_delete" },
    { 0x554778B0, "scene_delta" },
    { 0x378CA035, "scene_desc" },
    { 0x4E729D2D, "scene_disable_player_stuff" },
    { 0x0818FE8D, "scene_dockside_briefing" },
    { 0x712AC23F, "scene_dockside_models" },
    { 0xACCB9CFA, "scene_done" },
    { 0xF3535547, "scene_done_flag" },
    { 0x614434B3, "scene_drone_briefing" },
    { 0x0CA56129, "scene_drone_models" },
    { 0x72F67A12, "scene_drop_arm" },
    { 0x275BF376, "scene_e7_couple_a_run_from_mall_to_titanic_anim" },
    { 0x78A3F921, "scene_e7_couple_b_run_from_mall_to_titanic_anim" },
    { 0x0511498A, "scene_e7_couple_run_to_titanic_area_anim" },
    { 0x9AA6ECFE, "scene_editor_add_huds" },
    { 0xF3BFA7ED, "scene_editor_menu" },
    { 0xA8AC3797, "scene_editor_select_shot" },
    { 0xA475D66C, "scene_enable_cybercom" },
    { 0x9DB7E36E, "scene_enable_player_stuff" },
    { 0x39D12150, "scene_ender" },
    { 0xE0944FAE, "scene_enemies" },
    { 0x60D0334A, "scene_error_hud" },
    { 0x4F14E5A1, "scene_event8_door_breach_started" },
    { 0x467A06FA, "scene_exists" },
    { 0xED7DC605, "scene_fade_out" },
    { 0x0EFBD509, "scene_familiar_face" },
    { 0x3B56D7EB, "scene_familiar_face_rumble" },
    { 0x62937FB3, "scene_fov" },
    { 0x36D33D4D, "scene_front_bridge_hackers" },
    { 0x8AEE96EB, "scene_funcs" },
    { 0x4E161C25, "scene_generic" },
    { 0x74965878, "scene_give_back_weapon" },
    { 0xEDF820E6, "scene_glasses_on" },
    { 0x82DF8562, "scene_guys" },
    { 0x10EA9940, "scene_hallway" },
    { 0x4D2E877B, "scene_hallway_devestation" },
    { 0x0252B8AA, "scene_heli" },
    { 0x6C90B081, "scene_hide_weapon" },
    { 0x306B8D64, "scene_idle_waittill_input" },
    { 0x351D77EE, "scene_index" },
    { 0x613B113F, "scene_interrogation" },
    { 0xAE698E43, "scene_intro_cctv" },
    { 0x8BD013F7, "scene_intro_heli" },
    { 0x50953FEC, "scene_intro_interrogation" },
    { 0x12759317, "scene_intro_nag" },
    { 0xE6BCB4C9, "scene_is_playing" },
    { 0x95EA7799, "scene_kneecap" },
    { 0x112E1374, "scene_line" },
    { 0xF53CF1EA, "scene_link" },
    { 0xB0ED6108, "scene_list_menu" },
    { 0x9882C852, "scene_list_settext" },
    { 0x196C68A4, "scene_loop" },
    { 0xD0CB9FC5, "scene_mason_taser_knuckles" },
    { 0xD51E0E9B, "scene_menendez_cctv" },
    { 0xBD6CED78, "scene_menendez_hack" },
    { 0x9061788E, "scene_menu_cleanup" },
    { 0x27CDE70F, "scene_name" },
    { 0xF247E8C4, "scene_name1" },
    { 0x644F57FF, "scene_name2" },
    { 0xBEEB77D6, "scene_names" },
    { 0x017B4A95, "scene_no_hide_parts" },
    { 0x99C23D6A, "scene_no_tag" },
    { 0xE848E1BA, "scene_num" },
    { 0xAC574B2F, "scene_object" },
    { 0x7E438819, "scene_object_id" },
    { 0xC8F52C6A, "scene_observers_variable" },
    { 0x600B0AD0, "scene_ordered_notetracks" },
    { 0x125AD7CA, "scene_orig_origin" },
    { 0x73EECD6F, "scene_overflow_briefing" },
    { 0x2FB6CCCD, "scene_overflow_models" },
    { 0x67F09AFB, "scene_phase_2_end_models" },
    { 0xCBCF2ED5, "scene_play_dead" },
    { 0x123E33CB, "scene_played" },
    { 0xD5F54BF6, "scene_pmc_hackers" },
    { 0x23ED9260, "scene_pre_briefing" },
    { 0xDA835959, "scene_pre_briefing_models" },
    { 0xC3C9E634, "scene_pre_briefing_phase4" },
    { 0x2AA6612E, "scene_pre_models" },
    { 0x91353247, "scene_reach" },
    { 0xFBD5D38C, "scene_sal_open_door" },
    { 0x3AC3B1D0, "scene_sal_open_door_rumble" },
    { 0xCA648E29, "scene_salazar_exit" },
    { 0x6ABDC599, "scene_salazar_kill" },
    { 0x31E82D67, "scene_salazar_kill_victims" },
    { 0x4499E5D7, "scene_security_level" },
    { 0xF99A0A18, "scene_security_reboot" },
    { 0x14C06C0C, "scene_sequence_ended" },
    { 0x1C353A4F, "scene_sequence_started" },
    { 0x85A54C2A, "scene_server_room_super_kill" },
    { 0xFD94F8F3, "scene_set_visible_time" },
    { 0x2E89FFA1, "scene_shared" },
    { 0x869EF4B8, "scene_should_spectate_on_hot_join" },
    { 0x07D13C1C, "scene_simple_prop" },
    { 0xD26CEE31, "scene_skip_completed" },
    { 0xE14D7C6C, "scene_skip_sequence_ended" },
    { 0xCDFDDDAF, "scene_skip_sequence_started" },
    { 0x59525D46, "scene_skip_start_time" },
    { 0xAA786A73, "scene_skip_timeout" },
    { 0x48DBDE05, "scene_skip_timer" },
    { 0xF547DA5C, "scene_socotra_briefing" },
    { 0xC073C3B2, "scene_socotra_models" },
    { 0xC3915AEA, "scene_spawn_guys" },
    { 0x99CBB514, "scene_spawned" },
    { 0xFD6703E2, "scene_start" },
    { 0x0EB68601, "scene_stopped" },
    { 0xFB490AC2, "scene_stopping" },
    { 0xF045351E, "scene_sync_list" },
    { 0xB097A049, "scene_sys" },
    { 0xECBA7DD8, "scene_takedamage" },
    { 0xAE522028, "scene_torchcutters" },
    { 0x71DC86DA, "scene_trigger" },
    { 0x30A6BB47, "scene_use_camera_tween" },
    { 0xED2B1FC5, "scene_use_tag_angles" },
    { 0x4DE79C21, "scene_wait" },
    { 0x1F26C09D, "scene_wait_and_run" },
    { 0xA03F2F01, "scene_wakeup" },
    { 0xD6C5EBF4, "scene_warning_hud" },
    { 0x4D61A383, "scene_window_throw" },
    { 0x61A8B357, "scene_ziptied_pmcs" },
    { 0xBFF02DF7, "scenebundle" },
    { 0xC0D2908C, "scenedef" },
    { 0xE9BD0B3A, "scenegoal" },
    { 0x68BABB2A, "scenename" },
    { 0x1198A919, "sceneobjects" },
    { 0xF25B564E, "scenes" },
    { 0xF758B962, "sceneskippedcount" },
    { 0x93BBE8FF, "scenetype" },
    { 0x9576D7EA, "schedule" },
    { 0x5C5B48DA, "scheduled" },
    { 0x302C1CBF, "schematics" },
    { 0x816E9B34, "scheme" },
    { 0x5281BEBD, "scheming" },
    { 0x88F0B91E, "schlub" },
    { 0xE3491881, "school" },
    { 0xFB2CF459, "schoolcircle" },
    { 0x3F62C510, "schoolcircle_assembled" },
    { 0x902B96F2, "schoolcircle_breakup" },
    { 0xE5761D6E, "schoolcircle_crouch" },
    { 0x9EBBD60C, "schoolcircle_goals" },
    { 0xC1FBD345, "schoolcircle_guy_reset" },
    { 0xE279CF14, "schoolcircle_leader_moving" },
    { 0xD784C963, "schoolcircle_nav" },
    { 0x94D8B179, "schoonover" },
    { 0xB7EDC46F, "schreck1_end" },
    { 0x9BFCFEA4, "schreck1_start" },
    { 0xB901887C, "schreck2_end" },
    { 0x9CBAE857, "schreck2_start" },
    { 0x11BFF6B2, "schreck_end" },
    { 0x0C80484A, "schreck_nodes" },
    { 0xB35CCE64, "schreck_number" },
    { 0xC7A88D69, "schreck_start" },
    { 0xE0C0FB98, "schreck_starts_left" },
    { 0x25F54927, "schreck_starts_right" },
    { 0xCE6574D2, "schreck_tower_achievement" },
    { 0xBFCD36EF, "schrecks" },
    { 0xD2062538, "schreckstart" },
    { 0x46DA7DC4, "schrek_cleanup" },
    { 0x9EF90B1C, "schreks" },
    { 0x24E386F4, "schreks_and_mgs_count" },
    { 0x992209D8, "schreks_count" },
    { 0x17A39A68, "schwimmenwagen" },
    { 0x80BD48DC, "sci" },
    { 0xB9D47D13, "sci_total" },
    { 0x434AD321, "science" },
    { 0x2A25B2A2, "scientific" },
    { 0x02AAA2F5, "scientist" },
    { 0x56CB50E2, "scientist_ai" },
    { 0x6DD2AECF, "scientist_c4_anim" },
    { 0xCC1033AF, "scientist_final_node" },
    { 0xD99C6971, "scientist_first_node" },
    { 0xE7548D20, "scientist_takes_damage" },
    { 0x952024C4, "scientists" },
    { 0x6A558880, "scientists_spawners" },
    { 0x5CC20626, "sciprt_brushmodel" },
    { 0x338A9338, "scipt" },
    { 0x98C6C327, "scipt_node" },
    { 0x0197FB2D, "scipt_origin" },
    { 0x87EA05CE, "scjs" },
    { 0xFA5F204E, "scle" },
    { 0x954716EC, "sclosed" },
    { 0x763C336A, "scm2" },
    { 0x9C3EADD3, "scm3" },
    { 0xCEDCCC49, "scmod" },
    { 0x1BA01393, "scms" },
    { 0x34B8540A, "sco" },
    { 0xF41107F7, "sco_east_walkway_support" },
    { 0x0DBE2422, "sco_east_walkway_support_dialog" },
    { 0xF90F1DB2, "sco_east_walkway_support_interior" },
    { 0x1DA870C1, "sco_east_walkway_support_wait" },
    { 0x9F534937, "sco_main_entrance_support" },
    { 0x57D9BC49, "sco_west_walkway_support" },
    { 0x07705FCF, "sco_west_walkway_support_wait" },
    { 0x3EEDDB31, "scobalula" },
    { 0xCFD8CB65, "scobratargetname" },
    { 0xD76D610D, "scoldanim" },
    { 0x0ED250DD, "scoldplayer" },
    { 0x08EC1C8A, "scolorsuffix" },
    { 0x1E66C3D7, "scope" },
    { 0x10D25EC9, "scope_off" },
    { 0xE5F466BD, "scope_on" },
    { 0xDB0BAEF1, "scoped" },
    { 0x3D732565, "scorch" },
    { 0x26339052, "scorched" },
    { 0xF1242439, "score" },
    { 0xD1C01319, "score_achievement" },
    { 0xD79E81BD, "score_angle" },
    { 0x1E729E49, "score_angle_position" },
    { 0x06785A90, "score_cf_increment_info" },
    { 0xF14B292E, "score_cf_info" },
    { 0x6586BF8C, "score_cf_monitor" },
    { 0x3EFC9650, "score_cf_register_info" },
    { 0x290AB115, "score_chain_timer" },
    { 0xBBC8D2E3, "score_current" },
    { 0x32A952CD, "score_curve" },
    { 0x166FB977, "score_decrement" },
    { 0x5BCFFBA9, "score_diff" },
    { 0x6F36EC0D, "score_distance" },
    { 0x67812673, "score_dvar" },
    { 0x13B2F144, "score_event" },
    { 0xEAD7F38D, "score_event_allow_killstreak_weapons" },
    { 0xB380BB2C, "score_event_death_streak_count_required" },
    { 0xAEB5C543, "score_event_double_xp" },
    { 0x6EC959D6, "score_event_gametype_column_count" },
    { 0xC3E6269D, "score_event_gametype_column_score" },
    { 0x8884DD69, "score_event_gametype_column_xp" },
    { 0xFB714782, "score_event_gametype_score" },
    { 0x62CF3D6C, "score_event_gametype_xp" },
    { 0xE8F48E8F, "score_event_max_count" },
    { 0x3C528930, "score_event_medal_material" },
    { 0x157D8E5E, "score_event_medal_reference" },
    { 0x14F61834, "score_event_medal_wait_time" },
    { 0x8D1B4847, "score_event_monitor" },
    { 0xC3663DF5, "score_event_obituary_centertime" },
    { 0x14FC4839, "score_event_report_to_theater" },
    { 0xDB070ED9, "score_event_score_string" },
    { 0x6E79C0A0, "score_event_script_reference" },
    { 0x3CF0B489, "score_event_set_stats" },
    { 0xD3CAE8DD, "score_event_table_name" },
    { 0xA8F0B181, "score_event_table_name_cp" },
    { 0x1CB67DEF, "score_event_table_name_mp" },
    { 0x6F54464B, "score_event_table_name_zm" },
    { 0x254D22C1, "score_for_achievement" },
    { 0x1BEF3324, "score_highlight" },
    { 0x30449D68, "score_inc" },
    { 0xF9EDA2B0, "score_index" },
    { 0xB65230A6, "score_leaders" },
    { 0x7A5A923B, "score_lost_when_downed" },
    { 0xC3FBAA93, "score_move" },
    { 0x8F3F7751, "score_multiplier" },
    { 0xDC8F1D1F, "score_number" },
    { 0x058C0D93, "score_padding" },
    { 0x2F3075FB, "score_range" },
    { 0x0590F326, "score_rank_bonus" },
    { 0xD2980694, "score_set" },
    { 0xEF8C3078, "score_spawner" },
    { 0xB8C825C5, "score_special" },
    { 0x803E882F, "score_string" },
    { 0xAD9BA287, "score_target" },
    { 0x515A1FED, "score_team_event_monitor" },
    { 0x076D5C01, "score_to_drop" },
    { 0x4D864142, "score_total" },
    { 0x618B4051, "score_turn" },
    { 0xFA771EBB, "score_up" },
    { 0xCD593A0C, "score_x" },
    { 0xF35BB475, "score_y" },
    { 0xC1F0E768, "scorearray" },
    { 0x3122447B, "scoreboard" },
    { 0x8D785F88, "scoreboard1" },
    { 0xBB339747, "scoreboard_max_players" },
    { 0x8BDAD12A, "scoreboardposition" },
    { 0x58DEBA1A, "scoreboards" },
    { 0x9E3A7323, "scoreboostypos" },
    { 0x1F720738, "scorechain" },
    { 0xDBC2BE8B, "scorechaintimer" },
    { 0x074AE25F, "scorecheck" },
    { 0x18EBC12B, "scorecolumn" },
    { 0xADDCD6BF, "scored" },
    { 0xDC6596B7, "scored_spawn" },
    { 0x7468EF93, "scored_spawn_points" },
    { 0x9ED8C312, "scoredif" },
    { 0xFC3E4F80, "scorediff" },
    { 0xCDA47163, "scoreevent" },
    { 0x17D2BC09, "scoreeventcallbacks" },
    { 0x320D6FA1, "scoreeventcolumn" },
    { 0xB23EFB09, "scoreeventgameendcallback" },
    { 0x24E4C464, "scoreeventplayerkill" },
    { 0xD26A1EEF, "scoreeventpriority" },
    { 0x0166FE8D, "scoreeventprocessed" },
    { 0xA1CB6B52, "scoreevents" },
    { 0x8EE4CD66, "scoreevents_shared" },
    { 0x76FEBF72, "scoreeventtableid" },
    { 0xA467985F, "scoreeventtablelookup" },
    { 0x1A76033A, "scoreeventtablelookupint" },
    { 0x94964084, "scorefactor" },
    { 0x6129F364, "scoregiven" },
    { 0x67D60A31, "scoreincrease" },
    { 0xE92E5E75, "scoreinfo" },
    { 0x0FA1FD69, "scoreinfotable_demo_bookmark_priority" },
    { 0x5184E408, "scoreinfotable_double_xp" },
    { 0xE372858F, "scoreinfotable_gametype_score" },
    { 0x7768CC4F, "scoreinfotable_gametype_xp" },
    { 0xB49F3471, "scoreinfotable_give_gun_xp" },
    { 0x1F5F2892, "scoreinfotable_include_combat_efficiency_event" },
    { 0xFE974329, "scoreinfotable_include_hero" },
    { 0xE3FBA882, "scoreinfotable_include_killstreaks" },
    { 0x3A1A8ABB, "scoreinfotable_medal_backing_material" },
    { 0x54A626EE, "scoreinfotable_medal_category" },
    { 0x35750935, "scoreinfotable_medal_reference" },
    { 0x4A82F07A, "scoreinfotable_medal_sort_key" },
    { 0x57C13455, "scoreinfotable_save_medal_stats" },
    { 0x084CFB18, "scoreinfotable_score_string" },
    { 0xB5C39BD5, "scoreinfotable_script_reference" },
    { 0xAF5589AE, "scoreinfotable_team_score_material" },
    { 0x957B7364, "scoreinfotableid" },
    { 0x6AFE1AC4, "scoreinfotableloaded" },
    { 0xE300E83A, "scorelimit" },
    { 0xDCF5AEEA, "scorelimitcheck" },
    { 0x69730F01, "scorelimitdvar" },
    { 0x88CA8EED, "scorelimitisperround" },
    { 0xFA21E3C0, "scorelimitmax" },
    { 0xA74A74FE, "scorelimitmin" },
    { 0xAE6E4FEF, "scoremodifiercallback" },
    { 0x9ED66788, "scoremultiplier" },
    { 0xE0D7D064, "scoreongiveplayerscore" },
    { 0xE7747A04, "scorepanel_flipped" },
    { 0x4874AF36, "scorepercentageleft" },
    { 0x444AEDC2, "scoreperminute" },
    { 0x2531D741, "scoreperplayer" },
    { 0x94EE2327, "scoreremaining" },
    { 0x95FB849D, "scoreresetondeath" },
    { 0x88C20C30, "scoreroundbased" },
    { 0xF7711EBC, "scoreroundwinbased" },
    { 0x93DB5F90, "scorers" },
    { 0x03F32470, "scores" },
    { 0x8A99A447, "scorestreak" },
    { 0x2E1CC5B3, "scorestreakdialogplaying" },
    { 0xFBCA883E, "scorestreaks" },
    { 0xC0C55C1D, "scorestreaksearnedperuse" },
    { 0xCF78039C, "scorestreaksmaxstacking" },
    { 0x4A818CA5, "scoresub" },
    { 0x43EC2ACA, "scorethreshold" },
    { 0x62E9F79A, "scorethresholdstart" },
    { 0xFE10E861, "scoretype" },
    { 0x02593C80, "scorevalue" },
    { 0x6F36EC2C, "scoring" },
    { 0x77019C64, "scoring_player" },
    { 0x64D84F2B, "scoring_teams" },
    { 0x1137F00A, "scot" },
    { 0xB4709F32, "scott_b_shader_test" },
    { 0x1C76705D, "scout" },
    { 0x25E75BAE, "scout1" },
    { 0xFFE4E145, "scout2" },
    { 0xA17C0AB5, "scout_base_speed_modifier" },
    { 0xBCC74CC7, "scout_callback_damage" },
    { 0x7877E91A, "scout_default_radius_for_defend_role" },
    { 0x285DC0A1, "scout_default_radius_for_guard_role" },
    { 0x3A8F358D, "scout_default_radius_for_loiter_role" },
    { 0xFAEFE002, "scout_defend_height" },
    { 0xEC1EE2D6, "scout_drone" },
    { 0x855105E7, "scout_drone_initialize" },
    { 0x45707574, "scout_find_new_position" },
    { 0x737B0135, "scout_loiter_height" },
    { 0x3466E8BC, "scout_patrol_height" },
    { 0x6EF666A9, "scout_track_distance" },
    { 0xD5E2B399, "scout_track_height" },
    { 0x69FDCE44, "scout_track_tether" },
    { 0xFAF80E4B, "scouting" },
    { 0x5943CC9C, "scouts" },
    { 0x93B83120, "scouts_emerge" },
    { 0x93370F6C, "scoutsniper" },
    { 0xC5987FFD, "scoutsniper_amb" },
    { 0x69151BB4, "scoutsniper_anim" },
    { 0xD2119652, "scoutsniper_art" },
    { 0x3BD90EB8, "scoutsniper_code" },
    { 0x80EA47C5, "scoutsniper_fx" },
    { 0x540C6857, "scoutsniper_intro" },
    { 0xD52EB196, "scoutsniper_mcm_readygo" },
    { 0x67049740, "scoutsniperintrodvars" },
    { 0x7484A24D, "scoutsniperintroplayer" },
    { 0x62893E3F, "scr" },
    { 0xFBDFA20A, "scr_" },
    { 0x616A29F5, "scr_airstrikedebug" },
    { 0x5C9DC440, "scr_ani" },
    { 0x3A2CDAF5, "scr_anim" },
    { 0xE0C04C7C, "scr_animname" },
    { 0xF71E4CC4, "scr_anims" },
    { 0x90F2486A, "scr_animsound" },
    { 0x91DC7825, "scr_animsounds" },
    { 0xE065FC41, "scr_animtree" },
    { 0xA5191651, "scr_artilleryangle" },
    { 0xB6B1C3CD, "scr_artillerydebug" },
    { 0x6CBEECF9, "scr_artillerydistance" },
    { 0xF12C824A, "scr_bundle" },
    { 0x69064817, "scr_camerashot" },
    { 0x283179E7, "scr_cod4_test" },
    { 0xBF234BBF, "scr_const" },
    { 0x4C00C430, "scr_damagefeedback" },
    { 0x13288038, "scr_deadbody" },
    { 0x95CCACC7, "scr_degreestoroll" },
    { 0xEDCC641B, "scr_delete" },
    { 0xEF34CB25, "scr_demorecord_minplayers" },
    { 0x3458DCC7, "scr_domdebug" },
    { 0x6D8D6479, "scr_earthquake" },
    { 0xAB7DA894, "scr_eyeoffset" },
    { 0x3FE33355, "scr_face" },
    { 0x8B3B1F20, "scr_flashlight" },
    { 0x8CFE5E47, "scr_fog_baseheight" },
    { 0x9ABB363D, "scr_fog_blue" },
    { 0x1BC7F7A7, "scr_fog_disable" },
    { 0xC29003BB, "scr_fog_exp_halfheight" },
    { 0x135893C4, "scr_fog_exp_halfplane" },
    { 0xFD4C327E, "scr_fog_green" },
    { 0xF31B5567, "scr_fog_nearplane" },
    { 0x0FB8F86E, "scr_fog_red" },
    { 0x52370356, "scr_forceextendeddeath" },
    { 0x284AB31F, "scr_friendlyfire" },
    { 0xCBC2FDC9, "scr_ignoreall" },
    { 0x07396942, "scr_ignoreme" },
    { 0x622895A2, "scr_intro_patrolwalk" },
    { 0xB5F09F4E, "scr_intro_patrolwalk_reset" },
    { 0xB58CA95F, "scr_look" },
    { 0x6B83B561, "scr_model" },
    { 0x42F907E2, "scr_mortarangle" },
    { 0xF1A592FA, "scr_mortardebug" },
    { 0x65823F08, "scr_mortardistance" },
    { 0x94344796, "scr_motd" },
    { 0xC2D9AE5B, "scr_notetrack" },
    { 0x1E76347A, "scr_notetracks" },
    { 0x826EDBC1, "scr_notify" },
    { 0xFE76E4D4, "scr_org" },
    { 0xD526C371, "scr_player_speedscale" },
    { 0x2DDB739A, "scr_playfx" },
    { 0xE3A00FE3, "scr_popupchallenge" },
    { 0xFFC25C2E, "scr_popupcontract" },
    { 0x63812312, "scr_popuprank" },
    { 0x4427DFBF, "scr_radio" },
    { 0x0A660FB9, "scr_reset_goalradius" },
    { 0xDDCB01A6, "scr_rts_allpkgs" },
    { 0x649B4F7A, "scr_rts_cameramode" },
    { 0x1B552AFB, "scr_rts_enemydebug" },
    { 0x2229E7D2, "scr_rts_enemydisabled" },
    { 0x152EE739, "scr_rts_squaddebug" },
    { 0x0A40A105, "scr_scenes" },
    { 0xF5E2D0D7, "scr_set_health" },
    { 0xC9F1D69D, "scr_set_water_drops" },
    { 0x64868947, "scr_setmode" },
    { 0xF3B600ED, "scr_showspawns" },
    { 0x695A72D7, "scr_sound" },
    { 0xDDBCBF73, "scr_special_notetrack" },
    { 0x0686BD5F, "scr_testgrenadethrows" },
    { 0xD5DF6EF7, "scr_text" },
    { 0x8572D96E, "scr_thread" },
    { 0x31B334E2, "scr_touched_name" },
    { 0x2C8C299A, "scr_veh_explode_on_cleanup" },
    { 0x7E7F69CD, "scr_zm_game_module" },
    { 0x4730264F, "scr_zm_map_start_location" },
    { 0x87542F3B, "scr_zm_ui_gametype" },
    { 0x1A4E613F, "scr_zm_ui_gametype_group" },
    { 0xE534E8C9, "scram" },
    { 0xE8A0AE98, "scramble" },
    { 0xA5EAAA4C, "scrambled" },
    { 0xBA0D5C0A, "scrambler" },
    { 0x2C016435, "scrambler_death" },
    { 0x8F3F45D2, "scrambler_spawn" },
    { 0x5BF68B8A, "scramblerdetonate" },
    { 0xF83CDFE1, "scramblerent" },
    { 0x732818E1, "scramblerflatorigin" },
    { 0xAA893E08, "scramblerhandle" },
    { 0x8C65E876, "scramblerindex" },
    { 0x7AB38FA4, "scramblerinnerradius" },
    { 0x261F70BC, "scramblerinnerradiussq" },
    { 0xCBB5D4BE, "scramblerlength" },
    { 0xE30750D9, "scramblerouterradiussq" },
    { 0x681AF745, "scramblers" },
    { 0x66BE9F2A, "scramblerstun" },
    { 0x727FF13F, "scramblerteamchanged" },
    { 0x2FBB0CD5, "scramblerupdate" },
    { 0x312E999E, "scramblervoouterradius" },
    { 0x46AE24DA, "scramblerweapon" },
    { 0x4B07DCE5, "scramblesound" },
    { 0x57E1F301, "scramblesoundalert" },
    { 0xC019C5C9, "scramblesoundburst" },
    { 0x65068111, "scramblesoundping" },
    { 0x944FFBD9, "scrambling" },
    { 0xE777D1DC, "scrap" },
    { 0x8BE73B39, "scrape" },
    { 0xCB12D3D9, "scraper" },
    { 0x10315B2C, "scraping" },
    { 0x9BE5C761, "scrapper" },
    { 0xAB2452E1, "scratch" },
    { 0x07AFBA02, "scratch_score" },
    { 0x947F3762, "scrdof" },
    { 0x3B3D954E, "scream" },
    { 0x834F8D53, "scream_a_watcher" },
    { 0x25D837F2, "scream_anim" },
    { 0x90D6BE90, "scream_b_watcher" },
    { 0x8EDFB594, "scream_ent" },
    { 0x1CD2F804, "scream_points" },
    { 0xF5CAA9DD, "scream_sounds" },
    { 0x50E1764E, "screamers" },
    { 0x7388B6F2, "screaming" },
    { 0xCA1735F1, "screams" },
    { 0x4323639C, "screech" },
    { 0xE9AC4D4A, "screech_complete" },
    { 0x3D24D167, "screech_players" },
    { 0xBCD6DDD8, "screech_time" },
    { 0x4CF4F808, "screech_zones" },
    { 0x56D04199, "screecher" },
    { 0xD25CA200, "screecher_attack" },
    { 0x348EAB18, "screecher_attacking" },
    { 0x422D42A6, "screecher_chase" },
    { 0xD90DFD82, "screecher_chase_update" },
    { 0x26F7BA73, "screecher_check_score" },
    { 0x7F1E9E5B, "screecher_claimed" },
    { 0x61D6A9C8, "screecher_cleanup" },
    { 0xEEE52638, "screecher_damage_func" },
    { 0x8094DEF3, "screecher_death_func" },
    { 0xD0BF5B09, "screecher_debug" },
    { 0xD1819F0F, "screecher_debug_axis" },
    { 0xC3D71359, "screecher_detach" },
    { 0xC5753F23, "screecher_distance_tracking" },
    { 0xA4C1438A, "screecher_find_flesh" },
    { 0x50FB9E2D, "screecher_first_seen_hint_think" },
    { 0x695290AB, "screecher_fly_to_player" },
    { 0xE743DF7D, "screecher_get_closest_valid_player" },
    { 0x81F366B5, "screecher_init_done" },
    { 0x61FD11B3, "screecher_jump_dist" },
    { 0x140F17A7, "screecher_jump_down" },
    { 0x0A38F12F, "screecher_killed" },
    { 0x4ADEECAD, "screecher_lerp_time" },
    { 0xA83CB023, "screecher_lerp_timeout" },
    { 0xED44D1E8, "screecher_light_hint" },
    { 0x782A5F93, "screecher_light_on_sq" },
    { 0x56B30930, "screecher_locations" },
    { 0xB4854736, "screecher_melee_button_watcher" },
    { 0x48619FE8, "screecher_melee_damage" },
    { 0x3DBFDA6F, "screecher_nofx" },
    { 0xB8824DEE, "screecher_player_down" },
    { 0xC2F5AEBE, "screecher_player_melee" },
    { 0x5F009E60, "screecher_prespawn" },
    { 0x27009E79, "screecher_print" },
    { 0xAB221E0B, "screecher_rise" },
    { 0xCF73339D, "screecher_runaway" },
    { 0x97373DDA, "screecher_score" },
    { 0x0D6EA239, "screecher_score_win" },
    { 0x6F310FD7, "screecher_seen_hint" },
    { 0x87E6D0FD, "screecher_should_burrow" },
    { 0x92162F21, "screecher_should_runaway" },
    { 0xCEC3FAF3, "screecher_spawners" },
    { 0xF40E49CC, "screecher_spawning_logic" },
    { 0x4AB56847, "screecher_start_attack" },
    { 0x41E7093E, "screecher_tracking_dist" },
    { 0xF37585A5, "screecher_tracking_dist_max" },
    { 0xEA2CF068, "screecher_weapon" },
    { 0x90FA198F, "screecher_zombie_think" },
    { 0xF34BBA56, "screecher_zone" },
    { 0xDABC5126, "screechercolor" },
    { 0xF146C850, "screechers" },
    { 0xB0DB36EC, "screeching" },
    { 0x81D7A2B9, "screen" },
    { 0xB2C4FC94, "screen_ang" },
    { 0xC2914B49, "screen_beam" },
    { 0xD639D896, "screen_bink" },
    { 0x023157DE, "screen_close_menu" },
    { 0x414F019B, "screen_dirt_delay" },
    { 0x3F0B2996, "screen_fade" },
    { 0x593C2AF4, "screen_fade_in" },
    { 0x4BB247C9, "screen_fade_in_begins" },
    { 0x982E8CB2, "screen_fade_in_complete" },
    { 0xA2C23BB4, "screen_fade_in_delay" },
    { 0x759BF2F3, "screen_fade_menus" },
    { 0x57FD2687, "screen_fade_network_frame" },
    { 0x7E61DE2B, "screen_fade_out" },
    { 0x90C2D26B, "screen_fade_out_complete" },
    { 0x98FE88CF, "screen_fade_out_delay" },
    { 0xC04ACE5B, "screen_fade_to_alpha" },
    { 0xE9A12FDA, "screen_fade_to_alpha_with_blur" },
    { 0xAC4D13A6, "screen_faded" },
    { 0x789C40B3, "screen_faded_already" },
    { 0x724ABC52, "screen_flash" },
    { 0xEEFBF042, "screen_flash_dvar" },
    { 0x0F26125F, "screen_flash_visionset" },
    { 0x9F108EDB, "screen_forward" },
    { 0x7EF93455, "screen_fx_type" },
    { 0x457A5B5B, "screen_generic" },
    { 0x24DDB865, "screen_height" },
    { 0x54856ED5, "screen_internal_timer" },
    { 0xD0948381, "screen_loops" },
    { 0x19EBFE89, "screen_message" },
    { 0x1EC499F0, "screen_message_create" },
    { 0x122574DC, "screen_message_delay_fade_delete" },
    { 0x77F8007D, "screen_message_delete" },
    { 0xD5472159, "screen_message_delete_timeout" },
    { 0x8E333DC0, "screen_msg_active" },
    { 0x6BF23D54, "screen_overlay" },
    { 0x0C3A00F2, "screen_shake_manager" },
    { 0x846B23BF, "screen_struct" },
    { 0x39743CBE, "screen_timer_create" },
    { 0xB468AAFB, "screen_timer_delete" },
    { 0xB9FD90D4, "screen_timer_reached" },
    { 0x6DAB16D2, "screen_timer_stop" },
    { 0xBF6C5A1C, "screen_to_display" },
    { 0x8780AE3B, "screen_up" },
    { 0x6787F910, "screen_width" },
    { 0xD0E0C261, "screencapture" },
    { 0x0889164B, "screencompass" },
    { 0x10826FCF, "screening" },
    { 0xE7323F20, "screenproj" },
    { 0x4E8347F0, "screens" },
    { 0x4D3E98ED, "screenshake" },
    { 0xAEFB1F99, "screenshot" },
    { 0xBCC24250, "screenshots" },
    { 0xBA6F343D, "screenspace" },
    { 0x88E5D1A7, "screne" },
    { 0xF4B1290F, "screw" },
    { 0x8A155554, "screwed" },
    { 0xAF656A71, "screwing" },
    { 0x48AC5DD6, "screws" },
    { 0x5E0ED1F4, "scrip" },
    { 0xA5B0D25E, "scrip_int" },
    { 0xC444DBA2, "scrip_noteworthy" },
    { 0x19B8CEF8, "scrip_origins" },
    { 0xCF5B9F20, "scriper_mod" },
    { 0xA864D693, "scripmover" },
    { 0xCD724008, "script" },
    { 0x535014A9, "script_accel" },
    { 0xAE733F2A, "script_accel_fraction" },
    { 0x0189F9A9, "script_accumulate" },
    { 0x015DFD6C, "script_accuracy" },
    { 0x1BBBF974, "script_activated" },
    { 0x3D2183F2, "script_aigroup" },
    { 0xDE831400, "script_aigroup_name" },
    { 0x3FFFD1C6, "script_airspeed" },
    { 0x14C8A0A0, "script_aisquadname" },
    { 0x2153EFE0, "script_allowdeath" },
    { 0xE70CE58B, "script_ambientpackage" },
    { 0x06A48009, "script_ambientpriority" },
    { 0x863DAF04, "script_ambientroom" },
    { 0x097FED22, "script_ammo_clip" },
    { 0x3C82C8A2, "script_ammo_extra" },
    { 0xE90A6B23, "script_angles" },
    { 0x9472EA18, "script_anglevehicle" },
    { 0xA010FCA7, "script_animation" },
    { 0x550C62BC, "script_animator" },
    { 0x03E785FF, "script_animent" },
    { 0x81F95669, "script_animname" },
    { 0xF4761408, "script_anims_init" },
    { 0xC1D40316, "script_animscripted" },
    { 0x48A9494C, "script_area" },
    { 0x8F09D212, "script_array" },
    { 0x18F1B6D5, "script_attackmetype" },
    { 0xAFB41333, "script_attackpattern" },
    { 0x7E9A337E, "script_auto_use" },
    { 0x4E7785D7, "script_auto_use_radius" },
    { 0xCCD92669, "script_autosave" },
    { 0xB79E9408, "script_autosavename" },
    { 0x9C3F3C05, "script_autotarget" },
    { 0x4DC36805, "script_avoidplayer" },
    { 0xDD6EDB31, "script_badplace" },
    { 0x276ADBA1, "script_balconydeathchance" },
    { 0x99A9E356, "script_banzai" },
    { 0xF38D9724, "script_banzai_attack_chance" },
    { 0x70A1E136, "script_banzai_spawn" },
    { 0x49CAA608, "script_banzai_within_fov" },
    { 0xA6967B66, "script_base_height" },
    { 0x0FE6B062, "script_based_influencer_system" },
    { 0x05123487, "script_baseoffire" },
    { 0x1803EEF4, "script_battlechatter" },
    { 0x66F32E96, "script_bcdialog" },
    { 0xFF657976, "script_bctrigger" },
    { 0xA8446808, "script_bg_offset" },
    { 0xE7F51B27, "script_bombmode_dual" },
    { 0xBA4DAAE8, "script_bombmode_original" },
    { 0xEFEC70A1, "script_bombmode_single" },
    { 0xD99CCCD0, "script_brake" },
    { 0xD33B4590, "script_brushmodel" },
    { 0xE87D977B, "script_brushmodels" },
    { 0x848C1554, "script_bulletshield" },
    { 0xD0E0571F, "script_bundle" },
    { 0x6D944991, "script_burst_intensity" },
    { 0x8F1F1EC4, "script_burst_max" },
    { 0x7A00772A, "script_burst_min" },
    { 0xFE9F57C1, "script_burst_time" },
    { 0x0C12DB73, "script_car" },
    { 0x329B29A5, "script_careful" },
    { 0x3FCA3722, "script_chain" },
    { 0x3E1CE913, "script_chance" },
    { 0xDFD2CEFB, "script_char_group" },
    { 0xD8C8C19A, "script_char_groups" },
    { 0x894B217E, "script_char_index" },
    { 0x9EE65140, "script_cheap" },
    { 0x08C058B5, "script_choke" },
    { 0xBD6E635A, "script_cleartargetyaw" },
    { 0xF748F939, "script_cobratarget" },
    { 0x24A7A3C8, "script_color" },
    { 0xB6FA4BCD, "script_color_allies" },
    { 0xED89847F, "script_color_allies_old" },
    { 0x3A889867, "script_color_auto_disable" },
    { 0x0310C71C, "script_color_axis" },
    { 0x063BE9B6, "script_color_axis_old" },
    { 0xC89295E3, "script_color_scale" },
    { 0x8CCEE908, "script_color_stay_on" },
    { 0x8E3C1A4E, "script_combat_getout" },
    { 0x5C4445E4, "script_combat_idle" },
    { 0x9FA79D57, "script_contextual_melee" },
    { 0xDFB3631F, "script_control_btr" },
    { 0x63F63E28, "script_convert" },
    { 0x2E64E59A, "script_count_lock" },
    { 0x7AC1E270, "script_crashtype" },
    { 0x801BFAE0, "script_crashtypeoverride" },
    { 0xA3D02500, "script_damage" },
    { 0x65E3C226, "script_dealy" },
    { 0x154F3C77, "script_death" },
    { 0x98FF68F8, "script_death_max" },
    { 0xB3F494A6, "script_death_min" },
    { 0x206640FA, "script_deathchain" },
    { 0xF1C6675D, "script_deathflag" },
    { 0xA015CE94, "script_deathflag_longdeath" },
    { 0x08E537EC, "script_deathnotify" },
    { 0x41FD77E2, "script_deathroll" },
    { 0xF59361DE, "script_decel" },
    { 0xB44CF33B, "script_decel_fraction" },
    { 0xEB328A48, "script_delay" },
    { 0x8E4E9EDB, "script_delay_max" },
    { 0xA36D4675, "script_delay_min" },
    { 0x90359CE5, "script_delayed_playerseek" },
    { 0xB9CA24BE, "script_delete" },
    { 0x1A8374C3, "script_delete_on_zero" },
    { 0xA574FED8, "script_deleteai" },
    { 0x97A31B9E, "script_depth" },
    { 0x725C53BF, "script_destructable_area" },
    { 0x22487D3C, "script_dir" },
    { 0xCF36A829, "script_disable_bleeder" },
    { 0x5B3DCA5E, "script_disable_cqb" },
    { 0x19BD3B79, "script_disable_cqbwalk" },
    { 0x532DBE62, "script_disable_heat" },
    { 0xC805F4D0, "script_disable_idle_strafe" },
    { 0x8D47939F, "script_disable_reviver" },
    { 0xA9249115, "script_disablepain" },
    { 0x87E4ACBA, "script_disablereact" },
    { 0x03F50133, "script_disableturns" },
    { 0x8532E4F8, "script_disconnectpath_detail" },
    { 0xE126CCA7, "script_disconnectpaths" },
    { 0xE4B875A6, "script_dont_link_turret" },
    { 0xACCBDDD0, "script_dont_look" },
    { 0xAE57E607, "script_dontblindfire" },
    { 0x86FD6D2B, "script_dontpeek" },
    { 0x93A9317C, "script_dontshootwhilemoving" },
    { 0xE92F61DE, "script_doorstate" },
    { 0x132307A0, "script_dot" },
    { 0x2B8E9503, "script_drone" },
    { 0x687C09A3, "script_drone_no_sink" },
    { 0xE6D53649, "script_drones_max" },
    { 0x01CA61F7, "script_drones_min" },
    { 0x4DD7B6E6, "script_dropammo" },
    { 0x44EF2D67, "script_dropbombs" },
    { 0xB3450B4B, "script_dropbombs_delay" },
    { 0x636859FE, "script_dropbombs_delaytrace" },
    { 0x8B403850, "script_dropweapon" },
    { 0x82A8FAB7, "script_duration" },
    { 0x3F24DB40, "script_earthquake" },
    { 0x1A4F59FA, "script_emptyspawner" },
    { 0x60E37D49, "script_enable_cqb" },
    { 0x7DDF965A, "script_enable_cqbwalk" },
    { 0x77DDFF8B, "script_enable_heat" },
    { 0x7FC707C5, "script_enable_turret0" },
    { 0x59C48D5C, "script_enable_turret1" },
    { 0xCBCBFC97, "script_enable_turret2" },
    { 0xA5C9822E, "script_enable_turret3" },
    { 0xE7BD1E21, "script_enable_turret4" },
    { 0x141E3307, "script_ender" },
    { 0xC440F2AA, "script_engage" },
    { 0x510412F3, "script_engagedelay" },
    { 0xEDDB696E, "script_ent" },
    { 0x3538248B, "script_ent_cleanup" },
    { 0x00E3F4F9, "script_ent_flag_clear" },
    { 0x9167C22E, "script_ent_flag_set" },
    { 0x8EE98814, "script_exploder" },
    { 0x8E05F250, "script_exploder_group" },
    { 0x25B25F18, "script_exploder_radiant" },
    { 0x381566BA, "script_exploder_server" },
    { 0x606EE787, "script_exploders" },
    { 0x631D2964, "script_fade_duration" },
    { 0x31AFEDA1, "script_fallback" },
    { 0x84C1412D, "script_fallback_group" },
    { 0x6CE8DE13, "script_falldirection" },
    { 0x61744129, "script_favoriteenemy" },
    { 0x99A48697, "script_fightdist" },
    { 0x4D0DB49D, "script_firefx" },
    { 0x374C928A, "script_firefxdelay" },
    { 0x373667A2, "script_firefxsound" },
    { 0xC09C1326, "script_firefxtimeout" },
    { 0x200967B5, "script_fireondrones" },
    { 0x0D5AE553, "script_fixednode" },
    { 0xD48C6AB5, "script_flag" },
    { 0xFEBE33BF, "script_flag_clear" },
    { 0xC2D7A491, "script_flag_false" },
    { 0x83FF7020, "script_flag_false_trigger" },
    { 0x62978788, "script_flag_set" },
    { 0xEF42ADB1, "script_flag_set_on_cleared" },
    { 0x39A11FD8, "script_flag_set_on_touching" },
    { 0xDF562910, "script_flag_set_touching" },
    { 0xF8FD6930, "script_flag_true" },
    { 0xF1980FE1, "script_flag_true_trigger" },
    { 0x61F4876B, "script_flag_wait" },
    { 0xC5F88791, "script_flak88" },
    { 0x7D06E924, "script_flakaicount" },
    { 0xD3850EA2, "script_flanker" },
    { 0xAE51B794, "script_flashbangs" },
    { 0x6604B19F, "script_float" },
    { 0x88284F1A, "script_followmax" },
    { 0x4D3EAD04, "script_followmin" },
    { 0x7FEBC1B9, "script_followmode" },
    { 0x813F37E8, "script_force_count" },
    { 0x6C003E31, "script_forcecolor" },
    { 0xAB928682, "script_forcegib" },
    { 0xE4B0837D, "script_forcegoal" },
    { 0xE8BCB276, "script_forcegrenade" },
    { 0xFBC41B7D, "script_forcerambo" },
    { 0x103A9781, "script_forcespawn" },
    { 0x7EA45FEB, "script_forcespawn_always" },
    { 0x96FAD10A, "script_forcespawn_never" },
    { 0xE6E198AA, "script_forcespawn_none" },
    { 0x51B1EE7F, "script_forcespawn_once" },
    { 0xE91A4028, "script_forcespawn_once_only" },
    { 0x8E5E90ED, "script_forceyaw" },
    { 0x76EC4FCA, "script_friendname" },
    { 0xF3026080, "script_fxcommand" },
    { 0xFC5FF01A, "script_fxid" },
    { 0x807E0293, "script_fxstart" },
    { 0x71CE47A1, "script_fxstop" },
    { 0x41D8B98D, "script_gameobjectname" },
    { 0x09CC44D9, "script_gametype_ctf" },
    { 0x9C7D5929, "script_gametype_dm" },
    { 0xFED10831, "script_gametype_hq" },
    { 0xAE786C32, "script_gametype_koth" },
    { 0x05886C75, "script_gametype_sd" },
    { 0xD2013ECD, "script_gametype_tdm" },
    { 0xB3D35556, "script_gatetrigger" },
    { 0x89336713, "script_gen_csvdumpprintln" },
    { 0xA10AA6D4, "script_gen_dump" },
    { 0x03F13B1E, "script_gen_dump2" },
    { 0xD6C8A32E, "script_gen_dump_addline" },
    { 0x4922D9B2, "script_gen_dump_checksaved" },
    { 0x69097D56, "script_gen_dump_preload" },
    { 0x9DD7B006, "script_gen_dump_reasons" },
    { 0xED723493, "script_gen_dumpprintln" },
    { 0x8041FBC2, "script_ghettotag" },
    { 0x73CC909C, "script_goalradius" },
    { 0x571F3418, "script_goalvolume" },
    { 0xF3D7E63B, "script_goalyaw" },
    { 0xCFB78F1E, "script_godmode" },
    { 0x2622527E, "script_grenades" },
    { 0x74E9CDE6, "script_growl" },
    { 0xF0F7794C, "script_guy_1" },
    { 0x62FEE887, "script_guy_2" },
    { 0xFDB12B1C, "script_halfway_dist" },
    { 0xFCD34915, "script_halfway_height" },
    { 0x0C31055D, "script_health" },
    { 0xA8675C26, "script_height" },
    { 0x99956B5F, "script_heli" },
    { 0x665BA85B, "script_hero" },
    { 0xD7037EFB, "script_hidden" },
    { 0xE92C817F, "script_hidingdoor_action" },
    { 0xF08C10C6, "script_hidingdoor_ends_closed" },
    { 0x5E8818D4, "script_hidingdoor_model" },
    { 0x86F81381, "script_hidingdoor_starts_open" },
    { 0x32D094E8, "script_hint" },
    { 0xC89138A8, "script_hoverwait" },
    { 0xECC91FA9, "script_ignore_suppression" },
    { 0x4125B0C2, "script_ignoreall" },
    { 0x9A6E8567, "script_ignoreme" },
    { 0x80795C1B, "script_immunetoflash" },
    { 0x01430971, "script_index" },
    { 0x32036185, "script_index_a" },
    { 0x5805DBEE, "script_index_b" },
    { 0x8202763A, "script_int" },
    { 0x8942A465, "script_intensity_max" },
    { 0x7423FCCB, "script_intensity_min" },
    { 0xDAE5EBE2, "script_keepdriver" },
    { 0xFA67F159, "script_killspawner" },
    { 0x44A72845, "script_killspawner_group" },
    { 0xB2FF4D87, "script_label" },
    { 0x8DF71EEF, "script_landmark" },
    { 0xE4490800, "script_leftarc" },
    { 0x2F01264F, "script_length" },
    { 0x7000A53D, "script_light" },
    { 0x474EAF30, "script_light2_burst_intensity" },
    { 0x29287A81, "script_light2_burst_max" },
    { 0xD6510BBF, "script_light2_burst_min" },
    { 0xC6695C7E, "script_light2_burst_time" },
    { 0x4EAFFF6D, "script_light2_color" },
    { 0x2F22F5F2, "script_light2_delay_max" },
    { 0x44419D8C, "script_light2_delay_min" },
    { 0x390807FD, "script_light2_exponent" },
    { 0x6545E245, "script_light2_fade_duration" },
    { 0x25517F82, "script_light2_fx" },
    { 0x0C1C9864, "script_light2_inner_fov" },
    { 0xEEAB000B, "script_light2_intensity" },
    { 0xE8B9C1CC, "script_light2_intensity_max" },
    { 0x23A363E2, "script_light2_intensity_min" },
    { 0x7463A4DD, "script_light2_outer_fov" },
    { 0xEBAA0F3A, "script_light2_radius" },
    { 0x319E2C45, "script_light2_sound" },
    { 0x5FB8EDFE, "script_light2_targetname" },
    { 0x08B0961C, "script_light2_wait_max" },
    { 0x85C55412, "script_light2_wait_min" },
    { 0x68CA3899, "script_light_burst_max" },
    { 0xC3701727, "script_light_burst_min" },
    { 0x59937BC6, "script_light_burst_time" },
    { 0xA37C274A, "script_light_fx" },
    { 0x76B88150, "script_light_fx_offset" },
    { 0xC3437B6A, "script_light_label" },
    { 0x0BBEE3A7, "script_light_model" },
    { 0x412094DA, "script_light_no_range_check" },
    { 0x13F20851, "script_light_off_model" },
    { 0x0BD84430, "script_light_off_spin_model" },
    { 0xD31ADCDD, "script_light_on_model" },
    { 0x0FE71CB4, "script_light_on_spin_model" },
    { 0x1AE9B22F, "script_light_onetime" },
    { 0xDEFF8DF1, "script_light_rotate_yaw" },
    { 0x5734E70D, "script_light_sound" },
    { 0xEF8CF5A9, "script_light_spin_fx" },
    { 0x9640F849, "script_light_spin_tag" },
    { 0xA08F5614, "script_light_toggle" },
    { 0x53C304C8, "script_light_type" },
    { 0x84526FD4, "script_lights_on" },
    { 0xBC96B49A, "script_linkent" },
    { 0xC628806C, "script_linker_model" },
    { 0x38E27F26, "script_linkname" },
    { 0x09194748, "script_linkto" },
    { 0xED98E663, "script_linktos" },
    { 0xAF5CAC92, "script_location" },
    { 0x27988D25, "script_longdeath" },
    { 0x2E552217, "script_looping" },
    { 0x151DFFA4, "script_magic" },
    { 0xF99E5A52, "script_manualtarget" },
    { 0xBCDBF157, "script_mapsize_08" },
    { 0xC0EE8E92, "script_mapsize_16" },
    { 0xBF5A8F68, "script_mapsize_32" },
    { 0x266606DD, "script_mapsize_64" },
    { 0x52B0D143, "script_max_banzai_distance" },
    { 0xE0E78654, "script_max_fog_opacity" },
    { 0xE5034C07, "script_maxdist" },
    { 0xE4AD1EEF, "script_maxplayers" },
    { 0x3866CCB1, "script_mg42" },
    { 0xCA83D2D0, "script_mg42auto" },
    { 0xB943C6F7, "script_mg_angle" },
    { 0xB7E8D444, "script_mgturretauto" },
    { 0x1CB485A5, "script_mindist" },
    { 0x160BF4AD, "script_minplayers" },
    { 0xC89C320F, "script_minspec_level" },
    { 0xF4F74B07, "script_mixer_event" },
    { 0xF8A8DF68, "script_mixer_ltr_ramp" },
    { 0x8FFF3160, "script_mixer_robot_max" },
    { 0x3D27C29E, "script_mixer_robot_min" },
    { 0xEBBCF2E8, "script_mixer_rtl_ramp" },
    { 0xAEDECC79, "script_mod" },
    { 0x5D71A7EE, "script_model" },
    { 0x837E7BDD, "script_model_anims" },
    { 0xA340416F, "script_model_blink_on" },
    { 0x3695D28B, "script_model_link_ent" },
    { 0xC88AD9A0, "script_model_police_car" },
    { 0xDA48B622, "script_modelnames" },
    { 0xC2AF2211, "script_models" },
    { 0xAF5A92A4, "script_mortar_team_size" },
    { 0x8BF7FE1D, "script_mortargroup" },
    { 0x80022528, "script_mortargroup_domortar" },
    { 0x24CA7D8B, "script_mortargroup_mortar_group" },
    { 0xB826CF8D, "script_mortargroup_mortarzone" },
    { 0x0D6E520F, "script_mortargroup_style" },
    { 0x3E88BC3F, "script_move_dist" },
    { 0xC65483E2, "script_move_sin_index" },
    { 0x471EA88B, "script_move_target_node" },
    { 0xA054BB50, "script_move_update" },
    { 0x68D729F4, "script_moveoverride" },
    { 0xD8729916, "script_mover" },
    { 0xD48673E9, "script_namenumber" },
    { 0x9187E0D4, "script_next_spawn_manager" },
    { 0x1B15C72F, "script_no_respawn" },
    { 0x5DD011CB, "script_no_threat_on_spawn" },
    { 0xEB2E372C, "script_no_threat_update_on_first_frame" },
    { 0xFA283C66, "script_no_threat_update_on_fisrt_frame" },
    { 0xFEAB6E52, "script_nocorpse" },
    { 0xC9AB60B7, "script_node" },
    { 0xD5DF349B, "script_node_pausetime" },
    { 0xD466DB0D, "script_nodeathmessage" },
    { 0xA7051B2A, "script_nodestate" },
    { 0x09954AF1, "script_nodropsecondaryweapon" },
    { 0x385B9F0A, "script_nodropsidearm" },
    { 0x587133ED, "script_nodropweapon" },
    { 0x6B1B9B82, "script_noenemyinfo" },
    { 0x6F9E0B5C, "script_nofriendlywave" },
    { 0x49C422B0, "script_nohealth" },
    { 0xDDCFE133, "script_nomantle" },
    { 0xE148A662, "script_nomg" },
    { 0x9EE19502, "script_nonmovingvehicle" },
    { 0xDB7DE487, "script_norambo" },
    { 0x7D779144, "script_notetworthy" },
    { 0x45AEAEB6, "script_noteworhty" },
    { 0x271B8468, "script_noteworhy" },
    { 0x20B4A725, "script_noteworth" },
    { 0xCAAE374E, "script_noteworthy" },
    { 0xF1C52748, "script_noteworthy2" },
    { 0xC103125C, "script_noteworthy_value" },
    { 0x9A8A862C, "script_noteworty" },
    { 0x835E532E, "script_notewothy" },
    { 0x066715B4, "script_notify" },
    { 0x61DC9F4C, "script_notify_str" },
    { 0x7517D80D, "script_notify_trigger" },
    { 0xAFC6BE09, "script_num" },
    { 0x50E1F8F8, "script_numbombs" },
    { 0xB609B0B9, "script_numplayers" },
    { 0xFF1F6868, "script_objective" },
    { 0xCEFCEE5D, "script_objective_active" },
    { 0xDB99EBE8, "script_objective_inactive" },
    { 0x4498AAB1, "script_offtime" },
    { 0x0BD16AC6, "script_on_vehicle_turret" },
    { 0x1F5254DF, "script_onlyidle" },
    { 0x5ADE995B, "script_org" },
    { 0x49A1849D, "script_origin" },
    { 0xB551E1DC, "script_origins" },
    { 0xC294C7FC, "script_owner" },
    { 0x27699CDC, "script_pacifist" },
    { 0x80E0A970, "script_parameter" },
    { 0xA33B36DB, "script_parameters" },
    { 0x8B1CAB26, "script_paramters" },
    { 0x833073CC, "script_parms" },
    { 0xF1A012CD, "script_patrol_walk_anim" },
    { 0x042C70F2, "script_patroller" },
    { 0xE01DFFEE, "script_percent" },
    { 0x2E596046, "script_physics" },
    { 0x7F3ABF67, "script_physicsjolt" },
    { 0x13719141, "script_pilottalk" },
    { 0xAA2B0BF8, "script_play_multiple" },
    { 0xA8F3A02B, "script_player_chance" },
    { 0x243E334D, "script_player_min" },
    { 0xCC3505F3, "script_playerconeradius" },
    { 0xE6A769C3, "script_playerlink_org" },
    { 0x13CE38D8, "script_playerseek" },
    { 0x82EAFDBF, "script_playfx" },
    { 0x133FADF0, "script_playfxontag" },
    { 0x741CBF33, "script_prefab_exploder" },
    { 0xC8C5D62F, "script_presound" },
    { 0x5EB55FB9, "script_print_fx" },
    { 0x2B941E09, "script_radius" },
    { 0xF9DE551F, "script_random_killspawner" },
    { 0xF1D624EB, "script_randomspawn" },
    { 0x6428F243, "script_recordent" },
    { 0x2452285E, "script_repeat" },
    { 0x9181FC65, "script_requires_player" },
    { 0xB24F259E, "script_resume_speed" },
    { 0x65292AD7, "script_resumespeed" },
    { 0x180D66E1, "script_rightarc" },
    { 0xA1562D9C, "script_rumble" },
    { 0xA014D977, "script_run_scene" },
    { 0xB9D825B0, "script_rusher" },
    { 0x218A8D3A, "script_savetrigger_timer" },
    { 0xCFC613CF, "script_score" },
    { 0x4374B743, "script_score_curve" },
    { 0x095F9421, "script_scripted" },
    { 0xE3F6383E, "script_seekgoal" },
    { 0x29B74A30, "script_selfisattacker" },
    { 0x9B72833D, "script_set_cclass" },
    { 0x20C01612, "script_shape" },
    { 0xB9B81FFA, "script_shootai" },
    { 0x5CC32888, "script_shooting" },
    { 0x2E522FFB, "script_shoottanks" },
    { 0x35C1148C, "script_shotcount" },
    { 0x05F11911, "script_sightrange" },
    { 0xE42A9C03, "script_sirens_on" },
    { 0xBCF80582, "script_skilloverride" },
    { 0x0D47F13C, "script_sound" },
    { 0x850B2330, "script_soundalias" },
    { 0xCDAA9751, "script_spawn_here" },
    { 0x81EC425A, "script_spawner_targets" },
    { 0x5C223930, "script_spawner_targets_nodes" },
    { 0x7CC697D0, "script_special" },
    { 0x11D7DF94, "script_specialops" },
    { 0xEA60E3F6, "script_spiderhole" },
    { 0xF3ABC58A, "script_spiderhole_anim" },
    { 0x8E46D305, "script_spiderhole_charge" },
    { 0x16782C0F, "script_sprint" },
    { 0x20BB15E3, "script_squad" },
    { 0x032AA11E, "script_squadname" },
    { 0x0D2FD07F, "script_stance" },
    { 0xC129EA4D, "script_start" },
    { 0x3EAEABF0, "script_start_dist" },
    { 0xBFC66181, "script_startinghealth" },
    { 0x219C140A, "script_startingposition" },
    { 0x52F3956E, "script_startnotify" },
    { 0x70182C90, "script_startstate" },
    { 0x0A43EA74, "script_stealth" },
    { 0x66A618EE, "script_stealth_dontseek" },
    { 0x2A589309, "script_stop_exploder" },
    { 0x85279041, "script_stop_exploder_radiant" },
    { 0x8347BF17, "script_stopnode" },
    { 0xDB7BB468, "script_string" },
    { 0xE4431772, "script_string_name" },
    { 0xC250F27D, "script_string_trigger_name" },
    { 0xBCAEE103, "script_strings" },
    { 0x669AA9A0, "script_struct" },
    { 0xB6BA354B, "script_structs" },
    { 0xF5114066, "script_stuct" },
    { 0xD0B85AE4, "script_suffix" },
    { 0xC913C757, "script_sun_color" },
    { 0xFCCA5C8D, "script_sun_direction" },
    { 0x256DF68B, "script_sun_start_ang" },
    { 0x4297D58B, "script_sun_stop_ang" },
    { 0xAEB20031, "script_sunsample" },
    { 0x80E28A67, "script_sunsample_time" },
    { 0xE84E18A9, "script_tag" },
    { 0xC0650EC0, "script_tankgroup" },
    { 0xB8C6DEC1, "script_targetoffset" },
    { 0x4E9DE3A6, "script_targetoffset_z" },
    { 0xC8B0FB73, "script_targets" },
    { 0x53E817B8, "script_targetset" },
    { 0xDA0607A0, "script_targettype" },
    { 0xA3B61124, "script_team" },
    { 0x218D5549, "script_threatbiasgroup" },
    { 0x91224CA8, "script_threshold" },
    { 0x2151D6C6, "script_timer" },
    { 0x0B8E8CC9, "script_toggletakedamage" },
    { 0x9149575B, "script_touched" },
    { 0x792B512A, "script_trace" },
    { 0x20602C5F, "script_trailfx" },
    { 0x892E1B48, "script_trailfxdelay" },
    { 0xAB43823C, "script_trailfxsound" },
    { 0x9A1101A9, "script_trailfxtag" },
    { 0xD588BF62, "script_transition_time" },
    { 0x8BE655F9, "script_trigger" },
    { 0x090B55D9, "script_trigger2" },
    { 0x7FA76DE5, "script_trigger_allplayers" },
    { 0x9D6203A5, "script_trigger_group" },
    { 0xE7D06426, "script_trigger_spawnflags" },
    { 0xEA8B0B3A, "script_triggered_playerseek" },
    { 0xAD02EF27, "script_turningdir" },
    { 0xD66F2978, "script_turnrate" },
    { 0x592AA955, "script_turret" },
    { 0x585CE47C, "script_turret_ambush" },
    { 0xA5FC73EB, "script_turret_reuse_max" },
    { 0x7B6A68A5, "script_turret_reuse_min" },
    { 0x62F0D419, "script_turret_share" },
    { 0xFF128831, "script_turretmg" },
    { 0x5FA98D68, "script_unitrigger_type" },
    { 0x843A4DD6, "script_unload" },
    { 0x20DE56DA, "script_unload_group" },
    { 0x6F6C14DF, "script_unloaddelay" },
    { 0x3C5FDB8B, "script_unloadmgguy" },
    { 0x2B013E02, "script_usemg42" },
    { 0x70394B3E, "script_value" },
    { 0xA74427A6, "script_variables" },
    { 0x0D3A5855, "script_vars" },
    { 0xBAD30B66, "script_vector" },
    { 0x2066023D, "script_vehicle" },
    { 0xEA59E0E1, "script_vehicle_lights_off" },
    { 0xB856FB55, "script_vehicle_lights_on" },
    { 0x47F431CA, "script_vehicle_selfremove" },
    { 0xDD8AD30C, "script_vehicleaianim" },
    { 0x5D88B7AA, "script_vehicleattackgroup" },
    { 0xB34A9879, "script_vehicleattackgroupwait" },
    { 0x44294E7D, "script_vehicleavoidance" },
    { 0x97952882, "script_vehicledetour" },
    { 0xC29CAF6B, "script_vehicledetourgroup" },
    { 0x7A8BCCE3, "script_vehiclegroupdelete" },
    { 0xF7A95942, "script_vehiclenodegroup" },
    { 0xE4DAA8A7, "script_vehicleride" },
    { 0xEAC7D5FC, "script_vehicles" },
    { 0x56321B67, "script_vehiclespawngroup" },
    { 0x8284273C, "script_vehiclestartmove" },
    { 0x4A2842D8, "script_vehicletriggergroup" },
    { 0xACE82C7E, "script_vehiclewalk" },
    { 0x6FBA26CB, "script_vision" },
    { 0x7516AE19, "script_vision_time" },
    { 0x0A0EA05D, "script_volume" },
    { 0x4F893E41, "script_volumedown" },
    { 0x9487FAE5, "script_volumeramp" },
    { 0x9E11BC6E, "script_volumeup" },
    { 0x7D402220, "script_wait" },
    { 0x49E9BFC4, "script_wait_add" },
    { 0xBFEF2183, "script_wait_max" },
    { 0x85057F6D, "script_wait_min" },
    { 0x070B143D, "script_waittill" },
    { 0x17DF8A70, "script_walk" },
    { 0xF6AE00F7, "script_wheeldirection" },
    { 0xDA9D6B0D, "script_width" },
    { 0x1E3CBDC2, "script_wingman" },
    { 0x9891BA79, "script_yawspeed" },
    { 0x3732A9B0, "scriptable" },
    { 0x0863AD31, "scriptbrake" },
    { 0x53999F1F, "scriptbrushmodel" },
    { 0xF4A44050, "scriptbundle" },
    { 0xD33C9734, "scriptbundle_shared" },
    { 0x1157A889, "scriptbundlename" },
    { 0x3F831F3B, "scriptbundles" },
    { 0x279DD9E7, "scriptbundlesettings" },
    { 0x444CA6A8, "scriptcall" },
    { 0xA5FBAB0C, "scriptcallbackonfootstepevent" },
    { 0xFED97043, "scriptcalls" },
    { 0x38C0D610, "scriptchange" },
    { 0xECA16E40, "scriptdata" },
    { 0x019D26A0, "scriptdebugmenu" },
    { 0xBDEAFDC7, "scriptdestroyhq" },
    { 0x10B436DE, "scriptdetour_persist" },
    { 0x35EA2103, "scriptdevelop" },
    { 0x2DDB30C1, "scriptdocbegin" },
    { 0x4F08CF19, "scriptdocend" },
    { 0x6CFF281B, "scripted" },
    { 0xEB014C91, "scripted_anim" },
    { 0x307736E0, "scripted_animation" },
    { 0x8224BEA1, "scripted_animation_counter" },
    { 0x868CB33B, "scripted_animation_slot" },
    { 0x48623D95, "scripted_animdone" },
    { 0x54CEB961, "scripted_array_spawn" },
    { 0x63CC402C, "scripted_behavior" },
    { 0x263AB7EB, "scripted_damage_sources_only" },
    { 0x8C6EF1C0, "scripted_dialogue" },
    { 0xA722982E, "scripted_done" },
    { 0x7901B73E, "scripted_exit" },
    { 0xD6085CA5, "scripted_flak_and_shake_above_pby" },
    { 0xFB8DA37D, "scripted_grenade_throw" },
    { 0x77D342FD, "scripted_intro_fx" },
    { 0xA1B94D6A, "scripted_kill_spawners" },
    { 0x825E9B73, "scripted_lightning_flash" },
    { 0xBBCFEBF0, "scripted_line_delay" },
    { 0xA561C288, "scripted_meatshield" },
    { 0x4648B80D, "scripted_melee_weapon" },
    { 0x8EF57528, "scripted_mg42gunner_pain" },
    { 0xF50AD8C4, "scripted_mger_catch_alert" },
    { 0x55C89507, "scripted_mger_getawaytime" },
    { 0x11694742, "scripted_mger_kill" },
    { 0x3CEC08DA, "scripted_mger_think" },
    { 0x3CF90B0D, "scripted_molotov_throw" },
    { 0x73754F17, "scripted_molotov_throw_triggered" },
    { 0x1E4B5E74, "scripted_notifyname" },
    { 0x4A4196A3, "scripted_player_shot_death" },
    { 0x18E5070B, "scripted_sightconetrace" },
    { 0xC62F651B, "scripted_spawn" },
    { 0xC3C8C4E3, "scripted_spawn2" },
    { 0xC277A660, "scripted_spawn_go" },
    { 0x327B12CB, "scripted_stealth_break" },
    { 0x9211D309, "scripted_target" },
    { 0xF40FB339, "scripted_team" },
    { 0x16C41812, "scripted_thread" },
    { 0x8C7D488F, "scripted_trigs" },
    { 0x340CAE9F, "scripted_turret_switch" },
    { 0x06E71DCE, "scripted_weaponswitch" },
    { 0x9AD21F0C, "scriptedanim" },
    { 0xA0C2B2A5, "scriptedanimationindex" },
    { 0x18002998, "scriptedanimationtime" },
    { 0x9A9789CC, "scriptedanimdone" },
    { 0xD2D3A133, "scripteddeathtimes" },
    { 0x74835ED5, "scriptedenemy" },
    { 0x1B17D294, "scriptedfaceindex" },
    { 0x8563260B, "scriptedfacial" },
    { 0x520470FC, "scriptedfacialanim" },
    { 0x1F8C8210, "scriptedfacialsound" },
    { 0x2CEF3BDD, "scriptedfx" },
    { 0xA0AC38B4, "scriptedsoundindex" },
    { 0x2ADB8A8F, "scriptedweapon" },
    { 0xD4E5BB5C, "scriptenemy" },
    { 0x192BC37D, "scripter" },
    { 0xE091354B, "scripter_microtask" },
    { 0x45736EBC, "scripter_mod" },
    { 0xCFD21CED, "scripter_subtask" },
    { 0xFB78F33F, "scripter_task" },
    { 0x452A2143, "scripterd" },
    { 0xCB54423C, "scripters" },
    { 0x03910F5A, "scriptfunc" },
    { 0xD2547A80, "scriptfunction" },
    { 0x4C1CD8A6, "scriptgen" },
    { 0xF4DFC568, "scriptgendump" },
    { 0x418B54D5, "scriptgroup_initscenes" },
    { 0x19C21B2D, "scriptgroup_playscenes" },
    { 0x958F1367, "scriptgroup_stopscenes" },
    { 0xF1FCC926, "scriptids" },
    { 0x5BC81D50, "scripting" },
    { 0xAED735D2, "scriptlabel" },
    { 0x8971E30C, "scriptmenus" },
    { 0x270EA99F, "scriptmodel" },
    { 0xB2FA68E4, "scriptmodel_dump" },
    { 0xE0EFD926, "scriptmodels" },
    { 0x95C88ADB, "scriptmodelspawned" },
    { 0x73563F98, "scriptmodelsuseanimtree" },
    { 0xBE06D66F, "scriptmover" },
    { 0xA64A08B8, "scriptmover_charring" },
    { 0x7528A5A1, "scriptmover_flag0_handler" },
    { 0xC100AEF8, "scriptmover_flag1_handler" },
    { 0x74458ED7, "scriptmover_flag2_handler" },
    { 0x3525B92E, "scriptmover_flag3_handler" },
    { 0x28E8C4FD, "scriptmover_flag4_handler" },
    { 0xDF789223, "scriptmover_flag6_handler" },
    { 0x981E5ABA, "scriptmover_flag7_handler" },
    { 0x75ADDC29, "scriptmover_flag8_handler" },
    { 0x86F48C00, "scriptmover_flag9_handler" },
    { 0x1D0C40E0, "scriptmover_flag_charring_handler" },
    { 0x38E63F40, "scriptmover_flag_kniferang" },
    { 0x3772E522, "scriptmover_flag_riotshield" },
    { 0xEB6BF172, "scriptmover_gassed_handler" },
    { 0x618A0F8B, "scriptmover_heli_crash_sound_handler" },
    { 0x56701FC5, "scriptmovercompassicons" },
    { 0x19EDB1B6, "scriptmovers" },
    { 0xF895EFE1, "scriptname" },
    { 0x6753E198, "scriptneedstagaim" },
    { 0xF70B1852, "scriptonly_render_skipto" },
    { 0xC7C2780E, "scriptorigin" },
    { 0x70C8ACC8, "scriptoriginpoolthread" },
    { 0x66A541D8, "scriptoverride" },
    { 0xE07593EF, "scriptprintln" },
    { 0x8246BDC2, "scriptrequirestosprintcondition" },
    { 0xC46B4823, "scripts" },
    { 0x105D3067, "scriptsquadgroup" },
    { 0x3C41A5BD, "scriptstartragdoll" },
    { 0xC3AE43FF, "scriptstarttime" },
    { 0x6694FEC3, "scriptstruct" },
    { 0xA864BE3E, "scriptstruct_debug_render" },
    { 0xA52F8EFA, "scriptvars" },
    { 0xAA464DF5, "scriptvector" },
    { 0x61D45F3F, "scriptvector0" },
    { 0x3BD1E4D6, "scriptvector1" },
    { 0x15CF6A6D, "scriptvector2" },
    { 0xEFCCF004, "scriptvector3" },
    { 0x57C30660, "scriptvector7" },
    { 0xFD67E920, "scriptvehicletype" },
    { 0x69BF2C81, "scriptworthy" },
    { 0x68A42800, "scritp" },
    { 0x5A4EA1D5, "scritper" },
    { 0x2A4492E4, "scritper_mod" },
    { 0xE8215FCA, "scroll" },
    { 0xEE52EFA9, "scroll_dist" },
    { 0xC4916D91, "scroll_list" },
    { 0x1ECCC5FA, "scroll_speed" },
    { 0x9A73F086, "scrollable" },
    { 0xFD21C126, "scrolling" },
    { 0xB05FAA05, "scrolls" },
    { 0x434E28AC, "scronce" },
    { 0x4EB0547D, "scrorigin" },
    { 0x4449B8E2, "scrub" },
    { 0xE354DB8A, "scrub_guy" },
    { 0x39A2FE71, "scrubber" },
    { 0x583867E5, "scruct" },
    { 0x532D9A95, "scum" },
    { 0xE7DC9AE0, "scurrentvehicleposition" },
    { 0xDF2E70E1, "scuttle" },
    { 0x0C5B8B9C, "scythemodel" },
    { 0xBAF39230, "sd" },
    { 0xFBBC66B0, "sd_endgame" },
    { 0x71BF3665, "sd_endgamewithkillcam" },
    { 0x3986AC4A, "sd_get_bomb_goal" },
    { 0xCBFEA3DC, "sd_get_closest_bomb" },
    { 0x84827099, "sd_get_planted_zone" },
    { 0x534FE282, "sd_get_time_frac" },
    { 0xAD4C316D, "sd_getteamkillpenalty" },
    { 0xCA1EC9F8, "sd_getteamkillscore" },
    { 0xDE2EBB90, "sd_iskillboosting" },
    { 0xA142D5E5, "sd_playerspawnedcb" },
    { 0x7899D6C8, "sd_rules" },
    { 0xA8BA4268, "sd_struct" },
    { 0xBC96E073, "sd_wins_index" },
    { 0x1C89A71F, "sdamage" },
    { 0x0022E45D, "sdamageorigin" },
    { 0x44EE1D60, "sdbomb" },
    { 0x1F57A5F7, "sdbombmodel" },
    { 0x3064782B, "sdc" },
    { 0x5666F294, "sdd" },
    { 0x7C696CFD, "sde" },
    { 0x49D87BE2, "sdfs1" },
    { 0x58FC2A96, "sdialogue" },
    { 0x60784B73, "sdk" },
    { 0x1861D0C8, "sdk_1_death" },
    { 0xD8D75DD7, "sdk_2_death" },
    { 0x16FC0F7F, "sdk_awaken" },
    { 0x123FA656, "sdk_blowwup" },
    { 0xC90B957E, "sdk_fire_at_player" },
    { 0xAE93BBC7, "sdk_luv_you" },
    { 0x2162FC05, "sdk_movearound_thread" },
    { 0xD7509E9E, "sdk_passed" },
    { 0x29EEF657, "sdk_retaliate" },
    { 0xF49D61C6, "sdk_rolls_up" },
    { 0x137E52B9, "sdk_shoot_at_wasp_1" },
    { 0x3980CD22, "sdk_shoot_at_wasp_2" },
    { 0xB019CB74, "sdk_stop_n_own" },
    { 0xD341FBCC, "sdk_strat_1" },
    { 0x45496B07, "sdk_strat_2" },
    { 0x8F2F295E, "sdk_tries_to_fight_back" },
    { 0x00617ED7, "sdkfz" },
    { 0xD514B12B, "sdknode" },
    { 0x6A1B570D, "sdlbg" },
    { 0xAC7D4045, "sdm" },
    { 0xA4E32328, "sds1" },
    { 0x3A4A1F82, "sdteps" },
    { 0x5606795E, "sdummytargetname" },
    { 0xE0F60C99, "se" },
    { 0x56A2A792, "sea" },
    { 0x072898F2, "sea_animate" },
    { 0x92F3DFB6, "sea_black" },
    { 0x9A1106AE, "sea_bob" },
    { 0x001CC60A, "sea_bob_reset" },
    { 0x1C32C083, "sea_bob_reset_loop" },
    { 0xD2866BC4, "sea_closestwavearray" },
    { 0xC234A909, "sea_closestwavelogic" },
    { 0x683B2C01, "sea_cowbell" },
    { 0x73BC5006, "sea_foam" },
    { 0x6804A9C1, "sea_level" },
    { 0xF84BEC27, "sea_level_struct" },
    { 0x37C16E2A, "sea_litebob" },
    { 0x76A0F80D, "sea_logic" },
    { 0xAFE613C8, "sea_model" },
    { 0xD3381461, "sea_objectbob" },
    { 0x708840FD, "sea_objectbob_findparent" },
    { 0xB789B3AB, "sea_objectbob_follow" },
    { 0xFC97A296, "sea_objectbob_logic" },
    { 0xBE23116C, "sea_objectbob_precalc" },
    { 0x107B9E0B, "sea_viewbob" },
    { 0x3F806AC1, "sea_waves" },
    { 0x23AF6856, "sea_waves_fx" },
    { 0x9743F120, "sea_waves_fx2" },
    { 0xA0FE3B8B, "sea_waves_setup" },
    { 0x2ACB5569, "seaent" },
    { 0x84759E26, "seagull" },
    { 0x06E351FF, "seagull_ang_offset" },
    { 0xCF6116D9, "seagull_circle_01" },
    { 0xF5639142, "seagull_circle_02" },
    { 0x1B660BAB, "seagull_circle_03" },
    { 0x1A5FF31F, "seagull_do_idle_twitch" },
    { 0x6EC24A20, "seagull_fall_01" },
    { 0x5DD49895, "seagull_fall_01_start" },
    { 0xE0C9B95B, "seagull_fall_02" },
    { 0xE3FC179E, "seagull_fall_02_start" },
    { 0xBAC73EF2, "seagull_fall_03" },
    { 0x2CCEAE2D, "seagull_fall_04" },
    { 0x53C18614, "seagull_fall_04_start" },
    { 0x06CC33C4, "seagull_fall_05" },
    { 0x77B3DFCF, "seagull_fly_anims" },
    { 0xD04CD8FA, "seagull_hit_ground" },
    { 0x5DE05F23, "seagull_init" },
    { 0x7D9D9E0F, "seagull_models" },
    { 0xC1F715A5, "seagull_node" },
    { 0x8719763D, "seagull_structs" },
    { 0x7F1E8BCF, "seagull_takeoff_and_fly" },
    { 0x23B9706B, "seagull_width" },
    { 0x263B0959, "seagulls" },
    { 0x5EABD50D, "seaknight" },
    { 0x4FA58F9E, "seaknight1" },
    { 0x05A99613, "seaknight_airlift" },
    { 0xD8AAD940, "seaknight_almost_land_location" },
    { 0x7240A246, "seaknight_anims" },
    { 0x0CCC785E, "seaknight_badplace" },
    { 0x7A0A518E, "seaknight_close_doors" },
    { 0x45296614, "seaknight_collmap" },
    { 0x4C530697, "seaknight_crewchief_think" },
    { 0x98C81923, "seaknight_death_think" },
    { 0x1F6CDF2B, "seaknight_death_trigger" },
    { 0x6D0520C9, "seaknight_defender" },
    { 0xF8685E0C, "seaknight_departure_sequence" },
    { 0xF903DE30, "seaknight_dialog" },
    { 0x5DD47943, "seaknight_door_open_sound" },
    { 0xE77B72AE, "seaknight_doors_open" },
    { 0x9E46ED77, "seaknight_entrance_trigger" },
    { 0x81434E29, "seaknight_fire_turret" },
    { 0x830DD7F6, "seaknight_flag" },
    { 0xECB679D3, "seaknight_flies_in" },
    { 0x0C504E36, "seaknight_griggs_speech" },
    { 0xC6A1165F, "seaknight_land_location" },
    { 0x8884CF6F, "seaknight_leaves_prematurely" },
    { 0xE0789A0D, "seaknight_leaving_warning" },
    { 0x9A71C2F9, "seaknight_music" },
    { 0xF4D7A3B9, "seaknight_name" },
    { 0x48588664, "seaknight_node" },
    { 0xF8F9E57A, "seaknight_open_doors" },
    { 0x9463F7E5, "seaknight_path" },
    { 0x4E7E1A6F, "seaknight_player" },
    { 0x7961065A, "seaknight_player_dismount_gun" },
    { 0x97CC0040, "seaknight_player_monitor" },
    { 0x12D3A3AE, "seaknight_player_mount_gun" },
    { 0x3D1176D6, "seaknight_player_think" },
    { 0xD0A631FD, "seaknight_player_triggers" },
    { 0xB6402098, "seaknight_playlightfx" },
    { 0x828C06B0, "seaknight_riders_erase" },
    { 0xC63D53E6, "seaknight_sas_load" },
    { 0xC6060E3A, "seaknight_smoketown_think" },
    { 0xD0A018FD, "seaknight_sound" },
    { 0x596774BD, "seaknight_spawn" },
    { 0xC8504853, "seaknight_speed_up" },
    { 0xB2FE6992, "seaknight_turret_anim" },
    { 0x8A28EFBF, "seaknight_turret_anim_init" },
    { 0x7D4D8FD1, "seaknight_turret_test" },
    { 0xEEE971DB, "seaknight_turret_think" },
    { 0xFEE85946, "seaknight_wingman_think" },
    { 0x7378AB66, "seaknightfakeramp" },
    { 0xE47995CF, "seaknightrepulsor" },
    { 0xC0C5D2AE, "seaknightriders" },
    { 0xEA63414F, "seaknightriders_standinplace" },
    { 0xF1065960, "seaknights_squadron" },
    { 0x07A511EA, "seaknights_squadron_path" },
    { 0x4B29CD1A, "seal" },
    { 0xB44D029A, "seal4" },
    { 0x9F425B58, "seal_breach_door_open" },
    { 0xECFC8166, "seal_breaches" },
    { 0x864CEBAE, "seal_group_1" },
    { 0x604A7145, "seal_group_2" },
    { 0xEE94F761, "seal_hangar_entry" },
    { 0xA5D44D83, "seal_names" },
    { 0x0D9F5402, "seal_overwatch_complete" },
    { 0x580FDF9E, "seal_ruins" },
    { 0xA941F7BA, "seal_saved" },
    { 0x1BC5F876, "seal_shoot_learjet" },
    { 0xFB083166, "seal_standoff" },
    { 0x2DF46FAD, "sealed" },
    { 0x8735B056, "sealing" },
    { 0xA6F30C15, "seals" },
    { 0xF907DCEA, "seals_destroy_learjet" },
    { 0x56E02323, "seals_storm_hangar" },
    { 0x712C4783, "seam" },
    { 0x06977A37, "seam_debris" },
    { 0x83AD3832, "seam_list" },
    { 0x1E97347C, "seamless" },
    { 0x13460E79, "seamlessly" },
    { 0xB14019F2, "seams" },
    { 0xFF24D848, "sean" },
    { 0x5E06A236, "seanode" },
    { 0x8D9FB7AD, "search" },
    { 0x6A78683F, "search_depth" },
    { 0x308144DC, "search_distance_sq" },
    { 0x2A571470, "search_done" },
    { 0x68F23C26, "search_for_woods" },
    { 0xFE7B759C, "search_light" },
    { 0xD6CB2F3A, "search_loop" },
    { 0xDAED304D, "search_nodes_array" },
    { 0x120974C0, "search_player_for_satchel" },
    { 0x4BF92472, "search_radius" },
    { 0xC8FC5D0B, "search_target_node_again" },
    { 0xFE9126B5, "searchanimationmap" },
    { 0x3D6E01D6, "searchcenter" },
    { 0x6EFEFC23, "searchcounter" },
    { 0x708C1932, "searchdotprodminimums" },
    { 0x1BFF145A, "searched" },
    { 0xC82BAFBC, "searcher" },
    { 0xEE2E2A25, "searches" },
    { 0xC22FD43B, "searching" },
    { 0xAF7473BB, "searchlight" },
    { 0xF6386332, "searchlight_target_death" },
    { 0xB37E251D, "searchlight_turret_index" },
    { 0x7C642DED, "searchlight_turret_tag" },
    { 0x757C505A, "searchlights" },
    { 0x9876B783, "searchorigin" },
    { 0xA3E4A075, "searchpoint" },
    { 0x7F5FB107, "searchradius" },
    { 0x636EF2FE, "season" },
    { 0xD552E3CA, "seasonvetchallengearraycount" },
    { 0x7B3DA062, "seat" },
    { 0xA6CCAA06, "seat_available" },
    { 0x2D0AF080, "seat_hud" },
    { 0x4C6DD6F3, "seat_index" },
    { 0xAA8F58EF, "seat_locked" },
    { 0x79C18DEB, "seat_num" },
    { 0x54595B35, "seat_open" },
    { 0xA07AF841, "seat_pos" },
    { 0xA5A5ED58, "seat_position" },
    { 0x755F3AE5, "seat_position_to_index" },
    { 0x059BF41B, "seat_tag" },
    { 0xEFF10144, "seat_wanted" },
    { 0xF5A99575, "seated" },
    { 0x6BF94056, "seatgetweapon" },
    { 0xEBBD0D4E, "seatindex" },
    { 0xB736BD4E, "seating" },
    { 0x1D8A0C2D, "seats" },
    { 0x6B259E72, "seatstaken" },
    { 0x0A9DB2C0, "sec" },
    { 0xBD166F19, "sec3tion" },
    { 0x21185E76, "sec_asd_alert" },
    { 0x0C099D15, "sec_chatter_dialog" },
    { 0x7C5E64D9, "sec_evacuate" },
    { 0xD0D22828, "sec_explosion" },
    { 0xE2D82D82, "sec_gate_left" },
    { 0x2E5CDF46, "sec_gate_left_anim" },
    { 0x88258F8E, "sec_gate_left_player" },
    { 0x711F8232, "sec_gate_left_player_anim" },
    { 0x87833AF1, "sec_gate_right" },
    { 0xCFC37E63, "sec_gate_right_anim" },
    { 0x06F9DF23, "sec_gate_right_player" },
    { 0x3F120309, "sec_gate_right_player_anim" },
    { 0xFC84ED1E, "sec_hand_model" },
    { 0xC9304451, "sec_mall_explosion" },
    { 0x1F444A09, "sec_rappeling" },
    { 0xE6A44121, "sec_rocket_launchers" },
    { 0x9F3004C6, "sec_spit_and_drool" },
    { 0x4B50BE3C, "sec_to_wait" },
    { 0xDF121555, "secdef" },
    { 0x2332E956, "secene" },
    { 0x87F38ADF, "secguard" },
    { 0x5FBF1574, "secguard_gun" },
    { 0x65E39952, "secion" },
    { 0xF9629188, "seciton" },
    { 0x71553355, "second" },
    { 0xD431984B, "second_88_in_sights" },
    { 0xEC77171E, "second_88_obj" },
    { 0x415ACED3, "second_apartment_line" },
    { 0x3A02E3B4, "second_arty" },
    { 0x7EB4416A, "second_backup_truck" },
    { 0xEA368E61, "second_closest" },
    { 0x33866564, "second_closest_dist" },
    { 0x4ED184B9, "second_cover" },
    { 0x41132AE6, "second_cover_patrol" },
    { 0x31EA6464, "second_cover_reznov" },
    { 0x543D32AA, "second_cover_vignette" },
    { 0x7D932728, "second_cut" },
    { 0x111EA578, "second_door" },
    { 0xCEB98CD8, "second_endon" },
    { 0xE7441EC4, "second_endon_notify" },
    { 0x284ABCFB, "second_enemyattack_backupguy1" },
    { 0xB6434DC0, "second_enemyattack_backupguy2" },
    { 0x970D18EB, "second_enemyattack_thread" },
    { 0x8A63EFA6, "second_explosion_origin" },
    { 0x26D869D6, "second_explosive_nag" },
    { 0x745F8F70, "second_fake_f35" },
    { 0x71343AD3, "second_flashback" },
    { 0xF909EDF6, "second_floor_door_breach_guys" },
    { 0x1B2C780D, "second_floor_door_breach_setup" },
    { 0xC40FF796, "second_floor_door_breach_trigger" },
    { 0x8F75A21A, "second_floor_kill_trig" },
    { 0x0C93FF12, "second_floor_lab_main" },
    { 0xDB19FB99, "second_floor_laser_light_show" },
    { 0x01513CF8, "second_floor_obj" },
    { 0x9801C078, "second_floor_threads" },
    { 0xB94F8321, "second_glide_time" },
    { 0xF73AC271, "second_goal" },
    { 0x48E85E6B, "second_gunner_reply_intro" },
    { 0x215E2739, "second_guy" },
    { 0x3AC57DC1, "second_guy_1_sync" },
    { 0x26871530, "second_guy_2_sync" },
    { 0xEF45DD70, "second_guys" },
    { 0xCCB9CD3A, "second_half_compound_ai" },
    { 0x27375BAB, "second_hand" },
    { 0x95C67712, "second_hand_angles" },
    { 0x0C6ED5B9, "second_hand_array" },
    { 0x71124924, "second_highest" },
    { 0xF824D823, "second_hundreths_threshold" },
    { 0x46797BFF, "second_id" },
    { 0x3410F9D4, "second_jeep" },
    { 0xC557B493, "second_ledge" },
    { 0x7AB3D229, "second_limo_sighting" },
    { 0xE0D7AE4D, "second_limp_point" },
    { 0x985B5D1C, "second_location_callout" },
    { 0xFCC3F768, "second_names" },
    { 0x50059EAC, "second_node" },
    { 0x80C600EE, "second_node_name" },
    { 0xCE2BBD13, "second_notify" },
    { 0xFE67ACF7, "second_part" },
    { 0x418B154A, "second_pass_starting" },
    { 0xD242044B, "second_patrol_inc_vo" },
    { 0xE0F94050, "second_pilot_reply_intro" },
    { 0x1B467836, "second_plane_napalm_drop" },
    { 0x34CC5EB7, "second_player" },
    { 0xA8E2CC90, "second_rappel_guy_1" },
    { 0x1AEA3BCB, "second_rappel_guy_2" },
    { 0xB52F16BD, "second_read_trigger" },
    { 0x4B7FE315, "second_shack_trigger" },
    { 0x2453EE88, "second_shot" },
    { 0xFF9BD9FB, "second_smallest" },
    { 0xFA690D55, "second_smallest_leader" },
    { 0x74BE2973, "second_snd_ref" },
    { 0x30881CA7, "second_spawners" },
    { 0x9BDE2E60, "second_spot" },
    { 0xD70846E4, "second_sprint_hint" },
    { 0x89B01DCA, "second_squad_talker" },
    { 0x9A19F57F, "second_squad_talker_think" },
    { 0xD9466CD3, "second_target" },
    { 0xE6303690, "second_timeout_fail" },
    { 0x0E58F0D0, "second_truck_spawner" },
    { 0x15D5310A, "second_values" },
    { 0xD859EFB8, "second_village_break" },
    { 0x87D7AC22, "second_village_track_buildings" },
    { 0xD794590E, "second_warning_given" },
    { 0xEFD74ADB, "second_wave_count" },
    { 0xBFA63A29, "second_wave_counters" },
    { 0x505F8A20, "second_wave_dialogue" },
    { 0xEB74BF41, "second_wave_investigate_beartrap" },
    { 0xB670D1C9, "second_wave_spawners" },
    { 0x156DE008, "second_wave_targetname" },
    { 0x20A9A491, "secondaries" },
    { 0x17B5521C, "secondarray" },
    { 0x1CE98AB1, "secondary" },
    { 0x519AF70B, "secondary acquired" },
    { 0x356CEB5B, "secondary_attachment" },
    { 0x607A33C4, "secondary_attachment_flag" },
    { 0xAFF3A9EE, "secondary_attachment_mask" },
    { 0x45899C01, "secondary_attachment_ref" },
    { 0x74C77D66, "secondary_attachment_set" },
    { 0x093E69BD, "secondary_attacker" },
    { 0x66BB1B9C, "secondary_category" },
    { 0x00366BD3, "secondary_category_total" },
    { 0x0AACE648, "secondary_chance" },
    { 0x14A1CCE7, "secondary_death_fx_1" },
    { 0x05202073, "secondary_death_tag_1" },
    { 0x207ABDB7, "secondary_deathcam" },
    { 0xC9F658F3, "secondary_ent" },
    { 0xB2DF521E, "secondary_grenade" },
    { 0x68E25422, "secondary_grenade_count" },
    { 0x3D5ADFA2, "secondary_gun" },
    { 0xFE1A0C1B, "secondary_mastery" },
    { 0x92C3BCDB, "secondary_mastery_pistol" },
    { 0xB508B0AF, "secondary_msg" },
    { 0x6040C974, "secondary_num" },
    { 0x92560052, "secondary_pos" },
    { 0x69F316B3, "secondary_ref" },
    { 0x8501A503, "secondary_weapon_pos" },
    { 0x718180D1, "secondary_weapon_pos_array" },
    { 0x2AC013E6, "secondaryanimationsinit" },
    { 0x384B1055, "secondaryattachmentstotal" },
    { 0xFEC99207, "secondarycamoindex" },
    { 0xE8A8656D, "secondarydeathcamtime" },
    { 0xA8ABDF77, "secondaryfacialanimationthink" },
    { 0xB0F35466, "secondaryflags" },
    { 0x31A4FF6C, "secondarygrenaderef" },
    { 0xD451495D, "secondarygrenadesonlyprev" },
    { 0xF8A642E8, "secondaryloadoutaltweapon" },
    { 0x097DEB6D, "secondaryloadoutgunsmithvariantindex" },
    { 0x024C0BFB, "secondaryloadoutweapon" },
    { 0x19C7767B, "secondaryoffhand" },
    { 0x1A71EC67, "secondaryoffhandbuttonpressed" },
    { 0xF9E435C0, "secondaryoffhandcount" },
    { 0x1EBF5956, "secondaryoffhandname" },
    { 0xBCB5EA4F, "secondaryprogressbarfontsize" },
    { 0xA182EA42, "secondaryprogressbarheight" },
    { 0x8A9F5493, "secondaryprogressbarheight_ss" },
    { 0x2E70742A, "secondaryprogressbartextx" },
    { 0x8ADBC4BB, "secondaryprogressbartextx_ss" },
    { 0x5472EE93, "secondaryprogressbartexty" },
    { 0x173BF798, "secondaryprogressbartexty_ss" },
    { 0x6049DFC1, "secondaryprogressbarwidth" },
    { 0xD238E411, "secondaryprogressbarx" },
    { 0x68758B9E, "secondaryprogressbarx_ss" },
    { 0xAC3669A8, "secondaryprogressbary" },
    { 0xD8409679, "secondaryprogressbary_ss" },
    { 0x8E38586A, "secondarytarget" },
    { 0x24E0E600, "secondaryunloadtag" },
    { 0x5ED5ED01, "secondaryweapon" },
    { 0xD736BB7B, "secondaryweapon_accuracy" },
    { 0x92FBB821, "secondaryweapon_fightdist_max" },
    { 0x5A667011, "secondaryweapon_fightdist_maxsq" },
    { 0x3DA9E05F, "secondaryweapon_fightdist_min" },
    { 0xA40844EB, "secondaryweapon_fightdist_minsq" },
    { 0xF8D98B1B, "secondaryweaponattachstr" },
    { 0xDA65E3F7, "secondaryweaponclass" },
    { 0x779CC3C1, "secondaryweaponkill" },
    { 0xF15A0B00, "secondaryweaponname" },
    { 0x68CC767B, "secondaryweaponnum" },
    { 0xA5EE5EED, "secondaryweaponoptions" },
    { 0xBA82EA28, "secondaryweapons" },
    { 0xC730DE85, "secondaryweight" },
    { 0xBC35E1D3, "seconday" },
    { 0xA4F3BD02, "secondblindfirechance" },
    { 0x0C835E9B, "secondbuilding_breach" },
    { 0xA39A072A, "secondbuilding_check_for_clear" },
    { 0xF3062A2D, "secondchaingroup" },
    { 0x80E1B4D8, "secondclientnum" },
    { 0xEB9B16BE, "secondclosest" },
    { 0x084D74DA, "secondclosestdist" },
    { 0x0C3BA4F6, "secondclosestdistsq" },
    { 0xABD3AB25, "secondclosestent" },
    { 0x26C5ABEC, "secondcp" },
    { 0x2CD6B8B5, "secondgrenadeofdouble" },
    { 0xE78F341A, "secondgroup" },
    { 0xD83882EE, "secondgunhand" },
    { 0x617D1E18, "secondhit" },
    { 0x66DDEE72, "secondplace" },
    { 0xF2682FF5, "secondpos" },
    { 0xAB02D1A4, "seconds" },
    { 0x2D8D5ECC, "seconds_before_plane_overhead" },
    { 0x92F0083D, "seconds_per_hour" },
    { 0x0657E084, "seconds_per_iteration" },
    { 0x63D16F9A, "seconds_played" },
    { 0xA30E86C5, "seconds_remaining" },
    { 0x2B3B28E3, "seconds_tens" },
    { 0xF8B7CBDB, "seconds_to_win" },
    { 0xCEB2E4CF, "seconds_waited" },
    { 0x526F7A67, "secondsleft" },
    { 0x03CE65DA, "secondstodelayexecution" },
    { 0x672AFE0F, "secondstodisplay" },
    { 0x1306B7E0, "secondstowait" },
    { 0x0D0EA49A, "secondsuntildeath" },
    { 0xB5D2021C, "secondswaited" },
    { 0x8C75D30D, "secondtitle" },
    { 0x2A534289, "secounds" },
    { 0xEEE75825, "secret" },
    { 0x7B52D0A1, "secretary" },
    { 0x411058EA, "secretuse" },
    { 0xC88E13D2, "secrity" },
    { 0x88202CEB, "secs" },
    { 0xF8EDF58E, "secs_standing" },
    { 0xA1FA187D, "secserv01" },
    { 0xC7FC92E6, "secserv02" },
    { 0xEDFF0D4F, "secserv03" },
    { 0xE3EDB470, "secserv04" },
    { 0x09F02ED9, "secserv05" },
    { 0x2FF2A942, "secserv06" },
    { 0x55F523AB, "secserv07" },
    { 0xAC0B715C, "secserv08" },
    { 0xD20DEBC5, "secserv09" },
    { 0xFA8F043F, "secserv10" },
    { 0xD48C89D6, "secserv11" },
    { 0xAE8A0F6D, "secserv12" },
    { 0x88879504, "secserv13" },
    { 0x521A26EA, "secserv_01" },
    { 0x2C17AC81, "secserv_02" },
    { 0xA48C7CD5, "secservice_01" },
    { 0xCA8EF73E, "secservice_02" },
    { 0x0F846153, "secsystem" },
    { 0x3DF3708D, "secsystem_struct" },
    { 0xC4EA019E, "section" },
    { 0xEE33F058, "section2" },
    { 0xD242CECE, "section4" },
    { 0xE0516B13, "section_1_trigger" },
    { 0x7C55AB89, "section_2_retreat" },
    { 0x5066364C, "section_2_trigger" },
    { 0x4A2D81D5, "section_3_trigger" },
    { 0xAFC33B86, "section_4_done" },
    { 0x7F12A9C4, "section_name" },
    { 0xE56A9463, "section_trigger" },
    { 0x94D50501, "sections" },
    { 0x8F8740B3, "sector" },
    { 0xDC04CA50, "sector_position_monitor" },
    { 0xEA271362, "sectors" },
    { 0x9A384C36, "secturretaicontrolled" },
    { 0x2F450B15, "secturretdefaultoffmode" },
    { 0x719CA28B, "secturretdefaultonmode" },
    { 0x1F4EC8E8, "secturretdeletedelay" },
    { 0x766DE2C3, "secturretmaxrange" },
    { 0xEC9F2915, "secturretmodel" },
    { 0x02DE6966, "secturrettag" },
    { 0x18B41C2E, "secturrettype" },
    { 0xE3266392, "secure" },
    { 0x3401E8E4, "secure_mansion" },
    { 0x7B9A20E6, "secure_struct" },
    { 0x60FEC897, "secure_the_supply_drops" },
    { 0x4E76EDD2, "secured" },
    { 0x20A6039D, "secures" },
    { 0x3A9228A5, "securestarted" },
    { 0xEF779543, "securing" },
    { 0x0F0C0D4F, "securities" },
    { 0x8F4DE01B, "security" },
    { 0xBE5ACC4E, "security_1_done" },
    { 0x8F25ECFB, "security_2_done" },
    { 0xE01C79AC, "security_3_done" },
    { 0x236C9039, "security_4_done" },
    { 0x4DDB0082, "security_ambience" },
    { 0x76AF92C1, "security_breach" },
    { 0xCDB4EBF1, "security_camera_array" },
    { 0x34527121, "security_camera_cuts" },
    { 0x8A097228, "security_camera_logic" },
    { 0x73A15C36, "security_cameras_follow_player" },
    { 0x9322A31A, "security_cameras_random_rotate" },
    { 0x7CA703A4, "security_cameras_setup" },
    { 0xA15F390A, "security_door" },
    { 0x35DA651F, "security_door_clip" },
    { 0x916D7DF6, "security_door_damage" },
    { 0x132A819D, "security_door_open" },
    { 0x102B2496, "security_fail" },
    { 0xDED80937, "security_gate" },
    { 0xFC628E8D, "security_left" },
    { 0xA5CB4DD5, "security_left_gate" },
    { 0x4E8EE0A2, "security_middle_alert" },
    { 0xB1FF3E5A, "security_names" },
    { 0xD1E32747, "security_office_start" },
    { 0xE3FE9439, "security_panel_consequences" },
    { 0xBD4A19D9, "security_pass" },
    { 0xBBF52551, "security_rail_exit" },
    { 0xF9CF2FF3, "security_room" },
    { 0x18ECB2A3, "security_room_vo" },
    { 0x2774AA46, "security_scanner_gun_think" },
    { 0x69548055, "security_turret_think" },
    { 0xE60AA639, "securitylight" },
    { 0x4AC59333, "securitynode" },
    { 0xAD6CA9F6, "securityr_and_workers_alert" },
    { 0xC10CF292, "sedan" },
    { 0xE02F8FB5, "sedate" },
    { 0x48C337AB, "sedated" },
    { 0x100786CA, "sedation" },
    { 0xB1D467B8, "sediment" },
    { 0x9CE2ECC2, "sedimentfx" },
    { 0xCA357DEB, "sedonc" },
    { 0x8600012F, "sedric" },
    { 0x80982E59, "seductive" },
    { 0x0E70EC00, "seductive_lady_in_outer_bar" },
    { 0x8BEBB76A, "seductive_woman" },
    { 0xEEAC9136, "see" },
    { 0xF5341EBB, "see1" },
    { 0x076E5B3E, "see1_amb" },
    { 0x0D7536F1, "see1_anim" },
    { 0x5B9246DD, "see1_art" },
    { 0x2A3950ED, "see1_code" },
    { 0x50AEF5F9, "see1_drone_axis_assignweapon_german" },
    { 0xEB011037, "see1_event1" },
    { 0x78F9A0FC, "see1_event2" },
    { 0x9EFC1B65, "see1_event3" },
    { 0x0A8DE804, "see1_fx" },
    { 0xEB647904, "see1_fx_placement" },
    { 0xE8E73DB4, "see1_intro" },
    { 0xD4F5C5BC, "see1_molotov_attach" },
    { 0xA7DE3FC6, "see1_molotov_detach" },
    { 0x244CF312, "see1_opening" },
    { 0xFB08A811, "see1_outdoors" },
    { 0x35B49154, "see1_status" },
    { 0x724CA11D, "see1_subway" },
    { 0x0944F1E9, "see1_tank_aggressive" },
    { 0xB72C7A4F, "see1_tank_can_see_player" },
    { 0x1DAF24D0, "see1_tank_current_target" },
    { 0xCDA64EBA, "see1_tank_moved_once" },
    { 0xBCA48123, "see1_tank_moving" },
    { 0xDBC8E651, "see1_tank_no_stop_time" },
    { 0x4B9E319E, "see1_tank_reached_end_node" },
    { 0x28F15CB1, "see1_tank_start_nodes" },
    { 0xDD6ADE7F, "see1_trench_interrior" },
    { 0xD2DC7073, "see1_truck_hits_tree" },
    { 0x832CAF80, "see2" },
    { 0x9C57AAD1, "see2_amb" },
    { 0xB7A1FC38, "see2_anim" },
    { 0x12454AA6, "see2_art" },
    { 0x23FA8000, "see2_base" },
    { 0x09CED68F, "see2_base_lag_time" },
    { 0x17746E6F, "see2_breadcrumbs" },
    { 0xBB3D3BB8, "see2_callback_saverestored" },
    { 0x77FF3C30, "see2_drone_death" },
    { 0x36D583DD, "see2_droneanim_init" },
    { 0x1430F28A, "see2_drones" },
    { 0xB3AC0160, "see2_fail_the_mission_coop" },
    { 0xF8E76AD7, "see2_fortifications" },
    { 0xC1ED6CB1, "see2_fx" },
    { 0x3448ABBE, "see2_grave" },
    { 0xCB6CA124, "see2_handlelinequeue" },
    { 0x4C2B74E4, "see2_interior_pkg" },
    { 0xD31C66DF, "see2_interior_room" },
    { 0xC1662E53, "see2_life_time" },
    { 0xB94C6C9A, "see2_makeradiobreaks" },
    { 0x6BFA05BA, "see2_max_dist" },
    { 0x8B18FE31, "see2_max_dist_threat" },
    { 0x397D454F, "see2_max_tank_firing_dist" },
    { 0x10358BFD, "see2_max_tank_target_dist" },
    { 0x40A256F3, "see2_max_targeters" },
    { 0x65A3ECB6, "see2_percent_life_at_checkpoint" },
    { 0x7E2FAD65, "see2_playaudio" },
    { 0x72BF750C, "see2_player_armor" },
    { 0x38BB8E5A, "see2_playradiostart" },
    { 0x37034472, "see2_playradiostop" },
    { 0x1A47900E, "see2_playsound" },
    { 0xC3E3A084, "see2_sound" },
    { 0x1303623B, "see2_threat" },
    { 0xC8F78546, "see2_threat_groups" },
    { 0xF5E8FA40, "see2_tiger" },
    { 0x8CE05AD7, "see2_town" },
    { 0xDA26D17A, "see2_veh_death_thread" },
    { 0xEEE165F6, "see2_vehicle_behavior" },
    { 0x6CB4A76F, "see_checkpoint" },
    { 0xD6AB9B8F, "see_enemy" },
    { 0xD3751AED, "see_purple_smoke" },
    { 0x4801CEC6, "seed" },
    { 0xB905D9DA, "seeding" },
    { 0x1552C967, "seedposition" },
    { 0x1A0FC679, "seeds" },
    { 0x1A2B0F39, "seedtime" },
    { 0x072E1346, "seeenemydist" },
    { 0xD88374AA, "seeing" },
    { 0xA131A820, "seeing_ent" },
    { 0xBA093E01, "seek" },
    { 0xDE48F616, "seek_out_enemy_failure_max_attempts" },
    { 0x759078DC, "seek_out_enemy_interval_failure" },
    { 0xEA7C1BFB, "seek_out_enemy_interval_success" },
    { 0x353FF665, "seek_out_enemy_radius_big" },
    { 0xE5EBC91A, "seek_out_enemy_radius_small" },
    { 0x57633053, "seek_player" },
    { 0x77F08328, "seek_player_dog" },
    { 0x8271067D, "seek_player_smart" },
    { 0xA9FFE682, "seek_players" },
    { 0x3E1455E8, "seeker" },
    { 0x72F51D83, "seekers" },
    { 0xD03E9F1C, "seekers_chase_player" },
    { 0x17816F15, "seekersound" },
    { 0x6EF68829, "seekersusingcolors" },
    { 0x5A0B8247, "seeking" },
    { 0xC2BB8CE4, "seekingcoverinmyfov" },
    { 0x2FD70971, "seeknode" },
    { 0x02CBC25E, "seekoutenemytime" },
    { 0xAE359C38, "seelow" },
    { 0x9E181C77, "seem" },
    { 0xD9D652A8, "seeme" },
    { 0xECBD553C, "seemed" },
    { 0xC7A7A6A9, "seeming" },
    { 0x1E0CD7AE, "seems" },
    { 0x2C10AD3C, "seen" },
    { 0x433C0244, "seen_enemy_recently_interval" },
    { 0xC99AFC12, "seen_ent" },
    { 0x3AADB7EC, "seen_promo_anim" },
    { 0x79B67BCA, "seen_worse_vignette" },
    { 0xEA9DD9E6, "seerecently" },
    { 0x29CDC429, "sees" },
    { 0xFE2907FE, "seetag" },
    { 0xC8AA16CD, "sef" },
    { 0xA2A79C64, "seg" },
    { 0xD60F0E77, "seg_dist" },
    { 0x7197BBB2, "segfailure" },
    { 0xAD4B5113, "segid" },
    { 0xFF150C10, "segment" },
    { 0xFAA0B366, "segment_end" },
    { 0xBAEE903E, "segment_height" },
    { 0x3ECAD6A7, "segment_length" },
    { 0xA5C8F9CB, "segment_point" },
    { 0xE09FEF25, "segment_start" },
    { 0x9FAF2328, "segment_success" },
    { 0xB2F76614, "segment_time" },
    { 0x9C646A44, "segmentlength" },
    { 0x705112FB, "segments" },
    { 0x84F82E97, "segs" },
    { 0x3DD8140F, "seibert" },
    { 0x69CBACEE, "seige" },
    { 0x5CD01951, "seize" },
    { 0x54CE1D78, "sel_actionbutton" },
    { 0x98FF8139, "seldom" },
    { 0x187262ED, "select" },
    { 0xF5CFAC44, "select_alias" },
    { 0x56334A96, "select_all_ents_with_same_id" },
    { 0x363C4079, "select_by_property" },
    { 0x53D2F555, "select_color" },
    { 0x030A75C7, "select_copy" },
    { 0x57CB8CE8, "select_destructible_from_list" },
    { 0xC2CC7FD5, "select_destructibles" },
    { 0xE7561DC6, "select_dynent_from_list" },
    { 0xA51C08CC, "select_dynent_group" },
    { 0xFC53051B, "select_dynents" },
    { 0x151B6381, "select_entity" },
    { 0xBC5FACC2, "select_ents_by_property" },
    { 0x9EC9BDEE, "select_grab" },
    { 0x99C2EB79, "select_group" },
    { 0x43B30E64, "select_group_highlight" },
    { 0x46892AAD, "select_hop" },
    { 0xAA2815F2, "select_icon_think" },
    { 0xA5D78F86, "select_last_entity" },
    { 0xE11F3F33, "select_leader" },
    { 0xEFF0EA98, "select_leaper_spawn_point" },
    { 0xC4A6ADB6, "select_main_thread" },
    { 0x2115C3B5, "select_miscmodel_from_list" },
    { 0x0BD104E6, "select_miscmodels" },
    { 0x4F0B0C09, "select_mode" },
    { 0x068B9394, "select_mode_thread" },
    { 0x116D6E16, "select_model_thread" },
    { 0x7D61F672, "select_next_event" },
    { 0x1EBEFE8A, "select_number_of_attachments" },
    { 0x8D008DD7, "select_og_origin" },
    { 0x21C22F54, "select_prop_main_thread" },
    { 0x4FE9B253, "select_prop_mode" },
    { 0x1A452D1A, "select_prop_mode_thread" },
    { 0x5F009C95, "select_random_spawn" },
    { 0xEB86DD46, "select_scale" },
    { 0xCDB82240, "select_shot" },
    { 0xE3C0D50B, "select_target" },
    { 0xF6B3A57A, "select_target_highlight" },
    { 0xEB3B5705, "select_track" },
    { 0x7B055598, "select_track_highlight" },
    { 0x5E6D3031, "selectable" },
    { 0x3AF162E3, "selectactionbutton" },
    { 0xABC4FC04, "selectairstrikelocation" },
    { 0x3F311538, "selectartillerylocation" },
    { 0x31420E52, "selectcharacterindextouse" },
    { 0x7C8157DB, "selectclearcommand" },
    { 0x4B079972, "selectconfirmcommand" },
    { 0x11A55CC6, "selectdronestrikepath" },
    { 0xD3ECF79A, "selected" },
    { 0x51DFF574, "selected_back" },
    { 0xE1EB917F, "selected_class" },
    { 0xF9C8F3D6, "selected_color" },
    { 0xF9703190, "selected_delete" },
    { 0x83D263C5, "selected_destructible_save" },
    { 0x7473FE5E, "selected_drop" },
    { 0xB1D6061B, "selected_dynent_save" },
    { 0x89A375D8, "selected_ents_temp" },
    { 0x485E2D8F, "selected_fx" },
    { 0x0EC9C3D8, "selected_fx_ents" },
    { 0x6FC0BA90, "selected_fx_option_index" },
    { 0xB5772CBE, "selected_group" },
    { 0x390B314C, "selected_location" },
    { 0x2BBB97CF, "selected_locations" },
    { 0xC3E589B1, "selected_misc_model_save" },
    { 0xC8EC930C, "selected_misc_model_save_thread" },
    { 0xB1EE290C, "selected_miscmodel_save" },
    { 0xF7EE4A10, "selected_models_save_thread" },
    { 0xFECF7D39, "selected_node" },
    { 0x75FFC178, "selected_object" },
    { 0xAEE14515, "selected_object_check" },
    { 0xFE8B14BB, "selected_object_dist" },
    { 0xD70539F3, "selected_object_z_offset" },
    { 0x66452176, "selected_reset" },
    { 0x2085910D, "selected_rotate_highlight" },
    { 0xA3097DCA, "selected_save" },
    { 0xBD9E0F6B, "selected_save_highlight" },
    { 0x09B6D091, "selected_save_thread" },
    { 0x29E00CEA, "selected_shoot" },
    { 0xF360CA4E, "selected_struct" },
    { 0x9A784362, "selected_target" },
    { 0x0691143A, "selectedclass" },
    { 0x19A3CA3E, "selectedgadget" },
    { 0x04A21F06, "selectedindex" },
    { 0x87652513, "selectedmove_forward" },
    { 0xD9904552, "selectedmove_right" },
    { 0x153FCFD3, "selectedmove_up" },
    { 0x3DB78F51, "selectedmove_vector" },
    { 0x867B15AD, "selectednotetrackindex" },
    { 0x6B3D591B, "selectedposition" },
    { 0x375AC5BC, "selectedrotate_pitch" },
    { 0xA1B0444B, "selectedrotate_roll" },
    { 0xD4FB0E4B, "selectedrotate_yaw" },
    { 0x71B700ED, "selectedsize" },
    { 0x80631AFD, "selectedtarget" },
    { 0xBA3340D3, "selectedunits" },
    { 0x49F8A2EA, "selectedweapon" },
    { 0x82DD148F, "selecthelicopterlocation" },
    { 0x759D117B, "selecting" },
    { 0x585B7026, "selectinglocation" },
    { 0x268B3401, "selection" },
    { 0x218217EE, "selection_error" },
    { 0x1CE1AF28, "selections" },
    { 0x961B5D8C, "selectively" },
    { 0x0C2748B3, "selectmortarlocation" },
    { 0x95E8A357, "selectnapalmlocation" },
    { 0xE40E6312, "selector" },
    { 0x6E7B623B, "selectplanemortarlocation" },
    { 0xD1C3ED88, "selectrandomspawnlocation" },
    { 0x80FB30AD, "selectrandomtires" },
    { 0x55F4BDEC, "selects" },
    { 0xD71DCA1F, "seleted" },
    { 0x1970A3B3, "self" },
    { 0x581B53D6, "self_and_flag_wait" },
    { 0x2B191A1B, "self_angle" },
    { 0xF90F9F3A, "self_angles" },
    { 0x1B33DF70, "self_anim_node" },
    { 0x20FFC8FF, "self_delete" },
    { 0x62CB6B38, "self_destruct" },
    { 0x55599A80, "self_destruct_shinyou" },
    { 0x2B2FE37C, "self_destruct_time" },
    { 0x683775C8, "self_disconnectpaths" },
    { 0x1B4D3DFB, "self_endon_string1" },
    { 0xDE4E7656, "self_finish_dist" },
    { 0x63D7ECC3, "self_for_client" },
    { 0x79B53695, "self_forward" },
    { 0x8C8B7740, "self_in_zone" },
    { 0x86B23686, "self_info" },
    { 0xE6BCB52C, "self_inform_on_damage_trigger" },
    { 0x32395A8E, "self_is_on_bus_roof" },
    { 0x11B25BE5, "self_notify" },
    { 0x2ACE5866, "self_on_bus" },
    { 0x3EEE2DD5, "self_on_goo" },
    { 0x6B96D754, "self_origin" },
    { 0xFBF6048C, "self_piece" },
    { 0x805ED1D0, "self_pos" },
    { 0x826E09BE, "self_powered" },
    { 0x2B9C8118, "self_preservation" },
    { 0x76A54678, "self_right" },
    { 0x6BA97A98, "self_right_angle" },
    { 0x66C0231D, "self_to_camera" },
    { 0x7BFBFF95, "selfang" },
    { 0xCBD9EF5E, "selfarray" },
    { 0x56FA2F9F, "selfcooloff" },
    { 0xD11175FF, "selfdeathicons" },
    { 0xF716F816, "selfdefense_dog" },
    { 0x67F34E48, "selfdefensechallenge" },
    { 0xB95D8D21, "selfdestruct" },
    { 0x469EA23F, "selfdialog" },
    { 0x1DFEB478, "selfdisttoenemy" },
    { 0xDE9716E7, "selfdisttotarget" },
    { 0xA012D56D, "selfdospawn" },
    { 0xEF31387A, "selfentnum" },
    { 0xC5B0176A, "selfforward" },
    { 0x62E0F69E, "selfisonbus" },
    { 0x5D98ACDB, "selfkillstowardsattacker" },
    { 0xB9BE24AD, "selflookatpos" },
    { 0xDA78F500, "selfmonitordamagethread" },
    { 0xA21458D8, "selfnotify" },
    { 0xFD8E830E, "selfpenalizedtimethread" },
    { 0x009A160F, "selfpos" },
    { 0x4FC4A0A5, "selfpredictedpos" },
    { 0x7EC11307, "selfscorethread" },
    { 0xFECF24A7, "selfshootatpos" },
    { 0xAF3947CF, "selfthreat" },
    { 0x450CF10D, "selftoanimstart" },
    { 0x6A22F6EC, "selfup" },
    { 0x9D57DB99, "sell" },
    { 0x56A2F3CD, "sellf" },
    { 0xDABC882F, "selling" },
    { 0x2B50A7A9, "selow" },
    { 0x5F921A67, "selves" },
    { 0x1C7D8C5B, "semi" },
    { 0xC58D60D2, "semi_ammo_cache_think" },
    { 0x60D44332, "semiautofire" },
    { 0x8AE81F98, "semiautomatic" },
    { 0xFA6D68F8, "semifirenumshots" },
    { 0xDAF363FC, "semiforvarietycheck" },
    { 0x53ED3E9D, "semtex" },
    { 0xD43F0EEB, "semtexfx" },
    { 0xE8073201, "sence" },
    { 0xD03CE28B, "send" },
    { 0x17B02904, "send_ai_to_struct" },
    { 0xF9DCA7E5, "send_allies_here" },
    { 0xF30EE46A, "send_away_zombie_follower" },
    { 0x95EEBF9D, "send_barnes_to_hind" },
    { 0xB799E108, "send_clark_ahead_to_jump" },
    { 0x5F3EBE9F, "send_client_notify_for_breach" },
    { 0xD3F24B48, "send_clientnotify" },
    { 0xB13A9053, "send_completed_notify" },
    { 0x17417094, "send_crowd_to_snowcats" },
    { 0xE4939CE7, "send_dialog_reminder" },
    { 0x1947E951, "send_drones_notify" },
    { 0x1E294202, "send_entity_through_oc" },
    { 0xD473ED72, "send_fire_notify" },
    { 0x485A961F, "send_friendlies_to_end" },
    { 0x527AF2D2, "send_group_to_oc" },
    { 0xEE9F11EF, "send_group_to_sr" },
    { 0xC1DE0AEC, "send_hero_back_to_base" },
    { 0x824DA921, "send_heroes_to_new_position" },
    { 0x830902F8, "send_heroes_to_parameter_nodes" },
    { 0x353402E0, "send_hit_special_event_at_frame_end" },
    { 0x2BF56FA2, "send_moto_clientnotify" },
    { 0xEF491C5D, "send_notify" },
    { 0xF359DE8C, "send_plane" },
    { 0x9D09261B, "send_player_horse" },
    { 0x4B5260C9, "send_to_middle_of_courtyard" },
    { 0x4DFB294F, "send_to_nodes" },
    { 0xC6BD9D10, "send_to_retreat_node" },
    { 0x0D4C94C4, "send_warroom_stragglers_at_nearest_ally" },
    { 0x386EC543, "send_wave1_scripted_mg_kill_target" },
    { 0x072EFD3D, "send_wave_to_point_one" },
    { 0x93111611, "send_woods_to_bp" },
    { 0x5148C445, "send_zhao_to_bp" },
    { 0xEE17FFC2, "send_zombies_out" },
    { 0x4BAE177B, "sendafteractionreport" },
    { 0xF53D83B1, "sendaimonitorkeys" },
    { 0xB7C5B0D0, "sendaiscriptkeys" },
    { 0x4DC85068, "sendaiscriptvals" },
    { 0x313E332D, "sendanimscriptkeys" },
    { 0xCCF8A1E7, "sendcodestatekeys" },
    { 0x1D8E0786, "sendentinfokeys" },
    { 0x9A794036, "sendentinfovals" },
    { 0xDA0B94C6, "sender" },
    { 0x025F8D08, "sendfaceevent" },
    { 0xB91050F1, "sendflagcallsigndvar" },
    { 0xF2E1BB58, "sendflagcallsigndvars" },
    { 0x4C506F90, "sendhitspecialeventatframeend" },
    { 0xBFFA26D5, "sending" },
    { 0x393D9D17, "sending_plane_ents" },
    { 0x5F2C4E23, "sending_power" },
    { 0xE785FE82, "sendkillstreakdamageevent" },
    { 0xC8CA2330, "sendmenureponse" },
    { 0x0575D360, "sendmessage" },
    { 0x308F8DBC, "sendon" },
    { 0x19773DC0, "sendranks" },
    { 0xA1520EEA, "sends" },
    { 0x8659F240, "sendtime" },
    { 0x28E4E6F8, "sendupdateddmscores" },
    { 0xF05478D6, "sendupdatedteamscores" },
    { 0x1A825A4F, "sensative" },
    { 0x7A3A9791, "sense" },
    { 0x96A10AA5, "sense_distance" },
    { 0x8B898030, "sense_distance_sq" },
    { 0x1EBE4D92, "sensenearbyplayers" },
    { 0xD1441414, "sensible" },
    { 0xDE6E8137, "sensitive" },
    { 0x79998925, "sensitive_geo" },
    { 0xD326C236, "sensitive_geo_clear_warning_guy" },
    { 0x8B0F7098, "sensitive_geo_fog" },
    { 0x0C702B51, "sensitive_geo_set_warning_guy" },
    { 0x83DF628C, "sensitive_geo_warning_guy" },
    { 0xF3F71909, "sensitive_geo_watch" },
    { 0xCC9930C3, "sensitive_pipes_drop" },
    { 0x4BD99C3F, "sensitive_room_combat_start" },
    { 0x55CBD339, "sensitive_room_pipes" },
    { 0x2F85E3FC, "sensitive_room_pipes_hide" },
    { 0x5398C757, "sensitive_room_pipes_show" },
    { 0x8B8CA313, "sensitive_turret_hacked" },
    { 0xCD4D530E, "sensitivity" },
    { 0xAD6266A3, "sensor" },
    { 0xD357F370, "sensor_grenade" },
    { 0xC78B89B9, "sensor_grenade_laser_distance_sq" },
    { 0x31F8EC47, "sensor_grenade_test" },
    { 0xA0FB3C38, "sensor_grenade_track_time" },
    { 0xF0A669B2, "sensorent" },
    { 0x23A7E10B, "sensorgrenade" },
    { 0xAB21EE7B, "sensorgrenadedata" },
    { 0x7750AC68, "sensorgrenadedestroyed" },
    { 0x64EC11B9, "sensorgrenadehackertoolradius" },
    { 0x2A88C368, "sensorgrenadehackertooltimems" },
    { 0xA4617A57, "sensorgrenadescaneffect" },
    { 0x7819229F, "sensorgrenadetargetingeffect" },
    { 0xAA1A4765, "sensorgrenadethink" },
    { 0xF8F606CD, "sensorhandle" },
    { 0x4386CFE5, "sensorindex" },
    { 0x1B11B392, "sensors" },
    { 0x135C9345, "sensory_overload" },
    { 0x70153BFB, "sent" },
    { 0xC56D2162, "sentenced" },
    { 0xAF98935F, "sentient" },
    { 0x934806E6, "sentients" },
    { 0xAEAF0679, "sentienttiers_" },
    { 0xFBD5FC24, "sentine_rumblewhennearplayer" },
    { 0xF337E109, "sentinel" },
    { 0xD65F1AA1, "sentinel_armdamage" },
    { 0x1EA0FE64, "sentinel_begin_combat_distance" },
    { 0x0BFD6B3A, "sentinel_callbackdamage" },
    { 0x73C2BCE5, "sentinel_camera_destroyed" },
    { 0x8CEF2E36, "sentinel_cameradamage" },
    { 0x46C1510D, "sentinel_canseeenemy" },
    { 0xB7A88435, "sentinel_changesentinelposition" },
    { 0x2B35BB11, "sentinel_charge_at_player_time_out" },
    { 0xEB9B1410, "sentinel_chargeatplayer" },
    { 0xFE5946F6, "sentinel_chargeatplayernavigation" },
    { 0x5084B8A6, "sentinel_coredamage" },
    { 0xFB023764, "sentinel_damagebeamtouchingentity" },
    { 0xBE7E4DF0, "sentinel_damageplayer" },
    { 0x285CDFC3, "sentinel_deactivatealleffects" },
    { 0xAD2BC47F, "sentinel_debugbehavior" },
    { 0x82FE7CE0, "sentinel_debugdrawsize" },
    { 0xDCFE661F, "sentinel_debugfx" },
    { 0x99F5FD57, "sentinel_debugfx_beamcharge" },
    { 0x4D52560E, "sentinel_debugfx_noarms" },
    { 0xD617BCBC, "sentinel_debugfx_noface" },
    { 0x36502289, "sentinel_debugfx_playall" },
    { 0xB9185B43, "sentinel_deletedronedeathfx" },
    { 0xA2874766, "sentinel_destroyallarms" },
    { 0x6AA9ACAB, "sentinel_destroycore" },
    { 0x414EC94D, "sentinel_destroyface" },
    { 0xFA107381, "sentinel_dir" },
    { 0xAE45ED34, "sentinel_dodgeroll" },
    { 0x58CA6A3A, "sentinel_drone" },
    { 0xCC5C551E, "sentinel_drone_arm_break_fx" },
    { 0x4E289824, "sentinel_drone_arm_cut" },
    { 0x67E78218, "sentinel_drone_arm_cut_1" },
    { 0xD9EEF153, "sentinel_drone_arm_cut_2" },
    { 0xB3EC76EA, "sentinel_drone_arm_cut_3" },
    { 0x85BDAC3F, "sentinel_drone_arm_left" },
    { 0xD3E34DD8, "sentinel_drone_arm_left_broken_tag" },
    { 0xD2FDFD71, "sentinel_drone_arm_left_fx_tag" },
    { 0x45B72D6A, "sentinel_drone_arm_left_tag" },
    { 0x14AAEB63, "sentinel_drone_arm_model" },
    { 0x133869DA, "sentinel_drone_arm_right" },
    { 0xFAFA9067, "sentinel_drone_arm_right_broken_tag" },
    { 0x700ED43A, "sentinel_drone_arm_right_fx_tag" },
    { 0xED802783, "sentinel_drone_arm_right_tag" },
    { 0x8B276225, "sentinel_drone_arm_top" },
    { 0xDF784652, "sentinel_drone_arm_top_broken_tag" },
    { 0x32647CFB, "sentinel_drone_arm_top_fx_tag" },
    { 0xC4784BC8, "sentinel_drone_arm_top_tag" },
    { 0x0CDAFAAA, "sentinel_drone_away_from_character" },
    { 0x1F110464, "sentinel_drone_beam" },
    { 0x7FBF68BF, "sentinel_drone_beam_charge" },
    { 0xD68D9DDF, "sentinel_drone_beam_damage_per_second" },
    { 0x68AAACA7, "sentinel_drone_beam_fire" },
    { 0xA5D2F70C, "sentinel_drone_beam_fire1" },
    { 0x17DA6647, "sentinel_drone_beam_fire2" },
    { 0xF1D7EBDE, "sentinel_drone_beam_fire3" },
    { 0xF1DF0016, "sentinel_drone_beam_max_length" },
    { 0xDE8F2A77, "sentinel_drone_beam_set_source_to_target" },
    { 0x0DED5D5D, "sentinel_drone_beam_set_target_id" },
    { 0xFA4270FD, "sentinel_drone_beam_target_fx" },
    { 0x4CCD6C6D, "sentinel_drone_callbackradiusdamage" },
    { 0x1900D05A, "sentinel_drone_camera_ambient_fx" },
    { 0x67FB07F5, "sentinel_drone_camera_broken_tag" },
    { 0xBD547E30, "sentinel_drone_camera_destroyed" },
    { 0xD96586F8, "sentinel_drone_camera_fx_tag" },
    { 0x51758A93, "sentinel_drone_camera_scanner" },
    { 0x13C69614, "sentinel_drone_camera_turret_tag" },
    { 0xCFF23385, "sentinel_drone_change_position_toattack_target_delay" },
    { 0x5880563C, "sentinel_drone_claw_left_fx_tag" },
    { 0x2A3EE47E, "sentinel_drone_claw_model" },
    { 0x3FA043A1, "sentinel_drone_claw_right_fx_tag" },
    { 0x5F08D5A0, "sentinel_drone_claw_top_fx_tag" },
    { 0xDAFE3207, "sentinel_drone_claws_ambient_fx" },
    { 0x2B9B2DD8, "sentinel_drone_claws_charging_fx" },
    { 0x90DFE032, "sentinel_drone_core_blue_tag" },
    { 0xC875D0FD, "sentinel_drone_core_glow_fx" },
    { 0x5FC804AD, "sentinel_drone_core_red_tag" },
    { 0xD03614C9, "sentinel_drone_core_tag" },
    { 0x998224A6, "sentinel_drone_core_tag_2" },
    { 0xBF849F0F, "sentinel_drone_core_tag_3" },
    { 0xC94DD517, "sentinel_drone_damage_player_fx" },
    { 0x81883223, "sentinel_drone_deathfx" },
    { 0xFCF4E90E, "sentinel_drone_default_health_arm_left" },
    { 0xCD0480C5, "sentinel_drone_default_health_arm_right" },
    { 0xA44C3BEE, "sentinel_drone_default_health_arm_top" },
    { 0xEB7E2E19, "sentinel_drone_default_health_camera" },
    { 0x4E5BCF49, "sentinel_drone_default_health_core" },
    { 0x7C89C9CF, "sentinel_drone_default_health_face" },
    { 0x7A9C6A0C, "sentinel_drone_enemy_too_close_dist" },
    { 0x59AFAC88, "sentinel_drone_engine_fx" },
    { 0xFC15CD29, "sentinel_drone_engine_fx_tag" },
    { 0xA22F8EC4, "sentinel_drone_engine_roll_fx" },
    { 0xA362CF0D, "sentinel_drone_eye_break_fx" },
    { 0xA628FC03, "sentinel_drone_face_break_fx" },
    { 0x4B8A068F, "sentinel_drone_face_cut" },
    { 0x34D07024, "sentinel_drone_face_model" },
    { 0x4D08C59F, "sentinel_drone_face_tag" },
    { 0xF0EECF84, "sentinel_drone_fire_chance" },
    { 0x09CA7AAD, "sentinel_drone_hight_ex" },
    { 0xEA83A33B, "sentinel_drone_initialize" },
    { 0xEA95CDA6, "sentinel_drone_juke_move_dist_max" },
    { 0x86863764, "sentinel_drone_max_instances" },
    { 0x4F628DEC, "sentinel_drone_max_time_at_same_position" },
    { 0x85448692, "sentinel_drone_melee_chance" },
    { 0xF3EC0D16, "sentinel_drone_melee_dist" },
    { 0xC8313A4A, "sentinel_drone_move_dist_max" },
    { 0x31995ABA, "sentinel_drone_move_dist_max_ex" },
    { 0xEB69AEE4, "sentinel_drone_move_spacing" },
    { 0xA71594A1, "sentinel_drone_neargoal_dist" },
    { 0x07577E77, "sentinel_drone_player_damage_fx" },
    { 0x8C340313, "sentinel_drone_radius" },
    { 0x024AE33D, "sentinel_drone_radius_ex" },
    { 0xCA7C90A5, "sentinel_drone_repath_range" },
    { 0xD8BD3349, "sentinel_drone_scanner_light_fx" },
    { 0x225773CA, "sentinel_drone_source_to_target" },
    { 0xCC9F03F2, "sentinel_drone_target_id" },
    { 0x85ECD02D, "sentinel_drone_target_selection" },
    { 0x3F2EB28D, "sentinel_drone_targets" },
    { 0xD3A98974, "sentinel_drone_too_close_to_self_dist" },
    { 0xC998F26C, "sentinel_drone_too_close_to_self_dist_ex" },
    { 0x5F321FD6, "sentinel_droneenemy" },
    { 0x37E36704, "sentinel_duration" },
    { 0x45689097, "sentinel_electrifyzombie" },
    { 0x48A0F30D, "sentinel_emp_damage_percentage" },
    { 0xB1FA3FBE, "sentinel_engagement_distance_max" },
    { 0x46FCCA60, "sentinel_engagement_distance_min" },
    { 0xA970C435, "sentinel_engagment_height_max" },
    { 0xD402CF7B, "sentinel_engagment_height_min" },
    { 0xC4552B6B, "sentinel_evade_speed" },
    { 0xFFC58B10, "sentinel_facedamage" },
    { 0x2AB4CC15, "sentinel_firebeam" },
    { 0xF0135159, "sentinel_firebeamburst" },
    { 0xD9C08FEC, "sentinel_firebeamsuccession" },
    { 0xBCA4BD7A, "sentinel_firelogic" },
    { 0xAED5FF39, "sentinel_forcegoandstayinposition" },
    { 0xB8F3C1E5, "sentinel_getarmnumber" },
    { 0x1AF7DD91, "sentinel_getengagementdistmax" },
    { 0x85F552EF, "sentinel_getengagementdistmin" },
    { 0x227DF48E, "sentinel_getengagementheightmax" },
    { 0x75556350, "sentinel_getengagementheightmin" },
    { 0xCAFBB1D0, "sentinel_getnearestzombie" },
    { 0xB57B1706, "sentinel_getnextmovepositiontactical" },
    { 0x031CBD0E, "sentinel_hide_compass_on_remote_control" },
    { 0x8D62FAE7, "sentinel_hideinitialbrokenparts" },
    { 0x9F7ED0E5, "sentinel_hover_acceleration" },
    { 0xD5FE524C, "sentinel_hover_height" },
    { 0x5301B0B6, "sentinel_hover_height_variance" },
    { 0x9A8A7624, "sentinel_hover_inner_radius" },
    { 0x03A3F6F9, "sentinel_hover_outter_radius" },
    { 0x393EBEE7, "sentinel_hover_point_spacing" },
    { 0x348A270B, "sentinel_hover_radius" },
    { 0x0EEA7682, "sentinel_hover_speed" },
    { 0x33AB8E62, "sentinel_in_water_trace_mask" },
    { 0x0ABCCAA3, "sentinel_in_water_trace_maxs" },
    { 0xB3D03A89, "sentinel_in_water_trace_mins" },
    { 0xD5E90851, "sentinel_in_water_trace_wait" },
    { 0xF1CE0A96, "sentinel_initbeamlaunchers" },
    { 0xAB6DA2E2, "sentinel_intro" },
    { 0xD5314E71, "sentinel_introcompleted" },
    { 0xEF489818, "sentinel_is_drone_initialized" },
    { 0x5D3B9AA4, "sentinel_isenemyindoors" },
    { 0x5853DCD1, "sentinel_isenemyinnarrowplace" },
    { 0x7E57F99C, "sentinel_isinsideengagementdistance" },
    { 0xAE15E4EC, "sentinel_isnearanotherplayer" },
    { 0x50EDDA43, "sentinel_isnearanothersentinel" },
    { 0x8A02F3D0, "sentinel_killmyself" },
    { 0x1895AD7E, "sentinel_launch_piece" },
    { 0xA5DAECCB, "sentinel_max_distance_from_owner" },
    { 0x99042C6E, "sentinel_max_height_offset" },
    { 0x8098CB4A, "sentinel_missiles_to_destroy" },
    { 0x55872DF7, "sentinel_move_speed" },
    { 0x7487B2ED, "sentinel_name" },
    { 0xC06CC462, "sentinel_navigatetheworld" },
    { 0xC28FA12C, "sentinel_navigationstandstill" },
    { 0x75CA73EB, "sentinel_near_goal_notify_dist" },
    { 0xB116891A, "sentinel_onallarmsdestroyed" },
    { 0x5743760A, "sentinel_origin" },
    { 0xA0AC642F, "sentinel_pathupdateinterrupt" },
    { 0xA12166B7, "sentinel_play_claws_ambient_fx" },
    { 0x63263DD8, "sentinel_play_engine_fx" },
    { 0x36DA0BE3, "sentinel_play_taunt" },
    { 0x46E90AAE, "sentinel_radius" },
    { 0x986375F9, "sentinel_removefromlevelarray" },
    { 0x2593E364, "sentinel_selfdestruct" },
    { 0x4C8BB04A, "sentinel_setcompactmode" },
    { 0x7AD16DC4, "sentinel_shouldchangesentinelposition" },
    { 0x8D17648A, "sentinel_shutdown" },
    { 0x3C7D43DA, "sentinel_shutown_notify" },
    { 0x01AA38BC, "sentinel_spawn_broken_arm" },
    { 0x1680FB34, "sentinel_spawn_z_offset" },
    { 0x6BE270D3, "sentinel_stun_duration" },
    { 0x12D67237, "sentinel_time_at_same_position_max" },
    { 0xF7E14689, "sentinel_time_at_same_position_min" },
    { 0xE6CDB4EF, "sentinel_trace" },
    { 0x652E2611, "sentinel_turret_enemey_detect_frequency" },
    { 0x7DE1F666, "sentinel_vehicle_name" },
    { 0x980CF571, "sentinel_visionset_alias" },
    { 0x7066D54D, "sentinel_visionset_file" },
    { 0xEC539174, "sentinel_watchteamchange_singleton" },
    { 0x658470A9, "sentinelbundle" },
    { 0x0F20212E, "sentineldamageoverride" },
    { 0x5ED8DF92, "sentineldistancefailure" },
    { 0xF30E446C, "sentineldronehealtharmleft" },
    { 0x6B250A03, "sentineldronehealtharmright" },
    { 0x4989D42A, "sentineldronehealtharms" },
    { 0xA8C2EF68, "sentineldronehealtharmtop" },
    { 0xF36B0EC6, "sentineldronehealthcamera" },
    { 0x218F2356, "sentineldronehealthcore" },
    { 0xB24BE8F0, "sentineldronehealthface" },
    { 0x836F8023, "sentineldronemaxhealth" },
    { 0xD6DA4400, "sentinels" },
    { 0xD322FEB5, "sentitytype" },
    { 0xB3BA92E8, "sentry" },
    { 0xADE2D2EE, "sentry_1_setup" },
    { 0x1A8F0D96, "sentry_emp_kill" },
    { 0xF1CA9C5A, "sentry_kills" },
    { 0x18E850E9, "sentry_kills_total" },
    { 0xA659F2CC, "sentry_time" },
    { 0xE8E1CEF5, "sentry_turret" },
    { 0x23B71DCE, "sentry_turret_alert_sound" },
    { 0x5669B580, "sentry_turret_fire_for_time" },
    { 0x03E82EF6, "sentry_turret_shutdown" },
    { 0xFDFA68C4, "sentry_turrets" },
    { 0xBAAC504E, "sentryhackertoolradius" },
    { 0xA4EE0E23, "sentryhackertooltimems" },
    { 0xACE8EA64, "seondary" },
    { 0x1037F00A, "seounds" },
    { 0x1B6BA3EE, "separate" },
    { 0xF16AE0AE, "separated" },
    { 0xB7F8BEB3, "separately" },
    { 0x0AB1C407, "separating" },
    { 0x5B783FFD, "separation" },
    { 0x4892BDA2, "seperate" },
    { 0x89E483C2, "seperated" },
    { 0x62F539CF, "seperately" },
    { 0x57AC6949, "seperation" },
    { 0x0E5CD841, "seprate" },
    { 0x3CCDD911, "septic" },
    { 0x786C5EB4, "septic_dialog" },
    { 0xB6CA4E22, "seq" },
    { 0x3FDB1EF6, "seq_anim_funcs" },
    { 0xE2EA64B2, "seq_fromanimation_func" },
    { 0x885F0359, "seq_length" },
    { 0x3C4B0C82, "seq_start_length" },
    { 0xBA7CF861, "seq_toanimation_func" },
    { 0xAF9E962F, "seqence" },
    { 0x8B173FA2, "seqeunce" },
    { 0x7CE8FFE2, "sequence" },
    { 0x3E5162AD, "sequences" },
    { 0x9114A4D3, "sequencing" },
    { 0x15FDB300, "sequential" },
    { 0xD2DBEA45, "sequentially" },
    { 0x6818C9FF, "sequnce" },
    { 0xEDB9D7F4, "serenade" },
    { 0x84B5E0B9, "serene" },
    { 0x57EBF2E4, "sergeant" },
    { 0xA190F112, "sergei" },
    { 0x8F312DE5, "sergei_anim_override" },
    { 0xD82166B7, "sergei_audio_ent" },
    { 0xDB0A59A1, "sergei_door" },
    { 0x8F06647B, "sergei_fail_timer" },
    { 0xFD071584, "sergei_rolldoor" },
    { 0xEF01C877, "sergei_spawn_init" },
    { 0xBD88AA7B, "sergei_start" },
    { 0x174A7862, "series" },
    { 0x64C1F878, "serif" },
    { 0xD4DF5C79, "serious" },
    { 0xBF4CC15A, "serve" },
    { 0xA6DC8FAA, "served" },
    { 0x92B9DDEC, "server" },
    { 0xB6BF0386, "server_and_modem_machines" },
    { 0xEE551AFA, "server_choke_action" },
    { 0x60A35FFA, "server_choke_init" },
    { 0xB5A243FB, "server_choke_safe" },
    { 0xB92FF3DC, "server_choke_thread" },
    { 0x66264605, "server_entity_valid" },
    { 0xB5BEEF36, "server_frame" },
    { 0x695C1043, "server_frames_per_sec" },
    { 0x30632B02, "server_frames_to_persist" },
    { 0xD690A15C, "server_loops" },
    { 0x5B264219, "server_room_exit" },
    { 0x3055C0F5, "server_room_exit_door_close" },
    { 0xBCCDA3BF, "server_room_exit_door_open" },
    { 0x50B81F33, "server_room_guy_func" },
    { 0x8C915A79, "server_room_virus_bink" },
    { 0xB6F7472C, "server_safe_ground_trace" },
    { 0xFDDAA2AD, "server_safe_ground_trace_ignore_water" },
    { 0x900EF0ED, "server_safe_init" },
    { 0x3B7E03DC, "server_scenes" },
    { 0x41EFF448, "server_time" },
    { 0x00A64491, "server_version" },
    { 0x0193E964, "server_wait" },
    { 0xDBCEDF89, "servercore" },
    { 0x26228A20, "serverfaceanim" },
    { 0x3BF7C144, "serverfaceanim_shared" },
    { 0x9030C679, "serverfps" },
    { 0x80675353, "serverframe" },
    { 0xFB5A0BD5, "serverobjective_getobjective" },
    { 0xB84C13F0, "serverobjective_getobjectiveentity" },
    { 0xCF4A43EB, "serverobjective_getobjectiveorigin" },
    { 0x4E539C58, "serverobjective_getobjectiveprogress" },
    { 0x97C27A52, "serverobjective_getobjectiveteam" },
    { 0x77D988EF, "servers" },
    { 0xA9390E8D, "serverscript" },
    { 0x349FE40B, "serversettings" },
    { 0x2367BEC6, "servershortout" },
    { 0xAAA34DA1, "serverspf" },
    { 0x627630FF, "servertime" },
    { 0xD621084D, "servertimedmoveto" },
    { 0x9A7EA2EB, "servertimedrotateto" },
    { 0x3A4B346F, "serverwait" },
    { 0xB8BC5855, "serves" },
    { 0xF9884256, "service" },
    { 0x154CA166, "servicemen" },
    { 0xDD1DC62C, "servicereactionevents" },
    { 0xF6B7EA86, "servicereactions" },
    { 0xE24433C9, "services" },
    { 0xD88AC125, "servo_shortout" },
    { 0x1CB1286B, "servos" },
    { 0x49C02BF9, "sesa" },
    { 0xFD2EEADB, "session" },
    { 0xB2DCD7F9, "session_team" },
    { 0xB634F8C4, "sessionadvertcheckwait" },
    { 0xDC208F51, "sessionadverthud_0" },
    { 0x2B67EEC1, "sessionadverthud_0_text" },
    { 0x7E6F7C41, "sessionadverthud_1a" },
    { 0x8C04DAD1, "sessionadverthud_1a_text" },
    { 0xA471F6AA, "sessionadverthud_1b" },
    { 0x385B6A0C, "sessionadverthud_1b_text" },
    { 0xF05BD5D0, "sessionadverthud_2a" },
    { 0xABD9A012, "sessionadverthud_2a_text" },
    { 0x6263450B, "sessionadverthud_2b" },
    { 0x0710CCCB, "sessionadverthud_2b_text" },
    { 0x7E18B197, "sessionadverthud_3a" },
    { 0x9F448A7F, "sessionadverthud_3a_text" },
    { 0x0C11425C, "sessionadverthud_3b" },
    { 0x91909B66, "sessionadverthud_3b_text" },
    { 0xED8AA226, "sessionadverthud_4a" },
    { 0x89CEA760, "sessionadverthud_4a_text" },
    { 0xC78827BD, "sessionadverthud_4b" },
    { 0xFB32B325, "sessionadverthud_4b_text" },
    { 0x162D0956, "sessionadvertisementcheck" },
    { 0x64EDA039, "sessionadvertismentcreatedebughud" },
    { 0x4312D56E, "sessionadvertismentupdatedebughud" },
    { 0x491790F0, "sessionadvertscorepercent" },
    { 0x24FED85B, "sessionadvertstatus" },
    { 0xFE16B8A3, "sessionadvertstatustest" },
    { 0xAC627F71, "sessionadverttimeleft" },
    { 0x77F142C1, "sessionbans" },
    { 0x9B0CFB42, "sessionmode" },
    { 0xF427683F, "sessionmode_campaign" },
    { 0xFB45065E, "sessionmode_invalid" },
    { 0xC5FA8833, "sessionmode_multiplayer" },
    { 0xBCC7C79A, "sessionmode_zombies" },
    { 0x10D08E64, "sessionmodeiscampaigndeadopsgame" },
    { 0xB453FD6E, "sessionmodeiscampaigngame" },
    { 0x27C72C1B, "sessionmodeiscampaignzombiesgame" },
    { 0xE84CC3B8, "sessionmodeismultiplayergame" },
    { 0xBAC7E7E9, "sessionmodeisonlinegame" },
    { 0x16F43F1B, "sessionmodeisprivate" },
    { 0x860CCBB4, "sessionmodeisprivateonlinegame" },
    { 0x9FDC6B85, "sessionmodeissystemlink" },
    { 0x75E46361, "sessionmodeiszombiesgame" },
    { 0x280705F1, "sessionqosupdate" },
    { 0xE0BEB6EE, "sessionstate" },
    { 0xB2E5A818, "sessionteam" },
    { 0x74D6B22F, "set" },
    { 0x47341E47, "set name and rank" },
    { 0xD68111E4, "set1" },
    { 0x4888811F, "set2" },
    { 0x000F7196, "set2dicon" },
    { 0x6755C746, "set3d" },
    { 0x56F8FB7D, "set3dicon" },
    { 0x1967F0DB, "set3diswaypoint" },
    { 0x17B437A0, "set3duseicon" },
    { 0x4D0A070A, "set3flaggedanimknobs" },
    { 0xEA196D63, "set3flaggedanimknobsrestart" },
    { 0xDA8B72B8, "set_2d_icon" },
    { 0x9D3F10BD, "set_3d_icon" },
    { 0x53C833E5, "set_3d_icon_color" },
    { 0x9AA99ECC, "set_3d_is_waypoint" },
    { 0xB26128E1, "set_3d_use_icon" },
    { 0x557DAFB8, "set_50cal_gunner_anims" },
    { 0xB670658D, "set_50cal_vehicle_anims" },
    { 0x8B104B74, "set_a_b" },
    { 0x9764B84A, "set_a_b_c" },
    { 0xB112C5DD, "set_a_c" },
    { 0x51C7617D, "set_above_water" },
    { 0x8643CFF9, "set_accuracy" },
    { 0x218AC3EE, "set_accuracy_based_on_situation" },
    { 0x7BFA91CF, "set_action_slot" },
    { 0xD24683B8, "set_active_remote_weapon" },
    { 0x9ECCF58C, "set_actor_anim_rate" },
    { 0x887571AE, "set_actor_damage_override" },
    { 0xF6A8AF3C, "set_actor_start" },
    { 0xAA6A1DDF, "set_actor_traverse_callbacks" },
    { 0x90DBC5AE, "set_additive_anim" },
    { 0xE3E910B4, "set_aerial_vehicles" },
    { 0xAE338CDE, "set_after_action_report_player_medal" },
    { 0x3EC1E50F, "set_after_action_report_player_stat" },
    { 0x02EB5E93, "set_after_action_report_stat" },
    { 0xF29DE9C2, "set_after_action_report_stats" },
    { 0xEB0BC74B, "set_after_meatshield_dof" },
    { 0x9FDD56C1, "set_after_meatshield_dof_instant" },
    { 0xD79D7EF2, "set_aggressive_cull_radius" },
    { 0x752B0E80, "set_ai_accuracy" },
    { 0xE41F0AE9, "set_ai_group_cleared_count" },
    { 0x68993102, "set_ai_group_cleared_flag" },
    { 0x25463F7C, "set_ai_number" },
    { 0x8D6D88A5, "set_ai_supplements" },
    { 0x88E94F7E, "set_aiming_limits" },
    { 0xDB243B3F, "set_aimturn_limits" },
    { 0xDD5C4132, "set_alert_fx_level" },
    { 0xD76669F3, "set_alert_level" },
    { 0x711DB9A4, "set_all_actor_anim_rate" },
    { 0xDF2C4B4B, "set_all_ai_ignoreme" },
    { 0x00FCA68C, "set_all_exceptions" },
    { 0x1C9FAAFC, "set_all_players_blur" },
    { 0xC0206DBF, "set_all_players_double_vision" },
    { 0xFBEB9647, "set_all_players_shock" },
    { 0x7C583E41, "set_all_players_visionset" },
    { 0xB478FAC2, "set_allow_death" },
    { 0xFDFABAB5, "set_allowdeath" },
    { 0xD68BDC00, "set_allowed_stances" },
    { 0x2D501174, "set_allowed_stances_all" },
    { 0x47215167, "set_allowed_stances_prone" },
    { 0xA0FEFD9B, "set_alouette_context_ext" },
    { 0x1C7CEA11, "set_alouette_context_int" },
    { 0x5B0478A9, "set_alternate_tag" },
    { 0x3521F8FA, "set_ambience_blend" },
    { 0x1F997D31, "set_ambience_blend_over_time" },
    { 0xCB70E44D, "set_ambience_single" },
    { 0x67331596, "set_ambient" },
    { 0x22B4D943, "set_ambient_idle_yaw" },
    { 0x67FF17DB, "set_ambush_fog" },
    { 0x86242C38, "set_ammo" },
    { 0x18577231, "set_ammo_driven" },
    { 0x895395E0, "set_and_restore_force_goal" },
    { 0x151DA639, "set_and_wait_for_anim" },
    { 0x0E5A0B83, "set_anglemod_move_vector" },
    { 0x9B6A9C65, "set_anim" },
    { 0x26BDDEBF, "set_anim_array" },
    { 0x86186D4F, "set_anim_array_aiming" },
    { 0x3DA266C0, "set_anim_playback_rate" },
    { 0x857DB15E, "set_anim_rate" },
    { 0x25548C6C, "set_animarray" },
    { 0x3A315223, "set_animarray_crouching" },
    { 0x3C4E58E5, "set_animarray_crouching_left" },
    { 0x4D3BFF88, "set_animarray_crouching_right" },
    { 0x18A7BB93, "set_animarray_prone" },
    { 0x59EE486B, "set_animarray_standing" },
    { 0xA627F37D, "set_animarray_standing_left" },
    { 0x1A1F18AE, "set_animarray_standing_override" },
    { 0x9BD564E0, "set_animarray_standing_right" },
    { 0xB1ECCBA4, "set_animation" },
    { 0x5CA451AC, "set_animname" },
    { 0x9A75CAAE, "set_animname_custom" },
    { 0x152AF4AF, "set_animnames" },
    { 0x2E267877, "set_animrate" },
    { 0x689B69AF, "set_animrate_for_all" },
    { 0xACF061F6, "set_animrate_for_all_full_coverage" },
    { 0xBC43B774, "set_anims" },
    { 0xFB7772F1, "set_animtree" },
    { 0xF74EE627, "set_ape_run_cycle" },
    { 0x6ED8B820, "set_applydelta" },
    { 0xCE2BB708, "set_array_exposed" },
    { 0x22F33133, "set_arrow_model" },
    { 0x098B92C6, "set_as_target" },
    { 0xEDA4676E, "set_assault_fog" },
    { 0x4AD81B83, "set_attached_models" },
    { 0x2632634E, "set_attachment_cosmetic_variants" },
    { 0x4ADE964D, "set_attachtable_id" },
    { 0x73BC6DBA, "set_attack_delay" },
    { 0xFF6D4708, "set_attack_point_as_inaccessible" },
    { 0xBB5CC68B, "set_audio_snapshot_delay" },
    { 0x389AEE3C, "set_avoidance_for_time" },
    { 0x3824F6C2, "set_background" },
    { 0x8A7BF6DC, "set_banzai_melee_distance" },
    { 0x13EEEFD4, "set_base_impact_state" },
    { 0xD749C4A6, "set_baseaccuracy" },
    { 0xC7F5B8F2, "set_basefog_trigger" },
    { 0x32FE0FBA, "set_baton_guard_run_cycles" },
    { 0x3C9BD99F, "set_battlechatter" },
    { 0x6FB1AC4A, "set_beacon_damage" },
    { 0xFB5BE6E6, "set_beartrap_anim_names" },
    { 0xCEB883CD, "set_behavior_attribute" },
    { 0xD58D7709, "set_below_water" },
    { 0x1C6038D9, "set_best_target_func" },
    { 0xF956E85A, "set_best_target_func_from_weapon_type" },
    { 0xC01059D5, "set_betty_visible" },
    { 0xA8FDF80F, "set_bldg_green" },
    { 0x1E20EDF4, "set_bldg_orange" },
    { 0x1CA26CE9, "set_blend_in_out_times" },
    { 0xAC38DAED, "set_blend_times_for_scene" },
    { 0x223568B3, "set_blendweight" },
    { 0x6F28B74B, "set_bloom" },
    { 0x68FC346F, "set_blops_dialog" },
    { 0xFF56AABD, "set_blur" },
    { 0x4DF00401, "set_boat_swaying" },
    { 0x056DCEB6, "set_body" },
    { 0xF87A1792, "set_body_color" },
    { 0xB36A5F9D, "set_body_colors" },
    { 0x8F766C3C, "set_body_model" },
    { 0x24B3BF09, "set_boost_number" },
    { 0x468341AE, "set_brainwash_vision" },
    { 0x1529C659, "set_brainwash_weights" },
    { 0x63E3E7E5, "set_breach_gun_raised" },
    { 0x39645758, "set_breadcrumbs" },
    { 0x8DE516C9, "set_breadcrumbs_player_positions" },
    { 0x7EA1802C, "set_briefing_bloom_visuals" },
    { 0x4E2CD068, "set_briefing_visuals" },
    { 0xB99002E4, "set_briggs_killed" },
    { 0x4C21C084, "set_bruteforce_flag" },
    { 0x40C02419, "set_brutus_dependent_flags" },
    { 0xA44E7016, "set_build_time" },
    { 0xE2C3CBC4, "set_buildable_clientfield" },
    { 0x5AFC20E2, "set_bullet_shield" },
    { 0xF4546867, "set_burst_parameters" },
    { 0x68F9EE48, "set_c4_throw_binding" },
    { 0xF7A51BB0, "set_cam_space" },
    { 0x51FFFE89, "set_camera_animtime_and_rate" },
    { 0x45B946D9, "set_camera_number" },
    { 0x0DADBB46, "set_camera_snap" },
    { 0x96068847, "set_camera_zoom_hud_percent" },
    { 0xC4EEB87F, "set_camo_reveal_status" },
    { 0xDB465A48, "set_can_use" },
    { 0x13587E67, "set_capture_walk_anims" },
    { 0x0CF0298D, "set_capture_zombies_needed_per_zone" },
    { 0x4493263A, "set_carrier" },
    { 0x036149B5, "set_carrier_visible" },
    { 0x1B4941BC, "set_carry_crouch_speed" },
    { 0x282292C9, "set_carry_icon" },
    { 0x7AE7287D, "set_castro_reveal_vision" },
    { 0xEFD6D670, "set_caveexit_trigger" },
    { 0xD2930434, "set_cdp_dialog" },
    { 0x85AD921E, "set_challenge_stat" },
    { 0xE45A2C8B, "set_character" },
    { 0x474A5989, "set_character_align" },
    { 0xB95F9290, "set_character_mason" },
    { 0x83927414, "set_character_menendez" },
    { 0x9E81088B, "set_character_mode" },
    { 0xE5699687, "set_character_rig_mason" },
    { 0x75D614F2, "set_character_rig_mason_shadow" },
    { 0x3F11CC15, "set_chase_status" },
    { 0x0328AA01, "set_chopper_dof" },
    { 0x47A4EAF3, "set_chopper_fog_and_vision" },
    { 0x544CB90A, "set_circular_origin" },
    { 0xDFF0DE70, "set_civilian_run_cycle" },
    { 0xEF117982, "set_claim_team" },
    { 0x403E045A, "set_class" },
    { 0x52645A22, "set_claw_boot_sequence" },
    { 0x53DC0F75, "set_claymore_visible" },
    { 0xBC760DA4, "set_clearance_ceiling_wrapper" },
    { 0xB7F367A8, "set_clearingfog_trigger" },
    { 0xAC1AE354, "set_client_stat" },
    { 0x4B7143A0, "set_clientfield_buildables_code_callbacks" },
    { 0x56A5BFE3, "set_clientfield_code_callback" },
    { 0xCED9FED2, "set_clientfield_code_callbacks" },
    { 0x5654F132, "set_clientfield_craftables_code_callbacks" },
    { 0x09252263, "set_clientfield_navcard_code_callback" },
    { 0x633DB097, "set_clientfield_powerups" },
    { 0xA9BA5117, "set_closestunitparams" },
    { 0xD7A4DAC4, "set_cloud_fog" },
    { 0x46534793, "set_color" },
    { 0xD2F48594, "set_color_allies" },
    { 0xAC6E44F5, "set_color_chain" },
    { 0x633F6C5F, "set_color_chain_safe" },
    { 0x26D0617E, "set_color_heroes" },
    { 0x869B630D, "set_combat_bro_status" },
    { 0xEE1FE13E, "set_combat_target" },
    { 0xEF808A93, "set_combat_target_as_player" },
    { 0x0D1526FA, "set_commsbuildingroof_fog" },
    { 0x11B2B7C6, "set_compasstype" },
    { 0x9896BABE, "set_console_status" },
    { 0x76382237, "set_contract_award_stat" },
    { 0x5E31A160, "set_contract_award_stat_from_path" },
    { 0x4596DB81, "set_contract_stat" },
    { 0xC12BE328, "set_copterexit_trigger" },
    { 0x634EC09E, "set_corpse_burning" },
    { 0x5DA23C25, "set_cougar_objective" },
    { 0xCCF9A8CA, "set_counter" },
    { 0x0F199CCA, "set_cqb_run_anim" },
    { 0xFAA00F7E, "set_craftable_clientfield" },
    { 0x9B8E3789, "set_crash_dof" },
    { 0x7F822A6F, "set_createfx_water_dvars_street" },
    { 0xE682FF20, "set_creek_ambush_visionset" },
    { 0x7E1FF926, "set_creek_rain_visionset" },
    { 0x44463D52, "set_creek_village_visionset" },
    { 0xB445F597, "set_creek_visionset" },
    { 0xDC929C0D, "set_creek_warroom_visionset" },
    { 0xC992F5A2, "set_crosshair" },
    { 0x5FC196CB, "set_crouching_animarray_aiming" },
    { 0x8B9F014F, "set_cuba_dof" },
    { 0x10BB7398, "set_cuba_fog" },
    { 0x9633A8C1, "set_current_game_module" },
    { 0x668BBF64, "set_current_turned_match" },
    { 0xFB36C038, "set_curvature_fog" },
    { 0x7F795E72, "set_custom_approach" },
    { 0x25E292E6, "set_custom_approach_fields" },
    { 0xCC497455, "set_custom_audio_func" },
    { 0xE636B899, "set_custom_flashlight_values" },
    { 0x3B9DE486, "set_custom_flashlight_values_from_array" },
    { 0x99199795, "set_damage_fx_level" },
    { 0x4BB6B49B, "set_dead_poses_from_betrayal_anim" },
    { 0xA0F305DC, "set_death_anim" },
    { 0xB6527B9A, "set_death_model" },
    { 0x85B6A7D3, "set_deathanim" },
    { 0x0AEEDE9B, "set_deathmodel" },
    { 0xFACD2F34, "set_debug_hud_colors" },
    { 0xC6842968, "set_decay_time" },
    { 0x5216DA32, "set_defalco_killed" },
    { 0x85812AD9, "set_default" },
    { 0x3C1837EC, "set_default_attack_properties" },
    { 0x1234506C, "set_default_callbacks" },
    { 0xB2C9E892, "set_default_covering_fire" },
    { 0x40EA8B63, "set_default_dof" },
    { 0x262EA43C, "set_default_fog" },
    { 0xDD15FB4E, "set_default_laststand_pistol" },
    { 0x082EABD9, "set_default_path" },
    { 0x64BF21C5, "set_default_pathenemy_settings" },
    { 0xD4D619B2, "set_default_skipto" },
    { 0xE7DE5260, "set_default_snapshot" },
    { 0xA1CD736C, "set_default_vision" },
    { 0x74820985, "set_default_vision_set" },
    { 0x65E7A124, "set_default_visionset" },
    { 0xC3489973, "set_default_water_for_settings" },
    { 0x80BD16F3, "set_defend_fog" },
    { 0xFA43C2EB, "set_delete" },
    { 0x60C3C651, "set_demo_intermission_point" },
    { 0x5FE0A9A3, "set_deserted_fog_banks" },
    { 0x1979C99F, "set_destructed" },
    { 0xBB3E5DC7, "set_detonation_time" },
    { 0x2CBBD6C9, "set_difficulty" },
    { 0x05AB0F86, "set_difficulty_from_current_aa_frac" },
    { 0xCDD7BAAF, "set_difficulty_from_locked_settings" },
    { 0xE7EC6E7E, "set_dim_flashlight_values" },
    { 0xEA6D46EB, "set_disable_arrivals" },
    { 0xD35D2643, "set_display_info" },
    { 0xB959CE06, "set_dist" },
    { 0x6C6227EF, "set_distant_planegroup_speed" },
    { 0xBC9A516A, "set_dive_fog_and_vision" },
    { 0xD7224AE7, "set_dock_fog_setting" },
    { 0xBA4023A0, "set_dog_threatbias_group" },
    { 0xA56BDFE2, "set_dome_no_cull" },
    { 0x383962CB, "set_door_paths" },
    { 0xCCFF6EDC, "set_door_unusable" },
    { 0x6ABBCA39, "set_dr_filter" },
    { 0x787BC305, "set_dr_filter_framebuffer" },
    { 0x01A41EDB, "set_dr_filter_framebuffer_duplicate" },
    { 0xC20CC247, "set_dr_filter_offscreen" },
    { 0x1E56FC11, "set_dr_flag" },
    { 0xD174617D, "set_dr_flag_not_array" },
    { 0xC21EC78C, "set_draw_notetrack" },
    { 0xA6652F56, "set_drone_damage_hi" },
    { 0x794D5CEB, "set_drone_damage_low" },
    { 0x15040DA3, "set_drone_damage_med" },
    { 0x18CDD3BC, "set_drone_path_variance" },
    { 0x52E180C8, "set_drone_target" },
    { 0xE147A8FD, "set_drop_offset" },
    { 0xFDF565E8, "set_drop_weapon" },
    { 0x840D9CA3, "set_dropoff_flag_ondeath" },
    { 0x6EB70A40, "set_dropped" },
    { 0x94E8F9F8, "set_dvar_and_volume" },
    { 0xFC1F067E, "set_dvar_float_if_unset" },
    { 0xC25DC80F, "set_dvar_if_unset" },
    { 0x91B7FF45, "set_dvar_int_if_unset" },
    { 0xF2F80434, "set_early_level" },
    { 0x27185A19, "set_eject_fog_bank" },
    { 0x2404B266, "set_elem_alpha" },
    { 0x719DA0C2, "set_elevator_fastforward_visuals" },
    { 0xE8E08892, "set_empty_promotion_order" },
    { 0xACA78EC7, "set_enable" },
    { 0xD990C908, "set_end_distance_from_target" },
    { 0xB48E4A7A, "set_endfightfog_trigger" },
    { 0xC9DB4B42, "set_enemy_damage" },
    { 0x2B80D4E5, "set_enemy_kill" },
    { 0x00D0271E, "set_enemy_reticule" },
    { 0xFEC7E8DE, "set_engagement_to_closer" },
    { 0xB4675913, "set_ent_see2_bias_group" },
    { 0xEE4AB02C, "set_entertunnels_fog" },
    { 0x1C59DCE7, "set_entity" },
    { 0x6B2297D7, "set_entity_thermal" },
    { 0xDB436654, "set_env_dvars" },
    { 0x24232FB1, "set_environment" },
    { 0xBAE9421D, "set_eq_func" },
    { 0xC32F9B66, "set_eq_off" },
    { 0x6D556178, "set_eq_on" },
    { 0x8FC517E8, "set_equipment_invisibility_to_player" },
    { 0x5BD29D09, "set_equipment_list" },
    { 0x2DDF0C1E, "set_event_objective" },
    { 0xD54F54AF, "set_event_printname" },
    { 0xFC77F91E, "set_event_printname_thread" },
    { 0x1D123935, "set_exception" },
    { 0x77CE91A1, "set_exchange_timings" },
    { 0xD3B523BA, "set_exclusive_area" },
    { 0xF7F01A5C, "set_exert_id" },
    { 0xE6D023CE, "set_exittunnels_fog" },
    { 0xE1EE2AB7, "set_explosion_deathanim" },
    { 0x74CA9657, "set_extracam_material_location" },
    { 0x0E1FCFE1, "set_f35_hud_visible" },
    { 0xE13BF922, "set_faction_for_team" },
    { 0xB9F55A7E, "set_fadein_flag" },
    { 0x608E1695, "set_fail_mortars" },
    { 0x4753FD0C, "set_fallback" },
    { 0x9B55A807, "set_fallback_weapon" },
    { 0xD7A11C1E, "set_farid_killed" },
    { 0x146A0477, "set_faster_moveplayerbackrate" },
    { 0x1A1DF384, "set_female_percent" },
    { 0xB9C710AB, "set_fight_dist" },
    { 0xE4B635A8, "set_filter" },
    { 0x0443DA86, "set_filter_angola_gun_cam" },
    { 0x9CD30F88, "set_filter_base_frame_transition_boost" },
    { 0x3A8E4349, "set_filter_base_frame_transition_durden" },
    { 0x11AD1327, "set_filter_base_frame_transition_durden_blur" },
    { 0xEBF1BC59, "set_filter_base_frame_transition_warp" },
    { 0xBD3395CD, "set_filter_bit_flag" },
    { 0x8802E210, "set_filter_blood_droplets_amount" },
    { 0x4048C2D9, "set_filter_blood_droplets_count" },
    { 0x166AD25A, "set_filter_blood_droplets_coverage" },
    { 0x830E8192, "set_filter_blood_droplets_life" },
    { 0x55C13BE6, "set_filter_blood_droplets_sun" },
    { 0x3E6453DD, "set_filter_blood_spatter_reveal" },
    { 0x4496594A, "set_filter_blood_splats_amount" },
    { 0xA7EC40AB, "set_filter_blood_splats_count" },
    { 0x7D8077F0, "set_filter_blood_splats_coverage" },
    { 0x157ABB08, "set_filter_blood_splats_life" },
    { 0x9ABD9ECC, "set_filter_blood_splats_sun" },
    { 0x8222FEA0, "set_filter_claw_boot_amount" },
    { 0x84AA33E7, "set_filter_crackedglass_pakistan3_state" },
    { 0x889F635D, "set_filter_custom_tow_mode" },
    { 0xCBD4124B, "set_filter_drowning_damage_inner_radius" },
    { 0x78B9D7DD, "set_filter_drowning_damage_opacity" },
    { 0xD759316C, "set_filter_drowning_damage_outer_radius" },
    { 0x65003376, "set_filter_emp_amount" },
    { 0x6F3B715C, "set_filter_ev_interference_amount" },
    { 0x18E6D33A, "set_filter_ev_vehiclehijack_amount" },
    { 0xC00A297C, "set_filter_f35_damage_amount" },
    { 0x70DCA458, "set_filter_feedback_blood_drowning" },
    { 0xF3ADF179, "set_filter_feedback_blood_opacity" },
    { 0xBA8F6D71, "set_filter_feedback_blood_sundir" },
    { 0x0FD3A600, "set_filter_feedback_blood_vignette" },
    { 0x0B35CC4C, "set_filter_frame_transition_blur" },
    { 0xF0995839, "set_filter_frame_transition_flare" },
    { 0x99B2B09C, "set_filter_frame_transition_heavy_hexagons" },
    { 0x7C701E86, "set_filter_frame_transition_iris" },
    { 0x5DE453E3, "set_filter_frame_transition_light_hexagons" },
    { 0xCA966D02, "set_filter_frame_transition_saved_frame_reveal" },
    { 0xED612259, "set_filter_frame_transition_warp" },
    { 0xBE0D8475, "set_filter_freq" },
    { 0x3CA70CF0, "set_filter_frost_layer_one" },
    { 0x55D6D5F2, "set_filter_frost_layer_two" },
    { 0x1D42216D, "set_filter_frost_opacity" },
    { 0xC5F718D7, "set_filter_frost_reveal_direction" },
    { 0xB863A07A, "set_filter_gain" },
    { 0xD7DD07DB, "set_filter_gasmask_breath" },
    { 0x3D8B080B, "set_filter_harper_blood_amount" },
    { 0x220254D4, "set_filter_hazmat_opacity" },
    { 0xBC19D6A6, "set_filter_hud_outline_reveal_amount" },
    { 0xCF709D74, "set_filter_hud_projected_grid_position" },
    { 0xE2BE8307, "set_filter_hud_projected_grid_radius" },
    { 0x1C9B40DA, "set_filter_hud_projected_pip_radius" },
    { 0xBC7126CC, "set_filter_keyline_blend_opacity" },
    { 0xC37FCC75, "set_filter_lensflare_brightness" },
    { 0x8FC623AF, "set_filter_lensflare_cutoff" },
    { 0x5293A7D3, "set_filter_lensflare_intensity" },
    { 0x8FFA397A, "set_filter_massiah_amount" },
    { 0x4C32B68F, "set_filter_overdrive" },
    { 0x8152DF1E, "set_filter_oxygenmask_amount" },
    { 0x55AE0954, "set_filter_oxygenmask_condensation_amount" },
    { 0xD6C3A6E2, "set_filter_oxygenmask_crack_state" },
    { 0xDFEF99C3, "set_filter_oxygenmask_radialblur_amount" },
    { 0xD91F0F04, "set_filter_oxygenmask_smoke_amount" },
    { 0x8707F871, "set_filter_pakistan3_outline_reveal_amount" },
    { 0xE91D7F9F, "set_filter_pass_constant" },
    { 0x4E22239A, "set_filter_pass_enabled" },
    { 0x81F50880, "set_filter_pass_material" },
    { 0xA6DE18E5, "set_filter_pass_quads" },
    { 0x0DC95C4D, "set_filter_pentagon_blowout_amount" },
    { 0x2B22BAF3, "set_filter_pentagon_bulgeblur_amount" },
    { 0xC92418CC, "set_filter_pentagon_fullscreen_amount" },
    { 0x85A83922, "set_filter_pentagon_multicam1_amount" },
    { 0x024A19FD, "set_filter_pentagon_multicam1_bink1" },
    { 0x284C9466, "set_filter_pentagon_multicam1_bink2" },
    { 0xDD08C81B, "set_filter_pentagon_multicam2_amount" },
    { 0xCA1B08DE, "set_filter_pentagon_multicam2_bink1" },
    { 0xA4188E75, "set_filter_pentagon_multicam2_bink2" },
    { 0x866D75F4, "set_filter_q" },
    { 0x9D339D74, "set_filter_radialblur_amount" },
    { 0x25C139DF, "set_filter_rage_amount" },
    { 0x8361FF67, "set_filter_rage_ghost_amount" },
    { 0xD4C49CD2, "set_filter_rage_ghost_image" },
    { 0xC96C40CA, "set_filter_rage_ghost_offset" },
    { 0xBE5F1CFF, "set_filter_rage_ghost_scale" },
    { 0x0768E32A, "set_filter_rage_hit" },
    { 0xE74E2C28, "set_filter_rage_hit_opacity" },
    { 0xFC40C7C6, "set_filter_rage_hit_tint_color" },
    { 0xE1501268, "set_filter_rage_shift_amount" },
    { 0x30F2EFA0, "set_filter_rage_warp_amount" },
    { 0x0BB250E0, "set_filter_raindrops_amount" },
    { 0x804B6BBA, "set_filter_rccarcam_noise" },
    { 0xE12D3433, "set_filter_rccarcam_scanline_intensity" },
    { 0x94A4EC11, "set_filter_rccarcam_scanline_speed" },
    { 0x92382ED4, "set_filter_rts_hologram_position" },
    { 0x10F74367, "set_filter_rts_hologram_radius" },
    { 0x11738BBA, "set_filter_rts_vehicle_damage_amount" },
    { 0x33080C13, "set_filter_satellite_transition_amount" },
    { 0xDF79A5B5, "set_filter_sonar_attachment_params" },
    { 0x5DD279BF, "set_filter_sonar_reveal_amount" },
    { 0xF88185FB, "set_filter_speed_burst" },
    { 0x5152516C, "set_filter_sprite_blood_elapsed" },
    { 0xC511E703, "set_filter_sprite_blood_opacity" },
    { 0xDB8726C7, "set_filter_sprite_blood_seed_offset" },
    { 0xB5CF705D, "set_filter_sprite_dirt_elapsed" },
    { 0x622F2E3E, "set_filter_sprite_dirt_opacity" },
    { 0x61850C56, "set_filter_sprite_dirt_seed_offset" },
    { 0x4494085A, "set_filter_sprite_dirt_source_position" },
    { 0xE97C910B, "set_filter_sprite_dirt_sun_position" },
    { 0x7398D2C8, "set_filter_sprite_rain_elapsed" },
    { 0x748FD87F, "set_filter_sprite_rain_opacity" },
    { 0x6449643B, "set_filter_sprite_rain_seed_offset" },
    { 0x4165B39A, "set_filter_sprite_transition_blur" },
    { 0x7EF8C302, "set_filter_sprite_transition_boost" },
    { 0xA332A553, "set_filter_sprite_transition_elapsed" },
    { 0xA8541008, "set_filter_sprite_transition_move_radii" },
    { 0x4822F6BF, "set_filter_sprite_transition_octogons" },
    { 0x9311EBBA, "set_filter_squirrel_raindrops_amount" },
    { 0xB6F0188E, "set_filter_superflare_intensity" },
    { 0x104808CE, "set_filter_superflare_position" },
    { 0x6333FDD9, "set_filter_superflare_radius" },
    { 0xDCEE7C27, "set_filter_tactical_amount" },
    { 0xE7959365, "set_filter_teargas_amount" },
    { 0x7FB9BB44, "set_filter_teleportation_anus_amount" },
    { 0x2CF71D91, "set_filter_teleportation_anus_zoom" },
    { 0xF19A3B7D, "set_filter_teleportation_faces_amount" },
    { 0x90153EB8, "set_filter_teleportation_glow_radius" },
    { 0x5972EBFE, "set_filter_teleportation_lightning_reveal" },
    { 0xC90D3AE3, "set_filter_teleportation_panther_amount" },
    { 0x938A88FE, "set_filter_teleportation_panther_zoom" },
    { 0xA0B3D7E5, "set_filter_teleportation_space_background" },
    { 0x2B8F6CE9, "set_filter_teleportation_sparkle_amount" },
    { 0x9C9024F5, "set_filter_teleportation_warp_amount" },
    { 0x1784E1D4, "set_filter_teleportation_warp_direction" },
    { 0x534D04B4, "set_filter_teleporter_base_amount" },
    { 0x565F032C, "set_filter_teleporter_sprite_elapsed" },
    { 0x062EDEC3, "set_filter_teleporter_sprite_opacity" },
    { 0x21CBBD87, "set_filter_teleporter_sprite_seed_offset" },
    { 0xD2305609, "set_filter_teleporter_top_reveal" },
    { 0xF00A2BD7, "set_filter_type" },
    { 0xD8500DE2, "set_filter_vehicle_damage_amount" },
    { 0x54A416DC, "set_filter_vehicle_hijack_oor_amount" },
    { 0x2C0BA35A, "set_filter_vehicle_hijack_oor_noblack" },
    { 0x9DF2FCE0, "set_filter_vehicle_sun_position" },
    { 0x7FE7FC80, "set_filter_vision_pulse_constant" },
    { 0xDBAF26BA, "set_filter_warp_sr71_amount" },
    { 0x81DC0C25, "set_filter_water_dive_bubbles" },
    { 0x7C089DC3, "set_filter_water_scuba_bubble_attitude" },
    { 0x299B6209, "set_filter_water_scuba_bubbles" },
    { 0x0D08619A, "set_filter_water_scuba_dive_speed" },
    { 0x81771F18, "set_filter_water_sheet_reveal" },
    { 0x8AD7F59A, "set_filter_water_sheet_rivulet_reveal" },
    { 0xB2718D68, "set_filter_water_sheet_speed" },
    { 0x0089931E, "set_filter_water_wash_color" },
    { 0x570BF226, "set_filter_water_wash_reveal_dir" },
    { 0x8125E11D, "set_filter_zodiac_raindrops_amount" },
    { 0xB0078713, "set_final_fog" },
    { 0x63B9C47F, "set_firing" },
    { 0xFEB7BE2E, "set_first_fps_dof" },
    { 0xB466C876, "set_first_junction_vision" },
    { 0xFF32B61C, "set_fixednode" },
    { 0x21AF625B, "set_fixednode_true" },
    { 0xD1A458B0, "set_flag" },
    { 0x9D553AD9, "set_flag_and_die" },
    { 0x9E7189F5, "set_flag_if_not_set" },
    { 0x6C7B271F, "set_flag_messiah_mode" },
    { 0x14F803E2, "set_flag_movie_finished" },
    { 0x4FC5D69B, "set_flag_on_ai_group_clear" },
    { 0x4C006261, "set_flag_on_ai_group_count" },
    { 0xD8C7AF87, "set_flag_on_death" },
    { 0xF01D192A, "set_flag_on_group_clear" },
    { 0x4CC49CBD, "set_flag_on_group_cleared" },
    { 0x23648D04, "set_flag_on_notify" },
    { 0x4D74D6E5, "set_flag_on_player_action" },
    { 0x89697B58, "set_flag_on_player_damage" },
    { 0x70612DF0, "set_flag_on_targetname_trigger" },
    { 0x3855EBC9, "set_flag_on_trigger" },
    { 0x10A2EBDE, "set_flag_ondeath" },
    { 0xC5DF8061, "set_flag_permissions" },
    { 0xBED635A8, "set_flag_retreat_on_group_count" },
    { 0x7C18B3FD, "set_flag_when_ai_touches_trigger" },
    { 0x8587FF82, "set_flag_when_bmps_are_dead" },
    { 0xA8980C56, "set_flag_when_cleared" },
    { 0x35DC8061, "set_flag_when_triggered" },
    { 0x08854D1B, "set_flags" },
    { 0xBFBA21BB, "set_flags_on_street_triggers" },
    { 0xF6557F5A, "set_flags_while_players_stand_in_trigger" },
    { 0x6BCA274B, "set_flash_duration" },
    { 0xE7B19C85, "set_flashback_trail_fx" },
    { 0xC02406EE, "set_flightstick_weights" },
    { 0xAA5036DD, "set_floodlight_vision" },
    { 0x9D522FA9, "set_flying_dof" },
    { 0xA3A271AF, "set_flying_dof_instant" },
    { 0x5E3814B2, "set_fog" },
    { 0x75152068, "set_fog_bank_cod" },
    { 0x3A1D5663, "set_fog_culling" },
    { 0x2EE8B8D1, "set_fog_on_bus" },
    { 0xF945DD0C, "set_fog_progress" },
    { 0x82F2E835, "set_for_time" },
    { 0x1B497663, "set_force_color" },
    { 0xDE9CF53E, "set_force_color_spawner" },
    { 0x2A61CC17, "set_force_cover" },
    { 0xC4BBD053, "set_force_goal" },
    { 0x813B117C, "set_force_loop" },
    { 0xF14351EA, "set_force_no_cull" },
    { 0x1F385904, "set_force_no_cull_on_actors_during_scene" },
    { 0xFE7A0F53, "set_force_ragdoll" },
    { 0xD1F3DB97, "set_forced_target" },
    { 0x5F1EE84E, "set_forced_targets" },
    { 0xE0BBA7B4, "set_forcedgoal" },
    { 0x2DF38962, "set_forcegoal" },
    { 0xC35EE410, "set_forward_and_up_vectors" },
    { 0xE46235AB, "set_fov" },
    { 0xCA33DCA9, "set_friendly_chain_wrapper" },
    { 0x24EAD1AC, "set_friendly_poses" },
    { 0xE99EF255, "set_friendly_reticule" },
    { 0x92B9FDED, "set_friendly_stances" },
    { 0x7F9DAEC6, "set_friendlychain" },
    { 0xB5F556C8, "set_func" },
    { 0x956662EC, "set_function_pointer" },
    { 0x8131C002, "set_fx_hudelement" },
    { 0xA64F41F5, "set_gadget_cleanse_status" },
    { 0x2CCF67F4, "set_gadget_combat_efficiency_status" },
    { 0xACF097A5, "set_gadget_hero_weapon_status" },
    { 0x7373F026, "set_gadget_multirocket_flicker_status" },
    { 0x5DA611F2, "set_gadget_other_status" },
    { 0x39B1B87B, "set_gadget_status" },
    { 0x2780E408, "set_gadget_vision_pulse_status" },
    { 0x7F1D6DCF, "set_game_mode_group_stat" },
    { 0xF4504C5B, "set_game_mode_stat" },
    { 0x0669B4EE, "set_game_var" },
    { 0xF1ECD04E, "set_game_var_once" },
    { 0x7DCFA435, "set_gamemode" },
    { 0x7002CE5B, "set_gamemode_var" },
    { 0x7F914F05, "set_gamemode_var_once" },
    { 0x3B1736E5, "set_gear_state" },
    { 0xD08ABBFB, "set_generator_vfx_amount" },
    { 0xFDB85DC1, "set_generic_deathanim" },
    { 0x54E67C45, "set_generic_run_anim" },
    { 0x605AB2DF, "set_generic_threatbias" },
    { 0x35548ABE, "set_ghost_round_number" },
    { 0x5C591131, "set_gibbed" },
    { 0xAEE2F363, "set_gibbed_player" },
    { 0x494AF3AB, "set_global" },
    { 0xBF3AEE09, "set_global_power" },
    { 0xBD6CD4A8, "set_global_stat" },
    { 0xB3463699, "set_go_line" },
    { 0x90D3ED43, "set_goal" },
    { 0xEBF5579A, "set_goal_and_volume" },
    { 0x89E91CE5, "set_goal_ent" },
    { 0xECDFB21B, "set_goal_entity" },
    { 0xB6AA9674, "set_goal_func" },
    { 0x10B5EBE1, "set_goal_func_quits" },
    { 0xCB271141, "set_goal_go_crouch" },
    { 0xEE07DE4F, "set_goal_go_prone" },
    { 0x6FEBE312, "set_goal_node" },
    { 0xC3B715F2, "set_goal_node_forced" },
    { 0x2E67E580, "set_goal_pos" },
    { 0xE48903B6, "set_goal_tag" },
    { 0x34DD8A21, "set_goal_to_crouch_cqb" },
    { 0x7AF1FC6C, "set_goal_to_current_pos" },
    { 0x0B5A0181, "set_goal_to_guy" },
    { 0x252AEE66, "set_goal_to_nearest" },
    { 0x117CA7F4, "set_goal_volume" },
    { 0x84A2FDBB, "set_goalnode" },
    { 0x972C926A, "set_goalpos_and_volume_from_targetname" },
    { 0xC34C669D, "set_goalradius" },
    { 0x9A423409, "set_goalradius_based_on_settings" },
    { 0x47673BB2, "set_goals" },
    { 0x83EBDBA1, "set_goalvolume" },
    { 0x5B875B5B, "set_gpr" },
    { 0xF92C925B, "set_grabbable_by_anyone" },
    { 0xA5DBE737, "set_grave_state" },
    { 0xACCC5FD6, "set_grave_state_0" },
    { 0xD2CEDA3F, "set_grave_state_1" },
    { 0x60C76B04, "set_grave_state_2" },
    { 0x86C9E56D, "set_grave_state_3" },
    { 0x5850FB84, "set_green_awning" },
    { 0x6C0B7809, "set_green_patio" },
    { 0xBF6932F7, "set_grenade_list" },
    { 0x2832B91E, "set_grenadeammo" },
    { 0xE593D313, "set_grenadeawareness" },
    { 0x868F3D56, "set_grotto_fog" },
    { 0x6CCAB251, "set_guard_dead_poses" },
    { 0xE06E9D20, "set_gunner_anims" },
    { 0x181D1909, "set_gunner_vehicle_anims" },
    { 0x6DC470F1, "set_hack_hint_string" },
    { 0xA3B65390, "set_hacked_ent" },
    { 0x00C3FBD5, "set_hacker_tool_breaching" },
    { 0x546B635C, "set_hacker_tool_hacked" },
    { 0x9F467D49, "set_hacker_tool_hacking" },
    { 0xB80127D4, "set_hallway_fog_trigger" },
    { 0xFFDB4C0F, "set_handle_notetracks" },
    { 0x7B48401F, "set_hat_model" },
    { 0x5B80FAE8, "set_head" },
    { 0xC534A802, "set_head_look" },
    { 0xFB26B30E, "set_head_model" },
    { 0xC6688BB4, "set_health" },
    { 0x1010867F, "set_health_frac" },
    { 0x35B42CB4, "set_heatwave_fx" },
    { 0x482F1946, "set_heli_speed_evasive" },
    { 0x3D47BAA1, "set_heli_speed_hover" },
    { 0x4CB3570C, "set_heli_speed_normal" },
    { 0x2951DD2B, "set_helicopter_visuals" },
    { 0x5FA9D769, "set_helmet" },
    { 0x883D8451, "set_helmet_color" },
    { 0xF8E56A38, "set_helmet_colors" },
    { 0x53B098D4, "set_hero_run_anim" },
    { 0xECA1A7BB, "set_hero_weapon_state" },
    { 0x21CC3865, "set_hide_model_if_unavailable" },
    { 0x588EBF15, "set_high_alert" },
    { 0x683577C5, "set_high_alert_on_alarm" },
    { 0x3E05D0A6, "set_high_score_stat" },
    { 0x539DAD09, "set_highway_visuals" },
    { 0x6D8FDF5A, "set_hind_goal_pos_wrapper" },
    { 0xBD81D4D9, "set_hint_on_digger_trig" },
    { 0x5D210E97, "set_hint_string" },
    { 0xC2F6D0B6, "set_hold_distance_on_target_death" },
    { 0xE588392F, "set_hologram_red" },
    { 0x07137A35, "set_hologram_shown" },
    { 0x34A7EF4B, "set_horse_anim" },
    { 0x49222ADC, "set_horse_in_combat" },
    { 0xC2E267C2, "set_horseback_melee_values" },
    { 0x19D12308, "set_hud_blue" },
    { 0x653753CD, "set_hud_green" },
    { 0x2ACBC51D, "set_hud_grey" },
    { 0x93BBEB46, "set_hud_prompt" },
    { 0x25722089, "set_hud_prompt_test" },
    { 0xB0C253B9, "set_hud_red" },
    { 0x1FD96759, "set_hud_text" },
    { 0x86305C73, "set_hud_white" },
    { 0x1F885D9C, "set_hud_yellow" },
    { 0x8BD98A60, "set_hudelem" },
    { 0x0316FBF7, "set_hudelement_current_light_slot" },
    { 0x6EFC5EC8, "set_hudelement_current_shot" },
    { 0x3B4C2320, "set_huds_alphas" },
    { 0xEAD77D9F, "set_hudson_color" },
    { 0xD87C7FB0, "set_hudson_control_vision" },
    { 0xD5B183EE, "set_hudson_melee" },
    { 0x6478657F, "set_id_shader" },
    { 0x09D4ECE1, "set_if_defined" },
    { 0x722C740E, "set_igc_active" },
    { 0x1F64B264, "set_ignore_all" },
    { 0x37450DDC, "set_ignore_ent_array" },
    { 0x5988902D, "set_ignore_line_of_sight" },
    { 0x701E2EC6, "set_ignore_to_goal" },
    { 0xB4F5E3B9, "set_ignoreall" },
    { 0xC9E45D52, "set_ignoreme" },
    { 0xB25ADC48, "set_ignoreme_off" },
    { 0x79534CE2, "set_ignoreme_on" },
    { 0x4DB548B5, "set_ignoresuppression" },
    { 0x430D9587, "set_ignoresuppression_off" },
    { 0x10489773, "set_ignoresuppression_on" },
    { 0x7CA12541, "set_immediate_objective" },
    { 0xA84660FB, "set_impact_context_dist" },
    { 0xCC6535CD, "set_impact_context_norm" },
    { 0x521703C8, "set_impact_effect" },
    { 0x4554067B, "set_inbase_snapshot" },
    { 0xF8C34926, "set_index" },
    { 0x35A73FB0, "set_inflight_fog" },
    { 0x01E5C1E7, "set_initial_extra_cam_blur" },
    { 0x61F003DD, "set_instrument" },
    { 0xCF641761, "set_intel_map" },
    { 0xDEA0D47C, "set_interaction_height" },
    { 0x0FD8189F, "set_interaction_trigger_height" },
    { 0x05E0CF34, "set_interaction_trigger_radius" },
    { 0x01EDAF05, "set_interior_vision" },
    { 0xD2586D6D, "set_intermission_point" },
    { 0x489EC20D, "set_intro_fog" },
    { 0x4C7D9C85, "set_intro_fog_banks" },
    { 0x05BF5557, "set_intro_snapshot" },
    { 0xEC8CC1DD, "set_intro_to_exterior" },
    { 0x03C34B4C, "set_intruder_flag" },
    { 0x64E4F717, "set_isi_color" },
    { 0x8E63462B, "set_item_color" },
    { 0xA75081B3, "set_item_enemy_equipment" },
    { 0x5CEB14B2, "set_item_enemy_explosive" },
    { 0xA28D1A5F, "set_item_enemy_vehicle" },
    { 0xC9CF8686, "set_item_friendly_equipment" },
    { 0x4E2867E3, "set_item_friendly_explosive" },
    { 0x48E05B4A, "set_item_friendly_vehicle" },
    { 0x93580E49, "set_item_retrievable" },
    { 0x8A62DDEF, "set_item_text" },
    { 0x3CAA584C, "set_item_unplaceable" },
    { 0x703C667A, "set_jet_fog_banks" },
    { 0x26327FF2, "set_jetgun_engine_direction" },
    { 0x5592DFC0, "set_jfk_fog" },
    { 0x553377D6, "set_juggernaut_run_cycles" },
    { 0x097F850A, "set_karma_killed" },
    { 0x797405D7, "set_key_object" },
    { 0xAFA01DBF, "set_killcam_entities" },
    { 0xC6FDDEC0, "set_killstreak_delay_killcam" },
    { 0x6F8CD5A0, "set_knocked_out" },
    { 0xAF5CC3D7, "set_last_gib_time" },
    { 0xCBDB316C, "set_laststand_pistol" },
    { 0x10B77504, "set_layer_of_death" },
    { 0xD69E004D, "set_leader_gametype_dialog" },
    { 0x622FD3C9, "set_leap_attack_properties" },
    { 0xC6628090, "set_ledge_fog" },
    { 0x35E803DB, "set_legit_weapons_for_sniper_escape" },
    { 0x1942BC32, "set_level_completed" },
    { 0x32A13656, "set_level_goal" },
    { 0xC4C27DA4, "set_level_objective" },
    { 0xEC453681, "set_level_sun_default" },
    { 0xF310F6A2, "set_levelvar_now" },
    { 0xEDF0AC02, "set_light_color" },
    { 0x24DDA81C, "set_light_exponent" },
    { 0xB4E05F74, "set_light_flicker_fx_area" },
    { 0x1497B2DF, "set_light_inner_fov" },
    { 0x4DCC75EC, "set_light_intensity" },
    { 0xCCB98946, "set_light_notify" },
    { 0x13A93922, "set_light_outer_fov" },
    { 0x05771E4F, "set_light_radius" },
    { 0x718A0A38, "set_light_state" },
    { 0x74DE5770, "set_lighting_ent" },
    { 0x764E2149, "set_lighting_pair" },
    { 0xB85473AC, "set_lighting_state" },
    { 0xEA028059, "set_lights" },
    { 0x95B7B079, "set_limousine_visuals" },
    { 0x894B5E42, "set_link" },
    { 0x684F3718, "set_link_model" },
    { 0x54ED2D3B, "set_link_tag" },
    { 0x75269B71, "set_linkto" },
    { 0xD5C2A28B, "set_linkto_model" },
    { 0xE6668B9C, "set_linkto_tag" },
    { 0x8815A546, "set_loadout" },
    { 0xFE07C2D4, "set_loadout_offset" },
    { 0xEDF8C741, "set_location_gametype_stat" },
    { 0xFD2F0F7F, "set_lock_on_target" },
    { 0xDFED49B2, "set_lockbreaker_flag" },
    { 0xBC168E41, "set_locked_magicbox_state" },
    { 0x84DA9402, "set_lookat_from_dest" },
    { 0xFAC96AE3, "set_lookat_point" },
    { 0xB33389F8, "set_low_ready_false" },
    { 0xA6FC840F, "set_low_ready_true" },
    { 0x0ACA3C52, "set_macv_fog" },
    { 0x51E2324D, "set_magic_box_zbarrier_state" },
    { 0xD17329DC, "set_manual_wait_time" },
    { 0x070EE5F5, "set_map_stat" },
    { 0x24D50258, "set_map_weaponlocker_stat" },
    { 0x45E5345A, "set_mason_truck_burst_parameters" },
    { 0xEA30052D, "set_match_history_stat" },
    { 0x50ED6A62, "set_max_health_for_all_players" },
    { 0x535EA28C, "set_max_per_player" },
    { 0x3CF7CE0E, "set_max_target_distance" },
    { 0xE9153855, "set_maxsightdistsqrd" },
    { 0x67B7C032, "set_maxvisibledist" },
    { 0x340B1678, "set_melee_digbat_run_cycles" },
    { 0xD22BF79D, "set_melee_mortars" },
    { 0xB5EE5700, "set_melee_timer" },
    { 0xCD0BFB3C, "set_menu_hudelem" },
    { 0x7395EA6E, "set_menus_pos_by_num" },
    { 0xD2048F0C, "set_midcavefogenter_trigger" },
    { 0x96D77410, "set_min_target_distance" },
    { 0x5ED6720A, "set_min_target_distance_squared" },
    { 0xDCAF36F7, "set_min_time_remaining" },
    { 0x5DCAEA50, "set_mission_dvar" },
    { 0x25102C03, "set_model_animtime_and_rate" },
    { 0x0A0ACEF0, "set_model_visibility" },
    { 0xB926A284, "set_modified_sight_dist" },
    { 0x7FA923B9, "set_monitors_to_snow" },
    { 0x58918B71, "set_monitors_to_snow_int_screens" },
    { 0x56FB8361, "set_monkey_slide_anim" },
    { 0x1CBE9145, "set_morals_snapshot" },
    { 0x0D03C774, "set_mortar_chance" },
    { 0x64255373, "set_mortar_damage" },
    { 0x028F896C, "set_mortar_delays" },
    { 0x567B3A5C, "set_mortar_dust" },
    { 0x13935FDB, "set_mortar_notify" },
    { 0xDF4E225B, "set_mortar_quake" },
    { 0x724E96DF, "set_mortar_range" },
    { 0x957ACA22, "set_moto_stage" },
    { 0x3DA845B7, "set_moto_state" },
    { 0x949622D3, "set_mount_direction" },
    { 0x82C7EF16, "set_move_in_func" },
    { 0xB92A53AD, "set_move_out_func" },
    { 0x8625DF35, "set_move_speed" },
    { 0x0112E1AA, "set_movement_and_accel" },
    { 0x97323156, "set_movement_scale" },
    { 0xA5425A20, "set_mpla_run_cycles" },
    { 0x081E167B, "set_music_global" },
    { 0xF35C5627, "set_music_on_player" },
    { 0xE3595143, "set_music_on_team" },
    { 0xBBD5E9D3, "set_music_state_to_silence" },
    { 0x7C3DD48F, "set_music_when_bypass_barrels" },
    { 0x89996C44, "set_my_bias" },
    { 0xE7123CE3, "set_my_switchnode" },
    { 0xB897ECFF, "set_near_plane" },
    { 0x844F94C7, "set_next_extra_life" },
    { 0x52D4630E, "set_next_level" },
    { 0x419E790F, "set_next_music_state" },
    { 0x4B296929, "set_night_values" },
    { 0x0C4241D5, "set_no_ambient_snapshot" },
    { 0xAF0C3893, "set_no_back_menu" },
    { 0xB5844629, "set_no_damage" },
    { 0x4C42F05C, "set_no_gib" },
    { 0x32BA4634, "set_noriega_run_anims" },
    { 0x0F352CF6, "set_npc_weapon" },
    { 0xFC145D5B, "set_numbers_vision" },
    { 0xC5882508, "set_nvg_vision" },
    { 0x0479F6C5, "set_obj_progress" },
    { 0x3EF72E93, "set_objective" },
    { 0x8CA7C664, "set_objective_active" },
    { 0x73CA9FB7, "set_objective_color" },
    { 0x8605D24B, "set_objective_entity" },
    { 0x25F494BD, "set_objective_inactive" },
    { 0x48059DBB, "set_objective_on_bunker" },
    { 0xDFBF115F, "set_objective_on_vtol" },
    { 0xB4289FF2, "set_objective_perk" },
    { 0x61164F0F, "set_objective_pos_to_extraction_point" },
    { 0xBE057BBE, "set_objective_text_colors" },
    { 0xBC6238A6, "set_objective_when_player_ready" },
    { 0x793659C2, "set_objectives" },
    { 0x6FC542EA, "set_occupied" },
    { 0x69A92099, "set_occupy_no_target_time" },
    { 0xFB9F93EA, "set_off_exploders" },
    { 0xE20AD73F, "set_officefog_trigger" },
    { 0x06BFDA7B, "set_on_target_angle" },
    { 0x1EC3993C, "set_onplayer_attribs" },
    { 0x7954DF74, "set_opening_dof" },
    { 0x9410C69B, "set_opening_fog" },
    { 0x2CADFEB0, "set_option_index" },
    { 0x5C8CE1CD, "set_orient_mode" },
    { 0x0A93964E, "set_origin_by_name" },
    { 0xEC88AB78, "set_osprey_context_ext" },
    { 0xBE7E6916, "set_osprey_context_int" },
    { 0x28801FE3, "set_out_of_chair_vision" },
    { 0x05355D8B, "set_outro_fog_bank" },
    { 0x720F800A, "set_outro_vision" },
    { 0xA03AD61E, "set_overhead_planegroup_speed" },
    { 0x24C7169D, "set_overlay_constant" },
    { 0x30424200, "set_overlay_enabled" },
    { 0xA187E286, "set_overlay_material" },
    { 0xA09B1AC1, "set_owner_team" },
    { 0x7BF590DD, "set_pacifist" },
    { 0xB0BCB96F, "set_pacifist_off" },
    { 0x48167C9B, "set_pacifist_on" },
    { 0x2DF7AEFB, "set_pack_icon" },
    { 0x185BF84D, "set_pap_zbarrier_state" },
    { 0x61692488, "set_parasite_enemy" },
    { 0xE0AD9E65, "set_particle_light" },
    { 0xBB8FB891, "set_path_wait_points" },
    { 0xEAA63B62, "set_pathfight_dist" },
    { 0xD5F8C6F6, "set_patrol_path" },
    { 0xF753CD92, "set_patrol_vehicle_anims" },
    { 0x6E5DFCE8, "set_pause" },
    { 0x546A4F8C, "set_perk_clientfield" },
    { 0x86DCD22C, "set_perk_random_machine_state" },
    { 0xC3D72C52, "set_permissions" },
    { 0x7275C170, "set_permissions_for_machine" },
    { 0xB956860A, "set_persist_damaged_tanker_state_1" },
    { 0x93540BA1, "set_persist_damaged_tanker_state_2" },
    { 0xF8A0E259, "set_persist_deck_destruction_state_1" },
    { 0x1EA35CC2, "set_persist_deck_destruction_state_2" },
    { 0x44A5D72B, "set_persist_deck_destruction_state_3" },
    { 0x6AA85194, "set_persist_deck_destruction_state_4" },
    { 0x87419D29, "set_phalanx_cannon_default_target_vec" },
    { 0x938C9B72, "set_picked_up" },
    { 0xFE500AEC, "set_pickup_bobbing" },
    { 0x8956A523, "set_pickup_rotation" },
    { 0xBC39C454, "set_piece_count" },
    { 0xF97D1D11, "set_pilots_suggested_seat" },
    { 0xB8151135, "set_pistol_dof" },
    { 0x0DA73F34, "set_pitch" },
    { 0x54085F20, "set_play_one_spot" },
    { 0x43359210, "set_player_after_sullivan_scene" },
    { 0x7B46B2B7, "set_player_ammo_loadout" },
    { 0x4FA94558, "set_player_angles" },
    { 0x04C17625, "set_player_anim_use_lowready" },
    { 0x53216244, "set_player_attrib" },
    { 0xE8B6C424, "set_player_attrib_internal" },
    { 0xA6EC0DBF, "set_player_camo_viewmodel" },
    { 0x397D6B43, "set_player_chain" },
    { 0xC3FBD594, "set_player_clamps" },
    { 0xC46A59AE, "set_player_controlled_area" },
    { 0x3262A99F, "set_player_controlled_zone" },
    { 0x5DDFFF48, "set_player_current_ghost_zone" },
    { 0xC502E741, "set_player_dontspeak" },
    { 0x453662AE, "set_player_drone_speed" },
    { 0x539FA8A0, "set_player_end_conditions" },
    { 0xE5A8C680, "set_player_equipment" },
    { 0x5E436495, "set_player_eye_target" },
    { 0xB7B03243, "set_player_hero_weapon" },
    { 0x547804D8, "set_player_in_fog" },
    { 0xDEB6D047, "set_player_interactive_hands" },
    { 0x41C3CC82, "set_player_interactive_model" },
    { 0x1F2B869B, "set_player_invulerability" },
    { 0x12B9F445, "set_player_invulnerable" },
    { 0xD9B871B3, "set_player_is_female" },
    { 0x182EBD17, "set_player_last_known_pos" },
    { 0x07A54965, "set_player_lethal_grenade" },
    { 0x6F38A1FA, "set_player_low_ready" },
    { 0x166EF8B2, "set_player_mason" },
    { 0x03873F37, "set_player_melee_weapon" },
    { 0x1225A8CA, "set_player_menendez" },
    { 0x37FD0A0F, "set_player_model" },
    { 0xB28EBB91, "set_player_moving_speed_scale" },
    { 0xAD8B7269, "set_player_placeable_mine" },
    { 0x630958D2, "set_player_rig" },
    { 0xE5AC16A4, "set_player_score_hud" },
    { 0x46029446, "set_player_shock" },
    { 0x8F014F59, "set_player_speed" },
    { 0x13F92947, "set_player_speed_internal" },
    { 0x476C0E12, "set_player_staff" },
    { 0xF6296A18, "set_player_stance" },
    { 0xAE4F00F3, "set_player_stances" },
    { 0xFF1194DC, "set_player_start" },
    { 0xCD4DB90E, "set_player_stat" },
    { 0x58D971BC, "set_player_tactical_grenade" },
    { 0x7D625CF9, "set_player_threat_detected" },
    { 0xD9A7D024, "set_player_tombstone_index" },
    { 0x09BA3066, "set_player_turret" },
    { 0xCC4D5165, "set_player_uimodel" },
    { 0xA24CA3F0, "set_player_vehicle_difficulty" },
    { 0x744B5A22, "set_player_viewhand_model" },
    { 0x04D6695A, "set_player_viewmodel" },
    { 0x3D6C6EE1, "set_player_weapon_ammo" },
    { 0xF49C4BDB, "set_player_weapon_disabled" },
    { 0xEEE384D4, "set_players_dontspeak" },
    { 0x3117C7A3, "set_players_ignoreme" },
    { 0x0358D0B6, "set_playerspeed" },
    { 0x1392842A, "set_playf_off_last_spot" },
    { 0x5CB77C43, "set_poison_overlay" },
    { 0xA80FCFB1, "set_pool_fog" },
    { 0xDA38318E, "set_pool_visuals" },
    { 0x77A2F01E, "set_portal_override_comms_roof" },
    { 0x1F543AE7, "set_portal_override_event10_jumpto" },
    { 0x37D0ED08, "set_portal_override_event11_jumpto" },
    { 0xFD3C5AB9, "set_portal_override_event12_jumpto" },
    { 0x0F0A2672, "set_portal_override_event13_jumpto" },
    { 0x7E9336E3, "set_portal_override_event14_jumpto" },
    { 0x0854DE84, "set_portal_override_event15_jumpto" },
    { 0xB2A94E85, "set_portal_override_event16_jumpto" },
    { 0xBC5045AE, "set_portal_override_event17_jumpto" },
    { 0x9AD87768, "set_portal_override_event2_jumpto" },
    { 0xF6FB0FC7, "set_portal_override_event3_jumpto" },
    { 0x0658E88E, "set_portal_override_event4_jumpto" },
    { 0x54A944E5, "set_portal_override_event5_jumpto" },
    { 0x59050AE4, "set_portal_override_event6_jumpto" },
    { 0xA58A7B43, "set_portal_override_event7_jumpto" },
    { 0x9F45FC5A, "set_portal_override_event8_jumpto" },
    { 0x1C597281, "set_portal_override_event9_jumpto" },
    { 0xB589E15C, "set_portal_override_flame_trench" },
    { 0x6F2C35FC, "set_portal_override_gantry_battle" },
    { 0x0034EE7A, "set_portal_override_migsoverhead" },
    { 0x715486AE, "set_portal_override_missioncontrol_exit" },
    { 0x9DF39844, "set_portal_override_run_to_binoculars" },
    { 0xA25E5D3E, "set_portal_override_start" },
    { 0xB56DBC44, "set_portal_override_woods_door_kick" },
    { 0x5414CFCC, "set_pos" },
    { 0x5266D3BB, "set_position" },
    { 0xBC93FC38, "set_post_branching_scene_stats" },
    { 0xBEB73F2A, "set_post_intro_snapshot" },
    { 0x8F1DBFFF, "set_post_skydemon_spotlight_values" },
    { 0x64E7765B, "set_power_on" },
    { 0x1139BF6D, "set_pre_explosion" },
    { 0x9E05243B, "set_pre_melee_mortars" },
    { 0xF8FAB6DB, "set_premaxhealth" },
    { 0xF4953D6A, "set_presist_damaged_tanker_state_3" },
    { 0x669CACA5, "set_presist_damaged_tanker_state_4" },
    { 0xC7BCCE6B, "set_prisoner_run_cycle" },
    { 0x4AA84B30, "set_prisoner_script_settings" },
    { 0xEFDEA820, "set_promotion_order" },
    { 0x32C8C8EF, "set_quadrotor_guard_position" },
    { 0xFE4A2C9F, "set_race_zombie_run_cycle" },
    { 0x0A32B5D6, "set_radar_station_fog" },
    { 0x962F5E7D, "set_radar_visibility" },
    { 0xA6318E49, "set_rage_behaviour" },
    { 0xC22DCAAB, "set_rain_level" },
    { 0x2167A1D0, "set_rampsonarcolor" },
    { 0xAA07973D, "set_random_alt_weapon_drops" },
    { 0x126C805D, "set_random_cammo_drop" },
    { 0x98292CA2, "set_random_camo_drop" },
    { 0x988BE480, "set_random_gib" },
    { 0x92C5EC68, "set_rank" },
    { 0x739E5EB8, "set_rappel_dof" },
    { 0x220FB26D, "set_react_ai_goals" },
    { 0x35A2BE6F, "set_react_anim_time" },
    { 0xF8F10B07, "set_recapture_zombie_attack_target" },
    { 0xEBE77E8C, "set_recent_stat" },
    { 0xB10896AA, "set_redo" },
    { 0x53ECA751, "set_relay_station_fog" },
    { 0x9DABED87, "set_rendezvous_fog_and_vision" },
    { 0x95D9F566, "set_rescue_guy_pos" },
    { 0x34416618, "set_reveal_enemy" },
    { 0x4C0433B2, "set_reveal_self" },
    { 0x31FC9F0A, "set_reverb_drylevel" },
    { 0x3693E900, "set_reverb_fadetime" },
    { 0x06B5A7DD, "set_reverb_priority" },
    { 0xA2069D28, "set_reverb_roomtype" },
    { 0x5D16494B, "set_reverb_wetlevel" },
    { 0x942E67CC, "set_ricochet_protection_endtime" },
    { 0x4750264C, "set_risetosurface_base_fog" },
    { 0x9A4B4A9E, "set_risetosurface_water_fog" },
    { 0x50E83569, "set_road_fog" },
    { 0x526FB1CE, "set_rocket_count" },
    { 0x223FD298, "set_rocket_hallway_vision" },
    { 0x770318A4, "set_rocketguy_ammo" },
    { 0xFDDC5FE6, "set_rocketshield_ammo" },
    { 0xDBC36E92, "set_role" },
    { 0x10C819DB, "set_rope_collision" },
    { 0xF00803F7, "set_rotate_og_angles" },
    { 0xD588BD91, "set_roulettefogenter_trigger" },
    { 0x9B8ADC27, "set_roulettefogexit_trigger" },
    { 0x670A91B2, "set_round" },
    { 0xCECCF08E, "set_round_number" },
    { 0xF53A4B7E, "set_rts_fog" },
    { 0xCF81B8B2, "set_rts_fps_fog" },
    { 0x5F3AE1B7, "set_run_anim" },
    { 0xF752BF09, "set_run_speed" },
    { 0x66508F36, "set_run_speed_easy" },
    { 0x43379134, "set_runway_cam_cuts_dof" },
    { 0x47523D88, "set_runway_dof" },
    { 0x64C0C79F, "set_runway_fog" },
    { 0xA14264D8, "set_rusher_type" },
    { 0x189AE9DB, "set_sam_ext_context" },
    { 0x08F8F2A1, "set_sam_int_context" },
    { 0xF2EDDA7E, "set_screecher_zone_origin" },
    { 0x63113B89, "set_screen_fade_timer" },
    { 0x46E56FC3, "set_script_flags" },
    { 0x662AB7E0, "set_seat_occupied" },
    { 0xC500027D, "set_second_charge" },
    { 0x97E2E9D5, "set_secondary_offhand" },
    { 0x2E005DEE, "set_security_fastforward_visuals" },
    { 0xB3C3C1D5, "set_security_fog" },
    { 0xE8AE9AB4, "set_security_lights" },
    { 0xA01ECE12, "set_security_visuals" },
    { 0x1ADA43BE, "set_see2_threat_bias" },
    { 0xBF5202C8, "set_see_from_tag_flash" },
    { 0x06446F90, "set_sentinel_drone_enemy" },
    { 0x7D309AEB, "set_sergei_script_settings" },
    { 0x87218E55, "set_shader" },
    { 0x060950D1, "set_shader_position" },
    { 0xC034338D, "set_shield_flicker_status" },
    { 0x882D46AB, "set_ship_interior_fog_and_vision" },
    { 0xF374C6FC, "set_showcase_weapon" },
    { 0x047C2F00, "set_side_maxis" },
    { 0x9D7E9ED2, "set_side_richtofen" },
    { 0xE672A8AD, "set_side_turrets_enabled" },
    { 0x14F285C9, "set_sidequest_completed" },
    { 0x6F8E1DC9, "set_silent_context" },
    { 0xF578C05A, "set_skipto_cleanup_func" },
    { 0x7FD80E28, "set_sky_fog" },
    { 0x26E0B5D7, "set_slide_1_dof" },
    { 0x98C7CCB4, "set_slide_2_dof" },
    { 0xA163803A, "set_slide_4_dof" },
    { 0x174794C0, "set_slide_6_dof" },
    { 0xADB92A4B, "set_slingshot_weights" },
    { 0xF4A04902, "set_slums_at_cover_ai_params" },
    { 0x5472422B, "set_slums_moving_ai_params" },
    { 0x810B01C7, "set_snapshot_at_start" },
    { 0x874ECD3A, "set_sneak_walk" },
    { 0x8A9903A6, "set_sniper_turret_zoom" },
    { 0xB5FD1C41, "set_soct_boost" },
    { 0x808B5507, "set_soct_damage_hi" },
    { 0x447FCC70, "set_soct_damage_low" },
    { 0x2E87A004, "set_soct_damage_med" },
    { 0x2F961424, "set_sound_context_defaults" },
    { 0x5B4DC7D4, "set_spawncount" },
    { 0x8E36789D, "set_spawner_targets" },
    { 0xDFF934FC, "set_spawner_variables" },
    { 0x14FC896A, "set_special_node_search_radius" },
    { 0x5E40C6FA, "set_specialties" },
    { 0x02F44EE2, "set_specular_scale" },
    { 0xD0C07F53, "set_speed" },
    { 0x2CD72401, "set_speed_immediate" },
    { 0x9E07A6E7, "set_speed_limit_zones" },
    { 0x5A81B663, "set_speed_then_reset" },
    { 0xB213DB0A, "set_speeding_osprey" },
    { 0xB2B16021, "set_split_flag_on_goal" },
    { 0x02FCAAD3, "set_splitscreen_fog" },
    { 0x1814140A, "set_sprint" },
    { 0x43AC43E5, "set_sq_ll_show_code" },
    { 0x182DD46F, "set_sq_ows_start" },
    { 0x44A6AA8A, "set_sq_ts_quickset" },
    { 0xCC8BDCEE, "set_squad_blood_impact" },
    { 0x8CD10093, "set_squad_cqb" },
    { 0x5FFD9662, "set_squad_goal" },
    { 0x647E2C56, "set_stables_lock_trigger_status" },
    { 0xB9676730, "set_stage_time_limit" },
    { 0x708B08C9, "set_stances" },
    { 0xFF8C5D2B, "set_standard_flashlight_values" },
    { 0x5F4F32BD, "set_standard_spotlight_values" },
    { 0x30F33531, "set_standing_animarray_aiming" },
    { 0x441F161D, "set_start_day" },
    { 0x32DA845F, "set_start_enemies" },
    { 0xB3C6E00C, "set_start_music_state" },
    { 0x23DDE29A, "set_start_objective" },
    { 0x7F1DBD69, "set_start_pos" },
    { 0x4F80AF10, "set_start_position" },
    { 0x5670A616, "set_startup_vars" },
    { 0xEBF3BBBC, "set_stat" },
    { 0xFA59CC99, "set_state" },
    { 0xCB72AAE2, "set_state_active" },
    { 0x1F8FB8C4, "set_state_arriving" },
    { 0x3DD52FE8, "set_state_hidden" },
    { 0xAF43C33F, "set_state_inactive" },
    { 0x42295108, "set_state_initial" },
    { 0xFCF61F94, "set_state_leaving" },
    { 0xD05DA5ED, "set_state_power_on" },
    { 0x7613F484, "set_static" },
    { 0xA524D70D, "set_static_alpha" },
    { 0x6FED04DF, "set_static_amount" },
    { 0x355720C7, "set_static_postfxbundle" },
    { 0x2358DA67, "set_statstable_id" },
    { 0x16E7F4F9, "set_steiner_window_model" },
    { 0xFD57EA4E, "set_stored_weapondata" },
    { 0x8529C4BA, "set_story_stat" },
    { 0x7B4773E9, "set_stowed_weapon" },
    { 0x08BFC76E, "set_straffing_drones" },
    { 0x1CDB868A, "set_street_fog" },
    { 0x325743EB, "set_street_objective" },
    { 0x346E10E7, "set_strength_test_audio" },
    { 0xCB48284F, "set_strengthtest_difficulty" },
    { 0x5D60E278, "set_sun_shadow_split_distance" },
    { 0x65EF6FA4, "set_sunlight" },
    { 0x4F45A775, "set_suppression_off" },
    { 0x344B2991, "set_survival_stat" },
    { 0x2DA5125F, "set_swap_reznov_flag" },
    { 0x934D79A8, "set_swimming_depth_of_field" },
    { 0x6E778975, "set_swimming_vision_set" },
    { 0x207F7798, "set_swing_angle" },
    { 0xD0BE8C91, "set_switch_node" },
    { 0xA29E7200, "set_switch_timer" },
    { 0x07ADE4F1, "set_switch_weapon" },
    { 0x8990D010, "set_takedamage" },
    { 0x476DDCCD, "set_talker" },
    { 0xB6D0E766, "set_talker_until_msg" },
    { 0xFC725F0E, "set_tank_accuracy" },
    { 0x75B7A754, "set_tanker_idle_yaw" },
    { 0x16045F9D, "set_target" },
    { 0xEA65FA55, "set_target_ent_array" },
    { 0x0109C9F9, "set_target_flags" },
    { 0x41C07B57, "set_target_id" },
    { 0x8B3B201E, "set_target_leading" },
    { 0xE9960F0E, "set_targetname_to_noteworthy" },
    { 0x74F0A2DC, "set_targets" },
    { 0x5CE63E47, "set_targets_visible" },
    { 0xBEE52CB5, "set_tarmac_fog" },
    { 0x05F6E4F2, "set_tarmac_visuals" },
    { 0x11AEFAB5, "set_team" },
    { 0xAE15C459, "set_team_kill_penalty_scale" },
    { 0xF230F7BF, "set_team_pacifist" },
    { 0x43027BEC, "set_team_radar" },
    { 0xC9615F34, "set_team_score_hud" },
    { 0x4665F5A1, "set_team_use_text" },
    { 0x0D01EBA7, "set_team_use_time" },
    { 0xB8C81FF2, "set_teamgather_complete" },
    { 0xCC61FF9A, "set_teleporter_message" },
    { 0xCFCFCCB0, "set_temp_music" },
    { 0x7C166FC1, "set_temp_stat" },
    { 0x49FF923A, "set_text_creek_1" },
    { 0x5A67410F, "set_text_crossroads" },
    { 0xAB14026E, "set_text_flashpoint" },
    { 0x5A06B72C, "set_text_fullahead" },
    { 0x30E3EC4C, "set_text_inc_squad_urban" },
    { 0x0FA60529, "set_text_quagmire" },
    { 0xFFEA84D7, "set_third_person" },
    { 0x77724C2E, "set_threat" },
    { 0x96387FAD, "set_threat_bias_group_for_barge_ai" },
    { 0x17C1114D, "set_threatbias" },
    { 0xC57B0199, "set_threatbias_group" },
    { 0x50BE68B2, "set_threatbiasgroup" },
    { 0x874785DA, "set_time_scale_for_time" },
    { 0x5EB0E12B, "set_timeout" },
    { 0xC1613F8D, "set_timer" },
    { 0x738472D5, "set_timescale" },
    { 0xBBF093E6, "set_to_animation" },
    { 0x4A29C3E3, "set_to_animtree" },
    { 0x2F8F145F, "set_to_compound_fight_flags_and_notify_ai" },
    { 0xB95C52CD, "set_to_goal" },
    { 0xE9C3870B, "set_to_player" },
    { 0x5FA0EF55, "set_torso_targetting" },
    { 0x184D69C1, "set_total_score_hud" },
    { 0xAFB63EA4, "set_training_speed" },
    { 0x6A103D94, "set_transit_wind" },
    { 0xF2BD87D8, "set_trap_spears" },
    { 0xA97FFA41, "set_treasure_chest_cost" },
    { 0x285603D2, "set_trigger_flag_permissions" },
    { 0xE9D5FA52, "set_trophy_state" },
    { 0xACE343B9, "set_tunnelexit_trigger" },
    { 0xE392C48E, "set_tunnels_gas_off_fog" },
    { 0x9372545A, "set_tunnels_gas_on_fog" },
    { 0x25A405F4, "set_turret_best_target_func" },
    { 0x14D6ADB5, "set_turret_best_target_func_from_weapon_type" },
    { 0x283E6D2E, "set_turret_burst_parameters" },
    { 0xD9998852, "set_turret_callback" },
    { 0xFC5D19E9, "set_turret_ignore_ent_array" },
    { 0x6F1A7DA0, "set_turret_ignore_line_of_sight" },
    { 0x87822239, "set_turret_manual" },
    { 0x420A88FD, "set_turret_max_target_distance" },
    { 0xEC8B5102, "set_turret_occupy_no_target_time" },
    { 0xC34B3AF0, "set_turret_on_target_angle" },
    { 0xD0499B38, "set_turret_target" },
    { 0x8875F78E, "set_turret_target_by_name" },
    { 0x09D42544, "set_turret_target_ent_array" },
    { 0x3343FAB4, "set_turret_target_flags" },
    { 0xAEAC10C4, "set_turret_team" },
    { 0x4F5F59FA, "set_type" },
    { 0xF5ABB44D, "set_ui3d" },
    { 0x2E92DAA7, "set_uimapname" },
    { 0x8D68A428, "set_umbilical_fog_and_vision" },
    { 0xEE8E211A, "set_underwater_base_fog" },
    { 0xD73E42E0, "set_unitrigger_hint_string" },
    { 0x37548D12, "set_up_images" },
    { 0xA806359B, "set_up_lighting_for_cod" },
    { 0x395E6298, "set_up_map_room" },
    { 0x5D711252, "set_up_right_path_blockers" },
    { 0x6297CD75, "set_use_hint_text" },
    { 0x1BF6799B, "set_use_text" },
    { 0xDF0E9E69, "set_use_time" },
    { 0x2698B54F, "set_val" },
    { 0xD2EF5FFF, "set_value_for_player" },
    { 0x94D42E0C, "set_values" },
    { 0xE352E181, "set_variables" },
    { 0x361A1A39, "set_vectarget_id" },
    { 0x036608F5, "set_vehicle_anims" },
    { 0x0B10771D, "set_vehicle_anims_ultimate" },
    { 0x9095AEF9, "set_vehicle_damage_override" },
    { 0x90BBA81E, "set_vehicle_drivable_time" },
    { 0x1C60F8BC, "set_vehicle_drivable_time_starting_now" },
    { 0x48D3658A, "set_vehicle_rappel_anims" },
    { 0x9830B7D6, "set_vehicle_speed" },
    { 0xA4EC71FF, "set_vehicle_unusable_in_scene" },
    { 0xFBC9BDF0, "set_vehicleriders_bundle" },
    { 0xE1E56EDD, "set_village_art_values" },
    { 0x888E970A, "set_village_fog_setting" },
    { 0xD96AD687, "set_visible_carrier_model" },
    { 0xBD903F5C, "set_visible_team" },
    { 0x3F7E12BE, "set_vision_bloom" },
    { 0x212F36D9, "set_vision_cage" },
    { 0xA3C9F1E2, "set_vision_cave" },
    { 0xAC61ADCC, "set_vision_clearing" },
    { 0x05210814, "set_vision_endtable" },
    { 0x8BD2EF5B, "set_vision_set" },
    { 0xD757FDDE, "set_vision_tunnels" },
    { 0x89C9CEFB, "set_visionset_idle" },
    { 0x1E7FAA06, "set_visionset_lab" },
    { 0x75548A65, "set_visionset_office" },
    { 0xCCEA3D0C, "set_visionset_run" },
    { 0x34EDF7A9, "set_visionset_tech" },
    { 0xB2BC3818, "set_visionset_warroom" },
    { 0xD9087724, "set_vol_fog" },
    { 0xAA69BA8C, "set_vulture_drop_fx" },
    { 0x19795434, "set_vulture_overlay" },
    { 0xDF2166DF, "set_wait_for_notify" },
    { 0x81605E22, "set_wait_for_players" },
    { 0xF191039F, "set_wait_time" },
    { 0xCCFDC6D5, "set_walkdist" },
    { 0x8F380B72, "set_walkerpos" },
    { 0xAEAE4FFF, "set_war_room_fog" },
    { 0xFB3A0BE0, "set_warroom_fog" },
    { 0x11196A47, "set_warroom_visuals" },
    { 0xFE9D5F0D, "set_water_dvar" },
    { 0x4C3E3E8C, "set_water_dvars" },
    { 0x6778CE0F, "set_water_dvars_drone" },
    { 0x7922091F, "set_water_dvars_flatten_surface" },
    { 0x7680A46F, "set_water_dvars_market" },
    { 0x0071AD17, "set_water_dvars_sewer" },
    { 0xCCEC01E6, "set_water_dvars_strafe" },
    { 0xB3FB6ADE, "set_water_dvars_street" },
    { 0x7B94641B, "set_water_dvars_swim" },
    { 0x05206537, "set_water_dvars_swim_section" },
    { 0xEF30BDA3, "set_water_height" },
    { 0x9185C7E3, "set_waypoint" },
    { 0x06CE525F, "set_wc_icon_cosmetic_variants" },
    { 0xE02C8294, "set_wc_icon_weapon_options" },
    { 0x98372949, "set_weapon_ignore_max_ammo" },
    { 0x8360FAD4, "set_weapon_in_use" },
    { 0xF3037B75, "set_weapon_options" },
    { 0x70B16BFB, "set_weapon_stat" },
    { 0xC6592F0E, "set_weather_to_player" },
    { 0xC5BCF66B, "set_weaverbuilding_fog" },
    { 0xF4E5D371, "set_white_body_models" },
    { 0xFD03E2BC, "set_wind" },
    { 0x0B7B2838, "set_wind_effect" },
    { 0x66D2AEFA, "set_wind_value" },
    { 0x04ED59A0, "set_winnings_on_players" },
    { 0x7646206B, "set_world_map_icon" },
    { 0xA607B4B6, "set_world_map_marker" },
    { 0x412131FA, "set_world_map_rotation" },
    { 0x30B353AE, "set_world_map_scale" },
    { 0x4F860F07, "set_world_map_tint" },
    { 0xDF3ABCF1, "set_world_map_translation" },
    { 0xAA4E673C, "set_world_map_widget" },
    { 0x194BBC18, "set_wounded_auto_delete" },
    { 0xD73F76E4, "set_x_offset" },
    { 0x429DD64E, "set_xcam_specs" },
    { 0x34EE403B, "set_y_offset" },
    { 0xC1746AEB, "set_yellow_awning" },
    { 0xDF0D71F0, "set_yellow_patio" },
    { 0x6E01D282, "set_z_offset" },
    { 0x7D424DEA, "set_zodiac_exit_ads" },
    { 0xBE9C5C4B, "set_zodiac_overlay" },
    { 0x365BE7BF, "set_zombie_controlled_area" },
    { 0xAF7EE316, "set_zombie_controlled_zone" },
    { 0x0B5E8368, "set_zombie_gibbed" },
    { 0xF8552521, "set_zombie_melee_anim_state" },
    { 0xBE6F5AF7, "set_zombie_on_tank" },
    { 0x1C7585D1, "set_zombie_run_cycle" },
    { 0x56A35BCA, "set_zombie_run_cycle_override_value" },
    { 0xFBD07378, "set_zombie_run_cycle_restore_from_override" },
    { 0xAA966A7E, "set_zombie_var" },
    { 0xB09AFD1E, "set_zombie_var_once" },
    { 0xF15A7DA7, "set_zoom" },
    { 0x3129329F, "setaarstat" },
    { 0x07F79DF7, "setacceleration" },
    { 0xD11E9610, "setactionbuttonstate" },
    { 0xE44230BC, "setactionbuttontimer" },
    { 0x23E013B9, "setactionslot" },
    { 0x77A50F1C, "setactivegrenadetimer" },
    { 0xA6DFEEFD, "setactiveremotecontrolledweapon" },
    { 0xFCE65C7E, "setactorweapon" },
    { 0x96731AAF, "setadswidthandlerp" },
    { 0x3C7E2A60, "setadvertisedstatus" },
    { 0x0E524675, "setafteractionreportstat" },
    { 0x3051C25F, "setaiattribute" },
    { 0xE153339C, "setaicurrentweapon" },
    { 0x40926D5D, "setaifootstepprepend" },
    { 0x2CE503CE, "setailimit" },
    { 0xF2B25268, "setaimanimweights" },
    { 0x1635B720, "setaiminganims" },
    { 0x9059F2E8, "setaimingparams" },
    { 0x225EA2B2, "setairresistance" },
    { 0xF99D84C0, "setaispread" },
    { 0x9B4696DE, "setaitankhrustersstate" },
    { 0xA3330FB4, "setallowedstances" },
    { 0xAE96B2F3, "setallowxcamrightstickrotation" },
    { 0x0E9799E6, "setallvehiclefx" },
    { 0xE282A349, "setalphafadeforname" },
    { 0x3AF186DB, "setambientpackage" },
    { 0xD0FD4DCD, "setambientroomcontext" },
    { 0x1605FAF3, "setambientroomcontextengine" },
    { 0x07D94088, "setambientroomreverb" },
    { 0xE929228F, "setambientroomsidechainduck" },
    { 0x155204A8, "setambientroomsnapshot" },
    { 0x203A5EA4, "setambientroomtone" },
    { 0x9EF19D34, "setambientsidechainduck" },
    { 0xC66F0311, "setambientsnapshot" },
    { 0x30C75E1F, "setambienttrigger" },
    { 0x7867D88D, "setammo" },
    { 0x462167DD, "setammocounts" },
    { 0xD064AA4A, "setangularvelocity" },
    { 0x1BF01240, "setanim" },
    { 0xBA4DA757, "setanimaimweight" },
    { 0x820E2687, "setanimarray" },
    { 0x2D7E91BF, "setanimationonmodel" },
    { 0x253E6051, "setanimcurrframecount_for_current_shot" },
    { 0xAAB140E8, "setanimh" },
    { 0x84EEAE44, "setanimknob" },
    { 0x14D26175, "setanimknoball" },
    { 0xABF3F157, "setanimknoballh" },
    { 0x9EA679BA, "setanimknoballrestart" },
    { 0xE8DDD88A, "setanimknoblimited" },
    { 0x6191D5E3, "setanimknoblimitedrestart" },
    { 0xC4EC5D75, "setanimknobrestart" },
    { 0xCAC4B126, "setanimlimited" },
    { 0xC2D085AD, "setanimlookweight" },
    { 0x45621429, "setanimmode" },
    { 0xAABE348B, "setanimratecomplete" },
    { 0xCCDE77B1, "setanimrestart" },
    { 0x3CD3522F, "setanimrestart_once" },
    { 0x4CCC836B, "setanims" },
    { 0x55A44891, "setanims_land" },
    { 0x0D0AFBC1, "setanimspecial" },
    { 0x8791394F, "setanimstate" },
    { 0xE488E531, "setanimstatefromasd" },
    { 0xD9219E20, "setanimstatefromspeed" },
    { 0x11E7847B, "setanimtime" },
    { 0x20A75051, "setanimtimebyname" },
    { 0x81840BB8, "setanimtree" },
    { 0xF9258FF8, "setanimtype" },
    { 0x1242830F, "setarchive" },
    { 0x760B3005, "setarenapoints" },
    { 0x1127662C, "setattachmentcosmeticvariantindex" },
    { 0xB1D5CCA0, "setattachmentcosmeticvariantindexes" },
    { 0x257C943E, "setattachmentstat" },
    { 0xBA14BE7A, "setattacker" },
    { 0x6AE158F6, "setautopickup" },
    { 0xD044A598, "setavailable" },
    { 0xBAEB4BE7, "setavoidancemask" },
    { 0x175320C9, "setbacks" },
    { 0x4008CBC5, "setbacksperdemotion" },
    { 0x8D2A7DF6, "setbackweapon" },
    { 0xFFCB77F8, "setbasenewstatus" },
    { 0xFF1D4A84, "setbattlechatter" },
    { 0xFBE55294, "setblackboardattribute" },
    { 0x44CFC81D, "setblackhot" },
    { 0x401775C2, "setblockweaponpickup" },
    { 0x763A0B18, "setblur" },
    { 0xE13B348F, "setblurbylocalclientnum" },
    { 0x585981E7, "setbodyrenderoptions" },
    { 0xF7E94B21, "setbomboverheatingafterweaponchange" },
    { 0xA8E8355A, "setbombtimer" },
    { 0xF187DA5A, "setbottomarc" },
    { 0xC014D7A0, "setbrake" },
    { 0x2E5BF5B0, "setbuoyancyoffset" },
    { 0x04603618, "setburn" },
    { 0xC39FD8BA, "setbusfadetime" },
    { 0x7C3C7312, "setbusses" },
    { 0x2314A5FE, "setbusstate" },
    { 0x368ACFB9, "setbusvolume" },
    { 0xBD7BFBB8, "setcachedperks" },
    { 0x56A82186, "setcameraspikeactive" },
    { 0xCB98C55E, "setcamostate" },
    { 0x1A0C8AD9, "setcanbeflanked" },
    { 0x8D63F8D0, "setcandamage" },
    { 0x399F630C, "setcanuse" },
    { 0xD4ED2565, "setcarrier" },
    { 0xC5CEE451, "setcarriervisible" },
    { 0xC95BF2B3, "setcarryicon" },
    { 0xC155FA75, "setcarryingqrdrone" },
    { 0x72509A87, "setcategorytypeweight" },
    { 0x6761B27B, "setcellinvisibleatpos" },
    { 0x882136B2, "setcellvisibleatpos" },
    { 0x44050D8B, "setchallengeorstat" },
    { 0x431B00F3, "setcharacterbodystyle" },
    { 0x62C34A4C, "setcharacterbodytype" },
    { 0xC6E2EA52, "setcharacterhelmetstyle" },
    { 0x4A577034, "setcharacterindex" },
    { 0xE300A146, "setcheapflag" },
    { 0x496F897A, "setclaimteam" },
    { 0x93A49C9D, "setclass" },
    { 0x1D84AF77, "setclassnum" },
    { 0x863D6BB0, "setclearanceceiling" },
    { 0x94EF8D4C, "setclientaimlockonpitchstrength" },
    { 0x88B2E6A4, "setclientammocounterhide" },
    { 0x09102FEC, "setclientcgobjectivetext" },
    { 0xA7F4D126, "setclientcompass" },
    { 0xA5385772, "setclientdrawtalk" },
    { 0x75D35331, "setclientdvar" },
    { 0x5B1B7A98, "setclientdvars" },
    { 0x40668FCE, "setclientfield" },
    { 0x96632F9A, "setclientfieldtoplayer" },
    { 0x474E62E0, "setclientflag" },
    { 0x57FE2C9D, "setclientflagasval" },
    { 0x31FB0A1B, "setclientfov" },
    { 0xA16313AB, "setclienthudhardcore" },
    { 0x74268EBD, "setclientminiscoreboardhide" },
    { 0x7C73E78E, "setclientnamemode" },
    { 0x579369BF, "setclientnumlives" },
    { 0x4BF349E5, "setclientplayerpushamount" },
    { 0x329CE926, "setclientplayersprinttime" },
    { 0xD7812975, "setclientscriptmainmenu" },
    { 0xC9EA7A64, "setclientsysstate" },
    { 0x241D0EAE, "setclientthirdperson" },
    { 0x1A276E5B, "setclientthirdpersonangle" },
    { 0xD8F391D6, "setclienttweakable" },
    { 0x1B947E2A, "setclientuivisibilityflag" },
    { 0x4F525632, "setclientvolumetricfog" },
    { 0xFB3672CA, "setclingtriggervisibility" },
    { 0x8E003A57, "setclock" },
    { 0xAB3FE756, "setclone" },
    { 0xDE0948D6, "setcod7decodefx" },
    { 0x81238668, "setcodpointsstat" },
    { 0xAE2A5F5B, "setcollectible" },
    { 0xCD9BF989, "setcolorelem" },
    { 0x3131EE4A, "setcompassicon" },
    { 0x553B6A36, "setconstants" },
    { 0xA9DCD549, "setcontents" },
    { 0xC7016241, "setcontrollerlightbarcolor" },
    { 0xA9B702D5, "setcontrollerlightbarcolorpulsing" },
    { 0xF2E7970F, "setcontrolleruimodelvalue" },
    { 0x679C0175, "setconvergencetime" },
    { 0xD83F0F07, "setcopterdefensearea" },
    { 0x2C2DE39C, "setcopterdest" },
    { 0x535C24B3, "setcornerdirection" },
    { 0x7A94BFE2, "setcorpsegibstate" },
    { 0xADD0D5CC, "setcount" },
    { 0x0E202C1C, "setcovershootstarttime" },
    { 0x8A3FF3FA, "setctfaway" },
    { 0xFF5E52FB, "setculldist" },
    { 0xF946F6FD, "setcullfog" },
    { 0x0D21BED7, "setcurbstompcharacter" },
    { 0x8DCDC407, "setcurrentaiambientstate" },
    { 0xBF7A67A1, "setcurrentambientstate" },
    { 0xDAEAF427, "setcurrentgroup" },
    { 0x3E3799AC, "setcurrentspectatorclient" },
    { 0x42EEACDE, "setcurrentweapon" },
    { 0x33603145, "setcurrentweaponspinlerp" },
    { 0xE68EE88A, "setcursorhint" },
    { 0x491957B9, "setcurvebspline" },
    { 0x5E063976, "setcurvenotifyent" },
    { 0x46DF4F26, "setcurvesmooth" },
    { 0x4EFAA57D, "setcurvespeed" },
    { 0x47B1FD1D, "setcvar" },
    { 0xACE111F5, "setcybercomability" },
    { 0x8F532E96, "setdamagedirectionindicator" },
    { 0x10686B8A, "setdamagestage" },
    { 0xC35DFA59, "setdangerous" },
    { 0x6CDFE3B3, "setddlstat" },
    { 0x4CD48A93, "setdeadquote" },
    { 0xAA7ADAD1, "setdeathcontents" },
    { 0x513459D8, "setdebugangles" },
    { 0x645AE3BE, "setdebugorigin" },
    { 0xAF8821A9, "setdebugsideswitch" },
    { 0xC296DAE4, "setdecaytime" },
    { 0xA9564502, "setdeceleration" },
    { 0xB97730BE, "setdedicatedshadow" },
    { 0x957CFFD2, "setdefaultcallbacks" },
    { 0xBD35742A, "setdefaultdepthoffield" },
    { 0xBFAEC65D, "setdefaultdroppitch" },
    { 0x7CE0FFC4, "setdefaultpitch" },
    { 0x9EB6E484, "setdemointermissionpoint" },
    { 0x2E82B416, "setdemolockonvalues" },
    { 0x0DC5518F, "setdepthoffield" },
    { 0xC5E9E6FF, "setdesiredstanceformovement" },
    { 0x99E19E1E, "setdesiredstancetocrouch" },
    { 0x9E05346C, "setdesiredstancetostand" },
    { 0xBAC300C0, "setdifficulty" },
    { 0x74D15397, "setdiffstructarrays" },
    { 0xCD601072, "setdof" },
    { 0xE35CB5F5, "setdoftarget" },
    { 0x4FACDA28, "setdooropendelay" },
    { 0xF9F10A18, "setdoublejumpenergy" },
    { 0x8AAC71C0, "setdoublevision" },
    { 0x6B69EDE6, "setdrawinfrared" },
    { 0xB18B3A98, "setdrawname" },
    { 0x66A3677F, "setdrivepathphysicsscale" },
    { 0xE7DDEE0F, "setdropped" },
    { 0x8F67433B, "setdstat" },
    { 0x6C1294B8, "setdvar" },
    { 0x76E8D7A8, "setdvarbool" },
    { 0x59A72216, "setdvarfloat" },
    { 0x41F52997, "setdvarifundefined" },
    { 0xA64586EB, "setdvarint" },
    { 0x24023F66, "setdvars_based_on_varibles" },
    { 0x2776612B, "setdynentbodyrenderoptionspacked" },
    { 0x0BDA346A, "setdynentenabled" },
    { 0x30A95FE7, "setelectrified" },
    { 0xDAC5B79A, "setelectrifiedstate" },
    { 0xE03F37F6, "setelemalpha" },
    { 0x133CB667, "setelemcolor" },
    { 0x8394B907, "setelempoints" },
    { 0x6185F4D9, "setempjammed" },
    { 0xF4F56901, "setemptydvar" },
    { 0xD224409E, "setenablenode" },
    { 0xB2252D04, "setenablesense" },
    { 0xA9C5A3BE, "setenemyaccuracy" },
    { 0xB17B1065, "setenemyglobalscrambler" },
    { 0x2B6F0128, "setenemymodel" },
    { 0x77A67822, "setenemyscrambleramount" },
    { 0xC17A57A6, "setenemytoolowtoattack" },
    { 0xAF8DB5F0, "setengagementmaxdist" },
    { 0x6B48F31A, "setengagementmindist" },
    { 0x1B34354F, "setenginevolume" },
    { 0x9AE08D74, "setentertime" },
    { 0xEB593C1B, "setentgravitytrajectory" },
    { 0xFDE3533B, "setentityanimrate" },
    { 0xD7970FFF, "setentityheadicon" },
    { 0x4501C87C, "setentityheadiconshiddenwhilecontrolling" },
    { 0x41E2B60F, "setentityowner" },
    { 0x2D1EACB8, "setentitypaused" },
    { 0x21F41D11, "setentitytarget" },
    { 0xC51E2ADE, "setentityweapon" },
    { 0x28A5CD6C, "setenv" },
    { 0x507CDFA9, "seteq" },
    { 0xD74C861E, "seteqlerp" },
    { 0x0B99D72B, "seteverhadweaponall" },
    { 0x9B6D5FFB, "setexcludeteamfortrigger" },
    { 0x60CC9E2F, "setexertvoice" },
    { 0xA3C3DB68, "setexpfog" },
    { 0xAE0A0973, "setexploderid" },
    { 0x69B16290, "setextracam" },
    { 0xD07DF00E, "setextracamactive" },
    { 0xCF581130, "setextracamangles" },
    { 0xD883C6D1, "setextracamentity" },
    { 0xEB15F869, "setextracamfov" },
    { 0xA123FFD6, "setextracamorigin" },
    { 0xB1B17AB5, "setextracamrenderready" },
    { 0x6469F502, "setextracamstatic" },
    { 0xC2D0EE14, "setfaceroot" },
    { 0x971BCFA3, "setfacestate" },
    { 0x95A6D73F, "setfakeentorg" },
    { 0x9BA69B38, "setfakefire" },
    { 0x2D260E0F, "setfakeplayeranims" },
    { 0xC2E7B09D, "setfakeplayerverticalanims" },
    { 0x8D3C3170, "setfilterconstants" },
    { 0x2375D572, "setfilterpasscodetexture" },
    { 0xA7A4F1AE, "setfilterpassconstant" },
    { 0x4249AAE5, "setfilterpassenabled" },
    { 0xAC560C9D, "setfilterpassmaterial" },
    { 0x7800463A, "setfilterpassquads" },
    { 0x1B492F7F, "setfireloopmod" },
    { 0xB34C3F07, "setfirstmusicstate" },
    { 0x18893C32, "setfixednodesafevolume" },
    { 0xCA9B8535, "setflag_on_notify" },
    { 0xAA084DE5, "setflag_ontrig" },
    { 0xE1A5EEC7, "setflagasaway" },
    { 0xC322AE34, "setflaggedanim" },
    { 0x7D9C3F48, "setflaggedanimknob" },
    { 0x7EB4F501, "setflaggedanimknoball" },
    { 0x88B7C4AB, "setflaggedanimknoballh" },
    { 0x98CAEF56, "setflaggedanimknoballrestart" },
    { 0x2F6A2847, "setflaggedanimknoblimitedrestart" },
    { 0xEB8E06E9, "setflaggedanimknobrestart" },
    { 0xCF5998FA, "setflaggedanimlimited" },
    { 0x8AE82DA5, "setflaggedanimrestart" },
    { 0xABFC6E65, "setflaginnsec" },
    { 0x0EE35766, "setflagowner" },
    { 0x9AB0EC54, "setflags" },
    { 0x6535C002, "setflashbanged" },
    { 0xE3E93627, "setflashbangimmunity" },
    { 0x33C6287F, "setflashfrac" },
    { 0x1ADF347B, "setflickering" },
    { 0xE61ED21D, "setfogsliders" },
    { 0x5ACA2F62, "setfootstepeffect" },
    { 0x1DCC12D2, "setforceads" },
    { 0x97527381, "setforcecolor" },
    { 0x8D997A39, "setforcecolornotifyent" },
    { 0xFAE267D9, "setforcecolornotifymsg" },
    { 0xBFD1ACD6, "setforcecolortime" },
    { 0x9D33ABE8, "setforcecolorvalue" },
    { 0xFEF374CD, "setforcenocull" },
    { 0xA496540D, "setforcenotsimple" },
    { 0x297FFAAE, "setfovforkillcam" },
    { 0x4DB1EF36, "setfreecameralockonallowed" },
    { 0x8A7731A1, "setfriendlychain" },
    { 0x4479538B, "setfriendlyflags" },
    { 0x66F262BE, "setfriendlyglobalchain" },
    { 0x07AE5E0B, "setfriendlyhacking" },
    { 0x420B3FB3, "setfriendlyscrambleramount" },
    { 0xD15FFE17, "setfriendlyspawn" },
    { 0x9F82AF3B, "setfriendlytargetlocked" },
    { 0x8427E69D, "setfriendlytargetting" },
    { 0x0EF318B3, "setfrontendstreamingoverlay" },
    { 0x6AF43DCB, "setfxignorepause" },
    { 0xC8A50E16, "setfxplayer" },
    { 0x667CBA7E, "setfxteam" },
    { 0xDC61703F, "setgameendtime" },
    { 0x21804F26, "setgamemodeinfopoint" },
    { 0x6896D21F, "setgametypesetting" },
    { 0xFABEAB99, "setgenericscenevalue" },
    { 0xAF10DFB7, "setgestureclientfield" },
    { 0xA0A1DDAE, "setgibfxtoignorepause" },
    { 0xA25B6686, "setglobalfriendlychain" },
    { 0x05F6F04B, "setglobalfutz" },
    { 0x169CC712, "setgoal" },
    { 0x7363B301, "setgoalenity" },
    { 0xC6F2CCCF, "setgoalentity" },
    { 0x363D832C, "setgoalentityforbuddies" },
    { 0xB696F3A1, "setgoalforbuddies" },
    { 0x156339B6, "setgoalnode" },
    { 0xAD4BAB8F, "setgoalnode_tn" },
    { 0xCCAEA265, "setgoaloverridecb" },
    { 0xE65887E4, "setgoalpos" },
    { 0xA44F8EA3, "setgoalposition" },
    { 0x1C1CB2CC, "setgoalradius" },
    { 0x86408AA8, "setgoalvolume" },
    { 0x08EC1BD9, "setgoalvolume_trigger" },
    { 0x03135F9D, "setgoalvolumeauto" },
    { 0x971F2CEB, "setgoalyaw" },
    { 0x98DD26A0, "setgpr" },
    { 0x202686C5, "setgrappeltarget" },
    { 0x514A8393, "setgrapplabletype" },
    { 0x37DD400F, "setgravity" },
    { 0x6F8F54D7, "setgrenademissreason" },
    { 0x02528ECE, "setgrenadetimer" },
    { 0x7FB21CAB, "setgroup_down" },
    { 0x8BBE5194, "setgroup_up" },
    { 0xF6C076A8, "setgroupsnapshot" },
    { 0x9AF49228, "setgunnertargetent" },
    { 0x6521EB5D, "setgunnertargetvec" },
    { 0x6E075BDF, "setgunnerturretontargetrange" },
    { 0x8EB2ED4D, "sethealth" },
    { 0x8DF8C61C, "sethealthpercent" },
    { 0x50319265, "sethealthsnapshot" },
    { 0x7204255A, "setheavyrain" },
    { 0x0D6A2BD6, "setheight" },
    { 0x0AD297B1, "setheldweaponmodel" },
    { 0x15A6B241, "sethelicopterenveffects" },
    { 0x92CC1E27, "setheliheightlock" },
    { 0xBCB42FEB, "setheliheightpatchenabled" },
    { 0xEC7687E0, "sethidegumpalpha" },
    { 0x5E8CB1F3, "sethideonclientwhenscriptedanimcompleted" },
    { 0xCEA50A94, "sethighdetail" },
    { 0x739EA922, "sethighlighted" },
    { 0x450EF073, "sethindtarget" },
    { 0x622A981A, "sethintlowpriority" },
    { 0xD5EB00E3, "sethintstring" },
    { 0xF9FDB2B0, "sethintstringforperk" },
    { 0x6786D459, "sethintstringnow" },
    { 0x38B4D4A9, "sethostmigrationstatus" },
    { 0x42CDDF81, "sethoverparams" },
    { 0x314283BD, "sethudoutlinecolor" },
    { 0x158C8F9E, "sethudwarningtype" },
    { 0x49AA6762, "sethudweapontype" },
    { 0x28CCAC2E, "seticonpos" },
    { 0xB5408B33, "seticonshader" },
    { 0xF88039E6, "setidleanimoverride" },
    { 0xED73C86E, "setidleface" },
    { 0xF695FB2C, "setidlefacedelayed" },
    { 0x76AA5B30, "setignoreent" },
    { 0x6C536553, "setignoreentfortrigger" },
    { 0x67DF0ABC, "setignoremegroup" },
    { 0x25B39BE3, "setignorepauseworld" },
    { 0xC74680BE, "setincludemeshes" },
    { 0x50EC476D, "setinflictorstat" },
    { 0xACD48CF7, "setinfluenceat" },
    { 0xF9395EB9, "setinfluencerteammask" },
    { 0xE2DB071B, "setinfluencertimeout" },
    { 0xE5727A6C, "setinfraredvision" },
    { 0xE525AE24, "setinfraredvisionset" },
    { 0x85221711, "seting" },
    { 0x3A2713BF, "setinitiallookaheadpoint" },
    { 0xFEB1B9C2, "setinitialplayersconnected" },
    { 0x77A60658, "setinterval" },
    { 0x7DB15EB1, "setinventoryuimodels" },
    { 0x4151475D, "setinventoryweapon" },
    { 0x8C1F7070, "setinvisibletoall" },
    { 0x64218FFC, "setinvisibletoplayer" },
    { 0x724EF16B, "setjitterparams" },
    { 0x87F4A352, "setjumpenabled" },
    { 0xE924B5B4, "setkeyforbinding" },
    { 0x7AF8CF11, "setkeyobject" },
    { 0xA1889D21, "setkillcamentity" },
    { 0xE4044BC4, "setkillstreaks" },
    { 0x713DDE05, "setkillstreakteamkillpenaltyscale" },
    { 0x3BAE2154, "setkillstreaktimer" },
    { 0x5F4250A8, "setlastgibtime" },
    { 0x06532223, "setlastkilledby" },
    { 0x927E3C75, "setlaststandprevweap" },
    { 0xA3C2D891, "setlaststoppedtime" },
    { 0xEF0A27F0, "setleftarc" },
    { 0x9B820A0E, "setlevelcompleted" },
    { 0xF242C20B, "setleveldvars" },
    { 0x88CB1F11, "setlevelfadesnapshot" },
    { 0x3A9A7962, "setlightarmor" },
    { 0x211DEEFA, "setlightarmorhp" },
    { 0x4A3B09AA, "setlightcolor" },
    { 0xAA540D24, "setlightexponent" },
    { 0xB2ACC211, "setlightfovrange" },
    { 0x73B1942A, "setlightingentity" },
    { 0xF0711E2E, "setlightingstate" },
    { 0x56547454, "setlightintensity" },
    { 0x77552B67, "setlightradius" },
    { 0xCA48E0C8, "setlitfogbank" },
    { 0x5BB28094, "setloadouticoncoords" },
    { 0x59B607F6, "setloadouttextcoords" },
    { 0xE71B2232, "setlocalprofilevar" },
    { 0x074CB0BF, "setlocalradarenabled" },
    { 0x34FF7E35, "setlocalradarposition" },
    { 0xD8920201, "setlocalwindsource" },
    { 0xBEAE610C, "setlookanims" },
    { 0xCEE25739, "setlookat" },
    { 0xBE2885F6, "setlookatcurve" },
    { 0x64DF9CC4, "setlookatdirection" },
    { 0xDF42C640, "setlookatent" },
    { 0x2B0821D0, "setlookatent_delay" },
    { 0xCC61D9B4, "setlookatentity" },
    { 0xB4518657, "setlookatorigin" },
    { 0x43316AAC, "setlookattext" },
    { 0x9561ACCE, "setlookatyawlimits" },
    { 0x98E1D594, "setloopstate" },
    { 0x002F2DBA, "setlov" },
    { 0x2631A823, "setlow" },
    { 0x3FC40C11, "setloweredweapon" },
    { 0xAD66EB43, "setlowermessage" },
    { 0x9468E63A, "setlowermessagevalue" },
    { 0x5E6740A8, "setlowready" },
    { 0x3A9588EA, "setluimenudata" },
    { 0x877B12B0, "setmapcenter" },
    { 0xE21AFD04, "setmaplatlong" },
    { 0x12EAC852, "setmatchcompletionstat" },
    { 0x9D2F1D78, "setmatchflag" },
    { 0x5842A60C, "setmatchhistorystat" },
    { 0xD6911678, "setmatchscorehudelemforteam" },
    { 0xD299F7A6, "setmatchtalkflag" },
    { 0x884384E0, "setmaterialoverride" },
    { 0xE9C65C5F, "setmaxaccelerationscale" },
    { 0xE7117EB1, "setmaxhealth" },
    { 0x6EE6A1FB, "setmaximumparamvalueforcurrentgame" },
    { 0x1491122A, "setmaxpitchroll" },
    { 0xCB2CBDAA, "setmaxspeedscale" },
    { 0x5660FE79, "setmeleeattackdist" },
    { 0x049F0D0D, "setmentranssnap" },
    { 0x3BE5C07E, "setmenu" },
    { 0x6F3974E9, "setmindesiredturnyaw" },
    { 0x59C04A9C, "setminimap" },
    { 0x59948314, "setminimumstidistance" },
    { 0xF6AA2402, "setmissilebrake" },
    { 0x51280BDF, "setmissilecoasting" },
    { 0x0F454892, "setmissileowner" },
    { 0x1F537FC4, "setmissiondvar" },
    { 0x38C1FBE0, "setmisstime" },
    { 0xD8D53744, "setmixerbehavior" },
    { 0x24BCF00E, "setmixerexploderid" },
    { 0x1927FC47, "setmixerl2rrampspeed" },
    { 0x6A31B1E8, "setmixerlightbehavior" },
    { 0x035CB963, "setmixerlightcolor" },
    { 0xDD27C403, "setmixerlightexponent" },
    { 0xB49928F2, "setmixerlightfovrange" },
    { 0xCB7ABBCD, "setmixerlightintensity" },
    { 0x18889188, "setmixerlightmodels" },
    { 0x34DFC4FD, "setmixerlightparam" },
    { 0x287B5ED4, "setmixerlightradius" },
    { 0xD2F5BF04, "setmixerlightrotatetime" },
    { 0x68F26DE1, "setmixerparam" },
    { 0x14C58097, "setmixerr2lrampspeed" },
    { 0x3C89DF9C, "setmixerspinmodels" },
    { 0x088D8066, "setmode" },
    { 0xE48F905E, "setmodel" },
    { 0xF9DDEF95, "setmodelfromarray" },
    { 0x51BD5FA8, "setmodellodbias" },
    { 0x962FDF36, "setmodelvisibility" },
    { 0x0AB73AC6, "setmovementspeedmodifier" },
    { 0x5A7DD25D, "setmovespeedscale" },
    { 0xB0B70ABB, "setmovingplatformenabled" },
    { 0xE2075153, "setmultiextracamactive" },
    { 0x3C85A52C, "setmusic" },
    { 0xC1CDEDFB, "setmusicstate" },
    { 0x60CE1787, "setnameandrank" },
    { 0xAE9F75A2, "setnearestenemyscrambler" },
    { 0x500DC2F7, "setneargoalnotifydist" },
    { 0xC3034D3F, "setnemesisxuid" },
    { 0x39E427CF, "setnewplayerchain" },
    { 0x6C19826E, "setnextdogattackallowtime" },
    { 0xB5FF43DB, "setnextfindbestcovertime" },
    { 0x804A4F4C, "setnextplayergrenadetime" },
    { 0x3F351014, "setnoclearance" },
    { 0xE17E9C98, "setnormalhealth" },
    { 0x7084CF30, "setnormalrain" },
    { 0xEA8DA1FD, "setnorthyaw" },
    { 0x77D1BD47, "setnpcid" },
    { 0xA7A109E6, "setobjectivehinttext" },
    { 0xE5BA71AD, "setobjectivelocation" },
    { 0x3983A8CC, "setobjectiveremaining" },
    { 0xF38B59C3, "setobjectivescoretext" },
    { 0xF9863A37, "setobjectivestate" },
    { 0x71906523, "setobjectivestring" },
    { 0xB5DEB01D, "setobjectivetext" },
    { 0xE4DFF7B5, "setobjectivetextcolors" },
    { 0xF2AAA6B3, "setoffhandprimaryclass" },
    { 0xF4552CD7, "setoffhandsecondaryclass" },
    { 0x93292BF9, "setoffhandvisible" },
    { 0x2EA2374C, "setontargetangle" },
    { 0x0A30814D, "setorigin" },
    { 0xAF29C3F3, "setoriginbyname" },
    { 0x2ED6231F, "setorunsetperk" },
    { 0xFDAEA7B6, "setoutsidevisionfile" },
    { 0x158E5C55, "setoverlayconstant" },
    { 0x87083818, "setoverlayenabled" },
    { 0xBFABF23E, "setoverlaymaterial" },
    { 0xD610622C, "setowner" },
    { 0x29B9AA1F, "setownerteam" },
    { 0xC989313F, "setparagoniconid" },
    { 0x9ED0E94D, "setparagonrank" },
    { 0x89140677, "setparent" },
    { 0xA2DA283C, "setpathmovedelayedrandom" },
    { 0xCC185A14, "setpathtransitiontime" },
    { 0xBEA2B721, "setpauseworld" },
    { 0xF5DA4BE4, "setperfectsense" },
    { 0x5D8FA337, "setperk" },
    { 0x59CBEB9C, "setperkfortrigger" },
    { 0xEDFEA518, "setperkicon" },
    { 0x45F8C36E, "setperks" },
    { 0x5D0E3D0A, "setpersistentprofilevar" },
    { 0x40452018, "setpersonalthreatbias" },
    { 0xB8573880, "setpfxcontext" },
    { 0x04F3C597, "setphysacceleration" },
    { 0x546A72F3, "setphysangles" },
    { 0x3D6BD688, "setphysicsgravity" },
    { 0xC2FD1C5D, "setphysicsgravitydir" },
    { 0x4FE250B9, "setphysparams" },
    { 0x03F945E4, "setpickedup" },
    { 0xBCDCCEAF, "setpickupstartammo" },
    { 0xA9079010, "setpitchorient" },
    { 0x52BA038B, "setpkgdelivery" },
    { 0xF46117E6, "setpkgdependancyenforcement" },
    { 0xF80A567D, "setpkgqty" },
    { 0x2B13AB6B, "setplacementhint" },
    { 0x0C525C74, "setplanegoalpos" },
    { 0x3B2385B0, "setplayer" },
    { 0xD5B09443, "setplayer_anims" },
    { 0xEDA2BE50, "setplayerangles" },
    { 0x890B79C9, "setplayerburning" },
    { 0x456C5BBD, "setplayercobrahealth" },
    { 0x9CE09198, "setplayercollision" },
    { 0x080AED78, "setplayercurrentobjective" },
    { 0xEA323CD9, "setplayercurrentstreak" },
    { 0xCF4654E8, "setplayerdata" },
    { 0x494925CA, "setplayergravity" },
    { 0x32BD3B73, "setplayerignoreradiusdamage" },
    { 0x47F46D9E, "setplayermodels" },
    { 0x40BD869F, "setplayermomentumdebug" },
    { 0x3F1144CD, "setplayermovedrecentlythread" },
    { 0xE75AF502, "setplayernamestring" },
    { 0x5726227A, "setplayerrenderoptions" },
    { 0xBB0B918D, "setplayerspawnpos" },
    { 0x45CE24AD, "setplayerspread" },
    { 0xE385F8E6, "setplayerstat" },
    { 0x767F616F, "setplayerstateloadoutbonuscards" },
    { 0xFB497F80, "setplayerstateloadoutweapons" },
    { 0x8401D589, "setplayerteamrank" },
    { 0x6776E476, "setplayertocamera" },
    { 0xD2253991, "setplayerviewratescale" },
    { 0x6BB53B37, "setplayervisibilityfortrigger" },
    { 0x1E912B73, "setpoint" },
    { 0x158EE2CA, "setpointbar" },
    { 0x4D5539F9, "setpointontrack" },
    { 0xDBC91BB1, "setpointstowin" },
    { 0x46225E2B, "setposemovement" },
    { 0xFA0619F6, "setposemovementfnarray" },
    { 0xE19AD0AE, "setposition" },
    { 0xDDDC6BA1, "setposture" },
    { 0xEDE9BF13, "setpotentialthreat" },
    { 0x29AFE468, "setpreferedpoint" },
    { 0x7086E1EC, "setpregameclass" },
    { 0x023E8F17, "setpregameteam" },
    { 0xFDDE4DBF, "setprimaryweapon" },
    { 0x205FD7A9, "setprintchannel" },
    { 0x0B19C070, "setprogressbarprogress" },
    { 0x3E85C2EE, "setpromotion" },
    { 0xBB9808D7, "setproneanimnodes" },
    { 0x45F30A0F, "setpronedepthoffield" },
    { 0x9A704E80, "setpulsefx" },
    { 0x6D783A5E, "setqosgamedatapayload" },
    { 0x7EB3DCBD, "setradarvisibility" },
    { 0x9A318769, "setrandomrun" },
    { 0x0B946095, "setrank" },
    { 0xF466425B, "setrappelanims" },
    { 0x7F4B0AEC, "setrecentstat" },
    { 0x28169C31, "setreconmodeldeployed" },
    { 0x2C8660D2, "setredactfx" },
    { 0xB05BDE90, "setremoveweaponwhenused" },
    { 0x1159E080, "setrepairpaths" },
    { 0x643B118F, "setreverb" },
    { 0xBD00AE3C, "setrevivehintstring" },
    { 0x2E29CD17, "setricochetprotectionendtime" },
    { 0xA2C59A11, "setrightarc" },
    { 0x880B9521, "setriotshieldfailhint" },
    { 0x467E5694, "setriotshieldviewmodel" },
    { 0x7C63DADA, "setripplewave" },
    { 0x81164BFA, "setrotorspeed" },
    { 0x9E53F601, "setroundsplayed" },
    { 0xA9E4A24C, "setruncycle" },
    { 0x9068D9ED, "setruntopos" },
    { 0xA1E76C76, "sets" },
    { 0xAA332733, "setsaveddvar" },
    { 0x7D0838B3, "setscale" },
    { 0x411E7A54, "setscanningpitch" },
    { 0x07AFDE52, "setscoreboardcolumns" },
    { 0xEEBFA6B2, "setscoremultiplier" },
    { 0xA43A8B52, "setscriptenemy" },
    { 0xE48ABCCF, "setscriptgoal" },
    { 0x39BF99E6, "setscripthintstring" },
    { 0xAC26F113, "setscriptmoverflag" },
    { 0xB976DCC7, "setscriptspeed" },
    { 0x917F75AC, "setseatoccupied" },
    { 0xCBFC3D87, "setsecondaryweapon" },
    { 0x0C98E1AC, "setselected" },
    { 0x3DC3597C, "setsessionqosdata" },
    { 0x45821F8B, "setsessstat" },
    { 0x9BEFB288, "setshader" },
    { 0x636AC8D4, "setshaderconstant" },
    { 0xA6AAA147, "setshaderconstants" },
    { 0xC54E6093, "setshadesmodels" },
    { 0xAD1DE87C, "setshadowhint" },
    { 0x5C39944C, "setsharedinventoryuimodels" },
    { 0x8205F3CF, "setshootent" },
    { 0x68669EBF, "setshootstyle" },
    { 0xE7C34F75, "setshootstyleforsuppression" },
    { 0x02A85DDA, "setshootstyleforvisibleenemy" },
    { 0x2CD1A58B, "setshortcircuitedanimtime" },
    { 0xB5203D90, "setshoutcasterwaitingmessage" },
    { 0x3904C05A, "setshowcaseweaponpaintshopxuid" },
    { 0x829D3156, "setsightdist" },
    { 0x32E607E4, "setsize" },
    { 0xA1BBF812, "setskill" },
    { 0xB8D9AD6E, "setslowmotion" },
    { 0x064D1652, "setsnapdefault" },
    { 0x07D61721, "setsniperaccuracy" },
    { 0x32690BEE, "setsonarattachmentenabled" },
    { 0x2F4E3DFF, "setsonarenabled" },
    { 0xD31EF585, "setsoundblend" },
    { 0x23E91425, "setsoundcontext" },
    { 0x1D2BB2B0, "setsoundentcontext" },
    { 0xAF55E03E, "setsoundpitch" },
    { 0x96BE8328, "setsoundpitchrate" },
    { 0xA69510C2, "setsoundvolume" },
    { 0x009D2E5C, "setsoundvolumerate" },
    { 0x0648C5FB, "setspawnclientflag" },
    { 0x1845F87A, "setspawnerteam" },
    { 0xE31D7680, "setspawnervariables" },
    { 0xC4C07FBA, "setspawnpoint" },
    { 0xFB18AC4E, "setspawnpointrandomvariation" },
    { 0xE56E5846, "setspawnpointsbaseweight" },
    { 0x830143F3, "setspawnvariables" },
    { 0xBDBA7B94, "setspawnweapon" },
    { 0xC7D9EC4B, "setspecialloadouts" },
    { 0xC1E7080E, "setspectatepermissions" },
    { 0x5585FDA6, "setspectatepermissionsformachine" },
    { 0x5DAAC42B, "setspectatepermissionsgrief" },
    { 0x333FD8F0, "setspeed" },
    { 0x8F87DE5F, "setspeedimmediate" },
    { 0xCBA5B7BA, "setspreadoverride" },
    { 0xE67885F8, "setsprintcooldown" },
    { 0xBA25E637, "setsprintduration" },
    { 0x10C2259A, "setsquadfeatures" },
    { 0x52E74066, "setstablemissile" },
    { 0x4C522007, "setstage" },
    { 0xCB4291F3, "setstairsexittransform" },
    { 0xFE722FCF, "setstance" },
    { 0xD2A3CD65, "setstat" },
    { 0x3AD16126, "setstatbit" },
    { 0xD2804F21, "setstatlbbyname" },
    { 0x2BCA0F36, "setstatto" },
    { 0xA6E41E1F, "setstatusslothealth" },
    { 0x86983C48, "setstatusslotselectionstate" },
    { 0x663B7EA3, "setsteeringmode" },
    { 0xFEEEB8DD, "setstepoutanimspecial" },
    { 0xD7EA2748, "setsteptriggersound" },
    { 0x90AE9C97, "setstowedweapon" },
    { 0x1B38F67C, "setstunned" },
    { 0x81D6E1D2, "setsundirection" },
    { 0x3B6FB001, "setsunlight" },
    { 0x75588724, "setsunshadowsplitdistance" },
    { 0x6FC588FC, "setsupplydropthrustersstate" },
    { 0xD8523D53, "setsuppressiontime" },
    { 0x9BC7684B, "setswitchnode" },
    { 0x499DC9DC, "settakecoverwarnings" },
    { 0x67806688, "settalktospecies" },
    { 0x6E6C4F26, "settargetedentityendtime" },
    { 0x8577B148, "settargetedmissilesremaining" },
    { 0xA8E6D0D7, "settargetent" },
    { 0x65453879, "settargetentity" },
    { 0x6D499908, "settargethighlight" },
    { 0x63F13A8E, "settargetorigin" },
    { 0x2269C4F2, "settargettooclose" },
    { 0xE3EFBE09, "settargetyaw" },
    { 0xCA711294, "setteam" },
    { 0x48A3DC44, "setteamforentity" },
    { 0xDC378587, "setteamfortrigger" },
    { 0x7A4F79A5, "setteamhasmeat" },
    { 0x58F99DF8, "setteamradar" },
    { 0xA01ED649, "setteamradarwrapper" },
    { 0x7DF5D057, "setteamrevive" },
    { 0xEA8FA638, "setteamreviveicon" },
    { 0x2621D19F, "setteamsatellite" },
    { 0x954848CC, "setteamsatellitewrapper" },
    { 0xF9944FF2, "setteamscore" },
    { 0xB0BC3094, "setteamspyplane" },
    { 0xCA6F1E2D, "setteamspyplanewrapper" },
    { 0xDF2CAE70, "setteamusetext" },
    { 0x8453AC52, "setteamusetime" },
    { 0x0ABB5ADA, "settenthstimer" },
    { 0x5FBEA909, "settenthstimerup" },
    { 0xF6181ACA, "settext" },
    { 0xDC6304E9, "setthirdperson" },
    { 0xAF5CE968, "setthirdpersondof" },
    { 0x49E95DC0, "setthreatbias" },
    { 0x0509245A, "setthreatbiasagainstall" },
    { 0xC7708F99, "setthreatbiasgroup" },
    { 0xE8A9C29D, "setthreatbiasgroup_on_array" },
    { 0x073FE129, "setthreatbiasgroup_on_notify" },
    { 0xBA81EB9C, "settime" },
    { 0xE1754D76, "settimer" },
    { 0xD59B9EFD, "settimerup" },
    { 0xC58C60AA, "settimescale" },
    { 0x1676559F, "setting" },
    { 0x62408EA8, "setting_ammo" },
    { 0x68D58432, "setting_locking_tether_distance" },
    { 0x5D129AD2, "setting_tutorial_hud" },
    { 0xC1239D26, "settings" },
    { 0xD4CDDCD7, "settings_index" },
    { 0x086B307E, "settingvalue" },
    { 0x0803D548, "settle" },
    { 0xBF00915C, "settled" },
    { 0x38D67063, "settles" },
    { 0x681DE749, "settling" },
    { 0xB1D2725C, "setto" },
    { 0x437BE7FC, "settoparc" },
    { 0xFE2DB310, "settopplayerstats" },
    { 0x83C4A944, "settopscorer" },
    { 0xCC3AE2FC, "settopteamstats" },
    { 0x966FD71E, "settrackinfoqrcode" },
    { 0x83084A92, "settraitstats" },
    { 0x91AD671A, "settraitstatvalue" },
    { 0x80251728, "settraitvalue" },
    { 0xE4C6FF49, "settransported" },
    { 0xC33CDF32, "settup" },
    { 0x3223577C, "setturningability" },
    { 0xB77B26DA, "setturretanim" },
    { 0x4870C8F1, "setturretcarried" },
    { 0xA986C793, "setturretfireondrones" },
    { 0x9F0D51F2, "setturrethint" },
    { 0xE0D6E345, "setturretignoregoals" },
    { 0x772DCCE0, "setturretminimapvisible" },
    { 0x95FBC8E6, "setturretowner" },
    { 0x2BF2CCCB, "setturretspinning" },
    { 0x5CBFC55E, "setturrettarget" },
    { 0x3488D445, "setturrettargetent" },
    { 0xD013F7FA, "setturrettargetrelativeangles" },
    { 0x13022100, "setturrettargetvec" },
    { 0xC630EEB7, "setturrettargetvecsafe" },
    { 0x7F13A422, "setturretteam" },
    { 0xB1F8F94D, "setturrettype" },
    { 0xC16B1158, "settweakablelastvalue" },
    { 0x170C5248, "settweakablevalue" },
    { 0x00F61B64, "settypewriterfx" },
    { 0xBD3F2B3B, "setuimodelvalue" },
    { 0xCE1F0F30, "setuinextlevel" },
    { 0x3A876950, "setukkoscriptindex" },
    { 0x7CFD17F0, "setup" },
    { 0x643AFFCC, "setup_50cal" },
    { 0xC55B57E1, "setup_aa_gunner" },
    { 0x4DAC688D, "setup_achievement_spawn_func" },
    { 0x95108891, "setup_additive_aim" },
    { 0x70BF433C, "setup_aftermath_scene" },
    { 0x4A48F3A5, "setup_ai" },
    { 0x31E2D9FE, "setup_ai_anims" },
    { 0x31F77BE2, "setup_ai_e7_jump_spot_guy" },
    { 0x9D0E9D3A, "setup_ai_eq_triggers" },
    { 0xE3BD19F4, "setup_ai_weapon" },
    { 0x543BC86F, "setup_ai_zipline" },
    { 0x9EFCFC01, "setup_aianimthreads" },
    { 0x68B58652, "setup_airfield_crashing_plane" },
    { 0x7AD5B583, "setup_airfield_destructibles" },
    { 0x5545F690, "setup_airfield_mortars" },
    { 0x1AAE7A4D, "setup_airfield_rebels" },
    { 0x8E6C9E0E, "setup_airfield_shrimps" },
    { 0x0C6213B6, "setup_airfield_trucks" },
    { 0xE8EF8289, "setup_airless_ambient_packages" },
    { 0x7AB3512B, "setup_airstrike_planes" },
    { 0xC180841D, "setup_airstrike_triggers" },
    { 0x601A69CF, "setup_all_guard_towers" },
    { 0x810F6985, "setup_all_traps" },
    { 0xBB35AB0B, "setup_allied_quadrotors" },
    { 0xEA4A5085, "setup_allies" },
    { 0x84BC4D7A, "setup_ally_char_model" },
    { 0x83AB0208, "setup_ally_console_anims" },
    { 0x9E8696F6, "setup_ally_horses" },
    { 0x0F24E4EF, "setup_ambience" },
    { 0x98CC259F, "setup_ambient_2_1_asd" },
    { 0xA9D0CACF, "setup_ambient_convoy_vehicle" },
    { 0x08FACBBE, "setup_ambient_fx" },
    { 0xBFECC2AD, "setup_ambient_fx_sounds" },
    { 0x748D7CA0, "setup_and_anim_crane" },
    { 0x796F42E0, "setup_and_play_ctt1_vox" },
    { 0xB68E5E2B, "setup_and_play_ctt2_vox" },
    { 0x870D77E8, "setup_anim" },
    { 0x95FF7232, "setup_anim_array" },
    { 0xD59AE2CC, "setup_anim_array_callback" },
    { 0x845B966B, "setup_anim_structs" },
    { 0x9408DD5B, "setup_animated_signs" },
    { 0x5119E746, "setup_animation_trigger_on_escort_boat" },
    { 0x5325A383, "setup_anims" },
    { 0xA46B4B37, "setup_anims_callback" },
    { 0x13E94527, "setup_approach_points" },
    { 0x8FE81705, "setup_argus" },
    { 0xE757994C, "setup_armory_defend" },
    { 0x0EE15066, "setup_armory_rush" },
    { 0xD1F6F180, "setup_asds" },
    { 0xEEEB9032, "setup_assasination_flags" },
    { 0x7212C4F4, "setup_attributes" },
    { 0xC5E6C885, "setup_axis_char_model" },
    { 0xF4276CAF, "setup_axis_drone_deaths" },
    { 0x9BE69C9D, "setup_background_elements" },
    { 0xB985FE45, "setup_balcony_aa_gun" },
    { 0x4D85B421, "setup_balcony_guy" },
    { 0x1475A32E, "setup_banzai" },
    { 0x945CE3F1, "setup_banzai_guys" },
    { 0x67F24FE2, "setup_banzai_triggers" },
    { 0xA79C9AFA, "setup_bar_flags" },
    { 0x2FBFC88A, "setup_barge" },
    { 0xBC759FBF, "setup_barge_side_panel" },
    { 0x30582622, "setup_barnes_anim_array" },
    { 0x12455680, "setup_barrel_ai" },
    { 0x568140B8, "setup_barricade" },
    { 0xA4D66642, "setup_base_guard" },
    { 0x97D0A565, "setup_base_horses" },
    { 0x5DB36455, "setup_base_patrollers" },
    { 0xA6D78F57, "setup_basement_door" },
    { 0xCC931D9A, "setup_basic_scene" },
    { 0x47548921, "setup_baton_guard_anim_array" },
    { 0x5D0393E1, "setup_behind_spawners" },
    { 0xFB780126, "setup_bg_elements" },
    { 0x45DDE93D, "setup_bias_by_spawner" },
    { 0x379A476F, "setup_bigdog_anim_array" },
    { 0x3D15B224, "setup_bigdog_anims" },
    { 0xB6033A75, "setup_bigdog_guard" },
    { 0xC0FECB55, "setup_bigdog_previs" },
    { 0xCD3D1C78, "setup_bigdog_turret" },
    { 0x4280EC82, "setup_bink_monitor_randomize" },
    { 0x937040BD, "setup_blank_random_player" },
    { 0x0877AB4E, "setup_block" },
    { 0x3F3F7E99, "setup_boat" },
    { 0x611201F0, "setup_boat_escape_amb" },
    { 0x0C0F8A9B, "setup_boat_goal_sets" },
    { 0xEB9FBAFF, "setup_boat_regen" },
    { 0x129B57F6, "setup_boat_stop_points" },
    { 0xA1B2324B, "setup_body_funcs" },
    { 0xC119C8AA, "setup_bomblet" },
    { 0x17D4535F, "setup_bomblet_map_icon" },
    { 0xAC167E56, "setup_bonfiresale_audio" },
    { 0xCCF5B71C, "setup_bowman_anims" },
    { 0x75F5896A, "setup_bowman_victim" },
    { 0xFEC68FC7, "setup_brainwash_anims" },
    { 0x4465398D, "setup_breach_guards_react" },
    { 0x2781B035, "setup_brick_anims" },
    { 0xA24E7C8C, "setup_bridge_autodeath" },
    { 0xEC0A79E1, "setup_bridge_clip" },
    { 0x7F455969, "setup_bridge_defense" },
    { 0x86418360, "setup_bridge_explosion" },
    { 0x707AB29B, "setup_briefing_room" },
    { 0x539F5B99, "setup_briggs" },
    { 0x92DF94BF, "setup_brooks_fps" },
    { 0xF06E15F3, "setup_brushmodels" },
    { 0x1BB7D82C, "setup_buildable_switch" },
    { 0x34858944, "setup_buildables" },
    { 0x0C12F654, "setup_building_hits" },
    { 0xFC5A6F59, "setup_buildingcollapse_anims" },
    { 0x01E5A498, "setup_bulletcam" },
    { 0x936017B1, "setup_bunker_defenders" },
    { 0x2D37CB5E, "setup_bunker_enemy_params" },
    { 0x289FD2C7, "setup_bunker_exploders" },
    { 0xB230F3C0, "setup_bunker_infantry" },
    { 0x783869B4, "setup_bunker_lookat_physics_pulses" },
    { 0xB23AE663, "setup_bunker_scientist" },
    { 0x1E5D6C3B, "setup_button_attacker" },
    { 0x8932EE39, "setup_button_troops" },
    { 0xEC34A3F3, "setup_c5_nose_section" },
    { 0xB7B70727, "setup_cafe_wall" },
    { 0x32EED1BA, "setup_cagelight_fx" },
    { 0x13EFB045, "setup_callbacks" },
    { 0x11970122, "setup_camera" },
    { 0x889ABFB3, "setup_camera_ents" },
    { 0x568AAFE6, "setup_camera_prefabs" },
    { 0x3D505762, "setup_camo_suit_ai" },
    { 0x9F06922F, "setup_capture_drones" },
    { 0x61F25547, "setup_capture_zones" },
    { 0xED0B6E28, "setup_car_anims" },
    { 0xECD74478, "setup_carlos_anims" },
    { 0x54325291, "setup_castle_spawners" },
    { 0x6E91CC22, "setup_cattle" },
    { 0x9DA15ED1, "setup_chair1_anim" },
    { 0x1CD22798, "setup_chair2_anim" },
    { 0x31266FE5, "setup_chair_anims" },
    { 0xADE850F2, "setup_challenge" },
    { 0x31CA807D, "setup_challenges" },
    { 0xB2A123E1, "setup_chandelier_anims" },
    { 0xC7A7DCE0, "setup_character_extracam_settings" },
    { 0xC3C52048, "setup_character_extracam_struct" },
    { 0xF61CD9D1, "setup_character_streaming" },
    { 0x6E622BB3, "setup_characters" },
    { 0x66A8A71A, "setup_chase_uaz" },
    { 0x07D7549E, "setup_circling_heli_turret" },
    { 0xC0849912, "setup_civilian_anim_array" },
    { 0x654D7214, "setup_civilian_attributes" },
    { 0x43EA7C97, "setup_civilian_override_animations" },
    { 0x4C572AAD, "setup_civilian_stairs_anim_array" },
    { 0x53FE7942, "setup_classic_gametype" },
    { 0xCE92838D, "setup_claw_bigdog" },
    { 0xF04D56F5, "setup_clear_the_street_ai" },
    { 0x9042ECC7, "setup_client_hintelem" },
    { 0x9D05EC99, "setup_clientfields" },
    { 0x264B5960, "setup_clips" },
    { 0x541E4161, "setup_clock_mgs" },
    { 0x2D486F1E, "setup_closet_ambush" },
    { 0x65E30F92, "setup_collectible_corpse" },
    { 0x92182F9C, "setup_combat_tutorial" },
    { 0xD002E99F, "setup_commissar" },
    { 0xF2DFDD68, "setup_comms_guard" },
    { 0x5CF50638, "setup_compound_flags" },
    { 0x007AD16E, "setup_container_scriptbundle" },
    { 0x2BB70E6F, "setup_contextual_melee" },
    { 0xAE11B3D2, "setup_control" },
    { 0xB3B60F45, "setup_control_room_scene" },
    { 0x34D61413, "setup_control_room_victim" },
    { 0x94CA6A60, "setup_conversation_vo" },
    { 0x9C248971, "setup_convoy" },
    { 0xEEBA834C, "setup_convoy_vehicle" },
    { 0xDE997B93, "setup_courtyard_guys" },
    { 0xA1ED97BF, "setup_courtyard_vtols" },
    { 0x4F74CC71, "setup_cover_crouch" },
    { 0x84584C5F, "setup_cover_prone" },
    { 0xAB857F39, "setup_cover_stand" },
    { 0x67EE5314, "setup_cover_trans_split_array" },
    { 0xF51A85C4, "setup_cowering_scientist" },
    { 0x099DF593, "setup_cqb_anim_array" },
    { 0x6E06B367, "setup_craftable_pieces" },
    { 0x4AD1B20E, "setup_crouch_spot_attacker" },
    { 0x68941BFF, "setup_crouching_anim_array" },
    { 0x4759A81D, "setup_crows" },
    { 0xC9E9FBA5, "setup_cuba_melee" },
    { 0x8D7FF1F4, "setup_cuba_melee_weapon" },
    { 0x7013CEE8, "setup_custom_base_guard" },
    { 0x17319630, "setup_custom_vox" },
    { 0x4E57E388, "setup_dead_bodies" },
    { 0x0512653B, "setup_death_watch_for_new_targets" },
    { 0xA4F59945, "setup_deathfunc" },
    { 0x79AE8C25, "setup_deck_ai" },
    { 0xBD87959A, "setup_deck_battle_ally" },
    { 0xFB45A01D, "setup_deck_friendly_moveup" },
    { 0x0CB662B2, "setup_deck_phalanx_cannon_targets" },
    { 0xD30A2734, "setup_deck_phalanx_cannons" },
    { 0x306ABA2C, "setup_default_anim_array" },
    { 0x06EC7A8F, "setup_default_bink_monitors" },
    { 0x8FA390BC, "setup_default_client_flag_callbacks" },
    { 0x6C5BB8D1, "setup_default_cqb_anim_array" },
    { 0x8DCB5958, "setup_default_rusher_anim_array" },
    { 0xB219776B, "setup_default_rusher_wounded_anim" },
    { 0x8146BE1A, "setup_default_ui3d" },
    { 0xB178FE0D, "setup_default_wounded_anim_array" },
    { 0xD5E698F8, "setup_defenses" },
    { 0x2C3AEFF0, "setup_delete_frontend_items" },
    { 0xD0813E7A, "setup_delete_triggers" },
    { 0x8321F0C0, "setup_delta_arrays" },
    { 0x961E500F, "setup_destructible_buildings" },
    { 0x3B6E8120, "setup_destructibles" },
    { 0xF2E6B4C6, "setup_dev_freeroam" },
    { 0x9B36A3D5, "setup_devgui" },
    { 0x72260D3A, "setup_devgui_func" },
    { 0x8D51F889, "setup_dialogue_loops" },
    { 0x12F13948, "setup_dialogues" },
    { 0x9B933C6A, "setup_dig_devgui" },
    { 0xA884EB12, "setup_digbat" },
    { 0x9AF8A85C, "setup_digbat_anim_array" },
    { 0x34122388, "setup_diggers" },
    { 0xE1F2E1B9, "setup_dog_anim" },
    { 0x15ED3266, "setup_dog_handler" },
    { 0x94579770, "setup_door_anims" },
    { 0xF23BDAD0, "setup_door_for_animation" },
    { 0x9A666B3B, "setup_door_markers" },
    { 0x5C37F26B, "setup_door_scriptbundle" },
    { 0x821873EC, "setup_door_waits" },
    { 0xA9870442, "setup_doors" },
    { 0xFA73E4A6, "setup_driver_turret_aim_assist" },
    { 0x99AB871B, "setup_driving_anims" },
    { 0x8F6AAEF5, "setup_drone_delete_triggers" },
    { 0xE2DA9E64, "setup_drone_fx" },
    { 0x8183A07C, "setup_drone_models" },
    { 0xE6338472, "setup_drone_paths" },
    { 0xC15104EA, "setup_drone_run_anims" },
    { 0x38B73D69, "setup_drone_triggers" },
    { 0x4C85AEDF, "setup_drone_yells" },
    { 0x308DF7FA, "setup_drones" },
    { 0x852B1586, "setup_drones_for_burn" },
    { 0x05D7EC31, "setup_dropin" },
    { 0xCE209AE1, "setup_dryer_challenge" },
    { 0x88B85688, "setup_dualwield_anim_array" },
    { 0xDD29818F, "setup_dump_guard" },
    { 0xBDEEB7BB, "setup_dvars" },
    { 0xE3D9D291, "setup_dyn_ents" },
    { 0x5EBEF39E, "setup_dynamic_detour" },
    { 0xEC5D899E, "setup_eagle_anims" },
    { 0x184AC326, "setup_early_tanks" },
    { 0x670B87E0, "setup_ee_main_devgui" },
    { 0x81A348FD, "setup_elevator" },
    { 0x5A4711B4, "setup_elevator_gates" },
    { 0x0C318B5E, "setup_elite_anim_array" },
    { 0xA6327252, "setup_end_struct" },
    { 0xB79E6578, "setup_end_train_guys" },
    { 0x05AB8D00, "setup_ending_quadrotor" },
    { 0xE3F053C6, "setup_ending_vtol" },
    { 0xDDC37276, "setup_ending_water" },
    { 0xC3AF5F75, "setup_endscene_characters" },
    { 0x685BBFF9, "setup_enemies" },
    { 0x446A5E5B, "setup_enemy_aagun_guys" },
    { 0xE537DB3C, "setup_eq_channels" },
    { 0x4757250A, "setup_equipment_client_hintelem" },
    { 0xD7D452FC, "setup_escort_boat" },
    { 0x4E839EAB, "setup_event_wide_functions" },
    { 0xB698F424, "setup_eventname_triggers" },
    { 0x1749C67E, "setup_exits" },
    { 0x7A5FDE49, "setup_exploder_aliases" },
    { 0xB47D5DB3, "setup_explosions" },
    { 0x00AF0DFC, "setup_explosive_damage" },
    { 0x84E4D231, "setup_explosive_structures" },
    { 0xE347F824, "setup_export_names" },
    { 0xC6D80631, "setup_exterior" },
    { 0x6BB59301, "setup_extra_bridge" },
    { 0x1D2D0C5A, "setup_extra_cams" },
    { 0x71544C9B, "setup_f35" },
    { 0xA164798E, "setup_fail_messages" },
    { 0x669575A3, "setup_fake_dest_lvts" },
    { 0xF83A31DF, "setup_fake_motorcade" },
    { 0x8BD5E719, "setup_fallback" },
    { 0x77B94E61, "setup_fallback_monitors" },
    { 0x3440AD44, "setup_faller_locations" },
    { 0x142418B9, "setup_fallguy" },
    { 0xFD84F750, "setup_fallingsign_anims" },
    { 0xEA4F361B, "setup_female_anim_array" },
    { 0x3F92A4B8, "setup_field_ambushes" },
    { 0x1DFEB496, "setup_field_anims" },
    { 0x396A9ACF, "setup_field_guard" },
    { 0x97F23CDC, "setup_fields" },
    { 0x5F90510B, "setup_final_launchers" },
    { 0x32CB847C, "setup_fire_scientist" },
    { 0xFB6540E1, "setup_firesale_audio" },
    { 0xB490F652, "setup_first_defense" },
    { 0x70626023, "setup_first_jeep_ai" },
    { 0xDF0989A8, "setup_first_patrol" },
    { 0x1A39440D, "setup_flag" },
    { 0x2FEA9946, "setup_flag_anims" },
    { 0x6364237A, "setup_flag_fx" },
    { 0xC2A7BD8C, "setup_flags" },
    { 0xA831B45B, "setup_flak88_guard" },
    { 0x309A2582, "setup_flame_bunker_guard" },
    { 0x1523A770, "setup_flame_damage" },
    { 0xC3BDA773, "setup_flame_leapover" },
    { 0xCC1BA54E, "setup_flamethrower_stat" },
    { 0x83E03541, "setup_flashlight" },
    { 0x48757268, "setup_flashlights" },
    { 0xCB3A47B7, "setup_floating_debris_types" },
    { 0x2AEAD080, "setup_floating_objects" },
    { 0xF2FE3CF5, "setup_fog" },
    { 0x91A91BED, "setup_follower" },
    { 0x7BCEE726, "setup_follower_advanced" },
    { 0x0AE75D93, "setup_follower_goalradius" },
    { 0xF86C93B4, "setup_follower_goalradius_big" },
    { 0x0282C10B, "setup_follower_goalradius_riotshield" },
    { 0x82877E9E, "setup_for_bar" },
    { 0x13CC66D0, "setup_for_player" },
    { 0xC38CF849, "setup_force_behavior" },
    { 0x985C0F34, "setup_force_fall" },
    { 0x398E4690, "setup_foreshadow_victim" },
    { 0x236B8A4D, "setup_foxhole1" },
    { 0x496E04B6, "setup_foxhole2" },
    { 0x6F707F1F, "setup_foxhole3" },
    { 0x4738CC9A, "setup_fps_friendlies" },
    { 0x34B48E1A, "setup_friendlies" },
    { 0x1E304F62, "setup_friendly" },
    { 0xDED667A3, "setup_friendly_advance_triggers" },
    { 0x82FDC744, "setup_friendly_dancer" },
    { 0xECEBAC33, "setup_friendly_hud_icons" },
    { 0x722DFB9E, "setup_friendly_npc_boats" },
    { 0x99EA6999, "setup_friendly_teams" },
    { 0x0D2EDBC6, "setup_friends" },
    { 0x9B445A9B, "setup_frontdoors" },
    { 0xA41B5A58, "setup_fuel_depot_infantry" },
    { 0x464648BC, "setup_fueldepot_anims" },
    { 0x8339F3DB, "setup_fullscreen_postfx" },
    { 0x45876C81, "setup_fx" },
    { 0x1847C562, "setup_fx_anims" },
    { 0xD619E8B8, "setup_fx_spotlight" },
    { 0x23BDE8C3, "setup_fxanim_grass_triggers" },
    { 0xF6DCF468, "setup_gadget_thief_array" },
    { 0x59084590, "setup_game_mode_objects" },
    { 0x4B53C3C4, "setup_gameobject" },
    { 0x7E504FFE, "setup_gameplay_think" },
    { 0xDCCDF588, "setup_garage_breachers" },
    { 0xDA035E88, "setup_garage_bunk_guys" },
    { 0x8429DE06, "setup_garage_bunk_talker_guys" },
    { 0xB94FCB72, "setup_garage_chair_guy" },
    { 0xA5B057FD, "setup_garage_chair_guys" },
    { 0x8DEA49EE, "setup_garage_doors" },
    { 0x94F2E368, "setup_garage_first_reenforcements" },
    { 0xB45A6D94, "setup_garage_second_reenforcements" },
    { 0xF2E38D10, "setup_garage_smoker" },
    { 0x0F419437, "setup_gas_station" },
    { 0x5D1E6FB8, "setup_gasfreeze_ai" },
    { 0xC0F07A21, "setup_gate_guys" },
    { 0xCF9304C5, "setup_gate_puzzle" },
    { 0x340F0F1F, "setup_gaz" },
    { 0x6C8D69D3, "setup_gaz_gate" },
    { 0xAB34F9C4, "setup_general_container_bundle" },
    { 0x2AEBEDA0, "setup_generator_challenge" },
    { 0x4579F14F, "setup_generator_unitrigger" },
    { 0x933408D5, "setup_generic_anims" },
    { 0xDD9DB5FD, "setup_geo_anims" },
    { 0xBCB499AC, "setup_giant_robot_devgui" },
    { 0xEB3175D9, "setup_giant_robots_intermission" },
    { 0xCD14EE9F, "setup_gib" },
    { 0x34989CEF, "setup_global_challenges" },
    { 0xAFB4D94D, "setup_goggles" },
    { 0x91F394C6, "setup_griggs" },
    { 0x6618C124, "setup_ground_attack_objectives" },
    { 0x2E8AA3BA, "setup_groundnode_detour" },
    { 0xE585CA8F, "setup_groups" },
    { 0x8F144AA9, "setup_guard_escort" },
    { 0xAB1B8101, "setup_guard_firing_into_water" },
    { 0x235DD500, "setup_guard_tower" },
    { 0xB62F6687, "setup_guard_tower_individually" },
    { 0x4031AAFA, "setup_guards_at_bottom_of_road" },
    { 0x7C1570A6, "setup_gunner_behaviour" },
    { 0x19256B18, "setup_guy_door_anims" },
    { 0x022F81BC, "setup_guy_window_anims" },
    { 0x5D2AC674, "setup_guzzo_hud" },
    { 0xFD1B11E7, "setup_hall_defense" },
    { 0xF0B557C9, "setup_hall_offense" },
    { 0x8C52A778, "setup_hallway_ally" },
    { 0x43CDB05B, "setup_hardpoint_fx" },
    { 0x7FC75E6D, "setup_harper" },
    { 0x8AD6B34A, "setup_harper_pilot" },
    { 0x36DF163A, "setup_harris_fps" },
    { 0x8CAA59B8, "setup_hatch_marine" },
    { 0x7C3F9696, "setup_head_scientist" },
    { 0x00204D35, "setup_health" },
    { 0xC5C6E521, "setup_heat_anim_array" },
    { 0xA5309ADF, "setup_heavy_escort" },
    { 0x25D7F093, "setup_heavy_intro" },
    { 0x5CC78457, "setup_heli" },
    { 0x60DB6973, "setup_heli_guy" },
    { 0x32450BE4, "setup_heli_props" },
    { 0x6C616F86, "setup_heli_sounds" },
    { 0xE357D098, "setup_helicopter" },
    { 0x57D5AE33, "setup_helicopter_attack_points" },
    { 0x5BF9ABED, "setup_helicopter_delete_node" },
    { 0x16BBC183, "setup_hero" },
    { 0xC7269CC6, "setup_hero_rival" },
    { 0x418278D4, "setup_hero_squad" },
    { 0xF3AEF8C7, "setup_heroes" },
    { 0x6532DE5F, "setup_hide" },
    { 0xFCA6FDD5, "setup_hide_player" },
    { 0xC9108851, "setup_hintelem" },
    { 0x0AB49D5A, "setup_hud" },
    { 0x21257990, "setup_hud_elem" },
    { 0xAD01F49D, "setup_hudson_heli" },
    { 0x467B81A5, "setup_huey_ai_support" },
    { 0x948291A5, "setup_human_anims" },
    { 0x4AF8D0AE, "setup_idle_animation" },
    { 0x833EA8D3, "setup_idle_ropes" },
    { 0x30052A97, "setup_idle_strugles" },
    { 0x6BA924A0, "setup_in_array" },
    { 0x400203BE, "setup_inaccessible_zombie_attack_points" },
    { 0x2EEC4B1E, "setup_incoming_jeep" },
    { 0x6E6871F7, "setup_info" },
    { 0x1FB22BEE, "setup_init_hero_state" },
    { 0x95A64D83, "setup_initial_lander_states" },
    { 0xA86757CC, "setup_initial_scene" },
    { 0x8009E237, "setup_interaction_matrix" },
    { 0x8E52DB0F, "setup_interior" },
    { 0x57452656, "setup_intro_house" },
    { 0x1B8F58C9, "setup_investigation_guard" },
    { 0xBB325CEC, "setup_isaac" },
    { 0xFF9F1C4A, "setup_jeep_tank" },
    { 0xF94E6E3F, "setup_jeep_walkers" },
    { 0xE123AB3F, "setup_juggernaut_anim_array" },
    { 0x1958729E, "setup_key_doors" },
    { 0xE7B1E87C, "setup_killstreaks" },
    { 0xC2813FE2, "setup_ladder_enemy" },
    { 0xA79732CB, "setup_lander_screens" },
    { 0x70622DEC, "setup_landing" },
    { 0x9C2CF7CA, "setup_lastbattle_anims" },
    { 0x9ECFE829, "setup_later_tanks" },
    { 0x0DD1CC5A, "setup_launchpad_worker" },
    { 0xC139AA45, "setup_law_objective" },
    { 0xB9040D44, "setup_leader" },
    { 0x0D7B785F, "setup_leader_anims" },
    { 0x2D36A3A8, "setup_leaper" },
    { 0xA732B743, "setup_leapers" },
    { 0x5DA7501B, "setup_ledge_respawn" },
    { 0x56352541, "setup_left_uaz" },
    { 0x6B0EE9BF, "setup_level" },
    { 0x2B1A9C44, "setup_level_anims" },
    { 0x6A5FB3A8, "setup_level_vars" },
    { 0x79119DB5, "setup_levelvars" },
    { 0xE16ABC66, "setup_light_arrays" },
    { 0xD025E055, "setup_lighting_alignment_for_plane_exit" },
    { 0x12FC5AC1, "setup_lighting_pairs" },
    { 0xA10B4554, "setup_lights" },
    { 0x520F9477, "setup_limited" },
    { 0x4C9E92EA, "setup_limited_equipment" },
    { 0x9D5804B4, "setup_limo_victims" },
    { 0xC65918E1, "setup_line_protection" },
    { 0x1AB3DB49, "setup_live_character_customization_target" },
    { 0x50BE36EA, "setup_lock_lights" },
    { 0x23B41C2F, "setup_locker_double_doors" },
    { 0xA6D15640, "setup_low_ready_roof" },
    { 0xCD3741D6, "setup_machete_attacker" },
    { 0x56715EEA, "setup_main_barge" },
    { 0x6CE39497, "setup_mansion_door_anim" },
    { 0x6CCBE8E2, "setup_mansion_flags" },
    { 0xF30E8B84, "setup_mantle_guy_on_box" },
    { 0xE34637DB, "setup_mason" },
    { 0x64660568, "setup_mason_carry_woods" },
    { 0x1E5D24E4, "setup_mason_hill_initial_mg_gunners" },
    { 0xB5D82BF1, "setup_mason_protect_nag_distances" },
    { 0xBBA1BEC1, "setup_master_key" },
    { 0x41DE6C92, "setup_mcknight_sniper" },
    { 0x34810486, "setup_meat_world_objects" },
    { 0x55341282, "setup_meatshield_boat" },
    { 0xDE76B7B7, "setup_meatshield_boats_main" },
    { 0xC609A843, "setup_medic" },
    { 0xDAA6838D, "setup_melee_digbat_anim_array" },
    { 0xA92072A8, "setup_melee_mpla_anim_array" },
    { 0xDAE6BC1D, "setup_menedez_escape_extracam" },
    { 0x5FF24F2D, "setup_menendez" },
    { 0x8F96274D, "setup_menendez_and_crew" },
    { 0xC42CDBAE, "setup_menendez_m32" },
    { 0x516718D6, "setup_menu" },
    { 0x7323D374, "setup_menu_buttons" },
    { 0xB60FDF49, "setup_menus" },
    { 0x0E33A9EF, "setup_merchant_ship_chain_destruction" },
    { 0x7BD873CC, "setup_meteor_audio" },
    { 0xA19FAA61, "setup_metrodoor_anims" },
    { 0xADD3511C, "setup_metrogate_anims" },
    { 0x2C677029, "setup_mg42" },
    { 0x192E1211, "setup_mg_damage" },
    { 0x7C04F0FB, "setup_mgdeath_truck" },
    { 0x045DA712, "setup_microwavegun_vox" },
    { 0xBD00D054, "setup_militia_anim_array" },
    { 0x76E7B0B2, "setup_mixer_lights" },
    { 0x2F031157, "setup_moab_gunners" },
    { 0xB9179874, "setup_model_overrides" },
    { 0xA3946449, "setup_models" },
    { 0xB61CF03E, "setup_moon_visit_vox" },
    { 0x0B98B9FE, "setup_mortar_terrain" },
    { 0x0747B935, "setup_mortarhut_anim" },
    { 0x29D8B4BB, "setup_motel_pool_runners" },
    { 0x8058CC8E, "setup_mover" },
    { 0x0FA44749, "setup_moving_elevators" },
    { 0xB37B050D, "setup_mpla" },
    { 0x905273B5, "setup_mpla_anim_array" },
    { 0x702B17BE, "setup_music_egg" },
    { 0xA04A60C6, "setup_my_driver" },
    { 0x629CEF87, "setup_nag_lines" },
    { 0x62AC2D35, "setup_names" },
    { 0xC34BBFF2, "setup_neccessary_systems" },
    { 0x36E6613D, "setup_nixie_tubes_puzzle" },
    { 0x111E8F86, "setup_nodes" },
    { 0x52077ADC, "setup_non_rpg_guy" },
    { 0xD685D237, "setup_notetracks" },
    { 0x370B90D0, "setup_objective" },
    { 0x4826D8BB, "setup_objectives" },
    { 0x3D2CC87B, "setup_objectives_skip" },
    { 0xE81A884C, "setup_obstacle_course" },
    { 0x1E9BC073, "setup_oc_timer" },
    { 0xEAEA7D2E, "setup_office_wall" },
    { 0xDB4A8C75, "setup_one_handed_ai" },
    { 0x37DC370C, "setup_oneinchpunch_devgui" },
    { 0xDDF538B4, "setup_origins" },
    { 0xD20DFD55, "setup_outbound_jeeps" },
    { 0xE16C541F, "setup_outside_anims" },
    { 0x705EAA52, "setup_paci_spawners" },
    { 0x8AD983B4, "setup_paci_spawners2" },
    { 0xE4486341, "setup_paintshop_bg" },
    { 0x8D450472, "setup_pak_anims" },
    { 0xBEB339E6, "setup_panzershreck_guys" },
    { 0xC371F384, "setup_parachute_anim" },
    { 0xE53B7FDC, "setup_parked_vehicles" },
    { 0x3877870F, "setup_parking_garage" },
    { 0x6A570929, "setup_patrol" },
    { 0x920C97C0, "setup_patrol1_01" },
    { 0x9804DB22, "setup_patrol_member" },
    { 0x2AB15FBE, "setup_patrol_pursuit" },
    { 0x14E69984, "setup_patrol_walk1" },
    { 0x86EE08BF, "setup_patrol_walk2" },
    { 0x60EB8E56, "setup_patrol_walk3" },
    { 0x7CDCAFE0, "setup_patrol_walk5" },
    { 0xB62B56BA, "setup_patroller" },
    { 0xD2E6D0CB, "setup_patrolroutes" },
    { 0x32DB5251, "setup_patrons_anims" },
    { 0xE7DB4F83, "setup_pby_compass_menu" },
    { 0x181E0C75, "setup_perk_machines_not_controlled_by_zone_capture" },
    { 0xD9166788, "setup_perk_random_machines" },
    { 0xE3F25872, "setup_pers_upgrade_boards" },
    { 0x071BFADF, "setup_pers_upgrade_box_weapon" },
    { 0x535BB383, "setup_pers_upgrade_carpenter" },
    { 0x89BA29EE, "setup_pers_upgrade_cash_back" },
    { 0x13A98C70, "setup_pers_upgrade_double_points" },
    { 0x18E24A87, "setup_pers_upgrade_flopper" },
    { 0x934FDBAD, "setup_pers_upgrade_insta_kill" },
    { 0x4C0CAA98, "setup_pers_upgrade_jugg" },
    { 0xDFFF590B, "setup_pers_upgrade_multi_kill_headshots" },
    { 0xAC121789, "setup_pers_upgrade_nube" },
    { 0x08C91C0F, "setup_pers_upgrade_perk_lose" },
    { 0xAAA88ABE, "setup_pers_upgrade_pistol_points" },
    { 0x8196F416, "setup_pers_upgrade_revive" },
    { 0x25915A30, "setup_pers_upgrade_sniper" },
    { 0x80F102B1, "setup_personality_character_exerts" },
    { 0x163F3216, "setup_phone_audio" },
    { 0xD0A8F0F8, "setup_pillar_anims" },
    { 0xDB031194, "setup_pistol_anim_array" },
    { 0xCB4E4FEB, "setup_pistol_stairs_anim_array" },
    { 0x4A4F807F, "setup_plane_crate" },
    { 0x5C666AE0, "setup_plane_map" },
    { 0xC4A21371, "setup_plane_nose_fall" },
    { 0x6D43C9B6, "setup_plane_sounds" },
    { 0x1AE9BC3D, "setup_planter_spawners" },
    { 0x94D3898B, "setup_planter_squads" },
    { 0x73757448, "setup_player" },
    { 0xEAF3151F, "setup_player_action_notifies" },
    { 0xBAA205DB, "setup_player_anims" },
    { 0xC1EBFEA1, "setup_player_boat" },
    { 0x6474A906, "setup_player_cobra" },
    { 0xBB2A9470, "setup_player_contracts" },
    { 0xDE2D023A, "setup_player_control" },
    { 0x022A5034, "setup_player_damage_watchers" },
    { 0x5764D052, "setup_player_interactive_anims" },
    { 0xE43AD822, "setup_player_navcard_hud" },
    { 0xE6320916, "setup_player_planes" },
    { 0x4FDCA404, "setup_player_stats" },
    { 0x4268910A, "setup_player_tanks" },
    { 0x97F24E28, "setup_player_tiger" },
    { 0x5CB3BD63, "setup_players" },
    { 0xD39F91B0, "setup_players_loadgame" },
    { 0x8FDA554E, "setup_poi_fx" },
    { 0x2ADF5294, "setup_point_fx" },
    { 0x36186BC4, "setup_post_ambush" },
    { 0xE1025E4A, "setup_power_on_sfx" },
    { 0x4E884AC9, "setup_powerup" },
    { 0x8B47715A, "setup_powerup_devgui" },
    { 0xB418E208, "setup_pre_avalanche" },
    { 0x7AD326A4, "setup_precache" },
    { 0x93B429AC, "setup_previs_elements" },
    { 0x7C9F9226, "setup_price" },
    { 0xADADF7D3, "setup_prisoner_anim_array" },
    { 0xCDE04CA8, "setup_prisoner_anims" },
    { 0xC93FD5A2, "setup_prisoner_helper" },
    { 0xC49E1163, "setup_prisoner_rolldoor" },
    { 0x866764AC, "setup_prisoner_rush" },
    { 0x9149ED31, "setup_prisoners_override_animations" },
    { 0x75CC0FD3, "setup_prop_anims" },
    { 0xD87AB6F1, "setup_prop_fx" },
    { 0x4C393CEB, "setup_props" },
    { 0xAA803542, "setup_proximity_scan_and_alarm" },
    { 0x0FBC6945, "setup_puzzle_piece_glint" },
    { 0xFEDDC616, "setup_puzzles" },
    { 0x5F3E8B32, "setup_qr_code" },
    { 0xE2FF80B5, "setup_quad50_truck" },
    { 0xD00832AC, "setup_quadrotor_purchase" },
    { 0xD961F9CD, "setup_quest_triggers" },
    { 0x07BA7AA6, "setup_radar_patrol" },
    { 0x4A7AC634, "setup_radio" },
    { 0xCEDD5C11, "setup_radio_egg_audio" },
    { 0x1251BCEA, "setup_radio_tower_infantry" },
    { 0x928E3800, "setup_radiotower_anims" },
    { 0xF3ECEA66, "setup_radius_values" },
    { 0x56936212, "setup_raft" },
    { 0x7F147A8C, "setup_rage" },
    { 0xEC4AD7F5, "setup_rage_enemies" },
    { 0x84DF18A4, "setup_rage_settings" },
    { 0x05AE415B, "setup_railclimb_spawnfuncs" },
    { 0x5C12FF58, "setup_random_corpse_positions" },
    { 0x84EE7588, "setup_random_environment" },
    { 0xA3373F45, "setup_random_sun" },
    { 0x874945E7, "setup_rappel" },
    { 0xC17C0C5C, "setup_rappel_lure" },
    { 0x6A7277F3, "setup_rat_anims" },
    { 0x3F0C4B94, "setup_real_motorcade" },
    { 0x930BB2D5, "setup_rebel" },
    { 0x0D31D6C8, "setup_rebel_victim" },
    { 0x0A9E5E89, "setup_reinforce_guys" },
    { 0x8E57EB3C, "setup_remote_missile_target" },
    { 0x1DE60453, "setup_response_line" },
    { 0x16AA96F3, "setup_response_line_custom" },
    { 0x30E81BF6, "setup_response_line_override" },
    { 0x25D94529, "setup_response_waittime" },
    { 0x72919770, "setup_retreat_triggers" },
    { 0xFF091575, "setup_retrievable_hint_strings" },
    { 0x82E04ECB, "setup_retrievable_watcher" },
    { 0x243693D4, "setup_rex_starts" },
    { 0x669CBCCB, "setup_reznov" },
    { 0x1E057553, "setup_reznov_anim_array" },
    { 0x7584C1D3, "setup_richtofen_possessed_zombies" },
    { 0xA6149B61, "setup_ride_vignettes" },
    { 0x04760B6D, "setup_rider" },
    { 0x612C7D83, "setup_right_side_trap_guy" },
    { 0x43AD66A0, "setup_riotshield_vox" },
    { 0x26B07ADC, "setup_rival_hero" },
    { 0x45C10A49, "setup_rockect_map_icon" },
    { 0xEE86198E, "setup_rockets" },
    { 0x62047F0D, "setup_roof_flag_anims" },
    { 0xC6784BFA, "setup_roof_patrol" },
    { 0x33135E9C, "setup_room_and_context" },
    { 0x6E71514F, "setup_rope" },
    { 0x372B486B, "setup_rpg_avalanche1" },
    { 0xC523D930, "setup_rpg_avalanche2" },
    { 0x5363AF28, "setup_rpg_bridge" },
    { 0xD999FF0F, "setup_rpg_crate_and_trigger" },
    { 0xA6E3BF2A, "setup_rpg_ledge" },
    { 0x6DF78226, "setup_rpg_rpk_at_hilltop_guys" },
    { 0xFA541B9D, "setup_rpg_turret" },
    { 0x56901841, "setup_rts_generic_guys" },
    { 0xD3430166, "setup_rts_guy_model" },
    { 0x313D2BAF, "setup_rts_heroes" },
    { 0xD3C673FB, "setup_rts_spawnfunctions" },
    { 0xAAB97711, "setup_ru1" },
    { 0xD0BBF17A, "setup_ru2" },
    { 0x9C121A28, "setup_ruins_chimney" },
    { 0xE6F96842, "setup_runway_cessnas" },
    { 0x988CAEA9, "setup_runway_standoff" },
    { 0x241D3FA2, "setup_runway_trucks_and_drones" },
    { 0x1B5438F7, "setup_rus_flag_anims" },
    { 0x1AFEABE8, "setup_rusher" },
    { 0x08C9F3BB, "setup_rusher_anims" },
    { 0x0088C191, "setup_rusher_wounded_anim" },
    { 0x9F42BB74, "setup_russian_drone_paths" },
    { 0x1A1F42E0, "setup_safehouse_fps_convoy_vehicle" },
    { 0xE10F9FF0, "setup_sam_cougar" },
    { 0x756A8DDF, "setup_sas_buddies" },
    { 0xB760ECCC, "setup_satchel_anims" },
    { 0xC9C3D2F3, "setup_savimbi_for_battle" },
    { 0x80F3A30D, "setup_sc_guy" },
    { 0x7B244C18, "setup_scenes" },
    { 0xE293B3F9, "setup_sci_escort" },
    { 0xF742DB77, "setup_scientist_runners" },
    { 0x2F8F77F9, "setup_scope" },
    { 0x18C7D357, "setup_scope_view" },
    { 0x41C83444, "setup_script_gatetrigger" },
    { 0x7CDFEC7F, "setup_script_models" },
    { 0x691D8AA9, "setup_script_vehiclespawngroup" },
    { 0xC9550D9A, "setup_seagull_position" },
    { 0x829B4842, "setup_seat_control" },
    { 0x1A617DB7, "setup_second_jeep_ai" },
    { 0x70E42664, "setup_second_patrol" },
    { 0x4F1270F0, "setup_secondfloor_rush" },
    { 0x818F55F9, "setup_secsystem" },
    { 0x6042EE0D, "setup_section_1_vcs" },
    { 0xBA312C4E, "setup_section_2_vcs" },
    { 0x15C78B89, "setup_section_challenges" },
    { 0x840DD621, "setup_self_elite_anim_array" },
    { 0x19BC294A, "setup_sergei_anim_array" },
    { 0x6074719B, "setup_sergei_door" },
    { 0xE5F2913F, "setup_setgoalvolume_trigger" },
    { 0x4FEE2EF7, "setup_shot" },
    { 0xCDEDB7F7, "setup_shotgun_anim_array" },
    { 0xB30C9D56, "setup_simple_primary_lights" },
    { 0x5851352A, "setup_single_ambush" },
    { 0x754F0E4D, "setup_skipto" },
    { 0x6A55AA44, "setup_skipto_rappel" },
    { 0x673254CC, "setup_skiptos" },
    { 0x03738992, "setup_slingshot" },
    { 0xB720F533, "setup_slingshot_friendly_fire" },
    { 0x874B5568, "setup_sm_handoff_triggers" },
    { 0x01F809F4, "setup_sm_progresstriggers" },
    { 0x0810D0F5, "setup_small_boat" },
    { 0x48BB2136, "setup_smashtv_loadout" },
    { 0x52AB45BC, "setup_smg_anim_array" },
    { 0x231656EC, "setup_smoker" },
    { 0xDB73BA52, "setup_sniper_guy" },
    { 0x483ADB99, "setup_sniper_scientist" },
    { 0x9A9E441A, "setup_snowcat" },
    { 0x0A00FC13, "setup_snowcat_driver" },
    { 0x88C2F283, "setup_snowcat_passenger" },
    { 0x57ED755C, "setup_soct_riders" },
    { 0xE9ED4E7D, "setup_sortie" },
    { 0xF9811142, "setup_sound_variables" },
    { 0xCECE4CBC, "setup_spawn_funcs" },
    { 0x498EEE02, "setup_spawn_functions" },
    { 0x687E7770, "setup_spawn_sequence" },
    { 0xB0AB12B9, "setup_spawner_special_features" },
    { 0xE0D63CF4, "setup_spawners" },
    { 0xD74E8E8A, "setup_spawngroup_generics" },
    { 0xBAF692F4, "setup_specialty_perk" },
    { 0xDFC8F05F, "setup_spetsnaz_anim_array" },
    { 0xECC11A75, "setup_spetsnaz_rusher_anim_array" },
    { 0xEC84081E, "setup_spetz1" },
    { 0xC6818DB5, "setup_spetz2" },
    { 0x05B71F76, "setup_splitscreen_optimizations" },
    { 0xDCA3C50D, "setup_spot_target" },
    { 0x6C372B97, "setup_sq_debug" },
    { 0x0335829B, "setup_squad" },
    { 0x0A747868, "setup_squad_battle" },
    { 0x0FA78EA4, "setup_squad_member" },
    { 0x65D2D5E6, "setup_squad_movement_dialogue" },
    { 0x9E3CCAD8, "setup_sr71_runway_intro" },
    { 0x19205FEE, "setup_stabber" },
    { 0xE9A5BFD0, "setup_stairguy_alert" },
    { 0x9362E9A9, "setup_stairguy_notalert" },
    { 0x20D0930D, "setup_stairs_anim_array" },
    { 0xA8FB9229, "setup_standard_objects" },
    { 0xDBA191C7, "setup_standing_anim_array" },
    { 0x0D88D61C, "setup_start_node" },
    { 0xC3117535, "setup_static_character_customization_target" },
    { 0xDA3B4060, "setup_statue_anims" },
    { 0x2C27ED21, "setup_stealth_event" },
    { 0xAEF33F6B, "setup_stormtrooper" },
    { 0xFE0A64B1, "setup_stormtrooper_breach" },
    { 0x6771AA93, "setup_stormtrooper_heavy" },
    { 0xA5F1D87B, "setup_story_states" },
    { 0x708373B4, "setup_strafer" },
    { 0x641B35C3, "setup_street_cops_for_plaza" },
    { 0x361C8FA2, "setup_street_middle" },
    { 0x3C026325, "setup_stretcher_anim" },
    { 0xCA7E6D7B, "setup_strings" },
    { 0xA82F0DE4, "setup_stuck_event" },
    { 0x4B129D37, "setup_stuck_infantry" },
    { 0x5B614BB9, "setup_suicide_guy" },
    { 0xC351CC82, "setup_suicide_scientist" },
    { 0xBF796655, "setup_supply_drop_anims" },
    { 0x3D4489D5, "setup_supply_guys" },
    { 0xD29DD34E, "setup_surfer_truck" },
    { 0x80643734, "setup_surrender_dialogue" },
    { 0xD8967EAD, "setup_surrender_triggers" },
    { 0x3D311E8C, "setup_swinging_light" },
    { 0x55EB1E73, "setup_table_hindbehind_guy" },
    { 0xDB4C0C15, "setup_table_pulldown_guy" },
    { 0x6F620F44, "setup_tablet_devgui" },
    { 0x3DCF65B3, "setup_tank" },
    { 0x751FA0E7, "setup_tank_guy" },
    { 0x85D138F6, "setup_tank_trap_tank" },
    { 0x45B95262, "setup_tanks" },
    { 0x58EDA060, "setup_tape_knockover" },
    { 0x3599D8D3, "setup_targetname_spawners" },
    { 0xE3B3BBE2, "setup_tarmac_fx" },
    { 0xEFC9EBEC, "setup_team_follow_triggers" },
    { 0xCEFE00A9, "setup_teamgather" },
    { 0x29D1F2FD, "setup_teleport_aftereffects" },
    { 0x5B8EBA70, "setup_teleported_guys" },
    { 0xF03654B2, "setup_teleporter_screen" },
    { 0xF386FEEC, "setup_temp_sloth_triggers" },
    { 0x54614ECB, "setup_terrain_brass_sounds" },
    { 0x06F7A0B1, "setup_terrain_sounds" },
    { 0x0B032555, "setup_threat_bias" },
    { 0x60FB4941, "setup_threat_bias_group" },
    { 0x5A15EE68, "setup_threat_bias_groups" },
    { 0x1B68C204, "setup_threatbiases" },
    { 0xD0E5AB98, "setup_threatbiasgroups" },
    { 0x151DED84, "setup_throwchain" },
    { 0x5B4A274E, "setup_throwchain_clearjunkvars" },
    { 0xDEACFB9D, "setup_throwchain_dummy_path" },
    { 0x2A0CB683, "setup_throwchain_dummy_path_clearjunkvars" },
    { 0xD0FFA978, "setup_thug_anims" },
    { 0xC6A823B9, "setup_thundergun_vox" },
    { 0x71202A3B, "setup_time_bomb_detonation_model" },
    { 0x4ED6C8D4, "setup_timer_hudelems" },
    { 0x03407AED, "setup_tmp_detour_node" },
    { 0xC1ECF2DC, "setup_tomb_spawn_groups" },
    { 0x946F957D, "setup_topside_water" },
    { 0xF4EB5053, "setup_tow" },
    { 0x03AAAD29, "setup_train_station_anims" },
    { 0x6CE16686, "setup_traincar_door" },
    { 0xA03718BA, "setup_trainyard_gunners" },
    { 0x3507AB74, "setup_trainyard_wavers" },
    { 0x0A7BC9F3, "setup_traversal_anim_array" },
    { 0xBC375ECA, "setup_traversals" },
    { 0x24193C48, "setup_triggers" },
    { 0x604F01E6, "setup_truck_reinforce" },
    { 0x09403D18, "setup_tunnel_guys" },
    { 0x021E8599, "setup_tunnel_radio" },
    { 0x00D51479, "setup_tunnel_signaler" },
    { 0x800BDAFC, "setup_turret_damage_states" },
    { 0x45FAD1D5, "setup_tutorial" },
    { 0x4F809FF6, "setup_types" },
    { 0x01025994, "setup_ui3d" },
    { 0xEFDC9183, "setup_ui3d_full_dec20" },
    { 0x20BD4592, "setup_ui3d_normal" },
    { 0xF6D94591, "setup_umbilical_water" },
    { 0xA1576215, "setup_unitrigger" },
    { 0xD0740A00, "setup_unitrigger_buildable" },
    { 0xEA2ECDAA, "setup_unitrigger_buildable_array" },
    { 0xF924A1D8, "setup_unitrigger_buildable_internal" },
    { 0x56F80F8A, "setup_unitrigger_craftable" },
    { 0x779D19E8, "setup_unitrigger_craftable_array" },
    { 0x4832D516, "setup_unitrigger_craftable_internal" },
    { 0xC182432C, "setup_units" },
    { 0xF3402006, "setup_unlockable_music_tracks" },
    { 0x3091AFEC, "setup_vc_anim_array" },
    { 0xAECBB218, "setup_vc_rusher_anim_array" },
    { 0xFEF4712B, "setup_vc_rusher_wounded_anim" },
    { 0xAE560CD8, "setup_veh_spawn_funcs" },
    { 0x5CF8B42B, "setup_vehicle_damage" },
    { 0x323CDB1E, "setup_vehicle_other" },
    { 0xD7A0739D, "setup_vehicle_pause_node" },
    { 0x0DF78883, "setup_vehicle_regen" },
    { 0xC9FE3638, "setup_vehicle_tank" },
    { 0x005D77DB, "setup_vehicle_unitrigger_buildable" },
    { 0xAA10BBD9, "setup_vehicle_unitrigger_craftable" },
    { 0xD658F634, "setup_vehicles" },
    { 0x869054C7, "setup_victim" },
    { 0xEF90D82C, "setup_vig_ai" },
    { 0xAD5E9C2C, "setup_visionset_trigger" },
    { 0xAA6E3C2F, "setup_visionset_triggers" },
    { 0xB3C3C0CE, "setup_vo" },
    { 0xC326D15C, "setup_vtol" },
    { 0x94459B16, "setup_vtol_crash_site" },
    { 0xFC2303D7, "setup_vtol_escape_amb" },
    { 0x45ABD7CA, "setup_vtol_pieces" },
    { 0x5B7B1479, "setup_vtol_turret" },
    { 0xA664DA2E, "setup_vulture" },
    { 0xD84A0851, "setup_vultures" },
    { 0xCA0A3A30, "setup_war_map" },
    { 0x360C7AB0, "setup_warehouse_super_soct" },
    { 0xDCDFD2A4, "setup_watchers" },
    { 0xBD8A9CE6, "setup_water_physics" },
    { 0xF699D318, "setup_wave_manager" },
    { 0xD1C14D3F, "setup_wave_one_launchers" },
    { 0x353BB911, "setup_wave_two_launchers" },
    { 0x383E42F1, "setup_waving_guy" },
    { 0x425E8649, "setup_wc_extracam_settings" },
    { 0xFAE2B2CA, "setup_wc_weapon_model" },
    { 0x417ABFDC, "setup_weapon_attachments" },
    { 0x93FBED56, "setup_weapon_cabinet" },
    { 0x23DA54DB, "setup_weapon_caches" },
    { 0xC7CEC620, "setup_weapon_targets" },
    { 0xED58558D, "setup_weather_devices" },
    { 0x07268F73, "setup_weaver_fps" },
    { 0xCCE70486, "setup_welder" },
    { 0x2A2CD4BE, "setup_welder_prop" },
    { 0xCA5F9204, "setup_window_anims" },
    { 0x7803233C, "setup_woman_anims" },
    { 0x48B64686, "setup_woodbeam_anims" },
    { 0xA8EA77C0, "setup_woodchoppers" },
    { 0x4A659F08, "setup_woods_anims" },
    { 0xDD084CC3, "setup_woods_kill_standing_guard" },
    { 0x519E7670, "setup_wounded_anims" },
    { 0xF10A128A, "setup_wounded_anims_callback" },
    { 0x0036FBA9, "setup_wristwatch" },
    { 0x647A12C5, "setup_xform_buttons" },
    { 0x5730EA73, "setup_xform_menu" },
    { 0xBCA3325B, "setup_zcoast_water" },
    { 0x1D0E3D1E, "setup_zipline_flags" },
    { 0x2B16BE40, "setup_zipline_guard" },
    { 0xBD5BDCAE, "setup_zipline_room_guard" },
    { 0x9FBFF45E, "setup_zombie_attack_points" },
    { 0x71AA5C55, "setup_zombie_exerts" },
    { 0x73FC635E, "setup_zombie_init" },
    { 0xD9D8E0B0, "setup_zombie_knockdown" },
    { 0x58DAD115, "setup_zone_1_special" },
    { 0x3D3105D5, "setup_zone_flag_waits" },
    { 0x64A9E6F2, "setup_zone_monitor" },
    { 0xA675049C, "setup_zones" },
    { 0xE61EF822, "setupaapproachnodepreconditions" },
    { 0xBECF901E, "setupaction" },
    { 0x344356CB, "setupaim" },
    { 0x2E2348EF, "setupanim" },
    { 0x441E439F, "setupanimtree" },
    { 0x4EF508E8, "setupapproachnode" },
    { 0xBC27687D, "setupapproachnodedebug" },
    { 0x1761449B, "setupareatriggertargetname" },
    { 0x8896F283, "setupattackproperties" },
    { 0xB62F1260, "setupbaseicon" },
    { 0xCF9A1A64, "setupblankrandomplayer" },
    { 0x0AE696E6, "setupbombsquad" },
    { 0x51F86B78, "setupcallbacks" },
    { 0xEFAAC99F, "setupcargospots" },
    { 0xCFA3686C, "setupchargemeleeattack" },
    { 0x2F484A60, "setupclientfieldcodecallbacks" },
    { 0x1372736D, "setupclingtrigger" },
    { 0xDFD80445, "setupcombatrobothinttrigger" },
    { 0xA919F53A, "setupcqbpointsofinterest" },
    { 0xBDABE901, "setupcurtains" },
    { 0x3073278B, "setupcustomcharacterexerts" },
    { 0xD3F5BB28, "setupdamagehandling" },
    { 0xBF1D27E2, "setupdogspawnlocs" },
    { 0x07F98D4E, "setupeq" },
    { 0x84CFC5EF, "setupexploder" },
    { 0x883EB836, "setupexploders" },
    { 0x62926354, "setupexplosionanimscale" },
    { 0x928A4E20, "setupexposedset" },
    { 0x3B1E4CBE, "setupfordefusing" },
    { 0xBC0EA906, "setupgametype" },
    { 0xE6CB3F54, "setupguidedmissile" },
    { 0x8255A76E, "setuphats" },
    { 0xA4CE8B04, "setupkillcament" },
    { 0x2D24E1A4, "setupmapboundary" },
    { 0xA471E46D, "setupminimap" },
    { 0x903B2BBA, "setupmissileboundary" },
    { 0xD035B25A, "setupmissilecompassicons" },
    { 0xD9779084, "setupmodelandanimation" },
    { 0x15F74249, "setupmusic" },
    { 0xC49B1001, "setupmusiccodes" },
    { 0x89CC4E4C, "setupmusicstate" },
    { 0xDAEEC435, "setupnearbyspawns" },
    { 0x72D1A13B, "setupnetworkintruder" },
    { 0xD2EA5C61, "setupnextflag" },
    { 0x6E43CA87, "setupnodes" },
    { 0xF0804800, "setupradios" },
    { 0xDA002B6E, "setuprageloopid" },
    { 0xF064FCAB, "setuprandomtable" },
    { 0xF39ABB1E, "setupreaperminigun" },
    { 0x0DBED966, "setupreconeffect" },
    { 0x6D94050E, "setupretrievablehintstrings" },
    { 0x5C2883B9, "setupretrievablewatcher" },
    { 0x0CCD9B53, "setuprevive" },
    { 0x0755D7CD, "setuprocketcamera" },
    { 0x03FD2A5B, "setups" },
    { 0xDE07CAFC, "setupsafezones" },
    { 0xF4AE93EA, "setupscriptmovercompassicons" },
    { 0x178568DB, "setupspawngraphpoint" },
    { 0x21211A7B, "setupstring" },
    { 0xB5FF6F1A, "setuptabunfx" },
    { 0xA6C47ABB, "setuptarget" },
    { 0xEBFF918B, "setupteam" },
    { 0xC7516F2F, "setuptraits" },
    { 0x89234D40, "setupturrethealth" },
    { 0xF9D56ED5, "setupuniqueanims" },
    { 0x530C5EA3, "setupwatchers" },
    { 0xADE2925A, "setupwaterfall" },
    { 0x7644BCCD, "setupwaterfall_waterfall_csc" },
    { 0xA63903C5, "setupwaterfallmist" },
    { 0x3BA8B432, "setupwaterfallmist_waterfall_csc" },
    { 0x8943F0CD, "setupzoneexclusions" },
    { 0x111AE6AD, "setupzones" },
    { 0x78DB8FF6, "setusedstat" },
    { 0x060248F2, "setusehinttext" },
    { 0x58F382A9, "setusetext" },
    { 0x9047C95F, "setusetime" },
    { 0xC5ED98DF, "setusingremote" },
    { 0xEE69B16E, "setvalue" },
    { 0x39E91FAD, "setvehgoalnode" },
    { 0xC985552D, "setvehgoalpos" },
    { 0x1262ECFC, "setvehgoalpos_wrap" },
    { 0x0513D5D1, "setvehicleattachments" },
    { 0x7E56B50D, "setvehicleavoidance" },
    { 0xF8D63C75, "setvehicledamagemeter" },
    { 0xCD99462E, "setvehicledrivableduration" },
    { 0x6FEEC9BE, "setvehicledrivableendtime" },
    { 0x55E445CC, "setvehiclefordropdeploy" },
    { 0x56F9CE3B, "setvehiclefx" },
    { 0xFF588F8C, "setvehiclelockedon" },
    { 0x4DA68CB2, "setvehiclelockedonbyent" },
    { 0xF25938C6, "setvehiclelookattext" },
    { 0x8972A1DA, "setvehicleteam" },
    { 0x13193225, "setvehicletype" },
    { 0x993CC27E, "setvehicleweaponwaitduration" },
    { 0xB73C36AE, "setvehicleweaponwaitendtime" },
    { 0xE0A794CF, "setvehmaxspeed" },
    { 0x5BA4A2FD, "setvehvelocity" },
    { 0x3F3534A8, "setvehweapon" },
    { 0xF5DF04E6, "setvelocity" },
    { 0x89A53015, "setvictoryquote" },
    { 0x67B5FE65, "setviewclamp" },
    { 0xEBAA4514, "setviewlockent" },
    { 0xB44E136F, "setviewmodel" },
    { 0x060DC9CF, "setviewmodeldepthoffield" },
    { 0x1E2546AD, "setviewmodelrenderflag" },
    { 0xEE2C4706, "setviewpos" },
    { 0xADCFB1E0, "setvisiblecarriermodel" },
    { 0xC0F24776, "setvisiblescoreboardcolumns" },
    { 0xDE1D4550, "setvisibleteam" },
    { 0xBB863F19, "setvisibletoall" },
    { 0x757633A9, "setvisibletoallexceptteam" },
    { 0x858AC43F, "setvisibletoplayer" },
    { 0x1CAFE98B, "setvisibletoteam" },
    { 0x236D1EE9, "setvisionsetforplayer" },
    { 0xABC89FB3, "setvisionsetwaiter" },
    { 0xCE109086, "setvolfog" },
    { 0xDC82F8CE, "setvolfogforclient" },
    { 0xC6B5DC00, "setwagerafteractionreportstats" },
    { 0x576C147B, "setwagerwinningsonplayers" },
    { 0x7A825C54, "setwaitnode" },
    { 0xBA7C2461, "setwaitspeed" },
    { 0xDB86EB4D, "setwargamedata" },
    { 0x13ED0A8B, "setwarlordaggressivemode" },
    { 0xC0E855B7, "setwatchstyle" },
    { 0x99752B40, "setwaterbrush" },
    { 0x2936EECE, "setwaterdrops" },
    { 0x982700E0, "setwaterfog" },
    { 0x0433E02F, "setwatersheeting" },
    { 0x26B3BD1E, "setwaypoint" },
    { 0x454720A3, "setweapon" },
    { 0x67795B5F, "setweaponammoclip" },
    { 0x4079F435, "setweaponammofuel" },
    { 0x8DE272C8, "setweaponammooverall" },
    { 0xCDF98BCD, "setweaponammostock" },
    { 0x39D0E24F, "setweaponchallengeorstat" },
    { 0xE84545CF, "setweaponcosts" },
    { 0xAC014FDF, "setweapondist" },
    { 0xF316B4BF, "setweaponfriendlyhacking" },
    { 0xD89441AF, "setweaponfriendlytargeting" },
    { 0x5D56CE27, "setweaponfriendlytargetlocked" },
    { 0x8CB595A7, "setweaponhackpercent" },
    { 0xCD2CC2EC, "setweaponheatpercent" },
    { 0xBC4DC084, "setweaponlockonpercent" },
    { 0x6E92E06B, "setweaponoptions" },
    { 0x327FC665, "setweaponoverheating" },
    { 0x53033123, "setweaponrenderoptions" },
    { 0xB428FB49, "setweaponstat" },
    { 0x83608778, "setwetness" },
    { 0x01BBF9B3, "setwhitehot" },
    { 0x4B33DF3D, "setwidth" },
    { 0xC1DC0657, "setworldfogactivebank" },
    { 0x8C76EE08, "setxenonranks" },
    { 0xB53EBE89, "setyawspeed" },
    { 0x9D653A7D, "setzbarriercolmodel" },
    { 0xF64E9135, "setzbarrierpiecestate" },
    { 0xFA46F244, "setzombiename" },
    { 0x107248F0, "seven" },
    { 0x341C9E04, "seventeen" },
    { 0xEE42AD17, "seventstring" },
    { 0xAE41145D, "seventy" },
    { 0xF32F994B, "several" },
    { 0xA7347CC9, "severe" },
    { 0x58F9A72F, "severed" },
    { 0x82370994, "severely" },
    { 0x230922FC, "severing" },
    { 0x5F93E620, "severity" },
    { 0x14BB2583, "severity_max" },
    { 0xD9D1836D, "severity_min" },
    { 0x5FB65991, "sewer" },
    { 0x6FF66291, "sewer_entered" },
    { 0x30B8E4F0, "sewer_entry" },
    { 0x6BE37B81, "sewer_entry_fx" },
    { 0x53778244, "sewer_exit" },
    { 0x3709CE52, "sewer_exterior" },
    { 0x1E09A2D1, "sewer_exterior_ai_setup" },
    { 0x3E43D855, "sewer_exterior_harper_movement" },
    { 0x28BA288D, "sewer_exterior_harper_movement_complete" },
    { 0x76198630, "sewer_gate_clip_setup" },
    { 0x311F7188, "sewer_guard_logic" },
    { 0xE0A90FE5, "sewer_guard_shotat" },
    { 0x7BD815E5, "sewer_guard_spotlight_logic" },
    { 0x74042A3A, "sewer_guards_alerted" },
    { 0x09AE25EF, "sewer_guards_cleared" },
    { 0xDE3B1034, "sewer_interior" },
    { 0x32075621, "sewer_interior_skipto" },
    { 0xE8CC9C56, "sewer_light_off" },
    { 0xEDA5C8CB, "sewer_lights" },
    { 0x49C2FF6D, "sewer_move_up" },
    { 0xB61C0887, "sewer_reconstruct_ents" },
    { 0xDF653EBC, "sewer_searchlight_target_movement" },
    { 0x52008F43, "sewer_slide" },
    { 0x6ADFE978, "sewers" },
    { 0x0CE09BD3, "sex" },
    { 0x24783659, "sexiness" },
    { 0x7D0C93E1, "sexplosion" },
    { 0x06F88702, "sf" },
    { 0xBF9FF351, "sf_0_intensity" },
    { 0x659ACA1B, "sf_0_max_sprites" },
    { 0x6D4778CD, "sf_0_pos_x" },
    { 0x4744FE64, "sf_0_pos_y" },
    { 0xB94C6D9F, "sf_0_pos_z" },
    { 0x0889E9F9, "sf_0_size" },
    { 0xBF8AB920, "sf_1_intensity" },
    { 0xD308D5E6, "sf_1_max_sprites" },
    { 0x1B2BB45C, "sf_1_pos_x" },
    { 0x412E2EC5, "sf_1_pos_y" },
    { 0x6730A92E, "sf_1_pos_z" },
    { 0xAECD3C26, "sf_1_size" },
    { 0x027DDC41, "sf_civ_runners" },
    { 0x94F552E4, "sf_drive_by_guys" },
    { 0xE5CB2325, "sf_hero" },
    { 0x65C31E2D, "sf_runaway_guys" },
    { 0x348FF05F, "sf_spawn_drive_gate_1" },
    { 0xC2888124, "sf_spawn_drive_gate_2" },
    { 0xCC93BD34, "sf_touch_ai_allies" },
    { 0x873783CD, "sf_touch_ai_axis" },
    { 0x63E4A8CF, "sf_touch_ai_neutral" },
    { 0x7D228B87, "sf_touch_notplayer" },
    { 0xDA44B7E6, "sf_touch_once" },
    { 0x15A015D7, "sf_touch_vehicle" },
    { 0x6A59EEEF, "sf_turn_around_guys" },
    { 0x99D01CBB, "sf_vehicle" },
    { 0x0E502D96, "sfade" },
    { 0x6A768DE0, "sfare" },
    { 0xC8A1324A, "sflag" },
    { 0x612AB568, "sflagdepart" },
    { 0x4347B112, "sflagendon" },
    { 0x987C47D7, "sflagname" },
    { 0x20031144, "sflagplayernearbmp" },
    { 0xBBD92DBD, "sflagteaminposition" },
    { 0xCF29B9B3, "sflagventopen" },
    { 0x8B7801FE, "sfx" },
    { 0xF81CCC4B, "sfx_alias" },
    { 0x6BE6BDBF, "sfx_loop" },
    { 0x51E9A553, "sfx_loop_delay" },
    { 0xA30E9BF4, "sfx_off" },
    { 0x3608DA7E, "sfx_on" },
    { 0xCE7A643F, "sfx_start" },
    { 0xE9C95B47, "sfxandfx" },
    { 0x2CFB016B, "sg" },
    { 0xC7C5DDE1, "sg_anim" },
    { 0xB240BB75, "sg_animtree" },
    { 0x5C718866, "sg_csv_addtype" },
    { 0xC3A14E47, "sg_csv_soundadd" },
    { 0x86934EDD, "sg_effect" },
    { 0x0995C175, "sg_getanim" },
    { 0x1516CAC1, "sg_getanimtree" },
    { 0x0B18F840, "sg_getfx" },
    { 0x2FD3B64D, "sg_precache" },
    { 0x3976E3D2, "sg_precacheanim" },
    { 0x429D1CDD, "sg_precacheanims" },
    { 0xA9421EBB, "sg_precachefx" },
    { 0xF049F588, "sg_precacheitem" },
    { 0x620075F0, "sg_precachemenu" },
    { 0xCA4D57D4, "sg_precachemodel" },
    { 0x92EC848A, "sg_precacherumble" },
    { 0x0606CCCC, "sg_precaches" },
    { 0x908AE8CE, "sg_precacheshader" },
    { 0xB38B47B1, "sg_precacheshellshock" },
    { 0x659942FE, "sg_precachestring" },
    { 0x64FBAB4B, "sg_precacheturret" },
    { 0xE74A047F, "sg_precachevehicle" },
    { 0xB86C2843, "sg_standard_includes" },
    { 0x8D6E36DA, "sg_wait_dump" },
    { 0x9FD668BA, "sgc" },
    { 0xFA13D4BA, "sgen" },
    { 0x1B512FC2, "sgjammerprotection" },
    { 0x72057E85, "sgt" },
    { 0x4B0E6F61, "sgt_1" },
    { 0x7110E9CA, "sgt_2" },
    { 0x97136433, "sgt_3" },
    { 0xA9978BB9, "sgvolume" },
    { 0x9807F8EE, "sgw" },
    { 0x5D647BDD, "sh_clip" },
    { 0x9F78BA81, "sh_found" },
    { 0x72063369, "sh_l_left_shudder" },
    { 0x5B8C6B70, "sh_l_right_shudder" },
    { 0x6107A0FF, "sh_r_left_shudder" },
    { 0x4807EC26, "sh_r_right_shudder" },
    { 0x09FF22E7, "shabestari" },
    { 0x22940104, "shabs" },
    { 0x57F7A607, "shack" },
    { 0x19A82C62, "shack_cleared" },
    { 0x2F443AD9, "shack_glow" },
    { 0xBF626972, "shack_guys" },
    { 0xE16F41BE, "shack_light" },
    { 0xBF16590F, "shack_normal" },
    { 0x3A8999CE, "shack_obj_org" },
    { 0xCC40D38A, "shack_signal" },
    { 0x1E6DAE46, "shack_sleeper" },
    { 0x08047DFE, "shacks" },
    { 0xB861723E, "shader" },
    { 0x6978B057, "shader_2x" },
    { 0x9824E321, "shader_amount" },
    { 0xE0EEDFC5, "shader_digit_x" },
    { 0xBAEC655C, "shader_digit_y" },
    { 0x5AE339B0, "shader_height" },
    { 0x24385040, "shader_inited" },
    { 0xECC440D9, "shader_inst" },
    { 0x2B01B3D2, "shader_insta" },
    { 0x0A53AE72, "shader_invalid" },
    { 0xB1B6E664, "shader_invalid_offscreen" },
    { 0x3D3ED0D8, "shader_lock" },
    { 0x2D7E54C0, "shader_locking" },
    { 0x5C7CB1A4, "shader_name" },
    { 0xF3376934, "shader_reference" },
    { 0x27F1AA16, "shader_target" },
    { 0x1EA06770, "shader_target_offscreen" },
    { 0x1B743660, "shader_vec_blue" },
    { 0x4F6E7F55, "shader_vec_green" },
    { 0x9545ECB1, "shader_vec_red" },
    { 0xE924E8C8, "shader_white" },
    { 0xBA405D53, "shader_width" },
    { 0x5EB52929, "shaderanim" },
    { 0xBD335209, "shaderanim_animate_cracks" },
    { 0x3DBE2193, "shaderanim_shared" },
    { 0xAB0A3ED5, "shaderanim_update_opacity" },
    { 0x402C9C53, "shaderconstantname" },
    { 0xC5DD3283, "shadername" },
    { 0x8BD95C0E, "shadername_arg" },
    { 0xFA79EB21, "shaders" },
    { 0x213FD81C, "shaderworks" },
    { 0xDE63ECA7, "shades" },
    { 0xDA5FF756, "shadesmodel" },
    { 0x54A42215, "shadow" },
    { 0x0FAD54A6, "shadow_trig" },
    { 0x80654110, "shadowcasting" },
    { 0xEB3073DF, "shadowdistdraw" },
    { 0x361B7375, "shadowmap" },
    { 0x23FFDA7A, "shadowplane_org" },
    { 0x9E66152E, "shadowrunners" },
    { 0x4181DE64, "shadows" },
    { 0xF01CA557, "shaft" },
    { 0xCAC38B31, "shake" },
    { 0x179DD6F9, "shake_and_rumble" },
    { 0x7CEFF5BD, "shake_base_icon" },
    { 0xF8C9C71D, "shake_base_lights" },
    { 0x50E26553, "shake_it" },
    { 0xFA2B25B5, "shake_jeep_ride" },
    { 0x31BC2CED, "shake_maxwait" },
    { 0xBFBE40C2, "shake_on_jump" },
    { 0xB87DBB36, "shake_org" },
    { 0x449C3215, "shake_player_effect" },
    { 0xA74DF499, "shake_player_ref" },
    { 0xA8F5C16D, "shake_position" },
    { 0xE59CF42F, "shake_size" },
    { 0xD15DC29C, "shake_stop" },
    { 0x60B4D564, "shake_tank" },
    { 0x6CCC6B67, "shake_time" },
    { 0xC65A6154, "shakecamera" },
    { 0x1143A298, "shakes" },
    { 0xD435B5E6, "shaketime" },
    { 0x2D66A523, "shaketrig" },
    { 0x0F1804E4, "shaking" },
    { 0x92E1481D, "shaky" },
    { 0xE678F7BD, "shall" },
    { 0x8152E124, "shameless" },
    { 0x4A3ABBC1, "shamelessly" },
    { 0x5F6DA3F9, "shandtag" },
    { 0xF35B8446, "shane" },
    { 0xEFE89ABE, "shanghai" },
    { 0xDB9E13DB, "shangri" },
    { 0x59766B1C, "shanty" },
    { 0x281B886C, "shanty_allies_cqb_through" },
    { 0x527FB56E, "shanty_fence" },
    { 0x1E7F25FF, "shanty_fence_cut" },
    { 0xD7970A31, "shanty_fence_cut_setup" },
    { 0x191F563E, "shanty_opens" },
    { 0x9658999A, "shanty_run" },
    { 0x0E35C73D, "shanty_run_drop_weapon" },
    { 0x1780BE27, "shanty_run_trigger" },
    { 0x5A9B54CA, "shanty_timer" },
    { 0x5252F3BF, "shantymusictrig" },
    { 0xDA125690, "shantytown" },
    { 0x21137F48, "shape" },
    { 0x32A92F5C, "shaped" },
    { 0xAC7F0E63, "shapes" },
    { 0x23E4B2F2, "share" },
    { 0x275B6D65, "share_screen" },
    { 0x1BE9B0B2, "shared" },
    { 0x236AA966, "shared_ammo_weapon" },
    { 0x454D7744, "shared_callback_damage" },
    { 0x31209A1B, "shared_crafting_in_progress" },
    { 0xD266A2B2, "shared_generic_human" },
    { 0xBFCF7298, "shared_portable_turrets" },
    { 0xAB895D81, "shared_scene_sequence" },
    { 0x9D7E58C5, "shared_scene_sequence_name" },
    { 0xA1D36213, "shared_scene_sequence_started" },
    { 0x6C2F40E6, "shared_turrets" },
    { 0x81CDD7D5, "sharedigc" },
    { 0xEE18C67D, "shares" },
    { 0xEC961B24, "shares_trigger" },
    { 0x117AF0B4, "sharestat" },
    { 0xD3CE76A3, "sharing" },
    { 0x9FFD7B0C, "shark" },
    { 0x37EDA22D, "shark_init" },
    { 0x175862AE, "shark_path" },
    { 0x27A9E9D1, "shark_paths" },
    { 0xFFB830BC, "sharks_big_group" },
    { 0xA064A2C8, "sharks_rescue_one" },
    { 0x4218BD8F, "sharp" },
    { 0x44B35622, "sharp_left_turn_driver_anim" },
    { 0xD26FA7CA, "sharp_left_turn_passenger2_anim" },
    { 0x7326A4E4, "sharp_left_turn_passenger_anim" },
    { 0xBA286B99, "sharp_right_turn_driver_anim" },
    { 0xAC300FF1, "sharp_right_turn_passenger2_anim" },
    { 0xA4675789, "sharp_right_turn_passenger_anim" },
    { 0x02A1F531, "sharp_turn_left" },
    { 0x825C59DC, "sharp_turn_right" },
    { 0x4B6F05EE, "sharpen" },
    { 0x8C888EF5, "sharpshooter" },
    { 0xA7F2A2A4, "sharpshootermultiplier" },
    { 0xD77578CC, "shatter" },
    { 0x49F460A5, "shatter_trigger" },
    { 0xC6801CAF, "shattered" },
    { 0x563B289F, "shattered2" },
    { 0x94D68E2A, "shattered_1_done" },
    { 0xB44B678B, "shattered_1_explosion" },
    { 0xB133519E, "shattered_1_slow_mo_end" },
    { 0xA5281A0D, "shattered_1_slow_mo_start" },
    { 0xE4D6D485, "shattered_1_started" },
    { 0x9C4022D6, "shattered_part_two" },
    { 0x6377BE6D, "shattered_part_two_grenade_explosion" },
    { 0xB3278C30, "shattered_part_two_headlook_off" },
    { 0xDA942A8A, "shattered_part_two_timescale_normal" },
    { 0xD0C250E4, "shattered_part_two_timescale_slow" },
    { 0x0DB41B7C, "shattering" },
    { 0x0D0A264F, "shatters" },
    { 0xD7BF1ECE, "shave" },
    { 0xC836B50E, "shaved" },
    { 0xDACC0776, "shawn" },
    { 0xBD4A3279, "she" },
    { 0x4C8810FF, "shed" },
    { 0xF87CE561, "shed_door_nag" },
    { 0x1DC9DDDA, "shed_door_wait" },
    { 0xCDD025A0, "sheer" },
    { 0xB1DF0416, "sheet" },
    { 0x80FCF40A, "sheeting" },
    { 0xE69351EE, "sheeting_time" },
    { 0xBED2F5CC, "sheeting_time_s" },
    { 0x5146640B, "sheetmetal" },
    { 0xF3263F62, "sheild" },
    { 0xE3757F93, "shelf" },
    { 0x18B4F733, "shelf_anim_setup" },
    { 0x5CC0283B, "shelf_push_trigger_press" },
    { 0x70EA6F21, "shelf_pushed" },
    { 0x675CB779, "shell" },
    { 0x27ACC95A, "shellaccuracyradiusmax" },
    { 0xEA48BE44, "shellaccuracyradiusmin" },
    { 0x5DC5BDB0, "shells" },
    { 0xF1AA5A21, "shellshock" },
    { 0x2B155DCC, "shellshock_duration" },
    { 0xF5451EAE, "shellshock_file" },
    { 0x6835CBBC, "shellshock_thread" },
    { 0x669EC60E, "shellshocked" },
    { 0xE2956E49, "shellshockondamage" },
    { 0xA6760C4A, "shellshockonplayerdamage" },
    { 0x620870A1, "shellshockplayers" },
    { 0x7D0EE4C8, "shellshocks" },
    { 0xA8826095, "shellshockscalar" },
    { 0x077208E4, "shellwaitmax" },
    { 0xF253614A, "shellwaitmin" },
    { 0x6564D9F8, "shelter" },
    { 0x49CD9C47, "shelves" },
    { 0x47ABC227, "shelving_physics_explosion" },
    { 0x63B7B6E4, "shenanigans" },
    { 0x0752F5F7, "sherman" },
    { 0x57824A24, "sherman_1a" },
    { 0x942CBD4B, "sherman_1a_shoot_strat" },
    { 0xDC74D953, "sherman_1a_strat" },
    { 0xC989B95F, "sherman_1b" },
    { 0x029A28EC, "sherman_1b_shoot_strat" },
    { 0x2139FF74, "sherman_1b_strat" },
    { 0xE8105995, "sherman_2a" },
    { 0x8D22FAF6, "sherman_2a_shoot_strat" },
    { 0x05CD7CC6, "sherman_2a_strat" },
    { 0x0E12D3FE, "sherman_2b" },
    { 0x3B981579, "sherman_2b_shoot_strat" },
    { 0xB1282869, "sherman_2b_strat" },
    { 0x94A36899, "sherman_3a_strat" },
    { 0x338592B6, "sherman_3b_strat" },
    { 0x72A4D3A8, "sherman_wave_3a" },
    { 0xE4AC42E3, "sherman_wave_3b" },
    { 0x45B13C2E, "shermans" },
    { 0x8F01015B, "shermans_1_dead" },
    { 0x533623B2, "shermans_2_dead" },
    { 0x3FA7A4E1, "shermans_3_dead" },
    { 0x9ADCE973, "shermans_3b_dead" },
    { 0x974491C3, "shermans_fire_towards_bunkers" },
    { 0x339677EB, "shermans_point_turrets_forward" },
    { 0x640B2DB8, "shermans_wave_3" },
    { 0x3AE17EC6, "sherwood" },
    { 0x5F6574FC, "shh" },
    { 0x99B8E35C, "shhh" },
    { 0x4E9C5CEA, "shield" },
    { 0x70011837, "shield1" },
    { 0xFDF9A8FC, "shield2" },
    { 0x28746BA2, "shield_1" },
    { 0x0271F139, "shield_2" },
    { 0x6D384633, "shield_add_enemy" },
    { 0x78E12272, "shield_anim_move" },
    { 0x62FC407B, "shield_anim_stand" },
    { 0x50033FB7, "shield_blocked" },
    { 0x01033DFB, "shield_built" },
    { 0xF9021218, "shield_charge_powerup" },
    { 0x054E8096, "shield_damage" },
    { 0xD06E4585, "shield_damage_level" },
    { 0x64899BBE, "shield_debug" },
    { 0x64F60518, "shield_deploy" },
    { 0xDB05DC14, "shield_deployment" },
    { 0x96F0DB77, "shield_dmg" },
    { 0x52E168E0, "shield_elem" },
    { 0xF316EFA1, "shield_elem_fade" },
    { 0x5068BC60, "shield_ent" },
    { 0xFCFC23B7, "shield_equipment" },
    { 0xF79912DD, "shield_flag_on" },
    { 0x539C6B73, "shield_flicker" },
    { 0x6BD6FD73, "shield_gadget_off" },
    { 0x197D995F, "shield_gadget_on" },
    { 0x81349899, "shield_guard_think" },
    { 0xDB9DC2F4, "shield_is_flickering" },
    { 0x7C860F1A, "shield_is_inuse" },
    { 0x3B383993, "shield_is_on" },
    { 0x45488759, "shield_juke_done" },
    { 0x8593B700, "shield_model" },
    { 0xEE1B6BB9, "shield_monitor" },
    { 0x2035417E, "shield_move" },
    { 0xC9522600, "shield_nodes" },
    { 0xD225E6C0, "shield_off" },
    { 0xBDEBB145, "shield_on_connect" },
    { 0x2EC94EA3, "shield_on_flicker" },
    { 0x2D63EF0E, "shield_on_give" },
    { 0x3D5DA8F8, "shield_on_hud" },
    { 0xC654E420, "shield_on_take" },
    { 0x8BA432F7, "shield_origin" },
    { 0x9E4DB63E, "shield_placement" },
    { 0xD0CE58BB, "shield_planted" },
    { 0xBEE24CF0, "shield_raise_or_lower_gun" },
    { 0x7AED589C, "shield_recharge_spawnpoint" },
    { 0xDEFDE6BA, "shield_recharge_trigger_think" },
    { 0x2662EACC, "shield_run" },
    { 0xCE250BEC, "shield_setup" },
    { 0x77AB3E63, "shield_state_change" },
    { 0xB6160577, "shield_trigger" },
    { 0xE6711E4E, "shield_trigger_think" },
    { 0x2F7E3565, "shield_until_player" },
    { 0x5B157260, "shield_vo" },
    { 0x4524A629, "shield_weapon" },
    { 0xDC9A3380, "shield_zombie_arrive_func" },
    { 0x48131CA2, "shield_zombie_attract_func" },
    { 0xA5380336, "shieldbulletblocklimit" },
    { 0x135AAEA1, "shielddamage" },
    { 0x85660EBF, "shielddamageblocked" },
    { 0xE1125BC6, "shielddamagetaken" },
    { 0x476C14E8, "shielddeployanim" },
    { 0x3157C07D, "shielded" },
    { 0x279CB0F6, "shieldexpansionncolor" },
    { 0x6936235C, "shieldexpansionvaluex" },
    { 0x2EDFC800, "shieldfacing" },
    { 0x48AEFE04, "shieldhealth" },
    { 0x51FDBA3D, "shieldhit" },
    { 0x72427AC6, "shielding" },
    { 0x31418904, "shieldlightfx" },
    { 0xA49ABDA5, "shields" },
    { 0xF7827DFF, "shift" },
    { 0x92824804, "shifted" },
    { 0xBFF5BF3A, "shiftheld" },
    { 0xBC342A81, "shifting" },
    { 0x336AB5A3, "shiftpoint" },
    { 0xE6A89206, "shifts" },
    { 0x43792DD5, "shiftsides" },
    { 0x9666C678, "shiiiiiiiit" },
    { 0x78911867, "shiiiiit" },
    { 0x89E4F844, "shiiiit" },
    { 0x66FD3735, "shiiit" },
    { 0x8EE8F3B8, "shiled" },
    { 0xDCFCC606, "shimmer" },
    { 0x0E0B26EC, "shimmies" },
    { 0x899B2E15, "shimming" },
    { 0x73F21DF1, "shin" },
    { 0xA83EAA3E, "shine" },
    { 0x93B91321, "shines" },
    { 0xD07A4717, "shingledecker" },
    { 0xD4D99F15, "shinhoto" },
    { 0x15B5A564, "shinhotos" },
    { 0x49A44657, "shining" },
    { 0x1C1E9DD4, "shinnanagans" },
    { 0x30C2A080, "shintstring" },
    { 0xA257A974, "shinyo_boat_death_thread" },
    { 0x8FCD174B, "shinyo_boat_init" },
    { 0xE8F47241, "shinyo_engine_fx_control" },
    { 0x5A0F21FE, "shinyou" },
    { 0xAA9DC305, "shinyou_blast" },
    { 0xB9BE228F, "shinyou_blow_up" },
    { 0x8814CFAF, "ship" },
    { 0xC70D2CC1, "ship_alarms_exterior" },
    { 0x349C239A, "ship_base_origin" },
    { 0x00A76C4E, "ship_cheats" },
    { 0x48A0CDC3, "ship_debris" },
    { 0xE680C376, "ship_debris_start" },
    { 0xD27F149C, "ship_deck_cleanup" },
    { 0x6ADA10C6, "ship_destruction" },
    { 0xA9359D57, "ship_door_close" },
    { 0x963AF80C, "ship_door_delete" },
    { 0x6B028C01, "ship_door_open" },
    { 0x0391DA19, "ship_door_open_sudden" },
    { 0xA1232A78, "ship_door_setup" },
    { 0x8C9618D1, "ship_ent" },
    { 0x94483579, "ship_explode" },
    { 0x1EC48843, "ship_explosion" },
    { 0x273AC12A, "ship_fire_left" },
    { 0xC879B379, "ship_fire_right" },
    { 0x45C43DAC, "ship_gravity" },
    { 0x1AB2EDB8, "ship_gun_1" },
    { 0x8CBA5CF3, "ship_gun_2" },
    { 0x66B7E28A, "ship_gun_3" },
    { 0xF406F53E, "ship_names" },
    { 0x08E3E2B1, "ship_number" },
    { 0x47354719, "ship_sinking_sound" },
    { 0x0F31067F, "ship_start_fx" },
    { 0x680FB31D, "ship_tracerfire" },
    { 0x620F6387, "ship_wheel" },
    { 0x8A3CDA46, "shiparrival" },
    { 0x548AEAA3, "shiparrival_ambush_sequence" },
    { 0xA962B793, "shiparrival_back_five_to_nodes" },
    { 0x7D0D9037, "shiparrival_back_two_to_nodes" },
    { 0x7D95A692, "shiparrival_blocker1_sequence" },
    { 0x1559CAFD, "shiparrival_execution" },
    { 0x74296E67, "shiparrival_fakeanimate" },
    { 0x3B9CFED4, "shiparrival_fakeanimate_loop" },
    { 0xC80B2BBC, "shiparrival_flashlight_reminder" },
    { 0x170C4AE1, "shiparrival_front_two_to_nodes" },
    { 0xC906A7E5, "shiparrival_inside" },
    { 0x8C2BA996, "shiparrival_outside" },
    { 0x1700C4C8, "shiparrival_outside_conversation" },
    { 0x12BA970C, "shiparrival_spawn_crowd" },
    { 0xBAA4F8B9, "shiparrival_squad_to_nodes" },
    { 0xB65E0371, "shiparrival_tellmemore_conversation" },
    { 0x5D5711BC, "shiparrival_vip_to_nodes" },
    { 0x1EE836D6, "shipback" },
    { 0x07F71DB5, "shipcargo" },
    { 0x4D52445C, "shipcargo_objects" },
    { 0xE6A5423A, "shipcargo_outro_trigger_objective_position" },
    { 0xC1407B04, "shipcargo_outrocinema" },
    { 0x84B8EBDC, "shipcargo_steiner_drago_conversation" },
    { 0xB2423FE7, "shipcheats" },
    { 0xD659F8FE, "shipcinema" },
    { 0x62B4FA3C, "shipcinema_dof" },
    { 0xDBCD111E, "shipcinema_playback" },
    { 0x25A30037, "shipfirefight" },
    { 0x35339D25, "shipfirefight_bridgetoend" },
    { 0x8714019B, "shipfirefight_cargo_spawn_guards" },
    { 0xCA7692C6, "shipfirefight_cargo_to_bridge" },
    { 0x2F0EBCAF, "shipfirefight_friendly_escape" },
    { 0xF673D599, "shipfirefight_opposite_of_player" },
    { 0x5ED448B6, "shipfirefight_postcargo_drones" },
    { 0x839DCA1B, "shipfirefight_sas_arrival" },
    { 0x141CD8C1, "shipfirefight_spawn_friends" },
    { 0xCD93886D, "shipfirefight_spawn_office_guys" },
    { 0xFBCE3DBB, "shipfirefight_teamhandler" },
    { 0x1C47123D, "shipfirefight_uptobridge" },
    { 0x320CA4B8, "shipfront" },
    { 0x044E081C, "shipmast_reduce_enemy_accuracy" },
    { 0x902CEB16, "shipmast_zipline" },
    { 0x044AB067, "shipment" },
    { 0xE17D7D3A, "shipped" },
    { 0xF0BE069B, "shipping" },
    { 0x8202C627, "shiprope" },
    { 0x6CAFDCF6, "ships" },
    { 0x6EB7E173, "shipsquad" },
    { 0xB67AAD80, "shipvip" },
    { 0x19161915, "shirley" },
    { 0x71C3F9B3, "shirt" },
    { 0xB6DA1A2C, "shirtless" },
    { 0x0FBE4E62, "shirts" },
    { 0xC3C22FDB, "shirts01" },
    { 0x51BAC0A0, "shirts02" },
    { 0xF00AE60B, "shit" },
    { 0x1E7EDFAC, "shite" },
    { 0x4718E7D4, "shitless" },
    { 0x6BEF4A1F, "shitload" },
    { 0xA77AD8EB, "shitloc" },
    { 0x32A1916A, "shits" },
    { 0x6DE3184E, "shitstorm" },
    { 0x6C23AE25, "shiz" },
    { 0xCA20ACE2, "shiznit" },
    { 0x9B54CF75, "shock" },
    { 0x4BF5A349, "shock_distance" },
    { 0xA01DACF5, "shock_field_fx" },
    { 0x737EFA73, "shock_field_fx_1p" },
    { 0xB05E79A9, "shock_field_fx_3p" },
    { 0x1CFD23E2, "shock_field_off" },
    { 0xA47188D4, "shock_field_on" },
    { 0xB7CB65AD, "shock_field_think" },
    { 0x6FED7BC4, "shock_field_zap_sound" },
    { 0xA6702B5A, "shock_me" },
    { 0x218795FB, "shock_ondeath" },
    { 0x4DA622AC, "shock_ondeath_loc" },
    { 0x648C0224, "shock_onexplosion" },
    { 0x0D4FEB0B, "shock_onpain" },
    { 0xFD9DC76A, "shock_radius" },
    { 0x1C981877, "shock_range" },
    { 0x7F162B63, "shock_time" },
    { 0x6D46D9B8, "shockbox" },
    { 0x0607C6A0, "shockbox_anim" },
    { 0x2E7E52A2, "shocked" },
    { 0x590635FF, "shocked1" },
    { 0xE6FEC6C4, "shocked2" },
    { 0xF5D7B5A6, "shocked_time" },
    { 0xA11E8D96, "shockeffect" },
    { 0x08DE3875, "shockeffectarea" },
    { 0x7B43FE4E, "shockeffectdone" },
    { 0x2C72EBDF, "shockendtime" },
    { 0xEBB9E2F3, "shocking" },
    { 0xFC7B1323, "shocklight" },
    { 0x69043244, "shocks" },
    { 0x249CA1B2, "shocktime" },
    { 0x9276969D, "shocktype" },
    { 0xA05AE22A, "shockwave" },
    { 0x9CC5CC04, "shoe" },
    { 0x99CAC35F, "shoebox" },
    { 0x404996E6, "shoeboxs" },
    { 0xE4883E74, "shoeboxtracking" },
    { 0x5AEB8952, "sholmes" },
    { 0x8937CE80, "shoo_crow" },
    { 0xFCE4088E, "shoot" },
    { 0xEAB82A20, "shoot_ads_handler" },
    { 0x509D50CB, "shoot_ai" },
    { 0x15F37C37, "shoot_ammo_count" },
    { 0x6D6513EB, "shoot_and_kill" },
    { 0x500F25C2, "shoot_angle" },
    { 0x91951670, "shoot_angry" },
    { 0x24684ACB, "shoot_arm_up_delay" },
    { 0x9290ECBE, "shoot_at" },
    { 0xE99AEAE3, "shoot_at_btr" },
    { 0x174AC14E, "shoot_at_civilian_group" },
    { 0x1C092620, "shoot_at_drones" },
    { 0x34BA78E2, "shoot_at_entity_chain" },
    { 0xB52E0869, "shoot_at_giant_robot_vo" },
    { 0x21C8AFAF, "shoot_at_meatshield" },
    { 0xD710BBEA, "shoot_at_player" },
    { 0xC8329E9C, "shoot_at_players_feet" },
    { 0x48EC899D, "shoot_at_pos" },
    { 0xD104C596, "shoot_at_target" },
    { 0xA7C2E336, "shoot_at_target_once" },
    { 0xA3A5217A, "shoot_at_target_perfect_aim" },
    { 0x303088F3, "shoot_at_target_think" },
    { 0x7CE7F792, "shoot_at_target_untill_dead" },
    { 0x364ED8D2, "shoot_at_targets_ahead_of_me" },
    { 0x0EE25C47, "shoot_at_vc_node" },
    { 0x69D125C0, "shoot_at_wave3_vehicle" },
    { 0xD7790AFB, "shoot_behavior" },
    { 0x36A5B9F2, "shoot_behavior_change" },
    { 0xF9768826, "shoot_blend_time" },
    { 0xEAFC5828, "shoot_bolt" },
    { 0x2F0F4E00, "shoot_bolt_wait" },
    { 0x5E2F0AD8, "shoot_buildings" },
    { 0x4968D2A3, "shoot_bullets_at_rappel" },
    { 0x87DE4FE4, "shoot_burst_done" },
    { 0x8B511E41, "shoot_catwalk_final" },
    { 0x9AB1F223, "shoot_dj" },
    { 0x96EDCED5, "shoot_dog" },
    { 0xA5E0EFE7, "shoot_down_vtol" },
    { 0x7012F057, "shoot_enemy_until_he_hides_then_shoot_wall" },
    { 0x64E234D4, "shoot_ent" },
    { 0x9B816CD2, "shoot_exploder" },
    { 0x606F51D9, "shoot_fail_vo" },
    { 0x7B193FC7, "shoot_fire_time" },
    { 0xE2F3B68F, "shoot_flak" },
    { 0x8D96EBB6, "shoot_flame" },
    { 0xE390B87A, "shoot_fov" },
    { 0x616A573B, "shoot_from_behind_dialog" },
    { 0x4F5AE23E, "shoot_garage_guy" },
    { 0x546FB975, "shoot_gaz_guy" },
    { 0xC45CAB8D, "shoot_grenade" },
    { 0x6EE0F1EB, "shoot_ground_targets" },
    { 0x64295C33, "shoot_gun_range" },
    { 0xDABC8138, "shoot_guns" },
    { 0x284ECAD7, "shoot_hinge_instruction" },
    { 0x06A48308, "shoot_hostage" },
    { 0x4A00BF39, "shoot_loc" },
    { 0x12345359, "shoot_lock_trigger" },
    { 0xE9F73754, "shoot_magic_bullets" },
    { 0x8DCDAC3B, "shoot_me_when_player_looks" },
    { 0x77EDD6E1, "shoot_mechz_head_vo" },
    { 0x918E0EA2, "shoot_menendez_muzzle_flash" },
    { 0xC5574724, "shoot_mg42_script_targets" },
    { 0x11DB525E, "shoot_mg_targets" },
    { 0x89B737B4, "shoot_model" },
    { 0x63CB25AB, "shoot_model_background" },
    { 0x7AD30336, "shoot_model_hud" },
    { 0x00420400, "shoot_model_power_bar" },
    { 0xCE3503B5, "shoot_model_think" },
    { 0xA1800650, "shoot_my_turret_delay" },
    { 0xE04397CE, "shoot_notify" },
    { 0x3BCC0452, "shoot_notify_wrapper" },
    { 0x4CC925BF, "shoot_only_on_sight" },
    { 0xB45DC2EF, "shoot_or_collide_triggers_calls_fxanim_notify" },
    { 0x5FD9E45E, "shoot_or_collide_triggers_creates_fx" },
    { 0x2899E2F2, "shoot_origins" },
    { 0x6D3D49E5, "shoot_out_flashbang_window" },
    { 0x5336301E, "shoot_out_rest_of_windows" },
    { 0x97D388F5, "shoot_out_weaver_window" },
    { 0xD5F4B61D, "shoot_override" },
    { 0xD6D03EF6, "shoot_override_targetname" },
    { 0x146DFEBA, "shoot_plane_b" },
    { 0x609BB61A, "shoot_player" },
    { 0x799D7ADB, "shoot_player_camper" },
    { 0x2081C5F8, "shoot_pmc1" },
    { 0x92893533, "shoot_pmc2" },
    { 0x6C86BACA, "shoot_pmc3" },
    { 0x944B3175, "shoot_point" },
    { 0xB1CF72AB, "shoot_pool_guy_1" },
    { 0x3FC80370, "shoot_pool_guy_2" },
    { 0x9B9F3819, "shoot_pullout_rate" },
    { 0x39EB1CB3, "shoot_putaway_rate" },
    { 0x407D0FD6, "shoot_remote_missile" },
    { 0x7D32120D, "shoot_retreat_chopper_down" },
    { 0x0196B597, "shoot_rider" },
    { 0x92D5ED2F, "shoot_robot_vo" },
    { 0x4F640202, "shoot_rocket_at_arch" },
    { 0x99E32DC3, "shoot_rpg_from_struct" },
    { 0xCDBCAFDF, "shoot_semiforvariety_chance" },
    { 0x505782D0, "shoot_semiforvariety_time_interval" },
    { 0x13121AE9, "shoot_shoveler" },
    { 0x2E232892, "shoot_side_guns" },
    { 0x5885CFFC, "shoot_stingers" },
    { 0xCAD9E886, "shoot_target" },
    { 0xFB66C480, "shoot_target_distance" },
    { 0x16025FFA, "shoot_target_until_out_of_view" },
    { 0xB7EDC526, "shoot_the_vehicles" },
    { 0x4EE094AD, "shoot_this" },
    { 0xC55E195D, "shoot_thread" },
    { 0xC6CD5F6B, "shoot_through_wall" },
    { 0x403A464A, "shoot_time" },
    { 0xB9900B1C, "shoot_timer" },
    { 0xDF928585, "shoot_times" },
    { 0xFD6CC547, "shoot_tower_targets" },
    { 0x1A82E7AB, "shoot_turret" },
    { 0x364C1A13, "shoot_turret_at_target" },
    { 0xC240E69D, "shoot_turret_at_target_once" },
    { 0x1081013E, "shoot_up" },
    { 0xA1AFB995, "shoot_up_car" },
    { 0xAEF37111, "shoot_vec" },
    { 0x69DDCD6D, "shoot_while_moving" },
    { 0xB3407C30, "shoot_while_moving_thread" },
    { 0x9ECEF4BC, "shootanim_done" },
    { 0xDF7CC151, "shootanimlength" },
    { 0x8CA234F0, "shootanims" },
    { 0xBE20866E, "shootanimtime" },
    { 0x9C7E5749, "shootastold" },
    { 0xE1C8356D, "shootat_mig23_flyby" },
    { 0x0D549F3D, "shootatpos" },
    { 0x77060D9C, "shootatshootentorpos" },
    { 0x0F6F7770, "shootblank" },
    { 0x41561A28, "shootbuttonpressed" },
    { 0x07F13FB5, "shootenemytarget" },
    { 0x3B767333, "shootenemytarget_bullets" },
    { 0x5707B56D, "shootenemytarget_bullets_debugline" },
    { 0xFA166813, "shootenemywrapper" },
    { 0x42555324, "shootenemywrapper_func" },
    { 0x06AC764B, "shootenemywrapper_normal" },
    { 0xE0910D81, "shootenemywrapper_price" },
    { 0xD5748360, "shootenemywrapper_shootnotify" },
    { 0xB7009B03, "shootenemywrapper_ssnotify" },
    { 0x439A20B5, "shootent" },
    { 0xE7ABF4B0, "shootentvelocity" },
    { 0x1A92C0D7, "shooter" },
    { 0xD7F69C93, "shooter_coming" },
    { 0xCF074482, "shooter_max_power" },
    { 0x66400047, "shooter_mode" },
    { 0x825594E6, "shooter_mode_thread" },
    { 0x9F6D39B0, "shooter_models" },
    { 0x1F1D3976, "shooterrun" },
    { 0x1BB47C2E, "shooterrun_dorunanim" },
    { 0xF27F008E, "shooters" },
    { 0xF7A6EE88, "shootershoot" },
    { 0x6912A8A8, "shootershootthread" },
    { 0xDC783635, "shootershootthreadrpg" },
    { 0xCEDEC10A, "shootflamethrowerwrapper_func" },
    { 0x9E1A0491, "shootflamethrowerwrapper_normal" },
    { 0xFDFE2A26, "shootfromangles" },
    { 0x5FA6F8C5, "shootfrompitchangle" },
    { 0xA20DDF1E, "shootfrompitchdelta" },
    { 0xA547394C, "shootfrompos" },
    { 0xDD374204, "shootfromyawangle" },
    { 0x32F520AF, "shootfromyawdelta" },
    { 0x810D699B, "shootheight" },
    { 0x15264132, "shooting" },
    { 0xA2D236FF, "shooting_ai" },
    { 0xB62BD72C, "shooting_on_location_achieved" },
    { 0x5007595B, "shooting_start" },
    { 0xF11EEE96, "shooting_time" },
    { 0x471D6166, "shooting_turrets" },
    { 0xF7185B03, "shootingguy" },
    { 0x6290E120, "shootingplayerathigherdifficulty" },
    { 0x39C2C150, "shootme" },
    { 0x798F2822, "shootnearest_non_hero_friend" },
    { 0x8732192F, "shootnotetrack" },
    { 0xBB63444E, "shootnow" },
    { 0x45FD69B7, "shootobjective" },
    { 0x632FA170, "shootpos" },
    { 0x9F9FC854, "shootposoutsidelegalyawrange" },
    { 0x8759EA11, "shootposwrapper" },
    { 0xEB24E525, "shootrumble" },
    { 0x82AA914B, "shootrunningsuppressionvolley" },
    { 0xE1E16F31, "shoots" },
    { 0x4EB44858, "shoots_down" },
    { 0x210094F8, "shootshock" },
    { 0x81F4557B, "shootside" },
    { 0xA64103CE, "shootspot" },
    { 0x493C5FEB, "shootspotoncewithmissile" },
    { 0x23F9503D, "shootstyle" },
    { 0x0C140B61, "shoottarget" },
    { 0x88C883E1, "shoottime" },
    { 0x8A14057B, "shoottimestart" },
    { 0x0CFEFD8C, "shootturret" },
    { 0xD424F06C, "shootuntilneedtoturn" },
    { 0x9E20676D, "shootuntilshootbehaviorchange" },
    { 0x6BF381D7, "shootuntilshootbehaviorchange_corner" },
    { 0x1428CFFD, "shootuntilshootbehaviorchange_coverwall" },
    { 0xF0C62F91, "shootuntilshootbehaviorchangefortime" },
    { 0x21107EB5, "shootup" },
    { 0xADE3290D, "shootvolley" },
    { 0xD4EC2E0E, "shootweapon" },
    { 0x7B1A2553, "shootwhilemoving" },
    { 0x3B91FA34, "shootwhileturning" },
    { 0xDB039F07, "shootwrapper" },
    { 0x8AE60359, "shop" },
    { 0x58700E6D, "shop_area_clear" },
    { 0x3E080406, "shop_door_opens" },
    { 0xB436D912, "shopguy" },
    { 0x994C1286, "shopper" },
    { 0x31DA024C, "shore" },
    { 0x8725FBED, "shore_clip" },
    { 0x774746A8, "shore_destinations" },
    { 0xF06F7FBF, "shore_guys" },
    { 0xA817E0FC, "shore_target" },
    { 0x11764989, "shore_turret" },
    { 0x172CCC42, "shoreline" },
    { 0xA2916272, "shoreline_mg_bullets_per_second" },
    { 0xF2326DE4, "shoreline_mg_seconds_to_kill" },
    { 0xD94E9ACF, "shores" },
    { 0xB8042345, "short" },
    { 0x10FA24DF, "short_01_cacheside" },
    { 0x95A7171E, "short_01_towerside" },
    { 0x93D58EE4, "short_02_cacheside" },
    { 0x13DEA1A9, "short_02_towerside" },
    { 0x82FCA959, "short_dial_spin" },
    { 0x92886AC7, "short_intro_dialogue" },
    { 0xF8AE67A3, "short_shield" },
    { 0x25D75722, "short_training" },
    { 0xBF0CD81A, "shortage" },
    { 0x1A71A52F, "shortcantseeenemywait" },
    { 0x9B08F8C2, "shortcircuit" },
    { 0x49A4AD1A, "shortcircuitanimtime" },
    { 0x9EA327D5, "shortcircuited" },
    { 0x5AB55295, "shortcircuitedexit" },
    { 0x99F3F92E, "shortcircuiting" },
    { 0xD6DEA01C, "shortcircuted" },
    { 0xA0253609, "shortcircuting" },
    { 0xE4B723DE, "shortciruited" },
    { 0xC52EA387, "shortcut" },
    { 0x75958E7E, "shortcuts" },
    { 0x6CA64BA8, "shorten" },
    { 0x0E25A0DD, "shortencolor" },
    { 0x34C40894, "shorter" },
    { 0x6BED3E53, "shortest" },
    { 0x0416EA33, "shortest_distance" },
    { 0x8008BC88, "shortly" },
    { 0xA26A1E5F, "shortrank" },
    { 0x81E77731, "shorts_man" },
    { 0x22EFECFD, "shot" },
    { 0x7687F14E, "shot1" },
    { 0xF5EBB2B7, "shot1_drone_deckshot" },
    { 0x03C4690A, "shot1_drone_flyin" },
    { 0x508576E5, "shot2" },
    { 0x8F62C9C5, "shot2_drone_dogfight" },
    { 0xF1287E72, "shot3_chinadrone_startfire_" },
    { 0x82797DF0, "shot3_chinadrone_stopfire_" },
    { 0xD766AF4B, "shot3_deckshot_part_two" },
    { 0xA61A7FAF, "shot_at" },
    { 0xFCD8DC1D, "shot_at_target" },
    { 0x1BC64B12, "shot_bgelementoriginalangles" },
    { 0x95842E67, "shot_bgelementoriginalposition" },
    { 0xA3AEB816, "shot_bgelements" },
    { 0x2320A7AD, "shot_count" },
    { 0x6C6E1FBC, "shot_counter" },
    { 0x51AB37B6, "shot_death" },
    { 0x6A3A8670, "shot_destination" },
    { 0xFB017730, "shot_down_by_corsair" },
    { 0x4BE9E582, "shot_effects" },
    { 0x5EEDBA8B, "shot_export_num" },
    { 0x60E88A16, "shot_in_head" },
    { 0x8DFFE09A, "shot_in_the_head" },
    { 0x1188171E, "shot_in_the_head_point_blank" },
    { 0x48637B29, "shot_name" },
    { 0x8B1C7EA0, "shot_names" },
    { 0x2AE266D0, "shot_num" },
    { 0x7F2B31B3, "shot_number" },
    { 0x7178C3C9, "shot_offset" },
    { 0xE705E69B, "shot_opened" },
    { 0x051A0536, "shot_origin" },
    { 0x83ADAC2D, "shot_r_znear_value" },
    { 0xBD2CC03B, "shot_selected" },
    { 0x1F7D2484, "shot_start" },
    { 0x1D76D284, "shot_twice" },
    { 0xC6881E88, "shot_type" },
    { 0x096CD0D3, "shotairplane" },
    { 0x0A8132CF, "shotanimname" },
    { 0x874A20D2, "shotbyasniperorexplosive" },
    { 0xC2FEF522, "shotcount" },
    { 0xC94D53C9, "shotdelaybase" },
    { 0xF8DEFD30, "shotdelaymax" },
    { 0x6656DB8E, "shotdelaymin" },
    { 0x0377A821, "shotdelayrange" },
    { 0xED673EE3, "shotequipment" },
    { 0xF5B2E597, "shotfired" },
    { 0x55A411D9, "shotfiredbadplace" },
    { 0xA8ACB67D, "shotfireddarkscreenoverlay" },
    { 0xDCA74BD9, "shotfiredfriendlyproximity" },
    { 0x54B61B08, "shotfiredfriendlyproximity_trigger" },
    { 0xCF90EF58, "shotfiredfriendlyproximity_trigger_timeout" },
    { 0xCC642225, "shotfiredphysicssphere" },
    { 0xFF9507E1, "shotgun" },
    { 0x196B07BA, "shotgun_aim_4" },
    { 0xCD6612E8, "shotgun_aim_6" },
    { 0x15544FFF, "shotgun_death_detected" },
    { 0x746DEEB0, "shotgun_extra_long_range_dist" },
    { 0x40897968, "shotgun_extra_long_range_distsq" },
    { 0x8234CCB2, "shotgun_guy_logic" },
    { 0x2F762F1D, "shotgun_kill_index" },
    { 0x768A787B, "shotgun_long_range_distsq" },
    { 0x7ED066A3, "shotgun_med_range_distsq" },
    { 0x765B345E, "shotgun_olympia_lobby" },
    { 0x2AB747AC, "shotgun_pump_sound_end" },
    { 0x66A273AE, "shotgun_small_range_distsq" },
    { 0x1FADD2B2, "shotgunenergytokill" },
    { 0x093EA777, "shotgunloadout" },
    { 0x2481AF4F, "shotgunners" },
    { 0x2FF790C0, "shotgunpumpsound" },
    { 0x26BB9E88, "shotguns" },
    { 0x74E53AA2, "shotgunshoot" },
    { 0xD9F1B0FC, "shotgunswitchfinish" },
    { 0x0C47C825, "shotgunswitchstandruninternal" },
    { 0xBEEFE60A, "shotlen" },
    { 0xF2AD2A57, "shotnum" },
    { 0x44849B6A, "shotnumber" },
    { 0xE2B316F3, "shotorigin" },
    { 0xAB2196BC, "shots" },
    { 0xD10D6A8D, "shots_counter" },
    { 0x9542500C, "shots_delay" },
    { 0xBA3EB579, "shots_fired" },
    { 0x74B09182, "shots_fired_total" },
    { 0xED5E144B, "shots_per_burst" },
    { 0x3841E9A4, "shots_until_stop" },
    { 0x78157D95, "shotsafterplayerbecomesinvul" },
    { 0xA5585073, "shotsbase" },
    { 0xF10EAE5C, "shotsfired" },
    { 0x3804CF0B, "shotshit" },
    { 0xADCCCCC6, "shotsmax" },
    { 0x5326EE38, "shotsmin" },
    { 0x6EBEC54F, "shotsmissed" },
    { 0x29874155, "shotspot" },
    { 0xD783DD7B, "shotsrange" },
    { 0x02EDC383, "shotstokill" },
    { 0x507F2665, "shottie" },
    { 0xA8D559FA, "shottime" },
    { 0x8CE348F8, "shotty" },
    { 0xCC24F987, "shotty_gib" },
    { 0x462B0735, "shottype" },
    { 0x197B2A04, "shottypes" },
    { 0x544A4153, "shottys" },
    { 0x66AF5CB8, "shoud" },
    { 0x851724A4, "shoudl" },
    { 0x3E93F7D4, "should" },
    { 0x3E9897F8, "should_activate_per_player" },
    { 0xF8D3F5FB, "should_allow_postgame_damage" },
    { 0x0F5556CE, "should_allow_postgame_death" },
    { 0xC1A7AD53, "should_attack" },
    { 0x236DB95E, "should_attack_equipment" },
    { 0x068350F1, "should_attack_player_thru_boards" },
    { 0x9D365936, "should_award" },
    { 0x4C194939, "should_award_kill_near_plant_engineer_hardwired" },
    { 0x7E29BA17, "should_award_stat" },
    { 0x536C90DA, "should_banzai" },
    { 0x8B5FF71C, "should_be_deleted_during_evaporate_update" },
    { 0x2C496566, "should_be_flying" },
    { 0xAEE3A2CC, "should_be_reset" },
    { 0x6B8970B9, "should_be_slick" },
    { 0x05501D4C, "should_blend" },
    { 0xE34CAF0A, "should_block" },
    { 0x7B4677F4, "should_break" },
    { 0x61F7B00A, "should_break_c4" },
    { 0x43F18B8F, "should_break_c4_throw" },
    { 0xD9B58A43, "should_break_claymore_placement" },
    { 0x8AA2313E, "should_break_claymores" },
    { 0x9964B017, "should_break_disable_nvg_print" },
    { 0x1A2F3206, "should_break_grenade_launcher_hint" },
    { 0x38AED101, "should_break_minigun_spin_hint" },
    { 0x3D5E0EBD, "should_break_prone_hint" },
    { 0x3ACFFF83, "should_break_sniper_rifle_hint" },
    { 0x45615163, "should_break_where_is_he" },
    { 0x689A76D6, "should_break_zoom_hint" },
    { 0xDFE4649B, "should_brutus_aggro" },
    { 0x5DE5A96C, "should_buff_zombies" },
    { 0x7B61B3A4, "should_burn" },
    { 0xE808756D, "should_capture_zombie_attack_generator" },
    { 0x87D9EF1B, "should_change" },
    { 0xF15B158F, "should_charge" },
    { 0xB9854ADA, "should_delay_dds" },
    { 0xA4B4BFB1, "should_delay_killstreak" },
    { 0xA9FA335A, "should_delete" },
    { 0x6B721199, "should_delete_attack_coord_hint" },
    { 0x74F931C1, "should_delete_zbarriers" },
    { 0xE93D32B7, "should_detonate" },
    { 0x41178307, "should_die" },
    { 0x9A1DA345, "should_disable" },
    { 0x1DF754BD, "should_do_claw_attack" },
    { 0x67F58FE4, "should_do_flamethrower_attack" },
    { 0xEF99509F, "should_do_freezegun_death" },
    { 0x49825228, "should_do_player_damage" },
    { 0x68F7959A, "should_do_vulture_drop" },
    { 0xA69762D2, "should_drop_limited_weapon" },
    { 0x5BEAED5A, "should_drop_weapon_on_death" },
    { 0x8DF80B43, "should_emp" },
    { 0x54907F86, "should_enable" },
    { 0x63553A7E, "should_explode" },
    { 0x8D03D318, "should_face_struct" },
    { 0x0060C8B0, "should_fast_reload_by_weapon" },
    { 0xEE967760, "should_find_a_new_node" },
    { 0xBAF1DD6F, "should_flash" },
    { 0x11ECECC8, "should_fly_forward" },
    { 0x2CC2B603, "should_gib" },
    { 0xD8668E25, "should_give_killstreak" },
    { 0x233D0D21, "should_give_orghealth" },
    { 0x1D2DA0BD, "should_go_for_power_up" },
    { 0x1AAE8DB0, "should_go_to_near_owner" },
    { 0x6996AE57, "should_go_to_owner" },
    { 0x2E575F28, "should_grab_rope" },
    { 0x7D1CA87A, "should_growl" },
    { 0x2CFF2BC3, "should_headbang" },
    { 0x748E8423, "should_hide" },
    { 0x0E9AB06D, "should_howl" },
    { 0xF52C94ED, "should_howl_no" },
    { 0x92B4E211, "should_howl_yes" },
    { 0x061D021A, "should_ignore_candybooze" },
    { 0xCA9117AE, "should_kill_enemies" },
    { 0x5EBB3E90, "should_last_ghost_drop_powerup" },
    { 0xB10A5BE5, "should_load_josefina_gump" },
    { 0x32067D40, "should_load_mason_gump" },
    { 0x0D03EE28, "should_move" },
    { 0x1E5482AA, "should_move_ahead" },
    { 0x3F4D2083, "should_not_be_dead" },
    { 0xC556647A, "should_not_play_sounds" },
    { 0x29C36D9D, "should_not_remove" },
    { 0x9FFF71CA, "should_not_timeout" },
    { 0xCCC1D958, "should_not_turn" },
    { 0x0B9782A0, "should_notify" },
    { 0x2F1AC7D2, "should_offset" },
    { 0x49985128, "should_omit" },
    { 0x6D5A1D1B, "should_override_entity_camera_in_demo" },
    { 0x30A4C6DB, "should_pause" },
    { 0x50812745, "should_pause_spawning" },
    { 0xB7D2966F, "should_ping_object" },
    { 0x16CD8FC7, "should_play_reload_sound" },
    { 0x660AF82D, "should_play_sound" },
    { 0xEEBAACB4, "should_pooled_object_exist" },
    { 0x3A70E7D7, "should_prepare_death" },
    { 0x91453AB6, "should_raps_giveup_inaccessible_player" },
    { 0x5ED1DF9B, "should_reevaluate_target" },
    { 0x8C32C3EB, "should_remove" },
    { 0x67628F5B, "should_restore_zombie_total" },
    { 0x24FA8F52, "should_run" },
    { 0x9C8010E0, "should_run_no" },
    { 0xC4554A8D, "should_run_set_up" },
    { 0x0862639A, "should_run_yes" },
    { 0x0D012BEC, "should_runaway" },
    { 0x5B6A2459, "should_say_upgrade" },
    { 0xC379B9F8, "should_set_compass_icon" },
    { 0x1D2A29B9, "should_shellshock_player" },
    { 0x2EC0DCD4, "should_shield" },
    { 0x459DBC64, "should_shield_absorb_damage" },
    { 0x157FDC1B, "should_show_compass_due_to_radar" },
    { 0x76654644, "should_skip_linked_to_players_scene" },
    { 0x0B5CB230, "should_skip_scene_loop" },
    { 0x6E266F55, "should_skip_teardown" },
    { 0x945F8009, "should_slow_down_at_goal" },
    { 0x91736494, "should_smell" },
    { 0x93C82DFC, "should_spawn" },
    { 0x029CAF25, "should_spawn_destruct_gibs" },
    { 0xF53E88F5, "should_spawn_fx" },
    { 0x813B14EA, "should_spawn_gibs" },
    { 0x48F4AB34, "should_spawn_tags" },
    { 0x0B63C409, "should_spectate_on_join" },
    { 0xC4EF710C, "should_speed_up" },
    { 0x7B714F8E, "should_squelch" },
    { 0x772E4CBF, "should_start_fullscreen" },
    { 0x471E69AB, "should_stop" },
    { 0x7725B5B1, "should_stop_at_goal" },
    { 0xC5FECD24, "should_stop_patrolling" },
    { 0xF9895D7A, "should_suppress_damage" },
    { 0x66CC38F8, "should_switch_immediately" },
    { 0x479DC7A4, "should_switch_to_combat" },
    { 0xE58A0DF0, "should_switch_to_melee" },
    { 0xA1469EB3, "should_switch_to_pickup_weapon" },
    { 0xCC5DFD2B, "should_switch_to_range" },
    { 0x04211B4D, "should_switch_to_sidearm" },
    { 0x5DBD6095, "should_switch_to_unaware" },
    { 0xBC82903A, "should_take_hatchet_damage" },
    { 0x8DAA27B6, "should_teleport" },
    { 0x1D15045A, "should_try_to_bring_back_teammate" },
    { 0xB1E69062, "should_turn" },
    { 0xF4D5D74D, "should_turn_right" },
    { 0xC7A4C008, "should_update" },
    { 0xB07A55E6, "should_update_damage_fx_level" },
    { 0x90E4F489, "should_update_fx" },
    { 0x5D088F82, "should_update_state" },
    { 0x9B4A3F3C, "should_update_weapon_options" },
    { 0x060C55A8, "should_upgrade_weapon" },
    { 0x23808F48, "should_use_cia" },
    { 0x827C64DC, "should_wait" },
    { 0xE5E6CA10, "should_wait_limit" },
    { 0xC5C0F06B, "should_watch_for_emp" },
    { 0x281B7865, "should_water_rush" },
    { 0xBA85308B, "should_zigzag" },
    { 0x59AC4D0C, "should_zombie_have_stink" },
    { 0xBCA25005, "shoulda" },
    { 0x1BCF09CF, "shouldaddrankxp" },
    { 0x4364EA2E, "shouldadjuststanceattacticalwalk" },
    { 0x463BDDF7, "shouldadjusttocover" },
    { 0x8EA2A617, "shouldaffectclaymore" },
    { 0x5F3D820E, "shouldaffectweaponobject" },
    { 0xCB5326BB, "shouldaivomit" },
    { 0xDFCE99BD, "shouldapproachtoexposed" },
    { 0x7EE75D4D, "shouldaquiremutexonenemyforaivsaimelee" },
    { 0x5AB6BEEF, "shouldarriveexposed" },
    { 0x630EC61E, "shouldattackidle" },
    { 0x918BC20B, "shouldattackinchargemelee" },
    { 0xB523159D, "shouldattackobject" },
    { 0x2BA49E53, "shouldbeaggressive" },
    { 0x80547C26, "shouldbeajerk" },
    { 0xCB636409, "shouldbeangrycondition" },
    { 0x345FC6E7, "shouldbeawareofaim" },
    { 0x580DDE40, "shouldbeinforcemovement" },
    { 0x81F3C1E8, "shouldbereset" },
    { 0x76C7989E, "shouldbespectatorlatejoin" },
    { 0x6A073E22, "shouldbestopped" },
    { 0xBD10BB04, "shouldbleed" },
    { 0x40045D5C, "shouldbounce" },
    { 0x708A4300, "shouldbreaknvghintprint" },
    { 0xCB9E7F23, "shouldcalculatewinnings" },
    { 0x1C48E7D4, "shouldchangescreenpostfx" },
    { 0x6EEBFAE8, "shouldchangestanceforfun" },
    { 0x02A265AC, "shouldchargemelee" },
    { 0x02322A9A, "shouldchoosebettercover" },
    { 0x220D049E, "shouldchoosespecialdeath" },
    { 0x9A9AC288, "shouldchoosespecialpain" },
    { 0x6647CC1C, "shouldchoosespecialpronedeath" },
    { 0xAFDCE3AE, "shouldchoosespecialpronepain" },
    { 0x98A0097E, "shouldclearonanimscriptchange" },
    { 0xCF0A2F48, "shouldconserveammotime" },
    { 0x96FAFD17, "shouldcontinuetacticalwalkpain" },
    { 0xA3855625, "shouldcoveridleonly" },
    { 0xCF2844A6, "shouldcqb" },
    { 0xFCA47953, "shouldcrawlingpain" },
    { 0xC90F5587, "shoulddamage" },
    { 0xFD33B7A0, "shoulddebugaiming" },
    { 0xA437875F, "shoulddelaykillstreak" },
    { 0x60FD6BB5, "shoulddelete" },
    { 0x83E2FACF, "shoulddiequietly" },
    { 0x08AC7791, "shoulddisplayteammessages" },
    { 0x059CA7E2, "shoulddocqbtransition" },
    { 0x0A068DC0, "shoulddodamage" },
    { 0xE509AFB1, "shoulddoenemysounds" },
    { 0xF47BD1E5, "shoulddominiarrival" },
    { 0x1B83F68B, "shoulddorunningforwarddeath" },
    { 0x32F25DC4, "shoulddoseconddeathcam" },
    { 0xBD2FDB66, "shoulddosemiforvariety" },
    { 0xA221E84F, "shoulddoshortcircuitedexit" },
    { 0xF29416BF, "shoulddosounds" },
    { 0xBA110F4D, "shoulddospecialturn" },
    { 0x3BD0BFDF, "shoulddroplimitedweapon" },
    { 0x3B7FC94F, "shoulddropweapon" },
    { 0xE00DB351, "shouldenabledoverlay" },
    { 0x39107571, "shouldenableweapon" },
    { 0x110BDC71, "shoulder" },
    { 0x1C6C562B, "shoulder_board_node" },
    { 0x50256641, "shoulder_light_focus" },
    { 0x599C8701, "shoulder_mortar_boards" },
    { 0xC4AD7DF2, "shoulder_mortar_door" },
    { 0xB52991C8, "shoulder_node" },
    { 0xB98F6F4D, "shouldexposedrambo" },
    { 0x164F336D, "shouldfacemotion" },
    { 0x71D0A8BD, "shouldfacemotionwhilerunning" },
    { 0xE6FE6E69, "shouldfallerdrop" },
    { 0x50AFDB1E, "shouldfindcovernearself" },
    { 0xD3AFDC21, "shouldfirewhilechangingpose" },
    { 0xEDC59F0B, "shouldforcebehavior" },
    { 0x0996E17A, "shouldforcesidearm" },
    { 0x9A3596D1, "shouldforwardstep" },
    { 0xC112D2C3, "shouldfullsprint" },
    { 0x25253D0A, "shouldgib" },
    { 0x0F2A6067, "shouldgive" },
    { 0x7D405EAF, "shouldgiveinvuln" },
    { 0xD4B3CDFD, "shouldgivekillstreak" },
    { 0x342D80D9, "shouldgiveleaderbonus" },
    { 0xF3FF4424, "shouldgotonewposition" },
    { 0x774C531D, "shouldgotonode" },
    { 0xB2AE4BB3, "shouldhandlespecialpain" },
    { 0xE7990464, "shouldhelpadvancingteammate" },
    { 0x92C90EF1, "shouldholdgroundagainstenemy" },
    { 0x7E019A66, "shouldhowl" },
    { 0x5A83BC0A, "shouldhuntenemyplayer" },
    { 0x82436337, "shouldidlestrafe" },
    { 0x95684042, "shouldignorenonplayernonbigdogdamage" },
    { 0x8DB5BFA6, "shouldkeepaiming" },
    { 0x28E9DE00, "shouldkeepcrawling" },
    { 0xB85EC98B, "shouldkickbyrank" },
    { 0xE086B7C4, "shouldlean" },
    { 0x6126B9E3, "shouldleanatcovercondition" },
    { 0x2F854609, "shouldleavemap" },
    { 0x22056413, "shouldlookatpath" },
    { 0xFAB323AD, "shouldlookforbettercover" },
    { 0x8B692568, "shouldmelee" },
    { 0x2A77FBE8, "shouldmeleedist" },
    { 0xF25F1D20, "shouldmeleedistsq" },
    { 0xC5453000, "shouldmonitorai" },
    { 0x6F5A6E9E, "shouldmovecondition" },
    { 0x6AA20D72, "shouldmovelowg" },
    { 0x588BD0EB, "shouldmutexmelee" },
    { 0xF82B6383, "shouldnormalmelee" },
    { 0x795119FF, "shouldnotgib" },
    { 0x0CB80092, "shouldnt" },
    { 0x17AC66E1, "shouldonlyfireaccurately" },
    { 0x7F604FC5, "shouldoveratcovercondition" },
    { 0x0927B4CC, "shouldoverrideentitycameraindemo" },
    { 0xAA87D49E, "shouldpatrol" },
    { 0xCE0DEB19, "shouldpingobject" },
    { 0x29ED9827, "shouldplanarrivalintocover" },
    { 0x97E27C72, "shouldplay" },
    { 0x5D8C6779, "shouldplaybulletgibbeddeath" },
    { 0x7905CA1F, "shouldplayerspeak" },
    { 0x8E5A9317, "shouldplayfaceevent" },
    { 0x74ADFEB2, "shouldplaymachetegibbeddeath" },
    { 0xF4CCE2D9, "shouldplayovertimeround" },
    { 0x996CBD5E, "shouldplayreloadsound" },
    { 0x56B8C2CF, "shouldplaysound" },
    { 0x5589FA24, "shouldplayswordgibbeddeath" },
    { 0x222C2174, "shouldplaytazerdeath" },
    { 0x8F5E19A2, "shouldpreemptivejuke" },
    { 0xF1216C50, "shouldprovidecoveringfire" },
    { 0xD003D10E, "shouldraisegundist" },
    { 0x0FECBFEA, "shouldraisegundistsq" },
    { 0x7E4AF015, "shouldrambo" },
    { 0x03AAF469, "shouldreact" },
    { 0xFC21E5CC, "shouldreacttonewenemy" },
    { 0xAB97487A, "shouldreceivesurvivorbonus" },
    { 0xA3B6F91F, "shouldreenter" },
    { 0x310DD400, "shouldregisterclientfieldforarchetype" },
    { 0x09088FAB, "shouldreloadwhilerunning" },
    { 0xD46AE5FA, "shouldrepath" },
    { 0x69F7C176, "shouldresetgiveuponsuppressiontimer" },
    { 0xA50763DA, "shouldreturntocover" },
    { 0x8FBFFB11, "shouldreturntocovercondition" },
    { 0xE249EC84, "shouldreturntosuppressedcover" },
    { 0x78BC3F4C, "shouldrevivesequencehappen" },
    { 0xEEBCD2AD, "shouldroll" },
    { 0xBA28E5DB, "shouldrun" },
    { 0xFF10216F, "shouldrunngun" },
    { 0x01C76B4F, "shouldsaveonstartup" },
    { 0xCDA2FDC9, "shouldscramble" },
    { 0x1B31479C, "shouldset" },
    { 0xAA0AEE87, "shouldshootatscriptedtarget" },
    { 0xF37E9EEE, "shouldshootwhilemoving" },
    { 0x8FA49F2A, "shouldshootwhilerunningbackward" },
    { 0xC2688ABA, "shouldshowcompassduetoradar" },
    { 0x3AD879D4, "shouldshowcoverwarning" },
    { 0x59CC7CAA, "shouldshowrespawnmessage" },
    { 0x164DBE3F, "shouldsidestep" },
    { 0xA1C47C25, "shouldsidestepfunc" },
    { 0x42615BC7, "shouldskipmomentumdisplay" },
    { 0x454504BD, "shouldskipteardown" },
    { 0x097FE784, "shouldspawngibs" },
    { 0xC9CD96F0, "shouldsprint" },
    { 0x1623F314, "shouldsprintforvariation" },
    { 0xB4570404, "shouldstartambushround" },
    { 0xC54EF1CF, "shouldstartarrival" },
    { 0x23242ECA, "shouldstartarrivalcondition" },
    { 0xEED3B1F6, "shouldstarttraversal" },
    { 0x87F9F0B2, "shouldstayalive" },
    { 0x6521D069, "shouldstealth" },
    { 0x5BE99818, "shouldstealthresume" },
    { 0x8B6D1606, "shouldstepincondition" },
    { 0x5D6CCD88, "shouldstopambushing" },
    { 0x78BDA636, "shouldstopmoving" },
    { 0xB110E36D, "shouldsuppress" },
    { 0x8647B9B0, "shouldsuppressgibs" },
    { 0x56933209, "shouldswapshotgun" },
    { 0xCC470790, "shouldswitchsides" },
    { 0x5530167B, "shouldswitchtonewthreat" },
    { 0x857F64EA, "shouldswitchtotacticalwalkfromrun" },
    { 0x717659C4, "shouldswitchweaponfordistance" },
    { 0x7BAE718F, "shouldswitchweaponforsituation" },
    { 0x13291367, "shouldswitchweapons" },
    { 0x998363CD, "shouldtacticalarrivecondition" },
    { 0xDD3B88E4, "shouldtacticalwalk" },
    { 0x068E7D9C, "shouldtacticalwalkpain" },
    { 0xC42CC237, "shouldtacticalwalkscan" },
    { 0xCCF613AA, "shouldtakeovercondition" },
    { 0xA4451C91, "shouldteamkillkick" },
    { 0xE9F405FC, "shouldthrowdownweapon" },
    { 0x3D3B07CD, "shouldthrowflashbangatenemy" },
    { 0x9A6B6BF1, "shouldthrowgrenadeatcovercondition" },
    { 0x60248D95, "shouldtimeout" },
    { 0x38B94764, "shouldtrywoundedanimset" },
    { 0xB699DB19, "shouldturn" },
    { 0xA0C8D318, "shouldupdatedamage" },
    { 0x33361523, "shouldupdatejaw" },
    { 0xA8FEA69E, "shouldusecovernode" },
    { 0x2A9EB21B, "shouldusestartstopaimnotetrack" },
    { 0x2A732075, "shoulduseweapon" },
    { 0xC636A315, "shouldvantageatcovercondition" },
    { 0xB0C38F47, "shouldwait" },
    { 0x929AE3E4, "shouldwaitincombatidle" },
    { 0x8D9E59E7, "shouldwalkbackwards" },
    { 0x646AF947, "shouldyield" },
    { 0x6496723D, "shoule" },
    { 0x2EB5E8B4, "shoutcaster" },
    { 0x9E13D2D6, "shoutcaster_setting_allies_color_id" },
    { 0x4D2C7A91, "shoutcaster_setting_axis_color_id" },
    { 0xAB936FB9, "shoutcaster_setting_flip_score_panel" },
    { 0x2C4786B8, "shoutcaster_setting_team_identity" },
    { 0x41D2D6C3, "shouts" },
    { 0x1A38A732, "shove_players_off_bus" },
    { 0x754B2B14, "shoved" },
    { 0xA55EFE5C, "shovel" },
    { 0x391DFBC5, "shovel01" },
    { 0x5F20762E, "shovel02" },
    { 0x9C387837, "shovel_guy_logic" },
    { 0x70FB5F53, "shovel_prompt_update" },
    { 0x73980C03, "shovel_stop" },
    { 0xC18C3A9E, "shovel_trigger_prompt_and_visiblity" },
    { 0x6161D0F4, "shovel_unitrigger_think" },
    { 0x4350E722, "shoveler1" },
    { 0x1D4E6CB9, "shoveler2" },
    { 0x6A479639, "shoveler_alerted" },
    { 0x181D3AA1, "shoveler_react" },
    { 0xBA2DD343, "shoveler_stopanim" },
    { 0x76AD5810, "shovelers" },
    { 0x5208E4AC, "shoveling" },
    { 0xEF210A1B, "shoves" },
    { 0xCD346831, "shoving" },
    { 0x48F26766, "show" },
    { 0xB1BE11D8, "show_actor_count" },
    { 0x497460C9, "show_ads_message" },
    { 0xFC25948D, "show_after_delay" },
    { 0x9B1C727D, "show_alive_ai_count" },
    { 0xD93323FE, "show_alive_aigroup_count" },
    { 0xC399E623, "show_all_player_models" },
    { 0x278886C3, "show_all_weapon_buys" },
    { 0x2F922125, "show_alt_weapon_message" },
    { 0xFFBED14F, "show_ammo_count" },
    { 0x93D7DA3C, "show_and_enable_player_weapons" },
    { 0x4490285B, "show_anim_rate" },
    { 0x50B8427A, "show_anim_rates" },
    { 0x5D7EA7C4, "show_arms" },
    { 0xA36511C8, "show_bad_path" },
    { 0x9B68E9FF, "show_balance" },
    { 0x5B420B1E, "show_base" },
    { 0x0B85AC81, "show_betty_hint" },
    { 0x48CCE89D, "show_black_screen" },
    { 0x85800476, "show_boats" },
    { 0x568AB2EE, "show_briefly" },
    { 0xFF9119C1, "show_brush_model" },
    { 0xE3CAFBB5, "show_btr_instructions" },
    { 0x53D6E8F4, "show_bullet_charge_hint" },
    { 0x317CDAE5, "show_bullet_damage_hint" },
    { 0x33D98DEA, "show_bunker_damage" },
    { 0xD4DAC230, "show_bunker_explode" },
    { 0xE5E7AFB6, "show_ceiling" },
    { 0x1719D53A, "show_charged_shot_hint" },
    { 0x27DFE65C, "show_chest" },
    { 0x7549CEF3, "show_chest_sound_thread" },
    { 0x745DFF15, "show_chord_debug" },
    { 0x901F145B, "show_claymore_hint" },
    { 0x7E750F08, "show_cobra_crash" },
    { 0xB85C1CD3, "show_comstat_objects" },
    { 0x1D9DE3D4, "show_craftable_locations" },
    { 0x82531992, "show_damage" },
    { 0xE1D96FD2, "show_damaged" },
    { 0x80C3EEDD, "show_debug_info" },
    { 0x67B4E0A8, "show_destoyed_model" },
    { 0xFB238707, "show_destroyed_earth" },
    { 0x845D6262, "show_diggers" },
    { 0x6FA8CAE9, "show_dome_destruction" },
    { 0x89B6F073, "show_door_left" },
    { 0xC87964B3, "show_door_left_warped" },
    { 0x8DBB8466, "show_door_right" },
    { 0x68874308, "show_drive_hands" },
    { 0x98AA13DB, "show_drive_hint_forward" },
    { 0x3C07D9E6, "show_drive_hint_reverse" },
    { 0x430CA813, "show_earth" },
    { 0x1D2860A0, "show_elevator_floor" },
    { 0x35C69E7B, "show_emblem" },
    { 0xFBCFDB74, "show_emergence_holes" },
    { 0x6E8ED364, "show_engine_exhaust" },
    { 0xA8DB61FD, "show_equipment_hint" },
    { 0xAB609B65, "show_equipment_hint_text" },
    { 0x5B15C606, "show_erik_name" },
    { 0x3C073362, "show_exploding_column" },
    { 0xC8799780, "show_fa38_elevator_fxanim_model" },
    { 0xB581EF87, "show_fake_clip" },
    { 0x525B2512, "show_fall" },
    { 0x9A22113D, "show_final_time" },
    { 0x3AB0CD26, "show_firesale_box" },
    { 0xC0EAEA6E, "show_for_target" },
    { 0xB5516EB2, "show_for_time" },
    { 0xE0443901, "show_friendly_names" },
    { 0x9087AAC2, "show_friendly_outlines" },
    { 0x539A94A3, "show_fx" },
    { 0xD3BCAC18, "show_geo_models_trigger" },
    { 0xA1B6E560, "show_ghetto_tags" },
    { 0x303F02AF, "show_glass" },
    { 0xDA0D8BAC, "show_globe" },
    { 0x3C178AA1, "show_glowing_rope" },
    { 0x588C95FB, "show_goal_pos" },
    { 0x80390728, "show_grate_pull" },
    { 0x39803FAA, "show_grate_repair" },
    { 0x262FCC7A, "show_grief_hud_msg" },
    { 0xBCC02F9F, "show_grief_hud_msg_cleanup" },
    { 0x193D5DEF, "show_guards" },
    { 0x68CB719A, "show_hand" },
    { 0x8F53EF86, "show_helmet" },
    { 0x21968939, "show_helmets" },
    { 0xA07E78DC, "show_help" },
    { 0x53C0A512, "show_hint" },
    { 0x32D40124, "show_hint_text" },
    { 0xCBE90295, "show_hit_marker" },
    { 0xEC881725, "show_holotable_fuzz" },
    { 0xA210ED72, "show_hours" },
    { 0xC72856FC, "show_hud" },
    { 0x906DACBA, "show_ice_staff_piece" },
    { 0x3964A8D2, "show_icon" },
    { 0x25EA3BDD, "show_icons" },
    { 0x5EF697FB, "show_in_x_sec" },
    { 0xD35FA40C, "show_in_xsec" },
    { 0x69E0FB83, "show_infotext_for_duration" },
    { 0x97CBB7EC, "show_intact" },
    { 0x4DCECD80, "show_item" },
    { 0x9DD8E7B6, "show_laser" },
    { 0x4D8EDB8C, "show_last_stand_progress_bar" },
    { 0x85D2FE2C, "show_level_info" },
    { 0x7FC6DF8A, "show_liftoff_prompt" },
    { 0xC939EF60, "show_limo_burn" },
    { 0x0D9799DF, "show_loaders" },
    { 0xC2376028, "show_magic_box" },
    { 0xC8A0B171, "show_masonjr" },
    { 0x81B36E62, "show_masonjr_gun" },
    { 0xA46B1D43, "show_maze_fountain_water" },
    { 0xC724AC13, "show_me" },
    { 0xC9E4D305, "show_me_make_me_solid" },
    { 0x1B120157, "show_meat_throw_hint" },
    { 0x4A4360F6, "show_melon" },
    { 0x0050A2F2, "show_message" },
    { 0x366299BD, "show_mghut_dmg" },
    { 0xE3097D6B, "show_milliseconds" },
    { 0x656D06F4, "show_minutes" },
    { 0xDFC8E6CC, "show_model" },
    { 0x2975C716, "show_monitor1" },
    { 0x03734CAD, "show_monitor2" },
    { 0xAE88A79F, "show_morse_code" },
    { 0xB04E4DF2, "show_muzzle" },
    { 0xE766B674, "show_my_gun" },
    { 0x436C9354, "show_node_debug_info" },
    { 0x7D50C95D, "show_numbers" },
    { 0xC065E8BC, "show_on_hud" },
    { 0x97797986, "show_owner" },
    { 0x6F1A957D, "show_owner_on_attack" },
    { 0x77116375, "show_pain_from_explosive_dmg" },
    { 0x9688750B, "show_paintshop" },
    { 0xE18194DF, "show_paintshop_bg" },
    { 0x23FBD7A4, "show_perks" },
    { 0xE77E280B, "show_perks_disabled" },
    { 0xDEA2FAB9, "show_phone_chloe" },
    { 0xC262F91A, "show_phone_kurtz" },
    { 0xE3D5EDB8, "show_phone_kurtz_returned" },
    { 0x6D4939D2, "show_pilot_and_copilot" },
    { 0xFA99AA50, "show_player_hud" },
    { 0x079EAE6B, "show_player_tag" },
    { 0x4891947D, "show_players" },
    { 0x41CE9A77, "show_powerup_message" },
    { 0xF63B92FD, "show_prison_blood" },
    { 0x6357C15F, "show_progress_info" },
    { 0xB90512CE, "show_rain_fx_when_abovewater" },
    { 0x8A810D06, "show_rappel_hands" },
    { 0xA4262C81, "show_redacted" },
    { 0x1278017C, "show_rigs" },
    { 0x32760497, "show_rubble" },
    { 0x248400F7, "show_salazar" },
    { 0x784F5A67, "show_sam_turret" },
    { 0x5FB810E6, "show_savannah_rocks" },
    { 0x639FA706, "show_scanner_gun" },
    { 0x0A65A108, "show_scores" },
    { 0x475C9242, "show_secserv_01" },
    { 0x215A17D9, "show_secserv_02" },
    { 0xD0C670B3, "show_sl_pos" },
    { 0x88DBD9AE, "show_slow_time" },
    { 0x8FBDBA8E, "show_smoke_grenades" },
    { 0xA316B24C, "show_spas" },
    { 0x796EA479, "show_spawns" },
    { 0x8F4FE990, "show_spiderbot_case" },
    { 0x97E977F6, "show_start_spawns" },
    { 0x472337E4, "show_static_column" },
    { 0xCFEAC37E, "show_static_door" },
    { 0x5B09FADB, "show_static_push_models" },
    { 0xB80A4083, "show_status" },
    { 0x9B384291, "show_subtasks" },
    { 0x19DA2978, "show_super_kill_bodies" },
    { 0x398677DC, "show_swimming_arms" },
    { 0x9E323157, "show_tag" },
    { 0x49FE6C74, "show_tag_pos" },
    { 0xB7098F3C, "show_takeoff_effects" },
    { 0xA9C23F7E, "show_target" },
    { 0x8C6344EA, "show_task" },
    { 0x78D8CF71, "show_task_thread" },
    { 0x33C6F742, "show_team" },
    { 0xBFB71138, "show_territories_conquered" },
    { 0xCF3285A0, "show_text" },
    { 0xE0CAE4F2, "show_texture" },
    { 0x0B978540, "show_throw_prompt" },
    { 0x8A4CA42B, "show_thruster_prompt" },
    { 0xD9AE3602, "show_time" },
    { 0xA33DD74E, "show_time_bomb_hints" },
    { 0x41A52D51, "show_time_bomb_notification" },
    { 0x145918A4, "show_to_enemy_teams" },
    { 0xC9CFA3B2, "show_to_team" },
    { 0xA0BF1C6A, "show_triggers" },
    { 0x0535DBA3, "show_turret" },
    { 0x20D4B0E5, "show_tutorial_hint" },
    { 0xB3BEA47C, "show_tutorial_hint_with_full_movement" },
    { 0xD35651FF, "show_vehicle_count" },
    { 0xB14BF29F, "show_victory_vehicles" },
    { 0xC7744FED, "show_viewmodel" },
    { 0x5E3293FA, "show_wall_chunks" },
    { 0x9D945F73, "show_warning_message" },
    { 0xF93F6972, "show_water" },
    { 0x76A3AB20, "show_waypoint" },
    { 0x6DAEA2F7, "show_weak_spots" },
    { 0x928E202B, "show_woods_ak47" },
    { 0x7471268F, "show_woods_horse" },
    { 0xD2782F7F, "show_zombie_count" },
    { 0xED67843B, "show_zone_capture_debug_info" },
    { 0x85409D54, "show_zone_capture_objective" },
    { 0x7075818F, "showactionbuttons" },
    { 0xE133E828, "showafter" },
    { 0x656E58C3, "showaftertime" },
    { 0xA265B3DA, "showallentityheadicons" },
    { 0xD88BA37B, "showallparts" },
    { 0x865B9670, "showapart" },
    { 0x12D7BE0C, "showbanzaihint" },
    { 0xE0D5267A, "showblends" },
    { 0x86140CD9, "showbombicon" },
    { 0xA0D969EA, "showcase" },
    { 0x28AC6529, "showcase_weapon" },
    { 0xC9E935E1, "showcase_weapon_paintshop_class" },
    { 0xFBE05DBA, "showcaseweapon" },
    { 0x7F1938E7, "showcaseweapon_get" },
    { 0x4B073B25, "showcaseweaponacvi" },
    { 0x93ECB41D, "showcaseweaponattachmentinfo" },
    { 0x7DB0B49A, "showcaseweapondata" },
    { 0x8F9C1E31, "showcaseweaponmodel" },
    { 0xA7A58D47, "showcaseweaponname" },
    { 0x7FF9E1D4, "showcaseweaponrenderoptions" },
    { 0x43D1685D, "showclaimed" },
    { 0x9D8F4936, "showclientgenericmessagebar" },
    { 0xD08D6682, "showclientscorebar" },
    { 0xE3537DE7, "showcommandcontrolhint" },
    { 0x9681233A, "showcompass" },
    { 0xA94B30E3, "showcone" },
    { 0x56C209FB, "showcountdown" },
    { 0x0BD58A9D, "showdamage" },
    { 0x12B382FC, "showdeathsdebug" },
    { 0xFBFA48F2, "showdebughud" },
    { 0x9974ACA5, "showdebugline" },
    { 0xF101F273, "showdebugproc" },
    { 0x0437172A, "showdebugtrace" },
    { 0x291DD9AA, "showdestructedpieces" },
    { 0xF798E06E, "showdown" },
    { 0xD7C65271, "showdown_fire" },
    { 0x6D8A6C1F, "showdown_hut_door" },
    { 0x01086182, "showdown_icon_reveal" },
    { 0x9C05C53F, "showdown_over" },
    { 0xCF261822, "showdown_tag_num" },
    { 0x577A620C, "showdown_water_splash" },
    { 0xE8324AE9, "showed" },
    { 0x2FB350D0, "showedtopthreeplayers" },
    { 0x48BB82FF, "showelem" },
    { 0x2C68CFEF, "shower" },
    { 0xBDEBF3E6, "shower_key_door" },
    { 0x5E297636, "showers" },
    { 0x69F425E0, "showfailure" },
    { 0x68125934, "showflag" },
    { 0x42C7B291, "showfriendicon" },
    { 0xF4D92274, "showfx" },
    { 0xBF2DF096, "showgestures" },
    { 0x112269C7, "showheadicon" },
    { 0x3EAEF999, "showhiddengibpieces" },
    { 0xADEC9AC9, "showhitlog" },
    { 0x354EA31D, "showhud" },
    { 0x4AF767F3, "showhudandplaypromo" },
    { 0x4FFA369D, "showicon" },
    { 0xD153DC4A, "showiconthisteam" },
    { 0x310CCAFA, "showindemo" },
    { 0xCCFF07C4, "showinfovolume" },
    { 0x5F55A1FA, "showing" },
    { 0x05E00281, "showing_rocket" },
    { 0x11CF46F9, "showing_tile_side" },
    { 0x35390CAF, "showing_warning" },
    { 0xC0025CFC, "showinitialfactionpopup" },
    { 0xB4F6794D, "showit" },
    { 0xBECD7915, "showjumphint" },
    { 0x9BF6E6FC, "showjumphintelem" },
    { 0x8842FFE4, "showkillstreak" },
    { 0xC7D403CD, "showlastenemysightpos" },
    { 0x37541D28, "showlife" },
    { 0xDFA5A38C, "showlikelyenemypathdir" },
    { 0xBE42B410, "showline" },
    { 0x65308AFB, "showlines" },
    { 0x489F386E, "showloadoutattribute" },
    { 0x845B492E, "showmainmenuforteam" },
    { 0x31350C08, "showmarker" },
    { 0x882562FF, "showmenu" },
    { 0x0BFCC3DA, "showmissreason" },
    { 0xE2BE7B4D, "showmodel" },
    { 0xF762408C, "shown" },
    { 0x97BC6A2A, "shown_value" },
    { 0xD75CF0AB, "showname" },
    { 0x12C6F8E4, "shownenemies" },
    { 0x5EC7F544, "shownenemyequip" },
    { 0xC381180E, "shownenemyexplo" },
    { 0x76C77635, "shownodes" },
    { 0xBE9DF047, "shownotetrack" },
    { 0x4BC04CCF, "shownotetrackduration" },
    { 0x87080536, "shownotetrackoffset" },
    { 0x15778D58, "shownotetrackspeed" },
    { 0x3CB967EA, "shownotifymessage" },
    { 0x66541799, "shownotifymessageinternal" },
    { 0xB6E5AD7C, "shownotifymessagezombie" },
    { 0x8760683F, "shownretrievable" },
    { 0xD8EDF198, "shownumai" },
    { 0x66BE210F, "showobjective" },
    { 0xC15A38AA, "showobjectivetext" },
    { 0x2BACD307, "showonespawnpoint" },
    { 0x67B7C527, "showoutlines" },
    { 0x93258316, "showpaintshop" },
    { 0x123D36D9, "showpart" },
    { 0x00CB1973, "showpath" },
    { 0xE012A74E, "showpath_trigger" },
    { 0xAE77A5BA, "showperk" },
    { 0x1B1DAA35, "showperks" },
    { 0x7EECD98E, "showplayerteamhudelemtospectator" },
    { 0xCD512F7F, "showpowerupmessage" },
    { 0x961D3CAA, "showreviveicon" },
    { 0xA571F106, "showrocket" },
    { 0x759FB12D, "showrocketwhenreloadisdone" },
    { 0xE5BE96A6, "showround" },
    { 0x6394CCF3, "showrunning" },
    { 0xB56EA499, "shows" },
    { 0xE55F2133, "showsafespawnmessage" },
    { 0x8AE9FF38, "showscore" },
    { 0x1640CAF8, "showscoreboard" },
    { 0x779DF393, "showscores" },
    { 0xA7D01F99, "showskill" },
    { 0x7218C071, "showsniperglint" },
    { 0xA559A720, "showspawnmessage" },
    { 0x7D9B2146, "showspawnpoints" },
    { 0x59BCE1AA, "showspawns" },
    { 0xC5BA9968, "showsquadinfo" },
    { 0xE48EAAF5, "showsquadlocationselectionmap" },
    { 0x8C5BB0AE, "showstart" },
    { 0x87AE141E, "showstartspawnpoints" },
    { 0xD8CE50C5, "showstate" },
    { 0xF363262B, "showstopper" },
    { 0x70C5423F, "showsuccess" },
    { 0xA3AE68D9, "showtime" },
    { 0x73516CE7, "showtoenemyteams" },
    { 0x4664A3E2, "showtoplayer" },
    { 0xEDB35629, "showtopthreeplayers" },
    { 0x762D95B2, "showtoteam" },
    { 0xA4FD651B, "showtraverses" },
    { 0xFA9490DC, "showui" },
    { 0x1E9E5BD1, "showvalue" },
    { 0x859D37B8, "showviewmodel" },
    { 0x6030B386, "showweapon" },
    { 0x1822C1D4, "showweaponinfirstperson" },
    { 0xFFA1B96A, "showwindow" },
    { 0x4D0B6261, "showzbarrierpiece" },
    { 0x58B37231, "shreck" },
    { 0x86845E49, "shreck_damage_ent" },
    { 0x71FC8A60, "shreck_end_pos" },
    { 0xAD412711, "shreck_fired_to_house" },
    { 0x2C825613, "shreck_guy_killed" },
    { 0x18FB27D3, "shreck_hit" },
    { 0x7E4384E2, "shreck_hit_window" },
    { 0x891EF409, "shreck_points" },
    { 0x527B4EB3, "shreck_start_pos" },
    { 0xA962C966, "shreck_targets" },
    { 0x81EC4798, "shrecks" },
    { 0xBE7D2244, "shrecksmoke" },
    { 0x61DE2187, "shredded_guys" },
    { 0x470619C5, "shredded_guys_align" },
    { 0x841C9EF0, "shreds" },
    { 0x0588D399, "shrek_bounce_guy" },
    { 0x20E98A23, "shrek_bounce_spawner_strat" },
    { 0x4628F006, "shrek_target" },
    { 0x4ECCADB3, "shrike" },
    { 0xA0065E94, "shrimp" },
    { 0x63C621B0, "shrimp_effect" },
    { 0x480654C5, "shrimp_move_down_spline" },
    { 0x7740B29C, "shrimp_wait" },
    { 0xD0D49307, "shrimps" },
    { 0xBDE7D398, "shrine" },
    { 0x71E2DEC6, "shrink" },
    { 0x2BFE3A75, "shrink_goalradius_util" },
    { 0x9B123714, "shrink_my_radius" },
    { 0x709333BC, "shrink_pip_fullscreen" },
    { 0x7711E778, "shrink_ray_fling" },
    { 0xC8C1E622, "shrink_time" },
    { 0x94569102, "shrinkable" },
    { 0x42A5FD49, "shrinked" },
    { 0x075BF679, "shrinks" },
    { 0x87F82F26, "shrp_rules" },
    { 0x10F06D47, "shrprandomweapon" },
    { 0x9E0E70B9, "shrpweaponnumber" },
    { 0xE2BA8E45, "shrpweapontimer" },
    { 0x9622C92A, "shrunk" },
    { 0x41316A5F, "shs" },
    { 0x32FA354B, "shuddering_entity_think" },
    { 0xAD10FBE0, "shuffle" },
    { 0xDC4D49CA, "shuffle_array" },
    { 0xAEB1E190, "shuffle_cover_min_distsq" },
    { 0x9306C9B3, "shuffle_door_max_distsq" },
    { 0xCB79AF9F, "shuffleanim" },
    { 0xAA15B864, "shuffled" },
    { 0x8585A44D, "shuffledgroup" },
    { 0x0B122910, "shuffledist" },
    { 0x58872713, "shuffleleft" },
    { 0xB3CC53D7, "shufflemove" },
    { 0x40E0860B, "shufflemoveinterrupted" },
    { 0xA53A5FC4, "shufflenode" },
    { 0x5BF752B0, "shuffleradios" },
    { 0xF819ED86, "shuffleright" },
    { 0x74D9ACBD, "shufflezones" },
    { 0x9F62C261, "shuffling" },
    { 0x9899333A, "shuoldnt" },
    { 0xFF326A3F, "shut" },
    { 0xB9133872, "shut_down_chopper_support" },
    { 0x777B79D1, "shut_off" },
    { 0x1F78A85D, "shut_off_all_looping_sounds" },
    { 0xA491838E, "shut_off_boat" },
    { 0x9329F246, "shut_off_fx" },
    { 0x8419F22F, "shutdown" },
    { 0x2BAD199F, "shutdown_battlechatter" },
    { 0x0598C67E, "shutdown_empgrenade" },
    { 0x4BF24059, "shutdown_lights" },
    { 0x562705FD, "shutdown_squadbattlechatter" },
    { 0xAFC2DC96, "shutdown_think" },
    { 0x818CCEC9, "shutdowncontact" },
    { 0x5C7D326F, "shutdownemp" },
    { 0x2498A3CA, "shutdownemprebootindicatormenu" },
    { 0xCFED633A, "shutdownepictauntmodels" },
    { 0xFBC1BF62, "shutdownoncancelevent" },
    { 0xA8C52C76, "shutdowns" },
    { 0xD8DDB3DD, "shutdownwatcher" },
    { 0x2D64359E, "shutoff_swimming_loops" },
    { 0x80BCB93A, "shutoff_time" },
    { 0x21252065, "shutoffpapsounds" },
    { 0x41D6AF46, "shuts" },
    { 0x6A3CA660, "shutter" },
    { 0xE7135873, "shutter_enable_zone" },
    { 0x1D02D843, "shutter_guys" },
    { 0x9DBCDF71, "shutter_init" },
    { 0x557AE1E9, "shutter_l" },
    { 0x86CC8518, "shutter_left" },
    { 0xB51AD631, "shutter_light_green" },
    { 0x61F09F4D, "shutter_light_red" },
    { 0x75D5C684, "shutter_lights" },
    { 0x2B62759F, "shutter_move_switch" },
    { 0x73715DE0, "shutter_open_init" },
    { 0xBA440D4B, "shutter_pair_1" },
    { 0x6E3F1879, "shutter_pair_3" },
    { 0xC9C53A37, "shutter_r" },
    { 0x0A1EBDA7, "shutter_right" },
    { 0x46585F5B, "shutter_switch" },
    { 0x1A957249, "shutter_think" },
    { 0x82A4834C, "shutterpair" },
    { 0x9CF20820, "shutterpair_move" },
    { 0x149C005F, "shutterpair_move_bounce" },
    { 0x07E36257, "shutterpair_open" },
    { 0xB5782A4F, "shutterpair_open_watch" },
    { 0x2FF84C0B, "shutters" },
    { 0x9A48B59E, "shutters_open" },
    { 0x8F05B565, "shutters_open_2" },
    { 0x8C9A7CE1, "shutters_opened" },
    { 0x5597105D, "shuttersound" },
    { 0x2AB58DA4, "shutterwanderleft" },
    { 0x0B1D269B, "shutterwanderright" },
    { 0xB16B4D4F, "shutting" },
    { 0x11EFD89F, "shuttingdown" },
    { 0x1505BABA, "shuuuuuu" },
    { 0x7E0CB484, "sic" },
    { 0xF305E05F, "sick" },
    { 0x3575B53B, "sick_girls" },
    { 0x2AECC982, "sickening" },
    { 0x98EA785E, "sickle" },
    { 0x38AEBF12, "sickle_triggers" },
    { 0x1B115A1E, "sickness" },
    { 0x050692FB, "sicne" },
    { 0x580A3A1B, "sid" },
    { 0x984440EB, "sidable" },
    { 0x64D19A9C, "side" },
    { 0x5781EA4D, "side1" },
    { 0x6D95A517, "side1goalnodes" },
    { 0x7D8464B6, "side2" },
    { 0xBFC11F99, "side3goalnodes" },
    { 0x1805D6A5, "side_already_destroyed" },
    { 0x58C80A91, "side_arm_array" },
    { 0xD0B41EC0, "side_away_dist" },
    { 0x8545A8B9, "side_bet_all_bets_placed" },
    { 0x6AE77D92, "side_bet_begin" },
    { 0x634B76A6, "side_bet_end" },
    { 0x8488655E, "side_bet_timer" },
    { 0xBBAA9410, "side_close_dist" },
    { 0x62944A35, "side_damage_clip" },
    { 0x5817D26B, "side_death" },
    { 0x99EE6656, "side_deflection" },
    { 0x3ADE70A0, "side_dir" },
    { 0x20DA25B4, "side_dir_mag" },
    { 0x043A0DDE, "side_guard" },
    { 0x05359BA6, "side_gunners_gun" },
    { 0x3CB8FF6F, "side_max" },
    { 0xD1BB8A11, "side_min" },
    { 0x21B889CC, "side_movement" },
    { 0xFEE6FD99, "side_norm" },
    { 0x9BE5DA4A, "side_offset" },
    { 0x16360097, "side_push_vel" },
    { 0xB281512B, "side_selection" },
    { 0xE5AF3B61, "side_step" },
    { 0x095CECF8, "side_step_chance" },
    { 0xFFCC2F2B, "side_turret_get_best_target" },
    { 0x13B96489, "side_turret_is_target_in_view_score" },
    { 0xE661FC16, "side_turrets_forward" },
    { 0xC7B988EC, "side_vel" },
    { 0xF7F7D26C, "sideamnt" },
    { 0xC339957B, "sideanim" },
    { 0x3831C817, "sideanimweight" },
    { 0xC11924BA, "sidearm" },
    { 0xDB5F70B3, "sidearm_start" },
    { 0x1045213F, "sidearm_training" },
    { 0x6F589735, "sidearms" },
    { 0x2CC77A8E, "sidearmtraining_begin" },
    { 0x97D63CC2, "sidearmtraining_end" },
    { 0x77929119, "sidebet" },
    { 0x69FE1B99, "sidebetallbetsplaced" },
    { 0xA53D4025, "sidebetamount" },
    { 0x3531290B, "sidebetendtime" },
    { 0x37A341A6, "sidebetnumber" },
    { 0x55E15A9F, "sidebetpayout" },
    { 0x832F06A9, "sidebetplayers" },
    { 0xFEF98303, "sidebetpool" },
    { 0xC5485208, "sidebettimer" },
    { 0x3231F927, "sidebetwinners" },
    { 0xB01034B2, "sidebetwinnings" },
    { 0x830FEB6F, "sidec" },
    { 0x3E6C7080, "sidechainduck" },
    { 0x78FE9290, "sided" },
    { 0x8BF93A69, "sidedotmax" },
    { 0xA968CF17, "sidedotmin" },
    { 0x00E3AF17, "sideexplosionfx" },
    { 0x6D210C75, "sidenorth" },
    { 0x80F2FD90, "sidepaths" },
    { 0xDA5D3A32, "sidequest" },
    { 0x44531841, "sidequest_" },
    { 0xAAB76F27, "sidequest_boundary" },
    { 0x5EA5F0B8, "sidequest_complete" },
    { 0x0E55F3EC, "sidequest_completed" },
    { 0xBF0C131D, "sidequest_coop_completed_watcher" },
    { 0xF679BCF6, "sidequest_debug" },
    { 0xF68E6243, "sidequest_debug_tracker" },
    { 0x60A54D39, "sidequest_debug_tracker_update" },
    { 0x37426445, "sidequest_done" },
    { 0x70F78BA1, "sidequest_icons" },
    { 0x151DFC6A, "sidequest_init_tracker" },
    { 0x9B08126D, "sidequest_logic" },
    { 0x302FCBB9, "sidequest_logic_1" },
    { 0x56324622, "sidequest_logic_2" },
    { 0xE45D03AE, "sidequest_main" },
    { 0x76221A40, "sidequest_name" },
    { 0x498F1B6B, "sidequest_names" },
    { 0xFF948A5C, "sidequest_println" },
    { 0xB10FD4F7, "sidequest_solo_completed_watcher" },
    { 0x22750029, "sidequest_sq_complete" },
    { 0xC0C0CAB6, "sidequest_stage_active" },
    { 0xD9BE8A5B, "sidequest_start" },
    { 0x513E3F2A, "sidequest_start_next_stage" },
    { 0x818D4E23, "sidequest_stat" },
    { 0x0BC92E34, "sidequest_uses_teleportation" },
    { 0x6C987BBD, "sidequests" },
    { 0x889C423D, "sideroom" },
    { 0x22E844DF, "sides" },
    { 0xDC540552, "sidestep" },
    { 0x8CF72325, "sidestep_done" },
    { 0x3419296D, "sidestepanim" },
    { 0x5D7F396C, "sidestepanims" },
    { 0xFECCBECD, "sidestepblendout" },
    { 0x5BD78A70, "sidestepfunc" },
    { 0xA6D49FB4, "sidestepinit" },
    { 0xBB5ED0DA, "sidestepping" },
    { 0xCDCBE8A2, "sidesteptype" },
    { 0x34526248, "sidestepwatchforevent" },
    { 0x6B59E1B2, "sideswipe" },
    { 0x2A542A3D, "sideswipes" },
    { 0x44C7F6E0, "sideswitch" },
    { 0x023DF778, "sideswitching" },
    { 0xC498C88D, "sidetosideanim" },
    { 0x3A4F615E, "sidetracked" },
    { 0xBB3AC1DF, "sidewalk" },
    { 0x9A177459, "sideway" },
    { 0x991E7810, "sideways" },
    { 0xF86296D7, "sidewinder" },
    { 0x00ED242F, "sidewinder_reticlelockon_stop" },
    { 0x23743C52, "sidewinder_targeted" },
    { 0x3BAE1206, "siege" },
    { 0xD6BB7E31, "siegebot" },
    { 0x1D386BBC, "siegebot_arm_trace_clip_mask" },
    { 0x1356EE84, "siegebot_bundle" },
    { 0x3B05FC1B, "siegebot_callback_damage" },
    { 0x0DCB2CF5, "siegebot_driving" },
    { 0xFCF49D56, "siegebot_initialize" },
    { 0xCC487332, "siegebot_kill_on_tilting" },
    { 0x881B2DF7, "siegebot_kills" },
    { 0x392E3FF0, "siegebot_left_arm_trace_end" },
    { 0xAD2685B0, "siegebot_left_arm_trace_offset" },
    { 0x3CF86483, "siegebot_left_arm_trace_start" },
    { 0x3CF73653, "siegebot_left_arm_trace_tag" },
    { 0x6C9B01C5, "siegebot_missile_count_after_reload" },
    { 0xF9AA7BE0, "siegebot_missile_turret_index" },
    { 0xBD6A90CA, "siegebot_player_aimupdate" },
    { 0x5BEEC115, "siegebot_player_fireupdate" },
    { 0x982BD889, "siegebot_right_arm_trace_end" },
    { 0x3DE2A803, "siegebot_right_arm_trace_offset" },
    { 0x1477D962, "siegebot_right_arm_trace_start" },
    { 0xB5D5CBB2, "siegebot_right_arm_trace_tag" },
    { 0x51FA8B3B, "siegebot_rocket_wall_blocked_frames" },
    { 0xD208C5E9, "siegebot_rocket_wall_forward_offset" },
    { 0x1D3108B7, "siegebot_rocket_wall_relative_tag" },
    { 0xF8BAF796, "siegebot_rocket_wall_right_offset" },
    { 0x5DB14EFE, "siegebot_rocket_wall_tag" },
    { 0xA90B716F, "siegebot_rocket_wall_trace_end" },
    { 0xFF9AF3A4, "siegebot_rocket_wall_trace_start" },
    { 0x58B9F470, "siegebot_rocket_wall_trace_tag" },
    { 0x8ED6883E, "siegebot_rocket_wall_z_offset" },
    { 0xA28CC5AB, "siegebot_theia" },
    { 0xABE0534E, "siegebot_theia_bundle" },
    { 0xF3E02741, "siegebot_update_difficulty" },
    { 0x9C901CD6, "siegebot_watch_death" },
    { 0x3D6438AE, "siegecmd" },
    { 0x5DBE8B83, "sierra" },
    { 0xE6C87F08, "sigh" },
    { 0x6ACD85B1, "sighcone" },
    { 0xCD32EF8C, "sight" },
    { 0x0D78214F, "sight_dist" },
    { 0xAAEC569D, "sight_distsqrd" },
    { 0xB91C5232, "sight_horiz_dist" },
    { 0x7E7BA03F, "sight_rec" },
    { 0x5143A614, "sight_timeout" },
    { 0xF083A1EA, "sightblocker" },
    { 0xDCCE5940, "sightblockertn" },
    { 0x691A0558, "sightchecknode" },
    { 0x46EF5800, "sightchecknode_invalidate" },
    { 0x84236A30, "sightchecknodeproc" },
    { 0x7D286CE2, "sightcheckorigin" },
    { 0xFBADB457, "sightchecks" },
    { 0x87E955A4, "sightconetrace" },
    { 0xBD433E1C, "sightdetectdistance" },
    { 0x2E82D1DC, "sightdist" },
    { 0xD4B6776F, "sighted" },
    { 0xC0E09968, "sightenemy" },
    { 0x74675605, "sightfov" },
    { 0x2E822C3C, "sighting" },
    { 0x0054266A, "sightlatency" },
    { 0x8B573DCA, "sightpos" },
    { 0x98093881, "sightposleft" },
    { 0xE113C2C5, "sightpostime" },
    { 0x7438584B, "sightrange" },
    { 0xA50EE20F, "sights" },
    { 0x1B841DB7, "sighttarget" },
    { 0x1FD0939F, "sighttime" },
    { 0x5594396F, "sighttrace" },
    { 0xE7865C4B, "sighttracepassed" },
    { 0x74CEB7B3, "sighttracepoint" },
    { 0x55C88EDC, "sighttracetime" },
    { 0xCAD75D7E, "sign" },
    { 0x15819B73, "sign1" },
    { 0xDD84DAF2, "sign_01_hit" },
    { 0xF7AB71DE, "sign_01_splash" },
    { 0xE25D7945, "sign_02_hit" },
    { 0xC42B0A20, "sign_03_hit" },
    { 0xF6EA5F78, "sign_03_splash" },
    { 0x9139EBE3, "sign_04_hit" },
    { 0x0D33992E, "sign_05_hit" },
    { 0x7FF99D5E, "sign_bit" },
    { 0x5BA939C9, "sign_break_lp" },
    { 0xFD176261, "sign_dangle_break_start" },
    { 0xDE45814A, "sign_leyna" },
    { 0x876E07A3, "sign_leyna_start" },
    { 0x9F8333E1, "sign_loop_ent" },
    { 0x66880580, "sign_variant" },
    { 0x2E5CB8A5, "signal" },
    { 0x8E2E98C5, "signal_activated" },
    { 0x594FB86C, "signal_equipment_activated" },
    { 0xA4F295BC, "signal_node" },
    { 0x59EA6532, "signal_on_node" },
    { 0xF1FF0970, "signal_stop" },
    { 0x4CB90AAC, "signalarray" },
    { 0x26BD9FF4, "signaler" },
    { 0x2F63117E, "signaler_alive" },
    { 0x1B4C3103, "signaling" },
    { 0x4E28FBB4, "signals" },
    { 0xA6657609, "signature" },
    { 0xA4083765, "signature_boat_override" },
    { 0x8B8F8012, "signature_death" },
    { 0x86600896, "signature_death_explosion" },
    { 0xE79BD300, "signatures" },
    { 0xC9DB3D8F, "signbit" },
    { 0xC892AAC1, "signed" },
    { 0x60E61342, "significance" },
    { 0xC1C2D90A, "significant" },
    { 0x3EAC3C27, "significant_version" },
    { 0x1C0F44D7, "significantly" },
    { 0x1717B738, "signifies" },
    { 0x28FCC3B4, "signify" },
    { 0x48DE0C61, "signs" },
    { 0xD8ABDAF4, "sigth" },
    { 0x34A2417B, "silcox" },
    { 0xB47FA99A, "silence" },
    { 0xE73D60EA, "silenced" },
    { 0xD31AAF2C, "silencer" },
    { 0xC71E29AB, "silencing" },
    { 0x01022172, "silent" },
    { 0xCC25525C, "silent_launch" },
    { 0x49E01F93, "silent_runner" },
    { 0xA8535B47, "silent_runner_bg" },
    { 0xB4671BFC, "silently_lowerplywoodwalls" },
    { 0xE52B6115, "silentlyremovezombie" },
    { 0x89DFA787, "silhouette" },
    { 0x183EDA7E, "silhouettes" },
    { 0x7A50238E, "silly" },
    { 0x578162CE, "silo" },
    { 0xF4790A1B, "silo_dmg" },
    { 0xC8D3B671, "silos" },
    { 0x7B47AC22, "silver" },
    { 0xC3DF711F, "silverback" },
    { 0x621B92FA, "sim" },
    { 0x787F11BC, "simageshader" },
    { 0x3B8FD77C, "similar" },
    { 0xB8EEE979, "similarly" },
    { 0x289C3CE2, "similiarly" },
    { 0x81297D6F, "simple" },
    { 0xEC338B03, "simple_explosion" },
    { 0x210232B6, "simple_flood_spawn" },
    { 0x7BD8B0FB, "simple_floodspawn" },
    { 0x5B838834, "simple_hostmigration" },
    { 0x8CE837A2, "simple_respawn" },
    { 0x22356BA7, "simple_spawn" },
    { 0x203457D8, "simple_spawn_and_drive" },
    { 0x1EED34DA, "simple_spawn_dummy" },
    { 0xA0180F25, "simple_spawn_force_to_goal" },
    { 0x765666A9, "simple_spawn_force_to_goal_exact" },
    { 0xB6A7A6F0, "simple_spawn_force_to_goal_no_stop" },
    { 0x6F56A435, "simple_spawn_rusher" },
    { 0xC1F1F6FC, "simple_spawn_rusher_single" },
    { 0x7D262A13, "simple_spawn_script_delay" },
    { 0x7387A40A, "simple_spawn_single" },
    { 0x2962E239, "simple_spawn_single_and_drive" },
    { 0xE5C52D2A, "simple_spawner" },
    { 0xD8D534B7, "simple_spawners_level_init" },
    { 0xADB551DF, "simple_timed_explosion" },
    { 0xB8AE7A2B, "simpleaccuracycontrol" },
    { 0x7967D589, "simplecredits_code" },
    { 0x6F7D111F, "simpler" },
    { 0xF3E421C4, "simplifed" },
    { 0x4F4CA48F, "simplified" },
    { 0xAFCE113C, "simplify" },
    { 0xE15E260C, "simplifying" },
    { 0xB90BC083, "simply" },
    { 0xC4BC6130, "simply_patrol" },
    { 0x43396D27, "simulacrum" },
    { 0x10812CEF, "simulate" },
    { 0xA63701DD, "simulate_weapon_fire" },
    { 0x9D51E5E4, "simulate_weapon_fire_machine_gun" },
    { 0x660C06FA, "simulate_weapon_fire_machine_gun_full_auto" },
    { 0xC67D522D, "simulate_weapon_fire_machine_gun_semi_auto" },
    { 0xFCF76115, "simulate_weapon_fire_pistol" },
    { 0x2D9E373E, "simulate_weapon_fire_shotgun" },
    { 0x3BF90541, "simulate_weapon_fire_sniper" },
    { 0x2D87126E, "simulatenous" },
    { 0x7083DD36, "simulates" },
    { 0xB189D30F, "simulateweaponfire" },
    { 0xC6F9B144, "simulateweaponfiremachinegun" },
    { 0xC45D15CE, "simulateweaponfiremachinegunfullauto" },
    { 0xDEC71987, "simulateweaponfiremachinegunsemiauto" },
    { 0x7F17E972, "simulateweaponfirepistol" },
    { 0xA47ADE3F, "simulateweaponfireshotgun" },
    { 0x1C82F3D2, "simulateweaponfiresniper" },
    { 0xBE5D386A, "simulating" },
    { 0x0D6F15E4, "simulation" },
    { 0xE894ACB2, "simultaneous" },
    { 0xFA24F4BF, "simultaneously" },
    { 0x5CBCC643, "simultaniously" },
    { 0x2F67845D, "simutaneously" },
    { 0x3C191891, "sin" },
    { 0x36B626E5, "since" },
    { 0x29644C27, "sincerely" },
    { 0xBC000CDC, "sincurrent" },
    { 0xDE39CE5E, "sine" },
    { 0xC5D2E3FA, "sinful" },
    { 0x49C33890, "sing_police_names" },
    { 0xA0846CEA, "singals" },
    { 0xDD0CAD11, "singapore" },
    { 0x3E54D2E5, "single" },
    { 0xF74B47A6, "single50_truck" },
    { 0x84533C47, "single_anim" },
    { 0x581BD7AA, "single_anim_done" },
    { 0xD282B67A, "single_burst" },
    { 0x9885ACDC, "single_civ_approach_window_anim" },
    { 0x1FE21B93, "single_damage_trigger_cleanup" },
    { 0xABC719FE, "single_exploders" },
    { 0x18B3A511, "single_explosion_at_struct" },
    { 0xB1E5BFEA, "single_func" },
    { 0x3BDB6ACF, "single_gump_name" },
    { 0xACC89DC6, "single_loop_react_anim" },
    { 0xFD945FFE, "single_mission_difficulty" },
    { 0x44C887EA, "single_perk_ref" },
    { 0x35276DFE, "single_play" },
    { 0xF3CB6DBC, "single_reach_anim_idle" },
    { 0x16E770D8, "single_rpg_shot" },
    { 0xACD74F57, "single_rumble" },
    { 0x8828B758, "single_thread" },
    { 0x85F3FAEB, "singlebreacher" },
    { 0x48104FE6, "singleeffect" },
    { 0x15A09ACE, "singleguypacket" },
    { 0x6098A370, "singlelocation" },
    { 0x37F9ACA4, "singlelockap_guidance" },
    { 0xA1D35CC7, "singlemortaronerep" },
    { 0xC7E51506, "singleowner" },
    { 0x43273772, "singleplayer" },
    { 0x61EF43D5, "singleradarsweep" },
    { 0x21ACDC25, "singleshot" },
    { 0xA63323BC, "singleton" },
    { 0xEFA79BAF, "singletonstring" },
    { 0xF37EB3F6, "singular" },
    { 0x3CD83046, "singularity" },
    { 0xCA171CA0, "sink" },
    { 0xBCF867DB, "sink_angles" },
    { 0x962DDD18, "sink_anim" },
    { 0x87062D2C, "sink_big_fx" },
    { 0x0B3CCBE9, "sink_boat" },
    { 0xC87B9021, "sink_buoyancy" },
    { 0xEF0100E3, "sink_pos" },
    { 0x253F0656, "sink_ragdoll_corpses" },
    { 0x3C20574C, "sink_sfx" },
    { 0xF8939604, "sink_time" },
    { 0x30CA9838, "sinking" },
    { 0xD0C934E2, "sinking_barge" },
    { 0x6AECA831, "sinking_boat" },
    { 0x77593E59, "sinking_fx" },
    { 0x53A33E4B, "sinks" },
    { 0xFE12FDDB, "sinktime" },
    { 0x5A529678, "sins" },
    { 0x9C46326B, "sinx" },
    { 0x503BCA4F, "sip" },
    { 0x0436D57D, "sir" },
    { 0x62797210, "siren" },
    { 0xBC9819EC, "siren_1" },
    { 0x2E9F8927, "siren_2" },
    { 0x089D0EBE, "siren_3" },
    { 0xC0540B10, "siren_break" },
    { 0x1A351764, "siren_done_playing" },
    { 0x713DD2D6, "siren_ent" },
    { 0x572FA747, "siren_stop_on_endnode" },
    { 0x1D62BB2E, "sirenlightfx" },
    { 0xC1E52DEC, "sirenlightfxhandle" },
    { 0x83C82181, "sirenlights_off" },
    { 0x28C23775, "sirenlights_on" },
    { 0xE75DA4FB, "sirens" },
    { 0xE187935D, "sirens_off" },
    { 0xABFA8B11, "sirens_on" },
    { 0xCDC1983C, "sirs" },
    { 0xAF51D8A1, "sise" },
    { 0x18AD181D, "sister" },
    { 0xB831E0AB, "sit" },
    { 0x228AB736, "sit_at_dec20" },
    { 0x1ED5D2C2, "sit_rep_dialog" },
    { 0x547A03CC, "site" },
    { 0xDB30F74F, "sites" },
    { 0x08AA89DC, "sitrep" },
    { 0x1E80C47A, "sitrep_beast_mode_and_friendly" },
    { 0xCC7F018B, "sitrep_friendly_only" },
    { 0xC6F052E6, "sitrepscan1_enable" },
    { 0x60227000, "sitrepscan1_setdesat" },
    { 0xF5FCC731, "sitrepscan1_setfalloff" },
    { 0x4376E275, "sitrepscan1_setlinewidth" },
    { 0xF9C019C1, "sitrepscan1_setoutline" },
    { 0xE3CAAD17, "sitrepscan1_setradius" },
    { 0x439C65EE, "sitrepscan1_setsolid" },
    { 0x32DE8E47, "sitrepscan2_enable" },
    { 0x756E0BE1, "sitrepscan2_setdesat" },
    { 0xC3051290, "sitrepscan2_setfalloff" },
    { 0x93247488, "sitrepscan2_setlinewidth" },
    { 0xD0947AB8, "sitrepscan2_setoutline" },
    { 0x3E9D0D8C, "sitrepscan2_setradius" },
    { 0xFEC47ECB, "sitrepscan2_setsolid" },
    { 0x689CB58A, "sits" },
    { 0x045DFC3D, "sittag" },
    { 0x68EBA13D, "sittagangles" },
    { 0x705D3233, "sittagorigin" },
    { 0xAC1BA614, "sitter" },
    { 0xACDA2AA2, "sittimer" },
    { 0xC83B24A3, "sitting" },
    { 0xCAE793F4, "sitting_mcnamara" },
    { 0x5565D133, "situation" },
    { 0xE7848CE2, "situations" },
    { 0x804F9D97, "six" },
    { 0xA2D9A3EB, "sixth" },
    { 0x2E24ED66, "sixthsenseent" },
    { 0x83F79699, "sixthsenseents" },
    { 0x36EC76E6, "sixthsensemodel" },
    { 0x1CAF82F2, "sixty" },
    { 0x982BFCF2, "size" },
    { 0x53B12FD4, "size2" },
    { 0x827CC0C9, "size_max" },
    { 0xC48D458E, "size_max_org" },
    { 0x9D71EC77, "size_min" },
    { 0x41FEA82C, "size_min_org" },
    { 0x5BF8A21B, "size_x" },
    { 0x35F627B2, "size_y" },
    { 0x28232EB2, "sized" },
    { 0xFA52447D, "sizes" },
    { 0x7E5C4B34, "sizzle" },
    { 0x3C5C4900, "sizzle_range_squared" },
    { 0xFB9246E3, "sizzle_vec" },
    { 0xCF1643EE, "sj" },
    { 0x16CC5B66, "sjakatdar" },
    { 0x08F85CA1, "sjc" },
    { 0x56462DC8, "skating" },
    { 0x3AAE4518, "skeleton" },
    { 0x87F6E07C, "skeleton_arms_position" },
    { 0x670182CE, "skeleton_clientfield" },
    { 0x05EC5B06, "skeletonbehavior" },
    { 0xA770F4E8, "skeletoncanseeplayer" },
    { 0xA067C858, "skeletondeathaction" },
    { 0x72DF9548, "skeletongiblegscondition" },
    { 0x53729D53, "skeletonnotetrackmeleefire" },
    { 0x8B73C1F3, "skeletons" },
    { 0x989E1981, "skeletonsetgoal" },
    { 0x4DB74DEA, "skeletonshouldmeleecondition" },
    { 0xDB0C8138, "skeletonspawnsetup" },
    { 0xD89F6C60, "skeletontargetservice" },
    { 0xFBD7164A, "skewer" },
    { 0xE4677612, "skewer_the_beast" },
    { 0xB33A1BDD, "skewered" },
    { 0xD93A6469, "skid_fx" },
    { 0xB3BAC88C, "skidding" },
    { 0xA537D692, "skidfxnamearray" },
    { 0x6B1A4F78, "skies" },
    { 0x8F9A21AC, "skill" },
    { 0x5739EF80, "skill_drift" },
    { 0x67DF5076, "skill_multiplier" },
    { 0x4F8D5B23, "skill_override" },
    { 0xB2733C86, "skillmult" },
    { 0x4E2164AF, "skills" },
    { 0xE00EDCBF, "skillupdate" },
    { 0x2418C2B2, "skin" },
    { 0x5263C3FB, "skinned" },
    { 0xFE905F5D, "skinner" },
    { 0xC9E26A25, "skinner_vo" },
    { 0xE1209968, "skinner_wave_us_back" },
    { 0xFED05D3D, "skins" },
    { 0x0059315C, "skip" },
    { 0x2FE7D680, "skip4" },
    { 0xA220956C, "skip_alive_at_round_end_xp" },
    { 0x0470706E, "skip_anim_on_client" },
    { 0x8E3C54A2, "skip_anim_on_server" },
    { 0x9FE78B5D, "skip_camera_anims" },
    { 0x68413E1E, "skip_death_notetracks" },
    { 0x24AE8FD2, "skip_delete" },
    { 0x4BD71E61, "skip_demo_bookmark" },
    { 0xE6FFB226, "skip_dogs" },
    { 0x801DBB79, "skip_driver" },
    { 0xFC401E59, "skip_driver2" },
    { 0xCBFB4BE7, "skip_elevator_volume_check" },
    { 0x7F8893BA, "skip_first_check" },
    { 0x63DF9359, "skip_first_rescue" },
    { 0xBD4E7246, "skip_first_taunt" },
    { 0x57BF790A, "skip_gunner" },
    { 0x00DD899C, "skip_gunner2" },
    { 0xE7BB43F6, "skip_hill_spawning" },
    { 0x9CC5529D, "skip_interstitial" },
    { 0x63B66C27, "skip_intro" },
    { 0x80EA0C64, "skip_intro_prompt" },
    { 0xEFC73438, "skip_juggernaut_intro_sound" },
    { 0xC402572E, "skip_launchers" },
    { 0xDEC0A45B, "skip_level" },
    { 0xEBA4C738, "skip_lift_fuse" },
    { 0x160DBAD9, "skip_movie" },
    { 0x9B816D5C, "skip_movie_think" },
    { 0x77356492, "skip_msg" },
    { 0x97BAC5A9, "skip_next_destination" },
    { 0x434B4BAC, "skip_objective" },
    { 0x3514C6EB, "skip_piece" },
    { 0xE03A764D, "skip_scene" },
    { 0x5116FEDA, "skip_scene_menu_handle" },
    { 0x2F52C963, "skip_scene_on_client" },
    { 0x0390406F, "skip_scene_on_server" },
    { 0x601180FD, "skip_second_rescue" },
    { 0x36630CC9, "skip_sentinel_pathupdateinterrupt" },
    { 0x003C7543, "skip_sf_briefing" },
    { 0xCFE6097F, "skip_stumble" },
    { 0x9F83DEDC, "skip_success" },
    { 0x60282B10, "skip_team" },
    { 0x64047162, "skip_time_on_limping_guys" },
    { 0xCE0639B0, "skip_to" },
    { 0x4D738D69, "skip_to_charge_used" },
    { 0xC577D61C, "skip_to_sq_stage" },
    { 0xA40026AE, "skip_to_sunrise2" },
    { 0xCA02A117, "skip_to_sunrise3" },
    { 0xBFF14838, "skip_to_sunrise4" },
    { 0x7C9DF375, "skip_trigger" },
    { 0xA2420DD1, "skip_undo" },
    { 0x4A497471, "skip_weapon_object_damage" },
    { 0x98B55569, "skip_weapon_precache" },
    { 0xA0CE962D, "skipaimcheck" },
    { 0x2741573B, "skipanim" },
    { 0x2FDB480A, "skipautoragdoll" },
    { 0x60F0E391, "skipbattlechatterkill" },
    { 0xCEBB80D4, "skipcheck" },
    { 0xEDDBD1E2, "skipdeath" },
    { 0x5D45923D, "skipdeathanim" },
    { 0x8DBC65F5, "skipfutz" },
    { 0x8DEFBE41, "skipgameend" },
    { 0x5237B452, "skipifcurrentlyplayinggroup" },
    { 0x90B0C96B, "skipinitialwait" },
    { 0xF2115568, "skipinput" },
    { 0x3CACF752, "skipintro" },
    { 0x14CBF017, "skiplowammovox" },
    { 0x7B20572E, "skipme" },
    { 0xBF7150F0, "skipmovie" },
    { 0x36145777, "skipnotify" },
    { 0x71C57F7C, "skippable" },
    { 0xCC9A79C7, "skipped" },
    { 0x8CD11357, "skipped_radio" },
    { 0x7265D040, "skipped_scene_name" },
    { 0x7C55BA10, "skipped_to_event_1" },
    { 0xEE5D294B, "skipped_to_event_2" },
    { 0xC85AAEE2, "skipped_to_event_3" },
    { 0x3A621E1D, "skipped_to_event_4" },
    { 0x145FA3B4, "skipped_to_event_5" },
    { 0xAC207F5C, "skipped_to_missile" },
    { 0x3CA77EE4, "skippedto" },
    { 0xDD4A7744, "skipping" },
    { 0xE029CF99, "skipping_destination" },
    { 0xA0B1459C, "skipping_linked_scenes" },
    { 0x22892975, "skipping_scene" },
    { 0xC7B4794C, "skipping_wait" },
    { 0xBA97C99F, "skips" },
    { 0x347FB2AA, "skipscenedeath" },
    { 0x15EB27B0, "skipssuccess" },
    { 0x355D1723, "skipstartarea" },
    { 0xAC1DD7BF, "skipstartmove" },
    { 0xF6FCA01E, "skipt_model_convert_area" },
    { 0xFB0900EF, "skipteam" },
    { 0x0DB2FC1D, "skipthebriefing" },
    { 0x1D795D47, "skipto" },
    { 0x10701488, "skipto_a1d_01b" },
    { 0xF381D937, "skipto_a1d_01b_render" },
    { 0x202DE4B5, "skipto_a1d_02" },
    { 0xFB16E648, "skipto_a1d_02_render" },
    { 0xBEBA59E5, "skipto_a1m_01" },
    { 0xA2F0A038, "skipto_a1m_01_render" },
    { 0xD78C8F18, "skipto_a1m_02b" },
    { 0x0223F287, "skipto_a1m_02b_render" },
    { 0xBBD7228C, "skipto_a1m_03a" },
    { 0x468F117B, "skipto_a1m_03a_render" },
    { 0x2DDE91C7, "skipto_a1m_03b" },
    { 0x395C01BE, "skipto_a1m_03b_render" },
    { 0x07DC175E, "skipto_a1m_03c" },
    { 0x01068FD9, "skipto_a1m_03c_render" },
    { 0x49CFB351, "skipto_a1m_03d" },
    { 0x64036944, "skipto_a1m_03d_render" },
    { 0x00ADF5D8, "skipto_a1m_04" },
    { 0xF82BB947, "skipto_a1m_04_render" },
    { 0xD68345B3, "skipto_a2j_01b" },
    { 0x504057EA, "skipto_a2j_01b_render" },
    { 0xB080CB4A, "skipto_a2j_01c" },
    { 0x67243F25, "skipto_a2j_01c_render" },
    { 0xF40B7F60, "skipto_a2j_02" },
    { 0x6D163B5F, "skipto_a2j_02_render" },
    { 0x1A0DF9C9, "skipto_a2j_03" },
    { 0x784D67AC, "skipto_a2j_03_render" },
    { 0xC3B5A32F, "skipto_a2s_02" },
    { 0x314F1616, "skipto_a2s_02_render" },
    { 0x9DB328C6, "skipto_a2s_03" },
    { 0xFCF62191, "skipto_a2s_03_render" },
    { 0xDFA6C4B9, "skipto_a2s_04" },
    { 0xAD065E5C, "skipto_a2s_04_render" },
    { 0x13E54BCF, "skipto_a3a_01" },
    { 0x7FFF9CF6, "skipto_a3a_01_render" },
    { 0xA1DDDC94, "skipto_a3a_02" },
    { 0xD8A9ACF3, "skipto_a3a_02_render" },
    { 0xCB329EC5, "skipto_a3a_02a" },
    { 0xDAD50D58, "skipto_a3a_02a_render" },
    { 0xF135192E, "skipto_a3a_02b" },
    { 0x3766A0A9, "skipto_a3a_02b_render" },
    { 0x93C28F74, "skipto_a3d_01" },
    { 0x49623993, "skipto_a3d_01_render" },
    { 0xD9A3501C, "skipto_activate_trigger_delay" },
    { 0x1313F217, "skipto_afg1_01" },
    { 0x8402B70E, "skipto_afg1_01_render" },
    { 0x262EA14E, "skipto_afg2_01" },
    { 0x1E47C989, "skipto_afg2_01_render" },
    { 0xBFBE9B63, "skipto_afg_06" },
    { 0x6980E55A, "skipto_afg_06_render" },
    { 0x2C8EC203, "skipto_after_attack" },
    { 0x13A59501, "skipto_alley" },
    { 0x708450AB, "skipto_ang1" },
    { 0xFA2CF7D2, "skipto_ang1_render" },
    { 0x144AC1A4, "skipto_ang_01" },
    { 0x136DA2C3, "skipto_ang_01_render" },
    { 0x865230DF, "skipto_ang_02" },
    { 0x0D6A8A46, "skipto_ang_02_render" },
    { 0x604FB676, "skipto_ang_03" },
    { 0x0051E7C1, "skipto_ang_03_render" },
    { 0x5DC79051, "skipto_ant2_01" },
    { 0x6C751844, "skipto_ant2_01_render" },
    { 0x83CA0ABA, "skipto_ant2_02" },
    { 0xD9349415, "skipto_ant2_02_render" },
    { 0xA9CC8523, "skipto_ant2_03" },
    { 0x512D9E1A, "skipto_ant2_03_render" },
    { 0xCFCEFF8C, "skipto_ant2_04" },
    { 0x4F00C07B, "skipto_ant2_04_render" },
    { 0x5289FC32, "skipto_antfarm_two" },
    { 0xED1558A4, "skipto_antfarm_two_lightmoveable" },
    { 0x21118489, "skipto_antfarm_two_pendant_1" },
    { 0x4713FEF2, "skipto_antfarm_two_pendant_2" },
    { 0xEC0657E5, "skipto_anthem" },
    { 0xBFD62BDC, "skipto_anthem_approach" },
    { 0x00991013, "skipto_arena" },
    { 0x6946FD1D, "skipto_array" },
    { 0x06CE935C, "skipto_arrays" },
    { 0x32FB1701, "skipto_arrival" },
    { 0xF9DE02CE, "skipto_av7" },
    { 0x4AAEB4DE, "skipto_av7bosworth" },
    { 0xB739FB60, "skipto_av7briggs" },
    { 0xEF6994DD, "skipto_av7chloe" },
    { 0xA842620C, "skipto_av7harper" },
    { 0xAA79E658, "skipto_av7mason" },
    { 0xDDE2930F, "skipto_av7section" },
    { 0x623AB15D, "skipto_avalanche" },
    { 0x9DC216EF, "skipto_b1a_02" },
    { 0x8F41DFD6, "skipto_b1a_02_render" },
    { 0x77BF9C86, "skipto_b1a_03" },
    { 0xD3773451, "skipto_b1a_03_render" },
    { 0x155A8787, "skipto_b2d_02" },
    { 0x62173E7E, "skipto_b2d_02_render" },
    { 0x2E078E92, "skipto_b3r_00" },
    { 0x48D041BD, "skipto_b3r_00_render" },
    { 0x540A08FB, "skipto_b3r_01" },
    { 0xAEAB9F62, "skipto_b3r_01_render" },
    { 0x7BE820E4, "skipto_barge_defend" },
    { 0x6A1A43D1, "skipto_base" },
    { 0x5D523638, "skipto_base_jump" },
    { 0x2B7B4EE7, "skipto_beach" },
    { 0xDEBFBB9A, "skipto_beach_player_ai" },
    { 0x141F50BD, "skipto_beat_down" },
    { 0x2B43808E, "skipto_betrayal" },
    { 0x7D21FEC2, "skipto_bfr_01" },
    { 0xF90FF9ED, "skipto_bfr_01_render" },
    { 0x29BAE3D3, "skipto_blockingdone" },
    { 0x3F2EE6AD, "skipto_bp1wave3" },
    { 0x45D3FB15, "skipto_breach" },
    { 0xD9D59D9D, "skipto_bridge" },
    { 0xB75B59F8, "skipto_briggs_1" },
    { 0x2962C933, "skipto_briggs_2" },
    { 0x03604ECA, "skipto_briggs_3" },
    { 0xC3EA3996, "skipto_building" },
    { 0x59C4D913, "skipto_bus_dam" },
    { 0x60EC9D37, "skipto_bus_dam_deconstruct_ents" },
    { 0xBDC0EBFA, "skipto_bus_street" },
    { 0x09B76BA3, "skipto_c1a" },
    { 0xC764B8BC, "skipto_c1a_02" },
    { 0xA14379AB, "skipto_c1a_02_render" },
    { 0x4FD39D9A, "skipto_c1a_render" },
    { 0x7BBEDADE, "skipto_c1d" },
    { 0x004EFE57, "skipto_c1d_02" },
    { 0x71349A4E, "skipto_c1d_02_render" },
    { 0x081E3E59, "skipto_c1d_render" },
    { 0x96705556, "skipto_c2a_a" },
    { 0xD6781CE1, "skipto_c2a_a_render" },
    { 0x706DDAED, "skipto_c2a_b" },
    { 0x65B8D9B0, "skipto_c2a_b_render" },
    { 0x8D62EE8B, "skipto_c2d" },
    { 0x4E90A172, "skipto_c2d_render" },
    { 0x4398B523, "skipto_camo_battle" },
    { 0xB156A83D, "skipto_camo_intro" },
    { 0xA2869A1C, "skipto_capture" },
    { 0x52CB9415, "skipto_car_smash" },
    { 0xF5D8A71A, "skipto_celerium" },
    { 0x6B909281, "skipto_character_comparison" },
    { 0xD8574C78, "skipto_chase" },
    { 0xC0CCC524, "skipto_check_conditional_dvars" },
    { 0x0FCAA76B, "skipto_checkin" },
    { 0xFBFB9D08, "skipto_checkpoint" },
    { 0x27E94907, "skipto_claw" },
    { 0xCD2BF8F8, "skipto_claw_no_flamethrower" },
    { 0x13594762, "skipto_cleanup" },
    { 0x7E995C25, "skipto_club_exit" },
    { 0x7B541168, "skipto_club_solar" },
    { 0x1D462DAA, "skipto_com_01a" },
    { 0x59354745, "skipto_com_01a_render" },
    { 0xF743B341, "skipto_com_01b" },
    { 0x79EBF1F4, "skipto_com_01b_render" },
    { 0xEA39E10A, "skipto_com_02" },
    { 0xBA7470E5, "skipto_com_02_render" },
    { 0x2077453F, "skipto_comstation" },
    { 0x6E193DC2, "skipto_confrontation" },
    { 0xAEEA69E1, "skipto_construction" },
    { 0x81098DBF, "skipto_container" },
    { 0xB0147153, "skipto_convoy_rooftops_struct" },
    { 0x583AE4D7, "skipto_cougar_fall" },
    { 0xF87B61B4, "skipto_crc" },
    { 0x557CE034, "skipto_debug_heli_strafe" },
    { 0xCED438B9, "skipto_defalco_render" },
    { 0x34050965, "skipto_defalco_trainyard" },
    { 0xA1396B52, "skipto_deserted" },
    { 0x310F4C91, "skipto_dev_animtest" },
    { 0x2425B865, "skipto_dev_build_test" },
    { 0x428028C7, "skipto_dev_freeroam" },
    { 0x66775F74, "skipto_dev_freeroam_exterior" },
    { 0x6552422B, "skipto_dev_halltest" },
    { 0x3CF0FA3F, "skipto_dev_menendez_execution" },
    { 0x40FBA7CE, "skipto_dev_menendez_hill" },
    { 0x2127D2F2, "skipto_devfreeroam" },
    { 0x7B5AB355, "skipto_display_cleanup" },
    { 0xBD196A6A, "skipto_docks" },
    { 0x16E28AEE, "skipto_drive" },
    { 0x01F81F42, "skipto_drone_control" },
    { 0x0DEF22C0, "skipto_drone_crash" },
    { 0xE75906B6, "skipto_drones_mobilize_general" },
    { 0xCAD3BB15, "skipto_dropdown" },
    { 0xF3D3998D, "skipto_dropdown2" },
    { 0x12CADC28, "skipto_e1" },
    { 0x33FDC019, "skipto_e1_flight" },
    { 0x9CA575B8, "skipto_e1_main" },
    { 0x84D24B63, "skipto_e2" },
    { 0xFEA38019, "skipto_e2_main" },
    { 0x5C143F59, "skipto_end" },
    { 0x6C130337, "skipto_end_noai" },
    { 0x87256436, "skipto_endings" },
    { 0xC75E9BE4, "skipto_endings_scenario1" },
    { 0x39660B1F, "skipto_endings_scenario2" },
    { 0x136390B6, "skipto_endings_scenario3" },
    { 0x55572CA9, "skipto_endings_scenario4" },
    { 0x8E243868, "skipto_escape_battle" },
    { 0xE7210301, "skipto_escape_bosses" },
    { 0x90B92154, "skipto_escape_intro" },
    { 0x4BCDEE0D, "skipto_evd_01" },
    { 0x4504C710, "skipto_evd_01_render" },
    { 0x9589C196, "skipto_event" },
    { 0x5A3B97DB, "skipto_eventname" },
    { 0xD61F201B, "skipto_f35_boarding" },
    { 0x1DFE466A, "skipto_f35_dogfights" },
    { 0xD8485D36, "skipto_f35_eject" },
    { 0x5171E75E, "skipto_f35_flying" },
    { 0x51398461, "skipto_f35_ground_targets" },
    { 0x6C732C63, "skipto_f35_hotel" },
    { 0xC26CD9D4, "skipto_f35_outro" },
    { 0x81C04FAB, "skipto_f35_pacing" },
    { 0x56988AF1, "skipto_f35_rooftops" },
    { 0x3B3D67B7, "skipto_f35_rooftops_struct" },
    { 0x410762F4, "skipto_f35_trenchrun" },
    { 0x87C1CAD4, "skipto_f35_wakeup" },
    { 0x5C7D19B8, "skipto_fight_to_isaac" },
    { 0x6BAA01FC, "skipto_find_menendez" },
    { 0xBDB94555, "skipto_firehorse" },
    { 0xFF3A314D, "skipto_flag_names" },
    { 0x20E35192, "skipto_flashlight_setup" },
    { 0xA4C06453, "skipto_fog_set" },
    { 0xCEB29741, "skipto_foyer" },
    { 0x8F1CE766, "skipto_frogger" },
    { 0x1B23C374, "skipto_frogger_claw_support" },
    { 0xB5330DBC, "skipto_frogger_deconstruct_ents" },
    { 0x55B03F02, "skipto_front_door" },
    { 0xAC75B1A4, "skipto_front_door_nothing" },
    { 0xE81A25BD, "skipto_front_door_obama" },
    { 0xB4509389, "skipto_front_door_obama_sco" },
    { 0x6D30ECAE, "skipto_front_door_sco" },
    { 0x7A0BBFB1, "skipto_functions" },
    { 0x8494355B, "skipto_g20" },
    { 0xD3D715E5, "skipto_gaz_melee" },
    { 0x6B875048, "skipto_getaway" },
    { 0xCF4BA892, "skipto_give_player_weapon" },
    { 0xE8E7B882, "skipto_gulliver" },
    { 0xDD8939CD, "skipto_hai1_01" },
    { 0x1A0603D0, "skipto_hai1_01_render" },
    { 0xA6F16AAE, "skipto_hai1_01a" },
    { 0x23D48929, "skipto_hai1_01a_render" },
    { 0x80EEF045, "skipto_hai1_01b" },
    { 0xC742F5D8, "skipto_hai1_01b_render" },
    { 0x3D0478BE, "skipto_hai_01" },
    { 0x1374FE79, "skipto_hai_01_render" },
    { 0xF0FF83EC, "skipto_hai_03" },
    { 0x846AB29B, "skipto_hai_03_render" },
    { 0xCFE04122, "skipto_handle_xcam" },
    { 0xE3D8F697, "skipto_hangar" },
    { 0x7517F200, "skipto_harper_reveal" },
    { 0xD7B3A27D, "skipto_heli_jump" },
    { 0xF33A4F9E, "skipto_helipad_battle" },
    { 0xC7E2106D, "skipto_hijacked" },
    { 0x7E49EE5F, "skipto_hijacked_bridge" },
    { 0xACCD4DB2, "skipto_hijacked_menendez" },
    { 0x8FECFAA8, "skipto_horse_charge" },
    { 0xF149F402, "skipto_house" },
    { 0x9150E91E, "skipto_index" },
    { 0x2D3FCF36, "skipto_inner_ruins" },
    { 0xBF872E2C, "skipto_inner_solar" },
    { 0x85C81A81, "skipto_intersection" },
    { 0xC1C92A60, "skipto_intro" },
    { 0x57B4F7AF, "skipto_intro_defalco_alive" },
    { 0x025650DA, "skipto_intro_harper_dead" },
    { 0xF9493DBD, "skipto_intro_text_crawls" },
    { 0xBA60181A, "skipto_its_a_trap" },
    { 0xF25804F5, "skipto_jungle_ending" },
    { 0x686AF2C5, "skipto_jungle_escape" },
    { 0x0FF9FFC1, "skipto_jungle_stealth" },
    { 0xBDA03550, "skipto_jungle_stealth_house" },
    { 0xF829FE0A, "skipto_jungle_stealth_log" },
    { 0x546A7096, "skipto_kar_01" },
    { 0x2681EF21, "skipto_kar_01_render" },
    { 0x2E67F62D, "skipto_kar_02" },
    { 0x95FD94F0, "skipto_kar_02_render" },
    { 0x08657BC4, "skipto_kar_03" },
    { 0xCB2ADAA3, "skipto_kar_03_render" },
    { 0x03BCB496, "skipto_karma" },
    { 0xC2F751CD, "skipto_karma_2" },
    { 0x31017221, "skipto_krav_captured" },
    { 0xA50E9A30, "skipto_krav_interrogation" },
    { 0xB6D33D7F, "skipto_krav_tank" },
    { 0x8AC8D79F, "skipto_la_1" },
    { 0xA4E116FF, "skipto_la_1b" },
    { 0x18C16864, "skipto_la_2" },
    { 0xAD6E56E7, "skipto_lab" },
    { 0x8800A524, "skipto_lab_battle" },
    { 0x1E4BC4F6, "skipto_lab_defend" },
    { 0x73BCA594, "skipto_lab_entrance" },
    { 0x0E1105C3, "skipto_landing" },
    { 0xB219D9EF, "skipto_learjet" },
    { 0x084BF215, "skipto_ledge" },
    { 0xF97BD9D8, "skipto_list_menu" },
    { 0x68A7B842, "skipto_list_settext" },
    { 0x23DB4C0F, "skipto_loading_movie_1" },
    { 0xB1D3DCD4, "skipto_loading_movie_2" },
    { 0x61874E6A, "skipto_lobby" },
    { 0x577C3D7D, "skipto_los05" },
    { 0x72BBA483, "skipto_los_00_01" },
    { 0x99DAF3BA, "skipto_los_00_01_render" },
    { 0x00B43548, "skipto_los_00_02" },
    { 0xE32F3AF7, "skipto_los_00_02_render" },
    { 0xCB2670F6, "skipto_los_01" },
    { 0xA898664B, "skipto_los_01a" },
    { 0x95283132, "skipto_los_01a_render" },
    { 0x3690F710, "skipto_los_01b" },
    { 0x30B226CF, "skipto_los_01b_render" },
    { 0xA523F68D, "skipto_los_02" },
    { 0x99ED1C90, "skipto_los_02_render" },
    { 0x7F217C24, "skipto_los_03" },
    { 0xEB7C7E43, "skipto_los_03_render" },
    { 0x331C8752, "skipto_los_05" },
    { 0x66E16B7D, "skipto_los_05_render" },
    { 0xB2E1381A, "skipto_main_entrance" },
    { 0xD3AF7078, "skipto_mall" },
    { 0x4E706672, "skipto_market" },
    { 0x4C5B68B3, "skipto_market_dev_no_perk" },
    { 0x36C3839D, "skipto_market_dev_perk" },
    { 0x1A0547F1, "skipto_market_exit" },
    { 0xC6704259, "skipto_market_exit_deconstruct_ents" },
    { 0xBAF923C8, "skipto_market_exit_no_perk" },
    { 0xAD8CBD38, "skipto_market_exit_perk" },
    { 0x6C3D787C, "skipto_mason_bridge" },
    { 0x143B284C, "skipto_mason_bunker" },
    { 0xC365DA0A, "skipto_mason_catwalk" },
    { 0x0C42EE1F, "skipto_mason_cctv" },
    { 0x99F3D05C, "skipto_mason_deck" },
    { 0x3ADA6679, "skipto_mason_deck_final" },
    { 0x13524140, "skipto_mason_donkeykong" },
    { 0x1963DAB9, "skipto_mason_elevator" },
    { 0x513FAEA0, "skipto_mason_final_push" },
    { 0xA501786F, "skipto_mason_hallway" },
    { 0xAA2C93FE, "skipto_mason_hangar" },
    { 0xCB7F6462, "skipto_mason_hill" },
    { 0xD978F2C6, "skipto_mason_interrogation_room" },
    { 0xFD9BC697, "skipto_mason_intro" },
    { 0x2A309A8E, "skipto_mason_intro_briefing" },
    { 0xC953C619, "skipto_mason_lower_level" },
    { 0x0544CEC4, "skipto_mason_outro" },
    { 0xBE695D3C, "skipto_mason_salazar_caught" },
    { 0xC6829D00, "skipto_mason_salazar_exit" },
    { 0x6102E77D, "skipto_mason_security" },
    { 0xF7766B94, "skipto_mason_server_room" },
    { 0x58F19471, "skipto_mason_shattered" },
    { 0xBA68B929, "skipto_mason_start" },
    { 0xDE889213, "skipto_mason_to_mission" },
    { 0x216DE004, "skipto_mason_truck" },
    { 0x5E594E3E, "skipto_mason_vent" },
    { 0x90E3E8E4, "skipto_mason_wakeup" },
    { 0x305658A1, "skipto_mason_woods_freakout" },
    { 0x8FE8FD9F, "skipto_menendez_betrayal" },
    { 0xAEF78C91, "skipto_menendez_betrayal_alive_a" },
    { 0xD4FA06FA, "skipto_menendez_betrayal_alive_b" },
    { 0xFAFC8163, "skipto_menendez_betrayal_alive_c" },
    { 0x77A561C8, "skipto_menendez_betrayal_dead_a" },
    { 0xE9ACD103, "skipto_menendez_betrayal_dead_b" },
    { 0xC3AA569A, "skipto_menendez_betrayal_dead_c" },
    { 0x35B1C5D5, "skipto_menendez_betrayal_dead_d" },
    { 0xC29D2583, "skipto_menendez_combat" },
    { 0x07AB6828, "skipto_menendez_deck" },
    { 0x6439C808, "skipto_menendez_enter_mission" },
    { 0xF0FE59FF, "skipto_menendez_execution" },
    { 0x4F7AF5EB, "skipto_menendez_hallway" },
    { 0xBDCDC13A, "skipto_menendez_hangar" },
    { 0x70022A8E, "skipto_menendez_hill" },
    { 0xE30D5573, "skipto_menendez_intro" },
    { 0x76826642, "skipto_menendez_meat_shield" },
    { 0x1651E1BF, "skipto_menendez_plane" },
    { 0x7D04B351, "skipto_menendez_sees_noriega" },
    { 0xE013805D, "skipto_menendez_stables" },
    { 0xA06E021D, "skipto_menendez_start" },
    { 0x90C590BF, "skipto_menendez_to_mission" },
    { 0xCEFA5F5B, "skipto_menu" },
    { 0x0058D254, "skipto_metal_storms" },
    { 0x5E508707, "skipto_mon_01a" },
    { 0x289AC0FE, "skipto_mon_01a_render" },
    { 0xEC4917CC, "skipto_mon_01b" },
    { 0xB84AB5BB, "skipto_mon_01b_render" },
    { 0x1A3B4376, "skipto_morals" },
    { 0x6E8DF18D, "skipto_morals_rail" },
    { 0x0814FA12, "skipto_morals_rail_menendez" },
    { 0x65E893D5, "skipto_morals_rail_skip" },
    { 0x44091EF9, "skipto_motel" },
    { 0x57FCDEED, "skipto_mov_playback_temp" },
    { 0x0F07B07A, "skipto_move_briggs" },
    { 0x688F04FF, "skipto_name" },
    { 0x04DF95E5, "skipto_nic1_01" },
    { 0xB7027438, "skipto_nic1_01_render" },
    { 0xBCB8BD30, "skipto_nic2_01" },
    { 0x1A35D42F, "skipto_nic2_01_render" },
    { 0x5A281AC6, "skipto_nic_01" },
    { 0x24976791, "skipto_nic_01_render" },
    { 0x9836B8BB, "skipto_nic_01a" },
    { 0xA8DA2E22, "skipto_nic_01a_render" },
    { 0x262F4980, "skipto_nic_01b" },
    { 0xF48DB0BF, "skipto_nic_01b_render" },
    { 0x3425A05D, "skipto_nic_02" },
    { 0x50E570A0, "skipto_nic_02_render" },
    { 0xE820AB8B, "skipto_nic_04" },
    { 0x3784F072, "skipto_nic_04_render" },
    { 0xC21E3122, "skipto_nic_05" },
    { 0x04771E8D, "skipto_nic_05_render" },
    { 0x15DA3655, "skipto_nogame" },
    { 0x1A6F9324, "skipto_ntr_02a" },
    { 0xE4510B43, "skipto_ntr_02a_render" },
    { 0x8C77025F, "skipto_ntr_02b" },
    { 0xDE4DF2C6, "skipto_ntr_02b_render" },
    { 0x667487F6, "skipto_ntr_02c" },
    { 0xD1355041, "skipto_ntr_02c_render" },
    { 0xA86823E9, "skipto_ntr_02d" },
    { 0x6270E40C, "skipto_ntr_02d_render" },
    { 0x9F0FD550, "skipto_ny_streets" },
    { 0x09E2B2D7, "skipto_obama_render" },
    { 0xDA80F1DF, "skipto_obama_test" },
    { 0x27F59ED1, "skipto_obama_winning" },
    { 0xFFBF30C3, "skipto_outer_ruins" },
    { 0x93457595, "skipto_outro_vtol" },
    { 0x99DC3F92, "skipto_outro_vtol_play_anim" },
    { 0x096EE7C3, "skipto_pak1_01" },
    { 0xC4ACEBFA, "skipto_pak1_01_render" },
    { 0x1DC6CB7A, "skipto_pak2_01" },
    { 0x565E80D5, "skipto_pak2_01_render" },
    { 0xC55A4650, "skipto_pak_01" },
    { 0x30C4D00F, "skipto_pak_01_render" },
    { 0x2E3637CB, "skipto_pak_01c" },
    { 0xDDAE99B2, "skipto_pak_01c_render" },
    { 0x541D9C88, "skipto_pak_02a" },
    { 0xD3863137, "skipto_pak_02a_render" },
    { 0xC6250BC3, "skipto_pak_02b" },
    { 0x343237FA, "skipto_pak_02b_render" },
    { 0x37E53597, "skipto_pakistan" },
    { 0x1213B624, "skipto_pakistan_2" },
    { 0x3816308D, "skipto_pakistan_3" },
    { 0x1EDC8BDA, "skipto_pan1_01" },
    { 0x75A6B7F5, "skipto_pan1_01_render" },
    { 0x3800EDA3, "skipto_pan2_01" },
    { 0x469E139A, "skipto_pan2_01_render" },
    { 0xAAA25A54, "skipto_pan3_01" },
    { 0x3D2A60B3, "skipto_pan3_01_render" },
    { 0xCB3E5935, "skipto_pan4_01" },
    { 0x4C971FC8, "skipto_pan4_01_render" },
    { 0xA5275946, "skipto_pan5_01" },
    { 0x27CFAF11, "skipto_pan5_01_render" },
    { 0x2987E22F, "skipto_pan6_01" },
    { 0x8016DB16, "skipto_pan6_01_render" },
    { 0xD71503CA, "skipto_pan_00" },
    { 0x380B4880, "skipto_pan_01a" },
    { 0x31E4B5BF, "skipto_pan_01a_render" },
    { 0xAA12B7BB, "skipto_pan_01b" },
    { 0xE6313322, "skipto_pan_01b_render" },
    { 0x8B100EF8, "skipto_pan_02" },
    { 0xFCF6D027, "skipto_pan_02_render" },
    { 0xB2AEBC12, "skipto_panama" },
    { 0x38664AB1, "skipto_panama_2" },
    { 0x1263D048, "skipto_panama_3" },
    { 0xB35FDC54, "skipto_play_loading_test" },
    { 0x6A73DDD0, "skipto_plaza" },
    { 0x31AEFEA8, "skipto_point" },
    { 0x7E57F50D, "skipto_previs" },
    { 0x1A646912, "skipto_pro_00" },
    { 0x4066E37B, "skipto_pro_01" },
    { 0x58BBDAE2, "skipto_pro_01_render" },
    { 0xCE5F7440, "skipto_pro_02" },
    { 0xE11AA17F, "skipto_pro_02_render" },
    { 0xABF9A872, "skipto_pro_02b" },
    { 0x1A9301DD, "skipto_pro_02b_render" },
    { 0xF461EEA9, "skipto_pro_03" },
    { 0x96F4D2CC, "skipto_pro_03_render" },
    { 0x75F146AA, "skipto_ramp_top" },
    { 0x8C0F2793, "skipto_randomize_stats" },
    { 0x9909E952, "skipto_rappel" },
    { 0x7B3054BF, "skipto_render_ny_streets" },
    { 0x9BE5B719, "skipto_render_shot_01" },
    { 0x1DF6AD69, "skipto_render_shot_1" },
    { 0x43F927D2, "skipto_render_shot_2" },
    { 0x115C73E8, "skipto_river" },
    { 0x21D54B3D, "skipto_riverbed" },
    { 0x9CEAC2B6, "skipto_riverbed_intro" },
    { 0x01F27E62, "skipto_rock_swing" },
    { 0xF641FAA2, "skipto_roof_meeting" },
    { 0xB8DD7ADE, "skipto_ruins_interior" },
    { 0xD9DEE512, "skipto_runway" },
    { 0x1C897A7F, "skipto_sam" },
    { 0x9A494602, "skipto_sam_jump" },
    { 0x6D045B64, "skipto_savannah_finish" },
    { 0xD1687020, "skipto_savannah_hill" },
    { 0x63D8BD43, "skipto_savannah_start" },
    { 0xA1A20C49, "skipto_setup" },
    { 0xBF0A2EAA, "skipto_setup_blocker" },
    { 0xE38AE849, "skipto_sewer_exterior" },
    { 0x9E94257C, "skipto_sewer_exterior_bodies" },
    { 0xC3419277, "skipto_sewer_interior" },
    { 0xEC3DC0B6, "skipto_sewer_interior_no_perk" },
    { 0x80CDE53E, "skipto_sewer_interior_perk" },
    { 0xD946CF37, "skipto_skyline" },
    { 0xB554D8B6, "skipto_skyline_a_render" },
    { 0xFFFCF292, "skipto_skyline_a_test" },
    { 0x6EC707B3, "skipto_skyline_b_render" },
    { 0x6B4B9203, "skipto_skyline_b_test" },
    { 0x41EC8B39, "skipto_slums_halfway" },
    { 0x8AFDF6D3, "skipto_slums_intro" },
    { 0xDA06B6E8, "skipto_slums_main" },
    { 0x78B265B7, "skipto_sniper" },
    { 0xD5AB349A, "skipto_sniper_exit" },
    { 0xBD0FBEA2, "skipto_sniper_rappel" },
    { 0xC86C2122, "skipto_snow_ambush" },
    { 0x18451682, "skipto_solar_fight" },
    { 0x27DD20C4, "skipto_speech" },
    { 0x2174E19C, "skipto_spiderbot" },
    { 0x9DBA424D, "skipto_spots" },
    { 0x56A66580, "skipto_sr71_test" },
    { 0x09D26D65, "skipto_standoff" },
    { 0x5BCD68F2, "skipto_start" },
    { 0x3AE82ABB, "skipto_stealth_deconstruct_ents" },
    { 0x3184DE5F, "skipto_street" },
    { 0x9F17F9B5, "skipto_string" },
    { 0x8CDEFDCF, "skipto_suit_fly" },
    { 0x85CF8F20, "skipto_suit_jump" },
    { 0xB4488EAB, "skipto_sundeck" },
    { 0x22B16599, "skipto_surveillance" },
    { 0x437ED3DC, "skipto_t4_jbu_02_b" },
    { 0x450CEAA6, "skipto_t4_jbu_04_b" },
    { 0xF531334B, "skipto_t5_jbu_02_b" },
    { 0x433BF319, "skipto_t7_jbu_02_b" },
    { 0xCB64F576, "skipto_t7_jbu_02_b_2" },
    { 0x2DCB3180, "skipto_t7_jbu_02_b_cu" },
    { 0x107B6BAC, "skipto_t7_jbu_02_b_cu_alt" },
    { 0xD90E7F4B, "skipto_teleport" },
    { 0x07D68030, "skipto_teleport_ai" },
    { 0xF08888A8, "skipto_teleport_players" },
    { 0x597AAAAB, "skipto_teleport_single_ai" },
    { 0xE2335EE9, "skipto_tensionmap_test" },
    { 0x35471F38, "skipto_terrorist_hunt" },
    { 0x8F308723, "skipto_test_rendering" },
    { 0x1EA010D3, "skipto_test_scene" },
    { 0x4013E965, "skipto_theater" },
    { 0xC1A49ABA, "skipto_thermal_test" },
    { 0x67C13FF2, "skipto_transmission" },
    { 0x457EEC95, "skipto_trigs_off" },
    { 0x274D9871, "skipto_underground" },
    { 0x79777B41, "skipto_underground_xcam" },
    { 0x9625729E, "skipto_village" },
    { 0x6FB331A4, "skipto_vtol_landing_render" },
    { 0x27ACFF88, "skipto_vtol_landing_test" },
    { 0x1858EADF, "skipto_warehouse" },
    { 0x7E87B86E, "skipto_wave1" },
    { 0x58853E05, "skipto_wave2" },
    { 0x3282C39C, "skipto_wave3" },
    { 0xC531DD62, "skipto_yem_02" },
    { 0xFBB65ACD, "skipto_yem_02_render" },
    { 0xA775D2C8, "skipto_yem_03a" },
    { 0x431EA777, "skipto_yem_03a_render" },
    { 0x197D4203, "skipto_yem_03b" },
    { 0xF9CA603A, "skipto_yem_03b_render" },
    { 0x32617AE5, "skipto_yem_04a" },
    { 0x0CA9FB38, "skipto_yem_04a_render" },
    { 0x5863F54E, "skipto_yem_04b" },
    { 0x66C12589, "skipto_yem_04b_render" },
    { 0xE7A58218, "skipto_yem_04bb" },
    { 0x70EE3387, "skipto_yem_04bb_render" },
    { 0x4F4EDA6A, "skipto_zodiac" },
    { 0x31FAC33E, "skiptos" },
    { 0x3BB2DD28, "skipvote" },
    { 0x59BA455F, "skipwait" },
    { 0xFAAF5768, "skipweapon" },
    { 0x4FAC3FCD, "skirmishes" },
    { 0x7ABC08C1, "skirts" },
    { 0x684F47B8, "skit" },
    { 0x5560F6D2, "skit_start_reminder" },
    { 0xC502E691, "skit_vox_override" },
    { 0x0C07A5D8, "skitp" },
    { 0x7E0F1513, "skits" },
    { 0x38CBFB00, "skull" },
    { 0x5C66A273, "skus" },
    { 0xF75448F4, "sky" },
    { 0x5B8B2B11, "sky_0" },
    { 0x3588B0A8, "sky_1" },
    { 0xA7901FE3, "sky_2" },
    { 0x818DA57A, "sky_3" },
    { 0xF39514B5, "sky_4" },
    { 0xCD929A4C, "sky_5" },
    { 0x3F9A0987, "sky_6" },
    { 0x19978F1E, "sky_7" },
    { 0xFBF4CCA7, "sky_cowbell" },
    { 0xF17D018D, "sky_cowbell_drone_spawn_func" },
    { 0x5B3443E9, "sky_cowbell_drone_tracker" },
    { 0xAFC95630, "sky_cowbell_firing_func" },
    { 0x19ABEFBD, "sky_cowbell_get_ratio_total" },
    { 0x23465D4D, "sky_cowbell_set_max_drones" },
    { 0xC7013B22, "sky_cowbell_set_ratio" },
    { 0x99BACF4A, "sky_cowbell_stop" },
    { 0x39BE9E81, "sky_fire_light_ambience" },
    { 0xA2EBB7D8, "sky_metal" },
    { 0xB5D116A3, "sky_metal_cohesion" },
    { 0x089E0B90, "sky_metal_insanity" },
    { 0x2D1A8A9F, "sky_metal_separation" },
    { 0x03B1C220, "sky_metal_velocity_match" },
    { 0x607FB6B3, "sky_pillar_reset" },
    { 0x9A587BA1, "sky_rotation" },
    { 0x42ACB17A, "sky_transition" },
    { 0xA4D74581, "sky_transition_fog_settings" },
    { 0x1733F5C1, "sky_transition_max" },
    { 0x5B283B34, "sky_transition_off_time" },
    { 0x111CE78E, "sky_transition_on_time" },
    { 0x4DC959CF, "skybox" },
    { 0x2AA0B554, "skybox_trans_time" },
    { 0x3A9B5BA4, "skybrush" },
    { 0xFB902C57, "skybuster" },
    { 0x48AD7E9C, "skybuster_kill_3x" },
    { 0xA16F3B0E, "skybusters" },
    { 0x30524725, "skydemon" },
    { 0x7A728AB2, "skydemon_at_firing_spot" },
    { 0x98BF407B, "skydemon_kill_tank" },
    { 0x5A3E5137, "skydemon_land" },
    { 0x4A9471BE, "skydemon_repel" },
    { 0x34A0CE98, "skydemon_takeoff" },
    { 0x2091C8EC, "skydemon_trail" },
    { 0x7D44C90A, "skydive" },
    { 0x55887176, "skydive_landing" },
    { 0x32A9825B, "skydive_pre_gameplay" },
    { 0x5E4FC350, "skydive_section_01" },
    { 0xD057328B, "skydive_section_02" },
    { 0x3E1572CD, "skyheight" },
    { 0xBC8C4C60, "skylight" },
    { 0x4DFEFC14, "skylight_leader" },
    { 0x1B4D2D07, "skylight_nag" },
    { 0xE54C281A, "skyline" },
    { 0xC8BF2089, "skyline_cowbell" },
    { 0xCB820773, "skyline_crash_start" },
    { 0xC3D9BF02, "skyline_crash_take_control" },
    { 0x28A66E96, "skyline_dc_activate" },
    { 0x8ECE86E3, "skyline_dc_activate_noexplode" },
    { 0x5C098948, "skyline_dc_setup" },
    { 0x5E591C63, "skyline_dc_think" },
    { 0xD38B7A8E, "skyline_ny_activate" },
    { 0xDC42919B, "skyline_ny_activate_noexplode" },
    { 0xB19EDF00, "skyline_ny_setup" },
    { 0x736BADBB, "skyline_ny_think" },
    { 0x3D960EDB, "skyline_render_a_main" },
    { 0x0F97C536, "skyline_render_b_main" },
    { 0xE4B50B8A, "skyline_shanghai_activate" },
    { 0xA1E3BF27, "skyline_shanghai_activate_noexplode" },
    { 0xA316B5BC, "skyline_shanghai_setup" },
    { 0x91E531A9, "skyline_shot" },
    { 0xECCA7953, "skyline_start" },
    { 0xC617A5EB, "skyline_test_a_main" },
    { 0x7B22C5C6, "skyline_test_b_main" },
    { 0xA69DF832, "skypos" },
    { 0x092FE78C, "skyrocket" },
    { 0x1FDDEDE7, "skys" },
    { 0x0E10EE5C, "skyscraper02" },
    { 0x883E8502, "skytrig" },
    { 0xEB076578, "sl" },
    { 0x147D1558, "sl0" },
    { 0x3A7F8FC1, "sl1" },
    { 0x37F6F363, "sl10" },
    { 0x60820A2A, "sl2" },
    { 0x86848493, "sl3" },
    { 0xAC86FEFC, "sl4" },
    { 0xD2897965, "sl5" },
    { 0xF88BF3CE, "sl6" },
    { 0x1E8E6E37, "sl7" },
    { 0x0A6BBC79, "sl9" },
    { 0x933ECD9E, "sl_elem" },
    { 0x52D72D19, "slackers" },
    { 0xD67ABEB9, "slalzars" },
    { 0xA4169F76, "slam" },
    { 0x347CA107, "slam_chamber_doors" },
    { 0x1A8363D3, "slam_fx" },
    { 0x390D253D, "slam_player_after_restart" },
    { 0xD295EE03, "slam_zoom_intro" },
    { 0x89C68CD5, "slam_zoom_intro_old" },
    { 0x0C88085C, "slam_zoom_sound" },
    { 0xFD8FDF7C, "slammed" },
    { 0x688D5FE9, "slamming" },
    { 0x463692F3, "slamraam" },
    { 0xFE84FE69, "slams" },
    { 0x396ED8DB, "slamzoom" },
    { 0x80AC821A, "slamzoom_rotate_utility" },
    { 0x3968534F, "slamzoomn" },
    { 0x244BC3D4, "slank" },
    { 0xCFD963EF, "slanted_building_approach_trigger" },
    { 0x29B36A54, "slanted_building_drone_1" },
    { 0x9BBAD98F, "slanted_building_drone_2" },
    { 0xD7D3FBC4, "slanted_building_soct_trigger" },
    { 0x51A1CBCD, "slanted_building_started" },
    { 0xC24AAA13, "slap" },
    { 0xC055104F, "slappedwithmolotovdamage" },
    { 0x417281A0, "slash" },
    { 0x3E7D4C0C, "slashes" },
    { 0x6BC8D7E8, "slate" },
    { 0xD6BD209F, "slathered" },
    { 0x2BE55858, "slaughter" },
    { 0xB778D6C4, "slaughter_ready_wait" },
    { 0x132D0C6B, "slaughtered" },
    { 0x46068740, "slaughtering" },
    { 0x6E9A0B92, "slave" },
    { 0x564FEC5F, "slayback" },
    { 0xF3006D15, "sle" },
    { 0xC8D07B5D, "sledgehammer" },
    { 0xFF07C9EA, "sleds" },
    { 0x5A6DE956, "sleep" },
    { 0xC35DE4E0, "sleep_alert_trigger" },
    { 0x0B866DFF, "sleeper" },
    { 0x68DB6206, "sleepers" },
    { 0xCCE1D74A, "sleeping" },
    { 0xCD833F40, "sleeping_guys_wake" },
    { 0x6BCA18C9, "sleeps" },
    { 0x65D9B17A, "sleepy_shack" },
    { 0x4C6F9551, "sleight" },
    { 0x1E280DDD, "sleight_of_hand_client_field_func" },
    { 0x945CDFB8, "sleight_of_hand_code_callback_func" },
    { 0x00B44CEA, "sleight_of_hand_machine_active_model" },
    { 0xACBF976C, "sleight_of_hand_machine_disabled_model" },
    { 0x1B06479F, "sleight_of_hand_machine_light_fx" },
    { 0x90DA9F76, "sleight_of_hand_perk_bottle_weapon" },
    { 0x001A3938, "sleight_of_hand_perk_cost" },
    { 0x2E78087C, "sleight_of_hand_perk_machine_setup" },
    { 0x1F07387F, "sleight_of_hand_precache" },
    { 0x46BC5AAB, "sleight_of_hand_precache_override_func" },
    { 0x625E6BDB, "sleight_of_hand_radiant_machine_name" },
    { 0x1FFF78DD, "sleight_of_hand_register_clientfield" },
    { 0x86E1CB2A, "sleight_of_hand_set_clientfield" },
    { 0x96241807, "sleight_of_hand_shader" },
    { 0x26AB55B3, "sleight_off" },
    { 0x2680D19F, "sleight_on" },
    { 0x378F2179, "sleight_sumpf_on" },
    { 0x4EA61A99, "sleightperk" },
    { 0x7AAF92FD, "slice" },
    { 0x83B31DAD, "slice_count" },
    { 0x5D600980, "slice_done" },
    { 0x5732682A, "slice_times" },
    { 0xCDD3E8BC, "slices" },
    { 0x19ABF6A8, "slicing" },
    { 0x71F806A3, "slick_count" },
    { 0x36EA82CB, "slicked_players" },
    { 0xAC6AC72C, "slicked_zombies" },
    { 0xDF460622, "slicks" },
    { 0xB6E5B1F0, "slide" },
    { 0xB6FA20C6, "slide_1_dof" },
    { 0x6C682AB5, "slide_2_dof" },
    { 0x1994E3FB, "slide_4_dof" },
    { 0x3CCD1301, "slide_6_dof" },
    { 0xE3E7E84C, "slide_across_car_2_cover" },
    { 0x47AAAB1C, "slide_across_car_dog" },
    { 0x44BFBF35, "slide_across_car_human" },
    { 0x0699ABC1, "slide_anim_trig" },
    { 0x3BBA6064, "slide_crows_start" },
    { 0xBC78DE76, "slide_direction" },
    { 0xCB5453E7, "slide_dirt_duration" },
    { 0x61241FAF, "slide_dirt_fade_time" },
    { 0x8B7F946B, "slide_done" },
    { 0x67FBB813, "slide_door" },
    { 0x4DAB0E66, "slide_door_open" },
    { 0xFE7394DC, "slide_in_and_out_dialog" },
    { 0x9176C819, "slide_index" },
    { 0xC93916EC, "slide_jumpto" },
    { 0x132C487F, "slide_node" },
    { 0xAC3AC81A, "slide_node_start" },
    { 0x796D7500, "slide_one_flash_in_effect" },
    { 0x6397982D, "slide_one_flash_out_effect" },
    { 0x727708EE, "slide_one_pre_cut_effect" },
    { 0x7211477E, "slide_push_in_trigger" },
    { 0x06A0A786, "slide_push_think" },
    { 0x95CE3813, "slide_start_time" },
    { 0xAEAFAAE0, "slide_timeout" },
    { 0xAA96DECE, "slide_vo" },
    { 0xA78E8565, "slidedir" },
    { 0x3431A1E0, "slidedist" },
    { 0x9E06E2BC, "slideendtime" },
    { 0xC4B89D8A, "slidefortime" },
    { 0xC0D2A8BE, "slideframes" },
    { 0xABEB8C44, "slidehandler" },
    { 0xB7842DD7, "slideincrement" },
    { 0x07251DF2, "slider" },
    { 0x2CD68F71, "slider_pos" },
    { 0xAC81377D, "sliders" },
    { 0x2D27985B, "slides" },
    { 0xFDE947CB, "slideshow" },
    { 0xC6783E2A, "slideshows" },
    { 0x3476DB77, "slidestarttime" },
    { 0xA2B37ECB, "slidetime" },
    { 0xECF0B6D9, "slidevelocity" },
    { 0x9976D671, "sliding" },
    { 0x22341E3D, "sliding_bookcase_activate" },
    { 0x6CA3CC6C, "sliding_bookcase_init" },
    { 0xED7B840A, "sliding_bookcase_occupied" },
    { 0x2CF90036, "sliding_bookcase_think" },
    { 0xB1DB29E1, "sliding_bookcase_wobble" },
    { 0x267F574C, "sliding_door" },
    { 0x6328C21D, "sliding_door_close" },
    { 0x5097B0AD, "sliding_door_close_sound" },
    { 0x147D936D, "sliding_door_init" },
    { 0xD45EDE57, "sliding_door_open" },
    { 0xD803A344, "sliding_door_reset" },
    { 0x81CA8F32, "sliding_door_stop_close" },
    { 0x97AB443D, "sliding_door_think" },
    { 0x31C98E3B, "sliding_on_goo" },
    { 0x0283C2E8, "slight" },
    { 0x8B78910D, "slightly" },
    { 0x28570BAC, "slightly_delayed_player_response" },
    { 0xCF6DB714, "slimmed" },
    { 0xBB8F7F15, "slimptime" },
    { 0x2DB770B0, "slimptime_accel" },
    { 0x40BA1018, "slimptime_deccel" },
    { 0x1EAE78FA, "slinetoexecute" },
    { 0xE448F0E0, "sling" },
    { 0xA3D035BD, "sling_guards" },
    { 0x8D81185C, "sling_target_destroyed" },
    { 0xCD1B1100, "sling_trigs" },
    { 0x3E556433, "sling_vo_locations" },
    { 0x3A3EC100, "slingshot" },
    { 0x672F44D1, "slingshot_3d_objectives" },
    { 0x61655E5F, "slingshot_additional_tutorial_hint_press" },
    { 0x0C463F32, "slingshot_ai_play_anim" },
    { 0x5A160B0D, "slingshot_ai_vo" },
    { 0x7939A864, "slingshot_ai_vo_node" },
    { 0xFE749517, "slingshot_ambient_prisoners" },
    { 0xF4379705, "slingshot_ammo" },
    { 0xCFE31BA7, "slingshot_anim_node" },
    { 0xFE2C0313, "slingshot_blend_ammo_aim" },
    { 0xF762E084, "slingshot_blend_ammo_fire" },
    { 0xCD0266A2, "slingshot_blend_player_aim" },
    { 0x1CDF147B, "slingshot_blend_player_fire" },
    { 0x7D3FEEC8, "slingshot_blend_slingshot_aim" },
    { 0x66635CB5, "slingshot_blend_slingshot_fire" },
    { 0x71750FCA, "slingshot_center_ent" },
    { 0x3B79C411, "slingshot_cleanup" },
    { 0xE0B21B0A, "slingshot_drones" },
    { 0xAC0B126F, "slingshot_early_fire" },
    { 0xD62DC809, "slingshot_fire_weights" },
    { 0xBF750D31, "slingshot_fx" },
    { 0xD3D364BE, "slingshot_guards_flash" },
    { 0x4632B2D0, "slingshot_guards_kill" },
    { 0xF71E4BC8, "slingshot_guards_think" },
    { 0xC4F047F3, "slingshot_hands" },
    { 0xE79655B1, "slingshot_hands_animator" },
    { 0xFAE6C624, "slingshot_hands_animator_think" },
    { 0x6AECC9E5, "slingshot_holding_stick" },
    { 0xABC8926A, "slingshot_hud" },
    { 0x96B4D229, "slingshot_input" },
    { 0x6FADAE22, "slingshot_int" },
    { 0x406196D4, "slingshot_int_door_open" },
    { 0x8F7DD4C8, "slingshot_int_linger" },
    { 0xBAE56B16, "slingshot_int_linger_vo" },
    { 0xCC79BBAE, "slingshot_int_sergei" },
    { 0x3EC690D5, "slingshot_int_sergei_door" },
    { 0x273411A0, "slingshot_int_skip" },
    { 0x59CF468B, "slingshot_loading_sling" },
    { 0x52AF34FB, "slingshot_nagger" },
    { 0x76333A72, "slingshot_obj_update" },
    { 0x2C37DD23, "slingshot_play_anim" },
    { 0xC879955A, "slingshot_play_ending_idle_anim" },
    { 0xF3CEBFB8, "slingshot_play_fire_blend_anim" },
    { 0x1968F97F, "slingshot_play_fire_straight_anim" },
    { 0x2EB3BB76, "slingshot_play_idle_anim" },
    { 0xC1E0F9D5, "slingshot_play_intro_death" },
    { 0x3B862F7B, "slingshot_play_pull_anim" },
    { 0xC8225519, "slingshot_play_pull_idle_straight_anim" },
    { 0x6A8C3265, "slingshot_play_wave_anim" },
    { 0x59695D8A, "slingshot_player_clear_anim" },
    { 0x7DB29B6B, "slingshot_player_play_anim" },
    { 0xB321904A, "slingshot_player_pull" },
    { 0x8AF7D0F4, "slingshot_precache" },
    { 0x41D4D954, "slingshot_ready" },
    { 0xDCD05382, "slingshot_ready_vo" },
    { 0xE8DC31D5, "slingshot_roof" },
    { 0xFFBF9E78, "slingshot_roof_done" },
    { 0x77627247, "slingshot_shotgun" },
    { 0x3725436E, "slingshot_shotgun_refill" },
    { 0xB32AD0D7, "slingshot_shotgun_vo" },
    { 0x9D509B22, "slingshot_shots_taken" },
    { 0x26DABFDA, "slingshot_shrimp_manager" },
    { 0xC6023172, "slingshot_speech_temp" },
    { 0x50A13FF8, "slingshot_target_killed" },
    { 0x72547527, "slingshot_trigger_hint_press" },
    { 0x416710B9, "slingshot_trigger_press" },
    { 0xE4564224, "slingshot_trigger_think" },
    { 0x97EB94AD, "slingshot_vel_min" },
    { 0x89A2076E, "slingshot_velocity" },
    { 0x2E7F888B, "slingshot_view_angles" },
    { 0xA9C7FEA2, "slingshot_weights" },
    { 0x4663C82F, "slingshot_weights_init" },
    { 0xD6B6DE4C, "slingshottest" },
    { 0x8B645CDB, "slip" },
    { 0xE98AF20B, "slip_and_slide" },
    { 0xE4150DDF, "slip_bolt" },
    { 0x0DDF9929, "slip_on_ice" },
    { 0xCDC469CB, "slipgun" },
    { 0xCB7B4F12, "slipgun_activation_watcher_thread" },
    { 0x63B59A27, "slipgun_as_equipment" },
    { 0x16C85643, "slipgun_bought" },
    { 0x52E7A911, "slipgun_canister" },
    { 0xD3AC1F6B, "slipgun_cooker" },
    { 0xB219AADD, "slipgun_damage" },
    { 0xC8B470DC, "slipgun_damage_mod" },
    { 0x340EFD62, "slipgun_debug_circle" },
    { 0xD1004F8C, "slipgun_debug_line" },
    { 0x778A0F06, "slipgun_foot" },
    { 0xAE8A97A1, "slipgun_play_zombie_hit_vox" },
    { 0x40BA4F86, "slipgun_player_connect" },
    { 0x7C101C27, "slipgun_sizzle" },
    { 0x6F62C2D2, "slipgun_throttle" },
    { 0x02559FE5, "slipgun_zm_taken" },
    { 0xCA7C5E2F, "slipgun_zombie_1st_hit_response" },
    { 0x37EB603A, "slipgun_zombie_damage_response" },
    { 0xF8E401B3, "slipgun_zombie_death_response" },
    { 0xEF91C0BC, "slipgun_zombie_hit_response_internal" },
    { 0x48E38A69, "slipgunbuildable" },
    { 0xBEE3BD3E, "slipped" },
    { 0x4565B233, "slippers" },
    { 0xC94CEA19, "slippery" },
    { 0xB2123629, "slippery_spot_choke" },
    { 0x5BDB64C0, "slippery_spot_count" },
    { 0xE9BCA587, "slippery_spots" },
    { 0x7609AB77, "slipping" },
    { 0x50C6E7FA, "slips" },
    { 0xD2EC3D34, "sliquifier_distance_checks" },
    { 0x400BEE7D, "sliquifier_kill" },
    { 0x18B38D5D, "slng" },
    { 0x0EF18E9F, "slo" },
    { 0xF84C8128, "slo_mo_slide" },
    { 0x6F3693EF, "slomo" },
    { 0xADAAB3D5, "slomo_context_wait" },
    { 0x9429ECD9, "slomo_end_orgs" },
    { 0x2E794221, "slomo_off" },
    { 0x502B1395, "slomo_on" },
    { 0xE8A2640C, "slomo_start_orgs" },
    { 0xC531CBF4, "slone" },
    { 0xAFC98596, "slooooow" },
    { 0x08E3C51A, "slope" },
    { 0x40D4AB6A, "sloped" },
    { 0x52B47415, "slopes" },
    { 0x8B3E08D4, "sloppy" },
    { 0x2D11F419, "slot" },
    { 0xA2697BEF, "slot_cb" },
    { 0x9A9150D0, "slot_index" },
    { 0x4E8A0437, "slot_instructions" },
    { 0x4D9095F4, "slot_watcher" },
    { 0xFCA663C3, "sloth" },
    { 0x87DB20F0, "sloth_accumulate_damage" },
    { 0xB4FCC334, "sloth_behind_mansion" },
    { 0xCFE3C5B8, "sloth_box_move_show_vulture_fx" },
    { 0xFF5A982E, "sloth_breaks_barrier" },
    { 0x27C472B2, "sloth_buildable" },
    { 0x74DF92D2, "sloth_buildable_zones" },
    { 0xC6166D3D, "sloth_buildables" },
    { 0xEBE79851, "sloth_check_ragdolls" },
    { 0x31190B74, "sloth_check_turn" },
    { 0x3DA428E0, "sloth_clears_path_vo" },
    { 0x855C3C74, "sloth_crawler_pickup_vulture_fx_correction_func" },
    { 0x76E26738, "sloth_crawler_vo" },
    { 0x3E21932A, "sloth_damage_func" },
    { 0xBD8990A1, "sloth_debug_axis" },
    { 0x214E5BD3, "sloth_debug_barricade" },
    { 0x47B26D89, "sloth_debug_buildables" },
    { 0x4943BFE3, "sloth_debug_context" },
    { 0x25ECA971, "sloth_debug_doors" },
    { 0x3FF9E68E, "sloth_debug_input" },
    { 0xCC5AFFFC, "sloth_devgui_barricade" },
    { 0xF1BB3432, "sloth_devgui_booze" },
    { 0x9196C3B6, "sloth_devgui_candy" },
    { 0x1D8DFBC8, "sloth_devgui_context" },
    { 0x6E7E1FC2, "sloth_devgui_double_wide" },
    { 0x3363FEFC, "sloth_devgui_make_crawler" },
    { 0xC953AF49, "sloth_devgui_move_lamp" },
    { 0xE7E15ADE, "sloth_devgui_teleport" },
    { 0x548E5AF4, "sloth_devgui_update_phys_params" },
    { 0xB395941E, "sloth_devgui_warp_to_jail" },
    { 0x4939E399, "sloth_dist_sq" },
    { 0xF2C1630F, "sloth_do_turn_anim" },
    { 0x42639F3D, "sloth_doors" },
    { 0xBA1EBE9D, "sloth_drop" },
    { 0xDB411F5B, "sloth_enable" },
    { 0x7BE4D4D5, "sloth_end" },
    { 0xE0EFD039, "sloth_face_object" },
    { 0xCD2F503C, "sloth_feed_vo" },
    { 0xEFA11E8A, "sloth_ffotd_init" },
    { 0xE5E085E8, "sloth_ffotd_prespawn" },
    { 0x0A4D13FC, "sloth_first_encounter_vo" },
    { 0x625575BF, "sloth_fountain_think" },
    { 0xF16BC014, "sloth_get_unitrigger_origin" },
    { 0x1C0A4D79, "sloth_gift_prompt" },
    { 0xAB90B05F, "sloth_goal" },
    { 0xE4FADCF1, "sloth_grab_powerup" },
    { 0xD4E6CB63, "sloth_has_been_given_booze" },
    { 0xA335D92A, "sloth_hunched_structs" },
    { 0xFE01FCF4, "sloth_idle" },
    { 0x5F8D71DE, "sloth_in_armory_near_bench" },
    { 0x9FF59B23, "sloth_init_roam_point" },
    { 0x97761355, "sloth_init_start_funcs" },
    { 0xB793F970, "sloth_init_update_funcs" },
    { 0x2B865405, "sloth_is_pain" },
    { 0xA805D948, "sloth_is_same_zone" },
    { 0x4C8D2CA6, "sloth_is_traversing" },
    { 0xBDF350DA, "sloth_kill" },
    { 0xD2E364B3, "sloth_kill_zombie" },
    { 0xD14A54ED, "sloth_leg_pain" },
    { 0x37ADBD5D, "sloth_melee_notetracks" },
    { 0x1FAB0F7E, "sloth_move_to_same_side" },
    { 0xC23D93AE, "sloth_moving_box" },
    { 0x1D4698F7, "sloth_non_attacker" },
    { 0x06BD2567, "sloth_offset" },
    { 0x7546CBD4, "sloth_on_same_side" },
    { 0x8AD97322, "sloth_pain_react" },
    { 0x0D5EA2AE, "sloth_paralyzed" },
    { 0xC1B8A52A, "sloth_pickup" },
    { 0x7EAEE40D, "sloth_post_traverse" },
    { 0xD697F126, "sloth_pre_traverse" },
    { 0x6C006512, "sloth_prespawn" },
    { 0xE9E9D437, "sloth_print" },
    { 0xD031C78B, "sloth_protect" },
    { 0x5DF8A481, "sloth_putdown" },
    { 0x272E4611, "sloth_ragdoll_wait" },
    { 0x9667AC64, "sloth_ragdoll_zombie" },
    { 0x2E01359D, "sloth_reset_anim" },
    { 0x48D381CB, "sloth_retreat_vo" },
    { 0xED298223, "sloth_set_anim_rate" },
    { 0xF931D320, "sloth_set_state" },
    { 0xB82E92BB, "sloth_set_traverse_funcs" },
    { 0x802FBD91, "sloth_sling" },
    { 0x490DF2C1, "sloth_spawners" },
    { 0xCBF37532, "sloth_spawning_logic" },
    { 0x31A9A976, "sloth_start" },
    { 0x1EAFDBD9, "sloth_teleport_to_maze" },
    { 0xEFA11642, "sloth_think" },
    { 0x1CDC347E, "sloth_time_bomb_setup" },
    { 0x557C0AC1, "sloth_triggers" },
    { 0xC21BD9B7, "sloth_trigs" },
    { 0xCF9E828E, "sloth_unsling" },
    { 0x6194015F, "sloth_update_double_wide" },
    { 0xF5FB383C, "sloth_wallbuy_stubs" },
    { 0xEEA2C8FC, "slothanimstatefromspeed" },
    { 0x0D24B401, "slothbuildable" },
    { 0x987227B8, "slotname" },
    { 0xBAB2C7D0, "slots" },
    { 0xD1C74281, "slotsavailable" },
    { 0x53146E82, "slow" },
    { 0x860C9063, "slow_all_actors" },
    { 0xA25E286D, "slow_amount" },
    { 0x3D95D5B2, "slow_change_per_unit" },
    { 0xE3BBAE76, "slow_door_org" },
    { 0xD3C22E65, "slow_down" },
    { 0x35B5E3F6, "slow_down_nt" },
    { 0xBA4490D1, "slow_down_player_horse" },
    { 0x42185E34, "slow_down_player_with_meat" },
    { 0x414ADDF7, "slow_down_stp" },
    { 0xBFF0D4E8, "slow_end" },
    { 0x75935292, "slow_engine_trigger" },
    { 0x7521AE71, "slow_flash_color" },
    { 0x2A28315F, "slow_flash_time" },
    { 0x5735698D, "slow_mid" },
    { 0x3044C19C, "slow_mo_start" },
    { 0xAB85E310, "slow_mo_stop" },
    { 0xDCA31F73, "slow_mo_the_tip" },
    { 0x5A36874A, "slow_mo_truck_explo" },
    { 0x5B29796D, "slow_motion_off" },
    { 0x93DCB201, "slow_motion_on" },
    { 0x9CE6CEB1, "slow_raps" },
    { 0x965A4280, "slow_raps_trigger" },
    { 0xB6ABE7C3, "slow_rate" },
    { 0xADF13E00, "slow_shatter" },
    { 0x452549E2, "slow_speed" },
    { 0x1228645D, "slow_speed_change" },
    { 0xE86F958B, "slow_start" },
    { 0xA22BB3AF, "slow_trigger" },
    { 0x7EB8C8F6, "slow_triggers" },
    { 0x7E6D2736, "slow_vortex_fx" },
    { 0x4266CB1A, "slowdown" },
    { 0x447D3917, "slowdown_ai" },
    { 0x97FCBF6D, "slowdown_done" },
    { 0x089C945E, "slowdown_wait" },
    { 0x27B2E23F, "slowdown_wait_door_breach" },
    { 0xFA93F655, "slowdowndegrees" },
    { 0xDBF6E615, "slowdowns" },
    { 0x63D5AEB5, "slowdowntime" },
    { 0x718ACD95, "slowed" },
    { 0x85AD7F53, "slower" },
    { 0x0CA5C66A, "slowest" },
    { 0x6BC996F3, "slowest_allowed_speed" },
    { 0x07C08C14, "slowestrepeatwait" },
    { 0xA60A91B5, "slowgun_allow_player_paralyze" },
    { 0xCBF43E31, "slowgun_anim_rate" },
    { 0x31CCE284, "slowgun_damage" },
    { 0x953B8CE5, "slowgun_damage_mod" },
    { 0xE17F214B, "slowgun_damage_ug" },
    { 0xC6D549CC, "slowgun_debug_print" },
    { 0x154DEEBA, "slowgun_desired_anim_rate" },
    { 0x7BD14FF5, "slowgun_enemies" },
    { 0x792B0650, "slowgun_explosion_count" },
    { 0xDA1B84A0, "slowgun_explosion_time" },
    { 0x2B0F6949, "slowgun_fired" },
    { 0x563715CE, "slowgun_flying" },
    { 0x9281AF8C, "slowgun_get_enemies_in_range" },
    { 0xCF63CEFD, "slowgun_inner_range_squared" },
    { 0x09730106, "slowgun_on_zombie_spawned" },
    { 0x8B1592E4, "slowgun_outer_range_squared" },
    { 0x8A75B127, "slowgun_player_connect" },
    { 0x1CEABFB8, "slowgun_target_time" },
    { 0xAEF6F6FF, "slowgun_targets" },
    { 0x30C9D493, "slowgun_zombie_damage_response" },
    { 0x329E95D8, "slowgun_zombie_death_response" },
    { 0x5B60B1EE, "slowing" },
    { 0xCBD3D291, "slowing_down" },
    { 0x304AAB55, "slowing_down_speed" },
    { 0xE7E618AF, "slowly" },
    { 0x3E381B5E, "slowmo" },
    { 0x944F9BF9, "slowmo_check_system" },
    { 0x85DBD3B4, "slowmo_end" },
    { 0x32332ECB, "slowmo_hintprint" },
    { 0x0D8F7658, "slowmo_lerp_in" },
    { 0x8D2BD0D7, "slowmo_lerp_out" },
    { 0x8E7A7157, "slowmo_med_end" },
    { 0x1F512B3C, "slowmo_med_start" },
    { 0x32B938AF, "slowmo_setlerptime_in" },
    { 0x0CDCEF7A, "slowmo_setlerptime_out" },
    { 0x34D2BED5, "slowmo_setspeed_norm" },
    { 0x47FB1C50, "slowmo_setspeed_slow" },
    { 0x9CE770DF, "slowmo_start" },
    { 0xBAA46E9F, "slowmo_system_defaults" },
    { 0x02AB7767, "slowmo_system_init" },
    { 0x4588F1C9, "slowmo_truck_explo" },
    { 0x489A21A3, "slowmomode" },
    { 0x854F22CD, "slows" },
    { 0x9E2A30A5, "slowview" },
    { 0xB985CE11, "slpa" },
    { 0xE353CA40, "slpash" },
    { 0x41E5E437, "sludge" },
    { 0xBE30749A, "slum" },
    { 0x1EDEAEA8, "slum_alley_corner" },
    { 0x0D1862E3, "slum_alley_dog" },
    { 0x853F24D1, "slum_alley_initial" },
    { 0x3484F698, "slum_clean_up_standoff" },
    { 0x1F6E0490, "slum_edge_vo" },
    { 0x3BE347CC, "slum_state" },
    { 0xE7D0A3AF, "slum_vo_ambulance" },
    { 0x46E64AE1, "slumps" },
    { 0x3A6CBA95, "slums" },
    { 0xC71A72AE, "slums_anims" },
    { 0x90C5AA32, "slums_apache_retreat" },
    { 0x8F607181, "slums_axis_5_7" },
    { 0x31B18C26, "slums_bottle_neck" },
    { 0xA217E202, "slums_checkpoint" },
    { 0xEB8513F0, "slums_cleanup_1" },
    { 0x2BFF1412, "slums_current_scene" },
    { 0xE268ED38, "slums_done" },
    { 0x9A152D8B, "slums_drones_setup" },
    { 0x6201B80E, "slums_e_02_helicopter" },
    { 0xCD0B38FC, "slums_e_23_start" },
    { 0xC8438CC4, "slums_found_weapon_cache" },
    { 0x5A9668BA, "slums_get_target_nodes" },
    { 0x7481F9FC, "slums_go_to_node_using_funcs" },
    { 0xCAA8881C, "slums_heroes_watch" },
    { 0xBC7B1FAB, "slums_magic_rpg_setup" },
    { 0x73D39B54, "slums_magic_rpg_think" },
    { 0xAF2DCCB6, "slums_manage_grenade_count" },
    { 0x044FF47E, "slums_mg_nest_allies" },
    { 0x9C541D03, "slums_nag_check" },
    { 0x67034C40, "slums_nag_setup" },
    { 0x9D05A8F5, "slums_noriega_pistol_started" },
    { 0x95424FB8, "slums_objectives" },
    { 0xD479F5F5, "slums_paired_movement" },
    { 0xFD2900CC, "slums_side_door_watch" },
    { 0x3A268B56, "slums_soldier_rescued" },
    { 0x2879BB9B, "slums_spawn_functions" },
    { 0xD048DC0C, "slums_start" },
    { 0x3ECD19E2, "slums_wind_settings" },
    { 0xBAD5F053, "slums_zpu_destroyed" },
    { 0x1109DFE1, "sm" },
    { 0xC9F10A04, "sm_" },
    { 0x72B07E7A, "sm_active" },
    { 0xEE45DCD6, "sm_active_count" },
    { 0xE290D32D, "sm_active_count_max" },
    { 0xC4B2DF6B, "sm_active_count_max_hud" },
    { 0x5FA59123, "sm_active_count_min" },
    { 0x470C2455, "sm_active_count_min_hud" },
    { 0x73AF57CD, "sm_active_count_title" },
    { 0xF830189F, "sm_active_cpunt" },
    { 0x87AAA15D, "sm_advance_wait_max" },
    { 0xC50EAC73, "sm_advance_wait_min" },
    { 0x0521F809, "sm_apc_alley_digbats" },
    { 0xD8A102EE, "sm_apc_alley_digbats_spawnmanager" },
    { 0x65633073, "sm_array" },
    { 0x9CB99243, "sm_cam_ent" },
    { 0x3956B1E9, "sm_count" },
    { 0x693BF576, "sm_die" },
    { 0xBC41D555, "sm_goalnode" },
    { 0xBF8006E3, "sm_group_size" },
    { 0x20149B34, "sm_group_size_max" },
    { 0x8C831EB6, "sm_group_size_max_hud" },
    { 0x4D210F7A, "sm_group_size_min" },
    { 0xA268B598, "sm_group_size_min_hud" },
    { 0x34BB78F5, "sm_handoff_thread" },
    { 0x1DD09F47, "sm_handoff_triggered_" },
    { 0x9F73840D, "sm_i" },
    { 0xB77FA9B3, "sm_id" },
    { 0xCF5A22F4, "sm_kill" },
    { 0x06D7EC87, "sm_kill_ids" },
    { 0x24953DE5, "sm_name" },
    { 0xF6FBB55F, "sm_notify" },
    { 0x89B50B64, "sm_num" },
    { 0x451510FC, "sm_priority" },
    { 0x32A363E2, "sm_progresstrigger_thread" },
    { 0xA39D85C2, "sm_run_func_when_cleared" },
    { 0x87A191CE, "sm_run_func_when_cleared_internal" },
    { 0xAE324F47, "sm_run_func_when_complete" },
    { 0x13900061, "sm_run_func_when_complete_internal" },
    { 0x039BEF49, "sm_run_func_when_enabled" },
    { 0x34C1CB77, "sm_run_func_when_enabled_internal" },
    { 0x42C6933D, "sm_script_noteworthy" },
    { 0x5ADA03C2, "sm_sensitive_room_start_think" },
    { 0x44D3D237, "sm_slums_initial_retreat" },
    { 0xBC2F37E4, "sm_spawner_count" },
    { 0xEC676387, "sm_spawner_count_max" },
    { 0x5BA78CD1, "sm_spawner_count_max_hud" },
    { 0x8F471BF9, "sm_spawner_count_min" },
    { 0x7A568A0F, "sm_spawner_count_min_hud" },
    { 0x471F36BF, "sm_spawner_count_title" },
    { 0x714F4FDA, "sm_sub" },
    { 0xCD5ECBAC, "sm_sub2" },
    { 0xD01DC099, "sm_sunsamplesizenear" },
    { 0xB801D2E2, "sm_targetname" },
    { 0xF44C32F8, "sm_use_trig_when_cleared" },
    { 0xEEA09930, "sm_use_trig_when_cleared_internal" },
    { 0x8E608049, "sm_use_trig_when_complete" },
    { 0x22176E77, "sm_use_trig_when_complete_internal" },
    { 0x8BF80597, "sm_use_trig_when_enabled" },
    { 0x44411731, "sm_use_trig_when_enabled_internal" },
    { 0x593BF43C, "smack" },
    { 0xBB42781F, "smacked" },
    { 0x7E12911A, "small" },
    { 0xFCA9226C, "small_boat_attack_barge" },
    { 0x4B001D76, "small_boat_done" },
    { 0xC67841FF, "small_boat_unlink_rpg_guy" },
    { 0xCBA1BB4E, "small_explosion" },
    { 0x80916357, "small_fans" },
    { 0x3A15B46E, "small_fans_think" },
    { 0xB78925DD, "small_gate1" },
    { 0xDD8BA046, "small_gate2" },
    { 0x74D9D9C4, "small_gibs" },
    { 0x64820EFD, "small_hatch_headlights" },
    { 0xAF2CCA68, "small_hatchback" },
    { 0x21868F84, "small_magic_box" },
    { 0x3966803B, "small_rate" },
    { 0x40448BA1, "small_reznov_movie_num" },
    { 0x201ABACC, "small_room" },
    { 0xBB478DF6, "small_turbine" },
    { 0x4A0E02C5, "small_waterfall" },
    { 0x4FF5C1BA, "small_waterfall_b" },
    { 0x98F7856B, "smaller" },
    { 0xC1DE1112, "smallest" },
    { 0x14F93CFF, "smallest_ang" },
    { 0x1AFB12FE, "smallest_count" },
    { 0xF22FEC02, "smallest_leader" },
    { 0x01F3B6F6, "smallest_team" },
    { 0x11B207AA, "smallish" },
    { 0xD1E3E720, "smart" },
    { 0x1A5D3CD1, "smartbomb_handler" },
    { 0x786167F5, "smarter" },
    { 0x127C4465, "smartly" },
    { 0xB87163A7, "smash" },
    { 0x00548C4F, "smash_cam" },
    { 0x2D7B6225, "smash_fx_alias" },
    { 0xC38AC77B, "smash_gate" },
    { 0xB3C8ADE5, "smash_tapes" },
    { 0x9A4959CC, "smash_tv_notify" },
    { 0xD3A99070, "smashattackcb" },
    { 0xF46B336C, "smashed" },
    { 0x2E905F93, "smashes" },
    { 0xAD7F5579, "smashing" },
    { 0xC06ECA13, "smashpos" },
    { 0xD7DA5301, "smaw" },
    { 0x785F4B6E, "smeansofdamage" },
    { 0xBA36487D, "smeansofdeath" },
    { 0x131F832B, "smear" },
    { 0x73F089FE, "smell" },
    { 0x668DC260, "smell_kamarov" },
    { 0xAE2F4B1A, "smell_time" },
    { 0xFB7F19E1, "smells" },
    { 0xA4045D46, "smelt" },
    { 0xBC34F3D4, "smeltworks" },
    { 0xACF02A89, "smessage" },
    { 0x99DD36BC, "smg" },
    { 0x77C1D008, "smg_endgame_1" },
    { 0xE9C93F43, "smg_endgame_2" },
    { 0xC3C6C4DA, "smg_endgame_3" },
    { 0x0A72A566, "smg_endgame_array" },
    { 0x58B55F96, "smg_kill_index" },
    { 0xF22F9325, "smg_lobby" },
    { 0x24625872, "smg_ppsh_endgame_1" },
    { 0xFE5FDE09, "smg_ppsh_endgame_2" },
    { 0xD85D63A0, "smg_ppsh_endgame_3" },
    { 0x73CA3F98, "smg_ppsh_endgame_array" },
    { 0xBA48583F, "smg_ppsh_lobby" },
    { 0x340E5772, "smgads" },
    { 0x49190448, "smgfire" },
    { 0x19CEBD7B, "smgrange" },
    { 0x58C8BAF5, "smgrangeclose" },
    { 0x44CDA57F, "smgs" },
    { 0x47873F48, "smiley" },
    { 0xEE96C320, "smiley_face_reticle_index" },
    { 0x9768EDAC, "smissiletype" },
    { 0xD7D054DE, "smith" },
    { 0xF0B93748, "smithereens" },
    { 0x244CF318, "smod" },
    { 0xAF95B273, "smodel" },
    { 0x5F555075, "smodelindex" },
    { 0xCDB050EE, "smodelname" },
    { 0x22215922, "smodels" },
    { 0xFF41B010, "smoke" },
    { 0xE9F3AFE9, "smoke1" },
    { 0x850672FA, "smoke_array" },
    { 0x24D14B78, "smoke_damage" },
    { 0x880AFE5E, "smoke_detect" },
    { 0x3FAA3560, "smoke_exhale" },
    { 0xAE927961, "smoke_fx" },
    { 0x99AF4AAF, "smoke_fx_on" },
    { 0xA966296F, "smoke_grenade" },
    { 0x29C8FC60, "smoke_grenade_check_decrement" },
    { 0x488ED644, "smoke_grenade_death" },
    { 0xD6FA2F92, "smoke_grenade_done" },
    { 0x250DDD37, "smoke_grenade_fake_model" },
    { 0xB7705861, "smoke_grenade_hint" },
    { 0x098B7FB4, "smoke_grenade_on_the_scene" },
    { 0x326CC8A4, "smoke_grenade_radius" },
    { 0x5E2C6EFD, "smoke_grenade_triggers" },
    { 0xA0FD5AB6, "smoke_grenades" },
    { 0x443B29AF, "smoke_grenades_on_the_scene" },
    { 0x71DA4EFF, "smoke_has_been_thrown" },
    { 0x221B5300, "smoke_hint" },
    { 0x229F60E6, "smoke_hint_and_reset" },
    { 0x75A7E3E6, "smoke_is_inside" },
    { 0x52CD1F36, "smoke_model" },
    { 0x501E030B, "smoke_monster" },
    { 0xA5CA5147, "smoke_node_worthy" },
    { 0x3E0C1FEB, "smoke_popped" },
    { 0xF53954F3, "smoke_pos" },
    { 0xEBE21A56, "smoke_puff" },
    { 0xAA699650, "smoke_spiral" },
    { 0xC58A8C23, "smoke_structs" },
    { 0xB2873881, "smoke_tag" },
    { 0x19C970E1, "smoke_thrown" },
    { 0x7137F7FF, "smoke_til_dead" },
    { 0x6C6584E7, "smoke_trailfx" },
    { 0xF86A2B84, "smoke_transition_elem" },
    { 0x87DC3401, "smoke_trigger" },
    { 0xF20E3D70, "smoke_vel" },
    { 0x1F4936AE, "smoke_vo" },
    { 0xC10340DB, "smoke_weapon" },
    { 0x3EF9F2B0, "smokeangles" },
    { 0x54B65BB1, "smokeat4dude" },
    { 0x4F6C6D03, "smokeblockduration" },
    { 0x2A4C6C26, "smokeblocksight" },
    { 0x1657782B, "smokebuildtime" },
    { 0x3CC15FF4, "smoked" },
    { 0x848C64A8, "smokedetonate" },
    { 0xB80CE973, "smokeeffect" },
    { 0x049F065F, "smokeent" },
    { 0x887842E5, "smokefriendlies" },
    { 0x5C7CD6BA, "smokegrenade" },
    { 0x5A6D1281, "smokegrenadedissipation" },
    { 0x2B915EB6, "smokegrenadeduration" },
    { 0x56C5F73B, "smokegrenadeposition" },
    { 0x0D49CD35, "smokegrenades" },
    { 0x785B8D55, "smokegrenadetime" },
    { 0x516AE7EB, "smokegrenadetotaltime" },
    { 0x64098803, "smokeleader" },
    { 0x1FCA3427, "smokenodes" },
    { 0x9094C492, "smoker" },
    { 0xF029AD1A, "smoker_alerted" },
    { 0x034A7F09, "smoker_and_spawner" },
    { 0x6AAB929A, "smoker_guy" },
    { 0xC03CF495, "smoker_guys" },
    { 0x6669B4F2, "smoker_react" },
    { 0x4D6F98EA, "smoker_spawners" },
    { 0x73C57B0E, "smoker_stopanim" },
    { 0x2568B69D, "smokers" },
    { 0xB6973EFB, "smokes" },
    { 0xFB5C3BFC, "smokescreen" },
    { 0xA120882B, "smokescreen_southern_hill" },
    { 0x9E040A6D, "smokesound" },
    { 0x9141F501, "smokesoundduration" },
    { 0x3497E7CA, "smokespawnsafedist" },
    { 0x39E05C96, "smokesquad" },
    { 0x080594F8, "smokestack" },
    { 0x2B47E553, "smokestacks" },
    { 0x9AE8EE6B, "smokestruct" },
    { 0xA8B6FBBB, "smokethrow_pos" },
    { 0x6C8F36B6, "smokethrown" },
    { 0x6ECEC7A4, "smoketown" },
    { 0xAC31BEE8, "smoketown_ambient_friendlies_think" },
    { 0x2D8B2730, "smoketown_ambient_hostiles_think" },
    { 0x3A355350, "smoketown_ambient_think" },
    { 0xE1F9046F, "smoketown_at4_hostile" },
    { 0x4B402F9D, "smoketown_at4_impact" },
    { 0x9CF923C7, "smoketown_cobra_think" },
    { 0xDD34CCCB, "smoketown_construction_door" },
    { 0x321A2BE0, "smoketown_enemy_heli" },
    { 0xD314AFFC, "smoketown_flyover" },
    { 0xF5548CCC, "smoketown_heli_destroy_failsafe" },
    { 0x7CAB3438, "smoketown_land" },
    { 0x17F9E756, "smoketown_lz_advance" },
    { 0xF078FB70, "smoketown_lz_door" },
    { 0x4754F2C3, "smoketown_mortars" },
    { 0x38D11D3E, "smoketown_physics_explosion" },
    { 0x3EB50200, "smoketown_seaknight_return" },
    { 0x87CF34D6, "smoketown_upstairs" },
    { 0x107CA64A, "smoketownmi17" },
    { 0xA852D5C9, "smoketrackingstart" },
    { 0xFD05FA56, "smoketrail_points" },
    { 0x118E734C, "smokeweapon" },
    { 0x9BA9CB45, "smokey_transition" },
    { 0x14D8BE91, "smoking" },
    { 0xC9A2413D, "smoking_girl_camera_cut" },
    { 0x01DA49BC, "smoking_lady" },
    { 0xDE3568D8, "smokingguard" },
    { 0xB7F3D4B3, "smokingguards" },
    { 0xCFF78A0F, "smoky_hallway_crouched" },
    { 0xFCFE8524, "smoky_hallway_dialogue" },
    { 0x71DD2B37, "smoldering" },
    { 0x2ABE40A7, "smooth" },
    { 0xBDFA23C6, "smooth_frac" },
    { 0x0FCF042B, "smooth_in" },
    { 0x8A43EDBE, "smooth_out" },
    { 0x45668A2A, "smoother" },
    { 0x768B1479, "smoothing" },
    { 0x4B24072A, "smoothly" },
    { 0xF9BBF496, "smoothness" },
    { 0x563A0C54, "smoothorient" },
    { 0x5C2D64A5, "smother" },
    { 0x7B537490, "smoulder" },
    { 0xA1ABA688, "sms" },
    { 0x8F614911, "sms1" },
    { 0x0D061BB6, "sms1sn" },
    { 0x1594A761, "sms2sn" },
    { 0x64D8FC82, "smsj" },
    { 0x75EC3D01, "smsjo" },
    { 0xD122EEBD, "smth" },
    { 0x4033753F, "smuggled" },
    { 0x370C5A4A, "sn" },
    { 0xBFA62A18, "sn_name" },
    { 0x486A1C9F, "snake" },
    { 0xF54770FC, "snake_coiled" },
    { 0xC4E2162D, "snake_kill_easter_egg" },
    { 0x1E9F4159, "snake_slither" },
    { 0x5DB471CE, "snaked_monitor" },
    { 0xBCA7C7F7, "snakeswim" },
    { 0xB7E09E02, "snakeswim_start" },
    { 0xCF01E8DD, "sname" },
    { 0xE8A70855, "snap" },
    { 0xAF557B1B, "snap_lock_turret_onto_target" },
    { 0xF746E50C, "snap_max_height" },
    { 0xD0D5C174, "snap_processed" },
    { 0xD32DAF5C, "snap_starting_crate" },
    { 0x1A247A91, "snap_to_final_pos" },
    { 0x089A0A85, "snapacknowledged" },
    { 0xA7203AE4, "snapped" },
    { 0x06A93DA2, "snappedorigin" },
    { 0x76EE31E1, "snapping" },
    { 0x80D520A4, "snaps" },
    { 0xE65FD8D5, "snapshot" },
    { 0x544ABFF4, "snapshot_amb_silent" },
    { 0xECCA94D2, "snapshot_boat" },
    { 0x4E51C0C0, "snapshot_check" },
    { 0xFACD274F, "snapshot_default" },
    { 0x4373C527, "snapshot_default_1" },
    { 0xD16C55EC, "snapshot_default_2" },
    { 0xF76ED055, "snapshot_default_3" },
    { 0xDAEB479E, "snapshot_drone" },
    { 0xAA173FF9, "snapshot_ending" },
    { 0x2585F048, "snapshot_flashback_2" },
    { 0x4B886AB1, "snapshot_flashback_3" },
    { 0xAEFA6145, "snapshot_foley_quieter" },
    { 0x0BE9E986, "snapshot_ids" },
    { 0x02F4B74E, "snapshot_intro" },
    { 0x612278F0, "snapshot_level_end" },
    { 0x8CD80B26, "snapshot_level_end_immediate" },
    { 0x7E9A5B01, "snapshot_manager_1" },
    { 0xA49CD56A, "snapshot_manager_2" },
    { 0xCA9F4FD3, "snapshot_manager_3" },
    { 0xF0A1CA3C, "snapshot_manager_4" },
    { 0x16A444A5, "snapshot_manager_5" },
    { 0xCBDEC7A5, "snapshot_reset" },
    { 0xEE3CA4E8, "snapshot_set" },
    { 0x5AA194BE, "snapshot_slides" },
    { 0x6FFAB057, "snapshot_special_silent" },
    { 0xA7E5C44C, "snapshot_start" },
    { 0xB6C6D874, "snapshot_test" },
    { 0x55629DA9, "snapshot_under_woods" },
    { 0x6CBC20AB, "snapshot_value" },
    { 0xE1C74438, "snapshot_woods_default" },
    { 0x025BCFCA, "snapshot_woods_freak" },
    { 0xFA31F305, "snapshotacknowledged" },
    { 0x6AC55A24, "snapshots" },
    { 0x94A107B8, "snare" },
    { 0x5B0744C1, "snare_rope_id" },
    { 0xEB62FC3F, "snare_trap_handle_triggerer" },
    { 0x5532BD35, "snare_trap_thread" },
    { 0x9A18EBBA, "snd" },
    { 0x2C9AA706, "snd115count" },
    { 0xB9176BC8, "snd115egg" },
    { 0x787808CB, "snd115egg_1_override" },
    { 0x21D5D64F, "snd115egg_5_override" },
    { 0x50CDE7E0, "snd115egg_wait" },
    { 0x8D6B7081, "snd1stpersonexplo" },
    { 0xF6FF1CEB, "snd_add_exploder_alias" },
    { 0xF0CC7E6D, "snd_ads" },
    { 0xB3BE5F90, "snd_alarm" },
    { 0x64777A79, "snd_ally_revive" },
    { 0xE1B0897D, "snd_amb_off" },
    { 0x4ABDB7E2, "snd_amb_ruin_off" },
    { 0xFF720C50, "snd_argument" },
    { 0x9F4AC320, "snd_bdog_fire" },
    { 0x57B4537F, "snd_bdog_stop_fire" },
    { 0xFA5CDFE8, "snd_boost_end" },
    { 0x71FE188B, "snd_boost_start" },
    { 0x7A966C52, "snd_breathing_better" },
    { 0xA71E313F, "snd_breathing_hurt" },
    { 0xC6CEA5EE, "snd_build_add_vo_override" },
    { 0x2F723E7E, "snd_burn_scream" },
    { 0x5711D7EE, "snd_canyon_wind" },
    { 0x31B42ECF, "snd_canyon_wind_start" },
    { 0x0281398A, "snd_cd_ent" },
    { 0xF39DE286, "snd_commotion" },
    { 0x1E3FBC17, "snd_commotion_start" },
    { 0x4C89ED7E, "snd_countdown" },
    { 0x65017B9D, "snd_crowd_chant" },
    { 0x55E6FA8F, "snd_delete_auto_fx" },
    { 0x6F53436A, "snd_distant_gantry" },
    { 0x6775985C, "snd_distant_rocket_arm" },
    { 0x432C742A, "snd_door_status" },
    { 0xE2B416C0, "snd_ecrwl" },
    { 0xDCBD8075, "snd_ehs" },
    { 0xA50971C5, "snd_end_rnd" },
    { 0xE736B41E, "snd_end_rst" },
    { 0xAA0FF970, "snd_ent" },
    { 0x2A9E2D99, "snd_exploders" },
    { 0xCCD7536F, "snd_final_killcam" },
    { 0xAC79E2C5, "snd_first" },
    { 0x631B85B7, "snd_first_person" },
    { 0xFA1E0445, "snd_flare_ent" },
    { 0x45D4015A, "snd_footstep_override_npc" },
    { 0xBE67DE99, "snd_footstep_override_plr" },
    { 0x3ABECC05, "snd_fuel" },
    { 0xED48BC8E, "snd_fx_create" },
    { 0x7B6E81EB, "snd_impact" },
    { 0xC96F1D7F, "snd_jet_start" },
    { 0x5BA57787, "snd_killstreak_reaper" },
    { 0xE865310C, "snd_last_stand" },
    { 0xDC58AD14, "snd_launch" },
    { 0xFB32EF91, "snd_melee_end" },
    { 0x322E3A69, "snd_mp_end_round" },
    { 0xEAD0AD59, "snd_mp_snapshot_reset" },
    { 0x868D8EA4, "snd_music_state_triggers" },
    { 0x9C31C81F, "snd_ninja_pro_checker" },
    { 0xAA9D0336, "snd_ninja_pro_watcher" },
    { 0xBDD8C430, "snd_off" },
    { 0xDE913DDD, "snd_pa_start" },
    { 0xB6C93E47, "snd_pain_player" },
    { 0xB9CE2CDB, "snd_pers_upgrade_force_type" },
    { 0x00ED51A6, "snd_pers_upgrade_force_variant" },
    { 0xA099FBF2, "snd_pipe_shake" },
    { 0x466F4E88, "snd_pipe_steam" },
    { 0x818BC93C, "snd_pipe_steam_lrg" },
    { 0xF7179C9B, "snd_pipe_steam_lrg_2" },
    { 0xB61E8DFE, "snd_play_auto_fturbine_area_emmiters" },
    { 0x14F91CE8, "snd_play_auto_fx" },
    { 0x87A6A767, "snd_play_auto_fx_area_emmiters" },
    { 0xF6D547B9, "snd_play_auto_fyemen_area_emmiters" },
    { 0xFFF8DC01, "snd_play_gaz_idle" },
    { 0x3F26C2A4, "snd_play_loopers" },
    { 0xA8DFAD9E, "snd_playbackid_notplayed" },
    { 0x9CE82720, "snd_played" },
    { 0x559F8F39, "snd_pov_watcher" },
    { 0xBC09759E, "snd_print_fturbine_id" },
    { 0x06D38E35, "snd_print_fx_id" },
    { 0xD89B6DBF, "snd_print_fyemen_id" },
    { 0xF96ACA85, "snd_radar_engine_loop" },
    { 0x79F6A326, "snd_radar_groan_loop" },
    { 0x7DC5CA5C, "snd_random" },
    { 0xD6F348B9, "snd_rocket_gantry" },
    { 0xBC2A1D65, "snd_rocket_launch" },
    { 0x8D0BC7FF, "snd_rocket_notify" },
    { 0xDE5D02D7, "snd_sat_sound" },
    { 0x2039B8B4, "snd_set_default_snapshot" },
    { 0xB205C783, "snd_set_intro_snapshot" },
    { 0x64D5FCE6, "snd_set_low_ambience_snapshot" },
    { 0x36BBD2B2, "snd_set_snapshot" },
    { 0x391DEF6B, "snd_shattered" },
    { 0x3E13DD90, "snd_shattered_2" },
    { 0x7FCAC372, "snd_snapshot_init" },
    { 0x709F2106, "snd_snapshot_level_fadein" },
    { 0x46A725F3, "snd_snapshot_save" },
    { 0xFBF6B64C, "snd_snapshot_think" },
    { 0x91A2AA37, "snd_spiderbot_look_servo" },
    { 0xB16EED42, "snd_spiderbot_look_servo_start" },
    { 0xE8B3668C, "snd_start_add_exploder_alias" },
    { 0x45668C02, "snd_start_autofcarrier_audio" },
    { 0xF4506610, "snd_start_autofdrone_audio" },
    { 0x814A47E0, "snd_start_autofnightclub_audio" },
    { 0x79AC7D20, "snd_start_autofraid_audio" },
    { 0x113B7A0A, "snd_start_autofx_audio" },
    { 0x19182F21, "snd_start_autofx_river_fight" },
    { 0xA9E1CE38, "snd_start_autofyemen_audio" },
    { 0xAF8BC0AE, "snd_struct" },
    { 0x3A3C785D, "snd_swell_start" },
    { 0x79FAA868, "snd_target_gone" },
    { 0x2D999E4F, "snd_targetname" },
    { 0x32CAA81C, "snd_third" },
    { 0x0AEFD88C, "snd_third_person" },
    { 0x9C3426C1, "snd_thread" },
    { 0x39AA9512, "snd_underwater" },
    { 0x16B23CF7, "snd_vtol_start" },
    { 0x9AA0ACE6, "snd_window_wind_1" },
    { 0x749E327D, "snd_window_wind_2" },
    { 0x4E9BB814, "snd_window_wind_3" },
    { 0x144AAAC7, "sndactivatedrivesnapshot" },
    { 0xD8D5BE76, "sndactivatedrivingsnapshot" },
    { 0xACED72FA, "sndalarmtimeout" },
    { 0x581443FE, "sndalias" },
    { 0x8CB88832, "sndamb" },
    { 0x4B5B591F, "sndambientdelay" },
    { 0x07A7B93C, "sndandrumblewaituntillanding" },
    { 0x26E702C4, "sndannouncer_init" },
    { 0x2950E3BD, "sndannouncerisrich" },
    { 0x51F359C0, "sndannouncerplayvox" },
    { 0x700B295F, "sndannouncervoxadd" },
    { 0xC3729DB1, "sndattackvox" },
    { 0x29139699, "sndbackgroundmustracker" },
    { 0x1A007268, "sndboardmonitor" },
    { 0xFB5BF63F, "sndboatramsnapshotoff" },
    { 0x2166604B, "sndboatramsnapshoton" },
    { 0xD4C80541, "sndbrutusistalking" },
    { 0xF58F5261, "sndbrutusloopwatcher" },
    { 0x81EFB511, "sndbrutusmusicent" },
    { 0xBAF335B8, "sndbrutusvox" },
    { 0x3109EFD9, "sndbuildablecompletealias" },
    { 0x0265B8DD, "sndbuildableusealias" },
    { 0x76810D2E, "sndcanopyclose" },
    { 0xF7F3D6B1, "sndcchacking" },
    { 0x14CAFBC2, "sndchance" },
    { 0xF033932D, "sndchangeaudioroom" },
    { 0x7DE79DD3, "sndchangebreathingstate" },
    { 0xDC097E47, "sndchangecrawlsnapshot" },
    { 0xB35AA20D, "sndchangemotelmusicstate" },
    { 0xA1E972FE, "sndchangemusicstate" },
    { 0xF29CC70F, "sndchangetoapachemusicstate" },
    { 0x88072109, "sndchangeverb" },
    { 0x73573B93, "sndchargeshot_func" },
    { 0x5E753BAC, "sndcheers" },
    { 0x5B347CD3, "sndchyronloop" },
    { 0x0BF84E1F, "sndchyronwatcher" },
    { 0x3C294966, "sndcollapsing" },
    { 0x80DB0D1D, "sndconversation_addline" },
    { 0x7AB00F0C, "sndconversation_init" },
    { 0x20B36810, "sndconversation_play" },
    { 0x15BEA6B3, "sndconversationdone" },
    { 0xDC73CA36, "sndconversations" },
    { 0xE4DF0B58, "sndconvo1" },
    { 0x56E67A93, "sndconvo2" },
    { 0x30E4002A, "sndconvo3" },
    { 0xA2EB6F65, "sndconvo4" },
    { 0x27E4FDDC, "sndconvointerrupt" },
    { 0x66031F2D, "sndconvolinedone" },
    { 0xF6E37DE7, "sndconvostopcurrentconversation" },
    { 0x17BE9B35, "sndcooldown" },
    { 0x216A1A98, "sndcough" },
    { 0x6BB61CF7, "sndcountdown" },
    { 0xC4CC3A11, "sndcrowdswell1" },
    { 0xEACEB47A, "sndcrowdswell2" },
    { 0x755B5E07, "sndcurrentlocationarray" },
    { 0xE4073171, "snddamage" },
    { 0xA2D5A302, "snddamagelooptimer" },
    { 0x652759F0, "snddamagetimer" },
    { 0x03D44975, "snddeactivateroom" },
    { 0x40E2D5D8, "snddeactivatesnapshot" },
    { 0xEB12A51C, "snddeath_activate" },
    { 0x16410815, "snddeath_deactivate" },
    { 0x680DEC1D, "sndded" },
    { 0x6DCC34FA, "snddede" },
    { 0xD00FF7CB, "snddelayedchairaudio" },
    { 0xA70DD9BA, "snddelayedimp" },
    { 0x65239C61, "snddelayedmusic" },
    { 0xA2C32EFB, "snddelayedmusicstart" },
    { 0xC1FBADD3, "snddelayedsidequest8" },
    { 0x231059C5, "snddelete115ent" },
    { 0x1C5B6EC1, "snddeleteentondeath" },
    { 0xD5D2A2CE, "snddeleting" },
    { 0x451C4DAE, "snddnirepair" },
    { 0x2B4649A6, "snddnirepairdone" },
    { 0x0558B06E, "snddointeractionvox" },
    { 0xD3D93E33, "snddoormusic" },
    { 0x25579D51, "snddoormusic_triggered" },
    { 0xD51C75A4, "snddoormusictrigs" },
    { 0x706A3052, "snddooropening" },
    { 0x7283F198, "snddoublejump_watcher" },
    { 0xB87A4CDD, "snddryercountdown" },
    { 0x1FAB08D7, "sndduckamb" },
    { 0x33578AB4, "sndduckambendintro" },
    { 0xCD1D7C61, "sndduckaudiomorals" },
    { 0xEC4BD3E5, "sndducklookyloo" },
    { 0x06412031, "sndduckmortars" },
    { 0x27A6B3F8, "sndducksolar" },
    { 0x6E31BA97, "sndducksolaroff" },
    { 0xC13F73A1, "sndee4music" },
    { 0xEC067485, "sndeggmusicwait" },
    { 0x388617F4, "sndemp" },
    { 0x72A741E8, "sndend115" },
    { 0xD196B8A1, "sndendcheerloops" },
    { 0x4B7A2D9D, "sndendexertoverride" },
    { 0x1049BD1E, "sndendgamemusicredux" },
    { 0x3CCADCCF, "sndendingsnapshot" },
    { 0x238323ED, "sndendnixiecount" },
    { 0x79736512, "sndendnoirmusic" },
    { 0x3D4CE1C7, "sndendowsmusic" },
    { 0x2771912D, "sndendroundloop" },
    { 0x34A09FAB, "sndenduwwatcher" },
    { 0x1C4260D1, "sndent" },
    { 0x9559594F, "sndentorigin" },
    { 0x6F546E07, "sndeventstingertriggers" },
    { 0x85E6C424, "sndeventstingertriggerthink" },
    { 0x14D80E80, "sndeventtension" },
    { 0xC6BEE5F3, "sndf35_death_sound" },
    { 0x50681BB1, "sndf38snapshot" },
    { 0xF1191353, "sndf38snapshot_off" },
    { 0x4AD0BCBF, "sndf38snapshot_on" },
    { 0xCB9E8004, "sndfadeout" },
    { 0x2E573CAF, "sndfakeamb" },
    { 0x7D527C4E, "sndfakeambend" },
    { 0xF17F8F51, "sndfakefire" },
    { 0x266B4809, "sndfieldreport1" },
    { 0x4C6DC272, "sndfieldreport2" },
    { 0x72703CDB, "sndfieldreport3" },
    { 0x6108E5A5, "sndfinalkillcam_activate" },
    { 0x6C3DFFAC, "sndfinalkillcam_deactivate" },
    { 0x3F214541, "sndfinalkillcam_slowdown" },
    { 0x1AC9DC26, "sndfindwoodsroom" },
    { 0x4EA140EF, "sndfindwoodssnapshot" },
    { 0xF345A546, "sndfire" },
    { 0xFB57E37D, "sndfiredamage" },
    { 0xD841ACF8, "sndfiredamage_deleteent" },
    { 0xF000BE0D, "sndfireent" },
    { 0x2639D33D, "sndfiresalemusic_start" },
    { 0x0F0C046F, "sndfiresalemusic_stop" },
    { 0x51756B8F, "sndfiresalemusoff" },
    { 0xF8719FCC, "sndfirstdoor" },
    { 0xF81C493C, "sndfke" },
    { 0x4BEFADDA, "sndfks" },
    { 0x5B4309E2, "sndfksl" },
    { 0x2D94E790, "sndfoleycontext" },
    { 0xFB609A00, "sndforcewait" },
    { 0x71A341FB, "sndfuelpieces" },
    { 0x12446AE9, "sndfunctions" },
    { 0x2A2EE60B, "sndgameend" },
    { 0xDB35220F, "sndgameovermusicoverride" },
    { 0x2C663572, "sndgettensionlevel" },
    { 0x84F10DF8, "sndghostroundend" },
    { 0x0505F056, "sndghostroundmus" },
    { 0x22F6F56C, "sndghostroundmus_end" },
    { 0x8A006586, "sndghostroundready" },
    { 0xF05860A1, "sndghostroundready_stoplp" },
    { 0x458E132C, "sndgotoroundoccurred" },
    { 0x2C34B810, "sndgrthreads" },
    { 0x990FEEC6, "sndhalfway" },
    { 0xE1AB476F, "sndhealthsystem" },
    { 0x47E93FCD, "sndhit" },
    { 0x73F4BE36, "sndhitelectrifiedpulley" },
    { 0x0DDE7199, "sndid" },
    { 0x9C83D0D4, "sndigcskipwatcher" },
    { 0x81443BB5, "sndigcsnapshot" },
    { 0x6A7E1305, "sndigcsnapshotoverride" },
    { 0xBDE86827, "sndisnetworksafe" },
    { 0x9BA12D23, "sndjingleactive" },
    { 0x7E8848AE, "sndjinglecooldown" },
    { 0x6821DFE1, "sndjingledone" },
    { 0x65137453, "sndkillcam" },
    { 0x8CDACA39, "sndkillvox" },
    { 0x48FADD16, "sndknockedoutent" },
    { 0x0D0CBB60, "sndknockedoutent2" },
    { 0x0643F786, "sndlastlife_multi" },
    { 0x819C6E20, "sndlastlife_multi_getlastplayer" },
    { 0x5D624B32, "sndlastlife_multi_reset" },
    { 0x59336D0E, "sndlastlife_solo" },
    { 0x06843D4F, "sndlastlifesetup" },
    { 0xFC3145D6, "sndlastweapon" },
    { 0x74382D64, "sndlastzone" },
    { 0xBD3421CB, "sndlevelstartsnapoff" },
    { 0x1513C851, "sndlifegone" },
    { 0x05DBDAFE, "sndlocationbetweenrounds" },
    { 0x3133365D, "sndlocationbetweenroundswait" },
    { 0xF67A3ED6, "sndlocationplayed" },
    { 0xB55A93F8, "sndlocationqueue" },
    { 0xC6946869, "sndlocationsarray" },
    { 0x3459A7AC, "sndlocationshouldplay" },
    { 0xE3C33322, "sndloop_ent" },
    { 0x79425B0B, "sndloopent" },
    { 0x005C166B, "sndloopid" },
    { 0x238469FB, "sndloopingent" },
    { 0xE33EEB14, "sndmaelstrom" },
    { 0xE5CE9DFC, "sndmaelstrom_timeout" },
    { 0xB291D6BC, "sndmansionent" },
    { 0xEE85FBD1, "sndmaskoff" },
    { 0x6EE15A7D, "sndmatchsnapshot" },
    { 0x214D2715, "sndmechz" },
    { 0xD623417A, "sndmechzisnetworksafe" },
    { 0x598D8E55, "sndmechzistalking" },
    { 0xEE0C5A05, "sndmechzmusicent" },
    { 0x66305FE3, "sndmechznetworkchoke" },
    { 0x9B36845C, "sndmeleeswipe" },
    { 0x024652A8, "sndmeleewpn_isstaff" },
    { 0x00E24C1C, "sndmeleewpnsound" },
    { 0x235199D0, "sndmoveplinth" },
    { 0xBAFC9617, "sndmpprematch" },
    { 0x60AFFDCF, "sndmusegg1" },
    { 0xEEA88E94, "sndmusegg2" },
    { 0xF125214B, "sndmusegg2_override" },
    { 0xA81B429C, "sndmusegg2_wait" },
    { 0xA0F0BBBC, "sndmusegg3_counter" },
    { 0x74C731A8, "sndmuseggplay" },
    { 0xFC474F05, "sndmusicdeathwatcher" },
    { 0x90D21A5B, "sndmusiceastereggs" },
    { 0x38B2E312, "sndmusicegg" },
    { 0x310CACF9, "sndmusicegg_override" },
    { 0x1DF774A6, "sndmusicegg_wait" },
    { 0x0C6F212A, "sndmusicfunctions" },
    { 0xB3B69DE9, "sndmusichalfway" },
    { 0xDF586F18, "sndmusiconkillround" },
    { 0xEE001FB0, "sndmusicquestendgame" },
    { 0xA8967E04, "sndmusicsetrandomizer" },
    { 0x1B7D7BB8, "sndmusicspecialround" },
    { 0xDB951CD9, "sndmusicstingerevent" },
    { 0x4A63E15E, "sndmusicsystem_createstate" },
    { 0x009587D1, "sndmusicsystem_eeoverride" },
    { 0x8B6AD20C, "sndmusicsystem_eesetup" },
    { 0x5E61AA0E, "sndmusicsystem_eewait" },
    { 0x8895BD2E, "sndmusicsystem_isabletoplay" },
    { 0x0F8CBDF9, "sndmusicsystem_locations" },
    { 0x3B328A67, "sndmusicsystem_locationsinit" },
    { 0xFB40EB40, "sndmusicsystem_playstate" },
    { 0xA576B2EB, "sndmusicsystem_queuestate" },
    { 0x76113E2C, "sndmusicsystem_stopandflush" },
    { 0x5E99E3FB, "sndmusictimelimitwatcher" },
    { 0xBBAA609D, "sndmusictimesout" },
    { 0x25145CAF, "sndmusicunlock" },
    { 0xD26F48BF, "sndmusicvariable" },
    { 0x7C58FB47, "sndname" },
    { 0xC13970D7, "sndnexttensionevent" },
    { 0x2D09F8A8, "sndnixietubecountdown" },
    { 0x4EE07F31, "sndnoamb" },
    { 0x379AF877, "sndnomeleeonclient" },
    { 0xAA630B49, "sndnorepeats" },
    { 0x05EDA5F7, "sndnosamlaugh" },
    { 0x257BB744, "sndnt" },
    { 0x56D74922, "sndnum" },
    { 0xAC41D68E, "sndoccupants" },
    { 0x76EB38A5, "sndonoverride" },
    { 0x23CF79EA, "sndonwait" },
    { 0xA5624F44, "sndorg" },
    { 0xC70DFC78, "sndorigin" },
    { 0x5369A434, "sndpa_dovox" },
    { 0xB49A3F6B, "sndpa_playvox" },
    { 0x1E7472D2, "sndpa_traps" },
    { 0x8F9EE626, "sndpasetup" },
    { 0xCA682D71, "sndpc" },
    { 0x07E227DA, "sndperksacolajingle" },
    { 0xC9B03C1A, "sndperksacolajingleoverride" },
    { 0x617CEB1F, "sndperksacolaloop" },
    { 0x6A008207, "sndperksacolaloopoverride" },
    { 0x9D1DC607, "sndperksjingles_cooldown" },
    { 0x0A7CF0AB, "sndperksjingles_player" },
    { 0xAEF8A81F, "sndperksjingles_timer" },
    { 0x8BEBC2B9, "sndpingent" },
    { 0x462368B1, "sndpingid" },
    { 0x55EA06E9, "sndplanecrafted" },
    { 0x97273C31, "sndplanepieces" },
    { 0x5BB20899, "sndplaydelayedsmokeaudio" },
    { 0xFB9F277B, "sndplaydoorbell" },
    { 0xA39FBE33, "sndplaydoorleft" },
    { 0x2926AC26, "sndplaydoorright" },
    { 0x7495B092, "sndplaydriveranimsnd" },
    { 0x358DC87B, "sndplayerconsumed" },
    { 0xE7618574, "sndplayerconsumedid" },
    { 0xF980AF22, "sndplayerhitalert" },
    { 0x86EE8608, "sndplayerhitalert_playsound" },
    { 0x8FDC7BF6, "sndplayersdead" },
    { 0xB6B4173C, "sndplayervox" },
    { 0x417B0F77, "sndplayexplosionatposition" },
    { 0xDAEEC15B, "sndplayfakeciv" },
    { 0x91CAD12A, "sndplaygeneratormusicstinger" },
    { 0x8EF6914A, "sndplayloop" },
    { 0x3E391658, "sndplaymusicegg" },
    { 0x2A34116F, "sndplaystaffstingeronce" },
    { 0x553EBB87, "sndplaystateoverride" },
    { 0x5F9C184E, "sndplaystinger" },
    { 0x23155012, "sndplaystingerwithoverride" },
    { 0x5786F190, "sndplayvtolland" },
    { 0xF703B60D, "sndplayvtolland5" },
    { 0x1D063076, "sndplayvtolland6" },
    { 0x8ED4771D, "sndplayvtoltakeoff" },
    { 0xE4A9D44F, "sndpoweronmusicstinger" },
    { 0xCF163C95, "sndproxalert_entcleanup" },
    { 0xA1ED5963, "sndqueueflush" },
    { 0x1599530F, "sndqueuestinger" },
    { 0x9DB08CFA, "sndradio_override" },
    { 0xB879B3B4, "sndradioa" },
    { 0xFF22A5F2, "sndradiosetup" },
    { 0x713E84B0, "sndradiowait" },
    { 0xC1A99293, "sndrattle_grenade_client" },
    { 0x289CBD92, "sndrattle_server" },
    { 0x48F2D1DD, "sndrecaptureroundloop" },
    { 0xD928A8F8, "sndrecaptureroundloop_stop" },
    { 0x9A718FAF, "sndresetsoundsettings" },
    { 0x6FAF6F76, "sndrobot" },
    { 0xCC40AE19, "sndrobotheadcount" },
    { 0xC2CB7511, "sndroundwait" },
    { 0x000D36F6, "sndsafelights" },
    { 0x966F680A, "sndscanningent" },
    { 0x07BD3BA3, "sndscrampingent" },
    { 0x47C5D7D2, "sndset" },
    { 0x8A22DF99, "sndsetendsnapshot" },
    { 0x872E9E15, "sndsetmatchsnapshot" },
    { 0x963AF4D1, "sndsetupendgamemusicstates" },
    { 0x7CFCE6D3, "sndsetupmusiceasteregg" },
    { 0x790B3D9D, "sndsetzombiecontext" },
    { 0x4BC3962A, "sndshoulditplay" },
    { 0xC09367C0, "sndshutoffradio" },
    { 0x68E491A8, "sndsidequestnoirmusic" },
    { 0x94C80E91, "sndsidequestowsmusic" },
    { 0x12FA3A60, "sndslowmosnapshotoff" },
    { 0x3D961DBA, "sndslowmosnapshoton" },
    { 0x7681CE04, "sndsnapshotintro" },
    { 0x0B15BD01, "sndsongdone" },
    { 0x02D79677, "sndspdbotvox" },
    { 0x1E3E18BB, "sndspeakinganimaudio" },
    { 0x5D471091, "sndspectatorafterliferevert" },
    { 0x45F50A00, "sndspectatorsetup" },
    { 0xACB362CC, "sndstaffbuilt" },
    { 0x2D5701A2, "sndstaffupgradedstinger" },
    { 0x9C743B30, "sndstartalarms" },
    { 0x2A897A84, "sndstartmusicsystem" },
    { 0x58A34176, "sndstartsnapshot" },
    { 0xC16500C5, "sndstatechange" },
    { 0xEED99A91, "sndstatestop" },
    { 0xFF3A0754, "sndstinger" },
    { 0x51D63AF4, "sndstingerdone" },
    { 0x32C26AF5, "sndstingerforcestop" },
    { 0xBE667DC7, "sndstingerroundwait" },
    { 0xFCD2E7D9, "sndstingerroundwait_end" },
    { 0x774D8572, "sndstingerroundwait_start" },
    { 0xE2FCBB9B, "sndstingersetup" },
    { 0x133CA0D1, "sndstingersetupstates" },
    { 0x2ED27F7B, "sndstopbrutusloop" },
    { 0x7DB3E21F, "sndstopburnloop" },
    { 0x7D88204F, "sndstopcountdown" },
    { 0xE10AB6CA, "sndstopgazaudio" },
    { 0xE2498464, "sndstoploop" },
    { 0x4AB8165B, "sndstoproundreadylp" },
    { 0x57D61BBA, "sndswitchannouncervox" },
    { 0x2752E58F, "sndswitchvehiclecontext" },
    { 0x480CD1D4, "sndtacrig" },
    { 0xF967A1AD, "sndtacrigemergencyreserve" },
    { 0xA5E5F73E, "sndtheend" },
    { 0x94E3F255, "sndtime" },
    { 0xEDC85211, "sndtoiletflush" },
    { 0x7B9193F8, "sndtowerent" },
    { 0xFA674435, "sndtrackers" },
    { 0xA269D53D, "sndtrapfunc" },
    { 0xB208D030, "sndturnoffintrosnapshot" },
    { 0xBA7B948C, "sndupdatevehiclecontext" },
    { 0x7E56B784, "sndvonotify" },
    { 0x71D0CF94, "sndvonotifydtp" },
    { 0xC7EFB1C8, "sndvonotifyplain" },
    { 0xE3168725, "sndvoxoverride" },
    { 0xC98760DA, "sndvoxtriggers" },
    { 0x3D71CAE0, "sndvtolmode" },
    { 0x84A3CA09, "sndwait" },
    { 0x888D5088, "sndwatchactivate" },
    { 0x7D3ED5B7, "sndwatchcombatrobotvoxnotifies" },
    { 0xB610D7E7, "sndwatchexit" },
    { 0xEA9C5303, "sndwatchexplo" },
    { 0x1FFD4D27, "sndwatchforweapswitch" },
    { 0xBF49F6CC, "sndwatchlanding" },
    { 0xF0A6E2B6, "sndweaponpickupoverride" },
    { 0x3F8AA21C, "sndwidowswine" },
    { 0x9B27BEA6, "sndzhdaudio" },
    { 0xA40924B2, "sndzmbfadein" },
    { 0xEC0A10F7, "sndzmblaststand" },
    { 0x74267FB0, "sndzombieentcontext" },
    { 0x6F9498F6, "sndzombiehealth" },
    { 0xC354DB6D, "sndzombiehealthid" },
    { 0xD74CA393, "sneak" },
    { 0xCE07BA48, "sneak_in_hut_trigger" },
    { 0x0BD59F8D, "sneaking" },
    { 0x47BD88C2, "sneaks" },
    { 0x2BCC6738, "sneaky" },
    { 0xE9DCB9E0, "snfxfr" },
    { 0x69C9F3A8, "snicker" },
    { 0x6D113960, "snider_convoy_speed_check" },
    { 0x9CA076DA, "snigl" },
    { 0x724811FA, "snipe" },
    { 0xC9C056F3, "snipe_balls_wait" },
    { 0x2191A7D3, "snipe_balls_watch_ball" },
    { 0xA15FC956, "snipe_challenge_dist_min" },
    { 0x6B1CCA45, "snipe_challenge_dist_min_sq" },
    { 0xACA31F2F, "snipe_enemies" },
    { 0xCEFC6D34, "snipe_geo" },
    { 0x69A81C38, "snipe_the_supply_guy" },
    { 0xEDBC9835, "snipe_vision_adjust" },
    { 0xC1896D25, "snipeanim" },
    { 0x891B15CA, "sniped" },
    { 0x74F8640C, "sniper" },
    { 0x757EECFD, "sniper1" },
    { 0x0572C726, "sniper1_grazed_dialogue" },
    { 0xCCC95B03, "sniper1_killed" },
    { 0x6829C1DA, "sniper1_spawned" },
    { 0x9B816766, "sniper2" },
    { 0x3DEE1422, "sniper2_killed" },
    { 0x8B7CE749, "sniper2_spawned" },
    { 0x2F069543, "sniper_1_kill" },
    { 0x4B2990E2, "sniper_2_kill" },
    { 0xEF595100, "sniper_activity" },
    { 0x0026B09A, "sniper_ai_spawnfuncs" },
    { 0x5D00FA3E, "sniper_aims_and_shoots" },
    { 0xC9A65E5D, "sniper_amb" },
    { 0xACC5FB94, "sniper_anim" },
    { 0xD899DDB2, "sniper_art" },
    { 0x81B8A202, "sniper_battle_intro" },
    { 0x643B87F8, "sniper_battle_start" },
    { 0x9AC4420B, "sniper_battle_started" },
    { 0x6177C936, "sniper_challenge" },
    { 0xB94ACEB5, "sniper_challenge_shot" },
    { 0x79F400B1, "sniper_cover_battle2" },
    { 0x682D6DA1, "sniper_dead" },
    { 0x8E493ABC, "sniper_dead_now" },
    { 0xB0F1C010, "sniper_deaths_vo" },
    { 0x149EC69F, "sniper_dialog" },
    { 0x1D12D37D, "sniper_dialogue" },
    { 0x3C12C6F5, "sniper_duel" },
    { 0x68FFB1C0, "sniper_duel_function" },
    { 0x6926B538, "sniper_endgame_1" },
    { 0xDB2E2473, "sniper_endgame_2" },
    { 0xB52BAA0A, "sniper_endgame_3" },
    { 0xF9E4FFD6, "sniper_endgame_array" },
    { 0x885C27DA, "sniper_escape_initial_secondary_weapon_loadout" },
    { 0xC7566008, "sniper_escape_price_walk" },
    { 0x2332F381, "sniper_event" },
    { 0x245A803A, "sniper_event1" },
    { 0xFE5805D1, "sniper_event2" },
    { 0xD8558B68, "sniper_event3" },
    { 0xE266E447, "sniper_event4" },
    { 0x38CC52EC, "sniper_execute" },
    { 0xB4B684A3, "sniper_exit_vo" },
    { 0x6921BEEF, "sniper_fired_struct" },
    { 0xF46B4C2F, "sniper_foreshadowing" },
    { 0x46E1D0A5, "sniper_fx" },
    { 0xEB8B74CE, "sniper_gib_chance" },
    { 0x2DCF272D, "sniper_guard_damage_fail" },
    { 0x34F9D0BC, "sniper_guy" },
    { 0x72D4137F, "sniper_guys" },
    { 0x6223143C, "sniper_hide_origin" },
    { 0xD8702E36, "sniper_hit_struct" },
    { 0xCC28FA0E, "sniper_intro_kill" },
    { 0xED99DBE6, "sniper_kill_index" },
    { 0x9E767E76, "sniper_leafy_conceal" },
    { 0x728101F5, "sniper_lobby" },
    { 0x82122597, "sniper_logic" },
    { 0x503FAA79, "sniper_looking_max" },
    { 0xE461AD57, "sniper_mason_shot1" },
    { 0x5D34E4BC, "sniper_on_u" },
    { 0x8BF1FDB6, "sniper_on_u_damage_control" },
    { 0xC2E20BF0, "sniper_option" },
    { 0xF5351F35, "sniper_pawn" },
    { 0x24A64092, "sniper_plane_takeoff" },
    { 0x5C5B9FBD, "sniper_proximity_abort" },
    { 0x355985A6, "sniper_rappel_choice_fail" },
    { 0x22CAA6EC, "sniper_rappel_options" },
    { 0x5FBA5093, "sniper_rappel_vo" },
    { 0x709B74DE, "sniper_remove_trigger" },
    { 0xD2D2FC64, "sniper_run_direction" },
    { 0xC252959F, "sniper_scientist" },
    { 0x25728EBE, "sniper_second_shot" },
    { 0xCC762E34, "sniper_shoot" },
    { 0x69C72A33, "sniper_shot" },
    { 0x8F3FB029, "sniper_shot_without_death" },
    { 0x0625BA11, "sniper_spawner" },
    { 0xEC34D2F8, "sniper_spawners" },
    { 0x1E587819, "sniper_stat" },
    { 0xF660EB5F, "sniper_stealth_ai_setup" },
    { 0x42545E85, "sniper_stealth_ai_setupuake" },
    { 0xD560945B, "sniper_stealth_logic" },
    { 0xA57622C0, "sniper_stealth_main" },
    { 0x4BF26DC5, "sniper_support_enemies" },
    { 0x7870C2CE, "sniper_target_points" },
    { 0x6BC0C834, "sniper_target_updated" },
    { 0x124A4DF6, "sniper_text" },
    { 0xFEB85859, "sniper_text_countup" },
    { 0x56604F53, "sniper_text_init" },
    { 0xBE2B51FD, "sniper_think" },
    { 0x828F2323, "sniper_tower_destruction" },
    { 0x95E8E4D9, "sniper_training" },
    { 0x55F59996, "sniper_training_abort_on_stealth_break" },
    { 0xEC433276, "sniper_tree_enemy_update" },
    { 0x9AB436B2, "sniper_tree_kill" },
    { 0x864840C0, "sniper_tree_logic" },
    { 0xA46B4A49, "sniper_tree_player_discovered_logic" },
    { 0xB881EDF4, "sniper_triggers" },
    { 0x00087C04, "sniper_trigs" },
    { 0xB231A0DB, "sniper_victim" },
    { 0xA941627B, "sniper_vo_index" },
    { 0xF4CA4F5F, "sniper_vo_warning" },
    { 0x4FDAC1B7, "sniper_wait_for_fake_death" },
    { 0x94BC6AD2, "sniper_wasout_lasttime" },
    { 0xAF3C8082, "sniperads" },
    { 0x8504688D, "sniperbolt" },
    { 0x78E793EF, "snipercanshoot" },
    { 0x7B2A0F9E, "sniperconfirmdialogue" },
    { 0xBB0B5135, "sniperescape" },
    { 0x9FE39580, "sniperescape_amb" },
    { 0x1246EF57, "sniperescape_anim" },
    { 0xB262FFB7, "sniperescape_art" },
    { 0xEAEC0CC6, "sniperescape_audio" },
    { 0x725A2BE7, "sniperescape_code" },
    { 0xDA36CDBF, "sniperescape_exchange" },
    { 0x2BCF3792, "sniperescape_fastload" },
    { 0x277323B2, "sniperescape_fx" },
    { 0xC4B7B9AA, "sniperescape_main_weapon" },
    { 0x4EC7E8CF, "sniperescape_mcm_abouttobegin" },
    { 0x42EFF87C, "sniperescape_mcm_armflyoff" },
    { 0xBA190F7C, "sniperescape_mcm_bmprange" },
    { 0x02A569C5, "sniperescape_mcm_busheseast" },
    { 0x14F1347D, "sniperescape_mcm_bushesne" },
    { 0x33EED60B, "sniperescape_mcm_bushesnorth" },
    { 0x00CE82BF, "sniperescape_mcm_bushesnw" },
    { 0xDAE71E02, "sniperescape_mcm_bushesse" },
    { 0xF72BBA07, "sniperescape_mcm_busheswest" },
    { 0x7FBC88A7, "sniperescape_mcm_buysometime" },
    { 0xB5AFDF9A, "sniperescape_mcm_choppergetback" },
    { 0xC468FAC3, "sniperescape_mcm_clearshot" },
    { 0xC8AF31CA, "sniperescape_mcm_comingnorth" },
    { 0x6D086732, "sniperescape_mcm_comrpomised" },
    { 0x98FA5C39, "sniperescape_mcm_contactnorth" },
    { 0x35B6B745, "sniperescape_mcm_contactnw" },
    { 0xB07DFE83, "sniperescape_mcm_contactsouth" },
    { 0x3A615DCE, "sniperescape_mcm_contactsw" },
    { 0x8F75950F, "sniperescape_mcm_corioliseffect" },
    { 0x96E20CEA, "sniperescape_mcm_coveryou" },
    { 0x82515570, "sniperescape_mcm_enemiesse" },
    { 0xF0FD05FA, "sniperescape_mcm_eyeonflag" },
    { 0x88872BAB, "sniperescape_mcm_fightback" },
    { 0x89169447, "sniperescape_mcm_getonrifle" },
    { 0x06DD12E7, "sniperescape_mcm_gotanother" },
    { 0x84DD6320, "sniperescape_mcm_gothim" },
    { 0xA22950A6, "sniperescape_mcm_gotone" },
    { 0xC02CBD43, "sniperescape_mcm_greatshot" },
    { 0xE18D024C, "sniperescape_mcm_hesdown" },
    { 0xC2CE2AC5, "sniperescape_mcm_hostilesse" },
    { 0xD66C1174, "sniperescape_mcm_hostileswest" },
    { 0x03E15CCC, "sniperescape_mcm_inthewoods" },
    { 0x306E13AB, "sniperescape_mcm_morebehind" },
    { 0x18086FF4, "sniperescape_mcm_moreeast" },
    { 0x16E2C6DE, "sniperescape_mcm_morefromsouth" },
    { 0x0B01CDF4, "sniperescape_mcm_morene" },
    { 0x9FB1C2FD, "sniperescape_mcm_moresw" },
    { 0x413B7928, "sniperescape_mcm_movementne" },
    { 0x1463AC6D, "sniperescape_mcm_mymark" },
    { 0x0EABAD54, "sniperescape_mcm_oisit" },
    { 0xC2101B47, "sniperescape_mcm_otherside" },
    { 0xB01FFE46, "sniperescape_mcm_positiveid" },
    { 0xF83F2095, "sniperescape_mcm_prepranging" },
    { 0x1039A5DA, "sniperescape_mcm_shortcut" },
    { 0x58A7FB50, "sniperescape_mcm_table" },
    { 0x0D504616, "sniperescape_mcm_taketheshot" },
    { 0x10E5F05F, "sniperescape_mcm_tangodown" },
    { 0xA3DC734B, "sniperescape_mcm_tangosbushess" },
    { 0xD90FEB31, "sniperescape_mcm_tangoseast" },
    { 0x10EABCFB, "sniperescape_mcm_tangosnw" },
    { 0x7EA76A0B, "sniperescape_mcm_tangoswest" },
    { 0x67A49EAE, "sniperescape_mcm_targetneutralized" },
    { 0x2DD4D436, "sniperescape_mcm_targetsse" },
    { 0x2E5F6A08, "sniperescape_mcm_toofarahead" },
    { 0x4B0A73CC, "sniperescape_mcm_whitetruck" },
    { 0x86AE21DD, "sniperescape_mcm_woodseast" },
    { 0x069C3945, "sniperescape_mcm_woodsne" },
    { 0x1200B423, "sniperescape_mcm_woodsnorth" },
    { 0xF2798787, "sniperescape_mcm_woodsnw" },
    { 0xBC3A8BFA, "sniperescape_mcm_woodsse" },
    { 0x3F62FB31, "sniperescape_mcm_woodssouth" },
    { 0xD05D3DB8, "sniperescape_mcm_woodssw" },
    { 0x8C1DE8DF, "sniperescape_mcm_woodswest" },
    { 0xA2E7406C, "sniperescape_rul_amusementpk" },
    { 0xDFB4598E, "sniperescape_rul_cutoffexits" },
    { 0x2D9827CB, "sniperescape_rul_hotelpolissa" },
    { 0xD4407238, "sniperescape_rul_nearpool" },
    { 0x8F364B2F, "sniperescape_wounding" },
    { 0x44F8D8F8, "sniperfire" },
    { 0x602C522E, "sniperfx" },
    { 0x733948A0, "sniperhitcount" },
    { 0xA5FC5FFF, "sniperinterval" },
    { 0x29AA73FF, "sniperkills" },
    { 0x026F95CB, "sniperrange" },
    { 0xA69620C5, "sniperrangeclose" },
    { 0x94DC0ED1, "sniperrifles" },
    { 0x40E5478F, "snipers" },
    { 0xF214D244, "snipers1" },
    { 0x265720B9, "snipers1_ai" },
    { 0x641C417F, "snipers2" },
    { 0x03CA7A34, "snipers2_ai" },
    { 0x80FAEE26, "snipers_kill" },
    { 0x58132E12, "snipers_on_roof" },
    { 0x4B3B6BAD, "snipersactive" },
    { 0x387F7421, "snipershotcount" },
    { 0x2FFBBC5A, "snipersoundsource" },
    { 0x7C79EE37, "snipertarget" },
    { 0x5F29D8FF, "sniperteam" },
    { 0xAF0B8FE2, "snipervolume" },
    { 0x4E7C2F22, "snipervonotify" },
    { 0xDD36970B, "sniping" },
    { 0xC3104979, "sniping_timer" },
    { 0xACE63049, "snipping" },
    { 0x1DCF95D0, "snode" },
    { 0x76FBFFD1, "snodestowarpto" },
    { 0xFA9E4F11, "snoff" },
    { 0xA47C4BD7, "snotify" },
    { 0xA7C07120, "snotifystring" },
    { 0x9E0BB4A4, "snow" },
    { 0x646A30BF, "snow_ambush" },
    { 0xF6FDD9CD, "snow_ambushers" },
    { 0x75164647, "snow_drift_death" },
    { 0x499B4F43, "snow_drift_death_guy" },
    { 0x3806F5DB, "snow_fade_notify" },
    { 0x8CCD3F84, "snow_fall" },
    { 0x48D37D87, "snow_fall_monitor" },
    { 0xBA989433, "snow_falling_tree" },
    { 0x1845C9B3, "snow_hide" },
    { 0x48F86869, "snow_hide_main" },
    { 0xD3E5D0AE, "snow_left_splash" },
    { 0x3A03C14D, "snow_overlay" },
    { 0xE959FC3F, "snow_overlay_off" },
    { 0x5BCC024B, "snow_overlay_on" },
    { 0x343BA6D3, "snow_right_splash" },
    { 0xECC03AA6, "snow_splash_large" },
    { 0xDE63DAE0, "snowcat" },
    { 0xF3481848, "snowcat_alerted" },
    { 0xCB5A4CB7, "snowcat_area_reached" },
    { 0x401EBD44, "snowcat_attach_crate" },
    { 0x90410402, "snowcat_detach_crate" },
    { 0x176BE0AC, "snowcat_drag_vehicle" },
    { 0xB64FBFCA, "snowcat_dragovich" },
    { 0x07E45ADF, "snowcat_driver_setup" },
    { 0x3A73AAB7, "snowcat_exit" },
    { 0xE94BC6B1, "snowcat_guy1" },
    { 0x75162569, "snowcat_guys_exited" },
    { 0x245F73CD, "snowcat_krav" },
    { 0x3ACBEC70, "snowcat_krav_vehicle" },
    { 0xECC765ED, "snowcat_nevski" },
    { 0x3C692AEC, "snowcat_npc1_vehicle" },
    { 0x8C479A33, "snowcat_npc2_vehicle" },
    { 0x71263420, "snowcat_passenger_cleanup" },
    { 0xFFCEA66B, "snowcat_passenger_setup" },
    { 0xAC388AEB, "snowcat_petrenko" },
    { 0x2697D4F9, "snowcat_player_idle" },
    { 0xEE28A9CD, "snowcat_player_vehicle" },
    { 0xB8AEFB15, "snowcat_playintro" },
    { 0x85878ABC, "snowcat_react" },
    { 0x8829CFC0, "snowcat_sequence" },
    { 0xE2F8F9BE, "snowcat_set_alert" },
    { 0x6E56E71C, "snowcat_smoker" },
    { 0x49DEE2AB, "snowcat_sniperguy" },
    { 0x0F4B38A2, "snowcat_spawn_crowd" },
    { 0xFFAFCF85, "snowcat_static_crate" },
    { 0x89AFF18B, "snowcats" },
    { 0x2AAFB917, "snowfall" },
    { 0x2D989A57, "snowguy_sequence" },
    { 0xFF32D73C, "snowguys" },
    { 0x39C4E996, "snowmobileshoottimer" },
    { 0x35E010D8, "snownode" },
    { 0x06345EBD, "snowy" },
    { 0xD5331237, "snowy_enter_vignette" },
    { 0x792582A1, "snowy_exit_vignette" },
    { 0x7AAAA933, "snowy_level_concrete_surface_type" },
    { 0x73C2ADEB, "snowy_level_snow_surface_type" },
    { 0x348D6369, "snowy_level_surface_type_for_screen_fx" },
    { 0xA461FDAD, "snowy_level_surface_type_for_tread_fx" },
    { 0x387541BA, "snp_desert" },
    { 0x3BC615D9, "snpctype" },
    { 0x63E21181, "snpov" },
    { 0xC940DC84, "snsc" },
    { 0xB2C16D9B, "snuff" },
    { 0x2DB8C89F, "snumber" },
    { 0x42C3BACD, "snwak" },
    { 0x06B7C780, "snyder" },
    { 0x5D0ED4B3, "so" },
    { 0xD1312F39, "so0" },
    { 0x1D36240B, "so2" },
    { 0xF733A9A2, "so3" },
    { 0x43389E74, "so5" },
    { 0x3CE25972, "so_airsupport_incoming" },
    { 0x9AAB0157, "so_can_toggle" },
    { 0xA29A35DE, "so_claymore_activated" },
    { 0x4041ED0F, "so_claymore_trig_dot" },
    { 0x38FF7875, "so_cmp_afghanistan" },
    { 0xE4E94BF2, "so_cmp_afghanistan_fx" },
    { 0x0D452CF2, "so_create_hud_item" },
    { 0x8CC46DC7, "so_create_hud_item_delay_draw" },
    { 0x8A3C9676, "so_hud_can_show" },
    { 0x90D47AC9, "so_hud_can_toggle" },
    { 0xF688543D, "so_hud_pulse_alarm" },
    { 0xE9D7FD4A, "so_hud_pulse_close" },
    { 0x40C6EFB2, "so_hud_pulse_create" },
    { 0xF700B5CD, "so_hud_pulse_default" },
    { 0x4A74841E, "so_hud_pulse_disabled" },
    { 0xA93401B0, "so_hud_pulse_failure" },
    { 0x5731FE68, "so_hud_pulse_init" },
    { 0x5350C7F0, "so_hud_pulse_loop" },
    { 0x21302D7E, "so_hud_pulse_single" },
    { 0x5064E3C5, "so_hud_pulse_smart" },
    { 0x0F9B391E, "so_hud_pulse_stop" },
    { 0xD2E7344F, "so_hud_pulse_success" },
    { 0xB810293A, "so_hud_pulse_warning" },
    { 0xB28FB5E1, "so_hud_show_time" },
    { 0x88D9BAFE, "so_hud_xpos" },
    { 0xBE993BC9, "so_hud_ypos" },
    { 0xF7AC158E, "so_infohud_toggle_state" },
    { 0x3AE2754E, "so_interrogationtest_frontend" },
    { 0x5529EA47, "so_kill_ai" },
    { 0x41C57443, "so_mine_last_detonate_time" },
    { 0xA407BC77, "so_mine_locs" },
    { 0xC613F8F2, "so_mines" },
    { 0xEEC64910, "so_narrative1_frontend" },
    { 0x20618581, "so_narrative1_frontend_amb" },
    { 0xDC328D05, "so_narrative2_frontend" },
    { 0x74F106B0, "so_narrative2_frontend_amb" },
    { 0x25D183A7, "so_narrative2_frontend_anim" },
    { 0x855298AE, "so_narrative3_frontend" },
    { 0x663CCA8F, "so_narrative3_frontend_amb" },
    { 0x1EBCD2EB, "so_narrative4_frontend" },
    { 0xAF48FCCE, "so_narrative4_frontend_amb" },
    { 0xBD360F9C, "so_narrative5_frontend" },
    { 0xEC64D0CD, "so_narrative5_frontend_amb" },
    { 0x63552C81, "so_narrative6_frontend" },
    { 0x7E765FCC, "so_narrative6_frontend_amb" },
    { 0x493934BB, "so_old_goalradius" },
    { 0x68732F76, "so_outro_frontend" },
    { 0xC46050F7, "so_outro_frontend_amb" },
    { 0xA7C4CCA2, "so_remove_hud_item" },
    { 0xB75423AC, "so_rts_afghanistan" },
    { 0xC3AF283D, "so_rts_afghanistan_amb" },
    { 0xD2A2A792, "so_rts_afghanistan_art" },
    { 0xA453F005, "so_rts_afghanistan_fx" },
    { 0x0E7B987F, "so_rts_afghanistan_s1" },
    { 0xF208D4B0, "so_rts_mp_dockside" },
    { 0x724DF9E1, "so_rts_mp_dockside_amb" },
    { 0xCA7748F6, "so_rts_mp_dockside_art" },
    { 0x7AFAA741, "so_rts_mp_dockside_fx" },
    { 0xBFD0CDD3, "so_rts_mp_dockside_s1" },
    { 0x85603162, "so_rts_mp_drone" },
    { 0xDA179003, "so_rts_mp_drone_amb" },
    { 0x9DE17110, "so_rts_mp_drone_art" },
    { 0x3D524F67, "so_rts_mp_drone_fx" },
    { 0xA779F7E1, "so_rts_mp_drone_s1" },
    { 0xB4A6D7AE, "so_rts_mp_overflow" },
    { 0x1A55F98F, "so_rts_mp_overflow_amb" },
    { 0xD74D60AC, "so_rts_mp_overflow_art" },
    { 0xBB281F7B, "so_rts_mp_overflow_fx" },
    { 0x9FD69F7D, "so_rts_mp_overflow_s1" },
    { 0x81A57273, "so_rts_mp_socotra" },
    { 0x0CD1DAF6, "so_rts_mp_socotra_amb" },
    { 0x714D5D65, "so_rts_mp_socotra_art" },
    { 0xA7D91C6C, "so_rts_mp_socotra_fx" },
    { 0x683001CA, "so_rts_mp_socotra_s1" },
    { 0x7BFAA82E, "so_survival_mp_dockside_amb" },
    { 0x832D59D5, "so_tut_mp_drone_fx" },
    { 0x911D332F, "so_tut_mp_drone_s1" },
    { 0xE1451DA0, "so_waiting_for_players" },
    { 0x90B6205C, "so_war_dockside_audio" },
    { 0xEC187F7B, "so_war_dockside_support" },
    { 0x5A9FBC11, "so_war_mp_dockside_war_amb" },
    { 0xD08D5BE6, "so_war_mp_dockside_war_art" },
    { 0x619E7DF1, "so_war_mp_dockside_war_fx" },
    { 0x02AC73A3, "so_war_mp_dockside_war_s1" },
    { 0xE9B129FB, "soaap" },
    { 0x438429F0, "soap" },
    { 0x3C6FE33B, "sob" },
    { 0xB66914CD, "sobbing" },
    { 0x166D68D2, "soc" },
    { 0xC508C9F5, "society" },
    { 0x3CD36732, "socket" },
    { 0x38C699B3, "socoatra_ai_takeover_trigger" },
    { 0x1392BF2C, "socotra" },
    { 0x92F090C1, "socotra_ai_takeover_off" },
    { 0x9ECB5CB5, "socotra_ai_takeover_on" },
    { 0x4547C202, "socotra_climbup_intro" },
    { 0x07C67CE4, "socotra_clockwatch" },
    { 0xD0C031A4, "socotra_fade_out" },
    { 0x6F69F1E4, "socotra_floorwatch" },
    { 0x47675854, "socotra_geo_changes" },
    { 0xF712CD82, "socotra_heavy_guy_unload" },
    { 0x6991C52C, "socotra_heavy_squad_spawned" },
    { 0x3981D025, "socotra_karama_bodyguardspawn" },
    { 0xE16607EF, "socotra_karama_spawnwatch" },
    { 0xCAE7A88A, "socotra_karma_damagepulse" },
    { 0x7079EB28, "socotra_karma_damagewatch" },
    { 0x38B651DE, "socotra_karma_died" },
    { 0x5E2F9D52, "socotra_karma_hackallmechs" },
    { 0x3E77D23C, "socotra_karma_magic_circle" },
    { 0x4785A143, "socotra_karma_playedasplayerwatch" },
    { 0x17CBDB99, "socotra_karma_rescued" },
    { 0x9FEF2550, "socotra_karma_roomspawninit" },
    { 0x660D3D5F, "socotra_karma_shield" },
    { 0x5B3F4A1A, "socotra_karma_slice" },
    { 0x29BAA001, "socotra_karma_spawn" },
    { 0x63227D1D, "socotra_level_player_startfps" },
    { 0x5C39D48D, "socotra_level_precache" },
    { 0xA81D6885, "socotra_level_scenario_one" },
    { 0xA3AEB668, "socotra_level_scenario_one_registerevents" },
    { 0xE2B15C9D, "socotra_level_setup" },
    { 0x40A04B9F, "socotra_mission_complete" },
    { 0x9218E106, "socotra_mission_complete_s1" },
    { 0x21EC358B, "socotra_nextavailunit" },
    { 0x1613FB85, "socotra_objective_karma_watch" },
    { 0xEC7DA7DB, "socotra_orangeobjectivewatch" },
    { 0x20E8581C, "socotra_outro_anim" },
    { 0xB789B2C7, "socotra_outro_dialog" },
    { 0x10803BE3, "socotra_outro_fail" },
    { 0x7BFFCE14, "socotra_outro_success" },
    { 0x54657BC3, "socotra_pick_safehouses" },
    { 0x65724E22, "socotra_player_oobwatch" },
    { 0x60274DB1, "socotra_poi_inf_spawn" },
    { 0xF88ACCEE, "socotra_quad_spawn" },
    { 0xABCBA116, "socotra_rooftopcleanup" },
    { 0xB9A526A8, "socotra_rooftopdeath" },
    { 0x59F94540, "socotra_rooftopinit" },
    { 0x4771E717, "socotra_setstart" },
    { 0x669728E3, "socotra_setup_devgui" },
    { 0xD4D2B76D, "socotra_startintro" },
    { 0x287CC2AA, "socotra_startoutro" },
    { 0x9C0CDC68, "socotra_vtol_watch" },
    { 0x23008231, "socotra_watch_devgui" },
    { 0x6B0663BE, "socotraairheightclamp" },
    { 0x9100A96E, "socotraairnada" },
    { 0x5E715833, "socotraairsuperiorityhandlegunnertarget" },
    { 0x875FDF4F, "socotraairsuperiorityplayermove" },
    { 0x8BC009C0, "socotraairsuperiorityspawn" },
    { 0xDF5FC525, "socotraairsuperioritytakeoverwatch" },
    { 0x54D8DCE9, "socotraairsuperioritythink" },
    { 0x365F5441, "socotracodespawner" },
    { 0xF34D9D93, "socotragopath" },
    { 0x0E5E68D8, "socotrasafehousehighlightwatch" },
    { 0x4274938E, "socotravoxalloc" },
    { 0xE368DA5F, "socotravoxlist" },
    { 0xA8A90CA2, "soct" },
    { 0x290B92A6, "soct_anim" },
    { 0x2A5DBBBA, "soct_animated_damage_states_think" },
    { 0xAD040A00, "soct_behind_the_player_logic" },
    { 0xA78266AA, "soct_blowup_on_script_noteworthy" },
    { 0x87410D7A, "soct_boost" },
    { 0xCD4161A7, "soct_damage_fx_hi_1" },
    { 0x5B39F26C, "soct_damage_fx_hi_2" },
    { 0x813C6CD5, "soct_damage_fx_hi_3" },
    { 0xA8C45374, "soct_damage_fx_low_1" },
    { 0x1ACBC2AF, "soct_damage_fx_low_2" },
    { 0xF4C94846, "soct_damage_fx_low_3" },
    { 0x6E6F9030, "soct_damage_fx_med_1" },
    { 0xE076FF6B, "soct_damage_fx_med_2" },
    { 0xBA748502, "soct_damage_fx_med_3" },
    { 0xCFD01B2B, "soct_damaged_fx" },
    { 0x5108BB5B, "soct_death_challenge" },
    { 0x63E7A809, "soct_death_launch" },
    { 0x2DC34A73, "soct_driving_visionset" },
    { 0x8D2E6DA6, "soct_explosion" },
    { 0x17F777C1, "soct_hanger1_chaser_spawner" },
    { 0xC3C745C0, "soct_hanger2_chaser_spawner" },
    { 0x7986E2C5, "soct_hanger_blocker1_spawner" },
    { 0xE49F1DC6, "soct_hanger_blocker2_spawner" },
    { 0x570A629B, "soct_has_boost" },
    { 0x5FDC2C90, "soct_hotel_smash_damage" },
    { 0x7F04262B, "soct_in_front_of_player_logic" },
    { 0x8FA29298, "soct_intro_change_speed" },
    { 0xB8BC625D, "soct_intro_chicken" },
    { 0xD7026844, "soct_intro_chicken_cleanup" },
    { 0x485D8EE3, "soct_intro_chicken_left" },
    { 0xB9654756, "soct_intro_chicken_right" },
    { 0xC50E145D, "soct_intro_ready" },
    { 0x02F99F31, "soct_kill" },
    { 0x667FC375, "soct_market_inside_trigger" },
    { 0x42CD1C94, "soct_market_outside_trigger" },
    { 0xB82E49E0, "soct_pipes_boss_damage" },
    { 0x42C4EE26, "soct_player_attacker_damage_callback" },
    { 0xFFD96A03, "soct_player_collision" },
    { 0x34A81FA9, "soct_player_env_damage_scale" },
    { 0x4D391399, "soct_player_rams_one_damage" },
    { 0x7DF2DC32, "soct_post_broken_freeway_trigger" },
    { 0xEC3DC7CA, "soct_proximity_fail_think" },
    { 0x707E9892, "soct_rams_player_damage" },
    { 0xB7CA0614, "soct_setup" },
    { 0x5B8F93DF, "soct_slowmo_on_collision" },
    { 0x7A9FFB45, "soct_soct_kill" },
    { 0x3B3E2014, "soct_speed_penalty" },
    { 0xC7127531, "soct_stop_shooting_on_script_noteworthy" },
    { 0x830F5AC8, "soct_swap_to_damged_version" },
    { 0x02AC90AC, "soct_swap_to_dead_version" },
    { 0xA86BB18F, "soct_to_drone_setup" },
    { 0x92110344, "soct_tree_smash_damage" },
    { 0x313E23F7, "soct_walkway_ai_logic" },
    { 0x78999BD4, "soct_walkway_ai_spawn" },
    { 0x10CC866F, "soct_warning_message" },
    { 0x671D07B8, "soct_wheels_down" },
    { 0x290A2C93, "soct_wheels_up" },
    { 0x1CBF9011, "soct_world_collision_damage_scale" },
    { 0xDEE2A96D, "socts" },
    { 0x8874D80D, "sod" },
    { 0xF69E54EE, "soda" },
    { 0xC882FF63, "soemone" },
    { 0x75A8F004, "sofa" },
    { 0x9EC7F061, "sofa_guard_ragdoll_death" },
    { 0x63C92759, "soft" },
    { 0xB04F4BFC, "soften" },
    { 0x821D606C, "softsighttest" },
    { 0xF5647DBA, "software" },
    { 0xAE775276, "sog" },
    { 0x11569A31, "sog_spas_guaranteed" },
    { 0x42883414, "soil" },
    { 0xC566D750, "solar" },
    { 0x3D782662, "solarmusicduck" },
    { 0x3A471E04, "solarmusicduck2" },
    { 0x9897C538, "solarmusicduck2_1" },
    { 0x0A9F3473, "solarmusicduck2_2" },
    { 0x4E459F55, "soldier" },
    { 0x201DEA4D, "soldier2" },
    { 0x75A0CD26, "soldier_briggs_convo" },
    { 0x64510671, "soldier_goal" },
    { 0x563E7415, "soldier_is_near" },
    { 0xB6D10368, "soldier_names" },
    { 0xBD1BE2AC, "soldier_node" },
    { 0xC5B1712A, "soldier_shoots_hudson" },
    { 0xBB08EFE8, "soldier_stance" },
    { 0x797CD5A4, "soldiers" },
    { 0x5E5274AF, "soldiertypeset" },
    { 0x33A623B7, "sole_cleanup" },
    { 0x374B238F, "solely" },
    { 0x4083A98E, "solid" },
    { 0x22CF7143, "solid1" },
    { 0xB0C80208, "solid2" },
    { 0x3A59985F, "solid_camo_desert_nevada" },
    { 0x9DE81994, "solid_camo_desert_sahara" },
    { 0x32881149, "solid_camo_dusty" },
    { 0xD80321E9, "solid_camo_ice" },
    { 0x0240852B, "solid_camo_jungle_erdl" },
    { 0x12A5585B, "solid_camo_jungle_tiger" },
    { 0xF5C69475, "solid_camo_od" },
    { 0x92512541, "solid_camo_urban_german" },
    { 0xC76A74F6, "solid_camo_urban_warsaw" },
    { 0x9D71F80B, "solid_camo_winter_siberia" },
    { 0x0438E9D4, "solid_camo_winter_yukon" },
    { 0x3DEA1AB0, "solid_camo_woodland" },
    { 0x984123C7, "solid_camo_woodland_flora" },
    { 0x212C2211, "solid_vec" },
    { 0x2BC5C9D7, "solider" },
    { 0x05D62B8E, "soliders" },
    { 0x562BE231, "solids" },
    { 0xD8D7C0DC, "soliloquy" },
    { 0x2C4C75E7, "soliloquy_convos" },
    { 0xCED7D10D, "soliloquy_vo_done" },
    { 0xB93A49D8, "solo" },
    { 0xE8FD191B, "solo_collectible" },
    { 0xC47BF847, "solo_death" },
    { 0x96CD3281, "solo_destroy_lives_hud" },
    { 0x6CE17236, "solo_disable_quickrevive" },
    { 0x769D3B6A, "solo_fires" },
    { 0xFAAC7D6E, "solo_firing" },
    { 0x2AF2A7DD, "solo_game_free_player_quickrevive" },
    { 0x186010B5, "solo_has_lives" },
    { 0xC98F7AA2, "solo_last_stand" },
    { 0x74F45BAE, "solo_lives_given" },
    { 0x2D92A626, "solo_mode" },
    { 0xA094BBD8, "solo_power_up_hud" },
    { 0x2F815007, "solo_powerup_hud" },
    { 0x880B10DD, "solo_powerup_hud_array" },
    { 0x4786979F, "solo_powerup_hud_cover" },
    { 0x4215B4EA, "solo_powerup_hud_overlay" },
    { 0xF9D593DD, "solo_respawn" },
    { 0xC092D2CC, "solo_revive_buy_trigger_move" },
    { 0x5522FAA5, "solo_revive_buy_trigger_move_trigger" },
    { 0xAF9401D7, "solo_revive_exit" },
    { 0x59CCC4F4, "solo_revive_exit_pos" },
    { 0x84C54257, "solo_revive_expire_func" },
    { 0xF1557A11, "solo_revive_init" },
    { 0x2840AC64, "solo_revive_time" },
    { 0x5ED9655D, "solo_rubble" },
    { 0xC2B451E7, "solo_rubble_deleted" },
    { 0x30A60846, "solo_rubble_vignette" },
    { 0x056022F1, "solo_rumble_spawner" },
    { 0xC3898B23, "solo_set_pacifist" },
    { 0x3286DCE2, "solo_should_restart" },
    { 0xFA235C25, "solo_stat" },
    { 0x75381AC5, "solo_tombstone_removal" },
    { 0x0BC5C7C0, "soloing" },
    { 0x373BC041, "sololb_build_number" },
    { 0xEF954508, "solution" },
    { 0x818C2723, "solutions" },
    { 0x7AFD79E6, "solve" },
    { 0x5AC18196, "solved" },
    { 0xFCDCC419, "solves" },
    { 0xE249ACE9, "some" },
    { 0x52A6F1DF, "some_alive" },
    { 0x26152BF4, "some_guys" },
    { 0xC7EE8FA1, "somebody" },
    { 0xA1D5CCAD, "someday" },
    { 0x745454C7, "someflag" },
    { 0x49397F05, "somehow" },
    { 0x1D7EEC43, "someone" },
    { 0x51943AE5, "someone_completed_quest_cycle" },
    { 0x07220325, "someone_has_visited_nml" },
    { 0x3F68504A, "someone_inside" },
    { 0x2D3B324B, "someone_is_close" },
    { 0xD72E8539, "someone_still_touching_elevator" },
    { 0xBE472E11, "someone_touched_controls" },
    { 0x14189312, "someone_touching_elevator" },
    { 0xDECE9494, "someonebecominghuman" },
    { 0xE2715B8C, "someoneoneachteam" },
    { 0x451FE261, "somepoint" },
    { 0xE54CB293, "something" },
    { 0x51D525C2, "somethings" },
    { 0x5E906BBE, "sometime" },
    { 0x166CAFA1, "sometimes" },
    { 0x230154DB, "somewhat" },
    { 0xB47E95CE, "somewhere" },
    { 0x9435BA08, "somone" },
    { 0x69E6A780, "somthing" },
    { 0xECF39406, "somtimes" },
    { 0x4E722E7D, "somwhere" },
    { 0x048DA027, "son" },
    { 0x6A806A36, "sonar" },
    { 0x96A1A23B, "sonar_fade" },
    { 0x92A1227B, "sonar_fade_steps" },
    { 0xD2C7EC29, "sonar_fade_time" },
    { 0x9CF635A5, "sonar_filter_id" },
    { 0xDF772956, "sonar_forced" },
    { 0x6F791A02, "sonar_keep_on" },
    { 0xE71B9ACC, "sonar_off" },
    { 0x5643C204, "sonar_off_nofity" },
    { 0x41107BF6, "sonar_on" },
    { 0x8BF87C6A, "sonar_on_nofity" },
    { 0xFB327235, "sonar_onlyenemy" },
    { 0x4C79E154, "sonar_turning_on" },
    { 0x057D8179, "sonar_vision" },
    { 0x30D06C7D, "sonarent" },
    { 0x30F5F6F9, "sonarteam" },
    { 0x20D9958A, "song" },
    { 0x79C70156, "song_player" },
    { 0x7A138B17, "sonic" },
    { 0x76C4F430, "sonic_zombie_spawners" },
    { 0x5794A926, "sonicboom" },
    { 0x1DDCECBA, "soniczombiecount" },
    { 0x07032897, "soniczombiesenabled" },
    { 0x58BBD89E, "sons" },
    { 0x6FEB7304, "soon" },
    { 0x1BA4BD81, "sooner" },
    { 0x76F3E57F, "sopened" },
    { 0x6D0B22F5, "sophisticated" },
    { 0x07A2C70F, "sopt" },
    { 0x7EA7726C, "sore" },
    { 0x28448838, "sorry" },
    { 0x04D19365, "sort" },
    { 0xF324BBB9, "sort_ai_by_life_time" },
    { 0x7EAF50A2, "sort_arrays_small_to_large" },
    { 0x5864DCCF, "sort_by_distance" },
    { 0xD0E071F4, "sort_by_score" },
    { 0x6271B605, "sort_by_script_int" },
    { 0x785B4F18, "sort_by_startingpos" },
    { 0x0DD7191D, "sort_by_value" },
    { 0x9707D8F0, "sort_function" },
    { 0xC4C66FCD, "sort_greatest" },
    { 0xB59B9E1B, "sort_high_to_low" },
    { 0xBC109AE8, "sort_holy_array" },
    { 0x2F8999B2, "sort_ints_low_to_high" },
    { 0x93E8C75B, "sort_least" },
    { 0xA078218F, "sort_nodes_by_script_int" },
    { 0x6507D3A7, "sort_score_board" },
    { 0xDAA854A3, "sort_vehicles" },
    { 0x9537DAB6, "sorta" },
    { 0x1FF7C830, "sortarraybyclosest" },
    { 0x68B1348E, "sortarraybyfurthest" },
    { 0xD1BE91D2, "sortcurve" },
    { 0x1658C41D, "sortdata" },
    { 0x15439307, "sortdeadplayers" },
    { 0xC85AAE52, "sorted" },
    { 0x7FB94270, "sorted_array" },
    { 0x785BE5F5, "sorted_array_of_arrays" },
    { 0x7BA65655, "sorted_guys" },
    { 0x4067536F, "sorted_name_keys" },
    { 0x3608446E, "sorted_prio_keys" },
    { 0x73F8AF7D, "sortedarray" },
    { 0xDEE56B04, "sorteddotprod" },
    { 0xA560A30B, "sortedkillstreaks" },
    { 0x0BCDB548, "sortedmemberlist" },
    { 0xD7CC1D23, "sortedpoints" },
    { 0x715585EA, "sortedpotentialtargets" },
    { 0x1E160B9B, "sortedunits" },
    { 0x8449229A, "sortflags" },
    { 0x91DFFDC7, "sortie" },
    { 0x02DB4CD1, "sortie_wait" },
    { 0x7856C717, "sortindex" },
    { 0x50FF9EC3, "sorting" },
    { 0x137D3A38, "sortnodetransitionangles" },
    { 0x52207EE5, "sortplayersbylivesdescending" },
    { 0xA95A8C74, "sorts" },
    { 0x76950F62, "sos" },
    { 0x78F7FE08, "sotherflag" },
    { 0x59223616, "soudn" },
    { 0x8368F990, "soul" },
    { 0x6C130B53, "soul_absorbed" },
    { 0xE2C0AF5D, "soul_burst_range" },
    { 0x25F39909, "soul_catcher" },
    { 0x9B6ED4A4, "soul_catcher_check" },
    { 0xBC205A86, "soul_catcher_clip" },
    { 0x94B6E7B7, "soul_catcher_cooldown" },
    { 0xAF29B9AB, "soul_catcher_state_manager" },
    { 0xB45CEC00, "soul_catchers" },
    { 0x20799F95, "soul_catchers_charged" },
    { 0xC98AB416, "soul_catchers_vol" },
    { 0xB5E96222, "soul_pull" },
    { 0x790A726E, "soul_received" },
    { 0x4E43C7A0, "soul_runner_test" },
    { 0xD6837EDC, "soul_spark_end" },
    { 0x538468B2, "soul_swap" },
    { 0xB9D87D5F, "souless" },
    { 0x82561E3B, "soulless" },
    { 0x406FF37B, "souls" },
    { 0xD88CCD3B, "souls_received" },
    { 0x93B50D82, "sound" },
    { 0x0D8FCA5F, "sound1" },
    { 0x9B885B24, "sound2" },
    { 0x41A20268, "sound_alarm" },
    { 0x9B35E98F, "sound_alias" },
    { 0x1F03D844, "sound_alias1" },
    { 0x910B477F, "sound_alias2" },
    { 0x5035F8EF, "sound_alias_available" },
    { 0x149F923E, "sound_armed" },
    { 0xF0AC27FF, "sound_armed_loop" },
    { 0xBABDE2BE, "sound_attractors" },
    { 0x8265FD4C, "sound_bg" },
    { 0x9E124336, "sound_category_init" },
    { 0xC1335948, "sound_complete" },
    { 0xB41CC2CE, "sound_count" },
    { 0x651CD4AA, "sound_damage_player" },
    { 0xD9CE2B16, "sound_damage_player_updated" },
    { 0xB16DBF85, "sound_dialog" },
    { 0x88EC06C9, "sound_dialog_available" },
    { 0x3D1F3795, "sound_done" },
    { 0x5CEA36F2, "sound_done_vox_plr_1_respond_richtofen_0" },
    { 0x82ECB15B, "sound_done_vox_plr_1_respond_richtofen_1" },
    { 0x10E54220, "sound_done_vox_plr_1_respond_richtofen_2" },
    { 0x98F570B7, "sound_dummy" },
    { 0x54C7D084, "sound_dummy_2" },
    { 0x053F4D2A, "sound_effect" },
    { 0x70D0ED5B, "sound_effect_play" },
    { 0x3711DCB1, "sound_elevator2_ent_1" },
    { 0x1D2ABC19, "sound_elevator_ent_1" },
    { 0x432D3682, "sound_elevator_ent_2" },
    { 0xE3F4FEC1, "sound_emitter" },
    { 0xA1E2D5E8, "sound_emitter_single" },
    { 0x092EA6E8, "sound_emitters" },
    { 0x45E40A78, "sound_ent" },
    { 0x43D74EC1, "sound_ent1" },
    { 0x69D9C92A, "sound_ent2" },
    { 0x8FDC4393, "sound_ent3" },
    { 0xDFCBFB84, "sound_ent_1" },
    { 0x51D36ABF, "sound_ent_2" },
    { 0xBF5507D4, "sound_ent_a" },
    { 0x315C770F, "sound_ent_b" },
    { 0x7F73DB76, "sound_ent_back" },
    { 0x19C64102, "sound_ent_back_water" },
    { 0xA603F8D9, "sound_ent_cleanup" },
    { 0x844C2B34, "sound_ent_commotion" },
    { 0x3654378E, "sound_ent_delete" },
    { 0x1311D28C, "sound_ent_jet" },
    { 0x7A876D73, "sound_ent_screen_a" },
    { 0x087FFE38, "sound_ent_screen_b" },
    { 0x4BBA2CCE, "sound_ent_side_left" },
    { 0x3398B685, "sound_ent_side_right" },
    { 0xE2B21066, "sound_ent_sink" },
    { 0x5532C0A5, "sound_ent_smoov" },
    { 0x105FB484, "sound_ent_walla" },
    { 0x92E768FC, "sound_entity" },
    { 0xC879764E, "sound_entmg_delete" },
    { 0x107ADDD3, "sound_ents" },
    { 0xA7E633A1, "sound_exists" },
    { 0xF9930526, "sound_fade_out" },
    { 0x57FE1D2D, "sound_fade_out_snapshot" },
    { 0x7E529866, "sound_fade_snapshot" },
    { 0x3449468F, "sound_fade_then_delete" },
    { 0xCA421941, "sound_fade_then_delete_nodes" },
    { 0x62DE27F2, "sound_fake_reload" },
    { 0xB73A40FF, "sound_finished" },
    { 0x330113CE, "sound_flash_loop" },
    { 0xFFEC0318, "sound_flash_start" },
    { 0x159D2484, "sound_flash_stop" },
    { 0xF6ABA3F1, "sound_follow_plane" },
    { 0x054A927A, "sound_id_1" },
    { 0xDF481811, "sound_id_2" },
    { 0x347417A7, "sound_id_42" },
    { 0xA0AC63BD, "sound_ids" },
    { 0x4BBF2379, "sound_length" },
    { 0x6C615F3E, "sound_linkto" },
    { 0x3201411D, "sound_loop_enabled" },
    { 0x9F61D148, "sound_loopers_start" },
    { 0x84461723, "sound_movie_snapshot_alloff_but_mid_start" },
    { 0x0FF5232B, "sound_movie_snapshot_start" },
    { 0x75643599, "sound_movie_snapshot_stop" },
    { 0x42294DD0, "sound_name" },
    { 0x47C6DB32, "sound_notify" },
    { 0x8301637A, "sound_notify_1" },
    { 0x5CFEE911, "sound_notify_2" },
    { 0x36FC6EA8, "sound_notify_3" },
    { 0x410DC787, "sound_notify_4" },
    { 0x1B0B4D1E, "sound_notify_5" },
    { 0xF01A50F8, "sound_offset" },
    { 0x252AA012, "sound_on" },
    { 0xA66F2065, "sound_org" },
    { 0x6E0B7ABE, "sound_orig" },
    { 0x968FF70F, "sound_origin" },
    { 0xBFCE87FF, "sound_origin2" },
    { 0x2A634089, "sound_pickup" },
    { 0xBFA085CE, "sound_pip_ent" },
    { 0xDBD899A0, "sound_pit_move" },
    { 0x78E5CD15, "sound_pitch" },
    { 0x3FE7D120, "sound_planes" },
    { 0x6CFEAA88, "sound_played" },
    { 0x5832C80D, "sound_playloop_sound" },
    { 0x768730A1, "sound_pos" },
    { 0x648950FC, "sound_ref" },
    { 0x07395BD3, "sound_respawn" },
    { 0xDEC96FC9, "sound_ring_move" },
    { 0xC6A8E344, "sound_run" },
    { 0x4F3127FB, "sound_set" },
    { 0x10A46F16, "sound_shared" },
    { 0xEF21205D, "sound_shock_tabun_loop" },
    { 0xF6B74BA9, "sound_shock_tabun_start" },
    { 0xD0B3E0F3, "sound_shock_tabun_stop" },
    { 0xFEEB8965, "sound_smoke_loop" },
    { 0x4129B4F1, "sound_smoke_start" },
    { 0xE789BC1B, "sound_smoke_stop" },
    { 0x07DC283F, "sound_src_ref" },
    { 0x5FDB7779, "sound_stop" },
    { 0x36E9B7F6, "sound_struct" },
    { 0xF55D3346, "sound_subway_lights" },
    { 0xDD81BC28, "sound_tabun_loop" },
    { 0xDE34DA16, "sound_tabun_start" },
    { 0x738B6756, "sound_tabun_stop" },
    { 0xD92DC37B, "sound_tag" },
    { 0x975EE26A, "sound_tag_dupe" },
    { 0x9DBFF8AC, "sound_tag_dupped" },
    { 0x1967364A, "sound_target" },
    { 0xFD91A3DD, "sound_timescale_chopper_event" },
    { 0x1A6F5523, "sound_to_play" },
    { 0x7E300FA9, "sound_type" },
    { 0xECF69160, "sound_var" },
    { 0x14038431, "sound_watch_for_engine_add_power" },
    { 0x991FD1DF, "sound_watch_for_engine_evasive" },
    { 0xA64A2C06, "sound_watch_for_engine_high" },
    { 0x5C3C88C0, "sound_watch_for_engine_low" },
    { 0xB2088B05, "sound_watch_for_engine_take_off" },
    { 0x4DCA3112, "sound_watch_for_engine_taxi" },
    { 0x3A537F7F, "sound_wires_move" },
    { 0x02017476, "soundalias" },
    { 0xA3D5DC7B, "soundalias1" },
    { 0x31CE6D40, "soundalias2" },
    { 0x36FBD956, "soundalias_1" },
    { 0x10F95EED, "soundalias_2" },
    { 0x1B2D65B6, "soundaliases" },
    { 0x2B1F3C2F, "soundblend" },
    { 0x004A1B7B, "soundbombsite" },
    { 0x5ACE6F17, "soundcause" },
    { 0x68BDDEA2, "soundcausevar" },
    { 0x2431C8AA, "soundchance" },
    { 0x4C49B69F, "soundcount" },
    { 0x40EBA907, "sounddef" },
    { 0xAA35917B, "sounddelay" },
    { 0x7E0F33FA, "sounddone" },
    { 0x77C185D4, "sounddone_introvox" },
    { 0x8733F9A1, "sounddone_oneliner" },
    { 0x93AED17C, "sounddone_skit" },
    { 0xBD320495, "sounded" },
    { 0xBBC0FBF0, "soundeffectname" },
    { 0x6098643E, "soundenemy" },
    { 0xF9237299, "soundent" },
    { 0x51D4996F, "soundent_left" },
    { 0x1DDF50CA, "soundent_right" },
    { 0x6D66A2CA, "soundentarea" },
    { 0x702F7045, "soundentinsideidlehf" },
    { 0xB9DA9B69, "soundentinsideidlelf" },
    { 0x088F5F8D, "soundentinsideidlerotor" },
    { 0x845728F4, "soundentinsideidlewhine" },
    { 0xD4F950F9, "soundentoutsidecruiserotor" },
    { 0x767F03A6, "soundentoutsideidlehf" },
    { 0x4343320A, "soundentoutsideidlelf" },
    { 0x99A8DE7C, "soundentoutsideidlerotor" },
    { 0xE05E56F9, "soundentoutsideidlewhine" },
    { 0xEDE1347D, "soundentrotorwind" },
    { 0x644DFF20, "soundentrotorwindint" },
    { 0x7F28F5FA, "soundexists" },
    { 0x3E8C692B, "soundfriendly" },
    { 0x3722F948, "soundfx" },
    { 0x1D946139, "soundfxdelete" },
    { 0x799102F2, "soundgetplaybacktime" },
    { 0x008D3311, "soundid" },
    { 0xA2842CEE, "soundindex" },
    { 0xADAA9365, "soundlengthplaceholder" },
    { 0x775D3630, "soundlinecheckpointrestore" },
    { 0xAD32F53E, "soundlineemitter" },
    { 0x27787E84, "soundlinethink" },
    { 0xEAAFFFA4, "soundloop" },
    { 0xCDF2A880, "soundloopcheckpointrestore" },
    { 0x09C128EE, "soundloopemitter" },
    { 0x1F01C4B4, "soundloopthink" },
    { 0xBFAAAC3E, "soundmod" },
    { 0x8F0190F9, "soundmover" },
    { 0xF9117E0F, "soundname" },
    { 0x8D3EA339, "soundnotify" },
    { 0x94514EBA, "soundnum" },
    { 0x1AF80580, "soundonly" },
    { 0x7117F63B, "soundonly_done" },
    { 0xD54A94B8, "soundplay" },
    { 0x4CE1AA25, "soundplay_flag" },
    { 0x1645025B, "soundplayautofx" },
    { 0x4AED22CB, "soundplayed" },
    { 0x36CA710D, "soundplayer" },
    { 0xCF7E7120, "soundplaying" },
    { 0x5F98D546, "soundplayuidecodeloop" },
    { 0x7DD7D658, "soundpoint" },
    { 0xBDFF39B4, "soundpos" },
    { 0xC806E3F8, "soundqueuetime" },
    { 0x5BBA776A, "soundrandom_notifywait" },
    { 0x3C7298AA, "soundrandom_thread" },
    { 0xD5DD6248, "soundrandomsplay" },
    { 0x436039E5, "soundrandomsstarted" },
    { 0xCA76FF24, "soundrattle" },
    { 0x99EF89EF, "soundrattlerangemax" },
    { 0x2EF21491, "soundrattlerangemin" },
    { 0xD2E71C8B, "soundrattlesetup" },
    { 0x42296FCD, "sounds" },
    { 0x346E4538, "sounds_disabled" },
    { 0x0F6B8ABB, "soundsetaiambientstate" },
    { 0xEA25DEC5, "soundsetambientstate" },
    { 0x2913B292, "soundsetmusicstate" },
    { 0x14218F0F, "soundsnout" },
    { 0xF2FAD9B2, "soundspot" },
    { 0x3B615636, "soundstoplineemitter" },
    { 0xC0384F26, "soundstoploopemitter" },
    { 0xB6A5BF32, "soundtag" },
    { 0x474391BF, "soundtagname" },
    { 0x6F691DF3, "soundtoplay" },
    { 0xF7B911B2, "soundtype" },
    { 0xF0D0494F, "soundtype1" },
    { 0x7EC8DA14, "soundtype2" },
    { 0x5537096F, "soundupdatelineemitter" },
    { 0x02988198, "soundvolume" },
    { 0x1F2B3321, "soundwait" },
    { 0x5149BC76, "soundwaittime" },
    { 0xA91928DE, "source" },
    { 0x88D6C584, "source_array" },
    { 0x48C945D7, "source_enemy" },
    { 0xF2F892A4, "source_ent" },
    { 0x17C7CFE9, "source_loc" },
    { 0xCC247D9D, "source_node" },
    { 0x5217A417, "source_num" },
    { 0xE13B27B3, "source_origin" },
    { 0x0DBFBDFD, "source_pos" },
    { 0xBFA0FD24, "source_zombie_death" },
    { 0x09D29A41, "sources" },
    { 0x87E55770, "south" },
    { 0x303BB8B9, "south_ext_goals" },
    { 0xFD17AB45, "south_light" },
    { 0x0204F913, "south_pos" },
    { 0xE1217443, "south_structs" },
    { 0xBE7A9F46, "south_vol" },
    { 0xC61AAE9C, "south_zapper_light_green" },
    { 0xC027980C, "south_zapper_light_red" },
    { 0xEA7810A8, "southbound" },
    { 0x77A76393, "southboundvehicles" },
    { 0xE69300A7, "southeast" },
    { 0x4CB81AF1, "southern" },
    { 0x335F3984, "southern_hill_action_started" },
    { 0xF09A00E4, "southern_hill_ambush" },
    { 0x2A1B8263, "southern_hill_ambush_mg" },
    { 0x3A1CA61B, "southern_hill_attack_stop" },
    { 0x4745588F, "southern_hill_baglimit" },
    { 0xC363524F, "southern_hill_damagemonitor" },
    { 0x08139CFC, "southern_hill_deathmonitor" },
    { 0x9D874794, "southern_hill_defense" },
    { 0x50B45916, "southern_hill_intro" },
    { 0x09ECB916, "southern_hill_intro_interrupt" },
    { 0xCC28D2BD, "southern_hill_javelin" },
    { 0xE218A4DE, "southern_hill_killzone_sequence" },
    { 0x68242C06, "southern_hill_magic_sniper_max_cycletime" },
    { 0x448AFA94, "southern_hill_magic_sniper_min_cycletime" },
    { 0xBE4B70E8, "southern_hill_mg_targeting" },
    { 0xEC4671C2, "southern_hill_mortar_detonate" },
    { 0x90BD30EE, "southern_hill_mortars" },
    { 0x77D8BCAA, "southern_hill_mortars_killplayer" },
    { 0x933CC12C, "southern_hill_mortars_killtimer" },
    { 0xFF941EBB, "southern_hill_mortars_timing" },
    { 0x8F7D0AE9, "southern_hill_panic_screaming" },
    { 0xFE2B9AF1, "southern_hill_primary_attack" },
    { 0x67431592, "southern_hill_shotmonitor" },
    { 0x707860E5, "southern_hill_smoked" },
    { 0xBF7C271E, "southern_hill_smokescreens" },
    { 0x809C7C79, "southern_hill_timeout" },
    { 0x39E990F0, "southern_hill_vanguard_aim" },
    { 0xC297EF34, "southern_hill_vanguard_nav" },
    { 0x4044CA2C, "southern_hill_vanguard_setup" },
    { 0xD47544B2, "southern_hill_vanguard_wakeup" },
    { 0xCFFA1C6E, "southern_sas_mg" },
    { 0x478756F5, "southernhilladvancebaglimit" },
    { 0x0C990733, "southernmortarintrotimer" },
    { 0xA00FADD1, "southernmortarkilltimer" },
    { 0xB0421988, "southernmost" },
    { 0x93F7DDE2, "southernobjloc" },
    { 0x068200C5, "southwest" },
    { 0x4D6D87F1, "southwest_drones" },
    { 0x6B2F04C2, "southwestern" },
    { 0x3C71642F, "soviet" },
    { 0xD4AAF30C, "soviet_fallback" },
    { 0xDA6DA276, "soviets" },
    { 0xEF994D78, "sovremenniy" },
    { 0x1A9BB3A3, "soylent" },
    { 0x098035C5, "soyuz" },
    { 0xF2D5D544, "sp" },
    { 0x50798DE5, "sp1" },
    { 0x767C084E, "sp2" },
    { 0xF7C77A42, "sp_actor" },
    { 0x05FC01B9, "sp_ai" },
    { 0x5BA02F91, "sp_allies" },
    { 0xB0853920, "sp_assault" },
    { 0xAB62397F, "sp_attacked_woman" },
    { 0xAB4096E7, "sp_avenger" },
    { 0xD19F7F77, "sp_brim_shooters" },
    { 0x0920DA56, "sp_btr1_support" },
    { 0x1FD62425, "sp_btr2_support" },
    { 0x646BD3A8, "sp_cache1" },
    { 0xD67342E3, "sp_cache2" },
    { 0xB070C87A, "sp_cache3" },
    { 0xFC75BD4C, "sp_cache5" },
    { 0x6E7D2C87, "sp_cache6" },
    { 0xB506DB81, "sp_center_enemy" },
    { 0x2A98354B, "sp_center_guys" },
    { 0xA023AD9B, "sp_civ" },
    { 0x217626DA, "sp_claw_1" },
    { 0xFB73AC71, "sp_claw_2" },
    { 0x8DC2C271, "sp_courtyard_spawner" },
    { 0xEF80443D, "sp_crosby" },
    { 0x2D1B8B0C, "sp_crosser" },
    { 0xC97302D2, "sp_defender" },
    { 0xE9599A4E, "sp_digbat_axis" },
    { 0xD64C3669, "sp_diver" },
    { 0x2C574991, "sp_driver" },
    { 0xE5F1EB37, "sp_drone" },
    { 0x2DB52DAC, "sp_drone_ally" },
    { 0x9BDFF7D1, "sp_drone_axis" },
    { 0x14038F01, "sp_drone_civilian_1" },
    { 0x9ABC8299, "sp_drone_model" },
    { 0xC0249AFC, "sp_drone_mpla" },
    { 0x6694B843, "sp_drone_mpla_high" },
    { 0xFE3759C9, "sp_drone_unita" },
    { 0x1E913765, "sp_enemy" },
    { 0x0D3DB6E9, "sp_fail_reinforcement" },
    { 0x470D451A, "sp_final1" },
    { 0x210ACAB1, "sp_final2" },
    { 0xD22E48A3, "sp_friend" },
    { 0xFFD161CE, "sp_friendly" },
    { 0x18210EC8, "sp_friendly2" },
    { 0x3E238931, "sp_friendly3" },
    { 0x1BD4990D, "sp_gauntlet" },
    { 0xB5A20F62, "sp_generic" },
    { 0xD2B126C7, "sp_giant_robot" },
    { 0xF4723B47, "sp_grenade_guy" },
    { 0x8F706096, "sp_guard" },
    { 0xEA122D1B, "sp_guard1" },
    { 0x780ABDE0, "sp_guard2" },
    { 0xC0DD09DA, "sp_guard_left" },
    { 0x1CB8FB29, "sp_guard_right" },
    { 0xD09B272B, "sp_gunner_spawner" },
    { 0x31FB0D14, "sp_guy" },
    { 0x15034687, "sp_guys" },
    { 0x27CAFDF9, "sp_harper" },
    { 0x50A7356A, "sp_heli_crash_shooter" },
    { 0xAEDA7FDE, "sp_hill_machete" },
    { 0x6CE8383A, "sp_hill_shooters" },
    { 0x3C26E23A, "sp_hudson" },
    { 0x3BCC7E2F, "sp_intro" },
    { 0x2B03D0A3, "sp_jetpack" },
    { 0x6791B328, "sp_killstreaks" },
    { 0x645D23B7, "sp_last" },
    { 0x70B64D6F, "sp_launcher" },
    { 0x25C8B7CC, "sp_left" },
    { 0x5A1A403F, "sp_left_guys" },
    { 0x8B30560A, "sp_lockdown" },
    { 0xCE7E3999, "sp_menendez" },
    { 0x4B81E3DA, "sp_model" },
    { 0x81107E31, "sp_mpla" },
    { 0x1E4A0119, "sp_muj" },
    { 0x41559962, "sp_muj1" },
    { 0x1B531EF9, "sp_muj2" },
    { 0x6C1B9588, "sp_muj_initial" },
    { 0x344548FD, "sp_passenger" },
    { 0x7017728E, "sp_patroller" },
    { 0xABE2B323, "sp_pdf" },
    { 0xB3A3DBC9, "sp_pegasus" },
    { 0x84FBE095, "sp_perks_initialized" },
    { 0xB1D3AA48, "sp_pmc_spawner" },
    { 0x4DCF85F3, "sp_police_car_rider" },
    { 0x85D5A82B, "sp_rappel" },
    { 0xA96E5066, "sp_rappeler" },
    { 0x833BB96D, "sp_rappell" },
    { 0xEE24BB2B, "sp_red_truck_guys" },
    { 0x5EA45598, "sp_redshirt" },
    { 0x5E89A7AB, "sp_rideout_guy" },
    { 0x238B5919, "sp_rider" },
    { 0x40BB4F98, "sp_rider_spawner" },
    { 0x41D12DE3, "sp_right" },
    { 0x961D122E, "sp_right_guys" },
    { 0x3ACC0C56, "sp_rooftop" },
    { 0x25A9E204, "sp_rpg" },
    { 0x0E7C428C, "sp_runners" },
    { 0x03A4282C, "sp_rusher" },
    { 0x79E9A02F, "sp_rushers" },
    { 0x716D3472, "sp_sailor_spawner" },
    { 0x530B1BA2, "sp_semi_driver" },
    { 0xF3858049, "sp_shooter" },
    { 0x6486374E, "sp_sniper" },
    { 0xC76E3BF1, "sp_snipers" },
    { 0x7B16C379, "sp_soviet" },
    { 0x1C779B09, "sp_spawner" },
    { 0x3A5A87D5, "sp_st_fork" },
    { 0xA5659936, "sp_st_scaffolding_middle_0" },
    { 0xD97DD4F7, "sp_st_scaffolding_right_0" },
    { 0xB37B5A8E, "sp_st_scaffolding_right_1" },
    { 0x290A55E7, "sp_stables_exit_blocker_guy" },
    { 0x78816D2E, "sp_stables_pdf" },
    { 0xBA3C6398, "sp_stat_tracking_func" },
    { 0x5352C6A9, "sp_street_bdog_back" },
    { 0xA495168D, "sp_street_bdog_front" },
    { 0x40A14617, "sp_terrorist" },
    { 0xCB9B3D81, "sp_tool" },
    { 0x32369BD9, "sp_truck_driver" },
    { 0x8266A26A, "sp_truck_gunner" },
    { 0x220DDA12, "sp_unita" },
    { 0x2C566FB1, "sp_vehicle" },
    { 0xFD6DC7A7, "sp_wave_one_shooters" },
    { 0x70F08195, "spa" },
    { 0x7FFA5581, "space" },
    { 0x7CFC18E1, "space2backin" },
    { 0xC62C481B, "space_adj" },
    { 0xA501585E, "space_apart" },
    { 0x642365C4, "space_backin" },
    { 0x5FC61F5C, "space_between" },
    { 0xA89FF266, "space_between_text" },
    { 0x7B84580E, "space_go_outside" },
    { 0x316D0EC1, "space_snap2sr71" },
    { 0xF15CAE53, "space_snap_into_cockpit" },
    { 0x2B9B6BDD, "spacecraft" },
    { 0xD10C6B17, "spaced" },
    { 0x6EB9E74F, "spaceman" },
    { 0x8CD5E611, "spacer" },
    { 0x66D36BA8, "spaces" },
    { 0x833B5CDA, "spacesmall_delay" },
    { 0xF25DEB34, "spacing" },
    { 0xC364C995, "spacing1" },
    { 0xE96743FE, "spacing2" },
    { 0xEC6879C7, "spacing_dist" },
    { 0xEE66A8B5, "spacing_far_dist" },
    { 0xF5CD001B, "spacing_horz_dist" },
    { 0x1AE3E20E, "spacing_multiplier" },
    { 0xD6F2320C, "spacing_near_dist" },
    { 0x06F489D2, "spacing_value" },
    { 0x860EFF5E, "spaciouspoint" },
    { 0x91F2B9EA, "spam" },
    { 0xE9E21C9C, "spam_density_scale" },
    { 0xF7843824, "spam_group_hudelems" },
    { 0x2DD636B1, "spam_maxdist" },
    { 0x2602059F, "spam_model_circlescale" },
    { 0x63F3B9CC, "spam_model_circlescale_accumtime" },
    { 0x9078CCD9, "spam_model_circlescale_lasttime" },
    { 0x928ABA6D, "spam_model_clearcondition" },
    { 0xA74D800A, "spam_model_current_group" },
    { 0xB392D401, "spam_model_densityscale" },
    { 0x627FE117, "spam_model_erase" },
    { 0x7F95125C, "spam_model_group" },
    { 0xE119F96C, "spam_model_place" },
    { 0x6ADD6511, "spam_model_radius" },
    { 0x25F14BD3, "spam_model_redo" },
    { 0x92E68415, "spam_model_undo" },
    { 0x5B492C6A, "spam_modelattrace" },
    { 0x05FA846D, "spam_models_atcircle" },
    { 0x1E8FEA3A, "spam_models_customheight" },
    { 0xA0E4A911, "spam_models_customrotation" },
    { 0x197B7994, "spam_models_flowrate" },
    { 0xEA081F9E, "spam_models_iscustomheight" },
    { 0xF15CB595, "spam_models_iscustomrotation" },
    { 0xE9621217, "spamcount" },
    { 0x2805AD33, "spamdelay" },
    { 0x4F13F35E, "spamed_models" },
    { 0x70857971, "spamed_models_redo" },
    { 0xBDCC3F6F, "spaming_models" },
    { 0x910D1D70, "spammed" },
    { 0xE937B2E5, "spamming" },
    { 0xEABC9E80, "spammy" },
    { 0xA58F24A5, "spams" },
    { 0x8FE32D5E, "spamuimodelvalue" },
    { 0xC180462F, "spamy" },
    { 0x6BF03F81, "span" },
    { 0x050F798A, "spare" },
    { 0x47CF1165, "spare_change" },
    { 0x2A4051FA, "spared" },
    { 0x3484F146, "sparingly" },
    { 0x21009B14, "spark" },
    { 0x8EE64349, "spark_behavior" },
    { 0xF78A45BF, "spark_done" },
    { 0xCCFB843D, "spark_fx" },
    { 0xE8CC6BB7, "spark_fx_id" },
    { 0x26690F17, "spark_pos" },
    { 0x71F541A7, "spark_structs" },
    { 0x922989D4, "spark_threshold" },
    { 0xAC3FAF4C, "sparkang" },
    { 0x0F5B0118, "sparkers" },
    { 0x625F74B2, "sparkgen" },
    { 0xF4E22054, "sparking" },
    { 0xC8F3DABE, "sparking_power_lines" },
    { 0xA2BF0EBD, "sparkle" },
    { 0x2CE7144B, "sparkmodel" },
    { 0x5AC1D087, "sparks" },
    { 0x1FA1D66C, "sparks1" },
    { 0x91A945A7, "sparks2" },
    { 0x6BA6CB3E, "sparks3" },
    { 0xAD9A6731, "sparks4" },
    { 0x60B9CA09, "sparks_ent" },
    { 0xDF802E92, "sparksclaimed" },
    { 0xDEA9086D, "sparky" },
    { 0xDF93F9DE, "sparky_loop_snd" },
    { 0x0C70EFF1, "sparky_zombie_fx_cb" },
    { 0x135F7368, "sparky_zombie_trail_fx_cb" },
    { 0xCECE7137, "sparrow" },
    { 0x20C0E184, "sparse_ambient_patrols" },
    { 0x2EC8FB0E, "spartan" },
    { 0x4DBC34E4, "spas" },
    { 0x82DBAD8E, "spas_sp" },
    { 0x935ED4F9, "spath" },
    { 0xC52462C4, "spatter" },
    { 0x064B2615, "spawer" },
    { 0x9F7BE958, "spawing" },
    { 0x9B7FDA5E, "spawn" },
    { 0xEE1F95D3, "spawn1" },
    { 0x7C182698, "spawn2" },
    { 0xA21AA101, "spawn3" },
    { 0xE806668B, "spawn_50cal_attackers" },
    { 0xA32CBCED, "spawn_a_background_truck" },
    { 0x6304C6F9, "spawn_a_cow_burst" },
    { 0x0294052C, "spawn_a_mini_boss" },
    { 0x798E9844, "spawn_a_model" },
    { 0x4D4195D5, "spawn_a_quad_zombie" },
    { 0x1AE2C085, "spawn_a_rope" },
    { 0x3245E3C3, "spawn_a_zero" },
    { 0x620AA42F, "spawn_a_zombie" },
    { 0xF05237AC, "spawn_aa_volume_trigs" },
    { 0x0EFD8772, "spawn_accounting" },
    { 0xACE5305B, "spawn_admin_pickup_weapons" },
    { 0xE04F00FD, "spawn_aerial_vehicles" },
    { 0x5BE33058, "spawn_aft_explosion" },
    { 0xB0E2441B, "spawn_ai" },
    { 0xB0D3833D, "spawn_ai_and_make_dumb" },
    { 0x3AB3357F, "spawn_ai_at_path_end" },
    { 0xA7E030E8, "spawn_ai_battle" },
    { 0x803F2A8A, "spawn_ai_for_deck_battle" },
    { 0xBA02F75C, "spawn_ai_func" },
    { 0xA4DBC4DF, "spawn_ai_group" },
    { 0x7E166437, "spawn_ai_package_cargo" },
    { 0x6FCB44E3, "spawn_ai_package_helo" },
    { 0xE3370BFA, "spawn_ai_package_standard" },
    { 0xBE1FE37F, "spawn_ai_supplement" },
    { 0xC03D2C18, "spawn_airfield_littlebirds" },
    { 0x9117CC0A, "spawn_airfield_pickup_weapons" },
    { 0xBE5D6413, "spawn_airplane" },
    { 0xB17EA144, "spawn_ais_at_dock_for_aa_kill" },
    { 0x54F0F4AE, "spawn_all" },
    { 0x2DCA3B8E, "spawn_all_classname" },
    { 0x7BE0B990, "spawn_all_drones" },
    { 0x3B319843, "spawn_all_mounds" },
    { 0xB9FEF00E, "spawn_alley_flamer" },
    { 0x41620858, "spawn_alley_leader" },
    { 0x1101368F, "spawn_allies" },
    { 0x4FA3DF0D, "spawn_allies_generic" },
    { 0xF860FFB2, "spawn_allies_on_boat" },
    { 0xA3D60A5B, "spawn_allies_quietly" },
    { 0xC85D6F8A, "spawn_allies_start" },
    { 0xF5E308C2, "spawn_allies_start_classname" },
    { 0x20011B79, "spawn_ally_team" },
    { 0x7886FA4A, "spawn_ambient_asd" },
    { 0xE1D529CF, "spawn_ambient_drones" },
    { 0xE04CDCC2, "spawn_ambient_migs" },
    { 0x1F288D09, "spawn_ambient_vehicle_and_drive" },
    { 0x10D33A44, "spawn_ambush_guys" },
    { 0x0446B589, "spawn_and_animate_ghost_pianist" },
    { 0xBEE262A7, "spawn_and_attach_pilot" },
    { 0x8EF4B072, "spawn_and_attach_shark" },
    { 0xD0F0F0B1, "spawn_and_attach_truck_driver" },
    { 0x866329E2, "spawn_and_attach_uaz_driver" },
    { 0xDFCB2ABA, "spawn_and_path_a_corsair" },
    { 0x2273D85F, "spawn_and_path_a_ptboat" },
    { 0x9E13A3C0, "spawn_and_path_a_shark" },
    { 0xEDA6D33F, "spawn_and_path_a_zero" },
    { 0xC467B2D9, "spawn_and_play" },
    { 0xDCF8E281, "spawn_and_play_solo" },
    { 0x40E9B8B2, "spawn_angle" },
    { 0x5BC39F3D, "spawn_angles" },
    { 0x3E636482, "spawn_anim" },
    { 0xF3F6D5FF, "spawn_anim_finished" },
    { 0x1B8C5958, "spawn_anim_model" },
    { 0x39780BB4, "spawn_anim_player_model" },
    { 0x1A00E989, "spawn_animate_drone_friendly" },
    { 0xDE69A215, "spawn_animate_drone_vc" },
    { 0x8C2C5DE2, "spawn_anywhere" },
    { 0xFB723F3F, "spawn_anywhere_active" },
    { 0xD5482940, "spawn_anywhere_friendly" },
    { 0x3CC1BC67, "spawn_area_four_infantry" },
    { 0x8CB5AFCD, "spawn_area_three_infantry" },
    { 0xD36C6A7B, "spawn_area_two_infantry" },
    { 0x56112461, "spawn_arena_crossers" },
    { 0x87DD0F48, "spawn_arena_sniper" },
    { 0xE043D4DD, "spawn_arena_trucks" },
    { 0x8B00325B, "spawn_arena_uaz" },
    { 0x1A9C9F22, "spawn_armored_patrollers" },
    { 0x567E42D7, "spawn_armory" },
    { 0x537BEB04, "spawn_array" },
    { 0x2F3324A6, "spawn_array_empty" },
    { 0xC9D17550, "spawn_array_once" },
    { 0xFEA19444, "spawn_array_struct" },
    { 0x2D362BA4, "spawn_at_end" },
    { 0x8E0147FA, "spawn_at_struct" },
    { 0xAEB91659, "spawn_attack_drones_manager" },
    { 0x94CD4C67, "spawn_attackers" },
    { 0x7C447614, "spawn_attacking_drone" },
    { 0xAA9231D3, "spawn_avoid_drone_group" },
    { 0x8711689E, "spawn_avoid_f38_group" },
    { 0xDFBB18C3, "spawn_avoid_vtols" },
    { 0x0384646E, "spawn_axis" },
    { 0x3DC78F54, "spawn_axis_model" },
    { 0x192E574F, "spawn_axis_start" },
    { 0x52C432C7, "spawn_axis_start_classname" },
    { 0xCB64AF36, "spawn_backup_cache_horse" },
    { 0x1A2FBFC5, "spawn_barge_ai" },
    { 0x2C458AA6, "spawn_barge_ai_at_node" },
    { 0x17D8306D, "spawn_barge_housing_damage_fx" },
    { 0xB01F9EFB, "spawn_barge_side_damage_fx" },
    { 0xA3FBF456, "spawn_base" },
    { 0x716ABD4B, "spawn_base_defenders" },
    { 0x99092C33, "spawn_base_horses" },
    { 0xA3EAB5CF, "spawn_base_personnel" },
    { 0x720234E2, "spawn_beach_vehicles" },
    { 0xB2F1C4D0, "spawn_beehive_guys" },
    { 0xC7A59C02, "spawn_bias" },
    { 0x9323670D, "spawn_bigdog" },
    { 0x3E826E70, "spawn_binoc_krav_guards" },
    { 0x445E0F20, "spawn_binoc_scientists" },
    { 0x02BB4C53, "spawn_binoc_snipers" },
    { 0x57C5A696, "spawn_binoc_snipers_basewalk" },
    { 0x30FD2356, "spawn_binoculars_scene" },
    { 0x39523611, "spawn_blade" },
    { 0x7B3C06F8, "spawn_blades" },
    { 0x4DB7E948, "spawn_blinking_fx" },
    { 0xEDE0A3DA, "spawn_boat_trigger" },
    { 0xE377ED8F, "spawn_boats_animation_reference" },
    { 0xDFC40625, "spawn_bomb" },
    { 0x98261767, "spawn_bombers" },
    { 0xA7E130D0, "spawn_bonus_room" },
    { 0x5296D84E, "spawn_bookshelf_guy" },
    { 0x18894FE2, "spawn_boss" },
    { 0x41165C9C, "spawn_bot" },
    { 0x0E00B57F, "spawn_bow_climbers" },
    { 0x4A12ADB7, "spawn_bowman_undercover" },
    { 0xFC687C29, "spawn_bp1_horses" },
    { 0x908D13B8, "spawn_bp1_spetznaz" },
    { 0xF937E65C, "spawn_bp1exit_uazs" },
    { 0x062BE507, "spawn_bp2_exit_btr" },
    { 0x0DC45287, "spawn_bp2_exit_truck1" },
    { 0x9BBCE34C, "spawn_bp2_exit_truck2" },
    { 0x6969C2E3, "spawn_bp2_exit_uaz" },
    { 0x8E045D40, "spawn_bp2_exit_uaz1" },
    { 0x000BCC7B, "spawn_bp2_exit_uaz2" },
    { 0x80C64DDF, "spawn_bp2_sniper" },
    { 0x5DD82A93, "spawn_bp3_exit_battle_horses" },
    { 0x55EB4DAE, "spawn_bp3_vehicles" },
    { 0x71272550, "spawn_bridge_climbers" },
    { 0xB94BB633, "spawn_briggs" },
    { 0x99864AE3, "spawn_brooks_undercover" },
    { 0x70A17212, "spawn_brutus" },
    { 0x14BD1C56, "spawn_btr1_bp1" },
    { 0xA2AD5499, "spawn_btr2_bp1" },
    { 0x728BF83A, "spawn_buildkit_weapon_model" },
    { 0xEE7078D0, "spawn_bullet_hole_entity" },
    { 0xA0C77775, "spawn_bunker_2_front" },
    { 0x23E02EF2, "spawn_bunkers_pickup_weapons" },
    { 0xAD3EEBD9, "spawn_burned_guy" },
    { 0x3E3B3E43, "spawn_callback_thread" },
    { 0xFF8DBED8, "spawn_cam_model" },
    { 0x1CF4ADEB, "spawn_card" },
    { 0x2AD92703, "spawn_center_fountain_solar" },
    { 0x30736DC9, "spawn_chair1" },
    { 0x5675E832, "spawn_chair2" },
    { 0x8B7880E2, "spawn_character" },
    { 0x95A4CFFD, "spawn_chase_truck" },
    { 0x3DE2EFBC, "spawn_chase_trucks" },
    { 0x4B14BD48, "spawn_china_lake" },
    { 0x877B2816, "spawn_chinook_crew" },
    { 0x35039FEA, "spawn_chopper_boss" },
    { 0xC2C48AC5, "spawn_chopper_victim" },
    { 0xB0270EE0, "spawn_civs" },
    { 0x66A5CC27, "spawn_classes" },
    { 0x37489C4B, "spawn_cloud_effects" },
    { 0xD6DC0A57, "spawn_clouds" },
    { 0x8F97EDA8, "spawn_commando_marine" },
    { 0x903566CB, "spawn_convoy" },
    { 0x6C7386DD, "spawn_convoy_f35_allies" },
    { 0xCFD6A68A, "spawn_convoy_strafing_wave" },
    { 0x34BC3A3C, "spawn_corpsedudes" },
    { 0x669AAEED, "spawn_corsair_escort" },
    { 0x806B2762, "spawn_count" },
    { 0x4435912D, "spawn_counts" },
    { 0xB266B588, "spawn_courtyard_planes" },
    { 0xDE6D88EA, "spawn_courtyard_runners" },
    { 0x98CDB26A, "spawn_crane_building_heli" },
    { 0x32532C78, "spawn_crash_f38" },
    { 0x2E99FD84, "spawn_crashed_heli" },
    { 0x38079703, "spawn_crate_chunks" },
    { 0x83258240, "spawn_crewmember" },
    { 0x044D71C4, "spawn_cymbalmonkey" },
    { 0x67119C48, "spawn_dancer" },
    { 0xB6ED6482, "spawn_dead_body" },
    { 0x0B692BBA, "spawn_deck_spec_ops_battle" },
    { 0xA27A57B9, "spawn_defalco_or_standin" },
    { 0x101C3F5A, "spawn_defalco_with_head_shot" },
    { 0x732809AA, "spawn_delay" },
    { 0x4F1647F9, "spawn_depot_drones" },
    { 0x2020078F, "spawn_destructible" },
    { 0xA36C2D8B, "spawn_died" },
    { 0x77322653, "spawn_digbat_hallway" },
    { 0xE010863A, "spawn_dist_max" },
    { 0xA2AC7B24, "spawn_dist_min" },
    { 0xDF50D77A, "spawn_diving_guy" },
    { 0xCB279145, "spawn_dock_snipers" },
    { 0xC84E2C45, "spawn_dog" },
    { 0xDA68CFA8, "spawn_dog_tag" },
    { 0xC5E09AD4, "spawn_dogs" },
    { 0x5C1BB5E7, "spawn_drive_1" },
    { 0xEA1446AC, "spawn_drive_2" },
    { 0x10DAD989, "spawn_drone" },
    { 0x506763DD, "spawn_drone_at_struct" },
    { 0x7FDBF5AB, "spawn_drone_for_lapd_squibs" },
    { 0xD337527D, "spawn_drone_searcher" },
    { 0x6CAF75F8, "spawn_drone_skyline_dummy" },
    { 0x8D692C99, "spawn_drone_skyline_path" },
    { 0x3B07F078, "spawn_drone_stack_formation" },
    { 0xE2347218, "spawn_drone_swarm" },
    { 0xEF1D471E, "spawn_drone_to_fire" },
    { 0xADE6DD26, "spawn_drone_v_formation" },
    { 0xFE677580, "spawn_drones" },
    { 0xC3EA0297, "spawn_drop_locations" },
    { 0xB051BAB1, "spawn_duration" },
    { 0x28D92EAC, "spawn_dyn_model" },
    { 0xF0E426CD, "spawn_dynent" },
    { 0x12B41A15, "spawn_eject_friendly_follow_plane" },
    { 0x33A082B4, "spawn_end" },
    { 0xA895E46A, "spawn_end_helis" },
    { 0xC0EE8391, "spawn_end_of_final_killcam" },
    { 0x440D1A30, "spawn_end_scene_enemies" },
    { 0xD325750E, "spawn_ending_claw_at_struct" },
    { 0x963697B3, "spawn_enemies" },
    { 0x136E6B57, "spawn_enemy" },
    { 0x3678EE34, "spawn_enemy_bike_rider" },
    { 0xD3E7B32B, "spawn_enemy_group" },
    { 0x28DD99D8, "spawn_enemy_plane" },
    { 0x2A3073EE, "spawn_enemy_rail_vehicles" },
    { 0x26D0B2CC, "spawn_enemy_squad_by_chopper" },
    { 0x80EF754B, "spawn_enemy_squads" },
    { 0x086D6AF4, "spawn_enemy_targets" },
    { 0x343E6364, "spawn_engineer_postcb" },
    { 0xD378DC24, "spawn_ent" },
    { 0x3B603FA5, "spawn_ent_on_tag" },
    { 0xBF06E8A4, "spawn_entities" },
    { 0x11D9E12A, "spawn_entities_s" },
    { 0x9D981028, "spawn_entity" },
    { 0x477B780E, "spawn_entity_types" },
    { 0x6EDAD5CE, "spawn_escorting_corsairs" },
    { 0x9FA292E3, "spawn_ev6_fly_under" },
    { 0xEE91B50A, "spawn_ev6_ptboats" },
    { 0x7B8338B8, "spawn_event1_initial_enemies" },
    { 0x8403872E, "spawn_explosive_crate" },
    { 0x6A20DC74, "spawn_extra_attackers" },
    { 0xF26CD5D4, "spawn_extra_guys" },
    { 0x7B8D4BE5, "spawn_extra_runners" },
    { 0x65251CEE, "spawn_failed" },
    { 0x6FDDFE03, "spawn_fake_battle_lines" },
    { 0x4F4F0A36, "spawn_fake_character" },
    { 0xE4F6C882, "spawn_fake_guy" },
    { 0x648BF6E5, "spawn_fake_guy_lvt" },
    { 0x1A4B8E02, "spawn_fake_guy_outro" },
    { 0x89D1A2D6, "spawn_fake_guy_to_anim" },
    { 0x8AF12F8D, "spawn_fake_guy_to_anim_2" },
    { 0x4C2507C2, "spawn_fake_guy_to_anim_player" },
    { 0x2FE1D865, "spawn_fake_hero_outro" },
    { 0x15D87012, "spawn_fake_huey_riders" },
    { 0x2811D24E, "spawn_fake_rpg" },
    { 0x3960DDE1, "spawn_fake_weaver_and_krav_and_woods" },
    { 0xA7ACFBF1, "spawn_far_loop_entities" },
    { 0x19E5143F, "spawn_far_squad" },
    { 0x5E6EE570, "spawn_farid_with_shot_body" },
    { 0x574A25FF, "spawn_fast_planes" },
    { 0x610652A7, "spawn_fastrope_guy" },
    { 0x205D8156, "spawn_firefly_mover" },
    { 0x67A1FEEF, "spawn_firehorses" },
    { 0x94F91B30, "spawn_first_pt_boats" },
    { 0x602D8D45, "spawn_first_radio" },
    { 0x87CD9C94, "spawn_first_ship_drones" },
    { 0x4CBEE745, "spawn_first_truck" },
    { 0x8F43B24F, "spawn_first_wave" },
    { 0x50454D3E, "spawn_first_zone" },
    { 0xEE391543, "spawn_flag" },
    { 0x562F2B9F, "spawn_flak" },
    { 0x076DCAA7, "spawn_flame_runner" },
    { 0x74F80F9A, "spawn_flaming_guys" },
    { 0xA5646C18, "spawn_flaming_guys_side" },
    { 0x098C14F3, "spawn_flashlighfx" },
    { 0x6B9A56DD, "spawn_flavor_vc" },
    { 0xA9C8ECBE, "spawn_floating_bodies" },
    { 0x410A6547, "spawn_floor_effect" },
    { 0x1BC4A3CD, "spawn_fn" },
    { 0xF593CAAB, "spawn_fn_ai_jungle_patrol" },
    { 0x0E5A2D57, "spawn_fn_ai_run_to_holding_node" },
    { 0x4BBE7591, "spawn_fn_ai_run_to_jumper_node" },
    { 0x9F730402, "spawn_fn_ai_run_to_node_and_die" },
    { 0xB517FDB6, "spawn_fn_ai_run_to_prone_node" },
    { 0xB69DEB30, "spawn_fn_ai_run_to_target" },
    { 0x635252BC, "spawn_forward_runners" },
    { 0x0972574C, "spawn_foxhole1_waves" },
    { 0x9D1AF023, "spawn_foxhole2_waves" },
    { 0x3D430F2A, "spawn_foxhole3_waves" },
    { 0x99B55418, "spawn_friendlies" },
    { 0x0C3458A6, "spawn_from_structs" },
    { 0xB155ED5E, "spawn_frozen_guys" },
    { 0xA5AD1FA0, "spawn_fun_sniper_van" },
    { 0xC4D121B7, "spawn_func" },
    { 0x663D6984, "spawn_func_2" },
    { 0x46B0A4E6, "spawn_func_asd" },
    { 0xB58D600D, "spawn_func_assign_retreat_group" },
    { 0x0E6F0654, "spawn_func_bug_rig_ai" },
    { 0x5BA5BBA9, "spawn_func_capture_zombie" },
    { 0x739E0B0E, "spawn_func_defalco" },
    { 0x3A4E91CD, "spawn_func_delete_on_goal" },
    { 0x2414DDF9, "spawn_func_follow_path" },
    { 0x4642F9BA, "spawn_func_g20_attackers" },
    { 0x69C16868, "spawn_func_harper" },
    { 0x35D77819, "spawn_func_helicopter" },
    { 0x7B8344FF, "spawn_func_hillary" },
    { 0xD5FAE03B, "spawn_func_intersection_fallback_ai" },
    { 0xCB7EEBBE, "spawn_func_intersection_ss" },
    { 0x7499CB73, "spawn_func_jones" },
    { 0xFB5FBF21, "spawn_func_low_road_sniper" },
    { 0xD4029348, "spawn_func_menendez" },
    { 0xBAAD2024, "spawn_func_player_damage_only" },
    { 0xD6C212A2, "spawn_func_rappel" },
    { 0x2AEC2B0A, "spawn_func_recapture_zombie" },
    { 0x2CC2BE13, "spawn_func_running_and_dying" },
    { 0xB5909E1F, "spawn_func_running_and_dying_to_end" },
    { 0x275E608A, "spawn_func_salazar" },
    { 0xCE98096F, "spawn_func_sam" },
    { 0x348BDCB5, "spawn_func_scripted_flyby" },
    { 0x71B7BA59, "spawn_func_setup_death_thread" },
    { 0x7115ECB1, "spawn_func_throttle_spawns" },
    { 0xBE56E5C6, "spawn_func_tunnel_defender" },
    { 0x88EF7E4B, "spawn_funch_stealth_drone1" },
    { 0x5212E6EE, "spawn_funcs" },
    { 0x4C7941D0, "spawn_funcs_drones" },
    { 0x61C5E59D, "spawn_function" },
    { 0x62C8DFE4, "spawn_function_arg" },
    { 0x669579F6, "spawn_function_init" },
    { 0xB69694DC, "spawn_functions" },
    { 0x2FE7558B, "spawn_fx" },
    { 0xEFC0FD84, "spawn_fx_loopers" },
    { 0xD971D4F4, "spawn_fx_on_temp_ent" },
    { 0x995AE949, "spawn_gate_guys_and_delete_others" },
    { 0x610C12DC, "spawn_gaz_trucks" },
    { 0x60F8BE46, "spawn_ghost_round_presentation_ghost" },
    { 0x1638C0CC, "spawn_grass_guys" },
    { 0xABAC349D, "spawn_grenade" },
    { 0x938EF3C2, "spawn_grenade_bag" },
    { 0x21FBA797, "spawn_grenades_at_structs" },
    { 0xDA887CF3, "spawn_ground_target_guys" },
    { 0x78FC6FE2, "spawn_group" },
    { 0xE0F80887, "spawn_guards" },
    { 0x7103480C, "spawn_gunner" },
    { 0x9D64889E, "spawn_guy" },
    { 0x986B063A, "spawn_guy_from_targetname" },
    { 0xA93C315A, "spawn_guy_placement" },
    { 0x6B5BA054, "spawn_guy_that_runs_away" },
    { 0x5DB78A01, "spawn_guys" },
    { 0x531F36DA, "spawn_guys_at_base_entrance" },
    { 0x3CF1CBDC, "spawn_guys_from_krav_door" },
    { 0x24D5F82D, "spawn_guys_from_targetname" },
    { 0x421D9BDB, "spawn_guys_on_landing" },
    { 0xADA657C6, "spawn_guys_that_run_away" },
    { 0x8448E4F5, "spawn_guys_until_death_or_no_count" },
    { 0xAF49BF9A, "spawn_hanging_guys" },
    { 0x91C4C649, "spawn_hazmat_enemies" },
    { 0xD7F5CEB6, "spawn_heavy_guy" },
    { 0x769EEEB3, "spawn_height_max" },
    { 0xF98A30BD, "spawn_height_min" },
    { 0x41F497EC, "spawn_heli_attack" },
    { 0x27B4758A, "spawn_helicopter" },
    { 0x5CF5B3E2, "spawn_hero_drone" },
    { 0xF250BEAD, "spawn_hero_drones" },
    { 0x4AE20171, "spawn_heroes" },
    { 0x51DE46C8, "spawn_heros" },
    { 0xAB876C85, "spawn_heros_for_start" },
    { 0x647C975B, "spawn_hidden_reinforcement" },
    { 0x88D4D2F7, "spawn_highlight" },
    { 0x16E382CA, "spawn_hind" },
    { 0x33B4FF1D, "spawn_hind1_bp1" },
    { 0xBD899BFA, "spawn_hind2_bp1" },
    { 0x548EEEE3, "spawn_hip1_bp1" },
    { 0x0889FA11, "spawn_hip1_bp3" },
    { 0x866F5E54, "spawn_hip2_bp1" },
    { 0xD2745326, "spawn_hip2_bp3" },
    { 0xEF874F4B, "spawn_horse_and_rider" },
    { 0xE7F5123A, "spawn_horse_and_rider_ambient" },
    { 0x7B830A5B, "spawn_horse_charge" },
    { 0x9A3E6D2E, "spawn_horse_lineup" },
    { 0xC6C63EDB, "spawn_horses" },
    { 0x588559B0, "spawn_hostiles" },
    { 0x739DBCD2, "spawn_in_spectate" },
    { 0xD457FBC8, "spawn_in_stealth_failure_guards" },
    { 0xAFD8B3EF, "spawn_index" },
    { 0x1DAE2C0F, "spawn_inert_zombies" },
    { 0xBCB35C8C, "spawn_infinite_powerup_drop" },
    { 0x13CDA9DC, "spawn_influencer" },
    { 0x10D4233B, "spawn_influencer_dropped" },
    { 0x02D2BA5D, "spawn_influencer_enemy" },
    { 0x60E0B6A4, "spawn_influencer_enemy_carrier" },
    { 0x355B0BE6, "spawn_influencer_friendly" },
    { 0xE3ED1A17, "spawn_influencer_friendly_carrier" },
    { 0xE7045A99, "spawn_influencer_inner" },
    { 0xDAF17B1F, "spawn_influencers" },
    { 0x8EF9885E, "spawn_influencers_created" },
    { 0xD23A2BF9, "spawn_influencers_debug_render_thread" },
    { 0xBC6D6BEB, "spawn_init" },
    { 0x1F200288, "spawn_initial_cure_powerup" },
    { 0x97B9265B, "spawn_initial_outside_zombies" },
    { 0x8A112AF5, "spawn_interrogation_heroes" },
    { 0xEFF5671B, "spawn_intro_drone_set" },
    { 0xDBE2D860, "spawn_intro_enemy" },
    { 0x0E80C57F, "spawn_investigation_guards_trig" },
    { 0x3268087D, "spawn_jeeps_and_trucks" },
    { 0x84C0E13B, "spawn_jetwing_group" },
    { 0x8E1F9E63, "spawn_johnny_node_chaser" },
    { 0x8A0F27D7, "spawn_joker_weapon_model" },
    { 0x26360809, "spawn_juggernaut" },
    { 0x512B301E, "spawn_jump_viewmodel" },
    { 0x69A90A62, "spawn_karma_with_bruised_head" },
    { 0xE48BDB80, "spawn_karma_with_cut_throat" },
    { 0x836C1C12, "spawn_karma_with_head_shot" },
    { 0x76727840, "spawn_kill_brush" },
    { 0xDE8D20AC, "spawn_kill_brushes" },
    { 0xB70853D5, "spawn_kravchenko" },
    { 0x9FBEE6E5, "spawn_last_house_enemies" },
    { 0x0A15CA49, "spawn_last_zeros" },
    { 0xD5C0EABD, "spawn_launchpad_ai_trig" },
    { 0xCFC77245, "spawn_learjet_wave_2" },
    { 0x9717F794, "spawn_left1_zero" },
    { 0x6BE4B725, "spawn_left2_zero" },
    { 0x01351ED1, "spawn_level_meat_manager" },
    { 0xC8A1092A, "spawn_life_brush" },
    { 0x0912F6F2, "spawn_life_brushes" },
    { 0x4C7ABBCF, "spawn_lift_boat" },
    { 0x69AE1B86, "spawn_limited_number_from_spawners" },
    { 0xE27B515F, "spawn_line_sound" },
    { 0x135F5262, "spawn_line_sounds_beach" },
    { 0xE39C6BAE, "spawn_lines" },
    { 0x66D7AE95, "spawn_list" },
    { 0x5DC943A2, "spawn_lobby_guys" },
    { 0xF8481969, "spawn_loc" },
    { 0xB5B41657, "spawn_loc_cooldown" },
    { 0xA9248EC0, "spawn_loc_cull_cb" },
    { 0x5A3B3918, "spawn_location" },
    { 0x3657DDF3, "spawn_locations" },
    { 0xB13ED1E0, "spawn_locs" },
    { 0xD5067552, "spawn_manager" },
    { 0xAD131964, "spawn_manager_active_ai" },
    { 0xA2CED170, "spawn_manager_array" },
    { 0x44883B1C, "spawn_manager_auto_targetname_num" },
    { 0x2CE178DD, "spawn_manager_can_spawn" },
    { 0x73F1B0C7, "spawn_manager_cleanup" },
    { 0x524DE3E7, "spawn_manager_create_spawn_manager_struct" },
    { 0x573DE556, "spawn_manager_debug" },
    { 0xC254BBEC, "spawn_manager_debug_hud" },
    { 0xC34122C6, "spawn_manager_debug_hud2" },
    { 0x0854C9D7, "spawn_manager_debug_hud_title" },
    { 0x6D2D8DA0, "spawn_manager_debug_hud_update" },
    { 0x5B99D8B8, "spawn_manager_debug_setup" },
    { 0x2111823A, "spawn_manager_debug_spawn_manager" },
    { 0x2ADBFA39, "spawn_manager_debug_spawn_manager_values_dpad" },
    { 0xBAD6361C, "spawn_manager_debug_spawner_values" },
    { 0xA891EF57, "spawn_manager_disable" },
    { 0xFCB42C0C, "spawn_manager_enable" },
    { 0x59C8D9FD, "spawn_manager_enable_think" },
    { 0x95EE6040, "spawn_manager_enable_trigger_think" },
    { 0x7A1A4608, "spawn_manager_ent" },
    { 0x752C456A, "spawn_manager_flag_cleared" },
    { 0xA192045F, "spawn_manager_flag_complete" },
    { 0x4F80FCC2, "spawn_manager_flag_disabled" },
    { 0xA4C90661, "spawn_manager_flag_enabled" },
    { 0xB2AD4AA9, "spawn_manager_flag_killed" },
    { 0x180DD5B8, "spawn_manager_flags_setup" },
    { 0x0F78CF4B, "spawn_manager_frame_spawns" },
    { 0x96547D01, "spawn_manager_get_spawn_group_size" },
    { 0x826B96E5, "spawn_manager_get_spawners" },
    { 0x47D80BC7, "spawn_manager_insurance" },
    { 0x94A0A7E1, "spawn_manager_kill" },
    { 0x1A7D1C94, "spawn_manager_kill_think" },
    { 0xAD0CABD9, "spawn_manager_kill_trigger_think" },
    { 0x5059C78E, "spawn_manager_main" },
    { 0xB5B6BCE6, "spawn_manager_max_ai" },
    { 0x60968753, "spawn_manager_max_frame_spawn" },
    { 0x4430A4F0, "spawn_manager_random_count" },
    { 0x1F76C1E3, "spawn_manager_sanity" },
    { 0x8B1E96B4, "spawn_manager_set_global_active_count" },
    { 0x8180B524, "spawn_manager_setup" },
    { 0x2DB909FA, "spawn_manager_spawn" },
    { 0x668C4EDE, "spawn_manager_spawn_group" },
    { 0x12173487, "spawn_manager_targetname" },
    { 0x4F3C7857, "spawn_manager_think" },
    { 0x4721A049, "spawn_manager_throttle_reset" },
    { 0x32715CBC, "spawn_manager_throttle_think" },
    { 0x9EB6E779, "spawn_manager_total_count" },
    { 0x960BBCE6, "spawn_manager_wait" },
    { 0xDE2A811E, "spawn_manager_wave" },
    { 0xB1806B2F, "spawn_manager_wave_set" },
    { 0xA59F295D, "spawn_managers" },
    { 0x414C2DB1, "spawn_managers_kill_all_active" },
    { 0x3F33D674, "spawn_map_room_personnel" },
    { 0x298D9C82, "spawn_market_drone" },
    { 0xF3A5102B, "spawn_mason_hill_initial_pdf" },
    { 0x8FFE3B73, "spawn_mason_intro_snipers" },
    { 0xDA933605, "spawn_max" },
    { 0xF508CE66, "spawn_max_mounds" },
    { 0x76A323F9, "spawn_meat_zombie" },
    { 0xE9A28B30, "spawn_meat_zombies" },
    { 0x53C37648, "spawn_mechz" },
    { 0xFB7F6EE5, "spawn_menendez_vtol" },
    { 0xE10D30A1, "spawn_merchant_ship_soldier" },
    { 0xE1D42AED, "spawn_middle_at47" },
    { 0x0C7D40D4, "spawn_middle_building_guys" },
    { 0x34540BA0, "spawn_mig_cave_strafe" },
    { 0x7D46E147, "spawn_mig_flyby" },
    { 0xB64ADC9D, "spawn_mig_intro" },
    { 0x80F9EC80, "spawn_mig_strafe" },
    { 0xFF6AD108, "spawn_mig_tower" },
    { 0xC5748E6B, "spawn_min" },
    { 0x7940E10F, "spawn_mines" },
    { 0x15365E78, "spawn_miscmodel" },
    { 0x1A45ED18, "spawn_mission_courtyard_turret_gunner" },
    { 0xB9FD52A4, "spawn_model" },
    { 0x7FA8E0D7, "spawn_models" },
    { 0xF876AB87, "spawn_more_convoy_behind_me" },
    { 0xAA021714, "spawn_mortar_victims" },
    { 0x6CD6E25E, "spawn_mortarpit_ai" },
    { 0xCB2BA33F, "spawn_mortarpit_dudes" },
    { 0xA7E7E43D, "spawn_moving_cloud" },
    { 0xC647C0AA, "spawn_muj_defenders" },
    { 0x8CF73D84, "spawn_name" },
    { 0x4D6DEBB3, "spawn_navcomputer" },
    { 0x75F4F5BE, "spawn_new_gun" },
    { 0x813A2002, "spawn_next_radio" },
    { 0xCB8D3FAB, "spawn_next_zone" },
    { 0xB618321D, "spawn_node" },
    { 0xF425025C, "spawn_nodes" },
    { 0x991F34C8, "spawn_noteworthy" },
    { 0xCA7CE09E, "spawn_notify" },
    { 0x3297ED97, "spawn_num" },
    { 0x16B81DE4, "spawn_object" },
    { 0x27904A4C, "spawn_off_player" },
    { 0xCB974E89, "spawn_officer" },
    { 0x5252FA79, "spawn_org" },
    { 0x63353033, "spawn_origin" },
    { 0x93DBC6A6, "spawn_outro_axis" },
    { 0x7A2ABF9F, "spawn_package" },
    { 0x689D7789, "spawn_package_code" },
    { 0x608F9CA7, "spawn_path_node" },
    { 0x581DDD01, "spawn_path_node_internal" },
    { 0xDA09BD6E, "spawn_patrol01" },
    { 0x1AE3073A, "spawn_patrol_guys" },
    { 0x22980558, "spawn_patrol_pursuit" },
    { 0xD43D261C, "spawn_per_frame_update" },
    { 0x9E53094F, "spawn_perk_machine" },
    { 0xD292630F, "spawn_perk_upgrade_bottle" },
    { 0xF98A9CAD, "spawn_pickup" },
    { 0xF43A9E1F, "spawn_pickup_weapons" },
    { 0x48781C98, "spawn_pilots" },
    { 0x8D86CD15, "spawn_plane" },
    { 0xC5057EF7, "spawn_plane_and_pace" },
    { 0x3C57F3AD, "spawn_plane_fx_on_death" },
    { 0x14696001, "spawn_plane_group" },
    { 0x765368C6, "spawn_plane_loop_spline" },
    { 0xCE550F64, "spawn_planes" },
    { 0xE4013110, "spawn_player_arms" },
    { 0x2C095251, "spawn_player_body" },
    { 0x5428684F, "spawn_player_btr" },
    { 0xF7337C08, "spawn_player_clone" },
    { 0x388EFA31, "spawn_player_hands" },
    { 0x035FD3AC, "spawn_player_meat_manager" },
    { 0xB3ADDC20, "spawn_player_model" },
    { 0x2CC4D3C1, "spawn_player_plane" },
    { 0x824CC91F, "spawn_player_specific_model" },
    { 0xAEB784BF, "spawn_player_strafing_wave" },
    { 0x18196FA5, "spawn_point" },
    { 0x79666696, "spawn_point_class_name_being_used" },
    { 0x32EF48C5, "spawn_point_class_names" },
    { 0x74DEFC89, "spawn_point_entity" },
    { 0xAE5A64EC, "spawn_point_index" },
    { 0x9E2E38A8, "spawn_point_override" },
    { 0x38A63F67, "spawn_point_team_class_names" },
    { 0xA6321583, "spawn_point_team_name" },
    { 0x423D10B4, "spawn_points" },
    { 0xEE40077D, "spawn_pos" },
    { 0x85294724, "spawn_position" },
    { 0xB4182BDB, "spawn_pre_last_trench_guys" },
    { 0x4225A7D0, "spawn_prethink" },
    { 0x9EB4FE13, "spawn_priority_target_death_squad" },
    { 0x654E9B3C, "spawn_prisoners" },
    { 0xF955CC7C, "spawn_prize_glob" },
    { 0xA2EDA586, "spawn_prop" },
    { 0xA1CAC5E5, "spawn_prop_grenade" },
    { 0x3BCFC005, "spawn_punch_upgrade_tablet" },
    { 0xD09BBA38, "spawn_qdrotor_end_wave" },
    { 0xEE2EEB87, "spawn_quadrotor_and_drive_path" },
    { 0xA03D38C8, "spawn_quadrotor_formation" },
    { 0x6337B233, "spawn_quadrotor_pickup" },
    { 0x650B1B47, "spawn_quadrotors" },
    { 0xC6389246, "spawn_quadrotors_at_structs" },
    { 0xCCB47F2F, "spawn_ragdoll_corpses_at_structs" },
    { 0xF69AF048, "spawn_railclimb_guy" },
    { 0x7A3551B6, "spawn_ram_gate_uaz" },
    { 0xDF51DF3E, "spawn_random_allies_drone" },
    { 0x12680DE7, "spawn_random_axis_drone" },
    { 0x0E967EB7, "spawn_random_pickup" },
    { 0xE4E0D532, "spawn_random_weapon_pickup" },
    { 0x8D78E9DE, "spawn_rappel_hands" },
    { 0xCCE2311D, "spawn_raps" },
    { 0x4301C4BC, "spawn_recharge_tanks" },
    { 0x6E4399F9, "spawn_redshirts" },
    { 0x04944048, "spawn_regular_patrollers" },
    { 0xD54B1934, "spawn_reinforcement" },
    { 0xCA2A8E27, "spawn_reinforcements" },
    { 0xCEEC77C8, "spawn_replacement_ally" },
    { 0x4E7B547A, "spawn_replacement_baddies" },
    { 0x33AC17F5, "spawn_replacement_cliff_baddies" },
    { 0x6B61A238, "spawn_reward" },
    { 0xDB9045F1, "spawn_rideable_horse" },
    { 0xCCAC797E, "spawn_riders" },
    { 0xE3DFB6FE, "spawn_ridge_filler_enemies" },
    { 0xDC738E3F, "spawn_right1_zero" },
    { 0x553D2F1F, "spawn_right1_zerob" },
    { 0xE9741EF5, "spawn_right_truck" },
    { 0xC0D5AB63, "spawn_roof_sam" },
    { 0xD2414BC8, "spawn_rooftop" },
    { 0xDBD7D2A1, "spawn_rooftop_melee" },
    { 0xFADB0A74, "spawn_rooftop_vtol" },
    { 0x37751465, "spawn_rope" },
    { 0x9381F28E, "spawn_rts_cam" },
    { 0x0567EAFB, "spawn_ruins_pickup_weapons" },
    { 0x2D63E044, "spawn_salazar_guards" },
    { 0x6CCC19A2, "spawn_salazar_serverroom" },
    { 0x386CF0B1, "spawn_sam_drone_group" },
    { 0xDCCB4A6C, "spawn_sampan_atackers_early" },
    { 0xC40FC40A, "spawn_script_model_at_struct" },
    { 0x1412E1FB, "spawn_script_model_fx" },
    { 0xE10B6C8E, "spawn_script_noteworthy" },
    { 0xD660F0DD, "spawn_script_origin" },
    { 0x901CB8B3, "spawn_sdk" },
    { 0x53B8A283, "spawn_seaknight_crew" },
    { 0x8D40DBAF, "spawn_seals_from_optional_objective" },
    { 0xCD6B55A9, "spawn_searchlight_target" },
    { 0x8194BCC2, "spawn_second_wave_quads" },
    { 0x8A3B0C21, "spawn_secondary_fire_fx" },
    { 0xDC4ACAEB, "spawn_security_feed_ai" },
    { 0x731E2FA6, "spawn_security_feed_ai_spawner" },
    { 0xB1936AB8, "spawn_selected_object" },
    { 0xEE82C4BA, "spawn_selected_prop" },
    { 0xD9933F22, "spawn_sequence" },
    { 0x605F8EE8, "spawn_sergei_postcb" },
    { 0xA47B1F6F, "spawn_set" },
    { 0xB320EC80, "spawn_setcharacter" },
    { 0xB387A968, "spawn_ship_squad" },
    { 0x3F112050, "spawn_shovelers" },
    { 0xA5E6CADC, "spawn_side" },
    { 0xD297B002, "spawn_single_ally" },
    { 0x94CE6F93, "spawn_single_patroller" },
    { 0xD9412D32, "spawn_size" },
    { 0x439A6A14, "spawn_skel" },
    { 0x6E9AD745, "spawn_slingshot_ammo" },
    { 0x9CAE655B, "spawn_solid_fx" },
    { 0xF3C31717, "spawn_special_ai" },
    { 0x60CBA188, "spawn_specific_pickup" },
    { 0x22A28895, "spawn_spot" },
    { 0x7A0C6E11, "spawn_squad" },
    { 0x58A6ADEA, "spawn_squad_member" },
    { 0xFF7EC194, "spawn_squad_num" },
    { 0x8ABE1E42, "spawn_squad_trig" },
    { 0xFC0EE0BE, "spawn_sr71" },
    { 0x58287522, "spawn_sr71_cam" },
    { 0x9A83F82C, "spawn_stair_guy" },
    { 0xCF71850E, "spawn_stair_mowdown" },
    { 0x6A1ABB61, "spawn_stargate_fx_origins" },
    { 0xFBF937DF, "spawn_start" },
    { 0xCB7BCC69, "spawn_starting_friendlies" },
    { 0x76A9DB04, "spawn_static_actors" },
    { 0x65F114EF, "spawn_static_civs" },
    { 0x0FAD9730, "spawn_static_club_civs" },
    { 0x59ADAA09, "spawn_static_vehicles" },
    { 0x5C266120, "spawn_steiners_office_ai" },
    { 0xE7A8164A, "spawn_straffing_drone" },
    { 0x99005AC5, "spawn_stragglers" },
    { 0x24474D4D, "spawn_street_pickup_weapons" },
    { 0x9DE972E1, "spawn_stretcher" },
    { 0xF2945ECA, "spawn_struct" },
    { 0x02095317, "spawn_super_soct_trigger" },
    { 0x3D0D3026, "spawn_swift" },
    { 0x550A6E27, "spawn_tablet_model" },
    { 0xE539441F, "spawn_tag" },
    { 0xA0453888, "spawn_tag_origin" },
    { 0xBE0110A6, "spawn_tags" },
    { 0x9A0F8909, "spawn_tank" },
    { 0x7C57BC00, "spawn_tanks" },
    { 0xFC59A49E, "spawn_tanks_soon" },
    { 0x5BA3D7BE, "spawn_target_trigs" },
    { 0x031D673B, "spawn_targetname" },
    { 0x7D2EE7AA, "spawn_team" },
    { 0x4E52CF18, "spawn_tear_guys" },
    { 0xAC1F2C81, "spawn_technicals" },
    { 0xE443C43B, "spawn_telemetry_enemies" },
    { 0x1F336160, "spawn_telemetry_friendlies" },
    { 0xAF69064D, "spawn_teleporter" },
    { 0xDD121EBF, "spawn_temp_specialist_model" },
    { 0xAC715A23, "spawn_terrorist_rappel_guys" },
    { 0x0B3E869B, "spawn_the_big_boss" },
    { 0xF5D3130B, "spawn_think" },
    { 0x3C347390, "spawn_think_action" },
    { 0x7E4D389F, "spawn_think_thread_active" },
    { 0xDD5783D7, "spawn_throttle_enable_thread_ender" },
    { 0x6DA740F5, "spawn_throttle_reset" },
    { 0xEDDFCE6C, "spawn_through" },
    { 0xEFCD5FD5, "spawn_tigers" },
    { 0x8629833A, "spawn_time" },
    { 0x3543CED5, "spawn_to_die" },
    { 0x1F81E4AD, "spawn_todo" },
    { 0x9C3E9C97, "spawn_tower_guys" },
    { 0x5AD20259, "spawn_trainyard_runners" },
    { 0xDAC5039F, "spawn_trap_piece" },
    { 0xF9759CFB, "spawn_trapped" },
    { 0x402BBE36, "spawn_treasure" },
    { 0x75019B29, "spawn_treasures" },
    { 0x65046EED, "spawn_trenchrun_plane" },
    { 0x81112F1F, "spawn_trig" },
    { 0xBB25FF23, "spawn_trigger" },
    { 0xEB5EA53B, "spawn_trigger2" },
    { 0x5F3E70D8, "spawn_trigger_2" },
    { 0xF8C0A45E, "spawn_trigger_dummy" },
    { 0xE9E42063, "spawn_trigger_name" },
    { 0xC54D127D, "spawn_trigger_wait" },
    { 0xEFF90220, "spawn_truckride" },
    { 0x348D993A, "spawn_turrets" },
    { 0x14304BAC, "spawn_uaz1_arena" },
    { 0xEBE1FE3B, "spawn_uaz2_arena" },
    { 0xCA6EA392, "spawn_uaz3_arena" },
    { 0x3DD12F47, "spawn_uaz_bp3" },
    { 0xD1DCBE3C, "spawn_uber_prize" },
    { 0xEC0FF3FF, "spawn_uber_prizes" },
    { 0xCDA9A682, "spawn_upgraded_staff_triggers" },
    { 0xE83DFF7E, "spawn_utility_enemies" },
    { 0x210942EF, "spawn_vehicle" },
    { 0xC7DB0E1F, "spawn_vehicle_claw" },
    { 0xFD037C6B, "spawn_vehicle_from_targetname" },
    { 0x20DC0554, "spawn_vehicle_from_targetname_and_drive" },
    { 0x66A36C87, "spawn_vehicle_gibs" },
    { 0x208F7513, "spawn_vehicle_ground_claw" },
    { 0xACE8BCA6, "spawn_vehicle_influencer_lead_seconds" },
    { 0x9F97A5D9, "spawn_vehiclegroup_and_go_to_end_node_quick_and_then_blow_up_boy_this_function_name_is_sure_going_to_make_mackey_smile" },
    { 0x76BE7F36, "spawn_vehicles" },
    { 0xFFBF861C, "spawn_vehicles_bp1" },
    { 0x97A7CFB2, "spawn_vehicles_from_targetname" },
    { 0x194ECBA1, "spawn_vehicles_from_targetname_and_drive" },
    { 0xBA4FB3E8, "spawn_vehicles_from_targetname_and_gopath" },
    { 0xB29A7FC6, "spawn_vignette_guys" },
    { 0xF57F2C4F, "spawn_visibility_check_max" },
    { 0x638EC3D4, "spawn_vo" },
    { 0x2635168C, "spawn_vo_player" },
    { 0x267BB4EB, "spawn_volume" },
    { 0x4598A1CA, "spawn_volumes" },
    { 0xFF4EF110, "spawn_vtols_at_structs" },
    { 0x9944F1A7, "spawn_walker" },
    { 0x00B820D8, "spawn_wasp" },
    { 0xB0C8514D, "spawn_wave_of_mutilation" },
    { 0xC06C793D, "spawn_weapon" },
    { 0xCF6E931E, "spawn_weapon_cache" },
    { 0x6EEC6C13, "spawn_weapon_cache1" },
    { 0xFCE4FCD8, "spawn_weapon_cache2" },
    { 0x22E77741, "spawn_weapon_cache3" },
    { 0xE0F3DB4E, "spawn_weapon_cache4" },
    { 0x06F655B7, "spawn_weapon_cache5" },
    { 0x94EEE67C, "spawn_weapon_cache6" },
    { 0xBAF160E5, "spawn_weapon_cache7" },
    { 0xB22C17A7, "spawn_weapon_model" },
    { 0xCBA6E4B1, "spawn_weaver" },
    { 0x0AC76F75, "spawn_weaver_eye_helicopter" },
    { 0xB6F7226E, "spawn_wingsuit_and_drive_on_path" },
    { 0x3BCFD5B5, "spawn_with_delay" },
    { 0x4DC3FC25, "spawn_woods" },
    { 0x86C0A574, "spawn_woods_freakout_pdf" },
    { 0x44139EF7, "spawn_woods_undercover" },
    { 0xDBD29211, "spawn_wounded" },
    { 0x359F9B05, "spawn_wounded_at_struct" },
    { 0x5CA45BD1, "spawn_zodiac_littlebird" },
    { 0xD974570F, "spawn_zombie" },
    { 0x4100E141, "spawn_zombie_blood_plane" },
    { 0x31040961, "spawn_zombie_clone" },
    { 0xC8C28E2D, "spawn_zombies_after_time_bomb_round_killed" },
    { 0x3EF14F6A, "spawnable" },
    { 0xF41469A9, "spawnable_weapon" },
    { 0xE02E3A88, "spawnable_weapon_spawns" },
    { 0x76104227, "spawnactionbuttons" },
    { 0x99D28301, "spawnactor" },
    { 0x5062DF78, "spawnai" },
    { 0x21BCADE2, "spawnalllocs" },
    { 0x1A043076, "spawnallmaxs" },
    { 0x127254B8, "spawnallmins" },
    { 0x0D45BE71, "spawnandlinkfxtooffset" },
    { 0xAE5B32D8, "spawnandlinkfxtotag" },
    { 0xD521FD4A, "spawnangles" },
    { 0x484FB571, "spawnarray" },
    { 0xCDA1F3BD, "spawnaxis" },
    { 0x52F6835A, "spawnbomb" },
    { 0xFF9BBB0C, "spawnbreachhostiles" },
    { 0x77868CD5, "spawncameraglass" },
    { 0xC61DFBC6, "spawncargo" },
    { 0xA727D3AF, "spawnchicken" },
    { 0x8CF047B8, "spawncivilian_trigger" },
    { 0x97CC33C0, "spawncivilians" },
    { 0xF3DB290B, "spawnclient" },
    { 0xAEB6047C, "spawnclones" },
    { 0xCBED290E, "spawncollision" },
    { 0x74FF82F3, "spawncount" },
    { 0x189EC4B2, "spawncounteruav" },
    { 0xA0194395, "spawndart" },
    { 0x3F63526E, "spawndata" },
    { 0x5E011E53, "spawndef" },
    { 0xD15FB757, "spawndelay" },
    { 0x26EEA0C3, "spawndogtags" },
    { 0x9C823234, "spawndrone" },
    { 0x92B65DFE, "spawndude" },
    { 0xAB1F9EA1, "spawned" },
    { 0xB4B2768C, "spawned_ai_dont_move" },
    { 0xAC887E23, "spawned_banzai_dynamic" },
    { 0x3D8CDC9F, "spawned_banzai_immediate" },
    { 0xA34FC332, "spawned_bots" },
    { 0xBA5BA8C5, "spawned_callback" },
    { 0xD4EB1DB8, "spawned_charge" },
    { 0xB620B1D6, "spawned_collision_ffotd" },
    { 0xE871211C, "spawned_collision_fix" },
    { 0x53A935E0, "spawned_collmap" },
    { 0xB9F52FA9, "spawned_count" },
    { 0x3F53379E, "spawned_cymbal_monkey" },
    { 0xE545EF1D, "spawned_guy" },
    { 0x59720737, "spawned_hud" },
    { 0x381B7570, "spawned_killcam_cleanup" },
    { 0x647DCB36, "spawned_life_triggers" },
    { 0x8D7B7DB3, "spawned_player" },
    { 0x8179169D, "spawned_riot_shields" },
    { 0xAD2C7BB9, "spawned_slide_prone_trigger" },
    { 0x32B67123, "spawned_slide_push_trigger" },
    { 0x7F738843, "spawned_spectator" },
    { 0xEE496415, "spawned_spike_charge" },
    { 0xA68036E2, "spawned_this_frame" },
    { 0x8D6392CC, "spawned_this_wave" },
    { 0xBD8838FF, "spawned_vehicles" },
    { 0xEC77BA18, "spawned_wallbuy" },
    { 0xEEA4122F, "spawned_weapon_type" },
    { 0x681A826C, "spawned_with" },
    { 0xDABF8AE2, "spawned_zombie" },
    { 0x336752AE, "spawnedaitypes" },
    { 0xF3A64B3B, "spawnedallies" },
    { 0xE5226D10, "spawnedasspectator" },
    { 0xD621D691, "spawnedglobalscramber" },
    { 0x560591DA, "spawnedguy" },
    { 0x7DAC91D5, "spawnedguys" },
    { 0x6B1CC19E, "spawnedkillcamcleanup" },
    { 0xA6045408, "spawnedmodel" },
    { 0x8BBD150B, "spawnedperclient" },
    { 0x948C304E, "spawnedscrambler" },
    { 0xD1FAA707, "spawnedtargetname" },
    { 0x82EE334B, "spawnedthreatdetector" },
    { 0xBFEB4A66, "spawneduavs" },
    { 0x748A56EA, "spawnedvehicles" },
    { 0x5E6C596B, "spawnendoffinalkillcam" },
    { 0x50231AB5, "spawnentities_s" },
    { 0x2F06D687, "spawner" },
    { 0x484A486C, "spawner1" },
    { 0xBA51B7A7, "spawner2" },
    { 0x944F3D3E, "spawner3" },
    { 0xD642D931, "spawner4" },
    { 0xB0405EC8, "spawner5" },
    { 0xA0E9AB4F, "spawner_1" },
    { 0x2EE23C14, "spawner_2" },
    { 0x54E4B67D, "spawner_3" },
    { 0xE2DD4742, "spawner_4" },
    { 0x08DFC1AB, "spawner_5" },
    { 0x10B2DF66, "spawner_ambush_fill_left" },
    { 0x3EE742A6, "spawner_ang" },
    { 0x8E30635D, "spawner_array" },
    { 0xA6B4F4D2, "spawner_array_2" },
    { 0xEFAD48AB, "spawner_beater" },
    { 0x390BFF4F, "spawner_calculate_active_count" },
    { 0xA5DA94B9, "spawner_capture_zombie" },
    { 0x1861712F, "spawner_count" },
    { 0xC4F53B9C, "spawner_count_with_min_active" },
    { 0x90F1302A, "spawner_deathflag" },
    { 0xB4CCB413, "spawner_delete" },
    { 0x53B881FD, "spawner_dronespawn" },
    { 0x23DC2925, "spawner_expired" },
    { 0x1C2C9F98, "spawner_fallbackers" },
    { 0x6A022283, "spawner_guy" },
    { 0x14FE6F41, "spawner_id" },
    { 0x8780D55E, "spawner_index" },
    { 0x8B649865, "spawner_int" },
    { 0x31A58239, "spawner_main_chamber_capture_zombies" },
    { 0xF7CC5208, "spawner_make_real_ai" },
    { 0xBD4465C2, "spawner_makerealai" },
    { 0x980C55BF, "spawner_manager" },
    { 0xE5D9A7AD, "spawner_max_active_count" },
    { 0xEBCF423F, "spawner_name" },
    { 0x3D35E6DF, "spawner_noteworthies" },
    { 0xBB8A32AB, "spawner_noteworthy" },
    { 0xAEEB2409, "spawner_notifies" },
    { 0xC9BDA3C1, "spawner_notify_manager" },
    { 0x951E0AAA, "spawner_num" },
    { 0x0297CF49, "spawner_number" },
    { 0xEAD34F7C, "spawner_org" },
    { 0xD6F3A912, "spawner_override" },
    { 0xC250BD28, "spawner_primary" },
    { 0x83AF2FEB, "spawner_processes_colorcoded_ai" },
    { 0xE34E26A5, "spawner_ref" },
    { 0x719092FA, "spawner_run_to_node" },
    { 0xEFA105D8, "spawner_secondary" },
    { 0xFDA9E1A3, "spawner_secondary_chance" },
    { 0x62EEE0E7, "spawner_secondary_type" },
    { 0xB7C9A75A, "spawner_set" },
    { 0x7EBDBD32, "spawner_set_cleanup_category" },
    { 0xC4110989, "spawner_setup" },
    { 0x44EF0211, "spawner_shared" },
    { 0xBE40C8BF, "spawner_switch_think" },
    { 0x2AD952EF, "spawner_switch_think2" },
    { 0x36EE2161, "spawner_target_name" },
    { 0xC7FEC308, "spawner_target_names" },
    { 0xAADB7D08, "spawner_target_set" },
    { 0x6E24F5BC, "spawner_targetname" },
    { 0x8AC7BD04, "spawner_targets" },
    { 0xA8D978F5, "spawner_targets_init" },
    { 0x9A1E641E, "spawner_think" },
    { 0xE15409CA, "spawner_trigger" },
    { 0xCEAA7A33, "spawner_trigs" },
    { 0x11D5EF02, "spawner_type" },
    { 0x5970F9B7, "spawner_vc_temp_mg" },
    { 0x73CB6A5A, "spawner_victim" },
    { 0x94D836A2, "spawner_zone_name" },
    { 0x5AB6BB7A, "spawnerarray" },
    { 0xE3C284CE, "spawnercallbackthread" },
    { 0xCB545895, "spawnerclass" },
    { 0xC2F7261C, "spawnerclassname" },
    { 0x9BC02874, "spawnercount" },
    { 0x70296209, "spawnerfree" },
    { 0x21C2925C, "spawnerkey" },
    { 0x537B7C9F, "spawnerkeys" },
    { 0x287D67B6, "spawnermodel" },
    { 0x82BEC3A4, "spawnermove" },
    { 0x0CAA771A, "spawnername" },
    { 0x67CB78E1, "spawnernum" },
    { 0x14EDD77E, "spawners" },
    { 0x555DB954, "spawners_crouch_prone" },
    { 0x0BA0D8E4, "spawners_name" },
    { 0x71AA3DF8, "spawners_narrow" },
    { 0xF7C8003A, "spawners_ready" },
    { 0x747BD610, "spawners_setup" },
    { 0x6DC43CAA, "spawners_to_compound" },
    { 0xFA461AA4, "spawners_to_delete" },
    { 0x2B09EE86, "spawners_trigs" },
    { 0x6F101D02, "spawners_ucut" },
    { 0x3074FD70, "spawnerstodeletekillspawner" },
    { 0x6E52AE99, "spawnertargetname" },
    { 0x2C258E39, "spawnerthink" },
    { 0x10EBF50D, "spawnertn" },
    { 0x8064610F, "spawnertype" },
    { 0xC021AA1C, "spawnerval" },
    { 0x7867A224, "spawnerwave" },
    { 0xFF941BF2, "spawnevent" },
    { 0x9654A254, "spawneventinit" },
    { 0x0AEB4A72, "spawnexplosiveboltenemies" },
    { 0x6F22AB68, "spawnexplosiveboltfriendlycover" },
    { 0x7931B088, "spawnfakearms" },
    { 0xEE4EB448, "spawnfakeent" },
    { 0x553273FE, "spawnfakeplayer" },
    { 0xAB8E20FC, "spawnflag" },
    { 0xA38BAD5A, "spawnflag_actor" },
    { 0xA7285C65, "spawnflag_actor_scriptdeleteonzerocount" },
    { 0x49910006, "spawnflag_actor_scriptforcespawn" },
    { 0xFF710979, "spawnflag_actor_scriptinfinitespawn" },
    { 0x0084AB1F, "spawnflag_actor_scriptmakeroom" },
    { 0x32233D30, "spawnflag_actor_sm_priority" },
    { 0xC8EF5DF3, "spawnflag_actor_spawner" },
    { 0x51DF999A, "spawnflag_model_dynamic_path" },
    { 0xF1539077, "spawnflag_path_balcony" },
    { 0x8DE3E525, "spawnflag_path_balcony_norailing" },
    { 0xDDB12114, "spawnflag_path_can_parent" },
    { 0x480C73ED, "spawnflag_path_disabled" },
    { 0xF6F22071, "spawnflag_path_dont_crouch" },
    { 0x0A1E64F0, "spawnflag_path_dont_left" },
    { 0x06F747EB, "spawnflag_path_dont_link" },
    { 0x678A285F, "spawnflag_path_dont_prone" },
    { 0xE2D0659F, "spawnflag_path_dont_right" },
    { 0x8EB75B39, "spawnflag_path_dont_stand" },
    { 0x9CA871A8, "spawnflag_path_double_wide" },
    { 0xCA00DC3A, "spawnflag_path_not_chain" },
    { 0xEB5B6E84, "spawnflag_path_procedural" },
    { 0x492F2B54, "spawnflag_path_quadrotor" },
    { 0xD637CEA6, "spawnflag_path_stance_crouch" },
    { 0xC4DB4C8E, "spawnflag_path_stance_prone" },
    { 0xB61AC7B4, "spawnflag_path_stance_stand" },
    { 0xA19A0724, "spawnflag_path_wallrun" },
    { 0xA83C17F7, "spawnflag_scriptbundle_init" },
    { 0x62AB6C6B, "spawnflag_scriptbundle_play" },
    { 0xE85BA8B0, "spawnflag_start_node" },
    { 0xBCE8750B, "spawnflag_trigger_ai_allies" },
    { 0xABE72022, "spawnflag_trigger_ai_axis" },
    { 0x8B00510E, "spawnflag_trigger_ai_neutral" },
    { 0x272062C6, "spawnflag_trigger_hurt_ignore_last_stand" },
    { 0xF2156A7B, "spawnflag_trigger_hurt_no_protection" },
    { 0xC8CDE645, "spawnflag_trigger_hurt_once" },
    { 0xF21CC8A2, "spawnflag_trigger_hurt_player_only" },
    { 0x1AD7C289, "spawnflag_trigger_hurt_silent" },
    { 0xA786F1B9, "spawnflag_trigger_hurt_slow" },
    { 0xE421E314, "spawnflag_trigger_hurt_start_off" },
    { 0xDD6F15C1, "spawnflag_trigger_look" },
    { 0x7DC14311, "spawnflag_trigger_not_player" },
    { 0xE70D16E5, "spawnflag_trigger_spawn" },
    { 0xAAB053F5, "spawnflag_trigger_spawn_manager" },
    { 0xEB51EFC3, "spawnflag_trigger_touch_once" },
    { 0x606EFB48, "spawnflag_trigger_trigger_once" },
    { 0x39D28178, "spawnflag_trigger_vehicle" },
    { 0x1779168F, "spawnflag_turret_enabled" },
    { 0xEF307461, "spawnflag_turret_get_users" },
    { 0x22A55520, "spawnflag_turret_preplaced" },
    { 0xC6EBBD86, "spawnflag_vehicle_node_rotate" },
    { 0x865325CC, "spawnflag_vehicle_node_start_node" },
    { 0x1258E226, "spawnflag_vehicle_scriptdeleteonzerocount" },
    { 0xB3B576E3, "spawnflag_vehicle_scriptforcespawn" },
    { 0x93E12A3A, "spawnflag_vehicle_scriptinfinitespawn" },
    { 0x58473136, "spawnflag_vehicle_scriptmakeroom" },
    { 0xF8E55E9B, "spawnflag_vehicle_sm_priority" },
    { 0x288D2408, "spawnflag_vehicle_spawner" },
    { 0x16DA7701, "spawnflag_vehicle_useable" },
    { 0x5F8B9CBF, "spawnflags" },
    { 0x497C3419, "spawnflags_copy" },
    { 0xF72C5BB0, "spawnflakrocket" },
    { 0x93F55A7E, "spawnflare" },
    { 0xCB1FD98F, "spawnfriendly" },
    { 0x8F111F7A, "spawnfromspawner" },
    { 0xCF8C2FF9, "spawnfull" },
    { 0x2873B154, "spawnfunc" },
    { 0x36373024, "spawnfunc_e2_building_guys" },
    { 0x6E75F3F3, "spawnfunc_e2_init" },
    { 0xC26E6579, "spawnfunc_e2_truck_guys" },
    { 0x240A6236, "spawnfunc_ignoreall" },
    { 0x8033047F, "spawnfunc_ikpriority" },
    { 0xE9B8C0B8, "spawnfunc_no_name" },
    { 0xDBCC5EE4, "spawnfunc_player_rusher" },
    { 0xCF80252E, "spawnfunc_railclimb" },
    { 0x229DE46B, "spawnfunc_setthreatbiasgroup" },
    { 0x001A403C, "spawnfunc_towersniper_init" },
    { 0xD0D02E7E, "spawnfunc_truck_riders_delete" },
    { 0x53B0A2C7, "spawnfuncs" },
    { 0xC3FFF4BA, "spawnfunction" },
    { 0x3F9B9B7A, "spawnfunction_burning_guy" },
    { 0x94D5197C, "spawnfx" },
    { 0x1A7F5E58, "spawnfx_wrapper" },
    { 0xD5F0F98F, "spawngameid" },
    { 0xC691E3F4, "spawngin" },
    { 0x302396B4, "spawngiunit" },
    { 0x4F8D2326, "spawngraph" },
    { 0x773C4426, "spawngraphcheck" },
    { 0x7F6464D0, "spawngraphline" },
    { 0x2930FCE0, "spawngroundflame" },
    { 0x76F0C327, "spawngroup" },
    { 0x6ACBF19E, "spawngroups" },
    { 0x43F783BC, "spawngroupsize" },
    { 0x4F348790, "spawnguards" },
    { 0x51205544, "spawnguards_in_room" },
    { 0x053559BD, "spawnhelicopter" },
    { 0x631DB007, "spawnheligunner" },
    { 0x67866405, "spawnhiddenclone" },
    { 0x66CE4E94, "spawnhostile" },
    { 0xDD4581BB, "spawni" },
    { 0x67C47025, "spawnid" },
    { 0xCE8A1CB7, "spawnidx" },
    { 0x02DFE851, "spawnimmediate" },
    { 0x6E7AF8BA, "spawnindex" },
    { 0xF8693AB7, "spawninfluencer" },
    { 0x8A350862, "spawninfluencercloseid" },
    { 0xBDE4F788, "spawninfluencerid" },
    { 0x52DEFFE2, "spawning" },
    { 0x230C9833, "spawning_find_best_spawn_entity_for_player" },
    { 0x2CDCE66C, "spawningplayers" },
    { 0x09991493, "spawninitcb" },
    { 0x8D9835BA, "spawnintermission" },
    { 0xF4876F2C, "spawninterroundintermission" },
    { 0x7501043A, "spawnkill" },
    { 0xAD0D8732, "spawnkilltrigger" },
    { 0x02FE66E4, "spawnloc" },
    { 0xA352A6DA, "spawnlocations" },
    { 0xAD98F617, "spawnlocs" },
    { 0x04A43BA8, "spawnlogic" },
    { 0xA56BBC7A, "spawnlogic_begin" },
    { 0x2858620E, "spawnlogic_deaths" },
    { 0x828447E7, "spawnlogic_killdist" },
    { 0x58389F10, "spawnlogic_killtime" },
    { 0x98822143, "spawnlogic_spawnkills" },
    { 0xB4C83192, "spawnmanagers" },
    { 0xF3D9376A, "spawnmannequin" },
    { 0x09DBB644, "spawnmapcollision" },
    { 0x2E3EC4B4, "spawnmax" },
    { 0x51C188A7, "spawnmaxs" },
    { 0xD4B32A23, "spawnmessage" },
    { 0x5B4B38FA, "spawnmin" },
    { 0xD79A0FC2, "spawnminemover" },
    { 0x6AF14375, "spawnmins" },
    { 0x6A93A097, "spawnminsmaxsprimed" },
    { 0xABCDA0EC, "spawnmodelname" },
    { 0x8B2438E5, "spawnmonitorspeed" },
    { 0xE3B44D0B, "spawnmovetrigger" },
    { 0x1C5462D1, "spawnnapalmgroundflame" },
    { 0xC86848F2, "spawnnode" },
    { 0x120C4EC7, "spawnoffset" },
    { 0x884F63AD, "spawnonce" },
    { 0x03131097, "spawnonhost" },
    { 0x835D9087, "spawnoninit" },
    { 0x870C1324, "spawnorigin" },
    { 0x0A2CFB26, "spawnoverride" },
    { 0xE2633EF3, "spawnpathnode" },
    { 0x18E46119, "spawnpausecount" },
    { 0x3D970759, "spawnperframeupdate" },
    { 0x0E785B40, "spawnpickupfx" },
    { 0x77288A3F, "spawnplaceable" },
    { 0x8A724B74, "spawnplane" },
    { 0x1FEE8319, "spawnplayer" },
    { 0x45ED2CEE, "spawnplayerhelicopter" },
    { 0x9D823940, "spawnplayermodel" },
    { 0xF868991E, "spawnplayerprediction" },
    { 0x3F6206F4, "spawnpoint" },
    { 0xEED34C85, "spawnpoint_init" },
    { 0x9BC4ADF6, "spawnpoint_name" },
    { 0x3C700F78, "spawnpoint_playersview" },
    { 0xBB6A45E8, "spawnpoint_update" },
    { 0x9AE280CD, "spawnpointclassname" },
    { 0x2AFA9229, "spawnpointdir" },
    { 0x0C87CE48, "spawnpointindex" },
    { 0xEE86AFAA, "spawnpointinit" },
    { 0x9885F415, "spawnpointname" },
    { 0x58320F6E, "spawnpointnamebase" },
    { 0x2213D792, "spawnpointorigin" },
    { 0x8D8007E7, "spawnpoints" },
    { 0xE1FCDDBF, "spawnpointtarget" },
    { 0xA7E1A5C7, "spawnpointupdate" },
    { 0x15C7A101, "spawnpointupdate_zm" },
    { 0x814978E0, "spawnpos" },
    { 0xA869C16F, "spawnposition" },
    { 0x3107C3A3, "spawnpreloop" },
    { 0x31AC2742, "spawnprerise" },
    { 0x2513EC92, "spawnproc" },
    { 0xDB418365, "spawnprofile" },
    { 0x44F4F951, "spawnprotectionactive" },
    { 0xE37113D4, "spawnprotectioninactive" },
    { 0xCF312CE0, "spawnprotectiontime" },
    { 0x00FBE364, "spawnprotectiontimems" },
    { 0x3D552AAA, "spawnpt" },
    { 0x44B5FC07, "spawnqueue" },
    { 0xDCB186D4, "spawnqueuedclient" },
    { 0x20DDC4C4, "spawnqueuedclientonteam" },
    { 0x4C049C79, "spawnqueueindex" },
    { 0x74D78ADE, "spawnqueuemodified" },
    { 0x3D9257F3, "spawnrap" },
    { 0x26D9E1A2, "spawnraps" },
    { 0xC46EC6D9, "spawnrapshelicopter" },
    { 0x5DE84507, "spawnrcbomb" },
    { 0x83A8F992, "spawnreplacement" },
    { 0x43AAF247, "spawnresurrect" },
    { 0xE977692A, "spawnretrievablekniferang" },
    { 0x97FC85BC, "spawnriotshieldcover" },
    { 0xEF0D9A68, "spawnrocks" },
    { 0x217C06C1, "spawns" },
    { 0xB163CDFA, "spawns1" },
    { 0x8B615391, "spawns2" },
    { 0x655ED928, "spawns3" },
    { 0x95A56D7F, "spawnsafezone" },
    { 0x56D27A70, "spawnscore" },
    { 0xA616C034, "spawnshort" },
    { 0x367A1A29, "spawnsize" },
    { 0xC11BDE87, "spawnsmokegrenadetrigger" },
    { 0xBFE8AA13, "spawnsound" },
    { 0xDEDBB7C9, "spawnspectator" },
    { 0x275E440B, "spawnsquadatjeep" },
    { 0xC4B73218, "spawnstatusslot" },
    { 0xA8FB77BD, "spawnstruct" },
    { 0xDB8DE5F6, "spawnstructcb" },
    { 0x79E9652B, "spawnsvehicle" },
    { 0x4E502529, "spawnsystem" },
    { 0xDF886ACE, "spawnt" },
    { 0xC6B54620, "spawntacticalinsertion" },
    { 0x34F02E16, "spawntag" },
    { 0xCC403332, "spawntag0" },
    { 0xF242AD9B, "spawntag1" },
    { 0xD435BEB6, "spawntalon" },
    { 0x0B87FB50, "spawntargetname" },
    { 0xA5B54611, "spawnteam" },
    { 0xD46F3A55, "spawntheinvestigationguards" },
    { 0x3BA16324, "spawnthiefbeameffect" },
    { 0xBD253507, "spawnthrottleenable" },
    { 0xC5B11B5B, "spawnthrottleenablethread" },
    { 0xFE46DE11, "spawntime" },
    { 0xA550CAA1, "spawntimedfx" },
    { 0x88607EF8, "spawntimes" },
    { 0x9F62117C, "spawntimewaitmax" },
    { 0x1C76CF72, "spawntimewaitmin" },
    { 0x802DD60F, "spawntopplayermodel" },
    { 0xED43A132, "spawntraincar" },
    { 0x207E0F3E, "spawntrainengine" },
    { 0xA5E39192, "spawntraptriggertime" },
    { 0x6C513E64, "spawntrig" },
    { 0x94D53C81, "spawntriggered" },
    { 0x7FD70374, "spawntrigthink" },
    { 0xBC2B3A7C, "spawnturret" },
    { 0x7FD72F64, "spawnturretdisabletrigger" },
    { 0x56040542, "spawnturrethackertrigger" },
    { 0x8521CBAC, "spawnturretpickuptrigger" },
    { 0x1558D926, "spawnuseent" },
    { 0xEE83FF72, "spawnvehicle" },
    { 0x14A14F9B, "spawnvehiclegroup" },
    { 0x7517F791, "spawnvehiclegroup0" },
    { 0x4F157D28, "spawnvehiclegroup1" },
    { 0x1D0EB1C0, "spawnvehiclegroup21" },
    { 0xE71F66CC, "spawnvehiclegroup5" },
    { 0x5926D607, "spawnvehiclegroup6" },
    { 0x45042449, "spawnvehiclegroup8" },
    { 0x1F01A9E0, "spawnvehiclegroup9" },
    { 0x66DE33FD, "spawnvehicles" },
    { 0x0769746E, "spawnwarninglight" },
    { 0xEA2A7B3E, "spawnwatcher" },
    { 0xBCB9F517, "spawnwavestoptrigger" },
    { 0x51F1AC4A, "spawnwaypointfriendlies" },
    { 0xE01389DE, "spawnweapon" },
    { 0x0BACC60F, "spawnweightdebug" },
    { 0x47FC28C9, "spawnweights" },
    { 0x78491313, "spawnziplineguards" },
    { 0x66EB591C, "spawnzone" },
    { 0xD4A3C327, "speach" },
    { 0x65AE3BDD, "speak" },
    { 0x9D0876D0, "speak_charge_lines" },
    { 0x480C29C9, "speak_limit" },
    { 0x802141CC, "speaker" },
    { 0xC6D4023D, "speaker1" },
    { 0xECD67CA6, "speaker2" },
    { 0xF7D862FE, "speaker_array" },
    { 0xA595007A, "speaker_distance" },
    { 0x05E1F6FE, "speaker_ent_number" },
    { 0x2D8853AF, "speaker_ent_origin" },
    { 0x369AF60A, "speaker_feedback" },
    { 0xA7819B54, "speaker_interrupt" },
    { 0x789A21D2, "speaker_origin1" },
    { 0x5297A769, "speaker_origin2" },
    { 0xE74AF5ED, "speakera" },
    { 0x6A691101, "speakercount" },
    { 0xE4BA0D50, "speakerdmg" },
    { 0x9377914F, "speakers" },
    { 0x859C6A59, "speakersinit" },
    { 0x469B2CCB, "speaking" },
    { 0x3B1F0101, "speaking_player" },
    { 0x69C559BC, "speakinganim" },
    { 0x6D3681C9, "speakingline" },
    { 0x5F77C685, "speakingnum" },
    { 0x1C19271C, "speaks" },
    { 0x0F97EE2C, "spear" },
    { 0x0CE3590D, "spear_init" },
    { 0x644DB2C0, "spear_move" },
    { 0x4AAA522F, "spears" },
    { 0xB10BD9C8, "spec" },
    { 0xA7FB6B52, "spec_ops_advance" },
    { 0x25D6F84C, "spec_ops_advance_to_node_set" },
    { 0x7DFE821D, "spec_ops_ally_exit" },
    { 0xCF2C6AEC, "spec_ops_battle_finish" },
    { 0x9F28ACBF, "spec_ops_completed" },
    { 0xB6E3F7B4, "spec_ops_exit" },
    { 0x22A538F3, "spec_ops_failed" },
    { 0xFC8A3EC3, "spec_ops_kill_clear_battle" },
    { 0x857AD0F7, "spec_ops_killed" },
    { 0x89D240D8, "spec_ops_process_advancement" },
    { 0x17C4FBD1, "specatorclient" },
    { 0x039EA33A, "specfic" },
    { 0x7C68238F, "specfies" },
    { 0xA3C0D9DA, "special" },
    { 0xF7F968D7, "special_ai" },
    { 0x83E57DED, "special_ai_array" },
    { 0x2E819EFD, "special_ai_behavior_func" },
    { 0xA733B0FA, "special_ai_num" },
    { 0xCB097FF7, "special_ai_quantity_array" },
    { 0x090D0954, "special_ai_spawned" },
    { 0x1D1B98F2, "special_ai_type" },
    { 0x3F84D87D, "special_ai_types" },
    { 0x7B19788E, "special_ais" },
    { 0xD61429B8, "special_array" },
    { 0x6A9B3531, "special_attack" },
    { 0x55721DD7, "special_attractor_spawn" },
    { 0xCD1EF25D, "special_autosave_null_achievement" },
    { 0x49A5B75A, "special_autosavecondition" },
    { 0x13CFD9F2, "special_bullet_hole" },
    { 0x57CAC4BB, "special_card_earned" },
    { 0x0F47203D, "special_case" },
    { 0xC5A9D3C5, "special_death" },
    { 0x69EAE180, "special_death_balcony" },
    { 0x108299E2, "special_death_balcony_norail" },
    { 0x90E3BBDB, "special_death_death_indicator_hudelement_cleanup" },
    { 0x7469EBE2, "special_death_fx" },
    { 0xE152EBB3, "special_death_indicator_hudelement" },
    { 0x2A027BDE, "special_death_none" },
    { 0xB8EAB5A0, "special_debris_move" },
    { 0x6FAFE689, "special_dog_spawn" },
    { 0xE97739A7, "special_dragons_breath_death" },
    { 0xE65B5A70, "special_drop_setup" },
    { 0xE7BD5DF7, "special_eyes" },
    { 0x0F40C691, "special_fake_death" },
    { 0xD3FAC87F, "special_gib_weapon_chance" },
    { 0x31933907, "special_goals" },
    { 0x5DAB4990, "special_greenlight_ending" },
    { 0xF08551F9, "special_grenade" },
    { 0x5A41726D, "special_guys" },
    { 0x2CE30E57, "special_item_hudelem" },
    { 0x51B3B63A, "special_knife_attack_fx_name" },
    { 0x061480A1, "special_knife_attack_fx_tag" },
    { 0x4B9D6479, "special_node" },
    { 0x1C4C3834, "special_node_type" },
    { 0xFB59CBEA, "special_notify" },
    { 0xC6EBFB01, "special_num_array" },
    { 0x1906F8A2, "special_nums" },
    { 0x8F6D8D14, "special_op_terminated" },
    { 0x9110C1EF, "special_pack_cleanup" },
    { 0x487112F2, "special_pack_time_spawning" },
    { 0x13CB1A42, "special_pickup_idle" },
    { 0xB347EDB5, "special_powerup_drop" },
    { 0xA5E3B5E7, "special_pulses" },
    { 0xAD853D21, "special_raps_spawn" },
    { 0xB57A602D, "special_round_end" },
    { 0x268DD05E, "special_round_start" },
    { 0xD905190A, "special_save" },
    { 0xF1CDE45D, "special_sink_fx" },
    { 0x6AB8A7A2, "special_spawn" },
    { 0xE3AACAB3, "special_spawn_func" },
    { 0x832603DF, "special_status" },
    { 0x799D0911, "special_type" },
    { 0xBF1D74C1, "special_vision_kill_think" },
    { 0xA994D131, "special_vision_kills_challenge" },
    { 0x4D9A1BA8, "special_vox" },
    { 0x8AEB3564, "special_wasp_spawn" },
    { 0xE6EF3C99, "special_weapon" },
    { 0xFA5057AD, "special_weapon_magicbox_check" },
    { 0x51FE0DBE, "special_zombie_spawned_this_round" },
    { 0xB39D1AC4, "specialai" },
    { 0x46D315A3, "specialaiquantity" },
    { 0x8FB64D0E, "specialattack" },
    { 0x4BAFEE26, "specialattackchance" },
    { 0xF941430A, "specialcheck" },
    { 0x7056380F, "specialcontractcompleted" },
    { 0x76BC67A1, "specialcontractcurent" },
    { 0x712BD1C3, "specialcontractid" },
    { 0xBE6A1CDF, "specialcontracttarget" },
    { 0x4E6C1991, "specialdamage" },
    { 0x2B1CD623, "specialdayeffectchance" },
    { 0xEA3EC224, "specialdeath" },
    { 0x9906EFDE, "specialdeathfunc" },
    { 0x2009B1C2, "specialendon" },
    { 0xC73833BA, "specialfeaturesmenu" },
    { 0xDA8919CC, "specialgrenade" },
    { 0x713CDBF7, "specialgrenadedisabledtime" },
    { 0xE4F0994F, "specialgrenades" },
    { 0xBE9DC264, "specialgrenadetype" },
    { 0xB5A66C46, "specialindex" },
    { 0x3B655936, "specialist" },
    { 0x310E5E03, "specialist_killed_index" },
    { 0x017414B2, "specialistindex" },
    { 0x67662144, "specialistmedalachievement" },
    { 0xF0B09C29, "specialists" },
    { 0x36CFA8DB, "specialiststatabilityusage" },
    { 0x3C289BD3, "specialiststats" },
    { 0x9698F6D9, "specialites" },
    { 0xDF14F2AC, "specialized" },
    { 0x2DACCE06, "specialkeys" },
    { 0xCDEAF4C7, "specially" },
    { 0xB7FEEA8E, "specialmelee_standard" },
    { 0x0683D63F, "specialmeleechooseaction" },
    { 0xF617D0F6, "specialoffhand" },
    { 0xD4A6767B, "specialoffhandcount" },
    { 0x73EF0696, "specialpain" },
    { 0xBE0F54E5, "specialpain_todo" },
    { 0x7A27A3A4, "specialpainblocker" },
    { 0x349B55F3, "specialreact" },
    { 0xCF8D0D84, "specialreloadanimfunc" },
    { 0x1F014E4F, "specialriotshieldviewmodel" },
    { 0xDB7EE9D5, "specials" },
    { 0xB8931AFB, "specialties" },
    { 0x441A0B08, "specialties1" },
    { 0xB6217A43, "specialties2" },
    { 0x901EFFDA, "specialties3" },
    { 0x1BFB1FF4, "specialturnsuffix" },
    { 0xF72C4E1F, "specialty" },
    { 0x34337414, "specialty1" },
    { 0xA63AE34F, "specialty2" },
    { 0x803868E6, "specialty3" },
    { 0xC22C04D9, "specialty4" },
    { 0x0233945A, "specialty_additionalprimaryweapon_drank" },
    { 0x67F3BD5D, "specialty_additionalprimaryweapon_power_on" },
    { 0x401EA322, "specialty_armorvest_drank" },
    { 0xD829C0F5, "specialty_armorvest_power_on" },
    { 0xDC32F92F, "specialty_deadshot_drank" },
    { 0xC753E71E, "specialty_deadshot_power_on" },
    { 0xC5161F98, "specialty_detectexplosive" },
    { 0xE0BA8A51, "specialty_disarmexplosive" },
    { 0x0A72E829, "specialty_doubletap2_drank" },
    { 0x0A53D95E, "specialty_fastinteract" },
    { 0x93BEC36C, "specialty_fastreload_drank" },
    { 0x90B23CF7, "specialty_fastreload_power_on" },
    { 0xEF957F15, "specialty_finalstand_drank" },
    { 0x9BEF11A4, "specialty_finalstand_power_on" },
    { 0x5C10382D, "specialty_flakjacket_drank" },
    { 0x9DB2C8CC, "specialty_flakjacket_power_on" },
    { 0x815F7E76, "specialty_grenadepulldeath_drank" },
    { 0x4CC54E61, "specialty_grenadepulldeath_power_on" },
    { 0x28CE8463, "specialty_intruder" },
    { 0xA42E5FBA, "specialty_longersprint_drank" },
    { 0xB115817D, "specialty_longersprint_power_on" },
    { 0x18FAE743, "specialty_nomotionsensor" },
    { 0xE07CDCB4, "specialty_nomotionsensor_drank" },
    { 0x33ED4A47, "specialty_nottargetedbyairsupport" },
    { 0xF798A19D, "specialty_null" },
    { 0xAF01B112, "specialty_num" },
    { 0x449129EF, "specialty_quickrevive_drank" },
    { 0x6A5D45DE, "specialty_quickrevive_power_on" },
    { 0xA2826EC8, "specialty_rof_drank" },
    { 0xB72C3F4B, "specialty_rof_power_on" },
    { 0x5ACA9E89, "specialty_scavenger_drank" },
    { 0xAAD9D000, "specialty_scavenger_power_on" },
    { 0x04393EBD, "specialty_scavenger_stop" },
    { 0x75712259, "specialty_showenemyequipment" },
    { 0x158E707D, "specialty_size" },
    { 0x084F15BC, "specialty_staminup_drank" },
    { 0x5CADEE16, "specialty_threeprimaries_power_on" },
    { 0xD8282B66, "specialty_trespasser" },
    { 0xD0D1A8A2, "specialty_trigger" },
    { 0xEAD308A7, "specialty_widowswine_drank" },
    { 0x9453F212, "specialtyname" },
    { 0xCA2BB4E0, "specialtynumber" },
    { 0xC73F509A, "specialtype" },
    { 0xFF99CEA6, "specialtys" },
    { 0x19102D94, "specialtytoperkindex" },
    { 0x87A436F7, "specical" },
    { 0x0A66155A, "specically" },
    { 0x7FEA67E9, "species" },
    { 0xC59A95F1, "speciestype" },
    { 0xC2A32EC9, "specific" },
    { 0xE9034B49, "specific_cam" },
    { 0xBC92FC84, "specific_combat" },
    { 0x676B87A5, "specific_drone_death" },
    { 0x9B998934, "specific_powerup_drop" },
    { 0xE1F74FEF, "specific_seat" },
    { 0x9FF0CDF7, "specific_target" },
    { 0x69116157, "specifically" },
    { 0x94C6C3F8, "specification" },
    { 0xBF64E253, "specifications" },
    { 0xBD727FF6, "specificed" },
    { 0x26B1147A, "specificfromcolor" },
    { 0x1E02DDC0, "specifics" },
    { 0x8D4D9662, "specifictarget" },
    { 0x2AA091A6, "specificuse" },
    { 0x58BC5359, "specificweaponkill" },
    { 0x8F9CA1B6, "specifiec" },
    { 0xD1903DA9, "specified" },
    { 0xEFC44846, "specifies" },
    { 0xF89296BA, "specifified" },
    { 0x918E7B96, "specify" },
    { 0x16F3768A, "specifying" },
    { 0xD0261973, "specnotify" },
    { 0x24B9A62C, "specops" },
    { 0x6B50CE8D, "specops_death_notify" },
    { 0xEB4279A7, "specops_player_kill" },
    { 0xD07585E3, "specs" },
    { 0xF7F96BE6, "spectacular" },
    { 0x5B9803D4, "spectate" },
    { 0x995333B0, "spectate_cam" },
    { 0x73D48B16, "spectate_hud" },
    { 0x7B454ADF, "spectate_list" },
    { 0x9933A9B1, "spectate_player_watcher" },
    { 0xCB6BBFD9, "spectatecolor" },
    { 0xABF4CFF8, "spectated" },
    { 0xEA2F9401, "spectatekillcam" },
    { 0x188A435B, "spectateonjoin" },
    { 0x996D4CCC, "spectateoverride" },
    { 0x21BDB21C, "spectatetype" },
    { 0x54E5555D, "spectating" },
    { 0x251EBCB7, "spectatingthirdperson" },
    { 0x0E1253A8, "spectator" },
    { 0xA14FA183, "spectator_cycle" },
    { 0x74A1E0E1, "spectator_killcam_cleanup" },
    { 0xAF20954D, "spectator_respawn" },
    { 0x99389B89, "spectator_respawn_all" },
    { 0xF30BF142, "spectator_respawn_custom_score" },
    { 0xEA54C3FA, "spectator_respawn_new" },
    { 0x5E65DBAF, "spectator_respawn_player" },
    { 0x5465EFC4, "spectator_thirdperson_thread" },
    { 0x128DD783, "spectator_thread" },
    { 0xBFECB075, "spectator_toggle_3rd_person" },
    { 0x9E110015, "spectatorclient" },
    { 0x74ADD383, "spectatorkillcamcleanup" },
    { 0xA108C743, "spectators" },
    { 0xA61BA136, "spectators_respawn" },
    { 0x029CFB1D, "spectatorthirdpersonness" },
    { 0x906D457F, "spectre" },
    { 0x7C64F238, "spectrum" },
    { 0xEB622902, "specular" },
    { 0xEF7885DB, "speech" },
    { 0xF52F4438, "speech_anims" },
    { 0x95043A64, "speech_backup_spawn" },
    { 0x31320257, "speech_clean_up" },
    { 0x5383E2B0, "speech_courtyard_ai" },
    { 0x55C59701, "speech_crowd_animate_guy" },
    { 0x833D9FE5, "speech_crowd_spawn" },
    { 0xE6A2B0B0, "speech_crowd_think" },
    { 0x4EBEBCEE, "speech_done" },
    { 0x22E5EE54, "speech_drone_runners" },
    { 0x316A2798, "speech_drones_ignore_player" },
    { 0x723A8528, "speech_drones_ignore_player_timeout" },
    { 0x750A0BD9, "speech_end_drones" },
    { 0xD8D2C31D, "speech_end_sound" },
    { 0x6958DC36, "speech_fade_in" },
    { 0xF566AA04, "speech_leave_stage" },
    { 0xEA4CB421, "speech_main" },
    { 0xEFC452A4, "speech_menendez_quad_kill_counter" },
    { 0x0DBE4040, "speech_menendez_quad_run" },
    { 0x562B0201, "speech_menendez_quad_targets" },
    { 0x5984563A, "speech_of_decadence" },
    { 0x9DE455F3, "speech_origin_inside" },
    { 0x9630F2D0, "speech_origin_outside" },
    { 0xC6F45C62, "speech_quads" },
    { 0xCB557661, "speech_quads_exit_formation" },
    { 0x711872D5, "speech_spawn_crowd" },
    { 0x0BF42AD9, "speech_stage_guards" },
    { 0xDD549851, "speech_stop_player_ignoreme" },
    { 0x5B548269, "speech_timer" },
    { 0x32E2D211, "speech_vtol" },
    { 0xA2D24A09, "speech_vtol_crash_callback" },
    { 0x65058DCA, "speech_vtols_arrive" },
    { 0x73043F16, "speechvar" },
    { 0xD007DA9E, "speed" },
    { 0xA625F80C, "speed2d" },
    { 0x307172D6, "speed_buff" },
    { 0x9E71C436, "speed_burst_constant_index_blur_amount" },
    { 0x43EC2565, "speed_burst_constant_index_blur_origin_x" },
    { 0x1DE9AAFC, "speed_burst_constant_index_blur_origin_y" },
    { 0xFECE21A9, "speed_burst_constant_index_desaturation" },
    { 0x4C52D415, "speed_burst_constant_index_glow_pulse" },
    { 0x4B50379D, "speed_burst_constant_index_iris_base_glow" },
    { 0xCD2F706D, "speed_burst_constant_index_iris_zoom" },
    { 0xF7672B4C, "speed_burst_visionset" },
    { 0x5766A239, "speed_burst_visionset_alias" },
    { 0xB0CC763F, "speed_burst_visionset_priority" },
    { 0xB6BDED85, "speed_burst_visionset_ramp_hold" },
    { 0x5814F89B, "speed_burst_visionset_ramp_in" },
    { 0x5EC6A50E, "speed_burst_visionset_ramp_out" },
    { 0x48AD00D8, "speed_burst_visionset_steps" },
    { 0x6F247551, "speed_change" },
    { 0xB51411EE, "speed_change_max" },
    { 0x4ABFD7D4, "speed_change_num" },
    { 0x7CC72AF3, "speed_change_per_frame" },
    { 0x2EE0B8F4, "speed_change_round" },
    { 0x245A932C, "speed_change_watcher" },
    { 0x5D6C6C73, "speed_check" },
    { 0x1A590B75, "speed_checks_done" },
    { 0xE7398C7F, "speed_cola_ents" },
    { 0xAEECA900, "speed_control" },
    { 0x338298A2, "speed_count" },
    { 0x93C10200, "speed_current" },
    { 0x08F9835A, "speed_damage" },
    { 0xB85CE32A, "speed_debug" },
    { 0x307FFF17, "speed_dec" },
    { 0xAF17F0EC, "speed_dividend" },
    { 0xBC29D561, "speed_down" },
    { 0x33B17556, "speed_drone_max" },
    { 0x18BC49A8, "speed_drone_min" },
    { 0x6CC20B97, "speed_fail_time" },
    { 0x6D90E994, "speed_forward" },
    { 0xDEA13075, "speed_frac" },
    { 0x53B07AFB, "speed_fraction" },
    { 0xEDA821CB, "speed_fx" },
    { 0x5C66C607, "speed_idle" },
    { 0x49E54EDA, "speed_jingle" },
    { 0xA6740E52, "speed_left" },
    { 0x797BCCAA, "speed_match_dist_x" },
    { 0x9F7E4713, "speed_match_dist_y" },
    { 0xD251F345, "speed_max" },
    { 0xBD334BAB, "speed_min" },
    { 0xC5CD00E4, "speed_model" },
    { 0x27039842, "speed_modifier" },
    { 0xCAE2D9D9, "speed_modifier_max" },
    { 0x2588B867, "speed_modifier_min" },
    { 0x5751F8A3, "speed_mult" },
    { 0x0D0E06BC, "speed_multiplier" },
    { 0xCBB9A537, "speed_norm" },
    { 0x735CA9D3, "speed_of_wind" },
    { 0xB4AD049C, "speed_offset" },
    { 0xFBB30C8E, "speed_pct" },
    { 0x24B86F5C, "speed_penalty_time" },
    { 0xA15A754C, "speed_percent" },
    { 0xE3B10DF4, "speed_pickup_cleanup" },
    { 0x2B50BA53, "speed_pickup_update" },
    { 0xFB1E3122, "speed_plane_max" },
    { 0xD08C25DC, "speed_plane_min" },
    { 0x2D6D918F, "speed_ramp_up" },
    { 0xC1C0202D, "speed_reduced" },
    { 0x3C59FEC1, "speed_right" },
    { 0x768BE178, "speed_run" },
    { 0x1B0F1BBD, "speed_scale" },
    { 0xC82665BE, "speed_shader" },
    { 0xD4305602, "speed_slow" },
    { 0x029D8B21, "speed_test" },
    { 0x355278DA, "speed_test_init" },
    { 0x0DC5EF88, "speed_text" },
    { 0x7B3B2583, "speed_throw" },
    { 0xA0CA8D63, "speed_trigger" },
    { 0x11DA3BC0, "speed_ui_data_model" },
    { 0x4C4B118E, "speed_up" },
    { 0x6D2D2316, "speed_up_crash" },
    { 0x8A2E09F9, "speed_up_drone" },
    { 0xD9333A20, "speed_up_limo_for_crash" },
    { 0xDD5F3372, "speed_up_woodstiger" },
    { 0x4F584712, "speed_used" },
    { 0xFBF26C3C, "speed_zero_path_disconnect" },
    { 0x599EA03D, "speed_zhao_up" },
    { 0xD2397627, "speedbeforepause" },
    { 0xDA7D366B, "speedboost" },
    { 0xE9582001, "speedbumpcurrent" },
    { 0xDFFEC691, "speedbumps" },
    { 0x4777D87B, "speedbumps_setup" },
    { 0x3A292D50, "speedburst" },
    { 0x6E526AD0, "speedburstkill" },
    { 0xE1EF31C0, "speedburstkilldist" },
    { 0x654088E0, "speedburstlastontime" },
    { 0x91B4E5DB, "speedburston" },
    { 0x690D7733, "speeddifference" },
    { 0x2C66EA22, "speeding" },
    { 0xFBFCA75A, "speeding_up" },
    { 0x26CA7D29, "speeding_up_2" },
    { 0x00C802C0, "speeding_up_3" },
    { 0x17046C80, "speedinmph" },
    { 0x07C6AEF4, "speedmax" },
    { 0x3258BA3A, "speedmin" },
    { 0xD3B3BBDF, "speedmph" },
    { 0xB49E83B4, "speedometer" },
    { 0xC2B71496, "speedoncurve" },
    { 0x63BFA9FE, "speedpercentage" },
    { 0x796EA722, "speedpitchmax" },
    { 0x6102D89B, "speedratio" },
    { 0xF17A26FB, "speedregulator" },
    { 0x14D1A001, "speeds" },
    { 0x15B174A0, "speedscale" },
    { 0xDFFF45F5, "speedscalemultiplier" },
    { 0x81C2A7FA, "speedsq" },
    { 0x657833BB, "speedstepsize" },
    { 0x2050CF72, "speedtouse" },
    { 0xE17CA345, "speedup" },
    { 0x963C0D0E, "speedvolumemax" },
    { 0x30C2C18B, "speedy" },
    { 0x25F46945, "speices" },
    { 0x17B8F391, "spell" },
    { 0x3F5EED77, "spelling" },
    { 0x689A8533, "spend" },
    { 0xA145B9AD, "spending" },
    { 0x0872DEA3, "spent" },
    { 0x3983AF27, "spent_points" },
    { 0xC3DCD311, "spent_points_tracking" },
    { 0xEA3CC56E, "spets" },
    { 0xAB8D1485, "spetsnaz" },
    { 0xEE0A84F5, "spetsnaz_group_1" },
    { 0x140CFF5E, "spetsnaz_group_2" },
    { 0xEFFD2483, "spetsnaz_van_crash" },
    { 0xE02B6C8F, "spetz" },
    { 0xAD811144, "spetz1" },
    { 0x1F88807F, "spetz2" },
    { 0xF9860616, "spetz3" },
    { 0x2E548442, "spetz_body_fall" },
    { 0xBF09E5BD, "spetz_ded" },
    { 0x410ABBCE, "spetz_escape_scene" },
    { 0x8598846D, "spetz_hit" },
    { 0xD125AC56, "spetz_last" },
    { 0xA1034D1D, "spetz_push_civ" },
    { 0x9247179E, "spetz_scene_jumpto" },
    { 0x2A392C0A, "spetz_spawner" },
    { 0x8F305F1C, "spetz_stair_dialog" },
    { 0x5D85B1EA, "spetzkills" },
    { 0xD58B6A6B, "spetznas" },
    { 0xFBA0BFCB, "spetznas_1" },
    { 0x89995090, "spetznas_2" },
    { 0xD4B9F74F, "spetznas_fall_from_heli" },
    { 0x9397CE78, "spetznax" },
    { 0xDF9CC34A, "spetznaz" },
    { 0xB08E7DCC, "spewing" },
    { 0x07222779, "spez" },
    { 0x49FD3F99, "spez_civ_move_dialog" },
    { 0x8E2355D1, "spez_roof_dialog" },
    { 0x1A4BEA97, "spez_rooftop_conversation" },
    { 0xE02029B8, "spez_spawner" },
    { 0x2D3EAA0E, "sphere" },
    { 0xA4535303, "sphere_origin" },
    { 0x8B3C4C87, "sphere_radius" },
    { 0xAA272522, "sphere_size" },
    { 0x808DABB1, "spheres" },
    { 0x80FB8913, "sphericalcone" },
    { 0xE44097AE, "spider" },
    { 0xAC18CB33, "spider_bot_light_off" },
    { 0x1CFCF61F, "spider_bot_light_on" },
    { 0x3A74B130, "spider_callback_damage" },
    { 0x78B8D6C7, "spider_compass" },
    { 0xC56B4EB5, "spider_get_target_position" },
    { 0x324383CF, "spider_initialize" },
    { 0x86898524, "spider_lid" },
    { 0x377DE5EE, "spider_move_dist_max" },
    { 0x8A5554B0, "spider_move_dist_min" },
    { 0x732CDF99, "spiderbot" },
    { 0xEB130344, "spiderbot_amb_convo_triggers" },
    { 0xF4F6C72C, "spiderbot_animating" },
    { 0x8F3DC3DA, "spiderbot_anims" },
    { 0x1AEEEF1C, "spiderbot_anims_inited" },
    { 0xA091EECF, "spiderbot_audio_cleanup" },
    { 0x466907C8, "spiderbot_cleanup" },
    { 0xA3DF9B8C, "spiderbot_dialog" },
    { 0x48E2D2AB, "spiderbot_end" },
    { 0xB654C90E, "spiderbot_general_dof" },
    { 0x0F02ED3C, "spiderbot_light_trigger_think" },
    { 0x0B416F06, "spiderbot_lost" },
    { 0xB7D7E417, "spiderbot_pad_add_script_noteworthy" },
    { 0x7F35BA86, "spiderbot_patrol" },
    { 0x595B54DC, "spiderbot_precache_anims" },
    { 0x783050BE, "spiderbot_scanning_audio" },
    { 0x4D5C4394, "spiderbot_security_dof" },
    { 0x3F17576A, "spiderbot_slow_mo" },
    { 0x34E020AC, "spiderbot_speeds" },
    { 0x4A3D9B9C, "spiderbot_squashed" },
    { 0x9F5CD03D, "spiderbot_teleport" },
    { 0x06DF0AE8, "spiderbot_timed_out" },
    { 0x8D19201D, "spiderbot_transition" },
    { 0xDA0F387D, "spiderbot_tunnel_ambience" },
    { 0x87FC0B30, "spiderhole" },
    { 0xE410CB7D, "spiderhole_ambush_chatter" },
    { 0x78767599, "spiderhole_ambush_flipover" },
    { 0x21F3031F, "spiderhole_ambush_jumpin" },
    { 0x1A93A328, "spiderhole_anim" },
    { 0x2D690D20, "spiderhole_anim_internal" },
    { 0x61A65F1B, "spiderhole_charge" },
    { 0x1214AB8D, "spiderhole_charge_internal" },
    { 0xD660972A, "spiderhole_charge_think" },
    { 0xEFBD4C00, "spiderhole_drop_lid_to_ground" },
    { 0x8866FAE0, "spiderhole_duck" },
    { 0xC0E23EE9, "spiderhole_getout_anim" },
    { 0x2182229B, "spiderhole_grenade_toss" },
    { 0x94EDF185, "spiderhole_gun_spray" },
    { 0xFE523527, "spiderhole_reset_death" },
    { 0x20C275F5, "spiderhole_run_to_node" },
    { 0xF66B1CD9, "spiderhole_stabbins" },
    { 0x94934C9B, "spiderholes" },
    { 0x301573F9, "spiderholes_triggered" },
    { 0x5F09167E, "spiderholetrig" },
    { 0xB93558D1, "spiders" },
    { 0xE7ED5EC2, "spiece" },
    { 0x1594230D, "spieces" },
    { 0x41AE2FA1, "spike" },
    { 0xD3CF48B8, "spike_charge" },
    { 0xEDB77A33, "spike_charge_siegebot" },
    { 0x7F9695B3, "spike_detonation" },
    { 0xAD4F5BB6, "spike_group_score" },
    { 0x55E4F2FB, "spike_hit_limit" },
    { 0x31E90786, "spike_hits_during_trophy_down" },
    { 0x3EE3963D, "spike_position" },
    { 0xA22C73C2, "spike_score" },
    { 0x0369ADE9, "spike_the_meat" },
    { 0x133F421F, "spike_trap_move" },
    { 0x60F46DE3, "spike_trap_move_spikes" },
    { 0x63D36BBE, "spikecount" },
    { 0xBEF46DB0, "spikecoverradius" },
    { 0x0B7B930E, "spikedelay" },
    { 0x6B61411D, "spikedetonate" },
    { 0xB66AFA28, "spikefaketargets" },
    { 0xB301631B, "spikemore_delete_all_on_end_game" },
    { 0xF8996945, "spikemores" },
    { 0xF317FD48, "spikes" },
    { 0x73AF46E5, "spikes_chop_cone_range" },
    { 0x8858FE70, "spikes_chop_cone_range_sq" },
    { 0xB2B16B7B, "spikesarc_swipe" },
    { 0x48A31C41, "spikesdetonating" },
    { 0xC07DDBF5, "spiketargets" },
    { 0x3C890D2F, "spill_ent" },
    { 0xF7962E9A, "spilled" },
    { 0x98FEA67B, "spilling" },
    { 0x64050AEC, "spills" },
    { 0x953198D9, "spin" },
    { 0xC4024977, "spin_115" },
    { 0x002BF3AC, "spin_anemometers" },
    { 0xEA6680ED, "spin_crash" },
    { 0x0ECC9A32, "spin_dial" },
    { 0x7FE15652, "spin_emergency_light" },
    { 0x4D47F55B, "spin_ent" },
    { 0x44D589F3, "spin_fan" },
    { 0xEE245ED9, "spin_forever" },
    { 0xCE139A4B, "spin_globe" },
    { 0xBB84A60C, "spin_model_fx" },
    { 0xB5A5E875, "spin_model_fx_tag" },
    { 0x507E4C53, "spin_model_name" },
    { 0xEE809702, "spin_models" },
    { 0x138C79FB, "spin_off" },
    { 0x19B593A8, "spin_out" },
    { 0x74FE9B87, "spin_radio_tower" },
    { 0xD1C40354, "spin_rooftop_fans" },
    { 0xC7AF3F91, "spin_sound" },
    { 0x040D8300, "spin_stop_sound" },
    { 0x211C84E7, "spin_target" },
    { 0xC5605C0F, "spin_time" },
    { 0xA445D032, "spin_to_start" },
    { 0xF7F1D228, "spin_transit_turbines" },
    { 0x9E1D0808, "spin_trigger" },
    { 0x39E4EB49, "spin_turbine" },
    { 0x20305873, "spin_while_falling" },
    { 0xDFF7FBFE, "spinanim" },
    { 0xAB5CCE51, "spineless" },
    { 0x7D52EE09, "spinetarget" },
    { 0x9A57A26F, "spining" },
    { 0xC93D4DD9, "spinkill" },
    { 0x9F0FDBAE, "spinleft" },
    { 0xD4FE21E7, "spinleverdown" },
    { 0x9B474778, "spinleverup" },
    { 0x17FFADC4, "spinner" },
    { 0xDA0F1A90, "spinner_get_spin_time" },
    { 0x1DFCEE77, "spinners" },
    { 0x99643AA7, "spinners_wait_for_power" },
    { 0xBCEC23F1, "spinngy" },
    { 0x945B8D53, "spinning" },
    { 0x4FCF3732, "spinning_blocker_model" },
    { 0x0C56F71F, "spinning_blockers" },
    { 0xF876D42A, "spinning_blockers_cleanup" },
    { 0x278C2B70, "spinning_blockers_damage_trigger" },
    { 0xAF7C0F9B, "spinning_blockers_timeout" },
    { 0x284AABF5, "spinning_blockers_update" },
    { 0xA62110E9, "spinning_fan" },
    { 0x46CD614A, "spinning_out" },
    { 0xCD43DFC0, "spinoff" },
    { 0xF13CE5FC, "spinouttime" },
    { 0x2668F831, "spinpickup" },
    { 0x23583032, "spinrad" },
    { 0x6345ED90, "spins" },
    { 0x60D2FCE9, "spinsoundshortly" },
    { 0xFF4AAE8E, "spintime" },
    { 0xA978C131, "spintimes" },
    { 0x4C0D26FC, "spintrapthink" },
    { 0x70F42122, "spinup" },
    { 0x62068EDD, "spinuptime" },
    { 0x9AE33694, "spinzippulleys" },
    { 0xF95D0DC1, "spirals" },
    { 0x3D5A53C2, "spire" },
    { 0x9019D20D, "spires" },
    { 0xC19537DE, "spirit" },
    { 0x5E21A103, "spirit_fire_ent" },
    { 0xA52E4675, "spirit_fire_offset" },
    { 0x3371F821, "spirited" },
    { 0xB122BA63, "spit" },
    { 0x5867FE0F, "spitfire" },
    { 0xC1985652, "spits" },
    { 0x0642B39C, "spitter" },
    { 0xC8FA079B, "spitting" },
    { 0x0884E129, "spl_fallback" },
    { 0x913099A4, "spl_music" },
    { 0xE6F97F6E, "spl_normal" },
    { 0xA6740DA8, "splash" },
    { 0xAF8E756D, "splash_event" },
    { 0x247BADE9, "splash_fx" },
    { 0x13933AFD, "splash_origin" },
    { 0x0A7B4084, "splash_small" },
    { 0x2E11F700, "splash_struct" },
    { 0xE2628881, "splash_trig" },
    { 0x12DA4E76, "splash_trig_logic" },
    { 0xB74841A9, "splash_trig_think_ai" },
    { 0x6004802F, "splash_trig_think_plr" },
    { 0x50DBB4A8, "splash_trigs" },
    { 0xBAECF661, "splash_trigs_think" },
    { 0x6E093F6D, "splash_watcher" },
    { 0x5FF6BD2C, "splashdown" },
    { 0x63F5E3B4, "splashes" },
    { 0x2480E5D2, "splashfx" },
    { 0xCBF81EB9, "splashfxleft" },
    { 0x576DFBE4, "splashfxright" },
    { 0xF5316C70, "splashing" },
    { 0x22133EAE, "splashorigin" },
    { 0x585599DF, "splat" },
    { 0xB4D94266, "splats" },
    { 0x07C5F780, "splatter" },
    { 0xCA5D091A, "splay" },
    { 0x50B2BD6B, "splayer" },
    { 0x9F070F76, "splayerlocation" },
    { 0x1697932A, "spline" },
    { 0x579A0EFE, "spline_debug" },
    { 0x061273B8, "spline_name" },
    { 0xF17A61F0, "spline_offset" },
    { 0xC7966823, "spline_radius" },
    { 0x94AD2E33, "spline_vtol_think" },
    { 0xB3D3EFE5, "splines" },
    { 0xCA929E58, "spling" },
    { 0x3B755FDE, "splinter" },
    { 0x91B65017, "split" },
    { 0x6633772D, "split_array" },
    { 0xF44B4FFB, "split_meat" },
    { 0x0A5A4A39, "split_path_mig_left" },
    { 0x0BF87664, "split_path_mig_right" },
    { 0x9C163ACD, "split_player_points" },
    { 0x5B758F95, "split_size" },
    { 0x4AFCE24F, "split_spawn" },
    { 0x85D05F94, "split_spawned" },
    { 0xE86C1391, "split_state" },
    { 0xFD2DCDA5, "split_trasition_dir_end" },
    { 0x76927706, "split_trasition_dir_start" },
    { 0x66B6376C, "split_up_anim_interrupted" },
    { 0x5E8C0151, "split_up_door_kick" },
    { 0x0282894E, "split_up_scene_begin" },
    { 0xDE4C37EE, "split_up_start_vo" },
    { 0x5430E74C, "splitargs" },
    { 0xBE3C4DCE, "splits" },
    { 0x2016892B, "splitscreen" },
    { 0x6CBDB2AE, "splitscreen_fog" },
    { 0x70A2F920, "splitscreen_fog_setup" },
    { 0x70E9A7EB, "splitscreen_populate_dvars" },
    { 0x89AB7333, "splitscreen_restore_dvars" },
    { 0x2FEE1906, "splitscreenclient" },
    { 0xCB8C2271, "splitscreenplayercount" },
    { 0x41DB60C4, "splittime" },
    { 0x1E6E6507, "splitting" },
    { 0x3B6EBC4B, "splitting_meat" },
    { 0x6D5EA0F8, "splitup" },
    { 0x71410825, "splitup_objective_marker" },
    { 0xB3981CF9, "splitup_start_objective" },
    { 0xD40DE94D, "splode_dist" },
    { 0xF7A0D2CC, "splosion" },
    { 0xA8D2C4A9, "spm" },
    { 0x4C54A25B, "spmp" },
    { 0xA8FDE621, "spn_mgr_name" },
    { 0x77CA7147, "spn_targetname" },
    { 0xF139A09F, "spnotify" },
    { 0xB20279B9, "spoiler" },
    { 0x6EACD1EB, "spoke" },
    { 0x18BA32FF, "spoken" },
    { 0x626E67DE, "spoken_word" },
    { 0x743330B1, "spontaneously" },
    { 0xA8F29D64, "spoof" },
    { 0x5D92B662, "spooky" },
    { 0xC1E34EB9, "spooky_dog" },
    { 0x00ADA8D0, "spooky_sighting" },
    { 0x250B657E, "spool" },
    { 0x53814868, "spool_ent_a" },
    { 0xC588B7A3, "spool_ent_b" },
    { 0xE07C8347, "spool_ent_c1" },
    { 0x6E75140C, "spool_ent_c2" },
    { 0x94778E75, "spool_ent_c3" },
    { 0x48C6A461, "spools" },
    { 0x7EA15CA3, "spools_and_pumps" },
    { 0x58CF201E, "spools_moving" },
    { 0x38646134, "spools_stopping" },
    { 0xBEE19784, "spoon_easy_cleanup" },
    { 0x15189766, "spoon_in_tub" },
    { 0xBA336F70, "spoon_spin_func" },
    { 0x81F068D9, "spoon_spinners" },
    { 0xEB446E2C, "sporadic" },
    { 0x9A6CC954, "spore" },
    { 0xDC3C7A86, "sporeclientfields" },
    { 0xBED16AC7, "spores" },
    { 0x2E98E037, "sporestruct" },
    { 0x4D368C9C, "sporetag" },
    { 0xF9D13ADF, "sporetags" },
    { 0xFA2D61D9, "spork_door" },
    { 0x933FAA43, "spork_portal" },
    { 0xABDCA52C, "sports" },
    { 0xE18D5855, "spot" },
    { 0x460B1A1F, "spot0" },
    { 0x20089FB6, "spot1" },
    { 0xFA06254D, "spot2" },
    { 0xD403AAE4, "spot3" },
    { 0xAE01307B, "spot4" },
    { 0x87FEB612, "spot5" },
    { 0x015B6BC8, "spot_angles" },
    { 0x084E9459, "spot_delete" },
    { 0x506FE3E4, "spot_dest" },
    { 0x6BE0FB55, "spot_exports" },
    { 0xF2E7BA50, "spot_finder" },
    { 0xF92824BF, "spot_forward" },
    { 0x6D304B1C, "spot_index" },
    { 0xB181829E, "spot_launches_grenade" },
    { 0x59AA9724, "spot_light" },
    { 0x68845AF3, "spot_light_angle_change" },
    { 0xFAE6407A, "spot_light_model" },
    { 0x1EA5273C, "spot_light_speed" },
    { 0x62D8DD94, "spot_light_target" },
    { 0x73472DFD, "spot_noteworthy" },
    { 0x8D3A9CF2, "spot_org" },
    { 0x1A64306E, "spot_origin" },
    { 0xFDE91B96, "spot_pos" },
    { 0x81DA0ED1, "spot_position" },
    { 0xDF41DF0A, "spot_radius" },
    { 0x5EA7FDB0, "spot_targ" },
    { 0x569EB3D3, "spot_target" },
    { 0x2DA85CF5, "spot_target_ent" },
    { 0xBB51ABA2, "spot_target_node" },
    { 0xCFE5248B, "spot_target_path" },
    { 0x705F253D, "spot_target_path_end" },
    { 0x66B52803, "spot_time" },
    { 0x952154FB, "spot_to_track" },
    { 0x9962E47B, "spot_types" },
    { 0x3AF16383, "spotlight" },
    { 0x58EC52AA, "spotlight_angles" },
    { 0x1976E730, "spotlight_capture_player" },
    { 0xCA9A3F76, "spotlight_caster" },
    { 0x48FA7666, "spotlight_circle" },
    { 0xEF02C940, "spotlight_damage_think" },
    { 0xA7F9E753, "spotlight_default_target" },
    { 0x56060D6F, "spotlight_detection" },
    { 0x5A42AA4F, "spotlight_dodge_fail_think" },
    { 0xEF6EE076, "spotlight_done" },
    { 0xA00A3825, "spotlight_ent" },
    { 0xFD041565, "spotlight_forward" },
    { 0x26C7851A, "spotlight_function" },
    { 0x18E442DC, "spotlight_fx" },
    { 0x0E2457C4, "spotlight_fx_spawn" },
    { 0x364D6A82, "spotlight_halt_ent1" },
    { 0x104AF019, "spotlight_halt_ent2" },
    { 0xB7347D5F, "spotlight_interruption" },
    { 0xDAB5335A, "spotlight_kid" },
    { 0xA2EC08B3, "spotlight_len" },
    { 0xEC095BF5, "spotlight_linkto" },
    { 0x4F6BF3A6, "spotlight_move_away" },
    { 0x140C9603, "spotlight_name" },
    { 0xD9C5B385, "spotlight_off" },
    { 0x3F9F092B, "spotlight_on_player" },
    { 0x8840ED0A, "spotlight_on_woods" },
    { 0x08CCEDFA, "spotlight_on_zhao" },
    { 0x10406410, "spotlight_org" },
    { 0x975B9D24, "spotlight_path_reverse" },
    { 0x448900C0, "spotlight_pos" },
    { 0xC67CA5D8, "spotlight_sc" },
    { 0xF24A2666, "spotlight_search" },
    { 0x062917F0, "spotlight_search_path" },
    { 0xA7CE7F1D, "spotlight_struct" },
    { 0x7620395C, "spotlight_structs" },
    { 0x117C6AF6, "spotlight_tag" },
    { 0x7B280B71, "spotlight_target" },
    { 0x683BE7A7, "spotlight_target_basepos" },
    { 0x02FBAF02, "spotlight_think" },
    { 0xFA9C9C1E, "spotlight_trigger" },
    { 0x1CE01D35, "spotlightfx" },
    { 0x528B2DF2, "spotlights" },
    { 0xA7149157, "spotoffsets" },
    { 0x536510A4, "spots" },
    { 0xB685A6BA, "spots_nonprimary" },
    { 0xBD44A9D3, "spottargetname" },
    { 0xC8AF08B0, "spotted" },
    { 0x604AD5EB, "spotted_an_enemy" },
    { 0xF8E507CD, "spotted_flag" },
    { 0x61BD1EBB, "spotted_list" },
    { 0xB49FD2A7, "spottedby" },
    { 0x7682D9E4, "spottedenemy" },
    { 0x11D3698B, "spottedtime" },
    { 0x4C964096, "spotter" },
    { 0xE00E3E09, "spotters" },
    { 0xBE5A3D25, "spotting" },
    { 0x217CD72F, "spottn" },
    { 0x39014827, "spottrig" },
    { 0xEACD509E, "spottrigs" },
    { 0xF5805327, "spotx" },
    { 0xCF7DD8BE, "spoty" },
    { 0xA97B5E55, "spotz" },
    { 0x00F15B08, "spouting" },
    { 0x0C0BBEFB, "spouts" },
    { 0x2D924D27, "spov" },
    { 0x5C034D74, "sppplke" },
    { 0xB80AB638, "spray" },
    { 0x4467E5E0, "spray_button_pressed" },
    { 0x55CCCA62, "spray_buttons" },
    { 0xB37B1F9E, "spray_ent" },
    { 0xE01C0859, "spray_fx" },
    { 0xB87B72A2, "spray_hud" },
    { 0xB4FA2FBE, "spray_model" },
    { 0x032993D8, "spray_trajectory" },
    { 0x05C0A17B, "spraycan_fx" },
    { 0x4FC0295E, "spraycan_fx_stop" },
    { 0x1EB1E04B, "sprayed" },
    { 0xAE34C1A0, "spraying" },
    { 0x821E0893, "sprays" },
    { 0x803A2B20, "spread" },
    { 0x57DD1FD4, "spread_all" },
    { 0x2648B1D1, "spread_array_thread" },
    { 0x93302B16, "spreadads" },
    { 0xDDD241CC, "spreadfire" },
    { 0x173357B8, "spreading" },
    { 0xC70636AF, "spreadrange" },
    { 0x43825BA9, "spreadrangeclose" },
    { 0x8CD311CB, "spreads" },
    { 0xECD35F32, "spring" },
    { 0xFC98C285, "spring_jump_check_active" },
    { 0x47C03426, "springfield" },
    { 0xA0915BA3, "springleak" },
    { 0x7AC97485, "springpad" },
    { 0x25ED09B4, "springpad_add_fling_ent" },
    { 0xA74E942D, "springpad_animate" },
    { 0x90595CEC, "springpad_attack_delay" },
    { 0x886AFA16, "springpad_audio" },
    { 0x56205C88, "springpad_buddy" },
    { 0xB4815D9C, "springpad_cleanup" },
    { 0x53A884F0, "springpad_count_watcher" },
    { 0x738D05CB, "springpad_damage" },
    { 0x29371288, "springpad_door" },
    { 0xB834C9DB, "springpad_expired" },
    { 0x2451657E, "springpad_flag" },
    { 0x3D294968, "springpad_fling_attacker" },
    { 0x194AA6A2, "springpad_fx" },
    { 0xF2732B27, "springpad_in_range" },
    { 0x188789F3, "springpad_kills" },
    { 0xD0A6E8A3, "springpad_motor" },
    { 0x99F7BE31, "springpad_name" },
    { 0xD69DA675, "springpad_power_off" },
    { 0x67E338C9, "springpad_power_on" },
    { 0x08803E47, "springpad_sound_ent" },
    { 0x63AFF86D, "springpad_trigger_radius" },
    { 0xB23C1A2E, "springpad_whistle" },
    { 0xA98191BF, "springpadaudiocleanup" },
    { 0x11F240B7, "springpadbuildable" },
    { 0x0A0F18A3, "springpadthink" },
    { 0xF2D1DB35, "springpadthinkcleanup" },
    { 0xA75E6D5F, "sprinkler" },
    { 0x1E09215B, "sprinkler_debug" },
    { 0x58E3605C, "sprinkler_init" },
    { 0x39958106, "sprinkler_think" },
    { 0xCB2ECB74, "sprinkler_water_drops" },
    { 0xB4A5688A, "sprinkler_water_think" },
    { 0xA659A9E3, "sprinklers_init" },
    { 0x26F88B59, "sprint" },
    { 0xE2BFF56A, "sprint2walk" },
    { 0x02CB677D, "sprint2walk_done" },
    { 0x935FF9FB, "sprint_anim" },
    { 0x4723FF8B, "sprint_begin" },
    { 0xC916AD3A, "sprint_blocker" },
    { 0xF3EE003F, "sprint_dist_sq" },
    { 0xC5DB65DB, "sprint_drain_rate" },
    { 0xFF53366B, "sprint_end" },
    { 0xCB4E260C, "sprint_gap_time" },
    { 0xE92B7A65, "sprint_hint_timer" },
    { 0xDE6811CA, "sprint_hits" },
    { 0x63618342, "sprint_hits_half" },
    { 0xB9FF7E10, "sprint_index" },
    { 0x7FD017ED, "sprint_jump_check" },
    { 0x998EFFA1, "sprint_jump_cleared" },
    { 0x90576BD5, "sprint_jump_custom_death_message" },
    { 0x9852A580, "sprint_jump_custom_death_message_stop" },
    { 0x5F6C77E9, "sprint_key" },
    { 0x1D5AB369, "sprint_message" },
    { 0x7BA69447, "sprint_meter" },
    { 0x1F913B88, "sprint_meter_max" },
    { 0x7A371A16, "sprint_meter_min" },
    { 0xE1D72DD3, "sprint_mighty_wind" },
    { 0xC5390BAB, "sprint_mighty_wind2" },
    { 0xEB21A1D5, "sprint_or_not_vo" },
    { 0x4A9F6A19, "sprint_patrollers_end_func" },
    { 0xA43AC212, "sprint_patrollers_movement" },
    { 0x0C2AF51E, "sprint_pressed" },
    { 0x9ABD7371, "sprint_probability" },
    { 0x8C1340CD, "sprint_recover_rate" },
    { 0xE91DCE74, "sprint_recover_time" },
    { 0xB083FE88, "sprint_start" },
    { 0xD991B9DC, "sprint_think" },
    { 0x2EAC938F, "sprint_time" },
    { 0x35777FBF, "sprint_timer" },
    { 0xD43FCF9F, "sprint_to_cover" },
    { 0x831956FB, "sprint_to_goal" },
    { 0x7C0FB897, "sprint_to_retreat" },
    { 0x178CBA35, "sprint_vo_delete" },
    { 0x4AC2D487, "sprint_while_enemy_not_visible" },
    { 0xA084D30E, "sprint_wind" },
    { 0x31DB967E, "sprintanim" },
    { 0xA8B1FBB9, "sprintbuttonpressed" },
    { 0xB177CD3F, "sprintclip" },
    { 0xCC690462, "sprintclip7" },
    { 0xEAE96B09, "sprintdist" },
    { 0x5B4B542D, "sprintdistthissprint" },
    { 0x38587186, "sprinted" },
    { 0xF421EC80, "sprinter" },
    { 0xE4844AAB, "sprinters" },
    { 0x4A302DEF, "sprinting" },
    { 0x69A30986, "sprintmodifier" },
    { 0x72932907, "sprintonly" },
    { 0x5F75AD10, "sprints" },
    { 0xA2F0CC19, "sprintspeedmodifier" },
    { 0x20650C38, "sprintstarttime" },
    { 0x9CF98748, "sprintthenkill" },
    { 0x8CC5AA07, "sprintthenkillend" },
    { 0xED3B39D1, "sprintthenkilltimeout" },
    { 0xF176BD33, "sprinttogoal" },
    { 0x396823AD, "sprintuprequired" },
    { 0x2A15E100, "spript_forcespawn" },
    { 0x88033892, "sprite" },
    { 0x9CC0B24E, "sprops" },
    { 0xD428FF60, "spstart" },
    { 0xD3EAC08E, "spurts" },
    { 0xC5B7DD38, "sputter" },
    { 0x2B7348BE, "spwan" },
    { 0x81B98201, "spwaned" },
    { 0x240D3047, "spwn" },
    { 0x17D134CA, "spwner" },
    { 0x8CAFEC3E, "spwns" },
    { 0xA10454DD, "spy" },
    { 0x1504F44D, "spy_monitors_randomize" },
    { 0x679D0535, "spyplane" },
    { 0x695D8E4E, "spyplane_death" },
    { 0xBFC82AA3, "spyplane_death_waiter" },
    { 0x373BE1EF, "spyplane_mp_timer_kill_" },
    { 0xAE32AA05, "spyplane_sp_timer_kill_" },
    { 0x50412711, "spyplane_timeout" },
    { 0xC84B7ADD, "spyplane_watchfor_gamerules_destruction" },
    { 0x2E525E71, "spyplaneabort" },
    { 0xDA588ACB, "spyplaneactive" },
    { 0x12FEFCBC, "spyplaneentrancetime" },
    { 0x4F470C32, "spyplaneexittime" },
    { 0xD7BBFFBC, "spyplanemodel" },
    { 0x0B5A2341, "spyplaneshouldleave" },
    { 0xF0E4505D, "spyplanetype" },
    { 0x216DD4BB, "spyplaneupdatespeed" },
    { 0x5966DEA9, "spyplaneviewtime" },
    { 0x8285902D, "spz_breach_dialog" },
    { 0x18D84FAD, "sq" },
    { 0xAFD734E0, "sq_" },
    { 0x68A08F58, "sq_1_pts_1_over" },
    { 0x0B0CF173, "sq_1_ssp_1_over" },
    { 0x8154D1A0, "sq_2_pts_2_over" },
    { 0x6BF51C77, "sq_2_ssp_2_over" },
    { 0x371B4624, "sq_assign_signs" },
    { 0x4EF46F7A, "sq_atd_cur_drg" },
    { 0xC79875C5, "sq_atd_dragon_icon_setup" },
    { 0x0D913F60, "sq_atd_drg_puzzle" },
    { 0x475591EE, "sq_atd_drg_puzzle_complete" },
    { 0x271528D2, "sq_atd_elevator_activated" },
    { 0x9FC943DD, "sq_atd_elevators" },
    { 0x2C38B082, "sq_atd_over" },
    { 0x1BBDBC9E, "sq_atd_watch_elevator" },
    { 0xEE676649, "sq_ball_putdown_trigs" },
    { 0x98684983, "sq_bg_easy_cleanup" },
    { 0xF217C704, "sq_bg_macguffin_collected" },
    { 0xCBF65026, "sq_bg_macguffin_received_by_player" },
    { 0x10BCADF5, "sq_bg_macguffin_think" },
    { 0x98229BE7, "sq_bg_macguffins" },
    { 0x35AD9C43, "sq_bg_spawn_rumble" },
    { 0xABCF469E, "sq_boss_battle_complete" },
    { 0x13893E52, "sq_boundary" },
    { 0xB438A9BA, "sq_bp_button_pressed" },
    { 0x37F16744, "sq_bp_buttons" },
    { 0x9645C380, "sq_bp_correct_button" },
    { 0xE30AC0D4, "sq_bp_delete_green_lights" },
    { 0xFA7B75A9, "sq_bp_light_on" },
    { 0x78AC31C5, "sq_bp_set_current_bulb" },
    { 0x961BC27F, "sq_bp_spawn_board" },
    { 0xF5C0F84B, "sq_bp_spawn_trigger" },
    { 0xFC6B31FA, "sq_bp_start_puzzle_lights" },
    { 0xF453146E, "sq_bp_timeout" },
    { 0xFCB28413, "sq_bp_wrong_button" },
    { 0x0089863B, "sq_bt_over" },
    { 0x44534278, "sq_buildable" },
    { 0x999005D3, "sq_buildables" },
    { 0x4165AFAA, "sq_buried_clientfield_init" },
    { 0x52F17ECC, "sq_buried_register_visionset" },
    { 0xB2B53AD3, "sq_clientfield_vo" },
    { 0x5290FF32, "sq_clip" },
    { 0x0B552F58, "sq_cmd" },
    { 0x4E52513E, "sq_common_electricbox" },
    { 0x5E07E378, "sq_common_electricbox2" },
    { 0x4216C1EE, "sq_common_electricbox4" },
    { 0x68193C57, "sq_common_electricbox5" },
    { 0x817A5196, "sq_common_meteor" },
    { 0x7B4D1A30, "sq_common_panel" },
    { 0x9B781994, "sq_common_scaffolding" },
    { 0xCE6DCB0C, "sq_common_transceiver" },
    { 0x972F2AE2, "sq_craftable" },
    { 0x6F21A816, "sq_ctw_m_tubes_lit" },
    { 0x9F8820A5, "sq_ctw_over" },
    { 0xD61B2960, "sq_ctw_zombie_powered_up" },
    { 0xD0431278, "sq_data" },
    { 0x438878F5, "sq_debug_print_vo" },
    { 0x996B81CF, "sq_delete_tower_pieces" },
    { 0x0C16F3D7, "sq_easy_cleanup" },
    { 0xDB9029ED, "sq_fc_still_valid" },
    { 0x6C883910, "sq_final_easy_cleanup" },
    { 0xC11D3ADB, "sq_fireball_hit_player" },
    { 0x2FEC0F10, "sq_flatcard_logic" },
    { 0xD15D4D5B, "sq_ftl_get_lantern_holder" },
    { 0xD246357E, "sq_ftl_lantern_fuel" },
    { 0xC389BE96, "sq_ftl_lantern_inc" },
    { 0x1C9E9EC4, "sq_ftl_maxis_vo_on_holder" },
    { 0x31BA2F9F, "sq_ftl_over" },
    { 0xF7B0B60F, "sq_ftl_show_marker" },
    { 0xEE9E061D, "sq_generator_buildablestub_reject_func" },
    { 0x8D26A425, "sq_give_all_perks" },
    { 0x0D75CAD7, "sq_give_player_all_perks" },
    { 0x8D7F2FA3, "sq_give_player_perks" },
    { 0x6A705AA8, "sq_give_player_rewards" },
    { 0x8CEF775A, "sq_gl_over" },
    { 0x34EC5B9B, "sq_gl_setup_buildable_trig" },
    { 0x7CF24E62, "sq_highrise_clientfield_init" },
    { 0x9F2DF788, "sq_ip_over" },
    { 0x5BB81038, "sq_ip_puzzle_complete" },
    { 0xFF89E159, "sq_is_ghost_lamp" },
    { 0x53124688, "sq_is_max_tower_built" },
    { 0x73D59974, "sq_is_ric_tower_built" },
    { 0x20541B03, "sq_is_weapon_sniper" },
    { 0x42B8AEB4, "sq_jetgun_built" },
    { 0xE5F8CD19, "sq_lamp_generator_unitrig" },
    { 0x9096E9BD, "sq_lamp_piece" },
    { 0xF465E2E5, "sq_leg_punches" },
    { 0xF1044A92, "sq_level" },
    { 0xCE05945D, "sq_ll_over" },
    { 0x8BC2F390, "sq_ll_show_code" },
    { 0x9C221A55, "sq_ll_show_code_vo_max" },
    { 0x56ED67A1, "sq_ll_show_code_vo_ric" },
    { 0x49939B2E, "sq_location_valid" },
    { 0x514CD8FF, "sq_m_tower" },
    { 0xF8FDB6B5, "sq_m_tower_battery" },
    { 0x09DE4DC8, "sq_m_tower_vacuum_tube" },
    { 0x460E2EF2, "sq_main_controller" },
    { 0xB7AC02AC, "sq_maxis_complete" },
    { 0x0D995979, "sq_maxis_ending_spawn_func" },
    { 0xFE3A0565, "sq_metagame" },
    { 0x6BF36719, "sq_metagame_clear_lights" },
    { 0x433550D5, "sq_metagame_clear_tower_pieces" },
    { 0x5EDDB207, "sq_metagame_machine_set_light" },
    { 0x15D2529E, "sq_metagame_on_player_connect" },
    { 0x4A0815BF, "sq_metagame_player_connected" },
    { 0x1B3D2ED7, "sq_metagame_reset_machine" },
    { 0xB13577D2, "sq_metagame_turn_off_watcher" },
    { 0xB2FF8F77, "sq_ml_curr_lever" },
    { 0x820EACAD, "sq_ml_puzzle_logic" },
    { 0x6398EBFA, "sq_ml_puzzle_wait_for_levers" },
    { 0xF352C47D, "sq_ml_reset_levers" },
    { 0xBDD96B44, "sq_ml_show_lever_debug" },
    { 0xDF03A426, "sq_ml_spawn_lever" },
    { 0xB3CE7B59, "sq_ml_spawn_levers" },
    { 0xC996D6AE, "sq_ml_spawn_trigger" },
    { 0xCD005FED, "sq_mta_over" },
    { 0x066CAB11, "sq_mtower_buildable" },
    { 0xE89DBCE6, "sq_oillamp" },
    { 0x7154A7D2, "sq_one_inch_punch" },
    { 0x16E5D581, "sq_one_inch_punch_death_watch" },
    { 0x311438F3, "sq_one_inch_punch_disconnect_watch" },
    { 0x07511D08, "sq_one_inch_punch_kills" },
    { 0x32971CE5, "sq_one_inch_punch_reclean" },
    { 0x359DFEF5, "sq_one_inch_punch_stage" },
    { 0x6E54F5F1, "sq_one_inch_punch_tablet" },
    { 0xAF20AFB4, "sq_one_inch_punch_tablet_num" },
    { 0x5AE84F7A, "sq_osc_over" },
    { 0xC1B6A076, "sq_ows_over" },
    { 0x1D05A56C, "sq_ows_start" },
    { 0x223433FC, "sq_pickup_reset" },
    { 0x4BBB32CF, "sq_player" },
    { 0x0C3C8296, "sq_players" },
    { 0x9C2615A4, "sq_prestart_hide" },
    { 0x6CCAC159, "sq_progress" },
    { 0x3F20FE47, "sq_pts_create_use_trigger" },
    { 0xFBA06CDE, "sq_pts_springad_count" },
    { 0xC1663553, "sq_pts_springad_count1" },
    { 0x4F5EC618, "sq_pts_springad_count2" },
    { 0x75614081, "sq_pts_springad_count3" },
    { 0x336DA48E, "sq_pts_springad_count4" },
    { 0xA3DDB892, "sq_pts_springpad_in_place" },
    { 0x64B1DD4D, "sq_ptt_over" },
    { 0x6B5D7D80, "sq_r_tower" },
    { 0x423826F3, "sq_r_tower_crystal" },
    { 0x3D44C036, "sq_r_tower_satellite" },
    { 0x580634E9, "sq_refresh_player_navcard_hud" },
    { 0xA3334D57, "sq_refresh_player_navcard_hud_internal" },
    { 0x7D3E1A2B, "sq_richtofen_c_screecher_lights" },
    { 0x0E7A6CC6, "sq_richtofen_complete" },
    { 0xC3C2BF2D, "sq_richtofen_zombie" },
    { 0x5EF4E0B4, "sq_rtower_buildable" },
    { 0x3F106001, "sq_s_tower_antenna" },
    { 0x24CEF007, "sq_s_tower_wire" },
    { 0x2D6BFA19, "sq_sc2_over" },
    { 0x796FB863, "sq_sc_over" },
    { 0x030A9619, "sq_sc_switch" },
    { 0x0DBBD09D, "sq_set_stat" },
    { 0x5990827B, "sq_sign_damaged" },
    { 0xF2018411, "sq_slb_create_use_trigger" },
    { 0x73A48486, "sq_slb_over" },
    { 0xDE945DDD, "sq_sliquified" },
    { 0x354364BF, "sq_spawn_model_at_struct" },
    { 0x920EFC12, "sq_spawn_props" },
    { 0x11CD8084, "sq_ss1_over" },
    { 0x20778669, "sq_ss2_over" },
    { 0xB56E4C71, "sq_ss_button_debug" },
    { 0x6A4E9B52, "sq_ss_button_dud_thread" },
    { 0x1C03FFEC, "sq_ss_button_thread" },
    { 0xC5CC39D5, "sq_stage_3complete" },
    { 0xD5A83A80, "sq_std_struct_watcher" },
    { 0x7F0F9F17, "sq_std_watch_for_restart" },
    { 0x1499A076, "sq_std_watcher" },
    { 0x8C9F1FAF, "sq_struct_debug" },
    { 0x78B6AE2A, "sq_targets" },
    { 0xB7D428B1, "sq_tower_spawn_attachment" },
    { 0xC10DC7C3, "sq_tpo" },
    { 0x70FC2D57, "sq_tpo_check_players_in_time_bomb_volume" },
    { 0x006B1A58, "sq_tpo_generator_powered" },
    { 0xDB389541, "sq_tpo_give_item" },
    { 0x8383B24C, "sq_tpo_item_hunt_done" },
    { 0x0965E338, "sq_tpo_over" },
    { 0x223B3837, "sq_tpo_special_round_ended" },
    { 0xA0EBFBC4, "sq_tpo_special_round_started" },
    { 0xF7496C47, "sq_tpo_stop_checking_time_bomb_volume" },
    { 0x1462C05E, "sq_tpo_unitrig" },
    { 0xA5DCB734, "sq_ts_over" },
    { 0xAFA26F76, "sq_volume" },
    { 0x3A127FDF, "sq_wisp_failed" },
    { 0xFF310120, "sq_wisp_powered" },
    { 0xD091F418, "sq_zombie_damage_response" },
    { 0xEA71944E, "sq_zombie_death_event_response" },
    { 0x8916D84E, "sqad" },
    { 0x1655FF21, "sqaud" },
    { 0x1EA687DB, "sqaudmember" },
    { 0x17CD4B3C, "sqc" },
    { 0xDD141E32, "sqcommon" },
    { 0xBDE18FD6, "sqcommonbuildable" },
    { 0x77842F20, "sqcommoncraftable" },
    { 0xF1CAD0D3, "sqd" },
    { 0xA5C9CF68, "sqdistance" },
    { 0xA1A0231B, "sqmtowerbuildable" },
    { 0xE75F3773, "sqoillampbuildable" },
    { 0xDDA81F15, "sqr" },
    { 0x86547164, "sqr16" },
    { 0x4974F22E, "sqr32" },
    { 0xB16B088A, "sqr36" },
    { 0x18767FFF, "sqr64" },
    { 0x1445CDA7, "sqr8" },
    { 0xCCC6AAFB, "sqrt" },
    { 0x03EB6464, "sqrtowerbuildable" },
    { 0xB7A5A4AC, "sqs" },
    { 0xC47444D1, "squad" },
    { 0x0E7CCE4A, "squad1" },
    { 0xE87A53E1, "squad2" },
    { 0xC277D978, "squad3" },
    { 0xCC893257, "squad4" },
    { 0x492DF846, "squad_02" },
    { 0x81727AD5, "squad_1" },
    { 0x0D72D63E, "squad_ai" },
    { 0x379E6B23, "squad_array" },
    { 0x916EF8C4, "squad_at_ddm_pos" },
    { 0xE459F42B, "squad_at_steps" },
    { 0xA04BAAA8, "squad_attack" },
    { 0xE93D500B, "squad_auto_move" },
    { 0x078F607B, "squad_battle_cries" },
    { 0x1258A1E6, "squad_behavior_boat_landing_sampan_engagement" },
    { 0x33D9AD8E, "squad_bmp_destroy" },
    { 0xE84B86EA, "squad_breadcrumb_distsq" },
    { 0xB80D0D60, "squad_breath_off" },
    { 0xC407DEBA, "squad_breath_on" },
    { 0xC85D0599, "squad_cars" },
    { 0x05AD7F47, "squad_central" },
    { 0x0213FEE9, "squad_clean_up" },
    { 0xBE7A3EC3, "squad_clear" },
    { 0x28162F67, "squad_color_chain" },
    { 0xF3C82BF9, "squad_count" },
    { 0x7D3C437A, "squad_death" },
    { 0x78C5965F, "squad_death_watcher" },
    { 0x7794F1D6, "squad_detected" },
    { 0x8D3E7BA0, "squad_detected_so_you_dont_have_to" },
    { 0xD1D98EBA, "squad_detection_logic" },
    { 0xF2C55274, "squad_dialog" },
    { 0xA9756429, "squad_dir" },
    { 0x98838AC6, "squad_disable_hero_watcher" },
    { 0x7787B07D, "squad_disband" },
    { 0x691A0D2A, "squad_disbanded" },
    { 0xE5C83C54, "squad_dist" },
    { 0xCDF21904, "squad_dist_objective" },
    { 0xC45108C9, "squad_down_when_bettied" },
    { 0xC65139C7, "squad_drop_weapon_rate" },
    { 0xC6ECD1FA, "squad_enemies_globals_init" },
    { 0x90FA154D, "squad_enemies_init" },
    { 0x72C15BF4, "squad_enter_moonpool" },
    { 0xA36E8DBB, "squad_equip_suits" },
    { 0xFF7D2EA3, "squad_escapes_to_hillside" },
    { 0xBAC8A617, "squad_execute_cb" },
    { 0x3DE187E1, "squad_fail_trigger" },
    { 0xDE3D9873, "squad_fail_trigger_array" },
    { 0xD79FD44B, "squad_fail_trigger_persistent" },
    { 0x824BBC3F, "squad_follower_func" },
    { 0xCDC1E697, "squad_follower_settings_func" },
    { 0x11BC83F1, "squad_formation" },
    { 0x8E3DDC2D, "squad_formation_position" },
    { 0x52C481D6, "squad_gets_down" },
    { 0x2AF874FA, "squad_go_formation" },
    { 0x47EEAE09, "squad_go_formation_2" },
    { 0x4D6FB6F0, "squad_hidden" },
    { 0x85DB35F2, "squad_hideallsquadmarkers" },
    { 0xF4C093A3, "squad_id" },
    { 0x5E3FF5EA, "squad_ignoreall_till_nearflak" },
    { 0xCB52E355, "squad_in_position" },
    { 0x09DF45AA, "squad_init" },
    { 0x904D5E6D, "squad_leader_behavior_func" },
    { 0x55BD3D68, "squad_leader_influencer_radius" },
    { 0xAC55CE00, "squad_leader_influencer_score" },
    { 0xB8DDAE04, "squad_leader_influencer_score_curve" },
    { 0xDD2AD61F, "squad_leader_manager" },
    { 0x64D34A78, "squad_left_advance" },
    { 0x8C3A7D19, "squad_manager" },
    { 0xB306539C, "squad_manager_think" },
    { 0x6207780F, "squad_material" },
    { 0x83B86D33, "squad_move_inside_ship" },
    { 0xE9CAA5D5, "squad_moved" },
    { 0x54CF41B5, "squad_moves_to_next_safe_point" },
    { 0x68BF59E8, "squad_moveup_to_campfire" },
    { 0xE91F532E, "squad_moving" },
    { 0x4EFCBA1E, "squad_moving_up" },
    { 0xB1007703, "squad_nodes" },
    { 0xAB2B6F8F, "squad_nonodecheckonmove" },
    { 0xE2F2CC44, "squad_on_land_trigger" },
    { 0x3B8E9297, "squad_promotion" },
    { 0x74F79C9D, "squad_radius_max" },
    { 0xB25BA7B3, "squad_radius_min" },
    { 0x7BA550EC, "squad_reached_goal" },
    { 0x5C7EF607, "squad_ready_for_boat_drive" },
    { 0x9B8F00D1, "squad_ready_to_move" },
    { 0x555C2BFF, "squad_replenish_init" },
    { 0x15963949, "squad_right_advance" },
    { 0x20695F4F, "squad_run_to_safe_room" },
    { 0xE2E767FA, "squad_runto_guardhouse" },
    { 0x695EABBB, "squad_setup" },
    { 0x02E8970F, "squad_size" },
    { 0xD85811A9, "squad_spawn" },
    { 0xF5B4E73B, "squad_spawn_array" },
    { 0xA6B149D6, "squad_spawned" },
    { 0x527DA5E1, "squad_spread" },
    { 0xB4185E10, "squad_sprint" },
    { 0x262FE995, "squad_sprint_offset_distsq" },
    { 0xBED284B5, "squad_sprint_watcher" },
    { 0x38DB9546, "squad_start_spots" },
    { 0x47053442, "squad_state_attack" },
    { 0x762CF1A2, "squad_state_defend" },
    { 0x2BE4D243, "squad_state_invalid" },
    { 0x179129B5, "squad_state_managed" },
    { 0xCC6EE255, "squad_state_move" },
    { 0x9392136B, "squad_state_movewithai" },
    { 0x716F24BA, "squad_state_movewithplayer" },
    { 0xB66B4600, "squad_state_patrol" },
    { 0xA4C3EF6E, "squad_sundeck_fight" },
    { 0x21C66F53, "squad_takes_cover_from_sniper" },
    { 0x7E6073C6, "squad_targets" },
    { 0x58B721A2, "squad_to_e3_startspots" },
    { 0xA63F343C, "squad_type" },
    { 0x90A63445, "squad_under_apc" },
    { 0xF3C54DA2, "squad_unloaded" },
    { 0x3780B997, "squad_zoning" },
    { 0xC1A99EA0, "squadarray" },
    { 0xA6094C22, "squadattacktarget" },
    { 0x325FE1CA, "squadbreadcrumb" },
    { 0xB410015A, "squadcenter" },
    { 0xD1E78AFD, "squadchange" },
    { 0x6F33E358, "squadcommand" },
    { 0x81651048, "squadcommandinprogress" },
    { 0x734C5156, "squadcommandwaiter" },
    { 0x42E33D0E, "squadcount" },
    { 0x1C6B3EE3, "squadcreatefunc" },
    { 0x24C0EBD2, "squadcreatefuncs" },
    { 0xA8C86FD5, "squadcreatestrings" },
    { 0x9A8CEEC6, "squaddebug" },
    { 0x4972CDC5, "squaddialog" },
    { 0x1C800BDD, "squaddonothing" },
    { 0x2EF9BD50, "squadenemyteam" },
    { 0xB98A89B8, "squadent" },
    { 0x942B8B72, "squadid" },
    { 0xC0D04993, "squadindex" },
    { 0xB2F1D64D, "squadinitialized" },
    { 0x33BC1CD2, "squadleader" },
    { 0xE2600633, "squadleader_changed" },
    { 0xB645A6E9, "squadlist" },
    { 0x81730ABE, "squadmanager" },
    { 0x4CFBF572, "squadmate" },
    { 0xE1D0B235, "squadmate_dialog" },
    { 0x1DB675FD, "squadmates" },
    { 0x97EAB9D3, "squadmeetup_disturb" },
    { 0x3FF4E4AB, "squadmember" },
    { 0xE1B78133, "squadmemberdeath" },
    { 0x209C018A, "squadmembers" },
    { 0xA3DE2E85, "squadmemberthink" },
    { 0x370C3336, "squadmove" },
    { 0x2B2DA0E4, "squadmovewithai" },
    { 0x9C8C3A05, "squadmovewithplayer" },
    { 0x63C75A10, "squadname" },
    { 0x1636D9E2, "squadnotifylevelonempty" },
    { 0x527D372B, "squadofficerwaiter" },
    { 0x3B66D26B, "squadpatrol" },
    { 0x9987B804, "squadrand" },
    { 0xF17C853C, "squadref" },
    { 0xB31E92E2, "squadron" },
    { 0x431673B8, "squads" },
    { 0xE0C41286, "squadselectnext" },
    { 0x1CAFBE88, "squadselectnextaiandtakeover" },
    { 0x370DAA77, "squadstates" },
    { 0xA875E507, "squadthink" },
    { 0x290921A7, "squadthreatwaiter" },
    { 0xC85C2C67, "squadtracker" },
    { 0xB91AD0E9, "squadtype" },
    { 0xF3E77B3E, "squadupdate" },
    { 0x12C63234, "squadupdatefunc" },
    { 0x92F2E927, "squadupdatefuncs" },
    { 0x5A9D7A90, "squadupdatestrings" },
    { 0x7E1EA688, "square" },
    { 0x435FFC98, "square_anetta" },
    { 0xF506A401, "square_chain_2" },
    { 0x11ADDF15, "square_friendlies_strat" },
    { 0x0B6B98A8, "square_officer_strat" },
    { 0x86C4C4A5, "square_sdk_1" },
    { 0xACC73F0E, "square_sdk_2" },
    { 0xC1A59808, "square_sdks" },
    { 0x11B29D8D, "square_width" },
    { 0xE9FAC49C, "squared" },
    { 0x63D0A3A3, "squares" },
    { 0xAAC78955, "squashed" },
    { 0x593E2BFC, "squashed_death_alarm" },
    { 0x79C5A108, "squashed_death_alarm_nearest_point" },
    { 0x8E95AD9B, "squashed_death_init" },
    { 0x249BEB61, "squat" },
    { 0x15B16C9F, "squeeze" },
    { 0x750D6494, "squelch" },
    { 0x07C26245, "squelch_damage_overlay" },
    { 0x31EC232F, "squib" },
    { 0x93B8ED77, "squib_orgs" },
    { 0x4AA84F76, "squibs" },
    { 0x7B237CCC, "squibs_end" },
    { 0x3DE8DD67, "squibs_start" },
    { 0xB8A6DEB8, "squiggle" },
    { 0x51F2681C, "squirrel" },
    { 0x88CC9B6A, "squish" },
    { 0x79635697, "squishcount" },
    { 0x3EDACA16, "sr" },
    { 0x48DD3F7E, "sr71" },
    { 0x2D5505D4, "sr71_back_in_cockpit" },
    { 0x53AD674F, "sr71_by_cut" },
    { 0x9AF0DFA1, "sr71_camera_cut" },
    { 0x5A34FE63, "sr71_camera_cuts_done" },
    { 0x50F8F62C, "sr71_canopy_shut_end" },
    { 0xA6C3F8C7, "sr71_canopy_shut_start" },
    { 0x296096EA, "sr71_close_canopy" },
    { 0xC91C849A, "sr71_crew_group_anim" },
    { 0x841E3836, "sr71_do_takeoff_stick" },
    { 0xE4B1F795, "sr71_do_throttle" },
    { 0x301A7ABA, "sr71_earth_curvature_intro" },
    { 0xFD956294, "sr71_end" },
    { 0x5D225440, "sr71_external_before_launch" },
    { 0x342E1F12, "sr71_fade_to_space" },
    { 0x2E7905AA, "sr71_fire_thrusters" },
    { 0x442C64A6, "sr71_fireup_rumble" },
    { 0x5CB5E5C5, "sr71_go_to_ground" },
    { 0x88246FD9, "sr71_handle_engine_prompt" },
    { 0xDBB12E31, "sr71_handle_runway_props" },
    { 0x24E5F301, "sr71_intro" },
    { 0x9829C780, "sr71_intro_sounds" },
    { 0xD4E6049C, "sr71_lift_off" },
    { 0x06C82556, "sr71_relaystation_end" },
    { 0x845A8AFA, "sr71_rso_anim_intro" },
    { 0x412F494A, "sr71_rts" },
    { 0xB2AD2D93, "sr71_rts_second_state" },
    { 0x67952E42, "sr71_run_sound_ent" },
    { 0x736D5C0C, "sr71_run_sound_int_ent" },
    { 0xD44A2A88, "sr71_second_cut" },
    { 0x8F1C69EA, "sr71_side_jitter_func" },
    { 0x99DABE2D, "sr71_side_rumble_func" },
    { 0xFF253D6B, "sr71_sound_start" },
    { 0x2F1224A8, "sr71_sound_start_post_safehouse" },
    { 0xF12C9BA4, "sr71_space_backin" },
    { 0xD3A16AAE, "sr71_space_go_outside" },
    { 0x80E8E282, "sr71_space_snap_to_cockpit" },
    { 0x6D290739, "sr71_start_up" },
    { 0x7BB8B6A0, "sr71_tail_sound_l_ent" },
    { 0x164A321A, "sr71_tail_sound_l_int_ent" },
    { 0xE27D255A, "sr71_tail_sound_r_ent" },
    { 0xF4C23FD4, "sr71_tail_sound_r_int_ent" },
    { 0x9EE2E133, "sr71_takeoff" },
    { 0x384C4C85, "sr71_takeoff_rumble" },
    { 0xE7392AB2, "sr71_takeoff_sounds" },
    { 0x0BFA3E41, "sr71_test" },
    { 0x8ABD7D74, "sr71_thruster_jitter_func" },
    { 0x423338EF, "sr71_thruster_rumble_func" },
    { 0xDB657364, "sr71_twitch_anim" },
    { 0x762FAE9C, "sr71_update_jitter_facing" },
    { 0xFD71F173, "sr71_wait_for_x" },
    { 0xA28D7676, "sr_aa_targ" },
    { 0x5748A298, "sr_alive" },
    { 0xB21BB8E8, "sr_check_grenade" },
    { 0xDDA77021, "sr_nade_hit" },
    { 0x6576D1AF, "sr_node_array" },
    { 0x7C31EE6C, "sr_off" },
    { 0xA5C4C5F9, "sr_pop_up_targets" },
    { 0xA06EB612, "sr_rumble" },
    { 0x17A41557, "sr_watch_grenade_target" },
    { 0x221A5919, "src" },
    { 0x09BD3EF0, "src_node" },
    { 0xA3D9E01F, "src_s" },
    { 0x0629378F, "sre" },
    { 0x48AB3156, "sres" },
    { 0x4B44E513, "srgt" },
    { 0xEA381605, "sro" },
    { 0x0F7C64A4, "sroomname" },
    { 0xC1F2B289, "srs" },
    { 0x96C1BB54, "srsly" },
    { 0x5639666C, "srv_react_events" },
    { 0x64DD447F, "ss" },
    { 0xE72B2D5D, "ss0" },
    { 0x3330222F, "ss2" },
    { 0xE504FDED, "ss2_hack" },
    { 0xC415D225, "ss_buttons" },
    { 0x1B1CBB0D, "ss_comp_vox_count" },
    { 0x358664BB, "ss_debug" },
    { 0x274A9362, "ss_done" },
    { 0xCA557FFD, "ss_failed" },
    { 0xDE531358, "ss_kill_button_thread" },
    { 0xF5A030D4, "ss_logic" },
    { 0x34ED5B74, "ss_logic_internal" },
    { 0x092BFF4B, "ss_user_val" },
    { 0x5DCA570B, "ss_user_val_text" },
    { 0x1D3F9FDF, "ss_val" },
    { 0x0AC554D7, "ss_val_text" },
    { 0x93649AA2, "ss_won" },
    { 0x73160CA4, "ssasakiatvi" },
    { 0x594B7B5E, "ssavename" },
    { 0xFAEA0B25, "sscenename" },
    { 0xE5AB5415, "sscript_noteworthy" },
    { 0x9F56C24D, "sscript_vehiclenodegroup" },
    { 0x94F34755, "ssdflt" },
    { 0x3678BFD5, "ssh" },
    { 0x843BE837, "sshh" },
    { 0xD4A6E311, "ssp1_advance_dragon" },
    { 0xA0A65BD1, "ssp1_ball_first_sliquified" },
    { 0xCAC61507, "ssp1_ball_sliquified_2" },
    { 0x92037578, "ssp1_rotate_ball" },
    { 0xC8CBA898, "ssp1_sliquify_balls" },
    { 0xCA2C910A, "ssp1_watch_ball" },
    { 0x4DDBAB28, "ssp2_advance_dragon" },
    { 0xE43BF3BC, "ssp2_corpse_made" },
    { 0x43DC2E78, "ssp2_resurrection_done" },
    { 0xE1134C5D, "ssp_2_zombie_death_check" },
    { 0x079A5F2C, "sssn" },
    { 0xECBBEAEC, "sstartnode" },
    { 0x70AAA16A, "sstartpoint" },
    { 0xFF2CF55A, "sstrafenumber" },
    { 0x73A1C7BF, "sstruct" },
    { 0xB4013F92, "sstunnedanim" },
    { 0x762CC84A, "ssurce" },
    { 0x53034DB2, "ssysname" },
    { 0x6AD52C62, "ssysstate" },
    { 0x5ACBEBA0, "st" },
    { 0x54DEC0B9, "st1" },
    { 0x12EB24C6, "st6" },
    { 0x8E2EF6ED, "st_behavior" },
    { 0xEB886698, "st_fade_screen" },
    { 0xA07A4E59, "stab" },
    { 0xE6E50666, "stab_big" },
    { 0x65426BE7, "stab_effect" },
    { 0x19E1A571, "stab_event_start" },
    { 0x089AF330, "stab_leg" },
    { 0xB4FB4AEC, "stab_shoulder" },
    { 0x69874161, "stab_small" },
    { 0x6C2E3E6A, "stabalizer" },
    { 0xF494FD16, "stabbed" },
    { 0x70ADC530, "stabber" },
    { 0xE72AD37A, "stabber_setup" },
    { 0x2EBD161F, "stabbing" },
    { 0x9181E6EF, "stabee" },
    { 0xD0BD6D40, "staber_canbe_killed" },
    { 0x2E078A72, "stability" },
    { 0x290A4E50, "stabilize" },
    { 0x9628AED2, "stabilizer" },
    { 0x6BEA3C95, "stabilizer_audio" },
    { 0x2E7FADDD, "stabilizers" },
    { 0x1B754CD1, "stabilizing" },
    { 0xCD613B38, "stable" },
    { 0x9D2A0C2C, "stable_count" },
    { 0x19516793, "stables" },
    { 0x862C06D1, "stables_attacker_stabbed_with_pitchfork" },
    { 0xC601E545, "stables_brutality_front_logic" },
    { 0xDF5F5360, "stables_brutality_front_vo" },
    { 0xFC5CBC51, "stables_brutality_logic" },
    { 0xCB14FD6D, "stables_connect_paths" },
    { 0x3A4C6562, "stables_door" },
    { 0x87612A0A, "stables_exit_anim" },
    { 0xBD94FCCC, "stables_exit_anim_setup" },
    { 0x38B11312, "stables_exit_cartel_ralley" },
    { 0x94F2BC8D, "stables_exit_delete_clip" },
    { 0xC90C2821, "stables_exit_open" },
    { 0xC50F8C03, "stables_pdf_logic" },
    { 0x37EA5BC6, "stables_rage_get_to_goal" },
    { 0x4AD1363D, "stables_roof_discovered" },
    { 0x348C7799, "stables_roof_trigger" },
    { 0x934C7A03, "stables_trapped_horses" },
    { 0x9B4F85E9, "stables_triggers_player_rage" },
    { 0x3AC20C39, "stables_weapons_cache_anims" },
    { 0x8951687B, "stables_woman_attacked_anims" },
    { 0xF99ED01D, "stables_woman_attacked_anims_old" },
    { 0xD5E86F73, "stabletime" },
    { 0x46831CCF, "stablize" },
    { 0xD8C41B06, "stablizeparam" },
    { 0x7147A5D3, "stablizescale" },
    { 0xA6BBA610, "stabs" },
    { 0xB85FB9BD, "stace" },
    { 0x9C6E9833, "stack" },
    { 0x16FDA4EF, "stack_up_and_delete" },
    { 0x6E2261E8, "stacked" },
    { 0x464127FD, "stacker_2_carry" },
    { 0x2BB04AAD, "stacking" },
    { 0xBA55D1E2, "stacks" },
    { 0x13D13F6C, "stackup" },
    { 0xB69817F8, "stackupinc" },
    { 0xEF93542E, "stadium" },
    { 0x6BED19A6, "staet" },
    { 0xD16491F1, "staff" },
    { 0x4CFC1418, "staff_air" },
    { 0x7F4D75D6, "staff_air_death_event" },
    { 0xAA83447E, "staff_air_find_source" },
    { 0x05BC03D0, "staff_air_fling_zombie" },
    { 0xC67D74CE, "staff_air_fullycrafted" },
    { 0xCE6BCAC4, "staff_air_gem" },
    { 0x4BEC2567, "staff_air_gib" },
    { 0x437C8F91, "staff_air_lower_staff" },
    { 0x187B2973, "staff_air_middle_staff" },
    { 0xA1828A0E, "staff_air_position_source" },
    { 0x70088CA5, "staff_air_proximity_kill" },
    { 0x2B121B3B, "staff_air_upgraded" },
    { 0x6A48AE22, "staff_air_upper_staff" },
    { 0x86F6D957, "staff_air_zombie_damage_response" },
    { 0xC2723CFF, "staff_air_zombie_range" },
    { 0x1EF3CEAF, "staff_air_zombie_source" },
    { 0xBF15AE49, "staff_biplane_drop_pieces" },
    { 0xC2305758, "staff_charge_watch" },
    { 0x69405A9C, "staff_charge_watch_wrapper" },
    { 0x74205B8F, "staff_charger_check" },
    { 0xFB40E753, "staff_charger_get_player_msg" },
    { 0x3CA028A8, "staff_craft_vo" },
    { 0x71CD2515, "staff_crafted" },
    { 0x70D555AD, "staff_crafted_vo" },
    { 0xB15D5EE0, "staff_crystal_wait_for_teleport" },
    { 0x1B32C30C, "staff_data" },
    { 0xEFD994B8, "staff_dmg" },
    { 0x381C0E5B, "staff_enum" },
    { 0xC26AEA98, "staff_equip" },
    { 0x86D6DFD0, "staff_fire" },
    { 0xE1C5D52E, "staff_fire_death_event" },
    { 0x6A4FBED6, "staff_fire_fullycrafted" },
    { 0xEA18101C, "staff_fire_gem" },
    { 0xDAD0D129, "staff_fire_lower_staff" },
    { 0xFF1E128B, "staff_fire_middle_staff" },
    { 0x9EB44C13, "staff_fire_upgraded" },
    { 0x2B72ECDA, "staff_fire_upper_staff" },
    { 0x7EFFCB1F, "staff_fire_zombie_damage_response" },
    { 0x1E34975D, "staff_fire_zombie_hit_response_internal" },
    { 0x407AD7F1, "staff_fullycrafted" },
    { 0xE425716C, "staff_get_insert_message" },
    { 0x59EE7527, "staff_get_pickup_message" },
    { 0x78A2093F, "staff_hint" },
    { 0x4A343F93, "staff_hit" },
    { 0xCA57C87A, "staff_ice_dig_pieces" },
    { 0xABCF76C0, "staff_info" },
    { 0x42CEC962, "staff_lightning" },
    { 0x7F3C3120, "staff_lightning_arc_fx" },
    { 0x2B2C877D, "staff_lightning_ball_damage_over_time" },
    { 0x675A2835, "staff_lightning_ball_kill_zombies" },
    { 0xAF064E3A, "staff_lightning_ball_speed" },
    { 0x7798D878, "staff_lightning_death_event" },
    { 0x5CBD1B5A, "staff_lightning_death_fx" },
    { 0x8FEB5840, "staff_lightning_fullycrafted" },
    { 0xA7744DEE, "staff_lightning_gem" },
    { 0x824C8A30, "staff_lightning_get_shot_range" },
    { 0x2128DDFB, "staff_lightning_get_valid_targets" },
    { 0x04D5535C, "staff_lightning_is_target_valid" },
    { 0x39693792, "staff_lightning_kill_zombie" },
    { 0x8A2C31B3, "staff_lightning_lower_staff" },
    { 0x01CA5615, "staff_lightning_middle_staff" },
    { 0xA8590978, "staff_lightning_position_source" },
    { 0x3967159D, "staff_lightning_upgraded" },
    { 0x1AF5CBD4, "staff_lightning_upper_staff" },
    { 0x953E408D, "staff_lightning_zombie_damage_response" },
    { 0x4E6893A1, "staff_mechz_drop_pieces" },
    { 0x2F5CE50B, "staff_model" },
    { 0x6B14EE9B, "staff_part_count" },
    { 0xEA0A2C74, "staff_picked_up" },
    { 0x01F8B4EE, "staff_pickup_vo" },
    { 0x065876BA, "staff_piece" },
    { 0x5FCB6C29, "staff_piece_capture_complete" },
    { 0xCAC472AA, "staff_piece_glow" },
    { 0xE94D3934, "staff_revive_impact" },
    { 0x0AD3F999, "staff_sound" },
    { 0x0BA3CC7F, "staff_unlock_with_zone_capture" },
    { 0x87F105A0, "staff_upgrade_watch" },
    { 0x78F716B4, "staff_upgraded" },
    { 0x0B806760, "staff_upgraded_reload" },
    { 0x9519C1B3, "staff_upgraded_reload_monitor" },
    { 0x50F83521, "staff_water" },
    { 0xB8850763, "staff_water_death_event" },
    { 0x11D70761, "staff_water_fullycrafted" },
    { 0x8BC6E0D9, "staff_water_gem" },
    { 0x4BACA731, "staff_water_kill_zombie" },
    { 0x4FD16468, "staff_water_lower_staff" },
    { 0xD5151E38, "staff_water_middle_staff" },
    { 0x6380F3F7, "staff_water_on_zombie_spawned" },
    { 0xAB71DF6F, "staff_water_position_source" },
    { 0xEFF42184, "staff_water_upgraded" },
    { 0x729020BB, "staff_water_upper_staff" },
    { 0x821042A0, "staff_water_zombie_range" },
    { 0xA6C22658, "staffcraftable_air" },
    { 0x2B5AC210, "staffcraftable_fire" },
    { 0xC2ADE9A2, "staffcraftable_lightning" },
    { 0xCAC3B361, "staffcraftable_water" },
    { 0x3E32B9DE, "staffdamage" },
    { 0x3F840E58, "staffs" },
    { 0x3A4C542D, "staffs_charged" },
    { 0x1281BD94, "stag" },
    { 0x8523E821, "stage" },
    { 0xCA7D9806, "stage1amount" },
    { 0x586D2BAE, "stage1burntags" },
    { 0x039DA44D, "stage2amount" },
    { 0xEE680291, "stage2burntags" },
    { 0xCD73B840, "stage2timerset" },
    { 0x9D5D850C, "stage3amount" },
    { 0x54641B20, "stage3burntags" },
    { 0x007C1A2B, "stage4burntags" },
    { 0x1BAC06C2, "stage5burntags" },
    { 0xD40FD4E5, "stage_1" },
    { 0x953BBA08, "stage_1_done" },
    { 0x2F3CED1F, "stage_completed" },
    { 0x978FF1D9, "stage_completed_internal" },
    { 0x7332E9D3, "stage_failed" },
    { 0xE9502C05, "stage_failed_internal" },
    { 0x61A04AEC, "stage_final" },
    { 0x0D771218, "stage_index" },
    { 0x07747C56, "stage_logic" },
    { 0x8765DF76, "stage_logic_1" },
    { 0x6163650D, "stage_logic_2" },
    { 0xC84AFBFB, "stage_logic_func_wrapper" },
    { 0x56131379, "stage_logic_maxis" },
    { 0x443A6AF3, "stage_logic_richtofen" },
    { 0x35927D25, "stage_name" },
    { 0x27CD5134, "stage_names" },
    { 0x605C24A4, "stage_num" },
    { 0xB78F7E07, "stage_number" },
    { 0x024116D0, "stage_one" },
    { 0x547FC490, "stage_quads" },
    { 0xD70454E7, "stage_quads_exit" },
    { 0xC09CB660, "stage_start" },
    { 0xB7D9E185, "stage_start_watcher" },
    { 0x187891F8, "stage_starting" },
    { 0x3FAB4871, "stage_text" },
    { 0x02242AD2, "stage_two" },
    { 0x8913F329, "stage_vo" },
    { 0x132E0C3F, "stage_vo_filled_max" },
    { 0xD066795B, "stage_vo_filled_ric" },
    { 0x52DD3F76, "stage_vo_max" },
    { 0xC558A5C7, "stage_vo_max_amp_broken" },
    { 0xC0E6BE7A, "stage_vo_nag" },
    { 0x12393742, "stage_vo_ric" },
    { 0x70FA65BF, "stage_vo_ric_amp_amplified" },
    { 0xE16FAC31, "stage_vo_watch_gallows" },
    { 0x86DA442A, "stage_vo_watch_guillotine" },
    { 0xB7167CA3, "stage_vo_watch_underground" },
    { 0xA3CDD46E, "stage_zone" },
    { 0xD25F5A79, "stagecapture" },
    { 0xBFD345FC, "stageconstants" },
    { 0xB0B0BAED, "stageduration" },
    { 0x44739E87, "stagehealth" },
    { 0x7E1E79FE, "stageidx" },
    { 0x1F5587E9, "stagelength" },
    { 0xBB1AB626, "stagematerial" },
    { 0xEAB3FC9D, "stageprefix" },
    { 0xCB6BE931, "stager" },
    { 0x50D4A72A, "stageratio" },
    { 0xA5696EC8, "stages" },
    { 0x66DC8DA6, "stagesprite" },
    { 0x959973AE, "stagger" },
    { 0x899FF995, "stagger_standing" },
    { 0x21663890, "staggeramt" },
    { 0xBE5DD8F1, "staggered" },
    { 0x8AB4F8E4, "staggered_banzai_charge" },
    { 0xE817ACD1, "staggers" },
    { 0xFFD6BBD4, "staging" },
    { 0x920085B5, "stagname" },
    { 0x84B63CDC, "stair" },
    { 0x41E4EE66, "stair_aim" },
    { 0x01E60BD7, "stair_anims" },
    { 0xF9281468, "stair_behaviour" },
    { 0x2069801F, "stair_combat" },
    { 0x6DF96498, "stair_count" },
    { 0xB2807894, "stair_enemy_for_log_scene_logic" },
    { 0x285E94E6, "stair_friendly" },
    { 0x0B8CA183, "stair_friendly_think" },
    { 0xFBD917EC, "stair_guy" },
    { 0x289B7C5D, "stair_guy1" },
    { 0x4E9DF6C6, "stair_guy2" },
    { 0x8D10A441, "stair_guys_setup" },
    { 0x37AA14B0, "stair_runaway_scene_guys_spawn" },
    { 0x08C61980, "stair_skip_3" },
    { 0x12D7725F, "stair_skip_4" },
    { 0xC6D27D8D, "stair_skip_6" },
    { 0xAAE15C03, "stair_skip_8" },
    { 0x444E8B21, "stair_vo_override" },
    { 0xFAA815FA, "stairblocker" },
    { 0xE1A64538, "staircase" },
    { 0x3F8B6DAE, "staircase_direction" },
    { 0x64475D1F, "staircase_dont_bunch_up" },
    { 0xDB0F8F5F, "staircase_down" },
    { 0x91E35D29, "staircase_down_exit_l_2_stairs" },
    { 0xA273350F, "staircase_down_exit_r_2_stairs" },
    { 0xB328452E, "staircase_end" },
    { 0x40B3F23D, "staircase_end_threshold_distsq" },
    { 0x89E35554, "staircase_enemy_think" },
    { 0x1EE1D59A, "staircase_exit_type" },
    { 0x954183AB, "staircase_floodspawn_func" },
    { 0xD411A8C1, "staircase_loop" },
    { 0xE53FBCDA, "staircase_molotov_thrower_think_internal" },
    { 0x951102FD, "staircase_num_steps" },
    { 0x3CD19DAA, "staircase_num_total_steps" },
    { 0x20DB2B5D, "staircase_start" },
    { 0x67CC0372, "staircase_state" },
    { 0xABE2D6F8, "staircase_step_skip_num" },
    { 0xD19B9E07, "staircase_type" },
    { 0x5401D7D0, "staircase_up" },
    { 0xCC257B25, "staircase_up_exit_l_3_stairs" },
    { 0x0EB1D730, "staircase_up_exit_l_4_stairs" },
    { 0xBE331453, "staircase_up_exit_r_3_stairs" },
    { 0x4EB7D722, "staircase_up_exit_r_4_stairs" },
    { 0xC783C95B, "staircase_wait_thread" },
    { 0xCE4C442F, "stairfall" },
    { 0x3C81E62D, "stairfloods_setup" },
    { 0x9910E41F, "stairs" },
    { 0x97ECDAD8, "stairs_blocker" },
    { 0x2DF64EC5, "stairs_blocker_buyable" },
    { 0x0A84CF21, "stairs_building_damage_listener" },
    { 0xD2B9252F, "stairs_complete" },
    { 0x11859F42, "stairs_down" },
    { 0x0CEBE51C, "stairs_init" },
    { 0xDEC2E4C1, "stairs_move" },
    { 0x2A6A2B2E, "stairs_node" },
    { 0xE307B04B, "stairs_pieces" },
    { 0xC84300E6, "stairs_proc" },
    { 0x854CFAE7, "stairs_runner_node" },
    { 0xE628520F, "stairs_shoot_stairs_building" },
    { 0x80CD9F4F, "stairs_spawn_manager" },
    { 0xA3A737C6, "stairs_think" },
    { 0x5419DA20, "stairs_trig" },
    { 0xE22956D9, "stairs_up" },
    { 0xC9E22B0E, "stairs_util" },
    { 0xB68E6B99, "stairway" },
    { 0xA9A2E650, "stairways" },
    { 0x9BC4B224, "stairwell" },
    { 0x2EF6B9D5, "stake" },
    { 0x6B2CD8C8, "stale" },
    { 0x55FE3617, "stalemate" },
    { 0x20D2E2B3, "stalemate_wait_player" },
    { 0x47966072, "stalin" },
    { 0x82BAB1A2, "stalingrad" },
    { 0x607C696F, "stalingradspawn" },
    { 0xB3FC2278, "stalingradspawnsafe" },
    { 0xF2DFB22B, "stalingradspawnsafe_guys" },
    { 0x62A955F7, "stalk_vox_done" },
    { 0x7E78446A, "stalking" },
    { 0x611B7FE9, "stall" },
    { 0x68572900, "stall_node" },
    { 0xF95AD31C, "stall_node_1" },
    { 0xB0007316, "stalled" },
    { 0x38E7D81F, "stalling" },
    { 0x770E1802, "stallstring" },
    { 0x1E46ACBE, "stalltriggers" },
    { 0xFE274179, "stalltriggerthink" },
    { 0x5EF82DFF, "stamin" },
    { 0xED428240, "staminup" },
    { 0xFD558C7B, "staminup_callback_func" },
    { 0x9CB5EE48, "staminup_client_field_func" },
    { 0x588FBD51, "staminup_machine_active_model" },
    { 0xF0369EEB, "staminup_machine_disabled_model" },
    { 0x7DCB5CCF, "staminup_machine_fx_file_machine_light" },
    { 0x3BF3A200, "staminup_machine_light_fx" },
    { 0x44D85781, "staminup_perk_bottle_weapon" },
    { 0x2B27ED4D, "staminup_perk_cost" },
    { 0x86229DAF, "staminup_perk_machine_setup" },
    { 0x867A6F34, "staminup_precache" },
    { 0x5A8D1A8C, "staminup_precache_override_func" },
    { 0x4694710C, "staminup_radiant_machine_name" },
    { 0x055E325E, "staminup_register_clientfield" },
    { 0x80D0080F, "staminup_set_clientfield" },
    { 0xDE0022E0, "staminup_shader" },
    { 0x0AC97D3A, "stamp" },
    { 0xD25AA66C, "stampinup" },
    { 0x6502DBF1, "stance" },
    { 0x6E561B6A, "stance1" },
    { 0x4853A101, "stance2" },
    { 0x22512698, "stance3" },
    { 0x01838A82, "stance_any" },
    { 0x251D8D7A, "stance_button_held" },
    { 0x382CEB71, "stance_carry" },
    { 0x7DDD7E9A, "stance_carry_icon_disable" },
    { 0x9EE157CF, "stance_carry_icon_enable" },
    { 0x1D343824, "stance_change" },
    { 0xA7400800, "stance_change_time" },
    { 0x4C3D3AE6, "stance_crouch" },
    { 0xA3AD98EC, "stance_disabled" },
    { 0x63737620, "stance_handler" },
    { 0x6446F5B4, "stance_num" },
    { 0xA14F95CE, "stance_prone" },
    { 0xB4DCF568, "stance_prone_on_back" },
    { 0x3636F1E2, "stance_prone_on_front" },
    { 0xAE562EF4, "stance_stand" },
    { 0xCC453158, "stance_swim" },
    { 0xA1305E1C, "stance_type" },
    { 0x6FC43BF3, "stance_up" },
    { 0x3BD781A4, "stance_z_offset" },
    { 0xED1DCFA1, "stancebuttonpressed" },
    { 0xF9C10862, "stancechangeanim" },
    { 0x9134D643, "stancechangewatcher" },
    { 0x6018B744, "stancelockduration" },
    { 0xA1B28C58, "stances" },
    { 0x33CC52EA, "stancestring" },
    { 0xBC1F1035, "stancesupported" },
    { 0x132814A4, "stancing" },
    { 0x940086DB, "stand" },
    { 0xA228B067, "stand_and_smoke" },
    { 0x872FE611, "stand_from_dec20" },
    { 0x8AFFC64D, "stand_hint" },
    { 0xC017632C, "stand_idle" },
    { 0xB5CF29B6, "stand_idle_default" },
    { 0x6FB0E7E7, "stand_if_enemy_nearby_distsq" },
    { 0xF2BA7AFD, "stand_off" },
    { 0x45CF972B, "stand_off_bullets" },
    { 0xB3868D13, "stand_off_damage" },
    { 0x7CAC5F2F, "stand_offset" },
    { 0xC1158D0C, "stand_shoot_straight" },
    { 0x4C7CF3EA, "stand_think" },
    { 0x55097E76, "stand_trigger" },
    { 0x8CDA0B69, "stand_triggers" },
    { 0xCDC0C7BD, "stand_up" },
    { 0x16DE83E6, "stand_up_shrink_viewclamp" },
    { 0x295138BD, "stand_walk_combat_loop" },
    { 0x8A7D7DB0, "standalone" },
    { 0xAA5D989A, "standard" },
    { 0x791A5CF2, "standard_leadin" },
    { 0xA732921A, "standard_mp" },
    { 0xCA30B378, "standard_patrol_radius" },
    { 0x0EE2985E, "standard_powered_items" },
    { 0x865ECC76, "standard_size" },
    { 0xC8CC65D3, "standard_start" },
    { 0x77ACCED6, "standarding" },
    { 0x08C39F38, "standardize" },
    { 0x5B0FA76C, "standardized" },
    { 0x057C6695, "standards" },
    { 0xEC5B70F3, "standattack" },
    { 0xC30A9D18, "standby" },
    { 0xFCD11F4C, "standcivilian" },
    { 0x6F0ED42B, "standdown" },
    { 0x83959F36, "stander" },
    { 0x0A9596E6, "standguard" },
    { 0x60288EA4, "standhint" },
    { 0x56DA5FE7, "standhint_kill" },
    { 0x0032D17D, "standidle" },
    { 0x59F0BF2D, "standidlethread" },
    { 0xB98533C2, "standidlethreadinternal" },
    { 0x23AD5AC9, "standifmakesenemyvisible" },
    { 0x386C00EE, "standin" },
    { 0x72FACD45, "standing" },
    { 0x56C8B15F, "standing_array" },
    { 0xF80805C5, "standing_count" },
    { 0xF7DC0971, "standing_drones" },
    { 0x90C31389, "standing_drones_spawn" },
    { 0x257B0042, "standing_fast" },
    { 0xAEAD80E2, "standing_in_lava" },
    { 0x1DF61ED4, "standing_location_index" },
    { 0x037CCAD7, "standing_slow" },
    { 0xFC8C7863, "standingviewheight" },
    { 0x7AC93D11, "standins" },
    { 0x2288E1DA, "standoff" },
    { 0x9A88C0F9, "standoff_ai_setup" },
    { 0xD520CFFC, "standoff_ai_setup_done" },
    { 0x90557A70, "standoff_aim_chinese" },
    { 0x419BB1C8, "standoff_aim_seal" },
    { 0xDF0187A2, "standoff_dof_closeup" },
    { 0xD9AFE4DE, "standoff_dof_end" },
    { 0x57C7DC4D, "standoff_dof_start" },
    { 0x82ADF7BF, "standoff_dof_stop" },
    { 0xB9915886, "standoff_main" },
    { 0xC5DB7C60, "standoff_savepoint" },
    { 0x3A7C2279, "standoff_seals" },
    { 0xC2E9AD2C, "standoff_settle" },
    { 0x123D9B5F, "standoff_zhao_turn" },
    { 0xDEA19555, "standoff_zhao_walk" },
    { 0x59F6A6AE, "standrangesq" },
    { 0x11F7D7C3, "standruntocrouch" },
    { 0x53A59B9F, "standruntostand" },
    { 0xDE9D05FA, "stands" },
    { 0x87E3C9EC, "standspeed" },
    { 0x5F737E3A, "standtocrouch" },
    { 0x7BB02765, "standtocrouchanim" },
    { 0x18F58C12, "standtoprone" },
    { 0x217E4FCD, "standtopronerun" },
    { 0x795834BD, "standtopronewalk" },
    { 0x8A135D14, "standup" },
    { 0xEC881209, "standwalktocrouch" },
    { 0xF1D53891, "standwalktostand" },
    { 0xC054D395, "staples" },
    { 0x4052A7C9, "star" },
    { 0x256727C8, "star_on_sarge" },
    { 0x8635D56B, "star_on_streetguys" },
    { 0x1F3EDE54, "star_ping" },
    { 0xA0CD7C64, "star_street_guys" },
    { 0x675D484B, "starboard" },
    { 0xFB9E8232, "starboard_light" },
    { 0xFA698CCE, "starboard_side_guys" },
    { 0x6180515D, "starburst_debug" },
    { 0x3D74DDC6, "stare" },
    { 0xD2BB8CA5, "stare_grace_period" },
    { 0xE3094D16, "stare_threshold" },
    { 0x92941644, "staretotal" },
    { 0x41FEAFEC, "stargate" },
    { 0x691AA432, "stargate_play_fx" },
    { 0x2E709A83, "stargate_teleport_disable" },
    { 0xB67726D8, "stargate_teleport_enable" },
    { 0x67BFEC1A, "stargate_teleport_player" },
    { 0x5F30F5FB, "stargate_teleport_think" },
    { 0x41B8E69A, "stargetname" },
    { 0x5EAEA632, "starggering" },
    { 0xFCD6F57F, "staring" },
    { 0xD686331E, "stariwell" },
    { 0x8979D298, "stark" },
    { 0xF93E58C0, "stars" },
    { 0x034FB19F, "start" },
    { 0x6D76E1DB, "start fx" },
    { 0xCFE91694, "start1" },
    { 0x41F085CF, "start2" },
    { 0x29BF9105, "start3dcinematic" },
    { 0x730A0DAA, "start_" },
    { 0x0B87555B, "start_2nd_set_of_extra_horses" },
    { 0xF5B2BB54, "start_3d_audio" },
    { 0x08BBEA13, "start_aa_gun" },
    { 0x99E98442, "start_aa_guns" },
    { 0x4F1BBF05, "start_aaguns" },
    { 0x584158C6, "start_ac130" },
    { 0x6084A8CA, "start_ac130_shooting" },
    { 0x571DC197, "start_admin" },
    { 0x6CF955A6, "start_aftermath" },
    { 0xEFE81847, "start_aggressive_ai" },
    { 0x3AA71B51, "start_ahead" },
    { 0x05FC0D9B, "start_ai_exit" },
    { 0x439FF9A7, "start_ai_lvt" },
    { 0x6367981B, "start_ai_rappel" },
    { 0xE3824A8B, "start_ai_waves" },
    { 0x6D0A0AD9, "start_aim" },
    { 0x2819767A, "start_airfield" },
    { 0xE94FCD6E, "start_alasad_barn" },
    { 0x8AD3065B, "start_alasad_house" },
    { 0xBFF4CC8A, "start_alcatraz_sidequest" },
    { 0x0E9898A2, "start_all_yours" },
    { 0x7DFA8579, "start_alley" },
    { 0xB0C834C8, "start_allies" },
    { 0x43E7954E, "start_allies_in_stealth" },
    { 0xDAB3F642, "start_alpha" },
    { 0xB84F6E1E, "start_amb_marchers" },
    { 0x1E7FDB86, "start_ambient" },
    { 0xFE1C5133, "start_ambient_ai" },
    { 0x4F90AE08, "start_ambient_baseloop" },
    { 0xB4F0502A, "start_ambient_drones_rooftop" },
    { 0x32DC35BF, "start_ambient_event" },
    { 0xA5C6FF7C, "start_ambient_ground_vehicles" },
    { 0x329E7F01, "start_ambient_mortars" },
    { 0xF272BC46, "start_ambush" },
    { 0x3939B28C, "start_ambush_approach_node" },
    { 0x1855A2A8, "start_ammo" },
    { 0x4DC49686, "start_anderson_f35_exit" },
    { 0x8E4AFE1E, "start_ang" },
    { 0xE9AFD3AF, "start_angle" },
    { 0x13B728F6, "start_angles" },
    { 0x5BDFBF95, "start_anim" },
    { 0x0BD90C88, "start_anim_then_end_it_at_meatshield" },
    { 0x81C5C81A, "start_animating" },
    { 0x245ACEE4, "start_anims" },
    { 0x0DBAEC84, "start_apart" },
    { 0xE97A9D30, "start_apartment" },
    { 0x98CA0242, "start_ape" },
    { 0xFDD25B82, "start_approach" },
    { 0xB713B262, "start_arch" },
    { 0xFAC43110, "start_area01" },
    { 0x6CCBA04B, "start_area02" },
    { 0xA3A36AE7, "start_artillery_launch_ee" },
    { 0x518079DC, "start_artillery_launch_normal" },
    { 0x9915047B, "start_assasination" },
    { 0x05BBA06B, "start_asylum" },
    { 0xA8ED4C21, "start_at_outro" },
    { 0xF10D86C0, "start_atrium_walkers" },
    { 0x620731B8, "start_attack_run" },
    { 0xAE53F899, "start_audio_allowed" },
    { 0xC223CB95, "start_backbreaker" },
    { 0x3A16E7C9, "start_backup_trigger" },
    { 0x6AC4DEA7, "start_banzai_announce" },
    { 0x91577DBE, "start_banzai_attack" },
    { 0xDC3B2218, "start_banzai_yell" },
    { 0xB93348F5, "start_bar" },
    { 0xD0C68B59, "start_barge_sink" },
    { 0x138A2DEF, "start_barge_sinking" },
    { 0x0C718161, "start_barn" },
    { 0x0EB37B95, "start_barnes_sampan_swim" },
    { 0x3A79D108, "start_base_sounds" },
    { 0x79151F49, "start_basejump_fov" },
    { 0xE6F6BC75, "start_basement" },
    { 0x612B3BF5, "start_battle_trig" },
    { 0x5052A19D, "start_be_1" },
    { 0x76551C06, "start_be_2" },
    { 0xE09A6CBF, "start_beach" },
    { 0x3AA73FE1, "start_beam_time" },
    { 0x6FEC293C, "start_berserk" },
    { 0xBE119359, "start_bike" },
    { 0xD00C71B0, "start_bink" },
    { 0x8664A81B, "start_binks" },
    { 0xBF42109D, "start_binoc_anim" },
    { 0x4C3C223F, "start_binocular_anim" },
    { 0x38FF5E2C, "start_black_room_fx" },
    { 0xEFC14EC9, "start_blackout" },
    { 0x0E52057C, "start_blink" },
    { 0x707A8A07, "start_blow_up_horses" },
    { 0x07E0498F, "start_blur_player" },
    { 0x67C28F65, "start_boat_drag" },
    { 0x3774EE41, "start_boat_drive" },
    { 0xB94A8612, "start_boat_drive_background_drones" },
    { 0x24F5AB80, "start_boat_drop" },
    { 0xB5BC66C0, "start_boat_landing" },
    { 0x9CD47C26, "start_bog" },
    { 0xB599D7BB, "start_bog_backhalf" },
    { 0x0F0ADC1A, "start_bombing" },
    { 0x376F67FB, "start_bonfire_sale" },
    { 0x998C817D, "start_boss" },
    { 0xB569A70A, "start_boss_boat" },
    { 0x5F6FEB1C, "start_bottle_cycling" },
    { 0x1E8EB0E2, "start_bow_railclimb_drones" },
    { 0x2CF6FFEE, "start_bowman_anim" },
    { 0x00C1B3FE, "start_bp2" },
    { 0xEDFF4829, "start_bp2_mortars" },
    { 0x26C42E67, "start_bp3" },
    { 0x1829CB3D, "start_breach" },
    { 0x0DC9B0BC, "start_bridge_fxanims" },
    { 0x2415DA37, "start_build_counter" },
    { 0x04175A86, "start_bulging" },
    { 0xE0559250, "start_bunkers" },
    { 0x5B8B0E13, "start_burning" },
    { 0xC60E14FB, "start_burnt" },
    { 0x46508330, "start_bus" },
    { 0x24D75901, "start_button_combo" },
    { 0xAAAAD374, "start_by_mortar_pits" },
    { 0x56ECD745, "start_by_planters" },
    { 0x9144FEE3, "start_callback" },
    { 0x415C4BF7, "start_camera_path" },
    { 0x66DA9EE8, "start_captured" },
    { 0x767E196A, "start_cargo" },
    { 0x30475BF2, "start_carpenter" },
    { 0x8CF31031, "start_carpenter_new" },
    { 0xB69B5050, "start_castle_explode" },
    { 0x3683EB6E, "start_catwalk_allies" },
    { 0x536F2239, "start_center" },
    { 0x3CDCB195, "start_ch46" },
    { 0x798C58E1, "start_chain" },
    { 0x79DEEE7A, "start_chant" },
    { 0x7237644D, "start_charging_horse" },
    { 0xE5BB3570, "start_chase" },
    { 0x6AA99524, "start_chasing_tank" },
    { 0x91310072, "start_chess" },
    { 0x03386FAD, "start_chest" },
    { 0x6291A6AC, "start_chest_found" },
    { 0x2502A619, "start_chest_name" },
    { 0x52C11C77, "start_church" },
    { 0xE0BBCA1E, "start_church_x" },
    { 0x7FADEEFC, "start_civilians" },
    { 0x1CD9A89E, "start_civs_club" },
    { 0xCD94E974, "start_civs_lounge" },
    { 0x0AF0388D, "start_civs_outer_solar" },
    { 0xAFEAE1E2, "start_clackers" },
    { 0xFF8EAD4F, "start_clark_animation_flag" },
    { 0x8BF6EABF, "start_clark_home_explode" },
    { 0x5464467C, "start_clark_house_explosion" },
    { 0xA4AADC17, "start_classic_game_mode" },
    { 0x72CAD97C, "start_cliff" },
    { 0xAD653580, "start_clock" },
    { 0x5F24CFE7, "start_clocktower_vo" },
    { 0xD1EE5E2C, "start_club_encounter" },
    { 0x27BD966D, "start_cobra" },
    { 0x57114305, "start_cobra_path" },
    { 0xFB7ED77F, "start_cobraflight" },
    { 0xE956D06C, "start_cobras" },
    { 0x7B25E48F, "start_cobras_pos" },
    { 0x3C2E7C4B, "start_cobrastreets" },
    { 0x07229C03, "start_color" },
    { 0x611C9261, "start_combat_vo_group_enemy" },
    { 0x4BD9E60A, "start_combat_vo_group_friendly" },
    { 0x26FD3B7C, "start_combined_score" },
    { 0x79CD7E9D, "start_common" },
    { 0x20E31FB9, "start_compound" },
    { 0x2362ADE7, "start_container" },
    { 0x76D7FE9B, "start_context" },
    { 0x27C37EB4, "start_continues" },
    { 0x2695E004, "start_control_room_fxanims" },
    { 0x998E45BC, "start_controlroom" },
    { 0x436681E6, "start_convoy_vehicle_flash" },
    { 0x5EDD7815, "start_countdown_timer" },
    { 0x4732DB99, "start_course" },
    { 0x19595653, "start_court" },
    { 0xFD18F257, "start_courtyard" },
    { 0x6118F4C0, "start_courtyard_ambient_drones" },
    { 0x44A6BDD4, "start_courtyard_battle" },
    { 0x812C30C6, "start_courtyard_event" },
    { 0xF27C6A60, "start_cowbell" },
    { 0xD49E3A9B, "start_crafting_shared_piece" },
    { 0xE061B6DB, "start_crash" },
    { 0x89A208E7, "start_crate" },
    { 0x00AD0BA3, "start_crate_lowered_fog" },
    { 0xA3BD9E6A, "start_creek" },
    { 0x99BB4355, "start_creek_raining" },
    { 0x5419DD74, "start_critter_anims" },
    { 0xCCD4C484, "start_crowd_flee" },
    { 0x93AAF9E3, "start_crumb" },
    { 0x2A576EC1, "start_crying_woman" },
    { 0x6182A7B6, "start_damage_effects" },
    { 0xFDBE515A, "start_damage_state_index" },
    { 0x260DDB02, "start_dash" },
    { 0x0D0902CE, "start_date" },
    { 0x43AF9914, "start_day" },
    { 0xCC83BC34, "start_death" },
    { 0x83E1E325, "start_death_from_above_ragdoll" },
    { 0x47A81FFC, "start_death_sequence" },
    { 0x5A3EFC9B, "start_debug" },
    { 0x3DC0A424, "start_debug_stairs" },
    { 0x22EBAB21, "start_decrease_extra_cam_fov" },
    { 0x3DE51E70, "start_defalco_helipad" },
    { 0x3B8EF369, "start_default" },
    { 0x95E1AA6D, "start_defcon_countdown" },
    { 0x2ED52AFE, "start_defend" },
    { 0x9BE02EB7, "start_defend_armory" },
    { 0x86C1F1AB, "start_defend_convoy" },
    { 0xD7B0A3F3, "start_delay" },
    { 0x48D726F3, "start_delete_garbage" },
    { 0x32C031A3, "start_demo" },
    { 0x40D21D64, "start_dept_store_search" },
    { 0x049A906F, "start_deserted_first_fade_out" },
    { 0xB031A18B, "start_detection" },
    { 0x1B0110A4, "start_dialog_splitup" },
    { 0x6E5464BD, "start_dialog_splitup_trig" },
    { 0xD14ACB13, "start_difficulty_report_index" },
    { 0x3F61F568, "start_digbag_tackle_dialog" },
    { 0xFF3DD64E, "start_diorama_fx_3" },
    { 0xE11A13A5, "start_diorama_smoke" },
    { 0x583515D9, "start_dirt_path" },
    { 0x82267CF6, "start_dist" },
    { 0x2DB0B20D, "start_dist_explo_pa" },
    { 0x972BBA5A, "start_distance_planes_field_1" },
    { 0x60DCA6A1, "start_distance_planes_field_1_stop" },
    { 0xFCAA5E47, "start_dock_pa" },
    { 0x4B06FF97, "start_dogfight_event" },
    { 0x56DB8237, "start_dogs" },
    { 0xB429A3AF, "start_door_kick" },
    { 0xC132024F, "start_dot" },
    { 0x6A28D1F7, "start_drag_player_to_eject_tube" },
    { 0xD642CC32, "start_dragovich_speach" },
    { 0x8DCE288C, "start_drain" },
    { 0x19BADAA6, "start_drive" },
    { 0x8D41C5DA, "start_drive_by_after_mason" },
    { 0x9C534ED9, "start_drone_control_canopies" },
    { 0x2A0B5414, "start_drone_spawning_area" },
    { 0x910DC9FF, "start_drone_waves" },
    { 0x354544CD, "start_dump_index" },
    { 0x0C10CF87, "start_dumpster_push" },
    { 0x95CF5D2C, "start_duration_comp" },
    { 0xFDF41482, "start_dust" },
    { 0x2F5B059F, "start_dynamic_run_speed" },
    { 0xD988B5D4, "start_dynamicpath" },
    { 0xDF229067, "start_dynent_cleanup" },
    { 0x8A328904, "start_eat" },
    { 0x2307EABC, "start_elevator" },
    { 0xA90F2ED3, "start_elevator_kill_pa" },
    { 0xCD6919A4, "start_elevator_slide_pa" },
    { 0x5BED4056, "start_encounters_round_logic" },
    { 0xE92C4371, "start_end" },
    { 0xFAE5C2D7, "start_ending" },
    { 0xB02206AE, "start_ending_claws" },
    { 0x3DC09E3C, "start_ending_dialogue" },
    { 0x7B28483B, "start_ending_drones" },
    { 0xFFBEA897, "start_enemy_trig" },
    { 0x4953EA01, "start_ent" },
    { 0x89C089D5, "start_enter_armory" },
    { 0xB02F3686, "start_env_movie" },
    { 0x283D2541, "start_environmental_sounds" },
    { 0xFB626E93, "start_escape" },
    { 0xDA454CA9, "start_evaporate" },
    { 0x35B667C3, "start_event1" },
    { 0x80525F8B, "start_event1_music" },
    { 0xC3AEF888, "start_event2" },
    { 0x2026E5CA, "start_event2b" },
    { 0x46296033, "start_event2c" },
    { 0x6C2BDA9C, "start_event2d" },
    { 0x922E5505, "start_event2e" },
    { 0xE9B172F1, "start_event3" },
    { 0x8AB2C941, "start_event3_outro" },
    { 0xA7BDD6FE, "start_event4" },
    { 0xCDC05167, "start_event5" },
    { 0x686857EC, "start_event_3" },
    { 0x8EF763B8, "start_exclude" },
    { 0x7FCCB68C, "start_execution" },
    { 0x24DA8182, "start_exit" },
    { 0xB06CAA4F, "start_exploder_number" },
    { 0x2F50088E, "start_explosion_test" },
    { 0xE955FF9B, "start_explosive_ragdoll" },
    { 0x88E8ABC8, "start_extra_cam" },
    { 0xBCCED07B, "start_f35_snap" },
    { 0xB6F690EC, "start_factory_assault" },
    { 0xB718EBE8, "start_fade" },
    { 0x9A9D029A, "start_fade_in" },
    { 0x2674E7ED, "start_fade_out" },
    { 0xBEB866D4, "start_fadeout" },
    { 0x974199C4, "start_fair" },
    { 0xA40BA8D1, "start_fair_battle" },
    { 0xDAF419EE, "start_fake_mortars" },
    { 0x96983981, "start_fall" },
    { 0x8B3D66B1, "start_fardist" },
    { 0xCFE41DB6, "start_farm" },
    { 0x7FBD4E86, "start_farmhouse" },
    { 0x59AC6E6E, "start_fbattle_music" },
    { 0x6AD32D0E, "start_field" },
    { 0x079F36C7, "start_field_fallback" },
    { 0x71916EA9, "start_fight_uphill" },
    { 0x66805427, "start_final_battle" },
    { 0x09B660C7, "start_finale" },
    { 0x6E885095, "start_fire_node" },
    { 0xCE24D724, "start_fire_sale" },
    { 0x7E0CBD26, "start_fire_work" },
    { 0x5308CE8F, "start_firing" },
    { 0x2EA68891, "start_firing_notify" },
    { 0xC041540E, "start_first_engagement" },
    { 0x4B933A57, "start_first_fight" },
    { 0xD5848184, "start_first_hind" },
    { 0xA7F53435, "start_first_interstitial" },
    { 0xDF741007, "start_first_sampan_encounter" },
    { 0x4A891A20, "start_flag" },
    { 0x07154ECB, "start_flags" },
    { 0xB9BD9973, "start_flame" },
    { 0x2B3C82DF, "start_flame_truck" },
    { 0x7D4EA7BD, "start_flamer_setup" },
    { 0x3ED455D5, "start_flashback" },
    { 0x010E9E54, "start_flashback_movie" },
    { 0x03AE8114, "start_flashing" },
    { 0x9A80EDEA, "start_flicker" },
    { 0x4D7E466D, "start_flight_cleanup" },
    { 0x7D2F0ED2, "start_flinger_in_open_position" },
    { 0x9C05ED66, "start_flood" },
    { 0x5302F5C1, "start_follow" },
    { 0xAE0E6AB0, "start_footprint_warning_vo" },
    { 0x6A8A8545, "start_forest" },
    { 0x27BB5E5B, "start_fov" },
    { 0xDB2D802D, "start_frame" },
    { 0xD0590317, "start_freefall" },
    { 0xE3A0F861, "start_friendly_huey_a" },
    { 0x09A372CA, "start_friendly_huey_b" },
    { 0x2FA5ED33, "start_friendly_huey_c" },
    { 0x55A8679C, "start_friendly_huey_d" },
    { 0x86189073, "start_fullscreen_fade_out" },
    { 0xF0655F19, "start_fullscreen_glasses_bink" },
    { 0x6FA56358, "start_func" },
    { 0x2B3B2C33, "start_funcs" },
    { 0x673275D9, "start_functions" },
    { 0x366F4FFC, "start_furniture" },
    { 0x8B43381A, "start_game_modules" },
    { 0xD1413784, "start_gametype" },
    { 0xCAE7443F, "start_gas_door_blocker" },
    { 0xAB278AA0, "start_gas_player_mantle_trig" },
    { 0x89883266, "start_gas_trig" },
    { 0x395AB153, "start_gate" },
    { 0x4F0E4E72, "start_generator_capture" },
    { 0x3C84E77B, "start_generator_movement" },
    { 0x6CB85F78, "start_getaway_zeros" },
    { 0x1FE34192, "start_ghost_round" },
    { 0xEA51E45F, "start_glasses_bink" },
    { 0xD167C547, "start_godrays" },
    { 0x8214766E, "start_gr_eject_fall_to_earth" },
    { 0xE36A42A5, "start_graveyard" },
    { 0x51AA2D50, "start_graveyard_x" },
    { 0xD163161D, "start_greenhouse" },
    { 0x5C7E70FB, "start_greenhouse_helicopter" },
    { 0x8BE5E5CD, "start_ground_events" },
    { 0xC4FA6B12, "start_ground_sounds" },
    { 0x5F1AD233, "start_group" },
    { 0x95585704, "start_guards" },
    { 0x0C4B9512, "start_gunshop_candy" },
    { 0x7AB0AFE6, "start_gunshop_run" },
    { 0xF7FDC7DA, "start_guys" },
    { 0xFB8C1006, "start_guys_player" },
    { 0xAEED8D8F, "start_guys_think" },
    { 0xE017F690, "start_guys_think_ally_group" },
    { 0x90DBDC51, "start_guys_think_player_group" },
    { 0x2D40E04B, "start_hacking" },
    { 0x836A4A1B, "start_hacking_object" },
    { 0x6CC5F561, "start_hallway_actors" },
    { 0xA7866F95, "start_hallway_guards" },
    { 0xE0002D6F, "start_hands_flightstick" },
    { 0x68CEF0AF, "start_harper_animation" },
    { 0x1F3D16EA, "start_harper_ending" },
    { 0x63EFE091, "start_head_think" },
    { 0xF2F9C1CE, "start_headbang" },
    { 0xDC2B3EC4, "start_health" },
    { 0x902DAAB6, "start_hearbeat" },
    { 0x3024C5C6, "start_heartbeat" },
    { 0x5393252D, "start_heavy_resistance" },
    { 0xF2FECE9B, "start_height_offset" },
    { 0xFD83CB5D, "start_heli_exploding" },
    { 0x39572EE5, "start_heli_fire" },
    { 0xD271AD40, "start_heli_friendly_sequence" },
    { 0x3F5D9DC7, "start_heli_snipe_trig" },
    { 0x3570EC43, "start_heli_snipe_trying_to_run_trig" },
    { 0x06403BD1, "start_heli_sounds" },
    { 0xD84575CB, "start_helicopter_bridge" },
    { 0x49FDD4BE, "start_helicopter_killzone" },
    { 0x88849460, "start_helicopter_sounds" },
    { 0xECF212C8, "start_helicopters" },
    { 0xA87D32B1, "start_helidrop" },
    { 0xDF041389, "start_helo_event" },
    { 0x7223905E, "start_hey_charlie_node" },
    { 0x57080EA9, "start_hide_players" },
    { 0x0475A855, "start_highrise_sidequest" },
    { 0xA5CB8D92, "start_hijack" },
    { 0xDBAA99F9, "start_hilltop_melee" },
    { 0xD2A79601, "start_hind" },
    { 0xF0BACC52, "start_hip_dropoff" },
    { 0xD61C3D24, "start_horse_charge_vehicles" },
    { 0x0F54E584, "start_horse_event" },
    { 0x1DA194BE, "start_horse_patrollers" },
    { 0x23CF3196, "start_hud_outline" },
    { 0xE812A88F, "start_hudson_bloom" },
    { 0x98C06160, "start_hudson_mg_vo" },
    { 0x687F43B8, "start_huey_sam_attack_sequence" },
    { 0x77D4425F, "start_i" },
    { 0x7D86EE4E, "start_igc_audio" },
    { 0xB5AEAE83, "start_in_courtyard" },
    { 0x81AB2919, "start_in_hud_elem" },
    { 0xF2B15443, "start_inclinator" },
    { 0x51228191, "start_increase_extra_cam_fov" },
    { 0xABF8AB96, "start_index" },
    { 0x8253E52E, "start_inert" },
    { 0x22E0F1AF, "start_int_screens" },
    { 0x02909B19, "start_interogation" },
    { 0xACA3FC1C, "start_interrogation_animation" },
    { 0xD9D06C1D, "start_interrogation_questions" },
    { 0xBA61EE78, "start_intro" },
    { 0xDEF0268D, "start_intro1_drones" },
    { 0xE2F7CFCC, "start_intro2_drones" },
    { 0x0E028E97, "start_intro3_drones" },
    { 0x75F66286, "start_intro4_drones" },
    { 0x4F1D7251, "start_intro5_drones" },
    { 0x83794160, "start_intro_anim" },
    { 0xEA604D0B, "start_intro_anims" },
    { 0xC72712CC, "start_intro_music" },
    { 0x5BEC288F, "start_intro_planes_0" },
    { 0x3FCC518E, "start_intro_planes_21" },
    { 0x8BFFFBD7, "start_intro_planes_8" },
    { 0x65FD816E, "start_intro_planes_9" },
    { 0x17F43420, "start_intro_reveal" },
    { 0x64E2EB95, "start_intro_screen_zm" },
    { 0x4832E40F, "start_intro_sounds" },
    { 0x7738F81B, "start_intro_steiner" },
    { 0x25851AF0, "start_investigate_plane" },
    { 0xE2E2CF50, "start_item_hunt_with_timeout" },
    { 0x998809A7, "start_jail_close" },
    { 0x1DF59D07, "start_jail_cower" },
    { 0xEFF9FB6F, "start_jail_idle" },
    { 0xC9EB7271, "start_jail_open" },
    { 0x2ED3BA20, "start_jail_run" },
    { 0xBAE86AFA, "start_jail_wait" },
    { 0xBB05F04F, "start_javelin" },
    { 0xD29DB1EA, "start_jeep" },
    { 0x2B7B69B2, "start_jeep_hack" },
    { 0x53E85960, "start_jeep_vo" },
    { 0xC2288CFD, "start_jetwing_land_exhaust" },
    { 0x899CF870, "start_jfk_bulging" },
    { 0xE7F1562E, "start_jog" },
    { 0x63943B0C, "start_junkyard" },
    { 0x5DF40054, "start_karma_vitals_cam" },
    { 0xCA85178F, "start_key" },
    { 0x23A00CFD, "start_kill_watch_z_threshold" },
    { 0xA497E565, "start_knife_attack_trigger" },
    { 0x392D7031, "start_knife_scene_trigger" },
    { 0x518CBEA0, "start_knife_throw" },
    { 0x14DF6F1E, "start_lab_defend" },
    { 0x9DCEA668, "start_land_visionset" },
    { 0x7C145C4B, "start_landing" },
    { 0xB6877934, "start_landing_fx" },
    { 0x0842A10B, "start_launch" },
    { 0x50389708, "start_launchtubes" },
    { 0x597D3D9D, "start_left_balcony_damage_trigger" },
    { 0xADBEE024, "start_level" },
    { 0xF6401D34, "start_level_save" },
    { 0xB8F73B92, "start_level_start_pos" },
    { 0x5006408A, "start_lift_move_down" },
    { 0xD2E7A133, "start_light_fx" },
    { 0x17DE9F6C, "start_lightning" },
    { 0xF0A93E1C, "start_lightning_combat_roof" },
    { 0xFC6221DA, "start_lightning_indoor" },
    { 0x7C0C5229, "start_lightning_roof" },
    { 0x8940E409, "start_lights" },
    { 0x707E923F, "start_limo_ending" },
    { 0x34D01772, "start_limo_movie" },
    { 0xC9AC4FCE, "start_list" },
    { 0x42267048, "start_loc" },
    { 0x101A48A8, "start_loc_string" },
    { 0x5DBD7DBF, "start_location" },
    { 0x96C661C6, "start_locations" },
    { 0x33FB62A1, "start_look_ent" },
    { 0x0EC04D9C, "start_loop" },
    { 0x1F00CB88, "start_loop_for_maps_room" },
    { 0xF878E004, "start_machines" },
    { 0x909647F7, "start_magic_bullet_glass" },
    { 0xDAB09505, "start_mansion" },
    { 0x24053589, "start_market_canopies" },
    { 0xB4530455, "start_market_inside_guys_trigger" },
    { 0x54F0DFC3, "start_max_dist" },
    { 0x48923467, "start_max_falloff" },
    { 0xB2FE243D, "start_maze_achievement_threads" },
    { 0xB289961F, "start_mcknight_arguing_vo" },
    { 0x560CA622, "start_melee" },
    { 0xCEC413B3, "start_menu" },
    { 0x2AD96F90, "start_merchant_ship_coll" },
    { 0xBF6A77BB, "start_merchant_ship_klaxon" },
    { 0xD2EB17C3, "start_merchant_ship_pa" },
    { 0x1CC52B71, "start_merchant_ship_siren" },
    { 0x90692B3D, "start_metal_storm" },
    { 0xFAD9B083, "start_metalstorm_event" },
    { 0x7B311E8B, "start_mid_igc_pits" },
    { 0x4F085F7D, "start_midruins" },
    { 0x649C6E6D, "start_min_dist" },
    { 0xDFE4A621, "start_min_falloff" },
    { 0x9AC4AD77, "start_mine" },
    { 0x5EAD97FB, "start_minigun" },
    { 0xFCC36E25, "start_minigun_alley" },
    { 0xF0A74DD0, "start_minigun_fallback" },
    { 0xC3EF6864, "start_missile_launchers" },
    { 0x7245A395, "start_mist" },
    { 0xAD2CDBF0, "start_mocap_ar" },
    { 0x5C3D70D5, "start_moon_sidequest" },
    { 0x57896FED, "start_morpheus" },
    { 0x3B82B6ED, "start_mortar" },
    { 0x00ADAE7E, "start_mortar_pits" },
    { 0x66D2DACF, "start_mortar_run" },
    { 0x88A8F9EC, "start_mortars" },
    { 0x7F84AC7B, "start_move_triggers" },
    { 0x168C180E, "start_movement_audio" },
    { 0x1FF1337A, "start_movie" },
    { 0x84342313, "start_movie_loop" },
    { 0x443E64E3, "start_movie_scene" },
    { 0x72E982F4, "start_moving" },
    { 0xEBE42F8D, "start_moving_trig" },
    { 0xDA151F41, "start_msg" },
    { 0x02AFBED7, "start_multi_extracam" },
    { 0x4F73FDC8, "start_music_intro" },
    { 0xC72773E8, "start_music_intro_m" },
    { 0x90E00E37, "start_music_manager" },
    { 0x1731D1C3, "start_music_outside" },
    { 0xA9016837, "start_name" },
    { 0xFEAAC33F, "start_name_1" },
    { 0x8CA35404, "start_name_2" },
    { 0xE8C0BCA9, "start_napalm" },
    { 0x9E7D0342, "start_narrative_vo" },
    { 0xDEA0C608, "start_neardist" },
    { 0xF4D94657, "start_next_wave" },
    { 0x0D3411C2, "start_nml_ramp" },
    { 0x91BF33AE, "start_node" },
    { 0x78F4C29E, "start_node_1" },
    { 0x52F24835, "start_node_2" },
    { 0x2CEFCDCC, "start_node_3" },
    { 0x06ED5363, "start_node_4" },
    { 0xE3691F54, "start_node_array" },
    { 0xE6F36E54, "start_node_name" },
    { 0x4CFE1B38, "start_node_noteworthy" },
    { 0x7C70FC2B, "start_node_targetname" },
    { 0xD784ECD1, "start_nodes" },
    { 0xADFDC5EB, "start_nodes_east" },
    { 0x509AFB6D, "start_nodes_north" },
    { 0xE85F1BB2, "start_nodes_targetname" },
    { 0xF09C8671, "start_nodes_west" },
    { 0x7360A24F, "start_noise_test" },
    { 0xD13F375F, "start_non_demo" },
    { 0xA2969C27, "start_normal" },
    { 0x0B81FC4B, "start_nose_section" },
    { 0x64B37865, "start_notetrack_wait" },
    { 0x2D0F3D61, "start_notify" },
    { 0xCF743170, "start_nowhere" },
    { 0xD66AE891, "start_nuke" },
    { 0x4CD7CC92, "start_num" },
    { 0x90BA8182, "start_nva_ambush" },
    { 0x1372526F, "start_obstacle_course" },
    { 0x0ABEBBB8, "start_of_round" },
    { 0x04EEE7D6, "start_off_lvt" },
    { 0x5CD7A75E, "start_office_anim" },
    { 0x51D2B035, "start_office_building" },
    { 0x9DC7B7DB, "start_offset" },
    { 0xEBE713FC, "start_omaha_drones" },
    { 0x45C2F745, "start_on" },
    { 0xE3C25B43, "start_on_notify" },
    { 0xFF6497B5, "start_opacity" },
    { 0xF01E4606, "start_opening" },
    { 0x1C016CF4, "start_org" },
    { 0x68795FF6, "start_org_name" },
    { 0x7A113AC1, "start_orient" },
    { 0x8B1C9508, "start_origin" },
    { 0xF2FD1FB7, "start_origin_node" },
    { 0xCC2800A0, "start_origin_struct" },
    { 0x4D7AB5D0, "start_outro_fade" },
    { 0xE3E1BC02, "start_outro_movie" },
    { 0xEB12A02A, "start_outside_castle" },
    { 0x3162717C, "start_over" },
    { 0x0EA5B322, "start_overlay" },
    { 0xB5FA51BD, "start_overlook" },
    { 0xDFE37FFE, "start_pacing" },
    { 0x8AA0C09E, "start_pap_fx" },
    { 0x73DB505F, "start_path" },
    { 0x45ABDEB3, "start_path_delay" },
    { 0x220678F7, "start_path_name" },
    { 0x0849DB6E, "start_path_node" },
    { 0x215B5CFB, "start_path_variance" },
    { 0x3F0B3334, "start_patrollers" },
    { 0x88C0294F, "start_perk_bottle_cycling" },
    { 0xC1C3AB33, "start_pilot_execution" },
    { 0x11A62280, "start_pipe_slide" },
    { 0xE1336BC4, "start_pitch" },
    { 0x429548B7, "start_plane_landed_sound" },
    { 0x4DDC4BEE, "start_plane_landed_sounds" },
    { 0xFA34D91F, "start_plane_mortars" },
    { 0x55D63817, "start_plane_prop_sounds" },
    { 0x2789E7C2, "start_plane_vc" },
    { 0xE6687CFB, "start_planes" },
    { 0x4032DADA, "start_planes_sounds" },
    { 0x4AACEA01, "start_plant_sound" },
    { 0xA29A8FAD, "start_planters_end" },
    { 0x23124215, "start_player" },
    { 0x44E1A344, "start_player_asd_anim" },
    { 0x28804CE6, "start_player_flight_sequence" },
    { 0x2F29BCD0, "start_player_health_regen" },
    { 0x39D755B9, "start_player_health_snapshot" },
    { 0x2EF5FADE, "start_player_health_system" },
    { 0x2E8D02BE, "start_player_idle" },
    { 0xDD62370A, "start_player_interrogation_animation" },
    { 0x45892E24, "start_player_jump_water" },
    { 0x54AECD6A, "start_player_landed_animations" },
    { 0xA650579B, "start_player_timer" },
    { 0xCA2F9F22, "start_player_vox_again" },
    { 0xFD6E21D8, "start_plaza" },
    { 0xF7624103, "start_plazafly" },
    { 0x23BE4852, "start_pod3" },
    { 0xF116A880, "start_point" },
    { 0x2FC8782A, "start_point_array" },
    { 0x906DA478, "start_point_left" },
    { 0x149EF087, "start_point_right" },
    { 0x19C83EAB, "start_points" },
    { 0x004BC2EF, "start_pond" },
    { 0xF178E2EC, "start_pool" },
    { 0xF08DFC9C, "start_pos" },
    { 0xBC24D1CB, "start_position" },
    { 0xEB4BD16F, "start_postigc_music" },
    { 0x60A0934D, "start_power" },
    { 0x19EC8BFC, "start_pre_rope" },
    { 0x6C6318E1, "start_press_demo_fade_out" },
    { 0xA110277E, "start_pt" },
    { 0x702085B7, "start_raft" },
    { 0xD16125F3, "start_ragdoll" },
    { 0xBF4A02CB, "start_rail_opel" },
    { 0x5B091A7A, "start_railing_guy" },
    { 0xED93730C, "start_raining" },
    { 0x0DA51E81, "start_random_machine" },
    { 0x66FC707A, "start_rappel" },
    { 0x7707B9E3, "start_rappel_scene" },
    { 0xEAF04C02, "start_rats" },
    { 0x1E6810A1, "start_real_motorcade" },
    { 0x31B00BB9, "start_rear_snowcats" },
    { 0xF5287137, "start_rebel_flare" },
    { 0x387FC24A, "start_reboot_fx" },
    { 0xC4BAF419, "start_rescue" },
    { 0xC6B7345A, "start_rescue_anims" },
    { 0xE4AD496A, "start_rescue_karma_timer" },
    { 0xB4500529, "start_reveal" },
    { 0x345EB74B, "start_reveal_anim" },
    { 0xE37C8225, "start_revive_all" },
    { 0x8057A13C, "start_reznov_hatch_open" },
    { 0xBD6BBB47, "start_riotshield_deploy" },
    { 0x1E45356F, "start_river_pacing" },
    { 0x0238C1F5, "start_roam" },
    { 0xD3460CF5, "start_robot_stomp_warning_vo" },
    { 0xEBCBFDBB, "start_rocket_loop" },
    { 0x73A4F6C2, "start_round" },
    { 0x70FB5B15, "start_rubout_time" },
    { 0xF1F5B5EB, "start_ruins" },
    { 0xA7DBAE25, "start_run" },
    { 0x64E62367, "start_run_course" },
    { 0x30C774C1, "start_run_karambit" },
    { 0x868C6B9B, "start_runaway" },
    { 0x28A46717, "start_running" },
    { 0x5EA6FB03, "start_safehouse_fps" },
    { 0x8F3FA6C2, "start_samantha_intro_vo" },
    { 0x37D58F10, "start_satchel" },
    { 0xD8CFE987, "start_save_time" },
    { 0x1F50E4E4, "start_scale" },
    { 0xB2B1FA21, "start_scan" },
    { 0xF38A0273, "start_scientist_anims" },
    { 0xA9715445, "start_scientist_run_anims" },
    { 0x7D8E17A4, "start_sco_east_walkway" },
    { 0x58DD3697, "start_scope_scene" },
    { 0x1E042D74, "start_score" },
    { 0x63ACF109, "start_script_move" },
    { 0xC53D7805, "start_scripted_melee" },
    { 0xA081C5B4, "start_seaknight" },
    { 0x313C1BA7, "start_seaknights" },
    { 0x1A34B793, "start_search_loop" },
    { 0xAAD6D853, "start_second_fight_left" },
    { 0xA14FCF98, "start_see_mech_zombie_vo" },
    { 0xFB7A2544, "start_sewer_music" },
    { 0x4C9EF4E8, "start_shake" },
    { 0x21F0BD34, "start_ship_horn" },
    { 0xC0D822CB, "start_shooting_player" },
    { 0xAEE1BE66, "start_shot_key" },
    { 0x32B0EF13, "start_shrimp_path" },
    { 0x18E16176, "start_sit_rep" },
    { 0x0D9BBAFD, "start_size" },
    { 0x0CEF418B, "start_skid" },
    { 0xE6A837F5, "start_skill" },
    { 0xACC79AFB, "start_skit" },
    { 0x2DA29F36, "start_sky_battle" },
    { 0xA650C8A2, "start_skyline_shot" },
    { 0x3706791D, "start_slingshot" },
    { 0x00CE9981, "start_slo_mo" },
    { 0x70F1D28A, "start_slomo" },
    { 0xEC91716C, "start_slow_vortex" },
    { 0x0C5C4787, "start_slowing_soct_time" },
    { 0x0332F973, "start_smell" },
    { 0x204219D9, "start_smoketown" },
    { 0x112E8573, "start_sniper_objective" },
    { 0x014CA568, "start_soldier_anim" },
    { 0xCDBBA92E, "start_sounds" },
    { 0xF18E7534, "start_southern_hill" },
    { 0x50A63F40, "start_sparks" },
    { 0x67BCE857, "start_spawn" },
    { 0x067953F9, "start_spawn_notify" },
    { 0x560C5EA3, "start_speed" },
    { 0x6BB1CDC4, "start_spetsnaz_van_crash" },
    { 0x0A069601, "start_spetz_audio_lab" },
    { 0xBA6ECB2C, "start_spetz_clark_home_explode" },
    { 0x64CDEDC7, "start_spiderbot_audio" },
    { 0xDD5883B5, "start_spinner_sound" },
    { 0x6ECBF6AA, "start_spot" },
    { 0xACB462E2, "start_spotlight_detection" },
    { 0x9293F250, "start_spreading_fire" },
    { 0x948D3993, "start_sprinting_tutorial" },
    { 0xDE93EDF3, "start_squad_ambush" },
    { 0x41298487, "start_squad_boarding" },
    { 0xAA7DBAC7, "start_square" },
    { 0xE44BA107, "start_sr71_walkup_tracks" },
    { 0x12238187, "start_ssa_anim" },
    { 0xCE8930FA, "start_start" },
    { 0xD1438409, "start_state" },
    { 0x8B3EE07C, "start_steinercin_end" },
    { 0xFCF657C1, "start_stop_sfxid" },
    { 0x3785193F, "start_stopwatch" },
    { 0xD83B5B37, "start_street" },
    { 0x5F8C78CD, "start_string" },
    { 0x6BE40E81, "start_struct" },
    { 0xC0AA2BC5, "start_struct_name" },
    { 0x5A639FC2, "start_struct_targetname" },
    { 0xBAB6459F, "start_stun_fx" },
    { 0xB0AD7645, "start_subway_music" },
    { 0x7AE6C44B, "start_success" },
    { 0x85DB3A74, "start_sunlight" },
    { 0x06529875, "start_superflare" },
    { 0xA0CF0E0C, "start_sw_cam" },
    { 0x158EC9BD, "start_swell" },
    { 0x3C999161, "start_synchronized_melee" },
    { 0x487ED259, "start_table_eat" },
    { 0xB16E45CD, "start_takeoff_sounds" },
    { 0x3696D90E, "start_tank_crush" },
    { 0x2B701F54, "start_tankride" },
    { 0xF90963ED, "start_target" },
    { 0x667C4334, "start_targetname" },
    { 0xB4692E20, "start_tarmac" },
    { 0x1B59AA83, "start_teleport" },
    { 0x44296CD8, "start_teleport_ai" },
    { 0x640BCF9A, "start_teleport_ai_custom" },
    { 0xC3EC20B0, "start_teleport_players" },
    { 0x3799FBA3, "start_teleport_single_ai" },
    { 0x77E919D4, "start_teleport_squad" },
    { 0x885A7581, "start_temple_sidequest" },
    { 0x769253BF, "start_the_music" },
    { 0x85D39762, "start_third_fight" },
    { 0x2EB14B34, "start_threat_aim" },
    { 0xF721D9A5, "start_time" },
    { 0x6918AF4C, "start_time_ms" },
    { 0xE5D6A306, "start_timed_vortex" },
    { 0x827E691D, "start_timer" },
    { 0x5E7D5BEC, "start_to_compound_fight" },
    { 0xCE244001, "start_tower" },
    { 0x4854E280, "start_tower_creak" },
    { 0x6E7D6352, "start_town" },
    { 0x7C042B6A, "start_tracker" },
    { 0xD27047F7, "start_transit_sidequest" },
    { 0x24820EF9, "start_trick_teleport_player" },
    { 0xB6CDFC22, "start_trigger" },
    { 0xA307AFED, "start_triggers" },
    { 0xB5E9CAE8, "start_trip_wires" },
    { 0xB9154592, "start_triple_cam" },
    { 0xC4B23660, "start_triple_cam_warroom" },
    { 0xAF186388, "start_tunnel" },
    { 0x10419CC7, "start_tunnel_chase" },
    { 0x713FD419, "start_tunnels_axis_a" },
    { 0xCCF14C35, "start_turned_game_mode" },
    { 0x2A0E82DC, "start_turned_on" },
    { 0xEF3ED1A8, "start_tutorial" },
    { 0x4EF23677, "start_underwater_anim" },
    { 0x00C468D4, "start_underwater_snapshot" },
    { 0xF96FA4C4, "start_unhide_players" },
    { 0x8D400B59, "start_up" },
    { 0x4A52F6BF, "start_val" },
    { 0x5AFAD49D, "start_value" },
    { 0x30FEF6D9, "start_van_crash" },
    { 0x33EDD136, "start_van_crash_allies" },
    { 0x9CBA1E55, "start_vaultdoors" },
    { 0x8FCC079E, "start_vehicle_music" },
    { 0x4C0E0519, "start_vehicle_on_pathname" },
    { 0xE05757C5, "start_vehicle_sounds" },
    { 0x96FC6467, "start_vehicle_trig" },
    { 0xADFAE423, "start_vehiclepath" },
    { 0x2234D3DE, "start_vents" },
    { 0x25E941FC, "start_victory_music" },
    { 0x4CA979B4, "start_vietnam_camera" },
    { 0xEAC49836, "start_village" },
    { 0x41B82F61, "start_village_chase" },
    { 0xFC7C3A19, "start_village_defend" },
    { 0x0923D0BB, "start_vip" },
    { 0x46912107, "start_virus_2_bink" },
    { 0x47B42312, "start_vision" },
    { 0x623F1D9C, "start_vnode" },
    { 0x49249BFF, "start_vo" },
    { 0x63A62847, "start_vo_nag_group_" },
    { 0x6E1BF32D, "start_vo_nag_group_flag" },
    { 0x508CDB1D, "start_vo_nag_group_func" },
    { 0x6C610841, "start_vo_nag_group_trigger" },
    { 0x3E5D45DF, "start_vortex_fx" },
    { 0x261F7890, "start_vtol_guys" },
    { 0x224E197B, "start_vtol_timer" },
    { 0x19B8460E, "start_vulture_shooting_event" },
    { 0xBD0B4E79, "start_wait" },
    { 0xF6AC8390, "start_wait_node" },
    { 0xEE2D375F, "start_walking_villagers" },
    { 0xCD646EF5, "start_wall_clock" },
    { 0xC7A1361C, "start_war" },
    { 0xA7801DE7, "start_warehouse" },
    { 0xA3519DA7, "start_warp_guys" },
    { 0x9DBC21C2, "start_warroom_bink" },
    { 0x3C1FFCDB, "start_warroom_split_screen" },
    { 0xC84308E0, "start_water_dive" },
    { 0x611043A9, "start_water_sheeting" },
    { 0x8250393D, "start_water_trace" },
    { 0xC259004F, "start_wave_buildup" },
    { 0x429DAD7A, "start_weapon" },
    { 0xC6A7930E, "start_weaver_breach" },
    { 0x13E5DA72, "start_weaverstab" },
    { 0xE5EF78B8, "start_wingsuit" },
    { 0xFCBACD7C, "start_woods_clearing_vo" },
    { 0xF1C7EE06, "start_woods_horse" },
    { 0x8742334C, "start_worker_crate_investigate" },
    { 0x1483381B, "start_workers" },
    { 0x8D9D2D37, "start_workers_walking" },
    { 0x398673C8, "start_wounded" },
    { 0xB999D40D, "start_wounding" },
    { 0xB1F96E86, "start_x" },
    { 0xD7FBE8EF, "start_y" },
    { 0x8CB535DE, "start_yard" },
    { 0xC7475243, "start_yaw" },
    { 0x65F479B4, "start_z" },
    { 0x13BB58CD, "start_zipline" },
    { 0x3B1B0177, "start_zm_dash_counter_watchers" },
    { 0x6A1C693A, "start_zombie_dissolve" },
    { 0xA6492099, "start_zombie_gametype" },
    { 0x816DCDCC, "start_zombie_logic_in_x_sec" },
    { 0x43B2F782, "start_zombie_round_logic" },
    { 0xB211E563, "start_zombie_stuff" },
    { 0x01C049FF, "start_zombies" },
    { 0x5D12EC0B, "start_zones" },
    { 0x26F191F9, "start_zpu" },
    { 0x867E196F, "startactorreact" },
    { 0x2D0A77D9, "startadditionalwaiting" },
    { 0xEA0647C2, "startaim" },
    { 0xD6671E2E, "startaiming" },
    { 0x82A9639A, "startalley" },
    { 0x66B681B1, "startalpha" },
    { 0xDE5AA6FD, "startammo" },
    { 0xDB8A3269, "startang" },
    { 0x6CE00F48, "startangle" },
    { 0xFF85BE63, "startangles" },
    { 0xC6F8D970, "startanim" },
    { 0x962CEE04, "startartillerycanon" },
    { 0xC237BFF9, "startattacktrig" },
    { 0x1AC2BC5E, "startbanzailaststand" },
    { 0xCDBA10DF, "startbarrelpouring" },
    { 0x47920A8B, "startbinocs" },
    { 0xA52AE989, "startblindaiming" },
    { 0xA87402E7, "startbsm" },
    { 0xD2F3E35B, "startcameratween" },
    { 0x7A0E7D93, "startcarexit" },
    { 0x7767B75E, "startcarryturret" },
    { 0xC7D1471A, "startchallenge" },
    { 0x9F2DAE08, "startcolor" },
    { 0xAC2F50F4, "startcornerapproach" },
    { 0x47EB808A, "startcornerapproachconditions" },
    { 0x8C3CE1D5, "startcornerapproachpreconditions" },
    { 0x5C0A8960, "startcornerdist" },
    { 0x9AF44998, "startcornerdistsq" },
    { 0x4039449C, "startcount" },
    { 0x7435D6A3, "startcountdowntimer" },
    { 0xB52918BF, "startcoverarrival" },
    { 0x86D1D9CE, "startcovertrig" },
    { 0xA20891AE, "startcurrent" },
    { 0xC06A6EFC, "startcurve" },
    { 0x99E19649, "startdartremotecontrol" },
    { 0x02E5DAEE, "startdeaths" },
    { 0x65B89488, "startdelay" },
    { 0xE3B483BF, "startdemorecording" },
    { 0x4F9A43F0, "startdialogkey" },
    { 0x772CCD7C, "startdir" },
    { 0x411A215E, "startdirection" },
    { 0xDEDB378B, "startdist" },
    { 0x030378A4, "startdist_new" },
    { 0x2D727AC6, "startdistance" },
    { 0xA8EBA54C, "startdoorbreach" },
    { 0x63902F99, "startdoorkick" },
    { 0xD08DAAD5, "startdrive" },
    { 0x25291EC1, "startdronestrike" },
    { 0x9F3C9434, "startdyingcrawlbackaimsoon" },
    { 0x9357B8A4, "started" },
    { 0x32C9F237, "started_corpse_found_behavior" },
    { 0x1F083E9D, "started_crater_charge" },
    { 0x9C911659, "started_moving" },
    { 0xC6C32D20, "started_player_van_ending" },
    { 0x770270CB, "started_rappel" },
    { 0xECE78D40, "started_running" },
    { 0x247F419E, "started_timeout_ending" },
    { 0xAB3B3C1C, "started_waiting" },
    { 0x718EEF31, "startedaiming" },
    { 0x5C4F80D6, "startedfx" },
    { 0x8545A857, "startedinlaststand" },
    { 0x9A8AF909, "startedwaiting" },
    { 0xAB956432, "startelectrictrapdeploy" },
    { 0x1774AFAE, "startelem" },
    { 0xE3F2FEBF, "startempeffects" },
    { 0xDE70BAA2, "startending" },
    { 0x8CBF5AD1, "startendtime" },
    { 0x9564271C, "startenemypulse" },
    { 0xAF5FD55E, "startenginesound" },
    { 0xA77A6A62, "starter" },
    { 0x7BDCB8EA, "startergy" },
    { 0x8BF586F7, "startfadingblur" },
    { 0xF7823745, "startfinalcountdowntimer" },
    { 0x1AE2508A, "startfinalkillcam" },
    { 0x37D9660A, "startfire_node" },
    { 0x7ED62B7E, "startfiring" },
    { 0x332BDA31, "startfiringtime" },
    { 0xC9ABE6F5, "startflag" },
    { 0x78913F32, "startflashbanged" },
    { 0x60ED9255, "startflashing" },
    { 0xE83146D4, "startfov" },
    { 0xB536650B, "startfrac" },
    { 0xC5A9C5D2, "startframe" },
    { 0x465BE6CD, "startfullthreshold" },
    { 0x87970469, "startfuncptr" },
    { 0xA9A23DC9, "startfx" },
    { 0xBAE6B44E, "startfx_loop" },
    { 0x5B819C85, "startgame" },
    { 0xB2A3FF79, "startgamedialog" },
    { 0x303F5D8E, "startgamedialogkey" },
    { 0x8E77BAC5, "startgamesplayed" },
    { 0x9FD3778F, "startgen" },
    { 0xC1A58E42, "startgoal" },
    { 0x26AF95DB, "startguys" },
    { 0x45392375, "starth" },
    { 0x19B36DC2, "starthcgamedialog" },
    { 0xCDDED6B7, "starthcgamedialogkey" },
    { 0xE2EAB1A7, "startheadchopperdeploy" },
    { 0x4542A89D, "starthealth" },
    { 0x10327966, "startheight" },
    { 0x304D2350, "starthelicopter" },
    { 0xBC476C27, "startheliguardsupport" },
    { 0x367B5781, "starthits" },
    { 0x56D1B8F3, "starthostmigration" },
    { 0xAD574792, "starthuntbehavior" },
    { 0x6AEF69D8, "startidx" },
    { 0x61271B70, "startignoringspotlight" },
    { 0x6001F5B1, "startindex" },
    { 0x13865BA1, "starting" },
    { 0xA89A3805, "starting_ads_damage_dealt" },
    { 0xB5256B06, "starting_ammo" },
    { 0x5FD1E784, "starting_angles" },
    { 0xA4DDA5D0, "starting_beacon_watch" },
    { 0x9B250665, "starting_black_hole_bomb" },
    { 0x8959FBD9, "starting_brightness" },
    { 0x1E79923C, "starting_cargoship_obj" },
    { 0x536D6289, "starting_clamp" },
    { 0x447455E6, "starting_confront_steiner" },
    { 0x7DB09FC5, "starting_deaths" },
    { 0x985E8B01, "starting_debug" },
    { 0x79F1A0F8, "starting_enemy_damage_taken" },
    { 0x49B53F16, "starting_enemy_deaths" },
    { 0x0A014AE9, "starting_fall_off" },
    { 0x3EBB9EFE, "starting_floor" },
    { 0x88D2805C, "starting_guys" },
    { 0x08117F7E, "starting_health" },
    { 0xA0215F3D, "starting_height" },
    { 0x79A345FB, "starting_hud_elem" },
    { 0x7161B47F, "starting_logic_func" },
    { 0x718937A7, "starting_monkey_watch" },
    { 0xFC1C7C26, "starting_new_attack_pattern" },
    { 0x04C1B26F, "starting_new_hands_anim" },
    { 0x79F3F3F8, "starting_node" },
    { 0x2026CEC2, "starting_node_name" },
    { 0xD554C2C6, "starting_obj_num" },
    { 0x69FFF51D, "starting_octobomb_watch" },
    { 0x768AE65A, "starting_player_damage_dealt" },
    { 0xE68CD29D, "starting_player_damage_taken" },
    { 0x19D275C5, "starting_player_kills" },
    { 0x65FD77D9, "starting_points" },
    { 0x924BDBE2, "starting_pos" },
    { 0xF0155A3D, "starting_position" },
    { 0x769D1DD2, "starting_quantum_bomb" },
    { 0xD779F01F, "starting_rockets" },
    { 0xDEBC74C8, "starting_rope" },
    { 0x016A362E, "starting_seconds_remaining" },
    { 0xD24089D0, "starting_slowdown_ai" },
    { 0x4BC544F8, "starting_snapshot" },
    { 0x387F8F68, "starting_spawn_light" },
    { 0x5A990AC0, "starting_steiners_office" },
    { 0x99D67FCB, "starting_threatbias" },
    { 0x82995623, "startinggametype" },
    { 0x2C19CB88, "startinggunprogress" },
    { 0x9DE36223, "startingindex" },
    { 0xFA033054, "startinglocation" },
    { 0xF75D4B91, "startingpos" },
    { 0xC7F339B6, "startingteam" },
    { 0x90BD0471, "startingweapon" },
    { 0x7155BA9C, "startinitialstate" },
    { 0x238AC43E, "startintensity" },
    { 0xF523A423, "startintro" },
    { 0x5575D1E6, "startinvehicle" },
    { 0xE84F4C19, "startinvehicles" },
    { 0x998DF379, "startinvulnerabletime" },
    { 0x2A0BDECB, "startinwater" },
    { 0xB2989B7E, "startiswallrun" },
    { 0xC319C384, "startkey" },
    { 0xDBA20E7A, "startkills" },
    { 0xEC4E2B9C, "startlastkillcam" },
    { 0xC692FA3C, "startleadin" },
    { 0xAF1EDD7E, "startled" },
    { 0x363650D0, "startleft" },
    { 0x781F595F, "startlightning" },
    { 0xCE53E044, "startlineemitters" },
    { 0x4641A8B9, "startliquidrising" },
    { 0x12DC2DA7, "startloc" },
    { 0x635A7ADB, "startlocalpulse" },
    { 0xC14374D2, "startlocation" },
    { 0xABCF3C0E, "startlocationtoleavefrom" },
    { 0x1B096AA2, "startlook" },
    { 0xDD3B7B43, "startlookyloosnap" },
    { 0xBE94E54E, "startlosses" },
    { 0xADD37821, "startmelee" },
    { 0x99E5D86C, "startmessage" },
    { 0x6FA8501B, "startmessagedefaultduration" },
    { 0xF57B5D00, "startmessagenotifyqueue" },
    { 0x8D17105E, "startmicrowave" },
    { 0x27963F7C, "startmicrowavefx" },
    { 0xB7307465, "startminiarrival" },
    { 0x972A8FDF, "startmisses" },
    { 0x7CFD616E, "startmissilecam" },
    { 0xB29E4245, "startmonitoringflash" },
    { 0xB8ADD1A2, "startmonitoringtearusage" },
    { 0xB3CA60D5, "startmortarcanon" },
    { 0x4C553BFC, "startmove" },
    { 0x7BD35C93, "startmovetracklookahead" },
    { 0x594A07BD, "startmovetransition" },
    { 0x7EFE536A, "startmovetransitiondebug" },
    { 0x08530FA5, "startmovetransitionfinalconditions" },
    { 0xEC2A0FD7, "startmovetransitionmidconditions" },
    { 0xF5F51B9E, "startmovetransitionpreconditions" },
    { 0x15DBB4CB, "startmultiplayergame" },
    { 0x322A0D92, "startname" },
    { 0x7275C360, "startnapalm" },
    { 0x26850B50, "startnextround" },
    { 0xDC8F589D, "startnextzmround" },
    { 0xDA91FAF7, "startnode" },
    { 0x05428C1C, "startnode1" },
    { 0x7749FB57, "startnode2" },
    { 0x514780EE, "startnode3" },
    { 0x933B1CE1, "startnode4" },
    { 0x753557CD, "startnode_array" },
    { 0xE878C4AB, "startnoflyzone" },
    { 0x6835A18A, "startnoflyzones" },
    { 0xEDD8C249, "startnum" },
    { 0xD6AA177E, "startoffset" },
    { 0x1AFFD9D6, "startofline" },
    { 0x3EF85EE3, "startoflineentity" },
    { 0x1E759362, "startold" },
    { 0x98F09D9B, "startorg" },
    { 0x6353A1BA, "startorgs" },
    { 0x07649ADD, "startorigin" },
    { 0x34559887, "startoverride" },
    { 0xD2AD567C, "startpaintime" },
    { 0xD142A882, "startpath" },
    { 0x232E0CF2, "startpathrandomness" },
    { 0x2751E477, "startpause" },
    { 0x05CEA511, "startpaused" },
    { 0x00647223, "startpitch" },
    { 0x9E6B2034, "startplace" },
    { 0xE4CDC5C3, "startpoint" },
    { 0x2D137E20, "startpoint1" },
    { 0x9F1AED5B, "startpoint2" },
    { 0x555BF194, "startpoint_tn" },
    { 0x4328A2A5, "startpoint_triggers_delete" },
    { 0xF9B70D32, "startpoints" },
    { 0x34FBEAFD, "startpoisoning" },
    { 0x92B6852B, "startpos" },
    { 0x37613E3E, "startposition" },
    { 0x8ECED85D, "startposition_" },
    { 0x9B8624C2, "startposoffset" },
    { 0xEACD64B2, "startpower" },
    { 0x63C66A04, "startpregame" },
    { 0xA38B0008, "startprestige" },
    { 0xB65DCC4D, "startprogressbar" },
    { 0x1B320F34, "startqrdrone" },
    { 0xA3CB6E49, "startradius" },
    { 0xD7A0A9D8, "startragdoll" },
    { 0xBEE8F4E6, "startragdollonground" },
    { 0x1A7352A5, "startrate" },
    { 0xECBEE74C, "startratio" },
    { 0xBAA6E594, "startrattles" },
    { 0xE5BB10A6, "startref" },
    { 0xC821591C, "startremotecontrol" },
    { 0x33E810D5, "startresurrectviewangletransition" },
    { 0x299BADD4, "startretreatnode" },
    { 0x78BAE150, "startrevive" },
    { 0xF7FB011A, "startrewindableevent" },
    { 0xDAEA5867, "startriotshielddeploy" },
    { 0xC3A4F2A1, "startrobotcount_" },
    { 0xA802497E, "startrun" },
    { 0x82EE54DA, "startrunners2" },
    { 0x9B4F7126, "starts" },
    { 0x78811DB0, "starts2" },
    { 0xFDA6672C, "starts_array" },
    { 0x946CB89C, "starts_empty" },
    { 0x346CEAB1, "starts_open" },
    { 0x3CC0098A, "starts_slow" },
    { 0xDD885611, "starts_visible" },
    { 0x7E1AA363, "startscale" },
    { 0xEF19780F, "startscore" },
    { 0xA06AD8D6, "startscriptedanim" },
    { 0xDF147C7F, "startsearchpoint" },
    { 0x03DFBD61, "startsentientcount_" },
    { 0x56B12A24, "startsentinelremotecontrol" },
    { 0x9A01EE0A, "startsequencetriggertargetname" },
    { 0x6734AFD0, "startshoot" },
    { 0xCC3E7CD6, "startshore" },
    { 0xB2A6AA7A, "startside" },
    { 0xB877EEE6, "startskip" },
    { 0x2C9B557C, "startsound" },
    { 0x5688B641, "startsoundloops" },
    { 0x1E1D31E8, "startsoundrandoms" },
    { 0x79DB96F5, "startspeaking" },
    { 0x64F2EC00, "startspeed" },
    { 0x99A72347, "startspot" },
    { 0xAE09753E, "startspots" },
    { 0xB2C98FEE, "startspringpaddeploy" },
    { 0x23AB23BF, "startstance" },
    { 0xD16F5862, "startstatuscardtimer" },
    { 0xB29269CA, "startstrafe" },
    { 0x59173A32, "startstrafekillcams" },
    { 0x7D15FCE0, "startstruct" },
    { 0xADA75D73, "startstun" },
    { 0x8CA13BCB, "startsubwooferdecay" },
    { 0x00B45666, "startsubwooferdeploy" },
    { 0x92389C8C, "startsuncolor" },
    { 0x1A93B275, "startsuppressiondelay" },
    { 0x414A9FB0, "starttankremotecontrol" },
    { 0x65BA6FFA, "starttanning" },
    { 0xA2630AB8, "startteamops" },
    { 0xA4AD846C, "starttime" },
    { 0x78BBC115, "starttimeplayedtotal" },
    { 0x14662A06, "starttimer" },
    { 0x6994C84B, "starttimesec" },
    { 0xE8D73E1B, "starttoend" },
    { 0xC76AD9C8, "starttotargetcornerangles" },
    { 0x9AF91E6A, "starttrace" },
    { 0x70260776, "starttracesat" },
    { 0xC6854D44, "starttransanim" },
    { 0x9B29EBEB, "starttrashstumble" },
    { 0x25839439, "starttrigger" },
    { 0xA21724F5, "startturbinedeploy" },
    { 0x2EA0728E, "startturn" },
    { 0x674C3554, "startturretdeploy" },
    { 0x270AD59A, "startturretremotecontrol" },
    { 0x2A6995EB, "startuavfx" },
    { 0x787FCF1C, "startunitriggers" },
    { 0x1625ED42, "startunlockpoints" },
    { 0x0B6D2BE0, "startup" },
    { 0x506436A0, "startup_e3_freeflow_triggers" },
    { 0x71A43446, "startup_plane_sounds" },
    { 0x2BA72CE7, "startupfx1" },
    { 0x3093D9B4, "startval" },
    { 0xBE80447E, "startvalue" },
    { 0x938CB3EE, "startvol" },
    { 0xDC1B8822, "startvpshader" },
    { 0x8E26BC60, "startwait" },
    { 0xC243B5AE, "startwaterdive" },
    { 0x0D5EC191, "startwaterheight" },
    { 0x8956791F, "startwatersheeting" },
    { 0x9065063D, "startwatersheeting_singleton" },
    { 0xA30076D3, "startweapon" },
    { 0xCC0C74BA, "startwins" },
    { 0x7F5E4F9C, "starty" },
    { 0x363EAB38, "startyaw" },
    { 0x27C0230F, "startyawforward" },
    { 0xDE4EE045, "startzone" },
    { 0xB820DB7A, "starved" },
    { 0xBC9A8E88, "stash" },
    { 0x56F05A9B, "stashed" },
    { 0xDD1A7B94, "stashes" },
    { 0x2461863F, "stat" },
    { 0xC71CB4B2, "stat_category" },
    { 0x6661EE1A, "stat_counter" },
    { 0xDB9F4051, "stat_counter_merchant_ships" },
    { 0x64DF8DFF, "stat_counter_ptboat" },
    { 0xB1391926, "stat_counter_survivors" },
    { 0x6C3FC40B, "stat_counter_zeroes" },
    { 0xCB9F40FA, "stat_desired_value" },
    { 0x3F39DB75, "stat_desired_values" },
    { 0x0ED91BD1, "stat_dvar" },
    { 0xFD293DAB, "stat_flags" },
    { 0x2369852E, "stat_get_with_gametype" },
    { 0x52B45813, "stat_group" },
    { 0x5D350AA9, "stat_id" },
    { 0xCBD14276, "stat_index" },
    { 0x257FC497, "stat_name" },
    { 0xE45EB34E, "stat_names" },
    { 0xA8620C72, "stat_num" },
    { 0xA415EE3B, "stat_offset" },
    { 0xF059ACBF, "stat_path" },
    { 0x9A7D7935, "stat_path_array" },
    { 0x6F71437B, "stat_reward_available" },
    { 0xE885624A, "stat_set_with_gametype" },
    { 0xF585CCDD, "stat_to_swap" },
    { 0x7603D6A5, "stat_types" },
    { 0xA5DD369F, "stat_val" },
    { 0x510EC37D, "stat_value" },
    { 0xC133F56E, "stat_variable" },
    { 0xBDB93132, "stat_vo_check_1" },
    { 0x3513C7C2, "stat_vo_check_1_failed" },
    { 0x37EE9122, "stat_vo_check_2a" },
    { 0x26D68BB2, "stat_vo_check_2a_failed" },
    { 0x11EC16B9, "stat_vo_check_2b" },
    { 0x20D196CB, "stat_vo_check_2b_failed" },
    { 0x71B43C60, "stat_vo_check_3" },
    { 0x876E27B4, "stat_vo_check_3_failed" },
    { 0x1CACD2DA, "stat_weapon" },
    { 0x60A7AA3C, "statadd" },
    { 0xCBEDB867, "stataddinternal" },
    { 0x812C1EF4, "stataddtype" },
    { 0xF97BA7A2, "stataddwithgametype" },
    { 0x86C93E40, "state" },
    { 0x6EADA909, "state_alert_update" },
    { 0x60E8F168, "state_alerted" },
    { 0x601702F8, "state_anim" },
    { 0xDBE3C90A, "state_balconycombat_enter" },
    { 0x3344E4E8, "state_balconycombat_exit" },
    { 0x5151F00B, "state_balconycombat_update" },
    { 0xD5992982, "state_before" },
    { 0xCDA704DF, "state_change" },
    { 0x3D3CF778, "state_change_ender" },
    { 0xCC619253, "state_change_tester" },
    { 0xD3D566CB, "state_combat" },
    { 0xD4988DFC, "state_combat_enter" },
    { 0x9AF4712E, "state_combat_exit" },
    { 0xC637F0C1, "state_combat_update" },
    { 0x85B3C7D7, "state_combat_update_wait" },
    { 0x9A222158, "state_death_enter" },
    { 0xC18559A5, "state_death_update" },
    { 0xB99A7893, "state_dist" },
    { 0x314D66AC, "state_driving_update" },
    { 0xE14FE323, "state_emped_enter" },
    { 0x428B0743, "state_emped_exit" },
    { 0x8A8B75B0, "state_emped_update" },
    { 0x1B1968C1, "state_funcion" },
    { 0xAD4BFEAC, "state_funcs" },
    { 0x60549BD2, "state_functions" },
    { 0x3B3E7A3D, "state_groundcombat_exit" },
    { 0xC05314DA, "state_groundcombat_update" },
    { 0x896B6512, "state_guard_can_enter" },
    { 0x4001377D, "state_guard_enter" },
    { 0xAB509A91, "state_guard_exit" },
    { 0x0D8665AE, "state_guard_update" },
    { 0x5298A83C, "state_highalert_enter" },
    { 0xBE73FDED, "state_idgun_crush_enter" },
    { 0x1DADEB9E, "state_idgun_crush_update" },
    { 0x52342C27, "state_idgun_flying_crush_enter" },
    { 0x107DC38C, "state_idgun_flying_crush_update" },
    { 0x18D94909, "state_idgun_flying_death_update" },
    { 0x0CCAECA3, "state_jump_can_enter" },
    { 0xBF7DFC58, "state_jump_enter" },
    { 0x309FCA92, "state_jump_exit" },
    { 0x911F1AA5, "state_jump_update" },
    { 0xB76C2C48, "state_jumpdown_enter" },
    { 0x21EE6E62, "state_jumpdown_exit" },
    { 0x54C6085F, "state_jumpup_enter" },
    { 0xFD63DC4A, "state_loco" },
    { 0x4F943B70, "state_lowalert_enter" },
    { 0xBF0B4BB2, "state_machine" },
    { 0xEA9E083D, "state_machines" },
    { 0xBA139F03, "state_melee_combat_attack" },
    { 0x1336E598, "state_melee_combat_update" },
    { 0x679FCDCA, "state_name" },
    { 0x5569F019, "state_off_enter" },
    { 0x42F9B1F5, "state_off_exit" },
    { 0xE5168BF2, "state_off_update" },
    { 0xE8760B11, "state_params" },
    { 0xB9F1655E, "state_power_up_update" },
    { 0xCBCAA048, "state_priority_death" },
    { 0x19B50906, "state_priority_decrease" },
    { 0x81A89BAE, "state_priority_increase" },
    { 0xFBA2B8DC, "state_range_combat_attack" },
    { 0x871AB92B, "state_range_combat_update" },
    { 0x5447D15F, "state_scripted_update" },
    { 0xB6BB8241, "state_set" },
    { 0x14D89A82, "state_slash_update" },
    { 0x7779F95A, "state_stationary_enter" },
    { 0x4F779518, "state_stationary_exit" },
    { 0x0870BC1B, "state_stationary_update" },
    { 0xA62E7D45, "state_stationary_update_wait" },
    { 0xF0F6044D, "state_strafe_enter" },
    { 0x6FCDAA81, "state_strafe_exit" },
    { 0xD5B7537E, "state_strafe_update" },
    { 0xF9BBC086, "state_surge_exit" },
    { 0x91F83259, "state_surge_update" },
    { 0x134FC52E, "state_suspicious" },
    { 0x3AC54B7B, "state_switch" },
    { 0xFB764AAE, "state_timer" },
    { 0x2FEA97CC, "state_unaware" },
    { 0x73D33FB3, "state_unaware_enter" },
    { 0xD16325B3, "state_unaware_exit" },
    { 0xD9F380C0, "state_unaware_update" },
    { 0xD4AEAA87, "statearray" },
    { 0x7E289788, "statechange" },
    { 0xB378BD34, "stateindex" },
    { 0x24EFEE72, "statelevel" },
    { 0x389DAD85, "stately" },
    { 0xBB771E9F, "statemachine" },
    { 0x8058D139, "statemachine_shared" },
    { 0xDC9B4A92, "statemachinename" },
    { 0xE1D682BD, "statemachinestatus" },
    { 0xEBA2B8DC, "statement" },
    { 0x9F58181F, "statements" },
    { 0xBCD4B057, "statemodel" },
    { 0x7ACDC9EA, "statemodelname" },
    { 0x989E6379, "statename" },
    { 0x80ACC76B, "states" },
    { 0x6F1216EB, "statestring" },
    { 0x83082999, "statetagname" },
    { 0xD4F4DBD5, "statetext" },
    { 0x2C27707B, "statetime" },
    { 0x13657BF8, "statetype" },
    { 0xC5984606, "statevalid" },
    { 0x7207C095, "statget" },
    { 0x15CC9DE7, "statgetwithgametype" },
    { 0x5FF7AD21, "stathits" },
    { 0x93F4229F, "static" },
    { 0xB8ACDF42, "static_alpha" },
    { 0xFB08368F, "static_berlin_rus_flag_rolled" },
    { 0xB364FBB6, "static_bodies" },
    { 0x889A981B, "static_bodies_disable" },
    { 0x3CB01580, "static_bodies_enable" },
    { 0xB00C100C, "static_column" },
    { 0x679AF1E7, "static_crate" },
    { 0x298383E6, "static_door" },
    { 0x588E1BF8, "static_firing_behavior" },
    { 0x4698F2DB, "static_fx_done" },
    { 0x06B99654, "static_grass" },
    { 0x1A347A26, "static_melee_anim" },
    { 0xF9DA037B, "static_monitors" },
    { 0xAD781768, "static_peleliu_lvtcrew" },
    { 0x26AEA22A, "static_print3d" },
    { 0x39DE710F, "static_print_offset" },
    { 0x56A5944D, "static_sound_loop_play" },
    { 0x8BCFA97C, "static_sound_random_play" },
    { 0x76BAECA5, "static_time" },
    { 0xADEA5184, "static_trans_time" },
    { 0x9B8E9968, "static_trans_time_half" },
    { 0xE9368CB2, "static_trans_time_nearhalf" },
    { 0xF9B974AF, "static_transition" },
    { 0xE45494AD, "static_turbulence" },
    { 0xC99EC5D8, "static_tv" },
    { 0x0683B096, "static_vehicle_switch_fadeout" },
    { 0x47C29BC9, "static_vehicles" },
    { 0xE64F94B1, "staticalpha" },
    { 0x2321566B, "staticamount" },
    { 0xD4E19FD2, "staticbg" },
    { 0x6BA60511, "staticccdata" },
    { 0x5E8614BC, "staticeffect" },
    { 0xB65B1731, "staticinfluencerent" },
    { 0xF0D50698, "staticinfluencerents" },
    { 0x25ACB3C7, "staticlabel" },
    { 0x4E2D5426, "statics" },
    { 0x977ECBDE, "staticseconds" },
    { 0xA88BC91A, "statictext" },
    { 0x2368056C, "statictime" },
    { 0x3E679961, "statictrig" },
    { 0xE856611D, "staticweaponsstarttime" },
    { 0xE8A80FD1, "statindex" },
    { 0xD8FDE697, "station" },
    { 0x107DF518, "station5" },
    { 0xBDA32619, "station_pa_vox" },
    { 0xA485BF49, "station_pos_x" },
    { 0x7E8344E0, "station_pos_y" },
    { 0xF08AB41B, "station_pos_z" },
    { 0x72C1C858, "station_treasure_chest_init" },
    { 0xC3C6DE53, "stationary" },
    { 0xA68C1EE4, "stationarycrateoverride" },
    { 0xDCF4001C, "stationarythreshold" },
    { 0x73EE394E, "stations" },
    { 0x57EC6F7E, "stations_waiting" },
    { 0x0AEDADDE, "statitemindex" },
    { 0x81532684, "statlen" },
    { 0x8D249808, "statless_powerups" },
    { 0xFC8C0D7F, "statmisses" },
    { 0x79FCC132, "statmultiplier" },
    { 0x4259AE32, "statname" },
    { 0x2C5FF29D, "statnameforkillstreak" },
    { 0xC8431400, "statnumber" },
    { 0x49533C81, "statoffsets" },
    { 0xFBB2AE36, "statrange" },
    { 0xCAFFC346, "stats" },
    { 0x643CDBF0, "stats_allocation_column" },
    { 0x402AD3DB, "stats_cost_column" },
    { 0x25F3BD2B, "stats_group_column" },
    { 0xD5187603, "stats_init" },
    { 0x755DF74A, "stats_loadout_slot" },
    { 0xBC1A46AB, "stats_only" },
    { 0xA84ECF21, "stats_reference_column" },
    { 0x6AB5B83A, "stats_size" },
    { 0x2F0F17C5, "stats_table_col_allocation" },
    { 0x605D8D13, "stats_table_col_attachments" },
    { 0x6F756F1C, "stats_table_col_count" },
    { 0x731F9B1F, "stats_table_col_default_class" },
    { 0x52B50A60, "stats_table_col_desc" },
    { 0xFADF28EF, "stats_table_col_dlc_index" },
    { 0xE4E01E64, "stats_table_col_group" },
    { 0xEB4D008E, "stats_table_col_image" },
    { 0xAB77C0DD, "stats_table_col_momentum" },
    { 0x2CE1C912, "stats_table_col_name" },
    { 0x53FC6678, "stats_table_col_numbering" },
    { 0x7150036E, "stats_table_col_reference" },
    { 0xA0FB4EE3, "stats_table_col_slot" },
    { 0xA7607D13, "stats_table_col_sort_key" },
    { 0xCEF9A314, "stats_table_col_unlock_level" },
    { 0x411A5BCB, "stats_table_cp" },
    { 0xE641B421, "stats_table_max_items" },
    { 0xB1B829E5, "stats_table_mp" },
    { 0x10DD4AA1, "stats_table_ref" },
    { 0x3A0C2CDD, "stats_table_zm" },
    { 0xCBE7006F, "stats_this_frame" },
    { 0x00C67F75, "stats_todo" },
    { 0xBD8C5C59, "statset" },
    { 0x2D010AB6, "statsetinternal" },
    { 0xB15B0293, "statsetwithgametype" },
    { 0x12BD81CF, "statsmilestone3" },
    { 0x2F710548, "statsmilestoneinfo" },
    { 0x1BD0A716, "statsmilestones3" },
    { 0x0C41383E, "statsread" },
    { 0xE4A4C942, "statstable" },
    { 0x30946DD6, "statstable_shared" },
    { 0xF543DAD1, "statstableid" },
    { 0xC9CA2658, "statstablelookup" },
    { 0xA804A5CF, "statstablename" },
    { 0xA628B7E7, "stattotal" },
    { 0x19549957, "stattype" },
    { 0xDA56B01D, "statue" },
    { 0xA64C3316, "statue_anims" },
    { 0xA7DA04A4, "statue_fall_fx" },
    { 0xA6E0D7AA, "statue_fallen" },
    { 0x1786C249, "statue_heads" },
    { 0x26E02D98, "statue_targ" },
    { 0xCC9E371B, "statue_target" },
    { 0x2E2A14BB, "status" },
    { 0xE0D92A22, "status_light" },
    { 0x13921DE5, "status_show" },
    { 0x1092F030, "status_slot_bg_size" },
    { 0xA02074A6, "status_slot_health_width" },
    { 0x5E57AAA2, "status_slot_icon_size" },
    { 0x8878AE5D, "status_slot_inner_pad" },
    { 0x2B85CE99, "status_slot_max" },
    { 0x00F0E8C7, "status_slot_max_human" },
    { 0x44B3230B, "status_slot_max_mech" },
    { 0x92B73525, "status_slot_min_human" },
    { 0xA4C80FCD, "status_slot_min_mech" },
    { 0xF0E00C84, "status_slot_pad" },
    { 0xF9DEFF3E, "status_slot_timer_height" },
    { 0xDB235B37, "status_slot_width" },
    { 0x59D8B4EB, "status_slot_x" },
    { 0x33D63A82, "status_slot_y" },
    { 0xAC14955E, "statuscallback" },
    { 0xB6E1BE41, "statuscard" },
    { 0xC74A331D, "statuscard_height" },
    { 0x70B550E8, "statuscard_width" },
    { 0xC9219A54, "statuscard_x" },
    { 0xEF2414BD, "statuscard_y" },
    { 0xF5801C57, "statusdialog" },
    { 0x8D587529, "statusdialogenemies" },
    { 0x8CF1797C, "statusicon" },
    { 0x3C7B277E, "statusslottimer" },
    { 0xC35E77AC, "statusstr" },
    { 0xD6E42F50, "statustime" },
    { 0x659435D4, "statval" },
    { 0x5A18BA9E, "statvalue" },
    { 0x349843E3, "statvaluename" },
    { 0x34A10573, "statweapon" },
    { 0x211610F7, "statz" },
    { 0x07BEA32A, "stave" },
    { 0x9668F57A, "stay" },
    { 0x26321821, "stay_animated_at_node" },
    { 0x93D8A7EE, "stay_away_fromwall" },
    { 0xB0C62904, "stay_behind_player_boat" },
    { 0x82C74942, "stay_close_to_weaver_nags" },
    { 0x5963D75D, "stay_down" },
    { 0x121EA77D, "stay_in_battle" },
    { 0x3B733A01, "stay_in_front_of_player_boat" },
    { 0x7EA8E230, "stay_put" },
    { 0xA97705D3, "stay_with_player" },
    { 0x9A745B6C, "stayatgoal" },
    { 0x7A8E520D, "stayed" },
    { 0xB09517AD, "stayed_in" },
    { 0xA93D5122, "stayfulltime" },
    { 0xE389BE36, "staying" },
    { 0x519BB070, "stayinplace" },
    { 0x31DDF7B8, "stayoncurrent" },
    { 0x9F5E1247, "stayontag" },
    { 0xFAC100F5, "stays" },
    { 0x05FA0E15, "staytime" },
    { 0xB052E2EF, "stb1" },
    { 0x3E4B73B4, "stb2" },
    { 0x644DEE1D, "stb3" },
    { 0xE61FEF24, "std" },
    { 0x38FCF680, "std_deviation" },
    { 0x93D97D00, "std_lerp_time" },
    { 0xAA721EDB, "steady" },
    { 0x26A86D32, "steady_fire" },
    { 0xAEAB5DE6, "steal" },
    { 0xBA6A1ED5, "steal_dist" },
    { 0xDD92A0CD, "steal_dist2" },
    { 0x5999947D, "steal_life_cooldown" },
    { 0xFF294346, "steal_life_from" },
    { 0x9473F585, "steal_weapon" },
    { 0xF7BEEA6F, "stealer" },
    { 0x0DC8401F, "stealer_monkey_exits" },
    { 0x79B93748, "stealer_monkey_spawns" },
    { 0xF7E1597A, "stealing" },
    { 0x579AB019, "steals" },
    { 0xAD06727A, "stealth" },
    { 0x660CCE3C, "stealth1_bad_dudes_wave1" },
    { 0xD8143D77, "stealth1_bad_dudes_wave2" },
    { 0xB211C30E, "stealth1_bad_dudes_wave3" },
    { 0x7A499813, "stealth2_bad_dudes_wave1" },
    { 0x084228D8, "stealth2_bad_dudes_wave2" },
    { 0x3DBC6F0A, "stealth_achievement" },
    { 0xB0523653, "stealth_actors" },
    { 0xE53CDDB7, "stealth_ai" },
    { 0xCE93D770, "stealth_ai_alert_functions_default" },
    { 0xEBD7F2C7, "stealth_ai_alert_functions_set" },
    { 0xDCC31879, "stealth_ai_awareness_functions_default" },
    { 0xE75644F2, "stealth_ai_awareness_functions_set" },
    { 0x2AC6DC10, "stealth_ai_behavior" },
    { 0x9779F7C0, "stealth_ai_clear_custom_idle_and_react" },
    { 0x26090581, "stealth_ai_clear_custom_react" },
    { 0x6FE221DE, "stealth_ai_corpse_functions_default" },
    { 0x2D1F465D, "stealth_ai_corpse_functions_set" },
    { 0xB15300FA, "stealth_ai_idle_and_react" },
    { 0x1F0FFB4C, "stealth_ai_logic" },
    { 0x84C01EC4, "stealth_ai_reach_and_arrive_idle_and_react" },
    { 0x198BBA07, "stealth_ai_reach_and_arrive_idle_and_react_proc" },
    { 0x8B63F1EA, "stealth_ai_reach_idle_and_react" },
    { 0x9C2496F1, "stealth_ai_reach_idle_and_react_proc" },
    { 0x97794319, "stealth_ai_state_functions_default" },
    { 0x053B9792, "stealth_ai_state_functions_set" },
    { 0x05411235, "stealth_alert" },
    { 0xAFD1A462, "stealth_alerted" },
    { 0x23E0D772, "stealth_break" },
    { 0x2EC94AF8, "stealth_bridge_vc" },
    { 0x4553AD58, "stealth_broke" },
    { 0x6E659F96, "stealth_broken" },
    { 0x1AAD4492, "stealth_checker" },
    { 0x797E3610, "stealth_condition_checker" },
    { 0x53172B88, "stealth_corpses" },
    { 0x3C0B1642, "stealth_cover_broken" },
    { 0xB93E1DCA, "stealth_crate_trigger_think" },
    { 0x27C05AA7, "stealth_detect_corpse_range_default" },
    { 0x13D75010, "stealth_detect_corpse_range_set" },
    { 0xBB976C5F, "stealth_detect_ranges_default" },
    { 0x6FBA0038, "stealth_detect_ranges_set" },
    { 0xA1C73E2C, "stealth_dive_under" },
    { 0x1296F46E, "stealth_drone1" },
    { 0xF57D0FAF, "stealth_enemies" },
    { 0xD3B41FAC, "stealth_enemy_cautious_approach" },
    { 0x7BE07407, "stealth_enemy_detect_back" },
    { 0xA3396028, "stealth_enemy_detect_corpse_back" },
    { 0xA4F524A2, "stealth_enemy_detect_corpse_front" },
    { 0x46BF7D2B, "stealth_enemy_detect_front" },
    { 0x879CFBE2, "stealth_enemy_detect_shot" },
    { 0xC43934E9, "stealth_enemy_endon_alert" },
    { 0x8A0F7ABD, "stealth_enemy_init_health" },
    { 0xDF0A2DDB, "stealth_enemy_waittill_alert" },
    { 0xBA4A80EE, "stealth_environment_default" },
    { 0xC0BFECD4, "stealth_environment_foliage" },
    { 0x4844928D, "stealth_environment_rain" },
    { 0xE8740FA3, "stealth_evade_window" },
    { 0xC8814633, "stealth_event" },
    { 0x34A33375, "stealth_event_setup" },
    { 0xFAF80147, "stealth_fade_complete" },
    { 0xC927BC7D, "stealth_fail" },
    { 0xC12672DD, "stealth_fail_window_crouch" },
    { 0xB44F0753, "stealth_fail_with_noise" },
    { 0x5E57E848, "stealth_foliage_hud" },
    { 0xF602577E, "stealth_foliage_hud_value" },
    { 0xA5A34E2A, "stealth_foliage_settings" },
    { 0xF772D6C0, "stealth_friendly_movespeed_scale_default" },
    { 0x6C108017, "stealth_friendly_movespeed_scale_set" },
    { 0xF92EB8B1, "stealth_friendly_stance_handler_distances_default" },
    { 0xAE54581A, "stealth_friendly_stance_handler_distances_set" },
    { 0x78517F74, "stealth_goal" },
    { 0x0018F776, "stealth_goal_name" },
    { 0xCBB66D02, "stealth_guy" },
    { 0x3175369B, "stealth_heli_setup" },
    { 0x54703EFA, "stealth_helicopter_time" },
    { 0x9F2CE02B, "stealth_hud_alert" },
    { 0x7CADF831, "stealth_hud_alert_value" },
    { 0xF7A8EEC7, "stealth_hud_corpse" },
    { 0x9FBA64E5, "stealth_hud_corpse_value" },
    { 0xE9A6B70B, "stealth_hud_hidden" },
    { 0x71D9ED51, "stealth_hud_hidden_value" },
    { 0xC1DE92CE, "stealth_hud_spotted" },
    { 0x38D491DC, "stealth_hud_spotted_value" },
    { 0x485BE71B, "stealth_hut_kill" },
    { 0x07828B49, "stealth_hut_regroup" },
    { 0x24EDBD6A, "stealth_idles" },
    { 0xD9B46637, "stealth_init" },
    { 0x42C675C8, "stealth_init_spawn_func" },
    { 0xA053D4E1, "stealth_insure_enabled" },
    { 0xFA3DC2AD, "stealth_intro" },
    { 0x72E533C8, "stealth_kill_ai_generic_spawn" },
    { 0x36EC024B, "stealth_log_monitor_player_crouch" },
    { 0xC7A21A8E, "stealth_log_stop_monitoring_crouch" },
    { 0x696E4316, "stealth_nocorpselogic" },
    { 0x40ED5126, "stealth_num_times_player_seen" },
    { 0x3A86F153, "stealth_part_one" },
    { 0x303FF572, "stealth_reconstruct_ents" },
    { 0x2597BB2E, "stealth_rice_action_start" },
    { 0x2832DD2A, "stealth_safe_to_save" },
    { 0xE8C6F1EF, "stealth_sampan_action_fail" },
    { 0xC28BB08B, "stealth_sampan_action_fail_water" },
    { 0x18FB9D55, "stealth_sampan_action_start" },
    { 0xABB670FB, "stealth_sampan_complete" },
    { 0x5170B332, "stealth_sampan_kill" },
    { 0x443616D6, "stealth_sampan_musicstate" },
    { 0xFECA479B, "stealth_search_for_player" },
    { 0xABB166BA, "stealth_settings" },
    { 0xA3247A69, "stealth_shadow_ai_in_volume" },
    { 0x49A3F37D, "stealth_shadow_volumes" },
    { 0x5B9824AC, "stealth_spotted" },
    { 0x5E3C6023, "stealth_spotted_time_scale" },
    { 0xA9D7364E, "stealth_start_trigger" },
    { 0x46E30553, "stealth_successful" },
    { 0x6D0CE282, "stealth_surprise_vc" },
    { 0xAB668F53, "stealth_swimming_action" },
    { 0x9F45226A, "stealth_swimming_barnes" },
    { 0x8C4687C7, "stealth_trigger" },
    { 0x0A09B683, "stealth_trigger_checker" },
    { 0x736C4D8A, "stealth_trigs" },
    { 0x72FBF093, "stealth_visibility_hud" },
    { 0x32B12479, "stealth_visibility_hud_value" },
    { 0xE7C455C9, "stealth_visible_distance" },
    { 0x5E2A7E3D, "stealth_visible_dot" },
    { 0x5CE1DABE, "stealth_water_reveal" },
    { 0x64AD4954, "stealth_whizby_reaction" },
    { 0xF98358B4, "stealthactors" },
    { 0xE06B782F, "stealthbreak" },
    { 0x1FB96F31, "stealthchopperhackertoolradius" },
    { 0x2853E4A0, "stealthchopperhackertooltimems" },
    { 0x6F359032, "stealthgroups" },
    { 0xA5E5ED45, "stealthidleterminate" },
    { 0x64814B56, "stealthreactcondition" },
    { 0x40794849, "stealthreactstart" },
    { 0xCD2144B8, "stealthreactterminate" },
    { 0xB09DE97F, "stealthy" },
    { 0xD4ADD84F, "steam" },
    { 0xD0075CB8, "steam_bone" },
    { 0x8203DA31, "steam_ent" },
    { 0x7AAB5A45, "steam_ent_a" },
    { 0xADA11270, "steam_fx" },
    { 0xB2629994, "steam_go" },
    { 0x827E2B1B, "steam_large_1" },
    { 0xCE207160, "steam_rusher_left_crouch" },
    { 0x6B4ECFCC, "steam_rushers" },
    { 0xE4BDFECA, "steam_rushers_back" },
    { 0x14B179D4, "steam_rushers_front" },
    { 0xDB79BD9B, "steam_rushers_right" },
    { 0x0A7585EF, "steam_small_1" },
    { 0x986E16B4, "steam_small_2" },
    { 0xBE70911D, "steam_small_3" },
    { 0xFEDB8975, "steam_spots" },
    { 0x82B57942, "steamname" },
    { 0xBD5F2CF1, "steamreactions" },
    { 0x490F5BF0, "stearing" },
    { 0x81BF88F2, "steel" },
    { 0x62AB2CF1, "steel_tons_needed" },
    { 0xBCA42EE6, "steepl" },
    { 0x5DFFF79C, "steer" },
    { 0x778EABFE, "steer_factor" },
    { 0x2DB02C6F, "steer_max" },
    { 0xC2B2B711, "steer_min" },
    { 0xC2F692EC, "steering" },
    { 0x8EF47050, "steering_blend_time" },
    { 0xEEEE561D, "steering_loop" },
    { 0x7B6CFF29, "steering_origin" },
    { 0xA6499600, "steering_wheel" },
    { 0xFE3A6ED7, "steervalue" },
    { 0x11FB02CA, "steet" },
    { 0xCC4A0FCA, "steet_ambush_outside_spawn_func" },
    { 0xD51E9F03, "steet_dialogue" },
    { 0x2DEC2454, "steez" },
    { 0xFC1B7840, "stefan" },
    { 0x0F46029E, "steiener" },
    { 0x49F82829, "steiner" },
    { 0xAD0A79F8, "steiner_blood_drip_position" },
    { 0x7F968184, "steiner_door" },
    { 0x533C7905, "steiner_door_clip" },
    { 0xA1199443, "steiner_door_node" },
    { 0x8D81A909, "steiner_door_use_trig" },
    { 0x4DEBF270, "steiner_hall_door" },
    { 0x0A19C7D3, "steiner_hall_walk" },
    { 0x929443C1, "steiner_lab" },
    { 0x2503A553, "steiner_nazibase" },
    { 0x6E373FA7, "steiner_office_door" },
    { 0xDBCAB683, "steiner_office_start_main" },
    { 0x116A2B01, "steiner_spawnfunction" },
    { 0x4AECB188, "steiner_window" },
    { 0x0828D5A0, "steiners" },
    { 0x537A3E83, "steiners_hallway" },
    { 0x43B5BFBB, "steiners_office" },
    { 0xF7046122, "steiners_office_break_glass" },
    { 0x89CB310E, "steiners_office_breakin" },
    { 0xA4B0CEB5, "steiners_office_crack_glass" },
    { 0xF35C4F48, "steiners_office_freeze_anims" },
    { 0x027CFE18, "steiners_office_hit_glass" },
    { 0x6F3FE84A, "steiners_office_hit_glass2" },
    { 0x33227A27, "steiners_office_hudson_vo" },
    { 0x07BAC52B, "steiners_office_lift_fuse" },
    { 0x9161FE0A, "steiners_office_mantle_window" },
    { 0x4D5235E3, "steiners_office_mason_fire" },
    { 0x9C91726F, "steiners_office_move_fuse" },
    { 0x71D58526, "steiners_office_objectives" },
    { 0x50903DC7, "steiners_office_tackle_mason" },
    { 0xB2BBA874, "steiners_office_weaver_vo" },
    { 0x46340243, "steiners_voice" },
    { 0x86B53547, "step" },
    { 0x24D83EA7, "step_angle" },
    { 0x79CBFA2E, "step_dist" },
    { 0x0DDE156A, "step_down" },
    { 0x4578E698, "step_down_human" },
    { 0x4B9628F7, "step_height" },
    { 0x92A26805, "step_size" },
    { 0x51359FCF, "step_sound" },
    { 0x54A9F08D, "step_time" },
    { 0x24B6BAA1, "step_up" },
    { 0x58DD706F, "step_up_human" },
    { 0x65CA45E3, "stepamount" },
    { 0x1F230408, "stepanim" },
    { 0x1B6A036E, "stepdistance" },
    { 0x30B75EB0, "stephen" },
    { 0x853DEC33, "stepintoinitialize" },
    { 0xBF05158A, "stepintoterminate" },
    { 0xC1339AEA, "stepmultiplier" },
    { 0xA97D5735, "stepout" },
    { 0xB359BCF1, "stepoutandhidespeed" },
    { 0x6C33D257, "stepoutandshootenemy" },
    { 0x062911CA, "stepoutanim" },
    { 0x29EABD30, "stepoutdistance" },
    { 0xFB0A3607, "stepoutinitialize" },
    { 0xD9643255, "stepoutpos" },
    { 0xD540FC2D, "stepoutposes" },
    { 0x740F1A04, "stepouts" },
    { 0x4D716EF6, "stepoutterminate" },
    { 0xC80F111D, "stepouttimearray" },
    { 0xFE67B602, "stepped" },
    { 0x81426E28, "stepped_in" },
    { 0x0B26DC37, "steppeddir" },
    { 0xC97B7BD6, "steppedoutofcover" },
    { 0x867D826A, "steppedoutofcovernode" },
    { 0x5056B1E1, "steppedouttime" },
    { 0x1782B8D3, "stepping" },
    { 0xDB2FCB3E, "steps" },
    { 0x5661222D, "steps_per_stage" },
    { 0x8D7E56DC, "stepsize" },
    { 0x9A258A93, "stepspersecond" },
    { 0xE06F3007, "stepssofar" },
    { 0x683C8F54, "steptime" },
    { 0xC5F96664, "stepto" },
    { 0x000F6AB0, "steptrigs" },
    { 0x0AEB0481, "stereo" },
    { 0x8C628032, "stereo3d_lerp_depth" },
    { 0x642B1FE1, "stern" },
    { 0x14C74A3C, "stern_enemies" },
    { 0x257B22B0, "stern_enemies_a" },
    { 0x71801782, "stern_enemies_c" },
    { 0xB3F8DC09, "stern_levels" },
    { 0x5A697D3C, "stern_port_node" },
    { 0xC4C43E93, "stern_starboard_node" },
    { 0xEEAB4BA3, "stet" },
    { 0x8FD0019E, "steve" },
    { 0x4C35F6DB, "steve_cleanup" },
    { 0xC9660EEF, "stg44" },
    { 0x1E96DC04, "sthread" },
    { 0xBCBD88B7, "sthreads" },
    { 0xF29ABDE8, "stiarcase" },
    { 0x03FC176B, "stick" },
    { 0x87459393, "stick_camera" },
    { 0xD3627562, "stick_indicator_watch_early_shutdown" },
    { 0x02641FF4, "stick_layout" },
    { 0x303B0C39, "stick_movement" },
    { 0xEE8733E1, "stick_player" },
    { 0x223C35CF, "stick_vel" },
    { 0x19567C35, "sticking" },
    { 0x76B3B14A, "sticks" },
    { 0xF23B75DC, "stickspeed" },
    { 0xCB5B4D86, "sticksstones_end" },
    { 0x48127390, "sticksstones_main" },
    { 0x44F10705, "sticktraps" },
    { 0xFA9AE930, "sticky" },
    { 0x07985FFA, "sticky_explode" },
    { 0xE80CF34F, "sticky_grenade" },
    { 0x51AB3951, "sticky_grenade_damage" },
    { 0x3B8B5281, "sticky_grenade_hint" },
    { 0x1EDCFF76, "sticky_grenade_think" },
    { 0xD30FD7E9, "sticky_grenade_tracking" },
    { 0x4D111DB2, "sticky_indicator" },
    { 0x4F319863, "sticky_org" },
    { 0xC47745C9, "sticky_shutdown" },
    { 0x3962A843, "sticky_threw" },
    { 0x327DD8A9, "stickygrenadetracking" },
    { 0x2B574306, "stickyimagemodel" },
    { 0x724040EF, "stickyobjectradius" },
    { 0x217B2241, "stiener" },
    { 0x1B2BB1D1, "still" },
    { 0x1B473A19, "still_afloat" },
    { 0x593A71B7, "still_alive" },
    { 0x150DDE35, "still_avoiding" },
    { 0x7F26225B, "still_too_close" },
    { 0xBCCCFBA6, "stillpassing" },
    { 0xF3940C57, "stillupdating" },
    { 0xFC803D38, "sting" },
    { 0x2F198D8D, "stinger" },
    { 0xB426E172, "stinger_02" },
    { 0x84A4FB3A, "stinger_crew_get_target" },
    { 0xD919574B, "stinger_crew_shoot" },
    { 0x22F871FE, "stinger_defender_logic" },
    { 0x9F0586AF, "stinger_explode" },
    { 0x522FF84A, "stinger_explosion_radius" },
    { 0xD3035244, "stinger_ff_hint" },
    { 0xC6E2AC40, "stinger_fired" },
    { 0x381407FD, "stinger_fired_at_me" },
    { 0x1456CC1B, "stinger_hint" },
    { 0x1F531283, "stinger_hit_chopper" },
    { 0x9108C3D7, "stinger_hits_uaz" },
    { 0x5C4B79CE, "stinger_irt_cleartarget" },
    { 0xFFCA53F9, "stinger_irt_off" },
    { 0xBCE873F1, "stinger_mansion_doors" },
    { 0x87D48242, "stinger_me" },
    { 0xE24C3722, "stinger_min_distance" },
    { 0x246AF966, "stinger_nag" },
    { 0x38DFE666, "stinger_origin" },
    { 0x31C5312C, "stinger_spawner" },
    { 0x4B0B4131, "stingerdone" },
    { 0xD08E6334, "stingerent" },
    { 0x31CADFDC, "stingerfirednotify" },
    { 0x4E0F5AD6, "stingerid" },
    { 0xF14A1516, "stingerirtloop" },
    { 0x3B932672, "stingerlockdetected" },
    { 0xA6C78AA6, "stingerlockfinalized" },
    { 0x26D9DFB5, "stingerlocksound" },
    { 0x39D1B6CF, "stingerlockstarted" },
    { 0xD31A1EFF, "stingerlockstarttime" },
    { 0x2845C66F, "stingerlostsightlinetime" },
    { 0x1FBB720C, "stingers" },
    { 0x6217D666, "stingertarget" },
    { 0xBA6760B3, "stingertoggleloop" },
    { 0x5BFFC47B, "stingerwaitforads" },
    { 0x64765394, "stink" },
    { 0xE4CB5159, "stink_change_decrement" },
    { 0x8CF4A191, "stink_change_increment" },
    { 0x243D128A, "stink_ent" },
    { 0x949926A3, "stink_ent_pool" },
    { 0xD7355986, "stink_react_vo" },
    { 0x94438504, "stink_time_entered" },
    { 0x2063AFE7, "stink_time_exit" },
    { 0x44A69AC3, "stink_zombie_array_add" },
    { 0x0D134207, "stinks" },
    { 0x90FA79ED, "stinky" },
    { 0xB10E6555, "stlth_x" },
    { 0xB640479E, "stnd" },
    { 0x8773A6CD, "stndo" },
    { 0x02434819, "stock" },
    { 0x7C71464E, "stock_ammo" },
    { 0xEB3510A8, "stock_amount" },
    { 0xC9DC24C2, "stock_amt" },
    { 0x3ED36AAC, "stock_percentage" },
    { 0xB4E0AD66, "stock_weapon_caches" },
    { 0x983FF293, "stockammo" },
    { 0x627D45EB, "stockammotogive" },
    { 0xD18E7326, "stockcount" },
    { 0xB6E5D293, "stockcountalt" },
    { 0x360A3646, "stocked" },
    { 0xF34FF5F1, "stockmax" },
    { 0x407C5189, "stockpile" },
    { 0x180B4FF6, "stole" },
    { 0x0AF9C0FC, "stolen" },
    { 0xEBD4A50C, "stolen_gadget_ready_line_count" },
    { 0xD2351BE9, "stolen_life" },
    { 0xF706E4E0, "stolendialogindex" },
    { 0xB8E167F8, "stolenheroweapon" },
    { 0x6E219DA7, "stoll" },
    { 0x87942120, "stomp" },
    { 0x299069B8, "stomping" },
    { 0x1F7153CB, "stomps" },
    { 0x17B4854C, "stone" },
    { 0xB04AD3CF, "stones" },
    { 0x4CE0AA62, "stood" },
    { 0x7CF47DAA, "stool" },
    { 0xB25F4852, "stoolpush" },
    { 0xFCF56AB5, "stop" },
    { 0xCE9DE5D2, "stop all gunfireloopfx" },
    { 0x87140C16, "stop current floodspawner" },
    { 0xDE2CA008, "stop debug " },
    { 0xAA09DE02, "stop debugline " },
    { 0xF9604459, "stop fx" },
    { 0x38F853E7, "stop hover" },
    { 0x117FE2F2, "stop path" },
    { 0xD175A918, "stop random_spread" },
    { 0xF886F54C, "stop sound" },
    { 0xF6285749, "stop trail" },
    { 0x6518A180, "stop2_exposed" },
    { 0x7B3C0817, "stop3dcinematic" },
    { 0x31D06908, "stop_" },
    { 0xF93F7891, "stop_1" },
    { 0x1F41F2FA, "stop_2" },
    { 0x52DC43E2, "stop_3dprint" },
    { 0x6B46E7CC, "stop_4" },
    { 0x878AC2F3, "stop_aa_audio_failsafe" },
    { 0x6F45265D, "stop_aa_gun" },
    { 0x164D53E8, "stop_ac130" },
    { 0x8864A771, "stop_accumulation" },
    { 0xA0C8EB0D, "stop_acid_death_fx" },
    { 0x55F0B974, "stop_acquire_acquire_enemy" },
    { 0x004ABD66, "stop_action" },
    { 0x3680263E, "stop_adjusting_enemy_accuracy" },
    { 0xB87FEC4E, "stop_adjusting_vision" },
    { 0x5829BA5B, "stop_admin_mgs" },
    { 0x1BE58DE3, "stop_aft_track" },
    { 0xB296ED69, "stop_after_duration" },
    { 0x2D0F906E, "stop_ai_fake_shoot" },
    { 0x8F082173, "stop_aim" },
    { 0x28C4CF9B, "stop_aim_at_target" },
    { 0xBFF3E2E6, "stop_aiming_at_enemy" },
    { 0x626F79B4, "stop_air_support" },
    { 0xD32B0990, "stop_air_targetting" },
    { 0x5C0970D9, "stop_airfield_bombers" },
    { 0x04E688DE, "stop_airfield_planes" },
    { 0xC2C9CB24, "stop_airfield_temp_kill_axis" },
    { 0x1B17524B, "stop_airfield_trucks" },
    { 0xF860BB74, "stop_airfield_vehicles" },
    { 0x1105FAE7, "stop_airplane_destabilize" },
    { 0xB3637A4A, "stop_airstrike_reminders" },
    { 0x27AB45E9, "stop_alarm_lights" },
    { 0x9C0A5BF9, "stop_alarms_on_ender" },
    { 0x036EA8D7, "stop_alerting_friends_about_enemies" },
    { 0x0C1F99BF, "stop_align" },
    { 0x12A1583A, "stop_all_digger_rumble" },
    { 0xAECB2082, "stop_all_idle" },
    { 0x57512645, "stop_all_lines" },
    { 0x5E11F333, "stop_all_mortar_loops" },
    { 0x0219F26F, "stop_all_node_info" },
    { 0x6A055CB6, "stop_alley_tank_fire_loop" },
    { 0xBC1BB141, "stop_allied_drones" },
    { 0xF14760CD, "stop_ally_quadrotor_respawn" },
    { 0x3B5EE4E0, "stop_amb_convo" },
    { 0xAF9B5B0A, "stop_ambient_activity_warehouse_street" },
    { 0x0F453F0E, "stop_ambient_activity_warehouse_street_left" },
    { 0xFCB83195, "stop_ambient_behavior" },
    { 0x99076EDA, "stop_ambient_console_lights" },
    { 0xC3F333BB, "stop_ambient_explosions" },
    { 0x8CEADF37, "stop_ambient_mortars" },
    { 0x36F8E528, "stop_ambient_shooting_at_boats" },
    { 0x74CE6953, "stop_ambients" },
    { 0x109BA4AD, "stop_ambush_loop" },
    { 0x9BAD4968, "stop_ambush_music" },
    { 0x247990C2, "stop_ammo_tracking" },
    { 0xD0BCA29E, "stop_and_delete_heli_crash_sound" },
    { 0x6F069816, "stop_and_wait_for_flag" },
    { 0xD72ADBD7, "stop_anim" },
    { 0xA4DD77E4, "stop_anim_loop" },
    { 0xFE3C15DB, "stop_anim_scripted_on_death" },
    { 0x27C0193F, "stop_anim_until_player_looks" },
    { 0xFA91A730, "stop_animation_if_player_runs_past" },
    { 0xD9FABE6E, "stop_animmode" },
    { 0xD5F1818E, "stop_anims" },
    { 0x68C4D9E9, "stop_animscripted_on_damage" },
    { 0x540DA0CC, "stop_arena_explosions" },
    { 0x135510C4, "stop_arty_fire_loop" },
    { 0xB9BC645F, "stop_asad_recording" },
    { 0x43C1A568, "stop_at_checkpoint" },
    { 0x3D6563DA, "stop_at_checkpoint2" },
    { 0xB2EDFC9B, "stop_at_goal" },
    { 0x2DD8D916, "stop_at_halftrack" },
    { 0x2A94D176, "stop_at_node" },
    { 0xAED792EE, "stop_at_reverse_nodes" },
    { 0xDE827AFF, "stop_at_spline_end" },
    { 0x894DDF9A, "stop_at_tank" },
    { 0xF2C4004C, "stop_attack" },
    { 0x1106DFF7, "stop_attack_pattern" },
    { 0x012CDFC2, "stop_attack_this_tank" },
    { 0x8FCA39B9, "stop_attackbutton_hold_think" },
    { 0xD521CFD2, "stop_attacking_generator" },
    { 0x24E556AF, "stop_attacking_tank" },
    { 0xAA8EE05C, "stop_attacking_troops" },
    { 0x8E3A3301, "stop_attracting_zombies" },
    { 0x7F98B85C, "stop_audio_delete" },
    { 0x1C069D6C, "stop_audio_ent" },
    { 0xB78E92BF, "stop_axis_drones" },
    { 0x3BB65C39, "stop_back" },
    { 0xD61D76A7, "stop_bad_path_failsafe" },
    { 0x20623296, "stop_badplace" },
    { 0xD3E70075, "stop_bank_teller" },
    { 0x88F7B6B9, "stop_banzai_print" },
    { 0xABCDF9E4, "stop_banzai_thread" },
    { 0x3452A9F2, "stop_banzai_yell" },
    { 0x618253EF, "stop_barn_early_interruption" },
    { 0x35CF3884, "stop_barrel" },
    { 0x58C02985, "stop_barrel_loop" },
    { 0xB8E008F6, "stop_base_attack" },
    { 0x6FA0B87B, "stop_base_exp" },
    { 0xEA312817, "stop_base_impacts" },
    { 0xCF5EDC80, "stop_basin_friendly_strat" },
    { 0xD6F77979, "stop_bazooka_spawn" },
    { 0x00DE8A77, "stop_beach_vehicles" },
    { 0x39306302, "stop_beam_holding_idle" },
    { 0x4E633BD7, "stop_beam_resting_idle" },
    { 0xA688AD5C, "stop_beeping" },
    { 0x1C1A537A, "stop_before_shrine_waittill" },
    { 0x21E7E75B, "stop_behavior_check" },
    { 0x08D62DBC, "stop_being_careful" },
    { 0x07700D1D, "stop_being_stupid" },
    { 0xDB9CC0FD, "stop_berm_idle" },
    { 0x19310172, "stop_berserk" },
    { 0xCDA6E934, "stop_big_guns" },
    { 0xEE6FDDB4, "stop_big_splash" },
    { 0xD0FF2DD8, "stop_bigdog_scripted_fx_threads" },
    { 0xE62583C9, "stop_bink_monitor_randomize" },
    { 0x9DAD5A58, "stop_bink_on_hud" },
    { 0x01BCF775, "stop_blade_sounds" },
    { 0x07CDFAE2, "stop_blinking_crosshairs" },
    { 0x214343EE, "stop_blinky_light" },
    { 0x59F2FD63, "stop_blocker_think" },
    { 0x50824B08, "stop_blood" },
    { 0x8A09FB89, "stop_blur_player" },
    { 0x85FC6175, "stop_boat_audio" },
    { 0x081912BE, "stop_boat_on_damage" },
    { 0x1D887B9E, "stop_boat_sim" },
    { 0x4ACBF9A1, "stop_boat_underfire" },
    { 0x7D9E8700, "stop_bombing" },
    { 0x26D7266E, "stop_boost_camera_fx" },
    { 0x878CC1C0, "stop_bow_track" },
    { 0x0F7B7B2D, "stop_breadcrumb_obj" },
    { 0xE1C93CCA, "stop_breadcrumbs" },
    { 0x38BD39CE, "stop_breath" },
    { 0xC153EE31, "stop_bridge_launchers" },
    { 0x9AE4AC7C, "stop_brim_drones" },
    { 0x8B40EC50, "stop_brim_fights" },
    { 0xED428A51, "stop_buildable_fx" },
    { 0xF22C3E80, "stop_bullet_shield" },
    { 0x4F8A234E, "stop_bunker_defenders" },
    { 0xDA5021D6, "stop_burning_loop" },
    { 0x65D386B0, "stop_burst_fire_unmanned" },
    { 0xDD017769, "stop_bus_attack" },
    { 0x90E979F6, "stop_bus_wait" },
    { 0x83B39244, "stop_button_mash" },
    { 0x90C69A77, "stop_bwalla" },
    { 0x739E946D, "stop_cache_attack" },
    { 0x862725CE, "stop_camera_anims" },
    { 0x8D9739F7, "stop_camera_control" },
    { 0x25F56D34, "stop_camera_tweak" },
    { 0x3BFFAFBF, "stop_camera_wobble" },
    { 0x45E781BC, "stop_camping_function" },
    { 0x25861390, "stop_castle_spawners" },
    { 0x5E605B36, "stop_casualty_tracking" },
    { 0xD7192CBE, "stop_cave_defenders" },
    { 0x2F136DF8, "stop_cave_defenders2" },
    { 0xA7252A2E, "stop_cave_mg" },
    { 0x2B0335A4, "stop_ch46_idle" },
    { 0xCC393095, "stop_challenge_ingame_time_tracking" },
    { 0x4D08AFDE, "stop_chamber" },
    { 0xD869CB61, "stop_chamber3_5" },
    { 0x745C7E07, "stop_chandeliers_shake" },
    { 0x0B2A621A, "stop_charge_bar" },
    { 0xA6C015E1, "stop_charge_bar_thread" },
    { 0x2EAD836B, "stop_chase_dialogue" },
    { 0xFE0D62B1, "stop_chase_dist" },
    { 0x48C031C7, "stop_chase_uaz_launch" },
    { 0x9D436E7C, "stop_chasing_chaff" },
    { 0xB9521456, "stop_chasing_tank" },
    { 0x4F916E79, "stop_chasing_the_sky" },
    { 0x0CFD9E60, "stop_check" },
    { 0xE8CCEE48, "stop_check_walk" },
    { 0x219E0977, "stop_checkin_scanner_fx" },
    { 0x1BD5A869, "stop_checking_for_flanking" },
    { 0xDD6DF64B, "stop_checking_node_noteworthy" },
    { 0x4A64C3C3, "stop_checking_targets" },
    { 0xC882447D, "stop_cheer_vox" },
    { 0x42013FA4, "stop_chi_wave_3_shooting" },
    { 0xC28410C4, "stop_chopping" },
    { 0xAFC6ED97, "stop_cinematic" },
    { 0xB03E8F34, "stop_circle" },
    { 0x6CE579B6, "stop_circle_pulse" },
    { 0xD938C5EB, "stop_circling_area" },
    { 0x776F3241, "stop_civ_spawns" },
    { 0xD1BEBD93, "stop_civilian_move_anim" },
    { 0x3C71C146, "stop_civilians" },
    { 0xC2D86DC7, "stop_claw_grenade_turret" },
    { 0x3C26C995, "stop_claw_switch_think" },
    { 0x2B765265, "stop_cliff_nag" },
    { 0x6F4B300C, "stop_cliffgun" },
    { 0x243DEBBE, "stop_clounds" },
    { 0xB2FCF9AD, "stop_club_fx" },
    { 0x6E719729, "stop_cobra_hellfire_locking_sound" },
    { 0xCAB8712E, "stop_coll" },
    { 0x51B5CD1B, "stop_collectible_loop" },
    { 0x76060764, "stop_color_forcegoal" },
    { 0x66168952, "stop_color_logic" },
    { 0x2DA78207, "stop_color_move" },
    { 0xFD5E9EE1, "stop_combining_sunlight_and_brightness" },
    { 0xEFDD9629, "stop_comm_idle" },
    { 0xF2C39B68, "stop_comm_intro_loop" },
    { 0x07DCD0CC, "stop_contextual_melee" },
    { 0x5266BED5, "stop_contextual_melee_idle" },
    { 0x9C6AD9AD, "stop_convoy_fire" },
    { 0x51C5D233, "stop_convoy_hill_fire" },
    { 0x14A17A44, "stop_cooldown_fx" },
    { 0x192CAD9C, "stop_coral_loop" },
    { 0xEA4B818F, "stop_cornerr" },
    { 0xB7FB6A59, "stop_countdown" },
    { 0x116B66BF, "stop_countdown_timer" },
    { 0x2582157E, "stop_counting_guys" },
    { 0x00AB436F, "stop_covering" },
    { 0x7D065586, "stop_coverprint" },
    { 0x5F3C769A, "stop_cowbell" },
    { 0xAF01BFA2, "stop_cqb" },
    { 0xA54F0858, "stop_cqb_aim" },
    { 0x15AC6F99, "stop_crash_dust_fx" },
    { 0x55177C6A, "stop_crash_loop_sound" },
    { 0x3AC1669B, "stop_crawl_anim" },
    { 0xE0D3CB10, "stop_crawler_watch" },
    { 0x16E6677F, "stop_createdynents" },
    { 0x93FDA8BD, "stop_credits_button" },
    { 0x9CF78C04, "stop_ctw_ric_guillotine_glow" },
    { 0xE5A1E464, "stop_current_shoot_strat" },
    { 0x37806737, "stop_custom_dds" },
    { 0xF36DA0A2, "stop_cylinder" },
    { 0x1968D8FB, "stop_damage" },
    { 0xC68BCA9F, "stop_damage_mirror" },
    { 0xCFB2FADB, "stop_damage_watch" },
    { 0xEC9C3ACD, "stop_damaged_tanker" },
    { 0xED0B781D, "stop_dance" },
    { 0x6EAA383B, "stop_dc_turret_fire" },
    { 0xF8408000, "stop_dds_dialogue_print" },
    { 0x68E7E205, "stop_death_anim_short_circuit" },
    { 0xC742F3B1, "stop_death_fail" },
    { 0xEFD5BCAF, "stop_death_loop" },
    { 0x94A71B49, "stop_death_spin" },
    { 0x2989A23B, "stop_death_think" },
    { 0x4F507D9D, "stop_death_thread" },
    { 0x32A18C7C, "stop_debris_approach" },
    { 0x9DFFEE8E, "stop_debug_blocker" },
    { 0x92A07F92, "stop_debug_breadcrumbs" },
    { 0x679BBDE9, "stop_debug_position" },
    { 0x607EC7FC, "stop_debugging_unaware" },
    { 0x231D1326, "stop_deciding_how_to_shoot" },
    { 0x757CB1E3, "stop_decrease_extra_cam_fov" },
    { 0xBFA7584C, "stop_defalco_id" },
    { 0xCA3A6B18, "stop_default_behavior" },
    { 0x2271C2F5, "stop_default_drone_behavior" },
    { 0x77D9DB2A, "stop_defend_sm_think" },
    { 0x300DDB80, "stop_defend_spawners" },
    { 0x3A3A151F, "stop_delete_timer" },
    { 0x00FEDF59, "stop_detection" },
    { 0x89DBC928, "stop_dialog" },
    { 0x645FD9E1, "stop_dialog_text_box_cursor" },
    { 0xA1A6C8E3, "stop_dialog_text_input" },
    { 0x46589C1E, "stop_digger_rumble" },
    { 0x03B09EE3, "stop_digging_rumble" },
    { 0x505DA6E2, "stop_disabletrophy" },
    { 0xAB2D1276, "stop_disabling_the_hut_function" },
    { 0xD2245D9E, "stop_disarmthink" },
    { 0xB5006E12, "stop_display" },
    { 0x5602EA2C, "stop_displaying_boat_health" },
    { 0x536B5D01, "stop_dist_think" },
    { 0x31896A56, "stop_dive" },
    { 0x3BB46055, "stop_dive_node" },
    { 0xEDEF1D0F, "stop_dmg_watch_pipe" },
    { 0xF6F1733D, "stop_do_print3d_pos" },
    { 0x09EA92A5, "stop_dog_sound_on_death" },
    { 0xA3AE8A1B, "stop_dogfight_shake" },
    { 0xDFEEAEDB, "stop_donotetracks" },
    { 0x926DF699, "stop_dont_turn" },
    { 0x93CCE1F9, "stop_door_idle" },
    { 0xA81D56FD, "stop_down_loop" },
    { 0x276291F7, "stop_down_numbers" },
    { 0x8B62297F, "stop_drag_loop" },
    { 0x30044D1C, "stop_drag_shots" },
    { 0x8851ED94, "stop_draining_hero_weapon" },
    { 0x62D21BAB, "stop_draw_hud_on_death" },
    { 0x68CEA667, "stop_draw_line" },
    { 0xEAFE4154, "stop_draw_line_ent_to_pos" },
    { 0x680535FA, "stop_draw_notetrack" },
    { 0x76091CB0, "stop_draw_tank_locations" },
    { 0x5EFEF301, "stop_drawing_" },
    { 0xE559BCBA, "stop_drawing_all" },
    { 0x3934D3E3, "stop_drawing_axis_models" },
    { 0x5DAB6370, "stop_drawing_enemy_pos" },
    { 0x669EF4D7, "stop_drawing_fx" },
    { 0xE0A2A483, "stop_drawing_line" },
    { 0xF837D2DA, "stop_drawing_target" },
    { 0xD2C8E4D5, "stop_drawing_targets" },
    { 0x080ACA31, "stop_drawing_tracks" },
    { 0xA04109C9, "stop_drive_loop" },
    { 0x276E24B2, "stop_drive_particle_fx" },
    { 0x3CA4C6FB, "stop_driver_loop" },
    { 0x68E5D131, "stop_driving" },
    { 0xE172F8EA, "stop_drone_control_tones" },
    { 0x29E832FF, "stop_drone_loop" },
    { 0xD663C967, "stop_drone_loop_run_anim" },
    { 0x1FF1C3B2, "stop_drone_move" },
    { 0x7770C901, "stop_drone_respawning" },
    { 0x2A4A0847, "stop_drone_searcher_logic" },
    { 0x15CC0C62, "stop_drone_spawning_area" },
    { 0x76138AC0, "stop_drone_speed_adjust" },
    { 0x6633698F, "stop_drone_spotlight_detection" },
    { 0xA859ECAB, "stop_drone_think" },
    { 0xFEF0C9EB, "stop_drone_walk_anim_loop" },
    { 0xC13994E6, "stop_drone_yells" },
    { 0x3901E75F, "stop_dronenotetrack" },
    { 0x9B451CF0, "stop_drones_on_trig" },
    { 0xA085DEE0, "stop_dummy_anim_first_frame_think" },
    { 0x3F15BA15, "stop_dummy_anim_think" },
    { 0xD7FBB233, "stop_dummy_follow_path_think" },
    { 0x81DA5848, "stop_dummy_spawn_manager" },
    { 0x4F4101D5, "stop_dummy_step_aside_think" },
    { 0xC5F878BD, "stop_dummy_think" },
    { 0xD7776C9D, "stop_dummy_think_manager" },
    { 0x0BC88E74, "stop_dust" },
    { 0x87475E5D, "stop_dust_fx" },
    { 0x0A2BA32D, "stop_dynamic_run_speed" },
    { 0xA854C3F3, "stop_dynamic_run_speed_wait" },
    { 0x71350B69, "stop_dynent_cleanup" },
    { 0x24613DFB, "stop_dynent_monitor" },
    { 0xFD7557C3, "stop_dynents" },
    { 0x262C8A70, "stop_e1_flank_defenders" },
    { 0x812B44D5, "stop_e1c_mortar_struct" },
    { 0x54E64975, "stop_e1c_trench_mortars" },
    { 0x57DF74D9, "stop_e2_mortar_struct" },
    { 0xE9BF033D, "stop_e3_e4_tunnel" },
    { 0xC884894A, "stop_e5_fakefire" },
    { 0xB2F94BCA, "stop_effects" },
    { 0x5F38FC9B, "stop_egg_debug" },
    { 0xB79C8898, "stop_electric_cherry_reload_attack" },
    { 0x56D49CE7, "stop_elevator_sparks" },
    { 0x37D5F550, "stop_embers" },
    { 0x60A8D7D6, "stop_emergency_light" },
    { 0x1B5E6193, "stop_enabletrophy" },
    { 0x8D754C40, "stop_enemies" },
    { 0x3C8179B5, "stop_engage" },
    { 0x34913D92, "stop_engine_sound" },
    { 0xABA7133A, "stop_engineer_cooking" },
    { 0x73FA6241, "stop_engineer_idling" },
    { 0xF310AA8F, "stop_enginefire_fx" },
    { 0x663F874E, "stop_enginesmoke_fx" },
    { 0xB63CEB44, "stop_env_movie" },
    { 0xCB2E2441, "stop_escape" },
    { 0xFD3EA2AE, "stop_escape_tilt_gravity" },
    { 0x94994463, "stop_event1_fakefire" },
    { 0x41C02121, "stop_event1_recon" },
    { 0xC6C2E82A, "stop_event1_tutorial" },
    { 0xA4164346, "stop_event2_jogger_thread" },
    { 0x26193531, "stop_event_name_thread" },
    { 0x518B65EB, "stop_everything" },
    { 0x999E79E9, "stop_execution_half_shields" },
    { 0x9C3D6CD8, "stop_execution_timer" },
    { 0x50E4866E, "stop_exhaust" },
    { 0xAB268B3B, "stop_exhaust_fx" },
    { 0x8257D5F8, "stop_exit" },
    { 0xD10AB6FB, "stop_exit_tank" },
    { 0x67E7A937, "stop_exploder" },
    { 0xB79A7E1A, "stop_exploder_num" },
    { 0xD637FB18, "stop_exposed" },
    { 0xE31F0E22, "stop_exposure_flicker" },
    { 0x6EB3627E, "stop_extra_cam" },
    { 0xA8F9227E, "stop_f35_minigun" },
    { 0x121B9D25, "stop_f35_snap" },
    { 0xC29E533B, "stop_face" },
    { 0x812C5DD8, "stop_face_anims" },
    { 0x433AFAEB, "stop_facial_anims" },
    { 0xCD033840, "stop_facial_recognition" },
    { 0x919DBC9E, "stop_facing" },
    { 0xA14C70DA, "stop_fake_ambient_vehicles" },
    { 0xD01559F5, "stop_fake_arty_2" },
    { 0xB0F86F1A, "stop_fake_fire" },
    { 0x34398915, "stop_fake_gunfire_loop" },
    { 0x27ACC3E2, "stop_fake_water_tread" },
    { 0x6145D091, "stop_fakefire_mover" },
    { 0x51A5427A, "stop_fallback_interrupt" },
    { 0x5262A5AF, "stop_fan_trap_blood_fx" },
    { 0x88EC5DF7, "stop_feign" },
    { 0x1A6F9E5B, "stop_feign_interrupt" },
    { 0x5B85C046, "stop_fighter_magic_bullet_shield" },
    { 0xC719254E, "stop_find_flesh" },
    { 0xE58CF030, "stop_finding_flesh" },
    { 0x0D872864, "stop_fire" },
    { 0xE342508D, "stop_fire_barrage" },
    { 0xA35EF340, "stop_fire_sound_hack" },
    { 0x3665EB7D, "stop_fire_trig" },
    { 0xD5CE7AE1, "stop_fire_turret" },
    { 0x99A1F296, "stop_firescout_missiles" },
    { 0xD437089A, "stop_fireworks" },
    { 0xB779BBED, "stop_firing" },
    { 0x58955139, "stop_firing_1" },
    { 0x7E97CBA2, "stop_firing_2" },
    { 0xF7671A4C, "stop_firing_at_targets" },
    { 0xCD103D8E, "stop_firing_audio" },
    { 0xA207D9C0, "stop_firing_bullets_at_heli" },
    { 0xC1F8793D, "stop_firing_rpg" },
    { 0x5928964E, "stop_firing_turret" },
    { 0x8112836F, "stop_firing_when_shot" },
    { 0xB2389AD4, "stop_first_axis_drones" },
    { 0xC972C774, "stop_first_drones" },
    { 0xCDC29800, "stop_first_frame" },
    { 0x0AED86BD, "stop_first_mortars" },
    { 0x2A03E72E, "stop_flag" },
    { 0xE9E40B81, "stop_flagbearer_gunshots" },
    { 0x1465E5C2, "stop_flak88" },
    { 0xCA22F872, "stop_flak88_objective" },
    { 0x1FB410AD, "stop_flak88_remainingai" },
    { 0x845EE6B7, "stop_flame_damage" },
    { 0x3FA521E0, "stop_flame_sounds" },
    { 0x545F1E9A, "stop_flamebunker_death_loop" },
    { 0x2E033774, "stop_flamer_fake_death" },
    { 0xF7F1D88E, "stop_flamer_target_building" },
    { 0x5EC77790, "stop_flanker_behavior" },
    { 0xD81F26B4, "stop_flare" },
    { 0x09604315, "stop_flash_perk" },
    { 0x54884AB4, "stop_flashbang_effect" },
    { 0xA51DC9BA, "stop_flashing" },
    { 0xDFC1D0C1, "stop_flashing_thread" },
    { 0x4A54EC2E, "stop_flashlight_exploder" },
    { 0xE0714C3B, "stop_flashlight_reminder" },
    { 0x7EE4A394, "stop_flicker" },
    { 0x292FE0D2, "stop_flightstick" },
    { 0x7592E2DA, "stop_flightstick_animator" },
    { 0x4A8FE4B6, "stop_flinging" },
    { 0x8D08EC00, "stop_float_script" },
    { 0x5D44282C, "stop_flood" },
    { 0x19A9BC88, "stop_floor_1_vo" },
    { 0x8C70A588, "stop_fog" },
    { 0xEFE894AF, "stop_follow" },
    { 0x964EBAA1, "stop_follow_nodes" },
    { 0xC70ACC6F, "stop_follow_path" },
    { 0x93BEF291, "stop_following" },
    { 0x8C1CE7ED, "stop_following_barnes_obj" },
    { 0x78E7C54A, "stop_following_hudson_nag" },
    { 0xF06FBDC3, "stop_following_nodes" },
    { 0xAE05051B, "stop_fontscaler" },
    { 0x2A0D7AA9, "stop_for_blockade" },
    { 0x0E8C0E9B, "stop_for_bridge_blockade" },
    { 0x01F67EB4, "stop_forcing_target" },
    { 0x4660A924, "stop_fov_dec" },
    { 0xB8019220, "stop_fov_inc" },
    { 0xC6D86CA8, "stop_free_fly" },
    { 0x415ACB6B, "stop_freefall_anim" },
    { 0xDD3409BD, "stop_freeroam" },
    { 0xBFB41FBF, "stop_friendlyfire_shield" },
    { 0xD7FAD91E, "stop_ft" },
    { 0x0FDD1C32, "stop_fx" },
    { 0x7A0B9CA1, "stop_fx_immediately" },
    { 0x8E4EEED6, "stop_fx_looper" },
    { 0x48C9EAFB, "stop_fx_on_tag" },
    { 0x256FEFD0, "stop_gas_exploders" },
    { 0xE54B4A30, "stop_gas_trig" },
    { 0xDD97BA3B, "stop_gathering" },
    { 0xB99176BC, "stop_gathering_traces" },
    { 0x7C08B011, "stop_general_enemy_vo" },
    { 0xA6E1D830, "stop_geo_fx" },
    { 0x931C873E, "stop_getaway_zeros_1" },
    { 0xE1BE7112, "stop_geyser_fx" },
    { 0x7D2970AD, "stop_gimping_friendlies" },
    { 0xC3733644, "stop_glove_fx" },
    { 0x1F491595, "stop_goatpath_bombers" },
    { 0x1303C062, "stop_god_mode_potus_protection" },
    { 0x29C665F1, "stop_godrays" },
    { 0x2E9D39B3, "stop_godrod_challenge_watch" },
    { 0x07C3F71D, "stop_going_to_node" },
    { 0xAF6EA77A, "stop_going_to_node_slums" },
    { 0xD03A0670, "stop_goliath" },
    { 0xA581D5B5, "stop_grass_half_shields" },
    { 0x8D23C39F, "stop_grass_idle" },
    { 0x5071CFFC, "stop_grave_friendly_strat" },
    { 0x4CA93F79, "stop_grenade_launcher" },
    { 0xD7C954DD, "stop_grenades" },
    { 0xE73939A8, "stop_ground_sounds" },
    { 0x91EE1E7A, "stop_gunner_idle" },
    { 0x07CC79D9, "stop_gunner_shoot" },
    { 0xBA965063, "stop_guns_base" },
    { 0xC75B1153, "stop_guzzo_print_3d" },
    { 0xA721FC8C, "stop_hacking_sounds" },
    { 0xE5CB0FA0, "stop_hand_loop" },
    { 0x7096864A, "stop_handcuffs" },
    { 0xA20EC5CD, "stop_hangar_door_alarms" },
    { 0xD1606AC5, "stop_hangar_drones" },
    { 0x529D375B, "stop_harper_throw" },
    { 0x52D0030C, "stop_having_low_accuracy" },
    { 0x022E5875, "stop_hazmat" },
    { 0x0A78415A, "stop_head_update" },
    { 0x916FB64A, "stop_health" },
    { 0xA3CCBBE0, "stop_health_leak" },
    { 0xE74DAF3C, "stop_heart" },
    { 0xC5BCC54C, "stop_heartbeat_sound" },
    { 0x4F18EEF6, "stop_heat_shimmer" },
    { 0xAB811279, "stop_height" },
    { 0x666776FA, "stop_held_guy_vignette" },
    { 0xDF366F94, "stop_heli_crash_sound" },
    { 0x6575DA14, "stop_heli_drop_valid_location_arrived_at_goal_cylinder" },
    { 0xA5A4DD3D, "stop_heli_drop_valid_location_dropped_cylinder" },
    { 0xE0306E53, "stop_heli_drop_valid_location_marked_cylinder" },
    { 0x1E8772D3, "stop_heli_fire" },
    { 0xB0FDC7C2, "stop_heli_near_player_check" },
    { 0x553A4767, "stop_heli_sounds" },
    { 0xC85E4D82, "stop_helicopter_attack" },
    { 0x8472F674, "stop_helmet_loop" },
    { 0x0BDB88D2, "stop_here" },
    { 0x8882DAA6, "stop_hero_catch_up_teleport" },
    { 0x13E77708, "stop_hero_movement" },
    { 0x939895A9, "stop_hero_rain" },
    { 0x5192DB11, "stop_heroberlin_talk" },
    { 0xE4CE78E8, "stop_hide" },
    { 0xC84647E9, "stop_hiding" },
    { 0x57F28AB9, "stop_hill_screaming" },
    { 0x0A177DF2, "stop_hind_attack" },
    { 0x440D7C35, "stop_hind_rotors_after_touching_down" },
    { 0xF732CD73, "stop_hint" },
    { 0x75995F98, "stop_hint_logic" },
    { 0xCA4C93A8, "stop_hol3_mg_behavior" },
    { 0x3A191CD4, "stop_hol3_temp_kill_axis" },
    { 0x230C09E1, "stop_holding_gate" },
    { 0x6D751D51, "stop_holo_table" },
    { 0xF3345CDA, "stop_horse_tether" },
    { 0xD3F6B28C, "stop_house_breach" },
    { 0x88D22F6C, "stop_hud_outline" },
    { 0x81F1E576, "stop_hudson_nag" },
    { 0x85CCCA9F, "stop_id" },
    { 0x7A869B9E, "stop_idle" },
    { 0x45C1CD93, "stop_idle1" },
    { 0x6DF887C2, "stop_idle_anim" },
    { 0x9D86AC3D, "stop_idle_crewchief" },
    { 0xC3CFFD1F, "stop_idle_loop" },
    { 0x23FDCD71, "stop_idle_pilot" },
    { 0xEDFB38F0, "stop_idle_strafe_tracking" },
    { 0xBAA299B7, "stop_idling" },
    { 0x36A43507, "stop_igc" },
    { 0xA39A3109, "stop_ignoring_player_when_close" },
    { 0x10592C9F, "stop_ignoring_player_when_shot" },
    { 0xD45E32A2, "stop_impact_sound" },
    { 0x69DBA915, "stop_in" },
    { 0xA029DC47, "stop_increase_extra_cam_fov" },
    { 0xBF975558, "stop_inert" },
    { 0x081A3FED, "stop_infinite_ammo" },
    { 0x60075BCE, "stop_inopen_dialogue" },
    { 0xA76085F0, "stop_input_detection" },
    { 0xE3F517DD, "stop_inside_trigger" },
    { 0x07A6A9FC, "stop_intermission" },
    { 0x0E553101, "stop_interrupt" },
    { 0x4152E551, "stop_intro_cinematic_bino" },
    { 0xDA007EB9, "stop_intro_mortars" },
    { 0x3778EFDE, "stop_intro_snp" },
    { 0x27EA8324, "stop_intro_street_spawners" },
    { 0x783FE674, "stop_jeep" },
    { 0xEC380EC0, "stop_jeep_at_overlook" },
    { 0x9FD228F5, "stop_jeepcrash_spawn" },
    { 0x00E7EAD6, "stop_jetpack" },
    { 0xB898E5DC, "stop_jog" },
    { 0x9C1768E5, "stop_jog_idle" },
    { 0x8778619D, "stop_juggernaut_hunt_behavior" },
    { 0xF453DC35, "stop_juggernaut_protect_behavior" },
    { 0xB24E611D, "stop_jump_think" },
    { 0x8744BCB6, "stop_karma_vitals_cam" },
    { 0x22AEAD70, "stop_keep_tank_alive" },
    { 0x50A4CE41, "stop_kicking_up_dust" },
    { 0x380BC9A9, "stop_kill_near_zombies" },
    { 0x30E80B06, "stop_kill_timer" },
    { 0xD7F76C14, "stop_kill_trig_think" },
    { 0xF88912F5, "stop_killcam" },
    { 0x9E8E8090, "stop_killing" },
    { 0x56634BD9, "stop_killing_enemies" },
    { 0x9695B2EB, "stop_killing_theplayer" },
    { 0xAD66CAD4, "stop_ladder" },
    { 0xBAF19166, "stop_lander_rumble" },
    { 0x9E6A9FBD, "stop_last_gib_time" },
    { 0xA5E00ACF, "stop_last_valid_position" },
    { 0xFEE3E48E, "stop_leap" },
    { 0xE79543A0, "stop_leapfrog" },
    { 0x42AB8A5A, "stop_left_defenders" },
    { 0x9A439848, "stop_left_footstep_damage" },
    { 0xFF9D8B98, "stop_left_uaz_launch" },
    { 0xC31BC1CC, "stop_left_window_drones" },
    { 0xC1E9DEFF, "stop_lerp_position" },
    { 0x9DEBE210, "stop_lerping_thread" },
    { 0x0899A344, "stop_light" },
    { 0x958821CD, "stop_light_fx" },
    { 0x6B14C49A, "stop_lightning_color" },
    { 0xABA08AE6, "stop_line" },
    { 0xD5919C0C, "stop_line_points" },
    { 0xBC5FC0BA, "stop_line_sound" },
    { 0x9AD2A5FC, "stop_load" },
    { 0xD786A619, "stop_lobby_color_think" },
    { 0x8EF150FA, "stop_location_selection" },
    { 0xF9C3FEC6, "stop_locked_sound" },
    { 0xBBCE56C2, "stop_lockon_sound" },
    { 0xC90CD96A, "stop_logic" },
    { 0x0FAB48E1, "stop_look" },
    { 0x99A3C63B, "stop_look_at" },
    { 0xEB3464D9, "stop_look_trigger_think" },
    { 0x2C1ADE6A, "stop_lookat" },
    { 0x64B76BA7, "stop_looking" },
    { 0xE2B88C21, "stop_looking_around" },
    { 0xEF84D9E7, "stop_looking_at_target" },
    { 0xA5724972, "stop_loop" },
    { 0x97E235F6, "stop_loop_anim" },
    { 0x30A301B9, "stop_loop_heli" },
    { 0x767737A2, "stop_loop_notify" },
    { 0x2B3EE2BC, "stop_loop_on_entity" },
    { 0x3AEFC455, "stop_loop_play_end" },
    { 0xCDCE4B6C, "stop_loop_price" },
    { 0x5E668488, "stop_loop_sound_on_entity" },
    { 0xEC16A680, "stop_loop_spark" },
    { 0x3B5B905D, "stop_loop_test" },
    { 0xD7219723, "stop_looper" },
    { 0xC29731FE, "stop_looping" },
    { 0x06A66F62, "stop_looping_anim" },
    { 0x30DAC88E, "stop_looping_death_fx" },
    { 0xA5504CEF, "stop_looping_deathfx" },
    { 0x8BBCE460, "stop_looping_drones" },
    { 0x94125CED, "stop_looping_sounds" },
    { 0x481CE9CF, "stop_loopsound" },
    { 0xF1A83C9D, "stop_looptime_count" },
    { 0xD459EA57, "stop_low_bombers" },
    { 0x56480ACC, "stop_magic_bullet" },
    { 0x4B741FDC, "stop_magic_bullet_shield" },
    { 0xE0C4195C, "stop_magic_bullet_shield_safe" },
    { 0xBD72F242, "stop_magic_bullet_soon" },
    { 0x93A1BFA5, "stop_make_friendies_ignored" },
    { 0xBA8E725D, "stop_managing_health" },
    { 0xB609AED0, "stop_mansion_pen_ai" },
    { 0x5BAB0A74, "stop_mansion_waves" },
    { 0x7E20A17E, "stop_mapreading" },
    { 0xA222DC9A, "stop_margwatraveltell" },
    { 0xCB0A3C9E, "stop_mason_hill_wave2_mortar" },
    { 0xEFB2404F, "stop_mason_intro_mortar" },
    { 0xA2083111, "stop_mason_vtol_fire" },
    { 0xB236B44C, "stop_match_origin" },
    { 0x46D8A98F, "stop_match_speed" },
    { 0xEFC0320F, "stop_maze_rumble" },
    { 0x2FF2C08C, "stop_melee_debug_print" },
    { 0x5F740AC4, "stop_melee_sequence" },
    { 0x726F6DD4, "stop_melee_watch" },
    { 0x9DD0032E, "stop_merchant_ship_coll" },
    { 0x9E98518D, "stop_merchant_ship_klaxon" },
    { 0x8A4B6937, "stop_merchant_ship_siren" },
    { 0x2CF63BD4, "stop_messiah_papers" },
    { 0xDE0F20C8, "stop_mg" },
    { 0x96DD1E76, "stop_mg_anim_ent" },
    { 0x1B7029B9, "stop_mg_behavior_if_flanked" },
    { 0x4053109A, "stop_mg_from_auto_fire" },
    { 0x704739EC, "stop_mg_from_auto_fire2" },
    { 0x9649B455, "stop_mg_from_auto_fire3" },
    { 0x9BA98627, "stop_microwave" },
    { 0xF221DE90, "stop_mid_color_chain" },
    { 0x3AFC1B98, "stop_minigun_fallback_shouting" },
    { 0x35312E6C, "stop_misc_features_vo" },
    { 0xDC4741CA, "stop_monitor" },
    { 0xF0FEFAA1, "stop_monitor_damage_as_occupant" },
    { 0xB046B644, "stop_monitor_melee_swipe" },
    { 0x04CE85A9, "stop_monitor_missile_locked_on_to_me" },
    { 0x22EAF934, "stop_monitor_missiles_locked_on_to_me" },
    { 0x0D40F726, "stop_monitoring" },
    { 0xC9759050, "stop_monitoring_convoy_health" },
    { 0x8D28E1A5, "stop_monitoring_flash" },
    { 0x235A6BDD, "stop_monitoring_tear_usage" },
    { 0xE1CE718F, "stop_mortar" },
    { 0x90C076DD, "stop_mortar_airfield_ambient_canned" },
    { 0x785ADB7E, "stop_mortar_airfield_canned" },
    { 0x225E66B0, "stop_mortar_fx" },
    { 0x9AE364AA, "stop_mortar_guys" },
    { 0xCAC398A5, "stop_mortar_if_player_nearby" },
    { 0x4526DAF5, "stop_mortar_run" },
    { 0x74209343, "stop_mortarcycle_1" },
    { 0x02192408, "stop_mortarcycle_2" },
    { 0x0DC57F56, "stop_mortars" },
    { 0xB61584FF, "stop_move" },
    { 0x5F5311FB, "stop_move_anim_update" },
    { 0x6FD84E7F, "stop_move_killer" },
    { 0xD88B52DD, "stop_move_selected_object" },
    { 0xD0D1E6F4, "stop_movie" },
    { 0x313EBE7A, "stop_moving" },
    { 0x55B78B60, "stop_moving_in" },
    { 0x54D1E0D6, "stop_moving_rumble" },
    { 0x6ED18F82, "stop_moving_target" },
    { 0x5EC209AB, "stop_msg" },
    { 0x7E4FE921, "stop_multi_extracam" },
    { 0x78859FCC, "stop_my_firing" },
    { 0xCF012150, "stop_n_fire_node" },
    { 0xD41BF043, "stop_naglines" },
    { 0x3B1223D3, "stop_nitrogen_think" },
    { 0x94348B4C, "stop_node" },
    { 0x2B56DFC2, "stop_normal_countdown_flashing" },
    { 0xB9F82B98, "stop_notetracks" },
    { 0xF5BA77B3, "stop_notify" },
    { 0x5604A40A, "stop_numbers" },
    { 0x0E3C25A3, "stop_numbers_bink" },
    { 0x4F0D98E6, "stop_numbers_sound" },
    { 0x124EA374, "stop_numbers_strong" },
    { 0x92476BC2, "stop_obj_" },
    { 0x9FE2E9D5, "stop_occurred" },
    { 0xEBDB7290, "stop_office_anim" },
    { 0x8396E582, "stop_omaha_drones" },
    { 0xEE4B955C, "stop_on_drag" },
    { 0x04ECAB02, "stop_on_node" },
    { 0x846D22A5, "stop_on_notify" },
    { 0x9F6B45C1, "stop_one_inch_punch_attack" },
    { 0x5170B106, "stop_onplayerspawned" },
    { 0x9244A021, "stop_open_idle" },
    { 0x624AF0CF, "stop_or_start_fx" },
    { 0x592DEEE8, "stop_other_sam_vo" },
    { 0x6F12A074, "stop_out" },
    { 0x147CF0DF, "stop_overheat_drain" },
    { 0x8D4D16B6, "stop_overheatfx" },
    { 0x53C81BF2, "stop_pack_poi" },
    { 0x0A2A025D, "stop_pain_watcher" },
    { 0x5C56A22C, "stop_painting" },
    { 0x5B2895BC, "stop_pap_fx" },
    { 0x8BD40E99, "stop_passenger_loop" },
    { 0xE59E8A1D, "stop_path" },
    { 0x5C9B657E, "stop_path_to_tag" },
    { 0x5154DC9F, "stop_patrol_behavior" },
    { 0x34B3FC31, "stop_patrol_thread" },
    { 0xEBA9585E, "stop_patrolling" },
    { 0xA4ADC3F9, "stop_pby_idling" },
    { 0x7CC76294, "stop_physics_shake" },
    { 0xC74F3AFE, "stop_physicsjolt" },
    { 0x1D8BB044, "stop_pickup_timeout" },
    { 0xB47495FC, "stop_pillar_cover" },
    { 0x72B10EB0, "stop_ping" },
    { 0x4F40F895, "stop_pipe_idle" },
    { 0x6FFB0628, "stop_pitch_align" },
    { 0xEDB33675, "stop_plane_prop_sounds" },
    { 0x5944CE3A, "stop_plane_wind_sounds" },
    { 0xCCE6709F, "stop_plant_sound" },
    { 0x2091A562, "stop_planter_spawners" },
    { 0xFF400DB2, "stop_play_anim" },
    { 0x0EFFB6FE, "stop_play_anim_internal" },
    { 0xEA7CB8DB, "stop_player_aim_entity_update" },
    { 0xCEAF1051, "stop_player_at_jeep_trig" },
    { 0x37AE5CE0, "stop_player_boat_sim" },
    { 0x79301BFF, "stop_player_from_leaving" },
    { 0xB3B73E08, "stop_player_fx" },
    { 0x449CBDB9, "stop_player_grenade_watcher" },
    { 0x68956F5B, "stop_player_health_display" },
    { 0xAC6205C0, "stop_player_idle" },
    { 0x0C5C65A3, "stop_player_kill_check" },
    { 0x949DADDC, "stop_player_monitor_doublejump" },
    { 0xC0E7BD32, "stop_player_monitor_slide" },
    { 0xE2901C98, "stop_player_monitor_swimming" },
    { 0x27548EC2, "stop_player_monitor_time_played" },
    { 0x14D87E82, "stop_player_monitor_travel_dist" },
    { 0x0D024855, "stop_player_monitor_wall_run" },
    { 0xD9CE1067, "stop_player_mortar_run" },
    { 0xB61F7296, "stop_player_out_of_playable_area_monitor" },
    { 0xBE44083E, "stop_player_revive_monitor" },
    { 0x3E011D44, "stop_player_ride" },
    { 0xC0FE830A, "stop_player_rope_scroll" },
    { 0xC845C436, "stop_player_running_away_from_boss_boat" },
    { 0x5334674F, "stop_player_scores" },
    { 0x1D38A172, "stop_player_spot" },
    { 0x4A2281CB, "stop_player_too_many_weapons_monitor" },
    { 0xAF915919, "stop_player_view_particles" },
    { 0x9C575A4F, "stop_player_watch" },
    { 0x751883F0, "stop_player_zombie_breadcrumb" },
    { 0xB7953521, "stop_playerlook_override" },
    { 0x38B65F4A, "stop_point" },
    { 0x994F234A, "stop_pond_fight" },
    { 0x35319F6B, "stop_pop_smoke" },
    { 0x738B8E56, "stop_popup_donotetracks" },
    { 0x77ACC31B, "stop_pow_loop" },
    { 0x83CD452D, "stop_prev_timer" },
    { 0xC55DD4FE, "stop_print3d_on_ent" },
    { 0x31415269, "stop_printing_grenade_timers" },
    { 0x3871A4A1, "stop_printing_health_bars" },
    { 0x62A2A148, "stop_projectile_check" },
    { 0xEE914A6B, "stop_prop_mode" },
    { 0xB3A9B6ED, "stop_prop_move" },
    { 0x680A6CA9, "stop_prop_sound_with_ramp" },
    { 0xB431F51A, "stop_proximity_kill" },
    { 0xC6C60E80, "stop_pt_idling" },
    { 0x7F094AB0, "stop_pt_skimming" },
    { 0x14FB3B53, "stop_quake" },
    { 0xBF2529D6, "stop_quaking" },
    { 0x6661DA65, "stop_quick_text" },
    { 0x1BB7019D, "stop_quickrevive_logic" },
    { 0x21E8B783, "stop_radar_dish" },
    { 0x6793DC31, "stop_radio" },
    { 0x6378A934, "stop_radio_listener" },
    { 0x3B364CC6, "stop_radioman_think" },
    { 0xC0E67E30, "stop_radioop_idling" },
    { 0xF5D7DBC3, "stop_rage_vo" },
    { 0xADA028F0, "stop_ramp" },
    { 0x9E19B240, "stop_random_chamber_walls" },
    { 0xC5EF4376, "stop_random_earthquakes" },
    { 0x9BEA8697, "stop_random_vox" },
    { 0x301E7805, "stop_randomize" },
    { 0x295ED4BC, "stop_rappel" },
    { 0xA44DCF57, "stop_raps_sound_on_death" },
    { 0xC4BE71E0, "stop_reactions" },
    { 0xAE82A097, "stop_record" },
    { 0x55703FD1, "stop_redshirt_movement" },
    { 0xB988A50D, "stop_reman_mg_think" },
    { 0x462873AA, "stop_remote" },
    { 0x7B936DE9, "stop_remote_weapon" },
    { 0x31CF7838, "stop_repeat_dialog" },
    { 0x90733E14, "stop_respawning" },
    { 0x0D02F376, "stop_revive_trigger" },
    { 0xA5B8812F, "stop_riding" },
    { 0x536D545A, "stop_riding_with_player" },
    { 0x239BE753, "stop_right_defenders" },
    { 0xCA245721, "stop_right_footstep_damage" },
    { 0x3DE92DB0, "stop_riverbed_mortars" },
    { 0xACE2FC39, "stop_rocket_barrage" },
    { 0x91B85E4D, "stop_rocket_firing_thread" },
    { 0x7737AE1C, "stop_rocketman_deathsave" },
    { 0x2594366F, "stop_rolling" },
    { 0x5D7D6505, "stop_rotate" },
    { 0x08C2D398, "stop_rotate_highlight" },
    { 0x274D9981, "stop_rotate_mode" },
    { 0xD29BCCB8, "stop_rotate_thread" },
    { 0x64692870, "stop_rotateplane_thread" },
    { 0x1964695B, "stop_round_end_check" },
    { 0x8E5513ED, "stop_rpg_support" },
    { 0xFDC53343, "stop_rpg_turret_ai" },
    { 0xDA299BE4, "stop_rts_delay_gotopoint_choke_wait" },
    { 0x7983A5F2, "stop_rumble_check" },
    { 0x6D1C88BD, "stop_run_anim" },
    { 0x038171E0, "stop_run_idle" },
    { 0x4DB6B0C5, "stop_running" },
    { 0x72C5C37B, "stop_running_from_bus" },
    { 0xB5BD9462, "stop_running_to_node" },
    { 0x5EC5761E, "stop_rushers" },
    { 0x8369E982, "stop_rushing" },
    { 0x82DFFAA2, "stop_rushing_timeout" },
    { 0x6B2002D1, "stop_salazars_soct" },
    { 0x7AB72F47, "stop_sam_cougar" },
    { 0xA5DFEF33, "stop_sampan_when_friendlies_are_dead" },
    { 0xC7935F65, "stop_sandbox" },
    { 0xCF2A3097, "stop_savannah_grass" },
    { 0x43874E4E, "stop_savannah_start_mortars" },
    { 0xCFE40146, "stop_save_highlight" },
    { 0x192FE6B8, "stop_savebutton_loop" },
    { 0xAE513424, "stop_scale_speed_in_water" },
    { 0x73117150, "stop_scanner_gun_hide" },
    { 0x429436AB, "stop_scanner_gun_show" },
    { 0xBFA0FD6D, "stop_scripted_flash" },
    { 0x51D9A18C, "stop_scripted_strafe" },
    { 0xF719900A, "stop_sea_cowbell" },
    { 0xA7E060FC, "stop_searching" },
    { 0x7B1B76F8, "stop_searchlight" },
    { 0x25613221, "stop_second_ledge_force_death" },
    { 0x6DCEF2DC, "stop_seeking_sound" },
    { 0xA8DE8F8C, "stop_select_group" },
    { 0x6FE27A56, "stop_select_model" },
    { 0xC4EB54AA, "stop_selected_object_dist" },
    { 0x7BE4642E, "stop_sending" },
    { 0xC5E1B5E9, "stop_sequencing_notetracks" },
    { 0x100C8268, "stop_set_player_speed" },
    { 0xA62E39EF, "stop_set_trophy_state" },
    { 0xB182E290, "stop_setup_drone_yells" },
    { 0x00758412, "stop_shelf_fxanim" },
    { 0xA37E1C5C, "stop_sherman_bunker_shooting" },
    { 0xC61FFF9F, "stop_shield_when_player_runs_street" },
    { 0x589CBB7A, "stop_shock_onpain" },
    { 0x9B082BC5, "stop_shoot" },
    { 0x7A868BA5, "stop_shoot_at_target" },
    { 0x060FD000, "stop_shoot_at_target_think" },
    { 0x2EFC7CB6, "stop_shoot_model_think" },
    { 0xF5704411, "stop_shootat_drone" },
    { 0x8FD2C8E2, "stop_shooter_mode" },
    { 0x23186A1B, "stop_shooterrun" },
    { 0x1C1882FC, "stop_shootin_u" },
    { 0x606E31A3, "stop_shooting" },
    { 0xBD8123E0, "stop_shooting_at_kamikazes" },
    { 0x42046CD7, "stop_shot_death" },
    { 0x030DA5BA, "stop_shouting_tavern" },
    { 0x007D138A, "stop_show_alive_ai_count" },
    { 0xD6F43025, "stop_show_task" },
    { 0xD0C58635, "stop_showdown_damage" },
    { 0x5C30DD39, "stop_shreck_loop" },
    { 0x1CA2FB60, "stop_shrimps" },
    { 0x0BD749B2, "stop_shrine_dialogue" },
    { 0x8E875043, "stop_sidestep" },
    { 0x97628BC7, "stop_signal_failure" },
    { 0x83940E35, "stop_signal_loop" },
    { 0x9474967C, "stop_single" },
    { 0xD7915E79, "stop_skydemon_trail" },
    { 0x449169ED, "stop_slide_anim" },
    { 0xB039AC19, "stop_slide_rumble" },
    { 0xD9581E87, "stop_sling_drones" },
    { 0x6DF73D52, "stop_slingshot_early_fire" },
    { 0x1FC68837, "stop_slowmo" },
    { 0x98957B5C, "stop_smoke_reminder" },
    { 0xABE99156, "stop_smoking" },
    { 0xE7012699, "stop_snow" },
    { 0x749870C7, "stop_soct" },
    { 0x1B62825B, "stop_solar_walla" },
    { 0x2E35E349, "stop_soon" },
    { 0xFB5DEFB5, "stop_sound" },
    { 0xD079C975, "stop_sound_and_delete_ent_on_early_release" },
    { 0x761A1196, "stop_sound_on_ent_shutdown" },
    { 0xD89F2B84, "stop_sounds" },
    { 0x1D8F406B, "stop_sounds_on_death" },
    { 0x203C4EBF, "stop_spark" },
    { 0xC46964C6, "stop_sparks" },
    { 0x872A4AB7, "stop_spawn_profile" },
    { 0x94C152D8, "stop_spawn_weight_debug" },
    { 0xECCFECDD, "stop_spawner_cleanup" },
    { 0x8C3256D9, "stop_spawning_jetpack_ai" },
    { 0x8C5B31C5, "stop_spawning_pickups" },
    { 0x39206D04, "stop_speed_check" },
    { 0xD38AE76C, "stop_speed_think" },
    { 0x2DA047F5, "stop_spiderhole" },
    { 0xEE1C6A2F, "stop_spinner_sound" },
    { 0xB1727EC2, "stop_spinning" },
    { 0x3B1BB16E, "stop_spotlight_control" },
    { 0xDBC1B57B, "stop_spotlight_fail" },
    { 0x4D0A4D59, "stop_spotlight_flare" },
    { 0x7BF1A81E, "stop_spotlight_path" },
    { 0x2EA15F50, "stop_spotlight_shine" },
    { 0x1DA60BD4, "stop_spotting" },
    { 0x3A0237C7, "stop_spray" },
    { 0xC85BE098, "stop_spray_fx" },
    { 0x3FE0437C, "stop_sprint_watch" },
    { 0xCF3C65B3, "stop_squirming" },
    { 0xEC56840E, "stop_sr71_test" },
    { 0x68B2280E, "stop_staff_sound" },
    { 0x4E354FAD, "stop_stair_combat_logic" },
    { 0x27DEEDE0, "stop_state_machine_" },
    { 0x6FCAA47F, "stop_static_print3d" },
    { 0xFD3F0152, "stop_stay_on_turret" },
    { 0x182B8887, "stop_steiner_idle" },
    { 0x2D085C03, "stop_stingers_base" },
    { 0x030D07F1, "stop_strafe" },
    { 0x21814D94, "stop_strafe_miniguns" },
    { 0xA80D97C7, "stop_strafe_quake" },
    { 0xF103FF42, "stop_strafing_run" },
    { 0xBE586671, "stop_stream_epic_models" },
    { 0x56785E92, "stop_street_anim_entries" },
    { 0xC4188E7E, "stop_street_exploders" },
    { 0x5E6489E7, "stop_stretcher_anim_loop" },
    { 0x184E13FA, "stop_struct_render" },
    { 0x63DF1F52, "stop_stumble" },
    { 0xD3F96E41, "stop_stun_fx" },
    { 0x21660DF5, "stop_suicide_trigger" },
    { 0xDE61B3F4, "stop_super_enemies" },
    { 0x318A2FEB, "stop_supply_drop" },
    { 0x2E73226C, "stop_suppression_fire" },
    { 0xA5F6DEF1, "stop_suppressionfire" },
    { 0xB3EE3FC9, "stop_surface" },
    { 0x3FAD4F63, "stop_surveillance" },
    { 0xB88364BA, "stop_sw_cam" },
    { 0x87EA5C48, "stop_swaying" },
    { 0xEDBBCAEC, "stop_swimming_drown_damage" },
    { 0x2F3CD5C3, "stop_table_death" },
    { 0xEE3A91AB, "stop_tail_fx" },
    { 0x0601DD7C, "stop_taking_damage" },
    { 0x5829B81E, "stop_talking" },
    { 0xC19F703A, "stop_tall_grass_stealth" },
    { 0xB726DFA8, "stop_tank" },
    { 0xE47004AD, "stop_tank_at_end_node" },
    { 0x8F18749E, "stop_tank_firing" },
    { 0x093035F8, "stop_tank_idle_fire" },
    { 0x216B8296, "stop_tank_invincibility" },
    { 0x249691DE, "stop_target_missile_sound" },
    { 0x10B6F366, "stop_targetfinding" },
    { 0xCD7120ED, "stop_targeting" },
    { 0x1AFA520F, "stop_targeting_player" },
    { 0xE2432334, "stop_telegraphing" },
    { 0x97E83CBE, "stop_teleport_fx" },
    { 0xAA7DC627, "stop_temp_dialogue_print" },
    { 0x10A2D8CD, "stop_the_radio" },
    { 0x5B9C3599, "stop_thief_alarms" },
    { 0xB9A7490A, "stop_thief_chasing" },
    { 0xDBE2801A, "stop_thief_freeze_countdown" },
    { 0xFFD53D50, "stop_think" },
    { 0xA2F09A48, "stop_thinking" },
    { 0x9D840106, "stop_third_ledge_force_death" },
    { 0xB4DABC42, "stop_threatening_roof_claw" },
    { 0x60B6C671, "stop_ticking" },
    { 0x0F6186B3, "stop_tied_up_loop" },
    { 0x7ADCE5A3, "stop_time" },
    { 0x40ABB36F, "stop_timed_rumble" },
    { 0x5B10AB0B, "stop_timescale_on_timer" },
    { 0xAB18AA5A, "stop_tire_deflate" },
    { 0x4D6F6D59, "stop_titus_challenge_watch" },
    { 0x5367EF5D, "stop_to_reload" },
    { 0xC9DDA062, "stop_topfloor_spawners_when_player_in_pit" },
    { 0x545F9553, "stop_torch_fx" },
    { 0x96522058, "stop_tow_futz" },
    { 0xDE8CB85C, "stop_tower_loop" },
    { 0x5CC0989A, "stop_tracers" },
    { 0x1F0415A5, "stop_trackaimawarenessloop" },
    { 0x43B8E7BB, "stop_tracking" },
    { 0x80ECD8FE, "stop_tracking_heli" },
    { 0x1BE93799, "stop_tracking_nav_points" },
    { 0xBBCDC5FB, "stop_tracking_sound" },
    { 0xDC960B46, "stop_trap_fx" },
    { 0xC60EB163, "stop_traverse_idle" },
    { 0xA1255951, "stop_traverse_notetracks" },
    { 0x6493F6DF, "stop_traverse_turret" },
    { 0x2471CED9, "stop_trench_mortars" },
    { 0x5C41925C, "stop_trigger" },
    { 0x675D969E, "stop_trigger_name" },
    { 0x76EB59F2, "stop_trigger_waypoint" },
    { 0x3C37683A, "stop_truck_death" },
    { 0x0E473806, "stop_truck_fx" },
    { 0xDE01CFFE, "stop_trying_to_melee" },
    { 0xAE850E93, "stop_trying_to_strafe" },
    { 0xD29A4A45, "stop_tunnel_nag_lines" },
    { 0xD1DEB5F6, "stop_turret" },
    { 0x5E186EF9, "stop_turret_audio" },
    { 0x02257AAA, "stop_turret_count" },
    { 0x54EC6E52, "stop_turret_debug" },
    { 0xB407FD66, "stop_turret_shoot" },
    { 0xEB8E3AEE, "stop_tutorial" },
    { 0xE7717344, "stop_tutorial_vo" },
    { 0x05B4D1B3, "stop_tutorial_when_restarting_track" },
    { 0x79AA8B11, "stop_tutorials" },
    { 0x8CBF0F92, "stop_tv_glow" },
    { 0x2CFB4532, "stop_update_f35_hud" },
    { 0xA83F34E6, "stop_update_skill_on_change" },
    { 0xD34C54CB, "stop_updating_clip" },
    { 0x65F9EA86, "stop_updating_enemy_target_pos" },
    { 0x0B5DA7C0, "stop_updating_goal_yaw" },
    { 0x013270A2, "stop_updating_looper" },
    { 0xC230807E, "stop_updating_objective" },
    { 0xB2FD3B8C, "stop_upper" },
    { 0x44A10892, "stop_use_turret" },
    { 0xF694CE2D, "stop_using_built_in_burst_fire" },
    { 0xFFB79E08, "stop_using_turret_when_node_lost" },
    { 0xA7F31218, "stop_vehicle" },
    { 0xCA581723, "stop_vehicle_compasshandle" },
    { 0x50325367, "stop_vehicle_traffic_think" },
    { 0x1030C830, "stop_vehicle_wait" },
    { 0x7D3FDD4E, "stop_vietnam_camera" },
    { 0x4FF7FD85, "stop_vignette_animation" },
    { 0x36274FE1, "stop_village_ambient" },
    { 0x230430F2, "stop_vnode" },
    { 0x14C495C1, "stop_vo_convo" },
    { 0x3DA6B105, "stop_vortex_fx" },
    { 0xE123D2F2, "stop_vortex_fx_after_time" },
    { 0x29E83ED4, "stop_vtol_turret" },
    { 0x1FE45CAC, "stop_vulture_behavior" },
    { 0x468FE60F, "stop_wait_delay" },
    { 0x6B46FF00, "stop_wait_loop" },
    { 0xACF98EDD, "stop_wait_phase_end" },
    { 0x15508D2C, "stop_wait_safe_spawn_button" },
    { 0x23F84C35, "stop_waiting" },
    { 0x352262F6, "stop_waiting_at_node" },
    { 0x6496DF74, "stop_waiting_to_flinch" },
    { 0x9221A169, "stop_wake_idle" },
    { 0x07A54BBB, "stop_walk" },
    { 0x8781EA89, "stop_walkers" },
    { 0x83631FD9, "stop_war_blink" },
    { 0xA7FF3906, "stop_warning_indicator" },
    { 0xE2635CB0, "stop_wasp_sound_on_death" },
    { 0xE8650AA0, "stop_watch_bar_couch" },
    { 0x62AA5DF6, "stop_watch_chase_speed" },
    { 0xCA7B8F26, "stop_watch_hero_power" },
    { 0xF43C586E, "stop_watching_early_knock" },
    { 0x240AAA58, "stop_watching_for_need_to_turn" },
    { 0x5B4E90ED, "stop_watching_standup" },
    { 0xF50D3BD5, "stop_watchplayeraim" },
    { 0x4B488188, "stop_water_" },
    { 0xA68A8AD6, "stop_water_dive" },
    { 0xEECC28B2, "stop_water_fx" },
    { 0x51D384D6, "stop_water_mortars" },
    { 0x0B26E547, "stop_water_sheeting" },
    { 0xC1C83883, "stop_water_ship_exterior" },
    { 0x78704A23, "stop_water_trace" },
    { 0xA4AB1740, "stop_wave3_vehicle_dead" },
    { 0xAE19265B, "stop_wave_sound" },
    { 0x0F0C79BE, "stop_waving" },
    { 0xF96B5911, "stop_weapon_switch_watcher_thread" },
    { 0x353191F5, "stop_weld_loop_ddm_1" },
    { 0x5B340C5E, "stop_weld_loop_ddm_2" },
    { 0xE53CDA7D, "stop_wetness" },
    { 0xA97CEB1E, "stop_whistle" },
    { 0xC0A13D76, "stop_whizbys" },
    { 0xE8AB05E3, "stop_widows_wine" },
    { 0x0F682447, "stop_wind_fx" },
    { 0x8868FA05, "stop_window_vc_at_line_3" },
    { 0xCC63A278, "stop_woodchopper_anim" },
    { 0xE4A55057, "stop_wounded_loop" },
    { 0x57E47B28, "stop_yard_runners" },
    { 0xA2523F53, "stop_zak_blood" },
    { 0x13DE8A34, "stop_zeroes_defending_ship" },
    { 0xF59D7B4E, "stop_zombie" },
    { 0xABD58E90, "stop_zombie_bad_path" },
    { 0x807D5B62, "stop_zombie_emerge_dust_fx" },
    { 0xFF3BE542, "stop_zombie_fall_dust_fx" },
    { 0xEB3A9FAF, "stop_zombie_fall_fx" },
    { 0xE0784895, "stop_zombie_goto_entrance" },
    { 0x36795BDF, "stop_zombie_inert" },
    { 0x3B1F9BEF, "stop_zombie_inert_transition" },
    { 0xF4618B56, "stop_zombie_rise_dust_fx" },
    { 0xAEC99D2B, "stop_zombie_rise_fx" },
    { 0xAD6D668C, "stop_zombieexitbus" },
    { 0x52D9DA0C, "stopaiming" },
    { 0xE954518E, "stopairstrikelocationselection" },
    { 0x97F602E7, "stopallfxbundles" },
    { 0x4A1ECB6C, "stopallloopsounds" },
    { 0x0082F90C, "stopallrumbles" },
    { 0x77EEDD4A, "stopanim" },
    { 0x8625F59F, "stopanim_and_kill" },
    { 0x3CBA67D2, "stopanimdistsq" },
    { 0x470F7E4C, "stopanimscripted" },
    { 0xD9FAC646, "stopat_notify" },
    { 0xBAB27787, "stopatgoal" },
    { 0x0884D57B, "stopautofireface" },
    { 0x71B604D7, "stopbink" },
    { 0xB7CB665D, "stopbinocs" },
    { 0x7865980B, "stopblindaiming" },
    { 0x618FEC48, "stopbulletshieldnotifyent" },
    { 0xA7ED4DC4, "stopbulletshieldnotifymsg" },
    { 0x05417BA5, "stopbulletshieldtime" },
    { 0x5182EFA6, "stopburning" },
    { 0xA8DE3B4A, "stopburningsounds" },
    { 0xDFB19617, "stopburnsound" },
    { 0x5F062EE5, "stopcameratween" },
    { 0xDBC0E58C, "stopcarryturret" },
    { 0x1BCF6E27, "stopcinematicingame" },
    { 0xA9886C4F, "stopclouds" },
    { 0xC3E9455F, "stopcmd" },
    { 0x01BACF29, "stopcowering" },
    { 0x4D8313F0, "stopcrateeffects" },
    { 0x276537BD, "stopdebugmisstime" },
    { 0xB7DC54B5, "stopdemorecording" },
    { 0xFC486F25, "stopdist" },
    { 0xA12340FB, "stopdogmeleeattack" },
    { 0x51926122, "stopdoorbreach" },
    { 0x27A2CE51, "stopdriveidle" },
    { 0x503EB424, "stopduprenderbundle" },
    { 0xEBF6F0E2, "stoped" },
    { 0x2EEF0F59, "stopemp" },
    { 0x75562292, "stopempeffect" },
    { 0x41CFB09D, "stopempeffects" },
    { 0xB9CE1067, "stopemprule" },
    { 0x8BCBBAF0, "stopenginesound" },
    { 0x5F04BA5E, "stopepictauntscene" },
    { 0x1FA520F6, "stopextracam" },
    { 0x9B4D90AD, "stopfacialthread" },
    { 0x809B17EA, "stopfailsafe" },
    { 0xCEFD9AA9, "stopfire" },
    { 0x3EC7F964, "stopfirebeam" },
    { 0x81711119, "stopfirenode" },
    { 0x8748F439, "stopfireweapon" },
    { 0x90B21FDC, "stopfiring" },
    { 0x8CD67D62, "stopfiringonshootbehaviorchange" },
    { 0x174E63D7, "stopflamethrower" },
    { 0xF67869B7, "stopflareloopwatcher" },
    { 0xD78605F3, "stopflashing" },
    { 0xAF9BD93E, "stopflashingbadlytime" },
    { 0x47338FBB, "stopforcegoalnotifyent" },
    { 0x2C91F097, "stopforcegoalnotifymsg" },
    { 0xF2217C94, "stopforcegoaltime" },
    { 0x446F24B5, "stopforcestreamingxmodel" },
    { 0xC46CBC76, "stopfullsprint" },
    { 0xD555A113, "stopfx" },
    { 0x8442AF2C, "stopfxontag" },
    { 0x5EDFD1E4, "stophackertoolsoundloop" },
    { 0x43B54FE2, "stophelicopter" },
    { 0x59C7207F, "stopidle" },
    { 0xD737242B, "stopignorenotifyent" },
    { 0x9C56CB47, "stopignorenotifymsg" },
    { 0x883101E4, "stopignoretime" },
    { 0x2108A859, "stopignoringplayerwhenshot" },
    { 0x97F9D7CE, "stopignoringspotlight" },
    { 0x6F5DCD33, "stoping" },
    { 0xE09F31B9, "stopintrosnap" },
    { 0xEA3C0489, "stoplevelintrosnap" },
    { 0xA81D2C12, "stoplightloopexploder" },
    { 0x8D16C03F, "stopline" },
    { 0xFEC4D93F, "stoplocalsound" },
    { 0x3B98154B, "stoplookat" },
    { 0xB289498B, "stoplookatpathonkillanimscript" },
    { 0x9AEC63FA, "stoplookingatentity" },
    { 0x12997BE7, "stoploop" },
    { 0x283E3988, "stoploop_driver" },
    { 0xB2F15380, "stoploopat" },
    { 0xE17736B9, "stoplooping" },
    { 0xEAA69754, "stoploopsound" },
    { 0x95E0ED9D, "stoploopsoundaftertime" },
    { 0x40AE388A, "stopmaincamxcam" },
    { 0x4A3759E4, "stopmicrowave" },
    { 0x4B29D18B, "stopminigunsound" },
    { 0x337518A7, "stopmonitoringflash" },
    { 0x2641B450, "stopmonitoringtearusage" },
    { 0xCCA58996, "stopmonitorsolid" },
    { 0x58CDF28A, "stopmove" },
    { 0x144B90E8, "stopmovementandsetbrake" },
    { 0xFDE6CDC9, "stopmoveslide" },
    { 0x0C3F7601, "stopmyloop" },
    { 0xABDA003C, "stopname" },
    { 0x4E85C775, "stopnode" },
    { 0x10E3184F, "stopnodetn" },
    { 0x59E4F5CA, "stopnotifystopshootingaftertime" },
    { 0xF897385F, "stoponanimationend" },
    { 0xD45E2460, "stopondeath" },
    { 0x5C27EC27, "stopoutofboundseffects" },
    { 0x56026CFD, "stoppainwaitinterval" },
    { 0xF2040CC4, "stopped" },
    { 0x7EFBE79C, "stopped_anim" },
    { 0x627B1CAB, "stopped_at_node" },
    { 0xDEC53302, "stopped_firing" },
    { 0xC1047831, "stopped_opening" },
    { 0x62FC8F8D, "stopped_use_turret" },
    { 0xD5FF12DE, "stopped_using_remote" },
    { 0x4A569C16, "stoppedloop" },
    { 0x2718B15E, "stoppedmoving" },
    { 0x546F7444, "stoppeekcheckthread" },
    { 0xB71A7434, "stoppeeking" },
    { 0x0626BE82, "stopper" },
    { 0xBAF2FB41, "stopping" },
    { 0x1122E900, "stopplayingduprenderbundle" },
    { 0x9493D991, "stopplayingpostfxbundle" },
    { 0xBD98C097, "stoppoisoning" },
    { 0xDBB50216, "stoppoisoningandflareonspawn" },
    { 0xC83468D5, "stoppos" },
    { 0x3D1A8DB5, "stoppostfxbundle" },
    { 0xB4B813EB, "stoppostfxbundle_singleton" },
    { 0x4DFC894B, "stoppping" },
    { 0x7819CF45, "stopprints" },
    { 0x577E7BC6, "stopps" },
    { 0x414E1C40, "stopquake" },
    { 0x6407BC0D, "stopradiantexploder" },
    { 0x6598CD00, "stopreachidle" },
    { 0x5A6D79CA, "stoprevive" },
    { 0xE395F23B, "stoprotation" },
    { 0x8A0BA272, "stoprumble" },
    { 0xAD585AF8, "stoprunngun" },
    { 0x0F340AF2, "stoprunning" },
    { 0x5A15CC84, "stops" },
    { 0xCD9B34D0, "stopscript" },
    { 0x531D5F99, "stopshellshock" },
    { 0x461D3526, "stopshoot" },
    { 0x74C5D7BA, "stopshooting" },
    { 0x5CFF5E58, "stopshootingflametime" },
    { 0xBEB0F764, "stopshootturret" },
    { 0xC63F9EDE, "stopshootwhilemovingthreads" },
    { 0x1BEE67B0, "stopshortly" },
    { 0xF3923C7C, "stopshotgunpumpaftertime" },
    { 0xFA33608D, "stopshowstate" },
    { 0x056FD67C, "stopsnow" },
    { 0x356A1C2A, "stopsound" },
    { 0x8778D8AE, "stopsoundalias" },
    { 0x39419AE5, "stopsounds" },
    { 0x07434469, "stopsquadcommandlocationselection" },
    { 0x6C5D2B04, "stopstrafe" },
    { 0x2CF88D26, "stopstring" },
    { 0xB1DD546C, "stopstringmonitor" },
    { 0xF066F575, "stoptacticalwalk" },
    { 0x20BCED3F, "stoptalk" },
    { 0xA7D87BC1, "stoptalking" },
    { 0x2F0859A2, "stopteamops" },
    { 0x8C1BBB73, "stoptickingsound" },
    { 0x851C7AF2, "stoptime" },
    { 0x7679A621, "stoptimeup" },
    { 0xB8B2305E, "stoptracking" },
    { 0xFAFA849B, "stoptrigger" },
    { 0x7E4113DB, "stopturnblendout" },
    { 0x10657D2C, "stopturnedmusic" },
    { 0x5A75B9F6, "stopturnifnecessary" },
    { 0x99B77F7F, "stopturretfortime" },
    { 0x2E2E06AA, "stopturretondeath" },
    { 0xA31F8685, "stopupdaterunanimweights" },
    { 0x7B0BEA51, "stopuseanimtree" },
    { 0x69FA2F48, "stopuseturret" },
    { 0x47CEC101, "stopusingturret" },
    { 0xBC428BD7, "stopusingturretwhennodelost" },
    { 0xB99DFD2A, "stopwatch" },
    { 0x1C80CD20, "stopwatch_elem" },
    { 0x8F6216C9, "stopwatch_elem_glass" },
    { 0xCFE53FB8, "stopwatch_length_width" },
    { 0xD3FBA24E, "stopwhencanshoot" },
    { 0x42C60A0C, "storage" },
    { 0xD4C0A2B3, "storage_lander_doors" },
    { 0xB1CD41F4, "storage_lander_doors_only" },
    { 0x912DEAF9, "storage_status" },
    { 0x5F03DBE0, "storagenode" },
    { 0xF2003CDF, "storagestring" },
    { 0x6B674A98, "store" },
    { 0x9CA63EF4, "store_crumb" },
    { 0x633DA575, "store_door_state" },
    { 0x10F0AE38, "store_dvar" },
    { 0x63B2110F, "store_enemy_target_location" },
    { 0xD3473F90, "store_killcam_entity_on_entity" },
    { 0xEE31B4DE, "store_model" },
    { 0x62E16E96, "store_player_position" },
    { 0x12F725CA, "store_previous_veh_nodes" },
    { 0xC9BF3CBF, "store_shooter_model" },
    { 0xD7CF42EF, "store_undo_state" },
    { 0xF507DCC5, "store_weapon_dvar" },
    { 0x8E650A04, "store_worldstate_for_minigame" },
    { 0x84923E4C, "stored" },
    { 0x94B1D9E9, "stored_ammo" },
    { 0xC7A14F87, "stored_chance" },
    { 0xB025D52D, "stored_ents" },
    { 0x9FF6B454, "stored_hint_string" },
    { 0x3DEF8C47, "stored_weapon" },
    { 0xFBDEF072, "stored_weapon_data" },
    { 0xA95F4D82, "stored_weapon_info" },
    { 0x124B80AF, "storedallowpain" },
    { 0x4ADFCFB4, "storedammoclip" },
    { 0xB439C6E8, "storedammolhclip" },
    { 0x683AE384, "storedammostock" },
    { 0x674F8A10, "storeddisablepain" },
    { 0x62B2EAD5, "storedefaultspecialtydata" },
    { 0x0DFD11C2, "storedifferentobject" },
    { 0x718F50D8, "storedweapon" },
    { 0x7A4FDAED, "storefront" },
    { 0xC1A87E95, "storehandles" },
    { 0x6430F51B, "storereportbestsplittime" },
    { 0xBEB76A73, "stores" },
    { 0xC84CC7AD, "storespawndata" },
    { 0x33C42BD4, "storespecialtydata" },
    { 0x161DF7D9, "storing" },
    { 0x3B537750, "storm" },
    { 0x8556B43B, "storms" },
    { 0xCBE537A5, "stormtrooper" },
    { 0x7335BA64, "story" },
    { 0x6783E8B3, "storytelling" },
    { 0x8AEDFB7A, "stow" },
    { 0x10FE558C, "stow_gun_gadget" },
    { 0x388ED7D7, "stow_inventory" },
    { 0x56B1F484, "stow_on_back" },
    { 0xEF1F5718, "stow_on_hip" },
    { 0x35F9C80D, "stowed" },
    { 0x690797E9, "stowed_weapon_suppressed" },
    { 0x19917E68, "stowedmodelindex" },
    { 0x1069DD51, "stowedshieldmodel" },
    { 0xEDB48036, "stowing" },
    { 0x764732CA, "stowweapon" },
    { 0xCF7D3CCE, "stp_cd" },
    { 0x5A472488, "stpheli" },
    { 0x098561A5, "stpm" },
    { 0xFA42A0E2, "str" },
    { 0x5B9E7D6A, "str_1_full" },
    { 0xB6F6FFA9, "str_1_short" },
    { 0x8E6B5BC3, "str_2_full" },
    { 0x9817CC42, "str_2_short" },
    { 0xE68FBBE4, "str_3_full" },
    { 0x838069DF, "str_3_short" },
    { 0xB1A5AB8D, "str_4_full" },
    { 0x8F247060, "str_4_short" },
    { 0xFEA4654E, "str_5_full" },
    { 0xBD4A51B5, "str_5_short" },
    { 0x3F69DA5B, "str_abort_big_jump2_notify" },
    { 0x7AD0895E, "str_abort_flag" },
    { 0xB60A0E4B, "str_action" },
    { 0xF36B7B46, "str_action_arg" },
    { 0x5C2BCB80, "str_active_flag" },
    { 0x9E4C40C0, "str_actor" },
    { 0xEA052359, "str_adj_zone" },
    { 0x69E64C43, "str_ai_group" },
    { 0x7C759DC3, "str_ai_group_name" },
    { 0x185D5AB8, "str_ai_group_name_2" },
    { 0xB00659A4, "str_ai_targetname" },
    { 0x1921FA75, "str_ai_team" },
    { 0x4FA206F4, "str_aigroup" },
    { 0x48CFED9F, "str_alert_state" },
    { 0x93D4779E, "str_alerted_anim" },
    { 0x95B0C1AF, "str_alias" },
    { 0x30545F10, "str_align" },
    { 0xED87F90D, "str_align_menendez" },
    { 0x302CE25F, "str_align_node" },
    { 0x56E41B23, "str_align_structs" },
    { 0x27A9DA19, "str_align_targetname" },
    { 0x6F9B3666, "str_allies_spawner" },
    { 0xE9338998, "str_ammo_cache_id" },
    { 0xA60475E6, "str_anim" },
    { 0x857F072B, "str_anim1" },
    { 0x137797F0, "str_anim2" },
    { 0xB3DEE3E3, "str_anim_alias" },
    { 0x287AA67B, "str_anim_flag" },
    { 0xACCBE13A, "str_anim_key" },
    { 0x636CD52C, "str_anim_name" },
    { 0x73532FF4, "str_anim_name_add_mortar" },
    { 0x1C37A398, "str_anim_name_ai_caught" },
    { 0x057A8761, "str_anim_name_ai_caught_loop" },
    { 0xCD0936E2, "str_anim_notetrack_notify" },
    { 0xE9E9F095, "str_anim_override" },
    { 0x78C32493, "str_anim_scripted_name" },
    { 0x21352572, "str_anim_struct" },
    { 0xF501F9E9, "str_animation" },
    { 0xD54195F2, "str_animation1" },
    { 0xAF3F1B89, "str_animation2" },
    { 0xF521672B, "str_animname" },
    { 0x5620D4D6, "str_animtype" },
    { 0x12FCB2A6, "str_annihilator" },
    { 0x09A2C7D1, "str_append" },
    { 0xDFBE3539, "str_aquaroom_friendly_category" },
    { 0x97335642, "str_area" },
    { 0x6B6CC590, "str_area_name" },
    { 0x85EE4C22, "str_area_safe" },
    { 0xE5BB1688, "str_attach_model" },
    { 0x422787DD, "str_attachments" },
    { 0x82D84400, "str_attack_node" },
    { 0xD5A743BD, "str_attack_side" },
    { 0xFAB26C19, "str_awarded_by" },
    { 0x9157BFA6, "str_awareness_state" },
    { 0xE871A38B, "str_bad_zone" },
    { 0x09B8C91D, "str_base_curr_color" },
    { 0x5C42FEC1, "str_base_weapon" },
    { 0xB4323B92, "str_beam_model" },
    { 0x18D7FCFB, "str_beam_type" },
    { 0xA87007D9, "str_begin_flag" },
    { 0xEFAC812A, "str_bias_group" },
    { 0x9D7BE881, "str_bik_name" },
    { 0x6E8AD24B, "str_bink_name" },
    { 0xAEBB2010, "str_bit_clientfield" },
    { 0xAA1D4E14, "str_blink_interp_direction" },
    { 0xC775954B, "str_board_location" },
    { 0x1B68A3FF, "str_boarding_anim" },
    { 0x3D7BDB9E, "str_boat_boarding_anim" },
    { 0x8F0A8907, "str_boat_boarding_anim_idle" },
    { 0x620291B3, "str_boat_spawner_targetname" },
    { 0x9C832E6A, "str_boat_vehicle" },
    { 0x8AA71343, "str_boattype" },
    { 0xA5F810C3, "str_body_model" },
    { 0xBFB3D526, "str_body_part_tag" },
    { 0xFE8D5EBB, "str_bone_name" },
    { 0x663AC88A, "str_bonus" },
    { 0x637FB5EA, "str_brake" },
    { 0x95A4CBFE, "str_brake_anim" },
    { 0x8B532A09, "str_brake_loop_anim" },
    { 0x1B69A93E, "str_brake_message" },
    { 0x3319E17B, "str_bridge1" },
    { 0xC1127240, "str_bridge2" },
    { 0xE714ECA9, "str_bridge3" },
    { 0xA52150B6, "str_bridge4" },
    { 0x05FD090D, "str_briggs_alive" },
    { 0x8FD2C127, "str_brushmodelname" },
    { 0xB4FB6373, "str_buildables_build" },
    { 0x8E90ADED, "str_buildables_building" },
    { 0x7E2BBE81, "str_buildables_grab_part" },
    { 0x8A4C79F0, "str_buildables_swap_part" },
    { 0x096C4396, "str_building_flag" },
    { 0xFA38B370, "str_bundlename" },
    { 0x9537A5A9, "str_button" },
    { 0xCF86079E, "str_buttonpress" },
    { 0xB5C53F79, "str_cache_name" },
    { 0xB738F6BD, "str_calling_team" },
    { 0x83E20F46, "str_cam" },
    { 0x907B78AC, "str_camera_anim" },
    { 0x11BDD6B7, "str_cancel" },
    { 0x47BBA9D8, "str_cannon_name" },
    { 0x5ED17D11, "str_cannon_spot" },
    { 0xA03ADCB0, "str_captured_zone" },
    { 0xAF05047D, "str_category" },
    { 0x39C33148, "str_category_snipers" },
    { 0x337054A3, "str_category_startup" },
    { 0x52B8C4F8, "str_challenge_notify" },
    { 0x6C22821B, "str_change_on" },
    { 0x5FF29F5E, "str_character" },
    { 0x88064C84, "str_character_name" },
    { 0x020B83E3, "str_charge_anim" },
    { 0x5A79EA1A, "str_charge_loop_anim" },
    { 0xDD4CAB39, "str_child" },
    { 0xC268F83B, "str_chopper_crash_scene" },
    { 0xEE86278B, "str_chopper_spawner" },
    { 0xF7E145BF, "str_cin_id" },
    { 0xF6E5745D, "str_civ" },
    { 0x0647EC36, "str_civ_targetname" },
    { 0xC6B26197, "str_civilian_killed_targetname" },
    { 0xE548F607, "str_class" },
    { 0xD6CF0E9A, "str_classname" },
    { 0x5DFE8937, "str_cleanup" },
    { 0x70779D6A, "str_cleanup_category" },
    { 0x3851D328, "str_cleanup_civs_groupa" },
    { 0xAA594263, "str_cleanup_civs_groupb" },
    { 0x3D340A68, "str_cleanup_flag" },
    { 0x49F35E50, "str_clientfield" },
    { 0x47653DFF, "str_clientnotify" },
    { 0xAD0C8803, "str_cmd" },
    { 0xDCC990A1, "str_col" },
    { 0xDB4A26A4, "str_collide_trigger" },
    { 0x00F84FBE, "str_color" },
    { 0x7323B355, "str_complete_flag" },
    { 0x9DCBE8F4, "str_condition" },
    { 0xF808A3DC, "str_conditional_flag" },
    { 0xC7919AAD, "str_constant" },
    { 0xDEEC1671, "str_craftable" },
    { 0x7D7D7875, "str_craftable_name" },
    { 0xF1B804B0, "str_craftablename" },
    { 0x8EA57EB1, "str_crafted_clientuimodel" },
    { 0x069AB0BB, "str_crafting" },
    { 0xA95B7165, "str_crane_tag" },
    { 0x9B937BD0, "str_crosby_head" },
    { 0x662EC80C, "str_crouch_flag" },
    { 0x28CA1DF6, "str_cur_stat" },
    { 0x81905577, "str_curr_anim" },
    { 0x4948E564, "str_curr_weapon" },
    { 0x8C24C0C6, "str_current_challenge" },
    { 0x148F7BAD, "str_current_scene" },
    { 0xD2AD19A3, "str_current_shot" },
    { 0x08D742F7, "str_current_weapon" },
    { 0xF4242168, "str_custom_dvar" },
    { 0x22EBA134, "str_custom_notify" },
    { 0x012CE50A, "str_daily_challenge_filename" },
    { 0x3CCE4AE7, "str_damage_mod" },
    { 0x5FFFE0E3, "str_damage_trigger" },
    { 0xC6655035, "str_damage_type" },
    { 0xF53C1504, "str_damage_types" },
    { 0xB2F3668A, "str_damagemod" },
    { 0x7D6F68E0, "str_dead_quote_ref" },
    { 0xF2D8675D, "str_deadquote" },
    { 0x4F6FD39F, "str_death_anim" },
    { 0xDBFB1332, "str_deathanim" },
    { 0x4059C9B4, "str_deathmodel" },
    { 0x8149FEA6, "str_debug" },
    { 0xB59284E1, "str_defalco_alive" },
    { 0xD06300F4, "str_default" },
    { 0x6A1EE8BF, "str_default_vision" },
    { 0x17C92003, "str_delay_flag" },
    { 0xC1F7F5B5, "str_delete_flag" },
    { 0xC1C9DE00, "str_destructibledef" },
    { 0x2FA24527, "str_devgui_path" },
    { 0x10B34225, "str_dialog" },
    { 0x63B9DC7F, "str_dialog_array" },
    { 0x6EC80991, "str_dialog_name" },
    { 0x0C7C22DE, "str_difficulty" },
    { 0x695FDFDE, "str_dir" },
    { 0xD2F053EC, "str_direction" },
    { 0xEC99E627, "str_disable" },
    { 0x9B6A97C5, "str_display_name" },
    { 0xC6A73F35, "str_done" },
    { 0x551003DC, "str_dont_stop_flag" },
    { 0xAF6317CE, "str_door_clip" },
    { 0xBA740F55, "str_door_name" },
    { 0x23967ABB, "str_door_xmodel" },
    { 0x99669CD6, "str_dpad" },
    { 0x2452E55C, "str_dragon" },
    { 0xB3C35E0E, "str_driver_tag" },
    { 0xEC5B1D81, "str_drone_name" },
    { 0x9DA3B5E9, "str_drone_path_name" },
    { 0xBF96BED6, "str_drone_pos" },
    { 0x92DB2360, "str_drone_scene" },
    { 0x2DA5DCD0, "str_drone_type" },
    { 0x84B28752, "str_dvar" },
    { 0x95FD2A44, "str_dvar_zone_monitor" },
    { 0x1CF575FE, "str_dvar_zone_test" },
    { 0x7143940D, "str_dynent_name" },
    { 0x4B381ACA, "str_effect" },
    { 0xD2DD4B98, "str_effect_name" },
    { 0x5F400B78, "str_elec_damage_shellshock_override" },
    { 0x6EDB6F49, "str_elec_shellshock" },
    { 0xD29F1D08, "str_end" },
    { 0x6203C1B5, "str_end_flag" },
    { 0x346817A9, "str_end_idle" },
    { 0xF25E2E66, "str_end_msg" },
    { 0x7C3ADAB0, "str_end_nag_flag" },
    { 0x99CFC4B4, "str_end_notify" },
    { 0x99ACE2B0, "str_end_on" },
    { 0x99B578EB, "str_end_pos" },
    { 0xDF51E12E, "str_end_stomp" },
    { 0xFA0358A0, "str_end_struct" },
    { 0x53E4687D, "str_ender" },
    { 0xA609DB2E, "str_endflag" },
    { 0xAA686173, "str_endon" },
    { 0xA12EB64B, "str_endon2" },
    { 0x2148CDCC, "str_endon_flag" },
    { 0xCFA1FEA5, "str_endon_notify" },
    { 0xD550FA83, "str_enemy" },
    { 0x001CC2E2, "str_enemy_ai_name" },
    { 0x81D8900E, "str_enemy_scene" },
    { 0x92F2AB83, "str_enemy_sp" },
    { 0x19FF26B0, "str_enemy_targetname" },
    { 0x32C6C398, "str_ent" },
    { 0x0E3BC945, "str_ent_flag" },
    { 0xCEC244A2, "str_ent_name" },
    { 0x808D6EE1, "str_ent_targetname" },
    { 0xAA47E68F, "str_equipment" },
    { 0x3C381D2A, "str_equipname" },
    { 0x7AB182F1, "str_era" },
    { 0x5A8FE35B, "str_event" },
    { 0xA0243E11, "str_executioner_targetname" },
    { 0xF8F75A89, "str_exit_early" },
    { 0x148911F8, "str_exit_node" },
    { 0x77996ABE, "str_exploder" },
    { 0xC83F8FC5, "str_extra_cam" },
    { 0xBD3C35FC, "str_extra_info" },
    { 0x18DD9489, "str_extracam_hide" },
    { 0xB4B0F782, "str_extracam_show" },
    { 0x79939297, "str_faction" },
    { 0x3F8BFD4E, "str_factions" },
    { 0xE902AB98, "str_fail_enemy_spawners" },
    { 0x2DCDF1E3, "str_fail_string" },
    { 0x2C7129C1, "str_fall_death" },
    { 0x3D3ABF76, "str_fall_death_loop" },
    { 0x75997B04, "str_fall_death_splat" },
    { 0xC1F9A323, "str_fallback" },
    { 0x72DFABC1, "str_fallback_extra1" },
    { 0x98E2262A, "str_fallback_extra2" },
    { 0x0C8986BC, "str_fallback_flag" },
    { 0x53C1E13D, "str_fallback_nodes" },
    { 0x50950215, "str_fallback_notify" },
    { 0xD5E57A5C, "str_fallback_partner" },
    { 0xE7C6572D, "str_farid_alive" },
    { 0xC3A31D03, "str_female_spawners" },
    { 0x2807366F, "str_field" },
    { 0x62E25A07, "str_field_name" },
    { 0x3D4E0762, "str_fieldname" },
    { 0x190CAB92, "str_filename" },
    { 0x8435C87E, "str_fill" },
    { 0xC50670D5, "str_fill_char" },
    { 0xC588EEC4, "str_final_amp" },
    { 0xE62CF580, "str_final_pos" },
    { 0xF700CFFE, "str_final_weapon" },
    { 0x4AF0BE96, "str_fire_direction_weapon" },
    { 0x4AC85F5F, "str_flag" },
    { 0x12E29BD4, "str_flag1" },
    { 0x84EA0B0F, "str_flag2" },
    { 0x5EE790A6, "str_flag3" },
    { 0xA0DB2C99, "str_flag4" },
    { 0x7AD8B230, "str_flag5" },
    { 0x389813CD, "str_flag_clear" },
    { 0xF52C236E, "str_flag_close" },
    { 0x2D7F7DF8, "str_flag_ender" },
    { 0x4CA0CA3F, "str_flag_ender_2" },
    { 0x60C1E5F7, "str_flag_name" },
    { 0xB04C55EA, "str_flag_open" },
    { 0x4891F24A, "str_flag_override" },
    { 0x17287487, "str_fog" },
    { 0x82CAA3D2, "str_follow_up" },
    { 0xDCCDE714, "str_foot_tag" },
    { 0x267DAC38, "str_for_obj" },
    { 0x78969EEA, "str_force_spawn_kvp" },
    { 0x95AFB0F8, "str_force_spawn_name" },
    { 0x9F8877E4, "str_force_variant" },
    { 0x59E6FED1, "str_frame_amplitudes" },
    { 0x96BD923D, "str_friend" },
    { 0xCF9C46FA, "str_friendly_sp" },
    { 0x425A2933, "str_func_name" },
    { 0x9FC3F655, "str_function_name" },
    { 0xFC9F79E7, "str_fx" },
    { 0xE9637920, "str_fx_anim_start_notify" },
    { 0x71BA10DF, "str_fx_name" },
    { 0x76827902, "str_fx_tag" },
    { 0x424FB8A8, "str_fxanim" },
    { 0x97A0C9CE, "str_fxanim_model" },
    { 0xAF256E14, "str_fxanim_notify" },
    { 0x0631F5D3, "str_gametype" },
    { 0x1C176269, "str_gas_mask_model" },
    { 0x2AF702F6, "str_gender" },
    { 0x822DCF97, "str_glow_fx" },
    { 0xEC0FCA2B, "str_glow_tag" },
    { 0xA6AA789C, "str_goal" },
    { 0xAF629BD1, "str_goal_flag" },
    { 0xAA1C5F7C, "str_goal_node_tn" },
    { 0x5127DC7C, "str_goal_struct" },
    { 0xD3A5D0DB, "str_goal_type" },
    { 0x99ECA9B0, "str_goalnode" },
    { 0x581E17A6, "str_gondola_loc" },
    { 0x6DDDEED3, "str_grab" },
    { 0x60A5D945, "str_grab_notify" },
    { 0xD4EC0AFD, "str_gravity_trap_beam" },
    { 0x74B14A3E, "str_gravityspikes_name" },
    { 0xD1939EC5, "str_grenade_name" },
    { 0xF867C20C, "str_grenade_type" },
    { 0xEF7C9F46, "str_group" },
    { 0x9F48EC9B, "str_group_flag" },
    { 0xDA3B1B4C, "str_group_name" },
    { 0x6D31670E, "str_guidance_type" },
    { 0x932CDE6A, "str_gump" },
    { 0x2FA8664F, "str_gump_loading" },
    { 0x13CB6B4F, "str_gump_to_dump" },
    { 0x2BD40C35, "str_gun" },
    { 0x3B6A47FA, "str_gun_return_notify" },
    { 0x7F7ACA6B, "str_gunner_pos" },
    { 0x2C711729, "str_gunner_tag" },
    { 0x19F4438A, "str_guy" },
    { 0xFB4F34D3, "str_hands_model" },
    { 0x35ACADB7, "str_harper" },
    { 0x0817E343, "str_harper_exit_scene" },
    { 0xE6A64712, "str_headmodel" },
    { 0x7D7C0D45, "str_hero" },
    { 0x4EC380F1, "str_hero_name" },
    { 0xF6E313BE, "str_hint" },
    { 0xD8A4A5AE, "str_hint_string" },
    { 0xFFD2636B, "str_hit_loc" },
    { 0x5AFFF096, "str_hit_location" },
    { 0xBC47BFEE, "str_hitloc" },
    { 0xD4C7A50C, "str_holo_table" },
    { 0x10B07550, "str_hologram" },
    { 0x2F16AB71, "str_hookup_anim" },
    { 0xBFFFA73E, "str_horse_name" },
    { 0x98B1F298, "str_hud_current_state" },
    { 0xDF827AD2, "str_id" },
    { 0x994A19A0, "str_identifier" },
    { 0x222C5413, "str_idle" },
    { 0x08930339, "str_idle_anim" },
    { 0xA39E9F38, "str_idle_loop" },
    { 0x9929B720, "str_idle_loop_anim" },
    { 0x027D29F0, "str_idle_pos" },
    { 0x93ECACDE, "str_idle_scene" },
    { 0x6ABF55C6, "str_idle_stop_notify" },
    { 0x64480BAB, "str_idle_twitch" },
    { 0x6D537AC5, "str_impact_orient" },
    { 0xD646D373, "str_index" },
    { 0xD395C1E9, "str_index_on" },
    { 0x73E71C81, "str_index_time" },
    { 0x6F49AD3D, "str_info" },
    { 0x3FB3FBD6, "str_info_targetname" },
    { 0x55CE4248, "str_infotext" },
    { 0x9290A77B, "str_input" },
    { 0xBB7B88E7, "str_intel_vo" },
    { 0x3E8761A5, "str_interp_direction" },
    { 0xC6BEFE75, "str_intro" },
    { 0xE104B6EB, "str_jingle_alias" },
    { 0x029F7937, "str_joint" },
    { 0x6D1A6EE9, "str_karma_alive" },
    { 0x05E953B6, "str_key" },
    { 0xB48F50DD, "str_key_type" },
    { 0x7904DB12, "str_kill_flag" },
    { 0x8F4B8AAF, "str_kill_notify" },
    { 0xFC2F2466, "str_kill_on_door_notify" },
    { 0x6BEF68AC, "str_kill_trigger_notify" },
    { 0x631585A5, "str_killoff_flag" },
    { 0x1DFA6E50, "str_knockback_ground" },
    { 0xCA3F70C2, "str_kvp" },
    { 0x51BC4479, "str_label" },
    { 0x0E676E3B, "str_lane" },
    { 0x05C9A709, "str_launcher" },
    { 0xF7584029, "str_left_door_name" },
    { 0x812E24DF, "str_leg" },
    { 0xCC890DD4, "str_level_endon" },
    { 0xD9BE0E4F, "str_level_notify" },
    { 0x888233A9, "str_light_effect" },
    { 0xD7C5478B, "str_light_green" },
    { 0xB39741EF, "str_light_red" },
    { 0x880C6AA4, "str_light_targetname" },
    { 0x46639773, "str_line" },
    { 0xF5E52F63, "str_line_1" },
    { 0x83DDC028, "str_line_2" },
    { 0x18E38288, "str_link_type" },
    { 0x355393D4, "str_living_model" },
    { 0xBD87995E, "str_living_view" },
    { 0x47F92145, "str_loc" },
    { 0x1CB7B5B2, "str_local_coordinates" },
    { 0xE6EC90B6, "str_local_player_coordinates" },
    { 0xA130F6E0, "str_localized" },
    { 0x95456B04, "str_location" },
    { 0x7B2C69D2, "str_location_current" },
    { 0x63412232, "str_location_original" },
    { 0xB8F25617, "str_log_string" },
    { 0x31765DC2, "str_lowest_type" },
    { 0x9E1B5A97, "str_lui_string" },
    { 0x3D295E71, "str_machine_targetname" },
    { 0x30904AD7, "str_main_scene" },
    { 0x74DC1372, "str_male_spawners" },
    { 0x395F2528, "str_map_center_origin" },
    { 0x38A54BC5, "str_map_name" },
    { 0xE5152480, "str_mapname" },
    { 0x2BB85F63, "str_master_key_location" },
    { 0x976952C4, "str_match" },
    { 0x394451D8, "str_means_of_death" },
    { 0xBA4C7FF0, "str_meansofdeath" },
    { 0x5FFF9AE3, "str_medal_tag" },
    { 0xF4FD4814, "str_menu" },
    { 0x2F8503E1, "str_menu_action" },
    { 0x3C096274, "str_menu_id" },
    { 0x7AA7A596, "str_message" },
    { 0x8830A536, "str_message_1" },
    { 0x622E2ACD, "str_message_2" },
    { 0x36FEAABB, "str_mod" },
    { 0x34503E6A, "str_mod_final" },
    { 0x803D80BC, "str_mode" },
    { 0x748C4478, "str_model" },
    { 0x8CB6A237, "str_model_child" },
    { 0x051C64D0, "str_model_gender" },
    { 0xC3FFA042, "str_model_name" },
    { 0x5E7B9697, "str_model_parent" },
    { 0xF301DA9A, "str_model_swap" },
    { 0xB7A6C919, "str_model_tag" },
    { 0x16863B81, "str_model_targetname" },
    { 0xA43F2132, "str_model_to_delete" },
    { 0xB6ACCF47, "str_model_type" },
    { 0x9553FF11, "str_modelname" },
    { 0x30397102, "str_mortar" },
    { 0x406CF5F8, "str_move_anim_name" },
    { 0x1F9A2A89, "str_move_dialog" },
    { 0x5FA1957B, "str_movemode" },
    { 0x10118D73, "str_movie" },
    { 0x904992A3, "str_movie_1_name" },
    { 0x950F7232, "str_movie_2_name" },
    { 0x03D837D5, "str_movie_3_name" },
    { 0xBE9372C4, "str_movie_4_name" },
    { 0xF2A39BBF, "str_movie_5_name" },
    { 0x6868B54E, "str_movie_6_name" },
    { 0x3341A761, "str_movie_7_name" },
    { 0x95A162C0, "str_movie_8_name" },
    { 0xF37633BB, "str_movie_9_name" },
    { 0x6D8A08B3, "str_movie_name" },
    { 0x946E0CD4, "str_msg" },
    { 0xCBB15570, "str_name" },
    { 0xBDB3A32B, "str_name_append" },
    { 0xE3A0784F, "str_name_override" },
    { 0x3320392F, "str_name_type" },
    { 0x945CF3D8, "str_narrative_collectable_model" },
    { 0x41D40E8D, "str_nationality" },
    { 0xC3FC6342, "str_nav_volume_traversal" },
    { 0x1E126373, "str_nd" },
    { 0xED870AB3, "str_nd_name" },
    { 0x1ED2DBC6, "str_nd_start" },
    { 0x0B8E4E23, "str_nd_target0" },
    { 0xE58BD3BA, "str_nd_target1" },
    { 0x9710F393, "str_new_anim" },
    { 0xD93F43F3, "str_new_goalvolume" },
    { 0xAC5C8A70, "str_new_weapon" },
    { 0x0280BAC5, "str_next_map" },
    { 0x1E42F40C, "str_next_model" },
    { 0x2F815C91, "str_next_node_name" },
    { 0x15DDF727, "str_next_stat" },
    { 0xAD460D45, "str_nextstruct" },
    { 0x6C5C89E1, "str_node" },
    { 0x56BFD4F3, "str_node_end" },
    { 0x7CA42081, "str_node_key" },
    { 0x0DD77EEC, "str_node_set" },
    { 0xD441F479, "str_node_spawn" },
    { 0x33CCE320, "str_node_start" },
    { 0x6A4360E2, "str_node_targetname" },
    { 0x2A4A7D1F, "str_node_value" },
    { 0x01B2DCE0, "str_nodename" },
    { 0xFE8FEF71, "str_note" },
    { 0x09C4565E, "str_notetrack" },
    { 0x3CACE8F6, "str_notetrack_no_comment" },
    { 0x97D52484, "str_noteworthy" },
    { 0x8B453FD2, "str_notify" },
    { 0xD5DE4B6F, "str_notify1" },
    { 0x63D6DC34, "str_notify2" },
    { 0x89D9569D, "str_notify3" },
    { 0x17D1E762, "str_notify4" },
    { 0x3DD461CB, "str_notify5" },
    { 0xCBCCF290, "str_notify6" },
    { 0x487B795F, "str_notify_alias" },
    { 0x3642DF18, "str_notify_end" },
    { 0x3742EE3F, "str_notify_grid_off" },
    { 0xE01E884B, "str_notify_grid_on" },
    { 0x6F785AA6, "str_notify_message" },
    { 0x0E25242D, "str_notify_on_death" },
    { 0x047041A3, "str_notify_on_fallback" },
    { 0x6DDD7D76, "str_notify_opposite" },
    { 0xC0ADF81F, "str_obj_type" },
    { 0xB04BC952, "str_objective" },
    { 0xFDB17C42, "str_objective_notify" },
    { 0x736F2559, "str_objective_type" },
    { 0x533589F8, "str_off" },
    { 0xB7B6D234, "str_old_hint" },
    { 0xDFC08FEF, "str_old_vision" },
    { 0xF7A90D7F, "str_old_weapon" },
    { 0x0142D9A5, "str_open_container_message" },
    { 0xAFD25DB3, "str_open_notify" },
    { 0xCE588222, "str_opposite_team" },
    { 0x4CE34252, "str_option" },
    { 0x04D0E732, "str_orb_path" },
    { 0x0833BAA4, "str_orig_model" },
    { 0xF5D579AF, "str_origin" },
    { 0x86595979, "str_parent" },
    { 0xFBCF7972, "str_part" },
    { 0x829B9480, "str_part_name" },
    { 0x02BE8AFF, "str_partname" },
    { 0x54AF41FD, "str_parts" },
    { 0x27B32ECE, "str_passenger_tag" },
    { 0xC11C02B4, "str_path" },
    { 0x7A719061, "str_path_start" },
    { 0x840A22A7, "str_paths" },
    { 0xDAA7A601, "str_patrol_anim" },
    { 0x956E89EB, "str_patrol_name" },
    { 0x8E7F33E3, "str_patrol_spawner_targetname" },
    { 0x0DDC5D01, "str_pdf" },
    { 0xD156C379, "str_perk" },
    { 0x812834FF, "str_perk_bottle_weapon" },
    { 0x5DCBF59D, "str_perk_name" },
    { 0xCC38A712, "str_phrase" },
    { 0xB27C6B91, "str_piece" },
    { 0xEB7058D5, "str_piece_name" },
    { 0xB8AE3F78, "str_pieces" },
    { 0x4D3A7A48, "str_pip" },
    { 0x98B4D62C, "str_placing_stat" },
    { 0x32776183, "str_play_sound" },
    { 0xF72DFD2E, "str_player" },
    { 0x60E51667, "str_player_scene" },
    { 0xA7367777, "str_player_zone" },
    { 0x287E6B5C, "str_plea_line" },
    { 0x1CB8FBBB, "str_poi" },
    { 0x29D8544B, "str_pool_name" },
    { 0xCCAA20EB, "str_port_yaw_spot" },
    { 0x60EF80C1, "str_pos" },
    { 0x0BBFD1EE, "str_pose" },
    { 0x9BC566D8, "str_position" },
    { 0x435478B4, "str_power" },
    { 0x6767B2D3, "str_powerup" },
    { 0x76D9AA1E, "str_prev_color" },
    { 0xB7DA5531, "str_prev_level" },
    { 0x699603BD, "str_prev_vision" },
    { 0xFE516931, "str_primary" },
    { 0x1B54809E, "str_primary_grenade" },
    { 0xB7EB5880, "str_primary_weapon" },
    { 0x71143B00, "str_primary_weapon_base" },
    { 0x477D2DCB, "str_prompt" },
    { 0xB37DABD2, "str_punch_element" },
    { 0x614D724F, "str_push_anim" },
    { 0x69361FAF, "str_quest_clientfield" },
    { 0xF7E83DA0, "str_radiant_name" },
    { 0x777BA0FB, "str_rage_breath" },
    { 0x965A12B8, "str_rage_mode" },
    { 0x63B2FC9E, "str_rage_on" },
    { 0xDC42D195, "str_rappel" },
    { 0xAB6CD65D, "str_rappel_message" },
    { 0x21BE2DA5, "str_rappel_spawner_targetname" },
    { 0x524FA1DD, "str_rappel_start_targetname" },
    { 0x27892D04, "str_rappeler" },
    { 0x3B853502, "str_raygun_mark3_upgraded_weapon" },
    { 0xA7A5D493, "str_raygun_mark3_vortex_screen_fx" },
    { 0x8CA66F97, "str_raygun_mark3_weapon" },
    { 0x55311C3E, "str_raygun_mark3lh_upgraded_weapon" },
    { 0x4ECC23EB, "str_raygun_mark3lh_weapon" },
    { 0xFEFDBFA2, "str_react" },
    { 0xBA7431AB, "str_react_scene" },
    { 0xFDF99429, "str_reel" },
    { 0x516C0A1C, "str_ref" },
    { 0x40A130B5, "str_rejoin_convoy_vehicle_node" },
    { 0x9D589D53, "str_remove_on" },
    { 0x07FDA0FF, "str_restore_move_speed" },
    { 0x358B0BA3, "str_restore_state" },
    { 0x6904CC66, "str_result" },
    { 0x3D49585E, "str_ret" },
    { 0xCF1955E8, "str_retrieval_prompt" },
    { 0x6FB35847, "str_return_weapons_notify" },
    { 0x73B23F8A, "str_reward_model" },
    { 0x229CF52F, "str_reward_weapon" },
    { 0x535824A8, "str_rider_line" },
    { 0x91D1367F, "str_riders_boarding_anim" },
    { 0x397C98DA, "str_right_door_name" },
    { 0x7B8B5927, "str_rotate_type" },
    { 0x0B7727E3, "str_row" },
    { 0x97B59086, "str_rpg" },
    { 0x8922B198, "str_rts_mode" },
    { 0xF84D7DFE, "str_rumble" },
    { 0x2EF4C360, "str_rumble_catastrophic" },
    { 0x97D8E8A4, "str_rumble_major" },
    { 0x53CD5B80, "str_rumble_minor" },
    { 0x11FED455, "str_rumble_type" },
    { 0x91FB4AC4, "str_rusher_spawner_targetname" },
    { 0xA67E5398, "str_s_rpg_target" },
    { 0x5F2F4563, "str_s_rpgs_name" },
    { 0xA8A7AC5F, "str_sam_line" },
    { 0xD3D48040, "str_save_name" },
    { 0x37D37EBF, "str_savename" },
    { 0x294306EB, "str_scene" },
    { 0x6FA44E02, "str_scene1_name" },
    { 0x407D05B3, "str_scene2_name" },
    { 0x0B84F04B, "str_scene_1" },
    { 0x997D8110, "str_scene_2" },
    { 0x3CEC2CA1, "str_scene_enemy_attack" },
    { 0x9FBD9D80, "str_scene_loop" },
    { 0x2422BD4B, "str_scene_name" },
    { 0xC233D4D2, "str_scene_prefix" },
    { 0x7021B99D, "str_scene_prefix_n" },
    { 0x79CA9E41, "str_scene_walk" },
    { 0x15ACF6D0, "str_scenedef" },
    { 0xB9E94786, "str_scenename" },
    { 0x7D7CA5D1, "str_script_alias" },
    { 0xE8800AF4, "str_script_id" },
    { 0xA466E982, "str_script_noteworthy" },
    { 0xCA894D1C, "str_script_string" },
    { 0x587E9A1C, "str_seam_list_name" },
    { 0x47DA2249, "str_search" },
    { 0x6CD7321B, "str_search_array" },
    { 0xD4055D17, "str_seat_tag" },
    { 0xFFC2B37D, "str_secondary" },
    { 0xC10CCE9A, "str_secondary_grenade" },
    { 0x306136AC, "str_secondary_weapon" },
    { 0x4477AE24, "str_secondary_weapon_base" },
    { 0x50EF4127, "str_secsystem_name" },
    { 0x83A8D57A, "str_section" },
    { 0x5CBD0572, "str_shader" },
    { 0x8D613880, "str_shader_name" },
    { 0x169D3A99, "str_shader_override" },
    { 0xC368FCD1, "str_shot" },
    { 0x19321990, "str_side" },
    { 0xB5557ED9, "str_siege_shot" },
    { 0xD8A81EBE, "str_size" },
    { 0x6194780B, "str_skipto" },
    { 0xEF342C6D, "str_sm" },
    { 0xEEAA75B9, "str_sm_1" },
    { 0x14ACF022, "str_sm_2" },
    { 0x7DBFE5D9, "str_sm_name" },
    { 0x0A8650FE, "str_smoke_cloud" },
    { 0x5358A260, "str_sniper" },
    { 0xCCBF70FB, "str_sniper_category" },
    { 0x1ADA2EEF, "str_soct_scene" },
    { 0xE91D3E33, "str_soct_targetname" },
    { 0x5D7886BF, "str_sole_tag" },
    { 0x75FD9166, "str_song" },
    { 0x0A12BA5E, "str_song_id" },
    { 0x16782B0E, "str_sound" },
    { 0xDD1EF4EF, "str_sound_loop" },
    { 0xA399E3E4, "str_sound_off" },
    { 0x6F60D1E2, "str_soundalias" },
    { 0xE1C306DD, "str_spawn_count_list" },
    { 0x26870527, "str_spawn_entry" },
    { 0x171F9DBD, "str_spawn_loc" },
    { 0xF3A8E7D6, "str_spawn_manager" },
    { 0x28C25FFB, "str_spawner" },
    { 0x0ED49624, "str_spawner_flag" },
    { 0xC335265B, "str_spawner_name" },
    { 0xE6FE1EA9, "str_spawner_target" },
    { 0x6CC2E848, "str_spawner_targetname" },
    { 0xB88BE120, "str_spawner_targets" },
    { 0x02F6A6AC, "str_spawnerbase" },
    { 0xFEDF5AD6, "str_spawnername" },
    { 0xA0853D9E, "str_spawnpt" },
    { 0xC933872A, "str_spec_model" },
    { 0x26FC0075, "str_species" },
    { 0x759B7BD6, "str_spline" },
    { 0xE33A3387, "str_spline_start" },
    { 0x7E1966C1, "str_spline_then_ai" },
    { 0xA7568DD9, "str_spot" },
    { 0xB10A0ABD, "str_spot_name" },
    { 0xFEEFCF6E, "str_sq_bp_active_light" },
    { 0x75FBFAE5, "str_stage" },
    { 0x124BBC51, "str_stage_name" },
    { 0xF69C53DD, "str_stance" },
    { 0x50835AF4, "str_star_yaw_spot" },
    { 0x296F19BC, "str_start_idle" },
    { 0xCC525A1A, "str_start_node" },
    { 0x84F693BD, "str_start_notify" },
    { 0xCE4610FC, "str_start_point" },
    { 0x8F9E8E36, "str_start_scene" },
    { 0xE7155CD1, "str_start_stomp" },
    { 0xDAAA9565, "str_start_struct" },
    { 0x7A1B32E1, "str_starter_loc" },
    { 0xC8E3D0BD, "str_starting_location" },
    { 0xE5A59855, "str_startup_scene" },
    { 0xD7F161B3, "str_stat" },
    { 0x835171F3, "str_stat_name" },
    { 0xD51654A4, "str_state" },
    { 0xE430786C, "str_stealth_name" },
    { 0x3DD1BFFF, "str_stick" },
    { 0xE68AE8E0, "str_strip_lh" },
    { 0xA6D0D9EE, "str_strip_lh_from_crossbow" },
    { 0xA8809770, "str_strip_lh_or_dw" },
    { 0x7CE28596, "str_struct" },
    { 0xC7CADAB2, "str_struct_goal_name" },
    { 0xF45B435C, "str_struct_name" },
    { 0xD9DA1F9F, "str_struct_names" },
    { 0x6B44423E, "str_struct_starts" },
    { 0x95958253, "str_struct_targetname" },
    { 0x3F5C9BDB, "str_structname" },
    { 0xA09214FA, "str_structnames" },
    { 0xE81EDD09, "str_structs" },
    { 0x745DA6ED, "str_structs_name" },
    { 0x985E38FA, "str_suffix" },
    { 0x5BAE5F12, "str_surface" },
    { 0x0BF44419, "str_surface_type" },
    { 0x3BA245AB, "str_swing_anim" },
    { 0xA855E362, "str_swing_anim_thread" },
    { 0xD957D721, "str_switch" },
    { 0xF6D58016, "str_system" },
    { 0xFCD8D8A2, "str_table_start" },
    { 0xC6107C9B, "str_tag" },
    { 0xA1195428, "str_tag1" },
    { 0x1320C363, "str_tag2" },
    { 0xA19C44F8, "str_tag_flash" },
    { 0xC387440D, "str_tag_left" },
    { 0xE917433B, "str_tag_name" },
    { 0xD2182A3E, "str_tag_pivot" },
    { 0x93329A30, "str_tag_right" },
    { 0x3E24BF99, "str_tag_tesla_death_fx" },
    { 0x37150CD6, "str_tag_tesla_shock_eyes_fx" },
    { 0x88ED913C, "str_tag_turret_left" },
    { 0xF469CC13, "str_tag_turret_right" },
    { 0x824D5A76, "str_tagname" },
    { 0x6CABC9D6, "str_taken" },
    { 0x75867979, "str_tank_down_line" },
    { 0x6989FA90, "str_tank_tag" },
    { 0xEF913FB5, "str_tank_wave_over_line" },
    { 0x59EBC8E2, "str_tanker_model" },
    { 0x5F6003EA, "str_target" },
    { 0x6F18748E, "str_target_group" },
    { 0xC7DDFAD3, "str_target_names" },
    { 0x4B2EEC09, "str_target_node" },
    { 0xA734AA18, "str_target_relay" },
    { 0x8F7514B1, "str_target_spot" },
    { 0xA868727E, "str_target_struct" },
    { 0xA0B86A77, "str_targetname" },
    { 0x73C4129C, "str_targetname1" },
    { 0xE5CB81D7, "str_targetname2" },
    { 0x28B14510, "str_targetname_allies" },
    { 0x2ACFABA1, "str_targetname_source" },
    { 0x27BD3F45, "str_targetname_target" },
    { 0x6D4542E6, "str_team" },
    { 0x33091D47, "str_teleport_point" },
    { 0x395CE040, "str_teleport_to" },
    { 0xDCC91533, "str_temp_planes" },
    { 0xE1416973, "str_tesla_current_tube_effect" },
    { 0xFDBE8054, "str_text" },
    { 0xEEAB2C04, "str_text_to_show" },
    { 0xCAF38A88, "str_thread_cleanup" },
    { 0xD5F63E2F, "str_threat_bias_group" },
    { 0x2D866F64, "str_threat_type" },
    { 0xF67E0CE6, "str_time" },
    { 0xD6FD6D9D, "str_to_craft" },
    { 0xE02BE5BB, "str_to_num" },
    { 0xB110F418, "str_token" },
    { 0x4C701D34, "str_trap" },
    { 0x7FE94F9C, "str_traversal_data" },
    { 0x4FAEFC23, "str_trig" },
    { 0x095EBF14, "str_trig_idle" },
    { 0x1767D763, "str_trig_name" },
    { 0xCD83AFDF, "str_trig_react" },
    { 0xB93B5B10, "str_trig_targetname" },
    { 0xDB803BCF, "str_trigger" },
    { 0xDB65D1FD, "str_trigger_generator_name" },
    { 0xFFA6BDA7, "str_trigger_name" },
    { 0xB0DCAED1, "str_trigger_notify" },
    { 0xB22A2AC4, "str_trigger_targetname" },
    { 0xD72A94C2, "str_triggername" },
    { 0x06FC9C53, "str_tube" },
    { 0xBBB212D6, "str_turn_off_notify" },
    { 0x03199AEF, "str_turret" },
    { 0xEB446787, "str_turret_name" },
    { 0x07B81749, "str_type" },
    { 0xF50690E8, "str_typename" },
    { 0x5DECDF40, "str_types" },
    { 0xB13D1660, "str_unbuild_notify" },
    { 0x5D83A0D7, "str_unlock_method" },
    { 0xE6741EB9, "str_upgraded_staff_weapon" },
    { 0x3764261A, "str_use_hint" },
    { 0x2F49047D, "str_use_primary_if_none_exists" },
    { 0x4AA45619, "str_user_tag" },
    { 0x64F5EECE, "str_val" },
    { 0x2111F464, "str_valid_weapon" },
    { 0xB8DA2278, "str_value" },
    { 0xF0AB9680, "str_var" },
    { 0x85DC129F, "str_variable_id" },
    { 0x7C781ECD, "str_vec" },
    { 0xD9AF7A5C, "str_veh_pathnode" },
    { 0x36EC5BA7, "str_veh_spawner" },
    { 0x2ABB7C9B, "str_veh_targetname" },
    { 0x1C74455B, "str_vehicle" },
    { 0xBBF2F6AB, "str_vehicle_info_volume" },
    { 0x1122254A, "str_vehicle_node" },
    { 0x0006EBB6, "str_vehicle_spawner" },
    { 0x63E476C3, "str_vehicletype" },
    { 0x30B2017B, "str_vending_machine_targetname" },
    { 0x6A26752D, "str_vh_anim" },
    { 0x3E15771C, "str_vh_targetname" },
    { 0x1189FE51, "str_viewmodel" },
    { 0x745D5695, "str_viewmodel_name" },
    { 0xC8BBF115, "str_vinyl_record" },
    { 0x892EAADD, "str_vision" },
    { 0xDCB9964A, "str_vision_new" },
    { 0x5722B22F, "str_vision_old" },
    { 0x052CF5E0, "str_vision_set" },
    { 0xCC14D48F, "str_visionset" },
    { 0x3FE3C7C8, "str_vo" },
    { 0xEAEE6479, "str_vo_being_spoken" },
    { 0x83B8B3E3, "str_vo_category" },
    { 0xD0FD3B65, "str_vo_line" },
    { 0x04777D94, "str_vol" },
    { 0x9295C02B, "str_vol_civ" },
    { 0x8A7C6B8F, "str_volume" },
    { 0xED44C1FF, "str_volume_key" },
    { 0xE512E3AD, "str_volume_value" },
    { 0x0C45ED60, "str_vox" },
    { 0x4B66E891, "str_vox_file" },
    { 0x9D2951E8, "str_vox_id" },
    { 0x931CAE4D, "str_vox_line" },
    { 0x4DF8B3B4, "str_vtol_name" },
    { 0xEFEF8F76, "str_wait" },
    { 0xD32ADC4B, "str_wait_flag" },
    { 0xDD5753AF, "str_wait_scene" },
    { 0xC02E5073, "str_waittill" },
    { 0xFF387BFC, "str_walk_mode" },
    { 0x0AFEF9B0, "str_warp_point" },
    { 0xE85F1D1F, "str_water_values" },
    { 0x2A83DA8C, "str_weap_name" },
    { 0x4F1C77B0, "str_weap_octobomb" },
    { 0xEC0AB933, "str_weap_octobomb_upgraded" },
    { 0x94300349, "str_weap_staff" },
    { 0x2FFD9881, "str_weapon" },
    { 0xD8C41E28, "str_weapon_1st" },
    { 0xDDF8B538, "str_weapon_2nd" },
    { 0x5030D28C, "str_weapon_check" },
    { 0xCAC4AECB, "str_weapon_current" },
    { 0x50E9E288, "str_weapon_disable" },
    { 0x2EC14483, "str_weapon_full" },
    { 0x875358E1, "str_weapon_key" },
    { 0xC3484634, "str_weapon_last" },
    { 0xF8A1F2FB, "str_weapon_model" },
    { 0x3B6449C5, "str_weapon_name" },
    { 0xCDFCA70F, "str_weapon_on" },
    { 0xA3A5204E, "str_weapon_temp" },
    { 0xE45195D7, "str_weapon_time" },
    { 0x0132FAE4, "str_weapon_time_over" },
    { 0x62386D0C, "str_weapon_type" },
    { 0x6D0721FC, "str_weapon_with_attachment" },
    { 0xF1082FBF, "str_weapon_with_attachments" },
    { 0x1230EE80, "str_weaponname" },
    { 0xB03DD059, "str_what_happened" },
    { 0x9E245F82, "str_which_spots" },
    { 0x86A3391A, "str_widget_clientuimodel" },
    { 0x3307F547, "str_wind" },
    { 0xC9086633, "str_woods_anim" },
    { 0x1E130FF7, "str_wounded_anim" },
    { 0x63ABE95E, "str_wpn_sound" },
    { 0xCA0BDCBA, "str_xmodel" },
    { 0x50781624, "str_zombie_blood_model" },
    { 0x167C0DBD, "str_zombie_model" },
    { 0x3180DCB3, "str_zone" },
    { 0x1AB14CD0, "str_zone1" },
    { 0x8CB8BC0B, "str_zone2" },
    { 0xF53CF453, "str_zone_compare" },
    { 0xC207B762, "str_zone_list" },
    { 0x552CFFBF, "str_zone_list_active" },
    { 0x0B7182F1, "str_zone_list_occupied" },
    { 0x2D958B32, "str_zone_mgr_mode" },
    { 0xC3B922F3, "str_zone_name" },
    { 0x6B163EE5, "str_zone_notify" },
    { 0xE7120AF4, "straction" },
    { 0x455EB14C, "strafe" },
    { 0xCAA7EEDB, "strafe_a_moving_target" },
    { 0x631B8DB1, "strafe_a_zero" },
    { 0x9A716C45, "strafe_accel" },
    { 0xF9FE7DAF, "strafe_aim_free_look" },
    { 0x0275B9EE, "strafe_call_fail_time" },
    { 0x0289A7C4, "strafe_clamp_y" },
    { 0x749116FF, "strafe_clamp_z" },
    { 0x16A9C00F, "strafe_dist" },
    { 0x8651707B, "strafe_distance_attribute" },
    { 0x60E9A4C3, "strafe_dt" },
    { 0xB97E9085, "strafe_go" },
    { 0xA07E4BB6, "strafe_increment" },
    { 0xD81BBF8B, "strafe_level" },
    { 0xCE958386, "strafe_max_accel" },
    { 0x7A51C733, "strafe_max_vel" },
    { 0x5568CCC7, "strafe_org" },
    { 0x947503C4, "strafe_player" },
    { 0xA59D6344, "strafe_player_plane_fire_guns" },
    { 0xC782062F, "strafe_pos" },
    { 0x6317E8B6, "strafe_run_called" },
    { 0x38C37934, "strafe_shooting" },
    { 0x4C01DCDE, "strafe_side" },
    { 0x141CA569, "strafe_speed_attribute" },
    { 0x363573E8, "strafe_squibs" },
    { 0x5E06C889, "strafe_start" },
    { 0x3105F853, "strafe_stop" },
    { 0x66EA921C, "strafe_vel" },
    { 0xC67F2488, "strafe_vel_y" },
    { 0x388693C3, "strafe_vel_z" },
    { 0x28F51860, "strafed" },
    { 0x3F7CB93F, "strafedirection" },
    { 0x1FF1CD99, "strafekillcam" },
    { 0x716847D6, "strafemax" },
    { 0x56731C28, "strafemin" },
    { 0x6D2B9D66, "strafer" },
    { 0x5FC53C73, "straferun" },
    { 0xAF1FEAF1, "straferun_max_health" },
    { 0xC6A3E2B6, "straferunbda" },
    { 0x7326DAAD, "straferunchafffx" },
    { 0xCB0C7131, "straferuncontrailfx" },
    { 0xA40780C8, "straferunexitunits" },
    { 0x19442D44, "straferunexplodefx" },
    { 0x8345483B, "straferunexplodesound" },
    { 0xA6CF6346, "straferunflaredelay" },
    { 0xDD938D1D, "straferungunlookahead" },
    { 0xBD64A94A, "straferungunoffset" },
    { 0x4C115AFD, "straferungunradius" },
    { 0x87216C58, "straferungunsound" },
    { 0x13E81457, "straferungunweapon" },
    { 0x12890FC7, "straferunkillcams" },
    { 0x6B299C16, "straferunkills" },
    { 0x5BE3CDB7, "straferunkillsbeforeexit" },
    { 0x3F02A5A5, "straferunmaxstrafes" },
    { 0x98846D62, "straferunmodel" },
    { 0x3DC81F9E, "straferunmodelenemy" },
    { 0x09DCA5DD, "straferunnumkillcams" },
    { 0xF2044C5C, "straferunnumrockets" },
    { 0x3F8E78A4, "straferunrocketdelay" },
    { 0x4868371C, "straferunrockettags" },
    { 0xFCBC17BF, "straferunrocketweapon" },
    { 0x03D72B9B, "straferunshellshock" },
    { 0xAFEAD57B, "straferunshellshockduration" },
    { 0xAC7A22C5, "straferunshellshockradius" },
    { 0x80F474D9, "straferunvehicle" },
    { 0x932E17CF, "strafes" },
    { 0xE0C73614, "strafesidedotmax" },
    { 0x0B59415A, "strafesidedotmin" },
    { 0x141B3F07, "strafespacing" },
    { 0x70C7780A, "straffing_drone" },
    { 0x7C0654F5, "strafing" },
    { 0x82FECFAE, "strafing_runs" },
    { 0xAD2DF685, "stragglers" },
    { 0x6B543A32, "stragglers_chase" },
    { 0xCC417A7F, "straight" },
    { 0x83DCD182, "straight_weight" },
    { 0x4E45A09E, "straighten" },
    { 0xE64F8A42, "straighter" },
    { 0x42BDC6CE, "straightforward" },
    { 0xB8E8C8BC, "straih" },
    { 0x6CE3D3EA, "strain" },
    { 0x90A36540, "strait" },
    { 0xBE29627A, "stranded" },
    { 0x43EF582F, "strange" },
    { 0x46707B6E, "strangeness" },
    { 0x57868F66, "strangers" },
    { 0x50642784, "strangle_number_attack_number_1" },
    { 0xC26B96BF, "strangle_number_attack_number_2" },
    { 0x146A5851, "strangled" },
    { 0xDB521E7E, "strap1" },
    { 0xB54FA415, "strap2" },
    { 0xDE9051C9, "strat" },
    { 0xBB0681C9, "strategic" },
    { 0xEBBDBC96, "strategy" },
    { 0x0492CC32, "straw" },
    { 0x80AB944C, "stray" },
    { 0xED3770CF, "strays" },
    { 0x1E4B20CB, "streak" },
    { 0xE1FCF45D, "streak_hud" },
    { 0x4174E65C, "streak_hud_shadow" },
    { 0xB8DB1C19, "streak_time" },
    { 0x2ACD9497, "streak_timer_color_pulse" },
    { 0xE0787823, "streak_val" },
    { 0x0E1DF1B0, "streakcount" },
    { 0x6E5A3F08, "streakdir" },
    { 0xAFDD7766, "streakname" },
    { 0xA4E094B0, "streaknotify" },
    { 0x7D731219, "streakplusone" },
    { 0xC080D92A, "streaks" },
    { 0x9785D168, "streakval" },
    { 0x6A50159D, "stream" },
    { 0x6EACE780, "stream_epic_models" },
    { 0xDBFCE020, "stream_helper" },
    { 0x6D697025, "stream_hint_radio_model" },
    { 0x95C0A8C7, "stream_lod0" },
    { 0x6FBE2E5E, "stream_lod1" },
    { 0x49BBB3F5, "stream_lod2" },
    { 0x23B9398C, "stream_lod3" },
    { 0xFDB6BF23, "stream_lod4" },
    { 0xD7B444BA, "stream_lod5" },
    { 0xB1B1CA51, "stream_lod6" },
    { 0x8BAF4FE8, "stream_lod7" },
    { 0x4CB8F56F, "stream_lod_exclude_highest" },
    { 0x2BB5A63C, "stream_lod_highest" },
    { 0x04C09F76, "stream_lod_lowest" },
    { 0xCACB0E2E, "stream_mip0" },
    { 0xF0CD8897, "stream_mip1" },
    { 0x7EC6195C, "stream_mip2" },
    { 0xA4C893C5, "stream_mip3" },
    { 0x32C1248A, "stream_mip4" },
    { 0xC1D0BB54, "stream_mip_exclude_highest" },
    { 0x2929941B, "stream_mip_highest" },
    { 0xDB2B60CF, "stream_mip_lowest" },
    { 0xA2B7620D, "stream_model_for_time" },
    { 0xBEFDB48C, "stream_no_lods" },
    { 0x27FD8E45, "stream_no_mips" },
    { 0xA36EFF6C, "streamdumpteamindex" },
    { 0x4208344A, "streamed" },
    { 0x2DE5828C, "streamer" },
    { 0x51DD0275, "streamer01" },
    { 0x77DF7CDE, "streamer02" },
    { 0x8C4E8662, "streamer_01" },
    { 0x664C0BF9, "streamer_02" },
    { 0xE4A6D1A2, "streamer_ent" },
    { 0x8DF7CE2C, "streamer_hint" },
    { 0xCC9B55F4, "streamer_hint_timeout" },
    { 0xE504D0DC, "streamer_request_completed" },
    { 0x11A89B44, "streamer_wait" },
    { 0x7CEE47E7, "streamerhint" },
    { 0xACB4609C, "streamermodelhint" },
    { 0xD4F82627, "streamerrequest" },
    { 0xDE2C4B0F, "streamers" },
    { 0x32CC2AA4, "streamerwatcher" },
    { 0x26A3F68D, "streamfksl" },
    { 0x28FC7E9A, "streamhint" },
    { 0x0885D731, "streamhintent" },
    { 0x887CC00B, "streamhintent_btr_fire" },
    { 0x5A06D273, "streamhintent_btr_hijack" },
    { 0x9A0D89C1, "streamhintent_crash_limo" },
    { 0x2F1C06C6, "streamhintent_glass_room" },
    { 0x8F4D4002, "streamhintent_heli_pad" },
    { 0xAC8FFC0F, "streamhintsafehouse" },
    { 0xFB964266, "streamhintwindow" },
    { 0x7A7D9A8B, "streaming" },
    { 0x8AF68970, "streaming_binks_restored" },
    { 0xE84AA5D7, "streamline" },
    { 0xACC874F1, "streamlined" },
    { 0x282024DC, "streams" },
    { 0x20AEA930, "street" },
    { 0xC576E151, "street_1_bdog_killed" },
    { 0xF5DA0A65, "street_action" },
    { 0x5EC976D3, "street_action_tanks" },
    { 0x2D52CFA7, "street_ai_begin" },
    { 0x2EC959D5, "street_ai_spawn_funcs" },
    { 0x96FB29F4, "street_ais" },
    { 0xFE9CA594, "street_alley_chasers" },
    { 0x05EE51C5, "street_allies" },
    { 0x74812175, "street_ambient_rocket_think" },
    { 0xCCC8A267, "street_ambient_rockets" },
    { 0x3A5E218B, "street_ambush" },
    { 0x2C3FC829, "street_anim_entries" },
    { 0xD010DFCD, "street_asylum_roof_shreks_strat" },
    { 0x48363889, "street_badplace" },
    { 0xD26EDF02, "street_balcony_damage_listener" },
    { 0x811EAA1F, "street_balcony_run" },
    { 0xBB58BCE1, "street_balcony_runners" },
    { 0x786FEB65, "street_balcony_take_position" },
    { 0xB40DC015, "street_bank_flag_anims" },
    { 0xE5B3BB7A, "street_bank_flag_sequence" },
    { 0x0E273BA4, "street_bank_window" },
    { 0x6D0A4204, "street_bank_window_exp" },
    { 0xEED846B1, "street_barricade_clip" },
    { 0xC57FC161, "street_barricade_models" },
    { 0x23E9130D, "street_battle" },
    { 0xA6954CCA, "street_battle_finished" },
    { 0x0AA3CFF5, "street_battle_start_vo_done" },
    { 0xC3161D57, "street_battle_started" },
    { 0xE582D69B, "street_bdog_back" },
    { 0x8364B9C7, "street_bdog_front" },
    { 0xEDEA3012, "street_bdogs" },
    { 0x0BD5DB8E, "street_bdogs_killed" },
    { 0xCA08DDDD, "street_blockade_guys" },
    { 0x34AF18F9, "street_bowman_setup" },
    { 0x98A867A8, "street_bridge_spawner_think" },
    { 0x03F8F1FE, "street_cart_guy_died" },
    { 0xCED176D0, "street_cart_listener" },
    { 0x7946C59D, "street_cart_vo" },
    { 0x343C2A05, "street_chains" },
    { 0x6DC785F8, "street_charge_guys_setup" },
    { 0xC768B20C, "street_chopper_group" },
    { 0x2FF71E1E, "street_claw" },
    { 0xFFDE50B8, "street_claw_back" },
    { 0x1D5E2026, "street_claw_back_vo" },
    { 0x11D0DE5B, "street_claw_dead" },
    { 0xB8D46535, "street_claw_death_watch" },
    { 0x3C0A60E6, "street_claw_exposed_watcher" },
    { 0x31106492, "street_claw_front" },
    { 0xC80ED998, "street_claw_front_vo" },
    { 0x309FDF63, "street_claw_vo_grenade" },
    { 0x1AA5B14C, "street_claw_vo_player" },
    { 0x22E13421, "street_cleanup" },
    { 0x767520B1, "street_cleared" },
    { 0x4B7D80F9, "street_color_reinforcements" },
    { 0x26BF857E, "street_complete" },
    { 0x8584D68C, "street_converge" },
    { 0x4C9B22CF, "street_deathposes" },
    { 0xBBAFCFE1, "street_dialogue" },
    { 0x367D44C2, "street_elec_on_ground" },
    { 0xBFA3D146, "street_end" },
    { 0xEB79F267, "street_end_go" },
    { 0x72D1A85C, "street_end_guys_think" },
    { 0x8A0199DD, "street_end_ready_and_go" },
    { 0x899297AB, "street_end_watcher" },
    { 0x32676127, "street_execution" },
    { 0x7E8F1F10, "street_execution_abort" },
    { 0x3C9116AD, "street_execution_anim" },
    { 0x8639476A, "street_execution_bullet_shield" },
    { 0x608513FE, "street_execution_gunshotfx" },
    { 0x98842E04, "street_execution_victimdeath" },
    { 0x07E14E12, "street_execution_waitfor_spawn" },
    { 0x16E8CA65, "street_executioners" },
    { 0xEB720607, "street_executions_dialogue" },
    { 0xB3F5A903, "street_executions_playerspeed" },
    { 0xCCDC4241, "street_fail_condition" },
    { 0x3103E5B0, "street_fakefire" },
    { 0x85128BA3, "street_fight" },
    { 0x9F2CEFD8, "street_fight_over" },
    { 0xAC5770E4, "street_fire_hydrant" },
    { 0xF27F90CA, "street_fire_locations" },
    { 0xB716230D, "street_first_floodspawners" },
    { 0x92CD9F7D, "street_harper_finish" },
    { 0x16941FA2, "street_harper_logic" },
    { 0xDED1BC09, "street_heroes_setup" },
    { 0x934768C7, "street_hotdog_cart" },
    { 0x3392A721, "street_kill_extra_enemies" },
    { 0x4EEBA75C, "street_kill_zone_player_damage" },
    { 0x2C1E89AF, "street_laser_light_show" },
    { 0xC6ACD48E, "street_metalstorm_think" },
    { 0x4BED624F, "street_mg" },
    { 0xB1B7C4D6, "street_mg_spawners_strat" },
    { 0x03A698FD, "street_mg_target" },
    { 0x93F7A1F1, "street_mg_turret_loop" },
    { 0x9CD94782, "street_mg_turret_setup" },
    { 0x39064D01, "street_mgunner" },
    { 0xA158631D, "street_move_remaining_ais" },
    { 0x182101FB, "street_objectives" },
    { 0x7536F140, "street_opitimizations" },
    { 0x52DC4DD3, "street_player_must_die" },
    { 0x2260C675, "street_quadrotors" },
    { 0x13275371, "street_regroup" },
    { 0x1494063A, "street_respawner_clear" },
    { 0x82C17B37, "street_retreater_setup" },
    { 0xC70CC13D, "street_reznov_setup" },
    { 0x518947F1, "street_run_ahead_check" },
    { 0x11DC5EDD, "street_safety" },
    { 0xE83FDECE, "street_scene_screams" },
    { 0xFC0C84D1, "street_seeker_strat" },
    { 0x5CC3D7FD, "street_seekers_1" },
    { 0x82C65266, "street_seekers_2" },
    { 0xB6DC2AE0, "street_shellshock_and_visionset" },
    { 0x4774F2D5, "street_sign_damage_trigger" },
    { 0x6AFAADA5, "street_snipers" },
    { 0x7E4CA08D, "street_spawn_bdog_middle" },
    { 0xBAEC0A1F, "street_spawn_managers" },
    { 0x81AA6F45, "street_spawn_scripted_cop_car" },
    { 0x888615A0, "street_spotlight_on_gun" },
    { 0x6C988305, "street_start" },
    { 0x9811457F, "street_stay_on_mg" },
    { 0xECEB7A49, "street_terrorist_spawnfunc" },
    { 0x88C4B1BF, "street_train_surprise" },
    { 0xC74491D3, "street_treasure_chest_init" },
    { 0x16314FE1, "street_trigger" },
    { 0x7C825D48, "street_truck_explosion" },
    { 0xEE26053A, "street_veh_unload" },
    { 0x48CED074, "street_vehicles" },
    { 0x74DC260E, "street_vo" },
    { 0x094FDA5C, "street_vo_lapd_callouts" },
    { 0xEA204BE1, "street_vo_pmc_callouts" },
    { 0x544832DD, "street_walker_delay" },
    { 0x3FB158F8, "street_walker_think" },
    { 0x541C700C, "street_walkers" },
    { 0x8DC8B5DA, "street_weapons" },
    { 0xE51E1F46, "street_yemeni_enter_building" },
    { 0x408145FE, "streetbattle" },
    { 0x0F5E35EC, "streetdudes_findyou" },
    { 0xB762E008, "streetguys_objective" },
    { 0xDD7351AC, "streetlight" },
    { 0x0BB0C995, "streetlight01" },
    { 0x31B343FE, "streetlight02" },
    { 0x57B5BE67, "streetlight03" },
    { 0x4DA46588, "streetlight04" },
    { 0x73A6DFF1, "streetlight05" },
    { 0xBBE08601, "streetlights_setup" },
    { 0xF5C2069B, "streets" },
    { 0xED449B54, "streets_advance_bridge" },
    { 0x7545AB33, "streets_advance_right" },
    { 0x61072D84, "streets_attack_heli_think" },
    { 0xBCD0DD7A, "streets_helis_init" },
    { 0xACB726CC, "streets_intro_vignettes" },
    { 0x5C4B32DE, "streets_jets_group" },
    { 0xA5A0FB62, "streets_set_flags_on_aigroup_clear" },
    { 0x60BCABF9, "streets_spawn_full_count" },
    { 0x0A2C4F3E, "streets_start_spawners" },
    { 0x07D938DB, "streets_vo" },
    { 0x15674869, "streets_weaver_attack_heli_think" },
    { 0xFADE250E, "strela" },
    { 0x0D594B29, "strela_event_failsafe" },
    { 0x4169BFC2, "strela_failsafe" },
    { 0x2D598DD3, "strela_found" },
    { 0x04CF6F84, "strela_friendly" },
    { 0x5BC08FF9, "strela_friendly_ai" },
    { 0x69C57CE1, "strela_heli_1" },
    { 0x8FC7F74A, "strela_heli_2" },
    { 0x2F15BE5D, "strela_heli_firing" },
    { 0xA2E1E235, "strela_heli_shoot" },
    { 0xF9142F20, "strela_heli_think" },
    { 0x1A479165, "strela_helis_init" },
    { 0x04DF4650, "strela_is_attached" },
    { 0xAB1A494D, "strela_nag_lines" },
    { 0x9711039A, "strela_struct" },
    { 0x7CC8DB01, "strela_wait_for_pickup" },
    { 0x7CAE25EA, "strella_guard" },
    { 0x220843CC, "strella_guard_run" },
    { 0x51AB3D31, "strella_loop" },
    { 0x1889DDEA, "strendon" },
    { 0x77FDB408, "strendswith" },
    { 0x3860F32E, "strength" },
    { 0x17CCBCE1, "strength_test_button_prompt" },
    { 0x4914A789, "strength_test_complete" },
    { 0x4C662B7E, "strength_test_fail_timer" },
    { 0xC3344B8E, "strength_test_fighting_rumble" },
    { 0x668BD84D, "strength_test_screen_out" },
    { 0xBED59CB0, "strength_test_start" },
    { 0xC1CC4947, "strength_test_update" },
    { 0xA8256351, "strengths" },
    { 0xC1354F8E, "strengthtest" },
    { 0x7BF41615, "strengthtest_attack" },
    { 0xBB64C88E, "strengthtest_blur" },
    { 0x45D4027D, "strengthtest_button_presses" },
    { 0x1F5BB6A3, "strengthtest_custom_fail" },
    { 0x3FF44679, "strengthtest_enemy_attack_audio" },
    { 0xCE4A60A7, "strengthtest_fail_time" },
    { 0x92E02099, "strengthtest_fight_looping_audio" },
    { 0xE9819154, "strengthtest_max_button_presses" },
    { 0xD820D593, "strengthtest_speed_throw" },
    { 0x6EC8A8D8, "strengthtest_text" },
    { 0x820EAB42, "strengthtest_text_and" },
    { 0x7D34170C, "strengthtest_text_press" },
    { 0xCFBA6D30, "strengthtest_text_to_bash_window" },
    { 0x0353E685, "stress" },
    { 0xE7F77372, "stressed" },
    { 0x48B7F024, "stretch" },
    { 0xF397F487, "stretched" },
    { 0x6FB0BCA1, "stretcher" },
    { 0x6A662A0E, "stretcher_ai" },
    { 0x2D3B0284, "stretcher_angles" },
    { 0x08B61B93, "stretcher_anim" },
    { 0x996615B8, "stretcher_anim_loop" },
    { 0xF8B261E6, "stretcher_anim_single" },
    { 0x3F13CB3E, "stretcher_clip" },
    { 0xE9484B69, "stretcher_front_height_offset" },
    { 0x9A496B35, "stretcher_front_offset" },
    { 0x4EEBF6A2, "stretcher_front_origin" },
    { 0x0A11184D, "stretcher_guys_scene" },
    { 0xDD7B9220, "stretcher_length" },
    { 0x8C53989E, "stretcher_rear_height_offset" },
    { 0xE5B47B74, "stretcher_rear_offset" },
    { 0x44B3BCDB, "stretcher_rear_origin" },
    { 0x7A9930C1, "stretcher_vector" },
    { 0x611BF448, "stretchers" },
    { 0x49AE4238, "stretches" },
    { 0xFF8FE804, "stretching" },
    { 0xE1F7DD94, "strewn" },
    { 0xAB68F8FB, "strexplosion" },
    { 0x492611E3, "strfind" },
    { 0xF20EB7E8, "strflag" },
    { 0x4EB4DD6E, "strict" },
    { 0xC4D4AEB7, "stricter" },
    { 0x19685433, "strictly" },
    { 0xDB5172DA, "strig" },
    { 0x7D32E1AE, "strigger_noteworthy" },
    { 0xBDFD1991, "strigger_targetname" },
    { 0x4D6B3981, "striggername" },
    { 0x31A00646, "stright" },
    { 0x33936E22, "stright_up_player" },
    { 0x9DF8B12F, "strike" },
    { 0x22EDE9C8, "strike_ok" },
    { 0x3C714D54, "strike_pkg" },
    { 0x22DDB49C, "strikeforce" },
    { 0x9944F164, "strikeforce_decrement_unit_tokens" },
    { 0x7CFE20D6, "strikeforce_get_num_levels_till_gone" },
    { 0x3D3189C8, "strikeforce_increment_unit_tokens" },
    { 0x7110F39B, "strikepos" },
    { 0x626BD976, "strikes" },
    { 0x58B118DC, "strikezonegraceperiod" },
    { 0xECE9EF57, "strill" },
    { 0xE00762CE, "string" },
    { 0x7F2C1103, "string1" },
    { 0x0D24A1C8, "string2" },
    { 0x33271C31, "string3" },
    { 0xF133803E, "string4" },
    { 0x1735FAA7, "string5" },
    { 0xA52E8B6C, "string6" },
    { 0xCB3105D5, "string7" },
    { 0x7C3793FA, "string_assets" },
    { 0x2D83BADA, "string_message" },
    { 0x237EF712, "string_message_1" },
    { 0xFD7C7CA9, "string_message_2" },
    { 0xD77A0240, "string_message_3" },
    { 0x2D635934, "string_name" },
    { 0xEB00610E, "string_notify" },
    { 0x7B2CD58E, "string_on" },
    { 0xB17C255D, "string_override" },
    { 0xC197D1F4, "string_path_1" },
    { 0x339F412F, "string_path_2" },
    { 0x0D9CC6C6, "string_path_3" },
    { 0x4F9062B9, "string_path_4" },
    { 0x298DE850, "string_path_5" },
    { 0x94D06722, "string_shared" },
    { 0x0880D2A5, "string_to_display" },
    { 0x4581ED51, "string_to_float" },
    { 0xE3BFC899, "string_to_remove" },
    { 0xE9F36A76, "string_to_show" },
    { 0x680D02D4, "string_to_vector" },
    { 0xE9DCC205, "stringint_to_realint" },
    { 0x1E82FA08, "stringline" },
    { 0x052965C2, "stringlist" },
    { 0xFC9F0E82, "stringnames" },
    { 0x80ECC740, "stringrefs" },
    { 0xB3C5B671, "strings" },
    { 0x6E19863B, "strings_set_2" },
    { 0xACDC938A, "stringtable" },
    { 0xE1475DA7, "stringtodraw" },
    { 0x698A0B31, "stringtofloat" },
    { 0xD1853A34, "stringtovector" },
    { 0xAD8088A5, "strip" },
    { 0x5A0E9D34, "stripped" },
    { 0x73896BB4, "strips" },
    { 0xB495A958, "strisfloat" },
    { 0x680650D9, "strisint" },
    { 0x8B47DCC5, "strisnumber" },
    { 0xACAD6257, "strkey" },
    { 0xA51FBDF7, "strlen" },
    { 0xB623F338, "strmax" },
    { 0xD1191EE6, "strmin" },
    { 0x050FC56F, "strname" },
    { 0xCCBCB1F6, "strname_or_ai" },
    { 0x9F1B53E7, "strng" },
    { 0x3B023C99, "strnotify" },
    { 0x2C0A5CAE, "strobe" },
    { 0x5139E6B3, "strobe_active" },
    { 0x3A5FE188, "strobe_direction" },
    { 0xB19597DE, "strobe_equipped" },
    { 0xD9CFE367, "strobe_fired" },
    { 0x4F528BBA, "strobe_lights" },
    { 0xF9D84494, "strobe_model" },
    { 0xA3AB51E2, "strobe_queue" },
    { 0xBABAA528, "strobe_sky_and_transition" },
    { 0xE1AC9D04, "strobe_vo" },
    { 0x88962F35, "strobe_vo_tracker" },
    { 0x0ED28B9A, "strobelight" },
    { 0xBBD677D1, "strobes" },
    { 0x8B6DEDB1, "stroffsetx" },
    { 0x656B7348, "stroffsety" },
    { 0xB31992E8, "strong" },
    { 0xB3C0145D, "stronger" },
    { 0xEFF051AF, "stronghold" },
    { 0xFE0AE10D, "strongly" },
    { 0x8BAF85F6, "strorm" },
    { 0x087F8BB4, "strshocktype" },
    { 0x413DD8F9, "strsquadname" },
    { 0x39C15145, "strstartswith" },
    { 0x1D3C94F1, "strstate" },
    { 0x5A2FDDE0, "strstrip" },
    { 0x8BBAF31E, "strt_chtr" },
    { 0x59FE1322, "strt_hrs" },
    { 0x073758D3, "strt_tf" },
    { 0x09C42612, "strtag" },
    { 0xD925C50C, "strtemp" },
    { 0xD6DF1F20, "strtok" },
    { 0x393E0A6F, "strtok_loc" },
    { 0xFF4C1D2D, "strtovec" },
    { 0xF8571C08, "strtrig" },
    { 0x2FF66A12, "strtype" },
    { 0x12BE5A8A, "struc" },
    { 0xF68020ED, "struck" },
    { 0xDD6D3F91, "strucobj" },
    { 0x6EC2B4CE, "strucobj_b" },
    { 0x94C52F37, "strucobj_c" },
    { 0x14B42B8A, "struct" },
    { 0x6819F857, "struct1" },
    { 0xF612891C, "struct2" },
    { 0x1C150385, "struct3" },
    { 0xC4917FEB, "struct_0" },
    { 0x9E8F0582, "struct_1" },
    { 0x0853B150, "struct_1_spark" },
    { 0x788C8B19, "struct_2" },
    { 0xE98E1C01, "struct_200" },
    { 0xC38BA198, "struct_201" },
    { 0x359310D3, "struct_202" },
    { 0xCF32823B, "struct_2_spark" },
    { 0x528A10B0, "struct_3" },
    { 0xDD7EF446, "struct_3_spark" },
    { 0x6161D0B9, "struct_4_spark" },
    { 0x4EA8331C, "struct_5_spark" },
    { 0x24634E47, "struct_6_spark" },
    { 0xD9E77CA3, "struct_add_to_level_array" },
    { 0xC58DE549, "struct_aim_here" },
    { 0x50B465DE, "struct_anim" },
    { 0xCE9855E8, "struct_array" },
    { 0x1C3FFE5A, "struct_array_heroes_start" },
    { 0xA934D491, "struct_array_index" },
    { 0x5E5C9BF2, "struct_array_name" },
    { 0xEE33B6EE, "struct_array_noteworthy" },
    { 0x3CE09AE5, "struct_arrayspawn" },
    { 0xB2C5CF6B, "struct_bunker_damage1" },
    { 0x40BE6030, "struct_bunker_damage2" },
    { 0x66C0DA99, "struct_bunker_damage3" },
    { 0x24CD3EA6, "struct_bunker_damage4" },
    { 0x4ACFB90F, "struct_bunker_damage5" },
    { 0xB3330B2C, "struct_class_init" },
    { 0xE90ED91E, "struct_class_names" },
    { 0xFED61E8A, "struct_cleanup_blocking_done" },
    { 0x7311DBFD, "struct_cleanup_firehorse" },
    { 0xB529B1E6, "struct_cleanup_wave1" },
    { 0x8F27377D, "struct_cleanup_wave2" },
    { 0x6924BD14, "struct_cleanup_wave3" },
    { 0xCE39963A, "struct_closest" },
    { 0x221499FB, "struct_closest_black_hole" },
    { 0x7D14B97A, "struct_crate_move" },
    { 0xFF042D85, "struct_dest" },
    { 0x7BFCC904, "struct_drop_help" },
    { 0x16E86D0B, "struct_end_point" },
    { 0x5020B3DE, "struct_exp" },
    { 0x8FCAEEB8, "struct_forward" },
    { 0x9AB9B06B, "struct_gate_front_1l_blocker" },
    { 0x2704E0D1, "struct_gate_front_1r_blocker" },
    { 0x543CEF29, "struct_grenade" },
    { 0xD56C0B24, "struct_ground" },
    { 0x7E4A40AD, "struct_heli_goto" },
    { 0xB24585CE, "struct_key" },
    { 0xE6B05F7D, "struct_loc" },
    { 0x5E6E4D1F, "struct_locations" },
    { 0x426BDA58, "struct_name" },
    { 0xEBA0E8B8, "struct_obj" },
    { 0x6D7D5A4C, "struct_or_ent" },
    { 0x66C779AD, "struct_org" },
    { 0xFFAFDED7, "struct_origin" },
    { 0xF2D25095, "struct_parts" },
    { 0x5FBE0F07, "struct_player_start" },
    { 0x545C90F3, "struct_poi" },
    { 0x781C2249, "struct_pos" },
    { 0x37708867, "struct_projector" },
    { 0x74A5843D, "struct_remove" },
    { 0xB423B084, "struct_rotate_to" },
    { 0x72515D6D, "struct_screen" },
    { 0x93339952, "struct_spawn" },
    { 0x7A3F04BF, "struct_spawn_trigger" },
    { 0x20F0AD03, "struct_spawner" },
    { 0xE36BE272, "struct_spawners" },
    { 0x53525AE3, "struct_start" },
    { 0x720A0323, "struct_start_name" },
    { 0x9291FFD2, "struct_starts" },
    { 0x83BB0D9F, "struct_string_field" },
    { 0x7C9409D5, "struct_targ" },
    { 0xCD8BF072, "struct_target" },
    { 0xC58B71FF, "struct_targetname" },
    { 0x3EC0AE06, "struct_targetnames" },
    { 0xDEEE7D24, "struct_targs" },
    { 0x27B67DF4, "struct_teleport" },
    { 0x83DD3DA0, "struct_to_model" },
    { 0xCE17F2F8, "struct_to_obj" },
    { 0x91BBD105, "struct_tracers" },
    { 0x0F00AB00, "struct_value" },
    { 0x6E2BBB35, "structarray" },
    { 0x2313C711, "structarray_add" },
    { 0x04E1FC40, "structarray_remove" },
    { 0x0AFC4A53, "structarray_shuffle" },
    { 0x5AB06281, "structarray_swap" },
    { 0x53CF38EE, "structarray_swaptolast" },
    { 0x12968604, "structarrays" },
    { 0xCCB0A19B, "structdelete" },
    { 0xAF6CFA89, "structforward" },
    { 0xD6C7B04A, "structinfo" },
    { 0xC3AF6B39, "structnext" },
    { 0x86FA8B79, "structnormalized" },
    { 0x9CB39DC5, "structs" },
    { 0x48335BFD, "structs2" },
    { 0x2230E194, "structs3" },
    { 0x2FD3EB5A, "structstart" },
    { 0xE3D878E0, "structtn" },
    { 0x55DA38D4, "structural" },
    { 0x3372DAAC, "structure" },
    { 0xD213A040, "structured" },
    { 0x3C4C9FAF, "structures" },
    { 0xBEBFF7FD, "structvalue" },
    { 0x23E08FB4, "struggle" },
    { 0x53B6A8C6, "struggle_array" },
    { 0x7C44FDD7, "struggle_mud_vo" },
    { 0x1C23CAAD, "struggle_mud_vo_cooldown" },
    { 0x2AC4073D, "struggling" },
    { 0xF75D6D30, "stslo" },
    { 0x5134F7B3, "sttart" },
    { 0x8A805035, "stub" },
    { 0x77236F96, "stub1" },
    { 0x5120F52D, "stub2" },
    { 0x3F52B93C, "stub_resume_buildable" },
    { 0x56301821, "stub_suspend_buildable" },
    { 0x0FDACE12, "stub_unbuild_buildable" },
    { 0x20CAB1D2, "stub_uncraft_craftable" },
    { 0xFF715C18, "stubborn" },
    { 0xABBD1504, "stubs" },
    { 0xCCCD24CB, "stubs_keys" },
    { 0xE120BA07, "stuck" },
    { 0x6F1F199E, "stuck_ammo_boxes" },
    { 0xB873FA4D, "stuck_anim" },
    { 0x6294F1C8, "stuck_damage_trigger" },
    { 0x76CB61F4, "stuck_flee_nodes" },
    { 0x0458FDAB, "stuck_flee_panzer_nodes" },
    { 0x9FB90975, "stuck_infantry" },
    { 0x702163A2, "stuck_jeep" },
    { 0x3AD6D7A6, "stuck_jeep_anim" },
    { 0x611776A7, "stuck_jeep_fx" },
    { 0x36492C9C, "stuck_resolution" },
    { 0x7CA3B9FE, "stuck_tanknode" },
    { 0x13E63553, "stuck_to_player" },
    { 0x9E2B0ED4, "stuck_to_player_team_change" },
    { 0xB46C0C27, "stuck_to_shield" },
    { 0x2596DD4A, "stuck_trigger" },
    { 0xDC10F2F4, "stuckcount" },
    { 0x39A761DA, "stuckcycles" },
    { 0xE1B5436A, "stucklocation" },
    { 0x6226D314, "stucktime" },
    { 0x067B7913, "stucktoplayer" },
    { 0xB2B6DB68, "stucktoplayerteamchange" },
    { 0x63CA643C, "stuckwithstickygrenade" },
    { 0x07233470, "stuct" },
    { 0xFDFC07DB, "stucts" },
    { 0x0E658CFF, "studio" },
    { 0x282CA7C8, "study" },
    { 0xCD191DF5, "stuff" },
    { 0x410BC5C4, "stuffs" },
    { 0x7B2B7136, "stufftohide" },
    { 0x5A08933A, "stuhlinger" },
    { 0x7671B84D, "stuhlingerpossessed" },
    { 0xEBF688D5, "stuka" },
    { 0xDD9D7ECD, "stuka2" },
    { 0x10C42AA2, "stuka2_plane_sweep_think" },
    { 0xC505D913, "stuka_fly" },
    { 0x8B41D52F, "stuka_nodes" },
    { 0x69FD31AD, "stumble" },
    { 0x8A1C8720, "stumble_angles" },
    { 0x06709E9F, "stumble_anim" },
    { 0x88610270, "stumble_done" },
    { 0xE12B0A6C, "stumble_stun_cooldown_time" },
    { 0x2039791B, "stumble_time" },
    { 0xE7983027, "stumbleactionanimation" },
    { 0xB3A6F76C, "stumbleactionresult" },
    { 0x74B56AAC, "stumbles" },
    { 0xB2D7954A, "stumbletime" },
    { 0xF1A360C1, "stumblewall" },
    { 0x46AC9658, "stumbling" },
    { 0x28ECE8A6, "stump" },
    { 0xC2629349, "stun" },
    { 0xBE69EF2D, "stun_avogadro" },
    { 0x5490DEC0, "stun_blocker_model" },
    { 0xD43EDF65, "stun_blockers" },
    { 0x92E939BC, "stun_blockers_cleanup" },
    { 0xDCBB2246, "stun_blockers_damage_trigger" },
    { 0x4EB89F81, "stun_blockers_timeout" },
    { 0xD0B3D24B, "stun_blockers_update" },
    { 0x1DCEBC0C, "stun_done" },
    { 0xD1E31AD4, "stun_falloff_end" },
    { 0x250C86FF, "stun_falloff_start" },
    { 0xA3EF3E6E, "stun_fx" },
    { 0xBA3A54E4, "stun_fx_end" },
    { 0x5BC1453F, "stun_kills" },
    { 0x977944C0, "stun_kills_total" },
    { 0xF85C8225, "stun_lifetime" },
    { 0x333B3F9B, "stun_player" },
    { 0xDF8A7B60, "stun_test" },
    { 0x30F12B2A, "stun_zombie" },
    { 0xAEE9E36B, "stunactionanimation" },
    { 0xA0D3CBE5, "stunactionast" },
    { 0x49FFAEE5, "stunduration" },
    { 0x3837F5BB, "stunendtime" },
    { 0x53A23947, "stunfinishtime" },
    { 0x7B99890F, "stunfx" },
    { 0xA396496F, "stunfxfrequencymax" },
    { 0x3898D411, "stunfxfrequencymin" },
    { 0x443E96D9, "stunfxtag" },
    { 0x13263E71, "stunfxthink" },
    { 0x5FF63112, "stunned" },
    { 0x68D3026C, "stunned_callback" },
    { 0x1BFEFCCF, "stunned_guy_think" },
    { 0x6507B49A, "stunnedanimnumber" },
    { 0xF72C8444, "stunnedbytacticalgrenade" },
    { 0xD8E77882, "stunnedhandler" },
    { 0xEEF4C31A, "stunnedtankwithempgrenade" },
    { 0x384E1340, "stuns" },
    { 0xCD471B53, "stunstart" },
    { 0xAE912FE8, "stunstarttime" },
    { 0xB0A5453D, "stunstaticfx" },
    { 0xACA81161, "stunstop" },
    { 0xEAFFF269, "stunt_double" },
    { 0x0CB69F1E, "stuntime" },
    { 0xC86133E7, "stuntman_achieved" },
    { 0xB1F73767, "stunturret" },
    { 0x7C4491C1, "stunturretfx" },
    { 0x73296FCE, "stunturrettacticalgrenade" },
    { 0xF167D668, "stupid" },
    { 0x2395BC16, "stupiddelayfix" },
    { 0x5F4F908D, "stupidly" },
    { 0xDD219A3A, "sturm" },
    { 0xBC4EBFA1, "sturmovik" },
    { 0xD4D6ACCC, "stutter" },
    { 0xF88A577C, "stuttering" },
    { 0x42EA4CEE, "stye" },
    { 0x0F69B6F0, "style" },
    { 0x84FB775B, "styles" },
    { 0xCC0E8874, "stype" },
    { 0x40F7C3F9, "sub" },
    { 0x91F71CDB, "sub_anim" },
    { 0x9C77D865, "sub_blows_up" },
    { 0x26AA575F, "sub_damage" },
    { 0x9FA4B333, "sub_drop" },
    { 0x00BA4486, "sub_drop_start" },
    { 0x71F353DA, "sub_ents" },
    { 0x541C6776, "sub_explosion_fx" },
    { 0x759C73D6, "sub_fade" },
    { 0x86DF066D, "sub_goal" },
    { 0x40A10C67, "sub_goal_array" },
    { 0x31AFF163, "sub_goal_next" },
    { 0xA90B654C, "sub_menu_select" },
    { 0x9A288553, "sub_move" },
    { 0x2144632C, "sub_num" },
    { 0x95C19F4C, "sub_pens" },
    { 0x0D3432AB, "sub_rise" },
    { 0x90E31C8E, "sub_rise_start" },
    { 0xCBDB6434, "sub_spot" },
    { 0x6FF86B58, "sub_spot_dir" },
    { 0x3180DCEF, "sub_string" },
    { 0xD8FFA103, "sub_task" },
    { 0xA2F5FE72, "sub_tasks" },
    { 0x81D30D7D, "sub_vel" },
    { 0x37C9F849, "sub_xcam" },
    { 0x1E1C47A5, "subcategory" },
    { 0x3C5D8C0F, "subclass" },
    { 0x4343F595, "subclass_dualwield" },
    { 0x3C5F6027, "subclass_elite" },
    { 0x8906DC4A, "subclass_juggernaut" },
    { 0xAB9A8075, "subclass_juggernaut_death" },
    { 0x0F750920, "subclass_juggernaut_riotshield" },
    { 0xF9131B59, "subclass_militia" },
    { 0xC2864AEE, "subclass_regular" },
    { 0xF07398BF, "subclass_regular_allies" },
    { 0xC3F53C7E, "subclass_regular_axis" },
    { 0x5D34760F, "subclass_riotshield" },
    { 0x4F783947, "subclass_setup_spawn_functions" },
    { 0xC2048E71, "subclass_spawn_functions" },
    { 0x56CDCF5B, "subclasses" },
    { 0x71F0D107, "subclasstype" },
    { 0xAA4D547C, "subdivision" },
    { 0x017F28AD, "subdrone" },
    { 0x93E02D96, "subheader" },
    { 0xF1CCC337, "subject" },
    { 0xA232236E, "subjects" },
    { 0x002F6F0E, "subkey" },
    { 0x9D947017, "submarine" },
    { 0xB1A434DC, "submenu" },
    { 0x676D8391, "submenudef" },
    { 0x53AE4C1F, "submenus" },
    { 0x1EE257FD, "submerged" },
    { 0xBDC1ADDE, "submessage" },
    { 0xBC11C595, "submit" },
    { 0x4EA90865, "submitting" },
    { 0x2AE33E98, "subname" },
    { 0x9FB2A0D9, "subpen_blast" },
    { 0x3593AE2D, "subpen_dialog" },
    { 0x779BEA3E, "subpen_wait" },
    { 0xF03E8FAB, "subrank" },
    { 0x6CDA6B30, "subs" },
    { 0x2D3431DD, "subscribed" },
    { 0x8107967B, "subscriber" },
    { 0xCEF3C796, "subscription" },
    { 0x48B6ECF6, "subsequent" },
    { 0x0C7C9D53, "subset" },
    { 0xC1067D82, "subsets" },
    { 0x1A277AC3, "substantial" },
    { 0xA5759DEE, "substantially" },
    { 0x8767913C, "substate" },
    { 0x5C075945, "substate_index" },
    { 0x3D8859B0, "substateindex" },
    { 0x4057CE2D, "substatepending" },
    { 0x09AF64DB, "substation" },
    { 0xB9F989D5, "substitute" },
    { 0xC1FC5F4E, "substr" },
    { 0xD0ABE4F2, "substring" },
    { 0xEBAC7C7D, "substrings" },
    { 0x17BFB37E, "subsystem" },
    { 0x5A9D6E61, "subsystems" },
    { 0x54186A46, "subtask" },
    { 0x1B45B06C, "subtext" },
    { 0x607FCC09, "subtitle" },
    { 0x85B249A9, "subtitle2" },
    { 0xF9661120, "subtitle_test" },
    { 0xDF113500, "subtitles" },
    { 0x348E0C86, "subtitlesequence" },
    { 0xA778214E, "subtle" },
    { 0xBFC16871, "subtract" },
    { 0x7581CA34, "subtract_num" },
    { 0x68245F1E, "subtracted" },
    { 0x5F7699D7, "subtracting" },
    { 0x2F9E7B8D, "subtraction" },
    { 0x7D129FC1, "subtring" },
    { 0x06B54393, "suburban" },
    { 0xB3335748, "subverting" },
    { 0x00F303AE, "subway" },
    { 0x9929D578, "subway_arty_kill" },
    { 0xD9D23343, "subway_exitgate_startdefenders" },
    { 0x048C0CF6, "subway_exitgate_startrunners" },
    { 0x4AC34A4D, "subway_gate_action" },
    { 0xFA292410, "subway_gate_bugplayer" },
    { 0x7F18FD9E, "subway_gate_closeanim" },
    { 0x4F3674FF, "subway_gate_closed" },
    { 0xE71DDE3C, "subway_gate_openanim" },
    { 0x5483FA80, "subway_gate_opened" },
    { 0xD81A7EE4, "subway_gate_woodbeam_anim_loop" },
    { 0x01D72D1A, "subway_gate_woodbeam_anim_single" },
    { 0xE99574BE, "subway_gate_woodbeam_init" },
    { 0x5E84AD71, "subwoofer" },
    { 0x25763D47, "subwoofer_burst_func" },
    { 0xF6B12A24, "subwoofer_choke" },
    { 0xA41C8750, "subwoofer_cleanup" },
    { 0x54242273, "subwoofer_cost" },
    { 0x02A5F607, "subwoofer_damage" },
    { 0x39EAC95A, "subwoofer_death" },
    { 0x65591A52, "subwoofer_debug_animation_print" },
    { 0x63E3CE81, "subwoofer_debug_print" },
    { 0x19AD8324, "subwoofer_disappear_fx" },
    { 0x9AF9DE66, "subwoofer_emp_time" },
    { 0xAAD2CE75, "subwoofer_emped" },
    { 0xB1C3C557, "subwoofer_expired" },
    { 0x13F61897, "subwoofer_fling_func" },
    { 0x8349FCA6, "subwoofer_fx" },
    { 0xD39FF7A7, "subwoofer_gib_refs" },
    { 0x95443EF4, "subwoofer_handle_pain_notetracks" },
    { 0xC5B51AEE, "subwoofer_health" },
    { 0xF311006B, "subwoofer_in_range" },
    { 0xB82E915A, "subwoofer_is_powering_on" },
    { 0xEDD64437, "subwoofer_kills" },
    { 0x2C3E4FE9, "subwoofer_knockdown_func" },
    { 0x416601D7, "subwoofer_motor" },
    { 0xE0F6419B, "subwoofer_mount" },
    { 0x81997D75, "subwoofer_name" },
    { 0xA45BCB1B, "subwoofer_network_choke" },
    { 0xAB9D85FB, "subwoofer_network_choke_count" },
    { 0x15A5010E, "subwoofer_power_change" },
    { 0xC4F144E4, "subwoofer_power_level" },
    { 0xA3EF9CB1, "subwoofer_power_off" },
    { 0x9EA35705, "subwoofer_power_on" },
    { 0xCE01C0C1, "subwoofer_round_start" },
    { 0x6D519D9B, "subwoofer_sound_ent" },
    { 0x4A50C777, "subwoofer_speaker" },
    { 0x4969B090, "subwoofer_table" },
    { 0xA9F13A73, "subwooferbuildable" },
    { 0x3F7F6191, "subwooferdecay" },
    { 0x55DF6A27, "subwooferthink" },
    { 0xA049E3E8, "subxcam" },
    { 0x1AF54990, "suc" },
    { 0x62ECAD8F, "succeed" },
    { 0x26A3ADD4, "succeeded" },
    { 0xA37ABBF1, "succeeding" },
    { 0x505DF356, "succeeds" },
    { 0x68611D31, "succesffully" },
    { 0xE976EB3D, "succesfully" },
    { 0x77F265F6, "success" },
    { 0x2451BFCB, "success_flag" },
    { 0x639D6222, "success_hud_elem" },
    { 0x45F068C4, "success_igc" },
    { 0x929478F9, "success_mason" },
    { 0xF20533A2, "success_player" },
    { 0x8AD2862D, "success_watcher_damage" },
    { 0x31177336, "successes" },
    { 0x46B6919F, "successful" },
    { 0xFDB39C34, "successful_death" },
    { 0x33F8465D, "successful_hack" },
    { 0x7A77E398, "successful_revives" },
    { 0x37DF2B18, "successfulhack" },
    { 0x29492442, "successfully" },
    { 0x0A249356, "successfully_destroyed" },
    { 0x46ED6D46, "successfully_moved" },
    { 0x9A50EF9C, "successfuly" },
    { 0x35C437E4, "succession" },
    { 0x114465B0, "successive" },
    { 0xFF08BE6C, "successsaves" },
    { 0x5A55A725, "succss" },
    { 0x3FC92201, "succumb" },
    { 0x1BE3ED5F, "sucess" },
    { 0x8279C28D, "sucessfully" },
    { 0xF085EE18, "such" },
    { 0x628D5D53, "suck" },
    { 0xDF3DE908, "sucked" },
    { 0x173137B1, "suckers" },
    { 0xF3F1514D, "sucking" },
    { 0x3D64BD82, "sucks" },
    { 0x8A402BFB, "sucseess" },
    { 0x23541EDC, "sudden" },
    { 0xE962EBD9, "suddenly" },
    { 0xA3914AD8, "suffer" },
    { 0xFF4482EB, "suffered" },
    { 0x6EF612C0, "suffering" },
    { 0x67989AB3, "suffers" },
    { 0x122D88AA, "suffice" },
    { 0x2F2D40CD, "sufficient" },
    { 0xFBA97B66, "sufficient_time_remaining" },
    { 0xC8BD5AF0, "sufficiently" },
    { 0xAEB57A2E, "suffix" },
    { 0x19134E00, "suffle" },
    { 0xA4503E5D, "sugar" },
    { 0x1B8BBEDA, "sugar_field_planes" },
    { 0x319C8656, "sugarcane" },
    { 0xB5B9AA40, "sugarcane_color_chain" },
    { 0x16102B6F, "sugarcane_event" },
    { 0x41371755, "sugarcane_nag_lines" },
    { 0x0B599AB0, "sugarcane_run" },
    { 0xE24E1343, "sugarfield" },
    { 0x15A0E761, "suggest" },
    { 0xB2ABA64E, "suggested" },
    { 0x3E2CF4C3, "suggested_objective_order" },
    { 0x476D6752, "suggested_seat" },
    { 0x9946D71D, "suggestion" },
    { 0xC370AC35, "suicidal" },
    { 0x44BDEAE1, "suicidaldeath" },
    { 0x584B97B7, "suicide" },
    { 0x9F8A3F5C, "suicide_badguy_interrupt" },
    { 0x7D89430F, "suicide_bomber_reached_tank" },
    { 0x51EDE748, "suicide_do_suicide" },
    { 0x5E551BB0, "suicide_guy1" },
    { 0xAA5A1082, "suicide_guy3" },
    { 0x32646787, "suicide_guy3_dead" },
    { 0x4A1F55F8, "suicide_scientist" },
    { 0xBDDCEF51, "suicide_scientist_spawn_trig" },
    { 0xAE0AC711, "suicide_scientist_trig" },
    { 0x8677F253, "suicide_success" },
    { 0x28190A85, "suicide_target" },
    { 0x032B4342, "suicide_trigger_spawn" },
    { 0x5C3B9A2F, "suicide_trigger_think" },
    { 0x14B8CE92, "suicide_tunnel_running_guys_trigger" },
    { 0x339F8CB2, "suicide_weapon" },
    { 0x5DA69E51, "suicided" },
    { 0x361DA015, "suicidekick" },
    { 0xAF0E0D25, "suicideprogressbar" },
    { 0xF6072C79, "suicideprompt" },
    { 0x7BDAA8EE, "suicides" },
    { 0xFDF3981D, "suicidespawndelay" },
    { 0x292C9541, "suicidetexthud" },
    { 0x6D12A464, "suicidetime" },
    { 0xF7B8B00B, "suicideweapon" },
    { 0x3B052E37, "suienable" },
    { 0xFC55A42A, "suit" },
    { 0xF95B35B3, "suit_fly_vision" },
    { 0xCECC72E6, "suitable" },
    { 0x58339FBD, "suited" },
    { 0x5E08B2E5, "suits" },
    { 0x551A75B7, "sul" },
    { 0xDF51FCED, "sullivan" },
    { 0xC69AB563, "sullivan_pullout" },
    { 0x317D0F90, "sully_has_a_tommy" },
    { 0x2F17FB4E, "sum" },
    { 0x276A932C, "sumeet" },
    { 0x507789DB, "sumeet_todo" },
    { 0xCB44112F, "sumeets" },
    { 0xC8EA48AB, "summary" },
    { 0xA48BD5C1, "summary_abort_watcher" },
    { 0xCB1C81E9, "summary_cache_created" },
    { 0xFB64CF69, "summary_challenge" },
    { 0x141FE9EB, "summary_complete" },
    { 0xB37D392B, "summary_ready" },
    { 0xECBB254E, "summary_xp" },
    { 0x47F5F896, "summaryarray" },
    { 0xD929C8F4, "summed" },
    { 0xC343291E, "summon_box" },
    { 0x163FB8BF, "summon_box_qualifier" },
    { 0x35FF58AD, "summon_box_thread" },
    { 0x2F290210, "summon_the_shamans" },
    { 0xC7297593, "summoned" },
    { 0x260C8B2B, "summons" },
    { 0x12A3ADD8, "sumpf" },
    { 0xBCF818F4, "sumpf_exit_level" },
    { 0x81B38372, "sumpf_find_exit_point" },
    { 0x38BE3A68, "sumpf_player_spawn_placement" },
    { 0xE929E63E, "sumpf_zone_init" },
    { 0xAAE5C7F1, "sums" },
    { 0xA0D46F12, "sumx" },
    { 0xC6D6E97B, "sumy" },
    { 0x091580E5, "sun" },
    { 0xEDB1C784, "sun_bright_duration_max" },
    { 0xD8931FEA, "sun_bright_duration_min" },
    { 0x759E01FD, "sun_brightness" },
    { 0x9F866CCD, "sun_col_b" },
    { 0xE17A08C0, "sun_col_g" },
    { 0xFFAE135D, "sun_col_r" },
    { 0xAD2B60AD, "sun_color" },
    { 0x8EB6C304, "sun_dark_duration_max" },
    { 0x79981B6A, "sun_dark_duration_min" },
    { 0xDA07838D, "sun_dir" },
    { 0x706CFF38, "sun_dir_x" },
    { 0x966F79A1, "sun_dir_y" },
    { 0xBC71F40A, "sun_dir_z" },
    { 0x336298F4, "sun_light" },
    { 0xD422012D, "sun_light_fade" },
    { 0x658424FF, "sun_rise" },
    { 0x2435CC61, "sun_shadow_split_distance" },
    { 0x14C07505, "sun_start_ang" },
    { 0x7B5A55B1, "sun_stop_ang" },
    { 0xD5159421, "sun_transition_time_bright_to_dark" },
    { 0x674B92C9, "sun_transition_time_dark_to_bright" },
    { 0x6A5FB5B7, "sun_value_above_water_bright_b" },
    { 0xAC5351AA, "sun_value_above_water_bright_g" },
    { 0x0A380F27, "sun_value_above_water_bright_r" },
    { 0xE6B69DEF, "sun_value_above_water_dark_b" },
    { 0x28AA39E2, "sun_value_above_water_dark_g" },
    { 0x868EF75F, "sun_value_above_water_dark_r" },
    { 0xF58A6532, "sun_value_below_water_b" },
    { 0xB396C93F, "sun_value_below_water_g" },
    { 0x55B20BC2, "sun_value_below_water_r" },
    { 0x170E27EB, "sunang" },
    { 0x0B6FC350, "sunbeam" },
    { 0x1D7ECA4D, "sunburned" },
    { 0x8EF412C2, "suncolor" },
    { 0x3F46AB34, "suncolorb" },
    { 0xF85A0FBF, "suncolorb_new" },
    { 0xCD3F3BF9, "suncolorg" },
    { 0x74AC6CF6, "suncolorg_new" },
    { 0xDF1F04A4, "suncolorr" },
    { 0x99BE942F, "suncolorr_new" },
    { 0x7B5ED919, "sunday" },
    { 0x1FB930EE, "sundeck" },
    { 0xFD41BCDD, "sundeck_anims" },
    { 0xBD6980FE, "sundeck_save" },
    { 0x9970A687, "sundial" },
    { 0xF0B40FF2, "sundial_button" },
    { 0x1523FDA0, "sundial_button_already_pressed_by" },
    { 0x20359A78, "sundial_monitor" },
    { 0x9A8ED992, "sundir" },
    { 0xEBF249F0, "sundirection" },
    { 0x302E134E, "sundirx" },
    { 0xD7BB9AAD, "sundirx_new" },
    { 0x56308DB7, "sundiry" },
    { 0xF73EBBC0, "sundiry_new" },
    { 0xE4291E7C, "sundirz" },
    { 0xFD51EB87, "sundirz_new" },
    { 0xE2460E5D, "sunendangle" },
    { 0x82CFDA40, "sunfogcolorblue" },
    { 0xBF4584B5, "sunfogcolorgreen" },
    { 0x1716BF11, "sunfogcolorred" },
    { 0x267FC45E, "sunfogendang" },
    { 0x7169563D, "sunfogendang_new" },
    { 0x84F7D9EF, "sunfogstartang" },
    { 0x18442798, "sunfogstartang_new" },
    { 0xB03599AC, "sunk" },
    { 0xC7412ED3, "sunlight" },
    { 0x34591291, "sunlight_above_water" },
    { 0x2CC1FB2E, "sunlight_bright" },
    { 0x013A5EB2, "sunlight_dark" },
    { 0x881049C7, "sunlight_samplesize_change_init" },
    { 0x55A94AEC, "sunlight_under_water" },
    { 0x7FF99497, "sunpointsto" },
    { 0x9E6BEC06, "sunrise" },
    { 0xBDB7F210, "sunrise2" },
    { 0xE3BA6C79, "sunrise3" },
    { 0xA1C6D086, "sunrise4" },
    { 0x21C73273, "sunriseincrtime" },
    { 0xBE7A80ED, "sunriseinitcolor" },
    { 0xF2B3F3FC, "sunriseinterpcolors" },
    { 0x469EC8B8, "sunrisesetcolortarget" },
    { 0xE0496CF4, "suns" },
    { 0x6E2EEE44, "sunsamplesize" },
    { 0x532CA8E0, "sunsamplesize_time" },
    { 0xA6E47207, "sunset" },
    { 0xFC5F9FD0, "sunstartangle" },
    { 0x8264AF77, "sunx" },
    { 0x5C62350E, "suny" },
    { 0x99A31C96, "super" },
    { 0x639001A6, "super_ee_weapon" },
    { 0x44147464, "super_egg" },
    { 0x25F7FE4B, "super_enemies" },
    { 0x43BC7A24, "super_fly" },
    { 0x56BB53A5, "super_kill" },
    { 0x8E2864C8, "super_kill_done" },
    { 0xBC57850F, "super_kill_exploder_add" },
    { 0xC1A9D218, "super_kill_exploder_restore_all" },
    { 0x845674A2, "super_kill_exploder_stop_all" },
    { 0x3209EEBE, "super_kill_exploders" },
    { 0x6B6ED48B, "super_kill_knife" },
    { 0xFF31AA29, "super_kill_slow_end" },
    { 0x1204BE02, "super_kill_slow_start" },
    { 0x81D57A5F, "super_kill_started" },
    { 0xA98079F6, "super_pusher_off" },
    { 0x8B2B90E8, "super_pusher_on" },
    { 0x60EE3B3B, "super_radiation_trigger" },
    { 0x3C2CF975, "super_soct_shoot_logic" },
    { 0xBAB725BA, "super_soct_speed" },
    { 0xBA6D1F1C, "super_soct_speed_control" },
    { 0x58484C3F, "super_soct_think" },
    { 0x55F9828B, "super_temp_music" },
    { 0x23806894, "super_zombies_end" },
    { 0x51B1E25F, "supercede" },
    { 0xC11F63E6, "supercedes" },
    { 0x49555DDA, "superceding" },
    { 0xC5CF6F16, "superceede" },
    { 0xBD0343F6, "supercharged" },
    { 0xD3B77E58, "superegg_counter" },
    { 0x203DCFF8, "superegg_one" },
    { 0xD117B511, "superegg_one_trig" },
    { 0xA15808BC, "superegg_radio_one" },
    { 0x848CF448, "superegg_radio_three" },
    { 0x4DEC469E, "superegg_radio_two" },
    { 0x14014DE4, "superegg_three" },
    { 0x7C56FBFD, "superegg_three_trig" },
    { 0xDD29A4AA, "superegg_two" },
    { 0x1A82879B, "superegg_two_trig" },
    { 0x8AB353B2, "superenemies" },
    { 0x367BC739, "superenemy_create" },
    { 0x615834D0, "superenemy_remove_on_death" },
    { 0x23C99516, "superflare" },
    { 0xBAB7AF63, "superflare_handler" },
    { 0x25DC4389, "superflares" },
    { 0x7A37AC32, "superkill" },
    { 0xB039D141, "supermargwa" },
    { 0x60D385EE, "supermarket" },
    { 0x3E9CFE99, "superpower" },
    { 0x7B65CEF9, "superseded" },
    { 0x4008D45B, "supersprintdistance" },
    { 0x93FA55BB, "supervisor" },
    { 0xB07CDF64, "suport" },
    { 0xADC6A6FB, "supplemental" },
    { 0x33470705, "supplemental_horses_go" },
    { 0x77E0AB23, "supplementalwatcherobjects" },
    { 0x17722ACE, "supplementary" },
    { 0xE4D5702F, "supplied" },
    { 0x7A9C70C0, "supplies" },
    { 0x1A5CBC5F, "supplimental" },
    { 0xE4FA66DC, "supply" },
    { 0x719CF8AF, "supply_dialog" },
    { 0x251FAF48, "supply_drop" },
    { 0xE8E69894, "supply_drop_1" },
    { 0x0E83746A, "supply_drop_ai_tank_name" },
    { 0x2723EF70, "supply_drop_anim" },
    { 0x0E664A38, "supply_drop_combat_robot_name" },
    { 0xD88477C1, "supply_drop_crate_state_capture" },
    { 0xAEAFC41F, "supply_drop_crate_state_disarm" },
    { 0x56400F72, "supply_drop_crate_state_hack" },
    { 0x7B0A6F4F, "supply_drop_crate_state_none" },
    { 0xF97ED2F4, "supply_drop_dev_gui" },
    { 0xA53B1418, "supply_drop_marker_done" },
    { 0x92552392, "supply_drop_name" },
    { 0x995313A8, "supply_drop_objective" },
    { 0x41CDFB13, "supplydrop" },
    { 0xF08D7005, "supplydrop_ai_tank_state" },
    { 0x84281DBE, "supplydrop_care_package_state" },
    { 0x7CDF0C05, "supplydropaccel" },
    { 0xDAA8461D, "supplydropaitankdropanim" },
    { 0xBF6B93C8, "supplydropaitankidleanim" },
    { 0xC008F738, "supplydropcarepackagedropanim" },
    { 0x4C8820D1, "supplydropcarepackageidleanim" },
    { 0x11BFF7E6, "supplydropdisarmcrate" },
    { 0x1C13AD9E, "supplydropgrenadepullwatcher" },
    { 0xF434193C, "supplydropgrenadetimeout" },
    { 0x19376EA8, "supplydrophelicopterenemy" },
    { 0x77457FF1, "supplydrophelicopterfriendly" },
    { 0x293C31B7, "supplydropheliendpath" },
    { 0x54D07922, "supplydropheliendpath_v2" },
    { 0xC88C067C, "supplydrophelistartpath" },
    { 0xE64B062D, "supplydrophelistartpath_v2_part2" },
    { 0xFDA38A01, "supplydrophelistartpath_v2_part2_local" },
    { 0x1879B1C1, "supplydrophelistartpath_v2_setup" },
    { 0x2E671434, "supplydropspeed" },
    { 0x0E8DF431, "supplydropwatcher" },
    { 0xCC900407, "supplydropweapon" },
    { 0x9F0D9707, "supplygrenadedeathdrop" },
    { 0xEA19FE38, "supplystationclasschange" },
    { 0x2CA0339E, "support" },
    { 0x0B80235B, "support_ai" },
    { 0x857A56D6, "support_chopper" },
    { 0x80894217, "support_chopper1_deleter" },
    { 0x77AA9450, "support_chopper2_deleter" },
    { 0x3DCC6A79, "support_chopper2_go" },
    { 0x273876D4, "support_chopper_01" },
    { 0x90EB038D, "support_chopper_2" },
    { 0xB458F7D5, "support_heli" },
    { 0x9919C3B0, "support_heli_think" },
    { 0xE10CB9C6, "support_huey" },
    { 0x967C97AD, "support_huey_crash_path_start" },
    { 0x548A6E39, "support_huey_deck_targets" },
    { 0x82214FD6, "support_huey_deck_targets_2" },
    { 0x3997001A, "support_huey_drop" },
    { 0x4FD12759, "support_huey_guys" },
    { 0xCA9D3A64, "support_huey_kills" },
    { 0x07C03369, "support_huey_rappel" },
    { 0x413EF05F, "support_huey_strafe_stern" },
    { 0x758DBFA3, "support_huey_think" },
    { 0x4CB09680, "support_huey_weapon_think" },
    { 0x09BBB314, "support_m202_to_shore" },
    { 0xFF459CBE, "support_riders" },
    { 0x61BAAF05, "support_rpg_guys" },
    { 0x8D862FE6, "support_trigs" },
    { 0x44553D1E, "support_troop_names" },
    { 0x91FB650A, "support_troops_count" },
    { 0x083B85F2, "support_weaver_fail_condition" },
    { 0x40892AE1, "supported" },
    { 0x4A95B9ED, "supportedattachments" },
    { 0x88D86BBE, "supporters" },
    { 0xC943FD22, "supporting" },
    { 0xD8A5BB01, "supports" },
    { 0xDC20728C, "supports_super_sprint" },
    { 0xAC2374A9, "supportsaiweaponswitching" },
    { 0x984AB370, "supportsanimscripted" },
    { 0x3BC2BD67, "supportseliteanimations" },
    { 0x0A6698BF, "supportsflamedeaths" },
    { 0xBB246668, "supportsfutureflamedeaths" },
    { 0x8BBAB451, "supportsleancovercondition" },
    { 0xB5B909A6, "supportsleft" },
    { 0xFAFD8824, "supportsmganimations" },
    { 0x05638E53, "supportsovercovercondition" },
    { 0xDA4DC1C4, "supportspeekcovercondition" },
    { 0x0BBE9329, "supportspistolanimations" },
    { 0x5DD17A3D, "supportsright" },
    { 0x50754BBC, "supportsstepoutcondition" },
    { 0x0643CCB5, "supportsvantagecovercondition" },
    { 0x89965377, "supportsvomitingdeaths" },
    { 0x760C6125, "supportturretdestroyed" },
    { 0xF4F9A588, "suppose" },
    { 0x04BA319C, "supposed" },
    { 0xAFD556D1, "suppresionfire" },
    { 0xEAA1DC78, "suppress" },
    { 0x280DA310, "suppress_animscripts" },
    { 0x1ED822C0, "suppress_brutus_bridge_powerups" },
    { 0x4ECE5D4B, "suppress_brutus_powerup_drop" },
    { 0xCD30EF07, "suppress_drops" },
    { 0x58110C48, "suppress_print" },
    { 0x43B7F9BE, "suppress_stowed_weapon" },
    { 0xE9615B2F, "suppress_teargas_behavior" },
    { 0x9E031C02, "suppress_wait_ambush_min" },
    { 0xDA66E173, "suppress_wait_max" },
    { 0x5D52237D, "suppress_wait_min" },
    { 0x52E1F67A, "suppressability" },
    { 0xD3AF4914, "suppressableenemy" },
    { 0x2801EA8B, "suppressed" },
    { 0x0E26A519, "suppressedbehavior" },
    { 0x37677A40, "suppressedtime" },
    { 0xB1BECDE0, "suppressing" },
    { 0x37723843, "suppressing_fire" },
    { 0xBB74C654, "suppressingenemy" },
    { 0xDF1C832A, "suppression" },
    { 0xA1B7C6D2, "suppression_target" },
    { 0x70DEEAF3, "suppressionattackcomplete" },
    { 0x06F445F5, "suppressionmeter" },
    { 0xE5AF317A, "suppressionstart" },
    { 0x31D56A9B, "suppressionthreshold" },
    { 0xC1880BFD, "suppressionthreshold_old" },
    { 0xD313C91B, "suppressionthresold" },
    { 0xE1462725, "suppressiontime" },
    { 0xA72F9BF9, "suppressionwait" },
    { 0x9784596A, "suppressive" },
    { 0x30B1B6B5, "suppressnotification" },
    { 0x7231A18F, "suppressor" },
    { 0x4149F96A, "suppressr" },
    { 0x7A9047D0, "suppressspot" },
    { 0x276E512C, "suppy_drop_nav_mesh_valid_location_boundary" },
    { 0x2515D563, "suppy_drop_nav_mesh_valid_location_tolerance" },
    { 0x3F398328, "suppy_drop_on_target_distance" },
    { 0x1D7C1F5A, "suppydrophelicoptervehicleinfo" },
    { 0xFCE88F84, "suprise" },
    { 0x57033B88, "sur_cargo" },
    { 0x1D104620, "sur_cargo_pickup_trig" },
    { 0xF37FC11F, "sur_hardpoint" },
    { 0x45148C9C, "sur_num" },
    { 0xBA751830, "sur_playerspawnedcb" },
    { 0x0393A2E6, "sure" },
    { 0x681DD0CB, "surely" },
    { 0x7758F108, "surf_type" },
    { 0x5BB8209E, "surface" },
    { 0x09A3B3C6, "surface_break" },
    { 0xF26EAD57, "surface_check_offset" },
    { 0x485C257A, "surface_main" },
    { 0x73FC57B5, "surface_type" },
    { 0x37C50964, "surface_vector" },
    { 0x0B5BFA4A, "surface_vignettes" },
    { 0xCB942E04, "surface_vox" },
    { 0xF7A30C8A, "surfaceangles" },
    { 0x7D05BEB1, "surfacearray" },
    { 0x9B9B98F3, "surfacearrayindex" },
    { 0x9441A5FF, "surfaceflags" },
    { 0x15C2A609, "surfacefxdeftype" },
    { 0x8B712D29, "surfacefxtable_footstep" },
    { 0x6A4D3B3B, "surfacenormal" },
    { 0xD45CBE5F, "surfaceroll" },
    { 0xFB4FD201, "surfaces" },
    { 0x4C460A1A, "surfacetable" },
    { 0x3FA0BA75, "surfacetrace" },
    { 0x97570BBE, "surfacetype" },
    { 0x771A8FA1, "surfacetypes" },
    { 0xBB5426B7, "surfacing" },
    { 0xAEA590EB, "surfing" },
    { 0x251D7C5D, "surfnode" },
    { 0x7FE56816, "surgamestate" },
    { 0xD88281A1, "surge" },
    { 0xB034B3A2, "surgery" },
    { 0xC46E96DB, "surgespeedmultiplier" },
    { 0xB278DA2B, "surgical" },
    { 0x79CAB154, "surging" },
    { 0x83A4B192, "surgury" },
    { 0x5ED68732, "surgury_sfx" },
    { 0xBDED7560, "surmainloop" },
    { 0x219AB6EC, "surpression" },
    { 0xDE1D9875, "surpressor" },
    { 0xAFB30164, "surprise" },
    { 0xCCFEC67C, "surprise_anim" },
    { 0x83E0253F, "surprise_anims" },
    { 0x3B20D83C, "surprise_tank_dead" },
    { 0xA3AF2E28, "surprised" },
    { 0x5F6B11FD, "surprised_again" },
    { 0x37EA0D77, "surprisedplayer" },
    { 0xF61FA351, "surprisers" },
    { 0xAE28F5DC, "surprisers_die_soon" },
    { 0x0DE82D97, "surprises" },
    { 0xDEDCA155, "surrender" },
    { 0xC047CC11, "surrender_animnum" },
    { 0x34492C88, "surrender_dialog" },
    { 0xC75CE3A7, "surrender_end" },
    { 0xDB759814, "surrender_ragdoll_thread" },
    { 0x44ACBA82, "surrendered" },
    { 0x3628CE53, "surrendering" },
    { 0x1734FBA4, "surrenders" },
    { 0x1D1E29FB, "surround" },
    { 0xB66BB170, "surrounded" },
    { 0xBD1AAEE5, "surrounding" },
    { 0x4470D6F4, "surroundings" },
    { 0x0BBCA6FB, "surroundong" },
    { 0x02CDE69F, "surv_end" },
    { 0xD6B75F1F, "surv_off" },
    { 0xC21AC4AB, "surv_on" },
    { 0x9A82124F, "surv_spawners" },
    { 0x4A5559D4, "surv_start" },
    { 0x52FB732A, "surveillance" },
    { 0x4BB67D11, "surveillance_harper_pathing" },
    { 0x7270C77B, "surveillance_mark_menendez" },
    { 0xB37B1FD4, "surveillance_mode_hint" },
    { 0x6EA10FDF, "surveillance_prone_hint" },
    { 0xDE2C9FFD, "surveillance_spotlight_movement" },
    { 0x9AC77676, "surveillance_state_change_cleanup" },
    { 0x4A02FD1F, "surveillance_think" },
    { 0x1856CA84, "surveillance_zoom" },
    { 0xE9B7F214, "surveillance_zoom_hint" },
    { 0x3428E2B9, "surverlance" },
    { 0xDDB4647A, "surverlance_device" },
    { 0x2E2EE5EF, "survey" },
    { 0xCD7A4EB0, "surveyid" },
    { 0x054F351D, "survial" },
    { 0xD097F503, "survival" },
    { 0xA705AF9E, "survival_barricades" },
    { 0x736C1393, "survival_classic_custom_stat_update" },
    { 0xA66002C0, "survival_init" },
    { 0xF66FEC00, "survivalistchallenge" },
    { 0x59E0CC01, "survive" },
    { 0xD975E676, "survive_rounds_without_revive" },
    { 0xD46CCD5A, "surviveanimallowed" },
    { 0x5EBC8EBB, "surviveanimname" },
    { 0x56D8F697, "survived" },
    { 0x6942F2DD, "survived_broken_stealth" },
    { 0x57DEE721, "survived_hud" },
    { 0x5BA18439, "survived_msg" },
    { 0xEC9FF728, "survives" },
    { 0x135D85B4, "surviving" },
    { 0x70F4DA53, "survivor" },
    { 0x9651CE91, "survivor_2_go" },
    { 0xEE18B7FE, "survivor_3_go" },
    { 0x440C5B60, "survivor_burst" },
    { 0xD470CB43, "survivor_count" },
    { 0x8972A7B7, "survivor_dialogue_inside" },
    { 0x60510A33, "survivor_fall_timer" },
    { 0x44D81A99, "survivor_fell" },
    { 0xD1CAA7B6, "survivor_hang_on" },
    { 0xC03FBEB0, "survivor_init" },
    { 0xC47F5C39, "survivor_init_ambient" },
    { 0x4F0BC505, "survivor_number" },
    { 0x769F4845, "survivor_old_count" },
    { 0xAEB0C7C8, "survivor_run_swim" },
    { 0xD6232B85, "survivor_save_count" },
    { 0x52A29B9B, "survivor_saved" },
    { 0xAB5074A9, "survivor_shout" },
    { 0x71FD8E12, "survivor_sounds" },
    { 0x57DB065D, "survivor_sounds_death" },
    { 0xF03DE68E, "survivor_sounds_hangon" },
    { 0x56B68DEA, "survivor_update_pos" },
    { 0xD87DF091, "survivor_vox" },
    { 0x49318FE7, "survivor_watch_for_goal" },
    { 0xA7F96A41, "survivor_wave" },
    { 0xA1A86A12, "survivor_x" },
    { 0xEA4E8482, "survivors" },
    { 0x3A9A7D46, "survivors_group_1" },
    { 0x149802DD, "survivors_group_2" },
    { 0xEE958874, "survivors_group_3" },
    { 0x49D784C6, "survivors_retreat" },
    { 0x5CB9F641, "survsndent" },
    { 0xF5D7DFA5, "susan" },
    { 0xAF421110, "suspect" },
    { 0xF56D91BC, "suspect_a" },
    { 0x677500F7, "suspect_b" },
    { 0x40AC6D57, "suspect_b2" },
    { 0x4172868E, "suspect_c" },
    { 0x28CDE908, "suspect_c2" },
    { 0x83662281, "suspect_d" },
    { 0x6EEB02D1, "suspect_d2" },
    { 0x9F5952A3, "suspected" },
    { 0xC72FF1FB, "suspects" },
    { 0xA68D6BBE, "suspend_camo_suit" },
    { 0xF93698A2, "suspend_camo_suit_wait" },
    { 0x840FDF22, "suspend_scene_skip_until_fade" },
    { 0xBD6F486D, "suspend_timer" },
    { 0xCCB75BA4, "suspend_weapon_cycling" },
    { 0x3897C594, "suspended" },
    { 0xCCACF7B1, "suspendthink" },
    { 0x908C99CD, "suspense" },
    { 0x79A5FFC6, "suspensemusic" },
    { 0x8395D834, "suspensemusicforplayer" },
    { 0xA2078AF2, "suspension" },
    { 0x0961A4E9, "suspension_thread" },
    { 0x89EF47CA, "suspicion" },
    { 0xB6098380, "suspicious" },
    { 0x68EEFED4, "suspicious_guys_leaving_pip" },
    { 0xF3FFCD07, "sustained" },
    { 0x12348CA2, "suzy" },
    { 0xA6D0E072, "sv" },
    { 0xE6F36712, "sv_hostname" },
    { 0x11219309, "sv_snapshot_demo" },
    { 0x14C3E5CB, "svehiclemodel" },
    { 0x074893B5, "svehiclename" },
    { 0x25E84EDC, "svehicletype" },
    { 0xF7E41796, "sventnumber" },
    { 0xCFDB1DA9, "svnotify" },
    { 0x48CC99A7, "svoloch" },
    { 0xD0FF505F, "svolumename" },
    { 0x4FB49250, "svortex" },
    { 0x726B59D7, "svsd_bookmark_event" },
    { 0x402A454D, "svsd_bookmark_kill" },
    { 0x3BE8E962, "svt40weaponindex" },
    { 0xCCD35ADB, "sw" },
    { 0x3B46DCED, "sw_357" },
    { 0xC2D725EA, "swaittill" },
    { 0xC1F1DCC7, "swamp" },
    { 0x5C4C6F3C, "swamp_german_safe" },
    { 0xB286CF09, "swamp_pandora_fx_func" },
    { 0x867A5894, "swamp_sprint_protection" },
    { 0x6A88E9D8, "swap" },
    { 0x3C0894AC, "swap_attachments_on_reuse" },
    { 0x42357C11, "swap_boat" },
    { 0xDE3CF707, "swap_buildable_fields" },
    { 0xA83B1869, "swap_counter" },
    { 0x2087DB59, "swap_engine_sound" },
    { 0x36B5BBFE, "swap_ent" },
    { 0x845E8A85, "swap_flag" },
    { 0xEB4C8401, "swap_for_exterior" },
    { 0x3303C1FF, "swap_for_interior" },
    { 0xF0C16B80, "swap_heads" },
    { 0x0D9220FB, "swap_in_flamethrower" },
    { 0xE5C03B87, "swap_mg" },
    { 0x1BDD6D68, "swap_missile_guy_on_boat" },
    { 0xDDF43E0C, "swap_model_for_fletcher" },
    { 0x12004DC4, "swap_notify" },
    { 0x574F891B, "swap_player_body_dmg1" },
    { 0xE54819E0, "swap_player_body_dmg2" },
    { 0x0B4A9449, "swap_player_body_dmg3" },
    { 0xA2AF069D, "swap_quadrotors" },
    { 0x57A31317, "swap_rez_now" },
    { 0x0BBB2797, "swap_rocks_at_timer" },
    { 0x3C01CEC6, "swap_skybox_over_time" },
    { 0xA9680E2D, "swap_spawner" },
    { 0x85BDBB35, "swap_staff_hint" },
    { 0x9A0BB3D4, "swap_struct_with_origin" },
    { 0x726054F3, "swap_tablet" },
    { 0x68DCE409, "swap_to_cut_model_hand" },
    { 0xF47C53D8, "swap_to_cut_model_head" },
    { 0x1C11D8BB, "swap_to_dissolve_models" },
    { 0x0B0E63D6, "swap_to_husk_model" },
    { 0x6136EA6A, "swap_to_primary_weapon" },
    { 0xB3FE9AC7, "swap_to_reznov" },
    { 0xD5B4AD89, "swap_trigger" },
    { 0x2B391577, "swap_tv_model" },
    { 0xCE47D886, "swap_vista" },
    { 0xC91E22C4, "swap_vtol" },
    { 0xF0EF1D77, "swap_vtols" },
    { 0x51A2A363, "swap_weapon" },
    { 0x81A7A8D4, "swap_weapon_to_detonator" },
    { 0x00889FA2, "swap_weapon_to_time_bomb" },
    { 0x6AF42152, "swap_weapons" },
    { 0x2230BD32, "swapai" },
    { 0x15134B38, "swapairstrikefx" },
    { 0xF8E02567, "swapanim" },
    { 0x0473F185, "swapdelay" },
    { 0x591EA373, "swapdropweapon" },
    { 0x545860BF, "swapdropweaponprimary" },
    { 0xC32D8EA0, "swappable" },
    { 0x9687E68B, "swapped" },
    { 0x1D5A06D8, "swapped_for_ai" },
    { 0xBA040350, "swapped_guy_monitor" },
    { 0x826534CD, "swapper" },
    { 0x4189719F, "swapper_ai_think" },
    { 0xAEAA81E0, "swapping" },
    { 0x9F67E7B3, "swaps" },
    { 0xE72B8BC6, "swapshotgun" },
    { 0xE3A62111, "swapsquads" },
    { 0x21A0B0B5, "swapto_ent" },
    { 0x5BF22954, "swapweapon" },
    { 0x284C5BBB, "swarm" },
    { 0x36654CEF, "swarm_attack_think" },
    { 0x808DE2C3, "swarm_cam" },
    { 0x55A395C8, "swarm_death_wait" },
    { 0xAC53680D, "swarm_end" },
    { 0xC34EC704, "swarm_fx" },
    { 0x198303BA, "swarm_hillside" },
    { 0x2344774D, "swarm_id" },
    { 0xCAD082E8, "swarm_init" },
    { 0x7E53DD74, "swarm_killstreak" },
    { 0x7F5674AF, "swarm_killstreak_abort" },
    { 0x0F67311A, "swarm_killstreak_end" },
    { 0x7854835D, "swarm_killstreak_fx" },
    { 0xBD624921, "swarm_killstreak_start" },
    { 0xFD681E4B, "swarm_killstreak_watch_for_emp" },
    { 0xCB5AF84D, "swarm_show_debug" },
    { 0xD82599FB, "swarm_sound" },
    { 0x99D5C745, "swarm_split_monitor" },
    { 0xE8C75E3E, "swarm_start" },
    { 0x744BAAAC, "swarm_state_cleanup" },
    { 0x0C57B33A, "swarm_state_enter" },
    { 0x82BAD969, "swarm_target" },
    { 0xE7AE420A, "swarm_think" },
    { 0x26EF99A5, "swarming" },
    { 0xB15E885A, "swarms" },
    { 0x273EACE0, "swarmsound" },
    { 0x529C838A, "swastika" },
    { 0x0292D37C, "swat" },
    { 0x75E1C21F, "swaths" },
    { 0x607790F9, "sway" },
    { 0xCFADB142, "sway1" },
    { 0xB08CF918, "sway1max" },
    { 0xA9AB36D9, "sway2" },
    { 0x073010B1, "sway2max" },
    { 0xD9411F02, "sway_init" },
    { 0x9487E73E, "swaycalc" },
    { 0x0670E50F, "swaying" },
    { 0x8F7ABE51, "swaymax" },
    { 0x80855563, "swaynum" },
    { 0xE7083D57, "swaypointtargetname" },
    { 0x5E2A29C1, "swayrig" },
    { 0xD4F3F9F3, "swayuavrig" },
    { 0xAC1CE8C8, "sweapon" },
    { 0x0C5022E3, "sweapons" },
    { 0xB5D856F0, "sweapontype" },
    { 0xE5E1A405, "swear" },
    { 0x99DCAF33, "sweat" },
    { 0x3789002B, "sweep" },
    { 0x921FBCF8, "sweep1" },
    { 0x04272C33, "sweep2" },
    { 0xF7DE1752, "sweep_dist" },
    { 0x3E227920, "sweep_point_1" },
    { 0xB2184609, "sweep_point_1_targetname" },
    { 0xB029E85B, "sweep_point_2" },
    { 0x9E498DE8, "sweep_point_2_targetname" },
    { 0x8A276DF2, "sweep_point_3" },
    { 0xCC1A6C67, "sweep_point_3_targetname" },
    { 0xCEDB49A2, "sweep_pooled_items" },
    { 0xB3ED6866, "sweeper" },
    { 0xDF18E5F5, "sweeping" },
    { 0x5EC34C0A, "sweeps" },
    { 0x3236245E, "sweeptrace" },
    { 0xCF92E9CF, "sweet" },
    { 0x4CA7D759, "sweet_spot_dist" },
    { 0x7AB9E6AE, "sweeteners" },
    { 0xA91000EE, "sweetner" },
    { 0x9791980E, "sweetness" },
    { 0xBA5D619A, "sweim" },
    { 0x701C29B7, "swells" },
    { 0x6DC7FBB8, "swept" },
    { 0xDBF53091, "swerve" },
    { 0xABB610C7, "swerved" },
    { 0x82D3D7D9, "swerved_left" },
    { 0x00301484, "swerved_right" },
    { 0xA3B8BE09, "swich" },
    { 0x89EF6FE6, "swift" },
    { 0xF1A65D0D, "swift_anim_done" },
    { 0x6A941C95, "swift_movements" },
    { 0x5F2860B8, "swift_tunnel_entrance_anim" },
    { 0x824452DD, "swift_tunnel_setup" },
    { 0x81EA7A85, "swim" },
    { 0xFEA8B32C, "swim_anim_rate" },
    { 0x64DE559E, "swim_arms_spawned" },
    { 0x7053F0E4, "swim_climb_dock_ends" },
    { 0xB2461E29, "swim_climb_dock_starts" },
    { 0x5B641937, "swim_end" },
    { 0x614DA90C, "swim_ent1" },
    { 0xD3551847, "swim_ent2" },
    { 0xAA272142, "swim_goal_reached" },
    { 0x7CC847A6, "swim_mechanic" },
    { 0xF38C916A, "swim_move_start" },
    { 0xE6202CC2, "swim_move_stop" },
    { 0x96A27324, "swim_out" },
    { 0x538C42E6, "swim_pos" },
    { 0xF4A5D1AB, "swim_splash_left" },
    { 0x97A2DB1E, "swim_splash_right" },
    { 0x6EE805D3, "swim_time" },
    { 0x301BFF02, "swim_times" },
    { 0x633239A0, "swim_to_shore_done" },
    { 0x6185FAFE, "swim_traversal" },
    { 0x20473B48, "swimbegin" },
    { 0x1AC467D3, "swimcancel" },
    { 0x89251340, "swimdepth" },
    { 0xC4A84E7C, "swimend" },
    { 0xA6CA0B88, "swimheight" },
    { 0x6B2A97AA, "swimmers" },
    { 0x9DCF23B6, "swimming" },
    { 0xE02B0C18, "swimming_begin" },
    { 0x58A064F3, "swimming_drown_vox" },
    { 0xFF1FE50C, "swimming_end" },
    { 0x28978EBB, "swimming_fog" },
    { 0x0E3FEEE1, "swimming_get_time" },
    { 0x5800DC13, "swimming_init" },
    { 0x18F92FB3, "swimming_loop_delete" },
    { 0x7E05DA1B, "swimming_loops_ai" },
    { 0x3630DFE9, "swimming_loops_plr" },
    { 0x81DFBBE5, "swimming_monitor" },
    { 0x52357C96, "swimming_notify" },
    { 0x24E21FCF, "swimming_surface_func" },
    { 0x12B7C26F, "swimming_underwater_func" },
    { 0x50497854, "swimming_vision_set" },
    { 0x24FACE0F, "swimmingarms" },
    { 0x8BA63B07, "swimmingarmshide" },
    { 0x9D01E478, "swimmingarmsspawn" },
    { 0xF42F8F03, "swimmingaudioambientsetup" },
    { 0x3F10B0E0, "swimmingdrown" },
    { 0xC6B705C3, "swimmingdrowndamage" },
    { 0x5A5D62DA, "swimmingdrownfx" },
    { 0x945DC3B8, "swimmingdrownvision" },
    { 0x63AB7D2C, "swimmingfeature" },
    { 0x471E04E4, "swimmingfx" },
    { 0x0950590E, "swimmingtracker" },
    { 0x382CFE14, "swims" },
    { 0x12010022, "swimtime" },
    { 0xB907551C, "swimverticalspeed" },
    { 0x70BFAD97, "swimwaterheight" },
    { 0xFAFAE945, "swing" },
    { 0x0CE14B48, "swing_door" },
    { 0xA535818B, "swing_lanterns" },
    { 0x09E62165, "swing_trail_fx" },
    { 0xC32210CA, "swingangle" },
    { 0xC436358B, "swingbacktime" },
    { 0xDD20AF5A, "swingcrate" },
    { 0xFF42BF31, "swingdeath" },
    { 0x780C3623, "swinging" },
    { 0xB6A15788, "swinging_death" },
    { 0xA426759D, "swinging_lamp_init" },
    { 0x8BCE21D4, "swings" },
    { 0x51FF56E2, "swingtime" },
    { 0x661B0C8D, "swipe" },
    { 0x5ED154C5, "swipe_end_time" },
    { 0xA6752387, "swipeactionanimation" },
    { 0x6EFECE41, "swipeactionast" },
    { 0x9535398C, "swipeactiontime" },
    { 0xF13B8B33, "swiped" },
    { 0xB7165F0C, "swipes" },
    { 0x8F6EDCBD, "switch" },
    { 0x11675B4C, "switch group" },
    { 0x7425001D, "switch_activated" },
    { 0x7BE2D810, "switch_ambient_packages" },
    { 0x94CDFFA1, "switch_and_takeover" },
    { 0x4F2B5F02, "switch_announcer_to_richtofen" },
    { 0x8A304C74, "switch_argus_zones" },
    { 0x5AAF79B7, "switch_array" },
    { 0x1E948CED, "switch_back_primary_weapon" },
    { 0x4AFE8035, "switch_banks" },
    { 0xB4F1A60D, "switch_between_zland_poi" },
    { 0xF43214AD, "switch_briggs_anims" },
    { 0x0B3572AC, "switch_button" },
    { 0x05FE5594, "switch_case" },
    { 0x807962F6, "switch_character_anims" },
    { 0xEC20FBB0, "switch_character_anims_nopresets" },
    { 0x48C45E36, "switch_climbin_anim" },
    { 0xAC9F34C7, "switch_climbout_anim" },
    { 0x49021025, "switch_complete" },
    { 0x4881F8AF, "switch_console_activated" },
    { 0x84AC6FA8, "switch_enemies" },
    { 0x2B5445C8, "switch_flipped" },
    { 0xC2652266, "switch_flipped_generator" },
    { 0x7FFBBBA6, "switch_for_pby_pt" },
    { 0xEC2AA6A7, "switch_forward" },
    { 0x9FD5BDE7, "switch_from_alt_weapon" },
    { 0x3D178F50, "switch_from_cockpit_to_ground" },
    { 0x100011CC, "switch_from_ground_to_cockpit" },
    { 0x21EFC711, "switch_fullstatic" },
    { 0x4BF78C36, "switch_head" },
    { 0x41D48EE8, "switch_head_terrorist_4" },
    { 0x67D70951, "switch_head_terrorist_5" },
    { 0x13537CD2, "switch_in_flamethrower" },
    { 0xB7424B3E, "switch_in_two" },
    { 0x6D187124, "switch_index" },
    { 0x3C301B07, "switch_input_done" },
    { 0xAA71237A, "switch_interrogation_hands" },
    { 0x49BB3425, "switch_light_mixers" },
    { 0x50636A65, "switch_light_once_only" },
    { 0x4BC9052F, "switch_lights" },
    { 0x7E56FBA4, "switch_music_check" },
    { 0xA3754C0F, "switch_music_timer" },
    { 0x7A32228F, "switch_music_wait" },
    { 0x9A223F9D, "switch_nearend" },
    { 0xD6363C63, "switch_nearfullstatic" },
    { 0x79E359D4, "switch_node" },
    { 0x0BA1B816, "switch_node_name" },
    { 0x0676E447, "switch_nodes" },
    { 0x8C93298F, "switch_nodes_1" },
    { 0x1A8BBA54, "switch_nodes_2" },
    { 0x51C9CB36, "switch_off_angola_escape_triggers" },
    { 0x61AA1DCB, "switch_off_monkey_lander_fx" },
    { 0x26E4EDFA, "switch_on_angola_escape_trigges" },
    { 0xA2038B54, "switch_path_when_node_reached" },
    { 0xBF60BF0E, "switch_player_gadget" },
    { 0xA79C7999, "switch_player_scene_to_delta" },
    { 0xCC7230D6, "switch_player_to_delta" },
    { 0x1E646DB6, "switch_player_to_mason" },
    { 0xFA729BCC, "switch_player_to_sniper_weapon" },
    { 0x5FE27261, "switch_progress_sound" },
    { 0x9FFA470D, "switch_rifles" },
    { 0x57E4640A, "switch_sack" },
    { 0x9CA708D2, "switch_screams" },
    { 0x76B38552, "switch_successful" },
    { 0x2CF16C29, "switch_target_boards" },
    { 0x7D7B3D4B, "switch_team" },
    { 0x9E6F12F4, "switch_team_fordamage" },
    { 0x0A41ACDC, "switch_test" },
    { 0x4F219225, "switch_text" },
    { 0xC19E0E8B, "switch_time" },
    { 0x513AC94B, "switch_time_text" },
    { 0x72A4E306, "switch_to_colors" },
    { 0x8C122BC3, "switch_to_crush_asm" },
    { 0x3172785E, "switch_to_detonator" },
    { 0x15D18557, "switch_to_engine_high" },
    { 0xD61DD023, "switch_to_engine_low" },
    { 0x3EB4F91B, "switch_to_engine_taxi" },
    { 0xF3111FC2, "switch_to_fpv" },
    { 0x1CB37636, "switch_to_last_non_killstreak_weapon" },
    { 0x76B792ED, "switch_to_left" },
    { 0x31E4A04E, "switch_to_melee" },
    { 0x40BFFFC7, "switch_to_minigun" },
    { 0xB42DB73B, "switch_to_pistol" },
    { 0x5BABFCD1, "switch_to_player" },
    { 0x51BDB647, "switch_to_primary_weapon" },
    { 0x20ECDF90, "switch_to_right" },
    { 0xFCB0A8E9, "switch_to_rockets" },
    { 0x02A06F73, "switch_to_sidearm" },
    { 0x7C5B14BB, "switch_to_startpath" },
    { 0xF75E8EB0, "switch_to_tpv" },
    { 0xFC127F76, "switch_to_weapon" },
    { 0x378F58B5, "switch_track" },
    { 0xA3341FBE, "switch_trans" },
    { 0x31353764, "switch_trigger" },
    { 0x4DAD8FFE, "switch_turret" },
    { 0x28414727, "switch_up" },
    { 0x2CAB7CE0, "switch_vehicle" },
    { 0x4865D99A, "switch_vision_set_after" },
    { 0x9B9A063F, "switch_water_for_rest_of_creek" },
    { 0xE604661D, "switch_water_to_default" },
    { 0x4C9498EC, "switch_weapon" },
    { 0x620B8C08, "switch_weapon_asap" },
    { 0x221C54E6, "switch_weapon_in" },
    { 0xA78D11C1, "switch_weapon_out" },
    { 0x8EDFB455, "switch_woods_anims" },
    { 0xA98B9D01, "switchable" },
    { 0x67122BD1, "switchableweapon" },
    { 0x7B5D460F, "switchactiveambientpackage" },
    { 0x369B65C8, "switchactiveambientroom" },
    { 0x3C157F02, "switchanim" },
    { 0xA65C6FFA, "switcharoo" },
    { 0xFE0A9A78, "switchback" },
    { 0xF52F8DD3, "switchbacks" },
    { 0xC865426A, "switched" },
    { 0x377A4E37, "switched_light" },
    { 0x3B7FA3DE, "switchedsides" },
    { 0x3224C440, "switchedteamsresetgadgets" },
    { 0xCC6A61D7, "switchended" },
    { 0x3E350A84, "switchentnum" },
    { 0x034821AF, "switchers" },
    { 0xDA450B15, "switches" },
    { 0x82FFDEB5, "switchfrac" },
    { 0x519C4C0B, "switchfx" },
    { 0xED4ABFB8, "switchimmediate" },
    { 0x8F386B6F, "switchindex" },
    { 0xB8E6262B, "switching" },
    { 0x3AE7C74D, "switching_chars" },
    { 0x320486A0, "switching_teams" },
    { 0x25320EE9, "switching_to_occupied_turret_text" },
    { 0xEBAFB984, "switching_turret" },
    { 0x73B21F9C, "switchlevelvar" },
    { 0x5563B53F, "switchmap_preload" },
    { 0xA63AEE74, "switchmap_switch" },
    { 0x995D0A24, "switchmodel" },
    { 0x8AA95804, "switchname" },
    { 0xB3CA4C9D, "switchnode" },
    { 0xD384B9DC, "switchnodes" },
    { 0x35B7CD7C, "switchs" },
    { 0xB7E0259F, "switchsides" },
    { 0x83DB9DBA, "switchtime" },
    { 0x195D1223, "switchto_drone_override_node" },
    { 0x79B4692E, "switchto_minigun" },
    { 0x99981BBC, "switchto_rockets" },
    { 0x2A9ECFCD, "switchtoclientvolumetricfog" },
    { 0x4B423771, "switchtolastnonkillstreakweapon" },
    { 0xC437FF3A, "switchtolastweapon" },
    { 0x3373D11A, "switchtooffhand" },
    { 0x56F8C331, "switchtoservervolumetricfog" },
    { 0x522F2C8B, "switchtosidearm" },
    { 0x85E683CF, "switchtosidearmdone" },
    { 0xB76765A0, "switchtovalidweapon" },
    { 0xCB53A41E, "switchtoweapon" },
    { 0x5D207126, "switchtoweapon_hack" },
    { 0x09785D11, "switchtoweaponimmediate" },
    { 0x3A7DFFF5, "switchtype" },
    { 0xE41A57BD, "switchweapon" },
    { 0x7FAA6E7C, "switchweapons" },
    { 0x7D4243B5, "switchwith" },
    { 0x4BE3FF7F, "swoop" },
    { 0x0206DE14, "sword" },
    { 0x8A282A6C, "sword_anim" },
    { 0x60199CA0, "sword_endgame_1" },
    { 0xD2210BDB, "sword_endgame_2" },
    { 0xAC1E9172, "sword_endgame_3" },
    { 0xB5E41A6E, "sword_endgame_array" },
    { 0x8B8463D7, "sword_kill" },
    { 0x4A7C4345, "sword_kill_power" },
    { 0xEF480D3D, "sword_lobby" },
    { 0x8CF730BA, "sword_mode_minpower" },
    { 0x2F66D06F, "sword_officer" },
    { 0xC9265B2E, "sword_power" },
    { 0x8DC23941, "sword_pulled" },
    { 0xD0F529AD, "swordkills_challenge" },
    { 0x8135101C, "swordpreserve" },
    { 0x2809587D, "swore" },
    { 0x7E1FA62E, "sworn" },
    { 0x2C7E4791, "swp" },
    { 0x9038368B, "swtich" },
    { 0xC1F283C0, "swtiched" },
    { 0x4376A3A5, "symbol" },
    { 0x599ED59E, "symmetric" },
    { 0x3B546FFC, "sympathy" },
    { 0xC53180C5, "sympletic" },
    { 0x18F8A70D, "symptoms" },
    { 0x04ABF398, "sync" },
    { 0x345FCA73, "sync_done" },
    { 0x50465D16, "sync_follower_movemode" },
    { 0x41C3A56B, "sync_melee_blend_time" },
    { 0x078E7FF5, "sync_melee_lerp_time" },
    { 0xBD0B68FD, "sync_melee_slope_threshold" },
    { 0xB86F27C7, "sync_node" },
    { 0x8308CCBF, "sync_node_a" },
    { 0xA3A91AD0, "sync_struct" },
    { 0x6D3F377C, "sync_struct_a" },
    { 0x688BC01C, "sync_time" },
    { 0x5213BB4D, "sync_vehicle" },
    { 0xDE0A7C5E, "sync_with_client_scene" },
    { 0x00BA8C98, "sync_with_other_scenes" },
    { 0xB704D03D, "syncaiming" },
    { 0xCDB613AB, "synced" },
    { 0x9784F0A7, "synced_delete" },
    { 0xC03E2615, "synced_karambit_attack_done" },
    { 0x25DFFCF4, "synced_melee_dist_threshold_sq" },
    { 0xC1C2CAE6, "syncedmeleetarget" },
    { 0x0F2E49E3, "syncfirenodes" },
    { 0x038A8C60, "synch" },
    { 0xC13CFB25, "synchronize" },
    { 0x5A7EB512, "synchronize_binoc_anims" },
    { 0xCD5D7DDE, "synchronize_players" },
    { 0x7F078A3B, "synchronized" },
    { 0xC697C9E7, "synchronized_melee_ended" },
    { 0x73EB9D1C, "synchronous" },
    { 0x2A7FBC80, "syncing" },
    { 0x4C9DA628, "syncnotetrackent" },
    { 0x494D55E6, "syncpos" },
    { 0x54F56C9F, "syncrot" },
    { 0x05CD7573, "syncs" },
    { 0x559686A1, "syncsystemstates" },
    { 0xF7929048, "synctagangles" },
    { 0x6FFCD5B6, "syncxpstat" },
    { 0xC334AE4E, "syned" },
    { 0x026F5A53, "synonymous" },
    { 0xF5804A6C, "syntax" },
    { 0x04AFA9D3, "synthetic_clip_distance" },
    { 0xE5C73C43, "syrette" },
    { 0x53B034BC, "syringe" },
    { 0x2E3CA4C4, "sys" },
    { 0x0C587C73, "sysid" },
    { 0x7A067983, "sysstate" },
    { 0x15E46A98, "syst" },
    { 0xBEA63B8A, "system" },
    { 0x6B9651E8, "system_default_corpse_detect_ranges" },
    { 0x8319110B, "system_default_detect_ranges" },
    { 0x87ECDD16, "system_elements" },
    { 0x87FD3A1A, "system_event_change" },
    { 0x7F4A0CAA, "system_funcs" },
    { 0xE0DB6C48, "system_handle_clipbrush" },
    { 0xB996F627, "system_init" },
    { 0x035656DD, "system_init_shadows" },
    { 0x5F21D95F, "system_init_state_functions" },
    { 0x63D6C3AB, "system_message_handler" },
    { 0x074D9B1F, "system_message_loop" },
    { 0x483E0A58, "system_name" },
    { 0xE8698435, "system_offline_messages" },
    { 0x30553C67, "system_overload" },
    { 0xF1AC4000, "system_set_detect_ranges" },
    { 0x6FF5CFC8, "system_set_state_function" },
    { 0xAE32C3AE, "system_shared" },
    { 0x10FE6FAF, "system_state_alert" },
    { 0x3DA7FC56, "system_state_functions" },
    { 0x50F8673F, "system_state_hidden" },
    { 0xC7E52C22, "system_state_spotted" },
    { 0xE1E4CB2B, "system_trigger_funcs" },
    { 0x428B58CD, "systematic" },
    { 0x9AEB5A0B, "systematically" },
    { 0x91CD4E52, "systemlink" },
    { 0x24C2CDC5, "systems" },
    { 0xA6B0EAB5, "szombies" },
    { 0x6DC319E8, "szonetargetname" },
    { 0xE78C0153, "t" },
    { 0xF4DD0959, "t0" },
    { 0xCEDA8EF0, "t1" },
    { 0x40E1FE2B, "t2" },
    { 0xEFA01D95, "t2bfx" },
    { 0x27BAEEB5, "t2d" },
    { 0xCD38A321, "t2dn" },
    { 0x575B8D12, "t34" },
    { 0x02CE8B5D, "t34_move_and_blow_up" },
    { 0x1AD089F9, "t34_trigger_spawn_move" },
    { 0x06FF9394, "t34_trigger_spawn_move_stop" },
    { 0x7D8869B7, "t34_trigger_spawn_move_stop_fire" },
    { 0x9056581D, "t34s" },
    { 0x7AE97F54, "t4_02b" },
    { 0x72CCF185, "t4_jbu_02_b" },
    { 0x037BCBCF, "t4_jbu_04_b" },
    { 0x66E47894, "t5" },
    { 0xCF293A2E, "t5_jbu_02_b" },
    { 0xAFEE8D2D, "t5_veh_boat_nvapatrolboat" },
    { 0xD8EBE7CF, "t6" },
    { 0x56B8B91A, "t6_todo" },
    { 0x8567688B, "t6_wpn_grenade_frag_projectile" },
    { 0x88B7C6B9, "t6_wpn_pulwar_sword_prop" },
    { 0xFDF53F71, "t6_wpn_zmb_shield_dmg1_view" },
    { 0xCEB0B8C0, "t6_wpn_zmb_shield_dmg2_view" },
    { 0x7904A157, "t6todo" },
    { 0xC5274A37, "t6todo2" },
    { 0xEB56AB6F, "t6todolevel" },
    { 0xB2E96D66, "t7" },
    { 0xDFE93670, "t72" },
    { 0x8DFC852A, "t72_convoy_pkg" },
    { 0xF3AC8F0A, "t72_exploded" },
    { 0xDFC096A2, "t72_explosion_explode" },
    { 0xFC532862, "t72_explosionfx" },
    { 0x5775C4EF, "t72_in_final_position" },
    { 0xE45E5F68, "t72_kill_player_trigger" },
    { 0x5B8FD890, "t72_moveout" },
    { 0x907D4DD5, "t72_unit2" },
    { 0x44785903, "t72_unit4" },
    { 0x5DB32774, "t72_wait_novis" },
    { 0xBB943B1B, "t72_wait_vis" },
    { 0x3DB12DDB, "t72s" },
    { 0x04EB4BF3, "t7_cleanup" },
    { 0xBECA1638, "t7_jbu_02_b" },
    { 0xADEE16FF, "t7_jbu_02_b_2" },
    { 0x93E4450F, "t7_jbu_02_b_cu" },
    { 0x953F45DF, "t7_jbu_02_b_cu_alt" },
    { 0x9D6A43D6, "t7todo" },
    { 0x24F0DCA1, "t8" },
    { 0x427BFCBD, "t_alley" },
    { 0xB0FDE15B, "t_ammo_cache" },
    { 0x7623D86D, "t_ammo_cache_horse" },
    { 0x578A4CDD, "t_ammo_trigger" },
    { 0x0C323D79, "t_anim" },
    { 0xDE99DE68, "t_anim_trigger" },
    { 0x4BE43D17, "t_apartments" },
    { 0xC32277B7, "t_arch_trig" },
    { 0x7F5F7AAB, "t_archway" },
    { 0x257E1643, "t_audio_bump" },
    { 0xE6D9F70E, "t_axe" },
    { 0x290F0B29, "t_back_door_pdf" },
    { 0x7EB7C8E2, "t_balcony" },
    { 0xE418600B, "t_balcony_kick" },
    { 0x0A111CDE, "t_bathtub" },
    { 0x621A9761, "t_behind_bus" },
    { 0xC02E44CB, "t_billboard" },
    { 0xE1C84C10, "t_birdbath" },
    { 0x9107D512, "t_boarding" },
    { 0xA3421348, "t_bp3_cache" },
    { 0xC2C8BA36, "t_bp3_exit" },
    { 0x98774DBE, "t_bp3_uaz" },
    { 0xD224548A, "t_breach_trig" },
    { 0xE3FFD761, "t_bridge" },
    { 0x050FACD7, "t_brutality_start" },
    { 0xFBF09DFA, "t_brute_force" },
    { 0x59330286, "t_brute_use" },
    { 0x14D08B3F, "t_bruteforce" },
    { 0xE053E39B, "t_bullseye" },
    { 0xEFDE4D1E, "t_bump" },
    { 0x577916B5, "t_bunker" },
    { 0x02AE5017, "t_bus_kill" },
    { 0x56D910C6, "t_button" },
    { 0xF4F074D2, "t_bypass" },
    { 0x5EFE4348, "t_cache" },
    { 0x73F2D3AA, "t_cache_guard" },
    { 0x6AB5703C, "t_call_box" },
    { 0x3C4ECE7E, "t_call_triggers" },
    { 0xDE24A55C, "t_chalk_line" },
    { 0x3FC16714, "t_chase" },
    { 0x7C8F15DD, "t_child_guards" },
    { 0x50DBD86F, "t_cia" },
    { 0x6E0530A2, "t_cigar_box" },
    { 0xEB399561, "t_civilian_react" },
    { 0xC4A1B346, "t_cleanup" },
    { 0xDCEABCDD, "t_climb_help" },
    { 0xDBF26AA4, "t_clip" },
    { 0xF5975477, "t_color" },
    { 0x2262A142, "t_color_moveup" },
    { 0xCFA1F47A, "t_color_trigger" },
    { 0x1D08FDB9, "t_console" },
    { 0x608A0D4D, "t_control" },
    { 0x268983D4, "t_corpse_room" },
    { 0x2D879F81, "t_corpse_room_dmg" },
    { 0x59B8E2D4, "t_courtryard_trig" },
    { 0xB8188381, "t_crafting_table" },
    { 0x2CA6F0BD, "t_crane" },
    { 0x5B882CE8, "t_crane_building" },
    { 0xFE6EB061, "t_current" },
    { 0x87C431F4, "t_current_tree" },
    { 0x2EB20475, "t_damage" },
    { 0x098D1E23, "t_damage_area" },
    { 0x547C2C4A, "t_debris_trigger" },
    { 0x46391C63, "t_deep_warn" },
    { 0x71F4F784, "t_delta" },
    { 0xBF5619BC, "t_destroy" },
    { 0xCA89EBBE, "t_dig" },
    { 0x974E1A22, "t_dmg" },
    { 0xE4F2F922, "t_door" },
    { 0xDFFEAF5E, "t_door_damage" },
    { 0xE7B23748, "t_doortrig" },
    { 0xD9933867, "t_drone_kill" },
    { 0x285CA557, "t_drones" },
    { 0x984DDC10, "t_dryer" },
    { 0xEBE8479D, "t_electric_chair" },
    { 0x3F69EE40, "t_elevator" },
    { 0xE2D82AC3, "t_elevator_door" },
    { 0xA7ABEEE3, "t_end_nag_trigger" },
    { 0xB3268BE4, "t_enter" },
    { 0x32BCA896, "t_enter_hut" },
    { 0x3D009F82, "t_event" },
    { 0x2F267447, "t_execution_ground_volume" },
    { 0xAA79CA36, "t_exit" },
    { 0x5AE45933, "t_exit_village" },
    { 0x49AC8C6B, "t_explosive" },
    { 0x855EC10A, "t_f35_bump_trigger" },
    { 0xAAD350CE, "t_fail" },
    { 0x726FFA53, "t_fail_before_log" },
    { 0xCD7E1D5A, "t_fail_player" },
    { 0x7650B808, "t_fail_valley" },
    { 0x28853FC1, "t_final_color_moveup" },
    { 0x91F67406, "t_fire_damage" },
    { 0xDFBC51EB, "t_firewater" },
    { 0x6C7BACDA, "t_flyby" },
    { 0xFF704818, "t_for_warp" },
    { 0x16DAF45A, "t_fountain" },
    { 0xE5819EC2, "t_frustrum" },
    { 0x45A12514, "t_fx_anim" },
    { 0x226203B2, "t_garage_trig" },
    { 0xDBDF4698, "t_gas_station" },
    { 0xC7D80925, "t_generator" },
    { 0x03E75F90, "t_going" },
    { 0xDF264B8A, "t_gramophone" },
    { 0xF90E2D47, "t_groundref_x" },
    { 0xD30BB2DE, "t_groundref_y" },
    { 0xAD093875, "t_groundref_z" },
    { 0xF0E94A11, "t_hack" },
    { 0x24D5B014, "t_hide_and_show" },
    { 0x04B9CC89, "t_hill_civ_spawner" },
    { 0x2DF9FCC1, "t_hit" },
    { 0x54571DD0, "t_hole" },
    { 0x9862134E, "t_house" },
    { 0xAB222B4D, "t_hurt" },
    { 0xA62D40B4, "t_hurt_trigger" },
    { 0x2E68EB67, "t_in_vent" },
    { 0xB7BC613F, "t_intruder" },
    { 0x67B56DAB, "t_intruder_use" },
    { 0x85CC8092, "t_key_door" },
    { 0x82259875, "t_kick_trig" },
    { 0x66EE586A, "t_kill" },
    { 0xBC358049, "t_kill_bus" },
    { 0x3605FAA9, "t_kill_car" },
    { 0x85C7C111, "t_kill_spawn_managers" },
    { 0x8F0EBE8B, "t_kill_zone" },
    { 0xDBCADB22, "t_killbrush_1" },
    { 0xB5C860B9, "t_killbrush_2" },
    { 0x8FC5E650, "t_killbrush_3" },
    { 0x977E832B, "t_laser" },
    { 0x0E4159F5, "t_left" },
    { 0x817FC102, "t_left_apc" },
    { 0x8DC05632, "t_leg" },
    { 0x990F5AE5, "t_limpspeed" },
    { 0xA4BEC914, "t_limpspeedsettime" },
    { 0x6215AED7, "t_lobby_elevator" },
    { 0x4D97EF91, "t_log_scene" },
    { 0x8909CEDB, "t_look" },
    { 0x1030677C, "t_lookat" },
    { 0x5AFBB061, "t_map_table" },
    { 0x2929A8F7, "t_map_vo_trigger" },
    { 0xC4748824, "t_max" },
    { 0x5F7C7FB6, "t_melee" },
    { 0xB1D0498A, "t_min" },
    { 0xE4BB243D, "t_missiles" },
    { 0xF0851EDF, "t_move_triggers" },
    { 0xA6EB392A, "t_move_up_to_drain" },
    { 0xF9C6CD86, "t_moveup_1" },
    { 0xD3C4531D, "t_moveup_2" },
    { 0xADC1D8B4, "t_moveup_3" },
    { 0x7B660B17, "t_moveup_final" },
    { 0x5A6A133F, "t_moveup_initial" },
    { 0x301F5F0A, "t_mytrig" },
    { 0x3A9146D3, "t_name" },
    { 0x3214B0DC, "t_near" },
    { 0x837EAD38, "t_near_rock" },
    { 0xC48A2070, "t_no_prone" },
    { 0xFFC08F0E, "t_now" },
    { 0x93CB1C05, "t_obj" },
    { 0x047590E4, "t_obj_capture_bc" },
    { 0xE3EA0B8C, "t_obj_main_entrance" },
    { 0xD4CFD66C, "t_obj_transmission" },
    { 0xE6D3C477, "t_objective" },
    { 0x200C0F5E, "t_objective_door" },
    { 0xAE54AB06, "t_one" },
    { 0x4A4867A6, "t_open" },
    { 0xFE71DF79, "t_opposite" },
    { 0x0D2A05F5, "t_opposite_call_trigger" },
    { 0xE7DB546E, "t_opposite_move_trigger" },
    { 0x8E38D369, "t_other_hurt_trigger" },
    { 0xCBA9708F, "t_other_panel" },
    { 0xD05386A1, "t_overlook" },
    { 0x5AF1BA98, "t_panel" },
    { 0xA1047585, "t_pap" },
    { 0x7278D49E, "t_pap_intro" },
    { 0x3F3797E8, "t_parking_structure" },
    { 0x5DBE695D, "t_parking_structure_vehicle" },
    { 0x93A5AD0B, "t_path" },
    { 0x769EB977, "t_pdf_enter" },
    { 0x48906FD0, "t_perimeter_patrol" },
    { 0xE6579EB2, "t_perk" },
    { 0x0A020BEE, "t_perk_use" },
    { 0x2DBE4801, "t_physics" },
    { 0xC0CBA69A, "t_pickup" },
    { 0x85C7DACD, "t_place_ball" },
    { 0xE617F46A, "t_plane_fly" },
    { 0x47ADF3DB, "t_plane_fly_afterlife" },
    { 0xAAC76443, "t_plane_fuelable" },
    { 0xC515E144, "t_player_board" },
    { 0x17813E24, "t_player_door_exit_mall" },
    { 0xD01CCFD4, "t_plaza_left_color" },
    { 0xB829AAEF, "t_plaza_right_color" },
    { 0x267D8990, "t_portal" },
    { 0x7776DB3F, "t_position" },
    { 0x351F82C4, "t_pre_garage_trig" },
    { 0xEF070908, "t_previous_alerted_tree" },
    { 0x50792995, "t_proximity" },
    { 0xE6F2F73E, "t_pulley_hurt_trigger" },
    { 0xD7553254, "t_pulwar_victim" },
    { 0x8EA2179E, "t_push" },
    { 0xC4F4A571, "t_putdown" },
    { 0xBDA499D3, "t_putdown_ball" },
    { 0x3DB312A5, "t_radio_tower" },
    { 0x64852F68, "t_radius" },
    { 0x5497CA19, "t_rage" },
    { 0xC642B7BE, "t_rappel" },
    { 0x71B23F6F, "t_react" },
    { 0xF339EF05, "t_revive" },
    { 0x3E407AC7, "t_revive_machine" },
    { 0xEAA8468E, "t_reward_pickup" },
    { 0x43E4F6A0, "t_ride" },
    { 0xBD508191, "t_ride_trigger" },
    { 0xCEC0E1D8, "t_right" },
    { 0xD39BFF1F, "t_right_apc" },
    { 0xF8BCB128, "t_roof" },
    { 0xB8AE8DA8, "t_room1" },
    { 0x2AB5FCE3, "t_room2" },
    { 0x2AE5CD21, "t_sanity_check" },
    { 0x500F39FE, "t_scare" },
    { 0x301CADCC, "t_secondary" },
    { 0xDE3F34FF, "t_shoulder_bash" },
    { 0xA9F921D5, "t_sinkhole" },
    { 0x2215412B, "t_sit_rep_trig" },
    { 0x5C01EF86, "t_sm_street_back" },
    { 0x84B39D2E, "t_sm_village_fail" },
    { 0x40563B93, "t_sniper" },
    { 0xEFCA0762, "t_sniper_tree" },
    { 0xE537A693, "t_spawn" },
    { 0x1423AFD3, "t_spawn_manager" },
    { 0x61A4A454, "t_sq_bg" },
    { 0x34AA3CBA, "t_stairfall" },
    { 0x8B856A66, "t_start" },
    { 0xAA670BE6, "t_stop" },
    { 0xE3736410, "t_street_push_back" },
    { 0x5515E49C, "t_street_trig" },
    { 0x2CC31ED7, "t_success" },
    { 0xEBBB6440, "t_temp" },
    { 0xEBE07DB1, "t_to_be_deleted" },
    { 0x63D76D39, "t_touching" },
    { 0x4E2B907D, "t_tower" },
    { 0x285DE5A8, "t_tower_guys" },
    { 0x9DBA3D0C, "t_transporter" },
    { 0xAF96FBD4, "t_trig" },
    { 0x58230DEE, "t_trigger" },
    { 0xCEB2E828, "t_two" },
    { 0x5B4376C2, "t_unload_trigger" },
    { 0x5CFDD5E6, "t_upgrade" },
    { 0xDA697227, "t_use" },
    { 0xCD2C058A, "t_vehicle_spawn" },
    { 0x2D8492BB, "t_vehicle_spawner" },
    { 0xE37382A0, "t_vehicle_spawner_2" },
    { 0xF171C1C8, "t_villager_escape_goal" },
    { 0x0CF3723E, "t_vision_1" },
    { 0xE6F0F7D5, "t_vision_2" },
    { 0x02189544, "t_volume" },
    { 0x4E591E2D, "t_wait" },
    { 0x139297F8, "t_waitttime" },
    { 0x7C6E0466, "t_war_room" },
    { 0x4B0CD8CB, "t_warden_fence" },
    { 0x6B027FDD, "t_warden_fence_damage" },
    { 0x0086AF5B, "t_warehouse" },
    { 0xE5B9A78E, "t_warn" },
    { 0x3A329B1A, "t_warn_player" },
    { 0xC80D3F8F, "t_water" },
    { 0x59ED1F41, "t_wave" },
    { 0x459B3A28, "t_weapon_swap" },
    { 0xE5C2AE35, "t_zapper_field" },
    { 0x9DF04EF0, "t_zombie_blood_dig" },
    { 0xBDF5E96C, "t_zone" },
    { 0xEE144E20, "ta" },
    { 0xAF636BB1, "ta_tellerfee" },
    { 0x5CABA3AF, "ta_vaultfee" },
    { 0xC8EF85C0, "taacom" },
    { 0x99B9E96B, "taacom_killstreak_ready_wait" },
    { 0x10DF2E08, "taacombundle" },
    { 0xE8E5F223, "taacombundles" },
    { 0x89F44C55, "taacomdialogbundlekey" },
    { 0x2E24E6E8, "taacomwaittime" },
    { 0xF50E09D2, "tab" },
    { 0x988FFB13, "table" },
    { 0x4977714C, "table_ai_accuracy" },
    { 0x0F6B3B5C, "table_ai_armor" },
    { 0xB9D82C04, "table_ai_boss" },
    { 0x10038254, "table_ai_classname" },
    { 0x42DC5365, "table_ai_classtype" },
    { 0x3FE2FE7C, "table_ai_cmd_tag" },
    { 0x2CB64080, "table_ai_desc" },
    { 0x22A67C75, "table_ai_equipment" },
    { 0xB20E813D, "table_ai_health" },
    { 0x42AA6E01, "table_ai_initializer" },
    { 0x095D6832, "table_ai_name" },
    { 0x08B1BFC6, "table_ai_ref" },
    { 0x98F9CE1F, "table_ai_regen_rate" },
    { 0xADB9041B, "table_ai_species" },
    { 0x6411773A, "table_ai_swap_notify" },
    { 0xFD2516A3, "table_ai_swap_spawner" },
    { 0x4956B524, "table_ai_type_index_end" },
    { 0xCC1C928F, "table_ai_type_index_start" },
    { 0x601E41AC, "table_ai_veh_seat" },
    { 0x1BFD6B44, "table_ammo" },
    { 0xDB1951A4, "table_ammo_cost" },
    { 0x7FB1C476, "table_boss_ai" },
    { 0xBC36F619, "table_boss_delay" },
    { 0x0DD1DB53, "table_boss_nonai" },
    { 0xBA750826, "table_chance" },
    { 0x72A89032, "table_class_accuracy" },
    { 0x711EFC12, "table_class_armor" },
    { 0x5A796803, "table_class_equipment" },
    { 0x73D6D71A, "table_class_grenade_ammo" },
    { 0x0A10DF3C, "table_class_grenades" },
    { 0x72B09F0B, "table_class_health" },
    { 0x02EB189A, "table_class_icon" },
    { 0x61A28C41, "table_class_index_end" },
    { 0x43A0B8CA, "table_class_index_start" },
    { 0x7BF9B07A, "table_class_killstreaks" },
    { 0x62FA43FC, "table_class_perks" },
    { 0x7D753560, "table_class_ref" },
    { 0xC70CF7BE, "table_class_speed" },
    { 0xC03C317A, "table_class_weapon_ammo" },
    { 0x895316DC, "table_class_weapons" },
    { 0x8721D1B1, "table_cost" },
    { 0x976C13AE, "table_def_csv" },
    { 0x0E358987, "table_delay" },
    { 0xDAB949E1, "table_desc" },
    { 0x819F8DDE, "table_dialog" },
    { 0x463AA5AB, "table_eat_done" },
    { 0x44108451, "table_ev_cooldown" },
    { 0x6AF9F9C8, "table_ev_daisy" },
    { 0xC2895F50, "table_ev_index_end" },
    { 0x9FF33BE3, "table_ev_index_start" },
    { 0x31660108, "table_ev_latency" },
    { 0x076A09AD, "table_ev_maxplays" },
    { 0xCFD89D8A, "table_ev_param1" },
    { 0xA9D62321, "table_ev_param2" },
    { 0x83D3A8B8, "table_ev_param3" },
    { 0x6E80556A, "table_ev_priority" },
    { 0xD7A89D69, "table_ev_ref" },
    { 0xE85EBE05, "table_ev_triggernotify" },
    { 0x5E2EDBAE, "table_ev_type" },
    { 0x664318DF, "table_ev_unique" },
    { 0xBCBF009B, "table_flip" },
    { 0x24D14EA4, "table_flip_guy_died" },
    { 0x4C144F0E, "table_flip_open" },
    { 0x7CCB52AD, "table_flip_setup" },
    { 0x65F2688C, "table_flip_trig" },
    { 0xC1397ABA, "table_flips" },
    { 0xFCF2609D, "table_game_scenario" },
    { 0x616CE2D7, "table_game_type" },
    { 0xEFF8E423, "table_goto" },
    { 0xFBF695FE, "table_guys" },
    { 0x1AC407EF, "table_hall" },
    { 0x04AAE1A7, "table_idx" },
    { 0x89BAD3AA, "table_index" },
    { 0xE3A879BB, "table_minimum_populatiion" },
    { 0xCA71C793, "table_name" },
    { 0xD9902E6A, "table_nextwave_threshold" },
    { 0x5D211A12, "table_now_cover" },
    { 0xEDADEDA0, "table_org" },
    { 0xE5B103E7, "table_origins" },
    { 0x9CD49359, "table_package_index_end" },
    { 0x3AB7DCF2, "table_package_index_start" },
    { 0x88EF78BF, "table_pkg_binding_buy" },
    { 0x9341CC9C, "table_pkg_binding_command" },
    { 0xC375FBA2, "table_pkg_binding_takeover" },
    { 0x0A3EFB88, "table_pkg_cost" },
    { 0x982A732F, "table_pkg_delivery" },
    { 0x93129DC0, "table_pkg_desc" },
    { 0x8503C6C4, "table_pkg_gateflag" },
    { 0x56B02E30, "table_pkg_icon" },
    { 0x8E036E15, "table_pkg_marker" },
    { 0xE70B50C8, "table_pkg_max_in_play" },
    { 0x5172484E, "table_pkg_min_in_play" },
    { 0x27B39672, "table_pkg_name" },
    { 0x74FADFD4, "table_pkg_notify" },
    { 0x20B9B09F, "table_pkg_poi_dep" },
    { 0x3E9378C9, "table_pkg_qty" },
    { 0x1E626C06, "table_pkg_ref" },
    { 0xA2D429DE, "table_pkg_squad_type" },
    { 0x61A8CC74, "table_pkg_units" },
    { 0x80FB5CC0, "table_poi_captime" },
    { 0x6A31B779, "table_poi_faketarget" },
    { 0xC8C0A1FF, "table_poi_health" },
    { 0x7CB3A65D, "table_poi_index_end" },
    { 0xB7B97DCE, "table_poi_index_start" },
    { 0x4E1A0560, "table_poi_intrudercap" },
    { 0xD2C90130, "table_poi_model" },
    { 0xBBAA3256, "table_poi_obj_zoff" },
    { 0x406AF20A, "table_poi_objective" },
    { 0x2F074624, "table_poi_ref" },
    { 0x65D305EB, "table_poi_retake" },
    { 0xF124959E, "table_poi_showcompass" },
    { 0x2EF09B4E, "table_poi_team" },
    { 0x441BBF84, "table_rank" },
    { 0xCB54E689, "table_ref" },
    { 0xE8D3122F, "table_repeat" },
    { 0x63CC7B72, "table_row" },
    { 0x6CD90553, "table_rule_ally_team_dmg_reducer" },
    { 0xF80B167C, "table_rule_camera_angle_default" },
    { 0x4E684EDB, "table_rule_camera_angle_offsets" },
    { 0x7150A9C0, "table_rule_camera_mode" },
    { 0xC7C24C7B, "table_rule_enemyhelo" },
    { 0x64E101CA, "table_rule_enemyrvtol" },
    { 0xE6A3F8BF, "table_rule_index_end" },
    { 0xE05175F4, "table_rule_index_start" },
    { 0xAF5B3CA0, "table_rule_player_dmg_reducer" },
    { 0x9765365F, "table_rule_player_nag_squads" },
    { 0xAC6DDAE2, "table_rule_playerhelo" },
    { 0xEE1E628F, "table_rule_playervtol" },
    { 0xA1B55392, "table_rule_randomize_side" },
    { 0xBBDAEEDA, "table_rule_ref" },
    { 0xD39ED140, "table_rule_time" },
    { 0x28DE9286, "table_rule_transport_refuel" },
    { 0x2E715F75, "table_rule_z_height_default" },
    { 0xDC9B7372, "table_rule_zoom_avail" },
    { 0x29E3FB21, "table_scenario_index" },
    { 0x9E76D2DD, "table_shared" },
    { 0x065640FA, "table_slot" },
    { 0x4876ADE3, "table_special" },
    { 0xBF6B1AC6, "table_special_num" },
    { 0x27655148, "table_squad_size" },
    { 0x450C5BD3, "table_squad_type" },
    { 0x50B9274D, "table_struct" },
    { 0x13D4202C, "table_throw_01" },
    { 0xEA9195A9, "table_throw_01_start" },
    { 0x85DB8F67, "table_throw_02" },
    { 0xA85534D2, "table_throw_02_start" },
    { 0xEA63F281, "table_to_flip" },
    { 0xE9057CFB, "table_to_flip_model" },
    { 0x877DAB94, "table_trig" },
    { 0x948A2A4E, "table_type" },
    { 0x82715405, "table_user_defined" },
    { 0x1250DAF9, "table_value" },
    { 0x9FB88456, "table_var1" },
    { 0x24125267, "table_watch_reaction_complete" },
    { 0xEC480901, "table_wave" },
    { 0x88D5C716, "table_wave_def_index_end" },
    { 0x886BEED5, "table_wave_def_index_start" },
    { 0xB8B4DD59, "table_wave_lock" },
    { 0x80B15C98, "table_wave_unlock" },
    { 0xF8DC0662, "tablecoll_post" },
    { 0xCD5C483F, "tablecoll_pre" },
    { 0x7325530D, "tablehackedhealth" },
    { 0x2C2F6249, "tablehealth" },
    { 0xA00662BC, "tableid" },
    { 0xD4CC1345, "tablelookup" },
    { 0x5A31CE6C, "tablelookupcolumnforrow" },
    { 0xA6DF0337, "tablelookupfindcoreasset" },
    { 0x5E4FE4F9, "tablelookupistring" },
    { 0xD1439E4F, "tablelookuprow" },
    { 0x008F1EF9, "tablelookuprownum" },
    { 0xAC1550E5, "tablelowhealth" },
    { 0xEC4B31DD, "tablemaxhealth" },
    { 0x48DBA58E, "tablename" },
    { 0x1DA98CC4, "tablenumber" },
    { 0x6C1FBF6D, "tablerow" },
    { 0x04C04742, "tables" },
    { 0x76C7B67D, "tablet" },
    { 0xF15A36CE, "tablet_cleanliness_chastise" },
    { 0x76DE2F82, "tablet_cleanliness_thread" },
    { 0xFF41B522, "tabtype" },
    { 0xF5EBF79F, "tabun" },
    { 0x59C9129B, "tabun_debug" },
    { 0x63ABB1A0, "tabun_debug_line" },
    { 0x3FCBD5F8, "tabun_draw_cylinder_stop" },
    { 0x9932A23A, "tabungasduration" },
    { 0x4EA8921B, "tabungaspoisonheight" },
    { 0xFB767C28, "tabungaspoisonradius" },
    { 0x97EDFE91, "tabungasshockheight" },
    { 0xE493DA22, "tabungasshockradius" },
    { 0xDF3C0D7E, "tabuninitialgasshockduration" },
    { 0x02CAB558, "tabunshocksound" },
    { 0xFB0EA77C, "tabunsound" },
    { 0x5CB6CC2A, "tabunwalkingasshockduration" },
    { 0x1B10843B, "tac" },
    { 0x0A73D771, "tac_insert" },
    { 0x928E76D8, "tac_inserts" },
    { 0xE07D757C, "tacinsert" },
    { 0x2EB643BD, "tacinsertboost" },
    { 0xD0250D08, "tacitus" },
    { 0xC6A4A863, "tackle" },
    { 0x0A9CFF4D, "tackle_death_watcher" },
    { 0xDF7B0ECC, "tackle_end_window" },
    { 0x8FEF1D25, "tackle_start_window" },
    { 0x466959C4, "tackle_vic" },
    { 0xC86CFAAC, "tackle_vic_spawn" },
    { 0x6F51161D, "tackled" },
    { 0x97D622AA, "tackled_marine" },
    { 0xC3247ABB, "tackler" },
    { 0x09162AE6, "tackling" },
    { 0x6C5992EF, "tacmask" },
    { 0x244806C6, "taco" },
    { 0x426BD3EE, "tacodistsq" },
    { 0xDC99EE79, "tacos" },
    { 0x571F94D7, "tacpos" },
    { 0xCE31B915, "tact" },
    { 0x5A96D8BB, "tact_all_move" },
    { 0x8F211F8E, "tact_all_move_done" },
    { 0x5BD31451, "tact_all_move_done_done" },
    { 0xB331331B, "tact_all_move_ready" },
    { 0x7186FB3B, "tact_alltarget_enemy" },
    { 0x231CE70E, "tact_alltarget_enemy_done" },
    { 0x288C419B, "tact_alltarget_enemy_ready" },
    { 0x799D3C95, "tact_clamp" },
    { 0xFE26077D, "tact_claw" },
    { 0x5A6A4700, "tact_claw_done" },
    { 0x2FCA5ABB, "tact_claw_done_done" },
    { 0xCD5466C7, "tact_claw_move" },
    { 0x0048B72A, "tact_claw_move_done" },
    { 0xD8980A3D, "tact_claw_move_done_done" },
    { 0x03015925, "tact_claw_ready" },
    { 0x57335757, "tact_control" },
    { 0xA6F8D5BA, "tact_control_done" },
    { 0x8652714D, "tact_control_done_done" },
    { 0x8FB3E90F, "tact_control_ready" },
    { 0xB90DC5FC, "tact_enemy" },
    { 0x0A711327, "tact_enemy_done" },
    { 0xBFBCB4CA, "tact_enemy_done_done" },
    { 0x697DCF48, "tact_enemy_ready" },
    { 0x5CD051B5, "tact_expire" },
    { 0x57DD8F28, "tact_highlight" },
    { 0xBD9A7A03, "tact_highlight_done" },
    { 0x3AB97DBC, "tact_highlight_ready" },
    { 0x1031A059, "tact_inf" },
    { 0x8A3BF51C, "tact_inf_done" },
    { 0x95E22307, "tact_inf_done_done" },
    { 0x0ACFD1C4, "tact_inf_instruction" },
    { 0xAD17B1EF, "tact_inf_instruction_done" },
    { 0xC9DF6173, "tact_inf_move" },
    { 0x4BCD8426, "tact_inf_move_done" },
    { 0xAFC0E369, "tact_inf_move_done_done" },
    { 0x10597A93, "tact_inf_move_ready" },
    { 0x25BB1059, "tact_inf_ready" },
    { 0xCEE0A1B6, "tact_marker" },
    { 0x297D9C39, "tact_marker_done" },
    { 0xC321BBD2, "tact_marker_ready" },
    { 0xE46FF996, "tact_move_claw_instruction" },
    { 0xF423B259, "tact_move_claw_instruction_done" },
    { 0x5408B372, "tact_move_claw_instruction_ready" },
    { 0x6648E28A, "tact_prompt" },
    { 0x632E9E1C, "tact_prompt2" },
    { 0x6297DE07, "tact_prompt2_done" },
    { 0x2EDA7F6A, "tact_prompt2_done_done" },
    { 0xD5F6C2A8, "tact_prompt2_ready" },
    { 0x55D687DD, "tact_prompt_done" },
    { 0xDC47D5A0, "tact_prompt_done_done" },
    { 0x89D52A93, "tact_target" },
    { 0xB3807586, "tact_target_done" },
    { 0xEF5F5A32, "tact_target_enemy" },
    { 0xAEC0C445, "tact_target_enemy_done" },
    { 0x6836D5A8, "tact_target_enemy_done_done" },
    { 0xD82F0673, "tact_target_ready" },
    { 0xE9049815, "tact_targetasd" },
    { 0x7D0525B8, "tact_targetasd_done" },
    { 0x9D367D53, "tact_targetasd_done_done" },
    { 0x02F7DA41, "tactic" },
    { 0x0C0357F2, "tactical" },
    { 0xFFE725F9, "tactical_arrival_facing_yaw" },
    { 0x83FA8B51, "tactical_chance" },
    { 0xE5E2DCDA, "tactical_insertion_canceled" },
    { 0xD6B5C660, "tactical_insertion_destroyed" },
    { 0xE2D8A8AC, "tactical_nade_amt" },
    { 0x9C639D17, "tactical_scan_blend_out" },
    { 0xD5D523AA, "tactical_scan_interval" },
    { 0x0DB30A37, "tactical_walk_short_dist_sq" },
    { 0x08385083, "tacticaldistancemax" },
    { 0x833A914F, "tacticaldistancemaxsq" },
    { 0xCD4EAE6D, "tacticaldistancemin" },
    { 0x42D92B9D, "tacticaldistanceminsq" },
    { 0xF4917972, "tacticalfaceangle" },
    { 0x91A5EB04, "tacticalgrenade" },
    { 0x498514E9, "tacticalgrenadecount" },
    { 0xB313BA29, "tacticalinsertion" },
    { 0x286C9816, "tacticalinsertioncount" },
    { 0xAB70035C, "tacticalinsertiondestroyedbytrophysystem" },
    { 0xF43DCDEF, "tacticalinsertionfx" },
    { 0x605E31FE, "tacticalinsertiontime" },
    { 0x2EB217B9, "tacticalinsertionweapon" },
    { 0x88C222FF, "tactically" },
    { 0x3BD0DDE2, "tacticalmask" },
    { 0x39655029, "tacticalmaskfiltermapped" },
    { 0x5656857D, "tacticals" },
    { 0xD43BD5D5, "tacticalview" },
    { 0xC5097F9D, "tacticalwalk" },
    { 0xA480E8BD, "tacticalwalkactionstart" },
    { 0x2BB61BFD, "tacticalwalkforwardtobackwardtransition" },
    { 0xEFEDA88B, "tacticalwalking" },
    { 0x9F48170F, "tacticalwalkrate" },
    { 0x1DBF2D33, "tacticalwalkscanterminate" },
    { 0xBE47C90A, "tacticalweight" },
    { 0x85F9969E, "tacticval" },
    { 0xC055A1B6, "tactview" },
    { 0x6715790D, "tae" },
    { 0x21B2881A, "tafx" },
    { 0xB31A6DDF, "tag" },
    { 0xCC0F6F54, "tag1" },
    { 0x3E16DE8F, "tag2" },
    { 0x18146426, "tag3" },
    { 0x5A080019, "tag4" },
    { 0xCCDCA5E7, "tag_a" },
    { 0x4E00DB19, "tag_aim" },
    { 0x030A2A3F, "tag_aim_animated" },
    { 0x37C93B3D, "tag_align" },
    { 0xBBFA90FC, "tag_aligns" },
    { 0xAA68E132, "tag_ammo_locker_jnt" },
    { 0xA0E6F236, "tag_angles" },
    { 0x9B9704DF, "tag_animate" },
    { 0x83F75C15, "tag_array" },
    { 0x5AD536AC, "tag_b" },
    { 0x8837CF49, "tag_base" },
    { 0x05B81646, "tag_bomb" },
    { 0x3DF1A3D6, "tag_bullet" },
    { 0x1D2CEC7F, "tag_bunk_right_top" },
    { 0x80D7B115, "tag_c" },
    { 0xB5E70878, "tag_cabin_roof_joint_02" },
    { 0x0CD296E8, "tag_chunks" },
    { 0xC6A66D61, "tag_churn_ang" },
    { 0x88090431, "tag_churn_fx" },
    { 0xBB090A03, "tag_churn_pos" },
    { 0x6ABCF8F9, "tag_claimed" },
    { 0xE3B70D52, "tag_console_fx" },
    { 0xED9F77B0, "tag_driver" },
    { 0xAC4AB34B, "tag_driver_angles" },
    { 0xB9811765, "tag_driver_origin" },
    { 0x10FE0541, "tag_ent" },
    { 0x9F8857B7, "tag_entity" },
    { 0x3197A6DB, "tag_exh" },
    { 0x616FC525, "tag_eye" },
    { 0xE907C614, "tag_flash" },
    { 0x080F6F1F, "tag_flash_gunner1" },
    { 0x82EB7529, "tag_flash_gunner4_spot" },
    { 0x3A3BD67B, "tag_flash_loc" },
    { 0x9677EA17, "tag_flash_pos" },
    { 0xE1F8690A, "tag_foot" },
    { 0x0B2C979B, "tag_fov" },
    { 0x7A5035D6, "tag_front_corner_joint_01" },
    { 0x544DBB6D, "tag_front_corner_joint_02" },
    { 0x5D7F7CA0, "tag_fx" },
    { 0x0CB75454, "tag_fx_engine_left1" },
    { 0x62C3D087, "tag_fx_engine_right1" },
    { 0x0CBEED02, "tag_fx_engine_tail" },
    { 0xB10AF7BA, "tag_glint" },
    { 0x1C138C93, "tag_ground" },
    { 0xF2AD77F6, "tag_gunner_barrel4" },
    { 0xAEBAB81D, "tag_gunner_turret1" },
    { 0x9C99D2F1, "tag_guy0" },
    { 0x76975888, "tag_guy1" },
    { 0x0EA1422C, "tag_guy5" },
    { 0x6C85FFA9, "tag_guy8" },
    { 0x66CFB3AE, "tag_guy_num" },
    { 0x0AF5A89F, "tag_height" },
    { 0x23CE8FC7, "tag_hood_vent_left_fx" },
    { 0x38FC5FA6, "tag_hood_vent_right_fx" },
    { 0x16CA5989, "tag_id" },
    { 0xFA7CE3AF, "tag_l1" },
    { 0x88757474, "tag_l2" },
    { 0x13DE58A1, "tag_left" },
    { 0x5602F684, "tag_left_angles" },
    { 0x6899C6B0, "tag_left_foot" },
    { 0x6E9F60E7, "tag_left_orig" },
    { 0xF99BFD21, "tag_lid" },
    { 0x985FEFEF, "tag_light_belly" },
    { 0x0068FD13, "tag_light_l_wing" },
    { 0x1E727113, "tag_main_root_dist" },
    { 0x1DFA0550, "tag_monitor_damaged_1" },
    { 0x9001748B, "tag_monitor_damaged_2" },
    { 0x2400F93E, "tag_monitor_healthy" },
    { 0x4A51399A, "tag_monitor_healthy_water" },
    { 0x0EC87177, "tag_name" },
    { 0x83A2A6AE, "tag_names" },
    { 0xDEE68EBE, "tag_neck_dist" },
    { 0x2DCE9CD2, "tag_num" },
    { 0xCAD9541A, "tag_occupied" },
    { 0x3DE9DD1B, "tag_offset" },
    { 0xFCF83D34, "tag_org" },
    { 0xFC854048, "tag_origin" },
    { 0x4EFFA390, "tag_origin_animate" },
    { 0xEF2EBA88, "tag_origin_linkto" },
    { 0x6D55B5CA, "tag_override" },
    { 0x1287D1C3, "tag_owner" },
    { 0x0E7D99EA, "tag_part_02" },
    { 0x34801453, "tag_part_03" },
    { 0xC46A99A2, "tag_passenger" },
    { 0x5BF9FAFF, "tag_passenger1" },
    { 0xE9F28BC4, "tag_passenger2" },
    { 0x0FF5062D, "tag_passenger3" },
    { 0x9DED96F2, "tag_passenger4" },
    { 0xC3F0115B, "tag_passenger5" },
    { 0x51E8A220, "tag_passenger6" },
    { 0x3BC2B055, "tag_player" },
    { 0xF051786E, "tag_player_origin" },
    { 0xD3FF35DC, "tag_pos" },
    { 0x70D39A0B, "tag_position" },
    { 0x1E3A666D, "tag_r1" },
    { 0x443CE0D6, "tag_r2" },
    { 0x0E9812A1, "tag_range" },
    { 0x3D85E90C, "tag_right" },
    { 0x83D641D7, "tag_right_angles" },
    { 0x1265C28F, "tag_right_foot" },
    { 0x276520F4, "tag_right_orig" },
    { 0x9B24050F, "tag_rocket_l" },
    { 0x25FCA566, "tag_rocket_left" },
    { 0x87015351, "tag_rocket_r" },
    { 0xF2C992FD, "tag_rocket_right" },
    { 0x39EC6137, "tag_sound" },
    { 0xD46638CA, "tag_spin" },
    { 0x02070517, "tag_spin_origin" },
    { 0x8129EAD4, "tag_stowed_back" },
    { 0x6C3ED028, "tag_stowed_hip" },
    { 0xF8DED078, "tag_struct_index" },
    { 0xE27C0277, "tag_sync" },
    { 0xC74FE9AE, "tag_syncs" },
    { 0x07E01317, "tag_to_target" },
    { 0x2A2412CE, "tag_trail" },
    { 0x93EC30F7, "tag_turret_loc" },
    { 0x61EA5115, "tag_used" },
    { 0x308FF7AA, "tag_wake" },
    { 0xB02DDDB7, "tag_wake_origin" },
    { 0x234B06BA, "tag_weapon" },
    { 0xCF45B7C7, "tag_weapon1" },
    { 0x75159D1E, "tag_weapon_left" },
    { 0x95129ED5, "tag_weapon_right" },
    { 0xC7EBE3A3, "tagangles" },
    { 0x538FC792, "tagarray" },
    { 0x00DAB3D6, "tagcameraangles" },
    { 0x5C7901E8, "tagcameraorigin" },
    { 0xC4B10967, "tagets" },
    { 0x0B6B5445, "tagged" },
    { 0x88D5E2D3, "taglist" },
    { 0xCD9517D2, "tagname" },
    { 0x6E28F8DD, "tagnames" },
    { 0x72E75789, "tagnum" },
    { 0x1DFF32DB, "tagorg" },
    { 0x2882FD1D, "tagorigin" },
    { 0x811C0400, "tagplayerangles" },
    { 0x0B941F26, "tagplayerorigin" },
    { 0xFE78656B, "tagpos" },
    { 0x98B2FE66, "tags" },
    { 0x70478C4E, "tags_debug_print" },
    { 0x825B8F41, "tags_drawing" },
    { 0x3E38856A, "tagskeys" },
    { 0x6E8D9F5B, "tagsstodetach" },
    { 0xCD6CD1B7, "tagteamupdater" },
    { 0xF10CC9B8, "tagtmr" },
    { 0x77ADC01F, "tail" },
    { 0x9657CCB3, "tail_bullet_hole" },
    { 0xA7246081, "tail_ent" },
    { 0x1A525D16, "tail_light" },
    { 0x35FC650A, "tail_override" },
    { 0x1E6C6C87, "tail_wing" },
    { 0x541F3049, "tailfx" },
    { 0xF6381B21, "tailing" },
    { 0x94B9ECFD, "taillight" },
    { 0xBEDBB0D0, "taillight_left_org" },
    { 0x8AFB3DB1, "taillight_right_org" },
    { 0x6385CEDE, "taillighteffect" },
    { 0x55C0E74B, "taillightfx" },
    { 0x04AAF378, "taillightleftfx" },
    { 0xC5078C7A, "taillightleftfxhandle" },
    { 0x0E828282, "taillightlefttag" },
    { 0xBA18C617, "taillightrightfx" },
    { 0x6B5A3F51, "taillightrightfxhandle" },
    { 0x72F1D5AB, "taillightrighttag" },
    { 0x6C201CA2, "taillights_off" },
    { 0xADB05B94, "taillights_on" },
    { 0x962461AF, "tailored" },
    { 0x38242C58, "tainted" },
    { 0x7EEDE554, "take" },
    { 0x41F50E9D, "take_additional_primary_weapon_perk" },
    { 0x9F037FAA, "take_additionalprimaryweapon" },
    { 0x498AC57D, "take_all_grenades_and_equipment" },
    { 0xD27A5016, "take_all_perks" },
    { 0x5D8CEFB2, "take_all_player_weapons" },
    { 0x198B2A61, "take_ammo" },
    { 0x8A853FED, "take_ammo_from_supplydrop" },
    { 0x0C2D5D36, "take_and_give_back_player_weapons" },
    { 0x04AE6705, "take_and_giveback_weapons" },
    { 0xC38443B4, "take_away_weapon" },
    { 0xACAC290D, "take_binoc_trig" },
    { 0xCF6A8172, "take_binocular_anim" },
    { 0x38021DB3, "take_bow_from_woods" },
    { 0x5B72D247, "take_bowie" },
    { 0x6939735F, "take_carry_weapon" },
    { 0x1DDBE9DE, "take_carry_weapon_on_death" },
    { 0x7717B395, "take_claymores_from_top" },
    { 0xA7E53E73, "take_color_node" },
    { 0xF68B6E2A, "take_cover_against_overpass" },
    { 0xEF26DBE4, "take_cover_at_corner" },
    { 0xFBA272E7, "take_cover_done" },
    { 0xAAC5BFDE, "take_cover_warning_loop" },
    { 0x34F06B20, "take_deadshot_perk" },
    { 0xD41AC2D8, "take_disguise_vo" },
    { 0xDC042532, "take_fake_ppsh" },
    { 0x89166084, "take_fallback_weapon" },
    { 0x2435BB1B, "take_fn" },
    { 0xBC304CE5, "take_front_trigger" },
    { 0x98D843DB, "take_gadget" },
    { 0xFBD02062, "take_hero_weapon" },
    { 0x9C9DAC0A, "take_juggernaut_perk" },
    { 0x47AF8114, "take_masons_weapons" },
    { 0x929436BA, "take_menendez_high_rage_perks" },
    { 0x045F3DD6, "take_no_damage" },
    { 0x807E2AA2, "take_object" },
    { 0x037D013A, "take_off" },
    { 0xA7784A37, "take_off_accel" },
    { 0x66588045, "take_off_mask" },
    { 0x70A42119, "take_off_node" },
    { 0x2FC4056C, "take_off_oxygen_mask" },
    { 0xAB9A3068, "take_offhand_weapon" },
    { 0xDCFC8BDE, "take_old_weapon_and_give_new" },
    { 0xE0DF5301, "take_old_weapon_and_give_reward" },
    { 0x4FEF4084, "take_on_ally_class" },
    { 0x32E5D6BC, "take_out_pier_guy" },
    { 0x1A5F0B2A, "take_overheated_jetgun" },
    { 0xD441173B, "take_perk" },
    { 0xF19A85D0, "take_perk_by_slot" },
    { 0x40959B19, "take_player_damage_only" },
    { 0xC342CFBC, "take_player_damage_only_anim_func" },
    { 0x91B6D2DC, "take_player_damage_only_for_scene" },
    { 0x620102E7, "take_player_damage_only_for_time" },
    { 0xB8777DC2, "take_player_gadgets" },
    { 0x0B9ED5FE, "take_player_weapons" },
    { 0x6A8C051B, "take_players_out_of_tutorial_mode" },
    { 0xB3739C47, "take_quick_revive_perk" },
    { 0x1E4E31A4, "take_random_path" },
    { 0x18456364, "take_rear_trigger" },
    { 0xFEC0AB8A, "take_ref" },
    { 0xF369EA73, "take_rocket" },
    { 0x693C1581, "take_satchels_from_top" },
    { 0xA98B8E2A, "take_slienced_weapons_obj" },
    { 0x425B3603, "take_spot" },
    { 0xAA3CCB2D, "take_tazer" },
    { 0x4964F518, "take_then_give_weapons" },
    { 0x061DFEF0, "take_train_car" },
    { 0x1F37E85B, "take_use_weapon" },
    { 0xEA65CBE8, "take_vc2s_gun" },
    { 0xADF68331, "take_vulture_perk" },
    { 0x4DBFC32F, "take_weapon" },
    { 0xD9179028, "take_weapon_after_use" },
    { 0x18CD2F76, "take_weapons" },
    { 0xE3A79B82, "takeallkillstreaks" },
    { 0xFE91F994, "takeallweapons" },
    { 0x2E6B91E2, "takecoverwarnings" },
    { 0x9940BB20, "takecrossbow" },
    { 0x002DD707, "takedamage" },
    { 0xCAB66598, "takedown" },
    { 0xDAC93FF1, "takedown_apache_vo" },
    { 0xEE85B72C, "takeeasyononetarget" },
    { 0x045521AA, "takekillstreak" },
    { 0xE6613238, "takelivesondeath" },
    { 0xE817EE02, "taken" },
    { 0x135F4DD1, "taken_control_over" },
    { 0xC85285E8, "taken_nodes" },
    { 0xEC233958, "taken_off" },
    { 0x16E12822, "taken_pct" },
    { 0x556C84CF, "taken_perm" },
    { 0x0E1A686B, "takeo" },
    { 0xBF2AB813, "takeo_char_index" },
    { 0xF3192D48, "takeo_char_index_r" },
    { 0x42456E51, "takeobject" },
    { 0x210CC013, "takeoff" },
    { 0x428EC04E, "takeoff_end_game" },
    { 0x8D996522, "takeoff_knockdown" },
    { 0xDBBE88AD, "takeoff_nuke" },
    { 0x691D2960, "takeoff_pre_end_game" },
    { 0x2BC65BCE, "takeoff_rocket" },
    { 0x610292AE, "takeoff_trigger" },
    { 0x87A2D342, "takeoff_when_timer_is_out" },
    { 0xF209C6C6, "takeofffx1" },
    { 0xF4E09EBE, "takeoldweapons" },
    { 0xFF09DBBA, "takeover" },
    { 0x68DBA229, "takeover_" },
    { 0x6AA6B851, "takeover_attack" },
    { 0x4300FBE1, "takeover_briefing" },
    { 0x71F85BAE, "takeover_briefing_dialogue" },
    { 0x6D582D31, "takeover_clear_roof" },
    { 0x7372FF70, "takeover_complete" },
    { 0x1AA547E7, "takeover_fade" },
    { 0xF1B775FE, "takeover_flags" },
    { 0xF49560FA, "takeover_force" },
    { 0x1149384A, "takeover_objective" },
    { 0x1F99FC26, "takeover_player" },
    { 0x68A6085C, "takeover_setup" },
    { 0xDDFB257C, "takeoverinitialize" },
    { 0x11F3512E, "takeovernote" },
    { 0xA8608A25, "takeoverselected" },
    { 0xC6ABDEB6, "takeoverselectedinfantry" },
    { 0x8CE687F7, "takeoverselectedvehicle" },
    { 0x8ED01E0B, "takeoverterminate" },
    { 0xC6A7810E, "takeplayercontrol" },
    { 0x8D451252, "takeplayeroutoflaststand" },
    { 0x500E045E, "taker" },
    { 0x755741EC, "takerocket" },
    { 0x76107EC7, "takes" },
    { 0x6FBF2659, "takes_damage" },
    { 0x94820246, "takes_damage_door_guard" },
    { 0x6D8F65AC, "takes_damage_from_player" },
    { 0x525D2379, "takes_in_route" },
    { 0x18B4BAE3, "takesquadfeatures" },
    { 0xFDEF90F5, "takeuseweapon" },
    { 0x1F3745C0, "takeweapon" },
    { 0xB0F7FE07, "takeweaponafteruse" },
    { 0xF5E295EB, "takeweapons" },
    { 0x8395D2DD, "taking" },
    { 0x2DE8FD0D, "taking_evasive_actions" },
    { 0x4EEA3A5C, "taking_fire" },
    { 0x47D5F8F8, "taking_fire_sfx" },
    { 0xCDC40800, "taking_first_shots" },
    { 0xFA9F1B6F, "taking_off" },
    { 0x79202B29, "takingburndamage" },
    { 0xD2C149F2, "taks" },
    { 0x6D49D1A7, "talk" },
    { 0xD738B5ED, "talk_for_time" },
    { 0x2D08DF4D, "talk_guard" },
    { 0x00B01A8A, "talk_num" },
    { 0x30BB5A88, "talk_scientist" },
    { 0x30C6A76D, "talk_spots" },
    { 0x56B82395, "talk_timer" },
    { 0x9A17A768, "talkanim" },
    { 0xA1BCC4C0, "talkdelay" },
    { 0x219C516C, "talked" },
    { 0x35BF032A, "talker" },
    { 0x242711DD, "talker_characterid" },
    { 0xD41ACDDD, "talker_guys" },
    { 0x4296428D, "talker_hangar_spawn_func" },
    { 0xA4746149, "talker_node" },
    { 0x62F188A6, "talker_number" },
    { 0x7EF02437, "talker_origin" },
    { 0xE8315D23, "talker_spawn_func" },
    { 0xBEE93FE5, "talkers" },
    { 0xBBEEF451, "talkers_and_spawners" },
    { 0xD1D18F79, "talking" },
    { 0x8F2531BB, "talking_russian" },
    { 0x2F1FB9F3, "talknotifyseed" },
    { 0xB8FDC51E, "talks" },
    { 0x25AF19DE, "talks_in_danger" },
    { 0x633878C8, "tall" },
    { 0x2B27E18C, "tall_grass_enemy_clean_up" },
    { 0x8B34C72D, "tall_grass_general_nag" },
    { 0x0BEEAE6E, "tall_grass_hold_nag" },
    { 0x64E6828F, "tall_grass_moment_over" },
    { 0x3C1EFBDC, "tall_grass_nag" },
    { 0x529DD29A, "tall_grass_patrol_vo" },
    { 0x711DA0DF, "tall_grass_stealth" },
    { 0xC6799E02, "tall_grass_stealth_done" },
    { 0x70F9D63F, "tall_grass_stealth_vo" },
    { 0x6220FB3D, "taller" },
    { 0xD09B0AC9, "tally" },
    { 0xFF0F497D, "tally_completed_challenge" },
    { 0xA37BBCCA, "tally_dark_kills" },
    { 0xD144F67F, "tallying" },
    { 0x0A6DA157, "talon" },
    { 0x6BFA7510, "talon_deactivated" },
    { 0x936A7EFE, "talon_enemy" },
    { 0x5405CAEB, "talon_friendly" },
    { 0x650C0717, "talon_headicon_offset" },
    { 0x40764E5C, "talon_hint_done" },
    { 0x830FBDDB, "talon_light_fx" },
    { 0xFE355730, "talon_models" },
    { 0x06E160DA, "talon_picked_up" },
    { 0x6ECA6885, "talon_placed" },
    { 0x96FB318F, "talon_spawn" },
    { 0xC7533672, "talon_spawner" },
    { 0xF8A8A40E, "talon_storage_door_setup" },
    { 0x25C0EA93, "talon_storage_setup" },
    { 0x5F844CCD, "talonbulletglass" },
    { 0x7A6FC182, "talonbulletglassleft" },
    { 0x2B2136F1, "talonbulletglassright" },
    { 0xFB28529F, "taloninhurttrigger" },
    { 0x58874E24, "taloninnoplacementtrigger" },
    { 0x080E6A0E, "talons" },
    { 0xFD0544C6, "talonspawnorigin" },
    { 0xB55901B5, "tampered" },
    { 0x7C80CD6D, "tampers" },
    { 0xBD2BC6BE, "tan" },
    { 0xD0108D9C, "tangent" },
    { 0x2F19D817, "tangles" },
    { 0xEF4EC7B8, "tango" },
    { 0xB672F2CB, "tango_down_detection" },
    { 0x6720D3BA, "tango_down_dialog" },
    { 0x02459513, "tangos" },
    { 0x74C176C9, "tank" },
    { 0xF23D0EB7, "tank01_death" },
    { 0xFD122DC2, "tank01_death_start" },
    { 0x5D53EE69, "tank01_entrance" },
    { 0xF45AC8F8, "tank01_entrance_start" },
    { 0x3FB91F95, "tank01_turret" },
    { 0x4F149052, "tank1" },
    { 0xE4A4CA71, "tank1_disabled" },
    { 0xDE8906F8, "tank1_entrance_go" },
    { 0x33A42F24, "tank1_part2" },
    { 0xC0005435, "tank1_strat" },
    { 0x75EAB3FA, "tank1_target" },
    { 0x20A37387, "tank1_target1" },
    { 0xAE9C044C, "tank1_target2" },
    { 0xD49E7EB5, "tank1_target3" },
    { 0x72AEEDD3, "tank1_trig" },
    { 0x40B89A2A, "tank1attacknode" },
    { 0x291215E9, "tank2" },
    { 0x521FDD23, "tank2_attacked" },
    { 0x37215FB5, "tank2_first_attack" },
    { 0x343091D8, "tank2_is_attacked" },
    { 0xE1CD4FCB, "tank2_part2" },
    { 0x4876BF2F, "tank2_riders" },
    { 0xDBE3961F, "tank2_second_attack" },
    { 0x4494F932, "tank2_strat" },
    { 0xE294ECCE, "tank2_surrender" },
    { 0xF40DD657, "tank2_target" },
    { 0x029E49FC, "tank2_target1" },
    { 0x74A5B937, "tank2_target2" },
    { 0x4EA33ECE, "tank2_target3" },
    { 0x0F56BCCA, "tank2_trig" },
    { 0x030F9B80, "tank3" },
    { 0xB551523E, "tank3_at_first_stop" },
    { 0x181CE62F, "tank3_attack" },
    { 0xF73F4974, "tank3_attacked" },
    { 0xBF97159C, "tank3_riders" },
    { 0x4099EE17, "tank3_strat" },
    { 0xC67DC2DB, "tank3_targets" },
    { 0x8008F8E9, "tank3_trig" },
    { 0x0D20F45F, "tank4" },
    { 0xE71E79F6, "tank5" },
    { 0x215EDC3D, "tank_1" },
    { 0xC1EC462A, "tank_1_death_failsafe" },
    { 0xD2B73DE5, "tank_1_outro" },
    { 0x34BC654E, "tank_1_shoot_strat" },
    { 0x476156A6, "tank_2" },
    { 0x1F7F530E, "tank_2_outro" },
    { 0x3C313EF1, "tank_2_shoot_strat" },
    { 0x6D63D10F, "tank_3" },
    { 0xDD5F0694, "tank_3_dead" },
    { 0xD757E104, "tank_3_gets_shot" },
    { 0x3D85DE1C, "tank_3_gets_shot_failsafe" },
    { 0x1440E297, "tank_3_outro" },
    { 0x0AA8751C, "tank_3_shoot_strat" },
    { 0x281AAC69, "tank_3_start_node" },
    { 0x09B1C05C, "tank_4_start_node" },
    { 0x0F0CE9FA, "tank_abort" },
    { 0xDC7F776F, "tank_abort_think" },
    { 0x76B4B3C0, "tank_advancement_alley" },
    { 0xE9BC835D, "tank_advancement_arch" },
    { 0x07343D7B, "tank_advancement_bog" },
    { 0x75F7093E, "tank_aim_think" },
    { 0x56C5C6BB, "tank_angry" },
    { 0x063CAAAB, "tank_anim" },
    { 0xB19FE3B9, "tank_at_edge" },
    { 0xFD6E5D8B, "tank_attack_allied_drones_and_ai" },
    { 0x7F93FD84, "tank_attack_death_tally" },
    { 0x2E5E2FCE, "tank_attack_if_attacked" },
    { 0x50D78557, "tank_attack_player_then_go_back_to_base" },
    { 0x6564233D, "tank_back" },
    { 0x8F53E88E, "tank_balcony_speed_control" },
    { 0x83779D6B, "tank_baseattack" },
    { 0x9F34B86A, "tank_battle" },
    { 0xB58EB872, "tank_battle_starts" },
    { 0x791C692A, "tank_blocker" },
    { 0xFE171BD7, "tank_blocker_moving" },
    { 0x9E0C1331, "tank_blow_house" },
    { 0x3B74E3E5, "tank_boxes_enabled" },
    { 0x1E4D457C, "tank_bunker_collision_off" },
    { 0x10BAC2C6, "tank_bunker_collision_on" },
    { 0xE6A07CD6, "tank_button_off" },
    { 0x533F65EA, "tank_call_box" },
    { 0xF39F954E, "tank_call_boxes_update" },
    { 0x2DFCA848, "tank_can_see_ent" },
    { 0x4637B909, "tank_chain_basin" },
    { 0x7DEED1A2, "tank_climb_muj" },
    { 0x05864415, "tank_collision_think" },
    { 0xB072F745, "tank_combat_think" },
    { 0x2EFAE724, "tank_compute_enemy_position" },
    { 0x770E9A03, "tank_connect_paths" },
    { 0x4DD55E77, "tank_cooldown" },
    { 0x08056205, "tank_cooldown_timer" },
    { 0x11478B01, "tank_count" },
    { 0x3DB5E1C9, "tank_crush" },
    { 0x1391C68A, "tank_crush_anims" },
    { 0x6360AACE, "tank_crush_destructible" },
    { 0xAF30521E, "tank_crush_entrance" },
    { 0x2264342F, "tank_crush_fx_on_tag" },
    { 0x3C39E40A, "tank_crush_plaza" },
    { 0x904BE02F, "tank_damage" },
    { 0x8E4093B3, "tank_damage_callback" },
    { 0x36C64453, "tank_damage_reaction" },
    { 0xBEF55A96, "tank_damage_think" },
    { 0x568626E3, "tank_death_notifier" },
    { 0xA6660BD7, "tank_death_think" },
    { 0x11381BE6, "tank_debug_health" },
    { 0xCD2A55AC, "tank_debug_hud_init" },
    { 0xA06E2866, "tank_debug_patrol" },
    { 0x0827A387, "tank_debug_tags" },
    { 0x99550D18, "tank_defend" },
    { 0x192D062C, "tank_defender_deathmonitor" },
    { 0x7C87E3DD, "tank_defender_deathnotify" },
    { 0xC49F4257, "tank_defender_spawn_setup" },
    { 0xB045236C, "tank_defenders" },
    { 0x45E3A6E6, "tank_defense_completed" },
    { 0x99DB986B, "tank_defense_enforcement" },
    { 0x97A7CFB3, "tank_defense_failure" },
    { 0x50A366D4, "tank_defense_flares" },
    { 0xD0EE9584, "tank_defense_killspawner_check" },
    { 0x5A20AF2E, "tank_defense_killspawner_monitor" },
    { 0x4A7C8D37, "tank_defense_stragglers" },
    { 0xEFE75B3A, "tank_defense_victory_check" },
    { 0xF7C7560D, "tank_defense_warning" },
    { 0x2884E9F0, "tank_dest" },
    { 0x95175115, "tank_destroyed" },
    { 0x732A9EC7, "tank_destroyed_by_mine" },
    { 0x17208420, "tank_destruction" },
    { 0x056AEF0F, "tank_devgui_think" },
    { 0x08ED8041, "tank_dir" },
    { 0xE70EA25F, "tank_disconnect_paths" },
    { 0xB5589FB0, "tank_discovery_vo" },
    { 0xF1E1F205, "tank_drop_powerups" },
    { 0xD6635801, "tank_engage" },
    { 0x4BFB7DCB, "tank_ent" },
    { 0xF512CA7E, "tank_explo_timescale_snapshots" },
    { 0xB185291B, "tank_explode" },
    { 0xF82A6B78, "tank_explode_anims" },
    { 0x4623F178, "tank_fail_watch" },
    { 0x501CF209, "tank_fill_model" },
    { 0x14E62D89, "tank_finish_path" },
    { 0x72C598B8, "tank_fire" },
    { 0xD605D1C7, "tank_fire_at_depot" },
    { 0xCDB2A74E, "tank_fire_at_ent" },
    { 0xF2537CFD, "tank_fire_at_origin" },
    { 0x0CD23900, "tank_fire_at_struct" },
    { 0x134ABD7B, "tank_fire_pos" },
    { 0x1D53860E, "tank_fire_position" },
    { 0x256513E8, "tank_fire_target" },
    { 0x77FCE348, "tank_fire_watch" },
    { 0xC487CD48, "tank_fire_weapon_loop" },
    { 0xF6509813, "tank_fires" },
    { 0x1A3D4E6E, "tank_flamethrower" },
    { 0xB19D01AD, "tank_flamethrower_attack_complete" },
    { 0x5B16DA3A, "tank_flamethrower_cycle_targets" },
    { 0x7F3B24E0, "tank_flamethrower_get_targets" },
    { 0x9B7647B2, "tank_force_crouch_from_prone_after_on_tank" },
    { 0x0D0B0F6B, "tank_forward" },
    { 0x32CB19F9, "tank_front" },
    { 0xE9771D11, "tank_fullscreen_effect" },
    { 0x955831F9, "tank_game_end_think" },
    { 0xD0D3CA51, "tank_get_and_fire_at_struct" },
    { 0x6FB42D68, "tank_get_jump_down_offset" },
    { 0x0C975281, "tank_get_player_enemies" },
    { 0x91802DF0, "tank_get_target" },
    { 0xDB72B1A3, "tank_go_through_wall" },
    { 0xF56DB889, "tank_grenade_stuck_explode" },
    { 0x568C7D06, "tank_grenade_stuck_think" },
    { 0xA7ECA8FB, "tank_ground_abort_think" },
    { 0xDDF3FAAC, "tank_guards_escape" },
    { 0x37431932, "tank_hacked_c4" },
    { 0xDE096B2F, "tank_hacked_health_update" },
    { 0x83A8D785, "tank_has_radar" },
    { 0x643C7F72, "tank_hint_counter" },
    { 0xFA34D49B, "tank_hit" },
    { 0x334BD057, "tank_hit_ground" },
    { 0x593D96BE, "tank_hit_incoming" },
    { 0xA003AD2A, "tank_idle" },
    { 0x5AFAE5BE, "tank_idle_fire_turret" },
    { 0xE92A9F22, "tank_intro_music" },
    { 0x33D8EECF, "tank_invincible" },
    { 0xB0A0260D, "tank_is_idle" },
    { 0x5F08028B, "tank_is_mad" },
    { 0xA4C84B21, "tank_jump_down_store_offset" },
    { 0x66ACF0FC, "tank_kill" },
    { 0xC288B6C6, "tank_kill_challenge" },
    { 0xDEA65078, "tank_kill_count" },
    { 0x13D947D7, "tank_kill_final_wave" },
    { 0x65714B87, "tank_kill_players" },
    { 0x02AA13DF, "tank_killed" },
    { 0x44DAC370, "tank_killed_by_shreck" },
    { 0x2084A630, "tank_kills_first_wave" },
    { 0x34AD78E2, "tank_kills_second_wave" },
    { 0x5225D7C9, "tank_kills_to_finish" },
    { 0x67C3177D, "tank_kills_to_progress" },
    { 0x99521359, "tank_knockdown_balcony" },
    { 0xDF7C40B6, "tank_left_behind" },
    { 0x51722EBC, "tank_left_behind_vo" },
    { 0x8BD9027E, "tank_logic" },
    { 0x061E16DA, "tank_loopfire" },
    { 0x4084487A, "tank_loopfire_forever" },
    { 0xE4A16458, "tank_low_health_fx" },
    { 0x0344940B, "tank_lower_avoidance_on_death" },
    { 0xE7C5F979, "tank_luv_u" },
    { 0x44963B18, "tank_luvs_u" },
    { 0xF020D7AD, "tank_mantle" },
    { 0xD2D5FB5F, "tank_mantle_begin" },
    { 0x74BD9826, "tank_mantle_death" },
    { 0x268F8FA4, "tank_mantle_stance_wrapper" },
    { 0xCC9D3558, "tank_mantle_think" },
    { 0x9A160EF1, "tank_mark_tag_occupied" },
    { 0xF1E44C8C, "tank_mg" },
    { 0x955C657E, "tank_mg_arrow" },
    { 0xD7F3FB6A, "tank_mg_bar" },
    { 0x4911AC2C, "tank_mg_hint" },
    { 0xD527FAA5, "tank_mine" },
    { 0x99D13040, "tank_missionfailure" },
    { 0xF36FE0E3, "tank_model" },
    { 0x34095B4D, "tank_mounting" },
    { 0x7E903A43, "tank_move" },
    { 0x63870943, "tank_move_manager" },
    { 0x228838C2, "tank_move_think" },
    { 0x64B8CA2E, "tank_move_with_player" },
    { 0xCA9F131B, "tank_movement" },
    { 0x53B9CAAD, "tank_name" },
    { 0x689A45AC, "tank_names" },
    { 0xA28777A0, "tank_node" },
    { 0x0C827F4B, "tank_nodes" },
    { 0xD70092A7, "tank_notify" },
    { 0x75E41912, "tank_objective_display" },
    { 0xF5ECC864, "tank_occupants_1" },
    { 0x67F4379F, "tank_occupants_2" },
    { 0xA0EF11ED, "tank_offset" },
    { 0xB5A54F3F, "tank_on_friendlies" },
    { 0xBD0B0017, "tank_open_door" },
    { 0x0BE75B8E, "tank_org" },
    { 0xE3BD24CA, "tank_origin" },
    { 0x4C57EC98, "tank_outofworld_watcher" },
    { 0xEA59AFF9, "tank_owner" },
    { 0xA91C9909, "tank_path" },
    { 0x803B3D66, "tank_path_2" },
    { 0x9C2C5EF0, "tank_path_4" },
    { 0x1D0AD9CA, "tank_path_anims" },
    { 0x66F93AFE, "tank_path_start_nodes" },
    { 0xC3541949, "tank_pause_pos" },
    { 0x8D5DB12E, "tank_pickup_model" },
    { 0x3C5CBF1C, "tank_pickup_update" },
    { 0xC4CF3C92, "tank_piece" },
    { 0xD40F8B54, "tank_ping" },
    { 0xB1797460, "tank_poi" },
    { 0xEA313507, "tank_precache" },
    { 0x839ECD19, "tank_ran_me_over" },
    { 0xB6541C64, "tank_re_eval_time" },
    { 0x7A67F0AA, "tank_reload_movement_tutorial" },
    { 0x884F09FA, "tank_reset_turret" },
    { 0x489D99CF, "tank_riders" },
    { 0x4181F954, "tank_riders_ignored" },
    { 0x941757A7, "tank_riders_name" },
    { 0x70820281, "tank_rides_around_map_achievement_watcher" },
    { 0xF1FD5F5A, "tank_right" },
    { 0xD3B7F5B0, "tank_riotshield_think" },
    { 0x40185CF8, "tank_rocket_1" },
    { 0xB21FCC33, "tank_rocket_2" },
    { 0x8C1D51CA, "tank_rocket_3" },
    { 0x108B462E, "tank_rocket_ammo_max" },
    { 0x92979CD4, "tank_rocket_hint" },
    { 0x64E4C5EA, "tank_rocket_hit" },
    { 0x76E65AF1, "tank_rocket_reload_secs" },
    { 0x7AB24105, "tank_rocket_think" },
    { 0xAA0D75CC, "tank_rocket_watch" },
    { 0xB10BDF31, "tank_rocket_watch_ai" },
    { 0x884664B8, "tank_rolling_death" },
    { 0x89CB4A9E, "tank_rolls_in" },
    { 0xD6DA77BA, "tank_room_stair_node" },
    { 0xCA9FC4E1, "tank_rumble_update" },
    { 0x3636AE3F, "tank_run_flamethrowers" },
    { 0xFD199534, "tank_set_target" },
    { 0x1B39CEA3, "tank_setup" },
    { 0x2BB03343, "tank_shoot_bridge" },
    { 0xFD36A29D, "tank_shoot_while_backing" },
    { 0xB7DD8C1C, "tank_shooting_exploder_dialog" },
    { 0x51AF996B, "tank_should_fire_rocket" },
    { 0xC6C88F58, "tank_shreck_ricochet" },
    { 0xEC1DEDFC, "tank_smoke_death" },
    { 0xA06293BF, "tank_spawn_msg" },
    { 0x5F33121A, "tank_spawn_trigger_name" },
    { 0x66D82DC4, "tank_specific" },
    { 0x7A0DD318, "tank_spot_1_available" },
    { 0xB7D1E1E0, "tank_spot_1_guy" },
    { 0xF5A431CB, "tank_spot_2_available" },
    { 0x7DCA6EC7, "tank_spot_2_guy" },
    { 0x0CC51D98, "tank_start" },
    { 0x08453DEC, "tank_start_spawners" },
    { 0xDE3D0A80, "tank_starting" },
    { 0x3FEE34DC, "tank_startnode" },
    { 0xD571251B, "tank_state" },
    { 0x3B3F9C38, "tank_station" },
    { 0x2E1A3004, "tank_stop" },
    { 0xC3590343, "tank_stop_attack" },
    { 0x3B51B9CF, "tank_stop_move_on_death" },
    { 0x27C90C21, "tank_stop_shootin_u" },
    { 0x413EE319, "tank_stops_msg" },
    { 0xB49A8D18, "tank_strafe_commencing" },
    { 0xCE74D36F, "tank_strafe_end" },
    { 0xAC347410, "tank_strafe_kill" },
    { 0x65750798, "tank_strafe_miniguns" },
    { 0xDFC55CDF, "tank_strafe_run" },
    { 0x20AB677C, "tank_stun" },
    { 0x86996557, "tank_stun_abort" },
    { 0xA6CABC38, "tank_suppressor_spawner_death" },
    { 0xAA344ED0, "tank_suppressor_spawner_strat" },
    { 0xD3AD5124, "tank_sweep" },
    { 0xF52E797A, "tank_switch_path" },
    { 0x6DEC0164, "tank_tag" },
    { 0x28852598, "tank_tag_array_setup" },
    { 0xC8B1DE2C, "tank_tag_is_valid" },
    { 0x072DAD04, "tank_targ" },
    { 0x0D8165F7, "tank_target" },
    { 0x208E1C3F, "tank_target_evaluate" },
    { 0xAA75268D, "tank_target_hero_jeep" },
    { 0x3F6EDAD4, "tank_target_lost" },
    { 0xC3B11170, "tank_target_structs" },
    { 0x00CB8C2E, "tank_targets" },
    { 0xCBE799E7, "tank_targetting" },
    { 0xE2288BB7, "tank_targs" },
    { 0x0358C796, "tank_team_kill" },
    { 0x6D961ACC, "tank_think" },
    { 0x2D730FE1, "tank_timeout_callback" },
    { 0x1CADE769, "tank_timer_wait" },
    { 0x23C0C1C9, "tank_too_far_from_nav_mesh_abort_think" },
    { 0xB6403DB8, "tank_trigger" },
    { 0x7DBB8738, "tank_turret_forward" },
    { 0x9F3DA516, "tank_turret_manager" },
    { 0x5EF525EA, "tank_turret_pick_target" },
    { 0xE876CA94, "tank_turret_slewing" },
    { 0xF9D99CB7, "tank_turret_target_think" },
    { 0x88AC4864, "tank_type" },
    { 0xA2A078CB, "tank_up" },
    { 0x11BD9404, "tank_valid_location" },
    { 0x2CAEFEC8, "tank_volume_death_check" },
    { 0x2C93D61F, "tank_wander" },
    { 0x772BFE07, "tank_was_overrun" },
    { 0x4CFCF823, "tank_watch_owner_events" },
    { 0x1FEB7791, "tank_watch_owner_events_singleton" },
    { 0xCD9D6BA0, "tank_watch_turn_crawler" },
    { 0xBCAA0E31, "tank_watch_use" },
    { 0xECE26E0F, "tank_wave_1" },
    { 0x98169BF7, "tank_wave_1_strats" },
    { 0x7ADAFED4, "tank_wave_2" },
    { 0xA0DD793D, "tank_wave_3" },
    { 0x35098F9F, "tank_zombie_think" },
    { 0x6B09362E, "tankanim" },
    { 0xFEA60C53, "tankatkdead" },
    { 0x86D0C34F, "tankconfirm" },
    { 0x8F2EFC16, "tankconfirms" },
    { 0x0BA68E20, "tankcraftableupdateprompt" },
    { 0x1853FDEF, "tankcrush_scene" },
    { 0x8405135F, "tankcrusher" },
    { 0x3F9B0161, "tankdefenderpop" },
    { 0x7E91F25F, "tankdefensefailsafetime" },
    { 0xAE3CE66C, "tanken" },
    { 0xD1A60656, "tankencroachinitradius" },
    { 0x28C198DB, "tankencroachpausetime" },
    { 0x95FF59BC, "tankencroachrate" },
    { 0xF9B46E0F, "tankencroachsteps" },
    { 0x4646D010, "tanker" },
    { 0x0271243B, "tanker_drone" },
    { 0x6360416E, "tanker_exploder_stage_uno" },
    { 0x1626B9EE, "tanker_gas_station_think" },
    { 0x1C307ACD, "tanker_hole_offset" },
    { 0xDFC01817, "tanker_tree" },
    { 0xE2639262, "tanker_tree_start" },
    { 0x7BFCD15B, "tankexplosion_fx" },
    { 0xA78C3D60, "tankfight_snapshot" },
    { 0x00BF27F5, "tankgetout" },
    { 0x00D63833, "tankgroup1" },
    { 0x1C15E4DF, "tankhealth" },
    { 0x96F2365A, "tankid" },
    { 0xFC9B8BFF, "tankmantle_grenade" },
    { 0x3C07F3B7, "tankmantle_tossbacks_remaining" },
    { 0x59FEAC61, "tankmantling" },
    { 0x79EB7490, "tankmodel" },
    { 0xEB266868, "tankname" },
    { 0x35302E96, "tanknumber" },
    { 0xEECE45F3, "tankorgadjusted" },
    { 0xB155E6A2, "tankpop" },
    { 0xCDF40A8A, "tankreaching" },
    { 0x780EAA77, "tankrequests" },
    { 0x96E95FF3, "tankride" },
    { 0xDCBFA253, "tankride_achievement" },
    { 0x77C468D4, "tankride_achievement_drone_deathwatch" },
    { 0xA526ED29, "tankride_deathwatch" },
    { 0xD65A0704, "tankride_drone_spawnfunction" },
    { 0x8C176651, "tankride_spawners" },
    { 0x8F28C2A3, "tankride_vo" },
    { 0x5953566C, "tankriders_setup" },
    { 0xD239EFB6, "tankrumble" },
    { 0x83AE35C0, "tanks" },
    { 0xABF95FF5, "tanks_at_destination" },
    { 0xF5399D8D, "tanks_ctt2_over" },
    { 0x32F427A2, "tanks_deploy" },
    { 0x291C7D32, "tanks_engage" },
    { 0x43DB7885, "tanks_enter_camp" },
    { 0xC3CD6040, "tanks_fire_at_office" },
    { 0x231E9011, "tanks_init" },
    { 0xC6A26FB8, "tanks_left" },
    { 0x8583FE38, "tanks_luv_you" },
    { 0x94A8ED40, "tanks_spawn" },
    { 0x5ACA49D3, "tanks_spawned" },
    { 0xAF5F40D8, "tanks_special" },
    { 0xBFBE8CF9, "tanks_target_something" },
    { 0xDD24C327, "tanks_torn_apart_vo" },
    { 0x9CACE329, "tankshot" },
    { 0xDB294F2A, "tankspeed" },
    { 0xB8FEC1FE, "tanksquadfollow" },
    { 0x1EC2569E, "tanksquish" },
    { 0x72CEE094, "tankstop_spot_b4_aagun" },
    { 0xEC399E62, "tanktarget" },
    { 0x67E51D27, "tanktrigger" },
    { 0x8412F495, "tankuseanimtree" },
    { 0xE32E4127, "tao" },
    { 0x0930BB90, "tap" },
    { 0x011EC52E, "tap_ads_button" },
    { 0x43BEE0AA, "tap_attack_button" },
    { 0xA3B056E7, "tap_doublejump_button" },
    { 0x3C059D02, "tap_frag_button" },
    { 0x793AC1AA, "tap_jump_button" },
    { 0x6E37F7F0, "tap_melee_button" },
    { 0x4A40BE14, "tap_offhand_button" },
    { 0xF2781980, "tap_offhand_special_button" },
    { 0x14CF6D8F, "tap_reload_button" },
    { 0xEC17D837, "tap_use_button" },
    { 0x168B7E43, "tape_knockover_spetz" },
    { 0xC81C6C3B, "tape_knockover_trig" },
    { 0x40AADC85, "taper" },
    { 0x1AA8621C, "tapes" },
    { 0xB9C781E7, "tappinganim" },
    { 0x5535B062, "tar" },
    { 0x0728F919, "targ" },
    { 0xD8560162, "targ1" },
    { 0x0275F10D, "targ_1" },
    { 0x0658AFEE, "targ_1a" },
    { 0x28786B76, "targ_2" },
    { 0x10A5BDCB, "targ_2a" },
    { 0x4E7AE5DF, "targ_3" },
    { 0x28BF5D9B, "targ_ent" },
    { 0xAC274DDC, "targ_filled" },
    { 0xD5C17613, "targ_model" },
    { 0xF2411EF0, "targ_node" },
    { 0x835688DE, "targ_org" },
    { 0x720284DE, "targ_point" },
    { 0xBB9D49DF, "targ_struct" },
    { 0x11663E74, "targ_to_lay" },
    { 0xAD06CAD2, "targ_to_spin" },
    { 0x2908A1A0, "targent" },
    { 0xEA88FA62, "targerid_postsun" },
    { 0x181885F2, "targerid_scene" },
    { 0xCE6FDC1D, "targerid_small0" },
    { 0xA86D61B4, "targerid_small1" },
    { 0x56B783E8, "targerid_smallblur" },
    { 0xB07228B6, "target" },
    { 0x7F419D3B, "target1" },
    { 0x6ED39031, "target10" },
    { 0x48D115C8, "target11" },
    { 0xBAD88503, "target12" },
    { 0x94D60A9A, "target13" },
    { 0x06DD79D5, "target14" },
    { 0xE0DAFF6C, "target15" },
    { 0x52E26EA7, "target16" },
    { 0x2CDFF43E, "target17" },
    { 0x3EBFBCE9, "target18" },
    { 0x18BD4280, "target19" },
    { 0x0D3A2E00, "target2" },
    { 0xF30D5DB0, "target20" },
    { 0x333CA869, "target3" },
    { 0xF1490C76, "target4" },
    { 0x174B86DF, "target5" },
    { 0xA54417A4, "target6" },
    { 0xCB46920D, "target7" },
    { 0x8952F61A, "target8" },
    { 0xAF557083, "target9" },
    { 0xAE855062, "target_1_destroyed" },
    { 0xAEF372AD, "target_2" },
    { 0xE266FC71, "target_2_destroyed" },
    { 0xE8C9124B, "target_alpha" },
    { 0x544BBB55, "target_angles" },
    { 0xCC32D577, "target_aquire_ai" },
    { 0x079E0535, "target_aquire_tank" },
    { 0x0EF78A0A, "target_aquired" },
    { 0x66172FFC, "target_array" },
    { 0x943773D0, "target_array_destroyed" },
    { 0x93ADFAFC, "target_attacker" },
    { 0x8FB9B37D, "target_b" },
    { 0x89171C9A, "target_behind_me_angle" },
    { 0x62AF4706, "target_blur" },
    { 0x54F08AD1, "target_board_range" },
    { 0xE8EFBF47, "target_board_range_distance_control" },
    { 0x4AD820C3, "target_board_range_distance_hud" },
    { 0x34BB2427, "target_board_range_hud" },
    { 0xA18AE60C, "target_board_spawner_setup" },
    { 0xCA61E0BB, "target_board_swap" },
    { 0xF1C8B64B, "target_boundingisunderreticle" },
    { 0xF43C3DFC, "target_bread_crumbs" },
    { 0x037137EB, "target_bread_crumbs_render" },
    { 0x537CB7E9, "target_breadcrumb_current_index" },
    { 0x82AB7ED6, "target_breadcrumb_last_added" },
    { 0x9CF529C1, "target_breadcrumbs" },
    { 0x69F8A1D7, "target_by_zombie" },
    { 0xDEBB8BDE, "target_chopper" },
    { 0xD5C7164A, "target_clamp" },
    { 0xFCE31B9E, "target_clearreticlelockon" },
    { 0xB27B0C8D, "target_cone_check" },
    { 0xD4081209, "target_cpoints" },
    { 0xC7A85D2A, "target_crate" },
    { 0x571BB7ED, "target_death_watch" },
    { 0xA3A1EACD, "target_delta" },
    { 0x17419142, "target_destroyed" },
    { 0xEE2CC373, "target_died" },
    { 0x94388922, "target_dir" },
    { 0x6E677125, "target_dist" },
    { 0x1EB5DE79, "target_down" },
    { 0xE894BA2D, "target_down_1" },
    { 0x0E973496, "target_down_2" },
    { 0x3499AEFF, "target_down_3" },
    { 0x5121DA9D, "target_dude" },
    { 0xBA284AAB, "target_enemies" },
    { 0x9655E09C, "target_ent" },
    { 0xE7D3F235, "target_ent_cleanup" },
    { 0x065BE9D0, "target_entity" },
    { 0xCDF62ADC, "target_escaped" },
    { 0x1076293D, "target_fire_distance" },
    { 0xEB08E50C, "target_forward" },
    { 0x99CB0FE2, "target_fov" },
    { 0xE7CF1ABE, "target_getarray" },
    { 0x538115BA, "target_getoffset" },
    { 0x386B7AFA, "target_group" },
    { 0x414EC198, "target_height" },
    { 0xEF34CC6F, "target_hijackers" },
    { 0xC4978CF8, "target_hit" },
    { 0xCC2C77EE, "target_id" },
    { 0x8E1533AC, "target_in_view" },
    { 0xEB884467, "target_index" },
    { 0x4707ED01, "target_initialized" },
    { 0x4EEC83EA, "target_initilized" },
    { 0xF230EF9A, "target_is_valid" },
    { 0x7A924494, "target_isincircle" },
    { 0x4B2E4242, "target_isinrect" },
    { 0xDE3DC90A, "target_istarget" },
    { 0xD4634BD1, "target_jeep" },
    { 0x97B19C90, "target_kill_using_accuracy" },
    { 0xB75B8FC4, "target_lase_next" },
    { 0xE57EA743, "target_lase_override" },
    { 0x6ECEEC3E, "target_lase_points" },
    { 0xCC2A65B3, "target_lase_points_ally_track" },
    { 0x5EE81302, "target_lase_transition" },
    { 0x7A6342BA, "target_left" },
    { 0x448352CD, "target_list" },
    { 0xF0E9DBC5, "target_list_front" },
    { 0xAA067873, "target_list_left" },
    { 0x3629D3BA, "target_list_rear" },
    { 0x6AEE9C66, "target_list_right" },
    { 0xAE95F178, "target_list_x" },
    { 0x06C86967, "target_lost" },
    { 0xFF1F8F0B, "target_marine" },
    { 0xC7BD8663, "target_me" },
    { 0xFB87F63C, "target_model" },
    { 0xCAECF48A, "target_move" },
    { 0x1DF9023C, "target_name" },
    { 0xF128A56D, "target_name1" },
    { 0x172B1FD6, "target_name2" },
    { 0x3D2D9A3F, "target_name3" },
    { 0x331C4160, "target_name4" },
    { 0xBC8EFFFF, "target_names" },
    { 0xC0A4C975, "target_node" },
    { 0xF28E4F56, "target_node1" },
    { 0xCC8BD4ED, "target_node2" },
    { 0xEBB25E76, "target_node_pos" },
    { 0x25EAC044, "target_nodes" },
    { 0xAC7AAAC4, "target_num_players" },
    { 0x83B39CF4, "target_obj" },
    { 0x97EF5A84, "target_offset" },
    { 0x2EEE0131, "target_org" },
    { 0x49992ACB, "target_origin" },
    { 0x48A78719, "target_origin_array" },
    { 0x851B29AC, "target_origin_at_start" },
    { 0x3895F026, "target_originisincircle" },
    { 0xE2F7CE3D, "target_outline_green" },
    { 0xCE3B9D5E, "target_outline_locked" },
    { 0x574ACD17, "target_outline_locking" },
    { 0x3630524B, "target_outline_off" },
    { 0x8E077A1A, "target_outline_orange" },
    { 0xD8156729, "target_outline_red" },
    { 0x732C29F8, "target_outline_suspend" },
    { 0x2E309C41, "target_outline_thermal" },
    { 0x3F44FD62, "target_player" },
    { 0xC93CBAA1, "target_playerboat_only" },
    { 0xDDC9FE3D, "target_point" },
    { 0x2795427A, "target_point_z" },
    { 0x55829ED5, "target_pos" },
    { 0x77951E6C, "target_pos_down" },
    { 0x11CE58A4, "target_pos_offset_x" },
    { 0x37D0D30D, "target_pos_offset_y" },
    { 0x9E03D2BD, "target_pos_onnavmesh" },
    { 0x6188768C, "target_position" },
    { 0x27B2670F, "target_positions" },
    { 0x7300183F, "target_radius" },
    { 0x98C0B3C7, "target_rate" },
    { 0x8C2C7E7F, "target_reaquire_time" },
    { 0x1C5DED41, "target_remove" },
    { 0x7322E8BE, "target_reticule" },
    { 0x44DA2389, "target_right" },
    { 0xD0B7ADDF, "target_round" },
    { 0x23B77472, "target_rumble" },
    { 0x803E4E54, "target_rumble2" },
    { 0xA640C8BD, "target_rumble3" },
    { 0x44F45099, "target_scaleminmaxradius" },
    { 0xB18EE436, "target_scenes" },
    { 0x7A078777, "target_set" },
    { 0x3083BB83, "target_setallowhighsteering" },
    { 0x2D67C466, "target_setattackmode" },
    { 0x0170CBB2, "target_setjavelinonly" },
    { 0xD8545805, "target_setoffscreenshader" },
    { 0xFD724520, "target_setshader" },
    { 0x38A2C2C2, "target_setturretaquire" },
    { 0xEE948FD3, "target_slow_attack_range" },
    { 0xD2ED6CE5, "target_sounds" },
    { 0xEF609306, "target_speed" },
    { 0x26554005, "target_speed_scale" },
    { 0xC49983DD, "target_spot" },
    { 0xD376A4F3, "target_startreticlelockon" },
    { 0x1175D22C, "target_stop_sounds" },
    { 0x5A47BF22, "target_struct" },
    { 0xCA1023B0, "target_struct_name" },
    { 0xFBB5A8ED, "target_structs" },
    { 0x6301FA34, "target_success_vo" },
    { 0xC39F344B, "target_sunlight" },
    { 0x73354A67, "target_tag" },
    { 0x46372F33, "target_targetname" },
    { 0xF73B7CF2, "target_time" },
    { 0x966B3CCC, "target_timescale" },
    { 0x62ECE671, "target_to_remove" },
    { 0xE4761A9B, "target_trigger" },
    { 0x467768BA, "target_triggers" },
    { 0x80DC8FDD, "target_type" },
    { 0xC538CF26, "target_unit_highlight" },
    { 0x4B60B564, "target_value" },
    { 0x68ECC8C7, "target_value_col" },
    { 0x977E4005, "target_variable_offset" },
    { 0x229769D0, "target_vc" },
    { 0x56D36469, "target_vec" },
    { 0x5C3BEE6C, "target_vector" },
    { 0xB0E466C2, "target_vehicle_type" },
    { 0x44F39BBE, "target_vel" },
    { 0x4473A0B0, "target_velocity" },
    { 0xF1970748, "target_visuals" },
    { 0x58B9851A, "target_vtol_with_gun" },
    { 0x89B88FBE, "target_wait_for_real_death" },
    { 0x049BC5BD, "target_wait_for_special_fake_death" },
    { 0x49C0632E, "target_wait_time" },
    { 0x3CF169D5, "target_weapon" },
    { 0x79F6A0EA, "target_within_range" },
    { 0xF1083856, "target_yaw" },
    { 0x5FA5E035, "target_z" },
    { 0x0E4B2467, "target_zombie" },
    { 0xECD5D4DE, "target_zombies" },
    { 0x140A11A8, "targetability" },
    { 0x7B4A10F2, "targetable" },
    { 0x0D893C86, "targetacquired" },
    { 0xA19B8AC0, "targetai" },
    { 0xCD8C9D1A, "targetanglediff" },
    { 0x15EEC7E2, "targetangles" },
    { 0x8D6B0169, "targetarray" },
    { 0xBADF1BA6, "targetbetty" },
    { 0x8626B25F, "targetcolor" },
    { 0xB4361A3B, "targetcount" },
    { 0x3F31C1F3, "targetdamagealpha" },
    { 0xBA5EE72C, "targetdelta" },
    { 0x3CCD205B, "targetdir" },
    { 0xDC0EE042, "targetdist" },
    { 0x50F99F9B, "targetdistance" },
    { 0xA9B83E1E, "targetdistancesquared" },
    { 0xE2131CCC, "targetdistscore" },
    { 0xDB2EDCDE, "targetdistsq" },
    { 0x0E126350, "targetdroplocation" },
    { 0x753F4E26, "targetdummies" },
    { 0x04BE3B76, "targetdummy" },
    { 0x92E0332A, "targetdummythink" },
    { 0x5A058779, "targeted" },
    { 0x158FF9B3, "targeted_by" },
    { 0xA54404AA, "targeted_mortars" },
    { 0x0F1A4B2B, "targeted_player" },
    { 0x26EF8B20, "targetednodes" },
    { 0xDDD6BBFD, "targetent" },
    { 0xDA0D45B5, "targetent_offsetvec" },
    { 0x3D3984C4, "targetentarray" },
    { 0x22E69AC3, "targetentity" },
    { 0x63B3B085, "targetentityindex" },
    { 0x1108CF57, "targetentnum" },
    { 0xE47973BC, "targetents" },
    { 0xDDECBF5F, "targeter" },
    { 0x81C94AE6, "targeters" },
    { 0x50EA728E, "targetfaceangle" },
    { 0xD9ED1275, "targetfacingangle" },
    { 0x48DA8D5D, "targetforward" },
    { 0xAD90B2C3, "targetfxent" },
    { 0xC98857C6, "targetgetdist" },
    { 0xE9796FD3, "targetheight" },
    { 0x4A5582D4, "targethinge1" },
    { 0x4C9A35DB, "targethub" },
    { 0xF92983AD, "targeticon" },
    { 0x0652C22D, "targetid" },
    { 0x802C13D6, "targetid_none" },
    { 0x1442A332, "targetindex" },
    { 0xAAF9FB43, "targetinfrontofplane" },
    { 0xE355572A, "targeting" },
    { 0xFDECD1C8, "targeting_array" },
    { 0xD6B6BF26, "targeting_count" },
    { 0x6EF12A16, "targeting_delay" },
    { 0x79D47EC1, "targeting_hud_think" },
    { 0x28544253, "targeting_reticle" },
    { 0xDD193132, "targeting_spirit" },
    { 0xC4A36EB1, "targeting_thread" },
    { 0xBCFBF0CB, "targetinghacking" },
    { 0xAA0319D2, "targetinsertionsortcompare" },
    { 0xF5558B36, "targetisclose" },
    { 0x2A61F16C, "targetisinfront" },
    { 0x3EBDF23A, "targetlastknownlocation" },
    { 0xF60AC9B1, "targetlight1_off" },
    { 0xF90B9605, "targetlight1_on" },
    { 0xBA3718AA, "targetlight2_off" },
    { 0x2D95847C, "targetlight2_on" },
    { 0xAFD2F52A, "targetlist" },
    { 0xF0E9C1CC, "targetloc" },
    { 0x1105C223, "targetlocation" },
    { 0xF45ECDFD, "targetlookanimyawmax" },
    { 0x6494C480, "targetlookinitilized" },
    { 0xC28505C0, "targetlost" },
    { 0xAF6F4D9B, "targetmode" },
    { 0x314A27A0, "targetmovespeedscale" },
    { 0x170527FB, "targetname" },
    { 0xF6001C1B, "targetname_count" },
    { 0xE15CE1A7, "targetname_starter" },
    { 0x8F39F265, "targetnamed" },
    { 0x28AF51BA, "targetnameobj" },
    { 0xBD0ADC9A, "targetnames" },
    { 0x58BCFB4A, "targetnode" },
    { 0x75557485, "targetnodes" },
    { 0x2BE72B4E, "targetnum" },
    { 0x52230F3D, "targetobj" },
    { 0xF39BECAF, "targetoffset" },
    { 0xAC01E01E, "targetorderwatcher" },
    { 0xB3D2E7A8, "targetorg" },
    { 0x4EA45B3C, "targetorigin" },
    { 0x8A594B62, "targetpickup" },
    { 0x514224B1, "targetplayer" },
    { 0x4C646766, "targetplayertime" },
    { 0xBE9AFD92, "targetpoi" },
    { 0x11A7E9CC, "targetpoint" },
    { 0x451CB10A, "targetpointonpath" },
    { 0xAA72094F, "targetpoints" },
    { 0x02D18298, "targetpos" },
    { 0x110D9B7A, "targetposcopterheight" },
    { 0x8DD8C840, "targetr" },
    { 0xB3DB42A9, "targets" },
    { 0x671C9F97, "targets_and_uses_turret" },
    { 0x6AE2093B, "targets_hit" },
    { 0x22FC45B6, "targets_hit_counter" },
    { 0xE7F498CD, "targets_name" },
    { 0xAE37F61B, "targets_needed" },
    { 0x7C053DD5, "targets_platform" },
    { 0xC9F9243B, "targets_player" },
    { 0xD1756CEB, "targets_up" },
    { 0x90BC9E69, "targets_updated" },
    { 0x4D9D5812, "targetsall" },
    { 0xED36E355, "targetscan" },
    { 0xC253A087, "targetscanning" },
    { 0xC2417581, "targetshottime" },
    { 0x3F564FE2, "targetslot" },
    { 0x3DE57A6F, "targetsmissile" },
    { 0xE6DC13BF, "targetspeed" },
    { 0xDC1444A6, "targetspot" },
    { 0x78CAE1BC, "targetsquad" },
    { 0x37335750, "targetstopmoving" },
    { 0xF0F4DE51, "targetstring" },
    { 0x6695BA35, "targetstruct" },
    { 0xE6AD6936, "targetsused" },
    { 0x5330ACFD, "targetsvalid" },
    { 0x76563879, "targettaco" },
    { 0x2AE10761, "targettacodroptime" },
    { 0x08FAEA7E, "targettag" },
    { 0x88B0F044, "targettagorigin" },
    { 0x1AD50361, "targettags" },
    { 0x11E51D79, "targetteam" },
    { 0xBFA30DCB, "targetteamenemy" },
    { 0x19BB89EA, "targetteammate" },
    { 0xAD423579, "targetted" },
    { 0x4020E52B, "targetted_player" },
    { 0x44BF7B0A, "targetted_vec" },
    { 0xC52EB911, "targettimescale" },
    { 0xEBDB412A, "targetting" },
    { 0x5B63B34D, "targetting_drone" },
    { 0x8B8ACF14, "targettingai" },
    { 0x05414B74, "targettingradius" },
    { 0x942F529D, "targettingspeaker" },
    { 0xE64A9BE7, "targettoclose" },
    { 0x0F9B3A83, "targettostartpos" },
    { 0xE2B405C6, "targettype" },
    { 0x7CEB5EF3, "targetval" },
    { 0x0DED5581, "targetvalue" },
    { 0x76020468, "targetvec" },
    { 0x8FDE1056, "targetwatcher" },
    { 0xB64F10CF, "targetwetness" },
    { 0x0DE35EF7, "targetwithinrangeofplayspace" },
    { 0x40F645FF, "targetyaw" },
    { 0x7ABBEE1A, "targit" },
    { 0x0CEFA6D0, "targs" },
    { 0xF68C7EE8, "targs_left" },
    { 0x1700FFAF, "targt" },
    { 0x6031A416, "targtted" },
    { 0x1DFBF31B, "tarmac" },
    { 0x3CE28ADB, "tarmac_colornodes_think" },
    { 0x24DB0EE2, "tarmac_friendly_engagement_think" },
    { 0xDEDD7F34, "tarmac_nag_lines" },
    { 0xAD46E8C6, "tarmac_objectives" },
    { 0x54ACA8F3, "tarmac_room" },
    { 0x036D7924, "tarmac_worker_scenes" },
    { 0x650DB696, "tarp" },
    { 0x30C08F1B, "tarp1" },
    { 0x1A6CE79C, "tarp_array" },
    { 0x33641522, "tarp_clip_think" },
    { 0x1F42EEB3, "tarp_cover01" },
    { 0xF6DCFD6F, "tarp_crate_stack" },
    { 0x0BE16BAA, "tarp_crate_stack_start" },
    { 0x57FB90AB, "tarp_stack" },
    { 0x80FF6ED2, "tarp_woodstack" },
    { 0x3696DF8B, "tarpcrate" },
    { 0xF7171269, "tarpcrateexpsound" },
    { 0xC0FB55EA, "tarpcrates" },
    { 0xB35E7459, "tarped" },
    { 0x641D0009, "tarps" },
    { 0x465ED806, "tartget" },
    { 0x5773DD06, "taser" },
    { 0xCDFB5627, "taser_knuckles" },
    { 0xB50786D6, "taser_knuckles_pickup" },
    { 0xE392AA3C, "taser_mine_zap_count" },
    { 0xF13901D3, "taser_mine_zap_cycle_count" },
    { 0xBE22A1AA, "taser_mine_zap_period_seconds" },
    { 0x74992D0F, "taser_trig_adjustment" },
    { 0x9D1EADEB, "taser_trigger" },
    { 0x5E62528B, "taserhudfx" },
    { 0x796C1D52, "task" },
    { 0x3557D91B, "task_num" },
    { 0x31336C65, "tasked" },
    { 0xE1D2B35E, "tasking" },
    { 0x71A6A15D, "tasks" },
    { 0x1BC9FA12, "taste" },
    { 0x47A0194B, "tatical" },
    { 0x450821A4, "taught" },
    { 0x8473C79F, "taunt" },
    { 0x1A1BB32E, "taunt_alias" },
    { 0x16768195, "taunt_anim" },
    { 0x7CB1F6E7, "taunt_arr" },
    { 0x47997B68, "taunt_first_place" },
    { 0x7FFCEB49, "taunt_id" },
    { 0x53DEB81A, "taunt_notetracks" },
    { 0x5A0EFBB1, "taunt_type_first_place" },
    { 0x77A21079, "taunt_wait" },
    { 0x7B22ABA9, "tauntanimname" },
    { 0x3F463F4C, "tauntevents" },
    { 0x0447FD19, "tauntfinished" },
    { 0x1A98B7B1, "tauntindex" },
    { 0xE87ACDA1, "taunting" },
    { 0x7941BF2E, "tauntmodel" },
    { 0xE71E1326, "taunts" },
    { 0x1BD6A53A, "tauntstarted" },
    { 0x5F42D8C2, "tauntstate" },
    { 0x4B446873, "taut" },
    { 0x1A7C66F3, "tavern" },
    { 0x6A5CCC58, "tavern_stop_shouting" },
    { 0x0FB5EB23, "tavern_storming_delay" },
    { 0xC94DE1A8, "tavern_storming_hints" },
    { 0x8E697F64, "tawiki" },
    { 0x39448ED8, "tax" },
    { 0x348C3809, "taxi" },
    { 0x8C984A07, "taxi_start_node" },
    { 0xC9C4EE03, "taze" },
    { 0x7BBD4B3D, "tazed" },
    { 0xCF90AFDB, "tazer" },
    { 0x2A7E8389, "tazer_cost" },
    { 0x71001FA6, "tazer_flourish_delay" },
    { 0xEC7AE52F, "tazer_flourish_fx" },
    { 0x8F8691D2, "tazer_kill" },
    { 0xB66A6BB3, "tazerknuckle_melee" },
    { 0x601BBD5B, "tb" },
    { 0xAAB4D57E, "tb_defined_huds" },
    { 0x3BB7B9C0, "tb_group_huds" },
    { 0x6F7DC1A6, "tb_groups" },
    { 0x7FA2E745, "tbd" },
    { 0x445B96B5, "tbl_armor" },
    { 0xA1E6212B, "tbl_camoskin" },
    { 0xF22C2956, "tbl_killstreakdata" },
    { 0x9C025AD4, "tbl_perkdata" },
    { 0x21A4A703, "tbl_weaponattachment" },
    { 0x328710EA, "tbl_weaponids" },
    { 0xAD73D17A, "tbs" },
    { 0x917556D5, "tbui_linkertest_1" },
    { 0xB040BD9F, "tbui_linkertest_10" },
    { 0x3C480C82, "tbui_linkertest_10_amb" },
    { 0xC5CFE395, "tbui_linkertest_10_anim" },
    { 0xEFC02060, "tbui_linkertest_10_fx" },
    { 0x554BAB60, "tbui_linkertest_1_amb" },
    { 0x1DCF79B7, "tbui_linkertest_1_anim" },
    { 0x97C6B412, "tbui_linkertest_1_fx" },
    { 0xB777D13E, "tbui_linkertest_2" },
    { 0x00018502, "tbui_linkertest_28" },
    { 0x0958E1E3, "tbui_linkertest_28_amb" },
    { 0xF09F05C6, "tbui_linkertest_28_anim" },
    { 0xB5A2CAC7, "tbui_linkertest_28_fx" },
    { 0x2603FF6B, "tbui_linkertest_29" },
    { 0x54F6714E, "tbui_linkertest_29_amb" },
    { 0xAA1157E1, "tbui_linkertest_29_anim" },
    { 0x25BA9F94, "tbui_linkertest_29_fx" },
    { 0x9924923F, "tbui_linkertest_2_amb" },
    { 0x8BC69EA2, "tbui_linkertest_2_anim" },
    { 0x20D63EAB, "tbui_linkertest_2_fx" },
    { 0x006F3047, "tbui_linkertest_47" },
    { 0x49053BCA, "tbui_linkertest_47_amb" },
    { 0xA8A7AB8D, "tbui_linkertest_47_anim" },
    { 0x5F0A2E18, "tbui_linkertest_47_fx" },
    { 0x74F53D93, "tbui_linkertest_50" },
    { 0x656DBAD6, "tbui_linkertest_50_amb" },
    { 0x22DF5FB9, "tbui_linkertest_50_anim" },
    { 0xC22FFACC, "tbui_linkertest_50_fx" },
    { 0x02EDCE58, "tbui_linkertest_53" },
    { 0xFBDEEA49, "tbui_linkertest_53_amb" },
    { 0x9DF2A580, "tbui_linkertest_53_anim" },
    { 0xCCF70CB9, "tbui_linkertest_53_fx" },
    { 0x1F6DE79A, "tbui_linkertest_6" },
    { 0x4C56B87B, "tbui_linkertest_6_amb" },
    { 0xF092E32E, "tbui_linkertest_6_anim" },
    { 0x2EF47D8F, "tbui_linkertest_6_fx" },
    { 0xA362789B, "tbz" },
    { 0x36B8DA9A, "tc6_mine_detonation" },
    { 0xAC20B22D, "td" },
    { 0xBF41DE08, "tdef" },
    { 0xADB674F2, "tdef_flagtime" },
    { 0xE15444D0, "tdef_loadouts" },
    { 0xF6A792A2, "tdm" },
    { 0xC6322B36, "tdm_rules" },
    { 0x4032D621, "tdm_wins_index" },
    { 0x861E37C4, "te" },
    { 0x0C23C690, "te_dot_to" },
    { 0x0601DEBD, "te_magnitude_squared" },
    { 0x04024CF4, "teach" },
    { 0x27BE8F2F, "teach_ads" },
    { 0x5A4EEC8D, "teach_crouch" },
    { 0xDFB7D1A6, "teach_mantle" },
    { 0x2563A35D, "teach_melee" },
    { 0x8397DBD5, "teach_nade" },
    { 0x60996D6B, "teach_prone" },
    { 0xC26E1ECB, "teach_sprint" },
    { 0x35172378, "teach_sprint_crouch" },
    { 0x64969AD3, "teal" },
    { 0x3E94206A, "team" },
    { 0x8D07604E, "team0" },
    { 0x56282183, "team01" },
    { 0x07F800E3, "team01_sawguysfinished" },
    { 0x96E6A06D, "team01_sawguysinposition" },
    { 0x8B2997DF, "team01_ventopen" },
    { 0x00C8D471, "team01breacher" },
    { 0xE420B248, "team02" },
    { 0x529E68EF, "team02_rappel" },
    { 0x3BA7F284, "team02_sawguysfinished" },
    { 0x3E608F9E, "team02_sawguysinposition" },
    { 0x466CEEDA, "team02_ventopen" },
    { 0xF2A88692, "team02breacher" },
    { 0x0A232CB1, "team03" },
    { 0x60B55A38, "team03_rappel" },
    { 0xE1DA2C91, "team03_sawguysfinished" },
    { 0x65B81BC3, "team03_sawguysinposition" },
    { 0x101B9595, "team03_ventopen" },
    { 0x4DF8ECE7, "team03breacher" },
    { 0xB309DAB7, "team1" },
    { 0x1AAB65A4, "team1_run_trigger" },
    { 0x5A1FDB92, "team1_spawner" },
    { 0xA298C88E, "team1_think" },
    { 0x0B7EB4D4, "team1_walk_trigger" },
    { 0x41026B7C, "team2" },
    { 0x6704E5E5, "team3" },
    { 0x1AFFF113, "team5" },
    { 0xCEFAFC41, "team7" },
    { 0xE4665FE5, "team_1_zombie_release_grief_soul" },
    { 0x780E7415, "team_1_zombie_release_soul" },
    { 0x1160C6E2, "team_2_zombie_release_grief_soul" },
    { 0x6081D812, "team_2_zombie_release_soul" },
    { 0x5AD3A882, "team_a_downed" },
    { 0xEBA7DD23, "team_allies" },
    { 0x50637CA7, "team_america" },
    { 0xA62DAE2A, "team_axis" },
    { 0xA98F9C63, "team_b_downed" },
    { 0xE81F6E9B, "team_changed" },
    { 0x0F5CAE96, "team_changed_watcher" },
    { 0x629C8519, "team_colors" },
    { 0xDC822799, "team_counts" },
    { 0xAEECB13E, "team_follow_trigger_thread" },
    { 0x8857460B, "team_free" },
    { 0x88BF1CEF, "team_free_targeting" },
    { 0x17D63DC9, "team_icon_intro" },
    { 0x8B41A91A, "team_icon_size" },
    { 0x836FA0FA, "team_icon_size_lg" },
    { 0xE56BF4B0, "team_icon_winner" },
    { 0x611A31DB, "team_index" },
    { 0x3E64EDEB, "team_is_touching" },
    { 0xA397C749, "team_light_fx_handle" },
    { 0x5B09F715, "team_mask" },
    { 0x238D5805, "team_mates" },
    { 0x04C4C18B, "team_member_zoom_button_check" },
    { 0x9F8D3353, "team_names" },
    { 0x9BDE9543, "team_num" },
    { 0x61386A1C, "team_or_entnum" },
    { 0x72D03F58, "team_points" },
    { 0x4BD4DB43, "team_pool" },
    { 0xF34096AD, "team_score" },
    { 0xD942D5E6, "team_score_init" },
    { 0xB1BB57F0, "team_score_override" },
    { 0x84B21C77, "team_stats_init" },
    { 0x1E592FB1, "team_switch_exploit" },
    { 0x8A11D45B, "team_trig" },
    { 0xB0DE8FF0, "team_updater" },
    { 0x3C05A9A6, "team_x_start" },
    { 0xC67620C3, "team_y_start" },
    { 0xD380CE67, "teama" },
    { 0x50D58C95, "teamarray" },
    { 0x5F2D28D7, "teamascore" },
    { 0x61795F2C, "teamb" },
    { 0xD981CC66, "teambalance" },
    { 0xDCF93962, "teambalancedeadfirst" },
    { 0x602E8FB6, "teambalanceendofround" },
    { 0x1D00C6F9, "teambalancetimer" },
    { 0xDE12B72F, "teambased" },
    { 0x7E87610A, "teambscore" },
    { 0x8E5B7E84, "teamchange_graceperiod" },
    { 0x44004D26, "teamchange_keepbalanced" },
    { 0xB1F2A1E1, "teamchange_rememberchoice" },
    { 0x8303F14E, "teamchanged" },
    { 0xFE99B891, "teamchangegraceperiod" },
    { 0xEB310B85, "teamchangenotify" },
    { 0x437E6C27, "teamchanging" },
    { 0xA26F9383, "teamclientprefix" },
    { 0xCD6B23CC, "teamcolumn" },
    { 0x72A17CE4, "teamcompletedchallenge" },
    { 0x0940A597, "teamcount" },
    { 0xB2EDDC47, "teamemped" },
    { 0xF28E86C4, "teamemping" },
    { 0xD7AD0213, "teamequip_changed" },
    { 0x158D65E6, "teamfaction" },
    { 0x4D84438B, "teamflags" },
    { 0xD519FBBD, "teamflagzones" },
    { 0x8E0C9C8F, "teamgather" },
    { 0xEB461EBC, "teamgather_failure" },
    { 0xD8AC3B5B, "teamgather_main_update" },
    { 0x6BF5C5DB, "teamgather_success" },
    { 0x31B75188, "teamhasactivecounteruav" },
    { 0x00EF8C4E, "teamhasactiveemp" },
    { 0x88F5FE32, "teamhasradar" },
    { 0xA6AA456D, "teamhassatellite" },
    { 0x18793A82, "teamhasspyplane" },
    { 0xE308C311, "teamicon" },
    { 0xA59BFDF8, "teamicons" },
    { 0x37F36656, "teamindex" },
    { 0xDA4B384F, "teamkey" },
    { 0xF8F52B16, "teamkeys" },
    { 0x231B4B76, "teamkill" },
    { 0xB7976FB0, "teamkill_penalty" },
    { 0xC25B4791, "teamkill_score" },
    { 0xBD37CCFF, "teamkilldelay" },
    { 0x4F57D739, "teamkilled" },
    { 0xEA20354B, "teamkilledspawndelay" },
    { 0xD52616EA, "teamkilling" },
    { 0xB8F126C4, "teamkillkick" },
    { 0xA428A027, "teamkillkicked" },
    { 0x0A77947C, "teamkillpenaltymultiplier" },
    { 0x53BCE17D, "teamkillpenaltyscale" },
    { 0xA04731A9, "teamkillpointloss" },
    { 0xD9E008C5, "teamkillpunish" },
    { 0x67BC1493, "teamkillreducedpenalty" },
    { 0xF2DFC269, "teamkills" },
    { 0x0304E32D, "teamkillscoremultiplier" },
    { 0xF5257FB4, "teamkillspawndelay" },
    { 0xC9BCA7D3, "teamkillsthisround" },
    { 0xE4A5F9E7, "teamlimit" },
    { 0xE559766A, "teamlivesmaxvalue" },
    { 0x8044D06C, "teamlivesminvalue" },
    { 0x54CD8D6B, "teamlock" },
    { 0x13377C79, "teammate" },
    { 0xD1A09D1E, "teammate_dead" },
    { 0xE1AEA725, "teammate_needs_revive" },
    { 0xCB7A1387, "teammateneedsrevive" },
    { 0xE729DCB0, "teammates" },
    { 0x38A7C573, "teammenu" },
    { 0xB1FD07B7, "teammessage" },
    { 0x247B1FF0, "teammessagequeue" },
    { 0x0E3519FA, "teammessagequeuemax" },
    { 0xD650CC39, "teammovewaittime" },
    { 0x0327F501, "teammsg" },
    { 0x2C31CEF7, "teamname" },
    { 0xA0B1334A, "teamnametoignore" },
    { 0x73703952, "teamnum" },
    { 0xA3BEF948, "teamonly" },
    { 0xE21B687A, "teamops" },
    { 0x60C4492A, "teamops_dvar" },
    { 0x6521C6ED, "teamops_starting" },
    { 0xCFE86919, "teamopsacheived" },
    { 0xF8B6E626, "teamopsallowed" },
    { 0xCDBAAB59, "teamopsid" },
    { 0x39154CAD, "teamopsinfotableid" },
    { 0xF180D141, "teamopsinfotableloaded" },
    { 0x1687CF61, "teamopsinitialed" },
    { 0x3E7804B0, "teamopsinitialized" },
    { 0x2B46855E, "teamopskilltracker" },
    { 0xA295BA07, "teamopsname" },
    { 0x29B97631, "teamopsonplayerkilled" },
    { 0x2DFC4869, "teamopsonprocessplayerevent" },
    { 0xF5DDE2D3, "teamopsreward" },
    { 0xB7B1A955, "teamopsrewardindex" },
    { 0x48A94128, "teamopsshowhud" },
    { 0xCF51FCAA, "teamopsstart" },
    { 0xDFB9B8A5, "teamopsstarttime" },
    { 0x17ABECEC, "teamopstargetkills" },
    { 0x24CAAC88, "teamopsupdateprogress" },
    { 0xA6C201CA, "teamopswatcher" },
    { 0x62D47BB0, "teamorentnum" },
    { 0xCEFF20B5, "teamoutcomenotify" },
    { 0x8CAB5867, "teamoutcomenotifyzombie" },
    { 0xFE33AF3E, "teamplayercardsplash" },
    { 0x57487B97, "teamplayercountsequal" },
    { 0xA09D7D24, "teamplayers" },
    { 0x8461C9AA, "teamplayers_s" },
    { 0x032F0841, "teampostfix" },
    { 0x60A45986, "teamprefix" },
    { 0x4C15D8D3, "teamprogress" },
    { 0xC8760D12, "teamprogressbarfontsize" },
    { 0xEB92945F, "teamprogressbarheight" },
    { 0x2BB05334, "teamprogressbartexty" },
    { 0x4F966EDE, "teamprogressbarwidth" },
    { 0x05C216EF, "teamprogressbary" },
    { 0x8E08B0CD, "teamref" },
    { 0xE7A38025, "teams" },
    { 0xF705B237, "teams_have_enmity" },
    { 0x64725876, "teamsa" },
    { 0x3E6FDE0D, "teamsb" },
    { 0x61F8B934, "teamscore" },
    { 0xCFC9E1BC, "teamscore_material" },
    { 0xB61B8423, "teamscorelimitcheck" },
    { 0x7E3C69F4, "teamscorelimitsoon" },
    { 0x261DC085, "teamscoreperdeath" },
    { 0xF29440CB, "teamscoreperheadshot" },
    { 0xA84B87C9, "teamscoreperkill" },
    { 0x0BBFCB94, "teamscoreperkillconfirmed" },
    { 0x0EC7D180, "teamscoreperkilldenied" },
    { 0xFA9BFA35, "teamscoreratio" },
    { 0x3F7D6E27, "teamscores" },
    { 0x28E38A05, "teamscoresequal" },
    { 0xAEB909A7, "teamscorestring" },
    { 0xD9B0545B, "teamscoreuicallback" },
    { 0x22D37EA2, "teamset" },
    { 0xB8A40645, "teamshader" },
    { 0x57486C1A, "teamspawnpoints" },
    { 0x2B9C94B0, "teamssplitup" },
    { 0x090B2B62, "teamswitch" },
    { 0x3C4A5040, "teamswitch_threatbias_setup" },
    { 0x3EA5C8E7, "teamswitchexploit" },
    { 0xA416E865, "teamtime" },
    { 0xBCBBCA15, "teamtweaks" },
    { 0x46948A4A, "teamtype" },
    { 0xB5098881, "teamtypenonteambased" },
    { 0x0BBCF7B6, "teamtyperoundteambased" },
    { 0xD2560AFE, "teamtypeteambased" },
    { 0x6A52E2EC, "teamunderattack" },
    { 0xFEEEAE21, "teamusetexts" },
    { 0xA7A06A6B, "teamusetimes" },
    { 0xDE9A72BF, "teamwageroutcomenotify" },
    { 0xF5AACA6C, "teamwithlowestplayercount" },
    { 0x7D0933B6, "teamwithlowestscore" },
    { 0x9BA1A529, "teamwork" },
    { 0x89A9340E, "teamxstart" },
    { 0x206015CD, "tear" },
    { 0x02BC20FF, "tear_anim" },
    { 0x39053FAF, "tear_anim2" },
    { 0x38214826, "tear_down_gondola_poi" },
    { 0x2E1E6BE9, "tear_fastrope_guys" },
    { 0x0E322411, "tear_into_building" },
    { 0x8D21F753, "tear_into_facing" },
    { 0x3124AE14, "tear_into_position" },
    { 0xE99062D2, "tear_into_wait" },
    { 0xDCD5F169, "tear_timeout" },
    { 0x44B81397, "teardown_basic_scene" },
    { 0x1DC7A298, "teargas" },
    { 0xA1794330, "teargas_player" },
    { 0x97B509F6, "teargas_timer" },
    { 0x9F41194C, "teargas_trigger_think" },
    { 0xC3DA1428, "teargasduration" },
    { 0x4B16FF7B, "teargasfillduration" },
    { 0xFCC4FA8F, "teargasstarttime" },
    { 0x580FF16B, "teargassuffering" },
    { 0xB3462F2D, "teargrenade" },
    { 0xB0DBD0D8, "teargrenade_think" },
    { 0x969B009C, "teargrenadetimer" },
    { 0x5081B9C0, "tearheight" },
    { 0xD876F8DB, "tearing" },
    { 0xC8C0C927, "tearradius" },
    { 0x3301234C, "tears" },
    { 0x51C0F2D0, "tearsufferingduration" },
    { 0x700F69BC, "teartimer" },
    { 0x99A7AA3D, "tech" },
    { 0x66EC49DE, "technical" },
    { 0x883A89A4, "technical_damage_callback" },
    { 0xC4AF3D54, "technical_driver_climb_out" },
    { 0x19E14045, "technical_driver_duck" },
    { 0xB5136988, "technical_driver_idle" },
    { 0x0C518DB4, "technical_passenger_climb_out" },
    { 0xA3B2E665, "technical_passenger_duck" },
    { 0x415F78A8, "technical_passenger_idle" },
    { 0x5CE4B615, "technical_rocks" },
    { 0xB36EE5F5, "technical_rocks_clips" },
    { 0xB1A7CBB0, "technical_setup" },
    { 0x44169D9F, "technical_trig" },
    { 0x830CCAFA, "technical_turret_aim_2" },
    { 0x06F402E0, "technical_turret_aim_8" },
    { 0x5A797DE0, "technical_turret_death" },
    { 0x81FEF656, "technical_turret_jam" },
    { 0x2D90AAE6, "technical_turret_turn_l" },
    { 0x196DF928, "technical_turret_turn_r" },
    { 0x7CBCCE83, "technically" },
    { 0xDD2F8D41, "technicals" },
    { 0x84A55727, "technician" },
    { 0xC5C14F75, "technique" },
    { 0xDF430FDC, "techno" },
    { 0x5FA86613, "technologies" },
    { 0x138F0CB7, "technology" },
    { 0x2F7F5465, "techrope" },
    { 0xCD234DFC, "techs" },
    { 0x968C6BD5, "teddy" },
    { 0x76132CAD, "teeth" },
    { 0x75CD4364, "teh" },
    { 0x6B8AA361, "tehtimecounter" },
    { 0xD843602D, "tele" },
    { 0x83EFBF69, "tele_help" },
    { 0x8A65419B, "tele_help_end" },
    { 0x091365C6, "tele_origin" },
    { 0xC26D28AE, "tele_spark_audio_mover" },
    { 0xBE1489A8, "tele_targ" },
    { 0x2AE83290, "tele_vo_type" },
    { 0x8A7D5DA1, "telefrag" },
    { 0xC857BE5F, "telefragged" },
    { 0x2603724C, "telefragging" },
    { 0xE109C667, "telefraging" },
    { 0xD0CF23F7, "telegraph" },
    { 0x5635CD5A, "telegrapher" },
    { 0x02F124EE, "telegrapher_chair_animloop" },
    { 0x8AB8CC6F, "telegrapher_chair_anims" },
    { 0x12BD7DF3, "telegrapher_spawner" },
    { 0x02C62EAC, "telegrapher_stoptapping" },
    { 0x0217DA8A, "telegrapher_stoptapping_ondeath" },
    { 0x8C77A086, "telemetry" },
    { 0x329C3A77, "telemetry_doors_open" },
    { 0x025F20FB, "telemetry_enemies" },
    { 0xF4116420, "telemetry_friendlies" },
    { 0x4A839C09, "telemetry_friendlies_think" },
    { 0x5B3057B3, "telemetry_room_door" },
    { 0x150FDF90, "telemetry_sound_ent" },
    { 0xD479A790, "telepad" },
    { 0x732FA769, "telepad_loop" },
    { 0xDDB1DD7B, "telepads" },
    { 0xF3E36967, "telephone" },
    { 0x6FBAF950, "telephone_clip" },
    { 0x2760A3FA, "telepole_spark_fx_1" },
    { 0xF58FCCB8, "teleport" },
    { 0x355E59E9, "teleport_2d" },
    { 0xAABB419A, "teleport_2d_audio" },
    { 0x74CBCB97, "teleport_2d_audio_nopad" },
    { 0x668410F0, "teleport_2d_audio_specialroom_go" },
    { 0x492A85CE, "teleport_2d_audio_specialroom_start" },
    { 0x67082BFC, "teleport_2d_nopad" },
    { 0x58B77BAD, "teleport_active" },
    { 0xEAA09FDE, "teleport_actor" },
    { 0x70B21A5D, "teleport_actor_to_node" },
    { 0x8F8EC961, "teleport_ae_funcs" },
    { 0x9DF01AE0, "teleport_ae_start" },
    { 0x340C1C45, "teleport_aftereffect_bw_vision" },
    { 0x9FCEE6E8, "teleport_aftereffect_flare_vision" },
    { 0x5716654B, "teleport_aftereffect_flashy_vision" },
    { 0xF710E21C, "teleport_aftereffect_fov" },
    { 0x2C0612F7, "teleport_aftereffect_red_vision" },
    { 0xEF0E774F, "teleport_aftereffect_shellshock" },
    { 0xFD27AC1B, "teleport_aftereffect_shellshock_electric" },
    { 0x77A0F55B, "teleport_aftereffects" },
    { 0x3096A6FD, "teleport_ai" },
    { 0x3C1D32F4, "teleport_ai_single" },
    { 0x462AA8AA, "teleport_ai_to_node" },
    { 0x91004278, "teleport_ai_to_pos" },
    { 0x2B51C776, "teleport_and_take_node_by_targetname" },
    { 0xB326F234, "teleport_beam_fx_2d" },
    { 0x21FE2515, "teleport_behind_player_back" },
    { 0x5625EF10, "teleport_bowman_and_brooks" },
    { 0x5DBE651A, "teleport_bowman_c4_node" },
    { 0x863EA266, "teleport_brooks_c4_node" },
    { 0x17F7584B, "teleport_bus" },
    { 0x659E2A08, "teleport_cooldown" },
    { 0x85BE3FF2, "teleport_core_hint_update" },
    { 0xF86BDB69, "teleport_core_pos" },
    { 0x46514DB5, "teleport_core_start_exploder" },
    { 0x8811855F, "teleport_core_think" },
    { 0xB01BD818, "teleport_cost" },
    { 0x276703F8, "teleport_delay" },
    { 0xD424B253, "teleport_done" },
    { 0xC87E9D79, "teleport_first_player" },
    { 0x3E4C0A22, "teleport_friendlies" },
    { 0xF926BD3E, "teleport_friends" },
    { 0x661FD585, "teleport_harper_to_end" },
    { 0xB68429CF, "teleport_heroes" },
    { 0x610660C8, "teleport_hudson_to_location" },
    { 0x7FC0E34A, "teleport_human_shield" },
    { 0x4FEA0F8A, "teleport_initial_origin" },
    { 0x66AD4500, "teleport_kill_sampan_guy" },
    { 0x0361084A, "teleport_link_think" },
    { 0x802FA4E2, "teleport_location" },
    { 0xD654B591, "teleport_location_angles" },
    { 0x1CABB773, "teleport_location_index" },
    { 0xC6A865AF, "teleport_location_origin" },
    { 0x58340FA7, "teleport_node" },
    { 0x40B54710, "teleport_nuke" },
    { 0x91C92A24, "teleport_or_timeout" },
    { 0x1E6BE28B, "teleport_org" },
    { 0x34E15BAD, "teleport_origin" },
    { 0x6C4C208E, "teleport_pad" },
    { 0x811CA812, "teleport_pad_active_think" },
    { 0x5283C96A, "teleport_pad_countdown" },
    { 0xC3C0DC48, "teleport_pad_end_exploder" },
    { 0x160DD0E9, "teleport_pad_hide_use" },
    { 0xB3BEB53B, "teleport_pad_init" },
    { 0xED70CFE7, "teleport_pad_names" },
    { 0x5E48550F, "teleport_pad_player_fx" },
    { 0xB7F29119, "teleport_pad_start_exploder" },
    { 0x49539BFB, "teleport_pad_think" },
    { 0xF3A68D87, "teleport_pads_are_active" },
    { 0x55682D10, "teleport_player" },
    { 0xA35AD84D, "teleport_player_into_position" },
    { 0x35647579, "teleport_player_other_area" },
    { 0xF78B4C3F, "teleport_player_temp_into_enclosure" },
    { 0x6FBB7DEB, "teleport_player_to_gr_footprint_safe_spot" },
    { 0x6EE92233, "teleport_player_to_last_position" },
    { 0xDB10CE56, "teleport_player_to_location" },
    { 0x7C968094, "teleport_player_to_target" },
    { 0x552E05FB, "teleport_players" },
    { 0x61186753, "teleport_point" },
    { 0xDEF78E1A, "teleport_point_angles" },
    { 0xF8C68934, "teleport_point_origin" },
    { 0xF2457B82, "teleport_points" },
    { 0x7584317B, "teleport_pos" },
    { 0x918E17F9, "teleport_purple_guys_closer" },
    { 0x30ADCF19, "teleport_radius" },
    { 0x78A53596, "teleport_ship_squad" },
    { 0x5991830B, "teleport_spawned" },
    { 0x8A1E1D56, "teleport_specialroom_go" },
    { 0xF63F4CE8, "teleport_specialroom_start" },
    { 0xFFA21397, "teleport_spot" },
    { 0x13B3E70F, "teleport_start_exploder" },
    { 0x152D4EF2, "teleport_state" },
    { 0xD4A144B0, "teleport_struct" },
    { 0xFB606E7A, "teleport_struct_name" },
    { 0x3397EEF9, "teleport_struct_targetname" },
    { 0x50560FE8, "teleport_target" },
    { 0x9C483A19, "teleport_target_trigger" },
    { 0x8531BBC1, "teleport_targetname" },
    { 0x306CEB83, "teleport_targets" },
    { 0x0850A7FC, "teleport_time" },
    { 0x7B38A919, "teleport_to_skipto" },
    { 0x96E88F70, "teleport_to_start_node" },
    { 0x190333A9, "teleport_trigger" },
    { 0x5F0F1E6D, "teleport_trigger_invisible" },
    { 0xEB85FEC0, "teleport_used" },
    { 0x671FC3AF, "teleportation" },
    { 0xFCF63DF8, "teleportation_audio" },
    { 0x922FDF82, "teleportation_timed_out" },
    { 0xF4011ACB, "teleported" },
    { 0xDFDE690D, "teleporter" },
    { 0xA85C1B6E, "teleporter_audio_sfx" },
    { 0x685248BE, "teleporter_blocker" },
    { 0x0B190610, "teleporter_check_for_endgame" },
    { 0x7E83FAB0, "teleporter_dist" },
    { 0xBE617C10, "teleporter_done" },
    { 0xCF379B01, "teleporter_ending" },
    { 0x51FDA60F, "teleporter_ent" },
    { 0xA58363CE, "teleporter_exit_nml_gate2_ent" },
    { 0x7EDB6806, "teleporter_exit_nml_gate2_height" },
    { 0xB30A4F34, "teleporter_exit_nml_gate_ent" },
    { 0xAEB5E380, "teleporter_exit_nml_gate_height" },
    { 0x8B4490C2, "teleporter_exit_nml_gate_move" },
    { 0xB1194559, "teleporter_exit_nml_gate_open" },
    { 0x30996086, "teleporter_exit_nml_powerdown_time" },
    { 0x10B88629, "teleporter_exit_nml_think" },
    { 0xA19DB598, "teleporter_function" },
    { 0xC19E773D, "teleporter_fx_cool_down" },
    { 0xFE2DFE37, "teleporter_fx_init" },
    { 0xC76C401C, "teleporter_fx_setup" },
    { 0x074CB765, "teleporter_gate_move_time" },
    { 0x19297186, "teleporter_init" },
    { 0x5062EC26, "teleporter_intro" },
    { 0x02B53D7F, "teleporter_lights" },
    { 0xC500DA1B, "teleporter_lights_green" },
    { 0x0D4D1FFF, "teleporter_lights_red" },
    { 0x76A40D4F, "teleporter_map_light" },
    { 0x9B2EEB61, "teleporter_map_light_receiver" },
    { 0x6AF49B4A, "teleporter_map_light_receiver_flash" },
    { 0xB4FA8EAC, "teleporter_map_light_receiver_stop" },
    { 0xE742BBB5, "teleporter_message" },
    { 0xDCE2A1A3, "teleporter_pack" },
    { 0x0CF938A0, "teleporter_pad_trig" },
    { 0x910ECBED, "teleporter_power_cable" },
    { 0x1BA8D029, "teleporter_radius_stop" },
    { 0x7A009C17, "teleporter_radius_think" },
    { 0xC5B0A85B, "teleporter_samantha_chamber_line" },
    { 0xC83CAE6A, "teleporter_spawned" },
    { 0xB9F2A774, "teleporter_starting" },
    { 0xE22BAE0D, "teleporter_to_nml_gate2_ent" },
    { 0xF8958643, "teleporter_to_nml_gate2_height" },
    { 0x8B3DF875, "teleporter_to_nml_gate_ent" },
    { 0xAD39505B, "teleporter_to_nml_gate_height" },
    { 0xAF9FF3F5, "teleporter_to_nml_gate_move" },
    { 0x590BA9A6, "teleporter_to_nml_gate_open" },
    { 0x986FD39C, "teleporter_to_nml_init" },
    { 0x2B222584, "teleporter_to_nml_power_down" },
    { 0xAE26B507, "teleporter_to_nml_powerdown_time" },
    { 0xC1021075, "teleporter_vo" },
    { 0x9113FDCE, "teleporter_vo_play" },
    { 0x1B34E6B5, "teleporter_waiting_for_electric" },
    { 0x602BE549, "teleporter_wire_wait" },
    { 0xE5A0FC8C, "teleporters" },
    { 0x7FE940DB, "teleportfxin" },
    { 0x50B72D4E, "teleportfxout" },
    { 0xF9EDD920, "teleporting" },
    { 0x36010EF4, "teleporting_zombies" },
    { 0xC9289AFC, "teleportnode" },
    { 0x7BC3009E, "teleportorigin" },
    { 0x16410986, "teleportpos" },
    { 0xDAA07413, "teleports" },
    { 0xE9ECCBBC, "teleportstart" },
    { 0x89D73258, "teleportthread" },
    { 0xF9398CC7, "teleportthreadex" },
    { 0xA7FE1D91, "television" },
    { 0x33D97578, "televisions" },
    { 0xE254B90C, "tell" },
    { 0x27D7A974, "tell_player_to_use_triple25" },
    { 0xE86297E9, "teller" },
    { 0x627915C2, "teller_withdrawl" },
    { 0xED1C01EC, "tellfxhandle" },
    { 0x084CB4BC, "telling" },
    { 0x693F168F, "tells" },
    { 0x8A54AE0F, "telltimer" },
    { 0xF8F608DB, "temp" },
    { 0x0CC2DDC9, "temp proceed" },
    { 0x00751CE8, "temp1" },
    { 0x727C8C23, "temp2" },
    { 0x4C7A11BA, "temp3" },
    { 0x78505834, "temp_advance" },
    { 0xE0C9E012, "temp_ak" },
    { 0x2AD5867A, "temp_alias" },
    { 0x006DB062, "temp_angles" },
    { 0x6C03C6E9, "temp_array" },
    { 0x366426BD, "temp_attachment" },
    { 0x56C5683C, "temp_avoidance" },
    { 0xEEABAD02, "temp_avoidance_on_noteworthy" },
    { 0x57BEA120, "temp_axis_check" },
    { 0x911C100B, "temp_building_fx_explosion" },
    { 0x8E65624E, "temp_change_tunnel_light" },
    { 0x2C32ACD5, "temp_chest_name" },
    { 0x5B8F047C, "temp_civ_count" },
    { 0x7F0AB757, "temp_cleanup_func" },
    { 0x5370D1AF, "temp_clips" },
    { 0x18A079DB, "temp_confuse_ai_by_tree_climb" },
    { 0xD9C1077D, "temp_convoy_fx_explosion" },
    { 0x92CEDFBB, "temp_count" },
    { 0x54B02E1B, "temp_def" },
    { 0x70498E30, "temp_defend2_dogs_text" },
    { 0x69263B22, "temp_delayed_finish" },
    { 0x08F35921, "temp_demo_stopshooting" },
    { 0x1CED5AD8, "temp_dialogue_and_logic_takeoff" },
    { 0x2E1707E0, "temp_dialogue_print" },
    { 0xD77C009C, "temp_disable_hud_damage" },
    { 0x110474C2, "temp_dist" },
    { 0xD490F5C3, "temp_drone_control_show_controls" },
    { 0x75897DF8, "temp_dynamite_trig_to_player" },
    { 0xB1CA4B4B, "temp_enable_hud_damage" },
    { 0x0ACF3E9C, "temp_end_testing" },
    { 0x84B6EB7A, "temp_enemy" },
    { 0x27F9A57D, "temp_ent" },
    { 0x054C567E, "temp_enta" },
    { 0x56B63A6D, "temp_flash_light" },
    { 0xEEA28EDD, "temp_forward" },
    { 0x303DD50F, "temp_friendly_boost" },
    { 0x24D16B21, "temp_fx_origin" },
    { 0xDEFB96AD, "temp_get_arm_offset" },
    { 0x86056997, "temp_goal" },
    { 0x407ECC09, "temp_grenade_num" },
    { 0x6E3E0420, "temp_gun" },
    { 0xD877038F, "temp_guy" },
    { 0xF7789B97, "temp_hammock_melee_death_audio" },
    { 0x1E9B4D03, "temp_hammock_melee_death_audio_npc" },
    { 0x0368EAA8, "temp_health" },
    { 0x6A782670, "temp_hide_hudson" },
    { 0xD53F69BA, "temp_hut_dialogue" },
    { 0xF97C22AD, "temp_id" },
    { 0x4DC440B5, "temp_image" },
    { 0xF2DB68B2, "temp_index" },
    { 0xF2A70F91, "temp_index_weapon" },
    { 0xD4AF6819, "temp_intensity" },
    { 0x411B4208, "temp_introscreen_fix" },
    { 0x9E193CD6, "temp_level_end" },
    { 0x709AFB8B, "temp_lines" },
    { 0xE146B538, "temp_loop_orig" },
    { 0x382626E8, "temp_machines" },
    { 0x0AD0CB0E, "temp_magic_bullet_shield" },
    { 0xCFE666FF, "temp_mdl" },
    { 0x52A9FCA1, "temp_modderhelphud" },
    { 0x4D76B9BD, "temp_model" },
    { 0x8516837D, "temp_move" },
    { 0x7762D9A8, "temp_move_and_rotate_boat" },
    { 0x8DB28FCA, "temp_node" },
    { 0x0B81034E, "temp_notetracks" },
    { 0xCE836EB6, "temp_objectarray" },
    { 0xDE1AD52F, "temp_offset" },
    { 0xFDF5D128, "temp_org" },
    { 0x304634F7, "temp_org_doubletap" },
    { 0x4ED3A6A9, "temp_org_dp_s" },
    { 0x26A24C8B, "temp_org_jugger" },
    { 0x234B1E4C, "temp_org_jugs_s" },
    { 0xCFA013EE, "temp_org_pack_s" },
    { 0x01445589, "temp_org_packa" },
    { 0xB06D03F0, "temp_org_revive" },
    { 0x06AC329E, "temp_org_revive_s" },
    { 0x687FFE20, "temp_org_speed" },
    { 0xC296CC8E, "temp_org_speed_s" },
    { 0x272031FD, "temp_orig" },
    { 0x392343BC, "temp_origin" },
    { 0x5BBBC954, "temp_piece" },
    { 0x25BE8324, "temp_play_fx_late" },
    { 0xA37EDDE0, "temp_play_next_sq_fx" },
    { 0x104752A6, "temp_player_grenade_hack" },
    { 0xE27593EB, "temp_player_move" },
    { 0xC43F35F1, "temp_player_ready" },
    { 0x08BDE712, "temp_poi" },
    { 0x4CF46C18, "temp_pos" },
    { 0x1291EEA8, "temp_radius_damage" },
    { 0x5B5719C0, "temp_reels_0" },
    { 0x81599429, "temp_reels_1" },
    { 0xEB187693, "temp_regroup_trig" },
    { 0x4CE82930, "temp_remove_timer" },
    { 0x9A8F2571, "temp_result" },
    { 0x88FCE36A, "temp_reznov_audio_2" },
    { 0xC083401E, "temp_run_anim_to_idle" },
    { 0xC6B0139D, "temp_script_ent" },
    { 0x8646A6FB, "temp_script_sound" },
    { 0x4C99D85D, "temp_shield" },
    { 0x92065209, "temp_side_smoke" },
    { 0x26A05747, "temp_skip_to_event_2" },
    { 0x7C2131FD, "temp_sound_orig" },
    { 0x522A3432, "temp_sound_orig_2" },
    { 0x4E990954, "temp_spawned_origins" },
    { 0x1109D926, "temp_spot" },
    { 0x45646DB3, "temp_stat_enemy_id" },
    { 0xFAB82EB6, "temp_stop_sound_wait" },
    { 0xC3BFADEF, "temp_str" },
    { 0x5114A2B5, "temp_struct" },
    { 0xF76721C9, "temp_target" },
    { 0xD3DE46E9, "temp_target2" },
    { 0xA59033E3, "temp_target_model" },
    { 0x1FB66DCC, "temp_target_think" },
    { 0x2B3D91D3, "temp_test_fx" },
    { 0x38757D3B, "temp_text" },
    { 0x89B665EA, "temp_think" },
    { 0xF1C190BC, "temp_toggle_hud_damage" },
    { 0x9502130F, "temp_tower_sequence" },
    { 0x17D08986, "temp_tunnel_collapse" },
    { 0xD0342954, "temp_turret" },
    { 0xD793DDBD, "temp_up" },
    { 0xC024EDE8, "temp_vec" },
    { 0x65DF041B, "temp_vo" },
    { 0xEFC9375C, "temp_vo_func" },
    { 0xF1D7A952, "temp_vo_function" },
    { 0x94933659, "temp_vo_no_anim" },
    { 0x755048A4, "temp_vo_no_anim_helper" },
    { 0x996045FC, "temp_vo_origin" },
    { 0x4834FC7F, "temp_vo_origin_pos" },
    { 0x159AE258, "temp_vo_pos" },
    { 0xEB719420, "temp_vtol_rappel_guy" },
    { 0x550D5CCB, "temp_vtol_rappel_guys" },
    { 0xBBA5DABD, "temp_vtol_rappel_start" },
    { 0xE6C34241, "temp_vtol_stop_and_rappel" },
    { 0x8440C723, "temp_wait_for_reach_barnes" },
    { 0x3D35EE07, "temp_water" },
    { 0xC8EF58D6, "temp_weapon" },
    { 0xE18C9F49, "temp_weapons" },
    { 0x925F1A58, "temp_woods" },
    { 0x55F0161C, "tempangle" },
    { 0x35E4AF5F, "tempangles" },
    { 0x974805C6, "temparray" },
    { 0x9F85945F, "tempbomb" },
    { 0xB0CA0DD0, "tempboost" },
    { 0x5B4CF339, "tempboosttimeout" },
    { 0xD9A98D49, "tempbrassnotify" },
    { 0xC7B86555, "tempbrush" },
    { 0x0AAE7A93, "tempbuildingparts" },
    { 0x61D35A92, "tempchildren" },
    { 0x30187F39, "tempclass" },
    { 0x28CE0A76, "tempclean" },
    { 0xD63FB455, "tempclip" },
    { 0x5FC29647, "tempdist" },
    { 0xD6CFC3EA, "tempent" },
    { 0xE57C7075, "tempentry" },
    { 0x487447C3, "temperament" },
    { 0x03602971, "temperature" },
    { 0x0B0E0286, "temperment" },
    { 0x385DB7D9, "tempish" },
    { 0x2FCBCC97, "template" },
    { 0x6CE2DBBA, "template_amb" },
    { 0x8D920E88, "template_test_zone_init" },
    { 0x8E0357DA, "temple" },
    { 0x3C7F29DF, "temple_box_monitor" },
    { 0x9F82641B, "temple_camera_spot" },
    { 0x2094B883, "temple_create_spawner_list" },
    { 0xB47FC776, "temple_ignore_spawner" },
    { 0xE781A79D, "temple_init_zone_spawn_locations" },
    { 0xAE718896, "temple_light_model_swap_init" },
    { 0xB806E318, "temple_manage_zones" },
    { 0xBE0A48A8, "temple_pap_monitor_spinners" },
    { 0x76FAA4D1, "temple_player_connect" },
    { 0x5A53D129, "temple_player_spawned" },
    { 0x21D050B3, "temple_remove_visionset_caves" },
    { 0x7E71167F, "temple_roof" },
    { 0x0B948AB6, "temple_roof_top_dialog" },
    { 0xEFBA1226, "temple_roof_traversal_setup" },
    { 0x6AF59B74, "temple_roof_traverse" },
    { 0x60DCAA9B, "temple_round_prestart" },
    { 0x9A9B3185, "temple_round_spawning" },
    { 0x54347045, "temple_round_wait" },
    { 0x3FFD56D8, "temple_set_eclipse_visionset" },
    { 0xFECBAEBE, "temple_set_visionset" },
    { 0x70CA56A1, "temple_set_visionset_caves" },
    { 0x78AB33DE, "temple_sidequest_achieved" },
    { 0x4289652A, "tempmodel" },
    { 0x7D5F6FF3, "tempnode" },
    { 0x0EB612D5, "tempnum" },
    { 0xAEDECCA7, "temporarily" },
    { 0x898C61A4, "temporarly" },
    { 0x20FAAF4A, "temporary" },
    { 0xDA72BAE5, "temporary_dont_ignore" },
    { 0xE94FEBD6, "temporary_invulnerability" },
    { 0x23DC7EDC, "temporary_power_switch_logic" },
    { 0xE1BE9591, "tempory" },
    { 0x9CBCECE1, "tempppppp" },
    { 0xCD18ABFA, "temps" },
    { 0x8B2E731C, "tempspawn" },
    { 0xD344C323, "tempspot" },
    { 0x74BC90EE, "tempstate" },
    { 0xB404FB8F, "tempt_array" },
    { 0xD83E13CF, "temptarg" },
    { 0xE83D3FF4, "temptation" },
    { 0x3A0AE806, "temptation_array" },
    { 0x4EBCAC1D, "temptation_index" },
    { 0xC8965562, "tempted" },
    { 0x642D13AE, "temptext" },
    { 0xEFF767E5, "tempturretorg" },
    { 0x3B2F2863, "tempvec" },
    { 0x60C5BDB2, "tempvector" },
    { 0x308C45A2, "tempvo" },
    { 0x77025E49, "tempx" },
    { 0x50FFE3E0, "tempy" },
    { 0x7D6B5121, "tempyawdiff" },
    { 0xC307531B, "tempz" },
    { 0x29C84E92, "ten" },
    { 0x4193CA5D, "ten_monkeys_before" },
    { 0x97F455B0, "ten_seconds" },
    { 0x1608FBD2, "ten_seconds_before" },
    { 0x7F5BDED2, "tend" },
    { 0x46B2FD87, "tendancy" },
    { 0x4A143DDD, "tends" },
    { 0xE89E0BD8, "tenko" },
    { 0x518AF49D, "tens" },
    { 0xAB6A11C7, "tens_model" },
    { 0xECF977D1, "tension" },
    { 0xBC05F046, "tension_level" },
    { 0xDF838562, "tent" },
    { 0x65DBBEDB, "tent01" },
    { 0xF291E630, "tent_01" },
    { 0x6499556B, "tent_02" },
    { 0x3E96DB02, "tent_03" },
    { 0xB09E4A3D, "tent_04" },
    { 0x502C3A90, "tent_flap" },
    { 0x9F51E148, "tent_flap01_start" },
    { 0xF9260E8B, "tent_flap02_start" },
    { 0x7B19CA35, "tent_open" },
    { 0x8A645F6C, "tent_open_start" },
    { 0xADCF7F6E, "tenth" },
    { 0xC6696091, "tenths" },
    { 0x94976AA9, "tenzan" },
    { 0xE7A25D80, "ter_op" },
    { 0xAAB5C9F9, "terminal" },
    { 0x4F5F9BE9, "terminal_linker" },
    { 0xA8168EB3, "terminal_model" },
    { 0xE2FDDD30, "terminals" },
    { 0xF04E14FE, "terminate" },
    { 0x974DE41E, "terminate_all_the_things" },
    { 0x42453C48, "terminate_all_turrets_firing" },
    { 0xE090D26C, "terminate_cm_watcher" },
    { 0xD372FE9C, "terminatebsm" },
    { 0x20A5A85E, "terminated" },
    { 0x8D4017F4, "terminatefunc" },
    { 0x4D18C952, "terminatefuncptr" },
    { 0x5581475A, "terminatefunction" },
    { 0xC2C0EAE1, "terminates" },
    { 0x143A1E17, "terminating" },
    { 0xE461FFCD, "termination" },
    { 0xAF2105D8, "termniate" },
    { 0xD9877EB6, "terms" },
    { 0x5108524B, "ternary_digits" },
    { 0x4C74C948, "terr" },
    { 0x757E5378, "terrain" },
    { 0x5A88E5E6, "terrain_brass_ent_array" },
    { 0x422A6C90, "terrain_check_offset_high" },
    { 0x6040F5CA, "terrain_check_offset_low" },
    { 0x3B922784, "terrain_ent_array" },
    { 0x80EEA57D, "terrain_loop_sound_delete" },
    { 0xDD8650FA, "terrain_trace" },
    { 0xAC8463BC, "terrain_trace_brass" },
    { 0x979CA301, "terrebonne" },
    { 0x533B3C48, "terrible" },
    { 0x1D9B5DBD, "territories" },
    { 0x7872E075, "territory" },
    { 0x0FDEFD32, "territory_afghanistan" },
    { 0xACB56AFC, "territory_index" },
    { 0xD187D2C9, "territory_india" },
    { 0x7ABE6528, "territory_iran" },
    { 0x73C3452B, "territory_russia" },
    { 0x8DF04CA9, "terrorist" },
    { 0x5C5C8E65, "terrorist_bft_highlight" },
    { 0xD3EB8053, "terrorist_debug_spawnfunc" },
    { 0x4596811D, "terrorist_fire_at_player_flag" },
    { 0xCB2534B8, "terrorist_hunt_anims" },
    { 0xEA68F7D7, "terrorist_hunt_clean_up" },
    { 0xF4EE5393, "terrorist_hunt_court_clean_up" },
    { 0x8D0E4E6D, "terrorist_hunt_setup" },
    { 0xF2189B76, "terrorist_player_damage_flag" },
    { 0x0B457C9D, "terrorist_player_death_flag" },
    { 0x51E93EC6, "terrorist_shot_callback" },
    { 0xB8CA9033, "terrorist_spawn_full_count" },
    { 0x3842C2D9, "terrorist_spawner_4" },
    { 0x12404870, "terrorist_spawner_5" },
    { 0x3CA7CE26, "terrorist_team3" },
    { 0xBEA28799, "terrorist_teamswitch_check_targets" },
    { 0x80E8C35E, "terrorist_teamswitch_player_detected" },
    { 0x9A00F4F5, "terrorist_teamswitch_radius_check" },
    { 0xFDEC1237, "terrorist_teamswitch_reaction" },
    { 0xBD32E2F1, "terrorist_teamswitch_spawnfunc" },
    { 0xFB776462, "terrorist_teamswitch_think" },
    { 0x87CA4B20, "terrorists" },
    { 0xF607D757, "terrorists_expose" },
    { 0x6D9656AF, "tertiary" },
    { 0x768456A9, "tesing" },
    { 0x34C09A22, "tesla" },
    { 0x60D03557, "tesla_arc_count" },
    { 0x057A28E1, "tesla_arc_damage" },
    { 0xF38BA3C3, "tesla_blocker_model" },
    { 0x7F0B4E60, "tesla_blockers" },
    { 0x822F3AB1, "tesla_blockers_cleanup" },
    { 0x8C768539, "tesla_blockers_damage_trigger" },
    { 0x50608835, "tesla_blockers_deletion_monitors" },
    { 0x8614BA51, "tesla_blockers_fx" },
    { 0xBE694794, "tesla_blockers_move" },
    { 0xE3B41890, "tesla_blockers_timeout" },
    { 0xCA5C4134, "tesla_blockers_update" },
    { 0xA99414E8, "tesla_change_watcher" },
    { 0x5A4C31B7, "tesla_damage_func" },
    { 0x51E87BEB, "tesla_damage_init" },
    { 0xBC34BBED, "tesla_death" },
    { 0x98FCC024, "tesla_death_fx_callback" },
    { 0xACBDCE5B, "tesla_debug_arc" },
    { 0x4303154C, "tesla_devgui_dvar_think" },
    { 0xA954893B, "tesla_discharge" },
    { 0x2F9CE7F8, "tesla_discharge_mechanic" },
    { 0x236D3EA5, "tesla_discharged" },
    { 0x55A2B33E, "tesla_do_damage" },
    { 0x25FEBC97, "tesla_end_arc_damage" },
    { 0x49E1E777, "tesla_enemies" },
    { 0xB8379105, "tesla_enemies_hit" },
    { 0x42E262C5, "tesla_engine_sweets" },
    { 0x5D2FA0D0, "tesla_firing" },
    { 0x62BDDEFD, "tesla_flag_hit" },
    { 0x6F30C596, "tesla_fx_rail" },
    { 0xB3585264, "tesla_fx_tube" },
    { 0xDA0CECF0, "tesla_get_enemies_in_area" },
    { 0x22D66A68, "tesla_gun_exists" },
    { 0x42B7C319, "tesla_happy" },
    { 0xA4468055, "tesla_head_gib_func" },
    { 0xEA96AA67, "tesla_killstreak_sound" },
    { 0x09991892, "tesla_lightning_params" },
    { 0xC7F6502B, "tesla_loop_sound" },
    { 0x669ACD5C, "tesla_network_choke" },
    { 0x0A450EBF, "tesla_network_death_choke" },
    { 0x2727564B, "tesla_notetrack_think" },
    { 0x398DC86C, "tesla_ok_to_discharge" },
    { 0x7AC0E5CF, "tesla_play_arc_fx" },
    { 0xC80EA8B9, "tesla_play_death_fx" },
    { 0xF1CFF8AC, "tesla_play_fx" },
    { 0xC82683AA, "tesla_play_rail" },
    { 0xC4D6E3E4, "tesla_powerup_active" },
    { 0x691298EC, "tesla_powerup_dropped" },
    { 0x59434970, "tesla_pvp_thread" },
    { 0x6F5D566B, "tesla_shock_eyes_fx_callback" },
    { 0x3F6B791D, "tesla_sound_thread" },
    { 0xE54249C7, "tesla_time_over" },
    { 0xFCFEE658, "tesla_watch_gunner_downed" },
    { 0x7C330FB0, "tesla_weapon_powerup" },
    { 0xB51E6598, "tesla_weapon_powerup_countdown" },
    { 0x74CB9886, "tesla_weapon_powerup_off" },
    { 0x3682206F, "tesla_weapon_powerup_remove" },
    { 0x9937E421, "tesla_weapon_powerup_replace" },
    { 0xE7472A4D, "tesla_zombie_damage_response" },
    { 0x2CFFA872, "tesla_zombie_death_response" },
    { 0x291102F8, "teslafxtag" },
    { 0x8181A3A1, "test" },
    { 0x399B285A, "test1" },
    { 0x1398ADF1, "test2" },
    { 0x7B65EAB5, "test_align_struct" },
    { 0x344F484A, "test_alphabet_space" },
    { 0xA6D71FC2, "test_anims" },
    { 0x8E9DE7D9, "test_animsound_file" },
    { 0x79EBEC18, "test_betties" },
    { 0x1258B8AD, "test_blood_mounds" },
    { 0xFDA7813E, "test_boat" },
    { 0x839E7C3D, "test_boat_node" },
    { 0x252667C5, "test_callback" },
    { 0x0C72D708, "test_cleared" },
    { 0x4FE3ABB7, "test_damage" },
    { 0x74D28B13, "test_depth" },
    { 0xB7B18192, "test_dia" },
    { 0x23C32819, "test_end_wmd_level" },
    { 0x3A49F123, "test_ent" },
    { 0x43BD2A0B, "test_failed_path" },
    { 0x0AF551AE, "test_flak" },
    { 0xCCBDE806, "test_fucking_fog" },
    { 0xB237324D, "test_get_back_point" },
    { 0x48DB4874, "test_get_back_queryresult" },
    { 0x298AF3B7, "test_heli_dropoff" },
    { 0x256C9473, "test_id" },
    { 0x360AF198, "test_index" },
    { 0x248A8FE1, "test_kill_allies" },
    { 0x6D86F57C, "test_list" },
    { 0xF5447D66, "test_lvt" },
    { 0x09BC43A5, "test_magicgrenade" },
    { 0x86AE226A, "test_mechz_robot" },
    { 0x30919A8E, "test_mechz_sprint" },
    { 0x29EAD3F6, "test_mechz_tank" },
    { 0x60B4D569, "test_melee_trigger" },
    { 0x20EDE55D, "test_mode" },
    { 0xC078CFA5, "test_name" },
    { 0xE953CBF8, "test_node" },
    { 0x87F2953C, "test_oneinchpunch" },
    { 0x84431C31, "test_oneinchpunch_air" },
    { 0xA22FFD2F, "test_oneinchpunch_fire" },
    { 0x729FE794, "test_oneinchpunch_ice" },
    { 0xF38F470B, "test_oneinchpunch_lightning" },
    { 0x1F2704E7, "test_oneinchpunch_upgraded" },
    { 0x1848D0A6, "test_org" },
    { 0x6CB4F7BD, "test_org_foot" },
    { 0x8DA9FF79, "test_org_mid" },
    { 0x250E9182, "test_origin" },
    { 0xE33EE590, "test_origin_squared" },
    { 0xC0DE49B4, "test_pauser" },
    { 0xA26264B3, "test_player" },
    { 0xDEFAC32A, "test_player_tablet" },
    { 0xEE698DA6, "test_point" },
    { 0xB36131CF, "test_point_radius" },
    { 0xA057BD91, "test_print" },
    { 0x28F05578, "test_prints" },
    { 0x72FB8025, "test_radius_sq" },
    { 0x058EF943, "test_range" },
    { 0xD29AF645, "test_range_squared" },
    { 0x1431520C, "test_scene" },
    { 0xE783F18F, "test_scenes" },
    { 0x0D318AE7, "test_sight" },
    { 0xEA6C2012, "test_spawn_plane" },
    { 0xCAC7CD0F, "test_spawn_point_index" },
    { 0xAE523A17, "test_string" },
    { 0xE308BBC7, "test_struct" },
    { 0x5AE4091E, "test_stumble" },
    { 0x9665528F, "test_tags" },
    { 0x4C1E2367, "test_tanks" },
    { 0xAEF1E1B7, "test_time" },
    { 0x09A3A157, "test_timer" },
    { 0x93164EB8, "test_undefined" },
    { 0xC3E711DF, "test_value" },
    { 0xDE4C03C5, "testable" },
    { 0x7848A45B, "testaction" },
    { 0xF2FFA75F, "testai" },
    { 0xA242EF85, "testalphaout" },
    { 0xEFEF65A1, "testangles" },
    { 0x066B0B16, "testanim" },
    { 0xEC47F95B, "testanimname" },
    { 0xEA090589, "testanims" },
    { 0x06AE9BB7, "testcheck" },
    { 0xE5DD6234, "testcig" },
    { 0x67CA62F4, "testclient" },
    { 0x29C8DBE7, "testclients" },
    { 0xFC4617BA, "testdialogqueue" },
    { 0x4659F521, "testdist" },
    { 0x4F1F7511, "testdistsq" },
    { 0x92600B0D, "testdvars" },
    { 0x91F2EB8E, "tested" },
    { 0x563D5541, "testfunction" },
    { 0xFDB65068, "testgrenadethrowanimoffsets" },
    { 0xCA7A79E8, "testhps" },
    { 0x5A190E09, "testhurttriggers" },
    { 0x203C4867, "testing" },
    { 0x79552F71, "testing_hud" },
    { 0x791AB663, "testing_patience" },
    { 0x9F6ED2A5, "testing_spawner_bug" },
    { 0x2D29F527, "testingapproaches" },
    { 0xF964A872, "testkillbrushonstationary" },
    { 0x81961E0B, "testlife" },
    { 0x147DBE65, "testlifethink" },
    { 0xF82D1E23, "testline" },
    { 0x703D3031, "testmap" },
    { 0x8FC26198, "testmaps" },
    { 0x15B32A64, "testmenu" },
    { 0x01116FB5, "testorg" },
    { 0x4FBF1C3F, "testorigin" },
    { 0x93536391, "testpos" },
    { 0x8EA5CDC6, "testprediction" },
    { 0xEF79A796, "testresult" },
    { 0x6CF79948, "tests" },
    { 0x0CF63752, "testscriptruntimeerror" },
    { 0x7F73E9EF, "testscriptruntimeerror1" },
    { 0x0D6C7AB4, "testscriptruntimeerror2" },
    { 0xEFE63614, "testscriptruntimeerrorassert" },
    { 0xFF71E289, "testshock" },
    { 0x15DF7138, "testspawnorigin" },
    { 0xEE3907F0, "testspawnpoint" },
    { 0xA60B33E9, "testspot" },
    { 0xBB618960, "testspots" },
    { 0x5D7CCBE3, "testspotx" },
    { 0x377A517A, "testspoty" },
    { 0x382D8926, "teststruct" },
    { 0x8B85627A, "testtarget" },
    { 0x3C8AE65A, "testwheellocations" },
    { 0x8D7A2935, "tether" },
    { 0xBE751CB3, "tethering" },
    { 0x5B0DB004, "tethers" },
    { 0xA637741A, "teto2_over_te" },
    { 0xD5F4E9F4, "tex" },
    { 0x4DC9A9B4, "texas" },
    { 0x8CAA0808, "text" },
    { 0xFDD4C591, "text1" },
    { 0x23D73FFA, "text2" },
    { 0x8DD948FC, "text2label" },
    { 0x49D9BA63, "text3" },
    { 0x9029941B, "text3label" },
    { 0xC5BE2056, "text_3d" },
    { 0xC6435A12, "text_array" },
    { 0x02FC9DDE, "text_begin_fade_out" },
    { 0xACD578F6, "text_box" },
    { 0x5BE12BC8, "text_color" },
    { 0x0C722B2C, "text_color_black" },
    { 0x080FBD92, "text_color_white" },
    { 0xA244044F, "text_display" },
    { 0x007EEB97, "text_fade_in_time" },
    { 0xBBFF99B6, "text_fade_out_complete" },
    { 0x0764FF1C, "text_fade_out_time" },
    { 0xAB5D2F1E, "text_for_3d_objective" },
    { 0x89C274B8, "text_fps" },
    { 0xC8F4C020, "text_line_fade_in" },
    { 0xB75B6F58, "text_print" },
    { 0x8F717900, "text_rts" },
    { 0x1D12389D, "text_scale_first_line" },
    { 0x38AEB894, "text_scale_other_lines" },
    { 0x874C938A, "text_struct_array" },
    { 0x1A5CFA14, "textalpha" },
    { 0xAB23F9BD, "textcolor" },
    { 0x31704579, "textelem" },
    { 0xBF3EAFFC, "textelm" },
    { 0x6238D8AC, "textelm_fps" },
    { 0x99C01E44, "textelm_rts" },
    { 0xA9C9A7E2, "texthudelem" },
    { 0xC25F48DB, "textisstring" },
    { 0x46CC8DD2, "textlabel" },
    { 0x963519E6, "textline" },
    { 0xA211332B, "textline1" },
    { 0x3009C3F0, "textline2" },
    { 0xF07C0031, "textoffset" },
    { 0xBE3A0178, "textoverlay" },
    { 0xE91250B6, "textpos" },
    { 0x2D49050E, "textscale" },
    { 0x348B654B, "textsize" },
    { 0x82633EEA, "texture" },
    { 0x76601060, "texture_wait_was_called" },
    { 0xE3745577, "texturename" },
    { 0x26B083A5, "textures" },
    { 0xEBDE546D, "textures_print" },
    { 0x28AB58EC, "tfall" },
    { 0xA0F4FA41, "tflag" },
    { 0x5A57486C, "tflame" },
    { 0x63478F8A, "tforward" },
    { 0x0370AEFC, "tgfx0" },
    { 0x29732965, "tgfx1" },
    { 0xD323B64A, "tgh" },
    { 0x91301A57, "tgm" },
    { 0xECE5C45B, "tgtname" },
    { 0x442A9BD1, "th" },
    { 0x1A87C34A, "th1" },
    { 0x736B9AC7, "th1a" },
    { 0xF48548E1, "th2" },
    { 0x691E8CEA, "th2a" },
    { 0xCE82CE78, "th3" },
    { 0xD8942757, "th4" },
    { 0x3AFEB6FA, "tha" },
    { 0x04880CB0, "than" },
    { 0xB53522F3, "thank" },
    { 0x7C1F72A2, "thanks" },
    { 0x0E5235D0, "thanksgiving" },
    { 0x6C7E230C, "thar" },
    { 0x20792E3A, "that" },
    { 0xB1391E03, "that_one" },
    { 0x858EFAF0, "thatn" },
    { 0x13878BB5, "thats" },
    { 0xFA76B3D1, "thaw" },
    { 0xD308A09E, "the" },
    { 0x2B6556C2, "the_anim" },
    { 0xCF81755D, "the_apartment" },
    { 0xB4E395A8, "the_big_boss_defeated" },
    { 0xD50449EA, "the_big_boss_introduction" },
    { 0xE393EF9D, "the_bus" },
    { 0xC28209D8, "the_direction" },
    { 0x7C62E7C2, "the_drop" },
    { 0x944B5F8F, "the_end_anims" },
    { 0xD9218EC2, "the_fates" },
    { 0x87C958F9, "the_fates_have_been_decided" },
    { 0x0703E2ED, "the_inside" },
    { 0x556D0274, "the_lights_of_their_eyes" },
    { 0x79DE41B7, "the_line" },
    { 0x51EE9A11, "the_lvt" },
    { 0x43165567, "the_mod" },
    { 0x4BAC4608, "the_noteworthy" },
    { 0x2FF1977A, "the_other_gunner_died" },
    { 0x1D366B3F, "the_pivot" },
    { 0x8DA1B655, "the_plane" },
    { 0x37C607AB, "the_ptboat" },
    { 0x3ED61A8A, "the_ptboats" },
    { 0x1CE9865D, "the_script_thing" },
    { 0xC7B57F8C, "the_shark" },
    { 0xB3B1892F, "the_ship" },
    { 0x7CE3D870, "the_ship_is_sinking" },
    { 0x006E747C, "the_specific_exit" },
    { 0xEC2C4951, "the_squad" },
    { 0x4644BE5F, "the_tag" },
    { 0xB7213E36, "the_target" },
    { 0xC36A4D82, "the_to_anim" },
    { 0x25057152, "the_triggers" },
    { 0x9EC0B9B2, "the_wounding" },
    { 0x55061A7D, "thead" },
    { 0x7DCACC89, "theanim" },
    { 0x8A868BFC, "theater" },
    { 0xE0B78ECB, "theater_attack" },
    { 0x32617314, "theater_attack_lookat" },
    { 0x46C8F2EE, "theater_attack_start" },
    { 0x0271B161, "theater_battle_loops" },
    { 0x5CD605A9, "theater_box_monitor" },
    { 0xAB08EC67, "theater_chandelier_model_scale" },
    { 0xA9FDED55, "theater_cleanup" },
    { 0x150AC60F, "theater_dialog" },
    { 0x101E9F78, "theater_exit_level" },
    { 0x1797799E, "theater_find_exit_point" },
    { 0xB258E70B, "theater_fly_me_to_the_moon" },
    { 0x185746D8, "theater_fly_me_to_the_moon_init" },
    { 0x790E88EC, "theater_ignore_spawner" },
    { 0x2D4DC5E1, "theater_light" },
    { 0x7414B0DF, "theater_light_model_swap" },
    { 0xDCF14ADC, "theater_light_model_swap_init" },
    { 0x3E0FBDBA, "theater_light_models" },
    { 0xCBA1AF1C, "theater_main" },
    { 0xB895D388, "theater_moon_jump_go" },
    { 0x481198C2, "theater_moon_jumps" },
    { 0x2D7500DC, "theater_moon_jumps_clear" },
    { 0x11E8D57E, "theater_movie_reel_hud" },
    { 0x3D184D5A, "theater_playanim" },
    { 0xFC49220A, "theater_player_in_eeroom" },
    { 0xAFF3C372, "theater_player_jumps" },
    { 0x18FF9B17, "theater_quad_round" },
    { 0x306059F8, "theater_remove_reel_hud" },
    { 0x9B4925F5, "theater_remove_reel_on_death" },
    { 0xCF58A701, "theater_zone" },
    { 0x699DE1FA, "theater_zone_init" },
    { 0x28834D75, "theatermode" },
    { 0x86A05B62, "theatre" },
    { 0x3825D415, "theatre_zpo_listener" },
    { 0xAFBA6BC4, "thebus" },
    { 0xC40E8497, "thedarkness" },
    { 0x43D9DC17, "thedif" },
    { 0x17AF1F4D, "theeffectbundle" },
    { 0x8A0FD7F5, "theend" },
    { 0x0F14043C, "theflag" },
    { 0x7E7CE3BE, "theflare" },
    { 0x8D0FE8B7, "theguy" },
    { 0x795EE435, "thehind" },
    { 0x1DE84D58, "theia" },
    { 0x93219DBE, "theia_callback_damage" },
    { 0x38559D8C, "theia_finished_platform_attack" },
    { 0x380AE1F4, "theia_preparing_javelin_attack" },
    { 0x879719B9, "theia_preparing_spike_attack" },
    { 0xB33A49B2, "theight" },
    { 0x2FC81603, "their" },
    { 0xCAD99705, "theirang" },
    { 0x662A0AC4, "theiranim" },
    { 0x69172477, "theirorg" },
    { 0xED8ABA99, "theirorigin" },
    { 0x51CF7A3F, "theirpos" },
    { 0x40862D72, "theirs" },
    { 0xDF701CB0, "theirteam" },
    { 0x78CCBEF3, "thekey" },
    { 0x447098D8, "theline" },
    { 0x22DCB69F, "them" },
    { 0xC290C5A4, "themed" },
    { 0x8DD8B396, "theminis" },
    { 0x9E2D7A1D, "themselves" },
    { 0xB0D54764, "then" },
    { 0xCE2089E3, "thename" },
    { 0x2BEE2C32, "thenode" },
    { 0x3C45C302, "thenote" },
    { 0x397324F6, "theone" },
    { 0xDC963115, "theoretical" },
    { 0x0F830C78, "theoretically" },
    { 0xF796699E, "theory" },
    { 0x7B3C1259, "theplayer" },
    { 0xA906D798, "ther" },
    { 0xACBFAFB5, "there" },
    { 0x667E85ED, "thereafter" },
    { 0x9107FA86, "therefor" },
    { 0x53EB121F, "therefore" },
    { 0x15806B84, "theres" },
    { 0xD08FD4F2, "theres_only_one_flamer" },
    { 0x433ECEC6, "thermal" },
    { 0x1772F188, "thermal_setup" },
    { 0x65C7278E, "thermal_vehicles" },
    { 0xEB4FA38C, "thermalactive" },
    { 0xE358FF98, "thermalvisionfofoverlayoff" },
    { 0x395324D2, "thermalvisionfofoverlayon" },
    { 0x49B62464, "therse" },
    { 0x9FA16E2E, "these" },
    { 0xF0F4E5A3, "thespawn" },
    { 0xB830DD7E, "thespot" },
    { 0x8D15B60E, "thet" },
    { 0x0C422B13, "theta" },
    { 0xCBA5B76B, "theta2" },
    { 0xE70C6C51, "thetarget" },
    { 0x821548BC, "theturret" },
    { 0xC6FD5A3E, "theweapontype" },
    { 0xEAFA738B, "they" },
    { 0x3FA6C8C4, "theyre" },
    { 0xD263469C, "thhe" },
    { 0xA0B525F4, "thick" },
    { 0xD0616C3C, "thickens" },
    { 0x772E7491, "thicker" },
    { 0x77A9DCC5, "thickness" },
    { 0xAF6DB4DB, "thie" },
    { 0x29B07A97, "thief" },
    { 0x7039BFAE, "thief_activation_wait" },
    { 0xB15C54E3, "thief_actor_damage" },
    { 0x08A6326C, "thief_adjust_health" },
    { 0xBA38F4A4, "thief_blink" },
    { 0x4530F689, "thief_chasing" },
    { 0xD9897AD5, "thief_check_floor" },
    { 0xD2900FBD, "thief_check_vision" },
    { 0x83202602, "thief_check_walk" },
    { 0xBE48E905, "thief_clear_portals" },
    { 0x9F84F28B, "thief_clientfield_cb" },
    { 0x0974F1D3, "thief_cooldown_power_room" },
    { 0xC6E0CAE9, "thief_damage" },
    { 0x8509CE80, "thief_damage_claymore" },
    { 0x61F5B723, "thief_debug" },
    { 0xEEF050BC, "thief_elevator_watch" },
    { 0xAABAFBCA, "thief_end_game" },
    { 0x84F9FAC9, "thief_enter_portal" },
    { 0x6AA0A1D9, "thief_exit_level" },
    { 0x127B6E25, "thief_find_nearest_portal" },
    { 0x1B499703, "thief_flip_activated" },
    { 0x725AE91F, "thief_freeze_countdown" },
    { 0xC2D216A9, "thief_freezegun_damage_response" },
    { 0x9E03D6BB, "thief_get_next_portal" },
    { 0x5DE6BC69, "thief_get_next_victim" },
    { 0x4FE18977, "thief_goto_bottom" },
    { 0x2FA622CC, "thief_goto_portal" },
    { 0x51BA0136, "thief_health_multiplier" },
    { 0x1ED04C34, "thief_health_watch" },
    { 0x63330928, "thief_hero_weapon_changed" },
    { 0xC88B9E92, "thief_info" },
    { 0x77FF85E4, "thief_init_portals" },
    { 0xA2DC0EE6, "thief_init_trap_clips" },
    { 0x33775F7E, "thief_intermission" },
    { 0x51D2EE92, "thief_is_packing" },
    { 0xCDFF758E, "thief_light" },
    { 0xE9504403, "thief_new_gadget_anim_time" },
    { 0x57F13765, "thief_new_gadget_time" },
    { 0xB041D16F, "thief_nuke_damage" },
    { 0xEE79E7D0, "thief_overclock_power_threshold" },
    { 0x4212BAC2, "thief_override" },
    { 0xC24EE53B, "thief_override_portal" },
    { 0x7C832A49, "thief_portal_to_portal" },
    { 0x3BAA4957, "thief_portal_to_victim" },
    { 0x6D0021B4, "thief_pos" },
    { 0x8C392B37, "thief_post_death" },
    { 0x4465D8FD, "thief_pre_flip_wait_time" },
    { 0xFCFD660E, "thief_prespawn" },
    { 0x6DECD283, "thief_print" },
    { 0x9D9388AB, "thief_reaction" },
    { 0xAC450DBD, "thief_return_loot" },
    { 0x39B51947, "thief_round_aftermath" },
    { 0x7408DBDE, "thief_round_spawning" },
    { 0xA10B8863, "thief_round_start" },
    { 0xB74E27B1, "thief_round_stop" },
    { 0x6703238F, "thief_round_tracker" },
    { 0x49F1E5E5, "thief_round_vision" },
    { 0x87619BCE, "thief_round_wait" },
    { 0x58ECE814, "thief_run_to_floor" },
    { 0x7DE0231E, "thief_save_spawn_func" },
    { 0x57BE12E8, "thief_save_wait_func" },
    { 0x14FDC179, "thief_scale_health" },
    { 0x8EFB827C, "thief_set_state" },
    { 0x1275E7BE, "thief_ship_cheat_round_2" },
    { 0x7B49300C, "thief_shutdown_enemy_event" },
    { 0x32166B8F, "thief_shutdown_enemy_events" },
    { 0xB4D443AC, "thief_shutdown_lights" },
    { 0xE748D5AB, "thief_speed" },
    { 0x3640EA11, "thief_state" },
    { 0x9D879823, "thief_state_default" },
    { 0x5EA41032, "thief_state_done_fliping" },
    { 0x208A3F51, "thief_state_received_new_gadget" },
    { 0xBEC21A43, "thief_steal" },
    { 0xD21F2F30, "thief_take_loot" },
    { 0x469DA1BD, "thief_take_player" },
    { 0x2847559B, "thief_teleport" },
    { 0x08FDFDFE, "thief_thundergun_damage" },
    { 0x08527FC2, "thief_trap_stop" },
    { 0x68D33607, "thief_trap_watch" },
    { 0xABDDEA8A, "thief_trap_watcher" },
    { 0x4C2E5371, "thief_try_steal" },
    { 0x6483029D, "thief_turn_player" },
    { 0x5215BEB4, "thief_ui_model_clientfield_cb" },
    { 0x92CFD087, "thief_vector" },
    { 0x367A3248, "thief_watch_chase_speed" },
    { 0x71958360, "thief_watch_controls" },
    { 0x565DD655, "thief_watch_speed_damage" },
    { 0xF6707842, "thief_weapon_option" },
    { 0x606AE8B7, "thief_weapon_option_none" },
    { 0x11B5AB11, "thief_weapon_option_ui_model_clientfield_cb" },
    { 0x9653E054, "thief_zombie" },
    { 0xE595EEF2, "thief_zombie_choose_run" },
    { 0x9C599A76, "thief_zombie_default_enter_level" },
    { 0x408AF9D7, "thief_zombie_default_spawn_heuristic" },
    { 0x450D7387, "thief_zombie_die" },
    { 0xA1189000, "thief_zombie_enter_level" },
    { 0x9D8E0CB0, "thief_zombie_hunt" },
    { 0x84FA2657, "thief_zombie_idle_setup" },
    { 0x61616AA0, "thief_zombie_pick_best_spawner" },
    { 0xE1276C04, "thief_zombie_set_visibility" },
    { 0xEA136A2C, "thief_zombie_setup_victims" },
    { 0x4944D27C, "thief_zombie_spawn" },
    { 0xDB712BED, "thief_zombie_spawn_heuristic" },
    { 0xE1BCC3B0, "thief_zombie_spawners" },
    { 0xDDFB5815, "thief_zombie_think" },
    { 0x49621E74, "thief_zombie_victim_disconnect" },
    { 0xFC61BFF8, "thiefgametypefactor" },
    { 0x3C7EBEFC, "thiefstatusmodel" },
    { 0x317EEA63, "thier" },
    { 0x760C3A13, "thigh" },
    { 0x6D7A18E8, "thin" },
    { 0xE0D5CAAA, "thin_out_for_recruit" },
    { 0x0307ED75, "thin_out_friendlies" },
    { 0xBB0F1AFA, "thin_out_ruins_allies_for_wii" },
    { 0x0858A6B7, "thing" },
    { 0x1A7E052C, "thingnotify" },
    { 0xA06945EE, "things" },
    { 0x76FEBFAB, "things_for_fx" },
    { 0x92AFC4CA, "things_to_damage" },
    { 0x24507DD4, "thingy" },
    { 0x403AE9CB, "think" },
    { 0x189E7935, "think_buildables" },
    { 0x0E6D6A7F, "think_craftables" },
    { 0x9796D252, "think_fn" },
    { 0x08810E6C, "think_func" },
    { 0x343580C5, "think_interval" },
    { 0x32403719, "think_time" },
    { 0xF29A3406, "thinker" },
    { 0x8B43178F, "thinkgin" },
    { 0x906F5815, "thinking" },
    { 0xD74D136C, "thinkinterval" },
    { 0x2CFA442A, "thinks" },
    { 0x7C35AA27, "thinksquad" },
    { 0x10AE1289, "thinned" },
    { 0x3597D5D4, "thir" },
    { 0xD9AC65F8, "third" },
    { 0x39A77504, "third_aa_gun_encounter" },
    { 0xC3CCA790, "third_cover" },
    { 0x6142BA2B, "third_cover_reznov" },
    { 0x6E2F27F1, "third_cover_vignette" },
    { 0xEE2D64E4, "third_enemyattack_thread" },
    { 0xCCE0D556, "third_fight_counter" },
    { 0x31C6CF62, "third_flashback" },
    { 0xFA489280, "third_guy" },
    { 0x935B9CAB, "third_guys" },
    { 0x17189893, "third_heli_hide_event" },
    { 0x0AE265D2, "third_ledge" },
    { 0xDEA3D5BE, "third_limp_point" },
    { 0xBEFB75A4, "third_notify" },
    { 0x2493DC50, "third_person" },
    { 0x9D3D3D3C, "third_person_notify" },
    { 0xC732917E, "third_person_weapon_upgrade" },
    { 0xB011F332, "third_read_trigger" },
    { 0x3D73BADF, "third_shot" },
    { 0xB3CAE928, "third_target" },
    { 0x70E3245B, "third_tier" },
    { 0xD9CF8197, "third_timeout_fail" },
    { 0x49249E0C, "thirdpointpulseside" },
    { 0x34E2E853, "thirds" },
    { 0x771D29FB, "thirdsize" },
    { 0x4A691EAA, "thirdtitle" },
    { 0x08D269E9, "thirty" },
    { 0x5B9A503D, "this" },
    { 0xA2629E8E, "this_anim_length" },
    { 0x626E353C, "this_guy_going_towards_stairs" },
    { 0x35210CA4, "this_way_trigger" },
    { 0x0AEAEAB2, "thisangle" },
    { 0x4B58E3DE, "thisconvo" },
    { 0xF3722E31, "thisdest" },
    { 0x8FC9EC6A, "thisdir" },
    { 0x3BA8213D, "thisdist" },
    { 0x7A7378DA, "thisdudepointed" },
    { 0xCD0EE395, "thisentrynum" },
    { 0x24C1EA9E, "thisguy" },
    { 0x1DEC5FBA, "thisnodepose" },
    { 0xF0B90D86, "thisnotifynum" },
    { 0x6BD7AE5C, "thisoffset" },
    { 0x6316E633, "thisorigin" },
    { 0x34B068CD, "thisplayerisinlaststand" },
    { 0x759D697D, "thispos" },
    { 0xAC42AC77, "thisradius" },
    { 0x2B52AF3D, "thisrotspeed" },
    { 0xD47C0B65, "thisspawnid" },
    { 0x4C83191D, "thisstartorigin" },
    { 0x19C8B6BF, "thistraceto" },
    { 0x56EFD884, "tho" },
    { 0x9809BE55, "thompson" },
    { 0x2416AAA2, "thompson_ammo" },
    { 0xF08C83F4, "thorn" },
    { 0x0B2E8A1B, "thorough" },
    { 0xD4D71768, "those" },
    { 0xB4C403F5, "thottle" },
    { 0xFE1E7DFC, "though" },
    { 0x4EBCAAE0, "thought" },
    { 0x6948BC60, "thourought" },
    { 0x41060183, "thousand" },
    { 0xE4FFE7F2, "thousands" },
    { 0x7523E321, "thr" },
    { 0x4368586A, "thrasher" },
    { 0xA9E40513, "thrasher_berserk_cf" },
    { 0xC16766D8, "thrasher_berserk_cf_berserk" },
    { 0xCDB58866, "thrasher_berserk_cf_bits" },
    { 0x6AB1654B, "thrasher_berserk_cf_normal" },
    { 0x9C53C84E, "thrasher_berserk_cf_type" },
    { 0xD21CC5B4, "thrasher_berserk_eye_fx" },
    { 0x6F40B40D, "thrasher_berserk_eye_fx_file" },
    { 0x3F73F25B, "thrasher_berserk_fx1" },
    { 0xEDDAA55C, "thrasher_berserk_fx1_file" },
    { 0x1FF0D57E, "thrasher_berserk_fx1_tag" },
    { 0xCD6C8320, "thrasher_berserk_fx2" },
    { 0x19C3CD51, "thrasher_berserk_fx2_file" },
    { 0x68823811, "thrasher_berserk_fx2_tag" },
    { 0xF36EFD89, "thrasher_berserk_fx3" },
    { 0x314D06D6, "thrasher_berserk_fx3_file" },
    { 0xBCF43B24, "thrasher_berserk_fx3_tag" },
    { 0x97635C37, "thrasher_consume_cooldown" },
    { 0xE279ECDC, "thrasher_consume_dist" },
    { 0xE9F175AF, "thrasher_consume_dist_sq" },
    { 0x7B638616, "thrasher_consume_max" },
    { 0xF660B91B, "thrasher_consume_player_distance" },
    { 0xAFEA2844, "thrasher_consume_zombie_height" },
    { 0xF6474174, "thrasher_consume_zombie_max_dist" },
    { 0xFE391FA6, "thrasher_consume_zombie_min_dist" },
    { 0x52ACC822, "thrasher_consumed_player_fx" },
    { 0x91F818DF, "thrasher_consumed_player_fx_file" },
    { 0x7B1FDCB4, "thrasher_consumed_player_postfx" },
    { 0x3594281D, "thrasher_consumed_player_visionset_alias" },
    { 0x7A596ED1, "thrasher_consumed_player_visionset_file" },
    { 0x5FB5D435, "thrasher_consumed_player_visionset_lerp_step_count" },
    { 0xDDB04703, "thrasher_consumed_player_visionset_priority" },
    { 0xE8D34326, "thrasher_consumed_player_visionset_ramp_in_duration" },
    { 0x608CF5D6, "thrasher_early_round_health_multiplier" },
    { 0x48146AFD, "thrasher_eye_fx" },
    { 0xAFD14892, "thrasher_eye_fx_file" },
    { 0x1358648D, "thrasher_eye_tag" },
    { 0xFCC6A11B, "thrasher_footstep_earthquake_max_radius" },
    { 0x0759DAA4, "thrasher_footstep_fx" },
    { 0xD896F03D, "thrasher_footstep_fx_file" },
    { 0xB225578A, "thrasher_freed_safety" },
    { 0x53EE5568, "thrasher_head_health" },
    { 0x449DE79D, "thrasher_head_hitloc" },
    { 0xAFD21FBE, "thrasher_head_tag" },
    { 0x47C33EEC, "thrasher_laststand_safety" },
    { 0xF7F4BEE5, "thrasher_late_round_health_multiplier" },
    { 0x806C01E6, "thrasher_melee_dist" },
    { 0x8BEEE815, "thrasher_melee_dist_sq" },
    { 0x2832C2C0, "thrasher_melee_enraged" },
    { 0xF92F6F15, "thrasher_melee_knockdown_function" },
    { 0xC519DFD3, "thrasher_melee_yaw" },
    { 0xA5B0445A, "thrasher_mouth_cf" },
    { 0x255C1BF5, "thrasher_mouth_cf_bits" },
    { 0xA0EBC16B, "thrasher_mouth_cf_close" },
    { 0xEF3E9650, "thrasher_mouth_cf_delete" },
    { 0x772FD5AB, "thrasher_mouth_cf_idle" },
    { 0x33B75BCD, "thrasher_mouth_cf_open" },
    { 0xD304A891, "thrasher_mouth_cf_type" },
    { 0xBEE0B9CD, "thrasher_mouth_close_anim" },
    { 0xCCEBEA45, "thrasher_mouth_idle_anim" },
    { 0x2B205883, "thrasher_mouth_open_anim" },
    { 0xA60731C3, "thrasher_navmesh_boundary_dist" },
    { 0x6F64ADE8, "thrasher_navmesh_radius" },
    { 0xF02D211C, "thrasher_pustule_health" },
    { 0x59CFE1A6, "thrasher_pustule_health_multiplier" },
    { 0x6D1A9D4C, "thrasher_rage_auto" },
    { 0x7B7C3A56, "thrasher_rage_auto_multiplier" },
    { 0xB5FF5767, "thrasher_rage_health_bonus" },
    { 0x23131A70, "thrasher_rage_inc_headshot" },
    { 0xAEBD63BA, "thrasher_rage_inc_ingest_player" },
    { 0x552818BF, "thrasher_rage_inc_ingest_zombie" },
    { 0xE35B4137, "thrasher_rage_inc_nonvital" },
    { 0x8FB26D7E, "thrasher_rage_inc_pustule" },
    { 0xB52CF994, "thrasher_rage_invulnerable_time" },
    { 0x0D413A96, "thrasher_rage_threshold" },
    { 0xB002BC46, "thrasher_rumble_cooldown" },
    { 0x93DA56DA, "thrasher_speed" },
    { 0x472267DD, "thrasher_spike_count" },
    { 0xA656A636, "thrasher_spore_back" },
    { 0x3CB3FB44, "thrasher_spore_cf" },
    { 0xAFC50C5F, "thrasher_spore_cf_bits" },
    { 0x5979DFAF, "thrasher_spore_cf_spore1" },
    { 0xE7727074, "thrasher_spore_cf_spore2" },
    { 0x0D74EADD, "thrasher_spore_cf_spore3" },
    { 0x8CD6509D, "thrasher_spore_cf_spores" },
    { 0x4CFB9EB3, "thrasher_spore_cf_type" },
    { 0xF3666932, "thrasher_spore_chest" },
    { 0x27352279, "thrasher_spore_cloud_convert_chance" },
    { 0x6556BD8C, "thrasher_spore_cloud_evaluate" },
    { 0x238D669F, "thrasher_spore_cloud_lrg_fx" },
    { 0xED5DA138, "thrasher_spore_cloud_lrg_fx_file" },
    { 0xC9E4DD91, "thrasher_spore_cloud_max_convert" },
    { 0xD83695EB, "thrasher_spore_cloud_md_fx" },
    { 0x87B4516C, "thrasher_spore_cloud_md_fx_file" },
    { 0xDF00C943, "thrasher_spore_cloud_radius" },
    { 0xA3EE05DC, "thrasher_spore_cloud_round_max_convert" },
    { 0x0D8A1FA2, "thrasher_spore_cloud_sm_fx" },
    { 0x60563F5F, "thrasher_spore_cloud_sm_fx_file" },
    { 0xE30451EE, "thrasher_spore_cloud_time" },
    { 0xAFB33FB2, "thrasher_spore_damage_dists" },
    { 0x703257A9, "thrasher_spore_destroy_fx1" },
    { 0x03CC6B36, "thrasher_spore_destroy_fx1_file" },
    { 0x9634D212, "thrasher_spore_destroy_fx2" },
    { 0xC7D8C04F, "thrasher_spore_destroy_fx2_file" },
    { 0x73C9714F, "thrasher_spore_impact_cf" },
    { 0x0C43FC8A, "thrasher_spore_impact_cf_bits" },
    { 0x3AAEF85A, "thrasher_spore_impact_cf_type" },
    { 0x7B454B82, "thrasher_spore_impact_fx" },
    { 0xAD60ECFF, "thrasher_spore_impact_fx_file" },
    { 0x4DA404E5, "thrasher_spore_inflate_fx" },
    { 0x7908E39A, "thrasher_spore_inflate_fx_file" },
    { 0xAEAF1CE8, "thrasher_spore_inflate_time" },
    { 0x7B69E625, "thrasher_spore_leg" },
    { 0x3A7ED066, "thrasher_spore_state_destroyed" },
    { 0x36B05C44, "thrasher_spore_state_healthy" },
    { 0x81991493, "thrasher_spores" },
    { 0xB66342E2, "thrasher_stun_health" },
    { 0x4953D92B, "thrasher_stun_time" },
    { 0x31C2497C, "thrasher_teleport_cooldown" },
    { 0x466626C4, "thrasher_teleport_dest_func" },
    { 0x399912FF, "thrasher_teleport_destination_max_radius" },
    { 0xAC6D8178, "thrasher_teleport_destination_safe_radius" },
    { 0xF7B0F49D, "thrasher_teleport_min_distance" },
    { 0x0647509C, "thrasher_teleport_overlap" },
    { 0x1DCC491A, "thrasher_telerpot_min_distance_sq" },
    { 0x7F259F06, "thrasher_total_health" },
    { 0x24168E35, "thrasherambientfx1" },
    { 0x4A19089E, "thrasherambientfx2" },
    { 0x701B8307, "thrasherambientfx3" },
    { 0x67A1573A, "thrasherattackableobjectcallback" },
    { 0x57D6D5C4, "thrasherattackableobjectservice" },
    { 0xDFFBDCC8, "thrasherbehavior" },
    { 0xD5C67375, "thrasherberserkmode" },
    { 0x8259F2C4, "thrashercanberevived" },
    { 0x0FC6AA17, "thrashercanconsumecallback" },
    { 0x61D546F4, "thrashercanconsumeplayercallback" },
    { 0x5A5190CC, "thrasherclientfields" },
    { 0x4329C852, "thrasherclientutils" },
    { 0x9B2031FC, "thrasherclosestvalidplayer" },
    { 0xE557EA9B, "thrasherconsumecooldown" },
    { 0xA54844B5, "thrasherconsumecount" },
    { 0x9D35623C, "thrasherconsumed" },
    { 0xE4E88C0D, "thrasherconsumedcallback" },
    { 0x9AEE6FEB, "thrasherconsumedplayer" },
    { 0x3A60F862, "thrasherconsumemax" },
    { 0xF8C0F4F7, "thrasherconsumeplayer" },
    { 0xCF9A26C1, "thrasherconsumeplayerscene" },
    { 0xAAAF7923, "thrasherconsumeplayerutil" },
    { 0x394B19EE, "thrasherconsumezombie" },
    { 0xC1F12967, "thrasherconsumezombiecallback" },
    { 0x3C72FF88, "thrashercreateplayerclone" },
    { 0x055EE3AC, "thrasherdamagecallback" },
    { 0x506069F4, "thrasherdeath" },
    { 0x1CE9E0DE, "thrasherdisableeyeglow" },
    { 0x20E3B3F6, "thrashereyeglow" },
    { 0xCFCC93C3, "thrasherfreedtime" },
    { 0x2F3AACF4, "thrasherfxcleanup" },
    { 0x62CAF126, "thrashergetclosestlaststandplayer" },
    { 0x6C2BBF66, "thrashergoberserk" },
    { 0x5B105946, "thrasherhasturnedberserk" },
    { 0x3C98F9FA, "thrasherheadhealth" },
    { 0x6291F979, "thrasherhidefromplayer" },
    { 0xFC5C5AFD, "thrasherhideplayerbody" },
    { 0x1E849801, "thrasherhidepoppedpustules" },
    { 0x7C8ED1A3, "thrasherhidespikes" },
    { 0xA035FF2A, "thrasherinitspores" },
    { 0x66565BBF, "thrasherinterface" },
    { 0x5AAA10F7, "thrasherinvulnerability" },
    { 0x5FEDB470, "thrasherisberserk" },
    { 0x3A5A0044, "thrasherkillthrasheronautorevive" },
    { 0xE4C4FEAB, "thrasherknockdownservice" },
    { 0x6F5ADF20, "thrasherknockdownzombie" },
    { 0x47093284, "thrasherlastconsume" },
    { 0x4B1C8960, "thrasherlastfootstep" },
    { 0x1CB6B10C, "thrasherlastteleporttime" },
    { 0x362E85A0, "thrashermeleehitcallback" },
    { 0x91B1C35D, "thrashermovemodeattributecallback" },
    { 0xF39A7DBC, "thrashermovemodefriendlycallback" },
    { 0xCB3596FD, "thrashernotetrackmelee" },
    { 0x2284C497, "thrasherplayedberserkintro" },
    { 0x49FB81D5, "thrasherplayer" },
    { 0x384A5701, "thrasherplayerdeath" },
    { 0x5BCD6FBB, "thrasherprocessfootstep" },
    { 0xB3800086, "thrasherpustulepopcallback" },
    { 0x978978E9, "thrasherpustules" },
    { 0x1BB31A5A, "thrasherragecount" },
    { 0xE1F82635, "thrasherragelevel" },
    { 0xDB7FF69E, "thrasherrageservice" },
    { 0x5E066A4E, "thrasherreleaseconsumedcallback" },
    { 0x9E2A4FA2, "thrasherreleaseplayer" },
    { 0x15256FF0, "thrasherrestorepustule" },
    { 0x81B7A825, "thrashers" },
    { 0x5D6075C6, "thrasherserverutils" },
    { 0x0B4E95FD, "thrashershouldbestunned" },
    { 0x3BCFDA18, "thrashershouldconsumeplayer" },
    { 0xFDCDD8A5, "thrashershouldconsumezombie" },
    { 0x04FDBF15, "thrashershouldmelee" },
    { 0x56B22ED8, "thrashershouldshowpain" },
    { 0xAB95703E, "thrashershouldteleport" },
    { 0x69262DB7, "thrashershouldteleportcallback" },
    { 0x3D0C02CC, "thrashershouldturnberserk" },
    { 0xEB999617, "thrasherspawn" },
    { 0x44CA600A, "thrasherspawnsetup" },
    { 0xC411135F, "thrashersporedamagecallback" },
    { 0x8DF8CC2D, "thrashersporedamagedists" },
    { 0x015E61DC, "thrashersporeexplode" },
    { 0x4B871D5B, "thrashersporeimpact" },
    { 0x64D28ED0, "thrasherspores" },
    { 0x087D9384, "thrasherstarttraverse" },
    { 0x87097485, "thrasherstarttraversecallback" },
    { 0x1DB90449, "thrasherstopconsumeplayerscene" },
    { 0xEF0082A4, "thrasherstunhealth" },
    { 0x32C6FFCC, "thrasherstuninitialize" },
    { 0xE2DEE6F5, "thrasherstunstarttime" },
    { 0x01D49555, "thrasherstunupdate" },
    { 0xBC6753C6, "thrashertargetservice" },
    { 0x28290043, "thrasherteleport" },
    { 0x5622F976, "thrasherteleportcallback" },
    { 0x3E5B31B1, "thrasherteleportout" },
    { 0x69BA668D, "thrasherterminatetraverse" },
    { 0x8C38EEF8, "thrasherterminatetraversecallback" },
    { 0xAE899104, "thrasherzombieeligibleforknockdown" },
    { 0xB99814CE, "thre" },
    { 0x4A5E6DAD, "thread" },
    { 0x966ECB29, "thread_all" },
    { 0xCE1A87CA, "thread_all_ents" },
    { 0xB675FB35, "thread_bump_trigger" },
    { 0x2DCA7BB0, "thread_endon" },
    { 0xAF7A3E79, "thread_enter_exit_sound" },
    { 0xCAA1E222, "thread_func" },
    { 0xB78C4AAF, "thread_if_defined" },
    { 0x334D80EC, "thread_individually" },
    { 0x397777F2, "thread_line_sound" },
    { 0x32150A3D, "thread_on_assets" },
    { 0x85EDC9FB, "thread_render_screenshot" },
    { 0x7FC98C6D, "thread_running" },
    { 0xB8D1FC44, "thread_sound_trigger" },
    { 0xAA4B7EC2, "thread_static_sound_looper" },
    { 0x1C3E2DA0, "thread_static_sound_random" },
    { 0x5C126F2B, "thread_step_trigger" },
    { 0xCB324EA4, "thread_timed_out" },
    { 0xE62CE9D6, "thread_together" },
    { 0x0D2C3898, "thread_type" },
    { 0x563B368F, "thread_watch_for_damage" },
    { 0xC2321EB2, "thread_watch_for_death" },
    { 0x2714F5DC, "thread_zombie_vox" },
    { 0xD98E3352, "threadbias" },
    { 0x92B3BC97, "threadcqb_stand_signal_move_up" },
    { 0xD4F3BA5A, "threaded" },
    { 0x02D0985B, "threadedrecordplayerstats" },
    { 0xF4A329B4, "threadedsetstatlbbyname" },
    { 0xEA3BA4A6, "threadedsetweaponstatbyname" },
    { 0x39557A56, "threadedupdatehudicons" },
    { 0x812055BC, "threader" },
    { 0xEB51263B, "threading" },
    { 0x920A4235, "threadnotifyconnections" },
    { 0xADC6DEAC, "threads" },
    { 0x5250CAF3, "threadtospawn" },
    { 0xAA86143D, "threat" },
    { 0x84541587, "threat_bias_add" },
    { 0xCF79A323, "threat_bias_group" },
    { 0x572B71F2, "threat_bias_set" },
    { 0xE76A801A, "threat_dead" },
    { 0x226B51D2, "threat_detector" },
    { 0xA7104BAD, "threat_group_setter" },
    { 0x9C7772A6, "threat_ignore" },
    { 0x05822520, "threat_is_ai_tank" },
    { 0xCF5BABF2, "threat_is_alive" },
    { 0x0B6CE5AB, "threat_is_dog" },
    { 0x94634955, "threat_is_equipment" },
    { 0x14280E80, "threat_is_player" },
    { 0xB1600E34, "threat_is_qrdrone" },
    { 0xF93B6195, "threat_is_turret" },
    { 0x69FA4A45, "threat_is_warthog" },
    { 0x252E5E7F, "threat_requires_launcher" },
    { 0xE1486073, "threat_requires_rocket" },
    { 0x527D17DA, "threat_should_ignore" },
    { 0xE891AB0F, "threat_switch_weapon" },
    { 0x522F91C8, "threat_type" },
    { 0x306E0DB6, "threat_using_riotshield" },
    { 0xE157F4F6, "threat_visible" },
    { 0xAD12F93D, "threatangles" },
    { 0xD28AE602, "threatbias" },
    { 0x1A9DC306, "threatbias_debug" },
    { 0x4D8A2E29, "threatbias_lower_trigger" },
    { 0xA70847A0, "threatbias_lower_triggers" },
    { 0xD74E4635, "threatbias_normal_trigger" },
    { 0x93F75704, "threatbias_normal_triggers" },
    { 0xD1A49F79, "threatbiasgroiups" },
    { 0x71DA87EB, "threatbiasgroup" },
    { 0x94AC3E23, "threatbiasgroupexists" },
    { 0x00B7D886, "threatbiasgroupname" },
    { 0xEBDECACA, "threatbiasgroups" },
    { 0xEEE03DF4, "threatdetectordestroyed" },
    { 0x3C98BCD9, "threatdetectorradius" },
    { 0x5AAADAEF, "threatdetectorradiussqrd" },
    { 0x980AC8E6, "threatdialogkey" },
    { 0xA0E8586A, "threatdir" },
    { 0x1E32D838, "threatdistance" },
    { 0xDBB0F1ED, "threatdistsq" },
    { 0x60C9FA45, "threatdog" },
    { 0x9CF333A4, "threatemplacement" },
    { 0xE8453DD0, "threaten" },
    { 0x56E852CB, "threaten_roof_claw_for_time" },
    { 0xEC5DBC63, "threatened" },
    { 0x7F1A3FC8, "threatening" },
    { 0x6BF4AA24, "threatent" },
    { 0x9FEFEDE2, "threatgroup" },
    { 0x9799D786, "threatid" },
    { 0xDE30D58E, "threatinfantry" },
    { 0x436B9556, "threatinfantrycontact" },
    { 0xE0BEC6AA, "threatinfantryexposed" },
    { 0x21F9CB22, "threatinfantrymg" },
    { 0x3DF97277, "threatinfantryrpg" },
    { 0xFF7287D3, "threatinfantrysniper" },
    { 0x02F5223D, "threatlevel" },
    { 0x4825107A, "threatonkill" },
    { 0xE18736A3, "threatradiusmax" },
    { 0x0253386F, "threatradiusmaxsq" },
    { 0xA4232B8D, "threatradiusmin" },
    { 0x982D2ABD, "threatradiusminsq" },
    { 0x5B442BFC, "threats" },
    { 0x86242A0B, "threattracker" },
    { 0x47B12F75, "threattype" },
    { 0x17353E72, "threatval" },
    { 0x76C47177, "three" },
    { 0x668739FE, "three_ai_hit_by_mortar_beartrap_explosion" },
    { 0x4A4450E8, "three_attachment_perc" },
    { 0x1F90ECD5, "three_jet_squadron" },
    { 0xA8647007, "three_lines" },
    { 0x0537A43E, "three_player_coopenemyaccuracyscalar" },
    { 0xF071ABBD, "three_player_coopfriendlyaccuracyscalar" },
    { 0x7C84DAA9, "three_player_coopfriendlythreatbiasscalar" },
    { 0x520C9B29, "three_player_coopplayerdifficultyhealth" },
    { 0xC2C11E27, "three_player_deathinvulnerabletimemodifier" },
    { 0xF2F8B9AA, "three_player_enemy_pain_chance_modifier" },
    { 0xB23AEDB1, "three_player_hit_invulnerability_modifier" },
    { 0xBCEF09C7, "three_robot_round" },
    { 0x7E49B357, "three_robot_round_vo" },
    { 0x44A62B2D, "three_scenes" },
    { 0x2D2B258D, "three_team" },
    { 0x9F91944D, "threeprimaries_on" },
    { 0x95697B3B, "thresh" },
    { 0x9B9AFF03, "thresh2" },
    { 0x16FF8561, "threshchecksq" },
    { 0xEBC48C3C, "threshhold" },
    { 0xD25B7C9E, "threshold" },
    { 0x36CB8878, "threshold_distance" },
    { 0x8B2F52FE, "threshold_edge" },
    { 0x23AEC49C, "threshold_exceeded_captures" },
    { 0x6B266F98, "threshold_exceeded_deaths" },
    { 0xBFFAFCA0, "threshold_exceeded_defends" },
    { 0xFEB31B22, "threshold_exceeded_defuses" },
    { 0x303C1972, "threshold_exceeded_join_attempts" },
    { 0x6DD352F4, "threshold_exceeded_kd_ratio" },
    { 0xBE5C6C24, "threshold_exceeded_kills" },
    { 0xD69A3295, "threshold_exceeded_kills_per_min" },
    { 0x31DC1987, "threshold_exceeded_plants" },
    { 0x2F8D9CC1, "threshold_exceeded_score" },
    { 0xA1BAF6D8, "threshold_exceeded_score_per_min" },
    { 0xDA0BF373, "threshold_exceeded_splitscreen" },
    { 0x426910D0, "threshold_exceeded_tactical_insertion_use" },
    { 0xEADCFD77, "threshold_exceeded_total_time_played" },
    { 0x38B6C9A5, "threshold_exceeded_xp" },
    { 0xD8836900, "threshold_to_ground" },
    { 0xA20B2F49, "thresholdexceeded_e" },
    { 0xF68627F0, "thresholdfraction" },
    { 0xBE79A601, "thresholds" },
    { 0x954419FA, "thresholdsq" },
    { 0xF7B27DA7, "threshsq" },
    { 0xCA97D615, "threw" },
    { 0x06DC538B, "threw_grenade_at_enemy" },
    { 0xFC3D92D6, "threw_grenade_at_player" },
    { 0x6810C540, "threwback" },
    { 0x4DE0F235, "threwgrenade" },
    { 0xAD3F2202, "thrid" },
    { 0x0F3B8285, "thrilled" },
    { 0x65FCBF0B, "throat" },
    { 0x33764BA5, "throttle" },
    { 0x6C5C687A, "throttle_ai_keep_time" },
    { 0x74D54863, "throttle_ai_make_room" },
    { 0x0762233F, "throttle_blend_time" },
    { 0x9ABB4EF8, "throttle_bp3_spawn_managers" },
    { 0xABBC9E6C, "throttle_line_b_enemy_spawn" },
    { 0x8707156F, "throttle_shared" },
    { 0x218688A6, "throttleeffect" },
    { 0x91CA4CE3, "throttlefx" },
    { 0x6B672F1F, "throttleinput" },
    { 0x3B0D8102, "throttleleftweight" },
    { 0x00BB78ED, "throttlepercentage" },
    { 0xED57F3B4, "throttlepitchref" },
    { 0xBD8F8ACD, "throttlerightweight" },
    { 0x556B64B4, "throttles" },
    { 0x0FBD0F31, "throttlesmoothing" },
    { 0x0CA06EAB, "throttlesmoothingstart" },
    { 0xDAD2647F, "throttletospeed" },
    { 0x7FC42ED9, "throttleweight" },
    { 0x112B7F70, "throttling" },
    { 0x73405318, "throttling_engine_sounds" },
    { 0x90E53D2C, "through" },
    { 0x7D304258, "throughout" },
    { 0x4BBD46B7, "throughput" },
    { 0xD75DAF2F, "throughs" },
    { 0xCD4C5650, "throught" },
    { 0x032988FA, "throughvec" },
    { 0xBC4DB703, "throw" },
    { 0x1E8168CB, "throw_angle" },
    { 0x49E0A729, "throw_anim" },
    { 0xD1FDB88E, "throw_at_pos" },
    { 0x54DA91F1, "throw_back_anim" },
    { 0x75BF75D0, "throw_boat_driver_on_death" },
    { 0x050A1E58, "throw_buttonpressed" },
    { 0x1729865A, "throw_dist" },
    { 0x3E447F63, "throw_distance" },
    { 0x8C6AFAF6, "throw_done" },
    { 0x5845C048, "throw_down_weapon_done" },
    { 0x523B52A9, "throw_flashbangs" },
    { 0x260B3F43, "throw_force" },
    { 0xF1CA8A9B, "throw_gate_guy" },
    { 0x4263B8BA, "throw_gate_guys" },
    { 0xCB8960F8, "throw_gib" },
    { 0x35207890, "throw_grenade" },
    { 0xE572F558, "throw_grenade_at_player" },
    { 0x63A4A909, "throw_grenade_at_player_trigger" },
    { 0xEC90ADD7, "throw_guy" },
    { 0x0C530DC0, "throw_molotov" },
    { 0x3B98E335, "throw_nade_in_window" },
    { 0x50729ED3, "throw_object" },
    { 0xB7CA5159, "throw_object_with_gravity" },
    { 0x0D65DDF2, "throw_object_with_gravity_for_mortars" },
    { 0xCE010D34, "throw_off_balance" },
    { 0xDDFF6A02, "throw_on_death" },
    { 0x6360BBB7, "throw_smoke_from_pos" },
    { 0xBB2A7676, "throw_tag" },
    { 0x2AABF960, "throw_vec" },
    { 0x453A6F74, "throw_vect" },
    { 0x64D12587, "throw_vel" },
    { 0x4D390303, "throwable" },
    { 0x49A8BBC4, "throwanim" },
    { 0x13A17EA5, "throwanimname" },
    { 0x4B1DF877, "throwanims" },
    { 0x82308C04, "throwat" },
    { 0x259D6CFA, "throwback" },
    { 0x2E8986D9, "throwback_grenade" },
    { 0xDDFC8977, "throwbackgrenadekilledoriginalowner" },
    { 0x33327FDF, "throwbuttonpressed" },
    { 0xB0547FC6, "throwchain" },
    { 0x5596C7C1, "throwclass" },
    { 0x1E40333F, "throwdist" },
    { 0x10A395CB, "throwdistsq" },
    { 0xE9389BB3, "throwdown" },
    { 0x38A0B1FC, "throwdown_weapon_enemy_closeby_distsq" },
    { 0x1B8B9AA7, "throwdownweapon" },
    { 0x84457799, "throwdownweaponfallback" },
    { 0x30892FDE, "thrower" },
    { 0x996AD29D, "thrower_node" },
    { 0x3F2D9F41, "throwers" },
    { 0x946413EB, "throwgrenade" },
    { 0xBA38CC03, "throwgrenadeatenemyasap" },
    { 0x016EA503, "throwgrenadeatenemyasap_combat_utility" },
    { 0x148B8930, "throwgrenadeatplayerasap" },
    { 0xC7FD3932, "throwgrenadeatplayerasap_combat_utility" },
    { 0x16F292B3, "throwgun" },
    { 0x5093E3D3, "throwifpossible" },
    { 0x657B4D5D, "throwing" },
    { 0x856F773A, "throwing_grenade" },
    { 0x90DC42C2, "throwing_tomahawk" },
    { 0x66B1994E, "throwingat" },
    { 0x82EB803D, "throwinggrenade" },
    { 0xC52A7E57, "thrown" },
    { 0x8AC02599, "throwngrenadedudtime" },
    { 0xA1EB189A, "throwngrenadedudtimedvar" },
    { 0x3FC55A71, "throwngrenadedudtimemax" },
    { 0xAD3D38CF, "throwngrenadedudtimemin" },
    { 0x5DBED97B, "thrownode" },
    { 0xFEDB5399, "throworigin" },
    { 0x0F45A002, "throwposition" },
    { 0x76E2A072, "throws" },
    { 0x3EEEBC5B, "throwspot" },
    { 0x604E9F99, "throwstart" },
    { 0xAFDC1DE5, "throwtag" },
    { 0x6AF293F4, "throwtags" },
    { 0xDE01CBCC, "throwtarget" },
    { 0xE01FDF16, "throwtarget_default" },
    { 0x631BF81B, "throwvec" },
    { 0xB93245CC, "throwvel" },
    { 0xDBB065B7, "throwweapon" },
    { 0x4213BD7D, "thrt_inf_notify_distance" },
    { 0x59706E3E, "thru" },
    { 0xE58EE9DF, "thrust_the_spork" },
    { 0x855E862A, "thruster" },
    { 0x420D5A06, "thrusterfxhandle0" },
    { 0x680FD46F, "thrusterfxhandle1" },
    { 0xF6086534, "thrusterfxhandle2" },
    { 0x1C0ADF9D, "thrusterfxhandle3" },
    { 0x170478E5, "thrusters" },
    { 0xA02854E3, "thrusters_on" },
    { 0xC8F7ACD8, "thrustersinited" },
    { 0x215E161E, "thrusts" },
    { 0x1D71536F, "thrws" },
    { 0x4F2168B8, "ths" },
    { 0x74B82F85, "thug" },
    { 0x3D6747A6, "thug1" },
    { 0x75FEC043, "thug1_think" },
    { 0x1764CD3D, "thug2" },
    { 0xA0061B28, "thug2_think" },
    { 0xF16252D4, "thug3" },
    { 0x64023695, "thug3_think" },
    { 0x8C6B8CB3, "thug_1_breach" },
    { 0xE5D083D6, "thug_2_breach" },
    { 0x3CB7FD33, "thug_3" },
    { 0x9B316F96, "thug_3_blood" },
    { 0x61D5B249, "thug_3_breach" },
    { 0xD716C6F4, "thug_4_breach" },
    { 0x7200ED14, "thugs" },
    { 0x663EBB81, "thugs_start" },
    { 0x0D6AA5AA, "thumb_in_ass_dialogue" },
    { 0x8ECF7F15, "thumbstick" },
    { 0x7C6E5D8F, "thumbstick_default" },
    { 0xB3471385, "thumbstick_legacy" },
    { 0x188B496C, "thumbstick_legacysouthpaw" },
    { 0x77DA9831, "thumbstick_southpaw" },
    { 0xAA50DB6D, "thump" },
    { 0x4C0E224D, "thunder" },
    { 0x72E87C68, "thunder_close_sound" },
    { 0x14006D86, "thunder_death" },
    { 0xBE6049BB, "thunder_distant_sound" },
    { 0x93C464EB, "thunder_playsound" },
    { 0xB91BB35F, "thunder_rumble" },
    { 0xEDD25CF2, "thunder_strike_sound" },
    { 0xC2F2C617, "thunder_wall_blast" },
    { 0xE0860FC8, "thunder_wall_blast_fx" },
    { 0x2AF5DDDF, "thunderclose" },
    { 0x116098E8, "thunderdistant" },
    { 0x1F6D8B71, "thundergun" },
    { 0x28BE86FB, "thundergun_affect_ais" },
    { 0x409CB75A, "thundergun_death" },
    { 0x5F92286D, "thundergun_death_effects" },
    { 0x99964C81, "thundergun_debug_print" },
    { 0xF54101E7, "thundergun_devgui_dvar_think" },
    { 0x5BD05B96, "thundergun_disintegrate_func" },
    { 0x8857DDA4, "thundergun_disintegrated_death" },
    { 0x765D8BA4, "thundergun_exists" },
    { 0xD2538434, "thundergun_fired" },
    { 0xB83B9013, "thundergun_fling_enemies" },
    { 0xC8806297, "thundergun_fling_func" },
    { 0x61BF5228, "thundergun_fling_vecs" },
    { 0x952E71EF, "thundergun_fling_zombie" },
    { 0x443CF039, "thundergun_fx_fire" },
    { 0x7FD8CBC5, "thundergun_fx_listener" },
    { 0x966C584F, "thundergun_fx_power_cell" },
    { 0x34B34CBB, "thundergun_get_enemies_in_range" },
    { 0xD4B3693F, "thundergun_gib_enemies" },
    { 0x072AB1A7, "thundergun_gib_refs" },
    { 0x1C1C68F4, "thundergun_handle_pain_notetracks" },
    { 0x22A3C4CD, "thundergun_knockdown_enemies" },
    { 0xE9A339E9, "thundergun_knockdown_func" },
    { 0xF10F6B33, "thundergun_knockdown_gib" },
    { 0x426DA741, "thundergun_knockdown_zombie" },
    { 0xA8785E47, "thundergun_last_knockdown_anim" },
    { 0xB69D791B, "thundergun_network_choke" },
    { 0x9261C3FB, "thundergun_network_choke_count" },
    { 0x45E4E1C8, "thundergun_notetrack_think" },
    { 0xA1EC502A, "thundergun_on_player_connect" },
    { 0x06704A7C, "thundergun_play_fx_power_cell" },
    { 0x55A47C8C, "thundergun_play_power_cell_fx" },
    { 0x85E5339B, "thundergun_power_cell_fx_handles" },
    { 0x20DFB524, "thundergun_sound_thread" },
    { 0xCAEAC7B1, "thundergun_steam_vents" },
    { 0x11C66E2C, "thundersoundemitter" },
    { 0x7C869F51, "thus" },
    { 0x3D769F2B, "thwart" },
    { 0x1E282168, "ti" },
    { 0x35368F3D, "tian" },
    { 0xEE66567A, "tick" },
    { 0x27D7CCCB, "ticker" },
    { 0x73DCC19D, "ticket" },
    { 0xFB982936, "ticking" },
    { 0x7B57C44B, "tickingobject" },
    { 0xD4C4A90B, "tickle" },
    { 0x7EA0B3F5, "ticks" },
    { 0x652F4CD9, "tide" },
    { 0xCD256335, "tidy" },
    { 0x99286508, "tidy_on_deregister" },
    { 0xA775D326, "tidyup" },
    { 0x03B5972A, "tidyup_triggers" },
    { 0x5E4B1365, "tie" },
    { 0x517FC51A, "tie_rope_to_ai_hands" },
    { 0x25E85B9D, "tie_wins" },
    { 0x27F5FAD7, "tiebreaker" },
    { 0xFD74EB7B, "tied" },
    { 0xDB119BEF, "tiedcivilians" },
    { 0x0786445A, "tiem" },
    { 0xA9A186DD, "tier" },
    { 0x73D3BE38, "tier1robots_" },
    { 0xD00DAB6D, "tier2robots_" },
    { 0x75841262, "tier3robots_" },
    { 0x7FA410E1, "tier_1_magic_teleport" },
    { 0x5883CEBC, "tier_2_teleport" },
    { 0xEA3018EF, "tier_3_teleport" },
    { 0x6452FE53, "tiercheck" },
    { 0xFACBB68A, "tiered" },
    { 0x2E078826, "tierid" },
    { 0xBDD82C24, "tiername" },
    { 0xD131ADB7, "tiernum" },
    { 0x6A8F7645, "tieronespawner" },
    { 0x1418381C, "tiers" },
    { 0xC370F35E, "tierspawners" },
    { 0x2360E0B5, "tierthreespawner" },
    { 0x5A83A35F, "tiertwospawner" },
    { 0x839F0C74, "ties" },
    { 0xCCC3119A, "tiger" },
    { 0xA28CEB88, "tiger_headlights_on" },
    { 0x97E4B3CA, "tiger_in_loop_flag" },
    { 0x60F7D9B2, "tiger_owner" },
    { 0xF719A36E, "tiger_retreat" },
    { 0xB26AE53E, "tiger_stop_on_node" },
    { 0x8A035955, "tiger_tank" },
    { 0x8B78862B, "tiger_tank_crew" },
    { 0x2B39E195, "tigers" },
    { 0xDED9488B, "tigger" },
    { 0x2E77E681, "tigger_bomb_exploders" },
    { 0x2D3D4DC3, "tight" },
    { 0x6AC64842, "tighten" },
    { 0x75EE8657, "tighten_up_color_chains" },
    { 0xD2BC5E9E, "tighter" },
    { 0x85F728EE, "tightly" },
    { 0x3EDA3CD7, "tigr" },
    { 0x2D973639, "tigr_attack_dialog" },
    { 0x962D5679, "tii" },
    { 0x0834C5B4, "til" },
    { 0xEC1DE3C1, "tile" },
    { 0x9C86522B, "tile_broke_01" },
    { 0x50815D59, "tile_broke_03" },
    { 0x0E8DC166, "tile_broke_04" },
    { 0xDAE15DC9, "tile_whole_01" },
    { 0x00E3D832, "tile_whole_02" },
    { 0x7769A05E, "tilecount" },
    { 0xE18F25E8, "tiles" },
    { 0x11E0B700, "tiles_fall" },
    { 0x0A32E8A4, "tiles_stairs_start" },
    { 0x96079610, "till" },
    { 0x65F3C2C8, "tilt" },
    { 0x6B5A1C2B, "tilt_20_degrees" },
    { 0xAF60BAE4, "tilt_30_degrees" },
    { 0xF5FEC101, "tilt_40_degrees" },
    { 0x8C6B8BE8, "tilt_on_water" },
    { 0x6F38DF43, "tilt_point" },
    { 0xD9AA4057, "tilt_z" },
    { 0xBAB2EAD0, "tiltamnt" },
    { 0xAA09B9DB, "tilted" },
    { 0x322E5A10, "tilting" },
    { 0x998950E3, "tilts" },
    { 0x60DB70FA, "time" },
    { 0xD39A801E, "time0" },
    { 0xF99CFA87, "time1" },
    { 0x87958B4C, "time2" },
    { 0xD25E607E, "time2_array" },
    { 0xAD9805B5, "time3" },
    { 0xB191BB81, "time_1_to_2" },
    { 0x8BB05A8D, "time_2_to_3" },
    { 0xA672F488, "time_3_to_1" },
    { 0x3766E4AD, "time_ads" },
    { 0xE38AA81B, "time_aim_correct" },
    { 0xA5EA18F0, "time_aim_interval" },
    { 0x3F838E4C, "time_alive" },
    { 0x52612B98, "time_array" },
    { 0x4AB401A1, "time_before_accurate" },
    { 0x7998C19C, "time_before_fade_out" },
    { 0x76DF34A2, "time_before_regen" },
    { 0x67FB1325, "time_before_wave_start" },
    { 0x028F0060, "time_between_bursts_max" },
    { 0xAFB7919E, "time_between_bursts_min" },
    { 0x1486C59C, "time_between_dialogue" },
    { 0x6AEDC0FA, "time_between_flames" },
    { 0xF9AF6287, "time_between_lines" },
    { 0xBC54A645, "time_between_rockets" },
    { 0xD66EF625, "time_between_shots" },
    { 0x29277F66, "time_between_switching_speed" },
    { 0x74EF549E, "time_between_turns" },
    { 0xDEFE663F, "time_between_warps" },
    { 0xBCD9C6D7, "time_bomb_add_custom_func_global_restore" },
    { 0xA7EE4C64, "time_bomb_add_custom_func_global_save" },
    { 0xCA4AEC37, "time_bomb_clears_global_data" },
    { 0x3D86FD35, "time_bomb_clears_player_data" },
    { 0x9DBB695D, "time_bomb_custom_actor_speedup_func" },
    { 0x5F3CADA2, "time_bomb_custom_get_enemy_func" },
    { 0x655ECE7F, "time_bomb_custom_round_change" },
    { 0x45C81EFE, "time_bomb_destroy_hud_elem" },
    { 0x08FB98D3, "time_bomb_detonation_complete" },
    { 0x237362D3, "time_bomb_detonation_vo" },
    { 0x392A8B95, "time_bomb_detonator_only" },
    { 0xE20EF9EB, "time_bomb_enemy_respawn_failsafe" },
    { 0xBE7501F3, "time_bomb_get_enemy_array" },
    { 0xC7CD5909, "time_bomb_ghost_respawn_think" },
    { 0x865D291E, "time_bomb_global_data_restore_ghosts" },
    { 0x9DE1B77A, "time_bomb_global_data_restore_sloth" },
    { 0x0FE0010F, "time_bomb_global_data_save_ghosts" },
    { 0x691106BD, "time_bomb_global_data_save_sloth" },
    { 0x5CF55DF9, "time_bomb_held" },
    { 0x15E30AD4, "time_bomb_hints_shown" },
    { 0x3BBDE727, "time_bomb_hud_icon_show" },
    { 0x6C8953B2, "time_bomb_inventory_slot_think" },
    { 0x3BE5058B, "time_bomb_model" },
    { 0xA0080258, "time_bomb_model_init" },
    { 0x41B434F3, "time_bomb_overlay_deactivated" },
    { 0x5BEA75CF, "time_bomb_overlay_lerp_thread" },
    { 0xA28AA46F, "time_bomb_post_init" },
    { 0xEA3FB16B, "time_bomb_post_traverse" },
    { 0x437DC0B4, "time_bomb_pre_traverse" },
    { 0x8AD6DE9F, "time_bomb_precache" },
    { 0xE49ACA9A, "time_bomb_respawns_ghosts" },
    { 0xB6166DFB, "time_bomb_respawns_zombies" },
    { 0x734D9C4F, "time_bomb_restore_active" },
    { 0x74551479, "time_bomb_restored_data" },
    { 0x1F706B24, "time_bomb_restored_into_current_round" },
    { 0x647C1B00, "time_bomb_restores_global_data" },
    { 0xC0F4660A, "time_bomb_restores_player_data" },
    { 0x24848EEC, "time_bomb_restores_saved_data" },
    { 0xAFAA8CCF, "time_bomb_restores_wisp_state" },
    { 0x3A0A8E9B, "time_bomb_round_change" },
    { 0x8979185C, "time_bomb_round_wait" },
    { 0xD48ED147, "time_bomb_round_wait_done" },
    { 0x0A5B7BC6, "time_bomb_save_data" },
    { 0x8ABDDFEE, "time_bomb_save_exists" },
    { 0x013E0441, "time_bomb_saves_data" },
    { 0x45AFD3AF, "time_bomb_saves_global_data" },
    { 0x92E3A89D, "time_bomb_saves_player_data" },
    { 0xAB73D9CE, "time_bomb_saves_wisp_state" },
    { 0x9205363E, "time_bomb_saves_zombie_data" },
    { 0x8618F8B6, "time_bomb_spawn_func" },
    { 0x2BA18099, "time_bomb_stop_slow_all_actors" },
    { 0xB94AAA63, "time_bomb_takeaway" },
    { 0x02E6C3AC, "time_bomb_test_mode_end" },
    { 0x903C4247, "time_bomb_test_mode_start" },
    { 0x4FD147E4, "time_bomb_think" },
    { 0x022FCB80, "time_bomb_thrown_vo" },
    { 0xC38A164E, "time_bomb_whiteout_hudelem" },
    { 0x1376AD11, "time_bonus_iterations" },
    { 0x4BC8032F, "time_check" },
    { 0xC93ADBF6, "time_color" },
    { 0xF6903BE9, "time_colors" },
    { 0x64963BBE, "time_countdown" },
    { 0x4B231DE4, "time_countdown_delete" },
    { 0x862B0FFF, "time_counter" },
    { 0x1B0293A6, "time_delay" },
    { 0x0E08B2DE, "time_destroyed" },
    { 0x13AE6030, "time_diff" },
    { 0x8B66E113, "time_elapsed" },
    { 0x61BD9F53, "time_fired" },
    { 0x6212F7D8, "time_firing" },
    { 0xE2A37963, "time_first_sight" },
    { 0x115025B7, "time_for_left_ladder_climb" },
    { 0x649D5D65, "time_for_moveto" },
    { 0x8E22091D, "time_for_plane_crash" },
    { 0xCF40B0A2, "time_for_player_to_get_in_house" },
    { 0xCE659B10, "time_for_quad_wave" },
    { 0xE3A5A00A, "time_for_right_ladder_climb" },
    { 0x5DBE094D, "time_high" },
    { 0xEE44DA0C, "time_hit" },
    { 0x8AE32044, "time_in_half" },
    { 0x5268EE68, "time_in_low_gravity" },
    { 0xE65455E6, "time_in_seconds" },
    { 0x508F5BFD, "time_in_trigger_untill_friendlies_become_vulnerable" },
    { 0xE99C7EFB, "time_inc" },
    { 0x13F3C2A0, "time_increment" },
    { 0x3F699A6B, "time_index" },
    { 0x65C631AE, "time_interval" },
    { 0x5A0D8DBB, "time_last_hit" },
    { 0x4F504A58, "time_last_spoke_attack_line" },
    { 0x7114F241, "time_last_spoke_killed_line" },
    { 0xA52EA2C3, "time_last_used" },
    { 0xBBF3195E, "time_left" },
    { 0xEF8EDE73, "time_left_to_collision" },
    { 0x32A668AA, "time_limit" },
    { 0xA2E1EA2B, "time_limit_func" },
    { 0x6591A62A, "time_limited_stage" },
    { 0xC165DB56, "time_looking_at_orb" },
    { 0x3A3B2F39, "time_low" },
    { 0x836F2D41, "time_max" },
    { 0x3097BE7F, "time_min" },
    { 0x4A0A7F08, "time_name" },
    { 0xDBB6144A, "time_notify" },
    { 0xE725D1ED, "time_of_death" },
    { 0x32C4D3EC, "time_of_last_bounce" },
    { 0x473067DF, "time_of_rotation" },
    { 0x15D777C0, "time_offset" },
    { 0xAB243266, "time_on_china" },
    { 0x4F78FE35, "time_on_mg" },
    { 0x637BFF16, "time_or_notify" },
    { 0xDB02E37F, "time_out" },
    { 0xD5103D9A, "time_out_check" },
    { 0xCF01A55F, "time_out_of_range" },
    { 0x4EF0A605, "time_out_or_perk_grab" },
    { 0xA8D9435A, "time_outside" },
    { 0x33D5704F, "time_outside_arena_start" },
    { 0xBD547643, "time_over" },
    { 0xDF334595, "time_passed" },
    { 0xCD537CEA, "time_passes" },
    { 0x83495809, "time_per_stage" },
    { 0x29D93E60, "time_played" },
    { 0x3B4403E2, "time_ratio" },
    { 0x8A11CB72, "time_recent_sight" },
    { 0x03CAFF27, "time_rem" },
    { 0xF2DCC197, "time_remaining" },
    { 0x7FF9B435, "time_remaining_on_point_doubler_powerup" },
    { 0xDD294084, "time_remaining_on_powerup" },
    { 0x4217FC1F, "time_remaining_pers_upgrade" },
    { 0xA7BAD388, "time_remaning_on_insta_kill_powerup" },
    { 0xCF34D4ED, "time_required_to_defend" },
    { 0x739E314A, "time_required_to_dominate" },
    { 0x0BA32CAC, "time_required_to_dominate2x" },
    { 0x480FE9CE, "time_required_to_protect" },
    { 0x7DBE817B, "time_return_val" },
    { 0x645D407B, "time_runner" },
    { 0xE0BC29E0, "time_s" },
    { 0x2B3E7971, "time_scale" },
    { 0x92E71943, "time_scale_machine" },
    { 0x4BECF730, "time_scale_machine_restore" },
    { 0xE1A88593, "time_scale_range" },
    { 0xA6723D4A, "time_scale_step" },
    { 0x578DF741, "time_scaler" },
    { 0x82FDD868, "time_scalers" },
    { 0x53204EDC, "time_sec" },
    { 0x66D9F360, "time_seen" },
    { 0xD560AB08, "time_since_fire" },
    { 0xA371FEB6, "time_since_last_adjust" },
    { 0x86169D2F, "time_since_last_crack" },
    { 0xF786BA94, "time_since_last_damage" },
    { 0xE5FBB4B8, "time_since_last_damaged" },
    { 0x1EA8F20C, "time_since_last_movement" },
    { 0x1219CEFE, "time_since_last_teleport" },
    { 0x434796A4, "time_since_last_timeout" },
    { 0x7D245358, "time_since_warning" },
    { 0xA6E1F5C6, "time_slo_car_in" },
    { 0x0C852121, "time_slo_car_out" },
    { 0x077F7B65, "time_slo_ent" },
    { 0xAD6A3702, "time_slo_reverb" },
    { 0x2633503D, "time_slo_slide" },
    { 0xBD7365FE, "time_slo_super_jump" },
    { 0x7838AD4D, "time_slo_super_jump_reverb" },
    { 0x432FF049, "time_slo_van" },
    { 0xBA901440, "time_slo_van_reverb" },
    { 0xBFD738E9, "time_so_far" },
    { 0x36FA4CB9, "time_standing" },
    { 0x26BBD4A8, "time_started" },
    { 0x36A7D8E8, "time_started_shooting" },
    { 0xFE43FC3F, "time_stationary" },
    { 0x918D4463, "time_step" },
    { 0xDFEAF37E, "time_str" },
    { 0x97297083, "time_thrown" },
    { 0xD5E40180, "time_til_damage" },
    { 0xE4E09D69, "time_till_bite" },
    { 0x1112B648, "time_till_next_group" },
    { 0x1B1E9D22, "time_to_add" },
    { 0x5B74C5B2, "time_to_apply_vision" },
    { 0xB58ADE1F, "time_to_choose_fate" },
    { 0xD7C455EF, "time_to_collision" },
    { 0x467C2DC5, "time_to_death" },
    { 0x5E857E1F, "time_to_death_default" },
    { 0x934B9E1E, "time_to_death_jug" },
    { 0x0E1B8890, "time_to_delete_or_notify" },
    { 0x72F8D61B, "time_to_enemy" },
    { 0x9178BADC, "time_to_escape" },
    { 0x543243A3, "time_to_fall_down_stage1" },
    { 0xE22AD468, "time_to_fall_down_stage2" },
    { 0x2FF1DE06, "time_to_fire_death" },
    { 0xA7E8DA8A, "time_to_get_to_log" },
    { 0xB4ECBF81, "time_to_help_them" },
    { 0xE3DC5B2C, "time_to_hit" },
    { 0xBE6EEA8A, "time_to_land" },
    { 0x3558C102, "time_to_leave" },
    { 0x7906AE61, "time_to_max" },
    { 0xC733F68E, "time_to_move" },
    { 0xFB08474E, "time_to_move_on" },
    { 0x0D55BB3E, "time_to_move_up" },
    { 0xD2A399CB, "time_to_play" },
    { 0x06C6BAF4, "time_to_pulse" },
    { 0xF4F5D5FA, "time_to_race" },
    { 0xF9092F1D, "time_to_rappel" },
    { 0xDAE6B1FA, "time_to_redact" },
    { 0x174D888D, "time_to_remove" },
    { 0xDD28BFD8, "time_to_remove_vision" },
    { 0x8D869457, "time_to_report" },
    { 0x88128C9F, "time_to_ressess" },
    { 0x8B2DECA0, "time_to_resume_anim" },
    { 0x96D24D56, "time_to_rotate_to_side" },
    { 0x5428CFF6, "time_to_rumble" },
    { 0x9A2D10DC, "time_to_run" },
    { 0x54C178DF, "time_to_spawn_new_wave" },
    { 0xF87EC893, "time_to_spawn_panther" },
    { 0x75F4B26D, "time_to_split_up" },
    { 0x0EE6EAA2, "time_to_target" },
    { 0xF9F5B71E, "time_to_wait" },
    { 0x6554F95D, "time_to_wait_after_centering" },
    { 0xC25DC1A3, "time_to_wait_after_turning" },
    { 0xF9B54389, "time_to_wait_before_idle" },
    { 0x560B77F5, "time_travel" },
    { 0xFD717800, "time_travel_vision" },
    { 0xA5023E3E, "time_triggers" },
    { 0x7213AFA0, "time_until_forced_switch" },
    { 0x9DE18EF6, "time_used" },
    { 0x509A9C46, "time_val" },
    { 0x09C50ABB, "time_values" },
    { 0x557FB4C1, "time_waited" },
    { 0xAE7FF757, "time_waited_s" },
    { 0x29F3D8DD, "time_weight" },
    { 0x4F5EA191, "time_window" },
    { 0x7F53D53C, "time_window_check" },
    { 0xEB711895, "timealive" },
    { 0xFBB10A7E, "timealreadypassed" },
    { 0x15F999A3, "timeatchosennode" },
    { 0x30EFF5F9, "timeatnodemax" },
    { 0x3728FD9E, "timeatsameposition" },
    { 0x948D6387, "timeback" },
    { 0x3549FC8D, "timebeforefade" },
    { 0x54836C35, "timebetweenchecks" },
    { 0x0DD316E3, "timebetweencoughs" },
    { 0x8A1D23C5, "timebetweenglances" },
    { 0x2717C91C, "timebetweenhostiledown" },
    { 0xD518B04B, "timebetweenshells" },
    { 0x89E7F6DD, "timebetweenshots" },
    { 0x23F2CD36, "timebetweentransitions" },
    { 0x901E5E56, "timebomb" },
    { 0x267A962A, "timebomb_change_to_round" },
    { 0x726C0693, "timebomb_override_struct" },
    { 0x07B2E1B1, "timebomb_wait_for_hostmigration" },
    { 0xE5A62619, "timecode" },
    { 0xF7EF4179, "timecutoff" },
    { 0x1B19A2CA, "timed" },
    { 0x72701AC8, "timed_collapse" },
    { 0xC5E312F5, "timed_death" },
    { 0xBD9FC7BD, "timed_effects" },
    { 0x615A6064, "timed_event_monitor" },
    { 0xA5AD76A7, "timed_killbrush_in_minecart_area_geyser" },
    { 0x65F568CC, "timed_killbrush_in_start_area_geyser" },
    { 0x3A07502F, "timed_out" },
    { 0xC0D11F19, "timed_out_death_fx_1" },
    { 0x0F37D40C, "timed_out_death_sound_1" },
    { 0xFB81E949, "timed_out_death_tag_1" },
    { 0x0B455418, "timed_stage_10_seconds_to_go" },
    { 0x643B1D89, "timed_stage_25_percent" },
    { 0xC466AFCD, "timed_stage_50_percent" },
    { 0x5102F256, "timed_stage_75_percent" },
    { 0xC72ADC73, "timed_suicide" },
    { 0xF7A9686F, "timedautosavenumber" },
    { 0x8AC3290F, "timedautosaves" },
    { 0xFF921514, "timedautosavethread" },
    { 0x4346609F, "timedautosavetime" },
    { 0x34CE5D03, "timedelay" },
    { 0xD25DB0C6, "timedfunction" },
    { 0x39E0D2EB, "timedfunctionkey" },
    { 0xCDC6DBCA, "timedfunctionkeys" },
    { 0xE8B48C79, "timedfunctions" },
    { 0x6421DC77, "timediff" },
    { 0x60B3EEE1, "timediffsecs" },
    { 0x74C38F81, "timednotify" },
    { 0x21C4DDF6, "timedout" },
    { 0x7DD8EA8C, "timedtargets" },
    { 0xE4E6811A, "timeelapsed" },
    { 0x4272BE3B, "timefactor" },
    { 0xA797FAEE, "timefrac" },
    { 0xC8FF0C86, "timefromstart" },
    { 0x9CA364AD, "timehack" },
    { 0x66BC12DA, "timehigh" },
    { 0x644F139C, "timeignoreonspawn" },
    { 0xDBA3EFF3, "timein" },
    { 0xCBD255A1, "timeinair" },
    { 0x9C648312, "timeinc" },
    { 0xEDACE493, "timeincreasebetweenplanes" },
    { 0x346E6CB6, "timeing" },
    { 0x0157CB7A, "timeinsec" },
    { 0xAE6F4EEA, "timeinseconds" },
    { 0x8AE05E9F, "timekey" },
    { 0x040FC826, "timekeys" },
    { 0xA1B3FA09, "timelapse" },
    { 0x495B737B, "timelapse_end" },
    { 0x885895D1, "timeleft" },
    { 0xF16FCEEC, "timeleftint" },
    { 0x6D251637, "timelimit" },
    { 0xD84E658D, "timelimitcheck" },
    { 0xD0DBFFBF, "timelimitclock" },
    { 0x968AAF56, "timelimitclock_intermission" },
    { 0x9D56FBA0, "timelimitdvar" },
    { 0xD1466C63, "timelimitmax" },
    { 0x93E2614D, "timelimitmin" },
    { 0xEE237F3F, "timelimitoverride" },
    { 0x7FE6281C, "timeline" },
    { 0xB59D4ECC, "timelow" },
    { 0x25B862BE, "timemin" },
    { 0x80E730CA, "timems" },
    { 0x9A879E93, "timenotatgoal" },
    { 0x1D725CE1, "timeofday" },
    { 0x0D222BFB, "timeofdeathmillis" },
    { 0x869FC26B, "timeoffset" },
    { 0xD7372282, "timeofmove" },
    { 0x86219BAE, "timeofspawn" },
    { 0x73BA968E, "timeontarget" },
    { 0x20485390, "timeour" },
    { 0x04573206, "timeout" },
    { 0x1858BFE4, "timeout_alarm" },
    { 0x891F9949, "timeout_beep" },
    { 0x62250D91, "timeout_lerp_thread" },
    { 0x05B5719B, "timeout_lerp_thread_per_player" },
    { 0x019D97E6, "timeout_notify" },
    { 0x7807B1B2, "timeout_reset" },
    { 0xAB396B18, "timeout_then_notify" },
    { 0xB5D5C862, "timeout_time" },
    { 0x0C886B22, "timeout_van_ending" },
    { 0xAE19DE6E, "timeout_warning_vo_complete_" },
    { 0x216243B9, "timeoutcratewaiter" },
    { 0xEB1F527A, "timeoutduration" },
    { 0x0ED44182, "timeoutlength" },
    { 0x64F91574, "timeoutlightsoff" },
    { 0x3CF95F2D, "timeoutobj" },
    { 0xD5B838B9, "timeouts" },
    { 0x00FA1F11, "timeoutstarted" },
    { 0x7730E579, "timeouttime" },
    { 0x976322F1, "timeoutvalue" },
    { 0xAA61E82A, "timepassed" },
    { 0x74DFE6F8, "timepauseswheninzone" },
    { 0x12EF76A1, "timepercentageleft" },
    { 0xDC857E15, "timeperiod" },
    { 0x08DA38E8, "timeperiodsec" },
    { 0x04AF9985, "timeperoneteamkillreduction" },
    { 0xD066F1A3, "timeplayed" },
    { 0x8AF1F136, "timeplayedalive" },
    { 0xA636E0AD, "timeplayedcap" },
    { 0xC4EEA9D1, "timeplayedmoving" },
    { 0x3CE3D4D3, "timeplayedtotal" },
    { 0xC88A6FBC, "timeprintstr" },
    { 0xA52EC96D, "timepulse" },
    { 0x06F6F10C, "timer" },
    { 0x6F395E66, "timer2" },
    { 0x833D72D1, "timer_actual" },
    { 0x3342A0B4, "timer_china" },
    { 0x88BE9D37, "timer_done" },
    { 0x79A25CBA, "timer_expired" },
    { 0xFA7FCD81, "timer_func" },
    { 0x2E5F2BC3, "timer_grace_period" },
    { 0x5237CCAE, "timer_hud" },
    { 0xEC23B7A7, "timer_increment_loop" },
    { 0x9FBC61DF, "timer_max" },
    { 0xF50E39A1, "timer_min" },
    { 0xFB10AE64, "timer_on" },
    { 0x049813B3, "timer_past" },
    { 0x8D82E5BF, "timer_reached" },
    { 0xE091A0E5, "timer_set" },
    { 0x0C0BBF49, "timer_start" },
    { 0x16CF2B5F, "timer_start_time" },
    { 0xBCB369A8, "timer_tick" },
    { 0xC1E71539, "timer_til_despawn" },
    { 0x5F897C00, "timer_update" },
    { 0x551546C4, "timer_wait" },
    { 0x3BA06C0B, "timer_widget" },
    { 0x857AFB5F, "timeratio" },
    { 0x6D425375, "timercountdown" },
    { 0xEC3DF68A, "timercountdowninternal" },
    { 0x5FB4B55E, "timerdisplay" },
    { 0xA817341D, "timerelem" },
    { 0xE661A91A, "timeremaining" },
    { 0xA6AD6B60, "timerfontsize" },
    { 0x5CCDE66C, "timeridstring" },
    { 0x34858BC1, "timerisrunning" },
    { 0x64562418, "timerlength" },
    { 0x60D13215, "timerlimit" },
    { 0xD44E85ED, "timername" },
    { 0x94D6742D, "timeroffset" },
    { 0xC2B2393A, "timerpaused" },
    { 0x77385BC5, "timerpausetime" },
    { 0x149D3E8F, "timers" },
    { 0xBD8A8CF6, "timerstage" },
    { 0x57904613, "timerstarttime" },
    { 0xC8A2359F, "timerstopped" },
    { 0xEF0CD5C0, "timersused" },
    { 0x2117C869, "timertext" },
    { 0x66118D05, "timerypos" },
    { 0x2CF96B75, "times" },
    { 0x5D2D2395, "times_invulnerable" },
    { 0x4CAF3929, "times_moved" },
    { 0x17E5C6EF, "times_searched" },
    { 0xF816143F, "times_squad_has_moved" },
    { 0xD46A3A9C, "times_to_play" },
    { 0x7A0B9CBF, "times_up" },
    { 0xCB1B0C34, "timescale" },
    { 0x30CE20A5, "timescale_changed" },
    { 0xAE7FA663, "timescale_death" },
    { 0xEB83363B, "timescale_duration" },
    { 0x897847B1, "timescale_fadedown" },
    { 0xE89639FE, "timescale_fadeup" },
    { 0x669D4813, "timescale_fail" },
    { 0x4CA203A9, "timescale_fast" },
    { 0x05485526, "timescale_fast_security" },
    { 0x315D9624, "timescale_fuse" },
    { 0x9B44310D, "timescale_glasses" },
    { 0x430DB15C, "timescale_gren_qte" },
    { 0xF8E5F4FB, "timescale_hilltop" },
    { 0x80F0F3F2, "timescale_normal" },
    { 0x59C52E5B, "timescale_normal_pool" },
    { 0x22E8E75A, "timescale_off" },
    { 0xD21267A7, "timescale_over_time" },
    { 0xAD8F924A, "timescale_over_time_done" },
    { 0xFAB505EC, "timescale_success_watch" },
    { 0xC2C69A60, "timescale_tween" },
    { 0x27AABF04, "timescale_vel" },
    { 0x608F52FB, "timescalecurrent" },
    { 0xF1D02B11, "timescalediff" },
    { 0x84851B3F, "timescaleeffect" },
    { 0xC0861727, "timescales" },
    { 0x4FD8154B, "timescaleslow" },
    { 0x9A1617BD, "timescaling" },
    { 0xA6A4BE24, "timescore" },
    { 0x0761BDDD, "timesec" },
    { 0x22E32101, "timeseconds" },
    { 0x9B68B629, "timeshooting" },
    { 0x03932248, "timesince" },
    { 0x16EC1B0F, "timesincedistancecheck" },
    { 0x4254C05B, "timesincelastupdate" },
    { 0x93881D3E, "timesincethrown" },
    { 0x51FE39E4, "timeslice" },
    { 0x506388BE, "timeslo" },
    { 0x5DCD4045, "timeslow" },
    { 0x191D49A8, "timeslow_done" },
    { 0xDA4F8654, "timeslow_reverb" },
    { 0x1B2DDBEC, "timeslow_snd_stop" },
    { 0xCCAA7EFB, "timesofar" },
    { 0x44ED7F0E, "timespent" },
    { 0x28BD3112, "timespentswimminginlife" },
    { 0xD1E84DB8, "timespentwallrunninginlife" },
    { 0x3D1F6454, "timesplayerattackingautomaton" },
    { 0x58E077C7, "timestamp" },
    { 0x89F1B47F, "timestamp_name" },
    { 0x473A9009, "timestamp_name_to" },
    { 0x40EDA5E5, "timestamp_value" },
    { 0xE1AD9348, "timestamplastday1" },
    { 0x35497ABE, "timestamps" },
    { 0x2973F62A, "timestart" },
    { 0xDEB57764, "timestep" },
    { 0xEA5B9F63, "timestr" },
    { 0x3D0D46D3, "timetaken" },
    { 0xFBB7BF07, "timetext" },
    { 0xF83B2C84, "timetillblendout" },
    { 0x05E37668, "timetillendgame" },
    { 0xB63A95D3, "timetilnexttransition" },
    { 0xD7BDBF59, "timeto" },
    { 0x061657EE, "timetodrop" },
    { 0x7FA14AA5, "timetoenforce" },
    { 0x4FA2AD65, "timetofadeout" },
    { 0x5E1BF73C, "timetohit" },
    { 0x313CBC9B, "timetoimpact" },
    { 0x2B514753, "timetokillallscientists" },
    { 0x273F8814, "timetoliveinmillis" },
    { 0xF72C4AFE, "timetomove" },
    { 0x1256FD76, "timetorecord" },
    { 0x5F990DD7, "timetospawngroundguys" },
    { 0x41264B3C, "timetounlink" },
    { 0xF7F9A2EE, "timetowait" },
    { 0x1252B58B, "timetozone" },
    { 0xB20CAAFB, "timetravel_watcher" },
    { 0xCA9FC669, "timeuntilroundend" },
    { 0x8750AAD2, "timeuntilscripteddeath" },
    { 0xCABDC9F7, "timeuntilspawn" },
    { 0xB3B269B0, "timeuntiltheywrap" },
    { 0x0FEBAE56, "timeuntilwavespawn" },
    { 0x3F16CBA5, "timeused" },
    { 0xCDB89949, "timewait" },
    { 0x52FC2E76, "timewaited" },
    { 0x8BD386C6, "timewindow" },
    { 0xBF8B214A, "timiing" },
    { 0xB0EE8E0B, "timing" },
    { 0xBB894743, "timing_thingy" },
    { 0xD903096A, "timings" },
    { 0x37A39233, "timout" },
    { 0xB8AC1F98, "tincan" },
    { 0x79CFEA91, "tincan_think" },
    { 0x6212B973, "tincans" },
    { 0x09966188, "tinhats" },
    { 0xBE1D376F, "tinnitus" },
    { 0xD5617E46, "tint" },
    { 0x25EBA702, "tint_available" },
    { 0x304EDF1B, "tint_cleared" },
    { 0x2D72B496, "tint_failed" },
    { 0x1EADEA74, "tint_type_index" },
    { 0x13E79009, "tint_unavailable" },
    { 0x3CA8A1DA, "tint_val" },
    { 0x99833F4A, "tintamount" },
    { 0xA186EC00, "tintb" },
    { 0x5F93500D, "tintg" },
    { 0x01AE9290, "tintr" },
    { 0x936DE253, "tiny" },
    { 0x401708C8, "tip" },
    { 0x06C1EFB2, "tip_hud" },
    { 0x244DCE28, "tip_string" },
    { 0xA109B6FD, "tip_vehicle" },
    { 0xEB0710E8, "tipbarreldown" },
    { 0x0A6AD3E3, "tipbarrelup" },
    { 0x1A0C2E70, "tipping" },
    { 0xFF1082E3, "tips" },
    { 0xEB82F53B, "tips_seen" },
    { 0x78581753, "tire" },
    { 0x60391AEF, "tire_deflate" },
    { 0x1512019F, "tire_deflater" },
    { 0x018DA3A9, "tire_deflater_interuptable" },
    { 0xA7138C57, "tire_explosion" },
    { 0x41DDF6EE, "tire_explosionmode" },
    { 0xBA97B2DA, "tire_fire" },
    { 0x34F920D3, "tirechange" },
    { 0x3A5585DE, "tirechange_bowman" },
    { 0xD2F66A8E, "tirechange_brooks" },
    { 0x4DD5235F, "tirechange_spetz1" },
    { 0xDBCDB424, "tirechange_spetz2" },
    { 0x70DEE3DA, "tirechanger01" },
    { 0x4ADC6971, "tirechanger02" },
    { 0x9D67542D, "tired" },
    { 0xF2B14C50, "tiredefeffectcount" },
    { 0x3ED726D5, "tireindex" },
    { 0x01222911, "tirelocations" },
    { 0x8B878B82, "tires" },
    { 0x9228EF31, "tires_shot" },
    { 0xD91BEB0D, "tirethreadwatcher" },
    { 0xFC463A25, "tiretrigger" },
    { 0xCC995B4C, "tissue" },
    { 0x6E96A565, "titanic" },
    { 0x9A01E3A6, "titanic_event_animations" },
    { 0x1C7366D9, "titanic_event_boat" },
    { 0x7CB77566, "titanic_event_shrimp" },
    { 0xA9F4C2C5, "title" },
    { 0x4BC31566, "title1" },
    { 0x25C09AFD, "title2" },
    { 0xCB8B3223, "title_override_col" },
    { 0xD7595C6B, "title_screen_snapshot" },
    { 0xA70227A3, "title_update_main_end" },
    { 0x7BEEF190, "title_update_main_start" },
    { 0x1193121A, "titleisstring" },
    { 0xD6AFAE2D, "titlelabel" },
    { 0x7F1F8654, "titles" },
    { 0x7FA9F5FA, "titlesize" },
    { 0xC4A19800, "titletext" },
    { 0x0EE7AF30, "titus" },
    { 0xEAEF4D96, "titus6" },
    { 0x0C792022, "titus_dart_spread" },
    { 0x001E69BE, "titus_dart_spread_veh" },
    { 0x5DC2E714, "titus_fov_angle" },
    { 0xA6EA051F, "titus_tagged" },
    { 0x8E3E67C8, "titus_target_killed" },
    { 0x3A36F130, "titus_target_timeout" },
    { 0xE8784AC2, "titus_valid_dist" },
    { 0xF4CECA9B, "titus_weapon_name" },
    { 0x51BBDA78, "titusmarked" },
    { 0x25D244EC, "tj25" },
    { 0x2E9248E1, "tjanssen" },
    { 0xECE4F666, "tjiong" },
    { 0x6A2D163A, "tk" },
    { 0xD0E5600E, "tkeegan" },
    { 0xDC348575, "tl" },
    { 0x774FEB99, "tlf" },
    { 0x2FC199CA, "tlimptime" },
    { 0xBF4C9227, "tlimptime_accel" },
    { 0x82EB59A5, "tlimptime_deccel" },
    { 0x81614478, "tlo" },
    { 0x56758543, "tloc" },
    { 0x745908DF, "tlvt" },
    { 0xA73D8B19, "tlvt_start_node" },
    { 0xB6320B0C, "tm" },
    { 0x427A912D, "tma" },
    { 0x3ADF6BA6, "tmaxs" },
    { 0x8E482A88, "tmins" },
    { 0x26896FA3, "tmo" },
    { 0x752FADA3, "tmodeclearflag" },
    { 0xCAE0C618, "tmodesetflag" },
    { 0x7C9FBD54, "tmp" },
    { 0x8FAB1D26, "tmp_array" },
    { 0x959A75B5, "tmp_bomb_array" },
    { 0xB6BF308F, "tmp_bottle" },
    { 0x77A9B227, "tmp_detour_node" },
    { 0x6AE8254A, "tmp_ent" },
    { 0x69E0118A, "tmp_model" },
    { 0xD31F6C52, "tmp_offset" },
    { 0xF86D01B1, "tmp_origin" },
    { 0x78EDF6CF, "tmp_point" },
    { 0x2B209FF2, "tmpfacing" },
    { 0x05E8916F, "tmpmsg" },
    { 0xEEA72C8F, "tms" },
    { 0xE495D3B0, "tmt" },
    { 0x0A984E19, "tmu" },
    { 0x28397A47, "tn" },
    { 0xA87AD6CE, "tname" },
    { 0xFA78C30B, "tnode" },
    { 0x3976B509, "tnow" },
    { 0x0236FFDE, "to" },
    { 0xD46AA981, "to3" },
    { 0xBDCB7502, "to_anim" },
    { 0x338A941E, "to_anim_color" },
    { 0x4605B7A5, "to_animation" },
    { 0x961CDBC2, "to_animation_playing" },
    { 0x6E256D51, "to_animcompletioncount" },
    { 0x68D238EE, "to_animtree" },
    { 0x575518F4, "to_attacker" },
    { 0x366FC796, "to_be_continued" },
    { 0xF415FACB, "to_be_removed" },
    { 0xCD08ADBF, "to_cower" },
    { 0x9E6C0AC4, "to_delete" },
    { 0xF4B425A5, "to_door" },
    { 0x244064D7, "to_enemy" },
    { 0x6A3E8BCE, "to_enemy_angles" },
    { 0xE8D480D8, "to_frame_count" },
    { 0xC95643F2, "to_gesture_blend_time" },
    { 0xFFD482B0, "to_goal" },
    { 0xE5007AF0, "to_horse" },
    { 0x34CF5B1A, "to_hours" },
    { 0xF8C92FC5, "to_idle_blend_time" },
    { 0x9E3F9730, "to_ledge" },
    { 0x1A366A08, "to_maze" },
    { 0x86BF16CA, "to_mins" },
    { 0xC508A51E, "to_notify" },
    { 0xDD05A00C, "to_obj" },
    { 0xFA67488C, "to_percent" },
    { 0xBD7630CD, "to_point_dir" },
    { 0xB86F2BD1, "to_radians" },
    { 0xD9EDE473, "to_self" },
    { 0x9044BE00, "to_state" },
    { 0x94778C8A, "to_state_name" },
    { 0x88DE2076, "to_target" },
    { 0x0498090D, "to_taunt_blend_time" },
    { 0xFF02C9FA, "to_the_moon_alice_trigger" },
    { 0xA52C54A3, "to_trigger" },
    { 0xB7E1CABE, "toada" },
    { 0x046040F8, "toai" },
    { 0x29CE244D, "toaim" },
    { 0xE21D0B5A, "toang" },
    { 0x73234FC9, "toanim" },
    { 0xE95D1D37, "toarmed" },
    { 0x7CBE8242, "toast" },
    { 0xCA0031A3, "toattacker" },
    { 0x60C48D3B, "toattackervec" },
    { 0x57060E68, "toblast" },
    { 0xE8EA9468, "toboat" },
    { 0x92427C6B, "tobottom" },
    { 0x9CBCC035, "tobu" },
    { 0x532601C9, "toclear" },
    { 0xDEDE2247, "tocolor" },
    { 0xD032273B, "tocover" },
    { 0xDB191190, "tocrouch" },
    { 0xCF4F318E, "tocu" },
    { 0xB1B0CCBE, "tod" },
    { 0xDE42B0E3, "toda" },
    { 0x2EF84048, "today" },
    { 0xAB51E26E, "todest" },
    { 0xFA33D26D, "todo" },
    { 0xB07D9F6F, "todo_code" },
    { 0xD7B34727, "toe" },
    { 0xB4339A02, "toenemy" },
    { 0x8746F03C, "toenemyvec" },
    { 0xAB16883B, "toenemyyaw" },
    { 0xD8F2DF28, "toeu" },
    { 0xB2AB1E48, "tofaceevec" },
    { 0xD64A548A, "tofaceevec2d" },
    { 0xC496F37A, "toffset" },
    { 0x9F0B6AC7, "together" },
    { 0xC4C5677A, "together_again" },
    { 0xB9844299, "toggle" },
    { 0xF5518AF3, "toggle_3rd_person" },
    { 0x84BC744C, "toggle_activate_clientfields" },
    { 0x1C33CD33, "toggle_afghan_safe" },
    { 0xA042EEF0, "toggle_alley_badplace" },
    { 0x2D1FF508, "toggle_ambient_anim_group" },
    { 0xB63C5F9C, "toggle_angles" },
    { 0x851B17F5, "toggle_arms" },
    { 0x46CD7750, "toggle_barrel_damage" },
    { 0xA6B21D26, "toggle_binoculars" },
    { 0xDA8EB707, "toggle_bonfire_sale_on" },
    { 0xCABB99BC, "toggle_burn_fx" },
    { 0x7DE822A4, "toggle_camo_suit" },
    { 0x992F0FEA, "toggle_countries" },
    { 0x8AC3592D, "toggle_createfx_drawing" },
    { 0x0D5D2578, "toggle_damage_indicators" },
    { 0x819A0D13, "toggle_data_stream" },
    { 0x140F7798, "toggle_depth_of_field" },
    { 0xF78FCAAC, "toggle_door_triggers" },
    { 0xA62FC6C6, "toggle_doors_along_richtofen_street" },
    { 0x7A649D05, "toggle_drones" },
    { 0x4B8EE17F, "toggle_emp_fx" },
    { 0xDD336DDA, "toggle_entity_selection" },
    { 0x5C20D1F0, "toggle_event5_items" },
    { 0x3C03095B, "toggle_event5_triggers" },
    { 0x500F51C7, "toggle_exhaust_fx" },
    { 0x94F85F9A, "toggle_extra_cam" },
    { 0x753E118C, "toggle_extra_cam_multix" },
    { 0xC6D0BB2F, "toggle_extra_cam_squad0" },
    { 0xA0CE40C6, "toggle_extra_cam_squad1" },
    { 0x7ACBC65D, "toggle_extra_cam_squad2" },
    { 0x54C94BF4, "toggle_extra_cam_squad3" },
    { 0x3334EE6A, "toggle_fire_sale_on" },
    { 0xA29CC262, "toggle_flame_char_actor" },
    { 0x5B3EDD9E, "toggle_flight_helmet" },
    { 0x910C81CA, "toggle_flir_postfxbundle" },
    { 0x3CC4C2B6, "toggle_float_anim" },
    { 0x3BBB5E08, "toggle_friendly_push" },
    { 0xB8D414B5, "toggle_fx_bundle" },
    { 0xDC5652D5, "toggle_gas_suit" },
    { 0x53061517, "toggle_gasmask" },
    { 0x8E54690B, "toggle_globe" },
    { 0x64FE07B1, "toggle_glove_left" },
    { 0xD94D795C, "toggle_glove_right" },
    { 0x5A86312C, "toggle_grid_shader" },
    { 0xBF365CEF, "toggle_grid_shader_drone" },
    { 0x29AA4661, "toggle_grid_shader_god_rod" },
    { 0x0289492E, "toggle_hat_overlay" },
    { 0x0B3F0737, "toggle_health_overlay" },
    { 0x8CE4869D, "toggle_holo_table" },
    { 0x0A8F6E16, "toggle_hologram_fx" },
    { 0x08102F62, "toggle_idle_drift" },
    { 0x405160FD, "toggle_ignore_engineers" },
    { 0xD3327FF1, "toggle_ignore_players" },
    { 0xE9506044, "toggle_ignore_state" },
    { 0x8A49A44F, "toggle_ignoreall" },
    { 0xF0DC1E8F, "toggle_india_safe" },
    { 0x9FA297E2, "toggle_inner_gate" },
    { 0x85AC06A4, "toggle_iran_safe" },
    { 0xD422E97D, "toggle_jump_goggles" },
    { 0x64055E31, "toggle_karma_captured" },
    { 0x6AB2D9BD, "toggle_keyline_always" },
    { 0xDAF41DDE, "toggle_kill_trigger_flag" },
    { 0xE9B7393E, "toggle_leaper_collision" },
    { 0x23568973, "toggle_leaper_traversals" },
    { 0x0D81E774, "toggle_lensflare" },
    { 0x492F8FE7, "toggle_lights_group" },
    { 0x56144993, "toggle_locked_weapon_shader" },
    { 0x785900F7, "toggle_main_menu" },
    { 0xF5400128, "toggle_messiah_mode" },
    { 0x42D17595, "toggle_multi_extracam" },
    { 0xF58796F4, "toggle_occluders" },
    { 0x3EAEE71F, "toggle_off_intruder_when_blowing_dome" },
    { 0x80211FC7, "toggle_on" },
    { 0x2F279A46, "toggle_outline" },
    { 0xE92410A1, "toggle_pak_intel" },
    { 0xF3C1CCEC, "toggle_pby_in_flight" },
    { 0x8E0102E3, "toggle_pby_in_water" },
    { 0x0EC00CC8, "toggle_player_binoculars" },
    { 0x1ACE0AE3, "toggle_player_radio" },
    { 0x027F0F80, "toggle_rage_filter" },
    { 0x40C5BBCF, "toggle_rain_overlay" },
    { 0x5B056474, "toggle_redeemer_trigger" },
    { 0x1E704164, "toggle_reticle" },
    { 0x7E56865F, "toggle_rocketaim" },
    { 0x125D1832, "toggle_satellite_hotness" },
    { 0x39146C04, "toggle_satellite_remotemissile" },
    { 0xB603A78C, "toggle_scene_debug" },
    { 0x54F68D5A, "toggle_scene_menu" },
    { 0x28C15076, "toggle_show_spawn_locations" },
    { 0x42496438, "toggle_sounds" },
    { 0x2F52256E, "toggle_stink_overlay" },
    { 0x6CB82893, "toggle_swimming" },
    { 0x3C4E3A51, "toggle_tank_bunker_collision" },
    { 0x80D5ED1C, "toggle_think" },
    { 0x03A45389, "toggle_third_person_cam" },
    { 0xEFAE0EFF, "toggle_timer" },
    { 0xBE2E19EE, "toggle_titus_weapon" },
    { 0xDB89BD0C, "toggle_tokenlocked_weapon_shader" },
    { 0x40A59F5C, "toggle_transitions" },
    { 0xC434A955, "toggle_tread_fx" },
    { 0xF90941B9, "toggle_trig_cougar_enter" },
    { 0xA9EFEA07, "toggle_viewarm" },
    { 0x84420D58, "toggle_visibility" },
    { 0x7F3D0D17, "toggle_vr_combat" },
    { 0x50227074, "toggle_water_fx_actor" },
    { 0x65FAB4E4, "toggle_water_fx_model" },
    { 0x94A05B9B, "toggle_weapons_in_use" },
    { 0xCE588359, "toggle_weaver_ignore" },
    { 0x80969C0B, "toggle_wind_bunker_collision" },
    { 0xC0C3C80B, "toggle_wingsuit_overlay" },
    { 0xB5D10A88, "toggle_world_map_marker" },
    { 0xE667C20A, "toggle_world_map_widget" },
    { 0x5E445A7C, "toggle_xform_hud" },
    { 0x597BC829, "toggle_zodiac_overlay" },
    { 0x8CD77BD0, "toggle_zombie_traversals" },
    { 0xAB414B0D, "toggleable" },
    { 0xD43ABBE5, "toggleautoordertext" },
    { 0x323BE19E, "togglecameraspike" },
    { 0xFC8E0D9F, "toggled" },
    { 0x69FFC3F9, "toggledesiredstance" },
    { 0xFC14059A, "toggledvar" },
    { 0x584F561D, "toggleik" },
    { 0x36195336, "togglelightsonaftertime" },
    { 0xD69BA374, "togglelightsonaftertime_singleton" },
    { 0x951013B5, "togglephalanxstance" },
    { 0x52A45B50, "toggles" },
    { 0xC660D06F, "togglespawngibs" },
    { 0x7646F6CB, "togglezoneeffects" },
    { 0x9644FF8C, "toggling" },
    { 0x2AF89658, "togoalyaw" },
    { 0xF1DBBA0A, "toiled" },
    { 0x48E5827F, "toilet_counter" },
    { 0x672B8BAB, "toilet_trig" },
    { 0x38CFDBB7, "toilet_useage" },
    { 0x8DB50CF0, "toilettrig" },
    { 0x81C79487, "tojo" },
    { 0xC3909569, "tok" },
    { 0xED54230C, "token" },
    { 0xBCC0E282, "tokenize" },
    { 0x7F5567A5, "tokenizedattachmentinfo" },
    { 0x06C1A5AC, "tokenizedweaponrenderoptions" },
    { 0xB952F48F, "tokens" },
    { 0x26A33D7A, "tokens_remaining" },
    { 0xB45A05E0, "toks" },
    { 0x175E6DF4, "tokubetsukogekita" },
    { 0xD738B706, "told" },
    { 0xF643F107, "told_about_prone_success" },
    { 0x1AB86ACA, "tolerance" },
    { 0x2AAE1164, "tolerancecosangle" },
    { 0x613B84C4, "tolerancelevel" },
    { 0x223EC1E2, "tolerant" },
    { 0xCC34312B, "tolerated" },
    { 0xD1093F83, "toll1" },
    { 0x5F01D048, "toll2" },
    { 0x85044AB1, "toll3" },
    { 0x4310AEBE, "toll4" },
    { 0x69132927, "toll5" },
    { 0x86015404, "toll_end" },
    { 0x3F6DB2D2, "tollerance" },
    { 0x57B2BE45, "tolower" },
    { 0xA79F73DF, "tom" },
    { 0x90442D03, "tomahawk" },
    { 0xF1ED72CA, "tomahawk_attack_zombies" },
    { 0x1B0220E0, "tomahawk_charge_power" },
    { 0x13E0C38F, "tomahawk_check_for_zombie" },
    { 0x4B49F934, "tomahawk_func" },
    { 0xD2862652, "tomahawk_hit_zombie" },
    { 0x9047E731, "tomahawk_in_hellhole" },
    { 0x921C4305, "tomahawk_model" },
    { 0xEB1EEFA0, "tomahawk_on_player_connect" },
    { 0x9F8E4D01, "tomahawk_pick" },
    { 0x21E825DE, "tomahawk_picked_up" },
    { 0x8755246A, "tomahawk_pickup" },
    { 0x4B46A2ED, "tomahawk_pickup_spin" },
    { 0xAF703CF7, "tomahawk_pickup_trigger" },
    { 0x04232124, "tomahawk_return_player" },
    { 0xE3CCD70C, "tomahawk_ricochet_attack" },
    { 0x7C8D6FC3, "tomahawk_spawn" },
    { 0xCFCE9436, "tomahawk_spin" },
    { 0x2BAC5356, "tomahawk_the_macguffin" },
    { 0x9C854C31, "tomahawk_the_spoon" },
    { 0xC03A2B24, "tomahawk_thrown" },
    { 0x26BE24A4, "tomahawk_tutorial_hint" },
    { 0xA4172AF9, "tomahawk_update_hud_on_last_stand" },
    { 0x2FD54734, "tomahawk_upgrade_kills" },
    { 0x06194FA5, "tomahawk_upgrade_quest" },
    { 0xBD45D5E0, "tomahawk_upgraded_swap" },
    { 0x23DE6272, "tomahawks" },
    { 0x4BF6443F, "tomb" },
    { 0x739FF042, "tomb_actor_damage_override_wrapper" },
    { 0xACD5AF2A, "tomb_add_player_dialogue" },
    { 0xD0E4B72E, "tomb_ambient_precache" },
    { 0xE22C53BD, "tomb_audio_custom_response_line" },
    { 0x0DE88384, "tomb_audio_custom_weapon_check" },
    { 0x6F253956, "tomb_audio_get_mod_type_override" },
    { 0x0A27207B, "tomb_can_revive_override" },
    { 0x72EECED1, "tomb_can_track_ammo_custom" },
    { 0x5ABE71AC, "tomb_challenges_add_stats" },
    { 0x6BE58D92, "tomb_chamber_find_exit_point" },
    { 0xDB3359F1, "tomb_check_crafted_weapon_persistence" },
    { 0xB65F0270, "tomb_closest_player_override" },
    { 0x568DC89E, "tomb_custom_craftable_validation" },
    { 0x1FFAEF19, "tomb_custom_crawler_spawned_vo" },
    { 0x256DCBD2, "tomb_custom_divetonuke_explode" },
    { 0x94FFB28F, "tomb_custom_divetonuke_explode_network_optimized" },
    { 0xF357616C, "tomb_custom_electric_cherry_laststand" },
    { 0xDED9E30A, "tomb_custom_electric_cherry_reload_attack" },
    { 0x782AC8A6, "tomb_custom_player_track_ammo_count" },
    { 0x412F65CD, "tomb_custom_zombie_oh_shit_vox" },
    { 0x902CAEC2, "tomb_dig" },
    { 0xABD59BE1, "tomb_drone_built_vo" },
    { 0xD2B9FCD2, "tomb_generator_captured" },
    { 0x7528592B, "tomb_generator_defended" },
    { 0x93C589F6, "tomb_generator_lost" },
    { 0xE046126E, "tomb_get_closest_player_using_paths" },
    { 0x23FF23EC, "tomb_get_path_length_to_tank" },
    { 0x2C15DF3E, "tomb_giant_robot_accessed" },
    { 0x14217251, "tomb_giant_robot_stomped" },
    { 0xCC67C16D, "tomb_golden_hard_hat" },
    { 0x49D5393D, "tomb_golden_shovel" },
    { 0xA2F4C20C, "tomb_is_valid_target_in_chamber" },
    { 0x658B5C43, "tomb_magic_box_used_vo" },
    { 0x60DC1CCB, "tomb_mechz_killed" },
    { 0x1038BE60, "tomb_perk_extension" },
    { 0xCEC1CB5F, "tomb_player_damage_callback" },
    { 0x25D30C89, "tomb_player_intersection_tracker_override" },
    { 0xED06D487, "tomb_powerup_grab" },
    { 0x6E44158B, "tomb_powerup_init" },
    { 0xCEBD4D0C, "tomb_random_perk_weights" },
    { 0xF33DB9AF, "tomb_register_client_fields" },
    { 0x3BC1A76E, "tomb_round_spawn_failsafe" },
    { 0xE8BE0063, "tomb_shield_zm_taken" },
    { 0x1FD5EE2F, "tomb_sidequest_complete" },
    { 0x52854313, "tomb_spawn_trigger_radius" },
    { 0xABAC968C, "tomb_special_weapon_magicbox_check" },
    { 0xDB7CB849, "tomb_staff_update_prompt" },
    { 0x354FBF24, "tomb_standard_intermission" },
    { 0xF2A1902A, "tomb_trigger_update_message" },
    { 0xBD611266, "tomb_unitrigger_delete" },
    { 0x03DB9B69, "tomb_unitrigger_think" },
    { 0x53B96CB8, "tomb_validate_enemy_path_length" },
    { 0x4FCDDA15, "tomb_vehicle_damage_override_wrapper" },
    { 0x21560EF4, "tomb_watch_chamber_player_activity" },
    { 0x37D1F958, "tomb_weaponobjects_on_player_connect_override" },
    { 0x7FFC8F44, "tomb_zombie_death_event_callback" },
    { 0xC06F5C2E, "tombstone" },
    { 0x01F94FF0, "tombstone_clear" },
    { 0x2A7F8EEA, "tombstone_give" },
    { 0xF175CA57, "tombstone_grab" },
    { 0xDD08C9AC, "tombstone_grabbed" },
    { 0x693D452D, "tombstone_hostmigration" },
    { 0x909F2CBF, "tombstone_index" },
    { 0xA733066B, "tombstone_laststand" },
    { 0xF35B944C, "tombstone_laststand_func" },
    { 0xAFF713DC, "tombstone_machine_triggers" },
    { 0x01BB6441, "tombstone_melee_weapons" },
    { 0xD4F320C4, "tombstone_off" },
    { 0x5D6CE92E, "tombstone_on" },
    { 0x123FDBB7, "tombstone_player_init" },
    { 0xE7ED4F5F, "tombstone_removed" },
    { 0xB20F4532, "tombstone_revived" },
    { 0x331AD0BC, "tombstone_save_perks" },
    { 0xDCB193EE, "tombstone_spawn" },
    { 0x542A47A7, "tombstone_spawn_func" },
    { 0x64506EA6, "tombstone_timedout" },
    { 0x3F10F1D6, "tombstone_timeout" },
    { 0x46D221CD, "tombstone_weapon" },
    { 0x46B650AE, "tombstone_wobble" },
    { 0xD6D4AE51, "tombstones" },
    { 0x41E4EB60, "tome" },
    { 0x68AA7029, "tommy" },
    { 0xEB0BA778, "tommyk" },
    { 0xF8065260, "tomorrow" },
    { 0x359804A4, "ton" },
    { 0xCFF891D1, "tone" },
    { 0x0E455D07, "toned" },
    { 0x0671AD91, "tongue" },
    { 0x6D1163F4, "tonight" },
    { 0x7E8B6984, "toning" },
    { 0x1ECC4672, "tonode" },
    { 0x142F16D7, "tons" },
    { 0x98164EBD, "tony" },
    { 0x10CF39F0, "tonyflamer" },
    { 0x5B9A7F0D, "too" },
    { 0x909FF44C, "too_close" },
    { 0xD4194AA4, "too_close_damage_modifier" },
    { 0x07B86FFA, "too_close_distance" },
    { 0x709AE982, "too_close_for_zoom" },
    { 0xFEEDBCC3, "too_close_to_high_ground" },
    { 0x37C2CC25, "too_close_trigger" },
    { 0xF14FEA0A, "too_far_dist" },
    { 0x3208B7B7, "too_far_fail_managment" },
    { 0xD6C6B737, "too_high_dist" },
    { 0xCC046C54, "too_late" },
    { 0xEAFDEC9F, "tooclose" },
    { 0x45F2228B, "tooclosedist" },
    { 0x225DB535, "tooclosejukedistancesqr" },
    { 0x1339E518, "tooclosetopredictedparent" },
    { 0xE8DCCAB3, "tood" },
    { 0xDECB71D4, "took" },
    { 0x3F7AC796, "took_control" },
    { 0xE05D6747, "tookflashbangdamage" },
    { 0x275F6F1F, "tookmainweapon" },
    { 0xC6C46E40, "tookweapon" },
    { 0x135A6C70, "tookweaponfrom" },
    { 0xB8C8F76B, "tool" },
    { 0xE8B0F2A0, "tooled" },
    { 0x89889720, "toolongatnode" },
    { 0x1538514A, "tools" },
    { 0x89386F6A, "tooltip" },
    { 0xA8FE90F3, "tooltype" },
    { 0x135D5495, "tooslow_dialog" },
    { 0x488B0381, "tooth" },
    { 0x79CE89AA, "top" },
    { 0xE3F895A5, "top3" },
    { 0x8D0D4827, "top_ai" },
    { 0x9E839DB7, "top_arc" },
    { 0x9C66040D, "top_door_bottom" },
    { 0x7E685875, "top_door_top" },
    { 0xF19EC691, "top_floor_retreat" },
    { 0xAD2219EA, "top_floor_retreat_strat" },
    { 0x04B67D52, "top_guy" },
    { 0x700C1584, "top_height" },
    { 0x045980EF, "top_hinge_think" },
    { 0x6931FEE6, "top_node_r" },
    { 0x3B435A98, "top_of_ladder_trigger" },
    { 0xD7DF3CA4, "top_of_ramp_dialog" },
    { 0x0B3E6779, "top_of_rope" },
    { 0x2CC14868, "top_of_rope_trigger" },
    { 0x1E1E2417, "top_of_the_house" },
    { 0x76FF03B7, "top_origin" },
    { 0x5EF57263, "top_rocket_end" },
    { 0x75732EB0, "top_rocket_jnt" },
    { 0xDD34FD03, "top_rocket_piece_hits_ground" },
    { 0x88831BF4, "top_roll" },
    { 0xAD3AE6DF, "top_roll_door" },
    { 0xBF374A1A, "top_speed" },
    { 0x242EA6F4, "top_tag_origin" },
    { 0x9CAFC98F, "top_velocity_sq" },
    { 0xE0350E6A, "top_y" },
    { 0x404C010E, "toparc" },
    { 0x20D170B2, "toparmlost" },
    { 0xEC566A57, "topclawambientfx" },
    { 0x3469A225, "topclawchargefx" },
    { 0x966AE3C2, "topdown" },
    { 0x231CD8F3, "tophill" },
    { 0x786532A9, "topkills" },
    { 0x3D6E2E68, "topkillstreak" },
    { 0x30C07C99, "toplayer" },
    { 0xE4F44061, "topleft" },
    { 0xB3FC2E46, "toploading" },
    { 0xEC544FB3, "topmenu" },
    { 0x15121D80, "topn" },
    { 0xC691A437, "topname" },
    { 0x71480DCE, "topoftracklength" },
    { 0xBECA1774, "topoint" },
    { 0xA6E86511, "topped" },
    { 0x77D2DE15, "topplayer" },
    { 0x62C15215, "topplayercharacters" },
    { 0xC55B8047, "topplayerindex" },
    { 0x538E08EA, "topplayerscriptstructs" },
    { 0x6CA16392, "topplayerteam" },
    { 0x4506965F, "topple" },
    { 0xB6D2509C, "toppos" },
    { 0x6359FB65, "tops" },
    { 0xA812A174, "topscore" },
    { 0x318BFAE1, "topscorers" },
    { 0x360C4F0A, "topscoringplayer" },
    { 0x2B82C1A7, "topside" },
    { 0xDF79A001, "topsidefx" },
    { 0xE09FC4E4, "topthreeplayers" },
    { 0xD73408DD, "topthreeteamplayers" },
    { 0x975E497A, "topweapon" },
    { 0x20220E85, "topwinnings" },
    { 0x7F4B1CEF, "topy" },
    { 0xE28DCD81, "torch" },
    { 0x5DA1B12E, "torch_ai" },
    { 0x92A786A4, "torch_angles" },
    { 0x71EBF3BD, "torch_guy" },
    { 0x491EA9C3, "torch_guy_cutting_wall" },
    { 0x524F9E82, "torch_pos" },
    { 0x6AC30300, "torch_sounds" },
    { 0xB8515EC9, "torch_wall_scene" },
    { 0xEC06E1F4, "torchcutter" },
    { 0x6C0CB66E, "torched" },
    { 0xD6380CC7, "torching" },
    { 0x1535C6C9, "torigin" },
    { 0xE0010E16, "torn" },
    { 0xE5C33D19, "torn_down" },
    { 0x169825B6, "torpedo" },
    { 0x698BBA69, "torpedo_dialog" },
    { 0x32015622, "torpedo_dir" },
    { 0xDE9583ED, "torpedo_max_yaw_cos" },
    { 0x3602F22C, "torpedo_old_normal_vector" },
    { 0x18C439CB, "torpedo_origin" },
    { 0xF34B6BD5, "torpedo_pos" },
    { 0x7A82F1AE, "torpedo_target" },
    { 0xB6AD162C, "torpedo_target_offset" },
    { 0xF9BEB155, "torpedo_target_point" },
    { 0x3756D92D, "torpedo_target_pos" },
    { 0xE4C026D4, "torpedo_target_position" },
    { 0xDC16DB5E, "torpedo_trail_iterations" },
    { 0x36984E86, "torpedo_yaw_per_interval" },
    { 0xB21109F6, "torpedoes" },
    { 0x81A889A9, "torpedos" },
    { 0x5D7656C7, "torque" },
    { 0x8DC831BE, "torso" },
    { 0xF67B278F, "torsodmg1" },
    { 0x42FF2BFD, "torsodmg1_defined" },
    { 0x8473B854, "torsodmg2" },
    { 0x1723E71A, "torsodmg2_defined" },
    { 0xAA7632BD, "torsodmg3" },
    { 0xB169F827, "torsodmg3_defined" },
    { 0x386EC382, "torsodmg4" },
    { 0x52BB9AF4, "torsodmg4_defined" },
    { 0x5E713DEB, "torsodmg5" },
    { 0xB6A400E1, "torsodmg5_defined" },
    { 0xC40DB5C6, "torture" },
    { 0x53CC0F41, "tos" },
    { 0xBB27169E, "toset" },
    { 0x85D56CE3, "tospawn" },
    { 0x9F515023, "tosquadid" },
    { 0x98BDA068, "toss" },
    { 0xDA089722, "toss_ragdoll_drones" },
    { 0xA2DF0737, "tossanim" },
    { 0xEE1DD299, "tossback" },
    { 0x814C027B, "tossed" },
    { 0x2D789DDD, "tosser" },
    { 0x07762374, "tosses" },
    { 0xCA8F5002, "tossguy1" },
    { 0x30254830, "tossing" },
    { 0xD3FF6205, "tossrand" },
    { 0x5CCEB2CD, "tostate" },
    { 0x3DC1D1A7, "tostr" },
    { 0x16E20375, "total" },
    { 0x8B8AB1C1, "total_ads_damage_dealt" },
    { 0xAE7E1662, "total_ai" },
    { 0x0593276E, "total_ai_count" },
    { 0xF5D42AB1, "total_airmada_huey" },
    { 0x7539CF25, "total_airmada_phantom" },
    { 0x4DF9D302, "total_ammo" },
    { 0xB82B92CC, "total_amount" },
    { 0xC698E6C6, "total_amt" },
    { 0x4118EB4E, "total_anims" },
    { 0x13537980, "total_assigned" },
    { 0xC4670AE6, "total_attachments" },
    { 0x5B35678C, "total_bomb_count" },
    { 0x661DA075, "total_boss_killed" },
    { 0x0414D3FC, "total_brutuses_spawned" },
    { 0xBC870E0B, "total_buildings" },
    { 0x2A2BA225, "total_bursts" },
    { 0x804E92FE, "total_capture_zones" },
    { 0xC871C93A, "total_control_weight" },
    { 0x6C341F55, "total_count" },
    { 0xB3E1F1A8, "total_crumbs" },
    { 0x9AEB75F8, "total_cyan_guys" },
    { 0x1C9A9EBB, "total_damage" },
    { 0xCA4C2D31, "total_deaths" },
    { 0x6AC408CF, "total_digbat_killed" },
    { 0x506C1848, "total_dist" },
    { 0xECF3C1FC, "total_dmg_taken" },
    { 0x6530DC09, "total_dogs" },
    { 0x8079DECF, "total_downs" },
    { 0x72421DE1, "total_drones" },
    { 0x1E4E2CB8, "total_duration" },
    { 0x27EE5200, "total_enemies" },
    { 0x8492A1C4, "total_enemy_damage_taken" },
    { 0x07F7B6CA, "total_enemy_deaths" },
    { 0xBE7EF2CE, "total_ents" },
    { 0xADF3423A, "total_error" },
    { 0x52745FCB, "total_events" },
    { 0x07FBB35A, "total_fallbackers" },
    { 0x62B2EF00, "total_fire_time" },
    { 0x1316BEF1, "total_flight_structs" },
    { 0x139C9091, "total_force" },
    { 0x637851BF, "total_frame" },
    { 0x5DE3E037, "total_frame_count" },
    { 0x9BE21DC6, "total_frames" },
    { 0xEEE03DC9, "total_headshots" },
    { 0x4123EC0A, "total_health" },
    { 0x8302185E, "total_hits" },
    { 0x60061A55, "total_hits_end_leaper_round" },
    { 0xB61FFC68, "total_hits_start_leaper_round" },
    { 0x25B1A023, "total_kills" },
    { 0x71D1770B, "total_left" },
    { 0xEEEF874E, "total_metro_guys" },
    { 0x8E56D216, "total_mortars" },
    { 0x4506E757, "total_movement" },
    { 0xE0856FA3, "total_notify_count" },
    { 0xD6D9E150, "total_open_angle" },
    { 0x26CCC664, "total_open_time" },
    { 0xB3517AF1, "total_others" },
    { 0x5565EE37, "total_perks" },
    { 0x3F68EDFB, "total_pieces_hit" },
    { 0x7469BC61, "total_planes" },
    { 0xBD7D931F, "total_player_count" },
    { 0x8406DDC6, "total_player_damage_dealt" },
    { 0xE4E0B5F1, "total_player_damage_taken" },
    { 0x7A5BE851, "total_player_kills" },
    { 0x109A0F45, "total_points" },
    { 0x8CF5B600, "total_possible_gunners" },
    { 0x72E89D6A, "total_pulses" },
    { 0xADE87118, "total_red_guys" },
    { 0xD56D2A07, "total_respawns" },
    { 0x2829ACBA, "total_revives" },
    { 0x17ED2923, "total_rockets" },
    { 0x3343075B, "total_rope_length" },
    { 0xCF54562B, "total_rounds" },
    { 0xA32C83BE, "total_score" },
    { 0xF27915FF, "total_seconds" },
    { 0x17CBE7B1, "total_seconds_to_complete" },
    { 0x831D6FC6, "total_seconds_waited" },
    { 0x1BC2B672, "total_secs_to_wait" },
    { 0x1BF93961, "total_shoot_origins" },
    { 0xD8632383, "total_shots" },
    { 0xE2925EAA, "total_shots_end_leaper_round" },
    { 0x915B16B3, "total_shots_start_leaper_round" },
    { 0x6D385C0B, "total_size" },
    { 0xA014B4C5, "total_spawn_count" },
    { 0x3C0330AF, "total_spawned_boats_this_function_call" },
    { 0x0452AC07, "total_spawners" },
    { 0x0673F9B0, "total_spent" },
    { 0xD10D7FA0, "total_static_transition_time" },
    { 0x6B7F8D0C, "total_tag_origins" },
    { 0xB110C763, "total_time" },
    { 0xF65CB63F, "total_time_for_rotation_inside" },
    { 0xC6CBAF14, "total_time_for_rotation_outside" },
    { 0xF91FCF67, "total_tries" },
    { 0xFC3B0463, "total_turn_time" },
    { 0xAE1DBD9F, "total_unlocked" },
    { 0xC0CD5CCB, "total_value_count" },
    { 0x708F3DAE, "total_visible" },
    { 0x01CF17B9, "total_wait_time" },
    { 0x04DBDC3A, "total_waves" },
    { 0xBB527508, "total_weight" },
    { 0x267F6F94, "total_wins_index" },
    { 0xEAC6C0C9, "total_y" },
    { 0x9A8BFA2A, "total_zero_speed_time" },
    { 0x8CC1B336, "total_zeros_spawned" },
    { 0x9B19E270, "total_zombie_gibs" },
    { 0xE2B6F127, "total_zombies_killed" },
    { 0x061D8C3D, "totalaccumtime" },
    { 0xF88A4563, "totalai" },
    { 0xEF9BD338, "totalalive" },
    { 0xAA2E3925, "totalalivecount" },
    { 0xF7953337, "totalammo" },
    { 0x9C217D56, "totalanimdist" },
    { 0x542E3705, "totalanimtime" },
    { 0x54E4F2AF, "totalassists" },
    { 0xFA3A6DAD, "totalbleedersnotrevived" },
    { 0x2F4BB88A, "totalboss" },
    { 0x72488583, "totalcamerashots" },
    { 0xF1FC168A, "totalcapturetime" },
    { 0xEF0C7C51, "totalcategory" },
    { 0x6D27D423, "totalchallengesunlock" },
    { 0x6251CC09, "totalchange" },
    { 0xE3BB492A, "totalcount" },
    { 0x9531FC22, "totalcrateweight" },
    { 0xA862018B, "totaldamagetaken" },
    { 0x61B332C8, "totaldeaths" },
    { 0x513B8FE5, "totaldist" },
    { 0x70FD2670, "totaldistance" },
    { 0x33FE02AB, "totaldistancetravelled" },
    { 0x17D83354, "totaldistfromideal" },
    { 0xF3754F7C, "totaldogs" },
    { 0x0B256355, "totaldomination" },
    { 0xE7E6EC39, "totalduration" },
    { 0xB699033E, "totalfiretime" },
    { 0x268CC4AA, "totalflags" },
    { 0x639D35E8, "totalflagscaptured" },
    { 0x4F996C2B, "totalflagsreturned" },
    { 0x8948554F, "totalfree" },
    { 0xD4EA39C8, "totalfriends" },
    { 0xC3D2EF68, "totalgibs" },
    { 0xA50A40E9, "totalguys" },
    { 0x03EAE67E, "totalheadshots" },
    { 0x81226173, "totalhealth" },
    { 0xFAD7C813, "totalhits" },
    { 0xE8D3218D, "totalhqscaptured" },
    { 0xAEFD4904, "totalhqsdestroyed" },
    { 0x9F3CCCB9, "totalhumiliations" },
    { 0x324624DC, "totaligcviewtime" },
    { 0x088628AB, "totalkilldistances" },
    { 0xB9E3F6D4, "totalkills" },
    { 0x6BA63CCE, "totalkillsmax" },
    { 0x262F2EF2, "totalkillstreaks" },
    { 0xA75EFE06, "totalkillswiththiskillstreak" },
    { 0x52860DB3, "totall" },
    { 0x5E5453CE, "totallightgrids" },
    { 0x0E0ABC8D, "totallist" },
    { 0xB94C1E54, "totallosses" },
    { 0xC552A8D8, "totally" },
    { 0xBCE1093B, "totalmatchshots" },
    { 0xA9A3960D, "totalmax" },
    { 0xE7A57045, "totalmovetime" },
    { 0xB54E7C04, "totalnodes" },
    { 0xF93B00D6, "totaloccurrance" },
    { 0x0D6BF230, "totalpausedtime" },
    { 0x4E7AD6A2, "totalpausetime" },
    { 0xF97020BF, "totalplayercount" },
    { 0x5A5DF82F, "totalplayerlives" },
    { 0xB6870F06, "totalplayersneeded" },
    { 0x2999E9FE, "totalpop" },
    { 0x4FF362FC, "totalrequiredredshirts" },
    { 0x15F220AC, "totalrevivesequences" },
    { 0x6CA4B973, "totalrockethits" },
    { 0xE84D0E44, "totals" },
    { 0x31108043, "totalsabdestroyedbycommunists" },
    { 0x1F818813, "totalsabdestroyedbyops" },
    { 0x3FBEC512, "totalsabdestroyedbyteam" },
    { 0x88452C91, "totalscore" },
    { 0x65DC0134, "totalscoreypos" },
    { 0xC0810D02, "totalsddefused" },
    { 0x5D7BE06E, "totalsdplants" },
    { 0x36E5870C, "totalseconds" },
    { 0x85244ED4, "totalsecondswaited" },
    { 0x77457D03, "totalsecstowait" },
    { 0xB69DD87C, "totalspecialai" },
    { 0xD5742663, "totalspeedswhenmoving" },
    { 0x61F32C72, "totalstepswithoutout" },
    { 0x8ED82006, "totalsuicides" },
    { 0x08C915B2, "totaltime" },
    { 0x9AD731E2, "totaltimepassed" },
    { 0xC3876D3B, "totaltimeplayed" },
    { 0x0CA02063, "totaltransitions" },
    { 0xA85A7A44, "totaltries" },
    { 0x9ED4EC29, "totalweight" },
    { 0xB12B334C, "totalwins" },
    { 0x08219B55, "totalxp" },
    { 0x087E82EC, "totauntblendtime" },
    { 0xCF83801B, "toten" },
    { 0x34914552, "touch" },
    { 0xE9DFCCD3, "touch_trig" },
    { 0x362630BF, "touch_trigger" },
    { 0x109FC24F, "touchcount" },
    { 0xE4107C52, "touchdata" },
    { 0xF880D465, "touched" },
    { 0x9EC0FBB5, "touched_eq_function" },
    { 0x079E6236, "touched_trig" },
    { 0x83DE866A, "touched_trigger_runs_func" },
    { 0xE2923556, "touchedby" },
    { 0xB8E72F6F, "touchedkillbrush" },
    { 0xE683E429, "touchent" },
    { 0x4C543903, "toucher" },
    { 0x31214672, "touchers" },
    { 0x2651BE9A, "touches" },
    { 0xA0AD6B5E, "touching" },
    { 0xB5D92250, "touching_fail_trigger" },
    { 0x61778AA1, "touching_no_zone" },
    { 0xAFFD8FD9, "touching_player_monitor" },
    { 0xDC5B5C85, "touching_players" },
    { 0x0F38E583, "touchingcontestedflag" },
    { 0xA4B10FD0, "touchingplayers" },
    { 0x6451D3FE, "touchkeys" },
    { 0x9B08F836, "touchlist" },
    { 0x51C64DFA, "touchlistkeys" },
    { 0x941C12DF, "touchname" },
    { 0x849D96F0, "touchreturn" },
    { 0x40D58BF8, "touchtrig" },
    { 0xDADAA2A5, "touchtriggers" },
    { 0x893D6177, "touchy" },
    { 0xBAD246E6, "tough" },
    { 0x50BE7B6F, "tougher" },
    { 0xFFFEF7AB, "toughness" },
    { 0x5FD83932, "toupper" },
    { 0x90818557, "tour" },
    { 0x2F17E408, "tournement" },
    { 0x3867AF40, "tourniquets" },
    { 0xA42363A0, "tovarisch" },
    { 0x79D7C480, "tovec" },
    { 0x6C9024FB, "tovec_angles" },
    { 0xBD2A1673, "tovector" },
    { 0xEBD5F8E5, "tow" },
    { 0x1F1CE495, "tow_boundary_logic" },
    { 0x83D13D1E, "tow_failed_screen" },
    { 0xA91ACC18, "tow_fired" },
    { 0xF18A1983, "tow_force_off" },
    { 0xDE26EFCB, "tow_futz_off" },
    { 0x920D8977, "tow_futz_on" },
    { 0x91A23DE3, "tow_hero_light_hackery" },
    { 0x1C955E58, "tow_hide" },
    { 0x23425334, "tow_hide_damaged" },
    { 0x8266C640, "tow_highlight_on_heli_lookat" },
    { 0x9F8B4F18, "tow_launcher" },
    { 0xCC1587B0, "tow_missile" },
    { 0x26F80A13, "tow_missile_audio" },
    { 0x2042669E, "tow_missile_dropweapon_delete" },
    { 0x175C25D8, "tow_missile_guy" },
    { 0xD3DAC2CF, "tow_missile_guy_drop_weapon" },
    { 0x84F444D1, "tow_missile_guy_think" },
    { 0xC6DE9344, "tow_missile_instructions" },
    { 0x91876C0F, "tow_missile_moment" },
    { 0x70C9A2A9, "tow_missle_snapshots_and_telemetry" },
    { 0xA8459D3B, "tow_prop" },
    { 0xC86E7810, "tow_spot" },
    { 0xB523D4A2, "tow_unlimited_ammo" },
    { 0x72BFB71A, "tow_wait_for_pickup" },
    { 0xC62A17C4, "toward" },
    { 0x6A8B2CDC, "toward_player" },
    { 0xFBC980B3, "towardend" },
    { 0x4AC1CC77, "towards" },
    { 0x33BE957F, "towards_cam" },
    { 0x8D4926E0, "towardstart" },
    { 0xF0E5835E, "toweapon" },
    { 0x20825B00, "towef" },
    { 0x18B3EB34, "tower" },
    { 0x77336480, "tower01_force_blow_up" },
    { 0x913F9E80, "tower01_names" },
    { 0xF73D5747, "tower02_force_blow_up" },
    { 0x57DDBD0F, "tower02_names" },
    { 0x1CC6C995, "tower1" },
    { 0x26C2BC79, "tower1_guy" },
    { 0xAB5F9CB0, "tower1_guys" },
    { 0x99B9EC34, "tower2_blows_up" },
    { 0x8668FFE1, "tower2_guys" },
    { 0x4E84C012, "tower3_guys" },
    { 0xD5D0809A, "tower4_blows_up" },
    { 0x3BB1E62D, "tower5_blows_up" },
    { 0x3B1E320C, "tower5_guys" },
    { 0xFC61054A, "tower_01" },
    { 0x308D6BA3, "tower_01_start" },
    { 0xD65E8AE1, "tower_02" },
    { 0x93B6DC20, "tower_02_start" },
    { 0xB05C1078, "tower_03" },
    { 0x3460D99D, "tower_03_start" },
    { 0xBA6D6957, "tower_04" },
    { 0x18AE10A2, "tower_04_start" },
    { 0x946AEEEE, "tower_05" },
    { 0x758C8DCF, "tower_05_start" },
    { 0x243E076E, "tower_3_4_5_spawner" },
    { 0x690914C1, "tower_4_destroy_mg" },
    { 0x8640916A, "tower_5_destroy_mg" },
    { 0xE5B6820C, "tower_base" },
    { 0x82B87DE4, "tower_base_left" },
    { 0x1C0BECDB, "tower_base_right" },
    { 0x4A5A2754, "tower_broken" },
    { 0x715850CA, "tower_c4" },
    { 0x08C6ACD9, "tower_c4_2" },
    { 0x7E2E3351, "tower_cart" },
    { 0x50F0F403, "tower_cart_anim" },
    { 0x8631054B, "tower_cart_connect_paths" },
    { 0xBCF456DF, "tower_cart_events" },
    { 0xDC1BBF57, "tower_cart_left" },
    { 0x3207E507, "tower_cart_left_reach" },
    { 0x986CCA28, "tower_cart_trigger_wait" },
    { 0x8F18C063, "tower_chase" },
    { 0x4FD54A7D, "tower_cleanup" },
    { 0x5C3FC7C6, "tower_collapse" },
    { 0x0978E991, "tower_custom_death_message" },
    { 0x429621FC, "tower_damage" },
    { 0x606BA42A, "tower_damage_distance" },
    { 0xFA35C76A, "tower_debris" },
    { 0x15458023, "tower_destroy" },
    { 0xCCA82318, "tower_destroyed" },
    { 0x67805F65, "tower_destruction" },
    { 0x1FECF430, "tower_disk" },
    { 0xF257D29F, "tower_done" },
    { 0x97ABB73E, "tower_drone_think" },
    { 0x29F29DF2, "tower_drone_think_internal" },
    { 0xA026FC4F, "tower_earthquakes" },
    { 0x3874BE8D, "tower_explode_anims" },
    { 0x02D2389F, "tower_explosions" },
    { 0x6E3EE284, "tower_fireball" },
    { 0xFB391C7F, "tower_fireball_load" },
    { 0x1292B31D, "tower_fx" },
    { 0xC6B867FE, "tower_fx_piece" },
    { 0xA55854FA, "tower_gate" },
    { 0x161BDC9D, "tower_guard_bloodfx" },
    { 0x4A532C99, "tower_guards" },
    { 0x2E2EEF67, "tower_gun_destroyed" },
    { 0xF3B3E017, "tower_guy_function" },
    { 0x63B62157, "tower_guys" },
    { 0x0641B4E3, "tower_hits_deck" },
    { 0x1CBF6A01, "tower_impact" },
    { 0xA4FABB00, "tower_impact01" },
    { 0x17022A3B, "tower_impact02" },
    { 0x5D59E996, "tower_impact_fx" },
    { 0x73AF75FF, "tower_in_sync_lightning" },
    { 0x90A2B3FC, "tower_interface" },
    { 0x2F8AF23C, "tower_left_cart_think" },
    { 0x6C5B5B3F, "tower_legbreak_fx" },
    { 0x5F296088, "tower_lift" },
    { 0x38D1F5B0, "tower_lights" },
    { 0xB405A345, "tower_melee_complete" },
    { 0x8A6E7FF3, "tower_mg" },
    { 0xEB6F09C8, "tower_mg_ai" },
    { 0xE0C206CA, "tower_mg_kill" },
    { 0xE19F3636, "tower_name" },
    { 0x1F4AD155, "tower_num" },
    { 0x12C93F77, "tower_pos" },
    { 0xC7F45FEE, "tower_prisoner_think" },
    { 0xA55F0468, "tower_punch_watch_leg" },
    { 0x8466AE58, "tower_punch_watcher" },
    { 0x2D503FF4, "tower_rpg_at_player" },
    { 0x5AC16387, "tower_rpgs" },
    { 0xE618748B, "tower_shotgun" },
    { 0x808D1DC4, "tower_sling_vo" },
    { 0x5144DD07, "tower_spark_fx" },
    { 0x0964EA53, "tower_spawner_setup" },
    { 0x710634E1, "tower_start" },
    { 0x3875904B, "tower_start_spawners" },
    { 0xF14EBFCC, "tower_trap_fires" },
    { 0xA1CF744D, "tower_trap_move_switch" },
    { 0xD11A2410, "tower_trap_off" },
    { 0x9A0CA394, "tower_trap_reset_timer" },
    { 0xF0051658, "tower_trap_timer" },
    { 0xCCFFB13E, "tower_trap_trigger_think" },
    { 0x2DB73FF4, "tower_trap_upgrade_panel_closes_early" },
    { 0xEFD8A995, "tower_trap_upgraded" },
    { 0xCF422055, "tower_traps" },
    { 0x5A19620C, "tower_triggers" },
    { 0xDB036C21, "tower_upgrade_trigger_think" },
    { 0x53359D22, "tower_vo" },
    { 0x17955AAB, "tower_window" },
    { 0xC0D63EC4, "towerblastradius" },
    { 0xE82D2427, "towers" },
    { 0x5B4D9D92, "towers_start" },
    { 0xDC5883F4, "towlockedon" },
    { 0x332B1271, "town" },
    { 0xB7451EB4, "town_dist" },
    { 0x91BDEF36, "town_kill_dash_heli" },
    { 0xDEDBE2AB, "town_main" },
    { 0xBCCF58E4, "town_moveup" },
    { 0x8AE4D76E, "town_moveup2" },
    { 0xB0E751D7, "town_moveup3" },
    { 0x711E2717, "town_no_turning_back" },
    { 0xAC9890A1, "town_square" },
    { 0xF2DADD01, "town_state_spotted" },
    { 0x0A6ABE96, "town_treasure_chest_init" },
    { 0x960E7135, "town_truck_exploit" },
    { 0x14DF1D7C, "townsquare" },
    { 0x49BAB662, "tox" },
    { 0xCEBFEB7B, "toxin" },
    { 0x6FBD30CB, "toy" },
    { 0xFDB5C190, "toz" },
    { 0x743E6F19, "tp" },
    { 0x816D93FF, "tp_dot_to" },
    { 0xAF6DB724, "tp_magnitude_squared" },
    { 0x80F05A72, "tp_to_start" },
    { 0xB195B712, "tpa" },
    { 0x6590C240, "tpc" },
    { 0x5C76B792, "tpeak" },
    { 0xF91D1A07, "tpoint" },
    { 0xA830952F, "tpos" },
    { 0x5DC25274, "tpw" },
    { 0xC04363EB, "tr" },
    { 0xB58D3EA1, "tr0" },
    { 0x01923373, "tr2" },
    { 0xA52FAA04, "trace" },
    { 0xD3E37825, "trace1" },
    { 0xF9E5F28E, "trace2" },
    { 0xDE81B2AE, "trace_adjust" },
    { 0x9548DE4F, "trace_angles" },
    { 0x93F1110A, "trace_blockers" },
    { 0x7B833F50, "trace_count" },
    { 0x72511AEA, "trace_depth" },
    { 0x847D4863, "trace_dest" },
    { 0x3CDD662A, "trace_direction" },
    { 0xEF62FBD7, "trace_dist" },
    { 0x3EDF8A5E, "trace_dist_sq" },
    { 0x5C2CA912, "trace_distance" },
    { 0xA0E4EF0A, "trace_end" },
    { 0x38811738, "trace_end_points" },
    { 0x40BD487A, "trace_ent" },
    { 0xDAB627DA, "trace_entity" },
    { 0x1D7FA9F5, "trace_ents" },
    { 0x7410F6A5, "trace_fraction" },
    { 0xC9EDC448, "trace_gather_ent" },
    { 0xD528EFA8, "trace_goalpos" },
    { 0x0C443EFA, "trace_height" },
    { 0x35A171C0, "trace_height_offset" },
    { 0x95FCF520, "trace_hit_ent" },
    { 0x4D0D81D9, "trace_length_hud_elem" },
    { 0xDFB41962, "trace_max_length_hud_elem" },
    { 0xCA8C381C, "trace_number" },
    { 0x91268581, "trace_origin" },
    { 0x576F2BD7, "trace_passed" },
    { 0x0381555F, "trace_point" },
    { 0x6464F2E7, "trace_pos" },
    { 0x61D1DC95, "trace_real_ent" },
    { 0x0A9CFFD8, "trace_result" },
    { 0xD0F1DEE8, "trace_size" },
    { 0xA2DD0D11, "trace_start" },
    { 0xA0DF740F, "trace_surface_type" },
    { 0x66AE6213, "trace_test" },
    { 0xA02F1161, "trace_turret_target_by_name" },
    { 0x8D2E5505, "traceback" },
    { 0xE570BED4, "tracebomb" },
    { 0x4EAE6920, "traceboxhalfwidth" },
    { 0x0A402964, "traceconstanttest" },
    { 0x3510D348, "traced" },
    { 0x84B4ECDC, "tracedata" },
    { 0xA4E5A3CA, "tracedeath" },
    { 0xD09017F9, "tracedir" },
    { 0x052099E4, "tracedist" },
    { 0xEA5795FC, "tracedistsq" },
    { 0x7BA56AF3, "traceend" },
    { 0xBB98984F, "traceendpos" },
    { 0xCA852D27, "tracefwd" },
    { 0x4F91A87D, "traceheight" },
    { 0x116E68C3, "tracehit" },
    { 0x663B67C7, "traceleft" },
    { 0x54E64160, "tracelength" },
    { 0x3DF1FB54, "tracemask" },
    { 0xD48C0D3E, "tracemax" },
    { 0x698E97E0, "tracemin" },
    { 0x25393FBD, "tracenormal" },
    { 0x4ECD9255, "traceoffset" },
    { 0xC4B297D4, "traceoffsetabove" },
    { 0x1AE5064C, "traceoffsetbelow" },
    { 0xF97CA3E6, "traceorg" },
    { 0x05EA86C2, "traceorigin" },
    { 0x4B1A1B0D, "traceorigins" },
    { 0xA933BC84, "tracepassed" },
    { 0xF828B991, "tracepassedonnavmesh" },
    { 0xB3BB41E6, "tracepoint" },
    { 0xF7E77722, "tracepos" },
    { 0x7A3AC87D, "traceposition" },
    { 0x7947584E, "tracer" },
    { 0x385B0204, "tracer_end" },
    { 0xD57D18B2, "tracer_origins" },
    { 0x3B6BA76F, "tracer_start" },
    { 0xA119A1D5, "tracer_structs" },
    { 0xF91B710F, "traceresult" },
    { 0x3BFBB5D6, "traceresults" },
    { 0x6181DFDA, "tracerfire" },
    { 0xDB9ACF42, "traceright" },
    { 0x73752EF1, "tracers" },
    { 0xFA211A3E, "tracers_and_blood_damage" },
    { 0x9F49D2B7, "traces" },
    { 0xFAC488DF, "traceshow" },
    { 0xEB736920, "tracestart" },
    { 0x25B06A2E, "tracestartpos" },
    { 0xE951EDAE, "tracesthisframe" },
    { 0x7DD6E9EF, "tracetarget" },
    { 0x125EBA4D, "tracetimecheck" },
    { 0x0865E83E, "tracetimecheckhalfms" },
    { 0xD996077F, "traceto" },
    { 0x9446F2BF, "tracezoffset" },
    { 0x346E2A8D, "tracing" },
    { 0x893E887A, "track" },
    { 0x22163724, "track_ai_explodingvehicles_death" },
    { 0x8094B90B, "track_and_shoot_heli" },
    { 0x03EF8718, "track_array" },
    { 0x0F21649C, "track_available_rockets" },
    { 0xB538B286, "track_bike_landing" },
    { 0x7AC16261, "track_bike_liftoff" },
    { 0xFBA07BEB, "track_blackjack_consumable" },
    { 0x2050BB79, "track_blackjack_consumable_singleton" },
    { 0x0C830D08, "track_buildable_piece_pickedup" },
    { 0x0DDBD05A, "track_buildable_pieces_built" },
    { 0x1B46C55B, "track_buildables_built" },
    { 0x762F0266, "track_buildables_pickedup" },
    { 0x3150961B, "track_buildables_planted" },
    { 0x218A4027, "track_capture_time" },
    { 0x4C7B276B, "track_carrier" },
    { 0x08AD4BF1, "track_clip_damage" },
    { 0x2D8E97B2, "track_cooked_detonation" },
    { 0x3C1396D6, "track_count" },
    { 0x874D3DDD, "track_cpoints" },
    { 0x12DA47AE, "track_craftable_piece_pickedup" },
    { 0x48946939, "track_craftable_pieces_crafted" },
    { 0xF3126F50, "track_craftables_crafted" },
    { 0x165DF10C, "track_craftables_pickedup" },
    { 0x789DE941, "track_craftables_planted" },
    { 0x02C9B5FC, "track_crafted_staff_trigger" },
    { 0x66125ECE, "track_damage_and_sink" },
    { 0x3910F725, "track_death" },
    { 0x798699DA, "track_defender_deaths" },
    { 0x9C89852F, "track_dist_squared" },
    { 0x6A3D5EAF, "track_door_entry_exit" },
    { 0x88902238, "track_encounters_win_stats" },
    { 0x0C076F30, "track_ent" },
    { 0x9F0575CA, "track_ent_chain" },
    { 0x4934BDAD, "track_fire" },
    { 0x4E36223D, "track_free_played_time" },
    { 0x451BCDB7, "track_general_contractor" },
    { 0x8CC40D64, "track_gibs" },
    { 0xF1F40D91, "track_grass_guy_achievement" },
    { 0x1F3F22BA, "track_grenade_origin" },
    { 0xF17C9B4F, "track_gunner_death" },
    { 0xE7AEFB6B, "track_headshot_count" },
    { 0x056992F5, "track_hell_hound_kills" },
    { 0xEFFE817A, "track_id" },
    { 0x3BCB4D9F, "track_instant_melee_kills" },
    { 0x6B64EF93, "track_kills_over_time" },
    { 0xFB31942F, "track_knockdown" },
    { 0x372BCBF8, "track_lens_flare" },
    { 0x99746179, "track_lifted_for_ragdoll_count" },
    { 0x96634B70, "track_main_direction" },
    { 0x76AA5572, "track_max_player_zombie_points" },
    { 0xAD4D306D, "track_muj_tank_death" },
    { 0xB1D3FF14, "track_multi_detonation" },
    { 0xDD89E588, "track_name" },
    { 0x5BF5EF06, "track_nml_time" },
    { 0x335EEFF5, "track_perk_a_holic" },
    { 0x975CB5F6, "track_placed_buildables" },
    { 0x98805434, "track_placed_craftables" },
    { 0x858A068F, "track_planted_buildables_pickedup" },
    { 0x703326B9, "track_planted_craftables_pickedup" },
    { 0xE7A40E44, "track_played_time" },
    { 0x7129CDE6, "track_player" },
    { 0x9C0959AB, "track_player_completed_cycle" },
    { 0x7888D483, "track_player_eyes" },
    { 0x33CDF05C, "track_player_in_blocking_points" },
    { 0xBD1089C0, "track_player_proximity" },
    { 0x3C23B4FA, "track_player_wait" },
    { 0x562C7432, "track_players_ammo_count" },
    { 0xDE6BAE26, "track_players_intersection_tracker" },
    { 0xF0CD0D99, "track_points_spent" },
    { 0x25FABC33, "track_punches" },
    { 0x427B7846, "track_punches_single" },
    { 0x45AFF2D1, "track_quest_status_thread" },
    { 0xDAC16B9A, "track_quest_status_thread_custom_func" },
    { 0x4CB9C999, "track_riot_shield" },
    { 0x7D438588, "track_saveanderson" },
    { 0xC66BA920, "track_spawned_tower_guy_death" },
    { 0xFBA8345F, "track_spotlight_achievement" },
    { 0x1B5822FE, "track_spotlight_achievement_helper" },
    { 0x53AD8621, "track_staff_weapon_respawn" },
    { 0xC3E7AE8E, "track_takeoff_node" },
    { 0xB5349D82, "track_target" },
    { 0x059384E9, "track_thug" },
    { 0x3AE627C6, "track_total_zombie_killed" },
    { 0x9C78E254, "track_trap_killed" },
    { 0x29E8C2E4, "track_tunnel_death" },
    { 0xA1CF9D66, "track_tunnel_enemies" },
    { 0x86420DF1, "track_type" },
    { 0xCE88C6E2, "track_unit_type_usage" },
    { 0xA245CEC0, "track_unitfirewatch" },
    { 0x58097253, "track_vehicle_achievement" },
    { 0xB8E4E274, "track_water_tower_triggers" },
    { 0x2919CD8C, "track_wave2_plane1" },
    { 0x855A5559, "track_weapon_shot_fired" },
    { 0xA58FCCC1, "track_weapon_usage" },
    { 0xDF0DB0EF, "track_wmd_achievement" },
    { 0x6EA3B526, "track_zhao_and_woods_unload_horse" },
    { 0x08E6CD0E, "trackactivekillstreak" },
    { 0xE9C83446, "trackaimawarenessloop" },
    { 0x404C09A2, "trackassists" },
    { 0x19BC0E4E, "trackattackeedeath" },
    { 0x0127EA28, "trackattackerdamage" },
    { 0xD252C0D3, "trackattackerkill" },
    { 0x3D462B07, "trackattackerleaderboarddeathstats" },
    { 0x12CCFC9F, "trackbouncingbettiesonowner" },
    { 0xC284F8F6, "trackbouncingbettyasused" },
    { 0x70C7CE7A, "trackcarrier" },
    { 0x3017C7BA, "trackcollision" },
    { 0x8FD599BA, "trackcoverparamsservice" },
    { 0x4295346E, "trackdelayweapons" },
    { 0xD27C3D06, "trackdistancestops" },
    { 0xB95A5C48, "trackdoublejumpdistance" },
    { 0x02359D0D, "tracked" },
    { 0xB2D8487A, "trackedplayer" },
    { 0xA1B4E827, "trackentity" },
    { 0x587B88A6, "trackequipmentchange" },
    { 0x16584ECB, "tracker" },
    { 0xF292ECE7, "tracker_flying" },
    { 0x3CC80524, "tracker_fx_fly_distance" },
    { 0x02BA8837, "tracker_fx_fly_distance_sq" },
    { 0xD1496834, "tracker_fx_fly_height" },
    { 0xBE281CC7, "tracker_fx_foot_distance" },
    { 0x8F6B5F0E, "tracker_fx_foot_distance_sq" },
    { 0xB81E4A07, "tracker_fx_foot_height" },
    { 0xA2096997, "tracker_killcam_count" },
    { 0xE9B59465, "tracker_killcam_time" },
    { 0x5EE6531C, "tracker_killfx_count" },
    { 0x854F4BEC, "tracker_killfx_time" },
    { 0x35581821, "tracker_last_pos" },
    { 0xC64FDEB6, "tracker_playfx" },
    { 0xA5826844, "tracker_stationary_vel" },
    { 0x9866C217, "tracker_stationary_vel_sq" },
    { 0x3D40432A, "trackers" },
    { 0xD3F8D1EF, "trackerspecialtycounter" },
    { 0x5DFA8617, "trackerspecialtyself" },
    { 0x9A8FF6E2, "trackfreeplayedtime" },
    { 0x1B0A5CEF, "trackgrenades" },
    { 0x34F9B12E, "trackheropoweractivated" },
    { 0x90C48E4A, "trackheropoweravailable" },
    { 0x3591FCDC, "trackheropowerexpired" },
    { 0x0EDBF066, "trackindex" },
    { 0x6FE4CF36, "tracking" },
    { 0x2F2BA7AA, "tracking_inner_dist" },
    { 0xFF241EF5, "tracking_outer_dist" },
    { 0x775EAC8C, "tracking_turn_give_up_time" },
    { 0xCE86B14C, "tracking_turn_perfect_info_dist" },
    { 0x1EBFC27C, "tracking_turn_yaw" },
    { 0xE280D384, "tracking_var" },
    { 0x47CA378C, "trackkillstreaksupportkills" },
    { 0x53B63E57, "trackleaderboarddeathsduringusestats" },
    { 0x2A0C6D80, "trackleaderboarddeathstats" },
    { 0x9D1AE9CE, "tracklength" },
    { 0xA5FBF5CC, "trackloop" },
    { 0xB91D47F3, "trackloopgetcqbshootpos" },
    { 0x78C2D7B9, "trackloopgetshootfromangles" },
    { 0xEB8A11C9, "trackloopgetshootfrompos" },
    { 0x9874F6C1, "tracklooppacer" },
    { 0x39EF548A, "tracklooppause" },
    { 0x4C70F7EE, "tracklooppausethread" },
    { 0x4F69BF98, "trackloopstart" },
    { 0x6646BB60, "trackmaindirection" },
    { 0xE0CADA07, "trackname" },
    { 0x3F5EEA16, "trackonowner" },
    { 0x8213BE5E, "trackpickup" },
    { 0x4B4B2C58, "trackplayedtime" },
    { 0x002E46BB, "trackplayerorigin" },
    { 0x81E8F9FE, "trackplayerstats" },
    { 0xBA7E4238, "trackproximitygrenadesonowner" },
    { 0xC308D92F, "trackriotshield" },
    { 0xBCA3FE29, "trackriotshieldattractor" },
    { 0x40F769F5, "tracks" },
    { 0xEF9A9B04, "tracks_highroller_achievement" },
    { 0xABE01F70, "trackscompleted" },
    { 0x5368A7AA, "trackscriptstate" },
    { 0xEAAE596A, "tracksensorgrenadevictim" },
    { 0x5A9CBF6D, "trackshootentorpos" },
    { 0xCB6703EF, "tracksprintdistance" },
    { 0xDE1118A5, "trackstarttime" },
    { 0x87E07EB3, "trackstuckzombies" },
    { 0x11BBAA1F, "tracktargettogoal" },
    { 0x829DA249, "trackusedonhack" },
    { 0x97410D9E, "trackusedstatondeath" },
    { 0x3E6A4DD7, "trackvelocity" },
    { 0x66AFE8F9, "trackwagerweaponusage" },
    { 0x975C673E, "trackwallrunningdistance" },
    { 0x5BAB57CA, "trackweapon" },
    { 0x7F2FA4B6, "trackweaponfire" },
    { 0x05C35C47, "trackweaponfirenative" },
    { 0x236F7FAF, "trackweaponstats" },
    { 0xC32080CB, "trackweaponusage" },
    { 0x26D88099, "trackweaponzm" },
    { 0xAE16D9FC, "trackwithhead" },
    { 0xCFBA0A02, "tractor" },
    { 0x3BE8B1DF, "traded" },
    { 0x0D444193, "tradiational" },
    { 0xCBB922AB, "tradition" },
    { 0x9C83DCCD, "tradius" },
    { 0x0480D404, "traffic" },
    { 0x75832F5B, "traffic_dude" },
    { 0xDB1EBC6C, "traget" },
    { 0x8505C247, "trail" },
    { 0x958067D3, "trail_debug" },
    { 0xBFD2BEC1, "trail_effect" },
    { 0x3755E24E, "trail_effect_ender" },
    { 0xAB3CF418, "trail_fx" },
    { 0x86EEF393, "trail_fx_fly_l" },
    { 0x95159620, "trail_fx_fly_l_fast" },
    { 0x42B86E8D, "trail_fx_fly_r" },
    { 0x5584908A, "trail_fx_fly_r_fast" },
    { 0x30D631DE, "trail_fx_foot_l" },
    { 0x2AC2A73B, "trail_fx_foot_l_fast" },
    { 0x7CDB26B0, "trail_fx_foot_r" },
    { 0x1067E345, "trail_fx_foot_r_fast" },
    { 0x8044CDA2, "trail_tag" },
    { 0x775916CA, "trailer" },
    { 0xBFDD36A0, "trailer_model" },
    { 0x2514BF05, "trailers" },
    { 0x195943A1, "trailfx" },
    { 0xAA661DBF, "trailfx_looper" },
    { 0x5149C399, "trailing" },
    { 0x73F702F0, "trailprint" },
    { 0x7F140973, "trailrightfoot" },
    { 0x33FDC23E, "trails" },
    { 0x3900CD75, "train" },
    { 0xB9BA1434, "train_and_truck_warp" },
    { 0x86638A28, "train_angles" },
    { 0x019DDD43, "train_attach_points" },
    { 0xCE53D6BC, "train_audio_end" },
    { 0x9CF72ECD, "train_cars" },
    { 0xC85F8026, "train_connectpaths" },
    { 0x6BA8817A, "train_enter" },
    { 0x62149650, "train_exit_double_anim" },
    { 0x35B630B5, "train_exit_triple_anim" },
    { 0xF8647197, "train_exposure" },
    { 0x516CA3D2, "train_foreshadow" },
    { 0x9D6421B7, "train_fx_think" },
    { 0x418EB494, "train_guy_climb_flatbed" },
    { 0xF77AA25B, "train_guy_climb_run_boxcar" },
    { 0xD614AF82, "train_guy_strat" },
    { 0xA1B5C4D0, "train_guys" },
    { 0xA18E0572, "train_has_stopped" },
    { 0x5777EF43, "train_jump_debug_info" },
    { 0x7F6582B0, "train_jump_rumble" },
    { 0x9AFBF0D3, "train_jump_shake" },
    { 0x2D5322BA, "train_jump_timer" },
    { 0xFB2B02D1, "train_leave_timeout" },
    { 0x51765FC0, "train_leaving" },
    { 0xD8B88BF3, "train_left_path" },
    { 0xD254802A, "train_logic" },
    { 0x530FF9BF, "train_move" },
    { 0xA842CAA6, "train_move_think" },
    { 0xEE70EABC, "train_on_shake" },
    { 0xA3275B98, "train_positions" },
    { 0x023CC4F6, "train_ride" },
    { 0xFEFD4298, "train_right_path" },
    { 0x573C82E7, "train_rumble" },
    { 0x439A37AC, "train_start" },
    { 0x35606C60, "train_stop" },
    { 0x45A8FAC8, "train_stopping" },
    { 0x091CE410, "train_think" },
    { 0x7EE2E723, "train_turbulence" },
    { 0x8AFDE286, "train_wait_for_jump" },
    { 0x8982CD93, "train_waver_1" },
    { 0x177B5E58, "train_waver_2" },
    { 0x3BF49192, "train_wavers" },
    { 0xF7C556C8, "train_yard" },
    { 0xF11743FD, "traincar" },
    { 0x330F8BBC, "traincars" },
    { 0xF317FB0B, "trainee" },
    { 0x0039A06A, "trainees" },
    { 0xCD3983CC, "trainend" },
    { 0x66F2A32B, "trainengine" },
    { 0x93B74CF3, "training" },
    { 0x32C6DD76, "training_amb" },
    { 0x6D82C6D9, "training_anim" },
    { 0xBDDB9FEC, "training_fx" },
    { 0x545CE05C, "training_max_speed" },
    { 0x9B3E8FAB, "training_stalltriggers" },
    { 0x45F827E3, "training_targetdummies" },
    { 0x9141FD6B, "trainkilltrigger" },
    { 0xC07549AD, "trainoriginalposition" },
    { 0x253D23EF, "trainride" },
    { 0xC1527EEF, "trainride_vo" },
    { 0x9EC50C44, "trains" },
    { 0x7647BC67, "trainstart" },
    { 0x988A7FB2, "traintime" },
    { 0x3D79CB63, "traintiming" },
    { 0x2C0A035B, "traintrigger" },
    { 0xB58C037A, "traintriggers" },
    { 0x560723C5, "trainyard" },
    { 0xCE88BC74, "trainyard_elevator_escape_ready" },
    { 0xFAD5FF7A, "trainyard_light_off" },
    { 0x79D9562C, "trainyard_light_on" },
    { 0x8D3AC40D, "trainyard_melee_finished" },
    { 0xF113E471, "trainyard_runner_logic" },
    { 0x7893A129, "trainyard_soldier_logic" },
    { 0xAE7ECF39, "trainyard_vision_think" },
    { 0xB519958F, "trait" },
    { 0x03F7D35C, "traitor" },
    { 0xAD0F2B56, "traits" },
    { 0x504CE9E2, "trajectories" },
    { 0xAB0AE88A, "trajectory" },
    { 0x8495EA95, "traking" },
    { 0xD465861D, "tram" },
    { 0xB76FECF9, "tram_a" },
    { 0x2713C40A, "tram_at_start" },
    { 0xDD726762, "tram_b" },
    { 0x9B415974, "tram_node" },
    { 0xC5223586, "tram_node_array" },
    { 0x2CC22123, "tram_wait" },
    { 0xF78FDBE6, "trample" },
    { 0x17D0B54C, "trampled_under_hoof" },
    { 0xA7E03E5C, "trams" },
    { 0x0C81A74E, "tranfered" },
    { 0xF55AD468, "tranistion" },
    { 0xB22D4C39, "trans" },
    { 0xB0C37702, "trans1" },
    { 0x93FC360B, "trans1e" },
    { 0x8AC0FC99, "trans2" },
    { 0x6B6C67E4, "trans_amb" },
    { 0x3E17121B, "trans_anim" },
    { 0x6D9EC122, "trans_cam1" },
    { 0x479C46B9, "trans_cam2" },
    { 0xEE61DD11, "trans_in" },
    { 0x56700087, "trans_in_time" },
    { 0x0647AE6C, "trans_num" },
    { 0x8971DFEC, "trans_out_time" },
    { 0xC50BAE94, "trans_set" },
    { 0x6D1D5C0D, "trans_speed" },
    { 0x0F5D9328, "trans_start" },
    { 0xD963ABAF, "trans_time" },
    { 0xA1627677, "trans_time_glow_shader" },
    { 0x6796EAFF, "trans_time_id_shader" },
    { 0x8B3F49C6, "trans_to_swimtobase" },
    { 0x4A6E265E, "transanim" },
    { 0x3DD37C0A, "transanimslot" },
    { 0xCE8C5BF0, "transdecrunning" },
    { 0xDBE761FC, "transfer" },
    { 0xB3E176B3, "transfer_fn" },
    { 0xF1B0CA0E, "transfer_plane_trigger" },
    { 0x02ABAE89, "transfer_pos_as_is" },
    { 0x33BBF986, "transfer_route" },
    { 0xD37C6CDF, "transfered" },
    { 0xD02D0F6B, "transferheadchopper" },
    { 0x30C225CC, "transfering" },
    { 0xE7065E3D, "transferobjectivepositionentity" },
    { 0x6D8CA219, "transferred" },
    { 0xC1A2DB4A, "transferring" },
    { 0x7921BE25, "transferriotshield" },
    { 0x7C0CEFBF, "transfers" },
    { 0xE5627A70, "transferslipgun" },
    { 0x043D9FE2, "transferspringpad" },
    { 0x635BC3E2, "transfersubwoofer" },
    { 0x7A0B20AD, "transfertrap" },
    { 0xFBB07429, "transferturbine" },
    { 0x67DDE21A, "transferturret" },
    { 0x16C14F03, "transform" },
    { 0x7DD4E7AE, "transformation" },
    { 0x0C7B4FF8, "transformed" },
    { 0x77B75FC2, "transformed_points" },
    { 0x906287DE, "transformer" },
    { 0xD4DD2C84, "transformer_array" },
    { 0x1E58A940, "transformer_explode" },
    { 0xCAA0E32C, "transformer_pairs" },
    { 0x1EB552ED, "transformer_timer_init" },
    { 0x22532741, "transformers" },
    { 0x025E1D0B, "transformwhenenemyclose" },
    { 0x7EA84011, "transient" },
    { 0xC64A223B, "transindex" },
    { 0x4FAAB33A, "transit" },
    { 0xEDF8E1CB, "transit_actor_damage_override_wrapper" },
    { 0x6F60687A, "transit_audio_custom_response_line" },
    { 0x36759A11, "transit_breadcrumb_store_func" },
    { 0xD5677B47, "transit_breakable_glass" },
    { 0x20CBABD4, "transit_breakable_glass_init" },
    { 0x16B11A0E, "transit_buildable_vo_override" },
    { 0x060E16E7, "transit_bus_update_retrieve_trigger" },
    { 0xD3C163BC, "transit_craftable_vo_override" },
    { 0x931FD0B5, "transit_custom_death_vox" },
    { 0x212BBBB7, "transit_custom_deny_vox" },
    { 0xC950F241, "transit_custom_powerup_vo_response" },
    { 0x4972A779, "transit_gump_preallocate" },
    { 0x51A62456, "transit_ignore_spawner" },
    { 0x82B56301, "transit_intermission" },
    { 0x6C689D95, "transit_navcomputer_remove_card_on_success" },
    { 0x948134E8, "transit_pathnode_spawning" },
    { 0xA3DA2FDD, "transit_player_fake_death" },
    { 0x929C65C4, "transit_player_fake_death_cleanup" },
    { 0x04A7B769, "transit_player_fake_death_zombies" },
    { 0xEA2285E1, "transit_region" },
    { 0xD60A472E, "transit_respawn_override" },
    { 0xA3C756EC, "transit_screecher_cleanup" },
    { 0x1571C9BE, "transit_sidequest_achieved" },
    { 0x99DC5F19, "transit_special_weapon_magicbox_check" },
    { 0x4541F6FB, "transit_sq_started" },
    { 0xEB19D7ED, "transit_standard_intermission" },
    { 0x510407ED, "transit_vault_breach" },
    { 0xE3E6F526, "transit_vault_breach_init" },
    { 0xFCD1FC70, "transit_vision_change" },
    { 0x91C5091E, "transit_vision_init" },
    { 0x72963128, "transit_zone_init" },
    { 0x2D0B1520, "transition" },
    { 0xBB6FA698, "transition_anim" },
    { 0x208BFB32, "transition_camera" },
    { 0xA9379A04, "transition_camera_immediate" },
    { 0xA49AD7F1, "transition_dialogue" },
    { 0x58A3879B, "transition_done" },
    { 0xE44E4C34, "transition_filter_index" },
    { 0xA0F506BF, "transition_from_name" },
    { 0xC29FAA32, "transition_in" },
    { 0xE6918956, "transition_off" },
    { 0x8B1431C8, "transition_on" },
    { 0x23F7BAE5, "transition_out" },
    { 0xFAC1F3F8, "transition_pct" },
    { 0x9BAD5680, "transition_shader" },
    { 0x73A141CA, "transition_sky" },
    { 0x5463D1C4, "transition_smoother" },
    { 0x37994F97, "transition_sounds" },
    { 0x957E9A86, "transition_stair_count" },
    { 0xD0BD1A24, "transition_stair_count_in" },
    { 0x6905B43B, "transition_stair_count_out" },
    { 0x1CBF30CA, "transition_state" },
    { 0x6AE7A70A, "transition_streamer_timeout" },
    { 0xF72A3313, "transition_structs" },
    { 0xCF892542, "transition_text" },
    { 0x1DD55F84, "transition_time" },
    { 0x0C44B953, "transition_time_short" },
    { 0x29AD474C, "transition_to_laos" },
    { 0x6DDF336F, "transition_to_section_2" },
    { 0x5D4C0597, "transitional" },
    { 0x48090FFC, "transitional_dialogue" },
    { 0x7C30E9DF, "transitionanim" },
    { 0x009753D2, "transitionanimname" },
    { 0x0E1C6407, "transitionanimparent" },
    { 0x3962ADF6, "transitionedtoidle" },
    { 0x27B66A4D, "transitionin" },
    { 0x0805E5B8, "transitioning" },
    { 0x07E7B9EB, "transitionnotify" },
    { 0xB48CB32C, "transitionout" },
    { 0x2E0882AD, "transitionrunning" },
    { 0x99B36FCB, "transitions" },
    { 0x506DFE5B, "transitiontime" },
    { 0x685B7ACB, "transitionto" },
    { 0xF3EB6F67, "transitiontocombat" },
    { 0xC881F7ED, "transitiontoidle" },
    { 0xC52AFEB3, "transitiontostance" },
    { 0xC82993E3, "transitiontotacticalwalk" },
    { 0xA5508FF1, "transkeys" },
    { 0x1EC0118D, "translate" },
    { 0xC83C076B, "translate_notify_1" },
    { 0xE997DD3B, "translate_time" },
    { 0x9D026A33, "translated" },
    { 0x00EE255F, "translatedf" },
    { 0x62DD3E0C, "translates" },
    { 0x113A2538, "translating" },
    { 0x604C02B2, "translation" },
    { 0xCAC1A3DB, "translation_x" },
    { 0xA4BF2972, "translation_y" },
    { 0x7EBCAF09, "translation_z" },
    { 0x1FA2E258, "transmisisons" },
    { 0x4DCED349, "transmission" },
    { 0x27267B33, "transmission_main" },
    { 0xC6C169D5, "transmit" },
    { 0x459F0753, "transmittargetname" },
    { 0x102CA930, "transmitted" },
    { 0x9413E116, "transmitter" },
    { 0xC91DE6A5, "transmitting" },
    { 0xC0114F4E, "transmute" },
    { 0x71F655BB, "transparency" },
    { 0xBCAC44F1, "transparent" },
    { 0x8212B8E6, "transparentparticles" },
    { 0xFD445FC5, "transponder" },
    { 0xD09DE374, "transport" },
    { 0xC74A6F86, "transport_array" },
    { 0x3AEEF080, "transport_icon_size" },
    { 0x3A5FA798, "transport_item_height" },
    { 0x244086DB, "transport_item_width" },
    { 0x47A5B9CA, "transport_player_to_start_zone" },
    { 0xECBA9DD0, "transport_refuel_delay" },
    { 0x61AD9DAE, "transport_state" },
    { 0xD087A9E9, "transport_status_avail" },
    { 0x6EBCFB46, "transport_status_beingloaded" },
    { 0x1A98443B, "transport_status_inflight" },
    { 0x06E98021, "transport_status_refueling" },
    { 0x5EE2F8BA, "transport_unload" },
    { 0x50521AE9, "transport_width" },
    { 0xB514FB68, "transport_x_spacer" },
    { 0xC4F81447, "transport_y_spacer" },
    { 0xCB4F3D0B, "transportation" },
    { 0xEF52B203, "transportdlg" },
    { 0x82F32E11, "transporter" },
    { 0xAEBC2567, "transports" },
    { 0x2A0548CF, "transportshow" },
    { 0xF3E1B573, "transportstate" },
    { 0xBE97CD8D, "transportstateinit" },
    { 0x05F6E984, "transportthink" },
    { 0x69C0D8EE, "transtime" },
    { 0x8AE6B687, "transtion" },
    { 0xF0849061, "transtype" },
    { 0xEFCF8008, "transtypes" },
    { 0xE6454EC8, "trap" },
    { 0xFE04B150, "trap_activate" },
    { 0x8EAF5E22, "trap_activate_electric" },
    { 0x33237593, "trap_activate_fire" },
    { 0x34EE4DC7, "trap_activate_flipper" },
    { 0x50DD0D2F, "trap_activate_rotating" },
    { 0x887F2334, "trap_activated" },
    { 0xE914F105, "trap_array_remove" },
    { 0xCF16CEDB, "trap_audio" },
    { 0x23927464, "trap_audio_fx" },
    { 0xCA930FE2, "trap_batteries" },
    { 0xF5C91E23, "trap_checker_strat" },
    { 0x875C3787, "trap_checkers" },
    { 0x8DC73880, "trap_cover" },
    { 0x1FA521C0, "trap_damage" },
    { 0x9AF41A5A, "trap_damage_callback" },
    { 0xD4C20C3B, "trap_dialog" },
    { 0xF9615AD9, "trap_disable" },
    { 0xB82762E3, "trap_done" },
    { 0x94A3868B, "trap_door" },
    { 0xE2D7E9BC, "trap_door_clip" },
    { 0x20537EFA, "trap_electric_visionset_registered" },
    { 0x7C56054A, "trap_enable" },
    { 0x2B5E385C, "trap_finished_" },
    { 0xDAA84641, "trap_fire_visionset_registered" },
    { 0x9B0B8F8E, "trap_fx_monitor" },
    { 0x794097F0, "trap_guy" },
    { 0xCF2693F8, "trap_in_range" },
    { 0x22C40F09, "trap_init" },
    { 0xC5DEC0DB, "trap_kill" },
    { 0x5F7253FA, "trap_kills" },
    { 0xA9DFC1D0, "trap_lights_green" },
    { 0xB129E250, "trap_lights_red" },
    { 0x3FE80398, "trap_main" },
    { 0x3A5EED56, "trap_mode" },
    { 0x427B42AE, "trap_model" },
    { 0x84C62DCE, "trap_model_type_init" },
    { 0x4C764E93, "trap_move_switches" },
    { 0xD5A5EA5F, "trap_piece" },
    { 0xDED16A31, "trap_piece_deliver_clean_up" },
    { 0x5B6EE0EB, "trap_piece_returned" },
    { 0x0D99DAAD, "trap_piece_triggers" },
    { 0x68C9B7DE, "trap_play_fx" },
    { 0x64CB66E8, "trap_power_off" },
    { 0xC1C95702, "trap_power_on" },
    { 0x16180C77, "trap_reaction_func" },
    { 0xB7DC1440, "trap_reload_time" },
    { 0xAF0362EA, "trap_removed_to_make_room" },
    { 0x5B4D35AF, "trap_set_string" },
    { 0x5EA4BBD5, "trap_smash" },
    { 0x0832AABF, "trap_sounds" },
    { 0x31D9BABE, "trap_spots" },
    { 0x1F6F8BE8, "trap_sprung" },
    { 0xEB58A258, "trap_target" },
    { 0x3DE7BDA5, "trap_tear_down_monitor" },
    { 0x020F15B9, "trap_trigger" },
    { 0x25CD50F0, "trap_triggers" },
    { 0x906DDD88, "trap_trigs" },
    { 0x04B50D37, "trap_type" },
    { 0xD05F3F0D, "trap_use_think" },
    { 0x5B8892D8, "trapdoor" },
    { 0x57B0B113, "trapdoor_angles" },
    { 0xF1DBCF0D, "trapdoor_origin" },
    { 0x86E948F2, "trapfx" },
    { 0x7047BABB, "trapped" },
    { 0x607479B3, "trapped_horse_update" },
    { 0xA46767F3, "trapped_track" },
    { 0xD36BD849, "trapped_used" },
    { 0x99E8B4E3, "traps" },
    { 0x7393A4E1, "trash" },
    { 0xF40ECA61, "trash_boats" },
    { 0xFEBF89AD, "trashcan" },
    { 0xA5347C1A, "trashcan_rig" },
    { 0x1CB5C5C2, "trashstumble_guards" },
    { 0x71C86739, "travel" },
    { 0x4CE552E1, "travel_complete" },
    { 0x00262B80, "travel_down" },
    { 0xDE6A465D, "travel_offset" },
    { 0x7E7EFE79, "travel_path" },
    { 0x6E063CAF, "travel_time" },
    { 0xB76FBFBB, "travel_up" },
    { 0x88CCD881, "travelaccelerationduration" },
    { 0x0AD3D606, "travelangle" },
    { 0xF9D16684, "traveldecelerationduration" },
    { 0x05136174, "traveldistance" },
    { 0x9D04A766, "traveled" },
    { 0x58CE2260, "traveler" },
    { 0x1427F05A, "travelerfx" },
    { 0x6A46AC61, "travelertell" },
    { 0xADD65037, "travelertellfx" },
    { 0x4071814F, "traveling" },
    { 0x4F106DCC, "travelled" },
    { 0x5AC2BE59, "travelling" },
    { 0x04946B43, "travelradius" },
    { 0x5656C9C5, "travelright" },
    { 0x86889D70, "travels" },
    { 0xF2B2A3EE, "traveltime" },
    { 0xC1A40145, "travelto_next_spot" },
    { 0x3F017D4E, "traveltonode" },
    { 0xFC91DBEA, "traversable" },
    { 0x6BDCDC05, "traversal" },
    { 0x807AD21E, "traversal_anims" },
    { 0xA2CC4F96, "traversal_blocker" },
    { 0x76BFD1C3, "traversal_blocker_disabler" },
    { 0x5A1C6C9C, "traversal_booster_fx_watcher" },
    { 0x4C7B12B7, "traversal_end" },
    { 0x996FD89F, "traversal_nodes" },
    { 0x427A89E1, "traversal_timeout" },
    { 0x2EFE01A7, "traversal_turn_off_roll_over_44" },
    { 0x6EE5A120, "traversal_type" },
    { 0xD3C91D32, "traversaldir" },
    { 0x00BC7A94, "traversals" },
    { 0xAC4FB293, "traversalspeedboost" },
    { 0xB10EA82F, "traversalstartnode" },
    { 0xA6E85C0D, "traversaltype" },
    { 0xC1409427, "traverse" },
    { 0x8E27EFAD, "traverse_anim" },
    { 0x76FB0DFC, "traverse_death" },
    { 0x1B959CF9, "traverse_end" },
    { 0x3E09A317, "traverse_height" },
    { 0x37EDBF77, "traverseactionstart" },
    { 0xDBE5DB54, "traverseaimanims" },
    { 0x80F96F92, "traversealertness" },
    { 0x383B30ED, "traversealias" },
    { 0x5AE163FB, "traverseallowaiming" },
    { 0x555811E8, "traverseanim" },
    { 0x93018217, "traverseanimissequence" },
    { 0x9F61BF4E, "traverseanimrate" },
    { 0x437C4247, "traverseanimtransin" },
    { 0xF51309F2, "traverseanimtransout" },
    { 0xE9D41B3E, "traversecomplete" },
    { 0xA52F12A7, "traversedata" },
    { 0x62BAB55F, "traversedeath" },
    { 0xC7A12330, "traversedeathanim" },
    { 0xA533F571, "traversedeathindex" },
    { 0xA91CB55A, "traverseendnode" },
    { 0xF4F006E8, "traversefall" },
    { 0x231EEA5E, "traverseheight" },
    { 0x3CB30BF7, "traverseinfo" },
    { 0x0814A7BE, "traversemode" },
    { 0x62150CF0, "traversemovement" },
    { 0x7ED790BA, "traversename" },
    { 0x621FF452, "traverseplaybackrate" },
    { 0x2790CEA6, "traverseragdolldeath" },
    { 0x200AB8B0, "traverseragdolldeathsimple" },
    { 0x6671F49E, "traverses" },
    { 0x5248473A, "traversesetup" },
    { 0xC00AC594, "traversesound" },
    { 0x7FF89637, "traversestance" },
    { 0x59959945, "traversestartnode" },
    { 0x50856D10, "traversestartragdolldeath" },
    { 0x2C3E6F05, "traversestartz" },
    { 0x604773DA, "traversestate" },
    { 0xE99E17D6, "traversestopragdolldeath" },
    { 0x09C37F59, "traversethink" },
    { 0x5016612A, "traversetocoveranim" },
    { 0x84C2478A, "traversetocoversound" },
    { 0xE6661162, "traversing" },
    { 0x0E670DA1, "traversing_over_barrier_into_playspace" },
    { 0x8C51F63A, "travis" },
    { 0xE3DBBC94, "travisj" },
    { 0xDC33F5E9, "tray" },
    { 0x9E456BC5, "tray_curtains" },
    { 0x00FE9478, "tray_start" },
    { 0x9486FFF0, "treacherous" },
    { 0x97101F53, "tread" },
    { 0x4E145DF2, "tread_damage_fx" },
    { 0x3A66468C, "tread_fx" },
    { 0xE7DAB2A1, "tread_grind_fx" },
    { 0xD0DF28F5, "tread_override_thread" },
    { 0x5BA46817, "treaddeaddamagefactor" },
    { 0x210FC3E5, "treadfx" },
    { 0xC4EDD3E8, "treadfx_override" },
    { 0xC49DD27B, "treadfxnamearray" },
    { 0xF7EEFDC9, "treadget" },
    { 0x7BEA1003, "treadgetboat" },
    { 0x0FE6274D, "treading" },
    { 0xF7496679, "treading_drones" },
    { 0x5BE84DF1, "treading_drones_spawn" },
    { 0xE73C2382, "treads" },
    { 0x8CFEC674, "treak" },
    { 0x6CCE9E97, "treason" },
    { 0xF266A9F6, "treasure" },
    { 0x9821DA97, "treasure_chest_canplayerreceiveweapon" },
    { 0x4EFDC431, "treasure_chest_chooserandomweapon" },
    { 0xF4E72416, "treasure_chest_chooseweightedrandomweapon" },
    { 0x9C0CD747, "treasure_chest_firesale_active" },
    { 0x9BD912DB, "treasure_chest_give_weapon" },
    { 0xC6AF2B62, "treasure_chest_glowfx" },
    { 0xBBAB1CAD, "treasure_chest_init" },
    { 0xD47278DF, "treasure_chest_lid_close" },
    { 0xCA693A19, "treasure_chest_lid_open" },
    { 0x13157660, "treasure_chest_move" },
    { 0xFCE2E61E, "treasure_chest_move_vo" },
    { 0x94997C46, "treasure_chest_should_move" },
    { 0x0597887D, "treasure_chest_think" },
    { 0x26CE8514, "treasure_chest_timeout" },
    { 0x53A0B996, "treasure_chest_user_hint" },
    { 0x5E44B9BD, "treasure_chest_weapon_locking" },
    { 0xB496F4FF, "treasure_chest_weapon_spawn" },
    { 0x36E878C3, "treat" },
    { 0x8CAE0A41, "treat_owner_damage_as_friendly_fire" },
    { 0x68837A5E, "treat_self_damage_as_friendly_fire" },
    { 0xFD8CAB77, "treatallcoversasgeneric" },
    { 0x2E87C9B8, "treated" },
    { 0x7DDCB99B, "treatment" },
    { 0x39BED632, "treats" },
    { 0x509EED89, "tree" },
    { 0x2CB68092, "tree1" },
    { 0x1C5494D2, "tree1d" },
    { 0x06B40629, "tree2" },
    { 0x8E204F0F, "tree2d" },
    { 0xE0B18BC0, "tree3" },
    { 0x4F399BC4, "tree3d" },
    { 0xEAC2E49F, "tree4" },
    { 0xD774AF89, "tree4d" },
    { 0x58B42F4D, "tree_1_sound" },
    { 0x873943BA, "tree_2_sound" },
    { 0xECB97A6B, "tree_anim" },
    { 0x05221660, "tree_animates" },
    { 0x2B96D738, "tree_aquilaria_dest02" },
    { 0xA2B72D5D, "tree_aquilaria_dest02_start" },
    { 0xD6D1045B, "tree_array" },
    { 0xB221746E, "tree_array_sm" },
    { 0xE0913806, "tree_clip" },
    { 0x3D413B92, "tree_death" },
    { 0x98C885D5, "tree_destroyed" },
    { 0xD27741D1, "tree_destruction_trigger" },
    { 0xD2354F98, "tree_explosions" },
    { 0xE97CEB5F, "tree_fall" },
    { 0x8FFC75AE, "tree_fx" },
    { 0xA161327C, "tree_group_index" },
    { 0x886D71C5, "tree_guy" },
    { 0x0DBA4D39, "tree_guy_flame_sound" },
    { 0xCD996A29, "tree_intact" },
    { 0x36D89D4D, "tree_kaboom" },
    { 0xDC9BEF7D, "tree_loop_idle_anim" },
    { 0x4321F1A3, "tree_model" },
    { 0x1A4AB78A, "tree_origin" },
    { 0x6BD2CECE, "tree_palm_coco01" },
    { 0x0CE769EF, "tree_palm_coco01_start" },
    { 0x45D05465, "tree_palm_coco02" },
    { 0x092FC83C, "tree_palm_coco02_start" },
    { 0x324DC1CA, "tree_pos" },
    { 0xC96A2A19, "tree_rotate" },
    { 0x93E90C2C, "tree_search_time" },
    { 0x0B37325D, "tree_sniper" },
    { 0x6E8B8C18, "tree_sniper_check" },
    { 0xC55618F2, "tree_sniper_func" },
    { 0x57CF005C, "tree_sniper_glint" },
    { 0x2FD30F14, "tree_sniper_initialization" },
    { 0x4EA4615F, "tree_sniper_reveal" },
    { 0xBD8ADE5C, "tree_sniper_spawner" },
    { 0x18DDA8B1, "tree_sniper_spawner_func" },
    { 0x7D78FA08, "tree_sniper_think" },
    { 0x32B5329C, "tree_snipers" },
    { 0x836B0701, "tree_top_1" },
    { 0xA96D816A, "tree_top_2" },
    { 0xBAE24E2A, "tree_trig" },
    { 0xC65880EA, "tree_with_platform" },
    { 0x60501FE7, "treeang" },
    { 0x952D1BB5, "treeburst" },
    { 0xF9C16F84, "treebursts" },
    { 0x59CB13C9, "treecol" },
    { 0x5336310E, "treefall" },
    { 0x270ECBEB, "treefall_dof_get_up" },
    { 0xB2CDF541, "treefall_dof_look_down" },
    { 0x4B543BEB, "treefall_dof_look_harper_1" },
    { 0xD94CCCB0, "treefall_dof_look_harper_2" },
    { 0x4AE81A7F, "treefall_dof_look_salazar" },
    { 0xC85EF4E9, "treefall_dof_look_tree" },
    { 0x76417906, "treefall_dof_rope_cut" },
    { 0x1C62332A, "treefall_dof_rope_pulls" },
    { 0xDD7D7734, "treefall_dof_salazar_arrives" },
    { 0x3700A398, "treefall_dof_tree_impact" },
    { 0xC972E93B, "treeline" },
    { 0xDDEB5F50, "treemodel" },
    { 0xEF8DB7FD, "treeorg" },
    { 0x6012F180, "trees" },
    { 0x7368060B, "treesnipers_awake" },
    { 0x1C180F55, "treesnipers_setup" },
    { 0x1B66BF41, "treetops" },
    { 0x850867AA, "treetrigs" },
    { 0x48FD6D21, "treeup_angles" },
    { 0x5D7A2118, "treeup_vector" },
    { 0xA5ECBE0D, "trejo" },
    { 0x64C19F47, "trek" },
    { 0xD993FC5E, "treminaor" },
    { 0x9863FDC7, "trench" },
    { 0x97F99F0F, "trench_1" },
    { 0x25F22FD4, "trench_2" },
    { 0x8FBC8454, "trench_flame_structs" },
    { 0x9E656DD0, "trench_mg42_overrun" },
    { 0xCF4AC67F, "trench_name" },
    { 0x7E66AFC1, "trench_nva_fight_ai" },
    { 0xBC25BA0A, "trench_trigger" },
    { 0x7C62749D, "trench_walk" },
    { 0x24334EE4, "trench_walk_start" },
    { 0x5ADC7A6D, "trenchbattle" },
    { 0xA5386731, "trenchdefense" },
    { 0xEE5CF8B3, "trenches" },
    { 0x31654446, "trenchrun" },
    { 0x3D4678ED, "trenchrun_add_objective_to_plane" },
    { 0xE1BAD34C, "trenchrun_draw_line" },
    { 0x001955AC, "trenchrun_planes" },
    { 0x51F92632, "trenchrun_sanity_check" },
    { 0xFB43B3BA, "trenchrun_wave" },
    { 0x575D6FAD, "trespasser" },
    { 0xE9962D8C, "trespasser_perk" },
    { 0x50D09640, "trespassing" },
    { 0x820D3D79, "treyarch" },
    { 0x002276E2, "treyu_shoot_notify" },
    { 0xB8D5DC47, "trf" },
    { 0x253C57C4, "trgger" },
    { 0xB806B94E, "trgt" },
    { 0x3ABAE1F1, "trgts" },
    { 0x3F1776E5, "trhead" },
    { 0x3791DB53, "trhey" },
    { 0xCC02C54F, "triad" },
    { 0x898EF9A1, "triage" },
    { 0xD269E77B, "trial_delay" },
    { 0xB3CE6F4E, "trials" },
    { 0x3645F2E9, "triangle" },
    { 0xAEC10218, "trickery" },
    { 0x9F564BFA, "trickier" },
    { 0xB665470E, "tricking" },
    { 0x64E258ED, "tricks" },
    { 0xE0FB2107, "tricky" },
    { 0x964C8AB3, "tried" },
    { 0x3CD31902, "tried_attack" },
    { 0x5C5FCD8F, "tried_lock" },
    { 0xBE589746, "triedtraverseragdoll" },
    { 0x5C275E8C, "tries" },
    { 0x5948B3DF, "trig" },
    { 0x66E7A154, "trig1" },
    { 0xD8EF108F, "trig2" },
    { 0xB2EC9626, "trig3" },
    { 0xF4E03219, "trig4" },
    { 0x6EBC6837, "trig_1" },
    { 0xFCB4F8FC, "trig_2" },
    { 0x8F335BE7, "trig_a" },
    { 0x569B9458, "trig_access" },
    { 0x91DDF5BF, "trig_admin_back" },
    { 0xA4138B44, "trig_alley1_drones" },
    { 0xA1E44DE0, "trig_and_flag_setup" },
    { 0x0A837215, "trig_array" },
    { 0x63B3A946, "trig_axis_group1" },
    { 0xBAB9C495, "trig_axis_group1_kill" },
    { 0x3DB12EDD, "trig_axis_group2" },
    { 0x77962E90, "trig_axis_group2_kill" },
    { 0x17AEB474, "trig_axis_group3" },
    { 0x1D2BECAC, "trig_b" },
    { 0x66B649B4, "trig_bazooka_lookat" },
    { 0xC880BD6B, "trig_blowup_fakefire" },
    { 0x551B856D, "trig_bot" },
    { 0x20D5A795, "trig_bottom_floor_volume" },
    { 0x396A1051, "trig_box_carry" },
    { 0x8B2D328D, "trig_breadcrumb_escape" },
    { 0xDE5D2AC0, "trig_briggs_player_use" },
    { 0x9A239DEA, "trig_brush" },
    { 0xE66DBDB0, "trig_building_drones" },
    { 0x9E6B8DC6, "trig_building_player_breach" },
    { 0x5A6612C8, "trig_bunker_last_spawners" },
    { 0x4F32B9D5, "trig_burn_u" },
    { 0x001D864E, "trig_chain_bunkers_5" },
    { 0x322AACFF, "trig_chain_ruins_end" },
    { 0x5FE3600C, "trig_charge_drones" },
    { 0xE7FD8E2A, "trig_claymore" },
    { 0xE080C057, "trig_clean_room_player" },
    { 0x3AA95B27, "trig_clocktower_vo" },
    { 0xB4ED9EC2, "trig_cobrastreets_kill" },
    { 0x234EF476, "trig_color_leer_jet" },
    { 0x12593073, "trig_color_left_3" },
    { 0x63A65A65, "trig_color_left_3_end" },
    { 0x385BAADC, "trig_color_left_4" },
    { 0x14F08A82, "trig_color_left_4_end" },
    { 0xE4A857BB, "trig_color_pub" },
    { 0x2173240D, "trig_color_pub_end" },
    { 0xB9412FBB, "trig_colornode" },
    { 0x1905157E, "trig_contextual_melee" },
    { 0x159034C6, "trig_control_panel" },
    { 0x921B4E74, "trig_control_room_specialty" },
    { 0x1A10F5C0, "trig_damage_pillar" },
    { 0xB4E8DAAE, "trig_damage_tv" },
    { 0x963CA6CB, "trig_dc_enter_gauntlet" },
    { 0x1C1F708B, "trig_dc_guantlet_to_outskirts" },
    { 0x01922633, "trig_delay" },
    { 0xA1639569, "trig_deliver" },
    { 0xF2C49B9A, "trig_digbat_parking_lot" },
    { 0x24F8E0EB, "trig_ditch_guys" },
    { 0xCBF1B85E, "trig_dogfight" },
    { 0xB01B2282, "trig_e2_exit_ucut" },
    { 0x6F4EB9EC, "trig_e2_flame_marine" },
    { 0xF91F76AA, "trig_e2_u_cut_back_turn" },
    { 0xFBDD8DC3, "trig_e4_temple" },
    { 0x4936A7FC, "trig_elevator" },
    { 0x1C6A1B93, "trig_elevator_panel" },
    { 0x854AAB41, "trig_ent" },
    { 0xB25E3428, "trig_enter" },
    { 0x5D5CB5AC, "trig_enter_audio_material_trigger" },
    { 0xC9C207C1, "trig_enter_audio_step_trigger" },
    { 0x7EC2650F, "trig_enter_bump" },
    { 0xE9610E9B, "trig_enter_waterfall" },
    { 0x9AE7B5A1, "trig_enter_waterfall_mist" },
    { 0x045754EF, "trig_ev2" },
    { 0x3C9BC50A, "trig_fail" },
    { 0xB07CD80E, "trig_fail_player_if_backtracks" },
    { 0xB8C46D1C, "trig_fallback_archway" },
    { 0xC30C9FA0, "trig_final_drones" },
    { 0xBC98D8D6, "trig_first_gate_poppers" },
    { 0xE82995D8, "trig_flame_bunker_exit" },
    { 0x72B10F3D, "trig_flamer_explode_ready" },
    { 0xE8CE7EC5, "trig_for_vox" },
    { 0xB5BCDFAD, "trig_force_breach" },
    { 0x66D8B6E5, "trig_force_clarke_jump" },
    { 0x2B580673, "trig_funcs" },
    { 0xCA1CC817, "trig_furniture_clear_lookat" },
    { 0x19CEA572, "trig_gas_grenade" },
    { 0x570FE293, "trig_gas_on" },
    { 0x477997AA, "trig_gotcha" },
    { 0x63B86556, "trig_grass_admin_camo_guys" },
    { 0x6847F60D, "trig_grass_admin_camo_guys_2" },
    { 0x42457BA4, "trig_grass_admin_camo_guys_3" },
    { 0x6389EF22, "trig_grass_camo_guys" },
    { 0xD97C4A9F, "trig_height" },
    { 0x0E5AF1C1, "trig_hellhole" },
    { 0x897CA2CA, "trig_high" },
    { 0xB0F18A3D, "trig_hit" },
    { 0x493FB822, "trig_ignoreme" },
    { 0xF1A14BD6, "trig_index" },
    { 0x72F3D9F9, "trig_int_drones" },
    { 0xFE243739, "trig_isaac_player" },
    { 0x5A52E2B0, "trig_jap_first_wave" },
    { 0xDDAD8B37, "trig_jump_breadcrumb1" },
    { 0x6BA61BFC, "trig_jump_breadcrumb2" },
    { 0x91A89665, "trig_jump_breadcrumb3" },
    { 0x1FA1272A, "trig_jump_breadcrumb4" },
    { 0x08F641CF, "trig_key" },
    { 0x1A59E9F6, "trig_killspawner" },
    { 0x86CFADA6, "trig_last_aa_guys" },
    { 0xB01BF9D7, "trig_leave" },
    { 0x122F2249, "trig_leave_audio_material_trigger" },
    { 0x880731AC, "trig_leave_audio_step_trigger" },
    { 0xA2998812, "trig_leave_bump" },
    { 0x2BF9311C, "trig_leave_waterfall" },
    { 0x134587A8, "trig_leave_waterfall_mist" },
    { 0x9FFEB4B4, "trig_left_lobby_guy" },
    { 0x9215DFBC, "trig_low" },
    { 0x7912D757, "trig_mangrove_grenades" },
    { 0xDEA81E70, "trig_motel_fail" },
    { 0xA73B9381, "trig_move" },
    { 0x2371C377, "trig_name" },
    { 0x36D9739F, "trig_near_town" },
    { 0x24AD3E41, "trig_next_color" },
    { 0xE7BE396A, "trig_node_tick" },
    { 0xB504B9A1, "trig_notify" },
    { 0x6689AAA1, "trig_nova6_breadcrumb3" },
    { 0xA21B42D2, "trig_num" },
    { 0x52B57DF5, "trig_on_aiclear" },
    { 0x05677683, "trig_on_notify" },
    { 0xB2764A96, "trig_on_trig" },
    { 0xCB0BE248, "trig_origin" },
    { 0x806E2DC6, "trig_outside_retreat_house" },
    { 0x8FC227CA, "trig_override" },
    { 0x9438F2C2, "trig_past_last_trench" },
    { 0x923D99CC, "trig_path_right" },
    { 0x51D8A8DB, "trig_pen" },
    { 0x82445E16, "trig_pilot_putdown" },
    { 0x0A495255, "trig_player" },
    { 0x10697667, "trig_player_at_lab" },
    { 0x301BB630, "trig_player_celerium" },
    { 0x5F1D3253, "trig_player_celerium_door" },
    { 0x4C31C7F6, "trig_player_motel_door" },
    { 0x47781DA3, "trig_player_open_door" },
    { 0x39DDF30D, "trig_player_out_of_house" },
    { 0xD6150539, "trig_player_rain_drops" },
    { 0x41D85C79, "trig_player_riotshield" },
    { 0xA759CE97, "trig_playerneartank" },
    { 0x93EE1442, "trig_plaza_drones" },
    { 0x484BDBDC, "trig_pos" },
    { 0x93400C0B, "trig_position" },
    { 0xCF850134, "trig_radius" },
    { 0x799D56D9, "trig_reached_light" },
    { 0x5D82BB8B, "trig_reich_drones" },
    { 0xC55EC222, "trig_removal" },
    { 0x59016902, "trig_reset_hero_anim" },
    { 0x7A421299, "trig_right_lobby_guy" },
    { 0x694F16AE, "trig_room_enforcer" },
    { 0x25D4AB79, "trig_sal_at_asd_vol" },
    { 0x8B8582D8, "trig_script_control_btr" },
    { 0xAC8A1BEE, "trig_set_wind_goatpath" },
    { 0x5082D38F, "trig_set_wind_normal" },
    { 0x48D49559, "trig_setup_ending_limo" },
    { 0xB5C65BC3, "trig_shoulder_bash" },
    { 0x5B53F5D6, "trig_sm_lab_1_1" },
    { 0x225FF2FC, "trig_sm_lab_1_1_frontline" },
    { 0x35517B6D, "trig_sm_lab_1_2" },
    { 0xE5E1B92F, "trig_sm_lab_1_2_frontline" },
    { 0xB40DC319, "trig_sm_lab_2_1" },
    { 0xAB86131B, "trig_sm_lab_2_1_frontline" },
    { 0xDA103D82, "trig_sm_lab_2_2" },
    { 0x7D691580, "trig_sparks" },
    { 0x9418D397, "trig_spawn" },
    { 0xA9D60B7A, "trig_spawn_aa_early_mid_guys" },
    { 0x4FB7B2CE, "trig_spawn_aa_mid_guys" },
    { 0x2B702088, "trig_spawn_ambient_2_1_asd" },
    { 0xA12DF95D, "trig_spawn_area_1" },
    { 0xC73073C6, "trig_spawn_area_2" },
    { 0x1A974297, "trig_spawn_control_room_sci" },
    { 0x9D6B67AC, "trig_spawn_extra_cr" },
    { 0xC367770B, "trig_spawn_extra_locker_room" },
    { 0x81B8545F, "trig_spawn_first_hallway" },
    { 0x1E7697A3, "trig_spawn_flags" },
    { 0xE1540850, "trig_spawn_glass_room" },
    { 0x40A8E0CC, "trig_spawn_limo_2" },
    { 0x5FD8B983, "trig_spawn_offset" },
    { 0x83F1A286, "trig_spawn_onehanded_guy" },
    { 0x097A82FC, "trig_spawn_reinforcements" },
    { 0x69868DA4, "trig_spawn_second_hall" },
    { 0xF9A881E5, "trig_spawn_steam_squad" },
    { 0x06E52CC8, "trig_spawn_window_jumper" },
    { 0xFFF937FA, "trig_spawner" },
    { 0xCC2BA23A, "trig_start" },
    { 0xF97ACB85, "trig_stomp" },
    { 0x37FEA218, "trig_stomp_kill" },
    { 0xD56716C0, "trig_stomp_kill_left" },
    { 0x629E162F, "trig_stomp_kill_right" },
    { 0xA4427190, "trig_straight" },
    { 0x91089B66, "trig_stub" },
    { 0xA83D5F2D, "trig_target" },
    { 0xFA6BAB74, "trig_targetname" },
    { 0xB58E4E4E, "trig_thread" },
    { 0x33A68157, "trig_to_last_door" },
    { 0x68E5837C, "trig_to_remove" },
    { 0x3439D85B, "trig_top" },
    { 0x74108049, "trig_top_floor_volume" },
    { 0x5A3C52C4, "trig_tow" },
    { 0x876100B5, "trig_update" },
    { 0x16034767, "trig_use_door_lever" },
    { 0x088E0176, "trig_village" },
    { 0xEEE1BB68, "trig_volume_harper_throw" },
    { 0x9E7E9783, "trig_wait_for_player" },
    { 0x8F4BDC6A, "trig_warn" },
    { 0x65DE49F4, "trig_water_drops" },
    { 0x77F6C504, "trig_yard_mghouse_2" },
    { 0x9523F9E8, "trig_zsu" },
    { 0x875E9504, "triga" },
    { 0xC7ABF271, "trigarraywait" },
    { 0x18820C81, "trigarraywait2" },
    { 0xF52AB535, "trigflag" },
    { 0x4DBF3AE3, "trigger" },
    { 0x00904540, "trigger1" },
    { 0x34FCCC6B, "trigger1s" },
    { 0x7297B47B, "trigger2" },
    { 0x64BE0A1A, "trigger2s" },
    { 0x4C953A12, "trigger3" },
    { 0xBE9CA94D, "trigger4" },
    { 0x989A2EE4, "trigger5" },
    { 0x0AA19E1F, "trigger6" },
    { 0x7CBF3C53, "trigger_1" },
    { 0x0AB7CD18, "trigger_2" },
    { 0x36754391, "trigger_40mm_hit_timeframe" },
    { 0xC2377F27, "trigger_40mm_hit_timeframe_wait" },
    { 0x059D90C7, "trigger_activated" },
    { 0xB235BFA2, "trigger_air_raid_audio" },
    { 0x9F65FD99, "trigger_alive" },
    { 0x8687CFFC, "trigger_allie_sm" },
    { 0x50706D51, "trigger_ambience_touched" },
    { 0x89DF14B5, "trigger_and_delete" },
    { 0x5D6B50CA, "trigger_angles" },
    { 0xA2AF7BDB, "trigger_area_target" },
    { 0xA8E343F1, "trigger_array" },
    { 0x7863432F, "trigger_array_notify" },
    { 0x7BF64458, "trigger_arrays" },
    { 0x209E807D, "trigger_attack_before_animation_end" },
    { 0xD07ACF12, "trigger_auto_disable" },
    { 0x6D870178, "trigger_autosave" },
    { 0x633922FE, "trigger_autosave_immediate" },
    { 0x47D05069, "trigger_base_distant_helis" },
    { 0x65F6CC4A, "trigger_base_distant_helis_trig" },
    { 0x74FFAB8C, "trigger_base_migs" },
    { 0x73340120, "trigger_base_truck_04" },
    { 0x62AF6255, "trigger_beach_obj" },
    { 0xCC149C02, "trigger_behind" },
    { 0x925D5AE4, "trigger_blackhawk" },
    { 0xADA14B29, "trigger_blow_wooden_island" },
    { 0xBA0CEE6A, "trigger_body" },
    { 0x09B9D66B, "trigger_bottom" },
    { 0x54CA2200, "trigger_btr_reinforce" },
    { 0xEBEAA89C, "trigger_btr_reinforcement" },
    { 0x9D9F14AB, "trigger_cache_dialog" },
    { 0x731B6559, "trigger_cansee" },
    { 0x140A30AD, "trigger_carrier_explosions" },
    { 0xD2243DD5, "trigger_check_for_ents_touching" },
    { 0x34517FC9, "trigger_clear" },
    { 0x412D8B47, "trigger_collapse" },
    { 0x624D2C8A, "trigger_color_trigger" },
    { 0x398D38E2, "trigger_combat_roof_lighting" },
    { 0x0B8FF0E6, "trigger_coop_warp" },
    { 0xC2FCCFD7, "trigger_core" },
    { 0xD5931173, "trigger_count" },
    { 0x07EEA105, "trigger_damage" },
    { 0x68557C7D, "trigger_damage_fxanim" },
    { 0x02354BA9, "trigger_damage_waterhut_aa" },
    { 0xB0B59994, "trigger_damages" },
    { 0x5A63EAA7, "trigger_debug" },
    { 0x690464DD, "trigger_deflector_start" },
    { 0x14A3F4CF, "trigger_delete" },
    { 0xE87A9D27, "trigger_delete_on_repair" },
    { 0xE15D2D5D, "trigger_delete_on_touch" },
    { 0xBAAD2C90, "trigger_deletes_children" },
    { 0x99C9C87D, "trigger_deposit_think" },
    { 0x32E4EF39, "trigger_deposit_update_prompt" },
    { 0x229D5412, "trigger_dmg" },
    { 0x4280A107, "trigger_drop_chicken_coop" },
    { 0x673BF433, "trigger_drop_the_coop" },
    { 0x82AF2E7E, "trigger_dust" },
    { 0x452A9F35, "trigger_end" },
    { 0x513DCC96, "trigger_end1" },
    { 0x2B3B522D, "trigger_end2" },
    { 0xA55245C5, "trigger_ent" },
    { 0x6027AA72, "trigger_event" },
    { 0xB5351AA5, "trigger_event9_timer" },
    { 0xFE78B5E6, "trigger_eventname_think" },
    { 0x0E7077C6, "trigger_exit" },
    { 0xC52B5655, "trigger_exploder" },
    { 0xB3F27AB5, "trigger_flag_set" },
    { 0x0F7BE04B, "trigger_flag_set_touching" },
    { 0xC01F2B3F, "trigger_flags" },
    { 0x82F58EBE, "trigger_floodspawn_think" },
    { 0x79B697A6, "trigger_fog" },
    { 0x5398C14F, "trigger_fogdist3000" },
    { 0x7A876CC9, "trigger_fogdist5000" },
    { 0xAF347752, "trigger_found" },
    { 0x514E7902, "trigger_friendly_respawn" },
    { 0x9CE9C0F2, "trigger_friendlychain" },
    { 0xF6B53FB7, "trigger_friendlychain_think" },
    { 0x29A4F8D4, "trigger_func" },
    { 0xB4443147, "trigger_funcs" },
    { 0xE02406BA, "trigger_fvec" },
    { 0xDF502E19, "trigger_fxanim_bridge" },
    { 0x29B8275A, "trigger_fxanim_objbridge" },
    { 0xE5F062CF, "trigger_fxanim_objbridge_clip" },
    { 0xB6D76FF5, "trigger_gate_guard" },
    { 0x6BCEC2A8, "trigger_getlinkmap" },
    { 0x0F0FC5AB, "trigger_grass_guys" },
    { 0xC2CFEE19, "trigger_grenade_room_change" },
    { 0xD78451A7, "trigger_group" },
    { 0x6AA83B12, "trigger_group_" },
    { 0xB85AB1C6, "trigger_group_remove" },
    { 0xF7D5BE49, "trigger_gun_flak" },
    { 0xA4DB510B, "trigger_height" },
    { 0x309A620E, "trigger_hide" },
    { 0xA8E9C4FE, "trigger_hide_all" },
    { 0xBCBDB505, "trigger_hint" },
    { 0xF42ECA4A, "trigger_hint_func" },
    { 0x71B97B63, "trigger_hint_string" },
    { 0xE0A57996, "trigger_hintstring" },
    { 0x92E538D1, "trigger_hit" },
    { 0x591A19BE, "trigger_house" },
    { 0x9857203D, "trigger_hurt" },
    { 0x0011AE12, "trigger_hurt_monitor" },
    { 0x6EFF8D04, "trigger_hurtarray" },
    { 0x167E1904, "trigger_ignore" },
    { 0x0CBCDD38, "trigger_infront" },
    { 0x61D842AA, "trigger_inside" },
    { 0x09440BA3, "trigger_invisible" },
    { 0x846BE7C9, "trigger_is_occupied" },
    { 0x3EE0E30A, "trigger_is_on" },
    { 0x7EC03676, "trigger_issues_orders" },
    { 0x0FB1BE74, "trigger_jump_down_scene" },
    { 0x316D1D33, "trigger_key" },
    { 0x76324BBA, "trigger_kill" },
    { 0xE3395404, "trigger_kill_ai_on_contact" },
    { 0xEC76BE0B, "trigger_killer" },
    { 0xA774C0EC, "trigger_killstreak" },
    { 0xC2FFE987, "trigger_last_hiding_door" },
    { 0xD2052920, "trigger_left_lobby_color" },
    { 0x9A0A55FB, "trigger_lifetime" },
    { 0x866CA8F8, "trigger_lightning" },
    { 0xE1DF5464, "trigger_lightning_exploder" },
    { 0x141312BB, "trigger_location" },
    { 0x18EC5C6B, "trigger_look" },
    { 0x29B0977A, "trigger_look_use_button" },
    { 0x530A24EC, "trigger_lookat" },
    { 0x1520CA1D, "trigger_lookat_think" },
    { 0x39F9B335, "trigger_looking" },
    { 0x38DE3C45, "trigger_lower" },
    { 0x08A08877, "trigger_mh_coke_destruction" },
    { 0x4284694D, "trigger_middle" },
    { 0xFFD898BA, "trigger_migs" },
    { 0xF335CFE0, "trigger_migs_end" },
    { 0x229F5CED, "trigger_migs_intro" },
    { 0x5C7D8424, "trigger_monitor" },
    { 0xB37BF555, "trigger_monitor_init" },
    { 0x3ACCB5E5, "trigger_move" },
    { 0x358B1911, "trigger_multi" },
    { 0xF01C29E2, "trigger_multiple" },
    { 0x97DC80AD, "trigger_multiples" },
    { 0x8518A323, "trigger_name" },
    { 0xC9999072, "trigger_node" },
    { 0x17836ED9, "trigger_noriega" },
    { 0xC4A1CC2F, "trigger_noteworthy" },
    { 0x2B987803, "trigger_noteworthy_if_player0" },
    { 0xAF6C50D5, "trigger_notify" },
    { 0x7381CAEA, "trigger_notify_level" },
    { 0x2FEF77C6, "trigger_num" },
    { 0xDF0DC125, "trigger_off" },
    { 0x0EDE1CBE, "trigger_off_course_think" },
    { 0x278B64D0, "trigger_off_proc" },
    { 0x9A55A247, "trigger_offset" },
    { 0xBE19BC99, "trigger_on" },
    { 0x7100330B, "trigger_on_clear" },
    { 0x13FC7AFC, "trigger_on_goal_or_death" },
    { 0xDC769E6C, "trigger_on_proc" },
    { 0x827F6F1D, "trigger_on_timeout" },
    { 0x8980AB2D, "trigger_once" },
    { 0x90ADAF2C, "trigger_onces" },
    { 0xD79F2512, "trigger_or_flag_or_timeout" },
    { 0x158871B0, "trigger_org" },
    { 0x0F5566A4, "trigger_origin" },
    { 0xF598D568, "trigger_other" },
    { 0x890B3AA6, "trigger_override" },
    { 0x8446BCEC, "trigger_override_name" },
    { 0xA6BFFB11, "trigger_pacifist" },
    { 0x0DE0BDA1, "trigger_pad" },
    { 0x013E7631, "trigger_per_player" },
    { 0xEFA0DD50, "trigger_perimeter_patrol_watch" },
    { 0xA837D699, "trigger_player" },
    { 0xF1B8573C, "trigger_player_location_think" },
    { 0x8334EE5F, "trigger_player_shock_fx" },
    { 0x9FF59574, "trigger_point" },
    { 0x2B6AAF01, "trigger_point_action" },
    { 0xEB280237, "trigger_point_get_timer" },
    { 0xE3150E2A, "trigger_point_reset_timer" },
    { 0x21DAE85B, "trigger_point_timer_start" },
    { 0xA16F6318, "trigger_pool" },
    { 0x631DC360, "trigger_pos" },
    { 0x5B80EA4C, "trigger_price_n_griggs" },
    { 0x22F85355, "trigger_process" },
    { 0x8705B8D8, "trigger_radius" },
    { 0x94217CD0, "trigger_radius_damage" },
    { 0x49719C6A, "trigger_radius_default" },
    { 0x6ECF2996, "trigger_radius_height" },
    { 0x70CA056E, "trigger_radius_position" },
    { 0x085D5FB2, "trigger_requires_player" },
    { 0x03CE6E91, "trigger_right_lobby_color" },
    { 0x5C72B21B, "trigger_roof_lighting" },
    { 0xEC98B18C, "trigger_rooftop_dialog" },
    { 0xDC417C99, "trigger_runs_function_on_touch" },
    { 0xA2014270, "trigger_scene_sequence_started" },
    { 0x99F985A0, "trigger_seaknight" },
    { 0xA497FE57, "trigger_seaknight_gun" },
    { 0x4D096C00, "trigger_set_cover_from_heli" },
    { 0x8D0FBD45, "trigger_setup" },
    { 0xCBB2AF3A, "trigger_shadow_on_wall_lightning" },
    { 0x9963D32D, "trigger_shared" },
    { 0x9BB7EE6A, "trigger_sparks_off" },
    { 0x705D263C, "trigger_sparks_on" },
    { 0x6700EAE3, "trigger_spawn" },
    { 0x5D8ED323, "trigger_spawn_manager" },
    { 0xB0DA953A, "trigger_spawn_manager_create" },
    { 0xE5B88C85, "trigger_spawn_manager_setup" },
    { 0x0836C9BE, "trigger_spawner" },
    { 0x2A2600CD, "trigger_spawner_monitor" },
    { 0x29C09EBE, "trigger_spawner_spawn" },
    { 0x516EE91D, "trigger_spawner_spawns_guy" },
    { 0x7DA7175C, "trigger_spawner_spawns_guys" },
    { 0x8677D6F8, "trigger_spawnflags" },
    { 0x516958DB, "trigger_start1" },
    { 0xDF61E9A0, "trigger_start2" },
    { 0xE9386BB5, "trigger_start_final_breach" },
    { 0xC5655A52, "trigger_start_island" },
    { 0xB04F03ED, "trigger_start_mg_ridge" },
    { 0x3DFA30CD, "trigger_state" },
    { 0xA3244767, "trigger_still_valid" },
    { 0x4470E979, "trigger_string" },
    { 0x3144CB3D, "trigger_struct" },
    { 0x5E8E490A, "trigger_stub" },
    { 0x5F100E45, "trigger_stubs" },
    { 0x40EFC133, "trigger_surrender_thread" },
    { 0x94243ACB, "trigger_swim_to_sampan" },
    { 0xC532CF91, "trigger_target" },
    { 0x3EFC9D86, "trigger_target_targets" },
    { 0x74DDEF3E, "trigger_targeted" },
    { 0xCF309469, "trigger_targeted_mortars" },
    { 0x7DF306D0, "trigger_targetname" },
    { 0xB2DFA7A2, "trigger_think" },
    { 0xAA5FCAB3, "trigger_think_func" },
    { 0x96166EAA, "trigger_thread" },
    { 0x82FEC06A, "trigger_thread_death_monitor" },
    { 0x5CE07C2B, "trigger_thread_func" },
    { 0x095D7787, "trigger_timeout" },
    { 0x1A3B31BE, "trigger_to_armory" },
    { 0xD70EDC98, "trigger_to_check" },
    { 0x9CE13F37, "trigger_to_hit_name" },
    { 0x90CB4641, "trigger_to_watch" },
    { 0x3F778757, "trigger_top" },
    { 0xEC605BEE, "trigger_touch_think" },
    { 0xCD3E9173, "trigger_tree_top_think" },
    { 0x9B032080, "trigger_turns_off" },
    { 0x3743D890, "trigger_tv_1" },
    { 0x38E11EFE, "trigger_type" },
    { 0x0239A8E1, "trigger_types" },
    { 0x3F36B7C2, "trigger_unlock" },
    { 0x88AA58CD, "trigger_unlock_death" },
    { 0x7E0B3E0D, "trigger_unlocks" },
    { 0x351E9CC6, "trigger_upgraded" },
    { 0x4103B732, "trigger_upper" },
    { 0xE25B0B22, "trigger_upstairs_guys" },
    { 0x9CEC4E17, "trigger_use" },
    { 0xF9F13122, "trigger_use_button" },
    { 0xB0F9F644, "trigger_use_doubletap" },
    { 0x1B4ED8E9, "trigger_value" },
    { 0xE5BC737D, "trigger_vehicles" },
    { 0x78900720, "trigger_visible_to_player" },
    { 0x53ACB81E, "trigger_vision" },
    { 0x04B5734B, "trigger_volume_room01" },
    { 0x7373F13D, "trigger_wait" },
    { 0xD3BA75CB, "trigger_wait_and_set_flag" },
    { 0xA54114E6, "trigger_wait_facing" },
    { 0xD4D3F553, "trigger_wait_for_player_touch" },
    { 0x5C7C1A1D, "trigger_wait_or_time" },
    { 0xC63D7033, "trigger_wait_or_timeout" },
    { 0x2C7C1BCA, "trigger_wait_or_timeout_helper" },
    { 0x91F367D6, "trigger_wait_targetname" },
    { 0xB8D6C50D, "trigger_wait_time_failsafe" },
    { 0xC9DCE219, "trigger_wait_timeout" },
    { 0x80204ED6, "trigger_wait_until_clear" },
    { 0x2E07F5C4, "trigger_wait_with_notify" },
    { 0xA9B712FC, "trigger_waits" },
    { 0x54C487CD, "trigger_waittill_dead" },
    { 0xED1029DE, "trigger_warn" },
    { 0x5EF16300, "trigger_water_sheeting_think" },
    { 0x8C200F57, "trigger_waypoint" },
    { 0x9C68D96F, "trigger_weapon_shutdown" },
    { 0x8A536DE9, "trigger_withdraw_think" },
    { 0x59C086A5, "trigger_withdraw_update_prompt" },
    { 0x89B776E3, "triggerable" },
    { 0xE5FC0324, "triggeractivate" },
    { 0xAF2E02C9, "triggercheck" },
    { 0x55439DFC, "triggercolor" },
    { 0x2C019971, "triggercolor_bp2" },
    { 0xEAAC0F15, "triggercolor_claw_right" },
    { 0x9E25B59D, "triggerd" },
    { 0xBE36F652, "triggerdelete" },
    { 0x57765671, "triggerdetectid" },
    { 0x3D61C0AB, "triggerdistsq" },
    { 0x7A7E61D8, "triggered" },
    { 0x8C0A1696, "triggered_cougar_crawl_squib_structs" },
    { 0x924C948B, "triggered_drop_bad_areas" },
    { 0x54577F70, "triggered_explosion" },
    { 0x874E18DB, "triggered_explosions" },
    { 0x0056605E, "triggered_explosions_single" },
    { 0x5F7C913D, "triggered_lights_think" },
    { 0xF83A67B0, "triggered_objective_wait" },
    { 0xF14231A8, "triggered_playerseek" },
    { 0xC9EF702C, "triggered_spawners" },
    { 0xED1B4C45, "triggeredcount" },
    { 0x43B6A4E0, "triggeredthink" },
    { 0x175E6B8E, "triggerenable" },
    { 0x7B0AF5F2, "triggerent" },
    { 0xF78284A5, "triggerentnums" },
    { 0x61416FD2, "triggerentspawnpoints" },
    { 0xFE6599BE, "triggerer" },
    { 0x093A672F, "triggerfunction" },
    { 0xA065C695, "triggerfx" },
    { 0x362F9F41, "triggerh" },
    { 0xBE6287F2, "triggerhardpoint" },
    { 0x2D88B762, "triggerheight" },
    { 0xFCFDF6CF, "triggerhintstring" },
    { 0xB067390F, "triggerids" },
    { 0x1D5013FA, "triggerignoreteam" },
    { 0xD6D75EBD, "triggering" },
    { 0xF6DC8EFF, "triggering_player" },
    { 0xD5E7ADE9, "triggerkillstreak" },
    { 0x618C161E, "triggername" },
    { 0x9B85E388, "triggernotify" },
    { 0xD653EECD, "triggernum" },
    { 0xAF1C1502, "triggeroff" },
    { 0x635B9F8A, "triggeroffset" },
    { 0x8F0B91A5, "triggeroffsumpf" },
    { 0xA4B9A274, "triggeron" },
    { 0x72E1D5F8, "triggeron_on_notify" },
    { 0xB7BFA783, "triggeronsumpf" },
    { 0x1292A479, "triggerorigin" },
    { 0x00C92792, "triggerparentent" },
    { 0x3641990B, "triggerpriorities" },
    { 0x2024986F, "triggerpriority" },
    { 0x96D5AB3D, "triggerradius" },
    { 0x2D532CB0, "triggerred" },
    { 0x65E38243, "triggerreviveid" },
    { 0xCBF69FD2, "triggers" },
    { 0xAB90636F, "triggers_bmp_tarmac" },
    { 0xB0E4CBC8, "triggers_in_sequence" },
    { 0x4B71D29E, "triggers_print" },
    { 0x41383FF5, "triggers_to_remove" },
    { 0x6DFB7956, "triggers_to_turn_off" },
    { 0xEBF881C8, "triggers_to_turn_on" },
    { 0x94F1651F, "triggersenable" },
    { 0x6FAAA1A2, "triggerst" },
    { 0xE46114B3, "triggerstub" },
    { 0xF40CA91C, "triggerswroom" },
    { 0x163F8D90, "triggerteam" },
    { 0x0C9D5306, "triggerteamignore" },
    { 0x41F0F8CD, "triggerthink" },
    { 0xE529FCE4, "triggerthink_switch" },
    { 0xCF7FB299, "triggertn" },
    { 0x9D35713F, "triggertouched" },
    { 0xC6D14F1C, "triggertouchthink" },
    { 0xA36D4F1B, "triggertype" },
    { 0x8AEDA818, "triggerunlocked" },
    { 0x68766826, "triggerupgradebuyableweapons" },
    { 0x0CD9ED88, "triggeruse" },
    { 0x9ACB899C, "triggerused" },
    { 0x6D887BC2, "triggerwaitforturretupgradeused" },
    { 0x2D11C5E4, "triggerweakpointdamage" },
    { 0x16A9AE60, "triggerweaponslockerisvalidweapon" },
    { 0x08D8A50D, "triggerweaponslockerisvalidweaponpromptupdate" },
    { 0x78B3513E, "triggerweaponslockerthink" },
    { 0x230629B3, "triggerweaponslockerthinkupdateprompt" },
    { 0xE6CC80FF, "triggerweaponslockerwatch" },
    { 0x1E1BBB9A, "triggerweaponslockerweaponchangethink" },
    { 0x83CFB261, "triggerwidth" },
    { 0x3AFB0063, "triggerwindow" },
    { 0x7B6EA3D0, "triggger" },
    { 0x9FD668C7, "triggrs" },
    { 0x3A16F57A, "trigin" },
    { 0x1D5C25C4, "trigkey" },
    { 0x8E8DD677, "trigkeys" },
    { 0x97DB13A5, "trigme" },
    { 0xF2CE1A66, "trigmeon" },
    { 0x41E1BDD2, "trigname" },
    { 0x6BD4A434, "trignotify" },
    { 0x0C7FB4DB, "trigorg" },
    { 0xAF0F131D, "trigorigin" },
    { 0xAC1C594D, "trigout" },
    { 0x8AAF83C0, "trigplayer" },
    { 0xA0A1BE2A, "trigrad2" },
    { 0x4DD6082F, "trigrappel" },
    { 0x338B3066, "trigs" },
    { 0xD0969EAB, "trigs1" },
    { 0x5E8F2F70, "trigs2" },
    { 0x60716B06, "trigs_1" },
    { 0x3A6EF09D, "trigs_2" },
    { 0x0B38022F, "trigs_kick" },
    { 0x27BAB95C, "trigs_off" },
    { 0xD8CA58E9, "trigs_rolltop" },
    { 0x95A336E8, "trigs_setup" },
    { 0x19C81D08, "trigs_slide" },
    { 0x93EEC8DA, "trigs_with_script_flag" },
    { 0x45E6AB8C, "trigsn" },
    { 0xBD6C71B1, "trigtargetname" },
    { 0xF4284EF3, "trigtargets" },
    { 0x8AC690D5, "trigtn" },
    { 0x8D50A4F4, "trigval" },
    { 0x496892BE, "trigvalue" },
    { 0x9DDE6CA0, "trigwait" },
    { 0xFCA6C08B, "trilinear" },
    { 0x3D579255, "trim" },
    { 0x76A30802, "trim_dialogue" },
    { 0xE154EF4E, "trim_targetname" },
    { 0xA6C7AB3D, "trimmed" },
    { 0xF6E71D86, "trimming" },
    { 0xE890C1A3, "trimpathtoattack" },
    { 0xD2BE5EA4, "trims" },
    { 0xD7B765B5, "tring" },
    { 0x895C8727, "trio" },
    { 0xAF5F0190, "trip" },
    { 0x35265899, "triple" },
    { 0xA06B0866, "triple25" },
    { 0xC3A1990C, "triple25_aim" },
    { 0xE4E096BB, "triple25_dismount_trig" },
    { 0x1B8F8794, "triple25_gunner" },
    { 0x6D910BB9, "triple25_gunner_spawner" },
    { 0x7E59FA47, "triple25_instruct" },
    { 0x62CA7A50, "triple25_recycle" },
    { 0x35D60036, "triple25_shoot" },
    { 0xFB6DDBBB, "triple25_shoot1" },
    { 0x3BE41A7E, "triple25_target" },
    { 0x3FEB9361, "triple25_targets" },
    { 0x68FFEF6A, "triple25_triggers" },
    { 0x9CA1FD2D, "triple25gunner_animation_think" },
    { 0x2ABA3DB1, "triple25gunner_dismount" },
    { 0x68541799, "triple25s" },
    { 0x484F1399, "triplekill" },
    { 0x9F0190D3, "tripped" },
    { 0x54082458, "tripping" },
    { 0x74BE8B7B, "trips" },
    { 0x5E8351BF, "tripwire" },
    { 0xCE331DC6, "tripwires" },
    { 0xD50CEA53, "triumvirate" },
    { 0x16BA99C4, "trm" },
    { 0x3B1F1991, "trn_off_walla" },
    { 0xC556F11C, "tron" },
    { 0xA3D9D04F, "troop" },
    { 0x79081884, "troop1" },
    { 0x446E7316, "troops" },
    { 0xE968460B, "trophy" },
    { 0x00065310, "trophy_activation_delay_seconds" },
    { 0xC76725ED, "trophy_active_radius" },
    { 0x48D1F708, "trophy_ammo_count" },
    { 0xFC33DB82, "trophy_defense" },
    { 0x6667C327, "trophy_destroyed" },
    { 0x9E97619E, "trophy_disable_limit" },
    { 0xFCD2C4CE, "trophy_disabled" },
    { 0xDE9EBA31, "trophy_disables" },
    { 0x2168E5EE, "trophy_down" },
    { 0x3F2BB967, "trophy_flak_z" },
    { 0x7B5C17B8, "trophy_health" },
    { 0x628020E1, "trophy_on" },
    { 0x4B2B652B, "trophy_rolling_anim" },
    { 0x10006620, "trophy_state_change" },
    { 0x28BCB4A4, "trophy_state_change_recon" },
    { 0x8EE1A7CC, "trophy_stationary_anim" },
    { 0x31110D68, "trophy_stun_time_seconds" },
    { 0xF0A72D31, "trophy_system" },
    { 0x27175BCD, "trophy_system_destroyed" },
    { 0x6530962C, "trophy_system_disabled" },
    { 0xF015CDF7, "trophy_system_enabled" },
    { 0xEF5ED6AE, "trophy_system_health" },
    { 0x98E608CA, "trophy_system_init" },
    { 0x2226D57B, "trophy_system_rolling" },
    { 0xD64489FA, "trophy_system_stationary" },
    { 0x11EA4DB5, "trophy_system_stunned" },
    { 0x26C5EF6A, "trophy_trace_z" },
    { 0xCB8ABDF4, "trophyactivationdelay" },
    { 0x30912131, "trophyactive" },
    { 0xBE27628B, "trophyactiveradius" },
    { 0x8E345A2E, "trophyammocount" },
    { 0xB93B90FC, "trophyanim" },
    { 0xC03A4A04, "trophybreak" },
    { 0x4AE30561, "trophydeployanim" },
    { 0x389B78DD, "trophydestroy_fx_handle" },
    { 0xC6E73D45, "trophydestroyfx" },
    { 0x9BEAA3EE, "trophydestroytacinsert" },
    { 0x6339CDAE, "trophydetonationfx" },
    { 0xD32A7F55, "trophyflakz" },
    { 0x350FB6B9, "trophyhackertoolradius" },
    { 0xFAAC6868, "trophyhackertooltimems" },
    { 0xCFDB54FE, "trophylight_fx_1" },
    { 0xF2D14C03, "trophylight_fx_handle" },
    { 0xF1C13278, "trophylight_tag_1" },
    { 0x87C62303, "trophylongflashfx" },
    { 0x27DEF451, "trophyrepulsefx" },
    { 0x8F04A73D, "trophyrepulsefx_ground" },
    { 0xF5CC41B0, "trophyspinanim" },
    { 0xB81CD9D4, "trophystuntime" },
    { 0x86E58898, "trophysystem" },
    { 0xA55F8710, "trophysystemdetonate" },
    { 0x0F99B9C5, "trophysystemdisablethreshold" },
    { 0xF5C1A5EF, "trophysystemdowntime" },
    { 0xFE71D83A, "trophysystemhealth" },
    { 0x316E3DC7, "trophysystemrange" },
    { 0x06F13D0E, "trophysystemstationary" },
    { 0x5A624323, "trophywarmup" },
    { 0x22000077, "trophywatchhack" },
    { 0x10B1B3AB, "tropp1" },
    { 0x81206C16, "trot" },
    { 0x0A15575E, "trouble" },
    { 0x94B48B3E, "troubled" },
    { 0xFAB5A2ED, "troublemakers" },
    { 0x548A422B, "troubleshoot" },
    { 0x5FFE3DB6, "troublesome" },
    { 0x989ADA56, "trough_1_break" },
    { 0xE97AE385, "trough_2_break" },
    { 0x5D1D275C, "troups" },
    { 0x34EEA461, "trp" },
    { 0x5AF11ECA, "trs" },
    { 0x26126125, "truch" },
    { 0x4C14DB8E, "truck" },
    { 0x8CE7E8D8, "truck01_spawn_func" },
    { 0x58612743, "truck1" },
    { 0xC29AD0FD, "truck1_blow_up_node" },
    { 0xE659B808, "truck2" },
    { 0xE27353DE, "truck2_in_place" },
    { 0x0C5C3271, "truck3" },
    { 0xED3B3DA7, "truck_0" },
    { 0xE9BC1420, "truck_0_gunner_logic" },
    { 0xC738C33E, "truck_1" },
    { 0x257DCF21, "truck_1_guys" },
    { 0xA13648D5, "truck_2" },
    { 0xDB2FBDF0, "truck_2_guys" },
    { 0x7B33CE6C, "truck_3" },
    { 0x55315403, "truck_4" },
    { 0x0AE04D7C, "truck_arrives_outside_mission_courtyard" },
    { 0x8BCFA477, "truck_attack_player" },
    { 0xDE8455F3, "truck_audio_end" },
    { 0xB0053006, "truck_avalanche_control" },
    { 0x835B1679, "truck_avalanche_vertical_impacts" },
    { 0x38D5A228, "truck_base_defense_behavior" },
    { 0x176A0689, "truck_base_detonations" },
    { 0x0C134A8B, "truck_bashes_gate" },
    { 0xEDBC5287, "truck_blocker_explode" },
    { 0x5E107224, "truck_blows_up" },
    { 0x9261F5F8, "truck_boom" },
    { 0x5AB51510, "truck_bw" },
    { 0xA13CD70E, "truck_chase_logic" },
    { 0x1373DA73, "truck_collision_anim_starts" },
    { 0xA37CE476, "truck_continue_rail_after_wave1_cleared" },
    { 0xFC589D16, "truck_crash" },
    { 0x2D8E2913, "truck_crash_behavior" },
    { 0xAC59E51E, "truck_crash_drivers" },
    { 0x7DA424B3, "truck_crash_fx" },
    { 0x9851B8C9, "truck_crash_guys" },
    { 0x2D6CF0AB, "truck_crash_guys_anim" },
    { 0x1A61D6F7, "truck_crash_guys_invinc" },
    { 0xB6368FF1, "truck_crush_tank_in_position" },
    { 0x771C5911, "truck_damage_override" },
    { 0xEB297E0B, "truck_dead" },
    { 0x20A5FE3C, "truck_death_think" },
    { 0x83E79E89, "truck_depot_drones" },
    { 0x9E04A409, "truck_destructionfx" },
    { 0xE39D39AD, "truck_disable_turret_on_gunner_death" },
    { 0xE2E86D2A, "truck_door_open_setup" },
    { 0x466ED10F, "truck_driver" },
    { 0x6F9A58FA, "truck_drives_through_gate" },
    { 0xD25D7E63, "truck_enemies" },
    { 0x1C012AC8, "truck_ent_1" },
    { 0x8E089A03, "truck_ent_2" },
    { 0x69465134, "truck_exploded" },
    { 0xFE7FDD06, "truck_explosion_bridge" },
    { 0x2D10A0E6, "truck_explosion_ready" },
    { 0x25D48671, "truck_fail" },
    { 0xAC1FF458, "truck_gaz63_player_single50" },
    { 0x6DA594F6, "truck_gaz63_player_single50_physics" },
    { 0xAAE706C5, "truck_gaz63_quad50" },
    { 0xC7E85F0D, "truck_gaz66_player_single50" },
    { 0x25F69B3F, "truck_go" },
    { 0xB54085AF, "truck_go_boom" },
    { 0x2B288D45, "truck_guard1" },
    { 0x512B07AE, "truck_guard2" },
    { 0x3F7B06A0, "truck_guard_spawners" },
    { 0xF68EE7D7, "truck_guards" },
    { 0x2DEFF07C, "truck_gunner" },
    { 0x41EF060B, "truck_gunner_death" },
    { 0x52C79D65, "truck_guy_drop_gun" },
    { 0xCC88D42E, "truck_guy_spawners" },
    { 0x38FC3639, "truck_guy_strat" },
    { 0x11149711, "truck_guys" },
    { 0xE0ACA644, "truck_guys_think" },
    { 0xD15AF4F4, "truck_headlights_on" },
    { 0x9DF089C1, "truck_heat_pipes" },
    { 0x794F4F1A, "truck_hits_tree" },
    { 0x4B648166, "truck_horn_sound" },
    { 0xD282263B, "truck_init" },
    { 0xB715C141, "truck_is_player_on" },
    { 0xD3873AFB, "truck_is_up" },
    { 0x51F71A86, "truck_jump_shake" },
    { 0x7B18E1B6, "truck_loops" },
    { 0xBDBB403B, "truck_max_damage" },
    { 0xD66A8FBD, "truck_monitor" },
    { 0x11BA04D3, "truck_monitor_damage" },
    { 0x10BECED1, "truck_mortar_death" },
    { 0x4A0E8FF4, "truck_name" },
    { 0x1F6927ED, "truck_new" },
    { 0xF50B534D, "truck_node" },
    { 0xB655CD07, "truck_node_array" },
    { 0x2E690BF0, "truck_old" },
    { 0xA5B0162A, "truck_on_bridge" },
    { 0x499FDB83, "truck_origin" },
    { 0x1B87D4AF, "truck_passenger" },
    { 0x7CA60D67, "truck_patrol_path_1" },
    { 0x0A9E9E2C, "truck_patrol_path_2" },
    { 0x30A11895, "truck_patrol_path_3" },
    { 0x72B80D25, "truck_patroller_behavior" },
    { 0x3F21EEF1, "truck_patrollers_bp1" },
    { 0x23276141, "truck_pdf_1" },
    { 0x4929DBAA, "truck_pdf_2" },
    { 0x159DAC17, "truck_play_music" },
    { 0x5640BC08, "truck_reinforce" },
    { 0xCFE6A3AC, "truck_rockets" },
    { 0x429C2B18, "truck_rolling" },
    { 0x86D92BDA, "truck_rpg_target" },
    { 0x5063BB48, "truck_runs_from_avalanche" },
    { 0xF531B040, "truck_setup" },
    { 0x96DF253E, "truck_spawn_1" },
    { 0x70DCAAD5, "truck_spawn_2" },
    { 0x4ADA306C, "truck_spawn_3" },
    { 0x7BDC4807, "truck_spawn_func" },
    { 0x8463CB8C, "truck_spawn_functions" },
    { 0x0F363FD3, "truck_spawn_trigger" },
    { 0xBD9DD36E, "truck_speed" },
    { 0xB47C27B9, "truck_speed_logic" },
    { 0xFFE3BAA5, "truck_spot" },
    { 0xEEE877AF, "truck_start" },
    { 0x5C9527BC, "truck_start_node_01" },
    { 0xA89A1C8E, "truck_start_node_03" },
    { 0xEA8DB881, "truck_start_node_04" },
    { 0x95C14B14, "truck_stopped" },
    { 0x1E54965D, "truck_surf_down_road" },
    { 0xD5A4B028, "truck_survivers" },
    { 0xAC85F6E4, "truck_temp_escape_dialogue" },
    { 0x03D2EDD3, "truck_trigger" },
    { 0xF8704FC2, "truck_turret_index" },
    { 0x2036F93A, "truck_turret_think" },
    { 0xD0619FD7, "truck_unload_and_go" },
    { 0x4E1F3059, "truck_wall_react" },
    { 0x71F4BA18, "truck_waved_off" },
    { 0xB0F1FD58, "truck_wipeout" },
    { 0x4BB024B9, "truckanim" },
    { 0xD996586B, "truckbed" },
    { 0x7CDA827E, "truckguys" },
    { 0x4133E6C8, "truckjunk" },
    { 0x11AF2FDB, "truckride_logic" },
    { 0x8BBD9831, "trucks" },
    { 0xFEA5E27E, "trucks_go" },
    { 0xC643C618, "trucks_incoming" },
    { 0x137D7D39, "trucks_stop_at_checkpoint" },
    { 0xBE6B87F9, "true" },
    { 0x442E5CB3, "true_model" },
    { 0x5DD07767, "true_on" },
    { 0xC891BDB7, "true_value" },
    { 0xA1256FD4, "true_vehicle" },
    { 0x26BB7D06, "truecolor" },
    { 0x60A22B86, "truecount" },
    { 0xF2F68ED0, "trueoffset" },
    { 0x06A991AE, "truetime" },
    { 0x0A5CF499, "truly" },
    { 0x9305B3A3, "trump" },
    { 0xB2F7D1C9, "truncated" },
    { 0x5B5F258D, "trunk" },
    { 0x2CFE62CF, "trunk_fire_pos" },
    { 0x504FB059, "trust" },
    { 0xFEB89E86, "trusted" },
    { 0x6A059584, "truthfully" },
    { 0xDED856B0, "try" },
    { 0x8D11998A, "try_auto_save" },
    { 0x059ADB23, "try_auto_save_simple" },
    { 0xA25CDA58, "try_bulletcam" },
    { 0x5369B4F8, "try_countdown_achievement" },
    { 0xE1C98ED9, "try_crouch_max_shootent_velocity" },
    { 0xEC2EB847, "try_crouch_min_distsq" },
    { 0xCAC1D338, "try_crouch_random_chance" },
    { 0x7CB04DCB, "try_detonate" },
    { 0x293287F8, "try_face_enemy_distsq" },
    { 0x0E52B830, "try_forever_spawn" },
    { 0x06471BE2, "try_gib_extended_death" },
    { 0x30CF2541, "try_gibbing" },
    { 0xFDFD8721, "try_heat" },
    { 0x96163862, "try_pull_powerups" },
    { 0x0CAC9D01, "try_resume_zombie_spawning" },
    { 0x7AD79480, "try_save" },
    { 0x92CD321B, "try_save_proc" },
    { 0xE4887E58, "try_to_autosave_now" },
    { 0xD5F40CD5, "try_to_draw_line_to_node" },
    { 0x899C65AC, "try_to_pass_player" },
    { 0xBBE5EA9A, "try_to_start_challenge_round" },
    { 0x4F26C9F5, "try_to_start_ending_claw" },
    { 0x6FD641F7, "try_to_use_chaff" },
    { 0x9D84781A, "tryadddeathanim" },
    { 0x658BD669, "tryaddfiringdeathanim" },
    { 0x0C0F574C, "tryaddlocation" },
    { 0xD22632D8, "tryaddpointforhelicopterposition" },
    { 0xFC082F52, "tryadvancingonlastknownpositionbehavior" },
    { 0xA3C05F86, "tryautosave" },
    { 0x584C6E48, "trybalcony" },
    { 0x46284CC6, "trycasualty" },
    { 0xB2559D97, "trycornerrightgrenadedeath" },
    { 0x7B738B7C, "trycounter" },
    { 0x6D7BC7AE, "trydive" },
    { 0x0D21B9AD, "tryexposedreacquire" },
    { 0xC2208C82, "tryexposedthrowgrenade" },
    { 0xAE62D93B, "tryfireinform" },
    { 0xE70F39AE, "trygibbinghead" },
    { 0x12D3D9EF, "trygibbinglegs" },
    { 0x70577D34, "trygibbinglimb" },
    { 0x831324AE, "trygoingdown" },
    { 0x8DF26611, "trygoingtoclosestnodetoenemybehavior" },
    { 0xA895E3DA, "trygrenade" },
    { 0x80B02571, "trygrenadeinform" },
    { 0x9F1DA77C, "trygrenadeposproc" },
    { 0x918B388A, "trygrenadethrow" },
    { 0xC2379CA5, "tryheadshotslowmo" },
    { 0x19357228, "trying" },
    { 0x08988FF8, "trying_new_autosave" },
    { 0x2DDE8D34, "trying_to_spawn" },
    { 0xF6A68973, "trying_to_spike" },
    { 0x56721371, "trying_to_trigger_meat" },
    { 0x92F1B3A7, "trying_to_trigger_meat_time" },
    { 0x7996D458, "trying_to_use" },
    { 0x4DBD6B30, "trykill" },
    { 0xCAFD5F26, "tryleap" },
    { 0x8EE9B524, "trymelee" },
    { 0x90923205, "trymovetonextbestnode" },
    { 0x9F49B219, "trymovingnodes" },
    { 0x522765D1, "trynormalapproach" },
    { 0x2F63F618, "tryorder" },
    { 0x34BFB9CD, "tryreacquire" },
    { 0x7E18996D, "tryreacquirenode" },
    { 0x3947F866, "tryreacquireservice" },
    { 0x385148EF, "tryreload" },
    { 0xD6888716, "tryrunningdirectlytoenemybehavior" },
    { 0x3ACAFCE2, "tryrunningtoenemy" },
    { 0xD15E271B, "trys" },
    { 0xB0A791A2, "tryshortcircuitingarrivalanimation" },
    { 0x7E5B4861, "tryshortcircuitingexitanimation" },
    { 0x88A6747B, "trysidestep" },
    { 0xC57EBBF7, "trysidestepthread" },
    { 0x8AAE1D09, "tryspecialattack" },
    { 0xC4906609, "trystoppingservice" },
    { 0xF173BDC8, "trysurpressed" },
    { 0xA3AAC190, "trythreat" },
    { 0x5649A022, "trythrowgrenade" },
    { 0x18F0D9AA, "trythrowinggrenade" },
    { 0x34103DA9, "trythrowinggrenadestayhidden" },
    { 0x46E3E099, "trytimeout" },
    { 0xAED3AACE, "trytoapplyfiredamage" },
    { 0xFEE25E58, "trytoattackflashedenemy" },
    { 0x65FC4319, "trytobreakoffleg" },
    { 0x0694D622, "trytododamagefeedback" },
    { 0x4F7759F0, "trytogetoutofdangeroussituation" },
    { 0xC74180C6, "trytoglanceattheplayernow" },
    { 0x2E4495D5, "trytoreplace" },
    { 0x09FF7AFB, "tryturning" },
    { 0xA55CC0FE, "tryturret" },
    { 0xFF88735D, "tryuseheliguardsupport" },
    { 0x99FA428C, "tryusepredatormissile" },
    { 0x7F87CC32, "tryuseqrdrone" },
    { 0x0CEA5A1D, "tryusingsidearm" },
    { 0x53E76A08, "tryweaponthrowdown" },
    { 0x0D4F8703, "trywoundedanimset" },
    { 0x9A40E982, "ts" },
    { 0x9029FFE8, "ts_end" },
    { 0x2B7CFFC8, "ts_is_bowie_knife" },
    { 0x5F958C91, "ts_is_galvaknuckles" },
    { 0xF69A2BE2, "ts_sign_activate" },
    { 0xBE59DE02, "ts_sign_activated" },
    { 0x381B2D53, "ts_sign_check_all_activated" },
    { 0x8C0E8112, "ts_sign_damage_watch" },
    { 0xE506D53B, "ts_sign_deactivate" },
    { 0xE460388B, "ts_start" },
    { 0x99D91737, "ts_total_time" },
    { 0x1DAC826F, "tscale" },
    { 0x587280B9, "tsg" },
    { 0x6C953277, "tsi" },
    { 0x3F56F4B0, "tsize" },
    { 0x88865401, "tso" },
    { 0x2A885557, "tspawned" },
    { 0x9054C3CD, "tss" },
    { 0x1E4D5492, "tst" },
    { 0xA11254E0, "tst_01" },
    { 0x94B6FEC7, "tst_health" },
    { 0x2099A94E, "tst_last_health" },
    { 0xA87A34EF, "tst_snap_value" },
    { 0xD2485FC0, "tsv" },
    { 0x61F10DD7, "tswitch" },
    { 0x0C4858BD, "tt" },
    { 0xF0345AFC, "ttarget" },
    { 0x09D80D3B, "ttl" },
    { 0xBDD31869, "ttn" },
    { 0x97D09E00, "tto" },
    { 0x48EA229B, "tturet_watch_owner_events_singleton" },
    { 0xE645DE54, "tu" },
    { 0x5A271F35, "tu1" },
    { 0x80BDC6FF, "tu10" },
    { 0x8029999E, "tu2" },
    { 0xA62C1407, "tu3" },
    { 0x9C1ABB28, "tu4" },
    { 0xC21D3591, "tu5" },
    { 0xE81FAFFA, "tu6" },
    { 0xE2D5119C, "tu7_fix_100_percenter" },
    { 0xA3C89BBB, "tu7_fix_mastery_perk_2" },
    { 0x0410D184, "tu8" },
    { 0x2A134BED, "tu9" },
    { 0x93358117, "tube" },
    { 0x2F1FC889, "tube_clone" },
    { 0xFD52E3C3, "tube_clone_falls_to_earth" },
    { 0x337B06B9, "tube_used_for_timeout" },
    { 0x197670CE, "tubes" },
    { 0x895FDD36, "tuck" },
    { 0x04898FF9, "tucked" },
    { 0x4B136DF5, "tuco_crawling_anim_audio" },
    { 0xD365D6EE, "tuco_play_ambient_elements" },
    { 0x63CB0E12, "tuey" },
    { 0x23DE6B1D, "tueys" },
    { 0xEDAB36B3, "tug" },
    { 0x099C583D, "tui" },
    { 0x46854A24, "tumblewall" },
    { 0x9794E902, "tun" },
    { 0x994A9C2E, "tunable" },
    { 0x37FA6E51, "tunables" },
    { 0xEFB2AC0B, "tune" },
    { 0xCDBCF3F0, "tune_ai" },
    { 0x6FFAF60E, "tune_max_ai_numbers" },
    { 0xB99E0C15, "tuned" },
    { 0x51AC156E, "tuning" },
    { 0x4BC814B5, "tuning_structs" },
    { 0xAB359773, "tunnel" },
    { 0x91FCDD2C, "tunnel_11_destroyed" },
    { 0xB486DF40, "tunnel_6_destroyed" },
    { 0x12C84210, "tunnel_ai_spawning" },
    { 0xB7D48E89, "tunnel_breach" },
    { 0x12A56629, "tunnel_breakout_rock_setup" },
    { 0x97267E4C, "tunnel_burstout" },
    { 0x19EEADE9, "tunnel_chest" },
    { 0xB4509274, "tunnel_cleanup_after_fork" },
    { 0x9F0B789F, "tunnel_cliffhanger_art" },
    { 0xC74E40C8, "tunnel_cliffhanger_vision_settings" },
    { 0x54934B99, "tunnel_collapse_art" },
    { 0x8D4A62AA, "tunnel_collapse_vision_settings" },
    { 0xA6935AA1, "tunnel_crawl_rock_swap" },
    { 0xE9DFB88F, "tunnel_crouch_attack_animate" },
    { 0xF12BCEF1, "tunnel_custom_dds" },
    { 0x026D7CA9, "tunnel_death_counter" },
    { 0x0EB11F02, "tunnel_door" },
    { 0x1F6C2009, "tunnel_door_blocker" },
    { 0xE5172123, "tunnel_double_doors" },
    { 0xA95F215D, "tunnel_end_vo" },
    { 0x5B1CED4A, "tunnel_enemies" },
    { 0xF73AD035, "tunnel_exit_fog_settings" },
    { 0x881F10D9, "tunnel_exited" },
    { 0x9C5CD3BD, "tunnel_ext_amb_snapshot" },
    { 0x12745309, "tunnel_extra_vos" },
    { 0x7DA15BE6, "tunnel_guys_alerted" },
    { 0xD84D8E10, "tunnel_hide_behind_table_guy" },
    { 0x8F79B965, "tunnel_leaper_animate_then_cover" },
    { 0x5629BC1A, "tunnel_light" },
    { 0xAE2651A6, "tunnel_light_end_art" },
    { 0x2775FCDD, "tunnel_light_end_vision_settings" },
    { 0x6315E0A2, "tunnel_light_on_and_off" },
    { 0xF7D84915, "tunnel_lights" },
    { 0x8028F752, "tunnel_machete_attack_animate" },
    { 0x7C914902, "tunnel_node" },
    { 0x47C77C86, "tunnel_open" },
    { 0x4C580308, "tunnel_player_fail" },
    { 0xBA4C4B5E, "tunnel_player_went_left" },
    { 0xF73E0FAB, "tunnel_pulldown_table_then_fight" },
    { 0xC3189477, "tunnel_runner_logic" },
    { 0x751F34F4, "tunnel_section_1_entrance" },
    { 0xE58FC278, "tunnel_section_1_flashlight_hint" },
    { 0x480ABF1B, "tunnel_section_1_gate" },
    { 0x9C5F3857, "tunnel_section_1_room" },
    { 0x4F09110C, "tunnel_section_1_split_path" },
    { 0x5B7FB00F, "tunnel_section_2_ambush_1" },
    { 0xE97840D4, "tunnel_section_2_ambush_2" },
    { 0x0F7ABB3D, "tunnel_section_2_ambush_3" },
    { 0x17174FF5, "tunnel_section_2_ambush_clear" },
    { 0xF119612F, "tunnel_section_2_drown_guy" },
    { 0x399263FA, "tunnel_section_2_room" },
    { 0xD217B6E7, "tunnel_section_3_end_transition" },
    { 0x6B903DC6, "tunnel_section_3_falling_stuff" },
    { 0x783FC73D, "tunnel_section_3_falling_stuff_2" },
    { 0xA533EA10, "tunnel_section_3_see_light" },
    { 0x4B812840, "tunnel_section_3_war_room" },
    { 0x4C3079A9, "tunnel_shelf_mason_vo" },
    { 0x122918B7, "tunnel_signaler_animate" },
    { 0xE62B4D77, "tunnel_spawn_funcs" },
    { 0x53A1FF7F, "tunnel_speed_adjustment" },
    { 0xA7E1BC9A, "tunnel_start_jumpto" },
    { 0x7817D39B, "tunnel_strafer_animate" },
    { 0xE5E03D6C, "tunnel_structs" },
    { 0xD9A40C42, "tunnel_underscore" },
    { 0x9A48606E, "tunnel_vision" },
    { 0xD83FC341, "tunnel_visionset_change" },
    { 0x41815C51, "tunnel_vo_broken" },
    { 0x728AAF4D, "tunnel_war_room_light_settings" },
    { 0x76FDB156, "tunnel_woods_custom_cover" },
    { 0x3ED6D822, "tunnels" },
    { 0x65D48F15, "tunnels_bats" },
    { 0xCD58A9EF, "tunnels_groans" },
    { 0xD4661352, "tunnels_start_save_point" },
    { 0x101AB6D3, "tunnels_start_save_point_trig" },
    { 0x0FB51EC8, "tunnels_start_save_point_trig_2" },
    { 0x35B79931, "tunnels_start_save_point_trig_3" },
    { 0xDDC90061, "tunnnel" },
    { 0xB3860A8C, "tup" },
    { 0xFF8AFF5E, "tur" },
    { 0x74844A0E, "tur_1" },
    { 0x8048183E, "tur_1_owner" },
    { 0x4E81CFA5, "tur_2" },
    { 0xB95D34ED, "tur_2_owner" },
    { 0x832B6F6E, "tur_owner" },
    { 0x241904E2, "turbine" },
    { 0x3B8CD0BF, "turbine1" },
    { 0xC9856184, "turbine2" },
    { 0xEF87DBED, "turbine3" },
    { 0x7D806CB2, "turbine4" },
    { 0xA382E71B, "turbine5" },
    { 0x317B77E0, "turbine6" },
    { 0x27DFAB88, "turbine_1_talked" },
    { 0x4D262A61, "turbine_2_talked" },
    { 0x0730BBE9, "turbine_body" },
    { 0x2F962033, "turbine_buildable" },
    { 0x35BD6D37, "turbine_cleanup" },
    { 0x52BD8753, "turbine_deployed" },
    { 0xF5BD3A5D, "turbine_disappear_fx" },
    { 0xDCA3FFAB, "turbine_emp_time" },
    { 0x661FBD4A, "turbine_emped" },
    { 0x08440CB8, "turbine_failed_vo" },
    { 0x435F526C, "turbine_fan" },
    { 0x7E786D37, "turbine_health" },
    { 0x8D0F9A33, "turbine_is_powering_on" },
    { 0xC34180CE, "turbine_low_health" },
    { 0xB2CB80D2, "turbine_mid_health" },
    { 0x5BBB8170, "turbine_name" },
    { 0xE9012E39, "turbine_panel" },
    { 0xC4746CBB, "turbine_power_change" },
    { 0x96ECCD31, "turbine_power_is_on" },
    { 0x6462DA23, "turbine_power_level" },
    { 0x2B94D50C, "turbine_power_on" },
    { 0x9045C1D9, "turbine_power_watcher" },
    { 0x7341D766, "turbine_round_start" },
    { 0xC2BAB8EE, "turbine_spin_init" },
    { 0xC5E0AC98, "turbine_start_health" },
    { 0xDD9E079B, "turbine_watch_cleanup" },
    { 0x252B2811, "turbine_watch_for_emp" },
    { 0xC18B08B3, "turbine_zone" },
    { 0xCAE2F53D, "turbineanim" },
    { 0x5A47EF57, "turbineanimate" },
    { 0x38CA8510, "turbineaudio" },
    { 0x1865CC46, "turbinebuildable" },
    { 0x378D4C54, "turbinedecay" },
    { 0x0AF62BA8, "turbinefx" },
    { 0x51BDF5DB, "turbinefxonce" },
    { 0x7E291D0C, "turbinepowerdiminish" },
    { 0x3F63391A, "turbinepowermove" },
    { 0xB4A04ADC, "turbinepoweroff" },
    { 0x88EB55A6, "turbinepoweron" },
    { 0xE9F80E83, "turbinepowerthink" },
    { 0x6EE941AD, "turbines" },
    { 0xA3970DD3, "turbinescriptnoteworthy1" },
    { 0x318F9E98, "turbinescriptnoteworthy2" },
    { 0xAE0BA7BA, "turbinesplaced" },
    { 0x7CC748F2, "turbinewarmup" },
    { 0x070C53CF, "turbo" },
    { 0x142C46EA, "turbulence" },
    { 0x493BA4C0, "turck" },
    { 0x04A85E62, "turkeys" },
    { 0x6E384BC7, "turkish" },
    { 0x80D33B24, "turn" },
    { 0xF3F6EA07, "turn180_anim" },
    { 0x0BF9DB0D, "turn_135_min_angle" },
    { 0x19C94920, "turn_180" },
    { 0x6FF48AD8, "turn_180_left" },
    { 0x111D6469, "turn_180_min_angle" },
    { 0x5065B167, "turn_180_right" },
    { 0x2BBBFEC0, "turn_90" },
    { 0x51C78A89, "turn_90_min_angle" },
    { 0xD81D412A, "turn_additionalprimaryweapon_on" },
    { 0x4583FB0A, "turn_afterlife_interact_on" },
    { 0x81D47EA8, "turn_all_lights_green" },
    { 0x7191DA3A, "turn_all_lights_off" },
    { 0xD0B291EC, "turn_all_lights_on" },
    { 0x20D08FB8, "turn_all_lights_red" },
    { 0xB5E7A8F0, "turn_and_run" },
    { 0xE3A98BAC, "turn_angle" },
    { 0x5A323D3C, "turn_anim" },
    { 0x10E21C67, "turn_anim_done" },
    { 0x6A1507B1, "turn_anim_rate_multiplier" },
    { 0x4E64DA88, "turn_anim_with_idle" },
    { 0x76C614A4, "turn_area51_perks_on" },
    { 0xF2C3D780, "turn_around" },
    { 0x481A4C6B, "turn_around_chance" },
    { 0xFFDCCE33, "turn_around_guys_count" },
    { 0x88617178, "turn_around_left" },
    { 0x696AA787, "turn_around_right" },
    { 0x93AA0D1D, "turn_asd" },
    { 0x36983BB2, "turn_back" },
    { 0xABE2F274, "turn_back_to_default" },
    { 0xA03F369E, "turn_battlechatter_back_on" },
    { 0x80F20717, "turn_car" },
    { 0x7CC2EA3C, "turn_chugabud_on" },
    { 0x6E58FFA7, "turn_clientside_rumble_off" },
    { 0xEB084322, "turn_cola_off" },
    { 0x252FD298, "turn_crawler_asd" },
    { 0x434FEF27, "turn_deadshot_on" },
    { 0x773D522F, "turn_divetonuke_on" },
    { 0x2FFB11C1, "turn_doubletap_on" },
    { 0xDB66510D, "turn_down_cougar" },
    { 0x1D3CD45E, "turn_down_fog" },
    { 0x25AA3E02, "turn_electric_cherry_on" },
    { 0x75E42688, "turn_fight_room_unsafe" },
    { 0x34FCA80D, "turn_gadget_off" },
    { 0xD89D9B21, "turn_gadget_on" },
    { 0x87B2494E, "turn_grenade_into_a_dud" },
    { 0x0D2675EA, "turn_hind_off" },
    { 0x40C139E1, "turn_into_melee_digbats" },
    { 0x16074EFB, "turn_jeep_lights_on" },
    { 0x3B6A3D7D, "turn_jugger_on" },
    { 0x649D6AEC, "turn_left" },
    { 0x75A9D91C, "turn_left_heavy" },
    { 0x7114D391, "turn_left_light" },
    { 0xE2275C1D, "turn_light_green" },
    { 0x66F87309, "turn_light_red" },
    { 0x6C4BEC25, "turn_lightning_off" },
    { 0x23EE0351, "turn_lightning_on_combat_roof" },
    { 0xD11CF111, "turn_lightning_on_indoor" },
    { 0xD6E308AE, "turn_lightning_on_roof" },
    { 0x076EB265, "turn_loop" },
    { 0x209EA9AB, "turn_marathon_on" },
    { 0xC451F5BD, "turn_min_angle" },
    { 0x8CA49604, "turn_must_face_enemy_dist" },
    { 0x7179611C, "turn_must_face_enemy_distsq" },
    { 0x53294176, "turn_nodes_off_inside_burning_house" },
    { 0x91C0B9AA, "turn_off" },
    { 0xF6578E85, "turn_off_ads_text" },
    { 0xCD14D250, "turn_off_all_box_lights" },
    { 0x00E37C94, "turn_off_all_extra_cams" },
    { 0xE06562C6, "turn_off_all_lab_trigs" },
    { 0x037A99EF, "turn_off_ally_cam" },
    { 0x6FB6507B, "turn_off_badplace" },
    { 0x7CC10800, "turn_off_breadcrumb_obj" },
    { 0x7D4BA7C0, "turn_off_bullet_snapshot" },
    { 0x4358E7BE, "turn_off_claw_firing" },
    { 0x316B814B, "turn_off_claw_vision" },
    { 0x115FAF63, "turn_off_containment_clips" },
    { 0xFB46767A, "turn_off_cool_down_fx" },
    { 0x20B3A75D, "turn_off_cull" },
    { 0xF16AFA4A, "turn_off_current_3d_objective" },
    { 0xA01B9CB0, "turn_off_directional_marker" },
    { 0xC7C39A29, "turn_off_exploders" },
    { 0x62A2550D, "turn_off_extra_cam" },
    { 0x3364CC51, "turn_off_fire_sale" },
    { 0x7BE9FD4B, "turn_off_fire_struct" },
    { 0x664215E6, "turn_off_flashlights" },
    { 0x14B564CE, "turn_off_foliage_cover" },
    { 0xEA4C4581, "turn_off_for_bike_player_damage_override" },
    { 0x2CA02022, "turn_off_fougasse_timer" },
    { 0xDD1E9D5F, "turn_off_frag_lights" },
    { 0x0716FA3B, "turn_off_friendly_fire" },
    { 0x0571497A, "turn_off_friendly_player_look" },
    { 0x832ADC3A, "turn_off_goggles_vision" },
    { 0x503F455C, "turn_off_guns" },
    { 0x15353B71, "turn_off_highrises" },
    { 0x9CD618E3, "turn_off_hotel_lights" },
    { 0xC0173A4D, "turn_off_hudson_glasses" },
    { 0xFEDF315D, "turn_off_intro_cam" },
    { 0xF0CA165B, "turn_off_intro_cam_hud" },
    { 0x4B947E76, "turn_off_invulnerability" },
    { 0x1F2A9907, "turn_off_jump_aim_assist" },
    { 0x2CF70794, "turn_off_jungle_escape_spawn_triggers" },
    { 0x8440FAD9, "turn_off_laser_after" },
    { 0xF7122E99, "turn_off_laser_thread" },
    { 0x0E2DAF77, "turn_off_light" },
    { 0x7E06E317, "turn_off_magic_bullet_shield" },
    { 0x00BC7196, "turn_off_mason_hummer" },
    { 0x44601686, "turn_off_multi_extra_cams" },
    { 0x4DEE851F, "turn_off_mutex_trigger" },
    { 0x0A7F3C27, "turn_off_opposite_side_gondola_shockbox" },
    { 0x341157E3, "turn_off_primary_lights" },
    { 0xD8378E66, "turn_off_reflection_cam" },
    { 0x404396A5, "turn_off_rooftop_fans" },
    { 0x9C735176, "turn_off_scope_vision" },
    { 0x56AB9340, "turn_off_spot_light" },
    { 0x5A8B3110, "turn_off_spotlight_fx" },
    { 0xA49AC0BE, "turn_off_stealth" },
    { 0x12EA396E, "turn_off_sticky_aim" },
    { 0xF8634757, "turn_off_sun_flash_fx" },
    { 0x97590EA3, "turn_off_tank_hud" },
    { 0xE4CF3652, "turn_off_target" },
    { 0xD90A78DC, "turn_off_thread_for_minigun_player_damage_override" },
    { 0x7581A654, "turn_off_trainyard_vision" },
    { 0xC4F2861C, "turn_off_tresspasser" },
    { 0xF916EE9D, "turn_off_trigger_for_time" },
    { 0x367D451F, "turn_off_triggers_from_links" },
    { 0x21D2959C, "turn_off_vehicle_exhaust" },
    { 0x49887023, "turn_off_vehicle_tread_fx" },
    { 0x1E3DD2D5, "turn_off_videos" },
    { 0xFCE0D28F, "turn_off_vision_settings" },
    { 0x3A5F72C0, "turn_off_vista_lights" },
    { 0xFB6FD3BC, "turn_off_vo_cam" },
    { 0xEC12B621, "turn_off_vo_cam_watcher" },
    { 0xE2D166C1, "turn_off_waitfordryland" },
    { 0xB0CABEC7, "turn_off_walla_loop" },
    { 0xE7A20B86, "turn_off_water" },
    { 0x01A62094, "turn_off_waterfx" },
    { 0x5AD6AD56, "turn_off_whoswho" },
    { 0x521F08A8, "turn_off_windows" },
    { 0xE52D8E45, "turn_off_windshield_bink" },
    { 0xB9B23788, "turn_off_xcam" },
    { 0x17983BFB, "turn_off_yard_triggers" },
    { 0x58ADFF7C, "turn_on" },
    { 0x5C4D6402, "turn_on_active_ball_light" },
    { 0xF1B01534, "turn_on_active_light_green" },
    { 0xEA8F64F9, "turn_on_ally_cam" },
    { 0xACE045F3, "turn_on_ally_cam_multi" },
    { 0xEAC81E7A, "turn_on_bc" },
    { 0x894EA6DE, "turn_on_bullet_snapshot" },
    { 0x8939072F, "turn_on_cctv" },
    { 0x86C34158, "turn_on_claw_firing" },
    { 0x03878895, "turn_on_claw_vision" },
    { 0x1B581DA9, "turn_on_containment_clips" },
    { 0x9998A3FD, "turn_on_convoy_headlights" },
    { 0xCC85AD80, "turn_on_enemy_highlight" },
    { 0x28E4202F, "turn_on_extra_cam" },
    { 0x38B2A067, "turn_on_fire_sale" },
    { 0x70FF3CB8, "turn_on_friendly_player_look" },
    { 0x742A8AD3, "turn_on_future_damage_overlay" },
    { 0xC368B255, "turn_on_glasses" },
    { 0x256A7944, "turn_on_goggles_vision" },
    { 0xF8B19A67, "turn_on_interior_light_fx" },
    { 0xE58A11EF, "turn_on_intro_cam" },
    { 0x40CBAD27, "turn_on_lighting" },
    { 0x851C1E54, "turn_on_location_indicator" },
    { 0xA9C7F121, "turn_on_low_light_vision" },
    { 0xF3667E1E, "turn_on_mission_fail_volumes" },
    { 0x6F70C368, "turn_on_notify" },
    { 0x06A67BC5, "turn_on_player_view_fx" },
    { 0x185E612D, "turn_on_quad_sounds" },
    { 0x3CB7A818, "turn_on_radio" },
    { 0x336480A2, "turn_on_radio_reznov_lair" },
    { 0xE5397854, "turn_on_reflection_cam" },
    { 0xDAA08DF8, "turn_on_scope_vision" },
    { 0x20395A84, "turn_on_scope_vision_quick" },
    { 0x56E8BE60, "turn_on_sticky_aim" },
    { 0x006F6D9D, "turn_on_the_clouds" },
    { 0xC4B8705E, "turn_on_trainyard_vision" },
    { 0x86E6CE57, "turn_on_uaz_lights" },
    { 0xEE80631E, "turn_on_vo_cam" },
    { 0x6A60E797, "turn_on_windshield_bink" },
    { 0x143D17A6, "turn_on_xcam" },
    { 0x61EF8854, "turn_oneinch_punch_on" },
    { 0x01684FDD, "turn_override_off" },
    { 0xE845B2B9, "turn_packapunch_on" },
    { 0x3BD72DCD, "turn_perk_off" },
    { 0x9D65661A, "turn_perks_on" },
    { 0x57D28B71, "turn_power_off_and_close_doors" },
    { 0x90B84A55, "turn_power_on_and_open_doors" },
    { 0xC0848858, "turn_prediction_type_allies" },
    { 0x930367E9, "turn_prediction_type_axis" },
    { 0x423CA501, "turn_rate" },
    { 0x0651E5A4, "turn_revive_on" },
    { 0xE43D60F7, "turn_rig" },
    { 0x7232EBE0, "turn_rig_origin" },
    { 0xAF7EA583, "turn_right" },
    { 0x16885AFB, "turn_right_heavy" },
    { 0xB667C36A, "turn_right_light" },
    { 0xD18241C2, "turn_run" },
    { 0x502CD9C7, "turn_scale" },
    { 0x0077591C, "turn_shield_on" },
    { 0x4145789E, "turn_sixth_sense_on" },
    { 0x9CFB7861, "turn_sleight_on" },
    { 0xB371910F, "turn_to_face_point" },
    { 0x101CE34E, "turn_to_human" },
    { 0x9E6A924D, "turn_to_zombie" },
    { 0x47839A4C, "turn_tombstone_on" },
    { 0x4B791227, "turn_towards_target" },
    { 0x385F663D, "turn_trigger" },
    { 0x9598F4C7, "turn_turret_struct" },
    { 0xC7B913E8, "turn_val" },
    { 0xA3B796AA, "turn_vulture_on" },
    { 0x1A9B7B22, "turn_water_sheeting_off" },
    { 0x2D7C9314, "turn_water_sheeting_on" },
    { 0x3F99CE95, "turnangle" },
    { 0xDF5B03E6, "turnanglethreshold" },
    { 0xA1EE1AD2, "turnangletime" },
    { 0xA6081BF3, "turnanim" },
    { 0xE8163D7A, "turnanimlookupkey" },
    { 0x8CBEDE12, "turnanimlookupspecial" },
    { 0xC8D9F81F, "turnaround" },
    { 0x182FE925, "turnback" },
    { 0xAE58ABE6, "turnbackon" },
    { 0x8A628123, "turnblendout" },
    { 0x38F4C143, "turncorner" },
    { 0x982CE2E8, "turnd" },
    { 0xEF326307, "turndirection" },
    { 0x565FFA93, "turndirskew" },
    { 0x60C66E95, "turndistance" },
    { 0x8E87B787, "turned" },
    { 0xC82DFE84, "turned_disable_player_weapons" },
    { 0x8A8621F7, "turned_enable_player_weapons" },
    { 0xC75F5C07, "turned_give_melee_weapon" },
    { 0x90267AA3, "turned_had_knife" },
    { 0x9781A8A4, "turned_local_blast" },
    { 0xAE6B2C4F, "turned_player_buttons" },
    { 0x1D7B51C3, "turned_powerup_green_ammo" },
    { 0x13B4021A, "turned_powerup_green_double" },
    { 0x2FDD1AD6, "turned_powerup_green_insta" },
    { 0xA93BEF1E, "turned_powerup_green_monkey" },
    { 0xE9BED232, "turned_powerup_green_nuke" },
    { 0xF1D105F3, "turned_powerup_red_ammo" },
    { 0xC5C275AA, "turned_powerup_red_double" },
    { 0x29B11942, "turned_powerup_red_nuke" },
    { 0xA0DBBE6B, "turned_powerup_yellow_double" },
    { 0x0AE96173, "turned_powerup_yellow_nuke" },
    { 0xD85A2432, "turned_visionset" },
    { 0x8D19E8EA, "turned_zombie_validation" },
    { 0x07E9ADF6, "turnedhuman" },
    { 0x67600D9B, "turnedlog" },
    { 0xADFB9CC9, "turnedmeleeweapon" },
    { 0x1138402F, "turnedmeleeweapon_dw" },
    { 0x062C5778, "turngrenadeintoadud" },
    { 0xB44276AE, "turnifnecessary" },
    { 0xE78C9E15, "turnignoremotionangle" },
    { 0xE6FFE104, "turning" },
    { 0x970C9C8F, "turning_center_vec" },
    { 0x32E7906D, "turning_into_ghost" },
    { 0x4E76EFCD, "turning_isnt_working" },
    { 0x0638F75C, "turning_speed" },
    { 0x9B7B31D8, "turningaimingoff" },
    { 0x7311DCBB, "turnlastresort" },
    { 0xFCB0637D, "turnleft180limit" },
    { 0x19FA4CC5, "turnleft90limit" },
    { 0xCAD13D14, "turnleftlights" },
    { 0xE1AACA19, "turnlightgreen" },
    { 0x5BA3C6E5, "turnlightred" },
    { 0xF676F983, "turnoff" },
    { 0x71F061FA, "turnoff_house_turrets" },
    { 0xE781AE0E, "turnoffallambientanims" },
    { 0x0F09929F, "turnoffalllightsandlaser" },
    { 0xDC26A335, "turnofffx" },
    { 0xDC032B21, "turnofflight" },
    { 0x3110A54F, "turnon" },
    { 0x894F913F, "turnoncoolertrigger" },
    { 0xE5642B7E, "turnonpapsounds" },
    { 0xE1562B70, "turnout" },
    { 0xFBC547F3, "turnperkon" },
    { 0xC719F558, "turnpreditiontype" },
    { 0xBFE37C3A, "turnrate" },
    { 0xD0AC86F7, "turnrateyawchangeperframe" },
    { 0x28F39E2C, "turnright180limit" },
    { 0x89E76196, "turnright90limit" },
    { 0xC485D991, "turnrightlights" },
    { 0x0265E257, "turns" },
    { 0x09625349, "turns_left" },
    { 0x92BC7374, "turns_right" },
    { 0xDBC3B3AD, "turnsetupidle" },
    { 0x67925565, "turnspeed" },
    { 0x0146D125, "turnstartaiming" },
    { 0xB1A6234F, "turnstrength" },
    { 0xDD8AB153, "turnswitchpanelgreen" },
    { 0x84FE8647, "turnswitchpanelred" },
    { 0x3991AFA0, "turntable" },
    { 0xA1EFA23D, "turnthreshold" },
    { 0xA0B63456, "turntofacepoint" },
    { 0x185A1225, "turntofacerelativeyaw" },
    { 0x97C3D846, "turntomatchnode" },
    { 0xA64F3C15, "turntomatchnodedirection" },
    { 0x544DE2C5, "turnyaw" },
    { 0xF4240167, "turrent" },
    { 0x37B990DB, "turret" },
    { 0x849F87BA, "turret reloading" },
    { 0xCE4434E8, "turret1" },
    { 0x404BA423, "turret2" },
    { 0x1A4929BA, "turret3" },
    { 0x8C5098F5, "turret4" },
    { 0x664E1E8C, "turret5" },
    { 0xD8558DC7, "turret6" },
    { 0x01F3D2BB, "turret_1" },
    { 0x636158CE, "turret_1_barrel" },
    { 0x8FEC6380, "turret_2" },
    { 0x191E7EEB, "turret_2_barrel" },
    { 0xB5EEDDE9, "turret_3" },
    { 0xA242AC68, "turret_3_barrel" },
    { 0x73FB41F6, "turret_4" },
    { 0xC990DA05, "turret_4_barrel" },
    { 0x99FDBC5F, "turret_5" },
    { 0xC7D1FB52, "turret_5_barrel" },
    { 0x980AF03C, "turret_active" },
    { 0xC0FCA621, "turret_ads_reminder" },
    { 0xE3062423, "turret_ads_reminder_off" },
    { 0x212147C9, "turret_ads_reminder_press" },
    { 0x07FC0AD1, "turret_ads_reminder_timed" },
    { 0x24BD78EA, "turret_ai_array" },
    { 0xAEF3878B, "turret_ai_thread" },
    { 0x2EB9B43C, "turret_ammo" },
    { 0xA16A8872, "turret_ang" },
    { 0xF7040862, "turret_angles" },
    { 0x486B0EE9, "turret_array" },
    { 0x28E4E38F, "turret_attack_think" },
    { 0x62164996, "turret_attacks_runner" },
    { 0xF3C93834, "turret_audio" },
    { 0x77913F2C, "turret_audio_failsafe" },
    { 0xE62FD7AB, "turret_audio_override" },
    { 0x224C91CA, "turret_audio_override_alias" },
    { 0x7A672B9D, "turret_audio_ring_override_alias" },
    { 0x2227FA03, "turret_auto_use" },
    { 0xCF07422D, "turret_awareness" },
    { 0x9C61972E, "turret_barrel" },
    { 0x99B1C00A, "turret_barrel_snd" },
    { 0x406830EC, "turret_behavior" },
    { 0x01A828C2, "turret_body" },
    { 0xDD188B86, "turret_boot_time" },
    { 0x7FF49B98, "turret_burst" },
    { 0x67BEAC4F, "turret_burst_max_delay" },
    { 0xA97FA0A8, "turret_burst_max_delay_long" },
    { 0x7FE3313A, "turret_burst_max_duration" },
    { 0xE9065C65, "turret_burst_min_delay" },
    { 0x747FD102, "turret_burst_min_delay_long" },
    { 0xD8CF4EC8, "turret_burst_min_duration" },
    { 0xFEFAFCBA, "turret_burst_power_cutoff" },
    { 0xFC2EA2D0, "turret_burst_power_resume" },
    { 0x3BC800DE, "turret_burst_power_use" },
    { 0xD3B8B2A6, "turret_burst_range" },
    { 0xAB74AD23, "turret_can_be_hacked" },
    { 0xA1337A30, "turret_carried" },
    { 0xDE018432, "turret_carry_dist" },
    { 0x48F5BCBE, "turret_cleanup" },
    { 0xDE81EDBE, "turret_close_anim" },
    { 0xA236E596, "turret_cooldown_max" },
    { 0x8741B9E8, "turret_cooldown_min" },
    { 0xBFE0C3FB, "turret_cooldownrate" },
    { 0xCE3BCC0B, "turret_countdown" },
    { 0x3BD5FCD2, "turret_created" },
    { 0x843D363F, "turret_createmovewatcher" },
    { 0x836F5C6D, "turret_damage" },
    { 0x6A7D728E, "turret_damage_amt_1" },
    { 0x447AF825, "turret_damage_amt_2" },
    { 0x5FF1D852, "turret_damage_fx_1" },
    { 0x39EF5DE9, "turret_damage_fx_2" },
    { 0xD73E5C76, "turret_damage_states" },
    { 0xA558C202, "turret_damagewatch" },
    { 0x58ED2F46, "turret_data" },
    { 0x4C300990, "turret_deactivate" },
    { 0xD7F84474, "turret_deactivated" },
    { 0xA8EF5920, "turret_death" },
    { 0x53944973, "turret_death_monitor" },
    { 0x1EBD4F31, "turret_deathwatch" },
    { 0xA522BCF8, "turret_deathwatcher" },
    { 0x201319A1, "turret_debug_box" },
    { 0x6A14E39C, "turret_debug_line" },
    { 0x7A3CF8E7, "turret_debug_message" },
    { 0x88DA54BF, "turret_delay" },
    { 0x61DF2EC1, "turret_delay_range" },
    { 0x5179BB77, "turret_delete" },
    { 0x725A6C4D, "turret_deleteme" },
    { 0x4E820F76, "turret_destroyed_0" },
    { 0x748489DF, "turret_destroyed_1" },
    { 0x369B0396, "turret_dialog" },
    { 0xD6391DFE, "turret_disabled" },
    { 0x66F236DA, "turret_drain_power" },
    { 0x209190E6, "turret_drain_power_use" },
    { 0xA2FF06A7, "turret_drop_power_use" },
    { 0x4EB19ECA, "turret_duration" },
    { 0x5E95F267, "turret_emp_damage_percentage" },
    { 0x287AAB8B, "turret_emped" },
    { 0x9E96BAAD, "turret_enabled" },
    { 0xA8405329, "turret_enemy_detect_freq" },
    { 0x0D273F4F, "turret_entered" },
    { 0x63B0A5FE, "turret_exit" },
    { 0x973E6741, "turret_exited" },
    { 0x6FCD7885, "turret_explode" },
    { 0x06BCAE43, "turret_find_user" },
    { 0xF2B24332, "turret_fire" },
    { 0xB394C4BA, "turret_fire_burst_max" },
    { 0x7630B9A4, "turret_fire_burst_min" },
    { 0x08C82AB6, "turret_fire_snd" },
    { 0xE84690F2, "turret_fired" },
    { 0xBA75A6BD, "turret_fires" },
    { 0x8F0DE247, "turret_firing_offset" },
    { 0x9BE32704, "turret_flamethrower" },
    { 0x2BED1938, "turret_flash" },
    { 0xB6E196EB, "turret_fov_cos" },
    { 0xF6A1DBB5, "turret_fov_cos_busy" },
    { 0xF77F4E12, "turret_function" },
    { 0xE4E74A64, "turret_fx" },
    { 0xCB408270, "turret_gadget_deploy" },
    { 0x9364C50C, "turret_gadget_deploy_emped" },
    { 0x4318A539, "turret_gadget_deploy_fire_for_time" },
    { 0x690CD6E0, "turret_gadget_deploy_fireupdate" },
    { 0xC64A0FAA, "turret_gadget_deploy_fireupdate_old" },
    { 0xCE81CD90, "turret_gadget_deploy_main" },
    { 0x0D4CAD46, "turret_gadget_deploy_off" },
    { 0x8A2F18D8, "turret_gadget_deploy_on" },
    { 0x8B150479, "turret_gadget_deploy_scripted" },
    { 0x00148EB2, "turret_gadget_deploy_start_ai" },
    { 0x0A7EB26E, "turret_gadget_deploy_start_scripted" },
    { 0xD22727D9, "turret_gadget_deploy_think" },
    { 0x858576A8, "turret_get_attack_node" },
    { 0xE7736BDA, "turret_giveup" },
    { 0xE18957E4, "turret_guy_died" },
    { 0x5EEDAB0A, "turret_guy_spawner" },
    { 0xD2E4BA98, "turret_hack_fail" },
    { 0xA4820CBB, "turret_hack_rumble" },
    { 0xB5C38508, "turret_hack_start" },
    { 0x3AB7063F, "turret_hack_timer" },
    { 0x34549006, "turret_hacked" },
    { 0x4F968793, "turret_hacked_fully" },
    { 0x3B52CFF0, "turret_hacker_cost" },
    { 0x88076DA4, "turret_hacker_time" },
    { 0xA784B9C3, "turret_headicon_offset" },
    { 0xF9FF42A8, "turret_health" },
    { 0xBE0B1BA7, "turret_heat_max" },
    { 0x6FD61BAE, "turret_heat_maxshots" },
    { 0xDD4E0A71, "turret_heat_status" },
    { 0x0D0A7D2C, "turret_hide_compass_on_remote_control" },
    { 0x6335D050, "turret_hint_done" },
    { 0xA6840114, "turret_hud_elem_constant_size" },
    { 0xE687BF98, "turret_hud_marked_target" },
    { 0x44DCFAAD, "turret_id" },
    { 0x9D82C548, "turret_idle_sound" },
    { 0xDBEF7AFF, "turret_idle_sound_stop" },
    { 0xEAC8BB0F, "turret_ignore_me_timer" },
    { 0x1E98B968, "turret_ignore_time" },
    { 0x352728C9, "turret_in_range" },
    { 0xCF42B0B2, "turret_index" },
    { 0xE33D4EAE, "turret_index_used" },
    { 0x4D6EB848, "turret_init" },
    { 0xA5D6CA70, "turret_init_anim" },
    { 0xA5DC0BD1, "turret_initialze" },
    { 0x384DFB81, "turret_invalid_placement_model" },
    { 0x6766A297, "turret_invalid_placement_text" },
    { 0x72FF17B8, "turret_is_mine" },
    { 0x0410F4D2, "turret_kill" },
    { 0x3FDB4221, "turret_kill_players" },
    { 0x7479DF73, "turret_laser_watch" },
    { 0x52DAED11, "turret_last_pos" },
    { 0xE813554D, "turret_left" },
    { 0xE334B126, "turret_left_origin" },
    { 0x123AE8AB, "turret_left_target" },
    { 0x032A202A, "turret_lensflare_id" },
    { 0xA1E7695E, "turret_lighting_origin_set" },
    { 0xAAB0E57E, "turret_linktrigger" },
    { 0x53AFBDCD, "turret_lock_time" },
    { 0x28E670E8, "turret_loop_left" },
    { 0xCDAB34B7, "turret_loop_right" },
    { 0x4D539F35, "turret_lose_sight_time" },
    { 0xF1EAA5E9, "turret_mark_node_dangerous" },
    { 0x6B0FDE90, "turret_max_sight_dist_sq" },
    { 0x87C2871A, "turret_max_target_distance" },
    { 0x436D59CD, "turret_microwave" },
    { 0x3D07B4BD, "turret_microwave_sound" },
    { 0x82ED218F, "turret_microwave_sound_off" },
    { 0x494BE470, "turret_microwave_sound_off_waiter" },
    { 0xCDBF3444, "turret_microwave_sound_start" },
    { 0x3D16C1DB, "turret_microwave_sound_updater" },
    { 0x7D53D57C, "turret_microwave_sounds" },
    { 0x5603EF38, "turret_microwave_think" },
    { 0xB99ACDB7, "turret_microwave_watchfordogs" },
    { 0x29DE01BD, "turret_model" },
    { 0x511678C5, "turret_model_red" },
    { 0x55EFFA92, "turret_movement_behavior" },
    { 0x0DA3547B, "turret_name" },
    { 0xA40EBDC9, "turret_needed" },
    { 0x841C3C84, "turret_no_vis" },
    { 0x4F5B27CA, "turret_node" },
    { 0x1F7E1CCE, "turret_num" },
    { 0xD4B12D2F, "turret_offset" },
    { 0x4AB576DF, "turret_on_target" },
    { 0x40457F4E, "turret_on_target_thread" },
    { 0x58B98269, "turret_on_vistarget" },
    { 0xEB4EB64E, "turret_open" },
    { 0xA769D928, "turret_org" },
    { 0x2FB99BBC, "turret_origin" },
    { 0x332BF0AC, "turret_outline_material" },
    { 0x9522F517, "turret_outline_material_warn" },
    { 0x4C47A606, "turret_own_target" },
    { 0x6AE4D2A9, "turret_owner_power_callback" },
    { 0x61797004, "turret_path_monitor" },
    { 0x92476331, "turret_pickup_" },
    { 0xAD5F8154, "turret_pickup_text" },
    { 0x56E6B09E, "turret_pickup_update" },
    { 0xF2196552, "turret_pickupwatcher" },
    { 0xF90FB1D2, "turret_place_" },
    { 0x2397FE61, "turret_placed" },
    { 0xC6EA467F, "turret_placement" },
    { 0x1CBDE82D, "turret_placementwatcher" },
    { 0x6E0291F5, "turret_plant" },
    { 0xF6687418, "turret_pos" },
    { 0x0FF83AF7, "turret_position" },
    { 0xD8841C9B, "turret_power_off" },
    { 0x871DBD27, "turret_power_on" },
    { 0xC0538DBD, "turret_precache" },
    { 0xA72641A6, "turret_preplaced" },
    { 0x8FD2D2AD, "turret_range" },
    { 0x76068397, "turret_rapid_fire" },
    { 0x9B71695A, "turret_rapid_fire_stop" },
    { 0xB4228740, "turret_recover_power_use" },
    { 0xF8E33F98, "turret_recovery_angledot" },
    { 0x709B7F07, "turret_recovery_distance" },
    { 0xEE092D42, "turret_recovery_holdtime" },
    { 0xB2EE6B91, "turret_recovery_prompt_0" },
    { 0x8CEBF128, "turret_recovery_prompt_1" },
    { 0x9E555B2A, "turret_remote_text" },
    { 0xCCB401EF, "turret_rescue_hud_elem" },
    { 0x7457D47A, "turret_rescue_hud_elem_hide" },
    { 0x29DF9021, "turret_rescue_hud_elem_off" },
    { 0x344B82F9, "turret_rescue_hud_elem_show" },
    { 0x20FD017F, "turret_reset" },
    { 0xB8C5BB3A, "turret_reset_on_ender" },
    { 0x892E0770, "turret_right" },
    { 0xBAC67A25, "turret_right_origin" },
    { 0x7DA88480, "turret_right_target" },
    { 0x658537C1, "turret_rot_scale_combat" },
    { 0xA281B6B3, "turret_rot_scale_idle" },
    { 0xBAB49295, "turret_rotate_stopped" },
    { 0xB3E0B4F7, "turret_rotate_timeout" },
    { 0xF2A352B2, "turret_scan_angle_buffer" },
    { 0x89F9434C, "turret_scan_start" },
    { 0x351A0BCE, "turret_scan_start_sound_ent" },
    { 0x05829180, "turret_scan_stop" },
    { 0xB60C214B, "turret_scan_wait" },
    { 0xB6FDBD2E, "turret_sentry_think" },
    { 0x34DE2B92, "turret_set_difficulty" },
    { 0xC111D1C2, "turret_set_team" },
    { 0xACFC37D5, "turret_shared" },
    { 0x6BDE2903, "turret_shoot" },
    { 0x3B80E66E, "turret_sight_latency" },
    { 0x35F47C62, "turret_slot" },
    { 0xB99C7CBE, "turret_sound_cleanup" },
    { 0x606AF848, "turret_sound_init" },
    { 0x3BDFCEDB, "turret_spawn" },
    { 0xF5D48615, "turret_state" },
    { 0xF03ADAE4, "turret_state_scan_at_enemy" },
    { 0x098086F5, "turret_state_scan_forward" },
    { 0xFE77256D, "turret_state_scan_forward2" },
    { 0xF677ABF5, "turret_state_scan_left" },
    { 0x5C43F7D8, "turret_state_scan_right" },
    { 0x60D5D627, "turret_stun_ended" },
    { 0x529A8C7D, "turret_stun_kill" },
    { 0x4584A25E, "turret_suppression_fire" },
    { 0xD2165BBA, "turret_switch_hud_elem" },
    { 0x143D3430, "turret_switch_hud_elem_off" },
    { 0xC2239062, "turret_switch_watch" },
    { 0xEDFD79C9, "turret_target" },
    { 0x263FFE06, "turret_target_ai" },
    { 0x71E4ACAD, "turret_target_angle" },
    { 0x87C09F31, "turret_target_aquired" },
    { 0x279CB35D, "turret_target_aquired_watch" },
    { 0x88A86D64, "turret_target_check" },
    { 0x0BC59875, "turret_target_drones" },
    { 0x7B27C61A, "turret_target_flag" },
    { 0x2BBE02F6, "turret_target_lost" },
    { 0xD571326A, "turret_target_lost_watch" },
    { 0x37D1DE3A, "turret_target_players" },
    { 0x8D3AA897, "turret_target_vehicles" },
    { 0x5D26EEC0, "turret_targets" },
    { 0x63E1E51C, "turret_template" },
    { 0xBC1B579D, "turret_text_off" },
    { 0x9A942751, "turret_text_on" },
    { 0x661DADEA, "turret_think" },
    { 0x4B13668E, "turret_think_time" },
    { 0x4E24BF4C, "turret_time_to_go" },
    { 0x4D59169F, "turret_timeout" },
    { 0x83C29595, "turret_timeout_self_destruct" },
    { 0x0B353569, "turret_timer" },
    { 0xEDDBCC53, "turret_tow_fire" },
    { 0x038617B9, "turret_tow_think" },
    { 0x63A7D58E, "turret_tow_unlink" },
    { 0x279F8E5D, "turret_trace" },
    { 0xFC1B1F69, "turret_trace_offset" },
    { 0x550E48BC, "turret_trace_test" },
    { 0xE499C876, "turret_trigger" },
    { 0x8CFE8969, "turret_triggers" },
    { 0xB897D0C4, "turret_turnleft" },
    { 0xF03177C7, "turret_update_damage" },
    { 0xF6B7ABBD, "turret_use_failed" },
    { 0x8FF55105, "turret_use_time" },
    { 0xFC2180AF, "turret_user" },
    { 0xB58C8F18, "turret_user_moves" },
    { 0xE7D426ED, "turret_usewatcher" },
    { 0x0AE1CBD2, "turret_valid_placement_model" },
    { 0x9E03EA06, "turret_valid_placement_text" },
    { 0xEF82BC40, "turret_vehicle_entnum" },
    { 0xB659BDF8, "turret_vehicle_name" },
    { 0x48934903, "turret_visionset_alias" },
    { 0x4FBD093B, "turret_visionset_file" },
    { 0xF62DDC03, "turret_visionset_lerp_step_count" },
    { 0xB2AB8CB3, "turret_waits_for_player_exit" },
    { 0x0A440558, "turret_waits_for_player_use" },
    { 0xD456839F, "turret_watch_death_duration" },
    { 0xAD8D0F99, "turret_watch_owner_events" },
    { 0xF90BF04F, "turret_watch_owner_events_singleton" },
    { 0x6F487075, "turret_weapongivebackwatch" },
    { 0x348D377F, "turret_yaw" },
    { 0x61AC8A90, "turretaimpos" },
    { 0x502C5850, "turretallowfriendlyfiredamage" },
    { 0x124BF75F, "turretangles" },
    { 0x58F09DC6, "turretarray" },
    { 0x576C2E39, "turretbuildable" },
    { 0x21720AB0, "turretcallback_vehicledamage" },
    { 0xE309BF54, "turretcantarget" },
    { 0x6DB4F28F, "turretdamagecb" },
    { 0x4842E6E3, "turretdeathdetacher" },
    { 0x8439B5B1, "turretdeathwaiter" },
    { 0x16F0C61C, "turretdebug" },
    { 0x2DA8E9E5, "turretdebugwatch" },
    { 0xE6E2577B, "turretdecay" },
    { 0x0776F4EB, "turretdetacher" },
    { 0xCEAB8847, "turretdoaimanims" },
    { 0x2EAD73A5, "turretdoshoot" },
    { 0x5BD71DB5, "turretdoshootanims" },
    { 0xB0DD6BB0, "turretfiredelay" },
    { 0x2D750461, "turretfiredisable" },
    { 0xCE0CBA22, "turretfireenable" },
    { 0xD4AAC9B4, "turretfireupdate" },
    { 0xAEF23C92, "turretfiring" },
    { 0xD3EFB5B2, "turretforward" },
    { 0x730245D7, "turretguys" },
    { 0x4FAB9CC4, "turretidx" },
    { 0x85C7B75B, "turretindependent" },
    { 0xF20AC053, "turretinfo" },
    { 0x1FC79682, "turretinfos" },
    { 0x11CD7C13, "turretinhurttrigger" },
    { 0x2AAD4445, "turretinit" },
    { 0x32EBDE82, "turretinitdelay" },
    { 0x69C670E6, "turretinnoturretplacementtrigger" },
    { 0x5026E438, "turretinvulnerability" },
    { 0x64E287F0, "turretkills_challenge" },
    { 0x1B1A1486, "turretlocation" },
    { 0x5DAE8BD5, "turretlocked" },
    { 0x0431FD2A, "turretmodel" },
    { 0x55DB5951, "turretmovetimeout" },
    { 0xF0EB5AB6, "turretname" },
    { 0x9514E737, "turretontarget" },
    { 0x40CAF7E3, "turretontargetfortime" },
    { 0xC275C2D1, "turretorigin" },
    { 0x1F6FCDB8, "turretorigins" },
    { 0x4A224693, "turretoverheat" },
    { 0x932725B0, "turretowner" },
    { 0x884FAE38, "turretownerchange" },
    { 0x889F9A5F, "turretpkg" },
    { 0xCBA3319F, "turretqrkills_challenge" },
    { 0x14491009, "turretqrkills_death_listener" },
    { 0xD390706B, "turretregulatetime" },
    { 0xBF01218D, "turretrockethits" },
    { 0xBFA53800, "turretrotscale" },
    { 0x9AE7C3FA, "turrets" },
    { 0xF652CB00, "turrets_hacker_trigger_height" },
    { 0xA5F289A3, "turrets_hacker_trigger_width" },
    { 0xD577D91A, "turrets_headicon_offset" },
    { 0x4F7A3446, "turretscanning" },
    { 0x28FADC66, "turretscanstartwaiter" },
    { 0xB88BA04F, "turretscanstopnotify" },
    { 0x783E7BEA, "turretscanstopwaiter" },
    { 0x623FCCEA, "turretscanstopwaitercleanup" },
    { 0x89FFE66C, "turretsettings" },
    { 0xD950BFD7, "turretsightchecker" },
    { 0x006783B0, "turretsn" },
    { 0x02467E0D, "turretspinning" },
    { 0x8F5DA088, "turretsquadid" },
    { 0x366528EE, "turretstate" },
    { 0xD7A6C66A, "turretstatechange" },
    { 0xC83B1814, "turretstruct" },
    { 0x15863B74, "turrettagarray" },
    { 0x66644E84, "turrettarget" },
    { 0xE18D90B5, "turretthink" },
    { 0x15696E72, "turrettimer" },
    { 0xB6D5D902, "turretturn" },
    { 0x3B12FA43, "turrettype" },
    { 0x253E1F7F, "turretupgraded" },
    { 0x7B546D30, "turretupgrades" },
    { 0x4277BDA1, "turretvehicle" },
    { 0x4D0C70DD, "turretwasused" },
    { 0x9ACDBFDC, "turretwatch" },
    { 0x76C74C4F, "turretweapon" },
    { 0x5048A716, "turretweapons" },
    { 0xC10BA3F4, "tursquad" },
    { 0x258D79C7, "tus" },
    { 0xECC30A89, "tut_dialogue" },
    { 0x5A2643C3, "tut_done" },
    { 0x77C392B6, "tut_done_done" },
    { 0xF6322F39, "tut_done_done_done" },
    { 0x05E95712, "tut_hud" },
    { 0xDD91DA6D, "tut_start" },
    { 0x4007D730, "tut_start_done" },
    { 0xA7A531AB, "tut_start_done_done" },
    { 0x25CAB593, "tut_targets" },
    { 0x2525308B, "tutorial" },
    { 0x17D4869F, "tutorial_01" },
    { 0xA5CD1764, "tutorial_02" },
    { 0xCBCF91CD, "tutorial_03" },
    { 0x0DC32DC0, "tutorial_06" },
    { 0x21E5DF7E, "tutorial_08" },
    { 0x47E859E7, "tutorial_09" },
    { 0x71A6A6E1, "tutorial_10" },
    { 0x64A586EA, "tutorial_10a" },
    { 0xBDAB9BB3, "tutorial_12" },
    { 0xE135B900, "tutorial_12a" },
    { 0x97A9214A, "tutorial_13" },
    { 0x09B09085, "tutorial_14" },
    { 0xE3AE161C, "tutorial_15" },
    { 0x55B58557, "tutorial_16" },
    { 0x2FB30AEE, "tutorial_17" },
    { 0x6BCA9673, "tutorial_17a" },
    { 0x4192D399, "tutorial_18" },
    { 0x1B905930, "tutorial_19" },
    { 0xF4A33FE0, "tutorial_20" },
    { 0x9486153C, "tutorial_abort" },
    { 0xF2254D8B, "tutorial_complete" },
    { 0xE2FE24A0, "tutorial_create_hud" },
    { 0xCB77BE2E, "tutorial_display_tip" },
    { 0xFFB08A62, "tutorial_exit_watch" },
    { 0xBCF58D4B, "tutorial_message" },
    { 0x3CDDC8C4, "tutorial_msg_cleared" },
    { 0xA6399FBD, "tutorial_setup" },
    { 0xC5808F6B, "tutorial_text_hint_time" },
    { 0x9BE3D60E, "tutorialfunctions" },
    { 0xD8EF722A, "tutorialobj" },
    { 0x4B04D8EA, "tutorials" },
    { 0xD98DF83C, "tutorialtriggers" },
    { 0x584D4D8F, "tv" },
    { 0x705EBF90, "tv_01_impact" },
    { 0x804890A5, "tv_02_impact" },
    { 0x6C1D98BF, "tv_04_impact" },
    { 0xBA47CD29, "tv_06_impact" },
    { 0x498C6CC5, "tv_array" },
    { 0x428E4FCD, "tv_breach" },
    { 0xF1077AF0, "tv_breach_dialog" },
    { 0xDD12C1DC, "tv_breacher" },
    { 0xBC8747C9, "tv_changes_color" },
    { 0xAD6AFBC7, "tv_changes_intensity" },
    { 0x73E3E967, "tv_count" },
    { 0x8592FF91, "tv_damage" },
    { 0x7475BCF2, "tv_done" },
    { 0x823A08FB, "tv_extracam_off" },
    { 0xC58DC007, "tv_extracam_on" },
    { 0x21A4E537, "tv_fov_in" },
    { 0x92C1F62E, "tv_helper" },
    { 0x1D2781D4, "tv_lite_array" },
    { 0xDBD56884, "tv_logic" },
    { 0xD8498D0B, "tv_missile_controls" },
    { 0xDF78F9CB, "tv_missile_controls_message" },
    { 0xF70FE910, "tv_missile_futz" },
    { 0x71142CCF, "tv_missile_instruction_displayed" },
    { 0xE2CEC481, "tv_off" },
    { 0x8A85CC34, "tv_primary_lights" },
    { 0xB34B1C47, "tv_sound" },
    { 0xB0BDA604, "tv_sound_b" },
    { 0x0B2A703E, "tv_sounds" },
    { 0x2E90CE8A, "tv_start" },
    { 0xC21A9B72, "tv_start_spawners" },
    { 0x6D7D2123, "tv_station_visionset" },
    { 0xDDA34578, "tv_ui" },
    { 0x5CC8E34A, "tv_wall" },
    { 0x0999B2DA, "tv_wall_notify" },
    { 0xE2C659A3, "tv_wall_start" },
    { 0x6DBB3FF1, "tvelin" },
    { 0x2761870E, "tvhook" },
    { 0x47409E09, "tvmissile" },
    { 0x5677F388, "tvmissile_influencer_length" },
    { 0x9BC29D9E, "tvmissile_influencer_radius" },
    { 0x41ECB05A, "tvmissile_influencer_score" },
    { 0xA5395B46, "tvmissile_influencer_score_curve" },
    { 0x10F127C9, "tvmod" },
    { 0x9779D356, "tvs" },
    { 0xE951E139, "tvstation_entered" },
    { 0x324AD326, "tw" },
    { 0x9494A723, "twar" },
    { 0x791D5CA6, "twar_contested_flag" },
    { 0x5DA00375, "twar_contested_flag_influencer_radius" },
    { 0x64AEE683, "twar_contested_flag_influencer_score" },
    { 0x5A225BC7, "twar_contested_flag_influencer_score_curve" },
    { 0x94EB3634, "twar_flag_descriptor" },
    { 0xF92635E8, "twar_gamemodespawndvars" },
    { 0x074EB707, "twar_linked_flag_influencer_score" },
    { 0x5EFF04A7, "twar_linked_flag_influencer_score_falloff_percentage" },
    { 0xB3252797, "twar_linked_flag_near_objective_bonus" },
    { 0xB201F9BE, "twar_playerspawnedcb" },
    { 0x6F0CDC35, "twar_senddvartoallplayers" },
    { 0x9B32D364, "twar_setclientdvar" },
    { 0x9D0AA88F, "twar_threadedplayerspawnedcb" },
    { 0x28FA51C8, "twar_update_spawn_influencers" },
    { 0x4F275C1C, "twards" },
    { 0x2FD9E551, "twarflag" },
    { 0xD4121D38, "twarflags" },
    { 0xB7F9893F, "tweak" },
    { 0xBAA89A82, "tweak_toggle" },
    { 0x20DA9366, "tweak_x" },
    { 0x46DD0DCF, "tweak_y" },
    { 0xD4D59E94, "tweak_z" },
    { 0x85F5C0AF, "tweakable" },
    { 0x15CB3FF6, "tweakables" },
    { 0x36A20E1A, "tweakables_shared" },
    { 0xB77175EC, "tweakablesinitialized" },
    { 0x2FBDF634, "tweakage" },
    { 0x2156B2DE, "tweakart" },
    { 0x474ED644, "tweaked" },
    { 0xE9F13D99, "tweakfile" },
    { 0x8297CFEE, "tweakfog_fraction" },
    { 0x7FAE2FC1, "tweaking" },
    { 0x234C7C46, "tweaks" },
    { 0x3E090C1B, "tweaponlist" },
    { 0x198DC4FD, "tweeking" },
    { 0x8D509D5E, "tween" },
    { 0xD3430C3A, "tween_time" },
    { 0x52392041, "tweendof" },
    { 0xDCAD99A1, "tweened" },
    { 0xCD1EFFC1, "tweens" },
    { 0x5E8E04F6, "twenty" },
    { 0x4DE606EB, "twice" },
    { 0x33710AB7, "twin" },
    { 0x23AC5E84, "twin_apc_shoot" },
    { 0x1A3E98A2, "twist" },
    { 0x69039BFC, "twitch" },
    { 0xD3EC0604, "twitch_anim" },
    { 0x31CEA6B7, "twitch_anims" },
    { 0x43DF504B, "twitch_length" },
    { 0xBACE7C78, "twitch_time" },
    { 0x4003AD74, "twitchallowed" },
    { 0x4D7CEDDB, "twitchanim" },
    { 0xF1CA8490, "twitches" },
    { 0x0ED1144C, "twn" },
    { 0x34D38EB5, "two" },
    { 0x93F7FF3E, "two_attachment_perc" },
    { 0x3566810B, "two_digit_scene_num" },
    { 0x6D94B4E3, "two_digit_shot_num" },
    { 0x2D5D8B19, "two_lines" },
    { 0xB59891F9, "two_pi" },
    { 0xED19E9A8, "two_player_coopenemyaccuracyscalar" },
    { 0xED274ED3, "two_player_coopfriendlyaccuracyscalar" },
    { 0x4C0A2833, "two_player_coopfriendlythreatbiasscalar" },
    { 0xB19673F7, "two_player_coopplayerdifficultyhealth" },
    { 0x89052855, "two_player_deathinvulnerabletimemodifier" },
    { 0x01BB1260, "two_player_enemy_pain_chance_modifier" },
    { 0x9EF90923, "two_player_hit_invulnerability_modifier" },
    { 0x6ED175FA, "two_stage_spawner_think" },
    { 0xA04467EE, "two_tanks_dead_vo" },
    { 0xB9A846B5, "two_way" },
    { 0x4CA105E6, "twobuttonspressed" },
    { 0x983C708B, "twr_angles" },
    { 0xD47229A5, "twr_origin" },
    { 0x06B00EE7, "txt" },
    { 0x2E71A2EA, "txt_trigger" },
    { 0x6B4004F8, "txt_voice" },
    { 0xF0A8D27C, "txtsize" },
    { 0x4DF37C95, "tye" },
    { 0x17531AAD, "tyhe" },
    { 0x265D4C60, "tying" },
    { 0x757B6A61, "tyler" },
    { 0x10DDDEC9, "typ100" },
    { 0xFE311E35, "type" },
    { 0x9677B996, "type1" },
    { 0xD4A0CDB2, "type10" },
    { 0x2C3C5904, "type100_smg" },
    { 0x70753F2D, "type2" },
    { 0x4A72C4C4, "type3" },
    { 0x24704A5B, "type4" },
    { 0xFE6DCFF2, "type5" },
    { 0xD86B5589, "type6" },
    { 0xB268DB20, "type7" },
    { 0xEC8E0747, "type8" },
    { 0xC68B8CDE, "type9" },
    { 0xA391048E, "type94" },
    { 0xA474613B, "type94_init" },
    { 0x60CEB594, "type99_rifle" },
    { 0xB96C993B, "type99_rifle_scoped" },
    { 0x66BB61C0, "type_data" },
    { 0xB878B0B3, "type_flag_trigger" },
    { 0x5AA0F5D3, "type_getup_lives" },
    { 0xFD01CEEF, "type_goalvolume" },
    { 0xAF207FBC, "type_index" },
    { 0xE960DF94, "type_keys" },
    { 0x054285AD, "type_killspawner_trigger" },
    { 0xE06749EA, "type_of_attack" },
    { 0x3301D8FB, "type_predicate" },
    { 0x2F0A4736, "type_reg" },
    { 0x15041726, "type_reg_flag_trigger" },
    { 0xCA31246E, "type_reg_goalvolume" },
    { 0x0B566F72, "type_reg_killspawner_trigger" },
    { 0xAD9A01FB, "type_reg_spawn_trigger" },
    { 0x5DDD8006, "type_reg_spawners" },
    { 0xB7E3891B, "type_reg_trigger" },
    { 0x818D2AC7, "type_reg_vehicle" },
    { 0xCB06427E, "type_score" },
    { 0xC27AFB0E, "type_so" },
    { 0x9153778E, "type_so_flag_trigger" },
    { 0xA0D26476, "type_so_goalvolume" },
    { 0xF1551B4A, "type_so_killspawner_trigger" },
    { 0x45405353, "type_so_spawn_trigger" },
    { 0x14D1FE0E, "type_so_spawners" },
    { 0x9C2D7D53, "type_so_trigger" },
    { 0x8369EADF, "type_so_vehicle" },
    { 0x51FD46AC, "type_spawn_trigger" },
    { 0xCCD9B7C7, "type_spawners" },
    { 0xC044DE43, "type_struct" },
    { 0x301035DC, "type_trigger" },
    { 0x7BC1B598, "type_vehicle" },
    { 0x05368B2B, "typed" },
    { 0x36DF008A, "typekey" },
    { 0x6620ECC5, "typekeys" },
    { 0x9EE2B3B9, "typelimited" },
    { 0x0F47E40A, "typem" },
    { 0xBF94C585, "typeoverride" },
    { 0xCB115F04, "types" },
    { 0x93BAA4A6, "typestring" },
    { 0x3F7E9747, "typical" },
    { 0x3827F0CA, "typically" },
    { 0x441C4924, "typicaly" },
    { 0x09BBDB00, "typing" },
    { 0x2B678427, "typing_sound_thread" },
    { 0x1A223FBF, "typo" },
    { 0x74C74791, "tyrannized" },
    { 0xC18986EA, "u" },
    { 0xA882C864, "u2_crash" },
    { 0x2EDBABAD, "u2_maxhealth" },
    { 0x5882D638, "u_buttons" },
    { 0x768D82C9, "u_buttons_disable" },
    { 0x86E113C2, "u_cut_exit_ai_group_watcher" },
    { 0x694FD93E, "u_cut_guys" },
    { 0x1144BDE3, "u_w_r" },
    { 0x64C90E23, "uav" },
    { 0x78115B6E, "uav_death_model" },
    { 0x9598EF22, "uav_duration" },
    { 0xA9531027, "uav_duration_check" },
    { 0xED726A62, "uav_exit_time" },
    { 0x3CDC5320, "uav_health" },
    { 0xE6E7D195, "uav_low_health" },
    { 0xF526D465, "uav_model" },
    { 0x23418D63, "uav_name" },
    { 0x42CD8AD6, "uav_remote_aim_assist_range" },
    { 0x1117A5EA, "uav_remote_collision_radius" },
    { 0xD3B160EA, "uav_remote_fly_time" },
    { 0x97C5A935, "uav_remote_heli_range_countdown" },
    { 0x4508BB10, "uav_remote_max_heli_proximity" },
    { 0x5FD2B8DC, "uav_remote_max_past_range" },
    { 0x32BABE96, "uav_remote_min_heli_proximity" },
    { 0x2B4892E6, "uav_remote_model" },
    { 0xC106A33F, "uav_remote_model_enemy" },
    { 0x907DEFFD, "uav_remote_past_range_countdown" },
    { 0xE04CA32B, "uav_remote_z_offset" },
    { 0x39B30329, "uav_rotation_radius" },
    { 0x8322EE74, "uav_rotation_random_offset" },
    { 0x45D3DD7D, "uav_struct" },
    { 0xA9099EA6, "uav_target_convoy_leader" },
    { 0x88344AD1, "uav_time" },
    { 0x4E9F65D9, "uav_update" },
    { 0x56B85DB6, "uav_z_offset" },
    { 0x67D9D8DC, "uavacquiredprintandsound" },
    { 0x5ABE21F1, "uavhackertoolradius" },
    { 0xBC10D460, "uavhackertooltimems" },
    { 0x378A3541, "uavlight" },
    { 0xE54E46B9, "uavorigin" },
    { 0xEA1928AF, "uavrig" },
    { 0x51AB6212, "uavs" },
    { 0xA3D9FD58, "uavtime" },
    { 0x173DBC2D, "uavtracker" },
    { 0xCCBF247F, "uaz" },
    { 0x4550B2B7, "uaz1_arena_logic" },
    { 0xBBFF2240, "uaz2_arena_logic" },
    { 0x725ECE4D, "uaz3_arena_logic" },
    { 0x362C78E0, "uaz3_arena_skipto_logic" },
    { 0x6F1BF704, "uaz_anims" },
    { 0xAC67491E, "uaz_arena_chase_horse" },
    { 0x00402C4B, "uaz_arena_chase_horse_behavior" },
    { 0xB80F8E13, "uaz_bp1_exit_logic" },
    { 0x862A9FBC, "uaz_bp3_logic" },
    { 0x0AA03BBF, "uaz_driver_death" },
    { 0x39150680, "uaz_driver_duck" },
    { 0x78318A34, "uaz_driver_enter_from_huntedrun" },
    { 0xABD88D1F, "uaz_driver_enter_from_huntedrun_door" },
    { 0xB0353B1E, "uaz_driver_exit_into_run" },
    { 0x46B293E5, "uaz_driver_exit_into_run_door" },
    { 0xCB5B9F31, "uaz_driver_idle" },
    { 0xD688E24C, "uaz_driver_idle_drive" },
    { 0xE007309D, "uaz_driver_turnleft" },
    { 0x3B1A1A80, "uaz_driver_turnright" },
    { 0x6F67B25F, "uaz_driver_weave" },
    { 0x540ED6AE, "uaz_gate_dude" },
    { 0x7A95EA3B, "uaz_lguy_fire_hide_back_v1" },
    { 0x088E7B00, "uaz_lguy_fire_hide_back_v2" },
    { 0x514A8338, "uaz_lguy_fire_side_v1" },
    { 0xC351F273, "uaz_lguy_fire_side_v2" },
    { 0xBEF5D583, "uaz_lguy_idle_hide" },
    { 0xACEF89BE, "uaz_lguy_standfire_side_v3" },
    { 0xEEE325B1, "uaz_lguy_standfire_side_v4" },
    { 0xAD9575CC, "uaz_lguy_trans_back2hide" },
    { 0x876EBBCA, "uaz_lguy_trans_hide2back" },
    { 0x36A52563, "uaz_override_vehicle" },
    { 0x961FBCE5, "uaz_overrides" },
    { 0xAECD9BD8, "uaz_passenger2_enter_from_huntedrun" },
    { 0x307D683B, "uaz_passenger2_enter_from_huntedrun_door" },
    { 0x0EC532D2, "uaz_passenger2_exit_into_run" },
    { 0x1FA9B261, "uaz_passenger2_exit_into_run_door" },
    { 0x0E25E06D, "uaz_passenger2_idle" },
    { 0x0EBA9316, "uaz_passenger_enter_from_huntedrun" },
    { 0x427B58DD, "uaz_passenger_enter_from_huntedrun_door" },
    { 0xE764E8AC, "uaz_passenger_exit_into_run" },
    { 0x5C8040F7, "uaz_passenger_exit_into_run_door" },
    { 0x506A225A, "uaz_passenger_idle_drive" },
    { 0x4F2EBAF9, "uaz_rail_logic" },
    { 0x1F370AAF, "uaz_rear_driver_enter_from_huntedrun" },
    { 0x90D3FB16, "uaz_rear_driver_enter_from_huntedrun_door" },
    { 0x9876CCAF, "uaz_rear_driver_exit_into_run" },
    { 0x2932C116, "uaz_rear_driver_exit_into_run_door" },
    { 0x22BA4882, "uaz_rear_driver_idle" },
    { 0xDBD29476, "uaz_rguy_fire_back_rpg" },
    { 0xDEBF6A96, "uaz_rguy_fire_back_v1" },
    { 0xB8BCF02D, "uaz_rguy_fire_back_v2" },
    { 0x7CD3879E, "uaz_rguy_idle" },
    { 0xB7609885, "uaz_rguy_scan_side_v1" },
    { 0xE307F957, "uaz_rpg_launch" },
    { 0x40D718A3, "uaz_steeringwheel_death" },
    { 0x2207E384, "uaz_steeringwheel_duck" },
    { 0x325ABB3D, "uaz_steeringwheel_idle" },
    { 0xEA3C2EC9, "uaz_steeringwheel_turnleft" },
    { 0x09B0FDF4, "uaz_steeringwheel_turnright" },
    { 0xA43E5CBB, "uaz_steeringwheel_weave" },
    { 0xA4AA6145, "uaz_vehicle_anims" },
    { 0x1EF7E48F, "uaz_vehicle_anims_clear" },
    { 0x1522AD86, "uazs" },
    { 0x6C3B7D24, "ub_print" },
    { 0xD7B1EF89, "uber" },
    { 0xD165F61D, "uber_prize_models" },
    { 0x815DC2DC, "uberkillingmachinestreak" },
    { 0xAF515162, "ucut" },
    { 0x285AD72B, "ucut_allies" },
    { 0xFCB113F0, "ud_look_angle" },
    { 0x35B7656D, "udefined" },
    { 0xF35AF68F, "udot" },
    { 0x9AC8D4D1, "udotabs" },
    { 0xEA62233A, "udpated" },
    { 0x32A4480F, "ufo" },
    { 0x9C648046, "ufomode" },
    { 0xE6DB083B, "ugh" },
    { 0xF178112D, "ugliness" },
    { 0x4C8FA8DC, "ugly" },
    { 0x4702AECB, "ugx" },
    { 0xF7A4F547, "ugx_modder_help" },
    { 0xAF4CC2AB, "ugx_script" },
    { 0x25BADC36, "uh" },
    { 0x80D70380, "uh_oh" },
    { 0x8B8BC96A, "uhh" },
    { 0x4BBD569F, "ui" },
    { 0x75113B16, "ui3d" },
    { 0xBEB0724A, "ui3dsetwindow" },
    { 0x6377D85A, "ui3dwindow" },
    { 0x1A448435, "ui_aarmapname" },
    { 0xF15CE72A, "ui_binktv" },
    { 0xEADCDD7E, "ui_dofrontendsave" },
    { 0xCBA7F6D6, "ui_extracam_tv" },
    { 0xE9036651, "ui_mapname" },
    { 0x8BA65881, "ui_model" },
    { 0x1A2E89C5, "ui_model_name" },
    { 0x872FABF1, "ui_mp" },
    { 0x58BFDF3E, "ui_note" },
    { 0xB0D87FC5, "ui_team" },
    { 0xD67A65DA, "ui_throw" },
    { 0x409ADF13, "ui_throw_start" },
    { 0x08ED01D8, "ui_tv" },
    { 0xBBA19068, "uieditor" },
    { 0xF5F2AC2E, "uimodel" },
    { 0x27F1A7CD, "uint" },
    { 0xF9A26FC7, "uiparent" },
    { 0x15A433DD, "uitv" },
    { 0x78819460, "ultimate" },
    { 0xF28EE525, "ultimate_destination" },
    { 0xDCCFADA5, "ultimately" },
    { 0xD65D3815, "ultra" },
    { 0x7D046B51, "ultranationalist" },
    { 0x4E030F38, "ultranationalists" },
    { 0xEEDB6E4E, "ulx" },
    { 0xA784F27B, "ulxy" },
    { 0x14DDE8B7, "uly" },
    { 0xA164B441, "ulysses" },
    { 0x7FF6E50B, "umbilical" },
    { 0xE8E2AA66, "umbilical_cord" },
    { 0x0C776FB8, "umbilical_room_wires_1" },
    { 0x9A33B1FD, "umbilical_wires_ambient" },
    { 0x3FF5A5E6, "umbilical_wires_taught" },
    { 0x7BAE8AA8, "umbra" },
    { 0xE2F52F03, "umbra_fix_logic" },
    { 0x69B7E3F9, "umbra_fix_trigger" },
    { 0x6ACAFFB2, "umbra_name" },
    { 0x1BA5ADE8, "umbra_settometrigger" },
    { 0xDF7A43B4, "umm" },
    { 0x41ABFDC0, "un" },
    { 0x423768F0, "un0" },
    { 0x8E3C5DC2, "un2" },
    { 0x12536F63, "un_link" },
    { 0x63B192E2, "un_thread_on_targetname" },
    { 0x8773A289, "una" },
    { 0x24ABF758, "unable" },
    { 0x5367036A, "unacquire_weapon_toggle" },
    { 0x4258E32B, "unacquire_weapon_toggle_on_death_or_disconnect_thread" },
    { 0xE6C0D43C, "unaffected" },
    { 0x9838EB5C, "unaligned" },
    { 0xC52A63F1, "unarmed" },
    { 0x6BF49B30, "unarmedwalkactionstart" },
    { 0x98E97F70, "unary_predicate" },
    { 0x64DB5B4F, "unattach" },
    { 0x567A282C, "unattackable" },
    { 0x133C3097, "unauthorized" },
    { 0xCBA45B31, "unavailable" },
    { 0x9489A5EA, "unaware" },
    { 0x8E895A48, "unawarebehavior" },
    { 0x0EB2EE25, "unawarelightfx1" },
    { 0x0B47C91A, "unbearable_respin" },
    { 0xB98F764B, "unbelievable" },
    { 0xA7962E15, "unbind" },
    { 0xB30EB123, "unblock" },
    { 0xB805E558, "unblockarea" },
    { 0x0685471F, "unblockentsinarea" },
    { 0x36000CB8, "unbound" },
    { 0x9B6776CF, "unbroken" },
    { 0xA58A6A53, "unbroken_section" },
    { 0x7BBEAB40, "unbuild" },
    { 0x9F67AFC5, "unbuild_buildable" },
    { 0x1CD4C3C6, "unbuild_overheated_jetgun" },
    { 0x23E56964, "unbuild_respawn_fn" },
    { 0x9708B0E4, "unbuild_time_delay" },
    { 0xDBE651D0, "unbuilt" },
    { 0xF8F0E590, "uncage_player" },
    { 0x5C23BA58, "uncap" },
    { 0xD870E77B, "uncertainty" },
    { 0x3534797D, "uncertaintyradiusmax" },
    { 0x701E1B93, "uncertaintyradiusmin" },
    { 0x64482964, "uncesessary" },
    { 0x26D074B0, "unchangeable" },
    { 0x4844EA1C, "unchanged" },
    { 0x7DA65B68, "uncheck" },
    { 0x14D55782, "unclaim_attacking_point" },
    { 0xD3FA882A, "unclaim_position" },
    { 0x29CB16B7, "unclaimed" },
    { 0x8278CA5A, "uncle" },
    { 0xC22232D8, "uncloak" },
    { 0x24296790, "uncluttered" },
    { 0x81B64258, "uncomfortably" },
    { 0x52D817DF, "uncomment" },
    { 0xF41B02E4, "uncommented" },
    { 0xA5B709E1, "uncommenting" },
    { 0xEB99DE1E, "unconscious" },
    { 0xE9D06139, "uncontrollably" },
    { 0x1A19CD90, "uncorrection" },
    { 0x390C5A45, "uncorrects" },
    { 0xCE8F8E1E, "uncovered" },
    { 0x7A38CF06, "uncraft" },
    { 0x4061802D, "uncraft_craftable" },
    { 0x75007889, "uncrafted" },
    { 0x60009B5D, "undamaged" },
    { 0xFA70D96A, "undead" },
    { 0x5A4E33C2, "undead_ai_cleanup" },
    { 0x60B30E55, "undef" },
    { 0xD02CC881, "undefine" },
    { 0x10777417, "undefined" },
    { 0xF9E7E6FB, "undefined_delay" },
    { 0x376D918C, "undeletable" },
    { 0xF8908117, "undeleted" },
    { 0x28D0CB41, "under" },
    { 0x685C2C2B, "under_bridge" },
    { 0x43187866, "under_sam_trig_time" },
    { 0xA5E80E64, "under_snipers" },
    { 0x5DBEA6EC, "under_the_world" },
    { 0x93F032A6, "undercover" },
    { 0x37546618, "undercover_challenge" },
    { 0x478CB25B, "underestimate" },
    { 0xD6749645, "underestimated" },
    { 0xF2CED418, "undergone" },
    { 0x49D002EC, "underground" },
    { 0x61F7072E, "underground_bigroom_1" },
    { 0x3BF48CC5, "underground_bigroom_2" },
    { 0xFE620141, "underground_bm21_target" },
    { 0x1FA8FA31, "underground_exit_spawners" },
    { 0x763148C3, "underground_fire_fx_vision" },
    { 0x9F9CB316, "underground_fog_bank" },
    { 0x4A7CA3E3, "underground_fog_off" },
    { 0x8AC0AF87, "underground_harper_pathing" },
    { 0x2BEFD577, "underground_lighting" },
    { 0x648EB44C, "underground_main" },
    { 0x8C4788F7, "underground_mixer_light" },
    { 0x49A63364, "underground_spawners_1" },
    { 0xBBADA29F, "underground_spawners_2" },
    { 0x4DDC41C3, "underline" },
    { 0xBF1E717C, "underlying" },
    { 0x7614C4CB, "underneath" },
    { 0xDECB536C, "underneathe" },
    { 0x15340ED1, "underr" },
    { 0xDC30BE35, "underscore" },
    { 0xFF74C9A5, "underscorechance" },
    { 0x447A3F04, "underscores" },
    { 0x9397C49F, "understand" },
    { 0xCFECECA1, "understanding" },
    { 0x9794C22E, "understood" },
    { 0xBCDC229E, "underwater" },
    { 0x8CC164E0, "underwater_ambient_package_setup" },
    { 0xC666AD50, "underwater_begin" },
    { 0xA83B90E4, "underwater_blockers" },
    { 0x99E0CF50, "underwater_blood1" },
    { 0x0BE83E8B, "underwater_blood2" },
    { 0x76D830B6, "underwater_bubbles" },
    { 0x777ACB2E, "underwater_death_fx" },
    { 0x284B3E2A, "underwater_detection" },
    { 0x833007F4, "underwater_end" },
    { 0x46F3D658, "underwater_explo_sounds" },
    { 0x37514014, "underwater_loop1" },
    { 0xA958AF4F, "underwater_loop2" },
    { 0x5E6B805D, "underwater_notes1" },
    { 0x846DFAC6, "underwater_notes2" },
    { 0x3884D6D4, "underwater_off" },
    { 0x9CC264DE, "underwater_on" },
    { 0x30F0E51C, "underwater_physics_activate" },
    { 0x7E9E2B03, "underwater_scream1" },
    { 0x0C96BBC8, "underwater_scream2" },
    { 0x64B31055, "underwater_snapshot" },
    { 0xF4892467, "underwater_snapshot_off" },
    { 0x088BFDD3, "underwater_snapshot_on" },
    { 0xB28C3E38, "underwater_snapshot_override" },
    { 0x2A9BFE2C, "underwater_vision_set" },
    { 0xCBFE2605, "underwaterbase" },
    { 0xE51487F9, "underwaterbase_airsupport" },
    { 0xC81D2FB0, "underwaterbase_amb" },
    { 0x14560EA7, "underwaterbase_anim" },
    { 0x77C25067, "underwaterbase_art" },
    { 0x597D559E, "underwaterbase_bigflood" },
    { 0x0C028A45, "underwaterbase_bigigc" },
    { 0x0AA52362, "underwaterbase_broadcastcenter" },
    { 0x5E7474A9, "underwaterbase_deactivatecode" },
    { 0x7B49A9EE, "underwaterbase_divetobase" },
    { 0xF87C1F31, "underwaterbase_drones" },
    { 0x05929809, "underwaterbase_enterbase" },
    { 0xE5D27391, "underwaterbase_escape" },
    { 0x34D72722, "underwaterbase_fx" },
    { 0x839F863F, "underwaterbase_huey" },
    { 0x96048D81, "underwaterbase_introigc" },
    { 0x4BDF41ED, "underwaterbase_rendezvous" },
    { 0xF38C0F09, "underwaterbase_snipe" },
    { 0x0C45484A, "underwaterbase_thesurface" },
    { 0x47CB413D, "underwaterbase_upshaft" },
    { 0x5CD4CBEC, "underwaterbase_util" },
    { 0x44CF3DA0, "underwaterbase_vehicle_damage" },
    { 0x9E208C0D, "underwaterbegin" },
    { 0xBAECEDF5, "underwaterend" },
    { 0xC33415BC, "underwaterfx" },
    { 0x27CEE74D, "underwaterfxdelete" },
    { 0x0158ED95, "underwaternotify" },
    { 0x03836B0E, "underwaterwatchbegin" },
    { 0x832F9942, "underwaterwatchend" },
    { 0x01B20DB6, "underway" },
    { 0xDC94B463, "underworld" },
    { 0x0E7A7496, "undesired" },
    { 0x84029ECC, "undetonated" },
    { 0x3948D560, "undeveloped" },
    { 0xEAF5F6FB, "undo" },
    { 0x2E14716B, "undo_add" },
    { 0x9CFEB157, "undo_delete" },
    { 0x66E3D8DA, "undo_edit" },
    { 0xC7E2AAD8, "undo_link_changes" },
    { 0x6AF6D4D8, "undo_shooter_mode" },
    { 0xE237D944, "undo_shooter_model" },
    { 0x1DAABDE5, "undoing" },
    { 0x2FE6D6E1, "undolaststand" },
    { 0xB47E3150, "undone" },
    { 0x6120B99A, "undos" },
    { 0x0E2BAB0D, "unemp_players" },
    { 0xCCC0CD88, "unequal" },
    { 0x2C546980, "unequip_machete" },
    { 0x6C02CB92, "unequip_savimbi_machete" },
    { 0x95C33BDB, "unequip_savimbi_machete_battle" },
    { 0x7E03E584, "uneven" },
    { 0x5229FC00, "unexpected" },
    { 0x68C8E6BA, "unexpected_anim_pose_value" },
    { 0x66C0900A, "unfinished" },
    { 0x450A8D13, "unflash_flag" },
    { 0x5BB5C5A1, "unflip" },
    { 0xFAE64F02, "unforced_machete_head_gib_chance" },
    { 0xBBE875FC, "unforced_sword_head_gib_chance" },
    { 0x3101C942, "unforcetarget" },
    { 0xF8A466E6, "unfortunate" },
    { 0x0C9E0966, "unfortunate_schlub" },
    { 0x716634CB, "unfortunately" },
    { 0x2FC79DE1, "unfreeze" },
    { 0x23332117, "unfreeze_everyone" },
    { 0x5168124B, "unfreeze_helping" },
    { 0x33E9EAB4, "unfreeze_player_controls_after_blackscreen_over" },
    { 0xEC016FA2, "unfreeze_players" },
    { 0x7AFD5694, "unfreezing" },
    { 0x8D74D22D, "unfriendly" },
    { 0x416D035E, "unfrozen" },
    { 0x2815B22A, "unfrz" },
    { 0xAAC2B247, "unfurling" },
    { 0xFFCA7A4E, "unfutzed" },
    { 0x360269C6, "ungrouped" },
    { 0xD802DADC, "unguided" },
    { 0x557C5DFB, "unhack" },
    { 0xA3CB1732, "unhackable_powerup" },
    { 0x51B48AB2, "unhandle" },
    { 0x639BD59D, "unhandleplayer" },
    { 0x8B2C1800, "unhide" },
    { 0x52FDE5B6, "unhide_boxes_for_minigame" },
    { 0x5CC715E5, "unhide_compass" },
    { 0x38B44DD6, "unhide_debris" },
    { 0x47D1D32A, "unhide_magic_box" },
    { 0xF18B3E80, "unhide_player_carry" },
    { 0xD8825EAF, "unhide_quickrevive" },
    { 0xC6C3271C, "unhide_riders" },
    { 0xCF064A25, "unhide_sloth_barrier" },
    { 0x4912BF6F, "unhide_vtols" },
    { 0x28AAC069, "unhidestaticmodel" },
    { 0x54867F6F, "unidentified" },
    { 0xE9B094F1, "unified" },
    { 0xD0602B51, "unified_spawn_points" },
    { 0x065810D4, "unifiedsideswitching" },
    { 0x7562D53B, "uniform" },
    { 0xD69B3B26, "uniformly" },
    { 0x8BBFCCDA, "uniforms" },
    { 0x093E69A2, "unifying" },
    { 0xD173DC6A, "unimportant" },
    { 0x5E62ECE2, "unintentionally" },
    { 0x5D4B8E75, "uninterruptedobitfeedkills" },
    { 0xE7849252, "union" },
    { 0xB19712E4, "unique" },
    { 0xFE7F7567, "unique_guys" },
    { 0x950A2AC4, "unique_id" },
    { 0x2DB63E31, "unique_patrol_walk_anim" },
    { 0x6B0BD93A, "uniqueattachmentsweapon" },
    { 0xD8FBEB93, "uniqueid" },
    { 0xEEABE0C2, "uniqueids" },
    { 0xA3DFFEC5, "uniquename" },
    { 0xD1873F3F, "uniquenotify" },
    { 0xF45DEF97, "unit" },
    { 0x8438B2F1, "unit_axis" },
    { 0xD0CD8C42, "unit_conversion" },
    { 0xD39C111D, "unit_dispersed" },
    { 0x9749D0EF, "unit_facing_vec" },
    { 0x445DC1BE, "unit_highlight_on" },
    { 0x000D21EE, "unit_index" },
    { 0x97E4B93F, "unit_keep_distancefromconvoy" },
    { 0x6640D025, "unit_plant_ieds" },
    { 0x194893AE, "unit_think" },
    { 0x6CB02C7F, "unit_type_ally" },
    { 0x9A1BD352, "unit_type_axis" },
    { 0x4186954B, "unit_type_poi" },
    { 0xDFEFC8EC, "unita" },
    { 0x68645ACC, "unita_say" },
    { 0x03B34B74, "unitcenter" },
    { 0x5A326FFB, "unitdefend" },
    { 0x4364CAB0, "unitdelay" },
    { 0x7ED30B02, "unitdisperse" },
    { 0xF4C70004, "unitdispersetolocation" },
    { 0x47E5DF48, "unite" },
    { 0x83C011C8, "unitenemytoself" },
    { 0xB7BF15DA, "unitforwardvec2d" },
    { 0xD5DE700D, "unith" },
    { 0x22EA7A68, "unitid" },
    { 0x0513D52A, "unitname" },
    { 0xBF4D03AB, "unitreticletracker" },
    { 0x1F850CEF, "unitrigger" },
    { 0x49DF1607, "unitrigger_force_per_player_triggers" },
    { 0xE68446C9, "unitrigger_killed" },
    { 0x77C4E424, "unitrigger_logic" },
    { 0x208A8491, "unitrigger_max_radius" },
    { 0xE0C8ED6B, "unitrigger_offset" },
    { 0x13A434B8, "unitrigger_origin" },
    { 0xFCC6AAB1, "unitrigger_prompt_and_visibility" },
    { 0xA4B2C61E, "unitrigger_set_hint_string" },
    { 0x1361EB56, "unitrigger_stub" },
    { 0x5A0DEF14, "unitrigger_stub_show_hint_prompt_valid" },
    { 0x93E93EC9, "unitrigger_stubs" },
    { 0x509DBCAD, "unitrigger_system" },
    { 0xC54CD556, "unitrigger_think" },
    { 0xCA758BF2, "unitrigger_trigger" },
    { 0x139D7D36, "unitriggers" },
    { 0x8C1C644E, "units" },
    { 0x4AFE91F7, "units_delivered" },
    { 0xF8D9D0D1, "units_per_second" },
    { 0x5A205A39, "units_to_miles" },
    { 0x0078A54B, "unitsavailable" },
    { 0x78439C43, "unitsfromcentrepoint" },
    { 0xC6AE0802, "unitsprune" },
    { 0xC3BBE723, "unitstext" },
    { 0xDE04DEC9, "unitthink" },
    { 0x7BEF6F5C, "unittofaceevec2d" },
    { 0x1A14F513, "unitv" },
    { 0xB54D6AF8, "universal" },
    { 0xC51460E6, "universal_input_loop" },
    { 0xAD7E0919, "unknow" },
    { 0x72D06795, "unknown" },
    { 0x413346E4, "unknowns" },
    { 0x034C494E, "unlatch" },
    { 0x875B9D2F, "unleash" },
    { 0xF2653639, "unlees" },
    { 0xA33A51AB, "unless" },
    { 0x3E889479, "unlike" },
    { 0xFA86B224, "unlikely" },
    { 0xF3613F5D, "unlimit_boat_speed_for_rail" },
    { 0x842697A6, "unlimited" },
    { 0xB5165C92, "unlimited_rocket_ammo" },
    { 0xBA022415, "unlimited_rpgs" },
    { 0xEB0C7CAC, "unlimitedammo" },
    { 0x52FDDBD0, "unlink" },
    { 0xA364ABAE, "unlink_box" },
    { 0x555BAB0F, "unlink_boxcar_guys" },
    { 0xA2507B67, "unlink_from_barge_if_animating_on_death" },
    { 0x27ADBE08, "unlink_from_barge_on_death" },
    { 0xD2492F19, "unlink_from_ent" },
    { 0xE6C62C76, "unlink_grenades" },
    { 0x7540FD93, "unlink_later" },
    { 0xE8612F0F, "unlink_meat_traversal_nodes" },
    { 0x596687A6, "unlink_nodes" },
    { 0x084B3C45, "unlink_nodes_for_blocker_location" },
    { 0x62FC6C5A, "unlink_nodes_wrapper" },
    { 0xF9BBCAE6, "unlink_on_finish" },
    { 0x40CA640C, "unlink_platform_nodes" },
    { 0x84A76BE8, "unlink_player" },
    { 0x9C4F4ECC, "unlink_players_from_camera" },
    { 0x0D7E3879, "unlink_players_from_train" },
    { 0x7A2238B3, "unlink_pos" },
    { 0xCE2C7DC2, "unlink_selected_object" },
    { 0xA1CE8442, "unlink_when_close" },
    { 0xAE323621, "unlinkcamerafromrocket" },
    { 0xE9628A63, "unlinked" },
    { 0xEF7CE6FD, "unlinkfromcamera" },
    { 0xB1F16268, "unlinkfrommissile" },
    { 0x2C303D11, "unlinkguidedmissilecamera" },
    { 0xCDAA89C8, "unlinking" },
    { 0xDADB71FD, "unlinkkillcam" },
    { 0x32E3F5BC, "unlinkkillcams" },
    { 0xA9A0FDE7, "unlinknodes" },
    { 0xCB4F77E1, "unlinkonrotation" },
    { 0x4692E9BB, "unlinks" },
    { 0x9AB58E36, "unlinktraversal" },
    { 0x62F70FB4, "unlinkwhenclose" },
    { 0x012642BD, "unlinkwhenparentdies" },
    { 0xD18C21BD, "unlit_model" },
    { 0xF71CC0CC, "unlit_torch" },
    { 0xE8860E34, "unload" },
    { 0x082BCD5B, "unload_" },
    { 0x6327E0E9, "unload_ai" },
    { 0x72982E73, "unload_and_make_drones" },
    { 0x4BE08E5A, "unload_and_run_to_clash" },
    { 0xC31292C4, "unload_anim_sequence" },
    { 0xDAB679B3, "unload_boxcars" },
    { 0xE97E41E3, "unload_buffel" },
    { 0x4A2F51E0, "unload_bunker_gump" },
    { 0x7C24DBE8, "unload_convoy_vehicle" },
    { 0x5C1D7B9F, "unload_done" },
    { 0xA40B12DB, "unload_gaz66" },
    { 0xEBEBA2B0, "unload_group" },
    { 0xDF3B0523, "unload_group_after_spawn" },
    { 0x66BECB1B, "unload_groups" },
    { 0x2006F5C1, "unload_groups_land" },
    { 0xB78E29B9, "unload_gunner_groups" },
    { 0x9CB15BD4, "unload_helicopter" },
    { 0xC31D229B, "unload_jeep_1" },
    { 0x5115B360, "unload_jeep_2" },
    { 0x5301F7F8, "unload_jeep_players" },
    { 0x33B95917, "unload_late" },
    { 0x814CFC73, "unload_node" },
    { 0x25A98F2D, "unload_node_helicopter" },
    { 0xFA1966AA, "unload_node_render" },
    { 0x1DAC6992, "unload_ondeath" },
    { 0x101A1B91, "unload_rest" },
    { 0x22A57393, "unload_single_guy" },
    { 0x02A9A68C, "unload_snowcat_spots" },
    { 0xED5D7E92, "unload_spots" },
    { 0xC979BA2E, "unload_struct_adjustment" },
    { 0x775D8847, "unload_tank" },
    { 0x31F79E81, "unload_tank_riders" },
    { 0x1790C163, "unload_train_drones" },
    { 0xC1CD608D, "unload_trigger" },
    { 0x01B1446C, "unload_truck" },
    { 0x9AABE1D7, "unloaded" },
    { 0x923F83C2, "unloaded_" },
    { 0x4E03DF03, "unloadedguys" },
    { 0x56755CD1, "unloader" },
    { 0xC507A1DD, "unloadgroup" },
    { 0x35D4B91C, "unloadgroups" },
    { 0x13A91364, "unloadgroupsthread" },
    { 0x00565AF4, "unloading" },
    { 0x9EB40EC9, "unloading_cargo" },
    { 0x338AD959, "unloadmanager" },
    { 0x24619BA8, "unloadnode" },
    { 0x0195197B, "unloadque" },
    { 0x0FFA3D27, "unloads" },
    { 0x5F68DF75, "unloadtimeout" },
    { 0x5461D07B, "unloadtransport" },
    { 0x5D5ED4A7, "unloadwait" },
    { 0x78A5EF22, "unloc" },
    { 0x5A36B2C5, "unlock" },
    { 0x02AC2FF1, "unlock_all" },
    { 0xD88381F5, "unlock_all_perk_machines" },
    { 0x1778F677, "unlock_cost" },
    { 0x1362E607, "unlock_obj" },
    { 0xF1CB7647, "unlock_player" },
    { 0x6F381E3E, "unlock_players" },
    { 0x0DF8279E, "unlock_tokens" },
    { 0x3CEED68A, "unlock_weapon_model" },
    { 0xD3A73B39, "unlockable" },
    { 0x1EA41F3A, "unlockablemusic" },
    { 0x86AE3816, "unlockattachment" },
    { 0xAF2D7FA5, "unlockattachmentsingular" },
    { 0xD60B44A9, "unlockcamo" },
    { 0xF251D572, "unlockcamosingular" },
    { 0x53F05BB8, "unlockchallenge" },
    { 0x04CDD251, "unlockchallengegroup" },
    { 0xA541109F, "unlockchallengesingular" },
    { 0x46B748B2, "unlocked" },
    { 0x33BFDB2C, "unlocked_after_which_level" },
    { 0xFA3EC738, "unlocked_perk_upgrade" },
    { 0x5C8FC03D, "unlocked_trigger_hit" },
    { 0x4C32AE99, "unlockedattachment" },
    { 0xB0975FEA, "unlockedcamo" },
    { 0xB8C9E99D, "unlockedchallenge" },
    { 0x4CDB41C8, "unlockedfeature" },
    { 0x80DF724E, "unlockedperk" },
    { 0xF6294142, "unlockedweapon" },
    { 0x4BD82081, "unlockfeature" },
    { 0xDE46AF3A, "unlockfeaturesingular" },
    { 0x9908D262, "unlockfrontendmusic" },
    { 0x3574BEA3, "unlocking" },
    { 0x742938E0, "unlockitem" },
    { 0x6917416B, "unlockitemfromchallenge" },
    { 0x57455D0C, "unlockname" },
    { 0x9D668A64, "unlockpage" },
    { 0xD04D51B5, "unlockperk" },
    { 0xE05EF4FE, "unlockperksingular" },
    { 0xF6EC5654, "unlocks" },
    { 0x7060862B, "unlocksongbyalias" },
    { 0x11307F29, "unlocksquad" },
    { 0xEC21776E, "unlocktimeout" },
    { 0x1276D357, "unlocktokensadded" },
    { 0x5F738B65, "unlockweapon" },
    { 0xF663628E, "unlockweaponsingular" },
    { 0x1237E2A7, "unlodagroup" },
    { 0xB949EA5E, "unmake" },
    { 0xC49CE021, "unmake_hero" },
    { 0xA7C61A44, "unmake_hero_on_death" },
    { 0x6230D67D, "unmake_prisoner" },
    { 0x99E9888D, "unmanned" },
    { 0xA1ACA4B3, "unmark" },
    { 0x0ECB2F41, "unmark_target" },
    { 0xB1F38777, "unmount" },
    { 0xBC65927F, "unnamed" },
    { 0xF7EDD962, "unncessary" },
    { 0x4D01344F, "unneccessarily" },
    { 0x92D69238, "unnecessarily" },
    { 0x859BC065, "unnecessary" },
    { 0x859EB3CF, "unneeded" },
    { 0x12B4027E, "unneededmodel" },
    { 0xED3593E9, "unneededtrigger" },
    { 0x082A3F85, "unnessesary" },
    { 0x023A3BCC, "unnoticeable" },
    { 0xCCC83624, "unoccupied" },
    { 0x32C68663, "unowned" },
    { 0xAE706589, "unpacifisting" },
    { 0xD2FF56E3, "unpack" },
    { 0xE721DDD8, "unpacked" },
    { 0xE3A683D6, "unpause" },
    { 0xB2E806AA, "unpause_anim" },
    { 0xBC1FFDB1, "unpause_dialog_queue" },
    { 0x38BCE120, "unpause_jfk_anim" },
    { 0x608E3E73, "unpause_turret" },
    { 0x58BF7A62, "unplayable" },
    { 0x0C3750D7, "unpredictable" },
    { 0xF476D6A2, "unpressed" },
    { 0x22D6396C, "unprocessed" },
    { 0x635729DC, "unpunished" },
    { 0xCFE41854, "unqiue" },
    { 0x6284B37A, "unquenchable" },
    { 0xF0831E55, "unreachable" },
    { 0x7350627F, "unreachable_apartment_cleared" },
    { 0x1582632E, "unreachable_enemies_under_attack" },
    { 0xABB29EE4, "unreadable" },
    { 0x26F7CD48, "unrealistic" },
    { 0x699CC88B, "unregister" },
    { 0xD1F67A21, "unregister_candy_context" },
    { 0x1567335C, "unregister_unitrigger" },
    { 0x5D1F281C, "unregister_unitrigger_internal" },
    { 0x07BCDA4E, "unregister_unitrigger_on_kill_think" },
    { 0x9CAD4BA1, "unrelated" },
    { 0x6148CE22, "unreliable" },
    { 0x9BE03088, "unresolved" },
    { 0x1750AD6A, "unrest" },
    { 0x8E2BA06B, "unrestricted" },
    { 0x3BF7301E, "unrestricted_scramble_num" },
    { 0x23A805C9, "unril" },
    { 0x3AD897E6, "unruly" },
    { 0x2D89B82C, "unsafe_players" },
    { 0xF9C8D816, "unscaled" },
    { 0xEE5CF8C5, "unscaled_dist" },
    { 0x42FCAD65, "unseen" },
    { 0x82E120BE, "unseenmannequins" },
    { 0x877FE760, "unselectable" },
    { 0x630EFB0F, "unselected_color" },
    { 0xCFBD83B0, "unset" },
    { 0xC8ADC965, "unset_forcegoal" },
    { 0xF4196A5A, "unsetcollectible" },
    { 0x770ABC7E, "unsetfriendlyspawn" },
    { 0x7067E3A9, "unsetlightarmor" },
    { 0xE52E855C, "unsetperk" },
    { 0x9A2EC265, "unsetready" },
    { 0x065167A7, "unshared" },
    { 0xAF75DAD8, "unsigned" },
    { 0x2F1DFDF1, "unsolved_tiles" },
    { 0xD57BF957, "unsorted" },
    { 0x7A087A10, "unsorted_structs" },
    { 0x0C1D8D2E, "unspecified" },
    { 0xA1D82879, "unstable" },
    { 0xEC6D11F8, "unstick_player" },
    { 0x29DE1608, "unstop" },
    { 0xBFADD090, "unstoppable" },
    { 0xBCCDA2F4, "unstoppable_force" },
    { 0x2E9A29F4, "unstoppableforce_activation_delay" },
    { 0x4608B6FE, "unstoppableforce_blur_amount" },
    { 0xA918E87B, "unstoppableforce_blur_inner_radius" },
    { 0x72E6011C, "unstoppableforce_blur_outer_radius" },
    { 0x9374F384, "unstoppableforce_blur_velocity_scale" },
    { 0x40DD21DF, "unstoppableforce_blur_velocity_shouldscale" },
    { 0x9F16BEAF, "unstoppableforce_show_boost_speed_tolerance" },
    { 0xFBF55B12, "unstraight" },
    { 0x0CCEE82D, "unstraightanim" },
    { 0xED54A604, "unstuck" },
    { 0xB85EAC46, "unstuff" },
    { 0xF9660502, "unsuccessful" },
    { 0xF5F318EA, "unsuccessfull" },
    { 0x4F8ACE63, "unsucessful" },
    { 0xC53F5CB2, "unsupported" },
    { 0xA3FBE02A, "unsuppoted" },
    { 0x1A1DB36F, "unsure" },
    { 0x7390AD19, "unsurrounded" },
    { 0x02DC8EE1, "unsync" },
    { 0x7614127E, "unsynchappened" },
    { 0xCE16EDE0, "untargeted" },
    { 0xAB9219EF, "untested" },
    { 0xA4C7863D, "unti" },
    { 0x9A0CADBB, "until" },
    { 0x653AE0DD, "untill" },
    { 0x58C2916B, "unto" },
    { 0x145E4992, "untouched" },
    { 0xC4FE15F9, "untrained" },
    { 0xEE0BFC57, "untriggered" },
    { 0xC7A5874A, "unturned" },
    { 0xB80E98C4, "unusable" },
    { 0xE5CD5DCD, "unuseable" },
    { 0x7640B65F, "unused" },
    { 0xA7560B3D, "unused0" },
    { 0x815390D4, "unused1" },
    { 0xF35B000F, "unused2" },
    { 0xCD5885A6, "unused3" },
    { 0x586D445D, "unused_param" },
    { 0xA8218D9D, "unusedlocations" },
    { 0x95EB1C8A, "unusual" },
    { 0xBF28A9E5, "unwanted" },
    { 0xCE4A62B0, "unwield_fn" },
    { 0xAEBACD0F, "unwield_gravityspikes" },
    { 0x70C3B564, "unwilling" },
    { 0xB5F6560E, "up" },
    { 0xB7230742, "up_angle" },
    { 0xC70C648D, "up_angles" },
    { 0xBBB435B2, "up_anim" },
    { 0xCEFB7773, "up_arc" },
    { 0x8DE79897, "up_bb_stairs_now" },
    { 0x98A14F19, "up_bright" },
    { 0xB2A0A3E0, "up_deflection" },
    { 0x8B5AF710, "up_difference" },
    { 0xB4A51F9A, "up_dir" },
    { 0x07396A28, "up_direction" },
    { 0x390542E8, "up_distance" },
    { 0x03D1C8AC, "up_down_arc" },
    { 0x220433C4, "up_end" },
    { 0x5D6FEF05, "up_ladder" },
    { 0x5056BC31, "up_mid" },
    { 0x2A1A1B4C, "up_offset" },
    { 0x0C6D8A6A, "up_offset_modified" },
    { 0xCE38F703, "up_origin" },
    { 0x4DB49EF5, "up_pressed" },
    { 0xA1B22FC9, "up_score" },
    { 0xF2C32922, "up_size" },
    { 0x90E2FD4F, "up_stairs" },
    { 0x9C7ED3A7, "up_the_hill_dialog" },
    { 0xF892A345, "up_the_ladder" },
    { 0x3BA185B9, "up_the_street1" },
    { 0xBF754F4E, "up_the_vertical_shaft" },
    { 0xCC3D1691, "up_vec" },
    { 0x0F9EFF8A, "up_vec1" },
    { 0x2B018A34, "up_vector" },
    { 0x6DF4950E, "upaimlimit" },
    { 0x123198C2, "upamount" },
    { 0xE7B10F3B, "upangle" },
    { 0x7CE51ADA, "upangles" },
    { 0xDECEC739, "upanim" },
    { 0xEB2BD1FA, "uparc" },
    { 0xC447332A, "upated" },
    { 0x0A2961D4, "upbydistance" },
    { 0x3A388F84, "upbyheight" },
    { 0xDEBCCD1A, "update" },
    { 0xEE9AF09F, "update_aat_hud" },
    { 0x4BF284CA, "update_activate" },
    { 0xEC6BBBD0, "update_actor_damage" },
    { 0x3E31D523, "update_actor_threat" },
    { 0x44B7A2FC, "update_aigroup" },
    { 0xC608A3FD, "update_all_hudoutlines" },
    { 0xB52D4E18, "update_all_nodes" },
    { 0xF940ADC3, "update_ammo" },
    { 0x9F4E3555, "update_amount" },
    { 0x470E5151, "update_animation" },
    { 0x35F5FE71, "update_apartment_objective_position" },
    { 0xB7B326DB, "update_arena_challenge_seasons" },
    { 0xF161174E, "update_attack_hind_on_death" },
    { 0x88AD84A5, "update_balance_dvar" },
    { 0xF8164C8F, "update_base_fx" },
    { 0x3DB7981E, "update_based_on_flags" },
    { 0xA86F81B1, "update_berserk" },
    { 0x7B06F432, "update_billboard" },
    { 0x3CC786DF, "update_bleedout_timer" },
    { 0x3EFAE25B, "update_boat_wake_tag_position" },
    { 0x11E941ED, "update_box_prompt" },
    { 0x26BF1983, "update_breadcrumb_trail" },
    { 0x9C42A89C, "update_briggs_pos" },
    { 0x63D72964, "update_c4" },
    { 0xE98C65DE, "update_cam" },
    { 0x14E97314, "update_cap_fx" },
    { 0xE9075FCC, "update_captured_zone_count" },
    { 0x10E30AFD, "update_carry_object_objective_origin" },
    { 0x27369EDD, "update_carry_object_origin" },
    { 0xF75B40E2, "update_cb" },
    { 0x0873D37C, "update_character_animation_and_attachments" },
    { 0xE6F3AC24, "update_character_animation_based_on_showcase_weapon" },
    { 0x2142A641, "update_character_animation_tree_for_scene" },
    { 0xE23DDA16, "update_character_extracam" },
    { 0x7AF90665, "update_charger_position" },
    { 0xD2B737C2, "update_claw_pip" },
    { 0xF4F4212C, "update_client" },
    { 0x847AEC89, "update_client_ammo" },
    { 0x2D1DB7FE, "update_client_for_driver_and_occupants" },
    { 0xF40E2444, "update_client_for_player" },
    { 0x4689E203, "update_clientfields" },
    { 0x72E6C1D6, "update_closest_player" },
    { 0x0700C62D, "update_compass_icon" },
    { 0x2158302C, "update_compass_icons" },
    { 0x752EBC2E, "update_context" },
    { 0xF9E2E67A, "update_crash" },
    { 0x80B667B6, "update_crate" },
    { 0xDC7B6DB0, "update_crate_velocity" },
    { 0x1DD90F2B, "update_crouch" },
    { 0x142BF31B, "update_curr_time" },
    { 0x5BF496B6, "update_current_progress" },
    { 0xAA018D08, "update_current_targeters" },
    { 0x8B3F7B55, "update_damage_absorbed" },
    { 0x90B1A5B1, "update_damage_as_occupant" },
    { 0x9989BBB9, "update_damage_effects" },
    { 0x53F8D258, "update_damage_fx_level" },
    { 0xBE563173, "update_damage_states" },
    { 0x01735104, "update_damage_timer" },
    { 0x2D6FCF0C, "update_days" },
    { 0x1ACF6A5C, "update_death_info" },
    { 0x70AAF19B, "update_deathflag" },
    { 0xEAF262E9, "update_debug_friendlycolor" },
    { 0x6044A1AC, "update_debug_friendlycolor_on_death" },
    { 0x37BB6C06, "update_delay" },
    { 0xEBE14198, "update_dial_anims" },
    { 0xAD061403, "update_dialog_timer" },
    { 0x8EA0FFD1, "update_dialogue_timer" },
    { 0x64C88204, "update_distance" },
    { 0xDB26C633, "update_distance_to_closest_emp" },
    { 0x93F88F9C, "update_dog_threat" },
    { 0xF2E1BDAA, "update_doomsday_clock" },
    { 0x2C582173, "update_dr_filters" },
    { 0x697F7DE0, "update_dr_flag" },
    { 0x045E88BD, "update_drink" },
    { 0xC5F7D873, "update_drone_sam_attack_score" },
    { 0xF3E5B3A5, "update_drop_bomb" },
    { 0x2AADF8CF, "update_drop_booster" },
    { 0x119D8673, "update_drop_locations" },
    { 0xE198C2C5, "update_dvars" },
    { 0xE0FB7B15, "update_eat" },
    { 0x72425F2F, "update_ember_fx" },
    { 0x909ADBE5, "update_emped_driver_visuals" },
    { 0x89C55BF4, "update_emped_visuals" },
    { 0x44455ED8, "update_enabled" },
    { 0xA943B306, "update_enemy_remaining" },
    { 0x8EC6A864, "update_enemy_soct_list" },
    { 0xAE29A4E8, "update_enemy_target_pos_while_running" },
    { 0x8D5EE439, "update_exploders" },
    { 0xFABD35BF, "update_f35_hud" },
    { 0xE811BF5E, "update_failsafe" },
    { 0x00806EFD, "update_fall_anims" },
    { 0xE98EC606, "update_fallback_spawnpoints" },
    { 0x36B1AAF0, "update_ffa_top_scorers" },
    { 0x55319592, "update_flameboard" },
    { 0x9FBA4210, "update_flyby_audio" },
    { 0xC8A63472, "update_follow" },
    { 0xEFB3484B, "update_forced_gunner_targets" },
    { 0x55E851CA, "update_fov_on_restart" },
    { 0x44F476F8, "update_fov_to_current" },
    { 0x4F61000F, "update_freq" },
    { 0xF72DF2A1, "update_frequency" },
    { 0x20A503BB, "update_func" },
    { 0xA4EF005A, "update_funcs" },
    { 0xE1880B89, "update_fx_looper" },
    { 0x51B42EE1, "update_gadget" },
    { 0x51E60168, "update_global_counters_on_match_end" },
    { 0x3B540824, "update_goal_yaw" },
    { 0x9605596B, "update_gravityspikes_energy" },
    { 0x85C52E7E, "update_gravityspikes_state" },
    { 0x26EC606C, "update_ground_targ_pos" },
    { 0xF2A0BB80, "update_gun_objectives" },
    { 0x6845F237, "update_gunshop_candy" },
    { 0xFB56F613, "update_gunshop_run" },
    { 0x8C0761C5, "update_headbang" },
    { 0xF854DE5F, "update_health" },
    { 0x7610D31D, "update_health_packets" },
    { 0x007DA36D, "update_helicopter_sounds" },
    { 0x7E1F2196, "update_hint_string" },
    { 0x3F1192F9, "update_hints" },
    { 0xEB503B6D, "update_horse_fx" },
    { 0x47335D78, "update_hud" },
    { 0x83EA29CE, "update_hud_position" },
    { 0xFDD5F66A, "update_hud_pulse" },
    { 0x3D62EA6A, "update_hudoutline" },
    { 0xBCC8B856, "update_ice_chamber_digits" },
    { 0x983A9443, "update_icons_and_objective" },
    { 0x426F7EE1, "update_idle_anim" },
    { 0xF9D24AF4, "update_idle_lookat" },
    { 0x701D848E, "update_interval" },
    { 0xB70B23D8, "update_is_player_valid" },
    { 0xD390E660, "update_jail_close" },
    { 0x683B83A0, "update_jail_cower" },
    { 0x94C9CB32, "update_jail_idle" },
    { 0x31B22934, "update_jail_open" },
    { 0x30BA03DB, "update_jail_run" },
    { 0x5735C947, "update_jail_wait" },
    { 0xA70A3E77, "update_killstreak" },
    { 0x90C44FBC, "update_last_burned_by" },
    { 0x1B6383CC, "update_last_held_weapon_timings" },
    { 0x69A65ED1, "update_launcher" },
    { 0xDC9EEE7A, "update_leader" },
    { 0x3C7E750D, "update_leaderboards" },
    { 0x6A8021AD, "update_left_arm" },
    { 0x856585B7, "update_level_completed" },
    { 0x910D8515, "update_link" },
    { 0xCD85FFAF, "update_lives_remaining" },
    { 0xBD990DCD, "update_locked_shader" },
    { 0xD0E083B6, "update_locomotion" },
    { 0x5B09A4FF, "update_lookat" },
    { 0x120DC4D3, "update_low_gravity_fx" },
    { 0x2F4097FA, "update_lui_ammo_icon" },
    { 0xE6A601CF, "update_lui_rpg_icon" },
    { 0x309D298C, "update_main_guard" },
    { 0x3CD4438C, "update_mansion" },
    { 0x35B03CC9, "update_microwave_fx" },
    { 0x1C56CCE8, "update_minus_score" },
    { 0x1069D667, "update_missile_dog_threat" },
    { 0x97CDD5C8, "update_missile_player_threat" },
    { 0x0876BAB0, "update_model_attachment" },
    { 0x30D929FB, "update_model_rotation_for_right_stick" },
    { 0xBF144225, "update_mortar_objectives" },
    { 0x50C3C4B9, "update_move_anim_type" },
    { 0xE4450FAC, "update_msg" },
    { 0xCB5831BB, "update_multi_score" },
    { 0x07A3087E, "update_multiplier_bar" },
    { 0xDFEE667C, "update_nav_triggers" },
    { 0xA612833A, "update_nav_triggers_for_actor" },
    { 0x9086D16A, "update_next_arena" },
    { 0x6ACC2302, "update_node_arrivals" },
    { 0x84FD84F9, "update_non_player_threat" },
    { 0x88C39264, "update_notification" },
    { 0xF30E9551, "update_obj_on_dropped_jav" },
    { 0xDEFFDF4B, "update_obj_pos" },
    { 0x237C855C, "update_obj_position_with_trigger" },
    { 0x7153B1EA, "update_objective" },
    { 0x65E86400, "update_objective_model" },
    { 0x9D086585, "update_objective_on_death" },
    { 0x7AB22526, "update_objective_on_momentum_change" },
    { 0xD652F333, "update_objective_patrol" },
    { 0x0B64CEAD, "update_objective_position_by_trigger" },
    { 0x19418124, "update_objective_position_for_fairground" },
    { 0xFD17F259, "update_objective_states_rescue" },
    { 0x5EA2AB58, "update_objective_states_zeroes" },
    { 0xA1862F6F, "update_objective_stats_merchantship_ships" },
    { 0xEF8DB1E6, "update_objective_stats_ptboats" },
    { 0x4B358CA5, "update_objectives" },
    { 0xE20BDA5D, "update_on_give_perk" },
    { 0xC0EA1B16, "update_on_poi_removal" },
    { 0xDB14DBBF, "update_on_take_perk" },
    { 0xC23A7917, "update_only" },
    { 0xA264FB59, "update_open_table_status" },
    { 0x88E59487, "update_origin" },
    { 0x86364673, "update_outcome" },
    { 0x2A720981, "update_override" },
    { 0xBE6C84C3, "update_patrol" },
    { 0x6218E460, "update_percent" },
    { 0x3DA729B7, "update_perk_hud" },
    { 0x9BF94DA1, "update_plane_damage_state" },
    { 0x4F6C13E4, "update_played_time" },
    { 0x002DACE2, "update_player_ability_status" },
    { 0xA0509036, "update_player_barge_rolling" },
    { 0x9CB75A73, "update_player_classtype" },
    { 0x82296CD8, "update_player_closest_node_think" },
    { 0x7BEE2532, "update_player_damage" },
    { 0x03F9478F, "update_player_idle" },
    { 0x22C4A2EC, "update_player_model" },
    { 0x84B359A8, "update_player_profile" },
    { 0xF6E81A75, "update_player_threat" },
    { 0x2EDA566D, "update_player_times" },
    { 0x0DE1EACE, "update_player_vel" },
    { 0xA08AE386, "update_players_in_radius" },
    { 0xA0B5D89B, "update_players_on_bleedout_or_disconnect" },
    { 0x36266B17, "update_players_stats_at_match_end" },
    { 0x943971C2, "update_playerscore_hud" },
    { 0x1A0DFD8E, "update_playing_utc_time" },
    { 0xE9B16B6E, "update_plus_score" },
    { 0x48604542, "update_poi_on_death" },
    { 0xDDD636B7, "update_position_on_death" },
    { 0x968FFA3C, "update_prox_bar" },
    { 0x26C49866, "update_quick_revive" },
    { 0xED0B2701, "update_quickrevive_power_state" },
    { 0xD360769B, "update_rank" },
    { 0x35B6343B, "update_rate" },
    { 0x8B439FAE, "update_rearback_anim" },
    { 0xA7ECEDB7, "update_relay_fx_and_sound" },
    { 0xE17ECE2D, "update_relay_rotation" },
    { 0x008EDC43, "update_relays" },
    { 0x1DD61405, "update_reticle_icon" },
    { 0x963DF1D8, "update_retrieve_trigger" },
    { 0x9CAF6ED7, "update_reverse_anim" },
    { 0x3FA616B6, "update_right_arm" },
    { 0xA5CE0850, "update_riotshield" },
    { 0x12C6C132, "update_roam" },
    { 0x3E4964B6, "update_rocket_display" },
    { 0x70E668F7, "update_rocket_hud" },
    { 0x80A6323D, "update_roulette" },
    { 0xDAACF758, "update_roundlimit" },
    { 0x367397C0, "update_roundscorelimit" },
    { 0x259EADB2, "update_rts_fov" },
    { 0xAE78E936, "update_rumble" },
    { 0x25CC45E4, "update_run_anim" },
    { 0xDA136744, "update_save_bar" },
    { 0xC54DBCF9, "update_scene_sequence" },
    { 0x2B145A7D, "update_score" },
    { 0xD9F1C12E, "update_scorelimit" },
    { 0xB518BD99, "update_screen_stats" },
    { 0xD0DC0203, "update_script_forcespawn_based_on_flags" },
    { 0x024B20DE, "update_seaknight_objective_pos" },
    { 0x0BF297DC, "update_selected_entities" },
    { 0xDA390F52, "update_selected_object_position" },
    { 0x920E461A, "update_settings" },
    { 0xEA9FAED5, "update_show_helmets" },
    { 0x03B13EF6, "update_sidequest_stats" },
    { 0x16CDF7B1, "update_skill_from_profile" },
    { 0x02FB240F, "update_skill_level" },
    { 0x4614CAE7, "update_skill_on_change" },
    { 0x75063812, "update_smell" },
    { 0x9B4BB5C2, "update_smoke_position" },
    { 0x144EBD96, "update_sound" },
    { 0xBF35CF13, "update_sound_for_tarmac" },
    { 0x24384D63, "update_spawn_influencers" },
    { 0x67E08492, "update_spawner_target_on_trigger" },
    { 0x7FEF183E, "update_special" },
    { 0xAE07AFFC, "update_splash" },
    { 0x8EAC7002, "update_spotlight_circle" },
    { 0x06358A28, "update_spotlight_only" },
    { 0xE6975E84, "update_spotlight_sc" },
    { 0x6FCAC7C1, "update_squad_position" },
    { 0x84442246, "update_staff_accessories" },
    { 0x6B19623E, "update_state_machine" },
    { 0xE1CFC8CF, "update_states" },
    { 0xD8929653, "update_stop_anim" },
    { 0x43DE9900, "update_stowed_weapon" },
    { 0x5B07B8DC, "update_survival_stat" },
    { 0x00879981, "update_swim" },
    { 0xA415A998, "update_swim_anim_rate" },
    { 0xB3E36274, "update_table_eat" },
    { 0x4F34ED80, "update_target_array" },
    { 0x7664845F, "update_target_flag" },
    { 0x8DDB2A2E, "update_target_player" },
    { 0x24291691, "update_ternary_display" },
    { 0x2F9DA783, "update_thief" },
    { 0x403D3D3E, "update_thief_weapon" },
    { 0xDC9B5851, "update_threat" },
    { 0x22585C05, "update_threat_goal" },
    { 0x2FC9381E, "update_time" },
    { 0xFBBD88DB, "update_timelimit" },
    { 0x93C4286E, "update_timings" },
    { 0x2887D110, "update_top_scorers" },
    { 0x56C07204, "update_toss" },
    { 0x222DFBCC, "update_transition_anim" },
    { 0x9F07E1A7, "update_trigger" },
    { 0x4E293D29, "update_trigger_based_on_flags" },
    { 0x1A372E02, "update_trigger_visibility" },
    { 0xF6CC6E97, "update_trophy_system_state" },
    { 0xB77CE6F3, "update_turn180_anim" },
    { 0xC7F35B50, "update_turn_anim" },
    { 0x366DE7BB, "update_turret_destroyed" },
    { 0xB9741355, "update_turret_target" },
    { 0xCC48E8C9, "update_tutorial_hud" },
    { 0x523636D0, "update_ui_ammo_count" },
    { 0xA5A6066C, "update_ui_fullscreen_filter_model" },
    { 0x6EC3C7CE, "update_ui_model_ammo_count" },
    { 0xB0A8E76D, "update_use_frozen_moments" },
    { 0xE068DCB2, "update_use_message" },
    { 0x43B91137, "update_use_rate" },
    { 0xCB749726, "update_valid_players" },
    { 0x6E32223B, "update_vehicle_damage_timer" },
    { 0x5D7AB140, "update_vfxspot_pos" },
    { 0x318DD491, "update_victim" },
    { 0x6D918C59, "update_view_hands" },
    { 0xC4EB1D69, "update_visibility_according_to_radar" },
    { 0x244E128E, "update_voice_origin" },
    { 0x1563CE31, "update_waitlogic_tracker" },
    { 0x27E690FE, "update_wake_fx" },
    { 0x91D6E95D, "update_water_plane" },
    { 0x119C9BE6, "update_wave4_objective" },
    { 0x9F66EE13, "update_wc_icon_extracam" },
    { 0x490E47D9, "update_weapon" },
    { 0x22DB31D2, "update_weapon_ads" },
    { 0x927AE397, "update_weapon_aim" },
    { 0x77F8B42F, "update_weapon_hud" },
    { 0x08AA759E, "update_weapon_options" },
    { 0xA0A6EBE7, "update_weapon_script_model" },
    { 0x6AB26696, "update_wheels_animation" },
    { 0x85576D4D, "update_world_icon" },
    { 0xA45FE1CC, "update_world_icons" },
    { 0x9288F3C9, "update_xp" },
    { 0x5487E04A, "update_yaw" },
    { 0x7C9957AC, "update_zombie_goal_pos" },
    { 0x597E721E, "update_zombie_gravity_transition" },
    { 0x6CDE11C9, "update_zombie_locomotion" },
    { 0xAB745F3B, "update_zone_name" },
    { 0xE128E674, "updateacousticsensors" },
    { 0x5BABCEA8, "updateactiveambientpackage" },
    { 0x47492A21, "updateactiveambientroom" },
    { 0x5E5C8DFD, "updatealivetimes" },
    { 0x57E94477, "updateall" },
    { 0xF50A84C4, "updateallalivetimes" },
    { 0x3DD23073, "updateallkillstreakinventory" },
    { 0x5D1AE964, "updateallplayershudicons" },
    { 0x7B4B00A9, "updateallplayershudplayercounts" },
    { 0xF2581B3A, "updateallplayershudplayerprogressbars" },
    { 0xCA8DBDCD, "updateallspawnpoints" },
    { 0x16CA2E25, "updateallteamscores" },
    { 0x556B523B, "updateammobarscale" },
    { 0x2F10A3E9, "updateandfinalizematchrecord" },
    { 0xA5FF0D72, "updateanimpose" },
    { 0x67B330F8, "updateareanodes" },
    { 0x66A8B950, "updateattachedweaponmodels" },
    { 0x9CEDB097, "updateattacker" },
    { 0xCFD75F25, "updateattackermultikills" },
    { 0x0AF40242, "updateattackerslist" },
    { 0x9DBECAD3, "updateattackspotservice" },
    { 0xB557E74B, "updateavgusepos" },
    { 0x7089BCE5, "updatebar" },
    { 0x9891EDA5, "updatebarscale" },
    { 0xFD1737E6, "updatebaseicon" },
    { 0x2206B8DE, "updatebaseiconvisibility" },
    { 0x84B335DF, "updatebasenewstatus" },
    { 0x62317C10, "updatebaseposition" },
    { 0xEB1BE9F3, "updatebcdvars" },
    { 0x38535733, "updateblackoutoverlay" },
    { 0x296D9A20, "updatebombtimers" },
    { 0x5DD0AC48, "updatebsm" },
    { 0x4AA5A64B, "updatebullethudthink" },
    { 0xA031F380, "updatebus" },
    { 0x31945BDD, "updatebustires" },
    { 0xB8AB67CE, "updatecameraspikes" },
    { 0x14D9F52E, "updatecapsperminute" },
    { 0x77537B1D, "updatecarryobjectobjectiveorigin" },
    { 0xEACCFC9C, "updatecarryobjectorigin" },
    { 0xB81199B9, "updatecarryqrdroneplacement" },
    { 0x3F1CD124, "updatechallenges" },
    { 0xB96FECAB, "updatechildren" },
    { 0x6BD910CA, "updatechunkservice" },
    { 0xC997D930, "updatecinematicdof" },
    { 0x94C0470A, "updateclassglobals" },
    { 0xBE9378E6, "updateclippos" },
    { 0x98C0A606, "updatecombat" },
    { 0x7D2C360D, "updatecompassicon" },
    { 0x871AB38C, "updatecompassicons" },
    { 0xA3EDC3CA, "updatecontact" },
    { 0x18D5D556, "updatecontractwin" },
    { 0x56A12225, "updatecontractwinevents" },
    { 0x527C7BCC, "updatecorneraim" },
    { 0xED0C5638, "updatecurrentprogress" },
    { 0x9703A040, "updatecustomgamewinner" },
    { 0xE57C436A, "updated" },
    { 0xEAF71AC0, "updated_color_friendlies" },
    { 0xAB1852CC, "updated_text" },
    { 0xBCB19900, "updatedamagefeedback" },
    { 0xEAAB4112, "updateddmscores" },
    { 0xF3ADD525, "updatedeathiconsenabled" },
    { 0x193C6B50, "updatedeathinfo" },
    { 0x915A2075, "updatedeathinfodebug" },
    { 0x662AA726, "updatedebughud" },
    { 0xBAD1B803, "updatedebuginfo" },
    { 0x419EA3BC, "updatedebuginfointernal" },
    { 0xF49597B8, "updatedevsettings" },
    { 0xF755C633, "updatedevsettingszm" },
    { 0x7658849F, "updatedisplayvalue" },
    { 0x3B6EFD62, "updatedmscores" },
    { 0xD1C120BD, "updatedof" },
    { 0xB3F03DA6, "updatedomrecentkills" },
    { 0x8CD6D84B, "updatedomscores" },
    { 0x01F336EA, "updatedownedcounters" },
    { 0xE3BDC778, "updatedrivabletimeforalloccupants" },
    { 0x022CD788, "updatedvars" },
    { 0x44E36B77, "updatedvarsfromprofile" },
    { 0x62040DD4, "updateemp" },
    { 0xC67C5C4A, "updateendofmatchcounters" },
    { 0x5BB47036, "updateenemy" },
    { 0x64CBEFA6, "updateenemyequipment" },
    { 0x81C865E5, "updateenemymissiles" },
    { 0x1757C225, "updateenemyvehicles" },
    { 0xA7801F67, "updateentityheadclienticon" },
    { 0x95D5DBED, "updateentityheadclientobjective" },
    { 0x0057E8EE, "updateentityheadicon" },
    { 0x29295D50, "updateentityheadiconpos" },
    { 0x49AF735D, "updateentityheadteamicon" },
    { 0x881BEACF, "updateentityheadteamobjective" },
    { 0xFDACD5EA, "updateeventsperminute" },
    { 0x55C4DA6A, "updateeventthread" },
    { 0xE4223F31, "updatefacialanimforplayer" },
    { 0x7D658E7A, "updatefakeplayer" },
    { 0xBCE1B981, "updateflagstatushuddvars" },
    { 0xA0378363, "updateflakdronespeed" },
    { 0xA0781312, "updatefog" },
    { 0xA7998E82, "updatefreeplayedtime" },
    { 0xE6B89F13, "updatefreeplayertimes" },
    { 0xA542B274, "updatefriendicons" },
    { 0x32526D8E, "updatefriendiconsettings" },
    { 0xDCFA01F3, "updatefrustrationlevel" },
    { 0xE28E96A8, "updatefunc" },
    { 0x3D0809A6, "updatefuncptr" },
    { 0xF4391D56, "updatefunction" },
    { 0x86ACF4C9, "updatefunctions" },
    { 0x56154A57, "updategameevents" },
    { 0x7605FC7D, "updategamerprofile" },
    { 0x0EB084EC, "updategamestatdisplay" },
    { 0x843E8B8A, "updategametypedvars" },
    { 0x3139B401, "updategiveuponsuppressiontimer" },
    { 0x1AC3684F, "updateglassposition" },
    { 0x00117043, "updateglobalbotkilledcounter" },
    { 0x82345D5E, "updateglobalcounterstats" },
    { 0xCBC9C5B1, "updategriduseglobals" },
    { 0x127C3B74, "updatehardpoints" },
    { 0x42AEBD10, "updateheading" },
    { 0x5B10D40F, "updatehealthvalue" },
    { 0x951920C2, "updatehelicopterspeed" },
    { 0xC1E8424A, "updatehero" },
    { 0x64134457, "updatehighscores" },
    { 0x7430898C, "updatehostmigrationdata" },
    { 0x8FF92BF9, "updatehudicons" },
    { 0x8007B067, "updatehudmomentum" },
    { 0xA6D21B43, "updatehudmomentumforteam" },
    { 0x80FB6B7A, "updatehudplayercounts" },
    { 0x3F5C67EB, "updatehudprogressbar" },
    { 0x313B6A83, "updatehudweaponammo" },
    { 0xBB6C3BE1, "updateigcviewtime" },
    { 0x1E4D3508, "updateinflictor" },
    { 0xE5EE3C44, "updateinfocard" },
    { 0xC3DA14DE, "updateinventory" },
    { 0x77E905CD, "updatekeysforbindings" },
    { 0xE24A5966, "updatekill" },
    { 0xD72297A4, "updatekillstreakinventory" },
    { 0xE6FF9539, "updatekillstreakondeletion" },
    { 0xC0982005, "updatekillstreakondisconnect" },
    { 0x77B5C802, "updatekillstreakonhelicopterdeath" },
    { 0x976A4EDD, "updatelaserstatus" },
    { 0x7E0FA194, "updatelastheldweapontimings" },
    { 0xC04FC017, "updatelastheldweapontimingszm" },
    { 0x816F0632, "updatelinkglobals" },
    { 0x038EDEB8, "updatelosslatejoinstats" },
    { 0x214B6780, "updatelossstats" },
    { 0x4FC70DDE, "updatemagshots" },
    { 0x95D77CBD, "updatemagshots_" },
    { 0x8C594DD8, "updatemainmenu" },
    { 0xE15BCE74, "updatemarkerthread" },
    { 0xEF6804EB, "updatematchbonusscores" },
    { 0x9A9FE0C3, "updatematchsummary" },
    { 0x889DBEAB, "updatemeansofdeath" },
    { 0x8079590E, "updatememberstates" },
    { 0xA6622703, "updatemenu" },
    { 0x1F2CCCC8, "updatemicrowaveaim" },
    { 0x0CF9C230, "updatemillis" },
    { 0xB7E632C1, "updateminimapsetting" },
    { 0x19382EAB, "updateminusscorehud" },
    { 0x60390D97, "updatemissiondvar" },
    { 0x65D7DD11, "updatemodel" },
    { 0xD53184D8, "updatemomentum" },
    { 0x73D88F63, "updatemomentumhud" },
    { 0xFD74CF7F, "updatempchallenges" },
    { 0x3345A3E4, "updatemultikills" },
    { 0xF02730DF, "updatemusic" },
    { 0x65AAA0C0, "updatemutliscorehud" },
    { 0xE35EB412, "updatenavtriggers" },
    { 0xA1593EF3, "updateobjective" },
    { 0x4E1153B9, "updateobjectivehintmessage" },
    { 0x4280C014, "updateobjectivehintmessageonplayers" },
    { 0xCD54EAF0, "updateobjectivehintmessages" },
    { 0x5C7708D6, "updateobjectivetext" },
    { 0x04AD1234, "updateoneshotmultikills" },
    { 0xCEDDCB18, "updateonly" },
    { 0x2070B7D8, "updateorigin" },
    { 0xDA2B338E, "updateoutcome" },
    { 0x45F59535, "updateperiod" },
    { 0x54289651, "updatepersonalthreatbias_attackerlockedontome" },
    { 0xB4B8A386, "updatepersonalthreatbias_attackerlockingontome" },
    { 0x67BD73EE, "updatepersonalthreatbias_bots" },
    { 0x71A8CA1B, "updatepersratio" },
    { 0x8509B2AB, "updateplacement" },
    { 0xE3188155, "updateplacementmodels" },
    { 0x59A405F8, "updateplayedtime" },
    { 0xDBC71F52, "updateplayerdamage" },
    { 0xF62E26BC, "updateplayerhud" },
    { 0x702C6EE2, "updateplayerkilled" },
    { 0x24354FEF, "updateplayernum" },
    { 0xF96B2799, "updateplayerobjpoints" },
    { 0x3FE5AF34, "updateplayers" },
    { 0x3B2F36A8, "updateplayersatellitefordm" },
    { 0xD5224721, "updateplayerscore" },
    { 0xFE6526BB, "updateplayersightaccuracy" },
    { 0x77D3AF38, "updateplayerstate" },
    { 0xA0375BAE, "updateplayersuavstatus" },
    { 0xE21C950D, "updateplayertimes" },
    { 0x955D1463, "updateplusscorehud" },
    { 0x55C25E9B, "updateposition" },
    { 0x69380127, "updatepreferedpoint" },
    { 0x40890E74, "updateprone" },
    { 0x5F977FEC, "updatepronethread" },
    { 0xA2AB0D8D, "updatepronewrapper" },
    { 0xCEB08C88, "updateproxbar" },
    { 0x34964597, "updatepulsefadeamount" },
    { 0x446C8D00, "updatequeuemessage" },
    { 0xD15991AC, "updater" },
    { 0xB77DF5D9, "updater_alias" },
    { 0xF9140408, "updater_time" },
    { 0x41B24838, "updateradiationblackout" },
    { 0x835F5014, "updateradiationdosage" },
    { 0x3BEB8D57, "updateradiationdosimeter" },
    { 0xBF0250C0, "updateradiationdosimetercolor" },
    { 0xCABF4F55, "updateradiationflag" },
    { 0x9FFA0AD4, "updateradiationratepercent" },
    { 0x5EB1E883, "updateradiationshock" },
    { 0xC004735C, "updateradiationsound" },
    { 0x507CE0D0, "updateradiationtriggers" },
    { 0x7758FD48, "updaterank" },
    { 0xD66F5BE0, "updaterankannouncehud" },
    { 0x89A50E78, "updaterankannouncehud_internal" },
    { 0xDAFE7166, "updaterankedmatch" },
    { 0x9C4690F5, "updaterankscorehud" },
    { 0xB1EBD4B4, "updaterate" },
    { 0x936348DB, "updaterate_" },
    { 0xB5AC11DA, "updaterecentkills" },
    { 0x88293F84, "updaterecentzonekills" },
    { 0x338F2CA1, "updateretrievable" },
    { 0xCCAC0732, "updateretrievetrigger" },
    { 0x1D57117E, "updateriotshieldmodel" },
    { 0x1976AA50, "updateriotshieldplacement" },
    { 0x8AD86633, "updaterulesonend" },
    { 0x6C455E4D, "updaterunanimweights" },
    { 0x4DF5ADFD, "updaterunanimweightsthread" },
    { 0xC55CDB60, "updaterunweights" },
    { 0xC78AE4EE, "updaterunweightsbiasforward" },
    { 0xAC11C773, "updaterunweightsonce" },
    { 0xF75C0C15, "updates" },
    { 0xE765EAC4, "updatescore" },
    { 0xCD01D87F, "updatescoreelemsonce" },
    { 0x9BEEF577, "updatescores" },
    { 0x8BF515F0, "updatescriptweaponinfoandpos" },
    { 0x13DC3B34, "updateserverdvar" },
    { 0x809FA8EC, "updateserversettings" },
    { 0x76A62451, "updatesight" },
    { 0x22AB88ED, "updatesinglefragmultikill" },
    { 0x12A47278, "updatesitrepscan" },
    { 0xCFFE043D, "updatespecialdamagefeedback" },
    { 0x9D43F698, "updatespectatesettings" },
    { 0xD76664B3, "updatespeed" },
    { 0x2911A8F9, "updatespeedonlock" },
    { 0x74A11B60, "updatesquadlist" },
    { 0x749A9A99, "updatestandaloneriotshieldmodel" },
    { 0xE9D3819C, "updatestat" },
    { 0xB9561530, "updatestates" },
    { 0x9E74B5AD, "updatestatratio" },
    { 0x84E6E9DF, "updatestats" },
    { 0x0BD8C7E0, "updatestatus" },
    { 0x2988DF5A, "updatestowedweapon" },
    { 0x2A6FF625, "updatetacticalmask" },
    { 0xAC5795CD, "updatetargetting" },
    { 0x1AF294FE, "updatetargetyaw" },
    { 0xD797A84F, "updateteambalance" },
    { 0xB1A785D8, "updateteambalancedvar" },
    { 0x94977BB3, "updateteambalancedvars" },
    { 0x4E46CF8D, "updateteambalancewarning" },
    { 0x23D570DC, "updateteamclientfield" },
    { 0x36DC5BFB, "updateteamequipment" },
    { 0x1D33AC0A, "updateteammissiles" },
    { 0x3D345413, "updateteamops" },
    { 0x7277D032, "updateteamplacement" },
    { 0x2D1872E4, "updateteams" },
    { 0x7EB45E71, "updateteamscorebyflagscaptured" },
    { 0x828C341B, "updateteamscorebyroundswon" },
    { 0x95E3ED98, "updateteamscores" },
    { 0xCD14A993, "updateteamstatus" },
    { 0xA61D27D2, "updateteamtime" },
    { 0xB81E4071, "updateteamuavstatus" },
    { 0x7C5DCE1E, "updateteamvehicles" },
    { 0x359CF118, "updatethread specialiststatabilityusage" },
    { 0x89539239, "updatetiestats" },
    { 0x4809D0B5, "updatetime" },
    { 0xB5371B9B, "updatetimeplayedcapdvar" },
    { 0x91EF6CC2, "updatetimerpausedness" },
    { 0xE05CB81D, "updatetrackedblackboardattribute" },
    { 0xB1F374E6, "updatetrait" },
    { 0x9461D392, "updatetrigger" },
    { 0x1FCB6E9D, "updateturretplacement" },
    { 0x3B545A85, "updatetwarscores" },
    { 0xD65B49DF, "updateuitweakables" },
    { 0x65655A91, "updateuserate" },
    { 0x822568AF, "updateval" },
    { 0x0095AC17, "updatevechicledamagefeedback" },
    { 0xBBD1AA0A, "updatevisibility" },
    { 0x28C5B037, "updatevisibilityaccordingtoradar" },
    { 0x9B146F7C, "updatevisualeffects" },
    { 0x0CD821D4, "updatewageroutcome" },
    { 0x354F3F69, "updatewait" },
    { 0x5D95C6B0, "updatewaiter" },
    { 0x389DCC6A, "updateweapon" },
    { 0xF6655435, "updateweaponcontractplayed" },
    { 0x7C4A5320, "updateweaponcontractstart" },
    { 0x332A7C46, "updateweaponcontractwin" },
    { 0x1BD27BBA, "updateweaponglobals" },
    { 0x143AA9BD, "updateweaponslist" },
    { 0x9F41EF9B, "updateweapontimings" },
    { 0xDDA8D614, "updateweapontimingszm" },
    { 0x33B24198, "updateweaponusagestats" },
    { 0x4096FEFE, "updatewinlossstats" },
    { 0x17C49541, "updatewinstats" },
    { 0xEEF7B88D, "updateworldicon" },
    { 0x2A79230C, "updateworldicons" },
    { 0x9638853A, "updatezonemultikills" },
    { 0x841CB92B, "updating" },
    { 0xDAD10625, "updating_deathflag_" },
    { 0xA9E9DBEF, "updating_dm_scores" },
    { 0x2232B073, "updating_scores" },
    { 0xB2DF7B2A, "updating_team_status" },
    { 0x30C5D054, "updating_weapons_list" },
    { 0xBD0E4236, "updown" },
    { 0x743DC94B, "updownblend" },
    { 0xE21C9933, "upfxsn" },
    { 0x16D27DCA, "upgradable" },
    { 0xF8D4F987, "upgrade" },
    { 0xBE693ABD, "upgrade_active_func" },
    { 0x2B351796, "upgrade_as_attachment" },
    { 0x3F4E84D0, "upgrade_func" },
    { 0x8CC9518D, "upgrade_fx_origin" },
    { 0x5E27AD95, "upgrade_hit" },
    { 0xB0DAE3AD, "upgrade_in_box" },
    { 0x53C5E05E, "upgrade_index" },
    { 0xBFC21A18, "upgrade_knuckle_crack_begin" },
    { 0x5F10C30C, "upgrade_knuckle_crack_end" },
    { 0x4FE98C7F, "upgrade_limit" },
    { 0xA488EB3F, "upgrade_name" },
    { 0xE84A0051, "upgrade_name_dw" },
    { 0xBB58D3AC, "upgrade_tower_trap_weapon" },
    { 0xA6E38CCA, "upgrade_trigger" },
    { 0x4308B942, "upgrade_weapon" },
    { 0x3242041A, "upgrade_weapon_acvi" },
    { 0x47E8BFFD, "upgrade_weapon_options" },
    { 0x5479D174, "upgradecount" },
    { 0x668A3301, "upgraded" },
    { 0x4B1B835D, "upgraded_air_staff_equipped" },
    { 0x9D2E963A, "upgraded_ammo_cost" },
    { 0x5C61139C, "upgraded_ammo_purchased" },
    { 0xE3B709D5, "upgraded_fire_staff_equipped" },
    { 0xB5112CEF, "upgraded_lightning_staff_equipped" },
    { 0x2E0614CB, "upgraded_tomahawk_trigger" },
    { 0x5A7CD261, "upgraded_vortex_explosion_fx" },
    { 0x54FDB059, "upgraded_vortex_fx" },
    { 0x8922016E, "upgraded_vortex_time_client" },
    { 0x12EDE5A2, "upgraded_vortex_time_server" },
    { 0x2F5F994E, "upgraded_water_staff_equipped" },
    { 0xAB6C11D1, "upgradedweapon" },
    { 0xF1AEF710, "upgradedweaponname" },
    { 0xEA9592A3, "upgradehardpointitem" },
    { 0xB5087D3A, "upgradehud" },
    { 0x766E34F9, "upgradeindex" },
    { 0x78C8CF9F, "upgradekeys" },
    { 0xC46EF07E, "upgrades" },
    { 0x51674181, "upgradetrigger" },
    { 0x3F95B9AC, "upgradeupgrades" },
    { 0x3D8261C2, "upgrading" },
    { 0xE8D6C8D7, "uphill" },
    { 0x41B765BE, "uphill_fight_shore" },
    { 0x24D4B7EC, "uphill_stinger" },
    { 0x889A68EF, "uphill_stop_gap" },
    { 0x09C1F0AA, "upindex" },
    { 0x0DC2ECED, "upkeep" },
    { 0xD8D10476, "uplink" },
    { 0xB21370F6, "upload" },
    { 0x12FD20CD, "upload_codes" },
    { 0xF352670B, "upload_global_stat_counters" },
    { 0xD3CD3EB9, "upload_leaderboards" },
    { 0x9392F054, "upload_stats_soon" },
    { 0x063F08CF, "upload_zm_dash_counters" },
    { 0xA6FB8892, "upload_zm_dash_counters_end_game" },
    { 0x7FFE38B9, "uploaded" },
    { 0x2E6F57F2, "uploadglobalstatcounters" },
    { 0xEB11936A, "uploading" },
    { 0x9E975316, "uploadleaderboards" },
    { 0xBF703A28, "uploadscore" },
    { 0x9A7ED193, "uploadstats" },
    { 0xAB797602, "uploadstatssoon" },
    { 0xF216BDC9, "uploadtime" },
    { 0x21D40D98, "uplooklimit" },
    { 0x22EE70C9, "upon" },
    { 0x0C9EDDBC, "upoptions" },
    { 0x63C7CDCB, "uppath" },
    { 0x266C54AD, "upped" },
    { 0x3A8F066B, "upper" },
    { 0x2A02DF96, "upper_bound" },
    { 0xD4DAFEBE, "upper_bridge_logic" },
    { 0x938DBD8D, "upper_floor_enemies" },
    { 0xCA2C6D8D, "upper_floor_hiding_blocker" },
    { 0x17310BAF, "upper_group" },
    { 0x9523D6E4, "upper_house_gunner" },
    { 0x2FC6DCDB, "upper_mgguy" },
    { 0x0326210B, "upper_mine" },
    { 0x2BD24DFB, "upperbody" },
    { 0xE69EC67A, "upperheight" },
    { 0x69F91955, "uppermessagetext" },
    { 0x09789398, "upright" },
    { 0x3259D588, "uprising" },
    { 0x1CFBA0A3, "uprisings" },
    { 0xB9B16FB1, "ups" },
    { 0xAFCFEFEE, "upset" },
    { 0xA70E467B, "upshaft_init" },
    { 0x4CBC1C06, "upshift" },
    { 0xA51A3E3C, "upshiftpoint" },
    { 0xFD77CA6D, "upstair" },
    { 0x5D76AC6C, "upstairs" },
    { 0xDEDEA17D, "upstairs_blocker_purchased" },
    { 0x25640DA4, "upstairs_burn_trigs" },
    { 0xD1E8D5D6, "upstairs_chain" },
    { 0x1F8F24E0, "upstairs_checker" },
    { 0xDB2D4238, "upstairs_enemies_respond_to_attack" },
    { 0x2930E2F5, "upstairs_runanim" },
    { 0xDA672A9E, "upstairs_unreachable_enemies" },
    { 0x8DD8155B, "upstairs_vo_trig" },
    { 0x21FF49CA, "upstairs_window_enemies" },
    { 0xA6122961, "uptime" },
    { 0xC0B5D76D, "upto" },
    { 0x47C4E866, "uptown" },
    { 0x4A9708F0, "upvec" },
    { 0xD35607C4, "upvect" },
    { 0x272E1A03, "upvector" },
    { 0x0D83EF34, "upward" },
    { 0x361B55C0, "upward_units" },
    { 0x4BA37027, "upwards" },
    { 0x2471EB6F, "upwards_normal" },
    { 0x004D3B12, "upwardsdeathrangesq" },
    { 0x68AF3EBD, "ura" },
    { 0x3AB0F232, "uraah" },
    { 0x7FD41F3B, "ural" },
    { 0x1882BA0F, "urban" },
    { 0xF6A7CF82, "urf" },
    { 0x13B0FE27, "urf_baseheight" },
    { 0x29CA6240, "urf_baseorigin" },
    { 0xCFF86FEE, "urgency" },
    { 0x9AFFF57A, "urgent" },
    { 0x3D372305, "urns" },
    { 0x7A22C58C, "urzua" },
    { 0x8FF3DBA5, "us" },
    { 0xE1BB1E2F, "us0" },
    { 0x95B6295D, "us2" },
    { 0x49B1348B, "us4" },
    { 0x3C66258D, "us_battlechatter" },
    { 0xE250FE8A, "us_pilot_1" },
    { 0xBC4E8421, "us_pilot_2" },
    { 0x964C09B8, "us_pilot_3" },
    { 0xAAEE1FB3, "us_redshirt" },
    { 0xDAF262F6, "usa" },
    { 0x3E70F921, "usability" },
    { 0x0998F019, "usable" },
    { 0x67574F39, "usable_colorcodes" },
    { 0xCB787B87, "usable_spots" },
    { 0x439233FA, "usage" },
    { 0xF2C47F9F, "usagekey" },
    { 0xB4FAA214, "usagesinglegame" },
    { 0x90404B2E, "usc2" },
    { 0x42E87952, "use" },
    { 0xD560EC63, "use3d" },
    { 0x16620A17, "use_a_turret" },
    { 0x7E229F92, "use_absolute" },
    { 0x41456707, "use_actionslot" },
    { 0xD22A2552, "use_activated" },
    { 0x998F77B1, "use_activated_retrieve" },
    { 0xA6E09B88, "use_actual_pos" },
    { 0xEC1967B4, "use_adjusted_grenade_damage" },
    { 0xD4959077, "use_air_support" },
    { 0xB4F2BBCF, "use_alt_btn_to_move" },
    { 0x3B575076, "use_alternate_poi_positioning" },
    { 0x0F343011, "use_attackbutton" },
    { 0x18D24CF6, "use_autofill_wallbuy" },
    { 0x83D861E7, "use_big_goal_until_goal_is_safe" },
    { 0xC8B3F908, "use_blocker_clip_for_pathing" },
    { 0xAF53A432, "use_boards" },
    { 0xF7D30F48, "use_bow_gun" },
    { 0x4FEFC29C, "use_burst_fire" },
    { 0xD72A6539, "use_button" },
    { 0x9BA72E41, "use_button_held" },
    { 0xEE9A69BE, "use_button_pressed" },
    { 0x6C99E2B0, "use_camera_tween" },
    { 0xE9D6D271, "use_chaff" },
    { 0x37A29FFF, "use_choke" },
    { 0x2D3F3BE9, "use_clientside_board_fx" },
    { 0x408D9E88, "use_clientside_rock_tearin_fx" },
    { 0x12AE2FD6, "use_computer" },
    { 0xC6538EC7, "use_cqb_walk" },
    { 0x03E77F3F, "use_cyclic_spawns" },
    { 0x091F48A1, "use_delta" },
    { 0xD38C16BE, "use_digital_blood" },
    { 0xD9DEFA1C, "use_digital_blood_enabled" },
    { 0x58AD95DC, "use_dist_sq" },
    { 0xF1EC6FE5, "use_ever_released" },
    { 0x5238DA8A, "use_exit_behavior" },
    { 0xE3C5DFE4, "use_expensive_targeting" },
    { 0x267E2439, "use_female" },
    { 0x6DAA0DF9, "use_female_animations" },
    { 0xEE3059D4, "use_flashlight_weapon_in_tunnels" },
    { 0xEA39917F, "use_foliage_risers" },
    { 0xC7A63F23, "use_for_ammo" },
    { 0x78B55FDE, "use_fov" },
    { 0xC4F10A31, "use_frac" },
    { 0x001FE7DC, "use_freezegun_features" },
    { 0xD7F060A3, "use_fullscreen_fade" },
    { 0xA2F34219, "use_fullscreen_trans" },
    { 0x43F0BDC2, "use_glow" },
    { 0x694CA5E0, "use_grenade_special_bookmark" },
    { 0x3F41B30D, "use_grenade_special_long_bookmark" },
    { 0x17728A32, "use_helicopter_start_visionset" },
    { 0x083A6233, "use_helicopter_visionset" },
    { 0x285D0FCF, "use_helicopter_water_visionset" },
    { 0xD0AC648E, "use_hold" },
    { 0x6091BFFB, "use_hold_think" },
    { 0xD1F484B0, "use_hold_think_loop" },
    { 0xC459924C, "use_horse" },
    { 0x91FA5EB2, "use_interrupt" },
    { 0xE65E553F, "use_killstreak" },
    { 0x39919EB6, "use_killstreak_death_machine" },
    { 0x2E2656C3, "use_killstreak_grim_reaper" },
    { 0x161782E5, "use_killstreak_mp40" },
    { 0x9D9F8E96, "use_killstreak_tv_guided_missile" },
    { 0xA573F4D3, "use_launch_effects" },
    { 0xE3DBE5E9, "use_legacy_equipment_placement" },
    { 0x54F7A17A, "use_legacy_weapon_prompt_format" },
    { 0x073CE7E3, "use_lighting_ent" },
    { 0x58CCFD5B, "use_loop" },
    { 0x8A1A0018, "use_low_attack" },
    { 0xC85FA4FF, "use_low_goalradius" },
    { 0xBAB69E33, "use_low_gravity_risers" },
    { 0xD3697BEE, "use_magic_shield" },
    { 0x3E9EC281, "use_magicbox" },
    { 0xB7BE3FA3, "use_message_created" },
    { 0x9CE83FA4, "use_multiple_spawns" },
    { 0xC847C9EB, "use_near_goal" },
    { 0xBAF97DAD, "use_new_carpenter_func" },
    { 0xF409C3B7, "use_new_riser_water" },
    { 0xF4354FC7, "use_new_spawn_system" },
    { 0x5F89AA3A, "use_new_veh_husks" },
    { 0xBE5AB1C9, "use_non_teambased_enemy_selection" },
    { 0x6D63B88C, "use_normal" },
    { 0xDDD5E129, "use_nose_turret" },
    { 0x1AE7A636, "use_obj_offset" },
    { 0xB86BE3AF, "use_object_locked_for_team" },
    { 0xB145B521, "use_object_onuse" },
    { 0x71B1B581, "use_object_prox_think" },
    { 0x5C0FB655, "use_object_use_think" },
    { 0x0D6EB40C, "use_odd" },
    { 0x25AAD16E, "use_old_trace" },
    { 0xBB4D0D60, "use_pap" },
    { 0x7BE46651, "use_patrol_anim" },
    { 0xB68DC807, "use_patrol_anim_at_goal" },
    { 0x61F3FE3F, "use_perk_hud" },
    { 0xBC2A4851, "use_perk_random" },
    { 0xCFE21BE7, "use_plain" },
    { 0xCD0F3212, "use_player_cougar" },
    { 0xBBB63870, "use_points" },
    { 0xCEDA6367, "use_powerup_volumes" },
    { 0x5D91E65B, "use_radius" },
    { 0x688E82AA, "use_random_drop_path" },
    { 0x02B258B1, "use_random_start" },
    { 0x86C2E459, "use_rocket" },
    { 0x2AFFC810, "use_rockets" },
    { 0xE1AC9CA8, "use_round_logic" },
    { 0xB0E78F89, "use_safe_spawn_on_bus" },
    { 0xB6F54EF3, "use_safe_spawn_on_elevator" },
    { 0x023EE6FC, "use_solo_revive" },
    { 0xEF9E5AD3, "use_spawn_num" },
    { 0x47C8E4F0, "use_sr71_cam_relaystation" },
    { 0xD494E48C, "use_sr71_camera" },
    { 0x27EB897C, "use_staff_melee" },
    { 0x524101BB, "use_start" },
    { 0x59A3D4D9, "use_start_node_angles" },
    { 0x3D17BC9A, "use_start_spawns" },
    { 0x20E5AF3D, "use_swipe_protection" },
    { 0xF1BA3B32, "use_tag_angles" },
    { 0xFDD3E087, "use_targetname" },
    { 0xE3158A4D, "use_tazer_impact_fx" },
    { 0xF9C61CE5, "use_team_based_logic_for_locking_on" },
    { 0xDE5B0EA7, "use_the_turret" },
    { 0x66C9024D, "use_this_angle" },
    { 0x5541C576, "use_time" },
    { 0xF1B868D3, "use_trig" },
    { 0x1FAFE4BF, "use_trigger" },
    { 0x1ABAF7B4, "use_trigger1" },
    { 0x8CC266EF, "use_trigger2" },
    { 0x66BFEC86, "use_trigger3" },
    { 0x974A29DE, "use_trigger_on_flag" },
    { 0x2BB21C83, "use_trigger_on_group_clear" },
    { 0x8FB983B9, "use_trigger_on_group_count" },
    { 0x26AE18EE, "use_trigger_thread" },
    { 0xE75E86C6, "use_triggers" },
    { 0x9F2879BF, "use_turret" },
    { 0x3526FE63, "use_turret_teleport" },
    { 0xF0742FEE, "use_turret_thread" },
    { 0xC87C48BE, "use_vtol" },
    { 0x142A1311, "use_warehouse_switch" },
    { 0x40560CC3, "use_water_risers" },
    { 0x1F20FD1C, "use_weapon_type" },
    { 0xA7DE7E35, "use_weight" },
    { 0x70F99D16, "use_zombie_heroes" },
    { 0x6F3265FE, "useable" },
    { 0xC64EDA0E, "useaccel" },
    { 0x5FD1C258, "useairstrike" },
    { 0x9C07959D, "usealternateaimparams" },
    { 0x950509C4, "usealternatereviveicon" },
    { 0xA9B6C594, "usealternaterotor" },
    { 0x85B0B936, "useambientpackage" },
    { 0x9F053ABB, "useambientroom" },
    { 0xBE8376FE, "useangles" },
    { 0x7C80DD6D, "useanim" },
    { 0x2FACB8E4, "useanimationoverride" },
    { 0x2E8D82E5, "useanimationoverridecallback" },
    { 0x4F87E1B9, "useanimtree" },
    { 0xE8821E4C, "useanynode" },
    { 0x18E80B30, "useartillery" },
    { 0xD1F6806D, "usebar" },
    { 0x6ADB8298, "usebartext" },
    { 0x59ECF1CA, "usebodyindex" },
    { 0x2086C5C5, "usebreachapproach" },
    { 0xC331977D, "usebridge" },
    { 0x86AFB7DD, "usebuildkitweaponmodel" },
    { 0xA1A34092, "usebutton" },
    { 0xB535E0B7, "usebutton_tracker" },
    { 0xB7A99492, "usebuttonholdtime" },
    { 0x8529AC34, "usebuttonholdtimer" },
    { 0x0D5EF124, "usebuttonpressed" },
    { 0x4FDC0E7D, "useby" },
    { 0x89F83A2C, "usecache" },
    { 0xA386DE9B, "usecallback" },
    { 0xE09E781A, "usecarriedkillstreakweapon" },
    { 0x34F337EB, "usechokepoints" },
    { 0x7F0780D0, "useclip" },
    { 0xEF463A86, "usecodetriggers" },
    { 0xFADD1CC5, "usecombatscriptatcover" },
    { 0x563749F0, "usecooler" },
    { 0x99F50899, "usecoopheroes" },
    { 0x8926FC97, "usecovernode" },
    { 0xDF773FC7, "usecovernodeifpossible" },
    { 0x293DFC94, "usecovernodewrapper" },
    { 0x09ACEEB4, "usecurrentposition" },
    { 0xCE3C5F92, "used" },
    { 0x04745D55, "used_amt" },
    { 0xB22E57F9, "used_an_mg42" },
    { 0xDB5CF7A8, "used_at_least_once" },
    { 0xADA0F5B2, "used_by" },
    { 0xC923BDFA, "used_cooldown" },
    { 0x3234994D, "used_emp" },
    { 0xC73C59AD, "used_fletcher_names" },
    { 0x5A898C18, "used_generic_lines" },
    { 0x8E64C597, "used_in_animation" },
    { 0x87B03FE8, "used_levels" },
    { 0x7303D6D2, "used_lines" },
    { 0x2A6C2991, "used_moveup_lines" },
    { 0x18DD7EF9, "used_nag_lines" },
    { 0x4429E84F, "used_plane_damage_lines" },
    { 0xE28875FC, "used_reduction" },
    { 0x509B5FA0, "used_rpg_tower_damage_lines" },
    { 0x8CAFB1AE, "used_screecher_hole" },
    { 0xB1DCDA4F, "usedanimations" },
    { 0x3A8ABA68, "usedbaseweapons" },
    { 0x329090DB, "usedcallback" },
    { 0xF76D3872, "usedclackerobjectivemarker" },
    { 0x2B5FD81C, "usedefaultcallback" },
    { 0x2F863A52, "usedestroyfx" },
    { 0x247118C8, "usedids" },
    { 0x5BF4CAF3, "usedif" },
    { 0x1F6B159C, "usedkillstreakweapon" },
    { 0xD3DB7106, "usednote" },
    { 0x35456D12, "usedpositions" },
    { 0xEDBF58B3, "usedresurrect" },
    { 0x5A0FE1ED, "usedweapons" },
    { 0xBB1D1B37, "useelectricswitch" },
    { 0x8C05B17D, "useelectrictraps" },
    { 0x56EA2BF0, "useenemypos" },
    { 0xCB6C2029, "useent" },
    { 0x8697AAF9, "useenthp" },
    { 0x6DFF7FC2, "useentownerdeathwaiter" },
    { 0x2A00AF0E, "useexpensivelights" },
    { 0x6D591B4C, "usefacialanims" },
    { 0x06060EE7, "useflatangles" },
    { 0x09874AB8, "usefootsteptable" },
    { 0x0CADDE03, "usefov" },
    { 0x062E980F, "usefrozenmomentanim" },
    { 0x51A4F7FB, "usefrozenmoments" },
    { 0x6A24F03B, "useful" },
    { 0x7B6B905D, "usefull" },
    { 0x1E34A7EE, "usefunction" },
    { 0xB34BF8FC, "usegoalanimweight" },
    { 0xE7ED2917, "usegrenades" },
    { 0x2CC2E554, "usegunnerhelicopter" },
    { 0x1604BF0D, "usehardpoint" },
    { 0x52B3EDE4, "useheadindex" },
    { 0x9A2F8636, "usehellhounds" },
    { 0x3C23BE53, "usehelmetindex" },
    { 0x8F78C033, "useholdthink" },
    { 0x4B42FF9D, "useholdthinkloop" },
    { 0xFDE16AF1, "usehud" },
    { 0x146856E1, "useid" },
    { 0x8595A75E, "useing" },
    { 0x6B5E167C, "useintermissionpointsonwavespawn" },
    { 0x447F1B87, "usejavelin" },
    { 0x1B10F660, "usekillstreak" },
    { 0xC61C9D5A, "usekillstreakairstrike" },
    { 0x5B6DA341, "usekillstreakaitankdrop" },
    { 0x7C608C82, "usekillstreakartillery" },
    { 0xDD4869F0, "usekillstreakcounteruav" },
    { 0x98406011, "usekillstreakdogs" },
    { 0x1EACDAAB, "usekillstreakhelicopter" },
    { 0x0D3E2AF2, "usekillstreakhelicoptergunner" },
    { 0xF088BADC, "usekillstreakhelicopterplayer" },
    { 0x83EBAD67, "usekillstreakmortar" },
    { 0xE3698D7B, "usekillstreaknapalm" },
    { 0xE009A8A1, "usekillstreakplanemortar" },
    { 0x83F88CB4, "usekillstreakradar" },
    { 0xC5D441E5, "usekillstreakrcbomb" },
    { 0x64545483, "usekillstreaksatellite" },
    { 0x4BDB54FC, "usekillstreakstraferun" },
    { 0x921AC4CE, "usekillstreaksupplydrop" },
    { 0xAEE9041B, "usekillstreaktalondrop" },
    { 0xB5E29B6D, "usekillstreakturretdrop" },
    { 0x45A7CD93, "usekillstreakweapondrop" },
    { 0x46C9355D, "usekillstreakweaponfromcrate" },
    { 0x4AD7AECC, "uselaststandparams" },
    { 0xB253C3E1, "useleans" },
    { 0x0C8A0C0D, "useless" },
    { 0xEBB1EFBE, "uselessstring" },
    { 0x9D818304, "uselobbyplayers" },
    { 0x974ED5F5, "uselocalpaintshop" },
    { 0x2F1AEF5E, "usemeshbounds" },
    { 0x351817B7, "usemicrowaveturret" },
    { 0xED3AEE6D, "usemicrowaveturretkillstreak" },
    { 0x03008F6C, "usemissiledrone" },
    { 0x4C5C11EC, "usemixedrounds" },
    { 0x9200BEE9, "usemodel" },
    { 0xFEE81375, "usemortar" },
    { 0x844BCF41, "usenapalm" },
    { 0x288E62A9, "useobj" },
    { 0x3D54069F, "useobject" },
    { 0x3C16BBED, "useobjectlockedforteam" },
    { 0x43B12F6C, "useobjectmessage" },
    { 0xC181B918, "useobjectproxthink" },
    { 0x354AD25C, "useobjectusethink" },
    { 0xD9BAE6D0, "useoptionalmodels" },
    { 0x7ABE6BF7, "usepath" },
    { 0x30CA253A, "usepathfinding" },
    { 0xFC81D8EF, "useplanemortar" },
    { 0xB4CD12AD, "useplayerfootsteptable" },
    { 0xA10C7F8A, "useplayerhelicopter" },
    { 0xBCC09A33, "useplayerorigin" },
    { 0x5BCA9763, "useplayeruav" },
    { 0xD124B0E3, "useposition" },
    { 0x7A68FAF4, "user" },
    { 0x8B49C114, "user_cost" },
    { 0x104CF303, "user_created_soundrandoms" },
    { 0x9EABDEFA, "user_defined" },
    { 0x34088BB4, "user_delay" },
    { 0x479799CD, "user_grabbed_weapon" },
    { 0x2CFABD29, "user_input_timeout" },
    { 0x50AA494C, "user_ryan_ape" },
    { 0x8CB06889, "user_ryan_ape_health" },
    { 0xA3681212, "user_ryan_ape_pathing" },
    { 0xA8B21D68, "user_ryan_thief" },
    { 0x8037B27D, "user_ryan_thief_health" },
    { 0xB3C77D4F, "user_ryan_thief_victim" },
    { 0x929A6A12, "user_using_turret" },
    { 0xD61B8997, "useradaritem" },
    { 0xEE611284, "useradiussq" },
    { 0xB68CF5EC, "userate" },
    { 0xC5815E7B, "usercbomb" },
    { 0x1B36E02C, "userdata" },
    { 0xAC4C1D37, "usereacquirenode" },
    { 0xD7058741, "usereload" },
    { 0x4F88B29F, "useremotecontrolweapon" },
    { 0x086E7A68, "useremoteweapon" },
    { 0x0E9E32F5, "userespawntime" },
    { 0x64195EB5, "userflip" },
    { 0xBDF49BA6, "userifleanimsforsmg" },
    { 0x3B93CB5F, "userrequest" },
    { 0x797223E7, "users" },
    { 0x31833820, "userspawns" },
    { 0xDDE727BC, "usertag" },
    { 0xA06B755D, "uses" },
    { 0xCB04797D, "uses_at_current_location" },
    { 0x91AE4B46, "uses_gumps" },
    { 0x6D88EDB0, "uses_teleportation" },
    { 0x2BB2277C, "uses_tesla_powerup" },
    { 0xA0B48515, "useselfplacedturret" },
    { 0x341A2A71, "usesentryturret" },
    { 0x7150096F, "usesentryturretkillstreak" },
    { 0x356981C1, "useservervisionset" },
    { 0xA65C216B, "usesgears" },
    { 0x58D20C34, "useshowcasepaintjob" },
    { 0x77B585E5, "useshowcaseweapon" },
    { 0xF22FB47F, "usesightcheck" },
    { 0x0C82EC1B, "usesnow" },
    { 0x5D92AC2F, "usesound" },
    { 0xD8BB0B7E, "usesound_nexttime" },
    { 0xFCC20F5E, "usesound_waittime" },
    { 0xC426FEC0, "usespivottargeting" },
    { 0x7A86C3BB, "usesquadcommand" },
    { 0xA93E40A6, "usestartspawns" },
    { 0x81C3000E, "usestationaryturret" },
    { 0x82430826, "usestopaimnotetrack" },
    { 0x52D03A31, "usestoredammo" },
    { 0xC027A29A, "usesupplydropmarker" },
    { 0xCA405721, "usetagaim" },
    { 0xFDE4C20E, "usetagangles" },
    { 0xC94818A2, "usetalon" },
    { 0xAE2058D0, "usetalonkillstreak" },
    { 0x0D788C92, "usetanktrigger" },
    { 0x0C1AE1DD, "useteam" },
    { 0x2F7E10AA, "useteamequipmentclientfield" },
    { 0xABB04D83, "useteamuav" },
    { 0xAB32FA6F, "usetext" },
    { 0x5F09646D, "usetime" },
    { 0x1BAE94D5, "usetimer" },
    { 0x59A0C9AA, "usetowturret" },
    { 0xD0726E68, "usetowturretkillstreak" },
    { 0x5D023FE0, "usetreadfx" },
    { 0x9A6BFFF8, "usetrig" },
    { 0x564FFFEA, "usetrigger" },
    { 0x1F80B3D5, "usetriggerrequirelookat" },
    { 0x9BD27E8F, "usetriggerrequirelooktoward" },
    { 0x088082F9, "usetrueregen" },
    { 0xA5E86EE0, "useturret" },
    { 0x66AB5BF7, "usetwitch" },
    { 0x16337F9E, "usevehicle" },
    { 0xF574E7E8, "usevolume" },
    { 0x853C2AFA, "usevtoltime" },
    { 0xC983AEFD, "usewalk" },
    { 0x8DE097E2, "useweapon" },
    { 0xF852127D, "useweaponhidetags" },
    { 0x97877619, "useweaponmodel" },
    { 0x08959425, "useweights" },
    { 0xE440A248, "usexcamsforendgame" },
    { 0x334E7A2A, "usher" },
    { 0x028F0F73, "usher_guys_loop_scene" },
    { 0xF838FDB2, "usinf_all" },
    { 0xD20C7203, "using" },
    { 0x43A1F47C, "using_a_turret" },
    { 0x09085F58, "using_ai" },
    { 0xD28AAA95, "using_awareness" },
    { 0x3348A149, "using_beartrap" },
    { 0x4EBAF259, "using_captured_skitpo" },
    { 0x5AB31489, "using_damaged_soct" },
    { 0xF1B1D820, "using_dead_soct" },
    { 0xAEA4F5B5, "using_double_wide" },
    { 0x26F08D7F, "using_jump_skipto" },
    { 0x1C48AD13, "using_locked_magicbox" },
    { 0x4C98B889, "using_map_vehicle" },
    { 0xCCED3D54, "using_poi_last_check" },
    { 0x14289740, "using_remote" },
    { 0x809C5639, "using_solo_revive" },
    { 0x96A62277, "using_speed" },
    { 0x2C4D45B6, "using_start" },
    { 0x3F1D6E63, "using_weapon_or_upgrade" },
    { 0x32BF0718, "using_zombie_powerups" },
    { 0x9BB6329C, "usingautomaticweapon" },
    { 0x7C3A3494, "usingboltactionweapon" },
    { 0x0B312494, "usingextratime" },
    { 0x90058E8A, "usinggasweapon" },
    { 0x30F90E2F, "usinggrenadelauncher" },
    { 0xAB941343, "usingkillstreakfrominventory" },
    { 0xFFCBDC30, "usingkillstreakheldweapon" },
    { 0xB1A74DA1, "usingmomentum" },
    { 0x0682BA1A, "usingnodes" },
    { 0xE775F565, "usingnvfx" },
    { 0x667FE152, "usingobj" },
    { 0xAA72A10E, "usingpistol" },
    { 0xC5847C61, "usingplayergrenadetimer" },
    { 0x17C8B62F, "usingprimary" },
    { 0xE54A5FD7, "usingproneleftandright" },
    { 0x5B8BE64C, "usingrampage" },
    { 0x8D6B31A5, "usingremote" },
    { 0x33A66EE7, "usingrifle" },
    { 0x840FE59F, "usingrocketlauncher" },
    { 0x67FF4934, "usingscorestreaks" },
    { 0x39B0918F, "usingsecondary" },
    { 0x13125E40, "usingsemiautoweapon" },
    { 0xBFDD4B93, "usingshotgun" },
    { 0xEAA0D087, "usingshotgunweapon" },
    { 0x41C5D924, "usingsidearm" },
    { 0xFC132506, "usingsmg" },
    { 0x6EA1BA31, "usingstartpoint" },
    { 0x516630C2, "usingsupplystation" },
    { 0xC8364C36, "usingsword" },
    { 0xC5A14DA0, "usingtoploadingweapon" },
    { 0x334DA419, "usingturret" },
    { 0xE8FA6CBB, "usingvalidweapon" },
    { 0x91C8E9A9, "usingvehicle" },
    { 0x611C83EF, "usp" },
    { 0x4BF187E9, "uspawn_already_spawned" },
    { 0xEF1514B4, "uss" },
    { 0x94D89575, "usss0" },
    { 0x6ED61B0C, "usss1" },
    { 0x979AE2A1, "usual" },
    { 0x81E4A42C, "usually" },
    { 0xB34E04C1, "ut_stub" },
    { 0x1F7B7D95, "utc" },
    { 0x82B91A51, "util" },
    { 0xAA36B153, "util_evaluateknownenemylocation" },
    { 0x027484E2, "util_ignorecurrentsightpos" },
    { 0x70298D4B, "util_shared" },
    { 0x7B8F1843, "utilities" },
    { 0x07A8B9E7, "utility" },
    { 0x79EBCA3E, "utility_enemies" },
    { 0xA858BB49, "utility_mp" },
    { 0x13786FF9, "utilize" },
    { 0x7752E17F, "utilized" },
    { 0xCD692F30, "utilizes" },
    { 0x6596F54E, "utilizesairspace" },
    { 0x49728C38, "utils" },
    { 0x7DB02ACF, "utmost" },
    { 0x7FA32425, "uts" },
    { 0x1AF28AB3, "uts_box" },
    { 0xD7223F7A, "uts_craftable" },
    { 0xDC9441A7, "uts_craftablespawn" },
    { 0xDC071E47, "uts_source" },
    { 0x90CE2143, "uts_target" },
    { 0xD1E77798, "uv" },
    { 0x8609B214, "uvec" },
    { 0x1A7E4173, "uvs" },
    { 0x83843974, "uwb_chopper_snapshot" },
    { 0x1852DDDB, "uwb_default_room" },
    { 0x2A611322, "uwb_default_snapshot" },
    { 0xA8BC20FE, "uwb_override_rank_func" },
    { 0xEB8EECA5, "uwb_vs" },
    { 0xC2C06BFC, "uwsn_end" },
    { 0x8900B91A, "uwsn_strt" },
    { 0x85E282C6, "ux" },
    { 0xABE4FD2F, "uy" },
    { 0x9B870C81, "v" },
    { 0xB6C055A3, "v0" },
    { 0x90BDDB3A, "v1" },
    { 0xFE7C3E32, "v1_1" },
    { 0xD879C3C9, "v1_2" },
    { 0x6ABB60D1, "v2" },
    { 0xCFF4F6D5, "v2_1" },
    { 0xF5F7713E, "v2_2" },
    { 0x2129F9C9, "v2blocker" },
    { 0x44B8E668, "v3" },
    { 0x1D4B34F4, "v3_1" },
    { 0x8F52A42F, "v3_2" },
    { 0xE33849DC, "v78" },
    { 0x86AC825B, "v8" },
    { 0xCD10AF7C, "v_accurate_firing_angle" },
    { 0x259033C1, "v_achievement_location" },
    { 0x9B572176, "v_adjusted" },
    { 0x10A367A1, "v_af_02_02_truck_offload_truck" },
    { 0xCBC2B71A, "v_af_04_03_through_binoculars_tank" },
    { 0xEE5A8CFD, "v_af_04_06_reunion_tank_horsepush" },
    { 0xDBA2B801, "v_af_04_06_reunion_tank_run2tank" },
    { 0xB4FA8CE0, "v_af_04_06_reunion_tank_runtowoods" },
    { 0xD40D1BFC, "v_af_04_06_reunion_tank_tankbattle" },
    { 0x5B46F5E3, "v_af_04_09_reunion_tank_strangle" },
    { 0x91427BD5, "v_af_06_01_deserted_maintruck_offtruck" },
    { 0x9A420D5F, "v_af_06_01_deserted_maintruck_ontruck" },
    { 0xEAB9F49C, "v_afghan_intro_quad" },
    { 0x4A4A12B6, "v_afghan_intro_quad2" },
    { 0x704C8D1F, "v_afghan_intro_quad3" },
    { 0x663B3440, "v_afghan_intro_quad4" },
    { 0x09B895C9, "v_afghan_outro_claw" },
    { 0xAA17E2E9, "v_afghan_outro_claw2" },
    { 0x44071D6C, "v_afghan_outro_vtol1" },
    { 0xB60E8CA7, "v_afghan_outro_vtol2" },
    { 0x0B27EC64, "v_ai_forward" },
    { 0x09F6D150, "v_aim_point" },
    { 0xDF3BF26C, "v_aim_pos" },
    { 0x57C7BFBA, "v_aim_spot" },
    { 0xA444207B, "v_align" },
    { 0x7CEBCA10, "v_alpha" },
    { 0x4838B7A2, "v_ambulance" },
    { 0x6DEDFC84, "v_anchor_pos" },
    { 0xB12B2CFC, "v_ang" },
    { 0xCC300138, "v_ang_01_01_intro_buffel02" },
    { 0x09B11367, "v_ang_01_01_intro_chopper" },
    { 0x34A2B5EE, "v_ang_01_01_pirates_01_buffel" },
    { 0x71D54CB3, "v_ang_01_01_pirates_01_loop_buffel" },
    { 0xC153487F, "v_ang_01_05_riverbed_vignettes_a_gaz01_cargo" },
    { 0xDD2BC7B6, "v_ang_01_05_riverbed_vignettes_a_gaz01_truck" },
    { 0x5F5F6794, "v_ang_01_05_riverbed_vignettes_a_gaz02_cargo" },
    { 0x54E9BE99, "v_ang_01_05_riverbed_vignettes_a_gaz02_truck" },
    { 0x1A826A70, "v_ang_04_01_helicopter_buffel" },
    { 0x818DE9D2, "v_ang_04_01_helicopter_idle_landing" },
    { 0xAD6998B1, "v_ang_04_01_helicopter_landing" },
    { 0x7E73F104, "v_ang_05_02_first_lancing_chopper_flight_path" },
    { 0x88B933CE, "v_ang_05_03_ghaz_cargo_open_cargo" },
    { 0x2A02F62D, "v_ang_05_04_boat_jump_chopper" },
    { 0x16A5A650, "v_ang_05_04_going_down_chopper_jump" },
    { 0xBC134EBE, "v_ang_05_04_going_down_idle_chopper" },
    { 0x29399555, "v_ang_06_01_enemy_boat_ram_boat" },
    { 0x7D639426, "v_ang_06_01_enemy_boat_ram_boat_left_approach" },
    { 0xB4EF344A, "v_ang_06_01_enemy_boat_ram_boat_left_approach_front" },
    { 0xF5D911E4, "v_ang_06_01_enemy_boat_ram_boat_left_idle_front" },
    { 0x2BED3AAD, "v_ang_06_01_enemy_boat_ram_boat_right_approach" },
    { 0xCE82F0E5, "v_ang_06_01_enemy_boat_ram_boat_right_approach_front" },
    { 0xEAD5D8B3, "v_ang_06_01_enemy_boat_ram_boat_right_idle_front" },
    { 0x69849288, "v_ang_06_01_enemy_boat_ram_idle_rightboat" },
    { 0x936ECF2D, "v_ang_06_01_enemy_boat_ram_rightboat" },
    { 0x7BE14462, "v_ang_06_01_enemy_boat_ram_veer_boat" },
    { 0xAC8B5468, "v_ang_06_01_gunboat_jump_boat" },
    { 0xA56081C2, "v_ang_06_01_gunboat_ram_boat" },
    { 0x46E0145A, "v_ang_06_01_gunboat_veer_boat" },
    { 0x6A7E5B1F, "v_ang_06_02_find_woods_part1_shipping_container" },
    { 0x0088D03A, "v_ang_06_02_find_woods_part2_shipping_container" },
    { 0xE0C4FBD3, "v_ang_06_02_find_woods_part2_shipping_container_loop" },
    { 0x6CB580F4, "v_ang_06_02_get_strella_cargo" },
    { 0x8BDFFD6D, "v_ang_06_02_wheelhouse_hit_cargo" },
    { 0x85629880, "v_ang_06_04_barge_sinking" },
    { 0x02FFC0D3, "v_ang_06_04_hind_aftermath_barge" },
    { 0x1ECED2D3, "v_ang_06_04_hind_aftermath_hind" },
    { 0x1D1A0281, "v_ang_06_04_hind_aftermath_truck" },
    { 0xBF69C30C, "v_ang_06_04_hind_attacks_barge" },
    { 0xB19F0629, "v_ang_06_04_hind_attacks_dive_barge" },
    { 0x0467FA79, "v_ang_06_04_swim_barge" },
    { 0x9372EECE, "v_ang_07_03_village_ambienta_gaz_truck" },
    { 0x51E8D4ED, "v_ang_07_03_village_ambientb_gaz_truck" },
    { 0xE59D0AEA, "v_ang_offset" },
    { 0x0F5A1155, "v_angle" },
    { 0x8D35C51D, "v_angle_diff" },
    { 0x0EE0B191, "v_angle_offset" },
    { 0x6CAC4BA4, "v_angles" },
    { 0x3C799C01, "v_angles_0" },
    { 0x16772198, "v_angles_1" },
    { 0x887E90D3, "v_angles_2" },
    { 0x1B106CD2, "v_angles_anim_model" },
    { 0x43AF8E5D, "v_angles_body_forward" },
    { 0x5070D2F0, "v_angles_body_right" },
    { 0x68E59E30, "v_angles_clone_model" },
    { 0x0BF103E2, "v_angles_forward" },
    { 0xF5CA3A62, "v_angles_offset" },
    { 0xD689660E, "v_angles_old" },
    { 0xB5F18B31, "v_angles_or_tag" },
    { 0x5B00A8FC, "v_angles_player" },
    { 0xD6CD34FA, "v_angles_player_forward" },
    { 0xF1F294C8, "v_angles_to_source" },
    { 0xABD92018, "v_angles_to_target" },
    { 0xE498C1DC, "v_angles_to_use" },
    { 0x18D777C5, "v_anim_start_pos" },
    { 0x2D8E984D, "v_attack_origin" },
    { 0xD6CFBF38, "v_attack_source" },
    { 0x660FC956, "v_attacker_facing" },
    { 0x83CB75F0, "v_attacker_facing_forward_dir" },
    { 0x384D5A7E, "v_attacker_orientation" },
    { 0x2F3B20A8, "v_attract_point" },
    { 0xC8FF34B2, "v_average_origin" },
    { 0x1C88F16F, "v_away_from_source" },
    { 0xC3F14AEC, "v_b_to_c" },
    { 0xC48CFEE5, "v_back" },
    { 0x05B312DE, "v_back_scaled" },
    { 0x570BB798, "v_base_pos" },
    { 0x05D00B0C, "v_basic_offset" },
    { 0x6152F5D2, "v_battleship_forward" },
    { 0xF77B1BF7, "v_blast_origin" },
    { 0x3DEB21D0, "v_box_max" },
    { 0xAB63002E, "v_box_min" },
    { 0xAFCFEABD, "v_brf_holo_vtol_anim" },
    { 0x2D55874E, "v_briggs_angle" },
    { 0xCC45DE65, "v_briggs_angles_offset" },
    { 0xEE44E2A1, "v_briggs_pos" },
    { 0xD7F36EEE, "v_briggs_position_offset" },
    { 0x8731B57C, "v_buffel" },
    { 0x3771204C, "v_bullet_trace_end" },
    { 0x32631A9B, "v_cam_to_mz" },
    { 0x972F0C4A, "v_camera_eyes" },
    { 0x6BF6F813, "v_camera_movement" },
    { 0x3D8E8C95, "v_camera_offset" },
    { 0x458BC626, "v_camera_xy_origin" },
    { 0x13CAE743, "v_canopy_pos" },
    { 0x8246F8B5, "v_ceiling_position" },
    { 0x6BECBFFF, "v_center" },
    { 0x1FD1C37A, "v_center_pillar" },
    { 0x66A8FBA3, "v_centerpoint" },
    { 0x4C4C600E, "v_chaff_dir" },
    { 0xA20F1ABC, "v_chaff_direction" },
    { 0xBEF2B911, "v_chaff_pos" },
    { 0x1A99DE6A, "v_chair_angles" },
    { 0xA044E344, "v_chair_origin" },
    { 0x0BCEA68C, "v_check" },
    { 0xBF3517B2, "v_check_position" },
    { 0x6B29DB94, "v_civ_goal" },
    { 0xE3883C1C, "v_claw_angles" },
    { 0xB17F4F7A, "v_claw_origin" },
    { 0x5A02FB8A, "v_col" },
    { 0x435E66EA, "v_collision_normal" },
    { 0x392E82FA, "v_collision_parallel" },
    { 0xC40B2387, "v_collision_point" },
    { 0x255E1FF8, "v_collision_to_player" },
    { 0xD1D4FDA2, "v_collision_velocity" },
    { 0x431BC2A9, "v_color" },
    { 0x63ACB56B, "v_command_05_06_flight_deck_f35_liftoff" },
    { 0x5BD0F778, "v_command_07_07_anderson_take_off_alt_vtol" },
    { 0xAD5F420C, "v_command_07_07_anderson_take_off_vtol" },
    { 0xA249F7C3, "v_compact_mode" },
    { 0x2B7E8877, "v_convoy_vehicle" },
    { 0xF37909C3, "v_corpse_pos" },
    { 0xFB4D4786, "v_corpse_position" },
    { 0x17FBE126, "v_crew_semi_truck_ramp_open" },
    { 0xAA80C432, "v_crew_vtol_1_jetpack" },
    { 0x0B335A11, "v_crew_vtol_2_jetpack" },
    { 0x015FA53C, "v_crew_vtol_3_jetpack" },
    { 0xA7755A53, "v_crew_vtol_4_jetpack" },
    { 0x6A4A1CAE, "v_crew_vtol_5_jetpack" },
    { 0x43982C2D, "v_crew_vtol_6_jetpack" },
    { 0x4BC330CC, "v_cross" },
    { 0xBBA0D2D2, "v_crystal" },
    { 0x2D08317C, "v_curr_yaw" },
    { 0x6A651C7A, "v_curr_zombie_facing_dot" },
    { 0x4CC87D0A, "v_curr_zombie_origin" },
    { 0x3A80FF09, "v_curr_zombie_origin_sq" },
    { 0x76B65463, "v_curr_zombie_to_thunder_wall" },
    { 0x9D88A2CB, "v_current" },
    { 0x1C9981F2, "v_current_angles" },
    { 0xDEA31947, "v_current_position" },
    { 0xE1F3EED7, "v_damage" },
    { 0x46043680, "v_damage_origin" },
    { 0x2FA53F37, "v_death_origin" },
    { 0xFB4DB109, "v_debug_color" },
    { 0x3AB6A5CF, "v_defend_spot" },
    { 0xF7BE590E, "v_delta" },
    { 0x2E156F31, "v_desired_pos" },
    { 0xC7F9BE6A, "v_desired_vel" },
    { 0x20D952C8, "v_dest" },
    { 0xF4F312E3, "v_dest_angles" },
    { 0xFCD1EF5D, "v_dest_origin" },
    { 0xA47DE6BE, "v_dest_position" },
    { 0x7D86CA14, "v_destination" },
    { 0x177E8EC4, "v_detonate" },
    { 0xEC05D3C1, "v_diff" },
    { 0x5462D085, "v_difference" },
    { 0xA080D759, "v_dir" },
    { 0xCBE78FD7, "v_dir_to_path" },
    { 0xCBF2BF1D, "v_dir_to_player" },
    { 0x6BBEFCB5, "v_dir_to_target" },
    { 0xC904793F, "v_dir_to_trap" },
    { 0xC4FE4FC7, "v_direction" },
    { 0x48C39F87, "v_distance_traveled" },
    { 0xF7A93DC6, "v_door_angles_close" },
    { 0x276B3DD2, "v_door_angles_open" },
    { 0x8BB8FA69, "v_dot" },
    { 0xA86D2888, "v_down" },
    { 0xAE1F345D, "v_down_scaled" },
    { 0x2CAB0F51, "v_dragon_position" },
    { 0x4DE810CE, "v_drama_fx" },
    { 0xDE49D557, "v_drive_point" },
    { 0x03A311D0, "v_drone_forward" },
    { 0x97F787F0, "v_drone_goto" },
    { 0x955C2D8D, "v_drone_spawn_org" },
    { 0x61F65BC7, "v_drone_spotlight_trigger_origin" },
    { 0x1B1B946C, "v_drop_origin" },
    { 0xE3AFAA51, "v_drop_per_frame" },
    { 0x325A9E3C, "v_drop_point" },
    { 0x520ADD6C, "v_duration" },
    { 0xC9E830B2, "v_eland" },
    { 0x11D8FAEA, "v_elevator_start_angles" },
    { 0xEEDE5900, "v_elevator_start_pos" },
    { 0x491BC153, "v_end" },
    { 0x19B59544, "v_end_point" },
    { 0x992AF830, "v_end_pos" },
    { 0x862B9817, "v_endangles" },
    { 0x67DC5A07, "v_endpoint" },
    { 0x408DD52F, "v_endpos" },
    { 0x4741E2D5, "v_enemy_origin" },
    { 0xEF838F83, "v_enemy_pos" },
    { 0x8868739E, "v_enter" },
    { 0x1A48CFBD, "v_enter_pos" },
    { 0x0312CA5D, "v_escape_vector" },
    { 0x544F0F0D, "v_execution_civ_goal" },
    { 0x836EF144, "v_explode_point" },
    { 0x04BEF0B9, "v_explosion" },
    { 0xC02C5E5A, "v_explosion_origin" },
    { 0xA0D5568B, "v_eye" },
    { 0xBFF77CB5, "v_eye_direction" },
    { 0xB9F3DDCC, "v_eye_origin" },
    { 0xC430EDA8, "v_eye_pos" },
    { 0x455CD818, "v_eye_to_tag" },
    { 0xDDD515C0, "v_f35_forward" },
    { 0x16706F71, "v_f35_pos" },
    { 0xC7B72155, "v_f35_to_drone" },
    { 0x5ABF80B1, "v_f38_forward" },
    { 0xC975B582, "v_facing" },
    { 0x9C57AD8D, "v_fall_vector_current" },
    { 0x9360EA0C, "v_final" },
    { 0xBAEC3CD7, "v_final_angles" },
    { 0x9083D7EF, "v_final_pos" },
    { 0x9DAB2A32, "v_final_position" },
    { 0x72197C0B, "v_final_spot" },
    { 0x860ECE2C, "v_final_woods_rotation" },
    { 0xFBEEAC1A, "v_final_woods_spot" },
    { 0xFF58A499, "v_final_woods_trace" },
    { 0xA7191940, "v_fire" },
    { 0x1CA10DD6, "v_fire_at_offset" },
    { 0x8FA1B765, "v_fire_at_origin" },
    { 0xD3275BE6, "v_fire_direction" },
    { 0x67AD8EE6, "v_fire_offset" },
    { 0x26264143, "v_fire_pos" },
    { 0x8843F59B, "v_fireball_offset" },
    { 0x0EFF790D, "v_fireball_start_loc" },
    { 0xBBFFC4BF, "v_firehorse" },
    { 0x9B9E1BC2, "v_firing_pos" },
    { 0x49F5DA29, "v_flash_pos" },
    { 0xFBB83170, "v_flicker" },
    { 0x94DE28AB, "v_flicker_time_high" },
    { 0xF061838F, "v_flicker_time_low" },
    { 0x9110A86E, "v_fling" },
    { 0xF172090A, "v_float" },
    { 0x0385F2BD, "v_floor_pos" },
    { 0x80590A6C, "v_fly_away" },
    { 0x8B14783F, "v_font_color" },
    { 0x394708D0, "v_foot" },
    { 0x14341D4D, "v_force" },
    { 0x53EA0DB5, "v_force_dir" },
    { 0x0C9D5829, "v_force_launch" },
    { 0xD230AD83, "v_forward" },
    { 0xE54E7903, "v_forward_computed" },
    { 0xB02DBDCD, "v_forward_normalized" },
    { 0x6F9B0ED4, "v_forward_point" },
    { 0x33913844, "v_forward_scaled" },
    { 0xF597F315, "v_forward_trace" },
    { 0x9E29B10B, "v_from_wall" },
    { 0xF4992BF5, "v_from_wall_normalized" },
    { 0x1B46BE27, "v_full_offset" },
    { 0x9A75EC87, "v_fwd" },
    { 0x17760516, "v_fx" },
    { 0xE5BF8324, "v_fx_offset" },
    { 0x9F638251, "v_fx_org" },
    { 0x412B7F6B, "v_fx_origin" },
    { 0xC5F81FF5, "v_fx_pos" },
    { 0x22DBEE9C, "v_fxorigin" },
    { 0x0320D982, "v_gather_pos" },
    { 0x5328E21A, "v_giant_robot" },
    { 0x2188BF75, "v_goal" },
    { 0xB8A5D028, "v_goal_angles" },
    { 0x4BB135D2, "v_goal_org" },
    { 0xBC5FB476, "v_goal_pos" },
    { 0xE425BAAE, "v_gravity" },
    { 0xE893A95B, "v_gravity_trap_lift_amount_offset" },
    { 0x19C1716D, "v_gravity_trap_origin" },
    { 0x5DA14F3B, "v_gravity_trap_pos" },
    { 0x7783CE26, "v_grenade_target" },
    { 0xFFB479E8, "v_grenade_velocity" },
    { 0x3A04D91E, "v_grid_center_bottom" },
    { 0x7E4701CC, "v_grid_center_center" },
    { 0x0FD26474, "v_grid_center_top" },
    { 0x6BD7099A, "v_grid_left_bottom" },
    { 0x639F4F60, "v_grid_left_center" },
    { 0x9C5843A0, "v_grid_left_top" },
    { 0x5443B73B, "v_grid_right_bottom" },
    { 0x9F359B3D, "v_grid_right_center" },
    { 0xBEF0B447, "v_grid_right_top" },
    { 0x0607AFAD, "v_ground" },
    { 0x31F358AE, "v_ground_line" },
    { 0x143172ED, "v_ground_offset_fudge" },
    { 0x8F3269EE, "v_ground_pos" },
    { 0x80F08819, "v_ground_position" },
    { 0x64AB191D, "v_guillotine_spot" },
    { 0x5FF277A8, "v_gun_offset" },
    { 0x609D31FA, "v_gunl" },
    { 0x30F83A70, "v_gunner_angles" },
    { 0x26FF9F6D, "v_gunner_barrel1" },
    { 0xC0DE3816, "v_gunner_origin" },
    { 0xDCB5FA14, "v_gunr" },
    { 0x4CC8C0F6, "v_guy_origin" },
    { 0x2429B298, "v_harper_idle_pos" },
    { 0x58EF2409, "v_harper_pos" },
    { 0x10EFF569, "v_height_offset" },
    { 0x37A3F38C, "v_heli" },
    { 0x4B9CF9CA, "v_heli_forward" },
    { 0x3A3BED0E, "v_heli_name" },
    { 0x9A4DF96F, "v_heli_pos" },
    { 0x20DF61A0, "v_hidden" },
    { 0xDEE4BF23, "v_hit" },
    { 0x52FB7B1D, "v_hit_direction" },
    { 0x5ABC14A4, "v_hit_loc" },
    { 0x0383A5FB, "v_hit_location" },
    { 0x7C5A4EE4, "v_hit_origin" },
    { 0x07E4F0B4, "v_hit_point" },
    { 0xD90726A0, "v_hit_pos" },
    { 0xFE27C6A2, "v_ht_01_01_intro_bg_vtol1" },
    { 0x1AC55796, "v_ht_01_01_intro_bg_vtol10" },
    { 0x40C7D1FF, "v_ht_01_01_intro_bg_vtol11" },
    { 0xCEC062C4, "v_ht_01_01_intro_bg_vtol12" },
    { 0xF4C2DD2D, "v_ht_01_01_intro_bg_vtol13" },
    { 0x82BB6DF2, "v_ht_01_01_intro_bg_vtol14" },
    { 0xA8BDE85B, "v_ht_01_01_intro_bg_vtol15" },
    { 0x36B67920, "v_ht_01_01_intro_bg_vtol16" },
    { 0x5CB8F389, "v_ht_01_01_intro_bg_vtol17" },
    { 0x4AD92ADE, "v_ht_01_01_intro_bg_vtol18" },
    { 0x70DBA547, "v_ht_01_01_intro_bg_vtol19" },
    { 0xD8254C39, "v_ht_01_01_intro_bg_vtol2" },
    { 0x9C2DF16B, "v_ht_01_01_intro_bg_vtol20" },
    { 0x762B7702, "v_ht_01_01_intro_bg_vtol21" },
    { 0x5028FC99, "v_ht_01_01_intro_bg_vtol22" },
    { 0x2A268230, "v_ht_01_01_intro_bg_vtol23" },
    { 0x3437DB0F, "v_ht_01_01_intro_bg_vtol24" },
    { 0x0E3560A6, "v_ht_01_01_intro_bg_vtol25" },
    { 0xE832E63D, "v_ht_01_01_intro_bg_vtol26" },
    { 0xB222D1D0, "v_ht_01_01_intro_bg_vtol3" },
    { 0xBC342AAF, "v_ht_01_01_intro_bg_vtol4" },
    { 0x9631B046, "v_ht_01_01_intro_bg_vtol5" },
    { 0x702F35DD, "v_ht_01_01_intro_bg_vtol6" },
    { 0x4A2CBB74, "v_ht_01_01_intro_bg_vtol7" },
    { 0x543E1453, "v_ht_01_01_intro_bg_vtol8" },
    { 0x2E3B99EA, "v_ht_01_01_intro_bg_vtol9" },
    { 0x51E291B7, "v_ht_01_01_intro_explodingvtol" },
    { 0x0B274B97, "v_ht_01_01_intro_explodingvtol2" },
    { 0xD59BA8CD, "v_ht_01_01_intro_f38_1" },
    { 0xFB9E2336, "v_ht_01_01_intro_f38_2" },
    { 0x21A09D9F, "v_ht_01_01_intro_f38_3" },
    { 0x178F44C0, "v_ht_01_01_intro_f38_4" },
    { 0x3D91BF29, "v_ht_01_01_intro_f38_5" },
    { 0x63943992, "v_ht_01_01_intro_f38_6" },
    { 0x8996B3FB, "v_ht_01_01_intro_f38_7" },
    { 0x474EB5AB, "v_ht_01_01_intro_nearmissvtol" },
    { 0x427A530A, "v_ht_01_01_intro_playervtol" },
    { 0x297DE1A7, "v_ht_01_01_intro_playervtol_exterior" },
    { 0xE81858A4, "v_ht_01_01_intro_rearvtol1" },
    { 0x5A1FC7DF, "v_ht_01_01_intro_rearvtol2" },
    { 0x341D4D76, "v_ht_01_01_intro_rearvtol3" },
    { 0xE7176B2C, "v_ht_01_01_intro_wingsuit_1" },
    { 0x071A8D87, "v_ht_01_01_intro_wingsuit_1_harperdead" },
    { 0x591EDA67, "v_ht_01_01_intro_wingsuit_2" },
    { 0x331C5FFE, "v_ht_01_01_intro_wingsuit_3" },
    { 0x750FFBF1, "v_ht_01_01_intro_wingsuit_4" },
    { 0x79B98391, "v_ht_01_03_drone_fly_by_1" },
    { 0x9FBBFDFA, "v_ht_01_03_drone_fly_by_2" },
    { 0xC5BE7863, "v_ht_01_03_drone_fly_by_3" },
    { 0xEBC0F2CC, "v_ht_01_03_drone_fly_by_4" },
    { 0x11C36D35, "v_ht_01_03_drone_fly_by_5" },
    { 0x37C5E79E, "v_ht_01_03_drone_fly_by_6" },
    { 0x5DC86207, "v_ht_01_03_drone_fly_by_7" },
    { 0x23A335E0, "v_ht_01_03_drone_fly_by_8" },
    { 0x516C9C5B, "v_ht_01_05_coming_in_hot_qr1" },
    { 0xECE1E5CC, "v_ht_01_05_coming_in_hot_soldier10_pack" },
    { 0xF6F766D3, "v_ht_01_05_coming_in_hot_soldier11_pack" },
    { 0x3152C936, "v_ht_01_05_coming_in_hot_soldier12_pack" },
    { 0xCFD65D65, "v_ht_01_05_coming_in_hot_soldier13_pack" },
    { 0x860E1578, "v_ht_01_05_coming_in_hot_soldier14_pack" },
    { 0x6D1D012F, "v_ht_01_05_coming_in_hot_soldier15_pack" },
    { 0xEEA3E762, "v_ht_01_05_coming_in_hot_soldier16_pack" },
    { 0x2707F871, "v_ht_01_05_coming_in_hot_soldier17_pack" },
    { 0x86D87034, "v_ht_01_05_coming_in_hot_soldier1_pack" },
    { 0x4E3E3A8D, "v_ht_01_05_coming_in_hot_soldier2_pack" },
    { 0xB61760DE, "v_ht_01_05_coming_in_hot_soldier3_pack" },
    { 0x42641B97, "v_ht_01_05_coming_in_hot_soldier4_pack" },
    { 0x927100A0, "v_ht_01_05_coming_in_hot_soldier5_pack" },
    { 0x75DB4579, "v_ht_01_05_coming_in_hot_soldier6_pack" },
    { 0xFD0E656A, "v_ht_01_05_coming_in_hot_soldier7_pack" },
    { 0x0989CD23, "v_ht_01_05_coming_in_hot_soldier8_pack" },
    { 0x8C3AA41C, "v_ht_01_05_coming_in_hot_soldier9_pack" },
    { 0xFD807B42, "v_ht_06_03_end04_civ_vtol" },
    { 0x26ED6ABA, "v_ht_06_03_end04_harper_vtol" },
    { 0x678DEF34, "v_ht_06_03_end04_outside_part_1_menendez_vtol" },
    { 0x25F58709, "v_ht_06_03_end04_outside_part_1_quadrotor" },
    { 0xAFDD85E7, "v_ht_06_03_end04_outside_part_2_menendez_vtol" },
    { 0x84E13116, "v_ht_06_03_end04_outside_part_3_menendez_vtol" },
    { 0x28B58051, "v_ht_06_03_end05_civ_vtol" },
    { 0x1EC2BAC3, "v_ht_06_03_end05_outside_part_1_menendez_vtol" },
    { 0xD0C7E18A, "v_ht_06_03_end05_outside_part_1_quadrotor" },
    { 0x26158378, "v_ht_06_03_end06_civ_vtol" },
    { 0x64C1BCD6, "v_ht_06_03_end06_outside_part_1_menendez_vtol" },
    { 0xF6AAF37B, "v_ht_06_03_end06_outside_part_1_quadrotor" },
    { 0x61ED5F35, "v_hydrant_pos" },
    { 0x6883B4D3, "v_im_on_a_boat" },
    { 0xCC7B227A, "v_impact" },
    { 0x48EA2F27, "v_impact_origin" },
    { 0x2F950561, "v_impact_point" },
    { 0x333883D9, "v_impact_pos" },
    { 0x3DCAE6AC, "v_impact_velocity" },
    { 0x14428255, "v_interact_angles" },
    { 0xDCA393D5, "v_interact_pos" },
    { 0xBD610052, "v_intro_wp_fastrope_blackhawk" },
    { 0x7699513D, "v_is_countup_timer" },
    { 0x9F141D09, "v_jet" },
    { 0x65AA4FF2, "v_karma_10_3_defalco_dead_ending_vtol" },
    { 0x9B7B4174, "v_karma_10_3_escape_ending_vtol_doors" },
    { 0x28DC731B, "v_karma_1_1_final_approach_landing_idle_vtol" },
    { 0x61412C1C, "v_karma_1_1_final_approach_vtol" },
    { 0x5C3208A5, "v_karma_1_1_vtol_gear_down" },
    { 0x9D1109BA, "v_karma_1_1_vtol_gear_up" },
    { 0x61DD0ED7, "v_kill_pos" },
    { 0x47F316BC, "v_la_01_01_110_intro_bike1" },
    { 0xB9FA85F7, "v_la_01_01_110_intro_bike2" },
    { 0x93F80B8E, "v_la_01_01_110_intro_bike3" },
    { 0xD5EBA781, "v_la_01_01_110_intro_bike4" },
    { 0xAFE92D18, "v_la_01_01_110_intro_bike5" },
    { 0x5087347D, "v_la_01_01_110_intro_blkhwk" },
    { 0x95AB0565, "v_la_01_01_110_intro_blkhwk2" },
    { 0x6FA88AFC, "v_la_01_01_110_intro_blkhwk3" },
    { 0x49A61093, "v_la_01_01_110_intro_blkhwk4" },
    { 0xFA005B99, "v_la_01_01_110_intro_copcar1" },
    { 0x2002D602, "v_la_01_01_110_intro_copcar2" },
    { 0x4605506B, "v_la_01_01_110_intro_copcar3" },
    { 0x6C07CAD4, "v_la_01_01_110_intro_copcar4" },
    { 0x920A453D, "v_la_01_01_110_intro_copcar5" },
    { 0xD3DE7667, "v_la_01_01_110_intro_cougar" },
    { 0x9A60FF87, "v_la_01_01_110_intro_cougar2" },
    { 0x745E851E, "v_la_01_01_110_intro_cougar3" },
    { 0xB6522111, "v_la_01_01_110_intro_cougar4" },
    { 0x2B3CBF03, "v_la_01_01_110_intro_drone1" },
    { 0xB9354FC8, "v_la_01_01_110_intro_drone2" },
    { 0xDF37CA31, "v_la_01_01_110_intro_drone3" },
    { 0x9D442E3E, "v_la_01_01_110_intro_drone4" },
    { 0x7910C9BA, "v_la_03_01_cougarcrawl_cougar" },
    { 0xC59A32F8, "v_la_03_02_mountturret_cougar" },
    { 0x181E7F81, "v_la_03_02_mountturret_cougar_loop" },
    { 0xADE6677A, "v_la_03_04_cougarfalls_f35intro_car02" },
    { 0xF7370061, "v_la_03_04_cougarfalls_f35intro_cougar" },
    { 0x33603860, "v_la_03_04_cougarfalls_f35intro_drone" },
    { 0x5931831C, "v_la_03_04_cougarfalls_f35intro_f35" },
    { 0xA5AE4B75, "v_la_03_04_cougarfalls_f35intro_van" },
    { 0xD333082F, "v_la_03_05_lowroad_bigrig02" },
    { 0x6198F9BC, "v_la_03_05_lowroad_car01" },
    { 0xD3A068F7, "v_la_03_05_lowroad_car02" },
    { 0xAD9DEE8E, "v_la_03_05_lowroad_car03" },
    { 0xEF918A81, "v_la_03_05_lowroad_car04" },
    { 0x3B967F53, "v_la_03_05_lowroad_car06" },
    { 0xC62DD378, "v_la_03_05_lowroad_car06_loop" },
    { 0x05D26573, "v_la_03_05_lowroad_cougar01" },
    { 0x93CAF638, "v_la_03_05_lowroad_cougar02" },
    { 0xB9CD70A1, "v_la_03_05_lowroad_cougar03" },
    { 0xABD69CFA, "v_la_03_05_lowroad_policecar01" },
    { 0x85D42291, "v_la_03_05_lowroad_policecar02" },
    { 0xF2A244A0, "v_la_03_10_grouprappel_bigrig" },
    { 0x3C939E27, "v_la_03_10_grouprappel_car05" },
    { 0x6CA1C25F, "v_la_03_10_grouprappel_cougar" },
    { 0xA2E7EDD4, "v_la_03_10_grouprappel_sniper_bigrig" },
    { 0x1E2687BB, "v_la_03_10_grouprappel_sniper_car05" },
    { 0xB2528F1B, "v_la_03_10_grouprappel_sniper_cougar" },
    { 0x81A98792, "v_la_03_11_g20failure_cougar" },
    { 0x4209D770, "v_la_03_11_sniperevent_car01" },
    { 0x3D681D31, "v_la_03_12_entercougar_cougar" },
    { 0xC41933CC, "v_la_04_01_drive_leftturn_cougar" },
    { 0xA3B8113B, "v_la_04_02_dronebattle_drone" },
    { 0x775BA17B, "v_la_04_02_dronebattle_f35" },
    { 0x3E9A74D4, "v_la_04_04_crash_cougar_tag_player" },
    { 0x05C805B6, "v_la_05_01_cougar_exit_18wheeler" },
    { 0xFCC4A2BA, "v_la_05_01_cougar_exit_big_dog" },
    { 0x9494574F, "v_la_05_01_cougar_exit_bike1" },
    { 0x228CE814, "v_la_05_01_cougar_exit_bike2" },
    { 0x488F627D, "v_la_05_01_cougar_exit_bike3" },
    { 0x20DE4C0D, "v_la_05_01_cougar_exit_claw_turret" },
    { 0x1FF01A27, "v_la_05_01_cougar_exit_cop_car1" },
    { 0xADE8AAEC, "v_la_05_01_cougar_exit_cop_car2" },
    { 0xD3EB2555, "v_la_05_01_cougar_exit_cop_car3" },
    { 0x7753AE1E, "v_la_05_01_cougar_exit_cougar" },
    { 0x07F0E63C, "v_la_05_01_cougar_exit_cougar02" },
    { 0xA88A8351, "v_la_05_01_cougar_exit_f35" },
    { 0x97CA15FF, "v_la_05_01_cougar_exit_harperdead_cougar" },
    { 0xBD3EBC13, "v_la_05_02_clearthestreet_18whlr" },
    { 0x9E06C895, "v_la_05_02_clearthestreet_policecar" },
    { 0x3886B30D, "v_la_05_03_bruteforce_cougar" },
    { 0x360E5418, "v_la_07_02_f35staples_f35" },
    { 0xE4D9DE94, "v_la_08_01_save_anderson_ambulance" },
    { 0x553EDF28, "v_la_08_01_save_anderson_f35" },
    { 0x3BC7D8EB, "v_la_08_02_f35enter_f35" },
    { 0x697EFEFD, "v_la_08_02_f35enter_startup_f35" },
    { 0xC796804F, "v_la_10_01_f35_2" },
    { 0xA19405E6, "v_la_10_01_f35_3" },
    { 0xE387A1D9, "v_la_10_01_f35_4" },
    { 0xF16C5844, "v_la_10_01_f35eject_drone" },
    { 0x9396E92F, "v_la_10_01_f35eject_drone_intro" },
    { 0xB46A9DB0, "v_la_10_01_f35eject_f35" },
    { 0x9F79C601, "v_la_10_01_f35eject_start_drone" },
    { 0xD44E66BF, "v_la_10_02_promnight_cougar" },
    { 0x7EA3F485, "v_la_10_02_promnight_cougar02" },
    { 0x58A17A1C, "v_la_10_02_promnight_cougar03" },
    { 0x462B9C2F, "v_la_10_02_promnight_van" },
    { 0x5B74C12E, "v_la_10_02_promnightsam_cougar" },
    { 0x7FDD0E4C, "v_la_10_02_promnightsam_cougar02" },
    { 0xA5DF88B5, "v_la_10_02_promnightsam_cougar03" },
    { 0xADB7CCD8, "v_land_pos" },
    { 0x87220A88, "v_laser_destination" },
    { 0xA809004E, "v_laser_origin" },
    { 0x4618731F, "v_last_node_position" },
    { 0xCFCB49A5, "v_launch" },
    { 0x14DDBBBB, "v_launch_direction" },
    { 0x0241A430, "v_launch_final" },
    { 0xF9FF0CA1, "v_launch_offset" },
    { 0x2A0F70D0, "v_launch_spot" },
    { 0xDCB51AF2, "v_launcher_forward" },
    { 0x9D9A11A7, "v_left" },
    { 0xD73CB6BE, "v_left_angles" },
    { 0x55697279, "v_left_end" },
    { 0x88165F00, "v_left_scaled" },
    { 0xC6E71F12, "v_left_start" },
    { 0xCD13E495, "v_left_target" },
    { 0x4A08DFE8, "v_left_tire_angle" },
    { 0x311E0F3B, "v_left_tire_org" },
    { 0x81234140, "v_length" },
    { 0x78665CBB, "v_lift" },
    { 0x16B38C73, "v_lift_bottom" },
    { 0xFB7C2DCF, "v_lift_offset" },
    { 0x33F3C60F, "v_lift_top" },
    { 0x6162EAB3, "v_lightpos1" },
    { 0xEF5B7B78, "v_lightpos2" },
    { 0xA2DACB52, "v_link_offset" },
    { 0x9794DB6E, "v_loc" },
    { 0x85536595, "v_local" },
    { 0x7B7E3D11, "v_location" },
    { 0x2A923103, "v_locker_pos" },
    { 0xE4E5ACA5, "v_look" },
    { 0x06821708, "v_loot_offset" },
    { 0x364263A0, "v_lstick" },
    { 0xE11A8658, "v_max_ammo_origin" },
    { 0x7D368CD0, "v_menendez_f38" },
    { 0xEDE57850, "v_midpoint" },
    { 0x9D04F4FD, "v_mirror" },
    { 0x188103D4, "v_missile_left" },
    { 0x99EFBC0B, "v_missile_right" },
    { 0xF5468B5F, "v_missile_spawn_org" },
    { 0xB43FC6FB, "v_model" },
    { 0x2BA1C80F, "v_model_offset" },
    { 0x86AA369C, "v_model_origin" },
    { 0xCF9B1E56, "v_mov_0_test_01_cougar_01" },
    { 0xA2F16D19, "v_mov_ang_01_helicopter_01" },
    { 0x65D4C53F, "v_mov_com_02_vtol_01" },
    { 0xE35CEC11, "v_mov_los_03_cougar_01" },
    { 0x095F667A, "v_mov_los_03_cougar_02" },
    { 0x81527AA6, "v_mov_los_03_hummer_01" },
    { 0x5B50003D, "v_mov_los_03_hummer_02" },
    { 0x7BC76DD2, "v_mov_los_03_marineone_01" },
    { 0x4B2400AD, "v_mov_los_03_motorcycle_01" },
    { 0x71267B16, "v_mov_los_03_motorcycle_02" },
    { 0x020E8382, "v_mov_los_03_suv_01" },
    { 0xDC0C0919, "v_mov_los_03_suv_02" },
    { 0x9D0019E5, "v_mov_los_03_v78_01" },
    { 0xC302944E, "v_mov_los_03_v78_02" },
    { 0x1548CC35, "v_mov_pro_01_hummer" },
    { 0xF3D48B19, "v_mov_pro_01_mrap" },
    { 0x7346577D, "v_mov_pro_01_pomo1" },
    { 0x9948D1E6, "v_mov_pro_01_pomo2" },
    { 0xBF4B4C4F, "v_mov_pro_01_pomo3" },
    { 0xD921B4E4, "v_mov_pro_01_suv1" },
    { 0x4B29241F, "v_mov_pro_01_suv2" },
    { 0x2526A9B6, "v_mov_pro_01_suv3" },
    { 0x671A45A9, "v_mov_pro_01_suv4" },
    { 0x4117CB40, "v_mov_pro_01_suv5" },
    { 0xB31F3A7B, "v_mov_pro_01_suv6" },
    { 0xFE393909, "v_mov_pro_01_vtol1" },
    { 0x243BB372, "v_mov_pro_01_vtol2" },
    { 0x6FB6545E, "v_mov_tst_01_vtol_01" },
    { 0x2519F542, "v_mov_vtol_flying_01" },
    { 0x96BA651B, "v_move" },
    { 0xE9B1190A, "v_move_node" },
    { 0x86551766, "v_move_spot" },
    { 0x51058548, "v_move_z" },
    { 0xF0E902B3, "v_movement" },
    { 0x65C4D601, "v_movement_current" },
    { 0xEC788696, "v_movement_down" },
    { 0x6969B841, "v_movement_perp" },
    { 0x992B3CD0, "v_movement_perp_inverse" },
    { 0x41EB3AAF, "v_movepoint" },
    { 0xCF527D3B, "v_moveto_pos" },
    { 0x0C842143, "v_my_boat" },
    { 0x23696BC8, "v_my_forward" },
    { 0x28CBF35A, "v_mz_head" },
    { 0xD9347E1A, "v_narrow_volume" },
    { 0x20B4BDA6, "v_nav_check" },
    { 0x31947BDC, "v_nearest_navmesh_point" },
    { 0xC495D5C3, "v_new_ang" },
    { 0xF8E39443, "v_new_angles_left" },
    { 0x2308E636, "v_new_angles_right" },
    { 0x4A13BA2A, "v_new_dir" },
    { 0x1706268F, "v_new_forward_point" },
    { 0xF6912483, "v_new_forward_vec" },
    { 0x564E0BF0, "v_new_goal" },
    { 0x8246F4F0, "v_new_player_position" },
    { 0x2FE7373D, "v_new_pos" },
    { 0x6BD859E4, "v_new_position" },
    { 0x00B8C2A0, "v_newpos" },
    { 0xFAAA889C, "v_next_pos" },
    { 0xAEB775CB, "v_next_position" },
    { 0xFFD1ED18, "v_node" },
    { 0xDDA198C6, "v_node_normal" },
    { 0x3443B8B9, "v_norm_vec" },
    { 0x51763F9D, "v_normal" },
    { 0xB194883B, "v_normalized" },
    { 0x1C3D5CFC, "v_nuke_origin" },
    { 0xD649ABC0, "v_obj_pos" },
    { 0xC780FB80, "v_off_pos" },
    { 0x027C4935, "v_offset" },
    { 0xE2C63C47, "v_offset_end" },
    { 0xA199808E, "v_offset_origin" },
    { 0x46C7D28E, "v_offset_scale" },
    { 0x80C6672A, "v_old_angles" },
    { 0x08EBD504, "v_old_origin" },
    { 0xE5642E86, "v_on_navmesh" },
    { 0xC6F2FA46, "v_org" },
    { 0xC9DF882A, "v_org_left" },
    { 0xD1DEF879, "v_org_right" },
    { 0x71B16852, "v_orientation" },
    { 0x3F4CA307, "v_orig" },
    { 0xB71ED4A2, "v_origin" },
    { 0xAA0C7BD3, "v_origin_0" },
    { 0x840A016A, "v_origin_1" },
    { 0xBDF8BC58, "v_origin_offset" },
    { 0x44331A24, "v_origin_old" },
    { 0x1D0271F4, "v_origin_or_ent" },
    { 0xEE5848EE, "v_origin_player" },
    { 0xD7257444, "v_original_angles" },
    { 0x3FAF6240, "v_original_forward_vec" },
    { 0x778FF642, "v_original_origin" },
    { 0xCD3883FD, "v_original_position" },
    { 0x598E85B3, "v_output" },
    { 0xCE672B40, "v_override_dir" },
    { 0xA1EA2307, "v_p_angles" },
    { 0xBC22C945, "v_pad_forward" },
    { 0x3B0E13DB, "v_pakistan_1_1_market_intro_claw" },
    { 0x33649A1E, "v_pakistan_1_5_grenade_launch_claw" },
    { 0x7A8A156E, "v_pakistan_1_6_brute_force_claw01" },
    { 0x54879B05, "v_pakistan_1_6_brute_force_claw02" },
    { 0xC57A8211, "v_pakistan_1_6_brute_force_noaccess_claw" },
    { 0x3D55B27E, "v_pakistan_5_11_contextual_melee_tigr" },
    { 0xE02C8C8B, "v_pakistan_5_11_jump_down_attack_gaz_approach" },
    { 0xAFDB68AE, "v_pakistan_5_11_jump_down_attack_gaz_end" },
    { 0xD5461659, "v_pakistan_5_11_jump_down_attack_gaz_idle" },
    { 0x5B8CDA8B, "v_pakistan_5_11_jump_down_attack_gaz_kill" },
    { 0xCC2D4269, "v_pakistan_5_13_get_closer_drone" },
    { 0xE3F4AC30, "v_pakistan_5_13_get_closer_gantry" },
    { 0x92F31C4C, "v_pakistan_5_3_activity_below_btr_gate_entrance_btr" },
    { 0xFEA5B5BA, "v_pakistan_7_3_land_to_water_soct01" },
    { 0xD8A33B51, "v_pakistan_7_3_land_to_water_soct02" },
    { 0x78898B32, "v_pakistan_7_4_helo_crash_approach_hind" },
    { 0x15D75E38, "v_pakistan_7_4_helo_crash_fast_hind" },
    { 0xAE96DCDD, "v_pakistan_7_4_helo_crash_hind" },
    { 0x798B191C, "v_pakistan_7_4_helo_crash_idle_hind" },
    { 0xB958A129, "v_pakistan_7_4_helo_crash_soct" },
    { 0x4F96CB92, "v_pakistan_8_3_hangar_event_apache" },
    { 0x5D7C10FA, "v_pakistan_8_3_hangar_event_drone" },
    { 0xB95FC14A, "v_pakistan_8_3_hangar_event_soct01" },
    { 0x935D46E1, "v_pakistan_8_3_hangar_event_soct02" },
    { 0x6D5ACC78, "v_pakistan_8_3_hangar_event_soct03" },
    { 0x274AAF12, "v_pakistan_9_4_standoff_approach_soct1" },
    { 0x014834A9, "v_pakistan_9_4_standoff_approach_soct2" },
    { 0xA685494D, "v_pakistan_9_4_standoff_approach_success_soct" },
    { 0xA1F3474B, "v_pan_01_01_intro_frontyard_humvee" },
    { 0x0F8EBF74, "v_pan_01_01_intro_frontyard_idle_humvee" },
    { 0x2395A8FE, "v_pan_01_01_intro_out_of_hummer_hum1" },
    { 0xFD932E95, "v_pan_01_01_intro_out_of_hummer_hum2" },
    { 0xEB4C912A, "v_pan_01_07_gringos_humvee" },
    { 0x236C1D71, "v_pan_01_07_gringos_truck" },
    { 0xC52E6ACA, "v_pan_02_01_zodiac_leavesbeach_zodiac" },
    { 0x6AF9489D, "v_pan_02_04_unloading_gaz66_loop" },
    { 0xFECE752C, "v_pan_04_02_amblulance_van" },
    { 0xC6BBDBFB, "v_pan_08_01_gate_crash_jeep" },
    { 0x5F507D5F, "v_pan_08_01_jeep_exit_jeep" },
    { 0xDAB45246, "v_pan_08_01_jeep_rifle_grab_jeep" },
    { 0x27AFF98A, "v_pan_08_01_jeepride_jeep" },
    { 0x8B2F6651, "v_pan_08_01_jeepride_jeep_cycle" },
    { 0xA7805450, "v_pan_08_01_jeepride_jeep_end" },
    { 0x662CCE0A, "v_parasite_attractor_center" },
    { 0xB431A344, "v_parasite_origin" },
    { 0x17414ECD, "v_parking_lot_backup_truck" },
    { 0x084574B1, "v_path" },
    { 0x267B7025, "v_path_offset" },
    { 0xCB876A8B, "v_physics_launch" },
    { 0x69253449, "v_physicstrace_capsule_max" },
    { 0x841A5FF7, "v_physicstrace_capsule_min" },
    { 0xEF4A39D3, "v_pivot_pos" },
    { 0xDC745BD8, "v_plane_forward" },
    { 0x62F2DDF6, "v_plane_to_player" },
    { 0x3472A7D3, "v_player" },
    { 0x3BFEDCFB, "v_player_angle" },
    { 0xF222CB9A, "v_player_angles" },
    { 0x5A4A9AEC, "v_player_angles2" },
    { 0x1BA3AAB6, "v_player_before_zoom_ang" },
    { 0x271E567D, "v_player_before_zoom_eye" },
    { 0x836768EC, "v_player_before_zoom_org" },
    { 0x34F4B193, "v_player_dir" },
    { 0x866CFB21, "v_player_eye" },
    { 0x72457775, "v_player_forward" },
    { 0x46FF2245, "v_player_fwd" },
    { 0x80B488E9, "v_player_last_angles" },
    { 0xC624BD2D, "v_player_last_known_pos" },
    { 0x5093D5A0, "v_player_last_position" },
    { 0x105955F7, "v_player_offset" },
    { 0x0BF1C6B4, "v_player_origin" },
    { 0x3AA9C6B0, "v_player_pos" },
    { 0x91F555B3, "v_player_soct_start_pos" },
    { 0xCAFEA4D4, "v_player_to_enemy" },
    { 0xF1070944, "v_player_to_node" },
    { 0x8C0965A6, "v_player_to_plane" },
    { 0xC2CADA61, "v_player_to_potus" },
    { 0xD2B84487, "v_player_to_ref" },
    { 0x47FA366E, "v_player_to_self" },
    { 0x7BF57A66, "v_player_to_zombie_yaw" },
    { 0xCE07563E, "v_player_trace_origin" },
    { 0x9D5C70D7, "v_player_vel" },
    { 0x740386B3, "v_player_velocity" },
    { 0x0BBAA1A0, "v_player_xy_origin" },
    { 0xB44A2D5E, "v_poi_offset" },
    { 0x10E30246, "v_point" },
    { 0xD693CC3E, "v_point_center" },
    { 0x66589FC4, "v_point_to_rot" },
    { 0x6F62EAFC, "v_point_to_rotate" },
    { 0x22B1EA38, "v_point_to_rotate_around" },
    { 0xC55DCD82, "v_pos" },
    { 0x5D6414FC, "v_pos_above_gem" },
    { 0xB93123E8, "v_pos_end" },
    { 0x7EFA7E23, "v_pos_final" },
    { 0x33219FD6, "v_pos_left" },
    { 0x0DAC99AD, "v_pos_right" },
    { 0x6775FC8B, "v_pos_start" },
    { 0x088FD65D, "v_position" },
    { 0x2C5CD825, "v_powerup_origin" },
    { 0xB5938F5A, "v_predicted_location" },
    { 0x23C41C5C, "v_prev_origin" },
    { 0x7EF41E9F, "v_prev_vel" },
    { 0xC69115C7, "v_projected_spot" },
    { 0xFDF687E6, "v_punch_effect_fwd" },
    { 0x86EC6694, "v_punch_yaw" },
    { 0x36A949C6, "v_punched_from" },
    { 0x26E0D148, "v_push" },
    { 0xAFFD5D73, "v_qrotor" },
    { 0xA94BD457, "v_quadrotor" },
    { 0x8CFFBC15, "v_rand_offset" },
    { 0xBE2A524C, "v_rand_target_pos" },
    { 0x11659BF9, "v_random" },
    { 0xCBD0005A, "v_random_pos" },
    { 0x8488F3F3, "v_reference" },
    { 0x135F36A3, "v_reflection" },
    { 0x8203A1F3, "v_release" },
    { 0x38C28FA2, "v_right" },
    { 0x72130751, "v_right_angles" },
    { 0x2D8001C8, "v_right_end" },
    { 0xA8CEE65F, "v_right_scaled" },
    { 0xB26BD86B, "v_right_start" },
    { 0x8F45FDAA, "v_right_target" },
    { 0x9396F6B7, "v_right_tire_angle" },
    { 0x5F0FFD6C, "v_right_tire_org" },
    { 0xADD2C7AE, "v_rocket_impact_point" },
    { 0x7A8E1313, "v_rot" },
    { 0x079F3A24, "v_rotate_angles" },
    { 0x39A9BE16, "v_rotate_radius" },
    { 0x06816BA5, "v_rotate_speed" },
    { 0xF9773EDF, "v_rotate_to" },
    { 0x6C795E65, "v_rotate_vel" },
    { 0xCE6DC658, "v_rotated_point" },
    { 0x393439B2, "v_rotation_movement" },
    { 0x3FA1F4C5, "v_rotation_point" },
    { 0x8E2F3698, "v_rotor" },
    { 0xB6A59CE2, "v_rpg_pos" },
    { 0x0D68E286, "v_rstick" },
    { 0xE85A2E07, "v_runto_spot" },
    { 0xCD5E7C19, "v_sacotra_intro_zodiac" },
    { 0xDE933A62, "v_sacotra_intro_zodiac1" },
    { 0xB890BFF9, "v_sacotra_intro_zodiac2" },
    { 0x9C9F9E6F, "v_sacotra_intro_zodiac4" },
    { 0x769D2406, "v_sacotra_intro_zodiac5" },
    { 0x509AA99D, "v_sacotra_intro_zodiac6" },
    { 0x3C800558, "v_sacotra_outro_vtol_flyin_outro" },
    { 0xC154B047, "v_salazar_pos" },
    { 0x1D3B9AFB, "v_sam_cougar" },
    { 0x6A3F2BB6, "v_sam_org" },
    { 0x91272FA8, "v_saved_ang" },
    { 0x3A228376, "v_saved_pos" },
    { 0x74013152, "v_scaled" },
    { 0xF0F63253, "v_search_pos" },
    { 0x79B5FD77, "v_seated_angles" },
    { 0x8A1823B8, "v_self_forward" },
    { 0x09EB6A4B, "v_self_to_enemy" },
    { 0x3B8B3342, "v_shoot_pos" },
    { 0x0C7248CF, "v_shot_angles" },
    { 0xE7741E8A, "v_shot_end" },
    { 0x2F3A8891, "v_shot_start" },
    { 0x46258D17, "v_show_hours" },
    { 0x1321CDC8, "v_show_milliseconds" },
    { 0xF58659E1, "v_show_minutes" },
    { 0x43EEA8E5, "v_side" },
    { 0xAB613723, "v_singapore_1_player_outro_osprey" },
    { 0x7C650A60, "v_singapore_fail_vtol1" },
    { 0xEE6C799B, "v_singapore_fail_vtol2" },
    { 0x5EE31840, "v_sky_pos" },
    { 0x4E57B5B3, "v_slide" },
    { 0xCED0BAE5, "v_soct_wheels_down" },
    { 0x429894FA, "v_soct_wheels_up" },
    { 0x6B3E045A, "v_sole_angles" },
    { 0xA4C1AB1B, "v_source" },
    { 0xE1460D03, "v_source_to_target" },
    { 0xEB8AA3D9, "v_spawn" },
    { 0x1AAB8F9E, "v_spawn_org" },
    { 0x6A724B3A, "v_spawn_origin" },
    { 0x7D35959E, "v_spawn_point" },
    { 0xD8D1C67A, "v_spawn_pos" },
    { 0x34CCB9DE, "v_spawn_pos_left" },
    { 0xCAD9D895, "v_spawn_pos_right" },
    { 0x92B07549, "v_spawn_vector" },
    { 0x946DE6C1, "v_spawn_vector_dir" },
    { 0xF8C6B1D7, "v_spawnang" },
    { 0x3AD03F65, "v_spawnpt" },
    { 0x06E39E0C, "v_spot" },
    { 0xCA031AA4, "v_spot_angle" },
    { 0xBD97744A, "v_spot_forward" },
    { 0x567DCBEF, "v_spot_pos" },
    { 0xEBD494B3, "v_spotlight_angles" },
    { 0xE7BBAFAD, "v_spotlight_origin" },
    { 0x3AD5964E, "v_staff" },
    { 0x489B2980, "v_start" },
    { 0xAD9308E1, "v_start_ang" },
    { 0xE7702BFB, "v_start_angles" },
    { 0xA0936BC6, "v_start_current" },
    { 0xA7BE70B3, "v_start_org" },
    { 0x181054D5, "v_start_origin" },
    { 0xFC5C855B, "v_start_point" },
    { 0xA1F5A583, "v_start_pos" },
    { 0x14C96146, "v_start_position" },
    { 0x50B4C5EF, "v_start_spot" },
    { 0x671EA392, "v_start_trace" },
    { 0x089632B0, "v_start_yaw" },
    { 0x8334DCC0, "v_startangles" },
    { 0x38FCC60E, "v_startpos" },
    { 0x524D36CC, "v_stick_left" },
    { 0xC7DD4F7A, "v_stick_position" },
    { 0x56651AE3, "v_stick_right" },
    { 0x4E194C32, "v_sun_color" },
    { 0x09E8673B, "v_sun_direction_angles" },
    { 0xB861EBAC, "v_tag" },
    { 0x1625ED55, "v_tag_ang" },
    { 0xE6FED137, "v_tag_angles" },
    { 0x0B3E5957, "v_tag_flash" },
    { 0xFFA0CF22, "v_tag_fwd" },
    { 0x11D87E67, "v_tag_org" },
    { 0xA0A193E9, "v_tag_origin" },
    { 0xD7D00EFF, "v_tag_player_org" },
    { 0x83F1B7CF, "v_tag_pos" },
    { 0x4AD2403A, "v_tank_fwd" },
    { 0x3185A0CF, "v_target" },
    { 0xC47B451B, "v_target_landing" },
    { 0x226DD4CF, "v_target_location" },
    { 0x31362A8B, "v_target_offset" },
    { 0xA690D72C, "v_target_pos" },
    { 0x9A5B5A9B, "v_target_position" },
    { 0x21579AC9, "v_target_zombie_origin" },
    { 0x9C16C261, "v_targetl" },
    { 0xEFEA26FF, "v_targetr" },
    { 0x9A7503F8, "v_teleport_angles" },
    { 0x239D42C6, "v_teleport_pos" },
    { 0x58847C4E, "v_temp" },
    { 0x02BC2B52, "v_temp_approach_point" },
    { 0xE589283B, "v_temp_goal_point" },
    { 0x1EBC82BC, "v_terrorist_forward" },
    { 0xE2122D5B, "v_terrorist_to_self" },
    { 0xB1825AD2, "v_tgt_origin" },
    { 0xB7AC748C, "v_throw" },
    { 0x3A4AD804, "v_thumbstick" },
    { 0x9C9F175D, "v_thunder_wall_blast_pos" },
    { 0xB5C0C152, "v_to_dest" },
    { 0x204CE808, "v_to_drone" },
    { 0x857C5131, "v_to_end" },
    { 0x3B143046, "v_to_enemy" },
    { 0xE5A3F7C1, "v_to_ent" },
    { 0xC21E4042, "v_to_facee" },
    { 0x23D0BC80, "v_to_facee_computed" },
    { 0xDD7DB733, "v_to_goal" },
    { 0xEB20996E, "v_to_harper_from_spotlight" },
    { 0x3648936E, "v_to_node" },
    { 0x41283AD0, "v_to_plane" },
    { 0x6FF03BD5, "v_to_player" },
    { 0xC987F440, "v_to_point" },
    { 0xA8A5285C, "v_to_pos" },
    { 0x7C915AD8, "v_to_self" },
    { 0x5AB449C8, "v_to_stage" },
    { 0xD0160572, "v_to_tank" },
    { 0x0DE448AD, "v_to_target" },
    { 0x1F23D4C1, "v_to_tower" },
    { 0x8BCD853A, "v_to_wall" },
    { 0x146E137B, "v_to_wall_final" },
    { 0xBCE6B934, "v_to_wall_per_frame" },
    { 0x5190CC88, "v_to_wounded" },
    { 0x018DD3FC, "v_to_zombie" },
    { 0xF5584B7D, "v_top" },
    { 0x17F4E357, "v_trace" },
    { 0xBCB6D0C9, "v_trace_end" },
    { 0x77128B25, "v_trace_hit" },
    { 0xE1BA3E74, "v_trace_pos" },
    { 0x4A29BAA2, "v_trace_start" },
    { 0x6ED41AD6, "v_trace_to_point" },
    { 0xE578A0E8, "v_trig_offset" },
    { 0xB2B80CB6, "v_trigger_offset" },
    { 0xAD2A6D45, "v_trigger_origin" },
    { 0xD01C98B3, "v_trigger_pos" },
    { 0x71E234FE, "v_turned_blast_pos" },
    { 0xEEEB1002, "v_turret" },
    { 0xED1A7971, "v_turret_angles" },
    { 0xED993060, "v_turret_firing_angle" },
    { 0x5E85D0D2, "v_turret_yaw" },
    { 0x5E98E792, "v_unit_forward_computed" },
    { 0x9639F673, "v_unit_to_facee_computed" },
    { 0x766FBF83, "v_up" },
    { 0xE1DFDE44, "v_up_scaled" },
    { 0x228CBE5F, "v_vake" },
    { 0x5B05B191, "v_valid_point" },
    { 0x8DE718DA, "v_variable_offset" },
    { 0x88E8E062, "v_vec" },
    { 0xCAE30C9A, "v_vec_to_target" },
    { 0x2B0422E5, "v_vel" },
    { 0x8CD5B0C5, "v_velocity" },
    { 0xC8A80857, "v_velocity_per_frame" },
    { 0x4BC3620F, "v_view" },
    { 0x65A64C05, "v_vortex_explosion_origin" },
    { 0x7B30B1AD, "v_vortex_origin" },
    { 0xE006A077, "v_vtol" },
    { 0x9A9AA2F0, "v_vtol_doors_close" },
    { 0x2E8A0924, "v_vtol_doors_open" },
    { 0x53441E35, "v_vtol_flight_idle" },
    { 0xD41C8436, "v_vtol_gear_down" },
    { 0x11413A35, "v_vtol_gear_up" },
    { 0xFDB37089, "v_vtol_hover_idle" },
    { 0x965F27B4, "v_wait_pos" },
    { 0xEBFFCE76, "v_wall_normal" },
    { 0xBC1E8006, "v_war_drones_intro_player_jetpack" },
    { 0x338DA746, "v_war_drones_intro_seal_1_jetpack" },
    { 0xF803EB45, "v_war_drones_intro_seal_2_jetpack" },
    { 0x7BF02ED0, "v_war_drones_intro_seal_3_jetpack" },
    { 0xC559B3DF, "v_war_drones_intro_seal_4_jetpack" },
    { 0x941D904A, "v_war_drones_intro_seal_5_jetpack" },
    { 0x12787B0C, "v_war_drones_outro_succeed_heli_1" },
    { 0x847FEA47, "v_war_drones_outro_succeed_heli_2" },
    { 0x5E7D6FDE, "v_war_drones_outro_succeed_heli_3" },
    { 0x9C21E19F, "v_war_pak_fail_crashed_vtol" },
    { 0x57995F82, "v_war_pak_fail_vtol_1" },
    { 0x3196E519, "v_war_pak_fail_vtol_2" },
    { 0x258B8C62, "v_war_pak_intro_sc1_vtol_1" },
    { 0xFF8911F9, "v_war_pak_intro_sc1_vtol_2" },
    { 0xD9869790, "v_war_pak_intro_sc1_vtol_3" },
    { 0x0D114D1B, "v_war_pak_intro_sc2_vtol_1" },
    { 0x9B09DDE0, "v_war_pak_intro_sc2_vtol_2" },
    { 0xC10C5849, "v_war_pak_intro_sc2_vtol_3" },
    { 0x5DDBD8CB, "v_war_pak_succeed_crashed_vtol" },
    { 0x583E0C0C, "v_warp_position" },
    { 0xBA1958EB, "v_weapon_angles" },
    { 0xD34374BF, "v_weapon_angles_offset" },
    { 0x2007FA05, "v_weapon_origin" },
    { 0xA5B23E41, "v_weapon_origin_offset" },
    { 0x3B8DE789, "v_whirlwind_pos" },
    { 0x2432A782, "v_wind_dir" },
    { 0xD8C65273, "v_with_z" },
    { 0x98858387, "v_without_z" },
    { 0xAEAF4D86, "v_woods_projected_spot" },
    { 0x41EB9539, "v_woods_spot" },
    { 0xB0DE1FEC, "v_world_force" },
    { 0xE9500C94, "v_x" },
    { 0x0F5286FD, "v_y" },
    { 0x54E1A518, "v_yemen_02_02_car_flip_car" },
    { 0x655225DF, "v_yemen_02_02_drones_enter_ambush_drone_01" },
    { 0xF34AB6A4, "v_yemen_02_02_drones_enter_ambush_drone_02" },
    { 0x194D310D, "v_yemen_02_02_drones_enter_ambush_drone_03" },
    { 0xB78AFF63, "v_yemen_02_02_drones_enter_flyby_drone_01" },
    { 0x45839028, "v_yemen_02_02_drones_enter_flyby_drone_02" },
    { 0x6B860A91, "v_yemen_02_02_drones_enter_flyby_drone_03" },
    { 0xFF957957, "v_yemen_02_02_drones_enter_window_drone_01" },
    { 0xE11E7A74, "v_yemen_05_04_shoot_harper_vtol" },
    { 0x2EA3BA23, "v_yemen_05_05_mason_intro_hpr_lives_vtol" },
    { 0x35550166, "v_z" },
    { 0x4427FA34, "v_z_offset" },
    { 0x93EFFD01, "v_zombie_custom_goal_pos" },
    { 0x45EF6CD0, "v_zombie_forward" },
    { 0x0810DF61, "v_zombie_forward_2d" },
    { 0x27E1318F, "v_zombie_origin" },
    { 0x76DBD021, "v_zombie_pos" },
    { 0xE502452D, "v_zombie_right" },
    { 0x4733D782, "v_zombie_right_2d" },
    { 0xF5ED5B7E, "v_zombie_to_player" },
    { 0x17E60E9B, "v_zombie_to_player_2d" },
    { 0x1D99CC34, "v_zombiepos" },
    { 0xAE32D5A5, "v_zombietarget" },
    { 0x71841C0A, "va" },
    { 0x96DE62B0, "vacant" },
    { 0x030D3F3F, "vacate" },
    { 0x21364074, "vacation" },
    { 0x4E0501B8, "vacinity" },
    { 0x8B48D097, "vague" },
    { 0x40F779FA, "vaguely" },
    { 0x94F4955C, "vahn" },
    { 0xBB32C4C3, "vain" },
    { 0x35C84E32, "val" },
    { 0x22CC86CF, "val1" },
    { 0xB0C51794, "val2" },
    { 0x97F09ACA, "val_a" },
    { 0x71EE2061, "val_b" },
    { 0x7135ED09, "val_max" },
    { 0x8C2B18B7, "val_min" },
    { 0xE6AB4430, "val_range" },
    { 0x0D1DF9C1, "valid" },
    { 0x5B99056E, "valid_ai" },
    { 0x76B379AC, "valid_barriers" },
    { 0x17EFDC89, "valid_count" },
    { 0x29752B2B, "valid_drop" },
    { 0xD2D626DC, "valid_enemies" },
    { 0x911AEECC, "valid_escapes" },
    { 0x150CBB51, "valid_location" },
    { 0x4BF9B6D1, "valid_locs" },
    { 0xB0AB5C69, "valid_move_command" },
    { 0xCA441239, "valid_navmesh_positions" },
    { 0x8EA05FF1, "valid_path" },
    { 0xDE7B0813, "valid_player" },
    { 0x0AE31303, "valid_player_count" },
    { 0x4F0BBF42, "valid_player_found" },
    { 0x16FAD654, "valid_player_in_ghost_zone_count" },
    { 0xDA3085B6, "valid_player_num" },
    { 0x15C5BE42, "valid_players" },
    { 0xB0B2D344, "valid_players_in_screecher_zone" },
    { 0x5A9A4CAC, "valid_players_teleport" },
    { 0xE3CDABA8, "valid_poi" },
    { 0xB71C9732, "valid_poi_half_height" },
    { 0xE8CC5686, "valid_poi_height" },
    { 0xE46499BB, "valid_poi_inner_spacing" },
    { 0x3E4789E0, "valid_poi_max_radius" },
    { 0xB5BDBF6B, "valid_poi_radius_from_edges" },
    { 0xD0C62386, "valid_point" },
    { 0x5FE673C2, "valid_pos" },
    { 0x9AD1C414, "valid_powerup_location_callback" },
    { 0x3A2F35C4, "valid_radios" },
    { 0x62F44123, "valid_range" },
    { 0x2836467A, "valid_range_sq" },
    { 0x2229DA09, "valid_spaces" },
    { 0x80DD5C27, "valid_struct" },
    { 0xA8AB4400, "valid_structs_medium" },
    { 0x0546E90F, "valid_target" },
    { 0x59A89EE8, "valid_target_func" },
    { 0x64699DD6, "valid_targets" },
    { 0x543E79DB, "valid_targets_only" },
    { 0x9C3F07A7, "valid_team" },
    { 0xC9B1C54C, "valid_type" },
    { 0x9BDA01D0, "valid_weapon" },
    { 0xB80167F1, "valid_zones" },
    { 0x1AF83DC1, "validangles" },
    { 0x7CBF3F23, "validate" },
    { 0x97D7CAE0, "validate_and_set_no_target_position" },
    { 0xCC6A283E, "validate_crate_type" },
    { 0x2C3BA753, "validate_enemy_path_length" },
    { 0xD537A136, "validate_info" },
    { 0x0F1AAF3A, "validate_input" },
    { 0x172CAA98, "validate_on_navmesh" },
    { 0x37241756, "validate_poi_attractors" },
    { 0x13FCF9F0, "validatejuke" },
    { 0x98465929, "validatekillstreak" },
    { 0x619F2533, "validateperk" },
    { 0xE3647968, "validateperkgroup" },
    { 0x0A3A8512, "validates" },
    { 0x0E4776D0, "validation" },
    { 0xB4A5EF9D, "validation_func" },
    { 0x387AE360, "validattacker" },
    { 0xDBF2530B, "validattackers" },
    { 0xF75FE0F1, "validconnection" },
    { 0xE4F21A8B, "validdamagecause" },
    { 0xCAB270CC, "validdamagezone" },
    { 0x18E84CEE, "valide" },
    { 0xDD8C0B07, "validenemies" },
    { 0x0526BC7E, "validenemyarray" },
    { 0xD67B28B0, "validentities" },
    { 0x09864279, "valideventfound" },
    { 0xFE7719FA, "validextendedspawns" },
    { 0xC43AF4EE, "validgroupnum" },
    { 0x2CAE0881, "validhitlocation" },
    { 0xF7F372D5, "validindicies" },
    { 0x7FDA7937, "validity" },
    { 0x0D461962, "validity_check" },
    { 0xD87DF2A0, "validity_func" },
    { 0xDC5061FD, "validjukedirection" },
    { 0x2D539D67, "validlocations" },
    { 0x1C18B3B9, "validlocationsound" },
    { 0x0C94BDA8, "validmodel" },
    { 0xA1C3A295, "validnextstate" },
    { 0x9925522F, "validnormals" },
    { 0xD6CDD100, "validperks" },
    { 0xCC8374C1, "validplayers" },
    { 0x728F96E3, "validpositions" },
    { 0x8CFF9CFB, "validsoundcause" },
    { 0xE3D51D15, "validspawns" },
    { 0x92D7096C, "validsquads" },
    { 0x985D01F4, "validstate" },
    { 0x5F311991, "validsubstrings" },
    { 0x3515F333, "validtarget_radius" },
    { 0x36A66A95, "validtargets" },
    { 0x193F6071, "validtostate" },
    { 0x5E93295F, "validtransitions" },
    { 0xD19564F9, "validtype" },
    { 0x3EB69DC3, "validvalues" },
    { 0x493E0578, "validweapons" },
    { 0x6CC86798, "valley" },
    { 0x5628F7BD, "vals" },
    { 0x60F41EFC, "valstep" },
    { 0x23BF5CAB, "valstr" },
    { 0x30B37F75, "valstring" },
    { 0x9368BA0C, "value" },
    { 0x60564EFD, "value1" },
    { 0x8658C966, "value2" },
    { 0xA2EAE881, "value_func" },
    { 0x31ACA08E, "value_name" },
    { 0x7061B539, "value_with_default" },
    { 0xD86F9FDB, "valuearray" },
    { 0xC183AA20, "valued" },
    { 0x64562BC1, "valueiswithin" },
    { 0xB453DEED, "valuename" },
    { 0x852DEDFF, "valueparam" },
    { 0x2BBCA98F, "values" },
    { 0xCC19AB84, "valuetoadd" },
    { 0x23F6C97D, "valve" },
    { 0x87033197, "valve_hint_north" },
    { 0xC1C9F865, "valve_hint_south" },
    { 0x9EC88EA1, "valve_trigs" },
    { 0xC8EEB43C, "valves" },
    { 0x4B9619E1, "vampire" },
    { 0x92716ED2, "vampire_degen_rate" },
    { 0x140264F3, "vampire_end" },
    { 0x78C5D8AC, "vampire_health_regen" },
    { 0x224050F4, "vampire_kill" },
    { 0xA1C0395B, "vampire_main" },
    { 0xC26DAF79, "vampire_regen_damage" },
    { 0x4F933A9C, "vampire_regen_health" },
    { 0x2097B13E, "vampire_regen_kill" },
    { 0x7C250521, "vampirism" },
    { 0xE9C35960, "van" },
    { 0x14140C83, "van_audio" },
    { 0x35B53746, "van_crash_sync" },
    { 0xBC17C687, "van_damage_override" },
    { 0xD6746A82, "van_door_close" },
    { 0xF748530A, "van_ending" },
    { 0xAEB02665, "van_entrance_timeout" },
    { 0x5BB0F351, "van_fx" },
    { 0x61423143, "van_guys" },
    { 0x109C1F03, "van_incoming" },
    { 0x721B3625, "van_out" },
    { 0xCA757DEF, "van_push" },
    { 0x5B6823B9, "van_roadblock_behavior" },
    { 0xC72678D5, "van_start" },
    { 0xF800F3A2, "van_stopped" },
    { 0x210638F8, "van_struct" },
    { 0x28E6581F, "vang" },
    { 0x41C86781, "vangles" },
    { 0xC847FC06, "vanguards" },
    { 0x21E02720, "vanish" },
    { 0xEA082BB8, "vanishing" },
    { 0x32945EDA, "vanishingpoint" },
    { 0x64FA0A01, "vanquished" },
    { 0xF104150B, "vans" },
    { 0x554E6C6D, "vantage" },
    { 0x08C0C10A, "vanya" },
    { 0x1208BCDC, "var" },
    { 0x454CD50D, "var1" },
    { 0x6B4F4F76, "var2" },
    { 0x9151C9DF, "var3" },
    { 0x87407100, "var4" },
    { 0xAD42EB69, "var5" },
    { 0x09533AED, "var_counter" },
    { 0xD45C761E, "var_name" },
    { 0x66026A81, "var_names" },
    { 0x7A9D3CE0, "vararg" },
    { 0x154F5599, "variable" },
    { 0xE347CF7D, "variable_offset" },
    { 0x06064B4B, "variable_offset_time" },
    { 0xF28506BA, "variable_offset_z" },
    { 0xD3534450, "variables" },
    { 0x0EEDDAB0, "variance" },
    { 0xA6216360, "variant" },
    { 0xAC6A43F9, "variant1" },
    { 0xC02F0E84, "variant1_order" },
    { 0xD3EEADA5, "variant1_order1" },
    { 0xF9F1280E, "variant1_order2" },
    { 0x1FF3A277, "variant1_order3" },
    { 0x15E24998, "variant1_order4" },
    { 0x3BE4C401, "variant1_order5" },
    { 0x61E73E6A, "variant1_order6" },
    { 0xD26CBE62, "variant2" },
    { 0x1AA27AB7, "variant2_order" },
    { 0x9F3BA75C, "variant2_order1" },
    { 0x11431697, "variant2_order2" },
    { 0xEB409C2E, "variant2_order3" },
    { 0x2D343821, "variant2_order4" },
    { 0x0731BDB8, "variant2_order5" },
    { 0x79392CF3, "variant2_order6" },
    { 0x1E71B334, "variant4" },
    { 0xC08A7231, "variant4_order" },
    { 0xC4C7A22A, "variant4_order1" },
    { 0x9EC527C1, "variant4_order2" },
    { 0x78C2AD58, "variant4_order3" },
    { 0x82D40637, "variant4_order4" },
    { 0x5CD18BCE, "variant4_order5" },
    { 0x36CF1165, "variant4_order6" },
    { 0x44742D9D, "variant5" },
    { 0x338F6EB8, "variant5_order" },
    { 0xA8A61F81, "variant5_order1" },
    { 0xCEA899EA, "variant5_order2" },
    { 0xF4AB1453, "variant5_order3" },
    { 0x1AAD8EBC, "variant5_order4" },
    { 0x40B00925, "variant5_order5" },
    { 0x66B2838E, "variant5_order6" },
    { 0x6E499A36, "variant_count_array" },
    { 0xB5807004, "variant_limit" },
    { 0x8368BD71, "variant_num" },
    { 0x446D2D60, "variant_string" },
    { 0xFF73487F, "variant_type" },
    { 0x790DD30B, "variants" },
    { 0x99BBF564, "variation" },
    { 0xC3A40A70, "variation_count" },
    { 0x7A004997, "variations" },
    { 0x106B110C, "varient" },
    { 0x5107BE66, "varient2" },
    { 0x6CF8DFF0, "varient4" },
    { 0x5ACAFEDD, "varies" },
    { 0x44B7AA87, "variety" },
    { 0x70961F04, "various" },
    { 0x08484C2D, "varius" },
    { 0x1ACB4899, "varnameprefix" },
    { 0x11F0641F, "vars" },
    { 0xB3B708DF, "varwait" },
    { 0xF5FF4295, "vary" },
    { 0x35167A93, "varying" },
    { 0xC3D8D47A, "vasquez" },
    { 0xD385F7A3, "vasquez_in_pos" },
    { 0xA2EDC186, "vattackerorigin" },
    { 0x385166ED, "vaules" },
    { 0xF8E69CFB, "vault" },
    { 0xB16B5714, "vault_breach_think" },
    { 0x613F0AE7, "vault_door_l" },
    { 0xAD43FFB9, "vault_door_r" },
    { 0xF3A32065, "vault_doors" },
    { 0x77E98AF2, "vault_doors_dialogue" },
    { 0x0591DC10, "vault_doors_open" },
    { 0x918C6003, "vault_doors_team_ready" },
    { 0xF1104B0B, "vault_hall_walk_lighting_test" },
    { 0x493C2283, "vault_over_pipe" },
    { 0x797655E5, "vault_wait" },
    { 0xF0214E26, "vaultdoors_grigsby" },
    { 0xC7BF2112, "vaultdoors_player" },
    { 0x8D130B60, "vaultdoors_price" },
    { 0x52F60B9A, "vaults" },
    { 0x257F2738, "vc" },
    { 0xDF031698, "vc0" },
    { 0x05059101, "vc1" },
    { 0x48EAEB23, "vc10" },
    { 0x2B080B6A, "vc2" },
    { 0x510A85D3, "vc3" },
    { 0x770D003C, "vc4" },
    { 0x9D0F7AA5, "vc5" },
    { 0xC311F50E, "vc6" },
    { 0xE9146F77, "vc7" },
    { 0xC844A0C4, "vc_1" },
    { 0x3A4C0FFF, "vc_2" },
    { 0x14499596, "vc_3" },
    { 0x95335377, "vc_ai_array" },
    { 0x0112F6C4, "vc_ai_array_2" },
    { 0x1CF8EBA4, "vc_ak47" },
    { 0x163967F2, "vc_ambient_boat_movement" },
    { 0x42EBC453, "vc_ambush_break" },
    { 0x3A129A92, "vc_ambush_think" },
    { 0xAC5E5F31, "vc_ambushers" },
    { 0xEC88BDCB, "vc_anims" },
    { 0xABDBA126, "vc_appear_setup" },
    { 0x67EAEBF7, "vc_attack" },
    { 0x9C1CA5E2, "vc_attack_player_relentlessly" },
    { 0xE90425A5, "vc_attacks_snapshot" },
    { 0x33099405, "vc_awning_attacker" },
    { 0xC0286B76, "vc_boat_moving_loops" },
    { 0x9A31FB14, "vc_boat_moving_vox" },
    { 0x36A9395C, "vc_bridge_1" },
    { 0xA8B0A897, "vc_bridge_2" },
    { 0xF9A098B6, "vc_catwalk" },
    { 0xEE727EF7, "vc_chef_1" },
    { 0x7C6B0FBC, "vc_chef_2" },
    { 0x76A20C31, "vc_counterattack" },
    { 0xD05FEBE7, "vc_death" },
    { 0x289B905C, "vc_drop_water" },
    { 0x08A3CDE8, "vc_flashlight_combat_behavior_close" },
    { 0x2C2642EB, "vc_flashlight_combat_behavior_off" },
    { 0xA538F917, "vc_flashlight_combat_behavior_on" },
    { 0xDDE25DEB, "vc_guys" },
    { 0x6D053E1A, "vc_hut_1" },
    { 0x4702C3B1, "vc_hut_2" },
    { 0xB19A4C46, "vc_hut_drop" },
    { 0x15981E58, "vc_intro_actors" },
    { 0x6187C761, "vc_jump_out_attack_1" },
    { 0x878A41CA, "vc_jump_out_attack_2" },
    { 0xE29FB4A9, "vc_line_6_flavor" },
    { 0x1D6F2BBE, "vc_look_out_window" },
    { 0x04D9B6E2, "vc_lookout_in_position" },
    { 0xFF0BF49B, "vc_mg_gunner" },
    { 0x430A5271, "vc_not_looking_out" },
    { 0x36AC08A9, "vc_on_boat" },
    { 0x60505B20, "vc_rice" },
    { 0xF7C76657, "vc_rice_bowl" },
    { 0x23590542, "vc_rice_chopstick1" },
    { 0xFD568AD9, "vc_rice_chopstick2" },
    { 0xBBF83B5B, "vc_roof_doors" },
    { 0x8A666B1B, "vc_room_1_think_1" },
    { 0x185EFBE0, "vc_room_1_think_2" },
    { 0xA6C86462, "vc_room_1_think_2_strafe" },
    { 0xEE643E5B, "vc_room_1_think_special" },
    { 0x4AEBDE00, "vc_room_2_think" },
    { 0xEC5D89DA, "vc_rott" },
    { 0xB8871729, "vc_sampan" },
    { 0xA8A323DD, "vc_sampan_1" },
    { 0xCEA59E46, "vc_sampan_2" },
    { 0x4B8849CC, "vc_sleeping_1" },
    { 0xBD8FB907, "vc_sleeping_2" },
    { 0x9C807DAC, "vc_snipe_1" },
    { 0x0E87ECE7, "vc_snipe_2" },
    { 0xE885727E, "vc_snipe_3" },
    { 0xE5240411, "vc_snoring_1" },
    { 0x0B267E7A, "vc_snoring_2" },
    { 0x105EFBCD, "vc_spawner" },
    { 0x56240BB1, "vc_stealth_kill_ignoreall" },
    { 0xAD1535D1, "vc_stealth_kill_sleeping_1" },
    { 0xD317B03A, "vc_stealth_kill_sleeping_2" },
    { 0x48DBB7AC, "vc_stealth_killed" },
    { 0x319FDA30, "vc_tree_hugger" },
    { 0x5A486A88, "vc_truck" },
    { 0x6592D3F4, "vc_tunnel_split_path_1_right3" },
    { 0xBE5758E2, "vc_window_shooter" },
    { 0x64CC65AF, "vc_with_rpg" },
    { 0x243F5031, "vca" },
    { 0x9646BF6C, "vcd" },
    { 0xE24BB43E, "vcf" },
    { 0xC18D6277, "vclass" },
    { 0x4AC68569, "vclogin_vehicles" },
    { 0x84B737E9, "vconedir" },
    { 0xD06BEB93, "vcs" },
    { 0xEABF2A3D, "vcs_killed" },
    { 0xD185FFDB, "vcs_ridge" },
    { 0x48EBAE2E, "vcs_trigger" },
    { 0x462B0BB3, "vdamagedir" },
    { 0x6EB5FC54, "vdamageorigin" },
    { 0xE8BB43EE, "vdir" },
    { 0xD3CA3E9C, "vdirection" },
    { 0x141FAD01, "vdist" },
    { 0x4AA284C9, "vdistmax" },
    { 0x62313066, "vdominantdir" },
    { 0x077D9922, "vdot" },
    { 0x098E05AE, "ve" },
    { 0xD2412961, "vec" },
    { 0x0B26902F, "vec0_val0_specular" },
    { 0xA0EC79A1, "vec0_val1_dummy" },
    { 0x576CF50A, "vec0_val2_char" },
    { 0x4B3FAEAF, "vec0_val3_dummy" },
    { 0x171AB59A, "vec1" },
    { 0xF1183B31, "vec2" },
    { 0xCB15C0C8, "vec3" },
    { 0xEE988E5E, "vec3mad" },
    { 0xBB7EC3E4, "vec_approx_equals" },
    { 0x49B0D93F, "vec_backward" },
    { 0x8E17BA21, "vec_barricade" },
    { 0xE2E40379, "vec_black_hole_org" },
    { 0x54FBDC8D, "vec_dif" },
    { 0x3B434EE7, "vec_direction" },
    { 0x0ACC2589, "vec_dot" },
    { 0xC82EEC73, "vec_end" },
    { 0x1F89B090, "vec_end_pos" },
    { 0x7EB3D0A0, "vec_enemy" },
    { 0x59FCC393, "vec_enemy_to_node" },
    { 0xBDE0898F, "vec_enemy_to_point" },
    { 0x8571B319, "vec_enemy_to_self" },
    { 0x075BCABD, "vec_explosion_offset" },
    { 0x37C2D53A, "vec_explosion_origin" },
    { 0x48A29E22, "vec_facing" },
    { 0x7F39B8A3, "vec_forward" },
    { 0xB5A97B2C, "vec_from_target" },
    { 0x28648306, "vec_front_point" },
    { 0xCD543D15, "vec_goal" },
    { 0x7BFF6340, "vec_inc" },
    { 0x9D7B1C06, "vec_jolt_origin" },
    { 0x91612FB0, "vec_mortar_pos" },
    { 0x9E0BE353, "vec_movement" },
    { 0x39A302D5, "vec_offset" },
    { 0xF0BFF742, "vec_origin" },
    { 0x5D14D8FF, "vec_player_horse_forward" },
    { 0x75DE5F5E, "vec_player_horse_right" },
    { 0x56747AFD, "vec_player_look_forward" },
    { 0xA7F7C590, "vec_player_look_right" },
    { 0xA2D85F66, "vec_point" },
    { 0x6462ECFD, "vec_position" },
    { 0xA538BD8B, "vec_predict" },
    { 0xCAB7ECC2, "vec_right" },
    { 0x5A03A01B, "vec_sampledelay" },
    { 0x5F818E32, "vec_scale" },
    { 0xDA3E5507, "vec_self_goal_pos" },
    { 0x48D605C1, "vec_set_x" },
    { 0x22D38B58, "vec_set_y" },
    { 0x94DAFA93, "vec_set_z" },
    { 0xB2AF1BAC, "vec_spot" },
    { 0xDA9086A0, "vec_start" },
    { 0xC9C6D471, "vec_str" },
    { 0xF0740B37, "vec_tag_flash" },
    { 0x80A63824, "vec_to_ally" },
    { 0x40EC5627, "vec_to_attacker" },
    { 0xEDDBE47E, "vec_to_corpse" },
    { 0x8B966DC4, "vec_to_crash_zone" },
    { 0x65AAB911, "vec_to_end" },
    { 0x21121E26, "vec_to_enemy" },
    { 0x99BF23F0, "vec_to_enemy_normal" },
    { 0xAFA1784E, "vec_to_friend" },
    { 0xBB78C935, "vec_to_player" },
    { 0x4F0ABC47, "vec_to_player_end" },
    { 0x265F7A9E, "vec_to_pt" },
    { 0xE7ADBF0D, "vec_to_target" },
    { 0xA5817B4E, "vec_toforward" },
    { 0xAD9EFE18, "vec_tomissileforward" },
    { 0xD3B39FDF, "vec_toright" },
    { 0xE5BDD80B, "vec_variation" },
    { 0x28734B5C, "vec_woods_goal" },
    { 0x42BA58B0, "vecarray" },
    { 0xFAE4A224, "vecarrayindex" },
    { 0xA6A0B668, "veccomp" },
    { 0x04CCC882, "vecdot" },
    { 0x4F234DA0, "vecforward" },
    { 0xD76D3ED5, "vechicles" },
    { 0xB6CC7329, "veclength" },
    { 0xD6C80D1D, "vecright" },
    { 0x4BB45B08, "vecs" },
    { 0x854418C9, "vecscale" },
    { 0x55C5B3E7, "vect" },
    { 0x7815DB60, "vect_to_enemy" },
    { 0xC7BCFC11, "vect_to_enemy_2d" },
    { 0x8ACFA502, "vecto" },
    { 0x7D6CAC0E, "vectoangles" },
    { 0xCE5E4ABE, "vectoenemy" },
    { 0x631AA0D6, "vectomissile" },
    { 0x21402BCB, "vectoowner" },
    { 0x036672E3, "vectoplayerlocfromorigin" },
    { 0xEB9DBCD8, "vectopoint" },
    { 0x9B0373E4, "vector" },
    { 0xA9A84BF1, "vector3d" },
    { 0x1A821698, "vector3d_angle_between" },
    { 0xDB513A0E, "vector3d_component_of_a_along_b" },
    { 0x4DDD33C0, "vector3d_cross_product" },
    { 0x22C2EFD1, "vector3d_dot_product" },
    { 0x41FBC97E, "vector3d_from_points" },
    { 0x9AAA160C, "vector3d_is_normalized" },
    { 0xB702326D, "vector3d_is_zero" },
    { 0x53E9178E, "vector3d_magnitude" },
    { 0x8783E7EC, "vector3d_magnitude_squared" },
    { 0x769A0FF5, "vector3d_normalize" },
    { 0x040F3E41, "vector3d_orthogonal" },
    { 0xD3BAC7E1, "vector3d_parallel" },
    { 0xF4C7A082, "vector3d_scale" },
    { 0x05B5BD08, "vector_a" },
    { 0x77BD2C43, "vector_b" },
    { 0x45BA23B5, "vector_changed" },
    { 0x9DA2E798, "vector_compare" },
    { 0xD6986148, "vector_dir" },
    { 0xBBE906EC, "vector_divide" },
    { 0x2A617622, "vector_forward" },
    { 0x3552FA43, "vector_length" },
    { 0x55846C09, "vector_line" },
    { 0x948624B3, "vector_multiply" },
    { 0x74E6BF87, "vector_scale" },
    { 0xE98CD438, "vector_scale_2d" },
    { 0xAF1BFF4F, "vector_switch" },
    { 0x3E04C2CA, "vector_to_attacker" },
    { 0xB3825100, "vector_to_player" },
    { 0x18356F89, "vector_to_player_boat" },
    { 0xE8663043, "vector_to_point" },
    { 0x1AE6AF28, "vector_to_string" },
    { 0x136AE158, "vector_to_target" },
    { 0xD5E59FE7, "vector_towards_target" },
    { 0xF1EF0F55, "vectorangle" },
    { 0x2E582ECC, "vectorcross" },
    { 0xAC44686D, "vectordif" },
    { 0x5F9A4869, "vectordot" },
    { 0x5C5EF5E9, "vectorflat" },
    { 0xECB12B18, "vectorfromenemy" },
    { 0x4A12C219, "vectorfromlinetopoint" },
    { 0x2049593F, "vectorlerp" },
    { 0x7BF16FC5, "vectorname" },
    { 0xF679A325, "vectornormalize" },
    { 0x13422F93, "vectorprojection" },
    { 0xFD8C6D17, "vectors" },
    { 0xDC604012, "vectorscale" },
    { 0x85035408, "vectortoangle" },
    { 0xBDCDC423, "vectortoangles" },
    { 0x736F7871, "vectortoenemy" },
    { 0xBAA834D1, "vectortoenemyangles" },
    { 0x314E4414, "vectortolookpos" },
    { 0x1B3C88BE, "vectortoshootpos" },
    { 0xDF235BEA, "vectortostarttime" },
    { 0x5BECC98C, "vectortostoptime" },
    { 0xB03F0D68, "vectortostring" },
    { 0xF0C96E98, "vectortotarget" },
    { 0x83D66FBB, "vectortowardsothervector" },
    { 0xD8939F62, "vectostart" },
    { 0xA10610BB, "vectostr" },
    { 0x470445A5, "vectotarget" },
    { 0x4D67F091, "vectotoangles" },
    { 0x4E2BDACA, "vecup" },
    { 0x8DA7F6FB, "vecx" },
    { 0x67A57C92, "vecy" },
    { 0x41A30229, "vecz" },
    { 0xF464BA2E, "veers" },
    { 0x1D75C58E, "vees" },
    { 0xF1A12234, "vegetations" },
    { 0xC82FD082, "veh" },
    { 0xAA0BF202, "veh_activated" },
    { 0xB31B7B0F, "veh_ang" },
    { 0x73CA0258, "veh_anim_80s_hatchback_door_open" },
    { 0xBD0A9D98, "veh_anim_80s_van_rear_doors_open" },
    { 0xD5DD19A9, "veh_anim_future_heli_bay_closed" },
    { 0x003628F9, "veh_anim_future_heli_bay_open" },
    { 0xE5746243, "veh_anim_future_heli_geardown" },
    { 0xC38394B1, "veh_anim_mig23_wings_open" },
    { 0x07AB1095, "veh_anim_pak_train_boxcar_doors_open" },
    { 0xB583D705, "veh_anim_pickup_hood_open" },
    { 0xBFE7122F, "veh_anim_v78_vtol_engine_left" },
    { 0x526FAC8A, "veh_anim_v78_vtol_engine_right" },
    { 0x24A52A31, "veh_animate_pickup_cars" },
    { 0x03C67CDC, "veh_animate_pickup_trucks" },
    { 0x5589532B, "veh_asd" },
    { 0x5BBB57ED, "veh_blackhawk" },
    { 0x97A4589A, "veh_boost" },
    { 0x494CEA58, "veh_brake_unload" },
    { 0x3039DF2D, "veh_buffel" },
    { 0xD1A0E5BE, "veh_buffel1" },
    { 0xAB9E6B55, "veh_buffel2" },
    { 0x74706433, "veh_buffer" },
    { 0xDF0311D1, "veh_car" },
    { 0xB9836BAF, "veh_chicken_watcher" },
    { 0x59CFE750, "veh_claw" },
    { 0x1B9960B7, "veh_collision" },
    { 0xB244914F, "veh_convoy" },
    { 0x3A72BAEE, "veh_cougar" },
    { 0x2AC170D1, "veh_cougar3" },
    { 0x18BD37FB, "veh_crashed_vtol" },
    { 0xE4C691A2, "veh_deathwatch" },
    { 0x5E99906B, "veh_destructible_headlights" },
    { 0x77B6C095, "veh_done" },
    { 0x074AFF75, "veh_drone" },
    { 0x2A355156, "veh_drone1" },
    { 0x0432D6ED, "veh_drone2" },
    { 0xDE305C84, "veh_drone3" },
    { 0xB82DE21B, "veh_drone4" },
    { 0x8E4731A2, "veh_drone_best" },
    { 0xE05E98B4, "veh_ejectoccupants" },
    { 0x80520761, "veh_engine_stutter" },
    { 0x7C07FD78, "veh_ent" },
    { 0x9380C381, "veh_f35" },
    { 0xD5745F74, "veh_f38" },
    { 0x5426D513, "veh_fa38" },
    { 0x29EBA7CD, "veh_gaz" },
    { 0x051E53DE, "veh_gaz1" },
    { 0x9E79238C, "veh_heightmesh_max" },
    { 0xDBDD2EA2, "veh_heightmesh_min" },
    { 0x9B7539C9, "veh_heli" },
    { 0x3C108952, "veh_heli1" },
    { 0x4DFE44DF, "veh_heli_killed" },
    { 0xB150650A, "veh_heli_turret" },
    { 0xA2719BC3, "veh_hudson_heli" },
    { 0x0F97C3F1, "veh_husk_effects" },
    { 0x16BC4847, "veh_husk_models" },
    { 0xB42CA59E, "veh_idgun_allow_damage" },
    { 0xCDD5AF2C, "veh_idgun_crush_dist_sqr" },
    { 0x35B681B8, "veh_idgun_move_speed" },
    { 0xE4201124, "veh_inair" },
    { 0x32AE4445, "veh_landed" },
    { 0xEF19772F, "veh_magic_bullet_shield" },
    { 0x4BB8B155, "veh_metalstorm" },
    { 0x7CC0D6D0, "veh_name" },
    { 0x1D6C0B41, "veh_node" },
    { 0xDC931365, "veh_org" },
    { 0x78344ACA, "veh_owner" },
    { 0xCC7519CF, "veh_plane_flyable" },
    { 0x02A6608E, "veh_player" },
    { 0xB5EF64A2, "veh_player_cougar" },
    { 0x6F37607A, "veh_player_vtol" },
    { 0x4ED1671F, "veh_pre_speech_vtol" },
    { 0xE6F10ACD, "veh_predictedcollision" },
    { 0x58BD5602, "veh_qrotor" },
    { 0x4237222B, "veh_removed" },
    { 0x0DE956BB, "veh_rider_ragdoll_delay" },
    { 0x5D9524EB, "veh_river_b01_dropoff_chin_01" },
    { 0xEB8DB5B0, "veh_river_b01_dropoff_chin_02" },
    { 0x11903019, "veh_river_b01_dropoff_chin_03" },
    { 0x697AFC4D, "veh_river_b01_dropoff_pbr_01" },
    { 0x8F7D76B6, "veh_river_b01_dropoff_pbr_02" },
    { 0xA728E1DF, "veh_roof_sam" },
    { 0x6DF9999B, "veh_spawn_trig" },
    { 0x6CA02EDB, "veh_spawner" },
    { 0xF8E744AD, "veh_spawner_id" },
    { 0x390C75C4, "veh_speed_match" },
    { 0xC33EC522, "veh_stop_at_node" },
    { 0x2ED697D3, "veh_stuck" },
    { 0xF501256E, "veh_suspension_limit_activated" },
    { 0xB9ECF59D, "veh_tank" },
    { 0x1031CCD7, "veh_targetname" },
    { 0x9D14A429, "veh_throttle" },
    { 0xD4AE2D89, "veh_to_black_hole_dist_sqr" },
    { 0xB97403F0, "veh_to_black_hole_vec" },
    { 0x116090A3, "veh_toggle_exhaust_fx" },
    { 0x36BA5E2F, "veh_toggle_lights" },
    { 0xD4381C51, "veh_toggle_tread_fx" },
    { 0xE4933B4F, "veh_turret" },
    { 0xB8C798A9, "veh_type" },
    { 0x6D8DBCAE, "veh_vtol" },
    { 0x67B50CE1, "veh_weapon" },
    { 0x0FFAA44F, "vehaircraftcollisionenabled" },
    { 0x4246BC05, "vehcansee" },
    { 0x935C3A4A, "vehcheckforpredictedcrash" },
    { 0x51F4B717, "vehcile" },
    { 0x0B59942B, "vehclearentitytarget" },
    { 0xAAFC8CD9, "vehdontejectoccupantsondeath" },
    { 0x1F6808B9, "vehforcematerialspeed" },
    { 0x031C3C12, "vehfovcosine" },
    { 0x229D1289, "vehfovcosinebusy" },
    { 0x15B74E5D, "vehgetmodel" },
    { 0x466D8720, "vehgetpredictedyawtoenemy" },
    { 0x4FF1843A, "vehgoalentity" },
    { 0x4502A76B, "vehgroup" },
    { 0x80765564, "vehhelicopter_currentspeed" },
    { 0x6B6021B6, "vehhelicopter_getspeedtime" },
    { 0xF562FABC, "vehhelicopter_oldspeed" },
    { 0x0743822F, "vehhelicopter_oldspeedtime" },
    { 0x1ED798D5, "vehhighlyawareradius" },
    { 0x56385906, "vehical_depot" },
    { 0xBA5E68B6, "vehicl" },
    { 0x96FA87AF, "vehicle" },
    { 0x14EA2A64, "vehicle1" },
    { 0x86F1999F, "vehicle2" },
    { 0xCD789BAF, "vehicle_80s_hatch1" },
    { 0xEBEBA1C6, "vehicle_80s_hatch1_lowres" },
    { 0xDF5A69BF, "vehicle_80s_hatch1_thermal" },
    { 0x5B712C74, "vehicle_80s_hatch2" },
    { 0xCCE972AB, "vehicle_80s_hatch2_lowres" },
    { 0xEBF739F4, "vehicle_80s_hatch2_thermal" },
    { 0x2C6F4F96, "vehicle_80s_sedan1" },
    { 0xC7EC1976, "vehicle_80s_sedan1_brn_destructible" },
    { 0x67E8DCF5, "vehicle_80s_sedan1_lowres" },
    { 0x5D11848D, "vehicle_80s_sedan1_lowres_red" },
    { 0xE1DE85D0, "vehicle_80s_sedan1_nofire" },
    { 0x429B4944, "vehicle_80s_sedan1_side" },
    { 0xA71AEBBE, "vehicle_80s_sedan1_thermal" },
    { 0xC2984AD5, "vehicle_80s_wagon1" },
    { 0x1D6A2B14, "vehicle_80s_wagon1_lowres" },
    { 0x1F0A8709, "vehicle_80s_wagon1_nofire" },
    { 0xC7D2B8B5, "vehicle_80s_wagon1_thermal" },
    { 0x44E2076F, "vehicle_abandoned_by_drift_t" },
    { 0x345AA636, "vehicle_abandoned_by_occupants_t" },
    { 0x38CFCF2A, "vehicle_abandoned_by_occupants_timeout_t" },
    { 0x76013C83, "vehicle_about_to_spawn" },
    { 0xFB221867, "vehicle_achievement_count" },
    { 0xBD00021A, "vehicle_acquire_target" },
    { 0xD308FD42, "vehicle_add_loadfx_callback" },
    { 0x3C647131, "vehicle_add_main_callback" },
    { 0x72EE5DA4, "vehicle_ai" },
    { 0xF1020036, "vehicle_ai_killspawner_triggers_think" },
    { 0x3986E75D, "vehicle_ai_movement_triggers_think" },
    { 0x218ECF48, "vehicle_ai_shared" },
    { 0x5552E673, "vehicle_aianim" },
    { 0x26D683F9, "vehicle_aianimcheck" },
    { 0x0AFA3522, "vehicle_aianims" },
    { 0x53E31BFF, "vehicle_aianimthread" },
    { 0x8F95D48E, "vehicle_aim_turret_at_angle" },
    { 0x52FBA2FD, "vehicle_aimdown" },
    { 0x4FE89E52, "vehicle_aimup" },
    { 0x6C322F0E, "vehicle_airwatcher" },
    { 0x4E3DC1C2, "vehicle_alternate_path" },
    { 0xD36CBCE5, "vehicle_anim" },
    { 0x3A8E3F4E, "vehicle_anim_init" },
    { 0x426ACC2F, "vehicle_animate" },
    { 0x373A239A, "vehicle_animated_seaknight_land" },
    { 0x30C7FA2C, "vehicle_animname" },
    { 0x679CE0F4, "vehicle_anims" },
    { 0x565D3125, "vehicle_array" },
    { 0xA8C3E0D8, "vehicle_at_node" },
    { 0xCBB1D580, "vehicle_attachedmodels" },
    { 0x63E3ACB6, "vehicle_attractor" },
    { 0xDD34ACE2, "vehicle_attractor_damage" },
    { 0x0683CAF0, "vehicle_avoidance" },
    { 0xF5209BA0, "vehicle_badplace" },
    { 0xED93B0E2, "vehicle_badplacer" },
    { 0x65A51A1E, "vehicle_baseanim" },
    { 0xDF53FBCA, "vehicle_bm21" },
    { 0xFD5FF5E0, "vehicle_bmp_death_wait" },
    { 0xC6E1B6C5, "vehicle_bmp_setup" },
    { 0xECB1A122, "vehicle_bmp_think" },
    { 0xD1AB4B32, "vehicle_build" },
    { 0x3DC9FB62, "vehicle_buildable_trigger_think" },
    { 0x40821AFA, "vehicle_bullet_collisions" },
    { 0x99195D6D, "vehicle_bulletshield" },
    { 0x284641F9, "vehicle_bus_destructible" },
    { 0xED43FABA, "vehicle_c4_think" },
    { 0x7FA99233, "vehicle_callback" },
    { 0xF28A7256, "vehicle_camera_ang" },
    { 0xE927DA48, "vehicle_camera_fx" },
    { 0xFBAD6CB4, "vehicle_camera_pos" },
    { 0x78E66BB3, "vehicle_canned_seaknight_fx" },
    { 0xAA62321A, "vehicle_cleanup" },
    { 0xF490B59F, "vehicle_clear_corpses" },
    { 0x30DC9B8F, "vehicle_clear_truckjunk" },
    { 0x3F175661, "vehicle_clientinit" },
    { 0x18EE9A90, "vehicle_clientmain" },
    { 0x95E7D738, "vehicle_clip" },
    { 0x43C868C4, "vehicle_closemonitor" },
    { 0x82282736, "vehicle_cobra_attack_pattern_think" },
    { 0x351E4448, "vehicle_cobra_default_weapons_think" },
    { 0x66114E92, "vehicle_cobra_spawn_and_kill" },
    { 0xF7FCD5E8, "vehicle_cobra_think" },
    { 0xDC63C048, "vehicle_collision_slows_down_player" },
    { 0x7EF72DDF, "vehicle_collision_watcher" },
    { 0x57B73E9C, "vehicle_compass_types" },
    { 0x8A6FCCA4, "vehicle_compasshandle" },
    { 0xA06C132D, "vehicle_compassicon" },
    { 0xEF9D943C, "vehicle_connectpaths_wrapper" },
    { 0xD726778E, "vehicle_corpse" },
    { 0x80B4ADC7, "vehicle_count" },
    { 0xA36EC5BC, "vehicle_craftable_trigger_think" },
    { 0xE6EF0B89, "vehicle_crashpaths" },
    { 0xE7918171, "vehicle_damage" },
    { 0xD3543DA4, "vehicle_damage_callbacks" },
    { 0xBD6651DA, "vehicle_damage_filter" },
    { 0x7C15816B, "vehicle_damage_filter_damage_watcher" },
    { 0x6168B774, "vehicle_damage_filter_exit_watcher" },
    { 0x3AFAD1D5, "vehicle_damage_filters" },
    { 0xDED76FC6, "vehicle_damage_hints" },
    { 0xCDE5D14C, "vehicle_damage_override" },
    { 0xDF2E8EE8, "vehicle_damage_t" },
    { 0xB5929AE4, "vehicle_damage_think" },
    { 0xE57AB65B, "vehicle_damageset" },
    { 0x8276F484, "vehicle_death" },
    { 0xFC598A75, "vehicle_death_badplace" },
    { 0xDF251BDC, "vehicle_death_earthquake" },
    { 0xFDF84D0D, "vehicle_death_fx" },
    { 0xD0162B90, "vehicle_death_fx_override" },
    { 0x39E08F4E, "vehicle_death_jolt" },
    { 0x94087C62, "vehicle_death_radiusdamage" },
    { 0x3E6250E8, "vehicle_death_shared" },
    { 0xEB2B5745, "vehicle_death_think" },
    { 0xC2CA6DA7, "vehicle_death_thread" },
    { 0x5CDBFB1B, "vehicle_deathmodel" },
    { 0x7D0DBCFF, "vehicle_deathmodel_delay" },
    { 0x82FE4BDF, "vehicle_deathnotify" },
    { 0x96FF99C8, "vehicle_deathswitch" },
    { 0xA7A31B2B, "vehicle_debug" },
    { 0x33D35749, "vehicle_deckdust" },
    { 0x3BE61296, "vehicle_defense_cb" },
    { 0x37A0176B, "vehicle_delete" },
    { 0xEA34A8D3, "vehicle_delete_after_defend" },
    { 0x9500E43D, "vehicle_delete_at_end_of_path" },
    { 0xDCFD7422, "vehicle_delete_thread" },
    { 0x37715D40, "vehicle_deletegroup" },
    { 0x63988CF1, "vehicle_deleteme" },
    { 0xF8A84839, "vehicle_descriptor" },
    { 0xD8F7D070, "vehicle_descriptors" },
    { 0xE49E51D3, "vehicle_destroyed" },
    { 0xDCAA5132, "vehicle_detach_from_path_at_end" },
    { 0x19D6660E, "vehicle_detachfrompath" },
    { 0xB44CB3C5, "vehicle_detects_squad" },
    { 0x2293994B, "vehicle_detourpaths" },
    { 0xA9FF79C4, "vehicle_died" },
    { 0x8DA271E5, "vehicle_disconnect_paths" },
    { 0xC8AD1640, "vehicle_disconnectpaths_wrapper" },
    { 0xE539614D, "vehicle_downanim" },
    { 0x367320BF, "vehicle_drive_and_die_at_path_end" },
    { 0x7D95308C, "vehicle_driveidle" },
    { 0x15B6E52A, "vehicle_driveidle_animrate" },
    { 0xE93EED1A, "vehicle_driveidle_normal_speed" },
    { 0x9E936D2B, "vehicle_driveidle_r" },
    { 0x5EE71BA0, "vehicle_driver" },
    { 0x88CB5F62, "vehicle_drivers_are_invulnerable" },
    { 0x10F1A0FD, "vehicle_drop_single_flare" },
    { 0x1AC0E893, "vehicle_dropflare" },
    { 0x2479AA1B, "vehicle_duck_once" },
    { 0x249BF2F4, "vehicle_dump" },
    { 0x1B7E5355, "vehicle_dynamic_cover" },
    { 0x0ED8F964, "vehicle_dynamicpath" },
    { 0xCBD74BAC, "vehicle_eject_all_occupants" },
    { 0x245773C8, "vehicle_enemies_setup" },
    { 0xDFEEF477, "vehicle_enemies_with_drones_delete_on_unload" },
    { 0x3E759308, "vehicle_enemy_tanks" },
    { 0xB21F50D1, "vehicle_ent" },
    { 0xCAA71498, "vehicle_enter" },
    { 0x02360195, "vehicle_evasive_move" },
    { 0xCDB497B8, "vehicle_exhaust" },
    { 0x482A91D2, "vehicle_exit" },
    { 0x9E440043, "vehicle_explosion" },
    { 0x654C5E35, "vehicle_explosion_effect" },
    { 0xF87C11B7, "vehicle_explosion_launch" },
    { 0x9EE1674C, "vehicle_f35_player" },
    { 0x3782B9C0, "vehicle_filter_id" },
    { 0xDE137546, "vehicle_fire" },
    { 0x03DCE95A, "vehicle_fire_main_cannon" },
    { 0x7487CA4E, "vehicle_firedown" },
    { 0xBA0B49D6, "vehicle_fires_at_target_pool_then_dies" },
    { 0x9CFB954D, "vehicle_fireup" },
    { 0x8850C30B, "vehicle_fireweapon_t" },
    { 0x9767AB1C, "vehicle_flag_0_handler" },
    { 0xD16852E5, "vehicle_flag_1_handler" },
    { 0x7F7F632B, "vehicle_flag_3_handler" },
    { 0x314B7900, "vehicle_flag_4_handler" },
    { 0x48DBC7F2, "vehicle_flag_arrived" },
    { 0x4F49EF47, "vehicle_flag_change_exhaustfx_handler" },
    { 0x25999E8A, "vehicle_flag_change_handler" },
    { 0x36C1B2E9, "vehicle_flag_change_treadfx_handler" },
    { 0x9E9EDF16, "vehicle_flag_start_stop_rotor_fx" },
    { 0xE423AEA8, "vehicle_flag_start_use_engine_damage_high_sounds" },
    { 0x13F757DC, "vehicle_flag_start_use_engine_damage_low_sounds" },
    { 0x0B8B12CB, "vehicle_flag_switch_rotor_fx" },
    { 0x12C5889F, "vehicle_flag_toggle_exhaustfx_handler" },
    { 0x6390F823, "vehicle_flag_toggle_interior_lights_handler" },
    { 0x42A72030, "vehicle_flag_toggle_lights_handler" },
    { 0x6F75884D, "vehicle_flag_toggle_lockon_handler" },
    { 0x836F86F6, "vehicle_flag_toggle_siren_lights_handler" },
    { 0x1C6F7F76, "vehicle_flag_toggle_sounds" },
    { 0xF5CF52BF, "vehicle_flag_turn_off_treadfx" },
    { 0xB3DE769B, "vehicle_flags" },
    { 0xB4450CD4, "vehicle_free" },
    { 0x859EA44A, "vehicle_free_on_death_think" },
    { 0xA8B4C440, "vehicle_frontarmor" },
    { 0x89900E95, "vehicle_gatetrigger" },
    { 0x0DA5395F, "vehicle_get_damage_type_and_attacker" },
    { 0xA68971A0, "vehicle_get_occupant_team" },
    { 0xDEBF89DE, "vehicle_get_riders" },
    { 0x5D540F56, "vehicle_get_target" },
    { 0x679D0ADF, "vehicle_get_target_player_only" },
    { 0x6A34DAF3, "vehicle_getanimstart" },
    { 0x5A2473E0, "vehicle_getinanim" },
    { 0xAFCBE0DE, "vehicle_getinanim_clear" },
    { 0xCC08A50C, "vehicle_getinsound" },
    { 0x79C153A4, "vehicle_getinsoundtag" },
    { 0xC2C8471D, "vehicle_getinstart" },
    { 0xA68DC01A, "vehicle_getout" },
    { 0x3CB0FF45, "vehicle_getoutanim" },
    { 0xD5D9928F, "vehicle_getoutanim_clear" },
    { 0x9751A58D, "vehicle_getoutanim_pistol" },
    { 0x9DF7F287, "vehicle_getoutsound" },
    { 0x2C6E6101, "vehicle_getoutsoundtag" },
    { 0xED5CD0DE, "vehicle_getspawner" },
    { 0x98CBADA0, "vehicle_ghost_entering_occupants_t" },
    { 0xA3DFACD4, "vehicle_gib" },
    { 0x074F135C, "vehicle_gibs_death" },
    { 0xBE122D9B, "vehicle_givehealth" },
    { 0xF0338265, "vehicle_go_path_on_node" },
    { 0x66A4914E, "vehicle_go_to_end_and_delete" },
    { 0xC8D60DC3, "vehicle_goal" },
    { 0xC09177B2, "vehicle_goalradius_patrol" },
    { 0x46822B2A, "vehicle_gunner_fire" },
    { 0x40BE10DE, "vehicle_halftrack" },
    { 0xD3E5AE28, "vehicle_halftrack_mg_woodland" },
    { 0x5DC0FFDB, "vehicle_handleunloadevent" },
    { 0x0CBC99CE, "vehicle_hasavailablespots" },
    { 0xEAF66653, "vehicle_hasmainturret" },
    { 0x100F9207, "vehicle_hasname" },
    { 0x03C4E034, "vehicle_health" },
    { 0x5992E99D, "vehicle_health_overlay" },
    { 0xE3DF4A6D, "vehicle_heli_deletepath" },
    { 0x876EEB02, "vehicle_heli_land" },
    { 0x7EE96DB2, "vehicle_hits_gate" },
    { 0x304788B0, "vehicle_hud_tank_fireicon" },
    { 0x87AA7178, "vehicle_idle" },
    { 0xA39B7F03, "vehicle_idle_combat" },
    { 0x0A0AE717, "vehicle_idle_override" },
    { 0x2B54D1B2, "vehicle_idle_pistol" },
    { 0xB98CE39F, "vehicle_idle_twitchin" },
    { 0x01A43CB9, "vehicle_idling" },
    { 0x599F507C, "vehicle_immune_notify_func" },
    { 0xE31C6B19, "vehicle_in_use_save_restored_function" },
    { 0xA41C72A6, "vehicle_index" },
    { 0xC4409866, "vehicle_influencer_lead_seconds" },
    { 0x11211F28, "vehicle_influencer_score" },
    { 0xBEA0221C, "vehicle_influencer_score_curve" },
    { 0xF2B59DCC, "vehicle_init" },
    { 0x7CCA057C, "vehicle_initialize" },
    { 0xFA51F80E, "vehicle_initializer_cb" },
    { 0x949B2BE2, "vehicle_intro_to_plaza_think" },
    { 0x1FA2AF0F, "vehicle_is_firing_function" },
    { 0x97EA4621, "vehicle_is_tank" },
    { 0x597F7DC4, "vehicle_isstationary" },
    { 0x481A040F, "vehicle_kill_badplace_forever" },
    { 0x29AA20CE, "vehicle_kill_disconnect_paths_forever" },
    { 0x2972C08C, "vehicle_kill_player_ondeath" },
    { 0x84CAF402, "vehicle_kill_rumble_forever" },
    { 0xFEF41FAA, "vehicle_kill_treads_forever" },
    { 0x88E19BAD, "vehicle_land" },
    { 0xC2D63B5F, "vehicle_landvehicle" },
    { 0x7818F020, "vehicle_level_unstuff" },
    { 0x20C7C7A2, "vehicle_levelstuff" },
    { 0xB3FD46F4, "vehicle_life" },
    { 0x1711FF15, "vehicle_life_range_high" },
    { 0x9D868601, "vehicle_life_range_low" },
    { 0x0EBFCC04, "vehicle_liftoff" },
    { 0x57022E7C, "vehicle_liftoffvehicle" },
    { 0x275ED4D9, "vehicle_lights" },
    { 0xBFCAEFC5, "vehicle_lights_group" },
    { 0xE0B0BF07, "vehicle_lights_on" },
    { 0xCAC2848F, "vehicle_line_fire" },
    { 0xC14D7EC2, "vehicle_link" },
    { 0x34C569CB, "vehicle_linkedpaths" },
    { 0xC5AE65F7, "vehicle_load_ai" },
    { 0x31A9B3A6, "vehicle_load_assets" },
    { 0x5B22D0EF, "vehicle_load_fx" },
    { 0x6ECC59F5, "vehicle_luxurysedan_lowres" },
    { 0x7F38B2BE, "vehicle_luxurysedan_thermal" },
    { 0x3D8907DF, "vehicle_m1a1_think" },
    { 0x03F4AA35, "vehicle_main" },
    { 0x6A118559, "vehicle_main_callback" },
    { 0xD975A6C2, "vehicle_mainturrets" },
    { 0x57B94BA1, "vehicle_mantlefx" },
    { 0x6A766AD4, "vehicle_mg_off" },
    { 0x355700DE, "vehicle_mg_on" },
    { 0x429B8C5B, "vehicle_mgmanage" },
    { 0xF1DA6EBC, "vehicle_mgturret" },
    { 0xAFEBAF4F, "vehicle_modelinarray" },
    { 0x0745A492, "vehicle_move_and_blow_up" },
    { 0x6726CB47, "vehicle_name" },
    { 0x4D6A2DBE, "vehicle_node" },
    { 0x9EA40424, "vehicle_node_name" },
    { 0x2B9F623E, "vehicle_node_notify" },
    { 0xDB2C5EA2, "vehicle_node_wait" },
    { 0x9B9B2BE7, "vehicle_noteworthy_funcs" },
    { 0xC4405A93, "vehicle_numdrivers" },
    { 0x4BB7468E, "vehicle_occupants" },
    { 0x43E8EB6A, "vehicle_occupied" },
    { 0xCA984C78, "vehicle_origin" },
    { 0x5215DBF2, "vehicle_overlay" },
    { 0xC4C00FCE, "vehicle_override_anim" },
    { 0x9C31FBEF, "vehicle_override_strela_only" },
    { 0x766DE9BE, "vehicle_overturn_eject_occupants" },
    { 0x4F6AB888, "vehicle_overturn_suicide" },
    { 0xB0F18333, "vehicle_owner" },
    { 0x1AF0C326, "vehicle_panther" },
    { 0xEA040952, "vehicle_panzer" },
    { 0xF7EEA4E3, "vehicle_passengersonly" },
    { 0x70713947, "vehicle_path_disconnector" },
    { 0x005DC2CC, "vehicle_path_loop" },
    { 0x7B9E9326, "vehicle_pathdetach" },
    { 0xCC144EB6, "vehicle_paths" },
    { 0x28FD4635, "vehicle_patrol_init" },
    { 0xEED5B505, "vehicle_patrol_think" },
    { 0xCE90DAD7, "vehicle_pause_node" },
    { 0x0ACD4E62, "vehicle_pause_path" },
    { 0x3A6D77FC, "vehicle_paused" },
    { 0x0DD5F69E, "vehicle_pickup" },
    { 0x5C667B0C, "vehicle_play_explosion_sound" },
    { 0x3EE3246C, "vehicle_player_damage_only" },
    { 0x1C007D4C, "vehicle_pos" },
    { 0xCD2A44A9, "vehicle_position_will_telefrag" },
    { 0xBD8AA0BE, "vehicle_processtriggers" },
    { 0xAD9318D6, "vehicle_prop_anims" },
    { 0x94E94000, "vehicle_pullover_think" },
    { 0x7EA20578, "vehicle_reaquire_path" },
    { 0x57544FB9, "vehicle_reconnects_paths" },
    { 0x096630C9, "vehicle_record_initial_values" },
    { 0x53FC1461, "vehicle_recycle" },
    { 0x09912AF9, "vehicle_recycle_spawn" },
    { 0x521B9C81, "vehicle_recycle_spawner_t" },
    { 0xA4E28E13, "vehicle_regen_damage" },
    { 0x1FD7BAB6, "vehicle_reloadsound" },
    { 0xE03679E3, "vehicle_resume_path" },
    { 0x853F0C46, "vehicle_resumepath" },
    { 0x6C5E043A, "vehicle_resumepathvehicle" },
    { 0xE140138C, "vehicle_resumespeed" },
    { 0x62DEFF86, "vehicle_rideai" },
    { 0x3D9AB8FE, "vehicle_ridehandle" },
    { 0xD4212C48, "vehicle_rider_walk_setup" },
    { 0x29CF6253, "vehicle_riders_setup" },
    { 0x10807843, "vehicle_ridespawners" },
    { 0x4FAED715, "vehicle_route" },
    { 0xDACEC601, "vehicle_rumble" },
    { 0x4005B96B, "vehicle_seaknight_fake_load" },
    { 0x892E18FA, "vehicle_seaknight_fake_load_think" },
    { 0xB4E08CFE, "vehicle_seaknight_idle_and_load" },
    { 0x11A6096B, "vehicle_seaknight_idle_and_load_think" },
    { 0x28C95DD4, "vehicle_seaknight_rotors" },
    { 0xA27105CA, "vehicle_seaknight_unload" },
    { 0xAF4F371E, "vehicle_seaknight_unload_ai_think" },
    { 0xEA155DB6, "vehicle_set_team" },
    { 0x22F5391B, "vehicle_setspeed" },
    { 0xA9CB985D, "vehicle_setteam" },
    { 0x65A68101, "vehicle_setup" },
    { 0x835FC789, "vehicle_shared" },
    { 0xE32808F0, "vehicle_sharp_turn_left_snow_splash" },
    { 0xF4BE8CAB, "vehicle_sharp_turn_right_snow_splash" },
    { 0x8DAE9A69, "vehicle_shoot_rumble" },
    { 0x0E08C3FC, "vehicle_shoot_shock" },
    { 0xDC69E465, "vehicle_shoot_shock_overlay" },
    { 0xA6C5E740, "vehicle_shootat_target" },
    { 0x29874FFE, "vehicle_should_explode_on_cleanup" },
    { 0x5070889C, "vehicle_small_hatch" },
    { 0x3520E9FC, "vehicle_small_hatch_thermal" },
    { 0xC2CD95EC, "vehicle_small_hatchback_lowres" },
    { 0x1304976A, "vehicle_small_wagon" },
    { 0xD49382B5, "vehicle_smoke" },
    { 0xF7C02F2A, "vehicle_snow_falling_tree" },
    { 0x385346CC, "vehicle_snow_flutter_left" },
    { 0x71F04AE3, "vehicle_snow_flutter_right" },
    { 0x11518BFF, "vehicle_snow_splash_large" },
    { 0x35AEF626, "vehicle_snow_wheels_accelerate" },
    { 0x0E927DE9, "vehicle_sound_ent" },
    { 0x5153E6E7, "vehicle_spawn" },
    { 0xF606E292, "vehicle_spawn_callback_thread" },
    { 0x5FA6B2FB, "vehicle_spawn_group" },
    { 0xFAD9F548, "vehicle_spawn_stuff" },
    { 0x507EB7E6, "vehicle_spawned_callback" },
    { 0x5A417D62, "vehicle_spawned_thisframe" },
    { 0x692B3BC7, "vehicle_spawner_init" },
    { 0x8EB445D7, "vehicle_spawner_tool" },
    { 0x90B08B25, "vehicle_spawners" },
    { 0xCB38303B, "vehicle_spawners_init_finished" },
    { 0x9849C1CD, "vehicle_spawnflag" },
    { 0xCE26DECC, "vehicle_spawngroup" },
    { 0x7DAEB975, "vehicle_spawnidgenerate" },
    { 0x62F1EBEA, "vehicle_standattack" },
    { 0xE2A955EA, "vehicle_start" },
    { 0xFF8EAC81, "vehicle_startmove" },
    { 0x12604A96, "vehicle_startmovegroup" },
    { 0xFBBED711, "vehicle_startnodes" },
    { 0xB506B8A5, "vehicle_starts" },
    { 0xA5B2F619, "vehicle_state" },
    { 0x2F956418, "vehicle_static_line_fire" },
    { 0x8EBD2642, "vehicle_stop" },
    { 0x87BEE999, "vehicle_stop_at_node" },
    { 0xA514BEC2, "vehicle_stop_on_notify" },
    { 0xFACF6212, "vehicle_stuck_grenade_monitor" },
    { 0xDD8BC9D2, "vehicle_switch" },
    { 0x4E403623, "vehicle_switch_fade_in" },
    { 0x9B630BA6, "vehicle_switch_fadein_delay" },
    { 0x9E296F54, "vehicle_t72_think" },
    { 0x7A93EE5A, "vehicle_tag" },
    { 0x90638808, "vehicle_taken_over" },
    { 0xAE013E22, "vehicle_takes_damage" },
    { 0x4D921062, "vehicle_tank" },
    { 0xBE4EAA9F, "vehicle_tanker_truck" },
    { 0x5360B41D, "vehicle_target" },
    { 0xA7745C9F, "vehicle_target_player" },
    { 0xB5073164, "vehicle_targetname" },
    { 0x869ABCF6, "vehicle_targetname_array" },
    { 0x49B11B35, "vehicle_team" },
    { 0xFC65DED8, "vehicle_telefrag_griefers_at_position" },
    { 0xCE5ABA72, "vehicle_test" },
    { 0x5FF2C616, "vehicle_think" },
    { 0x6CA7D9E9, "vehicle_to_break" },
    { 0x6224C278, "vehicle_to_dummy" },
    { 0x87487FCC, "vehicle_to_kill" },
    { 0x4C7812C1, "vehicle_toggle_sounds" },
    { 0x073FA3A4, "vehicle_traffic_think" },
    { 0x21A1357F, "vehicle_transition" },
    { 0x85F2D4FB, "vehicle_transmute" },
    { 0xE6987A4D, "vehicle_treads" },
    { 0xCC5A7830, "vehicle_trig" },
    { 0xBA2FC523, "vehicle_truck" },
    { 0xA1C1EE85, "vehicle_truck_setup" },
    { 0x06FD60E2, "vehicle_truck_think" },
    { 0xEE6D8225, "vehicle_truckjunk" },
    { 0xD6FECFD1, "vehicle_turn_left" },
    { 0xEEACB4FC, "vehicle_turn_right" },
    { 0xA9AF59AD, "vehicle_turret_ai" },
    { 0xF6390BFB, "vehicle_turret_fire" },
    { 0x53688735, "vehicle_turret_requiresrider" },
    { 0x5F75A998, "vehicle_turret_scan" },
    { 0x581EBA21, "vehicle_turret_think" },
    { 0x87617A7A, "vehicle_type" },
    { 0x7D8EF8D6, "vehicle_type_count" },
    { 0x51FA5FF5, "vehicle_types" },
    { 0x182A8226, "vehicle_uaz_fabric" },
    { 0x515CA313, "vehicle_uaz_hardtop" },
    { 0x7665C027, "vehicle_uaz_light" },
    { 0xD875FD4D, "vehicle_uaz_open" },
    { 0xD28A2F2E, "vehicle_uaz_open_for_ride" },
    { 0xD2032643, "vehicle_unload" },
    { 0xCECB4576, "vehicle_unload_single" },
    { 0x86C676D3, "vehicle_unloadgroups" },
    { 0x5E189EB4, "vehicle_unloadwhenattacked" },
    { 0x430D01A3, "vehicle_unoccupied" },
    { 0x39E70C4E, "vehicle_upanim" },
    { 0x6B6144EC, "vehicle_variants" },
    { 0xEF327AE6, "vehicle_version" },
    { 0xDDC00BDB, "vehicle_vision_set" },
    { 0x6F719A09, "vehicle_wait" },
    { 0x9636D8BA, "vehicle_wait_damage_t" },
    { 0x37BC279D, "vehicle_wait_player_enter_t" },
    { 0x8F52E198, "vehicle_wait_till_node" },
    { 0xC73035A4, "vehicle_wait_tread_damage" },
    { 0x1FBE4453, "vehicle_walkai" },
    { 0xD7227DB9, "vehicle_walkercount" },
    { 0x0EAFDB16, "vehicle_walkspawners" },
    { 0x256AA219, "vehicle_watch_damage" },
    { 0x8B3D4B27, "vehicle_wave_attacked_by_player" },
    { 0xF3E5F9E3, "vehicle_weapon_fired" },
    { 0x38954F91, "vehicle_weapon_override" },
    { 0x69ADFC80, "vehicle_weave" },
    { 0x19E29E7F, "vehicle_whizby_or_close_impact" },
    { 0x8FDF4891, "vehicle_windowdressing" },
    { 0xCCBB2852, "vehicle_zpu_death" },
    { 0xA7F4BE4C, "vehicle_zpu_think" },
    { 0x95E979AF, "vehicleallreadydead" },
    { 0xE3DBBFC0, "vehicleanim" },
    { 0xB9684959, "vehicleanim1" },
    { 0xDF6AC3C2, "vehicleanim2" },
    { 0x84CEA3EB, "vehicleanims" },
    { 0xC6F34EA2, "vehiclearray" },
    { 0xF3CC947C, "vehicleattackgroup" },
    { 0x46880DD3, "vehicleavoidance" },
    { 0xCEE67717, "vehiclechase" },
    { 0xCBA6BD1D, "vehicleclass" },
    { 0x4D18350C, "vehiclecrush" },
    { 0x8EEE8DD1, "vehiclecustomsettings" },
    { 0x4967BD35, "vehicledamageassist" },
    { 0x2FCFB4F4, "vehicledamagescalar" },
    { 0xF937C96D, "vehicledeathwaiter" },
    { 0xBEA19AB5, "vehicledeathwatcher" },
    { 0x5C694D10, "vehiclee" },
    { 0x12F84EA8, "vehicleenteranim" },
    { 0x86971A40, "vehicleexitanim" },
    { 0x7F7C7ABC, "vehiclefireanim" },
    { 0x49CCFC5A, "vehiclefireanim_settle" },
    { 0x42EB304C, "vehiclefireicon" },
    { 0xD39FC6D7, "vehiclefootstepcallbacks" },
    { 0xC75394F8, "vehiclegearmodels" },
    { 0x4C357EB5, "vehiclegeartags" },
    { 0x02AE0CB4, "vehiclegroup" },
    { 0xEDB7D25E, "vehiclegroup spawned" },
    { 0x408B946E, "vehiclegunner" },
    { 0x27AA40D5, "vehiclehackertoolradius" },
    { 0xED627D44, "vehiclehackertooltimems" },
    { 0x791D931C, "vehiclehealthregen" },
    { 0x9CC6B64C, "vehiclehealths" },
    { 0xBB318D33, "vehiclehijack" },
    { 0x5BED8AC2, "vehiclehud" },
    { 0x0C7586E4, "vehiclehud2" },
    { 0xF1741556, "vehiclehudhealthnumbers" },
    { 0xC8FC1CAF, "vehicleinfo" },
    { 0x52DD7251, "vehicleinitthread" },
    { 0xE546A107, "vehiclekeys" },
    { 0x373F8AC1, "vehicleloopsounds" },
    { 0x940D1D08, "vehiclemainthread" },
    { 0xEE8555D7, "vehiclemoveupbuttonpressed" },
    { 0xAA87ADA2, "vehiclename" },
    { 0xD25100C7, "vehiclenode" },
    { 0x288241A5, "vehiclenode_loop_targetname" },
    { 0xEF71CAB7, "vehiclenode_peeloff_rail_targetname" },
    { 0xD5D817E7, "vehiclenode_start_targetname" },
    { 0x54D268FC, "vehiclenode_targetname" },
    { 0x65C595D1, "vehiclenode_wait" },
    { 0x617125BE, "vehiclenodes" },
    { 0x4EE30638, "vehicleoldownerteam" },
    { 0x09A5629D, "vehicleoldteam" },
    { 0x133B1C6D, "vehicleoldwatcherteam" },
    { 0xF9F3D62E, "vehicleposition" },
    { 0xF1F25C71, "vehicleprojectiledamagescalar" },
    { 0x811B4F80, "vehicleprojectilesplashdamagescalar" },
    { 0x60065439, "vehicleradius" },
    { 0x4C1AFDF6, "vehicleradiusdamage" },
    { 0xCA190C08, "vehiclerider_groups" },
    { 0x0014C128, "vehiclerider_use_index" },
    { 0xA003A3D6, "vehicleriderdeathanim" },
    { 0x8127FD84, "vehicleriders" },
    { 0x923223E8, "vehicleriders_shared" },
    { 0x8A0AFCD4, "vehicleridersbundle" },
    { 0xF2665D0C, "vehicleridersrobotbundle" },
    { 0xE05084F6, "vehicles" },
    { 0xA84566C0, "vehicles2" },
    { 0x4BA81004, "vehicles_ahead" },
    { 0x8A2BC877, "vehicles_allies" },
    { 0x3D50474C, "vehicles_anim_setup" },
    { 0xCD5EBE46, "vehicles_axis" },
    { 0xE07B3017, "vehicles_damage_states" },
    { 0x384D9931, "vehicles_damage_treadfx" },
    { 0xE1BC2F68, "vehicles_delete_all" },
    { 0x8AE7A2C4, "vehicles_enabled" },
    { 0xD8C8FF6D, "vehicles_husk_effects" },
    { 0xCAF31808, "vehicles_inited" },
    { 0xF196620D, "vehicles_list" },
    { 0x3BF94BED, "vehicles_low_road_damage_override" },
    { 0xFD57AFC4, "vehicles_rollout" },
    { 0x01983B1A, "vehicles_that_hunt" },
    { 0xC41D6EBC, "vehicles_to_delete" },
    { 0xE20EEFB1, "vehicles_to_remove" },
    { 0x35D5F2D9, "vehicles_with_drones" },
    { 0x894822AE, "vehiclescript" },
    { 0xE2EFCA6D, "vehiclesenabled" },
    { 0x21C00D01, "vehiclespawncallbackthread" },
    { 0xBD3F5EC1, "vehiclespawncontext" },
    { 0x4148C8EC, "vehiclespawners" },
    { 0xE401BC38, "vehiclespawnthread" },
    { 0x6B41F970, "vehiclespeed" },
    { 0x7038362F, "vehiclestimed" },
    { 0x586EA2BC, "vehiclestodelete" },
    { 0x6661E008, "vehicletarget" },
    { 0x98DF8FE1, "vehicletargetname" },
    { 0x85A42823, "vehicletargets" },
    { 0x3D07F58C, "vehicleteamthread" },
    { 0x374B2B73, "vehiclethread" },
    { 0xE59A3523, "vehicletoavoid" },
    { 0xB89F1183, "vehicletriggerspawnflags" },
    { 0x9D34DCA7, "vehicletype" },
    { 0x9DCB39E4, "vehicletypeattacked" },
    { 0x70E30D35, "vehicletypecallbackarray" },
    { 0x8B1469A2, "vehicletypefancy" },
    { 0x2800161E, "vehicletypes" },
    { 0xEC00A4E0, "vehiclevisibilityfromplayer" },
    { 0x66D6669C, "vehiclewalker_freespot_ondeath" },
    { 0x6B459ECA, "vehiclewalker_removeonunload" },
    { 0x48356CDB, "vehiclewalker_teamunderattack" },
    { 0xCB332958, "vehiclewalker_updategoalpos" },
    { 0x40603CD6, "vehiclewalkmember" },
    { 0x255B9567, "vehiclewasdestroyed" },
    { 0xAEB003F6, "vehiclewheelfx" },
    { 0xC264D29D, "vehilce" },
    { 0x824F5E51, "vehkilloccupantsondeath" },
    { 0x83600739, "vehmodel" },
    { 0x4CAD9B8B, "vehmodelenemy" },
    { 0x3B6B8426, "vehnode" },
    { 0x2B541B59, "vehnodes" },
    { 0x4EBA16FA, "vehnotinunit" },
    { 0xE29F25F8, "vehonpath" },
    { 0x264F5AB4, "vehpos" },
    { 0xDF6A68CD, "vehs" },
    { 0x95A5AC75, "vehs2" },
    { 0x6D424C6F, "vehseenrecently" },
    { 0xE21427D0, "vehsetentitytarget" },
    { 0x93E55E71, "vehsightlatency" },
    { 0x3BC3833B, "vehspeedips" },
    { 0xD85D100C, "vehviewmodel" },
    { 0x143B4919, "veihcle" },
    { 0x0CC32206, "veins" },
    { 0x6039BA26, "vel" },
    { 0xE75977EB, "vel1" },
    { 0x755208B0, "vel2" },
    { 0x9B548319, "vel3" },
    { 0x950418D2, "vel_dir" },
    { 0x09474878, "vel_factor" },
    { 0x81D1F4FD, "vel_hitdir" },
    { 0x770F1F0E, "vel_hitdirup" },
    { 0x7C366AD8, "vel_random" },
    { 0x793BD05C, "vel_towards_me" },
    { 0xBDFEC3B7, "vel_x" },
    { 0x97FC494E, "vel_y" },
    { 0x71F9CEE5, "vel_z" },
    { 0xCD502D2B, "velconst" },
    { 0x0591E074, "velocities" },
    { 0x9D097BF8, "velocity" },
    { 0xF3C8FB41, "velocity1" },
    { 0x19CB75AA, "velocity2" },
    { 0x3FCDF013, "velocity3" },
    { 0x9C1AC1CB, "velocity_approach" },
    { 0x9744842A, "velocity_approach_early_out" },
    { 0xD46895D5, "velocity_func" },
    { 0x0B02FD9F, "velocity_length" },
    { 0x829E8366, "velocity_normal" },
    { 0x40CC42A0, "velocity_rotation_frac" },
    { 0x4DE7D8D3, "velocity_scale" },
    { 0xBC38ABAD, "velocity_should_scale" },
    { 0xFC428900, "velocity_strength" },
    { 0xEB63D090, "velocity_up" },
    { 0x819400CD, "velocitydir" },
    { 0x9FC4C6CF, "velocityforward" },
    { 0x8A7223D3, "velocityforwardscale" },
    { 0x5B28FD3C, "velocitylength" },
    { 0x1624BABE, "velocitylengthsqr" },
    { 0xB9816735, "velocityloss" },
    { 0x329D8985, "velocitymag" },
    { 0x0F908FBE, "velocityscale" },
    { 0x93A2E138, "velocityscaler" },
    { 0xB7B39FB0, "velocitysq" },
    { 0x0C8F97B2, "velocitysqr" },
    { 0xF7558F2D, "velocitystablizeparam" },
    { 0x6EC9B641, "veloctiy_scale" },
    { 0xEB455328, "velscale" },
    { 0x84ADAEA7, "velvet" },
    { 0x73DDAC78, "vend_trigs" },
    { 0x3255FDE0, "vending" },
    { 0xF9C0AE1F, "vending_doubletap" },
    { 0xB8274142, "vending_jugg" },
    { 0x530E809A, "vending_location" },
    { 0x5A4FAC92, "vending_machine" },
    { 0x9598A722, "vending_machine_flicker_light" },
    { 0xCFD17239, "vending_machine_list" },
    { 0x7E5596E6, "vending_machine_trigger_think" },
    { 0xB6A3EE9D, "vending_machines" },
    { 0x2B1C5DBD, "vending_machines_powered_on_at_start" },
    { 0xE026DE0A, "vending_machines_with_weights" },
    { 0x7C827139, "vending_model_info" },
    { 0x00DD4A2A, "vending_name" },
    { 0x5C025696, "vending_randomization_effect" },
    { 0x96EA0CD8, "vending_revive" },
    { 0x59B61F78, "vending_set_hintstring" },
    { 0x9A143F2F, "vending_sleight" },
    { 0x1273D6AA, "vending_trigger_can_player_use" },
    { 0xA51BC2C7, "vending_trigger_post_think" },
    { 0x23952604, "vending_trigger_think" },
    { 0x3BE8A3B8, "vending_triggers" },
    { 0x026C90BD, "vending_upgrade" },
    { 0x5DB56B64, "vending_upgrade_trigger" },
    { 0xC101A20E, "vending_weapon_upgrade" },
    { 0x45B5C3F2, "vending_weapon_upgrade_cost" },
    { 0xAA820453, "vending_weapon_upgrade_trigger" },
    { 0x880B6F35, "vengeance" },
    { 0x4B505B2C, "vengeance_chance" },
    { 0xD1951384, "vengeance_distance_sq" },
    { 0x5A7B478E, "vengeanceservice" },
    { 0x6A91C5E8, "vent" },
    { 0xE4D33F11, "vent01" },
    { 0x0AD5B97A, "vent02" },
    { 0xA20EA989, "vent_dialogue" },
    { 0x5F9B7492, "vent_dialogue1" },
    { 0x3998FA29, "vent_dialogue2" },
    { 0x606CC955, "vent_dialogue2_01" },
    { 0x14B09444, "vent_drop" },
    { 0xA92BDADC, "vent_drop_triggers" },
    { 0x47321917, "vent_enemies_group1_spawner" },
    { 0x252F712E, "vent_enemies_group1_spawner_think" },
    { 0xDB869624, "vent_enemies_group2_spawner" },
    { 0xC5C5CBA5, "vent_enemies_group2_spawner_think" },
    { 0x13A82B12, "vent_explode" },
    { 0x1C3B7A55, "vent_flag" },
    { 0x323BE596, "vent_friendlies_group1_spawner" },
    { 0x8EAEA8F3, "vent_friendlies_group1_spawner_think" },
    { 0x48C5BC15, "vent_friendlies_group2_spawner" },
    { 0x458323F0, "vent_friendlies_group2_spawner_think" },
    { 0x8729F92B, "vent_friendlies_vent_jump" },
    { 0x99B2342E, "vent_grisby_vent_jump" },
    { 0x98E7587F, "vent_kick_rumble" },
    { 0x1C087F4F, "vent_nag" },
    { 0xB012D07A, "vent_nag_cleanup" },
    { 0xA784BD7B, "vent_org" },
    { 0x52969A98, "vent_sequence" },
    { 0x4BB9272C, "vent_team1_vent_jump" },
    { 0xF2435825, "vent_trigger_air_raid_siren" },
    { 0x6FA490E8, "vent_trigger_friendlies_vent_jump" },
    { 0xC5E74B6A, "vent_trigger_move_out" },
    { 0xB9A519A9, "vent_trigger_team1_vent_jump" },
    { 0x6B1EAB5E, "ventnodes01" },
    { 0x451C30F5, "ventnodes02" },
    { 0x1F19B68C, "ventnodes03" },
    { 0x448A2A6F, "vento" },
    { 0x461060C9, "ventral" },
    { 0x08F2AC53, "ventral_mist" },
    { 0x1818148A, "ventral_status" },
    { 0x0150DE6D, "ventral_turret_pitch" },
    { 0x7C6C6D83, "vents" },
    { 0x73E9F73D, "vents_friendly_movement" },
    { 0xBDCF9EFE, "vents_objectives" },
    { 0x1556CEC1, "vera" },
    { 0x3B59492A, "verb" },
    { 0xC2A37986, "verb_reset" },
    { 0xF762FDC9, "verified" },
    { 0x8C4B24B6, "verify" },
    { 0xA999064C, "verify_chest" },
    { 0x5C649976, "verify_chest_is_open" },
    { 0xB1A3697F, "verify_knife_achievements" },
    { 0x2F53C4EE, "verify_that_allies_are_undeletable" },
    { 0x6C1B2B2A, "verifying" },
    { 0x8347D255, "verifyunlocks" },
    { 0x15524E1C, "verindex" },
    { 0xDA0249FD, "veritcal" },
    { 0xF6232BC7, "verlet" },
    { 0x01B7E430, "versa" },
    { 0x829CB7A3, "version" },
    { 0x798527E2, "version_dlc1" },
    { 0x5382AD79, "version_dlc2" },
    { 0x2D803310, "version_dlc3" },
    { 0x37918BEF, "version_dlc4" },
    { 0x118F1186, "version_dlc5" },
    { 0x50203C45, "version_end_idx" },
    { 0xE65718FA, "version_index" },
    { 0x6F3D2F15, "version_number" },
    { 0x7AE8E950, "version_ship" },
    { 0x8F61DD8A, "version_ship_obsolete" },
    { 0xDF8FE2D2, "version_start_idx" },
    { 0xF230EDF5, "version_tu0" },
    { 0x7F66C20B, "version_tu0_ffotd_010113_0" },
    { 0xF332D665, "version_tu0_ffotd_010713_0" },
    { 0xCC2E738C, "version_tu1" },
    { 0x1996D914, "version_tu10" },
    { 0x9FE590EE, "version_tu10_obsolete" },
    { 0x3F99537D, "version_tu11" },
    { 0xE94A7432, "version_tu11_ffotd_062416_0" },
    { 0x527B1A7D, "version_tu11_obsolete" },
    { 0x659BCDE6, "version_tu12" },
    { 0x0186A598, "version_tu12_obsolete" },
    { 0x8B9E484F, "version_tu13" },
    { 0xC6356D0F, "version_tu13_obsolete" },
    { 0x818CEF70, "version_tu14" },
    { 0x94DA35EA, "version_tu14_obsolete" },
    { 0xA78F69D9, "version_tu15" },
    { 0x118D154F, "version_tu15_ffotd_090816_0" },
    { 0xB24CF8D9, "version_tu15_obsolete" },
    { 0xCD91E442, "version_tu16" },
    { 0x2245EAA4, "version_tu16_obsolete" },
    { 0xF3945EAB, "version_tu17" },
    { 0xDA29A63B, "version_tu17_obsolete" },
    { 0x49AAAC5C, "version_tu18" },
    { 0xC83BB5C6, "version_tu18_obsolete" },
    { 0x6FAD26C5, "version_tu19" },
    { 0x76616495, "version_tu19_obsolete" },
    { 0x9DC7376C, "version_tu1_ffotd_010113_0" },
    { 0x38CD2BBA, "version_tu1_ffotd_010713_0" },
    { 0x26FDB430, "version_tu1_ffotd_031813_0" },
    { 0x4D002E99, "version_tu1_ffotd_031813_1" },
    { 0x7302A902, "version_tu1_ffotd_031813_2" },
    { 0xD28D2025, "version_tu1_ffotd_031913_0" },
    { 0x8F3F85B6, "version_tu1_obsolete" },
    { 0x3E35E2C7, "version_tu2" },
    { 0x955D0B95, "version_tu20" },
    { 0x6F5A912C, "version_tu21" },
    { 0x988489DD, "version_tu2_ffotd_031813_0" },
    { 0x72820F74, "version_tu2_ffotd_031813_1" },
    { 0xE4897EAF, "version_tu2_ffotd_031813_2" },
    { 0xF8C372C8, "version_tu2_ffotd_031913_0" },
    { 0xE81FBF77, "version_tu2_obsolete" },
    { 0x1833685E, "version_tu3" },
    { 0x7380AEA0, "version_tu3_obsolete" },
    { 0x5A270451, "version_tu4" },
    { 0xCE21C761, "version_tu4_obsolete" },
    { 0x342489E8, "version_tu5" },
    { 0x72B7C0F2, "version_tu5_obsolete" },
    { 0xA62BF923, "version_tu6" },
    { 0x92C5B812, "version_tu6_ffotd_020416_0" },
    { 0x872E0B43, "version_tu6_obsolete" },
    { 0x80297EBA, "version_tu7" },
    { 0x1016336C, "version_tu7_obsolete" },
    { 0xC21D1AAD, "version_tu8" },
    { 0x867953ED, "version_tu8_obsolete" },
    { 0x9C1AA044, "version_tu9" },
    { 0x5A330A0B, "version_tu9_ffotd_041916_0" },
    { 0xBD11125E, "version_tu9_obsolete" },
    { 0xC5DF3692, "versions" },
    { 0xB1F90E94, "verson" },
    { 0x842A32F7, "versus" },
    { 0x2736976C, "vert" },
    { 0x4B8F806E, "vert_align" },
    { 0x5EEF24AB, "vert_allowance" },
    { 0xE7662676, "vert_equipment_attack_range" },
    { 0x8A05FC5A, "vert_offset" },
    { 0xF9134763, "vertalign" },
    { 0xE288D24B, "vertanim" },
    { 0x26A306BC, "vertdist" },
    { 0x1620AB38, "verteran" },
    { 0x0E085163, "vertex" },
    { 0xCD3A8943, "vertical" },
    { 0xE3F713A5, "vertical_align_bottom" },
    { 0x5EDF41DF, "vertical_align_center" },
    { 0x1FC694F2, "vertical_align_center_safearea" },
    { 0x20407193, "vertical_align_default" },
    { 0x544C6EDF, "vertical_align_fullscreen" },
    { 0x0D1AD1FE, "vertical_align_max" },
    { 0x4BC74F19, "vertical_align_noscale" },
    { 0xEF7E846B, "vertical_align_subtop" },
    { 0x1A2110F9, "vertical_align_to480" },
    { 0x44A99BDD, "vertical_align_top" },
    { 0xA22E92CD, "vertical_fall" },
    { 0x38F7E9E7, "vertical_offset" },
    { 0xF2BBDBB7, "vertical_speed" },
    { 0x8D2FD8B0, "vertical_spinners" },
    { 0xB2BD1719, "vertical_spinners_think" },
    { 0x863BA504, "verticalanim" },
    { 0x4A2F906E, "vertically" },
    { 0x1C2416EA, "verticaloffset" },
    { 0x3352980C, "verticalvel" },
    { 0xC185E8DD, "verticle" },
    { 0xA1DE3C86, "verticle_only" },
    { 0xB8318D6F, "verts" },
    { 0x972D8135, "vertvelocitymax" },
    { 0xC1BF8C7B, "vertvelocitymin" },
    { 0xF555B35C, "vertweight" },
    { 0x851B54E9, "very" },
    { 0xA7725197, "very_end_alert_strat" },
    { 0xE496B627, "very_end_kill_counter" },
    { 0x8877BD22, "very_end_spawners_5_strat" },
    { 0x49A2906E, "veryhurt" },
    { 0x977A4AC1, "veryhurttime" },
    { 0x2705746A, "vespa_smoke" },
    { 0x87A89713, "vessel" },
    { 0xA8486697, "vest" },
    { 0xC635B94E, "vests" },
    { 0x3025E6DE, "vet" },
    { 0xE6E1EF4A, "veteran" },
    { 0xFFFE0BBA, "veteran_achievement" },
    { 0x61788115, "veteran_remove_grenades" },
    { 0x0A236C75, "vew" },
    { 0xE38B8B45, "vf" },
    { 0x09AB701E, "vf_143" },
    { 0x164638AF, "vfacing" },
    { 0x9E0B9B40, "vforward" },
    { 0x5B62B694, "vfwd" },
    { 0x49986A57, "vfx" },
    { 0x2C4D8BE2, "vfx_cell_phone_screen" },
    { 0xDAF36E59, "vfx_ent" },
    { 0x6A79ECE5, "vfx_fill_name" },
    { 0x4DD1AD23, "vfx_fill_settings" },
    { 0xC7D61850, "vfx_filllight_1_update_for_shot" },
    { 0xA2A87D77, "vfx_josefina_smoulder" },
    { 0x7459F331, "vfx_josefina_smoulder_shot03" },
    { 0x73FC2480, "vfx_spot_name" },
    { 0xA801C9B2, "vfx_spot_settings" },
    { 0xF2F52ECB, "vfx_spotlight_controls" },
    { 0x7D796D65, "vfx_spotlight_for_precamera" },
    { 0x20F0F571, "vfx_spotlight_update_for_shot" },
    { 0x332663CF, "vfxspot" },
    { 0x8D327EB5, "vfxspot_on" },
    { 0xBD8910DC, "vg" },
    { 0x9B925C1D, "vg_init" },
    { 0xCE3BCF64, "vg_placed" },
    { 0xFF3A71A9, "vg_qualifier" },
    { 0xC5C31ABC, "vg_struct" },
    { 0x504CED38, "vg_struct_sound" },
    { 0x6772C32B, "vh" },
    { 0x6743C9FA, "vh_ac130" },
    { 0xAE58E6E6, "vh_acceleration" },
    { 0x9E15CD14, "vh_allied_drone" },
    { 0x005082DA, "vh_ambient" },
    { 0x7878BE38, "vh_apache" },
    { 0xEC49D02A, "vh_asd" },
    { 0x48DBE4A5, "vh_asd_player_perk" },
    { 0x48650DAF, "vh_asd_tutorial" },
    { 0x95E22D8C, "vh_asd_tutorial_2" },
    { 0xEAC38B91, "vh_avoid" },
    { 0x9FBB1C33, "vh_before_charge_uaz" },
    { 0x843C3629, "vh_biplane" },
    { 0x3608E520, "vh_boat" },
    { 0x54BF6F9E, "vh_btr" },
    { 0xCD378993, "vh_btr1" },
    { 0x5B301A58, "vh_btr2" },
    { 0x594A2A4A, "vh_buffel" },
    { 0x45A25CC2, "vh_buffel_1" },
    { 0xF2A8D0D5, "vh_buffel_helper" },
    { 0xD98F572A, "vh_buffel_mortar" },
    { 0xAA17C064, "vh_buffel_tip" },
    { 0xE781A391, "vh_cannon" },
    { 0x62194124, "vh_car" },
    { 0xDA368E92, "vh_charge_hind" },
    { 0x8C557B37, "vh_chopper" },
    { 0xCA89EC4B, "vh_claw" },
    { 0x091E56E3, "vh_claw_player_soct" },
    { 0x4E3091A2, "vh_claw_salazar_soct" },
    { 0x64DC0E2E, "vh_cleanup" },
    { 0xA5D750AD, "vh_contrainer_truck" },
    { 0x56B24CB0, "vh_convoy_leader" },
    { 0xDE3C8B57, "vh_cop_car" },
    { 0x8E67CAFD, "vh_cougar" },
    { 0x7E37F0E5, "vh_cougar2" },
    { 0x5433A9CE, "vh_courtyard_heli_1" },
    { 0x082EB4FC, "vh_courtyard_heli_3" },
    { 0x87409B39, "vh_current" },
    { 0x81EB184F, "vh_deceleration" },
    { 0x8670862C, "vh_distance_max" },
    { 0x6FD8B42C, "vh_drone" },
    { 0x03FE751D, "vh_drone1" },
    { 0x2A00EF86, "vh_drone2" },
    { 0x500369EF, "vh_drone3" },
    { 0x45F21110, "vh_drone4" },
    { 0xC6971554, "vh_eland" },
    { 0xE9A3F930, "vh_end_buffel" },
    { 0xEB63944A, "vh_enemy" },
    { 0x7F5A66D3, "vh_enemy_boat" },
    { 0xDF80810D, "vh_ent" },
    { 0x60C03CFF, "vh_entered" },
    { 0x0BF1B133, "vh_entity" },
    { 0x51DDA598, "vh_f35" },
    { 0x2C498F6B, "vh_f35_cougar_exit" },
    { 0x9427D0F4, "vh_fa38" },
    { 0xCF10C097, "vh_friendly" },
    { 0x47B0CF06, "vh_friendly_asd" },
    { 0x224A6217, "vh_g20_1" },
    { 0xB042F2DC, "vh_g20_2" },
    { 0x81389360, "vh_gaz" },
    { 0x91EAD3F9, "vh_gaz1" },
    { 0xB7ED4E62, "vh_gaz2" },
    { 0xB5A82BC8, "vh_guard_this" },
    { 0x5E63B98B, "vh_hangar" },
    { 0x24F570A0, "vh_hatch" },
    { 0xC4B2B06E, "vh_heli" },
    { 0xAF1BB085, "vh_helicopter" },
    { 0x76FF6BCA, "vh_helicopter_2" },
    { 0x80B781B2, "vh_helipad_drone" },
    { 0xEB75EF55, "vh_hero_eland" },
    { 0x398870B6, "vh_hill_buffel" },
    { 0xDB4D8600, "vh_hill_buffel2" },
    { 0xE407D120, "vh_hill_eland" },
    { 0xE02272ED, "vh_hind" },
    { 0x7CC17CFE, "vh_hind1" },
    { 0x56BF0295, "vh_hind2" },
    { 0x4C97670D, "vh_hip" },
    { 0xD97C659E, "vh_hip1" },
    { 0xB379EB35, "vh_hip2" },
    { 0x8D7770CC, "vh_hip3" },
    { 0x6774F663, "vh_hip4" },
    { 0xF0173C4A, "vh_hip_targets" },
    { 0x0CD8D68C, "vh_hips" },
    { 0x4552085D, "vh_horse" },
    { 0xAAF4149C, "vh_horses" },
    { 0x93793DA7, "vh_hostile_drone_1" },
    { 0x2171CE6C, "vh_hostile_drone_2" },
    { 0x59C59313, "vh_intro_buffel" },
    { 0xDD47EF6F, "vh_intro_courtyard_drone" },
    { 0x1B11A29A, "vh_intro_van" },
    { 0xEDD777E6, "vh_jeep" },
    { 0x4168DC66, "vh_lantern" },
    { 0xB652E700, "vh_lapd_car" },
    { 0x519C01B0, "vh_lead" },
    { 0x93DEC957, "vh_lead_buffel" },
    { 0xB11ED3E7, "vh_lead_plane" },
    { 0x9AA14CA5, "vh_leader" },
    { 0x2D8AF7E2, "vh_lear_jet" },
    { 0x1A70FFFB, "vh_learjet" },
    { 0x51F731F0, "vh_learjet_gaz" },
    { 0x23A8F0C7, "vh_learjet_gaz_2" },
    { 0xEDFD3207, "vh_learjet_truck" },
    { 0x80A208F9, "vh_left_defend_turret" },
    { 0x799E4A56, "vh_left_path_turret" },
    { 0x7AECF39E, "vh_link_truck" },
    { 0xF5B59703, "vh_littlebird" },
    { 0x0A01E5E0, "vh_littlebird1" },
    { 0x7C09551B, "vh_littlebird2" },
    { 0x5606DAB2, "vh_littlebird3" },
    { 0xC80E49ED, "vh_littlebird4" },
    { 0xE3917C5C, "vh_lockbreaker_asd" },
    { 0xB6FE1689, "vh_market_drone" },
    { 0x499EE8D1, "vh_mason_hummer" },
    { 0xFF8924D2, "vh_menendez_f38" },
    { 0x91F6F0FE, "vh_metalstorm" },
    { 0xD5550973, "vh_mig" },
    { 0xC1B3BF10, "vh_mig1" },
    { 0x33BB2E4B, "vh_mig2" },
    { 0x8084B3EA, "vh_mig23" },
    { 0x0DB8B3E2, "vh_mig3" },
    { 0x49C9A22B, "vh_motel_vehicles" },
    { 0xA2111246, "vh_my_horse" },
    { 0xA8853753, "vh_new_buffel" },
    { 0x443C6271, "vh_nitrogen_asd" },
    { 0x83C1BEF6, "vh_occupied" },
    { 0x8D62DC31, "vh_offload_truck" },
    { 0x1C6E7F20, "vh_old_buffel" },
    { 0xC102D62C, "vh_osprey" },
    { 0x2BF6F9A2, "vh_parking_lot_truck" },
    { 0x6BC6EAE9, "vh_phantom" },
    { 0xCD48F8F2, "vh_phantom1" },
    { 0xA7467E89, "vh_phantom2" },
    { 0x81440420, "vh_phantom3" },
    { 0x12F099EC, "vh_plane" },
    { 0xCC8861F9, "vh_player_claw" },
    { 0x8B25B462, "vh_player_drone" },
    { 0xC9A412EA, "vh_player_hummer" },
    { 0x3EACA940, "vh_player_jeep" },
    { 0x4A8C34C3, "vh_player_soct" },
    { 0x18BED257, "vh_player_vtol" },
    { 0xD99139D8, "vh_police_car1" },
    { 0x4B98A913, "vh_police_car2" },
    { 0x004604F8, "vh_police_mc1" },
    { 0x724D7433, "vh_police_mc2" },
    { 0x4C4AF9CA, "vh_police_mc3" },
    { 0xBE526905, "vh_police_mc4" },
    { 0x984FEE9C, "vh_police_mc5" },
    { 0x6AB55A83, "vh_potus" },
    { 0xFACBCD14, "vh_potus_convoy" },
    { 0x085D3EFC, "vh_presidents_vehicle" },
    { 0x6F149693, "vh_qr" },
    { 0x24F266C5, "vh_qrotor" },
    { 0xAC356243, "vh_quad" },
    { 0x4FEE022D, "vh_quadrotor" },
    { 0xA3E025D7, "vh_riders_horse" },
    { 0x98F84AF4, "vh_right_defend_turret" },
    { 0x32E25E63, "vh_right_path_asd" },
    { 0x5326AD3B, "vh_river_heli" },
    { 0x1377EE82, "vh_salazar_soct" },
    { 0xDD985AE3, "vh_sam" },
    { 0xACA4DC25, "vh_sam_cougar" },
    { 0xC829EB2C, "vh_savimbi_buffel" },
    { 0x719A5379, "vh_soct" },
    { 0x34E562FD, "vh_soct_crashes_into_heli" },
    { 0xC98AE922, "vh_soct_to_bump" },
    { 0x19875AE0, "vh_spawned" },
    { 0x5DBDDFE6, "vh_spawner" },
    { 0xA2EEA9E8, "vh_spiderbot" },
    { 0x03866371, "vh_super_soct" },
    { 0xF793F80E, "vh_tank" },
    { 0xD17B04C3, "vh_tank1" },
    { 0x5F739588, "vh_tank2" },
    { 0xD1DD12B9, "vh_target" },
    { 0x32A11163, "vh_target_current" },
    { 0x74F81EC8, "vh_temp" },
    { 0x0985D66F, "vh_tiger" },
    { 0x9BB919B0, "vh_tigr" },
    { 0xFE7FF35A, "vh_to_enter" },
    { 0xB04E4654, "vh_train_depot_gaz" },
    { 0x45900C37, "vh_truck" },
    { 0xB337B3DC, "vh_truck1" },
    { 0x253F2317, "vh_truck2" },
    { 0xFF3CA8AE, "vh_truck3" },
    { 0xA451B9E3, "vh_truck_driveway" },
    { 0x9A93285A, "vh_truck_push" },
    { 0x75083294, "vh_truck_targets" },
    { 0x7E9E0E6E, "vh_trucks" },
    { 0xB8F9A884, "vh_turret" },
    { 0xF56D24B6, "vh_uaz" },
    { 0x165C513B, "vh_uaz1" },
    { 0xA454E200, "vh_uaz2" },
    { 0xCA575C69, "vh_uaz3" },
    { 0x8863C076, "vh_uaz4" },
    { 0xA6BEE5D1, "vh_uaz_targets" },
    { 0x4AF5F6A9, "vh_uazs" },
    { 0x9F97A271, "vh_van" },
    { 0x554AFA3A, "vh_vehicle" },
    { 0x9579D511, "vh_vip_cougar" },
    { 0xEDC6E0E1, "vh_vtol" },
    { 0xDB5B6EC6, "vh_wheeler" },
    { 0xB76B4EEC, "vh_wingsuit" },
    { 0x6186007B, "vh_wisp" },
    { 0xF89C9985, "vh_wisp_mover" },
    { 0xE6429975, "vh_zodiac_jets" },
    { 0x3AA2267C, "vheicles" },
    { 0xAAD71C6F, "via" },
    { 0x396778EE, "via_powerup" },
    { 0xA05104EE, "viable" },
    { 0xE38E074A, "vibrate" },
    { 0x1E97587F, "vibrateaftertime" },
    { 0x0901974D, "vibrateamplitude" },
    { 0xDA4DA445, "vibratetime" },
    { 0xA5FD11A1, "vibration" },
    { 0xDB45C348, "vibrations" },
    { 0x5ED2279D, "vic" },
    { 0x64B5DF7A, "vice" },
    { 0x477D6A90, "vicinity" },
    { 0x615A2549, "victem" },
    { 0x8BCB913D, "victim" },
    { 0xC84B820E, "victim1" },
    { 0xA24907A5, "victim2" },
    { 0x9593A589, "victim_1" },
    { 0xBB961FF2, "victim_2" },
    { 0xE1989A5B, "victim_3" },
    { 0xB4E86222, "victim_ability" },
    { 0xC3D699DA, "victim_ammo" },
    { 0xE8403E22, "victim_animname" },
    { 0xCD971921, "victim_blood_fx" },
    { 0xDB244940, "victim_bp1_logic" },
    { 0x8D42B7F6, "victim_death" },
    { 0xAFC46A11, "victim_deathanim" },
    { 0x698B002A, "victim_dist_to_zone_origin" },
    { 0x3854BBC0, "victim_done" },
    { 0x5BD9EE89, "victim_doublejump_begin" },
    { 0x82701A51, "victim_doublejump_end" },
    { 0xCA27C9A2, "victim_fx_pump_duration" },
    { 0x45AC8176, "victim_gadget_power" },
    { 0xF6D73AB7, "victim_id" },
    { 0xDE226FD6, "victim_jump_begin" },
    { 0xA9592C1A, "victim_jump_end" },
    { 0x4CB74D48, "victim_list" },
    { 0xA0715BE6, "victim_score" },
    { 0x2127D377, "victim_setup" },
    { 0x8BE60129, "victim_slide_begin" },
    { 0xEEC9E9F1, "victim_slide_end" },
    { 0x3BECAC7C, "victim_spawner" },
    { 0x125503F9, "victim_swimming_begin" },
    { 0x85B4EFC1, "victim_swimming_end" },
    { 0x5D1971DD, "victim_wallrun_begin" },
    { 0xD4842F85, "victim_wallrun_end" },
    { 0x6A9F8D24, "victim_was_drowning" },
    { 0xFAD7926C, "victim_weapon" },
    { 0x1AB6AE89, "victimability" },
    { 0xE6AD924E, "victimactivebouncingbetties" },
    { 0xB51DE67F, "victimactiveproximitygrenades" },
    { 0x50B17209, "victimalternatefrontanim" },
    { 0x75A81C0F, "victimammo" },
    { 0x39B94C5C, "victimattackersthisspawn" },
    { 0xA0D11587, "victimbackanim" },
    { 0x349E388E, "victimbedout" },
    { 0xB5E94CB4, "victimbledout" },
    { 0x1C7E5537, "victimbodyindex" },
    { 0xD6B4E7E3, "victimclass" },
    { 0xD4514A46, "victimcombatefficiencylastontime" },
    { 0xAC8D5AB3, "victimcombatefficieny" },
    { 0xB712E1E0, "victimdialogname" },
    { 0x79EBAA4E, "victimelectrifiedby" },
    { 0x15081B04, "victimentnum" },
    { 0x08EFF9C3, "victimflashbacktime" },
    { 0x152F587E, "victimflatorigin" },
    { 0xD9FDF0ED, "victimfrontanim" },
    { 0x82B15D9D, "victimfxtag" },
    { 0x6DC341DD, "victimgadget" },
    { 0x0334B120, "victimgadgetpower" },
    { 0x0E60CCE9, "victimgadgetwasactivelastdamage" },
    { 0xF89B8925, "victimheroability" },
    { 0x149761BB, "victimheroabilityactive" },
    { 0xBD74D026, "victimheroabilityequipped" },
    { 0x960C176C, "victimheroabilityname" },
    { 0xFD26589A, "victimheropoweractive" },
    { 0x8D6B69EC, "victimheroweaponkillsthisactivation" },
    { 0x9846EC06, "victiminkillerfov" },
    { 0xD116C003, "victimisblackjack" },
    { 0x73C5CADD, "victimisroulette" },
    { 0x53EC26E8, "victimisthieforroulette" },
    { 0x81230E81, "victimkillstreakweaponindex" },
    { 0xB1B5179D, "victimlaststunnedby" },
    { 0x0492AB2D, "victimleftanim" },
    { 0x233CD484, "victimname" },
    { 0x4C5DC91D, "victimnode" },
    { 0x8F9A61BF, "victimonground" },
    { 0x5DB61F33, "victimorigin" },
    { 0x3FA6ED4C, "victimpowerarmorlasttookdamagetime" },
    { 0xA8E15AF6, "victimrightanim" },
    { 0xFBA7F2FC, "victims" },
    { 0xD563C62F, "victimsalive" },
    { 0xAA32D57E, "victimsoundmod" },
    { 0x24652CC7, "victimspawner" },
    { 0x0F75D090, "victimspeedburst" },
    { 0xD860A720, "victimspeedburstlastontime" },
    { 0xF7D83831, "victimstance" },
    { 0x3118D23A, "victimsupportindex" },
    { 0x13747EAA, "victimteam" },
    { 0xB320029C, "victimvisionpulseactivatetime" },
    { 0xA27DA11B, "victimvisionpulsearray" },
    { 0x2110084A, "victimvisionpulseorigin" },
    { 0xDD3A3CF5, "victimvisionpulseoriginarray" },
    { 0x82C262DE, "victimwasads" },
    { 0xB9995FB9, "victimwasdoublejumping" },
    { 0xEC335ABE, "victimwasheatwavestunned" },
    { 0xD56DB1AD, "victimwasinslamstate" },
    { 0xFC079577, "victimwaslungingwitharmblades" },
    { 0xA871D1C6, "victimwasonground" },
    { 0xA17A427B, "victimwasunderwater" },
    { 0xF67EC791, "victimwaswallrunning" },
    { 0xBAED683D, "victimweapon" },
    { 0xAB7637F2, "victimweaponpickedup" },
    { 0x8B5DE5F8, "victor" },
    { 0x5861B459, "victories" },
    { 0x42ECEBE0, "victorious" },
    { 0x7336A039, "victory" },
    { 0xE27B5D53, "victory_align" },
    { 0xC1E4C1C7, "victory_buffel_fire" },
    { 0x27F36AF4, "victory_buffel_target" },
    { 0xDFBE926C, "victory_dialog" },
    { 0x78E858F1, "victory_ending_dof_end" },
    { 0x8FED027A, "victory_ending_dof_start" },
    { 0x25ED257B, "victory_ent" },
    { 0x890EF38A, "victory_grass" },
    { 0xA4743D50, "victory_movie" },
    { 0x7B40BD8B, "victory_movie_done" },
    { 0x0D4B6E69, "victory_movie_go" },
    { 0xCC083F9D, "victory_shot_enemy" },
    { 0x4C1F6CD6, "victory_shot_friendlies" },
    { 0x6D9A6026, "victory_shot_friendly" },
    { 0x84775AB0, "victory_shot_friendly2" },
    { 0x1B018AE4, "victory_shots_warp" },
    { 0x5AFE3028, "victory_trigger" },
    { 0x7B0DE826, "victoryquotes" },
    { 0xECCAB862, "vid" },
    { 0xEBE71496, "video" },
    { 0xAC4BFA09, "videos" },
    { 0xAA8A97C2, "vietcong" },
    { 0xDF05820B, "vietnam" },
    { 0x3AE714DE, "vietnam_shot" },
    { 0x2F74D610, "vietnamese" },
    { 0x414D18CE, "view" },
    { 0x6DB18853, "view_ang" },
    { 0xB93F4E4D, "view_angles" },
    { 0xA3ED62DD, "view_chance" },
    { 0xC2A2D378, "view_cone" },
    { 0x002CF70E, "view_dot" },
    { 0x6143F114, "view_ent" },
    { 0x84C23287, "view_ents" },
    { 0x128EE544, "view_forward" },
    { 0xA66D8605, "view_frac" },
    { 0x7C8107E3, "view_goal_pos" },
    { 0xCADF64E0, "view_height" },
    { 0x36FA88B6, "view_kick_change" },
    { 0x3E7B4028, "view_location" },
    { 0xBA44FBCE, "view_location_ent" },
    { 0x8830D9DB, "view_magnet" },
    { 0xD2901375, "view_move_done" },
    { 0x7AC95CE9, "view_org" },
    { 0x2C1679C3, "view_origin" },
    { 0xD8E04D8D, "view_pos" },
    { 0xDCF70EB4, "view_position" },
    { 0xD6542A89, "view_score" },
    { 0x09B0EB16, "view_settings" },
    { 0xABEFF54F, "view_tag" },
    { 0x0CEC5234, "view_turn" },
    { 0x8F8E0F51, "view_vec" },
    { 0x462D8BDA, "viewable" },
    { 0xF526C8FB, "viewangle" },
    { 0x6BFB4F9A, "viewangles" },
    { 0x9DBCF044, "viewarm" },
    { 0x600992E4, "viewarm_cycle_updatehud" },
    { 0x26EC9DF7, "viewarms" },
    { 0x70EE967D, "viewarms_anim" },
    { 0x82570AC9, "viewarms_cycling" },
    { 0x32EAF772, "viewarms_cycling_updatehud" },
    { 0x5A624E41, "viewarms_hud" },
    { 0x93789C35, "viewarms_lastspindex" },
    { 0xC6E0F6D9, "viewarms_setup" },
    { 0x87E08063, "viewarms_steer_anim" },
    { 0xB659D305, "viewarms_steer_boost" },
    { 0xC18F10F2, "viewclampbottom" },
    { 0xD0DBEFAC, "viewclampleft" },
    { 0x1CECB543, "viewclampright" },
    { 0xCA128AA8, "viewclamptop" },
    { 0x4E3CB2F7, "viewcolor" },
    { 0xCECFD9CB, "viewcone" },
    { 0x99A7BD93, "viewdir" },
    { 0x0C494011, "viewed" },
    { 0x6C5D0D94, "viewhandmodel" },
    { 0xBD893D8C, "viewhands" },
    { 0x24A995D5, "viewhands_marine_sniper" },
    { 0x1A0301DB, "viewheight" },
    { 0x3806BD72, "viewing" },
    { 0xFF07A6C9, "viewingent" },
    { 0x216DAB30, "viewinit" },
    { 0x70B358CC, "viewkick" },
    { 0xE799EC38, "viewkickscalar" },
    { 0x73818D4A, "viewlerptime" },
    { 0x9EDC8B13, "viewlockedent" },
    { 0xEF4DAAA5, "viewlockedentity" },
    { 0x77EE75FE, "viewlockent" },
    { 0xF0EBB875, "viewmodel" },
    { 0xCB2CF84E, "viewmodel_anims" },
    { 0xDC19C590, "viewmodel_arms_down" },
    { 0x7B3E60EB, "viewmodel_arms_up" },
    { 0xFCE71F63, "viewmodel_nic_04_01_shattered_grenade" },
    { 0x02100E47, "viewmodel_off" },
    { 0x33DB7D33, "viewmodel_on" },
    { 0xEFCC93D3, "viewmodelfx" },
    { 0xED6991F9, "viewmodelhastag" },
    { 0x2594FD44, "viewmodels" },
    { 0xE13C8192, "viewmovementspeed" },
    { 0x8A31D9F7, "viewoffset" },
    { 0x7650E860, "vieworg" },
    { 0x85CA4AB4, "vieworigin" },
    { 0x7CB82A21, "viewpercentag" },
    { 0x1B4933C4, "viewpoint" },
    { 0x86873BAF, "viewport" },
    { 0x9F5CD2B0, "viewpos" },
    { 0xF0D62A90, "viewpos_dvar" },
    { 0x9428A734, "viewpostocorner" },
    { 0x53D741F7, "viewrad" },
    { 0x3B1E9494, "viewraddir" },
    { 0xD48B9C30, "viewradexpandcount" },
    { 0x5E0CDAC7, "viewradexpandmax" },
    { 0xD4833871, "views" },
    { 0xEBAC8A6C, "viewshieldmodel" },
    { 0x5AE336C6, "viewtag" },
    { 0x0C004DA1, "viewtarget" },
    { 0x734D3191, "viewtargetpos" },
    { 0x6BDD8B21, "viewtime" },
    { 0x70A1C976, "viewturner" },
    { 0xE0AE0842, "vig1" },
    { 0xA4A59CE6, "vig1node" },
    { 0xBAAB8DD9, "vig2" },
    { 0x0AB822F0, "vig2end" },
    { 0x3E68F709, "vig2node" },
    { 0x94A91370, "vig3" },
    { 0xEE6B2C94, "vig3node" },
    { 0x9EBA6C4F, "vig4" },
    { 0x449A9636, "vig_ai" },
    { 0x4A227D2C, "vig_num" },
    { 0x6B6A3693, "vig_spawners" },
    { 0x74FA0EFF, "vig_struct" },
    { 0x69E1D506, "vig_structs" },
    { 0x469F6EE8, "vig_trigger" },
    { 0xE5ED7883, "vig_triggers" },
    { 0x6E7AD9D2, "vigneete" },
    { 0x7D9EF8EB, "vignette" },
    { 0xCF4CE6A9, "vignette0_count" },
    { 0x63A6406B, "vignette_count" },
    { 0x410C8E39, "vignette_dudes" },
    { 0xB2BFCF4F, "vignette_funcs" },
    { 0x392D6A2F, "vignette_group" },
    { 0xC9687B2B, "vignette_mode" },
    { 0xC44A134B, "vignette_name" },
    { 0x145B2212, "vignettemode" },
    { 0xD935235B, "vignettemodecallback" },
    { 0x721CADCA, "vignettes" },
    { 0x1C9ACDC0, "vigorously" },
    { 0x8EE5FAE5, "vik" },
    { 0x8222FAFB, "vikharev" },
    { 0x4A1E17C9, "vikharev_door_node" },
    { 0x06587143, "viking" },
    { 0x876C7840, "viktor" },
    { 0x69608603, "vile" },
    { 0x9628709F, "villa" },
    { 0x8CDBEC1B, "village" },
    { 0xF12A8FBE, "village_1_spawn_trucks" },
    { 0x766BBB3F, "village_aa_gun" },
    { 0xCABD3664, "village_aa_gun_guards" },
    { 0x58E78EDA, "village_ai_intros" },
    { 0x9062925E, "village_amb" },
    { 0xE4B06482, "village_ambience" },
    { 0x083DF178, "village_animation_struct" },
    { 0xC4B31678, "village_anims" },
    { 0x746C6076, "village_approach" },
    { 0x14B52997, "village_assault" },
    { 0x0A4508BA, "village_assault_amb" },
    { 0xD1547DDD, "village_assault_anim" },
    { 0x5A491D59, "village_assault_art" },
    { 0x511B59D1, "village_assault_code" },
    { 0x250BB648, "village_assault_fx" },
    { 0xC7FF1CBE, "village_assault_snapshot" },
    { 0x4FF93710, "village_badguy" },
    { 0x3E5E8BDA, "village_badguy_escape" },
    { 0x105C6E04, "village_blocker" },
    { 0x12F42D6F, "village_bmp" },
    { 0x64528D0D, "village_buildings" },
    { 0x7B24F1FE, "village_cleanup" },
    { 0x03E2DED3, "village_damaged" },
    { 0x8607A3DA, "village_defend" },
    { 0x6E85B4BB, "village_defend_amb" },
    { 0xE600126E, "village_defend_anim" },
    { 0x45219598, "village_defend_art" },
    { 0xBC4D945E, "village_defend_code" },
    { 0xD5E36ACF, "village_defend_fx" },
    { 0x1F55CD4D, "village_defend_intro" },
    { 0x9EF0933E, "village_defend_intro_dvars" },
    { 0x584D6D6B, "village_diff" },
    { 0x20F42312, "village_enemies" },
    { 0x740C9385, "village_enemies_allert" },
    { 0x7E942129, "village_enemies_spawn_function" },
    { 0x1DC3A103, "village_execution_anims" },
    { 0x8ADC6FD5, "village_execution_anims_old" },
    { 0xF1CE975A, "village_executioner_spawn_func" },
    { 0xC4B5997C, "village_fail_general_logic" },
    { 0x6C2ED609, "village_fails" },
    { 0x7A3C7937, "village_flags" },
    { 0x4E935263, "village_friendlies" },
    { 0x3393DBFE, "village_friendlies_six" },
    { 0xB700703D, "village_guard_idle_logic" },
    { 0x8288D9D5, "village_helicopter" },
    { 0x29943F01, "village_helis" },
    { 0x1E44D2B0, "village_heycart_animations" },
    { 0x4DF64D70, "village_hut_kill" },
    { 0x9B219E84, "village_hut_start" },
    { 0x838CD42F, "village_intro_anims" },
    { 0x10040B64, "village_livestock_setup" },
    { 0xBB0EF381, "village_m202_destroyed" },
    { 0x7E2EFC91, "village_mark" },
    { 0xB3C3D98C, "village_meatshield_events" },
    { 0x32E7C288, "village_nag" },
    { 0xC64B3BC6, "village_objectives" },
    { 0x1F5BFC7B, "village_patrol_anims" },
    { 0x9BC98672, "village_patrols_and_guards" },
    { 0x1B9991F3, "village_pdf_ransacking_anims" },
    { 0x88E3DF09, "village_price" },
    { 0x57FA00EB, "village_progression_save_point_trigger" },
    { 0xB8ADE99E, "village_reveal_scenes_start" },
    { 0xCDC751BF, "village_runner_logic" },
    { 0x52D0ED37, "village_section" },
    { 0xF7B8189F, "village_spawn_funcs" },
    { 0x5AB1DBEC, "village_start_drones_notify" },
    { 0x9A23A78B, "village_stealth" },
    { 0x4A6FF986, "village_stealth_fail" },
    { 0x13B1679D, "village_stealth_hint" },
    { 0x3617F6CC, "village_stop_drones_notify" },
    { 0x1A561445, "village_tower" },
    { 0x4256495E, "village_trucks" },
    { 0xA7A49E92, "villagers" },
    { 0xDEC0353A, "villages" },
    { 0x56B8063A, "villain" },
    { 0xDEEB8915, "vin_area_stackers_setup" },
    { 0xAB063B74, "vince" },
    { 0xCC523DDF, "vine_model" },
    { 0x2D42F985, "vinecluster" },
    { 0x0DD9295D, "vinemed" },
    { 0x4BDBE529, "vinesm" },
    { 0x1D755FED, "vingette" },
    { 0x2FD53672, "vintersect2d" },
    { 0xF130C3DE, "vinyl_add_pickup" },
    { 0x82E2C59B, "vinyl_pickup_air" },
    { 0x1654CAA2, "vinyl_pickup_elec" },
    { 0x6C9C14C9, "vinyl_pickup_fire" },
    { 0x156BDE2E, "vinyl_pickup_ice" },
    { 0x51B81757, "vinyl_pickup_master" },
    { 0xC057EF82, "vinyl_pickup_player" },
    { 0x70D4071E, "violent" },
    { 0xFE4B5444, "violet" },
    { 0x24ACFB76, "vip" },
    { 0xC59AE9B1, "vip_can_still_fight" },
    { 0x203674F9, "vip_car_01" },
    { 0x4638EF62, "vip_car_02" },
    { 0x6C3B69CB, "vip_car_03" },
    { 0x39969F7A, "vip_cougar" },
    { 0x4F77DF21, "vip_death" },
    { 0xC732035F, "vip_guards" },
    { 0xD05AB5F8, "vip_protector_index" },
    { 0x9E5D7768, "vip_protectors" },
    { 0xF30CD797, "vip_rescue_dialogue" },
    { 0x6A31B2CD, "vip_rescue_node" },
    { 0xA1A6303F, "vip_spawner" },
    { 0xE1C41B3D, "vip_spot_manager" },
    { 0xC68729DC, "vip_spots" },
    { 0xEBCF2250, "vip_talks_to_price" },
    { 0xC4E6B9AF, "vip_zone" },
    { 0x054AEF1D, "vipforward" },
    { 0x40A144B0, "vipright" },
    { 0x6B37D269, "vips" },
    { 0xE80F490E, "virgo" },
    { 0xE6D8264E, "virtual" },
    { 0x579A92F5, "virtual_health_state" },
    { 0x985DCA08, "virus" },
    { 0x2D8E539E, "vis1" },
    { 0x078BD935, "vis2" },
    { 0xE1895ECC, "vis3" },
    { 0xBB86E463, "vis4" },
    { 0x71E06A03, "vis_check_done" },
    { 0x36A242B0, "vis_dist" },
    { 0x6217CC95, "vis_dot" },
    { 0xA988A7B9, "vis_name" },
    { 0xED297A0E, "vis_team_mask" },
    { 0x5C7DEA2F, "visbile" },
    { 0xDF588FEA, "visbileroll" },
    { 0x00A030E7, "visenemy" },
    { 0x52A71E60, "visibile" },
    { 0x88CB27D1, "visibility" },
    { 0x5AB41DA9, "visible" },
    { 0x67C17488, "visible_alpha" },
    { 0x3D4472B8, "visible_amount" },
    { 0xCC861AC0, "visible_mgguy_think" },
    { 0xF7FCE7DA, "visiblecarriermodel" },
    { 0x4BDE363B, "visibleenemy" },
    { 0x4E91AA5B, "visibleents" },
    { 0x95F307F0, "visiblemodel" },
    { 0x4E09F383, "visibleonlytoplayer" },
    { 0x24EAEB13, "visibleradius" },
    { 0x8CE56CE6, "visibleradiussquared" },
    { 0xEFBF54A4, "visibleroll" },
    { 0xB3EDD70E, "visibleteam" },
    { 0xA0425577, "visibletoall" },
    { 0x190C3500, "visiblity" },
    { 0x82F98125, "visibly" },
    { 0xEC2798A1, "vision" },
    { 0x68B518B5, "vision_angle" },
    { 0x0A068ECB, "vision_bike" },
    { 0x6BC152D4, "vision_change" },
    { 0x71D57B07, "vision_cheat_enabled" },
    { 0x3C5DC1A4, "vision_dist" },
    { 0x1813BDAE, "vision_dist2" },
    { 0xA3CBDC22, "vision_exterior" },
    { 0x44813A2E, "vision_file" },
    { 0x2632BF96, "vision_find_woods" },
    { 0xCFB59016, "vision_glow_change" },
    { 0xE658AC49, "vision_inclinator" },
    { 0xAFD19564, "vision_interior" },
    { 0xBA7C7410, "vision_interrogation_handler" },
    { 0x4F9138B3, "vision_jiffylube_handler" },
    { 0x9170D330, "vision_jiffylube_room" },
    { 0xE06EFE51, "vision_leave_container" },
    { 0x121713B8, "vision_millibar_room" },
    { 0xBD7D140C, "vision_mines" },
    { 0xE6405116, "vision_open_doors" },
    { 0x6082F476, "vision_pulse_changed" },
    { 0x7424A0F9, "vision_pulse_constid_edge_width" },
    { 0x16270320, "vision_pulse_constid_highlight_enemies" },
    { 0xD172FE4F, "vision_pulse_constid_iris_fade" },
    { 0x260FF690, "vision_pulse_constid_max_radius" },
    { 0x2433A64F, "vision_pulse_constid_pulse_width" },
    { 0x8BC24499, "vision_pulse_constid_radius" },
    { 0xCDDDD0FC, "vision_pulse_constid_viewmodel_edge_width" },
    { 0x0F541804, "vision_pulse_constid_viewmodel_is_pulsed" },
    { 0x30BF2915, "vision_pulse_constid_viewmodel_origin_x" },
    { 0x0ABCAEAC, "vision_pulse_constid_viewmodel_origin_y" },
    { 0xE16B6EB9, "vision_pulse_constid_viewmodel_pulse_position" },
    { 0x93E67484, "vision_pulse_constid_viewmodel_pulse_width" },
    { 0x91EE66CE, "vision_pulse_duration" },
    { 0x527D20AD, "vision_pulse_ent_script_vector" },
    { 0x5274159F, "vision_pulse_fade_ramp_in" },
    { 0x8BEF3F4A, "vision_pulse_fade_ramp_out" },
    { 0xA100B03F, "vision_pulse_miss_alias" },
    { 0x146E584B, "vision_pulse_owner" },
    { 0xF26B9E10, "vision_pulse_owner_death" },
    { 0xDB5A914C, "vision_pulse_owner_valid" },
    { 0xB1448DF1, "vision_pulse_ramp_out_time" },
    { 0x16F8DA67, "vision_pulse_reveal_time" },
    { 0xE9F006A2, "vision_pulse_visionset" },
    { 0xC0240A6F, "vision_pulse_visionset_alias" },
    { 0x83CCD8C9, "vision_pulse_visionset_priority" },
    { 0xC9798EB3, "vision_pulse_visionset_ramp_hold" },
    { 0xE7634049, "vision_pulse_visionset_ramp_in" },
    { 0x2158B060, "vision_pulse_visionset_ramp_out" },
    { 0xF044C04A, "vision_pulse_visionset_steps" },
    { 0x66F51E24, "vision_pulse_watch_death" },
    { 0x7FB55794, "vision_pulse_watch_emp" },
    { 0x43073AAC, "vision_set" },
    { 0xE076975A, "vision_set_avalanche" },
    { 0x2DB1917C, "vision_set_bridge" },
    { 0x42C24049, "vision_set_bright_duration_max" },
    { 0x5DB76BF7, "vision_set_bright_duration_min" },
    { 0x4D29350A, "vision_set_catwalk" },
    { 0xC6655BF3, "vision_set_change" },
    { 0xA91EB621, "vision_set_dark_duration_max" },
    { 0x53CCDE5F, "vision_set_dark_duration_min" },
    { 0xE50A015C, "vision_set_deck" },
    { 0xBF327136, "vision_set_default" },
    { 0xA5651739, "vision_set_exterior_01" },
    { 0x2EC4D36F, "vision_set_hallway" },
    { 0x6EC8AB52, "vision_set_hanger" },
    { 0x4D54C91B, "vision_set_hanger_elevator" },
    { 0x00621E8D, "vision_set_init" },
    { 0xDBDD6DB0, "vision_set_interrogation" },
    { 0xDB7B36F4, "vision_set_lowerlevel" },
    { 0x2E2A31EA, "vision_set_mason_serverroom" },
    { 0xF26F7641, "vision_set_menendez" },
    { 0xD143D4EE, "vision_set_name" },
    { 0x89D1641B, "vision_set_preclaw" },
    { 0xAA0B97F5, "vision_set_sensitive_room" },
    { 0xB68F7FE0, "vision_set_trigger_think" },
    { 0x0DA6598A, "vision_set_value" },
    { 0xA96F7F3E, "vision_set_vent" },
    { 0xC2DFBFAF, "vision_sets" },
    { 0x7CD745CC, "vision_sets_init" },
    { 0xD752D0E3, "vision_settings" },
    { 0x3DD51CA9, "vision_settings_dark_night" },
    { 0x04779A84, "vision_settings_daylight" },
    { 0x8E6E396A, "vision_settings_daylight_instant" },
    { 0x08403871, "vision_settings_light_night" },
    { 0x2E8AC20F, "vision_slingshot" },
    { 0x3CBFE6FD, "vision_superkill" },
    { 0x380B14C2, "vision_to_set" },
    { 0x5BB3C0D9, "vision_torture_room" },
    { 0xBA96B175, "vision_totalpercent" },
    { 0x4031CA30, "vision_trigger" },
    { 0x1539471D, "vision_trigs" },
    { 0x836BC9F3, "vision_underwater_explosion" },
    { 0xEFFD25D9, "vision_underwater_swimming" },
    { 0x6AEC7C2D, "vision_warehouse" },
    { 0x62979C5B, "vision_wobble" },
    { 0x6379E40F, "visionfile" },
    { 0x2F531102, "visionfilename" },
    { 0x14604F5C, "visionpulseactivatetime" },
    { 0xE8673DDB, "visionpulsearray" },
    { 0x49C73C0A, "visionpulseorigin" },
    { 0xE8C4CCB5, "visionpulseoriginarray" },
    { 0x1310CEAB, "visionpulsereveal" },
    { 0xE4D4FEA9, "visionpulserevealself" },
    { 0xC100FF05, "visionpulsespottedenemy" },
    { 0x931B4CA2, "visionpulsespottedenemytime" },
    { 0xD2EB21EB, "visionset" },
    { 0xA91119A2, "visionset_change" },
    { 0xC6454019, "visionset_change_thread" },
    { 0x49D0F7E3, "visionset_changetrigs" },
    { 0x0D88CF4C, "visionset_fade" },
    { 0xF78FE2C1, "visionset_firehorse" },
    { 0x2619B658, "visionset_flyin" },
    { 0xCC353152, "visionset_from" },
    { 0x40B906CC, "visionset_func" },
    { 0xB9E246FC, "visionset_idle" },
    { 0x3CC52D95, "visionset_idle_fade" },
    { 0x05EF0097, "visionset_in" },
    { 0xD9FD7B6E, "visionset_info" },
    { 0x7BF05F3B, "visionset_lerp_cb" },
    { 0xE216C11C, "visionset_mgr" },
    { 0x29121A9D, "visionset_mgr_deactivate" },
    { 0x0EB89279, "visionset_mgr_deactivate_all" },
    { 0x8A3E50D4, "visionset_mgr_reset" },
    { 0x56EB9930, "visionset_mgr_shared" },
    { 0x9BAC4E4B, "visionset_name" },
    { 0xC28EEB62, "visionset_out" },
    { 0x1FDB69B8, "visionset_restore" },
    { 0x591B2F99, "visionset_run" },
    { 0x08DEBA36, "visionset_run_fade" },
    { 0x4A0F22DA, "visionset_slot_cb" },
    { 0xC5F576D5, "visionset_to" },
    { 0x286AA4C6, "visionset_trigger" },
    { 0xD06CAAF6, "visionset_type" },
    { 0xCEDB02D7, "visionset_update_cb" },
    { 0xDB58FAFA, "visionset_vehicle" },
    { 0x714038E6, "visionsetberserker" },
    { 0x754DB772, "visionsetchangeback" },
    { 0x25EA08C8, "visionsetchangeto" },
    { 0x388F6A7A, "visionsetclear" },
    { 0xE0A3011D, "visionsetcrouch" },
    { 0xBB99CE8C, "visionsetdamage" },
    { 0x9AA169F1, "visionsetlaststand" },
    { 0x936E0056, "visionsetlaststandlerp" },
    { 0xD8B4B5A5, "visionsetlerpratio" },
    { 0x38A49890, "visionsetmissilecamforplayer" },
    { 0x6A90DA04, "visionsetnaked" },
    { 0xB4011AF6, "visionsetnakedforplayer" },
    { 0xA106AC5F, "visionsetnakedlerp" },
    { 0x00B81286, "visionsetname" },
    { 0xEC39824F, "visionsetnight" },
    { 0xB90138CA, "visionsets" },
    { 0x492E2B1E, "visionsetsmoke" },
    { 0x2637390B, "visionsettoggle" },
    { 0xD50F91A4, "visionsettranstime" },
    { 0xA2415BCC, "visionsetunderwater" },
    { 0xC071AF49, "visionstaytime" },
    { 0xF67CD15E, "visionstore_glowtweakbloomcutoff" },
    { 0x1DB3BDB4, "visionstore_glowtweakbloomdesaturation" },
    { 0xE0AFF0CC, "visionstore_glowtweakbloomintensity0" },
    { 0x06B26B35, "visionstore_glowtweakbloomintensity1" },
    { 0x653187E1, "visionstore_glowtweakenable" },
    { 0xA73FBB02, "visionstore_glowtweakradius0" },
    { 0xCD42356B, "visionstore_glowtweakradius1" },
    { 0xA9E9096C, "visionstore_glowtweakskybleedintensity0" },
    { 0xCFEB83D5, "visionstore_glowtweakskybleedintensity1" },
    { 0x39385031, "visionswitch" },
    { 0xE6D84757, "visiontransintime" },
    { 0xE7A08210, "visiontransouttime" },
    { 0xCBB5E0E6, "visit" },
    { 0xA5462069, "visited" },
    { 0x4A0C645A, "visitedzones" },
    { 0x858EBA7A, "visiting" },
    { 0x833E822B, "visitname" },
    { 0xAE9DBBAC, "visitors" },
    { 0x9FDBA536, "vison_settings" },
    { 0x45F96B32, "visor" },
    { 0xE987A03C, "visor_distortion" },
    { 0xD19E6CE3, "visor_message_boot_up" },
    { 0x726237E8, "visor_off" },
    { 0x679DE202, "visor_on" },
    { 0x6AE3D812, "visor_update_soct" },
    { 0x18CAAC9E, "visowner" },
    { 0x78F987D0, "vista" },
    { 0xE230C916, "vista_delete" },
    { 0x2FC6C020, "vista_highrise" },
    { 0x49CCCBE5, "vista_light" },
    { 0x896BBB3F, "vista_path_paths" },
    { 0x0278B429, "vista_path_total" },
    { 0x732C401F, "vista_robot_pose" },
    { 0x6A38A1AE, "vista_rockets" },
    { 0x1F132269, "visual" },
    { 0xA36F702B, "visualization" },
    { 0xF49FC7A1, "visualize" },
    { 0x0A883C34, "visually" },
    { 0xC2DDFCE0, "visuals" },
    { 0xA87C1C51, "vital" },
    { 0xBB6EB238, "vitals" },
    { 0x3FA0DB1E, "vlaue" },
    { 0x85D4362E, "vlen" },
    { 0xED8C9C49, "vlength" },
    { 0xD97A3266, "vm" },
    { 0x0BCBB5DC, "vm_end" },
    { 0x1F7CC6B7, "vm_start" },
    { 0x271083DB, "vma" },
    { 0x0AB1FF49, "vmax" },
    { 0x2625E243, "vmaxaispeedoverridge" },
    { 0xC5F2E355, "vmaxspeedoverridge" },
    { 0x9917F316, "vmd" },
    { 0x4D12FE44, "vmf" },
    { 0x57245723, "vmi" },
    { 0x25A72AF7, "vmin" },
    { 0xE51CE7E8, "vmj" },
    { 0xB2B2FE68, "vmodel" },
    { 0x3B333599, "vms" },
    { 0xF93F99A6, "vmt" },
    { 0x2055D956, "vmtype" },
    { 0x176DA451, "vnd_spline" },
    { 0x9D033FF1, "vnode" },
    { 0x02AAB1EC, "vnormal" },
    { 0x8D753D94, "vo" },
    { 0x89B6E7CD, "vo_aa_guns" },
    { 0xB01B9811, "vo_after_bp3_story" },
    { 0x4670A210, "vo_after_drag" },
    { 0x0B11E634, "vo_after_parking_structure" },
    { 0xFF87FA94, "vo_after_speech" },
    { 0x8362E2F4, "vo_alias_call" },
    { 0x3CB5D841, "vo_alias_response" },
    { 0xEFB02BB6, "vo_alley" },
    { 0xF91CC4CD, "vo_animname" },
    { 0xC4518203, "vo_announce_bp3_event" },
    { 0x5844B13C, "vo_anthem" },
    { 0x57D9321F, "vo_approach" },
    { 0x64804215, "vo_approach_bp1" },
    { 0x17BE6DE5, "vo_archway_enemy" },
    { 0x7C702618, "vo_area_alerted" },
    { 0xB2D28BFA, "vo_around_the_turn" },
    { 0xA7254166, "vo_array" },
    { 0x6A456D3E, "vo_at_tunnel_entrance" },
    { 0x7A61FFBF, "vo_atd_ball1_sniped" },
    { 0xB638099B, "vo_avoid_spotlight" },
    { 0x8EEBCF14, "vo_avoid_spotlight_detected" },
    { 0x08584FF6, "vo_b2_vc_chef" },
    { 0x19CCE8A1, "vo_b2_vc_windows" },
    { 0xA779C832, "vo_b4_vc_across_wall" },
    { 0x1DE49138, "vo_barnes_dive_gap" },
    { 0xD25485A2, "vo_base_under_attack" },
    { 0x295098A9, "vo_before_comm" },
    { 0x00C54F2A, "vo_before_struggle_room" },
    { 0xC86F576E, "vo_boat_damage_bowman" },
    { 0xA8B9F008, "vo_boat_damage_mason" },
    { 0x25580D70, "vo_boat_damage_woods" },
    { 0xDEB04C7E, "vo_boat_misc_features" },
    { 0x8BAF3872, "vo_bowman_index" },
    { 0x0EEE6E91, "vo_bp1_btr1_dead" },
    { 0x3A071F64, "vo_bp1_btr1_spawn" },
    { 0xA14CFA5C, "vo_bp1_btr2_dead" },
    { 0x835B1AB4, "vo_bp1_player_at_ammo_cache" },
    { 0x4F1554D1, "vo_bp1_player_enters_blocking_point" },
    { 0x3E251C80, "vo_bp1_player_pushed_into_blocking_point" },
    { 0xA26867C5, "vo_bp1_rpg_shot" },
    { 0x405F1EB9, "vo_bp2" },
    { 0x1A5CA450, "vo_bp3" },
    { 0x144C268E, "vo_bp3_story" },
    { 0x88C6A934, "vo_bridge" },
    { 0xE1B3D118, "vo_bridge_destroyed" },
    { 0x4573075D, "vo_bridge_four_part_convo" },
    { 0x9A656BDA, "vo_bridge_soliloquy" },
    { 0xE94CAA08, "vo_bus_dam" },
    { 0x873BAF71, "vo_bus_dam_enemy" },
    { 0xBE73F0FA, "vo_bus_smash" },
    { 0x040060B1, "vo_call_to_gate" },
    { 0xBF426FE4, "vo_callouts" },
    { 0xAD14238F, "vo_callouts_intro" },
    { 0xB5558ED5, "vo_cam_active" },
    { 0xA1AD76B2, "vo_cam_forward_dist_ai" },
    { 0xEF93CF2B, "vo_cam_forward_dist_overwatch" },
    { 0x216CA5BF, "vo_capture" },
    { 0xB3B0F220, "vo_change_level" },
    { 0xF9FD09CE, "vo_chinook_arrival" },
    { 0x41871218, "vo_chinook_in_position" },
    { 0xA7A5AEFE, "vo_choose_left_path" },
    { 0xDB3B0B2B, "vo_choose_right_path" },
    { 0xA2239D5F, "vo_choppers" },
    { 0x3EDCF2DC, "vo_claw_defend_enemy" },
    { 0x1915CEE3, "vo_claw_enemy" },
    { 0xCC21B072, "vo_claw_flamethrower_enemy" },
    { 0x7B6643E1, "vo_claw_grenade" },
    { 0x9CDC1720, "vo_claw_grenade_enemy" },
    { 0xEE7E8E3D, "vo_claw_rooftop_enemy" },
    { 0x56AC685E, "vo_claw_streets_enemy" },
    { 0x8D64E238, "vo_claws_leaving" },
    { 0x8D7D5216, "vo_clear_mortar_wave" },
    { 0x5127C0C2, "vo_clear_underwater" },
    { 0xE6532131, "vo_clear_vehicle_wave" },
    { 0xBEBC3578, "vo_convoy_damage_nag" },
    { 0x7806F0B3, "vo_convoy_distance_check_nag" },
    { 0x24C1BB06, "vo_convoy_distance_check_nag_stop" },
    { 0xBAA7DA17, "vo_convoy_strafed" },
    { 0x18D6B63D, "vo_corpse_alley" },
    { 0x3EA93715, "vo_counter" },
    { 0xF37D367C, "vo_courtyard" },
    { 0xA9D9A77F, "vo_defend" },
    { 0x2C2D0214, "vo_delay" },
    { 0xD934B910, "vo_delay_time" },
    { 0xC6E1BB79, "vo_detonation_warning" },
    { 0x31AC0511, "vo_dialog_id" },
    { 0x5591FF53, "vo_dogfight" },
    { 0xF8B83610, "vo_dogfight_f35" },
    { 0xB5A56FF5, "vo_done_bp1" },
    { 0xAD7290E8, "vo_downtown_hurry" },
    { 0x2A89E351, "vo_drone_control" },
    { 0xACD269CA, "vo_drone_control_intro" },
    { 0xC4E7ED32, "vo_drone_market" },
    { 0x8548191A, "vo_drones_offline" },
    { 0x086C0B85, "vo_during_drag" },
    { 0x4595356E, "vo_eject" },
    { 0xC40AD283, "vo_eject_collision" },
    { 0x89DC2AB5, "vo_eject_f35" },
    { 0xE59E96F4, "vo_engagement_bp1" },
    { 0xD0C09C8A, "vo_ent" },
    { 0x20859DB9, "vo_enter_bp1" },
    { 0x0FB8D5E5, "vo_escape_start_player" },
    { 0xCB50CDA8, "vo_evade_terrorists" },
    { 0xF01A1BC1, "vo_exit_control_room" },
    { 0x2B62634E, "vo_explosive_bp1" },
    { 0x41428140, "vo_extra_reanov_line" },
    { 0x0C495A76, "vo_f35_boarding" },
    { 0x198FC861, "vo_f35_startup" },
    { 0x8CB6DE12, "vo_f35_startup_f35" },
    { 0xA6EEADEA, "vo_f35_startup_harper" },
    { 0xE944FD73, "vo_f35_startup_player" },
    { 0x72565478, "vo_f38_fired_cannons" },
    { 0x2DAFBB5A, "vo_f38_fired_missile" },
    { 0x4D7B9FA3, "vo_f38_shot_down_drone" },
    { 0x900D2054, "vo_f38_target_lock_on_and_off" },
    { 0x858BAE55, "vo_fake_guards" },
    { 0x94C25A98, "vo_fall_down_hole" },
    { 0x528BD1B2, "vo_farmhouse_intro" },
    { 0x04187849, "vo_find_nav_card" },
    { 0xF3AD6345, "vo_find_town" },
    { 0xA3DDCA57, "vo_fire_at_yemeni" },
    { 0x4A8D998A, "vo_fire_directed" },
    { 0x5940CFD7, "vo_first_claw" },
    { 0xD098C802, "vo_first_guys" },
    { 0xCDF20F37, "vo_first_turn_sampans" },
    { 0x33623A56, "vo_flashback" },
    { 0xDE23B98C, "vo_for_alerted" },
    { 0xEC90AABF, "vo_for_hazmat_enemies" },
    { 0x897ACD7A, "vo_fourth_guys" },
    { 0x9E4CBEA8, "vo_fridge" },
    { 0x58C04631, "vo_frogger" },
    { 0x0AAAE730, "vo_frogger_enemy" },
    { 0xF53B3879, "vo_frogger_support" },
    { 0x7AD8AF5E, "vo_gaz_guys" },
    { 0xCA6EC856, "vo_gaz_melee" },
    { 0xE6192D3B, "vo_get_horse" },
    { 0xD09604A8, "vo_grapple" },
    { 0x158A9D8B, "vo_ground_air_transition" },
    { 0xCE308F1E, "vo_guantlet_left_balcony_rpg" },
    { 0x790E733C, "vo_guard_tower" },
    { 0x0A817A44, "vo_guy" },
    { 0x90BE8EDF, "vo_hangar_battle" },
    { 0xCE3799A1, "vo_head_to_bp1exit" },
    { 0x2759B918, "vo_heli_dead" },
    { 0x2AC94C03, "vo_helo_killed" },
    { 0x2183F28D, "vo_helo_wave_completed" },
    { 0xCFC2C459, "vo_hide_guard" },
    { 0xAF85EEA4, "vo_hijacked" },
    { 0x35C22B4F, "vo_hijacked_intro" },
    { 0x80993FCE, "vo_hijacked_left_path" },
    { 0x2D6FDFBB, "vo_hijacked_right_path" },
    { 0x3219018A, "vo_hind_breakaway" },
    { 0x28908E66, "vo_hint_standing_by_for_targets" },
    { 0x30633211, "vo_hip_rappel" },
    { 0x144492AC, "vo_horse_riders_bp1" },
    { 0x7A650AFB, "vo_hotel" },
    { 0xED2388D6, "vo_hud" },
    { 0x975D287D, "vo_hudson_call_back_to_base" },
    { 0xBD8BAA97, "vo_hudson_woods_putdown" },
    { 0xBBB32555, "vo_human_killed_chance" },
    { 0x565654CB, "vo_human_killer_chance" },
    { 0x69365B72, "vo_human_survival_chance" },
    { 0x84F0EC58, "vo_in_maze" },
    { 0x692A3139, "vo_incoming_at_blocking_points" },
    { 0xBEE7D650, "vo_incoming_first_time" },
    { 0xBBD7057D, "vo_index" },
    { 0xF805B2D5, "vo_indexes" },
    { 0xB58EAD1F, "vo_initial_island" },
    { 0x44DF98F1, "vo_interrogator" },
    { 0xD0EA185F, "vo_intro" },
    { 0x2D68D63E, "vo_intro_bp2" },
    { 0xE6A9C808, "vo_intro_drone" },
    { 0x01711046, "vo_intro_enemy" },
    { 0x0FD1662D, "vo_just_played" },
    { 0x690FEBCF, "vo_kill_terrorists" },
    { 0xAE8C80A9, "vo_killedby_player" },
    { 0xBE45CCED, "vo_killzone" },
    { 0xC11EFA7A, "vo_lapd_intersection" },
    { 0x5B28A3B9, "vo_lapd_plaza" },
    { 0x630B3FBC, "vo_lapd_street" },
    { 0x4A9D37B2, "vo_last_followup" },
    { 0xF8E7EB4D, "vo_last_time" },
    { 0xF6A3A5F2, "vo_leave_bp1" },
    { 0x3F84A376, "vo_level_start" },
    { 0x58863C39, "vo_line" },
    { 0x9AA6DF82, "vo_line_chosen" },
    { 0xE9202857, "vo_line_notify" },
    { 0xBD817EA5, "vo_line_position" },
    { 0x556583AD, "vo_lost_lock" },
    { 0x7A857E6C, "vo_lost_lock_on_drone" },
    { 0x97B1D52B, "vo_magic_rpg_guys" },
    { 0x587F9F37, "vo_market" },
    { 0xB353DADA, "vo_market_done" },
    { 0x63E65169, "vo_market_end" },
    { 0x6B3B2720, "vo_market_enter" },
    { 0xBC70811A, "vo_market_exit" },
    { 0x3D64EE9F, "vo_mason" },
    { 0x697BDBBA, "vo_maxis_atd_ball1_sniped" },
    { 0xFCDBC70F, "vo_maxis_atd_ball2_sniped" },
    { 0xA3BFF9AF, "vo_maxis_atd_elevators" },
    { 0xBFF60608, "vo_maxis_atd_order_complete" },
    { 0x1CF71DA9, "vo_maxis_atd_order_error" },
    { 0xB8D1776A, "vo_maxis_do_quest" },
    { 0x628C1503, "vo_maxis_find_sniper" },
    { 0xC5B21B02, "vo_maxis_first_tower" },
    { 0x24A58F3A, "vo_maxis_player_has_pap_ballistic" },
    { 0xA5778364, "vo_maxis_punch_tower" },
    { 0xFC167EA5, "vo_maxis_slb_hint" },
    { 0x27F0E48B, "vo_maxis_sliquify_fail" },
    { 0xB85F4FB2, "vo_maxis_ssp_complete" },
    { 0x970804D3, "vo_maxis_ssp_fail" },
    { 0x84F781DF, "vo_maxis_ssp_reincarnate" },
    { 0xA74E1F59, "vo_maxis_start_ssp" },
    { 0xD3AC17E2, "vo_menendez_intro" },
    { 0xA9AD0C5D, "vo_metal_storms" },
    { 0x95280393, "vo_mg" },
    { 0xD6941D87, "vo_millibar_meeting" },
    { 0xB31A820D, "vo_morals_shoot_vtol" },
    { 0xB5644CED, "vo_more_enemies" },
    { 0xDEFA612A, "vo_mortar_attack_trucks" },
    { 0x665D3295, "vo_mortar_check" },
    { 0x0761177D, "vo_mortar_fired_at_player" },
    { 0xF3E640BF, "vo_mortar_nag" },
    { 0x97EEF753, "vo_mortars" },
    { 0x6B76A0B6, "vo_mortars_incoming" },
    { 0xDE495709, "vo_muj_in_arena" },
    { 0x7B8251AC, "vo_nag_get_back" },
    { 0x17E4D37A, "vo_nag_id_menendez" },
    { 0x1608FE88, "vo_nag_rooftop_approach" },
    { 0xBB26FB89, "vo_nag_safe_distance" },
    { 0xDE3AF0D6, "vo_name" },
    { 0x161D1063, "vo_no_claw_switch" },
    { 0x2A92FD1C, "vo_no_guns" },
    { 0x98050BF9, "vo_non_random_mortars" },
    { 0x256FC43E, "vo_note_skits" },
    { 0x6E494F0E, "vo_on_turret_dead" },
    { 0x9E35F4F1, "vo_origin" },
    { 0x02597C65, "vo_outskirts" },
    { 0xB1309860, "vo_pa_announcement" },
    { 0xEE8807C3, "vo_pacing" },
    { 0xB027EDC9, "vo_pathchoice_hold" },
    { 0x363AA6C9, "vo_pip_pacing" },
    { 0xCE519FEE, "vo_plane_very_damaged" },
    { 0xB1C2AC2A, "vo_play_four_part_conversation" },
    { 0x81CBDA66, "vo_play_savannah_hill" },
    { 0xDF626DA5, "vo_play_savannah_start" },
    { 0x16D66993, "vo_play_soliloquy" },
    { 0xB80E4987, "vo_play_soliloquy_disconnect_listener" },
    { 0x3ACC7AD5, "vo_player_asd" },
    { 0xB7114239, "vo_player_horse_sprint" },
    { 0xCCC7AF51, "vo_player_shot_down_drone" },
    { 0x298C8E56, "vo_player_strafed" },
    { 0xD45DED26, "vo_player_tie_rope" },
    { 0x8641B170, "vo_player_who_discovered_stables_roof" },
    { 0xEBB8714B, "vo_playing" },
    { 0x33DDFB9D, "vo_post_barracks" },
    { 0x0B6C94D3, "vo_post_breach" },
    { 0x97D42E8D, "vo_pre_morals" },
    { 0xC8323F6D, "vo_promises" },
    { 0x98401A1A, "vo_promises_playing" },
    { 0xC836BD29, "vo_prone_bridge" },
    { 0x06C5FCD8, "vo_pulwar" },
    { 0xBAC0D9FF, "vo_puzzle_bad" },
    { 0x0772F0D7, "vo_puzzle_confused" },
    { 0x094845A1, "vo_puzzle_good" },
    { 0x226CB70F, "vo_rally_troops" },
    { 0x10DEEC49, "vo_ram_the_gate" },
    { 0xF6B41E28, "vo_redshirt_breach" },
    { 0xB4120C72, "vo_redshirt_hell" },
    { 0x4D584E47, "vo_redshirt_pullback" },
    { 0x4EF275BD, "vo_redshirt_roof" },
    { 0x68D021DF, "vo_redshirt_ura" },
    { 0x6CD8145D, "vo_redshirt_vault" },
    { 0x2BCD8047, "vo_redshirt_window" },
    { 0x9CAC8E39, "vo_reloading_last_time" },
    { 0x39927D6E, "vo_repeat_delay" },
    { 0x35879C7F, "vo_repeat_delay_inc" },
    { 0xC051024F, "vo_reznov_appearing" },
    { 0xB94F89DB, "vo_reznov_armory_floor_1" },
    { 0x47481AA0, "vo_reznov_armory_floor_2" },
    { 0x59BFFCEE, "vo_reznov_defend" },
    { 0x6F2A752B, "vo_reznov_minigun" },
    { 0x1F179579, "vo_richtofen_atd_ball_sniped" },
    { 0xECED8699, "vo_richtofen_atd_elevators" },
    { 0xAC7CC258, "vo_richtofen_atd_order" },
    { 0x0416CE53, "vo_richtofen_atd_order_error" },
    { 0x8AACEE19, "vo_richtofen_find_sniper" },
    { 0x15216924, "vo_richtofen_first_tower" },
    { 0x588BB8A7, "vo_richtofen_instructions" },
    { 0xF2D10F10, "vo_richtofen_nav_card" },
    { 0x6AC2515D, "vo_richtofen_power_on" },
    { 0x296B8D82, "vo_richtofen_punch_tower" },
    { 0x5FACA64B, "vo_richtofen_sliquify_confirm" },
    { 0x9293687C, "vo_ridge" },
    { 0x0C2F7FAC, "vo_riverbed" },
    { 0xB28AD361, "vo_riverbed_savimbi_nag" },
    { 0x3DD65630, "vo_roadblock" },
    { 0x4A03714F, "vo_rocket_hall" },
    { 0x6BB8FC1F, "vo_roof_meeting" },
    { 0xEACF379E, "vo_roof_traverse" },
    { 0x09B2A0E6, "vo_rooftop" },
    { 0x415946D5, "vo_rooftop_approach" },
    { 0x8BA09EDF, "vo_rooftop_battle" },
    { 0xA4092919, "vo_rooftops" },
    { 0x00D3C01A, "vo_rp_nag_lines" },
    { 0x33693DB3, "vo_rpg_nag" },
    { 0x2BD18806, "vo_russian" },
    { 0x866A6AD1, "vo_russian_choppers" },
    { 0x69AF5399, "vo_russians_in_arena" },
    { 0x73F2F8CB, "vo_salazar_pip" },
    { 0x06E18D39, "vo_scanner_bridge" },
    { 0xA11266E8, "vo_scanner_nag" },
    { 0xB1D2971A, "vo_seals_runway" },
    { 0x11364A0B, "vo_seals_under_fire" },
    { 0x5361B5A3, "vo_second_claw" },
    { 0x905AC639, "vo_second_sampans_wave" },
    { 0xEEBBEBE2, "vo_see_map_trigger" },
    { 0x0FFEE051, "vo_semi_truck" },
    { 0x81F0265E, "vo_septic_rail" },
    { 0x577DBFEC, "vo_sewer_exterior" },
    { 0x2B102A53, "vo_sewer_perk_dialog_exchange" },
    { 0x705A892E, "vo_sewer_perk_success" },
    { 0x56794E66, "vo_shoot_drones" },
    { 0xA5E2E9E2, "vo_sitrep" },
    { 0xF8E1A2B2, "vo_skylight" },
    { 0xC783A1B8, "vo_sliquify_fail_watch" },
    { 0xD67D852D, "vo_sniper_kill" },
    { 0x9326DD49, "vo_snow_hide" },
    { 0x179CEAF0, "vo_spetz_escaping" },
    { 0x3F0E068E, "vo_state" },
    { 0x202D7319, "vo_stay_topside" },
    { 0xD97C3655, "vo_strafing_run_ready" },
    { 0x9F1DCEF4, "vo_strafing_run_start" },
    { 0xF7E88D08, "vo_strafing_run_stop" },
    { 0x8795C809, "vo_street_moveup" },
    { 0x4A88511C, "vo_string" },
    { 0x1C860E00, "vo_string_1" },
    { 0x5BF51B34, "vo_struct" },
    { 0xFFBBF3F3, "vo_stuhlingerpossessed" },
    { 0x46CAEAE6, "vo_tank_approaching" },
    { 0xA60FC359, "vo_tank_breakaway" },
    { 0x9983EDDF, "vo_tank_cooling" },
    { 0xD2CB3040, "vo_tank_flame_zombie" },
    { 0xCC1B73C1, "vo_tank_killed" },
    { 0xBCE4D0DF, "vo_tank_leave" },
    { 0xAC5DCAFB, "vo_tank_wave_completed" },
    { 0xE9CC99E1, "vo_targatname" },
    { 0xEA7BB175, "vo_terrorist_hunt" },
    { 0x4CD556D1, "vo_terrorists_fire_at_player" },
    { 0xCC3737CE, "vo_text" },
    { 0x0CB3CBBC, "vo_third_claw" },
    { 0x1E274020, "vo_time_delay" },
    { 0x54D3A4F2, "vo_to_implement" },
    { 0x3F6858F2, "vo_to_ledge" },
    { 0xD647E82F, "vo_trenchruns" },
    { 0xCE568FAD, "vo_trigger" },
    { 0x6D6464AC, "vo_triggers" },
    { 0x743DFC49, "vo_truck_group_1_dead" },
    { 0x9952CD8D, "vo_try_puzzle_air1" },
    { 0xBF5547F6, "vo_try_puzzle_air2" },
    { 0x2BDA1C0C, "vo_try_puzzle_crypt" },
    { 0xCE9CD53D, "vo_try_puzzle_fire1" },
    { 0xF49F4FA6, "vo_try_puzzle_fire2" },
    { 0x1B93048B, "vo_try_puzzle_lightning1" },
    { 0xA98B9550, "vo_try_puzzle_lightning2" },
    { 0x21901E4E, "vo_try_puzzle_water1" },
    { 0xFB8DA3E5, "vo_try_puzzle_water2" },
    { 0x34D4557E, "vo_tunnel_reminder" },
    { 0xF9520125, "vo_tunnel_section_1" },
    { 0x1F2E169A, "vo_under_attack" },
    { 0x426FC7FE, "vo_underground" },
    { 0x038F730E, "vo_upper_hangar_battle" },
    { 0x7994DBCE, "vo_vehicles_bp1" },
    { 0x9E9A57E9, "vo_vehicles_bp1_safeguard" },
    { 0x31107EAE, "vo_vehicles_headed_to_base" },
    { 0x773FDF3D, "vo_vtol_crash_foreshadow" },
    { 0x909B3424, "vo_vtol_pilot_intro" },
    { 0x6839D4A1, "vo_warning_delay" },
    { 0xEC266ECA, "vo_weapon_watcher" },
    { 0xA2D77B82, "vo_welder" },
    { 0xE2B2F42E, "vo_white_truck" },
    { 0x51730451, "vo_window_breach" },
    { 0x26499EFE, "vo_woods_index" },
    { 0x97DEADD7, "vo_woods_tie_rope" },
    { 0x0CD41DCA, "vo_woods_to_bp" },
    { 0x87236909, "vo_yemeni_warning" },
    { 0x55173182, "vo_yemenis_fire_at_player" },
    { 0xF6F9F7CB, "vo_young_kid_aa_encounter" },
    { 0x67BE1283, "vo_zhao_tell_you_where_the_event_is" },
    { 0x2BFD6884, "vo_zhao_to_bp" },
    { 0x2CC94416, "vo_zodiac_approach" },
    { 0xBDB857EE, "vo_zodiac_get_ready" },
    { 0x192DFCC8, "vocal" },
    { 0xD7E529BB, "vocalizations" },
    { 0xBE329EE3, "vocals" },
    { 0x2F8E4698, "vodka" },
    { 0xF58A9728, "voffset" },
    { 0xE42BA0A9, "voice" },
    { 0x85A2D366, "voice_afghanistan" },
    { 0x82B6E63E, "voice_angola" },
    { 0x09428145, "voice_angola_2" },
    { 0xF5A0958B, "voice_blackout" },
    { 0x72A944B0, "voice_frontend" },
    { 0x807BCFA3, "voice_haiti" },
    { 0x730035CC, "voice_karma" },
    { 0xC5341FAB, "voice_karma_2" },
    { 0x514B7A65, "voice_la_1" },
    { 0xD31C054D, "voice_la_1b" },
    { 0x774DF4CE, "voice_la_2" },
    { 0x11CA04AD, "voice_lines" },
    { 0x69A7A10B, "voice_monsoon" },
    { 0x68FDCA88, "voice_mov_afghanistan_chinese_fleet" },
    { 0x458FEBD7, "voice_mov_angola" },
    { 0x3C5C807F, "voice_mov_av7" },
    { 0x6E87F8D8, "voice_mov_bfroom" },
    { 0x3EBFD7C9, "voice_mov_character_test" },
    { 0xC7BF0424, "voice_mov_command_center" },
    { 0x6FC3321D, "voice_mov_dan_test" },
    { 0x8F372EF4, "voice_mov_haiti" },
    { 0x77C62681, "voice_mov_haiti_ny_streets" },
    { 0x849FE32E, "voice_mov_haiti_prom_night" },
    { 0xD96CB458, "voice_mov_haiti_skyline_dc" },
    { 0x5DF91770, "voice_mov_haiti_skyline_ny" },
    { 0x67A13CC4, "voice_mov_haiti_skyline_shanghai" },
    { 0xE7AF8EDD, "voice_mov_intro" },
    { 0xAFC1D73C, "voice_mov_la" },
    { 0xDF415620, "voice_mov_la_supermarket" },
    { 0x9F91A1F2, "voice_mov_loading_test" },
    { 0x39F6EA16, "voice_mov_myanmar" },
    { 0x206BD166, "voice_mov_nicaragua" },
    { 0xF42665D7, "voice_mov_obama_bridge" },
    { 0x94877EC7, "voice_mov_obama_sinking" },
    { 0x5B3617C0, "voice_mov_obama_winning" },
    { 0xD07AF83D, "voice_mov_omwroom" },
    { 0x0BB11D7E, "voice_mov_outro_arlington_cemetery" },
    { 0x6E15027F, "voice_mov_outro_data_center" },
    { 0x458F84E1, "voice_mov_outro_nicaragua_cemetery" },
    { 0x6E31B1E4, "voice_mov_outro_oval_office" },
    { 0x34861D04, "voice_mov_outro_prison" },
    { 0x4B67BDDC, "voice_mov_pakistan" },
    { 0x14D03325, "voice_mov_panama" },
    { 0x89779D2D, "voice_mov_suburban_flashback" },
    { 0xC220FE58, "voice_mov_talkshow" },
    { 0xCE114B50, "voice_mov_vault_day_ext" },
    { 0xAA880C9E, "voice_mov_vault_day_int" },
    { 0xD831F68F, "voice_mov_vault_day_omwroom" },
    { 0x1AEE7D84, "voice_mov_vault_night_ext" },
    { 0x83070B72, "voice_mov_vault_night_int" },
    { 0x679B9E95, "voice_mov_whiteroom" },
    { 0xF168879D, "voice_mov_yemen_server_room" },
    { 0x2380F3E9, "voice_nicaragua" },
    { 0x18A2FA1C, "voice_over_barge" },
    { 0xD65376F5, "voice_over_river" },
    { 0x92D41C4D, "voice_pakistan" },
    { 0x7D4F52C2, "voice_pakistan_2" },
    { 0xA351CD2B, "voice_pakistan_3" },
    { 0xF0B7F608, "voice_panama" },
    { 0x0840E70F, "voice_panama_2" },
    { 0xE23E6CA6, "voice_panama_3" },
    { 0xB3535782, "voice_singapore" },
    { 0xEC3F2804, "voice_tag" },
    { 0xD26A8582, "voice_yemen" },
    { 0x5D915A3C, "voicebox" },
    { 0x83B23E13, "voicenum" },
    { 0xD16EB476, "voicenumber" },
    { 0xDC3FA4F2, "voiceovers" },
    { 0xE4B959C5, "voiceprefix" },
    { 0xA88E5613, "voiceradius" },
    { 0xBE4E6C5F, "voiceradiussq" },
    { 0x472F8720, "voices" },
    { 0x5BCBEEC2, "voicestring" },
    { 0x5E108243, "void" },
    { 0x70026C87, "voidondamage" },
    { 0x117C5709, "voidonspawn" },
    { 0x601BD6BE, "voidonspawnretrievetriggers" },
    { 0x675DB5BB, "voidpickup" },
    { 0x56421277, "voip" },
    { 0xBC601A70, "vol" },
    { 0x2675DE0C, "vol_1" },
    { 0x987D4D47, "vol_2" },
    { 0x7D5CD5B4, "vol_area" },
    { 0xE05EBE60, "vol_arena" },
    { 0x8574DD08, "vol_bridge" },
    { 0x2D62666C, "vol_bus_dam" },
    { 0xD02E2347, "vol_cache" },
    { 0x360A2E10, "vol_fog_think" },
    { 0x35E5A05D, "vol_frogger" },
    { 0x11CA488A, "vol_goal" },
    { 0x66B5B72E, "vol_market_exit" },
    { 0x10295E3A, "vol_name" },
    { 0x70CE348D, "vol_near_staircase_clear" },
    { 0x72858481, "vol_num" },
    { 0x5C45FD18, "vol_touching" },
    { 0x56817DCA, "volley" },
    { 0xCD16B840, "volley_meat" },
    { 0xF19701D9, "volleycoord" },
    { 0x3CE94577, "volleycount" },
    { 0x71AEE405, "volleys" },
    { 0x5CA45971, "volleywaitmax" },
    { 0xCA1C37CF, "volleywaitmin" },
    { 0xAFDEF5D5, "volly" },
    { 0x86BD1C1D, "voltage" },
    { 0x45DB3DAB, "volume" },
    { 0x0F9DFCB3, "volume2" },
    { 0x6A94982D, "volume_construction_house_bottom_floor" },
    { 0x7D7CB89F, "volume_construction_house_top_floor" },
    { 0x5607C111, "volume_construction_yard_rear" },
    { 0x7D2FFA02, "volume_containers" },
    { 0xC9DBC2CE, "volume_down" },
    { 0x54E7CCB3, "volume_entity" },
    { 0x315BC936, "volume_groups" },
    { 0xDE8412B3, "volume_hangar_back" },
    { 0x787CDD9F, "volume_hangar_front" },
    { 0xE7D07C38, "volume_leftgate" },
    { 0xA99FD30B, "volume_name" },
    { 0xA8217FC7, "volume_noteworthy" },
    { 0xFEBADB61, "volume_smoke" },
    { 0xD9C79CD8, "volume_targetname" },
    { 0x2FFBED45, "volume_trigger_thread" },
    { 0xA4DBB9CD, "volume_up" },
    { 0xE2E9CA38, "volumeaxis" },
    { 0xF3C9FC2D, "volumedesertiontime" },
    { 0x4C17C9A7, "volumemax" },
    { 0xF171EB19, "volumemin" },
    { 0xA7D2A161, "volumerate" },
    { 0x6A3A1C8A, "volumes" },
    { 0x0AF5B6AE, "volumes_flashed" },
    { 0x3C0FF815, "volumetargetname" },
    { 0x6EE4C313, "volumns" },
    { 0x06FDCDA6, "voluntarily" },
    { 0x63AD2A4B, "voluntary" },
    { 0x1EF9DEDA, "vomit" },
    { 0xEB29F954, "vomit_door_open_anim" },
    { 0x3AE16C6D, "vomit_floor" },
    { 0xC772F8DB, "vomit_glass" },
    { 0x48CBEC36, "vomit_notetrack" },
    { 0x6FFA9D06, "vomit_player" },
    { 0x08BA2C89, "vomit_woods" },
    { 0xE0110C16, "vomiting" },
    { 0xD641C8D5, "vomits" },
    { 0x972EFC57, "vonderhaar" },
    { 0xBAE4D31F, "vorigin" },
    { 0x92C41A6B, "vorkuta" },
    { 0x785D3C4E, "vorkuta_amb" },
    { 0x64E2E8E1, "vorkuta_anim" },
    { 0x3B961E70, "vorkuta_armory" },
    { 0x62DB3EC3, "vorkuta_bike_flag_handler" },
    { 0x587BD9F8, "vorkuta_building_vo" },
    { 0x00436218, "vorkuta_custom_introscreen" },
    { 0xB5700C2A, "vorkuta_custom_names" },
    { 0x42575C11, "vorkuta_event7" },
    { 0x59C2AB75, "vorkuta_events" },
    { 0xBD580A86, "vorkuta_fire_looper" },
    { 0x96E38894, "vorkuta_fx" },
    { 0x383FF664, "vorkuta_fx_on_player" },
    { 0x1A2BBBD5, "vorkuta_group_vox" },
    { 0xF8205D0B, "vorkuta_mine" },
    { 0x480E6789, "vorkuta_mine_alarms_start" },
    { 0x298E0DF1, "vorkuta_minigun_alley" },
    { 0x13EA4C52, "vorkuta_mission_end" },
    { 0xFF3C07F6, "vorkuta_objectives" },
    { 0xA876714D, "vorkuta_precache" },
    { 0xA4B0A328, "vorkuta_slingshot_util" },
    { 0xEFEAD4E3, "vorkuta_surface" },
    { 0x7B97FB32, "vorkuta_util" },
    { 0x12B5193D, "vortex" },
    { 0xE2310572, "vortex_effect_duration" },
    { 0x9323B25A, "vortex_effect_version_1" },
    { 0x6D2137F1, "vortex_effect_version_2" },
    { 0x229595C7, "vortex_effect_version_none" },
    { 0xCDEA33FD, "vortex_enter_duration" },
    { 0xCAD1F33F, "vortex_exit_duration" },
    { 0x4490CF45, "vortex_explosion" },
    { 0x18F01A62, "vortex_explosion_fx" },
    { 0xB376234A, "vortex_fx" },
    { 0x202B601F, "vortex_fx_handle" },
    { 0xF75A12B7, "vortex_id" },
    { 0xF95D6DD5, "vortex_loop_duration" },
    { 0x0BD79D1D, "vortex_manager" },
    { 0xAA021C43, "vortex_overlay_blur_amount" },
    { 0xA88FD9A2, "vortex_overlay_inner_radius" },
    { 0x3B9FBF04, "vortex_overlay_lerp_count" },
    { 0x905A6C25, "vortex_overlay_outer_radius" },
    { 0x3449E263, "vortex_overlay_priority" },
    { 0x42846CC9, "vortex_position" },
    { 0xBFCF5055, "vortex_projectile" },
    { 0x8F8E4BB0, "vortex_pull_duration" },
    { 0xD4E1840F, "vortex_rumble" },
    { 0xCFC4FE8A, "vortex_rumble_interior" },
    { 0x35A4024F, "vortex_rumble_shockwave" },
    { 0xC3882A62, "vortex_screen_effect_name" },
    { 0xB5527D98, "vortex_shake_and_rumble" },
    { 0x75E90D12, "vortex_start_clientfield" },
    { 0x28BDC918, "vortex_stop" },
    { 0xAB226723, "vortex_time_client" },
    { 0x398E3D2F, "vortex_time_server" },
    { 0xDA02636C, "vortex_visionset_lerp_count" },
    { 0x2C95A7EB, "vortex_visionset_priority" },
    { 0x18D1999C, "vortex_z_extension" },
    { 0x6C3C8140, "vortex_z_offset" },
    { 0xF17362F1, "vortexresetcondition" },
    { 0x965DA007, "vos" },
    { 0x826FB525, "vote" },
    { 0x188CAB94, "voteenabled" },
    { 0x7D2DDAC7, "votimer" },
    { 0xC74BC0DC, "votype" },
    { 0xF4425D84, "vox" },
    { 0xE9C70B46, "vox_357" },
    { 0xC9EA1C02, "vox_357_available" },
    { 0x8D5241C5, "vox_alias_name" },
    { 0xE6EA504A, "vox_ammo_low" },
    { 0x52343F0E, "vox_ammo_low_available" },
    { 0x6011B8A0, "vox_ammo_out" },
    { 0x84D1F400, "vox_ammo_out_available" },
    { 0x0884D93A, "vox_audio_secret" },
    { 0x6C83047E, "vox_audio_secret_available" },
    { 0x088C7052, "vox_bar" },
    { 0x5601A8F6, "vox_bar_available" },
    { 0xA680DAAC, "vox_behind_zombie" },
    { 0x493EAD77, "vox_bowie" },
    { 0x040AD0F7, "vox_bowie_available" },
    { 0xC0A8CD1F, "vox_category" },
    { 0x6829FDE5, "vox_close" },
    { 0xAD665569, "vox_close_available" },
    { 0x5A081EC2, "vox_comp_radio" },
    { 0x9A5DE4E1, "vox_comp_radio_mainframe" },
    { 0x39A4781E, "vox_crappy" },
    { 0x08CCD9BA, "vox_crappy_available" },
    { 0xBD830300, "vox_dmg_close" },
    { 0x859AAB20, "vox_dmg_close_available" },
    { 0xD44C619F, "vox_dog_spawn" },
    { 0xC0D1957F, "vox_dog_spawn_available" },
    { 0x75916BDB, "vox_dude" },
    { 0xA1F549AA, "vox_egg_sounddone" },
    { 0xF527B3FA, "vox_ent" },
    { 0x2FB64B34, "vox_flame" },
    { 0x4405004C, "vox_flame_available" },
    { 0x1D9ECAC4, "vox_gen_perk_dbltap" },
    { 0x790A3E9C, "vox_gen_perk_dbltap_available" },
    { 0xBE35DCF9, "vox_gen_perk_jugga" },
    { 0x5260DF95, "vox_gen_perk_jugga_available" },
    { 0x4F47DAAE, "vox_gen_perk_revive" },
    { 0x4FF5820A, "vox_gen_perk_revive_available" },
    { 0x32492A2A, "vox_gen_perk_speed" },
    { 0x64451A2E, "vox_gen_perk_speed_available" },
    { 0xBE08234B, "vox_gen_sigh" },
    { 0xC7801A23, "vox_gen_sigh_available" },
    { 0x5DBBF224, "vox_id" },
    { 0xFF55AFAD, "vox_index" },
    { 0x5A8409D5, "vox_insta_melee" },
    { 0x91209ED9, "vox_insta_melee_available" },
    { 0xFB64A560, "vox_kill_explo" },
    { 0xD0785AC0, "vox_kill_explo_available" },
    { 0x0053520B, "vox_kill_flame" },
    { 0x56B839E3, "vox_kill_flame_available" },
    { 0xB4522EC0, "vox_kill_headdist" },
    { 0x2FD546E0, "vox_kill_headdist_available" },
    { 0xA21AF8AE, "vox_kill_ray" },
    { 0x2534900A, "vox_kill_ray_available" },
    { 0x9679235F, "vox_kill_tesla" },
    { 0x5975753F, "vox_kill_tesla_available" },
    { 0x4B0E5441, "vox_killstreak" },
    { 0xC17A099D, "vox_killstreak_available" },
    { 0xD072A269, "vox_line" },
    { 0x86AC4640, "vox_line_prefix" },
    { 0x3088FB7B, "vox_mason_choke_drag" },
    { 0x3EEDBF1A, "vox_max_alpha" },
    { 0x76095A95, "vox_max_kilo" },
    { 0xEF881FE9, "vox_maxi_generator_" },
    { 0xF37FE8CC, "vox_maxi_generator_initiate_0_done" },
    { 0x0A5DA7BB, "vox_maxi_generator_interrupted_0_done" },
    { 0xDCCEBB82, "vox_maxi_generator_process_complete_0_done" },
    { 0x6CA90988, "vox_maxi_purge_countdown_0_done" },
    { 0xCB262163, "vox_maxi_purge_now_0_done" },
    { 0x2A437A6B, "vox_maxi_purge_robot_0_done" },
    { 0x9C878FC3, "vox_mg" },
    { 0x49109D3B, "vox_mg_available" },
    { 0xEC7A5E78, "vox_min_alpha" },
    { 0xF480B3C7, "vox_min_kilo" },
    { 0x3D02BA54, "vox_monkey" },
    { 0x15CCE12C, "vox_monkey_available" },
    { 0xC53BD610, "vox_mp40" },
    { 0x2092D0B0, "vox_mp40_available" },
    { 0x25ED710C, "vox_name_complete" },
    { 0x677BA771, "vox_nomoney_perk" },
    { 0xF77ED18D, "vox_nomoney_perk_available" },
    { 0x4AD253A5, "vox_num" },
    { 0xC7D3973F, "vox_oh_shit" },
    { 0x1076815F, "vox_oh_shit_available" },
    { 0xA9D09B39, "vox_override_while_near_tank" },
    { 0x60D65999, "vox_override_while_near_tank2" },
    { 0x3EBBCFF5, "vox_perk_lottery" },
    { 0x70D52CB9, "vox_perk_lottery_available" },
    { 0x66210727, "vox_perk_packa_get" },
    { 0x8B818767, "vox_perk_packa_get_available" },
    { 0x455C547E, "vox_perk_packa_wait" },
    { 0xDD0D45DA, "vox_perk_packa_wait_available" },
    { 0x4F8756DE, "vox_ppsh" },
    { 0xF27CFD7A, "vox_ppsh_available" },
    { 0x82050FFE, "vox_rand" },
    { 0xBC066DA5, "vox_raygun" },
    { 0x46092B29, "vox_raygun_available" },
    { 0xFB65CD5F, "vox_resp_hr_headdist" },
    { 0xA8486F3F, "vox_resp_hr_headdist_available" },
    { 0x97C189C4, "vox_resp_riv_headdist" },
    { 0x5864759C, "vox_resp_riv_headdist_available" },
    { 0x62A75CB6, "vox_response" },
    { 0x28D3A005, "vox_response_override" },
    { 0xF89A081B, "vox_shotgun" },
    { 0x28829D73, "vox_shotgun_available" },
    { 0xC8723372, "vox_sticky" },
    { 0x8D67C4D6, "vox_sticky_available" },
    { 0x32646ACB, "vox_sur" },
    { 0xAF3982AD, "vox_table_col_category" },
    { 0xCBF8EA79, "vox_table_col_delaybeforeplay" },
    { 0x17A20E69, "vox_table_col_percentage" },
    { 0x050B79B8, "vox_table_col_response" },
    { 0x31DE56B9, "vox_table_col_subcategory" },
    { 0xC7F076EA, "vox_table_col_suffix" },
    { 0xFA117F18, "vox_tesla" },
    { 0xFC91AA98, "vox_tesla_available" },
    { 0xF4C9CC62, "vox_timer" },
    { 0x76F9D009, "vox_trap_barrel" },
    { 0x60289EE5, "vox_trap_barrel_available" },
    { 0x7B534719, "vox_trap_log" },
    { 0x6C08FCF5, "vox_trap_log_available" },
    { 0x58D36EF3, "vox_type" },
    { 0xA664BBC8, "vox_weight_max" },
    { 0xBE5D3B38, "vox_weight_median" },
    { 0x03850356, "vox_weight_min" },
    { 0x8AFAF4DE, "vox_zipline" },
    { 0xE4A08B7A, "vox_zipline_available" },
    { 0x6F29D418, "voxaideactivate" },
    { 0x9F2869F5, "voxdeallocatewatch" },
    { 0xE9D9BF0E, "voxdrowning" },
    { 0x48AFFA41, "voxemergebreath" },
    { 0x7BA5E933, "voxid" },
    { 0x1E6A54E2, "voxids" },
    { 0x65A90717, "voxtimer" },
    { 0x16BA78AC, "voxunderwatertime" },
    { 0x88482219, "vpoint" },
    { 0xEB59FB11, "vr" },
    { 0x02797C60, "vreference" },
    { 0xBFCA5682, "vrill" },
    { 0x10373E85, "vrotray1" },
    { 0x3639B8EE, "vrotray2" },
    { 0x10D80214, "vrun" },
    { 0xC55780A8, "vs" },
    { 0xED2D163A, "vs_clearing" },
    { 0xFF0B8FA8, "vs_trigs" },
    { 0x5D97D0E4, "vs_tunnels" },
    { 0x7155649A, "vsmgr" },
    { 0x006A534A, "vsmgr_activate" },
    { 0x4A8D0343, "vsmgr_deactivate" },
    { 0xE8A56EFB, "vsmgr_default_info_name" },
    { 0xA87D8C8A, "vsmgr_duration_lerp_thread" },
    { 0x8C29E0F2, "vsmgr_duration_lerp_thread_per_player" },
    { 0xE6CCE8AA, "vsmgr_filter_custom_disable" },
    { 0x99A39D9F, "vsmgr_filter_custom_enable" },
    { 0x4FEBCDBE, "vsmgr_initializing" },
    { 0xCEA2D030, "vsmgr_is_spectating" },
    { 0xC6DEC51D, "vsmgr_is_type_currently_default" },
    { 0xE64953B2, "vsmgr_is_type_currently_default_func" },
    { 0xDA1DFD5F, "vsmgr_lerp_power_up_down" },
    { 0x30BDB3DB, "vsmgr_overlay_style_blur" },
    { 0xB542DE47, "vsmgr_overlay_style_burn" },
    { 0xC16C90B6, "vsmgr_overlay_style_electrified" },
    { 0x2EDD1A76, "vsmgr_overlay_style_filter" },
    { 0x7AC23F16, "vsmgr_overlay_style_none" },
    { 0x0A6D9BA8, "vsmgr_overlay_style_poison" },
    { 0xE1200CEB, "vsmgr_overlay_style_postfx_bundle" },
    { 0xF255557F, "vsmgr_overlay_style_speed_blur" },
    { 0x6A150794, "vsmgr_overlay_style_transported" },
    { 0x962491DC, "vsmgr_player_entnum" },
    { 0xCA5CC963, "vsmgr_prio_overlay_drown_blur" },
    { 0xFA6A80B1, "vsmgr_prio_overlay_flashback_warp" },
    { 0x5F1DBA02, "vsmgr_prio_overlay_gel_splat" },
    { 0xA8B403A4, "vsmgr_prio_overlay_zm_ai_avogadro_electrified" },
    { 0x8C3A29F4, "vsmgr_prio_overlay_zm_ai_screecher_blur" },
    { 0x2F04D4BD, "vsmgr_prio_overlay_zm_player_health_blur" },
    { 0x72FEA869, "vsmgr_prio_overlay_zm_powerup_zombie_blood" },
    { 0x1552CB98, "vsmgr_prio_overlay_zm_raps_round" },
    { 0xBC166BCE, "vsmgr_prio_overlay_zm_transit_burn" },
    { 0x275CB288, "vsmgr_prio_overlay_zm_trap_burn" },
    { 0xC10998F7, "vsmgr_prio_overlay_zm_trap_electrified" },
    { 0x88EE4B51, "vsmgr_prio_overlay_zm_wasp_round" },
    { 0x6BE9A3A6, "vsmgr_prio_overlay_zombie_vortex" },
    { 0xDD084298, "vsmgr_prio_visionset_heatwave_activate" },
    { 0x206FA944, "vsmgr_prio_visionset_heatwave_charred" },
    { 0x65BA5C28, "vsmgr_prio_visionset_mpintro" },
    { 0xEC5C8EF9, "vsmgr_prio_visionset_overdrive" },
    { 0xD4A6D98A, "vsmgr_prio_visionset_resurrect" },
    { 0xB2089F02, "vsmgr_prio_visionset_resurrect_up" },
    { 0x6A6F3B04, "vsmgr_prio_visionset_speedburst" },
    { 0x4A7FD560, "vsmgr_prio_visionset_visionpulse" },
    { 0xBA5842C1, "vsmgr_prio_visionset_zm_death" },
    { 0x689A7B24, "vsmgr_prio_visionset_zm_electric_cherry" },
    { 0x5A1519A3, "vsmgr_prio_visionset_zm_laststand" },
    { 0x04561141, "vsmgr_prio_visionset_zm_powerup_zombie_blood" },
    { 0x8EB572A8, "vsmgr_prio_visionset_zm_transit_power_high_low" },
    { 0xA954520F, "vsmgr_prio_visionset_zm_whos_who" },
    { 0xB6AECC10, "vsmgr_prio_visionset_zombie_turned" },
    { 0x273D22FE, "vsmgr_prio_visionset_zombie_vortex" },
    { 0x32A104D5, "vsmgr_prio_zm_brutus_teargas" },
    { 0x54F6A0CD, "vsmgr_register_info" },
    { 0x9B3B6CE0, "vsmgr_register_overlay_info_style_blur" },
    { 0x9097DD20, "vsmgr_register_overlay_info_style_burn" },
    { 0x9720BF3F, "vsmgr_register_overlay_info_style_electrified" },
    { 0x154038DD, "vsmgr_register_overlay_info_style_filter" },
    { 0x9E6241B9, "vsmgr_register_overlay_info_style_none" },
    { 0x2E050B0A, "vsmgr_register_visionset_info" },
    { 0x0EA91F3E, "vsmgr_register_visionset_override_transition_in" },
    { 0xCB24C5DE, "vsmgr_set_state_active" },
    { 0x0D41BF73, "vsmgr_set_state_inactive" },
    { 0xE5DCD38F, "vsmgr_states_inited" },
    { 0xDC1A2A2D, "vsmgr_timeout_lerp_thread" },
    { 0xE5EAE047, "vsmgr_timeout_lerp_thread_per_player" },
    { 0xE66A3E4F, "vsmgr_visionset_type_laststand" },
    { 0x23205296, "vsmgr_visionset_type_naked" },
    { 0x5F83512B, "vspawner" },
    { 0x932A903B, "vstartingorigin" },
    { 0x14704440, "vstodo" },
    { 0x282E0B45, "vstol" },
    { 0x7419BA1F, "vsurfacenormal" },
    { 0x7E577CEB, "vtag" },
    { 0x00D40496, "vteam" },
    { 0x76FAB0B6, "vtmodel" },
    { 0xC89E148A, "vtol" },
    { 0xA153C357, "vtol1" },
    { 0xB4899682, "vtol_1" },
    { 0x9620FAF6, "vtol_10" },
    { 0xB2121C80, "vtol_16" },
    { 0xA5822590, "vtol_23" },
    { 0xCA5C12E1, "vtol_approach" },
    { 0xB5E6880F, "vtol_approach_ambient_guys" },
    { 0xD91B52C8, "vtol_attach_light_fx" },
    { 0x25CFE064, "vtol_challenge" },
    { 0x80522040, "vtol_challenge_time" },
    { 0x99DE046D, "vtol_check_on_path" },
    { 0xBA1C179F, "vtol_clip" },
    { 0x3B4858B5, "vtol_death" },
    { 0x5F8ED3B6, "vtol_death_piece" },
    { 0xEF0E106C, "vtol_death_piece_delete" },
    { 0x893BD224, "vtol_dof_1" },
    { 0xFB43415F, "vtol_dof_2" },
    { 0xD540C6F6, "vtol_dof_3" },
    { 0x173462E9, "vtol_dof_4" },
    { 0x8B1784F3, "vtol_doors_open" },
    { 0x33CD78C0, "vtol_ent" },
    { 0xEC0CC30C, "vtol_escape" },
    { 0xCA81C7FC, "vtol_explode" },
    { 0x727A6D16, "vtol_explode2" },
    { 0xF62480C5, "vtol_explode_trail" },
    { 0xCCDBD3BE, "vtol_explosion" },
    { 0x3A8E8E27, "vtol_exterior" },
    { 0x2618FCAB, "vtol_exterior_explosion" },
    { 0xA71FC998, "vtol_firing_minigun" },
    { 0xC3CD5D84, "vtol_flock_manager" },
    { 0x4FCD0D90, "vtol_fly" },
    { 0xE9526C64, "vtol_fly_notetrack" },
    { 0x2741DFC9, "vtol_halo_jumps" },
    { 0x7EDE3F28, "vtol_hatch_open" },
    { 0x65E8DB8C, "vtol_hatch_snapshot" },
    { 0xC75C9A8A, "vtol_hatch_wind" },
    { 0x3C98C8D5, "vtol_hover_notetrack" },
    { 0x35EFD746, "vtol_icon" },
    { 0x98234CD1, "vtol_interior" },
    { 0x68D975B7, "vtol_interior_door_open" },
    { 0x63BC08F0, "vtol_kills" },
    { 0xC73CE47F, "vtol_kills_total" },
    { 0x2E0C12CD, "vtol_landed" },
    { 0x6617FAE6, "vtol_landing_activate" },
    { 0x16B5687A, "vtol_launch_ent" },
    { 0x9E76A1E4, "vtol_mode" },
    { 0x70786BE9, "vtol_mode_collision" },
    { 0xE720BDAA, "vtol_model_name" },
    { 0x0363A823, "vtol_move_away" },
    { 0x3D088F36, "vtol_mph" },
    { 0x6AD4611B, "vtol_nearmiss" },
    { 0xA30F01AA, "vtol_off_path" },
    { 0x973F939C, "vtol_on_path" },
    { 0x2AD0CDBC, "vtol_piece_override_damage" },
    { 0x3F7985FC, "vtol_piece_think" },
    { 0x8ED3A2E5, "vtol_player_override" },
    { 0xA716A9BE, "vtol_rpg" },
    { 0x15EBE92B, "vtol_scene_running" },
    { 0xDEE9CCED, "vtol_shake" },
    { 0x2F529A31, "vtol_shooter_damage_callback" },
    { 0x17AD017B, "vtol_shutdown" },
    { 0x1F38768C, "vtol_snapshot_change" },
    { 0xEEA32B2E, "vtol_snd" },
    { 0x2A3DB034, "vtol_snd_ent" },
    { 0x0D34F903, "vtol_spawn_func" },
    { 0x521C88A6, "vtol_spawn_struct" },
    { 0x3551AAC1, "vtol_structs" },
    { 0xDD33AF9C, "vtol_swap" },
    { 0xB6180AD7, "vtol_trigger" },
    { 0xB510B8E7, "vtol_turret_attacks_target" },
    { 0x9B4EFE5A, "vtol_turret_done" },
    { 0x0BB7E802, "vtol_up" },
    { 0xEA90E859, "vtol_wreck" },
    { 0x5D23926D, "vtoldestructiblecallback" },
    { 0x6D573482, "vtoldrophelicoptervehicleinfo" },
    { 0xCDD13EE8, "vtolleftfxid" },
    { 0x8C810915, "vtolrightfxid" },
    { 0xD5ED68C5, "vtols" },
    { 0xCD8927A3, "vtols_arrived" },
    { 0xC9A3940F, "vttype" },
    { 0x7D565FE8, "vulcan" },
    { 0x63884D2D, "vulnerable" },
    { 0x724B61F0, "vulture" },
    { 0x8B3A4A97, "vulture_anim_death" },
    { 0x6F59AB38, "vulture_anim_loop_air" },
    { 0x7943943D, "vulture_anim_loop_ground" },
    { 0x52A00D12, "vulture_clientfield_actor_clear" },
    { 0x264F2E95, "vulture_clientfield_actor_set" },
    { 0x47430E85, "vulture_clientfield_scriptmover_clear" },
    { 0x32880D0A, "vulture_clientfield_scriptmover_set" },
    { 0xA7958063, "vulture_clientfield_toplayer_clear" },
    { 0x232CBFDC, "vulture_clientfield_toplayer_set" },
    { 0xCC8D9AC2, "vulture_debug_text" },
    { 0xC71B71D7, "vulture_devgui_spawn_stink" },
    { 0x297938F5, "vulture_died" },
    { 0xD4311F4A, "vulture_drop_count_increment" },
    { 0xEAF45D18, "vulture_drop_funcs" },
    { 0xD7674BB6, "vulture_event_over" },
    { 0xD3EB582F, "vulture_fire_sale_box_fx_disable" },
    { 0xF150D334, "vulture_fire_sale_box_fx_enable" },
    { 0xA67DBD52, "vulture_flew_away" },
    { 0x96A4DEB7, "vulture_handle_solo_quick_revive" },
    { 0xA077CA0A, "vulture_horse" },
    { 0x90376FD9, "vulture_host_migration_func" },
    { 0x3C0604C6, "vulture_off" },
    { 0xE1A51358, "vulture_on" },
    { 0x742B0A4F, "vulture_perk_add_invalid_bonus_ammo_weapon" },
    { 0x908C773C, "vulture_perk_lost" },
    { 0xE0AD5FDF, "vulture_perk_machine_setup" },
    { 0x0ECB47B0, "vulture_perk_machine_think" },
    { 0x4F54D5FC, "vulture_perk_should_zombies_resume_find_flesh" },
    { 0x92139B9C, "vulture_perk_shows_mystery_box" },
    { 0x6E1682D6, "vulture_perk_stink_ramp_down_done" },
    { 0xFCCC6077, "vulture_perk_stink_ramp_up_done" },
    { 0x62F4A109, "vulture_perk_stop_zombie_reacquire_player" },
    { 0xD769DC9C, "vulture_perk_watch_fire_sale" },
    { 0xF6175093, "vulture_perk_watch_mystery_box" },
    { 0x7059F4A5, "vulture_perk_watch_powerup_drops" },
    { 0x79868C1F, "vulture_player_connect_callback" },
    { 0xDBA364A4, "vulture_precache" },
    { 0x45C24B4E, "vulture_register_clientfield" },
    { 0x0E0F8E1F, "vulture_set_clientfield" },
    { 0x0E7227C5, "vulture_start" },
    { 0x4272008C, "vulture_stink_value" },
    { 0xB6E5B276, "vulture_vision_toggle" },
    { 0x9EA9C9AA, "vulture_zombie_spawn_func" },
    { 0x9EE703E6, "vulture_zombies_find_exit_point" },
    { 0x2E3BA85B, "vultures" },
    { 0x12249A61, "vultures_alive" },
    { 0xEA9EAFEA, "vup" },
    { 0x074B1C9B, "vx" },
    { 0xE3E74BA6, "vxo" },
    { 0xE148A232, "vy" },
    { 0x890F76D1, "vyo" },
    { 0x75849218, "w" },
    { 0x5E329734, "w2la1" },
    { 0xD03A066F, "w2la2" },
    { 0x5C9E980A, "w2lo1" },
    { 0x369C1DA1, "w2lo2" },
    { 0xB6E64EE9, "w_afghan_ied_explosive" },
    { 0xF5625CF8, "w_base" },
    { 0xA65647F1, "w_brf_holo_asd_anim" },
    { 0x6CCEB530, "w_brf_holo_quadrotor_anim" },
    { 0x49C68F74, "w_curr_player_weapon" },
    { 0xD13F855E, "w_current" },
    { 0x4F1451FE, "w_cymbal_monkey_upgraded" },
    { 0x2D795F10, "w_damage" },
    { 0x7D3164C4, "w_give" },
    { 0xF790CA9F, "w_gravityspike" },
    { 0xF26475DE, "w_gravityspikes_wpn_prev" },
    { 0x04C2D3D7, "w_grenade" },
    { 0x72EFCECB, "w_hero" },
    { 0x9822D4D4, "w_min_last_stand_pistol_override" },
    { 0x5449E20E, "w_new_weapon" },
    { 0x90B60862, "w_octobomb" },
    { 0x5327E29D, "w_octobomb_upgraded" },
    { 0x080D0531, "w_old_weapon" },
    { 0xE14151E9, "w_perk_bottle_weapon" },
    { 0x0AFD47C8, "w_placed" },
    { 0x8848AFE8, "w_previous" },
    { 0x15F368CB, "w_primary" },
    { 0xB0D33E26, "w_raygun_mark3" },
    { 0xF0CF2CC9, "w_raygun_mark3_upgraded" },
    { 0x6C1DB712, "w_raygun_mark3lh" },
    { 0x88D25D2D, "w_raygun_mark3lh_upgraded" },
    { 0xF52F94AB, "w_returning" },
    { 0x35AA8C0D, "w_revive_tool" },
    { 0x5776CDC2, "w_reviver" },
    { 0xF436DB2F, "w_root" },
    { 0xEFAB127B, "w_sacotra_intro_bomb1" },
    { 0x7DA3A340, "w_sacotra_intro_bomb2" },
    { 0xA3A61DA9, "w_sacotra_intro_bomb3" },
    { 0x11FCBBCD, "w_sacotra_karma_rescue_knife" },
    { 0x46FD9093, "w_secondary" },
    { 0x69BAAA2A, "w_specialgrenade" },
    { 0x7A36CB10, "w_summoned_weapon" },
    { 0x8F3E38CC, "w_tactical" },
    { 0xE2763C49, "w_to_check" },
    { 0x1D6DB0A3, "w_weapon" },
    { 0x43F0E707, "w_widows_wine_bowie_knife" },
    { 0xBFCDCC0D, "w_widows_wine_grenade" },
    { 0x85B560D4, "w_widows_wine_knife" },
    { 0xEE38B02D, "w_widows_wine_prev_grenade" },
    { 0x6A22BDF4, "w_widows_wine_prev_knife" },
    { 0x595C1EF4, "w_widows_wine_sickle_knife" },
    { 0x54D39A98, "wa_room_exit_kick_open" },
    { 0x3C970696, "waaaaay" },
    { 0xD155E210, "wacky" },
    { 0x91D6956F, "waco" },
    { 0x41B91D81, "waco_paco" },
    { 0x205306B8, "waco_paco_full_go" },
    { 0x9C674019, "wading" },
    { 0x93432369, "wager" },
    { 0xA8628CDC, "wager_player_scored" },
    { 0x48C13A7E, "wagerannouncer" },
    { 0xE2282C76, "wagerbet" },
    { 0x7C464399, "wagerbetpercent" },
    { 0xB4140DB7, "wagergamefinalized" },
    { 0x994D82AA, "wagergametypes" },
    { 0x01D0304C, "wagermatch" },
    { 0x3CE053DB, "wagermatchfailed" },
    { 0x2611C2DB, "wagernotifyqueue" },
    { 0xD5235F38, "wageroutcomenotify" },
    { 0x4B4BFC3A, "wagersettings" },
    { 0x5A76E350, "wagertopearners" },
    { 0x13F4A24F, "wagerweaponsused" },
    { 0x9C5EBB26, "wagerweaponusage" },
    { 0x2DB92EC2, "wagerwinnings" },
    { 0x504BAD5F, "wagofthefinger" },
    { 0xC9D2A5F7, "wagon" },
    { 0x0E90E9A0, "wagon_fire_challenge" },
    { 0x1203717F, "wagon_fire_start" },
    { 0xBEBDF483, "wagon_fire_trigger_watch" },
    { 0xA3A07774, "wagon_traversal" },
    { 0x51CF3C15, "wahey" },
    { 0xD433B072, "wai" },
    { 0x9DB302AF, "wailtill" },
    { 0xFA71D6FD, "wais" },
    { 0x886A67C2, "wait" },
    { 0x870CDD1F, "wait1" },
    { 0x15056DE4, "wait2" },
    { 0xF40494A8, "wait_about" },
    { 0x937949FA, "wait_acrobatics_end" },
    { 0x91118A56, "wait_ambient_turret_end" },
    { 0x5A94A9BB, "wait_and_change_text" },
    { 0x0C585C50, "wait_and_chargeplayer" },
    { 0x23CFC1D2, "wait_and_clear_hack" },
    { 0xF6BBAB40, "wait_and_clearflag" },
    { 0xC5E7E59A, "wait_and_delete" },
    { 0x686127F7, "wait_and_detonate" },
    { 0x1799DD36, "wait_and_do_weapon_beacon_damage" },
    { 0xD5F2E4BE, "wait_and_explode" },
    { 0xC7A9338D, "wait_and_fade" },
    { 0x072838ED, "wait_and_find_new_gunner" },
    { 0xE1ABE765, "wait_and_fire_shots" },
    { 0x6B619A8B, "wait_and_fireweapon" },
    { 0xFEAD4A67, "wait_and_goto_idle" },
    { 0x3106E063, "wait_and_hide" },
    { 0x0ACF2895, "wait_and_hide_sq_bg_macguffin" },
    { 0xA00C30D7, "wait_and_kill" },
    { 0x21C29CB5, "wait_and_killspawner" },
    { 0xD14760E0, "wait_and_notify" },
    { 0x6BD18915, "wait_and_openflag" },
    { 0x2934E128, "wait_and_play_first_magic_box_seen_vo" },
    { 0x9F1D002B, "wait_and_play_truck_hold" },
    { 0x7D41B79A, "wait_and_play_unload_idle" },
    { 0x903BDC65, "wait_and_play_woods_end_idle" },
    { 0x6CD37805, "wait_and_play_zhao_end_idle" },
    { 0x159ADC20, "wait_and_playsoundatposition" },
    { 0xFB08731C, "wait_and_print" },
    { 0x3B56312B, "wait_and_remove" },
    { 0xA29AB05C, "wait_and_revive" },
    { 0xD7C29878, "wait_and_rumble" },
    { 0x1241BD94, "wait_and_say" },
    { 0x1E56AAB0, "wait_and_set_revive_shader_constant" },
    { 0x5AC55F56, "wait_and_setcandamage" },
    { 0x2882151F, "wait_and_setclientflagasval" },
    { 0x2A412E43, "wait_and_setflag" },
    { 0xB9CAF72B, "wait_and_shake" },
    { 0x077D612B, "wait_and_shake_custom" },
    { 0x549E86A4, "wait_and_shoot_at" },
    { 0xA35CA680, "wait_and_show" },
    { 0x01874D3C, "wait_and_spawn" },
    { 0xBED29437, "wait_and_stop_loop_sounds" },
    { 0xCCE12368, "wait_and_stoprumble" },
    { 0xCA6B9929, "wait_and_suicide" },
    { 0x0F57DC43, "wait_and_take_equipment" },
    { 0x451052A4, "wait_and_trigoff" },
    { 0xA4BFF670, "wait_and_unignore" },
    { 0x4BC6ECA2, "wait_and_unlink" },
    { 0xDF4BCB86, "wait_anim" },
    { 0xC5FABCA5, "wait_anim_length" },
    { 0x1D74CA91, "wait_any" },
    { 0x9B7AED74, "wait_any_func_array" },
    { 0x42B0A69C, "wait_axe_grab" },
    { 0xD524727F, "wait_before_kill" },
    { 0xAA45218A, "wait_before_timer" },
    { 0xC55343B7, "wait_between_spawn" },
    { 0x5B1CFB86, "wait_bot_goal_reached_loop" },
    { 0x0187ECCB, "wait_bot_path_failed_loop" },
    { 0x0399C1F1, "wait_by_door" },
    { 0x9A1A3DF0, "wait_chain" },
    { 0xDEBB1B42, "wait_chair_detach" },
    { 0x9B137272, "wait_clear_streamer_hint" },
    { 0xA16C5C9F, "wait_clear_took_damage_flag" },
    { 0x1A69A2EE, "wait_client_frame" },
    { 0x0FA6B675, "wait_condition1" },
    { 0x35A930DE, "wait_condition2" },
    { 0x73658497, "wait_corner_radius" },
    { 0x75CFA67F, "wait_damage_loop" },
    { 0x89A5CB77, "wait_dart_timed_out" },
    { 0xEDD77D3E, "wait_delay" },
    { 0xEEB396B3, "wait_delay1" },
    { 0x7CAC2778, "wait_delay2" },
    { 0x3E857276, "wait_delete_intro_trucks" },
    { 0x813F1AC6, "wait_dialog_buffer" },
    { 0x03D449FD, "wait_duration" },
    { 0xDA8BA893, "wait_endon" },
    { 0xE13749B8, "wait_ent" },
    { 0x9A0756F8, "wait_evasion_reaction_time" },
    { 0x567B6554, "wait_explode" },
    { 0x07CFD8E0, "wait_fade_destroy" },
    { 0xE675A6D3, "wait_fade_in" },
    { 0x8C00F071, "wait_final_killcam_slowdown" },
    { 0x3A77E2B4, "wait_fire_weapon" },
    { 0x868A1DFF, "wait_flag" },
    { 0xCCDA7F89, "wait_flash" },
    { 0xABA207CD, "wait_float" },
    { 0x6539D42A, "wait_for" },
    { 0x2B7F9D92, "wait_for_1st_battle_to_complete" },
    { 0x6D31E8AA, "wait_for_2nd_battle_to_complete" },
    { 0xC0B91F1D, "wait_for_3rd_battle_to_complete" },
    { 0x54317BC3, "wait_for_action" },
    { 0x9A4B6CFA, "wait_for_activate" },
    { 0xC6447251, "wait_for_activation" },
    { 0xD31B665D, "wait_for_ads" },
    { 0x40AC63D3, "wait_for_ads_or_timeout" },
    { 0xDF39835E, "wait_for_ai_to_reach_plane" },
    { 0x41DA2746, "wait_for_ai_to_use_turret" },
    { 0x139B1A25, "wait_for_airstrike" },
    { 0x3731D6C6, "wait_for_ais_to_appear" },
    { 0x99219205, "wait_for_alert" },
    { 0xA3AFDA1F, "wait_for_all_guys_to_reach_goal" },
    { 0x39733811, "wait_for_all_players" },
    { 0x4B6DDAB0, "wait_for_all_springpads_placed" },
    { 0x5825A32D, "wait_for_an_unlocked_trigger" },
    { 0xCD1F417A, "wait_for_anger" },
    { 0x9658B797, "wait_for_angry_dog" },
    { 0x63D7EB93, "wait_for_area_four_infantry" },
    { 0x9DAA4BA1, "wait_for_area_three_infantry" },
    { 0x2AB8A26F, "wait_for_area_two_infantry" },
    { 0x772AA858, "wait_for_arrive" },
    { 0x38B86B81, "wait_for_attack" },
    { 0xEDF32ED8, "wait_for_attack_button" },
    { 0xBF226C44, "wait_for_attack_button_or_timeout" },
    { 0xFDC23C50, "wait_for_attractor_positions_complete" },
    { 0x3BB78F86, "wait_for_balls_launched" },
    { 0xFBA55417, "wait_for_bda_dialog" },
    { 0x864EDAFC, "wait_for_bda_timeout" },
    { 0x38237EDC, "wait_for_beam_damage" },
    { 0xB0BCC293, "wait_for_best_boat_to_die" },
    { 0x6C5E6A14, "wait_for_biodome_breach" },
    { 0xC8F25330, "wait_for_black_box" },
    { 0x5BA52236, "wait_for_bloom" },
    { 0x5CE1E9A4, "wait_for_blundersplat_fired" },
    { 0x1D918881, "wait_for_blundersplat_upgraded_fired" },
    { 0x22D9D9EB, "wait_for_bolt_death" },
    { 0xB4D05FCF, "wait_for_bucket_activated" },
    { 0x5C049D05, "wait_for_buffer_time_to_pass" },
    { 0x3317AA5B, "wait_for_buildable" },
    { 0x487F5E08, "wait_for_bullet_fire" },
    { 0x3502DA52, "wait_for_bullet_impact" },
    { 0xC9DFF8E3, "wait_for_button_release" },
    { 0xE14350A0, "wait_for_calm" },
    { 0xF70A9650, "wait_for_calvary_to_hit_aa" },
    { 0x953CB280, "wait_for_candy" },
    { 0xCFAF1890, "wait_for_capture_trigger" },
    { 0x3F623F69, "wait_for_car" },
    { 0xFD5AC8D6, "wait_for_cher_death" },
    { 0xD6777DD1, "wait_for_close_player" },
    { 0xA86B7DB3, "wait_for_convoy_gone" },
    { 0xDCCAEE59, "wait_for_craftable" },
    { 0xF239F4B5, "wait_for_creepy_vo" },
    { 0x156A6F4A, "wait_for_current_end" },
    { 0x61EB8FD6, "wait_for_damage" },
    { 0x9D06D136, "wait_for_damage_events" },
    { 0x5C167E8B, "wait_for_damage_to_play_water" },
    { 0xAC22C895, "wait_for_death" },
    { 0x3C827941, "wait_for_destroy" },
    { 0x20C77A48, "wait_for_dialog_event" },
    { 0x950B98F7, "wait_for_dialog_triggers" },
    { 0x4B1BEBA1, "wait_for_digger_hack_digging" },
    { 0x56FE869A, "wait_for_digger_hack_moving" },
    { 0xD4889B6B, "wait_for_disconnect" },
    { 0xB7C7870E, "wait_for_dobj" },
    { 0xE7031AAE, "wait_for_drop" },
    { 0x39CD87A2, "wait_for_either" },
    { 0x6A686C8F, "wait_for_either_trigger" },
    { 0xA4F62630, "wait_for_end" },
    { 0xF3D0A5D7, "wait_for_end_credits" },
    { 0x6675545D, "wait_for_end_game" },
    { 0xDB53609E, "wait_for_enemies_to_die" },
    { 0xDA3BE6EB, "wait_for_enemy" },
    { 0xB27C96AE, "wait_for_engine_fire" },
    { 0x1004CB57, "wait_for_entry_vo" },
    { 0x8E1E7EA9, "wait_for_exit" },
    { 0xB0AAA19E, "wait_for_explosion" },
    { 0x800FB4C0, "wait_for_explosive_bolt_damage" },
    { 0x1C03B8B3, "wait_for_extracam_close" },
    { 0xB7796427, "wait_for_face_event" },
    { 0x7387888C, "wait_for_fence_guys_to_be_drafted" },
    { 0xA04B1646, "wait_for_final_flicker" },
    { 0x7AE83C31, "wait_for_finalbattle" },
    { 0x7A40519E, "wait_for_finalbattle_alternate" },
    { 0xD60A80FB, "wait_for_fire_rockets" },
    { 0xB2C47917, "wait_for_first_player" },
    { 0xBA8793F7, "wait_for_flag" },
    { 0x52867C5D, "wait_for_flag_or_time_elapses" },
    { 0x8D0010C3, "wait_for_flag_set_action" },
    { 0x20B11210, "wait_for_flag_set_lull" },
    { 0xB972505A, "wait_for_flinger_area_to_be_clear" },
    { 0x1D1DEE32, "wait_for_flung_players_to_land" },
    { 0x106A33E2, "wait_for_followers" },
    { 0xDC5727BD, "wait_for_foot_sync" },
    { 0xC6E06899, "wait_for_foot_sync_timeout" },
    { 0x64E70B34, "wait_for_friendlies_to_reach_alley_goal" },
    { 0x2FDC9ADF, "wait_for_fx_spawns_to_play_sound" },
    { 0x03F54BB5, "wait_for_game_end" },
    { 0x4F463584, "wait_for_gas" },
    { 0x7C4BEB67, "wait_for_gas_button" },
    { 0x1430D7F9, "wait_for_global_trigger" },
    { 0x4EF02164, "wait_for_goal" },
    { 0x75C6DFC2, "wait_for_grab_input" },
    { 0xB336435B, "wait_for_grenade_explode" },
    { 0x45BAA300, "wait_for_grenades" },
    { 0x747B8B0E, "wait_for_group_notify" },
    { 0xABD230CE, "wait_for_group_spawn" },
    { 0xF414CAF3, "wait_for_groupent_notify" },
    { 0x752F4973, "wait_for_guard_tower_sploders" },
    { 0x589DFAAE, "wait_for_guy_to_die_or_get_in_position" },
    { 0x478703C5, "wait_for_guys_gate" },
    { 0x5CAB1269, "wait_for_guys_gate_reach" },
    { 0xF58E0655, "wait_for_hint_destroy" },
    { 0x3F886D2C, "wait_for_horse_anim" },
    { 0x43BF6297, "wait_for_host" },
    { 0x1BFCF62A, "wait_for_human_zombie_exit_zipline" },
    { 0x0FD9DEEC, "wait_for_initial_conditions" },
    { 0x7DD0BE93, "wait_for_input" },
    { 0xEA846259, "wait_for_interrogation_scene_end" },
    { 0x258BFBAF, "wait_for_intro_anim" },
    { 0xC4235595, "wait_for_jetgun_fired" },
    { 0xBF3FE048, "wait_for_kill_trigger" },
    { 0x70586773, "wait_for_killanimscript_or_time" },
    { 0x2FF75446, "wait_for_killed" },
    { 0xCC04E099, "wait_for_laststand_notify" },
    { 0xB1203F93, "wait_for_leap" },
    { 0xC57DB2D5, "wait_for_leaper_attack" },
    { 0xF54D8225, "wait_for_level_notify_or_timeout" },
    { 0x08B9FE11, "wait_for_liftoff" },
    { 0x38C03B6D, "wait_for_linker_bunker_trigger" },
    { 0x7B8C746B, "wait_for_m202_to_hit_mg" },
    { 0x0382235C, "wait_for_m202_to_hit_mg_later" },
    { 0x3874668E, "wait_for_master_trigger" },
    { 0xC7C91287, "wait_for_maxis_tower" },
    { 0x898C73CF, "wait_for_maze_fountain_to_be_destroyed" },
    { 0x4717127F, "wait_for_microwavegun_fired" },
    { 0x8DC0A307, "wait_for_mine_pickup" },
    { 0xCF41F8B4, "wait_for_monkey_bolt_holder_to_die" },
    { 0xB94A1743, "wait_for_move_trigger" },
    { 0xE3D792E6, "wait_for_movie_to_be_done" },
    { 0x7A802E11, "wait_for_my_sploder" },
    { 0x45F37434, "wait_for_neutralize" },
    { 0x7CFB7C87, "wait_for_next_round" },
    { 0x19EB19FC, "wait_for_noteworthy" },
    { 0xC0BF5574, "wait_for_notification" },
    { 0x9495727A, "wait_for_notify" },
    { 0xD231ADC3, "wait_for_notify_then_track_notetracks" },
    { 0xE52412E4, "wait_for_opel_death" },
    { 0xBFD27871, "wait_for_pause" },
    { 0x3A5F1071, "wait_for_pickup" },
    { 0xCBE9CCCD, "wait_for_pilot" },
    { 0xEC2C0B2E, "wait_for_pistol_grabbed" },
    { 0xBF2D36DC, "wait_for_play_sound_on_tag" },
    { 0x290F06B6, "wait_for_player" },
    { 0xE1DFB1D5, "wait_for_player_advance" },
    { 0x08E482FB, "wait_for_player_at_gap" },
    { 0xA50DEAE2, "wait_for_player_damage" },
    { 0x30B0DD5B, "wait_for_player_damage_event" },
    { 0xF1F65569, "wait_for_player_dialog" },
    { 0x767C5147, "wait_for_player_disconnect" },
    { 0x06BDE0A6, "wait_for_player_downed" },
    { 0x4FB0F75F, "wait_for_player_exit_zipline" },
    { 0x9187E94E, "wait_for_player_falling" },
    { 0x080E6B99, "wait_for_player_jump" },
    { 0xE1D42785, "wait_for_player_kill" },
    { 0xD1374BE5, "wait_for_player_liftoff" },
    { 0x82CF611F, "wait_for_player_shoot_event" },
    { 0xDD79CDB5, "wait_for_player_thread" },
    { 0xB865E187, "wait_for_player_to_ads_for_time" },
    { 0x29495550, "wait_for_player_to_approach_airfield" },
    { 0x9C0CB21F, "wait_for_player_to_damage_me" },
    { 0x3FF82CF7, "wait_for_player_to_disconnect" },
    { 0x195CB924, "wait_for_player_to_disrupt_second_floor_or_leave" },
    { 0xC878E79D, "wait_for_player_to_drop_off_balcony" },
    { 0xF05B84F4, "wait_for_player_to_drop_price" },
    { 0xD9ED4959, "wait_for_player_to_drop_price_func" },
    { 0xC3D9FE90, "wait_for_player_to_exit_first_hut" },
    { 0x1626B5BC, "wait_for_player_to_fail_takeoff" },
    { 0xDCEF6B0B, "wait_for_player_to_get_close_to_boat" },
    { 0x8088B34B, "wait_for_player_to_get_on_island" },
    { 0xE3C7E92D, "wait_for_player_to_hit_housing_trigger" },
    { 0x3C420DA7, "wait_for_player_to_hookup" },
    { 0xF409A9C9, "wait_for_player_to_jump" },
    { 0x6117C677, "wait_for_player_to_kill_guard" },
    { 0x6B3C8706, "wait_for_player_to_kill_him" },
    { 0xB42AF94F, "wait_for_player_to_mark_enemy" },
    { 0x2C64D74D, "wait_for_player_to_meleekill_guard" },
    { 0x0A994590, "wait_for_player_to_place_claymores" },
    { 0x6C7F495A, "wait_for_player_to_pull_chute" },
    { 0x3F471299, "wait_for_player_to_reach_plane" },
    { 0x779E4688, "wait_for_player_to_reach_shore" },
    { 0x9B0A072A, "wait_for_player_to_see_leaper" },
    { 0xA425E19B, "wait_for_player_to_shoot_aa" },
    { 0xF6432D4C, "wait_for_player_to_take" },
    { 0x26367F33, "wait_for_player_to_use_boat" },
    { 0x9D07C28A, "wait_for_player_to_use_m202" },
    { 0x92CCBCA9, "wait_for_players" },
    { 0xF8B21C46, "wait_for_players_here" },
    { 0x82CAB2C5, "wait_for_poi_arrival" },
    { 0x87FB5DDC, "wait_for_power" },
    { 0x7ADEC17B, "wait_for_power_out_lower" },
    { 0x0844CA00, "wait_for_power_out_upper" },
    { 0xE901C48D, "wait_for_projectile_impact" },
    { 0xDA9E1C79, "wait_for_pulldown_trigger" },
    { 0x3498567B, "wait_for_respawn" },
    { 0xF707D9DE, "wait_for_retreat" },
    { 0x4DCDF9A1, "wait_for_retreat_done" },
    { 0xCEEFA349, "wait_for_richtofen_tower" },
    { 0x4160F51A, "wait_for_richtoffen_intro" },
    { 0x502FAC7E, "wait_for_roof_guard_death" },
    { 0x0CFC86CB, "wait_for_round" },
    { 0x5A2CEC7D, "wait_for_round_end" },
    { 0x3A7E1A10, "wait_for_round_over" },
    { 0x17A9A69D, "wait_for_round_range" },
    { 0x6FAC7861, "wait_for_sabotage" },
    { 0x07B0F15A, "wait_for_sam_cave_destroyed" },
    { 0x9A63761F, "wait_for_scale_notify" },
    { 0xB1947B1B, "wait_for_scene_to_nearly_complete" },
    { 0xF5C4EFF7, "wait_for_script_noteworthy_trigger" },
    { 0xFF2753B1, "wait_for_seaknight_to_take_off" },
    { 0xBA9286DA, "wait_for_shoot" },
    { 0x96DE49D9, "wait_for_signal" },
    { 0x06209090, "wait_for_signals" },
    { 0x572D9797, "wait_for_single_sploder" },
    { 0xDF681BAF, "wait_for_slipgun" },
    { 0xD70E707F, "wait_for_sloth" },
    { 0x9E9F72AE, "wait_for_snipe" },
    { 0xD1160BAD, "wait_for_sounddone_or_death" },
    { 0x83FCC27A, "wait_for_spawn_notify_swift" },
    { 0x161E8E6B, "wait_for_spawn_trigger_swift" },
    { 0xBA76E331, "wait_for_squad_objective" },
    { 0xFBE9D1CE, "wait_for_squad_to_hide" },
    { 0x618B7F55, "wait_for_staircase_trig" },
    { 0xB58D1802, "wait_for_stationary_tank" },
    { 0x0DDB5B26, "wait_for_stealth_to_break" },
    { 0xE018C20F, "wait_for_stop_notify" },
    { 0x6436DB27, "wait_for_stop_wait" },
    { 0x1FE97990, "wait_for_streamer_hint_scenes" },
    { 0x844D97A2, "wait_for_strobe" },
    { 0x7319BA07, "wait_for_submerge" },
    { 0x851CE223, "wait_for_surprise_guys" },
    { 0x28422697, "wait_for_switch_then_update" },
    { 0x5EE26398, "wait_for_switch_weapon" },
    { 0x2EA730AF, "wait_for_takeoff" },
    { 0x511BF02B, "wait_for_tank_cooldown" },
    { 0x1411A4E2, "wait_for_targetname_trigger" },
    { 0x3C98E6DD, "wait_for_targets" },
    { 0x46B0F389, "wait_for_team_death" },
    { 0xD80275C8, "wait_for_team_death_and_round_end" },
    { 0x080009F4, "wait_for_teleport_aftereffect" },
    { 0xC8111181, "wait_for_teleport_done_notify" },
    { 0x6BF377BE, "wait_for_the_player_speed" },
    { 0x143056F8, "wait_for_third_wave" },
    { 0x9C5A48A9, "wait_for_thompson" },
    { 0xD4AAB2C0, "wait_for_throw_status" },
    { 0xE52BD440, "wait_for_thundergun_fired" },
    { 0x648516CE, "wait_for_time" },
    { 0x9E3D3DB0, "wait_for_time_bomb_to_be_detonated_or_thrown_again" },
    { 0x6FABB2A7, "wait_for_timed_event" },
    { 0x369019CA, "wait_for_timeout" },
    { 0x3B2084B7, "wait_for_trigger" },
    { 0xD7B4D20B, "wait_for_trigger_and_notify" },
    { 0x82B4842D, "wait_for_trigger_and_notify_ent" },
    { 0x05EF8A99, "wait_for_trigger_by_name" },
    { 0xC7CF9E05, "wait_for_trigger_by_noteworthy" },
    { 0xCB4EAB80, "wait_for_trigger_clear_of_ai" },
    { 0xB01A476E, "wait_for_trigger_for_combat" },
    { 0x0F770995, "wait_for_trigger_or_timeout" },
    { 0xA6BD0CA7, "wait_for_trigger_snipe" },
    { 0x50AA228E, "wait_for_trigger_think" },
    { 0x780FF51E, "wait_for_turret_fire" },
    { 0x5207F478, "wait_for_unload" },
    { 0x2F2C0BE3, "wait_for_unnoticeable_cleanup_opportunity" },
    { 0xF24807A5, "wait_for_use_button" },
    { 0x2C33B026, "wait_for_use_button_while_in_trigger" },
    { 0xDD339A83, "wait_for_valid_damage" },
    { 0x987A7BFB, "wait_for_vehicle_damage_events" },
    { 0x73CACC65, "wait_for_vehicle_overturn" },
    { 0x4A22A00B, "wait_for_vehicle_retreat" },
    { 0xC29FA4E6, "wait_for_vehicle_to_stop_outside_min_radius" },
    { 0x7D06E910, "wait_for_wave2_ai_to_use_turret" },
    { 0x98C03A89, "wait_for_wave2_trig" },
    { 0x1CFADE41, "wait_for_wave3_spawn" },
    { 0x1F6A0E81, "wait_for_wave_death" },
    { 0x7D0DD58D, "wait_for_weaver" },
    { 0x4D48CAA3, "wait_for_window_hit" },
    { 0x95DC61E3, "wait_for_window_to_be_broken" },
    { 0xF029FA3E, "wait_for_woods_to_reach_door" },
    { 0x4BBA1753, "wait_for_x" },
    { 0x4B0C860B, "wait_for_x_press" },
    { 0xD6D99EE0, "wait_for_zombie_flame_fx" },
    { 0xCBF88FA1, "wait_for_zombie_to_esacpe" },
    { 0xEDA9EBDF, "wait_for_zombies_launched" },
    { 0xE79D0B90, "wait_frame" },
    { 0x9C96B893, "wait_func" },
    { 0xF6772442, "wait_ghost_ghost" },
    { 0xA0254875, "wait_give_perk" },
    { 0x5BA83BB8, "wait_goal_count" },
    { 0x5DEE12B3, "wait_idle" },
    { 0xD149C358, "wait_in_courtyard" },
    { 0x0037ED7F, "wait_in_town" },
    { 0xC80C2311, "wait_init_damage" },
    { 0xB8F39A26, "wait_interval" },
    { 0x62177E42, "wait_killcam_time" },
    { 0xE76175DB, "wait_lights1" },
    { 0x755A06A0, "wait_lights2" },
    { 0x9B5C8109, "wait_lights3" },
    { 0xA8F3EDD7, "wait_locations" },
    { 0x39C72159, "wait_max" },
    { 0x91907EB6, "wait_message" },
    { 0x946CFFE7, "wait_min" },
    { 0x8D366C82, "wait_music" },
    { 0x4C3231E1, "wait_n_delete" },
    { 0x268C6B6E, "wait_n_destroy" },
    { 0x95084B60, "wait_n_kill" },
    { 0x7F0E1D4A, "wait_n_kill_array" },
    { 0xEA1D83EB, "wait_n_notify" },
    { 0x8D0F8392, "wait_n_shake" },
    { 0xA5E3DADD, "wait_n_spawn" },
    { 0x37DF0AAD, "wait_n_spawn_solo" },
    { 0x76F13293, "wait_network_frame" },
    { 0x8ACABE7E, "wait_next_killstreak_dialog" },
    { 0xF8A52749, "wait_next_leader_dialog" },
    { 0x7BDF3781, "wait_node" },
    { 0x9D74D872, "wait_notify" },
    { 0x09DEDC41, "wait_notify_door" },
    { 0xF1284A32, "wait_on_box_alarm" },
    { 0x22D69866, "wait_on_reload" },
    { 0x52C7895C, "wait_on_vertical_death" },
    { 0xB2DF12CE, "wait_open_sesame" },
    { 0x04AB4CB6, "wait_or_timeout" },
    { 0x55098DB7, "wait_or_waittill" },
    { 0x9DD37D09, "wait_override" },
    { 0x62AF34DE, "wait_play_dialog" },
    { 0x70A55320, "wait_play_text_on_screen" },
    { 0x54ECEFEE, "wait_playback_time" },
    { 0x87D109FA, "wait_player_fall" },
    { 0x1265A3EB, "wait_player_gets_flamethrower" },
    { 0xDA217883, "wait_preload_weapon" },
    { 0x3F4093DA, "wait_put_piece_back_in_jail" },
    { 0x62A758AD, "wait_release_swim_buttons" },
    { 0xAF350B89, "wait_repopulate_flak" },
    { 0x94F49A0E, "wait_respawn_" },
    { 0x55B645AE, "wait_respawn_booze_at_start" },
    { 0xAA32EF0F, "wait_respawn_candy_booze" },
    { 0xFF5C067B, "wait_restore_npc_soct" },
    { 0x76084851, "wait_restore_player_soct" },
    { 0x156A78E4, "wait_restore_salazar_soct" },
    { 0x4EF6F494, "wait_score_cf_increment_info" },
    { 0xEE6484A2, "wait_server_frame" },
    { 0x397BB681, "wait_signal" },
    { 0x821991A3, "wait_skip_killcam_button" },
    { 0xD0F29FE3, "wait_skip_killcam_safe_spawn_button" },
    { 0xBB480158, "wait_spreader_allotment" },
    { 0x1547B038, "wait_spreaders" },
    { 0x7197B1A6, "wait_sr71_crew_group_anim" },
    { 0x000F48D7, "wait_start_candy_booze" },
    { 0x606C41C4, "wait_state" },
    { 0x82A5F74B, "wait_step" },
    { 0xFC5ECC2C, "wait_stop_flak_firing" },
    { 0xC06924CA, "wait_string" },
    { 0x00A649D0, "wait_switch_weapon" },
    { 0x45C15D8B, "wait_take_carry_weapon" },
    { 0x70DEE73F, "wait_team_change_end_killcam" },
    { 0xA2B8A9DF, "wait_team_changed" },
    { 0xC648B1CC, "wait_then_cleanup_vehicle" },
    { 0x40FD7924, "wait_then_create_base_magic_box_fx" },
    { 0xA2CC2255, "wait_then_go_to_target" },
    { 0x23B7FD8F, "wait_then_hide" },
    { 0xE0BC3CBF, "wait_then_kill_civilian_executioner" },
    { 0x92086A22, "wait_then_play_blood_pool_fx" },
    { 0x295A1860, "wait_then_thread_static" },
    { 0xFC498E58, "wait_til_fridge_move" },
    { 0xB82B207A, "wait_til_goal" },
    { 0x1AB5EBEC, "wait_till" },
    { 0x8870CFA8, "wait_till_all" },
    { 0xDE274E38, "wait_till_all_timeout" },
    { 0x43AC000B, "wait_till_any" },
    { 0x1FF63C0F, "wait_till_any_timeout" },
    { 0xD3DE6822, "wait_till_clear" },
    { 0xC8CA818A, "wait_till_clear_all" },
    { 0x0EAFBAEA, "wait_till_clear_all_timeout" },
    { 0x270609B1, "wait_till_clear_any" },
    { 0xF0C72955, "wait_till_clear_any_timeout" },
    { 0xD819E202, "wait_till_clear_timeout" },
    { 0x60C60341, "wait_till_dead" },
    { 0x3A87647B, "wait_till_death" },
    { 0x6CF2ABBD, "wait_till_done_playing_vcs" },
    { 0x3D58D85C, "wait_till_flashed" },
    { 0x4FC0056C, "wait_till_hero_weapon_is_fully_on" },
    { 0x0866592E, "wait_till_match" },
    { 0xC8575F2A, "wait_till_not_touching" },
    { 0x56D707DD, "wait_till_objects_ready" },
    { 0x3B6E7BEC, "wait_till_player_close_enough" },
    { 0x8616BE8E, "wait_till_player_looking_at_hind" },
    { 0x031012EA, "wait_till_pos_cleared" },
    { 0x454FDD00, "wait_till_reach_vehicle_node" },
    { 0xE8335960, "wait_till_scene_done" },
    { 0x2F376105, "wait_till_scene_ready" },
    { 0x069CB35F, "wait_till_something_happens" },
    { 0xB7191F9E, "wait_till_stable" },
    { 0xD266A8B4, "wait_till_timeout" },
    { 0x1803F73C, "wait_till_touching" },
    { 0x03865186, "wait_time" },
    { 0x5C65B6D9, "wait_time_and_enemies" },
    { 0xEB0BDCA6, "wait_time_before_awarding_loot_xp" },
    { 0xFA069C9D, "wait_time_max" },
    { 0x376AA7B3, "wait_time_min" },
    { 0xB72EE463, "wait_time_or_boats_defeated" },
    { 0x104521C7, "wait_time_to_start" },
    { 0x5846B5E2, "wait_timeout" },
    { 0xED730484, "wait_timeout2" },
    { 0x0CE6CF39, "wait_times" },
    { 0x40730930, "wait_to_be_clear" },
    { 0xEE97A198, "wait_to_be_gas" },
    { 0x1500BB81, "wait_to_be_looked_at" },
    { 0x6A7A060D, "wait_to_be_shot" },
    { 0x5409D19E, "wait_to_delete_beartrap_align" },
    { 0x8A650B38, "wait_to_do_water_depth" },
    { 0x86300FC8, "wait_to_end_looper" },
    { 0xC81CAA73, "wait_to_go" },
    { 0xD85363A6, "wait_to_move" },
    { 0x253E1ED5, "wait_to_reach_door" },
    { 0xB4543D7A, "wait_to_reach_struct" },
    { 0xF36503D2, "wait_to_remove_turret_hint" },
    { 0x2EECA2CB, "wait_to_set_explo_snapshot" },
    { 0xD5AAA072, "wait_to_set_explo_snapshot_uw" },
    { 0x9830E7BC, "wait_to_show_glowing_model" },
    { 0x3FAB2845, "wait_to_shut_off" },
    { 0xB0B17398, "wait_to_spawn_group2" },
    { 0xB0D82CA0, "wait_to_start_club_crowd" },
    { 0xA37A71DA, "wait_to_start_club_music" },
    { 0x6BE9AC8E, "wait_to_start_log_encounter" },
    { 0xC21DF674, "wait_to_unlink" },
    { 0xF0530225, "wait_traversal_timeout" },
    { 0x5F31A9C3, "wait_trig" },
    { 0xB937185D, "wait_trigger_clear" },
    { 0x24F6D551, "wait_turn_to_zombie" },
    { 0xCC5BD8B4, "wait_unbuild_chalk" },
    { 0x5B82EA6F, "wait_until_alley_is_clear_of_enemies" },
    { 0x0D24FE79, "wait_until_an_enemy_is_in_safe_area" },
    { 0xF8AC3BF5, "wait_until_anim_finishes" },
    { 0xD85AD801, "wait_until_convoy_can_move" },
    { 0xDBACC94A, "wait_until_deathflag_enemies_remaining" },
    { 0x858EE9CF, "wait_until_done_speaking" },
    { 0xE28B9524, "wait_until_first_player" },
    { 0x493F0E81, "wait_until_is_done" },
    { 0x1C68FF80, "wait_until_mortars_are_dead" },
    { 0x32A1D4C8, "wait_until_player_gets_close_or_progresses" },
    { 0x6BA01F77, "wait_until_player_goes_into_second_floor_or_melee_sequence_completes" },
    { 0x6B8B9FD4, "wait_until_player_nears_balcony" },
    { 0x62BF282D, "wait_until_player_on_horse" },
    { 0x091C5DFC, "wait_until_price_nears_balcony" },
    { 0xD82FFABD, "wait_until_price_reaches_his_trigger" },
    { 0x1A77B4A1, "wait_until_seaknight_gets_close" },
    { 0xFBC9809F, "wait_until_severely_damaged" },
    { 0xE0990331, "wait_until_spectate_on_join_completes" },
    { 0x39E3B7BE, "wait_until_the_heat_defend_area_is_clear" },
    { 0x9D1BBCD3, "wait_until_this_many_end_guys_killed" },
    { 0xD6BBD6E1, "wait_until_this_many_end_guys_killed_or_timeout" },
    { 0x0DB15022, "wait_until_vehicle_position_wont_telefrag" },
    { 0xDDC3BB3E, "wait_update" },
    { 0x879EC7BE, "wait_upstairs_clear" },
    { 0x77B714E9, "wait_upstairs_fallback" },
    { 0x12BE1495, "wait_variability" },
    { 0xC767523C, "wait_vehiclespawn" },
    { 0x0DD501EA, "wait_wallrun_begin" },
    { 0xCC21118F, "wait_while_enemies_are_alive_near_player" },
    { 0x6B7135D2, "wait_while_player_touching_ent" },
    { 0xDABDA1BC, "wait_while_players_can_see" },
    { 0x0F4788F0, "wait_zone_flags_updating" },
    { 0x66C53BEB, "wait_zone_moved" },
    { 0x8C4662E0, "waitabit" },
    { 0xDBAD4A14, "waitaftershot" },
    { 0x5AE6DAFE, "waitamount" },
    { 0x3D7D929C, "waitandactivateplayercontrol" },
    { 0x60D5960A, "waitanddamage" },
    { 0x34EE4B94, "waitanddelete" },
    { 0x6A3626FB, "waitanddeletedud" },
    { 0x68CFC671, "waitanddetonate" },
    { 0xEA2E17CD, "waitandfizzleout" },
    { 0x5D4D6FF5, "waitandprocessplayerkilledcallback" },
    { 0xE2AF3338, "waitandsetgoalvolume" },
    { 0x8DEB5B1B, "waitandspawnclient" },
    { 0xB17949A3, "waitanduploadstats" },
    { 0x21C398B1, "waitappearweapon" },
    { 0x4723DAED, "waitarray" },
    { 0x35D0ED23, "waitattachflag" },
    { 0xF7B34BDB, "waitbeforedeath" },
    { 0xBD1656BF, "waitbeforerotationcheck" },
    { 0x7FAE947D, "waitbetweenchecks" },
    { 0x719BCA27, "waitbetweentrains" },
    { 0xC7C66B36, "waitch_for_180turn" },
    { 0x4DB12645, "waitclearnode" },
    { 0x7556DED1, "waitcompleted" },
    { 0x6DD5ACD6, "waitcompletedsuccessfully" },
    { 0x171FAF49, "waitcondition" },
    { 0x2865C8DF, "waitcount" },
    { 0x997E1ABB, "waitdelay" },
    { 0x5B8BA80E, "waitduration" },
    { 0xCE8BFFCB, "waite" },
    { 0x487FAED5, "waited" },
    { 0xA6C0F512, "waitedtime" },
    { 0xB69109EA, "waitendonmigration" },
    { 0x5CA26093, "waiter" },
    { 0x2DB60FC2, "waiters" },
    { 0x425C8B9C, "waitfinalkillcamslowdown" },
    { 0x6BF6EAC8, "waitflag" },
    { 0x19D95897, "waitfor" },
    { 0x6CE315AD, "waitfor_bodyscan" },
    { 0x161CD15F, "waitfor_bodyscan_end" },
    { 0x056D8537, "waitfor_characterswitch" },
    { 0x8332BEEE, "waitfor_convo_trigger" },
    { 0xB65828AC, "waitfor_death" },
    { 0x4295B209, "waitfor_door_open" },
    { 0xB55A1746, "waitfor_dryland" },
    { 0xA52E0938, "waitfor_eightbit_use" },
    { 0x22797A3E, "waitfor_enemy" },
    { 0x22C5417C, "waitfor_enough_drones" },
    { 0x5CE063B3, "waitfor_exit_vehicle" },
    { 0xCD1DB4B9, "waitfor_failsafe" },
    { 0xE757BE94, "waitfor_first_player" },
    { 0x4EF1B188, "waitfor_flag" },
    { 0x690BEC51, "waitfor_flag_open_chest_location" },
    { 0x22ED617F, "waitfor_forest_zone_entry" },
    { 0xB0FEF944, "waitfor_gasmask_buy" },
    { 0xB7F6BADF, "waitfor_gasmask_on" },
    { 0xB154FB05, "waitfor_leadplane_death" },
    { 0xB70BC21E, "waitfor_mortar_death" },
    { 0x1BF9783A, "waitfor_music_stop" },
    { 0xC2944539, "waitfor_notify" },
    { 0x4F5D74C2, "waitfor_override" },
    { 0x5DFF2FD4, "waitfor_player_attack" },
    { 0x2FD7832A, "waitfor_player_grenade" },
    { 0x0E39836C, "waitfor_player_toshoot" },
    { 0xBE781CE0, "waitfor_povoff" },
    { 0x08F8413A, "waitfor_povon" },
    { 0xE5D138D9, "waitfor_reaper_end" },
    { 0x07065312, "waitfor_rtsoff" },
    { 0xF9C91164, "waitfor_rtson" },
    { 0xE5E6DAEA, "waitfor_smash" },
    { 0xD9A9BE04, "waitfor_startloop" },
    { 0xA0E711AC, "waitfor_stoploop" },
    { 0x788CA9BD, "waitfor_underwater" },
    { 0x53B12BE7, "waitfor_volume_increase" },
    { 0x10F13008, "waitforallclients" },
    { 0xB111D589, "waitforanypriorityreturn" },
    { 0x014D1BD7, "waitforbaseonalert" },
    { 0x44333182, "waitforclient" },
    { 0xDB666897, "waitforclonetouch" },
    { 0x696FC14F, "waitfordeath" },
    { 0x04441996, "waitforend" },
    { 0xAB20D6FD, "waitforendcreditschangemusic" },
    { 0xE3834BCA, "waitforeyesonlylook" },
    { 0x29C08F09, "waitforfaceeventcomplete" },
    { 0x6C794AC9, "waitforfaceeventrepeat" },
    { 0x8F3AFB21, "waitforfacesound" },
    { 0x07509D18, "waitforfacialanim" },
    { 0xD143BBDC, "waitforgameendthread" },
    { 0x23947892, "waitforglassbreak" },
    { 0x5662A67B, "waitforgrenadefire" },
    { 0x831A7B56, "waitforhelicoptershutdown" },
    { 0x39D8281C, "waitforhumanselection" },
    { 0x16FAE838, "waitforlocationselection" },
    { 0x70A263B4, "waitformovedone" },
    { 0xBD13F9E7, "waitfornewdrone" },
    { 0x68230976, "waitfornexttension" },
    { 0x425E7630, "waitfornotifies" },
    { 0xA85B140C, "waitfornotify" },
    { 0x57718169, "waitforonlyonedroplocation" },
    { 0x4371478F, "waitforpathgoalpos" },
    { 0xD1EB6B05, "waitforplayerkillcount" },
    { 0xF9BF27F3, "waitforplayers" },
    { 0x8BF6514D, "waitforplayertouch" },
    { 0x1924E810, "waitforragdoll" },
    { 0xAC5E053E, "waitforrecentfire" },
    { 0xC9DF30D8, "waitforrevive" },
    { 0x1CF87F21, "waitforservertime" },
    { 0x17C50624, "waitforsound" },
    { 0x5694A1CC, "waitforstats" },
    { 0x9E1A5FA2, "waitforstoppingmovetoexpire" },
    { 0x22FBCCE0, "waitforstring" },
    { 0xBCDB4DA8, "waitfortargettobeginlifespan" },
    { 0x61467144, "waitfortime" },
    { 0x9510F38A, "waitfortimeandnetworkframe" },
    { 0x0CA5246C, "waitfortimecheck" },
    { 0xB59D6FA4, "waitfortimeornotifies" },
    { 0x16A37F28, "waitfortimeornotify" },
    { 0x2C29F030, "waitfortimeornotifynoairstrikes" },
    { 0x56CA4F95, "waitfortimeornotifynoartillery" },
    { 0xEEDCE410, "waitfortimeout" },
    { 0xE2226A14, "waitfortimeoutbeep" },
    { 0xBB041B80, "waitfortimeouthacked" },
    { 0xB85F00D1, "waitfortrigger" },
    { 0x6B9153EE, "waitforvtolshutdownthread" },
    { 0x9C4E1BEB, "waitforweapon" },
    { 0xA60BB525, "waitframe" },
    { 0x36A07934, "waitframes" },
    { 0x0A84A1B7, "waitill" },
    { 0x08E7179B, "waitill_armed" },
    { 0x959DEF36, "waitill_fire_at_rebels" },
    { 0x81D6EE50, "waitill_notify_and_toggle_dynents" },
    { 0x6812948A, "waitinc" },
    { 0x001C7E2E, "waiting" },
    { 0xED5AD556, "waiting_for_damage_to_repair" },
    { 0x84D35C47, "waiting_for_grab" },
    { 0x76F8EB7E, "waiting_for_move_to_dense_foliage_area" },
    { 0xDC330EE2, "waiting_for_move_to_woods_drop_off_point" },
    { 0xB0B7B339, "waiting_for_next_dog_spawn" },
    { 0x3B0859CE, "waiting_for_next_leaper_spawn" },
    { 0x725C1111, "waiting_for_next_raps_spawn" },
    { 0xC6E7C6E8, "waiting_for_path_reconnection" },
    { 0x2116BBEB, "waiting_for_stealth_move_to_house" },
    { 0x921267C4, "waiting_to_end" },
    { 0x686F6B12, "waiting_to_revive" },
    { 0x67236C7A, "waitingforattackbuttonrelease" },
    { 0xFABC1DF1, "waitingforenemytodisappear" },
    { 0xAC2C2D2A, "waitingforgate" },
    { 0xF2E9A21A, "waitingforplayerstext" },
    { 0x1F0C86AE, "waitingondartthrow" },
    { 0x9FA69EEE, "waitingtospawn" },
    { 0x42F5FD1C, "waitinqueue" },
    { 0xA90F3701, "waitinspawnqueue" },
    { 0xCA4814B7, "waitkey" },
    { 0x3E331950, "waitkillcamtime" },
    { 0xC2BA7057, "waitlen" },
    { 0x8750B7DD, "waitlogic_finished" },
    { 0xC50057A0, "waitlongdurationwithbombtimeupdate" },
    { 0x515833BD, "waitlongdurationwithgameendtimeupdate" },
    { 0xAB19BD44, "waitlongdurationwithhostmigrationpause" },
    { 0x45E1D952, "waitlongdurationwithhostmigrationpauseemp" },
    { 0xBA71F098, "waitmax" },
    { 0xD5671C46, "waitmin" },
    { 0x75A738C7, "waitng" },
    { 0x8DA87466, "waitnode" },
    { 0x566D30AC, "waitnode_name" },
    { 0x70A6CDAB, "waitnodename" },
    { 0xE0051B99, "waitnodes" },
    { 0x7AD67496, "waitnote" },
    { 0x35A5B879, "waitnotify" },
    { 0x5A765F04, "waitontruegoal" },
    { 0x9132BBE4, "waitornot" },
    { 0x845FDDDD, "waitperiod" },
    { 0xFC3B0953, "waitperiodmilliseconds" },
    { 0x07CB95BE, "waitplaybacktime" },
    { 0x95B399ED, "waitplayernode" },
    { 0x680E1A7B, "waitremotecontrol" },
    { 0x31DCA0D6, "waitremoveweapon" },
    { 0x6ECB638B, "waitrequirevisibility" },
    { 0x9349460A, "waitrespawnbutton" },
    { 0x8192DB4B, "waitrespawnorsafespawnbutton" },
    { 0xBA694E0D, "waits" },
    { 0x6B367612, "waitsafespawnbutton" },
    { 0x501D7CA0, "waitsetstates" },
    { 0x7448F033, "waitsetstatesenabled" },
    { 0x3622E032, "waitsetstop" },
    { 0xDE7AB37A, "waitsignal" },
    { 0xF59EF804, "waitskipkillcambutton" },
    { 0x7A03EB44, "waitskipkillcamsafespawnbutton" },
    { 0x7FCED367, "waitspread" },
    { 0xEF7DBF61, "waitspread_code" },
    { 0x45FD533C, "waitspread_death" },
    { 0xD43CD1D5, "waitspread_insert" },
    { 0x4285C9EA, "waitspreader" },
    { 0x13CD657B, "waitstr" },
    { 0xFE0B9D65, "waitstring" },
    { 0xBECBCD85, "waitteamchangeendkillcam" },
    { 0xE142D68A, "waitthendelete" },
    { 0xBCFCAD2E, "waitthenexplode" },
    { 0xC8B88B02, "waitthenfreezeplayercontrolsifgameendedstill" },
    { 0x622A8673, "waitthengivecontroltoplayer" },
    { 0x4A38CD43, "waitthengivecontroltoplayerwithdelta" },
    { 0xCB0E0C18, "waitthenmove" },
    { 0x834A6315, "waitthennotifyfinalkillcam" },
    { 0x41388F05, "waitthennotifyroundkillcam" },
    { 0x5EC3825B, "waitthenplayfx" },
    { 0x99494C4A, "waitthensetdeleteafterdestructionwaittime" },
    { 0x78A36E4C, "waitthenspawn" },
    { 0x1824CC36, "waitthenstoptanning" },
    { 0x40017067, "waittill" },
    { 0xF2048A93, "waittill_actor_damage" },
    { 0xB9E5E798, "waittill_ads_button_pressed" },
    { 0x45679EDD, "waittill_ai_group_ai_count" },
    { 0xC0434FF5, "waittill_ai_group_amount_killed" },
    { 0x72214789, "waittill_ai_group_cleared" },
    { 0x371D219C, "waittill_ai_group_count" },
    { 0xF8886EED, "waittill_ai_group_spawner_count" },
    { 0xCA99DA30, "waittill_ai_in_volume_dead" },
    { 0xBCC6398B, "waittill_aigroupcleared" },
    { 0x3F7747AA, "waittill_aigroupcount" },
    { 0x0F278345, "waittill_all_ais_touching" },
    { 0xF5FA6177, "waittill_all_axis_are_dead" },
    { 0x5C74EA73, "waittill_all_helis_killed" },
    { 0xD33614F4, "waittill_all_players_touching" },
    { 0x191849E4, "waittill_all_zombies_dead" },
    { 0xE1E99144, "waittill_and_get_button_pressed" },
    { 0x844F1956, "waittill_and_setflag" },
    { 0x5B7E3888, "waittill_any" },
    { 0xC7F20692, "waittill_any_array" },
    { 0x416D7103, "waittill_any_array_endon" },
    { 0xEC87322B, "waittill_any_array_return" },
    { 0x39B48811, "waittill_any_ents" },
    { 0xF20332A2, "waittill_any_ents_two" },
    { 0x183E3618, "waittill_any_ex" },
    { 0x1BF1BB34, "waittill_any_notify" },
    { 0x1EA63E14, "waittill_any_or_timeout" },
    { 0x6745EF68, "waittill_any_player_touching" },
    { 0x045CE26D, "waittill_any_return" },
    { 0x9FCF3CD8, "waittill_any_timeout" },
    { 0x3E039667, "waittill_asm_complete" },
    { 0x65FFC64A, "waittill_asset_loaded" },
    { 0x00F1A306, "waittill_at_bash" },
    { 0x5F60888A, "waittill_attack_button_pressed" },
    { 0x0E0F2210, "waittill_bp1wave3_done" },
    { 0x631C353B, "waittill_bp2wave3_done" },
    { 0xDD7D41E2, "waittill_bp3wave3_done" },
    { 0x1BB5210B, "waittill_bus_rpg_fire" },
    { 0xB0C9C169, "waittill_button_pressed" },
    { 0x1713D92A, "waittill_call_strafe_run" },
    { 0x02DA74DC, "waittill_cartel_died" },
    { 0x6A9ECF4D, "waittill_cave_is_cleared" },
    { 0x0AD12C27, "waittill_claw_moves_to_a_node" },
    { 0x56750168, "waittill_close_to_goal" },
    { 0xD48A95FE, "waittill_combat" },
    { 0xCC2A54E2, "waittill_combat_wait" },
    { 0x2009FAF4, "waittill_confirm_location" },
    { 0xD4AD272B, "waittill_crafted" },
    { 0xD83EAE68, "waittill_crash_done_or_stopped" },
    { 0x8DAF7251, "waittill_damage_and_notify" },
    { 0x21FE06CC, "waittill_dead" },
    { 0x27BC4415, "waittill_dead guy died" },
    { 0xCFF9A825, "waittill_dead_guy_dead_or_dying" },
    { 0x5491EDE6, "waittill_dead_or_dying" },
    { 0xBFB394E5, "waittill_dead_or_dying_thread" },
    { 0x2206FE5F, "waittill_dead_thread" },
    { 0x52B1DB54, "waittill_dead_timeout" },
    { 0x2DB3083C, "waittill_death" },
    { 0xBE566490, "waittill_death_or_dismount" },
    { 0x705B7C53, "waittill_death_to_send_notify" },
    { 0x4202AAEF, "waittill_dialog_finished" },
    { 0x34694B65, "waittill_dialog_finished_array" },
    { 0x3DC2626B, "waittill_dialog_queue_finished" },
    { 0x26FBF9D2, "waittill_dismount_trig" },
    { 0x2E224D69, "waittill_dobj" },
    { 0xABFCEA6D, "waittill_done_talking" },
    { 0x5FDE6688, "waittill_door_can_close" },
    { 0xE68010A1, "waittill_door_trigger_clear_global_power_off" },
    { 0x0B9606FD, "waittill_door_trigger_clear_local_power_off" },
    { 0x9BCFB4DB, "waittill_drone_done" },
    { 0xDC288EBE, "waittill_dug" },
    { 0x564F2D81, "waittill_either" },
    { 0x8CA9C3FC, "waittill_either_function" },
    { 0x4EFCFEFC, "waittill_either_function_internal" },
    { 0xED1D7CD0, "waittill_either_trigger" },
    { 0xC13A0089, "waittill_empty_queue" },
    { 0x27F73339, "waittill_end" },
    { 0x40DC8F9D, "waittill_enemies_bigrig" },
    { 0x50E148DD, "waittill_enemies_by_bus" },
    { 0x523C4DCD, "waittill_enemies_under_overpass" },
    { 0x84CF188E, "waittill_enemy" },
    { 0x9B40C2BE, "waittill_enemy_in_range_of_player" },
    { 0xD7F1DD78, "waittill_enemy_too_close_or_timeout" },
    { 0xC7CF8CA9, "waittill_ent" },
    { 0xDC07EEB4, "waittill_fallback" },
    { 0xCCA080C8, "waittill_flag_anddie" },
    { 0x58D438D7, "waittill_flag_exists" },
    { 0x3CB4A568, "waittill_flag_or_notify" },
    { 0xB834F0CE, "waittill_frag_button_pressed" },
    { 0x2CB019B9, "waittill_func_ends" },
    { 0xDC4AF7BE, "waittill_goal_and_die" },
    { 0xDADD17CF, "waittill_goal_set_radius" },
    { 0x1ED4A8A7, "waittill_group_dies" },
    { 0x84EB40A3, "waittill_group_dies_timeout" },
    { 0xFFD46E29, "waittill_has_a_weapon" },
    { 0x7345396E, "waittill_input" },
    { 0xE19EFF61, "waittill_instance_scene_done" },
    { 0xEB3B78F1, "waittill_knuckles_trigger" },
    { 0x63B078BF, "waittill_level_any_timeout" },
    { 0xBA1AD964, "waittill_level_string" },
    { 0x4BBD2832, "waittill_load" },
    { 0x109BDE21, "waittill_looked_at_or_trigger" },
    { 0x9814F02B, "waittill_looking_at_entity" },
    { 0x788A7F90, "waittill_loopstart" },
    { 0x3907BC9A, "waittill_melee" },
    { 0x59C5F830, "waittill_menendez_id" },
    { 0xFB8A7015, "waittill_movie_done" },
    { 0xFE077489, "waittill_msg" },
    { 0x08E66BC6, "waittill_multiple" },
    { 0x6959D3EF, "waittill_multiple_ents" },
    { 0xEB3DE4A3, "waittill_near_or_death" },
    { 0x45341FF0, "waittill_not_god_mode" },
    { 0x75D69B46, "waittill_not_moving" },
    { 0x2797CC03, "waittill_notetrack" },
    { 0x4DC49497, "waittill_noteworthy_dies" },
    { 0xB8F8436B, "waittill_notify_n_trig" },
    { 0x0C9AA1FF, "waittill_notify_or_timeout" },
    { 0xFA1FF28D, "waittill_notify_timeout" },
    { 0x4EEBAA2E, "waittill_notify_weaver_rescue_door_close" },
    { 0x5F4DB1E1, "waittill_objective_event_proc" },
    { 0xAE7C922C, "waittill_oktospawn" },
    { 0xDA40B7E4, "waittill_on_node" },
    { 0x466B6201, "waittill_past_or_death" },
    { 0x3A863DAC, "waittill_pathing_done" },
    { 0xBE798A34, "waittill_pathresult" },
    { 0x2A230352, "waittill_player_activates" },
    { 0x01950AAD, "waittill_player_approaches_ai" },
    { 0x7239FA0E, "waittill_player_away" },
    { 0xCA0A6D31, "waittill_player_choice" },
    { 0x7B9DA6D0, "waittill_player_clear_of_breach_zone" },
    { 0xE24B403A, "waittill_player_crouches" },
    { 0x140D3076, "waittill_player_death" },
    { 0x86F7D61C, "waittill_player_has_brute_force_perk" },
    { 0x467463C9, "waittill_player_has_intruder_perk" },
    { 0x6DE27C4E, "waittill_player_has_lock_breaker_perk" },
    { 0x56E0E3D1, "waittill_player_has_sniper_weapon" },
    { 0x513DA7C6, "waittill_player_in_good_spot_to_breach" },
    { 0x78CB10DF, "waittill_player_in_range" },
    { 0x36B79119, "waittill_player_is_close" },
    { 0x094A633C, "waittill_player_leaves" },
    { 0x0ED87BD2, "waittill_player_lookat" },
    { 0xC8E128FE, "waittill_player_lookat_for_time" },
    { 0x3546BE91, "waittill_player_looking_at" },
    { 0x9508DC96, "waittill_player_looking_at_me" },
    { 0x7A5C0D90, "waittill_player_mounts_horse" },
    { 0x5FCC8298, "waittill_player_near_convoy_and_f35_for_eject" },
    { 0xF8FDED02, "waittill_player_near_courtyard" },
    { 0x852DA2A1, "waittill_player_nearby" },
    { 0xDFC26185, "waittill_player_not_looking" },
    { 0xB6ECB7D7, "waittill_player_not_looking_at" },
    { 0x46922D77, "waittill_player_onhorse_bp2exit" },
    { 0x322C3BD6, "waittill_player_onhorse_bp3exit" },
    { 0x1B92FF07, "waittill_player_past_or_event_kicked_off" },
    { 0x2E2BF2EC, "waittill_player_shoots" },
    { 0x76A8F04D, "waittill_player_touches" },
    { 0x7EEF49E7, "waittill_player_within_range" },
    { 0x5B17EE5E, "waittill_players_goes_away" },
    { 0xFE86638C, "waittill_radius" },
    { 0xAA49E994, "waittill_safe_place_to_raise_gate" },
    { 0xE420DF65, "waittill_scene_done" },
    { 0xF6633AA9, "waittill_scene_or_death" },
    { 0x891087CD, "waittill_scene_spawned" },
    { 0xF69C7A83, "waittill_skip_sequence_completed" },
    { 0xDD383AC8, "waittill_snipers_on_overpass" },
    { 0x9449E2C1, "waittill_someone_touches_grass" },
    { 0x6009989F, "waittill_spawn" },
    { 0x4A36358D, "waittill_spawn_manager_ai_remaining" },
    { 0x59E0FFA2, "waittill_spawn_manager_cleared" },
    { 0x260BA1A7, "waittill_spawn_manager_complete" },
    { 0x9DD27029, "waittill_spawn_manager_enabled" },
    { 0xB5295810, "waittill_spawn_manager_spawned_count" },
    { 0xB0951175, "waittill_spawn_manager_spawns_x_more" },
    { 0x7194BE67, "waittill_speech_anim_done" },
    { 0x1091EA73, "waittill_stable" },
    { 0xA8CCAF9F, "waittill_staff_inserted" },
    { 0x02B30D3D, "waittill_stance_button_held" },
    { 0xF7499BE2, "waittill_stance_button_pressed" },
    { 0x07B32615, "waittill_string" },
    { 0x9A2118C4, "waittill_subset" },
    { 0x893FCEE6, "waittill_textures_loaded" },
    { 0xE35B5F48, "waittill_thrown" },
    { 0x97AE0B63, "waittill_timeout" },
    { 0x9BE1ABE9, "waittill_touching_entity" },
    { 0xF7D6D012, "waittill_trig_and_notify" },
    { 0x39F78DC2, "waittill_trig_and_say" },
    { 0x7CF8C3E5, "waittill_trig_n_notify" },
    { 0x0D08646C, "waittill_trig_n_setflag" },
    { 0x1BC9BA75, "waittill_trigg_and_print" },
    { 0xCABF4099, "waittill_trigg_and_say" },
    { 0xBEE1BF08, "waittill_trigger_array" },
    { 0x965C51E6, "waittill_trigger_or_notify" },
    { 0xB322BEE1, "waittill_trigger_seaknight" },
    { 0xB6A3A592, "waittill_trigger_seaknight_gun" },
    { 0xB3D08BAE, "waittill_trigger_special" },
    { 0x1B026B06, "waittill_trigger_timeout_or_notify" },
    { 0x23B726C3, "waittill_triggerarea_clear" },
    { 0x316CE80C, "waittill_triggered_by_ai" },
    { 0xD3ED3593, "waittill_turret_is_released" },
    { 0xB72D2198, "waittill_turret_on_target_delay" },
    { 0xD0FF1A80, "waittill_unloaded" },
    { 0x38D9DB98, "waittill_use_button_held" },
    { 0xEDD0928D, "waittill_use_button_pressed" },
    { 0xBF75758A, "waittill_vehicle_group_spawn" },
    { 0xAB97BA66, "waittill_vehicle_move_up_button_pressed" },
    { 0x8D3C77B2, "waittill_vehiclenode" },
    { 0x3365DBB4, "waittill_vehiclenode_noteworthy" },
    { 0x9F35C023, "waittill_vehiclespawn" },
    { 0x0D16736F, "waittill_vehiclespawn_noteworthy" },
    { 0x78739166, "waittill_vehiclespawn_spawner_id" },
    { 0xB71BA2DA, "waittill_vo_done" },
    { 0xAF398928, "waittill_weapon_lock_or_timeout" },
    { 0xA6204D28, "waittill_zero_breachers" },
    { 0xA0F4F2B5, "waittill_zero_enemies" },
    { 0x8A8FA1F8, "waittill_zombie_blood_dug" },
    { 0xDD44D336, "waittill_zone_clear" },
    { 0x04C37BBA, "waittill_zone_is_cleared" },
    { 0x15130637, "waittillbriefingdone" },
    { 0xA975DF4D, "waittillcanspawnclient" },
    { 0xACDBEBF1, "waittillclose" },
    { 0xE31EE85F, "waittilldeathorempty" },
    { 0x08CF663D, "waittilldeathorleavesquad" },
    { 0x983E3BEA, "waittilldeathorpaindeath" },
    { 0xA486BE80, "waittilldelay" },
    { 0x880032D9, "waittilldeletedordeath" },
    { 0x37FBC1AB, "waittilldone" },
    { 0x1B116607, "waittillemp" },
    { 0xD18B0F46, "waittillend" },
    { 0x10EB5054, "waittillendfx" },
    { 0xFB52D256, "waittillendonthreaded" },
    { 0xFF2531F4, "waittillframend" },
    { 0xCA2E5D07, "waittillgrenadedrops" },
    { 0x272F1479, "waittillgrenadethrown" },
    { 0x2E67D944, "waittillhostmigrationcountdown" },
    { 0x8EF8DA7F, "waittillhostmigrationdone" },
    { 0x521E5168, "waittillhostmigrationstarts" },
    { 0x188BDAE1, "waittillkillstreakdone" },
    { 0xC830B4D0, "waittillnotifiesdone" },
    { 0x58A36008, "waittillnotmoving" },
    { 0x7C0CB655, "waittillnotmoving_and_notstunned" },
    { 0x1819459D, "waittillplayerishitagain" },
    { 0xD0397EB6, "waittillreloadfinished" },
    { 0xFA738912, "waittillrestartordistance" },
    { 0x6D8ABB1A, "waittillrollingornotmoving" },
    { 0x2ECF78DE, "waittills" },
    { 0x7000C5F1, "waittillslowprocessallowed" },
    { 0x1EF8B698, "waittillspeedset" },
    { 0x1CCA8387, "waittillstingerdone" },
    { 0x845AB4D0, "waittillstring" },
    { 0x6A63E18E, "waittilltimeoutmigrationaware" },
    { 0xAECB03BF, "waittilltimeoutordeath" },
    { 0x77A7FE7D, "waittime" },
    { 0xB8539515, "waittime_before_delete" },
    { 0xB6239656, "waittime_scale" },
    { 0x8D0A485E, "waittimeafterblinklights" },
    { 0xDD4E67FA, "waittimeatdestination" },
    { 0x1CD075C2, "waittimeifplayerishit" },
    { 0xE32762B7, "waittimeoruntilturretstatechange" },
    { 0x331EE3DE, "waitting" },
    { 0xF8D4CD7E, "waittll_close_enough" },
    { 0xF383E810, "waittodisableswimming" },
    { 0xBC0880D3, "waittoenableswimming" },
    { 0xFB65D38D, "waituntilawareofenemy" },
    { 0x2BA87A64, "waituntilhaventfoughtforawhile" },
    { 0xB8AE2B11, "waituntilteamchange" },
    { 0xFD0843D0, "waituntilteamchangesingleton" },
    { 0x3C1BCF8C, "waituntilwaverelease" },
    { 0x9550958F, "waitwithstatechangecheck" },
    { 0xE6A5EFE9, "waka" },
    { 0x7EAFD98D, "wake" },
    { 0x0906AB40, "wake_angles" },
    { 0x2823E6D0, "wake_angles_on_water" },
    { 0x6EB546EE, "wake_audio" },
    { 0x40956D62, "wake_convoy_by_shoot" },
    { 0x6EEE0E53, "wake_convoy_by_trig" },
    { 0x263368A0, "wake_engineer_trig" },
    { 0x0DAA6FFA, "wake_fx" },
    { 0xBEED5F38, "wake_fxhandle" },
    { 0x57AD7176, "wake_mon" },
    { 0xA9BC6EF1, "wake_nearby" },
    { 0x18DFA599, "wake_offset" },
    { 0x76244CAA, "wake_pos_on_water" },
    { 0x98AB406A, "wake_road_walkers" },
    { 0x66428EF0, "wake_road_walkers_bytrig" },
    { 0x4B756120, "wake_tag" },
    { 0x6CFD4E1F, "wake_up_bridge3_guys" },
    { 0x78B6F85C, "wake_up_campfire_guys" },
    { 0xFB65E390, "wake_up_loop_count" },
    { 0x1E698C00, "wake_up_squad" },
    { 0xE05280DD, "wake_up_time" },
    { 0x3EBCA2FB, "wakefx" },
    { 0x6955160C, "wakes" },
    { 0xAA9B63D0, "wakestate" },
    { 0x3FEA8F1E, "wakeup" },
    { 0xA3FF5173, "wakeup_in_fountain" },
    { 0x027B0F23, "wakeup_sequence_salazar" },
    { 0xB3FFB11E, "wakeup_tunnel_guys" },
    { 0xE5D27C67, "wakeup_woods_backbreaker_factionfight_cartel1" },
    { 0x73CB0D2C, "wakeup_woods_backbreaker_factionfight_cartel2" },
    { 0xF8615C38, "wakeupai" },
    { 0x3FE32D38, "waking" },
    { 0xF611CFD0, "waking_up" },
    { 0xCF08AA3E, "walk" },
    { 0xC79C8904, "walk2sprint" },
    { 0xB7D2A5E6, "walk_and_run_loops" },
    { 0x20B1906D, "walk_anims" },
    { 0xAE17EA8A, "walk_combatanim" },
    { 0x6E18361C, "walk_combatanim2" },
    { 0x84B908CE, "walk_cqb_f" },
    { 0x1D226DF4, "walk_floor_watcher" },
    { 0xA3ADB5C3, "walk_into_position" },
    { 0xBF50861D, "walk_lowready_f" },
    { 0xBFF163D8, "walk_mode" },
    { 0x1F836771, "walk_noncombatanim" },
    { 0x60AF3B81, "walk_noncombatanim2" },
    { 0xA5F40463, "walk_of_shame" },
    { 0xBFB29B81, "walk_stretcher" },
    { 0xB9E895C6, "walk_tags" },
    { 0x3223303A, "walk_tags_used" },
    { 0xEE6A023E, "walk_to" },
    { 0x346551DD, "walk_to_exit" },
    { 0xFF7340B5, "walk_to_loop_anim" },
    { 0x4AD9DDC3, "walk_toward_sarge" },
    { 0x025CC983, "walk_version" },
    { 0xA697E129, "walkanim" },
    { 0x6AD652C8, "walkanimname" },
    { 0xD79910A0, "walkanims" },
    { 0x737E0B5C, "walkcycle" },
    { 0x73E0C05A, "walkdist" },
    { 0x2ABA2FD6, "walkdistfacingmotion" },
    { 0xF636B7C6, "walkdown" },
    { 0x8D757F81, "walked" },
    { 0x0FCB64B8, "walkedthroughflames" },
    { 0x115CB767, "walker" },
    { 0xC1803DDE, "walkers" },
    { 0xA77B4F34, "walkerspawners" },
    { 0x546B3102, "walkguard1" },
    { 0x01EBCF42, "walking" },
    { 0x41C4C129, "walking_lady" },
    { 0xD5B84244, "walking_loop_audio" },
    { 0x3FF6EB91, "walking_the_stream" },
    { 0x6329614E, "walkingvehicle" },
    { 0x4D621BA4, "walkonly" },
    { 0x066EDA5A, "walkrope" },
    { 0xA3B71321, "walks" },
    { 0x4747AED9, "walkstring" },
    { 0xC4A9B0F7, "walkthough" },
    { 0x08EE9AD9, "walkthrough" },
    { 0x760C1E9D, "walkthroughdialog" },
    { 0x8DF82265, "walkto_cave_entrance_scene" },
    { 0x825968C1, "walkunderwater" },
    { 0x72D50FE5, "walkup" },
    { 0xCC09CC23, "walkway" },
    { 0xFCD516D0, "walkway_after" },
    { 0x99E8570F, "walkway_before" },
    { 0x75B4CE95, "walkway_bridge_pieces" },
    { 0x2EEB4387, "walkway_collapse" },
    { 0x6E5874AE, "walkway_dest" },
    { 0x5B41FE2F, "walkway_snipers_cleared" },
    { 0x982D58A6, "walkway_support_dialog" },
    { 0x5A09372E, "walkwithvehicle" },
    { 0x10FC4631, "wall" },
    { 0x67F85E2A, "wall1" },
    { 0x41F5E3C1, "wall2" },
    { 0x1BF36958, "wall3" },
    { 0x2604C237, "wall4" },
    { 0xCA7296A3, "wall_anim" },
    { 0xAE8770C3, "wall_array" },
    { 0x9A554963, "wall_breach" },
    { 0xC9514222, "wall_breach_think" },
    { 0x210DCD44, "wall_breach_think2" },
    { 0xA457CE05, "wall_break_1" },
    { 0xCA5A486E, "wall_break_2" },
    { 0x7B6EF244, "wall_brush" },
    { 0x9521ADC4, "wall_climb_drone" },
    { 0x7C099AAE, "wall_clip" },
    { 0x06D0131C, "wall_crumble_timeout" },
    { 0xD01F37E2, "wall_crumble_vo" },
    { 0x8B633641, "wall_debris" },
    { 0x5557512A, "wall_dive" },
    { 0xA946A30D, "wall_explo_done" },
    { 0xB8C4E045, "wall_explode_damage" },
    { 0x26FEC410, "wall_fire" },
    { 0x108E644C, "wall_grapple_event" },
    { 0x309401AA, "wall_hole" },
    { 0x84FBB8C2, "wall_hole_poster" },
    { 0x71FE1AEF, "wall_hop_human" },
    { 0xE51BD8D9, "wall_hop_quad" },
    { 0xBA646662, "wall_hop_zombie" },
    { 0x6EEA16F7, "wall_left" },
    { 0x5F2FE6AA, "wall_light_spinner" },
    { 0xDDE2DF2B, "wall_lights" },
    { 0xACC75BBA, "wall_lights_think" },
    { 0xEA60FEEB, "wall_move" },
    { 0xBEABC61D, "wall_move_rumble" },
    { 0x4E6A096D, "wall_normal" },
    { 0x0AC709DD, "wall_over_40" },
    { 0x9DB8F3D2, "wall_pos" },
    { 0xCC383B32, "wall_right" },
    { 0x7776CE38, "wall_smash" },
    { 0x2384C6CB, "wall_smash_audio" },
    { 0x7738A382, "wall_smash_slide" },
    { 0x89DF6C5D, "wall_smash_start" },
    { 0x35F5B351, "wall_smash_trig" },
    { 0xC2B03CE5, "wall_weapon_update_prompt" },
    { 0x886F51DA, "walla" },
    { 0xA6C960E7, "walla1" },
    { 0x34C1F1AC, "walla2" },
    { 0x1686DACB, "walla_audio_notify" },
    { 0x6F374533, "walla_loop" },
    { 0x51E08647, "walla_origin" },
    { 0xE6B14EC9, "walla_sounds" },
    { 0x80842567, "walla_trigger" },
    { 0x115B6D56, "walla_vignettes" },
    { 0x7F45E351, "wallblow" },
    { 0x1CE4977B, "wallbuy" },
    { 0x57D23CE0, "wallbuy_action" },
    { 0x723D0AFA, "wallbuy_autofill_weapons" },
    { 0x8172C050, "wallbuy_autospawn" },
    { 0x4789831F, "wallbuy_callback" },
    { 0x606E6080, "wallbuy_callback_hack_override" },
    { 0xDBF7D143, "wallbuy_callback_idx" },
    { 0xA443B6B5, "wallbuy_condition" },
    { 0x390D4E1B, "wallbuy_get_piece_array" },
    { 0xF7E42F23, "wallbuy_get_stub_array" },
    { 0x08DC175E, "wallbuy_grab_pieces" },
    { 0xC9123339, "wallbuy_hack" },
    { 0x96CFFC8F, "wallbuy_interrupt" },
    { 0x96FADC27, "wallbuy_pieces" },
    { 0x1B439EFB, "wallbuy_pieces_taken" },
    { 0x471FDB56, "wallbuy_player_connect" },
    { 0x5D888F14, "wallbuy_should_upgrade_weapon_override" },
    { 0xFEF1CD15, "wallbuy_struct" },
    { 0x533CA6CD, "wallbuy_stubs" },
    { 0xDDDD7AC8, "wallbuy_targetname" },
    { 0xAC2C2CC7, "wallbuy_updated" },
    { 0xB0F38FD3, "wallbuy_weapons_purchased" },
    { 0x7BC7631A, "wallbuys" },
    { 0xC7DF9EE0, "wallbuys_purchased" },
    { 0x28680023, "wallcroft" },
    { 0x59DE15DC, "wallexplosionsmall_fx" },
    { 0x6F320940, "wallhit_time" },
    { 0xB2BEC078, "wallmodel" },
    { 0x0DDD9DE1, "wallnode" },
    { 0x41A68B3C, "wallnormal" },
    { 0x37509FAC, "wallrantwooppositewallsnoground" },
    { 0xF602B864, "wallrun" },
    { 0x34C6C426, "wallrun_begin" },
    { 0xFE772D2A, "wallrun_end" },
    { 0x4349AFDB, "wallrun_jump_height" },
    { 0x9DA308B3, "wallrun_jump_velocity" },
    { 0xD7E30232, "wallrun_jumpheight" },
    { 0x469461A2, "wallrun_jumpvelocity" },
    { 0xB5D37467, "wallrun_traversal" },
    { 0xEC8F8B3E, "wallrunning" },
    { 0xBD654297, "wallruns" },
    { 0x9C920398, "walls" },
    { 0x81EF8DFF, "walls_down" },
    { 0xABB28392, "wallshoot" },
    { 0x65F444F1, "wallshoot_exploders" },
    { 0xA109A8FB, "wallshoot_start" },
    { 0xF811E4A0, "walter" },
    { 0x693F5161, "waltz" },
    { 0x463B1FAD, "wan" },
    { 0xD65FB00E, "wana" },
    { 0x5716BD8E, "wander" },
    { 0xB49DEF40, "wander_to_goal" },
    { 0xBA8787E6, "wanderfwddot" },
    { 0x94904832, "wandering" },
    { 0xE8AEF864, "wandermax" },
    { 0xD39050CA, "wandermin" },
    { 0xDFB45E31, "wanders" },
    { 0xFE2843A5, "wanderspacing" },
    { 0x6FD67832, "wanna" },
    { 0x04309A43, "want" },
    { 0x352A84F0, "want_cqb_tracking" },
    { 0x3FB3D84A, "want_shoot_while_moving" },
    { 0xD0601154, "want_to_be_speaking" },
    { 0x04148738, "wanted" },
    { 0x14A31C33, "wanted_angles" },
    { 0x2E5BAD68, "wanted_seat" },
    { 0x66E24F9D, "wanting" },
    { 0xE24B92B2, "wants" },
    { 0x5FC3D745, "wants_to_fire" },
    { 0xBB4B0E31, "wantsafespawn" },
    { 0xF06C0ED3, "wantshotgun" },
    { 0xF7452901, "wantupwardsdeath" },
    { 0x3E6CAFE1, "war" },
    { 0x1394DC4E, "war_ai" },
    { 0xC87FEB95, "war_ai_claymore" },
    { 0xBC68CEBB, "war_ai_regular" },
    { 0x0A49554C, "war_anim_play" },
    { 0x7D17BAC7, "war_anim_play_abort" },
    { 0x6FB376A0, "war_anim_play_abortwatch" },
    { 0xBEE74045, "war_anim_play_cleanup" },
    { 0xC22B10EB, "war_anim_play_cleanupwatcher" },
    { 0xBA0907B8, "war_anim_player_cleanup" },
    { 0x3B09CB6F, "war_boss" },
    { 0x77A7E298, "war_boss_behavior" },
    { 0x2C690B63, "war_boss_chopper" },
    { 0x3535466A, "war_boss_juggernaut" },
    { 0xBDF06EBD, "war_capture_abort" },
    { 0x7054A976, "war_capture_abort_death" },
    { 0xEC146BF4, "war_capture_abort_switch" },
    { 0x7A7EB61E, "war_capture_death_abort" },
    { 0x3A3D4334, "war_capture_input_abort" },
    { 0x279E4636, "war_capture_item_engaged" },
    { 0x25CA3CB5, "war_capture_logic" },
    { 0x25AEB1A3, "war_capture_logicai" },
    { 0x87FAD94A, "war_capture_point_captured" },
    { 0xB3076C28, "war_capture_point_destroyed_watcher" },
    { 0x3CED13C8, "war_capture_points" },
    { 0x2F321E09, "war_capture_points_init" },
    { 0x81D4B84C, "war_capture_progress_watch" },
    { 0x9A6A6B4A, "war_capture_switch_abort" },
    { 0x0031E523, "war_capture_trigger_use" },
    { 0xE3FE9036, "war_capture_used" },
    { 0xB9894E4E, "war_capture_user_detach" },
    { 0x8D5D491F, "war_capture_watcher" },
    { 0xFAE53B0A, "war_captured" },
    { 0x5A8C66AC, "war_captured_item" },
    { 0x3C16BF33, "war_char_switch" },
    { 0x1D9EE643, "war_char_switch_complete" },
    { 0xF80D3EDB, "war_char_switch_fullstatic" },
    { 0xFC8714AC, "war_char_switch_returning" },
    { 0x9A4622B0, "war_classes" },
    { 0xB0D8925D, "war_countdown" },
    { 0x6B0FD931, "war_countdown_delete" },
    { 0x8C783A05, "war_countdown_text" },
    { 0xB21878B3, "war_countdown_timer" },
    { 0x44D4D0AD, "war_create_trigger_use" },
    { 0x75FB0CBA, "war_defend_points" },
    { 0x31A9C677, "war_defend_points_init" },
    { 0xD37D56A5, "war_defend_watcher" },
    { 0xC5BBB9A7, "war_delete_ent" },
    { 0x60C3CD9D, "war_destroyed" },
    { 0x516CA8EF, "war_disable_sprint" },
    { 0x8F48D006, "war_dog_spawning" },
    { 0x415BB458, "war_dominate_get_best_dompoint" },
    { 0xAD855F7B, "war_dominate_points" },
    { 0xE76011A8, "war_dominate_points_init" },
    { 0xD2F55B02, "war_dominate_spawnloc_cull" },
    { 0x2B9E276A, "war_dominate_watcher" },
    { 0x35AEF11C, "war_door" },
    { 0xC38017D0, "war_enable_sprint" },
    { 0x4BB6A52D, "war_escape_points" },
    { 0x6EB56166, "war_escape_points_init" },
    { 0x0ABB17BC, "war_escape_trigger_watch" },
    { 0x53D31438, "war_escape_watcher" },
    { 0x9ABEBAA7, "war_game_items" },
    { 0x214CC2EE, "war_game_sequence" },
    { 0x7C2ECB39, "war_game_type" },
    { 0x581F6B4E, "war_gamedefs" },
    { 0x484F8AC6, "war_gameitems" },
    { 0x91F595A3, "war_gamemode_assassinate" },
    { 0xF1976FAC, "war_gamemode_capture" },
    { 0x48BB8EC6, "war_gamemode_defend" },
    { 0xF6E3B53D, "war_gamemode_dominate" },
    { 0xE12D42CB, "war_gamemode_escape" },
    { 0x32AD3177, "war_gamemode_protect" },
    { 0x523C2581, "war_gamemode_race" },
    { 0x2218FC4F, "war_gamemode_stealth" },
    { 0xC81CC58C, "war_gametype_generic_player_insert" },
    { 0x31DA7D06, "war_gametypes_init" },
    { 0xFE8BD2AB, "war_get_besthideout" },
    { 0x0C3FEE2B, "war_get_game_items_byparam" },
    { 0xFA029C7D, "war_get_names" },
    { 0xC8A7F681, "war_globals_init" },
    { 0x5E7A3078, "war_hide_game_items" },
    { 0xBA026990, "war_hideout" },
    { 0xC5A3A807, "war_hideout_points_init" },
    { 0xC6A99670, "war_hideoutfleewatcher" },
    { 0xDB36D477, "war_hud" },
    { 0xE3E1BA9A, "war_init" },
    { 0x8260CF03, "war_init_names" },
    { 0x4E99F7F5, "war_initgameitemsfor" },
    { 0xA64B6216, "war_logic" },
    { 0xB92C4552, "war_map_blink_country" },
    { 0x31CDA672, "war_monitor_stealth" },
    { 0xB62C43F4, "war_names" },
    { 0xC428957A, "war_no_spawnzones" },
    { 0x7DC922ED, "war_notifymybossondeath" },
    { 0x89DF5D13, "war_player_ready" },
    { 0xF609AAD6, "war_players_ready" },
    { 0x7148B562, "war_populate_game_items" },
    { 0x7C717B27, "war_population_domination_monitor" },
    { 0xCBA6C102, "war_population_domination_monitor_cleanup" },
    { 0x0DB82D27, "war_population_maintain_minimum_enemy" },
    { 0x8FF29BA5, "war_population_maintain_minimum_enemy_for_a_time" },
    { 0xB304D149, "war_population_manager" },
    { 0x5348E6B3, "war_population_turn_off_minimum_enemy" },
    { 0x1B4EA812, "war_postload" },
    { 0x96CF903B, "war_preload" },
    { 0x2B9C880B, "war_priority_distsq" },
    { 0x00C7C08F, "war_priority_targets" },
    { 0xA96F5A05, "war_progress" },
    { 0x2DB3FC5D, "war_progress_text" },
    { 0x526F23FA, "war_protect_damage_watcher" },
    { 0xEA1CD08E, "war_protect_death_broadcast" },
    { 0xCCCBA060, "war_protect_deathsquad" },
    { 0xE672B961, "war_protect_points" },
    { 0xBF9D771A, "war_protect_points_init" },
    { 0x28D4F4CD, "war_protect_progress" },
    { 0x7228D694, "war_protect_watcher" },
    { 0x1039E96A, "war_protection_object_died" },
    { 0x40E58A63, "war_race_gettargetbyname" },
    { 0x815D486C, "war_race_points_init" },
    { 0x41519B2A, "war_race_trigger_watch" },
    { 0xE8058C16, "war_race_watcher" },
    { 0xEB4AE067, "war_recruitfollowers" },
    { 0x674840F7, "war_repeat_wave" },
    { 0x6BA744D5, "war_room" },
    { 0x711E731F, "war_room_clear" },
    { 0x5ACB1CCC, "war_room_explosions" },
    { 0xAEECCD0A, "war_room_explosions_vo" },
    { 0xCE093CBB, "war_room_inspection_begins" },
    { 0x314E4723, "war_room_lock_player_in" },
    { 0x1CCB3F69, "war_room_portal_door" },
    { 0xDEB64538, "war_room_screen_north" },
    { 0xF4DC059F, "war_room_screen_ramp" },
    { 0xD894690A, "war_room_screen_south" },
    { 0x29556C15, "war_room_sound" },
    { 0xFCDE5A7C, "war_room_util" },
    { 0xB79600F4, "war_sam_sites" },
    { 0x4EAF876A, "war_scenario" },
    { 0x87A639DC, "war_set_objective" },
    { 0x9F283B79, "war_set_scenario" },
    { 0xBD20053C, "war_set_wave_to" },
    { 0x7842BC71, "war_show_game_items" },
    { 0xD88D9589, "war_spawn_chopper_squads" },
    { 0x2F70146F, "war_spawn_helicopter" },
    { 0x745BF4A8, "war_squelch_new_prog_bars" },
    { 0xE78051AC, "war_stealth_engage_enemies" },
    { 0xA103BC06, "war_stealth_patrol" },
    { 0x8663051C, "war_stealth_start_pacifist" },
    { 0x14387897, "war_target_manager" },
    { 0xB7AE4730, "war_target_shielder" },
    { 0x727DE5EB, "war_target_timeout" },
    { 0xD3A28C14, "war_trigger_use" },
    { 0x5A6A14E3, "war_vox" },
    { 0x7A60A014, "war_watch_player_life" },
    { 0x8463175F, "war_wave" },
    { 0x4103F9E9, "war_wave_catch_player_ready" },
    { 0x47BBBD97, "war_wave_catch_player_ready_clean" },
    { 0x444C1A3F, "war_wave_catch_player_ready_update" },
    { 0x5D7B3E36, "war_wave_maker" },
    { 0x659258A5, "war_wave_pickup_downed_players" },
    { 0x8E15D2E6, "war_waves" },
    { 0x3F7F0F93, "war_waves_repeated" },
    { 0x5DC4C568, "war_waves_setup" },
    { 0x3B9A2F98, "war_zodiac_player_insert" },
    { 0xE7327E78, "warclasstypeidx" },
    { 0x4DBA4FA8, "warclasstypeidxoverride" },
    { 0x7E7215F7, "ward" },
    { 0x2768F93D, "warden_fence_hotjoin_handler" },
    { 0x23D81CF8, "warden_fence_up" },
    { 0x1E0D6602, "warehosue" },
    { 0x1337838E, "warehouse" },
    { 0xABDC89E7, "warehouse01" },
    { 0xBD7A5B52, "warehouse01_start" },
    { 0x00F16C89, "warehouse_ambush_wait_for_doors" },
    { 0xEF3FD1BB, "warehouse_apache" },
    { 0x95E8A240, "warehouse_apache_death" },
    { 0x5A0FA080, "warehouse_apache_logic" },
    { 0x299D2168, "warehouse_apache_shoot_logic" },
    { 0x39C79AD2, "warehouse_approach_catwalk_trigger" },
    { 0xD3559348, "warehouse_approach_chopper2_trigger" },
    { 0xBDBD6561, "warehouse_approach_chopper3_trigger" },
    { 0xD457F352, "warehouse_approach_chopper4_trigger" },
    { 0xF59F9DA8, "warehouse_approach_chopper_trigger" },
    { 0xAB1CD196, "warehouse_area" },
    { 0xE0D26846, "warehouse_bike" },
    { 0xD440856A, "warehouse_bridge" },
    { 0xCE2B913F, "warehouse_bridge_clip" },
    { 0x063F25BB, "warehouse_bridge_coils" },
    { 0xA32EC1EB, "warehouse_cleanup" },
    { 0x67D23923, "warehouse_cleared" },
    { 0xC6B1E3F9, "warehouse_death" },
    { 0xCE8E941F, "warehouse_door_flag_set" },
    { 0x4CD4A6CE, "warehouse_drone_logic" },
    { 0x8BB46F0B, "warehouse_effects_triggers" },
    { 0xE5C5E0AF, "warehouse_electric_switch" },
    { 0xB8C0289C, "warehouse_enter_left_path_soct_trigger" },
    { 0xED06BF7D, "warehouse_enter_right_path_soct_trigger" },
    { 0x59072D7E, "warehouse_escape_vo" },
    { 0x6B6B89CD, "warehouse_fight" },
    { 0x36B3C6E2, "warehouse_front" },
    { 0x42891A1E, "warehouse_grigsby" },
    { 0xF5128F11, "warehouse_guys" },
    { 0x7980510E, "warehouse_guys_func" },
    { 0x4DBB76EA, "warehouse_head_to_protect_volume" },
    { 0x3F451671, "warehouse_hudson_line_470" },
    { 0x8B4A0B43, "warehouse_hudson_line_472" },
    { 0xB14C85AC, "warehouse_hudson_line_475" },
    { 0xE92EC8C0, "warehouse_hudson_line_479" },
    { 0xB6801E3B, "warehouse_init" },
    { 0xA749DFB8, "warehouse_kill_all_enemy" },
    { 0x8F8E6D0F, "warehouse_line_support" },
    { 0x03A3EF2A, "warehouse_main" },
    { 0xC584E73E, "warehouse_mg_dead" },
    { 0xAA988012, "warehouse_office_line" },
    { 0x9F3CB2B0, "warehouse_office_line_rushed" },
    { 0xA8D5D117, "warehouse_office_line_think" },
    { 0xBC9C0CA7, "warehouse_open_doors" },
    { 0x1BA94F1A, "warehouse_player" },
    { 0x603AB24D, "warehouse_player_reached_truck" },
    { 0x2FBB00E8, "warehouse_price" },
    { 0x38A4C57F, "warehouse_rear" },
    { 0x5D40AF2C, "warehouse_rear_line" },
    { 0xDCE43582, "warehouse_rear_line_rushed" },
    { 0x049BA15D, "warehouse_rear_line_think" },
    { 0xEFA2598A, "warehouse_retreating_enemies_think" },
    { 0x4587ED44, "warehouse_salazar_logic" },
    { 0xCD54C08F, "warehouse_seal_back_door" },
    { 0xA02A8007, "warehouse_spawn_func" },
    { 0x3C10D590, "warehouse_squad_fights_out" },
    { 0x2A0CA9D9, "warehouse_steiner" },
    { 0x0809CF47, "warehouse_steiner_line_471" },
    { 0xBC04DA75, "warehouse_steiner_line_473" },
    { 0x49FD6B3A, "warehouse_steiner_line_474" },
    { 0x23FAF0D1, "warehouse_steiner_line_477" },
    { 0x26E73A27, "warehouse_steiner_line_480" },
    { 0xDAE24555, "warehouse_steiner_line_482" },
    { 0xB97A7397, "warehouse_steiner_office_brooks" },
    { 0x39BCCA24, "warehouse_steiner_office_door_init" },
    { 0xCA45FEFF, "warehouse_steiner_office_double_door" },
    { 0x9462C366, "warehouse_steiner_office_single_door" },
    { 0x3B1610DB, "warehouse_steiner_office_weaver" },
    { 0x916E4BD3, "warehouse_steiner_story" },
    { 0x347361C3, "warehouse_steiner_story_vo" },
    { 0x5A372ED5, "warehouse_super_soct_logic" },
    { 0x6937AEB8, "warehouse_time_over_death" },
    { 0x5F970E07, "warehouse_timer_done" },
    { 0x07F72B5D, "warehouse_timer_init" },
    { 0x05F7AD2F, "warehouse_trigger_kill_allied_teammate" },
    { 0x0EBAFDDF, "warehouse_trigger_kill_enemies" },
    { 0x4B15A4C0, "warehouse_truck_mggunner" },
    { 0x4D5EBA0A, "warehouse_truck_turret_think" },
    { 0x49B611A0, "warehouse_unload_enemy_mind" },
    { 0xE93B5F3C, "warehouse_unload_trucks_init" },
    { 0xD9F6322B, "warehouse_veh_unload_trucks" },
    { 0x0E3D6662, "warehouse_vehicle_switch" },
    { 0x9326A4A4, "warehouse_vo" },
    { 0x2B3FAEBF, "wargamedatahudelem" },
    { 0x7B5C6CA2, "warheads" },
    { 0x3DD60D37, "warhudcolumnoffset" },
    { 0xD09068C8, "warhudelems" },
    { 0x2CBC0AF0, "warlord" },
    { 0xB83E89E8, "warlord_angry_accumilated_damage_max_dur" },
    { 0x9D1F8ABE, "warlord_angry_max_accumilated_damage" },
    { 0xB40279BB, "warlord_body_light_fx" },
    { 0xBA4A1C7C, "warlord_body_light_fx_file" },
    { 0x2994F02F, "warlord_body_light_tag" },
    { 0xA00F521B, "warlord_charge_distance" },
    { 0x20D5D4A3, "warlord_damage_actors_reduction_multiplier" },
    { 0xF0CA4790, "warlord_damage_explosive_reduction_multiplier" },
    { 0x39ECCB4F, "warlord_damage_heavy_state_fx" },
    { 0x7802AB28, "warlord_damage_heavy_state_fx_file" },
    { 0xE8B83731, "warlord_damage_heavy_state_lower_fx" },
    { 0x91745C3E, "warlord_damage_heavy_state_lower_fx_file" },
    { 0x95FFA7C0, "warlord_damage_state_clientfield" },
    { 0xC834914E, "warlord_damage_state_damage" },
    { 0xA427BE97, "warlord_damage_state_dead" },
    { 0xDFB5C537, "warlord_damage_state_fx" },
    { 0x2FAE6A50, "warlord_damage_state_fx_file" },
    { 0x0686BD7E, "warlord_damage_state_heavy_damage" },
    { 0xB94B6AE9, "warlord_damage_state_lower_fx" },
    { 0x8F999B76, "warlord_damage_state_lower_fx_file" },
    { 0x5289A289, "warlord_damage_state_lower_tag" },
    { 0x55100E49, "warlord_damage_state_percentage" },
    { 0x2DEEF14B, "warlord_damage_state_tag" },
    { 0xB4686D51, "warlord_damage_state_undamaged" },
    { 0xFA195E20, "warlord_death_fx" },
    { 0xEF2B9E51, "warlord_death_fx_file" },
    { 0x24E9344A, "warlord_death_tag" },
    { 0x436E6516, "warlord_diameter" },
    { 0x188535B3, "warlord_eye_fx" },
    { 0x58EB8C51, "warlord_head_light_fx" },
    { 0xA0575A9E, "warlord_head_light_fx_file" },
    { 0xE82C8C51, "warlord_head_light_tag" },
    { 0x69FA0781, "warlord_heavy_damage_state_percentage" },
    { 0x63AE015E, "warlord_height" },
    { 0x00FEAC1B, "warlord_hunt_duration" },
    { 0x0E0DDE2C, "warlord_hunt_max_accumilated_damage" },
    { 0xC16FEEFC, "warlord_hunt_max_radius" },
    { 0xDC52BD2E, "warlord_hunt_min_radius" },
    { 0x13AFC822, "warlord_juke_distance" },
    { 0x9EAD052D, "warlord_juke_too_close_dist" },
    { 0xE5B32BE4, "warlord_leap_distances" },
    { 0x6F9B3F94, "warlord_leap_names" },
    { 0xAC22823D, "warlord_leap_threshold" },
    { 0xFC636EA2, "warlord_lights_clientfield" },
    { 0x5E1EB105, "warlord_melee_blast_damage_max" },
    { 0x4900096B, "warlord_melee_blast_damage_min" },
    { 0xA9DA8BCB, "warlord_melee_blast_radius" },
    { 0x81C2F832, "warlord_melee_range_sq" },
    { 0x2468CF75, "warlord_navmesh_threshold" },
    { 0x16DD9C81, "warlord_navmesh_tolerance" },
    { 0xAE68208B, "warlord_near_juke_distance" },
    { 0x61F3D682, "warlord_next_angryattack_time" },
    { 0x34C0B599, "warlord_next_charge_time" },
    { 0xE66884E0, "warlord_next_juke_time" },
    { 0x00DB124A, "warlord_pain_cooldown_max" },
    { 0x83C65454, "warlord_pain_cooldown_min" },
    { 0xAFB9D85B, "warlord_projectile_watcher" },
    { 0x137D24A1, "warlord_radius" },
    { 0xA6410136, "warlord_recharge_health_max" },
    { 0xD5A4E8B8, "warlord_recharge_health_per_second" },
    { 0x7AD09402, "warlord_recharge_initial_health" },
    { 0xF25F4164, "warlord_repulse_fx" },
    { 0x1E1FC848, "warlord_repulse_ground_fx" },
    { 0xA18B7A76, "warlord_repulsor_radius" },
    { 0xCE9B8627, "warlord_seen_enemy_tolerence" },
    { 0x3AC2D890, "warlord_shield_critical_health_percentage" },
    { 0x5542D17A, "warlord_shield_health_max" },
    { 0xF6C936C2, "warlord_shield_medium_health_percentage" },
    { 0xFA1E4BFE, "warlord_sound_recharge_end" },
    { 0x0060FA51, "warlord_sound_recharge_loop" },
    { 0xDE81C46D, "warlord_sound_recharge_start" },
    { 0x9F028539, "warlord_tactical_juke_radius" },
    { 0xF96946E6, "warlord_thruster_back" },
    { 0xD585D88E, "warlord_thruster_back_tags" },
    { 0xCBFF9B9E, "warlord_thruster_clientfield" },
    { 0xAB081A68, "warlord_thruster_front" },
    { 0x1EADC540, "warlord_thruster_front_tags" },
    { 0x5C67E229, "warlord_thruster_fx" },
    { 0x237E6AB6, "warlord_thruster_fx_file" },
    { 0x08110F30, "warlord_thruster_left" },
    { 0x3EE60908, "warlord_thruster_left_tags" },
    { 0x62F4211E, "warlord_thruster_off" },
    { 0xE69533DF, "warlord_thruster_right" },
    { 0xF8CD8405, "warlord_thruster_right_tags" },
    { 0x94D93D1D, "warlord_type_clientfield" },
    { 0x00DAE259, "warlord_type_default" },
    { 0x3BA9A1E8, "warlord_type_hvt" },
    { 0x7112B6B1, "warlord_type_name_default" },
    { 0x64F772A0, "warlord_type_name_hvt" },
    { 0x27188A10, "warlord_type_uknown" },
    { 0x9DE5522F, "warlordangryattack" },
    { 0xC698CE8A, "warlordangryattack_shootthemall" },
    { 0xC7AB8FCE, "warlordbehavior" },
    { 0x96271879, "warlordcanjuke" },
    { 0x34D050EA, "warlordcantacticaljuke" },
    { 0xE95B29C8, "warlordclientutils" },
    { 0xFE54FDC3, "warlorddamageoverride" },
    { 0x695D7DEE, "warlorddamagestatehandler" },
    { 0xC55CEAC8, "warlorddangerousenemyattack" },
    { 0x69EE7109, "warlordinterface" },
    { 0x05620F99, "warlordlightshandler" },
    { 0xB4645FEC, "warlordserverutils" },
    { 0xC532C1B0, "warlordshouldnormalmelee" },
    { 0xB65F3CC0, "warlordspawnsetup" },
    { 0xA4D15A01, "warlordthrusterhandler" },
    { 0x6765FB9C, "warlordtypehandler" },
    { 0x285BC846, "warm" },
    { 0x626821E5, "warmap_offset" },
    { 0xD0BB47CF, "warmer" },
    { 0xC7B38AF9, "warms" },
    { 0x3233A04D, "warmup" },
    { 0xA5D3B207, "warmup_array" },
    { 0x2A1C5EEA, "warmuptime" },
    { 0x02594DDD, "warn" },
    { 0x3E1ADF7E, "warn_to_kill_player" },
    { 0x65194DF7, "warn_triggers" },
    { 0x8102558A, "warned" },
    { 0x51BB9CA1, "warnedlastplayer" },
    { 0xF64F72CB, "warning" },
    { 0x223BC08B, "warning_count" },
    { 0x616386C6, "warning_dialog" },
    { 0x9509E5B2, "warning_dist" },
    { 0x97DA089F, "warning_guy" },
    { 0x6274665D, "warning_hud" },
    { 0x584A5CF0, "warning_hud_created" },
    { 0x5C234D8F, "warning_message_timeout" },
    { 0xEA342AD8, "warning_on_screen" },
    { 0xA7255AE8, "warning_pos" },
    { 0x8A127801, "warning_shots" },
    { 0xB52E71AE, "warning_tag" },
    { 0xD8675939, "warning_time_delay" },
    { 0x1E0F060F, "warning_trigger_radius" },
    { 0xB119E48D, "warningl" },
    { 0x64E9AC29, "warninglight" },
    { 0xD281EE16, "warninglightcount" },
    { 0xF5506993, "warningr" },
    { 0xCF4DEF2A, "warnings" },
    { 0x3345C7FC, "warnings_started_time" },
    { 0x047E1523, "warningscore" },
    { 0xF0BA5EEA, "warningshots" },
    { 0xCF7AA3C0, "warningsounddist" },
    { 0xAB9CC48A, "warnlastplayer" },
    { 0x35810153, "warnleavingbattlefield" },
    { 0xEE2F2859, "warnmissilefired" },
    { 0xE0EA5B2D, "warnmissilelocked" },
    { 0xC0576AD6, "warnmissilelocking" },
    { 0x80A7F288, "warnmsg" },
    { 0xBD667D1C, "warns" },
    { 0x864085C3, "warp" },
    { 0xEE8F52D9, "warp_a_player" },
    { 0x74F1ACD3, "warp_ai_to_plane" },
    { 0x62AB31B7, "warp_bg" },
    { 0xBAB36412, "warp_buffel" },
    { 0xF1594830, "warp_buffel_array" },
    { 0x2400778C, "warp_car" },
    { 0x94A122AA, "warp_commissar_to_intro_spot" },
    { 0x5AEC1154, "warp_convoy" },
    { 0xEC2DA4CB, "warp_friendlies" },
    { 0x0D6CC2BE, "warp_me_in_slums_logic" },
    { 0xACF6AFB9, "warp_player" },
    { 0x49A6538B, "warp_player_end" },
    { 0x55BFDAA8, "warp_player_start" },
    { 0xFFFCDFD6, "warp_player_to_courtyard_fountain" },
    { 0xF8E3E87A, "warp_player_to_maze_fountain" },
    { 0x3064BEF0, "warp_players" },
    { 0xF89E8F77, "warp_players_after_library" },
    { 0x7FF01869, "warp_players_underworld" },
    { 0xCDBCCB14, "warp_point" },
    { 0x6A258600, "warp_pos" },
    { 0x0D8ECB4A, "warp_pt" },
    { 0x95B135B4, "warp_reznov_rooftop" },
    { 0x3ABEA883, "warp_spot_is_safe" },
    { 0x0962BB76, "warp_start" },
    { 0x09C4935D, "warp_struct" },
    { 0xC58562AC, "warp_tank_array" },
    { 0xB0C37AF0, "warp_targetname" },
    { 0x984B95F3, "warp_text" },
    { 0x1058A8DA, "warp_to_player_start" },
    { 0x10DC5C62, "warp_to_random_player_start" },
    { 0x4B18504B, "warp_to_struct" },
    { 0xAC24C9C7, "warp_to_struct_position" },
    { 0xA731B1D8, "warp_woods_if_player_sprints" },
    { 0xF865F170, "warpage" },
    { 0x277100A1, "warpalltohost" },
    { 0x95792570, "warpblack" },
    { 0xC9D71EB8, "warped" },
    { 0xE5B15FA7, "warpig" },
    { 0x3836CE1D, "warping" },
    { 0x994337DA, "warpnodes" },
    { 0x3297CE31, "warpout" },
    { 0x703E849C, "warpplayerthreat" },
    { 0x6E05629F, "warppt" },
    { 0x215B4D32, "warps" },
    { 0xC376096C, "warpspot_primary" },
    { 0x9A2ED814, "warpspot_secondary" },
    { 0x5DBA0F3A, "warpspots" },
    { 0xF65B8C10, "warpto" },
    { 0x93CE3700, "warpto_blackroom_spot" },
    { 0xDEE78032, "warpto_clearing" },
    { 0x62124BFC, "warpto_compound" },
    { 0xAB3D469E, "warpto_hind_vs_hind" },
    { 0x78E3CD4C, "warpto_landing" },
    { 0xD58D7629, "warpto_positions" },
    { 0x92BED766, "warpto_spots" },
    { 0x3FC995F1, "warpto_start_in_chopper" },
    { 0x8E868722, "warpto_susans_jumpto" },
    { 0xCB9BACEC, "warpto_tunnels" },
    { 0x4EBB0B24, "warrant" },
    { 0xAA398A3D, "warranty" },
    { 0x0E91F757, "warring" },
    { 0x7A736614, "warroom" },
    { 0xDF5DB696, "warroom_difficulty_adjustment" },
    { 0xBF53DCF8, "warroom_door_kick" },
    { 0xC036421D, "warroom_door_kick_start" },
    { 0x5ABAF1D0, "warroom_flags" },
    { 0x9C336BFB, "warroom_rocks" },
    { 0x3D556C81, "warroom_start" },
    { 0x1B605167, "warroom_wires" },
    { 0x14391688, "wars" },
    { 0x93CA51A2, "warscenarios" },
    { 0x937FBC05, "warthog_time" },
    { 0xBF796645, "warthoghackertoolradius" },
    { 0xE02C3D54, "warthoghackertooltimems" },
    { 0x130DB203, "warzone" },
    { 0x186A3578, "was" },
    { 0xE7383480, "was_aborted" },
    { 0x7049B6E2, "was_alive" },
    { 0xE224E76B, "was_already_at_max_stacking" },
    { 0xE32C32F1, "was_behind_player" },
    { 0xAF32C6C9, "was_close" },
    { 0xF4BE3F81, "was_dialog_said" },
    { 0xC7A7D249, "was_headshot" },
    { 0x033BF819, "was_idle" },
    { 0x285D0288, "was_in_our_trigger" },
    { 0x8A32E9D8, "was_inv" },
    { 0xCB4432CB, "was_looking_at_me" },
    { 0x6C3229B5, "was_moving" },
    { 0x9F36107D, "was_not_in_default_type" },
    { 0x93EB1403, "was_on_fire" },
    { 0x5C718EA4, "was_revived" },
    { 0x11939BF5, "was_temp" },
    { 0x53838684, "was_traversing" },
    { 0x373E05B8, "was_turret_kill" },
    { 0x1FB75498, "was_walking" },
    { 0xB58EDAC6, "wasactive" },
    { 0xBC077625, "wasaliveatmatchstart" },
    { 0x855CCC11, "wasallowingpain" },
    { 0xFC907CDC, "wasatcovernode" },
    { 0x7828ACD8, "waschained" },
    { 0x1B2BB768, "waschangingcoverpos" },
    { 0x589DC35D, "wascomplete" },
    { 0xA0E3749B, "wascontested" },
    { 0x94BC1B48, "wascontrollednowdead" },
    { 0x38C4A787, "wascooked" },
    { 0xDB6139D0, "wascrushedbyinterdimensionalgunblackholecondition" },
    { 0x7C79C635, "wasdamaged" },
    { 0xB7ECB22B, "wasdamagedbychargedsnipershot" },
    { 0x1F7CB1D2, "wasdamagedbyempgrenade" },
    { 0xD62E64B3, "wasdamagedbyexplosive" },
    { 0xE7493D97, "wasdamagedbyfullychargedsnipershot" },
    { 0x45D36373, "wasdamagedbygodrod" },
    { 0x962A7AB1, "wasdamagedbyplayergrenade" },
    { 0x3302700B, "wasdamagedbysnipershot" },
    { 0xF8D26A4C, "wasdamagedfrombulletpenetration" },
    { 0xE19536C3, "wasdefusing" },
    { 0xB240BAE1, "wasdemojump" },
    { 0x87CDB53F, "wasdowned" },
    { 0xD396C03B, "wasenabled" },
    { 0x01F6CDFF, "wasflashbangimmune" },
    { 0x34A4EC9C, "wasfullycharged" },
    { 0x099B0802, "wasgrenade" },
    { 0x776DA5C0, "wash" },
    { 0xA0356588, "washacked" },
    { 0x475BBA87, "washington" },
    { 0xCBB2163D, "washsound" },
    { 0x7A880023, "washuman" },
    { 0xC4EDE9EA, "wasincover" },
    { 0x93B580B3, "wasinlaststand" },
    { 0x93AD7553, "wasinprematch" },
    { 0x0AF2795E, "wasinthemoney" },
    { 0xF0838C12, "wasinwater" },
    { 0x566AD116, "wasjustplanted" },
    { 0xFCA485CC, "waskilledbyinterdimensionalguncondition" },
    { 0xC0758118, "waskilledbyteslacondition" },
    { 0xB8CD89F0, "waslastround" },
    { 0x76BB663D, "waslastzmround" },
    { 0x94E5522A, "wasleftunoccupied" },
    { 0x8ED737EC, "waslockingon" },
    { 0x3335B136, "wasnt" },
    { 0x70B90B86, "wasonground" },
    { 0x07A91F98, "wasp" },
    { 0xAF544B64, "wasp_1" },
    { 0x79AE8BD8, "wasp_1_fire_on_guys" },
    { 0x990F7117, "wasp_1_saved_day" },
    { 0x31977D79, "wasp_1_square_strat" },
    { 0xAD84A834, "wasp_1_yard_strat" },
    { 0x215BBA9F, "wasp_2" },
    { 0x7898DBC0, "wasp_2_death_notify" },
    { 0x9D69EE49, "wasp_2_fire_on_guys" },
    { 0xA93880EC, "wasp_2_square_strat" },
    { 0xCE1EA589, "wasp_2_yard_strat" },
    { 0xC93C5341, "wasp_add_to_spawn_pool" },
    { 0xE0DE0394, "wasp_behind_audio" },
    { 0xA5CEEC2F, "wasp_cleanup_failsafe" },
    { 0xE1FBC263, "wasp_combat" },
    { 0x63D90051, "wasp_counterattack" },
    { 0x1B18C607, "wasp_death" },
    { 0x60687790, "wasp_driving" },
    { 0x3EA86E6A, "wasp_enabled" },
    { 0xC55E1CF2, "wasp_enemy_too_close_dist" },
    { 0xE97B4687, "wasp_find_closest_in_global_pool" },
    { 0x06775F04, "wasp_fire_at_sdk" },
    { 0x779C5A05, "wasp_group_radius" },
    { 0xCEADC118, "wasp_group_size" },
    { 0x05DEC52D, "wasp_guard_acquire_enemy_dist" },
    { 0x4CB81466, "wasp_guard_keep_enemy_dist" },
    { 0x43E89D42, "wasp_guard_lose_enemy_dist" },
    { 0xCF0A39CD, "wasp_health" },
    { 0x343220D8, "wasp_health_increase" },
    { 0xFD30DCEC, "wasp_hover_radius" },
    { 0x90604BB9, "wasp_init" },
    { 0x32100861, "wasp_initialize" },
    { 0x53C1778E, "wasp_locs" },
    { 0x2BE24711, "wasp_manage_camera_swaps" },
    { 0x75F5D7B3, "wasp_melee_range" },
    { 0x235D6680, "wasp_move_dist_max" },
    { 0xD085F7BE, "wasp_move_dist_min" },
    { 0xEF38D4DC, "wasp_move_target" },
    { 0x37EF4513, "wasp_neargoal_dist" },
    { 0x55617C11, "wasp_round" },
    { 0xED222974, "wasp_round_aftermath" },
    { 0x0479B039, "wasp_round_count" },
    { 0xC6D41ADD, "wasp_round_ending" },
    { 0xAD29AF1F, "wasp_round_spawning" },
    { 0x3084F670, "wasp_round_start" },
    { 0x1CF867E8, "wasp_round_starting" },
    { 0xB483BFBC, "wasp_round_stop" },
    { 0x4F69DF64, "wasp_round_track_override" },
    { 0x5B578250, "wasp_round_tracker" },
    { 0xCAB4D930, "wasp_round_wait_func" },
    { 0xC5E6B80A, "wasp_rounds_enabled" },
    { 0x77BE2D1B, "wasp_run_think" },
    { 0xBF7A82D4, "wasp_running" },
    { 0xD040AA83, "wasp_saves" },
    { 0xF8B77BCC, "wasp_saves_the_day_1" },
    { 0x6ABEEB07, "wasp_saves_the_day_2" },
    { 0x603CABB6, "wasp_shoot_at_ent" },
    { 0x493E3E98, "wasp_spawn" },
    { 0xE4440264, "wasp_spawn_1" },
    { 0x564B719F, "wasp_spawn_2" },
    { 0x7835361C, "wasp_spawn_dist_max" },
    { 0xF549F412, "wasp_spawn_dist_min" },
    { 0x52F3C7B5, "wasp_spawn_func" },
    { 0x198FE8B9, "wasp_spawn_init" },
    { 0xE76B0F73, "wasp_spawn_logic" },
    { 0xB6720C26, "wasp_spawner_init" },
    { 0xC03323EC, "wasp_spawners" },
    { 0xA830D157, "wasp_stalk_audio" },
    { 0x11B54123, "wasp_targets" },
    { 0x59CB9292, "wasp_thundergun_knockdown" },
    { 0x9A98441C, "wasp_time" },
    { 0x7CBE31F2, "wasp_train_kill" },
    { 0xC95CAAF1, "wasp_trig" },
    { 0x826AA632, "wasp_trigger_moves" },
    { 0x4E8F80FF, "wasp_wall_break" },
    { 0xC5C1C831, "waspangle" },
    { 0x28A344CB, "waspdamage" },
    { 0x929C1999, "wasplanting" },
    { 0x409D58FB, "wasplayersliding" },
    { 0x26252328, "waspowered" },
    { 0x668B2234, "waspreviouslyincover" },
    { 0x62832933, "waspround_nomusic" },
    { 0xF8CCD22E, "wasproximityalarmactivatedbyself" },
    { 0xBA59B973, "wasps" },
    { 0x0175C7B6, "wasreached" },
    { 0xCA6A4FEC, "wassuicide" },
    { 0x7080CD19, "waste" },
    { 0x09D69F9F, "wasteamkill" },
    { 0x12DACE0C, "wasting" },
    { 0x46C31DBB, "wastouching" },
    { 0xE03BCA6F, "wastriggered" },
    { 0xF159B73B, "wasunderwater" },
    { 0xD5C57647, "wasveryhurt" },
    { 0x4F08B23E, "wasvisible" },
    { 0xE8305315, "waswarped" },
    { 0xCD1833D0, "waswinning" },
    { 0x388AD3F2, "watch" },
    { 0x0B3B4BA2, "watch_actor_bookmarks" },
    { 0x7570E25D, "watch_and_wait_scene" },
    { 0xF0C687A0, "watch_asd_death" },
    { 0x39C8AF4B, "watch_asd_deaths" },
    { 0xA7E6B180, "watch_asd_tutorial_2_death" },
    { 0x03F61C2B, "watch_asd_tutorial_death" },
    { 0xFE68C89A, "watch_assault_shield_damage" },
    { 0x56C2B39B, "watch_bad_trigger_touch" },
    { 0xDADB167B, "watch_bar_couch" },
    { 0x72AA4646, "watch_barricade" },
    { 0x844FD25B, "watch_base_attacked_flag" },
    { 0xABB6FD9B, "watch_bigdog_objective_noharper" },
    { 0xA4832CBC, "watch_blockade_destroyed_time" },
    { 0xC3DF6D2D, "watch_boat_boarding_done" },
    { 0xA607F9D0, "watch_boat_death" },
    { 0xA50B6C89, "watch_boat_hmg_death" },
    { 0x60C3053E, "watch_bodily_functions" },
    { 0xC0DABB0C, "watch_bolt_detonation" },
    { 0x7FF6D5F0, "watch_bot_corner" },
    { 0x2F38B7BF, "watch_botsdvars" },
    { 0x1D3E7EFA, "watch_brake" },
    { 0x43066B8E, "watch_bridge_halves" },
    { 0x94088EF8, "watch_burn_clear" },
    { 0x19567E6B, "watch_camera_head_damage" },
    { 0x0154E876, "watch_capture_menendez" },
    { 0xF040F041, "watch_cell_open_close" },
    { 0x761DCF3C, "watch_chamber_wall" },
    { 0x79786B80, "watch_claymores" },
    { 0x81C8B568, "watch_combat_axe" },
    { 0x3E9BCD60, "watch_combat_trigger" },
    { 0x25E75329, "watch_concussion" },
    { 0xB9C76AD1, "watch_crash_pos" },
    { 0x8120E77F, "watch_crash_trigger" },
    { 0x429AF6DE, "watch_crate" },
    { 0x5B9705B8, "watch_current_wave" },
    { 0x1A6DACFD, "watch_death" },
    { 0x15E7FDAF, "watch_debug_input" },
    { 0xD7943F6B, "watch_decoy" },
    { 0x80F2F027, "watch_devgui" },
    { 0x30A4D362, "watch_devgui_afterlife" },
    { 0x040EABFC, "watch_devgui_alcatraz_final_battle" },
    { 0xEED01F76, "watch_devgui_award_challenges" },
    { 0x95831971, "watch_devgui_brutus" },
    { 0x3F2C9A81, "watch_devgui_complete_puzzles" },
    { 0x957042CA, "watch_devgui_dig" },
    { 0x23E72289, "watch_devgui_double_points" },
    { 0x6783DB5C, "watch_devgui_ee_main" },
    { 0x86A7797A, "watch_devgui_get_key" },
    { 0x0F97CC93, "watch_devgui_give_shield" },
    { 0x0513836D, "watch_devgui_mechz" },
    { 0x32E657F2, "watch_devgui_oneinchpunch" },
    { 0xE82796A8, "watch_devgui_plane" },
    { 0x90960539, "watch_devgui_quadrotor" },
    { 0x01CB223E, "watch_devgui_tablet" },
    { 0x4FAF44D9, "watch_devgui_zombie_blood" },
    { 0x1F3000DC, "watch_door_for_open" },
    { 0x2B4EC24C, "watch_double_wide" },
    { 0x676CD560, "watch_driver_death" },
    { 0x0831DFE4, "watch_elevator_devgui" },
    { 0xF5012460, "watch_elevator_prompt" },
    { 0x4ADB3DCA, "watch_emp_grenade" },
    { 0xFCD35B2E, "watch_emp_grenade_stage1" },
    { 0xD0C5071A, "watch_emped" },
    { 0x33B974F8, "watch_end" },
    { 0xF0E244E5, "watch_entity_shutdown" },
    { 0xDD87C8AD, "watch_entrance_bigdogs" },
    { 0xAC3CFB4B, "watch_equipped_weapons_for_upgraded_staffs" },
    { 0xA224CAE6, "watch_escapepod_devgui" },
    { 0x82A90A4C, "watch_exit_vehicle" },
    { 0x7F66CBDA, "watch_explosive_crate" },
    { 0x87812219, "watch_fire_sale" },
    { 0xD5B5B838, "watch_first_move_trig" },
    { 0x17949913, "watch_flak" },
    { 0x1A57D278, "watch_flak_death" },
    { 0xE27BD24A, "watch_for_1st_village" },
    { 0xD84EBBF2, "watch_for_2nd_village" },
    { 0xFFDF238D, "watch_for_ads" },
    { 0x2AA77261, "watch_for_bend_village" },
    { 0xA6D1B28E, "watch_for_body_dump" },
    { 0x0073F6A2, "watch_for_boost" },
    { 0x62CDBBDC, "watch_for_cleanup_2" },
    { 0xE79DD52F, "watch_for_cockpit_switch" },
    { 0xAB63FF7E, "watch_for_convoys" },
    { 0xF0A2F36C, "watch_for_crystal_pickup" },
    { 0xD1AB4085, "watch_for_death" },
    { 0x547D67B1, "watch_for_death_before_explosion" },
    { 0xF4CCBEB2, "watch_for_decoys" },
    { 0xEC02875E, "watch_for_drop" },
    { 0xD673D804, "watch_for_dud" },
    { 0x111F9D4A, "watch_for_elevator_during_faller_spawn" },
    { 0xE8B9D8B5, "watch_for_emp" },
    { 0x4BA099A4, "watch_for_emp_close" },
    { 0x138EA912, "watch_for_emp_grenaded" },
    { 0x0AC0A0AD, "watch_for_end_game" },
    { 0x95985459, "watch_for_exit" },
    { 0xDBA6F0CE, "watch_for_explosion" },
    { 0x49D083F3, "watch_for_fail_revive" },
    { 0x2192FE51, "watch_for_fake_death" },
    { 0x7756EA79, "watch_for_fake_fire" },
    { 0xC086F34E, "watch_for_fall" },
    { 0xF04D4EC4, "watch_for_flare_trig" },
    { 0x94459A11, "watch_for_flash" },
    { 0x6CD3A722, "watch_for_flash_and_stun" },
    { 0xE16B1148, "watch_for_flash_and_stun_end" },
    { 0x232E28DB, "watch_for_foot_stomp" },
    { 0x4419FB9D, "watch_for_force_giant_robot" },
    { 0xD9194505, "watch_for_game_end" },
    { 0xE802F658, "watch_for_gib_notetracks" },
    { 0x66DC358A, "watch_for_glitches" },
    { 0x503B7AA9, "watch_for_gongs_gone_bad" },
    { 0x80C05BDA, "watch_for_grapple" },
    { 0x6B6D0F82, "watch_for_grenade_cancel" },
    { 0xF01938C2, "watch_for_grenade_duds" },
    { 0x4C2AE355, "watch_for_grenade_launcher_duds" },
    { 0xA8D4F6F4, "watch_for_grenade_throw" },
    { 0x6F9A1A5F, "watch_for_grenade_throw_done" },
    { 0x23F18392, "watch_for_halfway_cleanup" },
    { 0x9225192D, "watch_for_horse_melee" },
    { 0xD18815B6, "watch_for_infantry_event_start" },
    { 0xFA1982BD, "watch_for_jump" },
    { 0x44175E3E, "watch_for_knockoff" },
    { 0xB5293887, "watch_for_laststand" },
    { 0x84D9F474, "watch_for_lock" },
    { 0xACFE2BEB, "watch_for_lockout_screen" },
    { 0xA34C8D3A, "watch_for_minigun" },
    { 0x067E93D8, "watch_for_monkey_bolt" },
    { 0x6F81CABE, "watch_for_movement" },
    { 0xE7E606B6, "watch_for_open_sesame" },
    { 0x30638A7E, "watch_for_patrol_stealth_fail" },
    { 0xEDD2C26F, "watch_for_player_at_elevator" },
    { 0x6ABFC6F5, "watch_for_player_backtrack" },
    { 0x7FBF781A, "watch_for_player_backtrack_after_crate" },
    { 0x4259E675, "watch_for_player_dist" },
    { 0x3D3BA703, "watch_for_player_leaves_base_on_horse" },
    { 0x5700F562, "watch_for_player_pickup_staff" },
    { 0xFF2EE5CA, "watch_for_player_shooting" },
    { 0x259465EA, "watch_for_player_touch" },
    { 0x1D906E70, "watch_for_players_in_fire" },
    { 0xD0F894E8, "watch_for_poi_death" },
    { 0xE3DD26E1, "watch_for_remove_remote_weapon" },
    { 0xC0ABD95B, "watch_for_replay_gun" },
    { 0x1EC8E68B, "watch_for_respawn" },
    { 0xEE80CCA0, "watch_for_riot_shield_melee" },
    { 0x1367A4E1, "watch_for_rocket_firing" },
    { 0xE9DEA188, "watch_for_rockets" },
    { 0x74DC5CC4, "watch_for_roll" },
    { 0xA18D1974, "watch_for_rolled_over" },
    { 0x80238A02, "watch_for_sam_missiles" },
    { 0xC3FE4929, "watch_for_shot" },
    { 0x29C78220, "watch_for_skip_killcam" },
    { 0xBDDE20CB, "watch_for_slip_bolt" },
    { 0x39D34565, "watch_for_sprint" },
    { 0x72036347, "watch_for_staff_upgrades" },
    { 0x2927BEB6, "watch_for_stuck_spot" },
    { 0x45F74A80, "watch_for_tactical_grenade_change" },
    { 0x0D65C82D, "watch_for_targets" },
    { 0xF9CDFDE1, "watch_for_team_change" },
    { 0xAEA44179, "watch_for_throwbacks" },
    { 0xC94BC3FC, "watch_for_thunderguns" },
    { 0x2AAB0374, "watch_for_time_bombs" },
    { 0x66ECD8BA, "watch_for_timeout" },
    { 0x5B0E817A, "watch_for_tomahawk_charge" },
    { 0xDDA6D38A, "watch_for_tomahawk_throw" },
    { 0xFC7E6D77, "watch_for_touching_controls" },
    { 0x0AAF5799, "watch_for_trigger_condition" },
    { 0x55C8DC94, "watch_for_triple_attack" },
    { 0x38DBA27E, "watch_for_turret_kill" },
    { 0x4E88F38D, "watch_for_upgraded_staffs" },
    { 0x1965DCC4, "watch_for_valid_melee" },
    { 0xE65F8416, "watch_for_wave_start_or_incoming_timer" },
    { 0x4EC8A6B0, "watch_for_weapon_switch_left_hand" },
    { 0xA328D4D5, "watch_for_woods_through_tarp" },
    { 0xECA74CDA, "watch_game_ended" },
    { 0x1939EC5E, "watch_game_start" },
    { 0x60E0216A, "watch_global_power" },
    { 0x32735085, "watch_goal_trigger" },
    { 0x29D21FCB, "watch_gramophone_vinyl_pickup" },
    { 0x413BB27A, "watch_grenade_cancel" },
    { 0x3D7B829E, "watch_grenade_gravity" },
    { 0xD315B17F, "watch_grenade_target" },
    { 0xAE346B89, "watch_grenade_usage" },
    { 0xEEDFD3A8, "watch_group_deaths" },
    { 0x70E7255B, "watch_hack_ents" },
    { 0x84AF6FEB, "watch_harp_at_turret" },
    { 0x7C0CAA0E, "watch_heli_delete_trig" },
    { 0x89BBEA5A, "watch_heli_trig" },
    { 0xA6768C84, "watch_helo_death" },
    { 0xEBDE8383, "watch_hero_power" },
    { 0x554FA98B, "watch_hero_weapon_change" },
    { 0xA3ACC0F8, "watch_hero_weapon_give" },
    { 0x6026B04E, "watch_hero_weapon_take" },
    { 0x296EAB81, "watch_hint_stance" },
    { 0xCE05366F, "watch_hit_players" },
    { 0x89DAFC27, "watch_incoming_timer" },
    { 0x703D6DD0, "watch_interiors" },
    { 0x2A443A78, "watch_intro_rocket" },
    { 0x60EE5DE4, "watch_ir_strobe_equipped" },
    { 0x883080B9, "watch_ir_strobe_fired" },
    { 0xFD0A2014, "watch_jail_door" },
    { 0x3DF98AB4, "watch_killstreak_detect_perks_changed" },
    { 0x94C5A728, "watch_killstreak_tap_activation" },
    { 0x16F422CA, "watch_laser" },
    { 0xB2E25D35, "watch_left_arm" },
    { 0x56F38647, "watch_lightpower_devgui" },
    { 0x3A723E07, "watch_lockon" },
    { 0x4F0D1EDE, "watch_lockon_angles" },
    { 0xBC65E429, "watch_lockon_old" },
    { 0xE43C0820, "watch_magic_doors" },
    { 0x832B6EBF, "watch_melee_swipes" },
    { 0x92022E65, "watch_metalstorm_mms_usage" },
    { 0xBEC3586C, "watch_missile_death" },
    { 0x3A03ED6D, "watch_missile_kill_z" },
    { 0xB486CAF3, "watch_missile_usage" },
    { 0x78E7C11B, "watch_model_sliquification" },
    { 0x378CB851, "watch_mortar_weapon" },
    { 0x59A7D1DC, "watch_mounting" },
    { 0x1A1BB185, "watch_nav_computer_built" },
    { 0x32C6DA03, "watch_notetracks_slicing" },
    { 0xAED28C58, "watch_notetracks_slicing_times" },
    { 0x2DC13B23, "watch_obstacle_trigger" },
    { 0x8E9015DD, "watch_oc_pop_target" },
    { 0x55A62AA5, "watch_oc_target" },
    { 0xC2DB3FD7, "watch_oc_timer_end" },
    { 0xF45A2E2C, "watch_occasional_line" },
    { 0x1E17DD5D, "watch_offhand_end" },
    { 0x00D22BB7, "watch_one_shot_line" },
    { 0x69744AEC, "watch_one_shot_samantha_clue" },
    { 0x068EB779, "watch_one_shot_samantha_line" },
    { 0xFD79AB3F, "watch_opensesame" },
    { 0x70EFF235, "watch_overheat" },
    { 0xEF3446BF, "watch_pack_volume" },
    { 0xEEBC4CA9, "watch_part_pickup" },
    { 0x7BCE2CC9, "watch_perks_changed" },
    { 0x47874D19, "watch_pickup" },
    { 0x17F0B9E4, "watch_plant_sound" },
    { 0x94226E66, "watch_planted_intruders" },
    { 0xED47032B, "watch_player_controls" },
    { 0x8A190709, "watch_player_death" },
    { 0xCB6A2E72, "watch_player_drown_death" },
    { 0x00742FDF, "watch_player_drowning" },
    { 0xEEE31736, "watch_player_firing_tow_missile" },
    { 0x38574D7C, "watch_player_fx_finished" },
    { 0x4C9CD81C, "watch_player_grenades" },
    { 0x7CB6765A, "watch_player_in_maze" },
    { 0xD9E34D07, "watch_player_input" },
    { 0x16999F69, "watch_player_input_revive" },
    { 0xE2823D0A, "watch_player_input_suicide" },
    { 0xDEAFF58C, "watch_player_looking" },
    { 0xFBBC7F73, "watch_player_melee" },
    { 0xF44CA0AD, "watch_player_melee_events" },
    { 0x7D537401, "watch_player_mortar_death" },
    { 0x09F313F0, "watch_player_purchase" },
    { 0x27BA0BB1, "watch_player_rain_water_sheeting" },
    { 0x5BC92A94, "watch_player_springpads" },
    { 0xAC1AC4D2, "watch_player_touch" },
    { 0xBB50227B, "watch_player_tow_missile_ads" },
    { 0xE563C651, "watch_player_visibility" },
    { 0x6BE83116, "watch_player_zombies" },
    { 0xDE1D8F4D, "watch_poi_exploder" },
    { 0xAF57994C, "watch_power_water" },
    { 0x14EBC07B, "watch_predicted_player_changes" },
    { 0x536649EF, "watch_prompt_reassessment" },
    { 0x885F1B3B, "watch_proximity_grenade" },
    { 0x337165CC, "watch_ptboat_for_dialogue" },
    { 0x00B22C63, "watch_quad_death" },
    { 0xB48685F9, "watch_rampage_bookmark" },
    { 0x3AEF849C, "watch_raygun_impact" },
    { 0x272118E1, "watch_rejack_activate" },
    { 0x1EFA08B4, "watch_rejack_activate_requested" },
    { 0xB6EC4F96, "watch_rejack_suicide" },
    { 0xB53E6337, "watch_rejack_timeout" },
    { 0x3AF39ED9, "watch_remote_weapon_death" },
    { 0x1DFA17F4, "watch_remote_weapon_death_duration" },
    { 0x69A99C0D, "watch_remove_influencer" },
    { 0x5C7A1D1E, "watch_reset" },
    { 0xFC0AB383, "watch_reset_anim_rate" },
    { 0x46614851, "watch_reznov_exit_launch_bldg_trigger" },
    { 0xF4B605DE, "watch_right_arm" },
    { 0x5C0CB7C5, "watch_riot_shield_use" },
    { 0x54F6D0B0, "watch_riotshield_damage" },
    { 0x2FEE042F, "watch_riotshield_pickup" },
    { 0x7063D0C8, "watch_riotshield_usage" },
    { 0xA8ED4A70, "watch_rockets" },
    { 0xF73CED28, "watch_sal_at_asd" },
    { 0x0B078D2D, "watch_satchel" },
    { 0x1AC4F13F, "watch_satchel_detonation" },
    { 0xFE14CE7E, "watch_satchel_simple" },
    { 0x10AAAD0D, "watch_savannah_deep_fail" },
    { 0xA4D83529, "watch_savannah_deep_warn" },
    { 0xE632A1B9, "watch_savannah_short_fail" },
    { 0x53251385, "watch_savannah_short_warn" },
    { 0x95FFD44E, "watch_save_player" },
    { 0x0B76E09B, "watch_scene_ending" },
    { 0x557B98AC, "watch_scene_skip_requests" },
    { 0xE79B5797, "watch_scene_skipping" },
    { 0x71FC7435, "watch_security_panel_trigger" },
    { 0x34A1F774, "watch_securitynode_death" },
    { 0x2B11CD63, "watch_sentry_death" },
    { 0xF25868D7, "watch_shoot_harper" },
    { 0x1F8C0E1B, "watch_shoot_menendez" },
    { 0xDBA9BC53, "watch_shutdown" },
    { 0x536445D2, "watch_sloth_on_exit_side" },
    { 0x2510E538, "watch_sloth_on_same_side" },
    { 0x8DEB7E35, "watch_slowgun_fired" },
    { 0x70FC2BC3, "watch_smoke_death" },
    { 0x56E9EFB7, "watch_smoke_detonate" },
    { 0x815C75F8, "watch_smoke_effect_watch_resurrect" },
    { 0xF668C085, "watch_smoke_effect_watch_suicide" },
    { 0x36E60017, "watch_smoke_grenade_pickup_trigger" },
    { 0xCDC3EB4F, "watch_spectation" },
    { 0x057E0EA5, "watch_spectation_player" },
    { 0xBB5CCCB1, "watch_staff_air_fired" },
    { 0x218C2881, "watch_staff_air_impact" },
    { 0x3DA26606, "watch_staff_ammo_reload" },
    { 0x3FF00371, "watch_staff_fire_fired" },
    { 0xDB4F0C5C, "watch_staff_fire_upgrade_fired" },
    { 0x06843D18, "watch_staff_fired" },
    { 0xACD99507, "watch_staff_lightning_fired" },
    { 0xE7DC448C, "watch_staff_pickup" },
    { 0xBD596582, "watch_staff_revive_fired" },
    { 0x50AB9129, "watch_staff_upgrade_fired" },
    { 0x56CD26ED, "watch_staff_usage" },
    { 0x26EDB358, "watch_staff_water_fired" },
    { 0x790D29EE, "watch_staff_water_impact" },
    { 0xFE1CCDCD, "watch_start_swimming" },
    { 0xBC078970, "watch_stink" },
    { 0x795D8024, "watch_stop_player_fx" },
    { 0x9267D366, "watch_strafe_call_fail" },
    { 0xD36CD70C, "watch_subwoofers" },
    { 0xFCA1B9DC, "watch_supplemental_object_death" },
    { 0x2F9C67ED, "watch_survival_time" },
    { 0x8FF13426, "watch_tank_death" },
    { 0x0CA71DDA, "watch_target" },
    { 0x1D349946, "watch_target_trigger_thread" },
    { 0xF4427A64, "watch_temp_powered_item" },
    { 0x50E0BC12, "watch_timeout" },
    { 0x743299C7, "watch_to_oc" },
    { 0x985DC7CA, "watch_to_sr" },
    { 0x3E534406, "watch_to_turn_off_water_sheeting" },
    { 0x9945B672, "watch_tower_collapse" },
    { 0xC78EF4B7, "watch_transform" },
    { 0x2C357C23, "watch_traversal_end" },
    { 0x8A16CC3B, "watch_travesal_end" },
    { 0xED6B3B1A, "watch_trigger_visibility" },
    { 0xF68A1515, "watch_turret_keyline" },
    { 0x4AB6240B, "watch_turret_recovery" },
    { 0x1748A15E, "watch_usage" },
    { 0x35579833, "watch_use_trigger" },
    { 0xD9B31B24, "watch_vision_pulse_owner_death" },
    { 0x16664EE1, "watch_water_vision" },
    { 0xFD4B8044, "watch_weapon_change" },
    { 0x94594DF7, "watch_weapon_changes" },
    { 0xC02C27D8, "watch_weapon_object_alt_detonate" },
    { 0xA285E55F, "watch_weapon_object_alt_detonation" },
    { 0x83B30F83, "watch_weapon_object_detonation" },
    { 0x304C0609, "watch_weapon_object_spawn" },
    { 0x9B8AE929, "watch_weapon_object_usage" },
    { 0xB5B2ADE9, "watch_weapon_projectile_object_spawn" },
    { 0xFA76A676, "watch_weapon_systems" },
    { 0x361649C9, "watch_weapon_usage" },
    { 0x350E707F, "watch_window_damage" },
    { 0xD42FA123, "watch_world_pulse_end" },
    { 0x49CF85E9, "watch_zombie_blood_early_exit" },
    { 0xC089A07A, "watch_zombie_fall_off_tank" },
    { 0xB1807D73, "watch_zombie_flings" },
    { 0x97B82A2A, "watch_zombies" },
    { 0x1E59BB1A, "watchacousticsensordamage" },
    { 0x9FC9DA80, "watchammo" },
    { 0xC5833485, "watchattachmentchange" },
    { 0x9708CCDD, "watchbettys" },
    { 0xCBF51008, "watchbettyshutdown" },
    { 0x46021A5D, "watchbouncingbetty" },
    { 0x9059E14A, "watchburndamage" },
    { 0xF61861FB, "watchburnfinished" },
    { 0x01D74CDC, "watchburntimer" },
    { 0x8CF1EDC3, "watchc4" },
    { 0x6345B058, "watchc4altdetonate" },
    { 0xC40BE1DF, "watchc4altdetonation" },
    { 0x0B786B74, "watchc4detonation" },
    { 0xD7AFB0B0, "watchcameraspikedamage" },
    { 0x8575438A, "watchcarrycancelevents" },
    { 0xFCF737DC, "watchcheckpointtrigger" },
    { 0x4C1D0EFD, "watchclaymores" },
    { 0x1C635562, "watchclearhacking" },
    { 0x74E3CC84, "watchclearlockedon" },
    { 0xA4A86263, "watchclearlockingon" },
    { 0x3E517104, "watchclientfields" },
    { 0x7AE6D388, "watchcloneownerdisconnect" },
    { 0x936C06B2, "watchcollision" },
    { 0x8CE7B744, "watchcombatrobotdeath" },
    { 0xF298031D, "watchcombatrobothelicopterhacked" },
    { 0x6EBC9FFB, "watchcombatrobotlanding" },
    { 0xD4F822D5, "watchcombatrobotownerdisconnect" },
    { 0x7B2F894B, "watchcombatrobotownerdisconnect_singleton" },
    { 0xE4B3AAA0, "watchcombatrobotshutdown" },
    { 0xEBD22D59, "watchcontractreset" },
    { 0x420FB310, "watchcontractresets" },
    { 0x26C0CB41, "watchcounteruavs" },
    { 0x5D3D6064, "watchcurrentfiring" },
    { 0xF66DCA59, "watchdamage" },
    { 0x8C5BC4DC, "watchdeath" },
    { 0x543F1F48, "watchdeathtrigger" },
    { 0x13E49E5A, "watchdeployedriotshielddamage" },
    { 0xA9045897, "watchdeployedriotshieldents" },
    { 0x80579239, "watchdetonation" },
    { 0x727067FC, "watchdevnotify" },
    { 0xC17F9B98, "watchdisconnect" },
    { 0x92823005, "watchdoublejump" },
    { 0x3A35D39F, "watchduringzombie" },
    { 0x9F600105, "watched" },
    { 0x953DD183, "watchelectrictrapuse" },
    { 0x25AE88B5, "watchelimination" },
    { 0xDD2E8431, "watchempexplosion" },
    { 0x7462D78C, "watchempgrenadeshutdown" },
    { 0xA0D22101, "watchempgrenadetowardsplayer" },
    { 0x3C329D13, "watchenemyvelocity" },
    { 0xB712AA61, "watchentityshutdown" },
    { 0xF33365A3, "watcher" },
    { 0x3ED81BB8, "watcher_alarm_on_death" },
    { 0xE32B5CB1, "watcher_array" },
    { 0x71AB4A7E, "watcher_spawner" },
    { 0xC0DAA06A, "watcher_thread" },
    { 0x29A807DE, "watchername" },
    { 0x51548E74, "watcherplayer" },
    { 0x03132092, "watchers" },
    { 0x5607D0A8, "watchersinitialized" },
    { 0x3096C5FB, "watcherspot" },
    { 0x2ACB21A5, "watcherweaponnames" },
    { 0x757A040E, "watcherweapons" },
    { 0xCD30EB3A, "watches" },
    { 0x3826A243, "watches_for_friendly_fire" },
    { 0x24A69B51, "watchexplode" },
    { 0xEC6D1A73, "watchffaandmultiteamspawn" },
    { 0x9CE7010C, "watchffaspawn" },
    { 0xE6FB87F5, "watchfindremoteweapon" },
    { 0x2DE246FD, "watchfirstuse" },
    { 0xA3D40F49, "watchflaredetonation" },
    { 0xFE0027DC, "watchfor_death" },
    { 0xB6F14E29, "watchfor_notify" },
    { 0x00AB0FFF, "watchforattack" },
    { 0xBAE3002E, "watchforballisticknifekills" },
    { 0xD62FBAA7, "watchforbflagcap" },
    { 0x34B00301, "watchforcleanup" },
    { 0x2DCFBCF8, "watchforcratekill" },
    { 0x1D10E97F, "watchfordeath" },
    { 0x817CBB83, "watchfordeathbeforeexplosion" },
    { 0xCDCD002F, "watchfordisconnectcleanup" },
    { 0xCE97F4D5, "watchfordtp" },
    { 0xA46DA4B1, "watchforearlyleave" },
    { 0xE22E6007, "watchforearlyleave_helicopter" },
    { 0xF1C21B49, "watchforemoveremoteweapon" },
    { 0xB5C537E7, "watchforemp" },
    { 0x4F322C90, "watchforendgame" },
    { 0xAB966FDA, "watchforexplode" },
    { 0xA7EFD6F8, "watchforexplosion" },
    { 0x8366E648, "watchforexplosionnotetracks" },
    { 0xCDDAEB10, "watchforfakefire" },
    { 0xE31EE713, "watchforfire" },
    { 0x960A9334, "watchforgameend" },
    { 0x5DAA9588, "watchforgravityspikeexplosion" },
    { 0x8A855FC9, "watchforgrenadeduds" },
    { 0x4AD1F64B, "watchforgrenadefire" },
    { 0x4C773865, "watchforgrenadelauncherduds" },
    { 0x06503972, "watchforgrenadeputdown" },
    { 0x7780D29D, "watchforguidedmissilefire" },
    { 0xBB748780, "watchforhack" },
    { 0x3BE6A01B, "watchforhatchetkills" },
    { 0x25DC0DBF, "watchforherokill" },
    { 0xC468111B, "watchforhostmigration" },
    { 0xBEF79BFF, "watchforincomingfire" },
    { 0x8B861068, "watchforinvalidweaponswitch" },
    { 0xBA289092, "watchforkills" },
    { 0xC6A9DF54, "watchforkillstreakend" },
    { 0xDB083E88, "watchforleave" },
    { 0x83194D9A, "watchformantle" },
    { 0x966A0937, "watchforneedtoturnortimeout" },
    { 0x905F86F7, "watchforopendoor" },
    { 0xACD87DE5, "watchforoptionuse" },
    { 0x64FDA59E, "watchforoptionuse_thief_singleton" },
    { 0x2A68AD9C, "watchforotherkillstreaks" },
    { 0x1A428BE7, "watchforoverheat" },
    { 0x17710A44, "watchforownerexit" },
    { 0xAFA8FAA4, "watchforplayerfalldamage" },
    { 0x04A52CC7, "watchforplayerslide" },
    { 0x9869BB07, "watchforproximityexplosion" },
    { 0x6D0C644B, "watchforrapiddestroy" },
    { 0x0B1D3235, "watchforrespawn" },
    { 0xD698B9B7, "watchforscore" },
    { 0x6A2E3ED7, "watchforscramblers" },
    { 0xC6D62E4F, "watchforscriptexplosion" },
    { 0x5AADFA85, "watchforstationary" },
    { 0x63C8B607, "watchforthiefkill_singleton" },
    { 0x73ED3A0B, "watchforthrowbacks" },
    { 0x0CA1C83F, "watchfortowfire" },
    { 0x464BBD88, "watchforwater" },
    { 0x1EB9E79F, "watchgadgetactivated" },
    { 0x941E28BD, "watchgadgetactivated_singleton" },
    { 0x13536D88, "watchgameended" },
    { 0xD61504EF, "watchgameevents" },
    { 0x767DFB85, "watchgoalchanged" },
    { 0x1E6F997C, "watchgoalchangedwhileapproaching" },
    { 0x571136FF, "watchgoalradiuschanged" },
    { 0x1D665B6D, "watchgoaltrigger" },
    { 0xE469A90A, "watchgrenadecancel" },
    { 0x1B8EE22C, "watchgrenadethrow" },
    { 0xF227660F, "watchgrenadetowardsplayer" },
    { 0x95E6DB70, "watchgrenadetowardsplayerinternal" },
    { 0xD05BF708, "watchgrenadetowardsplayertimeout" },
    { 0x04D7B679, "watchgrenadeusage" },
    { 0x0E0F985A, "watchhackableentitydeath" },
    { 0x73FCE255, "watchhackerplayershutdown" },
    { 0xDE2AA8D9, "watchhackertoolend" },
    { 0xF46B6D2E, "watchhackertoolfired" },
    { 0x4D9789CB, "watchhackertoolinterrupt" },
    { 0x256A0863, "watchhackertooluse" },
    { 0x9DF46756, "watchhackspeed" },
    { 0x35BC7E69, "watchhatchettrigger" },
    { 0x910FCA96, "watchheadchopperuse" },
    { 0x682F8D05, "watchhelicopterdeath" },
    { 0xA0282FC6, "watchheroweaponchanged" },
    { 0x6A1EADA4, "watchheroweaponchanged_singleton" },
    { 0x129BB55F, "watchhideredflashingoverlay" },
    { 0xE973AA66, "watchhurttriggers" },
    { 0xDBD867E3, "watchincendiaryburn" },
    { 0x6983E16D, "watchincendiarygrenadedetonation" },
    { 0x729F457E, "watching" },
    { 0xB908EBBC, "watching_dockside_missile" },
    { 0x7877DB21, "watchingactiveclient" },
    { 0xAABF5ABF, "watchitem" },
    { 0x00F2190A, "watchjump" },
    { 0x780B2460, "watchkillsteakweaponswitch" },
    { 0xDD009DFF, "watchkillstreakend" },
    { 0xC8966078, "watchkillstreakremoval" },
    { 0x7364BF70, "watchkillstreakroundchange" },
    { 0xEB61C499, "watchkillstreakuse" },
    { 0x6D834702, "watchkillstreakweapondeath" },
    { 0xA06A5ED9, "watchkillstreakweapondelay" },
    { 0x71009640, "watchkillstreakweaponswitch" },
    { 0xBF4D3B41, "watchkillstreakweaponusage" },
    { 0x3A85DBFE, "watchkilltrigger" },
    { 0x700B26C9, "watchkillwhilecontesting" },
    { 0x493487DF, "watchkniferangretrieve" },
    { 0xF0D84238, "watchleavingbattlefield" },
    { 0x21EAC623, "watchlocationchangethread" },
    { 0x97E7701D, "watchmatchendingsoon" },
    { 0x8E292C47, "watchminimap" },
    { 0x587BD390, "watchmissiledeath" },
    { 0x71D93771, "watchmissilesthread" },
    { 0xF47C0627, "watchmissileusage" },
    { 0x29D5B99A, "watchmissleunlink" },
    { 0xB8B4A8E9, "watchmovetriggershutdown" },
    { 0xE8353556, "watchnapalmburn" },
    { 0x9C745219, "watchnetworkintruder" },
    { 0xE6E216D6, "watchnetworkintruderdamage" },
    { 0xED428595, "watchnetworkintruderdeath" },
    { 0x8FC4BCE8, "watchnetworkintruderplant" },
    { 0x7AC046E0, "watchobjectdamage" },
    { 0x4E654065, "watchoffhandend" },
    { 0x0BF1EE63, "watchownerdeath" },
    { 0x6DD8D83D, "watchownerdisconnect" },
    { 0x93CF0EB3, "watchownerdisconnect_singleton" },
    { 0xB9963EE3, "watchowneremp" },
    { 0x27A3A860, "watchownerevents" },
    { 0xF2349262, "watchownergameevents" },
    { 0x73FA0FF0, "watchownergameevents_singleton" },
    { 0x139C8CC1, "watchownerlaststand" },
    { 0xC5D3F055, "watchownernondeathevents" },
    { 0x927B01C5, "watchownerteamkillkicked" },
    { 0xBA0114DC, "watchparentdeath" },
    { 0x46F79DD9, "watchparentmissiles" },
    { 0x57189C36, "watchpickup" },
    { 0x585C19C3, "watchplacement" },
    { 0x0EEF2A74, "watchplayeraim" },
    { 0x9B482071, "watchplayeraimdebug" },
    { 0x94BB63E9, "watchplayerdeath" },
    { 0x42D2DE40, "watchplayerexitrequestthread" },
    { 0xF384949E, "watchplayerexitrequestthread_singleton" },
    { 0xD1B95EBA, "watchplayerteamchangethread" },
    { 0x3D8F7981, "watchpregameclasschange" },
    { 0xC9DCC9D1, "watchpronetouch" },
    { 0x38079CDA, "watchproximitygrenadedetonation" },
    { 0xEC28939B, "watchproximitygrenadehitplayer" },
    { 0xAE245B3C, "watchproxyshutdown" },
    { 0x5C000140, "watchrapsdeath" },
    { 0x6B2DD5FD, "watchrapskills" },
    { 0x186452C3, "watchrapskillstreakend" },
    { 0x3A23837E, "watchrapstippedover" },
    { 0xD852845F, "watchreconmodelfordeath" },
    { 0x79D88BA7, "watchreloading" },
    { 0x2C873275, "watchremotecontroldeactivate" },
    { 0x3A2BF7B5, "watchremotecontroldeactivate_remoteweapons" },
    { 0x22288894, "watchremotecontrolledweapondeath" },
    { 0xD3A36D4D, "watchremotesentryfire" },
    { 0x6A5DA0EC, "watchremotetriggerdisable" },
    { 0xCDD9EED1, "watchremotetriggeruse" },
    { 0xCDF2511B, "watchremoteweaponpings" },
    { 0x80BC72B6, "watchremoveremotecontrolledweapon" },
    { 0xE3065835, "watchrespin" },
    { 0x921CFA96, "watchrespingadgetactivated" },
    { 0x8D1C30FD, "watchrestartfx" },
    { 0x5A56E783, "watchreturnturrettoinventory" },
    { 0x252F2CB4, "watchrewindableevents" },
    { 0x0D594F11, "watchriotshieldattractor" },
    { 0xEB33B662, "watchriotshielddeploy" },
    { 0x1907E649, "watchriotshieldmelee" },
    { 0xB108F3B7, "watchriotshieldpickup" },
    { 0x66974B4A, "watchriotshieldstuckentitydeath" },
    { 0xBC2C7304, "watchriotshielduse" },
    { 0x714EDED6, "watchroundandgameend" },
    { 0x6F9EB97D, "watchs" },
    { 0xFE908AC8, "watchsatchel" },
    { 0x3CBCB105, "watchsatchelaltdetonate" },
    { 0xEB08EADA, "watchsatchelaltdetonation" },
    { 0x169D6D97, "watchsatcheldetonation" },
    { 0xA6B914A2, "watchscavengelethal" },
    { 0xA4594D9F, "watchscramble" },
    { 0xB8F94770, "watchscramblerdamage" },
    { 0x288C9631, "watchsensorgrenadedamage" },
    { 0xF73BEB0E, "watchshieldknockback" },
    { 0x688BA69F, "watchshieldlaststand" },
    { 0x855D834F, "watchshieldtriggervisibility" },
    { 0x82C0A703, "watchshootentvelocity" },
    { 0xB7551518, "watchshotgunswitchnotetracks" },
    { 0x308774F2, "watchshutdow" },
    { 0xE42FF528, "watchshutdown" },
    { 0x4342529D, "watchshutdownforfakeplayer" },
    { 0x3450E601, "watchslide" },
    { 0xA85C00CE, "watchsmokegrenadedetonation" },
    { 0x4C87904A, "watchspawnprofile" },
    { 0x5C7C8645, "watchspecialcrossbowtrigger" },
    { 0xF517A146, "watchspikelauncheritemcountchanged" },
    { 0x278F911D, "watchspringpaduse" },
    { 0xD58CC4C2, "watchsprint" },
    { 0x4161E0AD, "watchstartrun" },
    { 0x6E22167B, "watchstuckzombies" },
    { 0xF4FC6582, "watchstun" },
    { 0x83FE6BE9, "watchsubwooferuse" },
    { 0x4785158B, "watchsuppression" },
    { 0x00C2F451, "watchswimming" },
    { 0x34E6850F, "watchtabungrenadedetonation" },
    { 0xE52FA453, "watchtacinsertshutdown" },
    { 0x735D457C, "watchtakendamage" },
    { 0xE2A361E3, "watchtargetentityupdate" },
    { 0x34856C5E, "watchtargethack" },
    { 0x2B4AA377, "watchtazerknucklemelee" },
    { 0x41103651, "watchteamchange" },
    { 0x4DD504B0, "watchteamopstime" },
    { 0x7B7421DF, "watchthreatdetectordamage" },
    { 0xE196A932, "watchthrow" },
    { 0xF07BB203, "watchtimeout" },
    { 0xF229784A, "watchtoggle" },
    { 0x33C9D959, "watchtoofriendly" },
    { 0x8C208069, "watchtower" },
    { 0xA17AE473, "watchtrackswitch" },
    { 0x658BC6FA, "watchtriggervisibility" },
    { 0x711A4B64, "watchtrophysystemdamage" },
    { 0x82C3CDB4, "watchturbineuse" },
    { 0xDF62EB36, "watchturretlifespan" },
    { 0xFFE077B5, "watchturretplacement" },
    { 0xA54CB01E, "watchturretshutdown" },
    { 0x3978DB19, "watchturretuse" },
    { 0xB2A3D954, "watchtutorialtrigger" },
    { 0xCAF3D8EC, "watchuammoofftrigger" },
    { 0x7C41122A, "watchuammoontrigger" },
    { 0x5A8897C9, "watchuserrespawn" },
    { 0xB6371F75, "watchusetrigger" },
    { 0x4C831D66, "watchvisionswitchthread" },
    { 0x7F4A227D, "watchwallrun" },
    { 0xDE32795D, "watchwallruntwooppositewallsnoground" },
    { 0x42767F73, "watchwater" },
    { 0xB3C8ADC5, "watchwatertrigger" },
    { 0xF9B49546, "watchweaponchange" },
    { 0xBC82986B, "watchweaponchangecomplete" },
    { 0xA7BA05AD, "watchweaponchangezm" },
    { 0x041B78AC, "watchweapondeath" },
    { 0xF32CD29E, "watchweaponfire" },
    { 0x0EFC7AC4, "watchweaponobjectaltdetonate" },
    { 0x953CFAD3, "watchweaponobjectaltdetonation" },
    { 0x197A78E0, "watchweaponobjectdetonation" },
    { 0x144EBB18, "watchweaponobjectspawn" },
    { 0xCAB44D2F, "watchweaponobjectspawn_" },
    { 0xF228B3A8, "watchweaponobjectusage" },
    { 0x8A3E8923, "watchweaponprojectileobjectspawn" },
    { 0x9C87D5A5, "watchweaponslist" },
    { 0x95241D2A, "watchweaponswitchnotetracks" },
    { 0x501CBF33, "watchweaponusage" },
    { 0x4F42DD4C, "watchweaponusagezm" },
    { 0x70CF2688, "watchworldpulseend" },
    { 0xDB13C1BA, "water" },
    { 0x204418C7, "water1" },
    { 0x3890C8B2, "water_1" },
    { 0x6705BF28, "water_1_ent" },
    { 0x128E4E49, "water_2" },
    { 0x399E4D4B, "water_2_ent" },
    { 0x7CE68117, "water_ambient_back" },
    { 0xD7E81D69, "water_ambient_back_block" },
    { 0xC5865E09, "water_ambient_back_left" },
    { 0xCC7981C2, "water_ambient_back_pillar" },
    { 0x51FD1A34, "water_ambient_back_right" },
    { 0x97396C31, "water_ambient_box" },
    { 0xE05C4BD5, "water_ambient_front_block" },
    { 0x182D12CD, "water_ambient_front_left" },
    { 0x33F8B5B6, "water_ambient_front_pillar" },
    { 0xC1B357F0, "water_ambient_front_right" },
    { 0x951ABE57, "water_ambient_middle_left" },
    { 0xCA311D12, "water_ambient_middle_right" },
    { 0xBFAEA731, "water_ambient_mover" },
    { 0x9D61D325, "water_body_1" },
    { 0x7E532980, "water_bullets" },
    { 0x94947AC7, "water_burst_overwrite" },
    { 0x2DE9668C, "water_check_pos" },
    { 0xFE3AF8EB, "water_check_pos_2" },
    { 0x33964098, "water_coming" },
    { 0x18749E26, "water_damage" },
    { 0x3D54156B, "water_dart_cleanup" },
    { 0xDF9133C9, "water_delta" },
    { 0xFB764672, "water_dive_overlay_time" },
    { 0x0AA300AC, "water_drop_death_think" },
    { 0xE01DB4D4, "water_drop_end" },
    { 0xEDD28895, "water_drop_end_think" },
    { 0x7FA00273, "water_drop_touch_trig" },
    { 0xAAE85E5A, "water_drops_init" },
    { 0x649C0399, "water_drops_trigger_think" },
    { 0xC1F7D537, "water_drops_triggers_delete" },
    { 0xC516E217, "water_duds" },
    { 0x7F587F4E, "water_dvar_lerp" },
    { 0x9E8457EF, "water_fx" },
    { 0x32DCFF24, "water_fx1" },
    { 0xA4E46E5F, "water_fx2" },
    { 0x0F89B44C, "water_gate" },
    { 0x35D67320, "water_guard" },
    { 0x3723492F, "water_guard_node" },
    { 0x53BE9070, "water_gush_debug" },
    { 0x9A78B6F4, "water_height" },
    { 0x61D13FB2, "water_height_offset" },
    { 0xFC83306C, "water_impact_origin" },
    { 0xEDC60CB3, "water_kill_triggers" },
    { 0xE003D8C2, "water_killbrush_think" },
    { 0x6B08E259, "water_level" },
    { 0xE17FB61F, "water_level_fx_tag" },
    { 0x098FAB60, "water_level_raised" },
    { 0xECDCA633, "water_max_depth" },
    { 0x9ADA5475, "water_min_speed_scale_ai" },
    { 0x588F26B8, "water_min_speed_scale_player" },
    { 0x30F68B68, "water_mover" },
    { 0x8E2955C8, "water_name" },
    { 0x77BBA656, "water_on_visor" },
    { 0xC7E8DB44, "water_pa_1" },
    { 0x39F04A7F, "water_pa_2" },
    { 0x13EDD016, "water_pa_3" },
    { 0x18F86CD8, "water_planes" },
    { 0xC92CA119, "water_pos" },
    { 0x2CD4B03A, "water_scream" },
    { 0xA24841FA, "water_settings" },
    { 0x586A3BFB, "water_sheeting_fx" },
    { 0x9074661B, "water_sheeting_init" },
    { 0xD6C81DE5, "water_sheeting_overlay_time" },
    { 0x8DBEBBCA, "water_sheeting_rumble" },
    { 0xF99E9F32, "water_sheeting_trigger_think" },
    { 0xB2707E13, "water_slide_exit" },
    { 0xECDBC4F8, "water_spash" },
    { 0xCDFC1DA3, "water_splash_enter" },
    { 0x745C72C3, "water_splash_exit" },
    { 0xAD439CC4, "water_splash_fx_anim_loop" },
    { 0xF5E830FA, "water_splash_fx_anim_single" },
    { 0x7A7E5246, "water_splash_fx_handle_notetrack" },
    { 0xE75CB13C, "water_splash_fx_handler" },
    { 0x0E9D25B3, "water_start" },
    { 0x846B153A, "water_start_angles" },
    { 0xE8CB2080, "water_start_org" },
    { 0x89023E41, "water_stop" },
    { 0x3F742A50, "water_stuff_for_art1" },
    { 0xB17B998B, "water_stuff_for_art2" },
    { 0xBAE24A16, "water_stuff_go" },
    { 0x9E14C79A, "water_surface" },
    { 0xD921A244, "water_surface_underwater_begin" },
    { 0xD61C98B8, "water_surface_underwater_end" },
    { 0x8E04F33D, "water_surge_street" },
    { 0x8A7FA8B5, "water_tank" },
    { 0xF4BA2EA6, "water_texture" },
    { 0x9697822F, "water_think" },
    { 0x297AA5B8, "water_tower" },
    { 0x3B4E6558, "water_tower_achievement" },
    { 0xA1133C4B, "water_tower_brick_fx" },
    { 0x463AB9D0, "water_tower_fall" },
    { 0x64E1907B, "water_tower_fx_anim" },
    { 0x0D1E3190, "water_tower_number" },
    { 0x8F201EAD, "water_tower_origin" },
    { 0xAA94D2E8, "water_tower_target" },
    { 0xDA0082B8, "water_tower_trigs" },
    { 0xEED31EDC, "water_trail_monitor" },
    { 0xCBC50C07, "water_trigger" },
    { 0xF9924F94, "water_trigger_init" },
    { 0x583EED9E, "water_trigger_think" },
    { 0xB3AC70CA, "water_trigs" },
    { 0x1BB893B7, "water_volume" },
    { 0xD2304B48, "water_vox" },
    { 0xED1294B4, "water_wake_tag" },
    { 0x0D22249F, "water_watcher" },
    { 0xE00129EA, "water_wheel_watch" },
    { 0xF8D6B597, "waterall" },
    { 0xCE6B4686, "waterambientfxboxback" },
    { 0x7F881A88, "waterambientfxboxfront" },
    { 0x0E737E7E, "waterambientfxleftback" },
    { 0x8C301880, "waterambientfxleftfront" },
    { 0x040BDC60, "waterambientfxleftmiddle" },
    { 0xDF2C57C2, "waterambientfxmiddleback" },
    { 0xBCCEE32C, "waterambientfxmiddlefront" },
    { 0x256A9E7F, "waterambientfxrightback" },
    { 0x43232BA3, "waterambientfxrightfront" },
    { 0x3A0049F9, "waterambientfxrightmiddle" },
    { 0xEDAB74E1, "waterbox" },
    { 0xD5BA78E8, "watercooler" },
    { 0x631D726D, "watercooler_start" },
    { 0x7181B395, "waterdepth" },
    { 0x1818F5B0, "waterdrops_on_visor" },
    { 0x49ED09CE, "waterdropsactive" },
    { 0xA44EAF51, "waterfall" },
    { 0xF96E95ED, "waterfall_fog_trigger" },
    { 0xE5F74C70, "waterfall_spawner" },
    { 0x7014F858, "waterfall_triggers_init" },
    { 0xA4520D2C, "waterfall_watcher" },
    { 0xC68203FE, "waterfall_zone" },
    { 0x3EEB04EA, "waterfallmistoverlay" },
    { 0xBF6C61F3, "waterfallmistoverlayreset" },
    { 0x79DDE0EB, "waterfalloverlay" },
    { 0x27EC1B38, "waterfalls" },
    { 0x71220D90, "waterfx" },
    { 0x55C8A045, "waterfx_follow_harper" },
    { 0xC610F00A, "waterfxloop" },
    { 0xE3BE422B, "waterfxloopstarter" },
    { 0x1EFF214F, "waterheight" },
    { 0x3C632049, "waterhut" },
    { 0xFEEC3F1C, "waterhut_rpg_shot" },
    { 0x7B0D7B18, "waterhut_start" },
    { 0xE20DC23A, "waterkilltriggerthink" },
    { 0xF387CE34, "waterlevel" },
    { 0x8F21B3FC, "waterleveltag" },
    { 0xE01F449D, "watermark" },
    { 0x160D5F8B, "watermarking" },
    { 0x44B28C93, "watermelon" },
    { 0xD054CAC5, "waterplayer" },
    { 0x5E0BD2EF, "waterplop" },
    { 0x927CF422, "waterrushfx" },
    { 0x54DDBE35, "waters" },
    { 0x3617FC05, "waters_last_line" },
    { 0x0111B5EE, "waters_speaking" },
    { 0x62DEF4D0, "waters_think" },
    { 0x12D958D0, "watersheet_on_trigger" },
    { 0xDA118935, "watersheeting" },
    { 0xDA62579F, "watersheetingendtime" },
    { 0x33623FCB, "watersheetingminlength" },
    { 0xF27DAC8F, "watersim" },
    { 0x658878FA, "watersimenable" },
    { 0xB1895D79, "waterslide" },
    { 0x5FEBA0F6, "watersoundent" },
    { 0x685F5816, "waterthink" },
    { 0x2989DFEE, "waterthink_rampspeed" },
    { 0x2296D511, "watertower" },
    { 0x8E1F933B, "watertracedistancefromend" },
    { 0x70CEDFBF, "watery" },
    { 0xD6769985, "wav" },
    { 0x40A10E08, "wav_num" },
    { 0xA4952FB2, "wave" },
    { 0x0F53834F, "wave1" },
    { 0x06D10A1F, "wave1_complete" },
    { 0xF403EAB2, "wave1_done" },
    { 0xCBED5B7B, "wave1_kill_flag" },
    { 0xC90378B9, "wave1_pdf_spawnmanager" },
    { 0x997289DD, "wave1_started" },
    { 0x728142F3, "wave1_uproad_cartel_retreat" },
    { 0x9D4C1414, "wave2" },
    { 0x0A6CDD39, "wave2_bp2" },
    { 0x4C57AC23, "wave2_bp2_main" },
    { 0xE46A62D0, "wave2_bp3" },
    { 0x7D27B5B0, "wave2_bp3_main" },
    { 0x829670BF, "wave2_done" },
    { 0x9418B2C8, "wave2_kill_flag" },
    { 0x69F7047B, "wave2_loc" },
    { 0x9A8B10AF, "wave2_lower_house_gunner_dies" },
    { 0x534134CC, "wave2_molotov_instant_trigger" },
    { 0xD4DF5728, "wave2_player_takes_sidepath" },
    { 0x131CF9D3, "wave2_rock_guys" },
    { 0xF4741029, "wave2_rockguy_dies" },
    { 0x3C7D7C73, "wave2_sidepath_vo" },
    { 0xA5C27192, "wave2_timer" },
    { 0x8409EB65, "wave2_timer_done" },
    { 0xAA54F264, "wave2_upper_house_gunner_dies" },
    { 0x16962C58, "wave2_wait_time" },
    { 0x09A31CAB, "wave2bp2_btr1_behavior" },
    { 0x7D456996, "wave2bp2_btr2_behavior" },
    { 0xA482EEB4, "wave2bp2_tank_logic" },
    { 0xC34E8E7D, "wave3" },
    { 0x07340341, "wave3_bp1_main" },
    { 0x98CF77A0, "wave3_bp2_main" },
    { 0xB07D1493, "wave3_bp3_main" },
    { 0xD6BA1C00, "wave3_done" },
    { 0x10849132, "wave3_loc" },
    { 0x89619CC6, "wave4_hind1_circle" },
    { 0x2D4A138B, "wave4_hind2_circle" },
    { 0xE6E4DE63, "wave4_hip_circle" },
    { 0x2998A345, "wave4bp2_btr1_behavior" },
    { 0x60176904, "wave4bp2_btr2_behavior" },
    { 0x2116B91F, "wave4bp2_tank1_behavior" },
    { 0x2012C33A, "wave4bp2_tank2_behavior" },
    { 0x31D7F4C8, "wave4bp3_btr1_behavior" },
    { 0xC77DD1D9, "wave4bp3_btr2_behavior" },
    { 0x59497068, "wave4bp3_tank1_behavior" },
    { 0xEC74E479, "wave4bp3_tank2_behavior" },
    { 0x90E70BFA, "wave_1" },
    { 0xC3CA443A, "wave_1_panthers" },
    { 0xA28A95DA, "wave_1_timeout" },
    { 0x326193DE, "wave_1st_attack_time" },
    { 0x6AE49191, "wave_2" },
    { 0xFA205E27, "wave_2_panthers" },
    { 0xE9F9004B, "wave_2_schreks" },
    { 0x376560F5, "wave_2_timeout" },
    { 0xDC3B11DB, "wave_2b_spawners" },
    { 0x3595D8F9, "wave_3_split" },
    { 0x6EEE6558, "wave_alloweddistfromleader" },
    { 0x0812D5C8, "wave_ansel" },
    { 0xE3D50A21, "wave_arty" },
    { 0x2B5925C6, "wave_attack_finished" },
    { 0xF2E5A4AF, "wave_attack_time" },
    { 0x0DEE967B, "wave_attacker_random_behavior" },
    { 0x65D959F5, "wave_controller" },
    { 0xDACC675E, "wave_count" },
    { 0x82748EAE, "wave_delay" },
    { 0x5C2BC3D5, "wave_delay_max" },
    { 0x8938381B, "wave_delay_min" },
    { 0xEB78E4C5, "wave_done" },
    { 0xEDF327D5, "wave_dropped" },
    { 0xBD380ACB, "wave_ended" },
    { 0xE9A5F12E, "wave_exist" },
    { 0xD930294F, "wave_finished" },
    { 0x3B4E6B6C, "wave_handle_players" },
    { 0x813B97D8, "wave_handle_redshirts" },
    { 0x90F9DFE6, "wave_handle_safezone_guys" },
    { 0xF3799869, "wave_has_boss" },
    { 0xFBDE7D19, "wave_has_heli_squad" },
    { 0xC4AD35E3, "wave_height_z" },
    { 0x63234FA3, "wave_impact" },
    { 0x3464BA5C, "wave_lock" },
    { 0xC794E42E, "wave_manager" },
    { 0xFA4F6689, "wave_max" },
    { 0x15449237, "wave_min" },
    { 0x645BDED9, "wave_move_waveleader" },
    { 0xB7F4B48C, "wave_near_players" },
    { 0x7133C8E2, "wave_notify" },
    { 0x5FA14D3B, "wave_num" },
    { 0x6C7DDA8E, "wave_number" },
    { 0x00D01631, "wave_one_tank_fire" },
    { 0xAFAEBA81, "wave_playercheckperiod" },
    { 0xA808280F, "wave_populate" },
    { 0x1651611E, "wave_respawn_" },
    { 0xF04C5204, "wave_respawn_allies" },
    { 0xA65C1F7D, "wave_respawn_axis" },
    { 0x3F70198B, "wave_set" },
    { 0xC2F9D608, "wave_setup_leader" },
    { 0x70C61D1A, "wave_spawn" },
    { 0x0685A8AC, "wave_spawn_locs" },
    { 0xB7F12056, "wave_spawning" },
    { 0xF83513E1, "wave_speed_monitor" },
    { 0x011899A7, "wave_table" },
    { 0x6C7E9CB9, "wave_trigger_wait" },
    { 0x80D46BF9, "wave_type" },
    { 0xF536E330, "wave_types" },
    { 0x0E67E819, "wave_unlock" },
    { 0x7E724EF8, "wave_vo" },
    { 0xC221BD93, "wave_vo_done" },
    { 0x9BB0F192, "wave_waveleadergoalradius" },
    { 0xB1798C4E, "waveaggressivehud_label" },
    { 0xE2E9F647, "wavebased" },
    { 0x8B76ED18, "wavecollisiontrig" },
    { 0x41F00EFB, "wavecollisiontrig_aggressive" },
    { 0x310B4CAB, "wavedelay" },
    { 0x4A0745E4, "waveimpact" },
    { 0xC2E0F0C1, "waveleader" },
    { 0x9E34AA9F, "waveleader_movedone" },
    { 0x8A17A3BE, "waveleader_moving" },
    { 0xE7B82F96, "wavelength" },
    { 0xD3F7533E, "wavemovetime" },
    { 0xFF77A2AA, "wavenum" },
    { 0x159E4A64, "wavenumaihud_label" },
    { 0x87CA7565, "wavenumaihud_value" },
    { 0x5FE398D7, "wavenumberhud_label" },
    { 0x0320E20E, "wavenumberhud_value" },
    { 0xD7B3354B, "wavenumbosseshud_label" },
    { 0x2185AD0A, "wavenumbosseshud_value" },
    { 0x3E6E2A51, "wavenumdogshud_label" },
    { 0x90CA8C60, "wavenumdogshud_value" },
    { 0x8399B9AB, "wavenumspecialaihud_label" },
    { 0x72398B6A, "wavenumspecialaihud_value" },
    { 0x726C0411, "waveofmutilation" },
    { 0x0DAA1757, "wavepath" },
    { 0x24EE2D5A, "waveplayerspawnindex" },
    { 0x1CAD79D4, "waver" },
    { 0x7F40E9B5, "waver1" },
    { 0xA543641E, "waver2" },
    { 0xA84A2E35, "waver_loop" },
    { 0x0B81CBDF, "waveready" },
    { 0x95A84C4A, "waverepeats" },
    { 0x726DCF43, "waverespawndelay" },
    { 0x3E20053C, "waverotatetime" },
    { 0x4AA74447, "wavers" },
    { 0x42AFF43D, "waves" },
    { 0xDC0E2CBB, "waves_completed" },
    { 0x7DD1C210, "waves_move_up_quicker" },
    { 0x1BE15A91, "wavespawnindex" },
    { 0xE337EAE6, "wavespawntimer" },
    { 0xE6DE587B, "wavespeed" },
    { 0xFBCCD18D, "wavespots" },
    { 0x2A930D1E, "wavespots1" },
    { 0x049092B5, "wavespots2" },
    { 0xDE8E184C, "wavespots3" },
    { 0xB88B9DE3, "wavespots4" },
    { 0xE8997232, "wavestart" },
    { 0xA46990BB, "wavetouch" },
    { 0xA5BBFB63, "waving" },
    { 0x52BD39F9, "waving_guy_move" },
    { 0xCCDA932E, "wavy" },
    { 0xB0741F1C, "waw" },
    { 0x53050B5F, "waw_combat" },
    { 0x54B03E5D, "waw_init" },
    { 0x703EC330, "waw_shared" },
    { 0xE2D2E6B9, "waw_utility" },
    { 0x345B5702, "way" },
    { 0xED6452D8, "waypoint" },
    { 0xF21EB4FE, "waypoint_ent" },
    { 0x146F978B, "waypoint_reached" },
    { 0xBA18F248, "waypoint_shader" },
    { 0x1E86044D, "waypointalliestouching" },
    { 0x1B5437D4, "waypointaxistouching" },
    { 0xCD383E52, "waypointheading" },
    { 0xDC941E81, "waypointprogress" },
    { 0x9ECE32B3, "waypoints" },
    { 0xA7EF244D, "ways" },
    { 0xBD04160C, "wbr" },
    { 0xCAA75263, "wc" },
    { 0x6A95E285, "wc51" },
    { 0x3D02FF2F, "wc_icon_setup" },
    { 0x5EE50B20, "wclass" },
    { 0x4D442F51, "wdfo" },
    { 0x07EA595A, "wds_scene" },
    { 0x16AC4735, "we" },
    { 0xC5AD517A, "we_have_id" },
    { 0x58379312, "we_lost_chesire" },
    { 0xD95B2EE2, "we_win" },
    { 0x74610B51, "weak" },
    { 0x2DF6AE99, "weak_spot_health" },
    { 0xC1BBF492, "weaked_armor" },
    { 0x474C02E4, "weaken" },
    { 0xE9F6D299, "weaken_ai" },
    { 0x0ACCF885, "weaken_ai_group" },
    { 0xDE1C35B4, "weaken_harper_victim" },
    { 0x06DF9647, "weakened" },
    { 0x181654C4, "weakening" },
    { 0x79A56E58, "weakening_vo_played" },
    { 0x3F7D9318, "weaker" },
    { 0xC2656C87, "weakest" },
    { 0xDAF1D1F4, "weakness" },
    { 0x12618C89, "weakpoint" },
    { 0xA670AC2A, "weakpointobjective" },
    { 0x258BCC6E, "weaksauce" },
    { 0x50FF40F9, "weakspot" },
    { 0x60135FF4, "weakspot_bone_name" },
    { 0x26A5209F, "weakspotfx" },
    { 0x3B6698A2, "weakspottags" },
    { 0x8C6FB922, "wealth" },
    { 0x1E9A1F50, "weaopon" },
    { 0xCA775902, "weap" },
    { 0x5064C63F, "weap_away" },
    { 0x09B69E02, "weap_base" },
    { 0xEEB7CC65, "weap_beacon_firing" },
    { 0x4D8EDD06, "weap_beacon_gib" },
    { 0xCA385D0F, "weap_beacon_rumble" },
    { 0x2D277B01, "weap_beacon_zombie_death" },
    { 0xED7A89C2, "weap_before_knife" },
    { 0x1219286F, "weap_bench_off" },
    { 0x0EDA4A67, "weap_class" },
    { 0x9A654C20, "weap_first_raise" },
    { 0x4106B374, "weap_min_dmg_range" },
    { 0x1B995050, "weap_name" },
    { 0xFBA03ABF, "weap_raise" },
    { 0x73FA00E4, "weap_rearming" },
    { 0x37F677D3, "weap_tokens" },
    { 0xF4AE8E42, "weapclass" },
    { 0x3799E123, "weapflags" },
    { 0x19C2886B, "weapidx" },
    { 0x0A9F9D66, "weaplist" },
    { 0xC8356018, "weapn" },
    { 0x668D018F, "weapname" },
    { 0xDFCC01FD, "weapon" },
    { 0xC4FD004E, "weapon1" },
    { 0x9EFA85E5, "weapon2" },
    { 0x78F80B7C, "weapon3" },
    { 0x52F59113, "weapon4" },
    { 0x51EF04A6, "weapon_ads" },
    { 0x93200106, "weapon_ads_dot" },
    { 0xCAC8EDD1, "weapon_alt" },
    { 0x6592859A, "weapon_ammo" },
    { 0x8753824C, "weapon_and_attachments" },
    { 0x0CE36AF4, "weapon_and_attachments_string" },
    { 0xBBBA58D0, "weapon_ang" },
    { 0x140246EF, "weapon_anim" },
    { 0xE72992E1, "weapon_armed" },
    { 0xB9D2EEF7, "weapon_array" },
    { 0x4BCFCE34, "weapon_array_grenade" },
    { 0xCA7169E6, "weapon_array_inventory" },
    { 0xE4B7CCB8, "weapon_array_primary" },
    { 0xED60773F, "weapon_array_sidearm" },
    { 0xBF936266, "weapon_assassination" },
    { 0x26A2DD50, "weapon_at_time_of_death" },
    { 0xD1A9FC4F, "weapon_attachment_name" },
    { 0x3986937E, "weapon_attachment_table" },
    { 0xD718278E, "weapon_attachments" },
    { 0xAB94C521, "weapon_available" },
    { 0xDE021C6F, "weapon_base" },
    { 0x5BED2B9F, "weapon_beacon_anims" },
    { 0xA20C4CB4, "weapon_beacon_busy" },
    { 0x54370306, "weapon_beacon_launch_ragdoll" },
    { 0xEEB0F02C, "weapon_beacon_timeout" },
    { 0xDD224FE6, "weapon_bench_reset" },
    { 0x29AB6D09, "weapon_bolt" },
    { 0x999793A1, "weapon_bought" },
    { 0x0BE447FF, "weapon_box_callback" },
    { 0x94BB1271, "weapon_box_update" },
    { 0x8D00759A, "weapon_butt_sounds" },
    { 0x67820EEC, "weapon_button" },
    { 0x3E5A7880, "weapon_buy" },
    { 0x9CDA039E, "weapon_cabinet_door_open" },
    { 0x44F806C1, "weapon_cabinet_think" },
    { 0x22ABD1E5, "weapon_cabs" },
    { 0xF0175DDE, "weapon_cache" },
    { 0x1CB89F5F, "weapon_cache_start" },
    { 0xFFE44D4A, "weapon_cache_struct" },
    { 0x5997074D, "weapon_camo_stat" },
    { 0x573A1C5E, "weapon_camo_stat_col" },
    { 0x1194C978, "weapon_change" },
    { 0x9206D256, "weapon_change_complete" },
    { 0x1D170424, "weapon_change_notify" },
    { 0x2F2A470D, "weapon_change_on_turret" },
    { 0x2C008E7D, "weapon_change_watcher" },
    { 0x7D925EAC, "weapon_changed" },
    { 0x5DC03BF8, "weapon_check" },
    { 0x26C3FFDC, "weapon_check_1_anim" },
    { 0x0FB2C8F5, "weapon_check_2_anim" },
    { 0x2CFEB4AA, "weapon_check_3_anim" },
    { 0x8B3B13AB, "weapon_check_4_anim" },
    { 0xE95D9B61, "weapon_check_enemy" },
    { 0x9CB97A98, "weapon_class" },
    { 0x20FE6790, "weapon_class_register" },
    { 0x9AD93031, "weapon_classname" },
    { 0xD9E20EC0, "weapon_clientscript_cac_model" },
    { 0x17998062, "weapon_clip" },
    { 0x68881EE1, "weapon_clip_frac" },
    { 0xC3A14D88, "weapon_controller" },
    { 0xDC23B46E, "weapon_cost_client_filled" },
    { 0x28B71166, "weapon_costs" },
    { 0x267414AD, "weapon_count" },
    { 0xA47B71F1, "weapon_countdown" },
    { 0xA89BEF64, "weapon_crate_80s_basic" },
    { 0x841C5CC5, "weapon_crate_80s_full" },
    { 0xB66A0816, "weapon_crate_future_basic" },
    { 0xED25E26B, "weapon_crate_future_full" },
    { 0xE07E8E75, "weapon_customization_icon" },
    { 0x4339EA13, "weapon_damage" },
    { 0x7E8B8C5D, "weapon_damage_callback_array" },
    { 0xCD693928, "weapon_data" },
    { 0x48671F6D, "weapon_detect" },
    { 0x35267388, "weapon_detonate" },
    { 0x2D16EB5A, "weapon_display" },
    { 0x92467705, "weapon_doors_state" },
    { 0x8516C647, "weapon_drop" },
    { 0x1D0FDE22, "weapon_drop_ammo_adjustment" },
    { 0x54CFCD62, "weapon_drop_watcher" },
    { 0x03603102, "weapon_dropped" },
    { 0x78FD7523, "weapon_dw" },
    { 0xFBD4F508, "weapon_engage_dists_init" },
    { 0x660316BF, "weapon_ent" },
    { 0x792FEB3C, "weapon_fire" },
    { 0x0DEFC094, "weapon_fire_dot" },
    { 0xAEACD3B8, "weapon_fire_time" },
    { 0xAA1618B0, "weapon_fired" },
    { 0xD3245EC3, "weapon_floats_up" },
    { 0x3A7F6ABE, "weapon_fly_away_end" },
    { 0x0427182D, "weapon_fly_away_start" },
    { 0x0DACB3C7, "weapon_full_name" },
    { 0xB1F17A3B, "weapon_give" },
    { 0x5665991B, "weapon_grabbed" },
    { 0xB3820A09, "weapon_group" },
    { 0x9EBCC2CA, "weapon_group_anims" },
    { 0x8D81AAA3, "weapon_group_frontend_anims" },
    { 0xE9C84AB0, "weapon_group_top_3_anims" },
    { 0x7A320888, "weapon_gun_normal" },
    { 0xEBFF7F58, "weapon_gun_spray" },
    { 0x11A4013B, "weapon_hud" },
    { 0x50C80BC3, "weapon_icon" },
    { 0x86B02064, "weapon_index" },
    { 0x32E73AB3, "weapon_index_test" },
    { 0xE8B092C4, "weapon_indicies" },
    { 0x046B269C, "weapon_influencer_length" },
    { 0xCC942D1A, "weapon_influencer_radius" },
    { 0xD109626E, "weapon_influencer_score" },
    { 0x348E2ACA, "weapon_influencer_score_curve" },
    { 0x44E68B84, "weapon_info" },
    { 0xC2E98B51, "weapon_instance" },
    { 0x61B32CFC, "weapon_inventory" },
    { 0x7B0A9D5D, "weapon_is_better" },
    { 0x94909C9E, "weapon_is_charge_weapon" },
    { 0x17092B81, "weapon_is_dual_wield" },
    { 0x4738EBA1, "weapon_is_sniper_weapon" },
    { 0x9E3EAC48, "weapon_is_upgraded_staff" },
    { 0xCF77121D, "weapon_javelin" },
    { 0xB37E0CFC, "weapon_keys" },
    { 0xE81F0450, "weapon_kill_reporter" },
    { 0x7D112A68, "weapon_last_damage" },
    { 0x7BB86043, "weapon_left" },
    { 0xF5646769, "weapon_left_anim" },
    { 0x0B9C9402, "weapon_left_anim_intro" },
    { 0x37CE1C29, "weapon_limit" },
    { 0xEEB3DEC4, "weapon_limit_override" },
    { 0xAB61DC08, "weapon_list" },
    { 0xD259F916, "weapon_list_modified" },
    { 0x6AD7DF24, "weapon_locations" },
    { 0x9DC35D64, "weapon_locker" },
    { 0x7980ECFB, "weapon_locker_data" },
    { 0xBCA5D5B1, "weapon_locker_grab" },
    { 0x9E648DBF, "weapon_locker_map" },
    { 0xA52C84B2, "weapon_locker_online" },
    { 0xD1A90197, "weapon_lockers" },
    { 0x4618CDF1, "weapon_management" },
    { 0x2C6AB964, "weapon_melee" },
    { 0xECBFDFBF, "weapon_melee_charge" },
    { 0x5D382438, "weapon_melee_juke" },
    { 0x1D9CC43E, "weapon_melee_power" },
    { 0x7299BB32, "weapon_melee_power_left" },
    { 0x939C6611, "weapon_minigun" },
    { 0xC222D467, "weapon_model" },
    { 0xC3F0CB79, "weapon_model_dw" },
    { 0x095FE4DE, "weapon_models" },
    { 0xE0DA7A29, "weapon_name" },
    { 0x988704E2, "weapon_name_parts" },
    { 0x8E6FEBA0, "weapon_names" },
    { 0xD8754FAF, "weapon_needs_left_hand_on_horse" },
    { 0x3EB9C1A6, "weapon_none" },
    { 0x32D13007, "weapon_null" },
    { 0x8874EBB7, "weapon_null_sp" },
    { 0x7AAACBD0, "weapon_num" },
    { 0xBB7FC8B3, "weapon_number" },
    { 0x8889C9CB, "weapon_object_damage" },
    { 0x492C1E59, "weapon_object_destroyed" },
    { 0xDF8154F4, "weapon_object_do_damagefeedback" },
    { 0xAC9E1BF7, "weapon_object_placed" },
    { 0x4DFA3E61, "weapon_object_timeout" },
    { 0x9A1435CF, "weapon_off" },
    { 0xD01F310B, "weapon_option" },
    { 0xF19F1A0D, "weapon_option_new_index" },
    { 0xF293A26A, "weapon_options" },
    { 0x9D027940, "weapon_options_param" },
    { 0x2E03E9FA, "weapon_org" },
    { 0x416E9C36, "weapon_origin" },
    { 0xDFEE025C, "weapon_out" },
    { 0x31E25A9C, "weapon_overheating" },
    { 0xF4A949B8, "weapon_pickup_update" },
    { 0x9014CF81, "weapon_pieces" },
    { 0x4BA642F5, "weapon_pistol" },
    { 0xA0A61689, "weapon_position" },
    { 0x221D91FC, "weapon_position_change" },
    { 0x5B587C80, "weapon_positions" },
    { 0x5EFEC304, "weapon_powerup" },
    { 0x7576440B, "weapon_powerup_change" },
    { 0xDDD484F4, "weapon_powerup_countdown" },
    { 0xCA6FB35B, "weapon_powerup_remove" },
    { 0x13829525, "weapon_powerup_replace" },
    { 0xFC8C22FA, "weapon_primary" },
    { 0x7A396A5F, "weapon_primary_camo_style" },
    { 0x78C7BCDB, "weapon_proximity" },
    { 0x3577F7D3, "weapon_pullout" },
    { 0x7E96AB29, "weapon_pvp_attack" },
    { 0xA54977FF, "weapon_range" },
    { 0xEFF9244E, "weapon_range_close" },
    { 0xE0349FD5, "weapon_rcbomb" },
    { 0xD4ED29CA, "weapon_rechamber_done" },
    { 0xAE4158D4, "weapon_regular" },
    { 0x104D7E8A, "weapon_reload_complete_" },
    { 0xBE6F196F, "weapon_replaced_monitor" },
    { 0xB964187B, "weapon_reticle_zom_a" },
    { 0x516E021F, "weapon_reticle_zom_e" },
    { 0x399BA8B0, "weapon_reticle_zom_eyes" },
    { 0x374D9D3E, "weapon_reznov_knife" },
    { 0x18060A36, "weapon_right" },
    { 0xEDBD23CA, "weapon_right_anim" },
    { 0x7BE4351D, "weapon_right_anim_intro" },
    { 0x59883122, "weapon_root_name" },
    { 0xE7DA8898, "weapon_saw_mg_setup" },
    { 0xDDD06483, "weapon_script_model" },
    { 0x30F04216, "weapon_secondary" },
    { 0x826EDC77, "weapon_set_first_time_hint" },
    { 0xA6FDCF37, "weapon_setup" },
    { 0x55700BCB, "weapon_show" },
    { 0x1E9AA88C, "weapon_show_caches_when_need_launcher" },
    { 0x04FED7E8, "weapon_show_hint_choke" },
    { 0x2F4798DB, "weapon_smoke" },
    { 0x45D7722A, "weapon_spawn_org" },
    { 0xB69E1FD8, "weapon_spawn_think" },
    { 0x219B002C, "weapon_spawns" },
    { 0x43310915, "weapon_special_grenade_type" },
    { 0x65A565D5, "weapon_specialty1" },
    { 0x8BA7E03E, "weapon_specialty2" },
    { 0xB1AA5AA7, "weapon_specialty3" },
    { 0xC137DB30, "weapon_specific_fire_death_sm_fx" },
    { 0xB5B4259D, "weapon_specific_fire_death_torso_fx" },
    { 0xA7F807ED, "weapon_spread" },
    { 0xB58B2666, "weapon_stationary" },
    { 0x72895ECA, "weapon_stock" },
    { 0x4233597C, "weapon_stowed" },
    { 0xE8166F42, "weapon_straight" },
    { 0xAAA3487B, "weapon_string" },
    { 0x2189A24B, "weapon_struct" },
    { 0x26369EAC, "weapon_structs_setup" },
    { 0x81635A67, "weapon_supports_aat" },
    { 0x3F5A6AF7, "weapon_supports_attachments" },
    { 0x0B2C6C6E, "weapon_supports_default_attachment" },
    { 0x0EE21519, "weapon_supports_this_attachment" },
    { 0xC89E55C9, "weapon_swap" },
    { 0x65735A34, "weapon_switch" },
    { 0x2DC311D0, "weapon_switch_asap" },
    { 0xE8F25F9F, "weapon_switch_done" },
    { 0x858F852C, "weapon_switch_failsafe" },
    { 0x60D6D3C6, "weapon_switch_for_distance_time" },
    { 0x0F05BECE, "weapon_switch_started" },
    { 0xF4F2D7F0, "weapon_switch_time" },
    { 0x86380DD7, "weapon_switched" },
    { 0x0F12DE06, "weapon_table_col_aat_exempt" },
    { 0x74901E98, "weapon_table_col_ammo_cost" },
    { 0xAB946074, "weapon_table_col_autospawn" },
    { 0x04108C5A, "weapon_table_col_class" },
    { 0xD63D8D98, "weapon_table_col_content_restrict" },
    { 0x4317122D, "weapon_table_col_cost" },
    { 0x6064C794, "weapon_table_col_create_vox" },
    { 0xAD7E6228, "weapon_table_col_force_attachments" },
    { 0x7D0D5121, "weapon_table_col_hint" },
    { 0xA91BBFC5, "weapon_table_col_in_box" },
    { 0x2BA515D9, "weapon_table_col_is_limited" },
    { 0x13D7625F, "weapon_table_col_is_wonder_weapon" },
    { 0x8F7C699C, "weapon_table_col_is_zcleansed" },
    { 0xB0D8C677, "weapon_table_col_limit" },
    { 0x8BBD02C7, "weapon_table_col_name" },
    { 0x5F08BA1E, "weapon_table_col_upgrade_in_box" },
    { 0xA0BC524A, "weapon_table_col_upgrade_limit" },
    { 0x00DD0E28, "weapon_table_col_upgrade_name" },
    { 0xC117D52F, "weapon_table_col_vo" },
    { 0xC24695A5, "weapon_table_col_vo_respond" },
    { 0xBF3ED43B, "weapon_tags" },
    { 0xAEC69E19, "weapon_take" },
    { 0xCD3F6E8F, "weapon_taken_by_losing_specialty_additionalprimaryweapon" },
    { 0xFDE2FCFE, "weapon_team_mask" },
    { 0x685B63A2, "weapon_throw_down_done" },
    { 0x56B6F976, "weapon_to_check" },
    { 0xD5FBF885, "weapon_to_keep" },
    { 0xE9E96668, "weapon_to_restore" },
    { 0xE213EC9B, "weapon_to_take" },
    { 0x009A6305, "weapon_toggle_ents" },
    { 0xD4CB8695, "weapon_toggle_think" },
    { 0x19AF50FE, "weapon_toggle_vox" },
    { 0x12BF68AD, "weapon_toks" },
    { 0x5EFF1D88, "weapon_type" },
    { 0x488A1810, "weapon_type_callback_array" },
    { 0x0D880E85, "weapon_type_check" },
    { 0x0621ADD9, "weapon_type_check_custom" },
    { 0xD56C9434, "weapon_upgrade" },
    { 0x54F57CD8, "weapon_upgraded" },
    { 0xE711EDF4, "weapon_use_thread" },
    { 0xC4D4B70F, "weapon_used" },
    { 0x30FC7B57, "weapon_utils" },
    { 0x1E289B7F, "weapon_vc_knife" },
    { 0x4E5D4F09, "weapon_wait_duration_ms" },
    { 0xB94681B7, "weapon_watch_gunner_downed" },
    { 0x1A51BC10, "weapon_watcher_callback_array" },
    { 0x593F018A, "weapon_watchers_created" },
    { 0x5F220734, "weapon_weighting_funcs" },
    { 0xAB5A32D1, "weapon_yaw" },
    { 0x89058F7B, "weaponaltweaponname" },
    { 0x51D6C0CF, "weaponammo" },
    { 0x15C214DF, "weaponammostock" },
    { 0xDE94F2FD, "weaponangles" },
    { 0x0A98508D, "weaponanims" },
    { 0x43D5DA02, "weaponannihilator" },
    { 0xF14B6BC1, "weaponarmblade" },
    { 0x6B77D6C4, "weaponarray" },
    { 0xE6E93045, "weaponattachmentintersection" },
    { 0x2FEBFE79, "weaponballisticknife" },
    { 0x965F378E, "weaponbasemelee" },
    { 0xFD3908D3, "weaponbasemeleeheld" },
    { 0x250754A7, "weaponbayonetinfo" },
    { 0x5E184240, "weaponblock" },
    { 0x9774929B, "weaponblocksprone" },
    { 0xDDA51C80, "weaponbottomarc" },
    { 0x7937F010, "weaponbouncingbetty" },
    { 0x57C6D91D, "weaponbus" },
    { 0x565B7501, "weaponchargeable" },
    { 0xFE3E3483, "weaponcharged" },
    { 0xDA2CD0A3, "weaponclass" },
    { 0x29D8DC4E, "weaponclassarray" },
    { 0xC21BC58D, "weaponclassthink" },
    { 0x4B03078B, "weaponclip" },
    { 0x1026B8F6, "weaponcliparray" },
    { 0x1C8F4335, "weaponclipmodels" },
    { 0x93C1AC0A, "weaponclipmodelsloaded" },
    { 0x59244F88, "weaponclipsize" },
    { 0x2EC52B13, "weaponcliptype" },
    { 0x9F034C02, "weaponcost" },
    { 0x0B9CAE92, "weaponcustomizationiconsetup" },
    { 0x4E0A4CE9, "weapondamagepenalty" },
    { 0x63AC3439, "weapondamagetrace" },
    { 0xF0E61345, "weapondamagetracepassed" },
    { 0x09E79C15, "weapondata" },
    { 0xCD87C683, "weapondata_give" },
    { 0x3022EA21, "weapondata_take" },
    { 0x0F042081, "weapondetonate" },
    { 0xE5CC5D26, "weapondogibbing" },
    { 0xE8887C42, "weapondrop" },
    { 0x152B3DD9, "weapondualwieldweaponname" },
    { 0xAD321157, "weaponelevator" },
    { 0x54D27686, "weaponengagedistvalues" },
    { 0x654691A8, "weaponequiploopsoundplaying" },
    { 0x0544F79D, "weaponfightdist" },
    { 0xB13BE7EB, "weaponfilter" },
    { 0x8E29E497, "weaponfired" },
    { 0xAF7D03EB, "weaponfiredthread" },
    { 0x882CC756, "weaponfiretime" },
    { 0x361F5D0D, "weaponflashgrenade" },
    { 0x80FC7114, "weaponforward" },
    { 0xA1E6C2A1, "weaponfriendlyclosedistance" },
    { 0x73BB29E1, "weaponfriendlyhacking" },
    { 0x4E6DD005, "weaponfrontendfrozenmomentaligntarget" },
    { 0x4635DA0C, "weaponfrontendfrozenmomentexploder" },
    { 0x1EB5DBDB, "weaponfrontendfrozenmomentweaponleftanim" },
    { 0x08BF65B3, "weaponfrontendfrozenmomentweaponleftmodel" },
    { 0xF2FE4E54, "weaponfrontendfrozenmomentweaponrightanim" },
    { 0x49430442, "weaponfrontendfrozenmomentweaponrightmodel" },
    { 0xA58A63B2, "weaponfrontendfrozenmomentxanim" },
    { 0x32517F52, "weaponfrontendfrozenmomentxcam" },
    { 0xA61911F5, "weaponfrontendfrozenmomentxcamframe" },
    { 0x4B2ECE39, "weaponfrontendfrozenmomentxcamsubxcam" },
    { 0x7D4CEDD3, "weaponfuellife" },
    { 0x832249C9, "weaponfullycharged" },
    { 0x6CB934F8, "weapongadgetmultirocket" },
    { 0xCE3B3F6F, "weaponguidedmissiletype" },
    { 0x260B0975, "weaponhackertool" },
    { 0x0B318B40, "weaponhasattachment" },
    { 0x29B0C0D0, "weaponhasattachmentandunlocked" },
    { 0xE5AD6149, "weaponheadobjectiveheight" },
    { 0xAE6EEF6B, "weaponhealth" },
    { 0x7FDD4E6D, "weaponhidden" },
    { 0x2D3B87EE, "weaponholdallowed" },
    { 0xED21A84A, "weaponidkeys" },
    { 0x4B18A1F9, "weaponids" },
    { 0xA12EEFAA, "weaponidx" },
    { 0x4557BAAF, "weaponindex" },
    { 0xD0821C81, "weaponinfo" },
    { 0x0779B280, "weaponinfoname" },
    { 0x01EB3723, "weaponinventory" },
    { 0xA44CAA5B, "weaponinventorytype" },
    { 0xC7D76A32, "weaponisboltaction" },
    { 0x6A24B9BF, "weaponischarged" },
    { 0x87B6BA19, "weaponischargeshot" },
    { 0xEFCD4400, "weaponisdualwield" },
    { 0x59894880, "weaponisgasweapon" },
    { 0x5EB4B800, "weaponisknife" },
    { 0x07C0D49A, "weaponisminigun" },
    { 0xAC5CC6EA, "weaponissemiauto" },
    { 0x2DBA21FA, "weaponissniperrifle" },
    { 0xC5531494, "weaponissniperweapon" },
    { 0x74D3C24C, "weaponitemindex" },
    { 0xBBE9579B, "weaponized" },
    { 0x79EEDACD, "weaponkeys" },
    { 0xD2EBF18C, "weaponkills" },
    { 0x574BE61D, "weaponkillsthisspawn" },
    { 0x8EB5CF1C, "weaponknifeloadout" },
    { 0x75C8BD53, "weaponlauncherex41" },
    { 0xBB8C1D00, "weaponlaunchermulti" },
    { 0x0321C466, "weaponleftarc" },
    { 0x6544CFA5, "weaponlightninggun" },
    { 0x9C0CCE1B, "weaponlightninggunarc" },
    { 0x9DB5377C, "weaponlightninggunkillcamdecelpercent" },
    { 0xD8E54AAB, "weaponlightninggunkillcamoffset" },
    { 0xCAF82AD5, "weaponlightninggunkillcamtime" },
    { 0xBD84CC55, "weaponlist" },
    { 0x20439CF5, "weaponlockdetect" },
    { 0xA953E0E6, "weaponlockfinalize" },
    { 0x618593A2, "weaponlockfree" },
    { 0x4F67AA29, "weaponlocknoclearance" },
    { 0xF013D9FD, "weaponlockonradius" },
    { 0x3F1ADCA4, "weaponlockonspeed" },
    { 0x35C12954, "weaponlockremoveslot" },
    { 0xC477757C, "weaponlockstart" },
    { 0xEE1CE041, "weaponlocktargettooclose" },
    { 0xABB2E947, "weaponmaxammo" },
    { 0x4F5CA7B5, "weaponmaxdist" },
    { 0x12DDCFEC, "weaponmaxgibdistance" },
    { 0x87ABC71C, "weaponmeleebat" },
    { 0xD81E42FB, "weaponmeleeboneglass" },
    { 0x50EF580F, "weaponmeleebowie" },
    { 0x41B6AD46, "weaponmeleeboxing" },
    { 0x4B668568, "weaponmeleebutterfly" },
    { 0xCE518589, "weaponmeleechainsaw" },
    { 0xA3DC5F22, "weaponmeleecrescent" },
    { 0x2506CCE1, "weaponmeleecrowbar" },
    { 0x0A37FCB5, "weaponmeleedagger" },
    { 0x680E11A1, "weaponmeleefireaxe" },
    { 0xB6EABBA5, "weaponmeleeimprovise" },
    { 0x3FC29189, "weaponmeleekatana" },
    { 0xDBFC7979, "weaponmeleeknuckles" },
    { 0xFCAB6539, "weaponmeleemace" },
    { 0x155E5036, "weaponmeleenunchuks" },
    { 0xBA044FB0, "weaponmeleeprosthetic" },
    { 0xAD509F1B, "weaponmeleeshockbaton" },
    { 0x6AC28AE6, "weaponmeleeshovel" },
    { 0x9D6D34A6, "weaponmeleesword" },
    { 0xED508918, "weaponmeleewrench" },
    { 0xEDC05C64, "weaponmodel" },
    { 0xD8C50126, "weaponmodel_name" },
    { 0x3F4192F0, "weaponmountable" },
    { 0xE3A45B44, "weaponname" },
    { 0x71AF1FCB, "weaponnamelocationx" },
    { 0x4BACA562, "weaponnamelocationy" },
    { 0x323A0EF7, "weaponnames" },
    { 0x6C3E6703, "weaponnone" },
    { 0x175F5666, "weaponnull" },
    { 0x07D65157, "weaponnum" },
    { 0x7DC253A4, "weaponobject" },
    { 0x8D7E6697, "weaponobjectdamage" },
    { 0xD3110A61, "weaponobjectdebug" },
    { 0x24645F51, "weaponobjectdetectionmovable" },
    { 0xCAB56E5B, "weaponobjectdetectiontrigger" },
    { 0x95DA9085, "weaponobjectdetectiontrigger_wait" },
    { 0x9E612B82, "weaponobjectexplodethisframe" },
    { 0xCEED437A, "weaponobjectfizzleout" },
    { 0xAEC973D7, "weaponobjects" },
    { 0xBCB80391, "weaponobjects_hacker_trigger_height" },
    { 0x614A0A54, "weaponobjects_hacker_trigger_width" },
    { 0x94C17997, "weaponobjects_headicon_offset" },
    { 0xFC84698B, "weaponobjects_on_player_connect_override" },
    { 0x22D8E9BD, "weaponobjects_on_player_connect_override_internal" },
    { 0x85625E9C, "weaponobjectwatcher" },
    { 0x1866FBAB, "weaponobjectwatcherarray" },
    { 0x204EE6D1, "weaponoptions" },
    { 0x692742B2, "weaponpickedup" },
    { 0xB6304C21, "weaponpickupscount" },
    { 0x5CC673EC, "weaponpistolenergy" },
    { 0x01824A75, "weaponplayejectbrass" },
    { 0x08EBC235, "weaponplusattachments" },
    { 0x07AC2242, "weaponplusperkon" },
    { 0xAA31B63D, "weaponpos" },
    { 0x52E4EC99, "weaponprefix" },
    { 0x1F8471D4, "weaponpurchased" },
    { 0x34C2BC4C, "weaponrange" },
    { 0xE3A5ED08, "weaponrangeclose" },
    { 0xED1105DD, "weaponreadytofire" },
    { 0xB8A58340, "weaponref" },
    { 0x6B9C0832, "weaponreload" },
    { 0xC9252A4D, "weaponreloadtime" },
    { 0xE78B9AD5, "weaponrenderoptions" },
    { 0x5F7FFF60, "weaponrevivetool" },
    { 0xBC57AF6F, "weaponrightarc" },
    { 0xFA27506C, "weaponriotshield" },
    { 0xCFF260CC, "weaponriotshieldupgraded" },
    { 0x0C58B24E, "weaponry" },
    { 0xF996A5BC, "weapons" },
    { 0x36569313, "weapons_cache" },
    { 0xC81B1DB3, "weapons_configured" },
    { 0x2A63CF7B, "weapons_dealers" },
    { 0x981895AD, "weapons_free" },
    { 0xD3CA7AC4, "weapons_free_node" },
    { 0x4424BE54, "weapons_free_trigger" },
    { 0x4F9FE5F3, "weapons_get_dvar" },
    { 0xB98C8DF9, "weapons_get_dvar_int" },
    { 0xBA8DDD8B, "weapons_info" },
    { 0x38BE8607, "weapons_list" },
    { 0xE880C9B6, "weapons_mastery_assault" },
    { 0xE6A32C4C, "weapons_on_player" },
    { 0xA21B4BF4, "weapons_print" },
    { 0x13FBB349, "weapons_restored" },
    { 0x28CEED10, "weapons_shared" },
    { 0xC8E5B547, "weapons_stats_end_index" },
    { 0x7E4A3F6D, "weapons_stats_guns_end_index" },
    { 0xB92F3AA6, "weapons_stats_guns_start_index" },
    { 0xA5A9BE5C, "weapons_stats_start_index" },
    { 0x085BA9EE, "weapons_stolen" },
    { 0x0A6F78CE, "weapons_taken_by_losing_specialty_additionalprimaryweapon" },
    { 0x7B151096, "weapons_taken_for_last_stand" },
    { 0xA66FE863, "weapons_using_ammo_sharing" },
    { 0x94BF022F, "weapons_with_ir" },
    { 0x19AB4409, "weaponsatchelcharge" },
    { 0x0E3CCB26, "weaponsettings" },
    { 0xE76BEDE1, "weaponshoottime" },
    { 0xA2DF6D45, "weaponshotgunenergy" },
    { 0xFA6A2A33, "weaponshouldreload" },
    { 0xDE430A8C, "weaponshown" },
    { 0x5AC136CF, "weaponsleft" },
    { 0x2B6E85B4, "weaponslist" },
    { 0xC4D44219, "weaponslot" },
    { 0x5F8B749E, "weaponsmgnailgun" },
    { 0xE768C39B, "weaponsoff" },
    { 0x3EBE3A96, "weaponspecialcrossbow" },
    { 0xA0D4CE4D, "weaponspecialdiscgun" },
    { 0x69343CEA, "weaponspinsettings" },
    { 0xBE6D824E, "weaponssystems" },
    { 0x0582E0AD, "weaponssystems_add_weapon" },
    { 0x51A6985D, "weaponssystems_attach_weapon" },
    { 0x98284324, "weaponssystems_buttonrelease_wait" },
    { 0xDD5BC434, "weaponssystems_create_weapon" },
    { 0x67F8751B, "weaponssystems_detach_weapon" },
    { 0xE516118C, "weaponssystems_fire_missile" },
    { 0xB2AE21D2, "weaponssystems_get_missile_target" },
    { 0x358298C4, "weaponssystems_hud" },
    { 0x7D456218, "weaponssystems_model_attached_to_tag" },
    { 0x749B41EB, "weaponssystems_noammo_warning" },
    { 0xD7026200, "weaponssystems_zoom" },
    { 0x425B95C1, "weaponstaken" },
    { 0x3CFE10FD, "weaponstartammo" },
    { 0x642140A7, "weaponstarthitpoints" },
    { 0xBC23D43F, "weaponstat" },
    { 0x8F72DC32, "weaponstatname" },
    { 0xB1E08D46, "weaponstats" },
    { 0xF5FD3F20, "weaponstats_attachment_col_num" },
    { 0x74E8CCBB, "weaponstats_table" },
    { 0xFA260148, "weaponstatstring" },
    { 0xF40463C8, "weaponstockarray" },
    { 0x74232A9D, "weaponstolenfromentnum" },
    { 0x5A24E149, "weaponstun" },
    { 0xBEC271B7, "weaponsuicide" },
    { 0x11E7D4B5, "weaponswitchbuttonpressed" },
    { 0x02322401, "weaponswitcheffects" },
    { 0x54D0EA98, "weaponswitchfinish" },
    { 0xFAA27D21, "weaponswitchstandruninternal" },
    { 0xCEFDA64E, "weaponsystems_equiploopsound_start" },
    { 0x6AFB6CEE, "weaponsystems_equiploopsound_stop" },
    { 0xB47A6429, "weapontacticalinsertion" },
    { 0x7A000C5A, "weapontest_init" },
    { 0x2E87AD80, "weapontogetammo" },
    { 0xACFE1829, "weapontogive" },
    { 0x66F71E19, "weapontopack" },
    { 0xB429FF0E, "weapontoparc" },
    { 0x038D5CCA, "weapontoremove" },
    { 0x972A7A46, "weapontweaks" },
    { 0x95F36C35, "weapontype" },
    { 0x9611344A, "weapontypestr" },
    { 0x65FEAD92, "weaponused" },
    { 0x0DF7024E, "weaponusedtodamage" },
    { 0x1E4F5B94, "weaponvo" },
    { 0x53176F2A, "weaponvoresp" },
    { 0x1587C746, "weapony" },
    { 0x5897DFC3, "weaponzmcymbalmonkey" },
    { 0x81DE0C56, "weaponzmdeaththroe" },
    { 0x5AFD58DF, "weaponzmfists" },
    { 0x168D703F, "weaponzmteslagun" },
    { 0xD22A87EB, "weaponzmteslagunupgraded" },
    { 0x65CD3EF2, "weaponzmthundergun" },
    { 0x15A75BE2, "weaponzmthundergunupgraded" },
    { 0x43753A49, "weaporig" },
    { 0xF6064A4D, "weaps" },
    { 0x65349532, "weaptype" },
    { 0x45F73A6D, "weaqpons" },
    { 0x7E726430, "wear" },
    { 0xB3C7E6A8, "wearing" },
    { 0x90E1679B, "wears" },
    { 0x500591D5, "weary_walkers" },
    { 0x8073A5DF, "weary_walkers_setup" },
    { 0x48C49106, "weary_walkers_strat" },
    { 0xFF9C9FAE, "weary_walks" },
    { 0x03F27A4D, "wearywalks" },
    { 0x28F483F3, "weasel_won" },
    { 0xB64A684B, "weather" },
    { 0xD3A4B95E, "weather_chance" },
    { 0xA8F41D35, "weather_control" },
    { 0xEE5F8E85, "weather_device_cleanup" },
    { 0x16D8620E, "weather_fog" },
    { 0xFF41015B, "weather_manager" },
    { 0x6ADD606B, "weather_name" },
    { 0xAA00C190, "weather_rain" },
    { 0xB34E96E3, "weather_rotate" },
    { 0x3AB5A2AA, "weather_rotate_thread" },
    { 0xB88B0C25, "weather_settings" },
    { 0xC95EEED7, "weather_snow" },
    { 0x43F919C6, "weather_vision" },
    { 0xAFC196A7, "weather_wind_shake" },
    { 0xC065E9ED, "weatherfx" },
    { 0x0757C861, "weave" },
    { 0x04532271, "weaver" },
    { 0xE67A5C19, "weaver_after_ladder" },
    { 0xD4C18DD2, "weaver_anims" },
    { 0xA8E8C859, "weaver_assistance_fail_time" },
    { 0x2A8D359F, "weaver_assistance_start_time" },
    { 0x8F1147EE, "weaver_boat" },
    { 0xA171A9A3, "weaver_breach" },
    { 0xF47C0CBB, "weaver_breach2" },
    { 0x905FFD6A, "weaver_breach_into_room" },
    { 0x91715F71, "weaver_breachroom_after" },
    { 0xDF701D18, "weaver_btr" },
    { 0xDBE8478B, "weaver_btr_anim_thread" },
    { 0x0CC81661, "weaver_btr_disabled_setup" },
    { 0x6CA0230B, "weaver_btr_guys" },
    { 0x185FD582, "weaver_btr_start_moving" },
    { 0x776DBE7C, "weaver_button_press" },
    { 0x45F97E94, "weaver_cache_shotty" },
    { 0xD84318A3, "weaver_callout_dialog" },
    { 0xE9B4AF02, "weaver_cliff_internal" },
    { 0x7ED4223E, "weaver_delta" },
    { 0x95394EB4, "weaver_dist" },
    { 0x07C99386, "weaver_door_in" },
    { 0xF5441D2C, "weaver_door_in_model" },
    { 0x2AE64C4F, "weaver_door_link" },
    { 0x98AB8A57, "weaver_door_open" },
    { 0x57E541E1, "weaver_door_out" },
    { 0xD2412D9B, "weaver_door_out_model" },
    { 0x6C6CBDA2, "weaver_door_snow" },
    { 0x7857056A, "weaver_door_unlink" },
    { 0xD00AFB50, "weaver_dummy" },
    { 0x998798F1, "weaver_dummy_head" },
    { 0xDAF39552, "weaver_end_teleport_spot" },
    { 0x41AAB3B3, "weaver_ent" },
    { 0x248D6E81, "weaver_entered_c4" },
    { 0xBE193BFE, "weaver_eye_blood" },
    { 0x0FBA99CF, "weaver_eyepoke_node" },
    { 0xC0227150, "weaver_fire" },
    { 0x8D017581, "weaver_follow_objective_number" },
    { 0xDC529F82, "weaver_free_fall" },
    { 0x9AFF9A92, "weaver_frontdoor_blocker" },
    { 0x632C2823, "weaver_gas_room" },
    { 0x44BCABB5, "weaver_gasmask_anim" },
    { 0x7884598C, "weaver_guys" },
    { 0x00C82464, "weaver_guys_left" },
    { 0x0EAF085B, "weaver_guys_right" },
    { 0x87D8EDE4, "weaver_headsci_start" },
    { 0x756CB42D, "weaver_height" },
    { 0x2B4E847C, "weaver_heli" },
    { 0x01DF7C2D, "weaver_heli_think" },
    { 0x3C7CF53D, "weaver_ignore_toggler" },
    { 0x7D4192E3, "weaver_in_tunnel_start" },
    { 0x884A9872, "weaver_in_tunnel_start_node" },
    { 0xC0EF4852, "weaver_is_defined" },
    { 0x9E2F26C4, "weaver_is_rescued" },
    { 0xAB006F28, "weaver_jump_hack" },
    { 0xBD776298, "weaver_kill_smoker" },
    { 0x58C8FF17, "weaver_knife" },
    { 0x51AF115D, "weaver_knife_attach" },
    { 0x09401AC3, "weaver_knife_detach" },
    { 0x1C635F95, "weaver_landing" },
    { 0xE6650263, "weaver_landing_struct" },
    { 0x1DF9B975, "weaver_last_stand" },
    { 0xB6838A7A, "weaver_mask_ent" },
    { 0xEBB61E26, "weaver_must_kill" },
    { 0x6F0C4913, "weaver_must_kill_ai" },
    { 0x2272FE16, "weaver_near_security_door" },
    { 0xF8649CFD, "weaver_needs_help_timer" },
    { 0x72DDE3C8, "weaver_node" },
    { 0x81EE297D, "weaver_outsidetunnels_node" },
    { 0xFB9C2142, "weaver_plan_b" },
    { 0x18E6D79D, "weaver_player_hand" },
    { 0xDE164FAD, "weaver_position" },
    { 0x3E302A89, "weaver_postgas_room" },
    { 0x72E9A84E, "weaver_prone" },
    { 0x21BF8BDB, "weaver_pull_up" },
    { 0xEB6F0FE2, "weaver_pullup" },
    { 0x5FE1EB1F, "weaver_rappel_down" },
    { 0xFAD83177, "weaver_rescue" },
    { 0xD0E92642, "weaver_rescue_bowman" },
    { 0x605683E2, "weaver_rescue_brooks" },
    { 0x148B0A8B, "weaver_rescue_truck" },
    { 0x7BC8270C, "weaver_rescue_woods" },
    { 0xF143F967, "weaver_riders" },
    { 0xEB9AE594, "weaver_room_fire" },
    { 0x669EC516, "weaver_set_friendname" },
    { 0xC16906C7, "weaver_show_aug" },
    { 0xB1AEACE5, "weaver_show_knife" },
    { 0x9B0673C7, "weaver_show_pistol" },
    { 0x1C61F037, "weaver_slide_teleport" },
    { 0x15F74D90, "weaver_sniper_spot" },
    { 0x3164DA40, "weaver_snow_hide" },
    { 0x2F2DE197, "weaver_spawned_inseat" },
    { 0x15A862D0, "weaver_spawner" },
    { 0xB32C1310, "weaver_start" },
    { 0xCC8E8980, "weaver_start_shooting" },
    { 0x6953E784, "weaver_stop_shooting" },
    { 0x233E4C3D, "weaver_success_len" },
    { 0x07CE1541, "weaver_take_cover" },
    { 0xF3C98877, "weaver_team" },
    { 0x18FAC21A, "weaver_team_done" },
    { 0xEC73260B, "weaver_team_members" },
    { 0xD73E01A2, "weaver_team_support_done" },
    { 0xF45CCB15, "weaver_teleport" },
    { 0xF528B6A3, "weaver_teleport_rooftop" },
    { 0x50363340, "weaver_trigger" },
    { 0x20EB077C, "weaver_truck_node" },
    { 0x7420E198, "weaver_veh_btr" },
    { 0x2ECDBCF5, "weaver_vomit" },
    { 0x7CA07917, "weaver_vomit_anim" },
    { 0x8CDAD8CE, "weaver_vomit_anims" },
    { 0xD8F003DD, "weaver_wait_for_player" },
    { 0xBE281BC0, "weaver_weapon" },
    { 0xDD6A8C82, "weaver_weapon_swap" },
    { 0x3436A807, "weaver_window_blocker" },
    { 0x9BEEC50C, "weaver_window_break_len" },
    { 0xED1187D8, "weavers" },
    { 0xDB1D0AFD, "web" },
    { 0xAD9A3093, "webbing" },
    { 0xF134D1F0, "webcast" },
    { 0x78A42461, "wedged" },
    { 0xF827A3E5, "week" },
    { 0x55E0C55C, "weekend" },
    { 0x5F05C59F, "weekends" },
    { 0xB5702B28, "weekly" },
    { 0xBFBFF963, "weekly_slot_a" },
    { 0x4DB88A28, "weekly_slot_b" },
    { 0xB2856A56, "weeklyacontractcompleted" },
    { 0x617DBB2E, "weeklyacontractcurrent" },
    { 0x0ACFFFA0, "weeklyacontractid" },
    { 0xBF715A58, "weeklyacontracttarget" },
    { 0xCA3B1A5F, "weeklybcontractcompleted" },
    { 0xCE4322EB, "weeklybcontractcurrent" },
    { 0x2BDD1933, "weeklybcontractid" },
    { 0x9432316F, "weeklybcontracttarget" },
    { 0x39D685F4, "weeks" },
    { 0x5F10CC59, "weepingangel" },
    { 0xD3343868, "wehre" },
    { 0x62341371, "weight" },
    { 0x82D079EA, "weight1" },
    { 0x5CCDFF81, "weight2" },
    { 0x985FCE10, "weight_min" },
    { 0xC4EEB9AD, "weight_threshold" },
    { 0x6F723EC0, "weightarray" },
    { 0x740F8CBE, "weightchangespeed" },
    { 0xCBADC390, "weightchangespeedfast" },
    { 0xE4550F01, "weightchangespeedslow" },
    { 0x2CBD60EB, "weightchangespeedstruggle" },
    { 0x04AA821E, "weighted" },
    { 0x3503EBE1, "weighted_down" },
    { 0x4B6C2694, "weighteddelta" },
    { 0xC69FB2D7, "weighting" },
    { 0xED965D00, "weighting_func" },
    { 0xC4CD8E38, "weightoff" },
    { 0x7A479AF2, "weighton" },
    { 0xB62CEAD8, "weights" },
    { 0xE382E5D9, "weightscale" },
    { 0x39BB48FC, "weird" },
    { 0x8FD776F9, "weirdly" },
    { 0xAC4FBEAF, "welcome" },
    { 0x25094AF1, "weld_cover" },
    { 0xE5218A50, "weld_door" },
    { 0x44B600DC, "welder" },
    { 0xB0869D14, "welder_alerted" },
    { 0x89F299F2, "welder_ent" },
    { 0x41C93310, "welder_react" },
    { 0x353AFF98, "welder_sound" },
    { 0x11FAC044, "welder_stopanim" },
    { 0xD8B2701F, "welders" },
    { 0x708C23DB, "welding" },
    { 0xD9615B64, "welding_fx" },
    { 0x701C7FDD, "welding_stopped" },
    { 0x3A8EE709, "welding_time" },
    { 0x8259964C, "welds" },
    { 0xED8D8A15, "well" },
    { 0x73447AB0, "welldistancedamount" },
    { 0xF5454AF5, "wellll" },
    { 0xDE477527, "went" },
    { 0x33943BD9, "weoptions" },
    { 0xF39154A8, "wep_xpos" },
    { 0x2AAB2EBB, "wep_ypos" },
    { 0x1CE677FA, "wepaon_for_diamond" },
    { 0x7C971756, "wepbox" },
    { 0x0F62B28D, "wepbox_players" },
    { 0xC193EC46, "weps" },
    { 0xFE52CC2A, "were" },
    { 0xCB942E94, "werent" },
    { 0x459639D8, "west" },
    { 0xC964EFAA, "west_balcony_zone" },
    { 0x3391782C, "west_spawners" },
    { 0xE3B74048, "west_target" },
    { 0xD8E7D94D, "west_walkway" },
    { 0xDDB055EF, "west_walkway_support_east" },
    { 0xF0D12ED1, "west_walkway_support_north" },
    { 0x6B879702, "west_walkway_support_northeast" },
    { 0x2A5A0240, "westbound" },
    { 0xA3F7EA39, "western" },
    { 0x96A8CA85, "westportion" },
    { 0x2EF06F9B, "wet" },
    { 0xB36E2FD9, "wet_spawnfunc" },
    { 0x3E823D12, "wetdiff" },
    { 0xD47F6DC0, "wether" },
    { 0x9C7D2FE3, "wetlevel" },
    { 0xFDD0A87A, "wetness" },
    { 0xFA89F8A9, "wetness_monitor" },
    { 0x70A85667, "wetness_on_ai" },
    { 0xA8F6FE0F, "wetperframe" },
    { 0x3CAEC19E, "wf" },
    { 0x275DB4CD, "wfo" },
    { 0xD2C97974, "wg_st_dn" },
    { 0x288C0FE0, "wh" },
    { 0x48560B91, "whackamole" },
    { 0x4B08613A, "whackamole_death" },
    { 0x7D9BE234, "whackamole_dialog" },
    { 0x2CB51EFE, "whackamole_lastspeak" },
    { 0x0F3314F3, "whackamole_off" },
    { 0x4A7DD3DF, "whackamole_on" },
    { 0x2F79A335, "whackamole_unload" },
    { 0xA025B1CE, "whackamolecount" },
    { 0x43F61325, "whackamoleguys" },
    { 0xFF692DB9, "whackamolethread" },
    { 0x5413557F, "what" },
    { 0x98A75BAE, "what_killed_me" },
    { 0x712B567F, "what_kind_animal_vo" },
    { 0x6DBA3082, "what_to_gib" },
    { 0xCF33FA2A, "whatch" },
    { 0x96767B6F, "whatever" },
    { 0x56AE891E, "whatnot" },
    { 0x1EABD086, "whats" },
    { 0x1EE72AF2, "whats_my_vision" },
    { 0x301E7B55, "whats_that_noise" },
    { 0x0F347C3C, "whats_that_noise_anim_guards" },
    { 0x420315CC, "whats_that_noise_anim_woods" },
    { 0x8205F6B7, "whats_that_noise_player" },
    { 0x5E17A935, "whatsoever" },
    { 0xB8F6E2DE, "wheat" },
    { 0x5B8D5CE1, "wheat_field_triggers" },
    { 0xBE994A32, "wheel" },
    { 0x250EFB17, "wheel_fx" },
    { 0xCFBE60E6, "wheel_left" },
    { 0x8B6AAB6B, "wheel_names" },
    { 0xAEC3BD7D, "wheel_right" },
    { 0x6B26776A, "wheel_tag_names" },
    { 0xA9D80788, "wheel_turn_left" },
    { 0x171318D7, "wheel_turn_right" },
    { 0x015E31B7, "wheelbarrow" },
    { 0x41487D3D, "wheelbarrow_anim" },
    { 0x8309B5C5, "wheelchair" },
    { 0x82E8E7F6, "wheelcounts" },
    { 0xFD48F967, "wheeldir" },
    { 0x250D5A6D, "wheeldirectionchange" },
    { 0x7A0C9045, "wheeled" },
    { 0xA1E82AFC, "wheelorg" },
    { 0xB725ABBD, "wheels" },
    { 0x84E97254, "wheels_down" },
    { 0x8E286050, "wheels_shot" },
    { 0x978CEC27, "wheels_up" },
    { 0xABAFECEE, "wheetfield" },
    { 0x9BCBA4B8, "whelp_no_power_up_pickup" },
    { 0x04E66259, "when" },
    { 0xF40ABAC4, "when_hit_play_fall" },
    { 0xE85F4564, "when_last_killed" },
    { 0x40C659F6, "whene" },
    { 0x5A8A59A1, "whenever" },
    { 0x96F38842, "where" },
    { 0x149AAE1E, "where_am_i_in_relation_to_flr2_blue" },
    { 0x7F409B8B, "where_to_draw" },
    { 0x03E3EF36, "whereas" },
    { 0x1428CC1A, "whereever" },
    { 0xD8703955, "wherever" },
    { 0xADB6AB28, "whether" },
    { 0xAED014A8, "whew" },
    { 0xE81B1E70, "which" },
    { 0xB039EB68, "which_anim" },
    { 0x74966B14, "which_ball" },
    { 0x6F13BECC, "which_board_pull_type" },
    { 0x9D7A848B, "which_button" },
    { 0x85542410, "which_color" },
    { 0x17013BCB, "which_eating_anim" },
    { 0x4365B78D, "which_flag" },
    { 0xF5DC06BE, "which_generator" },
    { 0x1DD09BE7, "which_gun" },
    { 0xC9A090D1, "which_idle" },
    { 0xF42E001D, "which_line" },
    { 0x60EBB463, "which_melee_to_use" },
    { 0x6CBBD3C8, "which_player" },
    { 0x1DE85DD1, "which_set" },
    { 0x67621180, "which_target" },
    { 0x45769544, "which_wave" },
    { 0x6B98D6E2, "which_way_vo" },
    { 0x25A93221, "whichbit" },
    { 0x4FAA45A0, "whichbomb" },
    { 0x63A7D0A8, "whichever" },
    { 0x33B93FFC, "whichfoot" },
    { 0x5D292885, "whichfootnotetrack" },
    { 0xFEA4A389, "whichgroup" },
    { 0xDC9097FE, "whichgun" },
    { 0x9F4B55B3, "whichhand" },
    { 0x1B3BDA60, "while" },
    { 0xDEEE70A6, "whilst" },
    { 0xC5C33B11, "whirlwind_attract_anim" },
    { 0xC037051E, "whirlwind_attract_anim_watch_cancel" },
    { 0x94D27F4F, "whirlwind_drag_zombie" },
    { 0xD9F31092, "whirlwind_fast" },
    { 0x6491E52C, "whirlwind_kill_zombies" },
    { 0x693D397C, "whirlwind_move_zombie" },
    { 0x7E617481, "whirlwind_normal" },
    { 0x8B1B140C, "whirlwind_rumble_nearby_players" },
    { 0x8B5B43ED, "whirlwind_rumble_on" },
    { 0x1F0A611D, "whirlwind_rumble_player" },
    { 0x54FE3F04, "whirlwind_seek_zombies" },
    { 0xF5070E09, "whirlwind_speed" },
    { 0x4BD80403, "whirlwind_stopped" },
    { 0x27D095F1, "whirlwind_timeout" },
    { 0xD3E3534D, "whirlwind_unlink" },
    { 0x4ACFD715, "whiskey" },
    { 0x007654CD, "whisper" },
    { 0x7DD67E59, "whisper_radio" },
    { 0xA9D786BA, "whisper_radio_origin" },
    { 0xC58D0C3A, "whisper_radio_trig" },
    { 0xF606504C, "whispers" },
    { 0x78815D75, "whistle" },
    { 0xFF9F74E8, "white" },
    { 0xF3162632, "white_bg" },
    { 0xEB3A31EE, "white_bloom_in" },
    { 0x1CB15249, "white_bloom_out" },
    { 0x32A954A1, "white_fade_in" },
    { 0xEC7B3178, "white_fade_out" },
    { 0x4F1B96B1, "white_fade_post_liftoff" },
    { 0x123711EB, "white_flash" },
    { 0xAB42B87D, "white_out_delay" },
    { 0xC82D9B19, "white_overlay" },
    { 0x6CC4EA30, "white_screen_flash" },
    { 0x7C52A538, "white_truck" },
    { 0x999C0194, "white_val" },
    { 0x6F280EEA, "whitefade" },
    { 0xE9FB6BCC, "whiteflashfade" },
    { 0x9CE4DAF5, "whitein" },
    { 0x846E8740, "whitelist" },
    { 0x20DC27CB, "whitenoise_handler" },
    { 0x25ED89D4, "whiteout" },
    { 0x8E44B024, "whitescreen" },
    { 0xA8859215, "whitney" },
    { 0x982C9BF4, "whittled" },
    { 0x76D6F0F9, "whiz" },
    { 0xE5D31B43, "whiz_by_sound" },
    { 0xB222A803, "whizbie" },
    { 0x751A0372, "whizbies" },
    { 0x13497B1A, "whizby" },
    { 0xB0D1F615, "whizbys" },
    { 0xB818C2CE, "whizzed" },
    { 0x534438A7, "whizzing" },
    { 0xAEF176E7, "who" },
    { 0x66CC661C, "whoa" },
    { 0xED033F57, "whoever" },
    { 0x6E31C636, "whole" },
    { 0xAF6CC791, "whole_team_reached" },
    { 0xE9467C54, "wholepiece" },
    { 0x2EE239A9, "wholeteamhastoreach" },
    { 0xA479A2C3, "wholethe" },
    { 0x9EAEA930, "whom" },
    { 0xDB2F27B4, "whooaah" },
    { 0x6B24DD8E, "whooh" },
    { 0x58D69CBF, "whoosh_distance" },
    { 0x0C923AA1, "whoosh_distance_squared" },
    { 0xC8AE3453, "whopos" },
    { 0xBF1357D8, "whore" },
    { 0x52A9B45E, "whos" },
    { 0x9A883701, "whos_who_client_setup" },
    { 0xF545A4BD, "whos_who_effects_active" },
    { 0x9D337BA8, "whos_who_self_revive" },
    { 0xD5AA6C1D, "whos_who_shader" },
    { 0xFC456CA7, "whose" },
    { 0x059C0D82, "whoswho" },
    { 0xFD83DB18, "whoswho_laststand_func" },
    { 0x2B0A3F01, "why" },
    { 0xF79B8F32, "wiat" },
    { 0xBC8CDB48, "wicked" },
    { 0xEA666D10, "wide" },
    { 0x98ADFA31, "wide_idle" },
    { 0xBB6A4B92, "wider" },
    { 0xE57310FC, "widescreen" },
    { 0x6CC1A1C3, "widget_on" },
    { 0x04E0B5BC, "widget_toggle" },
    { 0xDABEE768, "widows" },
    { 0x9BF3A7FC, "widows_wine" },
    { 0xBB108B89, "widows_wine_1p_contact_explosion" },
    { 0x617A36AA, "widows_wine_1p_contact_explosion_play" },
    { 0x7BB38938, "widows_wine_1p_explosion" },
    { 0x598F5475, "widows_wine_bowie_knife" },
    { 0xA8110EE4, "widows_wine_client_field_func" },
    { 0x3EEBF9F0, "widows_wine_cocoon" },
    { 0xC3A073AF, "widows_wine_cocoon_duration" },
    { 0xC8522FD1, "widows_wine_cocoon_fraction" },
    { 0x5D07070A, "widows_wine_cocoon_fraction_rate" },
    { 0x6695B280, "widows_wine_cocoon_max_score" },
    { 0x7D6079A1, "widows_wine_cocoon_radius" },
    { 0x38F491DC, "widows_wine_cocoon_radius_sq" },
    { 0x80EAE695, "widows_wine_cocoon_zombie" },
    { 0x125AD71E, "widows_wine_cocoon_zombie_score" },
    { 0xA8DD76A3, "widows_wine_code_callback_func" },
    { 0x8A3844CD, "widows_wine_contact_explosion" },
    { 0x89BC44DD, "widows_wine_contact_explosion_count" },
    { 0xB14A83BE, "widows_wine_damage_callback" },
    { 0x7CEA6341, "widows_wine_elemental_speed_override" },
    { 0x32C07555, "widows_wine_fx_file_machine_light" },
    { 0xCDFB37E9, "widows_wine_fx_file_wrap" },
    { 0xD4AD9D4E, "widows_wine_fx_machine_light" },
    { 0xF0EDA1A4, "widows_wine_fx_wrap" },
    { 0xE862722B, "widows_wine_grenade" },
    { 0xEB83E0DF, "widows_wine_kill" },
    { 0xBC532C62, "widows_wine_knife" },
    { 0x82AEE9E9, "widows_wine_knife_override" },
    { 0xD54B79F5, "widows_wine_machine_active_model" },
    { 0xBC3B3127, "widows_wine_machine_disabled_model" },
    { 0xE37E107E, "widows_wine_name" },
    { 0xF10D5DE3, "widows_wine_override_melee_wallbuy_purchase" },
    { 0xDE1AA818, "widows_wine_override_wallbuy_purchase" },
    { 0x37C7ACA1, "widows_wine_perk_activate" },
    { 0x3B51BA6D, "widows_wine_perk_bottle_weapon" },
    { 0x454A7FF1, "widows_wine_perk_cost" },
    { 0x8C83D1F8, "widows_wine_perk_lost" },
    { 0xCFEB1583, "widows_wine_perk_machine_setup" },
    { 0x748C9620, "widows_wine_precache" },
    { 0x5EEDAE98, "widows_wine_precache_override_func" },
    { 0x0CF67770, "widows_wine_radiant_machine_name" },
    { 0xE2F1D962, "widows_wine_register_clientfield" },
    { 0x7242DB2B, "widows_wine_set_clientfield" },
    { 0xAC024E2C, "widows_wine_shader" },
    { 0xF05BD51E, "widows_wine_sickle_knife" },
    { 0x522B4934, "widows_wine_slow" },
    { 0x75AD1D3B, "widows_wine_slow_duration" },
    { 0x10C15D55, "widows_wine_slow_fraction" },
    { 0x5A589BCE, "widows_wine_slow_fraction_rate" },
    { 0x70ADAA4C, "widows_wine_slow_max_score" },
    { 0xC1AFA085, "widows_wine_slow_radius" },
    { 0x9345FE50, "widows_wine_slow_radius_sq" },
    { 0x8FA0E331, "widows_wine_slow_zombie" },
    { 0x782E2C12, "widows_wine_vehicle_behavior" },
    { 0x6BE80E33, "widows_wine_vehicle_damage_response" },
    { 0xC48ACB49, "widows_wine_wrap_cb" },
    { 0xCBE4E863, "widows_wine_zombie_damage_response" },
    { 0xADF37A5E, "widows_wine_zombie_death_watch" },
    { 0xD0BAE973, "width" },
    { 0xBE27D357, "width_fps" },
    { 0x688A5250, "width_mult" },
    { 0xF5AF18EF, "width_rts" },
    { 0xC55B2A1E, "wield" },
    { 0x66843A8D, "wield_fn" },
    { 0x0618E090, "wield_gravityspikes" },
    { 0xEBB14561, "wielded" },
    { 0xC289F674, "wierd" },
    { 0xEC1B3545, "wierdness" },
    { 0xED37A0BA, "wife" },
    { 0x48955602, "wiggle" },
    { 0x9D7C3B88, "wight" },
    { 0xBDC456EA, "wii" },
    { 0x0F21B16F, "wii_audio_testmap_amb" },
    { 0xC3145DAC, "wii_show_hide_weapon_1" },
    { 0x351BCCE7, "wii_show_hide_weapon_2" },
    { 0x1D7433BC, "wii_wait_to_spawn_clock_gunners" },
    { 0x548456D3, "wiiu" },
    { 0x5F23FA49, "wiki" },
    { 0x8C84B36A, "wikipedia" },
    { 0x7BD0BAF7, "wil" },
    { 0x39513DCD, "wilco" },
    { 0x897A5091, "wild" },
    { 0x8A7D9E07, "wildcard" },
    { 0x90E9E5FE, "wildcards" },
    { 0xC2B46297, "wildfie" },
    { 0xF098C925, "wildfire" },
    { 0x258C06FC, "wildly" },
    { 0xAEA0C25E, "wilkins" },
    { 0x59667D49, "will" },
    { 0x50612C3E, "will_die" },
    { 0xE3C3C31B, "will_hit" },
    { 0x2389CC09, "will_hit_target" },
    { 0x01F7D622, "will_upgrade_weapon_as_attachment" },
    { 0x4E446605, "willbekilled" },
    { 0x6FD17E30, "willbewithinrangewhengunisraised" },
    { 0x2C478A7F, "willcleanup" },
    { 0x82C47BCE, "willfall" },
    { 0xDE9F849B, "williams" },
    { 0x04EF01FF, "willing" },
    { 0x998E2B3F, "willrespawnimmediately" },
    { 0x4F6706E8, "willypetedamageheight" },
    { 0x54E7FE0F, "willypetedamageradius" },
    { 0x51CFD855, "willypeteinnerdamage" },
    { 0xB002964C, "willypeteouterdamage" },
    { 0x32F24055, "willys" },
    { 0x2FCBC625, "win" },
    { 0x3FE582F6, "win_limit_logic" },
    { 0xD63EA1FF, "win_limit_value" },
    { 0x35E6E8D2, "win_time_duration" },
    { 0x8291EE86, "win_time_start" },
    { 0xBABF8EBA, "winanim" },
    { 0x89D11B3B, "wind" },
    { 0x57BD250E, "wind_bunker_collision_off" },
    { 0x81D11860, "wind_bunker_collision_on" },
    { 0x5402366A, "wind_calm_setting" },
    { 0x646FE7F2, "wind_changed" },
    { 0x98105149, "wind_damage_cone" },
    { 0x04F7EC53, "wind_driving" },
    { 0x1B6C461D, "wind_ent" },
    { 0xDC5EED64, "wind_flag" },
    { 0x1D62A971, "wind_flag_rotation" },
    { 0x1EE64513, "wind_goatpath_setting" },
    { 0x1DE3A805, "wind_heavy_snd_ent" },
    { 0xDC0E013E, "wind_high" },
    { 0x940F11CD, "wind_id" },
    { 0xD08AE168, "wind_init" },
    { 0x26AE781B, "wind_initial_setting" },
    { 0xF69D08D8, "wind_low" },
    { 0xC2DC6E7C, "wind_max" },
    { 0x3FF12C72, "wind_min" },
    { 0x6A0B30DB, "wind_script" },
    { 0x03672D5A, "wind_setting" },
    { 0xEE545C55, "wind_settings" },
    { 0x04433BF3, "wind_shake_time_max" },
    { 0x872E7DFD, "wind_shake_time_min" },
    { 0x2D5F039D, "wind_snd_ent" },
    { 0xAA98151A, "wind_sounds" },
    { 0xE09DC86D, "wind_still_setting" },
    { 0xEF128D90, "wind_stops_flunctuating" },
    { 0xCDD4BEEC, "wind_trig" },
    { 0x232F9216, "wind_trigger" },
    { 0xCF5EAC88, "wind_vec" },
    { 0xA95C321F, "wind_vel" },
    { 0x096C3E1B, "windchange" },
    { 0x21589F37, "windcontroller" },
    { 0xD8DC2E9A, "winddirection" },
    { 0x676595B0, "winded" },
    { 0xDBEE3AFD, "windmill" },
    { 0x1A0F763C, "windmill_whoosh_setup" },
    { 0xD797C71D, "window" },
    { 0x7B62EBEE, "window1" },
    { 0x7636C51A, "window1_damaged" },
    { 0x55607185, "window2" },
    { 0x1B75BDD5, "window2_damaged" },
    { 0x2F5DF71C, "window3" },
    { 0x9C7D89A9, "window_1" },
    { 0x3C161D6B, "window_1_ent" },
    { 0xC2800412, "window_2" },
    { 0x0032CDC8, "window_2_ent" },
    { 0xE8827E7B, "window_3" },
    { 0x26740D5D, "window_3_ent" },
    { 0xF6F12733, "window_ambient_anims" },
    { 0x4735109B, "window_boards" },
    { 0x50DB17A7, "window_breach" },
    { 0xDA384CD1, "window_breach_functions" },
    { 0x3F8E076C, "window_breached" },
    { 0x4BA0655D, "window_break" },
    { 0xF1C8EABE, "window_break_pos" },
    { 0x22806E9A, "window_breech_reverb" },
    { 0x41A71551, "window_bullet_trigger" },
    { 0x82BD8054, "window_bullets_on_exit" },
    { 0xEA15EB42, "window_clouds" },
    { 0xB86CA04B, "window_crash_anim" },
    { 0x3A20346C, "window_damage_fx" },
    { 0x5CFAEBF4, "window_down" },
    { 0xC9625E4A, "window_down_height" },
    { 0xBAE599C8, "window_enemies" },
    { 0x6A673A09, "window_enemies_respond_to_attack" },
    { 0x8834A3F0, "window_entries" },
    { 0xA5A759A7, "window_frame" },
    { 0x153F592D, "window_guard_hit" },
    { 0xC7276031, "window_jumper" },
    { 0x0717AC63, "window_look_safe" },
    { 0x3E157B3F, "window_ls" },
    { 0x687A26C7, "window_main" },
    { 0xF0D07515, "window_mg_spawner" },
    { 0x1EEEDE10, "window_notetracks" },
    { 0x3B2452B4, "window_panzer" },
    { 0xDF365F40, "window_panzer_behaviour" },
    { 0x6400EC97, "window_panzer_fire" },
    { 0x14ABD084, "window_panzer_target" },
    { 0xD37556FA, "window_panzer_target_ent" },
    { 0x9D5FDB7E, "window_pos" },
    { 0xE6E48977, "window_pulse_points" },
    { 0xB989DA02, "window_pulses" },
    { 0xB5FAF735, "window_reflection_blur" },
    { 0xAF1B1BC9, "window_reminder_thread" },
    { 0x824E0EDD, "window_rs" },
    { 0x0653732F, "window_rumble" },
    { 0x4FEC541F, "window_rumble2" },
    { 0x29E9D9B6, "window_rumble3" },
    { 0x62FDE267, "window_safe" },
    { 0xD933086F, "window_shutter" },
    { 0x5F3B7731, "window_smash_wind_sound" },
    { 0xA54E4E4C, "window_snapshot" },
    { 0x75343B29, "window_swap" },
    { 0x1BF5DC96, "window_table_flip" },
    { 0xA98E9D30, "window_tag" },
    { 0x22B3C41B, "window_target" },
    { 0x1EF6542A, "window_target_move_loop" },
    { 0x6C531351, "window_throw_glass_break" },
    { 0x28C1820A, "window_throw_started" },
    { 0x02C38397, "windowdive" },
    { 0xEEEFA1E2, "windowdive_start" },
    { 0x2B3E0B6B, "windowfx" },
    { 0xBBF86B82, "windowfxspots" },
    { 0xAFFC915C, "windows" },
    { 0x889E3F70, "windows_destroyed" },
    { 0x1142D182, "windows_off" },
    { 0xBA3FC3F4, "windows_on" },
    { 0x9D7FAF2E, "windowshoot" },
    { 0x1DB39F0F, "windowshoot_start" },
    { 0xA4A8F3C8, "windowshout" },
    { 0x5BC31AFF, "windowtrig" },
    { 0x1B188883, "windowtrigger" },
    { 0xF189D3F1, "windrate" },
    { 0xB0532BD4, "windshield" },
    { 0x3FA8123E, "windshield_swap" },
    { 0x10A21583, "windsock" },
    { 0x99A1F0F4, "windstrength" },
    { 0x046AA7D7, "windweight" },
    { 0x63CEA0D2, "wine" },
    { 0x17C9AC00, "wing" },
    { 0x683C046F, "wing_climb_dialogue" },
    { 0x6812EFBD, "wing_dmg" },
    { 0xD9E8F9E6, "wing_forward" },
    { 0xC8D94BE7, "wing_rush_failsafe" },
    { 0x2544477A, "wing_sound_ent" },
    { 0xF19CCFDC, "wing_start_trigger" },
    { 0x61B2FFE6, "wing_tip_fx_l" },
    { 0x4D904E28, "wing_tip_fx_r" },
    { 0x1413D713, "wing_tip_l" },
    { 0xCFDD520D, "wing_tip_r" },
    { 0xAD6B7AD8, "wing_up" },
    { 0x2DBC7793, "winged" },
    { 0x2548E342, "wingleft_dmg" },
    { 0xB996420C, "wingman" },
    { 0x73DBEED2, "wingman_getgoalpos" },
    { 0x82EA3FFD, "wingman_think" },
    { 0xD6817ABB, "wingmanbaseacceleration" },
    { 0x8FEB6AF6, "wingmanbasedeceleration" },
    { 0x4569C18F, "wingmans" },
    { 0x8E90DD3D, "wingmanspeed" },
    { 0x22F0247D, "wingmanspeedscale" },
    { 0x0D490758, "wingmen" },
    { 0xBFF77AD3, "wingright_dmg" },
    { 0x8596C12B, "wings" },
    { 0x6BBEB780, "wingspan" },
    { 0x20E089CB, "wingsuit" },
    { 0x7975ADFA, "wingsuit_ai_setup" },
    { 0xC8FDE628, "wingsuit_anims" },
    { 0xF3D8C149, "wingsuit_breadcrumb_objective" },
    { 0x59C78AFB, "wingsuit_collision_check" },
    { 0x34A8037D, "wingsuit_deploy_chute" },
    { 0x6530D25C, "wingsuit_deploy_chute_fail" },
    { 0x6295D2FF, "wingsuit_follow_player" },
    { 0xA3294DB4, "wingsuit_fx" },
    { 0x4A91BC7A, "wingsuit_landing_done" },
    { 0x225ACD91, "wingsuit_main" },
    { 0xA11F8190, "wingsuit_player_landed" },
    { 0x816C074F, "wingsuit_speed" },
    { 0xB05A9D84, "wingsuit_speed_ai" },
    { 0x55BD975B, "wingsuit_squad_jump" },
    { 0xD1B5242A, "wingsuits" },
    { 0xF49BAB78, "winner" },
    { 0xD9C82FEA, "winner_text" },
    { 0x154AA99F, "winnerenum" },
    { 0x4B973E3E, "winnerscale" },
    { 0xA8831F0E, "winnerscore" },
    { 0x151B477B, "winnersize" },
    { 0x657DFF17, "winning" },
    { 0x867AB0ED, "winning_team" },
    { 0x8D0787EC, "winning_teams" },
    { 0x1CACA44D, "winningfinal" },
    { 0xE9B87998, "winningplayer" },
    { 0xD2F02D53, "winningreason" },
    { 0x2194CACE, "winnings" },
    { 0xC6CA6BDE, "winningssplit" },
    { 0xBB0667AC, "winningteam" },
    { 0xE2C83E60, "winningteamindex" },
    { 0x8A2EFFC4, "winningtime" },
    { 0x6116EEF7, "winnt" },
    { 0x0FFB3C34, "wins" },
    { 0xBA308263, "winstreak" },
    { 0x0132443A, "winterdark" },
    { 0xB3615D92, "winterlight" },
    { 0x71DAA6B9, "winters" },
    { 0xCE8A162D, "wintype" },
    { 0x538B577B, "wip" },
    { 0x4F6537FE, "wip_start" },
    { 0x30743E7C, "wipe" },
    { 0x03984A46, "wipe_count_per_frame" },
    { 0xB824B421, "wipe_volume" },
    { 0x6BE25AF0, "wiped" },
    { 0x3707D708, "wipeout" },
    { 0x33457226, "wire" },
    { 0x22CC1FEB, "wire1" },
    { 0x1E3CFF75, "wire1_fx1" },
    { 0x443F79DE, "wire1_fx2" },
    { 0xB0C4B0B0, "wire2" },
    { 0xA3559911, "wire2_fx2" },
    { 0xD6F61263, "wire_fx" },
    { 0xC8D24916, "wire_fx_done" },
    { 0x573FF78C, "wire_model" },
    { 0x816A1FB0, "wire_path" },
    { 0x1B4C1687, "wire_qualifier" },
    { 0x857D1E31, "wire_render" },
    { 0x6C9B8DAA, "wire_restart" },
    { 0x062FCBED, "wire_snap" },
    { 0xC8F3C1B2, "wire_struct" },
    { 0xAE7D299D, "wire_sway_01" },
    { 0xD47FA406, "wire_sway_02" },
    { 0xFA821E6F, "wire_sway_03" },
    { 0xF070C590, "wire_sway_04" },
    { 0xB54A82D6, "wired" },
    { 0x0A0DEFC7, "wiremodelnames" },
    { 0xE521940F, "wireorigins" },
    { 0x5765C559, "wires" },
    { 0x680B8A22, "wires1" },
    { 0x42090FB9, "wires2" },
    { 0x9FDA9073, "wires_move" },
    { 0x79870593, "wires_multi" },
    { 0x8A70937A, "wires_pistons" },
    { 0x552CF590, "wires_single" },
    { 0x70342049, "wires_slack_start" },
    { 0xF2191C79, "wires_spool" },
    { 0xEA7B18B4, "wires_stop" },
    { 0x5126EAAA, "wirespark_long" },
    { 0x063D76B2, "wirespark_med" },
    { 0x39CC6BFD, "wirewander" },
    { 0xF151D633, "wirh" },
    { 0x4063B3AD, "wise" },
    { 0xB26B22E8, "wish" },
    { 0x44D1A9F4, "wishes" },
    { 0x6BC71540, "wishlist" },
    { 0xF754CAA6, "wisp_move_from_sign_to_start" },
    { 0x689DAFDF, "wisp_stage_complete" },
    { 0x6ABA09F5, "with" },
    { 0x0E9B8016, "with_col" },
    { 0x20D9C880, "with_data" },
    { 0xD43877E3, "with_trace" },
    { 0x192F8C42, "withaoe" },
    { 0xA8B5614F, "withdraw" },
    { 0xC477F5FA, "withdraw_spot" },
    { 0xE83C7B10, "withdraw_trig" },
    { 0xFC84091D, "withdraw_triggers" },
    { 0x49733D83, "withdrawal_amount" },
    { 0x1831BEB8, "withdrawal_fees" },
    { 0x160E92C8, "withdrawal_number" },
    { 0xBC42CBE1, "withdrawl" },
    { 0xEA13B616, "withdraws" },
    { 0xDDC19F64, "wither" },
    { 0x194E5E14, "within" },
    { 0xF6315DE6, "within_array" },
    { 0xF75E10A5, "within_attack_range" },
    { 0x22FF7FF0, "within_fov" },
    { 0x6CE577B2, "within_range" },
    { 0x05498673, "withing" },
    { 0xBF5AEAA5, "withinprimaryrange" },
    { 0x37028453, "withinrange" },
    { 0x10C81609, "withinrangenow" },
    { 0xA84C7469, "withinsecondaryrange" },
    { 0x792C8ACB, "without" },
    { 0x73B62353, "withstand" },
    { 0xBAFE1EDE, "witness" },
    { 0xA973749E, "witnesses" },
    { 0x25F62244, "wjb" },
    { 0xB2D62DA3, "wl_clear_stored_weapondata" },
    { 0xAAAC31F8, "wl_get_stored_weapondata" },
    { 0x3FB22DB4, "wl_has_stored_weapondata" },
    { 0x53650CD4, "wl_set_stored_weapondata" },
    { 0x1606AD13, "wmd" },
    { 0x58ABE382, "wmd_ai_reset_on_goal" },
    { 0x8C06A256, "wmd_amb" },
    { 0x6593CE39, "wmd_anim" },
    { 0xBA8F8CD3, "wmd_approach_radar" },
    { 0xF08224C5, "wmd_art" },
    { 0xE9A9E7D5, "wmd_base" },
    { 0x4F0CDDB9, "wmd_basejump" },
    { 0x4B49D73F, "wmd_clean_up_pathing_vehicles" },
    { 0x8501B9E8, "wmd_dialogue" },
    { 0xA2E1579F, "wmd_event1" },
    { 0x30D9E864, "wmd_event2" },
    { 0xD63DC88D, "wmd_events" },
    { 0x5042254C, "wmd_fx" },
    { 0xF80F80C7, "wmd_fx_org" },
    { 0xBBB9638C, "wmd_intro" },
    { 0xAF6CEB85, "wmd_intro_cleanup" },
    { 0x56629451, "wmd_obj_escape" },
    { 0x3C8B225C, "wmd_obj_infiltrate" },
    { 0xE368D78F, "wmd_obj_insertion" },
    { 0x428FFFD7, "wmd_obj_jump_point" },
    { 0x7F3751B4, "wmd_obj_personnel_a" },
    { 0xF13EC0EF, "wmd_obj_personnel_b" },
    { 0xC9746B9C, "wmd_obj_radar" },
    { 0xFD3B6C2E, "wmd_obj_steiner" },
    { 0xCF5CB4E2, "wmd_obj_substation" },
    { 0xAB9E64A1, "wmd_obj_truck" },
    { 0xABFD876E, "wmd_objectives" },
    { 0x431FBA80, "wmd_player_rappel" },
    { 0x7320BF26, "wmd_radar" },
    { 0x782DF94F, "wmd_rts" },
    { 0x171D8FCA, "wmd_snow_hide" },
    { 0x119E2DFD, "wmd_sr71" },
    { 0xCFD7C1E8, "wmd_sr71_amb" },
    { 0x054DCAEF, "wmd_sr71_anim" },
    { 0xD1FF954F, "wmd_sr71_art" },
    { 0x94FD3129, "wmd_sr71_barracks" },
    { 0x23C48F0A, "wmd_sr71_fx" },
    { 0x839AE5B9, "wmd_sr71_safehouse" },
    { 0xFCB15D84, "wmd_sr71_start" },
    { 0xE3F16224, "wmd_sr71_util" },
    { 0xEE9E119A, "wmd_sr71_win" },
    { 0x70F3047A, "wmd_util" },
    { 0x86E2A514, "wmd_voice" },
    { 0xCF8D09B8, "wmill_sfx_setup" },
    { 0x31B83F65, "wnd_guard_in_pos" },
    { 0xBAD80D94, "wnf" },
    { 0xE5E867B5, "wng_st" },
    { 0x9027335E, "wnuen" },
    { 0x2CF4D1DA, "wnuen_bridge" },
    { 0x69EFC24F, "wnuen_bridge_clip" },
    { 0x5F42BBAB, "wnuen_bridge_coils" },
    { 0xA0C2C684, "woah" },
    { 0x5E8566FE, "wobble" },
    { 0x5A4F431E, "wobble_game_mode_objects" },
    { 0x3CE5AC3E, "wobble_speed" },
    { 0x40B635A0, "wods" },
    { 0x7F10824B, "woflhead_idle_anims" },
    { 0xB9AFBE4B, "woken" },
    { 0xD5814055, "wolf" },
    { 0xA229BEDB, "wolf_encounter_vo_played" },
    { 0x33BE39C4, "wolf_head_model" },
    { 0x8ADFFEAC, "wolf_head_model_string" },
    { 0xDD98516B, "wolf_head_removal" },
    { 0x4E6E0DF8, "wolf_intro_anim_complete" },
    { 0x66E015D8, "wolf_kill_cooldown" },
    { 0xBB478D9D, "wolf_kill_cooldown_watcher" },
    { 0x0D370C56, "wolf_kill_vo_cooldown" },
    { 0x531BA80E, "wolf_spit_out_powerup" },
    { 0xABE97F6D, "wolfhead_body_anims" },
    { 0x98471769, "wolfhead_body_death" },
    { 0x60719461, "wolfhead_body_float" },
    { 0x24C29626, "wolfhead_body_shrink" },
    { 0xFD428B47, "wolfhead_eat_anims" },
    { 0x90D6EEF8, "wolfhead_idle_anim" },
    { 0x98FB7AC8, "wolfhead_intro_anim" },
    { 0x87365095, "wolfhead_outtro_anim" },
    { 0xF787F40D, "wolfhead_pre_eat_anims" },
    { 0xE7A6039D, "wolves" },
    { 0x765294DD, "woman" },
    { 0x3D4DE01E, "woman_gun" },
    { 0x79DE5618, "woman_gun_anim_model" },
    { 0x88784BCC, "woman_setup_gun" },
    { 0x229FCF91, "women" },
    { 0x112A1043, "won" },
    { 0x5A31E636, "won_hand_2_hand" },
    { 0x4D66A56C, "wonder" },
    { 0x47B8E39C, "wondering" },
    { 0xD5D7976F, "wonders" },
    { 0x3BA71B7E, "wonkiness" },
    { 0xC107C3ED, "wont" },
    { 0x6C749FFA, "wont_disable_player_firing" },
    { 0xEB2795DA, "woo" },
    { 0x3059152A, "wood" },
    { 0x0C1724F7, "wood1" },
    { 0x9A0FB5BC, "wood2" },
    { 0x325C735D, "wood_axe_physics" },
    { 0x6F4F4642, "wood_bridge_rocket_clip_notify" },
    { 0xE11DCAFC, "wood_dest_node" },
    { 0xE6A6557D, "wood_fire" },
    { 0xEE6588B7, "wood_groans" },
    { 0xA42DBAD4, "wood_horse" },
    { 0xBB638F1F, "wood_think" },
    { 0x2F5A99CE, "wood_time" },
    { 0xACECE713, "woodbeam" },
    { 0x327BB005, "woodbridge" },
    { 0xE7574E0B, "woodbridge_destroy_collision" },
    { 0x451D89D9, "woodbridge_destroyed" },
    { 0x18BB0284, "woodbridge_explosion_start" },
    { 0xCEB01F9C, "woodbridge_start" },
    { 0x7F3C65CB, "woodchopper_alerted" },
    { 0x3F79A338, "woodchopper_death" },
    { 0x370F6330, "woodchopper_init" },
    { 0xAF8FC0D7, "wooden" },
    { 0x5C23E8CD, "wooden_bridge" },
    { 0x4DC1ED58, "woodenbridge" },
    { 0x616499DD, "woodland" },
    { 0x3F7395E5, "woods" },
    { 0xC2061775, "woods_advance_last_section" },
    { 0xD288FD25, "woods_after_charge" },
    { 0x15DFD95D, "woods_after_ladder" },
    { 0xE494E95E, "woods_and_bowman_getin" },
    { 0x9E7AF6B8, "woods_angles" },
    { 0x8B391DA1, "woods_anim_completed" },
    { 0x5B20C950, "woods_anim_origin" },
    { 0xD6538605, "woods_anim_started" },
    { 0x49E5ACEE, "woods_animation_wrapper" },
    { 0x9F057B3E, "woods_anims" },
    { 0x955CF5F0, "woods_at_bp2wave3" },
    { 0xC983DA2F, "woods_at_bp3wave3" },
    { 0x0BBDD25F, "woods_at_dogs" },
    { 0x83230A5E, "woods_at_table" },
    { 0x0C41E92A, "woods_attach_bottle" },
    { 0x189D9F79, "woods_attacker" },
    { 0x4257DDE3, "woods_backbreaker" },
    { 0xB4475700, "woods_backbreaker_become_corpse" },
    { 0xB8D7D662, "woods_backbreaker_door_fully_open" },
    { 0x3141A37B, "woods_backbreaker_door_kick" },
    { 0xD0C479B0, "woods_backbreaker_factionfight" },
    { 0x0653A8F0, "woods_backbreaker_head_slam" },
    { 0x9DC7C4D4, "woods_backbreaker_idle" },
    { 0xE6ECADB9, "woods_backbreaker_mature_content_filter" },
    { 0x199DAA62, "woods_backbreaker_neck_snap" },
    { 0x76A633B5, "woods_backbreaker_start_scuffle" },
    { 0xFD7A32B4, "woods_barrel" },
    { 0xCEC23CA6, "woods_behavior" },
    { 0xEB5A6E59, "woods_binoculars_point" },
    { 0x49C85D36, "woods_binoculars_point_2" },
    { 0x2B2756C8, "woods_bowman_delay" },
    { 0xA9780F38, "woods_bp2" },
    { 0xD44F48BC, "woods_bp2_exit_battle" },
    { 0x00F9E985, "woods_bp2_skipto" },
    { 0xCF7A89A1, "woods_bp3" },
    { 0xA5A01211, "woods_bp3exit" },
    { 0x1A46DC55, "woods_breachroom_after" },
    { 0xB7401232, "woods_broke_window" },
    { 0x2E343815, "woods_carry_complete" },
    { 0x91356E08, "woods_carry_delay_walk_frames" },
    { 0x6AAF0D4D, "woods_carry_disable_crouch" },
    { 0x8160FEE4, "woods_carry_disable_movement" },
    { 0xAAC52D95, "woods_carry_height_offset" },
    { 0x9240E74E, "woods_carry_is_crouched" },
    { 0x65F4BCD5, "woods_carry_is_moving" },
    { 0xC8CE612D, "woods_carry_set_rate" },
    { 0xE7754B09, "woods_circle_bp2" },
    { 0xE8AAEA06, "woods_climb_up_animation" },
    { 0xBF9518E2, "woods_comms_wait_point" },
    { 0x469587AD, "woods_container" },
    { 0xAF90C8A9, "woods_cover" },
    { 0xB43157C0, "woods_cover_node" },
    { 0x8702CDE7, "woods_crossbow_anims" },
    { 0x6602569B, "woods_crossbow_anims_handover" },
    { 0xE5EAE080, "woods_damage_fail_condition" },
    { 0x7886742E, "woods_damage_override" },
    { 0x08C7E79A, "woods_dc_confirm" },
    { 0xA6D6C395, "woods_dc_confirms" },
    { 0x9757900F, "woods_delete_knife" },
    { 0x6C125180, "woods_detach_bottle" },
    { 0x425B419B, "woods_detonates" },
    { 0xB1D04B48, "woods_dialog_ft_on_death" },
    { 0x1BFB6C0D, "woods_dive_point" },
    { 0x7452ADE6, "woods_dock_behavior" },
    { 0x4EA64E6D, "woods_door_kick" },
    { 0x89F9275A, "woods_door_kick_new" },
    { 0x2A452CDC, "woods_dummy" },
    { 0xF36CBC51, "woods_event4_start" },
    { 0x2E06A11D, "woods_explosion" },
    { 0x116ADE1C, "woods_fires_gun" },
    { 0x4C30DE66, "woods_fires_mg" },
    { 0x83BEED49, "woods_fougasse_vics" },
    { 0x242C9142, "woods_freakout_cleanup" },
    { 0xDA279F0C, "woods_freakout_hudson_intro_scenes" },
    { 0xE44C1B58, "woods_freakout_menendez" },
    { 0xD72B5B39, "woods_freakout_menendez_scene" },
    { 0xA4CC4EA1, "woods_freakout_pdf_run_to_mission" },
    { 0xDC0E7E60, "woods_freakout_remove_set_low_ready" },
    { 0xD42AEF64, "woods_freakout_scene_begin" },
    { 0x0B68F15D, "woods_freakout_woods_intro_scenes" },
    { 0xFF5ED874, "woods_free_pows" },
    { 0xACA9F57F, "woods_gas_room" },
    { 0x75501201, "woods_gasmask_anim" },
    { 0x66933501, "woods_get_on_pbr" },
    { 0x55EE5399, "woods_give_knife" },
    { 0xB079D201, "woods_goal" },
    { 0x2004DD98, "woods_goal_node" },
    { 0x3B7A1417, "woods_goto_bp1wave3" },
    { 0xD8FB64FE, "woods_goto_bp2wave3" },
    { 0x22B7FD35, "woods_goto_bp3" },
    { 0xE93DFB65, "woods_goto_bp3wave3" },
    { 0x6EC86F5F, "woods_goto_wave2" },
    { 0x1C20A2C6, "woods_grab_guy" },
    { 0x6F03309C, "woods_grenade_toss" },
    { 0xD99C07C5, "woods_headbutt" },
    { 0x302BBDB2, "woods_headed_to_reinforce_bp" },
    { 0x62AAA548, "woods_headsci_start" },
    { 0x0E4775EE, "woods_headset" },
    { 0xC7F9ECB8, "woods_hides_from_sniper" },
    { 0xB0938BA7, "woods_horse" },
    { 0x6547A6B6, "woods_hudson_idle" },
    { 0xC7503002, "woods_in_comms_node" },
    { 0xAF93C5B6, "woods_in_tunnel_start_node" },
    { 0x54FF0D2C, "woods_index" },
    { 0x207BE322, "woods_jam_dof" },
    { 0x069DE6FF, "woods_jam_heli" },
    { 0xBBA230FE, "woods_jam_hit" },
    { 0xF9910BC9, "woods_jam_nva_watcher" },
    { 0x1214A9E8, "woods_jump_over_pipe" },
    { 0x88EE52E0, "woods_keep_patroling" },
    { 0xDCCC304C, "woods_keep_patrolling_wait" },
    { 0xD0601E52, "woods_kick" },
    { 0xDABDD101, "woods_kick_barrel" },
    { 0x804CCD21, "woods_kicks_off_coke_fog" },
    { 0x54071EA2, "woods_kill_russian" },
    { 0x2CEEE7B1, "woods_killed_guard" },
    { 0x63AA3522, "woods_kneecapped" },
    { 0x63693361, "woods_landing_vo" },
    { 0xAE4B8966, "woods_mask_ent" },
    { 0xAC8EB58A, "woods_mg_align" },
    { 0xF7685321, "woods_mode" },
    { 0x45188EA4, "woods_nag_array" },
    { 0x7C80D24E, "woods_nag_lines" },
    { 0xAA4DA635, "woods_nag_mason_about_horse" },
    { 0x08CEE0FC, "woods_node" },
    { 0x91E9F310, "woods_num_missiles" },
    { 0xF32F55FE, "woods_onroof_point" },
    { 0xBDB01F2A, "woods_opens_door" },
    { 0xD6675F49, "woods_outsidetunnels_node" },
    { 0x33443012, "woods_patroller_think" },
    { 0x40A6559E, "woods_pause" },
    { 0x65A76AAA, "woods_play_moveup_line" },
    { 0x9B791A9F, "woods_play_nag_for_target" },
    { 0xF791975F, "woods_play_nag_for_target_while_alive" },
    { 0x72856B86, "woods_pos" },
    { 0x44366CF3, "woods_post_jeepmeetup" },
    { 0x79EBFFEB, "woods_postdogs" },
    { 0x9FB1AFA5, "woods_postgas_room" },
    { 0xC31220D3, "woods_postkick_node" },
    { 0xCF41BCA8, "woods_pow_vo_convo" },
    { 0x0C9FC01C, "woods_pow_vo_nag_line" },
    { 0x8AF85BB8, "woods_radio_node" },
    { 0xDD69F766, "woods_rally_goal" },
    { 0x2C5ECEA1, "woods_rampage" },
    { 0xC824F69A, "woods_return_base" },
    { 0x8654957F, "woods_ride_with_player" },
    { 0xC43803B5, "woods_ridealong" },
    { 0x44FE1043, "woods_room_off" },
    { 0xBBE5A20F, "woods_room_on" },
    { 0x5135981C, "woods_rope" },
    { 0x8DFE9723, "woods_run_to_half_dock" },
    { 0x69746B96, "woods_scream_approach" },
    { 0xFE18740E, "woods_scream_melee" },
    { 0x08947CCF, "woods_setup" },
    { 0x317F29DC, "woods_shoots_balcony_door" },
    { 0x552A8186, "woods_shoots_pistol_effect" },
    { 0x47C849B8, "woods_shore_point" },
    { 0x94EFBC1F, "woods_skipto_wave1" },
    { 0xED0099E4, "woods_sniper_spot" },
    { 0x8D44E4A7, "woods_snp_off" },
    { 0x484B2E13, "woods_snp_on" },
    { 0xAC9CB839, "woods_speed" },
    { 0xE6863BF9, "woods_split_up_loop" },
    { 0xAC125DC5, "woods_sprint_down_alley" },
    { 0x1CACFDBC, "woods_start" },
    { 0xC86F4376, "woods_stealth_carry_anims" },
    { 0x41F43A4E, "woods_stick_knife" },
    { 0xC2C9E88E, "woods_stop_talking_split" },
    { 0xE0F16277, "woods_take_knife" },
    { 0x265E37A5, "woods_test_loop" },
    { 0x0EF3BB75, "woods_tiger" },
    { 0x1CAAF63E, "woods_tirechange" },
    { 0xA8E94561, "woods_to_bp1" },
    { 0xCEEBBFCA, "woods_to_bp2" },
    { 0xF4EE3A33, "woods_to_bp3" },
    { 0x947437C2, "woods_to_kravchenko" },
    { 0x78A2B2E8, "woods_toggle_fight_in_bp" },
    { 0xACA358C9, "woods_toggle_follow_behavior" },
    { 0xCAA5FACC, "woods_trigger" },
    { 0x4287DB50, "woods_truck_trigger" },
    { 0x04C1AEC6, "woods_turret" },
    { 0xCDE893A1, "woods_vo_tunnel_fail" },
    { 0x4036C9D2, "woods_vomit_anims" },
    { 0xD5D713C5, "woods_vulture_struct" },
    { 0x3B061DFD, "woods_vulture_struct2" },
    { 0x753348D0, "woods_wait_c4_trig" },
    { 0x070C96E3, "woods_wait_on_player" },
    { 0x9496E9E4, "woods_wait_stairs" },
    { 0x07B6D455, "woods_waitloop" },
    { 0xF47CE055, "woods_walk_compound" },
    { 0x5BB83955, "woods_warped" },
    { 0x66F4301E, "woods_wave1_bp1" },
    { 0xD9774C34, "woods_weapon" },
    { 0xE0F96783, "woods_zhao_trigger" },
    { 0xDB4737EE, "woods_zipline_attack" },
    { 0xEB0F4306, "woodsfirststopanim" },
    { 0xC103BD65, "woodsnode" },
    { 0xBDE3F62A, "woodspot" },
    { 0x774868AF, "woodsruntopipe" },
    { 0xC9925F42, "woodstiger" },
    { 0xFC10B262, "woodstiger_area" },
    { 0xF300DF65, "woodstiger_firenode" },
    { 0x701F6A66, "woodstiger_knock_node" },
    { 0xF0A4CD12, "woodstiger_tree_knockover" },
    { 0xF27D440E, "woodsy" },
    { 0x5B64B76F, "woody" },
    { 0xE4542058, "woof" },
    { 0xE5549B18, "woohoo" },
    { 0x3B8D654B, "woosd" },
    { 0xB27DC2B8, "woosh_point" },
    { 0xD9865AD0, "wooshangle" },
    { 0xD0316E9A, "woot" },
    { 0x62102FF9, "word" },
    { 0x476DB3A8, "word_length" },
    { 0x864C6F30, "words" },
    { 0x5030674E, "work" },
    { 0xB197425A, "workable" },
    { 0x5446563D, "workaround" },
    { 0x17ED7291, "worked" },
    { 0x5C23F797, "worker" },
    { 0xE8DAFC4E, "workers" },
    { 0xC72C5082, "workflow" },
    { 0x8DFB0C35, "workhorse" },
    { 0xF083659F, "workin" },
    { 0x0B823CF2, "working" },
    { 0x3D612FA8, "working_guard" },
    { 0x77587DDD, "working_guard_spawner" },
    { 0x1A2D1B43, "working_guards" },
    { 0x09A69BA0, "working_zone_init" },
    { 0xC457CBF1, "works" },
    { 0x2F3AB262, "workshop" },
    { 0xF2935BAD, "workstations" },
    { 0x276BBBD7, "world" },
    { 0x7ABC2B41, "world_clock_get_offset" },
    { 0xAB3A106E, "world_clock_run" },
    { 0x21512264, "world_gravity" },
    { 0xF8F29C0F, "world_icon_update" },
    { 0xFA0E9867, "world_location" },
    { 0x9DC4CB50, "world_map" },
    { 0xD09645E1, "world_map_translate_to" },
    { 0xC00A4DFE, "world_map_zoom_to" },
    { 0x0D857FC3, "world_offset" },
    { 0x5DE61EF4, "world_pos" },
    { 0xF699E27C, "world_rotate_pos" },
    { 0xA5641FF1, "world_up_vector" },
    { 0x8092F9F0, "worlddamagedmodel1" },
    { 0xF29A692B, "worlddamagedmodel2" },
    { 0xCC97EEC2, "worlddamagedmodel3" },
    { 0x8BAF5C8F, "worldfxorigin" },
    { 0xDD455BD7, "worldgun" },
    { 0x975CF6FC, "worldgundw" },
    { 0x25F5EFAE, "worldheight" },
    { 0x7306BB13, "worldicons" },
    { 0xDDD2C6D6, "worldicons_disabled" },
    { 0x3CEFF866, "worldiswaypoint" },
    { 0xA5E6EA92, "worldlat" },
    { 0xCF57FF31, "worldlong" },
    { 0xCE897529, "worldmapx" },
    { 0xA886FAC0, "worldmapy" },
    { 0x7C2864E6, "worldmodel" },
    { 0x35B0BCB7, "worldpiece" },
    { 0xD836CD3B, "worldpoint" },
    { 0x482888E7, "worldspace" },
    { 0xE96874E0, "worldspawn" },
    { 0x7A465687, "worldtolocalcoords" },
    { 0xA4B4E872, "worldtrace" },
    { 0x16382CB8, "worldup" },
    { 0x04B06DDE, "worlduseicons" },
    { 0x6C2188D8, "worm" },
    { 0xDE28F813, "worn" },
    { 0x256C142F, "worried" },
    { 0xBB3314C0, "worries" },
    { 0x8D908647, "worrld" },
    { 0x8E9F6ADC, "worry" },
    { 0x2EC62E2C, "worrying" },
    { 0x21B04D6F, "worse" },
    { 0x1BE81153, "worsen" },
    { 0x9B862C76, "worst" },
    { 0xF49A4BE5, "worst_dist" },
    { 0x9777095B, "worst_trigger" },
    { 0x9FD32AD3, "worst_turret" },
    { 0xE9DA7021, "worst_turret_time" },
    { 0xDB120AF3, "worth" },
    { 0x6B173522, "worthy_name" },
    { 0xB92A9820, "worthydamageratio" },
    { 0xBE94FDF0, "would" },
    { 0xB038EC44, "wouldbesmartformyaitypetoseekoutenemy" },
    { 0x73E4340F, "wouldve" },
    { 0xEBD79D8E, "wound" },
    { 0x174658D1, "wounded" },
    { 0x02FD81CD, "wounded_ai_todo" },
    { 0xB1FF9494, "wounded_angles" },
    { 0x034C6965, "wounded_civs" },
    { 0x0946C05E, "wounded_civs_exit_club_then_use_pathnodes" },
    { 0xE402D80C, "wounded_combat" },
    { 0xB6F48FE5, "wounded_combat_trigger" },
    { 0x59E30F20, "wounded_counter" },
    { 0x5F9B7045, "wounded_fountain_guys_setup" },
    { 0x7109FC52, "wounded_group1_anim" },
    { 0x56E5D8A7, "wounded_group2_anim" },
    { 0x41089898, "wounded_guy_scene" },
    { 0x72A8A01A, "wounded_into_chopper" },
    { 0x6B73A0B1, "wounded_looptime_count" },
    { 0x0C1A2868, "wounded_man" },
    { 0x146EA45C, "wounded_man_begins_trigger" },
    { 0x4D001FBB, "wounded_setup" },
    { 0xBBF985A9, "wounded_spawn" },
    { 0x2F6DE557, "woundedcounter" },
    { 0x7576D350, "woundedloopcount" },
    { 0xAA74A3A0, "woundedlooptime" },
    { 0xE265181A, "woundedtrheshold" },
    { 0xAADAC58C, "wounding_enemy_detected" },
    { 0xCA47A9FF, "wounding_sight_blocker" },
    { 0xE105BFC5, "wounding_sight_blocker_deleted" },
    { 0x0B54FE31, "wounds" },
    { 0x1B3B6922, "wow" },
    { 0xB8C789B8, "wp" },
    { 0x71F8A699, "wp_init" },
    { 0x8189B087, "wpn_attach_tag" },
    { 0x87F03818, "wpn_gravityspikes" },
    { 0xD046C48D, "wpn_list" },
    { 0xD5FB84FC, "wpn_name" },
    { 0x38DF129D, "wpn_type" },
    { 0xB235A5CF, "wpnplyr" },
    { 0x1AD34095, "wrap" },
    { 0x4C688D26, "wrap_array_index" },
    { 0x90972ECC, "wrap_body" },
    { 0x6DCBE493, "wraping" },
    { 0xF0722424, "wrapped" },
    { 0x0494D5E2, "wrapper" },
    { 0x9FA0C1F3, "wrapper_func" },
    { 0xD1D344AD, "wrappers" },
    { 0xBDAEE1E4, "wraps" },
    { 0x9B51AF91, "wrapup_gameplay" },
    { 0x9297FC85, "wreck" },
    { 0x637BA05A, "wreckage" },
    { 0x7950A414, "wrecks" },
    { 0x0C30113E, "wrench_endgame_1" },
    { 0xE62D96D5, "wrench_endgame_2" },
    { 0xC02B1C6C, "wrench_endgame_3" },
    { 0x39141374, "wrench_endgame_array" },
    { 0x0FE5B3C3, "wrench_lobby" },
    { 0xD834F963, "wrestle" },
    { 0xB1D3166D, "wrestleanglethreshold" },
    { 0x63B74BA5, "wrestleindex" },
    { 0x5C650B5F, "wretched" },
    { 0x212D7786, "wrist" },
    { 0x89696CAB, "wristwatch" },
    { 0xE25DA4D6, "write" },
    { 0x43FCD204, "write_checkpoint_times" },
    { 0xA6905705, "write_error" },
    { 0xEC49B3BB, "write_error_msg" },
    { 0x3649FB10, "write_gantt_chart" },
    { 0x3914A878, "write_gantt_chart_header" },
    { 0x83F1CE34, "write_gantt_row" },
    { 0xFA117AFA, "write_header" },
    { 0xBC412E49, "write_high_scores_stats" },
    { 0x2DAC2E7E, "write_html" },
    { 0x27EA7D3E, "write_player_track" },
    { 0x0CAEA9AC, "write_project_header" },
    { 0xCFFEB495, "write_tasks" },
    { 0x1D730612, "writeable" },
    { 0x51002823, "writeclassstats" },
    { 0x317B15B9, "writegridlinks" },
    { 0xF358D8BD, "writegridnodes" },
    { 0xEA2E4349, "writes" },
    { 0x09092F13, "writeweaponstats" },
    { 0xC4DE9CCF, "writing" },
    { 0x174B772E, "written" },
    { 0xB22A073A, "writtenprefix" },
    { 0x85922D00, "wrong" },
    { 0x1C037010, "wrong_collector" },
    { 0xE2CFA6D0, "wrong_gong" },
    { 0xBB4F8E64, "wrong_press" },
    { 0xDB6B2891, "wrong_press_qualifier" },
    { 0x5323337C, "wrong_presser_thread" },
    { 0x4C7352DB, "wrong_torch" },
    { 0x5839D42B, "wrongs" },
    { 0xEA3ED618, "wrongstallnag" },
    { 0xEA6253A0, "wrote" },
    { 0xC80F562F, "wtc" },
    { 0x0A02F222, "wtf" },
    { 0x461E2E23, "wtf_am_i" },
    { 0x12FE1395, "wtfhack" },
    { 0xA30BA412, "wth_elem" },
    { 0x3E419792, "wth_lookat_point" },
    { 0x76D3EDC5, "wu" },
    { 0x0C08E473, "wuddya" },
    { 0xB2EB3139, "wuen_electric_switch" },
    { 0x3ADB4E01, "wuen_trig" },
    { 0xBA2F5A04, "wunderfizz_devgui_callback" },
    { 0xEB319C83, "wunderfizz_setup" },
    { 0x26F7C392, "wunderfizz_starting_machine" },
    { 0x359B17BB, "wunderfizz_unitrigger_think" },
    { 0x673D2153, "wunderfizz_used_vo" },
    { 0x9429FE24, "wunderfizzstub_update_prompt" },
    { 0xA580CFF2, "wunderfizztrigger_update_prompt" },
    { 0xC2D8E297, "ww" },
    { 0xEACCB5D8, "ww_grenade_pickedup" },
    { 0x13CCB255, "ww_grenade_powerup" },
    { 0x19A7EAAE, "ww_grenades_per_powerup" },
    { 0xB562B90D, "ww_melee_cocoon_chance" },
    { 0x53D35C55, "ww_points_given" },
    { 0x2C8F2390, "ww_powerup_drop_chance_melee" },
    { 0x1F9A5D05, "ww_powerup_drop_chance_normal" },
    { 0x869438A8, "ww_powerup_drop_chance_webbing" },
    { 0xDF1EB62D, "wwii" },
    { 0x50351271, "wwiiliams" },
    { 0x0BA0CD7E, "wwillaims" },
    { 0x7CE1D2DE, "wwilliams" },
    { 0x58A5F69E, "wwillimas" },
    { 0xFF9F03AA, "www" },
    { 0x4F8217AF, "x" },
    { 0x9251DA64, "x1" },
    { 0x0459499F, "x2" },
    { 0x7718D67A, "x2kills" },
    { 0x8A90400F, "x2score" },
    { 0xDE56CF36, "x3" },
    { 0x0CF9918E, "x78" },
    { 0x89C35229, "x__" },
    { 0x6DED43AD, "x_align" },
    { 0x61C52DB9, "x_alignment" },
    { 0x1F0EDD9D, "x_anchor" },
    { 0x55FA2549, "x_axis" },
    { 0x7CEEF4FB, "x_dif" },
    { 0x098E9E86, "x_dist" },
    { 0x3FF7249A, "x_for_diamond" },
    { 0x6E40E7F9, "x_forward" },
    { 0xF3DF8AB3, "x_fps" },
    { 0x73CE6A0E, "x_length" },
    { 0xC7C302A8, "x_llim" },
    { 0xFFD4E604, "x_mov" },
    { 0x9BCE0EE1, "x_off" },
    { 0x0EE19E2B, "x_offset" },
    { 0x2C5BE8CB, "x_placement" },
    { 0x79710D4C, "x_pos" },
    { 0x7B382C3B, "x_position" },
    { 0xD90271FC, "x_pressed" },
    { 0x1D8D9454, "x_rate" },
    { 0x358B9CBC, "x_right" },
    { 0xE474199E, "x_rlim" },
    { 0xA2E8F3DB, "x_rts" },
    { 0x0D426D9D, "x_sec" },
    { 0x44EAFAFA, "x_shift" },
    { 0x80DFFF11, "x_sign" },
    { 0x50E9500D, "x_size" },
    { 0xB83E32E9, "x_up" },
    { 0x4BF4F2CF, "x_val" },
    { 0xCFBEFB0C, "xadd" },
    { 0x893BCE3C, "xall" },
    { 0xA556D0DB, "xamnt" },
    { 0x00407999, "xang" },
    { 0x414C4FC0, "xanim" },
    { 0xA739BD34, "xanim_all" },
    { 0xF3651F21, "xanim_export" },
    { 0x5681E625, "xanim_ride" },
    { 0x5E018FFE, "xanim_unload" },
    { 0xDD951A80, "xattack_is_unlink" },
    { 0x82622F46, "xbox" },
    { 0x473DB734, "xcam" },
    { 0xFB934950, "xcam_fov" },
    { 0x6796469E, "xcam_frame" },
    { 0x4D4B425A, "xcam_off" },
    { 0xED1CB88C, "xcam_on" },
    { 0x10D363AF, "xcam_players" },
    { 0x3B2DEC3B, "xcamframe" },
    { 0x2126F815, "xcammoved" },
    { 0x81D56F55, "xcamname" },
    { 0xA52274B1, "xcap" },
    { 0x2D5891FA, "xcoord" },
    { 0xB06213A6, "xcoordmod" },
    { 0xFFD37779, "xd" },
    { 0x09D7744C, "xdir" },
    { 0x0480D6F4, "xdrop" },
    { 0xF14621C9, "xenon" },
    { 0xA3923DF7, "xenon_auto_aim" },
    { 0x93F70275, "xenon_auto_aim_stop_logic" },
    { 0x23B63188, "xenon_binds" },
    { 0x2EE0F4A7, "xenon_enable_auto_aim" },
    { 0x5ADFD616, "xenon_export" },
    { 0xD2E793A9, "xenon_no_key" },
    { 0x0FA1F6E4, "xenon_remove_auto_aim" },
    { 0x70B5DDBD, "xenon_yes_key" },
    { 0xE60EC1EA, "xenonoutput" },
    { 0xD57C025B, "xenonremote" },
    { 0xD0CEADE2, "xfactor" },
    { 0x81242CB9, "xfade" },
    { 0x4B446928, "xfile_version" },
    { 0xBE29A01B, "xform_button_pressed" },
    { 0x5EDE1B64, "xform_hud_active" },
    { 0x4503F77D, "xform_input_handler" },
    { 0xE45336C6, "xgate" },
    { 0xB04F0279, "xidle" },
    { 0x3A8A644F, "xkillsy" },
    { 0x379274D7, "xloc" },
    { 0xDB971AF0, "xm8" },
    { 0x34C460DE, "xmodel" },
    { 0xC89FF232, "xmodelalias" },
    { 0xE85BC241, "xmodels" },
    { 0x9BCD50D9, "xnum" },
    { 0xB0CBC08E, "xoffset" },
    { 0xCD54BACD, "xorigin" },
    { 0x37B5BA8D, "xp" },
    { 0x2564CF67, "xp_difficulty_multiplier" },
    { 0x80A106F1, "xp_display_delay_before_fade" },
    { 0x243B7DF9, "xp_display_max_height_offset" },
    { 0x7B0D070F, "xp_display_total_time" },
    { 0xDEF9F8ED, "xp_enable" },
    { 0xC630E8FF, "xp_end" },
    { 0xE4470606, "xp_init" },
    { 0xA37F40EC, "xp_mod" },
    { 0x2EC08310, "xp_revive_once_per_round" },
    { 0x509BC1B8, "xp_type" },
    { 0xEBB54091, "xpamount" },
    { 0x925E36F9, "xpcollectorsscale" },
    { 0xDFA86877, "xpcolumn" },
    { 0xB3E9B460, "xpearned" },
    { 0x9F73F9AF, "xpeventpopup" },
    { 0x372F7F77, "xpgain_type" },
    { 0x8AAB1B23, "xpgains" },
    { 0x71F09EC0, "xpgiven" },
    { 0x9E387EBD, "xpincrease" },
    { 0xA404B0FB, "xpmodifiercallback" },
    { 0x9DFD7B1B, "xpos" },
    { 0xA1DD662E, "xposition" },
    { 0x90465EA2, "xpossiblenode" },
    { 0x4E01D1C3, "xpratethread" },
    { 0x1CC5730D, "xpscale" },
    { 0x77D83DF4, "xptypes" },
    { 0x0A366F82, "xpval" },
    { 0xAF4C52FC, "xpvalue" },
    { 0xE4A8231D, "xray" },
    { 0x5DB834F6, "xs" },
    { 0xA34F527E, "xsync" },
    { 0x5B712D22, "xtra" },
    { 0xEB07A0C7, "xuid" },
    { 0x7E05EB84, "xval" },
    { 0xB5B455C9, "xvect" },
    { 0x67C98DD5, "xx" },
    { 0xC6488BA7, "xxx" },
    { 0xCC4235D7, "xxxxxxx" },
    { 0x2DA40163, "xxxxxxxx11" },
    { 0x95B0076F, "xxxxxxxxxxxxxxxxx" },
    { 0x41C7136C, "xy" },
    { 0x314A16EF, "xy_delta" },
    { 0x0C40D91D, "xy_vel_damp" },
    { 0xCC809CDF, "xydirection" },
    { 0xC8BF42BC, "xydist" },
    { 0x74B721BD, "xydistance" },
    { 0xEBB41A8B, "xyforward" },
    { 0xB9B9351D, "xyspeed" },
    { 0x54E73C52, "xyspeedmag" },
    { 0x93B61A4E, "xyz" },
    { 0xA7DA7E95, "xyzw" },
    { 0x297F9D46, "y" },
    { 0x5FBF690B, "y1" },
    { 0xEDB7F9D0, "y2" },
    { 0x0C70AFD0, "y_alignment" },
    { 0xC60A09BA, "y_anchor" },
    { 0x7DFD1956, "y_axis" },
    { 0xBCF90566, "y_dif" },
    { 0xAE7726F5, "y_dist" },
    { 0x7DEE999A, "y_fps" },
    { 0x33393887, "y_inc" },
    { 0x22465B65, "y_length" },
    { 0xF2B249FF, "y_llim" },
    { 0x3A13145D, "y_mov" },
    { 0x9D21DC7C, "y_off" },
    { 0xAE0DEAD4, "y_offset" },
    { 0x57B0E772, "y_offset_range" },
    { 0xED56FB02, "y_placement" },
    { 0xC5E4DA05, "y_pos" },
    { 0x57E96AA4, "y_pos_inc" },
    { 0xC6361D25, "y_rlim" },
    { 0xE38D0A82, "y_rts" },
    { 0xC1F51E37, "y_shift" },
    { 0x51DF1AA6, "y_sign" },
    { 0x118EC63A, "y_size" },
    { 0x2FEAFAD7, "y_start" },
    { 0x9049B0DA, "y_val" },
    { 0x7EF9283B, "ya" },
    { 0xE8B3B611, "yaaa" },
    { 0xE34D03BB, "yadd" },
    { 0x655495FC, "yahoo_fx" },
    { 0x4010F159, "yamantau" },
    { 0x65F46D35, "yamatau" },
    { 0xFE5C70B2, "yamnt" },
    { 0xDA918996, "yanics" },
    { 0xBC609828, "yankee" },
    { 0x29040A7D, "yard" },
    { 0x07D0139E, "yard_action" },
    { 0x6BD46BAC, "yard_mghouse" },
    { 0x65F53901, "yard_runners" },
    { 0x32B7803A, "yard_runners_strat" },
    { 0xBCCC073C, "yards" },
    { 0x3B6E5F7E, "yaw" },
    { 0x2386FE92, "yaw_angle" },
    { 0xBFBE85C1, "yaw_bits" },
    { 0xE08B8842, "yaw_count" },
    { 0x3ABD3C61, "yaw_desired" },
    { 0x8F590D6C, "yaw_diff" },
    { 0x925FD91D, "yaw_level" },
    { 0x90257FCA, "yaw_north" },
    { 0x264B665E, "yaw_to_add" },
    { 0x44900DA2, "yaw_to_cover" },
    { 0xFFDE9472, "yaw_to_use" },
    { 0x37AA4B81, "yaw_vec" },
    { 0xC5A2DC46, "yaw_vel" },
    { 0x879C93E2, "yawaccel" },
    { 0x32344391, "yawaccelerationtime" },
    { 0xB00B70A3, "yawadd" },
    { 0x2D2C8561, "yawaimweight" },
    { 0x631A830B, "yawangle" },
    { 0x5435B86A, "yawangles" },
    { 0x556FC556, "yawbits" },
    { 0x6CADAABA, "yawchange" },
    { 0x6A01274A, "yawconvergencetime" },
    { 0xF56D4360, "yawdecelerationthreshold" },
    { 0x26375774, "yawdelta" },
    { 0x5EB5FEC4, "yawdeltachange" },
    { 0x348AAFE3, "yawdiff" },
    { 0x13A8E684, "yawerror" },
    { 0x899D0B54, "yawmax" },
    { 0xB42F169A, "yawmin" },
    { 0xF5DABF95, "yawrange" },
    { 0x86963261, "yaws" },
    { 0xB59CA7C3, "yawsensitivity" },
    { 0x7B873BB7, "yawspeed" },
    { 0x1AE54A4B, "yawspeedads" },
    { 0x80F48C98, "yawstep" },
    { 0x1B430FBF, "yawthreshold" },
    { 0x1E134E31, "yawtime" },
    { 0x365A4697, "yawtoenemy" },
    { 0x75239066, "yawtoenemyposition" },
    { 0x2FE6474D, "yawtomakedeltamatchup" },
    { 0x7B042024, "yawtoobject" },
    { 0x7CEADE1C, "yawtoshootentorpos" },
    { 0x90E6446B, "yawtransition" },
    { 0x8057B145, "yawvar" },
    { 0xA28753EB, "yawy" },
    { 0x274BADC0, "yay" },
    { 0xDEC616B7, "yay_more_explosions_in_macv" },
    { 0xE82A015F, "yay_more_explosions_outside_macv" },
    { 0xB96119F5, "ycoord" },
    { 0x610BEFAB, "ydir" },
    { 0x170311DF, "ye" },
    { 0x0B1F68A4, "yeah" },
    { 0x63475C84, "yeahhhh" },
    { 0xE75FD74E, "year" },
    { 0xAFBBB381, "year_day" },
    { 0x3E4C2617, "yearned" },
    { 0xC4051BF1, "years" },
    { 0x9788D8AC, "yeehaw" },
    { 0x5E496CFF, "yell" },
    { 0x9071BAF8, "yellat" },
    { 0xAB992F81, "yelling" },
    { 0xA426C171, "yellow" },
    { 0x75A6DD12, "yellow_awning" },
    { 0x0E9C8047, "yellow_awning_clip" },
    { 0x0D5847A5, "yellow_backyard" },
    { 0xE893CC49, "yellow_conf_screen" },
    { 0x2BBF9207, "yellow_damage" },
    { 0x72EDB94E, "yellow_fac" },
    { 0xA0CF768C, "yellow_guys" },
    { 0x1218BADF, "yellow_patio" },
    { 0x5D8C0548, "yellow_patio_clip" },
    { 0xE71766AE, "yellowangle" },
    { 0x6C144A46, "yellowdolphin_jumper_thread" },
    { 0x8734D4D8, "yellows" },
    { 0xB1D2CF06, "yells" },
    { 0xFBC52F85, "yem_02" },
    { 0x477B7418, "yem_02_render" },
    { 0x8297AE1D, "yem_03a" },
    { 0xB0797C60, "yem_03a_render" },
    { 0xA89A2886, "yem_03b" },
    { 0xC00E7851, "yem_03b_render" },
    { 0xF7AC0600, "yem_04a" },
    { 0xC418823F, "yem_04a_render" },
    { 0x69B3753B, "yem_04b" },
    { 0x7864FFA2, "yem_04b_render" },
    { 0xACD5CDD3, "yem_04bb" },
    { 0x5BFCB34A, "yem_04bb_render" },
    { 0x174A8431, "yemen" },
    { 0x39ACD374, "yemen_aigroup_fallback" },
    { 0x1E0B5990, "yemen_aigroup_fallback_count_watch" },
    { 0x4624D55C, "yemen_amb" },
    { 0xBD3DD0A3, "yemen_anim" },
    { 0x8C556C93, "yemen_art" },
    { 0x3CA0112A, "yemen_capture" },
    { 0xC06BB294, "yemen_custom_introscreen2" },
    { 0x360B9ECC, "yemen_disable_sonar" },
    { 0xB7A7E1E4, "yemen_drone_control" },
    { 0xAE27B286, "yemen_drone_control_tones" },
    { 0x618039AA, "yemen_fallback_delay_bloodydeath" },
    { 0x7694BE72, "yemen_fallback_move" },
    { 0xF59E8966, "yemen_fx" },
    { 0x8C6A26E3, "yemen_hijacked" },
    { 0x2845A1E4, "yemen_market" },
    { 0xCEC17736, "yemen_market_clean_up" },
    { 0x4BF23AFE, "yemen_market_setup" },
    { 0x58AA856A, "yemen_metal_storms" },
    { 0x21674B5C, "yemen_morals" },
    { 0x5F2D5DF7, "yemen_morals_rail" },
    { 0xB61B01A3, "yemen_sonar_control" },
    { 0x4C654726, "yemen_speech" },
    { 0xDF493DA8, "yemen_speech_setup" },
    { 0x34F516D6, "yemen_terrorist_hunt" },
    { 0xFA3A3E54, "yemen_utility" },
    { 0xE7C21599, "yemen_vo" },
    { 0x4A0A99A2, "yemen_wounded" },
    { 0x45871892, "yemeni" },
    { 0xBDBBCC1A, "yemeni_bft_highlight" },
    { 0xEF50827A, "yemeni_detected_farid" },
    { 0xC3179086, "yemeni_fire_at_player_flag" },
    { 0x1923160B, "yemeni_names" },
    { 0xB7014A47, "yemeni_player_damage_flag" },
    { 0x1B858DEF, "yemeni_teamswitch_player_detected" },
    { 0xF02A2F03, "yemeni_teamswitch_radio_callout" },
    { 0x540CF204, "yemeni_teamswitch_spawnfunc" },
    { 0x25D13D26, "yemeni_watch_player_damage" },
    { 0xB9EAAFFD, "yep" },
    { 0x05EFA4CF, "yer" },
    { 0xDFED2A66, "yes" },
    { 0x07CC49FC, "yes_hud" },
    { 0xCFAB5DBA, "yes_key" },
    { 0x21E0C659, "yet" },
    { 0x76FBAF9A, "yeti" },
    { 0xBD42649F, "yfactor" },
    { 0x02AA2394, "yield" },
    { 0x18A3B207, "yields" },
    { 0xDF4EC2FE, "yinc" },
    { 0xE9F1BFF0, "yline" },
    { 0x54058C6D, "ylo" },
    { 0x703262F5, "ym0" },
    { 0xBC3757C7, "ym2" },
    { 0xFB11F055, "yo" },
    { 0xB8047A5A, "yo_bitch_play_stuff" },
    { 0x81584CAD, "yoff" },
    { 0x15DDE6FF, "yoffset" },
    { 0xA067ADD4, "york" },
    { 0x331B63D2, "you" },
    { 0xC6D79762, "youll" },
    { 0x9BD7E0D7, "young" },
    { 0x5B5F8D05, "young_soldier_dead" },
    { 0x280952DF, "young_soldier_dead_starts" },
    { 0xDB8B9B12, "young_soldier_dies" },
    { 0x1A902274, "your" },
    { 0xDE5ACD23, "your_level_name" },
    { 0x59E6A5CC, "your_number" },
    { 0x932E1A81, "youre" },
    { 0x17155267, "yours" },
    { 0xE6269A7A, "yourself" },
    { 0x7DE77FD2, "yourselves" },
    { 0x381A90AE, "youth" },
    { 0x64693808, "ypos" },
    { 0x6042EDC4, "ypr" },
    { 0x4965E8F7, "yro" },
    { 0x931BD9F9, "ys" },
    { 0x2FBFCA20, "ystep" },
    { 0x8E34774B, "yt1" },
    { 0x1C2D0810, "yt2" },
    { 0x0C2919B1, "yuck" },
    { 0xDBFB0864, "yuill" },
    { 0x6767FD4D, "yup" },
    { 0xDD43328C, "yuri" },
    { 0xA817C4BC, "yvect" },
    { 0x037D22DD, "z" },
    { 0x2F6FE0C5, "z2" },
    { 0xFF688E39, "z_barrier" },
    { 0x401DF898, "z_check" },
    { 0x5288C79F, "z_cutoff" },
    { 0x7EDD1F62, "z_delta" },
    { 0x6A8C5235, "z_diff" },
    { 0x4F994D00, "z_dist" },
    { 0xD72E3E77, "z_increment" },
    { 0xFED5A76C, "z_initial" },
    { 0xD63CBA6E, "z_llim" },
    { 0x36B4B71E, "z_mov" },
    { 0xBAD7F567, "z_move" },
    { 0x5FF71102, "z_moveto_offset" },
    { 0x7E39B8E9, "z_offset" },
    { 0xED7D3ED8, "z_rlim" },
    { 0xE239597A, "z_target_offset_override" },
    { 0x60E72C84, "z_upper" },
    { 0x2AC38233, "z_value" },
    { 0x98BDAAF9, "z_velocity" },
    { 0x24D68750, "z_wire_max" },
    { 0x3A0709D5, "zag" },
    { 0x71E94CE9, "zak" },
    { 0xA1B53407, "zak_arm_blood" },
    { 0xFB8B6418, "zak_arm_blood_pump" },
    { 0xB78DA5E4, "zak_blood" },
    { 0xCD85AC6D, "zak_blood_pool" },
    { 0x9BBA0629, "zak_car_org" },
    { 0x5E2B6901, "zak_dies" },
    { 0x1C1BF331, "zak_dot" },
    { 0x9083FB39, "zak_gaz_spot" },
    { 0x92FB5E08, "zak_got_hit" },
    { 0x5C72B2F0, "zak_griggs_spot" },
    { 0x18168D6E, "zak_org" },
    { 0x9DE9B484, "zak_pain" },
    { 0x6E0648BE, "zak_price_spot" },
    { 0x656EDF6D, "zak_price_spot_hide" },
    { 0x1ACE33C8, "zak_spawns" },
    { 0x748814AF, "zak_timer" },
    { 0x458C1BF1, "zakhaev" },
    { 0x8EF9AF15, "zakhaev_buddy1" },
    { 0xB4FC297E, "zakhaev_buddy2" },
    { 0x1B28B3A6, "zakhaev_buddy2_execute_guy" },
    { 0xA2F27E30, "zakmodel" },
    { 0x068A559B, "zakmodels" },
    { 0xAA02E460, "zaks" },
    { 0x5664AED2, "zangle" },
    { 0x2827412A, "zap" },
    { 0xCC04E5B6, "zap_player" },
    { 0x8D8732AE, "zap_wait" },
    { 0x0ADE6E63, "zap_zombie" },
    { 0xA034A791, "zapped" },
    { 0x83A6B1FD, "zapped_zombies" },
    { 0xE46B2C97, "zapper" },
    { 0x4AAED162, "zapper_counter" },
    { 0x0A0AB8E1, "zapper_counter_1000s" },
    { 0x9614BA55, "zapper_counter_100s" },
    { 0x4F3702B1, "zapper_counter_10s" },
    { 0xA6414265, "zapper_counter_1s" },
    { 0x06ACB4C1, "zapper_forward" },
    { 0x04CD579B, "zapper_fx_org" },
    { 0x44ED4C30, "zapper_fx_switch_org" },
    { 0xF734E19C, "zapper_installed" },
    { 0x3E008052, "zapper_kill_count" },
    { 0xAF6FCF62, "zapper_light_green" },
    { 0xB46B8842, "zapper_light_red" },
    { 0x57128C31, "zapper_lights" },
    { 0x8D0F5653, "zapper_power_box" },
    { 0xAB69FA50, "zapper_proximity_warning_activate" },
    { 0x6020A529, "zapper_proximity_warning_deactivate" },
    { 0x2DE5EB41, "zapper_proximity_warning_think" },
    { 0x965CD1AF, "zapper_switch_fx" },
    { 0x93ACA931, "zapper_up" },
    { 0x81AF7CD1, "zapperfx" },
    { 0x17336FC6, "zapperreadyfx" },
    { 0xECC3DA78, "zapperstruct" },
    { 0x3178D4C9, "zappervalues" },
    { 0xBE7E0340, "zaring" },
    { 0xB43D5425, "zavimbi" },
    { 0xE220ED8A, "zbarrier" },
    { 0xE90A14D7, "zbarrier_origin" },
    { 0x20186B11, "zbarrier_override" },
    { 0xE2595AB2, "zbarrier_override_tear_in" },
    { 0x2EF50DF0, "zbarrier_pieces" },
    { 0x8CA59341, "zbarrier_script_string_sets_collision" },
    { 0x7386EB03, "zbarrier_state_change" },
    { 0xE9AF5639, "zbarrier_zombie_tear_notetrack_override" },
    { 0x5D32B66C, "zbarriergetpiece" },
    { 0x01B642BA, "zbarrierpieceuseattachweapon" },
    { 0x479CF0DF, "zbarrierpieceuseboxriselogic" },
    { 0x183F63B3, "zbarrierpieceusedefaultmodel" },
    { 0x912CFE6C, "zbarrierpieceuseupgradedmodel" },
    { 0xFEE903C5, "zbarriers" },
    { 0x828DF1A7, "zbarriersupportszombiereachthroughattacks" },
    { 0x8EFC1E67, "zbarriersupportszombietaunts" },
    { 0x55942D64, "zbot_spawn" },
    { 0x5C6F3AE5, "zbot_spawn_think" },
    { 0x82DED253, "zcheck" },
    { 0x91B17C43, "zclassic" },
    { 0x04F59200, "zclassic_init" },
    { 0xC33DE839, "zclassic_main" },
    { 0xFFAF2067, "zclassic_preinit" },
    { 0x19E47704, "zcleansed" },
    { 0x07DF558F, "zcleansed_logic" },
    { 0xCABCD644, "zcleansed_powerup_custom_time_logic" },
    { 0x30C216C6, "zcleansed_powerup_grab" },
    { 0x9E805E40, "zcleansed_preinit" },
    { 0x939BDDD5, "zcleansed_zombie_powerup_grab" },
    { 0x17759AF7, "zcon" },
    { 0x91DEC4BB, "zcontainment" },
    { 0x00FF93BF, "zcontainment_preinit" },
    { 0x41E839B8, "zcoordmod" },
    { 0xC137B294, "zctivation" },
    { 0xE6863AD0, "zda" },
    { 0x63E7E2FD, "zdeadpool" },
    { 0xAF41AAF5, "zdeadpool_preinit" },
    { 0xD5C440F5, "zdelta" },
    { 0xA0A6A5D8, "zdetect" },
    { 0x7856E9AC, "zdiff" },
    { 0x0AA76F20, "zdifference" },
    { 0x501A9D6C, "zdisplacement" },
    { 0x563A9FDD, "zdist" },
    { 0x6FBBA7C5, "zdist2" },
    { 0xA925D8E0, "zdistcurrent" },
    { 0xDE0AE518, "zdistcurrentsq" },
    { 0xDC392CF3, "zee" },
    { 0x90343821, "zeg" },
    { 0x63630A1C, "zeitzev" },
    { 0x3C7C8163, "zero" },
    { 0x4BC8A108, "zero_accuracy_override" },
    { 0x7B688A77, "zero_announce_position" },
    { 0xE6FEBDCC, "zero_attachment_perc" },
    { 0x331395D0, "zero_boundary_watch" },
    { 0xED4823C8, "zero_client_stat" },
    { 0x9906359D, "zero_cloud" },
    { 0x133223F3, "zero_count" },
    { 0x09108338, "zero_damage_thread" },
    { 0xB9EB1A1C, "zero_death_count" },
    { 0xE23F0CE3, "zero_death_thread" },
    { 0x6D36373D, "zero_death_thread_water_hit" },
    { 0xEC65CAF7, "zero_end_spline_delete" },
    { 0xEF37496D, "zero_fly_fake_spline" },
    { 0xD1D1EA15, "zero_get_damage_point" },
    { 0x7FCD9EC4, "zero_idle_movement" },
    { 0xBF36F95B, "zero_kamikaze_rescue_3" },
    { 0x59BE2BCD, "zero_killed" },
    { 0x4722B0EC, "zero_max_speed" },
    { 0xAC45AF4A, "zero_min_speed" },
    { 0xC02FBDD5, "zero_number" },
    { 0x94089A55, "zero_old_count" },
    { 0xF13662DB, "zero_path" },
    { 0x9F714A17, "zero_piece_damage_thread" },
    { 0xE0EE9D05, "zero_plane_init" },
    { 0xE269C366, "zero_speed_start_time" },
    { 0x9418DADA, "zero_speed_warning_reset" },
    { 0x7C181DAE, "zero_spin_prop" },
    { 0x79EA38A5, "zero_spline_fire_start" },
    { 0xF07E15F4, "zero_squad" },
    { 0x3224D642, "zero_squad_fly_fake_spline" },
    { 0x81D7BC8F, "zero_strafe_defending_boat" },
    { 0x22D428EC, "zero_strafe_getaway_part_1" },
    { 0xB475AD47, "zero_strafe_sinking_pby" },
    { 0x52453EE2, "zero_x" },
    { 0x8DE6B972, "zeroalphatime" },
    { 0x26B94C58, "zeroed" },
    { 0xE5438C59, "zeroed_ang" },
    { 0xD0A2FEA7, "zeroes" },
    { 0x45A235DD, "zeroflyby" },
    { 0x0DE81D08, "zerogravityvolumeoff" },
    { 0x220BB7A2, "zerogravityvolumeon" },
    { 0x7796863D, "zeroing" },
    { 0x1FEC9B52, "zeros" },
    { 0x1399696B, "zeros_one" },
    { 0x1F057A64, "zerospeed" },
    { 0x5FC97B8F, "zeroth" },
    { 0xBD56D0A1, "zesn" },
    { 0xAD6BA4D2, "zfeather" },
    { 0xCEB3D4D5, "zfrac" },
    { 0x5D383915, "zfrequency" },
    { 0x63D9D446, "zgrief" },
    { 0x848E6BB7, "zgrief_hudmsg" },
    { 0xD4EA6903, "zgrief_init" },
    { 0xA6ED9CB2, "zgrief_main" },
    { 0xF53AC910, "zgrief_mode_fix" },
    { 0x8BD20FC7, "zgrief_player_bled_out_msg" },
    { 0x193D5F06, "zgrief_preinit" },
    { 0x25D9D792, "zgrief_respawn_override" },
    { 0xEADE58DB, "zhao" },
    { 0x2F8B38EA, "zhao_at_bp2wave3" },
    { 0x73719901, "zhao_at_bp3wave3" },
    { 0xBE6A4482, "zhao_bp2" },
    { 0xFF23D332, "zhao_bp2_exit_battle" },
    { 0x5E0C976B, "zhao_bp2_skipto" },
    { 0xE46CBEEB, "zhao_bp3" },
    { 0xD449848B, "zhao_bp3exit" },
    { 0xCADED3EF, "zhao_circle_bp2" },
    { 0x4F258C99, "zhao_goto_bp1wave3" },
    { 0x9959183C, "zhao_goto_bp2wave3" },
    { 0x555CA67B, "zhao_goto_bp3" },
    { 0x7CFEDFCB, "zhao_goto_bp3wave3" },
    { 0xF1D4C5D9, "zhao_goto_wave2" },
    { 0x96A3151C, "zhao_headed_to_reinforce_bp" },
    { 0x024493ED, "zhao_horse" },
    { 0xC854FDA4, "zhao_horse_charge" },
    { 0x6FD77FCA, "zhao_node" },
    { 0xB5A58162, "zhao_proximitywatch" },
    { 0xCB1D634C, "zhao_return_base" },
    { 0x0A91D5A0, "zhao_rtswatch" },
    { 0xA93F04C7, "zhao_set_ignore" },
    { 0x0B2D1F8C, "zhao_shootat_chopper" },
    { 0x3A6831DD, "zhao_skipto_wave1" },
    { 0x8F86EAA7, "zhao_test_loop" },
    { 0xD5A085C8, "zhao_text1" },
    { 0x47A7F503, "zhao_text2" },
    { 0x7E95A6B3, "zhao_to_bp1" },
    { 0x0C8E3778, "zhao_to_bp2" },
    { 0x3290B1E1, "zhao_to_bp3" },
    { 0x81936DE7, "zhao_to_weapons" },
    { 0x06934DBD, "zhao_up" },
    { 0x93F78B11, "zhao_vtol" },
    { 0xA02B97B2, "zhao_vtol_damage_override" },
    { 0x988678FB, "zhao_vtol_setup" },
    { 0x724928BB, "zhao_vulture_struct" },
    { 0x73616BC0, "zhao_wave1_bp1" },
    { 0xD4F7DD5B, "zhaoloc" },
    { 0x6C3E325F, "zhaopkg" },
    { 0x3A58EA44, "zhaos_horse" },
    { 0x77A6C9E9, "zhd" },
    { 0xE9728426, "zid" },
    { 0x8D10B8D9, "zied" },
    { 0xC37009BD, "zig" },
    { 0x36F4D549, "ziggy" },
    { 0x78D51A95, "zigzag" },
    { 0x5613DD46, "zigzag_activation_distance" },
    { 0x50C07476, "zigzag_distance_max" },
    { 0x35CB48C8, "zigzag_distance_min" },
    { 0x94AC32C0, "ziline" },
    { 0x2982E85F, "zinterp" },
    { 0xF140F3F2, "zip" },
    { 0xC41F3F75, "zip_audio" },
    { 0x008E8DF8, "zip_currentweapon" },
    { 0x5BA2B96F, "zip_hint_trig" },
    { 0x4CC9D40C, "zip_line_audio" },
    { 0xD313F19B, "zip_line_stopsound" },
    { 0xCDE809F2, "zip_lines" },
    { 0x9541F284, "zip_path" },
    { 0xD0047899, "zip_rope" },
    { 0xCE43E0CA, "zip_rope_audio" },
    { 0xBF9AD1B3, "zip_trig" },
    { 0x50592DF0, "zipactive" },
    { 0x1ABBE98A, "zipbuytrigger" },
    { 0xF872EA59, "zipdamage" },
    { 0x692F76F7, "zipdamagetrigger" },
    { 0xDDEFFDE7, "zipdamagevolume" },
    { 0xFC2C232A, "zipdone" },
    { 0x27F3715D, "ziphintdeactivated" },
    { 0x93EB9000, "zipinuse" },
    { 0x33CD59E4, "zipline" },
    { 0xF139921C, "zipline_ai_think" },
    { 0x11964DCD, "zipline_allowgun_trig" },
    { 0x102C0A91, "zipline_ally" },
    { 0xCF63B9BF, "zipline_anims" },
    { 0xE787CBCC, "zipline_animtree" },
    { 0xC93466AF, "zipline_call_trigger_think" },
    { 0xE814F050, "zipline_compound" },
    { 0x2757BC84, "zipline_cost" },
    { 0x32D9F79F, "zipline_debug_thread" },
    { 0xAB805164, "zipline_door1" },
    { 0x1D87C09F, "zipline_door2" },
    { 0x4E733D58, "zipline_endpoint_struct" },
    { 0x33214E6F, "zipline_enemies_idle_and_death" },
    { 0x89387478, "zipline_enemies_think" },
    { 0xC34B0B3C, "zipline_event_done" },
    { 0xF3F065E0, "zipline_flags" },
    { 0x3C2A1A01, "zipline_guard_takes_damage" },
    { 0x32E4C7E9, "zipline_guards" },
    { 0x0BD1BEA9, "zipline_hookup" },
    { 0x292FC1CA, "zipline_inbuilding" },
    { 0x7625EEDC, "zipline_infinite_ammo" },
    { 0x9147DC3E, "zipline_look_at_target" },
    { 0x1461A675, "zipline_look_at_window" },
    { 0xDFC9E954, "zipline_main" },
    { 0x90374A35, "zipline_move_along_rope" },
    { 0xF95EDCF7, "zipline_nag_delay" },
    { 0xAAD273C4, "zipline_player_death_disconnect_failsafe" },
    { 0xD9DA804C, "zipline_player_objective" },
    { 0x617D0EED, "zipline_player_think" },
    { 0xCFD46F38, "zipline_return_weapon" },
    { 0xAD07A97E, "zipline_room_damage" },
    { 0x2FC21025, "zipline_room_damage_ramp" },
    { 0x966F891E, "zipline_room_guard_01" },
    { 0x706D0EB5, "zipline_room_guard_02" },
    { 0x4A6A944C, "zipline_room_guard_03" },
    { 0x42141A2C, "zipline_ropeid" },
    { 0x8DE5569A, "zipline_rotate" },
    { 0x610BE4C9, "zipline_setup_crossbow" },
    { 0xD2360045, "zipline_setup_rope" },
    { 0x58CA182C, "zipline_setup_second_rope" },
    { 0x93E841CF, "zipline_startpoint_struct" },
    { 0xB7982CC0, "zipline_time" },
    { 0x20181FFD, "zipline_trig" },
    { 0x3169DFBC, "zipline_trigs" },
    { 0x920E930D, "zipline_truck1" },
    { 0xCA9D7DB4, "zipline_truck1_start" },
    { 0xB8110D76, "zipline_truck2" },
    { 0xCE1BAB67, "zipline_truck2_start" },
    { 0xDE1387DF, "zipline_truck3" },
    { 0x0BFFD63A, "zipline_truck3_start" },
    { 0xAC932511, "zipline_vehicle" },
    { 0xEA7443F8, "zipline_vehicles" },
    { 0x65855699, "zipline_window_hit" },
    { 0x7422D20D, "zipline_windowtrigger" },
    { 0x5D5F04AE, "zipliner" },
    { 0x4A3A0EF4, "zipliner_can_land_here" },
    { 0x83617F17, "ziplines" },
    { 0xA878D791, "ziplinevecto" },
    { 0x40DB096D, "ziplining" },
    { 0x2283C875, "zippo" },
    { 0x7D56E437, "zippo_flamefx" },
    { 0x5292BE4B, "zippo_flametag" },
    { 0xF561F148, "zippo_linktag" },
    { 0xAF174C5B, "zippowertrigger" },
    { 0x00A4278C, "zipshock" },
    { 0x0AE60D5E, "zipthink" },
    { 0xD3EDA968, "ziptie" },
    { 0x0D82CA44, "ziptie_enemy_think" },
    { 0x89737B2F, "ziptie_friendly_think" },
    { 0x4AE727C7, "ziptie_guard_ai" },
    { 0xD72BDE1C, "ziptie_intro_then_loop" },
    { 0x5E3DB0FC, "ziptied" },
    { 0xF6F691EC, "ziw_keys" },
    { 0x271C07AD, "zkeys" },
    { 0xAC8E5D72, "zm" },
    { 0xD5A90C37, "zm_aat_blast_furnace" },
    { 0x0354949D, "zm_aat_blast_furnace_burn" },
    { 0xFF63E348, "zm_aat_blast_furnace_burn_think" },
    { 0x1EA0A980, "zm_aat_blast_furnace_burn_vehicle" },
    { 0x5213A65F, "zm_aat_blast_furnace_cf_name_burn" },
    { 0x70671117, "zm_aat_blast_furnace_cf_name_burn_veh" },
    { 0xA67500ED, "zm_aat_blast_furnace_cf_name_explosion" },
    { 0x33F9F675, "zm_aat_blast_furnace_cf_name_explosion_veh" },
    { 0x2690D7B1, "zm_aat_blast_furnace_cooldown_attacker" },
    { 0xE1A22621, "zm_aat_blast_furnace_cooldown_entity" },
    { 0xF34E4145, "zm_aat_blast_furnace_cooldown_global" },
    { 0x82B97977, "zm_aat_blast_furnace_damage_feedback_icon" },
    { 0xCECE0E39, "zm_aat_blast_furnace_damage_feedback_sound" },
    { 0x8593E8DB, "zm_aat_blast_furnace_delay" },
    { 0x50297B11, "zm_aat_blast_furnace_dot_num_ticks" },
    { 0x01EFAA62, "zm_aat_blast_furnace_dot_tick_rate" },
    { 0xC0B26B7B, "zm_aat_blast_furnace_explosion" },
    { 0xE20241C4, "zm_aat_blast_furnace_explosion_fx" },
    { 0xA64AC9BB, "zm_aat_blast_furnace_explosion_sound" },
    { 0xA2E115CA, "zm_aat_blast_furnace_explosion_think" },
    { 0x44CBB769, "zm_aat_blast_furnace_explosion_time" },
    { 0x76A1734A, "zm_aat_blast_furnace_explosion_vehicle" },
    { 0x0DB9C8B9, "zm_aat_blast_furnace_icon" },
    { 0x62FF13EF, "zm_aat_blast_furnace_localized_string" },
    { 0x366BE0EF, "zm_aat_blast_furnace_name" },
    { 0x4DEC3074, "zm_aat_blast_furnace_occurs_on_death" },
    { 0xFB012682, "zm_aat_blast_furnace_percentage" },
    { 0xAB2483B9, "zm_aat_blast_furnace_range" },
    { 0xD85DA9AE, "zm_aat_dead_wire" },
    { 0x8174DFDC, "zm_aat_dead_wire_cf_name_zap" },
    { 0xDDAD2B88, "zm_aat_dead_wire_cf_name_zap_veh" },
    { 0x110F3C34, "zm_aat_dead_wire_cooldown_attacker" },
    { 0xABA3E1E8, "zm_aat_dead_wire_cooldown_entity" },
    { 0xD573CFFC, "zm_aat_dead_wire_cooldown_global" },
    { 0x921D8BA0, "zm_aat_dead_wire_damage_feedback_icon" },
    { 0xD1DE046C, "zm_aat_dead_wire_damage_feedback_sound" },
    { 0xB50355FA, "zm_aat_dead_wire_delay" },
    { 0xEBB15D4A, "zm_aat_dead_wire_icon" },
    { 0x763A59FC, "zm_aat_dead_wire_lightning_chain_params" },
    { 0x688F14D4, "zm_aat_dead_wire_localized_string" },
    { 0x3BDC9EC3, "zm_aat_dead_wire_max_arcs" },
    { 0x9E615054, "zm_aat_dead_wire_name" },
    { 0xB4FEEA75, "zm_aat_dead_wire_occurs_on_death" },
    { 0x9B96E8E5, "zm_aat_dead_wire_percentage" },
    { 0xE78B261C, "zm_aat_dead_wire_range" },
    { 0x522B211A, "zm_aat_dead_wire_zap" },
    { 0xB1AA7196, "zm_aat_dead_wire_zap_sound" },
    { 0x0F1245D3, "zm_aat_dead_wire_zap_vehicle" },
    { 0xF3CCCCA2, "zm_aat_dead_wire_zombie_slow_total_time" },
    { 0xA28F41F0, "zm_aat_dead_wire_zombie_zap_fx" },
    { 0xA7E7EF63, "zm_aat_fire_works" },
    { 0xABE8074D, "zm_aat_fire_works_cooldown_attacker" },
    { 0xACAF1F15, "zm_aat_fire_works_cooldown_entity" },
    { 0x2307D1D9, "zm_aat_fire_works_cooldown_global" },
    { 0x7D86FCA3, "zm_aat_fire_works_damage_feedback_icon" },
    { 0x9803A82D, "zm_aat_fire_works_damage_feedback_sound" },
    { 0x9B6B7072, "zm_aat_fire_works_death_callback" },
    { 0x287A9C9D, "zm_aat_fire_works_explode_sound" },
    { 0xCAB444CF, "zm_aat_fire_works_firing_num_frames" },
    { 0x5AFEEC5A, "zm_aat_fire_works_get_target" },
    { 0xB973F285, "zm_aat_fire_works_icon" },
    { 0x10449163, "zm_aat_fire_works_localized_string" },
    { 0x63D8A739, "zm_aat_fire_works_max_los_checks" },
    { 0x3BA9A0A3, "zm_aat_fire_works_name" },
    { 0x02653510, "zm_aat_fire_works_occurs_on_death" },
    { 0xEED1BABE, "zm_aat_fire_works_percentage" },
    { 0x93BF4680, "zm_aat_fire_works_range_sq" },
    { 0x272FB293, "zm_aat_fire_works_summon" },
    { 0x24D2F291, "zm_aat_fire_works_summon_burst_fx" },
    { 0xF71F41CC, "zm_aat_fire_works_summon_fx" },
    { 0x361CE0E1, "zm_aat_fire_works_summon_time" },
    { 0xFF65648F, "zm_aat_fire_works_summon_trail_fx" },
    { 0x446FE502, "zm_aat_fire_works_zombie_damage_response" },
    { 0xE7220ECF, "zm_aat_fire_works_zombie_gun_height" },
    { 0x2FFD891D, "zm_aat_thunder_wall" },
    { 0x9B2B89AA, "zm_aat_thunder_wall_break_fx" },
    { 0xEBA7AC60, "zm_aat_thunder_wall_cf_name_break_fx" },
    { 0xCF2982AF, "zm_aat_thunder_wall_cf_name_wall_fx" },
    { 0xAACDA393, "zm_aat_thunder_wall_cooldown_attacker" },
    { 0x60E43AEB, "zm_aat_thunder_wall_cooldown_entity" },
    { 0x029617FF, "zm_aat_thunder_wall_cooldown_global" },
    { 0x69401A55, "zm_aat_thunder_wall_damage_feedback_icon" },
    { 0x3D904F83, "zm_aat_thunder_wall_damage_feedback_sound" },
    { 0x8FB5A86D, "zm_aat_thunder_wall_delay" },
    { 0xBA733A85, "zm_aat_thunder_wall_explosion_sound" },
    { 0x5B954739, "zm_aat_thunder_wall_force" },
    { 0xAC0D5A0E, "zm_aat_thunder_wall_fx_time" },
    { 0x19AEB723, "zm_aat_thunder_wall_icon" },
    { 0xFAC6082D, "zm_aat_thunder_wall_localized_string" },
    { 0x1D0D3939, "zm_aat_thunder_wall_max_zombies_flung" },
    { 0xA9C12589, "zm_aat_thunder_wall_name" },
    { 0x2E486862, "zm_aat_thunder_wall_occurs_on_death" },
    { 0xCCA9D1A0, "zm_aat_thunder_wall_percentage" },
    { 0xC7CAA5DF, "zm_aat_thunder_wall_range" },
    { 0xEA8E3FAD, "zm_aat_thunder_wall_sound" },
    { 0x164A28A5, "zm_aat_thunder_wall_upward_angle" },
    { 0x2ABC80C6, "zm_aat_turned" },
    { 0x47A93E3E, "zm_aat_turned_cb" },
    { 0x41C2D5AC, "zm_aat_turned_cooldown_attacker" },
    { 0x219518C0, "zm_aat_turned_cooldown_entity" },
    { 0x2225A674, "zm_aat_turned_cooldown_global" },
    { 0x64EA3148, "zm_aat_turned_damage_feedback_icon" },
    { 0x45273AD4, "zm_aat_turned_damage_feedback_sound" },
    { 0x40A9D0B6, "zm_aat_turned_force" },
    { 0x197973F2, "zm_aat_turned_icon" },
    { 0x3BA68871, "zm_aat_turned_kill_limit" },
    { 0x4FD4AA9A, "zm_aat_turned_max_zombies_flung" },
    { 0xCDEE5FCC, "zm_aat_turned_name" },
    { 0xDBA2EA3A, "zm_aat_turned_name_localized_string" },
    { 0xD552DB7D, "zm_aat_turned_occurs_on_death" },
    { 0x35ED32CD, "zm_aat_turned_percentage" },
    { 0xF085C814, "zm_aat_turned_range" },
    { 0x80D827DA, "zm_aat_turned_sound" },
    { 0x9281E849, "zm_aat_turned_sprint_variant_max_arms_down" },
    { 0xC139AB96, "zm_aat_turned_sprint_variant_max_arms_up" },
    { 0xD6173242, "zm_aat_turned_time_limit" },
    { 0x75658434, "zm_aat_turned_upward_angle" },
    { 0xB955C8E7, "zm_aat_turned_validation_override" },
    { 0xB864F9AA, "zm_aat_turned_zombie_eye_fx" },
    { 0xF2F08C50, "zm_aat_turned_zombie_torso_fx" },
    { 0xCC5BAC97, "zm_ai_dogs" },
    { 0xEAD4E3C8, "zm_ai_faller" },
    { 0x5ACE0F0E, "zm_ai_raps" },
    { 0x30B36B7B, "zm_ai_round_over" },
    { 0xB1CA30AF, "zm_ai_wasp" },
    { 0x5A8856E4, "zm_alcatraz_amb" },
    { 0xB477AB0C, "zm_alcatraz_classic" },
    { 0xE9BB1BE9, "zm_alcatraz_craftables" },
    { 0xD24B9143, "zm_alcatraz_distance_tracking" },
    { 0xE84F36C6, "zm_alcatraz_gamemodes" },
    { 0x99824F6B, "zm_alcatraz_grief_cellblock" },
    { 0xC8389234, "zm_alcatraz_sq" },
    { 0xAD8D3FE2, "zm_alcatraz_sq_nixie" },
    { 0x89D78A22, "zm_alcatraz_sq_vo" },
    { 0xF6C0A7EC, "zm_alcatraz_traps" },
    { 0x358C17D8, "zm_alcatraz_travel" },
    { 0x74AB598C, "zm_alcatraz_utility" },
    { 0xD9255BE0, "zm_alcatraz_weap_quest" },
    { 0x8A7BA1FE, "zm_altbody" },
    { 0xAEB44471, "zm_att_blast_furnace_burn_fx" },
    { 0xEDE0706C, "zm_attackables" },
    { 0x5E101899, "zm_attacking_spot_dist" },
    { 0xAAB55CF5, "zm_audio" },
    { 0xD746D8E1, "zm_audio_announcer" },
    { 0x4DEB1DAF, "zm_ball_picked_up" },
    { 0xAEA44F69, "zm_ball_shot" },
    { 0xC1BD5BF7, "zm_behavior" },
    { 0xE2CF0456, "zm_behavior_utility" },
    { 0x58569CEC, "zm_bgb_crate_power_used" },
    { 0x21885F41, "zm_bgb_machine_audio_tell_cooldown" },
    { 0x8E48E723, "zm_bgb_machine_audio_tell_distance" },
    { 0x28D481B7, "zm_bgb_machine_audio_tell_height_threshold" },
    { 0x3430C24D, "zm_bgb_machine_available_fx" },
    { 0x0846D3F9, "zm_bgb_machine_available_fx_name" },
    { 0xDEB3FDE0, "zm_bgb_machine_available_fx_tag" },
    { 0xC7F415FF, "zm_bgb_machine_away_piece_index" },
    { 0x28F0494A, "zm_bgb_machine_base_piece_index" },
    { 0x7136CC1F, "zm_bgb_machine_bulb_activated_fx" },
    { 0xC1E417B7, "zm_bgb_machine_bulb_activated_fx_name" },
    { 0x6D9FB07B, "zm_bgb_machine_bulb_available_fx" },
    { 0x1C9CF7DB, "zm_bgb_machine_bulb_available_fx_name" },
    { 0xBB47D3C8, "zm_bgb_machine_bulb_away_fx" },
    { 0xE4887112, "zm_bgb_machine_bulb_away_fx_name" },
    { 0x470EF49C, "zm_bgb_machine_bulb_event_fx" },
    { 0x80B30BDE, "zm_bgb_machine_bulb_event_fx_name" },
    { 0xF5C05C12, "zm_bgb_machine_bulb_fx_tag_side_btm_left" },
    { 0xEC024D81, "zm_bgb_machine_bulb_fx_tag_side_btm_right" },
    { 0x21325481, "zm_bgb_machine_bulb_fx_tag_side_mid_left" },
    { 0xF0D50D6C, "zm_bgb_machine_bulb_fx_tag_side_mid_right" },
    { 0x1BA8F3DC, "zm_bgb_machine_bulb_fx_tag_side_top_left" },
    { 0xB94C6B33, "zm_bgb_machine_bulb_fx_tag_side_top_right" },
    { 0xDB29528E, "zm_bgb_machine_bulb_fx_tag_top" },
    { 0xE046D03F, "zm_bgb_machine_bulb_rounds_fx" },
    { 0x22AD2297, "zm_bgb_machine_bulb_rounds_fx_name" },
    { 0xBF1E0E99, "zm_bgb_machine_bulb_spark_fx" },
    { 0xC299527D, "zm_bgb_machine_bulb_spark_fx_name" },
    { 0x36D76BDB, "zm_bgb_machine_bulb_time_fx" },
    { 0x861E257B, "zm_bgb_machine_bulb_time_fx_name" },
    { 0x48529A6A, "zm_bgb_machine_cf_name" },
    { 0x06368E7C, "zm_bgb_machine_cost" },
    { 0xC0DE584F, "zm_bgb_machine_eye_activated_fx" },
    { 0x67BDF327, "zm_bgb_machine_eye_activated_fx_name" },
    { 0x6FDB30B8, "zm_bgb_machine_eye_away_fx" },
    { 0x7C93E882, "zm_bgb_machine_eye_away_fx_name" },
    { 0xE214512C, "zm_bgb_machine_eye_event_fx" },
    { 0x46F9786E, "zm_bgb_machine_eye_event_fx_name" },
    { 0xCB27497E, "zm_bgb_machine_eye_fx_tag_left" },
    { 0xC8479CB5, "zm_bgb_machine_eye_fx_tag_right" },
    { 0xBA652E0F, "zm_bgb_machine_eye_rounds_fx" },
    { 0x310981E7, "zm_bgb_machine_eye_rounds_fx_name" },
    { 0x27D5EB2B, "zm_bgb_machine_eye_time_fx" },
    { 0x80307B8B, "zm_bgb_machine_eye_time_fx_name" },
    { 0x4207E1BF, "zm_bgb_machine_flying_elec_fx" },
    { 0x8F17F717, "zm_bgb_machine_flying_elec_fx_name" },
    { 0x3BCF3AEA, "zm_bgb_machine_flying_elec_fx_tag" },
    { 0x4C2CB939, "zm_bgb_machine_flying_embers_down_fx" },
    { 0x654A885D, "zm_bgb_machine_flying_embers_down_fx_name" },
    { 0x763043D7, "zm_bgb_machine_flying_embers_fx_tag" },
    { 0x4F1432AC, "zm_bgb_machine_flying_embers_up_fx" },
    { 0x5FECBCEE, "zm_bgb_machine_flying_embers_up_fx_name" },
    { 0xCC30D6A2, "zm_bgb_machine_flying_gumballs_piece_index" },
    { 0x67C4AEED, "zm_bgb_machine_fx_state_cf_available" },
    { 0xB7FAE84A, "zm_bgb_machine_fx_state_cf_away" },
    { 0xA8A6F4C7, "zm_bgb_machine_fx_state_cf_give" },
    { 0x53E4696E, "zm_bgb_machine_fx_state_cf_moving" },
    { 0xA061BF55, "zm_bgb_machine_fx_state_cf_name" },
    { 0x8B451E16, "zm_bgb_machine_ghost_ball_cf_name" },
    { 0x17DE3660, "zm_bgb_machine_ghost_ball_wait" },
    { 0xFA92566D, "zm_bgb_machine_give_gumball_piece_index" },
    { 0x21C22A18, "zm_bgb_machine_gumball_ghost_fx" },
    { 0x6F2ED822, "zm_bgb_machine_gumball_ghost_fx_name" },
    { 0x94958279, "zm_bgb_machine_gumball_ghost_fx_tag" },
    { 0x39CC9CA9, "zm_bgb_machine_gumball_halo_fx" },
    { 0x94C226CD, "zm_bgb_machine_gumball_halo_fx_name" },
    { 0x89F3E404, "zm_bgb_machine_gumball_halo_fx_tag" },
    { 0x82887642, "zm_bgb_machine_light_interior_away_fx" },
    { 0x29242590, "zm_bgb_machine_light_interior_away_fx_name" },
    { 0xC1F4837D, "zm_bgb_machine_light_interior_fx" },
    { 0xDC1F9EA9, "zm_bgb_machine_light_interior_fx_name" },
    { 0xB1EDF0D0, "zm_bgb_machine_light_interior_fx_tag" },
    { 0x5051E4DA, "zm_bgb_machine_player_buys_cf_name" },
    { 0xE18DB7F9, "zm_bgb_machine_selection_cf_name" },
    { 0x7A626BD5, "zm_bgb_machine_shake_piece_index" },
    { 0x9FEBD2E3, "zm_bgb_machine_smoke_fx" },
    { 0xA3386B23, "zm_bgb_machine_smoke_fx_name" },
    { 0xA5229096, "zm_bgb_machine_smoke_fx_tag" },
    { 0x3BA768C3, "zm_bgb_machine_static_gumballs_piece_index" },
    { 0xE137315D, "zm_bgb_machine_targetname" },
    { 0xFB6D5153, "zm_bgb_near_death_experience" },
    { 0xF9C8C638, "zm_bgb_near_death_experience_1p_fx_stop_" },
    { 0x048B6019, "zm_bgb_secret_shopper" },
    { 0x144DE88E, "zm_bgb_unbearable" },
    { 0x5F7CF93D, "zm_bgb_wall_power_used" },
    { 0xD95B3770, "zm_blockers" },
    { 0x09E79EA0, "zm_board_melee_dist_sq" },
    { 0xA55E0588, "zm_board_trigger_dist_sq" },
    { 0xFE951448, "zm_bot" },
    { 0xF3C92372, "zm_buildables" },
    { 0xDA596616, "zm_buried" },
    { 0xC6B5C506, "zm_buried_achievement" },
    { 0x1A402057, "zm_buried_amb" },
    { 0x39848DA9, "zm_buried_buildable_pickedup_vo" },
    { 0x962F8D7E, "zm_buried_buildables" },
    { 0x6C1DCD6B, "zm_buried_classic" },
    { 0x03F0C6A7, "zm_buried_common_init" },
    { 0xF002D62C, "zm_buried_distance_tracking" },
    { 0xE70DD1EB, "zm_buried_ee" },
    { 0xB4279568, "zm_buried_ffotd" },
    { 0x71276F65, "zm_buried_fountain" },
    { 0xAA6A07B3, "zm_buried_fx" },
    { 0xB8D48261, "zm_buried_gamemodes" },
    { 0x64926490, "zm_buried_grief_street" },
    { 0xAFE495F5, "zm_buried_jail" },
    { 0x7C594A40, "zm_buried_maze" },
    { 0xEDD634C9, "zm_buried_maze_changed" },
    { 0x1DA28F18, "zm_buried_power" },
    { 0x6EA19405, "zm_buried_sq" },
    { 0x5023963A, "zm_buried_sq_bt" },
    { 0xC5323768, "zm_buried_sq_ctw" },
    { 0x57777F06, "zm_buried_sq_ftl" },
    { 0x3B578439, "zm_buried_sq_gl" },
    { 0x32AFCC7B, "zm_buried_sq_ip" },
    { 0x86309B80, "zm_buried_sq_ll" },
    { 0x3129A7B0, "zm_buried_sq_mta" },
    { 0x01AE75ED, "zm_buried_sq_ows" },
    { 0xA541261B, "zm_buried_sq_tpo" },
    { 0x470C249F, "zm_buried_sq_ts" },
    { 0xC92DC4E7, "zm_buried_turned_street" },
    { 0xC4B8969A, "zm_can_stumble" },
    { 0x850186EC, "zm_character_customization" },
    { 0x759AE0F8, "zm_character_dempsey" },
    { 0x3313EA26, "zm_character_nikolai" },
    { 0x0C236EFB, "zm_character_richtofen" },
    { 0xAFE3927B, "zm_character_takeo" },
    { 0x22B15A18, "zm_character_zod_beast" },
    { 0x3E501F30, "zm_clone" },
    { 0x90D3A051, "zm_combat" },
    { 0xABD96E8B, "zm_craft_shield" },
    { 0xF37770C8, "zm_craftables" },
    { 0x9F7644A5, "zm_craftables_fully_crafted_ui_duration" },
    { 0x3BC0DF91, "zm_craftables_lookat_dot" },
    { 0xB5422B7D, "zm_craftables_not_enough_pieces_ui_duration" },
    { 0x0B61DA21, "zm_crawler_push_disable_time" },
    { 0x18CCD228, "zm_crawler_push_dist_sq" },
    { 0x507242BB, "zm_custom_get_next_raps_round" },
    { 0xAD6409DE, "zm_custom_get_next_wasp_round" },
    { 0x760B62E2, "zm_custom_perk_random_power_flag" },
    { 0x22E6D2CD, "zm_custom_spawn_location_selection" },
    { 0x880F7825, "zm_daily_challenges" },
    { 0x49207008, "zm_dash_stats_game_end" },
    { 0x0D6EE2AB, "zm_dash_stats_game_start" },
    { 0x471C122B, "zm_dash_stats_wait_for_consumable_use" },
    { 0x0308EA7D, "zm_death" },
    { 0x152B27C8, "zm_death_visionset" },
    { 0x2D54C0A7, "zm_devgui" },
    { 0xF6E1392F, "zm_devgui_jetgun_never_overheat" },
    { 0x5A0E3356, "zm_disable_recording_buildable_stats" },
    { 0x37CA9E8F, "zm_disable_recording_stats" },
    { 0x82720A8B, "zm_dogs_hero_weapon_kill_power" },
    { 0x56434E5D, "zm_elemental_looping_anim" },
    { 0x2EDA5CA1, "zm_elemental_ring_enter_duration" },
    { 0x01F84F0B, "zm_elemental_ring_exit_duration" },
    { 0xEA2FBA69, "zm_elemental_ring_loop_duration" },
    { 0x7024E8CD, "zm_elemental_round_vision_file" },
    { 0x6F0CFEBC, "zm_elemental_round_visionset" },
    { 0x8B9F3A75, "zm_elemental_vision_lerp_count" },
    { 0x3822249D, "zm_elemental_vision_overlay_priority" },
    { 0x779AD13A, "zm_entrance_dist" },
    { 0xAE771217, "zm_equip_riotshield" },
    { 0x70202871, "zm_equip_shield" },
    { 0xC94F8120, "zm_equip_turret" },
    { 0x03B5DE3F, "zm_equipment" },
    { 0x7237F024, "zm_equipment_health" },
    { 0x1437A8B5, "zm_factory" },
    { 0x7F5DE500, "zm_factory_amb" },
    { 0x91DD4F37, "zm_factory_art" },
    { 0xE59F4632, "zm_factory_fx" },
    { 0x04C372A0, "zm_factory_teleporter" },
    { 0x4B0A4FE4, "zm_ffotd" },
    { 0xBB5E2F1C, "zm_find_flesh_radius" },
    { 0xA2B7236A, "zm_game_module" },
    { 0x353BAFBB, "zm_game_module_utility" },
    { 0x4A962F04, "zm_gamemodule_spawn_func" },
    { 0x06BF4903, "zm_gametype" },
    { 0x1CFEB160, "zm_giant" },
    { 0x06A8BFF1, "zm_giant_amb" },
    { 0xDE8B946E, "zm_giant_cleanup_mgr" },
    { 0xEC9BBB51, "zm_giant_fx" },
    { 0xE33FC163, "zm_giant_teleporter" },
    { 0xD96DFDC0, "zm_global" },
    { 0x7356AC45, "zm_goal_delay_far_max" },
    { 0x5E3804AB, "zm_goal_delay_far_min" },
    { 0x266B20CE, "zm_goal_delay_near_max" },
    { 0x79428F90, "zm_goal_delay_near_min" },
    { 0xA814A341, "zm_goal_dist_far" },
    { 0x07AC0A78, "zm_goal_dist_near" },
    { 0x4E2D876B, "zm_health_blur_overlay_blur_amount" },
    { 0x7FB73DBB, "zm_health_blur_overlay_duration_in" },
    { 0xB4EB5BC4, "zm_health_blur_overlay_duration_loop" },
    { 0x63D810AE, "zm_health_blur_overlay_duration_out" },
    { 0xEA12BDAC, "zm_health_blur_overlay_lerp_count" },
    { 0x85E83DFD, "zm_health_blur_overlay_outer_radius" },
    { 0x232BB02B, "zm_health_blur_overlay_priority" },
    { 0x8ABED61C, "zm_health_blur_overlay_should_offset" },
    { 0xC60248F8, "zm_health_blur_overlay_should_velocity" },
    { 0x46B23DD3, "zm_health_blur_overlay_should_velocity_scale" },
    { 0x082469E5, "zm_health_blur_overlay_time_fade_in" },
    { 0xCE747164, "zm_health_blur_overlay_time_fade_out" },
    { 0x8D62AE7A, "zm_health_blur_screen_effect_name" },
    { 0xF3CDEA9B, "zm_health_bluroverlay_inner_radius" },
    { 0x2C104D04, "zm_hero_weapon" },
    { 0xEF5D9A16, "zm_highrise" },
    { 0x1343B906, "zm_highrise_achievement" },
    { 0x78539457, "zm_highrise_amb" },
    { 0x54F2497E, "zm_highrise_buildables" },
    { 0x64F4816B, "zm_highrise_classic" },
    { 0x60812A2C, "zm_highrise_distance_tracking" },
    { 0x8AF212F6, "zm_highrise_elevators" },
    { 0x776A2968, "zm_highrise_ffotd" },
    { 0x7B0143B3, "zm_highrise_fx" },
    { 0x82AC5661, "zm_highrise_gamemodes" },
    { 0xD99B2E18, "zm_highrise_pandora_fx_func" },
    { 0x3F38D005, "zm_highrise_sq" },
    { 0x6FF9A171, "zm_highrise_sq_atd" },
    { 0x936CCD3F, "zm_highrise_sq_pts" },
    { 0x21923DDD, "zm_highrise_sq_slb" },
    { 0xC88FA6D6, "zm_highrise_sq_ssp" },
    { 0x62FA2DCF, "zm_highrise_utility" },
    { 0x6C40327A, "zm_highrise_zone_monitor_callback" },
    { 0x460EE6CB, "zm_idgun_hole_pull_acc" },
    { 0x33DF4FFA, "zm_idgun_hole_pull_max_speed" },
    { 0xD20277DF, "zm_init" },
    { 0x482F1ECD, "zm_juke_chance" },
    { 0x928D53E1, "zm_juke_time_max" },
    { 0x3FB5E51F, "zm_juke_time_min" },
    { 0x6F3E8597, "zm_jump_pad" },
    { 0x67E7BEEF, "zm_laststand" },
    { 0xB7B63DEA, "zm_laststand_visionset" },
    { 0x5624CDC1, "zm_load" },
    { 0x3E52B25B, "zm_loc_types" },
    { 0x4100E7E1, "zm_magicbox" },
    { 0xCD651797, "zm_mantle_over_40_move_speed_override" },
    { 0xC58C9E7C, "zm_map_event_craft_piece_pickedup" },
    { 0x2A696B72, "zm_map_event_craftable_built" },
    { 0xD6AFE199, "zm_map_event_craftable_pickedup" },
    { 0xE6384D36, "zm_map_event_craftable_planted" },
    { 0x4155136F, "zm_map_event_enter_beast_mode" },
    { 0x2F37CB97, "zm_map_event_enter_bubblegum_grabbed" },
    { 0x2B8E9043, "zm_map_event_enter_bubblegum_used" },
    { 0xAA4AE237, "zm_map_event_enter_super_beast_mode" },
    { 0x6902ED7C, "zm_map_event_invalid" },
    { 0xC41292DE, "zm_map_event_magic_box_offered" },
    { 0x60C26CFC, "zm_map_event_magic_box_returned" },
    { 0xED15B742, "zm_map_event_magic_box_taken" },
    { 0x48B960C4, "zm_map_event_pap_grabbed" },
    { 0x05C7CA52, "zm_map_event_pap_not_grabbed" },
    { 0xF105F343, "zm_map_event_pap_repack_grabbed" },
    { 0x3A42B215, "zm_map_event_pap_repack_not_grabbed" },
    { 0x3280FA67, "zm_map_event_pap_repack_used" },
    { 0x3F7FC32A, "zm_map_event_pap_used" },
    { 0xD3BE4B23, "zm_map_event_perk_machine_used" },
    { 0x013EB88A, "zm_map_event_pod_grabbed" },
    { 0x1F07A4AC, "zm_map_event_power_off" },
    { 0x741A5B56, "zm_map_event_power_on" },
    { 0x6CC84CBB, "zm_map_event_powerup_grabbed" },
    { 0xFE953903, "zm_map_event_purchase_ammo" },
    { 0xC302E089, "zm_map_event_purchase_door" },
    { 0xF970CCCD, "zm_map_event_purchase_gun" },
    { 0xC8A4B86B, "zm_map_event_ritual_ended" },
    { 0x1E9888F0, "zm_map_event_ritual_started" },
    { 0xE975E05F, "zm_map_event_round_end" },
    { 0xF3A3D894, "zm_map_event_round_start" },
    { 0x6F748B47, "zm_melee" },
    { 0xEE647C2E, "zm_melee_dist" },
    { 0x6ECCB6BD, "zm_melee_dist_sq" },
    { 0xC7148089, "zm_melee_jump_chance" },
    { 0x7DC84769, "zm_melee_jump_dist" },
    { 0x1025CA9A, "zm_melee_jump_distance_above" },
    { 0x0F11D4F6, "zm_melee_jump_distance_above_water" },
    { 0x9FECFE45, "zm_melee_water_jump_dist" },
    { 0xBF464D02, "zm_melee_weapon" },
    { 0x20785ACB, "zm_melee_yaw" },
    { 0x0629DBAB, "zm_mgturret" },
    { 0x0899106D, "zm_min_in_water_depth" },
    { 0x535A2969, "zm_mixed_wasp_raps_spawning" },
    { 0xAC4147EF, "zm_mobile_spawn" },
    { 0x3DC929B6, "zm_moon" },
    { 0x7C57D7E6, "zm_moon_achievement" },
    { 0x864E5D9B, "zm_moon_ai_astro" },
    { 0xC7D03B9B, "zm_moon_ai_quad" },
    { 0x0FD83F37, "zm_moon_amb" },
    { 0xBC780F84, "zm_moon_art" },
    { 0x98C95CA3, "zm_moon_digger" },
    { 0xDD7DF2CC, "zm_moon_distance_tracking" },
    { 0x186ADD48, "zm_moon_ffotd" },
    { 0x36389E13, "zm_moon_fx" },
    { 0xA9E990AD, "zm_moon_gravity" },
    { 0x93E4D62B, "zm_moon_jump_pad" },
    { 0xFA702A65, "zm_moon_sq" },
    { 0xECD10753, "zm_moon_sq_be" },
    { 0x488F6343, "zm_moon_sq_ctt" },
    { 0xE4006EEC, "zm_moon_sq_ctvg" },
    { 0x80D0B0A9, "zm_moon_sq_datalogs" },
    { 0xECEAD789, "zm_moon_sq_osc" },
    { 0x32CB7332, "zm_moon_sq_sc" },
    { 0x92F319C2, "zm_moon_sq_ss" },
    { 0x591CE3C5, "zm_moon_teleporter" },
    { 0x2F7147AF, "zm_moon_utility" },
    { 0x00E593E2, "zm_moon_wasteland" },
    { 0x1A4526C0, "zm_move_dist_sq" },
    { 0x3E640AE2, "zm_move_time" },
    { 0xAF0B241A, "zm_net" },
    { 0x365AA67A, "zm_nuked" },
    { 0xA2B6E7AC, "zm_nuked_ffotd" },
    { 0x5132EDAF, "zm_nuked_fx" },
    { 0x338D3F55, "zm_nuked_gamemodes" },
    { 0xA67F66E8, "zm_nuked_perks" },
    { 0xF3CD8706, "zm_nuked_standard" },
    { 0x633AA1F9, "zm_on_player_connect" },
    { 0xEA9F4CDF, "zm_on_player_disconnect" },
    { 0xD1073B91, "zm_on_player_spawned" },
    { 0x716FC13E, "zm_override_ai_aftermath_powerup_drop" },
    { 0x61EA4DD4, "zm_pain_dist_sq_max" },
    { 0xB1E4B463, "zm_pap_util" },
    { 0xC728C6C3, "zm_perk_additionalprimaryweapon" },
    { 0x56D7A026, "zm_perk_deadshot" },
    { 0xF95F1BC4, "zm_perk_doubletap2" },
    { 0xA7884D63, "zm_perk_electric_cherry" },
    { 0xB1EAC770, "zm_perk_juggernaut" },
    { 0x370D9BFC, "zm_perk_phdflopper" },
    { 0xB2D8C6A7, "zm_perk_quick_revive" },
    { 0x95F41F71, "zm_perk_random" },
    { 0x169DC9AD, "zm_perk_random_ball_on_off_piece_index" },
    { 0xEF7B83F4, "zm_perk_random_ball_spin_piece_index" },
    { 0x99EF1E76, "zm_perk_random_body_available_piece_index" },
    { 0x31740D23, "zm_perk_random_body_idle_piece_index" },
    { 0x802CA2D4, "zm_perk_random_body_on_off_piece_index" },
    { 0xB74603D7, "zm_perk_random_bottle_tag_piece_index" },
    { 0xD4A5F873, "zm_perk_random_cost" },
    { 0x1B9B15AC, "zm_perk_random_green_light_bit" },
    { 0x28FF3D58, "zm_perk_random_no_light_bit" },
    { 0xCD399F78, "zm_perk_random_red_light_bit" },
    { 0x6C7F6E32, "zm_perk_random_status_fx_tag" },
    { 0x2341F22D, "zm_perk_random_yellow_light_bit" },
    { 0xB3116A5E, "zm_perk_sleight_of_hand" },
    { 0x4E64316D, "zm_perk_staminup" },
    { 0x21F2CB7F, "zm_perk_widows_wine" },
    { 0x74C57FC0, "zm_perks" },
    { 0x95ADD22B, "zm_pers_upgrades" },
    { 0x25F8C2AD, "zm_pers_upgrades_functions" },
    { 0xD93D7691, "zm_pers_upgrades_system" },
    { 0x6A494388, "zm_placeable_mine" },
    { 0x3FA4841E, "zm_player" },
    { 0x336B1965, "zm_player_fake_death" },
    { 0x3B22B3BC, "zm_player_fake_death_cleanup" },
    { 0x4DBD061A, "zm_player_position_height" },
    { 0xCC592887, "zm_player_position_max" },
    { 0x6F38E0F9, "zm_player_position_min" },
    { 0xFFBCEFB1, "zm_player_spacing_inner" },
    { 0x2547AB20, "zm_playerhealth" },
    { 0x470978A5, "zm_position_query_last_stand_move_dist_max" },
    { 0x31EAD10B, "zm_position_query_last_stand_move_dist_min" },
    { 0x24801C51, "zm_position_query_move_dist_max" },
    { 0xF727F89E, "zm_position_query_radius" },
    { 0x86292404, "zm_power" },
    { 0x7B9E0697, "zm_powerup_bonfire_sale" },
    { 0xA5AB9A0E, "zm_powerup_carpenter" },
    { 0xF7B99E65, "zm_powerup_double_points" },
    { 0xA5F9A5F8, "zm_powerup_fire_sale" },
    { 0xA85AFEEF, "zm_powerup_free_perk" },
    { 0x84B890AE, "zm_powerup_full_ammo" },
    { 0xE01D98C2, "zm_powerup_insta_kill" },
    { 0xA647745D, "zm_powerup_nuke" },
    { 0x2A4EC8BC, "zm_powerup_shield_charge" },
    { 0x274C55AE, "zm_powerup_weapon_minigun" },
    { 0xE0DF0F6F, "zm_powerup_ww_grenade" },
    { 0x22646992, "zm_powerups" },
    { 0x4DD0B86C, "zm_prison" },
    { 0xA316D2AC, "zm_prison_achievement" },
    { 0xD98E1816, "zm_prison_ffotd" },
    { 0x7319CAC5, "zm_prison_fx" },
    { 0xD451D1C6, "zm_prison_spoon" },
    { 0xAC81CEDB, "zm_prison_sq_bg" },
    { 0xC8525113, "zm_prison_sq_fc" },
    { 0xF6D8581E, "zm_prison_sq_final" },
    { 0x92F7D4BD, "zm_prison_sq_wth" },
    { 0xFBE983BD, "zm_prototype" },
    { 0xF651E9A8, "zm_prototype_amb" },
    { 0xF5FF540F, "zm_prototype_art" },
    { 0x5B48D6CA, "zm_prototype_fx" },
    { 0x32D8F435, "zm_pts_animating" },
    { 0xDA6DC897, "zm_puppet" },
    { 0x62030AA3, "zm_random_char" },
    { 0xF0B01969, "zm_random_solo_char" },
    { 0x985B5B08, "zm_raps_sword_kill_power" },
    { 0xDE8EDF27, "zm_roundswitch" },
    { 0xAEEAAC14, "zm_run" },
    { 0x1EB2B88D, "zm_scob_utility" },
    { 0xDC726775, "zm_score" },
    { 0xA4BA499E, "zm_search_radius" },
    { 0x619E7A27, "zm_server_throttle" },
    { 0x4B064EC6, "zm_shared" },
    { 0x6E97C459, "zm_sidequests" },
    { 0x52F0D692, "zm_sight_dist_sq" },
    { 0xAE969B2B, "zm_spawner" },
    { 0x331DE3F1, "zm_sq_ball_putdown" },
    { 0x72B8DCA1, "zm_sq_ball_used" },
    { 0x58445908, "zm_sq_has_ball" },
    { 0x5B348052, "zm_stats" },
    { 0x508A08F8, "zm_stumble_chance" },
    { 0xD6DE90CD, "zm_stumble_min_distance_sq" },
    { 0xC98362F8, "zm_stumble_time_max" },
    { 0xE4788EA6, "zm_stumble_time_min" },
    { 0xF2C5BD38, "zm_switchsides_on_roundswitch" },
    { 0x09FFA5E0, "zm_timer" },
    { 0x7D76E87B, "zm_tomb" },
    { 0x2282064B, "zm_tomb_achievement" },
    { 0x54A425FE, "zm_tomb_amb" },
    { 0xA2C37C4F, "zm_tomb_ambient_scripts" },
    { 0xCDC4D06C, "zm_tomb_capture_zones" },
    { 0xC9217016, "zm_tomb_capture_zones_ffotd" },
    { 0x5D5BA750, "zm_tomb_challenges" },
    { 0x435339FC, "zm_tomb_chamber" },
    { 0x438DC322, "zm_tomb_classic" },
    { 0xF7A613CF, "zm_tomb_craftables" },
    { 0x99EA9186, "zm_tomb_dig" },
    { 0x2649A02D, "zm_tomb_distance_tracking" },
    { 0x66D26454, "zm_tomb_ee_lights" },
    { 0x69D27510, "zm_tomb_ee_main" },
    { 0xA159A601, "zm_tomb_ee_main_step_1" },
    { 0xC75C206A, "zm_tomb_ee_main_step_2" },
    { 0xED5E9AD3, "zm_tomb_ee_main_step_3" },
    { 0x1361153C, "zm_tomb_ee_main_step_4" },
    { 0x39638FA5, "zm_tomb_ee_main_step_5" },
    { 0x5F660A0E, "zm_tomb_ee_main_step_6" },
    { 0x85688477, "zm_tomb_ee_main_step_7" },
    { 0x4B435850, "zm_tomb_ee_main_step_8" },
    { 0x8D777412, "zm_tomb_ee_side" },
    { 0x239F5449, "zm_tomb_ffotd" },
    { 0xE0F9E0C4, "zm_tomb_fx" },
    { 0xD354B820, "zm_tomb_gamemodes" },
    { 0xFEAAABD8, "zm_tomb_get_round_enemy_array" },
    { 0xD1B0A244, "zm_tomb_giant_robot" },
    { 0x400CBE0E, "zm_tomb_giant_robot_ffotd" },
    { 0x73B257EA, "zm_tomb_main_quest" },
    { 0xDC8F4C29, "zm_tomb_quest_air" },
    { 0xACBBD1F9, "zm_tomb_quest_crypt" },
    { 0xC9FB2A74, "zm_tomb_quest_elec" },
    { 0x90429EF7, "zm_tomb_quest_fire" },
    { 0xC020B26C, "zm_tomb_quest_ice" },
    { 0xE6D36ABE, "zm_tomb_tank" },
    { 0x97BEC092, "zm_tomb_teleporter" },
    { 0xD7C0CE12, "zm_tomb_utility" },
    { 0xAD52727B, "zm_tomb_vo" },
    { 0x12E7166E, "zm_transit" },
    { 0xE68BC7CE, "zm_transit_achievement" },
    { 0x8BA48D04, "zm_transit_ai_screecher" },
    { 0xECB25D4F, "zm_transit_amb" },
    { 0x10EADC69, "zm_transit_ambush" },
    { 0xA72F5B6C, "zm_transit_art" },
    { 0x7415FAED, "zm_transit_automaton" },
    { 0x581AAD86, "zm_transit_base" },
    { 0x5D0F91E6, "zm_transit_buildables" },
    { 0x7C5E4C04, "zm_transit_burn_max_duration" },
    { 0xBA563C4D, "zm_transit_bus" },
    { 0xE9EEF913, "zm_transit_classic" },
    { 0x5F42D500, "zm_transit_cling" },
    { 0x3A9004E9, "zm_transit_depot_ext" },
    { 0xD974A973, "zm_transit_depot_int" },
    { 0x16CADC07, "zm_transit_diner_ext" },
    { 0xEEA7F01D, "zm_transit_diner_int" },
    { 0x427F37F4, "zm_transit_distance_tracking" },
    { 0x68096B8B, "zm_transit_dr" },
    { 0x17BDB53B, "zm_transit_dr_achievement" },
    { 0xD784C459, "zm_transit_dr_ffotd" },
    { 0x087FC874, "zm_transit_dr_fx" },
    { 0x569CBD30, "zm_transit_dr_gamemodes" },
    { 0x33FC4C54, "zm_transit_emp_detonate" },
    { 0xBFFB6C2A, "zm_transit_emp_init" },
    { 0xE44B6AE5, "zm_transit_farm_ext" },
    { 0x68CD7E6F, "zm_transit_farm_int" },
    { 0xD0C67EA0, "zm_transit_ffotd" },
    { 0xAC96BB3B, "zm_transit_fx" },
    { 0x8FD19599, "zm_transit_gamemodes" },
    { 0xCA5F1239, "zm_transit_grief_farm" },
    { 0x2D3A7ECF, "zm_transit_grief_station" },
    { 0xDA174FA9, "zm_transit_grief_town" },
    { 0xA117ACBE, "zm_transit_gump" },
    { 0x5246C7A3, "zm_transit_lava" },
    { 0x34C79C4F, "zm_transit_meat_farm" },
    { 0xB2365533, "zm_transit_meat_town" },
    { 0xCCCD9E99, "zm_transit_meat_tunnel" },
    { 0x1A825DBD, "zm_transit_nml_cornfield" },
    { 0x3E9F4689, "zm_transit_nml_town" },
    { 0x1C6D7876, "zm_transit_openings" },
    { 0x2DC5A76C, "zm_transit_perks" },
    { 0x6E91B990, "zm_transit_power" },
    { 0xF638DEC4, "zm_transit_power_ext" },
    { 0x60CBD5B2, "zm_transit_power_int" },
    { 0xF4F27929, "zm_transit_race_farm" },
    { 0x54031388, "zm_transit_race_power" },
    { 0x1FE6DC39, "zm_transit_race_town" },
    { 0x3EEABF4B, "zm_transit_race_tunnel" },
    { 0x132109FD, "zm_transit_sq" },
    { 0xE6EAE93D, "zm_transit_standard_farm" },
    { 0x35B3129B, "zm_transit_standard_station" },
    { 0x3FD3DB5D, "zm_transit_standard_town" },
    { 0x61D0ED05, "zm_transit_town_ext" },
    { 0xFF9FB58F, "zm_transit_town_int" },
    { 0x38BD31E7, "zm_transit_transitional" },
    { 0xF2715D2C, "zm_transit_turned_cornfield" },
    { 0x9CD25C76, "zm_transit_turned_diner" },
    { 0xECE366DE, "zm_transit_turned_farm" },
    { 0xE7CBE6AA, "zm_transit_turned_town" },
    { 0x548A300E, "zm_transit_upgrades" },
    { 0xCE3002D7, "zm_transit_utility" },
    { 0x4D19715B, "zm_transit_weather" },
    { 0x0D0BAEEE, "zm_transit_zones" },
    { 0x7C6E79D7, "zm_trap_burn_max" },
    { 0xF86A2336, "zm_trap_electric" },
    { 0xDA2650CD, "zm_trap_electric_max" },
    { 0x96203A67, "zm_trap_fire" },
    { 0x645EA757, "zm_traps" },
    { 0xB61619CC, "zm_traversal_override" },
    { 0xAF44313C, "zm_traversal_override_ignores" },
    { 0x838FFCF9, "zm_treasure_chest_init" },
    { 0x0A7D9D3F, "zm_turn_off_push_time" },
    { 0x531B2D03, "zm_turned" },
    { 0x0D0C5BF3, "zm_ui_infotext" },
    { 0x40F1A093, "zm_unitrigger" },
    { 0xD197CC6A, "zm_usermap" },
    { 0x1B332DE7, "zm_usermap_ai" },
    { 0xC1A87777, "zm_uspawn_influencer" },
    { 0x3B6C00B4, "zm_uspawn_point" },
    { 0x172BA133, "zm_utility" },
    { 0x2A850363, "zm_variant_type" },
    { 0xDB8CDFB4, "zm_variant_type_max" },
    { 0x4EB0E37D, "zm_wasp_ring_enter_duration" },
    { 0xFBBC35BF, "zm_wasp_ring_exit_duration" },
    { 0x2A47B055, "zm_wasp_ring_loop_duration" },
    { 0x3FBAC4F1, "zm_wasp_round_vision_file" },
    { 0xEF182E70, "zm_wasp_round_visionset" },
    { 0x300C5ED6, "zm_wasp_spawn_callback" },
    { 0x8B0C8A4B, "zm_wasp_sword_kill_power" },
    { 0xF7936E21, "zm_wasp_vision_lerp_count" },
    { 0x808152A9, "zm_wasp_vision_overlay_priority" },
    { 0xFB788CDA, "zm_weap_annihilator" },
    { 0x790026D5, "zm_weap_elemental_bow" },
    { 0x9B170CB8, "zm_weap_gravityspikes" },
    { 0xE82459B9, "zm_weap_thundergun" },
    { 0x33D4B538, "zm_weapons" },
    { 0x3601A113, "zm_zdraw" },
    { 0xBCFA45B0, "zm_zod" },
    { 0x4624F91A, "zm_zod_craftables" },
    { 0x54BF13F5, "zm_zod_idgun_quest" },
    { 0x6515F623, "zm_zombie_height" },
    { 0x7D67F312, "zm_zombie_hero_weapon_kill_power" },
    { 0xD8079BCA, "zm_zombie_sword_kill_power" },
    { 0x945F7A27, "zm_zombie_zigzag_goal_tolerence_dist" },
    { 0xBE68F0C5, "zm_zombie_zigzaz_activation_dist" },
    { 0x98109A33, "zm_zonemgr" },
    { 0xB8DC670B, "zmannouncerprefix" },
    { 0xF055426B, "zmannouncertalking" },
    { 0x571EEA5A, "zmannouncervox" },
    { 0x55FF305A, "zmaxis_init" },
    { 0x63AF0619, "zmaxis_preinit" },
    { 0x0B060D04, "zmb" },
    { 0xA356A688, "zmb_disable_" },
    { 0xBE6AFECD, "zmb_disable_claymore_prompt" },
    { 0xC670A652, "zmb_disable_spikemore_prompt" },
    { 0xA06B27F5, "zmb_enable_" },
    { 0x13290812, "zmb_enable_claymore_prompt" },
    { 0x0DA00253, "zmb_laugh_alias" },
    { 0x987C489B, "zmb_lost_knife" },
    { 0xA10160E0, "zmb_max_ammo" },
    { 0x0F986BAF, "zmb_max_ammo_level" },
    { 0x03D6B5C5, "zmb_music_states" },
    { 0x7AB53457, "zmb_sq_target_hit" },
    { 0x8317DB80, "zmb_vocals_attack" },
    { 0x508BAFCE, "zmb_vox" },
    { 0x8429E589, "zmbaivox_ambientdelay" },
    { 0x48DA4758, "zmbaivox_notifyconvert" },
    { 0x21372EBC, "zmbaivox_playdeath" },
    { 0x05EC52EC, "zmbaivox_playelectrocution" },
    { 0x2A44943D, "zmbaivox_playvox" },
    { 0xFBA192BA, "zmbdialogactive" },
    { 0x0D9E35AD, "zmbdialoggroup" },
    { 0x0B2EB6AC, "zmbdialoggroups" },
    { 0x30E465F9, "zmbdialogqueue" },
    { 0x064B6B71, "zmbehaviorutilitydocbegin" },
    { 0xCD7AC549, "zmbehaviorutilitydocend" },
    { 0xCDA486B1, "zmbmusicsetupmeat" },
    { 0x28CC6EAE, "zmbmuslooper" },
    { 0xB9EB25E3, "zmbvox" },
    { 0x87468718, "zmbvoxadd" },
    { 0xB2AEB464, "zmbvoxannouncertoteam" },
    { 0xEB373B93, "zmbvoxcreate" },
    { 0xDFADCF5E, "zmbvoxcrowdonteam" },
    { 0x11F4037E, "zmbvoxgetlinevariant" },
    { 0x48CCFF8C, "zmbvoxid" },
    { 0x13687C6C, "zmbvoxinitspeaker" },
    { 0x27836932, "zmbvoxmeatonteamspecific" },
    { 0x3EB7D896, "zmbvoxstartholdcounter" },
    { 0x44B488DE, "zmbvoxteamlasthadmeat" },
    { 0x664EC03C, "zmeat" },
    { 0x49F65458, "zmeat_preinit" },
    { 0xB1713093, "zmfactorytraversalservice" },
    { 0x70C29A47, "zmod" },
    { 0xBCD82F32, "zmove" },
    { 0x31B63098, "zmui_shield_crafted" },
    { 0x4398BAEB, "zmui_shield_part_pickup" },
    { 0x096A6903, "znear" },
    { 0xE3AE5B38, "znearbycheck" },
    { 0x3B504446, "znml" },
    { 0x4311CF06, "znml_preinit" },
    { 0x099FF87C, "znodes" },
    { 0xEF6BB624, "zod" },
    { 0xD1834141, "zodiac" },
    { 0x34D93A60, "zodiac_approach_main" },
    { 0x1020DA87, "zodiac_dismount_player_started" },
    { 0xF2C2D03D, "zodiac_jet_flyover" },
    { 0x12046F66, "zodiac_littlebird_logic" },
    { 0xCA6E5E4E, "zodiac_mason" },
    { 0x2F622C2C, "zodiac_player_insert_done" },
    { 0xEBE595A8, "zodiac_seal_squad" },
    { 0x6E87B434, "zodiac_shake_and_rumble" },
    { 0xE3182A56, "zodiac_underwater_snapshot" },
    { 0xA16F6DF9, "zodiak" },
    { 0x93742EB4, "zoff" },
    { 0x65919FEF, "zoffests" },
    { 0xEDD814FC, "zoffset" },
    { 0xBDF8EE58, "zoffsetcounter" },
    { 0x80AABF28, "zom_kill" },
    { 0xB3B92C1D, "zomb" },
    { 0x4EB855DB, "zombapult" },
    { 0x8C61F4FA, "zombe" },
    { 0xBA257DFE, "zombe_gametype_premain" },
    { 0xB1BB3775, "zombes" },
    { 0xFB9423CF, "zombie" },
    { 0xB67A821A, "zombie_" },
    { 0x1D07E514, "zombie_ability_devgui_think" },
    { 0xE16AC8EB, "zombie_acid_damage" },
    { 0x193F53F3, "zombie_acquire_enemy" },
    { 0x225DE261, "zombie_actor_limit" },
    { 0x5DCEC082, "zombie_additionalprimaryweapon_machine_angles" },
    { 0x41570F97, "zombie_additionalprimaryweapon_machine_clip_angles" },
    { 0x2772FE49, "zombie_additionalprimaryweapon_machine_clip_origin" },
    { 0x2A68D998, "zombie_additionalprimaryweapon_machine_monkey_angles" },
    { 0x0C339161, "zombie_additionalprimaryweapon_machine_monkey_origins" },
    { 0xEF3C90DC, "zombie_additionalprimaryweapon_machine_origin" },
    { 0xA11E51A8, "zombie_ai_limit" },
    { 0x99282F2E, "zombie_ai_limit_avogadro" },
    { 0x213EB890, "zombie_ai_limit_ghost" },
    { 0x34AA8B9C, "zombie_ai_limit_ghost_per_player" },
    { 0xFE35033B, "zombie_ai_limit_screecher" },
    { 0xAE30A349, "zombie_airlock_doors" },
    { 0x4C70C1D6, "zombie_airlock_think" },
    { 0x43F69312, "zombie_alcatraz_player_intersection_tracker_override" },
    { 0xB65847C6, "zombie_alive_audio" },
    { 0x7D90805E, "zombie_anim_intro" },
    { 0xCE91AF88, "zombie_anim_override" },
    { 0x42E5FC9E, "zombie_announcer_prefix" },
    { 0x4C799867, "zombie_arms_position" },
    { 0x888947FC, "zombie_assure_node" },
    { 0xBB3862E6, "zombie_astro_locations" },
    { 0xED2F79FB, "zombie_asylum" },
    { 0x4F23454E, "zombie_attack" },
    { 0xD19D47F2, "zombie_attack_anim" },
    { 0x18443ED8, "zombie_attack_callback" },
    { 0x9A468804, "zombie_attack_points" },
    { 0x6391CBA5, "zombie_attacked_trap" },
    { 0x1BDFE867, "zombie_avogadro" },
    { 0x38A6364E, "zombie_avogadro_locations" },
    { 0xA192423B, "zombie_bad_path" },
    { 0x84802C0D, "zombie_bad_path_notify" },
    { 0xFD21703F, "zombie_bad_path_timeout" },
    { 0xE4D129D4, "zombie_bartear_audio_offset" },
    { 0x9E887A93, "zombie_bartear_audio_plus_fx_offset_repair_horizontal" },
    { 0x32A6195B, "zombie_bartear_audio_plus_fx_offset_repair_verticle" },
    { 0x3F3F506F, "zombie_bartear_offset_fx_horizontle" },
    { 0xF46EFEE5, "zombie_bartear_offset_fx_verticle" },
    { 0xB9217CBC, "zombie_behind_vox" },
    { 0xCFE69F7A, "zombie_blacken" },
    { 0x880E3D8A, "zombie_blood" },
    { 0x283076A9, "zombie_blood_generators_started" },
    { 0xDE11F1CA, "zombie_blood_hint_watch" },
    { 0x0716F293, "zombie_blood_over" },
    { 0x32A03166, "zombie_blood_pickedup" },
    { 0x66DC807B, "zombie_blood_powerup" },
    { 0xAB66A9A1, "zombie_blood_revives" },
    { 0xCBCE0122, "zombie_board_tear_down_callback" },
    { 0x70879029, "zombie_boardtear_audio_offset" },
    { 0xE46D64AE, "zombie_boardtear_audio_plus_fx_offset_repair_horizontal" },
    { 0x92FC779A, "zombie_boardtear_audio_plus_fx_offset_repair_verticle" },
    { 0x0564F322, "zombie_boardtear_offset_fx_horizontle" },
    { 0x275F0BB0, "zombie_boardtear_offset_fx_verticle" },
    { 0x62E10B27, "zombie_breadcrumb_area_distance" },
    { 0x0066FCFA, "zombie_breadcrumb_area_num" },
    { 0xEEC471E5, "zombie_breadcrumb_distance" },
    { 0x5C901BC3, "zombie_breadcrumb_failed" },
    { 0x27F1FE16, "zombie_breadcrumb_failed_info" },
    { 0xF32BEAB8, "zombie_breadcrumbs" },
    { 0x59216BF0, "zombie_brutus_locations" },
    { 0x971C80A1, "zombie_buildables" },
    { 0x792C8A54, "zombie_buildables_callbacks" },
    { 0xBD634506, "zombie_buried_devgui" },
    { 0x21A64BEC, "zombie_burning_audio" },
    { 0x870C3E52, "zombie_burning_dmg" },
    { 0x61043C3C, "zombie_burning_fx" },
    { 0x57AF2923, "zombie_burning_watch" },
    { 0x634CC874, "zombie_burst" },
    { 0xD6C178A8, "zombie_can_drop_powerups" },
    { 0x8D2E0264, "zombie_can_forwardstep" },
    { 0xCE31C8E8, "zombie_can_sidestep" },
    { 0x5575F7AD, "zombie_can_slip" },
    { 0x3704D2C0, "zombie_cave_slide_init" },
    { 0x5151A04F, "zombie_change_rate" },
    { 0xCDD7F5A3, "zombie_chasing_tank_turn_crawler" },
    { 0x4F0CAC52, "zombie_check_suppress_gibs" },
    { 0x7AAB6F5B, "zombie_clear_electric_buff" },
    { 0x573933FD, "zombie_clientfield" },
    { 0x21E0612E, "zombie_climb_elevator" },
    { 0xE2A33ACC, "zombie_coast" },
    { 0x10C321CC, "zombie_coast_achievement" },
    { 0xEB1CD9EC, "zombie_coast_ai_director" },
    { 0xCEC5601D, "zombie_coast_amb" },
    { 0x76F28ADB, "zombie_coast_animated_intro" },
    { 0x22E5D1A6, "zombie_coast_cave_slide" },
    { 0x8440CEF5, "zombie_coast_delete_monkey_bolt_on_zombie_holder_death" },
    { 0x00AA218A, "zombie_coast_distance_tracking" },
    { 0xCB32C099, "zombie_coast_eggs" },
    { 0x0BFB0011, "zombie_coast_environmental" },
    { 0x21581736, "zombie_coast_ffotd" },
    { 0x8A318DFA, "zombie_coast_flinger" },
    { 0xEE1FA965, "zombie_coast_fx" },
    { 0x8839D3EF, "zombie_coast_lighthouse" },
    { 0x27C6690E, "zombie_coast_player_damage_level_override" },
    { 0x219D0B70, "zombie_coast_player_intersection_tracker_override" },
    { 0x0690F7C3, "zombie_coast_player_out_of_playable_area_monitor_callback" },
    { 0x093D8B60, "zombie_coast_poi_positioning_func" },
    { 0x0ED9D101, "zombie_coast_visionset" },
    { 0x301E17E4, "zombie_coast_water" },
    { 0x680D1D06, "zombie_coast_zipline" },
    { 0x63F931D4, "zombie_cod5_asylum_amb" },
    { 0xFCAC7BBB, "zombie_cod5_asylum_art" },
    { 0x5E93E26E, "zombie_cod5_asylum_fx" },
    { 0x58D96C06, "zombie_cod5_factory" },
    { 0x0204FAE7, "zombie_cod5_factory_amb" },
    { 0x0F04ABB4, "zombie_cod5_factory_art" },
    { 0x4818EB03, "zombie_cod5_factory_fx" },
    { 0xF54C8935, "zombie_cod5_factory_teleporter" },
    { 0x8F926F4F, "zombie_cod5_prototype_amb" },
    { 0x4A0F6D6C, "zombie_cod5_prototype_art" },
    { 0xC709A13B, "zombie_cod5_prototype_fx" },
    { 0x7BCF6E7B, "zombie_cod5_sumpf" },
    { 0x097F0BFE, "zombie_cod5_sumpf_amb" },
    { 0x5B288E9D, "zombie_cod5_sumpf_art" },
    { 0xAE9B22C4, "zombie_cod5_sumpf_fx" },
    { 0x26E879ED, "zombie_cod5_sumpf_magic_box" },
    { 0x5B9F6BA5, "zombie_cod5_sumpf_perks" },
    { 0xF5098AA0, "zombie_cod5_sumpf_trap_pendulum" },
    { 0xB0128F20, "zombie_cod5_sumpf_trap_perk_electric" },
    { 0xFB0DD169, "zombie_cod5_sumpf_zipline" },
    { 0xFA13632E, "zombie_cod5_sumpf_zone_management" },
    { 0xFEBDFAE9, "zombie_collide_radius" },
    { 0x296CFE65, "zombie_collision_patch" },
    { 0x92E8B306, "zombie_combat" },
    { 0xC3884C5F, "zombie_combat_utility" },
    { 0x1BFA6F52, "zombie_complete_emerging_into_playable_area" },
    { 0x4B93129E, "zombie_containment" },
    { 0x9EBC774A, "zombie_cosmodrome" },
    { 0x2C5213BA, "zombie_cosmodrome_achievement" },
    { 0x55017831, "zombie_cosmodrome_ai_monkey" },
    { 0x3D22B14B, "zombie_cosmodrome_amb" },
    { 0x097393E3, "zombie_cosmodrome_eggs" },
    { 0xB6C5DDBC, "zombie_cosmodrome_ffotd" },
    { 0x179B7A1F, "zombie_cosmodrome_fx" },
    { 0xD6091C4B, "zombie_cosmodrome_lander" },
    { 0xD5C737D4, "zombie_cosmodrome_magic_box" },
    { 0xCED4CC1F, "zombie_cosmodrome_pack_a_punch" },
    { 0x75D97E41, "zombie_cosmodrome_player_out_of_playable_area_monitor_callback" },
    { 0x11A9CB9F, "zombie_cosmodrome_traps" },
    { 0xEA35D00D, "zombie_cost" },
    { 0xF4A7A4A7, "zombie_count" },
    { 0x17C88E2A, "zombie_counter" },
    { 0x443764AB, "zombie_craftable_persistent_weapon" },
    { 0x177F7E7B, "zombie_craftable_set_record_stats" },
    { 0xD8581803, "zombie_craftables" },
    { 0xFBB993EE, "zombie_craftables_callbacks" },
    { 0xA7E9C2BF, "zombie_craftablestubs" },
    { 0x20B6E04D, "zombie_crater_locomotion" },
    { 0x80C12A61, "zombie_custom_craftable_built_vo" },
    { 0x14ADB6F4, "zombie_custom_equipment_setup" },
    { 0xCE0F7083, "zombie_custom_riser_fx_handler" },
    { 0xE27C4FB9, "zombie_custom_think_done" },
    { 0x74F024A1, "zombie_custom_think_logic" },
    { 0x7EE1F4B4, "zombie_cymbal_monkey_count" },
    { 0x2725C6D1, "zombie_damage" },
    { 0xD0CF525A, "zombie_damage_ads" },
    { 0x1275B6C4, "zombie_damage_callbacks" },
    { 0x361C69C5, "zombie_damage_claymore_func" },
    { 0x0887781C, "zombie_damage_event" },
    { 0xAE9B0147, "zombie_damage_failsafe" },
    { 0x4492808F, "zombie_damage_fx_func" },
    { 0xE820D359, "zombie_damage_override_callbacks" },
    { 0x29913F06, "zombie_damaged_by_bar_knockdown" },
    { 0xD890D9EC, "zombie_damageweapon_packed" },
    { 0x98DD23C0, "zombie_damageweapon_regular" },
    { 0x5403E36C, "zombie_damageweapon_type" },
    { 0x0FB6A064, "zombie_death" },
    { 0x25BA3EED, "zombie_death_achievement_sliquifier_check" },
    { 0x6CF4945D, "zombie_death_animscript" },
    { 0xCD459D98, "zombie_death_animscript_callbacks" },
    { 0x9CA5D500, "zombie_death_animscript_override" },
    { 0x029EEFA7, "zombie_death_audio" },
    { 0xE598ED27, "zombie_death_delete_me" },
    { 0xA548DBB9, "zombie_death_event" },
    { 0x6580BF0C, "zombie_death_event_callbacks" },
    { 0x3722339F, "zombie_death_frequency" },
    { 0xFD5376A9, "zombie_death_func" },
    { 0xF460D2F3, "zombie_death_gib" },
    { 0x39ABD62B, "zombie_death_no_headshot" },
    { 0x12EB8EFD, "zombie_death_params" },
    { 0xB3A70386, "zombie_death_points" },
    { 0xA761EBA4, "zombie_death_time_limit" },
    { 0x70D83E23, "zombie_debris" },
    { 0x1B6AF62E, "zombie_delay_powerup_drop" },
    { 0xD8F059CB, "zombie_delete" },
    { 0x7EBB3282, "zombie_dest" },
    { 0x9FC9CE00, "zombie_devgui" },
    { 0xA2B556A1, "zombie_devgui_ability_give" },
    { 0x2DD0266B, "zombie_devgui_ability_take" },
    { 0x32896EF3, "zombie_devgui_allow_fog" },
    { 0xA77E5044, "zombie_devgui_att" },
    { 0x4E8E32DC, "zombie_devgui_attachment_give" },
    { 0xD561E061, "zombie_devgui_build" },
    { 0xA6FBE7FF, "zombie_devgui_buildable_drop" },
    { 0xE14567F8, "zombie_devgui_check_kill_thread_every_frame_toggle" },
    { 0x1A029EEF, "zombie_devgui_chest_never_move" },
    { 0x4C2E2526, "zombie_devgui_cool_jetgun" },
    { 0xBE875F57, "zombie_devgui_debug_pers" },
    { 0x80E15954, "zombie_devgui_director_easy" },
    { 0x994A9C1A, "zombie_devgui_disable_kill_thread_toggle" },
    { 0xFAB184BE, "zombie_devgui_disown_equipment" },
    { 0x28D268EE, "zombie_devgui_dog_round" },
    { 0x26C34A2C, "zombie_devgui_dog_round_skip" },
    { 0x70BD50FF, "zombie_devgui_dpad_changeweapon" },
    { 0x5E43078C, "zombie_devgui_dpad_damage" },
    { 0xE401A573, "zombie_devgui_dpad_death" },
    { 0x2B7D8B9D, "zombie_devgui_dpad_none" },
    { 0x48A6E647, "zombie_devgui_dump_zombie_vars" },
    { 0x116FA08B, "zombie_devgui_equipment_give" },
    { 0x110109C4, "zombie_devgui_equipment_stays_healthy" },
    { 0xB2861051, "zombie_devgui_freezegun_think" },
    { 0x5BD8A58F, "zombie_devgui_give_ability" },
    { 0xD883DF47, "zombie_devgui_give_beacon" },
    { 0xA2A795FC, "zombie_devgui_give_black_hole_bomb" },
    { 0xEAA76FD6, "zombie_devgui_give_claymores" },
    { 0xB9FEC1E3, "zombie_devgui_give_dolls" },
    { 0xA2F6E562, "zombie_devgui_give_emp_bomb" },
    { 0xD6AC77F2, "zombie_devgui_give_frags" },
    { 0x365206B9, "zombie_devgui_give_health" },
    { 0x518BFA55, "zombie_devgui_give_lethal" },
    { 0x0C561379, "zombie_devgui_give_money" },
    { 0x2B8546FC, "zombie_devgui_give_monkey" },
    { 0x6EA1D3B3, "zombie_devgui_give_perk" },
    { 0x9B263B16, "zombie_devgui_give_power" },
    { 0x237C599D, "zombie_devgui_give_powerup" },
    { 0x7E373271, "zombie_devgui_give_quantum_bomb" },
    { 0x40FC521A, "zombie_devgui_give_sticky" },
    { 0x99084853, "zombie_devgui_give_time_bomb" },
    { 0xA9848DCB, "zombie_devgui_goto_round" },
    { 0x52BB7F77, "zombie_devgui_gun" },
    { 0x5D7DE337, "zombie_devgui_hrelevatorfloor" },
    { 0x670B20E1, "zombie_devgui_hrelevatorgo" },
    { 0x695C4EAF, "zombie_devgui_hrelevatorstop" },
    { 0x154FDB86, "zombie_devgui_hrescapepodreset" },
    { 0x34339D14, "zombie_devgui_hrpowerlighting" },
    { 0x1CAA6E6E, "zombie_devgui_invulnerable" },
    { 0x4F0EC7D3, "zombie_devgui_kill" },
    { 0xAD7871C8, "zombie_devgui_kill_thread_test_mode_toggle" },
    { 0x88AED469, "zombie_devgui_monkey_round" },
    { 0x5BCEA66C, "zombie_devgui_open_sesame" },
    { 0xD0D8AD0D, "zombie_devgui_pack_current_weapon" },
    { 0x20F5D779, "zombie_devgui_player_commands" },
    { 0xAA453AE0, "zombie_devgui_player_sq_commands" },
    { 0xAF2E3D2A, "zombie_devgui_power" },
    { 0x620F5BBA, "zombie_devgui_preserve_turbines" },
    { 0x44933300, "zombie_devgui_reopt_current_weapon" },
    { 0x05FF6438, "zombie_devgui_revive" },
    { 0xDF275F1C, "zombie_devgui_revive_all" },
    { 0x166AC60D, "zombie_devgui_take_ability" },
    { 0x55966E43, "zombie_devgui_take_money" },
    { 0xD0C86FC9, "zombie_devgui_take_weapon" },
    { 0x62A830C0, "zombie_devgui_take_weapons" },
    { 0x5FC186C5, "zombie_devgui_tesla_think" },
    { 0x602120C4, "zombie_devgui_thief_round" },
    { 0x423C80A9, "zombie_devgui_think" },
    { 0x693DCD8A, "zombie_devgui_thundergun_think" },
    { 0xFCADFB10, "zombie_devgui_toggle_ammo" },
    { 0xB94A4E28, "zombie_devgui_toggle_ignore" },
    { 0xEAC4A389, "zombie_devgui_tomb" },
    { 0xB2D20222, "zombie_devgui_turn_player" },
    { 0x5AE31026, "zombie_devgui_unpack_current_weapon" },
    { 0xB3F0FA59, "zombie_devgui_watch_input" },
    { 0x4688B881, "zombie_devgui_weapon_give" },
    { 0xF426D676, "zombie_died_in_sq_volume" },
    { 0xF6350B59, "zombie_dif_spots" },
    { 0xD064E1EC, "zombie_difficulty_ramp_up" },
    { 0x2374020F, "zombie_dir" },
    { 0x10D854DA, "zombie_director" },
    { 0xE4FC09BD, "zombie_director_aggro" },
    { 0x602D76C5, "zombie_director_death" },
    { 0x32370F2D, "zombie_director_impact_humangun" },
    { 0xAAB90E1D, "zombie_director_light_update" },
    { 0x4A9E07F7, "zombie_disintegrate" },
    { 0x4CDE4F6B, "zombie_dist_check" },
    { 0xBFEB75A0, "zombie_dive2nuke_visionset" },
    { 0xB91A634E, "zombie_dmg" },
    { 0x0D600E0F, "zombie_dmg_trig" },
    { 0x99ACD222, "zombie_do_drag" },
    { 0x49897E21, "zombie_do_not_update_goal" },
    { 0x1B469D35, "zombie_dog_clip" },
    { 0x2E944F59, "zombie_dog_collision" },
    { 0xED660C77, "zombie_dog_combat" },
    { 0xA81D1E43, "zombie_dog_death" },
    { 0xEB29D412, "zombie_dog_eye_glow" },
    { 0xC3C5BC25, "zombie_dog_init" },
    { 0xAB917E48, "zombie_dog_init_done" },
    { 0xAB0BAEA8, "zombie_dog_move" },
    { 0x0D3B2D93, "zombie_dog_pain" },
    { 0x0FEE5C22, "zombie_dog_pathing_hack" },
    { 0xA7DA348B, "zombie_dog_spawn_death_watch" },
    { 0x12068D55, "zombie_dog_spawn_dmg_watch" },
    { 0xE5262A2B, "zombie_dog_stop" },
    { 0x21D456C7, "zombie_dogs" },
    { 0x7268DC76, "zombie_door" },
    { 0xC9FB0569, "zombie_doors" },
    { 0x191EB167, "zombie_double_doors" },
    { 0xAE9E17C9, "zombie_drag_radius" },
    { 0x8F4F0B41, "zombie_drag_think" },
    { 0xB5564447, "zombie_drop_max_ammo" },
    { 0xFFEAFB88, "zombie_drops_left" },
    { 0xFFD155DE, "zombie_drops_stink" },
    { 0x1829268E, "zombie_earth_gravity_init" },
    { 0xCD2D48D6, "zombie_elec_death" },
    { 0x015B8562, "zombie_elevator_closets" },
    { 0x28738CF9, "zombie_emerge_dust_fx" },
    { 0xD97090F6, "zombie_emerge_fx" },
    { 0xAF582B8E, "zombie_end_traverse" },
    { 0x61684F36, "zombie_enemy" },
    { 0xE798F4DB, "zombie_enter_drag_state" },
    { 0xE83D635C, "zombie_entered_playable" },
    { 0x3B7E3377, "zombie_entered_water" },
    { 0xB4835002, "zombie_equipment" },
    { 0xFB76B129, "zombie_equipment_list" },
    { 0x0000DCBB, "zombie_equipment_player_init" },
    { 0x7C1262C3, "zombie_equipment_upgrade" },
    { 0xA5E11655, "zombie_exit_drag_state" },
    { 0x7F0B3C45, "zombie_exited_water" },
    { 0x7692D210, "zombie_explodes" },
    { 0x479C8F18, "zombie_explodes_intopieces" },
    { 0xB405779B, "zombie_exploding_death" },
    { 0xAB7AD415, "zombie_eye" },
    { 0xCB8E4BF9, "zombie_eye_callback" },
    { 0xF202BEDB, "zombie_eye_glow" },
    { 0x2E647812, "zombie_eye_glow_change" },
    { 0x3957FCFE, "zombie_eye_glow_stop" },
    { 0x5B676411, "zombie_eyeball_color_override" },
    { 0xF57C1464, "zombie_eyes" },
    { 0xA340759A, "zombie_eyes_clientfield_cb" },
    { 0x3AE99156, "zombie_eyes_clientfield_cb_additional" },
    { 0x2E3F63A0, "zombie_eyes_clientfield_cb_tu0" },
    { 0xA67FB0BC, "zombie_eyes_demo_clientfield_cb" },
    { 0x47CF4AC3, "zombie_eyes_demo_watcher" },
    { 0xAEE96CCB, "zombie_eyes_disabled" },
    { 0x189BC7B4, "zombie_eyes_handle_demo_jump" },
    { 0x68EB5CDB, "zombie_eyes_limited" },
    { 0x31F43265, "zombie_face" },
    { 0x7AA2B2B6, "zombie_failsafe_debug_flush" },
    { 0xCD0B04B1, "zombie_fall" },
    { 0x7EE6339B, "zombie_fall_burst_fx" },
    { 0xAF07E79A, "zombie_fall_death" },
    { 0xE7B3B33B, "zombie_fall_death_func" },
    { 0x6EF0D45F, "zombie_fall_death_out" },
    { 0x66144F89, "zombie_fall_dust_fx" },
    { 0x41DDAEE6, "zombie_fall_fx" },
    { 0x6E3F3CFD, "zombie_fall_get_vicitims" },
    { 0xCBC63006, "zombie_fall_loop" },
    { 0xD34C7DDC, "zombie_fall_should_attack" },
    { 0x9B89F9FB, "zombie_fall_spawners" },
    { 0xA04A8107, "zombie_fall_wait" },
    { 0xF4B3C3E8, "zombie_faller_always_drop" },
    { 0x60481671, "zombie_faller_death_wait" },
    { 0xAD56838E, "zombie_faller_delete" },
    { 0xE9F7D10C, "zombie_faller_do_fall" },
    { 0xD2031BD9, "zombie_faller_drop_not_occupied" },
    { 0x434D2EE4, "zombie_faller_emerge" },
    { 0xD9C354AC, "zombie_faller_enable_location" },
    { 0xE49376A2, "zombie_faller_location" },
    { 0xFE367272, "zombie_faller_should_drop" },
    { 0x0D573565, "zombie_faller_wait_start" },
    { 0xA236AAF7, "zombie_faller_watch_all_players" },
    { 0xF8E86540, "zombie_faller_watch_player" },
    { 0x5E812472, "zombie_fan_trap_death" },
    { 0x8333C402, "zombie_findnodes" },
    { 0x6293B965, "zombie_flame_damage" },
    { 0xF55604C3, "zombie_flame_watch" },
    { 0x599EF948, "zombie_flung" },
    { 0x2877D890, "zombie_follow_enemy" },
    { 0x47C0BC71, "zombie_followers_sent_away" },
    { 0xA45E3357, "zombie_for_elevator_unseen" },
    { 0x46409EA5, "zombie_force_run" },
    { 0x6CB194D9, "zombie_forward" },
    { 0x2037BA46, "zombie_forward_2d" },
    { 0x60389561, "zombie_free_cam_allowed" },
    { 0xC94C30D2, "zombie_game_over_death" },
    { 0xB3BDD182, "zombie_geyser_kill" },
    { 0x988075D7, "zombie_ghost_count" },
    { 0xFA9F8FC6, "zombie_ghost_locations" },
    { 0xB9829977, "zombie_ghost_round_states" },
    { 0x8A97FD20, "zombie_gib_all" },
    { 0xCC964A18, "zombie_gib_guts" },
    { 0x107203D7, "zombie_gib_head_weapons" },
    { 0xDC6E7E04, "zombie_gib_on_damage" },
    { 0xAE713F16, "zombie_gib_weapons" },
    { 0xEFDB50DB, "zombie_give_flame_damage_points" },
    { 0xE1EA6410, "zombie_go_faster" },
    { 0x5AC2C74B, "zombie_goes_to_exit_location" },
    { 0x1352119C, "zombie_goto_entrance" },
    { 0xBA982934, "zombie_goto_escape_point" },
    { 0x4497BBB0, "zombie_goto_point" },
    { 0x9AC45CB2, "zombie_goto_round" },
    { 0x5B874A75, "zombie_grab_trigger" },
    { 0x3A49BD02, "zombie_grabbable" },
    { 0xE7C303B9, "zombie_grabbed_by_mechz_claw" },
    { 0x5E595DB9, "zombie_gratetear_audio_plus_fx_offset_repair_horizontal" },
    { 0xE080E95B, "zombie_grenade_death" },
    { 0xFF12BE92, "zombie_gut_explosion" },
    { 0xFE38007A, "zombie_gut_explosion_cb" },
    { 0x3E14AE8B, "zombie_guy" },
    { 0x322DC7FC, "zombie_has_point_of_interest" },
    { 0x9FEC04BE, "zombie_hat_gib" },
    { 0x5CD7AE77, "zombie_head_gib" },
    { 0xA78F8B94, "zombie_health" },
    { 0xA1A0B272, "zombie_health_regen" },
    { 0x32DD82CB, "zombie_healthbar" },
    { 0x6A104404, "zombie_helicopter_kill" },
    { 0x1C4A2B44, "zombie_hero_weapon_list" },
    { 0x829DF388, "zombie_hero_weapon_player_init" },
    { 0xD6780E39, "zombie_highest_vision_set_apply" },
    { 0x47150932, "zombie_highrise_devgui" },
    { 0x34DB5F28, "zombie_hints" },
    { 0xC0464B42, "zombie_history" },
    { 0xE222FAD6, "zombie_in_bus_death_animscript_callback" },
    { 0x14F6B8A4, "zombie_in_chamber" },
    { 0x9E8B490A, "zombie_include_buildables" },
    { 0xB09BBE80, "zombie_include_craftables" },
    { 0x20B5FDE7, "zombie_include_equipment" },
    { 0xBC490ECA, "zombie_include_powerups" },
    { 0x8A54A830, "zombie_include_weapons" },
    { 0xBE6A932C, "zombie_init" },
    { 0x45325017, "zombie_init_done" },
    { 0x3446D83A, "zombie_integration_test_amb" },
    { 0x014258C8, "zombie_integration_test_fx" },
    { 0x5CCA0166, "zombie_intermission" },
    { 0x28190BC3, "zombie_intro_screen" },
    { 0x1A7EC207, "zombie_is_in_drag_state" },
    { 0x851AFCDC, "zombie_keep_in_drag_state" },
    { 0x7328CFDF, "zombie_kill_and_gib" },
    { 0xD62E6973, "zombie_kill_tracker" },
    { 0x94C099E9, "zombie_killed" },
    { 0xB57A0484, "zombie_killed_override" },
    { 0xD6DC2011, "zombie_killer_failsafe" },
    { 0x63E39627, "zombie_kite_watch" },
    { 0x6DB68516, "zombie_knockdown" },
    { 0x2E587165, "zombie_ladder_stage" },
    { 0x9A22570D, "zombie_land" },
    { 0xB921C610, "zombie_land_done" },
    { 0xF142CF34, "zombie_last_run_time" },
    { 0x7ABCA3B3, "zombie_last_stand" },
    { 0xC725F229, "zombie_last_stand_ammo_return" },
    { 0xEA98D60F, "zombie_last_stand_pistol_memory" },
    { 0x46FB33DB, "zombie_launch" },
    { 0xC6C6ACD3, "zombie_launch_and_burn" },
    { 0xAD1A2170, "zombie_lava_damage" },
    { 0x18387224, "zombie_leaper_locations" },
    { 0x3DCCBAF1, "zombie_left" },
    { 0x73A54E75, "zombie_left_before_spawn" },
    { 0xB8A74746, "zombie_lethal_grenade_list" },
    { 0xC4A883A6, "zombie_lethal_grenade_player_init" },
    { 0x8B18D62D, "zombie_lift" },
    { 0x5F9F9E70, "zombie_lift_override" },
    { 0x722D098B, "zombie_lift_wacky_rotate" },
    { 0x29B44891, "zombie_lighthouse_crawl_down" },
    { 0xB6D6BEFE, "zombie_list" },
    { 0x642DC173, "zombie_low_gravity" },
    { 0xBECD5849, "zombie_low_gravity_locomotion" },
    { 0x1E049EFC, "zombie_mechz_locations" },
    { 0x770DEFB2, "zombie_melee" },
    { 0xA5FD17C0, "zombie_melee_in_water" },
    { 0xBAD6DF17, "zombie_melee_watcher" },
    { 0xEA85F42C, "zombie_melee_weapon_list" },
    { 0x932CE4C0, "zombie_melee_weapon_player_init" },
    { 0x50778360, "zombie_monitor" },
    { 0x3D323CB1, "zombie_moon" },
    { 0x4D397621, "zombie_moon_achievement" },
    { 0x057848A2, "zombie_moon_ai_astro" },
    { 0x9D90B190, "zombie_moon_ai_quad" },
    { 0x86EF95DC, "zombie_moon_amb" },
    { 0xCD202D13, "zombie_moon_art" },
    { 0xF25E5661, "zombie_moon_check_zone" },
    { 0x019C598A, "zombie_moon_crawl_anim_override" },
    { 0x1E23812E, "zombie_moon_digger" },
    { 0x981B0B0B, "zombie_moon_distance_tracking" },
    { 0xD9B2D0CF, "zombie_moon_ffotd" },
    { 0xD98316E6, "zombie_moon_fx" },
    { 0x3B06DFFE, "zombie_moon_gravity" },
    { 0x028FC6CB, "zombie_moon_gravity_init" },
    { 0xFFED31E6, "zombie_moon_hatch" },
    { 0x22AFC09D, "zombie_moon_init_done" },
    { 0x9F360369, "zombie_moon_is_low_gravity_zone" },
    { 0xA452416E, "zombie_moon_jump_pad" },
    { 0x58F7F2E8, "zombie_moon_player_float" },
    { 0xBEF9A31C, "zombie_moon_player_out_of_playable_area_monitor_callback" },
    { 0x8F7CACA2, "zombie_moon_receiving_hatch_init" },
    { 0xEEBCD42C, "zombie_moon_sq" },
    { 0x0BFBB37C, "zombie_moon_sq_be" },
    { 0x86AABD72, "zombie_moon_sq_ctt" },
    { 0xBC1E455F, "zombie_moon_sq_ctvg" },
    { 0x959A382E, "zombie_moon_sq_datalogs" },
    { 0xC5E75A18, "zombie_moon_sq_osc" },
    { 0xA55219FD, "zombie_moon_sq_sc" },
    { 0x452A736D, "zombie_moon_sq_ss" },
    { 0x5086F101, "zombie_moon_start_init" },
    { 0x6F9778C4, "zombie_moon_teleporter" },
    { 0xAF087F14, "zombie_moon_traps" },
    { 0xF41DB41E, "zombie_moon_update_player_float" },
    { 0xC710BECA, "zombie_moon_update_player_gravity" },
    { 0x431086D4, "zombie_moon_utility" },
    { 0x8846BBD5, "zombie_moon_wasteland" },
    { 0xB483C904, "zombie_moonbiodome" },
    { 0xCB34DE8F, "zombie_moonhanger18" },
    { 0x7BA31938, "zombie_moonhellearth" },
    { 0x6C423E69, "zombie_mooninterior" },
    { 0x2E59141E, "zombie_moontunnels" },
    { 0xDC7A2511, "zombie_move" },
    { 0x402A69D5, "zombie_move_speed" },
    { 0xAD16DF15, "zombie_move_speed_original" },
    { 0x33F632B8, "zombie_move_speed_override" },
    { 0x1F4B7BCC, "zombie_move_speed_pre_jetgun_drag" },
    { 0x6CF8472E, "zombie_move_speed_restore" },
    { 0xE7FDF1ED, "zombie_move_speed_substate" },
    { 0x3C9017C8, "zombie_moveongoo_animcustom_fall" },
    { 0x4FDD7DE3, "zombie_moveongoo_animcustom_fall_done" },
    { 0xF15727E9, "zombie_moveongoo_animcustom_recover" },
    { 0x7C872FEC, "zombie_moveongoo_animcustom_recover_done" },
    { 0x7D3A4D85, "zombie_music_on" },
    { 0xC8E2D450, "zombie_napalm_locations" },
    { 0x7038E866, "zombie_network_choke_ids_count" },
    { 0x98B9F931, "zombie_network_choke_ids_max" },
    { 0x71DCDC77, "zombie_nuked" },
    { 0x30D4D6C1, "zombie_off" },
    { 0xADA6F91A, "zombie_on_mud" },
    { 0x1F659C12, "zombie_on_tank_death_animscript_callback" },
    { 0xC090E03B, "zombie_override_burn_fx" },
    { 0xFFC625D6, "zombie_pain" },
    { 0x4DCFDD6A, "zombie_paralyzed" },
    { 0x8F2C4D83, "zombie_path_bad" },
    { 0xF325E4ED, "zombie_path_timer" },
    { 0xF77AC130, "zombie_path_timer_override" },
    { 0xFB112531, "zombie_pathing" },
    { 0xB5AA8D10, "zombie_pathing_cleanup" },
    { 0xFE7FEEE3, "zombie_pathing_failed" },
    { 0x64E490F6, "zombie_pathing_failed_info" },
    { 0x17DF5AF4, "zombie_pathing_get_breadcrumb" },
    { 0xCE712031, "zombie_pathing_home" },
    { 0xB365F0CA, "zombie_pathing_init" },
    { 0x7F099F87, "zombie_penalty_period" },
    { 0xE1FDF0B1, "zombie_penalty_points" },
    { 0x2B7D83BE, "zombie_pentagon" },
    { 0x6272ECBF, "zombie_pentagon_amb" },
    { 0xF21F1622, "zombie_pentagon_anim" },
    { 0x3AB43B9C, "zombie_pentagon_art" },
    { 0x0280666E, "zombie_pentagon_elevators" },
    { 0x76BB05F0, "zombie_pentagon_ffotd" },
    { 0x79510A2B, "zombie_pentagon_fx" },
    { 0x2B5AA140, "zombie_pentagon_magic_box" },
    { 0x5690E671, "zombie_pentagon_player_cf_updateprofile" },
    { 0xF23E20D5, "zombie_pentagon_player_portalfx" },
    { 0x1E106B2B, "zombie_pentagon_player_portalfx_cool" },
    { 0x76256FED, "zombie_pentagon_teleporter" },
    { 0x5E1DAE43, "zombie_pentagon_traps" },
    { 0xDD080460, "zombie_pilot_sound" },
    { 0x2B459F32, "zombie_placeable_mine_list" },
    { 0xBC558F82, "zombie_placeable_mine_player_init" },
    { 0x87737425, "zombie_player" },
    { 0x12BE6860, "zombie_player_height_test" },
    { 0x97B3C442, "zombie_player_kill_points" },
    { 0xCE1DAC4B, "zombie_player_killed_count" },
    { 0x7D6B938E, "zombie_player_killed_count_info" },
    { 0xA3DD5246, "zombie_poi" },
    { 0x2815A88C, "zombie_poi_array" },
    { 0x349FC8F9, "zombie_pois" },
    { 0xC79F94E1, "zombie_power_clientfield_cb" },
    { 0xE3FAE1F5, "zombie_power_clientfield_off" },
    { 0x05243F49, "zombie_power_clientfield_on" },
    { 0x140FEBCF, "zombie_power_off" },
    { 0xC4F30953, "zombie_powerup_ape" },
    { 0x3711CFF4, "zombie_powerup_array" },
    { 0x33775452, "zombie_powerup_boss" },
    { 0x88DD3060, "zombie_powerup_grab_func" },
    { 0xE2A37EDF, "zombie_powerup_index" },
    { 0xE8310B6D, "zombie_powerup_weapon" },
    { 0x60CDDBB1, "zombie_powerups" },
    { 0xE3515922, "zombie_punch_damage" },
    { 0xBDE291A1, "zombie_punch_death" },
    { 0x3ED71A60, "zombie_quantum_bomb_spawned_func" },
    { 0xDCE856F0, "zombie_radio_play" },
    { 0xDE5622C8, "zombie_ragdoll_death" },
    { 0x77FA9C53, "zombie_ragdoll_explode_cb" },
    { 0xAFF3C129, "zombie_ragdoll_then_explode" },
    { 0x2BEA87E6, "zombie_ramp_up" },
    { 0x00D90DD1, "zombie_range" },
    { 0x86A718A9, "zombie_release_soul" },
    { 0x59E041ED, "zombie_repath_notifier" },
    { 0xA00E2D08, "zombie_repath_notify" },
    { 0x3750A92A, "zombie_respawned_health" },
    { 0xB190050D, "zombie_respawns" },
    { 0x7EC1279C, "zombie_right" },
    { 0xBDB7B225, "zombie_right_2d" },
    { 0x7578A311, "zombie_rise" },
    { 0xE3071DFB, "zombie_rise_burst_fx" },
    { 0xDF5A3CBA, "zombie_rise_death" },
    { 0x45FA933F, "zombie_rise_death_out" },
    { 0xAF6ED0E9, "zombie_rise_dust_fx" },
    { 0x04F66586, "zombie_rise_fx" },
    { 0xA2F03128, "zombie_rise_locations" },
    { 0x2E01B89B, "zombie_rise_spawners" },
    { 0x3A1B8BD0, "zombie_rise_version" },
    { 0xD58439A1, "zombie_round_change_custom" },
    { 0x55A51D58, "zombie_round_end_delay" },
    { 0x383A5C9F, "zombie_round_start_delay" },
    { 0x7C37F235, "zombie_run" },
    { 0xE8FE37E8, "zombie_screecher" },
    { 0x71CBD77C, "zombie_screecher_count" },
    { 0xA88E8FBD, "zombie_screecher_locations" },
    { 0x9261AE11, "zombie_screen_visited" },
    { 0x3BE84CFB, "zombie_screen_watcher" },
    { 0x27CEF9BF, "zombie_seen" },
    { 0xBAC1AF59, "zombie_server_choke_ids_count" },
    { 0xDA94F9CE, "zombie_server_choke_ids_max" },
    { 0x55D1C405, "zombie_set_and_restore_flame_state" },
    { 0x22D80504, "zombie_set_electric_buff" },
    { 0x76AAE567, "zombie_set_fake_playername" },
    { 0x338870C3, "zombie_set_slipping" },
    { 0x61EEBE66, "zombie_setposemovement" },
    { 0xF5A4E044, "zombie_setup_attack_properties" },
    { 0x370E8B27, "zombie_setup_attack_properties_dog" },
    { 0x4739891B, "zombie_setup_attack_properties_raps" },
    { 0xC26D5716, "zombie_setup_attack_properties_wasp" },
    { 0x6A3BCFE9, "zombie_shared" },
    { 0xDEDE63AD, "zombie_shock_eyes" },
    { 0x518B1E12, "zombie_shock_eyes_network_safe" },
    { 0x399F54A8, "zombie_should_gib" },
    { 0xA73EA670, "zombie_should_stay_in_drag_state" },
    { 0x5EADC269, "zombie_sidequest_completed" },
    { 0x0940C46A, "zombie_sidequest_coop_collectible" },
    { 0xB40A2E96, "zombie_sidequest_coop_stat" },
    { 0x44579652, "zombie_sidequest_previously_completed" },
    { 0x2F30A9EC, "zombie_sidequest_solo_collectible" },
    { 0x4A0E4B38, "zombie_sidequest_solo_stat" },
    { 0xB60184FC, "zombie_sidequest_stat" },
    { 0xF933660B, "zombie_slam_direction" },
    { 0x3D4FA0E5, "zombie_slide_watch" },
    { 0x21C0C94C, "zombie_sliding" },
    { 0xE5A67D03, "zombie_slow_for_time" },
    { 0xD712EDD5, "zombie_soul_catcher_death" },
    { 0xDF469AFC, "zombie_soul_runner" },
    { 0x890BB67E, "zombie_soul_to_charger" },
    { 0x10F39D7E, "zombie_sounds" },
    { 0xB25481C7, "zombie_spawn" },
    { 0xC8CDD11D, "zombie_spawn_dog_tracker" },
    { 0x79A57E85, "zombie_spawn_failed" },
    { 0x162DA110, "zombie_spawn_func" },
    { 0x0E358E98, "zombie_spawn_fx" },
    { 0x63A51F54, "zombie_spawn_init" },
    { 0x8C906397, "zombie_spawn_init_dog" },
    { 0xD2504CEE, "zombie_spawn_locations" },
    { 0x880D5985, "zombie_spawners" },
    { 0x06F538BE, "zombie_spawns" },
    { 0x4F263529, "zombie_special_day_effects_clientfield" },
    { 0x4C9F92F3, "zombie_special_drop_array" },
    { 0xDD1A43B3, "zombie_speed" },
    { 0xB3660C3D, "zombie_speed_buff" },
    { 0xD7C290BC, "zombie_speed_debuff" },
    { 0x9D8E8D95, "zombie_speed_up" },
    { 0x48E6CC8B, "zombie_speed_up_temple" },
    { 0x033974DD, "zombie_spetznaz" },
    { 0x1D1249E5, "zombie_spin_death" },
    { 0x4E0B6E3A, "zombie_spoon_func" },
    { 0x19A0E723, "zombie_spore_infect" },
    { 0x288B6F93, "zombie_start_traverse" },
    { 0x6E204789, "zombie_statless_powerups" },
    { 0xF74F9538, "zombie_sticky_grenade_spawned_func" },
    { 0xAFA1698B, "zombie_stink_array" },
    { 0x89B7808E, "zombie_stomp_death" },
    { 0x9BB14CAC, "zombie_stomped_by_gr_vo" },
    { 0xB62C1AFB, "zombie_subwoofer_kill" },
    { 0x82A4F800, "zombie_suicide_range" },
    { 0xF988BA23, "zombie_suicide_range_sq" },
    { 0x111B2FF5, "zombie_surfing_kill_count" },
    { 0x69D9AF24, "zombie_surfing_kills" },
    { 0xC20A940D, "zombie_tactical_grenade_list" },
    { 0xB32F1C2F, "zombie_tactical_grenade_player_init" },
    { 0x53E9B4B6, "zombie_taunt" },
    { 0x15661095, "zombie_team" },
    { 0x5605FF5C, "zombie_team_index" },
    { 0x62A43D81, "zombie_tear_notetracks" },
    { 0x96C9993D, "zombie_temple" },
    { 0x40F4269E, "zombie_temple_ai_monkey" },
    { 0x167DD728, "zombie_temple_amb" },
    { 0xF94CDAD9, "zombie_temple_elevators" },
    { 0x4D839FCB, "zombie_temple_ffotd" },
    { 0xBAF7A34A, "zombie_temple_fx" },
    { 0xF34B33CD, "zombie_temple_geyser" },
    { 0x3B7D1D65, "zombie_temple_maze" },
    { 0x381C2B92, "zombie_temple_pack_a_punch" },
    { 0xCEE0FFA8, "zombie_temple_player_out_of_playable_area_monitor_callback" },
    { 0xF972B9E8, "zombie_temple_sq" },
    { 0x65BDBA83, "zombie_temple_sq_bag" },
    { 0x193D7A1C, "zombie_temple_sq_brock" },
    { 0x48002BCD, "zombie_temple_sq_bttp" },
    { 0x3967A575, "zombie_temple_sq_bttp2" },
    { 0x881C0F48, "zombie_temple_sq_dgcwf" },
    { 0xC3A5912F, "zombie_temple_sq_lgs" },
    { 0xE91F8562, "zombie_temple_sq_oafc" },
    { 0x1951875D, "zombie_temple_sq_ptt" },
    { 0x6A34616D, "zombie_temple_sq_skits" },
    { 0x45A1B2F6, "zombie_temple_sq_std" },
    { 0x9424F6D0, "zombie_temple_traps" },
    { 0x22800700, "zombie_temple_waterslide" },
    { 0x2777B1DF, "zombie_tesla_head_gib" },
    { 0x128CD975, "zombie_tesla_hit" },
    { 0x702E1EDE, "zombie_testing" },
    { 0x13A10D6D, "zombie_theater" },
    { 0x94555CF8, "zombie_theater_amb" },
    { 0x78B8DF9F, "zombie_theater_art" },
    { 0xC31A7CFB, "zombie_theater_ffotd" },
    { 0x83F7FB9A, "zombie_theater_fx" },
    { 0x5A4A8917, "zombie_theater_magic_box" },
    { 0xFC68514F, "zombie_theater_movie_screen" },
    { 0x4E3CC872, "zombie_theater_projector_beam" },
    { 0x57E0A285, "zombie_theater_quad" },
    { 0x6419B6B8, "zombie_theater_teleporter" },
    { 0xA7A6ABF6, "zombie_think" },
    { 0x5B98EA79, "zombie_think_done" },
    { 0xE5422662, "zombie_through_portal" },
    { 0xC31191B9, "zombie_timer_offset" },
    { 0x1D5BA0CF, "zombie_timer_offset_interval" },
    { 0x447C443D, "zombie_to_entity" },
    { 0x6325B8B2, "zombie_to_entity_2d" },
    { 0x82B4832B, "zombie_to_mechz" },
    { 0xCD6DDDB4, "zombie_to_mechz_2d" },
    { 0x716B0DC7, "zombie_to_target" },
    { 0x1D29C3F8, "zombie_to_target_2d" },
    { 0x663C85F3, "zombie_to_thrasher" },
    { 0x60C0153C, "zombie_to_thrasher_2d" },
    { 0xC1841FF0, "zombie_total" },
    { 0xA73FF751, "zombie_total_set" },
    { 0x6BE9064E, "zombie_total_set_func" },
    { 0x27C2CEDB, "zombie_total_subtract" },
    { 0x38514564, "zombie_total_update" },
    { 0x436936FC, "zombie_tracking_dist" },
    { 0x327FC6D8, "zombie_tracking_high" },
    { 0x5B8B5DD2, "zombie_tracking_init" },
    { 0x0506AAB3, "zombie_tracking_too_far_dist" },
    { 0x0F06652F, "zombie_tracking_wait" },
    { 0x3B8E8BCC, "zombie_train" },
    { 0x0C565A00, "zombie_transit_audio_alias_override" },
    { 0x6CD18468, "zombie_transit_devgui" },
    { 0x540FF9D1, "zombie_transit_dr_devgui" },
    { 0xAD138C81, "zombie_transit_player_intersection_tracker_override" },
    { 0x6400A12D, "zombie_transit_player_too_many_weapons_monitor_callback" },
    { 0x980A1EDC, "zombie_trap_death" },
    { 0x16F4CD69, "zombie_trap_killed_count" },
    { 0xB6C27AE8, "zombie_trap_killed_count_info" },
    { 0x0B8330A1, "zombie_treasure_chest_cost" },
    { 0x616E4A92, "zombie_trigger" },
    { 0x4FBEC31C, "zombie_trigger_height" },
    { 0x412CC0FF, "zombie_trigger_origin" },
    { 0x22E2F99B, "zombie_trigger_radius" },
    { 0x53166FDA, "zombie_type" },
    { 0x6F98B93E, "zombie_unlock_all" },
    { 0x9B4DA288, "zombie_use_zigzag_path" },
    { 0x52BFB19E, "zombie_utility" },
    { 0xE625BDF1, "zombie_var" },
    { 0xEB9C5258, "zombie_vars" },
    { 0xE29426AC, "zombie_vertical" },
    { 0xC4F961EE, "zombie_vision_set_apply" },
    { 0x5F78C6C2, "zombie_vision_set_remove" },
    { 0xA9DBA31A, "zombie_vision_sets" },
    { 0x1C9AAF8A, "zombie_visionset" },
    { 0xCCD3897A, "zombie_vortex" },
    { 0x1A04E37B, "zombie_wait_explode" },
    { 0x5B1C9742, "zombie_wait_for_blundersplat_hit" },
    { 0xA30070AA, "zombie_wait_for_death" },
    { 0x6DBCC5FA, "zombie_wall_crawl" },
    { 0xFE18ABFE, "zombie_wall_crawl_drop" },
    { 0x23635229, "zombie_warroom_barricade_fix" },
    { 0xA2B11DEF, "zombie_watch_nogravity" },
    { 0x65123B80, "zombie_watch_run_notetracks" },
    { 0xC2B9EA5A, "zombie_water_icicle_tag" },
    { 0x26E3BDA2, "zombie_water_out" },
    { 0x8874C5F6, "zombie_weapon_devgui_think" },
    { 0x07C37668, "zombie_weapon_toggle_acquired_hint" },
    { 0x2A59A1BD, "zombie_weapon_toggle_acquired_light" },
    { 0x895F6A6D, "zombie_weapon_toggle_activate_hint" },
    { 0xBD57D7BA, "zombie_weapon_toggle_active_count" },
    { 0xA2448413, "zombie_weapon_toggle_active_light" },
    { 0x26849C96, "zombie_weapon_toggle_deactivate_hint" },
    { 0xFA348BC0, "zombie_weapon_toggle_disabled_hint" },
    { 0x4A5372E5, "zombie_weapon_toggle_disabled_light" },
    { 0x73186AE2, "zombie_weapon_toggle_inactive_light" },
    { 0x8F0DC507, "zombie_weapon_toggle_max_active_count" },
    { 0xFBBE9154, "zombie_weapon_toggles" },
    { 0x6DF368DB, "zombie_weapon_upgrade" },
    { 0x51E9BB25, "zombie_weapons" },
    { 0x78B1ECC0, "zombie_weapons_callbacks" },
    { 0x65EC2FEB, "zombie_weapons_no_max_ammo" },
    { 0x7D108000, "zombie_weapons_upgraded" },
    { 0x0003188A, "zombie_zapped" },
    { 0x18246842, "zombie_zipline_clip" },
    { 0x64F767A8, "zombie_zipline_intersect_monitor" },
    { 0x0ECAC10D, "zombie_zombie_keyline_render_clientfield_cb" },
    { 0x772ADDFF, "zombieanhilationenabled" },
    { 0xD58BD8EF, "zombieanimnotetrackthink" },
    { 0x0B84B6CA, "zombieattachleftorright" },
    { 0xA4EBCAF3, "zombieattachtobus" },
    { 0xEDBEEC6B, "zombieattackableobjectservice" },
    { 0xFC423C4D, "zombieattackobjectmocompstart" },
    { 0x3E5880DC, "zombieattackobjectmocompupdate" },
    { 0xD12F9CCE, "zombieattackobjectstart" },
    { 0xB732CE4F, "zombieattackobjectterminate" },
    { 0x63F7823D, "zombieattackplayerclinging" },
    { 0xCE198479, "zombieattackplayeronturret" },
    { 0xCBB95BA3, "zombieattackthroughboardsaction" },
    { 0x3A2740C8, "zombieattackthroughboardsactionterminate" },
    { 0xC28C6895, "zombiebehavior" },
    { 0x466864A1, "zombiebhbburst" },
    { 0x53D0F8B2, "zombieblackholebombpullend" },
    { 0xFF965F69, "zombieblackholebombpullstart" },
    { 0x4CD5B7A0, "zombieblackholebombpullupdate" },
    { 0xB271A282, "zombiecanjumponroof" },
    { 0x697DA011, "zombieclientutils" },
    { 0xA56A117B, "zombieclimbtoroof" },
    { 0xBC3279EC, "zombiecount" },
    { 0xDD1C093B, "zombiecrawlercollision" },
    { 0x2A8746F2, "zombiedamageplayercling" },
    { 0xB3CC29F5, "zombiedamageplayerturret" },
    { 0xC1DC95A5, "zombiedeathaction" },
    { 0x054C9348, "zombiedetachfrombus" },
    { 0x1DB6D2C9, "zombiedogbehavior" },
    { 0xBC8527AB, "zombiedoggravity" },
    { 0x273D1A1C, "zombiedoginterface" },
    { 0xBFE9B80F, "zombiedogmeleeaction" },
    { 0x557AE3BC, "zombiedogmeleeactionterminate" },
    { 0x5DE7A022, "zombiedogshouldmelee" },
    { 0x673B9825, "zombiedogshouldrun" },
    { 0x8A5696B5, "zombiedogshouldwalk" },
    { 0xDF671F4D, "zombiedogtargetservice" },
    { 0x99337008, "zombieelectrictrapdamage" },
    { 0x77106326, "zombieenteredplayable" },
    { 0x9301F944, "zombieexist" },
    { 0x9834F80B, "zombieexitbus" },
    { 0x050ED553, "zombieexitbusjump" },
    { 0x78128B97, "zombieexitwindow" },
    { 0x713B9EB0, "zombieexitwindowdelay" },
    { 0x98686FA4, "zombieeyemonitor" },
    { 0xF285AC94, "zombiefindflesh" },
    { 0xE8418BBB, "zombiefindfleshcode" },
    { 0x74B058D2, "zombiegetclosestdoortag" },
    { 0x6C0DFE24, "zombiegetclosestroofjumptag" },
    { 0x42029234, "zombiegetclosestroofopeningjumptag" },
    { 0xF741782C, "zombiegetcymbalmonkey" },
    { 0xE3469A32, "zombiegetplayerstoattack" },
    { 0x3B28D2AD, "zombiegetupactionterminate" },
    { 0x9E34D2A4, "zombiegetwindowanimrate" },
    { 0x1E2F48B8, "zombiegibkilledanhilateoverride" },
    { 0x58A30A23, "zombiegiblegscondition" },
    { 0x9D22515F, "zombiegottoattackspotcondition" },
    { 0x90B53E35, "zombiegottoentrancecondition" },
    { 0xCA32C315, "zombiegrabboardaction" },
    { 0xA08A6456, "zombiegrabboardactionterminate" },
    { 0xBABD3FC2, "zombiegrappleactionstart" },
    { 0x15C8D779, "zombiehandler" },
    { 0x8EFD1072, "zombiehasattackspotalreadycondition" },
    { 0x60A4B52E, "zombiehaslegs" },
    { 0x5FFCAAC4, "zombiehatchjumpdelay" },
    { 0x8D7B1FED, "zombiehealth" },
    { 0x6324E3A0, "zombieheighttraverse" },
    { 0xB6CA57E8, "zombieheighttraversestop" },
    { 0x67827C56, "zombieholdboardaction" },
    { 0x70F167DF, "zombieholdboardactionterminate" },
    { 0xC8330687, "zombieidgundeathmocompstart" },
    { 0x2A28D7FB, "zombieidgundeathupdate" },
    { 0xA0BAF4AD, "zombieidgunholedeathmocompstart" },
    { 0xD709F8AC, "zombieidgunholedeathmocompterminate" },
    { 0x87682560, "zombieinterface" },
    { 0x7BE06BF9, "zombieisatattackobject" },
    { 0x9669A842, "zombieisatentrance" },
    { 0x9AECF621, "zombieisatgoal" },
    { 0xA81E952B, "zombieisbeinggrappled" },
    { 0x8DA8A76C, "zombieispushed" },
    { 0x03FFF305, "zombieisthinkdone" },
    { 0x74029C9C, "zombiejuke" },
    { 0xBFE5B302, "zombiejukeactionstart" },
    { 0xADF76673, "zombiejukeactionterminate" },
    { 0x716B127B, "zombiejumpdownhatch" },
    { 0xD86B299C, "zombiejumpdownhatchkilled" },
    { 0x35F6D820, "zombiejumpoffroof" },
    { 0x3FCC5542, "zombiejumponroof" },
    { 0x16C97A37, "zombiekeepattackingthroughwindow" },
    { 0x442B4265, "zombiekilledbyblackholebombcondition" },
    { 0xC47C459D, "zombiekilledbyblackholebombend" },
    { 0x7CF5770E, "zombiekilledbyblackholebombstart" },
    { 0x8A7CA40B, "zombiekilledwhilegettingpulled" },
    { 0x2319AA61, "zombieknockdownactionstart" },
    { 0x403D5344, "zombieland" },
    { 0x08F55D17, "zombieleaderboardnumber" },
    { 0x5D0FE77E, "zombieleaderboardstatvariable" },
    { 0xB2F8099B, "zombieless_waits" },
    { 0x7E775B4D, "zombielevelspecifictargetcallback" },
    { 0x09404C34, "zombieliquidfiredamage" },
    { 0xFBF29484, "zombiemantleaction" },
    { 0xB80C2A39, "zombiemantleactionterminate" },
    { 0x661DACD4, "zombiemeleejumpmocompstart" },
    { 0xC4E312ED, "zombiemeleejumpmocompterminate" },
    { 0x38696553, "zombiemeleejumpmocompupdate" },
    { 0x1AFEF3BE, "zombiemeleeplayercounter" },
    { 0xA20DBE5E, "zombiemeleesuicidecallback" },
    { 0x7D289B52, "zombiemeleesuicidedonecallback" },
    { 0xB41C43C1, "zombiemeleesuicidestart" },
    { 0x38D49A80, "zombiemeleesuicideterminate" },
    { 0x582CFD88, "zombiemeleesuicideupdate" },
    { 0x0E4B2506, "zombiemode" },
    { 0x5AD28E53, "zombiemode_anim_intro_scenes" },
    { 0x56BDA171, "zombiemode_animated_intro" },
    { 0x6193BEAF, "zombiemode_cross_bow_fired" },
    { 0x9DD98DBE, "zombiemode_devgui_beacon_give" },
    { 0xEE99D38D, "zombiemode_devgui_black_hole_bomb_give" },
    { 0xDF0D1458, "zombiemode_devgui_cymbal_monkey_give" },
    { 0xAF6671E1, "zombiemode_devgui_emp_bomb_give" },
    { 0xC1F3B949, "zombiemode_devgui_nesting_dolls_give" },
    { 0x03CDDFDC, "zombiemode_devgui_quantum_bomb_give" },
    { 0xE5FF76A3, "zombiemode_divetonuke_perk_func" },
    { 0xB8C1E53D, "zombiemode_gasmask_change_player_headmodel" },
    { 0xD244879E, "zombiemode_gasmask_reset_player_model" },
    { 0x07D233AF, "zombiemode_gasmask_reset_player_viewmodel" },
    { 0xF04B2ACD, "zombiemode_gasmask_set_player_model" },
    { 0x35255F38, "zombiemode_gasmask_set_player_viewmodel" },
    { 0x4C596C5B, "zombiemode_give_player_model_override" },
    { 0x18C515FE, "zombiemode_melee_miss" },
    { 0x3AB1B54D, "zombiemode_offhand_weapon_give_override" },
    { 0x8DE33537, "zombiemode_player_set_viewmodel_override" },
    { 0x6104B2AF, "zombiemode_precache_player_model_override" },
    { 0x1B3E0283, "zombiemode_reusing_pack_a_punch" },
    { 0xBF421DB7, "zombiemode_sidequest_init" },
    { 0xA7268E94, "zombiemode_solo_last_stand_pistol" },
    { 0x8B6CDB2F, "zombiemode_spawner" },
    { 0x19AAA418, "zombiemode_time_bomb_give_func" },
    { 0xC1B8F914, "zombiemode_using_additionalprimaryweapon_perk" },
    { 0x0787858E, "zombiemode_using_afterlife" },
    { 0xDA00BE14, "zombiemode_using_chugabud_perk" },
    { 0xA9B56FC7, "zombiemode_using_deadshot_perk" },
    { 0xC6F7A7AB, "zombiemode_using_divetonuke_perk" },
    { 0x8408DA0F, "zombiemode_using_doubletap_perk" },
    { 0x399087BC, "zombiemode_using_electric_cherry_perk" },
    { 0xC6B7C1FD, "zombiemode_using_juggernaut_perk" },
    { 0xF9DE6E27, "zombiemode_using_marathon_perk" },
    { 0x30DACF60, "zombiemode_using_pack_a_punch" },
    { 0xFE1B012A, "zombiemode_using_perk_intro_fx" },
    { 0x2027BFEE, "zombiemode_using_random_perk" },
    { 0xE334177C, "zombiemode_using_revive_perk" },
    { 0x267F1F53, "zombiemode_using_sleightofhand_perk" },
    { 0x12AE4992, "zombiemode_using_tombstone_perk" },
    { 0x3B323F2C, "zombiemode_using_vulture_perk" },
    { 0x2422AE5F, "zombiemode_versus" },
    { 0xDA029A32, "zombiemoveaction" },
    { 0xE06DD77B, "zombiemoveactioncallback" },
    { 0x60CB6BC3, "zombiemoveactionterminate" },
    { 0x89350BBD, "zombiemoveactionupdate" },
    { 0x210EA112, "zombiemoveaway" },
    { 0xEFAFCEA3, "zombiemoveonbus" },
    { 0x61307A2C, "zombiemoveongoo" },
    { 0x9F22F532, "zombiemoveongoo_gobacktonormal" },
    { 0x03E819B1, "zombiemoveongoo_on_killanimscript" },
    { 0x472FC30C, "zombiemoveongoo_on_killanimscript_thread" },
    { 0x79B20FF5, "zombiemovetoattackspotaction" },
    { 0xE74742B6, "zombiemovetoattackspotactionterminate" },
    { 0xCF123EBB, "zombiemovetoentranceaction" },
    { 0xAD78ED80, "zombiemovetoentranceactionterminate" },
    { 0x4868C5CD, "zombienotetrackcrushfire" },
    { 0xF575FEDC, "zombienotetrackmeleefire" },
    { 0x8C0C9146, "zombieonbusenemy" },
    { 0xF03876E2, "zombieopeningdelay" },
    { 0x0BF3A489, "zombiepathtoladder" },
    { 0xA80CC2DD, "zombiepathtoroofopening" },
    { 0x24330AA3, "zombiependamage" },
    { 0x07A4E478, "zombiepickunmovingattackanim" },
    { 0xC8DB82B2, "zombieplayattachedanim" },
    { 0x44E7D244, "zombiepullboardaction" },
    { 0x11581AF9, "zombiepullboardactionterminate" },
    { 0x85FF4162, "zombiepushedactionstart" },
    { 0xB5A260D3, "zombiepushedactionterminate" },
    { 0x937D31FA, "zombiequad" },
    { 0x2B356D36, "zombieragdollsimple" },
    { 0x20D5506A, "zombieroofteardelay" },
    { 0x498E9B1E, "zombierooftearwakeup" },
    { 0xDEBFE596, "zombies" },
    { 0x40A0155D, "zombies_attacking_generator" },
    { 0x59349626, "zombies_axis" },
    { 0xB6C955FF, "zombies_drop_stink_on_death" },
    { 0x4A137103, "zombies_elev_teleport" },
    { 0xD8A06426, "zombies_elev_teleport_hidden" },
    { 0xBFAA46C6, "zombies_flinged" },
    { 0x7861A40A, "zombies_goto_position" },
    { 0x6DBDF7D2, "zombies_in_range" },
    { 0x2DB1AA92, "zombies_killed" },
    { 0xD89D2E38, "zombies_left_before_astro_spawn" },
    { 0xCCC96316, "zombies_nuked" },
    { 0xAB8C3CBB, "zombies_off_building" },
    { 0xB941899B, "zombies_only" },
    { 0x5753233A, "zombies_sorted" },
    { 0x61DE63D7, "zombies_timeout_playspace" },
    { 0x2B4A0DD2, "zombies_timeout_playspace_info" },
    { 0x0C9B43BE, "zombies_timeout_spawn" },
    { 0x24FF8761, "zombies_timeout_spawn_info" },
    { 0xCF1418BD, "zombies_timeout_undamaged" },
    { 0xB75D0196, "zombies_to_add" },
    { 0x39C0A711, "zombies_to_flush" },
    { 0x62FC5A09, "zombies_to_reduce_meter" },
    { 0xF464A665, "zombies_watch_tank" },
    { 0x91F31BD5, "zombiesatwindow" },
    { 0x03A8D6C9, "zombiescriptedattack" },
    { 0x0FCE7F33, "zombiesetnexttimetojumponroof" },
    { 0xF76741CF, "zombieshouldattackobject" },
    { 0x8347A165, "zombieshouldattackthroughboardscondition" },
    { 0x840E6DBF, "zombieshoulddetachfromwindow" },
    { 0x250B7510, "zombieshoulddisplaypain" },
    { 0xB16091DD, "zombieshouldenterplayablecondition" },
    { 0x55438464, "zombieshouldjukecondition" },
    { 0xE3BD24DD, "zombieshouldjumpmeleecondition" },
    { 0x3D3BCC9F, "zombieshouldjumpunderwatermelee" },
    { 0x185BCEA2, "zombieshouldknockdown" },
    { 0x6D860A95, "zombieshouldmeleecondition" },
    { 0xB8D00A4E, "zombieshouldmeleesuicide" },
    { 0xC81D899E, "zombieshouldmoveawaycondition" },
    { 0x040E6A55, "zombieshouldproceduraltraverse" },
    { 0x33C0C1EB, "zombieshouldstumblecondition" },
    { 0x8242B7F6, "zombieshouldstun" },
    { 0xC607D349, "zombieshouldtauntcondition" },
    { 0x1CF28735, "zombieshouldtearcondition" },
    { 0xC15D9812, "zombiesinside" },
    { 0x68A54345, "zombieskilled" },
    { 0x93181DA4, "zombiesleftbeforemonkeyspawn" },
    { 0xB5BD3144, "zombiesleftbeforenapalmspawn" },
    { 0x2D260971, "zombiesleftbeforesonicspawn" },
    { 0x2787B9E7, "zombiesonroof" },
    { 0xC5EC734F, "zombiespawnsetup" },
    { 0xA505B3F0, "zombiespecialdayeffectshandler" },
    { 0x1481D763, "zombiestatget" },
    { 0xC8A601A7, "zombiestatset" },
    { 0xC86291DB, "zombiestumble" },
    { 0x1866555B, "zombiestumbleactionstart" },
    { 0x05DCEEB0, "zombiestunactionend" },
    { 0x34015D43, "zombiestunactionstart" },
    { 0x288E19B1, "zombietargetservice" },
    { 0x4ED94E93, "zombietauntaction" },
    { 0x64A4CE38, "zombietauntactionterminate" },
    { 0xA73DF8C4, "zombietheaterteleporterseeklogic" },
    { 0x1AD9017E, "zombietheaterteleporterseeklogicfunc" },
    { 0x395570F0, "zombietraversalservice" },
    { 0xC8BF526B, "zombietraverseaction" },
    { 0xC4ED7430, "zombietraverseactionterminate" },
    { 0x315473EA, "zombietraversestartragdolldeath" },
    { 0xED8B1684, "zombietraversestopragdolldeath" },
    { 0xF91A63E9, "zombietrigger" },
    { 0x64895DEA, "zombietron" },
    { 0x80C27B2B, "zombietron_amb" },
    { 0xF209A988, "zombietron_art" },
    { 0x1F79067F, "zombietron_fx" },
    { 0xF884D016, "zombietron_main" },
    { 0x22DB3A04, "zombietron_mode" },
    { 0x1686BA5D, "zombietron_set_new_zombie_stats" },
    { 0x4B9C6801, "zombietron_upload_highscore" },
    { 0xF8F3D7B1, "zombietryattackthroughwindow" },
    { 0x5C133BD5, "zombieturnmocompstart" },
    { 0x8D87F0E4, "zombieturnmocompterminate" },
    { 0xA87A0334, "zombieturnmocompupdate" },
    { 0x1D739461, "zombieupdateblackholebombpullstate" },
    { 0x32CAD4DD, "zombieupdategoal" },
    { 0xCCBB12BA, "zombieupdategoalcode" },
    { 0x9BA65C35, "zombieupdatezigzaggoal" },
    { 0xD5317C4B, "zombiewalktoexit" },
    { 0x66B7FD7B, "zombiewalktowindow" },
    { 0x95AA9366, "zombiewindowtoroof" },
    { 0x1D0184CF, "zombiezipdamage" },
    { 0x09ED8C3E, "zombiezombieidlemocompstart" },
    { 0x00440A83, "zombification" },
    { 0xB9B24D71, "zombification_time" },
    { 0x6C33682A, "zombified" },
    { 0xF3352CED, "zombify" },
    { 0x9282160F, "zombify_player" },
    { 0x3F9C285B, "zombifyfx" },
    { 0x22B1EFDB, "zombifyhandler" },
    { 0x3BEC3F7B, "zombifying" },
    { 0xF5711DCB, "zombinit" },
    { 0x3C45992F, "zombmeleemonitor" },
    { 0x10492CE0, "zombo" },
    { 0x388E905C, "zombs" },
    { 0xF26D2A90, "zombstospawn" },
    { 0x7B0586AC, "zombtimer" },
    { 0x7E8D0707, "zone" },
    { 0xF888A1EC, "zone1" },
    { 0x6A901127, "zone2" },
    { 0xB24A4EFF, "zone_a" },
    { 0x7B541E30, "zone_active" },
    { 0xB9BD35F2, "zone_alarms_setup" },
    { 0xE445F6B4, "zone_approach_radius_max" },
    { 0x0609B679, "zone_area" },
    { 0x7B010FDD, "zone_array" },
    { 0xEF4A850B, "zone_array_contains" },
    { 0x4042DFC4, "zone_b" },
    { 0x8820A302, "zone_breached" },
    { 0x7C0E56D3, "zone_bus_dam" },
    { 0x42990DDC, "zone_capture" },
    { 0xBB399418, "zone_capture_area" },
    { 0x1F798B24, "zone_capture_clue" },
    { 0xB9DBB140, "zone_capture_complete_vo" },
    { 0xDF69033A, "zone_capture_gib_think" },
    { 0x20C78ADD, "zone_capture_powerup" },
    { 0x0362D297, "zone_capture_sound_state_think" },
    { 0xDB3634D0, "zone_captured" },
    { 0xB57B5E8C, "zone_captured_by_player" },
    { 0xB420B518, "zone_captured_cb" },
    { 0xFB86E8BC, "zone_captured_team" },
    { 0x4081244A, "zone_choke" },
    { 0xB10EB05F, "zone_connected" },
    { 0x6D27B771, "zone_contested" },
    { 0x552FCAEB, "zone_controlled_perk" },
    { 0xB7172DA4, "zone_defend_percent" },
    { 0xED2AA19B, "zone_destroyed" },
    { 0x957BF6F7, "zone_drone_counts" },
    { 0xA2E716E9, "zone_enabled" },
    { 0x72554CD0, "zone_flag_wait" },
    { 0x49D4AD9F, "zone_flag_wait_throttle" },
    { 0x8BE45753, "zone_flags" },
    { 0xC807AD1C, "zone_flags_updating" },
    { 0xD757F726, "zone_frogger" },
    { 0x745181DE, "zone_index" },
    { 0x5B838094, "zone_init" },
    { 0x36524583, "zone_is_active" },
    { 0xD58DB59C, "zone_is_enabled" },
    { 0x27B50BDE, "zone_keys" },
    { 0x96C20A58, "zone_locked" },
    { 0x84D8163F, "zone_manager" },
    { 0xEDEF4391, "zone_manager_init_func" },
    { 0xD96427B1, "zone_market_exit" },
    { 0xD3B0DECF, "zone_moved" },
    { 0x59F9B3BF, "zone_name" },
    { 0xF21BA907, "zone_name_a" },
    { 0x801439CC, "zone_name_b" },
    { 0x2CE3FC48, "zone_name_tokens" },
    { 0xA98F63C6, "zone_names" },
    { 0x4AF51A33, "zone_occupied_func" },
    { 0x7747581D, "zone_player" },
    { 0x04A8B72B, "zone_reset" },
    { 0x9DAF2154, "zone_roof" },
    { 0x72AA778C, "zone_roof_infirmary" },
    { 0x9CA2E564, "zone_scanning_active" },
    { 0x3E106C38, "zone_sewer" },
    { 0xBB3E545A, "zone_sloth" },
    { 0x4D1984D1, "zone_source" },
    { 0xB0018D4F, "zone_spawn_complete" },
    { 0x21C4368E, "zone_spawn_names" },
    { 0x2AB97E9B, "zone_spawn_planes" },
    { 0xB424D1BC, "zone_spawn_pos" },
    { 0xE4B7DC8D, "zone_spawners" },
    { 0xE883E21F, "zone_stealth" },
    { 0x981AF269, "zone_struct" },
    { 0x1DF7B389, "zone_substr" },
    { 0xDCCC6862, "zone_tag" },
    { 0x0542695A, "zone_tag_a" },
    { 0xDF3FEEF1, "zone_tag_b" },
    { 0x668F8894, "zone_trans_1" },
    { 0x681BA78C, "zone_trans_10" },
    { 0xD896F7CF, "zone_trans_2" },
    { 0xB2947D66, "zone_trans_3" },
    { 0xF4881959, "zone_trans_4" },
    { 0xCE859EF0, "zone_trans_5" },
    { 0x408D0E2B, "zone_trans_6" },
    { 0x1A8A93C2, "zone_trans_7" },
    { 0xBCA5D645, "zone_trans_8" },
    { 0x96A35BDC, "zone_trans_9" },
    { 0xCE1FCA4A, "zone_trigger" },
    { 0x13BA3226, "zone_trigger_watch" },
    { 0xBB7B26B3, "zone_trigs" },
    { 0x6D30FCE3, "zone_volumes" },
    { 0x2EF0780F, "zone_wait_till_enabled" },
    { 0x8715B526, "zoneautomovetime" },
    { 0xFF630891, "zonecounter" },
    { 0x67477381, "zoned" },
    { 0x56D118DA, "zonedestroyedbytimer" },
    { 0x4F2352A4, "zonedestroyedinenemystr" },
    { 0xFC77E3FD, "zonedestroyedinfriendlystr" },
    { 0xF6687CD3, "zoneguys" },
    { 0x2BDEFD79, "zoneindex" },
    { 0x931A3E17, "zonemovetime" },
    { 0xB0832F9A, "zonename" },
    { 0xB2A91B95, "zonenames" },
    { 0xCA8550C2, "zoneorgatmeshheight" },
    { 0xB1CF2B93, "zoneorgtoadjpos" },
    { 0x03100A3F, "zoneorgtochopper2d" },
    { 0xA6FCA341, "zoneorgtooppositeperpendicular" },
    { 0xE56286F0, "zoneorgtoperpendicular" },
    { 0x4F96ED99, "zoneorgtoplayer2d" },
    { 0x01B4B9AF, "zoneoverride" },
    { 0xE366D3B0, "zoneowningteam" },
    { 0xB34F24C5, "zonereturn" },
    { 0xCF270203, "zonerevealtime" },
    { 0xC52C30FE, "zones" },
    { 0x57D11A8A, "zones_for_extra_stink_locations" },
    { 0x02507FEA, "zonespawninginstr" },
    { 0x95DE880D, "zonespawnqueue" },
    { 0xF4308E2B, "zonespawntime" },
    { 0x486F01F3, "zonestocheck" },
    { 0x0D367E01, "zonetrigger" },
    { 0xE76EEB42, "zoning" },
    { 0x11471EF0, "zoom" },
    { 0x91758AA8, "zoom_avail" },
    { 0x6F7B4B83, "zoom_brightness_controls" },
    { 0x384FF134, "zoom_by" },
    { 0xB6255B39, "zoom_flash_shader" },
    { 0x52200B58, "zoom_fov_effect" },
    { 0x4F58145A, "zoom_hud" },
    { 0x8017EAC2, "zoom_in" },
    { 0x2E238177, "zoom_in_out_brightness" },
    { 0x66D0B8BF, "zoom_level" },
    { 0xD3660B00, "zoom_out_to_cliff" },
    { 0x7B9BB893, "zoom_pos" },
    { 0xD0B96EB8, "zoom_speed" },
    { 0x12AFAE3B, "zoom_turret_hud" },
    { 0x5D7D5683, "zoomed" },
    { 0xA114CBDF, "zoomed_fov" },
    { 0x6B6F7DEE, "zoomed_in_start_time" },
    { 0x4216F2D1, "zoomheight" },
    { 0x1B2BC568, "zooming" },
    { 0x74862F5B, "zooms" },
    { 0xC2ACAB72, "zort" },
    { 0xD9794D5F, "zpitted" },
    { 0x0AAAD843, "zpitted_preinit" },
    { 0x54737492, "zpo" },
    { 0x49FD3AD9, "zpo_listener" },
    { 0x531DB9D6, "zpoff" },
    { 0xE3393B95, "zpoff_listener" },
    { 0x7CF7C69D, "zpos" },
    { 0x98A9F998, "zpu" },
    { 0x320D5861, "zpu1" },
    { 0x580FD2CA, "zpu2" },
    { 0x3A0C19C6, "zpu_aa_gun" },
    { 0xF52A52AE, "zpu_battle_friendly_advance" },
    { 0x69E4FF4E, "zpu_battle_init" },
    { 0x503A149E, "zpu_battle_trigger_control" },
    { 0x3FCE9806, "zpu_c4" },
    { 0x36E6E711, "zpu_cancel" },
    { 0xEBB74942, "zpu_cancel_trig" },
    { 0xAE38A394, "zpu_damage_calc" },
    { 0x05C5E9D8, "zpu_death_fx" },
    { 0xC7EABA19, "zpu_dialogue" },
    { 0xD4D5A7C9, "zpu_dismount_trig" },
    { 0x863B8552, "zpu_driver_deathfunction" },
    { 0xE5A431DE, "zpu_encounter" },
    { 0x3A5E26F9, "zpu_fx" },
    { 0x974BF74F, "zpu_gun" },
    { 0xB1B7756E, "zpu_gunner" },
    { 0x85784477, "zpu_gunner_spawner" },
    { 0x75BBE732, "zpu_hut" },
    { 0xC2BFCF5B, "zpu_hut_start" },
    { 0xF3A442C0, "zpu_interface" },
    { 0x026F1337, "zpu_obj_num" },
    { 0x41E60058, "zpu_objective" },
    { 0x1E98212C, "zpu_player_followers" },
    { 0xF299FF3D, "zpu_player_turret" },
    { 0x90762A1A, "zpu_recycle" },
    { 0xEC844A59, "zpu_shoot1" },
    { 0x1286C4C2, "zpu_shoot2" },
    { 0xBA578EFF, "zpu_speech_started" },
    { 0xD78DC108, "zpu_target" },
    { 0xADB75B23, "zpu_targets" },
    { 0x552E6A40, "zpu_triggers" },
    { 0x7E02B306, "zpubadplace" },
    { 0xF1BCAD0B, "zpubattleseedtrig" },
    { 0x4972DB40, "zpublastradius" },
    { 0x8DE735ED, "zpuclosesavetrig" },
    { 0x039E3313, "zpugunner_animation_think" },
    { 0x1B67E04F, "zpugunner_dismount" },
    { 0x6294DDCF, "zpumidsavetrig" },
    { 0xFEB0E773, "zpus" },
    { 0x380582FF, "zpus_destroyed" },
    { 0x663E1FF6, "zrace" },
    { 0x272F75F6, "zrace_preinit" },
    { 0x05C89AAC, "zrange" },
    { 0x7A596BF8, "zrichtofen_init" },
    { 0x5FD4B76F, "zrichtofen_preinit" },
    { 0xB9B7B494, "zrnodes" },
    { 0x88CECC1C, "zs" },
    { 0xC260A269, "zscalarsq" },
    { 0x9B5F6E7A, "zstandard" },
    { 0x7CF3E066, "zstandard_main" },
    { 0xF64E852A, "zstandard_preinit" },
    { 0x666E52E9, "zsu" },
    { 0x74C98D68, "zsu_basic_control" },
    { 0xE758D6C9, "zsu_basic_fire" },
    { 0x269AB04A, "zsu_basic_movement" },
    { 0x636A5EC4, "zsu_positions" },
    { 0xD02764BD, "zsu_track_target_movement" },
    { 0x822E42E3, "zsurvival" },
    { 0x976B5660, "zsus" },
    { 0x1795D66C, "ztimer" },
    { 0x1D038167, "zturned" },
    { 0xD368678B, "zturned_preinit" },
    { 0xD04A6B04, "zurich" },
    { 0x0FEB9892, "zval" },
    { 0xEC2C073C, "zvar" },
}};

} // namespace xsk::arc::t7
