// Copyright 2024 xensik. All rights reserved.
//
// Use of this source code is governed by a GNU GPLv3 license
// that can be found in the LICENSE file.

#include "xsk/gsc/engine/h2.hpp"

namespace xsk::gsc::h2
{

extern std::array<std::pair<u32, char const*>, token_count> const token_list
{{
    { 0x0000, "" },
    { 0x0001, "pl#" },
    { 0x0002, "-" },
    { 0x0003, "radius`" },
    { 0x0004, "note:" },
    { 0x0005, "_" },
    { 0x0006, "_custom" },
    { 0x0007, "a" },
    { 0x0008, "ability" },
    { 0x0009, "accumulate" },
    { 0x000A, "accuracy" },
    { 0x000B, "actionslot1" },
    { 0x000C, "actionslot2" },
    { 0x000D, "actionslot3" },
    { 0x000E, "actionslot4" },
    { 0x000F, "actionslot5" },
    { 0x0010, "actionslot6" },
    { 0x0011, "actionslot7" },
    { 0x0012, "actionslot8" },
    { 0x0013, "activator" },
    { 0x0014, "active" },
    { 0x0015, "activecostume" },
    { 0x0016, "activeemblemslot" },
    { 0x0017, "activesquadmember" },
    { 0x0018, "activevisionset" },
    { 0x0019, "activevisionsetduration" },
    { 0x001A, "agent" },
    { 0x001B, "agenthealth" },
    { 0x001C, "agentname" },
    { 0x001D, "agentteam" },
    { 0x001E, "ai_event" },
    { 0x001F, "ai_sight_line_cycle_group" },
    { 0x0020, "ai_sight_line_group" },
    { 0x0021, "aim_highest_bone" },
    { 0x0022, "aim_vis_bone" },
    { 0x0023, "aispread" },
    { 0x0024, "aisquadmembers" },
    { 0x0025, "alert" },
    { 0x0026, "alertlevel" },
    { 0x0027, "alertlevelint" },
    { 0x0028, "alien" },
    { 0x0029, "alienplayerloadout" },
    { 0x002A, "alienplayerstats" },
    { 0x002B, "aliensession" },
    { 0x002C, "alignx" },
    { 0x002D, "aligny" },
    { 0x002E, "all" },
    { 0x002F, "allies" },
    { 0x0030, "allowcrouch" },
    { 0x0031, "allowdeath" },
    { 0x0032, "allowjump" },
    { 0x0033, "allowladders" },
    { 0x0034, "allowpain" },
    { 0x0035, "allowprone" },
    { 0x0036, "allstreaksrestricted" },
    { 0x0037, "alpha" },
    { 0x0038, "altmode" },
    { 0x0039, "always" },
    { 0x003A, "ambient" },
    { 0x003B, "ambienttrack" },
    { 0x003C, "ambienttrack_ac130" },
    { 0x003D, "ambush" },
    { 0x003E, "ambush_nodes_only" },
    { 0x003F, "angle_deltas" },
    { 0x0040, "anglelerprate" },
    { 0x0041, "angles" },
    { 0x0042, "anim_angle_delta" },
    { 0x0043, "anim_deltas" },
    { 0x0044, "anim_pose" },
    { 0x0045, "anim_will_finish" },
    { 0x0046, "animation" },
    { 0x0047, "animscript" },
    { 0x0048, "archived" },
    { 0x0049, "archivetime" },
    { 0x004A, "armor" },
    { 0x004B, "asleep" },
    { 0x004C, "aspectratio" },
    { 0x004D, "assaultstreaks" },
    { 0x004E, "assignedbucket" },
    { 0x004F, "assists" },
    { 0x0050, "attachment" },
    { 0x0051, "attachmentclassrestricted" },
    { 0x0052, "attachmentrestricted" },
    { 0x0053, "attachments" },
    { 0x0054, "attachtag" },
    { 0x0055, "attacker" },
    { 0x0056, "attackeraccuracy" },
    { 0x0057, "attackercount" },
    { 0x0058, "attackerisjuggernaut" },
    { 0x0059, "attackerpos" },
    { 0x005A, "author" },
    { 0x005B, "auto_ai" },
    { 0x005C, "auto_change" },
    { 0x005D, "auto_nonai" },
    { 0x005E, "avoidanceboundshalfsize" },
    { 0x005F, "awards" },
    { 0x0060, "axis" },
    { 0x0061, "b" },
    { 0x0062, "back" },
    { 0x0063, "back_left" },
    { 0x0064, "back_low" },
    { 0x0065, "back_mid" },
    { 0x0066, "back_right" },
    { 0x0067, "back_up" },
    { 0x0068, "background" },
    { 0x0069, "bad_guys" },
    { 0x006A, "bad_path" },
    { 0x006B, "badplaceawareness" },
    { 0x006C, "ball_off" },
    { 0x006D, "ball_on" },
    { 0x006E, "ball_pass" },
    { 0x006F, "bandwidthdown" },
    { 0x0070, "bandwidthtestcount" },
    { 0x0071, "bandwidthup" },
    { 0x0072, "baselineoverflow_max" },
    { 0x0073, "baselineoverflow_worst" },
    { 0x0074, "battery_discharge_begin" },
    { 0x0075, "battery_discharge_end" },
    { 0x0076, "begin" },
    { 0x0077, "begin_custom_anim" },
    { 0x0078, "begin_firing" },
    { 0x0079, "begin_firing_left" },
    { 0x007A, "bestweapon" },
    { 0x007B, "bestweaponindex" },
    { 0x007C, "bipods" },
    { 0x007D, "birthtime" },
    { 0x007E, "bl_rotor1" },
    { 0x007F, "bl_rotor2" },
    { 0x0080, "bl_rotor3" },
    { 0x0081, "blackops2prestige" },
    { 0x0082, "blackops2rank" },
    { 0x0083, "blade_hide" },
    { 0x0084, "blade_show" },
    { 0x0085, "blockfriendlies" },
    { 0x0086, "blurradius" },
    { 0x0087, "body" },
    { 0x0088, "body_animate_jnt" },
    { 0x0089, "bottomarc" },
    { 0x008A, "br_rotor1" },
    { 0x008B, "br_rotor2" },
    { 0x008C, "br_rotor3" },
    { 0x008D, "breadcrumbheader" },
    { 0x008E, "buff" },
    { 0x008F, "bullet_hitshield" },
    { 0x0090, "bullethit" },
    { 0x0091, "bulletwhizby" },
    { 0x0092, "c" },
    { 0x0093, "callingcardindex" },
    { 0x0094, "camo" },
    { 0x0095, "cancel_location" },
    { 0x0096, "canclimbladders" },
    { 0x0097, "canjumppath" },
    { 0x0098, "cardicon" },
    { 0x0099, "cardnameplate" },
    { 0x009A, "cardtitle" },
    { 0x009B, "cgmchecksum" },
    { 0x009C, "ch_prestige" },
    { 0x009D, "ch_prestige_max" },
    { 0x009E, "chainfallback" },
    { 0x009F, "chainnode" },
    { 0x00A0, "challengeprogress" },
    { 0x00A1, "challengestate" },
    { 0x00A2, "chest" },
    { 0x00A3, "churnscores" },
    { 0x00A4, "chyron_message1" },
    { 0x00A5, "chyron_message2" },
    { 0x00A6, "chyron_message3" },
    { 0x00A7, "civilian" },
    { 0x00A8, "clanidhigh" },
    { 0x00A9, "clanidlow" },
    { 0x00AA, "classname" },
    { 0x00AB, "clipdistance" },
    { 0x00AC, "code_classname" },
    { 0x00AD, "code_damageradius" },
    { 0x00AE, "code_move" },
    { 0x00AF, "code_move_slide" },
    { 0x00B0, "codecallback_agentadded" },
    { 0x00B1, "codecallback_agentdamaged" },
    { 0x00B2, "codecallback_agentkilled" },
    { 0x00B3, "codecallback_bullethitentity" },
    { 0x00B4, "codecallback_codeendgame" },
    { 0x00B5, "codecallback_entitydamage" },
    { 0x00B6, "codecallback_entityoutofworld" },
    { 0x00B7, "codecallback_handleinstantmessage" },
    { 0x00B8, "codecallback_hostmigration" },
    { 0x00B9, "codecallback_leaderdialog" },
    { 0x00BA, "codecallback_partymembers" },
    { 0x00BB, "codecallback_playerconnect" },
    { 0x00BC, "codecallback_playerdamage" },
    { 0x00BD, "codecallback_playerdisconnect" },
    { 0x00BE, "codecallback_playergrenadesuicide" },
    { 0x00BF, "codecallback_playerkilled" },
    { 0x00C0, "codecallback_playerlaststand" },
    { 0x00C1, "codecallback_playermigrated" },
    { 0x00C2, "codecallback_startgametype" },
    { 0x00C3, "codecallback_vehicledamage" },
    { 0x00C4, "color" },
    { 0x00C5, "color_blind_toggled" },
    { 0x00C6, "combat" },
    { 0x00C7, "combatmode" },
    { 0x00C8, "combatrecord" },
    { 0x00C9, "commonoption" },
    { 0x00CA, "confirm_location" },
    { 0x00CB, "connection_id" },
    { 0x00CC, "connectionidchunkhigh" },
    { 0x00CD, "connectionidchunklow" },
    { 0x00CE, "consolegame" },
    { 0x00CF, "consoleidchunkhigh" },
    { 0x00D0, "consoleidchunklow" },
    { 0x00D1, "constrained" },
    { 0x00D2, "contact" },
    { 0x00D3, "contextleanenabled" },
    { 0x00D4, "convergencetime" },
    { 0x00D5, "coopactivesquadmember" },
    { 0x00D6, "coopsquadmembers" },
    { 0x00D7, "costumes" },
    { 0x00D8, "count" },
    { 0x00D9, "cover" },
    { 0x00DA, "cover_approach" },
    { 0x00DB, "coversearchinterval" },
    { 0x00DC, "createstruct" },
    { 0x00DD, "createtime" },
    { 0x00DE, "criticalbulletdamagedist" },
    { 0x00DF, "crouch" },
    { 0x00E0, "currency" },
    { 0x00E1, "current" },
    { 0x00E2, "currentanimtime" },
    { 0x00E3, "currentgen" },
    { 0x00E4, "currentwinstreak" },
    { 0x00E5, "cursorhint" },
    { 0x00E6, "custom_attach_00" },
    { 0x00E7, "custom_attach_01" },
    { 0x00E8, "custom_attach_02" },
    { 0x00E9, "custom_attach_03" },
    { 0x00EA, "custom_attach_04" },
    { 0x00EB, "custom_attach_05" },
    { 0x00EC, "custom_attach_06" },
    { 0x00ED, "custom_attach_07" },
    { 0x00EE, "custom_attach_08" },
    { 0x00EF, "custom_attach_09" },
    { 0x00F0, "custom_attach_10" },
    { 0x00F1, "custom_attach_11" },
    { 0x00F2, "custom_attach_12" },
    { 0x00F3, "custom_attach_13" },
    { 0x00F4, "custom_attach_14" },
    { 0x00F5, "custom_attach_15" },
    { 0x00F6, "customclasses" },
    { 0x00F7, "customization_loaded" },
    { 0x00F8, "d" },
    { 0x00F9, "dailychallengeid" },
    { 0x00FA, "damage" },
    { 0x00FB, "damage_notdone" },
    { 0x00FC, "damagedir" },
    { 0x00FD, "damagelocation" },
    { 0x00FE, "damagemod" },
    { 0x00FF, "damagemultiplier" },
    { 0x0100, "damageshield" },
    { 0x0101, "damagetaken" },
    { 0x0102, "damageweapon" },
    { 0x0103, "damageyaw" },
    { 0x0104, "dangerreactduration" },
    { 0x0105, "datalength" },
    { 0x0106, "dcid" },
    { 0x0107, "dead" },
    { 0x0108, "death" },
    { 0x0109, "deathangles" },
    { 0x010A, "deathinvulnerabletime" },
    { 0x010B, "deathplant" },
    { 0x010C, "deathpos" },
    { 0x010D, "deaths" },
    { 0x010E, "deathshield" },
    { 0x010F, "defaultclasses" },
    { 0x0110, "defense" },
    { 0x0111, "defense_level" },
    { 0x0112, "delayeddeath" },
    { 0x0113, "deploy_riotshield" },
    { 0x0114, "desc" },
    { 0x0115, "descmodified" },
    { 0x0116, "desiredangle" },
    { 0x0117, "destructible_type" },
    { 0x0118, "detectable" },
    { 0x0119, "detected" },
    { 0x011A, "detonate" },
    { 0x011B, "device_id_high" },
    { 0x011C, "device_id_low" },
    { 0x011D, "deviceconnectionhistory" },
    { 0x011E, "deviceusefrequency" },
    { 0x011F, "diequietly" },
    { 0x0120, "diffusefraction" },
    { 0x0121, "direct" },
    { 0x0122, "disable" },
    { 0x0123, "disableplayeradsloscheck" },
    { 0x0124, "dlight" },
    { 0x0125, "dmg" },
    { 0x0126, "dodamagetoall" },
    { 0x0127, "dodangerreact" },
    { 0x0128, "doffar" },
    { 0x0129, "dofnear" },
    { 0x012A, "dofphysicalfocusdistance" },
    { 0x012B, "dofphysicalfstop" },
    { 0x012C, "dog" },
    { 0x012D, "doghandler" },
    { 0x012E, "doingambush" },
    { 0x012F, "done" },
    { 0x0130, "dontavoidplayer" },
    { 0x0131, "dotofdeath" },
    { 0x0132, "down" },
    { 0x0133, "downaimlimit" },
    { 0x0134, "drawoncompass" },
    { 0x0135, "dropweapon" },
    { 0x0136, "duration" },
    { 0x0137, "eftarc" },
    { 0x0138, "empty" },
    { 0x0139, "empty_offhand" },
    { 0x013A, "enable" },
    { 0x013B, "enablehudlighting" },
    { 0x013C, "enableshadows" },
    { 0x013D, "end_firing" },
    { 0x013E, "end_firing_left" },
    { 0x013F, "end_script" },
    { 0x0140, "enddeaths" },
    { 0x0141, "endkills" },
    { 0x0142, "enemy" },
    { 0x0143, "enemy_sighted" },
    { 0x0144, "enemy_sighted_lost" },
    { 0x0145, "enemy_visible" },
    { 0x0146, "enemyname" },
    { 0x0147, "enemyplatform" },
    { 0x0148, "enemyradarmode" },
    { 0x0149, "enemyxuidhigh" },
    { 0x014A, "enemyxuidlow" },
    { 0x014B, "energy_fire" },
    { 0x014C, "engagemaxdist" },
    { 0x014D, "engagemaxfalloffdist" },
    { 0x014E, "engagemindist" },
    { 0x014F, "engageminfalloffdist" },
    { 0x0150, "enhanceable" },
    { 0x0151, "entity" },
    { 0x0152, "entitydeleted" },
    { 0x0153, "entityoverflow_max" },
    { 0x0154, "entityoverflow_worst" },
    { 0x0155, "equipment" },
    { 0x0156, "equipmentsetups" },
    { 0x0157, "escaped" },
    { 0x0158, "exclusive" },
    { 0x0159, "exo_ability_activate" },
    { 0x015A, "exo_adrenaline_fire" },
    { 0x015B, "exo_boost" },
    { 0x015C, "exo_dodge" },
    { 0x015D, "exo_power" },
    { 0x015E, "exo_slide" },
    { 0x015F, "exo_slide_hit_player" },
    { 0x0160, "exoattachment1" },
    { 0x0161, "exoattachment2" },
    { 0x0162, "experience" },
    { 0x0163, "explode" },
    { 0x0164, "exposedduration" },
    { 0x0165, "extracustomclassesentitlement" },
    { 0x0166, "extracustomclassesprestige" },
    { 0x0167, "extrascore0" },
    { 0x0168, "extrascore1" },
    { 0x0169, "face_angle" },
    { 0x016A, "face_angle_3d" },
    { 0x016B, "face_angle_abs" },
    { 0x016C, "face_angle_rel" },
    { 0x016D, "face_current" },
    { 0x016E, "face_default" },
    { 0x016F, "face_direction" },
    { 0x0170, "face_enemy" },
    { 0x0171, "face_enemy_or_motion" },
    { 0x0172, "face_goal" },
    { 0x0173, "face_motion" },
    { 0x0174, "face_point" },
    { 0x0175, "facemotion" },
    { 0x0176, "failed" },
    { 0x0177, "falling" },
    { 0x0178, "fast_radar" },
    { 0x0179, "favoriteenemy" },
    { 0x017A, "finalaccuracy" },
    { 0x017B, "first_person" },
    { 0x017C, "firstplayedsptime" },
    { 0x017D, "fixednode" },
    { 0x017E, "fixednodesaferadius" },
    { 0x017F, "fl_rotor1" },
    { 0x0180, "fl_rotor2" },
    { 0x0181, "fl_rotor3" },
    { 0x0182, "flash" },
    { 0x0183, "flashbang" },
    { 0x0184, "foley" },
    { 0x0185, "follow" },
    { 0x0186, "followmax" },
    { 0x0187, "followmin" },
    { 0x0188, "font" },
    { 0x0189, "fontscale" },
    { 0x018A, "foot_ik_active" },
    { 0x018B, "foot_ik_blend_in" },
    { 0x018C, "foot_ik_blend_out" },
    { 0x018D, "foot_ik_inactive" },
    { 0x018E, "footstepdetectdist" },
    { 0x018F, "footstepdetectdistsprint" },
    { 0x0190, "footstepdetectdistwalk" },
    { 0x0191, "force_off" },
    { 0x0192, "force_on" },
    { 0x0193, "force_fully_on" },
    { 0x0194, "forcepartyskillignore" },
    { 0x0195, "forceragdollimmediate" },
    { 0x0196, "forcespectatorclient" },
    { 0x0197, "foregrip_off" },
    { 0x0198, "foreground" },
    { 0x0199, "forward" },
    { 0x019A, "fov" },
    { 0x019B, "fovcosine" },
    { 0x019C, "fovcosinebusy" },
    { 0x019D, "fovcosinez" },
    { 0x019E, "fr_rotor1" },
    { 0x019F, "fr_rotor2" },
    { 0x01A0, "fr_rotor3" },
    { 0x01A1, "fraction" },
    { 0x01A2, "frag" },
    { 0x01A3, "free" },
    { 0x01A4, "freecamera" },
    { 0x01A5, "freelook" },
    { 0x01A6, "frequency" },
    { 0x01A7, "friendlyfire" },
    { 0x01A8, "front_left" },
    { 0x01A9, "front_right" },
    { 0x01AA, "frontshieldanglecos" },
    { 0x01AB, "fs_concrete" },
    { 0x01AC, "fs_dirt" },
    { 0x01AD, "fs_metal" },
    { 0x01AE, "fs_wood" },
    { 0x01AF, "game_extrainfo" },
    { 0x01B0, "gamecount" },
    { 0x01B1, "gamertag" },
    { 0x01B2, "gamesplayed" },
    { 0x01B3, "gametype" },
    { 0x01B4, "gender" },
    { 0x01B5, "ghostsprestige" },
    { 0x01B6, "ghostsrank" },
    { 0x01B7, "glass" },
    { 0x01B8, "glass_damaged" },
    { 0x01B9, "glass_destroyed" },
    { 0x01BA, "globalcostume" },
    { 0x01BB, "gloves" },
    { 0x01BC, "glowalpha" },
    { 0x01BD, "glowcolor" },
    { 0x01BE, "goal" },
    { 0x01BF, "goal_changed" },
    { 0x01C0, "goal_reached" },
    { 0x01C1, "goal_yaw" },
    { 0x01C2, "goalheight" },
    { 0x01C3, "goalpos" },
    { 0x01C4, "goalradius" },
    { 0x01C5, "goaltime" },
    { 0x01C6, "goalweight" },
    { 0x01C7, "goingtoruntopos" },
    { 0x01C8, "gravity" },
    { 0x01C9, "gravity_noclip" },
    { 0x01CA, "grenade" },
    { 0x01CB, "grenade_fire" },
    { 0x01CC, "grenade_off" },
    { 0x01CD, "grenade_on" },
    { 0x01CE, "grenade_pullback" },
    { 0x01CF, "grenade_return_hand_tag" },
    { 0x01D0, "grenadeammo" },
    { 0x01D1, "grenadeawareness" },
//  { 0x01D2, "" },
//  { 0x01D3, "" },
//  { 0x01D4, "" },
    { 0x01D5, "grenadedanger" },
    { 0x01D6, "grenadeweapon" },
    { 0x01D7, "ground_slam" },
    { 0x01D8, "ground_slam_hit_player" },
    { 0x01D9, "groundentchanged" },
    { 0x01DA, "groundtype" },
    { 0x01DB, "gunblockedbywall" },
    { 0x01DC, "gunshot" },
    { 0x01DD, "gunshot_teammate" },
    { 0x01DE, "hardcoremodeon" },
    { 0x01DF, "hasdoublexpitem" },
    { 0x01E0, "hasradar" },
    { 0x01E1, "hasvalidcostumeselfieimage" },
    { 0x01E2, "head" },
    { 0x01E3, "headicon" },
    { 0x01E4, "headiconteam" },
    { 0x01E5, "headshots" },
    { 0x01E6, "health" },
    { 0x01E7, "healthregen" },
    { 0x01E8, "height" },
    { 0x01E9, "helmet" },
    { 0x01EA, "hidein3rdperson" },
    { 0x01EB, "hidewhendead" },
    { 0x01EC, "hidewhenindemo" },
    { 0x01ED, "hidewheninmenu" },
    { 0x01EE, "high_priority" },
    { 0x01EF, "highlyawareradius" },
    { 0x01F0, "hindlegstraceoffset" },
    { 0x01F1, "hintstring" },
    { 0x01F2, "hit_by_missile" },
    { 0x01F3, "horzalign" },
    { 0x01F4, "host_sucks_end_game" },
    { 0x01F5, "hostfailures" },
    { 0x01F6, "hostquits" },
    { 0x01F7, "hostsuccesses" },
    { 0x01F8, "human" },
    { 0x01F9, "iconnew" },
    { 0x01FA, "iconunlocked" },
    { 0x01FB, "ignoreall" },
    { 0x01FC, "ignoreclosefoliage" },
    { 0x01FD, "ignoreexplosionevents" },
    { 0x01FE, "ignoreforfixednodesafecheck" },
    { 0x01FF, "ignoreme" },
    { 0x0200, "ignorerandombulletdamage" },
    { 0x0201, "ignoresuppression" },
    { 0x0202, "ignoreplayersuppression" },
    { 0x0203, "ignoretriggers" },
    { 0x0204, "ikweight" },
    { 0x0205, "index" },
    { 0x0206, "infinite_energy" },
    { 0x0207, "info_notnull" },
    { 0x0208, "info_player_start" },
    { 0x0209, "init" },
    { 0x020A, "initstructs" },
    { 0x020B, "insolid" },
    { 0x020C, "intermission" },
    { 0x020D, "interval" },
    { 0x020E, "inuse" },
    { 0x020F, "invalid_parent" },
    { 0x0210, "invisible" },
    { 0x0211, "isradarblocked" },
    { 0x0212, "item" },
    { 0x0213, "j_exo_rcket_arm02" },
    { 0x0214, "j_exoclav04_l" },
    { 0x0215, "j_exoclav04_r" },
    { 0x0216, "j_exohip04_l" },
    { 0x0217, "j_exohip04_r" },
    { 0x0218, "j_eyeball_le" },
    { 0x0219, "j_eyeball_ri" },
    { 0x021A, "j_gun" },
    { 0x021B, "j_head" },
    { 0x021C, "j_hip_l" },
    { 0x021D, "j_hip_r" },
    { 0x021E, "j_knee_le" },
    { 0x021F, "j_knee_ri" },
    { 0x0220, "j_left_elbow" },
    { 0x0221, "j_left_hand" },
    { 0x0222, "j_left_shoulder" },
    { 0x0223, "j_mainroot" },
    { 0x0224, "j_neck" },
    { 0x0225, "j_right_elbow" },
    { 0x0226, "j_right_hand" },
    { 0x0227, "j_right_hand_placement" },
    { 0x0228, "j_right_shoulder" },
    { 0x0229, "j_rocket" },
    { 0x022A, "j_spine4" },
    { 0x022B, "j_spinelower" },
    { 0x022C, "j_spineupper" },
    { 0x022D, "jumpcost" },
    { 0x022E, "jumping" },
    { 0x022F, "justclass" },
    { 0x0230, "kdratio" },
    { 0x0231, "keepclaimednode" },
    { 0x0232, "keepclaimednodeifvalid" },
    { 0x0233, "keepnodeduringscriptedanim" },
    { 0x0234, "key1" },
    { 0x0235, "key2" },
    { 0x0236, "kill_timestamp" },
    { 0x0237, "killanimscript" },
    { 0x0238, "killcamentity" },
    { 0x0239, "killcamentitylookat" },
    { 0x023A, "kills" },
    { 0x023B, "killstreak" },
    { 0x023C, "killstreakcount" },
    { 0x023D, "killstreakrestricted" },
    { 0x023E, "killstreakunlocked" },
    { 0x023F, "knife_off" },
    { 0x0240, "knife_on" },
    { 0x0241, "known_event" },
    { 0x0242, "label" },
    { 0x0243, "ladder_down" },
    { 0x0244, "ladder_up" },
    { 0x0245, "land" },
    { 0x0246, "last_stand_count" },
    { 0x0247, "lastattacker" },
    { 0x0248, "lastenemysightpos" },
    { 0x0249, "lastplayedtime" },
    { 0x024A, "laststand" },
    { 0x024B, "leanamount" },
    { 0x024C, "ledge" },
    { 0x024D, "left" },
    { 0x024E, "leftaimlimit" },
    { 0x024F, "leftarc" },
    { 0x0250, "lethal" },
    { 0x0251, "lifecount" },
    { 0x0252, "light" },
    { 0x0253, "lives" },
    { 0x0254, "loadouts" },
    { 0x0255, "lockorientation" },
    { 0x0256, "lod" },
    { 0x0257, "look" },
    { 0x0258, "lookahead" },
    { 0x0259, "lookaheaddir" },
    { 0x025A, "lookaheaddist" },
    { 0x025B, "lookaheadhitsstairs" },
    { 0x025C, "lookforward" },
    { 0x025D, "lookright" },
    { 0x025E, "looktarget" },
    { 0x025F, "lookup" },
    { 0x0260, "loot" },
    { 0x0261, "lootnew" },
    { 0x0262, "loses" },
    { 0x0263, "low_priority" },
    { 0x0264, "lowresbackground" },
    { 0x0265, "luinotifyserver" },
    { 0x0266, "mag_eject" },
    { 0x0267, "mag_eject_left" },
    { 0x0268, "main" },
    { 0x0269, "manual" },
    { 0x026A, "manual_ai" },
    { 0x026B, "manual_change" },
    { 0x026C, "map" },
    { 0x026D, "matchid" },
    { 0x026E, "matchmakingsettingsversion" },
    { 0x026F, "matchmakingtesttype" },
    { 0x0270, "max_time" },
    { 0x0271, "maxfaceenemydist" },
    { 0x0272, "maxhealth" },
    { 0x0273, "maxrange" },
    { 0x0274, "maxsightdistsqrd" },
    { 0x0275, "maxturnspeed" },
    { 0x0276, "maxvisibledist" },
    { 0x0277, "melee_fired" },
    { 0x0278, "melee_hit_react" },
    { 0x0279, "meleeattackdist" },
    { 0x027A, "menuresponse" },
    { 0x027B, "micro_dlc_bits_last_gen" },
    { 0x027C, "micro_dlc_bits_next_gen" },
    { 0x027D, "middle_left" },
    { 0x027E, "middle_right" },
    { 0x027F, "migrateablequits" },
    { 0x0280, "min_energy" },
    { 0x0281, "min_time" },
    { 0x0282, "minpaindamage" },
    { 0x0283, "minusedistsq" },
    { 0x0284, "missile_fire" },
    { 0x0285, "missile_passed_target" },
    { 0x0286, "missile_stuck" },
    { 0x0287, "mlgversion" },
    { 0x0288, "mod" },
    { 0x0289, "mod_crush" },
    { 0x028A, "mod_energy" },
    { 0x028B, "mod_explosive" },
    { 0x028C, "mod_explosive_bullet" },
    { 0x028D, "mod_falling" },
    { 0x028E, "mod_grenade" },
    { 0x028F, "mod_grenade_splash" },
    { 0x0290, "mod_head_shot" },
    { 0x0291, "mod_impact" },
    { 0x0292, "mod_melee" },
    { 0x0293, "mod_melee_alien" },
    { 0x0294, "mod_melee_alt" },
    { 0x0295, "mod_melee_dog" },
    { 0x0296, "mod_pistol_bullet" },
    { 0x0297, "mod_projectile" },
    { 0x0298, "mod_projectile_splash" },
    { 0x0299, "mod_rifle_bullet" },
    { 0x029A, "mod_suicide" },
    { 0x029B, "mod_trigger_hurt" },
    { 0x029C, "mod_unknown" },
    { 0x029D, "model" },
    { 0x029E, "modeprefix" },
    { 0x029F, "modifiers" },
    { 0x02A0, "motiontrackerenabled" },
    { 0x02A1, "mounted_dlc_bits" },
    { 0x02A2, "movedone" },
    { 0x02A3, "movemode" },
    { 0x02A4, "munition" },
    { 0x02A5, "munition_level" },
    { 0x02A6, "mw3prestige" },
    { 0x02A7, "mw3rank" },
    { 0x02A8, "name" },
    { 0x02A9, "namemodified" },
    { 0x02AA, "near_goal" },
    { 0x02AB, "nearz" },
    { 0x02AC, "neutral" },
    { 0x02AD, "never" },
    { 0x02AE, "newenemyreactiondistsq" },
    { 0x02AF, "newentitlement" },
    { 0x02B0, "nextgen" },
    { 0x02B1, "nextreadblackops2" },
    { 0x02B2, "nextreadghosts0" },
    { 0x02B3, "nextreadghosts1" },
    { 0x02B4, "nextreadmw3" },
    { 0x02B5, "night_vision_off" },
    { 0x02B6, "night_vision_on" },
    { 0x02B7, "no_bot_random_path" },
    { 0x02B8, "no_cover" },
    { 0x02B9, "no_gravity" },
    { 0x02BA, "noattackeraccuracymod" },
    { 0x02BB, "noclip" },
    { 0x02BC, "node" },
    { 0x02BD, "node_not_safe" },
    { 0x02BE, "node_out_of_range" },
    { 0x02BF, "node_relinquished" },
    { 0x02C0, "node_taken" },
    { 0x02C1, "nodeoffsetpos" },
    { 0x02C2, "nododgemove" },
    { 0x02C3, "noteammove" },
    { 0x02C4, "nogravity" },
    { 0x02C5, "nogrenadereturnthrow" },
    { 0x02C6, "noncombat" },
    { 0x02C7, "none" },
    { 0x02C8, "nonmigrateablequits" },
    { 0x02C9, "nophysics" },
    { 0x02CA, "normal" },
    { 0x02CB, "normal_radar" },
    { 0x02CC, "northyaw" },
    { 0x02CD, "notifyname" },
    { 0x02CE, "notinsolid" },
    { 0x02CF, "num0" },
    { 0x02D0, "num1" },
    { 0x02D1, "num2" },
    { 0x02D2, "num3" },
    { 0x02D3, "num4" },
    { 0x02D4, "objective" },
    { 0x02D5, "obstacle" },
    { 0x02D6, "offense" },
    { 0x02D7, "offense_level" },
    { 0x02D8, "offhand" },
    { 0x02D9, "offhand_end" },
    { 0x02DA, "offhandweapon" },
    { 0x02DB, "oldtime" },
    { 0x02DC, "ondeactivate" },
    { 0x02DD, "onenterstate" },
    { 0x02DE, "only_sky" },
    { 0x02DF, "onlygoodnearestnodes" },
    { 0x02E0, "onwifi" },
    { 0x02E1, "operationsdeadline" },
    { 0x02E2, "oriented" },
    { 0x02E3, "orientto_complete" },
    { 0x02E4, "origin" },
    { 0x02E5, "other" },
    { 0x02E6, "over" },
    { 0x02E7, "owner" },
    { 0x02E8, "pacifist" },
    { 0x02E9, "pacifistwait" },
    { 0x02EA, "pain" },
    { 0x02EB, "pantssize" },
    { 0x02EC, "parentindex" },
    { 0x02ED, "parentname" },
    { 0x02EE, "partyid" },
    { 0x02EF, "pasttitledata" },
    { 0x02F0, "patch" },
    { 0x02F1, "patchbacking" },
    { 0x02F2, "path_blocked" },
    { 0x02F3, "path_changed" },
    { 0x02F4, "path_dir_change" },
    { 0x02F5, "path_enemy" },
    { 0x02F6, "path_need_dodge" },
    { 0x02F7, "path_set" },
    { 0x02F8, "pathenemyfightdist" },
    { 0x02F9, "pathenemylookahead" },
    { 0x02FA, "pathgoalpos" },
    { 0x02FB, "pathlookaheaddist" },
    { 0x02FC, "pathrandompercent" },
    { 0x02FD, "pc" },
    { 0x02FE, "pccg" },
    { 0x02FF, "pelvis" },
    { 0x0300, "perk1" },
    { 0x0301, "perk2" },
    { 0x0302, "perk3" },
    { 0x0303, "perk4" },
    { 0x0304, "perk5" },
    { 0x0305, "perk6" },
    { 0x0306, "perkclassrestricted" },
    { 0x0307, "perkrestricted" },
    { 0x0308, "perks" },
    { 0x0309, "perkslots" },
    { 0x030A, "pers" },
    { 0x030B, "persistentperksunlocked" },
    { 0x030C, "persistentweaponsunlocked" },
    { 0x030D, "phone_off" },
    { 0x030E, "phone_on" },
    { 0x030F, "physics_finished" },
    { 0x0310, "physics_impact" },
    { 0x0311, "pickup" },
    { 0x0312, "pickup_riotshield" },
    { 0x0313, "pistol" },
    { 0x0314, "pitchamount" },
    { 0x0315, "pitchconvergencetime" },
    { 0x0316, "plane_waypoint" },
    { 0x0317, "playedblackops2" },
    { 0x0318, "playedghosts" },
    { 0x0319, "playedmw3" },
    { 0x031A, "player" },
    { 0x031B, "player_controller" },
    { 0x031C, "player_pushed" },
    { 0x031D, "playercardbackground" },
    { 0x031E, "playercardpatch" },
    { 0x031F, "playercardpatchbacking" },
    { 0x0320, "playerconnectionhistory" },
    { 0x0321, "playerid" },
    { 0x0322, "playerip" },
    { 0x0323, "playername" },
    { 0x0324, "playerpositions" },
    { 0x0325, "players" },
    { 0x0326, "playerspread" },
    { 0x0327, "playerxuidhigh" },
    { 0x0328, "playerxuidlow" },
    { 0x0329, "playing" },
    { 0x032A, "points" },
    { 0x032B, "position" },
    { 0x032C, "positioninworld" },
    { 0x032D, "postsharpturnlookaheaddist" },
    { 0x032E, "precache" },
    { 0x032F, "predicted_projectile_impact" },
    { 0x0330, "prestige" },
    { 0x0331, "prestigedoublexp" },
    { 0x0332, "prestigedoublexpmaxtimeplayed" },
    { 0x0333, "prestigeshoptokens" },
    { 0x0334, "prestigeshoptokensentitlement" },
    { 0x0335, "prevanimdelta" },
    { 0x0336, "prevnode" },
    { 0x0337, "prevscript" },
    { 0x0338, "primary" },
    { 0x0339, "primaryattachment1" },
    { 0x033A, "primaryattachment2" },
    { 0x033B, "primaryattachment3" },
    { 0x033C, "primaryattachments" },
    { 0x033D, "primaryattachkit" },
    { 0x033E, "primarycamo" },
    { 0x033F, "primaryfurniturekit" },
    { 0x0340, "primaryoffhand" },
    { 0x0341, "primaryreticle" },
    { 0x0342, "primaryweapon" },
    { 0x0343, "privatematchactivesquadmember" },
    { 0x0344, "privatematchcustomclasses" },
    { 0x0345, "privatematchsquadmembers" },
    { 0x0346, "projectile_impact" },
    { 0x0347, "projectile_impact_player" },
    { 0x0348, "prone" },
    { 0x0349, "proneok" },
    { 0x034A, "providecoveringfire" },
    { 0x034B, "ps3" },
    { 0x034C, "ps4" },
    { 0x034D, "psoffsettime" },
    { 0x034E, "pushable" },
    { 0x034F, "radaralwayson" },
    { 0x0350, "radarmode" },
    { 0x0351, "radarshowenemydirection" },
    { 0x0352, "radarstrength" },
    { 0x0353, "radius" },
    { 0x0354, "ragdoll_early_result" },
    { 0x0355, "raise_riotshield" },
    { 0x0356, "rank" },
    { 0x0357, "rate" },
    { 0x0358, "reached_end_node" },
    { 0x0359, "reached_wait_node" },
    { 0x035A, "reached_wait_speed" },
    { 0x035B, "reactiontargetpos" },
    { 0x035C, "realtimedelta" },
    { 0x035D, "receiver" },
    { 0x035E, "recipename" },
    { 0x035F, "reciprocality" },
    { 0x0360, "reflection_clear_color" },
    { 0x0361, "reinforcement" },
    { 0x0362, "relativedir" },
    { 0x0363, "relativeoffset" },
    { 0x0364, "reload" },
    { 0x0365, "reload_start" },
    { 0x0366, "remotemissilespawn" },
    { 0x0367, "rendertotexture" },
    { 0x0368, "reportindex" },
    { 0x0369, "reports" },
    { 0x036A, "reputation" },
    { 0x036B, "requestarrivalnotify" },
    { 0x036C, "requirement_beat100waves" },
    { 0x036D, "requirement_beat200waves" },
    { 0x036E, "requirement_beat50waves" },
    { 0x036F, "requirement_beatenzombies" },
    { 0x0370, "requirement_maxarmorproficiency" },
    { 0x0371, "requirement_maxweaponproficiency" },
    { 0x0372, "requirement_playedallmaps" },
    { 0x0373, "requirement_unlockedprison" },
    { 0x0374, "requirement_unlockedtier2" },
    { 0x0375, "requirement_unlockedtier3" },
    { 0x0376, "reserved" },
    { 0x0377, "respawndelay" },
    { 0x0378, "result" },
    { 0x0379, "reticle" },
    { 0x037A, "return_pitch" },
    { 0x037B, "reverse" },
    { 0x037C, "revives" },
    { 0x037D, "right" },
    { 0x037E, "rightaimlimit" },
    { 0x037F, "rightarc" },
    { 0x0380, "riotshield_damaged" },
    { 0x0381, "riotshield_hit" },
    { 0x0382, "rocket" },
    { 0x0383, "rocket_off" },
    { 0x0384, "rocket_on" },
    { 0x0385, "rotatedone" },
    { 0x0386, "rotation" },
    { 0x0387, "run" },
    { 0x0388, "runcost" },
    { 0x0389, "runto_arrived" },
    { 0x038A, "safetochangescript" },
    { 0x038B, "scavenger" },
    { 0x038C, "scope_cap" },
    { 0x038D, "scope_center" },
    { 0x038E, "scope_top" },
    { 0x038F, "score" },
    { 0x0390, "script" },
    { 0x0391, "script_brushmodel" },
    { 0x0392, "script_clut" },
    { 0x0393, "script_context" },
    { 0x0394, "script_delay" },
    { 0x0395, "script_goal_changed" },
    { 0x0396, "script_label" },
    { 0x0397, "script_lightset" },
    { 0x0398, "script_linkname" },
    { 0x0399, "script_model" },
    { 0x039A, "script_noteworthy" },
    { 0x039B, "script_origin" },
    { 0x039C, "script_parent" },
    { 0x039D, "script_parentname" },
    { 0x039E, "script_pushable" },
    { 0x039F, "script_vehicle" },
    { 0x03A0, "script_vehicle_collision" },
    { 0x03A1, "script_vehicle_collmap" },
    { 0x03A2, "script_vehicle_corpse" },
    { 0x03A3, "script_visionset" },
    { 0x03A4, "script_water" },
    { 0x03A5, "script_reverb" },
    { 0x03A6, "script_zone" },
    { 0x03A7, "scriptable" },
    { 0x03A8, "scriptableactor" },
    { 0x03A9, "scripted_viewmodel_anim" },
    { 0x03AA, "scriptedarrivalent" },
    { 0x03AB, "search_end" },
    { 0x03AC, "secondary" },
    { 0x03AD, "secondaryattachment1" },
    { 0x03AE, "secondaryattachment2" },
    { 0x03AF, "secondaryattachments" },
    { 0x03B0, "secondaryattachkit" },
    { 0x03B1, "secondarycamo" },
    { 0x03B2, "secondaryfurniturekit" },
    { 0x03B3, "secondaryoffhand" },
    { 0x03B4, "secondaryreticle" },
    { 0x03B5, "secondaryweapon" },
    { 0x03B6, "sentry" },
    { 0x03B7, "sentry_manual" },
    { 0x03B8, "sentry_offline" },
    { 0x03B9, "servertimecount" },
    { 0x03BA, "servertimeexceedcount" },
    { 0x03BB, "servertimemax" },
    { 0x03BC, "servertimetotal" },
    { 0x03BD, "servertimetotalexceed" },
    { 0x03BE, "sessionstate" },
    { 0x03BF, "sessionteam" },
    { 0x03C0, "sharpturn" },
    { 0x03C1, "sharpturnlookaheaddist" },
    { 0x03C2, "sharpturnnotifydist" },
    { 0x03C3, "sharpturntooclosetodestdist" },
    { 0x03C4, "shirt" },
    { 0x03C5, "showinkillcam" },
    { 0x03C6, "showkillcam" },
    { 0x03C7, "sightlatency" },
    { 0x03C8, "defaultsightlatency" },
    { 0x03C9, "silenced_shot" },
    { 0x03CA, "skill_points" },
    { 0x03CB, "skillbucket" },
    { 0x03CC, "skillrating" },
    { 0x03CD, "skillratingtype" },
    { 0x03CE, "slidevelocity" },
    { 0x03CF, "slowmo_active" },
    { 0x03D0, "slowmo_passive" },
    { 0x03D1, "smoke" },
    { 0x03D2, "snd_channelvolprio_holdbreath" },
    { 0x03D3, "snd_channelvolprio_pain" },
    { 0x03D4, "snd_channelvolprio_shellshock" },
    { 0x03D5, "snd_enveffectsprio_level" },
    { 0x03D6, "snd_enveffectsprio_shellshock" },
    { 0x03D7, "sort" },
    { 0x03D8, "sound_blend" },
    { 0x03D9, "soundeventdone" },
    { 0x03DA, "space" },
    { 0x03DB, "spawned" },
    { 0x03DC, "spawner" },
    { 0x03DD, "spawnflags" },
    { 0x03DE, "spawnpos" },
    { 0x03DF, "spawntime" },
    { 0x03E0, "specialgrenade" },
    { 0x03E1, "spectatekillcam" },
    { 0x03E2, "spectating_cycle" },
    { 0x03E3, "spectator" },
    { 0x03E4, "speechcommand" },
    { 0x03E5, "speed" },
    { 0x03E6, "splatter" },
    { 0x03E7, "splineplanereachednode" },
    { 0x03E8, "sprint_begin" },
    { 0x03E9, "sprint_end" },
    { 0x03EA, "sprint_slide_begin" },
    { 0x03EB, "sprint_slide_end" },
    { 0x03EC, "squad_base" },
    { 0x03ED, "squad_mode" },
    { 0x03EE, "squad_name" },
    { 0x03EF, "squadhq" },
    { 0x03F0, "squadmembers" },
    { 0x03F1, "squadmemxp" },
    { 0x03F2, "squadname" },
    { 0x03F3, "stairs" },
    { 0x03F4, "stairsstate" },
    { 0x03F5, "stand" },
    { 0x03F6, "start_blend" },
    { 0x03F7, "start_move" },
    { 0x03F8, "start_ragdoll" },
    { 0x03F9, "startdeaths" },
    { 0x03FA, "startdeploy_riotshield" },
    { 0x03FB, "startingoffsetforlife" },
    { 0x03FC, "startkills" },
    { 0x03FD, "state_changed" },
    { 0x03FE, "statelocked" },
    { 0x03FF, "stencil_disable" },
    { 0x0400, "stencil_onesided" },
    { 0x0401, "stencil_twosided" },
    { 0x0402, "stencilfunc_always" },
    { 0x0403, "stencilfunc_equal" },
    { 0x0404, "stencilfunc_greater" },
    { 0x0405, "stencilfunc_greaterequal" },
    { 0x0406, "stencilfunc_less" },
    { 0x0407, "stencilfunc_lessequal" },
    { 0x0408, "stencilfunc_never" },
    { 0x0409, "stencilfunc_notequal" },
    { 0x040A, "stencilop_decr" },
    { 0x040B, "stencilop_decrsat" },
    { 0x040C, "stencilop_incr" },
    { 0x040D, "stencilop_incrsat" },
    { 0x040E, "stencilop_invert" },
    { 0x040F, "stencilop_keep" },
    { 0x0410, "stencilop_replace" },
    { 0x0411, "stencilop_zero" },
    { 0x0412, "stop" },
    { 0x0413, "stop_soon" },
    { 0x0414, "stopanimdistsq" },
    { 0x0415, "stopsoonnotifydist" },
    { 0x0416, "streak" },
    { 0x0417, "streaktype" },
    { 0x0418, "suckedashost" },
    { 0x0419, "suncolor" },
    { 0x041A, "sundirection" },
    { 0x041B, "sunlight" },
    { 0x041C, "support" },
    { 0x041D, "support_level" },
    { 0x041E, "suppression" },
    { 0x041F, "suppression_end" },
    { 0x0420, "suppressionduration" },
    { 0x0421, "suppressionmeter" },
    { 0x0422, "suppressionstarttime" },
    { 0x0423, "suppressiontime" },
    { 0x0424, "suppressionwait" },
    { 0x0425, "surfacetype" },
    { 0x0426, "surprisedbymedistsq" },
    { 0x0427, "swimmer" },
    { 0x0428, "switched_var_grenade" },
    { 0x0429, "syncedmeleetarget" },
    { 0x042A, "tactical" },
    { 0x042B, "tag" },
    { 0x042C, "tag_ai_aim_target" },
    { 0x042D, "tag_aim" },
    { 0x042E, "tag_aim_animated" },
    { 0x042F, "tag_aim_pivot" },
    { 0x0430, "tag_barrel" },
    { 0x0431, "tag_blade_off" },
    { 0x0432, "tag_body" },
    { 0x0433, "tag_brass" },
    { 0x0434, "tag_brass_2" },
    { 0x0435, "tag_butt" },
    { 0x0436, "tag_camera" },
    { 0x0437, "tag_clip" },
    { 0x0438, "tag_clip_dual" },
    { 0x0439, "tag_clip_dual2" },
    { 0x043A, "tag_detach" },
    { 0x043B, "tag_engine_left" },
    { 0x043C, "tag_engine_right" },
    { 0x043D, "tag_eotech_reticle" },
    { 0x043E, "tag_eye" },
    { 0x043F, "tag_flash" },
    { 0x0440, "tag_flash_11" },
    { 0x0441, "tag_flash_2" },
    { 0x0442, "tag_flash_22" },
    { 0x0443, "tag_flash_3" },
    { 0x0444, "tag_flash_launcher" },
    { 0x0445, "tag_flash_silenced" },
    { 0x0446, "tag_fx" },
    { 0x0447, "tag_gasmask" },
    { 0x0448, "tag_gasmask2" },
    { 0x0449, "tag_ik_ankle_fl" },
    { 0x044A, "tag_ik_ankle_fr" },
    { 0x044B, "tag_ik_ankle_kl" },
    { 0x044C, "tag_ik_ankle_kr" },
    { 0x044D, "tag_ik_ankle_ml" },
    { 0x044E, "tag_ik_ankle_mr" },
    { 0x044F, "tag_ik_footflat_fl" },
    { 0x0450, "tag_ik_footflat_fr" },
    { 0x0451, "tag_ik_footflat_kl" },
    { 0x0452, "tag_ik_footflat_kr" },
    { 0x0453, "tag_ik_footflat_ml" },
    { 0x0454, "tag_ik_footflat_mr" },
    { 0x0455, "tag_ik_hip_fl" },
    { 0x0456, "tag_ik_hip_fr" },
    { 0x0457, "tag_ik_hip_kl" },
    { 0x0458, "tag_ik_hip_kr" },
    { 0x0459, "tag_ik_hip_ml" },
    { 0x045A, "tag_ik_hip_mr" },
    { 0x045B, "tag_ik_knee_fl" },
    { 0x045C, "tag_ik_knee_fr" },
    { 0x045D, "tag_ik_knee_kl" },
    { 0x045E, "tag_ik_knee_kr" },
    { 0x045F, "tag_ik_knee_ml" },
    { 0x0460, "tag_ik_knee_mr" },
    { 0x0461, "tag_ik_loc_le" },
    { 0x0462, "tag_ik_loc_le_foregrip" },
    { 0x0463, "tag_ik_loc_le_launcher" },
    { 0x0464, "tag_ik_loc_le_shotgun" },
    { 0x0465, "tag_ik_target" },
    { 0x0466, "tag_inhand" },
    { 0x0467, "tag_jetblast_fx" },
    { 0x0468, "tag_jetpack" },
    { 0x0469, "tag_knife_attach" },
    { 0x046A, "tag_knife_fx" },
    { 0x046B, "tag_laser" },
    { 0x046C, "tag_launcher" },
    { 0x046D, "tag_magnifier_eotech_reticle" },
    { 0x046E, "tag_mobile_cover_upright" },
    { 0x046F, "tag_motion_tracker_bl" },
    { 0x0470, "tag_motion_tracker_br" },
    { 0x0471, "tag_motion_tracker_fx" },
    { 0x0472, "tag_motion_tracker_tl" },
    { 0x0473, "tag_origin" },
    { 0x0474, "tag_player" },
    { 0x0475, "tag_popout" },
    { 0x0476, "tag_rail_master_off" },
    { 0x0477, "tag_rail_master_on" },
    { 0x0478, "tag_rail_side_off" },
    { 0x0479, "tag_rail_side_on" },
    { 0x047A, "tag_reticle_acog" },
    { 0x047B, "tag_reticle_default" },
    { 0x047C, "tag_reticle_default2" },
    { 0x047D, "tag_reticle_hamr" },
    { 0x047E, "tag_reticle_on" },
    { 0x047F, "tag_reticle_red_dot" },
    { 0x0480, "tag_reticle_reflex" },
    { 0x0481, "tag_reticle_tavor_scope" },
    { 0x0482, "tag_reticle_thermal_scope" },
    { 0x0483, "tag_rider" },
    { 0x0484, "tag_riot_shield" },
    { 0x0485, "tag_rocket" },
    { 0x0486, "tag_scope_ads_off" },
    { 0x0487, "tag_scope_ads_on" },
    { 0x0488, "tag_shield_back" },
    { 0x0489, "tag_shotgun" },
    { 0x048A, "tag_show_alt" },
    { 0x048B, "tag_sight_off" },
    { 0x048C, "tag_sight_on" },
    { 0x048D, "tag_stow_back_mid_attach" },
    { 0x048E, "tag_stowed_back" },
    { 0x048F, "tag_stowed_hip_rear" },
    { 0x0490, "tag_sync" },
    { 0x0491, "tag_tip" },
    { 0x0492, "tag_turret" },
    { 0x0493, "tag_turret_base" },
    { 0x0494, "tag_turret_pitch" },
    { 0x0495, "tag_turret_yaw" },
    { 0x0496, "tag_weapon" },
    { 0x0497, "tag_weapon_chest" },
    { 0x0498, "tag_weapon_left" },
    { 0x0499, "tag_weapon_right" },
    { 0x049A, "tag_wheel_back_left" },
    { 0x049B, "tag_wheel_back_right" },
    { 0x049C, "tag_wheel_front_left" },
    { 0x049D, "tag_wheel_front_right" },
    { 0x049E, "tag_wheel_middle_left" },
    { 0x049F, "tag_wheel_middle_right" },
    { 0x04A0, "tag_wheel_spin_left01" },
    { 0x04A1, "tag_wheel_spin_left02" },
    { 0x04A2, "tag_wheel_spin_left03" },
    { 0x04A3, "tag_wheel_spin_right01" },
    { 0x04A4, "tag_wheel_spin_right02" },
    { 0x04A5, "tag_wheel_spin_right03" },
    { 0x04A6, "takedamage" },
    { 0x04A7, "target" },
    { 0x04A8, "target_script_trigger" },
    { 0x04A9, "targetname" },
    { 0x04AA, "team" },
    { 0x04AB, "team3" },
    { 0x04AC, "teambalanced" },
    { 0x04AD, "teammode_axisallies" },
    { 0x04AE, "teammode_ffa" },
    { 0x04AF, "teammovewaittime" },
    { 0x04B0, "their_score" },
    { 0x04B1, "thermal" },
    { 0x04B2, "thermalbodymaterial" },
    { 0x04B3, "third_person" },
    { 0x04B4, "threatbias" },
    { 0x04B5, "threatbiasgroup" },
    { 0x04B6, "threatsightdelayenabled" },
    { 0x04B7, "threatsightdelayfalloff" },
    { 0x04B8, "threshold" },
    { 0x04B9, "throwingknife" },
    { 0x04BA, "time" },
    { 0x04BB, "timeplayedtotal" },
    { 0x04BC, "titlenew" },
    { 0x04BD, "titleunlocked" },
    { 0x04BE, "top" },
    { 0x04BF, "toparc" },
    { 0x04C0, "totalxp" },
    { 0x04C1, "touch" },
    { 0x04C2, "touching_platform" },
    { 0x04C3, "traverse_complete" },
    { 0x04C4, "traverse_soon" },
    { 0x04C5, "traversecost" },
    { 0x04C6, "traversesoonnotifydist" },
    { 0x04C7, "trend" },
    { 0x04C8, "trigger" },
    { 0x04C9, "trigger_damage" },
    { 0x04CA, "trigger_use" },
    { 0x04CB, "trigger_use_touch" },
    { 0x04CC, "truck_cam" },
//  { 0x04CD, "" },
    { 0x04CE, "turnrate" },
    { 0x04CF, "turret_deactivate" },
    { 0x04D0, "turret_fire" },
    { 0x04D1, "turret_no_vis" },
    { 0x04D2, "turret_not_on_target" },
    { 0x04D3, "turret_on_target" },
    { 0x04D4, "turret_on_vistarget" },
    { 0x04D5, "turret_pitch_clamped" },
    { 0x04D6, "turret_rotate_stopped" },
    { 0x04D7, "turret_yaw_clamped" },
    { 0x04D8, "turretinvulnerability" },
//  { 0x04D9, "" },
    { 0x04DA, "turretownerchange" },
    { 0x04DB, "turretstatechange" },
    { 0x04DC, "type" },
    { 0x04DD, "ucdidhigh" },
    { 0x04DE, "ucdidlow" },
    { 0x04DF, "unlockedcamo" },
    { 0x04E0, "unlockedreticles" },
    { 0x04E1, "unlockpoints" },
    { 0x04E2, "unresolved_collision" },
    { 0x04E3, "up" },
    { 0x04E4, "upaimlimit" },
    { 0x04E5, "upgradechallengeprogress" },
    { 0x04E6, "upgradechallengestage" },
    { 0x04E7, "upgradepoints" },
    { 0x04E8, "upgradepurchased" },
    { 0x04E9, "useable" },
    { 0x04EA, "usechokepoints" },
    { 0x04EB, "usecombatscriptatcover" },
    { 0x04EC, "usedemblemslots" },
    { 0x04ED, "useorcaavoidance" },
    { 0x04EE, "usepathsmoothingvalues" },
    { 0x04EF, "veh_boatbounce" },
    { 0x04F0, "veh_boost_activated" },
    { 0x04F1, "veh_boost_deactivated" },
    { 0x04F2, "veh_brake" },
    { 0x04F3, "veh_collision" },
    { 0x04F4, "veh_contact" },
    { 0x04F5, "veh_jolt" },
    { 0x04F6, "veh_landed" },
    { 0x04F7, "veh_leftground" },
    { 0x04F8, "veh_pathdir" },
    { 0x04F9, "veh_pathspeed" },
    { 0x04FA, "veh_pathtype" },
    { 0x04FB, "veh_predictedcollision" },
    { 0x04FC, "veh_speed" },
    { 0x04FD, "veh_throttle" },
    { 0x04FE, "veh_topspeed" },
    { 0x04FF, "veh_transmission" },
    { 0x0500, "vehicle_dismount" },
    { 0x0501, "vehicle_mount" },
    { 0x0502, "vehicletype" },
    { 0x0503, "velocity" },
    { 0x0504, "vertalign" },
    { 0x0505, "visionsetmissilecam" },
    { 0x0506, "visionsetmissilecamduration" },
    { 0x0507, "visionsetnaked" },
    { 0x0508, "visionsetnakedduration" },
    { 0x0509, "visionsetnight" },
    { 0x050A, "visionsetnightduration" },
    { 0x050B, "visionsetpain" },
    { 0x050C, "visionsetpainduration" },
    { 0x050D, "visionsetthermal" },
    { 0x050E, "visionsetthermalduration" },
    { 0x050F, "vote" },
    { 0x0510, "wait" },
    { 0x0511, "walk" },
    { 0x0512, "walkdist" },
    { 0x0513, "walkdistfacingmotion" },
    { 0x0514, "wastacticalinsertion" },
    { 0x0515, "waypoint_reached" },
    { 0x0516, "weapon" },
    { 0x0517, "weapon_change" },
    { 0x0518, "weapon_dropped" },
    { 0x0519, "weapon_fired" },
    { 0x051A, "weapon_model_change" },
    { 0x051B, "weapon_switch_invalid" },
    { 0x051C, "weapon_switch_started" },
    { 0x051D, "weapon_taken" },
    { 0x051E, "weaponchange" },
    { 0x051F, "weaponclassrestricted" },
    { 0x0520, "weaponinfo" },
    { 0x0521, "weaponrank" },
    { 0x0522, "weaponrestricted" },
    { 0x0523, "weaponsetups" },
    { 0x0524, "weaponstats" },
    { 0x0525, "weeklychallengeid" },
    { 0x0526, "weight" },
    { 0x0527, "width" },
    { 0x0528, "wildcard1" },
    { 0x0529, "wildcard2" },
    { 0x052A, "wildcard3" },
    { 0x052B, "wildcardslots" },
    { 0x052C, "win_streak" },
    { 0x052D, "winlossratio" },
    { 0x052E, "wins" },
    { 0x052F, "won_match" },
    { 0x0530, "world" },
    { 0x0531, "worldmodel" },
    { 0x0532, "worldspawn" },
    { 0x0533, "x" },
    { 0x0534, "xb3" },
    { 0x0535, "xenon" },
    { 0x0536, "xp" },
    { 0x0537, "xp_multiplier" },
    { 0x0538, "xpmaxmultipliertimeplayed" },
    { 0x0539, "xpmultiplier" },
    { 0x053A, "xuid" },
    { 0x053B, "y" },
    { 0x053C, "yawconvergencetime" },
    { 0x053D, "your_score" },
    { 0x053E, "z" },
    { 0x053F, "zonly_physics" },
    { 0x0540, "codescripts/delete" },
    { 0x0541, "codescripts/struct" },
    { 0x0542, "codescripts/message" },
    { 0x0543, "maps/mp/gametypes/_callbacksetup" },
    { 0x0544, "__smangles" },
    { 0x0545, "__smid" },
    { 0x0546, "__smname" },
    { 0x0547, "__smorigin" },
    { 0x0548, "_abortdefendlocation" },
    { 0x0549, "_adddropmarkerinternal" },
    { 0x054A, "_adjustcamerayawpitchrate" },
    { 0x054B, "_advancetogoal" },
    { 0x054C, "_ai_delete" },
    { 0x054D, "_ai_group" },
    { 0x054E, "_ai_health" },
    { 0x054F, "_aliveplayers" },
    { 0x0550, "_allowalternatemelee" },
    { 0x0551, "_allowweaponpickup" },
    { 0x0552, "_ams" },
    { 0x0553, "_animactive" },
    { 0x0554, "_anime" },
    { 0x0555, "_animmode" },
    { 0x0556, "_animname" },
    { 0x0557, "_anims" },
    { 0x0558, "_anims_drone" },
    { 0x0559, "_anims_player" },
    { 0x055A, "_anims_proxy" },
    { 0x055B, "_array_wait" },
    { 0x055C, "_assignnewvehicleturretuser" },
    { 0x055D, "_attachfanclip" },
    { 0x055E, "_audio" },
    { 0x055F, "_autosave_game_now" },
    { 0x0560, "_autosave_game_now_nochecks" },
    { 0x0561, "_autosave_game_now_notrestart" },
    { 0x0562, "_autosave_stealthcheck" },
    { 0x0563, "_beginlocationselection" },
    { 0x0564, "_bootup_static" },
    { 0x0565, "_cangiveability" },
    { 0x0566, "_caralarmfx" },
    { 0x0567, "_caralarmstop" },
    { 0x0568, "_cleanupshootinglocationondeath" },
    { 0x0569, "_clearabilities" },
    { 0x056A, "_clearalltextafterhudelem" },
    { 0x056B, "_clearcharacterdialogondeath" },
    { 0x056C, "_clearcharacterdialogonnotify" },
    { 0x056D, "_clearentitytarget" },
    { 0x056E, "_clearperks" },
    { 0x056F, "_clearradiodialogondeath" },
    { 0x0570, "_clearworlddialogonnotify" },
    { 0x0571, "_cloak_enemy_array" },
    { 0x0572, "_cloak_enemy_state" },
    { 0x0573, "_cloak_toggle_internal" },
    { 0x0574, "_cloaked_stealth_settings" },
    { 0x0575, "_closingdistancecheck" },
    { 0x0576, "_color" },
    { 0x0577, "_colors_go_line" },
    { 0x0578, "_createfx" },
    { 0x0579, "_createhudline" },
    { 0x057A, "_custom_anim" },
    { 0x057B, "_custom_anim_loop" },
    { 0x057C, "_custom_anim_thread" },
    { 0x057D, "_debug_vector_to_string" },
    { 0x057E, "_defendlocation" },
    { 0x057F, "_delaygrenadethrow" },
    { 0x0580, "_delete" },
    { 0x0581, "_destroyprojectileafterdelay" },
    { 0x0582, "_destructible_preanims" },
    { 0x0583, "_destructible_preanimtree" },
    { 0x0584, "_detachall" },
    { 0x0585, "_determineallynodescore" },
    { 0x0586, "_determineshotgunnodescore" },
    { 0x0587, "_dialogtablelookup" },
    { 0x0588, "_disableoffhandweapons" },
    { 0x0589, "_disableusability" },
    { 0x058A, "_disableweapon" },
    { 0x058B, "_disableweaponswitch" },
    { 0x058C, "_displayhelpertext" },
    { 0x058D, "_displayrechargehelpertext" },
    { 0x058E, "_dmg" },
    { 0x058F, "_do_a_lil_damage_and_heal" },
    { 0x0590, "_drawdebug" },
    { 0x0591, "_earthquake" },
    { 0x0592, "_effect" },
    { 0x0593, "_effect_keys" },
    { 0x0594, "_enabledetonate" },
    { 0x0595, "_enableexplosivedeath" },
    { 0x0596, "_enableoffhandweapons" },
    { 0x0597, "_enableusability" },
    { 0x0598, "_enableweapon" },
    { 0x0599, "_enableweaponswitch" },
    { 0x059A, "_ensure_player_is_decloaked" },
    { 0x059B, "_evaluatebuddycovernodes" },
    { 0x059C, "_evaluatenodeattackradius" },
    { 0x059D, "_evaluatenodeinplayerfov" },
    { 0x059E, "_evaluatenodeiscover" },
    { 0x059F, "_evaluatenodeisexposed" },
    { 0x05A0, "_evaluatenodeknownenemyinradius" },
    { 0x05A1, "_evaluatenodelostoplayer" },
    { 0x05A2, "_evaluatenodeothershotgunnersbest" },
    { 0x05A3, "_evaluatenodeplayerinradius" },
    { 0x05A4, "_evaluatenodeplayervisibility" },
    { 0x05A5, "_evaluatenoderangetoplayer" },
    { 0x05A6, "_evaluateshotgunnercovernodes" },
    { 0x05A7, "_exit" },
    { 0x05A8, "_exit_menu" },
    { 0x05A9, "_extended_patrol_idle_animation_list_func" },
    { 0x05AA, "_extra_autosave_checks" },
    { 0x05AB, "_facility" },
    { 0x05AC, "_fastopen" },
    { 0x05AD, "_findfleelocation" },
    { 0x05AE, "_findnewvehicleturretuser" },
    { 0x05AF, "_fire" },
    { 0x05B0, "_first_frame_anim" },
    { 0x05B1, "_flag_wait_trigger" },
    { 0x05B2, "_force_kill" },
    { 0x05B3, "_freevehicle" },
    { 0x05B4, "_frozen_controls" },
    { 0x05B5, "_fx" },
    { 0x05B6, "_get_dummy" },
    { 0x05B7, "_get_if_defined_or_default" },
    { 0x05B8, "_getindex" },
    { 0x05B9, "_getmodulekillstreakweapon" },
    { 0x05BA, "_getpaintoutline" },
    { 0x05BB, "_getplayerscore" },
    { 0x05BC, "_getradarstrength" },
    { 0x05BD, "_getrandomorginfrontofplayer" },
    { 0x05BE, "_getscrambletypeidforstring" },
    { 0x05BF, "_getteampaintoutline" },
    { 0x05C0, "_getteamscore" },
    { 0x05C1, "_getvehiclespawnerarray" },
    { 0x05C2, "_getvehiclespawnerarray_by_spawngroup" },
    { 0x05C3, "_giveweapon" },
    { 0x05C4, "_glass_physics_wakeup" },
    { 0x05C5, "_glass_physics_wakeup_update" },
    { 0x05C6, "_global_fx_ents" },
    { 0x05C7, "_goalblockedbyai" },
    { 0x05C8, "_goalblockedbyplayer" },
    { 0x05C9, "_gopath" },
    { 0x05CA, "_group" },
    { 0x05CB, "_handle_triggers_on" },
    { 0x05CC, "_handlebreachgrenade" },
    { 0x05CD, "_hasability" },
    { 0x05CE, "_hasperk" },
    { 0x05CF, "_hint_stick_get_config_suffix" },
    { 0x05D0, "_hint_stick_update_breakfunc" },
    { 0x05D1, "_hint_stick_update_string" },
    { 0x05D2, "_ignore_settings_old" },
    { 0x05D3, "_initalliedaialleycombatbehavior" },
    { 0x05D4, "_initsafehouseexitkvabehavior" },
    { 0x05D5, "_insertintoglobalusablelist" },
    { 0x05D6, "_interactive" },
    { 0x05D7, "_investigate_last_known_position_with_endons" },
    { 0x05D8, "_investigate_last_known_position_wrapper" },
    { 0x05D9, "_is_godmode" },
    { 0x05DA, "_isairplane" },
    { 0x05DB, "_ishelicopter" },
    { 0x05DC, "_kill" },
    { 0x05DD, "_kill_fx" },
    { 0x05DE, "_lastanimtime" },
    { 0x05DF, "_lastwave" },
    { 0x05E0, "_lc" },
    { 0x05E1, "_lc_persists" },
    { 0x05E2, "_leaderdialogwait" },
    { 0x05E3, "_light" },
    { 0x05E4, "_linkto" },
    { 0x05E5, "_listen_drone_input" },
    { 0x05E6, "_listen_for_hold_to_exit" },
    { 0x05E7, "_listen_for_hold_to_exit_set_flags" },
    { 0x05E8, "_loadstarted" },
    { 0x05E9, "_make_overlay" },
    { 0x05EA, "_manage_timer" },
    { 0x05EB, "_mark_newlyspawned" },
    { 0x05EC, "_max_script_health" },
    { 0x05ED, "_mb" },
    { 0x05EE, "_mech_globals" },
    { 0x05EF, "_mech_hunt_baghdad" },
    { 0x05F0, "_mech_node" },
    { 0x05F1, "_mech_occupied" },
    { 0x05F2, "_mgoff" },
    { 0x05F3, "_mgon" },
    { 0x05F4, "_missile_strike_setting" },
    { 0x05F5, "_missilemissedtargetcheck" },
    { 0x05F6, "_missing_fx" },
    { 0x05F7, "_monitor_controls" },
    { 0x05F8, "_monitor_damage" },
    { 0x05F9, "_monitor_health" },
    { 0x05FA, "_monitor_regen" },
    { 0x05FB, "_monitor_static" },
    { 0x05FC, "_monitor_threat_count" },
    { 0x05FD, "_monitor_touch" },
    { 0x05FE, "_monitor_volume_array" },
    { 0x05FF, "_mount_snowmobile" },
    { 0x0600, "_newhudelem" },
    { 0x0601, "_nextcoverprint" },
    { 0x0602, "_nextmission" },
    { 0x0603, "_normalbehavior" },
    { 0x0604, "_notetrackfx" },
    { 0x0605, "_obituary" },
    { 0x0606, "_objective_delete" },
    { 0x0607, "_offset_position_from_tag" },
    { 0x0608, "_old_visionset" },
    { 0x0609, "_orbital_care_pod" },
    { 0x060A, "_orbital_strike_setting" },
    { 0x060B, "_patrol_endon_spotted_flag" },
    { 0x060C, "_pdrone_player_exit_return_control" },
    { 0x060D, "_pdrone_player_proxy" },
    { 0x060E, "_pdrone_player_proxy_clear" },
    { 0x060F, "_pdrone_player_proxy_delicate_flower" },
    { 0x0610, "_pdrone_stop_use_anim" },
    { 0x0611, "_pipe_fx_time" },
    { 0x0612, "_pipe_methods" },
    { 0x0613, "_pipes" },
    { 0x0614, "_play_view_model_cloak_toggle_anim" },
    { 0x0615, "_playerallow" },
    { 0x0616, "_playercleanupscrambleevents" },
    { 0x0617, "_playergetnextevent" },
    { 0x0618, "_playergetscrambleevent" },
    { 0x0619, "_playergetuniquescrambleid" },
    { 0x061A, "_playermonitorscrambleevents" },
    { 0x061B, "_playlocalsound" },
    { 0x061C, "_popopen" },
    { 0x061D, "_precache" },
    { 0x061E, "_pursueenemy" },
    { 0x061F, "_radio_queue" },
    { 0x0620, "_radiusdamage" },
    { 0x0621, "_randommissilemovement" },
    { 0x0622, "_reactionanimation" },
    { 0x0623, "_reduce_hud_target_count_on_death" },
    { 0x0624, "_remove_drone_control" },
    { 0x0625, "_remove_hud" },
    { 0x0626, "_remove_hud_on_death" },
    { 0x0627, "_remove_hudoutline_on_enemies" },
    { 0x0628, "_remove_overlay_static" },
    { 0x0629, "_remove_shield" },
    { 0x062A, "_reset_dvars" },
    { 0x062B, "_restorepreviousnameplatematerial" },
    { 0x062C, "_returnanimorigin" },
    { 0x062D, "_rotateprop" },
    { 0x062E, "_rotateyaw" },
    { 0x062F, "_s2walk" },
    { 0x0630, "_save_dvars" },
    { 0x0631, "_script_exploders" },
    { 0x0632, "_scripted_spawn" },
    { 0x0633, "_set_dvars" },
    { 0x0634, "_set_hudoutline_on_enemies" },
    { 0x0635, "_set_overlay_static_alpha" },
    { 0x0636, "_setability" },
    { 0x0637, "_setactionslot" },
    { 0x0638, "_setentitytarget" },
    { 0x0639, "_sethighestmissionifnotcheating" },
    { 0x063A, "_sethudoutline" },
    { 0x063B, "_sethudoutline_on_spawn" },
    { 0x063C, "_setlightintensity" },
    { 0x063D, "_setmissiondiffstringifnotcheating" },
    { 0x063E, "_setnameplatematerial" },
    { 0x063F, "_setperk" },
    { 0x0640, "_setplayerscore" },
    { 0x0641, "_setsaveddvar" },
    { 0x0642, "_setswitchnode" },
    { 0x0643, "_setteamscore" },
    { 0x0644, "_settext" },
    { 0x0645, "_setup_hud" },
    { 0x0646, "_setup_overlay_static" },
    { 0x0647, "_setupdooranimstyle" },
    { 0x0648, "_setvehgoalpos" },
    { 0x0649, "_setvehgoalpos_wrap" },
    { 0x064A, "_shotgunneradvance" },
    { 0x064B, "_shotgunnerambience" },
    { 0x064C, "_shotgunnerdamagefunction" },
    { 0x064D, "_shotgunnerdeath" },
    { 0x064E, "_show_contols" },
    { 0x064F, "_slomo_breach_blowback_guy" },
    { 0x0650, "_slomo_breach_c4_hostage" },
    { 0x0651, "_slomo_breach_chair_guy_animated" },
    { 0x0652, "_slomo_breach_chair_guy_normal" },
    { 0x0653, "_slomo_breach_desk_guy" },
    { 0x0654, "_slomo_breach_executed_guy" },
    { 0x0655, "_slomo_breach_executed_guy_pushed_to_floor" },
    { 0x0656, "_slomo_breach_executioner_knife" },
    { 0x0657, "_slomo_breach_executioner_pistol" },
    { 0x0658, "_slomo_breach_fightback_guy" },
    { 0x0659, "_slomo_breach_hostage_react" },
    { 0x065A, "_slomo_breach_knife_charger" },
    { 0x065B, "_slomo_breach_knife_hostage_death" },
    { 0x065C, "_slomo_breach_pistol_guy" },
    { 0x065D, "_slowmo_breach_funcs" },
    { 0x065E, "_slowmo_functions" },
    { 0x065F, "_slowopen" },
    { 0x0660, "_snd" },
    { 0x0661, "_snd_update_soundcontextoverride" },
    { 0x0662, "_sonicaoeanim" },
    { 0x0663, "_sonicaoenotready" },
    { 0x0664, "_sortbyscore" },
    { 0x0665, "_sound" },
    { 0x0666, "_spawner_mg42_think" },
    { 0x0667, "_spawner_stealth_default" },
    { 0x0668, "_spawntargetnamegotogoal" },
    { 0x0669, "_squaddoorbreach" },
    { 0x066A, "_startdooropen" },
    { 0x066B, "_state_init" },
    { 0x066C, "_stealth" },
    { 0x066D, "_stealth_move_detection_cap" },
    { 0x066E, "_stop_mech_hunt_baghdad" },
    { 0x066F, "_stunassaultdrones" },
    { 0x0670, "_stuncivilians" },
    { 0x0671, "_stunenemies" },
    { 0x0672, "_suicide" },
    { 0x0673, "_tag_entity" },
    { 0x0674, "_takeweaponsexcept" },
    { 0x0675, "_teleportleashbehavior" },
    { 0x0676, "_tff_sync_trigger_think" },
    { 0x0677, "_tff_sync_triggers" },
    { 0x0678, "_threatdetection" },
    { 0x0679, "_timeout" },
    { 0x067A, "_timeout_pause_on_death_and_prematch" },
    { 0x067B, "_trigger_handle_triggering" },
    { 0x067C, "_unlink" },
    { 0x067D, "_unsetability" },
    { 0x067E, "_unsetperk" },
    { 0x067F, "_updatebuddycovernodes" },
    { 0x0680, "_updateenemygroupdirection" },
    { 0x0681, "_updateenemyusable" },
    { 0x0682, "_updatepainamount" },
    { 0x0683, "_updateshotgunnercovernodes" },
    { 0x0684, "_updateteamusable" },
    { 0x0685, "_useperkenabled" },
    { 0x0686, "_validateattacker" },
    { 0x0687, "_vehicle_badplace" },
    { 0x0688, "_vehicle_effect" },
    { 0x0689, "_vehicle_effect_custom_param" },
    { 0x068A, "_vehicle_is_crashing" },
    { 0x068B, "_vehicle_landvehicle" },
    { 0x068C, "_vehicle_paths" },
    { 0x068D, "_vehicle_resume_named" },
    { 0x068E, "_vehicle_spawn" },
    { 0x068F, "_vehicle_stop_named" },
    { 0x0690, "_vehicle_unload" },
    { 0x0691, "_vehicleturretreenable" },
    { 0x0692, "_vmodel_anims" },
    { 0x0693, "_vmodel_enter" },
    { 0x0694, "_vmodel_exit" },
    { 0x0695, "_vmodel_sway" },
    { 0x0696, "_vol" },
    { 0x0697, "_wait" },
    { 0x0698, "_waittillgoalornewgoal" },
    { 0x0699, "_waittillmatch" },
    { 0x069A, "_waittillmatch_notify" },
    { 0x069B, "_walk" },
    { 0x069C, "_wavedelay" },
    { 0x069D, "_waveplayerspawnindex" },
    { 0x069E, "a10_30mm_fire" },
    { 0x069F, "a10_fire_missiles" },
    { 0x06A0, "a10_gun_dives" },
    { 0x06A1, "a10_missile_dives" },
    { 0x06A2, "a10_missile_set_target" },
    { 0x06A3, "a10_precache" },
    { 0x06A4, "a10_spawn_funcs" },
    { 0x06A5, "a10_wait_fire_missile" },
    { 0x06A6, "a10_wait_start_firing" },
    { 0x06A7, "a10_wait_stop_firing" },
    { 0x06A8, "aa_add_event" },
    { 0x06A9, "aa_add_event_float" },
    { 0x06AA, "aa_ai_functions" },
    { 0x06AB, "aa_door_functions" },
    { 0x06AC, "aa_explosion" },
    { 0x06AD, "aa_init_stats" },
    { 0x06AE, "aa_player_ads_tracking" },
    { 0x06AF, "aa_player_attacks_enemy_with_ads" },
    { 0x06B0, "aa_player_health_tracking" },
    { 0x06B1, "aa_print_vals" },
    { 0x06B2, "aa_should_start_fresh" },
    { 0x06B3, "aa_spawning_functions" },
    { 0x06B4, "aa_time_tracking" },
    { 0x06B5, "aa_update_flags" },
    { 0x06B6, "abandon_mission_warning_hint" },
    { 0x06B7, "abanglecutoff" },
    { 0x06B8, "abilities" },
    { 0x06B9, "abilitycansetfuncs" },
    { 0x06BA, "abilitychosen" },
    { 0x06BB, "abilitysetfuncs" },
    { 0x06BC, "abilityunsetfuncs" },
    { 0x06BD, "abort" },
    { 0x06BE, "abort_count" },
    { 0x06BF, "abort_drones" },
    { 0x06C0, "abort_wait_any_func_array" },
    { 0x06C1, "abortapproachifthreatened" },
    { 0x06C2, "abortlevel" },
    { 0x06C3, "abortreloadwhencanshoot" },
    { 0x06C4, "about_to_stop" },
    { 0x06C5, "about_to_unload" },
    { 0x06C6, "abouttobebreached" },
    { 0x06C7, "absangleclamp180" },
    { 0x06C8, "absyawtoangles" },
    { 0x06C9, "absyawtoenemy" },
    { 0x06CA, "absyawtoenemy2d" },
    { 0x06CB, "absyawtoorigin" },
    { 0x06CC, "absz" },
    { 0x06CD, "abyss_player_kill" },
    { 0x06CE, "ac_duct" },
    { 0x06CF, "ac_duct_01" },
    { 0x06D0, "ac_duct_02" },
    { 0x06D1, "ac130" },
    { 0x06D2, "ac130_flood_respawn" },
    { 0x06D3, "ac130gunner" },
    { 0x06D4, "ac130player" },
    { 0x06D5, "accaracy_mod" },
    { 0x06D6, "accel" },
    { 0x06D7, "accel_watcher" },
    { 0x06D8, "accelerating" },
    { 0x06D9, "acceltime" },
    { 0x06DA, "accessallmarkers" },
    { 0x06DB, "accumulated_restore" },
    { 0x06DC, "accumulateplayerpingdata" },
    { 0x06DD, "accuracy_fake_function" },
    { 0x06DE, "accuracygrowthmultiplier" },
    { 0x06DF, "accuracystationarymod" },
    { 0x06E0, "achieve_downed_kills" },
    { 0x06E1, "achieve_slowmo_breach_kills" },
    { 0x06E2, "achievement" },
    { 0x06E3, "achievement_attacker" },
    { 0x06E4, "achievementsniperdronetriplekill" },
    { 0x06E5, "acquire_target" },
    { 0x06E6, "acquired_animation" },
    { 0x06E7, "acquiring_dogfight_target" },
    { 0x06E8, "acquiring_lock_target" },
    { 0x06E9, "action_back" },
    { 0x06EA, "action_func" },
    { 0x06EB, "action_gears" },
    { 0x06EC, "action_killstreak" },
    { 0x06ED, "action_leaderboards" },
    { 0x06EE, "action_slot_num" },
    { 0x06EF, "action_slot_whistle" },
    { 0x06F0, "action_thread" },
    { 0x06F1, "action_weapons_primary" },
    { 0x06F2, "action_weapons_secondary" },
    { 0x06F3, "actionnotify" },
    { 0x06F4, "actionnotifymessage" },
    { 0x06F5, "actionslotenabled" },
    { 0x06F6, "actionslots" },
    { 0x06F7, "activate_betrayal_exo_abilities" },
    { 0x06F8, "activate_clientside_exploder" },
    { 0x06F9, "activate_color_code_internal" },
    { 0x06FA, "activate_destructibles_in_volume" },
    { 0x06FB, "activate_exo_ping" },
    { 0x06FC, "activate_exploder" },
    { 0x06FD, "activate_exploders_in_volume" },
    { 0x06FE, "activate_guy" },
    { 0x06FF, "activate_heater" },
    { 0x0700, "activate_individual_exploder" },
    { 0x0701, "activate_individual_exploder_proc" },
    { 0x0702, "activate_interactives_in_volume" },
    { 0x0703, "activate_mute_volume" },
    { 0x0704, "activate_security_drone" },
    { 0x0705, "activate_splashes" },
    { 0x0706, "activate_takedown_world_prompt_on_enemy" },
    { 0x0707, "activate_takedown_world_prompt_on_truck_enemy" },
    { 0x0708, "activate_targets" },
    { 0x0709, "activate_trigger" },
    { 0x070A, "activate_trigger_process" },
    { 0x070B, "activate_trigger_when_player_jumps" },
    { 0x070C, "activate_trigger_with_noteworthy" },
    { 0x070D, "activate_trigger_with_targetname" },
    { 0x070E, "activateagent" },
    { 0x070F, "activategroupedtridrones" },
    { 0x0710, "activateplayerhud" },
    { 0x0711, "activateratio" },
    { 0x0712, "activatethermal" },
    { 0x0713, "activation_cost" },
    { 0x0714, "active_boats" },
    { 0x0715, "active_button" },
    { 0x0716, "active_civilians" },
    { 0x0717, "active_cloaking_disable" },
    { 0x0718, "active_cloaking_enable" },
    { 0x0719, "active_drones" },
    { 0x071A, "active_events" },
    { 0x071B, "active_events_axis" },
    { 0x071C, "active_ffa_players" },
    { 0x071D, "active_objective" },
    { 0x071E, "active_vo_lockouts" },
    { 0x071F, "active_wait_spread" },
    { 0x0720, "activecounteruavs" },
    { 0x0721, "activefriendlyspawn" },
    { 0x0722, "activegrenadetimer" },
    { 0x0723, "activehordedefendlocs" },
    { 0x0724, "activenodes" },
    { 0x0725, "activeplayers" },
    { 0x0726, "activestyle" },
    { 0x0727, "activetarget" },
    { 0x0728, "activeuavs" },
    { 0x0729, "activeweapon" },
    { 0x072A, "actor_alarm_guard" },
    { 0x072B, "actor_anims" },
    { 0x072C, "actor_playscene_walker_stepover_cormack" },
    { 0x072D, "actor_playscene_walker_stepover_jackson" },
    { 0x072E, "actor_playscene_walker_stepover_will" },
    { 0x072F, "actual_spawn" },
    { 0x0730, "ad_offset_position_from_tag" },
    { 0x0731, "add_abort" },
    { 0x0732, "add_agents_to_game" },
    { 0x0733, "add_ai_to_colors" },
    { 0x0734, "add_and_select_entity" },
    { 0x0735, "add_animation" },
    { 0x0736, "add_animsound" },
    { 0x0737, "add_array_to_destructible" },
    { 0x0738, "add_avatar" },
    { 0x0739, "add_basement_enemy_flashlight" },
    { 0x073A, "add_bcs_location_mapping" },
    { 0x073B, "add_breach_func" },
    { 0x073C, "add_burke_flashlight" },
    { 0x073D, "add_button" },
    { 0x073E, "add_c4_glow" },
    { 0x073F, "add_call" },
    { 0x0740, "add_capture_enemy_momentum" },
    { 0x0741, "add_capture_friendly_momentum" },
    { 0x0742, "add_cellphone_notetracks" },
    { 0x0743, "add_cheap_flashlight" },
    { 0x0744, "add_cleanup_ent" },
    { 0x0745, "add_collision_offsets_to_path_ent" },
    { 0x0746, "add_collision_to_path" },
    { 0x0747, "add_collision_to_path_node" },
    { 0x0748, "add_contrail" },
    { 0x0749, "add_control_based_hint_strings" },
    { 0x074A, "add_coop_scene_models" },
    { 0x074B, "add_cover_node" },
    { 0x074C, "add_damage_function" },
    { 0x074D, "add_damage_fx" },
    { 0x074E, "add_damage_owner_recorder" },
    { 0x074F, "add_damagefeedback" },
    { 0x0750, "add_dds_category" },
    { 0x0751, "add_dds_category_axis" },
    { 0x0752, "add_dds_category_group" },
    { 0x0753, "add_dds_category_group_axis" },
    { 0x0754, "add_dds_countryid" },
    { 0x0755, "add_debug_element" },
    { 0x0756, "add_destructible_fx" },
    { 0x0757, "add_destructible_to_frame_queue" },
    { 0x0758, "add_destructible_type_function" },
    { 0x0759, "add_destructible_type_transient" },
    { 0x075A, "add_dialogue_line" },
    { 0x075B, "add_doc_civ_walla" },
    { 0x075C, "add_drone_to_squad" },
    { 0x075D, "add_earthquake" },
    { 0x075E, "add_endon" },
    { 0x075F, "add_enemy_flashlight" },
    { 0x0760, "add_extra_autosave_check" },
    { 0x0761, "add_fractional_data_point" },
    { 0x0762, "add_func" },
    { 0x0763, "add_fx" },
    { 0x0764, "add_global_spawn_function" },
    { 0x0765, "add_greece_starts" },
    { 0x0766, "add_hint_background" },
    { 0x0767, "add_hint_string" },
    { 0x0768, "add_hovertank_turret" },
    { 0x0769, "add_hud_line" },
    { 0x076A, "add_hudelm_position_internal" },
    { 0x076B, "add_humanoid_agent" },
    { 0x076C, "add_idle_control" },
    { 0x076D, "add_jav_glow" },
    { 0x076E, "add_kb_button" },
    { 0x076F, "add_key" },
    { 0x0770, "add_key_to_destructible" },
    { 0x0771, "add_keypairs_to_destructible" },
    { 0x0772, "add_kill_enemy_minion_momentum" },
    { 0x0773, "add_kill_enemy_momentum" },
    { 0x0774, "add_kill_friendly_minion_momentum" },
    { 0x0775, "add_kill_friendly_momentum" },
    { 0x0776, "add_lock_target" },
    { 0x0777, "add_mag_move_notetracks" },
    { 0x0778, "add_momentum" },
    { 0x0779, "add_moving_obstacle" },
    { 0x077A, "add_moving_vol_to_node" },
    { 0x077B, "add_name" },
    { 0x077C, "add_no_game_starts" },
    { 0x077D, "add_node_to_global_arrays" },
    { 0x077E, "add_noself_call" },
    { 0x077F, "add_note_track_data" },
    { 0x0780, "add_notetrack_and_get_index" },
    { 0x0781, "add_notetrack_array" },
    { 0x0782, "add_object_to_tactics_system" },
    { 0x0783, "add_objective" },
    { 0x0784, "add_option_to_selected_entities" },
    { 0x0785, "add_party_member_class_change" },
    { 0x0786, "add_passenger_to_player_pitbull" },
    { 0x0787, "add_path_node" },
    { 0x0788, "add_path_weights" },
    { 0x0789, "add_phrase_to_history" },
    { 0x078A, "add_player_flashlight" },
    { 0x078B, "add_proccess_trigger" },
    { 0x078C, "add_random_killspawner_to_spawngroup" },
    { 0x078D, "add_reactive_fx" },
    { 0x078E, "add_replace_after_load_done" },
    { 0x078F, "add_reverb" },
    { 0x0790, "add_rpg_to_tactics_system" },
    { 0x0791, "add_scene_model" },
    { 0x0792, "add_script_car" },
    { 0x0793, "add_shake_and_rumble_notetracks" },
    { 0x0794, "add_shake_and_rumble_notetracks_for_grab" },
    { 0x0795, "add_shake_and_rumble_notetracks_for_jump" },
    { 0x0796, "add_sit_load_ak_notetracks" },
    { 0x0797, "add_slowmo_breach_custom_function" },
    { 0x0798, "add_slowmo_breacher" },
    { 0x0799, "add_smoking_notetracks" },
    { 0x079A, "add_spawn_behavior" },
    { 0x079B, "add_spawn_function" },
    { 0x079C, "add_spawn_function_to_noteworthy" },
    { 0x079D, "add_spawn_function_to_targetname" },
    { 0x079E, "add_spawner_to_global_arrays" },
    { 0x079F, "add_start" },
    { 0x07A0, "add_start_assert" },
    { 0x07A1, "add_start_construct" },
    { 0x07A2, "add_struct_to_global_array" },
    { 0x07A3, "add_swarm_repulsor_for_ally" },
    { 0x07A4, "add_target_on_dot" },
    { 0x07A5, "add_target_on_los" },
    { 0x07A6, "add_target_pivot" },
    { 0x07A7, "add_to_animsound" },
    { 0x07A8, "add_to_array" },
    { 0x07A9, "add_to_bot_damage_targets" },
    { 0x07AA, "add_to_bot_use_targets" },
    { 0x07AB, "add_to_destroyed_count" },
    { 0x07AC, "add_to_dialogue" },
    { 0x07AD, "add_to_dialogue_generic" },
    { 0x07AE, "add_to_flock" },
    { 0x07AF, "add_to_group_civilian" },
    { 0x07B0, "add_to_group_enemy" },
    { 0x07B1, "add_to_javelin_targeting" },
    { 0x07B2, "add_to_radio" },
    { 0x07B3, "add_to_spawngroup" },
    { 0x07B4, "add_to_threat_bias" },
    { 0x07B5, "add_tokens_to_trigger_flags" },
    { 0x07B6, "add_trace_fx" },
    { 0x07B7, "add_trace_fx_proc" },
    { 0x07B8, "add_trigger_func_thread" },
    { 0x07B9, "add_trigger_function" },
    { 0x07BA, "add_turret_on_dismount" },
    { 0x07BB, "add_vehicle_anim" },
    { 0x07BC, "add_vehicle_player_anim" },
    { 0x07BD, "add_vision_set" },
    { 0x07BE, "add_vision_sets_from_triggers" },
    { 0x07BF, "add_vol_to_node" },
    { 0x07C0, "add_volume_to_global_arrays" },
    { 0x07C1, "add_wait" },
    { 0x07C2, "add_wait_asserter" },
    { 0x07C3, "add_warbird_cargo" },
    { 0x07C4, "add_weapon" },
    { 0x07C5, "add_z" },
    { 0x07C6, "addactioncovermealiasex" },
    { 0x07C7, "addactivecounteruav" },
    { 0x07C8, "addactiveuav" },
    { 0x07C9, "addaieventlistener_func" },
    { 0x07CA, "addairexplosion" },
    { 0x07CB, "addallowedthreatcallout" },
    { 0x07CC, "addalternatespawnpoint" },
    { 0x07CD, "addarmorypoints" },
    { 0x07CE, "addattachments" },
    { 0x07CF, "addattacker" },
    { 0x07D0, "addautomaticattachments" },
    { 0x07D1, "addcalloutresponseevent" },
    { 0x07D2, "addcastname" },
    { 0x07D3, "addcenterdual" },
    { 0x07D4, "addcenterheading" },
    { 0x07D5, "addcenterimage" },
    { 0x07D6, "addcentername" },
    { 0x07D7, "addcenternamedouble" },
    { 0x07D8, "addcentersubtitle" },
    { 0x07D9, "addcentertriple" },
    { 0x07DA, "addcheckfirealias" },
    { 0x07DB, "addchild" },
    { 0x07DC, "addcollisiontopool" },
    { 0x07DD, "addconcatdirectionalias" },
    { 0x07DE, "addconcattargetalias" },
    { 0x07DF, "addcratetype" },
    { 0x07E0, "addcratetypes_standard" },
    { 0x07E1, "adddeathicon" },
    { 0x07E2, "adddropmarker" },
    { 0x07E3, "added_aerial_links" },
    { 0x07E4, "addedtowave" },
    { 0x07E5, "addgap" },
    { 0x07E6, "addgrenadethrowanimoffset" },
    { 0x07E7, "addhinttrigger" },
    { 0x07E8, "addhostileburstalias" },
    { 0x07E9, "addinformalias" },
    { 0x07EA, "addinformevent" },
    { 0x07EB, "addinformreloadingaliasex" },
    { 0x07EC, "additional_delete_cars" },
    { 0x07ED, "additional_geo" },
    { 0x07EE, "additional_tactical_logic_func" },
    { 0x07EF, "additional_unlink_nodes" },
    { 0x07F0, "additionalassets" },
    { 0x07F1, "additionalsighttraceentities" },
    { 0x07F2, "additionalvo" },
    { 0x07F3, "additive_pain" },
    { 0x07F4, "additive_pull_weight" },
    { 0x07F5, "additiverotateroot" },
    { 0x07F6, "additiveturretdriveidle" },
    { 0x07F7, "additiveturretfire" },
    { 0x07F8, "additiveturretidle" },
    { 0x07F9, "additiveturretrotateleft" },
    { 0x07FA, "additiveturretrotateright" },
    { 0x07FB, "additiveusegunroot" },
    { 0x07FC, "addlastperks" },
    { 0x07FD, "addlaunchers" },
    { 0x07FE, "addleftname" },
    { 0x07FF, "addlefttitle" },
    { 0x0800, "addlevel" },
    { 0x0801, "addlightningexploder" },
    { 0x0802, "addlowermessage" },
    { 0x0803, "addmovecombataliasex" },
    { 0x0804, "addmovenoncombataliasex" },
    { 0x0805, "addnamealias" },
    { 0x0806, "addnamealiasex" },
    { 0x0807, "addnodestobechecked" },
    { 0x0808, "addnotetrack_animsound" },
    { 0x0809, "addnotetrack_attach" },
    { 0x080A, "addnotetrack_customfunction" },
    { 0x080B, "addnotetrack_detach" },
    { 0x080C, "addnotetrack_detach_gun" },
    { 0x080D, "addnotetrack_df" },
    { 0x080E, "addnotetrack_dialogue" },
    { 0x080F, "addnotetrack_flag" },
    { 0x0810, "addnotetrack_flag_clear" },
    { 0x0811, "addnotetrack_lui_notify" },
    { 0x0812, "addnotetrack_notify" },
    { 0x0813, "addnotetrack_playersound" },
    { 0x0814, "addnotetrack_set_omnvar" },
    { 0x0815, "addnotetrack_sound" },
    { 0x0816, "addnotetrack_startfxontag" },
    { 0x0817, "addnotetrack_stopfxontag" },
    { 0x0818, "addnotetrack_swapparttoefx" },
    { 0x0819, "addnotetrack_tracepartforefx" },
    { 0x081A, "addofficertosquad" },
    { 0x081B, "addonstart_animsound" },
    { 0x081C, "addoption" },
    { 0x081D, "addorderalias" },
    { 0x081E, "addorderevent" },
    { 0x081F, "addplanetolist" },
    { 0x0820, "addplayernamealias" },
    { 0x0821, "addplayertosquad" },
    { 0x0822, "addpossiblethreatcallout" },
    { 0x0823, "addposteventgeotocratebadplacearray" },
    { 0x0824, "addprereq" },
    { 0x0825, "addrankalias" },
    { 0x0826, "addreactionalias" },
    { 0x0827, "addreactionevent" },
    { 0x0828, "addresponsealias" },
    { 0x0829, "addresponseevent" },
    { 0x082A, "addresponseevent_internal" },
    { 0x082B, "addrightname" },
    { 0x082C, "addrighttitle" },
    { 0x082D, "addsafetyhealth" },
    { 0x082E, "addsituationalcombatorder" },
    { 0x082F, "addsituationalorder" },
    { 0x0830, "addspace" },
    { 0x0831, "addspacesmall" },
    { 0x0832, "addspawnpoints" },
    { 0x0833, "addspeaker" },
    { 0x0834, "addstartspawnpoints" },
    { 0x0835, "addstreaksupportprompt" },
    { 0x0836, "addsubleftname" },
    { 0x0837, "addsublefttitle" },
    { 0x0838, "addtakingfirealias" },
    { 0x0839, "addtauntalias" },
    { 0x083A, "addthreatalias" },
    { 0x083B, "addthreatcalloutalias" },
    { 0x083C, "addthreatcalloutecho" },
    { 0x083D, "addthreatcalloutlandmarkalias" },
    { 0x083E, "addthreatcalloutlocationalias" },
    { 0x083F, "addthreatcalloutqa_nextline" },
    { 0x0840, "addthreatcalloutresponsealias" },
    { 0x0841, "addthreatdistancealias" },
    { 0x0842, "addthreatelevationalias" },
    { 0x0843, "addthreatevent" },
    { 0x0844, "addthreatexposedalias" },
    { 0x0845, "addthreatobviousalias" },
    { 0x0846, "addtime" },
    { 0x0847, "addtoalivecount" },
    { 0x0848, "addtobaseangle" },
    { 0x0849, "addtobattlebuddywaitlist" },
    { 0x084A, "addtocarepackagedronelist" },
    { 0x084B, "addtocharactersarray" },
    { 0x084C, "addtodeletespike" },
    { 0x084D, "addtoexplosivedronelist" },
    { 0x084E, "addtohelilist" },
    { 0x084F, "addtolittlebirdlist" },
    { 0x0850, "addtolivescount" },
    { 0x0851, "addtoparticipantsarray" },
    { 0x0852, "addtosquad" },
    { 0x0853, "addtosystem" },
    { 0x0854, "addtoteam" },
    { 0x0855, "addtoteamcount" },
    { 0x0856, "addtototalspawned" },
    { 0x0857, "addtotrackingdronelist" },
    { 0x0858, "addtoturretlist" },
    { 0x0859, "addtowavespawner" },
    { 0x085A, "addturret" },
    { 0x085B, "adduavmodel" },
    { 0x085C, "aden_key_fr" },
    { 0x085D, "adjust_angles_to_player" },
    { 0x085E, "adjust_bounce_lookahead" },
    { 0x085F, "adjust_gravity" },
    { 0x0860, "adjust_model_speed_to_node" },
    { 0x0861, "adjust_pitbull_add_idle" },
    { 0x0862, "adjustallyaccuracyovertime" },
    { 0x0863, "adjustfov" },
    { 0x0864, "adjustlink" },
    { 0x0865, "adjustmissileoverlay" },
    { 0x0866, "adjustshadowcenter" },
    { 0x0867, "adjuststaticoverlay" },
    { 0x0868, "adrenaline" },
    { 0x0869, "adrenaline_col" },
    { 0x086A, "adrenaline_speed_scalar" },
    { 0x086B, "adrenalineinit" },
    { 0x086C, "adrenalinesettings" },
    { 0x086D, "adrenalinesupport" },
    { 0x086E, "adrone_condition_callback_to_state_deathspin" },
    { 0x086F, "adrone_condition_callback_to_state_destruct" },
    { 0x0870, "adrone_condition_callback_to_state_distant" },
    { 0x0871, "adrone_condition_callback_to_state_flyby" },
    { 0x0872, "adrone_condition_callback_to_state_flying" },
    { 0x0873, "adrone_condition_callback_to_state_flyover" },
    { 0x0874, "adrone_condition_callback_to_state_hover" },
    { 0x0875, "adrone_condition_callback_to_state_off" },
    { 0x0876, "ads" },
    { 0x0877, "ads_hint" },
    { 0x0878, "ads_hint_breakout" },
    { 0x0879, "ads_hint_breakout_think" },
    { 0x087A, "ads_hint_clear" },
    { 0x087B, "ads_hint_display" },
    { 0x087C, "ads_on" },
    { 0x087D, "adsmonitor" },
    { 0x087E, "adstime" },
    { 0x087F, "advance_bones_and_joker_intro" },
    { 0x0880, "advance_gideon_if_player_ahead" },
    { 0x0881, "advance_regardless_of_numbers" },
    { 0x0882, "advancedtraverse" },
    { 0x0883, "advancedtraverse2" },
    { 0x0884, "advancedwindowtraverse" },
    { 0x0885, "advanceonhidingenemy" },
    { 0x0886, "advancetoenemygroup" },
    { 0x0887, "advancetoenemygroupmax" },
    { 0x0888, "advancetoenemyinterval" },
    { 0x0889, "aerial_danger_exists_for" },
    { 0x088A, "aerial_dangers_monitoring" },
    { 0x088B, "aerial_group" },
    { 0x088C, "aerial_neighbors" },
    { 0x088D, "aerial_pathnode_group_connect_dist" },
    { 0x088E, "aerial_pathnode_offset" },
    { 0x088F, "aerial_pathnodes" },
    { 0x0890, "aerial_pathnodes_force_connect" },
    { 0x0891, "aerialdrone" },
    { 0x0892, "aerialkillstreakmarker" },
    { 0x0893, "affected" },
    { 0x0894, "afk" },
    { 0x0895, "after_collpase_ents" },
    { 0x0896, "afterlandanim" },
    { 0x0897, "afterlandanimconnected" },
    { 0x0898, "aftermath_anims" },
    { 0x0899, "agent_damage_finished" },
    { 0x089A, "agent_funcs" },
    { 0x089B, "agent_gameparticipant" },
    { 0x089C, "agent_override_difficulty" },
    { 0x089D, "agent_player_conf_think" },
    { 0x089E, "agent_player_dom_think" },
    { 0x089F, "agent_player_sd_think" },
    { 0x08A0, "agent_squadmember_conf_think" },
    { 0x08A1, "agent_squadmember_dom_think" },
    { 0x08A2, "agent_teamparticipant" },
    { 0x08A3, "agent_type" },
    { 0x08A4, "agentarray" },
    { 0x08A5, "agentbody" },
    { 0x08A6, "agentcostumetablename" },
    { 0x08A7, "agentdogbark" },
    { 0x08A8, "agentdogthink" },
    { 0x08A9, "agentfunc" },
    { 0x08AA, "aggresivelookat" },
    { 0x08AB, "aggressivemode" },
    { 0x08AC, "aggro_target" },
    { 0x08AD, "ah_delay_playerseek" },
    { 0x08AE, "ah_fast_body_cleanup" },
    { 0x08AF, "ah_init_track_block" },
    { 0x08B0, "ah_init_track_doors" },
    { 0x08B1, "ah_morgue_doors" },
    { 0x08B2, "ah_morgue_threat_proc" },
    { 0x08B3, "ah_move_track_block" },
    { 0x08B4, "ah_player_bodybag_slowdown" },
    { 0x08B5, "ah_track_door_open" },
    { 0x08B6, "ah_tranistion_doors" },
    { 0x08B7, "ai" },
    { 0x08B8, "ai_3d_sighting_model" },
    { 0x08B9, "ai_add_player_only_damage" },
    { 0x08BA, "ai_add_twenty_percent_damage" },
    { 0x08BB, "ai_ally_mb_intro_anim" },
    { 0x08BC, "ai_animate_props_on_death" },
    { 0x08BD, "ai_array" },
    { 0x08BE, "ai_array_killcount_flag_set" },
    { 0x08BF, "ai_boat_bow_splash_fx" },
    { 0x08C0, "ai_boat_water_foamfx" },
    { 0x08C1, "ai_canal_combat_01_accuracy_think" },
    { 0x08C2, "ai_canal_combat_02_accuracy_think" },
    { 0x08C3, "ai_canal_combat_03_accuracy_think" },
    { 0x08C4, "ai_canal_combat_04_accuracy_think" },
    { 0x08C5, "ai_canal_combat_05_accuracy_think" },
    { 0x08C6, "ai_charged_shot_wait_for_death" },
    { 0x08C7, "ai_classname_in_level" },
    { 0x08C8, "ai_classname_in_level_keys" },
    { 0x08C9, "ai_clear_custom_animation_reaction" },
    { 0x08CA, "ai_clear_custom_animation_reaction_and_idle" },
    { 0x08CB, "ai_cond_player_at_ambient_battle" },
    { 0x08CC, "ai_cond_player_at_escape_battle" },
    { 0x08CD, "ai_cond_player_at_pitbull_battle" },
    { 0x08CE, "ai_cond_player_at_police_battle" },
    { 0x08CF, "ai_cond_player_at_standoff_battle" },
    { 0x08D0, "ai_cond_player_at_standoff_battle_or_danger_zone" },
    { 0x08D1, "ai_cond_player_at_tanker_battle" },
    { 0x08D2, "ai_cond_player_at_van" },
    { 0x08D3, "ai_cond_reached_goal" },
    { 0x08D4, "ai_cond_reached_path_end" },
    { 0x08D5, "ai_create_behavior_function" },
    { 0x08D6, "ai_damage_think" },
    { 0x08D7, "ai_deathflag" },
    { 0x08D8, "ai_delete_self" },
    { 0x08D9, "ai_delete_when_out_of_sight" },
    { 0x08DA, "ai_detect_charged_damage" },
    { 0x08DB, "ai_detection" },
    { 0x08DC, "ai_detection_timeout" },
    { 0x08DD, "ai_disable_swim_or_underwater_walk" },
    { 0x08DE, "ai_diveboat_foam_trail" },
    { 0x08DF, "ai_diveboats_chase_trail" },
    { 0x08E0, "ai_dont_glow_in_thermal" },
    { 0x08E1, "ai_empty" },
    { 0x08E2, "ai_enable_swim_or_underwater_walk" },
    { 0x08E3, "ai_end_fixed_node" },
    { 0x08E4, "ai_end_ignore_all" },
    { 0x08E5, "ai_end_ignore_me" },
    { 0x08E6, "ai_end_magic_bullet_shield" },
    { 0x08E7, "ai_flee_from_microwave" },
    { 0x08E8, "ai_func_override" },
    { 0x08E9, "ai_functions" },
    { 0x08EA, "ai_game_mode" },
    { 0x08EB, "ai_gd" },
    { 0x08EC, "ai_get_behavior_function" },
    { 0x08ED, "ai_go_to_goal_before_colors" },
    { 0x08EE, "ai_ignore_everything" },
    { 0x08EF, "ai_ignore_foliage_for_time" },
    { 0x08F0, "ai_init" },
    { 0x08F1, "ai_jump_over_40_down_88" },
    { 0x08F2, "ai_kill" },
    { 0x08F3, "ai_kill_no_ragdoll" },
    { 0x08F4, "ai_kill_when_out_of_sight" },
    { 0x08F5, "ai_lasers" },
    { 0x08F6, "ai_lobby_think" },
    { 0x08F7, "ai_mantle_over_low_cover_40" },
    { 0x08F8, "ai_mb1" },
    { 0x08F9, "ai_mb1_allywarp" },
    { 0x08FA, "ai_mb1_drones" },
    { 0x08FB, "ai_mb1_first_guard_fallback" },
    { 0x08FC, "ai_mb1_jumpdown_guards" },
    { 0x08FD, "ai_mb1_script_end" },
    { 0x08FE, "ai_mb2" },
    { 0x08FF, "ai_mb2_drones" },
    { 0x0900, "ai_mb2_enemies_run" },
    { 0x0901, "ai_mb2_enemyrun" },
    { 0x0902, "ai_mb2_gate" },
    { 0x0903, "ai_mb2_mech_watcher" },
    { 0x0904, "ai_mb2_remove_stencils" },
    { 0x0905, "ai_mb2_script_end" },
    { 0x0906, "ai_message_handler_hidden" },
    { 0x0907, "ai_message_handler_spotted" },
    { 0x0908, "ai_mode" },
    { 0x0909, "ai_motorpool_animation" },
    { 0x090A, "ai_notify" },
    { 0x090B, "ai_number" },
    { 0x090C, "ai_player_only_damage_func" },
    { 0x090D, "ai_remove_outline_waiter" },
    { 0x090E, "ai_remove_player_only_damage" },
    { 0x090F, "ai_remove_twenty_percent_damage" },
    { 0x0910, "ai_restore_ignore_setting" },
    { 0x0911, "ai_run_behavior_until_condition" },
    { 0x0912, "ai_save_ignore_setting" },
    { 0x0913, "ai_set_custom_animation_reaction" },
    { 0x0914, "ai_set_goback_override_function" },
    { 0x0915, "ai_sets_goal" },
    { 0x0916, "ai_shoot_missile" },
    { 0x0917, "ai_shoot_missile_salvo" },
    { 0x0918, "ai_shot_by_player_team_notify" },
    { 0x0919, "ai_should_be_added" },
    { 0x091A, "ai_silo_floor_01_balcony" },
    { 0x091B, "ai_silo_floor_01_wave_2_think" },
    { 0x091C, "ai_silo_floor_01_wave_3_think" },
    { 0x091D, "ai_silo_think" },
    { 0x091E, "ai_slide_across_car" },
    { 0x091F, "ai_special_retreat_watcher" },
    { 0x0920, "ai_start_balcony_death" },
    { 0x0921, "ai_start_ignore_all" },
    { 0x0922, "ai_start_ignore_me" },
    { 0x0923, "ai_start_magic_bullet_shield" },
    { 0x0924, "ai_start_pacifist" },
    { 0x0925, "ai_start_respawn_death" },
    { 0x0926, "ai_stealth_pause_handler" },
    { 0x0927, "ai_step_up_32" },
    { 0x0928, "ai_stop_death_function" },
    { 0x0929, "ai_stun" },
    { 0x092A, "ai_swim_death" },
    { 0x092B, "ai_swim_pain" },
    { 0x092C, "ai_target" },
    { 0x092D, "ai_target_force" },
    { 0x092E, "ai_target_force_damaged" },
    { 0x092F, "ai_target_force_scripted" },
    { 0x0930, "ai_thermal" },
    { 0x0931, "ai_toggle_cloak" },
    { 0x0932, "ai_toggle_cloak_animate" },
    { 0x0933, "ai_toggle_cloak_complete_vo" },
    { 0x0934, "ai_toggle_cloak_start_vo" },
    { 0x0935, "ai_twenty_percent_damage_func" },
    { 0x0936, "ai_unignore_everything" },
    { 0x0937, "ai_wading_footsteps" },
    { 0x0938, "ai_wait_go" },
    { 0x0939, "ai_water_footstep" },
    { 0x093A, "ai_water_set_depth" },
    { 0x093B, "ai_wave_monitor_retreat" },
    { 0x093C, "ai_wave_monitor_threshold" },
    { 0x093D, "ai_wave_setgoalvolume" },
    { 0x093E, "ai_wave_spawn" },
    { 0x093F, "ai_wave_spawn_volume" },
    { 0x0940, "ai_wave_spawn_volume_threshold" },
    { 0x0941, "ai_wave_spawn_volume_threshold_retreat" },
    { 0x0942, "aianim_simple" },
    { 0x0943, "aianim_simple_vehicle" },
    { 0x0944, "aiareintheroom" },
    { 0x0945, "aiarraydeleteonflag" },
    { 0x0946, "aiarrayfallbackonflag" },
    { 0x0947, "aiarrayidleloop" },
    { 0x0948, "aiarraymovetonewidlepos" },
    { 0x0949, "aiarrayoverridemodelrandom" },
    { 0x094A, "aiattack" },
    { 0x094B, "aibattlechatterloop" },
    { 0x094C, "aicount" },
    { 0x094D, "aideathenemy" },
    { 0x094E, "aideatheventthread" },
    { 0x094F, "aideathfriendly" },
    { 0x0950, "aideleteonflag" },
    { 0x0951, "aidisablestealthcombat" },
    { 0x0952, "aidisplacewaiter" },
    { 0x0953, "aienablestealthcombat" },
    { 0x0954, "aienabletotalcombat" },
    { 0x0955, "aifallbackonflag" },
    { 0x0956, "aifollow" },
    { 0x0957, "aifolloworderwaiter" },
    { 0x0958, "aigrenadedangerwaiter" },
    { 0x0959, "aigroup_create" },
    { 0x095A, "aigroup_soldierthink" },
    { 0x095B, "aigroup_spawnerdeath" },
    { 0x095C, "aigroup_spawnerempty" },
    { 0x095D, "aigroup_spawnerthink" },
    { 0x095E, "aihasweapon" },
    { 0x095F, "aihostileburstloop" },
    { 0x0960, "aiidleloop" },
    { 0x0961, "aiidleloopdisable" },
    { 0x0962, "aiinwater" },
    { 0x0963, "aikilleventthread" },
    { 0x0964, "aikills" },
    { 0x0965, "aim_accel_turnrate_lerp" },
    { 0x0966, "aim_additives_think" },
    { 0x0967, "aim_assist_bmodel" },
    { 0x0968, "aim_assist_using_bmodels_init" },
    { 0x0969, "aim_assist_with_bmodels" },
    { 0x096A, "aim_at_my_attacker" },
    { 0x096B, "aim_axis_of_selected_ents" },
    { 0x096C, "aim_burke_at_angles" },
    { 0x096D, "aim_hud" },
    { 0x096E, "aim_hud_on" },
    { 0x096F, "aim_test" },
    { 0x0970, "aim_turnrate_pitch" },
    { 0x0971, "aim_turnrate_pitch_ads" },
    { 0x0972, "aim_turnrate_yaw" },
    { 0x0973, "aim_turnrate_yaw_ads" },
    { 0x0974, "aim_turret_at_ambush_point_or_visible_enemy" },
    { 0x0975, "aim_while_moving_thread" },
    { 0x0976, "aimassist_target" },
    { 0x0977, "aimblendtime" },
    { 0x0978, "aimbutdontshoot" },
    { 0x0979, "aimedatshootentorpos" },
    { 0x097A, "aimedsomewhatatenemy" },
    { 0x097B, "aimfaryawtolerance" },
    { 0x097C, "aimidlethread" },
    { 0x097D, "aimovetonewidlepos" },
    { 0x097E, "aimpitchdifftolerance" },
    { 0x097F, "aimsetupblendtime" },
    { 0x0980, "aimtarget" },
    { 0x0981, "aimweight" },
    { 0x0982, "aimweight_end" },
    { 0x0983, "aimweight_start" },
    { 0x0984, "aimweight_t" },
    { 0x0985, "aimweight_transframes" },
    { 0x0986, "aimyawdiffclosedistsq" },
    { 0x0987, "aimyawdiffclosetolerance" },
    { 0x0988, "aimyawdifffartolerance" },
    { 0x0989, "ainame" },
    { 0x098A, "ainameandrankwaiter" },
    { 0x098B, "aiofficerorders" },
    { 0x098C, "aioverridemodel" },
    { 0x098D, "aioverridemodelrandom" },
    { 0x098E, "aiowner" },
    { 0x098F, "air_strip_ambient_a10_gun_dive_1" },
    { 0x0990, "air_strip_ambient_a10_gun_dive_2" },
    { 0x0991, "air_strip_ambient_a10_gun_dive_3" },
    { 0x0992, "air_strip_ambient_dogfight_1" },
    { 0x0993, "air_strip_ambient_dogfight_2" },
    { 0x0994, "air_strip_ambient_dogfight_3" },
    { 0x0995, "airank" },
    { 0x0996, "airbrake_hint" },
    { 0x0997, "aircraft_wash" },
    { 0x0998, "aircraft_wash_thread" },
    { 0x0999, "airdropcratecollision" },
    { 0x099A, "airplane_list" },
    { 0x099B, "airstrike_drones" },
    { 0x099C, "airstrike_earthquake" },
    { 0x099D, "airstrike_flares_monitor" },
    { 0x099E, "airstrikefx" },
    { 0x099F, "airstrikeinprogress" },
    { 0x09A0, "airstrikeoverrides" },
    { 0x09A1, "airstriketype" },
    { 0x09A2, "airtoairevent" },
    { 0x09A3, "airtogroundevent" },
    { 0x09A4, "aistartusingassaultvehicle" },
    { 0x09A5, "aispread" },
    { 0x09A6, "aistate" },
    { 0x09A7, "aistealthcombatenemygotocover" },
    { 0x09A8, "aisuppressai" },
    { 0x09A9, "aithreadthreader" },
    { 0x09AA, "aiturnnotifies" },
    { 0x09AB, "aitype_check" },
    { 0x09AC, "aiupdateanimstate" },
    { 0x09AD, "aiupdatecombat" },
    { 0x09AE, "aiupdatesuppressed" },
    { 0x09AF, "aiweapon" },
    { 0x09B0, "ajani" },
    { 0x09B1, "akimboweaponent" },
    { 0x09B2, "alarm_annoyance" },
    { 0x09B3, "alarm_create_loops" },
    { 0x09B4, "alarm_enable" },
    { 0x09B5, "alarm_guid" },
    { 0x09B6, "alarm_interval" },
    { 0x09B7, "alarm_is_playing" },
    { 0x09B8, "alarm_monitor_cleanup" },
    { 0x09B9, "alarm_on" },
    { 0x09BA, "alarm_playing" },
    { 0x09BB, "alarm_reverb_distance_mix" },
    { 0x09BC, "alarm_start" },
    { 0x09BD, "alarm_start_loops" },
    { 0x09BE, "alarm_stop_loops" },
    { 0x09BF, "alarm_update_loops" },
    { 0x09C0, "alarm_validate_damage" },
    { 0x09C1, "alarmfx" },
    { 0x09C2, "alarmfx01" },
    { 0x09C3, "alarmsoundent" },
    { 0x09C4, "alarmsystem" },
    { 0x09C5, "alcove_clips" },
    { 0x09C6, "alert_check_function" },
    { 0x09C7, "alert_level" },
    { 0x09C8, "alert_level_table" },
    { 0x09C9, "alert_sound" },
    { 0x09CA, "alert_stop_animating" },
    { 0x09CB, "alert_when_another_is_hurt" },
    { 0x09CC, "alertai" },
    { 0x09CD, "alertaigroup" },
    { 0x09CE, "alertallpoolguards" },
    { 0x09CF, "alerted" },
    { 0x09D0, "alerted_amount" },
    { 0x09D1, "alerted_by_corpse" },
    { 0x09D2, "alertedenemies" },
    { 0x09D3, "alertedentity" },
    { 0x09D4, "alertedinfo" },
    { 0x09D5, "alertface" },
    { 0x09D6, "alertgroup" },
    { 0x09D7, "alerthighlighthudeffect" },
    { 0x09D8, "alerttimedelay" },
    { 0x09D9, "alias" },
    { 0x09DA, "alias_data" },
    { 0x09DB, "alias_name" },
    { 0x09DC, "aliens_make_entity_sentient_func" },
    { 0x09DD, "align_hint_think" },
    { 0x09DE, "alignment_factor" },
    { 0x09DF, "alive" },
    { 0x09E0, "alivecount" },
    { 0x09E1, "aliveplayers" },
    { 0x09E2, "all_avatars_scheduled_for_delete" },
    { 0x09E3, "all_dom_flags" },
    { 0x09E4, "all_exopush_enemies_dead" },
    { 0x09E5, "all_hp_zones" },
    { 0x09E6, "all_players_istouching" },
    { 0x09E7, "all_team_streak_col" },
    { 0x09E8, "all3duiscreens" },
    { 0x09E9, "allboothdisplays" },
    { 0x09EA, "allenemyambushers" },
    { 0x09EB, "allenemypatrollers" },
    { 0x09EC, "allenemyvehicles" },
    { 0x09ED, "allenvarray" },
    { 0x09EE, "alley_1_big_metal_gate" },
    { 0x09EF, "alley_1_complete_dialogue" },
    { 0x09F0, "alley_a_dialogue" },
    { 0x09F1, "alley_b_dialogue" },
    { 0x09F2, "alley_beckon" },
    { 0x09F3, "alley_combat_dialogue" },
    { 0x09F4, "alley_dialogue" },
    { 0x09F5, "alley_ending_point_trigger" },
    { 0x09F6, "alley_fail_dialogue" },
    { 0x09F7, "alley_flank_dialogue" },
    { 0x09F8, "alley_flank_dialogue_nag" },
    { 0x09F9, "alley_gideon_slide" },
    { 0x09FA, "alley_meetup_dialogue" },
    { 0x09FB, "alley_oncoming_dialogue" },
    { 0x09FC, "alley_setup" },
    { 0x09FD, "alley_veh_god_on" },
    { 0x09FE, "alley1_combat" },
    { 0x09FF, "alley1_force_deaths" },
    { 0x0A00, "alley1_kva" },
    { 0x0A01, "alley1_oncoming" },
    { 0x0A02, "alley1_oncoming_burke_alley_enter" },
    { 0x0A03, "alley1_oncoming_goto" },
    { 0x0A04, "alley1_oncoming_grenade_awareness" },
    { 0x0A05, "alley1_oncoming_truck_anims" },
    { 0x0A06, "alley1_oncoming_truck_seq" },
    { 0x0A07, "alley1_oncoming_truck_sweeper_monitor" },
    { 0x0A08, "alley1_oncoming_turret_fire" },
    { 0x0A09, "alley1_oncoming_turret_think" },
    { 0x0A0A, "alley1_stage1_combat" },
    { 0x0A0B, "alley1_stage1_rooftop_movedown" },
    { 0x0A0C, "alley1_stage2_combat" },
    { 0x0A0D, "alley1_stage2_combat_flag" },
    { 0x0A0E, "alley1_stage3_combat" },
    { 0x0A0F, "alley1_stage3_combat_flag" },
    { 0x0A10, "alley1_stage3_refill_think" },
    { 0x0A11, "alley1_veh_destro" },
    { 0x0A12, "alley2_combat" },
    { 0x0A13, "alley2_combat_enemy_vol_assign" },
    { 0x0A14, "alley2_combat_player_monitor" },
    { 0x0A15, "alley2_combat_vol_assign" },
    { 0x0A16, "alley2_jumpers" },
    { 0x0A17, "alley2_jumpers_setup" },
    { 0x0A18, "alley2_kva" },
    { 0x0A19, "alley2_spawner_locator" },
    { 0x0A1A, "alley2_stage1_combat" },
    { 0x0A1B, "alley2_stage2_combat" },
    { 0x0A1C, "alley2_stage3_combat" },
    { 0x0A1D, "alleys_distant_emergency_siren_blasts" },
    { 0x0A1E, "alleys_distant_euro_siren_loop" },
    { 0x0A1F, "alleys_distant_standard_siren_loop" },
    { 0x0A20, "alleys_end_music" },
    { 0x0A21, "alleys_music_end" },
    { 0x0A22, "alleys_rpg_fight_music" },
    { 0x0A23, "alleys_rpg_music" },
    { 0x0A24, "alleys_rpg_music_backup_trigger" },
    { 0x0A25, "alleysallymovement" },
    { 0x0A26, "alleysbegin" },
    { 0x0A27, "alleysbegincombatdialog" },
    { 0x0A28, "alleyscafeanims" },
    { 0x0A29, "alleyscheckifplayerretreated" },
    { 0x0A2A, "alleyscombat" },
    { 0x0A2B, "alleyscombatbacklinefloodspawns" },
    { 0x0A2C, "alleyscombatbacklineleftinteriorfloor1" },
    { 0x0A2D, "alleyscombatbacklineleftside" },
    { 0x0A2E, "alleyscombatbacklinerightinteriorfloor1" },
    { 0x0A2F, "alleyscombatbacklinerightinteriorfloor2" },
    { 0x0A30, "alleyscombatbacklinerightside" },
    { 0x0A31, "alleyscombatenemycountmonitor" },
    { 0x0A32, "alleyscombatenemyorders" },
    { 0x0A33, "alleyscombatenemyretreat" },
    { 0x0A34, "alleyscombatenemysetup" },
    { 0x0A35, "alleyscombatenterbuilding" },
    { 0x0A36, "alleyscombatfinalbldgfloodspawns" },
    { 0x0A37, "alleyscombatfinalbuilding" },
    { 0x0A38, "alleyscombatfinalbuildinginterior" },
    { 0x0A39, "alleyscombatfinalbuildingshotgunners" },
    { 0x0A3A, "alleyscombatfrontlinefloodspawns" },
    { 0x0A3B, "alleyscombatfrontlineleftbackstairs" },
    { 0x0A3C, "alleyscombatfrontlineleftside" },
    { 0x0A3D, "alleyscombatfrontlineleftsideinteriorfloor1" },
    { 0x0A3E, "alleyscombatfrontlinerightbackatm" },
    { 0x0A3F, "alleyscombatfrontlinerightside" },
    { 0x0A40, "alleyscombatinteriorfakebulletsactivate" },
    { 0x0A41, "alleyscombatinteriorfakebulletssetup" },
    { 0x0A42, "alleyscombatmidlineleftside" },
    { 0x0A43, "alleyscombatmidlinerightside" },
    { 0x0A44, "alleyscombatmidlinerightsideinterior" },
    { 0x0A45, "alleyscombattriggertoggles" },
    { 0x0A46, "alleysdialogtimer" },
    { 0x0A47, "alleysdronecivilians" },
    { 0x0A48, "alleysdronegawker" },
    { 0x0A49, "alleysenemyretreat" },
    { 0x0A4A, "alleysenemyrpg" },
    { 0x0A4B, "alleysenemyspawns" },
    { 0x0A4C, "alleysflaginit" },
    { 0x0A4D, "alleysgatebash" },
    { 0x0A4E, "alleysgatebashrumblelight" },
    { 0x0A4F, "alleysgateriprumbleheavy" },
    { 0x0A50, "alleysgateripunblockpath" },
    { 0x0A51, "alleysglobalsetup" },
    { 0x0A52, "alleysglobalvars" },
    { 0x0A53, "alleysilanaleadstheway" },
    { 0x0A54, "alleysintroanims" },
    { 0x0A55, "alleysintrotransitiondialogue" },
    { 0x0A56, "alleyskvaintrodialogue" },
    { 0x0A57, "alleysmidpointreminder" },
    { 0x0A58, "alleysmonitorgateriphint" },
    { 0x0A59, "alleysobjectivesetup" },
    { 0x0A5A, "alleysprecache" },
    { 0x0A5B, "alleysremainingenemies" },
    { 0x0A5C, "alleysrpgguyshootfirst" },
    { 0x0A5D, "alleyssetcompletedobjflags" },
    { 0x0A5E, "alleyssniperpip" },
    { 0x0A5F, "alleysspawnrpgenemies" },
    { 0x0A60, "alleysstartpoints" },
    { 0x0A61, "alleysstreettransitiondialogue" },
    { 0x0A62, "alleysvehicleexplodeondeath" },
    { 0x0A63, "alleysvehiclemonitor" },
    { 0x0A64, "alleysvideolog" },
    { 0x0A65, "alleysvisitorcentergate" },
    { 0x0A66, "alleysvisitorcentergatereminder" },
    { 0x0A67, "alleyway_fight_enemies" },
    { 0x0A68, "allfloorpannels" },
    { 0x0A69, "allies_bunker" },
    { 0x0A6A, "allies_careful" },
    { 0x0A6B, "allies_check_cloak_state" },
    { 0x0A6C, "allies_cover_michell" },
    { 0x0A6D, "allies_dialog_col" },
    { 0x0A6E, "allies_inert" },
    { 0x0A6F, "allies_plane" },
    { 0x0A70, "allies_rally_init" },
    { 0x0A71, "allies_s1" },
    { 0x0A72, "allies_s2" },
    { 0x0A73, "allies_start_spawn_name" },
    { 0x0A74, "allies_to_building_exit" },
    { 0x0A75, "allies_to_drone_swarm" },
    { 0x0A76, "allies_to_first_land_assist" },
    { 0x0A77, "allies_to_first_land_assist_debug" },
    { 0x0A78, "allies_to_fob" },
    { 0x0A79, "allies_to_fob_think" },
    { 0x0A7A, "allies_to_hill" },
    { 0x0A7B, "allies_to_truck_jump" },
    { 0x0A7C, "allies_to_weapons_platform_video_log" },
    { 0x0A7D, "alliesbreachatrium" },
    { 0x0A7E, "alliesbreachatriumonalarm" },
    { 0x0A7F, "alliesbreachconfroom" },
    { 0x0A80, "alliescapturing" },
    { 0x0A81, "allieschopper" },
    { 0x0A82, "alliesdrivein" },
    { 0x0A83, "alliesexitatrium" },
    { 0x0A84, "alliesexitconfroom" },
    { 0x0A85, "alliesexittruck" },
    { 0x0A86, "alliesflagcarrierclientnum" },
    { 0x0A87, "alliesflagstatus" },
    { 0x0A88, "alliesparkingdefend" },
    { 0x0A89, "alliesparkingkill" },
    { 0x0A8A, "alliesparkingkillalt" },
    { 0x0A8B, "alliesparkingkillvictim" },
    { 0x0A8C, "alliesparkingsetup" },
    { 0x0A8D, "alliesredirect" },
    { 0x0A8E, "alliesshootpooltargets" },
    { 0x0A8F, "alliesvulnerabletime" },
    { 0x0A90, "allieswarningtime" },
    { 0x0A91, "allow_backstabbers" },
    { 0x0A92, "allow_boost_jump" },
    { 0x0A93, "allow_death_delay" },
    { 0x0A94, "allow_death_during_zipline" },
    { 0x0A95, "allow_death_timer" },
    { 0x0A96, "allow_dog_paired_melee_vs_ai" },
    { 0x0A97, "allow_early_back_out" },
    { 0x0A98, "allow_exo_climb" },
    { 0x0A99, "allow_fake_shooting" },
    { 0x0A9A, "allow_pipe_damage" },
    { 0x0A9B, "allow_player_hovertank_mount" },
    { 0x0A9C, "allow_player_input_1" },
    { 0x0A9D, "allow_player_input_2" },
    { 0x0A9E, "allow_player_zip" },
    { 0x0A9F, "allow_random_killers" },
    { 0x0AA0, "allow_swimming" },
    { 0x0AA1, "allow_threat_paint" },
    { 0x0AA2, "allowable_double_attachments" },
    { 0x0AA3, "allowboostingabovetriggerradius" },
    { 0x0AA4, "allowcarry" },
    { 0x0AA5, "allowclasschoice" },
    { 0x0AA6, "allowdronedelivery" },
    { 0x0AA7, "allowedcallouts" },
    { 0x0AA8, "allowedpartialreloadontheruntime" },
    { 0x0AA9, "allowempdamage" },
    { 0x0AAA, "allowenemyspectate" },
    { 0x0AAB, "allowfauxdeath" },
    { 0x0AAC, "allowfreespectate" },
    { 0x0AAD, "allowlaststandai" },
    { 0x0AAE, "allowlatecomers" },
    { 0x0AAF, "allowmeleedamage" },
    { 0x0AB0, "allowneutral" },
    { 0x0AB1, "allowplayerscore" },
    { 0x0AB2, "allowshoot" },
    { 0x0AB3, "allowteamchoice" },
    { 0x0AB4, "allowtelefrag" },
    { 0x0AB5, "allowuse" },
    { 0x0AB6, "allowvehicledamage" },
    { 0x0AB7, "allowvote" },
    { 0x0AB8, "allowweapons" },
    { 0x0AB9, "alltargetlogicarray" },
    { 0x0ABA, "alltargetmax" },
    { 0x0ABB, "alltargetmin" },
    { 0x0ABC, "alltargetsarray" },
    { 0x0ABD, "alltriggerarray" },
    { 0x0ABE, "allvfx_struct" },
    { 0x0ABF, "ally" },
    { 0x0AC0, "ally_advance_ahead_upon_killing_group" },
    { 0x0AC1, "ally_ai_active" },
    { 0x0AC2, "ally_alert_vol" },
    { 0x0AC3, "ally_anims" },
    { 0x0AC4, "ally_determine_move_speed" },
    { 0x0AC5, "ally_dynamic_run_set" },
    { 0x0AC6, "ally_enable_boost_traversals" },
    { 0x0AC7, "ally_fire_on_dam" },
    { 0x0AC8, "ally_grapple" },
    { 0x0AC9, "ally_jet_shoot_think" },
    { 0x0ACA, "ally_move_dynamic_speed" },
    { 0x0ACB, "ally_mover" },
    { 0x0ACC, "ally_one_handed_grenade_proc" },
    { 0x0ACD, "ally_redirect_goto_node" },
    { 0x0ACE, "ally_reset_dynamic_speed" },
    { 0x0ACF, "ally_s2_squad_member_1" },
    { 0x0AD0, "ally_s2_squad_member_2" },
    { 0x0AD1, "ally_s2_squad_member_3" },
    { 0x0AD2, "ally_s2_squad_member_4" },
    { 0x0AD3, "ally_shoot_rpg_at_drones" },
    { 0x0AD4, "ally_squad_member_1" },
    { 0x0AD5, "ally_squad_member_2" },
    { 0x0AD6, "ally_squad_member_3" },
    { 0x0AD7, "ally_squad_member_4" },
    { 0x0AD8, "ally_stop_dynamic_speed" },
    { 0x0AD9, "ally_vo_controller" },
    { 0x0ADA, "ally_vo_org" },
    { 0x0ADB, "allyagentthink" },
    { 0x0ADC, "allybreachconfroomanddie" },
    { 0x0ADD, "allyburkeparkingsetup" },
    { 0x0ADE, "allyclaimedtarget" },
    { 0x0ADF, "allyclearforcegoalonend" },
    { 0x0AE0, "allyconfroomdeath" },
    { 0x0AE1, "allyexithandlevictim" },
    { 0x0AE2, "allyexitpool" },
    { 0x0AE3, "allyexittruck" },
    { 0x0AE4, "allyinfiltrators" },
    { 0x0AE5, "allypoolclimb" },
    { 0x0AE6, "allypoolkill" },
    { 0x0AE7, "allypoolsetup" },
    { 0x0AE8, "allyredirect" },
    { 0x0AE9, "allyredirectgotonode" },
    { 0x0AEA, "allyredirectnoteworthy" },
    { 0x0AEB, "allyscrambleanimations" },
    { 0x0AEC, "allysetupconfroom" },
    { 0x0AED, "allysetupstruggle" },
    { 0x0AEE, "allyshootpooltarget" },
    { 0x0AEF, "allyshootwalkwaytarget" },
    { 0x0AF0, "allysquad" },
    { 0x0AF1, "allystealthanimations" },
    { 0x0AF2, "allystruggleslomo" },
    { 0x0AF3, "allystrugglesuccess" },
    { 0x0AF4, "allytanks" },
    { 0x0AF5, "allywalkwaykill" },
    { 0x0AF6, "allywalkwaykillvictim" },
    { 0x0AF7, "almost_dead" },
    { 0x0AF8, "alpha_leader" },
    { 0x0AF9, "alpha_leader_think" },
    { 0x0AFA, "alpha_squad" },
    { 0x0AFB, "alpha_squad_and_player" },
    { 0x0AFC, "alphabetize" },
    { 0x0AFD, "alphabetize_localized_string" },
    { 0x0AFE, "already_dumpped" },
    { 0x0AFF, "already_got_end_level_notetrack" },
    { 0x0B00, "already_ran_function" },
    { 0x0B01, "already_set" },
    { 0x0B02, "already_used" },
    { 0x0B03, "alreadyaddedtoalivecount" },
    { 0x0B04, "alt_rspns_random_test" },
    { 0x0B05, "alt_rspns_test_func" },
    { 0x0B06, "alternates" },
    { 0x0B07, "altmeleedeath" },
    { 0x0B08, "altmeleevictimorientation" },
    { 0x0B09, "always_loop_ents" },
    { 0x0B0A, "always_pain" },
    { 0x0B0B, "always_sprint" },
    { 0x0B0C, "always_wake_drones" },
    { 0x0B0D, "alwaysdrawfriendlynames" },
    { 0x0B0E, "alwayslookatfirsttarget" },
    { 0x0B0F, "alwaysrocketdeath" },
    { 0x0B10, "alwaysrunforward" },
    { 0x0B11, "alwaysstaticout" },
    { 0x0B12, "alwaysusepistol" },
    { 0x0B13, "am_i_hit" },
    { 0x0B14, "am_i_moving" },
    { 0x0B15, "amb_push_oneshots" },
    { 0x0B16, "amb_pushing" },
    { 0x0B17, "amb_sky_combat" },
    { 0x0B18, "amb_sky_combat_setup" },
    { 0x0B19, "ambience" },
    { 0x0B1A, "ambience_inner" },
    { 0x0B1B, "ambience_outer" },
    { 0x0B1C, "ambient_animate" },
    { 0x0B1D, "ambient_battle_deployable_cover" },
    { 0x0B1E, "ambient_building_fires_fob_drone_swarm" },
    { 0x0B1F, "ambient_combat" },
    { 0x0B20, "ambient_combat_allies" },
    { 0x0B21, "ambient_combat_axis" },
    { 0x0B22, "ambient_combat_vo" },
    { 0x0B23, "ambient_deck" },
    { 0x0B24, "ambient_dialogue_manager" },
    { 0x0B25, "ambient_drones" },
    { 0x0B26, "ambient_eq" },
    { 0x0B27, "ambient_explosion_before_landing" },
    { 0x0B28, "ambient_explosion_courtyard" },
    { 0x0B29, "ambient_explosion_dirt_cooling_towers" },
    { 0x0B2A, "ambient_explosion_fireball_cooling_towers" },
    { 0x0B2B, "ambient_explosion_play" },
    { 0x0B2C, "ambient_explosions" },
    { 0x0B2D, "ambient_fan_rotate" },
    { 0x0B2E, "ambient_fires_inside_building" },
    { 0x0B2F, "ambient_flare_fx" },
    { 0x0B30, "ambient_gas_explosion_loading_zone" },
    { 0x0B31, "ambient_hangar" },
    { 0x0B32, "ambient_hangar_fan_blade_rotate" },
    { 0x0B33, "ambient_hangar_fan_blades_setup" },
    { 0x0B34, "ambient_hangar_workers" },
    { 0x0B35, "ambient_hangar_workers_spawn_settings" },
    { 0x0B36, "ambient_large_pipe_effects_courtyard" },
    { 0x0B37, "ambient_mb1_crane" },
    { 0x0B38, "ambient_mb2_claw_platform" },
    { 0x0B39, "ambient_mb2_crane" },
    { 0x0B3A, "ambient_mb2_cranes" },
    { 0x0B3B, "ambient_mb2_tanks" },
    { 0x0B3C, "ambient_model_fix" },
    { 0x0B3D, "ambient_modifier" },
    { 0x0B3E, "ambient_police_drone_vo" },
    { 0x0B3F, "ambient_police_drones" },
    { 0x0B40, "ambient_reverb" },
    { 0x0B41, "ambient_shrike_flyby" },
    { 0x0B42, "ambient_smk_walkway" },
    { 0x0B43, "ambient_sniper_rockets" },
    { 0x0B44, "ambient_soldier_vo_01" },
    { 0x0B45, "ambient_soldier_vo_02" },
    { 0x0B46, "ambient_soldier_vo_03" },
    { 0x0B47, "ambient_soldier_vo_04" },
    { 0x0B48, "ambient_soldier_vo_05" },
    { 0x0B49, "ambient_soldier_vo_06" },
    { 0x0B4A, "ambient_track" },
    { 0x0B4B, "ambient_underwater_effects_rescue" },
    { 0x0B4C, "ambient_warbird_fire" },
    { 0x0B4D, "ambient_warbird_shooting_think" },
    { 0x0B4E, "ambient_warbird_wait_to_fire" },
    { 0x0B4F, "ambientanimation" },
    { 0x0B50, "ambientcloudskill" },
    { 0x0B51, "ambientcloudsloadin" },
    { 0x0B52, "ambientdelay" },
    { 0x0B53, "ambientevent" },
    { 0x0B54, "ambienteventstart" },
    { 0x0B55, "ambientexp" },
    { 0x0B56, "ambienthdr" },
    { 0x0B57, "ambulance_damage_part" },
    { 0x0B58, "ambulance_firstframe_function" },
    { 0x0B59, "ambulance_max_health" },
    { 0x0B5A, "ambulance_objective_update" },
    { 0x0B5B, "ambulance_part_monitor" },
    { 0x0B5C, "ambulance_push_active" },
    { 0x0B5D, "ambulance_push_attach" },
    { 0x0B5E, "ambulance_push_idle" },
    { 0x0B5F, "ambulance_push_sequence_end" },
    { 0x0B60, "ambulance_push_step_away" },
    { 0x0B61, "ambush_ambushed_vo" },
    { 0x0B62, "ambush_breakout" },
    { 0x0B63, "ambush_duration" },
    { 0x0B64, "ambush_end" },
    { 0x0B65, "ambush_entrances" },
    { 0x0B66, "ambush_events" },
    { 0x0B67, "ambush_heli_explosion" },
    { 0x0B68, "ambush_player_if_alive_exopush" },
    { 0x0B69, "ambush_trap_ent" },
    { 0x0B6A, "ambush_wait" },
    { 0x0B6B, "ambush_yaw" },
    { 0x0B6C, "ambushendtime" },
    { 0x0B6D, "ambushnode" },
    { 0x0B6E, "ambushtimer" },
    { 0x0B6F, "americans" },
    { 0x0B70, "americans_setup" },
    { 0x0B71, "ammo" },
    { 0x0B72, "ammo_cache_think_global" },
    { 0x0B73, "ammo_icon" },
    { 0x0B74, "ammo_icon_fade_in" },
    { 0x0B75, "ammo_icon_fade_out" },
    { 0x0B76, "ammo_icon_think" },
    { 0x0B77, "ammo_icon_trig" },
    { 0x0B78, "ammo_max" },
    { 0x0B79, "ammo_pickup" },
    { 0x0B7A, "ammocheatinterval" },
    { 0x0B7B, "ammocheattime" },
    { 0x0B7C, "ammofeeder" },
    { 0x0B7D, "ammopickup" },
    { 0x0B7E, "ammopickup_scalar" },
    { 0x0B7F, "ammopickupfunc" },
    { 0x0B80, "ammopickupmodel" },
    { 0x0B81, "ammorefillprimary" },
    { 0x0B82, "ammorefillsecondary" },
    { 0x0B83, "amount" },
    { 0x0B84, "amount_in_sights" },
    { 0x0B85, "amplify_vfx" },
    { 0x0B86, "ams_enabled" },
    { 0x0B87, "ams_get_state" },
    { 0x0B88, "ams_init" },
    { 0x0B89, "ams_intensity" },
    { 0x0B8A, "ams_player_health" },
    { 0x0B8B, "ams_proxy_vehicle_speed" },
    { 0x0B8C, "ams_set_intensity" },
    { 0x0B8D, "ams_set_proxy_vehicle" },
    { 0x0B8E, "ams_set_state" },
    { 0x0B8F, "ams_start" },
    { 0x0B90, "ams_stop" },
    { 0x0B91, "amsx_get" },
    { 0x0B92, "amsx_get_proxy" },
    { 0x0B93, "amsx_get_proxy_vehicle_ent" },
    { 0x0B94, "amv_jetbike_height_time" },
    { 0x0B95, "amv_jetbike_height_val" },
    { 0x0B96, "angle" },
    { 0x0B97, "angle_interpolate" },
    { 0x0B98, "angle_lerp" },
    { 0x0B99, "angle_offset" },
    { 0x0B9A, "angleaccel" },
    { 0x0B9B, "anglelimit" },
    { 0x0B9C, "anglerangethread" },
    { 0x0B9D, "angles_and_origin" },
    { 0x0B9E, "angles_clamp_180" },
    { 0x0B9F, "angles_lerp" },
    { 0x0BA0, "angles_origin" },
    { 0x0BA1, "anglescheck" },
    { 0x0BA2, "anglesclamp180" },
    { 0x0BA3, "anglesondeath" },
    { 0x0BA4, "anglesonkill" },
    { 0x0BA5, "anglessubtract" },
    { 0x0BA6, "anglevalid" },
    { 0x0BA7, "angspeed" },
    { 0x0BA8, "anim_1" },
    { 0x0BA9, "anim_2" },
    { 0x0BAA, "anim_3" },
    { 0x0BAB, "anim_addmodel" },
    { 0x0BAC, "anim_animationendnotify" },
    { 0x0BAD, "anim_array" },
    { 0x0BAE, "anim_at_entity" },
    { 0x0BAF, "anim_at_self" },
    { 0x0BB0, "anim_blend_time_override" },
    { 0x0BB1, "anim_burke_boost_lets_go" },
    { 0x0BB2, "anim_burke_crawl" },
    { 0x0BB3, "anim_changes_pushplayer" },
    { 0x0BB4, "anim_custom_animmode" },
    { 0x0BB5, "anim_custom_animmode_loop" },
    { 0x0BB6, "anim_custom_animmode_loop_solo" },
    { 0x0BB7, "anim_custom_animmode_on_guy" },
    { 0x0BB8, "anim_custom_animmode_solo" },
    { 0x0BB9, "anim_deathnotify" },
    { 0x0BBA, "anim_debug" },
    { 0x0BBB, "anim_dialogueendnotify" },
    { 0x0BBC, "anim_disablepain" },
    { 0x0BBD, "anim_dontpushplayer" },
    { 0x0BBE, "anim_down" },
    { 0x0BBF, "anim_end_early" },
    { 0x0BC0, "anim_end_early_animationendnotify" },
    { 0x0BC1, "anim_end_early_deathnotify" },
    { 0x0BC2, "anim_end_early_dialogueendnotify" },
    { 0x0BC3, "anim_end_early_facialendnotify" },
    { 0x0BC4, "anim_exists" },
    { 0x0BC5, "anim_facialanim" },
    { 0x0BC6, "anim_facialendnotify" },
    { 0x0BC7, "anim_facialfiller" },
    { 0x0BC8, "anim_first_frame" },
    { 0x0BC9, "anim_first_frame_on_guy" },
    { 0x0BCA, "anim_first_frame_solo" },
    { 0x0BCB, "anim_first_frame_with_finale_gameplay" },
    { 0x0BCC, "anim_generic" },
    { 0x0BCD, "anim_generic_custom_animmode" },
    { 0x0BCE, "anim_generic_custom_animmode_loop" },
    { 0x0BCF, "anim_generic_first_frame" },
    { 0x0BD0, "anim_generic_gravity" },
    { 0x0BD1, "anim_generic_loop" },
    { 0x0BD2, "anim_generic_queue" },
    { 0x0BD3, "anim_generic_reach" },
    { 0x0BD4, "anim_generic_reach_and_arrive" },
    { 0x0BD5, "anim_generic_run" },
    { 0x0BD6, "anim_generic_teleport" },
    { 0x0BD7, "anim_gunhand" },
    { 0x0BD8, "anim_guninhand" },
    { 0x0BD9, "anim_handle_notetrack" },
    { 0x0BDA, "anim_idle_down" },
    { 0x0BDB, "anim_idle_up" },
    { 0x0BDC, "anim_is_death" },
    { 0x0BDD, "anim_laserbuoy" },
    { 0x0BDE, "anim_last_frame_solo" },
    { 0x0BDF, "anim_link_tag_model" },
    { 0x0BE0, "anim_loop" },
    { 0x0BE1, "anim_loop_hatch_anims_solo" },
    { 0x0BE2, "anim_loop_packet" },
    { 0x0BE3, "anim_loop_packet_solo" },
    { 0x0BE4, "anim_loop_solo" },
    { 0x0BE5, "anim_loop_solo_vm" },
    { 0x0BE6, "anim_loop_vm" },
    { 0x0BE7, "anim_moveto" },
    { 0x0BE8, "anim_node" },
    { 0x0BE9, "anim_org" },
    { 0x0BEA, "anim_org_ajani_post_breach" },
    { 0x0BEB, "anim_playsound_func" },
    { 0x0BEC, "anim_pos" },
    { 0x0BED, "anim_prep" },
    { 0x0BEE, "anim_prop_init_threads" },
    { 0x0BEF, "anim_prop_models" },
    { 0x0BF0, "anim_prop_models_animtree" },
    { 0x0BF1, "anim_props" },
    { 0x0BF2, "anim_props_animated" },
    { 0x0BF3, "anim_pushplayer" },
    { 0x0BF4, "anim_rate_to_speed" },
    { 0x0BF5, "anim_reach" },
    { 0x0BF6, "anim_reach_and_approach" },
    { 0x0BF7, "anim_reach_and_approach_node_solo" },
    { 0x0BF8, "anim_reach_and_approach_solo" },
    { 0x0BF9, "anim_reach_and_idle" },
    { 0x0BFA, "anim_reach_and_idle_solo" },
    { 0x0BFB, "anim_reach_and_plant" },
    { 0x0BFC, "anim_reach_and_plant_and_arrive" },
    { 0x0BFD, "anim_reach_cleanup" },
    { 0x0BFE, "anim_reach_cleanup_solo" },
    { 0x0BFF, "anim_reach_failsafe" },
    { 0x0C00, "anim_reach_fix" },
    { 0x0C01, "anim_reach_idle" },
    { 0x0C02, "anim_reach_solo" },
    { 0x0C03, "anim_reach_success" },
    { 0x0C04, "anim_reach_together" },
    { 0x0C05, "anim_reach_together_with_overrides" },
    { 0x0C06, "anim_reach_with_funcs" },
    { 0x0C07, "anim_relative" },
    { 0x0C08, "anim_removemodel" },
    { 0x0C09, "anim_roundabout_rappel_1" },
    { 0x0C0A, "anim_roundabout_rappel_2" },
    { 0x0C0B, "anim_scene_building_exit_cormack" },
    { 0x0C0C, "anim_scene_building_exit_will" },
    { 0x0C0D, "anim_scene_building_jump" },
    { 0x0C0E, "anim_scene_walker_stepover" },
    { 0x0C0F, "anim_scene_will_grabs_car_door" },
    { 0x0C10, "anim_scene_will_grabs_car_door_post_cherrypicker" },
    { 0x0C11, "anim_self_set_real_time" },
    { 0x0C12, "anim_self_set_time" },
    { 0x0C13, "anim_sequence" },
    { 0x0C14, "anim_set_rate" },
    { 0x0C15, "anim_set_rate_internal" },
    { 0x0C16, "anim_set_rate_single" },
    { 0x0C17, "anim_set_real_time" },
    { 0x0C18, "anim_set_time" },
    { 0x0C19, "anim_simple" },
    { 0x0C1A, "anim_simple_notify" },
    { 0x0C1B, "anim_single" },
    { 0x0C1C, "anim_single_droppod_custom" },
    { 0x0C1D, "anim_single_end_early" },
    { 0x0C1E, "anim_single_failsafe" },
    { 0x0C1F, "anim_single_failsafeonguy" },
    { 0x0C20, "anim_single_internal" },
    { 0x0C21, "anim_single_mech" },
    { 0x0C22, "anim_single_qte_middle" },
    { 0x0C23, "anim_single_qte_middle_fail" },
    { 0x0C24, "anim_single_queue" },
    { 0x0C25, "anim_single_run" },
    { 0x0C26, "anim_single_run_solo" },
    { 0x0C27, "anim_single_solo" },
    { 0x0C28, "anim_single_solo_custom" },
    { 0x0C29, "anim_single_solo_d" },
    { 0x0C2A, "anim_single_solo_in_place" },
    { 0x0C2B, "anim_single_solo_internal_vm" },
    { 0x0C2C, "anim_single_solo_run" },
    { 0x0C2D, "anim_single_solo_vm" },
    { 0x0C2E, "anim_single_solo_with_lerp" },
    { 0x0C2F, "anim_single_solo_with_special_walk" },
    { 0x0C30, "anim_single_solo_with_wait_flag" },
    { 0x0C31, "anim_single_to_delete" },
    { 0x0C32, "anim_single_to_delete_solo" },
    { 0x0C33, "anim_single_to_loop" },
    { 0x0C34, "anim_single_to_loop_solo" },
    { 0x0C35, "anim_single_with_gameplay" },
    { 0x0C36, "anim_spawn_generic_model" },
    { 0x0C37, "anim_spawn_model" },
    { 0x0C38, "anim_spawn_tag_model" },
    { 0x0C39, "anim_spawner_teleport" },
    { 0x0C3A, "anim_speed" },
    { 0x0C3B, "anim_start_at_groundpos" },
    { 0x0C3C, "anim_start_pos" },
    { 0x0C3D, "anim_start_pos_solo" },
    { 0x0C3E, "anim_state" },
    { 0x0C3F, "anim_stop" },
    { 0x0C40, "anim_stopanimscripted" },
    { 0x0C41, "anim_struct" },
    { 0x0C42, "anim_struct_exfil" },
    { 0x0C43, "anim_struct2" },
    { 0x0C44, "anim_tag" },
    { 0x0C45, "anim_teleport" },
    { 0x0C46, "anim_teleport_solo" },
    { 0x0C47, "anim_time" },
    { 0x0C48, "anim_up" },
    { 0x0C49, "anim_van_intro" },
    { 0x0C4A, "anim_wait_func" },
    { 0x0C4B, "anim_weight" },
    { 0x0C4C, "anim_with_teleport" },
    { 0x0C4D, "animal_anims" },
    { 0x0C4E, "animalanimations" },
    { 0x0C4F, "animalias" },
    { 0x0C50, "animarchetype" },
    { 0x0C51, "animarray" },
    { 0x0C52, "animarrayanyexist" },
    { 0x0C53, "animarrayfuncs" },
    { 0x0C54, "animarraypickrandom" },
    { 0x0C55, "animate_collapse_ent" },
    { 0x0C56, "animate_dead_body" },
    { 0x0C57, "animate_drills" },
    { 0x0C58, "animate_drive_idle" },
    { 0x0C59, "animate_drive_idle_on_dummies" },
    { 0x0C5A, "animate_guys" },
    { 0x0C5B, "animate_on_goal" },
    { 0x0C5C, "animate_player_on_rig_simple" },
    { 0x0C5D, "animate_props_on_death" },
    { 0x0C5E, "animate_script_origin" },
    { 0x0C5F, "animate_the_other_guys" },
    { 0x0C60, "animate_turret_with_viewmodel" },
    { 0x0C61, "animated_gun" },
    { 0x0C62, "animated_lights" },
    { 0x0C63, "animated_pod_function" },
    { 0x0C64, "animated_prop_anims" },
    { 0x0C65, "animateddeath" },
    { 0x0C66, "animatedpalmtrees" },
    { 0x0C67, "animatemodel" },
    { 0x0C68, "animatemoveintoplace" },
    { 0x0C69, "animatetreewind" },
    { 0x0C6A, "animation_process" },
    { 0x0C6B, "animation_think" },
    { 0x0C6C, "animcbs" },
    { 0x0C6D, "animdodgeobstaclelistener" },
    { 0x0C6E, "animdown" },
    { 0x0C6F, "anime" },
    { 0x0C70, "animent" },
    { 0x0C71, "animflagnameindex" },
    { 0x0C72, "animhasfacialoverride" },
    { 0x0C73, "animidledown" },
    { 0x0C74, "animidleup" },
    { 0x0C75, "animname" },
    { 0x0C76, "animnode" },
    { 0x0C77, "animontag" },
    { 0x0C78, "animontag_ragdoll_death" },
    { 0x0C79, "animontag_ragdoll_death_fall" },
    { 0x0C7A, "animontag_unloading_vehicle_explosion" },
    { 0x0C7B, "animplaybackrate" },
    { 0x0C7C, "animref" },
    { 0x0C7D, "anims" },
    { 0x0C7E, "animsapplied" },
    { 0x0C7F, "animscript_sittag" },
    { 0x0C80, "animscript_target" },
    { 0x0C81, "animscriptdonotetracksthread" },
    { 0x0C82, "animsequence" },
    { 0x0C83, "animset" },
    { 0x0C84, "animsets" },
    { 0x0C85, "animsound_aliases" },
    { 0x0C86, "animsound_exists" },
    { 0x0C87, "animsound_hud_extralines" },
    { 0x0C88, "animsound_hudlimit" },
    { 0x0C89, "animsound_start_tracker" },
    { 0x0C8A, "animsound_start_tracker_loop" },
    { 0x0C8B, "animsound_tagged" },
    { 0x0C8C, "animsound_tracker" },
    { 0x0C8D, "animsounds" },
    { 0x0C8E, "animsounds_thisframe" },
    { 0x0C8F, "animstate" },
    { 0x0C90, "animsubstate" },
    { 0x0C91, "animtree" },
    { 0x0C92, "animup" },
    { 0x0C93, "anml_doberman" },
    { 0x0C94, "announcerdisabled" },
    { 0x0C95, "annoyance_tracker" },
    { 0x0C96, "antiintrusion" },
    { 0x0C97, "any_enemy_is_able_to_attack" },
    { 0x0C98, "any_players_istouching" },
    { 0x0C99, "any_wheel_on_ground" },
    { 0x0C9A, "anyattachmentisscope" },
    { 0x0C9B, "anyplayersinkillcam" },
    { 0x0C9C, "anystingermissilelockedon" },
    { 0x0C9D, "anythingistouching" },
    { 0x0C9E, "anythingtouchingtrigger" },
    { 0x0C9F, "apex" },
    { 0x0CA0, "apm_mine_deletekillcament" },
    { 0x0CA1, "applied_reverb" },
    { 0x0CA2, "apply_difficulty_frac_with_func" },
    { 0x0CA3, "apply_difficulty_step_with_func" },
    { 0x0CA4, "apply_end_fog" },
    { 0x0CA5, "apply_fog" },
    { 0x0CA6, "apply_friendly_fire_damage_modifier" },
    { 0x0CA7, "apply_jump_fx" },
    { 0x0CA8, "apply_option_to_selected_fx" },
    { 0x0CA9, "apply_reinforcement_perk" },
    { 0x0CAA, "apply_reverb" },
    { 0x0CAB, "apply_truckjunk" },
    { 0x0CAC, "apply_whizby" },
    { 0x0CAD, "applybombcarrierclass" },
    { 0x0CAE, "applyemp" },
    { 0x0CAF, "applyflagcarrierclass" },
    { 0x0CB0, "applyflash" },
    { 0x0CB1, "applyloadout" },
    { 0x0CB2, "applyperks" },
    { 0x0CB3, "applyprisonturretradararrow" },
    { 0x0CB4, "approach_barracks_combat_setup" },
    { 0x0CB5, "approach_handle_murica_movement_left" },
    { 0x0CB6, "approach_idle_ents" },
    { 0x0CB7, "approach_scene_ents" },
    { 0x0CB8, "approach_spawn_functions" },
    { 0x0CB9, "approach_types" },
    { 0x0CBA, "approachconditioncheckfunc" },
    { 0x0CBB, "approaching" },
    { 0x0CBC, "approaching_roundabout_dialogue" },
    { 0x0CBD, "approaching_standoff" },
    { 0x0CBE, "approachnumber" },
    { 0x0CBF, "approachtype" },
    { 0x0CC0, "approachtypefunc" },
    { 0x0CC1, "approachwaittillclose" },
    { 0x0CC2, "aquiring_targets_think" },
    { 0x0CC3, "ar_moment" },
    { 0x0CC4, "arc_point" },
    { 0x0CC5, "arcade_plane_controls" },
    { 0x0CC6, "arcademode" },
    { 0x0CC7, "arcademode_hud_timer" },
    { 0x0CC8, "arcademode_stop_timer" },
    { 0x0CC9, "arcademode_stoptime" },
    { 0x0CCA, "archetype_exists" },
    { 0x0CCB, "archetypechanged" },
    { 0x0CCC, "archetypeexists" },
    { 0x0CCD, "archetypes" },
    { 0x0CCE, "archive" },
    { 0x0CCF, "are_we_close" },
    { 0x0CD0, "aredifferent" },
    { 0x0CD1, "arm_repair_attempt" },
    { 0x0CD2, "armada_intro_screen" },
    { 0x0CD3, "armed" },
    { 0x0CD4, "armordamagehints" },
    { 0x0CD5, "armorpiercingmod" },
    { 0x0CD6, "armorvestmod" },
    { 0x0CD7, "armorygiveexoability" },
    { 0x0CD8, "armorypoints" },
    { 0x0CD9, "armorypurchasefail" },
    { 0x0CDA, "armorythink" },
    { 0x0CDB, "array" },
    { 0x0CDC, "array_2dadd" },
    { 0x0CDD, "array_add" },
    { 0x0CDE, "array_call" },
    { 0x0CDF, "array_checkaddattachment" },
    { 0x0CE0, "array_combine" },
    { 0x0CE1, "array_combine_all" },
    { 0x0CE2, "array_combine_keys" },
    { 0x0CE3, "array_combine_multiple" },
    { 0x0CE4, "array_combine_non_integer_indices" },
    { 0x0CE5, "array_combine_unique" },
    { 0x0CE6, "array_compare" },
    { 0x0CE7, "array_contains" },
    { 0x0CE8, "array_delete" },
    { 0x0CE9, "array_delete_evenly" },
    { 0x0CEA, "array_exclude" },
    { 0x0CEB, "array_find" },
    { 0x0CEC, "array_first" },
    { 0x0CED, "array_index_by_classname" },
    { 0x0CEE, "array_index_by_parameters" },
    { 0x0CEF, "array_index_by_script_index" },
    { 0x0CF0, "array_insert" },
    { 0x0CF1, "array_kill" },
    { 0x0CF2, "array_levelcall" },
    { 0x0CF3, "array_levelthread" },
    { 0x0CF4, "array_levelthread_safe" },
    { 0x0CF5, "array_merge" },
    { 0x0CF6, "array_merge_links" },
    { 0x0CF7, "array_notify" },
    { 0x0CF8, "array_randomize" },
    { 0x0CF9, "array_remove" },
    { 0x0CFA, "array_remove_array" },
    { 0x0CFB, "array_remove_dead" },
    { 0x0CFC, "array_remove_duplicates" },
    { 0x0CFD, "array_remove_index" },
    { 0x0CFE, "array_remove_nokeys" },
    { 0x0CFF, "array_removeclaimedtargets" },
    { 0x0D00, "array_removedead" },
    { 0x0D01, "array_removedead_keepkeys" },
    { 0x0D02, "array_removedead_or_dying" },
    { 0x0D03, "array_removefirstinqueue" },
    { 0x0D04, "array_removeundefined" },
    { 0x0D05, "array_reverse" },
    { 0x0D06, "array_safe_delete" },
    { 0x0D07, "array_setgoalvolume" },
    { 0x0D08, "array_sort_by_handler" },
    { 0x0D09, "array_sort_with_func" },
    { 0x0D0A, "array_sound_start" },
    { 0x0D0B, "array_spawn" },
    { 0x0D0C, "array_spawn_allow_fail" },
    { 0x0D0D, "array_spawn_cg" },
    { 0x0D0E, "array_spawn_function" },
    { 0x0D0F, "array_spawn_function_noteworthy" },
    { 0x0D10, "array_spawn_function_targetname" },
    { 0x0D11, "array_spawn_noteworthy" },
    { 0x0D12, "array_spawn_targetname" },
    { 0x0D13, "array_spawn_targetname_allow_fail" },
    { 0x0D14, "array_spawn_targetname_cg" },
    { 0x0D15, "array_spawn_targetname_stagger" },
    { 0x0D16, "array_thread" },
    { 0x0D17, "array_thread_mod_delayed" },
    { 0x0D18, "array_thread_safe" },
    { 0x0D19, "array_thread4" },
    { 0x0D1A, "array_thread5" },
    { 0x0D1B, "array_wait" },
    { 0x0D1C, "array_waitlogic1" },
    { 0x0D1D, "array_waitlogic2" },
    { 0x0D1E, "array_waittill_player_lookat" },
    { 0x0D1F, "array_waittill_player_lookat_proc" },
    { 0x0D20, "arrayinsertion" },
    { 0x0D21, "arrayremovevalue" },
    { 0x0D22, "arrays_color_spawners" },
    { 0x0D23, "arrays_of_colorcoded_nodes" },
    { 0x0D24, "arrays_of_colorcoded_volumes" },
    { 0x0D25, "arrays_of_colorforced_ai" },
    { 0x0D26, "arrivalanim" },
    { 0x0D27, "arrivalendstance" },
    { 0x0D28, "arrivalnodetype" },
    { 0x0D29, "arrivalpathgoalpos" },
    { 0x0D2A, "arrivalstance" },
    { 0x0D2B, "arrivalstartdist" },
    { 0x0D2C, "arrivaltype" },
    { 0x0D2D, "arrive" },
    { 0x0D2E, "art_print_fog" },
    { 0x0D2F, "artendfogfileexport" },
    { 0x0D30, "artendvisionfileexport" },
    { 0x0D31, "artfxprintlnfog" },
    { 0x0D32, "artifact_pulse" },
    { 0x0D33, "artifacts" },
    { 0x0D34, "artifacts_fade" },
    { 0x0D35, "artillery_earthquake" },
    { 0x0D36, "artillerydangercenters" },
    { 0x0D37, "artilleryshellshock" },
    { 0x0D38, "artstartfogfileexport" },
    { 0x0D39, "artstartvisionfileexport" },
    { 0x0D3A, "assault_drone_stinger_target_pos" },
    { 0x0D3B, "assault_vehicle_ai_aerial_follow_path_outside" },
    { 0x0D3C, "assault_vehicle_ai_aerial_movement" },
    { 0x0D3D, "assault_vehicle_ai_aerial_pathing_c4" },
    { 0x0D3E, "assault_vehicle_ai_aerial_pathing_turret" },
    { 0x0D3F, "assault_vehicle_ai_air_movement_func" },
    { 0x0D40, "assault_vehicle_ai_can_see_living_enemy" },
    { 0x0D41, "assault_vehicle_ai_end_on_owner_disconnect" },
    { 0x0D42, "assault_vehicle_ai_enemy_exists_and_is_alive" },
    { 0x0D43, "assault_vehicle_ai_enemy_moved_air" },
    { 0x0D44, "assault_vehicle_ai_enemy_moved_ground" },
    { 0x0D45, "assault_vehicle_ai_follow_path" },
    { 0x0D46, "assault_vehicle_ai_get_camera_position" },
    { 0x0D47, "assault_vehicle_ai_get_nearest_node" },
    { 0x0D48, "assault_vehicle_ai_ground_movement" },
    { 0x0D49, "assault_vehicle_ai_ground_movement_loop" },
    { 0x0D4A, "assault_vehicle_ai_init" },
    { 0x0D4B, "assault_vehicle_ai_move_to_aerial_node" },
    { 0x0D4C, "assault_vehicle_ai_path_timeout_time" },
    { 0x0D4D, "assault_vehicle_ai_pick_aerial_node" },
    { 0x0D4E, "assault_vehicle_ai_threat" },
    { 0x0D4F, "assault_vehicle_ai_weapons" },
    { 0x0D50, "assaultfullstaticondeath" },
    { 0x0D51, "assaulthandledeath" },
    { 0x0D52, "assaulthandletimeoutwarning" },
    { 0x0D53, "assaulthudremove" },
    { 0x0D54, "assaulthudsetup" },
    { 0x0D55, "assaultobjectiveevent" },
    { 0x0D56, "assaultplayerexit" },
    { 0x0D57, "assaultsetinactivity" },
    { 0x0D58, "assaultvehiclemonitorweapons" },
    { 0x0D59, "assert_existance_of_anim" },
    { 0x0D5A, "assert_existance_of_anim_vm" },
    { 0x0D5B, "assert_existance_of_looping_anim" },
    { 0x0D5C, "assert_if_anim_not_defined" },
    { 0x0D5D, "assert_if_identical_origins" },
    { 0x0D5E, "assertdisplayed" },
    { 0x0D5F, "assertdisplayed_b" },
    { 0x0D60, "asset_name" },
    { 0x0D61, "asset_names" },
    { 0x0D62, "asset_type" },
    { 0x0D63, "assign_animals_tree" },
    { 0x0D64, "assign_animtree" },
    { 0x0D65, "assign_cloak_model" },
    { 0x0D66, "assign_drone_tree" },
    { 0x0D67, "assign_fx_to_trigger" },
    { 0x0D68, "assign_generic_human_tree" },
    { 0x0D69, "assign_goal_node" },
    { 0x0D6A, "assign_goal_vol" },
    { 0x0D6B, "assign_model" },
    { 0x0D6C, "assign_nodes_to_zipline_guys" },
    { 0x0D6D, "assign_npcid" },
    { 0x0D6E, "assign_script_breachgroup_to_ents" },
    { 0x0D6F, "assign_spawns" },
    { 0x0D70, "assign_spawns_version_2" },
    { 0x0D71, "assign_spawns_version_3" },
    { 0x0D72, "assign_unique_id" },
    { 0x0D73, "assignawards" },
    { 0x0D74, "assigned_brush" },
    { 0x0D75, "assigned_model" },
    { 0x0D76, "assigned_model_b" },
    { 0x0D77, "assigned_parent" },
    { 0x0D78, "assignpracticeroundclasses" },
    { 0x0D79, "assignteamspawns" },
    { 0x0D7A, "assistedsuicide" },
    { 0x0D7B, "assistedsuicideevent" },
    { 0x0D7C, "assistplayer" },
    { 0x0D7D, "assistpoints" },
    { 0x0D7E, "assists_disabled" },
    { 0x0D7F, "ast_mus_on" },
    { 0x0D80, "at_goal" },
    { 0x0D81, "at_path_end" },
    { 0x0D82, "at_rest" },
    { 0x0D83, "at_start" },
    { 0x0D84, "at_van_enemy_cleanup" },
    { 0x0D85, "atbrinkofdeath" },
    { 0x0D86, "atconcealmentnode" },
    { 0x0D87, "atk_bomber" },
    { 0x0D88, "atk_bomber_no_path_to_bomb_count" },
    { 0x0D89, "atk_bomber_update" },
    { 0x0D8A, "atlas_base_weapon_manager" },
    { 0x0D8B, "atlas_base_weapon_manager_elevator" },
    { 0x0D8C, "atlas_building_roof_walla" },
    { 0x0D8D, "atlas_drone_damage_function" },
    { 0x0D8E, "atlas_guard" },
    { 0x0D8F, "atlas_guard_dialogue_line1" },
    { 0x0D90, "atlas_guard1" },
    { 0x0D91, "atlas_guard2" },
    { 0x0D92, "atlas_guard3" },
    { 0x0D93, "atlas_guard4" },
    { 0x0D94, "atlas_guard5" },
    { 0x0D95, "atlas_guard6" },
    { 0x0D96, "atlas_guard7" },
    { 0x0D97, "atlas_intercepts" },
    { 0x0D98, "atlas_sign_flicker" },
    { 0x0D99, "atlas_suv_impact_fx" },
    { 0x0D9A, "atlas_suv_rider_no_react" },
    { 0x0D9B, "atlas_suv_rider_react" },
    { 0x0D9C, "atlas_suv_rider_think" },
    { 0x0D9D, "atlas_van_explode" },
    { 0x0D9E, "atlas1" },
    { 0x0D9F, "atlas2" },
    { 0x0DA0, "atlascard_cormack_walk" },
    { 0x0DA1, "atlascard_irons_grab_card" },
    { 0x0DA2, "atlascard_irons_handshake" },
    { 0x0DA3, "atlascard_irons_leave" },
    { 0x0DA4, "atlascard_irons_place_hand" },
    { 0x0DA5, "atlascard_irons_tap" },
    { 0x0DA6, "atlascard_irons_turn" },
    { 0x0DA7, "atlascard_irons_walk" },
    { 0x0DA8, "atlasdrn_condition_callback_to_state_deathspin" },
    { 0x0DA9, "atlasdrn_condition_callback_to_state_destruct" },
    { 0x0DAA, "atlasdrn_condition_callback_to_state_distant" },
    { 0x0DAB, "atlasdrn_condition_callback_to_state_flyby" },
    { 0x0DAC, "atlasdrn_condition_callback_to_state_flying" },
    { 0x0DAD, "atlasdrn_condition_callback_to_state_flyover" },
    { 0x0DAE, "atlasdrn_condition_callback_to_state_hover" },
    { 0x0DAF, "atlasdrn_condition_callback_to_state_off" },
    { 0x0DB0, "atlasdrn_lens_focus" },
    { 0x0DB1, "atm_is_muted" },
    { 0x0DB2, "atm_max_off_time" },
    { 0x0DB3, "atm_max_on_time" },
    { 0x0DB4, "atm_mute_time" },
    { 0x0DB5, "atm_off_time" },
    { 0x0DB6, "atmosfogdistancescale" },
    { 0x0DB7, "atmosfogenabled" },
    { 0x0DB8, "atmosfogextinctionstrength" },
    { 0x0DB9, "atmosfoghalfplanedistance" },
    { 0x0DBA, "atmosfoghazecolor" },
    { 0x0DBB, "atmosfoghazespread" },
    { 0x0DBC, "atmosfoghazestrength" },
    { 0x0DBD, "atmosfogheightfogbaseheight" },
    { 0x0DBE, "atmosfogheightfogenabled" },
    { 0x0DBF, "atmosfogheightfoghalfplanedistance" },
    { 0x0DC0, "atmosfoginscatterstrength" },
    { 0x0DC1, "atmosfogskyangularfalloffenabled" },
    { 0x0DC2, "atmosfogskydistance" },
    { 0x0DC3, "atmosfogskyfalloffanglerange" },
    { 0x0DC4, "atmosfogskyfalloffstartangle" },
    { 0x0DC5, "atmosfogstartdistance" },
    { 0x0DC6, "atmosfogsundirection" },
    { 0x0DC7, "atmosfogsunfogcolor" },
    { 0x0DC8, "atrium_breach_signal_start" },
    { 0x0DC9, "atrium_timer_expire" },
    { 0x0DCA, "atriumanimations" },
    { 0x0DCB, "atriumboostjump" },
    { 0x0DCC, "atriumboostjumpguy" },
    { 0x0DCD, "atriumbreachexplosionnotetrack" },
    { 0x0DCE, "atriumbreachidle" },
    { 0x0DCF, "atriumbreachidleburke" },
    { 0x0DD0, "atriumbreachidleinfiltrators" },
    { 0x0DD1, "atriumbreachmonitoralliesinposition" },
    { 0x0DD2, "atriumdoorbreachdamage" },
    { 0x0DD3, "atriumdoorsopen" },
    { 0x0DD4, "atriumdoorsopenonalarm" },
    { 0x0DD5, "atriumlookatdialogue" },
    { 0x0DD6, "atriumreminderdialogue" },
    { 0x0DD7, "atriumsetupdialogue" },
    { 0x0DD8, "atriumshootfirstdialogue" },
    { 0x0DD9, "atriumtimer" },
    { 0x0DDA, "atriumtimewindow" },
    { 0x0DDB, "atrrestoremech" },
    { 0x0DDC, "attach_assault_drone_lights" },
    { 0x0DDD, "attach_bone" },
    { 0x0DDE, "attach_cig" },
    { 0x0DDF, "attach_cig_self" },
    { 0x0DE0, "attach_clip" },
    { 0x0DE1, "attach_ent" },
    { 0x0DE2, "attach_fixed_scanner" },
    { 0x0DE3, "attach_flashlight_in_hand" },
    { 0x0DE4, "attach_flashlight_on_gun" },
    { 0x0DE5, "attach_flashlight_on_vehicle_unload" },
    { 0x0DE6, "attach_fx_to_mechanism" },
    { 0x0DE7, "attach_housing" },
    { 0x0DE8, "attach_light_to_face" },
    { 0x0DE9, "attach_light_to_police_car" },
    { 0x0DEA, "attach_littlebird_parts" },
    { 0x0DEB, "attach_model_override" },
    { 0x0DEC, "attach_or_link" },
    { 0x0DED, "attach_phone" },
    { 0x0DEE, "attach_player_current_weapon_to_anim_tag" },
    { 0x0DEF, "attach_player_current_weapon_to_rig" },
    { 0x0DF0, "attach_pointlight_to_beam" },
    { 0x0DF1, "attach_scanner" },
    { 0x0DF2, "attach_scanner_turret" },
    { 0x0DF3, "attach_tag" },
    { 0x0DF4, "attach_wakefx" },
    { 0x0DF5, "attach_weapon_to_tag_sync" },
    { 0x0DF6, "attachdistortionfx" },
    { 0x0DF7, "attachedguys" },
    { 0x0DF8, "attachedmodels" },
    { 0x0DF9, "attachedpath" },
    { 0x0DFA, "attachedpropmodel" },
    { 0x0DFB, "attachedproptag" },
    { 0x0DFC, "attachedusemodel" },
    { 0x0DFD, "attachflag" },
    { 0x0DFE, "attachgrenademodel" },
    { 0x0DFF, "attachhat" },
    { 0x0E00, "attachhead" },
    { 0x0E01, "attachmentdeath" },
    { 0x0E02, "attachmentexplode" },
    { 0x0E03, "attachmentmap_attachtoperk" },
    { 0x0E04, "attachmentmap_basetounique" },
    { 0x0E05, "attachmentmap_tobase" },
    { 0x0E06, "attachmentmap_tounique" },
    { 0x0E07, "attachmentmap_uniquetobase" },
    { 0x0E08, "attachmentperkmap" },
    { 0x0E09, "attachmenttype" },
    { 0x0E0A, "attachmissiles" },
    { 0x0E0B, "attachmodelti" },
    { 0x0E0C, "attachprops" },
    { 0x0E0D, "attachpropsfunction" },
    { 0x0E0E, "attachusemodel" },
    { 0x0E0F, "attachweapon" },
    { 0x0E10, "attack_accuracy" },
    { 0x0E11, "attack_available" },
    { 0x0E12, "attack_behavior" },
    { 0x0E13, "attack_damage_trigger" },
    { 0x0E14, "attack_delay" },
    { 0x0E15, "attack_drone_audio_handler" },
    { 0x0E16, "attack_drone_flybys_audio" },
    { 0x0E17, "attack_drone_formation_init" },
    { 0x0E18, "attack_drone_init" },
    { 0x0E19, "attack_drone_kamikaze_audio" },
    { 0x0E1A, "attack_drone_kamikaze_flying_fx" },
    { 0x0E1B, "attack_drone_queen_1shot_handler" },
    { 0x0E1C, "attack_drone_queen_audio" },
    { 0x0E1D, "attack_drone_queen_flybys_audio" },
    { 0x0E1E, "attack_drone_queen_flying_fx" },
    { 0x0E1F, "attack_drones_nofly_zone_radius" },
    { 0x0E20, "attack_drones_num_drones_per_queen" },
    { 0x0E21, "attack_drones_num_queens" },
    { 0x0E22, "attack_heli_cleanup" },
    { 0x0E23, "attack_heli_fx" },
    { 0x0E24, "attack_heli_safe_volumes" },
    { 0x0E25, "attack_hint_display" },
    { 0x0E26, "attack_if_buddy_killed" },
    { 0x0E27, "attack_origin_condition_threadd" },
    { 0x0E28, "attack_player_for_time" },
    { 0x0E29, "attack_sight_required" },
    { 0x0E2A, "attackback" },
    { 0x0E2B, "attacked_by_dog" },
    { 0x0E2C, "attacker_isonmyteam" },
    { 0x0E2D, "attacker_troop_isonmyteam" },
    { 0x0E2E, "attackercandamageitem" },
    { 0x0E2F, "attackerdata" },
    { 0x0E30, "attackerent" },
    { 0x0E31, "attackerinlaststand" },
    { 0x0E32, "attackerinremotekillstreak" },
    { 0x0E33, "attackerishittingteam" },
    { 0x0E34, "attackerlist" },
    { 0x0E35, "attackeronground" },
    { 0x0E36, "attackerposition" },
    { 0x0E37, "attackers" },
    { 0x0E38, "attackerstance" },
    { 0x0E39, "attackertable" },
    { 0x0E3A, "attackheliaiburstsize" },
    { 0x0E3B, "attackheliexcluders" },
    { 0x0E3C, "attackhelifov" },
    { 0x0E3D, "attackheligraceperiod" },
    { 0x0E3E, "attackhelikillsai" },
    { 0x0E3F, "attackhelimemory" },
    { 0x0E40, "attackhelimovetime" },
    { 0x0E41, "attackheliplayerbreak" },
    { 0x0E42, "attackhelirange" },
    { 0x0E43, "attackhelitargetreaquire" },
    { 0x0E44, "attackhelitimeout" },
    { 0x0E45, "attacking_player" },
    { 0x0E46, "attackmiss" },
    { 0x0E47, "attackmisstracktargetthread" },
    { 0x0E48, "attacknode" },
    { 0x0E49, "attacknothingtodo" },
    { 0x0E4A, "attackoffset" },
    { 0x0E4B, "attackradius" },
    { 0x0E4C, "attackradiussq" },
    { 0x0E4D, "attackstate" },
    { 0x0E4E, "attacksuppressableenemy" },
    { 0x0E4F, "attackteleportthread" },
    { 0x0E50, "attackvisibleenemy" },
    { 0x0E51, "attackzheight" },
    { 0x0E52, "attackzheightdown" },
    { 0x0E53, "attempt_execute" },
    { 0x0E54, "attempt_mark_enemy" },
    { 0x0E55, "attract_range" },
    { 0x0E56, "attract_strength" },
    { 0x0E57, "attractor" },
    { 0x0E58, "attractor2" },
    { 0x0E59, "attractornumber" },
    { 0x0E5A, "aud" },
    { 0x0E5B, "aud_2b_missile_final" },
    { 0x0E5C, "aud_2b_missile1" },
    { 0x0E5D, "aud_2b_missile2" },
    { 0x0E5E, "aud_2b_missile3" },
    { 0x0E5F, "aud_ac_units" },
    { 0x0E60, "aud_add_progress_map" },
    { 0x0E61, "aud_alarm_submix" },
    { 0x0E62, "aud_ally_card_accept" },
    { 0x0E63, "aud_ally_card_error" },
    { 0x0E64, "aud_ally_card_swipe" },
    { 0x0E65, "aud_ambient_animations" },
    { 0x0E66, "aud_ambient_helicopter" },
    { 0x0E67, "aud_approaching_poolhouse" },
    { 0x0E68, "aud_ascent_final_warbird" },
    { 0x0E69, "aud_atlas_suv_explo" },
    { 0x0E6A, "aud_autopsy_entrance" },
    { 0x0E6B, "aud_autopsy_entrance_vo" },
    { 0x0E6C, "aud_autopsy_knife_pry_door" },
    { 0x0E6D, "aud_avs_enemy_warbird" },
    { 0x0E6E, "aud_avs_enemy_warbird_2" },
    { 0x0E6F, "aud_avs_enemy_warbird_grapple" },
    { 0x0E70, "aud_avs_intro_allies_1" },
    { 0x0E71, "aud_avs_intro_allies_2" },
    { 0x0E72, "aud_background_chatter" },
    { 0x0E73, "aud_background_chatter_gate" },
    { 0x0E74, "aud_balcony_aircraft_wait" },
    { 0x0E75, "aud_ball_fountain" },
    { 0x0E76, "aud_bet_exo_climb_gear_lt" },
    { 0x0E77, "aud_bet_exo_climb_gear_rt" },
    { 0x0E78, "aud_bet_exo_climb_hit_lt" },
    { 0x0E79, "aud_bet_exo_climb_hit_rt" },
    { 0x0E7A, "aud_bet_exo_climb_settle_lt" },
    { 0x0E7B, "aud_bet_exo_climb_settle_rt" },
    { 0x0E7C, "aud_bet_exo_climb_windup_lt" },
    { 0x0E7D, "aud_bet_exo_climb_windup_rt" },
    { 0x0E7E, "aud_big_gate_open_stage_1" },
    { 0x0E7F, "aud_big_gate_open_stage_2" },
    { 0x0E80, "aud_big_gate_pre_open" },
    { 0x0E81, "aud_big_gate_stop_stage_1" },
    { 0x0E82, "aud_big_gate_stop_stage_2" },
    { 0x0E83, "aud_briefing" },
    { 0x0E84, "aud_building_drop" },
    { 0x0E85, "aud_building_pre_drop" },
    { 0x0E86, "aud_burke_bus1_land" },
    { 0x0E87, "aud_burke_hill_slide_stump" },
    { 0x0E88, "aud_burke_intro_anim" },
    { 0x0E89, "aud_burke_ledge_jump" },
    { 0x0E8A, "aud_burke_nearing_cliff" },
    { 0x0E8B, "aud_burke_open_door" },
    { 0x0E8C, "aud_burke_river_over_log" },
    { 0x0E8D, "aud_burke_riverbank_footstep_left" },
    { 0x0E8E, "aud_burke_riverbank_footstep_right" },
    { 0x0E8F, "aud_burke_riverbank_slide" },
    { 0x0E90, "aud_burke_step_over_log" },
    { 0x0E91, "aud_burke_stumble_knee" },
    { 0x0E92, "aud_burke_stumble_run" },
    { 0x0E93, "aud_burke_takedown" },
    { 0x0E94, "aud_burke_tree_cover_01" },
    { 0x0E95, "aud_burke_wall_climb" },
    { 0x0E96, "aud_burke_water_deep_step" },
    { 0x0E97, "aud_burke_water_enter" },
    { 0x0E98, "aud_burke_water_exit" },
    { 0x0E99, "aud_burke_water_fall_forward" },
    { 0x0E9A, "aud_burke_water_footstep_left" },
    { 0x0E9B, "aud_burke_water_footstep_right" },
    { 0x0E9C, "aud_burke_water_jump" },
    { 0x0E9D, "aud_burke_water_shallow_step" },
    { 0x0E9E, "aud_burke_water_slip" },
    { 0x0E9F, "aud_cap_45_onearm_toss" },
    { 0x0EA0, "aud_cap_escape_to_heli_truck_1" },
    { 0x0EA1, "aud_cap_escape_to_heli_truck_2" },
    { 0x0EA2, "aud_cap_heli_sfx_01" },
    { 0x0EA3, "aud_cap_heli_sfx_02" },
    { 0x0EA4, "aud_cap_heli_sfx_03" },
    { 0x0EA5, "aud_cap_heli_sfx_04" },
    { 0x0EA6, "aud_cap_heli_sfx_05" },
    { 0x0EA7, "aud_cap_heli_sfx_06" },
    { 0x0EA8, "aud_cap_interrogation_transition_vo" },
    { 0x0EA9, "aud_cap_s2_trolley_sfx_01" },
    { 0x0EAA, "aud_cap_s2_trolley_sfx_02" },
    { 0x0EAB, "aud_cap_s2_trolley_sfx_03" },
    { 0x0EAC, "aud_cap_s2_trolley_sfx_03_crk" },
    { 0x0EAD, "aud_cap_s2_trolley_sfx_04" },
    { 0x0EAE, "aud_cap_s2_trolley_sfx_05" },
    { 0x0EAF, "aud_cap_s2_trolley_sfx_06" },
    { 0x0EB0, "aud_cap_s2_trolley_sfx_07" },
    { 0x0EB1, "aud_cap_s2_trolley_sfx_08" },
    { 0x0EB2, "aud_cap_s2_trolley_sfx_09" },
    { 0x0EB3, "aud_cap_s2_trolley_sfx_10" },
    { 0x0EB4, "aud_cap_sml_onearm_toss" },
    { 0x0EB5, "aud_captured_foley_override_handler" },
    { 0x0EB6, "aud_captured_setup_anims" },
    { 0x0EB7, "aud_cave_ambience" },
    { 0x0EB8, "aud_cave_cascade" },
    { 0x0EB9, "aud_check_sound_done" },
    { 0x0EBA, "aud_chopper_sniper_bullet" },
    { 0x0EBB, "aud_chopper_sniper_whizby" },
    { 0x0EBC, "aud_clamp" },
    { 0x0EBD, "aud_clear_sticky_threat" },
    { 0x0EBE, "aud_close_sounds" },
    { 0x0EBF, "aud_combat_clearing_1_warbird" },
    { 0x0EC0, "aud_combat_clearing_2_littlebird_1" },
    { 0x0EC1, "aud_combat_clearing_2_littlebird_2" },
    { 0x0EC2, "aud_combat_clearing_3_littlebird_1" },
    { 0x0EC3, "aud_combat_clearing_3_littlebird_2" },
    { 0x0EC4, "aud_conduit_smash" },
    { 0x0EC5, "aud_copy_vector" },
    { 0x0EC6, "aud_cormack_approach" },
    { 0x0EC7, "aud_cormack_final_monitor_smash" },
    { 0x0EC8, "aud_cormack_final_smash_promo" },
    { 0x0EC9, "aud_cormack_grapple_kill" },
    { 0x0ECA, "aud_cormack_monitor_smash_promo" },
    { 0x0ECB, "aud_cormack_rappel_cable" },
    { 0x0ECC, "aud_courtyard_hangar_door_close" },
    { 0x0ECD, "aud_courtyard_hangar_door_hack" },
    { 0x0ECE, "aud_courtyard_hangar_door_hack_idle" },
    { 0x0ECF, "aud_courtyard_hangar_door_open" },
    { 0x0ED0, "aud_crane_mount_crouch_jump" },
    { 0x0ED1, "aud_crane_mount_lt_hand_hit" },
    { 0x0ED2, "aud_crane_mount_lt_hand_rest" },
    { 0x0ED3, "aud_crane_mount_rt_hand_hit" },
    { 0x0ED4, "aud_crane_mount_rt_hand_rest" },
    { 0x0ED5, "aud_crash_wakeup_sfx" },
    { 0x0ED6, "aud_create_drive_envs" },
    { 0x0ED7, "aud_create_entity" },
    { 0x0ED8, "aud_create_linked_entity" },
    { 0x0ED9, "aud_ctyard_vrap01" },
    { 0x0EDA, "aud_ctyard_vrap02" },
    { 0x0EDB, "aud_ctyard_vrap04" },
    { 0x0EDC, "aud_ctyard_vrap05" },
    { 0x0EDD, "aud_delete_on_sounddone" },
    { 0x0EDE, "aud_destroy_deployed_pod" },
    { 0x0EDF, "aud_det_foley_override_handler" },
    { 0x0EE0, "aud_detach_from_vtol" },
    { 0x0EE1, "aud_disable_deathsdoor_audio" },
    { 0x0EE2, "aud_dna_bomb_01" },
    { 0x0EE3, "aud_dna_bomb_02" },
    { 0x0EE4, "aud_door" },
    { 0x0EE5, "aud_door_takedown_mix_handler" },
    { 0x0EE6, "aud_door_takedown_scream" },
    { 0x0EE7, "aud_drone_attack" },
    { 0x0EE8, "aud_drone_investigating" },
    { 0x0EE9, "aud_drone_start_jets" },
    { 0x0EEA, "aud_drone_view_intro_start" },
    { 0x0EEB, "aud_drone_view_intro_target" },
    { 0x0EEC, "aud_drop_pod_fire" },
    { 0x0EED, "aud_drop_pod_land_fail" },
    { 0x0EEE, "aud_drop_pod_land_success" },
    { 0x0EEF, "aud_drop_pod_trophy_kill" },
    { 0x0EF0, "aud_duck" },
    { 0x0EF1, "aud_dyanmic_event" },
    { 0x0EF2, "aud_dynamic_event_startup" },
    { 0x0EF3, "aud_enable_deathsdoor_audio" },
    { 0x0EF4, "aud_engine_disable" },
    { 0x0EF5, "aud_engine_throttle_amount" },
    { 0x0EF6, "aud_engine_wait" },
    { 0x0EF7, "aud_enter_vtol" },
    { 0x0EF8, "aud_escape_doctor_bodybag" },
    { 0x0EF9, "aud_escape_give_gun_exo" },
    { 0x0EFA, "aud_escape_guard_takedown_door" },
    { 0x0EFB, "aud_escape_keycard" },
    { 0x0EFC, "aud_estate_grounds_ambience" },
    { 0x0EFD, "aud_estate_grounds_emitters" },
    { 0x0EFE, "aud_estate_living_ambience" },
    { 0x0EFF, "aud_estate_security_ambience" },
    { 0x0F00, "aud_exfil_door_1" },
    { 0x0F01, "aud_exfil_door_2a" },
    { 0x0F02, "aud_exfil_door_2b" },
    { 0x0F03, "aud_exfil_vtol_ascend" },
    { 0x0F04, "aud_exfil_vtol_grapple" },
    { 0x0F05, "aud_exfil_vtol_start" },
    { 0x0F06, "aud_exfil_vtol_wind" },
    { 0x0F07, "aud_exit_vtol" },
    { 0x0F08, "aud_exo_climb_burke" },
    { 0x0F09, "aud_exo_climb_flank_land" },
    { 0x0F0A, "aud_exo_climb_flank_over" },
    { 0x0F0B, "aud_exo_climb_gear_lt" },
    { 0x0F0C, "aud_exo_climb_gear_rt" },
    { 0x0F0D, "aud_exo_climb_gideon_land" },
    { 0x0F0E, "aud_exo_climb_hit_lt" },
    { 0x0F0F, "aud_exo_climb_hit_rt" },
    { 0x0F10, "aud_exo_climb_mount_jump" },
    { 0x0F11, "aud_exo_climb_mount_land" },
    { 0x0F12, "aud_exo_climb_rest_lt" },
    { 0x0F13, "aud_exo_climb_rest_rt" },
    { 0x0F14, "aud_exo_climb_slide_push" },
    { 0x0F15, "aud_exo_climb_slide_start" },
    { 0x0F16, "aud_exo_climb_slide_stop" },
    { 0x0F17, "aud_exo_climb_windup_lt" },
    { 0x0F18, "aud_exo_climb_windup_rt" },
    { 0x0F19, "aud_facility_breach_start" },
    { 0x0F1A, "aud_fade_in" },
    { 0x0F1B, "aud_fade_in_music" },
    { 0x0F1C, "aud_fade_loop_out_and_delete" },
    { 0x0F1D, "aud_fade_loop_out_and_delete_temp" },
    { 0x0F1E, "aud_fade_out" },
    { 0x0F1F, "aud_fade_out_and_delete" },
    { 0x0F20, "aud_fadeup_intro_loop" },
    { 0x0F21, "aud_fall_scream" },
    { 0x0F22, "aud_falls_climbing" },
    { 0x0F23, "aud_fin_rocket_damage_vfx" },
    { 0x0F24, "aud_find_exploder" },
    { 0x0F25, "aud_flag_handler" },
    { 0x0F26, "aud_foam_room_emitters" },
    { 0x0F27, "aud_foliage_insects" },
    { 0x0F28, "aud_foliage_mix" },
    { 0x0F29, "aud_foliage_movement" },
    { 0x0F2A, "aud_forest_ambience" },
    { 0x0F2B, "aud_forest_ambient_loops" },
    { 0x0F2C, "aud_fountains" },
    { 0x0F2D, "aud_garage_hyd_wrench" },
    { 0x0F2E, "aud_garage_lift" },
    { 0x0F2F, "aud_gas_sfx" },
    { 0x0F30, "aud_get_ambi_submix" },
    { 0x0F31, "aud_get_envelope_domain" },
    { 0x0F32, "aud_get_music_submix" },
    { 0x0F33, "aud_get_optional_param" },
    { 0x0F34, "aud_get_player_locamote_state" },
    { 0x0F35, "aud_get_progress_map" },
    { 0x0F36, "aud_get_sticky_threat" },
    { 0x0F37, "aud_get_threat_level" },
    { 0x0F38, "aud_gideon_autopsy_halls_start" },
    { 0x0F39, "aud_gideon_heli_runout_kick" },
    { 0x0F3A, "aud_gideon_heli_runout_start" },
    { 0x0F3B, "aud_gideon_test_chamber_ascend_start" },
    { 0x0F3C, "aud_gideon_test_chamber_bodybag_1" },
    { 0x0F3D, "aud_gideon_test_chamber_bodybag_2" },
    { 0x0F3E, "aud_gideon_test_chamber_climb_stairs_1" },
    { 0x0F3F, "aud_gideon_test_chamber_climb_stairs_2" },
    { 0x0F40, "aud_gideon_test_chamber_descend_stairs" },
    { 0x0F41, "aud_gideon_test_chamber_descend_stairs_2" },
    { 0x0F42, "aud_gideon_test_chamber_door_kick" },
    { 0x0F43, "aud_gideon_test_chamber_security" },
    { 0x0F44, "aud_gideon_test_chamber_stair_door" },
    { 0x0F45, "aud_grapple_from_foliage" },
    { 0x0F46, "aud_grapple_infil" },
    { 0x0F47, "aud_grapple_kill_foliage" },
    { 0x0F48, "aud_grapple_land_debris" },
    { 0x0F49, "aud_grapple_launch" },
    { 0x0F4A, "aud_grapple_monitor" },
    { 0x0F4B, "aud_grates" },
    { 0x0F4C, "aud_ground_veh_deathwatch" },
    { 0x0F4D, "aud_ground_veh_loops" },
    { 0x0F4E, "aud_ground_veh_speed_mapping" },
    { 0x0F4F, "aud_guard_station_ambience" },
    { 0x0F50, "aud_guard_station_main_door" },
    { 0x0F51, "aud_guardhouse_foley_cormack" },
    { 0x0F52, "aud_gun_throw_logic" },
    { 0x0F53, "aud_handle_alarms" },
    { 0x0F54, "aud_handle_buoy_sfx" },
    { 0x0F55, "aud_handle_clearing_dambs" },
    { 0x0F56, "aud_handle_earthquake" },
    { 0x0F57, "aud_handle_gangam_jets" },
    { 0x0F58, "aud_handle_incoming" },
    { 0x0F59, "aud_handle_map_setups" },
    { 0x0F5A, "aud_handle_river_progress_flags" },
    { 0x0F5B, "aud_handle_river_sfx" },
    { 0x0F5C, "aud_handle_river_shallow_flag" },
    { 0x0F5D, "aud_handle_so_missile" },
    { 0x0F5E, "aud_handle_vista_jets" },
    { 0x0F5F, "aud_handle_warning_vo" },
    { 0x0F60, "aud_handle_wave_incoming" },
    { 0x0F61, "aud_handle_waves_crash" },
    { 0x0F62, "aud_hangar_ambience" },
    { 0x0F63, "aud_hangar_car_door_exit" },
    { 0x0F64, "aud_hangar_door_exit" },
    { 0x0F65, "aud_hangar_door_open" },
    { 0x0F66, "aud_hangar_walla" },
    { 0x0F67, "aud_hatch_gideon" },
    { 0x0F68, "aud_hatch_plr" },
    { 0x0F69, "aud_hazmat_guy_foley" },
    { 0x0F6A, "aud_hazmat_guy_pushes_alarm" },
    { 0x0F6B, "aud_heli_battle_flyover" },
    { 0x0F6C, "aud_heli_crash_pos" },
    { 0x0F6D, "aud_heli_escape_idle_sfx" },
    { 0x0F6E, "aud_heli_manticore_flyover" },
    { 0x0F6F, "aud_helicopter_deathwatch" },
    { 0x0F70, "aud_helo_spotlight_spawn" },
    { 0x0F71, "aud_hostage_truck_hits_water" },
    { 0x0F72, "aud_hostage_truck_over_curb" },
    { 0x0F73, "aud_hostage_truck_over_edge" },
    { 0x0F74, "aud_hostage_truck_tbone" },
    { 0x0F75, "aud_human_activity_streams" },
    { 0x0F76, "aud_ilana_carmack_escape_controlroom" },
    { 0x0F77, "aud_ilana_carmack_escape_controlroom_attack" },
    { 0x0F78, "aud_ilana_carmack_escape_hallway" },
    { 0x0F79, "aud_ilana_carmack_escape_hallway_end" },
    { 0x0F7A, "aud_ilana_carmack_escape_takedown" },
    { 0x0F7B, "aud_ilana_carmack_rescue_01" },
    { 0x0F7C, "aud_impact_monitor" },
    { 0x0F7D, "aud_impact_system_diveboat" },
    { 0x0F7E, "aud_impact_system_hovertank" },
    { 0x0F7F, "aud_impact_system_jetbike" },
    { 0x0F80, "aud_in_zone" },
    { 0x0F81, "aud_incin_after" },
    { 0x0F82, "aud_incin_after_loop1" },
    { 0x0F83, "aud_incin_amb_kill" },
    { 0x0F84, "aud_incin_blackout" },
    { 0x0F85, "aud_incin_cart_done" },
    { 0x0F86, "aud_incin_cart_push" },
    { 0x0F87, "aud_incin_cart_push_stop" },
    { 0x0F88, "aud_incin_cart_start" },
    { 0x0F89, "aud_incin_flame_logic_first_burst" },
    { 0x0F8A, "aud_incin_flame_loop" },
    { 0x0F8B, "aud_incin_flame_loop_2" },
    { 0x0F8C, "aud_incin_pilot_light" },
    { 0x0F8D, "aud_incin_pilot_light1" },
    { 0x0F8E, "aud_incin_pilot_light2" },
    { 0x0F8F, "aud_incin_pilot_light3" },
    { 0x0F90, "aud_incin_pilot_light4" },
    { 0x0F91, "aud_incin_pilot_light5" },
    { 0x0F92, "aud_incin_pipe_burst" },
    { 0x0F93, "aud_incin_pipe_grab" },
    { 0x0F94, "aud_init" },
    { 0x0F95, "aud_insect_sound" },
    { 0x0F96, "aud_intel" },
    { 0x0F97, "aud_interrogation_music_pt1" },
    { 0x0F98, "aud_interrogation_music_pt2" },
    { 0x0F99, "aud_interrogation_scene" },
    { 0x0F9A, "aud_into_mech_missle" },
    { 0x0F9B, "aud_intro_caravan_mute" },
    { 0x0F9C, "aud_intro_caravan_passby" },
    { 0x0F9D, "aud_intro_caravan_unmute" },
    { 0x0F9E, "aud_intro_drone" },
    { 0x0F9F, "aud_intro_foley" },
    { 0x0FA0, "aud_intro_heli_flyover" },
    { 0x0FA1, "aud_intro_to_elev_walla" },
    { 0x0FA2, "aud_intro_truck_gate" },
    { 0x0FA3, "aud_intro_truck_passby_01" },
    { 0x0FA4, "aud_intro_truck_passby_02" },
    { 0x0FA5, "aud_intro_truck_stop" },
    { 0x0FA6, "aud_introblack_bullet" },
    { 0x0FA7, "aud_irons_reveal_bomb_shake" },
    { 0x0FA8, "aud_irons_reveal_bomb_shake_02" },
    { 0x0FA9, "aud_irons_reveal_star_trek_door" },
    { 0x0FAA, "aud_irons_says_hello" },
    { 0x0FAB, "aud_ironsstealth" },
    { 0x0FAC, "aud_is_even" },
    { 0x0FAD, "aud_is_specops" },
    { 0x0FAE, "aud_jeep_death_listener" },
    { 0x0FAF, "aud_knox_keypad" },
    { 0x0FB0, "aud_knox_thermite" },
    { 0x0FB1, "aud_knox_thermite_promo" },
    { 0x0FB2, "aud_lab_ambient_emitters" },
    { 0x0FB3, "aud_lab_foley_override_handler" },
    { 0x0FB4, "aud_lab_intro_screen" },
    { 0x0FB5, "aud_lab_phone_wait" },
    { 0x0FB6, "aud_lab_tech_chair_startle_1" },
    { 0x0FB7, "aud_lab_tech_chair_startle_2" },
    { 0x0FB8, "aud_lab_tech_desk_bump" },
    { 0x0FB9, "aud_laser_energy_beam_start" },
    { 0x0FBA, "aud_laser_pre_move_down" },
    { 0x0FBB, "aud_last_time" },
    { 0x0FBC, "aud_level_fadein" },
    { 0x0FBD, "aud_limp_exo" },
    { 0x0FBE, "aud_limp_off" },
    { 0x0FBF, "aud_limp_on" },
    { 0x0FC0, "aud_little_bird_hit" },
    { 0x0FC1, "aud_lockdown_alarm" },
    { 0x0FC2, "aud_lowstealth" },
    { 0x0FC3, "aud_manticore_crane" },
    { 0x0FC4, "aud_max" },
    { 0x0FC5, "aud_mech_crush_guy" },
    { 0x0FC6, "aud_mech_grapple_pitch_up" },
    { 0x0FC7, "aud_mech_idle_sfx" },
    { 0x0FC8, "aud_mech_jump" },
    { 0x0FC9, "aud_mech_missile_fire" },
    { 0x0FCA, "aud_mech_obj_move" },
    { 0x0FCB, "aud_mech_obj_move_end" },
    { 0x0FCC, "aud_mech_obj_move_wait" },
    { 0x0FCD, "aud_mech_panic_walla_watcher" },
    { 0x0FCE, "aud_mech_scanner" },
    { 0x0FCF, "aud_mech_trucks_enter" },
    { 0x0FD0, "aud_mech1_bg_truck" },
    { 0x0FD1, "aud_mechkill_catchdude" },
    { 0x0FD2, "aud_median_impact" },
    { 0x0FD3, "aud_meet_atlast_roof_explode" },
    { 0x0FD4, "aud_microwave_grenade" },
    { 0x0FD5, "aud_microwave_grenade_sparks_dude" },
    { 0x0FD6, "aud_microwave_grenade_sparks_env" },
    { 0x0FD7, "aud_min" },
    { 0x0FD8, "aud_monitor_irons" },
    { 0x0FD9, "aud_morgue_bodybag_doors" },
    { 0x0FDA, "aud_morgue_bodybag_line_emt" },
    { 0x0FDB, "aud_morgue_computer_door_entry_sfx" },
    { 0x0FDC, "aud_mus_boost" },
    { 0x0FDD, "aud_music_state" },
    { 0x0FDE, "aud_num_alive_enemies" },
    { 0x0FDF, "aud_observation_guard_radio" },
    { 0x0FE0, "aud_old_music_state" },
    { 0x0FE1, "aud_onearm_weapon_swap" },
    { 0x0FE2, "aud_overrides" },
    { 0x0FE3, "aud_pa_announc_01" },
    { 0x0FE4, "aud_pa_announc_02" },
    { 0x0FE5, "aud_pa_announc_03" },
    { 0x0FE6, "aud_pa_announc_04" },
    { 0x0FE7, "aud_painting_fall" },
    { 0x0FE8, "aud_panic_walla" },
    { 0x0FE9, "aud_patching_in_foley" },
    { 0x0FEA, "aud_patrol_helo_debris_sfx" },
    { 0x0FEB, "aud_penthouse_front_door" },
    { 0x0FEC, "aud_percent_chance" },
    { 0x0FED, "aud_piston_ent" },
    { 0x0FEE, "aud_pitbull_crash_concussion" },
    { 0x0FEF, "aud_play" },
    { 0x0FF0, "aud_play_announcer_warning" },
    { 0x0FF1, "aud_play_distance_attenuated_2d" },
    { 0x0FF2, "aud_play_dust" },
    { 0x0FF3, "aud_play_dynamic_explosion" },
    { 0x0FF4, "aud_play_horror_ambience" },
    { 0x0FF5, "aud_play_laser_move_down" },
    { 0x0FF6, "aud_play_laser_move_up" },
    { 0x0FF7, "aud_play_line_emitter" },
    { 0x0FF8, "aud_play_pcap_vo" },
    { 0x0FF9, "aud_play_pod_impact" },
    { 0x0FFA, "aud_play_point_source_loop" },
    { 0x0FFB, "aud_play_rocket_travel_loops" },
    { 0x0FFC, "aud_play_tank_explosion" },
    { 0x0FFD, "aud_play_trophy_fire" },
    { 0x0FFE, "aud_player_bus_exo_jump" },
    { 0x0FFF, "aud_player_bus_exo_land" },
    { 0x1000, "aud_player_bus_jump_handplant" },
    { 0x1001, "aud_player_bus_land" },
    { 0x1002, "aud_player_bus1_exo_land" },
    { 0x1003, "aud_player_bus1_land" },
    { 0x1004, "aud_player_climb_foley" },
    { 0x1005, "aud_player_climb_to_ledge" },
    { 0x1006, "aud_player_computer" },
    { 0x1007, "aud_player_computer_gl_timing_fix" },
    { 0x1008, "aud_player_computer_promo" },
    { 0x1009, "aud_player_exo_punch_driver" },
    { 0x100A, "aud_player_exo_punch_metal_plate" },
    { 0x100B, "aud_player_gets_in_tank" },
    { 0x100C, "aud_player_grab_mirror" },
    { 0x100D, "aud_player_hill_slide" },
    { 0x100E, "aud_player_jump_back_to_bus" },
    { 0x100F, "aud_player_jump_to_truck" },
    { 0x1010, "aud_player_land_back_on_bus" },
    { 0x1011, "aud_player_land_on_truck" },
    { 0x1012, "aud_player_rappel_complete" },
    { 0x1013, "aud_player_throw_driver" },
    { 0x1014, "aud_player_throw_metal_plate" },
    { 0x1015, "aud_player_wall_climb_01" },
    { 0x1016, "aud_player_wall_climb_02" },
    { 0x1017, "aud_player_wall_climb_03" },
    { 0x1018, "aud_player_wall_climb_04" },
    { 0x1019, "aud_player_wall_climb_05" },
    { 0x101A, "aud_playermech_end" },
    { 0x101B, "aud_playermech_foley_override_handler" },
    { 0x101C, "aud_playermech_start" },
    { 0x101D, "aud_plr_hit" },
    { 0x101E, "aud_plr_hit_vo_line" },
    { 0x101F, "aud_plr_hit_vo_look" },
    { 0x1020, "aud_plr_hit_vo_move_back" },
    { 0x1021, "aud_plr_hit_vo_move_forward" },
    { 0x1022, "aud_plr_inside_mech" },
    { 0x1023, "aud_pod_arm_reach" },
    { 0x1024, "aud_pod_hits_ground" },
    { 0x1025, "aud_pod_hits_ground_corrected" },
    { 0x1026, "aud_pod_scene_begin" },
    { 0x1027, "aud_pod_turbulence_01" },
    { 0x1028, "aud_pod_turbulence_02" },
    { 0x1029, "aud_poolhouse_ambience" },
    { 0x102A, "aud_post_courtyard_emitters" },
    { 0x102B, "aud_print" },
    { 0x102C, "aud_print_3d_on_ent" },
    { 0x102D, "aud_print_debug" },
    { 0x102E, "aud_print_error" },
    { 0x102F, "aud_print_synch" },
    { 0x1030, "aud_print_warning" },
    { 0x1031, "aud_print_zone" },
    { 0x1032, "aud_print_zone_small" },
    { 0x1033, "aud_rappel_player_hookup" },
    { 0x1034, "aud_rappel_player_movement_start" },
    { 0x1035, "aud_rappel_player_movement_stop" },
    { 0x1036, "aud_reached_penthouse" },
    { 0x1037, "aud_ready_hooks" },
    { 0x1038, "aud_recon_foley" },
    { 0x1039, "aud_red_light" },
    { 0x103A, "aud_reinforcements_door1" },
    { 0x103B, "aud_reinforcements_door2" },
    { 0x103C, "aud_rescue_drone" },
    { 0x103D, "aud_rescue_sfx_a" },
    { 0x103E, "aud_rescue_sfx_b" },
    { 0x103F, "aud_rescue_sfx_c" },
    { 0x1040, "aud_rescue_sfx_d" },
    { 0x1041, "aud_rescue_sfx_e" },
    { 0x1042, "aud_rescue_sfx_f" },
    { 0x1043, "aud_rescue_sfx_g" },
    { 0x1044, "aud_rocket_launch_start" },
    { 0x1045, "aud_rocket_stage_01_start" },
    { 0x1046, "aud_rooftop_warbird_departing" },
    { 0x1047, "aud_rooftop_wind_volume" },
    { 0x1048, "aud_rooftops_ambience" },
    { 0x1049, "aud_rotate_vector_yaw" },
    { 0x104A, "aud_run_tank_system" },
    { 0x104B, "aud_s1_elevator_boss_foley" },
    { 0x104C, "aud_s1_elevator_cormack_foley" },
    { 0x104D, "aud_s1_elevator_guard_foley" },
    { 0x104E, "aud_s1_elevator_kick_1" },
    { 0x104F, "aud_s1_elevator_kick_2" },
    { 0x1050, "aud_s2walk_alarm_tone_lp" },
    { 0x1051, "aud_s2walk_cell_prisoners" },
    { 0x1052, "aud_s2walk_cells_foley_mix" },
    { 0x1053, "aud_s2walk_clear_foley_mix" },
    { 0x1054, "aud_s2walk_cormack_punched" },
    { 0x1055, "aud_s2walk_door_close" },
    { 0x1056, "aud_s2walk_door_open" },
    { 0x1057, "aud_s2walk_emitters" },
    { 0x1058, "aud_s2walk_execution_fire" },
    { 0x1059, "aud_s2walk_execution_kneeling_prisoners" },
    { 0x105A, "aud_s2walk_flyby_1" },
    { 0x105B, "aud_s2walk_guard_3_foley_01" },
    { 0x105C, "aud_s2walk_guard_3_foley_02" },
    { 0x105D, "aud_s2walk_guard_hip_radio" },
    { 0x105E, "aud_s2walk_guard_radios" },
    { 0x105F, "aud_s2walk_ilona_push" },
    { 0x1060, "aud_s2walk_loudspeaker2_line1" },
    { 0x1061, "aud_s2walk_loudspeaker2_line2" },
    { 0x1062, "aud_s2walk_prisoner_2_beating" },
    { 0x1063, "aud_s2walk_start_cormack_foley" },
    { 0x1064, "aud_s2walk_start_gideon_bodyfall" },
    { 0x1065, "aud_s2walk_start_gideon_foley" },
    { 0x1066, "aud_s2walk_start_guard_1_foley" },
    { 0x1067, "aud_s2walk_start_guard_1_grabpush" },
    { 0x1068, "aud_s2walk_start_guard_2_foley" },
    { 0x1069, "aud_s2walk_start_guard_2_grab" },
    { 0x106A, "aud_s2walk_start_guard_2_grabpush" },
    { 0x106B, "aud_s2walk_start_guard_2_push" },
    { 0x106C, "aud_s2walk_start_guard_3_foley" },
    { 0x106D, "aud_s2walk_start_guard_3_walkup_foley" },
    { 0x106E, "aud_s2walk_start_ilona_foley" },
    { 0x106F, "aud_s2walk_start_player_foley" },
    { 0x1070, "aud_s2walk_temp_guard_vo" },
    { 0x1071, "aud_s2walk_trigger_start" },
    { 0x1072, "aud_s2walk_yard_prisoners_whimpering" },
    { 0x1073, "aud_s3escape_doctor_radio" },
    { 0x1074, "aud_scale_envelope" },
    { 0x1075, "aud_scale_vector" },
    { 0x1076, "aud_scale_vector_2d" },
    { 0x1077, "aud_scanner_door_open" },
    { 0x1078, "aud_security_alarm" },
    { 0x1079, "aud_security_center_drones_on" },
    { 0x107A, "aud_security_countdown" },
    { 0x107B, "aud_security_hatch_exit" },
    { 0x107C, "aud_security_main_screen" },
    { 0x107D, "aud_security_plant_emp" },
    { 0x107E, "aud_security_prints" },
    { 0x107F, "aud_security_reboot" },
    { 0x1080, "aud_security_vent" },
    { 0x1081, "aud_security_welcome" },
    { 0x1082, "aud_separation_door" },
    { 0x1083, "aud_separation_elevator" },
    { 0x1084, "aud_separation_logic" },
    { 0x1085, "aud_server_room_door_crack" },
    { 0x1086, "aud_server_room_door_enter" },
    { 0x1087, "aud_server_room_door_kick" },
    { 0x1088, "aud_server_room_thermite" },
    { 0x1089, "aud_server_thermite_burn_loop" },
    { 0x108A, "aud_server_thermite_burn_start" },
    { 0x108B, "aud_server_thermite_out" },
    { 0x108C, "aud_set_ambi_submix" },
    { 0x108D, "aud_set_level_fade_time" },
    { 0x108E, "aud_set_mission_failed_music" },
    { 0x108F, "aud_set_music_submix" },
    { 0x1090, "aud_set_point_source_loop_volume" },
    { 0x1091, "aud_set_spec_ops" },
    { 0x1092, "aud_set_sticky_threat" },
    { 0x1093, "aud_set_timescale" },
    { 0x1094, "aud_setup_drop_pod_loop" },
    { 0x1095, "aud_shack_explode" },
    { 0x1096, "aud_shack_explode_whizby" },
    { 0x1097, "aud_slomo_wait" },
    { 0x1098, "aud_smooth" },
    { 0x1099, "aud_sonar_vision_off" },
    { 0x109A, "aud_sonar_vision_on" },
    { 0x109B, "aud_spark_1" },
    { 0x109C, "aud_spark_2" },
    { 0x109D, "aud_spark_3" },
    { 0x109E, "aud_spark_4" },
    { 0x109F, "aud_spark_5" },
    { 0x10A0, "aud_sprinklers" },
    { 0x10A1, "aud_start_dna_events" },
    { 0x10A2, "aud_start_dna_events_cg" },
    { 0x10A3, "aud_start_exfil_foley" },
    { 0x10A4, "aud_start_nyse_fire" },
    { 0x10A5, "aud_start_slow_mo_gunshot_callback" },
    { 0x10A6, "aud_stealth_broken_timer" },
    { 0x10A7, "aud_stealth_melee" },
    { 0x10A8, "aud_stop_and_delete_ent" },
    { 0x10A9, "aud_stop_cormack_foley" },
    { 0x10AA, "aud_stop_headspace_ambience" },
    { 0x10AB, "aud_stop_horror_ambience" },
    { 0x10AC, "aud_stop_line_emitter" },
    { 0x10AD, "aud_stop_mech_panic_walla_watcher" },
    { 0x10AE, "aud_stop_mute_device_for_vo" },
    { 0x10AF, "aud_stop_point_source_loop" },
    { 0x10B0, "aud_stop_slow_mo_gunshot_callback" },
    { 0x10B1, "aud_stop_sound_logic" },
    { 0x10B2, "aud_stop_training_mute_device" },
    { 0x10B3, "aud_stop_vrap_mute_device" },
    { 0x10B4, "aud_table_pulldown" },
    { 0x10B5, "aud_tank_death_listener" },
    { 0x10B6, "aud_tank_field_littlebird" },
    { 0x10B7, "aud_tank_field_warbird" },
    { 0x10B8, "aud_tank_fire_watch" },
    { 0x10B9, "aud_tank_road_littlebird_1" },
    { 0x10BA, "aud_tank_road_littlebird_2" },
    { 0x10BB, "aud_tank_section_vehicles_handler" },
    { 0x10BC, "aud_tank_section_vehicles_spawned" },
    { 0x10BD, "aud_tanker_crash" },
    { 0x10BE, "aud_tanker_fall_down" },
    { 0x10BF, "aud_tennis_court_wakeup" },
    { 0x10C0, "aud_tire_splash" },
    { 0x10C1, "aud_titan_siege_mode_adj_left_side" },
    { 0x10C2, "aud_titan_siege_mode_adj_left_side_back" },
    { 0x10C3, "aud_titan_siege_mode_adj_right_side" },
    { 0x10C4, "aud_titan_siege_mode_adj_right_side_back" },
    { 0x10C5, "aud_training_s2_potus_ziptie_release" },
    { 0x10C6, "aud_transport_chopper" },
    { 0x10C7, "aud_trolley_music" },
    { 0x10C8, "aud_truck_dodge_slowmo_start" },
    { 0x10C9, "aud_truck_dodge_slowmo_whoosh" },
    { 0x10CA, "aud_truck_hits_divider" },
    { 0x10CB, "aud_truck_hits_ground" },
    { 0x10CC, "aud_truck_jump_slowmo" },
    { 0x10CD, "aud_truck_punch_slowmo" },
    { 0x10CE, "aud_truck1_engine_pullup" },
    { 0x10CF, "aud_truck2_engine_drive" },
    { 0x10D0, "aud_truck2_engine_idle" },
    { 0x10D1, "aud_truck2_engine_pullup" },
    { 0x10D2, "aud_trucks_arrive" },
    { 0x10D3, "aud_turret_entry" },
    { 0x10D4, "aud_turrets_activate" },
    { 0x10D5, "aud_use_string_tables" },
    { 0x10D6, "aud_var_nade_type" },
    { 0x10D7, "aud_vector_magnitude_2d" },
    { 0x10D8, "aud_vehicle_ride_data" },
    { 0x10D9, "aud_vrap_mute_start" },
    { 0x10DA, "aud_vtol_excellerate_end" },
    { 0x10DB, "aud_vtol_excellerate_start" },
    { 0x10DC, "aud_vtol_exterior_idle" },
    { 0x10DD, "aud_vtol_land" },
    { 0x10DE, "aud_vtol_passed" },
    { 0x10DF, "aud_wait_delay" },
    { 0x10E0, "aud_wait_for_mission_fail_music" },
    { 0x10E1, "aud_wakeup_amb" },
    { 0x10E2, "aud_wakeup_mech_cooldown_pings" },
    { 0x10E3, "aud_wakeup_mix" },
    { 0x10E4, "aud_warehouse_mech_lift" },
    { 0x10E5, "aud_warehouse_mech_lift_alarm" },
    { 0x10E6, "aud_warehouse_mech_lift_vo" },
    { 0x10E7, "aud_warehouse_roof_machines" },
    { 0x10E8, "aud_warehouse_roof_machines_line" },
    { 0x10E9, "aud_warning_vo" },
    { 0x10EA, "aud_watch_for_anim_end" },
    { 0x10EB, "aud_water_footsteps_foley" },
    { 0x10EC, "aud_water_footsteps_override" },
    { 0x10ED, "aud_water_sound" },
    { 0x10EE, "aud_waterfall_ambience" },
    { 0x10EF, "aud_windmill_sniper_whizby" },
    { 0x10F0, "aud_zap_logic_change" },
    { 0x10F1, "aud_zap_scene" },
    { 0x10F2, "audiblesightplaying" },
    { 0x10F3, "audio" },
    { 0x10F4, "audio_buzzer_struct" },
    { 0x10F5, "audio_jet_counter" },
    { 0x10F6, "audio_monitor_chopper01_death" },
    { 0x10F7, "audio_monitor_chopper02_death" },
    { 0x10F8, "audio_org" },
    { 0x10F9, "audio_presets_music_cue_groups" },
    { 0x10FA, "audio_presets_music_cues" },
    { 0x10FB, "audio_presets_music_moods" },
    { 0x10FC, "audio_presets_vehicle_maps" },
    { 0x10FD, "audio_presets_vehicles" },
    { 0x10FE, "audio_push_1_box_drop" },
    { 0x10FF, "audio_push_1_box_pickup" },
    { 0x1100, "audio_push_1_box_push" },
    { 0x1101, "audio_push_1_crane_move_1" },
    { 0x1102, "audio_push_1_crane_move_2" },
    { 0x1103, "audio_push_1_crane_move_3" },
    { 0x1104, "audio_push_2_box_drop" },
    { 0x1105, "audio_push_2_box_pickup" },
    { 0x1106, "audio_push_2_box_push" },
    { 0x1107, "audio_push_2_crane_move_1" },
    { 0x1108, "audio_push_2_crane_move_2" },
    { 0x1109, "audio_push_2_crane_move_3" },
    { 0x110A, "audio_start_wrestling_exo_guy" },
    { 0x110B, "audio_start_wrestling_guy2" },
    { 0x110C, "audio_start_wrestling_guy3" },
    { 0x110D, "audio_start_wrestling_guy4" },
    { 0x110E, "audio_start_wrestling_guy5" },
    { 0x110F, "audio_stingers_school_bodies_room" },
    { 0x1110, "audio_stringtable_mapname" },
    { 0x1111, "audio_zones" },
    { 0x1112, "audx_attenuate" },
    { 0x1113, "audx_delete_on_sounddone_internal" },
    { 0x1114, "audx_do_dynamic_explosion_math" },
    { 0x1115, "audx_duck" },
    { 0x1116, "audx_fade_in_internal" },
    { 0x1117, "audx_fade_out_internal" },
    { 0x1118, "audx_play_distance_attenuated_2d_internal" },
    { 0x1119, "audx_play_line_emitter_internal" },
    { 0x111A, "audx_print_3d_timer" },
    { 0x111B, "audx_set_spec_ops" },
    { 0x111C, "audx_slomo_wait" },
    { 0x111D, "auto_adjust_difficulty_player_movement_check" },
    { 0x111E, "auto_adjust_difficulty_player_positioner" },
    { 0x111F, "auto_adjust_difficulty_track_player_death" },
    { 0x1120, "auto_adjust_difficulty_track_player_shots" },
    { 0x1121, "auto_adjust_enemy_death_detection" },
    { 0x1122, "auto_adjust_enemy_died" },
    { 0x1123, "auto_adjust_flags" },
    { 0x1124, "auto_adjust_new_zone" },
    { 0x1125, "auto_adjust_results" },
    { 0x1126, "auto_adust_zone_complete" },
    { 0x1127, "auto_combat_music" },
    { 0x1128, "auto_mg42_target" },
    { 0x1129, "auto_mgturretlink" },
    { 0x112A, "auto_occumulator_base" },
    { 0x112B, "auto_recloak" },
    { 0x112C, "autoadjust_playerspots" },
    { 0x112D, "autoassign" },
    { 0x112E, "autoclose" },
    { 0x112F, "autofocus_hipenable" },
    { 0x1130, "autofocus_hipenable_bike" },
    { 0x1131, "autofocus_loop" },
    { 0x1132, "autopsy_cleanup" },
    { 0x1133, "autopsy_create_fodder_techs" },
    { 0x1134, "autopsy_doctor_door_doctor" },
    { 0x1135, "autopsy_doctor_door_enemies" },
    { 0x1136, "autopsy_doctor_door_enemy_ammo" },
    { 0x1137, "autopsy_doctor_door_enemy_think" },
    { 0x1138, "autopsy_doctor_door_fail" },
    { 0x1139, "autopsy_doctor_door_gideon" },
    { 0x113A, "autopsy_doctor_door_no_hint" },
    { 0x113B, "autopsy_doctor_door_player" },
    { 0x113C, "autopsy_door_action" },
    { 0x113D, "autopsy_door_tech" },
    { 0x113E, "autopsy_first_frame_entry_doors" },
    { 0x113F, "autopsy_fodder_tech_animate" },
    { 0x1140, "autopsy_fodder_tech_think" },
    { 0x1141, "autopsy_guard" },
    { 0x1142, "autopsy_guard_player_hit" },
    { 0x1143, "autopsy_main_doctor" },
    { 0x1144, "autopsy_start" },
    { 0x1145, "autoresettime" },
    { 0x1146, "autosave_by_name" },
    { 0x1147, "autosave_by_name_silent" },
    { 0x1148, "autosave_by_name_thread" },
    { 0x1149, "autosave_check_override" },
    { 0x114A, "autosave_check_pitbull_moving" },
    { 0x114B, "autosave_check_pitbull_no_recent_accel" },
    { 0x114C, "autosave_check_pitbull_upright" },
    { 0x114D, "autosave_fly_check" },
    { 0x114E, "autosave_hostile_drone_check" },
    { 0x114F, "autosave_jetbike_check_too_slow" },
    { 0x1150, "autosave_jetbike_check_trailing" },
    { 0x1151, "autosave_now" },
    { 0x1152, "autosave_now_silent" },
    { 0x1153, "autosave_now_trigger" },
    { 0x1154, "autosave_or_timeout" },
    { 0x1155, "autosave_proximity_threat_func" },
    { 0x1156, "autosave_recon" },
    { 0x1157, "autosave_stealth" },
    { 0x1158, "autosave_stealth_meter_check" },
    { 0x1159, "autosave_stealth_silent" },
    { 0x115A, "autosave_stealth_spotted_check" },
    { 0x115B, "autosave_tactical" },
    { 0x115C, "autosave_tactical_grenade_check" },
    { 0x115D, "autosave_tactical_grenade_check_dieout" },
    { 0x115E, "autosave_tactical_player_nades" },
    { 0x115F, "autosave_tactical_proc" },
    { 0x1160, "autosave_tactical_setup" },
    { 0x1161, "autosave_threat_check_enabled" },
    { 0x1162, "autosave_timeout" },
    { 0x1163, "autosaveammocheck" },
    { 0x1164, "autosavecheck" },
    { 0x1165, "autosavecheck_not_picky" },
    { 0x1166, "autosaveconfcentercombatcheck" },
    { 0x1167, "autosaveconfcenterstealthcheck" },
    { 0x1168, "autosavehealthcheck" },
    { 0x1169, "autosavenamethink" },
    { 0x116A, "autosaveplayercheck" },
    { 0x116B, "autosaveprint" },
    { 0x116C, "autosaves_think" },
    { 0x116D, "autosavesniperdronestealth" },
    { 0x116E, "autosavethreatcheck" },
    { 0x116F, "autoshootanimrate" },
    { 0x1170, "autospot_is_close_to_player" },
    { 0x1171, "autospotadswatcher" },
    { 0x1172, "autospotdeathwatcher" },
    { 0x1173, "autotarget" },
    { 0x1174, "auxillary_hud" },
    { 0x1175, "available" },
    { 0x1176, "available_crash_paths" },
    { 0x1177, "availablepositions" },
    { 0x1178, "avalanche_environment" },
    { 0x1179, "avalanche_falling_death" },
    { 0x117A, "avatar" },
    { 0x117B, "avatar_after_spawn" },
    { 0x117C, "avatar_scheduled_for_removal" },
    { 0x117D, "avatar_spawnpoint" },
    { 0x117E, "avatarinfo" },
    { 0x117F, "avengedplayerevent" },
    { 0x1180, "avm_add_envelope" },
    { 0x1181, "avm_add_in_state_callback" },
    { 0x1182, "avm_add_init_state_callback" },
    { 0x1183, "avm_add_loops" },
    { 0x1184, "avm_add_oneshot" },
    { 0x1185, "avm_add_oneshots" },
    { 0x1186, "avm_add_param_map_env" },
    { 0x1187, "avm_add_state_transition" },
    { 0x1188, "avm_begin_behavior_data" },
    { 0x1189, "avm_begin_behavior_def" },
    { 0x118A, "avm_begin_loop_data" },
    { 0x118B, "avm_begin_loop_def" },
    { 0x118C, "avm_begin_oneshot_data" },
    { 0x118D, "avm_begin_oneshot_def" },
    { 0x118E, "avm_begin_param_map" },
    { 0x118F, "avm_begin_preset_def" },
    { 0x1190, "avm_begin_state_data" },
    { 0x1191, "avm_begin_state_def" },
    { 0x1192, "avm_begin_state_group" },
    { 0x1193, "avm_change_smoothing_rate" },
    { 0x1194, "avm_compute_alpha_from_rc" },
    { 0x1195, "avm_compute_doppler_pitch" },
    { 0x1196, "avm_compute_smoothing_rc_from_alpha" },
    { 0x1197, "avm_create_vehicle_proxy" },
    { 0x1198, "avm_end_behavior_data" },
    { 0x1199, "avm_end_behavior_def" },
    { 0x119A, "avm_end_loop_data" },
    { 0x119B, "avm_end_loop_def" },
    { 0x119C, "avm_end_oneshot_data" },
    { 0x119D, "avm_end_oneshot_def" },
    { 0x119E, "avm_end_param_map" },
    { 0x119F, "avm_end_preset_def" },
    { 0x11A0, "avm_end_state_data" },
    { 0x11A1, "avm_end_state_def" },
    { 0x11A2, "avm_end_state_group" },
    { 0x11A3, "avm_get_running_instance_count" },
    { 0x11A4, "avm_get_update_rate" },
    { 0x11A5, "avm_init" },
    { 0x11A6, "avm_register_callback" },
    { 0x11A7, "avm_set_instance_master_volume" },
    { 0x11A8, "avm_set_loop_mute_state" },
    { 0x11A9, "avmx_add_behavior_shortcut_param_maps" },
    { 0x11AA, "avmx_add_instance" },
    { 0x11AB, "avmx_add_oneshot_ducking_scalar" },
    { 0x11AC, "avmx_add_preset" },
    { 0x11AD, "avmx_are_all_defined" },
    { 0x11AE, "avmx_continuously_update_snd_ent" },
    { 0x11AF, "avmx_create_instance_struct" },
    { 0x11B0, "avmx_create_param_io_struct" },
    { 0x11B1, "avmx_create_preset" },
    { 0x11B2, "avmx_fade_stop_and_delete_sound_obj" },
    { 0x11B3, "avmx_generate_instance_name" },
    { 0x11B4, "avmx_get" },
    { 0x11B5, "avmx_get_behavior_instance_struct" },
    { 0x11B6, "avmx_get_behavior_preset_struct" },
    { 0x11B7, "avmx_get_behavior_restricted_oneshots" },
    { 0x11B8, "avmx_get_callback" },
    { 0x11B9, "avmx_get_current_instance_sound_item_input" },
    { 0x11BA, "avmx_get_envelope" },
    { 0x11BB, "avmx_get_fadein_time" },
    { 0x11BC, "avmx_get_fadeout_time" },
    { 0x11BD, "avmx_get_instance" },
    { 0x11BE, "avmx_get_instance_name" },
    { 0x11BF, "avmx_get_instance_preset" },
    { 0x11C0, "avmx_get_instance_preset_name" },
    { 0x11C1, "avmx_get_instance_sound_item_output" },
    { 0x11C2, "avmx_get_instance_sound_item_volume" },
    { 0x11C3, "avmx_get_instance_state_struct" },
    { 0x11C4, "avmx_get_master_volume" },
    { 0x11C5, "avmx_get_oneshot_poly_mode" },
    { 0x11C6, "avmx_get_oneshot_update_mode" },
    { 0x11C7, "avmx_get_preset" },
    { 0x11C8, "avmx_get_preset_name" },
    { 0x11C9, "avmx_get_sound_alias" },
    { 0x11CA, "avmx_get_sound_alias_count" },
    { 0x11CB, "avmx_get_sound_instance" },
    { 0x11CC, "avmx_get_state_preset_struct" },
    { 0x11CD, "avmx_get_vehicle_entity" },
    { 0x11CE, "avmx_handle_oneshot_ducking" },
    { 0x11CF, "avmx_is_player_mode" },
    { 0x11D0, "avmx_is_vehicle_proxy" },
    { 0x11D1, "avmx_launch_state_machines" },
    { 0x11D2, "avmx_map_input" },
    { 0x11D3, "avmx_map_io" },
    { 0x11D4, "avmx_monitor_death" },
    { 0x11D5, "avmx_monitor_oneshot_done" },
    { 0x11D6, "avmx_normalize_ranged_value" },
    { 0x11D7, "avmx_preset_determine_param_map_env_owner" },
    { 0x11D8, "avmx_preset_determine_param_map_owner" },
    { 0x11D9, "avmx_preset_set_param_map_defaults" },
    { 0x11DA, "avmx_remove_instance" },
    { 0x11DB, "avmx_remove_oneshot_ducking_scalar" },
    { 0x11DC, "avmx_set_behavior_oneshot_overrides" },
    { 0x11DD, "avmx_set_instance_init_callback" },
    { 0x11DE, "avmx_set_instance_master_volume" },
    { 0x11DF, "avmx_set_loop_play_state" },
    { 0x11E0, "avmx_set_loop_volume" },
    { 0x11E1, "avmx_set_oneshot_ducking_scalar" },
    { 0x11E2, "avmx_set_oneshot_update_mode" },
    { 0x11E3, "avmx_set_preset_name" },
    { 0x11E4, "avmx_start_instance" },
    { 0x11E5, "avmx_start_loop" },
    { 0x11E6, "avmx_start_oneshot_alias" },
    { 0x11E7, "avmx_state_condition_function" },
    { 0x11E8, "avmx_state_enter_action_function" },
    { 0x11E9, "avmx_state_enter_action_init_data" },
    { 0x11EA, "avmx_state_enter_action_play_loops" },
    { 0x11EB, "avmx_state_enter_action_play_oneshots" },
    { 0x11EC, "avmx_state_exit_action_function" },
    { 0x11ED, "avmx_stop_instance" },
    { 0x11EE, "avmx_stop_loop" },
    { 0x11EF, "avmx_stop_snd_ent" },
    { 0x11F0, "avmx_update_instance_loop_assets" },
    { 0x11F1, "avmx_update_loop_ducking_scalar" },
    { 0x11F2, "avmx_update_loops" },
    { 0x11F3, "avmx_update_oneshot_duck_scalar" },
    { 0x11F4, "avmx_update_sound_ent_output_param" },
    { 0x11F5, "avmx_vehicle_getspeed" },
    { 0x11F6, "avoid_players" },
    { 0x11F7, "avoidairstrikelocations" },
    { 0x11F8, "avoidcarepackages" },
    { 0x11F9, "avoidcornervisibleenemies" },
    { 0x11FA, "avoidenemiesbydistance" },
    { 0x11FB, "avoidenemyspawn" },
    { 0x11FC, "avoidfullvisibleenemies" },
    { 0x11FD, "avoidgasclouds" },
    { 0x11FE, "avoidgrenades" },
    { 0x11FF, "avoidkillstreakonspawntimer" },
    { 0x1200, "avoidlastattackerlocation" },
    { 0x1201, "avoidlastdeathlocation" },
    { 0x1202, "avoidmines" },
    { 0x1203, "avoidrecentlyused" },
    { 0x1204, "avoidsamespawn" },
    { 0x1205, "avoidspawninhp" },
    { 0x1206, "avoidtelefrag" },
    { 0x1207, "award_intel" },
    { 0x1208, "award_player_exo_challenge_kill_for_scene" },
    { 0x1209, "awardcapturepoints" },
    { 0x120A, "awardedfinalsurvivor" },
    { 0x120B, "awardgameevent" },
    { 0x120C, "awardhordeheadshots" },
    { 0x120D, "awardhordekill" },
    { 0x120E, "awardhorderevive" },
    { 0x120F, "awardhorderoundnumber" },
    { 0x1210, "awardhordweaponlevel" },
    { 0x1211, "awardpoints" },
    { 0x1212, "awardxp" },
    { 0x1213, "aware_aievents" },
    { 0x1214, "awareness_meter_fail" },
    { 0x1215, "awareness_param" },
    { 0x1216, "axis_check_cloak_state" },
    { 0x1217, "axis_global_accuracy_mod" },
    { 0x1218, "axis_start_spawn_name" },
    { 0x1219, "axiscapturing" },
    { 0x121A, "axischopper" },
    { 0x121B, "axisflagcarrierclientnum" },
    { 0x121C, "axisflagstatus" },
    { 0x121D, "axismode" },
    { 0x121E, "azm_get_current_zone" },
    { 0x121F, "azm_get_damb_enable" },
    { 0x1220, "azm_get_filter_bypass" },
    { 0x1221, "azm_get_filter_enable" },
    { 0x1222, "azm_get_mix_bypass" },
    { 0x1223, "azm_get_mix_enable" },
    { 0x1224, "azm_get_occlusion_bypass" },
    { 0x1225, "azm_get_occlusion_enable" },
    { 0x1226, "azm_get_quad_enable" },
    { 0x1227, "azm_get_reverb_bypass" },
    { 0x1228, "azm_get_reverb_enable" },
    { 0x1229, "azm_init" },
    { 0x122A, "azm_print_enter_blend" },
    { 0x122B, "azm_print_exit_blend" },
    { 0x122C, "azm_print_progress" },
    { 0x122D, "azm_set_current_zone" },
    { 0x122E, "azm_set_damb_enable" },
    { 0x122F, "azm_set_filter_bypass" },
    { 0x1230, "azm_set_filter_enable" },
    { 0x1231, "azm_set_mix_bypass" },
    { 0x1232, "azm_set_mix_enable" },
    { 0x1233, "azm_set_occlusion_bypass" },
    { 0x1234, "azm_set_occlusion_enable" },
    { 0x1235, "azm_set_quad_enable" },
    { 0x1236, "azm_set_reverb_bypass" },
    { 0x1237, "azm_set_reverb_enable" },
    { 0x1238, "azm_set_zone_dynamic_ambience" },
    { 0x1239, "azm_set_zone_mix" },
    { 0x123A, "azm_set_zone_occlusion" },
    { 0x123B, "azm_set_zone_reverb" },
    { 0x123C, "azm_set_zone_streamed_ambience" },
    { 0x123D, "azm_start_zone" },
    { 0x123E, "azm_stop_zone" },
    { 0x123F, "azm_stop_zones" },
    { 0x1240, "azm_use_string_table" },
    { 0x1241, "azmx_blend_zones" },
    { 0x1242, "azmx_get_blend_args" },
    { 0x1243, "azmx_get_preset_from_string_table" },
    { 0x1244, "azmx_get_zone_preset_from_stringtable_internal" },
    { 0x1245, "azmx_is_valid_damb_blend_request" },
    { 0x1246, "azmx_is_valid_mix_blend_request" },
    { 0x1247, "azmx_is_valid_samb_blend_request" },
    { 0x1248, "azmx_load_zone" },
    { 0x1249, "azmx_restart_damb" },
    { 0x124A, "azmx_restart_mix" },
    { 0x124B, "azmx_restart_occlusion" },
    { 0x124C, "azmx_restart_reverb" },
    { 0x124D, "azmx_restart_stream" },
    { 0x124E, "azmx_set_param_internal" },
    { 0x124F, "azmx_wait_till_fade_done_and_remove_zone" },
    { 0x1250, "back_fake_bullets" },
    { 0x1251, "back_gunfire_timer" },
    { 0x1252, "back_line_of_fire" },
    { 0x1253, "background_block" },
    { 0x1254, "background_drop_pods" },
    { 0x1255, "background_explosion" },
    { 0x1256, "background_org" },
    { 0x1257, "backline_alive_check" },
    { 0x1258, "backline_flee_check" },
    { 0x1259, "backlineguys_total" },
    { 0x125A, "backlineguysalive" },
    { 0x125B, "backoff_count" },
    { 0x125C, "backshieldmodel" },
    { 0x125D, "backstabber_stage" },
    { 0x125E, "backstabber_update" },
    { 0x125F, "backstabevent" },
    { 0x1260, "backup_drop_pod_function" },
    { 0x1261, "bad_guys_die" },
    { 0x1262, "bad_perch_logic" },
    { 0x1263, "badmofo" },
    { 0x1264, "badplace" },
    { 0x1265, "badplace_cylinder_func" },
    { 0x1266, "badplace_delete_func" },
    { 0x1267, "badplace_on_entity" },
    { 0x1268, "badplace_remove" },
    { 0x1269, "badplace_think" },
    { 0x126A, "badplaceint" },
    { 0x126B, "badplacemodifier" },
    { 0x126C, "badplacer" },
    { 0x126D, "badplaces" },
    { 0x126E, "badshot" },
    { 0x126F, "badshotcount" },
    { 0x1270, "badspawn" },
    { 0x1271, "bagh_end_turretpull_mix" },
    { 0x1272, "bagh_grab_gunner" },
    { 0x1273, "bagh_punch_turret" },
    { 0x1274, "bagh_start_turretpull_mix" },
    { 0x1275, "bagh_throw_gunner" },
    { 0x1276, "bail_out_of_turret_dialogue" },
    { 0x1277, "balanceteams" },
    { 0x1278, "balarmon" },
    { 0x1279, "balcony_death_anims" },
    { 0x127A, "balcony_drone_foliage" },
    { 0x127B, "balcony_entrance_doors" },
    { 0x127C, "balcony_finale_end_camera_control" },
    { 0x127D, "balcony_lighting" },
    { 0x127E, "balcony_siren" },
    { 0x127F, "balcony_sniper_drone_idle" },
    { 0x1280, "balcony_sniper_drone_idle_cleanup" },
    { 0x1281, "ball_add_start" },
    { 0x1282, "ball_assign_random_start" },
    { 0x1283, "ball_assign_start" },
    { 0x1284, "ball_assign_team_spawns" },
    { 0x1285, "ball_at_rest" },
    { 0x1286, "ball_can_pass_ally" },
    { 0x1287, "ball_can_pass_enemy" },
    { 0x1288, "ball_can_pickup" },
    { 0x1289, "ball_can_throw" },
    { 0x128A, "ball_carried" },
    { 0x128B, "ball_carrier_cleanup" },
    { 0x128C, "ball_carrier_is_almost_visible" },
    { 0x128D, "ball_carrier_touched_goal" },
    { 0x128E, "ball_check_assist" },
    { 0x128F, "ball_check_pass_kill_pickup" },
    { 0x1290, "ball_clear_contents" },
    { 0x1291, "ball_connect_watch" },
    { 0x1292, "ball_create_ball_starts" },
    { 0x1293, "ball_create_killcam_ent" },
    { 0x1294, "ball_create_team_goal" },
    { 0x1295, "ball_default_origins" },
    { 0x1296, "ball_dont_interpolate" },
    { 0x1297, "ball_download_fx" },
    { 0x1298, "ball_download_wait" },
    { 0x1299, "ball_find_ground" },
    { 0x129A, "ball_fx_active" },
    { 0x129B, "ball_fx_start" },
    { 0x129C, "ball_fx_start_player" },
    { 0x129D, "ball_fx_stop" },
    { 0x129E, "ball_get_path_dist" },
    { 0x129F, "ball_get_view_team" },
    { 0x12A0, "ball_give_score" },
    { 0x12A1, "ball_goal_can_use" },
    { 0x12A2, "ball_goal_fx" },
    { 0x12A3, "ball_goal_fx_for_player" },
    { 0x12A4, "ball_goal_useobject" },
    { 0x12A5, "ball_goals" },
    { 0x12A6, "ball_goals_post_event" },
    { 0x12A7, "ball_in_goal" },
    { 0x12A8, "ball_init_map_min_max" },
    { 0x12A9, "ball_joint_angles_rate" },
    { 0x12AA, "ball_joint_last_angles" },
    { 0x12AB, "ball_joint_last_update_msec" },
    { 0x12AC, "ball_jump_nodes" },
    { 0x12AD, "ball_location_hud" },
    { 0x12AE, "ball_maxs" },
    { 0x12AF, "ball_mins" },
    { 0x12B0, "ball_on_connect" },
    { 0x12B1, "ball_on_pickup" },
    { 0x12B2, "ball_on_projectile_death" },
    { 0x12B3, "ball_on_projectile_hit_client" },
    { 0x12B4, "ball_on_reset" },
    { 0x12B5, "ball_overridemovingplatformdeath" },
    { 0x12B6, "ball_pass_or_shoot" },
    { 0x12B7, "ball_pass_or_throw_active" },
    { 0x12B8, "ball_pass_projectile" },
    { 0x12B9, "ball_pass_touch_goal" },
    { 0x12BA, "ball_pass_watch" },
    { 0x12BB, "ball_physics_bad_trigger_at_rest" },
    { 0x12BC, "ball_physics_bad_trigger_watch" },
    { 0x12BD, "ball_physics_fake_bounce" },
    { 0x12BE, "ball_physics_launch" },
    { 0x12BF, "ball_physics_launch_drop" },
    { 0x12C0, "ball_physics_out_of_level" },
    { 0x12C1, "ball_physics_timeout" },
    { 0x12C2, "ball_physics_touch_cant_pickup_player" },
    { 0x12C3, "ball_physics_touch_goal" },
    { 0x12C4, "ball_play_fx_joined_team" },
    { 0x12C5, "ball_play_local_team_sound" },
    { 0x12C6, "ball_play_score_fx" },
    { 0x12C7, "ball_player_on_connect" },
    { 0x12C8, "ball_restore_contents" },
    { 0x12C9, "ball_return_home" },
    { 0x12CA, "ball_score_event" },
    { 0x12CB, "ball_score_sound" },
    { 0x12CC, "ball_set_dropped" },
    { 0x12CD, "ball_shoot_watch" },
    { 0x12CE, "ball_spawn" },
    { 0x12CF, "ball_starts" },
    { 0x12D0, "ball_starts_post_event" },
    { 0x12D1, "ball_touch_goal_watch" },
    { 0x12D2, "ball_touched_goal" },
    { 0x12D3, "ball_touching_ground" },
    { 0x12D4, "ball_update_extrascore0" },
    { 0x12D5, "ball_waypoint_download" },
    { 0x12D6, "ball_waypoint_held" },
    { 0x12D7, "ball_waypoint_neutral" },
    { 0x12D8, "ball_waypoint_upload" },
    { 0x12D9, "balldrone" },
    { 0x12DA, "balldronetype" },
    { 0x12DB, "balliesintruck" },
    { 0x12DC, "balls" },
    { 0x12DD, "ballscoreassistevent" },
    { 0x12DE, "bar" },
    { 0x12DF, "bar_guy_check_function" },
    { 0x12E0, "bar_guys_waiting" },
    { 0x12E1, "bar_setup" },
    { 0x12E2, "barfighters_notify" },
    { 0x12E3, "barking_sound" },
    { 0x12E4, "barracks_approach_handle_dialogue" },
    { 0x12E5, "barracks_defense_guys" },
    { 0x12E6, "barracks_objectives" },
    { 0x12E7, "barrel" },
    { 0x12E8, "barrel_earthquake" },
    { 0x12E9, "barrel_heat_glow_fx" },
    { 0x12EA, "barrel_overheat_fx" },
    { 0x12EB, "barrelexpsound" },
    { 0x12EC, "barrellinker" },
    { 0x12ED, "barrelrollacceleration" },
    { 0x12EE, "barrelviewmodel" },
    { 0x12EF, "barrelviewmodeloffset" },
    { 0x12F0, "barrier_scene_ents" },
    { 0x12F1, "barrivalsenabled" },
    { 0x12F2, "bars" },
    { 0x12F3, "base" },
    { 0x12F4, "base_agl" },
    { 0x12F5, "base_angles" },
    { 0x12F6, "base_array_ambient_a10_gun_dive_1" },
    { 0x12F7, "base_array_ambient_a10_gun_dive_2" },
    { 0x12F8, "base_array_ambient_a10_gun_dive_3" },
    { 0x12F9, "base_array_ambient_a10_gun_dive_4" },
    { 0x12FA, "base_array_ambient_dogfight_1" },
    { 0x12FB, "base_array_ambient_dogfight_2" },
    { 0x12FC, "base_array_ambient_dogfight_3" },
    { 0x12FD, "base_array_ambient_dogfight_4" },
    { 0x12FE, "base_clip" },
    { 0x12FF, "base_intensity" },
    { 0x1300, "base_origin" },
    { 0x1301, "base_target_offset_angles" },
    { 0x1302, "base_target_offset_length" },
    { 0x1303, "baseaccuracy" },
    { 0x1304, "basealpha" },
    { 0x1305, "baseangles" },
    { 0x1306, "basedangle" },
    { 0x1307, "basedelta" },
    { 0x1308, "baseeffect" },
    { 0x1309, "baseeffectforward" },
    { 0x130A, "baseeffectpos" },
    { 0x130B, "baseeffectright" },
    { 0x130C, "basefontscale" },
    { 0x130D, "baseheight" },
    { 0x130E, "baseignorerandombulletdamage" },
    { 0x130F, "basement_door_clip_function" },
    { 0x1310, "basement_door_school_anim" },
    { 0x1311, "basement_enemy_flashlight_setup" },
    { 0x1312, "basement_fog_checkpoint" },
    { 0x1313, "basement_hide_setup" },
    { 0x1314, "basement_investigate" },
    { 0x1315, "basement_jump_awareness" },
    { 0x1316, "basement_troop_2" },
    { 0x1317, "basement_valve_and_door_stop_early" },
    { 0x1318, "baseorigin" },
    { 0x1319, "baseowner" },
    { 0x131A, "baseplayermovescale" },
    { 0x131B, "basetime" },
    { 0x131C, "basewidth" },
    { 0x131D, "baseyaw" },
    { 0x131E, "basic" },
    { 0x131F, "battery_cost" },
    { 0x1320, "battery_hud_is_visible" },
    { 0x1321, "battery_min" },
    { 0x1322, "batteryfillmax" },
    { 0x1323, "batteryinit" },
    { 0x1324, "batterymetervisible" },
    { 0x1325, "batterysetlevel" },
    { 0x1326, "batteryspend" },
    { 0x1327, "batteryupdatemeter" },
    { 0x1328, "battle_chatter_check_alley" },
    { 0x1329, "battle_chatter_off_both" },
    { 0x132A, "battle_chatter_on_both" },
    { 0x132B, "battle_deployable_cover_setup" },
    { 0x132C, "battle_exterior_sunflare" },
    { 0x132D, "battlebuddy" },
    { 0x132E, "battlebuddyrespawntimestamp" },
    { 0x132F, "battlebuddywaitlist" },
    { 0x1330, "battlechatter" },
    { 0x1331, "battlechatter_canprint" },
    { 0x1332, "battlechatter_canprintdump" },
    { 0x1333, "battlechatter_debugprint" },
    { 0x1334, "battlechatter_dist_check" },
    { 0x1335, "battlechatter_off" },
    { 0x1336, "battlechatter_on" },
    { 0x1337, "battlechatter_on_thread" },
    { 0x1338, "battlechatter_print" },
    { 0x1339, "battlechatter_printdump" },
    { 0x133A, "battlechatter_printdumpline" },
    { 0x133B, "bays_open" },
    { 0x133C, "bc_explosion_vision" },
    { 0x133D, "bc_initial_blur" },
    { 0x133E, "bc_shadow_tweak" },
    { 0x133F, "bcdisabled" },
    { 0x1340, "bcdrawobjects" },
    { 0x1341, "bcgetclaimednode" },
    { 0x1342, "bcinfo" },
    { 0x1343, "bcissniper" },
    { 0x1344, "bclearstrafeturnrate" },
    { 0x1345, "bcname" },
    { 0x1346, "bcnameid" },
    { 0x1347, "bcprintfailprefix" },
    { 0x1348, "bcprintwarnprefix" },
    { 0x1349, "bcrank" },
    { 0x134A, "bcs_location_mappings" },
    { 0x134B, "bcs_location_trigger_mapping" },
    { 0x134C, "bcs_location_trigs_init" },
    { 0x134D, "bcs_locations" },
    { 0x134E, "bcs_maxtalkingdistsqrdfromplayer" },
    { 0x134F, "bcs_maxthreatdistsqrdfromplayer" },
    { 0x1350, "bcs_minpriority" },
    { 0x1351, "bcs_scripted_dialogue_start" },
    { 0x1352, "bcs_setup_chatter_toggle_array" },
    { 0x1353, "bcs_setup_countryids" },
    { 0x1354, "bcs_setup_flavorburst_toggle_array" },
    { 0x1355, "bcs_setup_teams_array" },
    { 0x1356, "bcs_setup_voice" },
    { 0x1357, "bcs_threatresettime" },
    { 0x1358, "bcs_trigs_assign_aliases" },
    { 0x1359, "bcsdebugwaiter" },
    { 0x135A, "bcsenabled" },
    { 0x135B, "bcsounds" },
    { 0x135C, "bdisabledefaultfacialanims" },
    { 0x135D, "bdisablegearsounds" },
    { 0x135E, "bdisablemovetwitch" },
    { 0x135F, "bdoturnandmove" },
    { 0x1360, "beach_guy_monitor" },
    { 0x1361, "beacon" },
    { 0x1362, "beam_clip_disable_function" },
    { 0x1363, "beamgetgroundfx" },
    { 0x1364, "beamgroundfx" },
    { 0x1365, "beamminimap" },
    { 0x1366, "beams" },
    { 0x1367, "beamsounds" },
    { 0x1368, "beamstartfires" },
    { 0x1369, "become_aware_on_goal" },
    { 0x136A, "become_aware_when_player_is_in_volume" },
    { 0x136B, "bedroom_begin" },
    { 0x136C, "bedroom_main" },
    { 0x136D, "bedroom_start" },
    { 0x136E, "beffectlooping" },
    { 0x136F, "beforestairanim" },
    { 0x1370, "begin_anim_reach" },
    { 0x1371, "begin_attack_heli_behavior" },
    { 0x1372, "begin_barracks" },
    { 0x1373, "begin_big_cave" },
    { 0x1374, "begin_canyon" },
    { 0x1375, "begin_canyon_dam" },
    { 0x1376, "begin_canyon_exit" },
    { 0x1377, "begin_canyon_intro" },
    { 0x1378, "begin_canyon2" },
    { 0x1379, "begin_canyon3" },
    { 0x137A, "begin_capture" },
    { 0x137B, "begin_cave_entry" },
    { 0x137C, "begin_cave_hallway" },
    { 0x137D, "begin_combat_cave" },
    { 0x137E, "begin_concussion_grenade_tracking" },
    { 0x137F, "begin_courtyard_combat" },
    { 0x1380, "begin_crash_site" },
    { 0x1381, "begin_dnabomb" },
    { 0x1382, "begin_exo_push" },
    { 0x1383, "begin_ice_bridge" },
    { 0x1384, "begin_intro" },
    { 0x1385, "begin_intro_conversation" },
    { 0x1386, "begin_kill_hades_sequence" },
    { 0x1387, "begin_lake" },
    { 0x1388, "begin_lake_cinema" },
    { 0x1389, "begin_narrow_cave" },
    { 0x138A, "begin_on_foot_segment" },
    { 0x138B, "begin_overlook" },
    { 0x138C, "begin_pcap_vo_lab_serverroom_cormack" },
    { 0x138D, "begin_post_tower" },
    { 0x138E, "begin_refugee_walk" },
    { 0x138F, "begin_rooftop_combat" },
    { 0x1390, "begin_semtex_grenade_tracking" },
    { 0x1391, "begin_skyjack" },
    { 0x1392, "begin_snipers" },
    { 0x1393, "begin_spawnning_exo_spawners" },
    { 0x1394, "begin_stealth_walk" },
    { 0x1395, "begin_tank" },
    { 0x1396, "begin_the_shimmey_for_burke" },
    { 0x1397, "begin_the_street_fight" },
    { 0x1398, "begin_vtol_takedown" },
    { 0x1399, "begin_wallpull_slowmo" },
    { 0x139A, "beginc4tracking" },
    { 0x139B, "beginclasschoice" },
    { 0x139C, "begincourtyarddialogue" },
    { 0x139D, "begincustomevent" },
    { 0x139E, "beginflashgrenadetracking" },
    { 0x139F, "begingrenadetracking" },
    { 0x13A0, "beginning_idle_cine_turret" },
    { 0x13A1, "beginningoflevelsave" },
    { 0x13A2, "beginsliding" },
    { 0x13A3, "beginsmokegrenadetracking" },
    { 0x13A4, "beginteamchoice" },
    { 0x13A5, "behavior" },
    { 0x13A6, "behavior_data" },
    { 0x13A7, "behavior_list" },
    { 0x13A8, "behavior_under_construction" },
    { 0x13A9, "behaviors" },
    { 0x13AA, "behind_punish_dist" },
    { 0x13AB, "being_careful" },
    { 0x13AC, "beingartilleryshellshocked" },
    { 0x13AD, "beingdestroyed" },
    { 0x13AE, "beingrevived" },
    { 0x13AF, "bell_run" },
    { 0x13B0, "best_dodge_car" },
    { 0x13B1, "best_pr_kills" },
    { 0x13B2, "bestcovernode" },
    { 0x13B3, "bestmissilespawn" },
    { 0x13B4, "bestmissilespawnabove" },
    { 0x13B5, "bestspawnflag" },
    { 0x13B6, "bet_betrayal_pt1_gideon" },
    { 0x13B7, "bet_betrayal_pt1_ilona" },
    { 0x13B8, "bet_betrayal_pt1_irons" },
    { 0x13B9, "bet_betrayal_pt1_tech" },
    { 0x13BA, "bet_betrayal_pt2_gideon" },
    { 0x13BB, "bet_betrayal_pt2_ilona" },
    { 0x13BC, "bet_betrayal_pt2_irons" },
    { 0x13BD, "bet_boat_crash_audio_handler" },
    { 0x13BE, "bet_boat_crash_bldg_impact" },
    { 0x13BF, "bet_boat_dive_watcher" },
    { 0x13C0, "bet_boat_end_watcher" },
    { 0x13C1, "bet_boat_enter_plr_exo_arm" },
    { 0x13C2, "bet_boat_enter_plr_grab_wheel" },
    { 0x13C3, "bet_boat_enter_plr_jump_into_boat" },
    { 0x13C4, "bet_boat_enter_plr_power_on" },
    { 0x13C5, "bet_boat_enter_plr_sit" },
    { 0x13C6, "bet_boat_enter_plr_start" },
    { 0x13C7, "bet_boat_exit_ilona" },
    { 0x13C8, "bet_boat_exit_ilona_pickup_wpn" },
    { 0x13C9, "bet_boat_exit_ilona_stand" },
    { 0x13CA, "bet_boat_exit_jump_out" },
    { 0x13CB, "bet_boat_exit_stand_up" },
    { 0x13CC, "bet_boat_exit_start" },
    { 0x13CD, "bet_conf_door_opens" },
    { 0x13CE, "bet_conf_escape_guard_1_punched" },
    { 0x13CF, "bet_conf_escape_guard_1_react" },
    { 0x13D0, "bet_conf_escape_guard_1_tripped" },
    { 0x13D1, "bet_conf_escape_guard_2_punch" },
    { 0x13D2, "bet_conf_escape_guard_2_shot" },
    { 0x13D3, "bet_conf_escape_plr_foot_sweep" },
    { 0x13D4, "bet_conf_escape_plr_punch" },
    { 0x13D5, "bet_conf_escape_plr_wpn" },
    { 0x13D6, "bet_conf_fire_suppression" },
    { 0x13D7, "bet_conf_flash_bang_exp" },
    { 0x13D8, "bet_conf_gideon_exits" },
    { 0x13D9, "bet_conf_gideon_reacts" },
    { 0x13DA, "bet_conf_gideon_turns_to_leave" },
    { 0x13DB, "bet_conf_guard_1_enter" },
    { 0x13DC, "bet_conf_guard_1_swing_wpn" },
    { 0x13DD, "bet_conf_guard_2_push_down_ilona" },
    { 0x13DE, "bet_conf_guard_wpn_trained" },
    { 0x13DF, "bet_conf_ilona_punched" },
    { 0x13E0, "bet_conf_irons_enters" },
    { 0x13E1, "bet_conf_irons_exits" },
    { 0x13E2, "bet_conf_irons_turns_to_leave" },
    { 0x13E3, "bet_conf_irons_walks_to_ilona" },
    { 0x13E4, "bet_conf_kill_guard" },
    { 0x13E5, "bet_conf_plr_knock_back" },
    { 0x13E6, "bet_conf_plr_lean" },
    { 0x13E7, "bet_conf_plr_pull_wpn" },
    { 0x13E8, "bet_conf_plr_punched" },
    { 0x13E9, "bet_conf_plr_sit_back" },
    { 0x13EA, "bet_conf_slo_mo_kick_start" },
    { 0x13EB, "bet_conf_slo_mo_kick_stop" },
    { 0x13EC, "bet_conf_slo_mo_shoot_start" },
    { 0x13ED, "bet_conf_slo_mo_shoot_stop" },
    { 0x13EE, "bet_conf_sprinkler" },
    { 0x13EF, "bet_conf_steam_lp" },
    { 0x13F0, "bet_elevator_exoclimb_dismount" },
    { 0x13F1, "bet_elevator_exoclimb_dismount_foot" },
    { 0x13F2, "bet_ending_cormack" },
    { 0x13F3, "bet_ending_gideon" },
    { 0x13F4, "bet_ending_ilona" },
    { 0x13F5, "bet_ending_joker" },
    { 0x13F6, "bet_escape_additional_sprinklers" },
    { 0x13F7, "bet_escape_additional_steam" },
    { 0x13F8, "bet_escape_alarms" },
    { 0x13F9, "bet_escape_ilona" },
    { 0x13FA, "bet_escape_roof_slide" },
    { 0x13FB, "bet_escape_roof_slomo_end" },
    { 0x13FC, "bet_escape_roof_slomo_start" },
    { 0x13FD, "bet_foley_override_handler" },
    { 0x13FE, "bet_gideon_arm_scanner" },
    { 0x13FF, "bet_holo_glitches_1" },
    { 0x1400, "bet_holo_glitches_2" },
    { 0x1401, "bet_holo_glitches_3" },
    { 0x1402, "bet_holo_glitches_4" },
    { 0x1403, "bet_holo_irons_shoot_pistol" },
    { 0x1404, "bet_holo_irons_stand_and_walk" },
    { 0x1405, "bet_hologram_start" },
    { 0x1406, "bet_ilona_swim_end" },
    { 0x1407, "bet_ilona_swim_start" },
    { 0x1408, "bet_intro_done" },
    { 0x1409, "bet_intro_gideon" },
    { 0x140A, "bet_roof_glass_hit" },
    { 0x140B, "bet_roof_lower_blast_doors" },
    { 0x140C, "bet_roof_raise_blast_doors" },
    { 0x140D, "bet_roof_slide_start" },
    { 0x140E, "bet_roof_slo_mo_start" },
    { 0x140F, "bet_roof_slo_mo_stop" },
    { 0x1410, "bet_roof_water_hit" },
    { 0x1411, "bet_swim_boat_explo" },
    { 0x1412, "bet_swim_boat_hit_bottom" },
    { 0x1413, "bet_swim_boat_sink" },
    { 0x1414, "bet_swim_bullet_trails" },
    { 0x1415, "bet_swim_dock_debris_blocker" },
    { 0x1416, "bet_swim_dock_explode" },
    { 0x1417, "bet_walla_intro_patio" },
    { 0x1418, "betrayal_boat_vision_set_fog_changes" },
    { 0x1419, "betrayal_finale_player_jump" },
    { 0x141A, "betrayal_interior_clut" },
    { 0x141B, "betrayal_interior_darker_fog" },
    { 0x141C, "betrayal_intro_screen" },
    { 0x141D, "betrayal_locations" },
    { 0x141E, "betrayal_roof_transition" },
    { 0x141F, "bfirstmoveanim" },
    { 0x1420, "bg" },
    { 0x1421, "bg_falldamagemaxheight_old" },
    { 0x1422, "bg_falldamagemaxheight_orig" },
    { 0x1423, "bg_falldamageminheight_old" },
    { 0x1424, "bg_falldamageminheight_orig" },
    { 0x1425, "bg_guys" },
    { 0x1426, "bh_attacker_accuracy_increaser" },
    { 0x1427, "bh_cleanup" },
    { 0x1428, "bh_heli_enemy_killer" },
    { 0x1429, "bh_helo_flyby" },
    { 0x142A, "bh_intro" },
    { 0x142B, "bh_intro_autosave" },
    { 0x142C, "bh_pit" },
    { 0x142D, "bh_pit_cleanup" },
    { 0x142E, "bh_pit_exit" },
    { 0x142F, "bh_pit_yard_visblock" },
    { 0x1430, "bh_run_civilians" },
    { 0x1431, "bh_run_mechs" },
    { 0x1432, "bh_yard" },
    { 0x1433, "bh_yard_doors" },
    { 0x1434, "bh_yard_exit" },
    { 0x1435, "bhasbadpath" },
    { 0x1436, "bhasgunwhileriding" },
    { 0x1437, "bhasnopath" },
    { 0x1438, "biasgroup_think" },
    { 0x1439, "bidlehitreaction" },
    { 0x143A, "bidlelooking" },
    { 0x143B, "big_cave_abyss_death" },
    { 0x143C, "big_cave_autosave" },
    { 0x143D, "big_cave_cleanup" },
    { 0x143E, "big_fire_door_close" },
    { 0x143F, "big_fire_door_open" },
    { 0x1440, "big_kamikaze_death" },
    { 0x1441, "big_moment_ending_vfx" },
    { 0x1442, "big_moment_ending_vfx_ash_fall" },
    { 0x1443, "big_moment_ending_vfx_bouncing_rocks" },
    { 0x1444, "big_moment_ending_vfx_donut_smk" },
    { 0x1445, "big_moment_ending_vfx_falling_debris" },
    { 0x1446, "big_moment_ending_vfx_falling_debris_tower" },
    { 0x1447, "big_moment_ending_vfx_falling_rock" },
    { 0x1448, "big_moment_ending_vfx_ground_buckling" },
    { 0x1449, "big_moment_ending_vfx_ground_splinter_up" },
    { 0x144A, "big_moment_ending_vfx_rolling_smk" },
    { 0x144B, "big_moment_ending_vfx_shockwave" },
    { 0x144C, "big_moment_ending_vfx_thick_smk_vm" },
    { 0x144D, "big_moment_ending_vfx_tower_base_smk_looping" },
    { 0x144E, "big_moment_ending_vfx_tower_chunk_trailing_smk" },
    { 0x144F, "big_moment_ending_vfx_tower_explode" },
    { 0x1450, "big_moment_ending_vfx_tower_fall_camshake" },
    { 0x1451, "big_moment_ending_vfx_tower_initial_crack" },
    { 0x1452, "big_moment_ending_vfx_tower_lower_left_burst" },
    { 0x1453, "big_moment_ending_vfx_tower_lower_right_burst" },
    { 0x1454, "big_moment_ending_vfx_tower_middle_top_burst" },
    { 0x1455, "big_moment_ending_vfx_tower_pillar_left_burst" },
    { 0x1456, "big_moment_ending_vfx_tower_pillar_right_burst" },
    { 0x1457, "big_moment_ending_vfx_tower_smoke_up" },
    { 0x1458, "big_moment_ending_vfx_tower_smoke_up_tall" },
    { 0x1459, "big_moment_ending_vfx_tower_top_left_burst" },
    { 0x145A, "big_moment_ending_vfx_trailing_dust" },
    { 0x145B, "big_moment_ending_vfx_warbird_dust" },
    { 0x145C, "big_pipe_explosion_vfx_after_hangar" },
    { 0x145D, "bigfinale" },
    { 0x145E, "bigfinaleblockknife" },
    { 0x145F, "bigfinaleenemytruckdamagesetup" },
    { 0x1460, "bigfinalehadesknife" },
    { 0x1461, "bigfinalehitflash" },
    { 0x1462, "bigfinaleilanagun" },
    { 0x1463, "bigfinaleilanakickcar" },
    { 0x1464, "bigfinaleilanamagicshoot" },
    { 0x1465, "bigfinaleilanapunchcar" },
    { 0x1466, "bigfinaleilanashoot" },
    { 0x1467, "bigfinaleilanaslamcar" },
    { 0x1468, "bigfinaleplayergrabgun" },
    { 0x1469, "bigfinaleplayerhitbyveh" },
    { 0x146A, "bigfinaleplayerhitwall" },
    { 0x146B, "bigfinaleplayerknife" },
    { 0x146C, "bigfinaleplayerlosegun" },
    { 0x146D, "bigfinaleplayerripdoor" },
    { 0x146E, "bigfinaleplayershoot" },
    { 0x146F, "bigfinaleplayerstab" },
    { 0x1470, "bigfinaleplayerstabfail" },
    { 0x1471, "bigfinalepunchhades" },
    { 0x1472, "bigfinaleswitchhadeshead" },
    { 0x1473, "bike_mount_dof" },
    { 0x1474, "bike_reach_function" },
    { 0x1475, "bike_rider" },
    { 0x1476, "bike_riders" },
    { 0x1477, "binoc_hint_breakout" },
    { 0x1478, "binoc_overlay" },
    { 0x1479, "binocdidpan" },
    { 0x147A, "binocdidzoom" },
    { 0x147B, "binocs_put_away" },
    { 0x147C, "binocular_dof" },
    { 0x147D, "binocular_mwp_rim_flicker" },
    { 0x147E, "binocular_vision" },
    { 0x147F, "biometrichud" },
    { 0x1480, "bird_flyaway" },
    { 0x1481, "bird_shadow_after_sewer" },
    { 0x1482, "bird_startle" },
    { 0x1483, "birds_after_sewer" },
    { 0x1484, "birds_scatter_cliff_rappel" },
    { 0x1485, "birthnode" },
    { 0x1486, "bisactivated" },
    { 0x1487, "bisgunner" },
    { 0x1488, "biskillstreak" },
    { 0x1489, "bissuppressingsniper" },
    { 0x148A, "bistargeted" },
    { 0x148B, "bkillplayer" },
    { 0x148C, "black_distance" },
    { 0x148D, "black_overlay" },
    { 0x148E, "black_screen" },
    { 0x148F, "blackout" },
    { 0x1490, "blackoutoverlay" },
    { 0x1491, "blank" },
    { 0x1492, "blast_anim_set" },
    { 0x1493, "blast_door_compare" },
    { 0x1494, "blast_doors_mr_x" },
    { 0x1495, "blastdoor_hideents" },
    { 0x1496, "blastdoor_showents" },
    { 0x1497, "blastpursuitfailedposbad" },
    { 0x1498, "blastradius" },
    { 0x1499, "blastshieldusetracker" },
    { 0x149A, "blend" },
    { 0x149B, "blend_dof_presets" },
    { 0x149C, "blend_dof_viewmodel_presets" },
    { 0x149D, "blend_droppitch" },
    { 0x149E, "blend_movespeedscale" },
    { 0x149F, "blend_movespeedscale_default" },
    { 0x14A0, "blend_movespeedscale_percent" },
    { 0x14A1, "blend_out_fake_speed_blend_ms" },
    { 0x14A2, "blend_out_fake_speed_start_ms" },
    { 0x14A3, "blend_viewmodel_dof" },
    { 0x14A4, "blenddelete" },
    { 0x14A5, "blendintocrouchrun" },
    { 0x14A6, "blendintocrouchwalk" },
    { 0x14A7, "blendintostandrun" },
    { 0x14A8, "blendintostandwalk" },
    { 0x14A9, "blendtreeanims" },
    { 0x14AA, "blimp" },
    { 0x14AB, "blimp_animation" },
    { 0x14AC, "blimp_run" },
    { 0x14AD, "blimp_scripted_lights" },
    { 0x14AE, "blindfire" },
    { 0x14AF, "blink_flashlight" },
    { 0x14B0, "blink_lights" },
    { 0x14B1, "blink_lights_flicker" },
    { 0x14B2, "block_from_going_back" },
    { 0x14B3, "blockage_lighting" },
    { 0x14B4, "blockarea" },
    { 0x14B5, "blockentsinarea" },
    { 0x14B6, "blockgoalpos" },
    { 0x14B7, "blockingpain" },
    { 0x14B8, "blockweapondrops" },
    { 0x14B9, "blood_splat_on_screen" },
    { 0x14BA, "blood_splatter_simple" },
    { 0x14BB, "bloodeffect" },
    { 0x14BC, "bloodmeleeeffect" },
    { 0x14BD, "bloodsplateffect" },
    { 0x14BE, "bloodsprayexitwoundtrace" },
    { 0x14BF, "bloody_death" },
    { 0x14C0, "bloody_death_all_survivors" },
    { 0x14C1, "bloody_death_fx" },
    { 0x14C2, "blow_door" },
    { 0x14C3, "blowitup" },
    { 0x14C4, "blowout_goalradius_on_pathend" },
    { 0x14C5, "blowupatendoftrackingtime" },
    { 0x14C6, "blowupdronesequence" },
    { 0x14C7, "blowupdronesequenceexplosive" },
    { 0x14C8, "blue" },
    { 0x14C9, "blur_sine" },
    { 0x14CA, "blurry_rotors_on" },
    { 0x14CB, "blurview" },
    { 0x14CC, "bmarkallies" },
    { 0x14CD, "bmcd_debug_loop" },
    { 0x14CE, "bnoanimunload" },
    { 0x14CF, "boarderfx" },
    { 0x14D0, "boarderfxid" },
    { 0x14D1, "boat_bobbing_think" },
    { 0x14D2, "boat_canal" },
    { 0x14D3, "boat_crash_break_glass" },
    { 0x14D4, "boat_death_think" },
    { 0x14D5, "boat_end" },
    { 0x14D6, "boat_large_static_foam" },
    { 0x14D7, "boat_portal_tigger_on" },
    { 0x14D8, "boat_rock_check_triggers" },
    { 0x14D9, "boat_rocking_hangar" },
    { 0x14DA, "boat_rocking_jet_moment" },
    { 0x14DB, "boat_scene_big_bob_settings" },
    { 0x14DC, "boat_scene_boat_warning_system" },
    { 0x14DD, "boat_scene_bobbing_obstacle" },
    { 0x14DE, "boat_scene_bridge_collapse" },
    { 0x14DF, "boat_scene_cleanup" },
    { 0x14E0, "boat_scene_cleanup_warning_elem_on_crash" },
    { 0x14E1, "boat_scene_crash_moment" },
    { 0x14E2, "boat_scene_crash_moment_whiteout" },
    { 0x14E3, "boat_scene_disable_dive" },
    { 0x14E4, "boat_scene_dive_tutorial" },
    { 0x14E5, "boat_scene_dive_tutorial_trigger_hit" },
    { 0x14E6, "boat_scene_drive_gas_tutorial" },
    { 0x14E7, "boat_scene_drive_tutorial" },
    { 0x14E8, "boat_scene_early_setup" },
    { 0x14E9, "boat_scene_early_setup_start_bobbing_boats" },
    { 0x14EA, "boat_scene_fail_path" },
    { 0x14EB, "boat_scene_fire_missile_at_boat" },
    { 0x14EC, "boat_scene_handle_boat_collisions" },
    { 0x14ED, "boat_scene_handle_boat_damage" },
    { 0x14EE, "boat_scene_handle_fail_state" },
    { 0x14EF, "boat_scene_heli_change_paths" },
    { 0x14F0, "boat_scene_heli_change_paths_on_trigger" },
    { 0x14F1, "boat_scene_hide_warning_elem" },
    { 0x14F2, "boat_scene_master_handler" },
    { 0x14F3, "boat_scene_missile_dive_warning" },
    { 0x14F4, "boat_scene_missile_flight" },
    { 0x14F5, "boat_scene_missile_impact_damage_boat" },
    { 0x14F6, "boat_scene_missile_launch_volley" },
    { 0x14F7, "boat_scene_missile_wait_for_player_to_surface" },
    { 0x14F8, "boat_scene_monitor_boat_params" },
    { 0x14F9, "boat_scene_moving_obstacle" },
    { 0x14FA, "boat_scene_moving_obstacle_delete_boat_on_spawner_death" },
    { 0x14FB, "boat_scene_moving_obstacle_spawn_boat_in_radius" },
    { 0x14FC, "boat_scene_play_target_lock_sound_loop" },
    { 0x14FD, "boat_scene_prep_drones" },
    { 0x14FE, "boat_scene_prep_water_impacts" },
    { 0x14FF, "boat_scene_raise_canal_blocker" },
    { 0x1500, "boat_scene_remove_water_impact" },
    { 0x1501, "boat_scene_setup" },
    { 0x1502, "boat_scene_setup_spawn_swarm" },
    { 0x1503, "boat_scene_show_warning_elem" },
    { 0x1504, "boat_scene_small_bob_settings" },
    { 0x1505, "boat_scene_spawn_water_impact" },
    { 0x1506, "boat_scene_swap_to_grapple_body" },
    { 0x1507, "boat_scene_target_lock_sound" },
    { 0x1508, "boat_scene_trigger_fail_path" },
    { 0x1509, "boat_scene_vig_civ_setup" },
    { 0x150A, "boat_small_static_foam" },
    { 0x150B, "boats" },
    { 0x150C, "bob_mask" },
    { 0x150D, "bobbing_fnc" },
    { 0x150E, "bobbing_objects" },
    { 0x150F, "bobbing_settings" },
    { 0x1510, "bobbing_underwater" },
    { 0x1511, "bobbingbuoyangles" },
    { 0x1512, "bobbingobject" },
    { 0x1513, "bobobjectparam" },
    { 0x1514, "bobobjectto" },
    { 0x1515, "bodies_gag_door_trigger" },
    { 0x1516, "body_room_exit" },
    { 0x1517, "body_temp" },
    { 0x1518, "bodygasfx" },
    { 0x1519, "bodyrollvelocity" },
    { 0x151A, "bodyroom_gag_ghost_function" },
    { 0x151B, "bodyroom_gag_support_function" },
    { 0x151C, "bodystashguardalertwatch" },
    { 0x151D, "bodystashguardapproach" },
    { 0x151E, "bodystashguarddeath" },
    { 0x151F, "bodystashguardkillwatch" },
    { 0x1520, "bodystashguardnofeedback" },
    { 0x1521, "boid_add_vehicle_to_targets" },
    { 0x1522, "boid_cheap_death" },
    { 0x1523, "boid_cloud_spawned" },
    { 0x1524, "boid_flock_think" },
    { 0x1525, "boid_settings" },
    { 0x1526, "boid_settings_presets" },
    { 0x1527, "boid_vehicle_targets" },
    { 0x1528, "boids" },
    { 0x1529, "bollards_clips" },
    { 0x152A, "bollards_move" },
    { 0x152B, "bolthit" },
    { 0x152C, "bomb" },
    { 0x152D, "bomb_defuser" },
    { 0x152E, "bomb_defuser_update" },
    { 0x152F, "bomb_light" },
    { 0x1530, "bomb_plant_dof" },
    { 0x1531, "bomb_plant_dof_bokeh" },
    { 0x1532, "bomb_plant_lighting" },
    { 0x1533, "bomb_shakes" },
    { 0x1534, "bomb_tag" },
    { 0x1535, "bomb_tag_left" },
    { 0x1536, "bomb_tag_right" },
    { 0x1537, "bomb_target" },
    { 0x1538, "bomb_zone_assaulting" },
    { 0x1539, "bombdefused" },
    { 0x153A, "bombdefuseevent" },
    { 0x153B, "bombdefusetrig" },
    { 0x153C, "bombdetonateevent" },
    { 0x153D, "bomber_disable_movement_for_time" },
    { 0x153E, "bomber_monitor_no_path" },
    { 0x153F, "bomber_wait_for_bomb_reset" },
    { 0x1540, "bomber_wait_for_death" },
    { 0x1541, "bomberdropbombs" },
    { 0x1542, "bomberdropcarepackges" },
    { 0x1543, "bombexploded" },
    { 0x1544, "bomblet_camera_waiter" },
    { 0x1545, "bomblet_camera_waiter_complete" },
    { 0x1546, "bomblet_explosion_waiter" },
    { 0x1547, "bombowner" },
    { 0x1548, "bombplanted" },
    { 0x1549, "bombplantedanim" },
    { 0x154A, "bombplantedtime" },
    { 0x154B, "bombplantevent" },
    { 0x154C, "bombs" },
    { 0x154D, "bombshake_interval" },
    { 0x154E, "bombshake_interval_rand" },
    { 0x154F, "bombsquadicons" },
    { 0x1550, "bombsquadids" },
    { 0x1551, "bombsquadmodel" },
    { 0x1552, "bombsquadvisibilityupdater" },
    { 0x1553, "bombsquadwaiter" },
    { 0x1554, "bombtimer" },
    { 0x1555, "bombtimerwait" },
    { 0x1556, "bombzone_num_picked" },
    { 0x1557, "bombzonegoal" },
    { 0x1558, "bombzones" },
    { 0x1559, "bone" },
    { 0x155A, "bones" },
    { 0x155B, "bones_advance_hospital" },
    { 0x155C, "bones_bike" },
    { 0x155D, "bones_bike_idle_wait" },
    { 0x155E, "bones_dismount" },
    { 0x155F, "bones_fence" },
    { 0x1560, "bones_gate_jtbk_land" },
    { 0x1561, "bones_gate_jtbk_lift" },
    { 0x1562, "bones_high_five" },
    { 0x1563, "bones_onbike" },
    { 0x1564, "bones_rollout_manager" },
    { 0x1565, "boneyard_fire_at_targets" },
    { 0x1566, "boneyard_style_heli_missile_attack" },
    { 0x1567, "boneyard_style_heli_missile_attack_linked" },
    { 0x1568, "boobytrapcratethink" },
    { 0x1569, "bool_norecharge" },
    { 0x156A, "boost" },
    { 0x156B, "boost_attack" },
    { 0x156C, "boost_attack_deal_damage" },
    { 0x156D, "boost_dash" },
    { 0x156E, "boost_dash_think" },
    { 0x156F, "boost_dash_track_player_movement" },
    { 0x1570, "boost_dash_track_player_velocity" },
    { 0x1571, "boost_dodge_activate_plr" },
    { 0x1572, "boost_down_in_order" },
    { 0x1573, "boost_hint" },
    { 0x1574, "boost_hint_breakout" },
    { 0x1575, "boost_jump" },
    { 0x1576, "boost_jump_disable" },
    { 0x1577, "boost_jump_disable_npc" },
    { 0x1578, "boost_jump_enable" },
    { 0x1579, "boost_jump_enabled" },
    { 0x157A, "boost_jump_hint" },
    { 0x157B, "boost_jump_npc" },
    { 0x157C, "boost_jump_player" },
    { 0x157D, "boost_jump_to_heli" },
    { 0x157E, "boost_jump_toggle" },
    { 0x157F, "boost_jump_wrapper" },
    { 0x1580, "boost_land_anims" },
    { 0x1581, "boost_land_assist_npc" },
    { 0x1582, "boost_land_assist_npc_ground" },
    { 0x1583, "boost_land_first_shot" },
    { 0x1584, "boost_land_hud_disable" },
    { 0x1585, "boost_land_hud_enable" },
    { 0x1586, "boost_land_max_locked_out" },
    { 0x1587, "boost_land_max_shot_timer" },
    { 0x1588, "boost_land_npc" },
    { 0x1589, "boost_land_on" },
    { 0x158A, "boost_land_out_of_fuel" },
    { 0x158B, "boost_land_play_oneshot" },
    { 0x158C, "boost_land_player" },
    { 0x158D, "boost_land_release_locked_out" },
    { 0x158E, "boost_land_release_shot_timer" },
    { 0x158F, "boost_land_release_start_time" },
    { 0x1590, "boost_land_use_fuel" },
    { 0x1591, "boost_land_velocity_finder" },
    { 0x1592, "boost_lets_go" },
    { 0x1593, "boost_plane_controls" },
    { 0x1594, "boost_script_ender" },
    { 0x1595, "boost_setup_desat" },
    { 0x1596, "boost_slam_hint" },
    { 0x1597, "boost_slam_history" },
    { 0x1598, "boost_slam_use_hint" },
    { 0x1599, "boost_slam_use_monitor" },
    { 0x159A, "boost_timer" },
    { 0x159B, "boost_use_hint" },
    { 0x159C, "booster_distance_checker" },
    { 0x159D, "boosters_off_anim" },
    { 0x159E, "boostslamkillevent" },
    { 0x159F, "border_drone_fail" },
    { 0x15A0, "bored_patrol_anims" },
    { 0x15A1, "bot" },
    { 0x15A2, "bot_3d_sighting_model" },
    { 0x15A3, "bot_3d_sighting_model_thread" },
    { 0x15A4, "bot_abort_tactical_goal" },
    { 0x15A5, "bot_add_ambush_time_delayed" },
    { 0x15A6, "bot_add_missing_nodes" },
    { 0x15A7, "bot_add_scavenger_bag" },
    { 0x15A8, "bot_add_to_bot_damage_targets" },
    { 0x15A9, "bot_add_to_bot_level_targets" },
    { 0x15AA, "bot_add_to_bot_use_targets" },
    { 0x15AB, "bot_allow_to_capture_flag" },
    { 0x15AC, "bot_allowed_to_3_cap" },
    { 0x15AD, "bot_allowed_to_switch_teams" },
    { 0x15AE, "bot_allowed_to_use_killstreaks" },
    { 0x15AF, "bot_ambush_end" },
    { 0x15B0, "bot_assign_personality_functions" },
    { 0x15B1, "bot_attachment_reticle" },
    { 0x15B2, "bot_attachmenttable" },
    { 0x15B3, "bot_balance_personality" },
    { 0x15B4, "bot_ball_attacker_limit_for_team" },
    { 0x15B5, "bot_ball_defender_limit_for_team" },
    { 0x15B6, "bot_ball_get_balls_carried_by_team" },
    { 0x15B7, "bot_ball_get_closest_ball" },
    { 0x15B8, "bot_ball_get_free_balls" },
    { 0x15B9, "bot_ball_get_origin" },
    { 0x15BA, "bot_ball_is_resetting" },
    { 0x15BB, "bot_ball_origin_can_see_goal" },
    { 0x15BC, "bot_ball_think" },
    { 0x15BD, "bot_ball_trace_to_origin" },
    { 0x15BE, "bot_body_is_dead" },
    { 0x15BF, "bot_bots_enabled_or_added" },
    { 0x15C0, "bot_cache_entrances" },
    { 0x15C1, "bot_cache_entrances_to_bombzones" },
    { 0x15C2, "bot_cache_entrances_to_gametype_array" },
    { 0x15C3, "bot_cache_entrances_to_hardpoints" },
    { 0x15C4, "bot_cache_flag_distances" },
    { 0x15C5, "bot_camotable" },
    { 0x15C6, "bot_camp_tag" },
    { 0x15C7, "bot_camping" },
    { 0x15C8, "bot_can_join_team" },
    { 0x15C9, "bot_can_revive" },
    { 0x15CA, "bot_can_use_assault_ugv" },
    { 0x15CB, "bot_can_use_assault_ugv_only_ai_version" },
    { 0x15CC, "bot_can_use_box_by_type" },
    { 0x15CD, "bot_can_use_emp" },
    { 0x15CE, "bot_can_use_point_in_defend" },
    { 0x15CF, "bot_can_use_sentry_only_ai_version" },
    { 0x15D0, "bot_can_use_strafing_run" },
    { 0x15D1, "bot_can_use_warbird" },
    { 0x15D2, "bot_can_use_warbird_only_ai_version" },
    { 0x15D3, "bot_capture_hp_zone" },
    { 0x15D4, "bot_capture_point" },
    { 0x15D5, "bot_capture_zone" },
    { 0x15D6, "bot_capture_zone_get_furthest_distance" },
    { 0x15D7, "bot_check_tag_above_head" },
    { 0x15D8, "bot_check_team_is_using_position" },
    { 0x15D9, "bot_choose_difficulty_for_default" },
    { 0x15DA, "bot_choose_flag" },
    { 0x15DB, "bot_class" },
    { 0x15DC, "bot_client_counts" },
    { 0x15DD, "bot_cm_human_picked" },
    { 0x15DE, "bot_cm_spawned_bots" },
    { 0x15DF, "bot_cm_waited_players_time" },
    { 0x15E0, "bot_combine_tag_seen_arrays" },
    { 0x15E1, "bot_conf_think" },
    { 0x15E2, "bot_connect_monitor" },
    { 0x15E3, "bot_control_heli" },
    { 0x15E4, "bot_control_heli_main_move_loop" },
    { 0x15E5, "bot_crate_is_command_goal" },
    { 0x15E6, "bot_crate_valid" },
    { 0x15E7, "bot_ctf_ai_director_update" },
    { 0x15E8, "bot_ctf_get_node_chance" },
    { 0x15E9, "bot_ctf_think" },
    { 0x15EA, "bot_cur_loadout_num" },
    { 0x15EB, "bot_custom_classes_allowed" },
    { 0x15EC, "bot_damage_callback" },
    { 0x15ED, "bot_default_class_random" },
    { 0x15EE, "bot_default_sd_role_behavior" },
    { 0x15EF, "bot_defend_get_precalc_entrances_for_current_area" },
    { 0x15F0, "bot_defend_get_random_entrance_point_for_current_area" },
    { 0x15F1, "bot_defend_player_guarding" },
    { 0x15F2, "bot_defend_stop" },
    { 0x15F3, "bot_defend_think" },
    { 0x15F4, "bot_defending" },
    { 0x15F5, "bot_defending_center" },
    { 0x15F6, "bot_defending_nodes" },
    { 0x15F7, "bot_defending_override_origin_node" },
    { 0x15F8, "bot_defending_radius" },
    { 0x15F9, "bot_defending_trigger" },
    { 0x15FA, "bot_defending_type" },
    { 0x15FB, "bot_difficulty_defaults" },
    { 0x15FC, "bot_disable_tactical_goals" },
    { 0x15FD, "bot_dom_debug_should_capture_all" },
    { 0x15FE, "bot_dom_debug_should_protect_all" },
    { 0x15FF, "bot_dom_get_node_chance" },
    { 0x1600, "bot_dom_leader_dialog" },
    { 0x1601, "bot_dom_override_flag_targets" },
    { 0x1602, "bot_dom_think" },
    { 0x1603, "bot_draw_circle" },
    { 0x1604, "bot_draw_cylinder" },
    { 0x1605, "bot_draw_cylinder_think" },
    { 0x1606, "bot_drop" },
    { 0x1607, "bot_enable_tactical_goals" },
    { 0x1608, "bot_end_control_on_respawn" },
    { 0x1609, "bot_end_control_on_vehicle_death" },
    { 0x160A, "bot_end_control_watcher" },
    { 0x160B, "bot_ent_is_anonymous_mine" },
    { 0x160C, "bot_fallback_personality" },
    { 0x160D, "bot_fallback_weapon" },
    { 0x160E, "bot_filter_ambush_inuse" },
    { 0x160F, "bot_filter_ambush_vicinity" },
    { 0x1610, "bot_find_1_loadout_option" },
    { 0x1611, "bot_find_2_loadout_options" },
    { 0x1612, "bot_find_ambush_entrances" },
    { 0x1613, "bot_find_best_tag_from_array" },
    { 0x1614, "bot_find_defend_node_func" },
    { 0x1615, "bot_find_node_that_protects_point" },
    { 0x1616, "bot_find_node_to_capture_point" },
    { 0x1617, "bot_find_node_to_capture_zone" },
    { 0x1618, "bot_find_node_to_guard_player" },
    { 0x1619, "bot_find_random_midpoint" },
    { 0x161A, "bot_find_visible_tags" },
    { 0x161B, "bot_flag_trigger" },
    { 0x161C, "bot_flag_trigger_clear" },
    { 0x161D, "bot_force_stance_for_time" },
    { 0x161E, "bot_funcs" },
    { 0x161F, "bot_gametype_allied_attackers_for_team" },
    { 0x1620, "bot_gametype_allied_defenders_for_team" },
    { 0x1621, "bot_gametype_attacker_defender_ai_director_update" },
    { 0x1622, "bot_gametype_attacker_limit_for_team" },
    { 0x1623, "bot_gametype_chooses_class" },
    { 0x1624, "bot_gametype_chooses_team" },
    { 0x1625, "bot_gametype_defender_limit_for_team" },
    { 0x1626, "bot_gametype_get_allied_attackers_for_team" },
    { 0x1627, "bot_gametype_get_allied_defenders_for_team" },
    { 0x1628, "bot_gametype_get_num_players_on_team" },
    { 0x1629, "bot_gametype_get_players_by_role" },
    { 0x162A, "bot_gametype_initialize_attacker_defender_role" },
    { 0x162B, "bot_gametype_precaching_done" },
    { 0x162C, "bot_gametype_set_role" },
    { 0x162D, "bot_get_all_possible_flags" },
    { 0x162E, "bot_get_ambush_trap_item" },
    { 0x162F, "bot_get_client_limit" },
    { 0x1630, "bot_get_entrances_for_stance_and_index" },
    { 0x1631, "bot_get_grenade_ammo" },
    { 0x1632, "bot_get_grenade_for_purpose" },
    { 0x1633, "bot_get_heli_goal_dist_sq" },
    { 0x1634, "bot_get_heli_slowdown_dist_sq" },
    { 0x1635, "bot_get_host_team" },
    { 0x1636, "bot_get_human_picked_team" },
    { 0x1637, "bot_get_known_attacker" },
    { 0x1638, "bot_get_low_on_ammo" },
    { 0x1639, "bot_get_max_players_on_team" },
    { 0x163A, "bot_get_nodes_in_cone" },
    { 0x163B, "bot_get_num_teammates_capturing_zone" },
    { 0x163C, "bot_get_pick_13_count" },
    { 0x163D, "bot_get_player_team" },
    { 0x163E, "bot_get_rank_xp_and_prestige" },
    { 0x163F, "bot_get_string_index_for_integer" },
    { 0x1640, "bot_get_team_limit" },
    { 0x1641, "bot_get_teammates_capturing_zone" },
    { 0x1642, "bot_get_teammates_currently_defending_point" },
    { 0x1643, "bot_get_teammates_in_radius" },
    { 0x1644, "bot_get_total_gun_ammo" },
    { 0x1645, "bot_get_zones_within_dist" },
    { 0x1646, "bot_get_zones_within_dist_recurs" },
    { 0x1647, "bot_goal_can_override" },
    { 0x1648, "bot_grenade_matches_purpose" },
    { 0x1649, "bot_guard_player" },
    { 0x164A, "bot_gun_think" },
    { 0x164B, "bot_handle_no_valid_defense_node" },
    { 0x164C, "bot_has_tactical_goal" },
    { 0x164D, "bot_heli_find_unvisited_nodes" },
    { 0x164E, "bot_heli_nodes" },
    { 0x164F, "bot_heli_pilot_traceoffset" },
    { 0x1650, "bot_hp_allow_predictive_capping" },
    { 0x1651, "bot_hp_think" },
    { 0x1652, "bot_ignore_precalc_paths" },
    { 0x1653, "bot_in_combat" },
    { 0x1654, "bot_infect_ai_director_update" },
    { 0x1655, "bot_infect_angle_too_steep_for_knife_throw" },
    { 0x1656, "bot_infect_find_node_can_see_ent" },
    { 0x1657, "bot_infect_retrieve_knife" },
    { 0x1658, "bot_infect_think" },
    { 0x1659, "bot_initialized_remote_vehicles" },
    { 0x165A, "bot_interaction_type" },
    { 0x165B, "bot_invalid_attachment_combos" },
    { 0x165C, "bot_is_bodyguarding" },
    { 0x165D, "bot_is_capturing" },
    { 0x165E, "bot_is_capturing_flag" },
    { 0x165F, "bot_is_capturing_zone" },
    { 0x1660, "bot_is_defending" },
    { 0x1661, "bot_is_defending_point" },
    { 0x1662, "bot_is_guarding_player" },
    { 0x1663, "bot_is_monitoring_aerial_danger" },
    { 0x1664, "bot_is_patrolling" },
    { 0x1665, "bot_is_protecting" },
    { 0x1666, "bot_is_protecting_flag" },
    { 0x1667, "bot_is_remote_or_linked" },
    { 0x1668, "bot_is_tag_visible" },
    { 0x1669, "bot_is_valid_killstreak" },
    { 0x166A, "bot_israndom" },
    { 0x166B, "bot_jump_for_tag" },
    { 0x166C, "bot_killstreak_can_use_weapon_version" },
    { 0x166D, "bot_killstreak_choose_loc_enemies" },
    { 0x166E, "bot_killstreak_do_not_use" },
    { 0x166F, "bot_killstreak_drop" },
    { 0x1670, "bot_killstreak_drop_anywhere" },
    { 0x1671, "bot_killstreak_drop_hidden" },
    { 0x1672, "bot_killstreak_drop_outside" },
    { 0x1673, "bot_killstreak_get_all_outside_allies" },
    { 0x1674, "bot_killstreak_get_all_outside_enemies" },
    { 0x1675, "bot_killstreak_get_outside_players" },
    { 0x1676, "bot_killstreak_get_zone_allies_outside" },
    { 0x1677, "bot_killstreak_get_zone_enemies_outside" },
    { 0x1678, "bot_killstreak_is_valid_internal" },
    { 0x1679, "bot_killstreak_is_valid_single" },
    { 0x167A, "bot_killstreak_never_use" },
    { 0x167B, "bot_killstreak_remote_control" },
    { 0x167C, "bot_killstreak_sentry" },
    { 0x167D, "bot_killstreak_setup" },
    { 0x167E, "bot_killstreak_simple_use" },
    { 0x167F, "bot_killstreak_wait" },
    { 0x1680, "bot_know_enemies_on_start" },
    { 0x1681, "bot_ks_funcs" },
    { 0x1682, "bot_ks_heli_offset" },
    { 0x1683, "bot_last_loadout_num" },
    { 0x1684, "bot_leader_dialog" },
    { 0x1685, "bot_loadout_choose_fallback_primary" },
    { 0x1686, "bot_loadout_choose_from_attachmenttable" },
    { 0x1687, "bot_loadout_choose_from_camotable" },
    { 0x1688, "bot_loadout_choose_from_custom_default_class" },
    { 0x1689, "bot_loadout_choose_from_default_class" },
    { 0x168A, "bot_loadout_choose_from_reticletable" },
    { 0x168B, "bot_loadout_choose_from_set" },
    { 0x168C, "bot_loadout_choose_from_statstable" },
    { 0x168D, "bot_loadout_choose_values" },
    { 0x168E, "bot_loadout_class_callback" },
    { 0x168F, "bot_loadout_fields" },
    { 0x1690, "bot_loadout_get_difficulty" },
    { 0x1691, "bot_loadout_item_allowed" },
    { 0x1692, "bot_loadout_item_valid_for_rank" },
    { 0x1693, "bot_loadout_pick" },
    { 0x1694, "bot_loadout_set" },
    { 0x1695, "bot_loadout_set_has_wildcard" },
    { 0x1696, "bot_loadout_team" },
    { 0x1697, "bot_loadout_valid_choice" },
    { 0x1698, "bot_loadouts_initialized" },
    { 0x1699, "bot_lui_convert_team_to_int" },
    { 0x169A, "bot_make_entity_sentient" },
    { 0x169B, "bot_map_center" },
    { 0x169C, "bot_map_max_x" },
    { 0x169D, "bot_map_max_y" },
    { 0x169E, "bot_map_max_z" },
    { 0x169F, "bot_map_min_x" },
    { 0x16A0, "bot_map_min_y" },
    { 0x16A1, "bot_map_min_z" },
    { 0x16A2, "bot_max_players_on_team" },
    { 0x16A3, "bot_melee_tactical_insertion_check" },
    { 0x16A4, "bot_memory_goal" },
    { 0x16A5, "bot_memory_goal_time" },
    { 0x16A6, "bot_min_rank_for_item" },
    { 0x16A7, "bot_monitor_enemy_camp_spots" },
    { 0x16A8, "bot_monitor_team_limits" },
    { 0x16A9, "bot_monitor_watch_entrances_at_goal" },
    { 0x16AA, "bot_monitor_watch_entrances_bodyguard" },
    { 0x16AB, "bot_monitor_watch_entrances_camp" },
    { 0x16AC, "bot_new_tactical_goal" },
    { 0x16AD, "bot_notify_streak_used" },
    { 0x16AE, "bot_out_of_ammo" },
    { 0x16AF, "bot_out_of_combat_time" },
    { 0x16B0, "bot_patrol_area" },
    { 0x16B1, "bot_pers_init" },
    { 0x16B2, "bot_pers_update" },
    { 0x16B3, "bot_personality" },
    { 0x16B4, "bot_personality_list" },
    { 0x16B5, "bot_personality_type" },
    { 0x16B6, "bot_personality_types_desired" },
    { 0x16B7, "bot_pick_new_loadout_next_spawn" },
    { 0x16B8, "bot_pick_personality_from_weapon" },
    { 0x16B9, "bot_pick_random_point_from_set" },
    { 0x16BA, "bot_pick_random_point_in_radius" },
    { 0x16BB, "bot_picking_up" },
    { 0x16BC, "bot_pickup_weapon" },
    { 0x16BD, "bot_player_spawned" },
    { 0x16BE, "bot_point_is_on_pathgrid" },
    { 0x16BF, "bot_post_teleport" },
    { 0x16C0, "bot_post_use_ammo_crate" },
    { 0x16C1, "bot_post_use_box_of_type" },
    { 0x16C2, "bot_pre_use_ammo_crate" },
    { 0x16C3, "bot_pre_use_box_of_type" },
    { 0x16C4, "bot_prematchdonetime" },
    { 0x16C5, "bot_protect_point" },
    { 0x16C6, "bot_queued_process" },
    { 0x16C7, "bot_queued_process_level_thread" },
    { 0x16C8, "bot_queued_process_level_thread_active" },
    { 0x16C9, "bot_queued_process_queue" },
    { 0x16CA, "bot_random_path" },
    { 0x16CB, "bot_random_path_default" },
    { 0x16CC, "bot_random_path_function" },
    { 0x16CD, "bot_random_ranks_for_difficulty" },
    { 0x16CE, "bot_recent_point_of_interest" },
    { 0x16CF, "bot_register_killstreak_func" },
    { 0x16D0, "bot_remove_from_bot_level_targets" },
    { 0x16D1, "bot_remove_invalid_tags" },
    { 0x16D2, "bot_respawn_launcher_name" },
    { 0x16D3, "bot_restart_think_threads" },
    { 0x16D4, "bot_reticletable" },
    { 0x16D5, "bot_rnd_prestige" },
    { 0x16D6, "bot_rnd_rank" },
    { 0x16D7, "bot_scavenger_bags" },
    { 0x16D8, "bot_sd_ai_director_update" },
    { 0x16D9, "bot_sd_override_zone_targets" },
    { 0x16DA, "bot_sd_start" },
    { 0x16DB, "bot_sd_think" },
    { 0x16DC, "bot_seek_dropped_weapon" },
    { 0x16DD, "bot_send_cancel_notify" },
    { 0x16DE, "bot_send_place_notify" },
    { 0x16DF, "bot_sentry_activate" },
    { 0x16E0, "bot_sentry_add_goal" },
    { 0x16E1, "bot_sentry_cancel" },
    { 0x16E2, "bot_sentry_cancel_failsafe" },
    { 0x16E3, "bot_sentry_carried_obj" },
    { 0x16E4, "bot_sentry_choose_placement" },
    { 0x16E5, "bot_sentry_choose_target" },
    { 0x16E6, "bot_sentry_ensure_exit" },
    { 0x16E7, "bot_sentry_force_cancel" },
    { 0x16E8, "bot_sentry_path_start" },
    { 0x16E9, "bot_sentry_path_thread" },
    { 0x16EA, "bot_sentry_should_abort" },
    { 0x16EB, "bot_set_ambush_trap" },
    { 0x16EC, "bot_set_ambush_trap_wait_fire" },
    { 0x16ED, "bot_set_bombzone_bottargets" },
    { 0x16EE, "bot_set_difficulty" },
    { 0x16EF, "bot_set_loadout_class" },
    { 0x16F0, "bot_set_personality" },
    { 0x16F1, "bot_set_role" },
    { 0x16F2, "bot_set_role_delayed" },
    { 0x16F3, "bot_setup_ball_jump_nodes" },
    { 0x16F4, "bot_setup_bombzone_bottargets" },
    { 0x16F5, "bot_setup_bot_targets" },
    { 0x16F6, "bot_setup_callback_class" },
    { 0x16F7, "bot_setup_loadout_callback" },
    { 0x16F8, "bot_setup_map_specific_killstreaks" },
    { 0x16F9, "bot_should_cap_next_zone" },
    { 0x16FA, "bot_should_defend" },
    { 0x16FB, "bot_should_defend_flag" },
    { 0x16FC, "bot_should_do_killcam" },
    { 0x16FD, "bot_should_melee_level_damage_target" },
    { 0x16FE, "bot_should_pickup_weapons" },
    { 0x16FF, "bot_should_pickup_weapons_infect" },
    { 0x1700, "bot_should_use_ammo_crate" },
    { 0x1701, "bot_should_use_ballistic_vest_crate" },
    { 0x1702, "bot_should_use_grenade_crate" },
    { 0x1703, "bot_should_use_juicebox_crate" },
    { 0x1704, "bot_should_use_scavenger_bag" },
    { 0x1705, "bot_spawn_from_devgui_in_progress" },
    { 0x1706, "bot_spawned_before" },
    { 0x1707, "bot_sr_think" },
    { 0x1708, "bot_start_know_enemy" },
    { 0x1709, "bot_start_known_by_enemy" },
    { 0x170A, "bot_supported_killstreaks" },
    { 0x170B, "bot_switch_to_killstreak_weapon" },
    { 0x170C, "bot_tag_allowable_jump_height" },
    { 0x170D, "bot_tag_obj_radius" },
    { 0x170E, "bot_target" },
    { 0x170F, "bot_target_is_flag" },
    { 0x1710, "bot_targets" },
    { 0x1711, "bot_team" },
    { 0x1712, "bot_think" },
    { 0x1713, "bot_think_crate" },
    { 0x1714, "bot_think_crate_blocking_path" },
    { 0x1715, "bot_think_gametype" },
    { 0x1716, "bot_think_killstreak" },
    { 0x1717, "bot_think_level_actions" },
    { 0x1718, "bot_think_revive" },
    { 0x1719, "bot_think_seek_dropped_weapons" },
    { 0x171A, "bot_think_tactical_goals" },
    { 0x171B, "bot_think_watch_aerial_killstreak" },
    { 0x171C, "bot_think_watch_enemy" },
    { 0x171D, "bot_triggers" },
    { 0x171E, "bot_try_trap_follower" },
    { 0x171F, "bot_twar_capture_zone" },
    { 0x1720, "bot_twar_get_node_chance" },
    { 0x1721, "bot_twar_get_zone_label" },
    { 0x1722, "bot_twar_get_zones_for_team" },
    { 0x1723, "bot_twar_is_capturing_zone" },
    { 0x1724, "bot_twar_should_start_cautious_approach" },
    { 0x1725, "bot_twar_think" },
    { 0x1726, "bot_update_camp_assassin" },
    { 0x1727, "bot_usebutton_wait" },
    { 0x1728, "bot_valid_camp_assassin" },
    { 0x1729, "bot_validate_perk" },
    { 0x172A, "bot_validate_reticle" },
    { 0x172B, "bot_validate_weapon" },
    { 0x172C, "bot_variables_initialized" },
    { 0x172D, "bot_vectors_are_equal" },
    { 0x172E, "bot_visited_times" },
    { 0x172F, "bot_wait_for_event_flag_swap" },
    { 0x1730, "bot_waittill_bots_enabled" },
    { 0x1731, "bot_waittill_goal_or_fail" },
    { 0x1732, "bot_waittill_out_of_combat_or_time" },
    { 0x1733, "bot_waittill_using_vehicle" },
    { 0x1734, "bot_war_think" },
    { 0x1735, "bot_watch_entrances_delayed" },
    { 0x1736, "bot_watch_for_death" },
    { 0x1737, "bot_watch_manual_detonate" },
    { 0x1738, "bot_watch_new_tags" },
    { 0x1739, "bot_watch_nodes" },
    { 0x173A, "bot_weap_built_in_attachments" },
    { 0x173B, "bot_weap_personality" },
    { 0x173C, "bot_weap_statstable" },
    { 0x173D, "bothbarrels" },
    { 0x173E, "bothplayerssplitscreen" },
    { 0x173F, "botlastloadout" },
    { 0x1740, "botlastloadoutdifficulty" },
    { 0x1741, "botlastloadoutpersonality" },
    { 0x1742, "botloadoutfavoritecamoprimary" },
    { 0x1743, "botloadoutfavoritecamosecondary" },
    { 0x1744, "botloadoutsets" },
    { 0x1745, "botloadouttemplates" },
    { 0x1746, "bots" },
    { 0x1747, "bots_disable_team_switching" },
    { 0x1748, "bots_exist" },
    { 0x1749, "bots_gametype_handles_class_choice" },
    { 0x174A, "bots_gametype_handles_team_choice" },
    { 0x174B, "bots_ignore_team_balance" },
    { 0x174C, "bots_notify_on_disconnect" },
    { 0x174D, "bots_notify_on_spawn" },
    { 0x174E, "bots_remove_from_array_on_notify" },
    { 0x174F, "bots_update_difficulty" },
    { 0x1750, "bots_used" },
    { 0x1751, "bottarget" },
    { 0x1752, "bottargets" },
    { 0x1753, "bottom" },
    { 0x1754, "boulder_originandangles" },
    { 0x1755, "boulderbarrage" },
    { 0x1756, "bouncegate" },
    { 0x1757, "bouncelight" },
    { 0x1758, "bouncing_betty_animated" },
    { 0x1759, "bouncingbettyarray" },
    { 0x175A, "bounds" },
    { 0x175B, "box_extent" },
    { 0x175C, "boxes" },
    { 0x175D, "boxsettings" },
    { 0x175E, "boxtouchonly" },
    { 0x175F, "boxtruck_explode" },
    { 0x1760, "boxtype" },
    { 0x1761, "bp" },
    { 0x1762, "bplayerisinsidesafehouse" },
    { 0x1763, "bplayerleash" },
    { 0x1764, "bplayerscanon" },
    { 0x1765, "bpm" },
    { 0x1766, "braggingrightsloser" },
    { 0x1767, "brakingcurrenttime" },
    { 0x1768, "bravo" },
    { 0x1769, "bravo_leader" },
    { 0x176A, "breach_abort" },
    { 0x176B, "breach_ai_reset" },
    { 0x176C, "breach_ajani_land" },
    { 0x176D, "breach_anims" },
    { 0x176E, "breach_backtrack_fail" },
    { 0x176F, "breach_bad_guy2_gets_shot" },
    { 0x1770, "breach_bad_weapon_hint" },
    { 0x1771, "breach_charge" },
    { 0x1772, "breach_charge_2" },
    { 0x1773, "breach_cleanup" },
    { 0x1774, "breach_death_anims" },
    { 0x1775, "breach_debug_display_animnames" },
    { 0x1776, "breach_dof" },
    { 0x1777, "breach_dont_fire" },
    { 0x1778, "breach_doors" },
    { 0x1779, "breach_enemies_stunned" },
    { 0x177A, "breach_enemy_6" },
    { 0x177B, "breach_enemy_cancel_ragdoll" },
    { 0x177C, "breach_enemy_catch_exceptions" },
    { 0x177D, "breach_enemy_ignored_by_friendlies" },
    { 0x177E, "breach_enemy_ragdoll_on_death" },
    { 0x177F, "breach_enemy_spawner_think" },
    { 0x1780, "breach_enemy_track_status" },
    { 0x1781, "breach_enemy_waitfor_breach_ending" },
    { 0x1782, "breach_enemy_waitfor_death" },
    { 0x1783, "breach_enemy_waitfor_death_counter" },
    { 0x1784, "breach_explosion" },
    { 0x1785, "breach_failed_to_start" },
    { 0x1786, "breach_fire_straight" },
    { 0x1787, "breach_friendlies_ready_at_other_door" },
    { 0x1788, "breach_friendlies_restore_grenades" },
    { 0x1789, "breach_friendlies_take_grenades" },
    { 0x178A, "breach_friendly_hint" },
    { 0x178B, "breach_functions" },
    { 0x178C, "breach_fx" },
    { 0x178D, "breach_fx_setup" },
    { 0x178E, "breach_gideon_land" },
    { 0x178F, "breach_group_trigger_think" },
    { 0x1790, "breach_groups" },
    { 0x1791, "breach_guy_think" },
    { 0x1792, "breach_guys" },
    { 0x1793, "breach_hint_cleanup" },
    { 0x1794, "breach_hint_create" },
    { 0x1795, "breach_hostage_spawner_think" },
    { 0x1796, "breach_icon_think" },
    { 0x1797, "breach_index" },
    { 0x1798, "breach_joker_land" },
    { 0x1799, "breach_lighting" },
    { 0x179A, "breach_missionfailed" },
    { 0x179B, "breach_near_player" },
    { 0x179C, "breach_no_auto_reload" },
    { 0x179D, "breach_not_ready_hint" },
    { 0x179E, "breach_office_door" },
    { 0x179F, "breach_origin" },
    { 0x17A0, "breach_participants_ready_to_proceed" },
    { 0x17A1, "breach_passive_player" },
    { 0x17A2, "breach_passive_time" },
    { 0x17A3, "breach_play_fx" },
    { 0x17A4, "breach_player_land" },
    { 0x17A5, "breach_reloading_hint" },
    { 0x17A6, "breach_reset_animname" },
    { 0x17A7, "breach_reset_goaladius" },
    { 0x17A8, "breach_rumble" },
    { 0x17A9, "breach_set_animname" },
    { 0x17AA, "breach_set_goaladius" },
    { 0x17AB, "breach_should_be_skipped" },
    { 0x17AC, "breach_signal" },
    { 0x17AD, "breach_slo_mo_exit" },
    { 0x17AE, "breach_slow_down" },
    { 0x17AF, "breach_spawner_setup" },
    { 0x17B0, "breach_think" },
    { 0x17B1, "breach_too_many_enemies_hint" },
    { 0x17B2, "breach_top_off_weapon" },
    { 0x17B3, "breach_trigger_cleanup" },
    { 0x17B4, "breach_trigger_think" },
    { 0x17B5, "breach_use_triggers" },
    { 0x17B6, "breachactors" },
    { 0x17B7, "breachdialogreminders" },
    { 0x17B8, "breachdonotfire" },
    { 0x17B9, "breached" },
    { 0x17BA, "breachenemies" },
    { 0x17BB, "breachenemies_active" },
    { 0x17BC, "breachenemies_alive" },
    { 0x17BD, "breacher_think" },
    { 0x17BE, "breachers" },
    { 0x17BF, "breachersready" },
    { 0x17C0, "breachfailstate" },
    { 0x17C1, "breachfinished" },
    { 0x17C2, "breachfriendlies" },
    { 0x17C3, "breachfriendlies_can_teleport" },
    { 0x17C4, "breachfriendlies_grenades_empty" },
    { 0x17C5, "breachignoreenemy_count" },
    { 0x17C6, "breaching" },
    { 0x17C7, "breaching_shots_fired" },
    { 0x17C8, "breachless_door_opens" },
    { 0x17C9, "breachtargetarraymonitor" },
    { 0x17CA, "breachtargets" },
    { 0x17CB, "breachtrigger" },
    { 0x17CC, "bread_crumbs" },
    { 0x17CD, "break_both_climb_hint" },
    { 0x17CE, "break_detonate_frb_hint" },
    { 0x17CF, "break_exfil_out_bounds" },
    { 0x17D0, "break_exo_cloak_hint" },
    { 0x17D1, "break_from_ignoreall" },
    { 0x17D2, "break_glass" },
    { 0x17D3, "break_glass_when_near" },
    { 0x17D4, "break_hovertank_reload_hint" },
    { 0x17D5, "break_if_flashed_sonic" },
    { 0x17D6, "break_ignore_all_on_damage" },
    { 0x17D7, "break_left_climb_hint" },
    { 0x17D8, "break_me_out_if_player_found" },
    { 0x17D9, "break_nearest_light" },
    { 0x17DA, "break_office_glass_ahead_of_time" },
    { 0x17DB, "break_out_and_fight" },
    { 0x17DC, "break_out_if_damaged" },
    { 0x17DD, "break_prone_hint" },
    { 0x17DE, "break_right_climb_hint" },
    { 0x17DF, "breakable_light" },
    { 0x17E0, "breakables_fx" },
    { 0x17E1, "breaking" },
    { 0x17E2, "breakout_glass" },
    { 0x17E3, "breakout_opfor_cleanup" },
    { 0x17E4, "breakoutofshootingifwanttomoveup" },
    { 0x17E5, "breaks_os" },
    { 0x17E6, "breaktime" },
    { 0x17E7, "breathers" },
    { 0x17E8, "breathingmanager" },
    { 0x17E9, "breathingstoptime" },
    { 0x17EA, "brick" },
    { 0x17EB, "brick_smash_setup" },
    { 0x17EC, "bridge" },
    { 0x17ED, "bridge_atlas_suv_drive_up" },
    { 0x17EE, "bridge_car_explode" },
    { 0x17EF, "bridge_chunks" },
    { 0x17F0, "bridge_civs" },
    { 0x17F1, "bridge_collapse_anim" },
    { 0x17F2, "bridge_collapse_mob_explosion" },
    { 0x17F3, "bridge_collapse_rumble" },
    { 0x17F4, "bridge_collapse_rumble_steady" },
    { 0x17F5, "bridge_collapse_rumble_timed" },
    { 0x17F6, "bridge_collapse_screen_effects" },
    { 0x17F7, "bridge_collapse_sequence" },
    { 0x17F8, "bridge_collapsed" },
    { 0x17F9, "bridge_dialogue" },
    { 0x17FA, "bridge_enemies" },
    { 0x17FB, "bridge_explosion" },
    { 0x17FC, "bridge_fall" },
    { 0x17FD, "bridge_fire_clear" },
    { 0x17FE, "bridge_glows" },
    { 0x17FF, "bridge_idle_anims" },
    { 0x1800, "bridge_kva_hasmat" },
    { 0x1801, "bridge_player_notetrack_handler" },
    { 0x1802, "bridge_post_crash_pitbull_crawl_done" },
    { 0x1803, "bridge_rappel_squad" },
    { 0x1804, "bridge_reso_detonation" },
    { 0x1805, "bridge_screenfx" },
    { 0x1806, "bridge_soot" },
    { 0x1807, "bridge_street_fight" },
    { 0x1808, "bridge_takedown_fail" },
    { 0x1809, "bridge_takedown_fail_fade" },
    { 0x180A, "bridge_takedown_jump_complete" },
    { 0x180B, "bridge_takedown_success" },
    { 0x180C, "bridge_tanker_explode" },
    { 0x180D, "brief_fx" },
    { 0x180E, "briefing_allies" },
    { 0x180F, "briefing_ambient_allies" },
    { 0x1810, "briefing_ambient_ally_setup" },
    { 0x1811, "briefing_anim_struct" },
    { 0x1812, "briefing_begin" },
    { 0x1813, "briefing_foley" },
    { 0x1814, "briefing_main" },
    { 0x1815, "briefing_obj" },
    { 0x1816, "briefing_player" },
    { 0x1817, "briefing_start" },
    { 0x1818, "briefing_vignette_anims" },
    { 0x1819, "briefing_vignette_cleanup" },
    { 0x181A, "briefing_vignettes" },
    { 0x181B, "brinkofdeathkillstreak" },
    { 0x181C, "broken" },
    { 0x181D, "broken_door" },
    { 0x181E, "broken_glass" },
    { 0x181F, "broom_sweep_dust_fx" },
    { 0x1820, "brush" },
    { 0x1821, "brush_delete" },
    { 0x1822, "brush_show" },
    { 0x1823, "brush_shown" },
    { 0x1824, "brush_throw" },
    { 0x1825, "bsaveinprogress" },
    { 0x1826, "bsc_squelched" },
    { 0x1827, "bscripteddeath" },
    { 0x1828, "bsgods_condition_to_state_driving" },
    { 0x1829, "bsgods_condition_to_state_intro" },
    { 0x182A, "bsgods_enter_state_driving" },
    { 0x182B, "bsgods_in_state_driving" },
    { 0x182C, "bsgods_preset_constructor" },
    { 0x182D, "bsgods_preset_instance_init_callback" },
    { 0x182E, "bsharpturnduringsharpturn" },
    { 0x182F, "bshootwhilemoving" },
    { 0x1830, "bsniperenabled" },
    { 0x1831, "bsoundlooping" },
    { 0x1832, "btr_fire_at_target" },
    { 0x1833, "btr_get_target" },
    { 0x1834, "btr_turret_think" },
    { 0x1835, "bubllength" },
    { 0x1836, "buddy" },
    { 0x1837, "buddyjoinedvo" },
    { 0x1838, "buddyjoinwarbirdsetup" },
    { 0x1839, "buddyspawn" },
    { 0x183A, "bufferedchildstats" },
    { 0x183B, "bufferedstats" },
    { 0x183C, "build_aianims" },
    { 0x183D, "build_all_treadfx" },
    { 0x183E, "build_attach_models" },
    { 0x183F, "build_bulletshield" },
    { 0x1840, "build_call_buttons" },
    { 0x1841, "build_cover_death" },
    { 0x1842, "build_death_badplace" },
    { 0x1843, "build_death_jolt_delay" },
    { 0x1844, "build_deathanim" },
    { 0x1845, "build_deathfx" },
    { 0x1846, "build_deathfx_generic_script_model" },
    { 0x1847, "build_deathfx_override" },
    { 0x1848, "build_deathmodel" },
    { 0x1849, "build_deathquake" },
    { 0x184A, "build_deckdust" },
    { 0x184B, "build_destructible" },
    { 0x184C, "build_drive" },
    { 0x184D, "build_elevators" },
    { 0x184E, "build_exhaust" },
    { 0x184F, "build_frontarmor" },
    { 0x1850, "build_fx" },
    { 0x1851, "build_gaz_death" },
    { 0x1852, "build_grenadeshield" },
    { 0x1853, "build_hideparts" },
    { 0x1854, "build_hovertank_death" },
    { 0x1855, "build_humvee_anims" },
    { 0x1856, "build_idle" },
    { 0x1857, "build_is_airplane" },
    { 0x1858, "build_is_helicopter" },
    { 0x1859, "build_life" },
    { 0x185A, "build_light" },
    { 0x185B, "build_light_override" },
    { 0x185C, "build_localinit" },
    { 0x185D, "build_mainturret" },
    { 0x185E, "build_misc_anims" },
    { 0x185F, "build_missile_launcher" },
    { 0x1860, "build_new_view_matrix" },
    { 0x1861, "build_nodes_for_airspace" },
    { 0x1862, "build_path_by_targetname" },
    { 0x1863, "build_path_info" },
    { 0x1864, "build_quake" },
    { 0x1865, "build_radiusdamage" },
    { 0x1866, "build_rider_death_func" },
    { 0x1867, "build_rocket_deathfx" },
    { 0x1868, "build_rumble" },
    { 0x1869, "build_rumble_override" },
    { 0x186A, "build_rumble_unique" },
    { 0x186B, "build_shoot_shock" },
    { 0x186C, "build_single_tread" },
    { 0x186D, "build_team" },
    { 0x186E, "build_technical" },
    { 0x186F, "build_template" },
    { 0x1870, "build_threat_data" },
    { 0x1871, "build_treadfx" },
    { 0x1872, "build_treadfx_override_get_surface_function" },
    { 0x1873, "build_treadfx_override_tags" },
    { 0x1874, "build_treadfx_script_model" },
    { 0x1875, "build_turret" },
    { 0x1876, "build_unload_groups" },
    { 0x1877, "build_vrap_death" },
    { 0x1878, "build_walker_death" },
    { 0x1879, "buildattachmentmaps" },
    { 0x187A, "buildbaseweaponlist" },
    { 0x187B, "buildchallegeinfo" },
    { 0x187C, "buildchallengetableinfo" },
    { 0x187D, "builddot_damage" },
    { 0x187E, "builddot_ontick" },
    { 0x187F, "builddot_startloop" },
    { 0x1880, "builddot_wait" },
    { 0x1881, "building_1" },
    { 0x1882, "building_bone" },
    { 0x1883, "building_exit_arrived" },
    { 0x1884, "building_explode" },
    { 0x1885, "building_explosion_01" },
    { 0x1886, "building_jump_done" },
    { 0x1887, "building_jump_initiate" },
    { 0x1888, "building_research_bridge" },
    { 0x1889, "buildscoreboardtype" },
    { 0x188A, "buildshadowgeomopt" },
    { 0x188B, "buildshadowgeomopt_ng" },
    { 0x188C, "buildshadowmapgeomopt" },
    { 0x188D, "buildvalidflightpaths" },
    { 0x188E, "buildweapondata" },
    { 0x188F, "buildweaponname" },
    { 0x1890, "buildweaponnamecamo" },
    { 0x1891, "buildweaponnamereticle" },
    { 0x1892, "buildweaponsettings" },
    { 0x1893, "bulblength" },
    { 0x1894, "bulbradius" },
    { 0x1895, "bullet_armor" },
    { 0x1896, "bullet_attack" },
    { 0x1897, "bullet_break_glass_gag_timer" },
    { 0x1898, "bullet_cluster_01" },
    { 0x1899, "bullet_cluster_02" },
    { 0x189A, "bullet_cluster_03" },
    { 0x189B, "bullet_cluster_04" },
    { 0x189C, "bullet_cluster_06" },
    { 0x189D, "bullet_cluster_07" },
    { 0x189E, "bullet_cluster_12" },
    { 0x189F, "bullet_cluster_15" },
    { 0x18A0, "bullet_cluster_32" },
    { 0x18A1, "bullet_cluster_33" },
    { 0x18A2, "bullet_cluster_36" },
    { 0x18A3, "bullet_cluster_37" },
    { 0x18A4, "bullet_cluster_40" },
    { 0x18A5, "bullet_cluster_41" },
    { 0x18A6, "bullet_cluster_43" },
    { 0x18A7, "bullet_cluster_45" },
    { 0x18A8, "bullet_deflector_shield" },
    { 0x18A9, "bullet_magnet_shield" },
    { 0x18AA, "bullet_rain_drone_swarm" },
    { 0x18AB, "bullet_resistance" },
    { 0x18AC, "bullet_shield_shield" },
    { 0x18AD, "bullet_thing" },
    { 0x18AE, "bulletdamagemod" },
    { 0x18AF, "bullethitcallback" },
    { 0x18B0, "bulletpenetrationevent" },
    { 0x18B1, "bullets_break_office_glass_gag" },
    { 0x18B2, "bulletshielded" },
    { 0x18B3, "bulletsinclip" },
    { 0x18B4, "bulletstreak" },
    { 0x18B5, "bulletwhizbycheck_whilemoving" },
    { 0x18B6, "bulletwhizbycheckloop" },
    { 0x18B7, "bulletwhizbyreaction" },
    { 0x18B8, "bump_into_awareness" },
    { 0x18B9, "bump_music_for_burke_takedown" },
    { 0x18BA, "bump_nag_vo" },
    { 0x18BB, "bumper_test" },
    { 0x18BC, "bunker_guy01" },
    { 0x18BD, "bunker_guy02" },
    { 0x18BE, "bunker_guy03" },
    { 0x18BF, "bunker_intro_anim" },
    { 0x18C0, "bunker_respawn_handler" },
    { 0x18C1, "bunker_settings" },
    { 0x18C2, "buoys_return_to_bobbing" },
    { 0x18C3, "burke" },
    { 0x18C4, "burke_180_function" },
    { 0x18C5, "burke_advance" },
    { 0x18C6, "burke_advance_hospital" },
    { 0x18C7, "burke_aggression" },
    { 0x18C8, "burke_alert" },
    { 0x18C9, "burke_ask_player_to_use_bike" },
    { 0x18CA, "burke_at_school_door" },
    { 0x18CB, "burke_beam_bend" },
    { 0x18CC, "burke_bike" },
    { 0x18CD, "burke_bike_speed" },
    { 0x18CE, "burke_breach" },
    { 0x18CF, "burke_breach_interrupt" },
    { 0x18D0, "burke_burst_shoot" },
    { 0x18D1, "burke_bus_goal" },
    { 0x18D2, "burke_busted_light" },
    { 0x18D3, "burke_cheap_flashlight_setup" },
    { 0x18D4, "burke_cr_foley_console" },
    { 0x18D5, "burke_cr_foley_enter" },
    { 0x18D6, "burke_cr_foley_idle" },
    { 0x18D7, "burke_cr_foley_start" },
    { 0x18D8, "burke_deadroom_door" },
    { 0x18D9, "burke_disable_cqb" },
    { 0x18DA, "burke_dismount" },
    { 0x18DB, "burke_dismount_timing_fix" },
    { 0x18DC, "burke_drone_warning_dialogue" },
    { 0x18DD, "burke_exfil_approach" },
    { 0x18DE, "burke_exfil_lighting" },
    { 0x18DF, "burke_exit" },
    { 0x18E0, "burke_exo_cloak_on" },
    { 0x18E1, "burke_exo_push_end_early" },
    { 0x18E2, "burke_exo_push_wait" },
    { 0x18E3, "burke_fastzip_aim_turret" },
    { 0x18E4, "burke_fastzip_scene" },
    { 0x18E5, "burke_feet01" },
    { 0x18E6, "burke_forest_stealth_movement" },
    { 0x18E7, "burke_forest_takedown" },
    { 0x18E8, "burke_gate_jtbk_land" },
    { 0x18E9, "burke_gate_jtbk_lift" },
    { 0x18EA, "burke_gets_up" },
    { 0x18EB, "burke_greets_alpha_dialogue" },
    { 0x18EC, "burke_hand_plant_lf_wallclimb" },
    { 0x18ED, "burke_hand_plant_rt_wallclimb" },
    { 0x18EE, "burke_hill_slide" },
    { 0x18EF, "burke_intro_anim" },
    { 0x18F0, "burke_intro_dialogue" },
    { 0x18F1, "burke_intro_lighting" },
    { 0x18F2, "burke_knocked_to_ground" },
    { 0x18F3, "burke_mech_march_movement" },
    { 0x18F4, "burke_middle_takedown" },
    { 0x18F5, "burke_mounts_bike" },
    { 0x18F6, "burke_move_ahead_wait_function" },
    { 0x18F7, "burke_move_into_office" },
    { 0x18F8, "burke_move_through_alley_cover" },
    { 0x18F9, "burke_onbike" },
    { 0x18FA, "burke_path_through_school" },
    { 0x18FB, "burke_path_to_school" },
    { 0x18FC, "burke_patrol_takedown_02" },
    { 0x18FD, "burke_patrol_takedown_02_cleanup" },
    { 0x18FE, "burke_post_breach_move" },
    { 0x18FF, "burke_powers_up_bike" },
    { 0x1900, "burke_pre_sentinel_kva_reveal" },
    { 0x1901, "burke_rally_init" },
    { 0x1902, "burke_rally_street_dialogue" },
    { 0x1903, "burke_rappel" },
    { 0x1904, "burke_rappel_rope_swap" },
    { 0x1905, "burke_red_arm_light" },
    { 0x1906, "burke_red_arm_light_checkpoint" },
    { 0x1907, "burke_reunite_with_player_alley" },
    { 0x1908, "burke_rim_lights" },
    { 0x1909, "burke_river_entry_splash_fx" },
    { 0x190A, "burke_river_looping_splash_fx" },
    { 0x190B, "burke_rooftop_combat" },
    { 0x190C, "burke_rooftop_combat_animscript" },
    { 0x190D, "burke_rope" },
    { 0x190E, "burke_rope_long" },
    { 0x190F, "burke_run_slide" },
    { 0x1910, "burke_school_approach_idle" },
    { 0x1911, "burke_school_approach_idle_skip" },
    { 0x1912, "burke_se_forest_takedown_01" },
    { 0x1913, "burke_sentinel_kva_reveal" },
    { 0x1914, "burke_server_room_se" },
    { 0x1915, "burke_setupanimations" },
    { 0x1916, "burke_shimmey_setup" },
    { 0x1917, "burke_shimmy_1" },
    { 0x1918, "burke_shimmy_2" },
    { 0x1919, "burke_shimmy_2b" },
    { 0x191A, "burke_slide_02" },
    { 0x191B, "burke_solo_takedown" },
    { 0x191C, "burke_spit_blood" },
    { 0x191D, "burke_spot_lighting" },
    { 0x191E, "burke_startle_stairs" },
    { 0x191F, "burke_tree_slide_fx" },
    { 0x1920, "burke_walk_lighting" },
    { 0x1921, "burke_wall_climb_teleport" },
    { 0x1922, "burke_wall_idle" },
    { 0x1923, "burke_wall_idle_skip" },
    { 0x1924, "burkeambushnohitnotetrack" },
    { 0x1925, "burkecourtyardboostjump" },
    { 0x1926, "burkeopenatriumexitdoor" },
    { 0x1927, "burkestruggledeath" },
    { 0x1928, "burn_and_crash" },
    { 0x1929, "burn_on" },
    { 0x192A, "burning" },
    { 0x192B, "burning_trash_fire" },
    { 0x192C, "burnville_paratrooper_hack" },
    { 0x192D, "burnville_paratrooper_hack_loop" },
    { 0x192E, "burst_fire" },
    { 0x192F, "burst_fire_settings" },
    { 0x1930, "burst_fire_unmanned" },
    { 0x1931, "burst_fire_warbird" },
    { 0x1932, "burst_fire_weapon" },
    { 0x1933, "burstdelay" },
    { 0x1934, "burstfirenumshots" },
    { 0x1935, "burstmax" },
    { 0x1936, "burstmin" },
    { 0x1937, "burstshootanimrate" },
    { 0x1938, "burstshot" },
    { 0x1939, "bus_5_hop_blocker_a" },
    { 0x193A, "bus_5_hop_blocker_b" },
    { 0x193B, "bus_chase_suv_explode" },
    { 0x193C, "bus_chase_suv_lose_control" },
    { 0x193D, "bus_chase_suv_oneshots" },
    { 0x193E, "bus_crash" },
    { 0x193F, "bus_crash_at_end" },
    { 0x1940, "bus_crash_hold_on_last_frame" },
    { 0x1941, "bus_crash_setup_backup_collision" },
    { 0x1942, "bus_crash_start" },
    { 0x1943, "bus_jump_count" },
    { 0x1944, "bus_jumping_notetrack_setup" },
    { 0x1945, "bus_kva_impact_sparks" },
    { 0x1946, "bus_skid" },
    { 0x1947, "busereadyidle" },
    { 0x1948, "busted_light_gag" },
    { 0x1949, "butress_animate" },
    { 0x194A, "butress_origin_fix" },
    { 0x194B, "button" },
    { 0x194C, "button_down" },
    { 0x194D, "button_hint_disable" },
    { 0x194E, "button_hint_display" },
    { 0x194F, "button_is_clicked" },
    { 0x1950, "button_is_held" },
    { 0x1951, "button_is_kb" },
    { 0x1952, "button_mash_detection" },
    { 0x1953, "button_mash_dynamic_hint" },
    { 0x1954, "button_mash_level" },
    { 0x1955, "button_mash_success" },
    { 0x1956, "button_pressed" },
    { 0x1957, "button_pressed_think" },
    { 0x1958, "button_presses" },
    { 0x1959, "button_prompt_on_cardoor" },
    { 0x195A, "button_switch" },
    { 0x195B, "buttonclick" },
    { 0x195C, "buttondown" },
    { 0x195D, "buttonisheld" },
    { 0x195E, "buttonmash_add_per_press" },
    { 0x195F, "buttonmash_decay" },
    { 0x1960, "buttonmash_decay_per_frame" },
    { 0x1961, "buttonmash_hint_cleanup" },
    { 0x1962, "buttonmash_max" },
    { 0x1963, "buttonmash_monitor" },
    { 0x1964, "buttonmash_value" },
    { 0x1965, "buttonpressed_internal" },
    { 0x1966, "buttons" },
    { 0x1967, "buttontimer" },
    { 0x1968, "buttontimertotal" },
    { 0x1969, "buttress_function" },
    { 0x196A, "buzzkillevent" },
    { 0x196B, "bypassclasschoice" },
    { 0x196C, "bypassclasschoicefunc" },
    { 0x196D, "bystander_oppression_event_ents" },
    { 0x196E, "c4_earthquake" },
    { 0x196F, "c4_weaponname" },
    { 0x1970, "c4array" },
    { 0x1971, "c4damage" },
    { 0x1972, "c4death" },
    { 0x1973, "c4deathdetonate" },
    { 0x1974, "c4deatheffect" },
    { 0x1975, "c4empdamage" },
    { 0x1976, "c4empkillstreakwait" },
    { 0x1977, "c4explodethisframe" },
    { 0x1978, "cac" },
    { 0x1979, "cac_camera_offset" },
    { 0x197A, "cac_camera_targetoffset" },
    { 0x197B, "cac_camerazoff" },
    { 0x197C, "cac_camerazoff_zoom" },
    { 0x197D, "cac_camoffset_angle_ratio" },
    { 0x197E, "cac_camoffset_ratio" },
    { 0x197F, "cac_dist" },
    { 0x1980, "cac_framedelay" },
    { 0x1981, "cac_getcustomclassloc" },
    { 0x1982, "cac_getequipment" },
    { 0x1983, "cac_getequipmentextra" },
    { 0x1984, "cac_getkillstreak" },
    { 0x1985, "cac_getkillstreakmodule" },
    { 0x1986, "cac_getoffhand" },
    { 0x1987, "cac_getperk" },
    { 0x1988, "cac_getweapon" },
    { 0x1989, "cac_getweaponattachment" },
    { 0x198A, "cac_getweaponattachmentthree" },
    { 0x198B, "cac_getweaponattachmenttwo" },
    { 0x198C, "cac_getweaponcamo" },
    { 0x198D, "cac_getweaponreticle" },
    { 0x198E, "cac_getwildcard" },
    { 0x198F, "cac_has_slam" },
    { 0x1990, "cac_modified_damage" },
    { 0x1991, "cac_ratio_zoom" },
    { 0x1992, "cac_selector" },
    { 0x1993, "cac_targetzoff" },
    { 0x1994, "cac_targetzoff_zoom" },
    { 0x1995, "cac_weap_loot_offset" },
    { 0x1996, "cac_weap_offset" },
    { 0x1997, "cac_weap_screen_offset" },
    { 0x1998, "cac_weap_tuning" },
    { 0x1999, "cac_weap_tuning_camoffset" },
    { 0x199A, "cac_weap_tuning_weap_sideoffset" },
    { 0x199B, "cac_weap_tuning_weap_zoffset" },
    { 0x199C, "cac_weapon" },
    { 0x199D, "cacloadout" },
    { 0x199E, "cafe_irons_speech_bink" },
    { 0x199F, "cafe_market_damb" },
    { 0x19A0, "cafe_market_moped_away" },
    { 0x19A1, "cafe_market_music_play" },
    { 0x19A2, "cafe_market_music_stop" },
    { 0x19A3, "cafe_market_plane_flyover" },
    { 0x19A4, "cafecamerascancounter" },
    { 0x19A5, "cafecameraumbrella" },
    { 0x19A6, "cafecivilianmeetandgreet" },
    { 0x19A7, "cafeendcamerascan" },
    { 0x19A8, "cafegeeseflyinganimation" },
    { 0x19A9, "cafeilanaseat" },
    { 0x19AA, "cafeinitvendorgate" },
    { 0x19AB, "cafeintrodialog" },
    { 0x19AC, "cafeintrofov" },
    { 0x19AD, "cafemarketilanabackyardwait" },
    { 0x19AE, "cafemarketmoveilana" },
    { 0x19AF, "cafemarketplayerfollowtarget" },
    { 0x19B0, "cafemarketslowdownplayermore" },
    { 0x19B1, "cafeoutrositter" },
    { 0x19B2, "cafeplayercameralook" },
    { 0x19B3, "cafesetupilanabackpack" },
    { 0x19B4, "cafesetupplayerseat" },
    { 0x19B5, "cafesetuptouristilana" },
    { 0x19B6, "cafesittingreader" },
    { 0x19B7, "cafesittingreaderchoosenextanim" },
    { 0x19B8, "cafesittingreaderplaynextanim" },
    { 0x19B9, "cafeteasipper" },
    { 0x19BA, "cafeteria_reinforcements" },
    { 0x19BB, "cafeteria_squad_pressure" },
    { 0x19BC, "cafevideolog" },
    { 0x19BD, "cafewaiter" },
    { 0x19BE, "calc_cam_lookat" },
    { 0x19BF, "calc_f" },
    { 0x19C0, "calc_f_from_avatar" },
    { 0x19C1, "calc_f_from_avatar_spawnpoint" },
    { 0x19C2, "calc_f_fromscreen" },
    { 0x19C3, "calc_flock_goal_pos" },
    { 0x19C4, "calc_new_pos" },
    { 0x19C5, "calc_target_dir" },
    { 0x19C6, "calcanimstartpos" },
    { 0x19C7, "calctrackingyaw" },
    { 0x19C8, "calculate_aerial_pathnodes" },
    { 0x19C9, "calculate_aim_offset" },
    { 0x19CA, "calculate_base_target_offset" },
    { 0x19CB, "calculate_break_time" },
    { 0x19CC, "calculate_defend_stance" },
    { 0x19CD, "calculate_dodge_position" },
    { 0x19CE, "calculate_dodge_positions" },
    { 0x19CF, "calculate_flock_goal_positions" },
    { 0x19D0, "calculate_lateral_move_accuracy" },
    { 0x19D1, "calculate_locator_anim_speed" },
    { 0x19D2, "calculate_move_to_goal_yaw" },
    { 0x19D3, "calculate_player_wounded_accuracy" },
    { 0x19D4, "calculate_rope_target" },
    { 0x19D5, "calculate_sprinting_jumping_accuracy" },
    { 0x19D6, "calculate_stance_accuracy" },
    { 0x19D7, "calculate_tactical_score" },
    { 0x19D8, "calculate_tag_on_path_grid" },
    { 0x19D9, "calculate_threat_level" },
    { 0x19DA, "calculate_water_pos" },
    { 0x19DB, "calculate_zone_node_extents" },
    { 0x19DC, "calculated_aerial_nodes_done" },
    { 0x19DD, "calculated_aerial_nodes_in_progress" },
    { 0x19DE, "calculated_nearest_node" },
    { 0x19DF, "calculatedistances" },
    { 0x19E0, "calculatehoverlocation" },
    { 0x19E1, "calculateinitialposition" },
    { 0x19E2, "calculatekd" },
    { 0x19E3, "calculateleftstickdeadzone" },
    { 0x19E4, "calculatematchplaystyle" },
    { 0x19E5, "calculatenewhoverdestination" },
    { 0x19E6, "calculatenodeoffset" },
    { 0x19E7, "calculatenodeoffsetfromanimationdelta" },
    { 0x19E8, "calculatenodetransitionangles" },
    { 0x19E9, "calculatespm" },
    { 0x19EA, "calculations_in_progress" },
    { 0x19EB, "call_elevator" },
    { 0x19EC, "call_for_backup" },
    { 0x19ED, "call_in_assistance" },
    { 0x19EE, "callback" },
    { 0x19EF, "callback_codeendgame" },
    { 0x19F0, "callback_entityoutofworld" },
    { 0x19F1, "callback_hostmigration" },
    { 0x19F2, "callback_killingblow" },
    { 0x19F3, "callback_playerconnect" },
    { 0x19F4, "callback_playerdamage" },
    { 0x19F5, "callback_playerdamage_internal" },
    { 0x19F6, "callback_playerdisconnect" },
    { 0x19F7, "callback_playergrenadesuicide" },
    { 0x19F8, "callback_playerkilled" },
    { 0x19F9, "callback_playerlaststand" },
    { 0x19FA, "callback_playerlaststandhorde" },
    { 0x19FB, "callback_playermigrated" },
    { 0x19FC, "callback_startgametype" },
    { 0x19FD, "callbackcodeendgame" },
    { 0x19FE, "callbackentityoutofworld" },
    { 0x19FF, "callbackhostmigration" },
    { 0x1A00, "callbackplayerconnect" },
    { 0x1A01, "callbackplayerdamage" },
    { 0x1A02, "callbackplayerdisconnect" },
    { 0x1A03, "callbackplayergrenadesuicide" },
    { 0x1A04, "callbackplayerkilled" },
    { 0x1A05, "callbackplayerlaststand" },
    { 0x1A06, "callbackplayermigrated" },
    { 0x1A07, "callbacks" },
    { 0x1A08, "callbackstartgametype" },
    { 0x1A09, "callbackvoid" },
    { 0x1A0A, "calledout" },
    { 0x1A0B, "caller" },
    { 0x1A0C, "calloptionalbehaviorcallback" },
    { 0x1A0D, "callouttypewillrepeat" },
    { 0x1A0E, "callstrike" },
    { 0x1A0F, "callstrike_bomb" },
    { 0x1A10, "cam_percent_away" },
    { 0x1A11, "cam_scan_lp" },
    { 0x1A12, "cam_zoom_in" },
    { 0x1A13, "cam_zoom_out" },
    { 0x1A14, "camdirectionforward" },
    { 0x1A15, "came_from" },
    { 0x1A16, "camera" },
    { 0x1A17, "camera_array" },
    { 0x1A18, "camera_cut" },
    { 0x1A19, "camera_goal" },
    { 0x1A1A, "camera_helper" },
    { 0x1A1B, "camera_lookat" },
    { 0x1A1C, "camera_rotator_begin" },
    { 0x1A1D, "camera_rotator_think" },
    { 0x1A1E, "camera_scan" },
    { 0x1A1F, "camera_scanner_interior_killed" },
    { 0x1A20, "camera_scanner_interior_spotted" },
    { 0x1A21, "camera_scanner_interior_trigger_think" },
    { 0x1A22, "camera_scanner_think" },
    { 0x1A23, "camera_shake" },
    { 0x1A24, "camera_shake_on_turret_fire" },
    { 0x1A25, "camera_sway_tuning" },
    { 0x1A26, "camera_tag" },
    { 0x1A27, "camera_tag_angles" },
    { 0x1A28, "camera_tag_origin" },
    { 0x1A29, "camera_view_tuning" },
    { 0x1A2A, "cameradrift" },
    { 0x1A2B, "cameralinkpoint" },
    { 0x1A2C, "cameralookatescapevehicle" },
    { 0x1A2D, "cameraloop" },
    { 0x1A2E, "camerascanintrodialogue" },
    { 0x1A2F, "camerascanoutrodialog" },
    { 0x1A30, "cameraview" },
    { 0x1A31, "camerhelperarray" },
    { 0x1A32, "camlinkent" },
    { 0x1A33, "cammove" },
    { 0x1A34, "camoffset_ratio_cac" },
    { 0x1A35, "camoffset_ratio_lobby" },
    { 0x1A36, "camoffset_ratio_maxspeed" },
    { 0x1A37, "camoffset_ratio_prelobby" },
    { 0x1A38, "camoffset_ratio_prelobby_loot" },
    { 0x1A39, "camp_bomb_update" },
    { 0x1A3A, "camp_david_play_videos" },
    { 0x1A3B, "camp_david_reload_malfunction" },
    { 0x1A3C, "camp_david_thunder_transition" },
    { 0x1A3D, "camp_david_training_mute_device" },
    { 0x1A3E, "camp_scanner_guy" },
    { 0x1A3F, "camp_security_greeter" },
    { 0x1A40, "campaign" },
    { 0x1A41, "camparams" },
    { 0x1A42, "campdavid_player_arm_reveal" },
    { 0x1A43, "camper_guy" },
    { 0x1A44, "camper_time_started_hunting" },
    { 0x1A45, "camper_trigger_think" },
    { 0x1A46, "camping_needs_fallback_camp_location" },
    { 0x1A47, "camrotate" },
    { 0x1A48, "camzoff" },
    { 0x1A49, "can_be_damaged" },
    { 0x1A4A, "can_camp_near_others" },
    { 0x1A4B, "can_early_melee" },
    { 0x1A4C, "can_fire_turret" },
    { 0x1A4D, "can_melee_enemy_time" },
    { 0x1A4E, "can_pickup_bomb_time" },
    { 0x1A4F, "can_say_friendlyfire" },
    { 0x1A50, "can_see_attacker_for_a_bit" },
    { 0x1A51, "can_see_ent" },
    { 0x1A52, "can_see_origin" },
    { 0x1A53, "can_see_player" },
    { 0x1A54, "can_shoot_enemy" },
    { 0x1A55, "can_shoot_enemy_monitor" },
    { 0x1A56, "can_shoot_guns" },
    { 0x1A57, "can_shoot_missiles" },
    { 0x1A58, "can_shoot_weapons" },
    { 0x1A59, "can_teleport_ai_to_pos" },
    { 0x1A5A, "can_tip_think" },
    { 0x1A5B, "can_turret_start_play" },
    { 0x1A5C, "canal_adssetfovzoomin" },
    { 0x1A5D, "canal_balcony_smoke_and_spawn" },
    { 0x1A5E, "canal_binoc_hint" },
    { 0x1A5F, "canal_binoc_transition_in" },
    { 0x1A60, "canal_binoc_transition_out" },
    { 0x1A61, "canal_binocs_stop_zoom_in" },
    { 0x1A62, "canal_binocs_stop_zoom_out" },
    { 0x1A63, "canal_binocs_zoom_in" },
    { 0x1A64, "canal_binocs_zoom_out" },
    { 0x1A65, "canal_boat_explosion" },
    { 0x1A66, "canal_boat_hit_bottom" },
    { 0x1A67, "canal_breach_logic" },
    { 0x1A68, "canal_bridge_patrol_think" },
    { 0x1A69, "canal_bridge_patrols_spawn" },
    { 0x1A6A, "canal_chase_boats" },
    { 0x1A6B, "canal_convo_fov_shift_off" },
    { 0x1A6C, "canal_convo_fov_shift_on_start" },
    { 0x1A6D, "canal_convo_fov_shift_to_dead" },
    { 0x1A6E, "canal_convo_fov_shift_to_wp" },
    { 0x1A6F, "canal_cormack_move_to_window" },
    { 0x1A70, "canal_cormack_objective_convo" },
    { 0x1A71, "canal_delete_dead_demo_team" },
    { 0x1A72, "canal_dock_destroy" },
    { 0x1A73, "canal_door_button_hint_display" },
    { 0x1A74, "canal_drone_guard_sequence" },
    { 0x1A75, "canal_drone_guard_think" },
    { 0x1A76, "canal_drone_guards_move_to_struct_and_loop_animation" },
    { 0x1A77, "canal_drone_swarm_death_think" },
    { 0x1A78, "canal_drone_swarm_think" },
    { 0x1A79, "canal_emp_wave" },
    { 0x1A7A, "canal_enemy_damage_function" },
    { 0x1A7B, "canal_enemy_setup_post_explosive_pickup" },
    { 0x1A7C, "canal_fight_to_explosives_sequence" },
    { 0x1A7D, "canal_fight_to_weapon_platform" },
    { 0x1A7E, "canal_finale_button_mashing" },
    { 0x1A7F, "canal_finale_fov_shift_off" },
    { 0x1A80, "canal_finale_fov_shift_on" },
    { 0x1A81, "canal_finale_rumble" },
    { 0x1A82, "canal_finale_rumble_sm" },
    { 0x1A83, "canal_finale_sequence" },
    { 0x1A84, "canal_finale_shock" },
    { 0x1A85, "canal_finale_will_prep" },
    { 0x1A86, "canal_guard_player_close_check" },
    { 0x1A87, "canal_handle_bomb_pickup" },
    { 0x1A88, "canal_handle_bomb_plant_button_display" },
    { 0x1A89, "canal_handle_bomb_plant_start" },
    { 0x1A8A, "canal_handle_car_door_shields_vis" },
    { 0x1A8B, "canal_handle_dead_demo_team" },
    { 0x1A8C, "canal_handle_player_binoc_controls" },
    { 0x1A8D, "canal_highlight_dead_team" },
    { 0x1A8E, "canal_irons_open_door" },
    { 0x1A8F, "canal_jet_flyover" },
    { 0x1A90, "canal_jet_flyover2" },
    { 0x1A91, "canal_kamikaze_player_check" },
    { 0x1A92, "canal_laser" },
    { 0x1A93, "canal_logic" },
    { 0x1A94, "canal_middle_weapon_guards" },
    { 0x1A95, "canal_p1" },
    { 0x1A96, "canal_p2" },
    { 0x1A97, "canal_pop_smoke" },
    { 0x1A98, "canal_razorback" },
    { 0x1A99, "canal_razorback_turret_fire" },
    { 0x1A9A, "canal_razorback_turret_think" },
    { 0x1A9B, "canal_setup_dead_demo_team" },
    { 0x1A9C, "canal_setup_pt1" },
    { 0x1A9D, "canal_spawn_dead_demo_team" },
    { 0x1A9E, "canal_spawn_razorback" },
    { 0x1A9F, "canal_spawn_zipline_group1" },
    { 0x1AA0, "canal_spawn_zipline_group2" },
    { 0x1AA1, "canal_turn_player" },
    { 0x1AA2, "canal_turret_vehicle" },
    { 0x1AA3, "canal_turret_vehicle_passenger_think" },
    { 0x1AA4, "canal_turret_vehicle2" },
    { 0x1AA5, "canal_underwater_bullet_trails" },
    { 0x1AA6, "canal_video_board_cycle" },
    { 0x1AA7, "canal_wall_enemy_close_check" },
    { 0x1AA8, "canal_wall_enemy_think" },
    { 0x1AA9, "canal_wall_reinforcements" },
    { 0x1AAA, "canal_waterfall_last_fight" },
    { 0x1AAB, "canal_weapon_guards_spawn_and_think" },
    { 0x1AAC, "canal_weapon_platform_anim" },
    { 0x1AAD, "canal_weapon_platform_firing_loop" },
    { 0x1AAE, "canal_weapon_platform_vis_control" },
    { 0x1AAF, "canal_wmp_key_tweaks" },
    { 0x1AB0, "canals_part_2" },
    { 0x1AB1, "canbeplaced" },
    { 0x1AB2, "canblindfire" },
    { 0x1AB3, "cancalloutlocation" },
    { 0x1AB4, "cancelallbut" },
    { 0x1AB5, "cancelexitbuttonpressmonitor" },
    { 0x1AB6, "cancelkillcam" },
    { 0x1AB7, "cancelkillcamcallback" },
    { 0x1AB8, "cancelkillcamonuse" },
    { 0x1AB9, "cancelkillcamonuse_specificbutton" },
    { 0x1ABA, "cancelkillcamsafespawnbutton" },
    { 0x1ABB, "cancelkillcamsafespawncallback" },
    { 0x1ABC, "cancelkillcamusebutton" },
    { 0x1ABD, "cancelmode" },
    { 0x1ABE, "cancelnukeondeath" },
    { 0x1ABF, "cancelospbuddyexitcommand" },
    { 0x1AC0, "cancelpendingreinforcement" },
    { 0x1AC1, "cancelpossessbuttonpressmonitor" },
    { 0x1AC2, "cancelwarbirdbuddyexitcommand" },
    { 0x1AC3, "canclaim" },
    { 0x1AC4, "cancloak" },
    { 0x1AC5, "canconcat" },
    { 0x1AC6, "cancontestclaim" },
    { 0x1AC7, "candamagedestructible" },
    { 0x1AC8, "candeployjuggernaut" },
    { 0x1AC9, "candocombat" },
    { 0x1ACA, "candoflavorburst" },
    { 0x1ACB, "cangiveability" },
    { 0x1ACC, "canhitsuppressspot" },
    { 0x1ACD, "caninteractwith" },
    { 0x1ACE, "canisterdrips" },
    { 0x1ACF, "canistersteam" },
    { 0x1AD0, "canlean" },
    { 0x1AD1, "canlogclient" },
    { 0x1AD2, "canlogevent" },
    { 0x1AD3, "canlogkillstreak" },
    { 0x1AD4, "canloglife" },
    { 0x1AD5, "canmovepointtopoint" },
    { 0x1AD6, "cannon_effect" },
    { 0x1AD7, "cannotplacestring" },
    { 0x1AD8, "canopy_fade_in_cinematic" },
    { 0x1AD9, "canperformclienttraces" },
    { 0x1ADA, "canpickupobject" },
    { 0x1ADB, "canreact" },
    { 0x1ADC, "canreactagain" },
    { 0x1ADD, "canreadtext" },
    { 0x1ADE, "canreturntocover" },
    { 0x1ADF, "cansave" },
    { 0x1AE0, "cansay" },
    { 0x1AE1, "cansayname" },
    { 0x1AE2, "cansayplayername" },
    { 0x1AE3, "canseeandshootpoint" },
    { 0x1AE4, "canseeenemy" },
    { 0x1AE5, "canseeenemyfromexposed" },
    { 0x1AE6, "canseeplayer" },
    { 0x1AE7, "canseepointfromexposedatcorner" },
    { 0x1AE8, "canseepointfromexposedatnode" },
    { 0x1AE9, "cansetupstance" },
    { 0x1AEA, "canshootwhilerunning" },
    { 0x1AEB, "canshootwhilerunningbackward" },
    { 0x1AEC, "canshootwhilerunningforward" },
    { 0x1AED, "canshowsplash" },
    { 0x1AEE, "canshufflekillstreaks" },
    { 0x1AEF, "canshufflewithkillstreakweapon" },
    { 0x1AF0, "cansmash" },
    { 0x1AF1, "canstoppeeking" },
    { 0x1AF2, "cansuppressenemy" },
    { 0x1AF3, "cansuppressenemyfromexposed" },
    { 0x1AF4, "cansurvivevehicleexplosion" },
    { 0x1AF5, "cantfindanythingtodo" },
    { 0x1AF6, "canthrowgrenade" },
    { 0x1AF7, "cantraceto" },
    { 0x1AF8, "cantseeenemybehavior" },
    { 0x1AF9, "cantseeenemywait" },
    { 0x1AFA, "cantusehintthink" },
    { 0x1AFB, "canuse" },
    { 0x1AFC, "canusecallback" },
    { 0x1AFD, "canuselaser" },
    { 0x1AFE, "canuseobject" },
    { 0x1AFF, "canusesawapproach" },
    { 0x1B00, "canusewarbird" },
    { 0x1B01, "canyon_ally_vo" },
    { 0x1B02, "canyon_ally_vo_dam" },
    { 0x1B03, "canyon_ally_vo2" },
    { 0x1B04, "canyon_ally_vo3" },
    { 0x1B05, "canyon_intro_vo" },
    { 0x1B06, "canyon_no_game_start_setupfunc" },
    { 0x1B07, "canyon_whizby_sound" },
    { 0x1B08, "canyon_whizby_sounds" },
    { 0x1B09, "cao_agent" },
    { 0x1B0A, "cao_camera_ratio" },
    { 0x1B0B, "cao_camerazoff" },
    { 0x1B0C, "cao_camerazoff_zoom" },
    { 0x1B0D, "cao_camoffset_ratio" },
    { 0x1B0E, "cao_fardist" },
    { 0x1B0F, "cao_getactivecostume" },
    { 0x1B10, "cao_getactivecostumeindex" },
    { 0x1B11, "cao_getcostumebyindex" },
    { 0x1B12, "cao_getglobalcostumecategory" },
    { 0x1B13, "cao_getpercostumecategory" },
    { 0x1B14, "cao_isglobalcostumecategory" },
    { 0x1B15, "cao_neardist" },
    { 0x1B16, "cao_ratio_zoom" },
    { 0x1B17, "cao_set_costumes_from_lua" },
    { 0x1B18, "cao_setactivecostume" },
    { 0x1B19, "cao_setcostumebyindex" },
    { 0x1B1A, "cao_setglobalcostumecategory" },
    { 0x1B1B, "cao_setpercostumecategory" },
    { 0x1B1C, "cao_targetzoff" },
    { 0x1B1D, "cao_targetzoff_zoom" },
    { 0x1B1E, "cao_update" },
    { 0x1B1F, "caoavatarposoffset" },
    { 0x1B20, "cap_bake_chamber_gdn_01" },
    { 0x1B21, "cap_bake_chamber_gdn_02" },
    { 0x1B22, "cap_civilian_damage_proc" },
    { 0x1B23, "cap_crash_recovery_gdn" },
    { 0x1B24, "cap_elevator_crk" },
    { 0x1B25, "cap_elevator_gdn" },
    { 0x1B26, "cap_elevator_iln" },
    { 0x1B27, "cap_ending_gdn" },
    { 0x1B28, "cap_ending_gdn_extra" },
    { 0x1B29, "cap_ending_iln" },
    { 0x1B2A, "cap_gun_training_gdn" },
    { 0x1B2B, "cap_incinerator_crawl_loop_01" },
    { 0x1B2C, "cap_incinerator_end_01" },
    { 0x1B2D, "cap_incinerator_end_02" },
    { 0x1B2E, "cap_incinerator_end_03" },
    { 0x1B2F, "cap_incinerator_push_01" },
    { 0x1B30, "cap_incinerator_push_02" },
    { 0x1B31, "cap_incinerator_push_03" },
    { 0x1B32, "cap_incinerator_start_01" },
    { 0x1B33, "cap_incinerator_start_02" },
    { 0x1B34, "cap_incinerator_start_03" },
    { 0x1B35, "cap_interrogation_crk" },
    { 0x1B36, "cap_interrogation_crk_add" },
    { 0x1B37, "cap_interrogation_irn" },
    { 0x1B38, "cap_interrogation_plr" },
    { 0x1B39, "cap_intro_drive_gdn" },
    { 0x1B3A, "cap_intro_drive_iln" },
    { 0x1B3B, "cap_manticore_window_gdn_01" },
    { 0x1B3C, "cap_manticore_window_gdn_02" },
    { 0x1B3D, "cap_observation_gdn_01" },
    { 0x1B3E, "cap_observation_gdn_02" },
    { 0x1B3F, "cap_rescue_crk" },
    { 0x1B40, "cap_rescue_gdn" },
    { 0x1B41, "cap_rescue_iln" },
    { 0x1B42, "cap_separation_iln_01" },
    { 0x1B43, "cap_test_chamber_gdn_01" },
    { 0x1B44, "cap_test_chamber_gdn_02" },
    { 0x1B45, "cap_test_chamber_gdn_03" },
    { 0x1B46, "cap_trolley_gdn" },
    { 0x1B47, "capsperminute" },
    { 0x1B48, "capsule_damage" },
    { 0x1B49, "capture_doctor_scene_start" },
    { 0x1B4A, "capture_flag" },
    { 0x1B4B, "capture_hack" },
    { 0x1B4C, "capture_lighting" },
    { 0x1B4D, "capture_radius" },
    { 0x1B4E, "capturecount" },
    { 0x1B4F, "captured_ambient_animation_function" },
    { 0x1B50, "captured_ambient_animation_setup" },
    { 0x1B51, "captured_break_lock" },
    { 0x1B52, "captured_caravan_spawner" },
    { 0x1B53, "captured_caravan_truck_remover" },
    { 0x1B54, "captured_enter_exo" },
    { 0x1B55, "captured_hint_display" },
    { 0x1B56, "captured_hint_ender_function" },
    { 0x1B57, "captured_hint_radius" },
    { 0x1B58, "captured_hint_range_check" },
    { 0x1B59, "captured_mission_failed" },
    { 0x1B5A, "captured_open_door" },
    { 0x1B5B, "captured_player_cuffs" },
    { 0x1B5C, "captured_push_cart" },
    { 0x1B5D, "captured_take_exo" },
    { 0x1B5E, "captured_use_console" },
    { 0x1B5F, "captured_worker_weapons" },
    { 0x1B60, "capturetime" },
    { 0x1B61, "capturezone_reset_base_effects" },
    { 0x1B62, "capturezoneeffects" },
    { 0x1B63, "capzones" },
    { 0x1B64, "car_alarm_horn_01" },
    { 0x1B65, "car_alarm_main" },
    { 0x1B66, "car_alarm_org" },
    { 0x1B67, "car_alarm_setup" },
    { 0x1B68, "car_alarm_sound" },
    { 0x1B69, "car_alarm_timeout" },
    { 0x1B6A, "car_behavior" },
    { 0x1B6B, "car_chase_crash" },
    { 0x1B6C, "car_damage_owner_recorder" },
    { 0x1B6D, "car_door_broken" },
    { 0x1B6E, "car_door_ripoff_fx" },
    { 0x1B6F, "car_door_snap_player" },
    { 0x1B70, "car_door_snap_will" },
    { 0x1B71, "car_hit_blur" },
    { 0x1B72, "car_hit_shadows" },
    { 0x1B73, "car_lift" },
    { 0x1B74, "car_lift_scene" },
    { 0x1B75, "car_light" },
    { 0x1B76, "car_ride_bink" },
    { 0x1B77, "car_ride_boundary_fail" },
    { 0x1B78, "car_ride_doctor_waits" },
    { 0x1B79, "car_ride_driving_workers_wait" },
    { 0x1B7A, "car_ride_driving_workers_waits" },
    { 0x1B7B, "car_ride_enter_cormack_waits" },
    { 0x1B7C, "car_ride_enter_doctor_waits" },
    { 0x1B7D, "car_ride_gaz_waits" },
    { 0x1B7E, "car_ride_intro_fail" },
    { 0x1B7F, "car_ride_org" },
    { 0x1B80, "car_ride_player_rig" },
    { 0x1B81, "car_ride_rumble" },
    { 0x1B82, "car_ride_view_clamps" },
    { 0x1B83, "carabiner_knox" },
    { 0x1B84, "caralarm" },
    { 0x1B85, "cardfx" },
    { 0x1B86, "cardoor_buttons" },
    { 0x1B87, "cardoor_hint_breakout" },
    { 0x1B88, "cardoor_old_weapon" },
    { 0x1B89, "cardoor_weapon" },
    { 0x1B8A, "cardtagnames" },
    { 0x1B8B, "cardtagvisible" },
    { 0x1B8C, "career_stat_increment" },
    { 0x1B8D, "careful_logic" },
    { 0x1B8E, "carepackageandcarepackagevalid" },
    { 0x1B8F, "carepackageandgoliathvalid" },
    { 0x1B90, "carepackageandplatformvalid" },
    { 0x1B91, "carepackagecleanup" },
    { 0x1B92, "carepackagedrone" },
    { 0x1B93, "carepackagedrone_delete" },
    { 0x1B94, "carepackagedrone_deleteonactivate" },
    { 0x1B95, "carepackagedrone_explode" },
    { 0x1B96, "carepackagedrone_leave" },
    { 0x1B97, "carepackagedrone_remove" },
    { 0x1B98, "carepackagedrone_watchdeath" },
    { 0x1B99, "carepackagedrone_watchownerloss" },
    { 0x1B9A, "carepackagedrone_watchroundend" },
    { 0x1B9B, "carepackagedronefindowner" },
    { 0x1B9C, "carepackagedrones" },
    { 0x1B9D, "carepackagedronewatchcratedeath" },
    { 0x1B9E, "carepackagedronewatchdeath" },
    { 0x1B9F, "carepackages" },
    { 0x1BA0, "carepackagesetupminimap" },
    { 0x1BA1, "carepackagetouchvalid" },
    { 0x1BA2, "carepackagetrace" },
    { 0x1BA3, "cargo" },
    { 0x1BA4, "cargo_recover_fail" },
    { 0x1BA5, "cargo_ship_death_fx" },
    { 0x1BA6, "cargo_ship_fights_back" },
    { 0x1BA7, "cargo_ship_hit_aliases" },
    { 0x1BA8, "cargo_ship_hit_count" },
    { 0x1BA9, "cargo_ship_hit_react" },
    { 0x1BAA, "cargo_ship_missiles" },
    { 0x1BAB, "cargo_ship_rocking" },
    { 0x1BAC, "cargo_total" },
    { 0x1BAD, "carriedby" },
    { 0x1BAE, "carrieditem" },
    { 0x1BAF, "carriedobj" },
    { 0x1BB0, "carriedsentry" },
    { 0x1BB1, "carriedturret" },
    { 0x1BB2, "carrier" },
    { 0x1BB3, "carrierhascarryweaponinloadout" },
    { 0x1BB4, "carriervisible" },
    { 0x1BB5, "carrierweaponcurrent" },
    { 0x1BB6, "carry_first_done" },
    { 0x1BB7, "carryflag" },
    { 0x1BB8, "carryicon" },
    { 0x1BB9, "carryobject" },
    { 0x1BBA, "carryobject_overridemovingplatformdeath" },
    { 0x1BBB, "carryobjectproxthink" },
    { 0x1BBC, "carryobjectproxthinkdelayed" },
    { 0x1BBD, "carryobjectusethink" },
    { 0x1BBE, "carryweapon" },
    { 0x1BBF, "carryweaponthink" },
    { 0x1BC0, "cart" },
    { 0x1BC1, "cart_first_time" },
    { 0x1BC2, "cart_push" },
    { 0x1BC3, "cart_push2" },
    { 0x1BC4, "carter" },
    { 0x1BC5, "carter_cr_foley_idle" },
    { 0x1BC6, "carter_cr_foley_start" },
    { 0x1BC7, "casual_killer" },
    { 0x1BC8, "casualtytracking" },
    { 0x1BC9, "cat_array_add" },
    { 0x1BCA, "cat_array_get" },
    { 0x1BCB, "catch_damage_notify" },
    { 0x1BCC, "catch_death_notify" },
    { 0x1BCD, "catch_got_enemy" },
    { 0x1BCE, "catch_level_notify" },
    { 0x1BCF, "catch_mission_failed" },
    { 0x1BD0, "catch_weapon_switch" },
    { 0x1BD1, "categories" },
    { 0x1BD2, "categories_axis" },
    { 0x1BD3, "category_alias_name" },
    { 0x1BD4, "category_backoff_limit" },
    { 0x1BD5, "category_groups" },
    { 0x1BD6, "category_groups_axis" },
    { 0x1BD7, "category_name" },
    { 0x1BD8, "category_response_name" },
    { 0x1BD9, "cause_is_explosive" },
    { 0x1BDA, "cause_is_grenade" },
    { 0x1BDB, "cautious_approach_till_close" },
    { 0x1BDC, "cave_dialogue_cormack_attack" },
    { 0x1BDD, "cave_dialogue_cormack_contact" },
    { 0x1BDE, "cave_dialogue_cormack_drop_em" },
    { 0x1BDF, "cave_dialogue_cormack_dropping" },
    { 0x1BE0, "cave_dialogue_cormack_push" },
    { 0x1BE1, "cave_dialogue_ilona_down" },
    { 0x1BE2, "cave_dialogue_ilona_exit" },
    { 0x1BE3, "cave_dialogue_ilona_left" },
    { 0x1BE4, "cave_drill_fx" },
    { 0x1BE5, "cave_drill_pounding_fx" },
    { 0x1BE6, "cave_drill_rock_impact_fx" },
    { 0x1BE7, "cave_drills" },
    { 0x1BE8, "cave_drills_inside" },
    { 0x1BE9, "cave_drop_guys" },
    { 0x1BEA, "cave_ender_notify" },
    { 0x1BEB, "cave_entry" },
    { 0x1BEC, "cave_entry_animnode" },
    { 0x1BED, "cave_entry_bunker_battle" },
    { 0x1BEE, "cave_entry_dialogue" },
    { 0x1BEF, "cave_entry_goliath_attack" },
    { 0x1BF0, "cave_entry_goliath_behavior" },
    { 0x1BF1, "cave_entry_goliath_movement" },
    { 0x1BF2, "cave_entry_goliath_show" },
    { 0x1BF3, "cave_entry_goliath_spawn" },
    { 0x1BF4, "cave_entry_goliaths" },
    { 0x1BF5, "cave_entry_player" },
    { 0x1BF6, "cave_entry_scene" },
    { 0x1BF7, "cave_entry_sentinel" },
    { 0x1BF8, "cave_entry_slide_exploders" },
    { 0x1BF9, "cave_entry_surface_cleanup" },
    { 0x1BFA, "cave_entry_tank_missile" },
    { 0x1BFB, "cave_entry_walker_tank" },
    { 0x1BFC, "cave_falling_debris_fx" },
    { 0x1BFD, "cave_in" },
    { 0x1BFE, "cave_intro_anim_moment" },
    { 0x1BFF, "cave_npc_boost_assist" },
    { 0x1C00, "cave_npc_boost_assist_land" },
    { 0x1C01, "cave_shake_effects" },
    { 0x1C02, "cave_start_teleport" },
    { 0x1C03, "cave_temperature" },
    { 0x1C04, "cave_wall_temp_show" },
    { 0x1C05, "cave_water_origin" },
    { 0x1C06, "cb_usedkillstreak" },
    { 0x1C07, "cbdr_missile_think" },
    { 0x1C08, "cc_kva_alerted_walla" },
    { 0x1C09, "cc_technical_turret_fire" },
    { 0x1C0A, "ccfire" },
    { 0x1C0B, "cd_living_room_blinds" },
    { 0x1C0C, "cdrn_auto_unlink" },
    { 0x1C0D, "cdrn_intance_init" },
    { 0x1C0E, "cdrn_servo_oneshot_pch_func" },
    { 0x1C0F, "cdrn_wheel_speed_modifier_callback_linear" },
    { 0x1C10, "ceiling_fan" },
    { 0x1C11, "cell_prisoners_trig" },
    { 0x1C12, "center" },
    { 0x1C13, "center_node" },
    { 0x1C14, "center_screen_line" },
    { 0x1C15, "center_screen_lines" },
    { 0x1C16, "center_screen_text" },
    { 0x1C17, "center_universe" },
    { 0x1C18, "centeraimpoint" },
    { 0x1C19, "centerlinethread" },
    { 0x1C1A, "centerorbitalview" },
    { 0x1C1B, "centerpodspawnview" },
    { 0x1C1C, "cfxprintln" },
    { 0x1C1D, "cfxprintlnend" },
    { 0x1C1E, "cfxprintlnstart" },
    { 0x1C1F, "cg_car_light_shadowstate_on" },
    { 0x1C20, "cg_car_light_shadowstate_reset" },
    { 0x1C21, "cg_civ_conversation_gag1" },
    { 0x1C22, "cg_gate_anim_notetrack_load_stall" },
    { 0x1C23, "cg_helipad_red_fx_lights" },
    { 0x1C24, "cg_kill_entity_on_flag" },
    { 0x1C25, "cg_kill_entity_on_transition" },
    { 0x1C26, "cg_never_delete_setup" },
    { 0x1C27, "cg_noterack_delay_count" },
    { 0x1C28, "cg_open_close_school_entrance_doors" },
    { 0x1C29, "cg_school_entrance_doors_init" },
    { 0x1C2A, "cg_sentinel_fx_light" },
    { 0x1C2B, "cg_setup_civ_fence_special" },
    { 0x1C2C, "cg_setup_civs_baseball" },
    { 0x1C2D, "cg_setup_civs_fence" },
    { 0x1C2E, "cg_setup_civs_foodtruck" },
    { 0x1C2F, "cg_setup_civs_infosign" },
    { 0x1C30, "cg_setup_hospital_bodies" },
    { 0x1C31, "cg_setup_refugee_stage_audience" },
    { 0x1C32, "cg_setup_refugee_stage_speaker" },
    { 0x1C33, "cg_setup_school_entrance_doors_startpoints" },
    { 0x1C34, "cg_setup_social_groups" },
    { 0x1C35, "cg_spawn_perf_monitor" },
    { 0x1C36, "cg_spawn_perf_monitor_setup" },
    { 0x1C37, "cg_spraypaint_gag" },
    { 0x1C38, "cg_spraypaint_runner" },
    { 0x1C39, "cg_subway_turnstyle_open" },
    { 0x1C3A, "cg_swap_tank_treads_mat" },
    { 0x1C3B, "cg_tff_set_up_transient_meshes" },
    { 0x1C3C, "cg_tff_transition_canaloverlook_to_riverwalk" },
    { 0x1C3D, "cg_tff_transition_droneswarmone_blocker" },
    { 0x1C3E, "cg_tff_transition_droneswarmone_to_mall" },
    { 0x1C3F, "cg_tff_transition_eastview_blocker" },
    { 0x1C40, "cg_tff_transition_eastview_to_fob" },
    { 0x1C41, "cg_tff_transition_fob_to_droneswarmone" },
    { 0x1C42, "cg_tff_transition_fob_to_truckpush" },
    { 0x1C43, "cg_tff_transition_mall_to_shinkhole" },
    { 0x1C44, "cg_tff_transition_shinkhole_to_subway" },
    { 0x1C45, "cg_tff_transition_shopping_to_canaloverlook" },
    { 0x1C46, "cg_tff_transition_subway_to_shoppingdistrict" },
    { 0x1C47, "cg_trigger_enter_finale_silo_neutral" },
    { 0x1C48, "cg_trigger_enter_finale_silo_yellow" },
    { 0x1C49, "cg_visibility_proxy_office_interior" },
    { 0x1C4A, "ch_assists" },
    { 0x1C4B, "ch_bulletdamagecommon" },
    { 0x1C4C, "ch_cyl_zoff_far" },
    { 0x1C4D, "ch_cyl_zoff_near" },
    { 0x1C4E, "ch_emp_goliath_think" },
    { 0x1C4F, "ch_getprogress" },
    { 0x1C50, "ch_getstate" },
    { 0x1C51, "ch_gettarget" },
    { 0x1C52, "ch_hardpoints" },
    { 0x1C53, "ch_kills" },
    { 0x1C54, "ch_roundplayed" },
    { 0x1C55, "ch_roundwin" },
    { 0x1C56, "ch_setprogress" },
    { 0x1C57, "ch_setstate" },
    { 0x1C58, "ch_streak_kill" },
    { 0x1C59, "ch_vehicle_killed" },
    { 0x1C5A, "ch_vehicle_kills" },
    { 0x1C5B, "chaingun" },
    { 0x1C5C, "chair_actor_07" },
    { 0x1C5D, "chair_actor_08" },
    { 0x1C5E, "chair_animate" },
    { 0x1C5F, "challenge_parentchallenge" },
    { 0x1C60, "challenge_point_award" },
    { 0x1C61, "challenge_point_award_on_damage" },
    { 0x1C62, "challenge_rewardval" },
    { 0x1C63, "challenge_targetval" },
    { 0x1C64, "challengedata" },
    { 0x1C65, "challengeinfo" },
    { 0x1C66, "challengescompleted" },
    { 0x1C67, "challengesplashnotify" },
    { 0x1C68, "champion" },
    { 0x1C69, "chancetospawndog" },
    { 0x1C6A, "chancetospawnpickup" },
    { 0x1C6B, "change_camera" },
    { 0x1C6C, "change_color_node_quick" },
    { 0x1C6D, "change_color_node_quick_player_close_check" },
    { 0x1C6E, "change_debug_text_hud_color" },
    { 0x1C6F, "change_fall_tollerance" },
    { 0x1C70, "change_fov_back_to_65" },
    { 0x1C71, "change_lane" },
    { 0x1C72, "change_lane_too_close" },
    { 0x1C73, "change_music_to_standoff" },
    { 0x1C74, "change_optimal_flight_distance" },
    { 0x1C75, "change_player_health_packets" },
    { 0x1C76, "change_spawn_chance_highway_path_player_side" },
    { 0x1C77, "change_spawn_dist_highway_path_player_side" },
    { 0x1C78, "change_state" },
    { 0x1C79, "change_threat_detection_style" },
    { 0x1C7A, "change_to_original_models" },
    { 0x1C7B, "change_to_run_after_time" },
    { 0x1C7C, "change_to_run_now" },
    { 0x1C7D, "change_to_tactics_models" },
    { 0x1C7E, "change_weapons" },
    { 0x1C7F, "change_weapons_listener" },
    { 0x1C80, "changeaiming" },
    { 0x1C81, "changecrateweight" },
    { 0x1C82, "changed_team" },
    { 0x1C83, "changelightcolorto" },
    { 0x1C84, "changelightcolortoworkerthread" },
    { 0x1C85, "changestanceforfuntime" },
    { 0x1C86, "changestepoutpos" },
    { 0x1C87, "changethreatstyle" },
    { 0x1C88, "changeweapons" },
    { 0x1C89, "changingcoverpos" },
    { 0x1C8A, "changingweapon" },
    { 0x1C8B, "char_dialog_add_and_go" },
    { 0x1C8C, "character_hat_index" },
    { 0x1C8D, "character_head_index" },
    { 0x1C8E, "character_index_cache" },
    { 0x1C8F, "characterid_count" },
    { 0x1C90, "characterid_is_talking_currently" },
    { 0x1C91, "characters" },
    { 0x1C92, "charge" },
    { 0x1C93, "charge_blink" },
    { 0x1C94, "charge_indicator_hud" },
    { 0x1C95, "chargebattery" },
    { 0x1C96, "charged_shot_reticle" },
    { 0x1C97, "charged_shot_reticle_corners" },
    { 0x1C98, "charged_shot_rumble_ent" },
    { 0x1C99, "charged_shot_soundent" },
    { 0x1C9A, "chase_cam_ent" },
    { 0x1C9B, "chase_cam_last_num" },
    { 0x1C9C, "chase_cam_target" },
    { 0x1C9D, "chase_cleanup_after_player_crash" },
    { 0x1C9E, "chase_heli_fire" },
    { 0x1C9F, "chase_timer_cancel" },
    { 0x1CA0, "chase_timer_countdown" },
    { 0x1CA1, "chase_van" },
    { 0x1CA2, "chase_van_rabbiting_anim" },
    { 0x1CA3, "chase_van_set_close" },
    { 0x1CA4, "chase_van_set_far" },
    { 0x1CA5, "chase_van_set_medium" },
    { 0x1CA6, "chasecam" },
    { 0x1CA7, "chasecam_onent" },
    { 0x1CA8, "chatinitialized" },
    { 0x1CA9, "chatqueue" },
    { 0x1CAA, "chatterdisabled" },
    { 0x1CAB, "cheap_flashlight_hide" },
    { 0x1CAC, "cheap_flashlight_init" },
    { 0x1CAD, "cheap_flashlight_setup" },
    { 0x1CAE, "cheap_flashlight_show" },
    { 0x1CAF, "cheap_vehicles_have_shields" },
    { 0x1CB0, "cheapmagicbullet" },
    { 0x1CB1, "cheatammoifnecessary" },
    { 0x1CB2, "check_allies_in_volume" },
    { 0x1CB3, "check_animation" },
    { 0x1CB4, "check_campaign_completion" },
    { 0x1CB5, "check_class_time" },
    { 0x1CB6, "check_clearroof_early" },
    { 0x1CB7, "check_createfx_limit" },
    { 0x1CB8, "check_death_flag" },
    { 0x1CB9, "check_delete" },
    { 0x1CBA, "check_drone_callback" },
    { 0x1CBB, "check_enemies_for_alert" },
    { 0x1CBC, "check_exploder_platform" },
    { 0x1CBD, "check_failed_spawn_groups" },
    { 0x1CBE, "check_fire_and_forget" },
    { 0x1CBF, "check_flag_for_stat_tracking" },
    { 0x1CC0, "check_flight_distances" },
    { 0x1CC1, "check_for_door" },
    { 0x1CC2, "check_for_npc_weapon_cloak_status_update" },
    { 0x1CC3, "check_force_color" },
    { 0x1CC4, "check_grenade" },
    { 0x1CC5, "check_grenade_dmg" },
    { 0x1CC6, "check_group_at_goal" },
    { 0x1CC7, "check_group_facing_forward" },
    { 0x1CC8, "check_health" },
    { 0x1CC9, "check_hint_condition" },
    { 0x1CCA, "check_if_enemies_marked" },
    { 0x1CCB, "check_if_hurt" },
    { 0x1CCC, "check_if_intersecting_any_script_car" },
    { 0x1CCD, "check_if_multiple_ents_inside" },
    { 0x1CCE, "check_intel_achievements" },
    { 0x1CCF, "check_is_climbing" },
    { 0x1CD0, "check_item_found" },
    { 0x1CD1, "check_kill_damage" },
    { 0x1CD2, "check_kill_traversal" },
    { 0x1CD3, "check_lab_achievement" },
    { 0x1CD4, "check_limit_type" },
    { 0x1CD5, "check_look_both_ways_achievement" },
    { 0x1CD6, "check_los" },
    { 0x1CD7, "check_man_overboard" },
    { 0x1CD8, "check_melee_interaction_active" },
    { 0x1CD9, "check_missile_ammo" },
    { 0x1CDA, "check_missing_animation" },
    { 0x1CDB, "check_move_me_to_maintain_ratio" },
    { 0x1CDC, "check_on_target_process" },
    { 0x1CDD, "check_other_haslevelveteranachievement" },
    { 0x1CDE, "check_player_bunker_position" },
    { 0x1CDF, "check_player_deck_position_1" },
    { 0x1CE0, "check_player_deck_position_2" },
    { 0x1CE1, "check_player_gender" },
    { 0x1CE2, "check_player_in_sniper_zone" },
    { 0x1CE3, "check_player_in_stop_enemy_callout_vo_volume" },
    { 0x1CE4, "check_player_pickedup_sniper" },
    { 0x1CE5, "check_potential_falling_death" },
    { 0x1CE6, "check_restricted_airspace_achievement" },
    { 0x1CE7, "check_script_char_group_ratio" },
    { 0x1CE8, "check_seoul_achievements" },
    { 0x1CE9, "check_sound_tag_dupe" },
    { 0x1CEA, "check_sound_tag_dupe_reset" },
    { 0x1CEB, "check_spawn_group_isspawner" },
    { 0x1CEC, "check_time" },
    { 0x1CED, "check_to_activate" },
    { 0x1CEE, "check_trigger_flagset" },
    { 0x1CEF, "check_unloadgroup" },
    { 0x1CF0, "check_vo_type" },
    { 0x1CF1, "check_wait_on_cg_notetracks" },
    { 0x1CF2, "check_zkey_press" },
    { 0x1CF3, "checkadvanceonenemyconditions" },
    { 0x1CF4, "checkallowspectating" },
    { 0x1CF5, "checkapproachconditions" },
    { 0x1CF6, "checkapproachpreconditions" },
    { 0x1CF7, "checkarrivalenterpositions" },
    { 0x1CF8, "checkbuddyspawn" },
    { 0x1CF9, "checkcamposition" },
    { 0x1CFA, "checkchanged" },
    { 0x1CFB, "checkcombatstate" },
    { 0x1CFC, "checkcoverenterpos" },
    { 0x1CFD, "checkdynamicspawns" },
    { 0x1CFE, "checked" },
    { 0x1CFF, "checkendcombat" },
    { 0x1D00, "checkexpiretime" },
    { 0x1D01, "checkforbestweapon" },
    { 0x1D02, "checkforcebleedout" },
    { 0x1D03, "checkforceragdoll" },
    { 0x1D04, "checkforcrashing" },
    { 0x1D05, "checkforexplosivegoal" },
    { 0x1D06, "checkforexplosivegoalexplosive" },
    { 0x1D07, "checkforpersonalbests" },
    { 0x1D08, "checkforreinforcements" },
    { 0x1D09, "checkforunpause" },
    { 0x1D0A, "checkgameendchallenges" },
    { 0x1D0B, "checkgamemodemastery" },
    { 0x1D0C, "checkgrenadethrowdist" },
    { 0x1D0D, "checkhalftime" },
    { 0x1D0E, "checkhalftimescore" },
    { 0x1D0F, "checkhigherrankkillevents" },
    { 0x1D10, "checkhighjumpevents" },
    { 0x1D11, "checkhit" },
    { 0x1D12, "checkhitsthismag" },
    { 0x1D13, "checking_for_flag" },
    { 0x1D14, "checkkeyobject" },
    { 0x1D15, "checknodeexitpos" },
    { 0x1D16, "checknodestart" },
    { 0x1D17, "checkorbitallaserusage" },
    { 0x1D18, "checkpitchvisibility" },
    { 0x1D19, "checkplayerscorelimitsoon" },
    { 0x1D1A, "checkpracticeroundlockout" },
    { 0x1D1B, "checkroundswitch" },
    { 0x1D1C, "checkroundwin" },
    { 0x1D1D, "checkscorelimit" },
    { 0x1D1E, "checkstreakingevents" },
    { 0x1D1F, "checkstreakreward" },
    { 0x1D20, "checktargetisinfrontofplayer" },
    { 0x1D21, "checktargetisinvision" },
    { 0x1D22, "checkteamscorelimitsoon" },
    { 0x1D23, "checktimelimit" },
    { 0x1D24, "checktoturnoffemp" },
    { 0x1D25, "checktransitionconditions" },
    { 0x1D26, "checktransitionpreconditions" },
    { 0x1D27, "checkvandalismmedal" },
    { 0x1D28, "checkvehicleturretuserstatus" },
    { 0x1D29, "checkwarbirdtargetlos" },
    { 0x1D2A, "checkweapchange" },
    { 0x1D2B, "checkweaponspecifickill" },
    { 0x1D2C, "chemdamagethink" },
    { 0x1D2D, "chemical_rack" },
    { 0x1D2E, "chemical_rackgotosarray" },
    { 0x1D2F, "chemical_rackpausetime" },
    { 0x1D30, "chemical_racksactive" },
    { 0x1D31, "cherry_picker" },
    { 0x1D32, "cherry_picker_damage_alarm" },
    { 0x1D33, "cherry_picker_hud" },
    { 0x1D34, "cherry_picker_hud_bar" },
    { 0x1D35, "cherry_picker_hud_drone" },
    { 0x1D36, "cherry_picker_hud_drone2" },
    { 0x1D37, "cherry_picker_hud_emp" },
    { 0x1D38, "cherry_picker_target_add" },
    { 0x1D39, "cherry_picker_target_remove" },
    { 0x1D3A, "cherry_picker_turret_gameplay" },
    { 0x1D3B, "cherry_turret" },
    { 0x1D3C, "cherry_turret_hud" },
    { 0x1D3D, "chevron" },
    { 0x1D3E, "chevron_right" },
    { 0x1D3F, "childchecktime" },
    { 0x1D40, "children" },
    { 0x1D41, "choose_crash_path" },
    { 0x1D42, "choose_from_weighted_array" },
    { 0x1D43, "choose_vol" },
    { 0x1D44, "chooseanimfromset" },
    { 0x1D45, "chooseattackidle" },
    { 0x1D46, "choosefirstinfected" },
    { 0x1D47, "chooseidlepointreactanimation" },
    { 0x1D48, "choosepose" },
    { 0x1D49, "chooseposefunc" },
    { 0x1D4A, "choosesmashnode" },
    { 0x1D4B, "chopper" },
    { 0x1D4C, "chopper_01_away_by" },
    { 0x1D4D, "chopper_01_by_in" },
    { 0x1D4E, "chopper_01_close_lp" },
    { 0x1D4F, "chopper_01_dist_lp" },
    { 0x1D50, "chopper_01_wind_up" },
    { 0x1D51, "chopper_02_away_by" },
    { 0x1D52, "chopper_02_by_in" },
    { 0x1D53, "chopper_02_close_lp" },
    { 0x1D54, "chopper_02_dist_lp" },
    { 0x1D55, "chopper_02_wind_up" },
    { 0x1D56, "chopper_air_support_activate" },
    { 0x1D57, "chopper_final_explo" },
    { 0x1D58, "chopper_fx" },
    { 0x1D59, "chopper_pilot_death_anim" },
    { 0x1D5A, "chopper_shoot_down" },
    { 0x1D5B, "chopper_shoot_down_internal" },
    { 0x1D5C, "chopper_shoot_straight" },
    { 0x1D5D, "chopper_sniper_shot" },
    { 0x1D5E, "chopper_turret_off" },
    { 0x1D5F, "chopper_turret_on" },
    { 0x1D60, "chopperattackarrow" },
    { 0x1D61, "choppersniped" },
    { 0x1D62, "chopperturretfunc" },
    { 0x1D63, "chopperturretofffunc" },
    { 0x1D64, "chopperturretonfunc" },
    { 0x1D65, "chosen" },
    { 0x1D66, "chosentemplates" },
    { 0x1D67, "chromo_anim2" },
    { 0x1D68, "chromo_offset" },
    { 0x1D69, "chyron" },
    { 0x1D6A, "chyron_sound" },
    { 0x1D6B, "cig_hide" },
    { 0x1D6C, "cig_show" },
    { 0x1D6D, "cig_throwing" },
    { 0x1D6E, "cigar" },
    { 0x1D6F, "cigarette_light" },
    { 0x1D70, "cine_fire_debris_stumble" },
    { 0x1D71, "cine_holelight" },
    { 0x1D72, "cine_left_light" },
    { 0x1D73, "cine_sub_fire_rim" },
    { 0x1D74, "cine_sub_fog" },
    { 0x1D75, "cine_sub_right_irons" },
    { 0x1D76, "cine_sub_will_all_mulitlight" },
    { 0x1D77, "cinematic_rocket_guys" },
    { 0x1D78, "circling" },
    { 0x1D79, "circuit_breaker" },
    { 0x1D7A, "city_ambient_fx" },
    { 0x1D7B, "civ_ah" },
    { 0x1D7C, "civ_armshots" },
    { 0x1D7D, "civ_boat_spawn" },
    { 0x1D7E, "civ_chestshots" },
    { 0x1D7F, "civ_conversation_gag1" },
    { 0x1D80, "civ_damage_check" },
    { 0x1D81, "civ_domestic_truck_spawn" },
    { 0x1D82, "civ_gate_node" },
    { 0x1D83, "civ_headshots" },
    { 0x1D84, "civ_kills" },
    { 0x1D85, "civ_legshots" },
    { 0x1D86, "civ_panic_door_run_in" },
    { 0x1D87, "civ_run_nodes" },
    { 0x1D88, "civ_victims" },
    { 0x1D89, "civ1" },
    { 0x1D8A, "civ2" },
    { 0x1D8B, "civ3" },
    { 0x1D8C, "civ4" },
    { 0x1D8D, "civ5" },
    { 0x1D8E, "civ6" },
    { 0x1D8F, "civ7" },
    { 0x1D90, "civ8" },
    { 0x1D91, "civilain_flee_to_goal" },
    { 0x1D92, "civilian_actor_ai_player_reaction" },
    { 0x1D93, "civilian_actor_behavior_manager" },
    { 0x1D94, "civilian_actor_drone_player_reaction" },
    { 0x1D95, "civilian_actor_play_idle" },
    { 0x1D96, "civilian_actor_play_reaction" },
    { 0x1D97, "civilian_african_male_b" },
    { 0x1D98, "civilian_african_male_c" },
    { 0x1D99, "civilian_african_male_d" },
    { 0x1D9A, "civilian_alert_behavior" },
    { 0x1D9B, "civilian_alert_behavior_hangar" },
    { 0x1D9C, "civilian_alert_sound" },
    { 0x1D9D, "civilian_alert_sound_setup" },
    { 0x1D9E, "civilian_alert_watcher" },
    { 0x1D9F, "civilian_anim_setup" },
    { 0x1DA0, "civilian_anims" },
    { 0x1DA1, "civilian_attach_props" },
    { 0x1DA2, "civilian_below" },
    { 0x1DA3, "civilian_body_and_head_setup" },
    { 0x1DA4, "civilian_check_if_player_blocking" },
    { 0x1DA5, "civilian_clean_up" },
    { 0x1DA6, "civilian_cleanup" },
    { 0x1DA7, "civilian_combathunchedmoveturn" },
    { 0x1DA8, "civilian_combatmoveturn" },
    { 0x1DA9, "civilian_compact_car_constructor" },
    { 0x1DAA, "civilian_compact_car_init" },
    { 0x1DAB, "civilian_detach_props" },
    { 0x1DAC, "civilian_driveway_scene" },
    { 0x1DAD, "civilian_drone_repair_think" },
    { 0x1DAE, "civilian_drone_run_override" },
    { 0x1DAF, "civilian_drone_runner_collision" },
    { 0x1DB0, "civilian_drone_runners_think" },
    { 0x1DB1, "civilian_drone_scan_anim_struct" },
    { 0x1DB2, "civilian_drone_scan_female" },
    { 0x1DB3, "civilian_drone_scan_male" },
    { 0x1DB4, "civilian_drone_scan_scene" },
    { 0x1DB5, "civilian_drone_scan_vo" },
    { 0x1DB6, "civilian_drone_setup" },
    { 0x1DB7, "civilian_drone_stationary_think" },
    { 0x1DB8, "civilian_garage" },
    { 0x1DB9, "civilian_garage_1" },
    { 0x1DBA, "civilian_garage_2" },
    { 0x1DBB, "civilian_garage_spawner_setup" },
    { 0x1DBC, "civilian_garage_vo" },
    { 0x1DBD, "civilian_get_out_of_car_setup" },
    { 0x1DBE, "civilian_get_random_idle" },
    { 0x1DBF, "civilian_get_random_reaction" },
    { 0x1DC0, "civilian_get_random_run" },
    { 0x1DC1, "civilian_get_random_walk" },
    { 0x1DC2, "civilian_group" },
    { 0x1DC3, "civilian_guesthouse" },
    { 0x1DC4, "civilian_guesthouse_1" },
    { 0x1DC5, "civilian_guesthouse_2" },
    { 0x1DC6, "civilian_guesthouse_3" },
    { 0x1DC7, "civilian_guesthouse_spawner_setup" },
    { 0x1DC8, "civilian_guesthouse_vo" },
    { 0x1DC9, "civilian_guesthouse_walkin" },
    { 0x1DCA, "civilian_guesthouse_walkin_spawner_setup" },
    { 0x1DCB, "civilian_guesthouse_walkin_vo" },
    { 0x1DCC, "civilian_head_and_body_setup" },
    { 0x1DCD, "civilian_head_and_body_swap" },
    { 0x1DCE, "civilian_in_car_count" },
    { 0x1DCF, "civilian_in_car_get_out" },
    { 0x1DD0, "civilian_in_running_car" },
    { 0x1DD1, "civilian_in_running_car_setup" },
    { 0x1DD2, "civilian_init" },
    { 0x1DD3, "civilian_init_props" },
    { 0x1DD4, "civilian_jet_flyby" },
    { 0x1DD5, "civilian_killed" },
    { 0x1DD6, "civilian_left" },
    { 0x1DD7, "civilian_loop_setup" },
    { 0x1DD8, "civilian_loop_vo_trigger" },
    { 0x1DD9, "civilian_lost" },
    { 0x1DDA, "civilian_lost_guard" },
    { 0x1DDB, "civilian_lost_guard_setup" },
    { 0x1DDC, "civilian_lost_setup" },
    { 0x1DDD, "civilian_noncombatmoveturn" },
    { 0x1DDE, "civilian_panic_distance_check" },
    { 0x1DDF, "civilian_pool_1" },
    { 0x1DE0, "civilian_pool_2" },
    { 0x1DE1, "civilian_pool_3" },
    { 0x1DE2, "civilian_pool_spawner_setup" },
    { 0x1DE3, "civilian_pool_vo" },
    { 0x1DE4, "civilian_poolhouse_1" },
    { 0x1DE5, "civilian_poolhouse_2" },
    { 0x1DE6, "civilian_poolhouse_3" },
    { 0x1DE7, "civilian_poolhouse_vo" },
    { 0x1DE8, "civilian_right" },
    { 0x1DE9, "civilian_right_side" },
    { 0x1DEA, "civilian_right_side_1" },
    { 0x1DEB, "civilian_right_side_2" },
    { 0x1DEC, "civilian_right_side_3" },
    { 0x1DED, "civilian_right_side_setup" },
    { 0x1DEE, "civilian_right_side_vo" },
    { 0x1DEF, "civilian_roundabout_vo_1" },
    { 0x1DF0, "civilian_roundabout_vo_2" },
    { 0x1DF1, "civilian_roundabout_vo_3" },
    { 0x1DF2, "civilian_setup" },
    { 0x1DF3, "civilian_setup_esc_nodes" },
    { 0x1DF4, "civilian_setupanimations" },
    { 0x1DF5, "civilian_sonic_aoe_thread" },
    { 0x1DF6, "civilian_spawn_single" },
    { 0x1DF7, "civilian_stealth_detect" },
    { 0x1DF8, "civilian_urban_female_a" },
    { 0x1DF9, "civilian_urban_female_b" },
    { 0x1DFA, "civilian_urban_female_c" },
    { 0x1DFB, "civilian_urban_male_b" },
    { 0x1DFC, "civilian_urban_male_c" },
    { 0x1DFD, "civilian_urban_male_d" },
    { 0x1DFE, "civilian_urban_male_e" },
    { 0x1DFF, "civilian_wait_for_reaction" },
    { 0x1E00, "civilian_walk_animation" },
    { 0x1E01, "civilian_walker_behavior_manager" },
    { 0x1E02, "civilian_walker_idle_when_blocked" },
    { 0x1E03, "civilian_walker_phone" },
    { 0x1E04, "civilian_walker_phone_spawner_setup" },
    { 0x1E05, "civilian_walker_play_reaction" },
    { 0x1E06, "civilian_walker_play_walk" },
    { 0x1E07, "civilian_walker_setup" },
    { 0x1E08, "civilian_walker_setup_esc_nodes" },
    { 0x1E09, "civilian_walker_update_current_goal_and_animate_to" },
    { 0x1E0A, "civilian_walker_wait_for_walk_signal" },
    { 0x1E0B, "civilian_warning_given" },
    { 0x1E0C, "civilian_warning_vo" },
    { 0x1E0D, "civilian_watch_player_when_close" },
    { 0x1E0E, "civilian1" },
    { 0x1E0F, "civilian2" },
    { 0x1E10, "civiliananims" },
    { 0x1E11, "civilianendinganimations" },
    { 0x1E12, "civilianflashedarray" },
    { 0x1E13, "civilianjetflyby" },
    { 0x1E14, "civilianjetflyby_timer" },
    { 0x1E15, "civilianmarketanimations" },
    { 0x1E16, "civilianprops" },
    { 0x1E17, "civilians" },
    { 0x1E18, "civilians_below" },
    { 0x1E19, "civilians_flank_alley_react" },
    { 0x1E1A, "civilians_left" },
    { 0x1E1B, "civilians_right" },
    { 0x1E1C, "civkillwhennearplayer" },
    { 0x1E1D, "civscrambleanimations" },
    { 0x1E1E, "civsniperdamagemonitor" },
    { 0x1E1F, "claim_a_node" },
    { 0x1E20, "claimed" },
    { 0x1E21, "claimed_drone" },
    { 0x1E22, "claimed_node" },
    { 0x1E23, "claimed_walker_turret_target" },
    { 0x1E24, "claimplayer" },
    { 0x1E25, "claimteam" },
    { 0x1E26, "claimtrigger" },
    { 0x1E27, "clampedhealth" },
    { 0x1E28, "clamplookangle" },
    { 0x1E29, "clamppositiontolowerbounds" },
    { 0x1E2A, "clampreleasefx" },
    { 0x1E2B, "clamptobyte" },
    { 0x1E2C, "clamptoshort" },
    { 0x1E2D, "clampweaponweightvalue" },
    { 0x1E2E, "clampyaworbitoffset" },
    { 0x1E2F, "clan_profile_update" },
    { 0x1E30, "clanmemberownerids" },
    { 0x1E31, "class" },
    { 0x1E32, "class_num" },
    { 0x1E33, "class_override" },
    { 0x1E34, "classabilityready" },
    { 0x1E35, "classabilitytime" },
    { 0x1E36, "classcallback" },
    { 0x1E37, "classdmgmod" },
    { 0x1E38, "classgrenades" },
    { 0x1E39, "classmap" },
    { 0x1E3A, "classmaxhealth" },
    { 0x1E3B, "classold" },
    { 0x1E3C, "classpickcount" },
    { 0x1E3D, "classsettings" },
    { 0x1E3E, "classswitchwait" },
    { 0x1E3F, "classswitchwaiting" },
    { 0x1E40, "classtablename" },
    { 0x1E41, "classtablenum" },
    { 0x1E42, "classtime" },
    { 0x1E43, "classtweaks" },
    { 0x1E44, "classweaponswait" },
    { 0x1E45, "claymore_pickup_think_global" },
    { 0x1E46, "claymorearray" },
    { 0x1E47, "claymoredetectiondot" },
    { 0x1E48, "claymoredetectiongraceperiod" },
    { 0x1E49, "claymoredetectionmindist" },
    { 0x1E4A, "claymoredetonateradius" },
    { 0x1E4B, "claymoredetonation" },
    { 0x1E4C, "claymoremakesentient" },
    { 0x1E4D, "claymores" },
    { 0x1E4E, "claymoresentientfunc" },
    { 0x1E4F, "clean_kill_vo" },
    { 0x1E50, "clean_kill_vo_setup" },
    { 0x1E51, "clean_up_ai" },
    { 0x1E52, "clean_up_ai_single" },
    { 0x1E53, "clean_up_car" },
    { 0x1E54, "clean_up_hud_entity" },
    { 0x1E55, "clean_up_intro_pilots" },
    { 0x1E56, "clean_up_on_parent_death" },
    { 0x1E57, "clean_up_shadow_tag" },
    { 0x1E58, "clean_up_suv_drivers" },
    { 0x1E59, "clean_up_target_pos_ent" },
    { 0x1E5A, "clean_up_traffic_drivers" },
    { 0x1E5B, "clean_up_vehicle" },
    { 0x1E5C, "clean_up_vehicle_free_path" },
    { 0x1E5D, "clean_up_vehicle_seoul" },
    { 0x1E5E, "clean_up_vehicle_type" },
    { 0x1E5F, "clean_up_vehicles_all" },
    { 0x1E60, "cleanarray" },
    { 0x1E61, "cleanout_unneeded_ents_for_createfx" },
    { 0x1E62, "cleanup" },
    { 0x1E63, "cleanup_ai_logging_road" },
    { 0x1E64, "cleanup_ai_on_trigger" },
    { 0x1E65, "cleanup_ai_think" },
    { 0x1E66, "cleanup_ai_with_script_noteworthy" },
    { 0x1E67, "cleanup_atlas_on_death" },
    { 0x1E68, "cleanup_bobbing" },
    { 0x1E69, "cleanup_courtyard_enemies" },
    { 0x1E6A, "cleanup_drone_tags" },
    { 0x1E6B, "cleanup_enemies" },
    { 0x1E6C, "cleanup_enemy_ai_seoul" },
    { 0x1E6D, "cleanup_ents" },
    { 0x1E6E, "cleanup_ents_removing_bullet_shield" },
    { 0x1E6F, "cleanup_explosion_ents" },
    { 0x1E70, "cleanup_extra_ai" },
    { 0x1E71, "cleanup_foam_corridor_enemies" },
    { 0x1E72, "cleanup_fob_guys" },
    { 0x1E73, "cleanup_hovertank_combat" },
    { 0x1E74, "cleanup_in_aisle3" },
    { 0x1E75, "cleanup_land_assist" },
    { 0x1E76, "cleanup_mech_traversal_elements" },
    { 0x1E77, "cleanup_microwave_on_exit" },
    { 0x1E78, "cleanup_missile" },
    { 0x1E79, "cleanup_on_death" },
    { 0x1E7A, "cleanup_on_flag" },
    { 0x1E7B, "cleanup_on_goal" },
    { 0x1E7C, "cleanup_oncoming_suv" },
    { 0x1E7D, "cleanup_overlay" },
    { 0x1E7E, "cleanup_primer" },
    { 0x1E7F, "cleanup_primer_reload" },
    { 0x1E80, "cleanup_road_flares" },
    { 0x1E81, "cleanup_school_cars" },
    { 0x1E82, "cleanup_snake" },
    { 0x1E83, "cleanup_snake_cloud" },
    { 0x1E84, "cleanup_snake_cloud_on_flag" },
    { 0x1E85, "cleanup_snipers_zone" },
    { 0x1E86, "cleanup_specific_spawns" },
    { 0x1E87, "cleanup_squad_drone" },
    { 0x1E88, "cleanup_sticky" },
    { 0x1E89, "cleanup_sticky_on_death" },
    { 0x1E8A, "cleanup_tower_enemies" },
    { 0x1E8B, "cleanup_vista" },
    { 0x1E8C, "cleanupbuddyspawn" },
    { 0x1E8D, "cleanupcarepackage" },
    { 0x1E8E, "cleanuplasertargetingdevice" },
    { 0x1E8F, "cleanupnodefields" },
    { 0x1E90, "cleanupondeath" },
    { 0x1E91, "cleanupospents" },
    { 0x1E92, "cleanuprockettargeticon" },
    { 0x1E93, "cleanupvars" },
    { 0x1E94, "cleanupweaponsonground" },
    { 0x1E95, "clear_additive_helmet_anim" },
    { 0x1E96, "clear_ai_detection_on_death" },
    { 0x1E97, "clear_alerted_info" },
    { 0x1E98, "clear_all_color_orders" },
    { 0x1E99, "clear_all_loopers" },
    { 0x1E9A, "clear_anim_on_death" },
    { 0x1E9B, "clear_animation" },
    { 0x1E9C, "clear_anims" },
    { 0x1E9D, "clear_anims_on_death" },
    { 0x1E9E, "clear_archetype" },
    { 0x1E9F, "clear_blast_walk_anims" },
    { 0x1EA0, "clear_bot_camping_on_bot_death" },
    { 0x1EA1, "clear_bot_camping_on_reset" },
    { 0x1EA2, "clear_bot_on_bot_death" },
    { 0x1EA3, "clear_bot_on_reset" },
    { 0x1EA4, "clear_breaching_variable" },
    { 0x1EA5, "clear_bulletshield_on_alert" },
    { 0x1EA6, "clear_camper_data" },
    { 0x1EA7, "clear_cars_around_pos" },
    { 0x1EA8, "clear_color_order" },
    { 0x1EA9, "clear_color_order_from_team" },
    { 0x1EAA, "clear_colors" },
    { 0x1EAB, "clear_custom_animset" },
    { 0x1EAC, "clear_custom_gameskill_func" },
    { 0x1EAD, "clear_custom_patrol_anim_set" },
    { 0x1EAE, "clear_deathanim" },
    { 0x1EAF, "clear_defend" },
    { 0x1EB0, "clear_defend_or_goal_if_necessary" },
    { 0x1EB1, "clear_doctor_head" },
    { 0x1EB2, "clear_dodge_positions" },
    { 0x1EB3, "clear_door_effect" },
    { 0x1EB4, "clear_drone_cloud" },
    { 0x1EB5, "clear_dvar" },
    { 0x1EB6, "clear_enemy_outline_on_death" },
    { 0x1EB7, "clear_enemy_passthrough" },
    { 0x1EB8, "clear_entity_selection" },
    { 0x1EB9, "clear_event_on_prob" },
    { 0x1EBA, "clear_exception" },
    { 0x1EBB, "clear_force_color" },
    { 0x1EBC, "clear_fx_hudelements" },
    { 0x1EBD, "clear_generic_idle_anim" },
    { 0x1EBE, "clear_generic_run_anim" },
    { 0x1EBF, "clear_guy_fx" },
    { 0x1EC0, "clear_hint_button" },
    { 0x1EC1, "clear_hints" },
    { 0x1EC2, "clear_hud_on_notify" },
    { 0x1EC3, "clear_ignore_all_on_group" },
    { 0x1EC4, "clear_land_assist" },
    { 0x1EC5, "clear_light_set_for_player" },
    { 0x1EC6, "clear_max_momentum_delayed" },
    { 0x1EC7, "clear_maxed_momentum" },
    { 0x1EC8, "clear_momentum" },
    { 0x1EC9, "clear_npc_anim" },
    { 0x1ECA, "clear_npc_anims" },
    { 0x1ECB, "clear_on_action_success" },
    { 0x1ECC, "clear_overdrive_battery" },
    { 0x1ECD, "clear_path_weights" },
    { 0x1ECE, "clear_player_anim" },
    { 0x1ECF, "clear_player_attacked_by_dog_on_death" },
    { 0x1ED0, "clear_pluggable_move_loop_override" },
    { 0x1ED1, "clear_president_anims" },
    { 0x1ED2, "clear_promotion_order" },
    { 0x1ED3, "clear_refugee_camp_walk_anims" },
    { 0x1ED4, "clear_run_anim" },
    { 0x1ED5, "clear_script_goal_on" },
    { 0x1ED6, "clear_script_goal_on_gas_end" },
    { 0x1ED7, "clear_script_model_anim" },
    { 0x1ED8, "clear_set_goal" },
    { 0x1ED9, "clear_settable_fx" },
    { 0x1EDA, "clear_stencil_on_death" },
    { 0x1EDB, "clear_talking_currently_when_done" },
    { 0x1EDC, "clear_target_zone_update" },
    { 0x1EDD, "clear_team_colors" },
    { 0x1EDE, "clear_tool_hud" },
    { 0x1EDF, "clear_unresolved_collision_count_next_frame" },
    { 0x1EE0, "clear_urgent_walk_anims" },
    { 0x1EE1, "clear_vehicle_anim" },
    { 0x1EE2, "clearafterfade" },
    { 0x1EE3, "clearalertoutline" },
    { 0x1EE4, "clearalertstencilstate" },
    { 0x1EE5, "clearall" },
    { 0x1EE6, "clearammo" },
    { 0x1EE7, "clearbattlebuddy" },
    { 0x1EE8, "clearbuddymessage" },
    { 0x1EE9, "clearcarrier" },
    { 0x1EEA, "clearcopycatloadout" },
    { 0x1EEB, "cleardodgeanims" },
    { 0x1EEC, "cleared" },
    { 0x1EED, "clearempondeath" },
    { 0x1EEE, "clearfaceanimonanimdone" },
    { 0x1EEF, "clearfirefightdata" },
    { 0x1EF0, "clearfirefightshotsoninterval" },
    { 0x1EF1, "clearfxondeath" },
    { 0x1EF2, "clearhudtimer" },
    { 0x1EF3, "clearidshortly" },
    { 0x1EF4, "clearisspeaking" },
    { 0x1EF5, "clearkillcamstate" },
    { 0x1EF6, "clearkillstreaks" },
    { 0x1EF7, "clearlookatthread" },
    { 0x1EF8, "clearlowermessage" },
    { 0x1EF9, "clearlowermessages" },
    { 0x1EFA, "clearmovementparameters" },
    { 0x1EFB, "clearondeath" },
    { 0x1EFC, "clearonvictimdisconnect" },
    { 0x1EFD, "clearplayertargetlist" },
    { 0x1EFE, "clearpracticeroundlockoutdata" },
    { 0x1EFF, "clearprevioustispawnpoint" },
    { 0x1F00, "clearprogress" },
    { 0x1F01, "clearragdolldeath" },
    { 0x1F02, "clearrideintro" },
    { 0x1F03, "clearrideintroonteamchange" },
    { 0x1F04, "clearsightposnear" },
    { 0x1F05, "clearspawnpointdistancedata" },
    { 0x1F06, "clearspawnpointsightdata" },
    { 0x1F07, "clearstencil" },
    { 0x1F08, "clearstencilstate" },
    { 0x1F09, "clearstencilstateondeath" },
    { 0x1F0A, "clearsurvivaltime" },
    { 0x1F0B, "clearteamspawnpointdistancedata" },
    { 0x1F0C, "clearteamspawnpointsightdata" },
    { 0x1F0D, "cleartextmarker" },
    { 0x1F0E, "clearthreatbias" },
    { 0x1F0F, "clearunderwateraudiozone" },
    { 0x1F10, "clearusingremote" },
    { 0x1F11, "clearwatervarsonspawn" },
    { 0x1F12, "clientid" },
    { 0x1F13, "clientmatchdataid" },
    { 0x1F14, "clienttracespawnclass" },
    { 0x1F15, "clienttweakables" },
    { 0x1F16, "cliff_rappel" },
    { 0x1F17, "cliff_rappel_dialogue" },
    { 0x1F18, "cliff_rappel_dialogue_nag" },
    { 0x1F19, "cliff_rappel_landing" },
    { 0x1F1A, "cliff_rappel_lerpsun" },
    { 0x1F1B, "cliff_rappel_lighting_init" },
    { 0x1F1C, "cliff_rappel_lighting_setup" },
    { 0x1F1D, "cliff_rappel_logic" },
    { 0x1F1E, "cliff_rappel_moment" },
    { 0x1F1F, "cliff_rappel_shadow_tweaks" },
    { 0x1F20, "climb_fence_joker_01" },
    { 0x1F21, "climb_fence_joker_02" },
    { 0x1F22, "climb_fence_joker_03" },
    { 0x1F23, "climb_fence_joker_04" },
    { 0x1F24, "climb_fence_joker_05" },
    { 0x1F25, "climb_fence_joker_06" },
    { 0x1F26, "climb_fence_joker_07" },
    { 0x1F27, "climb_fence_joker_08" },
    { 0x1F28, "climb_fence_joker_09" },
    { 0x1F29, "climb_fence_joker_10" },
    { 0x1F2A, "climb_fence_torres_01" },
    { 0x1F2B, "climb_fence_torres_02" },
    { 0x1F2C, "climb_fence_torres_03" },
    { 0x1F2D, "climb_fence_torres_04" },
    { 0x1F2E, "climb_fence_torres_05" },
    { 0x1F2F, "climb_fence_torres_06" },
    { 0x1F30, "climb_fence_torres_07" },
    { 0x1F31, "climb_fence_torres_08" },
    { 0x1F32, "climb_fence_torres_09" },
    { 0x1F33, "climb_fence_torres_10" },
    { 0x1F34, "climb_hint" },
    { 0x1F35, "climb_scene_anim_boat_getout" },
    { 0x1F36, "climb_scene_cleanup" },
    { 0x1F37, "climb_scene_colors_careful_on_arrival" },
    { 0x1F38, "climb_scene_crane_allow_input" },
    { 0x1F39, "climb_scene_crane_dismount_to_wall" },
    { 0x1F3A, "climb_scene_crane_glass_break" },
    { 0x1F3B, "climb_scene_crane_grab_rumble" },
    { 0x1F3C, "climb_scene_crane_grab_shake" },
    { 0x1F3D, "climb_scene_crane_mount" },
    { 0x1F3E, "climb_scene_crane_move" },
    { 0x1F3F, "climb_scene_crane_move_rumble" },
    { 0x1F40, "climb_scene_crane_move_shake" },
    { 0x1F41, "climb_scene_fail_fall" },
    { 0x1F42, "climb_scene_fail_on_ground_notify" },
    { 0x1F43, "climb_scene_finale" },
    { 0x1F44, "climb_scene_finale_setup_anim_ents" },
    { 0x1F45, "climb_scene_finale_setup_people_ents" },
    { 0x1F46, "climb_scene_finale_setup_player_ents" },
    { 0x1F47, "climb_scene_finale_setup_vehicle_ents" },
    { 0x1F48, "climb_scene_first_climb" },
    { 0x1F49, "climb_scene_first_on_foot_warbird_turret" },
    { 0x1F4A, "climb_scene_force_dismount" },
    { 0x1F4B, "climb_scene_grapple_hint_handler" },
    { 0x1F4C, "climb_scene_handle_crane_climb" },
    { 0x1F4D, "climb_scene_handle_crane_climb_movement_input" },
    { 0x1F4E, "climb_scene_handle_finale_walker_civilian_vingette" },
    { 0x1F4F, "climb_scene_handle_walker" },
    { 0x1F50, "climb_scene_handle_walker_reaction" },
    { 0x1F51, "climb_scene_ilona_simple_climbing" },
    { 0x1F52, "climb_scene_master_handler" },
    { 0x1F53, "climb_scene_move_crate_on_path" },
    { 0x1F54, "climb_scene_moving_crates" },
    { 0x1F55, "climb_scene_on_foot" },
    { 0x1F56, "climb_scene_on_foot_crate_death_area" },
    { 0x1F57, "climb_scene_on_foot_ilana_past_crate" },
    { 0x1F58, "climb_scene_on_foot_setup" },
    { 0x1F59, "climb_scene_on_foot_warbird_arrival" },
    { 0x1F5A, "climb_scene_preprocess_crate_path" },
    { 0x1F5B, "climb_scene_rotate_crate_on_path" },
    { 0x1F5C, "climb_scene_second_climb" },
    { 0x1F5D, "climb_scene_second_climb_ilona_no_push" },
    { 0x1F5E, "climb_scene_set_colors_careful_on_arrival_setting" },
    { 0x1F5F, "climb_scene_setup" },
    { 0x1F60, "climb_scene_setup_droneswarm" },
    { 0x1F61, "climb_scene_setup_zipliners" },
    { 0x1F62, "climb_scene_skybridge" },
    { 0x1F63, "climb_scene_skybridge_break_glass" },
    { 0x1F64, "climb_scene_skybridge_teleport_ilona" },
    { 0x1F65, "climb_scene_start_action" },
    { 0x1F66, "climb_scene_start_crane" },
    { 0x1F67, "climb_scene_warbird_setup_rotar_death_trigger" },
    { 0x1F68, "climb_scne_finale_fade_out" },
    { 0x1F69, "climb_scne_finale_hide_body" },
    { 0x1F6A, "climb_trigger" },
    { 0x1F6B, "climb_wall_nag_dialogue" },
    { 0x1F6C, "climb_warbird" },
    { 0x1F6D, "climbing_animation_back_to_side_idle" },
    { 0x1F6E, "climbing_animation_dismount" },
    { 0x1F6F, "climbing_animation_idle_loop" },
    { 0x1F70, "climbing_animation_idle_to_side_idle" },
    { 0x1F71, "climbing_animation_side_idle_to_back" },
    { 0x1F72, "climbing_animation_side_idle_to_idle" },
    { 0x1F73, "climbing_animation_stop_idle" },
    { 0x1F74, "climbing_animation_traverse_move" },
    { 0x1F75, "climbing_crane_allow_input" },
    { 0x1F76, "climbing_crates" },
    { 0x1F77, "climbing_give_player_weapon" },
    { 0x1F78, "climbing_head_sway" },
    { 0x1F79, "climbing_helper_dir_is_blocked" },
    { 0x1F7A, "climbing_helper_player_combat_requested" },
    { 0x1F7B, "climbing_helper_player_dismount_requested" },
    { 0x1F7C, "climbing_helper_player_exit_combat_mode_requested" },
    { 0x1F7D, "climbing_helper_player_in_combat_mode" },
    { 0x1F7E, "climbing_helper_player_input_1_allowed" },
    { 0x1F7F, "climbing_helper_player_input_2_allowed" },
    { 0x1F80, "climbing_helper_player_jump_requested" },
    { 0x1F81, "climbing_helper_player_jumping" },
    { 0x1F82, "climbing_helper_player_mag_moving" },
    { 0x1F83, "climbing_helper_player_moving" },
    { 0x1F84, "climbing_hint_display" },
    { 0x1F85, "climbing_ilona_teleported" },
    { 0x1F86, "climbing_motion_dismount" },
    { 0x1F87, "climbing_motion_player_combat_mode" },
    { 0x1F88, "climbing_motion_player_jump_to_mag" },
    { 0x1F89, "climbing_motion_player_jumping" },
    { 0x1F8A, "climbing_motion_player_looking" },
    { 0x1F8B, "climbing_motion_player_mag_to_jump" },
    { 0x1F8C, "climbing_motion_player_moving_on_magnetic_surface" },
    { 0x1F8D, "climbing_motion_start_player_jump" },
    { 0x1F8E, "climbing_motion_start_player_jump_to_mag" },
    { 0x1F8F, "climbing_motion_start_player_mag_move" },
    { 0x1F90, "climbing_motion_start_player_mag_to_jump" },
    { 0x1F91, "climbing_motion_start_player_shooting" },
    { 0x1F92, "climbing_motion_stop_player_combat_mode" },
    { 0x1F93, "climbing_motion_stop_player_combat_mode_quick" },
    { 0x1F94, "climbing_player_controller" },
    { 0x1F95, "climbing_player_dismounting" },
    { 0x1F96, "climbing_player_mount" },
    { 0x1F97, "climbing_scene_on_foot_no_friendly_damage_in_death_area" },
    { 0x1F98, "climbing_update_available_moving_options" },
    { 0x1F99, "clip" },
    { 0x1F9A, "clip_missle_damage_think" },
    { 0x1F9B, "clipammol" },
    { 0x1F9C, "clipammor" },
    { 0x1F9D, "cloak" },
    { 0x1F9E, "cloak_again" },
    { 0x1F9F, "cloak_battery_hud" },
    { 0x1FA0, "cloak_battery_level" },
    { 0x1FA1, "cloak_device_hit_by_electro_magnetic_pulse" },
    { 0x1FA2, "cloak_disabled" },
    { 0x1FA3, "cloak_enemy_attack_behavior" },
    { 0x1FA4, "cloak_enemy_attack_behavior_mech" },
    { 0x1FA5, "cloak_enemy_default_setup" },
    { 0x1FA6, "cloak_enemy_fast_attack_behavior" },
    { 0x1FA7, "cloak_enemy_investigative_attack_behavior" },
    { 0x1FA8, "cloak_enemy_normal_behavior" },
    { 0x1FA9, "cloak_enemy_normal_behavior_mech" },
    { 0x1FAA, "cloak_enemy_reset_behavior" },
    { 0x1FAB, "cloak_enemy_reset_behavior_mech" },
    { 0x1FAC, "cloak_enemy_state_hidden" },
    { 0x1FAD, "cloak_enemy_state_spotted" },
    { 0x1FAE, "cloak_enemy_warning1_behavior" },
    { 0x1FAF, "cloak_enemy_warning1_behavior_mech" },
    { 0x1FB0, "cloak_enemy_warning2_behavior" },
    { 0x1FB1, "cloak_hud" },
    { 0x1FB2, "cloak_new" },
    { 0x1FB3, "cloak_npc_weapon_instantaneous" },
    { 0x1FB4, "cloak_off" },
    { 0x1FB5, "cloak_off_rope" },
    { 0x1FB6, "cloak_off_server_room" },
    { 0x1FB7, "cloak_on" },
    { 0x1FB8, "cloak_overlay" },
    { 0x1FB9, "cloak_stencil_on" },
    { 0x1FBA, "cloak_vm_weapon_blend" },
    { 0x1FBB, "cloak_vm_weapon_instantaneous" },
    { 0x1FBC, "cloak_warbird" },
    { 0x1FBD, "cloakactivateddialog" },
    { 0x1FBE, "cloakcooldown" },
    { 0x1FBF, "cloakdeactivateddialog" },
    { 0x1FC0, "cloaked_model" },
    { 0x1FC1, "cloaked_stealth_disable_battery_hud" },
    { 0x1FC2, "cloaked_stealth_disable_lab_hud_cinematic" },
    { 0x1FC3, "cloaked_stealth_enable_battery_hud" },
    { 0x1FC4, "cloaked_stealth_enable_lab_hud_cinematic" },
    { 0x1FC5, "cloaked_stealth_player_setup" },
    { 0x1FC6, "cloakedmodel" },
    { 0x1FC7, "cloaking_visual_effect_in_progress" },
    { 0x1FC8, "cloakingtransition" },
    { 0x1FC9, "cloakreadydialog" },
    { 0x1FCA, "cloakstate" },
    { 0x1FCB, "cloakwarbirdexit" },
    { 0x1FCC, "cloakweapon" },
    { 0x1FCD, "cloneloadout" },
    { 0x1FCE, "close" },
    { 0x1FCF, "close_ads_window_on_unlink" },
    { 0x1FD0, "close_all_doors" },
    { 0x1FD1, "close_elevator_doors" },
    { 0x1FD2, "close_enemy_check_on_mt_exit" },
    { 0x1FD3, "close_inner_doors" },
    { 0x1FD4, "close_interior_door" },
    { 0x1FD5, "close_me_when_exopush_over" },
    { 0x1FD6, "close_outer_doors" },
    { 0x1FD7, "close_pos" },
    { 0x1FD8, "close_silo_doors" },
    { 0x1FD9, "closeclassmenu" },
    { 0x1FDA, "closed" },
    { 0x1FDB, "closed_angles" },
    { 0x1FDC, "closeendinggates" },
    { 0x1FDD, "closeendinggatestransition" },
    { 0x1FDE, "closeenoughaimdegrees" },
    { 0x1FDF, "closeflightsound" },
    { 0x1FE0, "closeomamenuondeath" },
    { 0x1FE1, "closer_to_goal_vol" },
    { 0x1FE2, "closerfunc" },
    { 0x1FE3, "closest_drone" },
    { 0x1FE4, "closestai" },
    { 0x1FE5, "cloud_fx" },
    { 0x1FE6, "cloud_queen" },
    { 0x1FE7, "cloud_queen_fly" },
    { 0x1FE8, "cloudfasteffectchange" },
    { 0x1FE9, "cloudfastheavy" },
    { 0x1FEA, "cloudfastinit" },
    { 0x1FEB, "cloudfastlight" },
    { 0x1FEC, "cloudfastmedium" },
    { 0x1FED, "cloudfastnone" },
    { 0x1FEE, "cloudfastplayer" },
    { 0x1FEF, "cloudpushplayer" },
    { 0x1FF0, "cloudrandomizer" },
    { 0x1FF1, "clouds" },
    { 0x1FF2, "clouds_create" },
    { 0x1FF3, "cloudsunflicker" },
    { 0x1FF4, "cloudsunreset" },
    { 0x1FF5, "clusterdeployed" },
    { 0x1FF6, "clusterhellfire" },
    { 0x1FF7, "clustermissile" },
    { 0x1FF8, "clusterspiral" },
    { 0x1FF9, "clut_manage" },
    { 0x1FFA, "clut_manage_school" },
    { 0x1FFB, "clut_previous" },
    { 0x1FFC, "clut_rotate" },
    { 0x1FFD, "clut_trigger_manage" },
    { 0x1FFE, "clut_underwater" },
    { 0x1FFF, "cobra_missile_models" },
    { 0x2000, "cobra_weapon_tags" },
    { 0x2001, "cobrapilot_difficulty" },
    { 0x2002, "cobraweapon" },
    { 0x2003, "codecallback_givekillstreak" },
    { 0x2004, "codescripted" },
    { 0x2005, "cohesion_factor" },
    { 0x2006, "coi_bone" },
    { 0x2007, "coi_ent" },
    { 0x2008, "coi_pos" },
    { 0x2009, "cointoss" },
    { 0x200A, "cointossweighted" },
    { 0x200B, "col" },
    { 0x200C, "col_base" },
    { 0x200D, "col_body" },
    { 0x200E, "col_brush" },
    { 0x200F, "col_gun" },
    { 0x2010, "col_head" },
    { 0x2011, "col_leg_l" },
    { 0x2012, "col_leg_r" },
    { 0x2013, "col_lines" },
    { 0x2014, "col_moving_volumes" },
    { 0x2015, "col_t" },
    { 0x2016, "col_volumes" },
    { 0x2017, "cold_breath" },
    { 0x2018, "cold_burn_lighting_fog" },
    { 0x2019, "coll" },
    { 0x201A, "collapse_animate_lamps" },
    { 0x201B, "collapse_cleanup" },
    { 0x201C, "collapse_cop" },
    { 0x201D, "collapse_fov" },
    { 0x201E, "collapse_friendly_think" },
    { 0x201F, "collapse_player_disable_exo_and_weapons" },
    { 0x2020, "collapse_player_dynamic_speed" },
    { 0x2021, "collapse_player_look_at_tower" },
    { 0x2022, "collapse_scene_ents" },
    { 0x2023, "collapse_scene_ents_long" },
    { 0x2024, "collapse_shellshock" },
    { 0x2025, "collapse_stop_sign_think" },
    { 0x2026, "collapsing_buttress_01" },
    { 0x2027, "collapsing_buttress_02" },
    { 0x2028, "collapsing_buttress_03" },
    { 0x2029, "collapsing_buttress_missile" },
    { 0x202A, "collapsing_buttress_missile_flyby" },
    { 0x202B, "collect_func" },
    { 0x202C, "collectcount" },
    { 0x202D, "collectobjects" },
    { 0x202E, "collectpickup" },
    { 0x202F, "collectpickupfunc" },
    { 0x2030, "collectpickupmodel" },
    { 0x2031, "collision" },
    { 0x2032, "collision_brush_post_explosion" },
    { 0x2033, "collision_brush_pre_explosion" },
    { 0x2034, "collision_prop" },
    { 0x2035, "collision_watcher" },
    { 0x2036, "color_activate_post_burk_rally" },
    { 0x2037, "color_debug" },
    { 0x2038, "color_doesnt_care_about_classname" },
    { 0x2039, "color_doesnt_care_about_heroes" },
    { 0x203A, "color_from_index" },
    { 0x203B, "color_group_enter_lab_trigger" },
    { 0x203C, "color_node" },
    { 0x203D, "color_node_anim_at_node" },
    { 0x203E, "color_node_anim_at_node_animate" },
    { 0x203F, "color_node_arrival_notifies" },
    { 0x2040, "color_node_type_function" },
    { 0x2041, "color_ordered_node_assignment" },
    { 0x2042, "color_priority" },
    { 0x2043, "color_spawners_setup" },
    { 0x2044, "color_system" },
    { 0x2045, "color_teams" },
    { 0x2046, "color_user" },
    { 0x2047, "color0" },
    { 0x2048, "color01" },
    { 0x2049, "color1" },
    { 0x204A, "colorblind" },
    { 0x204B, "colorchecklist" },
    { 0x204C, "colorcode_is_used_in_map" },
    { 0x204D, "colordebug" },
    { 0x204E, "colorindex" },
    { 0x204F, "colorislegit" },
    { 0x2050, "colorlist" },
    { 0x2051, "colornode_clear_promotion_order" },
    { 0x2052, "colornode_func" },
    { 0x2053, "colornode_replace_on_death" },
    { 0x2054, "colornode_set_empty_promotion_order" },
    { 0x2055, "colornode_set_promotion_order" },
    { 0x2056, "colornode_set_respawn_point" },
    { 0x2057, "colornode_setgoal_func" },
    { 0x2058, "colornode_spawn_reinforcement" },
    { 0x2059, "colornode_stop_replace_on_death_group" },
    { 0x205A, "colornodes_debug_array" },
    { 0x205B, "colors" },
    { 0x205C, "colors_player_can_take_nodes" },
    { 0x205D, "cols" },
    { 0x205E, "colvol" },
    { 0x205F, "combat_canal_01" },
    { 0x2060, "combat_cave_cleanup" },
    { 0x2061, "combat_cave_dialogue" },
    { 0x2062, "combat_cave_exit" },
    { 0x2063, "combat_cave_to_lake_follow_dot" },
    { 0x2064, "combat_clearfacialanim" },
    { 0x2065, "combat_courtyard_general_01_think" },
    { 0x2066, "combat_courtyard_jammer" },
    { 0x2067, "combat_courtyard_jammer_complete" },
    { 0x2068, "combat_courtyard_jammer_ladder_left" },
    { 0x2069, "combat_courtyard_jammer_ladder_right" },
    { 0x206A, "combat_courtyard_mech" },
    { 0x206B, "combat_courtyard_path_general" },
    { 0x206C, "combat_courtyard_path_jammer_building" },
    { 0x206D, "combat_courtyard_path_left_00" },
    { 0x206E, "combat_courtyard_path_left_00_think" },
    { 0x206F, "combat_courtyard_path_left_01" },
    { 0x2070, "combat_courtyard_path_left_01_think" },
    { 0x2071, "combat_courtyard_path_left_02" },
    { 0x2072, "combat_courtyard_path_left_02_think" },
    { 0x2073, "combat_courtyard_path_left_03" },
    { 0x2074, "combat_courtyard_path_left_03_think" },
    { 0x2075, "combat_courtyard_path_middle_01" },
    { 0x2076, "combat_courtyard_path_middle_01_think" },
    { 0x2077, "combat_courtyard_path_middle_02" },
    { 0x2078, "combat_courtyard_path_middle_02_think" },
    { 0x2079, "combat_courtyard_path_middle_03" },
    { 0x207A, "combat_courtyard_path_middle_03_think" },
    { 0x207B, "combat_courtyard_path_right_01" },
    { 0x207C, "combat_courtyard_path_right_01_think" },
    { 0x207D, "combat_courtyard_path_right_02" },
    { 0x207E, "combat_courtyard_path_right_02_think" },
    { 0x207F, "combat_courtyard_path_right_03" },
    { 0x2080, "combat_courtyard_path_right_03_think" },
    { 0x2081, "combat_enemy_tank" },
    { 0x2082, "combat_enemy_trans_heli_wave_01" },
    { 0x2083, "combat_flyin_bridge" },
    { 0x2084, "combat_foam_corridor" },
    { 0x2085, "combat_forest_patrols_start" },
    { 0x2086, "combat_gaz_bridge" },
    { 0x2087, "combat_hangar" },
    { 0x2088, "combat_lobby" },
    { 0x2089, "combat_logging_road_end" },
    { 0x208A, "combat_player_in_m_turret" },
    { 0x208B, "combat_playfacialanim" },
    { 0x208C, "combat_post_breach_patrol" },
    { 0x208D, "combat_research_building" },
    { 0x208E, "combat_research_building_bridge" },
    { 0x208F, "combat_research_left_01" },
    { 0x2090, "combat_research_platform_01" },
    { 0x2091, "combat_research_pool_room" },
    { 0x2092, "combat_research_pool_walkway_01" },
    { 0x2093, "combat_research_right_01" },
    { 0x2094, "combat_silo" },
    { 0x2095, "combat_silo_boost" },
    { 0x2096, "combat_silo_complete" },
    { 0x2097, "combat_silo_mech" },
    { 0x2098, "combat_silo_seeker_ai" },
    { 0x2099, "combat_spawn_research_right_flank_02" },
    { 0x209A, "combat_state" },
    { 0x209B, "combat_street_blown_building" },
    { 0x209C, "combat_street_initial" },
    { 0x209D, "combat_street_mid_checkpoint_1" },
    { 0x209E, "combat_street_mid_checkpoint_2" },
    { 0x209F, "combat_street_seeker_ai" },
    { 0x20A0, "combat_street_wave_01" },
    { 0x20A1, "combat_street_wave_02" },
    { 0x20A2, "combat_street_wave_03" },
    { 0x20A3, "combat_street_wave_04" },
    { 0x20A4, "combat_street_wave_rear" },
    { 0x20A5, "combat_tank_courtyard" },
    { 0x20A6, "combat_tank_courtyard_gate_1_guys_think" },
    { 0x20A7, "combat_tank_field_flee_guys_think" },
    { 0x20A8, "combat_tank_road" },
    { 0x20A9, "combat_zip_rooftop" },
    { 0x20AA, "combatbehavior" },
    { 0x20AB, "combatbuttonbuffer" },
    { 0x20AC, "combatcrouchanims" },
    { 0x20AD, "combatendtime" },
    { 0x20AE, "combathigh" },
    { 0x20AF, "combatidle" },
    { 0x20B0, "combatidlepreventoverlappingplayer" },
    { 0x20B1, "combatmemorytimeconst" },
    { 0x20B2, "combatmemorytimerand" },
    { 0x20B3, "combatrecordtie" },
    { 0x20B4, "combatrecordwin" },
    { 0x20B5, "combatreminderdialogue" },
    { 0x20B6, "combatstandanims" },
    { 0x20B7, "combatstate" },
    { 0x20B8, "combattime" },
    { 0x20B9, "comebackcustomkillstreakfunc" },
    { 0x20BA, "comebackcustomospfunc" },
    { 0x20BB, "comebackevent" },
    { 0x20BC, "command_goal" },
    { 0x20BD, "command_used" },
    { 0x20BE, "commander_dialog" },
    { 0x20BF, "commander_speaking" },
    { 0x20C0, "commanding_bot" },
    { 0x20C1, "commit_exo_awards_stage_and_progress" },
    { 0x20C2, "commit_exo_awards_upgrade_points_custom" },
    { 0x20C3, "commit_exo_awards_upon_mission_success" },
    { 0x20C4, "common_canyon_funcs" },
    { 0x20C5, "commonstarttime" },
    { 0x20C6, "compare_killnow_score" },
    { 0x20C7, "compare_player_pass_dot" },
    { 0x20C8, "compare_script_index" },
    { 0x20C9, "compare_time_before_attack" },
    { 0x20CA, "compare_time_before_move" },
    { 0x20CB, "compare_time_since_birth" },
    { 0x20CC, "compareorbitangle" },
    { 0x20CD, "comparescreenpos" },
    { 0x20CE, "comparesizesfx" },
    { 0x20CF, "comparezoneindexes" },
    { 0x20D0, "compass_offsets" },
    { 0x20D1, "compass_text" },
    { 0x20D2, "compass_update_text" },
    { 0x20D3, "compassicons" },
    { 0x20D4, "complete_me" },
    { 0x20D5, "completed_delay" },
    { 0x20D6, "completedanims" },
    { 0x20D7, "completednodes" },
    { 0x20D8, "component_cache" },
    { 0x20D9, "component_weights" },
    { 0x20DA, "compute_best_gun_target" },
    { 0x20DB, "compute_fireweapon_direction" },
    { 0x20DC, "compute_spread" },
    { 0x20DD, "compute_target_lead_origin" },
    { 0x20DE, "compute_threat" },
    { 0x20DF, "computer_door_entry_sfx_notetrack" },
    { 0x20E0, "concealed_kill_tutorial_display" },
    { 0x20E1, "concealed_tutorial_display_hint" },
    { 0x20E2, "concussionendtime" },
    { 0x20E3, "condition_callback" },
    { 0x20E4, "condition_to_moving" },
    { 0x20E5, "condition_to_start_moving" },
    { 0x20E6, "condition_to_state_cruzin" },
    { 0x20E7, "condition_to_state_state_honking" },
    { 0x20E8, "condition_to_stop_moving" },
    { 0x20E9, "cone_length" },
    { 0x20EA, "conf_camper_camp_tags" },
    { 0x20EB, "conf_camping_tag" },
    { 0x20EC, "conf_fx" },
    { 0x20ED, "conf_static" },
    { 0x20EE, "confcenteratriumflashcharge" },
    { 0x20EF, "confcenterbegin" },
    { 0x20F0, "confcenterbossexplode" },
    { 0x20F1, "confcentercombatdialogue" },
    { 0x20F2, "confcenterexplosion" },
    { 0x20F3, "confcenterfailalarmsoundeddialogue" },
    { 0x20F4, "confcenterfailburkekilleddialogue" },
    { 0x20F5, "confcenterfailhadeskilledearlydialogue" },
    { 0x20F6, "confcenterfailinvalidtargetdialogue" },
    { 0x20F7, "confcenterfailtimeoutdialogue" },
    { 0x20F8, "confcenterfailtimerexpiredialogue" },
    { 0x20F9, "confcenterflaginit" },
    { 0x20FA, "confcentergatecharge" },
    { 0x20FB, "confcenterglobalsetup" },
    { 0x20FC, "confcenterglobalvars" },
    { 0x20FD, "confcenterintrodialogue" },
    { 0x20FE, "confcenterkilldialogue" },
    { 0x20FF, "confcenterlightglowfx" },
    { 0x2100, "confcenterobjectivesetup" },
    { 0x2101, "confcenteroutrodialogue" },
    { 0x2102, "confcenterpoolallywaterdrip" },
    { 0x2103, "confcenterpoolsplash" },
    { 0x2104, "confcenterprecache" },
    { 0x2105, "confcenterresidualsmoke" },
    { 0x2106, "confcentersetcompletedobjflags" },
    { 0x2107, "confcenterstartpoints" },
    { 0x2108, "confcentersupportadialogue" },
    { 0x2109, "confcentersupportbdialogue" },
    { 0x210A, "confcentersupportcdialogue" },
    { 0x210B, "confcentertotalcombat" },
    { 0x210C, "confcentervehiclesvulnerable" },
    { 0x210D, "conference_center_explo" },
    { 0x210E, "conference_center_explo_zone" },
    { 0x210F, "conference_center_fire" },
    { 0x2110, "conferenceroomanimations" },
    { 0x2111, "confhades" },
    { 0x2112, "config" },
    { 0x2113, "config_system" },
    { 0x2114, "confrontation_flashbang" },
    { 0x2115, "confrontation_fx_cleanup" },
    { 0x2116, "confrontation_guys" },
    { 0x2117, "confrontation_handle_player_clip" },
    { 0x2118, "confrontation_holo" },
    { 0x2119, "confrontation_hologram_fadeout" },
    { 0x211A, "confrontation_hudoutline_animate" },
    { 0x211B, "confrontation_hudoutline_cleanup" },
    { 0x211C, "confrontation_hudoutline_setup" },
    { 0x211D, "confrontation_irons_gun_shot" },
    { 0x211E, "confrontation_rig" },
    { 0x211F, "confrontation_scene_button_clean_up" },
    { 0x2120, "confrontation_scene_cleanup_confrontation" },
    { 0x2121, "confrontation_scene_cleanup_hologram" },
    { 0x2122, "confrontation_scene_cleaup" },
    { 0x2123, "confrontation_scene_escape" },
    { 0x2124, "confrontation_scene_escape_guard_dies" },
    { 0x2125, "confrontation_scene_escape_player_rise" },
    { 0x2126, "confrontation_scene_escape_qte_fail" },
    { 0x2127, "confrontation_scene_escape_qte_kick" },
    { 0x2128, "confrontation_scene_escape_qte_kick_kill" },
    { 0x2129, "confrontation_scene_escape_qte_raise_gun" },
    { 0x212A, "confrontation_scene_escape_qte_shoot" },
    { 0x212B, "confrontation_scene_flashbang_explode" },
    { 0x212C, "confrontation_scene_gun_swap" },
    { 0x212D, "confrontation_scene_hologram" },
    { 0x212E, "confrontation_scene_irons_lockdown" },
    { 0x212F, "confrontation_scene_irons_no_gun" },
    { 0x2130, "confrontation_scene_master_handler" },
    { 0x2131, "confrontation_scene_open_flashbang_door" },
    { 0x2132, "confrontation_scene_player_rumble_heavy" },
    { 0x2133, "confrontation_scene_player_rumble_light" },
    { 0x2134, "confrontation_scene_qte_kick_slomo_start" },
    { 0x2135, "confrontation_scene_qte_kick_slomo_stop" },
    { 0x2136, "confrontation_scene_qte_shoot_slomo_start" },
    { 0x2137, "confrontation_scene_qte_shoot_slomo_stop" },
    { 0x2138, "confrontation_scene_setup" },
    { 0x2139, "confrontation_static_start" },
    { 0x213A, "confrontation_tech_blood" },
    { 0x213B, "confroombodyscan" },
    { 0x213C, "confroombreachbodyguarddeath" },
    { 0x213D, "confroombreachhadesspeech" },
    { 0x213E, "confroomexplosiondronereaction" },
    { 0x213F, "confroomexplosivetrap" },
    { 0x2140, "confroomflashbang" },
    { 0x2141, "confroomhadessweep" },
    { 0x2142, "confroomragdoll" },
    { 0x2143, "confroomrecovery" },
    { 0x2144, "confroomreminderdialogue" },
    { 0x2145, "confroomsetup" },
    { 0x2146, "confroomstandingidles" },
    { 0x2147, "connect_node" },
    { 0x2148, "connect_nodes" },
    { 0x2149, "connect_paths" },
    { 0x214A, "connectandspawninstinctdogpack" },
    { 0x214B, "connected" },
    { 0x214C, "connectedmenus" },
    { 0x214D, "connectedpostgame" },
    { 0x214E, "connectingplayers" },
    { 0x214F, "connectnewagent" },
    { 0x2150, "connectpaths_ents_by_targetname" },
    { 0x2151, "connectpathsfunction" },
    { 0x2152, "connecttime" },
    { 0x2153, "connecttraverses" },
    { 0x2154, "considerchangingtarget" },
    { 0x2155, "considerthrowgrenade" },
    { 0x2156, "console" },
    { 0x2157, "console_guy" },
    { 0x2158, "consoleguy" },
    { 0x2159, "consolidated_inputs" },
    { 0x215A, "const_cosine_bunched_angle" },
    { 0x215B, "const_cosine_stick_angle" },
    { 0x215C, "constant_quake" },
    { 0x215D, "constrain_vector_to_cone" },
    { 0x215E, "constraingametype" },
    { 0x215F, "construct_vision_ents" },
    { 0x2160, "construct_vision_set" },
    { 0x2161, "construction_heli_shoot" },
    { 0x2162, "contact_watcher" },
    { 0x2163, "container_death_anims" },
    { 0x2164, "contents" },
    { 0x2165, "context_overrides" },
    { 0x2166, "continue_when_player_near_entity" },
    { 0x2167, "continuedrivenmovement" },
    { 0x2168, "continuemovement" },
    { 0x2169, "continuereinforcements" },
    { 0x216A, "control_foam_room_door02_clip" },
    { 0x216B, "control_goliath_usability" },
    { 0x216C, "control_mech_attacks" },
    { 0x216D, "control_mob_fire" },
    { 0x216E, "control_mob_turret" },
    { 0x216F, "control_room" },
    { 0x2170, "control_room_anims" },
    { 0x2171, "control_room_buzzer_started" },
    { 0x2172, "control_room_door_open_lt" },
    { 0x2173, "control_room_door_open_rt" },
    { 0x2174, "control_room_exit" },
    { 0x2175, "control_room_explosion" },
    { 0x2176, "control_room_foley_notetracks" },
    { 0x2177, "control_room_interior_vfx_on" },
    { 0x2178, "control_room_run" },
    { 0x2179, "control_room_run_approach" },
    { 0x217A, "control_room_run_joker" },
    { 0x217B, "control_room_run_player" },
    { 0x217C, "control_room_scene" },
    { 0x217D, "control_room_scene_actors" },
    { 0x217E, "control_room_scene_exit" },
    { 0x217F, "control_room_scene_player" },
    { 0x2180, "control_room_screens" },
    { 0x2181, "control_turret_after_delay" },
    { 0x2182, "controlcheck" },
    { 0x2183, "controllable_cloud_queen" },
    { 0x2184, "controllable_drone_activated" },
    { 0x2185, "controllable_drone_allowed_vols" },
    { 0x2186, "controllable_drone_hud" },
    { 0x2187, "controllable_drone_spawners" },
    { 0x2188, "controllable_drone_swarm_init" },
    { 0x2189, "controllable_drone_swarm_target" },
    { 0x218A, "controllable_drones" },
    { 0x218B, "controllable_fly_think" },
    { 0x218C, "controllable_hud_target_shader" },
    { 0x218D, "controlled_dog" },
    { 0x218E, "controlled_orbitalsupport_turret" },
    { 0x218F, "controller_rumble_heavy" },
    { 0x2190, "controller_rumble_heavy_long" },
    { 0x2191, "controller_rumble_heavy0" },
    { 0x2192, "controller_rumble_heavy1" },
    { 0x2193, "controller_rumble_heavy2" },
    { 0x2194, "controller_rumble_heavy3" },
    { 0x2195, "controller_rumble_light" },
    { 0x2196, "controller_rumble_light_long" },
    { 0x2197, "controller_rumble_light0" },
    { 0x2198, "controller_rumble_light1" },
    { 0x2199, "controller_rumble_light2" },
    { 0x219A, "controller_rumble_light3" },
    { 0x219B, "controlling_dog" },
    { 0x219C, "controllingorbitallaser" },
    { 0x219D, "controllingwarbird" },
    { 0x219E, "controlsfrozen" },
    { 0x219F, "conversation_index" },
    { 0x21A0, "conversation_response" },
    { 0x21A1, "conversation_start" },
    { 0x21A2, "conversation_stop" },
    { 0x21A3, "convert_8bit_color" },
    { 0x21A4, "convert_drones_near_player" },
    { 0x21A5, "convert_guy_to_drone" },
    { 0x21A6, "convert_to_time_string" },
    { 0x21A7, "convertfogtech" },
    { 0x21A8, "convertlegacyfog" },
    { 0x21A9, "convertmillisecondstodecisecondsandclamptoshort" },
    { 0x21AA, "convertoneshot" },
    { 0x21AB, "convertoneshotfx" },
    { 0x21AC, "converts" },
    { 0x21AD, "convoactive" },
    { 0x21AE, "convogate" },
    { 0x21AF, "convos" },
    { 0x21B0, "convoy_barrier" },
    { 0x21B1, "convoy_barrier_setup" },
    { 0x21B2, "convoy_crash_emitters" },
    { 0x21B3, "convoy_truck_explosion" },
    { 0x21B4, "convoydetonateambushinteract" },
    { 0x21B5, "cool_down_duration" },
    { 0x21B6, "cooldownstate" },
    { 0x21B7, "cooldowntime" },
    { 0x21B8, "cooldownwaittime" },
    { 0x21B9, "cooling_tower" },
    { 0x21BA, "cooling_tower_collapse" },
    { 0x21BB, "cooling_tower_collapse_visibility" },
    { 0x21BC, "coop_breached_from_same_door_in_a_muliti_door_room" },
    { 0x21BD, "coop_icon_blinkcrement" },
    { 0x21BE, "coop_icon_blinktime" },
    { 0x21BF, "coop_icon_color_blink" },
    { 0x21C0, "coop_icon_color_damage" },
    { 0x21C1, "coop_icon_color_downed" },
    { 0x21C2, "coop_icon_color_dying" },
    { 0x21C3, "coop_icon_color_normal" },
    { 0x21C4, "coop_icon_color_shoot" },
    { 0x21C5, "coop_icon_state" },
    { 0x21C6, "coop_player_in_special_ops_survival" },
    { 0x21C7, "coop_player_touching_valid_door_volume" },
    { 0x21C8, "coop_revive_nag_hud_refreshtime" },
    { 0x21C9, "coop_with_one_player_downed" },
    { 0x21CA, "coopkillstreaksplashnotify" },
    { 0x21CB, "cooplinker" },
    { 0x21CC, "coopoffensive" },
    { 0x21CD, "coopturret" },
    { 0x21CE, "cop_car_lights_on" },
    { 0x21CF, "cop_car_lights_on_barricade" },
    { 0x21D0, "copgroup" },
    { 0x21D1, "copier" },
    { 0x21D2, "copilot_intro" },
    { 0x21D3, "copy_angles_of_selected_ents" },
    { 0x21D4, "copy_animation_to_cloak_models" },
    { 0x21D5, "copy_animation_to_model" },
    { 0x21D6, "copy_attachments" },
    { 0x21D7, "copy_bar" },
    { 0x21D8, "copy_cat" },
    { 0x21D9, "copy_ents" },
    { 0x21DA, "copy_names" },
    { 0x21DB, "copy_script_model" },
    { 0x21DC, "copycatloadout" },
    { 0x21DD, "copystructarrayvalues" },
    { 0x21DE, "core_snipers_drone_spawners" },
    { 0x21DF, "coredamagetrig" },
    { 0x21E0, "coredeathtrig" },
    { 0x21E1, "coreshellshock" },
    { 0x21E2, "cormack" },
    { 0x21E3, "cormack_anim_rate_change" },
    { 0x21E4, "cormack_anim_scene_fob_meet" },
    { 0x21E5, "cormack_boost_jump" },
    { 0x21E6, "cormack_bridge_intro" },
    { 0x21E7, "cormack_dilate_pupils" },
    { 0x21E8, "cormack_dodge_drones" },
    { 0x21E9, "cormack_exfil_approach" },
    { 0x21EA, "cormack_firing_listener" },
    { 0x21EB, "cormack_flare" },
    { 0x21EC, "cormack_flare_notetrack_handler_flare" },
    { 0x21ED, "cormack_flare_notetrack_handler_ice" },
    { 0x21EE, "cormack_fov_end" },
    { 0x21EF, "cormack_fov_start" },
    { 0x21F0, "cormack_grapple_kill_rope" },
    { 0x21F1, "cormack_grapple_to_vtol" },
    { 0x21F2, "cormack_hall_handler" },
    { 0x21F3, "cormack_hand_on_ilana" },
    { 0x21F4, "cormack_helmet_close" },
    { 0x21F5, "cormack_helmet_open" },
    { 0x21F6, "cormack_ilana_cleanup" },
    { 0x21F7, "cormack_ilana_infil" },
    { 0x21F8, "cormack_intel_foley" },
    { 0x21F9, "cormack_intro" },
    { 0x21FA, "cormack_jetpack_switch" },
    { 0x21FB, "cormack_lake_callout_cargo" },
    { 0x21FC, "cormack_lake_callout_cover" },
    { 0x21FD, "cormack_lake_callout_coverme" },
    { 0x21FE, "cormack_lake_callout_downhere" },
    { 0x21FF, "cormack_lake_callout_goliath" },
    { 0x2200, "cormack_lake_callout_pin" },
    { 0x2201, "cormack_lake_callout_rpg" },
    { 0x2202, "cormack_lake_callout_stop" },
    { 0x2203, "cormack_landing_pad_combat" },
    { 0x2204, "cormack_light_handler" },
    { 0x2205, "cormack_missile" },
    { 0x2206, "cormack_missile_fx" },
    { 0x2207, "cormack_narrow_cave_search" },
    { 0x2208, "cormack_narrow_cave_start" },
    { 0x2209, "cormack_narrowcave_breach_grab_axe" },
    { 0x220A, "cormack_narrowcave_breach_ledge" },
    { 0x220B, "cormack_narrowcave_breach_surface" },
    { 0x220C, "cormack_narrowcave_breach_turn" },
    { 0x220D, "cormack_narrowcave_search_enter" },
    { 0x220E, "cormack_narrowcave_search_exit" },
    { 0x220F, "cormack_narrowcave_search_traverse_sec1" },
    { 0x2210, "cormack_outro" },
    { 0x2211, "cormack_perarts_jump_explosions" },
    { 0x2212, "cormack_pick" },
    { 0x2213, "cormack_pickup_stinger" },
    { 0x2214, "cormack_pod_exit_impact" },
    { 0x2215, "cormack_post_breach_move" },
    { 0x2216, "cormack_rappel" },
    { 0x2217, "cormack_reached" },
    { 0x2218, "cormack_server_room_se" },
    { 0x2219, "cormack_shoot_missile" },
    { 0x221A, "cormack_shoots_bridge_guy" },
    { 0x221B, "cormack_smash_monitor_01" },
    { 0x221C, "cormack_smash_monitor_02" },
    { 0x221D, "cormack_stealth_takedown_guard_sounds" },
    { 0x221E, "cormack_stealth_takedown_guy_waits" },
    { 0x221F, "cormack_stealth_takedown_rope_waits" },
    { 0x2220, "cormack_turkey_shoot" },
    { 0x2221, "cormack_wait" },
    { 0x2222, "corner_clearfacialanim" },
    { 0x2223, "corner_playaimfacialanim" },
    { 0x2224, "corner_playcornerfacialanim" },
    { 0x2225, "corner_think" },
    { 0x2226, "corneraiming" },
    { 0x2227, "cornerdeathreleasegrenade" },
    { 0x2228, "cornerdirection" },
    { 0x2229, "cornerline_height" },
    { 0x222A, "cornermode" },
    { 0x222B, "cornerreload" },
    { 0x222C, "cornerrightgrenadedeath" },
    { 0x222D, "corners" },
    { 0x222E, "cornersights" },
    { 0x222F, "corpse" },
    { 0x2230, "corpse_array" },
    { 0x2231, "corpse_array_time" },
    { 0x2232, "corpse_behavior_doesnt_require_player_sight" },
    { 0x2233, "corpse_cleanup" },
    { 0x2234, "corpse_entity" },
    { 0x2235, "corpse_height" },
    { 0x2236, "corpse_seen_by" },
    { 0x2237, "corpse_trigger_think" },
    { 0x2238, "cosine" },
    { 0x2239, "costume" },
    { 0x223A, "costume_changed" },
    { 0x223B, "costumecat2idx" },
    { 0x223C, "costumecategories" },
    { 0x223D, "costumelogged" },
    { 0x223E, "couldntseeenemypos" },
    { 0x223F, "count_bullet" },
    { 0x2240, "count_rocket" },
    { 0x2241, "count_swarm" },
    { 0x2242, "countdown_missile_launch" },
    { 0x2243, "counted" },
    { 0x2244, "counter" },
    { 0x2245, "countplayers" },
    { 0x2246, "countryid" },
    { 0x2247, "countryids" },
    { 0x2248, "courtyard" },
    { 0x2249, "courtyard_ally_mcd_safeguard" },
    { 0x224A, "courtyard_ally_mcd_safeguard_init" },
    { 0x224B, "courtyard_ambient_bullet_impact" },
    { 0x224C, "courtyard_ambient_bullet_impacts" },
    { 0x224D, "courtyard_ambient_explosions" },
    { 0x224E, "courtyard_burke_defend_squad" },
    { 0x224F, "courtyard_burke_enter_hangar_logic" },
    { 0x2250, "courtyard_burke_rally" },
    { 0x2251, "courtyard_cormack_enter_hangar_logic" },
    { 0x2252, "courtyard_defend_start" },
    { 0x2253, "courtyard_door_hack_complete_dialogue" },
    { 0x2254, "courtyard_door_hack_start_dialogue" },
    { 0x2255, "courtyard_doormen_enemy_think" },
    { 0x2256, "courtyard_end_jammer" },
    { 0x2257, "courtyard_enemy_initial_think" },
    { 0x2258, "courtyard_enemy_sniper_fodder_count" },
    { 0x2259, "courtyard_enemy_sniper_fodder_damage_function" },
    { 0x225A, "courtyard_enemy_sniper_fodder_think" },
    { 0x225B, "courtyard_enemy_sniper_fodder_track" },
    { 0x225C, "courtyard_enemy_think" },
    { 0x225D, "courtyard_entry_dialogue" },
    { 0x225E, "courtyard_gate_take_damage" },
    { 0x225F, "courtyard_gate_think" },
    { 0x2260, "courtyard_gates_think" },
    { 0x2261, "courtyard_glowing_ladders" },
    { 0x2262, "courtyard_goal_volume" },
    { 0x2263, "courtyard_goal_volume_trigger_b_think" },
    { 0x2264, "courtyard_goal_volume_trigger_think" },
    { 0x2265, "courtyard_hangar_door_close" },
    { 0x2266, "courtyard_hangar_door_close_rpg" },
    { 0x2267, "courtyard_hangar_door_hack" },
    { 0x2268, "courtyard_hangar_door_logic" },
    { 0x2269, "courtyard_hangar_door_open" },
    { 0x226A, "courtyard_hangar_mech_01_spawned" },
    { 0x226B, "courtyard_intro_magic_bullets" },
    { 0x226C, "courtyard_jammer" },
    { 0x226D, "courtyard_jammer_complete_dialogue" },
    { 0x226E, "courtyard_jammer_ladder_enemy_think" },
    { 0x226F, "courtyard_jammer_logic" },
    { 0x2270, "courtyard_jammer_plant_dof" },
    { 0x2271, "courtyard_jammer_plant_nag_dialogue" },
    { 0x2272, "courtyard_jammer_rumbles" },
    { 0x2273, "courtyard_jammer_scene" },
    { 0x2274, "courtyard_logic" },
    { 0x2275, "courtyard_mech_01" },
    { 0x2276, "courtyard_mech_02" },
    { 0x2277, "courtyard_mech_03" },
    { 0x2278, "courtyard_mech_04" },
    { 0x2279, "courtyard_mech_start_dialogue" },
    { 0x227A, "courtyard_mi17_spawn_01" },
    { 0x227B, "courtyard_mi17_spawn_02" },
    { 0x227C, "courtyard_mobile_cover_guys" },
    { 0x227D, "courtyard_rappel_preview" },
    { 0x227E, "courtyard_rappel_preview_guys" },
    { 0x227F, "courtyard_rappel_preview_think" },
    { 0x2280, "courtyard_rappel_preview_vehicles" },
    { 0x2281, "courtyard_rpg_drop" },
    { 0x2282, "courtyard_scrambler_rotate" },
    { 0x2283, "courtyard_scripted_props_staged_wakeup" },
    { 0x2284, "courtyard_scripted_props_think" },
    { 0x2285, "courtyard_squad_defend_nag_dialogue" },
    { 0x2286, "courtyard_start_dish" },
    { 0x2287, "courtyard_sun_off" },
    { 0x2288, "courtyard_traversal_hangar" },
    { 0x2289, "courtyard_traversal_initial" },
    { 0x228A, "courtyard_traversal_jammer" },
    { 0x228B, "courtyard_traversal_tank" },
    { 0x228C, "courtyard_vrap01" },
    { 0x228D, "courtyard_vrap02" },
    { 0x228E, "courtyard_vrap03" },
    { 0x228F, "courtyard_vrap04" },
    { 0x2290, "courtyard_vrap05" },
    { 0x2291, "courtyardguardcheckgatedialogue" },
    { 0x2292, "courtyardreminderdialogue" },
    { 0x2293, "courtyardspecialdetection" },
    { 0x2294, "cover_clearfacialanim" },
    { 0x2295, "cover_drone_disable" },
    { 0x2296, "cover_drone_disabled" },
    { 0x2297, "cover_drone_enable" },
    { 0x2298, "cover_drone_wheels" },
    { 0x2299, "cover_fire_missile_repulsor" },
    { 0x229A, "cover_nodes_first" },
    { 0x229B, "cover_nodes_last" },
    { 0x229C, "cover_playfacialanim" },
    { 0x229D, "cover_wall_think" },
    { 0x229E, "cover_warnings_disabled" },
    { 0x229F, "coverapproachlastminutecheck" },
    { 0x22A0, "covercrouch" },
    { 0x22A1, "covercrouchfail" },
    { 0x22A2, "covercrouchgrenade" },
    { 0x22A3, "covercrouchlean_aimmode" },
    { 0x22A4, "covercrouchleanpitch" },
    { 0x22A5, "coverenterpos" },
    { 0x22A6, "coverexit" },
    { 0x22A7, "coverexitangles" },
    { 0x22A8, "coverexitdist" },
    { 0x22A9, "coverexitpos" },
    { 0x22AA, "coverexitpostdist" },
    { 0x22AB, "coverleft45" },
    { 0x22AC, "coverleft90" },
    { 0x22AD, "coverleftgrenade" },
    { 0x22AE, "covermode" },
    { 0x22AF, "covermulti_choosehidestate" },
    { 0x22B0, "covermulti_dotransition" },
    { 0x22B1, "covermulti_enterstate" },
    { 0x22B2, "covermulti_exitstate" },
    { 0x22B3, "covermulti_getanimtransition" },
    { 0x22B4, "covermulti_getbestvaliddir" },
    { 0x22B5, "covermulti_getnonrandomvaliddir" },
    { 0x22B6, "covermulti_getrandomvaliddir" },
    { 0x22B7, "covermulti_getstatefromdir" },
    { 0x22B8, "covermulti_isvaliddir" },
    { 0x22B9, "covermulti_setdir" },
    { 0x22BA, "covermulti_setstate" },
    { 0x22BB, "covermulti_setstateinternal" },
    { 0x22BC, "covermulti_think" },
    { 0x22BD, "covernode" },
    { 0x22BE, "coverpoint" },
    { 0x22BF, "coverposestablishedtime" },
    { 0x22C0, "coverprint" },
    { 0x22C1, "coverreload" },
    { 0x22C2, "coverright45" },
    { 0x22C3, "coverright90" },
    { 0x22C4, "coverrightgrenade" },
    { 0x22C5, "coversetupanim" },
    { 0x22C6, "coverstand" },
    { 0x22C7, "coverstandfail" },
    { 0x22C8, "coverstandgrenade" },
    { 0x22C9, "covertest" },
    { 0x22CA, "covertrans" },
    { 0x22CB, "covertransangles" },
    { 0x22CC, "covertransdist" },
    { 0x22CD, "covertranspredist" },
    { 0x22CE, "covertype" },
    { 0x22CF, "cower_cleanup_civs_on_goal" },
    { 0x22D0, "cpm" },
    { 0x22D1, "cpu_transmission" },
    { 0x22D2, "cqb_aim" },
    { 0x22D3, "cqb_clearfacialanim" },
    { 0x22D4, "cqb_dof_off" },
    { 0x22D5, "cqb_dof_on" },
    { 0x22D6, "cqb_investigate_behavior" },
    { 0x22D7, "cqb_mode" },
    { 0x22D8, "cqb_playfacialanim" },
    { 0x22D9, "cqb_point_of_interest" },
    { 0x22DA, "cqb_reloadinternal" },
    { 0x22DB, "cqb_target" },
    { 0x22DC, "cqb_test" },
    { 0x22DD, "cqb_walk" },
    { 0x22DE, "cqb_wide_poi_track" },
    { 0x22DF, "cqb_wide_target_track" },
    { 0x22E0, "cqbenabled" },
    { 0x22E1, "cqbpointsofinterest" },
    { 0x22E2, "cqbtracking" },
    { 0x22E3, "cqbwalking" },
    { 0x22E4, "cracked_floor_function" },
    { 0x22E5, "cracked_windshield_swap" },
    { 0x22E6, "crane_animated_down" },
    { 0x22E7, "crane_animated_up" },
    { 0x22E8, "crane_cable" },
    { 0x22E9, "crane_cable_down" },
    { 0x22EA, "crane_cable_up" },
    { 0x22EB, "crane_check_for_stop_command" },
    { 0x22EC, "crane_claw_crate_grab" },
    { 0x22ED, "crane_claw_crate_release" },
    { 0x22EE, "crane_claw_drop_start" },
    { 0x22EF, "crane_claw_drop_stop" },
    { 0x22F0, "crane_claw_mvmnt_start" },
    { 0x22F1, "crane_claw_mvmnt_stop" },
    { 0x22F2, "crane_claw_rise_start" },
    { 0x22F3, "crane_claw_rise_stop" },
    { 0x22F4, "crane_force_stop_command" },
    { 0x22F5, "crane_mach_mvmnt_start" },
    { 0x22F6, "crane_mach_mvmnt_stop" },
    { 0x22F7, "cranechemcollision" },
    { 0x22F8, "cranechemcollisiontotal" },
    { 0x22F9, "cranecollision" },
    { 0x22FA, "cranecollisiontotal" },
    { 0x22FB, "cranes" },
    { 0x22FC, "cranesparks" },
    { 0x22FD, "cranethink" },
    { 0x22FE, "crash" },
    { 0x22FF, "crash_blackout" },
    { 0x2300, "crash_derailed_check" },
    { 0x2301, "crash_detour_check" },
    { 0x2302, "crash_dof_presets" },
    { 0x2303, "crash_event" },
    { 0x2304, "crash_fire_light" },
    { 0x2305, "crash_gideon_rescue_cormack" },
    { 0x2306, "crash_gideon_rescue_gideon" },
    { 0x2307, "crash_gideon_rescue_ilona" },
    { 0x2308, "crash_gideon_rescue2_cormack" },
    { 0x2309, "crash_gideon_rescue2_gideon" },
    { 0x230A, "crash_gideon_rescue2_ilona" },
    { 0x230B, "crash_introscreen" },
    { 0x230C, "crash_is_fatal" },
    { 0x230D, "crash_lighting_crash_site" },
    { 0x230E, "crash_lighting_crash_site_dof" },
    { 0x230F, "crash_lighting_drone_hall" },
    { 0x2310, "crash_lighting_engine_lighting" },
    { 0x2311, "crash_lighting_entry" },
    { 0x2312, "crash_lighting_entry_dof" },
    { 0x2313, "crash_lighting_entry_dof_scripted" },
    { 0x2314, "crash_lighting_goliath_dof" },
    { 0x2315, "crash_lighting_ice_caves_01" },
    { 0x2316, "crash_lighting_ice_caves_01_flare" },
    { 0x2317, "crash_lighting_ice_caves_02" },
    { 0x2318, "crash_lighting_lake_cinema" },
    { 0x2319, "crash_lighting_overlook" },
    { 0x231A, "crash_lighting_plane_fire" },
    { 0x231B, "crash_lighting_post_goliath_fall" },
    { 0x231C, "crash_lighting_skyjack_setup" },
    { 0x231D, "crash_lighting_underground_lake" },
    { 0x231E, "crash_logic" },
    { 0x231F, "crash_mechs" },
    { 0x2320, "crash_node" },
    { 0x2321, "crash_open_gate" },
    { 0x2322, "crash_open_left_gate" },
    { 0x2323, "crash_open_right_gate" },
    { 0x2324, "crash_overlay" },
    { 0x2325, "crash_overlook_sunflare" },
    { 0x2326, "crash_overlook_trigger" },
    { 0x2327, "crash_overlook_trigger_sunflare" },
    { 0x2328, "crash_path_check" },
    { 0x2329, "crash_plane_crash_ilona" },
    { 0x232A, "crash_precache" },
    { 0x232B, "crash_rumble" },
    { 0x232C, "crash_set_level_lighting_values" },
    { 0x232D, "crash_site_a10_gun_dive_1" },
    { 0x232E, "crash_site_a10_missile_dive_1" },
    { 0x232F, "crash_site_ally_drones" },
    { 0x2330, "crash_site_animnode" },
    { 0x2331, "crash_site_background_enemies" },
    { 0x2332, "crash_site_battle_chatter_chooser" },
    { 0x2333, "crash_site_battle_chatter_manager" },
    { 0x2334, "crash_site_battle_chatter_north" },
    { 0x2335, "crash_site_battle_chatter_south" },
    { 0x2336, "crash_site_bg_battle_chatter_north" },
    { 0x2337, "crash_site_bg_battle_chatter_south" },
    { 0x2338, "crash_site_bg_warbird_1" },
    { 0x2339, "crash_site_bg_warbird_2" },
    { 0x233A, "crash_site_bg_warbird_3" },
    { 0x233B, "crash_site_bg_warbirds" },
    { 0x233C, "crash_site_bunker_allies" },
    { 0x233D, "crash_site_bunker_sentinels" },
    { 0x233E, "crash_site_chutes" },
    { 0x233F, "crash_site_combat_manager" },
    { 0x2340, "crash_site_cormack" },
    { 0x2341, "crash_site_dead_razorback_guys" },
    { 0x2342, "crash_site_dialogue" },
    { 0x2343, "crash_site_drone" },
    { 0x2344, "crash_site_drones" },
    { 0x2345, "crash_site_drop_pod_enemies" },
    { 0x2346, "crash_site_drop_pod_manager" },
    { 0x2347, "crash_site_ilana" },
    { 0x2348, "crash_site_intro_killer" },
    { 0x2349, "crash_site_intro_killer2" },
    { 0x234A, "crash_site_jump_node_usage_scale" },
    { 0x234B, "crash_site_kill_counter" },
    { 0x234C, "crash_site_plane" },
    { 0x234D, "crash_site_plane_allies" },
    { 0x234E, "crash_site_player" },
    { 0x234F, "crash_site_player_gun" },
    { 0x2350, "crash_site_random_bg_explosion" },
    { 0x2351, "crash_site_random_playspace_explosion" },
    { 0x2352, "crash_site_razorback_allies" },
    { 0x2353, "crash_site_runway" },
    { 0x2354, "crash_speed" },
    { 0x2355, "crash_speed_ips" },
    { 0x2356, "crash_speed_mph" },
    { 0x2357, "crash_squad_take_cover" },
    { 0x2358, "crash_starts" },
    { 0x2359, "crash_struct" },
    { 0x235A, "crash_time" },
    { 0x235B, "crash_wakeup" },
    { 0x235C, "crashed" },
    { 0x235D, "crashed_pod_rotation" },
    { 0x235E, "crashedc17_missile_org" },
    { 0x235F, "crashfx" },
    { 0x2360, "crashing" },
    { 0x2361, "crashing_plane" },
    { 0x2362, "crashplane" },
    { 0x2363, "crashpos" },
    { 0x2364, "crate" },
    { 0x2365, "crate_calculate_on_path_grid" },
    { 0x2366, "crate_can_use" },
    { 0x2367, "crate_can_use_always" },
    { 0x2368, "crate_count" },
    { 0x2369, "crate_get_bot_target" },
    { 0x236A, "crate_get_nearest_valid_nodes" },
    { 0x236B, "crate_has_landed" },
    { 0x236C, "crate_in_range" },
    { 0x236D, "crate_is_on_path_grid" },
    { 0x236E, "crate_landed_and_on_path_grid" },
    { 0x236F, "crate_low_ammo_check" },
    { 0x2370, "crate_monitor_position" },
    { 0x2371, "crate_move_start" },
    { 0x2372, "crate_path_start" },
    { 0x2373, "crate_picked_up" },
    { 0x2374, "crate_should_claim" },
    { 0x2375, "crate_wait_use" },
    { 0x2376, "crateallcapturethinkhorde" },
    { 0x2377, "cratedetectstopphysics" },
    { 0x2378, "cratehandledamagecallback" },
    { 0x2379, "crateimpactcleanup" },
    { 0x237A, "cratemaxval" },
    { 0x237B, "cratemodelplayerupdater" },
    { 0x237C, "cratemodelteamupdater" },
    { 0x237D, "cratenonownerusetime" },
    { 0x237E, "crateothercapturethink" },
    { 0x237F, "crateownercapturethink" },
    { 0x2380, "crateownerdoubletapthink" },
    { 0x2381, "crateownerusetime" },
    { 0x2382, "cratesetupforuse" },
    { 0x2383, "cratesetuphintstrings" },
    { 0x2384, "crateteammodelupdater" },
    { 0x2385, "cratetrapsetupkillcam" },
    { 0x2386, "cratetype" },
    { 0x2387, "cratetypeisexcluded" },
    { 0x2388, "cratetypes" },
    { 0x2389, "crateusejuggernautupdater" },
    { 0x238A, "crateusepostjuggernautupdater" },
    { 0x238B, "crateuseteamupdater" },
    { 0x238C, "crawl_fx" },
    { 0x238D, "crawl_fx_rate" },
    { 0x238E, "crawl_target_and_init_flags" },
    { 0x238F, "crawl_through_targets_to_init_flags" },
    { 0x2390, "crawled" },
    { 0x2391, "crawlingpain" },
    { 0x2392, "crawlingpainanimoverridefunc" },
    { 0x2393, "crawlingpaintransanim" },
    { 0x2394, "crawlingpistol" },
    { 0x2395, "crch_exp_npc_cloak_buttons" },
    { 0x2396, "crch_lft_npc_cloak_buttons" },
    { 0x2397, "crch_rt_npc_cloak_buttons" },
    { 0x2398, "creaky_board" },
    { 0x2399, "create_active_zone" },
    { 0x239A, "create_ads_hint_string" },
    { 0x239B, "create_anim_ent_for_my_position" },
    { 0x239C, "create_anim_scene" },
    { 0x239D, "create_animation_list" },
    { 0x239E, "create_array_of_intel_items" },
    { 0x239F, "create_array_of_origins_from_table" },
    { 0x23A0, "create_badplace" },
    { 0x23A1, "create_black_screen" },
    { 0x23A2, "create_blend" },
    { 0x23A3, "create_bot_badplaces" },
    { 0x23A4, "create_chyron_text" },
    { 0x23A5, "create_client_overlay" },
    { 0x23A6, "create_client_overlay_custom_size" },
    { 0x23A7, "create_client_overlay_fullscreen" },
    { 0x23A8, "create_clientside_water_ents" },
    { 0x23A9, "create_common_envelop_arrays" },
    { 0x23AA, "create_confrontation_static_overlay" },
    { 0x23AB, "create_conversation_arrays" },
    { 0x23AC, "create_debug_text_hud" },
    { 0x23AD, "create_default_vision_set_fog" },
    { 0x23AE, "create_dof_preset" },
    { 0x23AF, "create_dof_viewmodel_preset" },
    { 0x23B0, "create_drone_kamikazes" },
    { 0x23B1, "create_dvar" },
    { 0x23B2, "create_dynamicambience" },
    { 0x23B3, "create_exo_temperature_hud" },
    { 0x23B4, "create_exploders_fromlist" },
    { 0x23B5, "create_flags_and_return_tokens" },
    { 0x23B6, "create_flickerlight_motion_preset" },
    { 0x23B7, "create_flickerlight_preset" },
    { 0x23B8, "create_foam_matrix" },
    { 0x23B9, "create_fog" },
    { 0x23BA, "create_fresh_friendly_icon" },
    { 0x23BB, "create_fx_ent_setup" },
    { 0x23BC, "create_fx_menu" },
    { 0x23BD, "create_fxlighting_object" },
    { 0x23BE, "create_gamemessage_text" },
    { 0x23BF, "create_hud_drone_overlay" },
    { 0x23C0, "create_hud_drone_target" },
    { 0x23C1, "create_hud_laser_crosshair" },
    { 0x23C2, "create_hud_nvg_overlay" },
    { 0x23C3, "create_hud_sonar_overlay" },
    { 0x23C4, "create_hud_static_overlay" },
    { 0x23C5, "create_hud_threat_overlay" },
    { 0x23C6, "create_interval_sound" },
    { 0x23C7, "create_level_envelop_arrays" },
    { 0x23C8, "create_level_misc_arrays" },
    { 0x23C9, "create_light_object" },
    { 0x23CA, "create_light_set" },
    { 0x23CB, "create_lock" },
    { 0x23CC, "create_looper" },
    { 0x23CD, "create_loopsound" },
    { 0x23CE, "create_mantle" },
    { 0x23CF, "create_mg_team" },
    { 0x23D0, "create_missileattractor_on_player_chopper" },
    { 0x23D1, "create_new_spawner_pool" },
    { 0x23D2, "create_nvg_overlay" },
    { 0x23D3, "create_overlay_element" },
    { 0x23D4, "create_path" },
    { 0x23D5, "create_pivot" },
    { 0x23D6, "create_pulselight_preset" },
    { 0x23D7, "create_pulsing_text" },
    { 0x23D8, "create_random_animation" },
    { 0x23D9, "create_reflection_object" },
    { 0x23DA, "create_reflection_objects" },
    { 0x23DB, "create_slowmo_breaches_from_entities" },
    { 0x23DC, "create_start" },
    { 0x23DD, "create_strip" },
    { 0x23DE, "create_sunflare_setting" },
    { 0x23DF, "create_trigger_hint_string" },
    { 0x23E0, "create_triggerfx" },
    { 0x23E1, "create_vehicle_from_spawngroup_and_gopath" },
    { 0x23E2, "create_vision_set_fog" },
    { 0x23E3, "create_vision_set_vision" },
    { 0x23E4, "create_warning_elem" },
    { 0x23E5, "createairdropcrate" },
    { 0x23E6, "createart_transient_thread" },
    { 0x23E7, "createassaultuav" },
    { 0x23E8, "createbar" },
    { 0x23E9, "createbombsquadmodel" },
    { 0x23EA, "createcapzone" },
    { 0x23EB, "createcarriedobject" },
    { 0x23EC, "createcarryobject" },
    { 0x23ED, "createchatevent" },
    { 0x23EE, "createchatphrase" },
    { 0x23EF, "createclientbar" },
    { 0x23F0, "createclientfontstring" },
    { 0x23F1, "createclientfontstring_func" },
    { 0x23F2, "createclienticon" },
    { 0x23F3, "createclientprogressbar" },
    { 0x23F4, "createclienttimer" },
    { 0x23F5, "createcollision" },
    { 0x23F6, "createdefaultbobsettings" },
    { 0x23F7, "createdefaultsmallbobsettings" },
    { 0x23F8, "createdogenemy" },
    { 0x23F9, "createdot" },
    { 0x23FA, "createdot_radius" },
    { 0x23FB, "createdroneenemy" },
    { 0x23FC, "createdynamicambience" },
    { 0x23FD, "createechoalias" },
    { 0x23FE, "createeffect" },
    { 0x23FF, "createempclientbar" },
    { 0x2400, "createenemy" },
    { 0x2401, "createexploder" },
    { 0x2402, "createexploderex" },
    { 0x2403, "createexplosivedrone" },
    { 0x2404, "createfontstring" },
    { 0x2405, "createfx" },
    { 0x2406, "createfx_adjust_array" },
    { 0x2407, "createfx_autosave" },
    { 0x2408, "createfx_centerprint" },
    { 0x2409, "createfx_centerprint_thread" },
    { 0x240A, "createfx_common" },
    { 0x240B, "createfx_draw_enabled" },
    { 0x240C, "createfx_enabled" },
    { 0x240D, "createfx_filter_types" },
    { 0x240E, "createfx_help_active" },
    { 0x240F, "createfx_help_keys" },
    { 0x2410, "createfx_inputlocked" },
    { 0x2411, "createfx_last_movement_timer" },
    { 0x2412, "createfx_loopcounter" },
    { 0x2413, "createfx_menu_list_active" },
    { 0x2414, "createfx_offset" },
    { 0x2415, "createfx_only_triggers" },
    { 0x2416, "createfx_print3d" },
    { 0x2417, "createfx_selecting" },
    { 0x2418, "createfxbyfxid" },
    { 0x2419, "createfxcursor" },
    { 0x241A, "createfxent" },
    { 0x241B, "createfxent_redo" },
    { 0x241C, "createfxent_undo" },
    { 0x241D, "createfxexploders" },
    { 0x241E, "createfxlogic" },
    { 0x241F, "createfxmasks" },
    { 0x2420, "creategastrackingoverlay" },
    { 0x2421, "createhordecrates" },
    { 0x2422, "createhumanoidenemy" },
    { 0x2423, "createicon" },
    { 0x2424, "createicon_hudelem" },
    { 0x2425, "createintervalsound" },
    { 0x2426, "createjuggernautoverlay" },
    { 0x2427, "createkillcamentity" },
    { 0x2428, "createlasertagarray" },
    { 0x2429, "createline" },
    { 0x242A, "createlineconstantly" },
    { 0x242B, "createloopeffect" },
    { 0x242C, "createloopsound" },
    { 0x242D, "createmissileoverlay" },
    { 0x242E, "createmission" },
    { 0x242F, "createmovingbadplace" },
    { 0x2430, "createnewexploder" },
    { 0x2431, "createoneshoteffect" },
    { 0x2432, "createorbitaltimer" },
    { 0x2433, "createoverlay" },
    { 0x2434, "createplaceable" },
    { 0x2435, "createplayerdroppod" },
    { 0x2436, "createplayersegmentstats" },
    { 0x2437, "createplayervariables" },
    { 0x2438, "createprimaryprogressbar" },
    { 0x2439, "createprimaryprogressbartext" },
    { 0x243A, "createprisonturrettrackingoverlay" },
    { 0x243B, "createreactiveent" },
    { 0x243C, "createreconuav" },
    { 0x243D, "createrpgrepulsors" },
    { 0x243E, "createsentryforplayer" },
    { 0x243F, "createserverbar" },
    { 0x2440, "createserverfontstring" },
    { 0x2441, "createservericon" },
    { 0x2442, "createservertimer" },
    { 0x2443, "createsniperimpulse" },
    { 0x2444, "createsquad" },
    { 0x2445, "createteamflag" },
    { 0x2446, "createteamobjpoint" },
    { 0x2447, "createteamprogressbar" },
    { 0x2448, "createteamprogressbartext" },
    { 0x2449, "createthreaticon" },
    { 0x244A, "createtimer" },
    { 0x244B, "createtrackingdrone" },
    { 0x244C, "createturret" },
    { 0x244D, "createturretforplayer" },
    { 0x244E, "createuseent" },
    { 0x244F, "createuseobject" },
    { 0x2450, "credits_active" },
    { 0x2451, "credits_alpha" },
    { 0x2452, "credits_data1" },
    { 0x2453, "credits_data2" },
    { 0x2454, "credits_display_think" },
    { 0x2455, "credits_end" },
    { 0x2456, "credits_spacing" },
    { 0x2457, "credits_speed" },
    { 0x2458, "credits_start" },
    { 0x2459, "crevasse_area_2_special" },
    { 0x245A, "crevasse_combat_wave_1" },
    { 0x245B, "crevasse_impact_ground" },
    { 0x245C, "crevasse_impact_wall" },
    { 0x245D, "crevasse_initial_group" },
    { 0x245E, "crevasse_ledge_adjustment" },
    { 0x245F, "crevasse_player_fall_down" },
    { 0x2460, "crevasse_player_get_up" },
    { 0x2461, "crevasse_player_impact_ground" },
    { 0x2462, "crevasse_player_impact_ground_throttled" },
    { 0x2463, "crevasse_player_impact_wall" },
    { 0x2464, "crevasse_player_slide_end" },
    { 0x2465, "crevasse_player_slide_hands" },
    { 0x2466, "crevasse_slide_end" },
    { 0x2467, "crevasse_slide_hands" },
    { 0x2468, "crevasse_upper" },
    { 0x2469, "crevasse_upper_cancelled" },
    { 0x246A, "crevasse_wave_1_cleaup" },
    { 0x246B, "crevasse_wave_1_drop" },
    { 0x246C, "crevasse_wave_1_left" },
    { 0x246D, "crevasse_wave_1_left_special" },
    { 0x246E, "crevasse_wave_1_mid" },
    { 0x246F, "crevasse_wave_1_right" },
    { 0x2470, "crevasse_wave_2" },
    { 0x2471, "crevasse_wave_3" },
    { 0x2472, "crib_debug" },
    { 0x2473, "critical_factor" },
    { 0x2474, "criticalfactors_awayfromenemies" },
    { 0x2475, "criticalfactors_domination" },
    { 0x2476, "criticalfactors_freeforall" },
    { 0x2477, "criticalfactors_global" },
    { 0x2478, "criticalfactors_safeguard" },
    { 0x2479, "criticalfactors_searchandrescue" },
    { 0x247A, "criticalresult" },
    { 0x247B, "cross2d" },
    { 0x247C, "crossbowstickevent" },
    { 0x247D, "crossing_into_alley" },
    { 0x247E, "crossproduct" },
    { 0x247F, "crouch_button_reset" },
    { 0x2480, "crouch_speed_scalar" },
    { 0x2481, "crouch_until_door_open" },
    { 0x2482, "crouch_until_path_to_door" },
    { 0x2483, "crouch_visible_from" },
    { 0x2484, "crouch_watcher" },
    { 0x2485, "crouchingisok" },
    { 0x2486, "crouchmovementsetspeed" },
    { 0x2487, "crouchrun_begin" },
    { 0x2488, "crouchrun_combatanim" },
    { 0x2489, "crouchrun_runnormal" },
    { 0x248A, "crouchrun_runoverride" },
    { 0x248B, "crouchruntocrouch" },
    { 0x248C, "crouchruntoprone" },
    { 0x248D, "crouchruntopronerun" },
    { 0x248E, "crouchruntopronewalk" },
    { 0x248F, "crouchruntostand" },
    { 0x2490, "crouchstatelistener" },
    { 0x2491, "crouchstop_begin" },
    { 0x2492, "crouchtocrouchrun" },
    { 0x2493, "crouchtocrouchwalk" },
    { 0x2494, "crouchtoprone" },
    { 0x2495, "crouchtopronerun" },
    { 0x2496, "crouchtopronewalk" },
    { 0x2497, "crouchtostand" },
    { 0x2498, "crouchtostandrun" },
    { 0x2499, "crouchtostandwalk" },
    { 0x249A, "crouchwalk_begin" },
    { 0x249B, "crouchwalktocrouch" },
    { 0x249C, "crouchwalktostand" },
    { 0x249D, "crumble_hoodoo_fx" },
    { 0x249E, "crvplrhitground" },
    { 0x249F, "cs_intro_bg_plane_breach" },
    { 0x24A0, "cs_intro_cormack_jetpack_off" },
    { 0x24A1, "cs_intro_cormack_land" },
    { 0x24A2, "cs_intro_cormack_ready_gun" },
    { 0x24A3, "cs_intro_cormack_remove_jetpack" },
    { 0x24A4, "cs_intro_ilona_hand_over_gun" },
    { 0x24A5, "cs_intro_plane_jumper_boost" },
    { 0x24A6, "cs_intro_plane_jumper_drop_to_ground" },
    { 0x24A7, "cs_intro_plane_jumper_land" },
    { 0x24A8, "cs_intro_player_remove_jetpack" },
    { 0x24A9, "csv_include" },
    { 0x24AA, "csv_lines" },
    { 0x24AB, "ct_enemies" },
    { 0x24AC, "ct_enemies_final_runaway_faceplayer" },
    { 0x24AD, "ct_enemies_runaway_faceplayer" },
    { 0x24AE, "ctf" },
    { 0x24AF, "ctf_bot_attacker_limit_for_team" },
    { 0x24B0, "ctf_bot_defender_limit_for_team" },
    { 0x24B1, "ctf_loadouts" },
    { 0x24B2, "ctf_second_zones" },
    { 0x24B3, "cuc_rotation_offset" },
    { 0x24B4, "cuc_scale" },
    { 0x24B5, "cuc_translation" },
    { 0x24B6, "cue_cash" },
    { 0x24B7, "cuff" },
    { 0x24B8, "cull_distance_triggers" },
    { 0x24B9, "cull_spawners_from_killspawner" },
    { 0x24BA, "cull_spawners_leaving_one_set" },
    { 0x24BB, "cur" },
    { 0x24BC, "cur_camoffset_ratio" },
    { 0x24BD, "cur_defend_angle_override" },
    { 0x24BE, "cur_defend_node" },
    { 0x24BF, "cur_defend_point_override" },
    { 0x24C0, "cur_defend_stance" },
    { 0x24C1, "cur_local_angles" },
    { 0x24C2, "cur_node" },
    { 0x24C3, "cur_point" },
    { 0x24C4, "cur_tank_target" },
    { 0x24C5, "curautosave" },
    { 0x24C6, "curclass" },
    { 0x24C7, "curdefvalue" },
    { 0x24C8, "curevent" },
    { 0x24C9, "curmeleetarget" },
    { 0x24CA, "curobjid" },
    { 0x24CB, "curorigin" },
    { 0x24CC, "curprogress" },
    { 0x24CD, "curr" },
    { 0x24CE, "curr_ambi_submix" },
    { 0x24CF, "curr_cue_name" },
    { 0x24D0, "curr_dist" },
    { 0x24D1, "curr_intensity" },
    { 0x24D2, "curr_io" },
    { 0x24D3, "curr_music_submix" },
    { 0x24D4, "curr_preset" },
    { 0x24D5, "curr_state" },
    { 0x24D6, "curr_time" },
    { 0x24D7, "current_aim_offset" },
    { 0x24D8, "current_air_space" },
    { 0x24D9, "current_anim" },
    { 0x24DA, "current_anim_data_scene" },
    { 0x24DB, "current_anim_vm" },
    { 0x24DC, "current_betrayal_boat_vision_fog" },
    { 0x24DD, "current_cam_target" },
    { 0x24DE, "current_cinematic" },
    { 0x24DF, "current_color_order" },
    { 0x24E0, "current_dir" },
    { 0x24E1, "current_elevation" },
    { 0x24E2, "current_enemy" },
    { 0x24E3, "current_ent" },
    { 0x24E4, "current_event" },
    { 0x24E5, "current_exo_guys_alive" },
    { 0x24E6, "current_fallbackers" },
    { 0x24E7, "current_filters" },
    { 0x24E8, "current_flag" },
    { 0x24E9, "current_follow_path" },
    { 0x24EA, "current_fov" },
    { 0x24EB, "current_gen_hangar_door_open" },
    { 0x24EC, "current_global_hint" },
    { 0x24ED, "current_goal_offset" },
    { 0x24EE, "current_goal_position" },
    { 0x24EF, "current_hint" },
    { 0x24F0, "current_hit_count" },
    { 0x24F1, "current_landing_fx" },
    { 0x24F2, "current_median_speed" },
    { 0x24F3, "current_mode_hud" },
    { 0x24F4, "current_objective" },
    { 0x24F5, "current_occlusion" },
    { 0x24F6, "current_pitch" },
    { 0x24F7, "current_point_was_authored" },
    { 0x24F8, "current_pos" },
    { 0x24F9, "current_preset_name" },
    { 0x24FA, "current_projectile" },
    { 0x24FB, "current_reverb" },
    { 0x24FC, "current_speed" },
    { 0x24FD, "current_stance_func" },
    { 0x24FE, "current_start" },
    { 0x24FF, "current_sunflare_setting" },
    { 0x2500, "current_target" },
    { 0x2501, "current_target_aim_begin_time_ms" },
    { 0x2502, "current_traverse_anime" },
    { 0x2503, "current_turret_target" },
    { 0x2504, "current_velocity" },
    { 0x2505, "current_vo" },
    { 0x2506, "current_warbird_weapon" },
    { 0x2507, "current_weapon" },
    { 0x2508, "current_wheel_pos" },
    { 0x2509, "current_yaw" },
    { 0x250A, "current_zone" },
    { 0x250B, "currentactivevehiclecount" },
    { 0x250C, "currentaliveenemycount" },
    { 0x250D, "currentammopickupcount" },
    { 0x250E, "currentcaralarms" },
    { 0x250F, "currentcolorcode" },
    { 0x2510, "currentcolorforced" },
    { 0x2511, "currentcovernode" },
    { 0x2512, "currentdefendloc" },
    { 0x2513, "currentdialogimportance" },
    { 0x2514, "currentdialognotifystring" },
    { 0x2515, "currentdialogsound" },
    { 0x2516, "currentdodgeanim" },
    { 0x2517, "currentenemycount" },
    { 0x2518, "currentfirefightshots" },
    { 0x2519, "currenthealth" },
    { 0x251A, "currentkillstreakindex" },
    { 0x251B, "currentkillstreaks" },
    { 0x251C, "currentleaderdialoggroup" },
    { 0x251D, "currently_anim_reaching" },
    { 0x251E, "currently_burst_firing" },
    { 0x251F, "currently_handling_player_damage" },
    { 0x2520, "currentnode" },
    { 0x2521, "currentpickupcount" },
    { 0x2522, "currentpointtotal" },
    { 0x2523, "currentroundnumber" },
    { 0x2524, "currentscore" },
    { 0x2525, "currentselectedclass" },
    { 0x2526, "currentsessiontime" },
    { 0x2527, "currentshotguncovernode" },
    { 0x2528, "currentstate" },
    { 0x2529, "currenttarget" },
    { 0x252A, "currentteamintelname" },
    { 0x252B, "currenttime" },
    { 0x252C, "currenttracecount" },
    { 0x252D, "currenttrackingyaw" },
    { 0x252E, "currenttrackingyawspeed" },
    { 0x252F, "currentvelocity" },
    { 0x2530, "currentweapon" },
    { 0x2531, "currentweaponatspawn" },
    { 0x2532, "custom_aim_animscript" },
    { 0x2533, "custom_aim_notetracks" },
    { 0x2534, "custom_anim_wait" },
    { 0x2535, "custom_animation" },
    { 0x2536, "custom_animscript" },
    { 0x2537, "custom_battlechatter" },
    { 0x2538, "custom_battlechatter_init_valid_phrases" },
    { 0x2539, "custom_battlechatter_internal" },
    { 0x253A, "custom_battlechatter_validate_phrase" },
    { 0x253B, "custom_callback" },
    { 0x253C, "custom_careful_radius" },
    { 0x253D, "custom_crawl_sound" },
    { 0x253E, "custom_crawling_death_array" },
    { 0x253F, "custom_death_script" },
    { 0x2540, "custom_deathsound" },
    { 0x2541, "custom_dismount_hint_return_when_dismounted" },
    { 0x2542, "custom_distance_along_path_think" },
    { 0x2543, "custom_dof_trace" },
    { 0x2544, "custom_dust_kickup" },
    { 0x2545, "custom_followpath_parameter_func" },
    { 0x2546, "custom_friendly_fire_message" },
    { 0x2547, "custom_friendly_fire_shader" },
    { 0x2548, "custom_gameskill_func" },
    { 0x2549, "custom_giveloadout" },
    { 0x254A, "custom_health_think" },
    { 0x254B, "custom_idle_trans_function" },
    { 0x254C, "custom_landing" },
    { 0x254D, "custom_laser_function" },
    { 0x254E, "custom_linkto_slide" },
    { 0x254F, "custom_no_game_setupfunc" },
    { 0x2550, "custom_player_attacker" },
    { 0x2551, "custom_radius_damage_for_exploders" },
    { 0x2552, "custom_regen_think" },
    { 0x2553, "customangles" },
    { 0x2554, "customanim" },
    { 0x2555, "customarrivalfunc" },
    { 0x2556, "customautosavecheck" },
    { 0x2557, "custombadplacethread" },
    { 0x2558, "custombcs_validphrases" },
    { 0x2559, "custombreathingtime" },
    { 0x255A, "customchatevent" },
    { 0x255B, "customchatphrase" },
    { 0x255C, "customclasspickcount" },
    { 0x255D, "customcratefunc" },
    { 0x255E, "customfunc" },
    { 0x255F, "customhealth" },
    { 0x2560, "customidleanimset" },
    { 0x2561, "customidleanimweights" },
    { 0x2562, "customidlesound" },
    { 0x2563, "customidletransitionfunc" },
    { 0x2564, "customkillstreakcratemodules" },
    { 0x2565, "custommaxhealth" },
    { 0x2566, "custommoveanimset" },
    { 0x2567, "custommovetransition" },
    { 0x2568, "custommovetransitionfunc" },
    { 0x2569, "customnotetrackfx" },
    { 0x256A, "customreactanime" },
    { 0x256B, "customrunningreacttobullets" },
    { 0x256C, "customunloadfunc" },
    { 0x256D, "cut" },
    { 0x256E, "cutoff_distance_current" },
    { 0x256F, "cutoff_distance_goal" },
    { 0x2570, "cutoff_falloff_current" },
    { 0x2571, "cutoff_falloff_goal" },
    { 0x2572, "cutter" },
    { 0x2573, "cvrdrn_paired_anim_explo" },
    { 0x2574, "cvrdrn_paired_anim_start" },
    { 0x2575, "cycle_charging_hud" },
    { 0x2576, "cycle_offhand_grenade" },
    { 0x2577, "dam_destroyed" },
    { 0x2578, "dam_enemies" },
    { 0x2579, "dam_explode" },
    { 0x257A, "dam_objective" },
    { 0x257B, "dam_targ" },
    { 0x257C, "dam_target_death" },
    { 0x257D, "damage_accumulation_clip" },
    { 0x257E, "damage_allowed" },
    { 0x257F, "damage_change_goal" },
    { 0x2580, "damage_feedback_setup" },
    { 0x2581, "damage_functions" },
    { 0x2582, "damage_fx" },
    { 0x2583, "damage_hint_bullet_only" },
    { 0x2584, "damage_hints" },
    { 0x2585, "damage_hints_cleanup" },
    { 0x2586, "damage_info" },
    { 0x2587, "damage_is_explosive" },
    { 0x2588, "damage_is_valid_for_friendlyfire_warning" },
    { 0x2589, "damage_mirror" },
    { 0x258A, "damage_multiplier_mod" },
    { 0x258B, "damage_not" },
    { 0x258C, "damage_part_area" },
    { 0x258D, "damage_scale" },
    { 0x258E, "damage_sound_time" },
    { 0x258F, "damage_type" },
    { 0x2590, "damageattacker" },
    { 0x2591, "damagecallback" },
    { 0x2592, "damagecenter" },
    { 0x2593, "damaged" },
    { 0x2594, "damaged_fire" },
    { 0x2595, "damaged_parts" },
    { 0x2596, "damaged_planter" },
    { 0x2597, "damaged_turbine_1" },
    { 0x2598, "damaged_turbine_2" },
    { 0x2599, "damagedealttoofast" },
    { 0x259A, "damagedlensviewmodel" },
    { 0x259B, "damagedone" },
    { 0x259C, "damagedownertome" },
    { 0x259D, "damagedplayers" },
    { 0x259E, "damageent" },
    { 0x259F, "damagefade" },
    { 0x25A0, "damagefeedback" },
    { 0x25A1, "damagefeedback_took_damage" },
    { 0x25A2, "damagefeedbackhud" },
    { 0x25A3, "damagefeedbacksnd" },
    { 0x25A4, "damagefeedbacktimer" },
    { 0x25A5, "damageinfo" },
    { 0x25A6, "damageinfocolorindex" },
    { 0x25A7, "damageinfovictim" },
    { 0x25A8, "damageisfromplayer" },
    { 0x25A9, "damagelocationisany" },
    { 0x25AA, "damagemodel" },
    { 0x25AB, "damageorigin" },
    { 0x25AC, "damageowner" },
    { 0x25AD, "damagepoint" },
    { 0x25AE, "damageradius" },
    { 0x25AF, "damagereceivedtoofast" },
    { 0x25B0, "damageringsarray" },
    { 0x25B1, "damageshellshockandrumble" },
    { 0x25B2, "damageshieldcounter" },
    { 0x25B3, "damageshieldpain" },
    { 0x25B4, "damagethendestroyriotshield" },
    { 0x25B5, "damagetracking" },
    { 0x25B6, "damb" },
    { 0x25B7, "damb_animal_sfx_offset" },
    { 0x25B8, "damb_enable" },
    { 0x25B9, "damb_init" },
    { 0x25BA, "damb_link_to_damb" },
    { 0x25BB, "damb_make_linked_damb" },
    { 0x25BC, "damb_manual_trigger" },
    { 0x25BD, "damb_pause_damb" },
    { 0x25BE, "damb_prob_mix_damb_presets" },
    { 0x25BF, "damb_set_max_entities" },
    { 0x25C0, "damb_set_oneshot_callback_for_component" },
    { 0x25C1, "damb_set_oneshot_callback_for_dynamic_ambience" },
    { 0x25C2, "damb_start_preset" },
    { 0x25C3, "damb_start_preset_at_point" },
    { 0x25C4, "damb_start_preset_on_entity" },
    { 0x25C5, "damb_stop" },
    { 0x25C6, "damb_stop_preset" },
    { 0x25C7, "damb_stop_preset_at_point" },
    { 0x25C8, "damb_stop_zone" },
    { 0x25C9, "damb_unpause_damb" },
    { 0x25CA, "damb_use_string_table" },
    { 0x25CB, "damb_zone_start_preset" },
    { 0x25CC, "damb_zone_stop_preset" },
    { 0x25CD, "damb1_name" },
    { 0x25CE, "damb2_name" },
    { 0x25CF, "dambinfostruct" },
    { 0x25D0, "dambx_create_damb_event" },
    { 0x25D1, "dambx_fade_out_playing_loop" },
    { 0x25D2, "dambx_fade_out_playing_sound" },
    { 0x25D3, "dambx_get_component_data" },
    { 0x25D4, "dambx_get_component_from_string_table" },
    { 0x25D5, "dambx_get_component_from_string_table_internal" },
    { 0x25D6, "dambx_get_component_preset" },
    { 0x25D7, "dambx_get_damb_preset" },
    { 0x25D8, "dambx_get_list_value_from_string_table" },
    { 0x25D9, "dambx_get_loop_def_from_string_table" },
    { 0x25DA, "dambx_get_loop_def_from_string_table_internal" },
    { 0x25DB, "dambx_get_loop_preset" },
    { 0x25DC, "dambx_get_preset_from_string_table" },
    { 0x25DD, "dambx_get_preset_from_stringtable_internal" },
    { 0x25DE, "dambx_get_two_value_float_array" },
    { 0x25DF, "dambx_make_first_wait" },
    { 0x25E0, "dambx_monitor_damb_point_distance" },
    { 0x25E1, "dambx_monitor_single_loops_on_ent" },
    { 0x25E2, "dambx_perform_loop_event" },
    { 0x25E3, "dambx_perform_oneshot_event" },
    { 0x25E4, "dambx_perform_play_event" },
    { 0x25E5, "dambx_pick_random_alias" },
    { 0x25E6, "dambx_pick_random_component" },
    { 0x25E7, "dambx_play" },
    { 0x25E8, "dambx_play_component_loops" },
    { 0x25E9, "dambx_start_linked_dambs" },
    { 0x25EA, "dambx_start_preset" },
    { 0x25EB, "dambx_stop_preset" },
    { 0x25EC, "dambx_trigger_linked_damb" },
    { 0x25ED, "dambx_update" },
    { 0x25EE, "dambx_update_serially" },
    { 0x25EF, "dambx_wait_till_sound_done_and_remove_handle" },
    { 0x25F0, "dangerforwardpush" },
    { 0x25F1, "dangermaxradius" },
    { 0x25F2, "dangerminradius" },
    { 0x25F3, "dangerovalscale" },
    { 0x25F4, "dangersprinttime" },
    { 0x25F5, "dangerzone_enemy_seek_player" },
    { 0x25F6, "dangle" },
    { 0x25F7, "darkscreenoverlay" },
    { 0x25F8, "dash" },
    { 0x25F9, "data" },
    { 0x25FA, "data_index" },
    { 0x25FB, "dazed_sky_bridge_explosions" },
    { 0x25FC, "dc_old_moveplaybackrate" },
    { 0x25FD, "dds" },
    { 0x25FE, "dds_ai_init" },
    { 0x25FF, "dds_characterid" },
    { 0x2600, "dds_clear_all_queued_events" },
    { 0x2601, "dds_clear_all_queued_events_axis" },
    { 0x2602, "dds_clear_old_expired_events" },
    { 0x2603, "dds_clear_old_expired_events_axis" },
    { 0x2604, "dds_disable" },
    { 0x2605, "dds_dmg_attacker" },
    { 0x2606, "dds_enable" },
    { 0x2607, "dds_event_activate" },
    { 0x2608, "dds_event_activate_play" },
    { 0x2609, "dds_exclude_this_ai" },
    { 0x260A, "dds_find_infantry_threat" },
    { 0x260B, "dds_find_threats" },
    { 0x260C, "dds_get_ai_id" },
    { 0x260D, "dds_get_alias_from_event" },
    { 0x260E, "dds_get_alias_from_name" },
    { 0x260F, "dds_get_non_ai_threats" },
    { 0x2610, "dds_getclock_position" },
    { 0x2611, "dds_init" },
    { 0x2612, "dds_killstreak_timer" },
    { 0x2613, "dds_main_process" },
    { 0x2614, "dds_main_process_axis" },
    { 0x2615, "dds_multikill_tracker" },
    { 0x2616, "dds_notify" },
    { 0x2617, "dds_notify_casualty" },
    { 0x2618, "dds_notify_grenade" },
    { 0x2619, "dds_notify_mod" },
    { 0x261A, "dds_notify_reload" },
    { 0x261B, "dds_notify_response" },
    { 0x261C, "dds_notify_threat" },
    { 0x261D, "dds_notify_threat_unique" },
    { 0x261E, "dds_process_active_events" },
    { 0x261F, "dds_process_active_events_axis" },
    { 0x2620, "dds_reinforcement_think" },
    { 0x2621, "dds_send_team_notify_on_disable" },
    { 0x2622, "dds_set_player_character_name" },
    { 0x2623, "dds_sort_ent_damage" },
    { 0x2624, "dds_sort_ent_dist" },
    { 0x2625, "dds_sort_ent_duration" },
    { 0x2626, "dds_threat_dir_stored" },
    { 0x2627, "dds_threat_guy" },
    { 0x2628, "dds_threat_mypos" },
    { 0x2629, "dds_watch_damage" },
    { 0x262A, "dds_watch_grenade_flee" },
    { 0x262B, "dds_watch_player_health" },
    { 0x262C, "deactivate" },
    { 0x262D, "deactivate_betrayal_exo_abilities" },
    { 0x262E, "deactivate_clientside_exploder" },
    { 0x262F, "deactivate_exo_ping" },
    { 0x2630, "deactivate_heater" },
    { 0x2631, "deactivate_index" },
    { 0x2632, "deactivate_reverb" },
    { 0x2633, "deactivate_targets" },
    { 0x2634, "deactivateagent" },
    { 0x2635, "deactivateagentdelayed" },
    { 0x2636, "deactivatedlaserfx" },
    { 0x2637, "dead_demo_team" },
    { 0x2638, "dead_guy_for_moors" },
    { 0x2639, "dead_mech_enemy" },
    { 0x263A, "dead_razorback_spawn" },
    { 0x263B, "dead_stinger_guy" },
    { 0x263C, "deaddriver" },
    { 0x263D, "deadquote_recently_used" },
    { 0x263E, "death_achievements" },
    { 0x263F, "death_achievements_rappel" },
    { 0x2640, "death_cleanup" },
    { 0x2641, "death_counter" },
    { 0x2642, "death_crash_nearby_player" },
    { 0x2643, "death_delayed_ragdoll" },
    { 0x2644, "death_firesound" },
    { 0x2645, "death_flop_dir" },
    { 0x2646, "death_fx_on_self" },
    { 0x2647, "death_invulnerable_activated" },
    { 0x2648, "death_model_override" },
    { 0x2649, "death_no_ragdoll" },
    { 0x264A, "death_out_of_control" },
    { 0x264B, "death_pit" },
    { 0x264C, "death_plummet" },
    { 0x264D, "death_rocket_out_of_control" },
    { 0x264E, "death_spining" },
    { 0x264F, "death_spiral" },
    { 0x2650, "death_state" },
    { 0x2651, "death_throw" },
    { 0x2652, "death_waiter" },
    { 0x2653, "death_watch" },
    { 0x2654, "death_watcher" },
    { 0x2655, "deathanim" },
    { 0x2656, "deathanimscript" },
    { 0x2657, "deathchain_goalvolume" },
    { 0x2658, "deathchainainotify" },
    { 0x2659, "deathchainspawnerlogic" },
    { 0x265A, "deathcleanup" },
    { 0x265B, "deathdamage_max" },
    { 0x265C, "deathdamage_min" },
    { 0x265D, "deatheffect" },
    { 0x265E, "deathflags" },
    { 0x265F, "deathfunc_rocket" },
    { 0x2660, "deathfunc_vol" },
    { 0x2661, "deathfunc_vrap" },
    { 0x2662, "deathfuncs" },
    { 0x2663, "deathfunction" },
    { 0x2664, "deathfunctions" },
    { 0x2665, "deathfx_ent" },
    { 0x2666, "deathoverridecallback" },
    { 0x2667, "deathposition" },
    { 0x2668, "deathrolloff" },
    { 0x2669, "deathrollon" },
    { 0x266A, "deathscript" },
    { 0x266B, "deathsdoor" },
    { 0x266C, "deathsdoor_enabled" },
    { 0x266D, "deathsoundsandfx" },
    { 0x266E, "deathspawner" },
    { 0x266F, "deathspawnerents" },
    { 0x2670, "deathspawnerpreview" },
    { 0x2671, "deathspin" },
    { 0x2672, "deathstring" },
    { 0x2673, "deathstring_passed" },
    { 0x2674, "deathtime" },
    { 0x2675, "debgugprintdestructiblelist" },
    { 0x2676, "debris" },
    { 0x2677, "debug" },
    { 0x2678, "debug_ai_count" },
    { 0x2679, "debug_all" },
    { 0x267A, "debug_anim_time" },
    { 0x267B, "debug_animsoundtag" },
    { 0x267C, "debug_animsoundtagselected" },
    { 0x267D, "debug_arrival" },
    { 0x267E, "debug_arrivals_on_actor" },
    { 0x267F, "debug_axis" },
    { 0x2680, "debug_bike_line" },
    { 0x2681, "debug_canal_breach_start" },
    { 0x2682, "debug_canal_start" },
    { 0x2683, "debug_character_count" },
    { 0x2684, "debug_check_allies_spawned" },
    { 0x2685, "debug_circle" },
    { 0x2686, "debug_circle_drawlines" },
    { 0x2687, "debug_color" },
    { 0x2688, "debug_color_friendlies" },
    { 0x2689, "debug_color_huds" },
    { 0x268A, "debug_colornodes" },
    { 0x268B, "debug_controls" },
    { 0x268C, "debug_corner" },
    { 0x268D, "debug_door_kick_start" },
    { 0x268E, "debug_draw" },
    { 0x268F, "debug_draw_aim" },
    { 0x2690, "debug_draw_anim_path" },
    { 0x2691, "debug_draw_arrow" },
    { 0x2692, "debug_draw_living_ai" },
    { 0x2693, "debug_draw_obstacles" },
    { 0x2694, "debug_draw_path" },
    { 0x2695, "debug_dumplightshadowstates" },
    { 0x2696, "debug_elements" },
    { 0x2697, "debug_enemy_jets_die" },
    { 0x2698, "debug_enemypos" },
    { 0x2699, "debug_enemyposproc" },
    { 0x269A, "debug_enemyposreplay" },
    { 0x269B, "debug_flashlight_basement_switch" },
    { 0x269C, "debug_fly" },
    { 0x269D, "debug_foam_tag" },
    { 0x269E, "debug_foot_passing" },
    { 0x269F, "debug_free_path" },
    { 0x26A0, "debug_friendly_death" },
    { 0x26A1, "debug_friendlyfire" },
    { 0x26A2, "debug_fxlighting" },
    { 0x26A3, "debug_fxlighting_buttons" },
    { 0x26A4, "debug_graph" },
    { 0x26A5, "debug_graph_draw" },
    { 0x26A6, "debug_graph_init" },
    { 0x26A7, "debug_graph_init_key" },
    { 0x26A8, "debug_grapplep" },
    { 0x26A9, "debug_hero_pathing" },
    { 0x26AA, "debug_hud_elem" },
    { 0x26AB, "debug_hudinfo_landassist" },
    { 0x26AC, "debug_id" },
    { 0x26AD, "debug_irons_chase" },
    { 0x26AE, "debug_line" },
    { 0x26AF, "debug_lobby_start" },
    { 0x26B0, "debug_message" },
    { 0x26B1, "debug_message_ai" },
    { 0x26B2, "debug_message_clear" },
    { 0x26B3, "debug_monitor_for_all_cloaked_stealth_enemies" },
    { 0x26B4, "debug_nuke" },
    { 0x26B5, "debug_out_of_bounds_areas" },
    { 0x26B6, "debug_pathing" },
    { 0x26B7, "debug_player_fall" },
    { 0x26B8, "debug_player_in_post_clip" },
    { 0x26B9, "debug_print_guys_in_volume" },
    { 0x26BA, "debug_radiusdamage_circle" },
    { 0x26BB, "debug_reflection" },
    { 0x26BC, "debug_reflection_buttons" },
    { 0x26BD, "debug_roof_start" },
    { 0x26BE, "debug_seoul_canal_begin_combat" },
    { 0x26BF, "debug_seoul_canal_fight_to_weapon_platform" },
    { 0x26C0, "debug_seoul_canal_start" },
    { 0x26C1, "debug_seoul_finale_scene_start" },
    { 0x26C2, "debug_seoul_shopping_district_flee_swarm" },
    { 0x26C3, "debug_seoul_shopping_district_start" },
    { 0x26C4, "debug_seoul_sinkhole_start" },
    { 0x26C5, "debug_seoul_subway_start" },
    { 0x26C6, "debug_show_org" },
    { 0x26C7, "debug_show_origin" },
    { 0x26C8, "debug_show_pos" },
    { 0x26C9, "debug_show_pos_once" },
    { 0x26CA, "debug_show_vec" },
    { 0x26CB, "debug_show_walker_tank_health" },
    { 0x26CC, "debug_silo_approach_clut" },
    { 0x26CD, "debug_silo_approach_start" },
    { 0x26CE, "debug_silo_door_kick_clut" },
    { 0x26CF, "debug_silo_exhaust_entrance_clut" },
    { 0x26D0, "debug_silo_exhaust_entrance_start" },
    { 0x26D1, "debug_silo_floor_03_clut" },
    { 0x26D2, "debug_silo_floor_03_start" },
    { 0x26D3, "debug_skip_button_press" },
    { 0x26D4, "debug_sky_bridge_start" },
    { 0x26D5, "debug_snake_points" },
    { 0x26D6, "debug_start_alleyway" },
    { 0x26D7, "debug_start_big_cave" },
    { 0x26D8, "debug_start_bike_ride_in" },
    { 0x26D9, "debug_start_cave_entry" },
    { 0x26DA, "debug_start_cave_hallway" },
    { 0x26DB, "debug_start_cliff_rappel" },
    { 0x26DC, "debug_start_combat_cave" },
    { 0x26DD, "debug_start_common" },
    { 0x26DE, "debug_start_courtyard" },
    { 0x26DF, "debug_start_courtyard_jammer" },
    { 0x26E0, "debug_start_crash" },
    { 0x26E1, "debug_start_crash_site" },
    { 0x26E2, "debug_start_demo_with_itiot" },
    { 0x26E3, "debug_start_drive_in" },
    { 0x26E4, "debug_start_equip_player" },
    { 0x26E5, "debug_start_exfil" },
    { 0x26E6, "debug_start_exit_drive" },
    { 0x26E7, "debug_start_exit_drive_end" },
    { 0x26E8, "debug_start_exopush" },
    { 0x26E9, "debug_start_facility_breach" },
    { 0x26EA, "debug_start_foam_room" },
    { 0x26EB, "debug_start_forest_start" },
    { 0x26EC, "debug_start_forest_takedown" },
    { 0x26ED, "debug_start_hospital" },
    { 0x26EE, "debug_start_hospital_capture" },
    { 0x26EF, "debug_start_ice_bridge" },
    { 0x26F0, "debug_start_intro" },
    { 0x26F1, "debug_start_intro_skip" },
    { 0x26F2, "debug_start_lake" },
    { 0x26F3, "debug_start_lake_cinema" },
    { 0x26F4, "debug_start_logging_road" },
    { 0x26F5, "debug_start_mech_march" },
    { 0x26F6, "debug_start_narrow_cave" },
    { 0x26F7, "debug_start_nightclub" },
    { 0x26F8, "debug_start_overlook" },
    { 0x26F9, "debug_start_research_facility_bridge" },
    { 0x26FA, "debug_start_school_basement" },
    { 0x26FB, "debug_start_school_before_fall" },
    { 0x26FC, "debug_start_school_begin" },
    { 0x26FD, "debug_start_school_interior" },
    { 0x26FE, "debug_start_school_wall_grab" },
    { 0x26FF, "debug_start_sentinel_reveal" },
    { 0x2700, "debug_start_server_room" },
    { 0x2701, "debug_start_server_room_promo" },
    { 0x2702, "debug_start_skyjack" },
    { 0x2703, "debug_start_tank_ascent" },
    { 0x2704, "debug_start_tank_board" },
    { 0x2705, "debug_start_tank_field" },
    { 0x2706, "debug_start_tank_field_left_fork" },
    { 0x2707, "debug_start_tank_field_right_fork" },
    { 0x2708, "debug_start_tank_hangar" },
    { 0x2709, "debug_start_tank_road" },
    { 0x270A, "debug_start_vtol_takedown" },
    { 0x270B, "debug_state" },
    { 0x270C, "debug_stealth" },
    { 0x270D, "debug_stealth_type" },
    { 0x270E, "debug_stopenemypos" },
    { 0x270F, "debug_tag" },
    { 0x2710, "debug_tag_camera" },
    { 0x2711, "debug_tag_internal" },
    { 0x2712, "debug_tags" },
    { 0x2713, "debug_test_next_mission" },
    { 0x2714, "debug_text" },
    { 0x2715, "debug_text_hud" },
    { 0x2716, "debug_timer" },
    { 0x2717, "debug_toggle" },
    { 0x2718, "debug_track" },
    { 0x2719, "debug_turrets" },
    { 0x271A, "debug_vehicle_node" },
    { 0x271B, "debug_vehicles" },
    { 0x271C, "debug_watch_dynamicevent_start_now" },
    { 0x271D, "debug_will_exo_breach" },
    { 0x271E, "debug_will_room_start" },
    { 0x271F, "debug_x4walker" },
    { 0x2720, "debugburstprint" },
    { 0x2721, "debugchains" },
    { 0x2722, "debugcircle" },
    { 0x2723, "debugcolorfriendlies" },
    { 0x2724, "debugcriticaldata" },
    { 0x2725, "debugdvars" },
    { 0x2726, "debugging_on" },
    { 0x2727, "debuggoalpos" },
    { 0x2728, "debugheight" },
    { 0x2729, "debughelper" },
    { 0x272A, "debugjump" },
    { 0x272B, "debugleft" },
    { 0x272C, "debugline" },
    { 0x272D, "debugmisstime" },
    { 0x272E, "debugmisstimeoff" },
    { 0x272F, "debugorigin" },
    { 0x2730, "debugplayerteleport" },
    { 0x2731, "debugpos" },
    { 0x2732, "debugposinternal" },
    { 0x2733, "debugpossize" },
    { 0x2734, "debugprint" },
    { 0x2735, "debugprint3dcontinuous" },
    { 0x2736, "debugscoredata" },
    { 0x2737, "debugskip_intro" },
    { 0x2738, "debugspawners" },
    { 0x2739, "debugstart_middle_takedown" },
    { 0x273A, "debugstart_post_middle_takedown" },
    { 0x273B, "debugthreat" },
    { 0x273C, "debugthreatcalc" },
    { 0x273D, "debugtimeout" },
    { 0x273E, "debugvar" },
    { 0x273F, "debugwavecount" },
    { 0x2740, "decel" },
    { 0x2741, "decide_to_change_lane" },
    { 0x2742, "decide_to_dodge" },
    { 0x2743, "decidenumcrawls" },
    { 0x2744, "decidenumshotsforburst" },
    { 0x2745, "decidenumshotsforfull" },
    { 0x2746, "decidewhatandhowtoshoot" },
    { 0x2747, "deck" },
    { 0x2748, "deck_dialog_rail_gun_secure" },
    { 0x2749, "deck_dialogue" },
    { 0x274A, "deck_drones" },
    { 0x274B, "deck_enemies_cleared" },
    { 0x274C, "deck_jammer_rumbles" },
    { 0x274D, "deck_jammers" },
    { 0x274E, "deck_navy_guys" },
    { 0x274F, "deck_reinforcement_ally_think" },
    { 0x2750, "deck_reinforcement_modify_accuracy" },
    { 0x2751, "decloak_intro_helicopter" },
    { 0x2752, "decloak_wait_1" },
    { 0x2753, "decloak_wait_2" },
    { 0x2754, "decloak_wait_3" },
    { 0x2755, "decloaking_model" },
    { 0x2756, "decon_finish" },
    { 0x2757, "decon_guy_walk_away" },
    { 0x2758, "decon_guy_walk_to" },
    { 0x2759, "decon_reverse_blocking" },
    { 0x275A, "decoy_hint_hud" },
    { 0x275B, "decreasegunlevelevent" },
    { 0x275C, "decrement_claimed_refcount" },
    { 0x275D, "decrement_firing_count_if_died_while_firing" },
    { 0x275E, "decrement_help_list_offset" },
    { 0x275F, "decrement_list_offset" },
    { 0x2760, "decrement_ref_count" },
    { 0x2761, "decrementalivecount" },
    { 0x2762, "decrementbulletsinclip" },
    { 0x2763, "decremented" },
    { 0x2764, "decrementfauxvehiclecount" },
    { 0x2765, "deep_array_call" },
    { 0x2766, "deep_array_thread" },
    { 0x2767, "deep_water_weapon" },
    { 0x2768, "deer_leaves_fx" },
    { 0x2769, "deer_sequence" },
    { 0x276A, "def" },
    { 0x276B, "def_asset_type" },
    { 0x276C, "def_fadein_time" },
    { 0x276D, "def_fadeout_time" },
    { 0x276E, "def_fire" },
    { 0x276F, "def_for_cuc_note" },
    { 0x2770, "def_input_name" },
    { 0x2771, "def_neon" },
    { 0x2772, "def_output_name" },
    { 0x2773, "def_output_scalar" },
    { 0x2774, "def_player_mode" },
    { 0x2775, "def_priority" },
    { 0x2776, "def_pulse" },
    { 0x2777, "def_smooth_down" },
    { 0x2778, "def_smooth_up" },
    { 0x2779, "def_sound_offset" },
    { 0x277A, "def_state_min_retrigger_time" },
    { 0x277B, "default_ball_origin" },
    { 0x277C, "default_class_chosen" },
    { 0x277D, "default_door_node_flashbang_frequency" },
    { 0x277E, "default_drop_pitch" },
    { 0x277F, "default_footsteps" },
    { 0x2780, "default_gametype_think" },
    { 0x2781, "default_goal_origins" },
    { 0x2782, "default_goalheight" },
    { 0x2783, "default_goalradius" },
    { 0x2784, "default_health" },
    { 0x2785, "default_hud" },
    { 0x2786, "default_loadout_if_notset" },
    { 0x2787, "default_ondeadevent" },
    { 0x2788, "default_onhalftime" },
    { 0x2789, "default_ononeleftevent" },
    { 0x278A, "default_ontimelimit" },
    { 0x278B, "default_player_dist" },
    { 0x278C, "default_reverb" },
    { 0x278D, "default_run_speed" },
    { 0x278E, "default_start" },
    { 0x278F, "default_start_override" },
    { 0x2790, "default_style" },
    { 0x2791, "default_sun_light" },
    { 0x2792, "default_target_vec" },
    { 0x2793, "default_unresolved_collision_handler" },
    { 0x2794, "default_vid_log_vol" },
    { 0x2795, "default_weapon" },
    { 0x2796, "defaultclass" },
    { 0x2797, "defaultdroppitch" },
    { 0x2798, "defaultdropyaw" },
    { 0x2799, "defaultexception" },
    { 0x279A, "defaultfxlightinglookup" },
    { 0x279B, "defaultidlestateoverride" },
    { 0x279C, "defaultmodel" },
    { 0x279D, "defaultmodellightinglookup" },
    { 0x279E, "defaultonmode" },
    { 0x279F, "defaults" },
    { 0x27A0, "defaultstand" },
    { 0x27A1, "defaultsundir" },
    { 0x27A2, "defaultsunlight" },
    { 0x27A3, "defaultturnthreshold" },
    { 0x27A4, "defaultvalue" },
    { 0x27A5, "defaultweapon" },
    { 0x27A6, "defend_entrance_index" },
    { 0x27A7, "defend_flag" },
    { 0x27A8, "defend_get_ally_bots_at_zone_for_stance" },
    { 0x27A9, "defend_objective_radius" },
    { 0x27AA, "defend_planted_bomb_update" },
    { 0x27AB, "defend_valid_center" },
    { 0x27AC, "defend_zone" },
    { 0x27AD, "defendedplayerevent" },
    { 0x27AE, "defender_damage_func" },
    { 0x27AF, "defender_set_script_pathstyle" },
    { 0x27B0, "defender_update" },
    { 0x27B1, "defendobjectiveevent" },
    { 0x27B2, "defense_cautious_approach" },
    { 0x27B3, "defense_death_monitor" },
    { 0x27B4, "defense_force_next_node_goal" },
    { 0x27B5, "defense_get_initial_entrances" },
    { 0x27B6, "defense_investigate_specific_point" },
    { 0x27B7, "defense_override_entrances" },
    { 0x27B8, "defense_score_flags" },
    { 0x27B9, "defense_watch_entrances_at_goal" },
    { 0x27BA, "defenseless_tank_impact" },
    { 0x27BB, "define_loadout" },
    { 0x27BC, "defrate" },
    { 0x27BD, "defsmooth" },
    { 0x27BE, "defuseendtime" },
    { 0x27BF, "defuser_bad_path_counter" },
    { 0x27C0, "defuser_wait_for_death" },
    { 0x27C1, "defusethink" },
    { 0x27C2, "defusetime" },
    { 0x27C3, "delay" },
    { 0x27C4, "delay_drone_kamikaze_player" },
    { 0x27C5, "delay_from_any_hint_s" },
    { 0x27C6, "delay_from_kill_s" },
    { 0x27C7, "delay_from_same_hint_s" },
    { 0x27C8, "delay_linkto_anim" },
    { 0x27C9, "delay_oncoming_bypass_kill" },
    { 0x27CA, "delay_retreat" },
    { 0x27CB, "delay_script_call" },
    { 0x27CC, "delay_script_call_proc" },
    { 0x27CD, "delay_scripting_if_stealth_broken" },
    { 0x27CE, "delay_set_fall_damage" },
    { 0x27CF, "delay_show_bones" },
    { 0x27D0, "delaycall" },
    { 0x27D1, "delaycall_proc" },
    { 0x27D2, "delaychildthread" },
    { 0x27D3, "delaychildthread_proc" },
    { 0x27D4, "delaycleanupdroppod" },
    { 0x27D5, "delaycontrol" },
    { 0x27D6, "delaydelete" },
    { 0x27D7, "delaydeleteprompt" },
    { 0x27D8, "delaydestroy" },
    { 0x27D9, "delayed_cut" },
    { 0x27DA, "delayed_delete" },
    { 0x27DB, "delayed_delete_light" },
    { 0x27DC, "delayed_earthquake" },
    { 0x27DD, "delayed_exploded_guy_deletion" },
    { 0x27DE, "delayed_luinotifyserver" },
    { 0x27DF, "delayed_player_seek_think" },
    { 0x27E0, "delayed_takeweapon" },
    { 0x27E1, "delayedbadplace" },
    { 0x27E2, "delayeddialogue" },
    { 0x27E3, "delayedexception" },
    { 0x27E4, "delayedleaderdialog" },
    { 0x27E5, "delayedleaderdialogbothteams" },
    { 0x27E6, "delayedlocktargetent" },
    { 0x27E7, "delayedlocktargettag" },
    { 0x27E8, "delayedplayergoal" },
    { 0x27E9, "delayer" },
    { 0x27EA, "delayfade" },
    { 0x27EB, "delayinc" },
    { 0x27EC, "delayminetime" },
    { 0x27ED, "delayplayfx" },
    { 0x27EE, "delayresetdeployedjuggernaut" },
    { 0x27EF, "delaysetweapon" },
    { 0x27F0, "delaystandardmelee" },
    { 0x27F1, "delaystartragdoll" },
    { 0x27F2, "delaythread" },
    { 0x27F3, "delaythread_nuke" },
    { 0x27F4, "delaythread_proc" },
    { 0x27F5, "deletable_magic_bullet_shield" },
    { 0x27F6, "deletable_turret" },
    { 0x27F7, "delete_after_wait" },
    { 0x27F8, "delete_ai" },
    { 0x27F9, "delete_ai_on_flag" },
    { 0x27FA, "delete_ai_on_goal" },
    { 0x27FB, "delete_ai_on_path_end" },
    { 0x27FC, "delete_all_grenades" },
    { 0x27FD, "delete_all_mines" },
    { 0x27FE, "delete_ambient" },
    { 0x27FF, "delete_at_goal" },
    { 0x2800, "delete_at_path_end" },
    { 0x2801, "delete_atlas_intercept" },
    { 0x2802, "delete_atlas_intercepts" },
    { 0x2803, "delete_atlas_van_driver" },
    { 0x2804, "delete_auto" },
    { 0x2805, "delete_bot_badplaces" },
    { 0x2806, "delete_breach" },
    { 0x2807, "delete_civilian_at_trigger" },
    { 0x2808, "delete_cloak_cover" },
    { 0x2809, "delete_collapse_ent" },
    { 0x280A, "delete_corpses_around_vehicle" },
    { 0x280B, "delete_debug_text_hud" },
    { 0x280C, "delete_destructibles_in_volumes" },
    { 0x280D, "delete_drone" },
    { 0x280E, "delete_enemy_on_flag" },
    { 0x280F, "delete_ents_by_targetname" },
    { 0x2810, "delete_exploder" },
    { 0x2811, "delete_exploder_proc" },
    { 0x2812, "delete_exploders_in_volumes" },
    { 0x2813, "delete_guy_on_trigger_stealth" },
    { 0x2814, "delete_guys_in_heli_when_vo_complete" },
    { 0x2815, "delete_hangar_allies_on_goal" },
    { 0x2816, "delete_heartrate_hud" },
    { 0x2817, "delete_highway_player_side" },
    { 0x2818, "delete_interactives_in_volumes" },
    { 0x2819, "delete_lane_cars" },
    { 0x281A, "delete_laser_on_death" },
    { 0x281B, "delete_links_then_self" },
    { 0x281C, "delete_me" },
    { 0x281D, "delete_me_in" },
    { 0x281E, "delete_me_on_flag" },
    { 0x281F, "delete_me_on_goal" },
    { 0x2820, "delete_me_on_goal_special" },
    { 0x2821, "delete_me_on_notify" },
    { 0x2822, "delete_mobile_cover" },
    { 0x2823, "delete_nearest_car_door_vehicle_collision" },
    { 0x2824, "delete_notify" },
    { 0x2825, "delete_ok" },
    { 0x2826, "delete_on_complete" },
    { 0x2827, "delete_on_crash" },
    { 0x2828, "delete_on_death" },
    { 0x2829, "delete_on_death_wait_sound" },
    { 0x282A, "delete_on_goal" },
    { 0x282B, "delete_on_not_defined" },
    { 0x282C, "delete_on_notify" },
    { 0x282D, "delete_on_path_end" },
    { 0x282E, "delete_on_player_unlink" },
    { 0x282F, "delete_on_removed" },
    { 0x2830, "delete_path_end" },
    { 0x2831, "delete_pod_crash_floor" },
    { 0x2832, "delete_pressed" },
    { 0x2833, "delete_primer" },
    { 0x2834, "delete_roadsurface_bridge" },
    { 0x2835, "delete_rooftop_los_blockers" },
    { 0x2836, "delete_selection" },
    { 0x2837, "delete_self_on_death_of" },
    { 0x2838, "delete_spawners" },
    { 0x2839, "delete_specific_navy_ships" },
    { 0x283A, "delete_start" },
    { 0x283B, "delete_subtitle_in" },
    { 0x283C, "delete_this_on_death" },
    { 0x283D, "delete_tower_debris" },
    { 0x283E, "delete_traffic_group" },
    { 0x283F, "delete_traffic_path" },
    { 0x2840, "delete_turret_on_death" },
    { 0x2841, "delete_veh" },
    { 0x2842, "delete_vehicle_at_trigger" },
    { 0x2843, "delete_vehicle_outof_view" },
    { 0x2844, "delete_vehicle_traffic_roundabout_straightways" },
    { 0x2845, "delete_vm_underwater_org" },
    { 0x2846, "delete_weapon_on_notify" },
    { 0x2847, "delete_wills_room_clip" },
    { 0x2848, "deleteaftertime" },
    { 0x2849, "deleteboat" },
    { 0x284A, "deletec4andclaymoresondisconnect" },
    { 0x284B, "deletecrate" },
    { 0x284C, "deletedebughudelem" },
    { 0x284D, "deletedefined" },
    { 0x284E, "deletedelay" },
    { 0x284F, "deletedestructiblekillcament" },
    { 0x2850, "deleteduringreflectionprobegeneration" },
    { 0x2851, "deleteent" },
    { 0x2852, "deleteequipment" },
    { 0x2853, "deleteexplosiontag" },
    { 0x2854, "deleteexplosivedrone" },
    { 0x2855, "deletegoliathpod" },
    { 0x2856, "deleteifnotused" },
    { 0x2857, "deletelasertagarray" },
    { 0x2858, "deletemapremotemissileclip" },
    { 0x2859, "deleteme" },
    { 0x285A, "deletemineonteamswitch" },
    { 0x285B, "deleteobjectwhendone" },
    { 0x285C, "deleteobjpoint" },
    { 0x285D, "deleteondeath" },
    { 0x285E, "deleteonownerdeath" },
    { 0x285F, "deleteonreviveordeathordisconnect" },
    { 0x2860, "deletepickupafterawhile" },
    { 0x2861, "deleteplacedentity" },
    { 0x2862, "deleteplayerdroppod" },
    { 0x2863, "deleteplayerdroppodvfx" },
    { 0x2864, "deletepodtrophyfx" },
    { 0x2865, "deletepodtrophyfxondeath" },
    { 0x2866, "deletepodtrophyfxondisconnect" },
    { 0x2867, "deletepodtrophyfxonteamchange" },
    { 0x2868, "deleteportableradar" },
    { 0x2869, "deleterotationents" },
    { 0x286A, "deletescrambler" },
    { 0x286B, "deleteshieldonplayerdeathordisconnect" },
    { 0x286C, "deleteshieldontriggerdeath" },
    { 0x286D, "deleteshieldontriggerpickup" },
    { 0x286E, "deleteshortly" },
    { 0x286F, "deletesquad" },
    { 0x2870, "deletestruct_ref" },
    { 0x2871, "deletestructarray" },
    { 0x2872, "deletestructarray_ref" },
    { 0x2873, "deleteti" },
    { 0x2874, "deletetrackingdrone" },
    { 0x2875, "deletetransrevmeshes" },
    { 0x2876, "deleteuseent" },
    { 0x2877, "deleteuseobject" },
    { 0x2878, "deletewalkingcivilians" },
    { 0x2879, "deleteweaponmodels" },
    { 0x287A, "delicate_flower" },
    { 0x287B, "deliverytrucksetup" },
    { 0x287C, "delta" },
    { 0x287D, "demo_feed_lines" },
    { 0x287E, "demo_skip_forward" },
    { 0x287F, "depleted" },
    { 0x2880, "deploy_check_player_in_elevator_think" },
    { 0x2881, "deploy_delay" },
    { 0x2882, "deploy_scene_ents" },
    { 0x2883, "deploy_scene_handcuff_ents" },
    { 0x2884, "deploy_sequence" },
    { 0x2885, "deploy_trophy" },
    { 0x2886, "deploy_vo" },
    { 0x2887, "deployable_cover" },
    { 0x2888, "deployable_cover_ai" },
    { 0x2889, "deployable_cover_anims" },
    { 0x288A, "deployable_cover_cleanup" },
    { 0x288B, "deployable_cover_focus_goal" },
    { 0x288C, "deployable_cover_kill" },
    { 0x288D, "deployable_cover_model" },
    { 0x288E, "deployable_cover_think" },
    { 0x288F, "deployable_cover_watch_death" },
    { 0x2890, "deployablecover" },
    { 0x2891, "deployablecoverinuse" },
    { 0x2892, "deployedscrambler" },
    { 0x2893, "deployflares" },
    { 0x2894, "deprecated__audio_msg_handler" },
    { 0x2895, "deprecated_aud_delay_play_2d_sound" },
    { 0x2896, "deprecated_aud_delay_play_2d_sound_internal" },
    { 0x2897, "deprecated_aud_delay_play_linked_sound" },
    { 0x2898, "deprecated_aud_delay_play_linked_sound_internal" },
    { 0x2899, "deprecated_aud_delete_on_sounddone" },
    { 0x289A, "deprecated_aud_fade_sound_in" },
    { 0x289B, "deprecated_aud_handle_flickering_light" },
    { 0x289C, "deprecated_aud_map" },
    { 0x289D, "deprecated_aud_map_range" },
    { 0x289E, "deprecated_aud_map2" },
    { 0x289F, "deprecated_aud_play_2d_sound" },
    { 0x28A0, "deprecated_aud_play_conversation" },
    { 0x28A1, "deprecated_aud_play_linked_sound" },
    { 0x28A2, "deprecated_aud_play_sound_at" },
    { 0x28A3, "deprecated_aud_play_sound_at_internal" },
    { 0x28A4, "deprecated_aud_register_msg_handler" },
    { 0x28A5, "deprecated_aud_send_msg" },
    { 0x28A6, "deprecated_aud_set_filter" },
    { 0x28A7, "deprecated_aud_set_occlusion" },
    { 0x28A8, "deprecated_audio_message" },
    { 0x28A9, "deprecated_audx_dispatch_msg" },
    { 0x28AA, "deprecated_audx_monitor_linked_entity_health" },
    { 0x28AB, "deprecated_audx_play_linked_sound_internal" },
    { 0x28AC, "deprecated_delete_sound_entity" },
    { 0x28AD, "deprecated_play_2d_sound_internal" },
    { 0x28AE, "depth_allow_crouch" },
    { 0x28AF, "depth_allow_prone" },
    { 0x28B0, "depth_allow_stand" },
    { 0x28B1, "derailed" },
    { 0x28B2, "desc_col" },
    { 0x28B3, "describe_start" },
    { 0x28B4, "description" },
    { 0x28B5, "deselect_all_ents" },
    { 0x28B6, "deselect_entity" },
    { 0x28B7, "desired_anim_pose" },
    { 0x28B8, "desired_range" },
    { 0x28B9, "desired_speed" },
    { 0x28BA, "desiredtimeofdeath" },
    { 0x28BB, "desk_animate" },
    { 0x28BC, "despawn_dist_sq" },
    { 0x28BD, "despawn_if_not_in_view" },
    { 0x28BE, "dest" },
    { 0x28BF, "dest_cover" },
    { 0x28C0, "destination2" },
    { 0x28C1, "destinations" },
    { 0x28C2, "destroy_aim_hud" },
    { 0x28C3, "destroy_all_frogger_vehicles_lane" },
    { 0x28C4, "destroy_cine_helicopter" },
    { 0x28C5, "destroy_drones_in_wave" },
    { 0x28C6, "destroy_drones_when_nuked" },
    { 0x28C7, "destroy_hint_on_friendlyfire" },
    { 0x28C8, "destroy_hud_elem_landassist" },
    { 0x28C9, "destroy_mobile_turret" },
    { 0x28CA, "destroy_office_snipe_glass" },
    { 0x28CB, "destroy_on_flag" },
    { 0x28CC, "destroy_radar_hud_elem_early" },
    { 0x28CD, "destroy_screen_pac" },
    { 0x28CE, "destroy_self_when_nuked" },
    { 0x28CF, "destroy_sentinel_drone_hud" },
    { 0x28D0, "destroy_the_window_exit" },
    { 0x28D1, "destroy_tracking_drone_in_water" },
    { 0x28D2, "destroy_truck_01" },
    { 0x28D3, "destroy_turret_when_player_leaves" },
    { 0x28D4, "destroy_walker_tank" },
    { 0x28D5, "destroy_warbird" },
    { 0x28D6, "destroy_warning_elem" },
    { 0x28D7, "destroy_warning_elem_when_hit_again" },
    { 0x28D8, "destroy_warning_elem_when_mission_failed" },
    { 0x28D9, "destroy_windshield" },
    { 0x28DA, "destroyactivedrones" },
    { 0x28DB, "destroyactiveequipmentvehicles" },
    { 0x28DC, "destroyactivehelis" },
    { 0x28DD, "destroyactivelittlebirds" },
    { 0x28DE, "destroyactiveorbitallasers" },
    { 0x28DF, "destroyactiverockets" },
    { 0x28E0, "destroyactivestreakvehicles" },
    { 0x28E1, "destroyactiveturrets" },
    { 0x28E2, "destroyactiveuavs" },
    { 0x28E3, "destroyactiveugvs" },
    { 0x28E4, "destroyactivevehicles" },
    { 0x28E5, "destroyatriumfighttimer" },
    { 0x28E6, "destroydroppedgun" },
    { 0x28E7, "destroyed" },
    { 0x28E8, "destroyedcount" },
    { 0x28E9, "destroyedcounttimeout" },
    { 0x28EA, "destroyedvo" },
    { 0x28EB, "destroyefx" },
    { 0x28EC, "destroyelem" },
    { 0x28ED, "destroyempobjectsinradius" },
    { 0x28EE, "destroyentityheadiconondeath" },
    { 0x28EF, "destroyheadiconsondeath" },
    { 0x28F0, "destroyhudelem" },
    { 0x28F1, "destroyiconsondeath" },
    { 0x28F2, "destroymarkettimer" },
    { 0x28F3, "destroyonownerdisconnect" },
    { 0x28F4, "destroyonreviveentdeath" },
    { 0x28F5, "destroyplayerdroppod" },
    { 0x28F6, "destroyplayericons" },
    { 0x28F7, "destroysetupambushtimer" },
    { 0x28F8, "destroyslowly" },
    { 0x28F9, "destructable_destroyed" },
    { 0x28FA, "destructable_destruct" },
    { 0x28FB, "destructable_think" },
    { 0x28FC, "destructible" },
    { 0x28FD, "destructible_anim" },
    { 0x28FE, "destructible_animation_think" },
    { 0x28FF, "destructible_anims" },
    { 0x2900, "destructible_attachmodel" },
    { 0x2901, "destructible_badplace_radius_multiplier" },
    { 0x2902, "destructible_boxtruck_think" },
    { 0x2903, "destructible_builddot_damage" },
    { 0x2904, "destructible_builddot_ontick" },
    { 0x2905, "destructible_builddot_startloop" },
    { 0x2906, "destructible_builddot_wait" },
    { 0x2907, "destructible_car_alarm" },
    { 0x2908, "destructible_cleans_up_more" },
    { 0x2909, "destructible_create" },
    { 0x290A, "destructible_createdot_predefined" },
    { 0x290B, "destructible_createdot_radius" },
    { 0x290C, "destructible_damage_threshold" },
    { 0x290D, "destructible_death" },
    { 0x290E, "destructible_disable_explosion" },
    { 0x290F, "destructible_dots" },
    { 0x2910, "destructible_explode" },
    { 0x2911, "destructible_explosion_radius_multiplier" },
    { 0x2912, "destructible_force_explosion" },
    { 0x2913, "destructible_function" },
    { 0x2914, "destructible_functions" },
    { 0x2915, "destructible_fx" },
    { 0x2916, "destructible_fx_kill_state_wait" },
    { 0x2917, "destructible_fx_spawn_immediate" },
    { 0x2918, "destructible_fx_spawn_think" },
    { 0x2919, "destructible_fx_spawnimmediate" },
    { 0x291A, "destructible_fx_think" },
    { 0x291B, "destructible_get_my_breakable_light" },
    { 0x291C, "destructible_getinfoindex" },
    { 0x291D, "destructible_gettype" },
    { 0x291E, "destructible_handles_collision_brushes" },
    { 0x291F, "destructible_health_drain_amount_multiplier" },
    { 0x2920, "destructible_healthdrain" },
    { 0x2921, "destructible_info" },
    { 0x2922, "destructible_lights_out" },
    { 0x2923, "destructible_loopfx" },
    { 0x2924, "destructible_loopsound" },
    { 0x2925, "destructible_model" },
    { 0x2926, "destructible_notify" },
    { 0x2927, "destructible_part" },
    { 0x2928, "destructible_parts" },
    { 0x2929, "destructible_physics" },
    { 0x292A, "destructible_protection_func" },
    { 0x292B, "destructible_setdot_ontick" },
    { 0x292C, "destructible_setdot_ontickfunc" },
    { 0x292D, "destructible_sound" },
    { 0x292E, "destructible_sound_think" },
    { 0x292F, "destructible_splash_damage" },
    { 0x2930, "destructible_splash_damage_scaler" },
    { 0x2931, "destructible_splash_rotatation" },
    { 0x2932, "destructible_spotlight" },
    { 0x2933, "destructible_spotlight_think" },
    { 0x2934, "destructible_state" },
    { 0x2935, "destructible_think" },
    { 0x2936, "destructible_trailer_collision_destroy_when_player_close" },
    { 0x2937, "destructible_trailer_collision_think" },
    { 0x2938, "destructible_transient" },
    { 0x2939, "destructible_update_part" },
    { 0x293A, "destructiblecoverwatcher" },
    { 0x293B, "destructibleframequeue" },
    { 0x293C, "destructibleinfo" },
    { 0x293D, "destructibles" },
    { 0x293E, "destructiblespawnedents" },
    { 0x293F, "destructiblespawnedentslimit" },
    { 0x2940, "det_blood_impact_burst01" },
    { 0x2941, "det_blood_impact_burst02" },
    { 0x2942, "det_blood_impact_burst03" },
    { 0x2943, "det_bones_bike_end_fx" },
    { 0x2944, "det_brick_pull_fx" },
    { 0x2945, "det_camp_lookat_trigger_think" },
    { 0x2946, "det_catch_guy_01_ball_drop" },
    { 0x2947, "det_catch_guy_01_pt_02" },
    { 0x2948, "det_catch_guy_01_pt_03" },
    { 0x2949, "det_catch_guy_01_pt_04" },
    { 0x294A, "det_catch_guy_01_pt_05" },
    { 0x294B, "det_catch_guy_02_pt_02" },
    { 0x294C, "det_catch_guy_02_pt_03" },
    { 0x294D, "det_catch_guy_02_pt_04" },
    { 0x294E, "det_catch_guy_02_pt_05" },
    { 0x294F, "det_debris_falling" },
    { 0x2950, "det_doc_cap_doc" },
    { 0x2951, "det_doc_cap_gdn" },
    { 0x2952, "det_doc_cap_jkr" },
    { 0x2953, "det_doc_picked_up" },
    { 0x2954, "det_doc_roll_over" },
    { 0x2955, "det_end_chopper_approach" },
    { 0x2956, "det_end_chopper_crash_start" },
    { 0x2957, "det_end_chopper_tumble" },
    { 0x2958, "det_end_chopper_tumble_2" },
    { 0x2959, "det_end_gate_close" },
    { 0x295A, "det_fall_through_ceiling" },
    { 0x295B, "det_gl_end_logo" },
    { 0x295C, "det_helicopter_explo" },
    { 0x295D, "det_helicopter_shot" },
    { 0x295E, "det_helmet_smash_fx" },
    { 0x295F, "det_hospital_gate_close" },
    { 0x2960, "det_hoverbike_mount_burke" },
    { 0x2961, "det_hoverbike_shutdown_burke" },
    { 0x2962, "det_hoverbike_startup_burke" },
    { 0x2963, "det_intro_gdn" },
    { 0x2964, "det_intro_gideon_foley_pt1" },
    { 0x2965, "det_intro_gideon_foley_pt2" },
    { 0x2966, "det_intro_gideon_foley_pt3" },
    { 0x2967, "det_joker_bike_end_fx" },
    { 0x2968, "det_knife_pull" },
    { 0x2969, "det_knife_stab_fx" },
    { 0x296A, "det_knx_thatsclassifiedmate" },
    { 0x296B, "det_mech_scanner_fx" },
    { 0x296C, "det_scanner_fx" },
    { 0x296D, "det_scanner_fx_bg" },
    { 0x296E, "det_school_fall_plr" },
    { 0x296F, "det_sent_meet_brk" },
    { 0x2970, "det_sent_meet_jkr" },
    { 0x2971, "det_sent_meet_knx" },
    { 0x2972, "det_shelf_papers_fx" },
    { 0x2973, "det_start_doctor_breathing" },
    { 0x2974, "det_stop_doctor_breathing" },
    { 0x2975, "det_vignette" },
    { 0x2976, "det_water_crash_jeep_1" },
    { 0x2977, "det_water_crash_jeep_2" },
    { 0x2978, "detach_attachments_from_weapon_model" },
    { 0x2979, "detach_cig" },
    { 0x297A, "detach_getoutrigs" },
    { 0x297B, "detach_housing" },
    { 0x297C, "detach_idle_clip" },
    { 0x297D, "detach_models_with_substr" },
    { 0x297E, "detach_motion_blur_disable" },
    { 0x297F, "detach_motion_blur_enable" },
    { 0x2980, "detach_phone" },
    { 0x2981, "detachall_on_death" },
    { 0x2982, "detachallweaponmodels" },
    { 0x2983, "detachflag" },
    { 0x2984, "detachgrenadeonscriptchange" },
    { 0x2985, "detachifattached" },
    { 0x2986, "detachprops" },
    { 0x2987, "detachusemodels" },
    { 0x2988, "detachweapon" },
    { 0x2989, "detcord_logic" },
    { 0x298A, "detect_being_pushed" },
    { 0x298B, "detect_cargo_ship_damage" },
    { 0x298C, "detect_cargo_ship_death" },
    { 0x298D, "detect_distsqrd" },
    { 0x298E, "detect_dropping" },
    { 0x298F, "detect_enemies" },
    { 0x2990, "detect_player_death" },
    { 0x2991, "detect_range" },
    { 0x2992, "detect_turret_death" },
    { 0x2993, "detect_when_player_is_in_volume" },
    { 0x2994, "detectedexploit" },
    { 0x2995, "detectexplosives" },
    { 0x2996, "detectfriendlyfireonentity" },
    { 0x2997, "detectid" },
    { 0x2998, "detection_grenade_duration" },
    { 0x2999, "detection_grenade_duration_bonus" },
    { 0x299A, "detection_grenade_hud_effect" },
    { 0x299B, "detection_grenade_range" },
    { 0x299C, "detection_grenade_sweep_time" },
    { 0x299D, "detection_grenade_think" },
    { 0x299E, "detection_highlight_hud_effect" },
    { 0x299F, "detection_highlight_hud_effect_apply" },
    { 0x29A0, "detection_highlight_hud_effect_off" },
    { 0x29A1, "detection_highlight_hud_effect_old" },
    { 0x29A2, "detection_highlight_hud_effect_on" },
    { 0x29A3, "detection_highlight_hud_effect_remove" },
    { 0x29A4, "detection_level" },
    { 0x29A5, "detectiongrenadethink" },
    { 0x29A6, "detectiongrenadewatch" },
    { 0x29A7, "determine_projectile_position" },
    { 0x29A8, "determine_sticky_position" },
    { 0x29A9, "determinecqbanim" },
    { 0x29AA, "determineexposedapproachtype" },
    { 0x29AB, "determineheatcoverexittype" },
    { 0x29AC, "determinenodeapproachtype" },
    { 0x29AD, "determinenodeexittype" },
    { 0x29AE, "determinenonnodeexittype" },
    { 0x29AF, "determinestate" },
    { 0x29B0, "determineweaponnameandattachments" },
    { 0x29B1, "detonate_foam_grenade" },
    { 0x29B2, "detonate_foam_nag_dialogue" },
    { 0x29B3, "detonate_hovertank_aa_projectile_on_death" },
    { 0x29B4, "detonateondeath" },
    { 0x29B5, "detonateonuse" },
    { 0x29B6, "detonateradius" },
    { 0x29B7, "detonatetrap" },
    { 0x29B8, "detour_flag" },
    { 0x29B9, "detoured" },
    { 0x29BA, "detouringpath" },
    { 0x29BB, "detpackstunradius" },
    { 0x29BC, "detroit_cg_precache_models" },
    { 0x29BD, "detroit_drive_in_fov" },
    { 0x29BE, "detroit_kva_bauerdoyoureadme" },
    { 0x29BF, "detroit_laser" },
    { 0x29C0, "detroit_locations" },
    { 0x29C1, "detroit_music_preset_constructor" },
    { 0x29C2, "detroit_spring_cam_lerp_speed" },
    { 0x29C3, "detroit_spring_cam_release_speed" },
    { 0x29C4, "detroitcustomkillstreakfunc" },
    { 0x29C5, "detroitpaladinoverrides" },
    { 0x29C6, "detroitstrikeheightoverrides" },
    { 0x29C7, "detroittramobjids" },
    { 0x29C8, "df_baghdad_combat_pre_load" },
    { 0x29C9, "df_baghdad_dnabomb_pre_load" },
    { 0x29CA, "df_baghdad_dof_presets" },
    { 0x29CB, "df_baghdad_global_spawnfunctions" },
    { 0x29CC, "df_baghdad_intro_pre_load" },
    { 0x29CD, "df_baghdad_lighting" },
    { 0x29CE, "df_baghdad_lighting_captured" },
    { 0x29CF, "df_baghdad_lighting_dna_bomb_01" },
    { 0x29D0, "df_baghdad_lighting_dna_bomb_02" },
    { 0x29D1, "df_baghdad_lighting_dna_bomb_03" },
    { 0x29D2, "df_baghdad_lighting_drones" },
    { 0x29D3, "df_baghdad_lighting_preload" },
    { 0x29D4, "df_baghdad_post_tower_autosaves" },
    { 0x29D5, "df_baghdad_post_tower_pre_load" },
    { 0x29D6, "df_baghdad_pre_load" },
    { 0x29D7, "df_baghdad_precache" },
    { 0x29D8, "df_baghdad_retrun_player_rig" },
    { 0x29D9, "df_baghdad_set_level_lighting_values" },
    { 0x29DA, "df_baghdad_snipers_pre_load" },
    { 0x29DB, "df_baghdad_starts" },
    { 0x29DC, "df_cheap_rpgs" },
    { 0x29DD, "df_enable_boostjump" },
    { 0x29DE, "df_fly_dof_presets" },
    { 0x29DF, "df_fly_lighting" },
    { 0x29E0, "df_fly_lighting_canyon" },
    { 0x29E1, "df_fly_lighting_canyon_finale" },
    { 0x29E2, "df_fly_lighting_end_pod" },
    { 0x29E3, "df_fly_pre_load" },
    { 0x29E4, "df_fly_precache" },
    { 0x29E5, "df_fly_set_level_lighting_values" },
    { 0x29E6, "df_fly_starts" },
    { 0x29E7, "df_global_accuracy" },
    { 0x29E8, "df_objectives" },
    { 0x29E9, "df_player_rig_name" },
    { 0x29EA, "dialog" },
    { 0x29EB, "dialog_collapse" },
    { 0x29EC, "dialog_complain_cold" },
    { 0x29ED, "dialog_hotel_top_floor_nk_alerted" },
    { 0x29EE, "dialog_mech_clear_queued" },
    { 0x29EF, "dialog_meltdown" },
    { 0x29F0, "dialog_monitor_drones_down" },
    { 0x29F1, "dialog_nags_heli" },
    { 0x29F2, "dialog_noise_stinger" },
    { 0x29F3, "dialogcounter" },
    { 0x29F4, "dialogdangerzone" },
    { 0x29F5, "dialogtable" },
    { 0x29F6, "dialogue" },
    { 0x29F7, "dialogue_approaching_drop_point" },
    { 0x29F8, "dialogue_ast_ahead" },
    { 0x29F9, "dialogue_boat_destroyed" },
    { 0x29FA, "dialogue_breach_ahead" },
    { 0x29FB, "dialogue_breach_complete" },
    { 0x29FC, "dialogue_building_jump" },
    { 0x29FD, "dialogue_canal_start" },
    { 0x29FE, "dialogue_carry_scene_01" },
    { 0x29FF, "dialogue_carry_scene_02" },
    { 0x2A00, "dialogue_chase_irons" },
    { 0x2A01, "dialogue_control_room_attack" },
    { 0x2A02, "dialogue_doctor_trolley" },
    { 0x2A03, "dialogue_drone_swarm_intro" },
    { 0x2A04, "dialogue_drone_turret_sequence" },
    { 0x2A05, "dialogue_droppod_intro" },
    { 0x2A06, "dialogue_droppod_intro_prelaunch" },
    { 0x2A07, "dialogue_droppod_prelaunch" },
    { 0x2A08, "dialogue_execute" },
    { 0x2A09, "dialogue_exhaust_hatch" },
    { 0x2A0A, "dialogue_exit_trench" },
    { 0x2A0B, "dialogue_gd" },
    { 0x2A0C, "dialogue_gd_lift" },
    { 0x2A0D, "dialogue_gid_rocket_reminder" },
    { 0x2A0E, "dialogue_gid_swarm_reminder" },
    { 0x2A0F, "dialogue_guardroom_door" },
    { 0x2A10, "dialogue_hatch_position" },
    { 0x2A11, "dialogue_head_to_exhaust_vent" },
    { 0x2A12, "dialogue_hotel_exit" },
    { 0x2A13, "dialogue_hotel_mid_floor_contact" },
    { 0x2A14, "dialogue_hotel_mid_floor_fight_over" },
    { 0x2A15, "dialogue_hotel_mid_floor_glass_gag" },
    { 0x2A16, "dialogue_hotel_missile_dodge" },
    { 0x2A17, "dialogue_hotel_pod_exit_begin" },
    { 0x2A18, "dialogue_hotel_top_floor_landassist" },
    { 0x2A19, "dialogue_hotel_top_floor_landing" },
    { 0x2A1A, "dialogue_hotel_top_floor_nk_soldier_spotted" },
    { 0x2A1B, "dialogue_huds" },
    { 0x2A1C, "dialogue_into_exhaust_hatch" },
    { 0x2A1D, "dialogue_intro" },
    { 0x2A1E, "dialogue_intro_black" },
    { 0x2A1F, "dialogue_introdrive" },
    { 0x2A20, "dialogue_irons_ending" },
    { 0x2A21, "dialogue_keep_moving" },
    { 0x2A22, "dialogue_mb1" },
    { 0x2A23, "dialogue_mb1_bootup" },
    { 0x2A24, "dialogue_mb1_intro" },
    { 0x2A25, "dialogue_mb1_jumpdown" },
    { 0x2A26, "dialogue_mb2" },
    { 0x2A27, "dialogue_mb2_gatesmash" },
    { 0x2A28, "dialogue_mb2_gid_il_convo" },
    { 0x2A29, "dialogue_mech" },
    { 0x2A2A, "dialogue_mech_everytime" },
    { 0x2A2B, "dialogue_missile_damage" },
    { 0x2A2C, "dialogue_missile_launch" },
    { 0x2A2D, "dialogue_more_boats" },
    { 0x2A2E, "dialogue_nag_loop" },
    { 0x2A2F, "dialogue_nag_player" },
    { 0x2A30, "dialogue_overpass" },
    { 0x2A31, "dialogue_pa_launch_coundown" },
    { 0x2A32, "dialogue_pa_security_breach" },
    { 0x2A33, "dialogue_performing_arts_entrance" },
    { 0x2A34, "dialogue_primary_ignitionin" },
    { 0x2A35, "dialogue_queue" },
    { 0x2A36, "dialogue_queue_global" },
    { 0x2A37, "dialogue_queue_single" },
    { 0x2A38, "dialogue_random_last_line" },
    { 0x2A39, "dialogue_random_line" },
    { 0x2A3A, "dialogue_ready_to_drop" },
    { 0x2A3B, "dialogue_reminder" },
    { 0x2A3C, "dialogue_s1elevator_outside" },
    { 0x2A3D, "dialogue_s2_elevator_open" },
    { 0x2A3E, "dialogue_s2_walk" },
    { 0x2A3F, "dialogue_s2elevator_outside" },
    { 0x2A40, "dialogue_s3_head_doctor" },
    { 0x2A41, "dialogue_s3_observation" },
    { 0x2A42, "dialogue_s3escape_guard" },
    { 0x2A43, "dialogue_s3escape_hall" },
    { 0x2A44, "dialogue_silo_contact" },
    { 0x2A45, "dialogue_trench_demo_team" },
    { 0x2A46, "dialogue_truck_push_sequence" },
    { 0x2A47, "dialogue_uv_bake_awcmon" },
    { 0x2A48, "dialogue_wallsmash_nag" },
    { 0x2A49, "dialogue_water_clear" },
    { 0x2A4A, "dialogue_will_revael" },
    { 0x2A4B, "dialoguelevelintro" },
    { 0x2A4C, "dialoguenotetrack" },
    { 0x2A4D, "didpastmeleefail" },
    { 0x2A4E, "didpastpursuitfail" },
    { 0x2A4F, "didshufflemove" },
    { 0x2A50, "didsomethingotherthanshooting" },
    { 0x2A51, "didstatusnotify" },
    { 0x2A52, "didtie" },
    { 0x2A53, "didturretexplosion" },
    { 0x2A54, "die" },
    { 0x2A55, "dieaftertime" },
    { 0x2A56, "died_being_tracked" },
    { 0x2A57, "died_of_headshot" },
    { 0x2A58, "diehardmode" },
    { 0x2A59, "differentiate_motion" },
    { 0x2A5A, "differentiated_acceleration" },
    { 0x2A5B, "differentiated_jerk" },
    { 0x2A5C, "differentiated_last_acceleration" },
    { 0x2A5D, "differentiated_last_origin" },
    { 0x2A5E, "differentiated_last_update" },
    { 0x2A5F, "differentiated_last_velocity" },
    { 0x2A60, "differentiated_speed" },
    { 0x2A61, "differentiated_velocity" },
    { 0x2A62, "difficulty" },
    { 0x2A63, "difficultysettings" },
    { 0x2A64, "difficultysettings_frac_data_points" },
    { 0x2A65, "difficultystring" },
    { 0x2A66, "difficultytype" },
    { 0x2A67, "digitaldistort" },
    { 0x2A68, "digitmodels" },
    { 0x2A69, "dimensionsx" },
    { 0x2A6A, "dimensionsy" },
    { 0x2A6B, "dir" },
    { 0x2A6C, "diraimlimit" },
    { 0x2A6D, "directhackduration" },
    { 0x2A6E, "directhacked" },
    { 0x2A6F, "directhackendtime" },
    { 0x2A70, "direction" },
    { 0x2A71, "dirt_on_screen_from_position" },
    { 0x2A72, "dirt_splatter_simple" },
    { 0x2A73, "dirteffect" },
    { 0x2A74, "dirty" },
    { 0x2A75, "disable_achievement_harder_they_fall" },
    { 0x2A76, "disable_achievement_harder_they_fall_guy" },
    { 0x2A77, "disable_ai_color" },
    { 0x2A78, "disable_ai_swim" },
    { 0x2A79, "disable_aim_assist_on_script_model" },
    { 0x2A7A, "disable_alert" },
    { 0x2A7B, "disable_all_fixed_scanners" },
    { 0x2A7C, "disable_all_turrets" },
    { 0x2A7D, "disable_arrivals" },
    { 0x2A7E, "disable_awareness" },
    { 0x2A7F, "disable_awareness_limited" },
    { 0x2A80, "disable_badplace_for_red_guys" },
    { 0x2A81, "disable_blindfire" },
    { 0x2A82, "disable_blood_pool" },
    { 0x2A83, "disable_bokeh" },
    { 0x2A84, "disable_boost_dash" },
    { 0x2A85, "disable_boost_hud" },
    { 0x2A86, "disable_boost_jump" },
    { 0x2A87, "disable_breathing_sound" },
    { 0x2A88, "disable_bulletwhizbyreaction" },
    { 0x2A89, "disable_careful" },
    { 0x2A8A, "disable_cloak_system" },
    { 0x2A8B, "disable_cormack_obj" },
    { 0x2A8C, "disable_cover_drone" },
    { 0x2A8D, "disable_cover_drone_on_mobile_turret_mount" },
    { 0x2A8E, "disable_cqb_points_of_interest" },
    { 0x2A8F, "disable_cqb_squad" },
    { 0x2A90, "disable_cqbwalk" },
    { 0x2A91, "disable_damagefeedback_hud" },
    { 0x2A92, "disable_damagefeedback_snd" },
    { 0x2A93, "disable_danger_react" },
    { 0x2A94, "disable_default_exo_powers" },
    { 0x2A95, "disable_destructible_bad_places" },
    { 0x2A96, "disable_dive_whizby_react" },
    { 0x2A97, "disable_dof_car_door_throw" },
    { 0x2A98, "disable_dog_control" },
    { 0x2A99, "disable_dog_kinect" },
    { 0x2A9A, "disable_dog_sneak" },
    { 0x2A9B, "disable_dog_sniff" },
    { 0x2A9C, "disable_dog_walk" },
    { 0x2A9D, "disable_dontevershoot" },
    { 0x2A9E, "disable_dynamic_run_speed" },
    { 0x2A9F, "disable_enable_exit_flags" },
    { 0x2AA0, "disable_exits" },
    { 0x2AA1, "disable_exo_during_land_assist" },
    { 0x2AA2, "disable_exo_for_highway" },
    { 0x2AA3, "disable_exo_melee" },
    { 0x2AA4, "disable_explosion" },
    { 0x2AA5, "disable_fall_damage" },
    { 0x2AA6, "disable_features_entering_cinema" },
    { 0x2AA7, "disable_firing" },
    { 0x2AA8, "disable_force_sprint" },
    { 0x2AA9, "disable_free_running" },
    { 0x2AAA, "disable_gideon_jog_when_turning" },
    { 0x2AAB, "disable_grenade_range_triggers" },
    { 0x2AAC, "disable_grenades" },
    { 0x2AAD, "disable_gun_recall" },
    { 0x2AAE, "disable_heat_behavior" },
    { 0x2AAF, "disable_high_jump" },
    { 0x2AB0, "disable_highway_path_player_side" },
    { 0x2AB1, "disable_ignorerandombulletdamage_drone" },
    { 0x2AB2, "disable_interactive_tv_use_triggers" },
    { 0x2AB3, "disable_ir_in_nightvision" },
    { 0x2AB4, "disable_long_death" },
    { 0x2AB5, "disable_me_when_exopush_finished" },
    { 0x2AB6, "disable_mech_chaingun" },
    { 0x2AB7, "disable_mech_rocket" },
    { 0x2AB8, "disable_mech_swarm" },
    { 0x2AB9, "disable_mech_threat_ping" },
    { 0x2ABA, "disable_meele_for_breach" },
    { 0x2ABB, "disable_melee" },
    { 0x2ABC, "disable_middle_civs" },
    { 0x2ABD, "disable_middle_civs_now" },
    { 0x2ABE, "disable_militia_behavior" },
    { 0x2ABF, "disable_mobile_turret_if_not_destroyed" },
    { 0x2AC0, "disable_motion_blur" },
    { 0x2AC1, "disable_mount_point" },
    { 0x2AC2, "disable_my_thermal" },
    { 0x2AC3, "disable_oneshotfx_with_noteworthy" },
    { 0x2AC4, "disable_outerspacelighting_interior" },
    { 0x2AC5, "disable_pain" },
    { 0x2AC6, "disable_physical_dof" },
    { 0x2AC7, "disable_pitbull_use" },
    { 0x2AC8, "disable_player_controls" },
    { 0x2AC9, "disable_player_swim" },
    { 0x2ACA, "disable_player_swimming" },
    { 0x2ACB, "disable_player_underwater_walk" },
    { 0x2ACC, "disable_pod_door_clip" },
    { 0x2ACD, "disable_rappel_trigger_monitor" },
    { 0x2ACE, "disable_readystand" },
    { 0x2ACF, "disable_replace_on_death" },
    { 0x2AD0, "disable_same_side_blocking" },
    { 0x2AD1, "disable_shield_ability" },
    { 0x2AD2, "disable_sniper_glint" },
    { 0x2AD3, "disable_sonar_when_not_allowed" },
    { 0x2AD4, "disable_sonic_aoe" },
    { 0x2AD5, "disable_sprint" },
    { 0x2AD6, "disable_ssao_over_time" },
    { 0x2AD7, "disable_static_mobile_cover" },
    { 0x2AD8, "disable_stealth_debug_hud" },
    { 0x2AD9, "disable_stealth_for_ai" },
    { 0x2ADA, "disable_stealth_smart_stance" },
    { 0x2ADB, "disable_stealth_system" },
    { 0x2ADC, "disable_stencil" },
    { 0x2ADD, "disable_surprise" },
    { 0x2ADE, "disable_swim" },
    { 0x2ADF, "disable_swim_or_underwater_walk" },
    { 0x2AE0, "disable_tactical_goals" },
    { 0x2AE1, "disable_target_tracking" },
    { 0x2AE2, "disable_teamflashbangimmunity" },
    { 0x2AE3, "disable_threat_atlas_van_driver" },
    { 0x2AE4, "disable_threat_grenade_response" },
    { 0x2AE5, "disable_threat_ping" },
    { 0x2AE6, "disable_tracking" },
    { 0x2AE7, "disable_trigger" },
    { 0x2AE8, "disable_trigger_helper" },
    { 0x2AE9, "disable_trigger_while_player_animating" },
    { 0x2AEA, "disable_trigger_with_noteworthy" },
    { 0x2AEB, "disable_trigger_with_targetname" },
    { 0x2AEC, "disable_turbine_elevator_trigger" },
    { 0x2AED, "disable_turnanims" },
    { 0x2AEE, "disable_turret_missiles" },
    { 0x2AEF, "disable_vol" },
    { 0x2AF0, "disable_weapon_pickup_wrapper" },
    { 0x2AF1, "disable_weapons_in_canal_view_room" },
    { 0x2AF2, "disableaicombatreactions" },
    { 0x2AF3, "disablealliescolor" },
    { 0x2AF4, "disableallstreaks" },
    { 0x2AF5, "disableapproach" },
    { 0x2AF6, "disablearrivals" },
    { 0x2AF7, "disableawareness" },
    { 0x2AF8, "disablebadplace" },
    { 0x2AF9, "disablebattlechatter" },
    { 0x2AFA, "disablebulletwhizbyreaction" },
    { 0x2AFB, "disableclientspawntraces" },
    { 0x2AFC, "disablecloudscount" },
    { 0x2AFD, "disablecloudsexploder" },
    { 0x2AFE, "disablecorpsealert" },
    { 0x2AFF, "disablecoverarrivalsonly" },
    { 0x2B00, "disabled" },
    { 0x2B01, "disabled_exo" },
    { 0x2B02, "disabled_use_for" },
    { 0x2B03, "disabledamagecallback" },
    { 0x2B04, "disabledamagecallbackinternal" },
    { 0x2B05, "disabledamagefeedbacksnd" },
    { 0x2B06, "disabledamageshieldpain" },
    { 0x2B07, "disabledefaultfacialanims" },
    { 0x2B08, "disabledoffhandweapons" },
    { 0x2B09, "disabledoorbehavior" },
    { 0x2B0A, "disabledronefiringafterkill" },
    { 0x2B0B, "disabledronefiringatstart" },
    { 0x2B0C, "disabledronefiringduringcrash" },
    { 0x2B0D, "disabledusability" },
    { 0x2B0E, "disabledweapon" },
    { 0x2B0F, "disabledweaponswitch" },
    { 0x2B10, "disableenemyalert" },
    { 0x2B11, "disableexits" },
    { 0x2B12, "disableexo" },
    { 0x2B13, "disablefacialfilleranims" },
    { 0x2B14, "disableforfeit" },
    { 0x2B15, "disablefriendlyfirereaction" },
    { 0x2B16, "disablegeardrop" },
    { 0x2B17, "disablegloballyusablebytype" },
    { 0x2B18, "disablegrenadetracking" },
    { 0x2B19, "disablekillstreakactionslots" },
    { 0x2B1A, "disablekillstreaks" },
    { 0x2B1B, "disablelongdeath" },
    { 0x2B1C, "disablelongdeath_saved" },
    { 0x2B1D, "disablelongpain" },
    { 0x2B1E, "disablemeleeonroof" },
    { 0x2B1F, "disablemonitorflash" },
    { 0x2B20, "disablemovementtracker" },
    { 0x2B21, "disableobject" },
    { 0x2B22, "disableorbitalthermal" },
    { 0x2B23, "disablepain" },
    { 0x2B24, "disableplayercommands" },
    { 0x2B25, "disableplayeruseent" },
    { 0x2B26, "disableranking" },
    { 0x2B27, "disablereactionanims" },
    { 0x2B28, "disableregen" },
    { 0x2B29, "disablereload" },
    { 0x2B2A, "disablesonicaoe" },
    { 0x2B2B, "disablespawning" },
    { 0x2B2C, "disablestealthonhadesdeath" },
    { 0x2B2D, "disablestencil" },
    { 0x2B2E, "disablestrangeondeath" },
    { 0x2B2F, "disablevariablescopehudondeath" },
    { 0x2B30, "disablevehiclescripts" },
    { 0x2B31, "disableweaponstats" },
    { 0x2B32, "disassociate_guy_from_vehicle" },
    { 0x2B33, "discardtime" },
    { 0x2B34, "disconnect_fake_pitbull" },
    { 0x2B35, "disconnect_node" },
    { 0x2B36, "disconnect_nodes" },
    { 0x2B37, "disconnect_paths" },
    { 0x2B38, "disconnect_paths_whenstopped" },
    { 0x2B39, "disconnected" },
    { 0x2B3A, "disconnectgatepaths" },
    { 0x2B3B, "disconnectpaths_ents_by_targetname" },
    { 0x2B3C, "disconnectpathsfunction" },
    { 0x2B3D, "disconnecttraverses" },
    { 0x2B3E, "discrete_waittill" },
    { 0x2B3F, "dismount_console" },
    { 0x2B40, "dismount_player_pitbull" },
    { 0x2B41, "dismount_timer" },
    { 0x2B42, "disomount_hint" },
    { 0x2B43, "dispatchnotify" },
    { 0x2B44, "display_animsound" },
    { 0x2B45, "display_ar_box" },
    { 0x2B46, "display_ar_line" },
    { 0x2B47, "display_ar_text" },
    { 0x2B48, "display_array" },
    { 0x2B49, "display_current_translation" },
    { 0x2B4A, "display_exit_hint" },
    { 0x2B4B, "display_fx_add_options" },
    { 0x2B4C, "display_fx_info" },
    { 0x2B4D, "display_hint" },
    { 0x2B4E, "display_hint_button" },
    { 0x2B4F, "display_hint_stick" },
    { 0x2B50, "display_hint_stick_timeout" },
    { 0x2B51, "display_hint_stick_timeout_mintime" },
    { 0x2B52, "display_hint_timeout" },
    { 0x2B53, "display_hint_timeout_mintime" },
    { 0x2B54, "display_hint_timeout_override_old" },
    { 0x2B55, "display_hint_until_zip_activated" },
    { 0x2B56, "display_no_target" },
    { 0x2B57, "display_no_target_hint" },
    { 0x2B58, "display_screen_effect" },
    { 0x2B59, "display_starts" },
    { 0x2B5A, "display_starts_pressed" },
    { 0x2B5B, "display_takedown_world_prompt_on_enemy" },
    { 0x2B5C, "display_update" },
    { 0x2B5D, "displayalertcountdowntimer" },
    { 0x2B5E, "displayboothholo" },
    { 0x2B5F, "displaybuddyspawnsuccessful" },
    { 0x2B60, "displaybuddystatusmessage" },
    { 0x2B61, "displayclientstring" },
    { 0x2B62, "displayed_hints" },
    { 0x2B63, "displaygameend" },
    { 0x2B64, "displayhealth" },
    { 0x2B65, "displayincomingairdropmessage" },
    { 0x2B66, "displayingdamagehints" },
    { 0x2B67, "displaykillstreakpoints" },
    { 0x2B68, "displayroundend" },
    { 0x2B69, "displayroundswitch" },
    { 0x2B6A, "displayruleofthirds" },
    { 0x2B6B, "displays" },
    { 0x2B6C, "displayscanresults" },
    { 0x2B6D, "displaysonicaoecontextualhints" },
    { 0x2B6E, "displaythreat" },
    { 0x2B6F, "dist" },
    { 0x2B70, "dist_from_center" },
    { 0x2B71, "dist_prop" },
    { 0x2B72, "dist_ratio_hitguy" },
    { 0x2B73, "dist_to_next_node" },
    { 0x2B74, "dist2yards" },
//  { 0x2B75, "" },
    { 0x2B76, "distance_2d_squared" },
    { 0x2B77, "distance_check_loop" },
    { 0x2B78, "distance_from_player" },
    { 0x2B79, "distance_on_path" },
    { 0x2B7A, "distance_to_goalvol_sq" },
    { 0x2B7B, "distance_to_last_stage" },
    { 0x2B7C, "distance2d_to_player" },
    { 0x2B7D, "distance2dandheightcheck" },
    { 0x2B7E, "distanceonpath" },
    { 0x2B7F, "distances" },
    { 0x2B80, "distmax" },
    { 0x2B81, "distmin" },
    { 0x2B82, "distmoved" },
    { 0x2B83, "distonpathsegment" },
    { 0x2B84, "distortionfxtoggle" },
    { 0x2B85, "distsq" },
    { 0x2B86, "distsumsquared" },
    { 0x2B87, "dive_boat_params" },
    { 0x2B88, "dive_fx" },
    { 0x2B89, "dive_warning" },
    { 0x2B8A, "diveboat" },
    { 0x2B8B, "diveboat_anims_initialized" },
    { 0x2B8C, "diveboat_attack_button_pressed" },
    { 0x2B8D, "diveboat_audio" },
    { 0x2B8E, "diveboat_condition_callback_to_state_dragging" },
    { 0x2B8F, "diveboat_condition_callback_to_state_ending" },
    { 0x2B90, "diveboat_condition_callback_to_state_idle" },
    { 0x2B91, "diveboat_condition_callback_to_state_jumping" },
    { 0x2B92, "diveboat_condition_callback_to_state_throttling" },
    { 0x2B93, "diveboat_constructor" },
    { 0x2B94, "diveboat_ending" },
    { 0x2B95, "diveboat_init" },
    { 0x2B96, "diveboat_throttle" },
    { 0x2B97, "diveboat_weapon_ammo_count" },
    { 0x2B98, "diveboat_weapon_attacked" },
    { 0x2B99, "diveboat_weapon_auto_targetting" },
    { 0x2B9A, "diveboat_weapon_fire_notify" },
    { 0x2B9B, "diveboat_weapon_fire_system" },
    { 0x2B9C, "diveboat_weapon_firing" },
    { 0x2B9D, "diveboat_weapon_gauge_level" },
    { 0x2B9E, "diveboat_weapon_reloading_system" },
    { 0x2B9F, "diveboat_weapon_target" },
    { 0x2BA0, "diveboat_weapon_targetting_system" },
    { 0x2BA1, "divide_nodes_into_groups" },
    { 0x2BA2, "dmg_screen_all" },
    { 0x2BA3, "dmg_screen_left" },
    { 0x2BA4, "dmg_screen_right" },
    { 0x2BA5, "dna_bomb_cool_fill_01" },
    { 0x2BA6, "dna_bomb_cool_fill_02" },
    { 0x2BA7, "dna_bomb_cool_fill_03" },
    { 0x2BA8, "dna_bomb_drone_handler" },
    { 0x2BA9, "dna_bomb_fire_01" },
    { 0x2BAA, "dna_bomb_fire_02" },
    { 0x2BAB, "dna_bomb_fire_03" },
    { 0x2BAC, "dna_bomb_warm_fill_01" },
    { 0x2BAD, "dna_bomb_warm_fill_02" },
    { 0x2BAE, "dna_bomb_warm_fill_03" },
    { 0x2BAF, "dnablackout" },
    { 0x2BB0, "dnablackout_moveplayers_off_roof" },
    { 0x2BB1, "dnadronebreakprisonglass" },
    { 0x2BB2, "dnadroneexplode" },
    { 0x2BB3, "dnadronelocs" },
    { 0x2BB4, "dnadronereachedgoal" },
    { 0x2BB5, "dnadrones" },
    { 0x2BB6, "dnadronesexplode" },
    { 0x2BB7, "dnaexplosionscreenshake" },
    { 0x2BB8, "do_abort" },
    { 0x2BB9, "do_bumps" },
    { 0x2BBA, "do_car_alarm" },
    { 0x2BBB, "do_continuous_rumble" },
    { 0x2BBC, "do_crash" },
    { 0x2BBD, "do_creak" },
    { 0x2BBE, "do_custom_fall_damage" },
    { 0x2BBF, "do_diveboat_threads" },
    { 0x2BC0, "do_earthquake" },
    { 0x2BC1, "do_exhaust_fx" },
    { 0x2BC2, "do_exo_repulsor" },
    { 0x2BC3, "do_fly_screen" },
    { 0x2BC4, "do_funcs" },
    { 0x2BC5, "do_hoodoo_voodoo" },
    { 0x2BC6, "do_in_order" },
    { 0x2BC7, "do_inside_bombshake" },
    { 0x2BC8, "do_into_idle_anim" },
    { 0x2BC9, "do_multiple_treads" },
    { 0x2BCA, "do_no_game_start" },
    { 0x2BCB, "do_no_game_start_teleport" },
    { 0x2BCC, "do_not_react_to_whistle" },
    { 0x2BCD, "do_nothing" },
    { 0x2BCE, "do_pathbased_avoidance" },
    { 0x2BCF, "do_player_cloak_update_threads" },
    { 0x2BD0, "do_player_explode_react" },
    { 0x2BD1, "do_random_dynamic_attachment" },
    { 0x2BD2, "do_reposition_zipline_compensation" },
    { 0x2BD3, "do_rev" },
    { 0x2BD4, "do_rotate_zipline_compensation" },
    { 0x2BD5, "do_rumble" },
    { 0x2BD6, "do_scanner_death" },
    { 0x2BD7, "do_scanner_fx" },
    { 0x2BD8, "do_scanner_sounds" },
    { 0x2BD9, "do_shaft_gameplay" },
    { 0x2BDA, "do_shaft_gameplay_setup" },
    { 0x2BDB, "do_shake" },
    { 0x2BDC, "do_single_tread" },
    { 0x2BDD, "do_tuning" },
    { 0x2BDE, "do_vehicle_scanner_tuning" },
    { 0x2BDF, "do_wait" },
    { 0x2BE0, "do_wait_any" },
    { 0x2BE1, "do_wait_endons_array" },
    { 0x2BE2, "do_wait_thread" },
    { 0x2BE3, "doadsblur" },
    { 0x2BE4, "doaim" },
    { 0x2BE5, "doaim_idle_think" },
    { 0x2BE6, "doairstrike" },
    { 0x2BE7, "doautospawn" },
    { 0x2BE8, "dobomberstrike" },
    { 0x2BE9, "dobuilddot_damage" },
    { 0x2BEA, "dobuilddot_wait" },
    { 0x2BEB, "doc_capture_bagspawn" },
    { 0x2BEC, "doc_capture_headswap" },
    { 0x2BED, "doc_fire" },
    { 0x2BEE, "doc_punched" },
    { 0x2BEF, "dock_debris" },
    { 0x2BF0, "dock_debris_blocker" },
    { 0x2BF1, "dock_mech" },
    { 0x2BF2, "doclamping" },
    { 0x2BF3, "doclamping_middle" },
    { 0x2BF4, "doclampingrelease" },
    { 0x2BF5, "doctor" },
    { 0x2BF6, "doctor_blood_swap" },
    { 0x2BF7, "doctor_capture_bag_capture_anim" },
    { 0x2BF8, "doctor_capture_bones_breach_functionality" },
    { 0x2BF9, "doctor_capture_bookshelf1" },
    { 0x2BFA, "doctor_capture_bookshelf2" },
    { 0x2BFB, "doctor_capture_breach_door_prompt" },
    { 0x2BFC, "doctor_capture_burke_alternate_point_anim" },
    { 0x2BFD, "doctor_capture_burke_doctorroom_idle" },
    { 0x2BFE, "doctor_capture_burke_enter_doctor_room" },
    { 0x2BFF, "doctor_capture_burke_shooting" },
    { 0x2C00, "doctor_capture_burke_takedown_finish" },
    { 0x2C01, "doctor_capture_check_takedown" },
    { 0x2C02, "doctor_capture_destroy_this_glass" },
    { 0x2C03, "doctor_capture_dialogue" },
    { 0x2C04, "doctor_capture_did_burke_kill_me_1" },
    { 0x2C05, "doctor_capture_did_burke_kill_me_2" },
    { 0x2C06, "doctor_capture_doctor_breach" },
    { 0x2C07, "doctor_capture_doctor_carry" },
    { 0x2C08, "doctor_capture_doctor_head_swap_function" },
    { 0x2C09, "doctor_capture_doctor_takedown_xprompt" },
    { 0x2C0A, "doctor_capture_door_breach_anim" },
    { 0x2C0B, "doctor_capture_draw_use_hint" },
    { 0x2C0C, "doctor_capture_draw_use_hint_melee" },
    { 0x2C0D, "doctor_capture_firstguy_breach" },
    { 0x2C0E, "doctor_capture_forthguy_breach" },
    { 0x2C0F, "doctor_capture_guy_3_kill_player" },
    { 0x2C10, "doctor_capture_guy1_health_check_killfunction" },
    { 0x2C11, "doctor_capture_guy3_health_check_killfunction" },
    { 0x2C12, "doctor_capture_hospital_breach_autosave" },
    { 0x2C13, "doctor_capture_inner_fight" },
    { 0x2C14, "doctor_capture_lerp_wait_function" },
    { 0x2C15, "doctor_capture_new_breach_doctor_takedown" },
    { 0x2C16, "doctor_capture_player_breach" },
    { 0x2C17, "doctor_capture_player_capture_thread" },
    { 0x2C18, "doctor_capture_player_killed" },
    { 0x2C19, "doctor_capture_player_melee_and_hit" },
    { 0x2C1A, "doctor_capture_set_new_objective_outside_breach" },
    { 0x2C1B, "doctor_capture_shoot_the_player" },
    { 0x2C1C, "doctor_capture_stop_spawning_school_trains" },
    { 0x2C1D, "doctor_capture_success_trigger" },
    { 0x2C1E, "doctor_capture_thirdguy_breach" },
    { 0x2C1F, "doctor_capture_thirdguy_notify_when_dead" },
    { 0x2C20, "doctor_capture_use_hint_blinks_melee" },
    { 0x2C21, "doctor_capture_xprompt" },
    { 0x2C22, "doctor_carry_wait_breach" },
    { 0x2C23, "doctor_hangar_waits" },
    { 0x2C24, "doctor_kva_reveal" },
    { 0x2C25, "doctor_pad_watcher" },
    { 0x2C26, "docustomanim" },
    { 0x2C27, "docustomidle" },
    { 0x2C28, "dodeathfromarray" },
    { 0x2C29, "dodge_behavior" },
    { 0x2C2A, "dodge_hint_breakout" },
    { 0x2C2B, "dodge_player_shots" },
    { 0x2C2C, "dodge_position" },
    { 0x2C2D, "dodgeleftanim" },
    { 0x2C2E, "dodgeleftanimoffset" },
    { 0x2C2F, "dodgeloadout" },
    { 0x2C30, "dodgemoveloopoverride" },
    { 0x2C31, "dodgerightanim" },
    { 0x2C32, "dodgerightanimoffset" },
    { 0x2C33, "dodging" },
    { 0x2C34, "dodoorgrenadethrow" },
    { 0x2C35, "dodot_delayfunc" },
    { 0x2C36, "dodot_fadeinblackout" },
    { 0x2C37, "dodot_fadeoutblackout" },
    { 0x2C38, "dodot_fadeoutblackoutanddestroy" },
    { 0x2C39, "dodot_poisonblackout" },
    { 0x2C3A, "dodot_poisondamage" },
    { 0x2C3B, "dodrivenidle" },
    { 0x2C3C, "does_player_have_smaw" },
    { 0x2C3D, "does_weapon_exist" },
    { 0x2C3E, "doexposedcalloutresponse" },
    { 0x2C3F, "doextendedkill" },
    { 0x2C40, "dof" },
    { 0x2C41, "dof_apply_to_results" },
    { 0x2C42, "dof_autopsy_door_seq" },
    { 0x2C43, "dof_blend_interior_ads" },
    { 0x2C44, "dof_blend_interior_ads_element" },
    { 0x2C45, "dof_blend_interior_ads_scalar" },
    { 0x2C46, "dof_blend_interior_generic" },
    { 0x2C47, "dof_calc_results" },
    { 0x2C48, "dof_car_explosion" },
    { 0x2C49, "dof_disable_ads" },
    { 0x2C4A, "dof_disable_script" },
    { 0x2C4B, "dof_enable_ads" },
    { 0x2C4C, "dof_enable_exterior" },
    { 0x2C4D, "dof_enable_interior" },
    { 0x2C4E, "dof_enable_script" },
    { 0x2C4F, "dof_enable_start" },
    { 0x2C50, "dof_end_escape" },
    { 0x2C51, "dof_escape_gun_seq" },
    { 0x2C52, "dof_far_blur" },
    { 0x2C53, "dof_far_end" },
    { 0x2C54, "dof_far_start" },
    { 0x2C55, "dof_fob_autofocus_disable" },
    { 0x2C56, "dof_fob_autofocus_enable" },
    { 0x2C57, "dof_fob_moment_start" },
    { 0x2C58, "dof_heli_crash" },
    { 0x2C59, "dof_heli_flight_seq" },
    { 0x2C5A, "dof_incinerator_seq" },
    { 0x2C5B, "dof_init" },
    { 0x2C5C, "dof_intro" },
    { 0x2C5D, "dof_intro_pre" },
    { 0x2C5E, "dof_introdrive_seq" },
    { 0x2C5F, "dof_irons_meet" },
    { 0x2C60, "dof_manticore_hangar" },
    { 0x2C61, "dof_mech_door" },
    { 0x2C62, "dof_mech_gate_crash" },
    { 0x2C63, "dof_mech_jump_getup" },
    { 0x2C64, "dof_mech_suit_entrance" },
    { 0x2C65, "dof_near_blur" },
    { 0x2C66, "dof_near_end" },
    { 0x2C67, "dof_near_start" },
    { 0x2C68, "dof_outro" },
    { 0x2C69, "dof_presets" },
    { 0x2C6A, "dof_process_ads" },
    { 0x2C6B, "dof_process_physical_ads" },
    { 0x2C6C, "dof_ref_ent" },
    { 0x2C6D, "dof_s2_walk" },
    { 0x2C6E, "dof_s3_interrogation" },
    { 0x2C6F, "dof_set_base" },
    { 0x2C70, "dof_set_focus" },
    { 0x2C71, "dof_set_generic" },
    { 0x2C72, "dof_spidertank_moment_off" },
    { 0x2C73, "dof_spidertank_moment_on" },
    { 0x2C74, "dof_subway_cinematic" },
    { 0x2C75, "dof_subway_cinematic_optimized" },
    { 0x2C76, "dof_sys_hacking" },
    { 0x2C77, "dof_time" },
    { 0x2C78, "dof_triggers" },
    { 0x2C79, "dof_tuner" },
    { 0x2C7A, "dof_update" },
    { 0x2C7B, "dof_uv_flash" },
    { 0x2C7C, "dof_viewmodel_presets" },
    { 0x2C7D, "dofacialdialogue" },
    { 0x2C7E, "dofdefault" },
    { 0x2C7F, "dofinalkillcam" },
    { 0x2C80, "dofinalkillcamfx" },
    { 0x2C81, "dofiring" },
    { 0x2C82, "dofiringeffects" },
    { 0x2C83, "dofriendlyfirereaction" },
    { 0x2C84, "dofunderwater" },
    { 0x2C85, "dog_addlean" },
    { 0x2C86, "dog_alt_melee_func" },
    { 0x2C87, "dog_animation_foundcorpse" },
    { 0x2C88, "dog_animation_generic" },
    { 0x2C89, "dog_animation_howl" },
    { 0x2C8A, "dog_animation_sawcorpse" },
    { 0x2C8B, "dog_animation_wakeup_fast" },
    { 0x2C8C, "dog_animation_wakeup_slow" },
    { 0x2C8D, "dog_anims_initialized" },
    { 0x2C8E, "dog_anims_toload" },
    { 0x2C8F, "dog_attack_alt_func" },
    { 0x2C90, "dog_attack_damage_tracking" },
    { 0x2C91, "dog_attack_dir" },
    { 0x2C92, "dog_attack_enemies" },
    { 0x2C93, "dog_attacking_me" },
    { 0x2C94, "dog_bark" },
    { 0x2C95, "dog_cant_kill_in_one_hit" },
    { 0x2C96, "dog_command_attack" },
    { 0x2C97, "dog_command_cancel" },
    { 0x2C98, "dog_command_flush" },
    { 0x2C99, "dog_command_goto" },
    { 0x2C9A, "dog_death_hud" },
    { 0x2C9B, "dog_death_quote" },
    { 0x2C9C, "dog_death_type" },
    { 0x2C9D, "dog_deathquote" },
    { 0x2C9E, "dog_delayed_allow_damage" },
    { 0x2C9F, "dog_delayed_unlink" },
    { 0x2CA0, "dog_downed_player" },
    { 0x2CA1, "dog_enemy_laststand_check" },
    { 0x2CA2, "dog_flush_functions" },
    { 0x2CA3, "dog_follow_path_func" },
    { 0x2CA4, "dog_get_within_range" },
    { 0x2CA5, "dog_got_hit" },
    { 0x2CA6, "dog_handle_traverse_notetracks" },
    { 0x2CA7, "dog_health" },
    { 0x2CA8, "dog_hint" },
    { 0x2CA9, "dog_hint_fade" },
    { 0x2CAA, "dog_hits_before_kill" },
    { 0x2CAB, "dog_jump_down" },
    { 0x2CAC, "dog_jump_up" },
    { 0x2CAD, "dog_link" },
    { 0x2CAE, "dog_long_jump" },
    { 0x2CAF, "dog_lower_camera" },
    { 0x2CB0, "dog_marker" },
    { 0x2CB1, "dog_melee_death" },
    { 0x2CB2, "dog_melee_index" },
    { 0x2CB3, "dog_melee_timing_array" },
    { 0x2CB4, "dog_monitor_goal_ent" },
    { 0x2CB5, "dog_neck_snapped" },
    { 0x2CB6, "dog_pant" },
    { 0x2CB7, "dog_pant_think" },
    { 0x2CB8, "dog_player_kill" },
    { 0x2CB9, "dog_presstime" },
    { 0x2CBA, "dog_raise_camera" },
    { 0x2CBB, "dog_swap_enemy" },
    { 0x2CBC, "dog_traverse_cleanup_on_end" },
    { 0x2CBD, "dog_traverse_kill" },
    { 0x2CBE, "dog_vs_player_anim_rate" },
    { 0x2CBF, "dog_waitfor_attack_or_bail" },
    { 0x2CC0, "dog_wall_and_window_hop" },
    { 0x2CC1, "dogallowplayerpairedanim" },
    { 0x2CC2, "dogarrivalanim" },
    { 0x2CC3, "dogasdamage" },
    { 0x2CC4, "dogattackaidist" },
    { 0x2CC5, "dogattackallowtime" },
    { 0x2CC6, "dogattackplayerdist" },
    { 0x2CC7, "dogdamagedradiussq" },
    { 0x2CC8, "dogfight_engaged_target" },
    { 0x2CC9, "dogfight_finale_knoxdeath_gideon" },
    { 0x2CCA, "dogfight_finale_knoxdeath_ilona" },
    { 0x2CCB, "dogfight_finale_knoxdeath_knox" },
    { 0x2CCC, "dogfight_irons_speech_bink" },
    { 0x2CCD, "dogfight_time" },
    { 0x2CCE, "dogfight_vo" },
    { 0x2CCF, "dogfight_vtol_ride_enter_ilona" },
    { 0x2CD0, "dogfight_vtol_ride_enter_knox" },
    { 0x2CD1, "doghintelem" },
    { 0x2CD2, "doginited" },
    { 0x2CD3, "doglastknowngoodpos" },
    { 0x2CD4, "doglastknowngoodposcustom" },
    { 0x2CD5, "doglookpose" },
    { 0x2CD6, "dogmelee" },
    { 0x2CD7, "dogmeleeearly" },
    { 0x2CD8, "dogmeleeplayercounter" },
    { 0x2CD9, "dognextidletwitchtime" },
    { 0x2CDA, "dogrenadethrow" },
    { 0x2CDB, "dogs" },
    { 0x2CDC, "dogs_dont_instant_kill" },
    { 0x2CDD, "dogsalive" },
    { 0x2CDE, "dogsinitialized" },
    { 0x2CDF, "dogstartmovedist" },
    { 0x2CE0, "dogstop_getnode" },
    { 0x2CE1, "dogstoppingdistsq" },
    { 0x2CE2, "dogtags" },
    { 0x2CE3, "dogtraverseanims" },
    { 0x2CE4, "dogturnadjust" },
    { 0x2CE5, "dogturnrate" },
    { 0x2CE6, "dohitreaction" },
    { 0x2CE7, "doimmediateragdolldeath" },
    { 0x2CE8, "doingadditivepain" },
    { 0x2CE9, "doingfinalkillcamfx" },
    { 0x2CEA, "doinglongdeath" },
    { 0x2CEB, "doingreacquirestep" },
    { 0x2CEC, "doingsplash" },
    { 0x2CED, "dolastminuteexposedapproach" },
    { 0x2CEE, "dolastminuteexposedapproachwrapper" },
    { 0x2CEF, "dolookatidle" },
    { 0x2CF0, "dom" },
    { 0x2CF1, "dom_b_move" },
    { 0x2CF2, "dom_flag_data" },
    { 0x2CF3, "domcaptureevent" },
    { 0x2CF4, "domcapturetime" },
    { 0x2CF5, "dome" },
    { 0x2CF6, "domeleedamage" },
    { 0x2CF7, "domeleevsai" },
    { 0x2CF8, "domeleevsai_simple" },
    { 0x2CF9, "domeleevsai_simple_animcustom" },
    { 0x2CFA, "domeleevsai_simple_animcustom_cleanup" },
    { 0x2CFB, "domeleevsdog" },
    { 0x2CFC, "domflags" },
    { 0x2CFD, "domino_hoodoos" },
    { 0x2CFE, "domissioncallback" },
    { 0x2CFF, "domneutralizeevent" },
    { 0x2D00, "dompointa" },
    { 0x2D01, "dompointb" },
    { 0x2D02, "dompointc" },
    { 0x2D03, "dompointnumber" },
    { 0x2D04, "domroundstarttime" },
    { 0x2D05, "done_flushing" },
    { 0x2D06, "doninebang" },
    { 0x2D07, "donodeexitanimation" },
    { 0x2D08, "dononattackcoverbehavior" },
    { 0x2D09, "donotetracks" },
    { 0x2D0A, "donotetracksforever" },
    { 0x2D0B, "donotetracksforeverintercept" },
    { 0x2D0C, "donotetracksforeverproc" },
    { 0x2D0D, "donotetracksforpopup" },
    { 0x2D0E, "donotetracksfortime" },
    { 0x2D0F, "donotetracksfortimeendnotify" },
    { 0x2D10, "donotetracksfortimeintercept" },
    { 0x2D11, "donotetracksfortimeout" },
    { 0x2D12, "donotetracksfortimeproc" },
    { 0x2D13, "donotetracksintercept" },
    { 0x2D14, "donotetrackspostcallback" },
    { 0x2D15, "donotetrackspostcallbackwithendon" },
    { 0x2D16, "donotetrackswithendon" },
    { 0x2D17, "donotetrackswithtimeout" },
    { 0x2D18, "donothingfunc" },
    { 0x2D19, "donottrackgamesplayed" },
    { 0x2D1A, "dont_allow_ammo_cache" },
    { 0x2D1B, "dont_animate_basement_door_on_death" },
    { 0x2D1C, "dont_animate_on_kva_death" },
    { 0x2D1D, "dont_auto_balance" },
    { 0x2D1E, "dont_auto_ride" },
    { 0x2D1F, "dont_break_anim" },
    { 0x2D20, "dont_clear_vehicle_anim" },
    { 0x2D21, "dont_delete_grenades_on_next_spawn" },
    { 0x2D22, "dont_delete_mines_on_next_spawn" },
    { 0x2D23, "dont_finish_death" },
    { 0x2D24, "dont_give_or_take_weapon" },
    { 0x2D25, "dont_plant_until_time" },
    { 0x2D26, "dont_shoot_warning_vo" },
    { 0x2D27, "dont_shoot_warning_vo_player_thread" },
    { 0x2D28, "dont_shoot_warning_vo_setup" },
    { 0x2D29, "dont_spawn_over_obstacles" },
    { 0x2D2A, "dont_tread_on_me" },
    { 0x2D2B, "dont_unlink_after_breach" },
    { 0x2D2C, "dont_unlink_ragdoll" },
    { 0x2D2D, "dontallowexplode" },
    { 0x2D2E, "dontattackme" },
    { 0x2D2F, "dontchangemoveplaybackrate" },
    { 0x2D30, "dontchangepushplayer" },
    { 0x2D31, "dontcolormove" },
    { 0x2D32, "dontcrouchtime" },
    { 0x2D33, "dontdisconnectpaths" },
    { 0x2D34, "dontdonotetracks" },
    { 0x2D35, "dontdrawoncompass" },
    { 0x2D36, "dontdropweapon" },
    { 0x2D37, "dontevershoot" },
    { 0x2D38, "dontfreeme" },
    { 0x2D39, "dontgetonpath" },
    { 0x2D3A, "dontgiveuponsuppressionyet" },
    { 0x2D3B, "dontmelee" },
    { 0x2D3C, "dontshoot" },
    { 0x2D3D, "dontshootstraight" },
    { 0x2D3E, "dontshootwhilemoving" },
    { 0x2D3F, "dontunloadondeath" },
    { 0x2D40, "dontunloadonend" },
    { 0x2D41, "dontwaitforpathend" },
    { 0x2D42, "donuke" },
    { 0x2D43, "door" },
    { 0x2D44, "door_breach" },
    { 0x2D45, "door_clip" },
    { 0x2D46, "door_close" },
    { 0x2D47, "door_connectpaths" },
    { 0x2D48, "door_fall_over" },
    { 0x2D49, "door_init" },
    { 0x2D4A, "door_irons_reveal_open" },
    { 0x2D4B, "door_kick_smoke" },
    { 0x2D4C, "door_lower" },
    { 0x2D4D, "door_model" },
    { 0x2D4E, "door_num" },
    { 0x2D4F, "door_open" },
    { 0x2D50, "door_open_blue" },
    { 0x2D51, "door_open_bounce" },
    { 0x2D52, "door_open_bounce_face" },
    { 0x2D53, "door_punch_flinches" },
    { 0x2D54, "door_raise" },
    { 0x2D55, "door_setup" },
    { 0x2D56, "door_shield_think" },
    { 0x2D57, "door_state_health" },
    { 0x2D58, "door_tag" },
    { 0x2D59, "door_takedown" },
    { 0x2D5A, "door_takedown_door" },
    { 0x2D5B, "door_thrown" },
    { 0x2D5C, "door_volume" },
    { 0x2D5D, "door_volume_array" },
    { 0x2D5E, "door2courtyard_open" },
    { 0x2D5F, "doorangle" },
    { 0x2D60, "doorclose" },
    { 0x2D61, "doorent" },
    { 0x2D62, "doorenter" },
    { 0x2D63, "doorenter_enable_cqbwalk" },
    { 0x2D64, "doorenter_trygrenade" },
    { 0x2D65, "doorenterexitcheck" },
    { 0x2D66, "doorexit" },
    { 0x2D67, "doorexit_disable_cqbwalk" },
    { 0x2D68, "doorflashchance" },
    { 0x2D69, "doorfragchance" },
    { 0x2D6A, "doornum" },
    { 0x2D6B, "dooropen" },
    { 0x2D6C, "doors" },
    { 0x2D6D, "doors_intialize" },
    { 0x2D6E, "doorshield_ripoff" },
    { 0x2D6F, "doorshield_throw" },
    { 0x2D70, "doortype" },
    { 0x2D71, "dopain" },
    { 0x2D72, "dopainfromarray" },
    { 0x2D73, "dopickyautosavechecks" },
    { 0x2D74, "dopplerize_suv_drive_up" },
    { 0x2D75, "dopplerize_train" },
    { 0x2D76, "doprematch" },
    { 0x2D77, "doproximityalarm" },
    { 0x2D78, "doquickmessage" },
    { 0x2D79, "doreload" },
    { 0x2D7A, "doreloadanim" },
    { 0x2D7B, "dosharpturn" },
    { 0x2D7C, "doshoot" },
    { 0x2D7D, "doshoottuned" },
    { 0x2D7E, "doslide" },
    { 0x2D7F, "dosound" },
    { 0x2D80, "dosounddistant" },
    { 0x2D81, "dospecialidle" },
    { 0x2D82, "dostandardkill" },
    { 0x2D83, "dot" },
    { 0x2D84, "dot_group" },
    { 0x2D85, "dothreatcalloutresponse" },
    { 0x2D86, "dotlimitmax" },
    { 0x2D87, "dotlimitmin" },
    { 0x2D88, "dotlimittagfwd" },
    { 0x2D89, "dotraverse" },
    { 0x2D8A, "dotraversegravity" },
    { 0x2D8B, "doturn" },
    { 0x2D8C, "doturnnotetracks" },
    { 0x2D8D, "doturretdeatheffects" },
    { 0x2D8E, "dotypelimit" },
    { 0x2D8F, "double_grenades_allowed" },
    { 0x2D90, "dovariablelengthtraverse" },
    { 0x2D91, "dowalkanim" },
    { 0x2D92, "dowalkanimoverride" },
    { 0x2D93, "down_arrow" },
    { 0x2D94, "down_part2_proc_ran" },
    { 0x2D95, "down_pos" },
    { 0x2D96, "downtown_ambient_guys" },
    { 0x2D97, "dpad_icon_col" },
    { 0x2D98, "drag_amount" },
    { 0x2D99, "drag_fade_in" },
    { 0x2D9A, "drag_fade_out" },
    { 0x2D9B, "drag_player_from_current_position" },
    { 0x2D9C, "drag_player_from_start_to_end" },
    { 0x2D9D, "drag_player_internal" },
    { 0x2D9E, "drag_player_until_time_or_pos" },
    { 0x2D9F, "drag_scene_begin" },
    { 0x2DA0, "dragging" },
    { 0x2DA1, "dragtaguntildeath" },
    { 0x2DA2, "draw_arrow" },
    { 0x2DA3, "draw_arrow_time" },
    { 0x2DA4, "draw_axis" },
    { 0x2DA5, "draw_circle_for_time" },
    { 0x2DA6, "draw_circle_lines_for_time" },
    { 0x2DA7, "draw_circle_lines_until_notify" },
    { 0x2DA8, "draw_circle_until_notify" },
    { 0x2DA9, "draw_code_move_info" },
    { 0x2DAA, "draw_col_vol" },
    { 0x2DAB, "draw_color_friendlies" },
    { 0x2DAC, "draw_colored_nodes" },
    { 0x2DAD, "draw_colornodes" },
    { 0x2DAE, "draw_cross" },
    { 0x2DAF, "draw_crosshair" },
    { 0x2DB0, "draw_debug" },
    { 0x2DB1, "draw_debug_sphere" },
    { 0x2DB2, "draw_distance" },
    { 0x2DB3, "draw_distance_line" },
    { 0x2DB4, "draw_dot_for_ent" },
    { 0x2DB5, "draw_dot_for_guy" },
    { 0x2DB6, "draw_effects_list" },
    { 0x2DB7, "draw_entity_bounds" },
    { 0x2DB8, "draw_final_line" },
    { 0x2DB9, "draw_help_list" },
    { 0x2DBA, "draw_line" },
    { 0x2DBB, "draw_line_for_time" },
    { 0x2DBC, "draw_line_from_ent_for_time" },
    { 0x2DBD, "draw_line_from_ent_to_ent_for_time" },
    { 0x2DBE, "draw_line_from_ent_to_ent_until_notify" },
    { 0x2DBF, "draw_line_from_ent_to_vec_for_time" },
    { 0x2DC0, "draw_line_from_self_to_origin" },
    { 0x2DC1, "draw_line_to_ent_for_time" },
    { 0x2DC2, "draw_line_until_notify" },
    { 0x2DC3, "draw_missile_target_line" },
    { 0x2DC4, "draw_point" },
    { 0x2DC5, "draw_radial_button" },
    { 0x2DC6, "draw_radial_buttons" },
    { 0x2DC7, "draw_scanner_cone" },
    { 0x2DC8, "draw_scanner_cone_loop" },
    { 0x2DC9, "draw_spawn_until_notify" },
    { 0x2DCA, "draw_tactics_lines" },
    { 0x2DCB, "draw_text_hud" },
    { 0x2DCC, "draw_text_hud_objective" },
    { 0x2DCD, "draw_text_hud_tool" },
    { 0x2DCE, "draw_trail" },
    { 0x2DCF, "draw_trigger" },
    { 0x2DD0, "draw_vehicle_node_triggered" },
    { 0x2DD1, "draw_volume" },
    { 0x2DD2, "drawapproachvec" },
    { 0x2DD3, "drawarrow" },
    { 0x2DD4, "drawarrowforever" },
    { 0x2DD5, "drawbcdirections" },
    { 0x2DD6, "drawbcobject" },
    { 0x2DD7, "drawchopperattackarrow" },
    { 0x2DD8, "drawenttag" },
    { 0x2DD9, "drawforwardforever" },
    { 0x2DDA, "drawfriend" },
    { 0x2DDB, "drawing_warzone_hud" },
    { 0x2DDC, "drawline" },
    { 0x2DDD, "drawminimapbounds" },
    { 0x2DDE, "drawn" },
    { 0x2DDF, "drawnode" },
    { 0x2DE0, "drawoffset" },
    { 0x2DE1, "draworgforever" },
    { 0x2DE2, "draworiginforever" },
    { 0x2DE3, "drawplayerlookatdebug" },
    { 0x2DE4, "drawplayerviewforever" },
    { 0x2DE5, "drawsniperdebug" },
    { 0x2DE6, "drawsphere" },
    { 0x2DE7, "drawspine" },
    { 0x2DE8, "drawstring" },
    { 0x2DE9, "drawstringtime" },
    { 0x2DEA, "drawtag" },
    { 0x2DEB, "drawtagforever" },
    { 0x2DEC, "drawtagtrails" },
    { 0x2DED, "drawusers" },
    { 0x2DEE, "drawvec" },
    { 0x2DEF, "drill_damage_fx" },
    { 0x2DF0, "drill_dust_fx" },
    { 0x2DF1, "drilling_animation" },
    { 0x2DF2, "drive" },
    { 0x2DF3, "drive_anim_add_idle" },
    { 0x2DF4, "drive_anim_centering" },
    { 0x2DF5, "drive_anim_jump_to_time" },
    { 0x2DF6, "drive_anim_name" },
    { 0x2DF7, "drive_cam_accel" },
    { 0x2DF8, "drive_cam_anim_accel" },
    { 0x2DF9, "drive_cam_anim_name" },
    { 0x2DFA, "drive_cam_centering" },
    { 0x2DFB, "drive_cam_vel" },
    { 0x2DFC, "drive_cam_yaw_sign" },
    { 0x2DFD, "drive_cover" },
    { 0x2DFE, "drive_crash_suv" },
    { 0x2DFF, "drive_free_path_func" },
    { 0x2E00, "drive_in_dialogue" },
    { 0x2E01, "drive_in_done" },
    { 0x2E02, "drive_in_mech_checkpoint_dialogue" },
    { 0x2E03, "drive_speed" },
    { 0x2E04, "drive_yaw_sign" },
    { 0x2E05, "drivenanimupdate" },
    { 0x2E06, "drivenmovemode" },
    { 0x2E07, "driver" },
    { 0x2E08, "driver_idle_speed" },
    { 0x2E09, "driver_shooting" },
    { 0x2E0A, "driverdead" },
    { 0x2E0B, "driveway_car" },
    { 0x2E0C, "driveway_car_1" },
    { 0x2E0D, "driveway_car_1_civilian_setup" },
    { 0x2E0E, "driveway_car_2" },
    { 0x2E0F, "driveway_car_2_civilian_setup" },
    { 0x2E10, "driveway_car_cleanup" },
    { 0x2E11, "driveway_car_cleanup_fx" },
    { 0x2E12, "driveway_civilian_cleanup" },
    { 0x2E13, "driveway_guard_anim" },
    { 0x2E14, "driveway_guard_left" },
    { 0x2E15, "driveway_guard_right" },
    { 0x2E16, "driveway_guard_setup" },
    { 0x2E17, "driveway_guard_watch_for_alert" },
    { 0x2E18, "driveway_monster_clip" },
    { 0x2E19, "driving_hovertank" },
    { 0x2E1A, "driving_section_save" },
    { 0x2E1B, "drivingvehicle" },
    { 0x2E1C, "drivingvehicleandturret" },
    { 0x2E1D, "drone" },
    { 0x2E1E, "drone_abort_monitor" },
    { 0x2E1F, "drone_abort_path" },
    { 0x2E20, "drone_active_thread" },
    { 0x2E21, "drone_air_spaces" },
    { 0x2E22, "drone_alert_sight" },
    { 0x2E23, "drone_alert_sight_can_see" },
    { 0x2E24, "drone_alert_sight_check" },
    { 0x2E25, "drone_anims" },
    { 0x2E26, "drone_archetype_custom_idle_base" },
    { 0x2E27, "drone_archetype_custom_idles" },
    { 0x2E28, "drone_archetype_idle_internal" },
    { 0x2E29, "drone_array_handling" },
    { 0x2E2A, "drone_attack_nodes" },
    { 0x2E2B, "drone_bullet" },
    { 0x2E2C, "drone_cam_timer" },
    { 0x2E2D, "drone_car_exploders" },
    { 0x2E2E, "drone_cinematic" },
    { 0x2E2F, "drone_civ_02_flee" },
    { 0x2E30, "drone_claim_node" },
    { 0x2E31, "drone_cloak_off" },
    { 0x2E32, "drone_closest" },
    { 0x2E33, "drone_cloud_controllable" },
    { 0x2E34, "drone_cloud_formation_circle" },
    { 0x2E35, "drone_cloud_formation_circle_player" },
    { 0x2E36, "drone_combat" },
    { 0x2E37, "drone_control" },
    { 0x2E38, "drone_control_pad" },
    { 0x2E39, "drone_control_pad_end" },
    { 0x2E3A, "drone_corpse_monitor" },
    { 0x2E3B, "drone_damage_monitor" },
    { 0x2E3C, "drone_dead" },
    { 0x2E3D, "drone_death_handler" },
    { 0x2E3E, "drone_death_thread" },
    { 0x2E3F, "drone_deathspin" },
    { 0x2E40, "drone_deer_spot_light" },
    { 0x2E41, "drone_delete_at_goal" },
    { 0x2E42, "drone_delete_on_unload" },
    { 0x2E43, "drone_detect" },
    { 0x2E44, "drone_dialog" },
    { 0x2E45, "drone_die_random" },
    { 0x2E46, "drone_drop_real_weapon_on_death" },
    { 0x2E47, "drone_emp_crash_movement" },
    { 0x2E48, "drone_enabled_animation" },
    { 0x2E49, "drone_exit" },
    { 0x2E4A, "drone_explo" },
    { 0x2E4B, "drone_explode" },
    { 0x2E4C, "drone_female_02_flee" },
    { 0x2E4D, "drone_fight" },
    { 0x2E4E, "drone_find_ground" },
    { 0x2E4F, "drone_fire_at_ent_cleanup" },
    { 0x2E50, "drone_fire_at_turret" },
    { 0x2E51, "drone_fire_queue" },
    { 0x2E52, "drone_fire_randomly" },
    { 0x2E53, "drone_fire_timing" },
    { 0x2E54, "drone_firing" },
    { 0x2E55, "drone_fly_away" },
    { 0x2E56, "drone_flyin_vm" },
    { 0x2E57, "drone_fx" },
    { 0x2E58, "drone_get_final_target_node" },
    { 0x2E59, "drone_get_goal_loc_with_arrival" },
    { 0x2E5A, "drone_getlerpfraction" },
    { 0x2E5B, "drone_give_soul" },
    { 0x2E5C, "drone_guy_down_dialogue" },
    { 0x2E5D, "drone_holo_on" },
    { 0x2E5E, "drone_hud_targets" },
    { 0x2E5F, "drone_idle" },
    { 0x2E60, "drone_idle_custom" },
    { 0x2E61, "drone_idle_override" },
    { 0x2E62, "drone_incoming_vo" },
    { 0x2E63, "drone_incoming_vo_setup" },
    { 0x2E64, "drone_init" },
    { 0x2E65, "drone_init_path" },
    { 0x2E66, "drone_intro" },
    { 0x2E67, "drone_intro_anim_length" },
    { 0x2E68, "drone_intro_conf_flythrough_actors" },
    { 0x2E69, "drone_intro_conf_room_scene" },
    { 0x2E6A, "drone_intro_execution_gun_flash" },
    { 0x2E6B, "drone_intro_fov_shift" },
    { 0x2E6C, "drone_intro_fov_shift_off" },
    { 0x2E6D, "drone_intro_fov_shift_on" },
    { 0x2E6E, "drone_intro_kva_front_setup" },
    { 0x2E6F, "drone_intro_nig_mil_setup" },
    { 0x2E70, "drone_investigate" },
    { 0x2E71, "drone_investigate_cleanup" },
    { 0x2E72, "drone_investigate_find_spots" },
    { 0x2E73, "drone_investigate_initiate" },
    { 0x2E74, "drone_investigate_monitor" },
    { 0x2E75, "drone_investigate_scan" },
    { 0x2E76, "drone_investigate_scan_tag_think" },
    { 0x2E77, "drone_investigate_spot" },
    { 0x2E78, "drone_investigate_thread" },
    { 0x2E79, "drone_investigate_trigger" },
    { 0x2E7A, "drone_investigate_triggers_main" },
    { 0x2E7B, "drone_investigate_try_location" },
    { 0x2E7C, "drone_investigate_visit_player_from" },
    { 0x2E7D, "drone_investigate_yaw" },
    { 0x2E7E, "drone_investigates" },
    { 0x2E7F, "drone_investigating_has_happened_once" },
    { 0x2E80, "drone_is_target" },
    { 0x2E81, "drone_kamikaze_hit_player" },
    { 0x2E82, "drone_kamikaze_player" },
    { 0x2E83, "drone_kamikaze_player_evil_style" },
    { 0x2E84, "drone_lerp_to_position" },
    { 0x2E85, "drone_lighting" },
    { 0x2E86, "drone_locked_heli_target" },
    { 0x2E87, "drone_locked_special_target" },
    { 0x2E88, "drone_locked_targets" },
    { 0x2E89, "drone_lockon_icons" },
    { 0x2E8A, "drone_lockon_missile_fire" },
    { 0x2E8B, "drone_look_ahead_point" },
    { 0x2E8C, "drone_look_at_entity" },
    { 0x2E8D, "drone_lookahead_value" },
    { 0x2E8E, "drone_lookat_ent" },
    { 0x2E8F, "drone_loop_custom" },
    { 0x2E90, "drone_loop_override" },
    { 0x2E91, "drone_magic_bullets" },
    { 0x2E92, "drone_missile_init" },
    { 0x2E93, "drone_missile_loop" },
    { 0x2E94, "drone_missile_make" },
    { 0x2E95, "drone_mode_population" },
    { 0x2E96, "drone_monitor_damage_shield" },
    { 0x2E97, "drone_monitor_player_aim" },
    { 0x2E98, "drone_move" },
    { 0x2E99, "drone_move_callback" },
    { 0x2E9A, "drone_move_time" },
    { 0x2E9B, "drone_move_z" },
    { 0x2E9C, "drone_moveto_ent" },
    { 0x2E9D, "drone_node_claimed_by_other" },
    { 0x2E9E, "drone_panic_delete" },
    { 0x2E9F, "drone_panic_spawn" },
    { 0x2EA0, "drone_parm" },
    { 0x2EA1, "drone_paths" },
    { 0x2EA2, "drone_play_looping_anim" },
    { 0x2EA3, "drone_play_scripted_anim" },
    { 0x2EA4, "drone_play_weapon_sound" },
    { 0x2EA5, "drone_pod" },
    { 0x2EA6, "drone_random_vocalizations" },
    { 0x2EA7, "drone_range_target_manage_hit" },
    { 0x2EA8, "drone_really_hit" },
    { 0x2EA9, "drone_relocating" },
    { 0x2EAA, "drone_respawn" },
    { 0x2EAB, "drone_return_home" },
    { 0x2EAC, "drone_run_number" },
    { 0x2EAD, "drone_run_speed" },
    { 0x2EAE, "drone_scan" },
    { 0x2EAF, "drone_scan_civilian_setup" },
    { 0x2EB0, "drone_search_light_fx" },
    { 0x2EB1, "drone_secure_zone" },
    { 0x2EB2, "drone_security_bays_open" },
    { 0x2EB3, "drone_security_prepare_attack" },
    { 0x2EB4, "drone_security_prepare_attack_relay" },
    { 0x2EB5, "drone_security_prepare_patrol" },
    { 0x2EB6, "drone_security_scan_tag_audio" },
    { 0x2EB7, "drone_security_scan_tag_cleanup" },
    { 0x2EB8, "drone_security_thrust_fx" },
    { 0x2EB9, "drone_security_thrust_fx_cleanup" },
    { 0x2EBA, "drone_set_archetype_idle" },
    { 0x2EBB, "drone_set_mode" },
    { 0x2EBC, "drone_setup_before_emp" },
    { 0x2EBD, "drone_shoot" },
    { 0x2EBE, "drone_shoot_at_ent" },
    { 0x2EBF, "drone_shoot_down" },
    { 0x2EC0, "drone_shoot_fx" },
    { 0x2EC1, "drone_spawn" },
    { 0x2EC2, "drone_spawn_and_drive" },
    { 0x2EC3, "drone_spawn_func" },
    { 0x2EC4, "drone_spawn_single_struct" },
    { 0x2EC5, "drone_spawner_get_height" },
    { 0x2EC6, "drone_spawners" },
    { 0x2EC7, "drone_spin_monitor" },
    { 0x2EC8, "drone_spot_light" },
    { 0x2EC9, "drone_start_player_input" },
    { 0x2ECA, "drone_stealth_display_seed_always" },
    { 0x2ECB, "drone_stopthrustereffects" },
    { 0x2ECC, "drone_street_allies" },
    { 0x2ECD, "drone_street_fight_enemy_func" },
    { 0x2ECE, "drone_street_lights" },
    { 0x2ECF, "drone_swarm_init" },
    { 0x2ED0, "drone_swarm_kamikaze_attack_player" },
    { 0x2ED1, "drone_swarm_kamikaze_explode" },
    { 0x2ED2, "drone_swarm_kamikaze_seek_player" },
    { 0x2ED3, "drone_swarm_kamikaze_set_attack_vars" },
    { 0x2ED4, "drone_swarm_kamikaze_set_goal" },
    { 0x2ED5, "drone_swarm_move_change_path_on_trigger" },
    { 0x2ED6, "drone_swarm_queen" },
    { 0x2ED7, "drone_swarm_queens" },
    { 0x2ED8, "drone_swarm_start_kamikaze_attack" },
    { 0x2ED9, "drone_tactical_picker_data" },
    { 0x2EDA, "drone_target" },
    { 0x2EDB, "drone_target_center" },
    { 0x2EDC, "drone_targets" },
    { 0x2EDD, "drone_test_point" },
    { 0x2EDE, "drone_test_points" },
    { 0x2EDF, "drone_test_tag" },
    { 0x2EE0, "drone_thermal_draw_disable" },
    { 0x2EE1, "drone_threat_data" },
    { 0x2EE2, "drone_thrusterfx" },
    { 0x2EE3, "drone_thrusterfx_bottom_threaded" },
    { 0x2EE4, "drone_thrusterfx_side_threaded" },
    { 0x2EE5, "drone_thrusterfxexplosive" },
    { 0x2EE6, "drone_thrusterplayer" },
    { 0x2EE7, "drone_thrusterplayerconnected" },
    { 0x2EE8, "drone_track_player" },
    { 0x2EE9, "drone_travel_time" },
    { 0x2EEA, "drone_turn" },
    { 0x2EEB, "drone_turret_fake_death_awesome" },
    { 0x2EEC, "drone_validate_node" },
    { 0x2EED, "drone_validate_path_to" },
    { 0x2EEE, "drone_view_shake" },
    { 0x2EEF, "drone_vs_turret_monitor_damage" },
    { 0x2EF0, "drone_wait_for_attack" },
    { 0x2EF1, "drone_wait_for_death" },
    { 0x2EF2, "drone_wait_move" },
    { 0x2EF3, "drone_waittill_goal" },
    { 0x2EF4, "drone_walker_pos" },
    { 0x2EF5, "drone_warning_given" },
    { 0x2EF6, "drone_warning_vo" },
    { 0x2EF7, "drone_was_hit" },
    { 0x2EF8, "droneaddtogloballist" },
    { 0x2EF9, "droneangularvelocity" },
    { 0x2EFA, "droneanim" },
    { 0x2EFB, "dronebombsquadmesh" },
    { 0x2EFC, "dronebounceheight" },
    { 0x2EFD, "dronecallbackthread" },
    { 0x2EFE, "dronecleanup" },
    { 0x2EFF, "dronecloakactivated" },
    { 0x2F00, "dronecloakcooldown" },
    { 0x2F01, "dronecloakdeactivateddialog" },
    { 0x2F02, "dronecloakingtransition" },
    { 0x2F03, "dronecloakready" },
    { 0x2F04, "dronecloakwaitforexit" },
    { 0x2F05, "dronecontrolobjdisplay" },
    { 0x2F06, "dronecontrolpadscreentouch" },
    { 0x2F07, "dronecrate_hud" },
    { 0x2F08, "dronedeploystance" },
    { 0x2F09, "dronedraftplants" },
    { 0x2F0A, "droneexplosionfx" },
    { 0x2F0B, "dronefailed" },
    { 0x2F0C, "dronefireatscriptedtarget" },
    { 0x2F0D, "droneflyinshooting" },
    { 0x2F0E, "dronegetspawnpoint" },
    { 0x2F0F, "dronehealth" },
    { 0x2F10, "dronehoverdirection" },
    { 0x2F11, "dronehud" },
    { 0x2F12, "dronehudfx" },
    { 0x2F13, "droneinitcloakomnvars" },
    { 0x2F14, "droneiscloaked" },
    { 0x2F15, "dronekills" },
    { 0x2F16, "dronelightset" },
    { 0x2F17, "dronemesh" },
    { 0x2F18, "dronemonitordamagewhilecloaking" },
    { 0x2F19, "dronepath" },
    { 0x2F1A, "dronerangeleaderboard" },
    { 0x2F1B, "droneremovefromgloballist" },
    { 0x2F1C, "dronerunoffset" },
    { 0x2F1D, "drones" },
    { 0x2F1E, "drones_attack_walker_turret" },
    { 0x2F1F, "drones_can_see_enemy_test" },
    { 0x2F20, "drones_have_shot_at_player" },
    { 0x2F21, "drones_logging_road" },
    { 0x2F22, "drones_lost_player_time" },
    { 0x2F23, "drones_s2_dead" },
    { 0x2F24, "drones_s2_end" },
    { 0x2F25, "drones_sent_vo" },
    { 0x2F26, "drones_stealth_detect" },
    { 0x2F27, "drones_targets_sets_to_default" },
    { 0x2F28, "drones_vs_car_shield" },
    { 0x2F29, "dronesatgoal" },
    { 0x2F2A, "dronesattackspeedmultiplier" },
    { 0x2F2B, "dronesetupcloaking" },
    { 0x2F2C, "dronespawn" },
    { 0x2F2D, "dronespawn_bodyonly" },
    { 0x2F2E, "dronespawner_init" },
    { 0x2F2F, "dronespawnerexits" },
    { 0x2F30, "dronespawners" },
    { 0x2F31, "dronespawnertemplate" },
    { 0x2F32, "dronesthermalteamselect" },
    { 0x2F33, "dronestruct" },
    { 0x2F34, "droneswarmaudio" },
    { 0x2F35, "dronetag" },
    { 0x2F36, "dronetarget" },
    { 0x2F37, "dronetargetmove" },
    { 0x2F38, "droneturret" },
    { 0x2F39, "dronetype" },
    { 0x2F3A, "droneusetrigger" },
    { 0x2F3B, "droneverticalvelocity" },
    { 0x2F3C, "droneviewmodel" },
    { 0x2F3D, "droneviewstatic" },
    { 0x2F3E, "dronevignette" },
    { 0x2F3F, "dronevisionset" },
    { 0x2F40, "droneweapon" },
    { 0x2F41, "drop_bots" },
    { 0x2F42, "drop_down" },
    { 0x2F43, "drop_fx_count" },
    { 0x2F44, "drop_fx_thread" },
    { 0x2F45, "drop_gear" },
    { 0x2F46, "drop_health_timeout_thread" },
    { 0x2F47, "drop_health_trigger_think" },
    { 0x2F48, "drop_locator" },
    { 0x2F49, "drop_off_walker_bird" },
    { 0x2F4A, "drop_perch_ally" },
    { 0x2F4B, "drop_pod" },
    { 0x2F4C, "drop_pod_bad_places" },
    { 0x2F4D, "drop_pod_bad_spawn_overlay" },
    { 0x2F4E, "drop_pod_chooser" },
    { 0x2F4F, "drop_pod_chromatic_abberation" },
    { 0x2F50, "drop_pod_clip" },
    { 0x2F51, "drop_pod_dome" },
    { 0x2F52, "drop_pod_dome_ground" },
    { 0x2F53, "drop_pod_door_close" },
    { 0x2F54, "drop_pod_door_spark" },
    { 0x2F55, "drop_pod_effect" },
    { 0x2F56, "drop_pod_enemy_model" },
    { 0x2F57, "drop_pod_fall" },
    { 0x2F58, "drop_pod_falling_debris" },
    { 0x2F59, "drop_pod_fx_start" },
    { 0x2F5A, "drop_pod_ground_impact" },
    { 0x2F5B, "drop_pod_handledeath" },
    { 0x2F5C, "drop_pod_screen_bootup" },
    { 0x2F5D, "drop_pod_screen_chrome_abber" },
    { 0x2F5E, "drop_pod_screen_glitch_warning" },
    { 0x2F5F, "drop_pod_screen_off" },
    { 0x2F60, "drop_pod_screen_off_damage" },
    { 0x2F61, "drop_pod_screen_on" },
    { 0x2F62, "drop_pod_screen_on_warning" },
    { 0x2F63, "drop_pod_screen_shake" },
    { 0x2F64, "drop_pod_screen_shake_large" },
    { 0x2F65, "drop_pod_thrusters" },
    { 0x2F66, "drop_pod_volume_array" },
    { 0x2F67, "drop_pods" },
    { 0x2F68, "drop_point_to_ground" },
    { 0x2F69, "drop_selection_to_ground" },
    { 0x2F6A, "drop_started_status" },
    { 0x2F6B, "drop_thresholds" },
    { 0x2F6C, "drop_to_ground" },
    { 0x2F6D, "drop_turret" },
    { 0x2F6E, "dropaiweapon" },
    { 0x2F6F, "dropallaiweapons" },
    { 0x2F70, "dropanim" },
    { 0x2F71, "dropclipmodel" },
    { 0x2F72, "dropgrenade" },
    { 0x2F73, "droplocationindex" },
    { 0x2F74, "dropoff_goal_ang" },
    { 0x2F75, "dropoff_height" },
    { 0x2F76, "dropped" },
    { 0x2F77, "droppeddeathweapon" },
    { 0x2F78, "droppedweaponent" },
    { 0x2F79, "droppingtoground" },
    { 0x2F7A, "droppod_cleanupondisconnect" },
    { 0x2F7B, "droppod_cleanuponteamchange" },
    { 0x2F7C, "droppod_final_impact" },
    { 0x2F7D, "droppod_first_building_impact" },
    { 0x2F7E, "droppod_harness_left_1" },
    { 0x2F7F, "droppod_harness_left_2" },
    { 0x2F80, "droppod_harness_right_1" },
    { 0x2F81, "droppod_harness_right_2" },
    { 0x2F82, "droppod_intro_blimp_explode" },
    { 0x2F83, "droppod_intro_blimp_missile" },
    { 0x2F84, "droppod_intro_missile_hit_pod" },
    { 0x2F85, "droppod_intro_radio_duck" },
    { 0x2F86, "droppod_lt_spinout" },
    { 0x2F87, "droppod_main" },
    { 0x2F88, "droppod_main_pod_jets" },
    { 0x2F89, "droppod_phase_2b_begin" },
    { 0x2F8A, "droppod_rt_spinout" },
    { 0x2F8B, "droppodbadspawndeathfx" },
    { 0x2F8C, "droppodbaseunfold" },
    { 0x2F8D, "droppodforcerespawn" },
    { 0x2F8E, "droppodspikeimpacts" },
    { 0x2F8F, "droppodtrophykill" },
    { 0x2F90, "droppodtrophysystem" },
    { 0x2F91, "droppoint" },
    { 0x2F92, "droppostoground" },
    { 0x2F93, "dropscavengerfordeath" },
    { 0x2F94, "dropshieldinplace" },
    { 0x2F95, "dropsite" },
    { 0x2F96, "dropsitetrace" },
    { 0x2F97, "droptime" },
    { 0x2F98, "droptimeout" },
    { 0x2F99, "dropturret" },
    { 0x2F9A, "dropturretproc" },
    { 0x2F9B, "droptype" },
    { 0x2F9C, "dropweaponfordeath" },
    { 0x2F9D, "dropweaponfordeathhorde" },
    { 0x2F9E, "dropweaponwrapper" },
    { 0x2F9F, "drowning_damage" },
    { 0x2FA0, "drowning_deadquote" },
    { 0x2FA1, "drowning_warning" },
    { 0x2FA2, "drs_ahead_test" },
    { 0x2FA3, "dry_fire" },
    { 0x2FA4, "dryerfan" },
    { 0x2FA5, "dryerfanrotatevelocity" },
    { 0x2FA6, "drylevel" },
    { 0x2FA7, "drymachine" },
    { 0x2FA8, "dshk_death_anim" },
    { 0x2FA9, "dshk_player_anims" },
    { 0x2FAA, "dshk_shelleject_fx" },
    { 0x2FAB, "dshk_shells" },
    { 0x2FAC, "dshk_turret_disable" },
    { 0x2FAD, "dshk_turret_init" },
    { 0x2FAE, "dshk_turrets" },
    { 0x2FAF, "dshk_viewmodel" },
    { 0x2FB0, "dsp_bus" },
    { 0x2FB1, "dsp_buses" },
    { 0x2FB2, "dt" },
    { 0x2FB3, "dual_firing" },
    { 0x2FB4, "duck_alias_" },
    { 0x2FB5, "duck_amount" },
    { 0x2FB6, "duck_dist_threshold_" },
    { 0x2FB7, "duck_env_name" },
    { 0x2FB8, "duck_moving_truck_drive" },
    { 0x2FB9, "duck_once" },
    { 0x2FBA, "duck_starts" },
    { 0x2FBB, "duck_stops" },
    { 0x2FBC, "duck_time" },
    { 0x2FBD, "ducked_instances" },
    { 0x2FBE, "duckidle" },
    { 0x2FBF, "duckidleoccurrence" },
    { 0x2FC0, "duckin" },
    { 0x2FC1, "ducking" },
    { 0x2FC2, "duckout" },
    { 0x2FC3, "dummy_model" },
    { 0x2FC4, "dummy_mover" },
    { 0x2FC5, "dummy_player" },
    { 0x2FC6, "dummy_to_vehicle" },
    { 0x2FC7, "dummyspeed" },
    { 0x2FC8, "dummytarget" },
    { 0x2FC9, "dump_missing_anims" },
    { 0x2FCA, "dumpit" },
    { 0x2FCB, "dumpsettings" },
    { 0x2FCC, "dupe_hud" },
    { 0x2FCD, "dupe_style_hud" },
    { 0x2FCE, "dust_car_stop" },
    { 0x2FCF, "dust_falling_control_room" },
    { 0x2FD0, "dust_settle_squad_intro" },
    { 0x2FD1, "dvar" },
    { 0x2FD2, "dvarfloatvalue" },
    { 0x2FD3, "dvarintvalue" },
    { 0x2FD4, "g_dx" },
    { 0x2FD5, "dying" },
    { 0x2FD6, "dyingcrawl" },
    { 0x2FD7, "dyingcrawlaiming" },
    { 0x2FD8, "dyingcrawlbackaim" },
    { 0x2FD9, "dyingcrawlbloodsmear" },
    { 0x2FDA, "dyn_flickerlight" },
    { 0x2FDB, "dyn_motion_flickerlight" },
    { 0x2FDC, "dyn_sniff" },
    { 0x2FDD, "dyn_sniff_disable" },
    { 0x2FDE, "dyn_sniff_enable" },
    { 0x2FDF, "dynamic_boost_jump" },
    { 0x2FE0, "dynamic_dof" },
    { 0x2FE1, "dynamic_ents" },
    { 0x2FE2, "dynamic_event_happened" },
    { 0x2FE3, "dynamic_pathing_main" },
    { 0x2FE4, "dynamic_run_ahead_test" },
    { 0x2FE5, "dynamic_run_set" },
    { 0x2FE6, "dynamic_run_speed_dialogue" },
    { 0x2FE7, "dynamic_run_speed_proc" },
    { 0x2FE8, "dynamic_run_speed_stopped" },
    { 0x2FE9, "dynamicdistortion" },
    { 0x2FEA, "dynamicevent" },
    { 0x2FEB, "dynamicevent_init" },
    { 0x2FEC, "dynamicevent_init_sound" },
    { 0x2FED, "dynamiceventcount" },
    { 0x2FEE, "dynamiceventendfunc" },
    { 0x2FEF, "dynamiceventstartfunc" },
    { 0x2FF0, "dynamiceventstatus" },
    { 0x2FF1, "dynamiceventstype" },
    { 0x2FF2, "dynamichangarspawns" },
    { 0x2FF3, "dynamicpathblock" },
    { 0x2FF4, "dynamicpathrampswitch" },
    { 0x2FF5, "dynamicspawns" },
    { 0x2FF6, "dynamicturnscaling" },
    { 0x2FF7, "e" },
    { 0x2FF8, "e3_demo_clear_alarm" },
    { 0x2FF9, "e3_demo_clear_basement_footsteps" },
    { 0x2FFA, "e3_demo_fade_in" },
    { 0x2FFB, "e3_demo_fade_out" },
    { 0x2FFC, "e3_drone_swarm_strafe" },
    { 0x2FFD, "e3_end_logo" },
    { 0x2FFE, "e3_enemies" },
    { 0x2FFF, "e3_first_fight_in_building" },
    { 0x3000, "e3_handle_bus_top_enemies" },
    { 0x3001, "e3_handle_threat_detection" },
    { 0x3002, "e3_handle_threat_shooting" },
    { 0x3003, "e3_jump_down" },
    { 0x3004, "e3_presentation" },
    { 0x3005, "eaniment" },
    { 0x3006, "early_approach_guy" },
    { 0x3007, "early_level" },
    { 0x3008, "early_voices_around_corner" },
    { 0x3009, "early_weapon_enabled" },
    { 0x300A, "earlydetonate" },
    { 0x300B, "earned" },
    { 0x300C, "earned_dialog_col" },
    { 0x300D, "earned_hint_col" },
    { 0x300E, "earnedkillstreakevent" },
    { 0x300F, "earnedstreaklevel" },
    { 0x3010, "earnkillstreak" },
    { 0x3011, "earth_angles" },
    { 0x3012, "earth_tag" },
    { 0x3013, "earthquake" },
    { 0x3014, "earthquake_notify_stop" },
    { 0x3015, "ebreachmodel" },
    { 0x3016, "edge" },
    { 0x3017, "edi_anims" },
    { 0x3018, "edoor" },
    { 0x3019, "ee_rpg_fire" },
    { 0x301A, "eexploderorigin" },
    { 0x301B, "effect" },
    { 0x301C, "effect_list_current_size" },
    { 0x301D, "effect_list_offset" },
    { 0x301E, "effect_list_offset_max" },
    { 0x301F, "effect_loopsound" },
    { 0x3020, "effect_soundalias" },
    { 0x3021, "effectonplayerview" },
    { 0x3022, "effectonplayerviewent" },
    { 0x3023, "einflictor" },
    { 0x3024, "either_player_looking_at" },
    { 0x3025, "ejected" },
    { 0x3026, "elbow_l_org" },
    { 0x3027, "elbow_r_org" },
    { 0x3028, "elec_hub_01" },
    { 0x3029, "elemtype" },
    { 0x302A, "elev_ride" },
    { 0x302B, "elevation_to_target" },
    { 0x302C, "elevator" },
    { 0x302D, "elevator_accel" },
    { 0x302E, "elevator_aggressive_call" },
    { 0x302F, "elevator_arrival_wind_gust_fx" },
    { 0x3030, "elevator_ascend_fx" },
    { 0x3031, "elevator_bottom_enemies_setup" },
    { 0x3032, "elevator_bottom_enemies_waits" },
    { 0x3033, "elevator_cage_steam_fx" },
    { 0x3034, "elevator_call" },
    { 0x3035, "elevator_callbutton_link_h" },
    { 0x3036, "elevator_callbutton_link_v" },
    { 0x3037, "elevator_callbuttons" },
    { 0x3038, "elevator_clamps_spark_fx" },
    { 0x3039, "elevator_debug" },
    { 0x303A, "elevator_decel" },
    { 0x303B, "elevator_descend_spark_fx" },
    { 0x303C, "elevator_fall_dof_tweaks" },
    { 0x303D, "elevator_floor_update" },
    { 0x303E, "elevator_fsm" },
    { 0x303F, "elevator_get_dvar" },
    { 0x3040, "elevator_get_dvar_int" },
    { 0x3041, "elevator_innerdoorspeed" },
    { 0x3042, "elevator_interrupt" },
    { 0x3043, "elevator_interrupted" },
    { 0x3044, "elevator_mechanism_steam_fx" },
    { 0x3045, "elevator_motion_detection" },
    { 0x3046, "elevator_move" },
    { 0x3047, "elevator_music" },
    { 0x3048, "elevator_outer_vent_lights_fx" },
    { 0x3049, "elevator_outterdoorspeed" },
    { 0x304A, "elevator_push" },
    { 0x304B, "elevator_rain_off_fx" },
    { 0x304C, "elevator_rain_on_fx" },
    { 0x304D, "elevator_rappel_rig" },
    { 0x304E, "elevator_return" },
    { 0x304F, "elevator_ride_s1s2" },
    { 0x3050, "elevator_ride_s2s3" },
    { 0x3051, "elevator_rm_dripping_water_fx" },
    { 0x3052, "elevator_rumble" },
    { 0x3053, "elevator_shaft_fake_light_rays" },
    { 0x3054, "elevator_sound_think" },
    { 0x3055, "elevator_speed" },
    { 0x3056, "elevator_steam_off_fx" },
    { 0x3057, "elevator_steam_on_fx" },
    { 0x3058, "elevator_think" },
    { 0x3059, "elevator_top_enemies_setup" },
    { 0x305A, "elevator_top_enemies_waits" },
    { 0x305B, "elevator_update_global_dvars" },
    { 0x305C, "elevator_waittime" },
    { 0x305D, "elevator_wall_steam_rise_fx" },
    { 0x305E, "elevators" },
    { 0x305F, "eliminateplayerevent" },
    { 0x3060, "eliminatetagevent" },
    { 0x3061, "elite" },
    { 0x3062, "elm" },
    { 0x3063, "em1_heat_meter" },
    { 0x3064, "em1_heat_meter_off" },
    { 0x3065, "emergency_break_videolog" },
    { 0x3066, "emergency_siren_blasts" },
    { 0x3067, "emitfalldamage" },
    { 0x3068, "emitter_origin" },
    { 0x3069, "emp" },
    { 0x306A, "emp_artifacts" },
    { 0x306B, "emp_crash" },
    { 0x306C, "emp_death_function" },
    { 0x306D, "emp_device_obj" },
    { 0x306E, "emp_gettimeoutfrommodules" },
    { 0x306F, "emp_grenade_detonate" },
    { 0x3070, "emp_grenade_think" },
    { 0x3071, "emp_hide_hud" },
    { 0x3072, "emp_hits" },
    { 0x3073, "emp_jamplayers" },
    { 0x3074, "emp_jamteam" },
    { 0x3075, "emp_mode" },
    { 0x3076, "emp_notify_on_target_hit" },
    { 0x3077, "emp_playertracker" },
    { 0x3078, "emp_prompt_breakout" },
    { 0x3079, "emp_snake" },
    { 0x307A, "emp_use" },
    { 0x307B, "emp_vulnerable_list" },
    { 0x307C, "emp_wait_till_contact_or_timeout" },
    { 0x307D, "emp_wave" },
    { 0x307E, "empanim" },
    { 0x307F, "empassistpoints" },
    { 0x3080, "empduration" },
    { 0x3081, "empedtank" },
    { 0x3082, "empedwarbird" },
    { 0x3083, "empeffect" },
    { 0x3084, "empeffects" },
    { 0x3085, "empendtime" },
    { 0x3086, "empequipmentdisabled" },
    { 0x3087, "empexodisabled" },
    { 0x3088, "empexplodewaiter" },
    { 0x3089, "empfx" },
    { 0x308A, "empgrenaded" },
    { 0x308B, "empgrenadedeathwaiter" },
    { 0x308C, "empgrenadeexplode" },
    { 0x308D, "empon" },
    { 0x308E, "empowner" },
    { 0x308F, "empplayer" },
    { 0x3090, "empplayerffadisconnect" },
    { 0x3091, "emprumbleloop" },
    { 0x3092, "empscrambleid" },
    { 0x3093, "empstreaksdisabled" },
    { 0x3094, "emptimeremaining" },
    { 0x3095, "empty_func" },
    { 0x3096, "empty_init_func" },
    { 0x3097, "empty_kill_func" },
    { 0x3098, "empty_spawner" },
    { 0x3099, "emptymech" },
    { 0x309A, "enable_achievement_harder_they_fall" },
    { 0x309B, "enable_achievement_harder_they_fall_guy" },
    { 0x309C, "enable_ai_after_time" },
    { 0x309D, "enable_ai_color" },
    { 0x309E, "enable_ai_color_dontmove" },
    { 0x309F, "enable_ai_on_goal" },
    { 0x30A0, "enable_ai_shotgun_destructible_damage" },
    { 0x30A1, "enable_ai_swim" },
    { 0x30A2, "enable_aim_assist_on_script_model" },
    { 0x30A3, "enable_all_fixed_scanners" },
    { 0x30A4, "enable_arrivals" },
    { 0x30A5, "enable_auto_mix" },
    { 0x30A6, "enable_awareness" },
    { 0x30A7, "enable_blood_pool" },
    { 0x30A8, "enable_boost_attack" },
    { 0x30A9, "enable_boost_dash" },
    { 0x30AA, "enable_boost_hud" },
    { 0x30AB, "enable_boost_jump" },
    { 0x30AC, "enable_bulletwhizbyreaction" },
    { 0x30AD, "enable_careful" },
    { 0x30AE, "enable_casualkiller" },
    { 0x30AF, "enable_check_health" },
    { 0x30B0, "enable_cormack_follow" },
    { 0x30B1, "enable_cormack_obj" },
    { 0x30B2, "enable_cqb_squad" },
    { 0x30B3, "enable_cqbwalk" },
    { 0x30B4, "enable_creepwalk" },
    { 0x30B5, "enable_damagefeedback_hud" },
    { 0x30B6, "enable_damagefeedback_snd" },
    { 0x30B7, "enable_danger_react" },
    { 0x30B8, "enable_dog_control" },
    { 0x30B9, "enable_dog_kinect" },
    { 0x30BA, "enable_dog_sneak" },
    { 0x30BB, "enable_dog_sniff" },
    { 0x30BC, "enable_dog_walk" },
    { 0x30BD, "enable_dontevershoot" },
    { 0x30BE, "enable_doorway_blocking" },
    { 0x30BF, "enable_dynamic_run_speed" },
    { 0x30C0, "enable_exits" },
    { 0x30C1, "enable_exo_melee" },
    { 0x30C2, "enable_exoclimb_combat" },
    { 0x30C3, "enable_fall_damage" },
    { 0x30C4, "enable_features_exiting_cinema" },
    { 0x30C5, "enable_firing" },
    { 0x30C6, "enable_flashlight_callback" },
    { 0x30C7, "enable_free_path_think" },
    { 0x30C8, "enable_free_running" },
    { 0x30C9, "enable_global_vehicle_spawn_functions" },
    { 0x30CA, "enable_grenade_range_triggers" },
    { 0x30CB, "enable_grenades" },
    { 0x30CC, "enable_heat_behavior" },
    { 0x30CD, "enable_high_jump" },
    { 0x30CE, "enable_highway_path_player_side" },
    { 0x30CF, "enable_ignorerandombulletdamage_drone" },
    { 0x30D0, "enable_ir_beacon" },
    { 0x30D1, "enable_jump_jet_pathing" },
    { 0x30D2, "enable_long_death" },
    { 0x30D3, "enable_mech_chaingun" },
    { 0x30D4, "enable_mech_rocket" },
    { 0x30D5, "enable_mech_swarm" },
    { 0x30D6, "enable_mech_threat_ping" },
    { 0x30D7, "enable_militia_behavior" },
    { 0x30D8, "enable_motion_blur" },
    { 0x30D9, "enable_motion_blur_cooling_tower_explosions" },
    { 0x30DA, "enable_motion_blur_rotation" },
    { 0x30DB, "enable_my_thermal" },
    { 0x30DC, "enable_pain" },
    { 0x30DD, "enable_pain_will_irons_during_shopping_fight" },
    { 0x30DE, "enable_passive_weapons" },
    { 0x30DF, "enable_physical_dof" },
    { 0x30E0, "enable_physical_dof_binoculars_autofocus_loop" },
    { 0x30E1, "enable_physical_dof_car_door_shield" },
    { 0x30E2, "enable_physical_dof_fob_autofocus_loop" },
    { 0x30E3, "enable_physical_dof_hip" },
    { 0x30E4, "enable_physical_dof_hip_fob" },
    { 0x30E5, "enable_physical_dof_interest_of_time" },
    { 0x30E6, "enable_pitbull_shooting" },
    { 0x30E7, "enable_player_control" },
    { 0x30E8, "enable_player_controls" },
    { 0x30E9, "enable_player_swim" },
    { 0x30EA, "enable_player_swimming" },
    { 0x30EB, "enable_player_underwater_walk" },
    { 0x30EC, "enable_pod_door_clip" },
    { 0x30ED, "enable_react_on_unload" },
    { 0x30EE, "enable_readystand" },
    { 0x30EF, "enable_rocket_death" },
    { 0x30F0, "enable_s1_motionset" },
    { 0x30F1, "enable_school_trains" },
    { 0x30F2, "enable_shield_ability" },
    { 0x30F3, "enable_sonic_aoe" },
    { 0x30F4, "enable_sprint" },
    { 0x30F5, "enable_ssao_over_time" },
    { 0x30F6, "enable_stealth_for_ai" },
    { 0x30F7, "enable_stealth_smart_stance" },
    { 0x30F8, "enable_stealth_system" },
    { 0x30F9, "enable_stencil" },
    { 0x30FA, "enable_surprise" },
    { 0x30FB, "enable_swim" },
    { 0x30FC, "enable_takedown_hint" },
    { 0x30FD, "enable_teamflashbangimmunity" },
    { 0x30FE, "enable_teamflashbangimmunity_proc" },
    { 0x30FF, "enable_threat_grenade_response" },
    { 0x3100, "enable_threat_ping" },
    { 0x3101, "enable_tracking" },
    { 0x3102, "enable_trigger" },
    { 0x3103, "enable_trigger_with_noteworthy" },
    { 0x3104, "enable_trigger_with_targetname" },
    { 0x3105, "enable_turnanims" },
    { 0x3106, "enable_vol" },
    { 0x3107, "enable_weapon_pickup_wrapper" },
    { 0x3108, "enable_weapon_pickup_wrapper_internal" },
    { 0x3109, "enablealliescolor" },
    { 0x310A, "enableallstreaks" },
    { 0x310B, "enableawareness" },
    { 0x310C, "enablebattlechatter" },
    { 0x310D, "enableboost" },
    { 0x310E, "enablecloudsexploder" },
    { 0x310F, "enablecqb" },
    { 0x3110, "enabled" },
    { 0x3111, "enableexo" },
    { 0x3112, "enableextendedkill" },
    { 0x3113, "enablegloballyusablebytype" },
    { 0x3114, "enablekillstreakactionslots" },
    { 0x3115, "enablelaststandweapons" },
    { 0x3116, "enablemdao" },
    { 0x3117, "enableobject" },
    { 0x3118, "enableorbitalthermal" },
    { 0x3119, "enableplayerweapons" },
    { 0x311A, "enableragdolldeath" },
    { 0x311B, "enablerocketdeath" },
    { 0x311C, "enablesonicaoe" },
    { 0x311D, "enablesprint" },
    { 0x311E, "enableteamintel" },
    { 0x311F, "end" },
    { 0x3120, "end_ambulance_anim_early" },
    { 0x3121, "end_angle" },
    { 0x3122, "end_anim_loop" },
    { 0x3123, "end_anim_name" },
    { 0x3124, "end_cables" },
    { 0x3125, "end_change_fov" },
    { 0x3126, "end_chopper" },
    { 0x3127, "end_color" },
    { 0x3128, "end_cqb" },
    { 0x3129, "end_crate" },
    { 0x312A, "end_crate_clip" },
    { 0x312B, "end_credits_with_next_press" },
    { 0x312C, "end_drag_dust" },
    { 0x312D, "end_drowning_damage" },
    { 0x312E, "end_exit_early" },
    { 0x312F, "end_exo_hover_on_notifies" },
    { 0x3130, "end_exo_push" },
    { 0x3131, "end_facial_on_death" },
    { 0x3132, "end_fade_to_black" },
    { 0x3133, "end_fardist" },
    { 0x3134, "end_first_fight_behavior_think" },
    { 0x3135, "end_follow_drone_on_emp" },
    { 0x3136, "end_hand_signal_to_caf" },
    { 0x3137, "end_hand_signal_to_hangar" },
    { 0x3138, "end_hdrcolorintensity" },
    { 0x3139, "end_hdrsuncolorintensity" },
    { 0x313A, "end_level" },
    { 0x313B, "end_logos" },
    { 0x313C, "end_mission_fade_audio_and_video" },
    { 0x313D, "end_mission_out_bounds" },
    { 0x313E, "end_neardist" },
    { 0x313F, "end_opacity" },
    { 0x3140, "end_pitch" },
    { 0x3141, "end_pos" },
    { 0x3142, "end_position" },
    { 0x3143, "end_ride_on_hovertank_done" },
    { 0x3144, "end_roof_ambient_aa_explosions" },
    { 0x3145, "end_roof_ambient_midair_runner_explosion_single" },
    { 0x3146, "end_script_corner" },
    { 0x3147, "end_skyfogintensity" },
    { 0x3148, "end_skyfogmaxangle" },
    { 0x3149, "end_skyfogminangle" },
    { 0x314A, "end_slide_delay" },
    { 0x314B, "end_slow_mo" },
    { 0x314C, "end_squad_cqb" },
    { 0x314D, "end_state_geo" },
    { 0x314E, "end_sunbeginfadeangle" },
    { 0x314F, "end_suncolor" },
    { 0x3150, "end_sundir" },
    { 0x3151, "end_sunendfadeangle" },
    { 0x3152, "end_sunfogscale" },
    { 0x3153, "end_the_exopush_even_if_never_pushed" },
    { 0x3154, "end_thread" },
    { 0x3155, "end_time" },
    { 0x3156, "end_turret_reservation" },
    { 0x3157, "end_vtol" },
    { 0x3158, "end_water_breach" },
    { 0x3159, "endaimidlethread" },
    { 0x315A, "endcolor" },
    { 0x315B, "endcustomevent" },
    { 0x315C, "enddronecontrol" },
    { 0x315D, "endedkillcamcleanup" },
    { 0x315E, "ender" },
    { 0x315F, "ender_cleanup" },
    { 0x3160, "endfaceenemyaimtracking" },
    { 0x3161, "endfireandanimidlethread" },
    { 0x3162, "endgame" },
    { 0x3163, "endgamedeath" },
    { 0x3164, "endgamehalftime" },
    { 0x3165, "endgameicon" },
    { 0x3166, "endgameontimelimit" },
    { 0x3167, "endgameovertime" },
    { 0x3168, "endgametimer" },
    { 0x3169, "endgastrackingoverlay" },
    { 0x316A, "endgastrackingoverlaydeath" },
    { 0x316B, "endidleatframeend" },
    { 0x316C, "ending" },
    { 0x316D, "ending_bones_bike_flyby" },
    { 0x316E, "ending_confculldist" },
    { 0x316F, "ending_fade_out" },
    { 0x3170, "ending_joker_bike_flyby" },
    { 0x3171, "ending_mech_lighting" },
    { 0x3172, "ending_on_off_think" },
    { 0x3173, "ending_player_bike_braking" },
    { 0x3174, "ending_slowmo_end" },
    { 0x3175, "ending_slowmo_start" },
    { 0x3176, "ending_viewmodelblur" },
    { 0x3177, "ending_viewmodelblur_reset" },
    { 0x3178, "ending2" },
    { 0x3179, "endingambushbreachexplosionfx" },
    { 0x317A, "endingambushdialogue" },
    { 0x317B, "endingambushvision" },
    { 0x317C, "endingautosavetacticalthread" },
    { 0x317D, "endingbegin" },
    { 0x317E, "endingburningsniper" },
    { 0x317F, "endingcivfleesetup" },
    { 0x3180, "endingcivilianflee" },
    { 0x3181, "endingcombatenemysetup" },
    { 0x3182, "endingcomplete" },
    { 0x3183, "endingcrashglaunchercorpse" },
    { 0x3184, "endingcrashtruckexplosionfx" },
    { 0x3185, "endingenemycrawlthread" },
    { 0x3186, "endingenemyfloatersteleport" },
    { 0x3187, "endingenemysetupsuperguy" },
    { 0x3188, "endingenemyshotgunnersteleport" },
    { 0x3189, "endingenemystumblethread" },
    { 0x318A, "endingenemytruckexitthread" },
    { 0x318B, "endingfailleavemissiondialogue" },
    { 0x318C, "endingfailtimerexpiredialogue" },
    { 0x318D, "endingfightdialogue" },
    { 0x318E, "endingfightkvadialogue" },
    { 0x318F, "endingfightprogressdialogue" },
    { 0x3190, "endingfightstart" },
    { 0x3191, "endingfinaleblooddrips" },
    { 0x3192, "endingfinalebloodremove" },
    { 0x3193, "endingfinalebloodsplat" },
    { 0x3194, "endingfirehydrantfx" },
    { 0x3195, "endingflaginit" },
    { 0x3196, "endinggetenemyspeaker" },
    { 0x3197, "endingglobalsetup" },
    { 0x3198, "endingglobalvars" },
    { 0x3199, "endinghades" },
    { 0x319A, "endinghadesconvoycrash" },
    { 0x319B, "endinghadesconvoycrashslomo" },
    { 0x319C, "endinghadesconvoyenter" },
    { 0x319D, "endinghadesconvoyfail" },
    { 0x319E, "endinghadesconvoyhitplayer" },
    { 0x319F, "endinghadesdialogue" },
    { 0x31A0, "endinghadesvehiclereminderdialogue" },
    { 0x31A1, "endinghadeswakesrumblelight" },
    { 0x31A2, "endinghidebigfinaleents" },
    { 0x31A3, "endinghideprecrashents" },
    { 0x31A4, "endingilanasetupambushdialogue" },
    { 0x31A5, "endingjumpdownreminderdialogue" },
    { 0x31A6, "endingobjectivesetup" },
    { 0x31A7, "endingplayercarpinnedfx" },
    { 0x31A8, "endingplayertoofardialogue" },
    { 0x31A9, "endingprecache" },
    { 0x31AA, "endingsetcompletedobjflags" },
    { 0x31AB, "endingsetupambushreminderdialogue" },
    { 0x31AC, "endingsetupcivilians" },
    { 0x31AD, "endingsetupvehicles" },
    { 0x31AE, "endingshopcrashfx" },
    { 0x31AF, "endingstartpoints" },
    { 0x31B0, "endingstorefrontdestroyedsetup" },
    { 0x31B1, "endingtruckclip" },
    { 0x31B2, "endingtruckfiredamagevol" },
    { 0x31B3, "endingvehicledamagefx" },
    { 0x31B4, "endingvehicledamageresidualfx" },
    { 0x31B5, "endintensity" },
    { 0x31B6, "endkillcamifnothingtoshow" },
    { 0x31B7, "endmgstreak" },
    { 0x31B8, "endmgstreakwhenleavemg" },
    { 0x31B9, "endmission_main_func" },
    { 0x31BA, "endofgamesummarylogger" },
    { 0x31BB, "endondeath" },
    { 0x31BC, "endonplayerspawn" },
    { 0x31BD, "endonremoveanimactive" },
    { 0x31BE, "endonstring" },
    { 0x31BF, "endpos" },
    { 0x31C0, "endprisontrackingoverlay" },
    { 0x31C1, "endradius" },
    { 0x31C2, "endrespawnnotify" },
    { 0x31C3, "endride" },
    { 0x31C4, "endrunningreacttobullets" },
    { 0x31C5, "endsceneondeath" },
    { 0x31C6, "endselectionohostmigration" },
    { 0x31C7, "endselectiononaction" },
    { 0x31C8, "endselectiononemp" },
    { 0x31C9, "endselectiononendgame" },
    { 0x31CA, "endsliding" },
    { 0x31CB, "endtime" },
    { 0x31CC, "enduavonlatejoiner" },
    { 0x31CD, "enemies" },
    { 0x31CE, "enemies_1_a_south" },
    { 0x31CF, "enemies_1_a2_south" },
    { 0x31D0, "enemies_below" },
    { 0x31D1, "enemies_in_tennis_court" },
    { 0x31D2, "enemies_left" },
    { 0x31D3, "enemies_move_away" },
    { 0x31D4, "enemies_right" },
    { 0x31D5, "enemies_tagged" },
    { 0x31D6, "enemies1" },
    { 0x31D7, "enemiesignoreplayerdrone" },
    { 0x31D8, "enemiesleft" },
    { 0x31D9, "enemy_alert_level_attack" },
    { 0x31DA, "enemy_alert_level_attack_wrapper" },
    { 0x31DB, "enemy_alert_level_change" },
    { 0x31DC, "enemy_alert_level_change_reponse" },
    { 0x31DD, "enemy_alert_level_default_pre_spotted_func" },
    { 0x31DE, "enemy_alert_level_forget" },
    { 0x31DF, "enemy_alert_level_logic" },
    { 0x31E0, "enemy_alert_level_normal" },
    { 0x31E1, "enemy_alert_level_normal_wrapper" },
    { 0x31E2, "enemy_alert_level_reset_wrapper" },
    { 0x31E3, "enemy_alert_level_set_pre_spotted_func" },
    { 0x31E4, "enemy_alert_level_waittime" },
    { 0x31E5, "enemy_alert_level_warning_wrapper" },
    { 0x31E6, "enemy_alert_level_warning1" },
    { 0x31E7, "enemy_alert_level_warning2" },
    { 0x31E8, "enemy_alert_vo" },
    { 0x31E9, "enemy_alert_vo_setup" },
    { 0x31EA, "enemy_animation_attack" },
    { 0x31EB, "enemy_animation_custom" },
    { 0x31EC, "enemy_animation_do_anim" },
    { 0x31ED, "enemy_animation_foundcorpse" },
    { 0x31EE, "enemy_animation_generic" },
    { 0x31EF, "enemy_animation_loop" },
    { 0x31F0, "enemy_animation_nothing" },
    { 0x31F1, "enemy_animation_post_anim" },
    { 0x31F2, "enemy_animation_pre_anim" },
    { 0x31F3, "enemy_animation_pre_anim_dog_special_first_condition" },
    { 0x31F4, "enemy_animation_sawcorpse" },
    { 0x31F5, "enemy_animation_wrapper" },
    { 0x31F6, "enemy_announce_alert" },
    { 0x31F7, "enemy_announce_attack" },
    { 0x31F8, "enemy_announce_corpse" },
    { 0x31F9, "enemy_announce_hmph" },
    { 0x31FA, "enemy_announce_huh" },
    { 0x31FB, "enemy_announce_snd" },
    { 0x31FC, "enemy_announce_snd_reset" },
    { 0x31FD, "enemy_announce_spotted" },
    { 0x31FE, "enemy_announce_spotted_acknowledge" },
    { 0x31FF, "enemy_announce_spotted_bring_group" },
    { 0x3200, "enemy_announce_wtf" },
    { 0x3201, "enemy_armshots" },
    { 0x3202, "enemy_below" },
    { 0x3203, "enemy_bullet" },
    { 0x3204, "enemy_callout_vo" },
    { 0x3205, "enemy_callout_vo_setup" },
    { 0x3206, "enemy_camp_assassin" },
    { 0x3207, "enemy_camp_assassin_goal" },
    { 0x3208, "enemy_camp_spots" },
    { 0x3209, "enemy_canal_drone_guards" },
    { 0x320A, "enemy_chestshots" },
    { 0x320B, "enemy_close_in_on_target" },
    { 0x320C, "enemy_combat_equip_microwave_grenades" },
    { 0x320D, "enemy_corpse_alert_level" },
    { 0x320E, "enemy_corpse_clear" },
    { 0x320F, "enemy_corpse_found" },
    { 0x3210, "enemy_corpse_found_behavior" },
    { 0x3211, "enemy_corpse_found_loop" },
    { 0x3212, "enemy_corpse_found_wrapper" },
    { 0x3213, "enemy_corpse_logic" },
    { 0x3214, "enemy_corpse_loop" },
    { 0x3215, "enemy_corpse_reset_behavior" },
    { 0x3216, "enemy_corpse_reset_wrapper" },
    { 0x3217, "enemy_corpse_saw_behavior" },
    { 0x3218, "enemy_corpse_saw_wrapper" },
    { 0x3219, "enemy_custom" },
    { 0x321A, "enemy_custom_corpse_behavior" },
    { 0x321B, "enemy_custom_fire_ok_time" },
    { 0x321C, "enemy_custom_state_behavior" },
    { 0x321D, "enemy_deck_guys" },
    { 0x321E, "enemy_default_anim_behavior" },
    { 0x321F, "enemy_default_corpse_anim_behavior" },
    { 0x3220, "enemy_default_corpse_behavior" },
    { 0x3221, "enemy_default_state_behavior" },
    { 0x3222, "enemy_default_threat_anim_behavior" },
    { 0x3223, "enemy_default_threat_behavior" },
    { 0x3224, "enemy_delete_at_goal" },
    { 0x3225, "enemy_dialog_col" },
    { 0x3226, "enemy_dog_init" },
    { 0x3227, "enemy_door_ambush_monitor_health" },
    { 0x3228, "enemy_doorkick" },
    { 0x3229, "enemy_drop_fx" },
    { 0x322A, "enemy_drop_traversal" },
    { 0x322B, "enemy_event_awareness" },
    { 0x322C, "enemy_event_awareness_notify" },
    { 0x322D, "enemy_event_category_awareness" },
    { 0x322E, "enemy_event_debug_print" },
    { 0x322F, "enemy_event_declare_to_team" },
    { 0x3230, "enemy_event_handle_clear" },
    { 0x3231, "enemy_event_listeners_init" },
    { 0x3232, "enemy_event_listeners_logic" },
    { 0x3233, "enemy_event_listeners_proc" },
    { 0x3234, "enemy_event_loop" },
    { 0x3235, "enemy_event_reaction_alert_upward" },
    { 0x3236, "enemy_event_reaction_explosion" },
    { 0x3237, "enemy_event_reaction_flashbang" },
    { 0x3238, "enemy_event_reaction_generic" },
    { 0x3239, "enemy_event_reaction_grapple_impact" },
    { 0x323A, "enemy_event_reaction_gunshot" },
    { 0x323B, "enemy_event_reaction_heard_scream" },
    { 0x323C, "enemy_event_reaction_investigate" },
    { 0x323D, "enemy_event_reaction_irons_generic" },
    { 0x323E, "enemy_event_reaction_nothing" },
    { 0x323F, "enemy_event_reaction_whistle" },
    { 0x3240, "enemy_event_reaction_whistle_relay" },
    { 0x3241, "enemy_event_reaction_witness_kill" },
    { 0x3242, "enemy_event_reaction_wrapper" },
    { 0x3243, "enemy_event_set_run_anim" },
    { 0x3244, "enemy_find_free_pathnode_closest" },
    { 0x3245, "enemy_find_free_pathnode_near" },
    { 0x3246, "enemy_find_original_goal" },
    { 0x3247, "enemy_flashlight_think_off" },
    { 0x3248, "enemy_flashlight_think_on" },
    { 0x3249, "enemy_flashlight_toggle_think" },
    { 0x324A, "enemy_found_corpse_loop" },
    { 0x324B, "enemy_free_vehicles" },
    { 0x324C, "enemy_get_nearby_pathnodes" },
    { 0x324D, "enemy_go_back" },
    { 0x324E, "enemy_go_back_clear_lastspot" },
    { 0x324F, "enemy_headshots" },
    { 0x3250, "enemy_heli_attacking" },
    { 0x3251, "enemy_heli_killed" },
    { 0x3252, "enemy_init" },
    { 0x3253, "enemy_investigate_position" },
    { 0x3254, "enemy_is_a_threat" },
    { 0x3255, "enemy_is_in_vehicle" },
    { 0x3256, "enemy_jet_shoot_think" },
    { 0x3257, "enemy_kills" },
    { 0x3258, "enemy_know_player_for_time" },
    { 0x3259, "enemy_left" },
    { 0x325A, "enemy_legshots" },
    { 0x325B, "enemy_locking_on_to_player" },
    { 0x325C, "enemy_lookaround_for_time" },
    { 0x325D, "enemy_missile_strike_exists" },
    { 0x325E, "enemy_model" },
    { 0x325F, "enemy_narrowcave_breach_axe_hit" },
    { 0x3260, "enemy_near_position" },
    { 0x3261, "enemy_objectives" },
    { 0x3262, "enemy_on_fire" },
    { 0x3263, "enemy_orbital_laser_exists" },
    { 0x3264, "enemy_paladin_exists" },
    { 0x3265, "enemy_prespotted_func_default" },
    { 0x3266, "enemy_promotion_thread" },
    { 0x3267, "enemy_react_and_displace_to" },
    { 0x3268, "enemy_reaction_state_alert" },
    { 0x3269, "enemy_reactto_and_lookaround" },
    { 0x326A, "enemy_reinforcements" },
    { 0x326B, "enemy_reinforcements_think" },
    { 0x326C, "enemy_respawn_lock_func" },
    { 0x326D, "enemy_respawn_vision_checker_thread" },
    { 0x326E, "enemy_return_to_normal_vo" },
    { 0x326F, "enemy_right" },
    { 0x3270, "enemy_run_away" },
    { 0x3271, "enemy_run_nodes" },
    { 0x3272, "enemy_runto_and_lookaround" },
    { 0x3273, "enemy_saw_corpse_logic" },
    { 0x3274, "enemy_server_room_se" },
    { 0x3275, "enemy_set_alert_level" },
    { 0x3276, "enemy_set_original_goal" },
    { 0x3277, "enemy_set_threat_anim_behavior" },
    { 0x3278, "enemy_set_threat_behavior" },
    { 0x3279, "enemy_setupanimations" },
    { 0x327A, "enemy_sight_trace" },
    { 0x327B, "enemy_sight_trace_passed" },
    { 0x327C, "enemy_sight_trace_process" },
    { 0x327D, "enemy_sight_trace_request" },
    { 0x327E, "enemy_startup_thread" },
    { 0x327F, "enemy_state_hidden" },
    { 0x3280, "enemy_state_spotted" },
    { 0x3281, "enemy_stop_current_behavior" },
    { 0x3282, "enemy_strafing_run_exists" },
    { 0x3283, "enemy_suv_explode" },
    { 0x3284, "enemy_suv_median" },
    { 0x3285, "enemy_tagged" },
    { 0x3286, "enemy_tank_ai_think" },
    { 0x3287, "enemy_tank_aim" },
    { 0x3288, "enemy_tank_damage_function" },
    { 0x3289, "enemy_tank_death_function" },
    { 0x328A, "enemy_target" },
    { 0x328B, "enemy_target_last_vis_time" },
    { 0x328C, "enemy_target_visible" },
    { 0x328D, "enemy_team_name" },
    { 0x328E, "enemy_threat_anim_defaults" },
    { 0x328F, "enemy_threat_logic" },
    { 0x3290, "enemy_threat_logic_dog" },
    { 0x3291, "enemy_threat_logic_dog_wait" },
    { 0x3292, "enemy_threat_logic_dog_wakeup_dist" },
    { 0x3293, "enemy_threat_loop" },
    { 0x3294, "enemy_threat_set_spotted" },
    { 0x3295, "enemy_units" },
    { 0x3296, "enemy_use_dialog_col" },
    { 0x3297, "enemy_vo_array_conversation_1" },
    { 0x3298, "enemy_vo_array_conversation_2" },
    { 0x3299, "enemy_vo_array_one_off" },
    { 0x329A, "enemy_vrap_damage_function" },
    { 0x329B, "enemy_walker" },
    { 0x329C, "enemy_walker_destroyed_dialogue" },
    { 0x329D, "enemy_walker_kill_player_if_too_close" },
    { 0x329E, "enemy_walker_reveal_dialogue" },
    { 0x329F, "enemy_walker_set_launcher_targets" },
    { 0x32A0, "enemy_walker_silence" },
    { 0x32A1, "enemy_walker_target_player_if_targeted" },
    { 0x32A2, "enemy_warbird_deathspin_listener" },
    { 0x32A3, "enemy_who_surprised_me" },
    { 0x32A4, "enemyagentthink" },
    { 0x32A5, "enemyambusheastopendoors" },
    { 0x32A6, "enemyambushsouthopendoors" },
    { 0x32A7, "enemyambushsouthshiftvol" },
    { 0x32A8, "enemyambushvehiclebadplace" },
    { 0x32A9, "enemyatriumflashbang" },
    { 0x32AA, "enemyboarderfxid" },
    { 0x32AB, "enemyclass" },
    { 0x32AC, "enemydirection" },
    { 0x32AD, "enemyendinganimations" },
    { 0x32AE, "enemyflagfxid" },
    { 0x32AF, "enemyfx" },
    { 0x32B0, "enemygroupcorpsedetection" },
    { 0x32B1, "enemyhitcounts" },
    { 0x32B2, "enemyisapproaching" },
    { 0x32B3, "enemyishiding" },
    { 0x32B4, "enemyisingeneraldirection" },
    { 0x32B5, "enemykills" },
    { 0x32B6, "enemylosmarker" },
    { 0x32B7, "enemymarker" },
    { 0x32B8, "enemymodel" },
    { 0x32B9, "enemynotify" },
    { 0x32BA, "enemyoutlinecolor" },
    { 0x32BB, "enemypatrolanimations" },
    { 0x32BC, "enemypatrolatriumthread" },
    { 0x32BD, "enemypatrolcourtyardthread" },
    { 0x32BE, "enemypatrolgatethread" },
    { 0x32BF, "enemypatrolparkingthread" },
    { 0x32C0, "enemypatrolpoolthread" },
    { 0x32C1, "enemypatrolrooftopthread" },
    { 0x32C2, "enemypatrolwalkwaythread" },
    { 0x32C3, "enemyreactanimations" },
    { 0x32C4, "enemyreinforcementsvehicleturretthread" },
    { 0x32C5, "enemyscrambleanimations" },
    { 0x32C6, "enemystruggler" },
    { 0x32C7, "enemytanks" },
    { 0x32C8, "enemytarget" },
    { 0x32C9, "enemyteam" },
    { 0x32CA, "enemytrigger" },
    { 0x32CB, "enemyturretfire" },
    { 0x32CC, "enemyturrettargetcar" },
    { 0x32CD, "enemyvehicleguyfallback" },
    { 0x32CE, "enemyvehicleturretthread" },
    { 0x32CF, "enemyvelocity" },
    { 0x32D0, "energydmgmod" },
    { 0x32D1, "energyturret" },
    { 0x32D2, "enforceexplosivedronelimit" },
    { 0x32D3, "engage_enemies" },
    { 0x32D4, "engage_enemy" },
    { 0x32D5, "engine_fxs" },
    { 0x32D6, "engine_rev_lo_os" },
    { 0x32D7, "ensurelaststandparamsvalidity" },
    { 0x32D8, "ent" },
    { 0x32D9, "ent_attacker" },
    { 0x32DA, "ent_draw_axis" },
    { 0x32DB, "ent_flag" },
    { 0x32DC, "ent_flag_assert" },
    { 0x32DD, "ent_flag_clear" },
    { 0x32DE, "ent_flag_clear_delayed" },
    { 0x32DF, "ent_flag_exist" },
    { 0x32E0, "ent_flag_init" },
    { 0x32E1, "ent_flag_set" },
    { 0x32E2, "ent_flag_set_delayed" },
    { 0x32E3, "ent_flag_wait" },
    { 0x32E4, "ent_flag_wait_either" },
    { 0x32E5, "ent_flag_wait_or_timeout" },
    { 0x32E6, "ent_flag_wait_vehicle_node" },
    { 0x32E7, "ent_flag_waitopen" },
    { 0x32E8, "ent_flag_waitopen_either" },
    { 0x32E9, "ent_flags_lock" },
    { 0x32EA, "ent_is_highlighted" },
    { 0x32EB, "ent_is_selected" },
    { 0x32EC, "ent_origin" },
    { 0x32ED, "ent_targets" },
    { 0x32EE, "ent_team" },
    { 0x32EF, "ent_threat" },
    { 0x32F0, "ent_wait_for_flag_or_time_elapses" },
    { 0x32F1, "ent_waits_for_trigger" },
    { 0x32F2, "enter_bridge" },
    { 0x32F3, "enter_firingrange" },
    { 0x32F4, "enter_forest" },
    { 0x32F5, "enter_hangar" },
    { 0x32F6, "enter_hotel_lobby" },
    { 0x32F7, "enter_lake_cave" },
    { 0x32F8, "enter_lost_player_mode_func" },
    { 0x32F9, "enter_message_deleted" },
    { 0x32FA, "enter_return_to_sweep_mode_func" },
    { 0x32FB, "enter_room_above_hangar" },
    { 0x32FC, "enter_server_room" },
    { 0x32FD, "enter_ship" },
    { 0x32FE, "enter_state_mag_to_jump_surface" },
    { 0x32FF, "enter_state_on_jump_surface" },
    { 0x3300, "enter_state_on_mag_surface" },
    { 0x3301, "enter_sweep_mode_func" },
    { 0x3302, "enter_track_player_mode_func" },
    { 0x3303, "enter_use_tags" },
    { 0x3304, "enter_vlobby" },
    { 0x3305, "enter_walker_rig" },
    { 0x3306, "enter_water_override" },
    { 0x3307, "enter_window_whoosh" },
    { 0x3308, "enteraistate" },
    { 0x3309, "entered_vehicle_notify" },
    { 0x330A, "enteringbombingarea" },
    { 0x330B, "enterpronewrapper" },
    { 0x330C, "enterpronewrapperproc" },
    { 0x330D, "enterstate" },
    { 0x330E, "entinfrontarc" },
    { 0x330F, "entisstucktoshield" },
    { 0x3310, "entities" },
    { 0x3311, "entities_are_selected" },
    { 0x3312, "entitiesinuse" },
    { 0x3313, "entity_has_been_called_out_timer" },
    { 0x3314, "entity_highlight_disable" },
    { 0x3315, "entity_highlight_enable" },
    { 0x3316, "entity_is_in_circle" },
    { 0x3317, "entity_number" },
    { 0x3318, "entity_path_disconnect_thread" },
    { 0x3319, "entity_ref_count" },
    { 0x331A, "entityheadicon" },
    { 0x331B, "entityheadiconoffset" },
    { 0x331C, "entityheadiconreferencefunc" },
    { 0x331D, "entityheadicons" },
    { 0x331E, "entityheadiconteam" },
    { 0x331F, "entnum" },
    { 0x3320, "entrance_alarm" },
    { 0x3321, "entrance_alarm_fast" },
    { 0x3322, "entrance_alarm_fast2" },
    { 0x3323, "entrance_indices" },
    { 0x3324, "entrance_origin_points" },
    { 0x3325, "entrance_points" },
    { 0x3326, "entrance_points_finished_caching" },
    { 0x3327, "entrance_room" },
    { 0x3328, "entrance_scanner_back_door_close" },
    { 0x3329, "entrance_scanner_back_door_open" },
    { 0x332A, "entrance_scanner_front_door_close" },
    { 0x332B, "entrance_scanner_front_door_open" },
    { 0x332C, "entrance_scanner_running" },
    { 0x332D, "entrance_to_enemy_zone" },
    { 0x332E, "entrance_visible_from" },
    { 0x332F, "entrance_vo_01" },
    { 0x3330, "entrance_vo_03" },
    { 0x3331, "entrance_watched_by_ally" },
    { 0x3332, "entrance_watched_by_player" },
    { 0x3333, "ents_mixed_in" },
    { 0x3334, "env" },
    { 0x3335, "env_array" },
    { 0x3336, "env_data" },
    { 0x3337, "env_effects_hostage_room" },
    { 0x3338, "env_function" },
    { 0x3339, "env_threat_to_vol" },
    { 0x333A, "envs" },
//  { 0x333B, "" },
    { 0x333C, "eq_main_track" },
    { 0x333D, "eq_mix_track" },
    { 0x333E, "eq_table" },
    { 0x333F, "eq_touching" },
    { 0x3340, "eq_track" },
    { 0x3341, "eq_trigger_num" },
    { 0x3342, "equal_strings" },
    { 0x3343, "equip_microwave_grenade" },
    { 0x3344, "equip_new_door" },
    { 0x3345, "equip_player" },
    { 0x3346, "equip_player_smg" },
    { 0x3347, "equipment_enabled" },
    { 0x3348, "equipmentdeathvfx" },
    { 0x3349, "equipmentdeletevfx" },
    { 0x334A, "equipmentdisableuse" },
    { 0x334B, "equipmentempstunvfx" },
    { 0x334C, "equipmentenableuse" },
    { 0x334D, "equipmentextra" },
    { 0x334E, "equipmentmines" },
    { 0x334F, "equipmentwatchenabledisableuse" },
    { 0x3350, "equipmentwatchuse" },
    { 0x3351, "erasefinalkillcam" },
    { 0x3352, "error" },
    { 0x3353, "esc_node_locations" },
    { 0x3354, "escape_artist" },
    { 0x3355, "escape_artist_distance" },
    { 0x3356, "escape_artist_failure" },
    { 0x3357, "escape_artist_success" },
    { 0x3358, "escape_driver2" },
    { 0x3359, "escape_drone_door_open" },
    { 0x335A, "escape_fight_wave" },
    { 0x335B, "escape_fire_door_slam_shut" },
    { 0x335C, "escape_gas" },
    { 0x335D, "escape_guys1" },
    { 0x335E, "escape_guys2_a" },
    { 0x335F, "escape_guys2_b" },
    { 0x3360, "escape_guys3" },
    { 0x3361, "escape_guys3_a" },
    { 0x3362, "escape_guys3_b" },
    { 0x3363, "escape_hallway_steam" },
    { 0x3364, "escape_hospital_trains" },
    { 0x3365, "escape_node" },
    { 0x3366, "escape_pa" },
    { 0x3367, "escape_scene_clean_up_secret_room" },
    { 0x3368, "escape_scene_cleanup" },
    { 0x3369, "escape_scene_close_door_when_player_close" },
    { 0x336A, "escape_scene_close_elevator_doors" },
    { 0x336B, "escape_scene_close_elveator_door" },
    { 0x336C, "escape_scene_close_firedoor" },
    { 0x336D, "escape_scene_confrontation_room_guards" },
    { 0x336E, "escape_scene_guard_call_help" },
    { 0x336F, "escape_scene_guard_player_seek" },
    { 0x3370, "escape_scene_hallway_climb" },
    { 0x3371, "escape_scene_hallway_run" },
    { 0x3372, "escape_scene_manage_flood_spawn_fire_door" },
    { 0x3373, "escape_scene_manage_guard_accuracy" },
    { 0x3374, "escape_scene_manage_guards" },
    { 0x3375, "escape_scene_master_handler" },
    { 0x3376, "escape_scene_open_elevator_doors" },
    { 0x3377, "escape_scene_open_elveator_door" },
    { 0x3378, "escape_scene_open_firedoor" },
    { 0x3379, "escape_scene_remove_guards_on_complete" },
    { 0x337A, "escape_scene_rush_for_door" },
    { 0x337B, "escape_scene_sentinel_makes_contact" },
    { 0x337C, "escape_scene_setup" },
    { 0x337D, "escape_scene_setup_firedoor" },
    { 0x337E, "escape_scene_side_door_guards" },
    { 0x337F, "escape_scene_start_hallway_drop_door" },
    { 0x3380, "escape_scene_swarm_warning" },
    { 0x3381, "escape_scene_wait_for_player_past_drop_door" },
    { 0x3382, "escape_scene_wait_for_player_past_guard_doors" },
    { 0x3383, "escape_shoot_guard" },
    { 0x3384, "escape_sprinklers_off" },
    { 0x3385, "escape_sprinklers_on" },
    { 0x3386, "escape_take_down_guard" },
    { 0x3387, "escape_vehicle" },
    { 0x3388, "escape_vehicle2" },
    { 0x3389, "escapevehicle" },
    { 0x338A, "estate" },
    { 0x338B, "estimate_player_speed" },
    { 0x338C, "estimatedtimetillscorelimit" },
    { 0x338D, "etarget" },
    { 0x338E, "euler_lerp" },
    { 0x338F, "eulogy_cormack_approach" },
    { 0x3390, "eulogy_cormack_leave" },
    { 0x3391, "eulogy_cormack_touch" },
    { 0x3392, "eulogy_irons_leave" },
    { 0x3393, "eulogy_irons_stand" },
    { 0x3394, "eulogy_irons_touch" },
    { 0x3395, "eulogy_player_touch" },
    { 0x3396, "euro_siren_01" },
    { 0x3397, "euro_siren_setup" },
    { 0x3398, "evacuation_balcony_death" },
    { 0x3399, "evacuation_corpses" },
    { 0x339A, "evacuation_first_drones_dead" },
    { 0x339B, "evacuation_first_drones_think" },
    { 0x339C, "evacuation_kiosk_movie" },
    { 0x339D, "evacuation_scene_animate_actor" },
    { 0x339E, "evacuation_scene_determine_run_cycle" },
    { 0x339F, "evacuation_scene_index" },
    { 0x33A0, "evacuation_scene_run_actor" },
    { 0x33A1, "evacuation_scene_run_actor_and_die" },
    { 0x33A2, "evacuation_scene_spawners" },
    { 0x33A3, "evacuation_scene_think" },
    { 0x33A4, "evacuation_scene_trigger_think" },
    { 0x33A5, "evacuation_setup" },
    { 0x33A6, "eval_max_range" },
    { 0x33A7, "eval_min_range" },
    { 0x33A8, "eval_too_close_range" },
    { 0x33A9, "evaluate_tactical_above_player" },
    { 0x33AA, "evaluate_tactical_in_front_of_enemy" },
    { 0x33AB, "evaluate_tactical_in_front_of_volume" },
    { 0x33AC, "evaluate_tactical_los" },
    { 0x33AD, "evaluate_tactical_range" },
    { 0x33AE, "evaluate_tactical_too_close" },
    { 0x33AF, "evaluate_threat_avoid_friendly_fire" },
    { 0x33B0, "evaluate_threat_los" },
    { 0x33B1, "evaluate_threat_player" },
    { 0x33B2, "evaluate_threat_range" },
    { 0x33B3, "evaluate_threat_valid_threat" },
    { 0x33B4, "evaluateattackevent" },
    { 0x33B5, "evaluatecombatevent" },
    { 0x33B6, "evaluatefiringevent" },
    { 0x33B7, "evaluatemeleeevent" },
    { 0x33B8, "evaluatemoveevent" },
    { 0x33B9, "evaluatereloadevent" },
    { 0x33BA, "evaluatesuppressionevent" },
    { 0x33BB, "evasive_addpoint" },
    { 0x33BC, "evasive_createmaneuvers" },
    { 0x33BD, "evasive_drawpoints" },
    { 0x33BE, "evasive_endmaneuvers" },
    { 0x33BF, "evasive_getallpoints" },
    { 0x33C0, "evasive_points" },
    { 0x33C1, "evasive_startmaneuvers" },
    { 0x33C2, "evasive_think" },
    { 0x33C3, "event" },
    { 0x33C4, "event_actor_animations" },
    { 0x33C5, "event_animated" },
    { 0x33C6, "event_aud" },
    { 0x33C7, "event_awareness_dialogue_wrapper" },
    { 0x33C8, "event_awareness_enders" },
    { 0x33C9, "event_awareness_main" },
    { 0x33CA, "event_awareness_waitclear_ai" },
    { 0x33CB, "event_awareness_waitclear_ai_proc" },
    { 0x33CC, "event_distance" },
    { 0x33CD, "event_ents" },
    { 0x33CE, "event_exit_player_knockback" },
    { 0x33CF, "event_fx" },
    { 0x33D0, "event_geo" },
    { 0x33D1, "event_killtriggers" },
    { 0x33D2, "event_mb1_climb_in_mech" },
    { 0x33D3, "event_mb1_climb_in_mech_gideon" },
    { 0x33D4, "event_mb1_jumpdown" },
    { 0x33D5, "event_mb1_weapons_come_online" },
    { 0x33D6, "event_mb2_gatesmash" },
    { 0x33D7, "event_mechsuit_swap" },
    { 0x33D8, "event_reset" },
    { 0x33D9, "event_start" },
    { 0x33DA, "event_type" },
    { 0x33DB, "eventaction" },
    { 0x33DC, "eventactionminwait" },
    { 0x33DD, "eventchance" },
    { 0x33DE, "eventduration" },
    { 0x33DF, "eventpriority" },
    { 0x33E0, "eventtype" },
    { 0x33E1, "eventtypeminwait" },
    { 0x33E2, "everusessecondaryweapon" },
    { 0x33E3, "every_other_one" },
    { 0x33E4, "evfromluminancenits" },
    { 0x33E5, "exceededmaxexplosivedrones" },
    { 0x33E6, "exceededmaxlittlebirds" },
    { 0x33E7, "exceededmaxtrackingdrones" },
    { 0x33E8, "exception" },
    { 0x33E9, "exception_exposed_mg42_portable" },
    { 0x33EA, "excludedai" },
    { 0x33EB, "excludedir" },
    { 0x33EC, "exclusive_fog_tech" },
    { 0x33ED, "exec_call" },
    { 0x33EE, "exec_call_noself" },
    { 0x33EF, "exec_func" },
    { 0x33F0, "exec_function" },
    { 0x33F1, "execute_ai" },
    { 0x33F2, "execute_ai_solo" },
    { 0x33F3, "execute_mode" },
    { 0x33F4, "execute_monitor" },
    { 0x33F5, "execute_primary_light_setkey_internal" },
    { 0x33F6, "execute_scriptable_primary_light" },
    { 0x33F7, "execute_target" },
    { 0x33F8, "executefunction" },
    { 0x33F9, "executer" },
    { 0x33FA, "executioner2standground" },
    { 0x33FB, "executionhostages" },
    { 0x33FC, "exfil" },
    { 0x33FD, "exfil_allies" },
    { 0x33FE, "exfil_animnode" },
    { 0x33FF, "exfil_arms" },
    { 0x3400, "exfil_cormack" },
    { 0x3401, "exfil_dialogue" },
    { 0x3402, "exfil_dof" },
    { 0x3403, "exfil_enemies" },
    { 0x3404, "exfil_enemies_setup" },
    { 0x3405, "exfil_enemy_missile" },
    { 0x3406, "exfil_fail" },
    { 0x3407, "exfil_guys" },
    { 0x3408, "exfil_logic" },
    { 0x3409, "exfil_player" },
    { 0x340A, "exfil_player_jump" },
    { 0x340B, "exfil_player_jump_fail" },
    { 0x340C, "exfil_setup" },
    { 0x340D, "exfil_spotlights_fx" },
    { 0x340E, "exfil_vtol" },
    { 0x340F, "exfil_workers" },
    { 0x3410, "exhaust_corridor_timer" },
    { 0x3411, "exhaust_fx_name" },
    { 0x3412, "exhaust_hatch_break_gideon" },
    { 0x3413, "exhaust_hatch_break_player" },
    { 0x3414, "exhaust_hatch_land_gideon" },
    { 0x3415, "exhaust_hatch_land_player" },
    { 0x3416, "exhaust_hatch_open" },
    { 0x3417, "exhaust_shaft_land" },
    { 0x3418, "exhaust_shaft_land_gideon" },
    { 0x3419, "exists_global_spawn_function" },
    { 0x341A, "exit_anim" },
    { 0x341B, "exit_anim_vm" },
    { 0x341C, "exit_drive_dialogue" },
    { 0x341D, "exit_drive_ending_begin" },
    { 0x341E, "exit_drive_failed_dialogue" },
    { 0x341F, "exit_drive_gaz_physics" },
    { 0x3420, "exit_drive_jetbike_lighting" },
    { 0x3421, "exit_drive_jetbike_lights_ai" },
    { 0x3422, "exit_drive_jetbike_lights_player" },
    { 0x3423, "exit_drive_jump_save_attempt" },
    { 0x3424, "exit_drive_main" },
    { 0x3425, "exit_drive_objects_think" },
    { 0x3426, "exit_drive_player_jetbike_initial_lights" },
    { 0x3427, "exit_drive_prepare_dialogue" },
    { 0x3428, "exit_drive_prepare_dialogue_nag" },
    { 0x3429, "exit_drive_rpgs" },
    { 0x342A, "exit_drive_rpgs_flyby" },
    { 0x342B, "exit_drive_script_checkpoints" },
    { 0x342C, "exit_drive_starting_anims_ambient_danger" },
    { 0x342D, "exit_drive_starting_magic_bullets" },
    { 0x342E, "exit_drive_timeout_fail" },
    { 0x342F, "exit_enemy" },
    { 0x3430, "exit_hotel" },
    { 0x3431, "exit_hovertank_rumbles" },
    { 0x3432, "exit_mech_rocket_fire" },
    { 0x3433, "exit_return_to_sweep_mode_func" },
    { 0x3434, "exit_ride_burke_away" },
    { 0x3435, "exit_ride_burke_door_open" },
    { 0x3436, "exit_ride_burke_mount" },
    { 0x3437, "exit_ride_burke_start" },
    { 0x3438, "exit_ride_jetbike_mount_player" },
    { 0x3439, "exit_ride_joker_start" },
    { 0x343A, "exit_run_nodes_enemy" },
    { 0x343B, "exit_run_nodes1" },
    { 0x343C, "exit_run_nodes2" },
    { 0x343D, "exit_sweep_mode_func" },
    { 0x343E, "exit_train_by" },
    { 0x343F, "exit_train_by_train3_loop" },
    { 0x3440, "exit_train_by_train3_whoosh" },
    { 0x3441, "exit_truck_fire" },
    { 0x3442, "exit_water_override" },
    { 0x3443, "exitaistate" },
    { 0x3444, "exitdrive_buttress" },
    { 0x3445, "exitdrive_chopper_final" },
    { 0x3446, "exitdrive_chopper_final_gopath" },
    { 0x3447, "exitdrive_chopper_initial" },
    { 0x3448, "exitdrive_chopper_initial_gopath" },
    { 0x3449, "exitdrive_chopper_tracks_1" },
    { 0x344A, "exitdrive_chopper_tracks_1_gopath" },
    { 0x344B, "exitdrive_ending_anims_burke" },
    { 0x344C, "exitdrive_ending_anims_player" },
    { 0x344D, "exited_lobby" },
    { 0x344E, "exitpronewrapper" },
    { 0x344F, "exitpronewrapperproc" },
    { 0x3450, "exitstate" },
    { 0x3451, "exittag" },
    { 0x3452, "exitwarbirdcontrolstate" },
    { 0x3453, "exo_active" },
    { 0x3454, "exo_battery_ability_flags" },
    { 0x3455, "exo_cinema_disabled" },
    { 0x3456, "exo_climb_allow_player_input_1" },
    { 0x3457, "exo_climb_allow_player_input_2" },
    { 0x3458, "exo_climb_anim_offsets" },
    { 0x3459, "exo_climb_animated_dismount" },
    { 0x345A, "exo_climb_draw_weapon" },
    { 0x345B, "exo_climb_force_animated_dismount" },
    { 0x345C, "exo_climb_grab_rumble" },
    { 0x345D, "exo_climb_grab_shake" },
    { 0x345E, "exo_climb_ground_ref_ent" },
    { 0x345F, "exo_climb_jump_rumble" },
    { 0x3460, "exo_climb_jump_shake" },
    { 0x3461, "exo_climb_jump_trigs" },
    { 0x3462, "exo_climb_left_swing_pressed" },
    { 0x3463, "exo_climb_mag_rumble" },
    { 0x3464, "exo_climb_magnetic_trigs" },
    { 0x3465, "exo_climb_move_options" },
    { 0x3466, "exo_climb_overrides" },
    { 0x3467, "exo_climb_player_center" },
    { 0x3468, "exo_climb_pullup_start" },
    { 0x3469, "exo_climb_retest_jumps_triggers" },
    { 0x346A, "exo_climb_rig" },
    { 0x346B, "exo_climb_right_swing_pressed" },
    { 0x346C, "exo_climb_sliding" },
    { 0x346D, "exo_climb_start" },
    { 0x346E, "exo_climb_tech_01" },
    { 0x346F, "exo_climb_tech_02" },
    { 0x3470, "exo_climb_tech_03" },
    { 0x3471, "exo_climb_weapon" },
    { 0x3472, "exo_cloak_battery_dead" },
    { 0x3473, "exo_cloak_battery_low" },
    { 0x3474, "exo_cloak_battery_recharge" },
    { 0x3475, "exo_cloak_button_press" },
    { 0x3476, "exo_cloak_disable" },
    { 0x3477, "exo_cloak_enable" },
    { 0x3478, "exo_cloak_off_time" },
    { 0x3479, "exo_cloak_on" },
    { 0x347A, "exo_dodge_cooldown" },
    { 0x347B, "exo_dodge_stealth_watcher" },
    { 0x347C, "exo_dodge_think" },
    { 0x347D, "exo_door" },
    { 0x347E, "exo_door_break" },
    { 0x347F, "exo_door_dialogue" },
    { 0x3480, "exo_door_disable_melee" },
    { 0x3481, "exo_door_enable_weapons" },
    { 0x3482, "exo_door_footstep_01" },
    { 0x3483, "exo_door_footstep_02" },
    { 0x3484, "exo_door_footstep_03" },
    { 0x3485, "exo_door_footstep_04" },
    { 0x3486, "exo_door_init" },
    { 0x3487, "exo_door_kick" },
    { 0x3488, "exo_door_logic" },
    { 0x3489, "exo_door_punch_cleanup" },
    { 0x348A, "exo_door_smash" },
    { 0x348B, "exo_door_throw" },
    { 0x348C, "exo_door_tilt_camera_during_animation" },
    { 0x348D, "exo_drone_flby" },
    { 0x348E, "exo_flicker_lighting" },
    { 0x348F, "exo_guy_cleanup_think" },
    { 0x3490, "exo_health_le_active_vfx" },
    { 0x3491, "exo_health_le_inactive_vfx" },
    { 0x3492, "exo_health_on" },
    { 0x3493, "exo_health_rt_active_vfx" },
    { 0x3494, "exo_health_rt_inactive_vfx" },
    { 0x3495, "exo_hover_init" },
    { 0x3496, "exo_hover_on" },
    { 0x3497, "exo_hover_think" },
    { 0x3498, "exo_hover_update" },
    { 0x3499, "exo_jump_button_listener" },
    { 0x349A, "exo_jump_button_pressed" },
    { 0x349B, "exo_jump_end" },
    { 0x349C, "exo_jump_process" },
    { 0x349D, "exo_knife_clean_up_attractor" },
    { 0x349E, "exo_knife_delete" },
    { 0x349F, "exo_knife_emp_watch" },
    { 0x34A0, "exo_knife_enable_detonate" },
    { 0x34A1, "exo_knife_manually_detonate" },
    { 0x34A2, "exo_knife_passed_target" },
    { 0x34A3, "exo_knife_recall" },
    { 0x34A4, "exo_knife_recall_watch" },
    { 0x34A5, "exo_knife_restock" },
    { 0x34A6, "exo_knife_stuck_watch" },
    { 0x34A7, "exo_knife_think" },
    { 0x34A8, "exo_knife_throw_watch" },
    { 0x34A9, "exo_knife_touch_watch" },
    { 0x34AA, "exo_lower_shield" },
    { 0x34AB, "exo_max" },
    { 0x34AC, "exo_move_speed_update" },
    { 0x34AD, "exo_mute_3p" },
    { 0x34AE, "exo_mute_init" },
    { 0x34AF, "exo_mute_think" },
    { 0x34B0, "exo_objective_use_prompt" },
    { 0x34B1, "exo_old_values" },
    { 0x34B2, "exo_overclock_vfx_le_active" },
    { 0x34B3, "exo_overclock_vfx_le_inactive" },
    { 0x34B4, "exo_overclock_vfx_ri_active" },
    { 0x34B5, "exo_overclock_vfx_ri_inactive" },
    { 0x34B6, "exo_ping_hud_effect" },
    { 0x34B7, "exo_ping_init" },
    { 0x34B8, "exo_ping_on" },
    { 0x34B9, "exo_ping_think" },
    { 0x34BA, "exo_ping_vfx_active" },
    { 0x34BB, "exo_ping_vfx_inactive" },
    { 0x34BC, "exo_power_cooldown" },
    { 0x34BD, "exo_punch_breach_debris" },
    { 0x34BE, "exo_punch_breach_debris_texture" },
    { 0x34BF, "exo_punch_breach_deep" },
    { 0x34C0, "exo_punch_breach_foley" },
    { 0x34C1, "exo_punch_breach_impact" },
    { 0x34C2, "exo_punch_breach_sweetener" },
    { 0x34C3, "exo_punch_outline_think" },
    { 0x34C4, "exo_push_begin_nag_loop" },
    { 0x34C5, "exo_push_combat_manager" },
    { 0x34C6, "exo_push_dialogue" },
    { 0x34C7, "exo_push_exit_enter_hospital_dialogue" },
    { 0x34C8, "exo_push_gourney" },
    { 0x34C9, "exo_push_hospital_callout" },
    { 0x34CA, "exo_push_over_default_values" },
    { 0x34CB, "exo_push_play_truck_idle_at_end_of_frame" },
    { 0x34CC, "exo_push_sparks01" },
    { 0x34CD, "exo_push_sparks01_quake" },
    { 0x34CE, "exo_push_sparks02" },
    { 0x34CF, "exo_push_sparks02_quake" },
    { 0x34D0, "exo_push_think_bones" },
    { 0x34D1, "exo_push_think_burke" },
    { 0x34D2, "exo_push_think_joker" },
    { 0x34D3, "exo_push_think_player_attached" },
    { 0x34D4, "exo_push_think_truck" },
    { 0x34D5, "exo_push_truck_handle_path_disconnect" },
    { 0x34D6, "exo_push_truck_handle_speed" },
    { 0x34D7, "exo_raise_shield" },
    { 0x34D8, "exo_reheat" },
    { 0x34D9, "exo_release_gideon_error_glow" },
    { 0x34DA, "exo_release_vm_error_glow" },
    { 0x34DB, "exo_repair_desk_unfold" },
    { 0x34DC, "exo_repair_movement" },
    { 0x34DD, "exo_repair_movement_stop" },
    { 0x34DE, "exo_repair_vm_lift_arm" },
    { 0x34DF, "exo_repair_vm_place_arm" },
    { 0x34E0, "exo_repair_vm_sit" },
    { 0x34E1, "exo_repair_vm_test_hand" },
    { 0x34E2, "exo_repair_weight_updates" },
    { 0x34E3, "exo_repulsor_activate_vfx" },
    { 0x34E4, "exo_repulsor_deactivate_vfx" },
    { 0x34E5, "exo_repulsor_impact" },
    { 0x34E6, "exo_repulsor_player_vfx_active" },
    { 0x34E7, "exo_repulsor_player_vfx_inactive" },
    { 0x34E8, "exo_repulsor_think" },
    { 0x34E9, "exo_rumble" },
    { 0x34EA, "exo_scaffolding_enemies" },
    { 0x34EB, "exo_scaffolding_enemy" },
    { 0x34EC, "exo_shield_is_active" },
    { 0x34ED, "exo_shield_is_on" },
    { 0x34EE, "exo_shield_on" },
    { 0x34EF, "exo_shield_think" },
    { 0x34F0, "exo_stim_activate" },
    { 0x34F1, "exo_stim_active" },
    { 0x34F2, "exo_stim_on" },
    { 0x34F3, "exo_stim_used" },
    { 0x34F4, "exo_super_vfx" },
    { 0x34F5, "exo_takedown" },
    { 0x34F6, "exo_takedown_death" },
    { 0x34F7, "exo_temp" },
    { 0x34F8, "exo_temp_breach" },
    { 0x34F9, "exo_temp_high_altitude" },
    { 0x34FA, "exo_temp_narrow_cave" },
    { 0x34FB, "exo_temp_outdoor" },
    { 0x34FC, "exo_temp_overlook_lake" },
    { 0x34FD, "exo_temperature_hud" },
    { 0x34FE, "exo_truck_push" },
    { 0x34FF, "exoabilitytracking" },
    { 0x3500, "exoactivated" },
    { 0x3501, "exobatteryabilities" },
    { 0x3502, "exobatterylevel" },
    { 0x3503, "exobatterymax" },
    { 0x3504, "exoclimb_combat_enabled" },
    { 0x3505, "exocloak" },
    { 0x3506, "exocount" },
    { 0x3507, "exofailfx" },
    { 0x3508, "exohuditem" },
    { 0x3509, "exoknife_count" },
    { 0x350A, "exoknifekillevent" },
    { 0x350B, "exomostrecenttimedeciseconds" },
    { 0x350C, "exoparams" },
    { 0x350D, "exopush_distance_debug_ui" },
    { 0x350E, "exopush_end_fight" },
    { 0x350F, "exopush_end_flee" },
    { 0x3510, "exopush_stage_manager" },
    { 0x3511, "exopush_start" },
    { 0x3512, "exorepulsorinit" },
    { 0x3513, "exosetfuncs" },
    { 0x3514, "exoshieldweapon" },
    { 0x3515, "exospeedscalars" },
    { 0x3516, "exosurvivalmatches" },
    { 0x3517, "exoteambuffsetup" },
    { 0x3518, "exounsetfuncs" },
    { 0x3519, "expand_foam" },
    { 0x351A, "expand_goalradius" },
    { 0x351B, "expandmaxs" },
    { 0x351C, "expandmins" },
    { 0x351D, "expandspawnpointbounds" },
    { 0x351E, "expected_drones" },
    { 0x351F, "expiretime" },
    { 0x3520, "explo_ambientexp_dirt" },
    { 0x3521, "explo_ambientexp_fireball" },
    { 0x3522, "explo_debris_alias_" },
    { 0x3523, "explo_delay_chance_" },
    { 0x3524, "explo_shot_array_" },
    { 0x3525, "explo_tail_alias_" },
    { 0x3526, "explode_drone_on_impact" },
    { 0x3527, "explode_drones_at_tanker" },
    { 0x3528, "explode_on_ground_impact" },
    { 0x3529, "explode_tanker" },
    { 0x352A, "exploded" },
    { 0x352B, "exploder" },
    { 0x352C, "exploder_after_load" },
    { 0x352D, "exploder_before_load" },
    { 0x352E, "exploder_damage" },
    { 0x352F, "exploder_delay" },
    { 0x3530, "exploder_earthquake" },
    { 0x3531, "exploder_flag_wait" },
    { 0x3532, "exploder_load" },
    { 0x3533, "exploder_model_is_chunk" },
    { 0x3534, "exploder_model_is_damaged_model" },
    { 0x3535, "exploder_model_starts_hidden" },
    { 0x3536, "exploder_num_" },
    { 0x3537, "exploder_pigeon" },
    { 0x3538, "exploder_playsound" },
    { 0x3539, "exploder_rumble" },
    { 0x353A, "exploder_sound" },
    { 0x353B, "exploder_to_array" },
    { 0x353C, "exploderfunction" },
    { 0x353D, "exploderfx" },
    { 0x353E, "exploderindex" },
    { 0x353F, "exploders" },
    { 0x3540, "exploding" },
    { 0x3541, "exploding_barrel_death" },
    { 0x3542, "explosion_cart_kill_trigger" },
    { 0x3543, "explosion_death" },
    { 0x3544, "explosion_death_offset" },
    { 0x3545, "explosion_death_ragdollfraction" },
    { 0x3546, "explosion_player_rumbles" },
    { 0x3547, "explosion_pos" },
    { 0x3548, "explosion_scene_bridge" },
    { 0x3549, "explosion_scene_drone_large" },
    { 0x354A, "explosion_scene_drones" },
    { 0x354B, "explosion_scene_org" },
    { 0x354C, "explosion_screen_flash" },
    { 0x354D, "explosion_van" },
    { 0x354E, "explosionangleoffset" },
    { 0x354F, "explosionoffset" },
    { 0x3550, "explosions" },
    { 0x3551, "explosive_bulletshielded" },
    { 0x3552, "explosive_drone_owner" },
    { 0x3553, "explosivedamagemod" },
    { 0x3554, "explosivedamagemonitor" },
    { 0x3555, "explosivedrone" },
    { 0x3556, "explosivedrone_changeowner" },
    { 0x3557, "explosivedrone_enemy_lightfx" },
    { 0x3558, "explosivedrone_followtarget" },
    { 0x3559, "explosivedrone_friendly_lightfx" },
    { 0x355A, "explosivedrone_grenade_stunbegin" },
    { 0x355B, "explosivedrone_grenade_stunend" },
    { 0x355C, "explosivedrone_grenade_stunned" },
    { 0x355D, "explosivedrone_grenade_watchdisable" },
    { 0x355E, "explosivedrone_highlighttarget" },
    { 0x355F, "explosivedrone_leave" },
    { 0x3560, "explosivedrone_movetoplayer" },
    { 0x3561, "explosivedrone_stopmovement" },
    { 0x3562, "explosivedrone_stunbegin" },
    { 0x3563, "explosivedrone_stunend" },
    { 0x3564, "explosivedrone_stunned" },
    { 0x3565, "explosivedrone_watchdeath" },
    { 0x3566, "explosivedrone_watchdisable" },
    { 0x3567, "explosivedrone_watchforgoal" },
    { 0x3568, "explosivedrone_watchhostmigration" },
    { 0x3569, "explosivedrone_watchownerdeath" },
    { 0x356A, "explosivedrone_watchownerloss" },
    { 0x356B, "explosivedrone_watchroundend" },
    { 0x356C, "explosivedrone_watchtargetdisconnect" },
    { 0x356D, "explosivedrone_watchtimeout" },
    { 0x356E, "explosivedronearray" },
    { 0x356F, "explosivedronedebugposition" },
    { 0x3570, "explosivedronedebugpositionforward" },
    { 0x3571, "explosivedronedebugpositionheight" },
    { 0x3572, "explosivedronedeletetrigger" },
    { 0x3573, "explosivedronedestroyed" },
    { 0x3574, "explosivedroneexplode" },
    { 0x3575, "explosivedroneinit" },
    { 0x3576, "explosivedronelink" },
    { 0x3577, "explosivedronemaxperplayer" },
    { 0x3578, "explosivedroneproximitytrigger" },
    { 0x3579, "explosivedrones" },
    { 0x357A, "explosivedronesettings" },
    { 0x357B, "explosivedronetimeout" },
    { 0x357C, "explosivegelcountdowndetonation" },
    { 0x357D, "explosivegelsettings" },
    { 0x357E, "explosivegrenadedeath" },
    { 0x357F, "explosiveheaddeath" },
    { 0x3580, "explosiveimpulse" },
    { 0x3581, "explosiveinfo" },
    { 0x3582, "explosivekills" },
    { 0x3583, "explosiveplanttime" },
    { 0x3584, "explosiveragdolldeath" },
    { 0x3585, "explosivetimeout" },
    { 0x3586, "exponent" },
    { 0x3587, "export" },
    { 0x3588, "exposed_group_logic" },
    { 0x3589, "exposed_guard_warning_given" },
    { 0x358A, "exposed_guard_warning_vo" },
    { 0x358B, "exposed_vo_said" },
    { 0x358C, "exposedapproachconditioncheck" },
    { 0x358D, "exposedapproachwaittillclose" },
    { 0x358E, "exposedcombatcheckputawaypistol" },
    { 0x358F, "exposedcombatcheckreloadorusepistol" },
    { 0x3590, "exposedcombatcheckstance" },
    { 0x3591, "exposedcombatmainloop" },
    { 0x3592, "exposedcombatneedtoturn" },
    { 0x3593, "exposedcombatpositionadjust" },
    { 0x3594, "exposedcombatstopusingrpgcheck" },
    { 0x3595, "exposedreload" },
    { 0x3596, "exposedreloading" },
    { 0x3597, "exposedtransition" },
    { 0x3598, "exposedwait" },
    { 0x3599, "exposure_adjust_courtyard_room" },
    { 0x359A, "exposure_adjust_courtyard_room_volume" },
    { 0x359B, "extended_idle_anims" },
    { 0x359C, "extendedkill_sticktovictim" },
    { 0x359D, "exterior_street_kickoff" },
    { 0x359E, "extra_autosave_checks_failed" },
    { 0x359F, "extra_cloud_cover_end" },
    { 0x35A0, "extra_cloud_cover_start" },
    { 0x35A1, "extra_height" },
    { 0x35A2, "extra_lookahead" },
    { 0x35A3, "extra_slow_player" },
    { 0x35A4, "extra_static" },
    { 0x35A5, "extra_vehicle_cleanup" },
    { 0x35A6, "extraction_chopper" },
    { 0x35A7, "extraction_chopper_collapse" },
    { 0x35A8, "extraction_chopper_move" },
    { 0x35A9, "extraction_chopper_spawn" },
    { 0x35AA, "extraction_nag_lines" },
    { 0x35AB, "extractionloc" },
    { 0x35AC, "extraenemiescombat" },
    { 0x35AD, "extrafiretime_max" },
    { 0x35AE, "extrafiretime_min" },
    { 0x35AF, "extraflare" },
    { 0x35B0, "extrahealthinit" },
    { 0x35B1, "extraspintime_max" },
    { 0x35B2, "extraspintime_min" },
    { 0x35B3, "eye_move_counter" },
    { 0x35B4, "eye_origin" },
    { 0x35B5, "eye_velocity" },
    { 0x35B6, "eyeheightlastframe" },
    { 0x35B7, "f_score" },
    { 0x35B8, "face_dof_mod" },
    { 0x35B9, "faceenemyaimtracking" },
    { 0x35BA, "faceenemyarrival" },
    { 0x35BB, "faceenemyatendofapproach" },
    { 0x35BC, "faceenemydelay" },
    { 0x35BD, "faceenemyimmediately" },
    { 0x35BE, "facelastnotifynum" },
    { 0x35BF, "facelight" },
    { 0x35C0, "faceresult" },
    { 0x35C1, "facewaitforresult" },
    { 0x35C2, "facewaiting" },
    { 0x35C3, "faceyaw" },
    { 0x35C4, "facial" },
    { 0x35C5, "facial_animation" },
    { 0x35C6, "facial_idle_monitor_thread" },
    { 0x35C7, "facialanimdone" },
    { 0x35C8, "facialanimidx" },
    { 0x35C9, "facialidlemonitor" },
    { 0x35CA, "facialidx" },
    { 0x35CB, "facialsounddone" },
    { 0x35CC, "facility_breach" },
    { 0x35CD, "facility_breach_charge" },
    { 0x35CE, "facility_breach_cleanup_player" },
    { 0x35CF, "facility_breach_crate" },
    { 0x35D0, "facility_breach_dialogue" },
    { 0x35D1, "facility_breach_get_burke_into_position" },
    { 0x35D2, "facility_breach_guys" },
    { 0x35D3, "facility_breach_logic" },
    { 0x35D4, "facility_breach_mute_device" },
    { 0x35D5, "facility_breach_nag_dialogue" },
    { 0x35D6, "facility_breach_rumbles" },
    { 0x35D7, "facility_breach_setup_player" },
    { 0x35D8, "facility_breach_spawn_bad_guys" },
    { 0x35D9, "facility_bridge_enemy_think" },
    { 0x35DA, "facing" },
    { 0x35DB, "facing_goal" },
    { 0x35DC, "fade" },
    { 0x35DD, "fade_from_black" },
    { 0x35DE, "fade_glow" },
    { 0x35DF, "fade_in" },
    { 0x35E0, "fade_in_crash_site" },
    { 0x35E1, "fade_in_inc" },
    { 0x35E2, "fade_in_intro_ambis" },
    { 0x35E3, "fade_in_scalar" },
    { 0x35E4, "fade_in_time" },
    { 0x35E5, "fade_name_random" },
    { 0x35E6, "fade_out" },
    { 0x35E7, "fade_out_level" },
    { 0x35E8, "fade_out_text" },
    { 0x35E9, "fade_out_time" },
    { 0x35EA, "fade_out_use_hint" },
    { 0x35EB, "fade_over_time" },
    { 0x35EC, "fade_time" },
    { 0x35ED, "fade_to_black" },
    { 0x35EE, "fade_to_white" },
    { 0x35EF, "fadeaway" },
    { 0x35F0, "fadedownstatic" },
    { 0x35F1, "fadefunc" },
    { 0x35F2, "fadein" },
    { 0x35F3, "fadein_time" },
    { 0x35F4, "fadeinblackout" },
    { 0x35F5, "fadeinoutgastrackingoverlay" },
    { 0x35F6, "fadeinoutprisontrackingoverlay" },
    { 0x35F7, "fadeoffset" },
    { 0x35F8, "fadeout_time" },
    { 0x35F9, "fadeoutblackout" },
    { 0x35FA, "fadeoverlay" },
    { 0x35FB, "fadetime" },
    { 0x35FC, "fadetoalpha" },
    { 0x35FD, "fadetoalphatime" },
    { 0x35FE, "fadeupstatic" },
    { 0x35FF, "fail_chase_van" },
    { 0x3600, "fail_duration" },
    { 0x3601, "fail_enable" },
    { 0x3602, "fail_leaving_area" },
    { 0x3603, "fail_missile_damage_think" },
    { 0x3604, "fail_on_friendly_fire" },
    { 0x3605, "fail_on_kill_civilian" },
    { 0x3606, "fail_out_of_range" },
    { 0x3607, "fail_player_for_abandon" },
    { 0x3608, "fail_range" },
    { 0x3609, "fail_start_time" },
    { 0x360A, "fail_success_allowed" },
    { 0x360B, "fail_time" },
    { 0x360C, "fail_trigger_move_on_notify" },
    { 0x360D, "failallydeath" },
    { 0x360E, "failatriumfighttimerexpire" },
    { 0x360F, "failburkekilled" },
    { 0x3610, "faildetonateambushinteract" },
    { 0x3611, "failed_music_alias" },
    { 0x3612, "failed_spawnvehicles" },
    { 0x3613, "failed_to_avoid_buttress" },
    { 0x3614, "failed_to_keep_up" },
    { 0x3615, "failed_vo" },
    { 0x3616, "failed_vo_setup" },
    { 0x3617, "failhadesstabplayer" },
    { 0x3618, "failingmission" },
    { 0x3619, "failinvalidtarget" },
    { 0x361A, "failkillhadeslate" },
    { 0x361B, "failkillhadessoon" },
    { 0x361C, "faillevelalarm" },
    { 0x361D, "failonfriendlyfire" },
    { 0x361E, "failsetupambushleavemission" },
    { 0x361F, "failsetupambushtimerexpire" },
    { 0x3620, "failtargetescaped1" },
    { 0x3621, "failtargetescaped2" },
    { 0x3622, "failtargetescaped3" },
    { 0x3623, "failureeventemp" },
    { 0x3624, "failureeventmissileburst" },
    { 0x3625, "failureeventmissileburstgas" },
    { 0x3626, "failureeventmissileburstgasdamage" },
    { 0x3627, "failureeventmissileburstthink" },
    { 0x3628, "failureeventpistolsonly" },
    { 0x3629, "failureeventpistolsonlyjammedbar" },
    { 0x362A, "failureeventpistolsonlythink" },
    { 0x362B, "failureeventpistolsreenabled" },
    { 0x362C, "failureeventsentry" },
    { 0x362D, "failureeventsmoke" },
    { 0x362E, "failureeventsmokethink" },
    { 0x362F, "failureeventupdateweaponjammedbar" },
    { 0x3630, "failurepistolshandleremotereturn" },
    { 0x3631, "fake_anim_shoot" },
    { 0x3632, "fake_attachedguys" },
    { 0x3633, "fake_bullet_damage_sounds" },
    { 0x3634, "fake_cockpit_jitter" },
    { 0x3635, "fake_damage_indicator" },
    { 0x3636, "fake_death" },
    { 0x3637, "fake_death_bullet" },
    { 0x3638, "fake_death_bullet_fx" },
    { 0x3639, "fake_death_over_time" },
    { 0x363A, "fake_drone_death" },
    { 0x363B, "fake_drone_shooting" },
    { 0x363C, "fake_drone_shooting_internal" },
    { 0x363D, "fake_drop_pods" },
    { 0x363E, "fake_enemy_missile_spawn" },
    { 0x363F, "fake_gunfire_shooter" },
    { 0x3640, "fake_gunfire_shooter_ambulance" },
    { 0x3641, "fake_gunfire_shooter_exopush_back" },
    { 0x3642, "fake_gunfire_shooter_exopush_front" },
    { 0x3643, "fake_gunfire_shooter_exopush_mid" },
    { 0x3644, "fake_gunfire_sniper_moment" },
    { 0x3645, "fake_laser" },
    { 0x3646, "fake_linkto" },
    { 0x3647, "fake_linkto_internal" },
    { 0x3648, "fake_loot_dispensation_logic" },
    { 0x3649, "fake_missile_from_behind_player" },
    { 0x364A, "fake_missile_target" },
    { 0x364B, "fake_plane" },
    { 0x364C, "fake_rocket_explode_moment" },
    { 0x364D, "fake_rocket_fire_notify" },
    { 0x364E, "fake_scanning_fx_thread" },
    { 0x364F, "fake_spotlight" },
    { 0x3650, "fake_tread_fx_hostage_truck" },
    { 0x3651, "fake_unlink" },
    { 0x3652, "fake_usedpositions" },
    { 0x3653, "fake_vehicle_fake_collision" },
    { 0x3654, "fake_vehicle_model" },
    { 0x3655, "fakehealth" },
    { 0x3656, "fakespeed" },
    { 0x3657, "faketurret" },
    { 0x3658, "fall_cave_swell" },
    { 0x3659, "fall_fail" },
    { 0x365A, "fall_speed_status" },
    { 0x365B, "fallback" },
    { 0x365C, "fallback_ai" },
    { 0x365D, "fallback_ai_think" },
    { 0x365E, "fallback_ai_think_death" },
    { 0x365F, "fallback_coverprint" },
    { 0x3660, "fallback_death" },
    { 0x3661, "fallback_goal" },
    { 0x3662, "fallback_initiated" },
    { 0x3663, "fallback_print" },
    { 0x3664, "fallback_spawner_think" },
    { 0x3665, "fallback_think" },
    { 0x3666, "fallback_wait" },
    { 0x3667, "falling_bits_fx" },
    { 0x3668, "falling_death" },
    { 0x3669, "falling_dust_on_cable" },
    { 0x366A, "falling_guard" },
    { 0x366B, "falloff" },
    { 0x366C, "fallvelmultiplier" },
    { 0x366D, "fan_blade_rotate" },
    { 0x366E, "far_enough_from_leader" },
    { 0x366F, "far_explode" },
    { 0x3670, "farflightsound" },
    { 0x3671, "farspawns" },
    { 0x3672, "farther_to_goal_vol" },
    { 0x3673, "fartherfunc" },
    { 0x3674, "fast_destructible_explode" },
    { 0x3675, "fastburst" },
    { 0x3676, "fastburstcount" },
    { 0x3677, "fastburstfirenumshots" },
    { 0x3678, "fastburstmodtime" },
    { 0x3679, "fastcloud_rumble_ent" },
    { 0x367A, "fastcloudlevel" },
    { 0x367B, "fastcloudrumble" },
    { 0x367C, "fastcrouch" },
    { 0x367D, "fasteranimspeed" },
    { 0x367E, "fastesttime" },
    { 0x367F, "fasthealinit" },
    { 0x3680, "fasthealsettings" },
    { 0x3681, "fastlook" },
    { 0x3682, "fastropeoffset" },
    { 0x3683, "fastroperig" },
    { 0x3684, "fastroperiganimating" },
    { 0x3685, "faststand" },
    { 0x3686, "fastwalk" },
    { 0x3687, "fastzip_explosion_seq" },
    { 0x3688, "fastzip_hit_the_ground" },
    { 0x3689, "fastzip_land" },
    { 0x368A, "fastzip_launch" },
    { 0x368B, "fastzip_rappel" },
    { 0x368C, "fastzip_slide" },
    { 0x368D, "fastzip_slide_end" },
    { 0x368E, "fastzip_turret_fire" },
    { 0x368F, "fastzip_turret_pullout" },
    { 0x3690, "fastzip_turret_putaway" },
    { 0x3691, "fastzip_turret_switch_complete" },
    { 0x3692, "fastzip_turret_switch_to" },
    { 0x3693, "fastzip_turret_think" },
    { 0x3694, "fastzip_unload" },
    { 0x3695, "faux_spawn_stance" },
    { 0x3696, "fauxdead" },
    { 0x3697, "fauxvehiclecount" },
    { 0x3698, "fav_random_switch" },
    { 0x3699, "favor_blindfire" },
    { 0x369A, "favrandom" },
    { 0x369B, "faze_out" },
    { 0x369C, "faze_out_finish" },
    { 0x369D, "fbt_desireddistmax" },
    { 0x369E, "fbt_firstburst" },
    { 0x369F, "fbt_lastbursterid" },
    { 0x36A0, "fbt_linebreakmax" },
    { 0x36A1, "fbt_linebreakmin" },
    { 0x36A2, "fbt_waitmax" },
    { 0x36A3, "fbt_waitmin" },
    { 0x36A4, "female_civilian_alert_sound" },
    { 0x36A5, "ffpoints" },
    { 0x36A6, "fieldgoalevent" },
    { 0x36A7, "fight_section_ambient_encounter" },
    { 0x36A8, "fight_section_boost_encounter" },
    { 0x36A9, "fight_section_crash_encounter" },
    { 0x36AA, "fight_section_escape_encounter" },
    { 0x36AB, "fight_section_pitbull_encounter" },
    { 0x36AC, "fight_section_police_encounter" },
    { 0x36AD, "fight_section_standoff_encounter" },
    { 0x36AE, "fight_section_tanker_encouter" },
    { 0x36AF, "fightdist" },
    { 0x36B0, "fighter_jet_crash_detection" },
    { 0x36B1, "fighter_jet_gun_hud" },
    { 0x36B2, "fighter_jet_handle_cockpit" },
    { 0x36B3, "fighter_jet_handle_cockpit_motion" },
    { 0x36B4, "fighter_jet_handle_throttle" },
    { 0x36B5, "fighter_jet_hud" },
    { 0x36B6, "fighter_jet_max_altitude" },
    { 0x36B7, "fighter_jet_set_shake" },
    { 0x36B8, "fighter_jet_sounds" },
    { 0x36B9, "fileprint_csv_start" },
    { 0x36BA, "fileprint_launcher" },
    { 0x36BB, "fileprint_launcher_end_file" },
    { 0x36BC, "fileprint_launcher_start_file" },
    { 0x36BD, "fileprint_map_entity_end" },
    { 0x36BE, "fileprint_map_entity_start" },
    { 0x36BF, "fileprint_map_header" },
    { 0x36C0, "fileprint_map_keypairprint" },
    { 0x36C1, "fileprint_map_start" },
    { 0x36C2, "fileprint_radiant_vec" },
    { 0x36C3, "fileprint_start" },
    { 0x36C4, "fileprintlauncher_linecount" },
    { 0x36C5, "fill" },
    { 0x36C6, "fill_new_traffic_entity_near_player" },
    { 0x36C7, "fill_pos_ent" },
    { 0x36C8, "filter_bypass" },
    { 0x36C9, "filter_enable" },
    { 0x36CA, "filter_lead_controller_init" },
    { 0x36CB, "filter_lead_controller_update" },
    { 0x36CC, "filter_nodes" },
    { 0x36CD, "filter1" },
    { 0x36CE, "filter2" },
    { 0x36CF, "filteraiarray" },
    { 0x36D0, "filters" },
    { 0x36D1, "fin_bldg_exp_audio" },
    { 0x36D2, "fin_bullet_trails" },
    { 0x36D3, "fin_ending_gideon_foley_1" },
    { 0x36D4, "fin_ending_gideon_foley_2" },
    { 0x36D5, "fin_ending_knife_drop" },
    { 0x36D6, "fin_ending_plr_foley_1" },
    { 0x36D7, "fin_ending_plr_foley_2" },
    { 0x36D8, "fin_ending_qte_stab" },
    { 0x36D9, "fin_ending_slo_mo_override" },
    { 0x36DA, "fin_ending1_1_gdn" },
    { 0x36DB, "fin_ending1_1_irs" },
    { 0x36DC, "fin_ending1_2_gdn" },
    { 0x36DD, "fin_ending2_1_irs" },
    { 0x36DE, "fin_ending2_2_gdn" },
    { 0x36DF, "fin_ending2_3combined_irs" },
    { 0x36E0, "fin_ending2_5_irs" },
    { 0x36E1, "fin_flyin_drop" },
    { 0x36E2, "fin_flyin_gideon_splash" },
    { 0x36E3, "fin_flyin_splash" },
    { 0x36E4, "fin_flyin_start" },
    { 0x36E5, "fin_gid_carry_pickup_1" },
    { 0x36E6, "fin_gid_carry_pickup_2" },
    { 0x36E7, "fin_gid_carry_plr_1" },
    { 0x36E8, "fin_gid_carry_plr_2" },
    { 0x36E9, "fin_gid_carry_plr_3" },
    { 0x36EA, "fin_gid_carry_plr_4" },
    { 0x36EB, "fin_gid_exit_water" },
    { 0x36EC, "fin_gid_plr_putdown" },
    { 0x36ED, "fin_glass_exp_audio" },
    { 0x36EE, "fin_irons_reveal_gun_away_exit" },
    { 0x36EF, "fin_irons_reveal_irons_points_gun" },
    { 0x36F0, "fin_irons_reveal_irons_quake" },
    { 0x36F1, "fin_irons_reveal_irons_start" },
    { 0x36F2, "fin_irons_reveal_irons_takes_gun" },
    { 0x36F3, "fin_irons_reveal_mash" },
    { 0x36F4, "fin_irons_reveal_mash_finish" },
    { 0x36F5, "fin_irons_reveal_mash_start" },
    { 0x36F6, "fin_irons_reveal_mash_try_stop" },
    { 0x36F7, "fin_irons_reveal_plr_stand" },
    { 0x36F8, "fin_irons_reveal_plr_start" },
    { 0x36F9, "fin_irons_reveal_scene_gid_exo_freeze" },
    { 0x36FA, "fin_irons_reveal_scene_gid_start" },
    { 0x36FB, "fin_irons_tackle" },
    { 0x36FC, "fin_irons_takedown_start" },
    { 0x36FD, "fin_lobby_gun_limp" },
    { 0x36FE, "fin_mech_exit_gideon" },
    { 0x36FF, "fin_midair_exp_audio" },
    { 0x3700, "fin_mitchel_vo" },
    { 0x3701, "fin_post_silo_gid_foley" },
    { 0x3702, "fin_post_silo_switch_to_plr" },
    { 0x3703, "fin_reveal_gid_drops_plr" },
    { 0x3704, "fin_silo_fail_launch" },
    { 0x3705, "fin_silo_plr_picked_up" },
    { 0x3706, "fin_silo_success" },
    { 0x3707, "fin_skybridge_glass_explo" },
    { 0x3708, "fin_skybridge_slo_mo_start" },
    { 0x3709, "fin_skybridge_slo_mo_stop" },
    { 0x370A, "fin_skybridge_takedown_start" },
    { 0x370B, "fin_water_exp_audio" },
    { 0x370C, "final_animation_angles" },
    { 0x370D, "final_animation_origin" },
    { 0x370E, "final_approach" },
    { 0x370F, "final_bus" },
    { 0x3710, "final_chopper_lighting" },
    { 0x3711, "final_flag_wait" },
    { 0x3712, "final_loc" },
    { 0x3713, "final_player_rig" },
    { 0x3714, "final_pod_crash_fast" },
    { 0x3715, "final_scene_handle_melee_hint" },
    { 0x3716, "final_scripted_chopper" },
    { 0x3717, "final_takedown_abutton_hit" },
    { 0x3718, "final_takedown_gun_up" },
    { 0x3719, "final_takedown_xbutton_hit" },
    { 0x371A, "final_use_struct" },
    { 0x371B, "finalblackout" },
    { 0x371C, "finale_cineviewmodel_lighting" },
    { 0x371D, "finale_civ_04_cower" },
    { 0x371E, "finale_cloak_off" },
    { 0x371F, "finale_cormack_decloak" },
    { 0x3720, "finale_cormack_walk_1" },
    { 0x3721, "finale_cormack_walk_2" },
    { 0x3722, "finale_cormack_walk_3" },
    { 0x3723, "finale_crate_close" },
    { 0x3724, "finale_crate_open_1" },
    { 0x3725, "finale_ending_buttonmash_fail" },
    { 0x3726, "finale_ending_buttonmash_start" },
    { 0x3727, "finale_ending_qte1_success" },
    { 0x3728, "finale_ending_qte1_timeout" },
    { 0x3729, "finale_ending_qte2_success" },
    { 0x372A, "finale_ending_qte2_timeout" },
    { 0x372B, "finale_enemy_gaz" },
    { 0x372C, "finale_enemy_gaz_1" },
    { 0x372D, "finale_enemy_transports" },
    { 0x372E, "finale_eyes_custom_mats_on" },
    { 0x372F, "finale_gideon_jump" },
    { 0x3730, "finale_gideon_leave" },
    { 0x3731, "finale_gideon_radio" },
    { 0x3732, "finale_ilana_land" },
    { 0x3733, "finale_ilana_turn" },
    { 0x3734, "finale_intro_screen" },
    { 0x3735, "finale_jet" },
    { 0x3736, "finale_joker_jump" },
    { 0x3737, "finale_mwp_lighting_offset" },
    { 0x3738, "finale_part1_cineviewmodel_lighting" },
    { 0x3739, "finale_pod" },
    { 0x373A, "finale_qte_show_knife" },
    { 0x373B, "finale_section_ambientfx_aa_explosions" },
    { 0x373C, "finale_section_ambientfx_midair_explosions" },
    { 0x373D, "finale_section_ambientfx_windowglass_explosion" },
    { 0x373E, "finale_street_crowd" },
    { 0x373F, "finale_trigger_pulled" },
    { 0x3740, "finalizespawnpointchoice" },
    { 0x3741, "finalkill" },
    { 0x3742, "finalkillcam_attacker" },
    { 0x3743, "finalkillcam_attackernum" },
    { 0x3744, "finalkillcam_deathtimeoffset" },
    { 0x3745, "finalkillcam_delay" },
    { 0x3746, "finalkillcam_killcamentityindex" },
    { 0x3747, "finalkillcam_killcamentitystarttime" },
    { 0x3748, "finalkillcam_psoffsettime" },
    { 0x3749, "finalkillcam_smeansofdeath" },
    { 0x374A, "finalkillcam_sweapon" },
    { 0x374B, "finalkillcam_timegameended" },
    { 0x374C, "finalkillcam_timerecorded" },
    { 0x374D, "finalkillcam_type" },
    { 0x374E, "finalkillcam_usestarttime" },
    { 0x374F, "finalkillcam_victim" },
    { 0x3750, "finalkillcam_winner" },
    { 0x3751, "finalkillcammusic" },
    { 0x3752, "finalsurvivorevent" },
    { 0x3753, "finalsurvivoruav" },
    { 0x3754, "find_a_new_turret_spot" },
    { 0x3755, "find_adjacent_target" },
    { 0x3756, "find_ambush_node" },
    { 0x3757, "find_best_cam_path" },
    { 0x3758, "find_best_exit_anim" },
    { 0x3759, "find_best_target" },
    { 0x375A, "find_camp_node" },
    { 0x375B, "find_camp_node_worker" },
    { 0x375C, "find_closest_bombzone_to_player" },
    { 0x375D, "find_closest_car" },
    { 0x375E, "find_closest_heli_node_2d" },
    { 0x375F, "find_connected_turrets" },
    { 0x3760, "find_dds_category_by_name" },
    { 0x3761, "find_defend_node_bodyguard" },
    { 0x3762, "find_defend_node_capture" },
    { 0x3763, "find_defend_node_capture_zone" },
    { 0x3764, "find_defend_node_patrol" },
    { 0x3765, "find_defend_node_protect" },
    { 0x3766, "find_destructibles" },
    { 0x3767, "find_different_way_to_attack_last_seen_position" },
    { 0x3768, "find_drop_path" },
    { 0x3769, "find_good_ambush_spot" },
    { 0x376A, "find_landing_node_along_path" },
    { 0x376B, "find_new_chase_target" },
    { 0x376C, "find_node_neighbors" },
    { 0x376D, "find_non_squad_allies_by_distance" },
    { 0x376E, "find_npc_dive_boat_handler" },
    { 0x376F, "find_path_between_aerial_nodes" },
    { 0x3770, "find_tactical_override" },
    { 0x3771, "find_threat" },
    { 0x3772, "find_ticking_bomb" },
    { 0x3773, "find_unclaimed_node" },
    { 0x3774, "find_unique_offset" },
    { 0x3775, "find_unload_node" },
    { 0x3776, "find_zones" },
    { 0x3777, "findandplayanims" },
    { 0x3778, "findaveragepoint" },
    { 0x3779, "findaveragepointvec" },
    { 0x377A, "findbattlebuddy" },
    { 0x377B, "findbestspawnlocation" },
    { 0x377C, "findboxcenter" },
    { 0x377D, "findbuddypathnode" },
    { 0x377E, "findbuddyspawn" },
    { 0x377F, "findclosenode" },
    { 0x3780, "findclosestplayer" },
    { 0x3781, "findcqbpointsofinterest" },
    { 0x3782, "finddisplay" },
    { 0x3783, "findgoodsuppressspot" },
    { 0x3784, "findingcqbpointsofinterest" },
    { 0x3785, "findisfacing" },
    { 0x3786, "findlocation" },
    { 0x3787, "findnewtargetpos" },
    { 0x3788, "findpointnearowner" },
    { 0x3789, "findpositionnum" },
    { 0x378A, "findrandomlocationneartarget" },
    { 0x378B, "findsecondhighestspawnscore" },
    { 0x378C, "findshockvictims" },
    { 0x378D, "findsnipertargetnearactor" },
    { 0x378E, "findspawnlocationnearplayer" },
    { 0x378F, "finger_material_swap" },
    { 0x3790, "finish_bodies_room_burke" },
    { 0x3791, "finish_creating_entity" },
    { 0x3792, "finish_drag_player_internal" },
    { 0x3793, "finish_drag_player_internal_delayed" },
    { 0x3794, "finish_fly_in_sequence" },
    { 0x3795, "finish_mission_fade" },
    { 0x3796, "finishairstrikeusage" },
    { 0x3797, "finishcoverexitnotetracks" },
    { 0x3798, "finishdeathwaiter" },
    { 0x3799, "finished" },
    { 0x379A, "finished_spawning" },
    { 0x379B, "finishedreload" },
    { 0x379C, "finishnotetracks" },
    { 0x379D, "finishplayerdamagewrapper" },
    { 0x379E, "finishreconagentloadout" },
    { 0x379F, "finishtraversedrop" },
    { 0x37A0, "fire" },
    { 0x37A1, "fire_and_forget" },
    { 0x37A2, "fire_archlight_rumbles" },
    { 0x37A3, "fire_at_dead_time" },
    { 0x37A4, "fire_at_ent" },
    { 0x37A5, "fire_at_target" },
    { 0x37A6, "fire_at_target_until_dead" },
    { 0x37A7, "fire_at_truck_01" },
    { 0x37A8, "fire_bullets_at_ent" },
    { 0x37A9, "fire_burst" },
    { 0x37AA, "fire_delay" },
    { 0x37AB, "fire_door_1_close" },
    { 0x37AC, "fire_door_1_open" },
    { 0x37AD, "fire_door_shield" },
    { 0x37AE, "fire_drone_swarm_at_walker" },
    { 0x37AF, "fire_drones_at_ent" },
    { 0x37B0, "fire_effect" },
    { 0x37B1, "fire_effects" },
    { 0x37B2, "fire_emp_wave" },
    { 0x37B3, "fire_ending_light" },
    { 0x37B4, "fire_fake_rocket_function" },
    { 0x37B5, "fire_first_tanker_missile" },
    { 0x37B6, "fire_flicker" },
    { 0x37B7, "fire_guns" },
    { 0x37B8, "fire_hint_display" },
    { 0x37B9, "fire_inside_02_manage" },
    { 0x37BA, "fire_light_on_dna_bomb_01" },
    { 0x37BB, "fire_light_on_dna_bomb_02" },
    { 0x37BC, "fire_loop_at_target_with_delay" },
    { 0x37BD, "fire_missile" },
    { 0x37BE, "fire_missiles" },
    { 0x37BF, "fire_missiles_at_drone_swarm" },
    { 0x37C0, "fire_missles_at_target_array" },
    { 0x37C1, "fire_missles_at_target_array_repeated" },
    { 0x37C2, "fire_notetrack_functions" },
    { 0x37C3, "fire_on_allies" },
    { 0x37C4, "fire_radius" },
    { 0x37C5, "fire_random_bomblet" },
    { 0x37C6, "fire_rate" },
    { 0x37C7, "fire_rocket_at" },
    { 0x37C8, "fire_rockets" },
    { 0x37C9, "fire_rope" },
    { 0x37CA, "fire_straight" },
    { 0x37CB, "fire_straight_bomblet" },
    { 0x37CC, "fire_targeted_bomblet" },
    { 0x37CD, "fireai" },
    { 0x37CE, "fireairocket" },
    { 0x37CF, "fireatposition" },
    { 0x37D0, "firebabymissile" },
    { 0x37D1, "firebigorbitalsupportgun" },
    { 0x37D2, "firebuddymediumorbitalsupportgun" },
    { 0x37D3, "firebuddythreatgrenades" },
    { 0x37D4, "firecontroller" },
    { 0x37D5, "firecontroller_minigun" },
    { 0x37D6, "firecontrollerfunc" },
    { 0x37D7, "firedirector" },
    { 0x37D8, "firedroppod" },
    { 0x37D9, "fireduration" },
    { 0x37DA, "fireempgrenades" },
    { 0x37DB, "fireinterval" },
    { 0x37DC, "firekamikazedrones" },
    { 0x37DD, "firelaserbeam" },
    { 0x37DE, "firelight_on_plane_01" },
    { 0x37DF, "firelight_volume" },
    { 0x37E0, "firelight_volume2" },
    { 0x37E1, "firemangarockets" },
    { 0x37E2, "firemediumorbitalsupportgun" },
    { 0x37E3, "firemediumorbitalsupportvolley" },
    { 0x37E4, "firemissile" },
    { 0x37E5, "fireorbitalmissile" },
    { 0x37E6, "firepod" },
    { 0x37E7, "firereadytime" },
    { 0x37E8, "firerocketorbitalsupportgun" },
    { 0x37E9, "firerocketswarm" },
    { 0x37EA, "fires_explosives" },
    { 0x37EB, "firesoundent" },
    { 0x37EC, "firestingerrumble" },
    { 0x37ED, "firetarget" },
    { 0x37EE, "fireteammembers" },
    { 0x37EF, "firethreatgrenades" },
    { 0x37F0, "firetime" },
    { 0x37F1, "fireuntiloutofammo" },
    { 0x37F2, "fireuntiloutofammo_waittillended" },
    { 0x37F3, "fireuntiloutofammointernal" },
    { 0x37F4, "firewarbirdrockets" },
    { 0x37F5, "firewarbirdthreatgrenades" },
    { 0x37F6, "firing_range_kill_glow" },
    { 0x37F7, "firing_range_round_1_glow" },
    { 0x37F8, "firing_range_round_2_glow" },
    { 0x37F9, "firing_range_round_3_glow" },
    { 0x37FA, "firing_range_setup_3dui_screens" },
    { 0x37FB, "firing_range_setup_booth_displays" },
    { 0x37FC, "firing_range_setup_env" },
    { 0x37FD, "firing_range_setup_env_vfx" },
    { 0x37FE, "firing_range_setup_floor_panels" },
    { 0x37FF, "firing_range_setup_max_range" },
    { 0x3800, "firing_range_setup_min_range" },
    { 0x3801, "firing_range_setup_target_logic" },
    { 0x3802, "firing_range_setup_targets" },
    { 0x3803, "firing_range_setup_triggers" },
    { 0x3804, "firing_sound_ent" },
    { 0x3805, "firingdamagetrig" },
    { 0x3806, "firingdeathallowed" },
    { 0x3807, "firingguns" },
    { 0x3808, "firingmissiles" },
    { 0x3809, "firingrange" },
    { 0x380A, "firingrangecleanup" },
    { 0x380B, "firingweapons" },
    { 0x380C, "first_drop_pod_submix" },
    { 0x380D, "first_event" },
    { 0x380E, "first_event_max" },
    { 0x380F, "first_event_min" },
    { 0x3810, "first_floor_trigger_think" },
    { 0x3811, "first_frame" },
    { 0x3812, "first_frame_time" },
    { 0x3813, "first_guy_looking" },
    { 0x3814, "first_nightclub_room_setup" },
    { 0x3815, "first_oven" },
    { 0x3816, "first_point" },
    { 0x3817, "first_response" },
    { 0x3818, "first_touch" },
    { 0x3819, "firstbloodevent" },
    { 0x381A, "firstbreacher" },
    { 0x381B, "firstcapture" },
    { 0x381C, "firstcontact" },
    { 0x381D, "firstdroppod" },
    { 0x381E, "firstguy" },
    { 0x381F, "firsthalftimepassed" },
    { 0x3820, "firstinfectedevent" },
    { 0x3821, "firstinit" },
    { 0x3822, "firstkillstreakearned" },
    { 0x3823, "firstplacement" },
    { 0x3824, "firstspawn" },
    { 0x3825, "firsttimedamaged" },
    { 0x3826, "fish_a" },
    { 0x3827, "fish_animloop" },
    { 0x3828, "fish_b" },
    { 0x3829, "fishbubblesfx" },
    { 0x382A, "fix_dark_script_models" },
    { 0x382B, "fixakimbostring" },
    { 0x382C, "fixed_point_on_squished_sphere" },
    { 0x382D, "fixed_point_squished_sphere" },
    { 0x382E, "fixednodesaferadius_default" },
    { 0x382F, "fixednodewason" },
    { 0x3830, "fixlocalfocus" },
    { 0x3831, "flag" },
    { 0x3832, "flag_assert" },
    { 0x3833, "flag_carriers" },
    { 0x3834, "flag_clear" },
    { 0x3835, "flag_clear_delayed" },
    { 0x3836, "flag_construction_enable_pitbull_shooting" },
    { 0x3837, "flag_count" },
    { 0x3838, "flag_count_decrement" },
    { 0x3839, "flag_count_increment" },
    { 0x383A, "flag_count_set" },
    { 0x383B, "flag_distances" },
    { 0x383C, "flag_exist" },
    { 0x383D, "flag_hack" },
    { 0x383E, "flag_has_been_captured_before" },
    { 0x383F, "flag_has_never_been_captured" },
    { 0x3840, "flag_init" },
    { 0x3841, "flag_on_death" },
    { 0x3842, "flag_set" },
    { 0x3843, "flag_set_delayed" },
    { 0x3844, "flag_set_on_timeout" },
    { 0x3845, "flag_set_once_either_set" },
    { 0x3846, "flag_set_once_this_set" },
    { 0x3847, "flag_set_when_room_cleared" },
    { 0x3848, "flag_smash" },
    { 0x3849, "flag_struct" },
    { 0x384A, "flag_trigger_init" },
    { 0x384B, "flag_triggers_init" },
    { 0x384C, "flag_turret_for_use" },
    { 0x384D, "flag_wait" },
    { 0x384E, "flag_wait_all" },
    { 0x384F, "flag_wait_any" },
    { 0x3850, "flag_wait_any_or_timeout" },
    { 0x3851, "flag_wait_any_return" },
    { 0x3852, "flag_wait_bones" },
    { 0x3853, "flag_wait_both_or_timeout" },
    { 0x3854, "flag_wait_burke" },
    { 0x3855, "flag_wait_either" },
    { 0x3856, "flag_wait_either_return" },
    { 0x3857, "flag_wait_either_timeout" },
    { 0x3858, "flag_wait_joker" },
    { 0x3859, "flag_wait_or_timeout" },
    { 0x385A, "flag_waitopen" },
    { 0x385B, "flag_waitopen_both" },
    { 0x385C, "flag_waitopen_either" },
    { 0x385D, "flag_waitopen_either_return" },
    { 0x385E, "flag_waitopen_or_timeout" },
    { 0x385F, "flagawayvo" },
    { 0x3860, "flagbasefxid" },
    { 0x3861, "flagbasemodel" },
    { 0x3862, "flagcaptureevent" },
    { 0x3863, "flageffects" },
    { 0x3864, "flageffectsstop" },
    { 0x3865, "flagfx" },
    { 0x3866, "flagfxid" },
    { 0x3867, "flagged_for_use" },
    { 0x3868, "flaggroundfxid" },
    { 0x3869, "flagmodel" },
    { 0x386A, "flagmonitor" },
    { 0x386B, "flagpickupevent" },
    { 0x386C, "flagreturnevent" },
    { 0x386D, "flagreturntime" },
    { 0x386E, "flags" },
    { 0x386F, "flags_lock" },
    { 0x3870, "flagsetup" },
    { 0x3871, "flagstowedfxid" },
    { 0x3872, "flagwaitthread" },
    { 0x3873, "flagwaitthread_proc" },
    { 0x3874, "flak_explode" },
    { 0x3875, "flak_intro_sequence" },
    { 0x3876, "flak_nag_vo" },
    { 0x3877, "flak_pepper_player" },
    { 0x3878, "flak_scenario1" },
    { 0x3879, "flame_loop" },
    { 0x387A, "flame_loop2" },
    { 0x387B, "flank_alley_door_kick" },
    { 0x387C, "flank_alley_door_kick_civilian_react" },
    { 0x387D, "flank_alley_door_kick_doors_open" },
    { 0x387E, "flank_alley_goto" },
    { 0x387F, "flank_alley_spawn_group_b" },
    { 0x3880, "flank_alley_spawn_group_c" },
    { 0x3881, "flank_alley_spawn_group_d" },
    { 0x3882, "flank_alley_turret_fire" },
    { 0x3883, "flank_combat" },
    { 0x3884, "flank_gunner_damage_function" },
    { 0x3885, "flank_handle_player_bypass" },
    { 0x3886, "flank_magic_gren" },
    { 0x3887, "flank_make_gunner_vulerable" },
    { 0x3888, "flank_right_dialogue" },
    { 0x3889, "flank_technical_unload" },
    { 0x388A, "flank_wall_climb_force_check" },
    { 0x388B, "flank_wall_climb_force_dismount" },
    { 0x388C, "flap_animclose" },
    { 0x388D, "flap_animidleclose" },
    { 0x388E, "flap_animidleopen" },
    { 0x388F, "flap_animopen" },
    { 0x3890, "flaps" },
    { 0x3891, "flaps_top" },
    { 0x3892, "flare_cormack" },
    { 0x3893, "flare_duration" },
    { 0x3894, "flare_fx" },
    { 0x3895, "flare_model" },
    { 0x3896, "flare_warning" },
    { 0x3897, "flares_active" },
    { 0x3898, "flares_during_standoff" },
    { 0x3899, "flares_fire" },
    { 0x389A, "flares_fire_burst" },
    { 0x389B, "flares_get_vehicle_velocity" },
    { 0x389C, "flares_hint" },
    { 0x389D, "flares_redirect_missiles" },
    { 0x389E, "flares_think" },
    { 0x389F, "flaresdeployedyaw" },
    { 0x38A0, "flarestarget" },
    { 0x38A1, "flash_attack" },
    { 0x38A2, "flash_fxs" },
    { 0x38A3, "flash_mob1" },
    { 0x38A4, "flash_mob2" },
    { 0x38A5, "flash_mob3" },
    { 0x38A6, "flash_signs" },
    { 0x38A7, "flashanimindex" },
    { 0x38A8, "flashbanganim" },
    { 0x38A9, "flashbangedloop" },
    { 0x38AA, "flashbanggettimeleftsec" },
    { 0x38AB, "flashbangimmunity" },
    { 0x38AC, "flashbangisactive" },
    { 0x38AD, "flashbangplayer" },
    { 0x38AE, "flashbangstart" },
    { 0x38AF, "flashbangstop" },
    { 0x38B0, "flashcount" },
    { 0x38B1, "flashduration" },
    { 0x38B2, "flashed" },
    { 0x38B3, "flashedkillevent" },
    { 0x38B4, "flashendtime" },
    { 0x38B5, "flashfrac" },
    { 0x38B6, "flashfx" },
    { 0x38B7, "flashing_welding" },
    { 0x38B8, "flashing_welding_death_handler" },
    { 0x38B9, "flashingteam" },
    { 0x38BA, "flashlight" },
    { 0x38BB, "flashlight_fx" },
    { 0x38BC, "flashlight_guy" },
    { 0x38BD, "flashlight_off_think" },
    { 0x38BE, "flashlight_on" },
    { 0x38BF, "flashlight_parm_offset" },
    { 0x38C0, "flashlight_parm_point_light" },
    { 0x38C1, "flashlight_parm_spotlight" },
    { 0x38C2, "flashlight_parm_type" },
    { 0x38C3, "flashlight_tag" },
    { 0x38C4, "flashmonitor" },
    { 0x38C5, "flashmonitorenablehealthshield" },
    { 0x38C6, "flashnearbyallies" },
    { 0x38C7, "flashrumbleduration" },
    { 0x38C8, "flashrumbleloop" },
    { 0x38C9, "flashthread" },
    { 0x38CA, "flashthrown" },
    { 0x38CB, "flat_angle" },
    { 0x38CC, "flat_origin" },
    { 0x38CD, "flavorburstlinedebug" },
    { 0x38CE, "flavorbursts" },
    { 0x38CF, "flavorbursts_off" },
    { 0x38D0, "flavorbursts_on" },
    { 0x38D1, "flavorburstsused" },
    { 0x38D2, "flavorburstvoices" },
    { 0x38D3, "flavorburstwouldrepeat" },
    { 0x38D4, "fleeingcivilian_roundaboutexit_lobby" },
    { 0x38D5, "fleethreshold" },
    { 0x38D6, "flicker_motion_presets" },
    { 0x38D7, "flicker_presets" },
    { 0x38D8, "flickering" },
    { 0x38D9, "flickering_light" },
    { 0x38DA, "flickering_tunnel_light" },
    { 0x38DB, "flickerlight" },
    { 0x38DC, "flickerlightintensity" },
    { 0x38DD, "flickerlights" },
    { 0x38DE, "flickerstaticoverlay" },
    { 0x38DF, "flickertransmeshes" },
    { 0x38E0, "flight_code_main" },
    { 0x38E1, "flight_code_start" },
    { 0x38E2, "flinch" },
    { 0x38E3, "flinching" },
    { 0x38E4, "flinchwhensuppressed" },
    { 0x38E5, "flip_spot_light" },
    { 0x38E6, "flipbook_model" },
    { 0x38E7, "float_lerp" },
    { 0x38E8, "floaters" },
    { 0x38E9, "flock" },
    { 0x38EA, "flock_drones" },
    { 0x38EB, "flock_goal_offset" },
    { 0x38EC, "flock_goal_position" },
    { 0x38ED, "flood_and_secure" },
    { 0x38EE, "flood_and_secure_spawn" },
    { 0x38EF, "flood_and_secure_spawn_goal" },
    { 0x38F0, "flood_and_secure_spawner" },
    { 0x38F1, "flood_and_secure_spawner_think" },
    { 0x38F2, "flood_spawn" },
    { 0x38F3, "flood_spawner_init" },
    { 0x38F4, "flood_spawner_scripted" },
    { 0x38F5, "flood_spawner_stop" },
    { 0x38F6, "flood_spawner_think" },
    { 0x38F7, "flood_trigger_think" },
    { 0x38F8, "floor_override" },
    { 0x38F9, "flushdialogonplayer" },
    { 0x38FA, "flushgroupdialog" },
    { 0x38FB, "flushgroupdialogonplayer" },
    { 0x38FC, "fly_away_be_free" },
    { 0x38FD, "fly_drone_activate" },
    { 0x38FE, "fly_drone_camera_start_1" },
    { 0x38FF, "fly_drone_camera_start_2" },
    { 0x3900, "fly_drone_intro_dialogue" },
    { 0x3901, "fly_drone_intro_kva_dialogue" },
    { 0x3902, "fly_drone_nag" },
    { 0x3903, "fly_drone_picture_live" },
    { 0x3904, "fly_drone_rumbling" },
    { 0x3905, "fly_drone_transition_off" },
    { 0x3906, "fly_drone_transition_on" },
    { 0x3907, "fly_drone_ui_off" },
    { 0x3908, "fly_drone_ui_on" },
    { 0x3909, "fly_ending_mix" },
    { 0x390A, "fly_fade_in_intro" },
    { 0x390B, "fly_in_ambient_heli_squad" },
    { 0x390C, "fly_in_ambient_jets" },
    { 0x390D, "fly_in_ambient_street_jets" },
    { 0x390E, "fly_in_dialogue" },
    { 0x390F, "fly_in_dialogue_part2" },
    { 0x3910, "fly_in_hud" },
    { 0x3911, "fly_in_hud_overlay" },
    { 0x3912, "fly_in_primary_light_setup" },
    { 0x3913, "fly_in_rooftop_combat_dialogue" },
    { 0x3914, "fly_in_rumble" },
    { 0x3915, "fly_in_scene_part1" },
    { 0x3916, "fly_in_scene_part2" },
    { 0x3917, "fly_in_sequence" },
    { 0x3918, "fly_in_squad_uncloak" },
    { 0x3919, "fly_in_vfx_dopl_light_setup" },
    { 0x391A, "fly_think" },
    { 0x391B, "fly_think_autopilot" },
    { 0x391C, "fly_think_autopilot_player" },
    { 0x391D, "fly_think_formation" },
    { 0x391E, "fly_think_constrained" },
    { 0x391F, "fly_to_target" },
    { 0x3920, "flyby" },
    { 0x3921, "flyin" },
    { 0x3922, "flyin_handle_steady_rumble" },
    { 0x3923, "flyin_scene_handle_vehicle_destroyed_rumbles" },
    { 0x3924, "flyin_steady_rumble_intensity" },
    { 0x3925, "flyinanimations" },
    { 0x3926, "flying" },
    { 0x3927, "flying_attack_drone_damage_monitor" },
    { 0x3928, "flying_attack_drone_damage_update" },
    { 0x3929, "flying_attack_drone_death_monitor" },
    { 0x392A, "flying_attack_drone_goal_update" },
    { 0x392B, "flying_attack_drone_logic" },
    { 0x392C, "flying_attack_drone_move_think" },
    { 0x392D, "flying_attack_drone_move_think_old" },
    { 0x392E, "flying_attack_drone_stun_monitor" },
    { 0x392F, "flying_attack_drone_system_init" },
    { 0x3930, "flying_attack_drones" },
    { 0x3931, "flying_by" },
    { 0x3932, "flying_over" },
    { 0x3933, "flyingbuildingent" },
    { 0x3934, "flyingspeed" },
    { 0x3935, "flylp" },
    { 0x3936, "flynodeorgtracepassed" },
    { 0x3937, "flyvignette" },
    { 0x3938, "fndogmeleevictim" },
    { 0x3939, "fnoverlord" },
    { 0x393A, "foam_corridor_dialogue" },
    { 0x393B, "foam_corridor_enemy_think" },
    { 0x393C, "foam_corridor_nag_dialogue" },
    { 0x393D, "foam_grenade" },
    { 0x393E, "foam_plant_dof" },
    { 0x393F, "foam_planted_kill_enemies" },
    { 0x3940, "foam_room" },
    { 0x3941, "foam_room_clear_think" },
    { 0x3942, "foam_room_complete_dialogue" },
    { 0x3943, "foam_room_crmk_plant_these_frvs" },
    { 0x3944, "foam_room_dialogue" },
    { 0x3945, "foam_room_door_01_close" },
    { 0x3946, "foam_room_door_02_close" },
    { 0x3947, "foam_room_door_03_close" },
    { 0x3948, "foam_room_door_close" },
    { 0x3949, "foam_room_door_think" },
    { 0x394A, "foam_room_end_animation" },
    { 0x394B, "foam_room_logic" },
    { 0x394C, "foam_room_video_log" },
    { 0x394D, "foambombfoams" },
    { 0x394E, "fob_ambient_battle_chatter" },
    { 0x394F, "fob_block_player_in" },
    { 0x3950, "fob_blocking" },
    { 0x3951, "fob_dof" },
    { 0x3952, "fob_drop_pod_1" },
    { 0x3953, "fob_drop_pod_fake" },
    { 0x3954, "fob_fire_lighting" },
    { 0x3955, "fob_ignore_management" },
    { 0x3956, "fob_injured_guys" },
    { 0x3957, "fob_meetup_vo" },
    { 0x3958, "fob_out_of_bounds_fail" },
    { 0x3959, "fob_placed_unload" },
    { 0x395A, "fob_player_blocking" },
    { 0x395B, "fob_pod_anims" },
    { 0x395C, "fob_stand_idles" },
    { 0x395D, "fob_stand_twitches" },
    { 0x395E, "fob_street_dof" },
    { 0x395F, "fog_entrance_doors" },
    { 0x3960, "fog_set" },
    { 0x3961, "fog_set_changes" },
    { 0x3962, "fog_setup_shopping_restaraunt_interior_enter" },
    { 0x3963, "fog_setup_shopping_restaraunt_interior_exit" },
    { 0x3964, "fog_transition_ent" },
    { 0x3965, "fogcheck" },
    { 0x3966, "fogflash" },
    { 0x3967, "fogset" },
    { 0x3968, "follow_crash_path" },
    { 0x3969, "follow_dist" },
    { 0x396A, "follow_drone_turret_target" },
    { 0x396B, "follow_enemy_with_laser" },
    { 0x396C, "follow_ent" },
    { 0x396D, "follow_path" },
    { 0x396E, "follow_path_and_animate" },
    { 0x396F, "follow_path_animate_set_ent" },
    { 0x3970, "follow_path_animate_set_node" },
    { 0x3971, "follow_path_animate_set_struct" },
    { 0x3972, "follow_path_wait_for_player" },
    { 0x3973, "follow_tag" },
    { 0x3974, "follow_volume" },
    { 0x3975, "follow_volume_array" },
    { 0x3976, "follow_volume_designated_head_bottom" },
    { 0x3977, "follow_volume_designated_head_top" },
    { 0x3978, "follow_volume_maintain_count" },
    { 0x3979, "follow_volume_status" },
    { 0x397A, "follow_volume_target" },
    { 0x397B, "follow_volume_target_opposite" },
    { 0x397C, "follow_volume_think" },
    { 0x397D, "followspeed" },
    { 0x397E, "font_color" },
    { 0x397F, "font_size" },
    { 0x3980, "fontheight" },
    { 0x3981, "fontpulse" },
    { 0x3982, "fontpulseinit" },
    { 0x3983, "fontscaler" },
    { 0x3984, "foo_env_function" },
    { 0x3985, "foodtruck_drone_walk_away_left" },
    { 0x3986, "foodtruck_drone_walk_away_right" },
    { 0x3987, "footstep_environmental_elements" },
    { 0x3988, "force_alert_patrol" },
    { 0x3989, "force_alert_trigger_monitor" },
    { 0x398A, "force_alert_trigger_setup" },
    { 0x398B, "force_all_complete" },
    { 0x398C, "force_all_players_to_role" },
    { 0x398D, "force_animated_dismount" },
    { 0x398E, "force_bounce_on" },
    { 0x398F, "force_bounce_on_briefing_hanger" },
    { 0x3990, "force_bounce_on_briefing_hanger_02" },
    { 0x3991, "force_civilian_hunched_run" },
    { 0x3992, "force_civilian_stand_run" },
    { 0x3993, "force_color_driven_anim" },
    { 0x3994, "force_crawl_angle" },
    { 0x3995, "force_crawling_death" },
    { 0x3996, "force_crawling_death_proc" },
    { 0x3997, "force_exit_turbine_combat_complete" },
    { 0x3998, "force_explosion" },
    { 0x3999, "force_face_anim_to_play" },
    { 0x399A, "force_fake_laser_origin_link" },
    { 0x399B, "force_highlight" },
    { 0x399C, "force_kamikaze" },
    { 0x399D, "force_kill" },
    { 0x399E, "force_laser_on" },
    { 0x399F, "force_new_goal" },
    { 0x39A0, "force_num_crawls" },
    { 0x39A1, "force_patrol_anim_set" },
    { 0x39A2, "force_patrol_anim_set_immediately_or_when_spawned" },
    { 0x39A3, "force_play_land_assist_hint" },
    { 0x39A4, "force_player_angles" },
    { 0x39A5, "force_run_speed_state" },
    { 0x39A6, "force_shadow_hotel" },
    { 0x39A7, "force_shadow_off_subcarback_firespot" },
    { 0x39A8, "force_shadow_on_subcarback_firespot" },
    { 0x39A9, "force_start_catchup" },
    { 0x39AA, "force_stop_sound" },
    { 0x39AB, "force_to_always_sidearm" },
    { 0x39AC, "force_uncloak_on_fire" },
    { 0x39AD, "force_vehicle_delete" },
    { 0x39AE, "forcealtmeleedeaths" },
    { 0x39AF, "forceattack" },
    { 0x39B0, "forceavatarrefresh" },
    { 0x39B1, "forcebuddyspawn" },
    { 0x39B2, "forceclassselection" },
    { 0x39B3, "forcecolor" },
    { 0x39B4, "forcecustomclassloc" },
    { 0x39B5, "forced_s1_motionset" },
    { 0x39B6, "forced_s1_motionset_overided" },
    { 0x39B7, "forced_slowmo_breach_lerpout" },
    { 0x39B8, "forced_slowmo_breach_slowdown" },
    { 0x39B9, "forced_start_catchup" },
    { 0x39BA, "forced_startingposition" },
    { 0x39BB, "forcedend" },
    { 0x39BC, "forcedgameskill" },
    { 0x39BD, "forcedisable" },
    { 0x39BE, "forcedisconnectuntil" },
    { 0x39BF, "forceend" },
    { 0x39C0, "forceenglish" },
    { 0x39C1, "forceexploding" },
    { 0x39C2, "forcefallthroughonropes" },
    { 0x39C3, "forcegoal" },
    { 0x39C4, "forcelaser" },
    { 0x39C5, "forcelongdeath" },
    { 0x39C6, "forceranking" },
    { 0x39C7, "forcerespawn" },
    { 0x39C8, "forcerespawn_time" },
    { 0x39C9, "forcerespawn_timer" },
    { 0x39CA, "forcesidearm" },
    { 0x39CB, "forcespawn" },
    { 0x39CC, "forcespawnangles" },
    { 0x39CD, "forcespawnorigin" },
    { 0x39CE, "forcespawnteam" },
    { 0x39CF, "forcestyle" },
    { 0x39D0, "forcesuppression" },
    { 0x39D1, "forcetarget" },
    { 0x39D2, "forcetonode" },
    { 0x39D3, "forceuseweapon" },
    { 0x39D4, "foreat_stealth_ambient_vehicle_drive_by" },
    { 0x39D5, "forest_ambient_enemy_se" },
    { 0x39D6, "forest_climb_wall_start" },
    { 0x39D7, "forest_mech_spawn" },
    { 0x39D8, "forest_start_logic" },
    { 0x39D9, "forest_stealth_gaz_think" },
    { 0x39DA, "forest_takedown" },
    { 0x39DB, "forest_takedown_01_rumbles" },
    { 0x39DC, "forest_takedown_02_ai_kill" },
    { 0x39DD, "forest_takedown_dof" },
    { 0x39DE, "forest_takedown_fx" },
    { 0x39DF, "forest_takedown_handle_gideon_weapon" },
    { 0x39E0, "forest_takedown_start_logic" },
    { 0x39E1, "forfeit_aborted" },
    { 0x39E2, "forfeitinprogress" },
    { 0x39E3, "forfeitwaitforabort" },
    { 0x39E4, "forget_time" },
    { 0x39E5, "forklift" },
    { 0x39E6, "forklift_audio_loop" },
    { 0x39E7, "forklift_crate_prop" },
    { 0x39E8, "forklift_door_prop" },
    { 0x39E9, "forklift_driver" },
    { 0x39EA, "forklift_fail_trigger_setup" },
    { 0x39EB, "forklift_org" },
    { 0x39EC, "forklift_setup" },
    { 0x39ED, "forklift_stop_watcher" },
    { 0x39EE, "form_patrol_group" },
    { 0x39EF, "formation_pos" },
    { 0x39F0, "formation_volumes" },
    { 0x39F1, "forward_direction" },
    { 0x39F2, "forward_punish_dist" },
    { 0x39F3, "forwardvec" },
    { 0x39F4, "found" },
    { 0x39F5, "found_corpse_wait" },
    { 0x39F6, "found_distsqrd" },
    { 0x39F7, "found_dog_distsqrd" },
    { 0x39F8, "found_toucher" },
    { 0x39F9, "fountaincivilians" },
    { 0x39FA, "fourplayevent" },
    { 0x39FB, "fov_face" },
    { 0x39FC, "fov_face_count" },
    { 0x39FD, "fov_inner" },
    { 0x39FE, "fov_lerp_to_50_blendtime" },
    { 0x39FF, "fov_original" },
    { 0x3A00, "fov_outer" },
    { 0x3A01, "fov_reset_previous" },
    { 0x3A02, "fov_screen" },
    { 0x3A03, "fov_screen_count" },
    { 0x3A04, "fov_set_to_35" },
    { 0x3A05, "fov_snap_to_55" },
    { 0x3A06, "fov_snipe" },
    { 0x3A07, "fovslidercheck" },
    { 0x3A08, "fparams" },
    { 0x3A09, "fps_controls" },
    { 0x3A0A, "fr_start" },
    { 0x3A0B, "frac" },
    { 0x3A0C, "frame_rate_tune_shadows_heli_crash" },
    { 0x3A0D, "frame_rate_tune_shadows_roof_top" },
    { 0x3A0E, "frame_rate_tune_shadows_turn_to_right" },
    { 0x3A0F, "frame_rate_tune_shadows_up_over_cliff" },
    { 0x3A10, "frame_selected" },
    { 0x3A11, "frame_wait_building_jump" },
    { 0x3A12, "framedelay" },
    { 0x3A13, "framerollacceleration" },
    { 0x3A14, "frames_visible" },
    { 0x3A15, "frameviewmodel" },
    { 0x3A16, "frameviewmodeloffset" },
    { 0x3A17, "frb_plant_rumbles" },
    { 0x3A18, "free_on_death" },
    { 0x3A19, "free_running" },
    { 0x3A1A, "free_running_hidden_weapon" },
    { 0x3A1B, "freedrive_dodge_static_early_distance" },
    { 0x3A1C, "freedrive_playermatch_catchup_multiplier" },
    { 0x3A1D, "freedrive_playermatch_catchup_ramp_end_dist" },
    { 0x3A1E, "freedrive_playermatch_catchup_ramp_start_dist" },
    { 0x3A1F, "freedrive_playermatch_farahead_delete_dist" },
    { 0x3A20, "freedrive_playermatch_farbehind_delete_dist" },
    { 0x3A21, "freedrive_playermatch_matched_multiplier" },
    { 0x3A22, "freedrive_playermatch_slowdown_multiplier" },
    { 0x3A23, "freedrive_playermatch_slowdown_ramp_end_dist" },
    { 0x3A24, "freedrive_playermatch_slowdown_ramp_start_dist" },
    { 0x3A25, "freedrive_progress_mod_default" },
    { 0x3A26, "freedrive_progress_mod_step" },
    { 0x3A27, "freedrive_stay_within_percent_of_edge" },
    { 0x3A28, "freedrive_vehicle_min_allowed_speed" },
    { 0x3A29, "freeentitysentient_func" },
    { 0x3A2A, "freefall" },
    { 0x3A2B, "freegameplayhudelems" },
    { 0x3A2C, "freeplayer" },
    { 0x3A2D, "freeplayers" },
    { 0x3A2E, "freerun_backtrack_death_squad_spawners" },
    { 0x3A2F, "freerun_enemy_alert_notified" },
    { 0x3A30, "freerun_fail_hunter" },
    { 0x3A31, "freerun_walker_array" },
    { 0x3A32, "freeze_anim_at_end" },
    { 0x3A33, "freezeallplayers" },
    { 0x3A34, "freezeatriumfighttimer" },
    { 0x3A35, "freezecontrolswrapper" },
    { 0x3A36, "freezecontrolswrapperwithdelay" },
    { 0x3A37, "freezemarkettimer" },
    { 0x3A38, "freezeplayerforroundend" },
    { 0x3A39, "freq" },
    { 0x3A3A, "frequencysource" },
    { 0x3A3B, "frequencytarget" },
    { 0x3A3C, "friend_jets" },
    { 0x3A3D, "friend_kill_points" },
    { 0x3A3E, "friendlies_breach" },
    { 0x3A3F, "friendlies_shoot_while_breaching" },
    { 0x3A40, "friendly_acc_hidden" },
    { 0x3A41, "friendly_acc_spotted" },
    { 0x3A42, "friendly_airstrike" },
    { 0x3A43, "friendly_anim_ent" },
    { 0x3A44, "friendly_animations" },
    { 0x3A45, "friendly_bias" },
    { 0x3A46, "friendly_breach" },
    { 0x3A47, "friendly_breach_thread" },
    { 0x3A48, "friendly_bubbles" },
    { 0x3A49, "friendly_bubbles_cleanup" },
    { 0x3A4A, "friendly_bubbles_cleanup_on_death" },
    { 0x3A4B, "friendly_bubbles_stop" },
    { 0x3A4C, "friendly_can_teleport" },
    { 0x3A4D, "friendly_color_hidden" },
    { 0x3A4E, "friendly_color_spotted" },
    { 0x3A4F, "friendly_compute_score" },
    { 0x3A50, "friendly_compute_stances_ai" },
    { 0x3A51, "friendly_compute_stances_player" },
    { 0x3A52, "friendly_custom_acc_behavior" },
    { 0x3A53, "friendly_custom_color_behavior" },
    { 0x3A54, "friendly_custom_state_behavior" },
    { 0x3A55, "friendly_default_acc_behavior" },
    { 0x3A56, "friendly_default_color_behavior" },
    { 0x3A57, "friendly_default_movespeed_scale" },
    { 0x3A58, "friendly_default_stance_handler_distances" },
    { 0x3A59, "friendly_default_state_behavior" },
    { 0x3A5A, "friendly_fire_checkpoints" },
    { 0x3A5B, "friendly_fire_fail_check" },
    { 0x3A5C, "friendly_fire_think" },
    { 0x3A5D, "friendly_get_stance" },
    { 0x3A5E, "friendly_getangles_ai" },
    { 0x3A5F, "friendly_getangles_player" },
    { 0x3A60, "friendly_getinshadow" },
    { 0x3A61, "friendly_getstance_ai" },
    { 0x3A62, "friendly_getstance_player" },
    { 0x3A63, "friendly_getvelocity" },
    { 0x3A64, "friendly_hud_destroy_on_mission_end" },
    { 0x3A65, "friendly_hud_icon_blink_on_damage" },
    { 0x3A66, "friendly_hud_icon_blink_on_fire" },
    { 0x3A67, "friendly_hud_icon_flash" },
    { 0x3A68, "friendly_hud_init" },
    { 0x3A69, "friendly_init" },
    { 0x3A6A, "friendly_mg42" },
    { 0x3A6B, "friendly_mg42_cleanup" },
    { 0x3A6C, "friendly_mg42_death_notify" },
    { 0x3A6D, "friendly_mg42_doneusingturret" },
    { 0x3A6E, "friendly_mg42_endtrigger" },
    { 0x3A6F, "friendly_mg42_stop_use" },
    { 0x3A70, "friendly_mg42_think" },
    { 0x3A71, "friendly_mg42_useable" },
    { 0x3A72, "friendly_mg42_wait_for_use" },
    { 0x3A73, "friendly_mgturret" },
    { 0x3A74, "friendly_nearby" },
    { 0x3A75, "friendly_pitbull" },
    { 0x3A76, "friendly_pitbull_aim" },
    { 0x3A77, "friendly_pitbull_fire" },
    { 0x3A78, "friendly_pitbull_headlights_off" },
    { 0x3A79, "friendly_pitbull_headlights_on" },
    { 0x3A7A, "friendly_pitbull_shadow_chase_van" },
    { 0x3A7B, "friendly_pitbull_shadow_player" },
    { 0x3A7C, "friendly_pose" },
    { 0x3A7D, "friendly_promotion_thread" },
    { 0x3A7E, "friendly_respawn_lock_func" },
    { 0x3A7F, "friendly_respawn_vision_checker_thread" },
    { 0x3A80, "friendly_set_movespeed_scale" },
    { 0x3A81, "friendly_set_stance_handler_distances" },
    { 0x3A82, "friendly_spawner" },
    { 0x3A83, "friendly_spotted_getup_from_prone" },
    { 0x3A84, "friendly_stance_handler" },
    { 0x3A85, "friendly_stance_handler_change_stance_down" },
    { 0x3A86, "friendly_stance_handler_change_stance_up" },
    { 0x3A87, "friendly_stance_handler_check_mightbeseen" },
    { 0x3A88, "friendly_stance_handler_resume_path" },
    { 0x3A89, "friendly_stance_handler_return_ai_sight" },
    { 0x3A8A, "friendly_stance_handler_set_stance_up" },
    { 0x3A8B, "friendly_stance_handler_stay_still" },
    { 0x3A8C, "friendly_startup_thread" },
    { 0x3A8D, "friendly_state_hidden" },
    { 0x3A8E, "friendly_state_spotted" },
    { 0x3A8F, "friendly_thermal_reflector_effect" },
    { 0x3A90, "friendly_visibility_logic" },
    { 0x3A91, "friendly_wave" },
    { 0x3A92, "friendly_wave_active" },
    { 0x3A93, "friendly_wave_masterthread" },
    { 0x3A94, "friendly_wave_trigger" },
    { 0x3A95, "friendlyboarderfxid" },
    { 0x3A96, "friendlychain" },
    { 0x3A97, "friendlychain_ondeath" },
    { 0x3A98, "friendlychain_ondeaththink" },
    { 0x3A99, "friendlychains" },
    { 0x3A9A, "friendlydamage" },
    { 0x3A9B, "friendlydeath_thread" },
    { 0x3A9C, "friendlyenemyeffects" },
    { 0x3A9D, "friendlyenemyeffectsstop" },
    { 0x3A9E, "friendlyenemylinkedeffects" },
    { 0x3A9F, "friendlyfire_damage_modifier" },
    { 0x3AA0, "friendlyfire_destructible_attacker" },
    { 0x3AA1, "friendlyfire_enable_attacker_owner_check" },
    { 0x3AA2, "friendlyfire_shield" },
    { 0x3AA3, "friendlyfire_warning" },
    { 0x3AA4, "friendlyfire_warnings" },
    { 0x3AA5, "friendlyfire_warnings_disable" },
    { 0x3AA6, "friendlyfire_warnings_off" },
    { 0x3AA7, "friendlyfire_warnings_on" },
    { 0x3AA8, "friendlyfire_whizby_distances_valid" },
    { 0x3AA9, "friendlyfirecheck" },
    { 0x3AAA, "friendlyfiredisabled" },
    { 0x3AAB, "friendlyfiredisabledfordestructible" },
    { 0x3AAC, "friendlyfirekick" },
    { 0x3AAD, "friendlyflagfxid" },
    { 0x3AAE, "friendlyfx" },
    { 0x3AAF, "friendlyhudicon_currentmaterial" },
    { 0x3AB0, "friendlyhudicon_disable" },
    { 0x3AB1, "friendlyhudicon_downed" },
    { 0x3AB2, "friendlyhudicon_enable" },
    { 0x3AB3, "friendlyhudicon_hideall" },
    { 0x3AB4, "friendlyhudicon_normal" },
    { 0x3AB5, "friendlyhudicon_rotating" },
    { 0x3AB6, "friendlyhudicon_showall" },
    { 0x3AB7, "friendlyhudicon_update" },
    { 0x3AB8, "friendlyicon" },
    { 0x3AB9, "friendlylosmarker" },
    { 0x3ABA, "friendlymarker" },
    { 0x3ABB, "friendlymodel" },
    { 0x3ABC, "friendlynamedist" },
    { 0x3ABD, "friendlyspawnorg" },
    { 0x3ABE, "friendlyspawntrigger" },
    { 0x3ABF, "friendlyspawnwave" },
    { 0x3AC0, "friendlyspawnwave_triggerthink" },
    { 0x3AC1, "friendlytrigger" },
    { 0x3AC2, "friendlywave_thread" },
    { 0x3AC3, "friendlywaypoint" },
    { 0x3AC4, "friendname" },
    { 0x3AC5, "frogger_brake_vehicle_at_trigger" },
    { 0x3AC6, "frogger_bus_spawners" },
    { 0x3AC7, "frogger_combat" },
    { 0x3AC8, "frogger_handle_bypass_middle" },
    { 0x3AC9, "frogger_impact_damage_function" },
    { 0x3ACA, "frogger_middle_guys" },
    { 0x3ACB, "frogger_middle_kill_check" },
    { 0x3ACC, "frogger_release_vehicle_at_trigger" },
    { 0x3ACD, "frogger_slow_down_lane" },
    { 0x3ACE, "frogger_spawn_selection" },
    { 0x3ACF, "frogger_spawners" },
    { 0x3AD0, "frogger_squad_crossing" },
    { 0x3AD1, "frogger_squad_crossing_complete_check" },
    { 0x3AD2, "frogger_teleport_end" },
    { 0x3AD3, "frogger_teleport_end_check" },
    { 0x3AD4, "frogger_teleport_middle" },
    { 0x3AD5, "frogger_teleport_middle_check" },
    { 0x3AD6, "frogger_vehicle_by" },
    { 0x3AD7, "frogger_vehicle_hit_fail" },
    { 0x3AD8, "frogger_vehicle_hit_react" },
    { 0x3AD9, "frogger_vehicle_rumble" },
    { 0x3ADA, "frogger_vehicles" },
    { 0x3ADB, "front_gunfire_timer" },
    { 0x3ADC, "frontshieldmodel" },
    { 0x3ADD, "frontyard_drone_cleanup" },
    { 0x3ADE, "fruit_table_impact" },
    { 0x3ADF, "fstopbase" },
    { 0x3AE0, "fstopperunit" },
    { 0x3AE1, "fuel_refresh_time" },
    { 0x3AE2, "fuel_update_hud" },
    { 0x3AE3, "fueled_up_vo" },
    { 0x3AE4, "fullmodel" },
    { 0x3AE5, "fullsights" },
    { 0x3AE6, "fully_controllable_swarm" },
    { 0x3AE7, "func" },
    { 0x3AE8, "func_bot_get_closest_navigable_point" },
    { 0x3AE9, "func_create_loopsound" },
    { 0x3AEA, "func_destructible_crush_player" },
    { 0x3AEB, "func_get_level_fx" },
    { 0x3AEC, "func_get_nodes_on_path" },
    { 0x3AED, "func_get_path_dist" },
    { 0x3AEE, "func_loopfxthread" },
    { 0x3AEF, "func_oneshotfxthread" },
    { 0x3AF0, "func_player_speed" },
    { 0x3AF1, "func_position_player" },
    { 0x3AF2, "func_position_player_get" },
    { 0x3AF3, "func_process_fx_rotater" },
    { 0x3AF4, "func_updatefx" },
    { 0x3AF5, "function_stack" },
    { 0x3AF6, "function_stack_caller_waits_for_turn" },
    { 0x3AF7, "function_stack_clear" },
    { 0x3AF8, "function_stack_func_begun" },
    { 0x3AF9, "function_stack_proc" },
    { 0x3AFA, "function_stack_self_death" },
    { 0x3AFB, "function_stack_timeout" },
    { 0x3AFC, "function_stack_wait" },
    { 0x3AFD, "function_stack_wait_finish" },
    { 0x3AFE, "functional_tester_load_next_start" },
    { 0x3AFF, "funeral" },
    { 0x3B00, "funeral_ambient_ai_soldiers" },
    { 0x3B01, "funeral_anim_ambient" },
    { 0x3B02, "funeral_anim_card" },
    { 0x3B03, "funeral_anim_cormack" },
    { 0x3B04, "funeral_anim_cormack_branch" },
    { 0x3B05, "funeral_anim_driver" },
    { 0x3B06, "funeral_anim_flag" },
    { 0x3B07, "funeral_anim_irons" },
    { 0x3B08, "funeral_anim_irons_wife" },
    { 0x3B09, "funeral_anim_player" },
    { 0x3B0A, "funeral_cleanup" },
    { 0x3B0B, "funeral_cormack" },
    { 0x3B0C, "funeral_intro_black_screen" },
    { 0x3B0D, "funeral_irons" },
    { 0x3B0E, "funeral_irons_wife" },
    { 0x3B0F, "funeral_play_animated_card" },
    { 0x3B10, "funeral_submix_handler" },
    { 0x3B11, "furfx" },
    { 0x3B12, "furniturepushsound" },
    { 0x3B13, "fus_burke_ctrl_rm_shoulder_ram" },
    { 0x3B14, "fus_gideon_bust_open_sec_door" },
    { 0x3B15, "fus_outro_burke_foley" },
    { 0x3B16, "fus_truck_flip_01" },
    { 0x3B17, "fus_truck_flip_02" },
    { 0x3B18, "fusion_door_explosion_swap" },
    { 0x3B19, "fusion_endlogo" },
    { 0x3B1A, "fusion_fastzip_quake" },
    { 0x3B1B, "fusion_fly_player_mist" },
    { 0x3B1C, "fusion_intro_background" },
    { 0x3B1D, "fusion_intro_dof" },
    { 0x3B1E, "fusion_intro_hades_videolog_vo" },
    { 0x3B1F, "fusion_intro_screen" },
    { 0x3B20, "fusion_intro_title_text" },
    { 0x3B21, "fusion_locations" },
    { 0x3B22, "fusion_silo_collapse_warbird" },
    { 0x3B23, "fusion_zip_dof" },
    { 0x3B24, "fwd_aug" },
    { 0x3B25, "fwd_dir" },
    { 0x3B26, "fx" },
    { 0x3B27, "fx_array" },
    { 0x3B28, "fx_autopsy_hatch_open" },
    { 0x3B29, "fx_body_dust_drag" },
    { 0x3B2A, "fx_body_dust_mech" },
    { 0x3B2B, "fx_bombshakes" },
    { 0x3B2C, "fx_bombshakes_physics_jitter" },
    { 0x3B2D, "fx_cam_view_test" },
    { 0x3B2E, "fx_clamp_rotation" },
    { 0x3B2F, "fx_contrail_handler" },
    { 0x3B30, "fx_current" },
    { 0x3B31, "fx_data" },
    { 0x3B32, "fx_elevator_descent_burke" },
    { 0x3B33, "fx_emergency_lights" },
    { 0x3B34, "fx_end_amb_fx" },
    { 0x3B35, "fx_engine_off" },
    { 0x3B36, "fx_engine_on" },
    { 0x3B37, "fx_ent" },
    { 0x3B38, "fx_escape_takedown_foot_stomp" },
    { 0x3B39, "fx_escape_takedown_wastebasket" },
    { 0x3B3A, "fx_exo_climb_gloves_off" },
    { 0x3B3B, "fx_exo_climb_lglove_disengage" },
    { 0x3B3C, "fx_exo_climb_lglove_engage" },
    { 0x3B3D, "fx_exo_climb_rglove_disengage" },
    { 0x3B3E, "fx_exo_climb_rglove_engage" },
    { 0x3B3F, "fx_flare_to_sun_flare" },
    { 0x3B40, "fx_footstep_dust_le" },
    { 0x3B41, "fx_footstep_dust_mech_le" },
    { 0x3B42, "fx_footstep_dust_mech_ri" },
    { 0x3B43, "fx_footstep_dust_ri" },
    { 0x3B44, "fx_footstep_dust_rocks_le" },
    { 0x3B45, "fx_footstep_dust_rocks_ri" },
    { 0x3B46, "fx_footstep_water_small_le" },
    { 0x3B47, "fx_footstep_water_small_ri" },
    { 0x3B48, "fx_get_ground_pos" },
    { 0x3B49, "fx_gideon_body_dust" },
    { 0x3B4A, "fx_gideon_body_dust_inc" },
    { 0x3B4B, "fx_goal_count" },
    { 0x3B4C, "fx_guard_2" },
    { 0x3B4D, "fx_heli_aa_explosion" },
    { 0x3B4E, "fx_heli_crash_debris_dust" },
    { 0x3B4F, "fx_heli_crash_enter_mech_sparks" },
    { 0x3B50, "fx_heli_crash_fist_dust_mech" },
    { 0x3B51, "fx_heli_crash_godrays_off" },
    { 0x3B52, "fx_heli_crash_godrays_on" },
    { 0x3B53, "fx_heli_crash_hero_falling_dust" },
    { 0x3B54, "fx_heli_crash_mech_sparks" },
    { 0x3B55, "fx_heli_flyby_dust" },
    { 0x3B56, "fx_heli_gideon_fire" },
    { 0x3B57, "fx_heli_manticore_dust" },
    { 0x3B58, "fx_heli_mech_punch" },
    { 0x3B59, "fx_heli_ride" },
    { 0x3B5A, "fx_highlightedent" },
    { 0x3B5B, "fx_id" },
    { 0x3B5C, "fx_inc" },
    { 0x3B5D, "fx_inc_cycle_fires" },
    { 0x3B5E, "fx_inc_godrays" },
    { 0x3B5F, "fx_inc_near_miss" },
    { 0x3B60, "fx_inc_oven_godrays_off" },
    { 0x3B61, "fx_inc_oven_godrays_on" },
    { 0x3B62, "fx_inc_pipe_explode" },
    { 0x3B63, "fx_init" },
    { 0x3B64, "fx_interrogation_arm_smash" },
    { 0x3B65, "fx_interrogation_irons_fire" },
    { 0x3B66, "fx_intro_ambient" },
    { 0x3B67, "fx_intro_body_dust" },
    { 0x3B68, "fx_intro_truck_dust" },
    { 0x3B69, "fx_knee_dust_mech_le" },
    { 0x3B6A, "fx_knee_dust_mech_ri" },
    { 0x3B6B, "fx_leaves" },
    { 0x3B6C, "fx_mech_cockpit" },
    { 0x3B6D, "fx_mech_cockpit_damage" },
    { 0x3B6E, "fx_mech_cockpit_damage_stop" },
    { 0x3B6F, "fx_mech_door_lift_fx" },
    { 0x3B70, "fx_mech_exit_land_dust" },
    { 0x3B71, "fx_mech_exit_steam" },
    { 0x3B72, "fx_mech_explode_amb_fx" },
    { 0x3B73, "fx_mech_foot_sparks" },
    { 0x3B74, "fx_mech_land_sparks" },
    { 0x3B75, "fx_mech_soft_land_dust" },
    { 0x3B76, "fx_moving_water_splatter" },
    { 0x3B77, "fx_moving_water_splatter_setup" },
    { 0x3B78, "fx_oceanfoam" },
    { 0x3B79, "fx_on" },
    { 0x3B7A, "fx_origin" },
    { 0x3B7B, "fx_paused" },
    { 0x3B7C, "fx_pnematic_anchor" },
    { 0x3B7D, "fx_props_security_cameras" },
    { 0x3B7E, "fx_props_setup" },
    { 0x3B7F, "fx_react_group" },
    { 0x3B80, "fx_rescue_body_slam_1" },
    { 0x3B81, "fx_rescue_body_slam_2" },
    { 0x3B82, "fx_rescue_guard_2_init" },
    { 0x3B83, "fx_rescue_guard_fire" },
    { 0x3B84, "fx_rescue_head_slam_1" },
    { 0x3B85, "fx_rescue_head_slam_2" },
    { 0x3B86, "fx_rotating" },
    { 0x3B87, "fx_spot_lens_flare_dir" },
    { 0x3B88, "fx_spot_lens_flare_tag" },
    { 0x3B89, "fx_stop_mech_door_lift_fx" },
    { 0x3B8A, "fx_stop_pilot_lights" },
    { 0x3B8B, "fx_sun_lens_flare" },
    { 0x3B8C, "fx_tag" },
    { 0x3B8D, "fx_tag0" },
    { 0x3B8E, "fx_target_locked" },
    { 0x3B8F, "fx_target_none" },
    { 0x3B90, "fx_time" },
    { 0x3B91, "fx_type" },
    { 0x3B92, "fx_uv_flash" },
    { 0x3B93, "fx_volume_pause" },
    { 0x3B94, "fx_volume_pause_noteworthy" },
    { 0x3B95, "fx_volume_pause_noteworthy_thread" },
    { 0x3B96, "fx_volume_restart" },
    { 0x3B97, "fx_volume_restart_noteworthy" },
    { 0x3B98, "fx_volume_restart_noteworthy_thread" },
    { 0x3B99, "fx_walk_heli_flyby" },
    { 0x3B9A, "fx_waves" },
    { 0x3B9B, "fx_zone_messages" },
    { 0x3B9C, "fx_zone_watcher" },
    { 0x3B9D, "fx_zone_watcher_all" },
    { 0x3B9E, "fx_zone_watcher_both" },
    { 0x3B9F, "fx_zone_watcher_either" },
    { 0x3BA0, "fx_zone_watcher_either_off_killthread" },
    { 0x3BA1, "fx_zone_watcher_late" },
    { 0x3BA2, "fx_zone_watcher_waitopen" },
    { 0x3BA3, "fxangle" },
    { 0x3BA4, "fxblink" },
    { 0x3BA5, "fxcost" },
    { 0x3BA6, "fxdelay" },
    { 0x3BA7, "fxents" },
    { 0x3BA8, "fxexists" },
    { 0x3BA9, "fxfireloopmod" },
    { 0x3BAA, "fxhudelements" },
    { 0x3BAB, "fxid" },
    { 0x3BAC, "fxid_enemy_light" },
    { 0x3BAD, "fxid_engine_distort" },
    { 0x3BAE, "fxid_explode" },
    { 0x3BAF, "fxid_friendly_light" },
    { 0x3BB0, "fxid_laser_glow" },
    { 0x3BB1, "fxid_launch_thruster" },
    { 0x3BB2, "fxid_lethalexplode" },
    { 0x3BB3, "fxid_position_thruster" },
    { 0x3BB4, "fxid_sparks" },
    { 0x3BB5, "fxid_thruster_down" },
    { 0x3BB6, "fxid_thruster_up" },
    { 0x3BB7, "fxid_warning" },
    { 0x3BB8, "fxonly" },
    { 0x3BB9, "fxorigin" },
    { 0x3BBA, "fxreactionset" },
    { 0x3BBB, "fxshowtoteam" },
    { 0x3BBC, "fxstart" },
    { 0x3BBD, "fxstop" },
    { 0x3BBE, "fxtags_bigwar" },
    { 0x3BBF, "fxtags_space" },
    { 0x3BC0, "fxtags_streets" },
    { 0x3BC1, "fxtagside" },
    { 0x3BC2, "fxtime" },
    { 0x3BC3, "g" },
    { 0x3BC4, "g_bob_scale_get_func" },
    { 0x3BC5, "g_bob_scale_set_func" },
    { 0x3BC6, "g_score" },
    { 0x3BC7, "g_speed" },
    { 0x3BC8, "g_speed_get_func" },
    { 0x3BC9, "g_speed_set_func" },
    { 0x3BCA, "g_turret_vel_array" },
    { 0x3BCB, "g_visionblend" },
    { 0x3BCC, "g_visiondefault" },
    { 0x3BCD, "g_visionexit" },
    { 0x3BCE, "g_visionvols" },
    { 0x3BCF, "g_xwalk_pitched_hard" },
    { 0x3BD0, "g_xwalk_started_to_move" },
    { 0x3BD1, "g_xwalk_time_started_to_move" },
    { 0x3BD2, "g_xwalk_vel_que" },
    { 0x3BD3, "g_xwalk_was_stopped" },
    { 0x3BD4, "gain" },
    { 0x3BD5, "game_is_current_gen" },
    { 0x3BD6, "game_message_append" },
    { 0x3BD7, "game_message_display" },
    { 0x3BD8, "game_message_listen" },
    { 0x3BD9, "game_messages" },
    { 0x3BDA, "game_messages_process" },
    { 0x3BDB, "game_messages_shutdown" },
    { 0x3BDC, "game_messages_startup" },
    { 0x3BDD, "gameended" },
    { 0x3BDE, "gameendlistener" },
    { 0x3BDF, "gameendtime" },
    { 0x3BE0, "gameflag" },
    { 0x3BE1, "gameflagclear" },
    { 0x3BE2, "gameflaginit" },
    { 0x3BE3, "gameflagset" },
    { 0x3BE4, "gameflagwait" },
    { 0x3BE5, "gamehasstarted" },
    { 0x3BE6, "gamelobby_camera_curve_modify" },
    { 0x3BE7, "gamelobby_camera_curve_movex" },
    { 0x3BE8, "gamelobby_camera_curve_storedy" },
    { 0x3BE9, "gamelobby_camera_depth_scaler" },
    { 0x3BEA, "gamelobby_camera_offset" },
    { 0x3BEB, "gamelobby_camera_rotation_speed" },
    { 0x3BEC, "gamelobby_camera_targetoffset" },
    { 0x3BED, "gamelobby_camerazoff_zoom" },
    { 0x3BEE, "gamelobby_camoffset_angle_ratio" },
    { 0x3BEF, "gamelobby_movespeed" },
    { 0x3BF0, "gamelobby_targetzoff_zoom" },
    { 0x3BF1, "gamelobbygroup_camera_offset" },
    { 0x3BF2, "gamelobbygroup_camera_targetoffset" },
    { 0x3BF3, "gamelobbygroup_camerazoff_zoom" },
    { 0x3BF4, "gamelobbygroup_camoffset_angle_ratio" },
    { 0x3BF5, "gamelobbygroup_targetzoff_zoom" },
    { 0x3BF6, "gamemode_chosenclass" },
    { 0x3BF7, "gamemodefirstspawn" },
    { 0x3BF8, "gamemodemaydropweapon" },
    { 0x3BF9, "gamemodemodifyplayerdamage" },
    { 0x3BFA, "gamemodeonunderwater" },
    { 0x3BFB, "gameobject" },
    { 0x3BFC, "gameobject_fauxspawn" },
    { 0x3BFD, "gameobjecthudindex" },
    { 0x3BFE, "gameplay" },
    { 0x3BFF, "gameplay_setup" },
    { 0x3C00, "gameshouldend" },
    { 0x3C01, "gameskill" },
    { 0x3C02, "gameskill_breath_func" },
    { 0x3C03, "gameskill_change_monitor" },
    { 0x3C04, "gametimer" },
    { 0x3C05, "gametweaks" },
    { 0x3C06, "gametypestarted" },
    { 0x3C07, "gamewinnerdialog" },
    { 0x3C08, "gangam_cinematic_warfare_manager" },
    { 0x3C09, "gangnam_autosave" },
    { 0x3C0A, "gangnam_main" },
    { 0x3C0B, "gangnam_objectives" },
    { 0x3C0C, "gap" },
    { 0x3C0D, "gap_jump_squib_occlusion" },
    { 0x3C0E, "garage_anim_struct" },
    { 0x3C0F, "garage_balcony_door" },
    { 0x3C10, "garage_balcony_enemy" },
    { 0x3C11, "garage_balcony_spawner_setup" },
    { 0x3C12, "garage_balcony_vo" },
    { 0x3C13, "garage_door_shut_off" },
    { 0x3C14, "garage_side_door" },
    { 0x3C15, "garagedooranimations" },
    { 0x3C16, "gas" },
    { 0x3C17, "gas_alarm_off_vo" },
    { 0x3C18, "gas_alarm_on_vo" },
    { 0x3C19, "gas_alarm_sfx_alias" },
    { 0x3C1A, "gas_cloud_origin" },
    { 0x3C1B, "gas_release" },
    { 0x3C1C, "gas_tags" },
    { 0x3C1D, "gas_warning_light_tags" },
    { 0x3C1E, "gascloudstart" },
    { 0x3C1F, "gasedvisionset" },
    { 0x3C20, "gaseffect" },
    { 0x3C21, "gasfieldsoff" },
    { 0x3C22, "gasfieldson" },
    { 0x3C23, "gasfriendly" },
    { 0x3C24, "gasmachine" },
    { 0x3C25, "gasmask" },
    { 0x3C26, "gasmask_breathing" },
    { 0x3C27, "gasmask_hud_elem" },
    { 0x3C28, "gasmask_hud_elem1" },
    { 0x3C29, "gasmask_off_npc" },
    { 0x3C2A, "gasmask_off_player" },
    { 0x3C2B, "gasmask_on_npc" },
    { 0x3C2C, "gasmask_on_player" },
    { 0x3C2D, "gasmissile" },
    { 0x3C2E, "gasoverlay" },
    { 0x3C2F, "gasparticletime" },
    { 0x3C30, "gasrange" },
    { 0x3C31, "gastime" },
    { 0x3C32, "gastrackingoverlay" },
    { 0x3C33, "gasvisualsend" },
    { 0x3C34, "gasvisualssetup" },
    { 0x3C35, "gasvisualsstart" },
    { 0x3C36, "gasvisualswarningstart" },
    { 0x3C37, "gate" },
    { 0x3C38, "gate_controlbox_broken_fx" },
    { 0x3C39, "gate_crash" },
    { 0x3C3A, "gate_decon_opposite_side" },
    { 0x3C3B, "gate_decon_opposite_side_guard" },
    { 0x3C3C, "gate_decon_player_side" },
    { 0x3C3D, "gate_decon_player_side_bones" },
    { 0x3C3E, "gate_decon_player_side_burke" },
    { 0x3C3F, "gate_decon_player_side_cinematic_screens" },
    { 0x3C40, "gate_decon_player_side_joker" },
    { 0x3C41, "gate_earthquake" },
    { 0x3C42, "gate_fx" },
    { 0x3C43, "gate_inner" },
    { 0x3C44, "gate_lightning" },
    { 0x3C45, "gate_lights_off" },
    { 0x3C46, "gate_lights_off_toggle_on" },
    { 0x3C47, "gate_lights_on" },
    { 0x3C48, "gate_model_spin" },
    { 0x3C49, "gate_open_rain_fall_fx" },
    { 0x3C4A, "gate_origin_change" },
    { 0x3C4B, "gate_pulse_on" },
    { 0x3C4C, "gate_rumble" },
    { 0x3C4D, "gate_spark_fx" },
    { 0x3C4E, "gatebreach" },
    { 0x3C4F, "gatebreachallyreachandidle" },
    { 0x3C50, "gatebreachandclear" },
    { 0x3C51, "gatebreachanimations" },
    { 0x3C52, "gatebreachdoorsexplode" },
    { 0x3C53, "gatebreachkill1" },
    { 0x3C54, "gatebreachkill2" },
    { 0x3C55, "gatebreachkillburke" },
    { 0x3C56, "gatebreachotherguysdie" },
    { 0x3C57, "gatebreachoutlineguard" },
    { 0x3C58, "gatebreachvictimapproach" },
    { 0x3C59, "gatebreachvictimdie" },
    { 0x3C5A, "gatefxoff" },
    { 0x3C5B, "gatefxon" },
    { 0x3C5C, "gateguarddialogue" },
    { 0x3C5D, "gateguardreminderdialogue" },
    { 0x3C5E, "gateopen" },
    { 0x3C5F, "gates" },
    { 0x3C60, "gather_delay" },
    { 0x3C61, "gather_delay_proc" },
    { 0x3C62, "gather_intel_trigger" },
    { 0x3C63, "gatherclassweapons" },
    { 0x3C64, "gaz" },
    { 0x3C65, "gaz_01_dist_by" },
    { 0x3C66, "gaz_02" },
    { 0x3C67, "gaz_02_dist_by" },
    { 0x3C68, "gaz_03" },
    { 0x3C69, "gaz_03_close_by" },
    { 0x3C6A, "gaz_04_slow_by" },
    { 0x3C6B, "gaz_05_slow_by" },
    { 0x3C6C, "gaz_brake_lights" },
    { 0x3C6D, "gaz_brake_lights_detail" },
    { 0x3C6E, "gaz_condition_callback_drive_to_idle" },
    { 0x3C6F, "gaz_condition_callback_first_to_second" },
    { 0x3C70, "gaz_condition_callback_idle_to_first" },
    { 0x3C71, "gaz_condition_callback_off_to_idle" },
    { 0x3C72, "gaz_condition_callback_second_to_first" },
    { 0x3C73, "gaz_condition_callback_state_off" },
    { 0x3C74, "gaz_condition_callback_to_off" },
    { 0x3C75, "gaz_condition_callback_to_state_wheels_bump" },
    { 0x3C76, "gaz_condition_callback_to_state_wheels_skid" },
    { 0x3C77, "gaz_damage_watcher" },
    { 0x3C78, "gaz_input_callback_about_to_stop" },
    { 0x3C79, "gaz_input_callback_zvelocity" },
    { 0x3C7A, "gaz_intro_waits" },
    { 0x3C7B, "gaz_splash_waits" },
    { 0x3C7C, "gaz_store_shootout_drive" },
    { 0x3C7D, "gaz_turret_guy_gettin_func" },
    { 0x3C7E, "gaz_turret_guy_think" },
    { 0x3C7F, "gaz_under_heat" },
    { 0x3C80, "gaz_water_crash_01" },
    { 0x3C81, "gaz_water_crash_02" },
    { 0x3C82, "gaz_water_crashed" },
    { 0x3C83, "gaz2" },
    { 0x3C84, "gd_player_lifts_gate" },
    { 0x3C85, "gelbombsquadmesh" },
    { 0x3C86, "gelexplosionfx" },
    { 0x3C87, "generate_fx_log" },
    { 0x3C88, "generatemaxweightedcratevalue" },
    { 0x3C89, "generatesquadname" },
    { 0x3C8A, "generator" },
    { 0x3C8B, "generator_fans" },
    { 0x3C8C, "generatorhat" },
    { 0x3C8D, "generic_clear" },
    { 0x3C8E, "generic_combat" },
    { 0x3C8F, "generic_damage_think" },
    { 0x3C90, "generic_dialogue_queue" },
    { 0x3C91, "generic_double_strobe" },
    { 0x3C92, "generic_enemy_vo_chatter" },
    { 0x3C93, "generic_event_actor_animations" },
    { 0x3C94, "generic_flicker" },
    { 0x3C95, "generic_flicker_msg_watcher" },
    { 0x3C96, "generic_flicker_pause" },
    { 0x3C97, "generic_flickering" },
    { 0x3C98, "generic_get_player_to_arms" },
    { 0x3C99, "generic_get_player_to_rig" },
    { 0x3C9A, "generic_get_rig_to_player" },
    { 0x3C9B, "generic_helmet_close" },
    { 0x3C9C, "generic_helmet_open" },
    { 0x3C9D, "generic_hint_vo" },
    { 0x3C9E, "generic_human" },
    { 0x3C9F, "generic_human_anims" },
    { 0x3CA0, "generic_index" },
    { 0x3CA1, "generic_keep_moving" },
    { 0x3CA2, "generic_locations" },
    { 0x3CA3, "generic_no_shot_vo_lines" },
    { 0x3CA4, "generic_pulsing" },
    { 0x3CA5, "generic_remove_player_rig" },
    { 0x3CA6, "generic_spot" },
    { 0x3CA7, "generic_squadron_deploy" },
    { 0x3CA8, "generic_taking_the_shot_vo_lines" },
    { 0x3CA9, "generic_target_acquired_vo_lines" },
    { 0x3CAA, "generic_target_down_vo_lines" },
    { 0x3CAB, "generic_traffic_preset_instance_init_callback" },
    { 0x3CAC, "generic_voice_override" },
    { 0x3CAD, "genericchallenge" },
    { 0x3CAE, "genius_achievement" },
    { 0x3CAF, "geo_flicker" },
    { 0x3CB0, "geo_off" },
    { 0x3CB1, "geo_on" },
    { 0x3CB2, "get_accurate_target" },
    { 0x3CB3, "get_adjusted_anim_rate" },
    { 0x3CB4, "get_adjusted_script_car_origin" },
    { 0x3CB5, "get_aerial_offset" },
    { 0x3CB6, "get_ai_fastzip_pos" },
    { 0x3CB7, "get_ai_group_ai" },
    { 0x3CB8, "get_ai_group_count" },
    { 0x3CB9, "get_ai_group_sentient_count" },
    { 0x3CBA, "get_ai_number" },
    { 0x3CBB, "get_ai_touching_volume" },
    { 0x3CBC, "get_ai_within_radius" },
    { 0x3CBD, "get_aim_limits" },
    { 0x3CBE, "get_alias_from_stored" },
    { 0x3CBF, "get_all_connected_nodes" },
    { 0x3CC0, "get_all_ents_in_chain" },
    { 0x3CC1, "get_all_force_color_friendlies" },
    { 0x3CC2, "get_all_my_locations" },
    { 0x3CC3, "get_all_target_ents" },
    { 0x3CC4, "get_all_valid_rocket_targets" },
    { 0x3CC5, "get_allied_attackers_for_team" },
    { 0x3CC6, "get_allied_defenders_for_team" },
    { 0x3CC7, "get_ally_flags" },
    { 0x3CC8, "get_angle_from_center" },
    { 0x3CC9, "get_angle_from_speed" },
    { 0x3CCA, "get_angle_mod_from_horiz_speed" },
    { 0x3CCB, "get_angle_mod_from_yaw_diff" },
    { 0x3CCC, "get_anim_data" },
    { 0x3CCD, "get_anim_position" },
    { 0x3CCE, "get_array_of_closest" },
    { 0x3CCF, "get_array_of_farthest" },
    { 0x3CD0, "get_attacker" },
    { 0x3CD1, "get_available_breachfriendlies" },
    { 0x3CD2, "get_availablepositions" },
    { 0x3CD3, "get_average_in_que" },
    { 0x3CD4, "get_average_origin" },
    { 0x3CD5, "get_badcountryidstr" },
    { 0x3CD6, "get_ball_goal_protect_radius" },
    { 0x3CD7, "get_best_ai_match_for_highest_priority_node" },
    { 0x3CD8, "get_best_available_new_colored_node" },
    { 0x3CD9, "get_best_cardoor_struct" },
    { 0x3CDA, "get_best_jump_target" },
    { 0x3CDB, "get_best_lock_target" },
    { 0x3CDC, "get_best_locking_target" },
    { 0x3CDD, "get_best_weapons" },
    { 0x3CDE, "get_bestdrone" },
    { 0x3CDF, "get_better_destructible" },
    { 0x3CE0, "get_black_overlay" },
    { 0x3CE1, "get_blast_door_num" },
    { 0x3CE2, "get_blended_difficulty" },
    { 0x3CE3, "get_breach_groups" },
    { 0x3CE4, "get_breach_indices_from_ents" },
    { 0x3CE5, "get_breach_notify" },
    { 0x3CE6, "get_broken_state_tags" },
    { 0x3CE7, "get_burke_to_deadroom" },
    { 0x3CE8, "get_c_right_dist_2d" },
    { 0x3CE9, "get_cardoor_in_players_hands" },
    { 0x3CEA, "get_center_of_array" },
    { 0x3CEB, "get_challenge_weapon_class" },
    { 0x3CEC, "get_civilian" },
    { 0x3CED, "get_civilian_ai" },
    { 0x3CEE, "get_civilian_car" },
    { 0x3CEF, "get_civilian_drone" },
    { 0x3CF0, "get_climb_triggers" },
    { 0x3CF1, "get_closest_ai" },
    { 0x3CF2, "get_closest_ai_exclude" },
    { 0x3CF3, "get_closest_ai_flat" },
    { 0x3CF4, "get_closest_ai_to_origin" },
    { 0x3CF5, "get_closest_ally" },
    { 0x3CF6, "get_closest_axis" },
    { 0x3CF7, "get_closest_colored_friendly" },
    { 0x3CF8, "get_closest_colored_friendly_with_classname" },
    { 0x3CF9, "get_closest_exclude" },
    { 0x3CFA, "get_closest_flag" },
    { 0x3CFB, "get_closest_index" },
    { 0x3CFC, "get_closest_index_to_player_view" },
    { 0x3CFD, "get_closest_living" },
    { 0x3CFE, "get_closest_neighbors" },
    { 0x3CFF, "get_closest_node_in_front_of_given_car" },
    { 0x3D00, "get_closest_on_glass_plane" },
    { 0x3D01, "get_closest_player" },
    { 0x3D02, "get_closest_player_healthy" },
    { 0x3D03, "get_closest_point" },
    { 0x3D04, "get_closest_point_from_segment_to_segment" },
    { 0x3D05, "get_closest_point_from_segment_to_segment_n" },
    { 0x3D06, "get_closest_point_on_segment" },
    { 0x3D07, "get_closest_scene" },
    { 0x3D08, "get_closest_tag" },
    { 0x3D09, "get_closest_to_player_view" },
    { 0x3D0A, "get_closest_with_targetname" },
    { 0x3D0B, "get_color_forced_ai" },
    { 0x3D0C, "get_color_info_from_trigger" },
    { 0x3D0D, "get_color_nodes_from_trigger" },
    { 0x3D0E, "get_color_nodes_from_trigger_codes" },
    { 0x3D0F, "get_color_spawner" },
    { 0x3D10, "get_color_to_promote_from_order" },
    { 0x3D11, "get_color_volume_from_trigger" },
    { 0x3D12, "get_color_volume_from_trigger_codes" },
    { 0x3D13, "get_colorcoded_nodes" },
    { 0x3D14, "get_colorcoded_volume" },
    { 0x3D15, "get_colorcodes" },
    { 0x3D16, "get_cormack_into_first_landassist" },
    { 0x3D17, "get_cormack_to_building_doorway" },
    { 0x3D18, "get_cormack_to_walker_scene" },
    { 0x3D19, "get_corpse_array" },
    { 0x3D1A, "get_countdown_hud" },
    { 0x3D1B, "get_country_prefix" },
    { 0x3D1C, "get_crash_deflection_angle" },
    { 0x3D1D, "get_crash_snd_alias" },
    { 0x3D1E, "get_crashed_vehicle_index" },
    { 0x3D1F, "get_createfx_array" },
    { 0x3D20, "get_createfx_types" },
    { 0x3D21, "get_cumulative_weights" },
    { 0x3D22, "get_curfloor" },
    { 0x3D23, "get_current_shot" },
    { 0x3D24, "get_current_weapon" },
    { 0x3D25, "get_current_weapon_name" },
    { 0x3D26, "get_custom_distance_on_path" },
    { 0x3D27, "get_damageable_grenade" },
    { 0x3D28, "get_damageable_grenade_pos" },
    { 0x3D29, "get_damageable_mine" },
    { 0x3D2A, "get_damageable_player" },
    { 0x3D2B, "get_damageable_player_pos" },
    { 0x3D2C, "get_damageable_sentry" },
    { 0x3D2D, "get_damb_component_stringtable" },
    { 0x3D2E, "get_damb_loops_stringtable" },
    { 0x3D2F, "get_damb_stringtable" },
    { 0x3D30, "get_datascene" },
    { 0x3D31, "get_death_anim" },
    { 0x3D32, "get_debug_element_color" },
    { 0x3D33, "get_delay" },
    { 0x3D34, "get_despawn_despawn_if_not_in_view" },
    { 0x3D35, "get_despawn_dist_sq" },
    { 0x3D36, "get_destroyed_count" },
    { 0x3D37, "get_destruct_parts" },
    { 0x3D38, "get_detection_distance_for_player_speed" },
    { 0x3D39, "get_diff_angles_from_facing" },
    { 0x3D3A, "get_diff_angles_from_gun" },
    { 0x3D3B, "get_diff_angles_from_tag_to_guy" },
    { 0x3D3C, "get_different_favoriteenemy" },
    { 0x3D3D, "get_different_player" },
    { 0x3D3E, "get_differentiated_acceleration" },
    { 0x3D3F, "get_differentiated_jerk" },
    { 0x3D40, "get_differentiated_speed" },
    { 0x3D41, "get_differentiated_velocity" },
    { 0x3D42, "get_direction" },
    { 0x3D43, "get_direction_from_normalized_movement" },
    { 0x3D44, "get_dist_to_end_in_miles" },
    { 0x3D45, "get_door" },
    { 0x3D46, "get_door_anime" },
    { 0x3D47, "get_door_model" },
    { 0x3D48, "get_door_volumes_from_breachgroup" },
    { 0x3D49, "get_dot" },
    { 0x3D4A, "get_download_state_hud" },
    { 0x3D4B, "get_drones_into_start_positions" },
    { 0x3D4C, "get_drones_touching_volume" },
    { 0x3D4D, "get_drones_with_targetname" },
    { 0x3D4E, "get_dummy" },
    { 0x3D4F, "get_e3_costume" },
    { 0x3D50, "get_edge_offset_bounds_at_progress" },
    { 0x3D51, "get_enemy_flags" },
    { 0x3D52, "get_enemy_team" },
    { 0x3D53, "get_enemy_warbird" },
    { 0x3D54, "get_ent" },
    { 0x3D55, "get_ent_by_target" },
    { 0x3D56, "get_ent_by_targetname" },
    { 0x3D57, "get_ent_closest_aerial_node" },
    { 0x3D58, "get_ents_by_noteworthy" },
    { 0x3D59, "get_ents_by_target" },
    { 0x3D5A, "get_ents_by_targetname" },
    { 0x3D5B, "get_escape_gas_dest_node" },
    { 0x3D5C, "get_evacuation_scene_spawner" },
    { 0x3D5D, "get_exo_ability_hud_omnvar_value" },
    { 0x3D5E, "get_exo_battery_percent" },
    { 0x3D5F, "get_exo_cloak_weapon" },
    { 0x3D60, "get_exo_shield_params" },
    { 0x3D61, "get_exo_shield_weapon" },
    { 0x3D62, "get_exploder_array" },
    { 0x3D63, "get_exploder_array_proc" },
    { 0x3D64, "get_exploder_ent" },
    { 0x3D65, "get_exploder_entarray" },
    { 0x3D66, "get_exploder_pos" },
    { 0x3D67, "get_extended_path" },
    { 0x3D68, "get_eye" },
    { 0x3D69, "get_eye_relative_dir" },
    { 0x3D6A, "get_fall_damage_from_speed" },
    { 0x3D6B, "get_farthest_car" },
    { 0x3D6C, "get_farthest_ent" },
    { 0x3D6D, "get_farthest_living" },
    { 0x3D6E, "get_field_from_array" },
    { 0x3D6F, "get_first_storable_weapon" },
    { 0x3D70, "get_flag_capture_radius" },
    { 0x3D71, "get_flag_label" },
    { 0x3D72, "get_flag_protect_radius" },
    { 0x3D73, "get_flashed_anim" },
    { 0x3D74, "get_flickerlight_motion_preset" },
    { 0x3D75, "get_flickerlight_preset" },
    { 0x3D76, "get_floor" },
    { 0x3D77, "get_floor_count_array" },
    { 0x3D78, "get_flush_volume" },
    { 0x3D79, "get_fog" },
    { 0x3D7A, "get_fog_filename" },
    { 0x3D7B, "get_follow_volume_array" },
    { 0x3D7C, "get_force_color" },
    { 0x3D7D, "get_force_color_guys" },
    { 0x3D7E, "get_forward_movement" },
    { 0x3D7F, "get_forward_movement_grab" },
    { 0x3D80, "get_fov_for_player" },
    { 0x3D81, "get_from_entity" },
    { 0x3D82, "get_from_entity_target" },
    { 0x3D83, "get_from_spawnstruct" },
    { 0x3D84, "get_from_spawnstruct_target" },
    { 0x3D85, "get_from_vehicle_node" },
    { 0x3D86, "get_front_sorted_threat_list" },
    { 0x3D87, "get_fx_chain" },
    { 0x3D88, "get_fx_count_for_speed" },
    { 0x3D89, "get_generic_anime" },
    { 0x3D8A, "get_geo_group" },
    { 0x3D8B, "get_goal_angles_ramped_given_viewdir" },
    { 0x3D8C, "get_goal_pos_on_segment" },
    { 0x3D8D, "get_group_connect_dist" },
    { 0x3D8E, "get_grouped_doorvolumes" },
    { 0x3D8F, "get_gun_pitch_rate" },
    { 0x3D90, "get_gun_yaw_rate" },
    { 0x3D91, "get_guy_offset" },
    { 0x3D92, "get_guy_or_backup_target_if_guy_died_or_dummy_target" },
    { 0x3D93, "get_guys_in_vols_and_kill" },
    { 0x3D94, "get_head_or_tail_variables" },
    { 0x3D95, "get_heart_rate_hud" },
    { 0x3D96, "get_helo_spotlight_bullet_origin" },
    { 0x3D97, "get_heroes" },
    { 0x3D98, "get_highest_dot" },
    { 0x3D99, "get_housing_children" },
    { 0x3D9A, "get_housing_closedpos" },
    { 0x3D9B, "get_housing_door_trigger" },
    { 0x3D9C, "get_housing_inside_trigger" },
    { 0x3D9D, "get_housing_leftdoor" },
    { 0x3D9E, "get_housing_leftdoor_opened_pos" },
    { 0x3D9F, "get_housing_mainframe" },
    { 0x3DA0, "get_housing_models" },
    { 0x3DA1, "get_housing_musak_model" },
    { 0x3DA2, "get_housing_primarylight" },
    { 0x3DA3, "get_housing_rightdoor" },
    { 0x3DA4, "get_housing_rightdoor_opened_pos" },
    { 0x3DA5, "get_hovertank_shake_value" },
    { 0x3DA6, "get_human_player" },
    { 0x3DA7, "get_idle_anim" },
    { 0x3DA8, "get_ignoreme" },
    { 0x3DA9, "get_in_mobile_turret_guy" },
    { 0x3DAA, "get_in_moving_vehicle" },
    { 0x3DAB, "get_in_vehicle" },
    { 0x3DAC, "get_index_for_weapon_name" },
    { 0x3DAD, "get_index_from_array" },
    { 0x3DAE, "get_index_from_weapon" },
    { 0x3DAF, "get_initfloor" },
    { 0x3DB0, "get_interior_intensity" },
    { 0x3DB1, "get_jet_array" },
    { 0x3DB2, "get_landing_node" },
    { 0x3DB3, "get_laser_designated_trace" },
    { 0x3DB4, "get_last_ent_in_chain" },
    { 0x3DB5, "get_last_known_shoot_pos" },
    { 0x3DB6, "get_last_selected_ent" },
    { 0x3DB7, "get_launch_anim" },
    { 0x3DB8, "get_least_used_from_array" },
    { 0x3DB9, "get_least_used_index" },
    { 0x3DBA, "get_legal_drone_for_kamikaze" },
    { 0x3DBB, "get_leveltime" },
    { 0x3DBC, "get_limit" },
    { 0x3DBD, "get_limit_table" },
    { 0x3DBE, "get_linked_air_spaces" },
    { 0x3DBF, "get_linked_ent" },
    { 0x3DC0, "get_linked_ents" },
    { 0x3DC1, "get_linked_nodes" },
    { 0x3DC2, "get_linked_points" },
    { 0x3DC3, "get_linked_structs" },
    { 0x3DC4, "get_linked_vehicle_node" },
    { 0x3DC5, "get_linked_vehicle_nodes" },
    { 0x3DC6, "get_links" },
    { 0x3DC7, "get_littlebird_crash_location_override" },
    { 0x3DC8, "get_living_ai" },
    { 0x3DC9, "get_living_ai_array" },
    { 0x3DCA, "get_living_aispecies" },
    { 0x3DCB, "get_living_aispecies_array" },
    { 0x3DCC, "get_living_players_on_team" },
    { 0x3DCD, "get_load_trigger_classes" },
    { 0x3DCE, "get_load_trigger_funcs" },
    { 0x3DCF, "get_loadout" },
    { 0x3DD0, "get_locked_difficulty_step_val_global" },
    { 0x3DD1, "get_locked_difficulty_step_val_player" },
    { 0x3DD2, "get_locked_difficulty_val_global" },
    { 0x3DD3, "get_locked_difficulty_val_player" },
    { 0x3DD4, "get_lt_button_info" },
    { 0x3DD5, "get_manhandled" },
    { 0x3DD6, "get_max_cars" },
    { 0x3DD7, "get_max_charge_time" },
    { 0x3DD8, "get_max_destroyed_count" },
    { 0x3DD9, "get_max_num_defenders_wanted_per_flag" },
    { 0x3DDA, "get_mech_chaingun_state" },
    { 0x3DDB, "get_mech_rocket_state" },
    { 0x3DDC, "get_mech_state" },
    { 0x3DDD, "get_mech_swarm_state" },
    { 0x3DDE, "get_minutes_and_seconds" },
    { 0x3DDF, "get_missile_target_offset" },
    { 0x3DE0, "get_mobile_cover_base_from_ent" },
    { 0x3DE1, "get_mode_for_weapon_name" },
    { 0x3DE2, "get_multiplier" },
    { 0x3DE3, "get_my_free_path_node" },
    { 0x3DE4, "get_my_vehicleride" },
    { 0x3DE5, "get_name" },
    { 0x3DE6, "get_name_for_nationality" },
    { 0x3DE7, "get_nearest" },
    { 0x3DE8, "get_nearest_capzone_team" },
    { 0x3DE9, "get_nearest_common" },
    { 0x3DEA, "get_nearest_not_plr" },
    { 0x3DEB, "get_neighbor_node" },
    { 0x3DEC, "get_neighbor_node_of_target" },
    { 0x3DED, "get_next_air_space" },
    { 0x3DEE, "get_next_allow_melee_time" },
    { 0x3DEF, "get_next_grid_position" },
    { 0x3DF0, "get_node" },
    { 0x3DF1, "get_node_at_radius_distance" },
    { 0x3DF2, "get_node_funcs_based_on_target" },
    { 0x3DF3, "get_non_mech_enemies" },
    { 0x3DF4, "get_normalized_point_in_volume" },
    { 0x3DF5, "get_notetrack_movement" },
    { 0x3DF6, "get_noteworthy_ent" },
    { 0x3DF7, "get_nozzle_opening_from_speed" },
    { 0x3DF8, "get_npc_center_offset" },
    { 0x3DF9, "get_num_allies_capturing_flag" },
    { 0x3DFA, "get_num_allies_getting_tag" },
    { 0x3DFB, "get_num_ally_flags" },
    { 0x3DFC, "get_num_card_tags" },
    { 0x3DFD, "get_num_visible_card_tags" },
    { 0x3DFE, "get_nums_from_origins" },
    { 0x3DFF, "get_obj_event" },
    { 0x3E00, "get_obj_origin" },
    { 0x3E01, "get_obstacle_dodge_amount" },
    { 0x3E02, "get_oldtown_doc_civ_vol" },
    { 0x3E03, "get_on_console_nag_lines" },
    { 0x3E04, "get_opposite_volume" },
    { 0x3E05, "get_option" },
    { 0x3E06, "get_optional_overlay" },
    { 0x3E07, "get_order_responder" },
    { 0x3E08, "get_origin_and_dir_on_glass_plane" },
    { 0x3E09, "get_other_flag" },
    { 0x3E0A, "get_other_player" },
    { 0x3E0B, "get_out_anim" },
    { 0x3E0C, "get_out_override" },
    { 0x3E0D, "get_out_time" },
    { 0x3E0E, "get_outer_closedpos" },
    { 0x3E0F, "get_outer_doorset" },
    { 0x3E10, "get_outer_doorsets" },
    { 0x3E11, "get_outer_leftdoor" },
    { 0x3E12, "get_outer_leftdoor_openedpos" },
    { 0x3E13, "get_outer_rightdoor" },
    { 0x3E14, "get_outer_rightdoor_openedpos" },
    { 0x3E15, "get_outside_range" },
    { 0x3E16, "get_overlay" },
    { 0x3E17, "get_override_flag_targets" },
    { 0x3E18, "get_override_zone_targets" },
    { 0x3E19, "get_pacifist" },
    { 0x3E1A, "get_part_fx_cost_for_action_state" },
    { 0x3E1B, "get_passengers" },
    { 0x3E1C, "get_path_getfunc" },
    { 0x3E1D, "get_path_segment_array" },
    { 0x3E1E, "get_pdrone_crash_location_override" },
    { 0x3E1F, "get_perlin_noise_position" },
    { 0x3E20, "get_photo_copier" },
    { 0x3E21, "get_phraseinvalidstr" },
    { 0x3E22, "get_pitbull_anim_node" },
    { 0x3E23, "get_pitbull_shake_value" },
    { 0x3E24, "get_plane_gun_angles" },
    { 0x3E25, "get_plane_gun_origin" },
    { 0x3E26, "get_player_anim_node" },
    { 0x3E27, "get_player_feet_from_view" },
    { 0x3E28, "get_player_from_self" },
    { 0x3E29, "get_player_gameskill" },
    { 0x3E2A, "get_player_grenade_button" },
    { 0x3E2B, "get_player_local_yaw" },
    { 0x3E2C, "get_player_point_target" },
    { 0x3E2D, "get_player_speed" },
    { 0x3E2E, "get_player_test_points" },
    { 0x3E2F, "get_player_touching" },
    { 0x3E30, "get_player_velocity" },
    { 0x3E31, "get_player_view_controller" },
    { 0x3E32, "get_player_volume" },
    { 0x3E33, "get_players_by_role" },
    { 0x3E34, "get_players_defending_flag" },
    { 0x3E35, "get_players_defending_zone" },
    { 0x3E36, "get_players_healthy" },
    { 0x3E37, "get_players_watching" },
    { 0x3E38, "get_pool_spawners_from_structarray" },
    { 0x3E39, "get_portable_mg_spot" },
    { 0x3E3A, "get_pos_at_given_distance_on_lane" },
    { 0x3E3B, "get_position_from_spline" },
    { 0x3E3C, "get_post_landing_dir" },
    { 0x3E3D, "get_precached_anim" },
    { 0x3E3E, "get_precached_animtree" },
    { 0x3E3F, "get_print3d_text" },
    { 0x3E40, "get_progress" },
    { 0x3E41, "get_progression_between_points" },
    { 0x3E42, "get_pulselight_preset" },
    { 0x3E43, "get_pulsing_hud" },
    { 0x3E44, "get_radius_of_array" },
    { 0x3E45, "get_random_air_space" },
    { 0x3E46, "get_random_character" },
    { 0x3E47, "get_random_outside_target" },
    { 0x3E48, "get_random_point_in_air_space" },
    { 0x3E49, "get_random_point_in_bounds" },
    { 0x3E4A, "get_random_point_in_volume" },
    { 0x3E4B, "get_random_point_nearby_in_volume" },
    { 0x3E4C, "get_random_point_radius_in_volume" },
    { 0x3E4D, "get_random_strings_and_alphabatize" },
    { 0x3E4E, "get_random_weapon" },
    { 0x3E4F, "get_rank_xp_and_prestige_for_bot" },
    { 0x3E50, "get_reactive_sound_ent" },
    { 0x3E51, "get_ready_to_use_turret" },
    { 0x3E52, "get_relative_direction" },
    { 0x3E53, "get_requested_jump_direction" },
    { 0x3E54, "get_requested_move_direction" },
    { 0x3E55, "get_responder_given_category" },
    { 0x3E56, "get_reverb_stringtable" },
    { 0x3E57, "get_right_stick_angle" },
    { 0x3E58, "get_room_volume_from_slomo_breach_number" },
    { 0x3E59, "get_round_end_time" },
    { 0x3E5A, "get_rt_button_info" },
    { 0x3E5B, "get_rumble_ent" },
    { 0x3E5C, "get_script_linkto_targets" },
    { 0x3E5D, "get_script_palette" },
    { 0x3E5E, "get_segment_max_progress_at_offset" },
    { 0x3E5F, "get_selected_move_vector" },
    { 0x3E60, "get_selected_option" },
    { 0x3E61, "get_self_ent" },
    { 0x3E62, "get_shoot_pos_with_offset" },
    { 0x3E63, "get_shot_by_drone_swarm" },
    { 0x3E64, "get_shuffle_to_corner_start_anim" },
    { 0x3E65, "get_single_living_ent" },
    { 0x3E66, "get_skill_from_index" },
    { 0x3E67, "get_smart_grenade_timer" },
    { 0x3E68, "get_smoke_pair" },
    { 0x3E69, "get_spawn_chance" },
    { 0x3E6A, "get_spawn_weapon_name" },
    { 0x3E6B, "get_spawner_from_pool" },
    { 0x3E6C, "get_specific_flag_by_label" },
    { 0x3E6D, "get_specific_flag_by_letter" },
    { 0x3E6E, "get_specific_zone" },
    { 0x3E6F, "get_spin_snd_alias" },
    { 0x3E70, "get_squad_out_of_pitbull" },
    { 0x3E71, "get_stage_nodes" },
    { 0x3E72, "get_standard_glow_text" },
    { 0x3E73, "get_start_dvars" },
    { 0x3E74, "get_start_spawn_centers" },
    { 0x3E75, "get_starting_offset_from_org" },
    { 0x3E76, "get_stick_dir_in_world_coor" },
    { 0x3E77, "get_stop_credits_button" },
    { 0x3E78, "get_stop_watch" },
    { 0x3E79, "get_storable_current_weapon" },
    { 0x3E7A, "get_storable_current_weapon_primary" },
    { 0x3E7B, "get_storable_weapons_list_all" },
    { 0x3E7C, "get_storable_weapons_list_primaries" },
    { 0x3E7D, "get_string_for_starts" },
    { 0x3E7E, "get_stringtable_mapname" },
    { 0x3E7F, "get_strip_color" },
    { 0x3E80, "get_strip_settings" },
    { 0x3E81, "get_stun_thread_for_ai" },
    { 0x3E82, "get_sun_direction" },
    { 0x3E83, "get_suppress_point" },
    { 0x3E84, "get_surface_override_function" },
    { 0x3E85, "get_surface_types" },
    { 0x3E86, "get_table_name" },
    { 0x3E87, "get_tactical_goal_pos" },
    { 0x3E88, "get_tag_index_from_tag_name" },
    { 0x3E89, "get_talker_func" },
    { 0x3E8A, "get_tank_health_percent" },
    { 0x3E8B, "get_target_air_space" },
    { 0x3E8C, "get_target_ent" },
    { 0x3E8D, "get_target_ents" },
    { 0x3E8E, "get_target_from_avatar" },
    { 0x3E8F, "get_target_nodes" },
    { 0x3E90, "get_target_score" },
    { 0x3E91, "get_target_structs" },
    { 0x3E92, "get_team" },
    { 0x3E93, "get_team_or_script_team" },
    { 0x3E94, "get_team_substr" },
    { 0x3E95, "get_teleport_delta" },
    { 0x3E96, "get_teleport_optimized_breachfriendly" },
    { 0x3E97, "get_template_level" },
    { 0x3E98, "get_threat_detectables" },
    { 0x3E99, "get_title_credit" },
    { 0x3E9A, "get_to_cherry_picker" },
    { 0x3E9B, "get_to_roof_nag" },
    { 0x3E9C, "get_tool_hudelem" },
    { 0x3E9D, "get_total_distance2d_on_path" },
    { 0x3E9E, "get_trace_types" },
    { 0x3E9F, "get_traffic_model" },
    { 0x3EA0, "get_traffic_weight" },
    { 0x3EA1, "get_trajectory_time_given_x" },
    { 0x3EA2, "get_trajectory_v_given_x" },
    { 0x3EA3, "get_trajectory_x_given_time" },
    { 0x3EA4, "get_traverse_disconnect_brush" },
    { 0x3EA5, "get_treadfx" },
    { 0x3EA6, "get_trigger_flag" },
    { 0x3EA7, "get_trigger_location_qualifier" },
    { 0x3EA8, "get_trigger_targs" },
    { 0x3EA9, "get_trophy_ammo" },
    { 0x3EAA, "get_turbine_shake_value" },
    { 0x3EAB, "get_turret_iteration_helper" },
    { 0x3EAC, "get_turret_setup_anim" },
    { 0x3EAD, "get_turrets" },
    { 0x3EAE, "get_uncliip_zipline_waittime" },
    { 0x3EAF, "get_underwater_walk_speed_scale_ai" },
    { 0x3EB0, "get_underwater_walk_speed_scale_default" },
    { 0x3EB1, "get_unload_group" },
    { 0x3EB2, "get_unused_crash_locations" },
    { 0x3EB3, "get_use_key" },
    { 0x3EB4, "get_valid_vols" },
    { 0x3EB5, "get_vehicle" },
    { 0x3EB6, "get_vehicle_ai_riders" },
    { 0x3EB7, "get_vehicle_ai_spawners" },
    { 0x3EB8, "get_vehicle_anim" },
    { 0x3EB9, "get_vehicle_array" },
    { 0x3EBA, "get_vehicle_effect" },
    { 0x3EBB, "get_vehicle_player_anim" },
    { 0x3EBC, "get_vehicle_pos_from_spline" },
    { 0x3EBD, "get_vehiclenode_any_dynamic" },
    { 0x3EBE, "get_vehicles_to_point_at_same_time" },
    { 0x3EBF, "get_vehnode_by_targetname" },
    { 0x3EC0, "get_vehnodes_by_targetname" },
    { 0x3EC1, "get_visible_nodes_array" },
    { 0x3EC2, "get_vision_set_fog" },
    { 0x3EC3, "get_walk_anim" },
    { 0x3EC4, "get_warbird_crash_location_override" },
    { 0x3EC5, "get_wash_effect" },
    { 0x3EC6, "get_wash_fx" },
    { 0x3EC7, "get_water_weapon" },
    { 0x3EC8, "get_weapon_fire_pos" },
    { 0x3EC9, "get_weapon_from_index" },
    { 0x3ECA, "get_weapon_model" },
    { 0x3ECB, "get_weapon_with_most_kills" },
    { 0x3ECC, "get_wheel_velocity" },
    { 0x3ECD, "get_white_overlay" },
    { 0x3ECE, "get_will_into_first_landassist" },
    { 0x3ECF, "get_will_to_building_doorway" },
    { 0x3ED0, "get_will_to_fob_anim_scene" },
    { 0x3ED1, "get_will_to_walker_scene" },
    { 0x3ED2, "get_within_range" },
    { 0x3ED3, "get_world_pitch_yaw_between_vectors" },
    { 0x3ED4, "get_world_relative_offset" },
    { 0x3ED5, "get_x_button" },
    { 0x3ED6, "get_yaw_offset_if_vm_model" },
    { 0x3ED7, "get_zone_dir" },
    { 0x3ED8, "get_zone_origins" },
    { 0x3ED9, "get_zone_origins_auto" },
    { 0x3EDA, "get_zone_stringtable" },
    { 0x3EDB, "getachievement" },
    { 0x3EDC, "getactiveagentsoftype" },
    { 0x3EDD, "getactiveplayerlist" },
    { 0x3EDE, "getadditionalbomberplanestarts" },
    { 0x3EDF, "getaerialkillstreakarray" },
    { 0x3EE0, "getagentdamagescalar" },
    { 0x3EE1, "getaiarraytouchingvolume" },
    { 0x3EE2, "getaicountincrease" },
    { 0x3EE3, "getaicurrentweapon" },
    { 0x3EE4, "getaicurrentweaponslot" },
    { 0x3EE5, "getaimpitchtoshootentorpos" },
    { 0x3EE6, "getaimyawtopoint" },
    { 0x3EE7, "getaimyawtoshootentorpos" },
    { 0x3EE8, "getaiprimaryweapon" },
    { 0x3EE9, "getairstrikedanger" },
    { 0x3EEA, "getaisecondaryweapon" },
    { 0x3EEB, "getaisidearmweapon" },
    { 0x3EEC, "getaliastypefromsoundalias" },
    { 0x3EED, "getallactiveparts" },
    { 0x3EEE, "getallstreakmodulescost" },
    { 0x3EEF, "getallweapons" },
    { 0x3EF0, "getallyassisttime" },
    { 0x3EF1, "getalternatemeleedeathanim" },
    { 0x3EF2, "getambushshootpos" },
    { 0x3EF3, "getammoforturretweapontype" },
    { 0x3EF4, "getangleindex" },
    { 0x3EF5, "getangleindexfromselfyaw" },
    { 0x3EF6, "getangleindices" },
    { 0x3EF7, "getangles_func" },
    { 0x3EF8, "getanim" },
    { 0x3EF9, "getanim_from_animname" },
    { 0x3EFA, "getanim_generic" },
    { 0x3EFB, "getanim_vm" },
    { 0x3EFC, "getanim_vm_index" },
    { 0x3EFD, "getanimatemodel" },
    { 0x3EFE, "getanimdata" },
    { 0x3EFF, "getanimendpos" },
    { 0x3F00, "getanimscalefactors" },
    { 0x3F01, "getanimtimeremainingseconds" },
    { 0x3F02, "getanimtimeseconds" },
    { 0x3F03, "getapproachent" },
    { 0x3F04, "getapproachpoint" },
    { 0x3F05, "getappropanim" },
    { 0x3F06, "getarrayelementsincone" },
    { 0x3F07, "getarrivalnode" },
    { 0x3F08, "getarrivalprestartpos" },
    { 0x3F09, "getarrivalstartpos" },
    { 0x3F0A, "getaspectratio" },
    { 0x3F0B, "getassaultvehiclec4radius" },
    { 0x3F0C, "getattachmentlistbasenames" },
    { 0x3F0D, "getattachmentlistuniqenames" },
    { 0x3F0E, "getattachmenttype" },
    { 0x3F0F, "getattackpoint" },
    { 0x3F10, "getaverageorigin" },
    { 0x3F11, "getaverageplayerorigin" },
    { 0x3F12, "getbackdeathanim" },
    { 0x3F13, "getbasefromlootversion" },
    { 0x3F14, "getbaseweaponname" },
    { 0x3F15, "getbeameffect" },
    { 0x3F16, "getbeament" },
    { 0x3F17, "getbestcovermode" },
    { 0x3F18, "getbestcovernodeifavailable" },
    { 0x3F19, "getbestenemy" },
    { 0x3F1A, "getbestspawnpoint" },
    { 0x3F1B, "getbeststepoutpos" },
    { 0x3F1C, "getbetterplayer" },
    { 0x3F1D, "getbetterteam" },
    { 0x3F1E, "getboredofthisnodetime" },
    { 0x3F1F, "getbuddyspawnangles" },
    { 0x3F20, "getbumpallowancebasedondifficulty" },
    { 0x3F21, "getburstdelaytime" },
    { 0x3F22, "getburster" },
    { 0x3F23, "getburstsize" },
    { 0x3F24, "getcameraent" },
    { 0x3F25, "getcamoindex" },
    { 0x3F26, "getcamostring" },
    { 0x3F27, "getcannedresponse" },
    { 0x3F28, "getcapxpscale" },
    { 0x3F29, "getcarepackagestreakforreinforcementoftype" },
    { 0x3F2A, "getcarrierweaponcurrent" },
    { 0x3F2B, "getcentroiddistance" },
    { 0x3F2C, "getchain" },
    { 0x3F2D, "getchains" },
    { 0x3F2E, "getchallengefilter" },
    { 0x3F2F, "getchallengestatus" },
    { 0x3F30, "getchallengetable" },
    { 0x3F31, "getchar" },
    { 0x3F32, "getclaimednode" },
    { 0x3F33, "getclaimteam" },
    { 0x3F34, "getclasschoice" },
    { 0x3F35, "getclassindex" },
    { 0x3F36, "getclosest" },
    { 0x3F37, "getclosest_in_front" },
    { 0x3F38, "getclosestauto" },
    { 0x3F39, "getclosestdrone" },
    { 0x3F3A, "getclosestflat" },
    { 0x3F3B, "getclosestfriendlyspeaker" },
    { 0x3F3C, "getclosestfx" },
    { 0x3F3D, "getclosests_flickering_model" },
    { 0x3F3E, "getcollision" },
    { 0x3F3F, "getcompasstext" },
    { 0x3F40, "getcornermode" },
    { 0x3F41, "getcorrectcoverangles" },
    { 0x3F42, "getcovermultipretendtype" },
    { 0x3F43, "getcratetypefordroptype" },
    { 0x3F44, "getcrouchdeathanim" },
    { 0x3F45, "getcrouchpainanim" },
    { 0x3F46, "getcrouchrunanim" },
    { 0x3F47, "getcurrentdifficultysetting" },
    { 0x3F48, "getcurrentforwardmovementanimation" },
    { 0x3F49, "getcurrentfraction" },
    { 0x3F4A, "getcurrentweaponslotname" },
    { 0x3F4B, "getdamageableents" },
    { 0x3F4C, "getdamagedirection" },
    { 0x3F4D, "getdamagelocation" },
    { 0x3F4E, "getdamageshieldpainanim" },
    { 0x3F4F, "getdamagetype" },
    { 0x3F50, "getdeathanim" },
    { 0x3F51, "getdeathspawnpoint" },
    { 0x3F52, "getdefaultcostume" },
    { 0x3F53, "getdefaultidlestate" },
    { 0x3F54, "getdefaultoverdrivespeedscale" },
    { 0x3F55, "getdegreeselevation" },
    { 0x3F56, "getdescription" },
    { 0x3F57, "getdesireddrivenmovemode" },
    { 0x3F58, "getdesiredgrenadetimervalue" },
    { 0x3F59, "getdesiredidlepose" },
    { 0x3F5A, "getdialogai" },
    { 0x3F5B, "getdifficulty" },
    { 0x3F5C, "getdirectedenergydeathanim" },
    { 0x3F5D, "getdirectioncompass" },
    { 0x3F5E, "getdirectionfacingangle" },
    { 0x3F5F, "getdirectionfacingclock" },
    { 0x3F60, "getdirectionfacingclockgivenangle" },
    { 0x3F61, "getdirectionfacingflank" },
    { 0x3F62, "getdistanceyards" },
    { 0x3F63, "getdistanceyardsnormalized" },
    { 0x3F64, "getdogdeathanim" },
    { 0x3F65, "getdogflashedanim" },
    { 0x3F66, "getdogmoveanim" },
    { 0x3F67, "getdognexttwitchtime" },
    { 0x3F68, "getdogpainanim" },
    { 0x3F69, "getdogstopanim" },
    { 0x3F6A, "getdogstopanimbase" },
    { 0x3F6B, "getdogstopanimlook" },
    { 0x3F6C, "getdogstoptransitionanim" },
    { 0x3F6D, "getdogturnanim" },
    { 0x3F6E, "getdomroundtimepassed" },
    { 0x3F6F, "getdoorside" },
    { 0x3F70, "getdronelerpfraction" },
    { 0x3F71, "getdroneperlinovertime" },
    { 0x3F72, "getdronespawnpoint" },
    { 0x3F73, "getdroptypefromstreakname" },
    { 0x3F74, "getdudefromarray" },
    { 0x3F75, "getdudesfromarray" },
    { 0x3F76, "getdvarfloatdefault" },
    { 0x3F77, "getdvarintdefault" },
    { 0x3F78, "getdvarvec" },
    { 0x3F79, "getdynamiceventhighestscore" },
    { 0x3F7A, "getdynamiceventstarttime" },
    { 0x3F7B, "getdynamiceventtimelimit" },
    { 0x3F7C, "getearliestclaimplayer" },
    { 0x3F7D, "getempdamageents" },
    { 0x3F7E, "getemptyloadout" },
    { 0x3F7F, "getemptyperks" },
    { 0x3F80, "getenemyeyepos" },
    { 0x3F81, "getenemysightpos" },
    { 0x3F82, "getenemytarget" },
    { 0x3F83, "getenemytargets" },
    { 0x3F84, "getenemyteam" },
    { 0x3F85, "getent_or_struct" },
    { 0x3F86, "getent_or_struct_or_node" },
    { 0x3F87, "getentarraywithflag" },
    { 0x3F88, "getentitytargetlocationwithspread" },
    { 0x3F89, "getentorstruct" },
    { 0x3F8A, "getentorstructarray" },
    { 0x3F8B, "getentsbyfxid" },
    { 0x3F8C, "getentwithflag" },
    { 0x3F8D, "geteventstate" },
    { 0x3F8E, "getexitnode" },
    { 0x3F8F, "getexitsplittime" },
    { 0x3F90, "getexploderdelaydefault" },
    { 0x3F91, "getexploders" },
    { 0x3F92, "geteyeyawtoorigin" },
    { 0x3F93, "getfadetime" },
    { 0x3F94, "getfarthest" },
    { 0x3F95, "getfastburstdelaytime" },
    { 0x3F96, "getfinaldroplocation" },
    { 0x3F97, "getfireeffect" },
    { 0x3F98, "getfirelightshoweffect" },
    { 0x3F99, "getfirstprimaryweapon" },
    { 0x3F9A, "getfirstzone" },
    { 0x3F9B, "getflagteam" },
    { 0x3F9C, "getflavorburstaliases" },
    { 0x3F9D, "getflavorburstid" },
    { 0x3F9E, "getflightdistance" },
    { 0x3F9F, "getflightpath" },
    { 0x3FA0, "getfloatproperty" },
    { 0x3FA1, "getfocusfromcontroller" },
    { 0x3FA2, "getfollowmovemode" },
    { 0x3FA3, "getformattedvalue" },
    { 0x3FA4, "getfraggrenadecount" },
    { 0x3FA5, "getfreeagent" },
    { 0x3FA6, "getfriendlylosmarker" },
    { 0x3FA7, "getfriendlymarker" },
    { 0x3FA8, "getfriendlyspawnstart" },
    { 0x3FA9, "getfriendlyspawntrigger" },
    { 0x3FAA, "getfrontarcclockdirection" },
    { 0x3FAB, "getfx" },
    { 0x3FAC, "getfxarraybyid" },
    { 0x3FAD, "getgametypenumlives" },
    { 0x3FAE, "getgamewinner" },
    { 0x3FAF, "getgenericanim" },
    { 0x3FB0, "getgrenadedropvelocity" },
    { 0x3FB1, "getgrenadegraceperiodtimeleft" },
    { 0x3FB2, "getgrenadeithrew" },
    { 0x3FB3, "getgrenademodel" },
    { 0x3FB4, "getgrenadethrowoffset" },
    { 0x3FB5, "getgrenadetimertime" },
    { 0x3FB6, "getgroundent" },
    { 0x3FB7, "getgroundslamcrushdamage" },
    { 0x3FB8, "getgroundslamhitlateralvimpart" },
    { 0x3FB9, "getgroundslamhitverticalvimpart" },
    { 0x3FBA, "getgroundslammaxdamage" },
    { 0x3FBB, "getgroundslammaxheight" },
    { 0x3FBC, "getgroundslammaxradius" },
    { 0x3FBD, "getgroundslammindamage" },
    { 0x3FBE, "getgroundslamminheight" },
    { 0x3FBF, "getgroundslamminradius" },
    { 0x3FC0, "getgroundslamragdolldirscale" },
    { 0x3FC1, "getgunpitchtoshootentorpos" },
    { 0x3FC2, "getgunyawtoshootentorpos" },
    { 0x3FC3, "gethalftime" },
    { 0x3FC4, "gethardcorecostume" },
    { 0x3FC5, "gethardenedaward" },
    { 0x3FC6, "gethelianchor" },
    { 0x3FC7, "gethelipilotmeshoffset" },
    { 0x3FC8, "gethelipilottraceoffset" },
    { 0x3FC9, "gethighestdot" },
    { 0x3FCA, "gethighestpriorityevent" },
    { 0x3FCB, "gethighestprogressedplayers" },
    { 0x3FCC, "gethighestscoringplayer" },
    { 0x3FCD, "gethighestscoringplayersarray" },
    { 0x3FCE, "gethitlocheight" },
    { 0x3FCF, "gethitloctag" },
    { 0x3FD0, "gethostilelosmarker" },
    { 0x3FD1, "gethostilemarker" },
    { 0x3FD2, "gethostplayer" },
    { 0x3FD3, "geticonshader" },
    { 0x3FD4, "geticontypeforreinforcementoftype" },
    { 0x3FD5, "getin" },
    { 0x3FD6, "getin_enteredvehicletrack" },
    { 0x3FD7, "getin_idle_func" },
    { 0x3FD8, "getinchesinfeet" },
    { 0x3FD9, "getindex" },
    { 0x3FDA, "getinorgs" },
    { 0x3FDB, "getinshadow_func" },
    { 0x3FDC, "getintervalsounddelaymaxdefault" },
    { 0x3FDD, "getintervalsounddelaymindefault" },
    { 0x3FDE, "getintproperty" },
    { 0x3FDF, "getitemweaponname" },
    { 0x3FE0, "getjointeampermissions" },
    { 0x3FE1, "getkeepweapons" },
    { 0x3FE2, "getkillcamentity" },
    { 0x3FE3, "getkillstreakalliesdialog" },
    { 0x3FE4, "getkillstreakallteamstreak" },
    { 0x3FE5, "getkillstreakcount" },
    { 0x3FE6, "getkillstreakcrateicon" },
    { 0x3FE7, "getkillstreakdescription" },
    { 0x3FE8, "getkillstreakdialog" },
    { 0x3FE9, "getkillstreakdpadicon" },
    { 0x3FEA, "getkillstreakearneddialog" },
    { 0x3FEB, "getkillstreakearnedhint" },
    { 0x3FEC, "getkillstreakenemydialog" },
    { 0x3FED, "getkillstreakenemyusedialog" },
    { 0x3FEE, "getkillstreakfromchallenge" },
    { 0x3FEF, "getkillstreakhint" },
    { 0x3FF0, "getkillstreakicon" },
    { 0x3FF1, "getkillstreakindex" },
    { 0x3FF2, "getkillstreakinformenemy" },
    { 0x3FF3, "getkillstreakkills" },
    { 0x3FF4, "getkillstreakmodules" },
    { 0x3FF5, "getkillstreakname" },
    { 0x3FF6, "getkillstreakoverheadicon" },
    { 0x3FF7, "getkillstreakreference" },
    { 0x3FF8, "getkillstreakrownum" },
    { 0x3FF9, "getkillstreakscore" },
    { 0x3FFA, "getkillstreaksound" },
    { 0x3FFB, "getkillstreakunearnedicon" },
    { 0x3FFC, "getkillstreakweapon" },
    { 0x3FFD, "getlabel" },
    { 0x3FFE, "getlaserradius" },
    { 0x3FFF, "getlastlivingplayer" },
    { 0x4000, "getlastweapon" },
    { 0x4001, "getlerpfraction" },
    { 0x4002, "getlevelcompleted" },
    { 0x4003, "getlevelindex" },
    { 0x4004, "getlevelname" },
    { 0x4005, "getlevelskill" },
    { 0x4006, "getlevelveteranaward" },
    { 0x4007, "getlightshowbeameffect" },
    { 0x4008, "getlinkedvehiclenodes" },
    { 0x4009, "getlinks_array" },
    { 0x400A, "getlistofgoodspawnpoints" },
    { 0x400B, "getlivingplayers" },
    { 0x400C, "getloadout" },
    { 0x400D, "getlocation" },
    { 0x400E, "getloccalloutalias" },
    { 0x400F, "getlookattarget" },
    { 0x4010, "getlookpitch" },
    { 0x4011, "getlookyaw" },
    { 0x4012, "getloopeffectdelaydefault" },
    { 0x4013, "getlosingplayers" },
    { 0x4014, "getlowermessage" },
    { 0x4015, "getlowestavailableclientid" },
    { 0x4016, "getlowestpartdistance" },
    { 0x4017, "getlowestskill" },
    { 0x4018, "getmapname" },
    { 0x4019, "getmarksmanunlockattachment" },
    { 0x401A, "getmatchrulesspecialclass" },
    { 0x401B, "getmatchstarttimeutc" },
    { 0x401C, "getmaxaliveenemycount" },
    { 0x401D, "getmaxdirectionsandexcludedirfromapproachtype" },
    { 0x401E, "getmaxdogcount" },
    { 0x401F, "getmaxdronecount" },
    { 0x4020, "getmaxenemycount" },
    { 0x4021, "getmaxpickupsperround" },
    { 0x4022, "getmaxrounds" },
    { 0x4023, "getmaxstreakcost" },
    { 0x4024, "getmeleeanimstate" },
    { 0x4025, "getmidangle" },
    { 0x4026, "getminioncount" },
    { 0x4027, "getminutespassed" },
    { 0x4028, "getmissiondvarstring" },
    { 0x4029, "getmodel" },
    { 0x402A, "getmodifiedrotationangle" },
    { 0x402B, "getmodifier" },
    { 0x402C, "getmodulelineemp" },
    { 0x402D, "getmodulesforcrate" },
    { 0x402E, "getmostkilled" },
    { 0x402F, "getmostkilledby" },
    { 0x4030, "getmoveanim" },
    { 0x4031, "getmoveplaybackrate" },
    { 0x4032, "getmovestate" },
    { 0x4033, "getname" },
    { 0x4034, "getnamedally" },
    { 0x4035, "getnames" },
    { 0x4036, "getnearestflagpoint" },
    { 0x4037, "getnearestflagteam" },
    { 0x4038, "getnearestpathnode" },
    { 0x4039, "getnearestspawns" },
    { 0x403A, "getnearestzonepoint" },
    { 0x403B, "getnetquantizedangle" },
    { 0x403C, "getnewenemyreactionanim" },
    { 0x403D, "getnextflashanim" },
    { 0x403E, "getnextfootdown" },
    { 0x403F, "getnextgun" },
    { 0x4040, "getnextlandingtime" },
    { 0x4041, "getnextlevelindex" },
    { 0x4042, "getnextlifeid" },
    { 0x4043, "getnextnode" },
    { 0x4044, "getnextobjid" },
    { 0x4045, "getnextplayerinownerqueue" },
    { 0x4046, "getnextrelevantdialog" },
    { 0x4047, "getnextroundnumber" },
    { 0x4048, "getnextzone" },
    { 0x4049, "getnextzonefromqueue" },
    { 0x404A, "getnodearrayfunction" },
    { 0x404B, "getnodedirection" },
    { 0x404C, "getnodeforward" },
    { 0x404D, "getnodeforwardangles" },
    { 0x404E, "getnodeforwardyaw" },
    { 0x404F, "getnodefunction" },
    { 0x4050, "getnodeoffset" },
    { 0x4051, "getnodeorigin" },
    { 0x4052, "getnodetype" },
    { 0x4053, "getnodeyawtoenemy" },
    { 0x4054, "getnodeyawtoorigin" },
    { 0x4055, "getnormalanimtime" },
    { 0x4056, "getnormaldirectionvec" },
    { 0x4057, "getnumactiveagents" },
    { 0x4058, "getnumbraggingrights" },
    { 0x4059, "getnumownedactiveagents" },
    { 0x405A, "getnumownedactiveagentsbytype" },
    { 0x405B, "getnumplayers" },
    { 0x405C, "getnumtouchingexceptteam" },
    { 0x405D, "getobjectivehinttext" },
    { 0x405E, "getobjectivescoretext" },
    { 0x405F, "getobjectivetext" },
    { 0x4060, "getobjpointbyindex" },
    { 0x4061, "getobjpointbyname" },
    { 0x4062, "getoffvehiclefunc" },
    { 0x4063, "getoldslam" },
    { 0x4064, "getoneshoteffectdelaydefault" },
    { 0x4065, "getonpath" },
    { 0x4066, "getorbitallaserzheight" },
    { 0x4067, "getorientedmeleevictimtargetyaw" },
    { 0x4068, "getosptaginfo" },
    { 0x4069, "getotherriotshieldname" },
    { 0x406A, "getotherteam" },
    { 0x406B, "getout" },
    { 0x406C, "getout_combat" },
    { 0x406D, "getout_delete" },
    { 0x406E, "getout_rigspawn" },
    { 0x406F, "getout_secondary" },
    { 0x4070, "getout_secondary_tag" },
    { 0x4071, "getout_timed_anim" },
    { 0x4072, "getoutloopsnd" },
    { 0x4073, "getoutrig_abort" },
    { 0x4074, "getoutrig_abort_while_deploying" },
    { 0x4075, "getoutrig_disable_abort_notify_after_riders_out" },
    { 0x4076, "getoutrig_model" },
    { 0x4077, "getoutrig_model_idle" },
    { 0x4078, "getoutsnd" },
    { 0x4079, "getoutstance" },
    { 0x407A, "getowneddomflags" },
    { 0x407B, "getownerteam" },
    { 0x407C, "getpainanim" },
    { 0x407D, "getparent" },
    { 0x407E, "getpartandstateindex" },
    { 0x407F, "getpatharray" },
    { 0x4080, "getperkcrateicon" },
    { 0x4081, "getperkforcrate" },
    { 0x4082, "getperlinovertime" },
    { 0x4083, "getpermutation" },
    { 0x4084, "getpersstat" },
    { 0x4085, "getpitchtoenemy" },
    { 0x4086, "getpitchtoorgfromorg" },
    { 0x4087, "getpitchtoshootentorpos" },
    { 0x4088, "getpitchtospot" },
    { 0x4089, "getplaneflyheight" },
    { 0x408A, "getplant" },
    { 0x408B, "getplayerclaymores" },
    { 0x408C, "getplayerdamagescale" },
    { 0x408D, "getplayereyeheight" },
    { 0x408E, "getplayerforguid" },
    { 0x408F, "getplayerfromclientnum" },
    { 0x4090, "getplayerhelispeed" },
    { 0x4091, "getplayersonteam" },
    { 0x4092, "getplayerstat" },
    { 0x4093, "getplayerstattime" },
    { 0x4094, "getplayertraceheight" },
    { 0x4095, "getplayerweaponhorde" },
    { 0x4096, "getpotentiallivingplayers" },
    { 0x4097, "getpracticeroundclass" },
    { 0x4098, "getpracticeroundcostume" },
    { 0x4099, "getpredictedaimyawtoshootentorpos" },
    { 0x409A, "getpredictedpathmidpoint" },
    { 0x409B, "getpredictedyawtoenemy" },
    { 0x409C, "getprefereddompoints" },
    { 0x409D, "getpreferredweapon" },
    { 0x409E, "getprestigelevel" },
    { 0x409F, "getpronedeathanim" },
    { 0x40A0, "getpronepainanim" },
    { 0x40A1, "getproperty" },
    { 0x40A2, "getqacalloutalias" },
    { 0x40A3, "getquadrant" },
    { 0x40A4, "getqueueevents" },
    { 0x40A5, "getradialanglefroment" },
    { 0x40A6, "getrandomanimentry" },
    { 0x40A7, "getrandomcovermode" },
    { 0x40A8, "getrandomcratetype" },
    { 0x40A9, "getrandomintfromseed" },
    { 0x40AA, "getrandomspectatorspawnpoint" },
    { 0x40AB, "getrandomunblockedanim" },
    { 0x40AC, "getrank" },
    { 0x40AD, "getrankforxp" },
    { 0x40AE, "getrankfromname" },
    { 0x40AF, "getrankinfofull" },
    { 0x40B0, "getrankinfolevel" },
    { 0x40B1, "getrankinfomaxxp" },
    { 0x40B2, "getrankinfominxp" },
    { 0x40B3, "getrankinfoxpamt" },
    { 0x40B4, "getrankxp" },
    { 0x40B5, "getratio" },
    { 0x40B6, "getredeemedxp" },
    { 0x40B7, "getrelativeangles" },
    { 0x40B8, "getrelativeteam" },
    { 0x40B9, "getremainingburstdelaytime" },
    { 0x40BA, "getremotename" },
    { 0x40BB, "getresponder" },
    { 0x40BC, "getroundaccuracy" },
    { 0x40BD, "getroundintermissiontimer" },
    { 0x40BE, "getroundswon" },
    { 0x40BF, "getrownumber" },
    { 0x40C0, "getrunanim" },
    { 0x40C1, "getrunningforwarddeathanim" },
    { 0x40C2, "getrunningforwardpainanim" },
    { 0x40C3, "getsafeanimmovedeltapercentage" },
    { 0x40C4, "getscoreinfovalue" },
    { 0x40C5, "getscorelimit" },
    { 0x40C6, "getscoreperminute" },
    { 0x40C7, "getscoreremaining" },
    { 0x40C8, "getsecondaryperkforcrate" },
    { 0x40C9, "getsecondaryperkhintfromperkref" },
    { 0x40CA, "getsecondspassed" },
    { 0x40CB, "getshootfrompos" },
    { 0x40CC, "getshootpospitch" },
    { 0x40CD, "getsingleairstrikedanger" },
    { 0x40CE, "getslotnumber" },
    { 0x40CF, "getsmokegrenadecount" },
    { 0x40D0, "getsmoothrandomvector" },
    { 0x40D1, "getsniperburstdelaytime" },
    { 0x40D2, "getsolevelcompleted" },
    { 0x40D3, "getspawninwateroffset" },
    { 0x40D4, "getspawnorigin" },
    { 0x40D5, "getspawnpoint" },
    { 0x40D6, "getspawnpoint_awayfromenemies" },
    { 0x40D7, "getspawnpoint_domination" },
    { 0x40D8, "getspawnpoint_freeforall" },
    { 0x40D9, "getspawnpoint_hardpoint" },
    { 0x40DA, "getspawnpoint_nearteam" },
    { 0x40DB, "getspawnpoint_random" },
    { 0x40DC, "getspawnpoint_safeguard" },
    { 0x40DD, "getspawnpoint_searchandrescue" },
    { 0x40DE, "getspawnpoint_startspawn" },
    { 0x40DF, "getspawnpoint_twar" },
    { 0x40E0, "getspawnpointarray" },
    { 0x40E1, "getspawnteam" },
    { 0x40E2, "getspeakers" },
    { 0x40E3, "getspherebounds" },
    { 0x40E4, "getsplittimes" },
    { 0x40E5, "getsplittimesside" },
    { 0x40E6, "getsprintanim" },
    { 0x40E7, "getsquadteam" },
    { 0x40E8, "getstairstransitionanim" },
    { 0x40E9, "getstance_func" },
    { 0x40EA, "getstancecenter" },
    { 0x40EB, "getstanddeathanim" },
    { 0x40EC, "getstandpainanim" },
    { 0x40ED, "getstandpistoldeathanim" },
    { 0x40EE, "getstandpistolpainanim" },
    { 0x40EF, "getstartpositionabove" },
    { 0x40F0, "getstat_easy" },
    { 0x40F1, "getstat_hardened" },
    { 0x40F2, "getstat_intel" },
    { 0x40F3, "getstat_progression" },
    { 0x40F4, "getstat_regular" },
    { 0x40F5, "getstat_veteran" },
    { 0x40F6, "getstingertargetposfunc" },
    { 0x40F7, "getstopanimstate" },
    { 0x40F8, "getstopdata" },
    { 0x40F9, "getstreakcost" },
    { 0x40FA, "getstreakforcrate" },
    { 0x40FB, "getstreakmodulebasekillstreak" },
    { 0x40FC, "getstreakmodulecost" },
    { 0x40FD, "getstrongbulletdamagedeathanim" },
    { 0x40FE, "getstruct" },
    { 0x40FF, "getstruct_delete" },
    { 0x4100, "getstructarray" },
    { 0x4101, "getstructarray_delete" },
    { 0x4102, "getsupportbarsize" },
    { 0x4103, "getswimanim" },
    { 0x4104, "gettagangles_c" },
    { 0x4105, "gettagforpos" },
    { 0x4106, "gettagorigin_rotatecompensation" },
    { 0x4107, "gettakennodes" },
    { 0x4108, "gettargetangleoffset" },
    { 0x4109, "gettargetentpos" },
    { 0x410A, "gettargetlist" },
    { 0x410B, "gettargettingai" },
    { 0x410C, "gettargettriggerhit" },
    { 0x410D, "getteambalance" },
    { 0x410E, "getteamcolor" },
    { 0x410F, "getteamcratemodel" },
    { 0x4110, "getteamdeploymodel" },
    { 0x4111, "getteamdompoints" },
    { 0x4112, "getteameliminatedstring" },
    { 0x4113, "getteamflagcarrymodel" },
    { 0x4114, "getteamflagcount" },
    { 0x4115, "getteamflagfx" },
    { 0x4116, "getteamflagicon" },
    { 0x4117, "getteamflagmodel" },
    { 0x4118, "getteamforfeitedstring" },
    { 0x4119, "getteamheadicon" },
    { 0x411A, "getteamhudicon" },
    { 0x411B, "getteamicon" },
    { 0x411C, "getteamindex" },
    { 0x411D, "getteammatesoutofcombat" },
    { 0x411E, "getteamname" },
    { 0x411F, "getteamshortname" },
    { 0x4120, "getteamsize" },
    { 0x4121, "getteamspawnmusic" },
    { 0x4122, "getteamspawnpoints" },
    { 0x4123, "getteamvoiceprefix" },
    { 0x4124, "getteamwinmusic" },
    { 0x4125, "getthing" },
    { 0x4126, "getthingarray" },
    { 0x4127, "getthreatinfantrycallouttype" },
    { 0x4128, "getthreatsovertime" },
    { 0x4129, "getthreatstyle" },
    { 0x412A, "gettierfromtable" },
    { 0x412B, "gettimeallowancebasedondifficulty" },
    { 0x412C, "gettimedeciseconds" },
    { 0x412D, "gettimeinterval" },
    { 0x412E, "gettimelimit" },
    { 0x412F, "gettimepassed" },
    { 0x4130, "gettimepasseddeciseconds" },
    { 0x4131, "gettimepasseddecisecondsincludingrounds" },
    { 0x4132, "gettimepassedincludingrounds" },
    { 0x4133, "gettimepassedpercentage" },
    { 0x4134, "gettimeremaining" },
    { 0x4135, "gettimeremainingincludingrounds" },
    { 0x4136, "gettimesincedompointcapture" },
    { 0x4137, "gettimetoreinforcementfortypems" },
    { 0x4138, "gettotalpercentcompletesp" },
    { 0x4139, "gettotalscore" },
    { 0x413A, "gettotalxp" },
    { 0x413B, "gettothechoppa" },
    { 0x413C, "gettouchingents" },
    { 0x413D, "gettranssplittime" },
    { 0x413E, "gettruenodeangles" },
//  { 0x413F, "" },
//  { 0x4140, "" },
//  { 0x4141, "" },
    { 0x4142, "gettweakabledvar" },
    { 0x4143, "gettweakabledvarvalue" },
    { 0x4144, "gettweakablelastvalue" },
    { 0x4145, "gettweakablevalue" },
    { 0x4146, "getuniqueflagnameindex" },
    { 0x4147, "getuniqueid" },
    { 0x4148, "getuniquestreakpromptid" },
    { 0x4149, "getunownedflagneareststart" },
    { 0x414A, "getunpausedtimepassed" },
    { 0x414B, "getupdatedattackpos" },
    { 0x414C, "getupdateteams" },
    { 0x414D, "getupifprone" },
    { 0x414E, "getvalidlocation" },
    { 0x414F, "getvalidpointtopointmovelocation" },
    { 0x4150, "getvalidspawnpathnodenearplayer" },
    { 0x4151, "getvalidspawns" },
    { 0x4152, "getvalidtargetssorted" },
    { 0x4153, "getvalueinrange" },
    { 0x4154, "getvectorarrayaverage" },
    { 0x4155, "getvectorrightangle" },
    { 0x4156, "getvehiclearray" },
    { 0x4157, "getvehiclenodepreviousforstartpath" },
    { 0x4158, "getvehiclespawner" },
    { 0x4159, "getvehiclespawnerarray" },
    { 0x415A, "getvelocity_func" },
    { 0x415B, "getviewmodelrotation" },
    { 0x415C, "getviewmodelstrafeoffset" },
    { 0x415D, "getwaitingbattlebuddy" },
    { 0x415E, "getwalkanim" },
    { 0x415F, "getwarmupeffect" },
    { 0x4160, "getwarmuplightshoweffect" },
    { 0x4161, "getwatcheddvar" },
    { 0x4162, "getwaterline" },
    { 0x4163, "getweaponattachmentarrayfromstats" },
    { 0x4164, "getweaponattachmentfromchallenge" },
    { 0x4165, "getweaponattachmentfromstats" },
    { 0x4166, "getweaponattachmentsbasenames" },
    { 0x4167, "getweaponbasedgrenadecount" },
    { 0x4168, "getweaponbasedsmokegrenadecount" },
    { 0x4169, "getweaponchoice" },
    { 0x416A, "getweaponclass" },
    { 0x416B, "getweaponforpos" },
    { 0x416C, "getweaponfromchallenge" },
    { 0x416D, "getweaponfxheight" },
    { 0x416E, "getweaponheaviestvalue" },
    { 0x416F, "getweaponnametokens" },
    { 0x4170, "getweaponweight" },
    { 0x4171, "getweightedchanceroll" },
    { 0x4172, "getwinningteam" },
    { 0x4173, "getxpscale" },
    { 0x4174, "getyaw" },
    { 0x4175, "getyaw2d" },
    { 0x4176, "getyawangles" },
    { 0x4177, "getyawfromorigin" },
    { 0x4178, "getyawtoenemy" },
    { 0x4179, "getyawtoorigin" },
    { 0x417A, "getyawtospot" },
    { 0x417B, "getyawtotag" },
    { 0x417C, "getzonearray" },
    { 0x417D, "gg_boost_begin" },
    { 0x417E, "gg_boost_end" },
    { 0x417F, "gg_bridge_shake_left" },
    { 0x4180, "gg_bridge_shake_right" },
    { 0x4181, "gg_bridge_snap_explosion" },
    { 0x4182, "gg_brk_boost_begin" },
    { 0x4183, "gg_brk_boost_end" },
    { 0x4184, "gg_bus_explode_death" },
    { 0x4185, "gg_drone_cable_explosions" },
    { 0x4186, "gg_drone_explosions" },
    { 0x4187, "gg_player_hit_windshield" },
    { 0x4188, "gg_slomo_end" },
    { 0x4189, "gg_slomo_start" },
    { 0x418A, "gg_start_bridge_collapse" },
    { 0x418B, "gg_start_bus_sliding" },
    { 0x418C, "gheight" },
    { 0x418D, "ghetto_tag_create" },
    { 0x418E, "ghillie_leaves" },
    { 0x418F, "gid_dragged_away" },
    { 0x4190, "gid_fall_down" },
    { 0x4191, "gid_hand_on_knox" },
    { 0x4192, "gid_kneel_down" },
    { 0x4193, "gid_release_plr_mech_suit" },
    { 0x4194, "gid_stand_and_drag" },
    { 0x4195, "gideon" },
    { 0x4196, "gideon_anim_set_manager" },
    { 0x4197, "gideon_arm_scan" },
    { 0x4198, "gideon_boost_jump" },
    { 0x4199, "gideon_bubble_trail" },
    { 0x419A, "gideon_bubble_trail_cg" },
    { 0x419B, "gideon_bubble_trails" },
    { 0x419C, "gideon_can_exit_range" },
    { 0x419D, "gideon_canal_bottom" },
    { 0x419E, "gideon_cannot_exit_range" },
    { 0x419F, "gideon_change_mask" },
    { 0x41A0, "gideon_change_outfit" },
    { 0x41A1, "gideon_door_mech_kick" },
    { 0x41A2, "gideon_exfil_boost" },
    { 0x41A3, "gideon_exfil_foley1" },
    { 0x41A4, "gideon_exfil_foley2" },
    { 0x41A5, "gideon_exfil_foley3" },
    { 0x41A6, "gideon_exfil_foley4" },
    { 0x41A7, "gideon_goto_canal_breach" },
    { 0x41A8, "gideon_gun_prep" },
    { 0x41A9, "gideon_helo_release" },
    { 0x41AA, "gideon_jump_to_heli" },
    { 0x41AB, "gideon_keep_up_fail_trigger" },
    { 0x41AC, "gideon_knife_takedown_unmute_foley" },
    { 0x41AD, "gideon_look_off" },
    { 0x41AE, "gideon_mech_footstep_splashes" },
    { 0x41AF, "gideon_mech_light" },
    { 0x41B0, "gideon_mech_water_drips" },
    { 0x41B1, "gideon_outfit_manager" },
    { 0x41B2, "gideon_play_scripted_anim_when_reaching_goal" },
    { 0x41B3, "gideon_pod" },
    { 0x41B4, "gideon_slide_dust" },
    { 0x41B5, "gideon_swim_stroke_up" },
    { 0x41B6, "gideon_turntable_demo" },
    { 0x41B7, "gideon_walking_down_stairs" },
    { 0x41B8, "gideon_wall_cloak_on" },
    { 0x41B9, "gideon_water_splash" },
    { 0x41BA, "gideon_water_splash_cg" },
    { 0x41BB, "give_boost_jump" },
    { 0x41BC, "give_capture_credit" },
    { 0x41BD, "give_diveboat_weapons" },
    { 0x41BE, "give_door_shield_weapon" },
    { 0x41BF, "give_enemy_boost" },
    { 0x41C0, "give_exo_cloak" },
    { 0x41C1, "give_exo_health" },
    { 0x41C2, "give_exo_hover" },
    { 0x41C3, "give_exo_mute" },
    { 0x41C4, "give_exo_overclock" },
    { 0x41C5, "give_exo_ping" },
    { 0x41C6, "give_exo_repulsor" },
    { 0x41C7, "give_exo_shield" },
    { 0x41C8, "give_expensive_flashlight" },
    { 0x41C9, "give_hovertank_weapons" },
    { 0x41CA, "give_infinite_ammo" },
    { 0x41CB, "give_laser" },
    { 0x41CC, "give_laser_sights" },
    { 0x41CD, "give_loadout" },
    { 0x41CE, "give_night_vision" },
    { 0x41CF, "give_overdrive_battery" },
    { 0x41D0, "give_player_challenge_frag" },
    { 0x41D1, "give_player_challenge_headshot" },
    { 0x41D2, "give_player_challenge_kill" },
    { 0x41D3, "give_player_exo" },
    { 0x41D4, "give_player_flashlight" },
    { 0x41D5, "give_player_gun" },
    { 0x41D6, "give_player_just_hands" },
    { 0x41D7, "give_player_more_ammo" },
    { 0x41D8, "give_player_pdrone" },
    { 0x41D9, "give_player_smart_grenade_launcher" },
    { 0x41DA, "give_player_variable_grenade" },
    { 0x41DB, "give_point" },
    { 0x41DC, "give_regular_grenades" },
    { 0x41DD, "give_water_weapon" },
    { 0x41DE, "give_weapon_knife" },
    { 0x41DF, "giveability" },
    { 0x41E0, "giveachievement_wrapper" },
    { 0x41E1, "giveadrenaline" },
    { 0x41E2, "giveadrenalinedirect" },
    { 0x41E3, "giveandapplyloadout" },
    { 0x41E4, "giveaward" },
    { 0x41E5, "givebackcarepackage" },
    { 0x41E6, "giveblindeyeafterspawn" },
    { 0x41E7, "givecontrolback" },
    { 0x41E8, "givedefaultperks" },
    { 0x41E9, "giveflagcapturexp" },
    { 0x41EA, "giveflagneutralizexp" },
    { 0x41EB, "givegearformapsplayed" },
    { 0x41EC, "givegearformaxarmorproficiency" },
    { 0x41ED, "givegearformaxweaponproficiency" },
    { 0x41EE, "givegearforwavescompleted" },
    { 0x41EF, "givehordekillstreak" },
    { 0x41F0, "givejuggernaut" },
    { 0x41F1, "givekillstreak" },
    { 0x41F2, "givekillstreakweapon" },
    { 0x41F3, "givelastonteamwarning" },
    { 0x41F4, "giveloadout" },
    { 0x41F5, "givematchbonus" },
    { 0x41F6, "givenextgun" },
    { 0x41F7, "giveobject" },
    { 0x41F8, "giveoffhand" },
    { 0x41F9, "giveonemanarmyclass" },
    { 0x41FA, "giveownedkillstreakitem" },
    { 0x41FB, "giveperk" },
    { 0x41FC, "giveplaceable" },
    { 0x41FD, "giveplayerchallengekillpoint" },
    { 0x41FE, "giveplayerconroldelayed" },
    { 0x41FF, "giveplayerscore" },
    { 0x4200, "givepointsfordamage" },
    { 0x4201, "givepointsforevent" },
    { 0x4202, "giverankxp" },
    { 0x4203, "giverankxpafterwait" },
    { 0x4204, "givereinforcementoftype" },
    { 0x4205, "givescoreloss" },
    { 0x4206, "giveselectedkillstreakitem" },
    { 0x4207, "givesentry" },
    { 0x4208, "givesuperexo" },
    { 0x4209, "givesuperhealth" },
    { 0x420A, "givesuperpunch" },
    { 0x420B, "givesuperrepulse" },
    { 0x420C, "givesuperspeed" },
    { 0x420D, "givesuperstomp" },
    { 0x420E, "giveteamammorefill" },
    { 0x420F, "giveteamscoreforobjective" },
    { 0x4210, "giveteamscoreforobjectiveendofframe" },
    { 0x4211, "giveuponsuppressiontime" },
    { 0x4212, "giveuptime" },
    { 0x4213, "givexp" },
    { 0x4214, "givezonecapturexp" },
    { 0x4215, "glass_break" },
    { 0x4216, "glass_break_think" },
    { 0x4217, "glass_broken" },
    { 0x4218, "glass_door_01_exterior_lighting" },
    { 0x4219, "glass_door_01_interior_lighting" },
    { 0x421A, "glass_door_02_exterior_lighting" },
    { 0x421B, "glass_door_02_interior_lighting" },
    { 0x421C, "glass_door_03_exterior_lighting" },
    { 0x421D, "glass_door_03_interior_lighting" },
    { 0x421E, "glass_door_04_exterior_lighting" },
    { 0x421F, "glass_door_04_interior_lighting" },
    { 0x4220, "glass_id" },
    { 0x4221, "glauncher_icon" },
    { 0x4222, "glauncher_icon_fade_in" },
    { 0x4223, "glauncher_icon_fade_out" },
    { 0x4224, "glauncher_icon_trig" },
    { 0x4225, "glaunchericonthink" },
    { 0x4226, "glint_behavior" },
    { 0x4227, "global_callbacks" },
    { 0x4228, "global_damage_func" },
    { 0x4229, "global_damage_func_ads" },
    { 0x422A, "global_data" },
    { 0x422B, "global_dialogue_function_stack" },
    { 0x422C, "global_dialogue_internal" },
    { 0x422D, "global_dialogue_internal_play_dialogue" },
    { 0x422E, "global_dialogue_internal_play_radio" },
    { 0x422F, "global_empty_callback" },
    { 0x4230, "global_fx" },
    { 0x4231, "global_kill_func" },
    { 0x4232, "global_mix" },
    { 0x4233, "global_spawn_functions" },
    { 0x4234, "global_tables" },
    { 0x4235, "globalinstantmessagehandler" },
    { 0x4236, "globalthink" },
    { 0x4237, "globalusableents" },
    { 0x4238, "gloveon" },
    { 0x4239, "glow" },
    { 0x423A, "glow_model" },
    { 0x423B, "glowcolor_mult" },
    { 0x423C, "glowstickenemyuselistener" },
    { 0x423D, "glowsticksetupandwaitfordeath" },
    { 0x423E, "glowstickteamupdater" },
    { 0x423F, "glowstickuselistener" },
    { 0x4240, "go_path_by_targetname" },
    { 0x4241, "go_path_by_targetname_reverse" },
    { 0x4242, "go_to_boosters_off_and_first_frame" },
    { 0x4243, "go_to_hide" },
    { 0x4244, "go_to_node" },
    { 0x4245, "go_to_node_arrays" },
    { 0x4246, "go_to_node_set_goal_ent" },
    { 0x4247, "go_to_node_set_goal_node" },
    { 0x4248, "go_to_node_set_goal_pos" },
    { 0x4249, "go_to_node_using_funcs" },
    { 0x424A, "go_to_node_wait_for_player" },
    { 0x424B, "go_to_origin" },
    { 0x424C, "go_to_struct" },
    { 0x424D, "go_to_vol" },
    { 0x424E, "goal_and_interupt" },
    { 0x424F, "goal_mover" },
    { 0x4250, "goal_node" },
    { 0x4251, "goal_pos" },
    { 0x4252, "goal_position" },
    { 0x4253, "goal_radius" },
    { 0x4254, "goal_type" },
    { 0x4255, "goalpos_within_volume" },
    { 0x4256, "goals" },
    { 0x4257, "goalvolume" },
    { 0x4258, "goalvolumes" },
    { 0x4259, "goback_startfunc" },
    { 0x425A, "godmode" },
    { 0x425B, "godoff" },
    { 0x425C, "godon" },
    { 0x425D, "going_for_knife" },
    { 0x425E, "goingtoproneaim" },
    { 0x425F, "golaith_exit_distance_dot" },
    { 0x4260, "golfcourse_treadfx_override" },
    { 0x4261, "goliath" },
    { 0x4262, "goliath_bad_landing_volumes" },
    { 0x4263, "goliath_dialog" },
    { 0x4264, "goliath_disable_threat" },
    { 0x4265, "goliath_distance" },
    { 0x4266, "goliath_entry_ice" },
    { 0x4267, "goliath_explode_logic_timer" },
    { 0x4268, "goliath_fail" },
    { 0x4269, "goliath_handle_death" },
    { 0x426A, "goliath_land" },
    { 0x426B, "goliath_pass" },
    { 0x426C, "goliath_player_rumbles" },
    { 0x426D, "goliath_rocket_logic" },
    { 0x426E, "goliathandcarepackagevalid" },
    { 0x426F, "goliathandgoliathvalid" },
    { 0x4270, "goliathandplatformvalid" },
    { 0x4271, "goliathattachflag" },
    { 0x4272, "goliathbadlandingcheck" },
    { 0x4273, "goliathbootupsequence" },
    { 0x4274, "goliathdropbomb" },
    { 0x4275, "goliathdropflag" },
    { 0x4276, "goliaththink" },
    { 0x4277, "gondola_movement_loops" },
    { 0x4278, "gondolaanimation" },
    { 0x4279, "gonevo" },
    { 0x427A, "goodaccuracy" },
    { 0x427B, "goodenemy" },
    { 0x427C, "goodshootpos" },
    { 0x427D, "gopath" },
    { 0x427E, "gotinfectedevent" },
    { 0x427F, "goto_current_colorindex" },
    { 0x4280, "goto_goal" },
    { 0x4281, "goto_node" },
    { 0x4282, "goto_node_and_delete" },
    { 0x4283, "goto_squad_node" },
    { 0x4284, "gotocover" },
    { 0x4285, "gotonextspawn" },
    { 0x4286, "gotonextstartspawn" },
    { 0x4287, "gotonode" },
    { 0x4288, "gotonodeanddelete" },
    { 0x4289, "gotonodeandwait" },
    { 0x428A, "gotoprevspawn" },
    { 0x428B, "gotoprevstartspawn" },
    { 0x428C, "gototogoal" },
    { 0x428D, "gotovolume" },
    { 0x428E, "gotpullbacknotify" },
    { 0x428F, "gourney_stop" },
    { 0x4290, "gov_anims_ajani" },
    { 0x4291, "gov_anims_joker" },
    { 0x4292, "gov_bldg_driveup" },
    { 0x4293, "gov_building_ai_timed_shooting" },
    { 0x4294, "gov_building_ally_goto" },
    { 0x4295, "gov_building_delete_soft_clip" },
    { 0x4296, "gov_building_exo_climb_burke_anims" },
    { 0x4297, "gov_building_exo_climb_burke_climb" },
    { 0x4298, "gov_building_exo_climb_goto" },
    { 0x4299, "gov_building_exo_climb_in_position" },
    { 0x429A, "gov_building_exo_climb_position_counter" },
    { 0x429B, "gov_building_exo_climb_vo" },
    { 0x429C, "gov_building_explode_advance_guys" },
    { 0x429D, "gov_building_firefight_anim_explode" },
    { 0x429E, "gov_building_firefight_anim_wounded" },
    { 0x429F, "gov_building_firefight_change_pos" },
    { 0x42A0, "gov_building_firefight_driveup" },
    { 0x42A1, "gov_building_firefight_driveup_explode" },
    { 0x42A2, "gov_building_firefight_front_soldiers" },
    { 0x42A3, "gov_building_firefight_init_shooting" },
    { 0x42A4, "gov_building_firefight_kva" },
    { 0x42A5, "gov_building_firefight_removal" },
    { 0x42A6, "gov_building_firefight_roadblock" },
    { 0x42A7, "gov_building_firefight_setup" },
    { 0x42A8, "gov_building_firefight_turret_settings" },
    { 0x42A9, "gov_building_gren_guy" },
    { 0x42AA, "gov_building_mil_devstart_setup" },
    { 0x42AB, "gov_building_mute_device" },
    { 0x42AC, "gov_building_rear_removal" },
    { 0x42AD, "gov_fail_on_death" },
    { 0x42AE, "gov_firefight_detect_breach" },
    { 0x42AF, "gov_firefight_enemy_reload_anims" },
    { 0x42B0, "gov_hostage_approach" },
    { 0x42B1, "gov_hostage_approach_redirect" },
    { 0x42B2, "gov_hostage_breach_actor_anims_and_idle" },
    { 0x42B3, "gov_hostage_breach_actor_anims_straight_to_idle" },
    { 0x42B4, "gov_hostage_breach_anim_idler" },
    { 0x42B5, "gov_hostage_breach_anim_setup" },
    { 0x42B6, "gov_hostage_breach_fail_miss_trigger" },
    { 0x42B7, "gov_hostage_breach_fail_trigger" },
    { 0x42B8, "gov_hostage_breach_give_radio" },
    { 0x42B9, "gov_hostage_breach_in_pos" },
    { 0x42BA, "gov_hostage_breach_marker_setup" },
    { 0x42BB, "gov_hostage_breach_post_anim_setup" },
    { 0x42BC, "gov_hostage_breach_setup" },
    { 0x42BD, "gov_hostage_h_breach_doors" },
    { 0x42BE, "gov_hostage_player_scan" },
    { 0x42BF, "gov_kva_soldiers" },
    { 0x42C0, "gov_post_h_breach_joker_actions" },
    { 0x42C1, "gov_rear_setup" },
    { 0x42C2, "gov_rear_squad_roundabout_goto" },
    { 0x42C3, "gov_road_block_patrol_route" },
    { 0x42C4, "gov_roof_breach_anim_chunks" },
    { 0x42C5, "gov_roof_breach_anim_setup" },
    { 0x42C6, "gov_roof_breach_elim_guy" },
    { 0x42C7, "gov_roof_breach_elim_setting_off" },
    { 0x42C8, "gov_roof_breach_elim_setting_on" },
    { 0x42C9, "gov_roof_breach_enable_player_invul" },
    { 0x42CA, "gov_roof_breach_end_slomo" },
    { 0x42CB, "gov_roof_breach_enemy_react_anims" },
    { 0x42CC, "gov_roof_breach_kill_assignment" },
    { 0x42CD, "gov_roof_breach_marker_setup" },
    { 0x42CE, "gov_roof_breach_multi_kill" },
    { 0x42CF, "gov_roof_breach_prep_squad_anims" },
    { 0x42D0, "gov_roof_breach_roof_destruction" },
    { 0x42D1, "gov_roof_breach_sequence" },
    { 0x42D2, "gov_roof_breach_start_slowmo" },
    { 0x42D3, "gov_roof_breach_success_monitor" },
    { 0x42D4, "gov_roof_breach_to_hbreach_vo" },
    { 0x42D5, "gov_soldiers_front" },
    { 0x42D6, "gov_soldiers_veh" },
    { 0x42D7, "gov_tram_bridge_ally_goto" },
    { 0x42D8, "gov_transition_clean_up" },
    { 0x42D9, "gov_veh_spawners" },
    { 0x42DA, "goverment_building_exoclimb_listen" },
    { 0x42DB, "government_building" },
    { 0x42DC, "government_building_interior_dialogue" },
    { 0x42DD, "government_building_mag_exo_dialogue" },
    { 0x42DE, "government_building_mag_exo_dialogue_nag" },
    { 0x42DF, "government_building_rail_walk_dialogue" },
    { 0x42E0, "government_building_reveal_dialogue" },
    { 0x42E1, "government_building_roof_breach_dialogue" },
    { 0x42E2, "government_building_roof_breach_dialogue_nag" },
    { 0x42E3, "gp_hint_text" },
    { 0x42E4, "grab_doctor_loop" },
    { 0x42E5, "grab_hand" },
    { 0x42E6, "grab_lighting" },
    { 0x42E7, "grab_n_stab_body_fall_with_lfe" },
    { 0x42E8, "grab_n_stab_brick_impact_with_lfe_glass" },
    { 0x42E9, "grab_n_stab_brick_snap" },
    { 0x42EA, "grab_n_stab_foley1_grabs_vox1" },
    { 0x42EB, "grab_n_stab_foley2" },
    { 0x42EC, "grab_n_stab_kick_impact_vox2" },
    { 0x42ED, "grab_n_stab_knife1" },
    { 0x42EE, "grab_n_stab_knife2" },
    { 0x42EF, "grab_n_stab_knife3" },
    { 0x42F0, "grab_n_stab_knife4" },
    { 0x42F1, "grab_n_stab_knife5" },
    { 0x42F2, "grab_n_stab_vox3" },
    { 0x42F3, "grab_players_classes" },
    { 0x42F4, "grab_stinger" },
    { 0x42F5, "gracedisance" },
    { 0x42F6, "graceperiod" },
    { 0x42F7, "gradius" },
    { 0x42F8, "gradually_return_player_speed" },
    { 0x42F9, "grand_fianle_paper_blowing" },
    { 0x42FA, "grand_finale_ambientfx_atlas_logo" },
    { 0x42FB, "grand_finale_building_explosion_smk" },
    { 0x42FC, "grand_finale_building_window_explosion_roofhang" },
    { 0x42FD, "grand_finale_fire_pool_fx" },
    { 0x42FE, "grand_finale_fx" },
    { 0x42FF, "grand_finale_iron_head_skin_override" },
    { 0x4300, "grand_finale_rooftop_explode" },
    { 0x4301, "graph_position" },
    { 0x4302, "graphs" },
    { 0x4303, "grapple" },
    { 0x4304, "grapple_abort" },
    { 0x4305, "grapple_abort_monitor" },
    { 0x4306, "grapple_abort_trace_passed" },
    { 0x4307, "grapple_add_void_point" },
    { 0x4308, "grapple_after_land_anim" },
    { 0x4309, "grapple_ai_alive" },
    { 0x430A, "grapple_ai_death_play" },
    { 0x430B, "grapple_ai_prep_for_kill" },
    { 0x430C, "grapple_allies" },
    { 0x430D, "grapple_allies_movement" },
    { 0x430E, "grapple_anim_anim" },
    { 0x430F, "grapple_anim_length" },
    { 0x4310, "grapple_anim_lerp" },
    { 0x4311, "grapple_anim_tree" },
    { 0x4312, "grapple_animate" },
    { 0x4313, "grapple_attach_bolt" },
    { 0x4314, "grapple_autosave_grappling_check" },
    { 0x4315, "grapple_begin" },
    { 0x4316, "grapple_break_glass" },
    { 0x4317, "grapple_can_stand" },
    { 0x4318, "grapple_check_footing" },
    { 0x4319, "grapple_check_surface_type" },
    { 0x431A, "grapple_commit_reticles" },
    { 0x431B, "grapple_commit_status" },
    { 0x431C, "grapple_complete_player_move" },
    { 0x431D, "grapple_config" },
    { 0x431E, "grapple_death_handler_standard" },
    { 0x431F, "grapple_death_listener" },
    { 0x4320, "grapple_death_pull" },
    { 0x4321, "grapple_death_pull_event" },
    { 0x4322, "grapple_death_pull_event_sounds" },
    { 0x4323, "grapple_death_pull_rope_state" },
    { 0x4324, "grapple_death_pull_suffixes" },
    { 0x4325, "grapple_death_rig" },
    { 0x4326, "grapple_death_style" },
    { 0x4327, "grapple_death_styles" },
    { 0x4328, "grapple_death_valid_pull" },
    { 0x4329, "grapple_death_valid_pull_concealed" },
    { 0x432A, "grapple_death_valid_pull_concealed_obs" },
    { 0x432B, "grapple_death_valid_pull_obs" },
    { 0x432C, "grapple_death_valid_standard" },
    { 0x432D, "grapple_decelerate_move_to" },
    { 0x432E, "grapple_defaultscriptedbodymodel" },
    { 0x432F, "grapple_defaultviewhandsmodel" },
    { 0x4330, "grapple_delayed_hide" },
    { 0x4331, "grapple_delete_monitor" },
    { 0x4332, "grapple_disable_weapon" },
    { 0x4333, "grapple_disconnect" },
    { 0x4334, "grapple_dist_max_watcher" },
    { 0x4335, "grapple_enable_normal_mantle_hint" },
    { 0x4336, "grapple_enable_weapon" },
    { 0x4337, "grapple_enabled" },
    { 0x4338, "grapple_enabled_listener" },
    { 0x4339, "grapple_enabled_listener_flag" },
    { 0x433A, "grapple_end_anim" },
    { 0x433B, "grapple_end_ent" },
    { 0x433C, "grapple_end_events" },
    { 0x433D, "grapple_entity" },
    { 0x433E, "grapple_entity_style" },
    { 0x433F, "grapple_fire" },
    { 0x4340, "grapple_fire_finished" },
    { 0x4341, "grapple_fire_plr_sound_bagh" },
    { 0x4342, "grapple_fire_rope" },
    { 0x4343, "grapple_fire_rope_finish" },
    { 0x4344, "grapple_fire_rope_impact" },
    { 0x4345, "grapple_fire_rope_thread" },
    { 0x4346, "grapple_get_style" },
    { 0x4347, "grapple_give" },
    { 0x4348, "grapple_grappling_stealth_getinshadow" },
    { 0x4349, "grapple_grappling_stealth_getstance" },
    { 0x434A, "grapple_hint" },
    { 0x434B, "grapple_hint_display" },
    { 0x434C, "grapple_hint_hide_kill" },
    { 0x434D, "grapple_hint_hide_kill_pull" },
    { 0x434E, "grapple_hint_hide_tutorial" },
    { 0x434F, "grapple_hint_hide_unusable" },
    { 0x4350, "grapple_hints" },
    { 0x4351, "grapple_init" },
    { 0x4352, "grapple_init_anims_actors" },
    { 0x4353, "grapple_init_anims_player" },
    { 0x4354, "grapple_init_anims_props" },
    { 0x4355, "grapple_init_anims_weapon" },
    { 0x4356, "grapple_init_death_style" },
    { 0x4357, "grapple_init_death_styles" },
    { 0x4358, "grapple_init_magnets" },
    { 0x4359, "grapple_init_player" },
    { 0x435A, "grapple_initialized" },
    { 0x435B, "grapple_kill" },
    { 0x435C, "grapple_kill_count" },
    { 0x435D, "grapple_kills_increment" },
    { 0x435E, "grapple_land" },
    { 0x435F, "grapple_land_over" },
    { 0x4360, "grapple_landing_anim" },
    { 0x4361, "grapple_landing_landed" },
    { 0x4362, "grapple_landing_prep" },
    { 0x4363, "grapple_landing_sound" },
    { 0x4364, "grapple_landing_trans" },
    { 0x4365, "grapple_lerp_velocity_to_linked" },
    { 0x4366, "grapple_loop_viewmodel_anim" },
    { 0x4367, "grapple_magnet_actor_monitor" },
    { 0x4368, "grapple_magnet_evaluate" },
    { 0x4369, "grapple_magnet_origin" },
    { 0x436A, "grapple_magnet_register" },
    { 0x436B, "grapple_magnet_state" },
    { 0x436C, "grapple_magnet_state_basics" },
    { 0x436D, "grapple_magnet_trace_validate" },
    { 0x436E, "grapple_magnet_unregister" },
    { 0x436F, "grapple_magnet_unregister_on_death" },
    { 0x4370, "grapple_magnet_update" },
    { 0x4371, "grapple_magnet_validate_current" },
    { 0x4372, "grapple_magnet_validate_ground" },
    { 0x4373, "grapple_magnets" },
    { 0x4374, "grapple_magnets_dynamic" },
    { 0x4375, "grapple_main" },
    { 0x4376, "grapple_mantle_find_victim" },
    { 0x4377, "grapple_mantle_plr_sound_bagh" },
    { 0x4378, "grapple_mantle_victim" },
    { 0x4379, "grapple_mantle_victim_ignore_thread" },
    { 0x437A, "grapple_mantle_victim_rig_cleanup" },
    { 0x437B, "grapple_mech_no_save" },
    { 0x437C, "grapple_model_precache" },
    { 0x437D, "grapple_models_init_player" },
    { 0x437E, "grapple_motion_blur_disable" },
    { 0x437F, "grapple_motion_blur_enable" },
    { 0x4380, "grapple_move" },
    { 0x4381, "grapple_move_plr_sound_bagh" },
    { 0x4382, "grapple_move_time" },
    { 0x4383, "grapple_nags" },
    { 0x4384, "grapple_not_connected" },
    { 0x4385, "grapple_notify_ai_capsule" },
    { 0x4386, "grapple_notify_closest_ai" },
    { 0x4387, "grapple_notify_magnet" },
    { 0x4388, "grapple_notify_players_magnet_unregister" },
    { 0x4389, "grapple_origin" },
    { 0x438A, "grapple_precache" },
    { 0x438B, "grapple_projectile_listener" },
    { 0x438C, "grapple_pullout_l" },
    { 0x438D, "grapple_pullout_r" },
    { 0x438E, "grapple_quick_fire_listener" },
    { 0x438F, "grapple_quick_fire_switch_back" },
    { 0x4390, "grapple_quick_fire_wait_and_set" },
    { 0x4391, "grapple_ragdolled" },
    { 0x4392, "grapple_register_hint" },
    { 0x4393, "grapple_register_snd_messages" },
    { 0x4394, "grapple_rope_length_thread" },
    { 0x4395, "grapple_rope_pull_lerp" },
    { 0x4396, "grapple_rope_state" },
    { 0x4397, "grapple_set_grappling" },
    { 0x4398, "grapple_set_hint" },
    { 0x4399, "grapple_set_status" },
    { 0x439A, "grapple_setup_death_event_handlers" },
    { 0x439B, "grapple_setup_rope_attached" },
    { 0x439C, "grapple_setup_rope_attached_player" },
    { 0x439D, "grapple_setup_rope_fire" },
    { 0x439E, "grapple_shutdown" },
    { 0x439F, "grapple_shutdown_player" },
    { 0x43A0, "grapple_snd_death" },
    { 0x43A1, "grapple_snd_pain" },
    { 0x43A2, "grapple_special" },
    { 0x43A3, "grapple_special_hint" },
    { 0x43A4, "grapple_special_indicator_offset" },
    { 0x43A5, "grapple_special_land_hide_rope" },
    { 0x43A6, "grapple_special_landing_anims" },
    { 0x43A7, "grapple_special_no_abort" },
    { 0x43A8, "grapple_special_no_enable_exo" },
    { 0x43A9, "grapple_special_no_enable_weapon" },
    { 0x43AA, "grapple_stand_and_lock_stances" },
    { 0x43AB, "grapple_start" },
    { 0x43AC, "grapple_start_listener" },
    { 0x43AD, "grapple_status_text_show" },
    { 0x43AE, "grapple_surface_type" },
    { 0x43AF, "grapple_switch" },
    { 0x43B0, "grapple_sync_attach_rotation" },
    { 0x43B1, "grapple_take" },
    { 0x43B2, "grapple_take_weapon" },
    { 0x43B3, "grapple_target_ent" },
    { 0x43B4, "grapple_text_compare" },
    { 0x43B5, "grapple_to_position" },
    { 0x43B6, "grapple_trace_parms" },
    { 0x43B7, "grapple_trace_validate" },
    { 0x43B8, "grapple_trace_validate_mantle" },
    { 0x43B9, "grapple_travel" },
    { 0x43BA, "grapple_travel_time" },
    { 0x43BB, "grapple_traverse" },
    { 0x43BC, "grapple_traverse_cleanup" },
    { 0x43BD, "grapple_traverse_configs" },
    { 0x43BE, "grapple_traverse_init" },
    { 0x43BF, "grapple_unlock_stances" },
    { 0x43C0, "grapple_update_preview" },
    { 0x43C1, "grapple_update_preview_position" },
    { 0x43C2, "grapple_valid_magnet_angle" },
    { 0x43C3, "grapple_validate_magnets" },
    { 0x43C4, "grapple_velocity_monitor" },
    { 0x43C5, "grapple_victim_landanim" },
    { 0x43C6, "grapple_view_model_hands_hide_show" },
    { 0x43C7, "grapple_vo" },
    { 0x43C8, "grapple_void_points" },
    { 0x43C9, "grapple_wait_for_ads_timeout" },
    { 0x43CA, "grapple_weapon_anim" },
    { 0x43CB, "grapple_weapon_listener" },
    { 0x43CC, "grapple_with_weapon_infinite_ammo" },
    { 0x43CD, "grapple_with_weapon_start" },
    { 0x43CE, "grapple_with_weapon_travel" },
    { 0x43CF, "grapple_with_weapon_turnrates" },
    { 0x43D0, "grappled" },
    { 0x43D1, "gravity_arc" },
    { 0x43D2, "gravity_drop" },
    { 0x43D3, "gravity_point" },
    { 0x43D4, "grd_player_grab" },
    { 0x43D5, "grd_trunk_close" },
    { 0x43D6, "gre_cafe_intro_pt1_ilona" },
    { 0x43D7, "gre_cafe_intro_pt2_ilona" },
    { 0x43D8, "gre_hades_death_outro_hades" },
    { 0x43D9, "gre_hades_death_outro_ilona" },
    { 0x43DA, "greece_locations" },
    { 0x43DB, "green" },
    { 0x43DC, "greenband_drones" },
    { 0x43DD, "greenbandcustomospfunc" },
    { 0x43DE, "greencrazylightloop" },
    { 0x43DF, "greensmokeloop" },
    { 0x43E0, "grenade_1" },
    { 0x43E1, "grenade_2" },
    { 0x43E2, "grenade_3" },
    { 0x43E3, "grenade_ambush" },
    { 0x43E4, "grenade_array" },
    { 0x43E5, "grenade_cache" },
    { 0x43E6, "grenade_cache_index" },
    { 0x43E7, "grenade_cycle_next" },
    { 0x43E8, "grenade_death_hint" },
    { 0x43E9, "grenade_death_indicator_hud" },
    { 0x43EA, "grenade_dirt_on_screen" },
    { 0x43EB, "grenade_display_time_remaining" },
    { 0x43EC, "grenade_earthquake" },
    { 0x43ED, "grenade_id" },
    { 0x43EE, "grenade_indicator_fx" },
    { 0x43EF, "grenade_launcher_vo" },
    { 0x43F0, "grenade_range_container" },
    { 0x43F1, "grenade_range_drone_death_detect" },
    { 0x43F2, "grenade_range_drone_think" },
    { 0x43F3, "grenade_range_enemy_think" },
    { 0x43F4, "grenade_range_use_triggers" },
    { 0x43F5, "grenade_target_lifetime" },
    { 0x43F6, "grenade_target_movement_manager" },
    { 0x43F7, "grenade_target_reset_manager" },
    { 0x43F8, "grenade_tracking" },
    { 0x43F9, "grenade_ui_off" },
    { 0x43FA, "grenade_ui_on" },
    { 0x43FB, "grenadeammo_prebreach" },
    { 0x43FC, "grenadeawarenessold" },
    { 0x43FD, "grenadecleanup" },
    { 0x43FE, "grenadecooldownelapsed" },
    { 0x43FF, "grenadecowerfunction" },
    { 0x4400, "grenadecyclehint" },
    { 0x4401, "grenadedest" },
    { 0x4402, "grenadeexplosionfx" },
    { 0x4403, "grenadegraceperiod" },
    { 0x4404, "grenadehidden" },
    { 0x4405, "grenadelandednearplayer" },
    { 0x4406, "grenadeline" },
    { 0x4407, "grenadeorigin" },
    { 0x4408, "grenadeproximitytracking" },
    { 0x4409, "grenaderangeleaderboard" },
    { 0x440A, "grenades" },
    { 0x440B, "grenadeshielded" },
    { 0x440C, "grenadetargetkills" },
    { 0x440D, "grenadethrowanims" },
    { 0x440E, "grenadethrowoffsets" },
    { 0x440F, "grenadethrowpose" },
    { 0x4410, "grenadetimers" },
    { 0x4411, "grenadetracking" },
    { 0x4412, "grey_out_player" },
    { 0x4413, "ground_origin" },
    { 0x4414, "ground_pos" },
    { 0x4415, "ground_ref" },
    { 0x4416, "ground_ref_ent" },
    { 0x4417, "ground_target" },
    { 0x4418, "ground_zero_alias_" },
    { 0x4419, "ground_zero_dist_threshold_" },
    { 0x441A, "groundpos" },
    { 0x441B, "groundslamcrushdeathfunction" },
    { 0x441C, "groundtoairevent" },
    { 0x441D, "group" },
    { 0x441E, "group_add_to_global_list" },
    { 0x441F, "group_center" },
    { 0x4420, "group_check_deaths" },
    { 0x4421, "group_create" },
    { 0x4422, "group_fastwalk_off" },
    { 0x4423, "group_fastwalk_on" },
    { 0x4424, "group_flag_clear" },
    { 0x4425, "group_flag_init" },
    { 0x4426, "group_flag_set" },
    { 0x4427, "group_free_combat" },
    { 0x4428, "group_get_ai_in_group" },
    { 0x4429, "group_get_flagname" },
    { 0x442A, "group_get_flagname_from_group" },
    { 0x442B, "group_initialize_formation" },
    { 0x442C, "group_left_corner" },
    { 0x442D, "group_light" },
    { 0x442E, "group_lock_angles" },
    { 0x442F, "group_map" },
    { 0x4430, "group_move" },
    { 0x4431, "group_move_mode" },
    { 0x4432, "group_patrol_wakeup" },
    { 0x4433, "group_resort_on_deaths" },
    { 0x4434, "group_return_ai_with_flag_set" },
    { 0x4435, "group_return_groups_with_flag_set" },
    { 0x4436, "group_run" },
    { 0x4437, "group_sort_by_closest_match" },
    { 0x4438, "group_sprint_off" },
    { 0x4439, "group_sprint_on" },
    { 0x443A, "group_under_construction" },
    { 0x443B, "group_unlock_angles" },
    { 0x443C, "group_wait_group_spawned" },
    { 0x443D, "group_wait_seek_player" },
    { 0x443E, "groupdevider" },
    { 0x443F, "groupedanim_pos" },
    { 0x4440, "groupname" },
    { 0x4441, "groups" },
    { 0x4442, "groupwarp" },
    { 0x4443, "growling" },
    { 0x4444, "gs" },
    { 0x4445, "guard_house_exit_door_clip" },
    { 0x4446, "guard_house_exit_light_02" },
    { 0x4447, "guard_house_light_exit_light" },
    { 0x4448, "guard_oppression_event_ents" },
    { 0x4449, "guard_the_gate" },
    { 0x444A, "guarddustdrag" },
    { 0x444B, "guardhouse_door" },
    { 0x444C, "guardhouse_door_waits" },
    { 0x444D, "guardhouse_grapple_timer" },
    { 0x444E, "guardian" },
    { 0x444F, "guards_at_market_checkpoint_array" },
    { 0x4450, "guest_house_vo" },
    { 0x4451, "guesthouse_enemies" },
    { 0x4452, "guesthouse_spawner_setup" },
    { 0x4453, "guid" },
    { 0x4454, "guide" },
    { 0x4455, "guide_anim_scene_fob_meet" },
    { 0x4456, "guidgen" },
    { 0x4457, "gun" },
    { 0x4458, "gun_animation" },
    { 0x4459, "gun_curgun" },
    { 0x445A, "gun_flashlight" },
    { 0x445B, "gun_flashlight_off" },
    { 0x445C, "gun_guns" },
    { 0x445D, "gun_hint" },
    { 0x445E, "gun_leave_behind" },
    { 0x445F, "gun_loadout" },
    { 0x4460, "gun_lock_sounds" },
    { 0x4461, "gun_on_ground" },
    { 0x4462, "gun_pickup_left" },
    { 0x4463, "gun_pickup_right" },
    { 0x4464, "gun_recall" },
    { 0x4465, "gun_remove" },
    { 0x4466, "gun_sound" },
    { 0x4467, "gun_state" },
    { 0x4468, "gun_struct" },
    { 0x4469, "gun_targ" },
    { 0x446A, "gun_threat" },
    { 0x446B, "gun_up_for_reload" },
    { 0x446C, "gun_vector" },
    { 0x446D, "gunfireloopfx" },
    { 0x446E, "gunfireloopfxthread" },
    { 0x446F, "gunfireloopfxvec" },
    { 0x4470, "gunfireloopfxvecthread" },
    { 0x4471, "gungameclass" },
    { 0x4472, "gungamegunindex" },
    { 0x4473, "gungameprevgunindex" },
    { 0x4474, "gunhand" },
    { 0x4475, "gunlist" },
    { 0x4476, "gunner" },
    { 0x4477, "gunner_pain_init" },
    { 0x4478, "gunner_pain_reset" },
    { 0x4479, "gunner_think" },
    { 0x447A, "gunner_turning_anims" },
    { 0x447B, "gunnerweapon" },
    { 0x447C, "guns_complete_cooldown_time" },
    { 0x447D, "guns_fire_time" },
    { 0x447E, "guns_last_fire_time" },
    { 0x447F, "guns_max_fire_time" },
    { 0x4480, "guy_1" },
    { 0x4481, "guy_1_takedown_01_dialogue" },
    { 0x4482, "guy_2" },
    { 0x4483, "guy_approach_mobile_turret" },
    { 0x4484, "guy_basement_flashlight_monitor" },
    { 0x4485, "guy_becomes_real_ai" },
    { 0x4486, "guy_blowup" },
    { 0x4487, "guy_can_jump" },
    { 0x4488, "guy_cig_manager" },
    { 0x4489, "guy_cleanup_vehiclevars" },
    { 0x448A, "guy_death" },
    { 0x448B, "guy_death_inside_warbird" },
    { 0x448C, "guy_deathhandle" },
    { 0x448D, "guy_deathimate_me" },
    { 0x448E, "guy_disassociate_internal" },
    { 0x448F, "guy_distance_checker" },
    { 0x4490, "guy_duck" },
    { 0x4491, "guy_duck_idle" },
    { 0x4492, "guy_duck_once" },
    { 0x4493, "guy_duck_once_check" },
    { 0x4494, "guy_duck_out" },
    { 0x4495, "guy_enter" },
    { 0x4496, "guy_enter_vehicle" },
    { 0x4497, "guy_exit_missile_explode_room" },
    { 0x4498, "guy_facing_player_intro" },
    { 0x4499, "guy_flashlight_basement_switch" },
    { 0x449A, "guy_get_in_mobile_turret" },
    { 0x449B, "guy_gets_on_turret" },
    { 0x449C, "guy_goes_directly_to_turret" },
    { 0x449D, "guy_handle" },
    { 0x449E, "guy_idle" },
    { 0x449F, "guy_idle_alert" },
    { 0x44A0, "guy_idle_alert_check" },
    { 0x44A1, "guy_idle_alert_to_casual" },
    { 0x44A2, "guy_idle_alert_to_casual_check" },
    { 0x44A3, "guy_jump_landing_puff" },
    { 0x44A4, "guy_jump_to_breach_stackup_cormack" },
    { 0x44A5, "guy_jump_to_breach_stackup_jackson" },
    { 0x44A6, "guy_jump_to_breach_stackup_will" },
    { 0x44A7, "guy_man_turret" },
    { 0x44A8, "guy_outside_school" },
    { 0x44A9, "guy_patrol_takedown_02" },
    { 0x44AA, "guy_patrol_takedown_02_alert_check" },
    { 0x44AB, "guy_pre_unload" },
    { 0x44AC, "guy_pre_unload_check" },
    { 0x44AD, "guy_reaction" },
    { 0x44AE, "guy_resets_goalpos" },
    { 0x44AF, "guy_runtovehicle" },
    { 0x44B0, "guy_runtovehicle_load" },
    { 0x44B1, "guy_runtovehicle_loaded" },
    { 0x44B2, "guy_should_man_turret" },
    { 0x44B3, "guy_spawns_and_gets_in_vehicle" },
    { 0x44B4, "guy_stand_attack" },
    { 0x44B5, "guy_stand_down" },
    { 0x44B6, "guy_toss_grenade" },
    { 0x44B7, "guy_tracking_player" },
    { 0x44B8, "guy_turn_hardleft" },
    { 0x44B9, "guy_turn_hardright" },
    { 0x44BA, "guy_turn_left" },
    { 0x44BB, "guy_turn_left_check" },
    { 0x44BC, "guy_turn_right" },
    { 0x44BD, "guy_turn_right_check" },
    { 0x44BE, "guy_turret_fire" },
    { 0x44BF, "guy_turret_turnleft" },
    { 0x44C0, "guy_turret_turnright" },
    { 0x44C1, "guy_unlink_on_death" },
    { 0x44C2, "guy_unload" },
    { 0x44C3, "guy_unload_custom" },
    { 0x44C4, "guy_unload_que" },
    { 0x44C5, "guy_unload_watcher" },
    { 0x44C6, "guy_vehicle_anim_simple" },
    { 0x44C7, "guy_vehicle_death" },
    { 0x44C8, "guy_weave" },
    { 0x44C9, "guy_weave_check" },
    { 0x44CA, "guy1_reach_wait" },
    { 0x44CB, "guy1_sentinel_kva_reveal" },
    { 0x44CC, "guy2_reach_wait" },
    { 0x44CD, "guy2_sentinel_kva_reveal" },
    { 0x44CE, "guy3_sentinel_kva_reveal" },
    { 0x44CF, "guyextrabloodnotetrack" },
    { 0x44D0, "guyragdollnotetrack" },
    { 0x44D1, "guys" },
    { 0x44D2, "guys_down_elevator" },
    { 0x44D3, "guys_to_die_before_next_health_drop" },
    { 0x44D4, "guys_to_wait" },
    { 0x44D5, "guytruckbloodnotetrack" },
    { 0x44D6, "h_breach_blockers_delete" },
    { 0x44D7, "h_breach_bullet_decals" },
    { 0x44D8, "h_breach_bullet_spawn_decal" },
    { 0x44D9, "h_breach_doors" },
    { 0x44DA, "h_breach_exo_kick" },
    { 0x44DB, "h_breach_hostile_elim" },
    { 0x44DC, "h_breach_multi_sync_kill_player_god" },
    { 0x44DD, "h_breach_multi_sync_kill_shooter" },
    { 0x44DE, "h_breach_multi_sync_kills" },
    { 0x44DF, "h_breach_multi_sync_kills_timeout" },
    { 0x44E0, "h_breach_timer" },
    { 0x44E1, "hack_destroy_heli_at_end_progression" },
    { 0x44E2, "hack_device" },
    { 0x44E3, "hack_device_setup" },
    { 0x44E4, "hack_fake_loop_because_you_cant_play_looping_vm_anims" },
    { 0x44E5, "hack_fix_lagos_flank_alley_camera_pop" },
    { 0x44E6, "hack_lighttweaks_enable" },
    { 0x44E7, "hack_security_begin" },
    { 0x44E8, "hack_security_main" },
    { 0x44E9, "hack_security_start" },
    { 0x44EA, "hack_security_vo" },
    { 0x44EB, "hack_start" },
    { 0x44EC, "hackagentangles" },
    { 0x44ED, "hackenablevisiontweaks" },
    { 0x44EE, "hacky_get_delta_xrot" },
    { 0x44EF, "hacky_get_delta_yrot" },
    { 0x44F0, "hades_end_mx" },
    { 0x44F1, "hades_explosion_slowmo_end" },
    { 0x44F2, "hades_explosion_slowmo_start" },
    { 0x44F3, "hades_is_dead" },
    { 0x44F4, "hades_rigged_walla" },
    { 0x44F5, "hades_throat_slash" },
    { 0x44F6, "hadesbodyscanfx" },
    { 0x44F7, "hadesreminderdialogue" },
    { 0x44F8, "hadesscriptedanimdeath" },
    { 0x44F9, "hadesspeechdialogue" },
    { 0x44FA, "hadesstabbedtakeoutfx" },
    { 0x44FB, "hadesthroatslashfx" },
    { 0x44FC, "hadesvehiclebadplace" },
    { 0x44FD, "hadtitan" },
    { 0x44FE, "half_size" },
    { 0x44FF, "halftime_switch_sides" },
    { 0x4500, "halftimeonscorelimit" },
    { 0x4501, "halftimeroundenddelay" },
    { 0x4502, "halftimetype" },
    { 0x4503, "halfwaydist" },
    { 0x4504, "hall_exploders" },
    { 0x4505, "hall_troop_scare_moment" },
    { 0x4506, "hallway_light_scare" },
    { 0x4507, "hand_flashlight" },
    { 0x4508, "hand_flashlight_handle_alert" },
    { 0x4509, "hand_flashlight_handle_effects" },
    { 0x450A, "hand_flashlight_handle_node_pause" },
    { 0x450B, "hand_flashlight_off" },
    { 0x450C, "hand_flashlight_on" },
    { 0x450D, "hand_flashlight_remove" },
    { 0x450E, "hand_flashlight_should_hide" },
    { 0x450F, "hand_flashlight_watch_for_drop" },
    { 0x4510, "hand_signal_after_hangar" },
    { 0x4511, "hand_signal_to_cafeteria" },
    { 0x4512, "hand_signal_to_hangar" },
    { 0x4513, "handcuff_break_fx" },
    { 0x4514, "handle_aa_guns" },
    { 0x4515, "handle_active_snipers" },
    { 0x4516, "handle_actor_enter_scanner" },
    { 0x4517, "handle_ads" },
    { 0x4518, "handle_aggro" },
    { 0x4519, "handle_alley_traversal" },
    { 0x451A, "handle_allow_death_for_walker_tank" },
    { 0x451B, "handle_ally_keep_up_with_player" },
    { 0x451C, "handle_ally_movement" },
    { 0x451D, "handle_ally_threat_during_execution_scene" },
    { 0x451E, "handle_ambient_cleanup_vehicles" },
    { 0x451F, "handle_ambient_drone" },
    { 0x4520, "handle_atlas_intercepts" },
    { 0x4521, "handle_atmospheric_transition" },
    { 0x4522, "handle_attached_guys" },
    { 0x4523, "handle_attack_drone_flyby_magnets" },
    { 0x4524, "handle_audio" },
    { 0x4525, "handle_bombing_runs" },
    { 0x4526, "handle_boost_dodge_training" },
    { 0x4527, "handle_boost_jump" },
    { 0x4528, "handle_boost_jump_npc_note" },
    { 0x4529, "handle_boost_jump_training" },
    { 0x452A, "handle_boost_slam_training" },
    { 0x452B, "handle_brake_lights" },
    { 0x452C, "handle_bridge_collapse" },
    { 0x452D, "handle_briefing" },
    { 0x452E, "handle_busses" },
    { 0x452F, "handle_button_prompts_on_pod" },
    { 0x4530, "handle_canal_intro_retreating" },
    { 0x4531, "handle_canyon_destructible" },
    { 0x4532, "handle_canyon_destructible_clips" },
    { 0x4533, "handle_canyon_turret_clips" },
    { 0x4534, "handle_capture" },
    { 0x4535, "handle_captured_anims" },
    { 0x4536, "handle_car_door_shield_damage" },
    { 0x4537, "handle_car_door_throw_hint" },
    { 0x4538, "handle_cardoor_outline_off" },
    { 0x4539, "handle_cardoor_outline_on" },
    { 0x453A, "handle_cargo_shut" },
    { 0x453B, "handle_chase_cam_toggle" },
    { 0x453C, "handle_chase_van" },
    { 0x453D, "handle_climb_scene_music" },
    { 0x453E, "handle_cloak_models_animation" },
    { 0x453F, "handle_cloaking" },
    { 0x4540, "handle_clouds" },
    { 0x4541, "handle_combat_runners" },
    { 0x4542, "handle_contact_collisions" },
    { 0x4543, "handle_controllable_cloud_queen_pathing" },
    { 0x4544, "handle_cormack" },
    { 0x4545, "handle_crashing" },
    { 0x4546, "handle_dam_targets" },
    { 0x4547, "handle_death" },
    { 0x4548, "handle_debris_visibility" },
    { 0x4549, "handle_decoy_tutorial" },
    { 0x454A, "handle_decoy_tutorial_hint_display" },
    { 0x454B, "handle_deployable_cover" },
    { 0x454C, "handle_destruct_parts" },
    { 0x454D, "handle_destructible_frame_queue" },
    { 0x454E, "handle_detached_guys_check" },
    { 0x454F, "handle_detection" },
    { 0x4550, "handle_detection_death" },
    { 0x4551, "handle_detection_spawners" },
    { 0x4552, "handle_detonator" },
    { 0x4553, "handle_disabling_sonic_blast" },
    { 0x4554, "handle_dismount" },
    { 0x4555, "handle_display_of_drones_number" },
    { 0x4556, "handle_diveboat_collisions" },
    { 0x4557, "handle_doctor" },
    { 0x4558, "handle_dogbite_notetrack" },
    { 0x4559, "handle_driving_music" },
    { 0x455A, "handle_driving_section" },
    { 0x455B, "handle_drone_cloud_vehicle_attack" },
    { 0x455C, "handle_drone_group" },
    { 0x455D, "handle_drone_on_turret" },
    { 0x455E, "handle_drone_opening" },
    { 0x455F, "handle_drone_smoke" },
    { 0x4560, "handle_drone_street_health_hack" },
    { 0x4561, "handle_drone_swarm_retreating" },
    { 0x4562, "handle_drone_swarm_shoot_at_player" },
    { 0x4563, "handle_drone_swarm_skipping" },
    { 0x4564, "handle_drone_target_selection" },
    { 0x4565, "handle_drone_target_selection_internal" },
    { 0x4566, "handle_drone_targetting_overlays" },
    { 0x4567, "handle_drone_teasers" },
    { 0x4568, "handle_drone_turret_target_movement" },
    { 0x4569, "handle_drone_turret_targeting" },
    { 0x456A, "handle_drones_attacking_walker" },
    { 0x456B, "handle_drones_vs_car_shield" },
    { 0x456C, "handle_drop_pod_screen_start" },
    { 0x456D, "handle_dropped_gun_angles" },
    { 0x456E, "handle_dying_player_brake_hint" },
    { 0x456F, "handle_dynamicevent" },
    { 0x4570, "handle_early_approach" },
    { 0x4571, "handle_earth_disc" },
    { 0x4572, "handle_emp_countdown" },
    { 0x4573, "handle_emp_kamikaze_drones" },
    { 0x4574, "handle_enemy_ambush_smoke_laser_sd" },
    { 0x4575, "handle_enemy_highlighting_in_binocs" },
    { 0x4576, "handle_enemy_when_player_is_in_cqb" },
    { 0x4577, "handle_evacuation_scene_triggers" },
    { 0x4578, "handle_evasive_controls" },
    { 0x4579, "handle_event_geo_off" },
    { 0x457A, "handle_event_geo_on" },
    { 0x457B, "handle_exocloak" },
    { 0x457C, "handle_failstate_primary_ignition_rumbles" },
    { 0x457D, "handle_fight_section" },
    { 0x457E, "handle_finale_objectives" },
    { 0x457F, "handle_flak" },
    { 0x4580, "handle_flak_cannons" },
    { 0x4581, "handle_foam_behavior" },
    { 0x4582, "handle_foam_detonator" },
    { 0x4583, "handle_fob" },
    { 0x4584, "handle_fob_runners" },
    { 0x4585, "handle_fob_runners_second_wave" },
    { 0x4586, "handle_force_land_assist" },
    { 0x4587, "handle_formation_nags" },
    { 0x4588, "handle_friendly_fob_razorback" },
    { 0x4589, "handle_friendly_pitbull" },
    { 0x458A, "handle_friendly_pitbull_shooting" },
    { 0x458B, "handle_fuel_refill" },
    { 0x458C, "handle_fuel_usage" },
    { 0x458D, "handle_fusion_portal_groups_on" },
    { 0x458E, "handle_fusion_portal_groups_toggle" },
    { 0x458F, "handle_gaz" },
    { 0x4590, "handle_gaz2" },
    { 0x4591, "handle_glass_collisions" },
    { 0x4592, "handle_glass_pathing" },
    { 0x4593, "handle_goliath_drop_pod_removal" },
    { 0x4594, "handle_goliath_drop_pod_timeout" },
    { 0x4595, "handle_grapple" },
    { 0x4596, "handle_guage_textures_intro_drive" },
    { 0x4597, "handle_guage_textures_intro_drive_newbike" },
    { 0x4598, "handle_gun_hint" },
    { 0x4599, "handle_gunner_death" },
    { 0x459A, "handle_gunner_pain" },
    { 0x459B, "handle_hack_security" },
    { 0x459C, "handle_hatch_takedown_notetracks" },
    { 0x459D, "handle_hide_droppod_building" },
    { 0x459E, "handle_hints" },
    { 0x459F, "handle_hotel_enemy_fallback" },
    { 0x45A0, "handle_hotel_entrance" },
    { 0x45A1, "handle_hotel_zipline_break_glass" },
    { 0x45A2, "handle_hover_hud" },
    { 0x45A3, "handle_hovertank_collisions" },
    { 0x45A4, "handle_hovertank_death" },
    { 0x45A5, "handle_hud_outline_binocs" },
    { 0x45A6, "handle_infil" },
    { 0x45A7, "handle_intro" },
    { 0x45A8, "handle_intro_clip" },
    { 0x45A9, "handle_irons" },
    { 0x45AA, "handle_irons_estate_animated_trees" },
    { 0x45AB, "handle_jet_boost" },
    { 0x45AC, "handle_jet_brake" },
    { 0x45AD, "handle_kamikaze_drone_visibility" },
    { 0x45AE, "handle_knuckles_turret" },
    { 0x45AF, "handle_lab_portal_scripting" },
    { 0x45B0, "handle_land_assist" },
    { 0x45B1, "handle_land_assist_safe_descent_training" },
    { 0x45B2, "handle_land_assist_training" },
    { 0x45B3, "handle_land_assist_training_hover" },
    { 0x45B4, "handle_level_exfil" },
    { 0x45B5, "handle_lift_worker_01" },
    { 0x45B6, "handle_lift_worker_02" },
    { 0x45B7, "handle_linked_ents" },
    { 0x45B8, "handle_littlebird_audio" },
    { 0x45B9, "handle_lobby_ambient_troops" },
    { 0x45BA, "handle_marking_guy" },
    { 0x45BB, "handle_microwaved_ai" },
    { 0x45BC, "handle_missile_hint" },
    { 0x45BD, "handle_missile_jet" },
    { 0x45BE, "handle_mob_turret" },
    { 0x45BF, "handle_movement_speed_in_final_building" },
    { 0x45C0, "handle_moving_platform_invalid" },
    { 0x45C1, "handle_moving_platform_touch" },
    { 0x45C2, "handle_moving_platforms" },
    { 0x45C3, "handle_name_identifiers_exit_drive" },
    { 0x45C4, "handle_name_identifiers_intro_drive" },
    { 0x45C5, "handle_npc_boost_jump_notetracks" },
    { 0x45C6, "handle_npc_crowds" },
    { 0x45C7, "handle_npc_death" },
    { 0x45C8, "handle_npcs_paths" },
    { 0x45C9, "handle_objective_marker" },
    { 0x45CA, "handle_objective_marker_movable" },
    { 0x45CB, "handle_objective_marker_skyjack" },
    { 0x45CC, "handle_objectives" },
    { 0x45CD, "handle_off_mission_pac" },
    { 0x45CE, "handle_outline_on_grenade_launcher" },
    { 0x45CF, "handle_pac_ally_movement" },
    { 0x45D0, "handle_pac_combat" },
    { 0x45D1, "handle_pac_entrance_fight" },
    { 0x45D2, "handle_pac_interior" },
    { 0x45D3, "handle_pac_laser_on_vols" },
    { 0x45D4, "handle_pac_retreating" },
    { 0x45D5, "handle_pac_retreating2" },
    { 0x45D6, "handle_pac_snipers" },
    { 0x45D7, "handle_pac_zipline_intos" },
    { 0x45D8, "handle_parked_police_car_radios" },
    { 0x45D9, "handle_path_blocking_fob" },
    { 0x45DA, "handle_pathing_on_glass" },
    { 0x45DB, "handle_pathing_post_event" },
    { 0x45DC, "handle_pathing_pre_event" },
    { 0x45DD, "handle_pdrone_audio" },
    { 0x45DE, "handle_performing_art_center_video_log" },
    { 0x45DF, "handle_pitbull_audio" },
    { 0x45E0, "handle_player" },
    { 0x45E1, "handle_player_abandoned_mission" },
    { 0x45E2, "handle_player_boost_jump" },
    { 0x45E3, "handle_player_breath" },
    { 0x45E4, "handle_player_cardoor_health" },
    { 0x45E5, "handle_player_cardoor_health_switch_weapon" },
    { 0x45E6, "handle_player_close_to_aircraft_rumbles" },
    { 0x45E7, "handle_player_during_tutorial" },
    { 0x45E8, "handle_player_ending_aerial_view" },
    { 0x45E9, "handle_player_exo_punch" },
    { 0x45EA, "handle_player_fov_indroppod" },
    { 0x45EB, "handle_player_jump_off_roof" },
    { 0x45EC, "handle_player_on_left_street" },
    { 0x45ED, "handle_player_pitbull" },
    { 0x45EE, "handle_player_pitbull_autosave_checks" },
    { 0x45EF, "handle_player_pitbull_damage" },
    { 0x45F0, "handle_player_pitbull_driving" },
    { 0x45F1, "handle_player_pitbull_hud" },
    { 0x45F2, "handle_player_pitbull_turret" },
    { 0x45F3, "handle_player_skipped_turret" },
    { 0x45F4, "handle_player_skipping_setups" },
    { 0x45F5, "handle_player_slide_rumbles" },
    { 0x45F6, "handle_player_starting_aerial_view" },
    { 0x45F7, "handle_player_wall_climb_rumbles" },
    { 0x45F8, "handle_pod_crash_building1" },
    { 0x45F9, "handle_pod_door_deform" },
    { 0x45FA, "handle_pod_screen_bootup" },
    { 0x45FB, "handle_pod_screen_off" },
    { 0x45FC, "handle_pod_screen_show" },
    { 0x45FD, "handle_pod_swap" },
    { 0x45FE, "handle_portal_group" },
    { 0x45FF, "handle_portal_scripting_vista" },
    { 0x4600, "handle_prone_and_crouch_bugs" },
    { 0x4601, "handle_queen" },
    { 0x4602, "handle_recon" },
    { 0x4603, "handle_reentry_fx" },
    { 0x4604, "handle_remove_overlay" },
    { 0x4605, "handle_rotors" },
    { 0x4606, "handle_rumble_and_screenshake" },
    { 0x4607, "handle_runner_spawner" },
    { 0x4608, "handle_sanfran_portal_groups_on" },
    { 0x4609, "handle_sd_dynamicevent" },
    { 0x460A, "handle_security_center" },
    { 0x460B, "handle_security_drone_hit" },
    { 0x460C, "handle_selected_ents" },
    { 0x460D, "handle_sfb_portal_groups_toggle" },
    { 0x460E, "handle_shopping_district_retreating" },
    { 0x460F, "handle_sinkhole_enemy_setup" },
    { 0x4610, "handle_sinkhole_video_log" },
    { 0x4611, "handle_smoke" },
    { 0x4612, "handle_snake_firing" },
    { 0x4613, "handle_sniper_exos" },
    { 0x4614, "handle_sniper_turrets" },
    { 0x4615, "handle_sonar_hint" },
    { 0x4616, "handle_sonic_when_in_subway" },
    { 0x4617, "handle_space_sky" },
    { 0x4618, "handle_spotlight_fx" },
    { 0x4619, "handle_spotlight_switch" },
    { 0x461A, "handle_starts" },
    { 0x461B, "handle_starts_endons" },
    { 0x461C, "handle_stealth_display_tutorial" },
    { 0x461D, "handle_stepover_scene_clip" },
    { 0x461E, "handle_stinger_objective" },
    { 0x461F, "handle_stop_hotel_music_flag" },
    { 0x4620, "handle_sun_spotlight" },
    { 0x4621, "handle_swarm_scene" },
    { 0x4622, "handle_tank_death" },
    { 0x4623, "handle_tank_obj" },
    { 0x4624, "handle_tanker_missiles" },
    { 0x4625, "handle_teleport" },
    { 0x4626, "handle_testers_skipping_pac_combat" },
    { 0x4627, "handle_threat_paint_death" },
    { 0x4628, "handle_traffic_collisions" },
    { 0x4629, "handle_train_bridge" },
    { 0x462A, "handle_triggers_off" },
    { 0x462B, "handle_triggers_on" },
    { 0x462C, "handle_turret_gunner_sonic_blast" },
    { 0x462D, "handle_turret_hud_target_text" },
    { 0x462E, "handle_turret_shootloop" },
    { 0x462F, "handle_turret_specific_saves" },
    { 0x4630, "handle_turret1_spawns" },
    { 0x4631, "handle_turret2_spawns" },
    { 0x4632, "handle_turret3_spawns" },
    { 0x4633, "handle_turrets" },
    { 0x4634, "handle_unarmed_viewbob" },
    { 0x4635, "handle_unresolved_collision" },
    { 0x4636, "handle_vehicle_ai" },
    { 0x4637, "handle_vehicle_death" },
    { 0x4638, "handle_vehicle_dof" },
    { 0x4639, "handle_vista_crashing_pods" },
    { 0x463A, "handle_vista_jets" },
    { 0x463B, "handle_vista_landing_pods" },
    { 0x463C, "handle_vista_missile_outrun" },
    { 0x463D, "handle_vista_pods" },
    { 0x463E, "handle_vista_tanks" },
    { 0x463F, "handle_vista_vehicles" },
    { 0x4640, "handle_volume_assign" },
    { 0x4641, "handle_wakeup_sphere_global" },
    { 0x4642, "handle_walker_tank_death" },
    { 0x4643, "handle_walker_tank_firing" },
    { 0x4644, "handle_walker_tank_shooting_himself" },
    { 0x4645, "handle_weapon_pickups" },
    { 0x4646, "handle_weapon_switch" },
    { 0x4647, "handle_weaponhud_visibility" },
    { 0x4648, "handle_wep_drone_dropoff" },
    { 0x4649, "handle_whistle_hint" },
    { 0x464A, "handle_will_irons_movement" },
    { 0x464B, "handleagentuse" },
    { 0x464C, "handleapdamage" },
    { 0x464D, "handleattachmentdamage" },
    { 0x464E, "handleattachmentdeath" },
    { 0x464F, "handlebackcrawlnotetracks" },
    { 0x4650, "handlebuoydings" },
    { 0x4651, "handlecleanupputaway" },
    { 0x4652, "handleclouds" },
    { 0x4653, "handlecloudsaerialjoin" },
    { 0x4654, "handlecloudsaerialleave" },
    { 0x4655, "handlecoopjoining" },
    { 0x4656, "handlecoopshooting" },
    { 0x4657, "handledamage" },
    { 0x4658, "handledamagefeedbacksound" },
    { 0x4659, "handledeath" },
    { 0x465A, "handledeathdamage" },
    { 0x465B, "handledogfootstepnotetracks" },
    { 0x465C, "handledogsoundnotetracks" },
    { 0x465D, "handledogturnnotetracks" },
    { 0x465E, "handledropclip" },
    { 0x465F, "handleemp" },
    { 0x4660, "handleempdamage" },
    { 0x4661, "handleendwater" },
    { 0x4662, "handleflarestimer" },
    { 0x4663, "handlefootstepnotetracks" },
    { 0x4664, "handlefriendlyfiredeath" },
    { 0x4665, "handlegrenadedamage" },
    { 0x4666, "handlehostmigration" },
    { 0x4667, "handleincomingstinger" },
    { 0x4668, "handlelockedtarget" },
    { 0x4669, "handlemeleebiteattacknotetracks" },
    { 0x466A, "handlemeleedamage" },
    { 0x466B, "handlemeleefinishattacknotetracks" },
    { 0x466C, "handlemissiledamage" },
    { 0x466D, "handlemovingwater" },
    { 0x466E, "handlenormaldeath" },
    { 0x466F, "handlenotetrack" },
    { 0x4670, "handlepickup" },
    { 0x4671, "handleplayerknockdownnotetracks" },
    { 0x4672, "handleprisonturretlights" },
    { 0x4673, "handleprompt" },
    { 0x4674, "handlepropattachments" },
    { 0x4675, "handleputaway" },
    { 0x4676, "handler" },
    { 0x4677, "handler_parm1" },
    { 0x4678, "handler_parm2" },
    { 0x4679, "handler_parm3" },
    { 0x467A, "handlerdronedetonate" },
    { 0x467B, "handlerdronethink" },
    { 0x467C, "handleriotshieldshockplant" },
    { 0x467D, "handlerocketlauncherammoondeath" },
    { 0x467E, "handles" },
    { 0x467F, "handlesafehouseoutroblur" },
    { 0x4680, "handlescavengerbagpickup" },
    { 0x4681, "handlesidetosidenotetracks" },
    { 0x4682, "handlestartaim" },
    { 0x4683, "handlestartaipart" },
    { 0x4684, "handlesuicidedeath" },
    { 0x4685, "handleteamchangedeath" },
    { 0x4686, "handletraversealignment" },
    { 0x4687, "handletraversedeathnotetrack" },
    { 0x4688, "handletraversedrop" },
    { 0x4689, "handletraversenotetracks" },
    { 0x468A, "handletraversenotetracksgravity" },
    { 0x468B, "handletraversenotetrackslandassist" },
    { 0x468C, "handletriggerhintinputtypetext" },
    { 0x468D, "handletsunamiwarningsounds" },
    { 0x468E, "handleturretonplayerdone" },
    { 0x468F, "handleturretsoundent" },
    { 0x4690, "handleuse" },
    { 0x4691, "handlevxnotetrack" },
    { 0x4692, "handlewatertriggermovement" },
    { 0x4693, "handleworlddeath" },
    { 0x4694, "handplant_target" },
    { 0x4695, "handprint_fx_test" },
    { 0x4696, "handprint_on" },
    { 0x4697, "handprint_on_fx" },
    { 0x4698, "hands_animation" },
    { 0x4699, "handshake_lighting" },
    { 0x469A, "handsignal" },
    { 0x469B, "hangar" },
    { 0x469C, "hangar_ambient_worker_setup" },
    { 0x469D, "hangar_ambient_worker_setup_anim" },
    { 0x469E, "hangar_car_door_light" },
    { 0x469F, "hangar_car_door_light_audio" },
    { 0x46A0, "hangar_cargo_crate" },
    { 0x46A1, "hangar_combat" },
    { 0x46A2, "hangar_combat_reinforcements" },
    { 0x46A3, "hangar_dialogue" },
    { 0x46A4, "hangar_door" },
    { 0x46A5, "hangar_doors_open" },
    { 0x46A6, "hangar_drones" },
    { 0x46A7, "hangar_enemies" },
    { 0x46A8, "hangar_enemy_think" },
    { 0x46A9, "hangar_ents" },
    { 0x46AA, "hangar_exit_door" },
    { 0x46AB, "hangar_explo_and_debris_01" },
    { 0x46AC, "hangar_explo_and_debris_02" },
    { 0x46AD, "hangar_fx" },
    { 0x46AE, "hangar_heli_wait_for_death" },
    { 0x46AF, "hangar_heli_wait_for_unload" },
    { 0x46B0, "hangar_jet_flyby" },
    { 0x46B1, "hangar_lift" },
    { 0x46B2, "hangar_lights_on" },
    { 0x46B3, "hangar_mech_01" },
    { 0x46B4, "hangar_pa" },
    { 0x46B5, "hangar_transport_01_away" },
    { 0x46B6, "hangar_transport_flying_01_away" },
    { 0x46B7, "hangar_transport_flying_02_away" },
    { 0x46B8, "hangar_vials" },
    { 0x46B9, "hangar_visor_bink" },
    { 0x46BA, "hanger_bad_path" },
    { 0x46BB, "hanger_ent_init" },
    { 0x46BC, "hanger_ent_reset" },
    { 0x46BD, "hanger_event" },
    { 0x46BE, "hanger_event_connect_nodes" },
    { 0x46BF, "hanger_event_connect_nodes_drone" },
    { 0x46C0, "hanger_event_connect_nodes_floor" },
    { 0x46C1, "hanger_event_disconnect_nodes" },
    { 0x46C2, "hanger_event_disconnect_nodes_drone" },
    { 0x46C3, "hanger_event_disconnect_nodes_floor" },
    { 0x46C4, "hanger_event_idle_anims" },
    { 0x46C5, "hanger_floor_init" },
    { 0x46C6, "hanger_floor_run" },
    { 0x46C7, "hanger_mech_think" },
    { 0x46C8, "hanger_reinforcements_think" },
    { 0x46C9, "hanger_warbird_clip_think" },
    { 0x46CA, "hanger_warbird_think" },
    { 0x46CB, "hanging_bodies" },
    { 0x46CC, "hardcorecostumetablename" },
    { 0x46CD, "hardcoremode" },
    { 0x46CE, "hardened" },
    { 0x46CF, "hardenedaward" },
    { 0x46D0, "hardpointmainloop" },
    { 0x46D1, "hardpointtweaks" },
    { 0x46D2, "hardpointtype" },
    { 0x46D3, "harmonic_breach_complete_dialogue" },
    { 0x46D4, "harmonic_breach_confirmation_dialogue" },
    { 0x46D5, "harmonic_breach_correction_dialogue" },
    { 0x46D6, "harmonic_breach_flash_off" },
    { 0x46D7, "harmonic_breach_nag_dialogue" },
    { 0x46D8, "harmonic_breach_nag_timer" },
    { 0x46D9, "harmonic_breach_prep_dialogue" },
    { 0x46DA, "harmonic_breach_prep_dialogue_nag" },
    { 0x46DB, "harmonic_breach_secure_pm" },
    { 0x46DC, "harmonic_breach_shoot_now_dialogue" },
    { 0x46DD, "harmonic_breach_start_dialogue" },
    { 0x46DE, "harmonic_breach_timer_warning_dialogue" },
    { 0x46DF, "harmonic_breach_turn_on" },
    { 0x46E0, "harness" },
    { 0x46E1, "harpoon_launch_effects" },
    { 0x46E2, "harriers" },
    { 0x46E3, "has_balanced_personality" },
    { 0x46E4, "has_ball" },
    { 0x46E5, "has_been_alerted" },
    { 0x46E6, "has_been_captured" },
    { 0x46E7, "has_bracket" },
    { 0x46E8, "has_char_group" },
    { 0x46E9, "has_chemicals" },
    { 0x46EA, "has_cold_breath" },
    { 0x46EB, "has_color" },
    { 0x46EC, "has_delta" },
    { 0x46ED, "has_entered_attack_behavior" },
    { 0x46EE, "has_expensive_flashlight" },
    { 0x46EF, "has_fake_pistol" },
    { 0x46F0, "has_flares" },
    { 0x46F1, "has_forced_target_changed" },
    { 0x46F2, "has_frontarmor" },
    { 0x46F3, "has_grenades_to_throw" },
    { 0x46F4, "has_idle_played" },
    { 0x46F5, "has_kicked_door" },
    { 0x46F6, "has_loadout" },
    { 0x46F7, "has_los" },
    { 0x46F8, "has_move_played" },
    { 0x46F9, "has_no_ir" },
    { 0x46FA, "has_override_flag_targets" },
    { 0x46FB, "has_override_zone_targets" },
    { 0x46FC, "has_paint_pro" },
    { 0x46FD, "has_passive_breacher" },
    { 0x46FE, "has_riders" },
    { 0x46FF, "has_roll_played" },
    { 0x4700, "has_semtex_on_it" },
    { 0x4701, "has_shotgun" },
    { 0x4702, "has_special_breach_anim" },
    { 0x4703, "has_started_thinking" },
    { 0x4704, "has_target_volume" },
    { 0x4705, "has_thermal_fx" },
    { 0x4706, "has_thrown_door_timeout" },
    { 0x4707, "has_trackrounds" },
    { 0x4708, "has_trophy_ammo" },
    { 0x4709, "has_unmatching_deathmodel_rig" },
    { 0x470A, "has_used_ads_or_timeout" },
    { 0x470B, "has_used_boost" },
    { 0x470C, "has_used_boost_dodge" },
    { 0x470D, "has_used_boost_recently" },
    { 0x470E, "has_used_boost_slam" },
    { 0x470F, "has_used_emp" },
    { 0x4710, "has_used_land_assist" },
    { 0x4711, "has_used_lt" },
    { 0x4712, "has_used_lt_rt" },
    { 0x4713, "has_used_rt" },
    { 0x4714, "has_used_smart_or_timeout" },
    { 0x4715, "has_veh_collision" },
    { 0x4716, "hasachievement" },
    { 0x4717, "hasagentsquadmember" },
    { 0x4718, "hasai" },
    { 0x4719, "hasaiassaultdrone" },
    { 0x471A, "hasaioption" },
    { 0x471B, "hasanim" },
    { 0x471C, "hasarhud" },
    { 0x471D, "hasassistpoints" },
    { 0x471E, "hasattachedprops" },
    { 0x471F, "hasattachedweapons" },
    { 0x4720, "hasaudiocheck" },
    { 0x4721, "hasbadplace" },
    { 0x4722, "hasbattlebuddy" },
    { 0x4723, "hasbeencalledout" },
    { 0x4724, "hasbeenhit" },
    { 0x4725, "hasbots" },
    { 0x4726, "hasclip" },
    { 0x4727, "hascloak" },
    { 0x4728, "hascoopsentry" },
    { 0x4729, "hasdied" },
    { 0x472A, "hasdodged" },
    { 0x472B, "hasdoneanycombat" },
    { 0x472C, "hasdonecombat" },
    { 0x472D, "hasdoor" },
    { 0x472E, "hasempgrenade" },
    { 0x472F, "hasenemysightpos" },
    { 0x4730, "hasextraammo" },
    { 0x4731, "hasflashbangs" },
    { 0x4732, "hashelicopterdustkickup" },
    { 0x4733, "hashelicopterturret" },
    { 0x4734, "hasincreasedtime" },
    { 0x4735, "hasknife" },
    { 0x4736, "hasleftcam" },
    { 0x4737, "haslevelveteranaward" },
    { 0x4738, "haslightarmor" },
    { 0x4739, "haslongpunch" },
    { 0x473A, "hasmaniac" },
    { 0x473B, "hasmat_kva_move_in" },
    { 0x473C, "hasmg" },
    { 0x473D, "hasmissionhardenedaward" },
    { 0x473E, "hasmovementtypechanged" },
    { 0x473F, "hasoverrideanimchanged" },
    { 0x4740, "haspaintgrenade" },
    { 0x4741, "hasperksprintfire" },
    { 0x4742, "hasreachedfinalpos" },
    { 0x4743, "hasriotshield" },
    { 0x4744, "hasriotshieldequipped" },
    { 0x4745, "hasrockets" },
    { 0x4746, "hasscavengedammothislife" },
    { 0x4747, "hasselfrevive" },
    { 0x4748, "hasspawned" },
    { 0x4749, "hasstarted" },
    { 0x474A, "hasstun" },
    { 0x474B, "hassuppressableenemy" },
    { 0x474C, "hastag" },
    { 0x474D, "hastitan45" },
    { 0x474E, "hastouchedstick" },
    { 0x474F, "hastrophy" },
    { 0x4750, "hasturret" },
    { 0x4751, "hasweaponstate" },
    { 0x4752, "hatch" },
    { 0x4753, "hatch_button_gameplay" },
    { 0x4754, "hatch_dof" },
    { 0x4755, "hatch_door_lightgrid_off" },
    { 0x4756, "hatch_door_middle" },
    { 0x4757, "hatch_door_push_fog_out" },
    { 0x4758, "hatch_door_veil" },
    { 0x4759, "hatch_door_vision" },
    { 0x475A, "hatch_land_blur" },
    { 0x475B, "hatch_lighting" },
    { 0x475C, "hatch_open_se_update_rumble_intensity" },
    { 0x475D, "hatch_takedown_bad_guy_punched" },
    { 0x475E, "hatch_takedown_cormack_door" },
    { 0x475F, "hatch_takedown_cormack_punch" },
    { 0x4760, "hatmodel" },
    { 0x4761, "have_flashlight" },
    { 0x4762, "havegonetocover" },
    { 0x4763, "havenothingtoshoot" },
    { 0x4764, "haventramboedwithintime" },
    { 0x4765, "havoc" },
    { 0x4766, "havoc_missile_launch" },
    { 0x4767, "hb_gun_away" },
    { 0x4768, "hb_highlight_disable" },
    { 0x4769, "hb_highlight_enable" },
    { 0x476A, "hb_joker_catch" },
    { 0x476B, "hb_joker_start" },
    { 0x476C, "hb_joker_step_back" },
    { 0x476D, "hb_lock_targets" },
    { 0x476E, "hb_player_plant" },
    { 0x476F, "hb_player_start" },
    { 0x4770, "hb_sensor_flash_off" },
    { 0x4771, "hb_sensor_flash_on" },
    { 0x4772, "hb_shots_fired" },
    { 0x4773, "hb_target_tagged" },
    { 0x4774, "hb_target_untagged" },
    { 0x4775, "hbra3_signature" },
    { 0x4776, "hbra3_signature_off" },
    { 0x4777, "hdrcolorintensity" },
    { 0x4778, "hdroverride" },
    { 0x4779, "hdrsuncolorintensity" },
    { 0x477A, "header" },
    { 0x477B, "headiconheight" },
    { 0x477C, "heading" },
    { 0x477D, "heading_your_way_dialogue" },
    { 0x477E, "headingsize" },
    { 0x477F, "headless_shadow_tweak" },
    { 0x4780, "headmodel" },
    { 0x4781, "headshotevent" },
    { 0x4782, "healer" },
    { 0x4783, "health_based_rumble" },
    { 0x4784, "health_drain" },
    { 0x4785, "health_monitor" },
    { 0x4786, "health_scale" },
    { 0x4787, "health_track" },
    { 0x4788, "health0" },
    { 0x4789, "healthbuffer" },
    { 0x478A, "healthcustom" },
    { 0x478B, "healthdrain" },
    { 0x478C, "healthoverlay" },
    { 0x478D, "healthoverlay_drips" },
    { 0x478E, "healthoverlay_remove" },
    { 0x478F, "healthoverlaycg" },
    { 0x4790, "healthoverlaycutoff" },
    { 0x4791, "healthregendisabled" },
    { 0x4792, "healthregenerated" },
    { 0x4793, "healthregeneration" },
    { 0x4794, "healthregenerationstreak" },
    { 0x4795, "healthregenlevel" },
    { 0x4796, "heard_alarm_reaction_behavior" },
    { 0x4797, "heartbeat" },
    { 0x4798, "heat" },
    { 0x4799, "heat_level" },
    { 0x479A, "heat_reload_anim" },
    { 0x479B, "heatlevel" },
    { 0x479C, "heavy_lifter" },
    { 0x479D, "heavy_wind" },
    { 0x479E, "heavyexodata" },
    { 0x479F, "heavyresistance" },
    { 0x47A0, "height_warning" },
    { 0x47A1, "heightfogbaseheight" },
    { 0x47A2, "heightfogenabled" },
    { 0x47A3, "heightfoghalfplanedistance" },
    { 0x47A4, "heightforhighcallout" },
    { 0x47A5, "heightmax" },
    { 0x47A6, "heli" },
    { 0x47A7, "heli_action_status" },
    { 0x47A8, "heli_addrecentdamage" },
    { 0x47A9, "heli_attract_range" },
    { 0x47AA, "heli_attract_strength" },
    { 0x47AB, "heli_can_see_target" },
    { 0x47AC, "heli_circling_think" },
    { 0x47AD, "heli_collision" },
    { 0x47AE, "heli_crash" },
    { 0x47AF, "heli_crash_indirect_zoff" },
    { 0x47B0, "heli_crash_lead" },
    { 0x47B1, "heli_crash_nodes" },
    { 0x47B2, "heli_custom_fireuntiloutofammo" },
    { 0x47B3, "heli_custom_reload" },
    { 0x47B4, "heli_damage_monitor" },
    { 0x47B5, "heli_damage_update" },
    { 0x47B6, "heli_death_monitor" },
    { 0x47B7, "heli_default_missiles_off" },
    { 0x47B8, "heli_default_missiles_on" },
    { 0x47B9, "heli_default_target_cleanup" },
    { 0x47BA, "heli_default_target_setup" },
    { 0x47BB, "heli_delete_on_pathend" },
    { 0x47BC, "heli_empgrenaded" },
    { 0x47BD, "heli_existance" },
    { 0x47BE, "heli_explode" },
    { 0x47BF, "heli_fight" },
    { 0x47C0, "heli_fire_missiles" },
    { 0x47C1, "heli_firelink" },
    { 0x47C2, "heli_flares_monitor" },
    { 0x47C3, "heli_fly_simple_path" },
    { 0x47C4, "heli_fly_vfx_dopl_fill_light_setup" },
    { 0x47C5, "heli_get_node_origin" },
    { 0x47C6, "heli_get_shooters" },
    { 0x47C7, "heli_get_target" },
    { 0x47C8, "heli_get_target_ai_only" },
    { 0x47C9, "heli_get_target_player_only" },
    { 0x47CA, "heli_gideon_fire" },
    { 0x47CB, "heli_goal_think" },
    { 0x47CC, "heli_has_player_target" },
    { 0x47CD, "heli_has_target" },
    { 0x47CE, "heli_hold_position" },
    { 0x47CF, "heli_lastattacker" },
    { 0x47D0, "heli_leave" },
    { 0x47D1, "heli_leave_nodes" },
    { 0x47D2, "heli_leave_on_changeteams" },
    { 0x47D3, "heli_leave_on_disconnect" },
    { 0x47D4, "heli_leave_on_gameended" },
    { 0x47D5, "heli_leave_on_timeout" },
    { 0x47D6, "heli_looking_at_target" },
    { 0x47D7, "heli_maxhealth" },
    { 0x47D8, "heli_missiles_think" },
    { 0x47D9, "heli_modifydamage" },
    { 0x47DA, "heli_monitoremp" },
    { 0x47DB, "heli_pick_fly_node" },
    { 0x47DC, "heli_pick_node_furthest_from_center" },
    { 0x47DD, "heli_probe_override" },
    { 0x47DE, "heli_reset" },
    { 0x47DF, "heli_secondary_explosions" },
    { 0x47E0, "heli_shoot_allies" },
    { 0x47E1, "heli_shoot_enemies" },
    { 0x47E2, "heli_shoot_enemy_trace_then_fire" },
    { 0x47E3, "heli_shoot_think" },
    { 0x47E4, "heli_sound" },
    { 0x47E5, "heli_spin" },
    { 0x47E6, "heli_spotlight_aim" },
    { 0x47E7, "heli_spotlight_aim_ents_cleanup" },
    { 0x47E8, "heli_spotlight_cleanup" },
    { 0x47E9, "heli_spotlight_create_default_targets" },
    { 0x47EA, "heli_spotlight_destroy_default_targets" },
    { 0x47EB, "heli_spotlight_exposure_change" },
    { 0x47EC, "heli_spotlight_off" },
    { 0x47ED, "heli_spotlight_on" },
    { 0x47EE, "heli_spotlight_random_targets_off" },
    { 0x47EF, "heli_spotlight_random_targets_on" },
    { 0x47F0, "heli_spotlight_think" },
    { 0x47F1, "heli_squad_01" },
    { 0x47F2, "heli_squad_02" },
    { 0x47F3, "heli_squad_03" },
    { 0x47F4, "heli_squad_05" },
    { 0x47F5, "heli_squad_06" },
    { 0x47F6, "heli_squad_07" },
    { 0x47F7, "heli_squad_08" },
    { 0x47F8, "heli_squad_09" },
    { 0x47F9, "heli_squad_11" },
    { 0x47FA, "heli_start_shooting" },
    { 0x47FB, "heli_staticdamage" },
    { 0x47FC, "heli_strafe" },
    { 0x47FD, "heli_targeting_delay" },
    { 0x47FE, "heli_toggle_shoot" },
    { 0x47FF, "heli_tower_death" },
    { 0x4800, "heli_tower_death2" },
    { 0x4801, "heli_turret_death_think" },
    { 0x4802, "heli_type" },
    { 0x4803, "heli_wait_for_unload" },
    { 0x4804, "heli_wait_node" },
    { 0x4805, "helianchor" },
    { 0x4806, "helicopter_crash" },
    { 0x4807, "helicopter_crash_directed" },
    { 0x4808, "helicopter_crash_flavor" },
    { 0x4809, "helicopter_crash_locations" },
    { 0x480A, "helicopter_crash_move" },
    { 0x480B, "helicopter_crash_path" },
    { 0x480C, "helicopter_crash_rotate" },
    { 0x480D, "helicopter_crash_zigzag" },
    { 0x480E, "helicopter_drone_attack" },
    { 0x480F, "helicopter_firelinkfunk" },
    { 0x4810, "helicopter_flyby" },
    { 0x4811, "helicopter_in_air_explosion" },
    { 0x4812, "helicopter_landing" },
    { 0x4813, "helicopter_list" },
    { 0x4814, "helicopter_predator_target_shader" },
    { 0x4815, "helicopter_slide_spark" },
    { 0x4816, "helicopter_view_intro" },
    { 0x4817, "heliheightoverride" },
    { 0x4818, "heliride_rockets_and_slowmo" },
    { 0x4819, "helis" },
    { 0x481A, "helispawning" },
    { 0x481B, "helitype" },
    { 0x481C, "helmet_close" },
    { 0x481D, "helmet_open" },
    { 0x481E, "helmet_swap" },
    { 0x481F, "helmet_swap_wait_function" },
    { 0x4820, "helmet_tag" },
    { 0x4821, "helmet_tag2" },
    { 0x4822, "helmetlaunch" },
    { 0x4823, "helmetpop" },
    { 0x4824, "helmetsidemodel" },
    { 0x4825, "helo" },
    { 0x4826, "helo_coming_back_dialogue" },
    { 0x4827, "helo_sniper_bullet_impacts" },
    { 0x4828, "helo_sniper_threaten_player" },
    { 0x4829, "helo_spotlight" },
    { 0x482A, "helo_spotlight_climbing_moment" },
    { 0x482B, "helo_spotlight_forest_think" },
    { 0x482C, "helo_spotlight_handle_intro_rumbles" },
    { 0x482D, "helo_spotlight_init" },
    { 0x482E, "helo_spotlight_kill_player_unless_notify" },
    { 0x482F, "helo_spotlight_light_motion" },
    { 0x4830, "helo_spotlight_logging_road" },
    { 0x4831, "helo_spotlight_logging_road_break_off" },
    { 0x4832, "helo_spotlight_movement" },
    { 0x4833, "helo_spotlight_point_of_interest_tracking" },
    { 0x4834, "helo_spotlight_search_for_player" },
    { 0x4835, "helo_spotlight_shoot_location" },
    { 0x4836, "helo_spotlight_shoot_struct" },
    { 0x4837, "helo_spotlight_shoot_trigger_think" },
    { 0x4838, "helo_spotlight_think" },
    { 0x4839, "helo_wall_climb" },
    { 0x483A, "help_list_offset" },
    { 0x483B, "help_list_offset_max" },
    { 0x483C, "help_navigation_buttons" },
    { 0x483D, "hero_list" },
    { 0x483E, "hero_stats" },
    { 0x483F, "heroes" },
    { 0x4840, "heroes_post_zip" },
    { 0x4841, "hidden" },
    { 0x4842, "hidden_for_capture" },
    { 0x4843, "hidden_kva" },
    { 0x4844, "hide_all_chars" },
    { 0x4845, "hide_avatar" },
    { 0x4846, "hide_avatar_akimbo_weapon" },
    { 0x4847, "hide_avatar_primary_weapon" },
    { 0x4848, "hide_avatar_secondary_weapon" },
    { 0x4849, "hide_avatar_weapons" },
    { 0x484A, "hide_avatars" },
    { 0x484B, "hide_brushes" },
    { 0x484C, "hide_chase_scene" },
    { 0x484D, "hide_crash_traffic" },
    { 0x484E, "hide_damaged_parts" },
    { 0x484F, "hide_display_hint" },
    { 0x4850, "hide_entity" },
    { 0x4851, "hide_ents_by_targetname" },
    { 0x4852, "hide_exploder_models" },
    { 0x4853, "hide_exploder_models_proc" },
    { 0x4854, "hide_fallen_bridge" },
    { 0x4855, "hide_for_capture" },
    { 0x4856, "hide_friendname_until_flag_or_notify" },
    { 0x4857, "hide_fusion_street_lights_off" },
    { 0x4858, "hide_geo" },
    { 0x4859, "hide_grenade_hints" },
    { 0x485A, "hide_hint" },
    { 0x485B, "hide_intact_bridge" },
    { 0x485C, "hide_mech_glass_static_overlay" },
    { 0x485D, "hide_mech_screen" },
    { 0x485E, "hide_mountains" },
    { 0x485F, "hide_navy_boats" },
    { 0x4860, "hide_non_owner_avatars" },
    { 0x4861, "hide_notsolid" },
    { 0x4862, "hide_objective_during_fly_in" },
    { 0x4863, "hide_on_models" },
    { 0x4864, "hide_plant_vista_intro" },
    { 0x4865, "hide_plant_vista_via_trigger" },
    { 0x4866, "hide_player_hud" },
    { 0x4867, "hide_radio" },
    { 0x4868, "hide_reveal_screen_reflections" },
    { 0x4869, "hide_turret" },
    { 0x486A, "hide_water" },
    { 0x486B, "hide_x4walker_melee_hint" },
    { 0x486C, "hide1_shelf_delete" },
    { 0x486D, "hide2_shelf_delete" },
    { 0x486E, "hideall" },
    { 0x486F, "hideapart" },
    { 0x4870, "hideattachmentswhilecloaked" },
    { 0x4871, "hidebar" },
    { 0x4872, "hideboatshadows" },
    { 0x4873, "hidecarryiconongameend" },
    { 0x4874, "hideelem" },
    { 0x4875, "hidefirehud" },
    { 0x4876, "hidefireshowaimidle" },
    { 0x4877, "hidefromplayer" },
    { 0x4878, "hidefromplayers" },
    { 0x4879, "hidegeo" },
    { 0x487A, "hideheadicons" },
    { 0x487B, "hidehudelementongameend" },
    { 0x487C, "hideidle" },
    { 0x487D, "hidemodels" },
    { 0x487E, "hideondeath" },
    { 0x487F, "hideoverlays" },
    { 0x4880, "hidepartatdepth" },
    { 0x4881, "hideplacedmodel" },
    { 0x4882, "hidepodfx" },
    { 0x4883, "hidestate" },
    { 0x4884, "hidetransitionmeshes" },
    { 0x4885, "hidetransitionmeshes_cg" },
    { 0x4886, "hideworldiconongameend" },
    { 0x4887, "hideyawoffset" },
    { 0x4888, "high_beam_oncoming" },
    { 0x4889, "high_beaming" },
    { 0x488A, "high_jump_enable" },
    { 0x488B, "high_jump_enabled" },
    { 0x488C, "high_jump_host_migration" },
    { 0x488D, "high_jump_on_player_spawn" },
    { 0x488E, "high_priority_for" },
    { 0x488F, "high_priority_hint" },
    { 0x4890, "higher_priority_expiration_time_s" },
    { 0x4891, "highestwins" },
    { 0x4892, "highlight" },
    { 0x4893, "highlight_custom" },
    { 0x4894, "highlight_effect" },
    { 0x4895, "highlight_forced" },
    { 0x4896, "highlight_on" },
    { 0x4897, "highlight_when_weapon_fired" },
    { 0x4898, "highlightairdrop" },
    { 0x4899, "highlightlastenemies" },
    { 0x489A, "highway_frogger_dialogue" },
    { 0x489B, "highway_frogger_end_nag" },
    { 0x489C, "highway_frogger_middle_ai_check" },
    { 0x489D, "highway_frogger_middle_nag" },
    { 0x489E, "highway_ledge_jump_go_dialogue" },
    { 0x489F, "highway_ledge_jump_prep_dialogue" },
    { 0x48A0, "highway_traffic_final_takedown_hold_on" },
    { 0x48A1, "highway_traffic_first_suvs" },
    { 0x48A2, "highway_traffic_helo_callout" },
    { 0x48A3, "highway_traffic_jump_2_dialogue" },
    { 0x48A4, "highway_traffic_jump_3_dialogue" },
    { 0x48A5, "highway_traffic_jump_4_dialogue" },
    { 0x48A6, "highway_traffic_jump_5_dialogue" },
    { 0x48A7, "highway_traffic_middle_takedown_dialogue" },
    { 0x48A8, "highway_traffic_takedown_dialogue" },
    { 0x48A9, "highway_traffic_traverse_dialogue" },
    { 0x48AA, "highway_veteran_helo_reduction" },
    { 0x48AB, "hijackerevent" },
    { 0x48AC, "hill_slide" },
    { 0x48AD, "hill_sunflare" },
    { 0x48AE, "hillslide_dust_fx" },
    { 0x48AF, "himar_print_ammo" },
    { 0x48B0, "himar_printer_equipped" },
    { 0x48B1, "himar_printing_ammo_full_check" },
    { 0x48B2, "hinge" },
    { 0x48B3, "hint" },
    { 0x48B4, "hint_abandon_warning_off" },
    { 0x48B5, "hint_allow_hide_time" },
    { 0x48B6, "hint_ar_optics_deactivate_off" },
    { 0x48B7, "hint_breakfunc" },
    { 0x48B8, "hint_button" },
    { 0x48B9, "hint_button_clear" },
    { 0x48BA, "hint_button_clear_fus" },
    { 0x48BB, "hint_button_create" },
    { 0x48BC, "hint_button_create_flashing" },
    { 0x48BD, "hint_button_flash" },
    { 0x48BE, "hint_button_locations" },
    { 0x48BF, "hint_button_melee" },
    { 0x48C0, "hint_button_melee_location" },
    { 0x48C1, "hint_button_position" },
    { 0x48C2, "hint_button_string_lookup" },
    { 0x48C3, "hint_button_string_lookup_fus" },
    { 0x48C4, "hint_button_tag" },
    { 0x48C5, "hint_button_trigger" },
    { 0x48C6, "hint_buttons" },
    { 0x48C7, "hint_concealed_kill_one" },
    { 0x48C8, "hint_cover_mouth_off" },
    { 0x48C9, "hint_create" },
    { 0x48CA, "hint_decoy_exposed_group_off" },
    { 0x48CB, "hint_decoy_off" },
    { 0x48CC, "hint_delete" },
    { 0x48CD, "hint_duration_s" },
    { 0x48CE, "hint_fade" },
    { 0x48CF, "hint_fade_instant" },
    { 0x48D0, "hint_fontscale" },
    { 0x48D1, "hint_grapple_off" },
    { 0x48D2, "hint_hoverbike" },
    { 0x48D3, "hint_instant" },
    { 0x48D4, "hint_knockout_off" },
    { 0x48D5, "hint_list" },
    { 0x48D6, "hint_mark_and_execute_off" },
    { 0x48D7, "hint_mash_button" },
    { 0x48D8, "hint_mech_grab" },
    { 0x48D9, "hint_mech_start" },
    { 0x48DA, "hint_mt_controls" },
    { 0x48DB, "hint_neverbreak" },
    { 0x48DC, "hint_nofadein" },
    { 0x48DD, "hint_position_internal" },
    { 0x48DE, "hint_prone_off" },
    { 0x48DF, "hint_pull_back" },
    { 0x48E0, "hint_push_forward" },
    { 0x48E1, "hint_quick" },
    { 0x48E2, "hint_quickfade" },
    { 0x48E3, "hint_rappel_off" },
    { 0x48E4, "hint_stealth_detection_off" },
    { 0x48E5, "hint_stick_get_updated" },
    { 0x48E6, "hint_stick_update" },
    { 0x48E7, "hint_string_disable_exo_climb" },
    { 0x48E8, "hint_string_disable_exo_door" },
    { 0x48E9, "hint_string_disable_mute_charge" },
    { 0x48EA, "hint_string_disable_place_sensor" },
    { 0x48EB, "hint_tagging_off" },
    { 0x48EC, "hint_text_exo_shield" },
    { 0x48ED, "hint_timeout" },
    { 0x48EE, "hint_triggers" },
    { 0x48EF, "hint_uncover_mouth_off" },
    { 0x48F0, "hint_update_config_change" },
    { 0x48F1, "hint_weap" },
    { 0x48F2, "hint_weap_swarm_hold" },
    { 0x48F3, "hint_weap_swarm_release" },
    { 0x48F4, "hint_with_background" },
    { 0x48F5, "hintatriumviewoff" },
    { 0x48F6, "hintbackground" },
    { 0x48F7, "hintcamerascanoff" },
    { 0x48F8, "hintcamerazoomoff" },
    { 0x48F9, "hintcaralarmoff" },
    { 0x48FA, "hintcourtyardoverwatchoff" },
    { 0x48FB, "hintdetonateambushoff" },
    { 0x48FC, "hintdisplayhandler" },
    { 0x48FD, "hintdisplayhandlersetup" },
    { 0x48FE, "hintdisplayhandlerupdate" },
    { 0x48FF, "hintdisplaymintimehandler" },
    { 0x4900, "hintdronemoveoff" },
    { 0x4901, "hintdroneshootoff" },
    { 0x4902, "hintdroneusetriggeroff" },
    { 0x4903, "hintdronezoomoff" },
    { 0x4904, "hintdropturret" },
    { 0x4905, "hintelem" },
    { 0x4906, "hintelement" },
    { 0x4907, "hintenter" },
    { 0x4908, "hintgrabgunoff" },
    { 0x4909, "hinthadeszoomoff" },
    { 0x490A, "hintleavingareaoff" },
    { 0x490B, "hintlookattruckoff" },
    { 0x490C, "hintmessage" },
    { 0x490D, "hintmutebreachoff" },
    { 0x490E, "hintpickup" },
    { 0x490F, "hintplayerstaboff" },
    { 0x4910, "hintprint" },
    { 0x4911, "hintprintwait" },
    { 0x4912, "hintripoff" },
    { 0x4913, "hintsafehouseexitsonicoff" },
    { 0x4914, "hintscrambleadvanceoff" },
    { 0x4915, "hintscramblesuppress1off" },
    { 0x4916, "hintscramblesuppress2off" },
    { 0x4917, "hintsniperdronemove" },
    { 0x4918, "hintsniperdroneshoot" },
    { 0x4919, "hintsupportalliesoff" },
    { 0x491A, "history" },
    { 0x491B, "history_count" },
    { 0x491C, "history_index" },
    { 0x491D, "hit_bullet_armor" },
    { 0x491E, "hit_enemy_walker_nag" },
    { 0x491F, "hit_ground_pos" },
    { 0x4920, "hit_kva_bus" },
    { 0x4921, "hit_off" },
    { 0x4922, "hit_surface" },
    { 0x4923, "hit_type" },
    { 0x4924, "hit_water" },
    { 0x4925, "hitloc" },
    { 0x4926, "hitlocdebug" },
    { 0x4927, "hitlocinited" },
    { 0x4928, "hitroundlimit" },
    { 0x4929, "hits" },
    { 0x492A, "hits_left" },
    { 0x492B, "hitscorelimit" },
    { 0x492C, "hitsthismag" },
    { 0x492D, "hittankagain" },
    { 0x492E, "hitwinlimit" },
    { 0x492F, "hms_greece_jump_across_164" },
    { 0x4930, "hms_greece_jump_across_192" },
    { 0x4931, "hms_greece_jump_down_96" },
    { 0x4932, "hms_greece_jump_over_32_across_320" },
    { 0x4933, "hms_greece_jump_over_32_across_352" },
    { 0x4934, "hms_greece_jump_over_32_across_400" },
    { 0x4935, "hms_greece_jump_over_32_down_192" },
    { 0x4936, "hms_greece_jump_over_36_down_128" },
    { 0x4937, "hms_greece_jump_over_36_down_164" },
    { 0x4938, "hms_greece_jump_over_36_down_180" },
    { 0x4939, "hms_greece_jump_over_36_down_208" },
    { 0x493A, "hms_greece_jump_over_40_down_88" },
    { 0x493B, "hms_greece_window_dive" },
    { 0x493C, "hms_greece_window_over_40" },
    { 0x493D, "hold_count" },
    { 0x493E, "hold_count_check" },
    { 0x493F, "hold_frames" },
    { 0x4940, "hold_indefintely" },
    { 0x4941, "holdingbreath" },
    { 0x4942, "holdingleavebutton" },
    { 0x4943, "hologram_guys" },
    { 0x4944, "hologram_rand_level" },
    { 0x4945, "holt" },
    { 0x4946, "homing_delay_max" },
    { 0x4947, "homing_delay_min" },
    { 0x4948, "honking" },
    { 0x4949, "horde_collect_count" },
    { 0x494A, "horde_defend_killcount" },
    { 0x494B, "horde_defuse_count" },
    { 0x494C, "horde_drone_flying_fx" },
    { 0x494D, "horde_drops" },
    { 0x494E, "horde_perks" },
    { 0x494F, "horde_type" },
    { 0x4950, "hordeabilityregenbar" },
    { 0x4951, "hordeaddcompaniondrone" },
    { 0x4952, "hordeaddexoshield" },
    { 0x4953, "hordeaddexplosivedeath" },
    { 0x4954, "hordeaddgeneraltuningvalues" },
    { 0x4955, "hordeaddnavigationabilities" },
    { 0x4956, "hordeaddtoxicgas" },
    { 0x4957, "hordeaddtoxicgascleanup" },
    { 0x4958, "hordeaddtoxicgasthink" },
    { 0x4959, "hordeallowallboost" },
    { 0x495A, "hordeammofull" },
    { 0x495B, "hordeapplyaimodifiers" },
    { 0x495C, "hordeapplyaimodifiersdiceroll" },
    { 0x495D, "hordearmor" },
    { 0x495E, "hordearmories" },
    { 0x495F, "hordearmoryemptimeout" },
    { 0x4960, "hordeattachminigunbarrel" },
    { 0x4961, "hordeautoassign" },
    { 0x4962, "hordebatterylevel" },
    { 0x4963, "hordebombs" },
    { 0x4964, "hordecheckobjectivefailure" },
    { 0x4965, "hordeclassendtime" },
    { 0x4966, "hordeclassic" },
    { 0x4967, "hordeclassrunfirstspawn" },
    { 0x4968, "hordeclassstarttime" },
    { 0x4969, "hordeclassturret" },
    { 0x496A, "hordeclassweapons" },
    { 0x496B, "hordecollectcancel" },
    { 0x496C, "hordecollected" },
    { 0x496D, "hordecollectlocs" },
    { 0x496E, "hordecratethink" },
    { 0x496F, "hordecreatedrone" },
    { 0x4970, "hordedamagescale" },
    { 0x4971, "hordedefendcancel" },
    { 0x4972, "hordedefendenemyoutline" },
    { 0x4973, "hordedefendlocs" },
    { 0x4974, "hordedefusecancel" },
    { 0x4975, "hordedefused" },
    { 0x4976, "hordedefuselocs" },
    { 0x4977, "hordedefuseobjects" },
    { 0x4978, "hordedefuseonbeginuse" },
    { 0x4979, "hordedefuseonenduse" },
    { 0x497A, "hordedialog" },
    { 0x497B, "hordedialoginit" },
    { 0x497C, "hordedifficultylevel" },
    { 0x497D, "hordedisablearmories" },
    { 0x497E, "hordednaexplosion" },
    { 0x497F, "hordedoginwater" },
    { 0x4980, "hordedogtype" },
    { 0x4981, "hordedome" },
    { 0x4982, "hordedrone" },
    { 0x4983, "hordedrone_handledamage" },
    { 0x4984, "hordedrone_watchdeath" },
    { 0x4985, "hordedronedestroyed" },
    { 0x4986, "hordedronemodel" },
    { 0x4987, "hordedroneshoot" },
    { 0x4988, "hordedronespawns" },
    { 0x4989, "hordedroneturret_handledamagecallback" },
    { 0x498A, "hordedroneturret_setupdamagecallback" },
    { 0x498B, "hordedronetype" },
    { 0x498C, "hordedroplocations" },
    { 0x498D, "hordedroplocationtrace" },
    { 0x498E, "hordeempduration" },
    { 0x498F, "hordeenableweapons" },
    { 0x4990, "hordeendgame" },
    { 0x4991, "hordeenemykilled" },
    { 0x4992, "hordeexobattery" },
    { 0x4993, "hordefadeinblackout" },
    { 0x4994, "hordefadeoutblackout" },
    { 0x4995, "hordegetattachmentstring" },
    { 0x4996, "hordegetclosesthealthyenemy" },
    { 0x4997, "hordegetclosesthealthyplayer" },
    { 0x4998, "hordegetdronespawn" },
    { 0x4999, "hordegetenemyloadout" },
    { 0x499A, "hordegetmapindex" },
    { 0x499B, "hordegetoutsideposition" },
    { 0x499C, "hordegetstartingroundnum" },
    { 0x499D, "hordegetweaponupgrades" },
    { 0x499E, "hordegiveability" },
    { 0x499F, "hordegiveclassweapons" },
    { 0x49A0, "hordegivekillstreak" },
    { 0x49A1, "hordegiveperk" },
    { 0x49A2, "hordegivescorestreakupgrade" },
    { 0x49A3, "hordeheadshots" },
    { 0x49A4, "hordehideroundstats" },
    { 0x49A5, "hordeicon" },
    { 0x49A6, "hordeinitdefuseobjects" },
    { 0x49A7, "hordeintelcancel" },
    { 0x49A8, "hordeintermissionclearcountdown" },
    { 0x49A9, "hordeintermissionfinalcountdown" },
    { 0x49AA, "hordeisarmoryupgrade" },
    { 0x49AB, "hordeishardcore" },
    { 0x49AC, "hordekillstreakmodules" },
    { 0x49AD, "hordeleaderdialogallplayers" },
    { 0x49AE, "hordelevelflip" },
    { 0x49AF, "hordeloadouts" },
    { 0x49B0, "hordeloadwaveweapons" },
    { 0x49B1, "hordemodedodgers" },
    { 0x49B2, "hordemodeelites" },
    { 0x49B3, "hordemodegrunts" },
    { 0x49B4, "hordemodespecials" },
    { 0x49B5, "hordemonitorclassability" },
    { 0x49B6, "hordemonitordoubletap" },
    { 0x49B7, "hordemonitorplayersready" },
    { 0x49B8, "hordenumroundscompleted" },
    { 0x49B9, "hordeobjectiveindex" },
    { 0x49BA, "hordeobjectiveorder" },
    { 0x49BB, "hordeobjectivesuccess" },
    { 0x49BC, "hordeonusedefuseobject" },
    { 0x49BD, "hordeplayerdefusing" },
    { 0x49BE, "hordepreviousfailureevent" },
    { 0x49BF, "horderandomizeaimodifiertypes" },
    { 0x49C0, "horderemoveksicon" },
    { 0x49C1, "horderesetarmory" },
    { 0x49C2, "hordereturnrandomaitypes" },
    { 0x49C3, "horderoundintermission" },
    { 0x49C4, "horderoundstats" },
    { 0x49C5, "hordescore" },
    { 0x49C6, "hordescorestreaksplash" },
    { 0x49C7, "hordesentryarray" },
    { 0x49C8, "hordesentryinit" },
    { 0x49C9, "hordesentryspawns" },
    { 0x49CA, "hordesetcharactermodel" },
    { 0x49CB, "hordesetprevioushighestwave" },
    { 0x49CC, "hordesetupdogstate" },
    { 0x49CD, "hordesetzombiemodel" },
    { 0x49CE, "hordeshouldupgradefail" },
    { 0x49CF, "hordespawndroneturret" },
    { 0x49D0, "hordespawnenemyturret" },
    { 0x49D1, "hordestartinground" },
    { 0x49D2, "hordestartzombieoutro" },
    { 0x49D3, "hordetriggeroff" },
    { 0x49D4, "hordetriggeron" },
    { 0x49D5, "hordeturret_handledamagecallback" },
    { 0x49D6, "hordeturret_handledeath" },
    { 0x49D7, "hordeturret_setactive" },
    { 0x49D8, "hordeturret_setinactive" },
    { 0x49D9, "hordeturret_setupdamagecallback" },
    { 0x49DA, "hordeturretpicktarget" },
    { 0x49DB, "hordeturretshoot" },
    { 0x49DC, "hordeupdatemapperformance" },
    { 0x49DD, "hordeupdateroundstats" },
    { 0x49DE, "hordeupdatescore" },
    { 0x49DF, "hordeuseddroplocations" },
    { 0x49E0, "hordevolaststand" },
    { 0x49E1, "hordevomissionfail" },
    { 0x49E2, "hordevoroundstart" },
    { 0x49E3, "hordewaitforturretdeath" },
    { 0x49E4, "hordewaveadjust" },
    { 0x49E5, "hordewaveweapons" },
    { 0x49E6, "hordeweaponlevel" },
    { 0x49E7, "hordeweaponsjammed" },
    { 0x49E8, "hordezombiechasesounds" },
    { 0x49E9, "hordezombiedeathsounds" },
    { 0x49EA, "hordezombiepainsounds" },
    { 0x49EB, "hordezombieplaypainsound" },
    { 0x49EC, "hordezombiesounds" },
    { 0x49ED, "horiz_speed_calc" },
    { 0x49EE, "horizontal_cone_range" },
    { 0x49EF, "horizontaloffsetlook" },
    { 0x49F0, "horizontaloffsetstrafe" },
    { 0x49F1, "horror_burk_opens_bodies_room_door" },
    { 0x49F2, "horror_burk_opens_bodies_room_door_mus" },
    { 0x49F3, "horror_burk_opens_bodies_room_door_sfx" },
    { 0x49F4, "horror_burke_gets_up_after_tile" },
    { 0x49F5, "horror_fluorescent_break" },
    { 0x49F6, "horror_ghost_runs_by_door" },
    { 0x49F7, "horz" },
    { 0x49F8, "hospital_barrel_swap_physics" },
    { 0x49F9, "hospital_breach_dof" },
    { 0x49FA, "hospital_breach_gun_away" },
    { 0x49FB, "hospital_breach_prep_dialogue" },
    { 0x49FC, "hospital_breach_punch" },
    { 0x49FD, "hospital_capture_dialogue" },
    { 0x49FE, "hospital_desk_door_open" },
    { 0x49FF, "hospital_dialogue" },
    { 0x4A00, "hospital_entry_dialogue" },
    { 0x4A01, "hospital_escape_door_function" },
    { 0x4A02, "hospital_flashbang1" },
    { 0x4A03, "hospital_flashbang2" },
    { 0x4A04, "hospital_flashbang3" },
    { 0x4A05, "hospital_flicker_lights" },
    { 0x4A06, "hospital_kva_cleanup" },
    { 0x4A07, "hospital_main" },
    { 0x4A08, "hospital_post_breach_01" },
    { 0x4A09, "hospital_post_breach_02" },
    { 0x4A0A, "hospital_post_breach_03" },
    { 0x4A0B, "hospital_post_breach_04" },
    { 0x4A0C, "hospital_post_breach_05" },
    { 0x4A0D, "hospital_slowmo_start" },
    { 0x4A0E, "hospital_stairs_autosave" },
    { 0x4A0F, "hospitalroofguys" },
    { 0x4A10, "hostage_1" },
    { 0x4A11, "hostage_drowned_bubble_trails" },
    { 0x4A12, "hostage_health_regen" },
    { 0x4A13, "hostage_mission_fail" },
    { 0x4A14, "hostage_rescued_bubble_trails" },
    { 0x4A15, "hostage_truck" },
    { 0x4A16, "hostage_truck_anim_single_break_when_timeout_or_fail" },
    { 0x4A17, "hostage_truck_failure" },
    { 0x4A18, "hostage_truck_freeway_by" },
    { 0x4A19, "hostage_truck_fwy_notetrack_setup" },
    { 0x4A1A, "hostage_truck_gameover" },
    { 0x4A1B, "hostage_truck_oncoming" },
    { 0x4A1C, "hostage_truck_scripted_descent" },
    { 0x4A1D, "hostage_truck_slomo_end" },
    { 0x4A1E, "hostage_truck_slomo_end_notetrack" },
    { 0x4A1F, "hostage_truck_slomo_end_pt2" },
    { 0x4A20, "hostage_truck_slomo_start" },
    { 0x4A21, "hostage_truck_slomo_start_pt1" },
    { 0x4A22, "hostage_truck_slomo_start_pt2" },
    { 0x4A23, "hostage_truck_slomo_start_pt3" },
    { 0x4A24, "hostage_truck_slomo_start_pt4" },
    { 0x4A25, "hostage_truck_swimming_drowning_monitor" },
    { 0x4A26, "hostage_truck_viewmodel_swap" },
    { 0x4A27, "hostagebeatup" },
    { 0x4A28, "hostageclearmarklocktext" },
    { 0x4A29, "hostagecorner" },
    { 0x4A2A, "hostagedeathdetection" },
    { 0x4A2B, "hostageexecution" },
    { 0x4A2C, "hostageexecutiondeath" },
    { 0x4A2D, "hostageexecutionseq" },
    { 0x4A2E, "hostageexecutionseqvfx" },
    { 0x4A2F, "hostagelocktargetstext" },
    { 0x4A30, "hostagemanhandle" },
    { 0x4A31, "hostagemarktargetstext" },
    { 0x4A32, "hostagepm" },
    { 0x4A33, "hostages" },
    { 0x4A34, "hostforcedend" },
    { 0x4A35, "hostidledout" },
    { 0x4A36, "hostile_pose" },
    { 0x4A37, "hostilemodel" },
    { 0x4A38, "hostilesspawned" },
    { 0x4A39, "hostmigrationcontrolsfrozen" },
    { 0x4A3A, "hostmigrationname" },
    { 0x4A3B, "hostmigrationreturnedplayercount" },
    { 0x4A3C, "hostmigrationtimer" },
    { 0x4A3D, "hostmigrationtimerthink" },
    { 0x4A3E, "hostmigrationtimerthink_internal" },
    { 0x4A3F, "hostmigrationwait" },
    { 0x4A40, "hostmigrationwaitforplayers" },
    { 0x4A41, "hostname" },
    { 0x4A42, "hostpital_breach_start" },
    { 0x4A43, "hotel_civ_04_death" },
    { 0x4A44, "hotel_crowd_panic_trigger" },
    { 0x4A45, "hotel_crowd_panic_walla" },
    { 0x4A46, "hotel_crowd_panic_walla_chkpt" },
    { 0x4A47, "hotel_female_01_hallway" },
    { 0x4A48, "hotel_glass_footstep_think" },
    { 0x4A49, "hotel_lobby_fire_lighting" },
    { 0x4A4A, "hotel_razorback_approach" },
    { 0x4A4B, "hotel_razorback_fly_by" },
    { 0x4A4C, "hotel_wake_think" },
    { 0x4A4D, "hotel_windows_explode" },
    { 0x4A4E, "hover_hint_breakout" },
    { 0x4A4F, "hover_tank_immobilize" },
    { 0x4A50, "hover_tank_immobilize_rockets" },
    { 0x4A51, "hover_tank_startup_sequence" },
    { 0x4A52, "hoverbike_exit_prompt" },
    { 0x4A53, "hoverbike_meet_up_mech1" },
    { 0x4A54, "hoverbike_ride_in_autorumble" },
    { 0x4A55, "hoverbike_rumble" },
    { 0x4A56, "hoverbike_smk_push_garage" },
    { 0x4A57, "hoverbounceconeangle" },
    { 0x4A58, "hoverlp" },
    { 0x4A59, "hoverscreen_chromo_anim" },
    { 0x4A5A, "hoverscreen_chromo_anim_turnoff" },
    { 0x4A5B, "hoverscreen_chromo_anim2" },
    { 0x4A5C, "hoverscreen_damage_fx" },
    { 0x4A5D, "hoverscreen_hit" },
    { 0x4A5E, "hoverscreen_restore" },
    { 0x4A5F, "hoverscreen_reveal" },
    { 0x4A60, "hoverscreen_turnoff" },
    { 0x4A61, "hoverscreen_turnoff_movie" },
    { 0x4A62, "hoverscreen_turnon_movie" },
    { 0x4A63, "hoverspeed" },
    { 0x4A64, "hovertank" },
    { 0x4A65, "hovertank_aimed_enemy_ai_weapon_hint" },
    { 0x4A66, "hovertank_aimed_enemy_vehicle_weapon_hint" },
    { 0x4A67, "hovertank_aimed_enemy_weapon_hint" },
    { 0x4A68, "hovertank_antiair_fire" },
    { 0x4A69, "hovertank_antiair_recoil" },
    { 0x4A6A, "hovertank_ascent_final_enemies" },
    { 0x4A6B, "hovertank_audio" },
    { 0x4A6C, "hovertank_barrel_turn" },
    { 0x4A6D, "hovertank_cannon_fire" },
    { 0x4A6E, "hovertank_cannon_hint_off" },
    { 0x4A6F, "hovertank_cannon_reload_hint" },
    { 0x4A70, "hovertank_checkpoint_logic" },
    { 0x4A71, "hovertank_combat_cleanup" },
    { 0x4A72, "hovertank_combat_clearing_choppers_1" },
    { 0x4A73, "hovertank_combat_clearing_choppers_3" },
    { 0x4A74, "hovertank_combat_global_enemy_think" },
    { 0x4A75, "hovertank_combat_road_log_scene" },
    { 0x4A76, "hovertank_constructor" },
    { 0x4A77, "hovertank_control_panel" },
    { 0x4A78, "hovertank_defend_combat" },
    { 0x4A79, "hovertank_defend_setup" },
    { 0x4A7A, "hovertank_destroy_hint_data" },
    { 0x4A7B, "hovertank_emp_hint_off" },
    { 0x4A7C, "hovertank_enemy_outline" },
    { 0x4A7D, "hovertank_enemy_outline_ai" },
    { 0x4A7E, "hovertank_enemy_outline_offset" },
    { 0x4A7F, "hovertank_enemy_outline_vehicle" },
    { 0x4A80, "hovertank_enter" },
    { 0x4A81, "hovertank_exterior_model" },
    { 0x4A82, "hovertank_fx" },
    { 0x4A83, "hovertank_hint_ai_in_sights" },
    { 0x4A84, "hovertank_hint_enemy_kill_tracking" },
    { 0x4A85, "hovertank_hint_reset_flag" },
    { 0x4A86, "hovertank_hint_stop" },
    { 0x4A87, "hovertank_hint_vehicle_in_sights" },
    { 0x4A88, "hovertank_hud_data_fontscale" },
    { 0x4A89, "hovertank_hud_init" },
    { 0x4A8A, "hovertank_hud_misc_fontscale" },
    { 0x4A8B, "hovertank_hud_mode_fontscale" },
    { 0x4A8C, "hovertank_hud_weapon_fontscale" },
    { 0x4A8D, "hovertank_init" },
    { 0x4A8E, "hovertank_missile_hint_off" },
    { 0x4A8F, "hovertank_missile_small_slow" },
    { 0x4A90, "hovertank_missile_small_start" },
    { 0x4A91, "hovertank_missile_small_stop" },
    { 0x4A92, "hovertank_monitor_status" },
    { 0x4A93, "hovertank_physics" },
    { 0x4A94, "hovertank_player" },
    { 0x4A95, "hovertank_projectile_callback" },
    { 0x4A96, "hovertank_ride" },
    { 0x4A97, "hovertank_ride_anims" },
    { 0x4A98, "hovertank_rumble" },
    { 0x4A99, "hovertank_rumble_stop" },
    { 0x4A9A, "hovertank_setup_hint_data" },
    { 0x4A9B, "hovertank_swap_model" },
    { 0x4A9C, "hovertank_switch_to_cannon" },
    { 0x4A9D, "hovertank_switch_to_emp" },
    { 0x4A9E, "hovertank_switch_to_missile" },
    { 0x4A9F, "hovertank_trophy_system" },
    { 0x4AA0, "hovertank_turrent_light" },
    { 0x4AA1, "hovertank_turrent_reflection" },
    { 0x4AA2, "hovertank_turret" },
    { 0x4AA3, "hovertank_weapon" },
    { 0x4AA4, "hovertank_weapon_hint" },
    { 0x4AA5, "hovertank_weapon_hint_data" },
    { 0x4AA6, "hoverweapon" },
    { 0x4AA7, "hp" },
    { 0x4AA8, "hp_pause_for_dynamic_event" },
    { 0x4AA9, "hpcapteam" },
    { 0x4AAA, "hpcaptureloop" },
    { 0x4AAB, "hpstarttime" },
    { 0x4AAC, "hpupdateuserate" },
    { 0x4AAD, "ht_cannon_reload" },
    { 0x4AAE, "ht_condition_callback_to_state_destruct" },
    { 0x4AAF, "ht_condition_callback_to_state_idle" },
    { 0x4AB0, "ht_condition_callback_to_state_moving" },
    { 0x4AB1, "ht_condition_callback_to_state_off" },
    { 0x4AB2, "ht_turret_condition_callback_to_state_destruct" },
    { 0x4AB3, "ht_turret_condition_callback_to_state_off" },
    { 0x4AB4, "ht_turret_condition_callback_to_state_rotating" },
    { 0x4AB5, "ht_turret_condition_callback_to_state_stationary" },
    { 0x4AB6, "hud" },
    { 0x4AB7, "hud_allies" },
    { 0x4AB8, "hud_alpha" },
    { 0x4AB9, "hud_blink_current_weapon_name" },
    { 0x4ABA, "hud_damagefeedback" },
    { 0x4ABB, "hud_damagefeedback_headshot" },
    { 0x4ABC, "hud_debug_add" },
    { 0x4ABD, "hud_debug_add_display" },
    { 0x4ABE, "hud_debug_add_frac" },
    { 0x4ABF, "hud_debug_add_message" },
    { 0x4AC0, "hud_debug_add_num" },
    { 0x4AC1, "hud_debug_add_second_string" },
    { 0x4AC2, "hud_debug_add_string" },
    { 0x4AC3, "hud_debug_clear" },
    { 0x4AC4, "hud_destroy" },
    { 0x4AC5, "hud_elem" },
    { 0x4AC6, "hud_elem_update_distance" },
    { 0x4AC7, "hud_end" },
    { 0x4AC8, "hud_execute" },
    { 0x4AC9, "hud_init" },
    { 0x4ACA, "hud_malfunction" },
    { 0x4ACB, "hud_mantle" },
    { 0x4ACC, "hud_mark" },
    { 0x4ACD, "hud_missile_target" },
    { 0x4ACE, "hud_off" },
    { 0x4ACF, "hud_offset" },
    { 0x4AD0, "hud_on" },
    { 0x4AD1, "hud_outlineenable" },
    { 0x4AD2, "hud_params" },
    { 0x4AD3, "hud_precache" },
    { 0x4AD4, "hud_scubamask" },
    { 0x4AD5, "hud_scubamask_model" },
    { 0x4AD6, "hud_set_invisible" },
    { 0x4AD7, "hud_set_visible" },
    { 0x4AD8, "hud_start" },
    { 0x4AD9, "hud_target_think" },
    { 0x4ADA, "hud_targets" },
    { 0x4ADB, "hud_text" },
    { 0x4ADC, "hud_update_fire_text" },
    { 0x4ADD, "hud_value" },
    { 0x4ADE, "hud_warning" },
    { 0x4ADF, "hud_watch_for_boost_active" },
    { 0x4AE0, "hudalerttimer" },
    { 0x4AE1, "huddata" },
    { 0x4AE2, "huddebugnum" },
    { 0x4AE3, "huddownspace" },
    { 0x4AE4, "hudelem_count" },
    { 0x4AE5, "hudelem_destroy" },
    { 0x4AE6, "hudelem_lagos_heart_rate" },
    { 0x4AE7, "hudelem_lagos_heart_rate_bpm" },
    { 0x4AE8, "hudelem_lagos_heart_rate_bpmvar" },
    { 0x4AE9, "hudelem_x" },
    { 0x4AEA, "hudelem_y" },
    { 0x4AEB, "hudelements" },
    { 0x4AEC, "hudelems" },
    { 0x4AED, "hudgo" },
    { 0x4AEE, "hudinit" },
    { 0x4AEF, "huditem" },
    { 0x4AF0, "hudleftspace" },
    { 0x4AF1, "hudmsgshare" },
    { 0x4AF2, "hudnum" },
    { 0x4AF3, "hudoutline_blink" },
    { 0x4AF4, "hudoutline_conf_intensity" },
    { 0x4AF5, "hudoutline_dvars_reset" },
    { 0x4AF6, "hudoutline_dvars_set" },
    { 0x4AF7, "hudoutline_spawner_all" },
    { 0x4AF8, "hudoutline_spawner_think" },
    { 0x4AF9, "hudoutline_think" },
    { 0x4AFA, "hudoutline_toggle_all" },
    { 0x4AFB, "hudoutline_toggle_target" },
    { 0x4AFC, "hudoutline_wait_death" },
    { 0x4AFD, "hudoutlinedvars" },
    { 0x4AFE, "hudoutlineenabledbysonarvision" },
    { 0x4AFF, "huds" },
    { 0x4B00, "hudsetpoint_func" },
    { 0x4B01, "hudtimerindex" },
    { 0x4B02, "hudtweaks" },
    { 0x4B03, "human_anims" },
    { 0x4B04, "human_traverse" },
    { 0x4B05, "human_traverse_kill" },
    { 0x4B06, "humans" },
    { 0x4B07, "humvee_antenna_animates" },
    { 0x4B08, "humvee_antenna_animates_until_death" },
    { 0x4B09, "humvee_org" },
    { 0x4B0A, "humvee_turret_init" },
    { 0x4B0B, "hunt_human" },
    { 0x4B0C, "hunted_style_door_open" },
    { 0x4B0D, "hunterkiller" },
    { 0x4B0E, "hurtagain" },
    { 0x4B0F, "hurtplayersthink" },
    { 0x4B10, "i_am_hit_engage" },
    { 0x4B11, "i_have_seen_the_player" },
    { 0x4B12, "ialliesatgate" },
    { 0x4B13, "ic_underwater_visionset_change" },
    { 0x4B14, "ice_axe" },
    { 0x4B15, "ice_axe_delete_special" },
    { 0x4B16, "ice_bridge_goons" },
    { 0x4B17, "ice_bridge_kill_fall" },
    { 0x4B18, "ice_caves_02_sets" },
    { 0x4B19, "ice_caves_02_trigger" },
    { 0x4B1A, "ice_caves_03_sets" },
    { 0x4B1B, "ice_caves_03_trigger" },
    { 0x4B1C, "ice_lake_chopper" },
    { 0x4B1D, "ice_lake_cinema_heli" },
    { 0x4B1E, "ice_lake_clear" },
    { 0x4B1F, "ice_lake_kill" },
    { 0x4B20, "ice_lake_wakeup" },
    { 0x4B21, "ice_lake_wakeup_noreaction" },
    { 0x4B22, "ice_lake_wakeup_play_reaction" },
    { 0x4B23, "ice_lake_wakeup_reaction" },
    { 0x4B24, "ice_lake_wave_0" },
    { 0x4B25, "ice_lake_wave_0_amb" },
    { 0x4B26, "ice_lake_wave_0_crate" },
    { 0x4B27, "ice_lake_wave_0_patrol" },
    { 0x4B28, "ice_lake_wave_1" },
    { 0x4B29, "ice_lake_wave_2" },
    { 0x4B2A, "ice_lake_wave_3" },
    { 0x4B2B, "ice_overlook_sets" },
    { 0x4B2C, "icon_always_show" },
    { 0x4B2D, "icon_col" },
    { 0x4B2E, "icon_trigger_setup" },
    { 0x4B2F, "iconatbaseblue" },
    { 0x4B30, "iconatbasered" },
    { 0x4B31, "iconawayblue" },
    { 0x4B32, "iconawayred" },
    { 0x4B33, "iconbluespectator" },
    { 0x4B34, "iconcapture2d" },
    { 0x4B35, "iconcapture3d" },
    { 0x4B36, "iconcaptureflag2d" },
    { 0x4B37, "iconcaptureflag3d" },
    { 0x4B38, "iconcontested2d" },
    { 0x4B39, "iconcontested3d" },
    { 0x4B3A, "iconcontestedspectator" },
    { 0x4B3B, "icondefend2d" },
    { 0x4B3C, "icondefend3d" },
    { 0x4B3D, "icondefendflag2d" },
    { 0x4B3E, "icondefendflag3d" },
    { 0x4B3F, "icondroppedblue" },
    { 0x4B40, "icondroppedred" },
    { 0x4B41, "iconelem" },
    { 0x4B42, "iconelem2" },
    { 0x4B43, "iconelem3" },
    { 0x4B44, "iconents" },
    { 0x4B45, "iconescort2d" },
    { 0x4B46, "iconescort3d" },
    { 0x4B47, "iconkill2d" },
    { 0x4B48, "iconkill3d" },
    { 0x4B49, "iconmissingblue" },
    { 0x4B4A, "iconmissingred" },
    { 0x4B4B, "iconname" },
    { 0x4B4C, "iconneutral2d" },
    { 0x4B4D, "iconneutral3d" },
    { 0x4B4E, "iconneutralspectator" },
    { 0x4B4F, "iconoverlay" },
    { 0x4B50, "iconredspectator" },
    { 0x4B51, "iconreturnflag2d" },
    { 0x4B52, "iconreturnflag3d" },
    { 0x4B53, "icons" },
    { 0x4B54, "iconwaitforflag2d" },
    { 0x4B55, "iconwaitforflag3d" },
    { 0x4B56, "id" },
    { 0x4B57, "idamage" },
    { 0x4B58, "identify_and_play_anim" },
    { 0x4B59, "idflags" },
    { 0x4B5A, "idflags_no_armor" },
    { 0x4B5B, "idflags_no_knockback" },
    { 0x4B5C, "idflags_no_protection" },
    { 0x4B5D, "idflags_no_team_protection" },
    { 0x4B5E, "idflags_passthru" },
    { 0x4B5F, "idflags_penetration" },
    { 0x4B60, "idflags_radius" },
    { 0x4B61, "idflags_shield_explosive_impact" },
    { 0x4B62, "idflags_shield_explosive_impact_huge" },
    { 0x4B63, "idflags_shield_explosive_splash" },
    { 0x4B64, "idflags_stun" },
    { 0x4B65, "idflagstime" },
    { 0x4B66, "idle" },
    { 0x4B67, "idle_alert" },
    { 0x4B68, "idle_alert_to_casual" },
    { 0x4B69, "idle_anim" },
    { 0x4B6A, "idle_anim_update" },
    { 0x4B6B, "idle_animation_list_func" },
    { 0x4B6C, "idle_animations" },
    { 0x4B6D, "idle_animstop" },
    { 0x4B6E, "idle_ent" },
    { 0x4B6F, "idle_hardleft" },
    { 0x4B70, "idle_hardright" },
    { 0x4B71, "idle_look_down_limit_mag" },
    { 0x4B72, "idle_look_sideways_limit_mag" },
    { 0x4B73, "idle_look_up_limit_mag" },
    { 0x4B74, "idle_lp" },
    { 0x4B75, "idle_main" },
    { 0x4B76, "idle_on_reach" },
    { 0x4B77, "idle_org" },
    { 0x4B78, "idle_proc" },
    { 0x4B79, "idle_proc_func" },
    { 0x4B7A, "idle_reach_node" },
    { 0x4B7B, "idle_scene_ents" },
    { 0x4B7C, "idleanim" },
    { 0x4B7D, "idleanimtype" },
    { 0x4B7E, "idledown" },
    { 0x4B7F, "idleface" },
    { 0x4B80, "idlelookattargets" },
    { 0x4B81, "idleoccurrence" },
    { 0x4B82, "idlepoint" },
    { 0x4B83, "idlepointreached" },
    { 0x4B84, "idleset" },
    { 0x4B85, "idlesound" },
    { 0x4B86, "idlesound_waitfordoneordeath" },
    { 0x4B87, "idlesoundorigin" },
    { 0x4B88, "idletargetmover" },
    { 0x4B89, "idletargetmoverexplosive" },
    { 0x4B8A, "idlethread" },
    { 0x4B8B, "idletrackloop" },
    { 0x4B8C, "idleup" },
    { 0x4B8D, "idlewait" },
    { 0x4B8E, "idlewaitabit" },
    { 0x4B8F, "idlingatcover" },
    { 0x4B90, "ie_briefing_start_cormack" },
    { 0x4B91, "ie_briefing_start_cormack_2" },
    { 0x4B92, "ie_briefing_start_ilona" },
    { 0x4B93, "ie_car_ride" },
    { 0x4B94, "ie_hangar_irons" },
    { 0x4B95, "ie_hangar_kva" },
    { 0x4B96, "ie_intro_cormack" },
    { 0x4B97, "ie_poolhouse_civilian_vignettes" },
    { 0x4B98, "ie_west_civilian_vignettes" },
    { 0x4B99, "ie_west_deterrent_drones" },
    { 0x4B9A, "ie_west_drones" },
    { 0x4B9B, "ie_west_enemies" },
    { 0x4B9C, "ie_west_spawner_setup" },
    { 0x4B9D, "iexplodernum" },
    { 0x4B9E, "if_array_choose_random_target" },
    { 0x4B9F, "if_the_boat_is_a_rockin_dont_come_a_knockin" },
    { 0x4BA0, "iflashfuse" },
    { 0x4BA1, "ignite_tanker_spurt" },
    { 0x4BA2, "ignore_all_until_path_end" },
    { 0x4BA3, "ignore_badplace" },
    { 0x4BA4, "ignore_death_fx" },
    { 0x4BA5, "ignore_everything" },
    { 0x4BA6, "ignore_fade_notetrack" },
    { 0x4BA7, "ignore_friendlies" },
    { 0x4BA8, "ignore_me_till_goal" },
    { 0x4BA9, "ignore_me_timer" },
    { 0x4BAA, "ignore_me_timer_prev_value" },
    { 0x4BAB, "ignore_player_intro" },
    { 0x4BAC, "ignore_suppression_trigger_ai_think" },
    { 0x4BAD, "ignore_suppression_trigger_think" },
    { 0x4BAE, "ignore_target" },
    { 0x4BAF, "ignore_triggers" },
    { 0x4BB0, "ignore_until_goal_reached" },
    { 0x4BB1, "ignore_until_timeout" },
    { 0x4BB2, "ignore_until_unloaded" },
    { 0x4BB3, "ignoreallenemies" },
    { 0x4BB4, "ignorecollision" },
    { 0x4BB5, "ignored_by_attack_heli" },
    { 0x4BB6, "ignoreeachother" },
    { 0x4BB7, "ignoregrenadesafetime" },
    { 0x4BB8, "ignoreme_for_x" },
    { 0x4BB9, "ignoreorigin" },
    { 0x4BBA, "ignorepathchange" },
    { 0x4BBB, "ignorerandombulletdamage_drone_proc" },
    { 0x4BBC, "ignoreregendelay" },
    { 0x4BBD, "ignoresightpos" },
    { 0x4BBE, "ignoresonicaoe" },
    { 0x4BBF, "ignorewash" },
    { 0x4BC0, "ignreall" },
    { 0x4BC1, "ilana" },
    { 0x4BC2, "ilana_break_wall" },
    { 0x4BC3, "ilana_dock_advance_count" },
    { 0x4BC4, "ilana_glass_impact" },
    { 0x4BC5, "ilana_hall_handler" },
    { 0x4BC6, "ilana_keeps_up" },
    { 0x4BC7, "ilana_lake_callout_cargo" },
    { 0x4BC8, "ilana_lake_callout_cave" },
    { 0x4BC9, "ilana_lake_callout_goliath" },
    { 0x4BCA, "ilana_lake_callout_left" },
    { 0x4BCB, "ilana_lake_callout_right" },
    { 0x4BCC, "ilana_lake_callout_shot" },
    { 0x4BCD, "ilana_narrow_cave_search" },
    { 0x4BCE, "ilana_narrow_cave_start" },
    { 0x4BCF, "ilana_pick_up_gun" },
    { 0x4BD0, "ilana_swimming_bubbles" },
    { 0x4BD1, "ilana_turkey_shoot" },
    { 0x4BD2, "ilana_vo_org" },
    { 0x4BD3, "ilana_water_impact" },
    { 0x4BD4, "ilanaalleybehavior" },
    { 0x4BD5, "ilanaalleytransbehavior" },
    { 0x4BD6, "ilanaanims" },
    { 0x4BD7, "ilanaendingambush" },
    { 0x4BD8, "ilanaendinganimations" },
    { 0x4BD9, "ilanaendingfight" },
    { 0x4BDA, "ilanaendinghades" },
    { 0x4BDB, "ilanaendingmovement" },
    { 0x4BDC, "ilanahitcarfx" },
    { 0x4BDD, "ilanahitwallfx" },
    { 0x4BDE, "ilanaleapfrogadjustgoal" },
    { 0x4BDF, "ilanaleapfroggetgoal" },
    { 0x4BE0, "ilanamovetruck" },
    { 0x4BE1, "ilanasafehouseanimations" },
    { 0x4BE2, "ilanascrambleanimations" },
    { 0x4BE3, "ilanascrambledrones" },
    { 0x4BE4, "ilanascramblefinale" },
    { 0x4BE5, "ilanascramblefinalemoveandsuppress" },
    { 0x4BE6, "ilanascramblehotel" },
    { 0x4BE7, "ilanascrambleinit" },
    { 0x4BE8, "ilanascrambleintro" },
    { 0x4BE9, "ilanascramblemovement" },
    { 0x4BEA, "ilanascrambleopenstartdoor" },
    { 0x4BEB, "ilanasetupmovetruck" },
    { 0x4BEC, "ilanasmokescreen" },
    { 0x4BED, "ilanastabbedfx" },
    { 0x4BEE, "ilanastabbedtakeoutfx" },
    { 0x4BEF, "ilanasuppresspos" },
    { 0x4BF0, "ilanathroatslashfx" },
    { 0x4BF1, "ilanatogglesnipersuppression" },
    { 0x4BF2, "ilanaturn2exit" },
    { 0x4BF3, "iln_dragged_away" },
    { 0x4BF4, "iln_flip_over" },
    { 0x4BF5, "iln_get_up" },
    { 0x4BF6, "iln_kneel_down" },
    { 0x4BF7, "iln_sprint_to_knox" },
    { 0x4BF8, "ilona" },
    { 0x4BF9, "ilona_can_turn" },
    { 0x4BFA, "ilona_cannot_turn" },
    { 0x4BFB, "ilona_generic_update_vo" },
    { 0x4BFC, "image" },
    { 0x4BFD, "immune_sonic_blast" },
    { 0x4BFE, "impact_info" },
    { 0x4BFF, "important_dialogue" },
    { 0x4C00, "important_dialogue_queue" },
    { 0x4C01, "impulse_wave" },
    { 0x4C02, "in_basement" },
    { 0x4C03, "in_combat_mode" },
    { 0x4C04, "in_combat_zone" },
    { 0x4C05, "in_deathsdoor" },
    { 0x4C06, "in_firingrange" },
    { 0x4C07, "in_goal" },
    { 0x4C08, "in_melee" },
    { 0x4C09, "in_position_building_jump" },
    { 0x4C0A, "in_position_vo" },
    { 0x4C0B, "in_river" },
    { 0x4C0C, "in_scanner_cone" },
    { 0x4C0D, "in_school" },
    { 0x4C0E, "in_sights_hud" },
    { 0x4C0F, "in_sights_timestamp" },
    { 0x4C10, "in_spawnspectator" },
    { 0x4C11, "in_state_callback" },
    { 0x4C12, "in_turret" },
    { 0x4C13, "in_use" },
    { 0x4C14, "inactive" },
    { 0x4C15, "inactive_objective" },
    { 0x4C16, "inc" },
    { 0x4C17, "inc4death" },
    { 0x4C18, "incin_amb" },
    { 0x4C19, "incin_burst" },
    { 0x4C1A, "incin_burst2" },
    { 0x4C1B, "incin_close" },
    { 0x4C1C, "incineration_escape_logic" },
    { 0x4C1D, "incinerator_ally_push" },
    { 0x4C1E, "incinerator_ally_push_stop" },
    { 0x4C1F, "incinerator_cart_push" },
    { 0x4C20, "incinerator_crawl" },
    { 0x4C21, "incinerator_dialogue" },
    { 0x4C22, "incinerator_dialogue_2" },
    { 0x4C23, "incinerator_intro" },
    { 0x4C24, "incinerator_player_blur" },
    { 0x4C25, "incinerator_player_damage" },
    { 0x4C26, "incinerator_player_end_anim_and_cleanup" },
    { 0x4C27, "incinerator_player_wobble" },
    { 0x4C28, "incinerator_push_action" },
    { 0x4C29, "incinerator_rumble_hold" },
    { 0x4C2A, "incinerator_stance" },
    { 0x4C2B, "include" },
    { 0x4C2C, "include_in_idle" },
    { 0x4C2D, "incoming_alias_" },
    { 0x4C2E, "incomingmissile" },
    { 0x4C2F, "incomingmissilesound" },
    { 0x4C30, "incomming_missiles" },
    { 0x4C31, "incpersstat" },
    { 0x4C32, "incplayerstat" },
    { 0x4C33, "incranimaimweight" },
    { 0x4C34, "incrankxp" },
    { 0x4C35, "increase_actor_base_accuracy_by_player_distance" },
    { 0x4C36, "increase_difficulty" },
    { 0x4C37, "increasegunlevelevent" },
    { 0x4C38, "increment_claimed_refcount" },
    { 0x4C39, "increment_help_list_offset" },
    { 0x4C3A, "increment_hit" },
    { 0x4C3B, "increment_kill" },
    { 0x4C3C, "increment_list_offset" },
    { 0x4C3D, "increment_ref_count" },
    { 0x4C3E, "increment_take_cover_warnings_on_death" },
    { 0x4C3F, "incrementalivecount" },
    { 0x4C40, "incrementattachmentstat" },
    { 0x4C41, "incrementcombatrecordstat" },
    { 0x4C42, "incrementfauxvehiclecount" },
    { 0x4C43, "incrementweaponstat" },
    { 0x4C44, "index_col" },
    { 0x4C45, "index_is_selected" },
    { 0x4C46, "indicate_start" },
    { 0x4C47, "indicatoroffset" },
    { 0x4C48, "indoor_think" },
    { 0x4C49, "indoorcqbtogglecheck" },
    { 0x4C4A, "infect_allowsuicide" },
    { 0x4C4B, "infect_choosingfirstinfected" },
    { 0x4C4C, "infect_chosefirstinfected" },
    { 0x4C4D, "infect_countdowninprogress" },
    { 0x4C4E, "infect_isbeingchosen" },
    { 0x4C4F, "infect_loadouts" },
    { 0x4C50, "infect_players" },
    { 0x4C51, "infect_teamscores" },
    { 0x4C52, "infectautoassign" },
    { 0x4C53, "infected_knife_name" },
    { 0x4C54, "infectedclass" },
    { 0x4C55, "infectedrejoined" },
    { 0x4C56, "infectedsurvivorevent" },
    { 0x4C57, "infil_allies" },
    { 0x4C58, "infil_begin" },
    { 0x4C59, "infil_main" },
    { 0x4C5A, "infil_start" },
    { 0x4C5B, "infil_vo" },
    { 0x4C5C, "infiltratorburke" },
    { 0x4C5D, "infinalstand" },
    { 0x4C5E, "infiniteloop" },
    { 0x4C5F, "info" },
    { 0x4C60, "information_center" },
    { 0x4C61, "information_center_combat" },
    { 0x4C62, "information_center_dialogue" },
    { 0x4C63, "information_center_enemies_charge" },
    { 0x4C64, "informattacking" },
    { 0x4C65, "informincoming" },
    { 0x4C66, "informkillfirm" },
    { 0x4C67, "informreloading" },
    { 0x4C68, "informsuppressed" },
    { 0x4C69, "informto" },
    { 0x4C6A, "inframes" },
    { 0x4C6B, "infront" },
    { 0x4C6C, "infront_dist_max" },
    { 0x4C6D, "infront_dist_min" },
    { 0x4C6E, "ingame_movies" },
    { 0x4C6F, "ingas" },
    { 0x4C70, "ingraceperiod" },
    { 0x4C71, "ingrenadegraceperiod" },
    { 0x4C72, "init_active" },
    { 0x4C73, "init_ai_swim" },
    { 0x4C74, "init_ai_swim_animsets" },
    { 0x4C75, "init_aibattlechatter" },
    { 0x4C76, "init_ambient_explosion_arrays" },
    { 0x4C77, "init_amimset_mech_transition" },
    { 0x4C78, "init_and_run" },
    { 0x4C79, "init_anim_sets" },
    { 0x4C7A, "init_animatedmodels" },
    { 0x4C7B, "init_animatedmodels_dump" },
    { 0x4C7C, "init_animset_ambush" },
    { 0x4C7D, "init_animset_combat" },
    { 0x4C7E, "init_animset_complete_custom_crouch" },
    { 0x4C7F, "init_animset_complete_custom_stand" },
    { 0x4C80, "init_animset_cover_left" },
    { 0x4C81, "init_animset_cover_multi" },
    { 0x4C82, "init_animset_cover_prone" },
    { 0x4C83, "init_animset_cover_right" },
    { 0x4C84, "init_animset_cover_wall" },
    { 0x4C85, "init_animset_cqb_move" },
    { 0x4C86, "init_animset_cqb_stand" },
    { 0x4C87, "init_animset_custom_crouch" },
    { 0x4C88, "init_animset_custom_stand" },
    { 0x4C89, "init_animset_death" },
    { 0x4C8A, "init_animset_default_crouch" },
    { 0x4C8B, "init_animset_default_move" },
    { 0x4C8C, "init_animset_default_prone" },
    { 0x4C8D, "init_animset_default_stand" },
    { 0x4C8E, "init_animset_flashed" },
    { 0x4C8F, "init_animset_heat_reload" },
    { 0x4C90, "init_animset_heat_run_move" },
    { 0x4C91, "init_animset_heat_stand" },
    { 0x4C92, "init_animset_idle" },
    { 0x4C93, "init_animset_mech_addpain" },
    { 0x4C94, "init_animset_mech_cqb_move" },
    { 0x4C95, "init_animset_mech_death" },
    { 0x4C96, "init_animset_mech_default_stand" },
    { 0x4C97, "init_animset_mech_flashed" },
    { 0x4C98, "init_animset_mech_grapple_tappy" },
    { 0x4C99, "init_animset_mech_grenade_animations" },
    { 0x4C9A, "init_animset_mech_pain" },
    { 0x4C9B, "init_animset_mech_player_grapple_tappy" },
    { 0x4C9C, "init_animset_mech_rope_grapple_tappy" },
    { 0x4C9D, "init_animset_mech_run_move" },
    { 0x4C9E, "init_animset_mech_shoot_moving" },
    { 0x4C9F, "init_animset_mech_stop" },
    { 0x4CA0, "init_animset_mech_walk_move" },
    { 0x4CA1, "init_animset_melee" },
    { 0x4CA2, "init_animset_pain" },
    { 0x4CA3, "init_animset_pistol_move" },
    { 0x4CA4, "init_animset_pistol_stand" },
    { 0x4CA5, "init_animset_reactions" },
    { 0x4CA6, "init_animset_rpg_crouch" },
    { 0x4CA7, "init_animset_rpg_stand" },
    { 0x4CA8, "init_animset_run_move" },
    { 0x4CA9, "init_animset_run_n_gun" },
    { 0x4CAA, "init_animset_shotgun_crouch" },
    { 0x4CAB, "init_animset_shotgun_stand" },
    { 0x4CAC, "init_animset_smg_ambush" },
    { 0x4CAD, "init_animset_smg_crouch" },
    { 0x4CAE, "init_animset_smg_crouch_run" },
    { 0x4CAF, "init_animset_smg_move" },
    { 0x4CB0, "init_animset_smg_stand" },
    { 0x4CB1, "init_animset_unstable_run_move" },
    { 0x4CB2, "init_animset_unstable_stand" },
    { 0x4CB3, "init_animset_unstable_walk_move" },
    { 0x4CB4, "init_animset_walk_move" },
    { 0x4CB5, "init_animsounds" },
    { 0x4CB6, "init_animsounds_for_animname" },
    { 0x4CB7, "init_antenna" },
    { 0x4CB8, "init_assembly_line" },
    { 0x4CB9, "init_audio" },
    { 0x4CBA, "init_audio_flags" },
    { 0x4CBB, "init_battlechatter" },
    { 0x4CBC, "init_bells" },
    { 0x4CBD, "init_blimps" },
    { 0x4CBE, "init_bobbing_boats" },
    { 0x4CBF, "init_boost_land_arrays" },
    { 0x4CC0, "init_bot_attachmenttable" },
    { 0x4CC1, "init_bot_camotable" },
    { 0x4CC2, "init_bot_reticletable" },
    { 0x4CC3, "init_bot_weap_statstable" },
    { 0x4CC4, "init_card_tags" },
    { 0x4CC5, "init_casualkiller_archetype" },
    { 0x4CC6, "init_ceiling_fans" },
    { 0x4CC7, "init_class_motion" },
    { 0x4CC8, "init_class_table" },
    { 0x4CC9, "init_cloak_view_model_anims" },
    { 0x4CCA, "init_cloaked_stealth_detection_range" },
    { 0x4CCB, "init_cloaked_stealth_settings" },
    { 0x4CCC, "init_cloaked_stealth_visibility_range_v1" },
    { 0x4CCD, "init_color_grouping" },
    { 0x4CCE, "init_colors" },
    { 0x4CCF, "init_computed_detection_distance_setting" },
    { 0x4CD0, "init_creepwalk_archetype" },
    { 0x4CD1, "init_crosshair" },
    { 0x4CD2, "init_damage_feedback" },
    { 0x4CD3, "init_dds_active_events" },
    { 0x4CD4, "init_dds_categories" },
    { 0x4CD5, "init_dds_categories_axis" },
    { 0x4CD6, "init_dds_category_groups" },
    { 0x4CD7, "init_dds_category_groups_axis" },
    { 0x4CD8, "init_dds_countryids" },
    { 0x4CD9, "init_dds_flags" },
    { 0x4CDA, "init_destroyed_count" },
    { 0x4CDB, "init_destructible_frame_queue" },
    { 0x4CDC, "init_detection_distance_setting" },
    { 0x4CDD, "init_detection_distance_setting_for_shadow" },
    { 0x4CDE, "init_dialogue_flags" },
    { 0x4CDF, "init_displays" },
    { 0x4CE0, "init_diveboat_weapon" },
    { 0x4CE1, "init_diveboat_weapon_gauge" },
    { 0x4CE2, "init_dog_anims" },
    { 0x4CE3, "init_dog_control" },
    { 0x4CE4, "init_door_shield" },
    { 0x4CE5, "init_drone_motion" },
    { 0x4CE6, "init_drone_motion_old" },
    { 0x4CE7, "init_dshk_player" },
    { 0x4CE8, "init_dshk_turret_processing" },
    { 0x4CE9, "init_elevator" },
    { 0x4CEA, "init_exoclimb_hud" },
    { 0x4CEB, "init_exposed_turn_animations" },
    { 0x4CEC, "init_facility_breach" },
    { 0x4CED, "init_facility_breach_anims" },
    { 0x4CEE, "init_facility_breach_model_anims" },
    { 0x4CEF, "init_facility_breach_npc_anims" },
    { 0x4CF0, "init_facility_breach_view_model_anims" },
    { 0x4CF1, "init_fans" },
    { 0x4CF2, "init_firingrange" },
    { 0x4CF3, "init_flags" },
    { 0x4CF4, "init_flags_shopping_district" },
    { 0x4CF5, "init_flavorbursts" },
    { 0x4CF6, "init_fog_transition" },
    { 0x4CF7, "init_globals" },
    { 0x4CF8, "init_grenade_animations" },
    { 0x4CF9, "init_grenade_hints" },
    { 0x4CFA, "init_ground_slam" },
    { 0x4CFB, "init_health" },
    { 0x4CFC, "init_height" },
    { 0x4CFD, "init_helicopters" },
    { 0x4CFE, "init_hovertank" },
    { 0x4CFF, "init_hovertank_weapons" },
    { 0x4D00, "init_hud" },
    { 0x4D01, "init_huds" },
    { 0x4D02, "init_impact_system_arrays" },
    { 0x4D03, "init_jet_crash_points" },
    { 0x4D04, "init_juggernaut_animsets" },
    { 0x4D05, "init_land_assist_player_rig" },
    { 0x4D06, "init_level_arrays" },
    { 0x4D07, "init_level_flags" },
    { 0x4D08, "init_level_lighting_flags" },
    { 0x4D09, "init_level_players" },
    { 0x4D0A, "init_level_variables" },
    { 0x4D0B, "init_light_def" },
    { 0x4D0C, "init_lighting_flags" },
    { 0x4D0D, "init_linked_air_spaces" },
    { 0x4D0E, "init_linked_ents" },
    { 0x4D0F, "init_lit_model" },
    { 0x4D10, "init_littlebird_landing" },
    { 0x4D11, "init_littlebird_landing_thread" },
    { 0x4D12, "init_loadout" },
    { 0x4D13, "init_local" },
    { 0x4D14, "init_local_simple" },
    { 0x4D15, "init_locked_list" },
    { 0x4D16, "init_mech_actions" },
    { 0x4D17, "init_mech_animsets" },
    { 0x4D18, "init_mech_turn_animations" },
    { 0x4D19, "init_menu" },
    { 0x4D1A, "init_mgturretsettings" },
    { 0x4D1B, "init_microwave_grenade" },
    { 0x4D1C, "init_mobile_cover_drone" },
    { 0x4D1D, "init_momentum" },
    { 0x4D1E, "init_move_transition_arrays" },
    { 0x4D1F, "init_moving_turn_animations" },
    { 0x4D20, "init_multiteamdata" },
    { 0x4D21, "init_new_tank_group" },
    { 0x4D22, "init_note_targets" },
    { 0x4D23, "init_notetracks" },
    { 0x4D24, "init_notetracks_for_animname" },
    { 0x4D25, "init_overtime_momentum" },
    { 0x4D26, "init_path_constants" },
    { 0x4D27, "init_path_traversal" },
    { 0x4D28, "init_pcap_vo" },
    { 0x4D29, "init_pcap_vo_bigm" },
    { 0x4D2A, "init_pcap_vo_freeway_jump_gideon" },
    { 0x4D2B, "init_pcap_vo_hostage_breach" },
    { 0x4D2C, "init_pcap_vo_hostage_scene" },
    { 0x4D2D, "init_pcap_vo_intro" },
    { 0x4D2E, "init_pcap_vo_intro_briefing" },
    { 0x4D2F, "init_pcap_vo_outro" },
    { 0x4D30, "init_pcap_vo_truck_takedown" },
    { 0x4D31, "init_pcap_vo_video_log" },
    { 0x4D32, "init_personality_camper" },
    { 0x4D33, "init_personality_default" },
    { 0x4D34, "init_player" },
    { 0x4D35, "init_player_cloak_overlay" },
    { 0x4D36, "init_player_cloak_state" },
    { 0x4D37, "init_player_gameobjects" },
    { 0x4D38, "init_player_swim" },
    { 0x4D39, "init_plr_vo" },
    { 0x4D3A, "init_reset_ai" },
    { 0x4D3B, "init_reverb" },
    { 0x4D3C, "init_riotshield" },
    { 0x4D3D, "init_riotshield_ai" },
    { 0x4D3E, "init_riotshield_ai_anims" },
    { 0x4D3F, "init_riotshield_animsets" },
    { 0x4D40, "init_s1_animset_combat" },
    { 0x4D41, "init_s1_animset_cover_left" },
    { 0x4D42, "init_s1_animset_cover_right" },
    { 0x4D43, "init_s1_animset_cover_wall" },
    { 0x4D44, "init_s1_animset_cqb_stand" },
    { 0x4D45, "init_s1_animset_death" },
    { 0x4D46, "init_s1_animset_default_crouch" },
    { 0x4D47, "init_s1_animset_default_move" },
    { 0x4D48, "init_s1_animset_default_stand" },
    { 0x4D49, "init_s1_animset_idle" },
    { 0x4D4A, "init_s1_animset_melee" },
    { 0x4D4B, "init_s1_animset_pain" },
    { 0x4D4C, "init_s1_animset_run_move" },
    { 0x4D4D, "init_s1_animset_run_n_gun" },
    { 0x4D4E, "init_s1_animset_smg_crouch" },
    { 0x4D4F, "init_s1_animset_walk_move" },
    { 0x4D50, "init_s1_coverstand_turn_animations" },
    { 0x4D51, "init_s1_exposed_turn_animations" },
    { 0x4D52, "init_s1_moving_turn_animations" },
    { 0x4D53, "init_scanner_yaw" },
    { 0x4D54, "init_screeneffect_vars" },
    { 0x4D55, "init_script_friendnames" },
    { 0x4D56, "init_script_triggers" },
    { 0x4D57, "init_scriptable_primary_lights" },
    { 0x4D58, "init_scripted_light" },
    { 0x4D59, "init_self_fog_transition" },
    { 0x4D5A, "init_self_visionset" },
    { 0x4D5B, "init_selfiebooth" },
    { 0x4D5C, "init_smart_grenade" },
    { 0x4D5D, "init_smvals" },
    { 0x4D5E, "init_snd_flags" },
    { 0x4D5F, "init_snipers_drones" },
    { 0x4D60, "init_spawns" },
    { 0x4D61, "init_squadbattlechatter" },
    { 0x4D62, "init_squadmanager" },
    { 0x4D63, "init_state_callback" },
    { 0x4D64, "init_state_list" },
    { 0x4D65, "init_stats" },
    { 0x4D66, "init_swim_anim_deltas" },
    { 0x4D67, "init_swim_anims" },
    { 0x4D68, "init_take_cover_warnings" },
    { 0x4D69, "init_tank" },
    { 0x4D6A, "init_target_points" },
    { 0x4D6B, "init_template_table" },
    { 0x4D6C, "init_thruster" },
    { 0x4D6D, "init_time" },
    { 0x4D6E, "init_tool_hud" },
    { 0x4D6F, "init_traffic" },
    { 0x4D70, "init_trigger_flags" },
    { 0x4D71, "init_turbines" },
    { 0x4D72, "init_uncloaked_detection_distance_setting" },
    { 0x4D73, "init_uncloaked_detection_distance_setting_for_shadow" },
    { 0x4D74, "init_variable_grenade" },
    { 0x4D75, "init_vehicle_free_path" },
    { 0x4D76, "init_vehicles" },
    { 0x4D77, "init_vision_set" },
    { 0x4D78, "init_visionset_progress_trigger" },
    { 0x4D79, "init_vo_flags" },
    { 0x4D7A, "init_water" },
    { 0x4D7B, "init_whizby" },
    { 0x4D7C, "init_wind_if_uninitialized" },
    { 0x4D7D, "init_zone_drones" },
    { 0x4D7E, "init2" },
    { 0x4D7F, "initactivisioncredits" },
    { 0x4D80, "initadvancetoenemy" },
    { 0x4D81, "initagentlevelvariables" },
    { 0x4D82, "initagentscriptvariables" },
    { 0x4D83, "initalerttime" },
    { 0x4D84, "initalleys" },
    { 0x4D85, "initalleysart" },
    { 0x4D86, "initalleysend" },
    { 0x4D87, "initalleysstart" },
    { 0x4D88, "initalleystransition" },
    { 0x4D89, "initalleystransitionstart" },
    { 0x4D8A, "initallysquad" },
    { 0x4D8B, "initanimset" },
    { 0x4D8C, "initanimtree" },
    { 0x4D8D, "initarmories" },
    { 0x4D8E, "initawards" },
    { 0x4D8F, "initbattlechatter" },
    { 0x4D90, "initbeginconfcentercombat" },
    { 0x4D91, "initbeginconfcenterkill" },
    { 0x4D92, "initbeginconfcenteroutro" },
    { 0x4D93, "initbeginconfcentersupporta" },
    { 0x4D94, "initbeginconfcentersupportb" },
    { 0x4D95, "initbeginconfcentersupportc" },
    { 0x4D96, "initbotlevelvariables" },
    { 0x4D97, "initbotmapextents" },
    { 0x4D98, "initbufferedstats" },
    { 0x4D99, "initcharacterface" },
    { 0x4D9A, "initcivilianprops" },
    { 0x4D9B, "initclientdvars" },
    { 0x4D9C, "initclientdvarssplitscreenspecific" },
    { 0x4D9D, "initconfcentercombat" },
    { 0x4D9E, "initconfcenterintro" },
    { 0x4D9F, "initconfcenterkill" },
    { 0x4DA0, "initconfcenteroutro" },
    { 0x4DA1, "initconfcenterstart" },
    { 0x4DA2, "initconfcenterstealthsettings" },
    { 0x4DA3, "initconfcentersupporta" },
    { 0x4DA4, "initconfcentersupportb" },
    { 0x4DA5, "initconfcentersupportc" },
    { 0x4DA6, "initcontact" },
    { 0x4DA7, "initcovercrouchnode" },
    { 0x4DA8, "initcoverstandnode" },
    { 0x4DA9, "initcredits" },
    { 0x4DAA, "initdeaths" },
    { 0x4DAB, "initdefuseobject" },
    { 0x4DAC, "initdeveloperdvars" },
    { 0x4DAD, "initdistortionfx" },
    { 0x4DAE, "initdoganimations" },
    { 0x4DAF, "initdogarchetype" },
    { 0x4DB0, "initdogarchetype_death" },
    { 0x4DB1, "initdogarchetype_move" },
    { 0x4DB2, "initdogarchetype_reaction" },
    { 0x4DB3, "initdogarchetype_stop" },
    { 0x4DB4, "initdogtraverseanims" },
    { 0x4DB5, "initdot" },
    { 0x4DB6, "initdroneflyinturnrate" },
    { 0x4DB7, "initdroneturnrate" },
    { 0x4DB8, "inited" },
    { 0x4DB9, "initedentityheadicons" },
    { 0x4DBA, "initendingambush" },
    { 0x4DBB, "initendingambushinteractlighting" },
    { 0x4DBC, "initendingfight" },
    { 0x4DBD, "initendinghades" },
    { 0x4DBE, "initendinghadesfight" },
    { 0x4DBF, "initfacialanims" },
    { 0x4DC0, "initfanprops" },
    { 0x4DC1, "initfinalkillcam" },
    { 0x4DC2, "initfx" },
    { 0x4DC3, "initgameflags" },
    { 0x4DC4, "initglobals" },
    { 0x4DC5, "initgrenades" },
    { 0x4DC6, "initgrenadethrowanims" },
    { 0x4DC7, "inithandsignals" },
    { 0x4DC8, "inithordesettings" },
    { 0x4DC9, "initial_ally_wave" },
    { 0x4DCA, "initial_bomb_location" },
    { 0x4DCB, "initial_bomb_location_nearest_node" },
    { 0x4DCC, "initial_bomb_pickup_time" },
    { 0x4DCD, "initial_combat" },
    { 0x4DCE, "initial_deck_guys_invuln" },
    { 0x4DCF, "initial_enemies_wave1" },
    { 0x4DD0, "initial_enemy_target" },
    { 0x4DD1, "initial_hangar_guys_invuln" },
    { 0x4DD2, "initial_hangar_setup" },
    { 0x4DD3, "initial_pickup_wait_time" },
    { 0x4DD4, "initial_spawn_time" },
    { 0x4DD5, "initial_state" },
    { 0x4DD6, "initial_state_name_pair" },
    { 0x4DD7, "initial_state_spec" },
    { 0x4DD8, "initialdmscoreupdate" },
    { 0x4DD9, "initialhealth" },
    { 0x4DDA, "initialize" },
    { 0x4DDB, "initialize_character_group" },
    { 0x4DDC, "initialize_colors" },
    { 0x4DDD, "initialize_intel" },
    { 0x4DDE, "initialize_sd_role" },
    { 0x4DDF, "initialize_stealth_debug_hud" },
    { 0x4DE0, "initializeallyarray" },
    { 0x4DE1, "initialized_civilian_animations" },
    { 0x4DE2, "initialized_gameobject_vars" },
    { 0x4DE3, "initializematchrules" },
    { 0x4DE4, "initializeoribtalmode" },
    { 0x4DE5, "initializesniperdronedata" },
    { 0x4DE6, "initializetagpathvariables" },
    { 0x4DE7, "initialzonedelay" },
    { 0x4DE8, "initiate_exo_push_on_player_advance" },
    { 0x4DE9, "initiate_exo_push_on_sniperguys_dead" },
    { 0x4DEA, "initiated" },
    { 0x4DEB, "initiw6credits" },
    { 0x4DEC, "initiw6credits_s1" },
    { 0x4DED, "initkillstreakdata" },
    { 0x4DEE, "initlaser" },
    { 0x4DEF, "initlaserents" },
    { 0x4DF0, "initlaserfx" },
    { 0x4DF1, "initlasersound" },
    { 0x4DF2, "initlevelface" },
    { 0x4DF3, "initlevelflags" },
    { 0x4DF4, "initmechsplittimes" },
    { 0x4DF5, "initmissiondata" },
    { 0x4DF6, "initmovestartstoptransitions" },
    { 0x4DF7, "initmultiobjectives" },
    { 0x4DF8, "initnotifymessage" },
    { 0x4DF9, "initorbitlowerbounds" },
    { 0x4DFA, "initpainfx" },
    { 0x4DFB, "initperkdvars" },
    { 0x4DFC, "initpersstat" },
    { 0x4DFD, "initpickups" },
    { 0x4DFE, "initplayer" },
    { 0x4DFF, "initplayerclass" },
    { 0x4E00, "initplayerforharmonicbreach" },
    { 0x4E01, "initplayerkillstreaks" },
    { 0x4E02, "initplayerscriptvariables" },
    { 0x4E03, "initplayerstat" },
    { 0x4E04, "initplayerstats" },
    { 0x4E05, "initposemovementfunctions" },
    { 0x4E06, "initridekillstreak" },
    { 0x4E07, "initridekillstreak_internal" },
    { 0x4E08, "initrunngun" },
    { 0x4E09, "inits1soldiersplittimes" },
    { 0x4E0A, "initsafehouseclear" },
    { 0x4E0B, "initsafehouseclearstart" },
    { 0x4E0C, "initsafehouseexosuitup" },
    { 0x4E0D, "initsafehouseexosuitupfadeout" },
    { 0x4E0E, "initsafehousefollow" },
    { 0x4E0F, "initsafehouseintro" },
    { 0x4E10, "initsafehousekill" },
    { 0x4E11, "initsafehouseoutro" },
    { 0x4E12, "initsafehouseoutrostart" },
    { 0x4E13, "initsafehousetakedownkill" },
    { 0x4E14, "initsafehousetransition" },
    { 0x4E15, "initsafehousetransitionstart" },
    { 0x4E16, "initsafehousexslice" },
    { 0x4E17, "initscanvariables" },
    { 0x4E18, "initscoreboard" },
    { 0x4E19, "initscoredata" },
    { 0x4E1A, "initsniperscrambledrones" },
    { 0x4E1B, "initsniperscramblefinale" },
    { 0x4E1C, "initsniperscramblefinalelighting" },
    { 0x4E1D, "initsniperscramblehotel" },
    { 0x4E1E, "initsniperscrambleintro" },
    { 0x4E1F, "initsniperscramblestarthotel" },
    { 0x4E20, "initsniperscramblesuppressionfeedback" },
    { 0x4E21, "initsoldierentrance" },
    { 0x4E22, "initsoldierexit" },
    { 0x4E23, "initsoldiersplittimes" },
    { 0x4E24, "initsoliders1entrance" },
    { 0x4E25, "initsoliders1exit" },
    { 0x4E26, "initsonicaoe" },
    { 0x4E27, "initspawn" },
    { 0x4E28, "initspawnpointvalues" },
    { 0x4E29, "initspawns" },
    { 0x4E2A, "initstart" },
    { 0x4E2B, "initstataward" },
    { 0x4E2C, "initstate" },
    { 0x4E2D, "initstingerusage" },
    { 0x4E2E, "inittabletoverlay" },
    { 0x4E2F, "inittakedownkill" },
    { 0x4E30, "initteamspawnelements" },
    { 0x4E31, "initthinkpatrolenemy" },
    { 0x4E32, "inittransdistandanglesforarchetype" },
    { 0x4E33, "inittriggermultiplevisionlightset" },
    { 0x4E34, "inittweaks" },
    { 0x4E35, "initweapon" },
    { 0x4E36, "initwindowtraverse" },
    { 0x4E37, "initzombies" },
    { 0x4E38, "injured_by_base" },
    { 0x4E39, "injured_by_main_exit_door" },
    { 0x4E3A, "injured_guy_dialogue" },
    { 0x4E3B, "injured_guy_vo" },
    { 0x4E3C, "injured_player_blur" },
    { 0x4E3D, "injured_player_wobble" },
    { 0x4E3E, "injured_soldier_loop" },
    { 0x4E3F, "inlaststand" },
    { 0x4E40, "inliveplayerkillstreak" },
    { 0x4E41, "innercone" },
    { 0x4E42, "inovertime" },
    { 0x4E43, "inplayerportableradar" },
    { 0x4E44, "inplayerscrambler" },
    { 0x4E45, "inplayersmokescreen" },
    { 0x4E46, "inprogress" },
    { 0x4E47, "input_bool" },
    { 0x4E48, "input_callback_acceleration_g" },
    { 0x4E49, "input_callback_degrees_from_upright" },
    { 0x4E4A, "input_callback_distance" },
    { 0x4E4B, "input_callback_distance2d" },
    { 0x4E4C, "input_callback_doppler" },
    { 0x4E4D, "input_callback_doppler_exaggerated" },
    { 0x4E4E, "input_callback_doppler_subtle" },
    { 0x4E4F, "input_callback_jerk_gps" },
    { 0x4E50, "input_callback_jetbike_anti_slip" },
    { 0x4E51, "input_callback_jetbike_drag" },
    { 0x4E52, "input_callback_jetbike_thrust" },
    { 0x4E53, "input_callback_jetbike_total_repulsor" },
    { 0x4E54, "input_callback_pitch" },
    { 0x4E55, "input_callback_pitch_roll_max" },
    { 0x4E56, "input_callback_player_jetbike_height" },
    { 0x4E57, "input_callback_relative_speed" },
    { 0x4E58, "input_callback_speed" },
    { 0x4E59, "input_callback_speed_mph" },
    { 0x4E5A, "input_callback_throttle" },
    { 0x4E5B, "input_callback_yaw" },
    { 0x4E5C, "input_cdrn_ball_joint_pitch_rate" },
    { 0x4E5D, "input_cdrn_ball_joint_rate" },
    { 0x4E5E, "input_cdrn_ball_joint_roll_rate" },
    { 0x4E5F, "input_cdrn_in_use" },
    { 0x4E60, "input_cdrn_speed" },
    { 0x4E61, "input_cdrn_stuck_amount" },
    { 0x4E62, "input_cdrn_throttle" },
    { 0x4E63, "input_cdrn_wheel_speed" },
    { 0x4E64, "input_cdrn_wheel_speed_left" },
    { 0x4E65, "input_cdrn_wheel_speed_right" },
    { 0x4E66, "input_delta_time" },
    { 0x4E67, "input_diveboat_drag" },
    { 0x4E68, "input_diveboat_drag_with_mph" },
    { 0x4E69, "input_diveboat_throttle" },
    { 0x4E6A, "input_hint" },
    { 0x4E6B, "input_hint_use" },
    { 0x4E6C, "input_hovertank_anti_slip" },
    { 0x4E6D, "input_hovertank_anti_slip_direction" },
    { 0x4E6E, "input_hovertank_anti_slip_magnitude" },
    { 0x4E6F, "input_hovertank_auto_yaw" },
    { 0x4E70, "input_hovertank_auto_yaw_direction" },
    { 0x4E71, "input_hovertank_auto_yaw_magnitude" },
    { 0x4E72, "input_hovertank_repulsor_back_left" },
    { 0x4E73, "input_hovertank_repulsor_back_right" },
    { 0x4E74, "input_hovertank_repulsor_front_left" },
    { 0x4E75, "input_hovertank_repulsor_front_right" },
    { 0x4E76, "input_hovertank_repulsors" },
    { 0x4E77, "input_hovertank_throttle" },
    { 0x4E78, "input_hovertank_throttle_direction" },
    { 0x4E79, "input_hovertank_throttle_magnitude" },
    { 0x4E7A, "input_hovertank_turret_pch" },
    { 0x4E7B, "input_hovertank_turret_yaw" },
    { 0x4E7C, "input_hovertank_uprighting" },
    { 0x4E7D, "input_modifiers" },
    { 0x4E7E, "input_name" },
    { 0x4E7F, "input_player_pdrone_look" },
    { 0x4E80, "input_reactive_radius" },
    { 0x4E81, "input_scalar_actual" },
    { 0x4E82, "input_scalar_target" },
    { 0x4E83, "input_start_time" },
    { 0x4E84, "input_type" },
    { 0x4E85, "inseq" },
    { 0x4E86, "insert_effect" },
    { 0x4E87, "insert_to_lane" },
    { 0x4E88, "inshallowwater" },
    { 0x4E89, "instance_init_callback" },
    { 0x4E8A, "instance_name" },
    { 0x4E8B, "instances" },
    { 0x4E8C, "instantkillplayersincloud" },
    { 0x4E8D, "instantly_promote_nearest_friendly" },
    { 0x4E8E, "instantly_promote_nearest_friendly_with_classname" },
    { 0x4E8F, "instantly_set_color_from_array" },
    { 0x4E90, "instantly_set_color_from_array_with_classname" },
    { 0x4E91, "instigators" },
    { 0x4E92, "instinctcustomospfunc" },
    { 0x4E93, "instinctdogs" },
    { 0x4E94, "instinctdogspawnpoints" },
    { 0x4E95, "insyncmeleewithtarget" },
    { 0x4E96, "int_clamp" },
    { 0x4E97, "intel_begin" },
    { 0x4E98, "intel_counter" },
    { 0x4E99, "intel_feedback" },
    { 0x4E9A, "intel_items" },
    { 0x4E9B, "intel_main" },
    { 0x4E9C, "intel_player_rig" },
    { 0x4E9D, "intel_start" },
    { 0x4E9E, "intel_think" },
    { 0x4E9F, "intel_upload_text" },
    { 0x4EA0, "intelminigun" },
    { 0x4EA1, "intensity" },
    { 0x4EA2, "intensityhdr" },
    { 0x4EA3, "inter_salvo_delay" },
    { 0x4EA4, "interactive_landanim" },
    { 0x4EA5, "interactive_number" },
    { 0x4EA6, "interactive_takeoffanim" },
    { 0x4EA7, "interactive_tv" },
    { 0x4EA8, "interactive_type" },
    { 0x4EA9, "interactive_warnings" },
    { 0x4EAA, "interactivekeypairs" },
    { 0x4EAB, "interactives" },
    { 0x4EAC, "interactteam" },
    { 0x4EAD, "interceptionevent" },
    { 0x4EAE, "interceptnotetracksforweaponswitch" },
    { 0x4EAF, "interior" },
    { 0x4EB0, "interior_allies" },
    { 0x4EB1, "interior_dialogue" },
    { 0x4EB2, "interior_dof_blend" },
    { 0x4EB3, "interior_door" },
    { 0x4EB4, "interior_door1_done" },
    { 0x4EB5, "interior_fallback_think" },
    { 0x4EB6, "interior_gameplay" },
    { 0x4EB7, "interior_init_level_flags" },
    { 0x4EB8, "interior_light" },
    { 0x4EB9, "interior_light_bounce" },
    { 0x4EBA, "interior_light_red" },
    { 0x4EBB, "interior_light_red_ending" },
    { 0x4EBC, "interior_npc_anims" },
    { 0x4EBD, "interior_player_anims" },
    { 0x4EBE, "interior_prepare_dialogue" },
    { 0x4EBF, "interior_setup_anims" },
    { 0x4EC0, "interior_shake_1" },
    { 0x4EC1, "interior_sun" },
    { 0x4EC2, "interiordnadrones" },
    { 0x4EC3, "interp_with_clamp" },
    { 0x4EC4, "interruptdeath" },
    { 0x4EC5, "inthickwater" },
    { 0x4EC6, "into_the_forest_dialogue" },
    { 0x4EC7, "intransit" },
    { 0x4EC8, "intro_actors" },
    { 0x4EC9, "intro_aerial_fire_fx" },
    { 0x4ECA, "intro_allies" },
    { 0x4ECB, "intro_allies_killed_by_mig" },
    { 0x4ECC, "intro_ally_boost_fx" },
    { 0x4ECD, "intro_ally_heli" },
    { 0x4ECE, "intro_ally_tank" },
    { 0x4ECF, "intro_ally1" },
    { 0x4ED0, "intro_ally2" },
    { 0x4ED1, "intro_ally3" },
    { 0x4ED2, "intro_amb_building_meteor_impacts" },
    { 0x4ED3, "intro_amb_canal_water_impacts" },
    { 0x4ED4, "intro_amb_dirt_impacts" },
    { 0x4ED5, "intro_ambient_aa_explosion_far" },
    { 0x4ED6, "intro_ambient_cleanup" },
    { 0x4ED7, "intro_ambient_missiles" },
    { 0x4ED8, "intro_anim" },
    { 0x4ED9, "intro_anim_struct" },
    { 0x4EDA, "intro_anim_vm" },
    { 0x4EDB, "intro_anims" },
    { 0x4EDC, "intro_apt_vf_debris" },
    { 0x4EDD, "intro_ar_anchor_anim" },
    { 0x4EDE, "intro_ar_anim_shg" },
    { 0x4EDF, "intro_ar_load_screen" },
    { 0x4EE0, "intro_ar_loadtext" },
    { 0x4EE1, "intro_ar_path_anim" },
    { 0x4EE2, "intro_ar_scale_ssao" },
    { 0x4EE3, "intro_ar_sethud" },
    { 0x4EE4, "intro_armap_moment" },
    { 0x4EE5, "intro_arms" },
    { 0x4EE6, "intro_bad_guy_4" },
    { 0x4EE7, "intro_bad_guy_5" },
    { 0x4EE8, "intro_bad_guy_6" },
    { 0x4EE9, "intro_bag_guy_start" },
    { 0x4EEA, "intro_bag_guy_table" },
    { 0x4EEB, "intro_bag_guy_walk_away" },
    { 0x4EEC, "intro_beach_briefing_anims" },
    { 0x4EED, "intro_beach_invasion" },
    { 0x4EEE, "intro_begin" },
    { 0x4EEF, "intro_bink" },
    { 0x4EF0, "intro_birds" },
    { 0x4EF1, "intro_blimp_explode" },
    { 0x4EF2, "intro_blimp_explode2" },
    { 0x4EF3, "intro_blimp_explode3" },
    { 0x4EF4, "intro_blimp_explode4" },
    { 0x4EF5, "intro_blimp_explode5" },
    { 0x4EF6, "intro_blimp_missile" },
    { 0x4EF7, "intro_blimp_missile_trail_delete" },
    { 0x4EF8, "intro_bobbing_boats" },
    { 0x4EF9, "intro_bottom_droppod" },
    { 0x4EFA, "intro_camera_blur" },
    { 0x4EFB, "intro_cave_rumble" },
    { 0x4EFC, "intro_cave_rumble_cleanup" },
    { 0x4EFD, "intro_city_ambient_fx" },
    { 0x4EFE, "intro_cloud" },
    { 0x4EFF, "intro_combat_tank" },
    { 0x4F00, "intro_dialog" },
    { 0x4F01, "intro_dialogue" },
    { 0x4F02, "intro_dof" },
    { 0x4F03, "intro_dof_physically_based" },
    { 0x4F04, "intro_drive_hint" },
    { 0x4F05, "intro_drive_jetbike_lights" },
    { 0x4F06, "intro_drive_jetbike_lights_friendlies" },
    { 0x4F07, "intro_drive_jetbike_lights_player" },
    { 0x4F08, "intro_drive_jetbike_lights_red" },
    { 0x4F09, "intro_drive_scripted_bike_bones" },
    { 0x4F0A, "intro_drive_scripted_bike_bones_gestures" },
    { 0x4F0B, "intro_drive_scripted_bike_burke" },
    { 0x4F0C, "intro_drive_scripted_bike_burke_gestures" },
    { 0x4F0D, "intro_drive_scripted_bike_joker" },
    { 0x4F0E, "intro_drive_scripted_bike_joker_gestures" },
    { 0x4F0F, "intro_drive_start_scripted_bike" },
    { 0x4F10, "intro_drone" },
    { 0x4F11, "intro_drone_tablet_touch_fx" },
    { 0x4F12, "intro_drop_pod_se_phase_2b_start" },
    { 0x4F13, "intro_drop_pod_se_start" },
    { 0x4F14, "intro_drop_pod_vm_motionline" },
    { 0x4F15, "intro_droppod_blimp_detach01" },
    { 0x4F16, "intro_droppod_blimp_detach02" },
    { 0x4F17, "intro_droppod_thrusters" },
    { 0x4F18, "intro_droppod_thrusters_stop" },
    { 0x4F19, "intro_droppod_velocity_streaks" },
    { 0x4F1A, "intro_enable_weapons" },
    { 0x4F1B, "intro_end_anim" },
    { 0x4F1C, "intro_flak_explosion_fx" },
    { 0x4F1D, "intro_flight_missiles_fire" },
    { 0x4F1E, "intro_flight_start" },
    { 0x4F1F, "intro_fly_drone_idle" },
    { 0x4F20, "intro_fly_in_animated" },
    { 0x4F21, "intro_fly_in_animated_part2" },
    { 0x4F22, "intro_fly_in_missile_hit_warbird" },
    { 0x4F23, "intro_fly_in_missile_hit_warbird_rotorsmoke" },
    { 0x4F24, "intro_fly_in_missile_hit_warbird_rotorsmoke_stop" },
    { 0x4F25, "intro_fly_in_missile_hit_warbird_tower" },
    { 0x4F26, "intro_fly_in_part2_vo" },
    { 0x4F27, "intro_fly_in_post_crash_vo" },
    { 0x4F28, "intro_fly_in_vo" },
    { 0x4F29, "intro_flyin" },
    { 0x4F2A, "intro_flyin_ambient_aa_explosions" },
    { 0x4F2B, "intro_flyin_ambient_explosion_midair_runner_single" },
    { 0x4F2C, "intro_flyin_ambient_window_glass_explosions" },
    { 0x4F2D, "intro_gideon" },
    { 0x4F2E, "intro_give_player_driving" },
    { 0x4F2F, "intro_ground_explosion_fx" },
    { 0x4F30, "intro_hades_video_length" },
    { 0x4F31, "intro_heli" },
    { 0x4F32, "intro_heli_carry_walkers" },
    { 0x4F33, "intro_heli_movies" },
    { 0x4F34, "intro_helipad_lights" },
    { 0x4F35, "intro_helis" },
    { 0x4F36, "intro_helis_background" },
    { 0x4F37, "intro_hostage_executed" },
    { 0x4F38, "intro_hostage_leader" },
    { 0x4F39, "intro_hostage_leader_2" },
    { 0x4F3A, "intro_hostage_leader_3" },
    { 0x4F3B, "intro_infil_gideon_fx" },
    { 0x4F3C, "intro_infil_gideon_pod_dmg" },
    { 0x4F3D, "intro_infil_gideon_pod_fx" },
    { 0x4F3E, "intro_infil_knox_fx" },
    { 0x4F3F, "intro_infil_knox_pod_fx" },
    { 0x4F40, "intro_infil_pergola_fx" },
    { 0x4F41, "intro_infil_player_pod_fx" },
    { 0x4F42, "intro_lerp_sun" },
    { 0x4F43, "intro_lighting" },
    { 0x4F44, "intro_lines" },
    { 0x4F45, "intro_logic" },
    { 0x4F46, "intro_main" },
    { 0x4F47, "intro_mid_flak_explosion_fx" },
    { 0x4F48, "intro_missile_hit" },
    { 0x4F49, "intro_missile_hit_pod" },
    { 0x4F4A, "intro_missile_trail" },
    { 0x4F4B, "intro_missile_trail_delete" },
    { 0x4F4C, "intro_movie" },
    { 0x4F4D, "intro_moving_ships" },
    { 0x4F4E, "intro_near_flak_explosion_fx" },
    { 0x4F4F, "intro_node" },
    { 0x4F50, "intro_offse" },
    { 0x4F51, "intro_offset" },
    { 0x4F52, "intro_play_ar_anim" },
    { 0x4F53, "intro_player" },
    { 0x4F54, "intro_player_rumble" },
    { 0x4F55, "intro_pod_audio" },
    { 0x4F56, "intro_pod_door_flyout" },
    { 0x4F57, "intro_pod_drop" },
    { 0x4F58, "intro_pod_emergency_door_close" },
    { 0x4F59, "intro_pod_engine_fx" },
    { 0x4F5A, "intro_pod_exit_building1" },
    { 0x4F5B, "intro_pod_hit_apartment" },
    { 0x4F5C, "intro_pod_hit_building_2" },
    { 0x4F5D, "intro_pod_hit_building1" },
    { 0x4F5E, "intro_pod_hit_building1_flr1" },
    { 0x4F5F, "intro_pod_hit_building1_flr2" },
    { 0x4F60, "intro_pod_hit_building1_flr3" },
    { 0x4F61, "intro_post_load" },
    { 0x4F62, "intro_prime_minister" },
    { 0x4F63, "intro_prime_minister_2" },
    { 0x4F64, "intro_quad_whoooshes" },
    { 0x4F65, "intro_rack_focus_cargo_dof" },
    { 0x4F66, "intro_rack_focus_dof" },
    { 0x4F67, "intro_radio_chatter" },
    { 0x4F68, "intro_rain_splat_onlens" },
    { 0x4F69, "intro_reg_vehicles" },
    { 0x4F6A, "intro_running_guy" },
    { 0x4F6B, "intro_scene" },
    { 0x4F6C, "intro_scene_done" },
    { 0x4F6D, "intro_screen" },
    { 0x4F6E, "intro_screen_create" },
    { 0x4F6F, "intro_screen_custom_func" },
    { 0x4F70, "intro_screen_custom_timing" },
    { 0x4F71, "intro_shadows" },
    { 0x4F72, "intro_shake_cam" },
    { 0x4F73, "intro_ship_icons" },
    { 0x4F74, "intro_shoot_hint" },
    { 0x4F75, "intro_sinkhole_explo" },
    { 0x4F76, "intro_skyjack_black" },
    { 0x4F77, "intro_skyjack_fade_in" },
    { 0x4F78, "intro_space" },
    { 0x4F79, "intro_spotlight_setup" },
    { 0x4F7A, "intro_start" },
    { 0x4F7B, "intro_sun_flare_position" },
    { 0x4F7C, "intro_tablet_touch_fx" },
    { 0x4F7D, "intro_title_text" },
    { 0x4F7E, "intro_title_text_end" },
    { 0x4F7F, "intro_title_text_start" },
    { 0x4F80, "intro_traffic_lanes" },
    { 0x4F81, "intro_view_traffic" },
    { 0x4F82, "intro_vo" },
    { 0x4F83, "intro_warbird_camshake" },
    { 0x4F84, "intro_warbird_engine_wash_fx" },
    { 0x4F85, "intro_warbird_rotor_rainstreak" },
    { 0x4F86, "intro_warbird_rotorwash_fly" },
    { 0x4F87, "intro_warbird_rotorwash_ground" },
    { 0x4F88, "intro_warbird_wash_fx" },
    { 0x4F89, "intro_warbird_wash_handler" },
    { 0x4F8A, "intro_warbird_wash_trace" },
    { 0x4F8B, "intro_warbird_wind_debris" },
    { 0x4F8C, "intro_zodiac_wake_fx" },
    { 0x4F8D, "intro_zoom_in_out_fleet" },
    { 0x4F8E, "introdrive_truck_throw_guard" },
    { 0x4F8F, "introscreen" },
    { 0x4F90, "introscreen_complete_delay" },
    { 0x4F91, "introscreen_corner_line" },
    { 0x4F92, "introscreen_fade_in" },
    { 0x4F93, "introscreen_feed_lines" },
    { 0x4F94, "introscreen_generic_black_fade_in" },
    { 0x4F95, "introscreen_generic_fade_in" },
    { 0x4F96, "introscreen_generic_fade_out" },
    { 0x4F97, "introscreen2" },
    { 0x4F98, "introwave1" },
    { 0x4F99, "inuseby" },
    { 0x4F9A, "invalidparentoverridecallback" },
    { 0x4F9B, "inventory" },
    { 0x4F9C, "inventory_array" },
    { 0x4F9D, "inventory_create" },
    { 0x4F9E, "inventory_destroy" },
    { 0x4F9F, "inventory_hide" },
    { 0x4FA0, "inventory_show" },
    { 0x4FA1, "inventroy_update" },
    { 0x4FA2, "invert_controls_prompt" },
    { 0x4FA3, "investigate" },
    { 0x4FA4, "investigate_someone_using_bomb_update" },
    { 0x4FA5, "investigate_spot_return_to" },
    { 0x4FA6, "investigatenodes" },
    { 0x4FA7, "investigating" },
    { 0x4FA8, "investigating_last_known_position" },
    { 0x4FA9, "invirtuallobby" },
    { 0x4FAA, "invul" },
    { 0x4FAB, "invulnerable" },
    { 0x4FAC, "invulnerabletime" },
    { 0x4FAD, "invultime_onshield" },
    { 0x4FAE, "invultime_postshield" },
    { 0x4FAF, "invultime_preshield" },
    { 0x4FB0, "inwater" },
    { 0x4FB1, "inwaterwake" },
    { 0x4FB2, "iprintlnsubtitles" },
    { 0x4FB3, "irons" },
    { 0x4FB4, "irons_chase_door_close" },
    { 0x4FB5, "irons_chase_logic" },
    { 0x4FB6, "irons_estate_animated_trees" },
    { 0x4FB7, "irons_estate_animated_trees_setup" },
    { 0x4FB8, "irons_estate_briefing_setup" },
    { 0x4FB9, "irons_estate_call_notify" },
    { 0x4FBA, "irons_estate_car_setup" },
    { 0x4FBB, "irons_estate_close_awareness_check" },
    { 0x4FBC, "irons_estate_collect_corpse_override" },
    { 0x4FBD, "irons_estate_custom_pre_spotted" },
    { 0x4FBE, "irons_estate_custom_state_behavior" },
    { 0x4FBF, "irons_estate_elevator_dof" },
    { 0x4FC0, "irons_estate_enemy_attack_behavior" },
    { 0x4FC1, "irons_estate_enemy_close_in_on_target" },
    { 0x4FC2, "irons_estate_enemy_go_back" },
    { 0x4FC3, "irons_estate_enemy_investigate_position" },
    { 0x4FC4, "irons_estate_enemy_normal_behavior" },
    { 0x4FC5, "irons_estate_enemy_state_hidden" },
    { 0x4FC6, "irons_estate_enemy_state_spotted" },
    { 0x4FC7, "irons_estate_enemy_warning1_behavior" },
    { 0x4FC8, "irons_estate_enemy_warning2_behavior" },
    { 0x4FC9, "irons_estate_exfil_setup" },
    { 0x4FCA, "irons_estate_global_flags" },
    { 0x4FCB, "irons_estate_hanger_setup" },
    { 0x4FCC, "irons_estate_intel_debug_checkpoint" },
    { 0x4FCD, "irons_estate_intro_reveal_setup" },
    { 0x4FCE, "irons_estate_intro_reveal_setup_debug_checkpoint" },
    { 0x4FCF, "irons_estate_jump_monitor" },
    { 0x4FD0, "irons_estate_objectives" },
    { 0x4FD1, "irons_estate_outside_vision_setup" },
    { 0x4FD2, "irons_estate_patrol_resume_move_start_func" },
    { 0x4FD3, "irons_estate_penthouse_cormack_setup" },
    { 0x4FD4, "irons_estate_penthouse_setup" },
    { 0x4FD5, "irons_estate_plane_setup" },
    { 0x4FD6, "irons_estate_precache" },
    { 0x4FD7, "irons_estate_recon_setup" },
    { 0x4FD8, "irons_estate_security_center_debug_checkpoint" },
    { 0x4FD9, "irons_estate_security_center_exit_setup" },
    { 0x4FDA, "irons_estate_security_center_setup" },
    { 0x4FDB, "irons_estate_starts" },
    { 0x4FDC, "irons_estate_stealth_achievement" },
    { 0x4FDD, "irons_estate_stealth_ai_status_monitor" },
    { 0x4FDE, "irons_estate_stealth_ai_status_thread" },
    { 0x4FDF, "irons_estate_stealth_anims" },
    { 0x4FE0, "irons_estate_stealth_custom" },
    { 0x4FE1, "irons_estate_stealth_disable" },
    { 0x4FE2, "irons_estate_stealth_enable" },
    { 0x4FE3, "irons_estate_stealth_settings_normal" },
    { 0x4FE4, "irons_estate_stealth_setup" },
    { 0x4FE5, "irons_estate_threat_search" },
    { 0x4FE6, "irons_estate_trigger_saves" },
    { 0x4FE7, "irons_estate_tutorial_setup" },
    { 0x4FE8, "irons_estate_underwater_setup" },
    { 0x4FE9, "irons_estate_vehicle_damaged_watcher" },
    { 0x4FEA, "irons_estate_vehicle_guy_stealth_setup" },
    { 0x4FEB, "irons_estate_vehicle_open_door_anim" },
    { 0x4FEC, "irons_estate_vehicle_passenger_death_watcher" },
    { 0x4FED, "irons_estate_vehicle_passenger_go_back" },
    { 0x4FEE, "irons_estate_vehicle_passenger_normal" },
    { 0x4FEF, "irons_estate_vignette" },
    { 0x4FF0, "irons_estate_waterfall_cave_setup" },
    { 0x4FF1, "irons_estate_waterfall_debug_checkpoint" },
    { 0x4FF2, "irons_estate_waterfall_setup" },
    { 0x4FF3, "irons_estate_whistle" },
    { 0x4FF4, "irons_exo_hack" },
    { 0x4FF5, "irons_hangar_waits" },
    { 0x4FF6, "irons_keypad_door_open" },
    { 0x4FF7, "irons_knows_music" },
    { 0x4FF8, "irons_reveal_exit_door_open" },
    { 0x4FF9, "irons_reveal_mash_loop_stopped" },
    { 0x4FFA, "irons_reveal_mash_state" },
    { 0x4FFB, "irons_reveal_scene" },
    { 0x4FFC, "irons_rooftop" },
    { 0x4FFD, "is_1_near_2" },
    { 0x4FFE, "is_abort_missile" },
    { 0x4FFF, "is_after_start" },
    { 0x5000, "is_ai" },
    { 0x5001, "is_aim_assist_enabled_on_script_model" },
    { 0x5002, "is_angles" },
    { 0x5003, "is_anim_based_death" },
    { 0x5004, "is_autopilot" },
    { 0x5005, "is_being_tracked" },
    { 0x5006, "is_blockage" },
    { 0x5007, "is_boid_in_vols" },
    { 0x5008, "is_breach_anim_loop_setup" },
    { 0x5009, "is_breach_anim_single_setup" },
    { 0x500A, "is_breaking" },
    { 0x500B, "is_bullet_damage" },
    { 0x500C, "is_cao_agent" },
    { 0x500D, "is_command_bound" },
    { 0x500E, "is_controlling_uav" },
    { 0x500F, "is_coop" },
    { 0x5010, "is_coop_online" },
    { 0x5011, "is_corpse" },
    { 0x5012, "is_createfx_type" },
    { 0x5013, "is_current_weapon_shield" },
    { 0x5014, "is_damagefeedback_hud_enabled" },
    { 0x5015, "is_damagefeedback_snd_enabled" },
    { 0x5016, "is_dds_enabled" },
    { 0x5017, "is_dead_sentient" },
    { 0x5018, "is_deathsdoor_audio_enabled" },
    { 0x5019, "is_default_start" },
    { 0x501A, "is_demo" },
    { 0x501B, "is_doing_scripted_anim" },
    { 0x501C, "is_driving_pdrone" },
    { 0x501D, "is_drone" },
    { 0x501E, "is_drone_turret_target" },
    { 0x501F, "is_drowning" },
    { 0x5020, "is_dummy" },
    { 0x5021, "is_enabled" },
    { 0x5022, "is_enemy_target" },
    { 0x5023, "is_entering_goliath" },
    { 0x5024, "is_exo_ability_weapon" },
    { 0x5025, "is_exo_climbing" },
    { 0x5026, "is_exoclimb_combat" },
    { 0x5027, "is_exoclimb_cover" },
    { 0x5028, "is_exoclimb_jumped" },
    { 0x5029, "is_exoclimb_mag_moved" },
    { 0x502A, "is_filter_lead_controller" },
    { 0x502B, "is_first_drop" },
    { 0x502C, "is_first_frame" },
    { 0x502D, "is_first_start" },
    { 0x502E, "is_float_equal" },
    { 0x502F, "is_free_running" },
    { 0x5030, "is_friendlyfire_event" },
    { 0x5031, "is_from_animsound" },
    { 0x5032, "is_gen4" },
    { 0x5033, "is_goal_blocked" },
    { 0x5034, "is_godmode" },
    { 0x5035, "is_greece" },
    { 0x5036, "is_ground_enemy" },
    { 0x5037, "is_group_a_larger_than_group_b" },
    { 0x5038, "is_guy_follow_status_blocked" },
    { 0x5039, "is_hero" },
    { 0x503A, "is_hidden_from_heli" },
    { 0x503B, "is_holding" },
    { 0x503C, "is_hovertank_weapon" },
    { 0x503D, "is_hyena" },
    { 0x503E, "is_in_array" },
    { 0x503F, "is_in_callable_location" },
    { 0x5040, "is_in_force_vol" },
    { 0x5041, "is_in_lockon_bounds" },
    { 0x5042, "is_in_thermal_vision" },
    { 0x5043, "is_indoor_map" },
    { 0x5044, "is_inside_radius_of_closest_point_of_segment" },
    { 0x5045, "is_inside_valid_location_trigger" },
    { 0x5046, "is_invulnerable_from_ai" },
    { 0x5047, "is_jumping" },
    { 0x5048, "is_land_assist_activated" },
    { 0x5049, "is_lane_start_node" },
    { 0x504A, "is_later_in_alphabet" },
    { 0x504B, "is_lethal_equipment" },
    { 0x504C, "is_light_entity" },
    { 0x504D, "is_linked" },
    { 0x504E, "is_linked_to_pod" },
    { 0x504F, "is_linked_to_ship" },
    { 0x5050, "is_locked" },
    { 0x5051, "is_looping" },
    { 0x5052, "is_lowered" },
    { 0x5053, "is_maxed_momentum" },
    { 0x5054, "is_minion" },
    { 0x5055, "is_mobile_cover" },
    { 0x5056, "is_moving" },
    { 0x5057, "is_neighboring_lane_clear" },
    { 0x5058, "is_new_weapon" },
    { 0x5059, "is_no_game_start" },
    { 0x505A, "is_node_script_origin" },
    { 0x505B, "is_node_script_struct" },
    { 0x505C, "is_objective" },
    { 0x505D, "is_occupied" },
    { 0x505E, "is_on_target" },
    { 0x505F, "is_overrode" },
    { 0x5060, "is_pair_a_closer_than_pair_b" },
    { 0x5061, "is_pdrone" },
    { 0x5062, "is_phrase_in_history" },
    { 0x5063, "is_player_cloaked" },
    { 0x5064, "is_player_controlled" },
    { 0x5065, "is_player_down" },
    { 0x5066, "is_player_down_and_out" },
    { 0x5067, "is_player_gamepad_enabled" },
    { 0x5068, "is_player_in_rocket_blast" },
    { 0x5069, "is_player_looking_at" },
    { 0x506A, "is_player_near_burke" },
    { 0x506B, "is_player_near_burke_or_flag" },
    { 0x506C, "is_player_touching_median_trigger" },
    { 0x506D, "is_player_underwater" },
    { 0x506E, "is_player_using_laser" },
    { 0x506F, "is_playing" },
    { 0x5070, "is_playing_scripted_anim" },
    { 0x5071, "is_position_in_group" },
    { 0x5072, "is_precalculated_entrance" },
    { 0x5073, "is_prepping" },
    { 0x5074, "is_protecting_flag" },
    { 0x5075, "is_pyramid_spawner" },
    { 0x5076, "is_reacting" },
    { 0x5077, "is_real_vehicle" },
    { 0x5078, "is_really_throwing_grenade" },
    { 0x5079, "is_really_throwing_grenade_rising_edge_time" },
    { 0x507A, "is_rider" },
    { 0x507B, "is_roomtype_valid" },
    { 0x507C, "is_score_a_greater_than_b" },
    { 0x507D, "is_scraping" },
    { 0x507E, "is_script_vehicle_selfremove" },
    { 0x507F, "is_shield_up_state" },
    { 0x5080, "is_shoot_button_pressed" },
    { 0x5081, "is_shotgun_damage" },
    { 0x5082, "is_shown_to_player" },
    { 0x5083, "is_so" },
    { 0x5084, "is_sonar_vision_allowed" },
    { 0x5085, "is_sonar_vision_on" },
    { 0x5086, "is_specialop" },
    { 0x5087, "is_speed_target_just_reached" },
    { 0x5088, "is_stopping" },
    { 0x5089, "is_string_a_number" },
    { 0x508A, "is_survival" },
    { 0x508B, "is_swimming" },
    { 0x508C, "is_switching" },
    { 0x508D, "is_the_player" },
    { 0x508E, "is_traffic_ent" },
    { 0x508F, "is_transition" },
    { 0x5090, "is_transition_to_both" },
    { 0x5091, "is_transition_to_left" },
    { 0x5092, "is_transition_to_no" },
    { 0x5093, "is_transition_to_right" },
    { 0x5094, "is_trigger_once" },
    { 0x5095, "is_true" },
    { 0x5096, "is_turret" },
    { 0x5097, "is_turret_accelerating" },
    { 0x5098, "is_turret_rotating" },
    { 0x5099, "is_unstorable_weapon" },
    { 0x509A, "is_using_boost" },
    { 0x509B, "is_using_model_memory_sharing" },
    { 0x509C, "is_using_zipline" },
    { 0x509D, "is_valid_clientside_exploder_name" },
    { 0x509E, "is_valid_damagetype" },
    { 0x509F, "is_valid_non_human_paint_target" },
    { 0x50A0, "is_valid_target" },
    { 0x50A1, "is_vector" },
    { 0x50A2, "is_viable_lock_target" },
    { 0x50A3, "is_walkdist_override" },
    { 0x50A4, "is_walking" },
    { 0x50A5, "is_weak_melee_weapon" },
    { 0x50A6, "is_xslice" },
    { 0x50A7, "is360" },
    { 0x50A8, "isabovewaterline" },
    { 0x50A9, "isactive" },
    { 0x50AA, "isactivekillstreakwaterrestricted" },
    { 0x50AB, "isadestructable" },
    { 0x50AC, "isads" },
    { 0x50AD, "isadsenabled" },
    { 0x50AE, "isagent" },
    { 0x50AF, "isaifunc" },
    { 0x50B0, "isaigameparticipant" },
    { 0x50B1, "isairdenied" },
    { 0x50B2, "isairdropmarker" },
    { 0x50B3, "isairplane" },
    { 0x50B4, "isaiteamparticipant" },
    { 0x50B5, "isalerted" },
    { 0x50B6, "isalliedcountryid" },
    { 0x50B7, "isalliesline" },
    { 0x50B8, "isallteamstreak" },
    { 0x50B9, "isaltmodeweapon" },
    { 0x50BA, "isanimblocked" },
    { 0x50BB, "isanimdeltaingoal" },
    { 0x50BC, "isanimloop" },
    { 0x50BD, "isanimloop_animname" },
    { 0x50BE, "isarena" },
    { 0x50BF, "isatbrinkofdeath" },
    { 0x50C0, "isattachment" },
    { 0x50C1, "isattachmentsniperscopedefault" },
    { 0x50C2, "isattachmentsniperscopedefaulttokenized" },
    { 0x50C3, "isattachmentunlocked" },
    { 0x50C4, "isattackervalid" },
    { 0x50C5, "isattackerwithindist" },
    { 0x50C6, "isattacking" },
    { 0x50C7, "isaugmentedgamemode" },
    { 0x50C8, "isbackstabevent" },
    { 0x50C9, "isbadequipment" },
    { 0x50CA, "isbeinggrappled" },
    { 0x50CB, "isbombcarrier" },
    { 0x50CC, "isbombsiteweapon" },
    { 0x50CD, "isboostingabovetriggerradius" },
    { 0x50CE, "isbreaching" },
    { 0x50CF, "isbuffequippedonweapon" },
    { 0x50D0, "isbulletdamage" },
    { 0x50D1, "isbulletweapon" },
    { 0x50D2, "isbuoy" },
    { 0x50D3, "isbuzzkillevent" },
    { 0x50D4, "iscacprimaryweapon" },
    { 0x50D5, "iscacsecondaryweapon" },
    { 0x50D6, "iscallouttypeconcat" },
    { 0x50D7, "iscallouttypeqa" },
    { 0x50D8, "iscallouttypereport" },
    { 0x50D9, "iscamounlocked" },
    { 0x50DA, "iscapturingcrate" },
    { 0x50DB, "iscaralive" },
    { 0x50DC, "iscarepackageinposteventgeo" },
    { 0x50DD, "iscarrying" },
    { 0x50DE, "iscarryingturrethead" },
    { 0x50DF, "iscarrykillstreak" },
    { 0x50E0, "ischallengeunlocked" },
    { 0x50E1, "ischangingweapon" },
    { 0x50E2, "ischeap" },
    { 0x50E3, "ischeapshieldenabled" },
    { 0x50E4, "iscivflashed" },
    { 0x50E5, "iscivilianflashed" },
    { 0x50E6, "iscombatpathnode" },
    { 0x50E7, "iscombatscriptnode" },
    { 0x50E8, "iscontested" },
    { 0x50E9, "iscontrollingdrone" },
    { 0x50EA, "iscontrollingwarbird" },
    { 0x50EB, "iscooked" },
    { 0x50EC, "iscqbwalking" },
    { 0x50ED, "iscqbwalkingorfacingenemy" },
    { 0x50EE, "iscrashing" },
    { 0x50EF, "iscrawldeltaallowed" },
    { 0x50F0, "iscrawling" },
    { 0x50F1, "iscustomanimating" },
    { 0x50F2, "isdefusing" },
    { 0x50F3, "isdeltaallowed" },
    { 0x50F4, "isdeserteagle" },
    { 0x50F5, "isdestructible" },
    { 0x50F6, "isdestructibleweapon" },
    { 0x50F7, "isdoingpain" },
    { 0x50F8, "isdoingsplash" },
    { 0x50F9, "isdoingtraversal" },
    { 0x50FA, "isdronevehiclealive" },
    { 0x50FB, "isdropping" },
    { 0x50FC, "isemped" },
    { 0x50FD, "isempedbykillstreak" },
    { 0x50FE, "isempgrenaded" },
    { 0x50FF, "isenemy" },
    { 0x5100, "isenemyvisiblefromexposed" },
    { 0x5101, "isenvironmentweapon" },
    { 0x5102, "isevent1highpriority" },
    { 0x5103, "isexcluded" },
    { 0x5104, "isexoxmg" },
    { 0x5105, "isexplosivedangeroustoplayer" },
    { 0x5106, "isexposed" },
    { 0x5107, "isfastheal" },
    { 0x5108, "isfiltered" },
    { 0x5109, "isfirstround" },
    { 0x510A, "isflashbanged" },
    { 0x510B, "isflashed" },
    { 0x510C, "isflashing" },
    { 0x510D, "isfloat" },
    { 0x510E, "isflyingkillstreak" },
    { 0x510F, "isfmjdamage" },
    { 0x5110, "isforward" },
    { 0x5111, "isfriendlyfire" },
    { 0x5112, "isfriendlyteam" },
    { 0x5113, "isfriendlytosentry" },
    { 0x5114, "isgamemodeclass" },
    { 0x5115, "isgameparticipant" },
    { 0x5116, "isgimme" },
    { 0x5117, "isgrenade" },
    { 0x5118, "isgroundfoam" },
    { 0x5119, "ishardwrireprotected" },
    { 0x511A, "isheadshot" },
    { 0x511B, "ishelicopter" },
    { 0x511C, "ishidden" },
    { 0x511D, "ishighestscoringplayer" },
    { 0x511E, "isholdinggrenade" },
    { 0x511F, "ishome" },
    { 0x5120, "ishorde" },
    { 0x5121, "ishordedrone" },
    { 0x5122, "ishordeenemysentry" },
    { 0x5123, "isinarray" },
    { 0x5124, "isinbound" },
    { 0x5125, "isinbound_single" },
    { 0x5126, "isinboundingspere" },
    { 0x5127, "isincombat" },
    { 0x5128, "isincontact" },
    { 0x5129, "isindoor" },
    { 0x512A, "isingas" },
    { 0x512B, "isinitialinfected" },
    { 0x512C, "isinkillcam" },
    { 0x512D, "isinrange" },
    { 0x512E, "isinremotetransition" },
    { 0x512F, "isinset" },
    { 0x5130, "isinsonicstun" },
    { 0x5131, "isinturret" },
    { 0x5132, "isinunlocktable" },
    { 0x5133, "isinventoryweapon" },
    { 0x5134, "isjuggernaut" },
    { 0x5135, "isjuggernautdef" },
    { 0x5136, "isjuggernautgl" },
    { 0x5137, "isjuggernautmaniac" },
    { 0x5138, "isjuggernautrecon" },
    { 0x5139, "isjuggmodejuggernaut" },
    { 0x513A, "isjuiced" },
    { 0x513B, "iskillstreakaffectedbyemp" },
    { 0x513C, "iskillstreakaffectedbyjammer" },
    { 0x513D, "iskillstreakchallenge" },
    { 0x513E, "iskillstreakdenied" },
    { 0x513F, "iskillstreaktimerrunning" },
    { 0x5140, "iskillstreakweapon" },
    { 0x5141, "islagostraversesetting" },
    { 0x5142, "islastnode" },
    { 0x5143, "islastplayeralive" },
    { 0x5144, "islastround" },
    { 0x5145, "isleaderboard" },
    { 0x5146, "isleaderboardentry" },
    { 0x5147, "isleaderboardscreen" },
    { 0x5148, "isleaderboardscreenrow" },
    { 0x5149, "isleaving" },
    { 0x514A, "islightflickering" },
    { 0x514B, "islightflickerpaused" },
    { 0x514C, "islockedonto" },
    { 0x514D, "islongrangeai" },
    { 0x514E, "islongshot" },
    { 0x514F, "islookingatorigin" },
    { 0x5150, "islootweapon" },
    { 0x5151, "islowthrowsafe" },
    { 0x5152, "ismahem" },
    { 0x5153, "ismeleemod" },
    { 0x5154, "ismembersaying" },
    { 0x5155, "ismetalsurface" },
    { 0x5156, "ismlgmatch" },
    { 0x5157, "ismlgprivatematch" },
    { 0x5158, "ismlgsplitscreen" },
    { 0x5159, "ismlgsystemlink" },
    { 0x515A, "ismoving" },
    { 0x515B, "isneargrenade" },
    { 0x515C, "isnewattacker" },
    { 0x515D, "isnodecover3d" },
    { 0x515E, "isnodecoverleft" },
    { 0x515F, "isnodecovermulticorner" },
    { 0x5160, "isnodecoverorconceal" },
    { 0x5161, "isnodecoverright" },
    { 0x5162, "isnuked" },
    { 0x5163, "isobjectivebased" },
    { 0x5164, "isobjectiveround" },
    { 0x5165, "isoffhandweapon" },
    { 0x5166, "isoffhandweaponenabled" },
    { 0x5167, "isofficer" },
    { 0x5168, "isonemanarmymenu" },
    { 0x5169, "isoneshotkill" },
    { 0x516A, "isonhumanteam" },
    { 0x516B, "isonhumanteamorspectator" },
    { 0x516C, "isorbitalcam" },
    { 0x516D, "isorigintouchingvol" },
    { 0x516E, "isoutofbounds" },
    { 0x516F, "isovertimetext" },
    { 0x5170, "ispainted" },
    { 0x5171, "ispartiallysuppressedwrapper" },
    { 0x5172, "ispathclear" },
    { 0x5173, "ispathdataavailable" },
    { 0x5174, "ispeekoutposclear" },
    { 0x5175, "isperformingmaneuver" },
    { 0x5176, "isplaced" },
    { 0x5177, "isplanting" },
    { 0x5178, "isplayer" },
    { 0x5179, "isplayerffaenemy" },
    { 0x517A, "isplayerincombat" },
    { 0x517B, "isplayerinlaststand" },
    { 0x517C, "isplayernearlocation" },
    { 0x517D, "isplayeronenemyteam" },
    { 0x517E, "isplayeroutsideofanybombsite" },
    { 0x517F, "isplayertimer" },
    { 0x5180, "isplayerweapon" },
    { 0x5181, "ispodrocket" },
    { 0x5182, "ispointascoredhigherthanb" },
    { 0x5183, "ispointblank" },
    { 0x5184, "ispossessed" },
    { 0x5185, "ispregameplaylevel" },
    { 0x5186, "ispresident" },
    { 0x5187, "isprimary" },
    { 0x5188, "isprimaryweapon" },
    { 0x5189, "isprotectedbyriotshield" },
    { 0x518A, "isrambo" },
    { 0x518B, "israndom" },
    { 0x518C, "isreallyalive" },
    { 0x518D, "isregisteredevent" },
    { 0x518E, "isrelativeteam" },
    { 0x518F, "isreloading" },
    { 0x5190, "isreserved" },
    { 0x5191, "isresetting" },
    { 0x5192, "isresuce" },
    { 0x5193, "isreviving" },
    { 0x5194, "isridekillstreak" },
    { 0x5195, "isriotshield" },
    { 0x5196, "isrocketcorpse" },
    { 0x5197, "isroundbased" },
    { 0x5198, "isrpd" },
    { 0x5199, "isrunningarmorycommand" },
    { 0x519A, "isrunningweapongive" },
    { 0x519B, "issac3" },
    { 0x519C, "issafetospawnon" },
    { 0x519D, "isscoreboosting" },
    { 0x519E, "isseeking" },
    { 0x519F, "issentry" },
    { 0x51A0, "issentrygun" },
    { 0x51A1, "issetup" },
    { 0x51A2, "isshocked" },
    { 0x51A3, "isshooting" },
    { 0x51A4, "isshootingrockets" },
    { 0x51A5, "isshotdelayed" },
    { 0x51A6, "isshotgun" },
    { 0x51A7, "isshotgunai" },
    { 0x51A8, "isshown" },
    { 0x51A9, "isshuttingdown" },
    { 0x51AA, "issidearm" },
    { 0x51AB, "issiliding" },
    { 0x51AC, "issingleshot" },
    { 0x51AD, "issliding" },
    { 0x51AE, "issniper" },
    { 0x51AF, "issniperrifle" },
    { 0x51B0, "issoringevent" },
    { 0x51B1, "issp" },
    { 0x51B2, "issp_towerdefense" },
    { 0x51B3, "isspaceai" },
    { 0x51B4, "isspawningonbattlebuddy" },
    { 0x51B5, "isspeakerinrange" },
    { 0x51B6, "isspeaking" },
    { 0x51B7, "isspeakingfailsafe" },
    { 0x51B8, "isspectator" },
    { 0x51B9, "issquad" },
    { 0x51BA, "isstack" },
    { 0x51BB, "isstanceallowedwrapper" },
    { 0x51BC, "isstationary" },
    { 0x51BD, "isstrstart" },
    { 0x51BE, "isstuck" },
    { 0x51BF, "isstucktofriendly" },
    { 0x51C0, "issue_color_order_to_ai" },
    { 0x51C1, "issue_color_orders" },
    { 0x51C2, "issue_color_orders_generic" },
    { 0x51C3, "issue_leave_node_order_to_ai_and_get_ai" },
    { 0x51C4, "issuffix" },
    { 0x51C5, "issupportstreak" },
    { 0x51C6, "issuppressedwrapper" },
    { 0x51C7, "isswimming" },
    { 0x51C8, "isswitchingteams" },
    { 0x51C9, "issystemhacked" },
    { 0x51CA, "istactical" },
    { 0x51CB, "istakingdamage" },
    { 0x51CC, "istank" },
    { 0x51CD, "istatechange" },
    { 0x51CE, "isteam" },
    { 0x51CF, "isteaminlaststand" },
    { 0x51D0, "isteamintelcomplete" },
    { 0x51D1, "isteamparticipant" },
    { 0x51D2, "isteamsaying" },
    { 0x51D3, "isteamspeaking" },
    { 0x51D4, "isteamswitchbalanced" },
    { 0x51D5, "isthinkfast" },
    { 0x51D6, "isthinkfastweapon" },
    { 0x51D7, "isthreatenedbyenemy" },
    { 0x51D8, "isthrowbackevent" },
    { 0x51D9, "istimelimitedchallenge" },
    { 0x51DA, "istouchingbadtrigger" },
    { 0x51DB, "istouchingwater" },
    { 0x51DC, "istrap" },
    { 0x51DD, "istraversing" },
    { 0x51DE, "istryingtousekillstreakslot" },
    { 0x51DF, "isturretenergyweapon" },
    { 0x51E0, "isundefined" },
    { 0x51E1, "isunstableground" },
    { 0x51E2, "isup" },
    { 0x51E3, "isurgentwalk" },
    { 0x51E4, "isusabilityenabled" },
    { 0x51E5, "isused" },
    { 0x51E6, "isusingremote" },
    { 0x51E7, "isusingsamevoice" },
    { 0x51E8, "isvalidattachment" },
    { 0x51E9, "isvalidbattlebuddy" },
    { 0x51EA, "isvalidcamo" },
    { 0x51EB, "isvalidclass" },
    { 0x51EC, "isvaliddamagecause" },
    { 0x51ED, "isvalidequipment" },
    { 0x51EE, "isvalidevent" },
    { 0x51EF, "isvalidffatarget" },
    { 0x51F0, "isvalidfoamspace" },
    { 0x51F1, "isvalidkillstreak" },
    { 0x51F2, "isvalidlastweapon" },
    { 0x51F3, "isvalidmovespeedscaleweapon" },
    { 0x51F4, "isvalidnonshieldweapon" },
    { 0x51F5, "isvalidoffhand" },
    { 0x51F6, "isvalidprimary" },
    { 0x51F7, "isvalidreticle" },
    { 0x51F8, "isvalidsecondary" },
    { 0x51F9, "isvalidsoundcause" },
    { 0x51FA, "isvalidspawn" },
    { 0x51FB, "isvalidstreakplayer" },
    { 0x51FC, "isvalidteamtarget" },
    { 0x51FD, "isvalidtispawnposition" },
    { 0x51FE, "isvalidunderwaterweapon" },
    { 0x51FF, "isvalidweapon" },
    { 0x5200, "isvehicle" },
    { 0x5201, "isvehiclealive" },
    { 0x5202, "isvehicleattached" },
    { 0x5203, "isvehiclekilltrigger" },
    { 0x5204, "iswading" },
    { 0x5205, "iswarbird" },
    { 0x5206, "iswatersurface" },
    { 0x5207, "isweaponallowedingrenadegraceperiod" },
    { 0x5208, "isweaponchallenge" },
    { 0x5209, "isweaponclasschallenge" },
    { 0x520A, "isweaponenabled" },
    { 0x520B, "isweaponinitialized" },
    { 0x520C, "isweaponswitchenabled" },
    { 0x520D, "iswinner" },
    { 0x520E, "iswithinattackheight" },
    { 0x520F, "itemremoveammofromaltmodes" },
    { 0x5210, "itiot_dialogue" },
    { 0x5211, "itiot_fade_in" },
    { 0x5212, "itiot_fade_out" },
    { 0x5213, "itiot_logic" },
    { 0x5214, "jackson" },
    { 0x5215, "jackson_dodge_drones" },
    { 0x5216, "jackson_intro" },
    { 0x5217, "jammer_1_defenders_logic" },
    { 0x5218, "jammer_1_nag_lines" },
    { 0x5219, "jammer_2_nag_lines" },
    { 0x521A, "jammer_3_drones" },
    { 0x521B, "jammer_3_navy_drone_combat" },
    { 0x521C, "jammer_3_navy_drone_drones_setup" },
    { 0x521D, "jammer_3_navy_drone_guy_setup" },
    { 0x521E, "jammer_3_navy_guys" },
    { 0x521F, "jammer_3_remove_from_array_when_dead" },
    { 0x5220, "jammer_3_shrike_flyby" },
    { 0x5221, "jammer_enemies_hint" },
    { 0x5222, "jammer_enemies_spawn" },
    { 0x5223, "jammer_enemy_1_think" },
    { 0x5224, "jammer_enemy_2_think" },
    { 0x5225, "jammer_guards" },
    { 0x5226, "jammer_objective" },
    { 0x5227, "jammer_plant" },
    { 0x5228, "jammer_think" },
    { 0x5229, "javelin_dof" },
    { 0x522A, "jeeprideplayerarms" },
    { 0x522B, "jeeprideplayerlinktag" },
    { 0x522C, "jet_badplace" },
    { 0x522D, "jet_boom" },
    { 0x522E, "jet_crash_move" },
    { 0x522F, "jet_crash_path" },
    { 0x5230, "jet_crash_points" },
    { 0x5231, "jet_engine_fx" },
    { 0x5232, "jet_fire_guns" },
    { 0x5233, "jet_flash_fx_blink" },
    { 0x5234, "jet_flash_fx_green" },
    { 0x5235, "jet_flash_fx_red" },
    { 0x5236, "jet_flight_time" },
    { 0x5237, "jet_fly_vec" },
    { 0x5238, "jet_flyby" },
    { 0x5239, "jet_flyto" },
    { 0x523A, "jet_init" },
    { 0x523B, "jet_launch_missile" },
    { 0x523C, "jet_moment" },
    { 0x523D, "jet_parts" },
    { 0x523E, "jet_planesound" },
    { 0x523F, "jet_reset" },
    { 0x5240, "jet_shake" },
    { 0x5241, "jet_shakes" },
    { 0x5242, "jet_shoot_gun" },
    { 0x5243, "jet_shoot_missile_cbdr" },
    { 0x5244, "jet_spawn_loop" },
    { 0x5245, "jet_timer" },
    { 0x5246, "jet_wait_boom" },
    { 0x5247, "jet_wait_fire_missile" },
    { 0x5248, "jet_wait_start_firing" },
    { 0x5249, "jet_wait_stop_firing" },
    { 0x524A, "jetbike" },
    { 0x524B, "jetbike_allow_player_use" },
    { 0x524C, "jetbike_allow_player_use_detroit" },
    { 0x524D, "jetbike_allow_player_use_internal" },
    { 0x524E, "jetbike_anims_initialized" },
    { 0x524F, "jetbike_audio" },
    { 0x5250, "jetbike_blend_out_fake_speed" },
    { 0x5251, "jetbike_collision_hit_func" },
    { 0x5252, "jetbike_condition_callback_to_state_destruct" },
    { 0x5253, "jetbike_condition_callback_to_state_distant" },
    { 0x5254, "jetbike_condition_callback_to_state_flyby" },
    { 0x5255, "jetbike_condition_callback_to_state_flying" },
    { 0x5256, "jetbike_condition_callback_to_state_flyover" },
    { 0x5257, "jetbike_condition_callback_to_state_hover" },
    { 0x5258, "jetbike_condition_callback_to_state_off" },
    { 0x5259, "jetbike_condition_callback_to_state_starting" },
    { 0x525A, "jetbike_constructor" },
    { 0x525B, "jetbike_dismount_red_light" },
    { 0x525C, "jetbike_dismount_riding_player" },
    { 0x525D, "jetbike_exit_pre_mount_lighting" },
    { 0x525E, "jetbike_exitdrive_bones" },
    { 0x525F, "jetbike_exitdrive_burke" },
    { 0x5260, "jetbike_exitdrive_door" },
    { 0x5261, "jetbike_exitdrive_fov_changes" },
    { 0x5262, "jetbike_exitdrive_joker_and_doctor" },
    { 0x5263, "jetbike_exitdrive_player" },
    { 0x5264, "jetbike_handle_fake_speed" },
    { 0x5265, "jetbike_handle_viewmodel_anims" },
    { 0x5266, "jetbike_hit_cliff" },
    { 0x5267, "jetbike_hit_landing" },
    { 0x5268, "jetbike_hit_ramp" },
    { 0x5269, "jetbike_intro" },
    { 0x526A, "jetbike_intro_hover_npc_bikes" },
    { 0x526B, "jetbike_intro_hover_player_bike" },
    { 0x526C, "jetbike_is_trailing" },
    { 0x526D, "jetbike_landing_finished" },
    { 0x526E, "jetbike_npc_load" },
    { 0x526F, "jetbike_obj" },
    { 0x5270, "jetbike_physics" },
    { 0x5271, "jetbike_player_think" },
    { 0x5272, "jetbike_set_viewmodel_state" },
    { 0x5273, "jetbike_snd_messages" },
    { 0x5274, "jetbike_soft_landing" },
    { 0x5275, "jetbike_speedometer_off" },
    { 0x5276, "jetbike_speedometer_on" },
    { 0x5277, "jetbike_speedometer_on_thread" },
    { 0x5278, "jetbike_speedometer_think" },
    { 0x5279, "jetbike_start_hovering" },
    { 0x527A, "jetbike_start_hovering_now" },
    { 0x527B, "jetbike_stop_hovering" },
    { 0x527C, "jetbike_stop_hovering_now" },
    { 0x527D, "jetbike_stop_player_think" },
    { 0x527E, "jetbike_stop_player_use" },
    { 0x527F, "jetbike_thrust_fx" },
    { 0x5280, "jetbike_thrust_fx_internal" },
    { 0x5281, "jetbike_too_slow" },
    { 0x5282, "jetbike_tread_fx" },
    { 0x5283, "jetbikes_arrive_at_school" },
    { 0x5284, "jethud" },
    { 0x5285, "jetpack_fly_input_monitor" },
    { 0x5286, "jetpack_fly_play_anims" },
    { 0x5287, "jetpack_fly_setup" },
    { 0x5288, "jets" },
    { 0x5289, "jkuline" },
    { 0x528A, "jkupoint" },
    { 0x528B, "jkuprint" },
    { 0x528C, "jkuprint3dattached" },
    { 0x528D, "joined" },
    { 0x528E, "joinedvo" },
    { 0x528F, "joining_team" },
    { 0x5290, "jointext" },
    { 0x5291, "joker" },
    { 0x5292, "joker_advance_hospital" },
    { 0x5293, "joker_bike" },
    { 0x5294, "joker_bike_idle_wait" },
    { 0x5295, "joker_bones_bike_start" },
    { 0x5296, "joker_dismount" },
    { 0x5297, "joker_fence" },
    { 0x5298, "joker_gate_jtbk_land" },
    { 0x5299, "joker_gate_jtbk_lift" },
    { 0x529A, "joker_onbike" },
    { 0x529B, "joker_red_arm_light_checkpoint" },
    { 0x529C, "joker_sentinel_kva_reveal" },
    { 0x529D, "jugg" },
    { 0x529E, "juggernatudefmod" },
    { 0x529F, "juggernaut" },
    { 0x52A0, "juggernaut_hunt_immediately_behavior" },
    { 0x52A1, "juggernaut_initialized" },
    { 0x52A2, "juggernaut_next_alert_time" },
    { 0x52A3, "juggernaut_sound_when_player_close" },
    { 0x52A4, "juggernautallies" },
    { 0x52A5, "juggernautattachments" },
    { 0x52A6, "juggernautaxis" },
    { 0x52A7, "juggernautmod" },
    { 0x52A8, "juggernautmodifydamage" },
    { 0x52A9, "juggernautoverlay" },
    { 0x52AA, "juggernautsounds" },
    { 0x52AB, "juggernautsuicide" },
    { 0x52AC, "juggernautweak" },
    { 0x52AD, "juggmovespeedscaler" },
    { 0x52AE, "juggremoveongameended" },
    { 0x52AF, "juggremover" },
    { 0x52B0, "juggsettings" },
    { 0x52B1, "juggtype" },
    { 0x52B2, "juicedicon" },
    { 0x52B3, "juicedtimer" },
    { 0x52B4, "jump_across_112_over_32" },
    { 0x52B5, "jump_anim_with_gravity" },
    { 0x52B6, "jump_animstring" },
    { 0x52B7, "jump_complete" },
    { 0x52B8, "jump_direction_is_valid" },
    { 0x52B9, "jump_down_now" },
    { 0x52BA, "jump_down_when_in_view" },
    { 0x52BB, "jump_down_when_in_view_cormack" },
    { 0x52BC, "jump_reach_status" },
    { 0x52BD, "jump_scene_think" },
    { 0x52BE, "jump_sound" },
    { 0x52BF, "jump_state" },
    { 0x52C0, "jump_target" },
    { 0x52C1, "jump_through_window_human" },
    { 0x52C2, "jump_to_mag_direction_is_valid" },
    { 0x52C3, "jump_training_hint" },
    { 0x52C4, "jump_training_vo_think" },
    { 0x52C5, "jump_type_select" },
    { 0x52C6, "jumpbuttonbuffer" },
    { 0x52C7, "jumpdown_130_human" },
    { 0x52C8, "jumpdown_224" },
    { 0x52C9, "jumper_clip_1" },
    { 0x52CA, "jumper_clip_2" },
    { 0x52CB, "jumping_rig" },
    { 0x52CC, "jumping_take_down" },
    { 0x52CD, "jumpintowater" },
    { 0x52CE, "jumpstatelistener" },
    { 0x52CF, "justconvertedoneshot" },
    { 0x52D0, "justswitchedtokillstreakweapon" },
    { 0x52D1, "kamikaze" },
    { 0x52D2, "kamikaze_drone_explo" },
    { 0x52D3, "kamikaze_drone_get_target_origin" },
    { 0x52D4, "kamikaze_new_style" },
    { 0x52D5, "kamikaze_shooter" },
    { 0x52D6, "kb_locked" },
    { 0x52D7, "kc_randomspawntext" },
    { 0x52D8, "kc_teamspawntext" },
    { 0x52D9, "keep_active_distance_text" },
    { 0x52DA, "keep_filling_clip_ammo" },
    { 0x52DB, "keep_gunner_oriented_with_turret" },
    { 0x52DC, "keep_primary" },
    { 0x52DD, "keep_stair_override" },
    { 0x52DE, "keep_up_with_burke" },
    { 0x52DF, "keepcarryweapon" },
    { 0x52E0, "keepemptimeremaining" },
    { 0x52E1, "keepiconpositioned" },
    { 0x52E2, "keepnukeemptimeremaining" },
    { 0x52E3, "keeppositioned" },
    { 0x52E4, "keepprogress" },
    { 0x52E5, "keeppursuingtargetradiussq" },
    { 0x52E6, "keeptryingtomelee" },
    { 0x52E7, "keepweapons" },
    { 0x52E8, "key_hint_print" },
    { 0x52E9, "keycard" },
    { 0x52EA, "keyobject" },
    { 0x52EB, "kick_door" },
    { 0x52EC, "kick_in_duration" },
    { 0x52ED, "kick_off_snipers_dead1_specific" },
    { 0x52EE, "kick_off_snipers_dead2_specific" },
    { 0x52EF, "kick_off_snipers_dead3_specific" },
    { 0x52F0, "kick_out_duration" },
    { 0x52F1, "kick_player_timeout" },
    { 0x52F2, "kickifdontspawn" },
    { 0x52F3, "kickoff_modify" },
    { 0x52F4, "kickoff_notify" },
    { 0x52F5, "kickoff_sniper_combat" },
    { 0x52F6, "kickwait" },
    { 0x52F7, "kid" },
    { 0x52F8, "kill_after_timeout" },
    { 0x52F9, "kill_all_env_fx" },
    { 0x52FA, "kill_all_inside_guys_now" },
    { 0x52FB, "kill_all_players_trigger" },
    { 0x52FC, "kill_all_streetfighters" },
    { 0x52FD, "kill_and_delete" },
    { 0x52FE, "kill_badplace" },
    { 0x52FF, "kill_before_water" },
    { 0x5300, "kill_bridge_copcar_light" },
    { 0x5301, "kill_bridge_fog" },
    { 0x5302, "kill_clipping_enemy" },
    { 0x5303, "kill_color_replacements" },
    { 0x5304, "kill_controllable_drone_swarm" },
    { 0x5305, "kill_counts" },
    { 0x5306, "kill_damage" },
    { 0x5307, "kill_death_anim_thread" },
    { 0x5308, "kill_death_anim_thread_picked" },
    { 0x5309, "kill_deathflag" },
    { 0x530A, "kill_deathflag_proc" },
    { 0x530B, "kill_enemies" },
    { 0x530C, "kill_exploder" },
    { 0x530D, "kill_exterior_vfx" },
    { 0x530E, "kill_flashlight_fx" },
    { 0x530F, "kill_flicker_when_damaged" },
    { 0x5310, "kill_fog_on_hill" },
    { 0x5311, "kill_fx" },
    { 0x5312, "kill_fx_attached_to_chain" },
    { 0x5313, "kill_fx_by_view_think" },
    { 0x5314, "kill_fx_on_chain" },
    { 0x5315, "kill_fx_thread" },
    { 0x5316, "kill_fx_with_handle" },
    { 0x5317, "kill_fx_with_handle_on_death" },
    { 0x5318, "kill_fx_with_handle_on_death_internal" },
    { 0x5319, "kill_gideon_bubble_trail" },
    { 0x531A, "kill_gideon_bubble_trail_cg" },
    { 0x531B, "kill_goals" },
    { 0x531C, "kill_heli_logic" },
    { 0x531D, "kill_intro_vfx" },
    { 0x531E, "kill_jolt" },
    { 0x531F, "kill_kamikaze_drones" },
    { 0x5320, "kill_kva_on_rope" },
    { 0x5321, "kill_last_sniper_guys" },
    { 0x5322, "kill_lights" },
    { 0x5323, "kill_local_units" },
    { 0x5324, "kill_looping_drone_camera_sounds" },
    { 0x5325, "kill_me" },
    { 0x5326, "kill_me_if_player_escapes" },
    { 0x5327, "kill_me_in_x_seconds" },
    { 0x5328, "kill_me_on_flag" },
    { 0x5329, "kill_me_on_notify" },
    { 0x532A, "kill_me_on_sentrev_cleanup" },
    { 0x532B, "kill_me_on_truck_pushover" },
    { 0x532C, "kill_no_react" },
    { 0x532D, "kill_npc_on_impact" },
    { 0x532E, "kill_objects" },
    { 0x532F, "kill_off_inside_guy" },
    { 0x5330, "kill_on_animend" },
    { 0x5331, "kill_on_damage" },
    { 0x5332, "kill_on_fastzip_jump" },
    { 0x5333, "kill_on_trigger" },
    { 0x5334, "kill_oneshot" },
    { 0x5335, "kill_path_on_death" },
    { 0x5336, "kill_player_if_move_ahead" },
    { 0x5337, "kill_player_under_log_execution" },
    { 0x5338, "kill_player_under_log_test" },
    { 0x5339, "kill_riders" },
    { 0x533A, "kill_s_flicker_jb" },
    { 0x533B, "kill_s_flicker_sh" },
    { 0x533C, "kill_spawner" },
    { 0x533D, "kill_spawnernum" },
    { 0x533E, "kill_spotlight" },
    { 0x533F, "kill_streak" },
    { 0x5340, "kill_target" },
    { 0x5341, "kill_trigger" },
    { 0x5342, "kill_trigger_array" },
    { 0x5343, "kill_vehicle_spawner" },
    { 0x5344, "kill_vol" },
    { 0x5345, "kill_when_player_close" },
    { 0x5346, "kill_when_player_not_looking" },
    { 0x5347, "kill_when_player_reaches_overhang" },
    { 0x5348, "kill_with_delay" },
    { 0x5349, "kill_wrapper" },
    { 0x534A, "killable_kamikazes" },
    { 0x534B, "killafterdodgeevent" },
    { 0x534C, "killagent" },
    { 0x534D, "killallallies" },
    { 0x534E, "killcam" },
    { 0x534F, "killcamcleanup" },
    { 0x5350, "killcament" },
    { 0x5351, "killcamentnum" },
    { 0x5352, "killcamlength" },
    { 0x5353, "killcamoffset" },
    { 0x5354, "killcamstartedtimedeciseconds" },
    { 0x5355, "killcamstarttime" },
    { 0x5356, "killcamtime" },
    { 0x5357, "killcamvalid" },
    { 0x5358, "killchemrackvfx" },
    { 0x5359, "killconfirmedevent" },
    { 0x535A, "killcount" },
    { 0x535B, "killdeathanimating" },
    { 0x535C, "killdeniedevent" },
    { 0x535D, "killdog" },
    { 0x535E, "killedaxis" },
    { 0x535F, "killedballcarrierevent" },
    { 0x5360, "killedbestenemyplayer" },
    { 0x5361, "killedby" },
    { 0x5362, "killedinuse" },
    { 0x5363, "killedplayer" },
    { 0x5364, "killedplayerevent" },
    { 0x5365, "killedplayers" },
    { 0x5366, "killedplayerscurrent" },
    { 0x5367, "killedself" },
    { 0x5368, "killentity" },
    { 0x5369, "killer_tracker" },
    { 0x536A, "killfishbubblesfx" },
    { 0x536B, "killflagcarrierevent" },
    { 0x536C, "killfloodspawnersonflag" },
    { 0x536D, "killfxontag_safe" },
    { 0x536E, "killidleanim" },
    { 0x536F, "killing_will_down" },
    { 0x5370, "killlights" },
    { 0x5371, "killmutefx" },
    { 0x5372, "killnowscore" },
    { 0x5373, "killobjectsunderwater" },
    { 0x5374, "killonbadpath" },
    { 0x5375, "killoverclockfx" },
    { 0x5376, "killpingfx" },
    { 0x5377, "killplayer" },
    { 0x5378, "killplayersincloud" },
    { 0x5379, "killplayersusingremotestreaks" },
    { 0x537A, "killrepulsorfx" },
    { 0x537B, "killsasinfected" },
    { 0x537C, "killself" },
    { 0x537D, "killshouldaddtokillstreak" },
    { 0x537E, "killsomecivilians" },
    { 0x537F, "killspawn_groups" },
    { 0x5380, "killspawner" },
    { 0x5381, "killssinceammodrop" },
    { 0x5382, "killssinceinteldrop" },
    { 0x5383, "killsthislife" },
    { 0x5384, "killstimfx" },
    { 0x5385, "killstreak_botcanuse" },
    { 0x5386, "killstreak_botfunc" },
    { 0x5387, "killstreak_botparm" },
    { 0x5388, "killstreak_duration" },
    { 0x5389, "killstreak_gimme_slot" },
    { 0x538A, "killstreak_global_bp_exists_for" },
    { 0x538B, "killstreak_info" },
    { 0x538C, "killstreak_inuse" },
    { 0x538D, "killstreak_laser_fxmode" },
    { 0x538E, "killstreak_slot_1" },
    { 0x538F, "killstreak_slot_2" },
    { 0x5390, "killstreak_slot_3" },
    { 0x5391, "killstreak_slot_4" },
    { 0x5392, "killstreak_stacking_start_slot" },
    { 0x5393, "killstreak_string_table" },
    { 0x5394, "killstreak_tank_groups" },
    { 0x5395, "killstreak_tanks" },
    { 0x5396, "killstreak_team" },
    { 0x5397, "killstreak1" },
    { 0x5398, "killstreak2" },
    { 0x5399, "killstreak3" },
    { 0x539A, "killstreak4" },
    { 0x539B, "killstreakcounter" },
    { 0x539C, "killstreakcratethink" },
    { 0x539D, "killstreakearned" },
    { 0x539E, "killstreakfuncs" },
    { 0x539F, "killstreakhit" },
    { 0x53A0, "killstreakindexweapon" },
    { 0x53A1, "killstreakjoinevent" },
    { 0x53A2, "killstreakmines" },
    { 0x53A3, "killstreakmodules" },
    { 0x53A4, "killstreakrewards" },
    { 0x53A5, "killstreakrounddelay" },
    { 0x53A6, "killstreaks" },
    { 0x53A7, "killstreaks_array" },
    { 0x53A8, "killstreakscaler" },
    { 0x53A9, "killstreaksdisabled" },
    { 0x53AA, "killstreaksetupfuncs" },
    { 0x53AB, "killstreakspawnshield" },
    { 0x53AC, "killstreaksplashnotify" },
    { 0x53AD, "killstreaktagevent" },
    { 0x53AE, "killstreaktype" },
    { 0x53AF, "killstreakusepressed" },
    { 0x53B0, "killstreakusewaiter" },
    { 0x53B1, "killstreakweildweapons" },
    { 0x53B2, "killstreakwieldweapons" },
    { 0x53B3, "killteaminlaststand" },
    { 0x53B4, "killtimer" },
    { 0x53B5, "killtrigger" },
    { 0x53B6, "killwarbirds" },
    { 0x53B7, "killwhilecapture" },
    { 0x53B8, "killwithballevent" },
    { 0x53B9, "killwithflagevent" },
    { 0x53BA, "killwrapper" },
    { 0x53BB, "killz" },
    { 0x53BC, "knee_l_org" },
    { 0x53BD, "knife" },
    { 0x53BE, "knife_attached" },
    { 0x53BF, "knife_guy_cleanup" },
    { 0x53C0, "knife_guy_stabs_player" },
    { 0x53C1, "knifedetach" },
    { 0x53C2, "knifeequip" },
    { 0x53C3, "knock_down_player_coop" },
    { 0x53C4, "knock_player_off_wall" },
    { 0x53C5, "knocked_to_oncoming_rumble" },
    { 0x53C6, "knockoutofads" },
    { 0x53C7, "knox" },
    { 0x53C8, "knox_arm_jerk" },
    { 0x53C9, "knox_death_scene" },
    { 0x53CA, "knox_death_start" },
    { 0x53CB, "knox_go_limp" },
    { 0x53CC, "knox_hand_grab" },
    { 0x53CD, "knox_move_to_breach_door" },
    { 0x53CE, "knox_pda" },
    { 0x53CF, "knox_pod" },
    { 0x53D0, "knox_post_breach_move" },
    { 0x53D1, "knox_rumble" },
    { 0x53D2, "knox_server_room_se" },
    { 0x53D3, "knox_server_room_se_peek" },
    { 0x53D4, "knuckledusters" },
    { 0x53D5, "knuckles_bloodsplosion" },
    { 0x53D6, "knuckles_left_fellout" },
    { 0x53D7, "knuckles_reenable_grapple" },
    { 0x53D8, "knuckles_right_fellout" },
    { 0x53D9, "knuckles_watch_dude_damage" },
    { 0x53DA, "ks_module_added_points_column" },
    { 0x53DB, "ks_module_killstreak_ref_column" },
    { 0x53DC, "ks_module_ref_column" },
    { 0x53DD, "ks_module_slot_column" },
    { 0x53DE, "ks_module_support_column" },
    { 0x53DF, "ks_modules_table" },
    { 0x53E0, "kt_time" },
    { 0x53E1, "kva" },
    { 0x53E2, "kva_1_dead" },
    { 0x53E3, "kva_2_dead" },
    { 0x53E4, "kva_ambush_last_group_reveal" },
    { 0x53E5, "kva_ar" },
    { 0x53E6, "kva_basement_guy" },
    { 0x53E7, "kva_basement_idle_start" },
    { 0x53E8, "kva_bathroom" },
    { 0x53E9, "kva_crawling" },
    { 0x53EA, "kva_dead_count" },
    { 0x53EB, "kva_death_impact_post" },
    { 0x53EC, "kva_fake_death_checker" },
    { 0x53ED, "kva_fake_death_checker_bloodfx" },
    { 0x53EE, "kva_gets_shot" },
    { 0x53EF, "kva_guard_beatup" },
    { 0x53F0, "kva_guard_corner" },
    { 0x53F1, "kva_guy1_footsteps" },
    { 0x53F2, "kva_guy1_gets_shot" },
    { 0x53F3, "kva_guy2_footsteps" },
    { 0x53F4, "kva_guy2_gets_shot" },
    { 0x53F5, "kva_guy3_footsteps" },
    { 0x53F6, "kva_guy3_gets_shot" },
    { 0x53F7, "kva_heavy" },
    { 0x53F8, "kva_hit_glass_impact" },
    { 0x53F9, "kva_hostage_beatup" },
    { 0x53FA, "kva_hostage_execution_array" },
    { 0x53FB, "kva_hostage_leader" },
    { 0x53FC, "kva_hostage_minister" },
    { 0x53FD, "kva_hostage_victim" },
    { 0x53FE, "kva_knife_takedown" },
    { 0x53FF, "kva_knife_takedown_scene_begin" },
    { 0x5400, "kva_last_heavy" },
    { 0x5401, "kva_opening_vo" },
    { 0x5402, "kva_pickup_flip_and_skid" },
    { 0x5403, "kva_pickup_hit_bus" },
    { 0x5404, "kva_pickup_hit_divider_01" },
    { 0x5405, "kva_pickup_hit_divider_03" },
    { 0x5406, "kva_pickup_hit_windshield" },
    { 0x5407, "kva_pickup_wheel_skid_ram" },
    { 0x5408, "kva_pm_guard" },
    { 0x5409, "kva_retreat_drone_think" },
    { 0x540A, "kva_retreat_drones_animated" },
    { 0x540B, "kva_sentinel_atlas_reveal_moment" },
    { 0x540C, "kva_shooter_s1" },
    { 0x540D, "kva_shooter_s2" },
    { 0x540E, "kva_show_timer" },
    { 0x540F, "kva_spot_player_durring_fall" },
    { 0x5410, "kva_truck" },
    { 0x5411, "kva1_sentinel_kva_reveal" },
    { 0x5412, "kva2_sentinel_kva_reveal" },
    { 0x5413, "kva3_sentinel_kva_reveal" },
    { 0x5414, "kvafollowtarget" },
    { 0x5415, "kvaguardanimations" },
    { 0x5416, "kvasafehouseguardarray" },
    { 0x5417, "kvashotgunners" },
    { 0x5418, "l" },
    { 0x5419, "lab" },
    { 0x541A, "lab_alarms" },
    { 0x541B, "lab_brk_illtakedriver" },
    { 0x541C, "lab_camera_light" },
    { 0x541D, "lab_climb_lighting" },
    { 0x541E, "lab_climb_rim_lighting_off" },
    { 0x541F, "lab_doorway_dyn_path" },
    { 0x5420, "lab_e3_end_logo" },
    { 0x5421, "lab_exfil_detonate_anims" },
    { 0x5422, "lab_exfil_missile_strike" },
    { 0x5423, "lab_exfil_wrist_panel" },
    { 0x5424, "lab_intro_screen" },
    { 0x5425, "lab_locations" },
    { 0x5426, "lab_mute_gun_holster" },
    { 0x5427, "lab_root_climb_dof" },
    { 0x5428, "lab_root_climb_vision" },
    { 0x5429, "lab_script_exit_volume" },
    { 0x542A, "lab_script_volume" },
    { 0x542B, "lab_tank_exit_crmk_land" },
    { 0x542C, "lab_tank_exit_crmk_stand" },
    { 0x542D, "lab_tank_exit_crmk_walk" },
    { 0x542E, "lab_tank_exit_gid_at_hatch" },
    { 0x542F, "lab_tank_exit_gid_stairs" },
    { 0x5430, "lab_tank_exit_gid_stand" },
    { 0x5431, "lab_tank_exit_gid_walk" },
    { 0x5432, "lab_tank_exit_knx_at_hatch" },
    { 0x5433, "lab_tank_exit_knx_land" },
    { 0x5434, "lab_tank_exit_knx_stairs" },
    { 0x5435, "lab_tank_exit_knx_stand" },
    { 0x5436, "lab_tank_exit_plr_at_hatch" },
    { 0x5437, "lab_tank_exit_plr_land" },
    { 0x5438, "lab_tank_exit_plr_stairs" },
    { 0x5439, "lab_tank_exit_plr_stand" },
    { 0x543A, "lab_vehicle_callback" },
    { 0x543B, "lab2_mp" },
    { 0x543C, "lab2customairstrike" },
    { 0x543D, "lab2customlaserstreakfunc" },
    { 0x543E, "laboratory" },
    { 0x543F, "laboratory_cqb" },
    { 0x5440, "laboratory_elevator_to_hall" },
    { 0x5441, "laboratory_start_idle" },
    { 0x5442, "laboratory_traversal" },
    { 0x5443, "labpaladinoverrides" },
    { 0x5444, "labtemptuner1" },
    { 0x5445, "labtemptuner2" },
    { 0x5446, "labtemptuner3" },
    { 0x5447, "lag_ajani_brief_equip" },
    { 0x5448, "lag_ajani_brief_start" },
    { 0x5449, "lag_alley_gideon_shoulder_charge" },
    { 0x544A, "lag_brk_nocleanshot_done" },
    { 0x544B, "lag_brk_onme_done" },
    { 0x544C, "lag_brk_stayclose_done" },
    { 0x544D, "lag_brk_takeoutsuv_done" },
    { 0x544E, "lag_freeway_jump_gideon" },
    { 0x544F, "lag_gid_brief_equip" },
    { 0x5450, "lag_gid_brief_start" },
    { 0x5451, "lag_gl_end_logo" },
    { 0x5452, "lag_gov_wallpullup_exit" },
    { 0x5453, "lag_gov_wallpullup_exit_foot" },
    { 0x5454, "lag_hostage_hades" },
    { 0x5455, "lag_hostage_pm" },
    { 0x5456, "lag_intro_brief_ajn" },
    { 0x5457, "lag_intro_brief_gdn" },
    { 0x5458, "lag_intro_brief_jkr" },
    { 0x5459, "lag_intro_vo_overlap_mix" },
    { 0x545A, "lag_joke_brief_approach_plr" },
    { 0x545B, "lag_joke_brief_equip_1" },
    { 0x545C, "lag_joke_brief_equip_2" },
    { 0x545D, "lag_joke_brief_equip_3" },
    { 0x545E, "lag_joke_brief_radio" },
    { 0x545F, "lag_joke_brief_wpn_check" },
    { 0x5460, "lag_mid_qte_foley_01a" },
    { 0x5461, "lag_mid_qte_foley_01b" },
    { 0x5462, "lag_mid_qte_foley_02" },
    { 0x5463, "lag_mid_qte_impact" },
    { 0x5464, "lag_mid_qte_mtl_chunk" },
    { 0x5465, "lag_mid_qte_truck_01" },
    { 0x5466, "lag_mid_qte_truck_02" },
    { 0x5467, "lag_mid_qte_truck_bounce" },
    { 0x5468, "lag_mid_qte_truck_skids" },
    { 0x5469, "lag_npc_exo_climb_foley" },
    { 0x546A, "lag_pm_rescue_pt1_gdn" },
    { 0x546B, "lag_pm_rescue_pt2_ajn" },
    { 0x546C, "lag_pm_rescue_pt2_gdn" },
    { 0x546D, "lag_pm_rescue_pt2_pm" },
    { 0x546E, "lag_shore_rescue_ajani" },
    { 0x546F, "lag_shore_rescue_burke" },
    { 0x5470, "lag_shore_rescue_joker" },
    { 0x5471, "lag_video_log_irs" },
    { 0x5472, "lagos_custom_laser" },
    { 0x5473, "lagos_irons_speech_bink" },
    { 0x5474, "lagos_locations" },
    { 0x5475, "lagos_player_swimming_pt1" },
    { 0x5476, "lagos_player_swimming_pt2" },
    { 0x5477, "lagos_player_swimming_truck_anims" },
    { 0x5478, "lagos_shore_pcap_start" },
    { 0x5479, "lagos_swimming_drowning_start" },
    { 0x547A, "lagos_swimming_into_stroke" },
    { 0x547B, "lagos_swimming_stroke" },
    { 0x547C, "lagos_technical_turret_fire" },
    { 0x547D, "lagos_title_screen" },
    { 0x547E, "lagoshack" },
    { 0x547F, "lake_autosave" },
    { 0x5480, "lake_callouts" },
    { 0x5481, "lake_chopper" },
    { 0x5482, "lake_cinema_cormack" },
    { 0x5483, "lake_cinema_enemies" },
    { 0x5484, "lake_cinema_gideon" },
    { 0x5485, "lake_cinema_ilona" },
    { 0x5486, "lake_cinema_player" },
    { 0x5487, "lake_dialogue" },
    { 0x5488, "lake_dialogue_start" },
    { 0x5489, "lake_drown" },
    { 0x548A, "lake_events" },
    { 0x548B, "lake_exit" },
    { 0x548C, "lake_fall_in" },
    { 0x548D, "lake_handle_vol_movement" },
    { 0x548E, "lake_reinforcements_1" },
    { 0x548F, "lake_reinforcements_2" },
    { 0x5490, "lake_reinforcements_final" },
    { 0x5491, "lake_scene_anim_node" },
    { 0x5492, "lake_scene_fail_timeout" },
    { 0x5493, "lake_upper_deck" },
    { 0x5494, "lake_vol_movement" },
    { 0x5495, "lake_warbird_approaches" },
    { 0x5496, "land_assist" },
    { 0x5497, "land_assist_activated" },
    { 0x5498, "land_assist_available_startime" },
    { 0x5499, "land_assist_current_vol" },
    { 0x549A, "land_assist_effect" },
    { 0x549B, "land_assist_hint_breakout" },
    { 0x549C, "land_assist_hint_force_breakout" },
    { 0x549D, "land_assist_hint_safe_descent_breakout" },
    { 0x549E, "land_assist_init" },
    { 0x549F, "land_assist_light" },
    { 0x54A0, "land_assist_rig" },
    { 0x54A1, "land_assist_thrusters" },
    { 0x54A2, "land_assist_thrusters_with_land" },
    { 0x54A3, "land_assist_vol" },
    { 0x54A4, "land_entity" },
    { 0x54A5, "land_magnet" },
    { 0x54A6, "land_pod_badly" },
    { 0x54A7, "land_pod_cleanly" },
    { 0x54A8, "land_point" },
    { 0x54A9, "land_tag" },
    { 0x54AA, "landanimbody" },
    { 0x54AB, "landanimhands" },
    { 0x54AC, "landassist_fx_counter" },
    { 0x54AD, "landassist_jump_cormack_jump" },
    { 0x54AE, "landassist_jump_cormack_powerup" },
    { 0x54AF, "landassist_jump_cormack_run" },
    { 0x54B0, "landassist_jump_cormack_walkback" },
    { 0x54B1, "landassist_jump_will_jump" },
    { 0x54B2, "landassist_jump_will_powerup" },
    { 0x54B3, "landassist_jump_will_run" },
    { 0x54B4, "landassist_jump_will_walkback" },
    { 0x54B5, "landhiderope" },
    { 0x54B6, "landing_dust_team" },
    { 0x54B7, "landing_gear_up" },
    { 0x54B8, "landing_pad_drones" },
    { 0x54B9, "landing_pad_lift_upper_static_setup" },
    { 0x54BA, "landing_pad_lights_off" },
    { 0x54BB, "landing_pad_lights_on" },
    { 0x54BC, "lane" },
    { 0x54BD, "lane_change_behavior" },
    { 0x54BE, "lane_processed" },
    { 0x54BF, "lane_start_node" },
    { 0x54C0, "lanterns" },
    { 0x54C1, "laptopinfo" },
    { 0x54C2, "large_propane_tank_think" },
    { 0x54C3, "largeprojectiledamage" },
    { 0x54C4, "largesparkdistance" },
    { 0x54C5, "laser_aim_pos" },
    { 0x54C6, "laser_artillery" },
    { 0x54C7, "laser_attacktargets" },
    { 0x54C8, "laser_coredamage_activated" },
    { 0x54C9, "laser_coredamage_deactivated" },
    { 0x54CA, "laser_designate_target" },
    { 0x54CB, "laser_designate_target_kinect" },
    { 0x54CC, "laser_designator_disable_list" },
    { 0x54CD, "laser_fireontarget" },
    { 0x54CE, "laser_follower" },
    { 0x54CF, "laser_fx" },
    { 0x54D0, "laser_handledamage" },
    { 0x54D1, "laser_handlefakedeath" },
    { 0x54D2, "laser_handlemovebottom" },
    { 0x54D3, "laser_handlemovetop" },
    { 0x54D4, "laser_handleownerdisconnect" },
    { 0x54D5, "laser_initfxents" },
    { 0x54D6, "laser_initmoveorgs" },
    { 0x54D7, "laser_initoffswitch" },
    { 0x54D8, "laser_initsentry" },
    { 0x54D9, "laser_offswitch_onbeginuse" },
    { 0x54DA, "laser_offswitch_oncantuse" },
    { 0x54DB, "laser_offswitch_onenduse" },
    { 0x54DC, "laser_offswitch_onuseplantobject" },
    { 0x54DD, "laser_on" },
    { 0x54DE, "laser_setactive" },
    { 0x54DF, "laser_setinactive" },
    { 0x54E0, "laser_setowner" },
    { 0x54E1, "laser_setplaced" },
    { 0x54E2, "laser_setplacesentry" },
    { 0x54E3, "laser_tag" },
    { 0x54E4, "laser_tag_array" },
    { 0x54E5, "laser_targeting_device" },
    { 0x54E6, "laser_targets" },
    { 0x54E7, "laser_triggers" },
    { 0x54E8, "laser_usableoffswitch_off" },
    { 0x54E9, "laser_usableoffswitch_on" },
    { 0x54EA, "laser_watchdisabled" },
    { 0x54EB, "laser_watchlightbeam" },
    { 0x54EC, "laser2_mp" },
    { 0x54ED, "laser2customairstrike" },
    { 0x54EE, "laser2customkillstreakfunc" },
    { 0x54EF, "laser2customorbitallaserfunc" },
    { 0x54F0, "laser2customospfunc" },
    { 0x54F1, "laserallowed" },
    { 0x54F2, "lasercooldownafterhit" },
    { 0x54F3, "lasercoretrigids" },
    { 0x54F4, "lasercorevisualsblocked" },
    { 0x54F5, "laserdodamge" },
    { 0x54F6, "laserdophysics" },
    { 0x54F7, "laserent" },
    { 0x54F8, "laserforceon" },
    { 0x54F9, "laserforwardangles" },
    { 0x54FA, "laserfxactive" },
    { 0x54FB, "laserlightfill" },
    { 0x54FC, "laseroff_func" },
    { 0x54FD, "laseroffswitch_isvisible" },
    { 0x54FE, "laseron" },
    { 0x54FF, "laseron_func" },
    { 0x5500, "laseroriginoffset" },
    { 0x5501, "laserpilotquake" },
    { 0x5502, "lasersight_think" },
    { 0x5503, "lasersurfacequake" },
    { 0x5504, "lasertag" },
    { 0x5505, "laserweapon" },
    { 0x5506, "lassetgoalpos" },
    { 0x5507, "last_aim_priority" },
    { 0x5508, "last_aim_time_ms" },
    { 0x5509, "last_aim_type" },
    { 0x550A, "last_alert_time" },
    { 0x550B, "last_anim_time" },
    { 0x550C, "last_anim_time_check" },
    { 0x550D, "last_atk_bomber_death_time" },
    { 0x550E, "last_avatar_position" },
    { 0x550F, "last_balcony_death" },
    { 0x5510, "last_big_acceleration_msec" },
    { 0x5511, "last_bomb_location" },
    { 0x5512, "last_bump_time" },
    { 0x5513, "last_burke_external_dialogue" },
    { 0x5514, "last_cable" },
    { 0x5515, "last_camera_helper" },
    { 0x5516, "last_car_exit_index" },
    { 0x5517, "last_collision_time" },
    { 0x5518, "last_damage_attacker" },
    { 0x5519, "last_damage_direction_vec" },
    { 0x551A, "last_damage_point" },
    { 0x551B, "last_damage_pos" },
    { 0x551C, "last_displayed_ent" },
    { 0x551D, "last_dmg_player" },
    { 0x551E, "last_dmg_type" },
    { 0x551F, "last_downed_time" },
    { 0x5520, "last_drone_attacking_sound" },
    { 0x5521, "last_drone_investigating_sound" },
    { 0x5522, "last_drone_lens_sound" },
    { 0x5523, "last_drone_passive_sound" },
    { 0x5524, "last_enemy_chatter_vo" },
    { 0x5525, "last_enemy_notification" },
    { 0x5526, "last_enemy_sight_time" },
    { 0x5527, "last_enemy_sighting_position" },
    { 0x5528, "last_ent" },
    { 0x5529, "last_exo_movement_time" },
    { 0x552A, "last_facing" },
    { 0x552B, "last_fire_time" },
    { 0x552C, "last_flare_time" },
    { 0x552D, "last_flyby_time" },
    { 0x552E, "last_gear_change_time" },
    { 0x552F, "last_generic_hint_said" },
    { 0x5530, "last_global_badplace_time" },
    { 0x5531, "last_grenade_throw_time" },
    { 0x5532, "last_guy_in_group" },
    { 0x5533, "last_hint_time_any_ms" },
    { 0x5534, "last_hint_times_ms" },
    { 0x5535, "last_hit_callout_time" },
    { 0x5536, "last_hovertank_weapon_anim" },
    { 0x5537, "last_hovertank_weapon_anim_complete_time" },
    { 0x5538, "last_infected_hiding_loc" },
    { 0x5539, "last_infected_hiding_time" },
    { 0x553A, "last_investigation_time" },
    { 0x553B, "last_kill_times_ms" },
    { 0x553C, "last_known_enemy_pos" },
    { 0x553D, "last_known_enemy_reason" },
    { 0x553E, "last_known_position_claimed" },
    { 0x553F, "last_known_position_monitor" },
    { 0x5540, "last_losing_flag_react" },
    { 0x5541, "last_melee_ti_check" },
    { 0x5542, "last_missile_fired_at_player" },
    { 0x5543, "last_missile_side" },
    { 0x5544, "last_mission_sound_time" },
    { 0x5545, "last_modelfunc" },
    { 0x5546, "last_motion_time" },
    { 0x5547, "last_pass_throw_check" },
    { 0x5548, "last_patrol_goal" },
    { 0x5549, "last_picked_time" },
    { 0x554A, "last_pitch_aim" },
    { 0x554B, "last_pitch_noise" },
    { 0x554C, "last_player_damage" },
    { 0x554D, "last_pos" },
    { 0x554E, "last_punish_time" },
    { 0x554F, "last_queue_time" },
    { 0x5550, "last_repair_weights" },
    { 0x5551, "last_revive_fail_time" },
    { 0x5552, "last_rocket_time" },
    { 0x5553, "last_rockets_time" },
    { 0x5554, "last_run_time" },
    { 0x5555, "last_saw_player" },
    { 0x5556, "last_saw_player_time" },
    { 0x5557, "last_score" },
    { 0x5558, "last_selected_entity_has_changed" },
    { 0x5559, "last_sentry" },
    { 0x555A, "last_set_goalent" },
    { 0x555B, "last_set_goalnode" },
    { 0x555C, "last_set_goalpos" },
    { 0x555D, "last_skid_time" },
    { 0x555E, "last_song" },
    { 0x555F, "last_spawned_vehicle" },
    { 0x5560, "last_spot" },
    { 0x5561, "last_state" },
    { 0x5562, "last_strips" },
    { 0x5563, "last_target" },
    { 0x5564, "last_team_gunshot_announce" },
    { 0x5565, "last_teleport_time" },
    { 0x5566, "last_threat_debug" },
    { 0x5567, "last_time" },
    { 0x5568, "last_time_jumped_for_tag" },
    { 0x5569, "last_time_secured" },
    { 0x556A, "last_timeout" },
    { 0x556B, "last_traffic_hit_pos" },
    { 0x556C, "last_traffic_hit_time" },
    { 0x556D, "last_trophy_time" },
    { 0x556E, "last_turret_missile_time" },
    { 0x556F, "last_warning_line" },
    { 0x5570, "last_wheel_pos" },
    { 0x5571, "last_yaw_aim" },
    { 0x5572, "last_yaw_noise" },
    { 0x5573, "last_z" },
    { 0x5574, "lastadvancetoenemyattacker" },
    { 0x5575, "lastadvancetoenemydest" },
    { 0x5576, "lastadvancetoenemysrc" },
    { 0x5577, "lastadvancetoenemytime" },
    { 0x5578, "lastapproachaborttime" },
    { 0x5579, "lastattackedshieldplayer" },
    { 0x557A, "lastattackedshieldtime" },
    { 0x557B, "lastautosavetime" },
    { 0x557C, "lastavatarpositionent" },
    { 0x557D, "lastbadpathgoal" },
    { 0x557E, "lastbadpathmovestate" },
    { 0x557F, "lastbadpathtime" },
    { 0x5580, "lastbadpathultimategoal" },
    { 0x5581, "lastcaptureteam" },
    { 0x5582, "lastcaralarmtime" },
    { 0x5583, "lastcarexplosiondamagelocation" },
    { 0x5584, "lastcarexplosionlocation" },
    { 0x5585, "lastcarexplosionrange" },
    { 0x5586, "lastcarexplosiontime" },
    { 0x5587, "lastcarrier" },
    { 0x5588, "lastcarrierscored" },
    { 0x5589, "lastcarrierteam" },
    { 0x558A, "lastclaimteam" },
    { 0x558B, "lastclaimtime" },
    { 0x558C, "lastclass" },
    { 0x558D, "lastcolorforced" },
    { 0x558E, "lastconcussedtime" },
    { 0x558F, "lastcontact" },
    { 0x5590, "lastcoopstreaktime" },
    { 0x5591, "lastdamageat" },
    { 0x5592, "lastdamagedtime" },
    { 0x5593, "lastdamagefromenemytargettime" },
    { 0x5594, "lastdamagewasfromenemy" },
    { 0x5595, "lastdeathicon" },
    { 0x5596, "lastdeathpos" },
    { 0x5597, "lastdialogtime" },
    { 0x5598, "lastdirection" },
    { 0x5599, "lastdogmeleeplayertime" },
    { 0x559A, "lastdoground" },
    { 0x559B, "lastdroppableweapon" },
    { 0x559C, "lastencountertime" },
    { 0x559D, "lastenemypos" },
    { 0x559E, "lastenemysightposold" },
    { 0x559F, "lastenemysightposselforigin" },
    { 0x55A0, "lastenemysighttime" },
    { 0x55A1, "lastenemytime" },
    { 0x55A2, "lastequippedweapon" },
    { 0x55A3, "lastexplodingbarrel" },
    { 0x55A4, "lastflashedtime" },
    { 0x55A5, "lastfraggrenadetoplayerstart" },
    { 0x55A6, "lastfriendlytrigger" },
    { 0x55A7, "lastgrenadelandednearplayertime" },
    { 0x55A8, "lastgrenadesuicidetime" },
    { 0x55A9, "lastgrenadetime" },
    { 0x55AA, "lastgroundtype" },
    { 0x55AB, "lastgrowlplayedtime" },
    { 0x55AC, "lastguntimevo" },
    { 0x55AD, "lasthit" },
    { 0x55AE, "lasthittime" },
    { 0x55AF, "lasthostmigrationstate" },
    { 0x55B0, "lasthoveroffset" },
    { 0x55B1, "lastindex" },
    { 0x55B2, "lastinflictor" },
    { 0x55B3, "lastkilldogtime" },
    { 0x55B4, "lastkilledby" },
    { 0x55B5, "lastkilledplayer" },
    { 0x55B6, "lastkillstreak" },
    { 0x55B7, "lastkillstreakmodules" },
    { 0x55B8, "lastkillstreaks" },
    { 0x55B9, "lastkilltime" },
    { 0x55BA, "lastknownposition" },
    { 0x55BB, "lastlethalweapon" },
    { 0x55BC, "lastlethalweaponammoclip" },
    { 0x55BD, "lastleveluptime" },
    { 0x55BE, "lastlighttime" },
    { 0x55BF, "lastmansd" },
    { 0x55C0, "lastmeleefailedmypos" },
    { 0x55C1, "lastmeleefailedpos" },
    { 0x55C2, "lastmissedenemy" },
    { 0x55C3, "lastnamesaid" },
    { 0x55C4, "lastnamesaidtime" },
    { 0x55C5, "lastnamesaidtimeout" },
    { 0x55C6, "lastnearestnode" },
    { 0x55C7, "lastnodelookingattrace" },
    { 0x55C8, "lastnonshieldweapon" },
    { 0x55C9, "lastnonuseweapon" },
    { 0x55CA, "lastpaintime" },
    { 0x55CB, "lastpantplayedtime" },
    { 0x55CC, "lastperks" },
    { 0x55CD, "lastplayerangles" },
    { 0x55CE, "lastplayernamecalltime" },
    { 0x55CF, "lastplayersighted" },
    { 0x55D0, "lastprimaryweaponswaptime" },
    { 0x55D1, "lastpursuitfailedmypos" },
    { 0x55D2, "lastpursuitfailedpos" },
    { 0x55D3, "lastpursuitfailedtime" },
    { 0x55D4, "lastrambotime" },
    { 0x55D5, "lastreacttime" },
    { 0x55D6, "lastrecoiloffset" },
    { 0x55D7, "lastreloadstarttime" },
    { 0x55D8, "lastrunningreactanim" },
    { 0x55D9, "lastsavetime" },
    { 0x55DA, "lastshoottime" },
    { 0x55DB, "lastshotby" },
    { 0x55DC, "lastshotfiredtime" },
    { 0x55DD, "lastshottime" },
    { 0x55DE, "lastsightposwatch" },
    { 0x55DF, "lastslowprocessframe" },
    { 0x55E0, "lastspawnpoint" },
    { 0x55E1, "lastspawnteam" },
    { 0x55E2, "lastspawntime" },
    { 0x55E3, "lastsprintendtime" },
    { 0x55E4, "laststand_enabled" },
    { 0x55E5, "laststand_kill_will_down_func" },
    { 0x55E6, "laststand_player_func" },
    { 0x55E7, "laststand_type" },
    { 0x55E8, "laststandallowsuicide" },
    { 0x55E9, "laststandammowacher" },
    { 0x55EA, "laststandbleedout" },
    { 0x55EB, "laststandexoabilitymonitor" },
    { 0x55EC, "laststandkeepoverlay" },
    { 0x55ED, "laststandkeepoverlayhorde" },
    { 0x55EE, "laststandmonitorabandonment" },
    { 0x55EF, "laststandparams" },
    { 0x55F0, "laststandrespawnplayer" },
    { 0x55F1, "laststandrespawnplayerhorde" },
    { 0x55F2, "laststandrevivehorde" },
    { 0x55F3, "laststandselfrevive" },
    { 0x55F4, "laststandstarttime" },
    { 0x55F5, "laststandtimer" },
    { 0x55F6, "laststandtimerhorde" },
    { 0x55F7, "laststandupdatereviveiconcolorhorde" },
    { 0x55F8, "laststandusetime" },
    { 0x55F9, "laststandwaittilldeath" },
    { 0x55FA, "laststandwaittilldeathhorde" },
    { 0x55FB, "laststandwaittillliferecived" },
    { 0x55FC, "laststate" },
    { 0x55FD, "laststatechangetime" },
    { 0x55FE, "laststatus" },
    { 0x55FF, "laststatustime" },
    { 0x5600, "laststoppedtime" },
    { 0x5601, "lastsuppressiontime" },
    { 0x5602, "lastsurfacetype" },
    { 0x5603, "lasttacticalweapon" },
    { 0x5604, "lasttacticalweaponammoclip" },
    { 0x5605, "lastteamspeaktime" },
    { 0x5606, "lastteamthreatcallout" },
    { 0x5607, "lastteamthreatcallouttime" },
    { 0x5608, "lasttime" },
    { 0x5609, "lasttimedamaged" },
    { 0x560A, "lasttododamage" },
    { 0x560B, "lasttwoenemies" },
    { 0x560C, "lastupdatetime" },
    { 0x560D, "lastusedweapon" },
    { 0x560E, "lastuserate" },
    { 0x560F, "lastvalue" },
    { 0x5610, "lastvisionsetthermal" },
    { 0x5611, "lastwave" },
    { 0x5612, "lastweapon" },
    { 0x5613, "launch_car_with_missiles" },
    { 0x5614, "launch_drone_missile_special" },
    { 0x5615, "launch_drone_missiles" },
    { 0x5616, "launch_intro_building_descend_fob_loops" },
    { 0x5617, "launch_intro_loops" },
    { 0x5618, "launch_intro_point_source_dambs" },
    { 0x5619, "launch_intro_ride_loops" },
    { 0x561A, "launch_line_emitters" },
    { 0x561B, "launch_loops" },
    { 0x561C, "launch_mall_offices_loops" },
    { 0x561D, "launch_middle_loops" },
    { 0x561E, "launch_missile" },
    { 0x561F, "launch_office_loops" },
    { 0x5620, "launch_org" },
    { 0x5621, "launch_outro_loops" },
    { 0x5622, "launch_riverwalk_loops" },
    { 0x5623, "launch_school_interior_loops" },
    { 0x5624, "launch_school_interior_point_source_dambs" },
    { 0x5625, "launch_school_street_loops" },
    { 0x5626, "launch_school_street_point_source_dambs" },
    { 0x5627, "launch_sinkhole_subway_loops" },
    { 0x5628, "launch_threads" },
    { 0x5629, "launch_truck_puch_trans_loops" },
    { 0x562A, "launcher_index" },
    { 0x562B, "launcher_out_of_ammo_obj" },
    { 0x562C, "launcher_out_of_ammo_obj_clear" },
    { 0x562D, "launcher_out_of_ammo_think" },
    { 0x562E, "launcher_write_clipboard" },
    { 0x562F, "launchers_disable_threat_grenade_response" },
    { 0x5630, "launchers_enable_threat_grenade_response" },
    { 0x5631, "launchers_rotate_down" },
    { 0x5632, "launchers_rotate_up" },
    { 0x5633, "launchexplosivegel" },
    { 0x5634, "launchshield" },
    { 0x5635, "launchtridrone" },
    { 0x5636, "launchuav" },
    { 0x5637, "layer" },
    { 0x5638, "lbs_condition_callback_to_state_deathspin" },
    { 0x5639, "lbs_condition_callback_to_state_destruct" },
    { 0x563A, "lbs_condition_callback_to_state_distant" },
    { 0x563B, "lbs_condition_callback_to_state_flyby" },
    { 0x563C, "lbs_condition_callback_to_state_flying" },
    { 0x563D, "lbs_condition_callback_to_state_flyover" },
    { 0x563E, "lbs_condition_callback_to_state_hover" },
    { 0x563F, "lbs_condition_callback_to_state_off" },
    { 0x5640, "lead_origin" },
    { 0x5641, "lead_pos" },
    { 0x5642, "lead_snake" },
    { 0x5643, "lead_time" },
    { 0x5644, "leaderboard_compare_scores" },
    { 0x5645, "leaderboard_defaults" },
    { 0x5646, "leaderboard_make" },
    { 0x5647, "leaderboard_precache" },
    { 0x5648, "leaderboard_record" },
    { 0x5649, "leaderboard_score_to_digits" },
    { 0x564A, "leaderboard_screen" },
    { 0x564B, "leaderboard_screen_make" },
    { 0x564C, "leaderboard_screen_update" },
    { 0x564D, "leaderboard_sort_scores" },
    { 0x564E, "leaderdialog" },
    { 0x564F, "leaderdialog_islockedout" },
    { 0x5650, "leaderdialog_lockoutcleardelayed" },
    { 0x5651, "leaderdialog_trylockout" },
    { 0x5652, "leaderdialogactive" },
    { 0x5653, "leaderdialogbothteams" },
    { 0x5654, "leaderdialoggroup" },
    { 0x5655, "leaderdialoggroups" },
    { 0x5656, "leaderdialoglocalsound" },
    { 0x5657, "leaderdialoglocqueue" },
    { 0x5658, "leaderdialogonplayer" },
    { 0x5659, "leaderdialogonplayer_func" },
    { 0x565A, "leaderdialogonplayer_internal" },
    { 0x565B, "leaderdialogonplayers" },
    { 0x565C, "leaderdialogqueue" },
    { 0x565D, "leaderdialogwait" },
    { 0x565E, "leadersound" },
    { 0x565F, "leadersoundgroup" },
    { 0x5660, "leaking" },
    { 0x5661, "leanaim" },
    { 0x5662, "leanasitturns" },
    { 0x5663, "leashcoversearchradius" },
    { 0x5664, "leashcoversearchradiusmin" },
    { 0x5665, "leashheightoffset" },
    { 0x5666, "leashplayerdistancetether" },
    { 0x5667, "leashsearchoffset" },
    { 0x5668, "leave_gun_and_run_to_new_spot" },
    { 0x5669, "leave_path_for_free_path" },
    { 0x566A, "leavecoverandshoot" },
    { 0x566B, "leaveorbitalstrikeearly" },
    { 0x566C, "leaveremotekillstreaks" },
    { 0x566D, "leaving_gov_building" },
    { 0x566E, "leaving_gov_building_post_vo" },
    { 0x566F, "leaving_mission_area_while_in_trig" },
    { 0x5670, "leaving_team" },
    { 0x5671, "left_alias" },
    { 0x5672, "left_arrow" },
    { 0x5673, "left_big_loop_start" },
    { 0x5674, "left_big_pivot" },
    { 0x5675, "left_brakelight_tag" },
    { 0x5676, "left_canyon1" },
    { 0x5677, "left_color_node" },
    { 0x5678, "left_door_anim" },
    { 0x5679, "left_ent" },
//  { 0x567A, "left_headlight_tag" },
//  { 0x567B, "left_loop_start" },
//  { 0x567C, "left_mount_trigger_function" },
//  { 0x567D, "left_pivot" },
//  { 0x567E, "left_post" },
//  { 0x567F, "left_swing_pressed" },
//  { 0x5680, "left_swing_released" },
//  { 0x5681, "left_swipe_monitor" },
//  { 0x5682, "left_tap_monitor" },
//  { 0x5683, "" },
//  { 0x5684, "legal_loop" },
//  { 0x5685, "lens_left" },
//  { 0x5686, "lens_right" },
//  { 0x5687, "lensviewmodel" },
    { 0x5688, "lerp" },
    { 0x5689, "lerp_angles_function" },
    { 0x568A, "lerp_anim_weight_on_actor_over_time" },
    { 0x568B, "lerp_drone_to_position" },
    { 0x568C, "lerp_fov_overtime" },
    { 0x568D, "lerp_fov_wait" },
    { 0x568E, "lerp_fovscale_overtime" },
    { 0x568F, "lerp_in_turn_rate" },
    { 0x5690, "lerp_intensity" },
    { 0x5691, "lerp_light_fov_range" },
    { 0x5692, "lerp_linktoblend" },
    { 0x5693, "lerp_move_speed_scale" },
    { 0x5694, "lerp_origin_function" },
    { 0x5695, "lerp_out_drop_pitch" },
    { 0x5696, "lerp_player_view_to_position" },
    { 0x5697, "lerp_player_view_to_position_absolute" },
    { 0x5698, "lerp_player_view_to_position_oldstyle" },
    { 0x5699, "lerp_player_view_to_tag" },
    { 0x569A, "lerp_player_view_to_tag_and_hit_geo" },
    { 0x569B, "lerp_player_view_to_tag_internal" },
    { 0x569C, "lerp_player_view_to_tag_oldstyle" },
    { 0x569D, "lerp_player_view_to_tag_oldstyle_internal" },
    { 0x569E, "lerp_pupil_over_time" },
    { 0x569F, "lerp_saveddvar" },
    { 0x56A0, "lerp_saveddvar_cg_ng" },
    { 0x56A1, "lerp_spot_briefing" },
    { 0x56A2, "lerp_spot_color" },
    { 0x56A3, "lerp_spot_intensity" },
    { 0x56A4, "lerp_spot_intensity_array" },
    { 0x56A5, "lerp_spot_radius" },
    { 0x56A6, "lerp_sun" },
    { 0x56A7, "lerp_sun_01" },
    { 0x56A8, "lerp_sun_02" },
    { 0x56A9, "lerp_sun_cargo_ship" },
    { 0x56AA, "lerp_sunsamplesizenear_overtime" },
    { 0x56AB, "lerp_time_function_wallpull" },
    { 0x56AC, "lerp_time_in" },
    { 0x56AD, "lerp_time_out" },
    { 0x56AE, "lerp_to_position" },
    { 0x56AF, "lerp_to_target" },
    { 0x56B0, "lerp_towards_desiredangle" },
    { 0x56B1, "lerp_viewmodel_dof" },
    { 0x56B2, "lerp_weight" },
    { 0x56B3, "lerp_wind" },
    { 0x56B4, "lerpfov_saved" },
    { 0x56B5, "lerpfov_saved_thread" },
    { 0x56B6, "lerpfraction" },
    { 0x56B7, "lerpplayerlook" },
    { 0x56B8, "lerpscreenblurup" },
    { 0x56B9, "lettertonumber" },
    { 0x56BA, "level_audio_reverb_function" },
    { 0x56BB, "level_audio_zones_function" },
    { 0x56BC, "level_bounds" },
    { 0x56BD, "level_bounds_fail" },
    { 0x56BE, "level_bounds_nag" },
    { 0x56BF, "level_bounds_nag_vo" },
    { 0x56C0, "level_complete" },
    { 0x56C1, "level_diveboat_to_vm_model" },
    { 0x56C2, "level_drone_abort_monitor" },
    { 0x56C3, "level_end_save" },
    { 0x56C4, "level_fade_time" },
    { 0x56C5, "level_has_start_points" },
    { 0x56C6, "level_intro_cinematic" },
    { 0x56C7, "level_jetbike_to_vm_model" },
    { 0x56C8, "level_progress" },
    { 0x56C9, "level_progress_alley1combat" },
    { 0x56CA, "level_progress_exodoor" },
    { 0x56CB, "level_progress_fail" },
    { 0x56CC, "level_progress_flankcombat" },
    { 0x56CD, "level_progress_froggercombat" },
    { 0x56CE, "level_progress_froggercomplete" },
    { 0x56CF, "level_progress_govexit" },
    { 0x56D0, "level_progress_monorail" },
    { 0x56D1, "level_progress_nag" },
    { 0x56D2, "level_progress_oncomingcombat" },
    { 0x56D3, "level_progress_roundaboutcombat" },
    { 0x56D4, "level_specific_bot_targets" },
    { 0x56D5, "level_specific_dof" },
    { 0x56D6, "level_start_fade_in" },
    { 0x56D7, "level_stinger_lock_target" },
    { 0x56D8, "level_stinger_missile_targets" },
    { 0x56D9, "level_trigger_should_abort" },
    { 0x56DA, "level_trigger_should_abort_melee" },
    { 0x56DB, "level_trigger_should_abort_ranged" },
    { 0x56DC, "levelflag" },
    { 0x56DD, "levelflagclear" },
    { 0x56DE, "levelflaginit" },
    { 0x56DF, "levelflags" },
    { 0x56E0, "levelflagset" },
    { 0x56E1, "levelflagwait" },
    { 0x56E2, "levelflagwaitopen" },
    { 0x56E3, "levelglobalsetup" },
    { 0x56E4, "levelglobalvars" },
    { 0x56E5, "levelhasvehicles" },
    { 0x56E6, "levelintroscreen" },
    { 0x56E7, "levelprecacheassets" },
    { 0x56E8, "levels" },
    { 0x56E9, "levelstartpoints" },
    { 0x56EA, "lfelp" },
    { 0x56EB, "lgt_alarm_pulsing" },
    { 0x56EC, "lgt_change_intensity_over_time" },
    { 0x56ED, "lgt_emergency_screens" },
    { 0x56EE, "lgt_escape_door_alarm" },
    { 0x56EF, "lgt_heli_escape" },
    { 0x56F0, "lgt_incinerator_seq" },
    { 0x56F1, "lgt_init" },
    { 0x56F2, "lgt_manticore_bay" },
    { 0x56F3, "lgt_mech2_door" },
    { 0x56F4, "lgt_morgue" },
    { 0x56F5, "lgt_s2_walk" },
    { 0x56F6, "lgt_start_fire" },
    { 0x56F7, "lgt_sys_hacking" },
    { 0x56F8, "lgt_test_chamber" },
    { 0x56F9, "lgt_uv_flash" },
    { 0x56FA, "lifeid" },
    { 0x56FB, "lifespan" },
    { 0x56FC, "lifetimer" },
    { 0x56FD, "lift_worker_01_waits" },
    { 0x56FE, "lift_worker_02_waits" },
    { 0x56FF, "lifter" },
    { 0x5700, "lifts" },
    { 0x5701, "light_cine_fire" },
    { 0x5702, "light_debug_dvar_init" },
    { 0x5703, "light_ending_cinematic" },
    { 0x5704, "light_ending_cinematic_dof" },
    { 0x5705, "light_fx_name" },
    { 0x5706, "light_get_dof_preset" },
    { 0x5707, "light_get_dof_viewmodel_preset" },
    { 0x5708, "light_init" },
    { 0x5709, "light_message" },
    { 0x570A, "light_message_init" },
    { 0x570B, "light_number" },
    { 0x570C, "light_object_set_intensity" },
    { 0x570D, "light_register_message" },
    { 0x570E, "light_set" },
    { 0x570F, "light_set_override_for_player" },
    { 0x5710, "light_setup_common_dof_presets" },
    { 0x5711, "light_setup_common_dof_viewmodel_presets" },
    { 0x5712, "light_setup_common_flickerlight_presets" },
    { 0x5713, "light_setup_global_dvars" },
    { 0x5714, "light_setup_pulse_presets" },
    { 0x5715, "light_strip_checkpoint" },
    { 0x5716, "light_tag" },
    { 0x5717, "lightarmorhp" },
    { 0x5718, "lightbox_hideents" },
    { 0x5719, "lightent" },
    { 0x571A, "lightents" },
    { 0x571B, "lightfxfunc" },
    { 0x571C, "lightgridlightdemote" },
    { 0x571D, "lightgridsupersamplecount" },
    { 0x571E, "lighting_begin_preload" },
    { 0x571F, "lighting_confrontation_auto_dof" },
    { 0x5720, "lighting_fx_lens_subway_interior" },
    { 0x5721, "lighting_irons_dof" },
    { 0x5722, "lighting_note" },
    { 0x5723, "lighting_origin" },
    { 0x5724, "lighting_setup_off_zip" },
    { 0x5725, "lighting_setup_reactor_door" },
    { 0x5726, "lighting_setup_reactor_door_volume" },
    { 0x5727, "lighting_setup_turbine_elevator" },
    { 0x5728, "lighting_setup_turbine_elevator_volume" },
    { 0x5729, "lighting_subway_breach" },
    { 0x572A, "lighting_target_dof" },
    { 0x572B, "lighting_target_dof_ender" },
    { 0x572C, "lighting_vehicle_takedown_01" },
    { 0x572D, "lighting_vehicle_takedown_01_lerp" },
    { 0x572E, "lighting_vehicle_takedown_01_on" },
    { 0x572F, "lighting_will_reveal" },
    { 0x5730, "lightingnote" },
    { 0x5731, "lightingstate" },
    { 0x5732, "lightintensityflicker" },
    { 0x5733, "lightmap" },
    { 0x5734, "lightmapsamplescale" },
    { 0x5735, "lightmapscale" },
    { 0x5736, "lightmapshadow" },
    { 0x5737, "lightning" },
    { 0x5738, "lightning_bolt_fx" },
    { 0x5739, "lightning_call" },
    { 0x573A, "lightning_call_gate" },
    { 0x573B, "lightning_call_single" },
    { 0x573C, "lightning_call_traversal" },
    { 0x573D, "lightning_flash" },
    { 0x573E, "lightning_gag" },
    { 0x573F, "lightning_normal" },
    { 0x5740, "lightning_strike" },
    { 0x5741, "lightning_strike_hangar_start" },
    { 0x5742, "lightningexploder" },
    { 0x5743, "lightningexploderindex" },
    { 0x5744, "lightningflash" },
    { 0x5745, "lightningthink" },
    { 0x5746, "lightrigs" },
    { 0x5747, "lights" },
    { 0x5748, "lights_delayfxforframe" },
    { 0x5749, "lights_off" },
    { 0x574A, "lights_off_internal" },
    { 0x574B, "lights_on" },
    { 0x574C, "lights_on_blue" },
    { 0x574D, "lights_on_blue_02" },
    { 0x574E, "lights_on_internal" },
    { 0x574F, "lights_on_neutral" },
    { 0x5750, "lights_on_orange" },
    { 0x5751, "lights_on_orange_02" },
    { 0x5752, "lightset" },
    { 0x5753, "lightset_betrayal" },
    { 0x5754, "lightset_betrayal_grungy" },
    { 0x5755, "lightset_betrayal_grungy_int" },
    { 0x5756, "lightset_betrayal_grungy_out" },
    { 0x5757, "lightset_betrayal_interior" },
    { 0x5758, "lightset_betrayal_mall" },
    { 0x5759, "lightset_betrayal_race" },
    { 0x575A, "lightset_betrayal_river_int" },
    { 0x575B, "lightset_betrayal_river_out" },
    { 0x575C, "lightset_betrayal_subway" },
    { 0x575D, "lightset_current" },
    { 0x575E, "lightset_previous" },
    { 0x575F, "lightset_seoul_shopping" },
    { 0x5760, "lightset_triggers" },
    { 0x5761, "lightson" },
    { 0x5762, "lighttarget" },
    { 0x5763, "lighttargetname" },
    { 0x5764, "lightweightscalar" },
    { 0x5765, "ligting_note" },
    { 0x5766, "limit_player_view" },
    { 0x5767, "limitdecimalplaces" },
//  { 0x5768, "limp_footsteps" },
//  { 0x5769, "" },
    { 0x576A, "line_claimed" },
    { 0x576B, "line_interect_sphere" },
    { 0x576C, "line_segment_end_point" },
    { 0x576D, "linear_encounter_script" },
    { 0x576E, "linear_interpolate" },
    { 0x576F, "linear_map" },
    { 0x5770, "linear_map_clamp" },
    { 0x5771, "linearlerp" },
    { 0x5772, "lineartogamma_srgb" },
    { 0x5773, "linedraw" },
    { 0x5774, "linelist" },
    { 0x5775, "lineofsight" },
    { 0x5776, "linerar_lerp" },
    { 0x5777, "lines" },
    { 0x5778, "linesize" },
    { 0x5779, "linethread" },
    { 0x577A, "linetime" },
    { 0x577B, "linetime_proc" },
    { 0x577C, "lingering_grnd_smoke_attached" },
    { 0x577D, "lingering_ground_smk" },
    { 0x577E, "link" },
    { 0x577F, "link_offset" },
    { 0x5780, "link_player_and_play_idle" },
    { 0x5781, "link_player_and_start_driving_anims" },
    { 0x5782, "link_player_to_mob_turret" },
    { 0x5783, "link_tag" },
    { 0x5784, "link_to_sittag" },
    { 0x5785, "link_trigger" },
    { 0x5786, "link_with_stored_offsets" },
    { 0x5787, "linkcollisiontoturret" },
    { 0x5788, "linkdistance" },
    { 0x5789, "linked" },
    { 0x578A, "linked_entity" },
    { 0x578B, "linked_ents" },
    { 0x578C, "linked_light_ents" },
    { 0x578D, "linked_lights" },
    { 0x578E, "linked_magnet" },
    { 0x578F, "linked_models" },
    { 0x5790, "linked_player" },
    { 0x5791, "linked_prefab_ents" },
    { 0x5792, "linked_rocket" },
    { 0x5793, "linked_things" },
    { 0x5794, "linked_to_cover" },
    { 0x5795, "linkedtotag" },
    { 0x5796, "linkgeototurret" },
    { 0x5797, "linkparent" },
    { 0x5798, "linkparent_ent" },
    { 0x5799, "linkparent_tag" },
    { 0x579A, "linkpet" },
    { 0x579B, "linkplayerorbitalship" },
    { 0x579C, "linkplayerpod" },
    { 0x579D, "links" },
    { 0x579E, "linkto_with_world_offset" },
    { 0x579F, "linkto_with_world_offset_internal" },
    { 0x57A0, "linktoblend" },
    { 0x57A1, "linktoent" },
    { 0x57A2, "listen_for" },
    { 0x57A3, "listen_for_cancel" },
    { 0x57A4, "listen_for_dog_commands" },
    { 0x57A5, "listen_for_dog_kinect_commands" },
    { 0x57A6, "listenforcoverapproach" },
    { 0x57A7, "listenforexomoveevent" },
    { 0x57A8, "listening_org" },
    { 0x57A9, "lit_models" },
    { 0x57AA, "lite" },
    { 0x57AB, "lite_settings" },
    { 0x57AC, "liteintensity" },
    { 0x57AD, "little_bird_landing_init" },
    { 0x57AE, "littlebird_deathspin" },
    { 0x57AF, "littlebird_emp_crash_movement" },
    { 0x57B0, "littlebird_emp_damage_function" },
    { 0x57B1, "littlebird_emp_death" },
    { 0x57B2, "littlebird_gideon" },
    { 0x57B3, "littlebird_hanger_flyby" },
    { 0x57B4, "littlebird_landing" },
    { 0x57B5, "littlebird_lands_and_unloads" },
    { 0x57B6, "littlebird_player" },
    { 0x57B7, "littlebird_rpg_rider_think" },
    { 0x57B8, "littlebird_sentinel_constructor" },
    { 0x57B9, "littlebird_turrets_think" },
    { 0x57BA, "littlebirde_getout_unlinks" },
    { 0x57BB, "littlebirds" },
    { 0x57BC, "livescount" },
    { 0x57BD, "living_ai_prethink" },
    { 0x57BE, "living_gate" },
    { 0x57BF, "living_room_clear" },
    { 0x57C0, "load" },
    { 0x57C1, "load_actor_anims" },
    { 0x57C2, "load_ai" },
    { 0x57C3, "load_ai_goddriver" },
    { 0x57C4, "load_anims" },
    { 0x57C5, "load_costume_indices" },
    { 0x57C6, "load_friendlies" },
    { 0x57C7, "load_fx" },
    { 0x57C8, "load_generic_human_anims" },
    { 0x57C9, "load_mech" },
    { 0x57CA, "load_middle_transient" },
    { 0x57CB, "load_missile_area_transient" },
    { 0x57CC, "load_model_anims" },
    { 0x57CD, "load_outro_transient" },
    { 0x57CE, "load_pitbull_animations" },
    { 0x57CF, "load_player_anims" },
    { 0x57D0, "load_precache" },
    { 0x57D1, "load_prop_anims" },
    { 0x57D2, "load_script_model_anims" },
    { 0x57D3, "load_scripted_anims" },
    { 0x57D4, "load_side" },
    { 0x57D5, "load_vehicle_anims" },
    { 0x57D6, "load_vehicles_anims" },
    { 0x57D7, "loadeffects" },
    { 0x57D8, "loadfromstructfn" },
    { 0x57D9, "loadout" },
    { 0x57DA, "loadout_changed" },
    { 0x57DB, "loadout_complete" },
    { 0x57DC, "loadoutallperks" },
    { 0x57DD, "loadoutcomplete" },
    { 0x57DE, "loadoutequipment" },
    { 0x57DF, "loadoutkillstreakmodules" },
    { 0x57E0, "loadoutoffhand" },
    { 0x57E1, "loadoutperks" },
    { 0x57E2, "loadoutprimary" },
    { 0x57E3, "loadoutprimarycamo" },
    { 0x57E4, "loadoutprimaryreticle" },
    { 0x57E5, "loadoutsecondary" },
    { 0x57E6, "loadoutsecondarycamo" },
    { 0x57E7, "loadoutsecondaryreticle" },
    { 0x57E8, "loadouttrackvariablegrenades" },
    { 0x57E9, "loadoutvalidforcopycat" },
    { 0x57EA, "loadoutvalues" },
    { 0x57EB, "loadoutwildcards" },
    { 0x57EC, "lobby_ambient_aa_explosions" },
    { 0x57ED, "lobby_ambient_explosion_midair_runner_single" },
    { 0x57EE, "lobby_protect" },
    { 0x57EF, "lobby_update_group_new" },
    { 0x57F0, "loc_end" },
    { 0x57F1, "loc_start" },
    { 0x57F2, "local_init" },
    { 0x57F3, "localrot" },
    { 0x57F4, "locamote" },
    { 0x57F5, "locamote_prev" },
    { 0x57F6, "locateenemypositions" },
    { 0x57F7, "location" },
    { 0x57F8, "location_add_last_callout_time" },
    { 0x57F9, "location_array" },
    { 0x57FA, "location_called_out_ever" },
    { 0x57FB, "location_called_out_recently" },
    { 0x57FC, "location_dupes_thread" },
    { 0x57FD, "location_get_last_callout_time" },
    { 0x57FE, "locationaliases" },
    { 0x57FF, "locationlastcallouttimes" },
    { 0x5800, "locations_to_investigate" },
    { 0x5801, "lock" },
    { 0x5802, "lock_exists" },
    { 0x5803, "lock_on_hud" },
    { 0x5804, "lock_on_stage" },
    { 0x5805, "lock_on_target" },
    { 0x5806, "lock_on_to_player" },
    { 0x5807, "lock_on_warning" },
    { 0x5808, "lock_spawner_for_awhile" },
    { 0x5809, "lock_target" },
    { 0x580A, "lock_targets" },
    { 0x580B, "lockaction" },
    { 0x580C, "locked" },
    { 0x580D, "locked_feedback" },
    { 0x580E, "locked_guns_hud" },
    { 0x580F, "locked_target_think" },
    { 0x5810, "locked_targets" },
    { 0x5811, "lockedlist" },
    { 0x5812, "lockedstingertarget" },
    { 0x5813, "lockedtarget" },
    { 0x5814, "locking_feedback" },
    { 0x5815, "locking_target" },
    { 0x5816, "locking_target_still_valid" },
    { 0x5817, "locking_time" },
    { 0x5818, "lockon_behavior" },
    { 0x5819, "lockon_fov" },
    { 0x581A, "lockon_time" },
    { 0x581B, "locksighttest" },
    { 0x581C, "locktargets" },
    { 0x581D, "loddistscale" },
    { 0x581E, "lodistscale" },
    { 0x581F, "log_pile_collapse" },
    { 0x5820, "log_pile_scripted_think" },
    { 0x5821, "logassists" },
    { 0x5822, "logbreadcrumbdata" },
    { 0x5823, "logbreadcrumbdatasp" },
    { 0x5824, "logclasschoice" },
    { 0x5825, "logcompletedchallenge" },
    { 0x5826, "logdynamiceventstarttime" },
    { 0x5827, "logexostats" },
    { 0x5828, "logfinalstats" },
    { 0x5829, "logfirefightshotshits" },
    { 0x582A, "loggameevent" },
    { 0x582B, "logging_road" },
    { 0x582C, "logging_road_end_drop_logic" },
    { 0x582D, "logging_road_gaz_headlight_moment" },
    { 0x582E, "logging_road_logic" },
    { 0x582F, "logging_road_loud_combat" },
    { 0x5830, "logging_road_loud_combat_end" },
    { 0x5831, "logging_road_loud_combat_enemy_think" },
    { 0x5832, "logging_road_loud_combat_field" },
    { 0x5833, "logging_road_loud_combat_mech_march" },
    { 0x5834, "logging_road_loud_combat_trench" },
    { 0x5835, "logging_road_mud_tracks" },
    { 0x5836, "logging_road_mud_tracks_2" },
    { 0x5837, "logging_road_post_vrap" },
    { 0x5838, "logging_road_seeker_save" },
    { 0x5839, "logic" },
    { 0x583A, "loginitialstats" },
    { 0x583B, "logkillevent" },
    { 0x583C, "logkillsconfirmed" },
    { 0x583D, "logkillsdenied" },
    { 0x583E, "logkillstreakevent" },
    { 0x583F, "logloadout" },
    { 0x5840, "logmultikill" },
    { 0x5841, "logplayerandkilleradsandfov" },
    { 0x5842, "logplayerandkillerexomovedata" },
    { 0x5843, "logplayerandkillershieldcloakhoveractive" },
    { 0x5844, "logplayerandkillerstanceandmotionstate" },
    { 0x5845, "logplayerconsoleidandonwifiinmatchdata" },
    { 0x5846, "logplayercostume" },
    { 0x5847, "logplayerdata" },
    { 0x5848, "logplayerdeath" },
    { 0x5849, "logplayerlife" },
    { 0x584A, "logplayerping" },
    { 0x584B, "logplayerstats" },
    { 0x584C, "logplayerxp" },
    { 0x584D, "logprintplayerdeath" },
    { 0x584E, "logspecialassists" },
    { 0x584F, "logweaponstat" },
    { 0x5850, "logxpgains" },
    { 0x5851, "longdeathstarting" },
    { 0x5852, "longregentime" },
    { 0x5853, "longshotevent" },
    { 0x5854, "look_at_damage_trigger" },
    { 0x5855, "look_at_position" },
    { 0x5856, "look_control_on" },
    { 0x5857, "lookahead_path" },
    { 0x5858, "lookahead_value" },
    { 0x5859, "lookangle" },
    { 0x585A, "lookat_roundabout_rappel_trigger" },
    { 0x585B, "lookat_roundabout_tanker_explode_trigger" },
    { 0x585C, "lookat_triggers" },
    { 0x585D, "lookatent" },
    { 0x585E, "lookatidleupdate" },
    { 0x585F, "lookattarget" },
    { 0x5860, "lookbothways" },
    { 0x5861, "lookfast" },
    { 0x5862, "lookforbettercover" },
    { 0x5863, "lookforenemy" },
    { 0x5864, "lookline" },
    { 0x5865, "looklp" },
    { 0x5866, "lookupanim" },
    { 0x5867, "lookupanimarray" },
    { 0x5868, "lookupcameraconstraints" },
    { 0x5869, "lookupdeathquote" },
    { 0x586A, "lookupdoganim" },
    { 0x586B, "lookuptransitionanim" },
    { 0x586C, "loop_cache" },
    { 0x586D, "loop_data" },
    { 0x586E, "loop_duck_scalar" },
    { 0x586F, "loop_ent" },
    { 0x5870, "loop_entity_ref_count" },
    { 0x5871, "loop_fade_time" },
    { 0x5872, "loop_friendly_thermal_reflector_effect" },
    { 0x5873, "loop_fx_on_vehicle_tag" },
    { 0x5874, "loop_fx_sound" },
    { 0x5875, "loop_fx_sound_interval" },
    { 0x5876, "loop_fx_sound_interval_with_angles" },
    { 0x5877, "loop_fx_sound_with_angles" },
    { 0x5878, "loop_handle_index" },
    { 0x5879, "loop_list" },
    { 0x587A, "loop_sound_delete" },
    { 0x587B, "loop_under_construction" },
    { 0x587C, "loop_wait_building_jump" },
    { 0x587D, "loopanims" },
    { 0x587E, "looper" },
    { 0x587F, "loopfx" },
    { 0x5880, "loopfx_ontag" },
    { 0x5881, "loopfxchangedelay" },
    { 0x5882, "loopfxchangeid" },
    { 0x5883, "loopfxchangeorg" },
    { 0x5884, "loopfxdeletion" },
    { 0x5885, "loopfxstop" },
    { 0x5886, "loopfxthread" },
    { 0x5887, "loophide" },
    { 0x5888, "loopidlesound" },
    { 0x5889, "looping_airplanes" },
    { 0x588A, "looping_civilian_path_foodwalkers" },
    { 0x588B, "looping_heli_array" },
    { 0x588C, "looping_helis_currently_moving" },
    { 0x588D, "looping_tank_spawner" },
    { 0x588E, "loopingidleanimation" },
    { 0x588F, "loopingsoundstopnotifies" },
    { 0x5890, "loopmovesound" },
    { 0x5891, "loopreflectoreffect" },
    { 0x5892, "loops" },
    { 0x5893, "loopsound" },
    { 0x5894, "loopsound_ent" },
    { 0x5895, "loopsoundthread" },
    { 0x5896, "loopstingerlockedfeedback" },
    { 0x5897, "loopstingerlockingfeedback" },
    { 0x5898, "lootplaytimevalidated" },
    { 0x5899, "los" },
    { 0x589A, "losendtime" },
    { 0x589B, "losing_connection_multipler" },
    { 0x589C, "lost_civilian_anim_struct" },
    { 0x589D, "lost_civilian_door" },
    { 0x589E, "lost_civilian_guard_watch_for_alert" },
    { 0x589F, "low_ammo" },
    { 0x58A0, "low_wall_human" },
    { 0x58A1, "lower_accuracy_by_percent" },
    { 0x58A2, "lower_elevator_door" },
    { 0x58A3, "lower_shield" },
    { 0x58A4, "lower_stairwell_door" },
    { 0x58A5, "lowering_door_slide_hint" },
    { 0x58A6, "lowering_door_think" },
    { 0x58A7, "lowermessage" },
    { 0x58A8, "lowermessagefont" },
    { 0x58A9, "lowermessages" },
    { 0x58AA, "lowermessagethink" },
    { 0x58AB, "lowertextfontsize" },
    { 0x58AC, "lowertexty" },
    { 0x58AD, "lowertextyalign" },
    { 0x58AE, "lowertimer" },
    { 0x58AF, "lowestwins" },
    { 0x58B0, "lowestwithhalfplayedtime" },
    { 0x58B1, "lowstandisok" },
    { 0x58B2, "lrgvolmin" },
    { 0x58B3, "lsr_rocket_count" },
    { 0x58B4, "lsr_rocket_think" },
    { 0x58B5, "lsr_target_ent" },
    { 0x58B6, "lsr_target_monitor_and_cleanup" },
    { 0x58B7, "lt_harness_breakout" },
    { 0x58B8, "lt_root_climb_key_intensity_init" },
    { 0x58B9, "lt_root_climb_key_shadow_res" },
    { 0x58BA, "lt_root_climb_rim_intensity_init" },
    { 0x58BB, "lt_rt_harness_breakout" },
    { 0x58BC, "ltindices" },
    { 0x58BD, "ltorigin" },
    { 0x58BE, "lunging_take_down" },
    { 0x58BF, "lvl_visionset" },
    { 0x58C0, "m_angledelta" },
    { 0x58C1, "m_anim" },
    { 0x58C2, "m_delta" },
    { 0x58C3, "m_turnanim" },
    { 0x58C4, "m_turret_1_dead_dialogue" },
    { 0x58C5, "m_worldstartpos" },
    { 0x58C6, "m990_hit" },
    { 0x58C7, "machinesparkarray" },
    { 0x58C8, "maddox" },
    { 0x58C9, "mag_glove_get_direction_from_normalized_movement" },
    { 0x58CA, "mag_glove_get_requested_move_direction" },
    { 0x58CB, "mag_glove_orient_to_surface" },
    { 0x58CC, "mag_glove_player_controller" },
    { 0x58CD, "mag_glove_player_mount" },
    { 0x58CE, "mag_glove_precache" },
    { 0x58CF, "mag_hit" },
    { 0x58D0, "mag_mount_link_player" },
    { 0x58D1, "mag_mount_unlink_player" },
    { 0x58D2, "mag_move_dir" },
    { 0x58D3, "mag_rest" },
    { 0x58D4, "mag_to_jump_direction_is_valid" },
    { 0x58D5, "mag_wall_gov_setup" },
    { 0x58D6, "mag_windup_l" },
    { 0x58D7, "mag_windup_r" },
    { 0x58D8, "magic_bullet_death_detection" },
    { 0x58D9, "magic_bullet_kill" },
    { 0x58DA, "magic_bullet_shield" },
    { 0x58DB, "magic_bullet_strafe" },
    { 0x58DC, "magic_distance" },
    { 0x58DD, "magic_emp_grenade" },
    { 0x58DE, "magic_grenades_thrown" },
    { 0x58DF, "magic_smoke_grenade" },
    { 0x58E0, "magic_threat_grenade" },
    { 0x58E1, "magicreloadwhenreachenemy" },
    { 0x58E2, "maglev_by_school_sweetener_num" },
    { 0x58E3, "magnet" },
    { 0x58E4, "magnet_factor" },
    { 0x58E5, "magnet_radius" },
    { 0x58E6, "magnetic_hands_direction_is_valid" },
    { 0x58E7, "magnetoptions" },
    { 0x58E8, "main_anim_idle_vm" },
    { 0x58E9, "main_anims" },
    { 0x58EA, "main_anims_vm" },
    { 0x58EB, "main_autopsy" },
    { 0x58EC, "main_autopsy_halls" },
    { 0x58ED, "main_battle_to_heli" },
    { 0x58EE, "main_camp_spot" },
    { 0x58EF, "main_driver" },
    { 0x58F0, "main_end_escape" },
    { 0x58F1, "main_gatedoor" },
    { 0x58F2, "main_gd" },
    { 0x58F3, "main_heliride" },
    { 0x58F4, "main_incinerator" },
    { 0x58F5, "main_introdrive" },
    { 0x58F6, "main_mb1" },
    { 0x58F7, "main_mb1_intro" },
    { 0x58F8, "main_mb1_jump" },
    { 0x58F9, "main_mb1_mech" },
    { 0x58FA, "main_mb2" },
    { 0x58FB, "main_mb2_gatesmash" },
    { 0x58FC, "main_missle_lighting_floor3" },
    { 0x58FD, "main_missle_lighting_silotop" },
    { 0x58FE, "main_model" },
    { 0x58FF, "main_passenger" },
    { 0x5900, "main_pod_jets" },
    { 0x5901, "main_run_to_heli" },
    { 0x5902, "main_s1elevator" },
    { 0x5903, "main_s2elevator" },
    { 0x5904, "main_s2walk" },
    { 0x5905, "main_s3escape" },
    { 0x5906, "main_s3interrogate" },
    { 0x5907, "main_s3trolley" },
    { 0x5908, "main_test_chamber" },
    { 0x5909, "main_thread" },
    { 0x590A, "main2" },
    { 0x590B, "maingun_fx" },
    { 0x590C, "maingun_fx_override" },
    { 0x590D, "mainloopstart" },
    { 0x590E, "maintain_position" },
    { 0x590F, "maintain_position_around_queen" },
    { 0x5910, "make_all_boats_visible" },
    { 0x5911, "make_ally_jet" },
    { 0x5912, "make_array" },
    { 0x5913, "make_boidcloud" },
    { 0x5914, "make_boidcloud_from_spawned_models" },
    { 0x5915, "make_bridge_big" },
    { 0x5916, "make_bridge_normal" },
    { 0x5917, "make_camera_look_at_talker" },
    { 0x5918, "make_crate_boidcloud" },
    { 0x5919, "make_deaddrone" },
    { 0x591A, "make_discrete_trigger" },
    { 0x591B, "make_drone_crate" },
    { 0x591C, "make_drone_crate_group" },
    { 0x591D, "make_drone_fully_controllable" },
    { 0x591E, "make_drone_turret_target" },
    { 0x591F, "make_drone_turret_target_2" },
    { 0x5920, "make_drop_missile" },
    { 0x5921, "make_droppods" },
    { 0x5922, "make_emp_vulnerable" },
    { 0x5923, "make_empty_breach" },
    { 0x5924, "make_enemy_jet" },
    { 0x5925, "make_enemy_jet_special" },
    { 0x5926, "make_entity_sentient_mp" },
    { 0x5927, "make_exploder_truck" },
    { 0x5928, "make_gate_close_down" },
    { 0x5929, "make_hero" },
    { 0x592A, "make_invulnerable_while_idle" },
    { 0x592B, "make_me_alert" },
    { 0x592C, "make_missile_ammo_hud" },
    { 0x592D, "make_mobile_turret_unusable" },
    { 0x592E, "make_mobile_turret_usable" },
    { 0x592F, "make_modile_turret_invincible" },
    { 0x5930, "make_no_fly_zone" },
    { 0x5931, "make_non_sentient" },
    { 0x5932, "make_queen_invulnerable" },
    { 0x5933, "make_react_explosion" },
    { 0x5934, "make_reentry_strobe" },
    { 0x5935, "make_remaining_player_a_little_stronger" },
    { 0x5936, "make_seat_cormack" },
    { 0x5937, "make_seat_npc" },
    { 0x5938, "make_seat_rack" },
    { 0x5939, "make_shooter_car" },
    { 0x593A, "make_smart_floor_effect" },
    { 0x593B, "make_squirly_path" },
    { 0x593C, "make_tracking_grenade" },
    { 0x593D, "make_vehicl_invicible" },
    { 0x593E, "make_walker" },
    { 0x593F, "make_walker_invulnerable" },
    { 0x5940, "make_walker_tank_invulnerable_for_time" },
    { 0x5941, "makeavailableforbcs" },
    { 0x5942, "makeenemyusable" },
    { 0x5943, "makeentitysentient_func" },
    { 0x5944, "makeexplosivetargetablebyai" },
    { 0x5945, "makegloballyunusablebytype" },
    { 0x5946, "makegloballyusablebytype" },
    { 0x5947, "makehelitype" },
    { 0x5948, "makeinvul" },
    { 0x5949, "makeletterstonumbers" },
    { 0x594A, "makemobileturretunusable" },
    { 0x594B, "makesolid" },
    { 0x594C, "makesureturnworks" },
    { 0x594D, "makesureweaponchanges" },
    { 0x594E, "maketeamusable" },
    { 0x594F, "male_civilian_alert_sound" },
    { 0x5950, "man_overboard" },
    { 0x5951, "man_overboard_helper" },
    { 0x5952, "manage_aim_cursor" },
    { 0x5953, "manage_burke_bike_behavior" },
    { 0x5954, "manage_day_night" },
    { 0x5955, "manage_deck_combat" },
    { 0x5956, "manage_dof" },
    { 0x5957, "manage_force_shadow_lights" },
    { 0x5958, "manage_health_rumble" },
    { 0x5959, "manage_highlight" },
    { 0x595A, "manage_highlight_end" },
    { 0x595B, "manage_laser_beams" },
    { 0x595C, "manage_player_exo" },
    { 0x595D, "manage_player_exo_toggling" },
    { 0x595E, "manage_player_using_mobile_turret" },
    { 0x595F, "manage_staircase_lights" },
    { 0x5960, "manage_turn" },
    { 0x5961, "manage_walker_health" },
    { 0x5962, "manage_windshield_states" },
    { 0x5963, "manga_rocket_explosion" },
    { 0x5964, "manga_rocket_trail" },
    { 0x5965, "mangarocketparentupdate" },
    { 0x5966, "mangarocketupdate" },
    { 0x5967, "manhandled" },
    { 0x5968, "manhandled_spawners" },
    { 0x5969, "manhandler" },
    { 0x596A, "manhandler_hold" },
    { 0x596B, "manhandler_think" },
    { 0x596C, "manhole_lighting" },
    { 0x596D, "manhole_move_start" },
    { 0x596E, "manhole_move_start_foley" },
    { 0x596F, "manhuntintroscreen" },
    { 0x5970, "manipulate_createfx_ents" },
    { 0x5971, "mantle_over_low_wall_38_human" },
    { 0x5972, "mantle_over_low_wall_40_human" },
    { 0x5973, "mantling" },
    { 0x5974, "manual_cannon_reload" },
    { 0x5975, "manual_linkto" },
    { 0x5976, "manual_tag_linkto" },
    { 0x5977, "manual_target" },
    { 0x5978, "manual_think" },
    { 0x5979, "manualdropthink" },
    { 0x597A, "manuallydetonateall" },
    { 0x597B, "manuallydetonated_removeundefined" },
    { 0x597C, "manuallydetonatedarray" },
    { 0x597D, "manuallydetonatefunc" },
    { 0x597E, "manuallyjoiningkillstreak" },
    { 0x597F, "manuallyjoinwarbird" },
    { 0x5980, "manualtarget" },
    { 0x5981, "map_border_hud_updater" },
    { 0x5982, "map_border_trig_array" },
    { 0x5983, "map_extents" },
    { 0x5984, "map_height" },
    { 0x5985, "map_is_early_in_the_game" },
    { 0x5986, "map_sun_flare_position" },
    { 0x5987, "map_width" },
    { 0x5988, "map_without_loadout" },
    { 0x5989, "mapcenter" },
    { 0x598A, "mapcustombotkillstreakfunc" },
    { 0x598B, "mapcustomkillstreakfunc" },
    { 0x598C, "mapkillstreak" },
    { 0x598D, "mapkillstreakautodropindex" },
    { 0x598E, "mapkillstreakdamagefeedbacksound" },
    { 0x598F, "mapkillstreakevent" },
    { 0x5990, "mapkillstreakpickupstring" },
    { 0x5991, "maprange" },
    { 0x5992, "maps" },
    { 0x5993, "mapsize" },
    { 0x5994, "mapstreaksdisabled" },
    { 0x5995, "marine_3" },
    { 0x5996, "mark_adjacent_script_cars" },
    { 0x5997, "mark_and_execute_off" },
    { 0x5998, "mark_and_execute_on" },
    { 0x5999, "mark_and_execute_vo_controller" },
    { 0x599A, "mark_enemies" },
    { 0x599B, "mark_enemy" },
    { 0x599C, "mark_enemy_model" },
    { 0x599D, "mark_friendly_model" },
    { 0x599E, "mark_fx" },
    { 0x599F, "mark_guy_fx" },
    { 0x59A0, "mark_monitor" },
    { 0x59A1, "mark_nodes_near_spawnnodes_and_startnodes" },
    { 0x59A2, "mark_stats_checkpoint" },
    { 0x59A3, "mark_stencil" },
    { 0x59A4, "mark_swarm_target" },
    { 0x59A5, "markallies" },
    { 0x59A6, "markalliesenemytarget" },
    { 0x59A7, "markallytargets" },
    { 0x59A8, "markatriumenemiesatwarning" },
    { 0x59A9, "markdistance" },
    { 0x59AA, "markdronetargetally" },
    { 0x59AB, "markdronetargetenemy" },
    { 0x59AC, "markdronetargetvehicle" },
    { 0x59AD, "marked" },
    { 0x59AE, "marked_enemy" },
    { 0x59AF, "marked_enemy_death_cleanup" },
    { 0x59B0, "marked_enemy_marker" },
    { 0x59B1, "markedplayerarray" },
    { 0x59B2, "markedplayers" },
    { 0x59B3, "markedturretarray" },
    { 0x59B4, "markenemyposinvisible" },
    { 0x59B5, "market_kill_volume" },
    { 0x59B6, "market_walla_cleanup" },
    { 0x59B7, "market_walla_init" },
    { 0x59B8, "marketcamiszoomed" },
    { 0x59B9, "marketdecoywalk" },
    { 0x59BA, "marketenemyinit" },
    { 0x59BB, "marketguybadplace" },
    { 0x59BC, "markethost" },
    { 0x59BD, "marketkvaambusherdrawgun" },
    { 0x59BE, "marketkvaambusherstopidle" },
    { 0x59BF, "marketkvafollowtargetalerted" },
    { 0x59C0, "marketkvafollowtargetalertmonitor" },
    { 0x59C1, "marketkvafollowtargetbuttoncapture" },
    { 0x59C2, "marketkvafollowtargetbuttonhint" },
    { 0x59C3, "marketkvafollowtargetdrawgun" },
    { 0x59C4, "marketkvafollowtargetgate" },
    { 0x59C5, "marketkvafollowtargetkill" },
    { 0x59C6, "marketkvafollowtargetmeleecheck" },
    { 0x59C7, "marketkvafollowtargetnecksnaprumble" },
    { 0x59C8, "marketkvafollowtargetstopidle" },
    { 0x59C9, "marketkvafollowtargettimer" },
    { 0x59CA, "marketkvafollowtargetwalk1" },
    { 0x59CB, "marketkvafollowtargetwalk2" },
    { 0x59CC, "marketmovekvafollowtarget" },
    { 0x59CD, "marketscanautohighlight" },
    { 0x59CE, "marketscancomplete" },
    { 0x59CF, "markettimewindow" },
    { 0x59D0, "marketvendor" },
    { 0x59D1, "markparkingcars" },
    { 0x59D2, "markplayerasrockettarget" },
    { 0x59D3, "markplayertarget" },
    { 0x59D4, "mash_x" },
    { 0x59D5, "mask" },
    { 0x59D6, "mask_destructibles_in_volumes" },
    { 0x59D7, "mask_exploders_in_volume" },
    { 0x59D8, "mask_interactives_in_volumes" },
    { 0x59D9, "masked_exploder" },
    { 0x59DA, "massnodeinitfunctions" },
    { 0x59DB, "master" },
    { 0x59DC, "master_volume" },
    { 0x59DD, "masterychallengeprocess" },
    { 0x59DE, "match_angles_pos" },
    { 0x59DF, "match_player_floor_percent" },
    { 0x59E0, "match_player_speed" },
    { 0x59E1, "match_speed_to_jet" },
    { 0x59E2, "matchbonus" },
    { 0x59E3, "matchdata" },
    { 0x59E4, "matchforfeittimer" },
    { 0x59E5, "matchforfeittimer_internal" },
    { 0x59E6, "matchmakinggame" },
    { 0x59E7, "matchoutcomenotify" },
    { 0x59E8, "matchrules_allowcustomclasses" },
    { 0x59E9, "matchrules_damagemultiplier" },
    { 0x59EA, "matchrules_numinitialinfected" },
    { 0x59EB, "matchrules_randomize" },
    { 0x59EC, "matchrules_showjuggradaricon" },
    { 0x59ED, "matchrules_switchteamdisabled" },
    { 0x59EE, "matchrules_vampirism" },
    { 0x59EF, "matchstarted" },
    { 0x59F0, "matchstarttimer" },
    { 0x59F1, "matchstarttimer_internal" },
    { 0x59F2, "matchstarttimerskip" },
    { 0x59F3, "matchstarttimerwaitforplayers" },
    { 0x59F4, "matchzonestotriggers" },
    { 0x59F5, "material" },
    { 0x59F6, "materiallayering_ng" },
    { 0x59F7, "matrix33" },
    { 0x59F8, "maverick_counter" },
//  { 0x59F9, "max" },
    { 0x59FA, "max_accel" },
    { 0x59FB, "max_active_events" },
    { 0x59FC, "max_bob_period" },
    { 0x59FD, "max_calls_per_frame" },
    { 0x59FE, "max_count" },
    { 0x59FF, "max_delay" },
    { 0x5A00, "max_delta" },
    { 0x5A01, "max_delta_angle" },
    { 0x5A02, "max_drones" },
    { 0x5A03, "max_dx" },
    { 0x5A04, "max_dx_period" },
    { 0x5A05, "max_dy" },
    { 0x5A06, "max_dy_period" },
    { 0x5A07, "max_entities" },
    { 0x5A08, "max_exo_guysalive" },
    { 0x5A09, "max_fake_health" },
    { 0x5A0A, "max_fire_time" },
    { 0x5A0B, "max_float" },
    { 0x5A0C, "max_health" },
    { 0x5A0D, "max_health_amplify_object" },
    { 0x5A0E, "max_hit_count" },
    { 0x5A0F, "max_pitch" },
    { 0x5A10, "max_pitch_period" },
    { 0x5A11, "max_pitch_time" },
    { 0x5A12, "max_points" },
    { 0x5A13, "max_pt" },
    { 0x5A14, "max_punishments" },
    { 0x5A15, "max_radius" },
    { 0x5A16, "max_range" },
    { 0x5A17, "max_roll" },
    { 0x5A18, "max_roll_period" },
    { 0x5A19, "max_sink" },
    { 0x5A1A, "max_sniper_burst_delay_time" },
    { 0x5A1B, "max_speed" },
    { 0x5A1C, "max_start_angle" },
    { 0x5A1D, "max_trav_time" },
    { 0x5A1E, "max_voices" },
    { 0x5A1F, "max_warnings" },
    { 0x5A20, "max_yaw" },
    { 0x5A21, "max_yaw_period" },
    { 0x5A22, "maxalivedogcount" },
    { 0x5A23, "maxalivedronecount" },
    { 0x5A24, "maxaliveenemycount" },
    { 0x5A25, "maxallowedteamkills" },
    { 0x5A26, "maxalpha" },
    { 0x5A27, "maxammopickupsperround" },
    { 0x5A28, "maxanglecheckpitchdelta" },
    { 0x5A29, "maxanglecheckyawdelta" },
    { 0x5A2A, "maxburstdelay" },
    { 0x5A2B, "maxburstfireinterval" },
    { 0x5A2C, "maxclients" },
    { 0x5A2D, "maxdamage" },
    { 0x5A2E, "maxdamageamount" },
    { 0x5A2F, "maxdelay" },
    { 0x5A30, "maxdestructions" },
    { 0x5A31, "maxdetpackdamage" },
    { 0x5A32, "maxdirections" },
    { 0x5A33, "maxdist" },
    { 0x5A34, "maxdistancecallout" },
    { 0x5A35, "maxdistancethreshold" },
    { 0x5A36, "maxdogcount" },
    { 0x5A37, "maxdronecount" },
    { 0x5A38, "maxenemycount" },
    { 0x5A39, "maxentries" },
    { 0x5A3A, "maxevents" },
    { 0x5A3B, "maxflashedseconds" },
    { 0x5A3C, "maxfontscale" },
    { 0x5A3D, "maxfriendlies" },
    { 0x5A3E, "maxhealthoverlay" },
    { 0x5A3F, "maxkillstreaks" },
    { 0x5A40, "maxlaserrange" },
    { 0x5A41, "maxlightarmorhp" },
    { 0x5A42, "maxlightstopsperframe" },
    { 0x5A43, "maxlives" },
    { 0x5A44, "maxloadouts" },
    { 0x5A45, "maxlogclients" },
    { 0x5A46, "maxmove" },
    { 0x5A47, "maxnodes" },
    { 0x5A48, "maxnumawardsperplayer" },
    { 0x5A49, "maxnumchallengesperplayer" },
    { 0x5A4A, "maxopacity" },
    { 0x5A4B, "maxorbitangle" },
    { 0x5A4C, "maxorbitdist" },
    { 0x5A4D, "maxperplayerexplosives" },
    { 0x5A4E, "maxpickupsperround" },
    { 0x5A4F, "maxpitch" },
    { 0x5A50, "maxplayercount" },
    { 0x5A51, "maxpoint" },
    { 0x5A52, "maxradius" },
    { 0x5A53, "maxrank" },
    { 0x5A54, "maxrounds" },
    { 0x5A55, "maxrunngunangle" },
    { 0x5A56, "maxscore" },
    { 0x5A57, "maxspeakers" },
    { 0x5A58, "maxtracecount" },
    { 0x5A59, "maxtracesperframe" },
    { 0x5A5A, "maxtrackingrange" },
    { 0x5A5B, "maxturn" },
    { 0x5A5C, "maxvehiclesallowed" },
    { 0x5A5D, "may_change_cover_warning_alpha" },
    { 0x5A5E, "maydolaststand" },
    { 0x5A5F, "maydolaststandhorde" },
    { 0x5A60, "maydoupwardsdeath" },
    { 0x5A61, "maydropweapon" },
    { 0x5A62, "mayonlydie" },
    { 0x5A63, "mayprocesschallenges" },
    { 0x5A64, "mayshootwhilemoving" },
    { 0x5A65, "mayspawn" },
    { 0x5A66, "maythrowdoublegrenade" },
    { 0x5A67, "mb_off" },
    { 0x5A68, "mb_on" },
    { 0x5A69, "mb_run_to_goal" },
    { 0x5A6A, "mb_setup" },
    { 0x5A6B, "mb_surprise" },
    { 0x5A6C, "mb_tackle" },
    { 0x5A6D, "mb2_lift" },
    { 0x5A6E, "mb2_lift_enemydeath" },
    { 0x5A6F, "mb2_lift_steam" },
    { 0x5A70, "mb2_max_enemies" },
    { 0x5A71, "mblur_cam_enable" },
    { 0x5A72, "mblur_cam_enable_trigger" },
    { 0x5A73, "mblur_disable" },
    { 0x5A74, "mblur_disable_trigger" },
    { 0x5A75, "mblur_enable" },
    { 0x5A76, "mblur_enable_trigger" },
    { 0x5A77, "mblur_intro_fly_in_disable" },
    { 0x5A78, "mblur_intro_fly_in_enable" },
    { 0x5A79, "mblur_off" },
    { 0x5A7A, "mblur_on" },
    { 0x5A7B, "mblur_rotation_on" },
    { 0x5A7C, "mccqueue" },
    { 0x5A7D, "mech" },
    { 0x5A7E, "mech_action_shoot" },
    { 0x5A7F, "mech_action_smash" },
    { 0x5A80, "mech_action_smash_projectile" },
    { 0x5A81, "mech_amb" },
    { 0x5A82, "mech_badplace_behavior" },
    { 0x5A83, "mech_behavior_init" },
    { 0x5A84, "mech_bullet_ricochet" },
    { 0x5A85, "mech_capture_player" },
    { 0x5A86, "mech_convoy_dialogue" },
    { 0x5A87, "mech_corral_alt" },
    { 0x5A88, "mech_crush" },
    { 0x5A89, "mech_damage_end_support" },
    { 0x5A8A, "mech_death_function" },
    { 0x5A8B, "mech_death_save" },
    { 0x5A8C, "mech_death_throw" },
    { 0x5A8D, "mech_death_update_objective" },
    { 0x5A8E, "mech_do_melee" },
    { 0x5A8F, "mech_emp_function" },
    { 0x5A90, "mech_emp_loop" },
    { 0x5A91, "mech_enable" },
    { 0x5A92, "mech_enable_switch_exhaust_version" },
    { 0x5A93, "mech_entry_action" },
    { 0x5A94, "mech_error_timeout" },
    { 0x5A95, "mech_exit_fade_out" },
    { 0x5A96, "mech_exit_gate_lighting" },
    { 0x5A97, "mech_fire_missile" },
    { 0x5A98, "mech_fire_missile_first" },
    { 0x5A99, "mech_fire_rockets" },
    { 0x5A9A, "mech_fire_rockets_for_anim" },
    { 0x5A9B, "mech_fire_rockets_special" },
    { 0x5A9C, "mech_fs_walk_slow" },
    { 0x5A9D, "mech_fx" },
    { 0x5A9E, "mech_generic_attacking_behavior" },
    { 0x5A9F, "mech_generic_human" },
    { 0x5AA0, "mech_get_closest_node" },
    { 0x5AA1, "mech_glass_damage_think" },
    { 0x5AA2, "mech_grapple_init" },
    { 0x5AA3, "mech_grapple_kill_success" },
    { 0x5AA4, "mech_grapple_player_success_loop" },
    { 0x5AA5, "mech_grapple_pull_guy_to_player" },
    { 0x5AA6, "mech_grapple_reset_dof" },
    { 0x5AA7, "mech_grapple_setup_function" },
    { 0x5AA8, "mech_grapple_spawn_mech_guy" },
    { 0x5AA9, "mech_grapple_spawn_mech_parts" },
    { 0x5AAA, "mech_grapple_start_slowmo" },
    { 0x5AAB, "mech_grapple_start_speedup" },
    { 0x5AAC, "mech_grapple_stop_slowmo" },
    { 0x5AAD, "mech_grapple_tappy_fail" },
    { 0x5AAE, "mech_grapple_tappy_monitor_button_presses" },
    { 0x5AAF, "mech_grapple_tappy_pressed" },
    { 0x5AB0, "mech_grapple_tappy_success" },
    { 0x5AB1, "mech_handle_grapple_tappy" },
    { 0x5AB2, "mech_handle_grapple_tappy_sound" },
    { 0x5AB3, "mech_hit_vfx" },
    { 0x5AB4, "mech_hunt_alter_turnrates" },
    { 0x5AB5, "mech_hunt_immediately_behavior" },
    { 0x5AB6, "mech_hunt_stealth_behavior" },
    { 0x5AB7, "mech_incoming_damage_modifiers" },
    { 0x5AB8, "mech_incoming_damage_modifiers_baghdad" },
    { 0x5AB9, "mech_incoming_damage_target_player" },
    { 0x5ABA, "mech_init" },
    { 0x5ABB, "mech_initialized" },
    { 0x5ABC, "mech_intro_gate_lighting" },
    { 0x5ABD, "mech_intro_land_dust" },
    { 0x5ABE, "mech_is_hunting" },
    { 0x5ABF, "mech_is_shooting_rockets" },
    { 0x5AC0, "mech_linkplayerview_rocket" },
    { 0x5AC1, "mech_long_distance_damage" },
    { 0x5AC2, "mech_lower_rocket_pod" },
    { 0x5AC3, "mech_lower_turnrates" },
    { 0x5AC4, "mech_march_follower_enemy_think" },
    { 0x5AC5, "mech_march_footstep_rumbles" },
    { 0x5AC6, "mech_march_logic" },
    { 0x5AC7, "mech_march_runner_enemy_think" },
    { 0x5AC8, "mech_max_health" },
    { 0x5AC9, "mech_melee_behavior" },
    { 0x5ACA, "mech_melee_endscript" },
    { 0x5ACB, "mech_melee_is_valid" },
    { 0x5ACC, "mech_melee_trace_passed" },
    { 0x5ACD, "mech_metal_rattle" },
    { 0x5ACE, "mech_minigun_loop" },
    { 0x5ACF, "mech_movement" },
    { 0x5AD0, "mech_obj_loop" },
    { 0x5AD1, "mech_obj_move" },
    { 0x5AD2, "mech_objective_nag" },
    { 0x5AD3, "mech_pain_adder" },
    { 0x5AD4, "mech_pain_loop" },
    { 0x5AD5, "mech_pilot" },
    { 0x5AD6, "mech_player_anims" },
    { 0x5AD7, "mech_precise_target_position" },
    { 0x5AD8, "mech_raise_rocket_pod" },
    { 0x5AD9, "mech_random_missile_attractor_cleanup" },
    { 0x5ADA, "mech_random_missile_attractors" },
    { 0x5ADB, "mech_rocket_clear" },
    { 0x5ADC, "mech_rocket_deploy_projectile_think" },
    { 0x5ADD, "mech_rocket_fire_timeout" },
    { 0x5ADE, "mech_rocket_launcher_behavior" },
    { 0x5ADF, "mech_rocket_projectile_think" },
    { 0x5AE0, "mech_scan" },
    { 0x5AE1, "mech_script_model_anims" },
    { 0x5AE2, "mech_script_models" },
    { 0x5AE3, "mech_set_goal_node" },
    { 0x5AE4, "mech_setup" },
    { 0x5AE5, "mech_setup_grapple_tappy" },
    { 0x5AE6, "mech_setup_player_for_forced_walk_scene" },
    { 0x5AE7, "mech_setup_player_for_gameplay" },
    { 0x5AE8, "mech_setup_player_for_scene" },
    { 0x5AE9, "mech_slate_quick" },
    { 0x5AEA, "mech_spawn_player_rig" },
    { 0x5AEB, "mech_spawn_warbird" },
    { 0x5AEC, "mech_splode_sound" },
    { 0x5AED, "mech_start_badplace_behavior" },
    { 0x5AEE, "mech_start_generic_attacking" },
    { 0x5AEF, "mech_start_grapple_tappy" },
    { 0x5AF0, "mech_start_hunting" },
    { 0x5AF1, "mech_start_reduced_nonplayer_damage" },
    { 0x5AF2, "mech_start_rockets" },
    { 0x5AF3, "mech_start_target_attacker" },
    { 0x5AF4, "mech_steps" },
    { 0x5AF5, "mech_stop_badplace_behavior" },
    { 0x5AF6, "mech_stop_boost_slam_sp_dmg" },
    { 0x5AF7, "mech_stop_generic_attacking" },
    { 0x5AF8, "mech_stop_hunting" },
    { 0x5AF9, "mech_stop_reduced_nonplayer_damage" },
    { 0x5AFA, "mech_stop_rockets" },
    { 0x5AFB, "mech_stop_target_attacker" },
    { 0x5AFC, "mech_swarm_line_of_sight_lock_duration" },
    { 0x5AFD, "mech_swarm_number_of_rockets_per_target" },
    { 0x5AFE, "mech_swarm_rocket_dud_max_count" },
    { 0x5AFF, "mech_swarm_rocket_dud_min_count" },
    { 0x5B00, "mech_swarm_rocket_max_targets" },
    { 0x5B01, "mech_swarm_skip_line_of_sight_obstruction_test" },
    { 0x5B02, "mech_swarm_two_stage_swarm_homing_distance" },
    { 0x5B03, "mech_swarm_two_stage_swarm_homing_strength" },
    { 0x5B04, "mech_swarm_use_two_stage_swarm" },
    { 0x5B05, "mech_target_attacker" },
    { 0x5B06, "mech_threat_paint_delay" },
    { 0x5B07, "mech_turn_loop" },
    { 0x5B08, "mech_unlinkplayerview_rocket" },
    { 0x5B09, "mech_using_this_node" },
    { 0x5B0A, "mech_vehicle_anims" },
    { 0x5B0B, "mech_vfx_loop" },
    { 0x5B0C, "mech_victim_death_func" },
    { 0x5B0D, "mech_wait_for_drop" },
    { 0x5B0E, "mech_wall_smash" },
    { 0x5B0F, "mech_wall_smash_3d" },
    { 0x5B10, "mech_warehouse_door_smash" },
    { 0x5B11, "mech_weapon_offline" },
    { 0x5B12, "mech1" },
    { 0x5B13, "mech1_animdrop" },
    { 0x5B14, "mech1_death_move_monsters" },
    { 0x5B15, "mech1_dropfx" },
    { 0x5B16, "mech1_dropsound" },
    { 0x5B17, "mech1_focal_change" },
    { 0x5B18, "mech1_forceangle" },
    { 0x5B19, "mech1_logic" },
    { 0x5B1A, "mech2" },
    { 0x5B1B, "mech3_logic" },
    { 0x5B1C, "mech4_death_move_monsters" },
    { 0x5B1D, "mech4_logic" },
    { 0x5B1E, "mechanism_center_lights_event_fx" },
    { 0x5B1F, "mechbird_handlecloak" },
    { 0x5B20, "mechdata" },
    { 0x5B21, "mechdata_left_bones" },
    { 0x5B22, "mechdata_right_bones" },
    { 0x5B23, "mechhealth" },
    { 0x5B24, "mechmissileattractors" },
    { 0x5B25, "mechmissilerepulsors" },
    { 0x5B26, "mechpainbuildup" },
    { 0x5B27, "mechrocketdebug" },
    { 0x5B28, "mechs_attacking_me" },
    { 0x5B29, "mechs_focal_change" },
    { 0x5B2A, "mechs_living" },
    { 0x5B2B, "mechs_motorpool_animation" },
    { 0x5B2C, "mechs_upclose" },
    { 0x5B2D, "mechuistate" },
    { 0x5B2E, "median_crash" },
    { 0x5B2F, "median_cross" },
    { 0x5B30, "medium_orbitalsupport_ammo" },
    { 0x5B31, "medvolmin" },
    { 0x5B32, "meet_cormack_cormack" },
    { 0x5B33, "meet_cormack_kill_org" },
    { 0x5B34, "meet_cormack_pt2_begin" },
    { 0x5B35, "meet_cormack_pt2_enemies" },
    { 0x5B36, "meet_cormack_pt2_main" },
    { 0x5B37, "meet_cormack_pt2_start" },
    { 0x5B38, "meet_cormack_pt2_vo" },
    { 0x5B39, "melee" },
    { 0x5B3A, "melee_able_timer" },
    { 0x5B3B, "melee_acquiremutex" },
    { 0x5B3C, "melee_aivsai_animcustominterruptionmonitor" },
    { 0x5B3D, "melee_aivsai_chooseaction" },
    { 0x5B3E, "melee_aivsai_execute" },
    { 0x5B3F, "melee_aivsai_exposed_chooseanimationandposition" },
    { 0x5B40, "melee_aivsai_exposed_chooseanimationandposition_behind" },
    { 0x5B41, "melee_aivsai_exposed_chooseanimationandposition_buildexposedlist" },
    { 0x5B42, "melee_aivsai_exposed_chooseanimationandposition_flip" },
    { 0x5B43, "melee_aivsai_exposed_chooseanimationandposition_wrestle" },
    { 0x5B44, "melee_aivsai_getinposition" },
    { 0x5B45, "melee_aivsai_getinposition_finalize" },
    { 0x5B46, "melee_aivsai_getinposition_issuccessful" },
    { 0x5B47, "melee_aivsai_getinposition_updateandvalidatetarget" },
    { 0x5B48, "melee_aivsai_main" },
    { 0x5B49, "melee_aivsai_schedulenotetracklink" },
    { 0x5B4A, "melee_aivsai_specialcover_canexecute" },
    { 0x5B4B, "melee_aivsai_specialcover_chooseanimationandposition" },
    { 0x5B4C, "melee_aivsai_targetlink" },
    { 0x5B4D, "melee_chooseaction" },
    { 0x5B4E, "melee_clearfacialanim" },
    { 0x5B4F, "melee_damage_trigger" },
    { 0x5B50, "melee_deathhandler_delayed" },
    { 0x5B51, "melee_deathhandler_regular" },
    { 0x5B52, "melee_decide_winner" },
    { 0x5B53, "melee_disableinterruptions" },
    { 0x5B54, "melee_dogcleanup" },
    { 0x5B55, "melee_droppedweaponmonitorthread" },
    { 0x5B56, "melee_droppedweaponrestore" },
    { 0x5B57, "melee_endscript" },
    { 0x5B58, "melee_endscript_checkdeath" },
    { 0x5B59, "melee_endscript_checkpositionandmovement" },
    { 0x5B5A, "melee_endscript_checkstatechanges" },
    { 0x5B5B, "melee_endscript_checkweapon" },
    { 0x5B5C, "melee_enemy" },
    { 0x5B5D, "melee_enemy_new_node_time" },
    { 0x5B5E, "melee_enemy_node" },
    { 0x5B5F, "melee_handlenotetracks" },
    { 0x5B60, "melee_handlenotetracks_death" },
    { 0x5B61, "melee_handlenotetracks_shoulddieafterunsync" },
    { 0x5B62, "melee_handlenotetracks_unsync" },
    { 0x5B63, "melee_hint_displayed" },
    { 0x5B64, "melee_init" },
    { 0x5B65, "melee_isvalid" },
    { 0x5B66, "melee_mainloop" },
    { 0x5B67, "melee_needsweaponswap" },
    { 0x5B68, "melee_partnerendedmeleemonitorthread" },
    { 0x5B69, "melee_partnerendedmeleemonitorthread_shouldanimsurvive" },
    { 0x5B6A, "melee_playchargesound" },
    { 0x5B6B, "melee_playfacialanim" },
    { 0x5B6C, "melee_pressed" },
    { 0x5B6D, "melee_releasemutex" },
    { 0x5B6E, "melee_resetaction" },
    { 0x5B6F, "melee_self_at_same_node_time" },
    { 0x5B70, "melee_self_new_node_time" },
    { 0x5B71, "melee_self_node" },
    { 0x5B72, "melee_standard_checktimeconstraints" },
    { 0x5B73, "melee_standard_chooseaction" },
    { 0x5B74, "melee_standard_delaystandardcharge" },
    { 0x5B75, "melee_standard_getinposition" },
    { 0x5B76, "melee_standard_main" },
    { 0x5B77, "melee_standard_playattackloop" },
    { 0x5B78, "melee_standard_resetgiveuptime" },
    { 0x5B79, "melee_standard_updateandvalidatetarget" },
    { 0x5B7A, "melee_startmovement" },
    { 0x5B7B, "melee_stealthcheck" },
    { 0x5B7C, "melee_stopmovement" },
    { 0x5B7D, "melee_threat" },
    { 0x5B7E, "melee_tryexecuting" },
    { 0x5B7F, "melee_unlink" },
    { 0x5B80, "melee_unlinkinternal" },
    { 0x5B81, "melee_updateandvalidatestartpos" },
    { 0x5B82, "meleealwayswin" },
    { 0x5B83, "meleeattackcheck_whilemoving" },
    { 0x5B84, "meleebiteattackplayer" },
    { 0x5B85, "meleechargedistsq" },
    { 0x5B86, "meleecoverchargegraceendtime" },
    { 0x5B87, "meleecoverchargemintime" },
    { 0x5B88, "meleed" },
    { 0x5B89, "meleedamage" },
    { 0x5B8A, "meleefailed" },
    { 0x5B8B, "meleeforcedexposedflip" },
    { 0x5B8C, "meleeforcedexposedwrestle" },
    { 0x5B8D, "meleegetattackercardinaldirection" },
    { 0x5B8E, "meleeingplayer" },
    { 0x5B8F, "meleekilltarget" },
    { 0x5B90, "meleeplayerwhilemoving" },
    { 0x5B91, "meleeradiussq" },
    { 0x5B92, "meleeseq" },
    { 0x5B93, "meleestate" },
    { 0x5B94, "meleestruggle_istraverse" },
    { 0x5B95, "meleestrugglevsai" },
    { 0x5B96, "meleestrugglevsai_interrupted_animcustom" },
    { 0x5B97, "meleestrugglevsai_interrupted_animcustom_cleanup" },
    { 0x5B98, "meleestrugglevsai_interruptedcheck" },
    { 0x5B99, "meleestrugglevsai_traverse" },
    { 0x5B9A, "meleestrugglevsdog" },
    { 0x5B9B, "meleestrugglevsdog_collision" },
    { 0x5B9C, "meleestrugglevsdog_end" },
    { 0x5B9D, "meleestrugglevsdog_interruptedcheck" },
    { 0x5B9E, "meleestrugglevsdog_justdie" },
    { 0x5B9F, "meleestrugglevsdog_traverse" },
    { 0x5BA0, "memberaddfuncs" },
    { 0x5BA1, "memberaddstrings" },
    { 0x5BA2, "membercombatwaiter" },
    { 0x5BA3, "membercount" },
    { 0x5BA4, "memberdeathwaiter" },
    { 0x5BA5, "memberhastimedout" },
    { 0x5BA6, "memberid" },
    { 0x5BA7, "memberremovefuncs" },
    { 0x5BA8, "memberremovestrings" },
    { 0x5BA9, "members" },
    { 0x5BAA, "membertimeout" },
    { 0x5BAB, "menu" },
    { 0x5BAC, "menu_add_options" },
    { 0x5BAD, "menu_change_selected_fx" },
    { 0x5BAE, "menu_create" },
    { 0x5BAF, "menu_create_select" },
    { 0x5BB0, "menu_fx_creation" },
    { 0x5BB1, "menu_fx_option_set" },
    { 0x5BB2, "menu_none" },
    { 0x5BB3, "menu_select_by_name" },
    { 0x5BB4, "menuclass" },
    { 0x5BB5, "menugiveclass" },
    { 0x5BB6, "menunone" },
    { 0x5BB7, "menus" },
    { 0x5BB8, "menuspectator" },
    { 0x5BB9, "merge_lane" },
    { 0x5BBA, "merida" },
    { 0x5BBB, "message_handlers" },
    { 0x5BBC, "messages" },
    { 0x5BBD, "metal_detector" },
    { 0x5BBE, "metal_detector_dmg_monitor" },
    { 0x5BBF, "metal_detector_touch_monitor" },
    { 0x5BC0, "metal_detector_weapons" },
    { 0x5BC1, "methodsinit" },
    { 0x5BC2, "mg_animmg" },
    { 0x5BC3, "mg_gunner_death_notify" },
    { 0x5BC4, "mg_gunner_team" },
    { 0x5BC5, "mg42" },
    { 0x5BC6, "mg42_enabled" },
    { 0x5BC7, "mg42_firing" },
    { 0x5BC8, "mg42_gunner_manual_think" },
    { 0x5BC9, "mg42_gunner_think" },
    { 0x5BCA, "mg42_hide_distance" },
    { 0x5BCB, "mg42_setdifficulty" },
    { 0x5BCC, "mg42_suppressionfire" },
    { 0x5BCD, "mg42_target_drones" },
    { 0x5BCE, "mg42_think" },
    { 0x5BCF, "mg42_trigger" },
    { 0x5BD0, "mg42badplace_maxtime" },
    { 0x5BD1, "mg42badplace_mintime" },
    { 0x5BD2, "mg42pain" },
    { 0x5BD3, "mginit" },
    { 0x5BD4, "mgkill" },
    { 0x5BD5, "mgoff" },
    { 0x5BD6, "mgon" },
    { 0x5BD7, "mgteam_take_turns_firing" },
    { 0x5BD8, "mgturret" },
    { 0x5BD9, "mgturret_auto" },
    { 0x5BDA, "mgturretleft" },
    { 0x5BDB, "mgturretright" },
    { 0x5BDC, "mgturretsettings" },
    { 0x5BDD, "mgun_left" },
    { 0x5BDE, "mgun_right" },
    { 0x5BDF, "mhunt_cafe_cam_enter_front" },
    { 0x5BE0, "mhunt_cafe_cam_exit_front" },
    { 0x5BE1, "mhunt_cafe_cam_scan_fail" },
    { 0x5BE2, "mhunt_cafe_cam_scan_get" },
    { 0x5BE3, "mhunt_cafe_cam_scan_start" },
    { 0x5BE4, "mhunt_cafe_cam_scan_stop" },
    { 0x5BE5, "mhunt_cafe_cam_scan_target" },
    { 0x5BE6, "mhunt_cafe_cam_switch" },
    { 0x5BE7, "mhunt_cafe_cam_zoom_in" },
    { 0x5BE8, "mhunt_cafe_cam_zoom_out" },
    { 0x5BE9, "mhunt_cafe_cam1_switch" },
    { 0x5BEA, "mhunt_cafe_cam2_switch" },
    { 0x5BEB, "mhunt_cafe_cam3_switch" },
    { 0x5BEC, "mhunt_cafe_cam4_switch" },
    { 0x5BED, "mhunt_cc_assault_veh_01_approach" },
    { 0x5BEE, "mhunt_cc_assault_veh_02_approach" },
    { 0x5BEF, "mhunt_cc_assault_veh_03_approach" },
    { 0x5BF0, "mhunt_cc_hades_veh_escape" },
    { 0x5BF1, "mhunt_cc_parked_car_expl" },
    { 0x5BF2, "mhunt_level_end" },
    { 0x5BF3, "mhunt_melee_keycard_tkdwn" },
    { 0x5BF4, "mhunt_safehouse_cc_expl_distant" },
    { 0x5BF5, "mhunt_snpr_blood_impact_splat" },
    { 0x5BF6, "mhunt_snpr_dest_cafe_wall" },
    { 0x5BF7, "mhunt_snpr_tower_collapse" },
    { 0x5BF8, "mhunt_tv_broadcast" },
    { 0x5BF9, "mhunt_tv_dest_expl" },
    { 0x5BFA, "mi17_condition_callback_to_fly" },
    { 0x5BFB, "mi17_condition_callback_to_flyby" },
    { 0x5BFC, "mi17_condition_callback_to_hover" },
    { 0x5BFD, "mi17_input_callback_about_to_unload" },
    { 0x5BFE, "mi17_input_callback_facing" },
    { 0x5BFF, "microdrone_get_best_target" },
    { 0x5C00, "microdrone_get_target_offset" },
    { 0x5C01, "microdrone_get_target_pos" },
    { 0x5C02, "microdrone_think" },
    { 0x5C03, "microdronelauncher_cleanup" },
    { 0x5C04, "microwave_claim_safe_node" },
    { 0x5C05, "microwave_grenade_ai_flee_pulse" },
    { 0x5C06, "microwave_grenade_explode_wait" },
    { 0x5C07, "microwave_set_safe_goal" },
    { 0x5C08, "microwaved" },
    { 0x5C09, "microwaveded_ai" },
    { 0x5C0A, "mid_dude" },
    { 0x5C0B, "mid_dude_dead" },
    { 0x5C0C, "mid_gunfire_timer" },
    { 0x5C0D, "midair_exp_audio" },
    { 0x5C0E, "midair_exp_glass" },
    { 0x5C0F, "middle_civ_manager" },
    { 0x5C10, "middle_takedown_gun_up" },
    { 0x5C11, "middle_takedown_tread_fx" },
    { 0x5C12, "midpoint" },
    { 0x5C13, "midspawns" },
    { 0x5C14, "mig29_afterburners_node_wait" },
    { 0x5C15, "mig29_fire" },
    { 0x5C16, "mig29_fire_missiles" },
    { 0x5C17, "mig29_gun_dives" },
    { 0x5C18, "mig29_missile_dives" },
    { 0x5C19, "mig29_missile_set_target" },
    { 0x5C1A, "mig29_wait_fire_missile" },
    { 0x5C1B, "mig29_wait_start_firing" },
    { 0x5C1C, "mig29_wait_stop_firing" },
    { 0x5C1D, "military_drone_guards_patrol_think" },
    { 0x5C1E, "military_drone_guards_stationary_think" },
    { 0x5C1F, "military_drone_runners_think" },
    { 0x5C20, "military_drone_stationary_think" },
    { 0x5C21, "mimic_player_move" },
    { 0x5C22, "min" },
    { 0x5C23, "min_alert_level_duration" },
    { 0x5C24, "min_bob_period" },
    { 0x5C25, "min_delay" },
    { 0x5C26, "min_delta" },
    { 0x5C27, "min_delta_angle" },
    { 0x5C28, "min_drone_swarm_size" },
    { 0x5C29, "min_dx_period" },
    { 0x5C2A, "min_dy_period" },
    { 0x5C2B, "min_fire_time" },
    { 0x5C2C, "min_flyingby_wait" },
    { 0x5C2D, "min_flyingover_wait" },
    { 0x5C2E, "min_heavy" },
    { 0x5C2F, "min_light" },
    { 0x5C30, "min_num_bots_assaulting_first_flag" },
    { 0x5C31, "min_pitch" },
    { 0x5C32, "min_pitch_period" },
    { 0x5C33, "min_pitch_time" },
    { 0x5C34, "min_pt" },
    { 0x5C35, "min_radius" },
    { 0x5C36, "min_range" },
    { 0x5C37, "min_retrigger_time" },
    { 0x5C38, "min_roll_period" },
    { 0x5C39, "min_sniper_burst_delay_time" },
    { 0x5C3A, "min_speed" },
    { 0x5C3B, "min_speed_ips" },
    { 0x5C3C, "min_start_angle" },
    { 0x5C3D, "min_trav_time" },
    { 0x5C3E, "min_unload_frac_to_flop" },
    { 0x5C3F, "min_weap_clean2" },
    { 0x5C40, "min_yaw_period" },
    { 0x5C41, "minburstdelay" },
    { 0x5C42, "minburstfireinterval" },
    { 0x5C43, "mindamage" },
    { 0x5C44, "mindamageamount" },
    { 0x5C45, "mindelay" },
    { 0x5C46, "mindetpackdamage" },
    { 0x5C47, "mindistancecallout" },
    { 0x5C48, "mindistsquared" },
    { 0x5C49, "mindot" },
    { 0x5C4A, "mine_beacon" },
    { 0x5C4B, "mine_explode" },
    { 0x5C4C, "mine_launch" },
    { 0x5C4D, "mine_spin" },
    { 0x5C4E, "minebeacon" },
    { 0x5C4F, "minebeaconteamupdater" },
    { 0x5C50, "minebounce" },
    { 0x5C51, "minechangeowner" },
    { 0x5C52, "minecountdown" },
    { 0x5C53, "minedamagedebug" },
    { 0x5C54, "minedamagehalfheight" },
    { 0x5C55, "minedamageheightpassed" },
    { 0x5C56, "minedamagemax" },
    { 0x5C57, "minedamagemin" },
    { 0x5C58, "minedamagemonitor" },
    { 0x5C59, "minedamageradius" },
    { 0x5C5A, "minedeletetrigger" },
    { 0x5C5B, "minedetectiongraceperiod" },
    { 0x5C5C, "minedetectionheight" },
    { 0x5C5D, "minedetectionradius" },
    { 0x5C5E, "mineexplode" },
    { 0x5C5F, "mineproximitytrigger" },
    { 0x5C60, "mines" },
    { 0x5C61, "mineselfdestruct" },
    { 0x5C62, "mineselfdestructtime" },
    { 0x5C63, "minestunbegin" },
    { 0x5C64, "minestunend" },
    { 0x5C65, "minethrown" },
    { 0x5C66, "minewatchownerchangeteams" },
    { 0x5C67, "minewatchownerdisconnect" },
    { 0x5C68, "minexposedgrenadedist" },
    { 0x5C69, "mini_chute_hide" },
    { 0x5C6A, "mini_chutes" },
    { 0x5C6B, "mini_plane_controls" },
    { 0x5C6C, "mini_version" },
    { 0x5C6D, "minigun_ai_target_cleanup" },
    { 0x5C6E, "minigun_cleanup_func" },
    { 0x5C6F, "minigun_fire" },
    { 0x5C70, "minigun_ignoreme" },
    { 0x5C71, "minigun_spindown" },
    { 0x5C72, "minigun_spindown_sound" },
    { 0x5C73, "minigun_spinup" },
    { 0x5C74, "minigunsspinning" },
    { 0x5C75, "minigunweapon" },
    { 0x5C76, "minimap_image" },
    { 0x5C77, "minimapcornertargetname" },
    { 0x5C78, "minimapheight" },
    { 0x5C79, "minimapicon" },
    { 0x5C7A, "minimaporigin" },
    { 0x5C7B, "minimapplayer" },
    { 0x5C7C, "minimum_in_sights_needed" },
    { 0x5C7D, "minindoortime" },
    { 0x5C7E, "minion_ai" },
    { 0x5C7F, "minion_count_hud" },
    { 0x5C80, "minion_damage" },
    { 0x5C81, "minion_max_hud" },
    { 0x5C82, "minion_spawn_timer_hud" },
    { 0x5C83, "minionstreak" },
    { 0x5C84, "minlfevolumethreshold" },
    { 0x5C85, "minoffsetfromowner" },
    { 0x5C86, "minorbitdist" },
    { 0x5C87, "minpitch" },
    { 0x5C88, "minpoint" },
    { 0x5C89, "minpointmodpos" },
    { 0x5C8A, "minradius" },
    { 0x5C8B, "minrate" },
    { 0x5C8C, "mintimethreshold" },
    { 0x5C8D, "miss_player" },
    { 0x5C8E, "missile_abort_if_owner_destroyed" },
    { 0x5C8F, "missile_array" },
    { 0x5C90, "missile_auto_reload" },
    { 0x5C91, "missile_damage_think" },
    { 0x5C92, "missile_deathwait" },
    { 0x5C93, "missile_defense_precache" },
    { 0x5C94, "missile_delayed_trail" },
    { 0x5C95, "missile_delete" },
    { 0x5C96, "missile_door_close" },
    { 0x5C97, "missile_door_open" },
    { 0x5C98, "missile_earthquake" },
    { 0x5C99, "missile_fire_audio" },
    { 0x5C9A, "missile_fire_audio_end" },
    { 0x5C9B, "missile_fly" },
    { 0x5C9C, "missile_handle_threat_grenade" },
    { 0x5C9D, "missile_hint" },
    { 0x5C9E, "missile_hit_warbird_b" },
    { 0x5C9F, "missile_idx" },
    { 0x5CA0, "missile_large_thrusters_off" },
    { 0x5CA1, "missile_lock_sounds" },
    { 0x5CA2, "missile_miss_player" },
    { 0x5CA3, "missile_model" },
    { 0x5CA4, "missile_object" },
    { 0x5CA5, "missile_org" },
    { 0x5CA6, "missile_reload_system" },
    { 0x5CA7, "missile_settargetandflightmode" },
    { 0x5CA8, "missile_small_thrusters_off" },
    { 0x5CA9, "missile_start_offset" },
    { 0x5CAA, "missile_starts" },
    { 0x5CAB, "missile_stopped" },
    { 0x5CAC, "missile_strike_gas_clouds" },
    { 0x5CAD, "missile_stuff" },
    { 0x5CAE, "missile_target" },
    { 0x5CAF, "missile_target_icons" },
    { 0x5CB0, "missile_target_onscreen_guys_first" },
    { 0x5CB1, "missile_targetting" },
    { 0x5CB2, "missile_test" },
    { 0x5CB3, "missile_tracking_hud" },
    { 0x5CB4, "missile_turret_think" },
    { 0x5CB5, "missile_turrets_on" },
    { 0x5CB6, "missileammo" },
    { 0x5CB7, "missileattractor" },
    { 0x5CB8, "missileboostused" },
    { 0x5CB9, "missilechem" },
    { 0x5CBA, "missiledooropen" },
    { 0x5CBB, "missileexplosion" },
    { 0x5CBC, "missileeyes" },
    { 0x5CBD, "missileeyesgo" },
    { 0x5CBE, "missileeyesinit" },
    { 0x5CBF, "missilefx" },
    { 0x5CC0, "missilelaunchnexttag" },
    { 0x5CC1, "missilelosetarget" },
    { 0x5CC2, "missilemodel" },
    { 0x5CC3, "missileparticles" },
    { 0x5CC4, "missileplayexplodeeffectforplayer" },
    { 0x5CC5, "missiles" },
    { 0x5CC6, "missiles_loaded_count" },
    { 0x5CC7, "missiles_strike_building" },
    { 0x5CC8, "missiles_strike_explo" },
    { 0x5CC9, "missilespawn" },
    { 0x5CCA, "missilestrikegastime" },
    { 0x5CCB, "missilestrikeondeath" },
    { 0x5CCC, "missiletag" },
    { 0x5CCD, "missiletags" },
    { 0x5CCE, "missiletags_left" },
    { 0x5CCF, "missiletags_right" },
    { 0x5CD0, "missiletagsready" },
    { 0x5CD1, "missilewatchproximity" },
    { 0x5CD2, "missing_animation_parameters" },
    { 0x5CD3, "missing_animations" },
    { 0x5CD4, "mission_fail_func" },
    { 0x5CD5, "mission_fail_on_civilian_death" },
    { 0x5CD6, "mission_fail_on_dead" },
    { 0x5CD7, "mission_fail_warning" },
    { 0x5CD8, "mission_fail_warning_exitdrive" },
    { 0x5CD9, "mission_out_of_bounds_fail" },
    { 0x5CDA, "mission_recon" },
    { 0x5CDB, "mission_timer" },
    { 0x5CDC, "mission_timer_event" },
    { 0x5CDD, "mission_timer_hud_creator" },
    { 0x5CDE, "mission_warn_out_of_bounds_fail" },
    { 0x5CDF, "missioncallbacks" },
    { 0x5CE0, "missionfail" },
    { 0x5CE1, "missionfailed" },
    { 0x5CE2, "missionfailedwrapper" },
    { 0x5CE3, "missionsettings" },
    { 0x5CE4, "missle_lighting" },
    { 0x5CE5, "missle_starts" },
    { 0x5CE6, "misstime" },
    { 0x5CE7, "misstimeconstant" },
    { 0x5CE8, "misstimedebounce" },
    { 0x5CE9, "misstimedistancefactor" },
    { 0x5CEA, "mitchell_over_here_dialogue" },
    { 0x5CEB, "mix" },
    { 0x5CEC, "mix_bypass" },
    { 0x5CED, "mix_down" },
    { 0x5CEE, "mix_enable" },
    { 0x5CEF, "mix_up" },
    { 0x5CF0, "mix1" },
    { 0x5CF1, "mix1_name" },
    { 0x5CF2, "mix2" },
    { 0x5CF3, "mix2_name" },
    { 0x5CF4, "mm_add_dynamic_volmod_submix" },
    { 0x5CF5, "mm_add_submix" },
    { 0x5CF6, "mm_blend_submix" },
    { 0x5CF7, "mm_blend_zone_mix" },
    { 0x5CF8, "mm_clear_solo_volmods" },
    { 0x5CF9, "mm_clear_submix" },
    { 0x5CFA, "mm_clear_submixes" },
    { 0x5CFB, "mm_clear_volmod_mute_mix" },
    { 0x5CFC, "mm_clear_zone_mix" },
    { 0x5CFD, "mm_init" },
    { 0x5CFE, "mm_make_submix_sticky" },
    { 0x5CFF, "mm_make_submix_unsticky" },
    { 0x5D00, "mm_mute_volmods" },
    { 0x5D01, "mm_scale_submix" },
    { 0x5D02, "mm_solo_volmods" },
    { 0x5D03, "mm_start_preset" },
    { 0x5D04, "mm_start_zone_preset" },
    { 0x5D05, "mmx_start_zone_preset" },
    { 0x5D06, "mob_audio_setup" },
    { 0x5D07, "mob_camera_static" },
    { 0x5D08, "mob_dismount_console" },
    { 0x5D09, "mob_drone" },
    { 0x5D0A, "mob_enter_player_clip" },
    { 0x5D0B, "mob_entrance_defenders_logic" },
    { 0x5D0C, "mob_fire" },
    { 0x5D0D, "mob_fire_linger_smoke" },
    { 0x5D0E, "mob_lat_move" },
    { 0x5D0F, "mob_pitch_anim" },
    { 0x5D10, "mob_pitch_sign" },
    { 0x5D11, "mob_turret_left" },
    { 0x5D12, "mob_turret_move" },
    { 0x5D13, "mob_turret_right" },
    { 0x5D14, "mob_turret_targets" },
    { 0x5D15, "mob_vert_move" },
    { 0x5D16, "mob_xform" },
    { 0x5D17, "mob_yaw_anim" },
    { 0x5D18, "mob_yaw_sign" },
    { 0x5D19, "mobile_cover_anim" },
    { 0x5D1A, "mobile_cover_badplace" },
    { 0x5D1B, "mobile_cover_courtyard_start" },
    { 0x5D1C, "mobile_cover_drone_hint_think" },
    { 0x5D1D, "mobile_cover_drone_trigger_think" },
    { 0x5D1E, "mobile_cover_drones_cg" },
    { 0x5D1F, "mobile_cover_dummy_player_think" },
    { 0x5D20, "mobile_cover_explosion" },
    { 0x5D21, "mobile_cover_impulse" },
    { 0x5D22, "mobile_cover_link_think" },
    { 0x5D23, "mobile_cover_link_think_angle_controller" },
    { 0x5D24, "mobile_cover_sound_loop" },
    { 0x5D25, "mobile_cover_sound_think" },
    { 0x5D26, "mobile_cover_vehicle_controller" },
    { 0x5D27, "mobile_turret" },
    { 0x5D28, "mobile_turret_burning" },
    { 0x5D29, "mobile_turret_burning_limit_controls" },
    { 0x5D2A, "mobile_turret_dropoff" },
    { 0x5D2B, "mobile_turret_gopath" },
    { 0x5D2C, "mobile_turret_health_1" },
    { 0x5D2D, "mobile_turret_health_2" },
    { 0x5D2E, "mobile_turret_health_3" },
    { 0x5D2F, "mobile_turret_health_4" },
    { 0x5D30, "mobile_turret_health_think" },
    { 0x5D31, "mobile_turret_hint_button" },
    { 0x5D32, "mobile_turret_hint_button_clear" },
    { 0x5D33, "mobile_turret_landing" },
    { 0x5D34, "mobile_turret_missile" },
    { 0x5D35, "mobile_turret_rocket_target" },
    { 0x5D36, "mobile_turret_tutorial_hints" },
    { 0x5D37, "moblie_turrets_intro" },
    { 0x5D38, "mode" },
    { 0x5D39, "mode_button_released" },
    { 0x5D3A, "model_anims" },
    { 0x5D3B, "model_dummy_death" },
    { 0x5D3C, "model_flicker" },
    { 0x5D3D, "model_flicker_preset" },
    { 0x5D3E, "model_init" },
    { 0x5D3F, "model_speed_to_mph" },
    { 0x5D40, "modelbase" },
    { 0x5D41, "modelbombsquad" },
    { 0x5D42, "modeldestroyed" },
    { 0x5D43, "modeldummy" },
    { 0x5D44, "modeldummyon" },
    { 0x5D45, "modelents" },
    { 0x5D46, "modelplacement" },
    { 0x5D47, "modelplacementfailed" },
    { 0x5D48, "models" },
    { 0x5D49, "modelscale" },
    { 0x5D4A, "modifier" },
    { 0x5D4B, "modifiercompanionaitypes" },
    { 0x5D4C, "modifierexplosiveaitypes" },
    { 0x5D4D, "modifiershieldaitypes" },
    { 0x5D4E, "modifiertoxicaitypes" },
    { 0x5D4F, "modify_moveplaybackrate_together" },
    { 0x5D50, "modify_player_speed" },
    { 0x5D51, "modify_rate" },
    { 0x5D52, "modifydamage" },
    { 0x5D53, "modifydamagefunc" },
    { 0x5D54, "modifyplayerdamage" },
    { 0x5D55, "modifyplayerdamagehorde" },
    { 0x5D56, "mods_override" },
    { 0x5D57, "module1idx" },
    { 0x5D58, "module2idx" },
    { 0x5D59, "module3idx" },
    { 0x5D5A, "modulehide" },
    { 0x5D5B, "modulepickup" },
    { 0x5D5C, "moduleroll" },
    { 0x5D5D, "modules" },
    { 0x5D5E, "moduletrap" },
    { 0x5D5F, "momentum" },
    { 0x5D60, "momentum_multiplier_max" },
    { 0x5D61, "monitor" },
    { 0x5D62, "monitor_2d_reverb_volume" },
    { 0x5D63, "monitor_aerial_danger" },
    { 0x5D64, "monitor_ai_detection" },
    { 0x5D65, "monitor_airbrake" },
    { 0x5D66, "monitor_alert" },
    { 0x5D67, "monitor_alerted" },
    { 0x5D68, "monitor_aud_median" },
    { 0x5D69, "monitor_ball" },
    { 0x5D6A, "monitor_base_damage" },
    { 0x5D6B, "monitor_boost_dodging" },
    { 0x5D6C, "monitor_boost_slamming" },
    { 0x5D6D, "monitor_bullet_damage" },
    { 0x5D6E, "monitor_cac_set_weapon" },
    { 0x5D6F, "monitor_callbutton" },
    { 0x5D70, "monitor_cao_set_cao_focus" },
    { 0x5D71, "monitor_cao_set_costume_preview" },
    { 0x5D72, "monitor_car_door_shield_damage" },
    { 0x5D73, "monitor_cautious_approach_dangerous_locations" },
    { 0x5D74, "monitor_cautious_approach_early_out" },
    { 0x5D75, "monitor_change_security_drone_gotos" },
    { 0x5D76, "monitor_charge_time" },
    { 0x5D77, "monitor_cherry_picker_cancel" },
    { 0x5D78, "monitor_cherry_picker_height" },
    { 0x5D79, "monitor_cherry_picker_stick_movement" },
    { 0x5D7A, "monitor_clans" },
    { 0x5D7B, "monitor_class_select_or_weapon_change" },
    { 0x5D7C, "monitor_clear_cardoor_buttons" },
    { 0x5D7D, "monitor_color_blind_toggle" },
    { 0x5D7E, "monitor_controllable_drone_cloud_health" },
    { 0x5D7F, "monitor_create_a_class" },
    { 0x5D80, "monitor_create_an_operator" },
    { 0x5D81, "monitor_cycle_direction" },
    { 0x5D82, "monitor_death_and_reinforce" },
    { 0x5D83, "monitor_death_stop_sounds" },
    { 0x5D84, "monitor_debug_addfakemembers" },
    { 0x5D85, "monitor_defend_player" },
    { 0x5D86, "monitor_dist_from_earth" },
    { 0x5D87, "monitor_door_broken" },
    { 0x5D88, "monitor_door_impact" },
    { 0x5D89, "monitor_door_punch" },
    { 0x5D8A, "monitor_door_react" },
    { 0x5D8B, "monitor_door_state" },
    { 0x5D8C, "monitor_drone_cloud_health" },
    { 0x5D8D, "monitor_drone_cloud_members" },
    { 0x5D8E, "monitor_drone_death" },
    { 0x5D8F, "monitor_drone_depletion" },
    { 0x5D90, "monitor_drone_hit_or_timeout" },
    { 0x5D91, "monitor_drone_missile_death" },
    { 0x5D92, "monitor_drone_number" },
    { 0x5D93, "monitor_drone_stick_deflection" },
    { 0x5D94, "monitor_drone_street_enemy_count" },
    { 0x5D95, "monitor_drone_swearm_boundaries" },
    { 0x5D96, "monitor_drones_hit_ground" },
    { 0x5D97, "monitor_droppod_destruction" },
    { 0x5D98, "monitor_enemy_dangerous_killstreak" },
    { 0x5D99, "monitor_enemy_jet_health" },
    { 0x5D9A, "monitor_equip_interrupt" },
    { 0x5D9B, "monitor_escape_artist" },
    { 0x5D9C, "monitor_ever_used_boost" },
    { 0x5D9D, "monitor_execution_scene_civs" },
    { 0x5D9E, "monitor_execution_scene_soldiers" },
    { 0x5D9F, "monitor_exo_survival_veteran" },
    { 0x5DA0, "monitor_exocrossbow_launch" },
    { 0x5DA1, "monitor_exoping_battery_charge" },
    { 0x5DA2, "monitor_fail_triggers" },
    { 0x5DA3, "monitor_failed_switchback" },
    { 0x5DA4, "monitor_fixed_scanner" },
    { 0x5DA5, "monitor_fixed_scanner_explode" },
    { 0x5DA6, "monitor_flag_ownership" },
    { 0x5DA7, "monitor_flag_status" },
    { 0x5DA8, "monitor_flashlight_burke" },
    { 0x5DA9, "monitor_flashlight_death" },
    { 0x5DAA, "monitor_flashlight_owner_death" },
    { 0x5DAB, "monitor_fuorescent_light_dist" },
    { 0x5DAC, "monitor_genius_achievement" },
    { 0x5DAD, "monitor_gideon_talk" },
    { 0x5DAE, "monitor_grenade_count" },
    { 0x5DAF, "monitor_grenade_fire" },
    { 0x5DB0, "monitor_grenades" },
    { 0x5DB1, "monitor_interaction_rumbles" },
    { 0x5DB2, "monitor_interaction_toggle_player_has_door" },
    { 0x5DB3, "monitor_irons_talk" },
    { 0x5DB4, "monitor_jetbike_wheelman" },
    { 0x5DB5, "monitor_jump_training_end" },
    { 0x5DB6, "monitor_knuckles_vacate" },
    { 0x5DB7, "monitor_land_assist_think" },
    { 0x5DB8, "monitor_last_weapon" },
    { 0x5DB9, "monitor_lazer_on_vol" },
    { 0x5DBA, "monitor_left_swing_released" },
    { 0x5DBB, "monitor_life" },
    { 0x5DBC, "monitor_lockon" },
    { 0x5DBD, "monitor_lsr_missile_launch" },
    { 0x5DBE, "monitor_member_class_changes" },
    { 0x5DBF, "monitor_member_focus_change" },
    { 0x5DC0, "monitor_member_timeouts" },
    { 0x5DC1, "monitor_microdrone_launch" },
    { 0x5DC2, "monitor_microwave_grenades" },
    { 0x5DC3, "monitor_missile_death" },
    { 0x5DC4, "monitor_missile_distance" },
    { 0x5DC5, "monitor_missile_fire_done" },
    { 0x5DC6, "monitor_missile_firing" },
    { 0x5DC7, "monitor_missile_indication" },
    { 0x5DC8, "monitor_missile_input" },
    { 0x5DC9, "monitor_missile_snd_ent" },
    { 0x5DCA, "monitor_missile_target" },
    { 0x5DCB, "monitor_mobile_turret_health" },
    { 0x5DCC, "monitor_mobile_turret_missiles" },
    { 0x5DCD, "monitor_move_btn_fr_vl" },
    { 0x5DCE, "monitor_mute_battery_charge" },
    { 0x5DCF, "monitor_my_health" },
    { 0x5DD0, "monitor_na45_use" },
    { 0x5DD1, "monitor_node_visible" },
    { 0x5DD2, "monitor_num_activated_drones" },
    { 0x5DD3, "monitor_num_drones_in_swarm" },
    { 0x5DD4, "monitor_offhand_cycle" },
    { 0x5DD5, "monitor_oldtown_doc_civs" },
    { 0x5DD6, "monitor_on_ground" },
    { 0x5DD7, "monitor_out_of_bounds_areas" },
    { 0x5DD8, "monitor_overclock_battery_charge" },
    { 0x5DD9, "monitor_pa_dist" },
    { 0x5DDA, "monitor_pass_throw" },
    { 0x5DDB, "monitor_pause_spawning" },
    { 0x5DDC, "monitor_pilot_shoot" },
    { 0x5DDD, "monitor_pitbull_recent_accel" },
    { 0x5DDE, "monitor_place_foam_bomb" },
    { 0x5DDF, "monitor_plane_speed" },
    { 0x5DE0, "monitor_player_boost" },
    { 0x5DE1, "monitor_player_damage" },
    { 0x5DE2, "monitor_player_damage_for_cloak" },
    { 0x5DE3, "monitor_player_death" },
    { 0x5DE4, "monitor_player_fire_for_cloak" },
    { 0x5DE5, "monitor_player_grapple" },
    { 0x5DE6, "monitor_player_grappled_knuckes" },
    { 0x5DE7, "monitor_player_health_in_turret" },
    { 0x5DE8, "monitor_player_input" },
    { 0x5DE9, "monitor_player_leaving_squad_hotel" },
    { 0x5DEA, "monitor_player_light_off" },
    { 0x5DEB, "monitor_player_melee" },
    { 0x5DEC, "monitor_player_on_heli" },
    { 0x5DED, "monitor_player_pushed" },
    { 0x5DEE, "monitor_player_pushed_while_linked" },
    { 0x5DEF, "monitor_player_removed" },
    { 0x5DF0, "monitor_player_rip_off_roof" },
    { 0x5DF1, "monitor_player_rpg_drop" },
    { 0x5DF2, "monitor_player_shooting" },
    { 0x5DF3, "monitor_player_speed_for_cloak" },
    { 0x5DF4, "monitor_player_sprinting_past_ambush" },
    { 0x5DF5, "monitor_player_unresolved" },
    { 0x5DF6, "monitor_player_weapon_for_cloak" },
    { 0x5DF7, "monitor_player_wheelman" },
    { 0x5DF8, "monitor_pod_landing_for_debris" },
    { 0x5DF9, "monitor_reach_thread_death" },
    { 0x5DFA, "monitor_right_swing_released" },
    { 0x5DFB, "monitor_right_trigger_interaction_l" },
    { 0x5DFC, "monitor_right_trigger_interaction_l_ps3" },
    { 0x5DFD, "monitor_right_trigger_interaction_r" },
    { 0x5DFE, "monitor_roof_use_trigger" },
    { 0x5DFF, "monitor_rpg_drop" },
    { 0x5E00, "monitor_script_model_damage" },
    { 0x5E01, "monitor_security_drone_death" },
    { 0x5E02, "monitor_seeker_pos" },
    { 0x5E03, "monitor_server_room_se" },
    { 0x5E04, "monitor_setup_group" },
    { 0x5E05, "monitor_shield_stolen" },
    { 0x5E06, "monitor_shield_switchout" },
    { 0x5E07, "monitor_shield_timeout" },
    { 0x5E08, "monitor_sideshooter" },
    { 0x5E09, "monitor_smoke_grenades" },
    { 0x5E0A, "monitor_snake_gameplay_failure" },
    { 0x5E0B, "monitor_snipers_stragglers" },
    { 0x5E0C, "monitor_speech_action" },
    { 0x5E0D, "monitor_stealth_flags" },
    { 0x5E0E, "monitor_tactics_mode" },
    { 0x5E0F, "monitor_tank_health" },
    { 0x5E10, "monitor_temperature" },
    { 0x5E11, "monitor_throw_door" },
    { 0x5E12, "monitor_tram" },
    { 0x5E13, "monitor_turn_light_off" },
    { 0x5E14, "monitor_turret_2_death" },
    { 0x5E15, "monitor_turret_damage" },
    { 0x5E16, "monitor_turret_death_spawn_dmg" },
    { 0x5E17, "monitor_turret_exit" },
    { 0x5E18, "monitor_turret_rotation_rate" },
    { 0x5E19, "monitor_turret_shoot" },
    { 0x5E1A, "monitor_unauthorized_shield" },
    { 0x5E1B, "monitor_vehicle_mount" },
    { 0x5E1C, "monitor_vehicle_speed" },
    { 0x5E1D, "monitor_vision_use" },
    { 0x5E1E, "monitor_vl_mode_change" },
    { 0x5E1F, "monitor_walker_death_stop_sounds" },
    { 0x5E20, "monitor_weapon_ammo_count" },
    { 0x5E21, "monitor_weapon_remove" },
    { 0x5E22, "monitor_weapon_switch" },
    { 0x5E23, "monitor_wheel_movements" },
    { 0x5E24, "monitor_wheelman" },
    { 0x5E25, "monitor_x4_vm_swap" },
    { 0x5E26, "monitor_zone_control" },
    { 0x5E27, "monitoradstime" },
    { 0x5E28, "monitoraiwarbirddeathortimeout" },
    { 0x5E29, "monitoraiwarbirdswitch" },
    { 0x5E2A, "monitorallydeath" },
    { 0x5E2B, "monitorallyenemy" },
    { 0x5E2C, "monitorallystrugglefailure" },
    { 0x5E2D, "monitorallywalkwaykillvictim" },
    { 0x5E2E, "monitoramplifierdamage" },
    { 0x5E2F, "monitoratriumenemieskilled" },
    { 0x5E30, "monitoratriumfighttimer" },
    { 0x5E31, "monitorbackbutton" },
    { 0x5E32, "monitorbaddogai" },
    { 0x5E33, "monitorbadhumanoidai" },
    { 0x5E34, "monitorblastshieldsurvival" },
    { 0x5E35, "monitorbombuse" },
    { 0x5E36, "monitorboostjumpdistance" },
    { 0x5E37, "monitorbuddydisconnect" },
    { 0x5E38, "monitorbuddywarbirddeathortimeout" },
    { 0x5E39, "monitorconcussion" },
    { 0x5E3A, "monitorconfroomenemies" },
    { 0x5E3B, "monitorconfroomwindows" },
    { 0x5E3C, "monitorconnectedduringstreak" },
    { 0x5E3D, "monitorconvoyvehicle3" },
    { 0x5E3E, "monitorconvoyvehicle3damage" },
    { 0x5E3F, "monitorcourtyardallytargetdeath" },
    { 0x5E40, "monitorcourtyardallytargets" },
    { 0x5E41, "monitorcourtyardplayertargets" },
    { 0x5E42, "monitordamage" },
    { 0x5E43, "monitordamagewhilecloaking" },
    { 0x5E44, "monitordeaddrones" },
    { 0x5E45, "monitordeath" },
    { 0x5E46, "monitordefenddeaths" },
    { 0x5E47, "monitordestructiblewalls" },
    { 0x5E48, "monitordetonateambushbuttonpress" },
    { 0x5E49, "monitordetonateambushfail" },
    { 0x5E4A, "monitordetonateambushinteract" },
    { 0x5E4B, "monitordetonateambushsuccess" },
    { 0x5E4C, "monitordisconnect" },
    { 0x5E4D, "monitordistance" },
    { 0x5E4E, "monitordome" },
    { 0x5E4F, "monitordot" },
    { 0x5E50, "monitordownpressed" },
    { 0x5E51, "monitordownreleased" },
    { 0x5E52, "monitordrop" },
    { 0x5E53, "monitordropinternal" },
    { 0x5E54, "monitored_tag_origins" },
    { 0x5E55, "monitorempgrenade" },
    { 0x5E56, "monitorenddronecontrol" },
    { 0x5E57, "monitorendingenemies" },
    { 0x5E58, "monitorendingilanaentrancemantle" },
    { 0x5E59, "monitorendingplayerentrancemantle" },
    { 0x5E5A, "monitorenemycrawlplayerdist" },
    { 0x5E5B, "monitorexecutionerdamage" },
    { 0x5E5C, "monitorexecutionerdeath" },
    { 0x5E5D, "monitorexecutionertrigger" },
    { 0x5E5E, "monitorfalldistance" },
    { 0x5E5F, "monitorfinalesafevol" },
    { 0x5E60, "monitorfinalstandsurvival" },
    { 0x5E61, "monitorflash" },
    { 0x5E62, "monitorflashbang" },
    { 0x5E63, "monitorfollowtargetescape" },
    { 0x5E64, "monitorforceshotgunspawn" },
    { 0x5E65, "monitorfx" },
    { 0x5E66, "monitorgameended" },
    { 0x5E67, "monitorgrabgunbuttonpress" },
    { 0x5E68, "monitorgroundslam" },
    { 0x5E69, "monitorgroundslamhitplayer" },
    { 0x5E6A, "monitorhadesalert" },
    { 0x5E6B, "monitorhadesdeath" },
    { 0x5E6C, "monitorhadesstabbuttonpress" },
    { 0x5E6D, "monitorhadesstabfail" },
    { 0x5E6E, "monitorhadesstabsuccess" },
    { 0x5E6F, "monitorhadesvehiclehint" },
    { 0x5E70, "monitorhadesvehicleinteract" },
    { 0x5E71, "monitorheaddestroy" },
    { 0x5E72, "monitorhitpercent" },
    { 0x5E73, "monitorholdbreath" },
    { 0x5E74, "monitorhotelilanaleapfrog" },
    { 0x5E75, "monitorhotelplayerleapfrog" },
    { 0x5E76, "monitorisenemyvalidtarget" },
    { 0x5E77, "monitorkilledkillstreak" },
    { 0x5E78, "monitorkills" },
    { 0x5E79, "monitorkillstreakprogress" },
    { 0x5E7A, "monitorkvatargetinalley" },
    { 0x5E7B, "monitorlaseroff" },
    { 0x5E7C, "monitorlastweapon" },
    { 0x5E7D, "monitorleaveareawarning" },
    { 0x5E7E, "monitorlevelalarm" },
    { 0x5E7F, "monitorlivetime" },
    { 0x5E80, "monitorlookatent" },
    { 0x5E81, "monitormagcycle" },
    { 0x5E82, "monitormantle" },
    { 0x5E83, "monitormantlevols" },
    { 0x5E84, "monitormarkedplayertarget" },
    { 0x5E85, "monitormarkingthread" },
    { 0x5E86, "monitormatchchallenges" },
    { 0x5E87, "monitorminetriggering" },
    { 0x5E88, "monitormisc" },
    { 0x5E89, "monitormisccallback" },
    { 0x5E8A, "monitormovetruckinteract" },
    { 0x5E8B, "monitormutebombdeath" },
    { 0x5E8C, "monitormutebombplayers" },
    { 0x5E8D, "monitoronlydrones" },
    { 0x5E8E, "monitororbitalstrikedeath" },
    { 0x5E8F, "monitororbitalstrikesafearea" },
    { 0x5E90, "monitororbitalstriketimeout" },
    { 0x5E91, "monitororbitalstrikeweapon" },
    { 0x5E92, "monitorparkingcaralarm" },
    { 0x5E93, "monitorparkingcarexplode" },
    { 0x5E94, "monitorparkingcars" },
    { 0x5E95, "monitorparkingguards" },
    { 0x5E96, "monitorparkingguardsdead" },
    { 0x5E97, "monitorparkinginvestigatorsdead" },
    { 0x5E98, "monitorparkinginvestigatorsneargoal" },
    { 0x5E99, "monitorparkingkillvictim" },
    { 0x5E9A, "monitorphysicschairs" },
    { 0x5E9B, "monitorplaceambushinteract" },
    { 0x5E9C, "monitorplacebreachhint" },
    { 0x5E9D, "monitorplayeractivity" },
    { 0x5E9E, "monitorplayerapproachfishtank" },
    { 0x5E9F, "monitorplayerdeath" },
    { 0x5EA0, "monitorplayerdisconnect" },
    { 0x5EA1, "monitorplayerfirerpgattower" },
    { 0x5EA2, "monitorplayergameended" },
    { 0x5EA3, "monitorplayergrabgun" },
    { 0x5EA4, "monitorplayerleftlowerpassage" },
    { 0x5EA5, "monitorplayerlookat" },
    { 0x5EA6, "monitorplayerlookatgateguards" },
    { 0x5EA7, "monitorplayerlookingatatrium" },
    { 0x5EA8, "monitorplayermatchchallenges" },
    { 0x5EA9, "monitorplayerpickupglauncher" },
    { 0x5EAA, "monitorplayersegments" },
    { 0x5EAB, "monitorplayershootfirstatrium" },
    { 0x5EAC, "monitorplayersignalatriumbreach" },
    { 0x5EAD, "monitorplayerspawns" },
    { 0x5EAE, "monitorplayerswitchteams" },
    { 0x5EAF, "monitorplayerteamchange" },
    { 0x5EB0, "monitorpointnotifylua" },
    { 0x5EB1, "monitorpoolguard" },
    { 0x5EB2, "monitorpoolkillvictim" },
    { 0x5EB3, "monitorpoolkillvictimalert" },
    { 0x5EB4, "monitorpoolkillvictimdeath" },
    { 0x5EB5, "monitorportableradaruse" },
    { 0x5EB6, "monitorprisonkillstreakownership" },
    { 0x5EB7, "monitorprocesschallenge" },
    { 0x5EB8, "monitorpronetime" },
    { 0x5EB9, "monitorrefractionkillstreakownership" },
    { 0x5EBA, "monitorrestaurantglassfrenzyvol" },
    { 0x5EBB, "monitorriotsuppressionsystem" },
    { 0x5EBC, "monitorroundend" },
    { 0x5EBD, "monitors" },
    { 0x5EBE, "monitorscavengerpickup" },
    { 0x5EBF, "monitorscopechange" },
    { 0x5EC0, "monitorscrambleruse" },
    { 0x5EC1, "monitorsemtex" },
    { 0x5EC2, "monitorsemtexstick" },
    { 0x5EC3, "monitorsetupambushtimer" },
    { 0x5EC4, "monitorshotsfired" },
    { 0x5EC5, "monitorsinglesprintdistance" },
    { 0x5EC6, "monitorslidesafevol" },
    { 0x5EC7, "monitorsmartgrenade" },
    { 0x5EC8, "monitorsniperdronetriplekill" },
    { 0x5EC9, "monitorsnipertowersuppressiondamage" },
    { 0x5ECA, "monitorspawndurringstreak" },
    { 0x5ECB, "monitorspikedestroy" },
    { 0x5ECC, "monitorsprintdistance" },
    { 0x5ECD, "monitorsprinttime" },
    { 0x5ECE, "monitorstartdronecontrol" },
    { 0x5ECF, "monitorstreakreward" },
    { 0x5ED0, "monitorstreaks" },
    { 0x5ED1, "monitorstuck" },
    { 0x5ED2, "monitorsupersafevol" },
    { 0x5ED3, "monitorsupportdropprogress" },
    { 0x5ED4, "monitorsurvivaltime" },
    { 0x5ED5, "monitortagcollector" },
    { 0x5ED6, "monitortagnoteworthyevent" },
    { 0x5ED7, "monitorthirdpersonmodel" },
    { 0x5ED8, "monitorthreathighlight" },
    { 0x5ED9, "monitorthreathighlightnotification" },
    { 0x5EDA, "monitortime" },
    { 0x5EDB, "monitortiuse" },
    { 0x5EDC, "monitortrackswitching" },
    { 0x5EDD, "monitoruavsafearea" },
    { 0x5EDE, "monitorupgrades" },
    { 0x5EDF, "monitoruppressed" },
    { 0x5EE0, "monitorupreleased" },
    { 0x5EE1, "monitorwalkwaykillvictim" },
    { 0x5EE2, "monitorwarbirdsafearea" },
    { 0x5EE3, "monitorweaponselection" },
    { 0x5EE4, "monitorweaponswap" },
    { 0x5EE5, "monitory_health_battery_charge" },
    { 0x5EE6, "monitorzoomonburke" },
    { 0x5EE7, "monitorzoomonhades1" },
    { 0x5EE8, "monitorzoomonhades2" },
    { 0x5EE9, "monsters_can_jump" },
    { 0x5EEA, "most_threatening_car" },
    { 0x5EEB, "mothership_fly" },
    { 0x5EEC, "mothership_fly2" },
    { 0x5EED, "mothership_fly3" },
    { 0x5EEE, "mothership_fly4" },
    { 0x5EEF, "mothership_fly5" },
    { 0x5EF0, "motion_blur_fall" },
    { 0x5EF1, "motion_blur_intro" },
    { 0x5EF2, "motion_blur_rotation_enable" },
    { 0x5EF3, "motion_blur_sink_hole_zipline" },
    { 0x5EF4, "motion_light" },
    { 0x5EF5, "motion_light_timeout" },
    { 0x5EF6, "motion_manage" },
    { 0x5EF7, "motion_trigger" },
    { 0x5EF8, "mount_bike_dof" },
    { 0x5EF9, "mount_hint" },
    { 0x5EFA, "mount_hovertank" },
    { 0x5EFB, "mount_org" },
    { 0x5EFC, "mount_pitbull" },
    { 0x5EFD, "mount_player_pitbull" },
    { 0x5EFE, "mount_pos" },
    { 0x5EFF, "mount_snowmobile" },
    { 0x5F00, "mountains_manager" },
    { 0x5F01, "move" },
    { 0x5F02, "move_again_noflag" },
    { 0x5F03, "move_all_fx" },
    { 0x5F04, "move_allies_to_upper" },
    { 0x5F05, "move_bones_and_joker_up" },
    { 0x5F06, "move_bots_from_team_to_team" },
    { 0x5F07, "move_burke_outside_office" },
    { 0x5F08, "move_check" },
    { 0x5F09, "move_checkstairstransition" },
    { 0x5F0A, "move_child_beams" },
    { 0x5F0B, "move_door_to_position" },
    { 0x5F0C, "move_drone_target_along_path" },
    { 0x5F0D, "move_earth_with_pod" },
    { 0x5F0E, "move_earth2_with_pod" },
    { 0x5F0F, "move_effects_ent_here" },
    { 0x5F10, "move_ent" },
    { 0x5F11, "move_fails" },
    { 0x5F12, "move_fly_drone_check" },
    { 0x5F13, "move_forward_if_safe" },
    { 0x5F14, "move_free_run" },
    { 0x5F15, "move_god_rays_rocket_fail" },
    { 0x5F16, "move_guy" },
    { 0x5F17, "move_hovertank_to_start" },
    { 0x5F18, "move_initial_enemies" },
    { 0x5F19, "move_into_place_right" },
    { 0x5F1A, "move_lift" },
    { 0x5F1B, "move_lights_here" },
    { 0x5F1C, "move_lo_lp" },
    { 0x5F1D, "move_mech_origins" },
    { 0x5F1E, "move_noncombat_anim" },
    { 0x5F1F, "move_origin" },
    { 0x5F20, "move_outside_circle" },
    { 0x5F21, "move_overwatch_heli_to_slope" },
    { 0x5F22, "move_pivot_process" },
    { 0x5F23, "move_player_to_ent_by_targetname" },
    { 0x5F24, "move_player_to_start" },
    { 0x5F25, "move_player_view_at_ledge" },
    { 0x5F26, "move_riders_here" },
    { 0x5F27, "move_right_scaffolding_guy" },
    { 0x5F28, "move_scale" },
    { 0x5F29, "move_selection_to_cursor" },
    { 0x5F2A, "move_squad_and_walkers" },
    { 0x5F2B, "move_squad_into_ship" },
    { 0x5F2C, "move_squad_member_to_ent" },
    { 0x5F2D, "move_squad_member_to_ent_by_targetname" },
    { 0x5F2E, "move_squad_to_bridge" },
    { 0x5F2F, "move_sunflare_back" },
    { 0x5F30, "move_sunflare_back_startpoints" },
    { 0x5F31, "move_swimming_player_with_current" },
    { 0x5F32, "move_target_for_squirly_effect" },
    { 0x5F33, "move_target_pos_to_new_turrets_visibility" },
    { 0x5F34, "move_team_towards_hospital" },
    { 0x5F35, "move_to_cave_combat" },
    { 0x5F36, "move_to_correct_node" },
    { 0x5F37, "move_to_death_spot" },
    { 0x5F38, "move_to_dest" },
    { 0x5F39, "move_to_hangar" },
    { 0x5F3A, "move_to_run_pos" },
    { 0x5F3B, "move_tour_door_shadow_caulk" },
    { 0x5F3C, "move_transition_arrays" },
    { 0x5F3D, "move_truck_junk_here" },
    { 0x5F3E, "move_turrets_here" },
    { 0x5F3F, "move_universe_to_new_pod" },
    { 0x5F40, "move_use_object" },
    { 0x5F41, "move_use_turret" },
    { 0x5F42, "move_wave" },
    { 0x5F43, "move_wave_random" },
    { 0x5F44, "move_when_enemy_hides" },
    { 0x5F45, "move_with_rate" },
    { 0x5F46, "moveanimset" },
    { 0x5F47, "moveanimtype" },
    { 0x5F48, "movebackforth" },
    { 0x5F49, "moveboat" },
    { 0x5F4A, "movebuildingdeathtriggers" },
    { 0x5F4B, "movecovertocover" },
    { 0x5F4C, "movecovertocover_checkendpose" },
    { 0x5F4D, "movecovertocover_checkstartpose" },
    { 0x5F4E, "movecovertocoverfinish" },
    { 0x5F4F, "movecqb" },
    { 0x5F50, "movedoorsidetoside" },
    { 0x5F51, "movedrecently" },
    { 0x5F52, "movefloorpaneldown" },
    { 0x5F53, "movefloorpanelup" },
    { 0x5F54, "moveflyingbuilding" },
    { 0x5F55, "movegates" },
    { 0x5F56, "moveinit" },
    { 0x5F57, "movelogic" },
    { 0x5F58, "moveloopcleanupfunc" },
    { 0x5F59, "moveloopoverridefunc" },
    { 0x5F5A, "movemainloop" },
    { 0x5F5B, "movemainloopinternal" },
    { 0x5F5C, "movemainloopprocess" },
    { 0x5F5D, "movemainloopprocessoverridefunc" },
    { 0x5F5E, "movement" },
    { 0x5F5F, "movement_acceleration_loop" },
    { 0x5F60, "movement_rumble" },
    { 0x5F61, "movement_velocity_loop" },
    { 0x5F62, "movementtracker" },
    { 0x5F63, "movementtype" },
    { 0x5F64, "moveorbitalsupporttodestination" },
    { 0x5F65, "moveorgs" },
    { 0x5F66, "moveorigin" },
    { 0x5F67, "moveoverridesound" },
    { 0x5F68, "moveplaybackrate" },
    { 0x5F69, "moveplaybackrate_orig" },
    { 0x5F6A, "moveplayereyetocam" },
    { 0x5F6B, "mover" },
    { 0x5F6C, "mover_debug_text" },
    { 0x5F6D, "mover_delete" },
    { 0x5F6E, "mover_reset_angles" },
    { 0x5F6F, "mover_reset_origin" },
    { 0x5F70, "mover_suicide" },
    { 0x5F71, "moveratemultiplier" },
    { 0x5F72, "movers" },
    { 0x5F73, "moverun" },
    { 0x5F74, "movescale" },
    { 0x5F75, "movesound_waitfordoneordeath" },
    { 0x5F76, "movesoundorigin" },
    { 0x5F77, "movespeed" },
    { 0x5F78, "movespeed_get_func" },
    { 0x5F79, "movespeed_multiplier" },
    { 0x5F7A, "movespeed_ramp_over_time" },
    { 0x5F7B, "movespeed_scale" },
    { 0x5F7C, "movespeed_set_func" },
    { 0x5F7D, "movespeedscale" },
    { 0x5F7E, "movespeedscaler" },
    { 0x5F7F, "movestand_moveoverride" },
    { 0x5F80, "movestartbattlechatter" },
    { 0x5F81, "movestate" },
    { 0x5F82, "movestopper" },
    { 0x5F83, "moveswim" },
    { 0x5F84, "moveswim_combat" },
    { 0x5F85, "moveswim_combat_enter" },
    { 0x5F86, "moveswim_combat_exit" },
    { 0x5F87, "moveswim_combat_forward_enter" },
    { 0x5F88, "moveswim_combat_forward_exit" },
    { 0x5F89, "moveswim_combat_move_set" },
    { 0x5F8A, "moveswim_combat_strafe_enter" },
    { 0x5F8B, "moveswim_combat_strafe_exit" },
    { 0x5F8C, "moveswim_noncombat" },
    { 0x5F8D, "moveswim_noncombat_enter" },
    { 0x5F8E, "moveswim_noncombat_exit" },
    { 0x5F8F, "moveswim_noncombat_twitchupdate" },
    { 0x5F90, "moveswim_set" },
    { 0x5F91, "moveswim_track_combat" },
    { 0x5F92, "movetargets" },
    { 0x5F93, "movetargettodest" },
    { 0x5F94, "moveto_floor" },
    { 0x5F95, "movetocovernearplayer" },
    { 0x5F96, "movetonearbycover" },
    { 0x5F97, "movetonodeovertime" },
    { 0x5F98, "movetracker" },
    { 0x5F99, "movetrackers" },
    { 0x5F9A, "movetransitionrate" },
    { 0x5F9B, "movetransitionrate_orig" },
    { 0x5F9C, "movetrig" },
    { 0x5F9D, "movetruckfirefx" },
    { 0x5F9E, "movetrucktiresmokefx" },
    { 0x5F9F, "movewalk" },
    { 0x5FA0, "movezoneaftertime" },
    { 0x5FA1, "moving" },
    { 0x5FA2, "moving_buoys" },
    { 0x5FA3, "moving_note_targets" },
    { 0x5FA4, "moving_obstacles" },
    { 0x5FA5, "moving_platform" },
    { 0x5FA6, "moving_platform_empty_func" },
    { 0x5FA7, "moving_unload" },
    { 0x5FA8, "moving_water_flag" },
    { 0x5FA9, "moving_water_init" },
    { 0x5FAA, "movingplatformdeathfunc" },
    { 0x5FAB, "movingplatformtouchvalid" },
    { 0x5FAC, "movingstate" },
    { 0x5FAD, "movingtruckidle" },
    { 0x5FAE, "mp_comeback" },
    { 0x5FAF, "mp_createfx" },
    { 0x5FB0, "mp_dam" },
    { 0x5FB1, "mp_detroit" },
    { 0x5FB2, "mp_exo_cloak_activate" },
    { 0x5FB3, "mp_exo_cloak_deactivate" },
    { 0x5FB4, "mp_exo_health_activate" },
    { 0x5FB5, "mp_exo_health_deactivate" },
    { 0x5FB6, "mp_exo_mute_activate" },
    { 0x5FB7, "mp_exo_mute_deactivate" },
    { 0x5FB8, "mp_exo_overclock_activate" },
    { 0x5FB9, "mp_exo_overclock_deactivate" },
    { 0x5FBA, "mp_exo_ping_activate" },
    { 0x5FBB, "mp_exo_ping_deactivate" },
    { 0x5FBC, "mp_exo_repulsor_activate" },
    { 0x5FBD, "mp_exo_repulsor_deactivate" },
    { 0x5FBE, "mp_exo_repulsor_repel" },
    { 0x5FBF, "mp_exo_shield_activate" },
    { 0x5FC0, "mp_exo_shield_deactivate" },
    { 0x5FC1, "mp_greenband" },
    { 0x5FC2, "mp_instinct" },
    { 0x5FC3, "mp_instinct_owner" },
    { 0x5FC4, "mp_ks_goliath_death_explosion" },
    { 0x5FC5, "mp_ks_goliath_pod_burst" },
    { 0x5FC6, "mp_ks_goliath_self_destruct" },
    { 0x5FC7, "mp_levity" },
    { 0x5FC8, "mp_prison" },
    { 0x5FC9, "mp_prison_inuse" },
    { 0x5FCA, "mp_prison_killstreak" },
    { 0x5FCB, "mp_prison_killstreak_duration" },
    { 0x5FCC, "mp_recovery" },
    { 0x5FCD, "mp_recovery_killstreak" },
    { 0x5FCE, "mp_refraction" },
    { 0x5FCF, "mp_refraction_inuse" },
    { 0x5FD0, "mp_refraction_killstreak_duration" },
    { 0x5FD1, "mp_refraction_owner" },
    { 0x5FD2, "mp_regular_exo_hover" },
    { 0x5FD3, "mp_solar" },
    { 0x5FD4, "mp_suppressed_exo_hover" },
    { 0x5FD5, "mp_terrace" },
    { 0x5FD6, "mp_torqued" },
    { 0x5FD7, "mp_venus" },
    { 0x5FD8, "mp_wpn_exo_knife_player_impact" },
    { 0x5FD9, "mph_to_model_speed" },
    { 0x5FDA, "mph_to_ups" },
    { 0x5FDB, "mre_loop" },
    { 0x5FDC, "ms_until_ready_to_fire" },
    { 0x5FDD, "mt_getteamheadicon" },
    { 0x5FDE, "mt_getteamicon" },
    { 0x5FDF, "mt_getteamname" },
    { 0x5FE0, "mt_use_tags" },
    { 0x5FE1, "mtdm_updateteamplacement" },
    { 0x5FE2, "multi_drone_handle_anim" },
    { 0x5FE3, "multi_sync_kill_shooter" },
    { 0x5FE4, "multi_sync_kills" },
    { 0x5FE5, "multibomb" },
    { 0x5FE6, "multikill_count" },
    { 0x5FE7, "multikill_monitor" },
    { 0x5FE8, "multikillevent" },
    { 0x5FE9, "multikillonebulletevent" },
    { 0x5FEA, "multiple_dialogue_queue" },
    { 0x5FEB, "multiple_objectives" },
    { 0x5FEC, "multiple_routes" },
    { 0x5FED, "multiply_by_leftstick" },
    { 0x5FEE, "multiply_by_throttle" },
    { 0x5FEF, "multiteambased" },
    { 0x5FF0, "murder_player_seek" },
    { 0x5FF1, "mus_alley_combat" },
    { 0x5FF2, "mus_auto_submixer" },
    { 0x5FF3, "mus_auto_submixer_thread" },
    { 0x5FF4, "mus_exit_subway" },
    { 0x5FF5, "mus_get_combat_count" },
    { 0x5FF6, "mus_get_playing_cue_preset" },
    { 0x5FF7, "mus_init" },
    { 0x5FF8, "mus_is_playing" },
    { 0x5FF9, "mus_lag_brk_takeoutsuv_done" },
    { 0x5FFA, "mus_play" },
    { 0x5FFB, "mus_stop" },
    { 0x5FFC, "mus_submixer" },
    { 0x5FFD, "mus_submixer_thread" },
    { 0x5FFE, "music" },
    { 0x5FFF, "music_crossfade" },
    { 0x6000, "music_handler" },
    { 0x6001, "music_loop" },
    { 0x6002, "music_loop_internal" },
    { 0x6003, "music_loop_internal_stop_with_fade_then_call" },
    { 0x6004, "music_loop_stealth" },
    { 0x6005, "music_loop_stealth_pause" },
    { 0x6006, "music_play" },
    { 0x6007, "music_play_internal_stop_with_fade_then_call" },
    { 0x6008, "music_stop" },
    { 0x6009, "musiccontroller" },
    { 0x600A, "musiclength" },
    { 0x600B, "musicplaywrapper" },
    { 0x600C, "must_wait_for_full_charge" },
    { 0x600D, "mustmaintainclaim" },
    { 0x600E, "musx_cash_cue" },
    { 0x600F, "musx_construct_cue" },
    { 0x6010, "musx_get_auto_mix" },
    { 0x6011, "musx_get_cashed_cue" },
    { 0x6012, "musx_monitor_game_vars" },
    { 0x6013, "musx_start_cue" },
    { 0x6014, "musx_stop_all_music" },
    { 0x6015, "mute_breach_explosion" },
    { 0x6016, "mute_charge" },
    { 0x6017, "mute_charge_01_rumbles" },
    { 0x6018, "mute_device_active" },
    { 0x6019, "mute_device_enter" },
    { 0x601A, "mute_device_exit" },
    { 0x601B, "mute_device_filter" },
    { 0x601C, "mute_device_in_bubble" },
    { 0x601D, "mute_device_mix_enable" },
    { 0x601E, "mute_device_plant_fx" },
    { 0x601F, "mute_device_start" },
    { 0x6020, "mute_event_distances" },
    { 0x6021, "mute_fx" },
    { 0x6022, "mute_fx_on" },
    { 0x6023, "mute_intro_ambis" },
    { 0x6024, "mute_on" },
    { 0x6025, "mutebombinit" },
    { 0x6026, "muzzleflashoverride" },
    { 0x6027, "mw_claimed" },
    { 0x6028, "mw_grenade" },
    { 0x6029, "mw_old_animname" },
    { 0x602A, "mw_old_badplace_awareness" },
    { 0x602B, "mw_old_goalradius" },
    { 0x602C, "mwp_bombplant_reflection_probe_lightgrid_tweaks" },
    { 0x602D, "mwp_cine_lighhting_fx" },
    { 0x602E, "mwp_cine_lighhting_radspot" },
    { 0x602F, "mwp_cine_optimize_left_big_key_all" },
    { 0x6030, "mwp_cine_optimize_weaplat_rim_all" },
    { 0x6031, "mwp_cine_optimize_will_key_left_post_firerim" },
    { 0x6032, "mwp_cine_optimize_will_key_left_pre_firerim" },
    { 0x6033, "mwp_explosion_lightset_vig" },
    { 0x6034, "mwp_lighting_origin_offset_reset" },
    { 0x6035, "my_current_node_delays" },
    { 0x6036, "my_debug_name" },
    { 0x6037, "my_orgs" },
    { 0x6038, "my_vol" },
    { 0x6039, "mygrenadecooldownelapsed" },
    { 0x603A, "mysetbacks" },
    { 0x603B, "nag_lines_if_player_skips_charges" },
    { 0x603C, "nag_player_get_door" },
    { 0x603D, "nag_player_land_assist" },
    { 0x603E, "nag_player_to_shoot_target" },
    { 0x603F, "nag_until_flag" },
    { 0x6040, "name_col" },
    { 0x6041, "name_complete" },
    { 0x6042, "name_drift" },
    { 0x6043, "name1" },
    { 0x6044, "name2" },
    { 0x6045, "name3" },
    { 0x6046, "named_magic_bullet_strafe" },
    { 0x6047, "namedist_old" },
    { 0x6048, "nameindex" },
    { 0x6049, "namemodelmap" },
    { 0x604A, "nameplatematerial" },
    { 0x604B, "names" },
    { 0x604C, "namesaidrecently" },
    { 0x604D, "nametagmodel" },
    { 0x604E, "narrow_animnode" },
    { 0x604F, "narrow_cave_axe_throw" },
    { 0x6050, "narrow_cave_cave_in" },
    { 0x6051, "narrow_cave_cormack" },
    { 0x6052, "narrow_cave_cormack_cave_in_dialogue" },
    { 0x6053, "narrow_cave_cormack_radio" },
    { 0x6054, "narrow_cave_cormack_teleport_monitor" },
    { 0x6055, "narrow_cave_dialogue" },
    { 0x6056, "narrow_cave_drop_pod" },
    { 0x6057, "narrow_cave_enemies" },
    { 0x6058, "narrow_cave_follow_dot" },
    { 0x6059, "narrow_cave_ilana" },
    { 0x605A, "narrow_cave_ilana_teleport_monitor" },
    { 0x605B, "narrow_cave_ilona_thermals" },
    { 0x605C, "narrow_cave_jump_out_fail" },
    { 0x605D, "narrow_cave_player" },
    { 0x605E, "narrow_cave_player_allows" },
    { 0x605F, "narrow_cave_radio_response" },
    { 0x6060, "narrow_cave_swap_axe" },
    { 0x6061, "narrow_in_camera_play" },
    { 0x6062, "narrowcave_player_breach_weapon_enable" },
    { 0x6063, "narrowcave_sec1_traverse_sec2" },
    { 0x6064, "narrowcave_sec2_enter" },
    { 0x6065, "narrowcave_sec2_exit" },
    { 0x6066, "narrowcave_sec2_traverse_floodroom" },
    { 0x6067, "narrowcave_traverse_sec1" },
    { 0x6068, "nationalityokformoveorder" },
    { 0x6069, "nationalityokformoveordernoncombat" },
    { 0x606A, "nationalityusescallsigns" },
    { 0x606B, "nationalityusessurnames" },
    { 0x606C, "navy_drone_drones_damage_func" },
    { 0x606D, "navy_drone_guys_damage_func" },
    { 0x606E, "navy_vo" },
    { 0x606F, "nc_underwater_visionset_change" },
    { 0x6070, "nearby_shot_alert" },
    { 0x6071, "nearbyplayers" },
    { 0x6072, "neardeathkillevent" },
    { 0x6073, "neardistance" },
    { 0x6074, "nearest_node" },
    { 0x6075, "nearest_node_for_camping" },
    { 0x6076, "nearest_nodes" },
    { 0x6077, "nearest_points" },
    { 0x6078, "nearestnode" },
    { 0x6079, "nearestzone" },
    { 0x607A, "nearflagpoint" },
    { 0x607B, "nearspawns" },
    { 0x607C, "neck_org" },
    { 0x607D, "necksnapped" },
    { 0x607E, "need_to_reload" },
    { 0x607F, "needlocalmemberid" },
    { 0x6080, "needrecalculategoodshootpos" },
    { 0x6081, "needrecalculatesuppressspot" },
    { 0x6082, "needs_to_decrement_launcher_count" },
    { 0x6083, "needsbattlebuddy" },
    { 0x6084, "needsbuttontorespawn" },
    { 0x6085, "needsprecaching" },
    { 0x6086, "needsscopeoverride" },
    { 0x6087, "needstorechamber" },
    { 0x6088, "needsupportvo" },
    { 0x6089, "needtochangecovermode" },
    { 0x608A, "needtodecelforarrival" },
    { 0x608B, "needtopresent" },
    { 0x608C, "needtoreload" },
    { 0x608D, "needtoturn" },
    { 0x608E, "negativewrap" },
    { 0x608F, "negotiation_hall_to_lab" },
    { 0x6090, "neighbor_left" },
    { 0x6091, "neighbor_right" },
    { 0x6092, "neighborhood_radius" },
    { 0x6093, "neighbors" },
    { 0x6094, "neutralize_bio_weapons_complete" },
    { 0x6095, "never_saw_it_coming" },
    { 0x6096, "neverdelete" },
    { 0x6097, "neverenablecqb" },
    { 0x6098, "neverforcesnipermissenemy" },
    { 0x6099, "neverlean" },
    { 0x609A, "neversprintforvariation" },
    { 0x609B, "neverstopmonitoringflash" },
    { 0x609C, "new" },
    { 0x609D, "new_category_axis" },
    { 0x609E, "new_cormack_bridge_anim" },
    { 0x609F, "new_force_color_being_set" },
    { 0x60A0, "new_goal_time" },
    { 0x60A1, "new_golaith_anim" },
    { 0x60A2, "new_goliath_moment" },
    { 0x60A3, "new_ilana_bridge_anim" },
    { 0x60A4, "new_kva_basement_1" },
    { 0x60A5, "new_kva_window_ambush" },
    { 0x60A6, "new_lite_settings" },
    { 0x60A7, "new_player_bridge_anim" },
    { 0x60A8, "new_position" },
    { 0x60A9, "new_pull_earthquake" },
    { 0x60AA, "new_reso_anim" },
    { 0x60AB, "new_stage_heli_spawn" },
    { 0x60AC, "new_tool_hud" },
    { 0x60AD, "new_tool_hudelem" },
    { 0x60AE, "newenemyreactionanim" },
    { 0x60AF, "newenemysurprisedreaction" },
    { 0x60B0, "newfallback_overmind" },
    { 0x60B1, "newhandleboostbegin" },
    { 0x60B2, "newhandleboostend" },
    { 0x60B3, "newhandlespawngroundimpact" },
    { 0x60B4, "newhandletraversenotetracks" },
    { 0x60B5, "newhandletraversenotetracks_landassist" },
    { 0x60B6, "newmode" },
    { 0x60B7, "newmodel" },
    { 0x60B8, "newradialbutton" },
    { 0x60B9, "newradialbuttongroup" },
    { 0x60BA, "next" },
    { 0x60BB, "next_button" },
    { 0x60BC, "next_chain_move" },
    { 0x60BD, "next_flag_hide_time" },
    { 0x60BE, "next_goal_time" },
    { 0x60BF, "next_health_drop_time" },
    { 0x60C0, "next_node" },
    { 0x60C1, "next_obj_pos" },
    { 0x60C2, "next_pr_dialog_time" },
    { 0x60C3, "next_reactive_time" },
    { 0x60C4, "next_strat_level_check" },
    { 0x60C5, "next_time_check_tags" },
    { 0x60C6, "next_time_hunt_carrier" },
    { 0x60C7, "nextallowedlooktime" },
    { 0x60C8, "nextallowedsuppresstime" },
    { 0x60C9, "nextcornergrenadedeathtime" },
    { 0x60CA, "nextcrawlingpaintime" },
    { 0x60CB, "nextcrawlingpaintimefromlegdamage" },
    { 0x60CC, "nextdoorgrenadetime" },
    { 0x60CD, "nextgiveuponenemytime" },
    { 0x60CE, "nextgrenadedrop" },
    { 0x60CF, "nextgrenadetrytime" },
    { 0x60D0, "nextlightning" },
    { 0x60D1, "nextmeleechargesound" },
    { 0x60D2, "nextmeleechargetarget" },
    { 0x60D3, "nextmeleechargetime" },
    { 0x60D4, "nextmeleechecktarget" },
    { 0x60D5, "nextmeleechecktime" },
    { 0x60D6, "nextmeleestandardchargetarget" },
    { 0x60D7, "nextmeleestandardchargetime" },
    { 0x60D8, "nextmissiletag" },
    { 0x60D9, "nextmission" },
    { 0x60DA, "nextmission_exit_time" },
    { 0x60DB, "nextnodes" },
    { 0x60DC, "nextpeekoutattempttime" },
    { 0x60DD, "nextsaytime" },
    { 0x60DE, "nextsaytimes" },
    { 0x60DF, "nextslot" },
    { 0x60E0, "nextstandinghitdying" },
    { 0x60E1, "nexttracer" },
    { 0x60E2, "nexttypesaytimes" },
    { 0x60E3, "nextusetime" },
    { 0x60E4, "nigerian_bullhorn" },
    { 0x60E5, "nightvision_check" },
    { 0x60E6, "nightvision_dlight" },
    { 0x60E7, "nightvision_dlight_effect" },
    { 0x60E8, "nightvision_effectsoff" },
    { 0x60E9, "nightvision_enabled" },
    { 0x60EA, "nightvision_off" },
    { 0x60EB, "nightvision_on" },
    { 0x60EC, "nightvision_reflector_effect" },
    { 0x60ED, "nightvision_started" },
    { 0x60EE, "nightvision_toggle" },
    { 0x60EF, "ninebangexplodewaiter" },
    { 0x60F0, "ninebanghandler" },
    { 0x60F1, "no_ai" },
    { 0x60F2, "no_anim_rotors" },
    { 0x60F3, "no_attractor" },
    { 0x60F4, "no_below_vo" },
    { 0x60F5, "no_bg" },
    { 0x60F6, "no_bobbing" },
    { 0x60F7, "no_breath_hud" },
    { 0x60F8, "no_civilian_friendly_fire_until_seen" },
    { 0x60F9, "no_crash_handling" },
    { 0x60FA, "no_crouch_or_prone_think_for_player" },
    { 0x60FB, "no_destructible_animation" },
    { 0x60FC, "no_fly_zone" },
    { 0x60FD, "no_friendly_fire_penalty" },
    { 0x60FE, "no_friendly_fire_splash_damage" },
    { 0x60FF, "no_gametype_update" },
    { 0x6100, "no_grenades" },
    { 0x6101, "no_gun" },
    { 0x6102, "no_interp" },
    { 0x6103, "no_interrupt" },
    { 0x6104, "no_line" },
    { 0x6105, "no_long_death" },
    { 0x6106, "no_magic_bullet" },
    { 0x6107, "no_more_outlines" },
    { 0x6108, "no_moving_platfrom_death" },
    { 0x6109, "no_moving_platfrom_unlink" },
    { 0x610A, "no_pain_sound" },
    { 0x610B, "no_path" },
    { 0x610C, "no_pistol_switch" },
    { 0x610D, "no_prone" },
    { 0x610E, "no_prone_for_player" },
    { 0x610F, "no_prone_in_vol" },
    { 0x6110, "no_rider_death" },
    { 0x6111, "no_slowmo" },
    { 0x6112, "no_stopanimscripted" },
    { 0x6113, "no_target_local_spotlight_angles" },
    { 0x6114, "no_threat_return_node" },
    { 0x6115, "no_tracking_grenades_active" },
    { 0x6116, "no_treads" },
    { 0x6117, "no_vehicle_getoutanim" },
    { 0x6118, "no_vehicle_ragdoll" },
    { 0x6119, "no_wait_building_jump" },
    { 0x611A, "no_wakeup_physics_sphere" },
    { 0x611B, "noabort" },
    { 0x611C, "noairdropkills" },
    { 0x611D, "noalarm" },
    { 0x611E, "noautosaveammocheck" },
    { 0x611F, "nobob" },
    { 0x6120, "nobuddyspawns" },
    { 0x6121, "noclosemechrun" },
    { 0x6122, "nocorpsedelete" },
    { 0x6123, "nocratetimeout" },
    { 0x6124, "node_ambushing_from" },
    { 0x6125, "node_closest_to_defend_center" },
    { 0x6126, "node_has_radius" },
    { 0x6127, "node_is_aerial" },
    { 0x6128, "node_is_exposed" },
    { 0x6129, "node_is_on_path_from_labels" },
    { 0x612A, "node_is_valid__to_convert_to_aerial_pathnode" },
    { 0x612B, "node_search" },
    { 0x612C, "node_trigger_process" },
    { 0x612D, "node_wait" },
    { 0x612E, "node_wait_triggered" },
    { 0x612F, "node_within_use_radius_of_crate" },
    { 0x6130, "node0_has_neighbor_connected_to_node1" },
    { 0x6131, "nodeath" },
    { 0x6132, "nodeathsound" },
    { 0x6133, "nodecanhitground" },
    { 0x6134, "nodechecked" },
    { 0x6135, "nodefindremotemissleent" },
    { 0x6136, "nodegetremotemissileorgfromabove" },
    { 0x6137, "nodegetremotemissileorigin" },
    { 0x6138, "nodegetremotemissleentorg" },
    { 0x6139, "nodehasremotemissiledataset" },
    { 0x613A, "nodeispathnode" },
    { 0x613B, "nodeisremotemissilefromabove" },
    { 0x613C, "nodes" },
    { 0x613D, "nodes_array" },
    { 0x613E, "nodeschecked" },
    { 0x613F, "nodestocheck" },
    { 0x6140, "nodetestfirefromabove" },
    { 0x6141, "nodroneweaponsound" },
    { 0x6142, "nodrop" },
    { 0x6143, "noenableexo" },
    { 0x6144, "noenableweapon" },
    { 0x6145, "nofallanim" },
    { 0x6146, "nofirstframemelee" },
    { 0x6147, "nofour" },
    { 0x6148, "nofriendlyhudicon" },
    { 0x6149, "nogun" },
    { 0x614A, "nogunshoot" },
    { 0x614B, "noisy_turret_clear_default_angles" },
    { 0x614C, "noisy_turret_set_default_angles" },
    { 0x614D, "noisy_turret_think" },
    { 0x614E, "nomeleechargedelay" },
    { 0x614F, "nomeleedeathorient" },
    { 0x6150, "non_glow_model" },
    { 0x6151, "non_player_contact_watcher" },
    { 0x6152, "non_player_damage" },
    { 0x6153, "non_vehicle_guys_a" },
    { 0x6154, "nonanimatedpositions" },
    { 0x6155, "nonhumantypes" },
    { 0x6156, "nonkillstreakagent" },
    { 0x6157, "nonplayerimpvolreduction" },
    { 0x6158, "noonespawnedyet" },
    { 0x6159, "nooverlappinguv" },
    { 0x615A, "nopickuptime" },
    { 0x615B, "noplayerinvul" },
    { 0x615C, "noragdoll" },
    { 0x615D, "noragdollents" },
    { 0x615E, "noreload" },
    { 0x615F, "normal_friendly_fire_penalty" },
    { 0x6160, "normal_stencil" },
    { 0x6161, "normalfogscale" },
    { 0x6162, "normalfogscale_start" },
    { 0x6163, "normalize_script_friendname" },
    { 0x6164, "normalizecompassdirection" },
    { 0x6165, "normalizeplayersegment" },
    { 0x6166, "norunngun" },
    { 0x6167, "norunreload" },
    { 0x6168, "noruntwitch" },
    { 0x6169, "noself_array_call" },
    { 0x616A, "noself_delaycall" },
    { 0x616B, "noself_delaycall_proc" },
    { 0x616C, "noself_func" },
    { 0x616D, "nospawn" },
    { 0x616E, "notanksquish" },
    { 0x616F, "notargethudelem" },
    { 0x6170, "notargethudelem_pulse" },
    { 0x6171, "note" },
    { 0x6172, "note_group" },
    { 0x6173, "note_track_start_fx_on_tag" },
    { 0x6174, "note_track_start_sound" },
    { 0x6175, "note_track_stop_efx_on_tag" },
    { 0x6176, "note_track_swap_to_efx" },
    { 0x6177, "note_track_trace_to_efx" },
    { 0x6178, "noteleport" },
    { 0x6179, "notes" },
    { 0x617A, "notetrack" },
    { 0x617B, "notetrack_aud_countdown_start" },
    { 0x617C, "notetrack_aud_shoot_missile_start" },
    { 0x617D, "notetrack_break_bar" },
    { 0x617E, "notetrack_close_elevator_doors" },
    { 0x617F, "notetrack_drag_cover_dont_pickup" },
    { 0x6180, "notetrack_drag_cover_pickup" },
    { 0x6181, "notetrack_fade_to_white_fail" },
    { 0x6182, "notetrack_final_fail_slowmo" },
    { 0x6183, "notetrack_final_part5_success_slomo" },
    { 0x6184, "notetrack_fov_end" },
    { 0x6185, "notetrack_gideon_start" },
    { 0x6186, "notetrack_gov_rescue_handcuffs" },
    { 0x6187, "notetrack_gov_wall_climb_intro_left_plant" },
    { 0x6188, "notetrack_gov_wall_climb_intro_left_start" },
    { 0x6189, "notetrack_gov_wall_climb_intro_right_plant" },
    { 0x618A, "notetrack_gov_wall_climb_intro_right_start" },
    { 0x618B, "notetrack_h_breach_small" },
    { 0x618C, "notetrack_highway_bus_land_from_ledge" },
    { 0x618D, "notetrack_highway_final_td_mirror_snap_and_drag" },
    { 0x618E, "notetrack_highway_final_td_suv_collision" },
    { 0x618F, "notetrack_highway_final_td_truck_rail_impact" },
    { 0x6190, "notetrack_highway_final_td_truck_water_impact" },
    { 0x6191, "notetrack_highway_jump_land" },
    { 0x6192, "notetrack_irons_reveal_lerp_fov_out" },
    { 0x6193, "notetrack_mech_exit_fov_change" },
    { 0x6194, "notetrack_middle_takedown_grab_side" },
    { 0x6195, "notetrack_middle_takedown_jump_to_bus" },
    { 0x6196, "notetrack_middle_takedown_jump_to_truck" },
    { 0x6197, "notetrack_middle_takedown_land_on_bus" },
    { 0x6198, "notetrack_middle_takedown_land_on_truck" },
    { 0x6199, "notetrack_middle_takedown_punch_window" },
    { 0x619A, "notetrack_middle_takedown_truck_swipe" },
    { 0x619B, "notetrack_missile_stopped_vm_fade_out" },
    { 0x619C, "notetrack_pickup02_fade_in" },
    { 0x619D, "notetrack_pickup02_fade_out" },
    { 0x619E, "notetrack_player_blast_react" },
    { 0x619F, "notetrack_player_control" },
    { 0x61A0, "notetrack_playsound" },
    { 0x61A1, "notetrack_rocket_launch_start" },
    { 0x61A2, "notetrack_roof_breach_land" },
    { 0x61A3, "notetrack_roof_breach_large" },
    { 0x61A4, "notetrack_roof_breach_medium" },
    { 0x61A5, "notetrack_roof_breach_small" },
    { 0x61A6, "notetrack_rumble_heavy" },
    { 0x61A7, "notetrack_rumble_intense" },
    { 0x61A8, "notetrack_rumble_light" },
    { 0x61A9, "notetrack_rumble_moderate" },
    { 0x61AA, "notetrack_rumble_moderate_on_gideon" },
    { 0x61AB, "notetrack_run01_fade_in" },
    { 0x61AC, "notetrack_run01_fade_out" },
    { 0x61AD, "notetrack_run02_fade_in" },
    { 0x61AE, "notetrack_run02_fade_out" },
    { 0x61AF, "notetrack_run03_fade_in" },
    { 0x61B0, "notetrack_run03_fade_out" },
    { 0x61B1, "notetrack_run04_fade_in" },
    { 0x61B2, "notetrack_run04_fade_out" },
    { 0x61B3, "notetrack_setup" },
    { 0x61B4, "notetrack_setup_middle" },
    { 0x61B5, "notetrack_setup_outro" },
    { 0x61B6, "notetrack_show_takedown_knife" },
    { 0x61B7, "notetrack_swap_roof_brush" },
    { 0x61B8, "notetrack_takedown_start_window" },
    { 0x61B9, "notetrack_unlink" },
    { 0x61BA, "notetrack_unlink_and_start_ragdoll" },
    { 0x61BB, "notetrack_vfx_blast" },
    { 0x61BC, "notetrack_vfx_ignition" },
    { 0x61BD, "notetrack_vm_exo_magnet_end" },
    { 0x61BE, "notetrack_vm_exo_magnet_start" },
    { 0x61BF, "notetrack_vo_exo_climb" },
    { 0x61C0, "notetrack_wait" },
    { 0x61C1, "notetrackalertnessaiming" },
    { 0x61C2, "notetrackalertnessalert" },
    { 0x61C3, "notetrackalertnesscasual" },
    { 0x61C4, "notetrackbodyfall" },
    { 0x61C5, "notetrackcodemove" },
    { 0x61C6, "notetrackdelete" },
    { 0x61C7, "notetrackdetachshield" },
    { 0x61C8, "notetrackdropclip" },
    { 0x61C9, "notetrackfaceenemy" },
    { 0x61CA, "notetrackfire" },
    { 0x61CB, "notetrackfirespray" },
    { 0x61CC, "notetrackfootscrape" },
    { 0x61CD, "notetrackfootstep" },
    { 0x61CE, "notetrackgatebash" },
    { 0x61CF, "notetrackgravity" },
    { 0x61D0, "notetrackgundrop" },
    { 0x61D1, "notetrackgunhand" },
    { 0x61D2, "notetrackguntoback" },
    { 0x61D3, "notetrackguntochest" },
    { 0x61D4, "notetrackhide" },
    { 0x61D5, "notetrackland" },
    { 0x61D6, "notetracklaser" },
    { 0x61D7, "notetrackloadshell" },
    { 0x61D8, "notetrackmeleeattackeft" },
    { 0x61D9, "notetrackmovementrun" },
    { 0x61DA, "notetrackmovementstop" },
    { 0x61DB, "notetrackmovementwalk" },
    { 0x61DC, "notetrackpain" },
    { 0x61DD, "notetrackpistolpickup" },
    { 0x61DE, "notetrackpistolputaway" },
    { 0x61DF, "notetrackpistolrechamber" },
    { 0x61E0, "notetrackposeback" },
    { 0x61E1, "notetrackposecrawl" },
    { 0x61E2, "notetrackposecrouch" },
    { 0x61E3, "notetrackposeprone" },
    { 0x61E4, "notetrackposestand" },
    { 0x61E5, "notetrackrefillclip" },
    { 0x61E6, "notetrackrocketlauncherammoattach" },
    { 0x61E7, "notetrackrocketlauncherammodelete" },
    { 0x61E8, "notetracks" },
    { 0x61E9, "notetracks_bridge_collapse" },
    { 0x61EA, "notetracks_burke_collapse" },
    { 0x61EB, "notetracks_burke_pitbull_intro" },
    { 0x61EC, "notetracks_bus_jump" },
    { 0x61ED, "notetracks_hostage_truck_takedown" },
    { 0x61EE, "notetracks_player_pitbull_crash" },
    { 0x61EF, "notetracks_player_pitbull_intro" },
    { 0x61F0, "notetracks_player_rig_collapse" },
    { 0x61F1, "notetracks_playerrig_truck_middle_takedown" },
    { 0x61F2, "notetracks_traffic_start_vm" },
    { 0x61F3, "notetracks_truck_middle_takedown_kva_truck" },
    { 0x61F4, "notetracks_truck_middle_takedown_pt4" },
    { 0x61F5, "notetrackshoot" },
    { 0x61F6, "notetrackshow" },
    { 0x61F7, "notetrackspacejet" },
    { 0x61F8, "notetrackspacejet_proc" },
    { 0x61F9, "notetrackstartragdoll" },
    { 0x61FA, "notetrackstopanim" },
    { 0x61FB, "notfirsttime" },
    { 0x61FC, "notfirsttimedogs" },
    { 0x61FD, "nothing_for_now" },
    { 0x61FE, "notify_assault_drone_on_player_command" },
    { 0x61FF, "notify_bike_hover" },
    { 0x6200, "notify_delay" },
    { 0x6201, "notify_delay_endon" },
    { 0x6202, "notify_delay_param" },
    { 0x6203, "notify_disable" },
    { 0x6204, "notify_doors_close" },
    { 0x6205, "notify_doors_open" },
    { 0x6206, "notify_drones_all_dead" },
    { 0x6207, "notify_enable" },
    { 0x6208, "notify_enemy_bots_bomb_used" },
    { 0x6209, "notify_enemy_team_bomb_used" },
    { 0x620A, "notify_facial_anim_end" },
    { 0x620B, "notify_fire_rocket_0" },
    { 0x620C, "notify_fire_rocket_1" },
    { 0x620D, "notify_fire_rocket_2" },
    { 0x620E, "notify_fire_rocket_3" },
    { 0x620F, "notify_fire_rocket_4" },
    { 0x6210, "notify_fire_rocket_5" },
    { 0x6211, "notify_fire_rocket_6" },
    { 0x6212, "notify_guy_mounted" },
    { 0x6213, "notify_kill_aim_anim" },
    { 0x6214, "notify_mech_swap" },
    { 0x6215, "notify_method" },
    { 0x6216, "notify_moving_platform_invalid" },
    { 0x6217, "notify_on_damage" },
    { 0x6218, "notify_on_death" },
    { 0x6219, "notify_on_end" },
    { 0x621A, "notify_on_flag" },
    { 0x621B, "notify_on_trigger" },
    { 0x621C, "notify_on_trigger_with_name" },
    { 0x621D, "notify_on_use_trigger" },
    { 0x621E, "notify_on_whizby" },
    { 0x621F, "notify_qte_prompt_and_slowmo" },
    { 0x6220, "notify_recon_drone_on_player_command" },
    { 0x6221, "notify_relay" },
    { 0x6222, "notify_spotted_player" },
    { 0x6223, "notify_spotted_player_alleyway" },
    { 0x6224, "notify_valve_on_death" },
    { 0x6225, "notify_warbird_when_killed" },
    { 0x6226, "notify_when_tag_picked_up_or_unavailable" },
    { 0x6227, "notify_wrapper" },
    { 0x6228, "notifyaftertime" },
    { 0x6229, "notifyconnecting" },
    { 0x622A, "notifycoopover" },
    { 0x622B, "notifydamage" },
    { 0x622C, "notifydamageafterframe" },
    { 0x622D, "notifydamagenotdone" },
    { 0x622E, "notifydeath" },
    { 0x622F, "notifygrenadepickup" },
    { 0x6230, "notifyicon" },
    { 0x6231, "notifymessage" },
    { 0x6232, "notifyonanimend" },
    { 0x6233, "notifyonplayerkill" },
    { 0x6234, "notifyonplayermovingsniperdrone" },
    { 0x6235, "notifyonstartaim" },
    { 0x6236, "notifyoverlay" },
    { 0x6237, "notifyroundover" },
    { 0x6238, "notifystartaim" },
    { 0x6239, "notifystopshootingaftertime" },
    { 0x623A, "notifystring" },
    { 0x623B, "notifytext" },
    { 0x623C, "notifytext2" },
    { 0x623D, "notifytitle" },
    { 0x623E, "notifytracker" },
    { 0x623F, "notrack_final_part5_body_swap" },
    { 0x6240, "notsolid_ents_by_targetname" },
    { 0x6241, "notti" },
    { 0x6242, "noturnanims" },
    { 0x6243, "notusableforjoiningplayers" },
    { 0x6244, "nounignore" },
    { 0x6245, "nousebar" },
    { 0x6246, "nox_generic_hints" },
    { 0x6247, "nox_generic_hints_internal" },
    { 0x6248, "npc_anims" },
    { 0x6249, "npc_cloak_buttons" },
    { 0x624A, "npc_cloak_enable" },
    { 0x624B, "npc_heli_shot" },
    { 0x624C, "npc_maxlrgvelocity" },
    { 0x624D, "npc_maxmedvelocity" },
    { 0x624E, "npc_maxsmlvelocity" },
    { 0x624F, "npc_maxvelocity" },
    { 0x6250, "npc_minvelocitythreshold" },
    { 0x6251, "npc_numvelocityranges" },
    { 0x6252, "npc_pitbull_shot" },
    { 0x6253, "npc_shoots_pool_enemy" },
    { 0x6254, "npcdelete" },
    { 0x6255, "npcid" },
    { 0x6256, "npcidtracker" },
    { 0x6257, "nt_helicrash_slowend" },
    { 0x6258, "nt_helicrash_slowstart" },
    { 0x6259, "nt_incinerator_player_pipe_grab" },
    { 0x625A, "nt_incinerator_player_saved" },
    { 0x625B, "nt_s1_elevator_end" },
    { 0x625C, "nt_s1_elevator_push_fall" },
    { 0x625D, "nt_s1_truck_dismount_guards" },
    { 0x625E, "nt_s2walk_anims_start" },
    { 0x625F, "nt_trolley_doctor_start" },
    { 0x6260, "nt_trolley_door_01" },
    { 0x6261, "nt_trolley_door_02" },
    { 0x6262, "nt_trolley_gate" },
    { 0x6263, "nt_trolley_guard_start" },
    { 0x6264, "nt_trolley_player_start" },
    { 0x6265, "nt_trolley_zip_start" },
    { 0x6266, "nt_warbird_anims_start" },
    { 0x6267, "nt_warbird_mech_link" },
    { 0x6268, "nuke" },
    { 0x6269, "nuke_clockobject" },
    { 0x626A, "nuke_empjam" },
    { 0x626B, "nuke_empteamtracker" },
    { 0x626C, "nuke_soundobject" },
    { 0x626D, "nukeaftermatheffect" },
    { 0x626E, "nuked" },
    { 0x626F, "nukedeath" },
    { 0x6270, "nukedetonated" },
    { 0x6271, "nukeearthquake" },
    { 0x6272, "nukeeffect" },
    { 0x6273, "nukeeffects" },
    { 0x6274, "nukeemptimeout" },
    { 0x6275, "nukeemptimeremaining" },
    { 0x6276, "nukeincoming" },
    { 0x6277, "nukeinfo" },
    { 0x6278, "nukeslowmo" },
    { 0x6279, "nukesoundexplosion" },
    { 0x627A, "nukesoundincoming" },
    { 0x627B, "nuketimer" },
    { 0x627C, "nukevision" },
    { 0x627D, "nukevisioninprogress" },
    { 0x627E, "nukevisionset" },
    { 0x627F, "null_func" },
    { 0x6280, "num" },
    { 0x6281, "num_active_tracking_grenades" },
    { 0x6282, "num_bridge_drones_destroyed" },
    { 0x6283, "num_drones_killed" },
    { 0x6284, "num_in_formation" },
    { 0x6285, "num_lives" },
    { 0x6286, "num_lobby_idles" },
    { 0x6287, "num_missile_attractors" },
    { 0x6288, "num_missile_repulsors" },
    { 0x6289, "num_move_wait_skips" },
    { 0x628A, "num_node_connections_to_group" },
    { 0x628B, "num_objectives_visable" },
    { 0x628C, "num_pipe_fx" },
    { 0x628D, "num_points" },
    { 0x628E, "num_shots" },
    { 0x628F, "num_zones" },
    { 0x6290, "numactive" },
    { 0x6291, "numagents" },
    { 0x6292, "numareas" },
    { 0x6293, "number_of_hp_zones_pre_teleport" },
    { 0x6294, "numberofdronestokill" },
    { 0x6295, "numberofimportantpeopletalking" },
    { 0x6296, "numberofpossiblespawnchoices" },
    { 0x6297, "numcaps" },
    { 0x6298, "numcardtags" },
    { 0x6299, "numcharges" },
    { 0x629A, "numcrawls" },
    { 0x629B, "numcrtaescaptured" },
    { 0x629C, "numdeathsuntilcornergrenadedeath" },
    { 0x629D, "numdeathsuntilcrawlingpain" },
    { 0x629E, "numdroneswaitingtospawn" },
    { 0x629F, "numdropcrates" },
    { 0x62A0, "numenemyvoices" },
    { 0x62A1, "numequipmentkillsintel" },
    { 0x62A2, "numextraflares" },
    { 0x62A3, "numflares" },
    { 0x62A4, "numfriendlyvoices" },
    { 0x62A5, "numgametypereservedobjectives" },
    { 0x62A6, "numgrenadesinprogresstowardsplayer" },
    { 0x62A7, "numheadshotsintel" },
    { 0x62A8, "numkills" },
    { 0x62A9, "numkillstreakkillsintel" },
    { 0x62AA, "nummeleekillsintel" },
    { 0x62AB, "numnearbyplayers" },
    { 0x62AC, "numnearbyprisonturrets" },
    { 0x62AD, "numofreloadmalfunctions" },
    { 0x62AE, "numplayerswaitingtoenterkillcam" },
    { 0x62AF, "numplayerswaitingtospawn" },
    { 0x62B0, "numrevives" },
    { 0x62B1, "numspeakers" },
    { 0x62B2, "numtouching" },
    { 0x62B3, "numtraces" },
    { 0x62B4, "obj" },
    { 0x62B5, "obj_array" },
    { 0x62B6, "obj_base" },
    { 0x62B7, "obj_battle_to_exfil" },
    { 0x62B8, "obj_bio_weapons" },
    { 0x62B9, "obj_bridge" },
    { 0x62BA, "obj_bridge_start" },
    { 0x62BB, "obj_console" },
    { 0x62BC, "obj_defend_squad" },
    { 0x62BD, "obj_destroy_vtol" },
    { 0x62BE, "obj_disable_courtyard_scrambler" },
    { 0x62BF, "obj_ent" },
    { 0x62C0, "obj_enter_atlas_silo" },
    { 0x62C1, "obj_enter_mobile_turret" },
    { 0x62C2, "obj_escape" },
    { 0x62C3, "obj_escape_the_helo" },
    { 0x62C4, "obj_exists" },
    { 0x62C5, "obj_funeral" },
    { 0x62C6, "obj_get_gun" },
    { 0x62C7, "obj_get_in_org" },
    { 0x62C8, "obj_goto_razorback" },
    { 0x62C9, "obj_infiltrate_facility" },
    { 0x62CA, "obj_init" },
    { 0x62CB, "obj_irons" },
    { 0x62CC, "obj_lake_sniper_rifle" },
    { 0x62CD, "obj_laser" },
    { 0x62CE, "obj_locate_atlas_tank" },
    { 0x62CF, "obj_locate_chopper" },
    { 0x62D0, "obj_meet_cormack" },
    { 0x62D1, "obj_neutralize_bio_weapons" },
    { 0x62D2, "obj_origin" },
    { 0x62D3, "obj_overlook" },
    { 0x62D4, "obj_plant_charges" },
    { 0x62D5, "obj_recover_cargo" },
    { 0x62D6, "obj_rescue_1" },
    { 0x62D7, "obj_rescue_2" },
    { 0x62D8, "obj_secure_deck" },
    { 0x62D9, "obj_shut_down_reactor" },
    { 0x62DA, "obj_stop_missile_launch" },
    { 0x62DB, "obj_tag" },
    { 0x62DC, "obj_underwater" },
    { 0x62DD, "obj_use_drone" },
    { 0x62DE, "obj_use_mobile_cover" },
    { 0x62DF, "obj_use_smaw" },
    { 0x62E0, "obj3d_origins" },
    { 0x62E1, "objcollect" },
    { 0x62E2, "objdefend" },
    { 0x62E3, "objdefuse" },
    { 0x62E4, "object" },
    { 0x62E5, "object_control" },
    { 0x62E6, "object_init_reset" },
    { 0x62E7, "object_reset" },
    { 0x62E8, "objectgroupcost" },
    { 0x62E9, "objective_01_on_cardoor" },
    { 0x62EA, "objective_01_on_cormack" },
    { 0x62EB, "objective_01_on_turret" },
    { 0x62EC, "objective_01_on_will" },
    { 0x62ED, "objective_breach" },
    { 0x62EE, "objective_clearadditionalpositions" },
    { 0x62EF, "objective_complete" },
    { 0x62F0, "objective_event_init" },
    { 0x62F1, "objective_flag_init" },
    { 0x62F2, "objective_init" },
    { 0x62F3, "objective_is_active" },
    { 0x62F4, "objective_is_inactive" },
    { 0x62F5, "objective_manager" },
    { 0x62F6, "objective_radius" },
    { 0x62F7, "objective_recon" },
    { 0x62F8, "objective_state_tracker" },
    { 0x62F9, "objective_string_precache" },
    { 0x62FA, "objective_trigger_path_objective_updates" },
    { 0x62FB, "objectivebased" },
    { 0x62FC, "objectivedeathdetection" },
    { 0x62FD, "objectivefailureevents" },
    { 0x62FE, "objectivehintcapturezone" },
    { 0x62FF, "objectivehintdefendhq" },
    { 0x6300, "objectivehintpreparezone" },
    { 0x6301, "objectiveindex" },
    { 0x6302, "objectiveisallowed" },
    { 0x6303, "objectiveonvisuals" },
    { 0x6304, "objectivepointsmod" },
    { 0x6305, "objectives" },
    { 0x6306, "objectivescaler" },
    { 0x6307, "objid" },
    { 0x6308, "objidallies" },
    { 0x6309, "objidaxis" },
    { 0x630A, "objidenemy" },
    { 0x630B, "objidfriendly" },
    { 0x630C, "objidmlgspectator" },
    { 0x630D, "objidpingenemy" },
    { 0x630E, "objidpingfriendly" },
    { 0x630F, "objids" },
    { 0x6310, "objidstart" },
    { 0x6311, "objintel" },
    { 0x6312, "objintercepthades" },
    { 0x6313, "objmarkerplayertarget" },
    { 0x6314, "objmarkervehicle" },
    { 0x6315, "objoutlinevehicle" },
    { 0x6316, "objpingdelay" },
    { 0x6317, "objpoint_alpha_default" },
    { 0x6318, "objpointnames" },
    { 0x6319, "objpoints" },
    { 0x631A, "objpointscale" },
    { 0x631B, "objpointsize" },
    { 0x631C, "objscrambledrones" },
    { 0x631D, "objscramblefollowilana" },
    { 0x631E, "objscramblegapjump" },
    { 0x631F, "objscramblejumpdown" },
    { 0x6320, "objscramblekillsniper" },
    { 0x6321, "objscramblemovetruck" },
    { 0x6322, "objscrambleplayerrunfirst" },
    { 0x6323, "objscramblepoolcafe" },
    { 0x6324, "objscramblerpg" },
    { 0x6325, "objscramblesnipertower" },
    { 0x6326, "objscramblesuppress" },
    { 0x6327, "objscramblesuppressdisplay" },
    { 0x6328, "objscramblewoundedsoldier" },
    { 0x6329, "objsetupdefault" },
    { 0x632A, "objsetupentity" },
    { 0x632B, "objtransitiontoalleys" },
    { 0x632C, "observation_room_scientist_anims" },
    { 0x632D, "observation_room_scientist_death" },
    { 0x632E, "observation_room_scientist_setup" },
    { 0x632F, "observer" },
    { 0x6330, "obstacles" },
    { 0x6331, "occ" },
    { 0x6332, "occluder" },
    { 0x6333, "occlusion" },
    { 0x6334, "occlusion_bypass" },
    { 0x6335, "occlusion_enable" },
    { 0x6336, "occlusion1" },
    { 0x6337, "occlusion2" },
    { 0x6338, "occumulate_player_use_presses" },
    { 0x6339, "occumulator" },
    { 0x633A, "occumulator_base" },
    { 0x633B, "occumulator_scale" },
    { 0x633C, "ocean" },
    { 0x633D, "ocean_pieces" },
    { 0x633E, "oceanmover_init" },
    { 0x633F, "oceanobjectmover_init" },
    { 0x6340, "oceanobjectmover_set_goal" },
    { 0x6341, "oceansinamplitude" },
    { 0x6342, "oceansinmovement" },
    { 0x6343, "oceansinperiod" },
    { 0x6344, "off_threshold" },
    { 0x6345, "offhand_switchout" },
    { 0x6346, "offhandclass" },
    { 0x6347, "offhandextra" },
    { 0x6348, "office_2guys_ambush" },
    { 0x6349, "office_atrium_dialogue" },
    { 0x634A, "office_civ" },
    { 0x634B, "office_dialogue" },
    { 0x634C, "office_glass" },
    { 0x634D, "office_guard" },
    { 0x634E, "office_hallway_door_close" },
    { 0x634F, "office_hallway_door_open" },
    { 0x6350, "office_interior_dialogue" },
    { 0x6351, "office_reunion_dialogue" },
    { 0x6352, "office_roof_door_close" },
    { 0x6353, "office_roof_door_open" },
    { 0x6354, "office_scene_cleanup" },
    { 0x6355, "office_scene_gideon_down_double_stairs" },
    { 0x6356, "office_scene_gideon_enter_secret_room" },
    { 0x6357, "office_scene_gideon_to_roof" },
    { 0x6358, "office_scene_gideon_to_stairs" },
    { 0x6359, "office_scene_intro_pcap" },
    { 0x635A, "office_scene_master_handler" },
    { 0x635B, "office_scene_move_to_secret_room" },
    { 0x635C, "office_scene_open_swipe_door" },
    { 0x635D, "office_scene_player_actions_manager" },
    { 0x635E, "office_scene_player_give_just_hands" },
    { 0x635F, "office_scene_player_handle_move_speed" },
    { 0x6360, "office_scene_player_movement_manager" },
    { 0x6361, "office_scene_player_signed_distance_to_plane" },
    { 0x6362, "office_scene_pre_setup" },
    { 0x6363, "office_scene_scripted_dodge_gideon_civ_wait_for_gideon_in_range" },
    { 0x6364, "office_scene_scripted_dodge_gideon_civilian" },
    { 0x6365, "office_scene_scripted_handle_landing_heli" },
    { 0x6366, "office_scene_scripted_player_blocker_move_with_gideon" },
    { 0x6367, "office_scene_setup" },
    { 0x6368, "office_scene_silence_heli" },
    { 0x6369, "office_scene_vignette_atlas_walker_manager" },
    { 0x636A, "office_scene_vignette_boat_loop_handler" },
    { 0x636B, "office_scene_vignette_boats" },
    { 0x636C, "office_scene_vignette_drones" },
    { 0x636D, "office_scene_vignette_handle_atlas_ai" },
    { 0x636E, "office_scene_vignette_handle_drones" },
    { 0x636F, "office_scene_vignette_helicopters" },
    { 0x6370, "office_scene_vignette_send_boat_through_path" },
    { 0x6371, "office_scene_vignette_set_atlas_walker_urgent_walk_anims" },
    { 0x6372, "office_scene_vignette_setup" },
    { 0x6373, "office_scene_vignette_setup_civilians" },
    { 0x6374, "office_scene_vignette_spawn_personal_guard_hallway" },
    { 0x6375, "office_skylights_breakable" },
    { 0x6376, "office_support_after_ambush" },
    { 0x6377, "officercount" },
    { 0x6378, "officerid" },
    { 0x6379, "officers" },
    { 0x637A, "officerwaiter" },
    { 0x637B, "offmodel" },
    { 0x637C, "offset" },
    { 0x637D, "offset_debug" },
    { 0x637E, "offset_position_from_drone" },
    { 0x637F, "offset_position_from_tag" },
    { 0x6380, "offset_tag" },
    { 0x6381, "offset_thread" },
    { 0x6382, "offset3d" },
    { 0x6383, "offsetdir" },
    { 0x6384, "offsetdist" },
    { 0x6385, "offsetone" },
    { 0x6386, "offsetrange" },
    { 0x6387, "offsettoorigin" },
    { 0x6388, "offsetzero" },
    { 0x6389, "offswitch" },
    { 0x638A, "og" },
    { 0x638B, "og_health" },
    { 0x638C, "og_heli_spawn" },
    { 0x638D, "og_newenemyreactiondistsq" },
    { 0x638E, "og_position" },
    { 0x638F, "og_spawn" },
    { 0x6390, "oil_tanker_bridge_explosion" },
    { 0x6391, "oil_tanker_bridge_fire" },
    { 0x6392, "oil_tanker_crash_fx" },
    { 0x6393, "oil_tanker_explosion_fx" },
    { 0x6394, "old_acc" },
    { 0x6395, "old_accuracy" },
    { 0x6396, "old_ai_target" },
    { 0x6397, "old_angles" },
    { 0x6398, "old_animname" },
    { 0x6399, "old_attributes" },
    { 0x639A, "old_base" },
    { 0x639B, "old_baseaccuracy" },
    { 0x639C, "old_bp_awareness" },
    { 0x639D, "old_contents" },
    { 0x639E, "old_controls" },
    { 0x639F, "old_crash_loc" },
    { 0x63A0, "old_disablearrivals" },
    { 0x63A1, "old_dof_physical_enable" },
    { 0x63A2, "old_fixednode" },
    { 0x63A3, "old_fixednodesaferadius" },
    { 0x63A4, "old_forcecolor" },
    { 0x63A5, "old_fovcosine" },
    { 0x63A6, "old_goalradius" },
    { 0x63A7, "old_gravity" },
    { 0x63A8, "old_health" },
    { 0x63A9, "old_health_long_regen_delay" },
    { 0x63AA, "old_health_regen_delay" },
    { 0x63AB, "old_ignoreme" },
    { 0x63AC, "old_interval" },
    { 0x63AD, "old_introscreen_default" },
    { 0x63AE, "old_locations" },
    { 0x63AF, "old_locations_mp" },
    { 0x63B0, "old_maxsightdistsqrd" },
    { 0x63B1, "old_movementtype" },
    { 0x63B2, "old_moveplaybackrate" },
    { 0x63B3, "old_name" },
    { 0x63B4, "old_origin" },
    { 0x63B5, "old_path" },
    { 0x63B6, "old_pathlookaheaddist" },
    { 0x63B7, "old_pathrandompercent" },
    { 0x63B8, "old_position" },
    { 0x63B9, "old_stealth_numbers" },
    { 0x63BA, "old_threat_bias_group" },
    { 0x63BB, "old_threatbias" },
    { 0x63BC, "old_threatbiasgroupname" },
    { 0x63BD, "old_turnrate" },
    { 0x63BE, "old_viewbobamplitudeducked" },
    { 0x63BF, "old_viewbobamplitudesprinting" },
    { 0x63C0, "old_viewbobamplitudestanding" },
    { 0x63C1, "old_vl_focus" },
    { 0x63C2, "old_walkdist" },
    { 0x63C3, "old_walkdistfacingmotion" },
    { 0x63C4, "old_weapon" },
    { 0x63C5, "old_z" },
    { 0x63C6, "oldacc" },
    { 0x63C7, "oldanimname" },
    { 0x63C8, "oldbase" },
    { 0x63C9, "oldcombatmode" },
    { 0x63CA, "oldcontents" },
    { 0x63CB, "oldconvergencetime" },
    { 0x63CC, "olddontattackme" },
    { 0x63CD, "oldfightdist" },
    { 0x63CE, "oldfixednode" },
    { 0x63CF, "oldgoalradius" },
    { 0x63D0, "oldgrenade" },
    { 0x63D1, "oldgrenadeammo" },
    { 0x63D2, "oldgrenadeawareness" },
    { 0x63D3, "oldgrenadereturnthrow" },
    { 0x63D4, "oldgrenadeweapon" },
    { 0x63D5, "oldgrenawareness" },
    { 0x63D6, "oldhandler" },
    { 0x63D7, "oldheadicon" },
    { 0x63D8, "oldheadiconteam" },
    { 0x63D9, "oldignoreme" },
    { 0x63DA, "oldmaxdist" },
    { 0x63DB, "oldmaxsight" },
    { 0x63DC, "oldmode" },
    { 0x63DD, "oldmoveplaybackrate" },
    { 0x63DE, "oldnotifymessage" },
    { 0x63DF, "oldorigin" },
    { 0x63E0, "oldpathenemyfightdist" },
    { 0x63E1, "oldpathenemylookahead" },
    { 0x63E2, "oldradius" },
    { 0x63E3, "oldrotx" },
    { 0x63E4, "oldroty" },
    { 0x63E5, "oldscriptforcecolor" },
    { 0x63E6, "oldstance" },
    { 0x63E7, "oldstyle" },
    { 0x63E8, "oldtown_ceiling_fans" },
    { 0x63E9, "oldtown_chasers" },
    { 0x63EA, "oldtown_civs" },
    { 0x63EB, "oldtown_dock" },
    { 0x63EC, "oldtown_dock_anim_jumper" },
    { 0x63ED, "oldtown_dock_anim_jumper_setup" },
    { 0x63EE, "oldtown_dock_backtrack_death_squad_spawners" },
    { 0x63EF, "oldtown_dock_backtrack_fail_send_in_flyers" },
    { 0x63F0, "oldtown_dock_civ_setup" },
    { 0x63F1, "oldtown_dock_cleanup" },
    { 0x63F2, "oldtown_dock_combat_cleanup" },
    { 0x63F3, "oldtown_dock_enemies" },
    { 0x63F4, "oldtown_dock_enemy_mech_death_alert" },
    { 0x63F5, "oldtown_dock_enemy_moveup" },
    { 0x63F6, "oldtown_dock_enemy_retreat" },
    { 0x63F7, "oldtown_dock_enemy_setup" },
    { 0x63F8, "oldtown_dock_fail_avoid_player_got_in_boat" },
    { 0x63F9, "oldtown_dock_fail_enemies" },
    { 0x63FA, "oldtown_dock_fail_enemy_hunt" },
    { 0x63FB, "oldtown_dock_fail_init" },
    { 0x63FC, "oldtown_dock_fail_start" },
    { 0x63FD, "oldtown_dock_failstate_backtrack" },
    { 0x63FE, "oldtown_dock_failstate_backtrack_deathsquad" },
    { 0x63FF, "oldtown_dock_ilana_advance" },
    { 0x6400, "oldtown_dock_ilana_advance_think" },
    { 0x6401, "oldtown_dock_littlebird_rooftop_goal" },
    { 0x6402, "oldtown_dock_littlebird_rooftop_vig" },
    { 0x6403, "oldtown_dock_master_handler" },
    { 0x6404, "oldtown_dock_mech_damage_function" },
    { 0x6405, "oldtown_dock_mech_death_event" },
    { 0x6406, "oldtown_dock_mech_entrance" },
    { 0x6407, "oldtown_dock_mech_goal" },
    { 0x6408, "oldtown_dock_mech_rockets" },
    { 0x6409, "oldtown_dock_post_boat_cleanup" },
    { 0x640A, "oldtown_enemy_array" },
    { 0x640B, "oldtown_freerun" },
    { 0x640C, "oldtown_freerun_cg_perf_maintain" },
    { 0x640D, "oldtown_freerun_civ_badplace_pathing" },
    { 0x640E, "oldtown_freerun_civ_ender" },
    { 0x640F, "oldtown_freerun_civ_init" },
    { 0x6410, "oldtown_freerun_civ_setup" },
    { 0x6411, "oldtown_freerun_civ_walker_maintainer" },
    { 0x6412, "oldtown_freerun_civ_walker_panic" },
    { 0x6413, "oldtown_freerun_civ_walker_panic_retreat" },
    { 0x6414, "oldtown_freerun_civ_walker_removal" },
    { 0x6415, "oldtown_freerun_civ_walker_setup" },
    { 0x6416, "oldtown_freerun_doorkick_enemy" },
    { 0x6417, "oldtown_freerun_doorkick_enemy_setup" },
    { 0x6418, "oldtown_freerun_doorkick_player" },
    { 0x6419, "oldtown_freerun_doorkick_player_removal" },
    { 0x641A, "oldtown_freerun_enemy_chase_player" },
    { 0x641B, "oldtown_freerun_enemy_chaser_cleaner" },
    { 0x641C, "oldtown_freerun_enemy_chk_player_pos" },
    { 0x641D, "oldtown_freerun_enemy_cleanup_maintain" },
    { 0x641E, "oldtown_freerun_enemy_dresser_kick" },
    { 0x641F, "oldtown_freerun_enemy_dresser_kick_setup" },
    { 0x6420, "oldtown_freerun_enemy_fragging" },
    { 0x6421, "oldtown_freerun_enemy_goal_assign" },
    { 0x6422, "oldtown_freerun_enemy_monitor_player_pos" },
    { 0x6423, "oldtown_freerun_enemy_removal" },
    { 0x6424, "oldtown_freerun_enemy_removal_offscreen" },
    { 0x6425, "oldtown_freerun_enemy_secondgoal" },
    { 0x6426, "oldtown_freerun_enemy_spawner_alert" },
    { 0x6427, "oldtown_freerun_enemy_spawner_func" },
    { 0x6428, "oldtown_freerun_enemy_spawner_init" },
    { 0x6429, "oldtown_freerun_enemy_vo_setup" },
    { 0x642A, "oldtown_freerun_failstate_backtrack" },
    { 0x642B, "oldtown_freerun_failstate_backtrack_deathsquad" },
    { 0x642C, "oldtown_freerun_failstate_monitor" },
    { 0x642D, "oldtown_freerun_ilana_awareness" },
    { 0x642E, "oldtown_freerun_ilona_ignore_pain_handler" },
    { 0x642F, "oldtown_freerun_mech_hunting" },
    { 0x6430, "oldtown_freerun_mech_persist" },
    { 0x6431, "oldtown_freerun_scripted_object_setup" },
    { 0x6432, "oldtown_freerun_security_checkpoint_guards_hold_fire" },
    { 0x6433, "oldtown_freerun_vis_jumper" },
    { 0x6434, "oldtown_freerun_vis_jumper2" },
    { 0x6435, "oldtown_freerun_warbird_pass" },
    { 0x6436, "oldtown_pa" },
    { 0x6437, "oldtown_scene_master_handler" },
    { 0x6438, "oldwalkdist" },
    { 0x6439, "omaclasschanged" },
    { 0x643A, "omausebar" },
    { 0x643B, "on_agent_dog_killed" },
    { 0x643C, "on_agent_generic_damaged" },
    { 0x643D, "on_agent_player_damaged" },
    { 0x643E, "on_agent_player_killed" },
    { 0x643F, "on_agent_squadmate_killed" },
    { 0x6440, "on_alert_chase_player" },
    { 0x6441, "on_alert_go_volume" },
    { 0x6442, "on_alert_notify_level" },
    { 0x6443, "on_bot_killed" },
    { 0x6444, "on_damaged_finished" },
    { 0x6445, "on_humanoid_agent_killed_common" },
    { 0x6446, "on_minion_killed" },
    { 0x6447, "on_path_from" },
    { 0x6448, "on_path_grid" },
    { 0x6449, "on_radar_hud" },
    { 0x644A, "on_shield_down" },
    { 0x644B, "on_shield_up" },
    { 0x644C, "on_the_way_to_jammer_2" },
    { 0x644D, "on_threshold" },
    { 0x644E, "onagentkilled" },
    { 0x644F, "onagentspawned" },
    { 0x6450, "onaiconnect" },
    { 0x6451, "onairstrikedeath" },
    { 0x6452, "onassaultdronedeath" },
    { 0x6453, "onatv" },
    { 0x6454, "onback" },
    { 0x6455, "onbattlebuddymenuselection" },
    { 0x6456, "onbegincarrying" },
    { 0x6457, "onbeginuse" },
    { 0x6458, "onbeginuse_elevator" },
    { 0x6459, "onbody" },
    { 0x645A, "oncancel" },
    { 0x645B, "oncanceldelegate" },
    { 0x645C, "oncantuse" },
    { 0x645D, "oncarried" },
    { 0x645E, "oncarrieddelegate" },
    { 0x645F, "oncarrierdeath" },
    { 0x6460, "oncoming_alley_truck" },
    { 0x6461, "oncoming_bypass_kill" },
    { 0x6462, "oncoming_pitbull_speed" },
    { 0x6463, "oncoming_scene_pitbull_speed_monitor" },
    { 0x6464, "onconnectprompt" },
    { 0x6465, "oncontested" },
    { 0x6466, "oncreatedelegate" },
    { 0x6467, "ondamage" },
    { 0x6468, "ondeactivedelegate" },
    { 0x6469, "ondeadevent" },
    { 0x646A, "ondeath" },
    { 0x646B, "ondeathdelegate" },
    { 0x646C, "ondeathdot_buildfunc" },
    { 0x646D, "ondeathdot_poisondamageplayer" },
    { 0x646E, "ondeathfunc" },
    { 0x646F, "ondeathti" },
    { 0x6470, "ondisconnect" },
    { 0x6471, "ondogkilled" },
    { 0x6472, "ondrop" },
    { 0x6473, "ondropflaghudstatus" },
    { 0x6474, "one_ammo" },
    { 0x6475, "one_frac" },
    { 0x6476, "one_handed_ammo_tracking" },
    { 0x6477, "one_handed_drop_handling" },
    { 0x6478, "one_handed_exododge_handling" },
    { 0x6479, "one_handed_get_base_weapon" },
    { 0x647A, "one_handed_grenade_handling" },
    { 0x647B, "one_handed_help" },
    { 0x647C, "one_handed_help_aggro" },
    { 0x647D, "one_handed_help_flash" },
    { 0x647E, "one_handed_help_flash_ally_tracker" },
    { 0x647F, "one_handed_help_gen" },
    { 0x6480, "one_handed_help_gun" },
    { 0x6481, "one_handed_help_try" },
    { 0x6482, "one_handed_help_vo_setup" },
    { 0x6483, "one_handed_mantle_handling" },
    { 0x6484, "one_handed_melee_take_weapon" },
    { 0x6485, "one_handed_modify_threatbias" },
    { 0x6486, "one_handed_pickup_handling" },
    { 0x6487, "one_handed_swap_tracking" },
    { 0x6488, "one_handed_switch_to_melee" },
    { 0x6489, "one_handed_weapon_check_swap" },
    { 0x648A, "one_shot" },
    { 0x648B, "one_time" },
    { 0x648C, "one_vo" },
    { 0x648D, "one_weap" },
    { 0x648E, "onelefttime" },
    { 0x648F, "onemanarmyweaponchangetracker" },
    { 0x6490, "onendgame" },
    { 0x6491, "onenduse" },
    { 0x6492, "onenter" },
    { 0x6493, "onenteranimstate" },
    { 0x6494, "onenterdot_buildfunc" },
    { 0x6495, "onenterdot_player" },
    { 0x6496, "onenterdot_poisondamagecount" },
    { 0x6497, "onenterdot_poisondamageoverlay" },
    { 0x6498, "onenterdot_poisondamageplayer" },
    { 0x6499, "onenterfunc" },
    { 0x649A, "oneshot_data" },
    { 0x649B, "oneshot_duck_vals" },
    { 0x649C, "oneshot_handle_index" },
    { 0x649D, "oneshot_list" },
    { 0x649E, "oneshot_overrides" },
    { 0x649F, "oneshot_poly_mode" },
    { 0x64A0, "oneshot_under_construction" },
    { 0x64A1, "oneshot_update_mode" },
    { 0x64A2, "oneshotfx" },
    { 0x64A3, "oneshotfxthread" },
    { 0x64A4, "oneshotkillevent" },
    { 0x64A5, "oneshots" },
    { 0x64A6, "oneshotsoundonmovingent" },
    { 0x64A7, "oneshotsoundonstationaryent" },
    { 0x64A8, "onexit" },
    { 0x64A9, "onexitdot_buildfunc" },
    { 0x64AA, "onexitdot_player" },
    { 0x64AB, "onexitdot_poisondamageplayer" },
    { 0x64AC, "onexitfunc" },
    { 0x64AD, "onexplosivedronedeath" },
    { 0x64AE, "onexplosiveplayerconnect" },
    { 0x64AF, "onfinalsurvivor" },
    { 0x64B0, "onflashbanged" },
    { 0x64B1, "onfoot_start_alley_setup" },
    { 0x64B2, "onforfeit" },
    { 0x64B3, "onfreeplayerconnect" },
    { 0x64B4, "ongameended" },
    { 0x64B5, "onhalftime" },
    { 0x64B6, "onjoinedspectators" },
    { 0x64B7, "onjoinedteam" },
    { 0x64B8, "onkillstreakdisowned" },
    { 0x64B9, "onkillstreakkilled" },
    { 0x64BA, "onlastalive" },
    { 0x64BB, "onlinegame" },
    { 0x64BC, "only_allowable_tactical_goals" },
    { 0x64BD, "onlydronesremaining" },
    { 0x64BE, "onlyroundoverride" },
    { 0x64BF, "onmodel" },
    { 0x64C0, "onmovingplatformcollision" },
    { 0x64C1, "onnopoisonside" },
    { 0x64C2, "onnormaldeath" },
    { 0x64C3, "ononeleftevent" },
    { 0x64C4, "onorbitalsupportplayerconnect" },
    { 0x64C5, "onpickup" },
    { 0x64C6, "onpickupfailed" },
    { 0x64C7, "onpickupflaghudstatus" },
    { 0x64C8, "onplaced" },
    { 0x64C9, "onplaceddelegate" },
    { 0x64CA, "onplayer" },
    { 0x64CB, "onplayerconnect" },
    { 0x64CC, "onplayerconnectaudioinit" },
    { 0x64CD, "onplayerconnectduringstreak" },
    { 0x64CE, "onplayerconnected" },
    { 0x64CF, "onplayerconnectfucntions" },
    { 0x64D0, "onplayerconnectfunctions" },
    { 0x64D1, "onplayerconnecthintstring" },
    { 0x64D2, "onplayerconnecthorde" },
    { 0x64D3, "onplayerconnecthunterkiller" },
    { 0x64D4, "onplayerconnecting" },
    { 0x64D5, "onplayerdeath" },
    { 0x64D6, "onplayerkilled" },
    { 0x64D7, "onplayerlaststand" },
    { 0x64D8, "onplayerscore" },
    { 0x64D9, "onplayerspawned" },
    { 0x64DA, "onplayerspawnedduringstreak" },
    { 0x64DB, "onplayerspawnedhintstring" },
    { 0x64DC, "onplayerspawnedhunterkiller" },
    { 0x64DD, "onprecachegametype" },
    { 0x64DE, "onprisonplayerconnect" },
    { 0x64DF, "onprisonplayerdisconnect" },
    { 0x64E0, "onrecondronedeath" },
    { 0x64E1, "onrecoveryplayerconnect" },
    { 0x64E2, "onrecoveryplayerdisconnect" },
    { 0x64E3, "onreset" },
    { 0x64E4, "onresetflaghudstatus" },
    { 0x64E5, "onrespawndelay" },
    { 0x64E6, "onrotatingvehicleturret" },
    { 0x64E7, "onroundswitch" },
    { 0x64E8, "onsamesideofdoor" },
    { 0x64E9, "onscorelimit" },
    { 0x64EA, "onsnowmobile" },
    { 0x64EB, "onspawnfinished" },
    { 0x64EC, "onspawnplayer" },
    { 0x64ED, "onspawnspectator" },
    { 0x64EE, "onspectatingclient" },
    { 0x64EF, "onstartgametype" },
    { 0x64F0, "onsuicidedeath" },
    { 0x64F1, "onsurvivorseliminated" },
    { 0x64F2, "onteamselection" },
    { 0x64F3, "ontimelimit" },
    { 0x64F4, "ontrackingdronedeath" },
    { 0x64F5, "ontrackingplayerconnect" },
    { 0x64F6, "onturretdeath" },
    { 0x64F7, "onuncontested" },
    { 0x64F8, "onunderwater" },
    { 0x64F9, "onunoccupied" },
    { 0x64FA, "onupdateuserate" },
    { 0x64FB, "onuse" },
    { 0x64FC, "onuse_elevator" },
    { 0x64FD, "onusedefuseobject" },
    { 0x64FE, "onuseplantobject" },
    { 0x64FF, "onuseupdate" },
    { 0x6500, "onweapondamage" },
    { 0x6501, "onxpevent" },
    { 0x6502, "onzonecapture" },
    { 0x6503, "onzonecontested" },
    { 0x6504, "onzoneuncontested" },
    { 0x6505, "onzoneunoccupied" },
    { 0x6506, "open" },
    { 0x6507, "open_all_doors" },
    { 0x6508, "open_angles" },
    { 0x6509, "open_big_door" },
    { 0x650A, "open_car_door" },
    { 0x650B, "open_car_doors" },
    { 0x650C, "open_door" },
    { 0x650D, "open_door_anim" },
    { 0x650E, "open_doors_for_unload" },
    { 0x650F, "open_double_doors_by_name" },
    { 0x6510, "open_double_hatch_by_name" },
    { 0x6511, "open_double_sliding_doors_toggle" },
    { 0x6512, "open_elevator_doors" },
    { 0x6513, "open_firedoor_for_guards" },
    { 0x6514, "open_hangar_doors" },
    { 0x6515, "open_hatch_breakout" },
    { 0x6516, "open_inner_doors" },
    { 0x6517, "open_left_door" },
    { 0x6518, "open_org" },
    { 0x6519, "open_outer_doors" },
    { 0x651A, "open_position" },
    { 0x651B, "open_right_door" },
    { 0x651C, "open_server_room_door" },
    { 0x651D, "open_single_door_by_name" },
    { 0x651E, "open_sliding_door_toggle" },
    { 0x651F, "open_time" },
    { 0x6520, "open_up_fov" },
    { 0x6521, "open_velocity" },
    { 0x6522, "open_window" },
    { 0x6523, "opendoor" },
    { 0x6524, "opendynamicbuildingplatformpath" },
    { 0x6525, "opened_org" },
    { 0x6526, "opening_movie_function" },
    { 0x6527, "opening_prop_deletes" },
    { 0x6528, "opening_run" },
    { 0x6529, "opening_start" },
    { 0x652A, "opening_start_fov_changes" },
    { 0x652B, "opening_warbird" },
    { 0x652C, "openingsplashscreen" },
    { 0x652D, "openrestaurantdoor" },
    { 0x652E, "operating_base_ambientfx_aa_explosion" },
    { 0x652F, "operating_base_ambientfx_ground_dirt_explosion" },
    { 0x6530, "operating_base_ambientfx_ground_fireball_explosion" },
    { 0x6531, "operating_base_ambientfx_midair_explosion" },
    { 0x6532, "operating_base_ambientfx_window_glass_explosion" },
    { 0x6533, "opfor_ah" },
    { 0x6534, "opfor_ah_start_front" },
    { 0x6535, "opfor_ammo_drop_mod" },
    { 0x6536, "opfor_bh" },
    { 0x6537, "opfor_death_mod" },
    { 0x6538, "opfor_dialog_col" },
    { 0x6539, "opfor_help_aggro" },
    { 0x653A, "opfor_help_aggro_cleanup" },
    { 0x653B, "opfor_interrogation" },
    { 0x653C, "opfor_kill_guard" },
    { 0x653D, "opfor_retreat" },
    { 0x653E, "opp_trig" },
    { 0x653F, "oppressed_civ01" },
    { 0x6540, "oppressed_civ02" },
    { 0x6541, "oppressed_civs" },
    { 0x6542, "oppression_starter" },
    { 0x6543, "opticsthermal_blur" },
    { 0x6544, "opticsthermal_blur_off" },
    { 0x6545, "opticsthermal_think" },
    { 0x6546, "opticsthermalenabled" },
    { 0x6547, "optimized_process_trigger" },
    { 0x6548, "optimizedvehicletriggerprocess" },
    { 0x6549, "optional_responder_name" },
    { 0x654A, "optionalnumber" },
    { 0x654B, "optionalstepeffectfunction" },
    { 0x654C, "optionalstepeffects" },
    { 0x654D, "optionalstepeffectsmallfunction" },
    { 0x654E, "optionalstepeffectssmall" },
    { 0x654F, "options" },
    { 0x6550, "orbit" },
    { 0x6551, "orbital_endpoint" },
    { 0x6552, "orbital_forward" },
    { 0x6553, "orbital_laser_allies" },
    { 0x6554, "orbital_laser_axis" },
    { 0x6555, "orbital_lasers" },
    { 0x6556, "orbital_location" },
    { 0x6557, "orbital_ships" },
    { 0x6558, "orbital_util_capsule_traces" },
    { 0x6559, "orbital_util_capsule_traces_frame" },
    { 0x655A, "orbital_util_covered_volumes" },
    { 0x655B, "orbital_util_last_trace" },
    { 0x655C, "orbital_util_remote_traces" },
    { 0x655D, "orbital_util_remote_traces_frame" },
    { 0x655E, "orbital_viewangles" },
    { 0x655F, "orbitalanimate" },
    { 0x6560, "orbitaldropmarkers" },
    { 0x6561, "orbitallaseroverridefunc" },
    { 0x6562, "orbitallaseroverrides" },
    { 0x6563, "orbitalphysicswaiter" },
    { 0x6564, "orbitalstrikchargeupspeedup" },
    { 0x6565, "orbitalstrikebeginchargeup" },
    { 0x6566, "orbitalstrikechargeupcomplete" },
    { 0x6567, "orbitalstrikecleanup" },
    { 0x6568, "orbitalstriketimer" },
    { 0x6569, "orbitalsupport_big_turret" },
    { 0x656A, "orbitalsupport_buddy" },
    { 0x656B, "orbitalsupport_buddy_chatter_timer" },
    { 0x656C, "orbitalsupport_buddy_turret" },
    { 0x656D, "orbitalsupport_chatter_timer" },
    { 0x656E, "orbitalsupport_endtime" },
    { 0x656F, "orbitalsupport_hold_time" },
    { 0x6570, "orbitalsupport_onlookers" },
    { 0x6571, "orbitalsupport_planemodel" },
    { 0x6572, "orbitalsupport_player" },
    { 0x6573, "orbitalsupport_spawn" },
    { 0x6574, "orbitalsupport_speed" },
    { 0x6575, "orbitalsupport_targetent" },
    { 0x6576, "orbitalsupport_use_duration" },
    { 0x6577, "orbitalsupportexit" },
    { 0x6578, "orbitalsupportinuse" },
    { 0x6579, "orbitalsupportoverridefunc" },
    { 0x657A, "orbitalsupportoverrides" },
    { 0x657B, "orbitalthermalmode" },
    { 0x657C, "orbitaltype" },
    { 0x657D, "orbitangle" },
    { 0x657E, "orbitlowerbounds" },
    { 0x657F, "orderaction" },
    { 0x6580, "orderdisplace" },
    { 0x6581, "ordermove" },
    { 0x6582, "orderonqueueddialog" },
    { 0x6583, "orderto" },
    { 0x6584, "org" },
    { 0x6585, "org_angles" },
    { 0x6586, "org_origin" },
    { 0x6587, "org_player_highway_ledge" },
    { 0x6588, "org_pos" },
    { 0x6589, "org_spawner" },
    { 0x658A, "orghealth" },
    { 0x658B, "orient_facing" },
    { 0x658C, "orientmeleevictim" },
    { 0x658D, "orienttonormal" },
    { 0x658E, "orig_alpha" },
    { 0x658F, "orig_angles" },
    { 0x6590, "orig_flashbangimmunity" },
    { 0x6591, "orig_origin" },
    { 0x6592, "origacceleration" },
    { 0x6593, "origairacceleration" },
    { 0x6594, "origfov" },
    { 0x6595, "origgravity" },
    { 0x6596, "origin_ent" },
    { 0x6597, "origin_friendly_pitbull_headlight" },
    { 0x6598, "origin_offset" },
    { 0x6599, "origin_pitbull_headlight" },
    { 0x659A, "origin_prev" },
    { 0x659B, "origin_within_volume" },
    { 0x659C, "origin2" },
    { 0x659D, "original_ang" },
    { 0x659E, "original_angles" },
    { 0x659F, "original_intensityhdr" },
    { 0x65A0, "original_model" },
    { 0x65A1, "original_org" },
    { 0x65A2, "original_orientation" },
    { 0x65A3, "original_origin" },
    { 0x65A4, "original_position" },
    { 0x65A5, "original_r_znear" },
    { 0x65A6, "originalowner" },
    { 0x65A7, "originalpos" },
    { 0x65A8, "originalrot" },
    { 0x65A9, "originaltarget" },
    { 0x65AA, "originheightoffset" },
    { 0x65AB, "origins" },
    { 0x65AC, "origins_pasrsed" },
    { 0x65AD, "oscillate_speed" },
    { 0x65AE, "osp_buddy_exit" },
    { 0x65AF, "osplightset" },
    { 0x65B0, "osprig" },
    { 0x65B1, "ospvisionset" },
    { 0x65B2, "ot" },
    { 0x65B3, "other_col_point" },
    { 0x65B4, "otherbombzones" },
    { 0x65B5, "otherstringent" },
    { 0x65B6, "otherteam" },
    { 0x65B7, "othertrophy" },
    { 0x65B8, "outcomenotify" },
    { 0x65B9, "outcomeoverlay" },
    { 0x65BA, "outdoor_motion_dlight" },
    { 0x65BB, "outdoor_motion_dlight_timeout" },
    { 0x65BC, "outdoor_motion_light" },
    { 0x65BD, "outdoor_only_maxs" },
    { 0x65BE, "outdoor_only_mins" },
    { 0x65BF, "outdoor_think" },
    { 0x65C0, "outer_space_lighting" },
    { 0x65C1, "outercone" },
    { 0x65C2, "outerspace_intro_new" },
    { 0x65C3, "outerspacelighting" },
    { 0x65C4, "outerspacelighting_checkpoint" },
    { 0x65C5, "outerspawns" },
    { 0x65C6, "outfit_initial" },
    { 0x65C7, "outframes" },
    { 0x65C8, "outlinecolor" },
    { 0x65C9, "outlined" },
    { 0x65CA, "output_name" },
    { 0x65CB, "output_states_to_file" },
    { 0x65CC, "output_type" },
    { 0x65CD, "outro" },
    { 0x65CE, "outro_drone_tablet_touch_fx" },
    { 0x65CF, "outro_horde_cleanup" },
    { 0x65D0, "outro_newscast" },
    { 0x65D1, "outro_tablet_touch_fx" },
    { 0x65D2, "outro_vm_arm_blood_init" },
    { 0x65D3, "outro_vm_body_drag_dust" },
    { 0x65D4, "outside" },
    { 0x65D5, "outside_group_1" },
    { 0x65D6, "outside_group_start_fighting" },
    { 0x65D7, "outside_zones" },
    { 0x65D8, "over_drive_is_active" },
    { 0x65D9, "overclock_fx_l" },
    { 0x65DA, "overclock_fx_r" },
    { 0x65DB, "overclock_on" },
    { 0x65DC, "overdrive_cooldown" },
    { 0x65DD, "overdrive_cooldown_internal" },
    { 0x65DE, "overdrive_disable" },
    { 0x65DF, "overdrive_effects_start" },
    { 0x65E0, "overdrive_effects_stop" },
    { 0x65E1, "overdrive_enable" },
    { 0x65E2, "overdrive_force_cooldown" },
    { 0x65E3, "overdrive_force_start" },
    { 0x65E4, "overdrive_force_stop" },
    { 0x65E5, "overdrive_heatup" },
    { 0x65E6, "overdrive_heatup_internal" },
    { 0x65E7, "overdrive_initialize_params" },
    { 0x65E8, "overdrive_is_enabled" },
    { 0x65E9, "overdrive_is_on" },
    { 0x65EA, "overdrive_manage_fov" },
    { 0x65EB, "overdrive_off" },
    { 0x65EC, "overdrive_on" },
    { 0x65ED, "overdrive_reset" },
    { 0x65EE, "overdrive_start" },
    { 0x65EF, "overdrive_think" },
    { 0x65F0, "overdrive_updatebar" },
    { 0x65F1, "overexposed_effect" },
    { 0x65F2, "overflow_vols" },
    { 0x65F3, "overhead_icon_col" },
    { 0x65F4, "overhead_icon_col_plus1" },
    { 0x65F5, "overhead_icon_col_plus2" },
    { 0x65F6, "overhead_icon_col_plus3" },
    { 0x65F7, "overheated" },
    { 0x65F8, "overheattime" },
    { 0x65F9, "overlay" },
    { 0x65FA, "overlayoffsety" },
    { 0x65FB, "overlaysonar" },
    { 0x65FC, "overlaystatic" },
    { 0x65FD, "overlaystatic2" },
    { 0x65FE, "overlaythreat" },
    { 0x65FF, "overlook_anim" },
    { 0x6600, "overlook_autosave" },
    { 0x6601, "overlook_continue" },
    { 0x6602, "overlook_dialogue_1" },
    { 0x6603, "overlook_dialogue_2" },
    { 0x6604, "overlook_drone" },
    { 0x6605, "overlook_fall" },
    { 0x6606, "overlook_force_stand" },
    { 0x6607, "overlook_grab_save" },
    { 0x6608, "overlook_grab_save_individual" },
    { 0x6609, "overlook_kill_player" },
    { 0x660A, "overlook_land" },
    { 0x660B, "overlook_override_anim" },
    { 0x660C, "overlook_recover" },
    { 0x660D, "overlook_slide_fx" },
    { 0x660E, "overlook_smoke_vista" },
    { 0x660F, "overlook_start_combat" },
    { 0x6610, "overlook_to_lake_teleport" },
    { 0x6611, "overlook_wind" },
    { 0x6612, "override_anim" },
    { 0x6613, "override_anim_org" },
    { 0x6614, "override_anim_time" },
    { 0x6615, "override_breath_values" },
    { 0x6616, "override_class_function" },
    { 0x6617, "override_crawl_death_anims" },
    { 0x6618, "override_dds_categories" },
    { 0x6619, "override_dds_category" },
    { 0x661A, "override_dds_category_allteams" },
    { 0x661B, "override_dds_category_axis" },
    { 0x661C, "override_deadquote" },
    { 0x661D, "override_drone_platform_death" },
    { 0x661E, "override_event_distances_for_mute_volume" },
    { 0x661F, "override_footstep_notetrack_scripts" },
    { 0x6620, "override_footsteps" },
    { 0x6621, "override_kamikaze_range" },
    { 0x6622, "override_max_wave_delay" },
    { 0x6623, "override_max_wave_spawns" },
    { 0x6624, "override_member_loadout_for_practice_round" },
    { 0x6625, "override_min_wave_delay" },
    { 0x6626, "override_mount_anim" },
    { 0x6627, "override_rig" },
    { 0x6628, "override_stealth_distances" },
    { 0x6629, "override_target" },
    { 0x662A, "override_view_angle_unclamp_time" },
    { 0x662B, "override_water_footsteps" },
    { 0x662C, "overridealerttimedelay" },
    { 0x662D, "overrider" },
    { 0x662E, "overrides" },
    { 0x662F, "overridewatchdvars" },
    { 0x6630, "overshoot_next_node" },
    { 0x6631, "overtimescorewinoverride" },
    { 0x6632, "overwatch_heli" },
    { 0x6633, "ownedtheentiregame" },
    { 0x6634, "ownedtheentireround" },
    { 0x6635, "owner_team" },
    { 0x6636, "ownerdamagedradiussq" },
    { 0x6637, "ownerid" },
    { 0x6638, "ownerlist" },
    { 0x6639, "ownerprevpos" },
    { 0x663A, "ownerradiussq" },
    { 0x663B, "ownersattacker" },
    { 0x663C, "ownerstringent" },
    { 0x663D, "ownerteam" },
    { 0x663E, "ownertrigger" },
    { 0x663F, "ownervehicle" },
    { 0x6640, "p_hits" },
    { 0x6641, "pa_airlock" },
    { 0x6642, "pa_codered" },
    { 0x6643, "pa_emergency" },
    { 0x6644, "pa_emergency_turbine" },
    { 0x6645, "pa_system_filler_after_joker" },
    { 0x6646, "pac_attack_when_alert" },
    { 0x6647, "pac_enemy_group" },
    { 0x6648, "pac_enemy_stats" },
    { 0x6649, "packageholdtimer" },
    { 0x664A, "packagesingletapped" },
    { 0x664B, "padding" },
    { 0x664C, "pain_protection" },
    { 0x664D, "pain_protection_check" },
    { 0x664E, "pain_resistance" },
    { 0x664F, "pain_setflaggedanimknob" },
    { 0x6650, "pain_setflaggedanimknoballrestart" },
    { 0x6651, "pain_setflaggedanimknobrestart" },
    { 0x6652, "pain_test" },
    { 0x6653, "painai" },
    { 0x6654, "painanimlength" },
    { 0x6655, "paindamageincrement" },
    { 0x6656, "paindamageincrementback" },
    { 0x6657, "paindamagemin" },
    { 0x6658, "paindamagestart" },
    { 0x6659, "paindamagetime" },
    { 0x665A, "paindeathnotify" },
    { 0x665B, "painfunction" },
    { 0x665C, "painmanagement" },
    { 0x665D, "painonstairs" },
    { 0x665E, "painpitchdifftolerance" },
    { 0x665F, "paint_grenade_detonate" },
    { 0x6660, "painted" },
    { 0x6661, "painted_tracked" },
    { 0x6662, "paintime" },
    { 0x6663, "paintoutline" },
    { 0x6664, "painyawdiffclosedistsq" },
    { 0x6665, "painyawdiffclosetolerance" },
    { 0x6666, "painyawdifffartolerance" },
    { 0x6667, "pairbattlebuddy" },
    { 0x6668, "palm_anims" },
    { 0x6669, "palm_style_door_open" },
    { 0x666A, "panaramic_screen_fx" },
    { 0x666B, "panel_off" },
    { 0x666C, "panel_on" },
    { 0x666D, "panel_smashed" },
    { 0x666E, "panel_state" },
    { 0x666F, "panic_walla" },
    { 0x6670, "panic_walla_oneshots" },
    { 0x6671, "panned_quad_1_front" },
    { 0x6672, "panned_quad_1_rear" },
    { 0x6673, "panned_quad_2_front" },
    { 0x6674, "panned_quad_2_rear" },
    { 0x6675, "panned_quad_3_front" },
    { 0x6676, "panned_quad_3_rear" },
    { 0x6677, "panoramicfx" },
    { 0x6678, "panzer_delay" },
    { 0x6679, "panzer_ent" },
    { 0x667A, "panzer_ent_offset" },
    { 0x667B, "panzer_node" },
    { 0x667C, "panzer_pos" },
    { 0x667D, "panzer_target" },
    { 0x667E, "parachute_death_monitor" },
    { 0x667F, "parachute_function" },
    { 0x6680, "parachute_movement" },
    { 0x6681, "parachute_notetrack_logic" },
    { 0x6682, "parachute_unload" },
    { 0x6683, "param_map_defaults" },
    { 0x6684, "param_maps" },
    { 0x6685, "param1" },
    { 0x6686, "params" },
    { 0x6687, "params_default" },
    { 0x6688, "parent" },
    { 0x6689, "parent_ent" },
    { 0x668A, "parentcrate" },
    { 0x668B, "parentorigin" },
    { 0x668C, "parking_lot_clear" },
    { 0x668D, "parking_lot_runners" },
    { 0x668E, "parkingalarmcar" },
    { 0x668F, "parkingburkejumpdown" },
    { 0x6690, "parkingguardsreminderdialogue" },
    { 0x6691, "parkinginvestigatorsdialogue" },
    { 0x6692, "parkingreminderdialogue" },
    { 0x6693, "parkingstairskilldialogue" },
    { 0x6694, "parm1" },
    { 0x6695, "parm2" },
    { 0x6696, "parm3" },
    { 0x6697, "parm4" },
    { 0x6698, "parms" },
    { 0x6699, "parse_underwater_triggers" },
    { 0x669A, "parsed" },
    { 0x669B, "parselocationaliases" },
    { 0x669C, "part" },
    { 0x669D, "part_b_mechanism_light_glow_fx" },
    { 0x669E, "part_b_mechanism_light_pulse_fx" },
    { 0x669F, "partciledrylocation" },
    { 0x66A0, "participants" },
    { 0x66A1, "participation" },
    { 0x66A2, "participation_point_cap" },
    { 0x66A3, "participation_point_flattenovertime" },
    { 0x66A4, "particlespawn" },
    { 0x66A5, "particlespawnoriginoffset" },
    { 0x66A6, "particlespray" },
    { 0x66A7, "particlespraymultiplenode" },
    { 0x66A8, "partner" },
    { 0x66A9, "partnerspawning" },
    { 0x66AA, "parts" },
    { 0x66AB, "party_members" },
    { 0x66AC, "partymembers_cb" },
    { 0x66AD, "pass_dot" },
    { 0x66AE, "pass_hovertank_damage_to_player" },
    { 0x66AF, "pass_icon" },
    { 0x66B0, "pass_line_of_sight" },
    { 0x66B1, "pass_mech_melee_damage_to_player" },
    { 0x66B2, "pass_or_throw_active" },
    { 0x66B3, "pass_origin" },
    { 0x66B4, "pass_tappy" },
    { 0x66B5, "pass_target" },
    { 0x66B6, "passenger_2_turret_anim" },
    { 0x66B7, "passenger_2_turret_func" },
    { 0x66B8, "passenger_idle" },
    { 0x66B9, "passenger_shooting" },
    { 0x66BA, "passenger2turret_anime" },
    { 0x66BB, "passkillpickupevent" },
    { 0x66BC, "passoja_death_wait_function" },
    { 0x66BD, "passplayer" },
    { 0x66BE, "passtime" },
    { 0x66BF, "paste_ents" },
    { 0x66C0, "path" },
    { 0x66C1, "path_accel_time" },
    { 0x66C2, "path_chosen" },
    { 0x66C3, "path_deccel_time" },
    { 0x66C4, "path_detour" },
    { 0x66C5, "path_detour_get_detourpath" },
    { 0x66C6, "path_detour_script_origin" },
    { 0x66C7, "path_gate_open" },
    { 0x66C8, "path_gate_wait_till_open" },
    { 0x66C9, "path_gobbler" },
    { 0x66CA, "path_heli" },
    { 0x66CB, "path_idealtime" },
    { 0x66CC, "path_maxspeed" },
    { 0x66CD, "path_mindeccelspeed" },
    { 0x66CE, "path_minspeed" },
    { 0x66CF, "path_nodes" },
    { 0x66D0, "path_solids" },
    { 0x66D1, "path_timeout" },
    { 0x66D2, "path_to_node_at_current_speed" },
    { 0x66D3, "path_to_this_node" },
    { 0x66D4, "path_weight" },
    { 0x66D5, "pathaccel" },
    { 0x66D6, "pathaccelmode" },
    { 0x66D7, "pathchange_candoturnanim" },
    { 0x66D8, "pathchange_cleanupturnanim" },
    { 0x66D9, "pathchange_doturnanim" },
    { 0x66DA, "pathchange_getturnanim" },
    { 0x66DB, "pathchangecheckoverridefunc" },
    { 0x66DC, "pathchangelistener" },
    { 0x66DD, "pathdataavailable" },
    { 0x66DE, "pathdeccel" },
    { 0x66DF, "pathidx" },
    { 0x66E0, "pathinfo_curstartpitch" },
    { 0x66E1, "pathinfo_end_loc" },
    { 0x66E2, "pathinfo_endaim" },
    { 0x66E3, "pathinfo_endpitch" },
    { 0x66E4, "pathinfo_endyaw" },
    { 0x66E5, "pathinfo_len" },
    { 0x66E6, "pathinfo_mode" },
    { 0x66E7, "pathinfo_start_loc" },
    { 0x66E8, "pathinfo_startaim" },
    { 0x66E9, "pathinfo_startpitch" },
    { 0x66EA, "pathinfo_startyaw" },
    { 0x66EB, "pathinfo_t" },
    { 0x66EC, "pathinfo_totalt" },
    { 0x66ED, "pathinfo_velocity" },
    { 0x66EE, "pathing_done" },
    { 0x66EF, "pathmaxrotx" },
    { 0x66F0, "pathmaxrotz" },
    { 0x66F1, "pathrandompercent_reset" },
    { 0x66F2, "pathrandompercent_set" },
    { 0x66F3, "pathrandompercent_zero" },
    { 0x66F4, "pathspeed" },
    { 0x66F5, "pathstartdecceldist" },
    { 0x66F6, "pathtgtspeed" },
    { 0x66F7, "pathturnanimblendtime" },
    { 0x66F8, "pathturnanimoverridefunc" },
    { 0x66F9, "patio_civ_01_cower" },
    { 0x66FA, "patio_civ_03_scream" },
    { 0x66FB, "patio_doors" },
    { 0x66FC, "patio_flashbang" },
    { 0x66FD, "patio_intro_civ_death" },
    { 0x66FE, "patio_male_01_mumble" },
    { 0x66FF, "patrol" },
    { 0x6700, "patrol_01" },
    { 0x6701, "patrol_01_unload_spawn_func" },
    { 0x6702, "patrol_02_unload_spawn_func" },
    { 0x6703, "patrol_03_idle_think" },
    { 0x6704, "patrol_03_unload_spawn_func" },
    { 0x6705, "patrol_04_unload_spawn_func" },
    { 0x6706, "patrol_anim_set" },
    { 0x6707, "patrol_anim_sets" },
    { 0x6708, "patrol_anim_turn180" },
    { 0x6709, "patrol_anims" },
    { 0x670A, "patrol_claimed" },
    { 0x670B, "patrol_creepwalk_unload_spawn_func" },
    { 0x670C, "patrol_do_start_transition_anim" },
    { 0x670D, "patrol_do_stop_transition_anim" },
    { 0x670E, "patrol_end_idle" },
    { 0x670F, "patrol_goal_pos" },
    { 0x6710, "patrol_idle_anim" },
    { 0x6711, "patrol_master" },
    { 0x6712, "patrol_no_stop_transition" },
    { 0x6713, "patrol_pet" },
    { 0x6714, "patrol_post_breach_think" },
    { 0x6715, "patrol_resume_move_start_func" },
    { 0x6716, "patrol_script_animation" },
    { 0x6717, "patrol_scriptedanim" },
    { 0x6718, "patrol_scriptedanims" },
    { 0x6719, "patrol_start" },
    { 0x671A, "patrol_stop" },
    { 0x671B, "patrol_walk_anim" },
    { 0x671C, "patrol_walk_twitch" },
    { 0x671D, "patroller" },
    { 0x671E, "pause_bigmoment_vfx" },
    { 0x671F, "pause_flickerlight" },
    { 0x6720, "pause_oneshot" },
    { 0x6721, "paused" },
    { 0x6722, "pauseeffect" },
    { 0x6723, "pauseexploder" },
    { 0x6724, "pauseexploders" },
    { 0x6725, "pausefxid" },
    { 0x6726, "pausemax" },
    { 0x6727, "pausemin" },
    { 0x6728, "pauseracksystem" },
    { 0x6729, "pausetime" },
    { 0x672A, "pausetimer" },
    { 0x672B, "pausewarbirdenginefxforplayer" },
    { 0x672C, "pausing_bot_connect_monitor" },
    { 0x672D, "pay_machine" },
    { 0x672E, "pbull_callback_crash" },
    { 0x672F, "pbull_callback_from_gas_off_to_rev_hi" },
    { 0x6730, "pbull_callback_from_gas_off_to_rev_low" },
    { 0x6731, "pbull_callback_from_gas_off_to_rev_med" },
    { 0x6732, "pbull_callback_from_reverse_to_reverse_gas_off" },
    { 0x6733, "pbull_callback_from_stopped_to_reverse" },
    { 0x6734, "pbull_callback_gas_off" },
    { 0x6735, "pbull_callback_to_brakes_med" },
    { 0x6736, "pbull_crash_watch" },
    { 0x6737, "pbull_init" },
    { 0x6738, "pbull_is_downshifting" },
    { 0x6739, "pbull_is_reversed" },
    { 0x673A, "pbull_is_revving" },
    { 0x673B, "pbull_is_upshifting" },
    { 0x673C, "pbull_play_reverse_beeps" },
    { 0x673D, "pbull_shift_watch" },
    { 0x673E, "pc_hint_text" },
    { 0x673F, "pc_pitbull_crash" },
    { 0x6740, "pc_pitbull_spawn" },
    { 0x6741, "pc_veh" },
    { 0x6742, "pc_watchstreakuse" },
    { 0x6743, "pcap_drone_opening" },
    { 0x6744, "pcap_pm_rescue" },
    { 0x6745, "pcap_shore_outro" },
    { 0x6746, "pcap_squad_briefing" },
    { 0x6747, "pcap_vo_fus_control_room_burke" },
    { 0x6748, "pcap_vo_fus_control_room_joker" },
    { 0x6749, "pcap_vo_fus_intro_burke" },
    { 0x674A, "pcap_vo_fus_intro_panama_burke" },
    { 0x674B, "pcap_vo_lab_chopper_evac_enter_burke" },
    { 0x674C, "pcap_vo_lab_chopper_evac_enter_cormack" },
    { 0x674D, "pcap_vo_lab_cliff_jump_burke" },
    { 0x674E, "pcap_vo_lab_cliff_rappel_meetup_burke" },
    { 0x674F, "pcap_vo_lab_cliff_rappel_meetup_cormack" },
    { 0x6750, "pcap_vo_lab_cliff_rappel_meetup_knox" },
    { 0x6751, "pcap_vo_lab_intro_guy1" },
    { 0x6752, "pcap_vo_lab_serverroom_burke" },
    { 0x6753, "pcap_vo_lab_serverroom_cormack" },
    { 0x6754, "pcap_vo_lab_serverroom_knox" },
    { 0x6755, "pcap_vo_lab_serverroom_promo_cormack" },
    { 0x6756, "pcap_vo_lab_serverroom_promo_knox" },
    { 0x6757, "pcap_vo_lab_wallclimb_player_hero_01" },
    { 0x6758, "pcap_vo_sanfran_boost_down_burke" },
    { 0x6759, "pcap_vo_sanfran_intro_burke" },
    { 0x675A, "pcap_vo_sanfran_pitbull_crash_burke" },
    { 0x675B, "pcap_vo_sf_b_boosters_cormack" },
    { 0x675C, "pcap_vo_sf_b_bridge_init" },
    { 0x675D, "pcap_vo_sf_b_intro_cormack" },
    { 0x675E, "pcap_vo_sf_b_intro_gideon" },
    { 0x675F, "pd_get_laser_designated_trace" },
    { 0x6760, "pd_laser_designate_target" },
    { 0x6761, "pd_laser_targeting_device" },
    { 0x6762, "pd_monitorlaseroff" },
    { 0x6763, "pd_shouldforcedisablelaser" },
    { 0x6764, "pdrone" },
    { 0x6765, "pdrone_activate" },
    { 0x6766, "pdrone_ai" },
    { 0x6767, "pdrone_ai_deploy" },
    { 0x6768, "pdrone_atlas_init" },
    { 0x6769, "pdrone_can_move_to_point" },
    { 0x676A, "pdrone_can_see_owner_from_point" },
    { 0x676B, "pdrone_can_teleport_to_point" },
    { 0x676C, "pdrone_condition_callback_to_state_deathspin" },
    { 0x676D, "pdrone_condition_callback_to_state_destruct" },
    { 0x676E, "pdrone_condition_callback_to_state_distant" },
    { 0x676F, "pdrone_condition_callback_to_state_flyby" },
    { 0x6770, "pdrone_condition_callback_to_state_flying" },
    { 0x6771, "pdrone_condition_callback_to_state_flyover" },
    { 0x6772, "pdrone_condition_callback_to_state_hover" },
    { 0x6773, "pdrone_condition_callback_to_state_off" },
    { 0x6774, "pdrone_could_be_friendly_fire" },
    { 0x6775, "pdrone_crash_land" },
    { 0x6776, "pdrone_cycle_fire_sound" },
    { 0x6777, "pdrone_damage_function" },
    { 0x6778, "pdrone_deactivate_think" },
    { 0x6779, "pdrone_death_explode" },
    { 0x677A, "pdrone_deploy" },
    { 0x677B, "pdrone_deploy_check" },
    { 0x677C, "pdrone_deploy_hint" },
    { 0x677D, "pdrone_emp_death" },
    { 0x677E, "pdrone_fire_at_enemy" },
    { 0x677F, "pdrone_fire_finished" },
    { 0x6780, "pdrone_fire_request" },
    { 0x6781, "pdrone_fire_weapon" },
    { 0x6782, "pdrone_flying_fx" },
    { 0x6783, "pdrone_get_nodes_in_radius" },
    { 0x6784, "pdrone_gunshot_teammate" },
    { 0x6785, "pdrone_handle_death" },
    { 0x6786, "pdrone_launch" },
    { 0x6787, "pdrone_launched" },
    { 0x6788, "pdrone_marked_state" },
    { 0x6789, "pdrone_monitor_death" },
    { 0x678A, "pdrone_movement_follow" },
    { 0x678B, "pdrone_movement_follow_buddy" },
    { 0x678C, "pdrone_movement_go_to_point" },
    { 0x678D, "pdrone_notify_explosion" },
    { 0x678E, "pdrone_orient_to_closest_ai_target" },
    { 0x678F, "pdrone_orient_to_closest_ent_target" },
    { 0x6790, "pdrone_orient_to_closest_target" },
    { 0x6791, "pdrone_parms" },
    { 0x6792, "pdrone_player_add_ent_target" },
    { 0x6793, "pdrone_player_add_vehicle_target" },
    { 0x6794, "pdrone_player_callback_look" },
    { 0x6795, "pdrone_player_collision_monitor" },
    { 0x6796, "pdrone_player_condition_callback_to_state_flying" },
    { 0x6797, "pdrone_player_condition_callback_to_state_hover" },
    { 0x6798, "pdrone_player_condition_callback_to_state_idle" },
    { 0x6799, "pdrone_player_condition_callback_to_state_looking" },
    { 0x679A, "pdrone_player_death" },
    { 0x679B, "pdrone_player_enter" },
    { 0x679C, "pdrone_player_exit" },
    { 0x679D, "pdrone_player_force_exit" },
    { 0x679E, "pdrone_player_get_current_fov" },
    { 0x679F, "pdrone_player_init" },
    { 0x67A0, "pdrone_player_is_driving" },
    { 0x67A1, "pdrone_player_loop" },
    { 0x67A2, "pdrone_player_spawn" },
    { 0x67A3, "pdrone_player_use" },
    { 0x67A4, "pdrone_return" },
    { 0x67A5, "pdrone_return_pathing" },
    { 0x67A6, "pdrone_security_condition_callback_to_state_deathspin" },
    { 0x67A7, "pdrone_security_condition_callback_to_state_destruct" },
    { 0x67A8, "pdrone_security_condition_callback_to_state_distant" },
    { 0x67A9, "pdrone_security_condition_callback_to_state_flyby" },
    { 0x67AA, "pdrone_security_condition_callback_to_state_flying" },
    { 0x67AB, "pdrone_security_condition_callback_to_state_flyover" },
    { 0x67AC, "pdrone_security_condition_callback_to_state_hover" },
    { 0x67AD, "pdrone_security_condition_callback_to_state_off" },
    { 0x67AE, "pdrone_security_speed_modifier_callback_linear" },
    { 0x67AF, "pdrone_security_speed_modifier_callback_perlin_noise" },
    { 0x67B0, "pdrone_security_speed_modifier_callback_smoother" },
    { 0x67B1, "pdrone_should_hold_fire" },
    { 0x67B2, "pdrone_speed_modifier_callback_linear" },
    { 0x67B3, "pdrone_speed_modifier_callback_perlin_noise" },
    { 0x67B4, "pdrone_speed_modifier_callback_smoother" },
    { 0x67B5, "pdrone_swarm_condition_callback_to_state_distant" },
    { 0x67B6, "pdrone_swarm_condition_callback_to_state_flying" },
    { 0x67B7, "pdrone_swarm_condition_callback_to_state_hover" },
    { 0x67B8, "pdrone_targeting" },
    { 0x67B9, "pdrone_update_threat_sensor" },
    { 0x67BA, "pdroneactive" },
    { 0x67BB, "pdronereturning" },
    { 0x67BC, "peekout" },
    { 0x67BD, "penalty_timer" },
    { 0x67BE, "pendingreinforcementavailable" },
    { 0x67BF, "penthouse_begin" },
    { 0x67C0, "penthouse_main" },
    { 0x67C1, "penthouse_objective" },
    { 0x67C2, "penthouse_reinforcements_01_guy_01_vo" },
    { 0x67C3, "penthouse_reinforcements_01_guy_02_vo" },
    { 0x67C4, "penthouse_reinforcements_02_guy_01_vo" },
    { 0x67C5, "penthouse_reinforcements_02_guy_02_vo" },
    { 0x67C6, "penthouse_start" },
    { 0x67C7, "penthouse_vo" },
    { 0x67C8, "percent" },
    { 0x67C9, "percentchance" },
    { 0x67CA, "perch_runner" },
    { 0x67CB, "perch_spot_wave" },
    { 0x67CC, "perelementswap" },
    { 0x67CD, "perferred_crash_location" },
    { 0x67CE, "perforing_color_driven_anim" },
    { 0x67CF, "perk_deleteondeath" },
    { 0x67D0, "perkfuncs" },
    { 0x67D1, "perkicon" },
    { 0x67D2, "perkname" },
    { 0x67D3, "perkoutlined" },
    { 0x67D4, "perksetfuncs" },
    { 0x67D5, "perksperkname" },
    { 0x67D6, "perksperkpower" },
    { 0x67D7, "perksuseslot" },
    { 0x67D8, "perkunsetfuncs" },
    { 0x67D9, "perkusedeathtracker" },
    { 0x67DA, "perlin_flickering_light" },
    { 0x67DB, "permanentcustommovetransition" },
    { 0x67DC, "persist" },
    { 0x67DD, "persistentdatainfo" },
    { 0x67DE, "persistentdebugline" },
    { 0x67DF, "personalcoldbreath" },
    { 0x67E0, "personalcoldbreathspawner" },
    { 0x67E1, "personalcoldbreathstop" },
    { 0x67E2, "personality" },
    { 0x67E3, "personality_init_function" },
    { 0x67E4, "personality_update_function" },
    { 0x67E5, "personalitymanuallyset" },
    { 0x67E6, "personalradar" },
    { 0x67E7, "personalsighttime" },
    { 0x67E8, "personalusebar" },
    { 0x67E9, "pet_debug_positions" },
    { 0x67EA, "pet_patrol" },
    { 0x67EB, "pet_patrol_create_positions" },
    { 0x67EC, "pet_patrol_get_available_origin" },
    { 0x67ED, "pet_patrol_handle_move_state" },
    { 0x67EE, "pet_patrol_handle_movespeed" },
    { 0x67EF, "pet_patrol_init_positions" },
    { 0x67F0, "phone" },
    { 0x67F1, "phone_conversation" },
    { 0x67F2, "photo_copier" },
    { 0x67F3, "photo_copier_copy_bar_goes" },
    { 0x67F4, "photo_copier_init" },
    { 0x67F5, "photo_copier_light_on" },
    { 0x67F6, "photo_copier_no_light" },
    { 0x67F7, "photo_copier_stop" },
    { 0x67F8, "photo_light_flicker" },
    { 0x67F9, "phrase" },
    { 0x67FA, "physical_output" },
    { 0x67FB, "physics_bodies_off" },
    { 0x67FC, "physics_bodies_on" },
    { 0x67FD, "physics_crash" },
    { 0x67FE, "physics_gravity_vector" },
    { 0x67FF, "physics_impact_watch" },
    { 0x6800, "physics_launch" },
    { 0x6801, "physics_launch_with_impulse" },
    { 0x6802, "physics_object_create" },
    { 0x6803, "physics_object_remove" },
    { 0x6804, "physics_pulse_on" },
    { 0x6805, "physicsjolt_proximity" },
    { 0x6806, "physicssphereforce" },
    { 0x6807, "physicssphereradius" },
    { 0x6808, "physicswaiter" },
    { 0x6809, "pianodamagethink" },
    { 0x680A, "pianothink" },
    { 0x680B, "pick_best_gear" },
    { 0x680C, "pick_player_location_vol" },
    { 0x680D, "pick_target_nag_dialogue" },
    { 0x680E, "pickedupweaponfrom" },
    { 0x680F, "pickinstinctdogspawnpoint" },
    { 0x6810, "picknewtarget" },
    { 0x6811, "pickup_allowed" },
    { 0x6812, "pickup_goal_ang" },
    { 0x6813, "pickup_gun" },
    { 0x6814, "pickup_message_deleted" },
    { 0x6815, "pickup_stinger" },
    { 0x6816, "pickupbounce" },
    { 0x6817, "pickupent" },
    { 0x6818, "pickupobjectdelay" },
    { 0x6819, "pickupstartflashing" },
    { 0x681A, "pickuptimeout" },
    { 0x681B, "pickuptimer" },
    { 0x681C, "pickuptrigger" },
    { 0x681D, "pieces" },
    { 0x681E, "pigeons_camera_view_zone3000" },
    { 0x681F, "pigeons_flock_takeoff" },
    { 0x6820, "pigeons_flyoff_alley1" },
    { 0x6821, "pigeons_ledges_react_roundabout" },
    { 0x6822, "pigeons_rail_react_intro" },
    { 0x6823, "pilot" },
    { 0x6824, "pilot_intro" },
    { 0x6825, "ping_fx" },
    { 0x6826, "pingstate" },
    { 0x6827, "pipe" },
    { 0x6828, "pipe_calc_ballistic" },
    { 0x6829, "pipe_calc_nofx" },
    { 0x682A, "pipe_calc_splash" },
    { 0x682B, "pipe_damage" },
    { 0x682C, "pipe_fx_array" },
    { 0x682D, "pipe_logic" },
    { 0x682E, "pipe_wait_loop" },
    { 0x682F, "pipefx" },
    { 0x6830, "pipes_init" },
    { 0x6831, "pipesdamage" },
    { 0x6832, "pipesetup" },
    { 0x6833, "pistolshoot" },
    { 0x6834, "pitbull_atlas_impact" },
    { 0x6835, "pitbull_atlas_impact_initial" },
    { 0x6836, "pitbull_back_to_speed" },
    { 0x6837, "pitbull_crash_impact_fx" },
    { 0x6838, "pitbull_crash_jump_start" },
    { 0x6839, "pitbull_crash_sound_design" },
    { 0x683A, "pitbull_crash_swap_to_real_model" },
    { 0x683B, "pitbull_crashed_dof" },
    { 0x683C, "pitbull_drive_dof" },
    { 0x683D, "pitbull_flipped_failsafe" },
    { 0x683E, "pitbull_headlights_off" },
    { 0x683F, "pitbull_headlights_on" },
    { 0x6840, "pitbull_hide_part" },
    { 0x6841, "pitbull_impact_blur" },
    { 0x6842, "pitbull_impact_blur_long" },
    { 0x6843, "pitbull_impact_fx" },
    { 0x6844, "pitbull_intro_animation" },
    { 0x6845, "pitbull_intro_control_rumble" },
    { 0x6846, "pitbull_intro_foley_ui" },
    { 0x6847, "pitbull_land_upside_down" },
    { 0x6848, "pitbull_play_lui_cinematic" },
    { 0x6849, "pitbull_roof_impact" },
    { 0x684A, "pitbull_rumble" },
    { 0x684B, "pitbull_rumble_stop" },
    { 0x684C, "pitbull_second_impact" },
    { 0x684D, "pitbull_show_part" },
    { 0x684E, "pitbull_start_flip" },
    { 0x684F, "pitbull_turret_aim" },
    { 0x6850, "pitbull_turret_fire" },
    { 0x6851, "pitbull_turret_set_target" },
    { 0x6852, "pitbull_turret_targeting" },
    { 0x6853, "pitbull_update_hud_brightness" },
    { 0x6854, "pitbull_update_lui_charge" },
    { 0x6855, "pitbull_vehicle_collision_rumble" },
    { 0x6856, "pitbulldestroyedanimation" },
    { 0x6857, "pitch" },
    { 0x6858, "pitch_map_name" },
    { 0x6859, "pitch_rate" },
    { 0x685A, "pitch_time" },
    { 0x685B, "pitching_hard" },
    { 0x685C, "pitching_hard_start_time" },
    { 0x685D, "pivot" },
    { 0x685E, "place" },
    { 0x685F, "place_foam_bomb" },
    { 0x6860, "place_weapon_on" },
    { 0x6861, "placeableconfigs" },
    { 0x6862, "placedsfx" },
    { 0x6863, "placeiedrumblelight" },
    { 0x6864, "placement" },
    { 0x6865, "placementheighttolerance" },
    { 0x6866, "placementlinkentity" },
    { 0x6867, "placementoffsetz" },
    { 0x6868, "placementok" },
    { 0x6869, "placementorigin" },
    { 0x686A, "placementradius" },
    { 0x686B, "placestring" },
    { 0x686C, "placeweaponon" },
    { 0x686D, "placingitemstreakname" },
    { 0x686E, "placingsentry" },
    { 0x686F, "plagueevent" },
    { 0x6870, "plane" },
    { 0x6871, "plane_bomb_cluster" },
    { 0x6872, "plane_bomb_node" },
    { 0x6873, "plane_chase_cam" },
    { 0x6874, "plane_expl_gloves" },
    { 0x6875, "plane_health_monitor" },
    { 0x6876, "plane_health_regen" },
    { 0x6877, "plane_in_formation" },
    { 0x6878, "plane_init" },
    { 0x6879, "plane_intialized" },
    { 0x687A, "plane_sound_node" },
    { 0x687B, "plane_sound_players" },
    { 0x687C, "plane_spots" },
    { 0x687D, "plane_test" },
    { 0x687E, "planeanimatepath" },
    { 0x687F, "planemodel" },
    { 0x6880, "planeplayeffects" },
    { 0x6881, "planes" },
    { 0x6882, "planning_fail" },
    { 0x6883, "plant_emp" },
    { 0x6884, "plant_emp_setup" },
    { 0x6885, "plant_emp_trigger" },
    { 0x6886, "plant_foam_nag_dialogue" },
    { 0x6887, "plant_tracker_begin" },
    { 0x6888, "plant_tracker_debug_checkpoint" },
    { 0x6889, "plant_tracker_light_model_swap" },
    { 0x688A, "plant_tracker_main" },
    { 0x688B, "plant_tracker_objective" },
    { 0x688C, "plant_tracker_rumbles" },
    { 0x688D, "plant_tracker_start" },
    { 0x688E, "plant_tracker_vo" },
    { 0x688F, "plant_tracker_waits" },
    { 0x6890, "planttime" },
    { 0x6891, "platform_door_think" },
    { 0x6892, "platformmatches" },
    { 0x6893, "play_2d_reverb_alarm_sound" },
    { 0x6894, "play_aim_anim" },
    { 0x6895, "play_ally_callout_vo" },
    { 0x6896, "play_ally_warning_vo" },
    { 0x6897, "play_and_store_fx_on_tag" },
    { 0x6898, "play_anim_and_delete" },
    { 0x6899, "play_anim_on_trigger" },
    { 0x689A, "play_announcment_over_pa" },
    { 0x689B, "play_arm_room_dialog" },
    { 0x689C, "play_arm_room_dialog_nag" },
    { 0x689D, "play_back_thruster_light_rz" },
    { 0x689E, "play_backout_sound_breath" },
    { 0x689F, "play_backout_sound_heartbeat" },
    { 0x68A0, "play_base_radio_dialog1" },
    { 0x68A1, "play_base_soldier_group_dialog" },
    { 0x68A2, "play_bike_gesture" },
    { 0x68A3, "play_blood_fx_when_shot" },
    { 0x68A4, "play_blood_pool" },
    { 0x68A5, "play_boost_sound" },
    { 0x68A6, "play_boosters_off_anim" },
    { 0x68A7, "play_bridge_lb_sentinel_flyby" },
    { 0x68A8, "play_building_jump_1_scene" },
    { 0x68A9, "play_camera_shake_tour_ride" },
    { 0x68AA, "play_canopy_bink" },
    { 0x68AB, "play_canopy_closed_bink" },
    { 0x68AC, "play_centroid_switch_floor3" },
    { 0x68AD, "play_centroid_switch_top" },
    { 0x68AE, "play_character_microwave_sparks" },
    { 0x68AF, "play_charged_shot_fx" },
    { 0x68B0, "play_chyron_video" },
    { 0x68B1, "play_cinematic" },
    { 0x68B2, "play_civilian_dialog" },
    { 0x68B3, "play_cliff_rappel_animation" },
    { 0x68B4, "play_combat_state" },
    { 0x68B5, "play_courtyard_hangar_door_rpg" },
    { 0x68B6, "play_credits" },
    { 0x68B7, "play_death_explosion_fx" },
    { 0x68B8, "play_deploy_scene_handcuff_ents" },
    { 0x68B9, "play_detpack_plant_sound" },
    { 0x68BA, "play_dialog" },
    { 0x68BB, "play_dialog_boost" },
    { 0x68BC, "play_dialog_boost_block_chatter" },
    { 0x68BD, "play_dialog_boost_block_mission" },
    { 0x68BE, "play_dialog_boost_block_nag" },
    { 0x68BF, "play_dialog_bridge" },
    { 0x68C0, "play_dialog_bridge_block_crash" },
    { 0x68C1, "play_dialog_bridge_block_crawl" },
    { 0x68C2, "play_dialog_confrontation_block_go" },
    { 0x68C3, "play_dialog_confrontation_block_leave" },
    { 0x68C4, "play_dialog_confrontation_block_mrx" },
    { 0x68C5, "play_dialog_intro" },
    { 0x68C6, "play_dialog_intro_block_cargo" },
    { 0x68C7, "play_dialog_intro_block_fleet" },
    { 0x68C8, "play_dialog_oncoming" },
    { 0x68C9, "play_dialog_oncoming_block_converging" },
    { 0x68CA, "play_dialog_oncoming_block_knocked" },
    { 0x68CB, "play_dialog_street" },
    { 0x68CC, "play_dialog_street_block_assist" },
    { 0x68CD, "play_dialog_street_block_boost_incoming" },
    { 0x68CE, "play_dialog_street_block_boosters" },
    { 0x68CF, "play_dialog_street_block_cover" },
    { 0x68D0, "play_dialog_street_block_foot" },
    { 0x68D1, "play_dialog_street_block_friendlies" },
    { 0x68D2, "play_dialog_street_block_helo" },
    { 0x68D3, "play_dialog_street_block_hurry" },
    { 0x68D4, "play_dialog_street_block_pitbull" },
    { 0x68D5, "play_dialog_street_block_sitrep" },
    { 0x68D6, "play_dialog_street_block_van_stop" },
    { 0x68D7, "play_dialog_tunnel" },
    { 0x68D8, "play_dialog_tunnel_block_bus" },
    { 0x68D9, "play_dialog_tunnel_block_chase" },
    { 0x68DA, "play_dialog_tunnel_block_construction" },
    { 0x68DB, "play_dialog_tunnel_block_tanker" },
    { 0x68DC, "play_dialog_tunnel_block_update" },
    { 0x68DD, "play_dialog_van" },
    { 0x68DE, "play_dialog_van_arrest" },
    { 0x68DF, "play_dialog_van_check" },
    { 0x68E0, "play_dialog_van_collapse" },
    { 0x68E1, "play_dialog_van_deploy" },
    { 0x68E2, "play_dialogue" },
    { 0x68E3, "play_dialogue_boat" },
    { 0x68E4, "play_dialogue_boat_block_close" },
    { 0x68E5, "play_dialogue_boat_block_dive" },
    { 0x68E6, "play_dialogue_boat_block_grapple" },
    { 0x68E7, "play_dialogue_boat_block_intro" },
    { 0x68E8, "play_dialogue_boat_block_missiles" },
    { 0x68E9, "play_dialogue_boat_block_ramp" },
    { 0x68EA, "play_dialogue_climb" },
    { 0x68EB, "play_dialogue_climb_block_boatexit" },
    { 0x68EC, "play_dialogue_climb_block_bridge" },
    { 0x68ED, "play_dialogue_climb_block_careful" },
    { 0x68EE, "play_dialogue_climb_block_climb" },
    { 0x68EF, "play_dialogue_climb_block_contact" },
    { 0x68F0, "play_dialogue_climb_block_containers" },
    { 0x68F1, "play_dialogue_climb_block_crane" },
    { 0x68F2, "play_dialogue_climb_block_cross" },
    { 0x68F3, "play_dialogue_climb_block_drop" },
    { 0x68F4, "play_dialogue_climb_block_grapple1" },
    { 0x68F5, "play_dialogue_climb_block_grapple2" },
    { 0x68F6, "play_dialogue_climb_block_grapple3" },
    { 0x68F7, "play_dialogue_climb_block_ledge" },
    { 0x68F8, "play_dialogue_climb_block_tower" },
    { 0x68F9, "play_dialogue_climb_block_way" },
    { 0x68FA, "play_dialogue_climb_crane_nag" },
    { 0x68FB, "play_dialogue_climb_grapple_nag" },
    { 0x68FC, "play_dialogue_confrontation" },
    { 0x68FD, "play_dialogue_crane_block_go" },
    { 0x68FE, "play_dialogue_crane_block_jump" },
    { 0x68FF, "play_dialogue_crane_block_slide" },
    { 0x6900, "play_dialogue_crane_block_start" },
    { 0x6901, "play_dialogue_docks" },
    { 0x6902, "play_dialogue_docks_backtrack" },
    { 0x6903, "play_dialogue_docks_block_boat" },
    { 0x6904, "play_dialogue_docks_block_boatnag" },
    { 0x6905, "play_dialogue_docks_block_intro" },
    { 0x6906, "play_dialogue_escape" },
    { 0x6907, "play_dialogue_escape_block_announce" },
    { 0x6908, "play_dialogue_escape_block_climb" },
    { 0x6909, "play_dialogue_escape_block_deadend" },
    { 0x690A, "play_dialogue_escape_block_guarddoor" },
    { 0x690B, "play_dialogue_escape_block_intros" },
    { 0x690C, "play_dialogue_escape_block_swarm" },
    { 0x690D, "play_dialogue_office" },
    { 0x690E, "play_dialogue_office_block_baghdad" },
    { 0x690F, "play_dialogue_office_block_congrats" },
    { 0x6910, "play_dialogue_office_block_door" },
    { 0x6911, "play_dialogue_office_block_guard" },
    { 0x6912, "play_dialogue_office_block_kva" },
    { 0x6913, "play_dialogue_oldtown" },
    { 0x6914, "play_dialogue_oldtown_block_contact" },
    { 0x6915, "play_dialogue_oldtown_block_naglines" },
    { 0x6916, "play_dialogue_oldtown_player_spotted" },
    { 0x6917, "play_dialogue_roof" },
    { 0x6918, "play_dialogue_roof_block_alert" },
    { 0x6919, "play_dialogue_roof_block_away" },
    { 0x691A, "play_dialogue_roof_block_fall" },
    { 0x691B, "play_dialogue_roof_block_gates" },
    { 0x691C, "play_dialogue_roof_block_jump" },
    { 0x691D, "play_dialogue_roof_block_run" },
    { 0x691E, "play_dialogue_sewer" },
    { 0x691F, "play_dialogue_sewer_block_announcement" },
    { 0x6920, "play_dialogue_sewer_block_checkpoint" },
    { 0x6921, "play_dialogue_sewer_block_guards" },
    { 0x6922, "play_dialogue_swim" },
    { 0x6923, "play_dialogue_swim_block_cough" },
    { 0x6924, "play_dialogue_swim_block_sewer" },
    { 0x6925, "play_dilaogue_docks_block_ast" },
    { 0x6926, "play_doctor_pip" },
    { 0x6927, "play_drone_range_dialog1" },
    { 0x6928, "play_drone_range_dialog2" },
    { 0x6929, "play_drone_range_dialog3" },
    { 0x692A, "play_dust" },
    { 0x692B, "play_earthquake_rumble" },
    { 0x692C, "play_earthquake_rumble_for_all_players" },
    { 0x692D, "play_emp_audio" },
    { 0x692E, "play_emp_nag_lines" },
    { 0x692F, "play_emp_reboot_bik" },
    { 0x6930, "play_entire_interactive_pod_exit" },
    { 0x6931, "play_environment_microwave_sparks" },
    { 0x6932, "play_event_music" },
    { 0x6933, "play_exo_hover_vfx" },
    { 0x6934, "play_exo_repair_movement_sound" },
    { 0x6935, "play_exo_room_dialog1" },
    { 0x6936, "play_exo_room_dialog1_nag" },
    { 0x6937, "play_exo_room_dialog2" },
    { 0x6938, "play_exo_room_techs_dialog1" },
    { 0x6939, "play_exo_room_techs_dialog2" },
    { 0x693A, "play_explosion_sound_drone_success" },
    { 0x693B, "play_falling_snow" },
    { 0x693C, "play_finale_low_burn" },
    { 0x693D, "play_finale_silo_blue" },
    { 0x693E, "play_finale_silo_center" },
    { 0x693F, "play_finale_silo_end_cine" },
    { 0x6940, "play_finale_silo_neutral" },
    { 0x6941, "play_finale_silo_orange" },
    { 0x6942, "play_finale_silo_orange_approach" },
    { 0x6943, "play_finale_silo_round_tunnel" },
    { 0x6944, "play_finale_silo_yellow" },
    { 0x6945, "play_flickering_bridge_light" },
    { 0x6946, "play_flickering_fire_light" },
    { 0x6947, "play_flickering_hanger_light" },
    { 0x6948, "play_flickering_info_hallway_light" },
    { 0x6949, "play_flickering_info_light" },
    { 0x694A, "play_flickering_interior_light" },
    { 0x694B, "play_flickering_light_school_01" },
    { 0x694C, "play_flickering_light_school_03" },
    { 0x694D, "play_flickerlight_motion_preset" },
    { 0x694E, "play_flickerlight_preset" },
    { 0x694F, "play_front_thruster_light_rz" },
    { 0x6950, "play_fullscreen_blood_splatter" },
    { 0x6951, "play_fullscreen_dirt" },
    { 0x6952, "play_fullscreen_mist" },
    { 0x6953, "play_funeral_dialog" },
    { 0x6954, "play_fx_attached_to_actor" },
    { 0x6955, "play_fx_attached_to_chain" },
    { 0x6956, "play_fx_on_actor" },
    { 0x6957, "play_fx_on_chain" },
    { 0x6958, "play_fx_with_handle" },
    { 0x6959, "play_fxlighting_fx" },
    { 0x695A, "play_garage_bike_dismount" },
    { 0x695B, "play_goliath_death_fx" },
    { 0x695C, "play_grapple_anim" },
    { 0x695D, "play_grenade_range_dialog1" },
    { 0x695E, "play_grenade_range_dialog2" },
    { 0x695F, "play_grenade_range_dialog3" },
    { 0x6960, "play_grenade_range_dialog4" },
    { 0x6961, "play_grenade_range_dialog5" },
    { 0x6962, "play_hit_reaction" },
    { 0x6963, "play_hostage_vehicle_pip" },
    { 0x6964, "play_hotel_exit_adaptive_music" },
    { 0x6965, "play_idle_anim" },
    { 0x6966, "play_idle_back_thruster_rz" },
    { 0x6967, "play_idle_front_thruster_rz" },
    { 0x6968, "play_idle_tread_front_rz" },
    { 0x6969, "play_ilana_vo" },
    { 0x696A, "play_insufficient_lethal_energy_sfx" },
    { 0x696B, "play_insufficient_tactical_energy_sfx" },
    { 0x696C, "play_interior_dialogue" },
    { 0x696D, "play_interval_sound" },
    { 0x696E, "play_irons_bink" },
    { 0x696F, "play_irons_pip" },
    { 0x6970, "play_jammer_1_anim" },
    { 0x6971, "play_jammer_2_anim" },
    { 0x6972, "play_jump_out_anim" },
    { 0x6973, "play_jump_out_of_heli_rumble" },
    { 0x6974, "play_lab_reactor_pip" },
    { 0x6975, "play_lensflare_subway_int_off" },
    { 0x6976, "play_lensflare_subway_int_on" },
    { 0x6977, "play_loop_sound_on_destructible" },
    { 0x6978, "play_loop_sound_on_entity" },
    { 0x6979, "play_loop_sound_on_tag" },
    { 0x697A, "play_loop_until_drop_distance" },
    { 0x697B, "play_loop_until_message" },
    { 0x697C, "play_looping_beep_on_player" },
    { 0x697D, "play_loopsound_in_space" },
    { 0x697E, "play_maglev_train_path" },
    { 0x697F, "play_microwave_physics" },
    { 0x6980, "play_microwave_sparkfx" },
    { 0x6981, "play_missile_whoosh_thread" },
    { 0x6982, "play_mode" },
    { 0x6983, "play_monitor_cinematic" },
    { 0x6984, "play_mwp_sinkhole_forceshadows" },
    { 0x6985, "play_new_and_kill_old_fx_l" },
    { 0x6986, "play_new_and_kill_old_fx_r" },
    { 0x6987, "play_new_idle" },
    { 0x6988, "play_out_of_bounds_vo" },
    { 0x6989, "play_pa_dialog_reset" },
    { 0x698A, "play_pa_exo_dialog1" },
    { 0x698B, "play_pa_exo_dialog2" },
    { 0x698C, "play_pa_street_dialog1" },
    { 0x698D, "play_pain_sound" },
    { 0x698E, "play_persistent_fx_on_screen" },
    { 0x698F, "play_pitbull_add_idle" },
    { 0x6990, "play_pitbull_anim" },
    { 0x6991, "play_pitbull_camera_anim" },
    { 0x6992, "play_pitbull_camera_speed_anim" },
    { 0x6993, "play_pitbull_gear_shift_anim" },
    { 0x6994, "play_pitbull_speed_anim" },
    { 0x6995, "play_pitbull_steer_anim" },
    { 0x6996, "play_pm_rescue_walla" },
    { 0x6997, "play_pulse_light" },
    { 0x6998, "play_pulse_preset" },
    { 0x6999, "play_railgun_fx" },
    { 0x699A, "play_rappel_pip" },
    { 0x699B, "play_reactive_fx" },
    { 0x699C, "play_ready_room_dialog1" },
    { 0x699D, "play_ready_room_dialog2" },
    { 0x699E, "play_ready_room_dialog3" },
    { 0x699F, "play_ready_room_dialog4" },
    { 0x69A0, "play_ready_room_elevator_nag" },
    { 0x69A1, "play_ready_up_anim" },
    { 0x69A2, "play_regular_back_thruster_rz" },
    { 0x69A3, "play_regular_front_thruster_rz" },
    { 0x69A4, "play_regular_tail_thruster_rz" },
    { 0x69A5, "play_regular_tread_back_rz" },
    { 0x69A6, "play_regular_tread_front_rz" },
    { 0x69A7, "play_reload_buzz" },
    { 0x69A8, "play_reload_malfunction" },
    { 0x69A9, "play_reload_malfunction_on_next_reload" },
    { 0x69AA, "play_rest_anim" },
    { 0x69AB, "play_rumble_arm_repair" },
    { 0x69AC, "play_rumble_elevator" },
    { 0x69AD, "play_rumble_funeral_gun_salute" },
    { 0x69AE, "play_rumble_jeep_ride" },
    { 0x69AF, "play_rumble_on_entity" },
    { 0x69B0, "play_rumble_training_s1_mute_breach" },
    { 0x69B1, "play_rumble_training_s1_president_load_fail" },
    { 0x69B2, "play_rumble_training_s1_reload_malfunction" },
    { 0x69B3, "play_rumble_training_s2_president_load" },
    { 0x69B4, "play_rumble_walker_tank" },
    { 0x69B5, "play_s_flicker_fluo_jump2_shadow_on" },
    { 0x69B6, "play_s_flicker_jb1" },
    { 0x69B7, "play_s_flicker_jb2" },
    { 0x69B8, "play_s_flicker_sh" },
    { 0x69B9, "play_seoul_videolog" },
    { 0x69BA, "play_shooting_range_dialog_friendlies" },
    { 0x69BB, "play_shooting_range_dialog_overdrive" },
    { 0x69BC, "play_shooting_range_dialog1" },
    { 0x69BD, "play_shooting_range_dialog1_nag" },
    { 0x69BE, "play_shooting_range_dialog2" },
    { 0x69BF, "play_shooting_range_dialog2_nag" },
    { 0x69C0, "play_shooting_range_dialog3" },
    { 0x69C1, "play_shooting_range_dialog4" },
    { 0x69C2, "play_shooting_range_dialogue_sequence" },
    { 0x69C3, "play_soul_intro_movie" },
    { 0x69C4, "play_sound" },
    { 0x69C5, "play_sound_in_space" },
    { 0x69C6, "play_sound_in_space_with_angles" },
    { 0x69C7, "play_sound_on_entity" },
    { 0x69C8, "play_sound_on_tag" },
    { 0x69C9, "play_sound_on_tag_endon_death" },
    { 0x69CA, "play_sound_stop_on_notify" },
    { 0x69CB, "play_squad_gesture" },
    { 0x69CC, "play_tennis_court_vo" },
    { 0x69CD, "play_throw_anim" },
    { 0x69CE, "play_thruster_amount_given_tag" },
    { 0x69CF, "play_thruster_rotation" },
    { 0x69D0, "play_tour_start_dialog1" },
    { 0x69D1, "play_tower_debris_fx" },
    { 0x69D2, "play_tracking_grenade_impacts" },
    { 0x69D3, "play_training_s1_flag_vo_training_s1_joker_prophet_approaching" },
    { 0x69D4, "play_training_s1_gideon_jeep_nag" },
    { 0x69D5, "play_training_s1_joker_clear_room" },
    { 0x69D6, "play_training_s1_joker_close_kitchen" },
    { 0x69D7, "play_training_s1_joker_dammit" },
    { 0x69D8, "play_training_s1_joker_dont_engage" },
    { 0x69D9, "play_training_s1_joker_drop_em" },
    { 0x69DA, "play_training_s1_joker_everyone_knows" },
    { 0x69DB, "play_training_s1_joker_go_go" },
    { 0x69DC, "play_training_s1_joker_good_kill" },
    { 0x69DD, "play_training_s1_joker_hit_em" },
    { 0x69DE, "play_training_s1_joker_hit_em_mitchell" },
    { 0x69DF, "play_training_s1_joker_mr_president" },
    { 0x69E0, "play_training_s1_joker_mute_charge" },
    { 0x69E1, "play_training_s1_joker_mute_charge_nag" },
    { 0x69E2, "play_training_s1_joker_ok_move" },
    { 0x69E3, "play_training_s1_joker_on_you" },
    { 0x69E4, "play_training_s1_joker_our_ride" },
    { 0x69E5, "play_training_s1_joker_patrol_approaching" },
    { 0x69E6, "play_training_s1_joker_pools_clear" },
    { 0x69E7, "play_training_s1_joker_pools_clear_stealth" },
    { 0x69E8, "play_training_s1_joker_poppin_smoke" },
    { 0x69E9, "play_training_s1_joker_ride_nag" },
    { 0x69EA, "play_training_s1_joker_spotted_us" },
    { 0x69EB, "play_training_s1_joker_stack_up" },
    { 0x69EC, "play_training_s1_joker_take_out" },
    { 0x69ED, "play_training_s1_joker_take_out_nag" },
    { 0x69EE, "play_training_s1_joker_threat_grenade" },
    { 0x69EF, "play_training_s1_joker_two_terrace" },
    { 0x69F0, "play_training_s1_joker_were_clear" },
    { 0x69F1, "play_training_s1_kva_what" },
    { 0x69F2, "play_training_s1_prophet_tracking_potus" },
    { 0x69F3, "play_training_s1_reload_malfunctions" },
    { 0x69F4, "play_training_s1_rivers_clear" },
    { 0x69F5, "play_training_s1_rivers_contact_below" },
    { 0x69F6, "play_training_s1_rivers_got_another" },
    { 0x69F7, "play_training_s1_rivers_got_drones" },
    { 0x69F8, "play_training_s1_rivers_hostiles_road" },
    { 0x69F9, "play_training_s1_rivers_multiple_hostiles" },
    { 0x69FA, "play_training_s1_rivers_pools_clear" },
    { 0x69FB, "play_training_s1_rivers_room_clear" },
    { 0x69FC, "play_training_s1_shit_clear" },
    { 0x69FD, "play_training_s1_wrong_grenade" },
    { 0x69FE, "play_training_s2_gideon_clear_move" },
    { 0x69FF, "play_training_s2_gideon_dont_let_up" },
    { 0x6A00, "play_training_s2_gideon_drone_down" },
    { 0x6A01, "play_training_s2_gideon_go_go" },
    { 0x6A02, "play_training_s2_gideon_hit_door_nag" },
    { 0x6A03, "play_training_s2_gideon_media_room" },
    { 0x6A04, "play_training_s2_gideon_mitchell_assault_drone" },
    { 0x6A05, "play_training_s2_gideon_mitchell_assault_drone_nag" },
    { 0x6A06, "play_training_s2_gideon_mitchell_secure_nag" },
    { 0x6A07, "play_training_s2_gideon_mitchell_sweep" },
    { 0x6A08, "play_training_s2_gideon_mr_president" },
    { 0x6A09, "play_training_s2_gideon_my_lead" },
    { 0x6A0A, "play_training_s2_gideon_our_exfil" },
    { 0x6A0B, "play_training_s2_gideon_package_secure" },
    { 0x6A0C, "play_training_s2_gideon_president_inside" },
    { 0x6A0D, "play_training_s2_gideon_prophet_approaching" },
    { 0x6A0E, "play_training_s2_gideon_smart_grenades" },
    { 0x6A0F, "play_training_s2_gideon_the_warbird" },
    { 0x6A10, "play_training_s2_gideon_use_overdrive" },
    { 0x6A11, "play_training_s2_gideon_use_your_shield" },
    { 0x6A12, "play_training_s2_joker_clear" },
    { 0x6A13, "play_training_s2_joker_contact" },
    { 0x6A14, "play_training_s2_joker_drones" },
    { 0x6A15, "play_training_s2_joker_entering_kitchen" },
    { 0x6A16, "play_training_s2_joker_front_entrance" },
    { 0x6A17, "play_training_s2_joker_here_they" },
    { 0x6A18, "play_training_s2_joker_living_room" },
    { 0x6A19, "play_training_s2_prophet_large_qrf" },
    { 0x6A1A, "play_training_vo_prophet_exfil_approach" },
    { 0x6A1B, "play_trigger_flashlight_off" },
    { 0x6A1C, "play_van_videolog_pip" },
    { 0x6A1D, "play_vb_cardoor_anim" },
    { 0x6A1E, "play_video_log_climb_block_intro" },
    { 0x6A1F, "play_videolog" },
    { 0x6A20, "play_vision_light_fog_normal" },
    { 0x6A21, "play_vrap_sounds" },
    { 0x6A22, "play_warbird_carrying_walker" },
    { 0x6A23, "play_warbird_mobile_turret_dropoff" },
    { 0x6A24, "play_window_sound" },
    { 0x6A25, "playafterburner" },
    { 0x6A26, "playaispawneffect" },
    { 0x6A27, "playalarmloop" },
    { 0x6A28, "playanim" },
    { 0x6A29, "playanimfortime" },
    { 0x6A2A, "playanimnatratefortime" },
    { 0x6A2B, "playanimnatrateuntilnotetrack" },
    { 0x6A2C, "playanimnfortime" },
    { 0x6A2D, "playanimnuntilnotetrack" },
    { 0x6A2E, "playanimuntilnotetrack" },
    { 0x6A2F, "playaudioturretmoveup" },
    { 0x6A30, "playbark" },
    { 0x6A31, "playbattlechatter" },
    { 0x6A32, "playbeameffects" },
    { 0x6A33, "playblendtransition" },
    { 0x6A34, "playblendtransitionstandrun" },
    { 0x6A35, "playbombfx" },
    { 0x6A36, "playbubbleeffect" },
    { 0x6A37, "playbuoylights" },
    { 0x6A38, "playc4effects" },
    { 0x6A39, "playclaymoreeffects" },
    { 0x6A3A, "playcloakoverheatdialog" },
    { 0x6A3B, "playcontrail" },
    { 0x6A3C, "playcranespawnvfx" },
    { 0x6A3D, "playcredits" },
    { 0x6A3E, "playcustomevent" },
    { 0x6A3F, "playdamagesound" },
    { 0x6A40, "playdeathanim" },
    { 0x6A41, "playdeathfx" },
    { 0x6A42, "playdeathsound" },
    { 0x6A43, "playdialog" },
    { 0x6A44, "playedstartingmusic" },
    { 0x6A45, "playeffectongroundent" },
    { 0x6A46, "playengineeffects" },
    { 0x6A47, "playentrysounddelayed" },
    { 0x6A48, "player_abandon_squad_distance_think" },
    { 0x6A49, "player_abandoned_mission_fail" },
    { 0x6A4A, "player_abandoned_mission_warning" },
    { 0x6A4B, "player_abandoned_mission_warning_vo_setup" },
    { 0x6A4C, "player_abandoning_mission_vo" },
    { 0x6A4D, "player_accuracy_think" },
    { 0x6A4E, "player_add_dshk_turret" },
    { 0x6A4F, "player_ads_disable_manager" },
    { 0x6A50, "player_ads_think" },
    { 0x6A51, "player_ads_time" },
    { 0x6A52, "player_aim_debug" },
    { 0x6A53, "player_airbraked" },
    { 0x6A54, "player_alerted_mission_fail" },
    { 0x6A55, "player_alerted_mission_fail_convoy" },
    { 0x6A56, "player_alerted_mission_fail_meter" },
    { 0x6A57, "player_allow_damage" },
    { 0x6A58, "player_and_hatch_doors" },
    { 0x6A59, "player_and_squad" },
    { 0x6A5A, "player_angles_at_last_hovertank_fire" },
    { 0x6A5B, "player_animated_sequence_cleanup" },
    { 0x6A5C, "player_animated_sequence_restrictions" },
    { 0x6A5D, "player_animations" },
    { 0x6A5E, "player_anims" },
    { 0x6A5F, "player_anims_toload" },
    { 0x6A60, "player_apply_mission_failed_wrapper_on_death_for_duration" },
    { 0x6A61, "player_assault_snipers" },
    { 0x6A62, "player_assisted_jump" },
    { 0x6A63, "player_attack_nodes_update" },
    { 0x6A64, "player_attack_think" },
    { 0x6A65, "player_attacked" },
    { 0x6A66, "player_attacker" },
    { 0x6A67, "player_attacker_accuracy" },
    { 0x6A68, "player_basement_objective_mover" },
    { 0x6A69, "player_bike" },
    { 0x6A6A, "player_bike_lower" },
    { 0x6A6B, "player_bike_obj" },
    { 0x6A6C, "player_bike_shutoff" },
    { 0x6A6D, "player_bike_to_ai_model" },
    { 0x6A6E, "player_bike_to_vm_model" },
    { 0x6A6F, "player_bike_wing_flaps" },
    { 0x6A70, "player_bike_wing_flaps_left" },
    { 0x6A71, "player_bikenew" },
    { 0x6A72, "player_blocking_shot" },
    { 0x6A73, "player_blocking_shot_vo_lines" },
    { 0x6A74, "player_blur_ads" },
    { 0x6A75, "player_blur_monitor_ads" },
    { 0x6A76, "player_blur_monitor_non_ads" },
    { 0x6A77, "player_blur_non_ads" },
    { 0x6A78, "player_blur_reset" },
    { 0x6A79, "player_blur_think" },
    { 0x6A7A, "player_boat" },
    { 0x6A7B, "player_boat_dive" },
    { 0x6A7C, "player_boat_gas" },
    { 0x6A7D, "player_bob_scale_set" },
    { 0x6A7E, "player_boost_hint" },
    { 0x6A7F, "player_boost_time" },
    { 0x6A80, "player_boosting" },
    { 0x6A81, "player_braking" },
    { 0x6A82, "player_breach" },
    { 0x6A83, "player_breaks_stealth_during_tutorial" },
    { 0x6A84, "player_breath_amount" },
    { 0x6A85, "player_breath_amount_fill_rate" },
    { 0x6A86, "player_breath_amount_use_rate" },
    { 0x6A87, "player_breath_elem" },
    { 0x6A88, "player_breath_fulltime" },
    { 0x6A89, "player_breath_hud" },
    { 0x6A8A, "player_broke_stealth" },
    { 0x6A8B, "player_broke_stealth_once" },
    { 0x6A8C, "player_bubbles_fx" },
    { 0x6A8D, "player_bus" },
    { 0x6A8E, "player_bus_anim_single_break_when_timeout_or_fail" },
    { 0x6A8F, "player_bus_slomo_end_notetrack" },
    { 0x6A90, "player_bus_slomo_end_pt2" },
    { 0x6A91, "player_bus_slomo_start_pt1" },
    { 0x6A92, "player_bus_slomo_start_pt2" },
    { 0x6A93, "player_bus_slomo_start_pt3" },
    { 0x6A94, "player_bus_slomo_start_pt4" },
    { 0x6A95, "player_bus_slomo_start_pt5" },
    { 0x6A96, "player_bus_start" },
    { 0x6A97, "player_camera_shake" },
    { 0x6A98, "player_camera_shake_land" },
    { 0x6A99, "player_can_be_shot" },
    { 0x6A9A, "player_can_see" },
    { 0x6A9B, "player_can_see_ai" },
    { 0x6A9C, "player_can_see_ai_bones" },
    { 0x6A9D, "player_can_see_ai_through_foliage" },
    { 0x6A9E, "player_can_see_civ" },
    { 0x6A9F, "player_can_see_corpse" },
    { 0x6AA0, "player_can_see_point" },
    { 0x6AA1, "player_can_see_vehicle" },
    { 0x6AA2, "player_can_stop_swimming" },
    { 0x6AA3, "player_canal_drop" },
    { 0x6AA4, "player_cant_be_shot" },
    { 0x6AA5, "player_carried_skybridge" },
    { 0x6AA6, "player_catch_up_on_boost" },
    { 0x6AA7, "player_character_name" },
    { 0x6AA8, "player_charged_shot" },
    { 0x6AA9, "player_chase_progress_mod" },
    { 0x6AAA, "player_chase_speed_control" },
    { 0x6AAB, "player_check_distance_to_ceiling" },
    { 0x6AAC, "player_check_distance_to_ground" },
    { 0x6AAD, "player_chooses_manual_control" },
    { 0x6AAE, "player_cleanup_charge_indicator" },
    { 0x6AAF, "player_cleanup_reticle" },
    { 0x6AB0, "player_cleanup_rumble" },
    { 0x6AB1, "player_cleanup_sound" },
    { 0x6AB2, "player_cleanupongameended" },
    { 0x6AB3, "player_cleanuponteamchange" },
    { 0x6AB4, "player_clear_pass_target" },
    { 0x6AB5, "player_climb_wall" },
    { 0x6AB6, "player_climb_wall_head_sway" },
    { 0x6AB7, "player_clip" },
    { 0x6AB8, "player_clip_pod_door" },
    { 0x6AB9, "player_cloak_on" },
    { 0x6ABA, "player_close_disable_ignore_check" },
    { 0x6ABB, "player_close_to_fail_dist" },
    { 0x6ABC, "player_color_node" },
    { 0x6ABD, "player_color_pulse" },
    { 0x6ABE, "player_command_for_exit" },
    { 0x6ABF, "player_control_on" },
    { 0x6AC0, "player_covertrigger" },
    { 0x6AC1, "player_covertype" },
    { 0x6AC2, "player_cqb_off" },
    { 0x6AC3, "player_cqb_on" },
    { 0x6AC4, "player_crash" },
    { 0x6AC5, "player_damage" },
    { 0x6AC6, "player_damage_atlas_flag_set" },
    { 0x6AC7, "player_damage_check" },
    { 0x6AC8, "player_damaged_car_watcher" },
    { 0x6AC9, "player_death" },
    { 0x6ACA, "player_death_detection" },
    { 0x6ACB, "player_defend_snipers" },
    { 0x6ACC, "player_delete_ball_goal_fx" },
    { 0x6ACD, "player_did_most_damage" },
    { 0x6ACE, "player_died_recently" },
    { 0x6ACF, "player_died_recently_degrades" },
    { 0x6AD0, "player_died_water" },
    { 0x6AD1, "player_dismount" },
    { 0x6AD2, "player_dismount_link_player_end_of_frame" },
    { 0x6AD3, "player_dismount_newbike" },
    { 0x6AD4, "player_dismount_vehicle" },
    { 0x6AD5, "player_dist_limit" },
    { 0x6AD6, "player_dist_to_speaker" },
    { 0x6AD7, "player_distsqrd" },
    { 0x6AD8, "player_do_camera_shake" },
    { 0x6AD9, "player_do_charge_indicator" },
    { 0x6ADA, "player_do_reticle" },
    { 0x6ADB, "player_do_rumble" },
    { 0x6ADC, "player_do_sound" },
    { 0x6ADD, "player_does_not_see_spawner" },
    { 0x6ADE, "player_dof_aperture" },
    { 0x6ADF, "player_dof_distance" },
    { 0x6AE0, "player_dof_max_distance" },
    { 0x6AE1, "player_dolasercoredamage" },
    { 0x6AE2, "player_doorkick" },
    { 0x6AE3, "player_downed_death_buffer_time" },
    { 0x6AE4, "player_driver" },
    { 0x6AE5, "player_drone_control" },
    { 0x6AE6, "player_drone_manager" },
    { 0x6AE7, "player_drop_pod_se_door_kick" },
    { 0x6AE8, "player_drown_end_vm_transition" },
    { 0x6AE9, "player_drowning_damage_thread" },
    { 0x6AEA, "player_drowning_start" },
    { 0x6AEB, "player_dynamic_dof" },
    { 0x6AEC, "player_enable_highlight" },
    { 0x6AED, "player_enter_round_trigger" },
    { 0x6AEE, "player_enter_turret" },
    { 0x6AEF, "player_enter_walker" },
    { 0x6AF0, "player_enter_walker_anim" },
    { 0x6AF1, "player_entering_server_room" },
    { 0x6AF2, "player_enters_mobile_turret_dialogue" },
    { 0x6AF3, "player_escape" },
    { 0x6AF4, "player_exhaust_corridor" },
    { 0x6AF5, "player_exhaust_corridor_rumbles" },
    { 0x6AF6, "player_exit_breach_fail" },
    { 0x6AF7, "player_exit_turret" },
    { 0x6AF8, "player_exit_walker" },
    { 0x6AF9, "player_exit_walker_anim" },
    { 0x6AFA, "player_exiting" },
    { 0x6AFB, "player_exo_activate" },
    { 0x6AFC, "player_exo_activate_single_internal" },
    { 0x6AFD, "player_exo_add_array" },
    { 0x6AFE, "player_exo_add_single" },
    { 0x6AFF, "player_exo_cloak_on" },
    { 0x6B00, "player_exo_cloak_on_wallclimb" },
    { 0x6B01, "player_exo_deactivate" },
    { 0x6B02, "player_exo_deactivate_single_internal" },
    { 0x6B03, "player_exo_disable" },
    { 0x6B04, "player_exo_enable" },
    { 0x6B05, "player_exo_get_owned_array" },
    { 0x6B06, "player_exo_get_unowned_array" },
    { 0x6B07, "player_exo_init" },
    { 0x6B08, "player_exo_is_active" },
    { 0x6B09, "player_exo_is_active_single" },
    { 0x6B0A, "player_exo_is_active_single_internal" },
    { 0x6B0B, "player_exo_jump_hint" },
    { 0x6B0C, "player_exo_jump_hint_off" },
    { 0x6B0D, "player_exo_jump_release_hint_off" },
    { 0x6B0E, "player_exo_monitor" },
    { 0x6B0F, "player_exo_power_on" },
    { 0x6B10, "player_exo_remove_array" },
    { 0x6B11, "player_exo_remove_single" },
    { 0x6B12, "player_exo_set_owned_array" },
    { 0x6B13, "player_exoclimb_mag_moved" },
    { 0x6B14, "player_exoclimb_moved" },
    { 0x6B15, "player_failed_drop" },
    { 0x6B16, "player_fall_lighting" },
    { 0x6B17, "player_fall_zone_swap" },
    { 0x6B18, "player_falling_kill_logic" },
    { 0x6B19, "player_falling_to_death" },
    { 0x6B1A, "player_fastzip" },
    { 0x6B1B, "player_fastzip_land" },
    { 0x6B1C, "player_fired_missiles" },
    { 0x6B1D, "player_follow_volume_think" },
    { 0x6B1E, "player_forest_takedown" },
    { 0x6B1F, "player_forest_takedown_bad_guy_left_vox" },
    { 0x6B20, "player_forest_takedown_bad_guy_right_vox" },
    { 0x6B21, "player_fov_54" },
    { 0x6B22, "player_fov_65" },
    { 0x6B23, "player_fov_controller" },
    { 0x6B24, "player_free_aim" },
    { 0x6B25, "player_friendly_hud_destroy" },
    { 0x6B26, "player_friendlyfire_addreactionevent" },
    { 0x6B27, "player_friendlyfire_waiter" },
    { 0x6B28, "player_friendlyfire_waiter_damage" },
    { 0x6B29, "player_gasping_breath" },
    { 0x6B2A, "player_getout" },
    { 0x6B2B, "player_getout_sound" },
    { 0x6B2C, "player_getout_sound_end" },
    { 0x6B2D, "player_getout_sound_loop" },
    { 0x6B2E, "player_gets_weapons_back" },
    { 0x6B2F, "player_getvelocity_pc" },
    { 0x6B30, "player_giveachievement_wrapper" },
    { 0x6B31, "player_grace_period" },
    { 0x6B32, "player_grapple_check" },
    { 0x6B33, "player_grapple_hint" },
    { 0x6B34, "player_grapple_into_vehicle" },
    { 0x6B35, "player_grappled" },
    { 0x6B36, "player_grenade_check" },
    { 0x6B37, "player_grenade_check_dieout" },
    { 0x6B38, "player_gun_lock_target_origin" },
    { 0x6B39, "player_guns_cooldown_can_shoot" },
    { 0x6B3A, "player_guns_cooldown_get_heat" },
    { 0x6B3B, "player_guns_cooldown_shoot_notify" },
    { 0x6B3C, "player_guns_cooldown_think" },
    { 0x6B3D, "player_hand_plant_lf_wallclimb" },
    { 0x6B3E, "player_hand_plant_rt_wallclimb" },
    { 0x6B3F, "player_handle_charged_shot" },
    { 0x6B40, "player_handleturrethints" },
    { 0x6B41, "player_handleturretpickup" },
    { 0x6B42, "player_handleturretrippable" },
    { 0x6B43, "player_handplant" },
    { 0x6B44, "player_handplant_standalone" },
    { 0x6B45, "player_hands_idle_start" },
    { 0x6B46, "player_hands_idle_stop" },
    { 0x6B47, "player_hangar_waits" },
    { 0x6B48, "player_has_caught_up" },
    { 0x6B49, "player_has_jumped" },
    { 0x6B4A, "player_has_printing_himar" },
    { 0x6B4B, "player_has_returned_to_road" },
    { 0x6B4C, "player_has_returned_to_squad" },
    { 0x6B4D, "player_has_thermal" },
    { 0x6B4E, "player_has_weapon" },
    { 0x6B4F, "player_health_check" },
    { 0x6B50, "player_health_current" },
    { 0x6B51, "player_health_packets" },
    { 0x6B52, "player_heartbeat" },
    { 0x6B53, "player_helo_release" },
    { 0x6B54, "player_hover_height" },
    { 0x6B55, "player_idle" },
    { 0x6B56, "player_ied_footsteps_left" },
    { 0x6B57, "player_ied_footsteps_right" },
    { 0x6B58, "player_in_deep_water" },
    { 0x6B59, "player_in_disable_sniper_volume" },
    { 0x6B5A, "player_in_mt" },
    { 0x6B5B, "player_in_oncoming" },
    { 0x6B5C, "player_init" },
    { 0x6B5D, "player_init_charge_indicator" },
    { 0x6B5E, "player_init_reticle" },
    { 0x6B5F, "player_init_rumble" },
    { 0x6B60, "player_init_sound" },
    { 0x6B61, "player_input_control_hint_off" },
    { 0x6B62, "player_input_ending_aim_button_off" },
    { 0x6B63, "player_input_ending_shoot_button_off" },
    { 0x6B64, "player_input_rappel_hint_off" },
    { 0x6B65, "player_input_shaft_buttons_off" },
    { 0x6B66, "player_input_slide_under_door" },
    { 0x6B67, "player_input_sprint" },
    { 0x6B68, "player_intel_display_object" },
    { 0x6B69, "player_intel_display_object_array" },
    { 0x6B6A, "player_intel_display_objects" },
    { 0x6B6B, "player_intel_mode_disable" },
    { 0x6B6C, "player_intel_mode_think" },
    { 0x6B6D, "player_is_aiming_with_rocket" },
    { 0x6B6E, "player_is_behind_me" },
    { 0x6B6F, "player_is_driving" },
    { 0x6B70, "player_is_good_missile_target" },
    { 0x6B71, "player_is_in_scanner_cone" },
    { 0x6B72, "player_is_near_live_grenade" },
    { 0x6B73, "player_is_pushing_rumble" },
    { 0x6B74, "player_is_rappelling" },
    { 0x6B75, "player_is_shooting" },
    { 0x6B76, "player_is_skipping_setups" },
    { 0x6B77, "player_is_valid_target" },
    { 0x6B78, "player_isusingkillstreak" },
    { 0x6B79, "player_jammer_movie" },
    { 0x6B7A, "player_jetpack" },
    { 0x6B7B, "player_joined_update_pass_target_hudoutline" },
    { 0x6B7C, "player_jump_into_mob_nag_lines" },
    { 0x6B7D, "player_jumped_out_vol" },
    { 0x6B7E, "player_kill_function" },
    { 0x6B7F, "player_kill_trigger" },
    { 0x6B80, "player_killed" },
    { 0x6B81, "player_knife" },
    { 0x6B82, "player_knockdown" },
    { 0x6B83, "player_knockout_wakeup" },
    { 0x6B84, "player_knockout_white" },
    { 0x6B85, "player_land_on_hood" },
    { 0x6B86, "player_land_on_wing" },
    { 0x6B87, "player_lasercoreeffect" },
    { 0x6B88, "player_leave_cafeteria_nag_lines" },
    { 0x6B89, "player_leave_round_trigger" },
    { 0x6B8A, "player_leaves_humvee" },
    { 0x6B8B, "player_leaving_bodyroom_gag" },
    { 0x6B8C, "player_left_road_hint" },
    { 0x6B8D, "player_left_squad_hint" },
    { 0x6B8E, "player_link_to" },
    { 0x6B8F, "player_link_to_cover" },
    { 0x6B90, "player_linked" },
    { 0x6B91, "player_linkto_drone_missile" },
    { 0x6B92, "player_locked_on" },
    { 0x6B93, "player_look_limit_controller" },
    { 0x6B94, "player_looking_at" },
    { 0x6B95, "player_looking_at_object" },
    { 0x6B96, "player_looking_at_relative" },
    { 0x6B97, "player_looking_in_direction_2d" },
    { 0x6B98, "player_los_check" },
    { 0x6B99, "player_loses_speedscale" },
    { 0x6B9A, "player_mag_glove_activate_wallclimb" },
    { 0x6B9B, "player_mag_glove_lglove_disengage" },
    { 0x6B9C, "player_mag_glove_off" },
    { 0x6B9D, "player_mag_glove_rglove_disengage" },
    { 0x6B9E, "player_mech_melee_modifier" },
    { 0x6B9F, "player_mech_melee_modifier_damage_function" },
    { 0x6BA0, "player_missile_firing_logic" },
    { 0x6BA1, "player_mission_failed_handler" },
    { 0x6BA2, "player_mobile_turret_explo" },
    { 0x6BA3, "player_mobile_turret_warning" },
    { 0x6BA4, "player_mode" },
    { 0x6BA5, "player_mount_vehicle" },
    { 0x6BA6, "player_move_mod" },
    { 0x6BA7, "player_moved_forward" },
    { 0x6BA8, "player_movement_tweaks" },
    { 0x6BA9, "player_movement_weapons_setup" },
    { 0x6BAA, "player_moves" },
    { 0x6BAB, "player_movespeed_calc_loop" },
    { 0x6BAC, "player_nades" },
    { 0x6BAD, "player_name_called_recently" },
    { 0x6BAE, "player_near_logging_road_end_log" },
    { 0x6BAF, "player_no_pickup_time" },
    { 0x6BB0, "player_on_disconnect" },
    { 0x6BB1, "player_on_rotors" },
    { 0x6BB2, "player_onbike" },
    { 0x6BB3, "player_one_already_breached" },
    { 0x6BB4, "player_out_of_bounds_count" },
    { 0x6BB5, "player_out_of_bounds_mission_fail" },
    { 0x6BB6, "player_out_of_bounds_warning" },
    { 0x6BB7, "player_out_of_bounds_warning_vo" },
    { 0x6BB8, "player_pbull_honk" },
    { 0x6BB9, "player_pc_velocity" },
    { 0x6BBA, "player_perarts_jump_explosions" },
    { 0x6BBB, "player_picked_team" },
    { 0x6BBC, "player_pitbull" },
    { 0x6BBD, "player_pitbull_init" },
    { 0x6BBE, "player_pitbull_physics_wake_up" },
    { 0x6BBF, "player_pitbull_woosh_sounds" },
    { 0x6BC0, "player_place_ied_foley" },
    { 0x6BC1, "player_plant_frb" },
    { 0x6BC2, "player_pod" },
    { 0x6BC3, "player_popped_flares" },
    { 0x6BC4, "player_pos" },
    { 0x6BC5, "player_post_crash" },
    { 0x6BC6, "player_presinkhole_debris" },
    { 0x6BC7, "player_presinkhole_jump_pipeburst" },
    { 0x6BC8, "player_process_dshk_turrets" },
    { 0x6BC9, "player_projectile_think" },
    { 0x6BCA, "player_proximity_rumble" },
    { 0x6BCB, "player_proxy" },
    { 0x6BCC, "player_proxy_org" },
    { 0x6BCD, "player_proxy_took_damage" },
    { 0x6BCE, "player_push_impulse" },
    { 0x6BCF, "player_pushed_kill" },
    { 0x6BD0, "player_radio_emitter" },
    { 0x6BD1, "player_radio_emitter_overlap" },
    { 0x6BD2, "player_radio_squelch_out_queued" },
    { 0x6BD3, "player_rappel" },
    { 0x6BD4, "player_rappel_camera_sway" },
    { 0x6BD5, "player_rappel_control" },
    { 0x6BD6, "player_rappel_rope_swap" },
    { 0x6BD7, "player_rappel_rumbles" },
    { 0x6BD8, "player_reached_stealth_finish_line" },
    { 0x6BD9, "player_reached_window" },
    { 0x6BDA, "player_reaches_shack" },
    { 0x6BDB, "player_ready_capture" },
    { 0x6BDC, "player_recovered_stealth" },
    { 0x6BDD, "player_recovers_from_red_flashing" },
    { 0x6BDE, "player_regen_restore" },
    { 0x6BDF, "player_regen_scale" },
    { 0x6BE0, "player_remove_dshk_turret" },
    { 0x6BE1, "player_repulsor" },
    { 0x6BE2, "player_resetlasercorevalues" },
    { 0x6BE3, "player_restore_reticle" },
    { 0x6BE4, "player_revived_or_dead" },
    { 0x6BE5, "player_rides_humvee_offset_dismount" },
    { 0x6BE6, "player_rides_in_humvee" },
    { 0x6BE7, "player_rides_in_humvee_offset" },
    { 0x6BE8, "player_rides_shotgun_in_humvee" },
    { 0x6BE9, "player_rig" },
    { 0x6BEA, "player_rig_heli" },
    { 0x6BEB, "player_rig_highway_ledge" },
    { 0x6BEC, "player_rig_lighting_org" },
    { 0x6BED, "player_rig_lighting_org_willroom" },
    { 0x6BEE, "player_rig_spawn_function" },
    { 0x6BEF, "player_rocket" },
    { 0x6BF0, "player_rope" },
    { 0x6BF1, "player_rope_long" },
    { 0x6BF2, "player_run_progress_trigger_think" },
    { 0x6BF3, "player_run_rumble" },
    { 0x6BF4, "player_rushes_ahead" },
    { 0x6BF5, "player_safe" },
    { 0x6BF6, "player_saw_kill" },
    { 0x6BF7, "player_school_disable_values" },
    { 0x6BF8, "player_school_flashlight" },
    { 0x6BF9, "player_screen_flash" },
    { 0x6BFA, "player_scuba" },
    { 0x6BFB, "player_scuba_breathe_sound" },
    { 0x6BFC, "player_scuba_bubbles" },
    { 0x6BFD, "player_scuba_mask" },
    { 0x6BFE, "player_scuba_mask_disable" },
    { 0x6BFF, "player_seek" },
    { 0x6C00, "player_seek_disable" },
    { 0x6C01, "player_seek_enable" },
    { 0x6C02, "player_sees_my_scope" },
    { 0x6C03, "player_sees_spawner" },
    { 0x6C04, "player_sentinel_kva_reveal" },
    { 0x6C05, "player_sentry_timeout" },
    { 0x6C06, "player_server_room_se_end" },
    { 0x6C07, "player_set_all_reticle_colors" },
    { 0x6C08, "player_set_in_water" },
    { 0x6C09, "player_set_pass_target" },
    { 0x6C0A, "player_set_swimming" },
    { 0x6C0B, "player_setupanimations" },
    { 0x6C0C, "player_shadow_monitor" },
    { 0x6C0D, "player_shimmy_1" },
    { 0x6C0E, "player_shimmy_2" },
    { 0x6C0F, "player_shimmy_3" },
    { 0x6C10, "player_shimmy_4" },
    { 0x6C11, "player_shimmy_intro" },
    { 0x6C12, "player_shooting_at" },
    { 0x6C13, "player_shooting_logic" },
    { 0x6C14, "player_shot_guns" },
    { 0x6C15, "player_shouldclearturretpickuphints" },
    { 0x6C16, "player_shoulddisableremoteenter" },
    { 0x6C17, "player_show_missile_reticle" },
    { 0x6C18, "player_show_turret_hud" },
    { 0x6C19, "player_skipping_setup" },
    { 0x6C1A, "player_slows_down" },
    { 0x6C1B, "player_soft_land_alt" },
    { 0x6C1C, "player_speed" },
    { 0x6C1D, "player_speed_control" },
    { 0x6C1E, "player_speed_control_rocket_blast" },
    { 0x6C1F, "player_speed_control_underwater" },
    { 0x6C20, "player_speed_default" },
    { 0x6C21, "player_speed_hud" },
    { 0x6C22, "player_speed_manager" },
    { 0x6C23, "player_speed_percent" },
    { 0x6C24, "player_speed_proc" },
    { 0x6C25, "player_speed_set" },
    { 0x6C26, "player_spotlight" },
    { 0x6C27, "player_stance_monitor" },
    { 0x6C28, "player_started_vtol_grapple_monitor" },
    { 0x6C29, "player_starts_battle" },
    { 0x6C2A, "player_state" },
    { 0x6C2B, "player_stealth_audio" },
    { 0x6C2C, "player_stealth_cloak_think" },
    { 0x6C2D, "player_swim_hint" },
    { 0x6C2E, "player_swimming_moving_water" },
    { 0x6C2F, "player_tank" },
    { 0x6C30, "player_target" },
    { 0x6C31, "player_targeting_think" },
    { 0x6C32, "player_test_points" },
    { 0x6C33, "player_throwgrenade_timer" },
    { 0x6C34, "player_too_far_hint" },
    { 0x6C35, "player_touched_arr" },
    { 0x6C36, "player_touched_car_watcher" },
    { 0x6C37, "player_touching_post_clip" },
    { 0x6C38, "player_training_s1_joker_threat_grenade_nag" },
    { 0x6C39, "player_truck" },
    { 0x6C3A, "player_ugv_health" },
    { 0x6C3B, "player_ugv_health_hurtagain" },
    { 0x6C3C, "player_ugv_health_max_health" },
    { 0x6C3D, "player_under_logging_road_end_log" },
    { 0x6C3E, "player_underwater_breath" },
    { 0x6C3F, "player_underwater_end" },
    { 0x6C40, "player_underwater_shock" },
    { 0x6C41, "player_underwater_start" },
    { 0x6C42, "player_unlink_from_cover" },
    { 0x6C43, "player_unlink_from_drone_missile" },
    { 0x6C44, "player_unlink_on_death" },
    { 0x6C45, "player_unlink_on_sprint" },
    { 0x6C46, "player_unlock" },
    { 0x6C47, "player_unresolved_collision_watch" },
    { 0x6C48, "player_update_pass_target" },
    { 0x6C49, "player_update_pass_target_hudoutline" },
    { 0x6C4A, "player_update_slow_aim" },
    { 0x6C4B, "player_upkeep" },
    { 0x6C4C, "player_use_dshk_with_viewmodel" },
    { 0x6C4D, "player_used_exoclimb_combat" },
    { 0x6C4E, "player_used_exoclimb_cover" },
    { 0x6C4F, "player_used_grapple" },
    { 0x6C50, "player_used_grenade_recently" },
    { 0x6C51, "player_using_missile" },
    { 0x6C52, "player_velocity_display" },
    { 0x6C53, "player_view" },
    { 0x6C54, "player_viewhand_model" },
    { 0x6C55, "player_visible_duration" },
    { 0x6C56, "player_wait_and_unlink" },
    { 0x6C57, "player_walk" },
    { 0x6C58, "player_walk_end" },
    { 0x6C59, "player_warbird_flyout" },
    { 0x6C5A, "player_warbird_spawn" },
    { 0x6C5B, "player_watchdeath" },
    { 0x6C5C, "player_watchexitlasercore" },
    { 0x6C5D, "player_weapons" },
    { 0x6C5E, "player2" },
    { 0x6C5F, "playeractivatedairsupport" },
    { 0x6C60, "playeraddnotifycommands" },
    { 0x6C61, "playeraffectedarray" },
    { 0x6C62, "playerallowalternatemelee" },
    { 0x6C63, "playerallowboostjump" },
    { 0x6C64, "playerallowdodge" },
    { 0x6C65, "playerallowhighjump" },
    { 0x6C66, "playerallowhighjumpdrop" },
    { 0x6C67, "playerallowpowerslide" },
    { 0x6C68, "playerallowweaponpickup" },
    { 0x6C69, "playeranims" },
    { 0x6C6A, "playerassist" },
    { 0x6C6B, "playerattachpoint" },
    { 0x6C6C, "playerboostjumpprecaching" },
    { 0x6C6D, "playerbreathingsound" },
    { 0x6C6E, "playercanuselaser" },
    { 0x6C6F, "playercanuseturret" },
    { 0x6C70, "playercapturelpm" },
    { 0x6C71, "playercardplayer" },
    { 0x6C72, "playercardsplashnotify" },
    { 0x6C73, "playerchangemode" },
    { 0x6C74, "playercleanupbarrel" },
    { 0x6C75, "playercleanupondeath" },
    { 0x6C76, "playercleanuponother" },
    { 0x6C77, "playercleanupthermalvisioncommands" },
    { 0x6C78, "playerclearorbitalsupportonteamchange" },
    { 0x6C79, "playerclearrippableturretinfo" },
    { 0x6C7A, "playerclearwarbirdonteamchange" },
    { 0x6C7B, "playercloakactivated" },
    { 0x6C7C, "playercloakcooldown" },
    { 0x6C7D, "playercloakready" },
    { 0x6C7E, "playercloakwaitforexit" },
    { 0x6C7F, "playerclockdirection" },
    { 0x6C80, "playercommonreconvehiclesetup" },
    { 0x6C81, "playercontrolled" },
    { 0x6C82, "playercontrolorbitalstrike" },
    { 0x6C83, "playercontrolwarbirdsetup" },
    { 0x6C84, "playercostume" },
    { 0x6C85, "playerdamaged" },
    { 0x6C86, "playerdamagerumble" },
    { 0x6C87, "playerdelaycontrol" },
    { 0x6C88, "playerdelayrumble" },
    { 0x6C89, "playerdelaystartsparkseffect" },
    { 0x6C8A, "playerdeleteexhaustfxonvehicledeath" },
    { 0x6C8B, "playerdestroyglassbelow" },
    { 0x6C8C, "playerdied" },
    { 0x6C8D, "playerdisableabilitytypes" },
    { 0x6C8E, "playerdisabledwait" },
    { 0x6C8F, "playerdisablestreakstatic" },
    { 0x6C90, "playerdisableunderwater" },
    { 0x6C91, "playerdisplayjoinrequest" },
    { 0x6C92, "playerdoginit" },
    { 0x6C93, "playerdohunterkillerbehavior" },
    { 0x6C94, "playerdone_anim_laststand" },
    { 0x6C95, "playerdone_anim_neck_snap" },
    { 0x6C96, "playerdone_anim_saved" },
    { 0x6C97, "playerdoridekillstreak" },
    { 0x6C98, "playerdoublegrenadetime" },
    { 0x6C99, "playerdrone" },
    { 0x6C9A, "playerdrone_anim_knockdown" },
    { 0x6C9B, "playerdrone_create" },
    { 0x6C9C, "playerenablestreakstatic" },
    { 0x6C9D, "playerenableunderwater" },
    { 0x6C9E, "playerendinganimations" },
    { 0x6C9F, "playerenterarea" },
    { 0x6CA0, "playerentersoftlanding" },
    { 0x6CA1, "playerfakeshootempgrenadeattarget" },
    { 0x6CA2, "playerfakeshootpaintgrenadeattarget" },
    { 0x6CA3, "playerfakeshootpaintmissile" },
    { 0x6CA4, "playerfindaltnode" },
    { 0x6CA5, "playerfindnodeinfront" },
    { 0x6CA6, "playerfindnodeinfrontinternal" },
    { 0x6CA7, "playerfiresounds" },
    { 0x6CA8, "playerforclientid" },
    { 0x6CA9, "playerfxorg" },
    { 0x6CAA, "playergetclosestnode" },
    { 0x6CAB, "playergetclosestnodeinternal" },
    { 0x6CAC, "playergetkillstreaklastweapon" },
    { 0x6CAD, "playergetnearestnode" },
    { 0x6CAE, "playergetnodelookingat" },
    { 0x6CAF, "playergetorbitalstartpos" },
    { 0x6CB0, "playergetoutsidenode" },
    { 0x6CB1, "playergetrippableammo" },
    { 0x6CB2, "playergetturretendpoint" },
    { 0x6CB3, "playergetusetime" },
    { 0x6CB4, "playergivebackcarepackage" },
    { 0x6CB5, "playergiveturrethead" },
    { 0x6CB6, "playergrenadebasetime" },
    { 0x6CB7, "playergrenaderangetime" },
    { 0x6CB8, "playerhandlebarrel" },
    { 0x6CB9, "playerhandlebootupsequence" },
    { 0x6CBA, "playerhandleboundarystatic" },
    { 0x6CBB, "playerhandleboundarystaticradius" },
    { 0x6CBC, "playerhandledamage" },
    { 0x6CBD, "playerhandleexhaustfx" },
    { 0x6CBE, "playerhandlejoining" },
    { 0x6CBF, "playerhandlekillvehicle" },
    { 0x6CC0, "playerhandleradarping" },
    { 0x6CC1, "playerhasammo" },
    { 0x6CC2, "playerhasrippableturretinfo" },
    { 0x6CC3, "playerhastouchedstick" },
    { 0x6CC4, "playerhasturretheadweapon" },
    { 0x6CC5, "playerhbreachwristequipment" },
    { 0x6CC6, "playerhealth_regularregendelay" },
    { 0x6CC7, "playerhealthregen" },
    { 0x6CC8, "playerhealthregeninit" },
    { 0x6CC9, "playerhideturretoverlay" },
    { 0x6CCA, "playerhudelements" },
    { 0x6CCB, "playerhudoutlineshunterkiller" },
    { 0x6CCC, "playerhurtcheck" },
    { 0x6CCD, "playeridlereminderdialogue" },
    { 0x6CCE, "playerimmunetofire" },
    { 0x6CCF, "playerinit" },
    { 0x6CD0, "playerinorbital" },
    { 0x6CD1, "playerinside" },
    { 0x6CD2, "playerinteractdronecontrol" },
    { 0x6CD3, "playerinvul" },
    { 0x6CD4, "playerinwater" },
    { 0x6CD5, "playerisclose" },
    { 0x6CD6, "playerisinfront" },
    { 0x6CD7, "playerisonleft" },
    { 0x6CD8, "playerisrocketswarmreloading" },
    { 0x6CD9, "playerisrocketswarmtargetlocked" },
    { 0x6CDA, "playerkilled" },
    { 0x6CDB, "playerkilled_internal" },
    { 0x6CDC, "playerkillheavyexo" },
    { 0x6CDD, "playerlaunchcarepackage" },
    { 0x6CDE, "playerlaunchdroppod" },
    { 0x6CDF, "playerleashbehavior" },
    { 0x6CE0, "playerleashdisable" },
    { 0x6CE1, "playerleavearea" },
    { 0x6CE2, "playerleavesoftlanding" },
    { 0x6CE3, "playerlinktodeltablend" },
    { 0x6CE4, "playerlinktodeltadelayed" },
    { 0x6CE5, "playermech_badplace" },
    { 0x6CE6, "playermech_chaingun_watcher" },
    { 0x6CE7, "playermech_damage_manager" },
    { 0x6CE8, "playermech_damage_parts" },
    { 0x6CE9, "playermech_disable_badplace" },
    { 0x6CEA, "playermech_dodamage" },
    { 0x6CEB, "playermech_enable_badplace" },
    { 0x6CEC, "playermech_end" },
    { 0x6CED, "playermech_fx_init" },
    { 0x6CEE, "playermech_health_restore" },
    { 0x6CEF, "playermech_init" },
    { 0x6CF0, "playermech_init_dmg_screens" },
    { 0x6CF1, "playermech_init_vo" },
    { 0x6CF2, "playermech_invalid_gun_callback" },
    { 0x6CF3, "playermech_invalid_rocket_callback" },
    { 0x6CF4, "playermech_invalid_swarm_callback" },
    { 0x6CF5, "playermech_invalid_weapon_instance" },
    { 0x6CF6, "playermech_invalid_weapon_watcher" },
    { 0x6CF7, "playermech_is_damage_allowed" },
    { 0x6CF8, "playermech_link_viewmodel_part" },
    { 0x6CF9, "playermech_mech_regen" },
    { 0x6CFA, "playermech_monitor_rocket_recharge" },
    { 0x6CFB, "playermech_monitor_swarm_recharge" },
    { 0x6CFC, "playermech_monitor_update_recharge" },
    { 0x6CFD, "playermech_physics_push" },
    { 0x6CFE, "playermech_physics_push_finale" },
    { 0x6CFF, "playermech_physics_push_off" },
    { 0x6D00, "playermech_physics_push_on" },
    { 0x6D01, "playermech_player_hit_fx" },
    { 0x6D02, "playermech_restore_player_data" },
    { 0x6D03, "playermech_rocket_targeting_allowed" },
    { 0x6D04, "playermech_rockets_and_swarm_watcher" },
    { 0x6D05, "playermech_rockets_wait_rocket" },
    { 0x6D06, "playermech_rockets_wait_swarm" },
    { 0x6D07, "playermech_save_player_data" },
    { 0x6D08, "playermech_start" },
    { 0x6D09, "playermech_state_manager" },
    { 0x6D0A, "playermech_threat_paint" },
    { 0x6D0B, "playermech_threat_paint_loop" },
    { 0x6D0C, "playermech_threat_paint_ping_loop" },
    { 0x6D0D, "playermech_ui_chaingun_feedback" },
    { 0x6D0E, "playermech_ui_rocket_feedback" },
    { 0x6D0F, "playermech_ui_state_enter" },
    { 0x6D10, "playermech_ui_state_leave" },
    { 0x6D11, "playermech_ui_state_reset" },
    { 0x6D12, "playermech_ui_swarm_feedback" },
    { 0x6D13, "playermech_ui_turn_off_threat_count" },
    { 0x6D14, "playermech_ui_update_lui" },
    { 0x6D15, "playermech_ui_update_threat_compass_values" },
    { 0x6D16, "playermech_ui_weapon_feedback" },
    { 0x6D17, "playermech_watch_emp_grenade" },
    { 0x6D18, "playermodelforweapon" },
    { 0x6D19, "playermoduleshaverippedturret" },
    { 0x6D1A, "playermonitordeath" },
    { 0x6D1B, "playermonitorfordronedelivery" },
    { 0x6D1C, "playermonitormarkedtarget" },
    { 0x6D1D, "playermonitorrocketturretfire" },
    { 0x6D1E, "playermonitorwarbirdpossession" },
    { 0x6D1F, "playermonitorweaponswitch" },
    { 0x6D20, "playermovetruck" },
    { 0x6D21, "playermovingdrone" },
    { 0x6D22, "playernameids" },
    { 0x6D23, "playernode" },
    { 0x6D24, "playeronspawnprompt" },
    { 0x6D25, "playerpainbreathingsound" },
    { 0x6D26, "playerpiggyback" },
    { 0x6D27, "playerplayattachmentdialog" },
    { 0x6D28, "playerplayinvalidpositioneffect" },
    { 0x6D29, "playerplaytargetfx" },
    { 0x6D2A, "playerplaythrustersound" },
    { 0x6D2B, "playerplayvaporizefx" },
    { 0x6D2C, "playerprekilled" },
    { 0x6D2D, "playerprocesstaggedassist" },
    { 0x6D2E, "playerquickkill" },
    { 0x6D2F, "playerrecordrippableammo" },
    { 0x6D30, "playerremotecoopturret" },
    { 0x6D31, "playerremotekillstreakhidehud" },
    { 0x6D32, "playerremotekillstreakshowhud" },
    { 0x6D33, "playerremovenotifycommands" },
    { 0x6D34, "playerreset" },
    { 0x6D35, "playerresetaftercoopstreak" },
    { 0x6D36, "playerresetaftercoopstreakinternal" },
    { 0x6D37, "playerresetafterwarbird" },
    { 0x6D38, "playerresetomnvars" },
    { 0x6D39, "playerresetospomnvars" },
    { 0x6D3A, "playerresetwarbirdomnvars" },
    { 0x6D3B, "playerrestoreangles" },
    { 0x6D3C, "playerrocketsandswarmwatcher" },
    { 0x6D3D, "playerrubberbandmovespeedscale" },
    { 0x6D3E, "players_ready" },
    { 0x6D3F, "players_waiting_to_join" },
    { 0x6D40, "players_within_distance" },
    { 0x6D41, "playersafehouseanimations" },
    { 0x6D42, "playersaveangles" },
    { 0x6D43, "playerscore" },
    { 0x6D44, "playerscores" },
    { 0x6D45, "playerscrambleanimations" },
    { 0x6D46, "playerscramblefinale" },
    { 0x6D47, "playerseeker" },
    { 0x6D48, "playerseesme" },
    { 0x6D49, "playerseesmetime" },
    { 0x6D4A, "playersetavailableweaponshud" },
    { 0x6D4B, "playersetcamera" },
    { 0x6D4C, "playersethudempscrambled" },
    { 0x6D4D, "playersethudempscrambledoff" },
    { 0x6D4E, "playersetjuggexomodel" },
    { 0x6D4F, "playersetupcoopstreak" },
    { 0x6D50, "playersetupcoopstreakinternal" },
    { 0x6D51, "playersetupjuggernautexo" },
    { 0x6D52, "playersetuprecordedturrethead" },
    { 0x6D53, "playersetupstreakprompt" },
    { 0x6D54, "playersetupturretenergybar" },
    { 0x6D55, "playersetupuavpaintoutline" },
    { 0x6D56, "playershouldshowhud" },
    { 0x6D57, "playershowfullstatic" },
    { 0x6D58, "playershowjuggernauthud" },
    { 0x6D59, "playershowstreakstaticfordamage" },
    { 0x6D5A, "playershowstreakstaticforrange" },
    { 0x6D5B, "playershowturretoverlay" },
    { 0x6D5C, "playerslookingforsafespawn" },
    { 0x6D5D, "playersnowfootsteps" },
    { 0x6D5E, "playersnowfootstepscrash" },
    { 0x6D5F, "playerspawned" },
    { 0x6D60, "playerspawnpos" },
    { 0x6D61, "playerspeed" },
    { 0x6D62, "playerspread" },
    { 0x6D63, "playerspeedscale" },
    { 0x6D64, "playerstartoutofboundsstatic" },
    { 0x6D65, "playerstartpromptforstreaksupport" },
    { 0x6D66, "playerstartusingassaultvehicle" },
    { 0x6D67, "playerstartweaponname" },
    { 0x6D68, "playerstatictonormal" },
    { 0x6D69, "playerstatus" },
    { 0x6D6A, "playerstealthkill" },
    { 0x6D6B, "playerstoppromptforstreaksupport" },
    { 0x6D6C, "playerswitchtobigturret" },
    { 0x6D6D, "playerswitchtomediumturret" },
    { 0x6D6E, "playerswitchtorocketturret" },
    { 0x6D6F, "playerswitchtoturret" },
    { 0x6D70, "playertakestreaksupportinput" },
    { 0x6D71, "playertargets" },
    { 0x6D72, "playerteam" },
    { 0x6D73, "playertouchingtrigger" },
    { 0x6D74, "playertouchtriggerthink" },
    { 0x6D75, "playertrackturretammo" },
    { 0x6D76, "playertriggered" },
    { 0x6D77, "playertweaks" },
    { 0x6D78, "playerunderwater" },
    { 0x6D79, "playerunlimitedammothread" },
    { 0x6D7A, "playerupdateflagstatus" },
    { 0x6D7B, "playerupdateflagstatusonjointeam" },
    { 0x6D7C, "playervehicle" },
    { 0x6D7D, "playerview_checkinterrupted" },
    { 0x6D7E, "playerview_endsequence" },
    { 0x6D7F, "playerview_knockdownanim" },
    { 0x6D80, "playerview_knockdownlate" },
    { 0x6D81, "playerview_playknockdownanim" },
    { 0x6D82, "playerview_playknockdownanimlimited" },
    { 0x6D83, "playerview_playmissanim" },
    { 0x6D84, "playerview_show" },
    { 0x6D85, "playerview_spawn" },
    { 0x6D86, "playerview_startsequence" },
    { 0x6D87, "playerview_unlinkplayeranddelete" },
    { 0x6D88, "playerwaitreset" },
    { 0x6D89, "playerwaittillgoliathactivated" },
    { 0x6D8A, "playerwaittillridekillstreakblack" },
    { 0x6D8B, "playerwaittillridekillstreakcomplete" },
    { 0x6D8C, "playerwaittillweaponswitchover" },
    { 0x6D8D, "playerwasnearby" },
    { 0x6D8E, "playerwatch_unresolved_collision" },
    { 0x6D8F, "playerwatch_unresolved_collision_count" },
    { 0x6D90, "playerwatchemp" },
    { 0x6D91, "playerwatchflagstatus" },
    { 0x6D92, "playerwatchforearlyexit" },
    { 0x6D93, "playerwatchnoobtubeuse" },
    { 0x6D94, "playerwatchrocketuse" },
    { 0x6D95, "playerwaterclearwait" },
    { 0x6D96, "playerweapon" },
    { 0x6D97, "playerweather" },
    { 0x6D98, "playerwithinfov2d" },
    { 0x6D99, "playerwristmodelanim" },
    { 0x6D9A, "playexplodedeathanim" },
    { 0x6D9B, "playface_waitfornotify" },
    { 0x6D9C, "playface_waitfortime" },
    { 0x6D9D, "playfacethread" },
    { 0x6D9E, "playfacialanim" },
    { 0x6D9F, "playfakecontrail" },
    { 0x6DA0, "playfireeffects" },
    { 0x6DA1, "playflavorburstline" },
    { 0x6DA2, "playfootstep" },
    { 0x6DA3, "playfootstepeffect" },
    { 0x6DA4, "playfootstepeffectsmall" },
    { 0x6DA5, "playfootstepoverride" },
    { 0x6DA6, "playfx_fordrop" },
    { 0x6DA7, "playfxent" },
    { 0x6DA8, "playfxontag_functionhack" },
    { 0x6DA9, "playfxontag_safe" },
    { 0x6DAA, "playfxturretmoveup" },
    { 0x6DAB, "playgrowl" },
    { 0x6DAC, "playheatfx" },
    { 0x6DAD, "playidle" },
    { 0x6DAE, "playidleanim" },
    { 0x6DAF, "playidleanimation" },
    { 0x6DB0, "playidleface" },
    { 0x6DB1, "playidlesound" },
    { 0x6DB2, "playinformevent" },
    { 0x6DB3, "playing_hit_reaction" },
    { 0x6DB4, "playing_lab_cinematic" },
    { 0x6DB5, "playing_new_enemy_reaction_anim" },
    { 0x6DB6, "playing_pain_sound" },
    { 0x6DB7, "playing_presets" },
    { 0x6DB8, "playing_view_model_cloak_toggle_anim" },
    { 0x6DB9, "playingdeathanim" },
    { 0x6DBA, "playingloopfiresounds" },
    { 0x6DBB, "playingmovementanim" },
    { 0x6DBC, "playinteriorsound" },
    { 0x6DBD, "playjetfx" },
    { 0x6DBE, "playlasercontainmentstart" },
    { 0x6DBF, "playlasercontainmentswap" },
    { 0x6DC0, "playlasercoreevent" },
    { 0x6DC1, "playlaserendingeffect" },
    { 0x6DC2, "playlingereffects" },
    { 0x6DC3, "playlocalsoundwrapper" },
    { 0x6DC4, "playlookanimation" },
    { 0x6DC5, "playloopedfxontag" },
    { 0x6DC6, "playloopedfxontag_originupdate" },
    { 0x6DC7, "playloopingsoundonorigin" },
    { 0x6DC8, "playloopsoundtoplayers" },
    { 0x6DC9, "playmoveanim" },
    { 0x6DCA, "playmoveanimknob" },
    { 0x6DCB, "playmovementsparks" },
    { 0x6DCC, "playmovesound" },
    { 0x6DCD, "playoceanfoam" },
    { 0x6DCE, "playorangegoo" },
    { 0x6DCF, "playorderevent" },
    { 0x6DD0, "playorstopfx_fordrop" },
    { 0x6DD1, "playpainanim" },
    { 0x6DD2, "playpanting" },
    { 0x6DD3, "playphrase" },
    { 0x6DD4, "playpropanim" },
    { 0x6DD5, "playreactionevent" },
    { 0x6DD6, "playresponseevent" },
    { 0x6DD7, "playrocketreloadsound" },
    { 0x6DD8, "playrocketswarmreloadsound" },
    { 0x6DD9, "playsmokefx" },
    { 0x6DDA, "playsound_and_light" },
    { 0x6DDB, "playsound_float" },
    { 0x6DDC, "playsound_loop_on_ent" },
    { 0x6DDD, "playsound_victim" },
    { 0x6DDE, "playsoundatpoint" },
    { 0x6DDF, "playsoundinspace" },
    { 0x6DE0, "playsoundonplayers" },
    { 0x6DE1, "playsoundtoallplayers" },
    { 0x6DE2, "playspace_explosion" },
    { 0x6DE3, "playspace_org" },
    { 0x6DE4, "playspinnerfx" },
    { 0x6DE5, "playtankexhaust" },
    { 0x6DE6, "playthreatevent" },
    { 0x6DE7, "playthrustereffects" },
    { 0x6DE8, "playtickingsound" },
    { 0x6DE9, "playtrailfx" },
    { 0x6DEA, "playtransitionanimation" },
    { 0x6DEB, "playtransitionanimationfunc" },
    { 0x6DEC, "playtransitionanimationthread_withoutwaitsetstates" },
    { 0x6DED, "playtransitionstandwalk" },
    { 0x6DEE, "playwarbirdenginefx" },
    { 0x6DEF, "playwarmupeffects" },
    { 0x6DF0, "playwarmupsounds" },
    { 0x6DF1, "playwaves" },
    { 0x6DF2, "plodding_footsteps" },
    { 0x6DF3, "plodding_footsteps_ends" },
    { 0x6DF4, "plot_points" },
    { 0x6DF5, "plr_dragged_away" },
    { 0x6DF6, "plr_exo_door_kick" },
    { 0x6DF7, "plr_fall_over" },
    { 0x6DF8, "pluggable_move_loop_override_function" },
    { 0x6DF9, "plugins" },
    { 0x6DFA, "plyr_forest_takedown_gun_wrestle" },
    { 0x6DFB, "plyr_forest_takedown_punch" },
    { 0x6DFC, "plyr_forest_takedown_tree_slam" },
    { 0x6DFD, "pm_clipvelocity" },
    { 0x6DFE, "pm_permuterestrictiveclipplanes" },
    { 0x6DFF, "pm_projectvelocity" },
    { 0x6E00, "pm_rescue_foley" },
    { 0x6E01, "pm_slidemove" },
    { 0x6E02, "pm_stepslidemove" },
    { 0x6E03, "pmap_under_construction" },
    { 0x6E04, "pmc_alljuggernauts" },
    { 0x6E05, "pmc_match" },
    { 0x6E06, "pod_cormack_custom_mats_landing_on" },
    { 0x6E07, "pod_cormack_custom_mats_on" },
    { 0x6E08, "pod_door_button_prompt" },
    { 0x6E09, "pod_enemies" },
    { 0x6E0A, "pod_engine_fx" },
    { 0x6E0B, "pod_flyin" },
    { 0x6E0C, "pod_fx_create" },
    { 0x6E0D, "pod_get_up" },
    { 0x6E0E, "pod_get_up_corrected" },
    { 0x6E0F, "pod_goes_flying" },
    { 0x6E10, "pod_intro_mix" },
    { 0x6E11, "pod_light_intro" },
    { 0x6E12, "pod_light_intro_pre" },
    { 0x6E13, "pod_light_strobe" },
    { 0x6E14, "pod_phase1a_start" },
    { 0x6E15, "pod_rumble" },
    { 0x6E16, "pod_screen" },
    { 0x6E17, "pod_scripted_lights" },
    { 0x6E18, "pod_shake_play" },
    { 0x6E19, "podrocket" },
    { 0x6E1A, "podsetuptrophyfx" },
    { 0x6E1B, "podsquad" },
    { 0x6E1C, "point" },
    { 0x6E1D, "point_in_angle_of_crosshairs" },
    { 0x6E1E, "point_in_fov" },
    { 0x6E1F, "point_inside" },
    { 0x6E20, "point_is_in_screen_circle" },
    { 0x6E21, "point_source_dambs" },
    { 0x6E22, "point_tag" },
    { 0x6E23, "point_tag2" },
    { 0x6E24, "point_to_ambush" },
    { 0x6E25, "point1" },
    { 0x6E26, "point2" },
    { 0x6E27, "pointblankevent" },
    { 0x6E28, "pointevents" },
    { 0x6E29, "pointinfov" },
    { 0x6E2A, "pointisinairstrikearea" },
    { 0x6E2B, "pointnotifylua" },
    { 0x6E2C, "poison" },
    { 0x6E2D, "police_drone_play_all_fx" },
    { 0x6E2E, "police_drone_play_anim" },
    { 0x6E2F, "police_drone_play_fx" },
    { 0x6E30, "poll_for_found" },
    { 0x6E31, "pollallowedstancesthread" },
    { 0x6E32, "pool" },
    { 0x6E33, "pool_building_enemy_think" },
    { 0x6E34, "pool_building_walkway_01_enemy_think" },
    { 0x6E35, "pool_civ_01_cower" },
    { 0x6E36, "pool_civ_01_cower_setup" },
    { 0x6E37, "pool_civ_wounded_woman" },
    { 0x6E38, "pool_female_wounded" },
    { 0x6E39, "pool_male_01_cower" },
    { 0x6E3A, "pool_walla_scream" },
    { 0x6E3B, "poolalliesadvance" },
    { 0x6E3C, "poolhouse_drones" },
    { 0x6E3D, "poolhouse_enemies" },
    { 0x6E3E, "poolhouse_prop_cleanup" },
    { 0x6E3F, "poolhouse_spawner_setup" },
    { 0x6E40, "poolindex" },
    { 0x6E41, "poolkillanimations" },
    { 0x6E42, "poolyard_guard_wander_setup" },
    { 0x6E43, "poolyard_guard_wander_watch_for_alert" },
    { 0x6E44, "pop_cormack_into_exfil_anim_to_match_player" },
    { 0x6E45, "pop_flares_when_fired_on" },
    { 0x6E46, "pop_up" },
    { 0x6E47, "pop_up_and_hide_speed" },
    { 0x6E48, "popinpopout" },
    { 0x6E49, "populate_ai_civilians" },
    { 0x6E4A, "populate_drone_civilians" },
    { 0x6E4B, "populatedronecivilians" },
    { 0x6E4C, "popupandshoot" },
    { 0x6E4D, "portable_mg_behavior" },
    { 0x6E4E, "portable_mg_gun_tag" },
    { 0x6E4F, "portable_mg_spot" },
    { 0x6E50, "portable_radar" },
    { 0x6E51, "portableradararray" },
    { 0x6E52, "portableradarbeepsounds" },
    { 0x6E53, "portableradardamagelistener" },
    { 0x6E54, "portableradarproximitytracker" },
    { 0x6E55, "portableradarsetup" },
    { 0x6E56, "portableradaruselistener" },
    { 0x6E57, "portableradarwatchowner" },
    { 0x6E58, "portal_group_off" },
    { 0x6E59, "portal_group_on" },
    { 0x6E5A, "pos" },
    { 0x6E5B, "pos_angle" },
    { 0x6E5C, "pos_array" },
    { 0x6E5D, "pose" },
    { 0x6E5E, "position_ally_for_bomb_plant" },
    { 0x6E5F, "position_elevators" },
    { 0x6E60, "position_error" },
    { 0x6E61, "position_for_movement" },
    { 0x6E62, "position_in_circle" },
    { 0x6E63, "position_in_spear" },
    { 0x6E64, "position_smoothing" },
    { 0x6E65, "positionptm" },
    { 0x6E66, "positivewrap" },
    { 0x6E67, "possesswarbird" },
    { 0x6E68, "possible" },
    { 0x6E69, "possible_targets" },
    { 0x6E6A, "possiblethreatcallouts" },
    { 0x6E6B, "post" },
    { 0x6E6C, "post_car_ride_cormack" },
    { 0x6E6D, "post_car_ride_player" },
    { 0x6E6E, "post_collapse_vfx_on_crash_site" },
    { 0x6E6F, "post_credits_still_image" },
    { 0x6E70, "post_entity_creation_function" },
    { 0x6E71, "post_event_geo" },
    { 0x6E72, "post_event_hp_zones" },
    { 0x6E73, "post_event_nodes" },
    { 0x6E74, "post_event_pathing_blockers" },
    { 0x6E75, "post_explosion_alarms" },
    { 0x6E76, "post_fire_function" },
    { 0x6E77, "post_h_breach_ajani_start" },
    { 0x6E78, "post_h_breach_burke_start" },
    { 0x6E79, "post_h_breach_joker_start" },
    { 0x6E7A, "post_intro_loop_anim" },
    { 0x6E7B, "post_intro_loop_anim_vm" },
    { 0x6E7C, "post_load" },
    { 0x6E7D, "post_load_funcs" },
    { 0x6E7E, "post_load_precache" },
    { 0x6E7F, "post_main_loop_anim" },
    { 0x6E80, "post_main_loop_anim_vm" },
    { 0x6E81, "post_middle_takedown_highway_path_player_side" },
    { 0x6E82, "post_middle_takedown_traffic_done" },
    { 0x6E83, "post_pod_intro_stuff" },
    { 0x6E84, "post_reactor_alarm" },
    { 0x6E85, "post_refuel" },
    { 0x6E86, "post_tower_axis_logic" },
    { 0x6E87, "post_tower_inits_precache" },
    { 0x6E88, "post_win_camshake" },
    { 0x6E89, "post_win_disable_rumbles" },
    { 0x6E8A, "postdeathkillevent" },
    { 0x6E8B, "postdna_mech_attack" },
    { 0x6E8C, "postgamenotifies" },
    { 0x6E8D, "postgamepromotion" },
    { 0x6E8E, "postpainfunc" },
    { 0x6E8F, "postroundtime" },
    { 0x6E90, "postscriptfunc" },
    { 0x6E91, "postspawn_rpg_vehicle" },
    { 0x6E92, "potentialscantargets" },
    { 0x6E93, "potentialtarget" },
    { 0x6E94, "potentialtargetanimations" },
    { 0x6E95, "pov_mode" },
    { 0x6E96, "power_outage_audio" },
    { 0x6E97, "practiceloadout" },
    { 0x6E98, "practiceround" },
    { 0x6E99, "practiceroundassistevent" },
    { 0x6E9A, "practiceroundclasstablename" },
    { 0x6E9B, "practiceroundcostumetablename" },
    { 0x6E9C, "practicerounddialogplayed" },
    { 0x6E9D, "practicerounddialogvalid" },
    { 0x6E9E, "practiceroundgame" },
    { 0x6E9F, "practiceroundkillevent" },
    { 0x6EA0, "pre_bomb_plant_lighting" },
    { 0x6EA1, "pre_bridge_collapse_helo_idle" },
    { 0x6EA2, "pre_bridge_collapse_scene" },
    { 0x6EA3, "pre_event_hp_zones" },
    { 0x6EA4, "pre_event_nodes" },
    { 0x6EA5, "pre_event_pathing_blockers" },
    { 0x6EA6, "pre_fire_function" },
    { 0x6EA7, "pre_guesthouse_vo" },
    { 0x6EA8, "pre_h_breach_ajani_start" },
    { 0x6EA9, "pre_h_breach_burke_start" },
    { 0x6EAA, "pre_h_breach_joker_start" },
    { 0x6EAB, "pre_hack_security_check" },
    { 0x6EAC, "pre_hangar_hall_explosion" },
    { 0x6EAD, "pre_load" },
    { 0x6EAE, "pre_lobby_framedelay" },
    { 0x6EAF, "pre_lobby_update" },
    { 0x6EB0, "pre_reactor_alarms" },
    { 0x6EB1, "pre_spotted_func" },
    { 0x6EB2, "pre_unload" },
    { 0x6EB3, "pre_unload_idle" },
    { 0x6EB4, "prebreachcurrentweapon" },
    { 0x6EB5, "precache_big_cave" },
    { 0x6EB6, "precache_boost_fx_npc" },
    { 0x6EB7, "precache_boost_fx_player" },
    { 0x6EB8, "precache_cave_entry" },
    { 0x6EB9, "precache_cave_hallway" },
    { 0x6EBA, "precache_code" },
    { 0x6EBB, "precache_combat_cave" },
    { 0x6EBC, "precache_crash_site" },
    { 0x6EBD, "precache_destructible" },
    { 0x6EBE, "precache_destructibles" },
    { 0x6EBF, "precache_exo_temperature" },
    { 0x6EC0, "precache_for_hovertank" },
    { 0x6EC1, "precache_fx" },
    { 0x6EC2, "precache_ice_bridge" },
    { 0x6EC3, "precache_icons" },
    { 0x6EC4, "precache_lake" },
    { 0x6EC5, "precache_lake_cinema" },
    { 0x6EC6, "precache_lui_event_strings" },
    { 0x6EC7, "precache_lui_hovertank_screens" },
    { 0x6EC8, "precache_main" },
    { 0x6EC9, "precache_microwave_anims" },
    { 0x6ECA, "precache_microwave_grenade_fx" },
    { 0x6ECB, "precache_narrow_cave" },
    { 0x6ECC, "precache_overlook" },
    { 0x6ECD, "precache_player_land_assist" },
    { 0x6ECE, "precache_presets" },
    { 0x6ECF, "precache_scanner_turret" },
    { 0x6ED0, "precache_script" },
    { 0x6ED1, "precache_script_models" },
    { 0x6ED2, "precache_scripts" },
    { 0x6ED3, "precache_skyjack" },
    { 0x6ED4, "precache_stuff" },
    { 0x6ED5, "precache_var_grenade_fx" },
    { 0x6ED6, "precache_vtol_takedown" },
    { 0x6ED7, "precacheanims" },
    { 0x6ED8, "precacheassets" },
    { 0x6ED9, "precacheassets_and_initflags" },
    { 0x6EDA, "precachecivilian" },
    { 0x6EDB, "precacheciviliananims" },
    { 0x6EDC, "precachedooranimations" },
    { 0x6EDD, "precacheflags" },
    { 0x6EDE, "precachefx" },
    { 0x6EDF, "precacheharmonicbreach" },
    { 0x6EE0, "precacheharmonicbreachanimations" },
    { 0x6EE1, "precacheharmonicbreachfx" },
    { 0x6EE2, "precacheharmonicbreachitems" },
    { 0x6EE3, "precacheharmonicbreachplayerrig" },
    { 0x6EE4, "precachemodelarray" },
    { 0x6EE5, "precacheorbital" },
    { 0x6EE6, "precachepropmodels" },
    { 0x6EE7, "precachescriptmodelanimations" },
    { 0x6EE8, "precachescriptmodelanims" },
    { 0x6EE9, "precachesecuritycamera" },
    { 0x6EEA, "precachesetup" },
    { 0x6EEB, "precachevehicleanimations" },
    { 0x6EEC, "precisepositioning" },
    { 0x6EED, "predamageshieldignoreme" },
    { 0x6EEE, "preending_confculldist" },
    { 0x6EEF, "preferalliesbydistance" },
    { 0x6EF0, "preferbyteambase" },
    { 0x6EF1, "preferdompoints" },
    { 0x6EF2, "preferhardpointpoints" },
    { 0x6EF3, "preferplayeranchors" },
    { 0x6EF4, "preferred_crash_location" },
    { 0x6EF5, "preferred_crash_style" },
    { 0x6EF6, "preferred_death_anim" },
    { 0x6EF7, "preferredoffsetfromowner" },
    { 0x6EF8, "preferredtarget" },
    { 0x6EF9, "prefers_drones" },
    { 0x6EFA, "prefertwarzone" },
    { 0x6EFB, "preflight_vo" },
    { 0x6EFC, "prekillcamnotify" },
    { 0x6EFD, "prekilledfunc" },
    { 0x6EFE, "preload" },
    { 0x6EFF, "preloadweapons" },
    { 0x6F00, "prelobby_camera_ratio" },
    { 0x6F01, "prelobby_camerazoff" },
    { 0x6F02, "prelobby_camerazoff_zoom" },
    { 0x6F03, "prelobby_fardist" },
    { 0x6F04, "prelobby_movespeed" },
    { 0x6F05, "prelobby_neardist" },
    { 0x6F06, "prelobby_ratio_zoom" },
    { 0x6F07, "prelobby_targetzoff" },
    { 0x6F08, "prelobby_targetzoff_zoom" },
    { 0x6F09, "prelobbyzoom" },
    { 0x6F0A, "prematch_done_time" },
    { 0x6F0B, "prematch_over" },
    { 0x6F0C, "prematchperiod" },
    { 0x6F0D, "prematchperiodend" },
    { 0x6F0E, "prematurecornergrenadedeath" },
    { 0x6F0F, "prep_bobbing" },
    { 0x6F10, "prep_cinematic" },
    { 0x6F11, "prep_ending" },
    { 0x6F12, "prep_for_controls" },
    { 0x6F13, "prep_user_for_drone" },
    { 0x6F14, "prep_user_for_dronecrate" },
    { 0x6F15, "prepare_blast_doors" },
    { 0x6F16, "prepare_dialog" },
    { 0x6F17, "prepare_dialogue" },
    { 0x6F18, "prepare_option_for_change" },
    { 0x6F19, "prepare_show_threat" },
    { 0x6F1A, "prepare_to_be_shot" },
    { 0x6F1B, "prepare_to_teleport" },
    { 0x6F1C, "prepareattackplayer" },
    { 0x6F1D, "prepared" },
    { 0x6F1E, "prepareforclasschange" },
    { 0x6F1F, "preplaced_guys_function" },
    { 0x6F20, "preplacedpostscriptfunc" },
    { 0x6F21, "prereqs" },
    { 0x6F22, "preset_cache" },
    { 0x6F23, "preset_constructors" },
    { 0x6F24, "preset_name" },
    { 0x6F25, "presets" },
    { 0x6F26, "president" },
    { 0x6F27, "presseddown" },
    { 0x6F28, "pressedup" },
    { 0x6F29, "presses" },
    { 0x6F2A, "pressure_explosion" },
    { 0x6F2B, "pressure_explosion_damage" },
    { 0x6F2C, "pressure_explosion_lead_up" },
    { 0x6F2D, "pressure_explosion_leadup_1" },
    { 0x6F2E, "pressure_explosion_leadup_2" },
    { 0x6F2F, "pressure_explosion_leadup_3" },
    { 0x6F30, "pressure_explosion_leadup_4" },
    { 0x6F31, "pressure_explosion_leadup_5" },
    { 0x6F32, "pressure_explosion_leadup_6" },
    { 0x6F33, "pressure_explosion_leadup_7" },
    { 0x6F34, "pretend_to_be_dead" },
    { 0x6F35, "pretending_to_be_dead" },
    { 0x6F36, "prev" },
    { 0x6F37, "prev_accel_oneshot_time" },
    { 0x6F38, "prev_attached_path" },
    { 0x6F39, "prev_attachedpath" },
    { 0x6F3A, "prev_cue_name" },
    { 0x6F3B, "prev_defend_node" },
    { 0x6F3C, "prev_dist" },
    { 0x6F3D, "prev_dp" },
    { 0x6F3E, "prev_dv" },
    { 0x6F3F, "prev_dx" },
    { 0x6F40, "prev_eyel_diff" },
    { 0x6F41, "prev_eyer_diff" },
    { 0x6F42, "prev_height" },
    { 0x6F43, "prev_impacttime" },
    { 0x6F44, "prev_node" },
    { 0x6F45, "prev_pitch" },
    { 0x6F46, "prev_rate" },
    { 0x6F47, "prev_role" },
    { 0x6F48, "prev_speed" },
    { 0x6F49, "prev_state" },
    { 0x6F4A, "prev_throttle" },
    { 0x6F4B, "prev_time" },
    { 0x6F4C, "prev_turret_state" },
    { 0x6F4D, "prev_velo" },
    { 0x6F4E, "prev_yards" },
    { 0x6F4F, "prev_zv" },
    { 0x6F50, "prevattack" },
    { 0x6F51, "prevenemy" },
    { 0x6F52, "prevent_friendly_from_shooting_during_stealth" },
    { 0x6F53, "prevent_look_until_notify" },
    { 0x6F54, "prevent_tracking_drone_in_water" },
    { 0x6F55, "preventpainforashorttime" },
    { 0x6F56, "prevframevelocity" },
    { 0x6F57, "previewcostume" },
    { 0x6F58, "previewgearcategory" },
    { 0x6F59, "previewgearid" },
    { 0x6F5A, "previous_bump_zvel" },
    { 0x6F5B, "previous_button" },
    { 0x6F5C, "previous_intensityhdr" },
    { 0x6F5D, "previous_position" },
    { 0x6F5E, "previous_turret_target" },
    { 0x6F5F, "previous_weapon" },
    { 0x6F60, "previous_yaw" },
    { 0x6F61, "previousadrenaline" },
    { 0x6F62, "previousadrenalinesupport" },
    { 0x6F63, "previousclasstime" },
    { 0x6F64, "previousgoalnode" },
    { 0x6F65, "previousintensityhdr" },
    { 0x6F66, "previously_played_fx_joint_l" },
    { 0x6F67, "previously_played_fx_joint_r" },
    { 0x6F68, "previously_played_fx_name_l" },
    { 0x6F69, "previously_played_fx_name_r" },
    { 0x6F6A, "previouspitchdelta" },
    { 0x6F6B, "previousprimary" },
    { 0x6F6C, "previoustrackedplayer" },
    { 0x6F6D, "prevleanfracpitch" },
    { 0x6F6E, "prevleanfracyaw" },
    { 0x6F6F, "prevlethalvarclass" },
    { 0x6F70, "prevlethalvartype" },
    { 0x6F71, "prevmovearchetype" },
    { 0x6F72, "prevmovemode" },
    { 0x6F73, "prevmovestate" },
    { 0x6F74, "prevnameplatematerial" },
    { 0x6F75, "prevownerteam" },
    { 0x6F76, "prevputguninhandtime" },
    { 0x6F77, "prevsnowmobiledeath" },
    { 0x6F78, "prevsnowmobiledeathtime" },
    { 0x6F79, "prevstairsstate" },
    { 0x6F7A, "prevstance" },
    { 0x6F7B, "prevtacticalvarclass" },
    { 0x6F7C, "prevtacticalvartype" },
    { 0x6F7D, "prevturnrate" },
    { 0x6F7E, "prevzoneindex" },
    { 0x6F7F, "price" },
    { 0x6F80, "price_breach_ent" },
    { 0x6F81, "price_breach_ent_movesto_player" },
    { 0x6F82, "price_breach_ent_rotatesto_player" },
    { 0x6F83, "primary_light" },
    { 0x6F84, "primary_weapon_array" },
    { 0x6F85, "primaryattachment" },
    { 0x6F86, "primarygrenade" },
    { 0x6F87, "primaryname" },
    { 0x6F88, "primaryprogressbarfontsize" },
    { 0x6F89, "primaryprogressbarheight" },
    { 0x6F8A, "primaryprogressbartextx" },
    { 0x6F8B, "primaryprogressbartexty" },
    { 0x6F8C, "primaryprogressbarwidth" },
    { 0x6F8D, "primaryprogressbarx" },
    { 0x6F8E, "primaryprogressbary" },
    { 0x6F8F, "primarytarget" },
    { 0x6F90, "primarytorestore" },
    { 0x6F91, "primaryturretanim" },
    { 0x6F92, "primaryweaponent" },
    { 0x6F93, "primaryweapons" },
    { 0x6F94, "primaryweaponsammo" },
    { 0x6F95, "primer" },
    { 0x6F96, "print_altitude" },
    { 0x6F97, "print_csv_asset" },
    { 0x6F98, "print_debug_text_hud" },
    { 0x6F99, "print_debug_text_string_hud" },
    { 0x6F9A, "print_distance_on_ent" },
    { 0x6F9B, "print_fx_options" },
    { 0x6F9C, "print_org" },
    { 0x6F9D, "print_roll" },
    { 0x6F9E, "print_speed" },
    { 0x6F9F, "print_state" },
    { 0x6FA0, "print_throttle" },
    { 0x6FA1, "print_tilt" },
    { 0x6FA2, "print_vehicle_info" },
    { 0x6FA3, "print_yaw" },
    { 0x6FA4, "print3d_over_target" },
    { 0x6FA5, "print3d_time" },
    { 0x6FA6, "print3ddraw" },
    { 0x6FA7, "print3dfortime" },
    { 0x6FA8, "print3drise" },
    { 0x6FA9, "print3dthread" },
    { 0x6FAA, "print3dtime" },
    { 0x6FAB, "print3duntilnotify" },
    { 0x6FAC, "printabovehead" },
    { 0x6FAD, "printandsoundoneveryone" },
    { 0x6FAE, "printandsoundonplayer" },
    { 0x6FAF, "printandsoundonteam" },
    { 0x6FB0, "printboldonteam" },
    { 0x6FB1, "printboldonteamarg" },
    { 0x6FB2, "printdisplaceinfo" },
    { 0x6FB3, "printer" },
    { 0x6FB4, "printerdebugger" },
    { 0x6FB5, "printhealthtoscreen" },
    { 0x6FB6, "printlnscreenandconsole" },
    { 0x6FB7, "printonplayers" },
    { 0x6FB8, "printonteam" },
    { 0x6FB9, "printonteamarg" },
    { 0x6FBA, "printorigin3duntilnotify" },
    { 0x6FBB, "printshoot" },
    { 0x6FBC, "printshootproc" },
    { 0x6FBD, "printyaws" },
    { 0x6FBE, "printyawtoenemy" },
    { 0x6FBF, "prioritize_colorcoded_nodes" },
    { 0x6FC0, "prioritize_watch_nodes_toward_enemies" },
    { 0x6FC1, "priority" },
    { 0x6FC2, "priority_sort" },
    { 0x6FC3, "priority_vols" },
    { 0x6FC4, "prison_turret_active" },
    { 0x6FC5, "prison_turret_alarm_sfx" },
    { 0x6FC6, "prison_turret_burn_sfx" },
    { 0x6FC7, "prison_turret_laser_glow" },
    { 0x6FC8, "prison_turret_warning_light_enemy" },
    { 0x6FC9, "prison_turret_warning_light_friendly" },
    { 0x6FCA, "prison_turrets" },
    { 0x6FCB, "prison_turrets_alive" },
    { 0x6FCC, "prisoncustomkillstreakfunc" },
    { 0x6FCD, "prisoner_6_shadow_and_loop" },
    { 0x6FCE, "prisoner_randomizer" },
    { 0x6FCF, "prisonpaladinoverrides" },
    { 0x6FD0, "prisonturretportableradar" },
    { 0x6FD1, "prisonturrettimer" },
    { 0x6FD2, "prisonturrettrackingoverlay" },
    { 0x6FD3, "privatematch" },
    { 0x6FD4, "pro_cave_get_up" },
    { 0x6FD5, "pro_cave_grabbing_gun" },
    { 0x6FD6, "pro_cave_help_ilona" },
    { 0x6FD7, "pro_cave_helped_up" },
    { 0x6FD8, "pro_cave_ilona_pick_up_gun" },
    { 0x6FD9, "pro_cave_pick_up_gun" },
    { 0x6FDA, "pro_cave_roll_over" },
    { 0x6FDB, "pro_cave_stowing_gun" },
    { 0x6FDC, "pro_hall_follow_dot" },
    { 0x6FDD, "prob_scale" },
    { 0x6FDE, "probability" },
    { 0x6FDF, "probedistancemethod" },
    { 0x6FE0, "process" },
    { 0x6FE1, "process_animation" },
    { 0x6FE2, "process_blend" },
    { 0x6FE3, "process_button_held_and_clicked" },
    { 0x6FE4, "process_buttonmash" },
    { 0x6FE5, "process_buttonmash_finale_scene" },
    { 0x6FE6, "process_buttonmash_handle_fail" },
    { 0x6FE7, "process_buttonmash_handle_hint" },
    { 0x6FE8, "process_color_order_to_ai" },
    { 0x6FE9, "process_cover_node" },
    { 0x6FEA, "process_cover_node_with_last_in_mind_allies" },
    { 0x6FEB, "process_cover_node_with_last_in_mind_axis" },
    { 0x6FEC, "process_deathflags" },
    { 0x6FED, "process_flight_path" },
    { 0x6FEE, "process_fov" },
    { 0x6FEF, "process_fx_rotater" },
    { 0x6FF0, "process_melee_notetracks" },
    { 0x6FF1, "process_moving_platform_death" },
    { 0x6FF2, "process_path_node" },
    { 0x6FF3, "process_reticle_multikill" },
    { 0x6FF4, "process_screen_shake" },
    { 0x6FF5, "process_stab_finale_scene" },
    { 0x6FF6, "process_traffic_leader_pending_due_to_lane_split" },
    { 0x6FF7, "processassistevent" },
    { 0x6FF8, "processattachments" },
    { 0x6FF9, "processchallenge" },
    { 0x6FFA, "processdamagetaken" },
    { 0x6FFB, "processed" },
    { 0x6FFC, "processed_trigger" },
    { 0x6FFD, "processing_emp_death_function" },
    { 0x6FFE, "processingkilledchallenges" },
    { 0x6FFF, "processlobbydata" },
    { 0x7000, "processlobbyscoreboards" },
    { 0x7001, "processviaitemstatsprogress" },
    { 0x7002, "processviaitemstatsstate" },
    { 0x7003, "progress" },
    { 0x7004, "progress_bar" },
    { 0x7005, "progress_dif" },
    { 0x7006, "progress_maps" },
    { 0x7007, "progress_node" },
    { 0x7008, "progress_path_create" },
    { 0x7009, "progress_path_get_my_node_from_org" },
    { 0x700A, "progress_path_move_to_correct_node" },
    { 0x700B, "progress_trigger_callbacks" },
    { 0x700C, "progressioncombat" },
    { 0x700D, "progressionkillhades" },
    { 0x700E, "progressionoutro" },
    { 0x700F, "progressionsupportphase1" },
    { 0x7010, "progressionsupportphase2" },
    { 0x7011, "progressionsupportphase3" },
    { 0x7012, "project_into_plane" },
    { 0x7013, "project_perpendicular" },
    { 0x7014, "projectile" },
    { 0x7015, "projectile_alive" },
    { 0x7016, "projectileexplode" },
    { 0x7017, "projectilesstopped" },
    { 0x7018, "projector" },
    { 0x7019, "promote_nearest_friendly" },
    { 0x701A, "promote_nearest_friendly_with_classname" },
    { 0x701B, "promotionsplashnotify" },
    { 0x701C, "prompt_show_hide" },
    { 0x701D, "promptforstreaksupport" },
    { 0x701E, "promptid" },
    { 0x701F, "prone_anim_override" },
    { 0x7020, "prone_hint_trigger" },
    { 0x7021, "prone_rate_override" },
    { 0x7022, "prone_transitionto" },
    { 0x7023, "prone_visible_from" },
    { 0x7024, "proneaiming" },
    { 0x7025, "pronecombatmainloop" },
    { 0x7026, "pronecrawl" },
    { 0x7027, "pronecrawltoprone" },
    { 0x7028, "pronelegsstraighttree" },
    { 0x7029, "pronereload" },
    { 0x702A, "pronerun_begin" },
    { 0x702B, "pronestill" },
    { 0x702C, "pronestop_begin" },
    { 0x702D, "pronetime" },
    { 0x702E, "proneto" },
    { 0x702F, "pronetocrouch" },
    { 0x7030, "pronetocrouchrun" },
    { 0x7031, "pronetocrouchwalk" },
    { 0x7032, "pronetopronemove" },
    { 0x7033, "pronetopronerun" },
    { 0x7034, "pronetostand" },
    { 0x7035, "pronetostandrun" },
    { 0x7036, "pronetostandwalk" },
    { 0x7037, "pronewalk_begin" },
    { 0x7038, "prop_anims" },
    { 0x7039, "prop_cig_throw" },
    { 0x703A, "prop_delete" },
    { 0x703B, "prop_delete_cig" },
    { 0x703C, "prop_notetrack_exist" },
    { 0x703D, "prop_notetracks" },
    { 0x703E, "prop10_drones" },
    { 0x703F, "prop30" },
    { 0x7040, "propanims" },
    { 0x7041, "propsendinganimations" },
    { 0x7042, "protect_radius" },
    { 0x7043, "protect_watch_allies" },
    { 0x7044, "proxbar" },
    { 0x7045, "proxbartext" },
    { 0x7046, "proxtriggerlos" },
    { 0x7047, "proxtriggerthink" },
    { 0x7048, "proxy" },
    { 0x7049, "proxy_alarm_on" },
    { 0x704A, "prv_cac" },
    { 0x704B, "prv_cac_weapon" },
    { 0x704C, "prv_vl_cao_focus" },
    { 0x704D, "ps_item" },
    { 0x704E, "pull_fence_dust" },
    { 0x704F, "pulse" },
    { 0x7050, "pulse_button_timeout" },
    { 0x7051, "pulse_compass_text" },
    { 0x7052, "pulse_fx" },
    { 0x7053, "pulse_presets" },
    { 0x7054, "pulse_think" },
    { 0x7055, "pulseorbitalsupportreloadtext" },
    { 0x7056, "punch_door" },
    { 0x7057, "punish_view_level" },
    { 0x7058, "punishment" },
    { 0x7059, "punishment_anim" },
    { 0x705A, "punishment_check" },
    { 0x705B, "punishment_level" },
    { 0x705C, "punishment_push" },
    { 0x705D, "punishment_recovery" },
    { 0x705E, "pursue_player" },
    { 0x705F, "push_dude_into_shelves" },
    { 0x7060, "push_item_on_que" },
    { 0x7061, "push_right_after_flag" },
    { 0x7062, "pushmode" },
    { 0x7063, "pushpoint" },
    { 0x7064, "put_bridge_in_proper_place" },
    { 0x7065, "put_cardoor_on_will" },
    { 0x7066, "put_roadsurface_in_proper_place" },
    { 0x7067, "put_toy_in_volume" },
    { 0x7068, "putgunaway" },
    { 0x7069, "putgunbackinhandonkillanimscript" },
    { 0x706A, "putguninhand" },
    { 0x706B, "putweaponbackinrighthand" },
    { 0x706C, "pv_maxlrgvelocity" },
    { 0x706D, "pv_maxmedvelocity" },
    { 0x706E, "pv_maxsmlvelocity" },
    { 0x706F, "pv_maxvelocity" },
    { 0x7070, "pv_minvelocitythreshold" },
    { 0x7071, "pv_numvelocityranges" },
    { 0x7072, "pyramid_death_report" },
    { 0x7073, "pyramid_spawn" },
    { 0x7074, "pyramid_spawner_reports_death" },
    { 0x7075, "q" },
    { 0x7076, "qafinished" },
    { 0x7077, "qsetgoalpos" },
    { 0x7078, "qte_fail_off" },
    { 0x7079, "qte_grab_hold_off" },
    { 0x707A, "qte_middle_dodge_off" },
    { 0x707B, "qte_middle_jump_off" },
    { 0x707C, "qte_middle_pull_kva_off" },
    { 0x707D, "qte_middle_pull_windshield_off" },
    { 0x707E, "qte_middle_shoot_off" },
    { 0x707F, "qte_pry_open_off" },
    { 0x7080, "qte_shoot_kva_off" },
    { 0x7081, "qte_success_off" },
    { 0x7082, "qte_swim_off" },
    { 0x7083, "quad_enable" },
    { 0x7084, "quadrant_display" },
    { 0x7085, "quadrantanimweights" },
    { 0x7086, "qualityspotshadow" },
    { 0x7087, "quarter_up_position" },
    { 0x7088, "queen" },
    { 0x7089, "queen_change_path" },
    { 0x708A, "queen_count" },
    { 0x708B, "queen_curl" },
    { 0x708C, "queen_data_accel" },
    { 0x708D, "queen_data_decel" },
    { 0x708E, "queen_data_desired_speed" },
    { 0x708F, "queen_data_follow_radii" },
    { 0x7090, "queen_deadzone" },
    { 0x7091, "queen_drone_fly" },
    { 0x7092, "queen_drone_form_hemisphere" },
    { 0x7093, "queen_drone_gopath" },
    { 0x7094, "queen_factor" },
    { 0x7095, "queen_follow_anim" },
    { 0x7096, "queen_relative_speed" },
    { 0x7097, "querymemberanimstate" },
    { 0x7098, "querymemberstate" },
    { 0x7099, "queueadd" },
    { 0x709A, "queueanim" },
    { 0x709B, "queuecreate" },
    { 0x709C, "queued_anim_threads" },
    { 0x709D, "queueremovefirst" },
    { 0x709E, "queues" },
    { 0x709F, "quick_cursor" },
    { 0x70A0, "quick_death" },
    { 0x70A1, "quick_pulse" },
    { 0x70A2, "quick_transition_flash" },
    { 0x70A3, "quickcommands" },
    { 0x70A4, "quickgunlevelevent" },
    { 0x70A5, "quickmessagetoall" },
    { 0x70A6, "quickresponses" },
    { 0x70A7, "quicksort" },
    { 0x70A8, "quicksort_compare" },
    { 0x70A9, "quicksort_flag_compare" },
    { 0x70AA, "quicksortmid" },
    { 0x70AB, "quickstatements" },
    { 0x70AC, "r" },
    { 0x70AD, "r_hudoutlineenable" },
    { 0x70AE, "r_hudoutlinehaloblurradius" },
    { 0x70AF, "r_hudoutlinehalolumscale" },
    { 0x70B0, "r_hudoutlinepostmode" },
    { 0x70B1, "radar_dish_rotate" },
    { 0x70B2, "radarmover" },
    { 0x70B3, "radial_angle_to_vector" },
    { 0x70B4, "radial_button_current_group" },
    { 0x70B5, "radial_button_definitions" },
    { 0x70B6, "radial_button_group" },
    { 0x70B7, "radial_button_group_info" },
    { 0x70B8, "radial_button_previous_group" },
    { 0x70B9, "radial_init" },
    { 0x70BA, "radiant_pos" },
    { 0x70BB, "radiation_totalpercent" },
    { 0x70BC, "radii" },
    { 0x70BD, "radio_add" },
    { 0x70BE, "radio_chatter" },
    { 0x70BF, "radio_dialog_add_and_go" },
    { 0x70C0, "radio_dialogue" },
    { 0x70C1, "radio_dialogue_clear_stack" },
    { 0x70C2, "radio_dialogue_interupt" },
    { 0x70C3, "radio_dialogue_nag_loop" },
    { 0x70C4, "radio_dialogue_overlap" },
    { 0x70C5, "radio_dialogue_overlap_stop" },
    { 0x70C6, "radio_dialogue_play" },
    { 0x70C7, "radio_dialogue_queue" },
    { 0x70C8, "radio_dialogue_queue_global" },
    { 0x70C9, "radio_dialogue_queue_single" },
    { 0x70CA, "radio_dialogue_remove_from_stack" },
    { 0x70CB, "radio_dialogue_safe" },
    { 0x70CC, "radio_dialogue_stop" },
    { 0x70CD, "radio_queue_thread" },
    { 0x70CE, "radio_run_guy" },
    { 0x70CF, "radio_try_squelch_out" },
    { 0x70D0, "radio_walkby_guy_vo" },
    { 0x70D1, "radiometricunithdr" },
    { 0x70D2, "radiometricunitshdr" },
    { 0x70D3, "radiosity" },
    { 0x70D4, "radiosityhdr" },
    { 0x70D5, "radiosityscale" },
    { 0x70D6, "radiosityscale_ng" },
    { 0x70D7, "radiosityscalehdr" },
    { 0x70D8, "radius_pos" },
    { 0x70D9, "radiusartilleryshellshock" },
    { 0x70DA, "radiussq" },
    { 0x70DB, "ragdoll_corpses" },
    { 0x70DC, "ragdoll_directionscale" },
    { 0x70DD, "ragdoll_fall_anim" },
    { 0x70DE, "ragdoll_getout_death" },
    { 0x70DF, "ragdoll_immediate" },
    { 0x70E0, "ragdoll_start_vel" },
    { 0x70E1, "ragdolldeath" },
    { 0x70E2, "ragdollonfirefx" },
    { 0x70E3, "ragdolltime" },
    { 0x70E4, "rail_gun_done" },
    { 0x70E5, "rail_gun_start" },
    { 0x70E6, "rail_gun_warbird_damage_function" },
    { 0x70E7, "railgun_ambient_air" },
    { 0x70E8, "railgun_cargo_ship_missiles" },
    { 0x70E9, "railgun_charge" },
    { 0x70EA, "railgun_damage_timer" },
    { 0x70EB, "railgun_enemies" },
    { 0x70EC, "railgun_hud_update" },
    { 0x70ED, "railgun_minigun_1" },
    { 0x70EE, "railgun_minigun_fire" },
    { 0x70EF, "railgun_missile_impact" },
    { 0x70F0, "railgun_ready" },
    { 0x70F1, "railgun_track_damage" },
    { 0x70F2, "railgun_track_damage_static" },
    { 0x70F3, "railgun_warbird_think" },
    { 0x70F4, "railing_dangerzone_think" },
    { 0x70F5, "rain" },
    { 0x70F6, "rain_attach_player_drizzle" },
    { 0x70F7, "rain_attach_player_heavy" },
    { 0x70F8, "rain_attach_player_heavy_speedy" },
    { 0x70F9, "rain_attach_player_medium" },
    { 0x70FA, "rain_elevator_fx" },
    { 0x70FB, "raineffectchange" },
    { 0x70FC, "rainhard" },
    { 0x70FD, "raininit" },
    { 0x70FE, "rainlevel" },
    { 0x70FF, "rainlevelrandomwait" },
    { 0x7100, "rainlevelwait" },
    { 0x7101, "rainlight" },
    { 0x7102, "rainmedium" },
    { 0x7103, "rainnone" },
    { 0x7104, "raise_blast_doors" },
    { 0x7105, "raise_shield" },
    { 0x7106, "rake_with_bullets" },
    { 0x7107, "rambo" },
    { 0x7108, "ramboaccuracymult" },
    { 0x7109, "ramboaim" },
    { 0x710A, "ramboaiminternal" },
    { 0x710B, "ramboanims" },
    { 0x710C, "rambochance" },
    { 0x710D, "ramp_down_motion_blur" },
    { 0x710E, "ramp_up_motion_blur" },
    { 0x710F, "rand_pos_or_neg" },
    { 0x7110, "rand_second_accel_thresh" },
    { 0x7111, "random" },
    { 0x7112, "random_bloody_death" },
    { 0x7113, "random_damage" },
    { 0x7114, "random_dog_barks" },
    { 0x7115, "random_drag_amount" },
    { 0x7116, "random_dynamic_attachment" },
    { 0x7117, "random_factor" },
    { 0x7118, "random_killer_update" },
    { 0x7119, "random_killspawner" },
    { 0x711A, "random_move_rate_blend" },
    { 0x711B, "random_spawn" },
    { 0x711C, "random_spread" },
    { 0x711D, "random_vector" },
    { 0x711E, "random_weight" },
    { 0x711F, "random_weight_sorted" },
    { 0x7120, "randomaditionaltime" },
    { 0x7121, "randomanimoftwo" },
    { 0x7122, "randomfasteranimspeed" },
    { 0x7123, "randomgrenaderange" },
    { 0x7124, "randomidleanimation" },
    { 0x7125, "randomidleanims" },
    { 0x7126, "randomintrange_limit" },
    { 0x7127, "randominttable" },
    { 0x7128, "randominttablesize" },
    { 0x7129, "randomize_flock_positions" },
    { 0x712A, "randomize_name_list" },
    { 0x712B, "randomize_turret_spread" },
    { 0x712C, "randomizeidleset" },
    { 0x712D, "randomoccurrance" },
    { 0x712E, "randompathstoptime" },
    { 0x712F, "randomspawnscore" },
    { 0x7130, "randomvector" },
    { 0x7131, "randomvectorincone" },
    { 0x7132, "randomvectorrange" },
    { 0x7133, "randomzonespawn" },
    { 0x7134, "range" },
    { 0x7135, "range_name" },
    { 0x7136, "range_slop" },
    { 0x7137, "rangeinmeters" },
    { 0x7138, "ranges" },
    { 0x7139, "rank_for_items" },
    { 0x713A, "rankedmatch" },
    { 0x713B, "rankedmatchupdates" },
    { 0x713C, "rankingenabled" },
    { 0x713D, "ranktable" },
    { 0x713E, "rankupsplashnotify" },
    { 0x713F, "rankxp" },
    { 0x7140, "rappel_animation_rumbles" },
    { 0x7141, "rappel_control_hint" },
    { 0x7142, "rappel_kill_achievement" },
    { 0x7143, "rappel_rumbles" },
    { 0x7144, "rappel_vo_callouts" },
    { 0x7145, "rappeller" },
    { 0x7146, "rateofchange" },
    { 0x7147, "raven_player_can_see_ai" },
    { 0x7148, "raw_weight" },
    { 0x7149, "razor_cormack_hand_on_crate" },
    { 0x714A, "razor_cormack_reaches_crate" },
    { 0x714B, "razor_cormack_stowing_gun" },
    { 0x714C, "razor_crate_move" },
    { 0x714D, "razor_player_hand_off_crate" },
    { 0x714E, "razor_player_hand_on_crate" },
    { 0x714F, "razor_rb_hatch_close" },
    { 0x7150, "razor_rb_lifting_off" },
    { 0x7151, "razor_rb_missile_hit" },
    { 0x7152, "razor_rb_missile_launch" },
    { 0x7153, "razor_surface_override_function" },
    { 0x7154, "razorback" },
    { 0x7155, "razorback_cargo" },
    { 0x7156, "razorback_cargo_player" },
    { 0x7157, "razorback_cormack" },
    { 0x7158, "razorback_dialogue" },
    { 0x7159, "razorback_explosion" },
    { 0x715A, "razorback_fire_start" },
    { 0x715B, "razorback_fire_stop" },
    { 0x715C, "razorback_fly_in" },
    { 0x715D, "razorback_gun_enable" },
    { 0x715E, "razorback_ilana" },
    { 0x715F, "razorback_land" },
    { 0x7160, "razorback_lighting" },
    { 0x7161, "razorback_mech" },
    { 0x7162, "razorback_mech_behavior" },
    { 0x7163, "razorback_mech_missiles" },
    { 0x7164, "razorback_mech_shoot" },
    { 0x7165, "razorback_org" },
    { 0x7166, "razorback_razorback" },
    { 0x7167, "razorback_rumble" },
    { 0x7168, "razorback_spotlight" },
    { 0x7169, "razorback_spotlight_init" },
    { 0x716A, "razorback_trigger_handler" },
    { 0x716B, "rb_blast_marks" },
    { 0x716C, "rb_flee_goal_pick" },
    { 0x716D, "re_enable_combat" },
    { 0x716E, "re_target" },
    { 0x716F, "reach_aborted" },
    { 0x7170, "reach_death_notify" },
    { 0x7171, "reach_goal_pos" },
    { 0x7172, "reach_with_arrivals_begin" },
    { 0x7173, "reach_with_planting" },
    { 0x7174, "reach_with_planting_and_arrivals" },
    { 0x7175, "reach_with_standard_adjustments_begin" },
    { 0x7176, "reach_with_standard_adjustments_end" },
    { 0x7177, "reached_node" },
    { 0x7178, "reachers" },
    { 0x7179, "reachidle" },
    { 0x717A, "reacquire_state" },
    { 0x717B, "reacquire_without_facing" },
    { 0x717C, "reacquirewhennecessary" },
    { 0x717D, "react_anim" },
    { 0x717E, "reactingtobullet" },
    { 0x717F, "reaction" },
    { 0x7180, "reaction_ai" },
    { 0x7181, "reaction_explosions" },
    { 0x7182, "reaction_pickup_event" },
    { 0x7183, "reaction_pickup_player_proximity" },
    { 0x7184, "reaction_pickup_queue_explosion" },
    { 0x7185, "reaction_proc" },
    { 0x7186, "reaction_sleep" },
    { 0x7187, "reaction_sleep_wait_wakeup" },
    { 0x7188, "reaction_sleep_wait_wakeup_dist" },
    { 0x7189, "reaction_wait" },
    { 0x718A, "reactionanim" },
    { 0x718B, "reactioncasualty" },
    { 0x718C, "reactionfriendlyfire" },
    { 0x718D, "reactionscheckloop" },
    { 0x718E, "reactiontakingfire" },
    { 0x718F, "reactiontaunt" },
    { 0x7190, "reactive_fx_ents" },
    { 0x7191, "reactive_fx_thread" },
    { 0x7192, "reactive_sound_ents" },
    { 0x7193, "reactive_thread" },
    { 0x7194, "reactor_alarm" },
    { 0x7195, "reactor_bot_drive_self_start" },
    { 0x7196, "reactor_bot_drive_self_stop" },
    { 0x7197, "reactor_bot_drive_shelf_start" },
    { 0x7198, "reactor_bot_drive_shelf_stop" },
    { 0x7199, "reactor_bot_elevator_open" },
    { 0x719A, "reactor_bot_elevator_start_lp" },
    { 0x719B, "reactor_bot_elevator_stop_lp" },
    { 0x719C, "reactor_bot_final_elevator_start" },
    { 0x719D, "reactor_bot_final_elevator_stop" },
    { 0x719E, "reactor_bot_initial_elevator_start" },
    { 0x719F, "reactor_bot_initial_elevator_stop" },
    { 0x71A0, "reactor_bot_shelf_drop" },
    { 0x71A1, "reactor_bot_shelf_pickup" },
    { 0x71A2, "reactor_bot_turn_self" },
    { 0x71A3, "reactor_bot_turn_shelf" },
    { 0x71A4, "reactor_catwalk_spawner_trigger_think" },
    { 0x71A5, "reactor_entrance_rally" },
    { 0x71A6, "reactor_entrance_rally_anim" },
    { 0x71A7, "reactor_light_rays" },
    { 0x71A8, "reactor_reveal_lighting" },
    { 0x71A9, "reactor_robots_badplace_think" },
    { 0x71AA, "reactor_robots_shelf_think" },
    { 0x71AB, "reactor_room" },
    { 0x71AC, "reactor_room_allies_run_from_crate" },
    { 0x71AD, "reactor_room_catwalk_combat" },
    { 0x71AE, "reactor_room_catwalk_death" },
    { 0x71AF, "reactor_room_combat" },
    { 0x71B0, "reactor_room_combat_mid_checkpoint" },
    { 0x71B1, "reactor_room_combat_seek_player" },
    { 0x71B2, "reactor_room_crane" },
    { 0x71B3, "reactor_room_crane_adjust_housing" },
    { 0x71B4, "reactor_room_crane_grab_crate" },
    { 0x71B5, "reactor_room_crane_light" },
    { 0x71B6, "reactor_room_crane_murderplayer_think" },
    { 0x71B7, "reactor_room_crane_rotate_to_angle" },
    { 0x71B8, "reactor_room_crane_think" },
    { 0x71B9, "reactor_room_crate_think" },
    { 0x71BA, "reactor_room_crate_tracking" },
    { 0x71BB, "reactor_room_drone_cleanup" },
    { 0x71BC, "reactor_room_drones" },
    { 0x71BD, "reactor_room_get_best_crate" },
    { 0x71BE, "reactor_room_link_cables" },
    { 0x71BF, "reactor_room_microwave_grenade_equip" },
    { 0x71C0, "reactor_room_redshirt_cleanup" },
    { 0x71C1, "reactor_room_redshirts" },
    { 0x71C2, "reactor_room_reveal_ally_vo_close_check" },
    { 0x71C3, "reactor_room_reveal_door" },
    { 0x71C4, "reactor_room_reveal_enemies_think" },
    { 0x71C5, "reactor_room_reveal_scene" },
    { 0x71C6, "reactor_room_reveal_scene_ally_think" },
    { 0x71C7, "reactor_room_reveal_scene_approach" },
    { 0x71C8, "reactor_room_reveal_scene_guys_ready" },
    { 0x71C9, "reactor_room_reveal_squibs" },
    { 0x71CA, "reactor_room_robot_emp_death" },
    { 0x71CB, "reactor_room_robot_grid_ally_safeguard" },
    { 0x71CC, "reactor_room_robot_monitor_death" },
    { 0x71CD, "reactor_room_robot_scripted_think" },
    { 0x71CE, "reactor_room_robot_think" },
    { 0x71CF, "reactor_room_robots" },
    { 0x71D0, "reactor_room_robots_lift_adjust_bars" },
    { 0x71D1, "reactor_room_sonic_hint_use_check" },
    { 0x71D2, "reactto" },
    { 0x71D3, "reacttobulletchance" },
    { 0x71D4, "reacttobulletsinterruptcheck" },
    { 0x71D5, "readncolumns" },
    { 0x71D6, "readtriple" },
    { 0x71D7, "ready" },
    { 0x71D8, "ready_for_reveal" },
    { 0x71D9, "ready_knuckles_delete" },
    { 0x71DA, "ready_room_assault_rifle" },
    { 0x71DB, "ready_room_elevator_right" },
    { 0x71DC, "ready_room_gideon" },
    { 0x71DD, "ready_room_player" },
    { 0x71DE, "ready_room_sniper_rifle" },
    { 0x71DF, "ready_room_things" },
    { 0x71E0, "readyanimarray" },
    { 0x71E1, "readyanimweights" },
    { 0x71E2, "readyforatriumbreach" },
    { 0x71E3, "readyplayer" },
    { 0x71E4, "readystand_anims_inited" },
    { 0x71E5, "readytobemanhandled" },
    { 0x71E6, "readytobreach" },
    { 0x71E7, "readytodie" },
    { 0x71E8, "readytomanhandle" },
    { 0x71E9, "readytomeleetarget" },
    { 0x71EA, "readytoreturntocover" },
    { 0x71EB, "real_target" },
    { 0x71EC, "realorigin" },
    { 0x71ED, "realtext" },
    { 0x71EE, "rear_dist" },
    { 0x71EF, "reassign_ctf_team_spawns" },
    { 0x71F0, "rebuild_friendly_icon" },
    { 0x71F1, "rec_bathroom_guy" },
    { 0x71F2, "rec_chair_kva_gets_shot" },
    { 0x71F3, "rec_drive_lookat_trigger_think" },
    { 0x71F4, "rec_drone_scanner" },
    { 0x71F5, "rec_exo_arm_repair_attempt_01_npc" },
    { 0x71F6, "rec_exo_arm_repair_attempt_02_npc" },
    { 0x71F7, "rec_exo_arm_repair_attempt_03_npc" },
    { 0x71F8, "rec_exo_arm_repair_attempt_exit_npc" },
    { 0x71F9, "rec_funeral_21_gun_salute" },
    { 0x71FA, "rec_funeral_part_1_cormack" },
    { 0x71FB, "rec_funeral_part_2_cormack" },
    { 0x71FC, "rec_funeral_part_2_irons" },
    { 0x71FD, "rec_guy_doubledoor_breach_start" },
    { 0x71FE, "rec_jeep_adr_gdn" },
    { 0x71FF, "rec_jeep_ride_pt1" },
    { 0x7200, "rec_jeep_ride_pt2" },
    { 0x7201, "rec_jeep_ride_pt3" },
    { 0x7202, "rec_kva_with_president_gets_shot" },
    { 0x7203, "rec_littlebird_formation_spawn" },
    { 0x7204, "rec_mute_breach_slo_mo1" },
    { 0x7205, "rec_mute01_chair_kva_killed" },
    { 0x7206, "rec_mute01_joker_breach" },
    { 0x7207, "rec_mute01_joker_kick" },
    { 0x7208, "rec_mute01_joker_run" },
    { 0x7209, "rec_mute01_joker_start" },
    { 0x720A, "rec_mute01_joker_turn" },
    { 0x720B, "rec_mute01_kva_hits_wall" },
    { 0x720C, "rec_mute01_kva_kicked" },
    { 0x720D, "rec_mute01_kva_with_gun_killed" },
    { 0x720E, "rec_mute01_potus_free" },
    { 0x720F, "rec_player_drone_end" },
    { 0x7210, "rec_player_drone_start" },
    { 0x7211, "rec_player_exo_breach_start" },
    { 0x7212, "rec_plr_kills_president" },
    { 0x7213, "rec_readyroom_elevator_left_close" },
    { 0x7214, "rec_readyroom_elevator_left_hatch_back" },
    { 0x7215, "rec_readyroom_elevator_left_hatch_front" },
    { 0x7216, "rec_readyroom_elevator_left_open" },
    { 0x7217, "rec_readyroom_elevator_left_open2" },
    { 0x7218, "rec_readyroom_elevator_left_up" },
    { 0x7219, "rec_readyroom_elevator_right_close" },
    { 0x721A, "rec_readyroom_elevator_right_open" },
    { 0x721B, "rec_readyroom_elevator_right_open2" },
    { 0x721C, "rec_readyroom_elevator_right_up" },
    { 0x721D, "rec_readyroom_gideon_pushes_button" },
    { 0x721E, "rec_s1_drones_attack" },
    { 0x721F, "rec_s1_drones_fly_by" },
    { 0x7220, "rec_s1_drones_wait_for_attack" },
    { 0x7221, "rec_s1_president_killed" },
    { 0x7222, "rec_s2_breach_gun_holster" },
    { 0x7223, "rec_s2_breach_slo_mo" },
    { 0x7224, "rec_s2_door_guy_ambush" },
    { 0x7225, "rec_s2_drones_attack" },
    { 0x7226, "rec_s2_exfil_car_plr_hand" },
    { 0x7227, "rec_s2_exfil_car_plr_help_potus" },
    { 0x7228, "rec_s2_exfil_car_plr_start" },
    { 0x7229, "rec_s2_exfil_potus_enter_car" },
    { 0x722A, "rec_s2_exfil_potus_start" },
    { 0x722B, "rec_sim_reveal_gideon" },
    { 0x722C, "rec_sim_reveal_irons" },
    { 0x722D, "rec_sim_start_joker" },
    { 0x722E, "rec_slomo_audio_handler" },
    { 0x722F, "rec_slomo_kill_bad_guy" },
    { 0x7230, "rec_star_trek_door_close" },
    { 0x7231, "rec_star_trek_door_open" },
    { 0x7232, "rec_t2_warbird_decloak" },
    { 0x7233, "rec_t2_warbird_door_open" },
    { 0x7234, "rec_t2_warbird_land" },
    { 0x7235, "rec_t2_warbird_start" },
    { 0x7236, "rec_threat01_joker_kick" },
    { 0x7237, "rec_threat01_joker_start" },
    { 0x7238, "rec_tour_end_jeep_gate_plr_close" },
    { 0x7239, "rec_tour_end_jeep_gate_plr_open" },
    { 0x723A, "rec_tour_escort_jeep_start" },
    { 0x723B, "rec_tour_hangar_background" },
    { 0x723C, "rec_tour_npc_jeep_exit_gate_close" },
    { 0x723D, "rec_tour_npc_jeep_exit_gate_open" },
    { 0x723E, "rec_tour_ride_driver_gear_shift" },
    { 0x723F, "rec_tour_ride_gid_exits_jeep" },
    { 0x7240, "rec_tour_ride_gid_hand_on_door" },
    { 0x7241, "rec_tour_ride_irons_gestures" },
    { 0x7242, "rec_tour_ride_irons_turns_to_plr" },
    { 0x7243, "rec_tour_ride_irons_waves" },
    { 0x7244, "rec_tour_ride_plr_door" },
    { 0x7245, "rec_tour_ride_plr_exits_jeep" },
    { 0x7246, "rec_tour_ride_veh_leftdoor_close" },
    { 0x7247, "rec_tour_ride_veh_leftdoor_open" },
    { 0x7248, "rec_tour_ride_veh_rightdoor_close" },
    { 0x7249, "rec_tour_ride_veh_rightdoor_open" },
    { 0x724A, "rec_tour_titan_1_start" },
    { 0x724B, "rec_tour_titan_2_walk_anim_start" },
    { 0x724C, "rec_tour_titan_gate_plr_open" },
    { 0x724D, "rec_tour_vehicle_1_start" },
    { 0x724E, "rec_tour_vtol_takeoff_spawn" },
    { 0x724F, "rec_train1_end" },
    { 0x7250, "rec_train1_exfil_car_start" },
    { 0x7251, "rec_train1_stealth_car_spawn" },
    { 0x7252, "rec_train1_stealth_car_stop" },
    { 0x7253, "rec_train2_ambush_car_1" },
    { 0x7254, "rec_train2_ambush_car_2" },
    { 0x7255, "rec_train2_exfil_car_end" },
    { 0x7256, "rec_train2_exfil_car_start" },
    { 0x7257, "rec_training01_lodge_stealth_exit_end" },
    { 0x7258, "rec_training01_lodge_stealth_exit_start" },
    { 0x7259, "rec_training01_lodge_stealth_open" },
    { 0x725A, "rec_training1_jeep_arrive" },
    { 0x725B, "rec_training1_jeep_enter" },
    { 0x725C, "rec_training1_jeep_irons_door_close" },
    { 0x725D, "rec_training1_jeep_irons_door_open" },
    { 0x725E, "rec_training1_jeep_player_door_close" },
    { 0x725F, "rec_welcometoatlas_gideon" },
    { 0x7260, "rec_welcometoatlas_irons" },
    { 0x7261, "recall" },
    { 0x7262, "recentdamageamount" },
    { 0x7263, "recentkillcount" },
    { 0x7264, "recently_loaded_listener" },
    { 0x7265, "recentlysawenemy" },
    { 0x7266, "rechamber" },
    { 0x7267, "recharge" },
    { 0x7268, "recipeclassapplyjuggernaut" },
    { 0x7269, "reclaimedreservedobjectives" },
    { 0x726A, "recoildirection" },
    { 0x726B, "recoilscale" },
    { 0x726C, "recon_allies" },
    { 0x726D, "recon_anim_struct" },
    { 0x726E, "recon_begin" },
    { 0x726F, "recon_checkpoint_lasttime" },
    { 0x7270, "recon_log_loadout" },
    { 0x7271, "recon_log_spawnpoint_info" },
    { 0x7272, "recon_main" },
    { 0x7273, "recon_objective_lasttime" },
    { 0x7274, "recon_player" },
    { 0x7275, "recon_player_downed" },
    { 0x7276, "recon_set_spawnpoint" },
    { 0x7277, "recon_start" },
    { 0x7278, "recon_vo" },
    { 0x7279, "reconhandledeath" },
    { 0x727A, "reconhandletimeout" },
    { 0x727B, "reconhandletimeoutwarning" },
    { 0x727C, "reconhudremove" },
    { 0x727D, "reconhudsetup" },
    { 0x727E, "reconlogplayerinfo" },
    { 0x727F, "reconnect_fake_pitbull" },
    { 0x7280, "reconplayerexit" },
    { 0x7281, "reconsetinactivity" },
    { 0x7282, "reconspawnturret" },
    { 0x7283, "reconuav_stinger_target_pos" },
    { 0x7284, "record_bread_crumbs_for_ambush" },
    { 0x7285, "record_enemy_notification" },
    { 0x7286, "record_enemy_sightings" },
    { 0x7287, "record_grenade_rising_edges" },
    { 0x7288, "record_grenade_throw_times" },
    { 0x7289, "record_last_player_damage" },
    { 0x728A, "record_sighting" },
    { 0x728B, "record_stealth_event" },
    { 0x728C, "recordfinalkillcam" },
    { 0x728D, "recordsegemtdata" },
    { 0x728E, "recordtogglescopestates" },
    { 0x728F, "recordvalidationinfraction" },
    { 0x7290, "recover" },
    { 0x7291, "recover_cargo" },
    { 0x7292, "recover_from_careful_disable" },
    { 0x7293, "recover_interval" },
    { 0x7294, "recovery_breach_cleanup_player" },
    { 0x7295, "recovery_breach_setup_player" },
    { 0x7296, "recovery_dynamic_event" },
    { 0x7297, "recovery_locations" },
    { 0x7298, "recovery_thermal_manager" },
    { 0x7299, "recoverycustomospfunc" },
    { 0x729A, "recoveryeventcustomospfunc" },
    { 0x729B, "recursed" },
    { 0x729C, "red" },
    { 0x729D, "red_burn_lighting_fog" },
    { 0x729E, "red_hoodoo_fx" },
    { 0x729F, "red_hoodoo1" },
    { 0x72A0, "red_hoodoos" },
    { 0x72A1, "red_light_strobe_courtyard" },
    { 0x72A2, "red_point" },
    { 0x72A3, "redfill" },
    { 0x72A4, "redfill2" },
    { 0x72A5, "redo" },
    { 0x72A6, "redshirt_death_vo" },
    { 0x72A7, "reduce_damage_while_holding_cardoor" },
    { 0x72A8, "reduce_player_movement_videolog" },
    { 0x72A9, "reduced_nonplayer_damage" },
    { 0x72AA, "reducegiptponkillanimscript" },
    { 0x72AB, "reducetakecoverwarnings" },
    { 0x72AC, "reenable_grapple" },
    { 0x72AD, "ref" },
    { 0x72AE, "ref_col" },
    { 0x72AF, "reference" },
    { 0x72B0, "refill_starting_weapons" },
    { 0x72B1, "refillammo" },
    { 0x72B2, "refillammohorde" },
    { 0x72B3, "refillbattery" },
    { 0x72B4, "refillclip" },
    { 0x72B5, "refillsinglecountammo" },
    { 0x72B6, "reflection_pod_guys" },
    { 0x72B7, "reflection_pod_guys_landing" },
    { 0x72B8, "reflection_pod_guys2" },
    { 0x72B9, "reflectionprobebuttons" },
    { 0x72BA, "reflectionprobenmlluminance" },
    { 0x72BB, "refraction_turrets" },
    { 0x72BC, "refraction_turrets_alive" },
    { 0x72BD, "refraction_turrets_moved_down" },
    { 0x72BE, "refractioncustomkillstreakfunc" },
    { 0x72BF, "refractioncustomospfunc" },
    { 0x72C0, "refractionturrettimer" },
    { 0x72C1, "refractionvulcancustomfunc" },
    { 0x72C2, "refresh_core_snipers_enemies" },
    { 0x72C3, "refresh_existing_bots" },
    { 0x72C4, "refresh_reactive_fx_ents" },
    { 0x72C5, "refuel_timings" },
    { 0x72C6, "refuel_vo" },
    { 0x72C7, "refugee_butress_down" },
    { 0x72C8, "refugee_butress_down_time" },
    { 0x72C9, "refugee_camp_ai" },
    { 0x72CA, "refugee_camp_autopilot_engaged" },
    { 0x72CB, "refugee_camp_civ_convo_01" },
    { 0x72CC, "refugee_camp_cleanup" },
    { 0x72CD, "refugee_camp_dialogue" },
    { 0x72CE, "refugee_camp_intro_dialogue" },
    { 0x72CF, "refugee_camp_main" },
    { 0x72D0, "refugee_camp_security_checkpoint_dialogue" },
    { 0x72D1, "refugee_debug" },
    { 0x72D2, "refugee_walk" },
    { 0x72D3, "regen_cooldown" },
    { 0x72D4, "regen_front_armor" },
    { 0x72D5, "regenhealthmod" },
    { 0x72D6, "regenrate" },
    { 0x72D7, "regenspeed" },
    { 0x72D8, "register_ai_anims" },
    { 0x72D9, "register_archetype" },
    { 0x72DA, "register_boost_dodge" },
    { 0x72DB, "register_boost_jump" },
    { 0x72DC, "register_boost_slam" },
    { 0x72DD, "register_common_mp_snd_messages" },
    { 0x72DE, "register_common_snd_messages" },
    { 0x72DF, "register_death" },
    { 0x72E0, "register_difficulty" },
    { 0x72E1, "register_fx" },
    { 0x72E2, "register_kill" },
    { 0x72E3, "register_level_name" },
    { 0x72E4, "register_moving_collision_on_nodes" },
    { 0x72E5, "register_new_weapon" },
    { 0x72E6, "register_notetracks" },
    { 0x72E7, "register_player_anims" },
    { 0x72E8, "register_pluggable_move_loop_override" },
    { 0x72E9, "register_radio_squelches" },
    { 0x72EA, "register_shot_hit" },
    { 0x72EB, "register_snd_messages" },
    { 0x72EC, "register_sp_perks" },
    { 0x72ED, "register_target_lock_change_func" },
    { 0x72EE, "register_trigger_callbacks" },
    { 0x72EF, "register_vehicle_anims" },
    { 0x72F0, "registerarchetype" },
    { 0x72F1, "registerdvars" },
    { 0x72F2, "registerhalftimedvar" },
    { 0x72F3, "registeringshothit" },
    { 0x72F4, "registerlaststandparameter" },
    { 0x72F5, "registermissioncallback" },
    { 0x72F6, "registernotetracks" },
    { 0x72F7, "registernumlivesdvar" },
    { 0x72F8, "registernumteamsdvar" },
    { 0x72F9, "registerroundlimitdvar" },
    { 0x72FA, "registerroundswitchdvar" },
    { 0x72FB, "registerscorelimitdvar" },
    { 0x72FC, "registertimelimitdvar" },
    { 0x72FD, "registertweakable" },
    { 0x72FE, "registerwatchdvar" },
    { 0x72FF, "registerwatchdvarfloat" },
    { 0x7300, "registerwatchdvarint" },
    { 0x7301, "registerwinlimitdvar" },
    { 0x7302, "registerxpeventinfo" },
    { 0x7303, "regular_exo_hover_vfx" },
    { 0x7304, "regular_plane_controls" },
    { 0x7305, "reincrement_count_if_deleted" },
    { 0x7306, "reinforce_on_death" },
    { 0x7307, "reinforcement_endtime" },
    { 0x7308, "reinforcementcratekillstreakthink" },
    { 0x7309, "reinforcementcratespecialtythink" },
    { 0x730A, "reinitializematchrulesonmigration" },
    { 0x730B, "reinitializescorelimitonmigration" },
    { 0x730C, "reinitializethermal" },
    { 0x730D, "relativepoint" },
    { 0x730E, "release_hint_off" },
    { 0x730F, "release_player_view_to_rig_anim" },
    { 0x7310, "release_x_breakout" },
    { 0x7311, "releasegas" },
    { 0x7312, "releasemeetingcivilians" },
    { 0x7313, "releasestring" },
    { 0x7314, "reload_ammo" },
    { 0x7315, "reload_checker_hack" },
    { 0x7316, "reload_disable_safe" },
    { 0x7317, "reload_enable" },
    { 0x7318, "reload_launchers" },
    { 0x7319, "reload_malfunction_disable_on_grenade_throw" },
    { 0x731A, "reloading" },
    { 0x731B, "reloading_big_orbitalsupport_gun" },
    { 0x731C, "reloading_buddy_medium_orbitalsupport_gun" },
    { 0x731D, "reloading_medium_orbitalsupport_gun" },
    { 0x731E, "reloading_rocket_orbitalsupport_gun" },
    { 0x731F, "reloadrocket" },
    { 0x7320, "reloadrocketswarm" },
    { 0x7321, "reloadtracking" },
    { 0x7322, "remainingrocketshots" },
    { 0x7323, "reminder_boost_jump_drone_street" },
    { 0x7324, "remote_missile_height_override" },
    { 0x7325, "remote_vehicle_setup" },
    { 0x7326, "remotecontrolled" },
    { 0x7327, "remoteent" },
    { 0x7328, "remotemissile_actionslot" },
    { 0x7329, "remotemissile_fx" },
    { 0x732A, "remotemissileenttracetooriginpassedwrapper" },
    { 0x732B, "remotemissileinprogress" },
    { 0x732C, "remoteridetransition" },
    { 0x732D, "remoteturretlist" },
    { 0x732E, "remove_ai_from_colors" },
    { 0x732F, "remove_all_actors_that_are_squelched" },
    { 0x7330, "remove_all_actors_with_same_characterid" },
    { 0x7331, "remove_all_intel" },
    { 0x7332, "remove_and_insert_at_traffic_tail" },
    { 0x7333, "remove_and_insert_before_leader" },
    { 0x7334, "remove_and_insert_behind_leader" },
    { 0x7335, "remove_avatar" },
    { 0x7336, "remove_bad_locked_targets" },
    { 0x7337, "remove_boost_jump" },
    { 0x7338, "remove_camera_view_angles" },
    { 0x7339, "remove_cardoor_from_npc" },
    { 0x733A, "remove_cheap_flashlight" },
    { 0x733B, "remove_cockpit_from_view" },
    { 0x733C, "remove_color_from_array" },
    { 0x733D, "remove_corpse_loop_while_stealth_broken" },
    { 0x733E, "remove_crawled" },
    { 0x733F, "remove_damage_function" },
    { 0x7340, "remove_damagefeedback" },
    { 0x7341, "remove_dead_bodies_from_cone" },
    { 0x7342, "remove_dead_from_array" },
    { 0x7343, "remove_deathfx_entity_delay" },
    { 0x7344, "remove_display_name" },
    { 0x7345, "remove_diveboat_weapons" },
    { 0x7346, "remove_drone_mode" },
    { 0x7347, "remove_drone_turret_drones" },
    { 0x7348, "remove_dropped_guns_near_explosives" },
    { 0x7349, "remove_dupes" },
    { 0x734A, "remove_ends_from_path" },
    { 0x734B, "remove_exo_temperature_hud" },
    { 0x734C, "remove_extra_autosave_check" },
    { 0x734D, "remove_fighter_jet_hud" },
    { 0x734E, "remove_flashlight_on_goal" },
    { 0x734F, "remove_flashlight_upon_combat" },
    { 0x7350, "remove_friendly_fire_damage_modifier" },
    { 0x7351, "remove_from_animloop" },
    { 0x7352, "remove_from_array_when_dead" },
    { 0x7353, "remove_from_arrays" },
    { 0x7354, "remove_from_bot_damage_targets" },
    { 0x7355, "remove_from_bot_use_targets" },
    { 0x7356, "remove_from_flock" },
    { 0x7357, "remove_from_idle_array_on_death" },
    { 0x7358, "remove_from_tactics_array_on_delete" },
    { 0x7359, "remove_from_tactics_array_on_pickup" },
    { 0x735A, "remove_from_target_array_on_death" },
    { 0x735B, "remove_from_targets_on_death" },
    { 0x735C, "remove_from_traffic_lane" },
    { 0x735D, "remove_fxlighting_object" },
    { 0x735E, "remove_global_spawn_function" },
    { 0x735F, "remove_grapple" },
    { 0x7360, "remove_h_breach_hostages" },
    { 0x7361, "remove_heroes_from_array" },
    { 0x7362, "remove_hint" },
    { 0x7363, "remove_hovertank_weapons" },
    { 0x7364, "remove_hud" },
    { 0x7365, "remove_hud_drone_target" },
    { 0x7366, "remove_hud_outline_binocs" },
    { 0x7367, "remove_intact_bridge" },
    { 0x7368, "remove_intel_item" },
    { 0x7369, "remove_invalid_locks" },
    { 0x736A, "remove_level_first_frame" },
    { 0x736B, "remove_light_from_face" },
    { 0x736C, "remove_lock_target" },
    { 0x736D, "remove_magic_bullet_shield_from_guy_on_unload_or_death" },
    { 0x736E, "remove_monitored_tags" },
    { 0x736F, "remove_moving_obstacle" },
    { 0x7370, "remove_moving_obstacle_on_death" },
    { 0x7371, "remove_name" },
    { 0x7372, "remove_nocolor_from_array" },
    { 0x7373, "remove_nodes_with_users_from_array" },
    { 0x7374, "remove_non_riders_from_array" },
    { 0x7375, "remove_noteworthy_from_array" },
    { 0x7376, "remove_object_from_tactics_system" },
    { 0x7377, "remove_on_spawner_delete" },
    { 0x7378, "remove_option" },
    { 0x7379, "remove_outline_on_death" },
    { 0x737A, "remove_passenger_from_player_pitbull" },
    { 0x737B, "remove_patrol_anim_set" },
    { 0x737C, "remove_pre_penthouse_trees" },
    { 0x737D, "remove_reflection_objects" },
    { 0x737E, "remove_replace_on_death" },
    { 0x737F, "remove_script_car" },
    { 0x7380, "remove_script_friendnames_from_list" },
    { 0x7381, "remove_selected_option" },
    { 0x7382, "remove_slowmo_breacher" },
    { 0x7383, "remove_spawn_function" },
    { 0x7384, "remove_sticky" },
    { 0x7385, "remove_sticky_on_explosion" },
    { 0x7386, "remove_sticky_on_respawn" },
    { 0x7387, "remove_target" },
    { 0x7388, "remove_target_on_timeout" },
    { 0x7389, "remove_tracking_on_disconnect" },
    { 0x738A, "remove_turret_on_mount" },
    { 0x738B, "remove_unarmed_when_pickup_new_wep" },
    { 0x738C, "remove_user_from_drone" },
    { 0x738D, "remove_user_from_dronecrate" },
    { 0x738E, "remove_vehicle_from_tactics_array_on_death" },
    { 0x738F, "remove_vehicle_spawned_thisframe" },
    { 0x7390, "remove_vol_index" },
    { 0x7391, "remove_when_out_of_range" },
    { 0x7392, "remove_without_classname" },
    { 0x7393, "remove_without_model" },
    { 0x7394, "remove_zipline_on_death" },
    { 0x7395, "removeactivecounteruav" },
    { 0x7396, "removeactivespawner" },
    { 0x7397, "removeactiveuav" },
    { 0x7398, "removeallfromlivescount" },
    { 0x7399, "removebombcarrierclass" },
    { 0x739A, "removebombzone" },
    { 0x739B, "removeburiedlightgrid" },
    { 0x739C, "removechild" },
    { 0x739D, "removecoopturretbuddy" },
    { 0x739E, "removecoopturretbuddyondisconnect" },
    { 0x739F, "removed" },
    { 0x73A0, "removedestroyedchildren" },
    { 0x73A1, "removedisconnectedplayerfromplacement" },
    { 0x73A2, "removedronevisionandlightsetpermap" },
    { 0x73A3, "removeemp" },
    { 0x73A4, "removeentityheadicon" },
    { 0x73A5, "removeexplosivedrone" },
    { 0x73A6, "removeflagcarrierclass" },
    { 0x73A7, "removefromalivecount" },
    { 0x73A8, "removefrombattlebuddywaitlist" },
    { 0x73A9, "removefromcarepackagedronelistondeath" },
    { 0x73AA, "removefromcharactersarray" },
    { 0x73AB, "removefromexplosivedronelistondeath" },
    { 0x73AC, "removefromhelilist" },
    { 0x73AD, "removefromlittlebirdlistondeath" },
    { 0x73AE, "removefromlivescount" },
    { 0x73AF, "removefromparticipantsarray" },
    { 0x73B0, "removefromsquad" },
    { 0x73B1, "removefromsystem" },
    { 0x73B2, "removefromteamcount" },
    { 0x73B3, "removefromtotalspawned" },
    { 0x73B4, "removefromtrackingdronelistondeath" },
    { 0x73B5, "removefromturretlist" },
    { 0x73B6, "removefxentwithentity" },
    { 0x73B7, "removegroupedtridrone" },
    { 0x73B8, "removeharmonicbreachhostages" },
    { 0x73B9, "removekillcamentity" },
    { 0x73BA, "removekillstreakicons" },
    { 0x73BB, "removelastelement" },
    { 0x73BC, "removelightarmorondeath" },
    { 0x73BD, "removelightarmoronmatchend" },
    { 0x73BE, "removelowermessage" },
    { 0x73BF, "removenotetrack" },
    { 0x73C0, "removeofficerfromsquad" },
    { 0x73C1, "removeonnextairdrop" },
    { 0x73C2, "removeorbitalsupportbuddy" },
    { 0x73C3, "removeorbitalsupportbuddyonchangeteams" },
    { 0x73C4, "removeorbitalsupportbuddyoncommand" },
    { 0x73C5, "removeorbitalsupportbuddyondisconnect" },
    { 0x73C6, "removeorbitalsupportbuddyonspectate" },
    { 0x73C7, "removeorbitalsupportplayer" },
    { 0x73C8, "removeorbitalsupportplayeraftertime" },
    { 0x73C9, "removeorbitalsupportplayeronchangeteams" },
    { 0x73CA, "removeorbitalsupportplayeroncommand" },
    { 0x73CB, "removeorbitalsupportplayeroncrash" },
    { 0x73CC, "removeorbitalsupportplayerondisconnect" },
    { 0x73CD, "removeorbitalsupportplayerongamecleanup" },
    { 0x73CE, "removeorbitalsupportplayeronspectate" },
    { 0x73CF, "removeospvisionandlightsetpermap" },
    { 0x73D0, "removeoverlaydeath" },
    { 0x73D1, "removeperkhud" },
    { 0x73D2, "removeperks" },
    { 0x73D3, "removepickup" },
    { 0x73D4, "removeplanefromlist" },
    { 0x73D5, "removeplayerondisconnect" },
    { 0x73D6, "removeplayertarget" },
    { 0x73D7, "removepod" },
    { 0x73D8, "removerack" },
    { 0x73D9, "removerevnmeshes" },
    { 0x73DA, "removesafetyhealth" },
    { 0x73DB, "removeselffrom_squadlastseenenemypos" },
    { 0x73DC, "removesolarreflectorlevelwatch" },
    { 0x73DD, "removesolarreflectorplayer" },
    { 0x73DE, "removesolarreflectorplayeraftertime" },
    { 0x73DF, "removesolarreflectorplayeroncommand" },
    { 0x73E0, "removesolarreflectorplayerwatch" },
    { 0x73E1, "removespawnmessageshortly" },
    { 0x73E2, "removespeaker" },
    { 0x73E3, "removestreaksupportprompt" },
    { 0x73E4, "removethreatevents" },
    { 0x73E5, "removethreaticon" },
    { 0x73E6, "removetrackingdrone" },
    { 0x73E7, "removetransitionmeshes" },
    { 0x73E8, "removetruckguardoutline" },
    { 0x73E9, "removeuavmodel" },
    { 0x73EA, "removeundefined" },
    { 0x73EB, "removevulcanvisionandlightsetpermap" },
    { 0x73EC, "removewarbirdbuddy" },
    { 0x73ED, "removewarbirdbuddyoncommand" },
    { 0x73EE, "removewarbirdvisionsetpermap" },
    { 0x73EF, "removeweapons" },
    { 0x73F0, "rempveoverlaydeath" },
    { 0x73F1, "render_alerted_info" },
    { 0x73F2, "render_detect_ranges" },
    { 0x73F3, "render_detect_ranges_for_entity" },
    { 0x73F4, "render_ranges_for_a_corpse" },
    { 0x73F5, "render_ranges_for_the_corpses" },
    { 0x73F6, "render_vision_cone" },
    { 0x73F7, "render_vision_cone_for_entity" },
    { 0x73F8, "repair_desk_align_needle" },
    { 0x73F9, "repair_desk_grab_needle" },
    { 0x73FA, "repair_desk_harness_close" },
    { 0x73FB, "repair_desk_harness_release" },
    { 0x73FC, "repair_desk_push_needle" },
    { 0x73FD, "repair_desk_remove_needle" },
    { 0x73FE, "repair_guy_01" },
    { 0x73FF, "repair_guy_02" },
    { 0x7400, "repair_weights" },
    { 0x7401, "repeat_hint_until_comply" },
    { 0x7402, "repeat_hint_until_comply_oldstyle" },
    { 0x7403, "repeatoneshotprisonalarm" },
    { 0x7404, "repel_player_missile" },
    { 0x7405, "replace_on_death" },
    { 0x7406, "replenishloadout" },
    { 0x7407, "report_trigger" },
    { 0x7408, "reportalias" },
    { 0x7409, "repulsor_fx" },
    { 0x740A, "repulsoractive" },
    { 0x740B, "repulsornumber" },
    { 0x740C, "requestreacttobullet" },
    { 0x740D, "required_aiming_time_s" },
    { 0x740E, "requiredexitstance" },
    { 0x740F, "requiredmapaspectratio" },
    { 0x7410, "requireonground" },
    { 0x7411, "requires_player_los" },
    { 0x7412, "requireslos" },
    { 0x7413, "rescue_guard_fire" },
    { 0x7414, "rescuedplayers" },
    { 0x7415, "resdhirt1" },
    { 0x7416, "research_building_combat_complete" },
    { 0x7417, "research_building_enemy_think" },
    { 0x7418, "research_facility_bridge_logic" },
    { 0x7419, "research_facility_combat_dialogue" },
    { 0x741A, "research_facility_interior_dialogue" },
    { 0x741B, "research_left_01_enemy_think" },
    { 0x741C, "research_left_lower_01_enemy_think" },
    { 0x741D, "research_platform_enemy_think" },
    { 0x741E, "research_right_01_enemy_think" },
    { 0x741F, "research_right_lower_01_enemy_think" },
    { 0x7420, "reselect_entitites" },
    { 0x7421, "reserve_turret" },
    { 0x7422, "reset_accuracy" },
    { 0x7423, "reset_ai_from_drone" },
    { 0x7424, "reset_angles" },
    { 0x7425, "reset_animname" },
    { 0x7426, "reset_axis_of_selected_ents" },
    { 0x7427, "reset_bot_settings_for_a_few_frames" },
    { 0x7428, "reset_button_buffers" },
    { 0x7429, "reset_cmds" },
    { 0x742A, "reset_copier" },
    { 0x742B, "reset_damage_info_when_healed" },
    { 0x742C, "reset_dds_categories" },
    { 0x742D, "reset_event_type" },
    { 0x742E, "reset_forced_target_if_no_line_of_sight" },
    { 0x742F, "reset_friendly_fire_when_player_lands" },
    { 0x7430, "reset_fx_hud_colors" },
    { 0x7431, "reset_goalvolume" },
    { 0x7432, "reset_group_advance_to_enemy_timer" },
    { 0x7433, "reset_health" },
    { 0x7434, "reset_highway_path_player_side" },
    { 0x7435, "reset_maxsightdistsqrd" },
    { 0x7436, "reset_origin" },
    { 0x7437, "reset_player_health" },
    { 0x7438, "reset_player_stats_on_exit" },
    { 0x7439, "reset_shot_on_reload" },
    { 0x743A, "reset_thread_sent" },
    { 0x743B, "reset_threatbias" },
    { 0x743C, "reset_threatbiasgroup" },
    { 0x743D, "reset_time" },
    { 0x743E, "reset_turret" },
    { 0x743F, "reset_unresolved_collision_handler" },
    { 0x7440, "reset_visionset_on_disconnect" },
    { 0x7441, "reset_visionset_on_spawn" },
    { 0x7442, "reset_visionset_on_team_change" },
    { 0x7443, "reset_walkdist" },
    { 0x7444, "reset_zone_owners" },
    { 0x7445, "resetaccuracyandpause" },
    { 0x7446, "resetadrenaline" },
    { 0x7447, "resetanimmode" },
    { 0x7448, "resetattackerlist" },
    { 0x7449, "resetbrinkofdeathkillstreakshortly" },
    { 0x744A, "resetc4explodethisframe" },
    { 0x744B, "resetcliponabort" },
    { 0x744C, "resetfastheal" },
    { 0x744D, "resetgates" },
    { 0x744E, "resetgiveuponenemytime" },
    { 0x744F, "resetgoalradius" },
    { 0x7450, "resetinterval" },
    { 0x7451, "resetlookforbettercovertime" },
    { 0x7452, "resetmissdebouncetime" },
    { 0x7453, "resetmisstime" },
    { 0x7454, "resetnextsaytimes" },
    { 0x7455, "resetnotify" },
    { 0x7456, "resetoncancel" },
    { 0x7457, "resetondeath" },
    { 0x7458, "resetplayeronteamchange" },
    { 0x7459, "resetplayervariables" },
    { 0x745A, "resetreinforcements" },
    { 0x745B, "resetrespondtodeathtime" },
    { 0x745C, "resetrotategateconstant" },
    { 0x745D, "resetrotategates" },
    { 0x745E, "resetseekoutenemytime" },
    { 0x745F, "resetskill" },
    { 0x7460, "resetsniperaim" },
    { 0x7461, "resetstate" },
    { 0x7462, "resetstingerlocking" },
    { 0x7463, "resetstingerlockingondeath" },
    { 0x7464, "resettags" },
    { 0x7465, "resetuidvarsonconnect" },
    { 0x7466, "resetuidvarsondeath" },
    { 0x7467, "resetuidvarsonspawn" },
    { 0x7468, "resetuidvarsonspectate" },
    { 0x7469, "resetusability" },
    { 0x746A, "resetvirtuallobbypresentable" },
    { 0x746B, "resetvulnerabletimers" },
    { 0x746C, "resetweapon" },
    { 0x746D, "reso_bridge_distantce_dot" },
    { 0x746E, "resolvebraggingrights" },
    { 0x746F, "resonance_light" },
    { 0x7470, "respawn_asspectator" },
    { 0x7471, "respawn_death_spawn" },
    { 0x7472, "respawn_enemies_force_vision_check" },
    { 0x7473, "respawn_friendlies_force_vision_check" },
    { 0x7474, "respawn_mode" },
    { 0x7475, "respawn_on_death" },
    { 0x7476, "respawn_reinforcements_without_vision_check" },
    { 0x7477, "respawn_spawner" },
    { 0x7478, "respawn_spawner_org" },
    { 0x7479, "respawn_watcher" },
    { 0x747A, "respawn_with_launcher" },
    { 0x747B, "respawneliminatedplayers" },
    { 0x747C, "respawnplayer" },
    { 0x747D, "respawntimerstarttime" },
    { 0x747E, "respond_to_threat_grenade" },
    { 0x747F, "responder" },
    { 0x7480, "responderclockdirection" },
    { 0x7481, "respondto" },
    { 0x7482, "respondtodeadteammate" },
    { 0x7483, "respondtodeathtime" },
    { 0x7484, "response_distance_min" },
    { 0x7485, "response_wait" },
    { 0x7486, "response_wait_axis" },
    { 0x7487, "responseevent_failsafe" },
    { 0x7488, "responsegeneric" },
    { 0x7489, "responsetakingfire" },
    { 0x748A, "responsethreatcallout" },
    { 0x748B, "responsethreatexposed" },
    { 0x748C, "restart_exterior_vfx" },
    { 0x748D, "restart_fx_looper" },
    { 0x748E, "restart_oneshots" },
    { 0x748F, "restart_selected_exploders" },
    { 0x7490, "restarteffect" },
    { 0x7491, "restartexploder" },
    { 0x7492, "restartfxid" },
    { 0x7493, "restartmoveloop" },
    { 0x7494, "restartwarbirdenginefxforplayer" },
    { 0x7495, "restaurant_civ_03_cower" },
    { 0x7496, "restaurant_door_civ_killed" },
    { 0x7497, "restaurant_doors_open" },
    { 0x7498, "restaurant_fish_tank_destruct" },
    { 0x7499, "restaurant_water" },
    { 0x749A, "restaurant_wet_floor_think" },
    { 0x749B, "restore_after_deathsdoor" },
    { 0x749C, "restore_default_exo_powers" },
    { 0x749D, "restore_footstep_notetrack_scripts" },
    { 0x749E, "restore_footsteps" },
    { 0x749F, "restore_idle" },
    { 0x74A0, "restore_ignore_setting" },
    { 0x74A1, "restore_moveplaybackrate" },
    { 0x74A2, "restore_movetransitionrate" },
    { 0x74A3, "restore_players_weapons" },
    { 0x74A4, "restore_prebreach_weapons" },
    { 0x74A5, "restore_reload" },
    { 0x74A6, "restore_thrusters_all" },
    { 0x74A7, "restore_vehicle_speed" },
    { 0x74A8, "restore_water_footsteps" },
    { 0x74A9, "restoreangles" },
    { 0x74AA, "restoredata" },
    { 0x74AB, "restoredefaultpitch" },
    { 0x74AC, "restoredefaults" },
    { 0x74AD, "restoredefaultturnrate" },
    { 0x74AE, "restoreheadicon" },
    { 0x74AF, "restoreperk" },
    { 0x74B0, "restoreperks" },
    { 0x74B1, "restorepitch" },
    { 0x74B2, "restoreplayeractions" },
    { 0x74B3, "restoreplayercontrols" },
    { 0x74B4, "restoreplayerweaponstatepersistent" },
    { 0x74B5, "restorevision" },
    { 0x74B6, "restoreweapon" },
    { 0x74B7, "restoreweaponclipammo" },
    { 0x74B8, "restoreweapons" },
    { 0x74B9, "restoreweaponstockammo" },
    { 0x74BA, "restrict_movement_while_releasing_the_pm" },
    { 0x74BB, "restrict_player_view_to_rig_anim" },
    { 0x74BC, "restricted_airspace" },
    { 0x74BD, "resume_driving_from_dodge" },
    { 0x74BE, "resume_vehicle_traffic_roundabout_straightways" },
    { 0x74BF, "resumetimer" },
    { 0x74C0, "retarget_lighting" },
    { 0x74C1, "retarget_model_init" },
    { 0x74C2, "reticle_hide" },
    { 0x74C3, "reticle_origin" },
    { 0x74C4, "reticle_show" },
    { 0x74C5, "retract_rope" },
    { 0x74C6, "retreat_from_vol_to_vol" },
    { 0x74C7, "retreat_function" },
    { 0x74C8, "retreat_group" },
    { 0x74C9, "retreat_path" },
    { 0x74CA, "retreat_proc" },
    { 0x74CB, "retreat_vols" },
    { 0x74CC, "retreat_volume" },
    { 0x74CD, "retreat_volume_and_set_flag" },
    { 0x74CE, "retreat_watcher" },
    { 0x74CF, "retreating_kva" },
    { 0x74D0, "return_after_offhand" },
    { 0x74D1, "return_allies_after_videolog_plays" },
    { 0x74D2, "return_boost_dash" },
    { 0x74D3, "return_fall_tollerance" },
    { 0x74D4, "return_false" },
    { 0x74D5, "return_fire_rocket" },
    { 0x74D6, "return_full_mobility" },
    { 0x74D7, "return_hud" },
    { 0x74D8, "return_notify_on_event" },
    { 0x74D9, "return_player_movement_videolog" },
    { 0x74DA, "return_stealth_distances" },
    { 0x74DB, "return_tag" },
    { 0x74DC, "return_threat_bias_from_agro" },
    { 0x74DD, "return_to_normal" },
    { 0x74DE, "return_to_position" },
    { 0x74DF, "returnaftertime" },
    { 0x74E0, "returnfilterednoteworthyarray" },
    { 0x74E1, "returnflag" },
    { 0x74E2, "returnhome" },
    { 0x74E3, "returns" },
    { 0x74E4, "returntocover" },
    { 0x74E5, "returntrue" },
    { 0x74E6, "reuse_avatar" },
    { 0x74E7, "rev" },
    { 0x74E8, "rev_main_anims" },
    { 0x74E9, "rev_main_anims_vm" },
    { 0x74EA, "reveal_explosion" },
    { 0x74EB, "reveal_scene" },
    { 0x74EC, "reveal_scene_start" },
    { 0x74ED, "revengeevent" },
    { 0x74EE, "revengeunlockevent" },
    { 0x74EF, "reverb" },
    { 0x74F0, "reverb_alarm_volume" },
    { 0x74F1, "reverb_alarm_volume_update_rate" },
    { 0x74F2, "reverb_bypass" },
    { 0x74F3, "reverb_enable" },
    { 0x74F4, "reverb_settings" },
    { 0x74F5, "reverb_track" },
    { 0x74F6, "reverb1" },
    { 0x74F7, "reverb2" },
    { 0x74F8, "reverse_cloak" },
    { 0x74F9, "reverse_mag_glove_crane_move" },
    { 0x74FA, "reverse_node" },
    { 0x74FB, "reverse_street_train_function" },
    { 0x74FC, "reversegravity" },
    { 0x74FD, "revertvisionsetforplayer" },
    { 0x74FE, "revive_player" },
    { 0x74FF, "revive_watch_for_finished" },
    { 0x7500, "revived" },
    { 0x7501, "revivesetup" },
    { 0x7502, "revivetagevent" },
    { 0x7503, "revivetriggerthink" },
    { 0x7504, "revivetriggerthinkhorde" },
    { 0x7505, "rh_exit_door" },
    { 0x7506, "rh_loader_movement" },
    { 0x7507, "ride_hovertank_ai" },
    { 0x7508, "ride_in_mech" },
    { 0x7509, "rider_anims" },
    { 0x750A, "rider_death_detection" },
    { 0x750B, "rider_func" },
    { 0x750C, "rider_think_loop" },
    { 0x750D, "riders" },
    { 0x750E, "riders_no_damage" },
    { 0x750F, "riders_unloadable" },
    { 0x7510, "ridevisionset" },
    { 0x7511, "ridingvehicle" },
    { 0x7512, "rifle_butt" },
    { 0x7513, "rifleshoot" },
    { 0x7514, "rifleshootobjectiveambush" },
    { 0x7515, "rifleshootobjectivenormal" },
    { 0x7516, "rifleshootobjectivesuppress" },
    { 0x7517, "rig" },
    { 0x7518, "riggetgravity" },
    { 0x7519, "riggetvelocity" },
    { 0x751A, "right_alias" },
    { 0x751B, "right_arrow" },
    { 0x751C, "right_big_loop_start" },
    { 0x751D, "right_big_pivot" },
    { 0x751E, "right_brakelight_tag" },
    { 0x751F, "right_dir" },
    { 0x7520, "right_door_anim" },
    { 0x7521, "right_ent" },
    { 0x7522, "right_headlight_tag" },
    { 0x7523, "right_left_punish_dist" },
    { 0x7524, "right_loop_start" },
    { 0x7525, "right_pivot" },
    { 0x7526, "right_post" },
    { 0x7527, "right_swing_pressed" },
    { 0x7528, "right_swing_released" },
    { 0x7529, "right_swipe_monitor" },
    { 0x752A, "right_tap_monitor" },
    { 0x752B, "rightstickrotateavatar" },
    { 0x752C, "rigprocessvelocity" },
    { 0x752D, "rigsetgravity" },
    { 0x752E, "rigsetvelocity" },
    { 0x752F, "ring" },
    { 0x7530, "riot_shield_collision" },
    { 0x7531, "riot_shield_names" },
    { 0x7532, "riotshield_approach_conditions" },
    { 0x7533, "riotshield_approach_type" },
    { 0x7534, "riotshield_bullet_hit_shield" },
    { 0x7535, "riotshield_bullet_hit_shield_clear" },
    { 0x7536, "riotshield_charge" },
    { 0x7537, "riotshield_choose_pose" },
    { 0x7538, "riotshield_clear" },
    { 0x7539, "riotshield_death" },
    { 0x753A, "riotshield_endmovetransition" },
    { 0x753B, "riotshield_fastwalk_off" },
    { 0x753C, "riotshield_fastwalk_on" },
    { 0x753D, "riotshield_flashbang" },
    { 0x753E, "riotshield_flee" },
    { 0x753F, "riotshield_flee_and_drop_shield" },
    { 0x7540, "riotshield_grenadecower" },
    { 0x7541, "riotshield_init_flee" },
    { 0x7542, "riotshield_initialized" },
    { 0x7543, "riotshield_lock_orientation" },
    { 0x7544, "riotshield_melee_aivsai" },
    { 0x7545, "riotshield_melee_standard" },
    { 0x7546, "riotshield_pain" },
    { 0x7547, "riotshield_sprint_off" },
    { 0x7548, "riotshield_sprint_on" },
    { 0x7549, "riotshield_startcombat" },
    { 0x754A, "riotshield_startmovetransition" },
    { 0x754B, "riotshield_turn_into_regular_ai" },
    { 0x754C, "riotshield_unlock_orientation" },
    { 0x754D, "riotshield_watch_for_change_weapon" },
    { 0x754E, "riotshield_watch_for_exo_shield_pullback" },
    { 0x754F, "riotshield_watch_for_exo_shield_release" },
    { 0x7550, "riotshield_watch_for_ladder_early_exit" },
    { 0x7551, "riotshield_watch_for_start_change_weapon" },
    { 0x7552, "riotshieldcleanup" },
    { 0x7553, "riotshieldcollisionentity" },
    { 0x7554, "riotshielddistancetest" },
    { 0x7555, "riotshieldentity" },
    { 0x7556, "riotshieldkillevent" },
    { 0x7557, "riotshieldmod" },
    { 0x7558, "riotshieldretrievetrigger" },
    { 0x7559, "riotshieldtakeweapon" },
    { 0x755A, "riotshieldxpbullets" },
    { 0x755B, "rippable" },
    { 0x755C, "ripples_on_body" },
    { 0x755D, "ris_is_muted" },
    { 0x755E, "ris_max_off_time" },
    { 0x755F, "ris_max_on_time" },
    { 0x7560, "ris_mute_time" },
    { 0x7561, "ris_off_time" },
    { 0x7562, "river_drilling_animation" },
    { 0x7563, "river_drills" },
    { 0x7564, "river_entry_splash_fx" },
    { 0x7565, "river_room_combat_dialouge" },
    { 0x7566, "river_slow_movement_ai_think" },
    { 0x7567, "riverbounce_hideents" },
    { 0x7568, "road_battle_setup" },
    { 0x7569, "road_width" },
    { 0x756A, "roaming_light" },
    { 0x756B, "robot" },
    { 0x756C, "rock_mob" },
    { 0x756D, "rock_the_boat" },
    { 0x756E, "rocket_ai" },
    { 0x756F, "rocket_cine_dof" },
    { 0x7570, "rocket_cleanupondeath" },
    { 0x7571, "rocket_destroyed_for_achievement" },
    { 0x7572, "rocket_fail_lighting" },
    { 0x7573, "rocket_fail_smoke" },
    { 0x7574, "rocket_fire_rumbles" },
    { 0x7575, "rocket_jump_human" },
    { 0x7576, "rocket_jump_human_railing" },
    { 0x7577, "rocket_kill_watcher" },
    { 0x7578, "rocket_success_dof_debugging" },
    { 0x7579, "rocket_success_lighting_pre_cine" },
    { 0x757A, "rocket_success_pt2_gideon_in_frame" },
    { 0x757B, "rocket_success_pt2_lighting_debugging" },
    { 0x757C, "rocket_swarm" },
    { 0x757D, "rocket_swarm_create_and_manage_attractor" },
    { 0x757E, "rocket_swarm_death_thread" },
    { 0x757F, "rocket_swarm_end_position" },
    { 0x7580, "rocket_swarm_fired_rumbles" },
    { 0x7581, "rocket_swarm_get_height_offset" },
    { 0x7582, "rocket_swarm_iterate_next_node" },
    { 0x7583, "rocket_swarm_linear_think" },
    { 0x7584, "rocket_swarm_path_node_think" },
    { 0x7585, "rocket_swarm_path_think" },
    { 0x7586, "rocket_swarm_random_course_change" },
    { 0x7587, "rocket_swarm_should_path" },
    { 0x7588, "rocket_swarm_start_position" },
    { 0x7589, "rocket_swarm_straight_rocket" },
    { 0x758A, "rocket_swarm_target_course_change" },
    { 0x758B, "rocket_target_think" },
    { 0x758C, "rocket_targets" },
    { 0x758D, "rocket_think" },
    { 0x758E, "rocket_two_stage_swarm_think" },
    { 0x758F, "rocketammo" },
    { 0x7590, "rocketattachment" },
    { 0x7591, "rocketclip" },
    { 0x7592, "rocketdestroyaftertime" },
    { 0x7593, "rocketlauncherammo" },
    { 0x7594, "rocketpodup" },
    { 0x7595, "rocketpositionupdate" },
    { 0x7596, "rocketreloadsound" },
    { 0x7597, "rockets" },
    { 0x7598, "rockettargetent" },
    { 0x7599, "rocketturret" },
    { 0x759A, "rocketvisible" },
    { 0x759B, "rocking" },
    { 0x759C, "rocks" },
    { 0x759D, "role" },
    { 0x759E, "roll" },
    { 0x759F, "roll_ent" },
    { 0x75A0, "rolling_lp" },
    { 0x75A1, "rollingdeath" },
    { 0x75A2, "roof_breach_anticipation_fx" },
    { 0x75A3, "roof_breach_burke_plant" },
    { 0x75A4, "roof_breach_chunks_bursts" },
    { 0x75A5, "roof_breach_device_area_mark" },
    { 0x75A6, "roof_breach_device_explosion" },
    { 0x75A7, "roof_breach_device_plant_dust" },
    { 0x75A8, "roof_breach_device_plant_mini_charges" },
    { 0x75A9, "roof_breach_device_radial_sml_explosions" },
    { 0x75AA, "roof_breach_fx" },
    { 0x75AB, "roof_breach_laser_detonate" },
    { 0x75AC, "roof_logic" },
    { 0x75AD, "roof_scene_enter_water_cleanup" },
    { 0x75AE, "roof_scene_grass_close_window_blast_doors" },
    { 0x75AF, "roof_scene_grass_death_squad_handler" },
    { 0x75B0, "roof_scene_grass_deploy_guards" },
    { 0x75B1, "roof_scene_grass_guard_cleanup" },
    { 0x75B2, "roof_scene_grass_handle_guard_doors" },
    { 0x75B3, "roof_scene_grass_monitor_guard_clear" },
    { 0x75B4, "roof_scene_grass_section" },
    { 0x75B5, "roof_scene_grass_section_failstates" },
    { 0x75B6, "roof_scene_grass_setup_blast_door_clip" },
    { 0x75B7, "roof_scene_guards" },
    { 0x75B8, "roof_scene_hide_rig" },
    { 0x75B9, "roof_scene_industrial_death_squad_handler" },
    { 0x75BA, "roof_scene_industrial_drone_swarm_launch_manager" },
    { 0x75BB, "roof_scene_industrial_launch_drone_swarm" },
    { 0x75BC, "roof_scene_industrial_open_hatch" },
    { 0x75BD, "roof_scene_industrial_section" },
    { 0x75BE, "roof_scene_industrial_section_failstates" },
    { 0x75BF, "roof_scene_industrial_set_up_swarm" },
    { 0x75C0, "roof_scene_master_handler" },
    { 0x75C1, "roof_scene_scripted_elevator_shaft_close" },
    { 0x75C2, "roof_scene_scripted_ilona_fire_at_swarm" },
    { 0x75C3, "roof_scene_scripted_ilona_fire_at_swarm_behavior_clear" },
    { 0x75C4, "roof_scene_set_up" },
    { 0x75C5, "roof_scene_setup_failstates" },
    { 0x75C6, "roof_scene_slide" },
    { 0x75C7, "roof_scene_slide_ilana_anim_to_swim" },
    { 0x75C8, "roof_scene_slide_raise_gates" },
    { 0x75C9, "roof_scene_slide_remove_glass_blocker" },
    { 0x75CA, "roof_scene_slide_slomo_start" },
    { 0x75CB, "roof_scene_slide_slomo_stop" },
    { 0x75CC, "roof_scene_slide_wait_for_player_jumped" },
    { 0x75CD, "roof_scene_vignette_civilians" },
    { 0x75CE, "roof_scene_vignettes" },
    { 0x75CF, "roof_trigger" },
    { 0x75D0, "roof_use_trigger" },
    { 0x75D1, "rooftop_ambient_dust" },
    { 0x75D2, "rooftop_anim_length" },
    { 0x75D3, "rooftop_bombshakes" },
    { 0x75D4, "rooftop_enemy_counter" },
    { 0x75D5, "rooftop_enemy_think" },
    { 0x75D6, "rooftop_enemy_think_left" },
    { 0x75D7, "rooftop_enemy_think_right" },
    { 0x75D8, "rooftop_glass_explode" },
    { 0x75D9, "rooftop_slide" },
    { 0x75DA, "rooftop_slo_mo_override" },
    { 0x75DB, "rooftop_strafe" },
    { 0x75DC, "rooftop_strafe_start" },
    { 0x75DD, "rooftopreminderdialogue" },
    { 0x75DE, "rooftopwatchparkingguards" },
    { 0x75DF, "room_has_multiple_doors" },
    { 0x75E0, "room_volume" },
    { 0x75E1, "roomtype" },
    { 0x75E2, "root_anim" },
    { 0x75E3, "rope" },
    { 0x75E4, "rope_end_rappel" },
    { 0x75E5, "rope_knox" },
    { 0x75E6, "rope_link" },
    { 0x75E7, "rope_model" },
    { 0x75E8, "rope_setupanimation" },
    { 0x75E9, "rope_started" },
    { 0x75EA, "ropesound" },
    { 0x75EB, "rot_bot" },
    { 0x75EC, "rot_top" },
    { 0x75ED, "rotate" },
    { 0x75EE, "rotate_axis_angle" },
    { 0x75EF, "rotate_camera_to_internal" },
    { 0x75F0, "rotate_camera_to_match_ent" },
    { 0x75F1, "rotate_camera_to_offset_angles" },
    { 0x75F2, "rotate_camera_to_see_ent" },
    { 0x75F3, "rotate_ent_towards_center" },
    { 0x75F4, "rotate_missile_targets" },
    { 0x75F5, "rotate_over_time" },
    { 0x75F6, "rotate_player_to_facing_angles" },
    { 0x75F7, "rotate_roll_link" },
    { 0x75F8, "rotate_space_debris" },
    { 0x75F9, "rotate_the_universe" },
    { 0x75FA, "rotate_to_goal" },
    { 0x75FB, "rotate_until_no_diff" },
    { 0x75FC, "rotateavatartagcamera" },
    { 0x75FD, "rotatedirection" },
    { 0x75FE, "rotatedryerfan" },
    { 0x75FF, "rotategatebounce" },
    { 0x7600, "rotategates" },
    { 0x7601, "rotategatesconstant" },
    { 0x7602, "rotatehelispawn" },
    { 0x7603, "rotatemeshes" },
    { 0x7604, "rotateorbitalshippivots" },
    { 0x7605, "rotateorbitalships" },
    { 0x7606, "rotateplane" },
    { 0x7607, "rotateradar" },
    { 0x7608, "rotatetargets" },
    { 0x7609, "rotatethink" },
    { 0x760A, "rotatetime" },
    { 0x760B, "rotatetoangle" },
    { 0x760C, "rotateuavrig" },
    { 0x760D, "rotating_gate_constant" },
    { 0x760E, "rotating_gates" },
    { 0x760F, "rotatinglinkarray" },
    { 0x7610, "rotation_is_occuring" },
    { 0x7611, "rotation_offset" },
    { 0x7612, "rotation_parent" },
    { 0x7613, "rotation_total" },
    { 0x7614, "rotor_anim" },
    { 0x7615, "round_float" },
    { 0x7616, "round_millisec_on_sec" },
    { 0x7617, "round_target_unit_per_second" },
    { 0x7618, "roundabout_bicycle_riders" },
    { 0x7619, "roundabout_center_vehicle_nodes" },
    { 0x761A, "roundabout_center_vehicle_nodes_cg" },
    { 0x761B, "roundabout_center_vehicles" },
    { 0x761C, "roundabout_center_vehicles_cg" },
    { 0x761D, "roundabout_center_vehicles_moving" },
    { 0x761E, "roundabout_center_vehicles_tank_explo" },
    { 0x761F, "roundabout_civilian_flee_path_and_run_select" },
    { 0x7620, "roundabout_combat" },
    { 0x7621, "roundabout_combat_dialogue" },
    { 0x7622, "roundabout_combat_initial" },
    { 0x7623, "roundabout_combat_start_slow_motion" },
    { 0x7624, "roundabout_combat_started" },
    { 0x7625, "roundabout_combat_tanker_explode" },
    { 0x7626, "roundabout_combat_tanker_explode_veh_cg" },
    { 0x7627, "roundabout_combat_tanker_fire_damage" },
    { 0x7628, "roundabout_exited" },
    { 0x7629, "roundabout_flee_goals" },
    { 0x762A, "roundabout_general_mayhem" },
    { 0x762B, "roundabout_lobby_couch" },
    { 0x762C, "roundabout_lobby_couch_front" },
    { 0x762D, "roundabout_lobby_elevator" },
    { 0x762E, "roundabout_lobby_elevator_exiting_react_1" },
    { 0x762F, "roundabout_lobby_elevator_exiting_react_2" },
    { 0x7630, "roundabout_lobby_elevator_waiting_react_1" },
    { 0x7631, "roundabout_lobby_elevator_waiting_react_2" },
    { 0x7632, "roundabout_lobby_phone" },
    { 0x7633, "roundabout_lobby_phone_front" },
    { 0x7634, "roundabout_lobby_phone2" },
    { 0x7635, "roundabout_lobby_reacts_into_walk" },
    { 0x7636, "roundabout_lobby_security_desk" },
    { 0x7637, "roundabout_lobby_security_desk_front" },
    { 0x7638, "roundabout_lobby_vehicles" },
    { 0x7639, "roundabout_lobby_vehicles_cg" },
    { 0x763A, "roundabout_lobby_walkingtalk" },
    { 0x763B, "roundabout_magic_microwave_grenade" },
    { 0x763C, "roundabout_panic_walla" },
    { 0x763D, "roundabout_ropes" },
    { 0x763E, "roundabout_rpg_car_damage_function" },
    { 0x763F, "roundabout_rpg_fire" },
    { 0x7640, "roundabout_rush_goal" },
    { 0x7641, "roundabout_setup" },
    { 0x7642, "roundabout_setup_center_vehicle_nodes" },
    { 0x7643, "roundabout_setup_center_vehicle_nodes_cg" },
    { 0x7644, "roundabout_setup_center_vehicles" },
    { 0x7645, "roundabout_setup_center_vehicles_cg" },
    { 0x7646, "roundabout_street_car_hood_hit" },
    { 0x7647, "roundabout_street_car_hood_hit_driver" },
    { 0x7648, "roundabout_street_drop_bikes" },
    { 0x7649, "roundabout_swap_vehicle_for_model" },
    { 0x764A, "roundabout_tanker_damage" },
    { 0x764B, "roundabout_tanker_enemy_settings" },
    { 0x764C, "roundabout_tanker_enemy_settings_other" },
    { 0x764D, "roundabout_tanker_explosion" },
    { 0x764E, "roundabout_tanker_lookat" },
    { 0x764F, "roundabout_tanker_magic_rpg" },
    { 0x7650, "roundabout_traffic" },
    { 0x7651, "roundabout_walla_flag_explosion" },
    { 0x7652, "roundactive" },
    { 0x7653, "roundbegin" },
    { 0x7654, "rounddecimalplaces" },
    { 0x7655, "roundend" },
    { 0x7656, "roundenddelay" },
    { 0x7657, "roundenddof" },
    { 0x7658, "roundendwait" },
    { 0x7659, "roundheadshots" },
    { 0x765A, "roundkills" },
    { 0x765B, "roundnumber" },
    { 0x765C, "roundsplayed" },
    { 0x765D, "roundswitch" },
    { 0x765E, "roundswitchdvar" },
    { 0x765F, "roundswitchmax" },
    { 0x7660, "roundswitchmin" },
    { 0x7661, "roundup" },
    { 0x7662, "roundupgradepoints" },
    { 0x7663, "roundwinnerdialog" },
    { 0x7664, "rows" },
    { 0x7665, "rpg_at_heli" },
    { 0x7666, "rpg_at_squad_01" },
    { 0x7667, "rpg_explosion" },
    { 0x7668, "rpg_guys" },
    { 0x7669, "rpg_juke" },
    { 0x766A, "rpg_shoot" },
    { 0x766B, "rpg_shoot_dist" },
    { 0x766C, "rpgdeath" },
    { 0x766D, "rpgdestroywall" },
    { 0x766E, "rpgplayerrepulsor" },
    { 0x766F, "rpgplayerrepulsor_create" },
    { 0x7670, "rpgplayerrepulsor_getnummisses" },
    { 0x7671, "rpgshoot" },
    { 0x7672, "rs_angle" },
    { 0x7673, "rspns_cat_name" },
    { 0x7674, "rspns_cat_name_alt" },
    { 0x7675, "rt_harness_breakout" },
    { 0x7676, "rubberband_settings" },
    { 0x7677, "rules" },
    { 0x7678, "rumble" },
    { 0x7679, "rumble_base_entity" },
    { 0x767A, "rumble_basetime" },
    { 0x767B, "rumble_cam_shake" },
    { 0x767C, "rumble_duration" },
    { 0x767D, "rumble_ent" },
    { 0x767E, "rumble_entity" },
    { 0x767F, "rumble_flydrone_animation" },
    { 0x7680, "rumble_flydrone_control" },
    { 0x7681, "rumble_frogger_vehicles" },
    { 0x7682, "rumble_heavy" },
    { 0x7683, "rumble_heavy_1" },
    { 0x7684, "rumble_heavy_2" },
    { 0x7685, "rumble_heavy_3" },
    { 0x7686, "rumble_killer" },
    { 0x7687, "rumble_large" },
    { 0x7688, "rumble_light" },
    { 0x7689, "rumble_light_1" },
    { 0x768A, "rumble_light_2" },
    { 0x768B, "rumble_light_3" },
    { 0x768C, "rumble_loop" },
    { 0x768D, "rumble_medium" },
    { 0x768E, "rumble_middle_takedown_throw_guy" },
    { 0x768F, "rumble_notetracks" },
    { 0x7690, "rumble_radius" },
    { 0x7691, "rumble_ramp_off" },
    { 0x7692, "rumble_ramp_on" },
    { 0x7693, "rumble_ramp_to" },
    { 0x7694, "rumble_randomaditionaltime" },
    { 0x7695, "rumble_roundabout_rpg_car_hit" },
    { 0x7696, "rumble_roundabout_tanker" },
    { 0x7697, "rumble_scale" },
    { 0x7698, "rumble_set_ent_rumble_intensity_for_time" },
    { 0x7699, "rumble_small" },
    { 0x769A, "rumble_thread" },
    { 0x769B, "rumble_till_out_of_range" },
    { 0x769C, "rumbleatriumbreach" },
    { 0x769D, "rumblemonitor" },
    { 0x769E, "rumbleon" },
    { 0x769F, "rumbleplayerdistantexplosion" },
    { 0x76A0, "rumbleplayerheavy" },
    { 0x76A1, "rumbleplayerlight" },
    { 0x76A2, "rumblesniperdronefire" },
    { 0x76A3, "rumblesniperdronenearexplosion" },
    { 0x76A4, "rumblesniperdronetakenout" },
    { 0x76A5, "rumbletrigger" },
    { 0x76A6, "rumbling" },
    { 0x76A7, "run_accuracy" },
    { 0x76A8, "run_assembly_line" },
    { 0x76A9, "run_ball" },
    { 0x76AA, "run_call_after_wait_array" },
    { 0x76AB, "run_clearfacialanim" },
    { 0x76AC, "run_dog_command" },
    { 0x76AD, "run_fan" },
    { 0x76AE, "run_func_after_wait_array" },
    { 0x76AF, "run_nodes1" },
    { 0x76B0, "run_noself_call_after_wait_array" },
    { 0x76B1, "run_override_weights" },
    { 0x76B2, "run_overrideanim" },
    { 0x76B3, "run_overrideanim_hasstairanimarray" },
    { 0x76B4, "run_overridebulletreact" },
    { 0x76B5, "run_overridesound" },
    { 0x76B6, "run_playfacialanim" },
    { 0x76B7, "run_post_function" },
    { 0x76B8, "run_selfiebooth" },
    { 0x76B9, "run_spawn_functions" },
    { 0x76BA, "run_speed" },
    { 0x76BB, "run_speed_state" },
    { 0x76BC, "run_thread_on_noteworthy" },
    { 0x76BD, "run_thread_on_notify" },
    { 0x76BE, "run_thread_on_targetname" },
    { 0x76BF, "run_to_heli_heli_landing" },
    { 0x76C0, "run_to_heli_manticore_scene" },
    { 0x76C1, "run_to_new_spot_and_setup_gun" },
    { 0x76C2, "run_traffic" },
    { 0x76C3, "run_train" },
    { 0x76C4, "run_train_shaker" },
    { 0x76C5, "run_train_with_shaking" },
    { 0x76C6, "run_tram_killstreak" },
    { 0x76C7, "runanim" },
    { 0x76C8, "runaway_drone_think" },
    { 0x76C9, "runaway_guy_delete" },
    { 0x76CA, "runbeam" },
    { 0x76CB, "runbeamupdate" },
    { 0x76CC, "runcombat" },
    { 0x76CD, "rundecidewhatandhowtoshoot" },
    { 0x76CE, "rundroplocations" },
    { 0x76CF, "runhordecollect" },
    { 0x76D0, "runhordedefend" },
    { 0x76D1, "runhordedefuse" },
    { 0x76D2, "runhordeintel" },
    { 0x76D3, "runhordemode" },
    { 0x76D4, "runhordeobjective" },
    { 0x76D5, "runhordezombies" },
    { 0x76D6, "runingturnrate" },
    { 0x76D7, "runloopcount" },
    { 0x76D8, "runloopisnearbeginning" },
    { 0x76D9, "runngun" },
    { 0x76DA, "runngun_backward" },
    { 0x76DB, "runngunincrement" },
    { 0x76DC, "runnguntransitionpoint" },
    { 0x76DD, "runngunweight" },
    { 0x76DE, "running_car" },
    { 0x76DF, "running_handle_hud_outline_binocs" },
    { 0x76E0, "running_intance_accumulator" },
    { 0x76E1, "running_to_goal" },
    { 0x76E2, "running_up_the_stairs_fail" },
    { 0x76E3, "runningaimblendtime" },
    { 0x76E4, "runningaimlimits" },
    { 0x76E5, "runningmechblendtime" },
    { 0x76E6, "runningreacttobullets" },
    { 0x76E7, "runningtovehicle" },
    { 0x76E8, "runnormalround" },
    { 0x76E9, "runonshootbehaviorend" },
    { 0x76EA, "runpos" },
    { 0x76EB, "runroundspawning" },
    { 0x76EC, "runshootwhilemoving" },
    { 0x76ED, "runtovehicleoverride" },
    { 0x76EE, "runzombieround" },
    { 0x76EF, "rushed" },
    { 0x76F0, "rvb_apply_reverb" },
    { 0x76F1, "rvb_deactive_reverb" },
    { 0x76F2, "rvb_get_applied_reverb" },
    { 0x76F3, "rvb_init" },
    { 0x76F4, "rvb_set_dry_level" },
    { 0x76F5, "rvb_set_wet_level" },
    { 0x76F6, "rvb_start_preset" },
    { 0x76F7, "rvb_use_string_table" },
    { 0x76F8, "rvbx_apply_inital_reverb" },
    { 0x76F9, "rvbx_create" },
    { 0x76FA, "rvbx_get_preset_from_string_table" },
    { 0x76FB, "rvbx_get_reverb_preset" },
    { 0x76FC, "rvbx_get_reverb_preset_from_stringtable_internal" },
    { 0x76FD, "rvbx_store_current_reverb_track" },
    { 0x76FE, "s_flicker_catwalk_alarm" },
    { 0x76FF, "s1_deleted_prisoners_anims" },
    { 0x7700, "s1_drive_and_elevator_scene" },
    { 0x7701, "s1_elevator_boundary_function" },
    { 0x7702, "s1_motionset_avaliable" },
    { 0x7703, "s1_popping_smoke" },
    { 0x7704, "s1_truck_unload_main_allies_anims" },
    { 0x7705, "s1_truck_unload_main_guards_anims" },
    { 0x7706, "s2_elevator_door_close" },
    { 0x7707, "s2_elevator_door_open" },
    { 0x7708, "s2_elevator_door_open_top" },
    { 0x7709, "s2_elevator_ride_down" },
    { 0x770A, "s2_prison_amb" },
    { 0x770B, "s2_walk_execution_pa" },
    { 0x770C, "s2_walk_footsteps" },
    { 0x770D, "s2_walk_vo_execution" },
    { 0x770E, "s2elevator_fade_transition" },
    { 0x770F, "s2elevator_trolley_intro_scene" },
    { 0x7710, "s2walk_ambient_character_cleanup" },
    { 0x7711, "s2walk_cage_door_open" },
    { 0x7712, "s2walk_dynamic_speed_adjuster" },
    { 0x7713, "s2walk_guard_cages_vo_notetrack" },
    { 0x7714, "s2walk_guard_end_cleanup" },
    { 0x7715, "s2walk_guard_gate_vo_notetrack" },
    { 0x7716, "s2walk_player_push" },
    { 0x7717, "s3_body_movement" },
    { 0x7718, "s3_break_glass" },
    { 0x7719, "s3_controlroom_attack_vo_notetrack" },
    { 0x771A, "s3_controlroom_exit_vo_notetrack1" },
    { 0x771B, "s3_controlroom_exit_vo_notetrack2" },
    { 0x771C, "s3_controlroom_exit_vo_notetrack3" },
    { 0x771D, "s3_controlroom_exit_vo_notetrack4" },
    { 0x771E, "s3_controlroom_exit_vo_notetrack5" },
    { 0x771F, "s3_controlroom_exit_vo_notetrack6" },
    { 0x7720, "s3_controlroom_exit_vo_notetrack7" },
    { 0x7721, "s3_controlroom_vo_notetrack1" },
    { 0x7722, "s3_controlroom_vo_notetrack2" },
    { 0x7723, "s3_controlroom_vo_notetrack3" },
    { 0x7724, "s3_controlroom_vo_notetrack4" },
    { 0x7725, "s3_controlroom_vo_notetrack5" },
    { 0x7726, "s3_controlroom_vo_notetrack6" },
    { 0x7727, "s3_enter_security_room" },
    { 0x7728, "s3_escape_ally_gun_help_anim" },
    { 0x7729, "s3_escape_console_gun_action" },
    { 0x772A, "s3_escape_console_monitor" },
    { 0x772B, "s3_escape_controlroom_door_notetrack" },
    { 0x772C, "s3_escape_controlroom_exit_door_notetrack" },
    { 0x772D, "s3_escape_controlroom_exit_door_swipe_sfx_notetrack" },
    { 0x772E, "s3_escape_deathwatcher" },
    { 0x772F, "s3_escape_door_notetrack" },
    { 0x7730, "s3_escape_elevator_movement" },
    { 0x7731, "s3_escape_elevator_start" },
    { 0x7732, "s3_escape_guard_function" },
    { 0x7733, "s3_escape_guards_enter" },
    { 0x7734, "s3_escape_gun_action" },
    { 0x7735, "s3_escape_hack_action" },
    { 0x7736, "s3_escape_hack_action_switcher" },
    { 0x7737, "s3_escape_outer_door" },
    { 0x7738, "s3_escape_player_exo_and_gun_anim" },
    { 0x7739, "s3_escape_player_gun" },
    { 0x773A, "s3_escape_sliding_door_player" },
    { 0x773B, "s3_fade_over_time" },
    { 0x773C, "s3_get_gun_vo_notetrack1" },
    { 0x773D, "s3_get_gun_vo_notetrack2" },
    { 0x773E, "s3_get_gun_vo_notetrack3" },
    { 0x773F, "s3_guard_takedown_vo_notetrack" },
    { 0x7740, "s3_interrogate_doctor_scene" },
    { 0x7741, "s3_splitup_event" },
    { 0x7742, "s3_toggle_rig" },
    { 0x7743, "s3escape_console_cinematic_watcher" },
    { 0x7744, "s3escape_console_pause_checkpoint" },
    { 0x7745, "s3escape_console_setup" },
    { 0x7746, "s3escape_doctor_kill" },
    { 0x7747, "s3escape_doctor_killbox_prompt" },
    { 0x7748, "s3escape_doctor_scene" },
    { 0x7749, "s3escape_fade_to_black" },
    { 0x774A, "s3escape_gideon_gun_anim" },
    { 0x774B, "s3escape_intro_scene" },
    { 0x774C, "sabbomb" },
    { 0x774D, "safe_activate_trigger_with_targetname" },
    { 0x774E, "safe_str" },
    { 0x774F, "safe_to_spawn_vehciles" },
    { 0x7750, "safe_vehicle_delete" },
    { 0x7751, "safe_volume" },
    { 0x7752, "safefromgas" },
    { 0x7753, "safehouse_backyard_damb" },
    { 0x7754, "safehouse_balcony_siren" },
    { 0x7755, "safehouse_escape_music" },
    { 0x7756, "safehouse_exo_trans_fade_in" },
    { 0x7757, "safehouse_exo_trans_fade_out" },
    { 0x7758, "safehouse_int_trigger_think" },
    { 0x7759, "safehouse_sonic_destruct" },
    { 0x775A, "safehousebackyardalertmonitoroff" },
    { 0x775B, "safehousebackyardalertmonitoron" },
    { 0x775C, "safehousebackyarddamagetriggers" },
    { 0x775D, "safehousebackyarddamagetriggerstoggle" },
    { 0x775E, "safehousebackyarddamagetriggerwaits" },
    { 0x775F, "safehousebagdropreminder" },
    { 0x7760, "safehousebagdroprumblelight" },
    { 0x7761, "safehousebeginentrance" },
    { 0x7762, "safehousebeginexit" },
    { 0x7763, "safehousechangeclothes" },
    { 0x7764, "safehouseclearfirstfloordialogue" },
    { 0x7765, "safehouseclearsecondfloordialogue" },
    { 0x7766, "safehousecourtyarddistraction" },
    { 0x7767, "safehousecourtyarddistractioninterrupt" },
    { 0x7768, "safehousecourtyardsightwatch" },
    { 0x7769, "safehousecourtyardtakedownilonafail" },
    { 0x776A, "safehousecourtyardtakedownknifenpc" },
    { 0x776B, "safehousecourtyardtakedownprops" },
    { 0x776C, "safehousedoorinit" },
    { 0x776D, "safehousedoorplayerblocker" },
    { 0x776E, "safehousedoorsetlocked" },
    { 0x776F, "safehousedoorunlockednotetrack" },
    { 0x7770, "safehouseenddronecontrolsetup" },
    { 0x7771, "safehouseenemiesignoreplayer" },
    { 0x7772, "safehouseenemyinit" },
    { 0x7773, "safehouseexit2floor" },
    { 0x7774, "safehouseexit2floorviewmodel" },
    { 0x7775, "safehouseexitautosaves" },
    { 0x7776, "safehouseexitdeadbodysetupcouchguard" },
    { 0x7777, "safehouseexitdeadbodysetuppacingguard" },
    { 0x7778, "safehouseexitplayerjumpwatcher" },
    { 0x7779, "safehouseexitplayerleaps" },
    { 0x777A, "safehouseexittogglegates" },
    { 0x777B, "safehousefailcoverblown" },
    { 0x777C, "safehousefailkvaalerted" },
    { 0x777D, "safehousefailtargetescaped" },
    { 0x777E, "safehouseflaginit" },
    { 0x777F, "safehousefollowplayernotifies" },
    { 0x7780, "safehousefollowreminder1" },
    { 0x7781, "safehousefollowreminder2" },
    { 0x7782, "safehousefollowreminder3" },
    { 0x7783, "safehouseforceopensafehousedoor" },
    { 0x7784, "safehousefrontdoorreminder" },
    { 0x7785, "safehousegatebashfx" },
    { 0x7786, "safehouseglobalsetup" },
    { 0x7787, "safehouseglobalvars" },
    { 0x7788, "safehouseguardalertwatch" },
    { 0x7789, "safehouseguardsightwatch" },
    { 0x778A, "safehouseguardtriggerwatch" },
    { 0x778B, "safehouseilanabagdropwait" },
    { 0x778C, "safehouseilanacheckdeckweapon" },
    { 0x778D, "safehouseilanaclearsafehouse" },
    { 0x778E, "safehouseilanaexitstairs" },
    { 0x778F, "safehouseilanaopendooridle" },
    { 0x7790, "safehouseilanaopensafehousedoor" },
    { 0x7791, "safehouseilanaplanningguardsearlykill" },
    { 0x7792, "safehouseilanasafehouseexit" },
    { 0x7793, "safehouseilanasetupteamkill" },
    { 0x7794, "safehouseilanasonicexocheck" },
    { 0x7795, "safehouseilanastairway" },
    { 0x7796, "safehouseilanatransition" },
    { 0x7797, "safehouseilanaweaponshot" },
    { 0x7798, "safehousekilldialogue" },
    { 0x7799, "safehousekillreminder" },
    { 0x779A, "safehousekvafollowtargetdeath" },
    { 0x779B, "safehousemonitorbagdrophint" },
    { 0x779C, "safehousemonitorbagdropinteract" },
    { 0x779D, "safehouseobjectivesetup" },
    { 0x779E, "safehouseoutrodialogue" },
    { 0x779F, "safehousepacingguard" },
    { 0x77A0, "safehousepacingguardalertmonitor" },
    { 0x77A1, "safehousepacingguardconversationmonitor" },
    { 0x77A2, "safehousepacingguarddeath" },
    { 0x77A3, "safehousepacingguardtriggerwatch" },
    { 0x77A4, "safehousepatrolleralertwatch" },
    { 0x77A5, "safehouseplanningguard" },
    { 0x77A6, "safehouseplanningguarddeathcheck" },
    { 0x77A7, "safehouseplanningguardfailendnotetrack" },
    { 0x77A8, "safehouseplanningguardfailwatch" },
    { 0x77A9, "safehouseplanningguards" },
    { 0x77AA, "safehouseplanningguardsdialog" },
    { 0x77AB, "safehouseplanningguardsweapons" },
    { 0x77AC, "safehouseplayermovespeedscale1stfloor" },
    { 0x77AD, "safehouseplayermovespeedscale2ndfloor" },
    { 0x77AE, "safehouseprecache" },
    { 0x77AF, "safehouseremoveplayerblocker" },
    { 0x77B0, "safehouseremovethreatgrenade" },
    { 0x77B1, "safehousesecondfloorilonacouchkill" },
    { 0x77B2, "safehousesecondfloorreminder" },
    { 0x77B3, "safehousesetcompletedobjflags" },
    { 0x77B4, "safehousesetupsniperdroneilana" },
    { 0x77B5, "safehousesleepingguard" },
    { 0x77B6, "safehousesleepingguardanimcheck" },
    { 0x77B7, "safehousesleepingguarddeath" },
    { 0x77B8, "safehousesniperdronecloaking" },
    { 0x77B9, "safehousesniperdronelaunch" },
    { 0x77BA, "safehousesonicdustfx" },
    { 0x77BB, "safehousespawnbackalleykva" },
    { 0x77BC, "safehousespawnbackalleyrooftopkva" },
    { 0x77BD, "safehousespawnwindowshooters" },
    { 0x77BE, "safehousestartpoints" },
    { 0x77BF, "safehousestartpointsfinal" },
    { 0x77C0, "safehousetakedownreturnplayercontrol" },
    { 0x77C1, "safehousetoggleexitflagtriggers" },
    { 0x77C2, "safehousetransitiondialogue" },
    { 0x77C3, "safehousetranstoalleygatesetup" },
    { 0x77C4, "safehousetvdestructible" },
    { 0x77C5, "safehousevideochatmovie" },
    { 0x77C6, "safehousewindowshootermonitor" },
    { 0x77C7, "safehousewindowshootermovetarget" },
    { 0x77C8, "safehousewindowshooterthink" },
    { 0x77C9, "safehousewindowshutterdestroy" },
    { 0x77CA, "safelyplayanimatrateuntilnotetrack" },
    { 0x77CB, "safelyplayanimnatrateuntilnotetrack" },
    { 0x77CC, "safelyplayanimnuntilnotetrack" },
    { 0x77CD, "safelyplayanimuntilnotetrack" },
    { 0x77CE, "safemod" },
    { 0x77CF, "safeorigin" },
    { 0x77D0, "safetyteleport_actor" },
    { 0x77D1, "safetyteleport_allies" },
    { 0x77D2, "saint" },
    { 0x77D3, "salvo_ammo" },
    { 0x77D4, "salvo_cooldown_max" },
    { 0x77D5, "salvo_cooldown_min" },
    { 0x77D6, "salvo_idx" },
    { 0x77D7, "salvo0" },
    { 0x77D8, "salvo1" },
    { 0x77D9, "sam_acquiretarget" },
    { 0x77DA, "sam_attacktargets" },
    { 0x77DB, "sam_fireontarget" },
    { 0x77DC, "sam_watchcrashing" },
    { 0x77DD, "sam_watchlaser" },
    { 0x77DE, "sam_watchleaving" },
    { 0x77DF, "sam_watchlineofsight" },
    { 0x77E0, "samb" },
    { 0x77E1, "samb1_name" },
    { 0x77E2, "samb2_name" },
    { 0x77E3, "same_color_code_as_last_time" },
    { 0x77E4, "same_mech_chaingun_last_state" },
    { 0x77E5, "same_mech_rocket_last_state" },
    { 0x77E6, "same_mech_swarm_last_state" },
    { 0x77E7, "sameshotdamage" },
    { 0x77E8, "sammissilegroup" },
    { 0x77E9, "sammissilegroups" },
    { 0x77EA, "samtargetent" },
    { 0x77EB, "samturret" },
    { 0x77EC, "sanfran_b_bridge_clut" },
    { 0x77ED, "sanfran_b_dark_lightset" },
    { 0x77EE, "sanfran_b_darker_lightset" },
    { 0x77EF, "sanfran_b_dim" },
    { 0x77F0, "sanfran_b_exterior_clut" },
    { 0x77F1, "sanfran_b_exterior_clut_fast" },
    { 0x77F2, "sanfran_b_fire" },
    { 0x77F3, "sanfran_b_hangar_lightset" },
    { 0x77F4, "sanfran_b_info_top_lightset" },
    { 0x77F5, "sanfran_b_interior_blue_clut" },
    { 0x77F6, "sanfran_b_interior_clut" },
    { 0x77F7, "sanfran_b_lightset" },
    { 0x77F8, "sanfran_b_locations" },
    { 0x77F9, "sanfran_intro_screen" },
    { 0x77FA, "sanfran_locations" },
    { 0x77FB, "sarray_clear" },
    { 0x77FC, "sarray_copy" },
    { 0x77FD, "sarray_create_func_obj" },
    { 0x77FE, "sarray_get" },
    { 0x77FF, "sarray_length" },
    { 0x7800, "sarray_pop" },
    { 0x7801, "sarray_push" },
    { 0x7802, "sarray_set" },
    { 0x7803, "sarray_sort_by_handler" },
    { 0x7804, "sarray_spawn" },
    { 0x7805, "save" },
    { 0x7806, "save_exhaust_hatch" },
    { 0x7807, "save_flank_info" },
    { 0x7808, "save_friendlies" },
    { 0x7809, "save_game_big_jump" },
    { 0x780A, "save_game_drone_swarm_street_begin" },
    { 0x780B, "save_game_start_building_fob" },
    { 0x780C, "save_game_when_dead" },
    { 0x780D, "save_ignore_setting" },
    { 0x780E, "save_intel_for_all_players" },
    { 0x780F, "save_redo_buffer" },
    { 0x7810, "save_turret_sharing_info" },
    { 0x7811, "save_undo_buffer" },
    { 0x7812, "savecommit_aftergrenade" },
    { 0x7813, "saved" },
    { 0x7814, "saved_actionslotdata" },
    { 0x7815, "saved_bg_viewbobmax" },
    { 0x7816, "saved_hud_damagefeedback" },
    { 0x7817, "saved_lastweapon" },
    { 0x7818, "saved_targetname" },
    { 0x7819, "savedata" },
    { 0x781A, "savedcompassfadetime" },
    { 0x781B, "savedefaultturnrate" },
    { 0x781C, "savednotify" },
    { 0x781D, "savedorigin" },
    { 0x781E, "savedposition" },
    { 0x781F, "saveheadicon" },
    { 0x7820, "savehere" },
    { 0x7821, "saveplayerweaponstatepersistent" },
    { 0x7822, "savetostructfn" },
    { 0x7823, "saw_mgturretlink" },
    { 0x7824, "sawcorpse" },
    { 0x7825, "sawenemymove" },
    { 0x7826, "saydamaged" },
    { 0x7827, "saygenericdialogue" },
    { 0x7828, "saying_vo" },
    { 0x7829, "saylocalsound" },
    { 0x782A, "saylocalsounddelayed" },
    { 0x782B, "sayspecificdialogue" },
    { 0x782C, "sbadplacename" },
    { 0x782D, "scaffolding_update_my_volume_think" },
    { 0x782E, "scalar_actual" },
    { 0x782F, "scalar_target" },
    { 0x7830, "scale" },
    { 0x7831, "scale_3d_hint_button" },
    { 0x7832, "scale_3d_hud_elem" },
    { 0x7833, "scale_flame_sound_logic2" },
    { 0x7834, "scale_missile_reticle_with_dist" },
    { 0x7835, "scale_vehicle_speed" },
    { 0x7836, "scaler" },
    { 0x7837, "scalesoundsonexit" },
    { 0x7838, "scalestickinput" },
    { 0x7839, "scalevelocity" },
    { 0x783A, "scan_space_with_noise" },
    { 0x783B, "scancamerafoundpotentialtarget" },
    { 0x783C, "scancamerainitvariables" },
    { 0x783D, "scancameraswitching" },
    { 0x783E, "scancameratargetdialogue" },
    { 0x783F, "scancounter" },
    { 0x7840, "scanfadeintro" },
    { 0x7841, "scanfadeoutro" },
    { 0x7842, "scanforrocketenemies" },
    { 0x7843, "scaninitremindermonitor" },
    { 0x7844, "scanlinemeshes" },
    { 0x7845, "scanner_beam" },
    { 0x7846, "scanner_cone_inside_ents" },
    { 0x7847, "scanner_forward" },
    { 0x7848, "scanner_front_door_close" },
    { 0x7849, "scanner_front_door_open" },
    { 0x784A, "scanner_local_velocity" },
    { 0x784B, "scanner_local_yaw" },
    { 0x784C, "scanner_mode" },
    { 0x784D, "scanner_monitor_emp_damage" },
    { 0x784E, "scanner_offset_from_vehicle_facing" },
    { 0x784F, "scanner_origin" },
    { 0x7850, "scanner_pa_vo" },
    { 0x7851, "scanner_pause_timer" },
    { 0x7852, "scanner_rear_door_close" },
    { 0x7853, "scanner_return" },
    { 0x7854, "scanner_rumble" },
    { 0x7855, "scanner_sweep_direction" },
    { 0x7856, "scanner_tilt" },
    { 0x7857, "scanner_yaw" },
    { 0x7858, "scanning" },
    { 0x7859, "scanprogress" },
    { 0x785A, "scantag" },
    { 0x785B, "scantagaudio" },
    { 0x785C, "scantakestoolongmonitor" },
    { 0x785D, "scantime" },
    { 0x785E, "scavenger_altmode" },
    { 0x785F, "scavenger_secondary" },
    { 0x7860, "scene_control_room_ai" },
    { 0x7861, "scene_control_room_fade_up" },
    { 0x7862, "scene_enemy_walk_setup_loops" },
    { 0x7863, "scene_intro_walk" },
    { 0x7864, "scene_models" },
    { 0x7865, "scene_origin" },
    { 0x7866, "scene_s1_in_elevator" },
    { 0x7867, "scene_walk" },
    { 0x7868, "schedule_remove_avatar" },
    { 0x7869, "school_animated_fences" },
    { 0x786A, "school_begin_onbike" },
    { 0x786B, "school_bodies_room_no_crouching" },
    { 0x786C, "school_burke_external" },
    { 0x786D, "school_deadroom_dialogue" },
    { 0x786E, "school_dialogue" },
    { 0x786F, "school_drone_spawn" },
    { 0x7870, "school_enter_dialogue" },
    { 0x7871, "school_exterior_cleaning_crew_dialogue" },
    { 0x7872, "school_exterior_dialogue" },
    { 0x7873, "school_fall" },
    { 0x7874, "school_fall_frame_hide" },
    { 0x7875, "school_fall_into_basement" },
    { 0x7876, "school_fall_rumble" },
    { 0x7877, "school_fall_slowmo_lerp" },
    { 0x7878, "school_funtions_to_load" },
    { 0x7879, "school_jeep_light_tgl" },
    { 0x787A, "school_kva_basement_dialogue" },
    { 0x787B, "school_kva_basement_rats_dialogue" },
    { 0x787C, "school_kva_fall_notice_guy" },
    { 0x787D, "school_kva_spot_guy" },
    { 0x787E, "school_light_burst_dialogue" },
    { 0x787F, "school_lightning_strike" },
    { 0x7880, "school_main" },
    { 0x7881, "school_objective" },
    { 0x7882, "school_shimmy_dialogue" },
    { 0x7883, "school_stairs_dialogue" },
    { 0x7884, "school_thisway_dialogue" },
    { 0x7885, "school_upthestairs" },
    { 0x7886, "school_wall_grab_rumble" },
    { 0x7887, "schoolfall_start" },
    { 0x7888, "science_room" },
    { 0x7889, "scn_cap_mech_door_closes" },
    { 0x788A, "scn_cap_mech_door_grab" },
    { 0x788B, "scn_truck_sounds" },
    { 0x788C, "score_and_sort_current_spawns" },
    { 0x788D, "score_col" },
    { 0x788E, "score_factor" },
    { 0x788F, "score_fx" },
    { 0x7890, "score_handler" },
    { 0x7891, "score_keeper" },
    { 0x7892, "score_manager_detect_damage" },
    { 0x7893, "score_manager_detect_enemy_death" },
    { 0x7894, "score_manager_detect_timeout" },
    { 0x7895, "score_manager_force_stop" },
    { 0x7896, "score_manager_increase_score" },
    { 0x7897, "score_manager_init" },
    { 0x7898, "score_manager_print_current_score" },
    { 0x7899, "score_manager_print_final_score" },
    { 0x789A, "score_manager_waittill_timeout_or_maxscore" },
    { 0x789B, "scoreatlifestart" },
    { 0x789C, "scorefactors_awayfromenemies" },
    { 0x789D, "scorefactors_domination" },
    { 0x789E, "scorefactors_freeforall" },
    { 0x789F, "scorefactors_hardpoint" },
    { 0x78A0, "scorefactors_nearteam" },
    { 0x78A1, "scorefactors_safeguard" },
    { 0x78A2, "scorefactors_searchandrescue" },
    { 0x78A3, "scorefactors_twar" },
    { 0x78A4, "scorelimitoverride" },
    { 0x78A5, "scorepercentagecutoff" },
    { 0x78A6, "scoreperplayer" },
    { 0x78A7, "scorespawns_awayfromenemies" },
    { 0x78A8, "scorespawns_domination" },
    { 0x78A9, "scorespawns_freeforall" },
    { 0x78AA, "scorespawns_hardpoint" },
    { 0x78AB, "scorespawns_nearteam" },
    { 0x78AC, "scorespawns_safeguard" },
    { 0x78AD, "scorespawns_searchandrescue" },
    { 0x78AE, "scorespawns_twar" },
    { 0x78AF, "scr_anim" },
    { 0x78B0, "scr_anim_viewmodel" },
    { 0x78B1, "scr_anim_vm" },
    { 0x78B2, "scr_anim_vm_index" },
    { 0x78B3, "scr_animsound" },
    { 0x78B4, "scr_animtree" },
    { 0x78B5, "scr_face" },
    { 0x78B6, "scr_goaltime" },
    { 0x78B7, "scr_look" },
    { 0x78B8, "scr_model" },
    { 0x78B9, "scr_notetrack" },
    { 0x78BA, "scr_prim_lght" },
    { 0x78BB, "scr_prim_light" },
    { 0x78BC, "scr_radio" },
    { 0x78BD, "scr_sound" },
    { 0x78BE, "scr_stub" },
    { 0x78BF, "scr_text" },
    { 0x78C0, "scr_viewanim" },
    { 0x78C1, "scramble_amb_siren_loop" },
    { 0x78C2, "scramble_siren_01" },
    { 0x78C3, "scramble_siren_setup" },
    { 0x78C4, "scrambleatlasrpg" },
    { 0x78C5, "scramblecivdrones" },
    { 0x78C6, "scramblecivfinale" },
    { 0x78C7, "scramblecivhotel" },
    { 0x78C8, "scramblecivhothall" },
    { 0x78C9, "scrambleciviliancower" },
    { 0x78CA, "scramblecivilianflee" },
    { 0x78CB, "scramblecivpatio" },
    { 0x78CC, "scramblecivpool" },
    { 0x78CD, "scramblecivrestaurant" },
    { 0x78CE, "scramblecivrestaurantdooropener" },
    { 0x78CF, "scramblecivsetup" },
    { 0x78D0, "scrambled" },
    { 0x78D1, "scrambledestroycafewall" },
    { 0x78D2, "scrambledronesfightreminderdialogue" },
    { 0x78D3, "scrambledronesplayerrestaurantreminderdialogue" },
    { 0x78D4, "scrambleeventcurrent" },
    { 0x78D5, "scrambleevents" },
    { 0x78D6, "scramblefailplayerleftilanadialogue" },
    { 0x78D7, "scramblefinalealldronesdeaddialogue" },
    { 0x78D8, "scramblefinaleallies" },
    { 0x78D9, "scramblefinalecar" },
    { 0x78DA, "scramblefinaleextrawoundedally" },
    { 0x78DB, "scramblefinalefirstwoundedally" },
    { 0x78DC, "scramblefinaleplayermovetruckreminderdialogue" },
    { 0x78DD, "scramblefinaleplayeruserpgreminderdialogue" },
    { 0x78DE, "scramblefinalesuppresssniperdialogue" },
    { 0x78DF, "scramblefiredamagemonitor" },
    { 0x78E0, "scramblegapjumpslomo" },
    { 0x78E1, "scramblehideplayergapjump" },
    { 0x78E2, "scramblehotelilanafirstdialogue" },
    { 0x78E3, "scramblehotelilanahitdialogue" },
    { 0x78E4, "scramblehoteljumpdownreminderdialogue" },
    { 0x78E5, "scramblehotelleapfrogcompletedialogue" },
    { 0x78E6, "scramblehotelplayerfirstdialogue" },
    { 0x78E7, "scramblehotelplayerrunreminderdialogue" },
    { 0x78E8, "scramblehotelsuppressorrunreminderdialogue" },
    { 0x78E9, "scramblehotelsuppresssniperreminderdialogue" },
    { 0x78EA, "scramblehothallciv" },
    { 0x78EB, "scrambleid" },
    { 0x78EC, "scrambleilanagapjump" },
    { 0x78ED, "scrambleintrogapjumpreminderdialogue" },
    { 0x78EE, "scrambleintrothroughdoorreminderdialogue" },
    { 0x78EF, "scramblejumprumbleheavy" },
    { 0x78F0, "scramblejumprumblelight" },
    { 0x78F1, "scramblemodifyplayerviewkick" },
    { 0x78F2, "scramblemonitormovetruckhint" },
    { 0x78F3, "scrambleplayercafejump" },
    { 0x78F4, "scrambleplayerfishtankstumble" },
    { 0x78F5, "scrambleplayergapjump" },
    { 0x78F6, "scrambleplayerhoteljump" },
    { 0x78F7, "scrambleplayerjumpwatcher" },
    { 0x78F8, "scrambleplayerleaps" },
    { 0x78F9, "scrambler_light" },
    { 0x78FA, "scrambler_light_off" },
    { 0x78FB, "scramblerbeepsounds" },
    { 0x78FC, "scramblerdamagelistener" },
    { 0x78FD, "scramblerestaurantcivexit" },
    { 0x78FE, "scramblerestaurantdoorsopen" },
    { 0x78FF, "scramblerestaurantexitclip" },
    { 0x7900, "scramblerproximitytracker" },
    { 0x7901, "scramblers" },
    { 0x7902, "scramblersetup" },
    { 0x7903, "scrambleruselistener" },
    { 0x7904, "scramblerwatchowner" },
    { 0x7905, "scramblesetupexittruck" },
    { 0x7906, "scramblesniperkillplayerfailmsg" },
    { 0x7907, "scramblesniperragdoll" },
    { 0x7908, "scramblesnipertowerdestruction" },
    { 0x7909, "scramblesnipertowerdestructionshake" },
    { 0x790A, "scramblespawndronesa" },
    { 0x790B, "scramblespawndronesb" },
    { 0x790C, "scramblestartdoorinit" },
    { 0x790D, "scramblestartdoorshots" },
    { 0x790E, "scrambletruckfiredamagevol" },
    { 0x790F, "scrambletruckpushrumbleheavy" },
    { 0x7910, "scramblevehicleexplodeondeath" },
    { 0x7911, "scramblevisitorcentergateopen" },
    { 0x7912, "scramproxyactive" },
    { 0x7913, "scramproxyperk" },
    { 0x7914, "scrape_pos" },
    { 0x7915, "scrape_sounds" },
    { 0x7916, "scrapeenabled" },
    { 0x7917, "scrapefadeouttime" },
    { 0x7918, "scrapeseperationtime" },
    { 0x7919, "scrapeupdaterate" },
    { 0x791A, "screen" },
    { 0x791B, "screen_detailed_alpha" },
    { 0x791C, "screen_effect_base" },
    { 0x791D, "screen_effect_fade" },
    { 0x791E, "screen_effect_on_open_bottom" },
    { 0x791F, "screen_effect_on_open_side" },
    { 0x7920, "screen_effect_sides" },
    { 0x7921, "screen_fade" },
    { 0x7922, "screen_fade_in" },
    { 0x7923, "screen_fade_out" },
    { 0x7924, "screen_flicker" },
    { 0x7925, "screen_flicker_full" },
    { 0x7926, "screen_flicker_full_solo" },
    { 0x7927, "screenangle" },
    { 0x7928, "screeneffect" },
    { 0x7929, "screennamemap" },
    { 0x792A, "screenpos" },
    { 0x792B, "screenshakefade" },
    { 0x792C, "script_accel" },
    { 0x792D, "script_accel_fraction" },
    { 0x792E, "script_accumulate" },
    { 0x792F, "script_accuracy" },
    { 0x7930, "script_ai_invulnerable" },
    { 0x7931, "script_aigroup" },
    { 0x7932, "script_airresistance" },
    { 0x7933, "script_airspeed" },
    { 0x7934, "script_allow_driver_death" },
    { 0x7935, "script_allow_rider_death" },
    { 0x7936, "script_allow_rider_deaths" },
    { 0x7937, "script_allowdeath" },
    { 0x7938, "script_ammo_alt_clip" },
    { 0x7939, "script_ammo_alt_extra" },
    { 0x793A, "script_ammo_clip" },
    { 0x793B, "script_ammo_extra" },
    { 0x793C, "script_ammo_max" },
    { 0x793D, "script_angles" },
    { 0x793E, "script_anglevehicle" },
    { 0x793F, "script_animation" },
    { 0x7940, "script_animname" },
    { 0x7941, "script_area" },
    { 0x7942, "script_assaultnode" },
    { 0x7943, "script_attackai" },
    { 0x7944, "script_attackeraccuracy" },
    { 0x7945, "script_attackmetype" },
    { 0x7946, "script_attackpattern" },
    { 0x7947, "script_attackspeed" },
    { 0x7948, "script_audio_blend_mode" },
    { 0x7949, "script_audio_enter_func" },
    { 0x794A, "script_audio_enter_msg" },
    { 0x794B, "script_audio_exit_func" },
    { 0x794C, "script_audio_exit_msg" },
    { 0x794D, "script_audio_point_func" },
    { 0x794E, "script_audio_progress_func" },
    { 0x794F, "script_audio_progress_map" },
    { 0x7950, "script_audio_progress_msg" },
    { 0x7951, "script_audio_update_rate" },
    { 0x7952, "script_audio_use_distance_only" },
    { 0x7953, "script_audio_zones" },
    { 0x7954, "script_autosave" },
    { 0x7955, "script_autosavename" },
    { 0x7956, "script_autotarget" },
    { 0x7957, "script_avoidplayer" },
    { 0x7958, "script_avoidvehicles" },
    { 0x7959, "script_axial" },
    { 0x795A, "script_badplace" },
    { 0x795B, "script_balcony" },
    { 0x795C, "script_baseoffire" },
    { 0x795D, "script_battlechatter" },
    { 0x795E, "script_battleplan" },
    { 0x795F, "script_bcdialog" },
    { 0x7960, "script_bctrigger" },
    { 0x7961, "script_bg_offset" },
    { 0x7962, "script_bombmode_dual" },
    { 0x7963, "script_bombmode_original" },
    { 0x7964, "script_bombmode_single" },
    { 0x7965, "script_brake" },
    { 0x7966, "script_breach_id" },
    { 0x7967, "script_breachgroup" },
    { 0x7968, "script_bulletshield" },
    { 0x7969, "script_burst" },
    { 0x796A, "script_burst_max" },
    { 0x796B, "script_burst_min" },
    { 0x796C, "script_button" },
    { 0x796D, "script_car_on_left" },
    { 0x796E, "script_car_on_right" },
    { 0x796F, "script_careful" },
    { 0x7970, "script_cars" },
    { 0x7971, "script_chance" },
    { 0x7972, "script_char_group" },
    { 0x7973, "script_char_index" },
    { 0x7974, "script_chatgroup" },
    { 0x7975, "script_cheap" },
    { 0x7976, "script_cleartargetyaw" },
    { 0x7977, "script_cobratarget" },
    { 0x7978, "script_color_allies" },
    { 0x7979, "script_color_axis" },
    { 0x797A, "script_color_delay_override" },
    { 0x797B, "script_colorlast" },
    { 0x797C, "script_color_assign_intelligently" },
    { 0x797D, "script_combatbehavior" },
    { 0x797E, "script_combatmode" },
    { 0x797F, "script_count" },
    { 0x7980, "script_count_max" },
    { 0x7981, "script_count_min" },
    { 0x7982, "script_crashtype" },
    { 0x7983, "script_crashtypeoverride" },
    { 0x7984, "script_damage" },
    { 0x7985, "script_danger_react" },
    { 0x7986, "script_death" },
    { 0x7987, "script_death_max" },
    { 0x7988, "script_death_min" },
    { 0x7989, "script_deathchain" },
    { 0x798A, "script_deathflag" },
    { 0x798B, "script_deathflag_longdeath" },
    { 0x798C, "script_deathroll" },
    { 0x798D, "script_deathtime" },
    { 0x798E, "script_decel" },
    { 0x798F, "script_decel_fraction" },
    { 0x7990, "script_delay_max" },
    { 0x7991, "script_delay_min" },
    { 0x7992, "script_delay_post" },
    { 0x7993, "script_delay_spawn" },
    { 0x7994, "script_delayed_playerseek" },
    { 0x7995, "script_delete" },
    { 0x7996, "script_deleteai" },
    { 0x7997, "script_dest_cover_chunkfx" },
    { 0x7998, "script_dest_cover_chunkhealth" },
    { 0x7999, "script_dest_cover_chunksnd" },
    { 0x799A, "script_dest_cover_dmg_dist" },
    { 0x799B, "script_dest_cover_dmg_model" },
    { 0x799C, "script_dest_cover_numchunks" },
    { 0x799D, "script_destruct_collision" },
    { 0x799E, "script_destructable_area" },
    { 0x799F, "script_destructible_tree_think" },
    { 0x79A0, "script_diequietly" },
    { 0x79A1, "script_difficulty" },
    { 0x79A2, "script_disablevehicleaudio" },
    { 0x79A3, "script_disconnectpaths" },
    { 0x79A4, "script_displaceable" },
    { 0x79A5, "script_dof_far_blur" },
    { 0x79A6, "script_dof_far_end" },
    { 0x79A7, "script_dof_far_start" },
    { 0x79A8, "script_dof_near_blur" },
    { 0x79A9, "script_dof_near_end" },
    { 0x79AA, "script_dof_near_start" },
    { 0x79AB, "script_dont_link_turret" },
    { 0x79AC, "script_dontpeek" },
    { 0x79AD, "script_dontshootwhilemoving" },
    { 0x79AE, "script_dontunloadonend" },
    { 0x79AF, "script_dot" },
    { 0x79B0, "script_drone" },
    { 0x79B1, "script_drone_override" },
    { 0x79B2, "script_drone_repeat_count" },
    { 0x79B3, "script_dronelag" },
    { 0x79B4, "script_drones_max" },
    { 0x79B5, "script_drones_min" },
    { 0x79B6, "script_dronestartmove" },
    { 0x79B7, "script_duration" },
    { 0x79B8, "script_earthquake" },
    { 0x79B9, "script_emptyspawner" },
    { 0x79BA, "script_end_flag_clear" },
    { 0x79BB, "script_ender" },
    { 0x79BC, "script_engage" },
    { 0x79BD, "script_engagedelay" },
    { 0x79BE, "script_ent_flag_clear" },
    { 0x79BF, "script_ent_flag_set" },
    { 0x79C0, "script_ent_flag_wait" },
    { 0x79C1, "script_explode" },
    { 0x79C2, "script_exploder" },
    { 0x79C3, "script_exploder_delay" },
    { 0x79C4, "script_exploder_group" },
    { 0x79C5, "script_explosive_bullet_shield" },
    { 0x79C6, "script_faceangles" },
    { 0x79C7, "script_faceenemydist" },
    { 0x79C8, "script_facing" },
    { 0x79C9, "script_fallback" },
    { 0x79CA, "script_fallback_group" },
    { 0x79CB, "script_falldirection" },
    { 0x79CC, "script_favoriteenemy" },
    { 0x79CD, "script_fightdist" },
    { 0x79CE, "script_firefx" },
    { 0x79CF, "script_firefxdelay" },
    { 0x79D0, "script_firefxsound" },
    { 0x79D1, "script_firefxtimeout" },
    { 0x79D2, "script_firelink" },
    { 0x79D3, "script_fireondrones" },
    { 0x79D4, "script_fixednode" },
    { 0x79D5, "script_fixedposition" },
    { 0x79D6, "script_flag" },
    { 0x79D7, "script_flag_clear" },
    { 0x79D8, "script_flag_delay" },
    { 0x79D9, "script_flag_false" },
    { 0x79DA, "script_flag_flase" },
    { 0x79DB, "script_flag_set" },
    { 0x79DC, "script_flag_true" },
    { 0x79DD, "script_flag_wait" },
    { 0x79DE, "script_flagwait" },
    { 0x79DF, "script_flakaicount" },
    { 0x79E0, "script_flanker" },
    { 0x79E1, "script_flashbangs" },
    { 0x79E2, "script_flowrate" },
    { 0x79E3, "script_fogset_end" },
    { 0x79E4, "script_fogset_start" },
    { 0x79E5, "script_followmax" },
    { 0x79E6, "script_followmin" },
    { 0x79E7, "script_followmode" },
    { 0x79E8, "script_force_count" },
    { 0x79E9, "script_forcecolor" },
    { 0x79EA, "script_forcefire_delay" },
    { 0x79EB, "script_forcefire_duration" },
    { 0x79EC, "script_forcegoal" },
    { 0x79ED, "script_forcegrenade" },
    { 0x79EE, "script_forcespawn" },
    { 0x79EF, "script_forceyaw" },
    { 0x79F0, "script_friendly_fire_disable" },
    { 0x79F1, "script_friendname" },
    { 0x79F2, "script_friendnames" },
    { 0x79F3, "script_fxcommand" },
    { 0x79F4, "script_fxid" },
    { 0x79F5, "script_fxstart" },
    { 0x79F6, "script_fxstop" },
    { 0x79F7, "script_gameobjectname" },
    { 0x79F8, "script_gametype_atdm" },
    { 0x79F9, "script_gametype_ctf" },
    { 0x79FA, "script_gametype_dm" },
    { 0x79FB, "script_gametype_hq" },
    { 0x79FC, "script_gametype_koth" },
    { 0x79FD, "script_gametype_sd" },
    { 0x79FE, "script_gametype_tdm" },
    { 0x79FF, "script_gatetrigger" },
    { 0x7A00, "script_ghettotag" },
    { 0x7A01, "script_goal_radius" },
    { 0x7A02, "script_goal_type" },
    { 0x7A03, "script_goal_yaw" },
    { 0x7A04, "script_goalheight" },
    { 0x7A05, "script_goalpitch" },
    { 0x7A06, "script_goalvolume" },
    { 0x7A07, "script_goalyaw" },
    { 0x7A08, "script_god_mode" },
    { 0x7A09, "script_godmode" },
    { 0x7A0A, "script_grenades" },
    { 0x7A0B, "script_grenadeshield" },
    { 0x7A0C, "script_grenadespeed" },
    { 0x7A0D, "script_group" },
    { 0x7A0E, "script_growl" },
    { 0x7A0F, "script_health" },
    { 0x7A10, "script_helimove" },
    { 0x7A11, "script_hidden" },
    { 0x7A12, "script_hint" },
    { 0x7A13, "script_hoverwait" },
    { 0x7A14, "script_idleanim" },
    { 0x7A15, "script_idlereach" },
    { 0x7A16, "script_ignore_suppression" },
    { 0x7A17, "script_ignoreall" },
    { 0x7A18, "script_ignoreme" },
    { 0x7A19, "script_immunetoflash" },
    { 0x7A1A, "script_increment" },
    { 0x7A1B, "script_index" },
    { 0x7A1C, "script_intensity_max" },
    { 0x7A1D, "script_intensity_min" },
    { 0x7A1E, "script_keepdriver" },
    { 0x7A1F, "script_kill_vehicle_spawner" },
    { 0x7A20, "script_killspawner" },
    { 0x7A21, "script_killspawner_group" },
    { 0x7A22, "script_land" },
    { 0x7A23, "script_landmark" },
    { 0x7A24, "script_laser" },
    { 0x7A25, "script_light" },
    { 0x7A26, "script_light_startnotify" },
    { 0x7A27, "script_light_stopnotify" },
    { 0x7A28, "script_linikto" },
    { 0x7A29, "script_linkto" },
    { 0x7A2A, "script_location" },
    { 0x7A2B, "script_longdeath" },
    { 0x7A2C, "script_looping" },
    { 0x7A2D, "script_manualtarget" },
    { 0x7A2E, "script_mapsize_08" },
    { 0x7A2F, "script_mapsize_16" },
    { 0x7A30, "script_mapsize_32" },
    { 0x7A31, "script_mapsize_64" },
    { 0x7A32, "script_max_left_angle" },
    { 0x7A33, "script_max_right_angle" },
    { 0x7A34, "script_maxdist" },
    { 0x7A35, "script_maxspawn" },
    { 0x7A36, "script_mg_angle" },
    { 0x7A37, "script_mg42" },
    { 0x7A38, "script_mg42auto" },
    { 0x7A39, "script_mgturret" },
    { 0x7A3A, "script_mgturretauto" },
    { 0x7A3B, "script_minspec_hooks_level" },
    { 0x7A3C, "script_minspec_level" },
    { 0x7A3D, "script_missiles" },
    { 0x7A3E, "script_model_anims" },
    { 0x7A3F, "script_modelname" },
    { 0x7A40, "script_models" },
    { 0x7A41, "script_mortargroup" },
//  { 0x7A42, "" },
    { 0x7A43, "script_moveoverride" },
    { 0x7A44, "script_moveplaybackrate" },
    { 0x7A45, "script_mover" },
    { 0x7A46, "script_mover_add_animation" },
    { 0x7A47, "script_mover_add_hintstring" },
    { 0x7A48, "script_mover_add_parameters" },
    { 0x7A49, "script_mover_agent_spawn_watch" },
    { 0x7A4A, "script_mover_allow_usable" },
    { 0x7A4B, "script_mover_animate" },
    { 0x7A4C, "script_mover_animations" },
    { 0x7A4D, "script_mover_apply_move_parameters" },
    { 0x7A4E, "script_mover_classnames" },
    { 0x7A4F, "script_mover_connect_watch" },
    { 0x7A50, "script_mover_connectpaths" },
    { 0x7A51, "script_mover_defaults" },
    { 0x7A52, "script_mover_delay" },
    { 0x7A53, "script_mover_delete" },
    { 0x7A54, "script_mover_disconnectpaths" },
    { 0x7A55, "script_mover_func_on_notify" },
    { 0x7A56, "script_mover_handle_notetracks" },
    { 0x7A57, "script_mover_hide" },
    { 0x7A58, "script_mover_hintstrings" },
    { 0x7A59, "script_mover_init" },
    { 0x7A5A, "script_mover_init_move_parameters" },
    { 0x7A5B, "script_mover_is_animated" },
    { 0x7A5C, "script_mover_is_dynamic_path" },
    { 0x7A5D, "script_mover_is_script_mover" },
    { 0x7A5E, "script_mover_levelnotify" },
    { 0x7A5F, "script_mover_move_to_named_goal" },
    { 0x7A60, "script_mover_move_to_target" },
    { 0x7A61, "script_mover_named_goals" },
    { 0x7A62, "script_mover_notify" },
    { 0x7A63, "script_mover_notsolid" },
    { 0x7A64, "script_mover_parameters" },
    { 0x7A65, "script_mover_parse_ent" },
    { 0x7A66, "script_mover_parse_move_parameters" },
    { 0x7A67, "script_mover_parse_range" },
    { 0x7A68, "script_mover_parse_targets" },
    { 0x7A69, "script_mover_play_animation" },
    { 0x7A6A, "script_mover_reset" },
    { 0x7A6B, "script_mover_reset_init" },
    { 0x7A6C, "script_mover_save_default_move_parameters" },
    { 0x7A6D, "script_mover_set_defaults" },
    { 0x7A6E, "script_mover_set_param" },
    { 0x7A6F, "script_mover_set_usable" },
    { 0x7A70, "script_mover_show" },
    { 0x7A71, "script_mover_solid" },
    { 0x7A72, "script_mover_start" },
    { 0x7A73, "script_mover_trigger" },
    { 0x7A74, "script_mover_trigger_off" },
    { 0x7A75, "script_mover_trigger_on" },
    { 0x7A76, "script_mover_update_paths" },
    { 0x7A77, "script_mover_use_trigger" },
    { 0x7A78, "script_mover_watch_for_reset" },
    { 0x7A79, "script_mp_style_helicopter" },
    { 0x7A7A, "script_multiplier" },
    { 0x7A7B, "script_namenumber" },
    { 0x7A7C, "script_nobark" },
    { 0x7A7D, "script_nobloodpool" },
    { 0x7A7E, "script_node_pausetime" },
    { 0x7A7F, "script_nodestate" },
    { 0x7A80, "script_nodrop" },
    { 0x7A81, "script_noflip" },
    { 0x7A82, "script_nofriendlywave" },
    { 0x7A83, "script_nohealth" },
    { 0x7A84, "script_nomg" },
    { 0x7A85, "script_nostairs" },
    { 0x7A86, "script_nosurprise" },
    { 0x7A87, "script_noteworthy2" },
    { 0x7A88, "script_notify" },
    { 0x7A89, "script_noturnanim" },
    { 0x7A8A, "script_notworthy" },
    { 0x7A8B, "script_nowall" },
    { 0x7A8C, "script_objective" },
    { 0x7A8D, "script_objective_active" },
    { 0x7A8E, "script_objective_inactive" },
    { 0x7A8F, "script_objectname" },
    { 0x7A90, "script_offradius" },
    { 0x7A91, "script_offtime" },
    { 0x7A92, "script_old_forcecolor" },
    { 0x7A93, "script_oneway" },
    { 0x7A94, "script_onlyidle" },
    { 0x7A95, "script_origin_other" },
    { 0x7A96, "script_origin_roof" },
    { 0x7A97, "script_origin_target_array" },
    { 0x7A98, "script_pacifist" },
    { 0x7A99, "script_painter_maxdist" },
    { 0x7A9A, "script_painter_treeorient" },
    { 0x7A9B, "script_paintergroup" },
    { 0x7A9C, "script_parameters" },
    { 0x7A9D, "script_params" },
    { 0x7A9E, "script_pathtype" },
    { 0x7A9F, "script_patroller" },
    { 0x7AA0, "script_percent" },
    { 0x7AA1, "script_personality" },
    { 0x7AA2, "script_pet" },
    { 0x7AA3, "script_physics" },
    { 0x7AA4, "script_physicsjolt" },
    { 0x7AA5, "script_pilottalk" },
    { 0x7AA6, "script_plane" },
    { 0x7AA7, "script_playerconeradius" },
    { 0x7AA8, "script_playerseek" },
    { 0x7AA9, "script_prefab_exploder" },
    { 0x7AAA, "script_presound" },
    { 0x7AAB, "script_print_fx" },
    { 0x7AAC, "script_probe_heli_closed" },
    { 0x7AAD, "script_probe_heli_default" },
    { 0x7AAE, "script_probe_heli_open" },
    { 0x7AAF, "script_probe_heli_reset" },
    { 0x7AB0, "script_probe_pitbull_default" },
    { 0x7AB1, "script_probe_pitbull_tunnel_exterior" },
    { 0x7AB2, "script_probe_pitbull_tunnel_exterior_no_trigger" },
    { 0x7AB3, "script_probe_pitbull_tunnel_interior" },
    { 0x7AB4, "script_qualityspotshadow" },
    { 0x7AB5, "script_radius" },
    { 0x7AB6, "script_random_killspawner" },
    { 0x7AB7, "script_randomspawn" },
    { 0x7AB8, "script_readystand" },
    { 0x7AB9, "script_repeat" },
    { 0x7ABA, "script_requires_player" },
    { 0x7ABB, "script_reuse" },
    { 0x7ABC, "script_reuse_max" },
    { 0x7ABD, "script_reuse_min" },
    { 0x7ABE, "script_rumble" },
    { 0x7ABF, "script_savedata" },
    { 0x7AC0, "script_savetrigger_timer" },
    { 0x7AC1, "script_screen_fxid" },
    { 0x7AC2, "script_seekgoal" },
    { 0x7AC3, "script_self_remove" },
    { 0x7AC4, "script_selfremove" },
    { 0x7AC5, "script_shotcount" },
    { 0x7AC6, "script_side" },
    { 0x7AC7, "script_sightrange" },
    { 0x7AC8, "script_skilloverride" },
    { 0x7AC9, "script_slowmo_breach" },
    { 0x7ACA, "script_slowmo_breach_doortype" },
    { 0x7ACB, "script_slowmo_breach_spawners" },
    { 0x7ACC, "script_smokegroup" },
    { 0x7ACD, "script_sound" },
    { 0x7ACE, "script_soundalias" },
    { 0x7ACF, "script_spawn_here" },
    { 0x7AD0, "script_spawn_once" },
    { 0x7AD1, "script_spawn_pool" },
    { 0x7AD2, "script_spawngroup" },
    { 0x7AD3, "script_spawnsubgroup" },
    { 0x7AD4, "script_specialops" },
    { 0x7AD5, "script_specialopsname" },
    { 0x7AD6, "script_speed" },
    { 0x7AD7, "script_spotlight" },
    { 0x7AD8, "script_spotlimit" },
    { 0x7AD9, "script_squad" },
    { 0x7ADA, "script_squadname" },
    { 0x7ADB, "script_stack" },
    { 0x7ADC, "script_stance" },
    { 0x7ADD, "script_start" },
    { 0x7ADE, "script_startinghealth" },
    { 0x7ADF, "script_startingposition" },
    { 0x7AE0, "script_startname" },
    { 0x7AE1, "script_startrunning" },
    { 0x7AE2, "script_state_compare" },
    { 0x7AE3, "script_stay_drone" },
    { 0x7AE4, "script_stealth" },
    { 0x7AE5, "script_stealth_dontseek" },
    { 0x7AE6, "script_stealth_function" },
    { 0x7AE7, "script_stealthgroup" },
    { 0x7AE8, "script_stopnode" },
    { 0x7AE9, "script_stoptoshoot" },
    { 0x7AEA, "script_sunenable" },
    { 0x7AEB, "script_sunsamplesizenear" },
    { 0x7AEC, "script_sunshadowscale" },
    { 0x7AED, "script_suppression" },
    { 0x7AEE, "script_surfacetype" },
    { 0x7AEF, "script_tankgroup" },
    { 0x7AF0, "script_targetoffset_z" },
    { 0x7AF1, "script_targettype" },
    { 0x7AF2, "script_team" },
    { 0x7AF3, "script_tess_distance" },
    { 0x7AF4, "script_tess_falloff" },
    { 0x7AF5, "script_threatbias" },
    { 0x7AF6, "script_threatbiasgroup" },
    { 0x7AF7, "script_threshold" },
    { 0x7AF8, "script_timeout" },
    { 0x7AF9, "script_timer" },
    { 0x7AFA, "script_to_state" },
    { 0x7AFB, "script_trace" },
    { 0x7AFC, "script_transient" },
    { 0x7AFD, "script_transmission" },
    { 0x7AFE, "script_trigger_group" },
    { 0x7AFF, "script_triggered_playerseek" },
    { 0x7B00, "script_triggername" },
    { 0x7B01, "script_turningdir" },
    { 0x7B02, "script_turret" },
    { 0x7B03, "script_turret_ambush" },
    { 0x7B04, "script_turret_reuse_max" },
    { 0x7B05, "script_turret_reuse_min" },
    { 0x7B06, "script_turret_share" },
    { 0x7B07, "script_turretmg" },
    { 0x7B08, "script_type" },
    { 0x7B09, "script_unload" },
    { 0x7B0A, "script_unloaddelay" },
    { 0x7B0B, "script_unloadmgguy" },
    { 0x7B0C, "script_unloadtype" },
    { 0x7B0D, "script_usemg42" },
    { 0x7B0E, "script_usenormals" },
    { 0x7B0F, "script_vehicle_lights_off" },
    { 0x7B10, "script_vehicle_lights_on" },
    { 0x7B11, "script_vehicle_move_to_node" },
    { 0x7B12, "script_vehicle_seflremove" },
    { 0x7B13, "script_vehicle_selfremove" },
    { 0x7B14, "script_vehicleaianim" },
    { 0x7B15, "script_vehiclecargo" },
    { 0x7B16, "script_vehicledetour" },
    { 0x7B17, "script_vehicledetourgroup" },
    { 0x7B18, "script_vehicledetourtype" },
    { 0x7B19, "script_vehiclegroup" },
    { 0x7B1A, "script_vehiclegroupdelete" },
    { 0x7B1B, "script_vehiclenodegroup" },
    { 0x7B1C, "script_vehicleride" },
    { 0x7B1D, "script_vehiclespawngroup" },
    { 0x7B1E, "script_vehiclestartmove" },
    { 0x7B1F, "script_vehicletriggergroup" },
    { 0x7B20, "script_vehiclewalk" },
    { 0x7B21, "script_visionset_end" },
    { 0x7B22, "script_visionset_start" },
    { 0x7B23, "script_wait" },
    { 0x7B24, "script_wait_add" },
    { 0x7B25, "script_wait_max" },
    { 0x7B26, "script_wait_min" },
    { 0x7B27, "script_wheeldirection" },
    { 0x7B28, "script_wingman" },
    { 0x7B29, "script_wtf" },
    { 0x7B2A, "script_yawspeed" },
    { 0x7B2B, "scriptabilities" },
    { 0x7B2C, "scriptable_pillars_light_retarget" },
    { 0x7B2D, "scriptable_primary_light_centerofinterest" },
    { 0x7B2E, "scriptable_primary_light_override" },
    { 0x7B2F, "scriptable_primary_light_setstate" },
    { 0x7B30, "scriptable_primary_light_setstate_color" },
    { 0x7B31, "scriptable_primary_light_setstate_cone" },
    { 0x7B32, "scriptable_primary_light_setstate_dir" },
    { 0x7B33, "scriptable_primary_light_setstate_intensity" },
    { 0x7B34, "scriptable_primary_light_setstate_pos" },
    { 0x7B35, "scriptable_primary_light_setstate_radius" },
    { 0x7B36, "scriptable_primary_light_think" },
    { 0x7B37, "scriptdetour_persist" },
    { 0x7B38, "scripted_dialogue" },
    { 0x7B39, "scripted_elems" },
    { 0x7B3A, "scripted_fx_on_struct" },
    { 0x7B3B, "scripted_line_delay" },
    { 0x7B3C, "scripted_node" },
    { 0x7B3D, "scripted_path_style" },
    { 0x7B3E, "scripted_screen_flicker_loop" },
    { 0x7B3F, "scripted_spawn" },
    { 0x7B40, "scripted_spin_fan_blades" },
    { 0x7B41, "scriptedarrivalententity" },
    { 0x7B42, "scripteddialoguebuffertime" },
    { 0x7B43, "scripteddialoguestarttime" },
    { 0x7B44, "scriptflag" },
    { 0x7B45, "scriptmodel" },
    { 0x7B46, "scriptmodelplayanimwithnotify" },
    { 0x7B47, "scriptmodelplayanimwithnotify_notetracks" },
    { 0x7B48, "scriptperks" },
    { 0x7B49, "scriptstarttime" },
    { 0x7B4A, "scripttargets" },
    { 0x7B4B, "scrub_guy" },
    { 0x7B4C, "scuba_assisted" },
    { 0x7B4D, "scuba_fx_cleanup" },
    { 0x7B4E, "scuba_org" },
    { 0x7B4F, "scubamask_distortion" },
    { 0x7B50, "sd_1st_int_window_goal" },
    { 0x7B51, "sd_anim_generic_reach_and_play" },
    { 0x7B52, "sd_anim_reach_and_play_loop" },
    { 0x7B53, "sd_autosave_check" },
    { 0x7B54, "sd_bomb_just_planted" },
    { 0x7B55, "sd_bombs" },
    { 0x7B56, "sd_bombzones" },
    { 0x7B57, "sd_drone_kamikaze" },
    { 0x7B58, "sd_drone_patrol_think" },
    { 0x7B59, "sd_endgame" },
    { 0x7B5A, "sd_flee_drone_swarm" },
    { 0x7B5B, "sd_force_patrol1_anim_set" },
    { 0x7B5C, "sd_glass_projection_setup" },
    { 0x7B5D, "sd_glass_projection_think" },
    { 0x7B5E, "sd_handle_glass_smash" },
    { 0x7B5F, "sd_intersection_chopper" },
    { 0x7B60, "sd_intersection2_smoke_and_spawn" },
    { 0x7B61, "sd_intersection3_smoke_laser_spawn" },
    { 0x7B62, "sd_loadout" },
    { 0x7B63, "sd_onbombtimerend" },
    { 0x7B64, "sd_panel_impact" },
    { 0x7B65, "sd_path_check1" },
    { 0x7B66, "sd_patrol1_command" },
    { 0x7B67, "sd_patrol1_player_close_check" },
    { 0x7B68, "sd_press_use" },
    { 0x7B69, "sd_shop_logo_control" },
    { 0x7B6A, "sd_smoke_laser_ambush" },
    { 0x7B6B, "sd_snake_crash_into_player" },
    { 0x7B6C, "sd_spawn_and_retreat_goals" },
    { 0x7B6D, "sd_spawn_crossfire_2nd_floor_enemies" },
    { 0x7B6E, "sd_spawn_turret_truck" },
    { 0x7B6F, "sd_spawn_zipline_group1" },
    { 0x7B70, "sd_spawn_zipline_group2" },
    { 0x7B71, "sd_street_combat" },
    { 0x7B72, "sd_switch_axis_colors" },
    { 0x7B73, "sd_triggers" },
    { 0x7B74, "sd_upstairs_enemies_spawn" },
    { 0x7B75, "sd_vo_inside_restaurant" },
    { 0x7B76, "sd_zipline_enemy_think" },
    { 0x7B77, "sdbomb" },
    { 0x7B78, "sdbombmodel" },
    { 0x7B79, "sdrone_weapon_fire_sound_next" },
    { 0x7B7A, "sdrone_weapon_fire_sounds" },
    { 0x7B7B, "se_balcony_finale" },
    { 0x7B7C, "se_balcony_finale_balcony" },
    { 0x7B7D, "se_balcony_finale_irons" },
    { 0x7B7E, "se_balcony_finale_player" },
    { 0x7B7F, "se_balcony_finale_player_speed" },
    { 0x7B80, "se_balcony_part1_up_to_tackle" },
    { 0x7B81, "se_balcony_reveal_head_sway" },
    { 0x7B82, "se_breach_guards" },
    { 0x7B83, "se_breach_patrol_guy_01" },
    { 0x7B84, "se_breach_patrol_guy_02" },
    { 0x7B85, "se_bridge_takedown" },
    { 0x7B86, "se_burke_cover_tree_wave" },
    { 0x7B87, "se_burke_dive_over_log" },
    { 0x7B88, "se_burke_forest_wall_climb" },
    { 0x7B89, "se_burke_hill_slide" },
    { 0x7B8A, "se_burke_river_cross" },
    { 0x7B8B, "se_burke_river_over_log" },
    { 0x7B8C, "se_burke_river_to_wall" },
    { 0x7B8D, "se_burke_stumble_knee" },
    { 0x7B8E, "se_burke_stumble_run" },
    { 0x7B8F, "se_burke_takedown_01" },
    { 0x7B90, "se_burke_tree_cover_01" },
    { 0x7B91, "se_burke_tree_stump" },
    { 0x7B92, "se_burke_tree_to_wall" },
    { 0x7B93, "se_canal_breach" },
    { 0x7B94, "se_check_player_too_far_from_burke" },
    { 0x7B95, "se_cormack_meet" },
    { 0x7B96, "se_cormack_meet_init" },
    { 0x7B97, "se_door_kick" },
    { 0x7B98, "se_exfil" },
    { 0x7B99, "se_exfil_fx" },
    { 0x7B9A, "se_exfil_razorback" },
    { 0x7B9B, "se_exhaust_hatch" },
    { 0x7B9C, "se_exhaust_hatch_player" },
    { 0x7B9D, "se_exhaust_land" },
    { 0x7B9E, "se_facility_breach" },
    { 0x7B9F, "se_foam_corridor" },
    { 0x7BA0, "se_foam_corridor_approach" },
    { 0x7BA1, "se_foam_corridor_bomb" },
    { 0x7BA2, "se_foam_corridor_grenade" },
    { 0x7BA3, "se_foam_corridor_guy_4" },
    { 0x7BA4, "se_foam_room" },
    { 0x7BA5, "se_foam_room_bomb" },
    { 0x7BA6, "se_foam_room_player" },
    { 0x7BA7, "se_forest_takedown_01" },
    { 0x7BA8, "se_forest_takedown_01_distance_think" },
    { 0x7BA9, "se_forest_takedown_01_fail_conditions" },
    { 0x7BAA, "se_hovertank_exit" },
    { 0x7BAB, "se_hovertank_exit_cormack_shadow" },
    { 0x7BAC, "se_hovertank_exit_cover_fire" },
    { 0x7BAD, "se_hovertank_exit_cover_fire_cleanup" },
    { 0x7BAE, "se_hovertank_mount" },
    { 0x7BAF, "se_hovertank_reveal" },
    { 0x7BB0, "se_hovertank_reveal_actor" },
    { 0x7BB1, "se_hovertank_reveal_lift_think" },
    { 0x7BB2, "se_intro" },
    { 0x7BB3, "se_intro_ambient_jets" },
    { 0x7BB4, "se_intro_ambient_warbirds" },
    { 0x7BB5, "se_intro_burke_react" },
    { 0x7BB6, "se_intro_flyin_gideon" },
    { 0x7BB7, "se_intro_missiles" },
    { 0x7BB8, "se_intro_shack" },
    { 0x7BB9, "se_irons_chase" },
    { 0x7BBA, "se_irons_elevator_doors" },
    { 0x7BBB, "se_irons_end_helo" },
    { 0x7BBC, "se_irons_react_to_gunfire" },
    { 0x7BBD, "se_irons_reveal" },
    { 0x7BBE, "se_irons_reveal_exo" },
    { 0x7BBF, "se_irons_reveal_handle_button_prompts_on_arm" },
    { 0x7BC0, "se_irons_reveal_handle_material_swap" },
    { 0x7BC1, "se_irons_reveal_head_jolt" },
    { 0x7BC2, "se_irons_reveal_head_sway" },
    { 0x7BC3, "se_irons_reveal_monitor_button_on_arm" },
    { 0x7BC4, "se_irons_reveal_pt2_gideon" },
    { 0x7BC5, "se_knox_courtyard_hangar_door_hack_open" },
    { 0x7BC6, "se_kva_basement_2" },
    { 0x7BC7, "se_kva_basement_2_idle" },
    { 0x7BC8, "se_link_player_to_rig" },
    { 0x7BC9, "se_mech_exit" },
    { 0x7BCA, "se_mech_march" },
    { 0x7BCB, "se_missile_load" },
    { 0x7BCC, "se_player_exfil_out_of_bounds_check" },
    { 0x7BCD, "se_player_hill_slide" },
    { 0x7BCE, "se_player_rig_move_to_irons" },
    { 0x7BCF, "se_search_drone_backup" },
    { 0x7BD0, "se_search_drone_deer" },
    { 0x7BD1, "se_search_drone_spotted_player" },
    { 0x7BD2, "se_search_drone_vehicle" },
    { 0x7BD3, "se_search_drones_01" },
    { 0x7BD4, "se_server_room_entrance" },
    { 0x7BD5, "se_server_room_player_close" },
    { 0x7BD6, "se_server_room_player_kills_guy" },
    { 0x7BD7, "se_server_room_player_misses" },
    { 0x7BD8, "se_slow_player_if_too_far_ahead" },
    { 0x7BD9, "se_vehicle_mute_charge" },
    { 0x7BDA, "se_vehicle_takedown_01" },
    { 0x7BDB, "se_vehicle_takedown_dummyfunc" },
    { 0x7BDC, "se_vehicle_takedown_fail_condition_guy" },
    { 0x7BDD, "se_vehicle_takedown_fail_conditions" },
    { 0x7BDE, "se_vehicle_takedown_stealth_alert_check" },
    { 0x7BDF, "se_wall_climb_roots" },
    { 0x7BE0, "se_will_reveal" },
    { 0x7BE1, "se_will_reveal_irons" },
    { 0x7BE2, "search_drone_alert_monitor" },
    { 0x7BE3, "search_drone_alerted_dialogue" },
    { 0x7BE4, "search_drone_behavior" },
    { 0x7BE5, "search_drone_damage_detection" },
    { 0x7BE6, "search_drone_random_turns" },
    { 0x7BE7, "search_drone_spotted_player" },
    { 0x7BE8, "search_drone_warning_dialogue" },
    { 0x7BE9, "search_drones_count" },
    { 0x7BEA, "search_string" },
    { 0x7BEB, "seattag" },
    { 0x7BEC, "sec_door_breach_anim" },
    { 0x7BED, "sec_godray" },
    { 0x7BEE, "sec_room_attach_to_elevator" },
    { 0x7BEF, "sec_room_elevator_open" },
    { 0x7BF0, "sec_room_move_to_elevator" },
    { 0x7BF1, "sec_trig1" },
    { 0x7BF2, "sec_trig2" },
    { 0x7BF3, "sec_trig3" },
    { 0x7BF4, "sec_trig4" },
    { 0x7BF5, "second_floor_snipers" },
    { 0x7BF6, "second_floor_trigger_think" },
    { 0x7BF7, "second_line_of_fire" },
    { 0x7BF8, "second_nightclub_room_setup" },
    { 0x7BF9, "second_room_nightclub_setup" },
    { 0x7BFA, "secondaryattachment" },
    { 0x7BFB, "secondaryattachment3" },
    { 0x7BFC, "secondarygrenade" },
    { 0x7BFD, "secondaryname" },
    { 0x7BFE, "secondaryreinforcementhinttext" },
    { 0x7BFF, "secondarytarget" },
    { 0x7C00, "secondaryweaponent" },
    { 0x7C01, "secondguys_total" },
    { 0x7C02, "secondguysalive" },
    { 0x7C03, "secondline_alive_check" },
    { 0x7C04, "secondline_flee_check" },
    { 0x7C05, "secondowner" },
    { 0x7C06, "secsoffiringbeforereload" },
    { 0x7C07, "secsoffiringbeforereloaddefault" },
    { 0x7C08, "section_1_civilians" },
    { 0x7C09, "securehardpointevent" },
    { 0x7C0A, "securestarted" },
    { 0x7C0B, "security_building_entrance" },
    { 0x7C0C, "security_camera_dialogue" },
    { 0x7C0D, "security_center_anim_struct" },
    { 0x7C0E, "security_center_begin" },
    { 0x7C0F, "security_center_bink" },
    { 0x7C10, "security_center_bink_off" },
    { 0x7C11, "security_center_drones_turn_on" },
    { 0x7C12, "security_center_drones_turn_on_internal" },
    { 0x7C13, "security_center_drones_turn_on_setup" },
    { 0x7C14, "security_center_exit" },
    { 0x7C15, "security_center_fan_blades" },
    { 0x7C16, "security_center_fan_blades_internal" },
    { 0x7C17, "security_center_guard_exposed_vo_said" },
    { 0x7C18, "security_center_guard_left_tagged" },
    { 0x7C19, "security_center_guard_right_tagged" },
    { 0x7C1A, "security_center_guard_spawner_setup" },
    { 0x7C1B, "security_center_hatch_trigger" },
    { 0x7C1C, "security_center_lights" },
    { 0x7C1D, "security_center_main" },
    { 0x7C1E, "security_center_main_screen_bink" },
    { 0x7C1F, "security_center_player_rig_and_hatch_door_setup" },
    { 0x7C20, "security_center_rooftop_drone" },
    { 0x7C21, "security_center_rooftop_obj" },
    { 0x7C22, "security_center_script_brushmodels" },
    { 0x7C23, "security_center_server_lights" },
    { 0x7C24, "security_center_start" },
    { 0x7C25, "security_center_vo" },
    { 0x7C26, "security_check_1_dialogue" },
    { 0x7C27, "security_checkpoint_trigger_play_beep" },
    { 0x7C28, "security_checkpoint_trigger_think" },
    { 0x7C29, "security_doors_approach" },
    { 0x7C2A, "security_drone_attack" },
    { 0x7C2B, "security_drone_hit_react" },
    { 0x7C2C, "security_drone_sparks" },
    { 0x7C2D, "security_drones" },
    { 0x7C2E, "security_elevator_approach" },
    { 0x7C2F, "security_elevator_descent" },
    { 0x7C30, "security_elevator_descent_ai" },
    { 0x7C31, "security_elevator_descent_player" },
    { 0x7C32, "security_elevator_open" },
    { 0x7C33, "security_elevator_open_anim" },
    { 0x7C34, "security_elevator_prompt" },
    { 0x7C35, "security_room" },
    { 0x7C36, "security_triggers" },
    { 0x7C37, "securitycameraadsmonitor" },
    { 0x7C38, "securitycameraclearalltargets" },
    { 0x7C39, "securitycameraclearscannedtarget" },
    { 0x7C3A, "securitycameradisable" },
    { 0x7C3B, "securitycameraenable" },
    { 0x7C3C, "securitycamerafovcheck" },
    { 0x7C3D, "securitycamerahud" },
    { 0x7C3E, "securitycameramarktargets" },
    { 0x7C3F, "securitycameraminimapangles" },
    { 0x7C40, "securitycamerapotentialsignalmatch" },
    { 0x7C41, "securitycamerareturndistancetotarget" },
    { 0x7C42, "securitycamerascanhud" },
    { 0x7C43, "securitycamerascantrace" },
    { 0x7C44, "securitycameraswitching" },
    { 0x7C45, "securitycameratargetfrequency" },
    { 0x7C46, "securitycameratransitionblur" },
    { 0x7C47, "securitycameraviewlink" },
    { 0x7C48, "securitycamerazoomincontrols" },
    { 0x7C49, "securitycamerazoominstructions" },
    { 0x7C4A, "securitycamerazoommodifier" },
    { 0x7C4B, "securitycamerazoomoutcontrols" },
    { 0x7C4C, "see_enemy_dot" },
    { 0x7C4D, "see_enemy_dot_close" },
    { 0x7C4E, "see_frames" },
    { 0x7C4F, "seeing" },
    { 0x7C50, "seek_player_on_detection" },
    { 0x7C51, "seek_player_on_fail" },
    { 0x7C52, "seek_player_on_trigger" },
    { 0x7C53, "seeker_clear" },
    { 0x7C54, "seeker_dialogue" },
    { 0x7C55, "seeker_think" },
    { 0x7C56, "seeking_path" },
    { 0x7C57, "seekoutenemytime" },
    { 0x7C58, "seekplayercheck" },
    { 0x7C59, "seen_attacker" },
    { 0x7C5A, "seen_audio_ent" },
    { 0x7C5B, "segments" },
    { 0x7C5C, "select_all_exploders_of_currently_selected" },
    { 0x7C5D, "select_by_name" },
    { 0x7C5E, "select_by_name_list" },
    { 0x7C5F, "select_by_substring" },
    { 0x7C60, "select_entity" },
    { 0x7C61, "select_index_array" },
    { 0x7C62, "select_last_entity" },
    { 0x7C63, "select_target_think" },
    { 0x7C64, "selectairstrikelocation" },
    { 0x7C65, "selectbestspawnpoint" },
    { 0x7C66, "selected" },
    { 0x7C67, "selected_ent_buttons" },
    { 0x7C68, "selected_fx" },
    { 0x7C69, "selected_fx_ents" },
    { 0x7C6A, "selected_fx_option_index" },
    { 0x7C6B, "selectedclass" },
    { 0x7C6C, "selectedmove_forward" },
    { 0x7C6D, "selectedmove_right" },
    { 0x7C6E, "selectedmove_up" },
    { 0x7C6F, "selectedrotate_pitch" },
    { 0x7C70, "selectedrotate_roll" },
    { 0x7C71, "selectedrotate_yaw" },
    { 0x7C72, "selectinglocation" },
    { 0x7C73, "selectonemanarmyclass" },
    { 0x7C74, "self_delete" },
    { 0x7C75, "self_destruct_goliath" },
    { 0x7C76, "self_func" },
    { 0x7C77, "self_to_target_local_angles" },
    { 0x7C78, "self_tracking_functions" },
    { 0x7C79, "selfdeathicons" },
    { 0x7C7A, "selfdeletedelay" },
    { 0x7C7B, "selfiebooth" },
    { 0x7C7C, "selfrevivethinkloop" },
    { 0x7C7D, "semifirenumshots" },
    { 0x7C7E, "semtex_sticky_handle" },
    { 0x7C7F, "semtexstickevent" },
    { 0x7C80, "send_activate_zone_msg" },
    { 0x7C81, "send_ai_to_colorvolume" },
    { 0x7C82, "send_cormack" },
    { 0x7C83, "send_deactivate_zone_msg" },
    { 0x7C84, "send_heli_through_path" },
    { 0x7C85, "send_notify" },
    { 0x7C86, "send_swarm_to_chopper" },
    { 0x7C87, "send_will_wait" },
    { 0x7C88, "sendagentweaponnotify" },
    { 0x7C89, "sendallenemiesintriggertogoalvol" },
    { 0x7C8A, "sendupdateddmscores" },
    { 0x7C8B, "sendupdatedteamscores" },
    { 0x7C8C, "sensoroutlined" },
    { 0x7C8D, "sent_chopper" },
    { 0x7C8E, "sent_guy_1_decloak" },
    { 0x7C8F, "sent_guy_1_footsteps" },
    { 0x7C90, "sent_guy_1_footsteps_part2" },
    { 0x7C91, "sent_guy_1_footsteps_part3" },
    { 0x7C92, "sent_guy_2_decloak" },
    { 0x7C93, "sent_guy_2_footsteps" },
    { 0x7C94, "sent_guy_3_decloak" },
    { 0x7C95, "sent_guy_3_footsteps" },
    { 0x7C96, "sent_guy1_cloak" },
    { 0x7C97, "sent_guy1_mask_down" },
    { 0x7C98, "sent_guy1_mask_up" },
    { 0x7C99, "sentinel_guy1" },
    { 0x7C9A, "sentinel_kva_fov_function" },
    { 0x7C9B, "sentinel_op1" },
    { 0x7C9C, "sentinel_op2" },
    { 0x7C9D, "sentinel_op4" },
    { 0x7C9E, "sentinel_reveal_dialogue_continue" },
    { 0x7C9F, "sentinel_reveal_final_vo" },
    { 0x7CA0, "sentinel_reveal_guy1_decloak" },
    { 0x7CA1, "sentinel_reveal_guy2_decloak" },
    { 0x7CA2, "sentinel_reveal_guy3_decloak" },
    { 0x7CA3, "sentinel_reveal_lighting" },
    { 0x7CA4, "sentinel_reveal_lighting_origins" },
    { 0x7CA5, "sentinel_reveal_moment_dialogue" },
    { 0x7CA6, "sentinel_reveal_slowmo_start" },
    { 0x7CA7, "sentinel_reveal_slowmo_stop" },
    { 0x7CA8, "sentinel_team_vo" },
    { 0x7CA9, "sentintel_reveal_dialogue" },
    { 0x7CAA, "sentintel_reveal_door_dialogue" },
    { 0x7CAB, "sentry_attacktargets" },
    { 0x7CAC, "sentry_beepsounds" },
    { 0x7CAD, "sentry_burstfirestart" },
    { 0x7CAE, "sentry_burstfirestop" },
    { 0x7CAF, "sentry_directhacked" },
    { 0x7CB0, "sentry_fire" },
    { 0x7CB1, "sentry_handledamage" },
    { 0x7CB2, "sentry_handledeath" },
    { 0x7CB3, "sentry_handleownerdisconnect" },
    { 0x7CB4, "sentry_handleuse" },
    { 0x7CB5, "sentry_heatmonitor" },
    { 0x7CB6, "sentry_initsentry" },
    { 0x7CB7, "sentry_lasermark" },
    { 0x7CB8, "sentry_makenotsolid" },
    { 0x7CB9, "sentry_makesolid" },
    { 0x7CBA, "sentry_oncarrierchangedteam" },
    { 0x7CBB, "sentry_oncarrierdeath" },
    { 0x7CBC, "sentry_oncarrierdisconnect" },
    { 0x7CBD, "sentry_ongameended" },
    { 0x7CBE, "sentry_place_delay" },
    { 0x7CBF, "sentry_setactive" },
    { 0x7CC0, "sentry_setcancelled" },
    { 0x7CC1, "sentry_setcarried" },
    { 0x7CC2, "sentry_setinactive" },
    { 0x7CC3, "sentry_setowner" },
    { 0x7CC4, "sentry_setplaced" },
    { 0x7CC5, "sentry_spindown" },
    { 0x7CC6, "sentry_spinup" },
    { 0x7CC7, "sentry_stopattackingtargets" },
    { 0x7CC8, "sentry_targetlocksound" },
    { 0x7CC9, "sentry_timeout" },
    { 0x7CCA, "sentry_watchdisabled" },
    { 0x7CCB, "sentrygun" },
    { 0x7CCC, "sentrymodeoff" },
    { 0x7CCD, "sentrymodeon" },
    { 0x7CCE, "sentrysettings" },
    { 0x7CCF, "sentrytype" },
    { 0x7CD0, "seo_ambient_ground_explosions" },
    { 0x7CD1, "seo_atlas_meet_cormack" },
    { 0x7CD2, "seo_atlas_meet_gideon" },
    { 0x7CD3, "seo_atlas_meet_will" },
    { 0x7CD4, "seo_big_car_explo" },
    { 0x7CD5, "seo_binocs_equip" },
    { 0x7CD6, "seo_canal_dynamic_bombs" },
    { 0x7CD7, "seo_canal_heli_attacked" },
    { 0x7CD8, "seo_canal_razorback" },
    { 0x7CD9, "seo_dirt_explosions" },
    { 0x7CDA, "seo_drone_missile" },
    { 0x7CDB, "seo_drone_missile_impact" },
    { 0x7CDC, "seo_droppod1_cormack" },
    { 0x7CDD, "seo_droppod1_will" },
    { 0x7CDE, "seo_droppod2_alt_will" },
    { 0x7CDF, "seo_droppod2_cormack" },
    { 0x7CE0, "seo_droppod3_exit" },
    { 0x7CE1, "seo_droppod3_intro_cormack" },
    { 0x7CE2, "seo_finale_cormack_assist_player" },
    { 0x7CE3, "seo_finale_cormack_crouch" },
    { 0x7CE4, "seo_finale_cormack_enter_scene" },
    { 0x7CE5, "seo_finale_cormack_grab_metal" },
    { 0x7CE6, "seo_finale_cormack_pull_player" },
    { 0x7CE7, "seo_finale_cormack_rescue" },
    { 0x7CE8, "seo_finale_cormack_walk_to_player" },
    { 0x7CE9, "seo_finale_player_arm_slice" },
    { 0x7CEA, "seo_finale_player_bounces" },
    { 0x7CEB, "seo_finale_player_dragged_away" },
    { 0x7CEC, "seo_finale_player_falls" },
    { 0x7CED, "seo_finale_player_grab_hatch" },
    { 0x7CEE, "seo_finale_player_hatch_react" },
    { 0x7CEF, "seo_finale_player_jump_onto_platform" },
    { 0x7CF0, "seo_finale_player_lands" },
    { 0x7CF1, "seo_finale_player_leg_down" },
    { 0x7CF2, "seo_finale_player_leg_up" },
    { 0x7CF3, "seo_finale_player_retrieve_bomb" },
    { 0x7CF4, "seo_finale_player_two_handed_hatch_pull" },
    { 0x7CF5, "seo_finale_rumble_heavy" },
    { 0x7CF6, "seo_finale_rumble_light" },
    { 0x7CF7, "seo_finale_start" },
    { 0x7CF8, "seo_finale_will_bomb_accept" },
    { 0x7CF9, "seo_finale_will_bomb_arm" },
    { 0x7CFA, "seo_finale_will_bomb_hatch_trap" },
    { 0x7CFB, "seo_finale_will_bomb_turn" },
    { 0x7CFC, "seo_finale_will_first_attempt_to_free" },
    { 0x7CFD, "seo_finale_will_grab_hatch" },
    { 0x7CFE, "seo_finale_will_grabs_player" },
    { 0x7CFF, "seo_finale_will_jump_onto_platform" },
    { 0x7D00, "seo_finale_will_open_hatch" },
    { 0x7D01, "seo_finale_will_place_bomb" },
    { 0x7D02, "seo_finale_will_pushes_player" },
    { 0x7D03, "seo_finale_will_second_attempt" },
    { 0x7D04, "seo_finale_will_start" },
    { 0x7D05, "seo_finale_will_struggle" },
    { 0x7D06, "seo_finale_wp_belly_explo" },
    { 0x7D07, "seo_finale_wp_big_explo" },
    { 0x7D08, "seo_finale_wp_hatch_close" },
    { 0x7D09, "seo_finale_wp_init_explo" },
    { 0x7D0A, "seo_finale_wp_landing_gears_up" },
    { 0x7D0B, "seo_finale_wp_lift_off" },
    { 0x7D0C, "seo_finale_wp_prepare_to_lift_off" },
    { 0x7D0D, "seo_finale_wp_take_off" },
    { 0x7D0E, "seo_finale_wp_wing_explo" },
    { 0x7D0F, "seo_fireball_explosions" },
    { 0x7D10, "seo_fob_fake_jet_flyby" },
    { 0x7D11, "seo_fob_initial_razorback" },
    { 0x7D12, "seo_fob_pod_descend" },
    { 0x7D13, "seo_fob_pod_door_land" },
    { 0x7D14, "seo_fob_pod_door_open" },
    { 0x7D15, "seo_fob_pod_flaps" },
    { 0x7D16, "seo_fob_pod_land" },
    { 0x7D17, "seo_fob_razorback_01" },
    { 0x7D18, "seo_fob_razorback_02" },
    { 0x7D19, "seo_fob_tank_01" },
    { 0x7D1A, "seo_fob_tank_02" },
    { 0x7D1B, "seo_fob_tank_03" },
    { 0x7D1C, "seo_fob_tank_procedural" },
    { 0x7D1D, "seo_get_vip_away_cg" },
    { 0x7D1E, "seo_gideon_meet_atlast_start" },
    { 0x7D1F, "seo_hotel_ent_wp_takeoff" },
    { 0x7D20, "seo_intro_patrol_drones" },
    { 0x7D21, "seo_mall_sizeup_crmk_powerup" },
    { 0x7D22, "seo_mall_sizeup_crmk_runjump" },
    { 0x7D23, "seo_mall_sizeup_crmk_turn" },
    { 0x7D24, "seo_mall_sizeup_crmk_walk" },
    { 0x7D25, "seo_mall_sizeup_will_powerup" },
    { 0x7D26, "seo_mall_sizeup_will_runjump" },
    { 0x7D27, "seo_mall_sizeup_will_walk" },
    { 0x7D28, "seo_mall_sizeup_will_wpn_sling" },
    { 0x7D29, "seo_meet_atlas_civ_scriptmodel_cg" },
    { 0x7D2A, "seo_meet_atlas_slowmo_end" },
    { 0x7D2B, "seo_meet_atlas_slowmo_start" },
    { 0x7D2C, "seo_outro_falling_debris" },
    { 0x7D2D, "seo_outro_pause_env_fx" },
    { 0x7D2E, "seo_outro_rolling_smk" },
    { 0x7D2F, "seo_outro_thick_smk_vm" },
    { 0x7D30, "seo_outro_tire_fire" },
    { 0x7D31, "seo_outro_wp_belly_explo_1" },
    { 0x7D32, "seo_outro_wp_belly_explo_2" },
    { 0x7D33, "seo_outro_wp_belly_explo_2_end" },
    { 0x7D34, "seo_outro_wp_env_fx_start" },
    { 0x7D35, "seo_outro_wp_explo_sequence_start" },
    { 0x7D36, "seo_outro_wp_init_explo" },
    { 0x7D37, "seo_outro_wp_tail_explo" },
    { 0x7D38, "seo_outro_wp_tail_explo_shockwave" },
    { 0x7D39, "seo_outro_wp_tail_explo_shockwave_ground" },
    { 0x7D3A, "seo_outro_wp_take_off_start" },
    { 0x7D3B, "seo_outro_wp_wing_fall_off" },
    { 0x7D3C, "seo_outro_wp_wp_powerup" },
    { 0x7D3D, "seo_per_arts_jump_explo_3" },
    { 0x7D3E, "seo_pod_break_loose_and_fall" },
    { 0x7D3F, "seo_pod_cormack_exit" },
    { 0x7D40, "seo_pod_cormack_land" },
    { 0x7D41, "seo_pod_cormack_pivot" },
    { 0x7D42, "seo_pod_cormack_reach_hatch" },
    { 0x7D43, "seo_pod_cormack_walk_2" },
    { 0x7D44, "seo_pod_enter_cormack_fs" },
    { 0x7D45, "seo_pod_enter_cormack_lt_pull" },
    { 0x7D46, "seo_pod_enter_cormack_lt_reach" },
    { 0x7D47, "seo_pod_enter_cormack_rt_pull" },
    { 0x7D48, "seo_pod_enter_cormack_rt_reach" },
    { 0x7D49, "seo_pod_enter_jack_fs" },
    { 0x7D4A, "seo_pod_enter_jack_lt_pull" },
    { 0x7D4B, "seo_pod_enter_jack_lt_reach" },
    { 0x7D4C, "seo_pod_enter_jack_rt_pull" },
    { 0x7D4D, "seo_pod_enter_jack_rt_reach" },
    { 0x7D4E, "seo_pod_enter_player_fs" },
    { 0x7D4F, "seo_pod_enter_player_lt_hand" },
    { 0x7D50, "seo_pod_enter_player_lt_pull" },
    { 0x7D51, "seo_pod_enter_player_lt_reach" },
    { 0x7D52, "seo_pod_enter_player_rt_hand" },
    { 0x7D53, "seo_pod_enter_player_rt_pull" },
    { 0x7D54, "seo_pod_enter_player_rt_reach" },
    { 0x7D55, "seo_pod_enter_start" },
    { 0x7D56, "seo_pod_enter_will_fs" },
    { 0x7D57, "seo_pod_enter_will_lt_pull" },
    { 0x7D58, "seo_pod_enter_will_lt_reach" },
    { 0x7D59, "seo_pod_enter_will_rt_pull" },
    { 0x7D5A, "seo_pod_enter_will_rt_reach" },
    { 0x7D5B, "seo_pod_ext_player_land" },
    { 0x7D5C, "seo_pod_ext_player_turn" },
    { 0x7D5D, "seo_pod_int_player_exit" },
    { 0x7D5E, "seo_pod_int_player_kick_attempt" },
    { 0x7D5F, "seo_pod_int_player_kick_open_hatch" },
    { 0x7D60, "seo_pod_int_player_lean_in_door" },
    { 0x7D61, "seo_pod_int_player_move_to_hatch" },
    { 0x7D62, "seo_pod_int_player_move_to_hatch_left" },
    { 0x7D63, "seo_pod_int_player_move_to_hatch_right" },
    { 0x7D64, "seo_pod_int_player_reach_hatch" },
    { 0x7D65, "seo_pod_int_player_unbuckle" },
    { 0x7D66, "seo_pod_int_player_unbuckle_left" },
    { 0x7D67, "seo_pod_int_player_unbuckle_right" },
    { 0x7D68, "seo_pod_launch_cam_shake" },
    { 0x7D69, "seo_pod_new_guy_exit" },
    { 0x7D6A, "seo_pod_new_guy_gets_up" },
    { 0x7D6B, "seo_pod_new_guy_land" },
    { 0x7D6C, "seo_pod_overhead_screen_start" },
    { 0x7D6D, "seo_pod_phase3_door_pop" },
    { 0x7D6E, "seo_pod_phase3_screen_boot" },
    { 0x7D6F, "seo_pod_phase3_screen_down" },
    { 0x7D70, "seo_pod_phase3_screen_up" },
    { 0x7D71, "seo_pod_phase3_seat_arm_down" },
    { 0x7D72, "seo_pod_phase3_seat_arm_up" },
    { 0x7D73, "seo_pod_phase3_turn_lever" },
    { 0x7D74, "seo_pod_phase3_vm_seat_arm_up" },
    { 0x7D75, "seo_pod_will_land" },
    { 0x7D76, "seo_pod_will_walk_1" },
    { 0x7D77, "seo_pod_will_walk_2" },
    { 0x7D78, "seo_single_drones_flyby" },
    { 0x7D79, "seo_sinkhole_wp_flyby" },
    { 0x7D7A, "seo_smoke_grenade_ambush" },
    { 0x7D7B, "seo_start_drone_submix" },
    { 0x7D7C, "seo_stop_intro_patrol_drones" },
    { 0x7D7D, "seo_stop_single_drones_flyby" },
    { 0x7D7E, "seo_swarm_die" },
    { 0x7D7F, "seo_swarm_emp_wave" },
    { 0x7D80, "seo_truck_explo" },
    { 0x7D81, "seo_video_log_start" },
    { 0x7D82, "seo_vista_amb_explos" },
    { 0x7D83, "seo_vista_bombing_run" },
    { 0x7D84, "seo_will_car_door_explo" },
    { 0x7D85, "seo_will_death_hatch_open_wait_cycle" },
    { 0x7D86, "seo_will_death_plant_charge_part1" },
    { 0x7D87, "seo_will_death_plant_charge_part2" },
    { 0x7D88, "seo_zipline_harpoon_fire" },
    { 0x7D89, "seo_zipline_harpoon_impact" },
    { 0x7D8A, "seo_zipline_rappel_begin" },
    { 0x7D8B, "seo_zipline_rappel_land" },
    { 0x7D8C, "seo_zipline_retract_rope" },
    { 0x7D8D, "seoul_building_jump_sequence" },
    { 0x7D8E, "seoul_cg_precache_models" },
    { 0x7D8F, "seoul_color_think" },
    { 0x7D90, "seoul_cover_art" },
    { 0x7D91, "seoul_drone_swarm_intro" },
    { 0x7D92, "seoul_encounter_01" },
    { 0x7D93, "seoul_finale_cinematic_lighting" },
    { 0x7D94, "seoul_fob" },
    { 0x7D95, "seoul_foley_override_handler" },
    { 0x7D96, "seoul_hotel_entrance" },
    { 0x7D97, "seoul_land_assist" },
    { 0x7D98, "seoul_locations" },
    { 0x7D99, "seoul_missile_evade" },
    { 0x7D9A, "seoul_start" },
    { 0x7D9B, "seoul_start_from_pod" },
    { 0x7D9C, "seoul_truck_push" },
    { 0x7D9D, "seoul_zipline_scripted" },
    { 0x7D9E, "seoul_zipline_scripted_custom" },
    { 0x7D9F, "separation_factor" },
    { 0x7DA0, "serial_playback_lock" },
    { 0x7DA1, "server_culled_sounds" },
    { 0x7DA2, "server_lights" },
    { 0x7DA3, "server_lights_setup" },
    { 0x7DA4, "server_room_approach_dialogue" },
    { 0x7DA5, "server_room_dialogue" },
    { 0x7DA6, "server_room_fire_knox_gun" },
    { 0x7DA7, "server_room_guy_killed_by_knox" },
    { 0x7DA8, "server_room_lasers" },
    { 0x7DA9, "server_room_logic" },
    { 0x7DAA, "server_room_nag_dialogue" },
    { 0x7DAB, "server_room_promo_logic" },
    { 0x7DAC, "server_room_se_end" },
    { 0x7DAD, "server_unit_01" },
    { 0x7DAE, "server_unit_02" },
    { 0x7DAF, "sessioncostume" },
    { 0x7DB0, "set" },
    { 0x7DB1, "set_accuracy" },
    { 0x7DB2, "set_accuracy_based_on_situation" },
    { 0x7DB3, "set_agent_health" },
    { 0x7DB4, "set_agent_team" },
    { 0x7DB5, "set_agent_values" },
    { 0x7DB6, "set_ai_anims" },
    { 0x7DB7, "set_ai_bcvoice" },
    { 0x7DB8, "set_ai_number" },
    { 0x7DB9, "set_aim_and_turn_limits" },
    { 0x7DBA, "set_all_exceptions" },
    { 0x7DBB, "set_allowdeath" },
    { 0x7DBC, "set_ambient" },
    { 0x7DBD, "set_ambush_sidestep_anims" },
    { 0x7DBE, "set_anglemod_move_vector" },
    { 0x7DBF, "set_anim_array" },
    { 0x7DC0, "set_anim_array_aiming" },
    { 0x7DC1, "set_anim_playback_rate" },
    { 0x7DC2, "set_animarray_add_smg_turn_aims_stand" },
    { 0x7DC3, "set_animarray_add_turn_aims_crouch" },
    { 0x7DC4, "set_animarray_add_turn_aims_stand" },
    { 0x7DC5, "set_animarray_burst_and_semi_fire_crouch" },
    { 0x7DC6, "set_animarray_burst_and_semi_fire_stand" },
    { 0x7DC7, "set_animarray_crouch_aim" },
    { 0x7DC8, "set_animarray_crouching" },
    { 0x7DC9, "set_animarray_crouching_left" },
    { 0x7DCA, "set_animarray_crouching_right" },
    { 0x7DCB, "set_animarray_crouching_turns" },
    { 0x7DCC, "set_animarray_custom_burst_and_semi_fire_crouch" },
    { 0x7DCD, "set_animarray_custom_burst_and_semi_fire_stand" },
    { 0x7DCE, "set_animarray_mech_burst_and_semi_fire_stand" },
    { 0x7DCF, "set_animarray_mech_burst_and_semi_fire_walk" },
    { 0x7DD0, "set_animarray_mech_standing_turns" },
    { 0x7DD1, "set_animarray_prone" },
    { 0x7DD2, "set_animarray_smg_standing_turns" },
    { 0x7DD3, "set_animarray_stance_change" },
    { 0x7DD4, "set_animarray_stance_change_smg" },
    { 0x7DD5, "set_animarray_standing" },
    { 0x7DD6, "set_animarray_standing_left" },
    { 0x7DD7, "set_animarray_standing_right" },
    { 0x7DD8, "set_animarray_standing_turns" },
    { 0x7DD9, "set_animarray_standing_turns_pistol" },
    { 0x7DDA, "set_animname" },
    { 0x7DDB, "set_archetype" },
    { 0x7DDC, "set_array" },
    { 0x7DDD, "set_attached_models" },
    { 0x7DDE, "set_avatar_dof" },
    { 0x7DDF, "set_baghdad_standard_dof" },
    { 0x7DE0, "set_baseaccuracy" },
    { 0x7DE1, "set_basic_animated_model" },
    { 0x7DE2, "set_battlechatter" },
    { 0x7DE3, "set_battlechatter_variable" },
    { 0x7DE4, "set_blast_walk_anims" },
    { 0x7DE5, "set_blur" },
    { 0x7DE6, "set_boost_lighting" },
    { 0x7DE7, "set_brakes" },
    { 0x7DE8, "set_breaching_variable" },
    { 0x7DE9, "set_bridge_lighting" },
    { 0x7DEA, "set_cam_shake" },
    { 0x7DEB, "set_cam_shake_drop" },
    { 0x7DEC, "set_canyon_dof" },
    { 0x7DED, "set_cargo_ship_drone_view_lighting" },
    { 0x7DEE, "set_cloak_material_for_npc_weapon" },
    { 0x7DEF, "set_cloak_material_for_vm_weapon" },
    { 0x7DF0, "set_cloak_on_model" },
    { 0x7DF1, "set_cloak_parameter" },
    { 0x7DF2, "set_color_goal_node" },
    { 0x7DF3, "set_combat_stand_animset" },
    { 0x7DF4, "set_completed_flags" },
    { 0x7DF5, "set_completed_objective_flags" },
    { 0x7DF6, "set_console_status" },
    { 0x7DF7, "set_contested_zone" },
    { 0x7DF8, "set_contested_zone_wait" },
    { 0x7DF9, "set_corner_anim_array" },
    { 0x7DFA, "set_corpse_detection_ranges_for_cloak_system" },
    { 0x7DFB, "set_count" },
    { 0x7DFC, "set_counts" },
    { 0x7DFD, "set_crouching_animarray_aiming" },
    { 0x7DFE, "set_crouching_turns" },
    { 0x7DFF, "set_custom_gameskill_func" },
    { 0x7E00, "set_custom_move_start_transition" },
    { 0x7E01, "set_custom_patrol_anim_set" },
    { 0x7E02, "set_custom_run_anim" },
    { 0x7E03, "set_damb_component_stringtable" },
    { 0x7E04, "set_damb_loops_stringtable" },
    { 0x7E05, "set_damb_stringtable" },
    { 0x7E06, "set_deadquote" },
    { 0x7E07, "set_death_icon" },
    { 0x7E08, "set_death_model" },
    { 0x7E09, "set_deathanim" },
    { 0x7E0A, "set_deathsdoor" },
    { 0x7E0B, "set_default_aim_limits" },
    { 0x7E0C, "set_default_breath_values" },
    { 0x7E0D, "set_default_hud_parameters" },
    { 0x7E0E, "set_default_pathenemy_settings" },
    { 0x7E0F, "set_default_start" },
    { 0x7E10, "set_default_swimmer_aim_limits" },
    { 0x7E11, "set_delays" },
    { 0x7E12, "set_demigod_while" },
    { 0x7E13, "set_df_objective_active" },
    { 0x7E14, "set_df_objective_active_spiderturrets" },
    { 0x7E15, "set_difficulty_from_locked_settings" },
    { 0x7E16, "set_disable_friendlyfire_value_delayed" },
    { 0x7E17, "set_display_name" },
    { 0x7E18, "set_dog_walk_anim" },
    { 0x7E19, "set_door_charge_anim_normal" },
    { 0x7E1A, "set_door_charge_anim_special" },
    { 0x7E1B, "set_early_level" },
    { 0x7E1C, "set_empty_promotion_order" },
    { 0x7E1D, "set_entflag_on_notify" },
    { 0x7E1E, "set_event_distance" },
    { 0x7E1F, "set_exception" },
    { 0x7E20, "set_exo_ability_hud_omnvar" },
    { 0x7E21, "set_exo_temperature_over_time" },
    { 0x7E22, "set_external_temperature_over_time" },
    { 0x7E23, "set_favoriteenemy" },
    { 0x7E24, "set_firing" },
    { 0x7E25, "set_firing_disabled" },
    { 0x7E26, "set_fixednode_false" },
    { 0x7E27, "set_fixednode_true" },
    { 0x7E28, "set_flag_in_trigger" },
    { 0x7E29, "set_flag_on_burke_wave_to_ambulance" },
    { 0x7E2A, "set_flag_on_dead" },
    { 0x7E2B, "set_flag_on_dead_or_dying" },
    { 0x7E2C, "set_flag_on_death" },
    { 0x7E2D, "set_flag_on_func_wait_proc" },
    { 0x7E2E, "set_flag_on_spawned" },
    { 0x7E2F, "set_flag_on_spawned_ai_proc" },
    { 0x7E30, "set_flag_on_targetname_trigger" },
    { 0x7E31, "set_flag_on_trigger" },
    { 0x7E32, "set_flag_rappel_player_input_start" },
    { 0x7E33, "set_flag_rappel_player_input_stop" },
    { 0x7E34, "set_flag_when_in_volume" },
    { 0x7E35, "set_flavorbursts" },
    { 0x7E36, "set_flavorbursts_team_state" },
    { 0x7E37, "set_fog" },
    { 0x7E38, "set_fog_progress" },
    { 0x7E39, "set_fog_to_ent_values" },
    { 0x7E3A, "set_fog_to_ent_values_dfog" },
    { 0x7E3B, "set_force_color" },
    { 0x7E3C, "set_force_color_spawner" },
    { 0x7E3D, "set_force_cover" },
    { 0x7E3E, "set_force_script_models_highway_path_player_side" },
    { 0x7E3F, "set_force_sprint" },
    { 0x7E40, "set_forced_target" },
    { 0x7E41, "set_forcedgoal" },
    { 0x7E42, "set_forcegoal" },
    { 0x7E43, "set_forward_and_up_vectors" },
    { 0x7E44, "set_friendlyfire_warnings" },
    { 0x7E45, "set_fx_hudelement" },
    { 0x7E46, "set_generic_deathanim" },
    { 0x7E47, "set_generic_idle_anim" },
    { 0x7E48, "set_generic_run_anim" },
    { 0x7E49, "set_generic_run_anim_array" },
    { 0x7E4A, "set_goal_ent" },
    { 0x7E4B, "set_goal_entity" },
    { 0x7E4C, "set_goal_from_settings" },
    { 0x7E4D, "set_goal_height_from_settings" },
    { 0x7E4E, "set_goal_node" },
    { 0x7E4F, "set_goal_node_targetname" },
    { 0x7E50, "set_goal_pos" },
    { 0x7E51, "set_goal_radius" },
    { 0x7E52, "set_goal_volume" },
    { 0x7E53, "set_goalradius" },
    { 0x7E54, "set_goalvolume" },
    { 0x7E55, "set_grenadeammo" },
    { 0x7E56, "set_grid_color_dark" },
    { 0x7E57, "set_group_advance_to_enemy_parameters" },
    { 0x7E58, "set_guy_on_fire" },
    { 0x7E59, "set_health" },
    { 0x7E5A, "set_helmet_closed" },
    { 0x7E5B, "set_helmet_open" },
    { 0x7E5C, "set_hemi_ao" },
    { 0x7E5D, "set_high_priority_target_for_bot" },
    { 0x7E5E, "set_hudoutline" },
    { 0x7E5F, "set_idle_anim" },
    { 0x7E60, "set_ignoreall" },
    { 0x7E61, "set_ignoreme" },
    { 0x7E62, "set_ignoresonicaoe" },
    { 0x7E63, "set_ignoresuppression" },
    { 0x7E64, "set_initial_rush_goal" },
    { 0x7E65, "set_intensities" },
    { 0x7E66, "set_intro_lighting" },
    { 0x7E67, "set_irons_tour_ride_reflection" },
    { 0x7E68, "set_itiot_flags" },
    { 0x7E69, "set_landing_target_fx" },
    { 0x7E6A, "set_laser_ambush_stats" },
    { 0x7E6B, "set_level_lighting_values" },
    { 0x7E6C, "set_level_player_rumble_ent_intensity" },
    { 0x7E6D, "set_level_player_rumble_ent_intensity_for_time" },
    { 0x7E6E, "set_light_set_for_player" },
    { 0x7E6F, "set_lighting_values" },
    { 0x7E70, "set_lookat_from_dest" },
    { 0x7E71, "set_lookat_point" },
    { 0x7E72, "set_main_vol_and_retreat_vol" },
    { 0x7E73, "set_manual_target" },
    { 0x7E74, "set_maxed_momentum" },
    { 0x7E75, "set_maxsightdistsqrd" },
    { 0x7E76, "set_mech_chaingun_last_state" },
    { 0x7E77, "set_mech_chaingun_state" },
    { 0x7E78, "set_mech_rocket_last_state" },
    { 0x7E79, "set_mech_rocket_state" },
    { 0x7E7A, "set_mech_state" },
    { 0x7E7B, "set_mech_swarm_last_state" },
    { 0x7E7C, "set_mech_swarm_state" },
    { 0x7E7D, "set_mech_weapon_state" },
    { 0x7E7E, "set_melee_early" },
    { 0x7E7F, "set_melee_timer" },
    { 0x7E80, "set_mission_failed_override" },
    { 0x7E81, "set_momentum" },
    { 0x7E82, "set_momentum_multiplier" },
    { 0x7E83, "set_move_animset" },
    { 0x7E84, "set_moveplaybackrate" },
    { 0x7E85, "set_movetransitionrate" },
    { 0x7E86, "set_new_bomber" },
    { 0x7E87, "set_normal_time_if_gun_fired" },
    { 0x7E88, "set_npc_anims" },
    { 0x7E89, "set_obj_markers_current" },
    { 0x7E8A, "set_objective_active" },
    { 0x7E8B, "set_objective_inactive" },
    { 0x7E8C, "set_off_exploders" },
    { 0x7E8D, "set_oncoming_lighting" },
    { 0x7E8E, "set_operator_temperature_over_time" },
    { 0x7E8F, "set_optimal_flight_dist" },
    { 0x7E90, "set_option_index" },
    { 0x7E91, "set_org" },
    { 0x7E92, "set_origin_and_angles" },
    { 0x7E93, "set_origin_per_time" },
    { 0x7E94, "set_pacifist" },
    { 0x7E95, "set_painted_trackrounds" },
    { 0x7E96, "set_patrol_anim_set" },
    { 0x7E97, "set_patrol_run_anim_array" },
    { 0x7E98, "set_pitbull_anim" },
    { 0x7E99, "set_pitbull_anim_node" },
    { 0x7E9A, "set_pivot_pos" },
    { 0x7E9B, "set_player_attacker_accuracy" },
    { 0x7E9C, "set_player_detection_distance_for_speed" },
    { 0x7E9D, "set_player_link_angles_tag_relative" },
    { 0x7E9E, "set_player_rig_spawn_function" },
    { 0x7E9F, "set_player_speed_hud" },
    { 0x7EA0, "set_player_start" },
    { 0x7EA1, "set_player_viewhand_model" },
    { 0x7EA2, "set_pos" },
    { 0x7EA3, "set_post_slide_blend_time" },
    { 0x7EA4, "set_president_anims" },
    { 0x7EA5, "set_promotion_order" },
    { 0x7EA6, "set_pull_weight" },
    { 0x7EA7, "set_random_flock_goal_position" },
    { 0x7EA8, "set_rank_xp_and_prestige_for_bot" },
    { 0x7EA9, "set_reactive_motion_values" },
    { 0x7EAA, "set_refugee_camp_walk_anims" },
    { 0x7EAB, "set_reverb_stringtable" },
    { 0x7EAC, "set_room_to_breached" },
    { 0x7EAD, "set_rumble_intensity" },
    { 0x7EAE, "set_run_anim" },
    { 0x7EAF, "set_run_anim_array" },
    { 0x7EB0, "set_s1_animarray_add_turn_aims_crouch" },
    { 0x7EB1, "set_s1_animarray_add_turn_aims_stand" },
    { 0x7EB2, "set_s1_animarray_burst_and_semi_fire_crouch" },
    { 0x7EB3, "set_s1_animarray_burst_and_semi_fire_stand" },
    { 0x7EB4, "set_s1_animarray_crouch_aim" },
    { 0x7EB5, "set_s1_animarray_crouching_turns" },
    { 0x7EB6, "set_s1_animarray_stance_change" },
    { 0x7EB7, "set_s1_animarray_stance_change_smg" },
    { 0x7EB8, "set_s1_animarray_standing_turns" },
    { 0x7EB9, "set_scripted_pathing_style" },
    { 0x7EBA, "set_security_center_tv" },
    { 0x7EBB, "set_security_lights" },
    { 0x7EBC, "set_seoul_fall_height" },
    { 0x7EBD, "set_smdvars" },
    { 0x7EBE, "set_snipers_section_clear" },
    { 0x7EBF, "set_spawncount" },
    { 0x7EC0, "set_spot_color" },
    { 0x7EC1, "set_spot_intensity" },
    { 0x7EC2, "set_stage" },
    { 0x7EC3, "set_standing_animarray_aiming" },
    { 0x7EC4, "set_standing_cover_turns" },
    { 0x7EC5, "set_standing_turns" },
    { 0x7EC6, "set_start_pos" },
    { 0x7EC7, "set_start_transients" },
    { 0x7EC8, "set_stat_dvars" },
    { 0x7EC9, "set_stream_origin_for_intro" },
    { 0x7ECA, "set_street_lighting" },
    { 0x7ECB, "set_stringtable_mapname" },
    { 0x7ECC, "set_sun_flare" },
    { 0x7ECD, "set_sun_flare_position" },
    { 0x7ECE, "set_sun_shadow_params" },
    { 0x7ECF, "set_swimming_animarray_aiming" },
    { 0x7ED0, "set_swimming_turns" },
    { 0x7ED1, "set_talker_until_msg" },
    { 0x7ED2, "set_talking_currently" },
    { 0x7ED3, "set_target_player_or_will" },
    { 0x7ED4, "set_target_tracking_disabled" },
    { 0x7ED5, "set_team_bcvoice" },
    { 0x7ED6, "set_team_pacifist" },
    { 0x7ED7, "set_temp_hud_text" },
    { 0x7ED8, "set_this_flag_when_im_dead" },
    { 0x7ED9, "set_threat_grenade_response" },
    { 0x7EDA, "set_threatbias" },
    { 0x7EDB, "set_threatbiasgroup" },
    { 0x7EDC, "set_threshold" },
    { 0x7EDD, "set_time_between_attacks" },
    { 0x7EDE, "set_tool_hudelem" },
    { 0x7EDF, "set_traffic_change_speedup" },
    { 0x7EE0, "set_trigger_flag_permissions" },
    { 0x7EE1, "set_trophy_ammo" },
    { 0x7EE2, "set_tunnel_lighting" },
    { 0x7EE3, "set_tunnel_lighting_1" },
    { 0x7EE4, "set_tunnel_lighting_2" },
    { 0x7EE5, "set_turret_death_anim" },
    { 0x7EE6, "set_turret_team" },
    { 0x7EE7, "set_tv_screen_broken" },
    { 0x7EE8, "set_tv_screen_unbroken" },
    { 0x7EE9, "set_umbra_values" },
    { 0x7EEA, "set_unstorable_weapon" },
    { 0x7EEB, "set_up_ambient_battle" },
    { 0x7EEC, "set_up_auto_non_ai_turret" },
    { 0x7EED, "set_up_bus_crash_anims" },
    { 0x7EEE, "set_up_exo_temperature" },
    { 0x7EEF, "set_up_median_crash_anims" },
    { 0x7EF0, "set_up_pitbull_crash_anims" },
    { 0x7EF1, "set_up_pitbull_escape_anims" },
    { 0x7EF2, "set_up_player_gundown" },
    { 0x7EF3, "set_up_player_s1" },
    { 0x7EF4, "set_up_player_s2" },
    { 0x7EF5, "set_up_police_battle" },
    { 0x7EF6, "set_up_president" },
    { 0x7EF7, "set_up_president_s2" },
    { 0x7EF8, "set_up_tank_exit_anims" },
    { 0x7EF9, "set_up_target" },
    { 0x7EFA, "set_urgent_walk_anims" },
    { 0x7EFB, "set_van_lighting" },
    { 0x7EFC, "set_variable_grenades_with_no_switch" },
    { 0x7EFD, "set_vehicle_anims" },
    { 0x7EFE, "set_vehicle_anims_slow" },
    { 0x7EFF, "set_vehicle_anims_turret" },
    { 0x7F00, "set_vehicle_effect" },
    { 0x7F01, "set_vehicle_goal_position" },
    { 0x7F02, "set_vehicle_speed" },
    { 0x7F03, "set_vision_set" },
    { 0x7F04, "set_vision_set_player" },
    { 0x7F05, "set_visionset_for_watching_players" },
    { 0x7F06, "set_wait_then_clear_skipbloodpool" },
    { 0x7F07, "set_waits" },
    { 0x7F08, "set_walkdist" },
    { 0x7F09, "set_weapon_data" },
    { 0x7F0A, "set_when_time_flag_balcony_tackle_fake_okay" },
    { 0x7F0B, "set_when_time_flag_balcony_tackle_okay" },
    { 0x7F0C, "set_when_time_flag_balcony_tackle_too_late" },
    { 0x7F0D, "set_whizby_radius" },
    { 0x7F0E, "set_whizby_spread" },
    { 0x7F0F, "set_wind" },
    { 0x7F10, "set_x" },
    { 0x7F11, "set_y" },
    { 0x7F12, "set_z" },
    { 0x7F13, "set_zero_speed" },
    { 0x7F14, "set_zone_stringtable" },
    { 0x7F15, "set2dicon" },
    { 0x7F16, "set3dicon" },
    { 0x7F17, "set3duseicon" },
    { 0x7F18, "setactivegrenadetimer" },
    { 0x7F19, "setadrenaline" },
    { 0x7F1A, "setadrenalinesupport" },
    { 0x7F1B, "setaimingparams" },
    { 0x7F1C, "setairdropcratecollision" },
    { 0x7F1D, "setalertoutline" },
    { 0x7F1E, "setalertstencilstate" },
    { 0x7F1F, "setalertstencilstate_axis" },
    { 0x7F20, "setalleystransitionculldist" },
    { 0x7F21, "setallvehiclefx" },
    { 0x7F22, "setaltsceneobj" },
    { 0x7F23, "setalwaysusepistol" },
    { 0x7F24, "setanimaimweight" },
    { 0x7F25, "setanimrestart_once" },
    { 0x7F26, "setanims" },
    { 0x7F27, "setanims_coverleft_stand" },
    { 0x7F28, "setanims_coverright_stand" },
    { 0x7F29, "setanims_coverup_stand" },
    { 0x7F2A, "setanims_slow" },
    { 0x7F2B, "setanims_turret" },
    { 0x7F2C, "setanimtree" },
    { 0x7F2D, "setattackingteam" },
    { 0x7F2E, "setautospot" },
    { 0x7F2F, "setbackenemygunlevelevent" },
    { 0x7F30, "setbackfirstplayergunlevelevent" },
    { 0x7F31, "setbacklevel" },
    { 0x7F32, "setblackbox" },
    { 0x7F33, "setblastshield" },
    { 0x7F34, "setboostdash" },
    { 0x7F35, "setcanuse" },
    { 0x7F36, "setcarepackage" },
    { 0x7F37, "setcarrier" },
    { 0x7F38, "setcarriervisible" },
    { 0x7F39, "setcarryicon" },
    { 0x7F3A, "setcarryingsentry" },
    { 0x7F3B, "setcarryingturret" },
    { 0x7F3C, "setcinematiccamerastyle" },
    { 0x7F3D, "setclaimteam" },
    { 0x7F3E, "setclass" },
    { 0x7F3F, "setcombatrecordstat" },
    { 0x7F40, "setcombatrecordstatifgreater" },
    { 0x7F41, "setcombatstandmoveanimweights" },
    { 0x7F42, "setcommonrulesfrommatchrulesdata" },
    { 0x7F43, "setcontestedicons" },
    { 0x7F44, "setcopycatloadout" },
    { 0x7F45, "setcrawlingpaintransanim" },
    { 0x7F46, "setcrouchmovement" },
    { 0x7F47, "setcurrentgroup" },
    { 0x7F48, "setdeepwaterweapon" },
    { 0x7F49, "setdefaultactionslot" },
    { 0x7F4A, "setdefaultcallbacks" },
    { 0x7F4B, "setdefaultcorneranimmode" },
    { 0x7F4C, "setdefaultcostumeifneeded" },
    { 0x7F4D, "setdefaultdof" },
    { 0x7F4E, "setdefaulthudoutlinedvars" },
    { 0x7F4F, "setdefaulthudoutlinestyle" },
    { 0x7F50, "setdefaultpostfx" },
    { 0x7F51, "setdefaultwallanimmode" },
    { 0x7F52, "setdelaymine" },
    { 0x7F53, "setdeployedjuggernaut" },
    { 0x7F54, "setdifficulty" },
    { 0x7F55, "setdistanceonparts" },
    { 0x7F56, "setdodgeanims" },
    { 0x7F57, "setdof" },
    { 0x7F58, "setdot_height" },
    { 0x7F59, "setdot_ontick" },
    { 0x7F5A, "setdot_origin" },
    { 0x7F5B, "setdot_radius" },
    { 0x7F5C, "setdoubleload" },
    { 0x7F5D, "setdrivenanim" },
    { 0x7F5E, "setdronehealth" },
    { 0x7F5F, "setdronevisionandlightsetpermap" },
    { 0x7F60, "setdropped" },
    { 0x7F61, "setdvar_cg_ng" },
    { 0x7F62, "setdynamiceventstartpercent" },
    { 0x7F63, "setempimmune" },
    { 0x7F64, "setemptydvar" },
    { 0x7F65, "setendgame" },
    { 0x7F66, "setenemydetection" },
    { 0x7F67, "setenemydifficultysettings" },
    { 0x7F68, "setentitydamagecallback" },
    { 0x7F69, "setentityheadicon" },
    { 0x7F6A, "setexomelee" },
    { 0x7F6B, "setexoslam" },
    { 0x7F6C, "setexoslide" },
    { 0x7F6D, "setexplosivegelteamheadicon" },
    { 0x7F6E, "setextrascore0" },
    { 0x7F6F, "setextrascore1" },
    { 0x7F70, "setfinalstand" },
    { 0x7F71, "setfireloopmod" },
    { 0x7F72, "setfirstinfected" },
    { 0x7F73, "setflagaftertime" },
    { 0x7F74, "setflashbangimmunity" },
    { 0x7F75, "setflashfrac" },
    { 0x7F76, "setfogsliders" },
    { 0x7F77, "setfootstepeffect" },
    { 0x7F78, "setfootstepeffectsmall" },
    { 0x7F79, "setfovscale" },
    { 0x7F7A, "setfreefall" },
    { 0x7F7B, "setfriendlydetection" },
    { 0x7F7C, "setfriendlyspawn" },
    { 0x7F7D, "setgameobjecthudindex" },
    { 0x7F7E, "setghilliemodels" },
    { 0x7F7F, "setglobalaimsettings" },
    { 0x7F80, "setglobaldifficulty" },
//  { 0x7F81, "" },
    { 0x7F82, "setgoalradius" },
    { 0x7F83, "setgrenadetimer" },
    { 0x7F84, "setgroup_down" },
    { 0x7F85, "setgroup_up" },
    { 0x7F86, "setguns" },
    { 0x7F87, "setharmonicbreachhudoutlinestyle" },
    { 0x7F88, "sethasdonecombat" },
    { 0x7F89, "setheadicon" },
    { 0x7F8A, "setheadicon_multiple" },
    { 0x7F8B, "setheadmodel" },
    { 0x7F8C, "setheight" },
    { 0x7F8D, "sethighjump" },
    { 0x7F8E, "sethudnumbursts" },
    { 0x7F8F, "sethudtimer" },
    { 0x7F90, "seticonshader" },
    { 0x7F91, "seticonsize" },
    { 0x7F92, "setidleface" },
    { 0x7F93, "setidlefacedelayed" },
    { 0x7F94, "setinfectedmodels" },
    { 0x7F95, "setinfectedmsg" },
    { 0x7F96, "setinflictorstat" },
    { 0x7F97, "setinitialtonormalinfected" },
    { 0x7F98, "setintelmode" },
    { 0x7F99, "setinterval" },
    { 0x7F9A, "setjuiced" },
    { 0x7F9B, "setjumpincrease" },
    { 0x7F9C, "setkeyobject" },
    { 0x7F9D, "setkillcamentity" },
    { 0x7F9E, "setkillcamerastyle" },
    { 0x7F9F, "setkillstreaks" },
    { 0x7FA0, "setlastcallouttype" },
    { 0x7FA1, "setlaststoppedtime" },
    { 0x7FA2, "setlevelcompleted" },
    { 0x7FA3, "setlightarmor" },
    { 0x7FA4, "setlightarmorhp" },
    { 0x7FA5, "setlightingstate" },
    { 0x7FA6, "setlightweight" },
    { 0x7FA7, "setlocaljammer" },
    { 0x7FA8, "setlowermessage" },
    { 0x7FA9, "setmapcenterfordev" },
    { 0x7FAA, "setmapkillstreaktimer" },
    { 0x7FAB, "setmarksman" },
    { 0x7FAC, "setmeleeattackdist" },
    { 0x7FAD, "setmenu" },
    { 0x7FAE, "setmineteamheadicon" },
    { 0x7FAF, "setmissilespecialclipmaskdelayed" },
    { 0x7FB0, "setmisstime" },
    { 0x7FB1, "setmlgicons" },
    { 0x7FB2, "setmodel_warbird" },
    { 0x7FB3, "setmodelfromarray" },
    { 0x7FB4, "setmodelremoteturret" },
    { 0x7FB5, "setmodelturretbaseonly" },
    { 0x7FB6, "setmodelturretplacementfailed" },
    { 0x7FB7, "setmodelturretplacementgood" },
    { 0x7FB8, "setmodelvisibility" },
    { 0x7FB9, "setmoveanim" },
    { 0x7FBA, "setmovenonforwardanims" },
    { 0x7FBB, "setmovespeedincrease" },
    { 0x7FBC, "setmpinstinctplayer" },
    { 0x7FBD, "setnameandrank_andaddtosquad" },
    { 0x7FBE, "setneutralicons" },
    { 0x7FBF, "setnewplayerchain" },
    { 0x7FC0, "setnextdogattackallowtime" },
    { 0x7FC1, "setnextplayergrenadetime" },
    { 0x7FC2, "setnotetrackeffect" },
    { 0x7FC3, "setnotetracksound" },
    { 0x7FC4, "setnpcid" },
    { 0x7FC5, "setobjatrium" },
    { 0x7FC6, "setobjectivehinttext" },
    { 0x7FC7, "setobjectivescoretext" },
    { 0x7FC8, "setobjectivetext" },
    { 0x7FC9, "setobjectivetextcolors" },
    { 0x7FCA, "setobjfollowtarget" },
    { 0x7FCB, "setobjinfilsafehouse" },
    { 0x7FCC, "setobjintercepthades" },
    { 0x7FCD, "setobjmarketscan" },
    { 0x7FCE, "setobjsniperdronesupport" },
    { 0x7FCF, "setoceansinvalueshightide" },
    { 0x7FD0, "setoceansinvalueslowtide" },
    { 0x7FD1, "setoldslam" },
    { 0x7FD2, "setonemanarmy" },
    { 0x7FD3, "setorbitallaserforteam" },
    { 0x7FD4, "setorbitalsupportbuddy" },
    { 0x7FD5, "setorbitalsupportplayer" },
    { 0x7FD6, "setorbitalview" },
    { 0x7FD7, "setoriginbyname" },
    { 0x7FD8, "setospvisionandlightsetpermap" },
    { 0x7FD9, "setoverdrive" },
    { 0x7FDA, "setoverkillpro" },
    { 0x7FDB, "setoverridewatchdvar" },
    { 0x7FDC, "setovertimelimitdvar" },
    { 0x7FDD, "setownerteam" },
    { 0x7FDE, "setpainted" },
    { 0x7FDF, "setparent" },
    { 0x7FE0, "setpastpursuitfailed" },
    { 0x7FE1, "setpersonalbestifgreater" },
    { 0x7FE2, "setpersonalbestiflower" },
    { 0x7FE3, "setpersonaluav" },
    { 0x7FE4, "setpersstat" },
    { 0x7FE5, "setpickedup" },
    { 0x7FE6, "setplayer_anims" },
    { 0x7FE7, "setplayerbcnameid" },
    { 0x7FE8, "setplayerheadicon" },
    { 0x7FE9, "setplayerheadicon_large" },
    { 0x7FEA, "setplayermodels" },
    { 0x7FEB, "setplayerscoreboardinfo" },
    { 0x7FEC, "setplayerstance" },
    { 0x7FED, "setplayerstat" },
    { 0x7FEE, "setplayerstatifgreater" },
    { 0x7FEF, "setplayerstatiflower" },
    { 0x7FF0, "setplayertocamera" },
    { 0x7FF1, "setpoint" },
    { 0x7FF2, "setpointbar" },
    { 0x7FF3, "setpose" },
    { 0x7FF4, "setposemovement" },
    { 0x7FF5, "setposemovementfnarray" },
    { 0x7FF6, "setposition" },
    { 0x7FF7, "setposture" },
    { 0x7FF8, "setprimaryspawnweapon" },
    { 0x7FF9, "setprisonturretplayer" },
    { 0x7FFA, "setragdolldeath" },
    { 0x7FFB, "setrambogrenadeoffsets" },
    { 0x7FFC, "setrandomorbitalsupportstartposition" },
    { 0x7FFD, "setrearview" },
    { 0x7FFE, "setrecoilscale" },
    { 0x7FFF, "setrefillgrenades" },
    { 0x8000, "setrefractionturretplayer" },
    { 0x8001, "setregenspeed" },
    { 0x8002, "setripoffturrethead" },
    { 0x8003, "setsaboteur" },
    { 0x8004, "setsafehouseextdrawdist" },
    { 0x8005, "setsafehouseintdrawdist" },
    { 0x8006, "setsaveddvar_cg_ng" },
    { 0x8007, "setselfunusuable" },
    { 0x8008, "setselfusable" },
    { 0x8009, "setshallowwaterweapon" },
    { 0x800A, "setsharpfocus" },
    { 0x800B, "setshield" },
    { 0x800C, "setshootenttoenemy" },
    { 0x800D, "setshootstyle" },
    { 0x800E, "setshootstyleforsuppression" },
    { 0x800F, "setshootstyleforvisibleenemy" },
    { 0x8010, "setshootwhilemoving" },
    { 0x8011, "setshowgrenades" },
    { 0x8012, "setsize" },
    { 0x8013, "setskill" },
    { 0x8014, "setsniperaccuracy" },
    { 0x8015, "setsolarreflectorplayer" },
    { 0x8016, "setsonicblast" },
    { 0x8017, "setsoundstate" },
    { 0x8018, "setspawnpoint" },
    { 0x8019, "setspawnvariables" },
    { 0x801A, "setspecialloadout" },
    { 0x801B, "setspecialloadouts" },
    { 0x801C, "setspectatepermissions" },
    { 0x801D, "setspectator" },
    { 0x801E, "setsteadyaimpro" },
    { 0x801F, "setsteelnerves" },
    { 0x8020, "setstencilstate" },
    { 0x8021, "setstim" },
    { 0x8022, "setstoppingpower" },
    { 0x8023, "setstunresistance" },
    { 0x8024, "setsurvivaltime" },
    { 0x8025, "settacticalinsertion" },
    { 0x8026, "settargetandshader" },
    { 0x8027, "settargetangularacceleration" },
    { 0x8028, "settargetentity_smoothtracking" },
    { 0x8029, "settargetoutline" },
    { 0x802A, "setteam" },
    { 0x802B, "setteamheadicon" },
    { 0x802C, "setteamheadicon_large" },
    { 0x802D, "setteamicons" },
    { 0x802E, "setteammodels" },
    { 0x802F, "setteamradarwrapper" },
    { 0x8030, "setteamusetext" },
    { 0x8031, "setteamusetime" },
    { 0x8032, "setthermal" },
    { 0x8033, "setthermaldof" },
    { 0x8034, "setthirdpersondof" },
    { 0x8035, "settimeofnextsound" },
    { 0x8036, "settimeromnvar" },
    { 0x8037, "settings" },
    { 0x8038, "settoneverdelete" },
    { 0x8039, "settridroneteamheadicon" },
    { 0x803A, "setturretfireondrones" },
    { 0x803B, "setturretusable" },
    { 0x803C, "settweakablelastvalue" },
    { 0x803D, "settweakablevalue" },
    { 0x803E, "setuav" },
    { 0x803F, "setuioptionsmenu" },
    { 0x8040, "setunderwateraudiozone" },
    { 0x8041, "setunstableground" },
    { 0x8042, "setup" },
    { 0x8043, "setup_a10_waits" },
    { 0x8044, "setup_additive_aim" },
    { 0x8045, "setup_ai" },
    { 0x8046, "setup_ai_eq_triggers" },
    { 0x8047, "setup_ai_for_bus_sequence" },
    { 0x8048, "setup_aianimthreads" },
    { 0x8049, "setup_alley_anims" },
    { 0x804A, "setup_alley_escape_breach" },
    { 0x804B, "setup_alley_wall_climb_foley" },
    { 0x804C, "setup_allies" },
    { 0x804D, "setup_ally_squad" },
    { 0x804E, "setup_ally_squad_member" },
    { 0x804F, "setup_alpha_squad" },
    { 0x8050, "setup_ambient_walker_tank" },
    { 0x8051, "setup_and_fire_missles_at_guys_repeated" },
    { 0x8052, "setup_anim_array" },
    { 0x8053, "setup_anim_receivers" },
    { 0x8054, "setup_animated_guy" },
    { 0x8055, "setup_atlas_drone" },
    { 0x8056, "setup_audio" },
    { 0x8057, "setup_audio_dnabomb" },
    { 0x8058, "setup_audio_zone_bridge_intact" },
    { 0x8059, "setup_audio_zone_tunnel" },
    { 0x805A, "setup_bigmoment_notetracks" },
    { 0x805B, "setup_bones" },
    { 0x805C, "setup_bot_ball" },
    { 0x805D, "setup_bot_conf" },
    { 0x805E, "setup_bot_ctf" },
    { 0x805F, "setup_bot_dom" },
    { 0x8060, "setup_bot_gun" },
    { 0x8061, "setup_bot_hp" },
    { 0x8062, "setup_bot_infect" },
    { 0x8063, "setup_bot_sd" },
    { 0x8064, "setup_bot_twar" },
    { 0x8065, "setup_bot_war" },
    { 0x8066, "setup_boulder_audio" },
    { 0x8067, "setup_boulder_data" },
    { 0x8068, "setup_breach_marker" },
    { 0x8069, "setup_bridge_explosion_anim_sequence" },
    { 0x806A, "setup_bridge_explosion_anim_sequence_bridge" },
    { 0x806B, "setup_bridge_explosion_anim_sequence_humans" },
    { 0x806C, "setup_bridge_explosion_anim_sequence_vehicles" },
    { 0x806D, "setup_bridge_explosion_trigger" },
    { 0x806E, "setup_briefing_anims" },
    { 0x806F, "setup_buddy_drone_deploy_anims" },
    { 0x8070, "setup_building_traverse_and_vista" },
    { 0x8071, "setup_burke" },
    { 0x8072, "setup_burke_aim_anims" },
    { 0x8073, "setup_burke_river_cross_notetracks" },
    { 0x8074, "setup_button_notifies" },
    { 0x8075, "setup_callbacks" },
    { 0x8076, "setup_camparams" },
    { 0x8077, "setup_canyon" },
    { 0x8078, "setup_canyon_dam" },
    { 0x8079, "setup_canyon_dam_old_controls" },
    { 0x807A, "setup_canyon_exit" },
    { 0x807B, "setup_canyon_old_controls" },
    { 0x807C, "setup_canyon2" },
    { 0x807D, "setup_canyon2_old_controls" },
    { 0x807E, "setup_canyon3" },
    { 0x807F, "setup_canyon3_old_controls" },
    { 0x8080, "setup_capture" },
    { 0x8081, "setup_car_passing_lights" },
    { 0x8082, "setup_car_ride_moment" },
    { 0x8083, "setup_cave_entry_loading_razorback" },
    { 0x8084, "setup_cg_start_points" },
    { 0x8085, "setup_charged_shot" },
    { 0x8086, "setup_cherry_picker_turret" },
    { 0x8087, "setup_chopper_crash_anims" },
    { 0x8088, "setup_choppers" },
    { 0x8089, "setup_civ_animations" },
    { 0x808A, "setup_civ_fence_special" },
    { 0x808B, "setup_civs" },
    { 0x808C, "setup_civs_baseball" },
    { 0x808D, "setup_civs_fence" },
    { 0x808E, "setup_civs_foodtruck" },
    { 0x808F, "setup_civs_infosign" },
    { 0x8090, "setup_civs_talking" },
    { 0x8091, "setup_civs_walkers" },
    { 0x8092, "setup_cleanup_vehicle" },
    { 0x8093, "setup_climb_anims" },
    { 0x8094, "setup_climb_anims_parse_anim_offsets" },
    { 0x8095, "setup_climb_model" },
    { 0x8096, "setup_climb_special_arrays" },
    { 0x8097, "setup_clip" },
    { 0x8098, "setup_clip_pickups" },
    { 0x8099, "setup_cloak_cover" },
    { 0x809A, "setup_combat" },
    { 0x809B, "setup_common" },
    { 0x809C, "setup_complete_missile_not_prefab" },
    { 0x809D, "setup_complete_missile_prefab" },
    { 0x809E, "setup_control_room_door_explosion_light" },
    { 0x809F, "setup_control_room_player_start" },
    { 0x80A0, "setup_control_room_scene_dof" },
    { 0x80A1, "setup_control_room_screen_light" },
    { 0x80A2, "setup_cormack_meetup_scene_notetracks" },
    { 0x80A3, "setup_corpses" },
    { 0x80A4, "setup_cover_crouch" },
    { 0x80A5, "setup_cover_nodes_street" },
    { 0x80A6, "setup_cover_prone" },
    { 0x80A7, "setup_cover_stand" },
    { 0x80A8, "setup_crash_events" },
    { 0x80A9, "setup_crash_flicker_presets" },
    { 0x80AA, "setup_crash_light_motions" },
    { 0x80AB, "setup_crash_site_intro_anims" },
    { 0x80AC, "setup_crevasse_fall_and_recover" },
    { 0x80AD, "setup_crouching_anim_array" },
    { 0x80AE, "setup_day_lighting_volume" },
    { 0x80AF, "setup_deck_deploy_warbird" },
    { 0x80B0, "setup_decon_gate_anims" },
    { 0x80B1, "setup_deer_notetracks" },
    { 0x80B2, "setup_default_level_vars" },
    { 0x80B3, "setup_destructible_dots" },
    { 0x80B4, "setup_destructibles" },
    { 0x80B5, "setup_destructibles_thread" },
    { 0x80B6, "setup_det_intro_catch_anims" },
    { 0x80B7, "setup_dialogue" },
    { 0x80B8, "setup_dnabomb" },
    { 0x80B9, "setup_dnabomb_anims" },
    { 0x80BA, "setup_dof_default_interior" },
    { 0x80BB, "setup_dof_default_interior_volume" },
    { 0x80BC, "setup_dof_door_breach" },
    { 0x80BD, "setup_dof_drone" },
    { 0x80BE, "setup_dof_enter_turret" },
    { 0x80BF, "setup_dof_exit_turret" },
    { 0x80C0, "setup_dof_funeral" },
    { 0x80C1, "setup_dof_funeral_cg" },
    { 0x80C2, "setup_dof_government_breach" },
    { 0x80C3, "setup_dof_government_climb" },
    { 0x80C4, "setup_dof_government_overlook" },
    { 0x80C5, "setup_dof_hostage_release" },
    { 0x80C6, "setup_dof_intro" },
    { 0x80C7, "setup_dof_mini_atrium" },
    { 0x80C8, "setup_dof_mini_atrium_volume" },
    { 0x80C9, "setup_dof_presets" },
    { 0x80CA, "setup_dof_roundabout_tanker_explosion" },
    { 0x80CB, "setup_dof_safehousefollow" },
    { 0x80CC, "setup_dof_safehouseintro" },
    { 0x80CD, "setup_dof_security" },
    { 0x80CE, "setup_dof_security_volume" },
    { 0x80CF, "setup_dof_server_room" },
    { 0x80D0, "setup_dof_shoreline" },
    { 0x80D1, "setup_dof_takedownkill" },
    { 0x80D2, "setup_dof_tour_ride" },
    { 0x80D3, "setup_dof_training_2_drone" },
    { 0x80D4, "setup_dof_van_takedown" },
    { 0x80D5, "setup_dof_viewmodel_presets" },
    { 0x80D6, "setup_dont_leave_failure" },
    { 0x80D7, "setup_dont_leave_hint" },
    { 0x80D8, "setup_dont_leave_squad" },
    { 0x80D9, "setup_dont_leave_squad_hint" },
    { 0x80DA, "setup_door_anim" },
    { 0x80DB, "setup_door_anim_leader" },
    { 0x80DC, "setup_doorshield_anims" },
    { 0x80DD, "setup_drive_shadows" },
    { 0x80DE, "setup_drone_intro_anims" },
    { 0x80DF, "setup_drone_mode" },
    { 0x80E0, "setup_drone_street_fight" },
    { 0x80E1, "setup_drone_swarm_crates" },
    { 0x80E2, "setup_droppod_intro_anims" },
    { 0x80E3, "setup_dynamic_detour" },
    { 0x80E4, "setup_elevator_security_light" },
    { 0x80E5, "setup_end_gate" },
    { 0x80E6, "setup_end_scene" },
    { 0x80E7, "setup_ending_anims" },
    { 0x80E8, "setup_entrance_gate_anims" },
    { 0x80E9, "setup_evacuation_scene" },
    { 0x80EA, "setup_exfil_anims" },
    { 0x80EB, "setup_exit_ride_anims" },
    { 0x80EC, "setup_exitdrive_control_hints" },
    { 0x80ED, "setup_exitdrive_encounters" },
    { 0x80EE, "setup_exitdrive_ending_anims" },
    { 0x80EF, "setup_exitdrive_starting_anims" },
    { 0x80F0, "setup_exo_arm_moment_lighting" },
    { 0x80F1, "setup_exo_climb_audio" },
    { 0x80F2, "setup_exo_door_kick_anims" },
    { 0x80F3, "setup_exo_room_lighting_volume" },
    { 0x80F4, "setup_eye_highlights" },
    { 0x80F5, "setup_eye_highlights_02" },
    { 0x80F6, "setup_eye_highlights_gideon" },
    { 0x80F7, "setup_fall_cloth_floey" },
    { 0x80F8, "setup_fastzip_anims" },
    { 0x80F9, "setup_fastzip_unload" },
    { 0x80FA, "setup_fence_climb_anims" },
    { 0x80FB, "setup_final_chopper" },
    { 0x80FC, "setup_final_lighting" },
    { 0x80FD, "setup_final_straightaway_bus_jump" },
    { 0x80FE, "setup_final_straightaway_buttresses" },
    { 0x80FF, "setup_final_straightaway_missiles" },
    { 0x8100, "setup_finale_anims" },
    { 0x8101, "setup_firelight_explosion_hangar" },
    { 0x8102, "setup_firing_range_stall_lighting_volume" },
    { 0x8103, "setup_first_fight_left_guy" },
    { 0x8104, "setup_first_fight_right_guy1" },
    { 0x8105, "setup_first_fight_right_guy2" },
    { 0x8106, "setup_flag_exploders" },
    { 0x8107, "setup_flank_wall_climb_lighting" },
    { 0x8108, "setup_flank_wall_climb_lighting_complete" },
    { 0x8109, "setup_flickerlight_motion_presets" },
    { 0x810A, "setup_flickerlight_presets" },
    { 0x810B, "setup_flickerlight_presets2" },
    { 0x810C, "setup_flipbook_models" },
    { 0x810D, "setup_fob_blocker_guy_loop" },
    { 0x810E, "setup_fog_tweak" },
    { 0x810F, "setup_food_line_and_guards" },
    { 0x8110, "setup_footstep_fx" },
    { 0x8111, "setup_free_drive_path" },
    { 0x8112, "setup_free_run_cover_crouch_anims" },
    { 0x8113, "setup_free_run_move_anims" },
    { 0x8114, "setup_free_run_transition_anims" },
    { 0x8115, "setup_funeral" },
    { 0x8116, "setup_funeral_ambi_fade" },
    { 0x8117, "setup_fusion_finale_arm_fx" },
    { 0x8118, "setup_fusion_finale_arm_rimlight" },
    { 0x8119, "setup_fusion_finale_helicopter_light" },
    { 0x811A, "setup_fusion_finale_light_flicker" },
    { 0x811B, "setup_fusion_finale_light_rim" },
    { 0x811C, "setup_fusion_finale_light_rim_fov" },
    { 0x811D, "setup_fusion_finale_lightgrid" },
    { 0x811E, "setup_fusion_light_model_flicker" },
    { 0x811F, "setup_fusion_light_model_flicker2" },
    { 0x8120, "setup_fusion_light_model_flicker3" },
    { 0x8121, "setup_fx" },
    { 0x8122, "setup_fx_chain" },
    { 0x8123, "setup_gag_stage_littlebird_load" },
    { 0x8124, "setup_gag_stage_littlebird_unload" },
    { 0x8125, "setup_galaxy_hatch" },
    { 0x8126, "setup_gameplay" },
    { 0x8127, "setup_gangnam_station_intersection" },
    { 0x8128, "setup_gate_crash" },
    { 0x8129, "setup_generic_allies" },
    { 0x812A, "setup_generic_no_shot_vo" },
    { 0x812B, "setup_generic_taking_the_shot_vo" },
    { 0x812C, "setup_generic_target_acquired_vo" },
    { 0x812D, "setup_generic_target_down_vo" },
    { 0x812E, "setup_gideon" },
    { 0x812F, "setup_gideon_climb_notetracks" },
    { 0x8130, "setup_gideon_intro_foley" },
    { 0x8131, "setup_goliath_bridge_anims" },
    { 0x8132, "setup_government_climb_sunlerp" },
    { 0x8133, "setup_government_rpg_explosion_dof" },
    { 0x8134, "setup_government_rpg_explosion_lighting" },
    { 0x8135, "setup_groundnode_detour" },
    { 0x8136, "setup_guy_for_animation" },
    { 0x8137, "setup_guy_for_droppod" },
    { 0x8138, "setup_hangar_door_open_sequence" },
    { 0x8139, "setup_hangar_interior_walls" },
    { 0x813A, "setup_hangar_notetracks" },
    { 0x813B, "setup_hangar_shadow_shell" },
    { 0x813C, "setup_harmonic_breach_anims" },
    { 0x813D, "setup_hazmant_suit_room" },
    { 0x813E, "setup_hazmat_intro_allies" },
    { 0x813F, "setup_helicopter_blades_damage" },
    { 0x8140, "setup_help_keys" },
    { 0x8141, "setup_hemiao_enable" },
    { 0x8142, "setup_hero" },
    { 0x8143, "setup_hints" },
    { 0x8144, "setup_hospital" },
    { 0x8145, "setup_hospital_bodies" },
    { 0x8146, "setup_hospital_notetracks" },
    { 0x8147, "setup_hospital_post_breach_anims" },
    { 0x8148, "setup_hospital_transition" },
    { 0x8149, "setup_hostage_key_fov_tune" },
    { 0x814A, "setup_hotel_exo_punch_breach_anims" },
    { 0x814B, "setup_hoverbike_meet_up_notetracks" },
    { 0x814C, "setup_hovertank" },
    { 0x814D, "setup_hovertank_combat" },
    { 0x814E, "setup_hud_elem" },
    { 0x814F, "setup_hud_lighting" },
    { 0x8150, "setup_ignore_suppression_triggers" },
    { 0x8151, "setup_ilona_lighting" },
    { 0x8152, "setup_individual_exploder" },
    { 0x8153, "setup_injured_soldiers" },
    { 0x8154, "setup_intel_cormack" },
    { 0x8155, "setup_intel_main" },
    { 0x8156, "setup_intel_player" },
    { 0x8157, "setup_intro" },
    { 0x8158, "setup_intro_canyon" },
    { 0x8159, "setup_intro_canyon_old_controls" },
    { 0x815A, "setup_intro_old_controls" },
    { 0x815B, "setup_investigate_location" },
    { 0x815C, "setup_jet_waits" },
    { 0x815D, "setup_jetbike_checkpoint_anims" },
    { 0x815E, "setup_jetbike_motorpool_anims" },
    { 0x815F, "setup_joker" },
    { 0x8160, "setup_kill_drone_trig" },
    { 0x8161, "setup_kill_drone_trig_proc" },
    { 0x8162, "setup_knockdown_sequence" },
    { 0x8163, "setup_lab_entrance_light" },
    { 0x8164, "setup_lab_script_exit_volume" },
    { 0x8165, "setup_lab_script_volume" },
    { 0x8166, "setup_lagos_intro_alley_transition_volume" },
    { 0x8167, "setup_lagos_intro_alley_volume" },
    { 0x8168, "setup_lagos_intro_interiors_post_exo_volume" },
    { 0x8169, "setup_lagos_intro_interiors_volume" },
    { 0x816A, "setup_lake_anims" },
    { 0x816B, "setup_land_assist_jump_anims" },
    { 0x816C, "setup_lane_information" },
    { 0x816D, "setup_last_movement_timer" },
    { 0x816E, "setup_level_lighting_values" },
    { 0x816F, "setup_level_rumble_ent" },
    { 0x8170, "setup_level_transient_zone_variable" },
    { 0x8171, "setup_levelvars" },
    { 0x8172, "setup_lightgrid_lighting_drone" },
    { 0x8173, "setup_lighting" },
    { 0x8174, "setup_lighting_alley" },
    { 0x8175, "setup_lighting_alley_interiors" },
    { 0x8176, "setup_lighting_alley_interiors_volume" },
    { 0x8177, "setup_lighting_alley_volume" },
    { 0x8178, "setup_lighting_alley1_start" },
    { 0x8179, "setup_lighting_alley2_start" },
    { 0x817A, "setup_lighting_ambush" },
    { 0x817B, "setup_lighting_basement_start" },
    { 0x817C, "setup_lighting_boat_crash" },
    { 0x817D, "setup_lighting_boat_start" },
    { 0x817E, "setup_lighting_canal_area" },
    { 0x817F, "setup_lighting_canal_area_volume" },
    { 0x8180, "setup_lighting_chase_buildings" },
    { 0x8181, "setup_lighting_chase_buildings_volume" },
    { 0x8182, "setup_lighting_chase_start" },
    { 0x8183, "setup_lighting_chase_start_volume" },
    { 0x8184, "setup_lighting_chase_tunnel" },
    { 0x8185, "setup_lighting_chase_tunnel_transition" },
    { 0x8186, "setup_lighting_chase_tunnel_transition_volume" },
    { 0x8187, "setup_lighting_chase_tunnel_volume" },
    { 0x8188, "setup_lighting_climb_start" },
    { 0x8189, "setup_lighting_confrontation_start" },
    { 0x818A, "setup_lighting_control_room_start" },
    { 0x818B, "setup_lighting_courtyard_start" },
    { 0x818C, "setup_lighting_day" },
    { 0x818D, "setup_lighting_door_breach" },
    { 0x818E, "setup_lighting_drone" },
    { 0x818F, "setup_lighting_drone_attack" },
    { 0x8190, "setup_lighting_elevator_ride" },
    { 0x8191, "setup_lighting_escape_start" },
    { 0x8192, "setup_lighting_exo_hangar" },
    { 0x8193, "setup_lighting_exo_hangar_doorway" },
    { 0x8194, "setup_lighting_exo_hangar_doorway_volume" },
    { 0x8195, "setup_lighting_exo_hangar_volume" },
    { 0x8196, "setup_lighting_exo_room" },
    { 0x8197, "setup_lighting_finale_start" },
    { 0x8198, "setup_lighting_firing_doorway_volume" },
    { 0x8199, "setup_lighting_firing_range" },
    { 0x819A, "setup_lighting_firing_range_doorway" },
    { 0x819B, "setup_lighting_firing_range_entrance" },
    { 0x819C, "setup_lighting_firing_range_entrance_volume" },
    { 0x819D, "setup_lighting_firing_range_exit" },
    { 0x819E, "setup_lighting_firing_range_exit_volume" },
    { 0x819F, "setup_lighting_firing_range_gallery" },
    { 0x81A0, "setup_lighting_firing_range_lights_moment" },
    { 0x81A1, "setup_lighting_firing_range_stall" },
    { 0x81A2, "setup_lighting_firing_range_stall_01_volume" },
    { 0x81A3, "setup_lighting_firing_range_stall_02_volume" },
    { 0x81A4, "setup_lighting_firing_range_stall_03_volume" },
    { 0x81A5, "setup_lighting_firing_range_stall_04_volume" },
    { 0x81A6, "setup_lighting_firing_range_stall_05_volume" },
    { 0x81A7, "setup_lighting_firing_range_stall_06_volume" },
    { 0x81A8, "setup_lighting_firing_range_stall_07_volume" },
    { 0x81A9, "setup_lighting_firing_range_stall_08_volume" },
    { 0x81AA, "setup_lighting_firing_range_stall_exposure" },
    { 0x81AB, "setup_lighting_firing_range_volume" },
    { 0x81AC, "setup_lighting_flank_start" },
    { 0x81AD, "setup_lighting_fly_drone" },
    { 0x81AE, "setup_lighting_fly_drone_off" },
    { 0x81AF, "setup_lighting_fly_drone_off_night" },
    { 0x81B0, "setup_lighting_fly_drone_off_turbine" },
    { 0x81B1, "setup_lighting_fly_drone_turbine" },
    { 0x81B2, "setup_lighting_frogger_start" },
    { 0x81B3, "setup_lighting_funeral_sequence" },
    { 0x81B4, "setup_lighting_funeral_start" },
    { 0x81B5, "setup_lighting_fx_during_mini_games" },
    { 0x81B6, "setup_lighting_generic_volume" },
    { 0x81B7, "setup_lighting_government" },
    { 0x81B8, "setup_lighting_government_breach" },
    { 0x81B9, "setup_lighting_government_ext" },
    { 0x81BA, "setup_lighting_government_ext_volume" },
    { 0x81BB, "setup_lighting_government_hostage" },
    { 0x81BC, "setup_lighting_government_hostage_volume" },
    { 0x81BD, "setup_lighting_government_overlook" },
    { 0x81BE, "setup_lighting_government_overlook_door" },
    { 0x81BF, "setup_lighting_government_overlook_volume" },
    { 0x81C0, "setup_lighting_government_start" },
    { 0x81C1, "setup_lighting_government_volume" },
    { 0x81C2, "setup_lighting_hangar_demos" },
    { 0x81C3, "setup_lighting_hangar_doors" },
    { 0x81C4, "setup_lighting_harmonic_breach" },
    { 0x81C5, "setup_lighting_harmonic_breach_dof" },
    { 0x81C6, "setup_lighting_harmonic_breach_hud" },
    { 0x81C7, "setup_lighting_hostage_release" },
    { 0x81C8, "setup_lighting_house_interior" },
    { 0x81C9, "setup_lighting_house_interior_transition" },
    { 0x81CA, "setup_lighting_house_interior_transition_volume" },
    { 0x81CB, "setup_lighting_house_interior_volume" },
    { 0x81CC, "setup_lighting_initial_rpgs" },
    { 0x81CD, "setup_lighting_intro_drone" },
    { 0x81CE, "setup_lighting_intro_start" },
    { 0x81CF, "setup_lighting_lab_interior" },
    { 0x81D0, "setup_lighting_lab_interior_volume" },
    { 0x81D1, "setup_lighting_lab_start" },
    { 0x81D2, "setup_lighting_lab_warehouse" },
    { 0x81D3, "setup_lighting_lab_warehouse_volume" },
    { 0x81D4, "setup_lighting_lagos_generic" },
    { 0x81D5, "setup_lighting_lagos_intro_alley" },
    { 0x81D6, "setup_lighting_lagos_intro_alley_transition" },
    { 0x81D7, "setup_lighting_lagos_intro_interiors" },
    { 0x81D8, "setup_lighting_lagos_intro_post_exo_interiors" },
    { 0x81D9, "setup_lighting_lagos_sunflare_volume" },
    { 0x81DA, "setup_lighting_lobby" },
    { 0x81DB, "setup_lighting_lobby_volume" },
    { 0x81DC, "setup_lighting_marketplace" },
    { 0x81DD, "setup_lighting_marketplace_interiors" },
    { 0x81DE, "setup_lighting_marketplace_interiors_volume" },
    { 0x81DF, "setup_lighting_marketplace_volume" },
    { 0x81E0, "setup_lighting_middle_takedown_start" },
    { 0x81E1, "setup_lighting_night" },
    { 0x81E2, "setup_lighting_night_pool" },
    { 0x81E3, "setup_lighting_office_start" },
    { 0x81E4, "setup_lighting_old_town_start" },
    { 0x81E5, "setup_lighting_oncoming_start" },
    { 0x81E6, "setup_lighting_outro" },
    { 0x81E7, "setup_lighting_outro_start" },
    { 0x81E8, "setup_lighting_outro_volume" },
    { 0x81E9, "setup_lighting_override_exo_wallclimb" },
    { 0x81EA, "setup_lighting_pantry_interior" },
    { 0x81EB, "setup_lighting_pantry_interior_volume" },
    { 0x81EC, "setup_lighting_post_h_breach_start" },
    { 0x81ED, "setup_lighting_post_middle_takedown_start" },
    { 0x81EE, "setup_lighting_pre_h_breach_start" },
    { 0x81EF, "setup_lighting_rail_start" },
    { 0x81F0, "setup_lighting_railwalk" },
    { 0x81F1, "setup_lighting_railwalk_volume" },
    { 0x81F2, "setup_lighting_reactor_exit_start" },
    { 0x81F3, "setup_lighting_reactor_start" },
    { 0x81F4, "setup_lighting_ready_room_elevators" },
    { 0x81F5, "setup_lighting_rec_yard" },
    { 0x81F6, "setup_lighting_rec_yard_transition" },
    { 0x81F7, "setup_lighting_rec_yard_transition_volume" },
    { 0x81F8, "setup_lighting_rec_yard_volume" },
    { 0x81F9, "setup_lighting_roof_start" },
    { 0x81FA, "setup_lighting_roundabout" },
    { 0x81FB, "setup_lighting_roundabout_start" },
    { 0x81FC, "setup_lighting_roundabout_transition" },
    { 0x81FD, "setup_lighting_roundabout_transition_volume" },
    { 0x81FE, "setup_lighting_roundabout_volume" },
    { 0x81FF, "setup_lighting_security_start" },
    { 0x8200, "setup_lighting_sewer_start" },
    { 0x8201, "setup_lighting_shoreline" },
    { 0x8202, "setup_lighting_shoreline_start" },
    { 0x8203, "setup_lighting_sunflare" },
    { 0x8204, "setup_lighting_suv_takedown" },
    { 0x8205, "setup_lighting_swim_start" },
    { 0x8206, "setup_lighting_tanker_aftermath" },
    { 0x8207, "setup_lighting_tanker_aftermath_cleanup" },
    { 0x8208, "setup_lighting_tanker_aftermath_volume" },
    { 0x8209, "setup_lighting_tour_augmented_reality_start" },
    { 0x820A, "setup_lighting_tour_end_start" },
    { 0x820B, "setup_lighting_tour_exo_begin_start" },
    { 0x820C, "setup_lighting_tour_exo_exit_start" },
    { 0x820D, "setup_lighting_tour_firing_range_start" },
    { 0x820E, "setup_lighting_tour_ride_begin_start" },
    { 0x820F, "setup_lighting_traffic_crossing" },
    { 0x8210, "setup_lighting_traffic_crossing_volume" },
    { 0x8211, "setup_lighting_training_2_begin_start" },
    { 0x8212, "setup_lighting_training_2_end_start" },
    { 0x8213, "setup_lighting_training_2_golf_course_start" },
    { 0x8214, "setup_lighting_training_2_lodge_begin_start" },
    { 0x8215, "setup_lighting_training_2_lodge_breach_start" },
    { 0x8216, "setup_lighting_training_2_lodge_exit_start" },
    { 0x8217, "setup_lighting_training_2_transition" },
    { 0x8218, "setup_lighting_training_2_transition_volume" },
    { 0x8219, "setup_lighting_training_begin_start" },
    { 0x821A, "setup_lighting_training_end_character_sequence" },
    { 0x821B, "setup_lighting_training_end_start" },
    { 0x821C, "setup_lighting_training_golf_course_start" },
    { 0x821D, "setup_lighting_training_lodge_begin_start" },
    { 0x821E, "setup_lighting_training_lodge_breach_start" },
    { 0x821F, "setup_lighting_training_lodge_exit_start" },
    { 0x8220, "setup_lighting_turbine_start" },
    { 0x8221, "setup_lighting_underwater" },
    { 0x8222, "setup_lighting_underwater_lights" },
    { 0x8223, "setup_lighting_underwater_start" },
    { 0x8224, "setup_lighting_underwater_sunlerp" },
    { 0x8225, "setup_lighting_underwater_volume" },
    { 0x8226, "setup_lighting_van_takedown" },
    { 0x8227, "setup_lighting_van_takedown_start" },
    { 0x8228, "setup_lighting_weapons_platform_area" },
    { 0x8229, "setup_lighting_weapons_platform_area_volume" },
    { 0x822A, "setup_lightning_transition" },
    { 0x822B, "setup_lights_pre_elevator" },
    { 0x822C, "setup_lower_atmosphere_fall" },
    { 0x822D, "setup_m_turret" },
    { 0x822E, "setup_mag_glove_anims" },
    { 0x822F, "setup_main_missile" },
    { 0x8230, "setup_mall_sizeup_anims" },
    { 0x8231, "setup_mech_for_drop" },
    { 0x8232, "setup_mech_grapple_kill_anims" },
    { 0x8233, "setup_mechs" },
    { 0x8234, "setup_meet_cormack_pt2_objective" },
    { 0x8235, "setup_mg_turrets" },
    { 0x8236, "setup_middle_notetracks" },
    { 0x8237, "setup_mig29_waits" },
    { 0x8238, "setup_miniguns" },
    { 0x8239, "setup_missile_launchers" },
    { 0x823A, "setup_mob_turret" },
    { 0x823B, "setup_mob_turret_targets" },
    { 0x823C, "setup_mobile_turret" },
    { 0x823D, "setup_mobile_turret_gameplay" },
    { 0x823E, "setup_motion_blur_chase_start" },
    { 0x823F, "setup_motion_blur_oncoming" },
    { 0x8240, "setup_motorpool" },
    { 0x8241, "setup_move_chase_van" },
    { 0x8242, "setup_move_friendly_pitbull" },
    { 0x8243, "setup_move_player_pitbull" },
    { 0x8244, "setup_names" },
    { 0x8245, "setup_narrow_cave_anims" },
    { 0x8246, "setup_new_eq_settings" },
    { 0x8247, "setup_night_lighting_pool_volume" },
    { 0x8248, "setup_night_lighting_volume" },
    { 0x8249, "setup_nightclub_notetracks" },
    { 0x824A, "setup_nothing" },
    { 0x824B, "setup_npc_cloak_button_anims" },
    { 0x824C, "setup_npc_paths" },
    { 0x824D, "setup_npc_pod_landings" },
    { 0x824E, "setup_objective_flags" },
    { 0x824F, "setup_objectives" },
    { 0x8250, "setup_openning_vista" },
    { 0x8251, "setup_orange_room_enter" },
    { 0x8252, "setup_orange_room_enter_volume" },
    { 0x8253, "setup_orange_room_exit" },
    { 0x8254, "setup_orange_room_exit_volume" },
    { 0x8255, "setup_orbital_entry" },
    { 0x8256, "setup_outerspacelighting_interior" },
    { 0x8257, "setup_outro" },
    { 0x8258, "setup_outro_notetracks" },
    { 0x8259, "setup_park_rpg_barrage" },
    { 0x825A, "setup_pdrone_animations" },
    { 0x825B, "setup_pdrone_type" },
    { 0x825C, "setup_personal_drone" },
    { 0x825D, "setup_personalities" },
    { 0x825E, "setup_physical_dof_fob" },
    { 0x825F, "setup_pitbull_vfx_lights" },
    { 0x8260, "setup_player" },
    { 0x8261, "setup_player_blocking_shot_vo" },
    { 0x8262, "setup_player_driving_anims" },
    { 0x8263, "setup_player_fall" },
    { 0x8264, "setup_player_fall_fog" },
    { 0x8265, "setup_player_for_animated_sequence" },
    { 0x8266, "setup_player_for_gameplay" },
    { 0x8267, "setup_player_for_scene" },
    { 0x8268, "setup_player_pitbull" },
    { 0x8269, "setup_player_pod" },
    { 0x826A, "setup_player_pod_b" },
    { 0x826B, "setup_player_pod_exit" },
    { 0x826C, "setup_player_takedown_notetracks" },
    { 0x826D, "setup_pm_rescue_anims" },
    { 0x826E, "setup_pod_eject_anims" },
    { 0x826F, "setup_pod_exit_anims" },
    { 0x8270, "setup_poison_gas_death" },
    { 0x8271, "setup_portal_scripting" },
    { 0x8272, "setup_post_refuel" },
    { 0x8273, "setup_post_refuel_old_controls" },
    { 0x8274, "setup_post_tower" },
    { 0x8275, "setup_precache" },
    { 0x8276, "setup_queen_drone" },
    { 0x8277, "setup_rappel_marker" },
    { 0x8278, "setup_reentry" },
    { 0x8279, "setup_refugee_camp_soldiers" },
    { 0x827A, "setup_refugee_camp_soldiers_group_1" },
    { 0x827B, "setup_refugee_stage_audience" },
    { 0x827C, "setup_refugee_stage_speaker" },
    { 0x827D, "setup_regroup_obj" },
    { 0x827E, "setup_reminder_volumes" },
    { 0x827F, "setup_repair_hangar_lighting" },
    { 0x8280, "setup_rider_anims" },
    { 0x8281, "setup_rocket_pieces" },
    { 0x8282, "setup_roof_breach_anims" },
    { 0x8283, "setup_roundabout_point_source_dambs" },
    { 0x8284, "setup_roundabout_rpg_fire_emitters" },
    { 0x8285, "setup_roundabout_tanker_proxy_fire_emitters" },
    { 0x8286, "setup_run_n_gun" },
    { 0x8287, "setup_s2_ally_squad_member" },
    { 0x8288, "setup_safe_vols_near_cardoors" },
    { 0x8289, "setup_school" },
    { 0x828A, "setup_school_bodies" },
    { 0x828B, "setup_school_notetracks" },
    { 0x828C, "setup_school_shimmy_anims" },
    { 0x828D, "setup_school_stealth" },
    { 0x828E, "setup_script_gatetrigger" },
    { 0x828F, "setup_scriptable_primary_light" },
    { 0x8290, "setup_se" },
    { 0x8291, "setup_sentinel_reveal_anims" },
    { 0x8292, "setup_seoul_building_jump_sequence_lighting" },
    { 0x8293, "setup_seoul_canal_start_lighting" },
    { 0x8294, "setup_seoul_drone_swarm_intro_lighting" },
    { 0x8295, "setup_seoul_fob_lighting" },
    { 0x8296, "setup_seoul_hotel_entrance_lighting" },
    { 0x8297, "setup_seoul_hotel_lighting" },
    { 0x8298, "setup_seoul_intro_lighting" },
    { 0x8299, "setup_seoul_jump_lighting" },
    { 0x829A, "setup_seoul_shopping_district_start_lighting" },
    { 0x829B, "setup_seoul_sinkhole_start_lighting" },
    { 0x829C, "setup_seoul_space_entry_lighting" },
    { 0x829D, "setup_seoul_subway_start_lighting" },
    { 0x829E, "setup_server_room_door_open_lighting" },
    { 0x829F, "setup_server_room_lighting" },
    { 0x82A0, "setup_server_room_scene_notetracks" },
    { 0x82A1, "setup_shg_fx" },
    { 0x82A2, "setup_shuffle_anim_array" },
    { 0x82A3, "setup_side_missile" },
    { 0x82A4, "setup_side_missile_prefab" },
    { 0x82A5, "setup_skyjack_anims" },
    { 0x82A6, "setup_skyjack_mag_glove_anims" },
    { 0x82A7, "setup_smart_grenade_pickups" },
    { 0x82A8, "setup_smash_nodes" },
    { 0x82A9, "setup_sniper_debug_hud_elem" },
    { 0x82AA, "setup_sniper_spawns" },
    { 0x82AB, "setup_snipers" },
    { 0x82AC, "setup_social_groups" },
    { 0x82AD, "setup_space_transport" },
    { 0x82AE, "setup_spawn_functions" },
    { 0x82AF, "setup_spawners" },
    { 0x82B0, "setup_squad_for_gameplay" },
    { 0x82B1, "setup_squad_for_scene" },
    { 0x82B2, "setup_squad_member_for_gameplay" },
    { 0x82B3, "setup_squad_member_for_scene" },
    { 0x82B4, "setup_standing_anim_array" },
    { 0x82B5, "setup_start_points" },
    { 0x82B6, "setup_start_points_for_transients" },
    { 0x82B7, "setup_start_transients" },
    { 0x82B8, "setup_start_vehicle_on_path" },
    { 0x82B9, "setup_street_reunion_spawners" },
    { 0x82BA, "setup_subsurface_scatter" },
    { 0x82BB, "setup_sunlight_off" },
    { 0x82BC, "setup_sunlight_off_volume" },
    { 0x82BD, "setup_tank" },
    { 0x82BE, "setup_tank_battle" },
    { 0x82BF, "setup_tanker_crash_notetrack" },
    { 0x82C0, "setup_team" },
    { 0x82C1, "setup_tff_cleanups" },
    { 0x82C2, "setup_tff_transitions" },
    { 0x82C3, "setup_threat_bias_groups" },
    { 0x82C4, "setup_threat_grenade_pickups" },
    { 0x82C5, "setup_threatbias_combat" },
    { 0x82C6, "setup_tour" },
    { 0x82C7, "setup_tour_hangar_doors_lighting" },
    { 0x82C8, "setup_tour_hangar_opening" },
    { 0x82C9, "setup_tour_ride_skin_spec_fix" },
    { 0x82CA, "setup_tracks_1" },
    { 0x82CB, "setup_tracks_2" },
    { 0x82CC, "setup_traffic_group" },
    { 0x82CD, "setup_traffic_path" },
    { 0x82CE, "setup_traffic_path_with_options" },
    { 0x82CF, "setup_traffic_spawner" },
    { 0x82D0, "setup_training_01_end_ambi_swap" },
    { 0x82D1, "setup_training_01_end_compound_ambi_emitter" },
    { 0x82D2, "setup_training_02_breach_smartglass" },
    { 0x82D3, "setup_training_2_breach" },
    { 0x82D4, "setup_training_2_drone" },
    { 0x82D5, "setup_training_2_heli_dof" },
    { 0x82D6, "setup_training_2_heli_lighting" },
    { 0x82D7, "setup_training_2_start_area_lighting" },
    { 0x82D8, "setup_training_2_suv_dof" },
    { 0x82D9, "setup_training_2_suv_fires" },
    { 0x82DA, "setup_training_sequence_1" },
    { 0x82DB, "setup_training_sequence_2" },
    { 0x82DC, "setup_training_start_area_dof" },
    { 0x82DD, "setup_training_start_area_lighting" },
    { 0x82DE, "setup_transient_transitions" },
    { 0x82DF, "setup_triggers" },
    { 0x82E0, "setup_triggers_street_battle" },
    { 0x82E1, "setup_turbine_room_outerspace_lighting" },
    { 0x82E2, "setup_turbine_room_pulsing_lights" },
    { 0x82E3, "setup_turret_anims" },
    { 0x82E4, "setup_underwater_dof" },
    { 0x82E5, "setup_vehicle_for_damage" },
    { 0x82E6, "setup_vehicle_spawners" },
    { 0x82E7, "setup_vehicles" },
    { 0x82E8, "setup_vehicles_for_middle_takedown" },
    { 0x82E9, "setup_vehicles_for_takedown" },
    { 0x82EA, "setup_vfx_lighting" },
    { 0x82EB, "setup_vfx_sunflare" },
    { 0x82EC, "setup_vignette" },
    { 0x82ED, "setup_vo" },
    { 0x82EE, "setup_vols" },
    { 0x82EF, "setup_wake_volumes" },
    { 0x82F0, "setup_wall_climb_foley" },
    { 0x82F1, "setup_wall_pull_anims" },
    { 0x82F2, "setup_wallpull" },
    { 0x82F3, "setup_warbird" },
    { 0x82F4, "setup_warbird_grapple_kill_anims" },
    { 0x82F5, "setup_water_crash" },
    { 0x82F6, "setup_window_explosion_wait" },
    { 0x82F7, "setup_worldhands_anims" },
    { 0x82F8, "setup_zipline_gun" },
    { 0x82F9, "setupaiforanimsequence" },
    { 0x82FA, "setupaiforendinganim" },
    { 0x82FB, "setupaim" },
    { 0x82FC, "setupaitargetmarkingvariables" },
    { 0x82FD, "setupalleysvo" },
    { 0x82FE, "setupamplifierdamagemonitor" },
    { 0x82FF, "setupapproachnode" },
    { 0x8300, "setupbetrayalportalscripting" },
    { 0x8301, "setupbigfinaleguys" },
    { 0x8302, "setupbombsquad" },
    { 0x8303, "setupbotsformapkillstreak" },
    { 0x8304, "setupcallbacks" },
    { 0x8305, "setupcarepackagedrone" },
    { 0x8306, "setupcloaking" },
    { 0x8307, "setupcommonassaultdroneproperties" },
    { 0x8308, "setupconfcentervo" },
    { 0x8309, "setupconvoycrashedvehicles" },
    { 0x830A, "setupcoopturret" },
    { 0x830B, "setupcqbpointsofinterest" },
    { 0x830C, "setupcranechem" },
    { 0x830D, "setupdamagecallback" },
    { 0x830E, "setupdamagecallbackinternal" },
    { 0x830F, "setupdamageflags" },
    { 0x8310, "setupdebughudelem" },
    { 0x8311, "setupdestructiblekillcaments" },
    { 0x8312, "setupdialogue" },
    { 0x8313, "setupdogstate" },
    { 0x8314, "setupdynamicevent" },
    { 0x8315, "setupenemygoalvolumesettings" },
    { 0x8316, "setupexploders" },
    { 0x8317, "setupexposedcombatloop" },
    { 0x8318, "setupfinalebarrier" },
    { 0x8319, "setupflightsounds" },
    { 0x831A, "setupfog" },
    { 0x831B, "setupforrandomspawn" },
    { 0x831C, "setupgaragedoor" },
    { 0x831D, "setupgates" },
    { 0x831E, "setuphadescrashedvehicle" },
    { 0x831F, "setupheavyresistancemodel" },
    { 0x8320, "setupholograms" },
    { 0x8321, "setupkillcament" },
    { 0x8322, "setupkillstreakdevgui" },
    { 0x8323, "setupledgefx" },
    { 0x8324, "setuplongpunch" },
    { 0x8325, "setupmaniac" },
    { 0x8326, "setupmeetingcivilians" },
    { 0x8327, "setupminimap" },
    { 0x8328, "setupmovement" },
    { 0x8329, "setupnearbyspawns" },
    { 0x832A, "setupoceanfoam" },
    { 0x832B, "setuporbitalstrike" },
    { 0x832C, "setupparkinginvestigators" },
    { 0x832D, "setupplayercommands" },
    { 0x832E, "setupplayerdeath" },
    { 0x832F, "setupplayerhud" },
    { 0x8330, "setupplayerinventory" },
    { 0x8331, "setupplayersduringstreak" },
    { 0x8332, "setupplayertargets" },
    { 0x8333, "setuppoolallytargets" },
    { 0x8334, "setuppoolkillvictim" },
    { 0x8335, "setupprisonturrets" },
    { 0x8336, "setupproneaim" },
    { 0x8337, "setupradar" },
    { 0x8338, "setuprandomtable" },
    { 0x8339, "setupriotsuppresionsystem" },
    { 0x833A, "setuprippablemodel" },
    { 0x833B, "setuprobotarmnotetracks" },
    { 0x833C, "setuprockets" },
    { 0x833D, "setuprocketswarm" },
    { 0x833E, "setupsavedactionslots" },
    { 0x833F, "setupshotgunkva" },
    { 0x8340, "setupsniperdebughudelem" },
    { 0x8341, "setupsuperexo" },
    { 0x8342, "setuptrophy" },
    { 0x8343, "setupuniqueanims" },
    { 0x8344, "setupvalidtargetsbyarray" },
    { 0x8345, "setupvalidtargetsbyname" },
    { 0x8346, "setupvehicleanims" },
    { 0x8347, "setupvfxgroup" },
    { 0x8348, "setupwarbirdhud" },
    { 0x8349, "setupwarbirdkillstreak" },
    { 0x834A, "setupwaves" },
    { 0x834B, "setupzones" },
    { 0x834C, "setusablebyteam" },
    { 0x834D, "setusehinttext" },
    { 0x834E, "setusetext" },
    { 0x834F, "setusetime" },
    { 0x8350, "setusingremote" },
    { 0x8351, "setvehgoalpos_wrap" },
    { 0x8352, "setvehgoalposauto" },
    { 0x8353, "setvehiclefx" },
    { 0x8354, "setvirtuallobbypresentable" },
    { 0x8355, "setvisibleteam" },
    { 0x8356, "setvulcanvisionandlightsetpermap" },
    { 0x8357, "setwaitingicons" },
    { 0x8358, "setwarbirdvisionsetpermap" },
    { 0x8359, "setweaponstat" },
    { 0x835A, "setweaponusagevariables" },
    { 0x835B, "setwidth" },
    { 0x835C, "setxenonranks" },
    { 0x835D, "severed_arm_anim" },
    { 0x835E, "sewer_exit_monitor_player_weapon_fire" },
    { 0x835F, "sewer_scene_backtrack_fail_send_in_flyers" },
    { 0x8360, "sewer_scene_backtrack_failure" },
    { 0x8361, "sewer_scene_checkpoint_fail_conditions" },
    { 0x8362, "sewer_scene_checkpoint_failed_player_jumped_down" },
    { 0x8363, "sewer_scene_checkpoint_failed_player_shot" },
    { 0x8364, "sewer_scene_checkpoint_failed_player_stayed_behind" },
    { 0x8365, "sewer_scene_checkpoint_failed_player_too_close" },
    { 0x8366, "sewer_scene_checkpoint_failed_player_went_back" },
    { 0x8367, "sewer_scene_checkpoint_guard_wakeup" },
    { 0x8368, "sewer_scene_checkpoint_handle_guard_wakeup" },
    { 0x8369, "sewer_scene_checkpoint_player_killvol_handling" },
    { 0x836A, "sewer_scene_chkpt_fail_extra_hunters" },
    { 0x836B, "sewer_scene_chkpt_fail_extra_hunters_setup" },
    { 0x836C, "sewer_scene_chkpt_fail_warbird" },
    { 0x836D, "sewer_scene_cleanup" },
    { 0x836E, "sewer_scene_dialogue_manager" },
    { 0x836F, "sewer_scene_drone_oppresion_fly" },
    { 0x8370, "sewer_scene_drone_surprise_ilona" },
    { 0x8371, "sewer_scene_drone_vehicle_setup" },
    { 0x8372, "sewer_scene_guards_alerted_wake_up_scene" },
    { 0x8373, "sewer_scene_handle_opression_event" },
    { 0x8374, "sewer_scene_ilona_movement_manager" },
    { 0x8375, "sewer_scene_manhole_backtrack_failure" },
    { 0x8376, "sewer_scene_manhole_interaction" },
    { 0x8377, "sewer_scene_manhole_spawn_swim_swarm" },
    { 0x8378, "sewer_scene_market_atlas_oppression_setup" },
    { 0x8379, "sewer_scene_market_bystander_oppression_setup" },
    { 0x837A, "sewer_scene_market_section" },
    { 0x837B, "sewer_scene_market_section_handle_ilona_move" },
    { 0x837C, "sewer_scene_market_vig_civ_init" },
    { 0x837D, "sewer_scene_master_handler" },
    { 0x837E, "sewer_scene_oppresion_guys" },
    { 0x837F, "sewer_scene_oppression_civ01" },
    { 0x8380, "sewer_scene_oppression_civ02" },
    { 0x8381, "sewer_scene_oppression_guard" },
    { 0x8382, "sewer_scene_scripted_objects" },
    { 0x8383, "sewer_scene_setup" },
    { 0x8384, "sewer_scene_setup_manholde_vignette_civs" },
    { 0x8385, "sewer_scene_spawn_guards_at_market_checkpoint" },
    { 0x8386, "sewer_scene_store_oppresion_guy" },
    { 0x8387, "sewer_scene_swim_cleanup" },
    { 0x8388, "sewer_scene_teleport_ilona_to_sewer_exit" },
    { 0x8389, "sewer_scene_vignette_actor_flee" },
    { 0x838A, "sewer_scene_vignette_bystander_react" },
    { 0x838B, "sf_b_bridge_burk" },
    { 0x838C, "sf_b_bridge_cormack" },
    { 0x838D, "sf_b_bridge_maddox" },
    { 0x838E, "sf_b_videolog" },
    { 0x838F, "sfa_generic_traffic_constructor" },
    { 0x8390, "sfb_end_logo" },
    { 0x8391, "sfb_intro_burke_foley" },
    { 0x8392, "sfb_intro_car_explode" },
    { 0x8393, "shack_explode" },
    { 0x8394, "shack_roof_damage_fx" },
    { 0x8395, "shader" },
    { 0x8396, "shader_height" },
    { 0x8397, "shader_width" },
    { 0x8398, "shadow_bar2_enter" },
    { 0x8399, "shadow_bar2_exit" },
    { 0x839A, "shadow_card" },
    { 0x839B, "shadow_destroyed_trigger_think" },
    { 0x839C, "shadow_godray_window_large_dim_think" },
    { 0x839D, "shadow_godray_window_large_think" },
    { 0x839E, "shadow_pos" },
    { 0x839F, "shadow_shopping_walkway_enter" },
    { 0x83A0, "shadow_shopping_walkway_exit" },
    { 0x83A1, "shadow_shopping_walkway_pre_enter" },
    { 0x83A2, "shadow_tag" },
    { 0x83A3, "shadow_tag_01" },
    { 0x83A4, "shadow_tag_02" },
    { 0x83A5, "shadow_tag_03" },
    { 0x83A6, "shadow_tag_05" },
    { 0x83A7, "shadow_tag_06" },
    { 0x83A8, "shadow_tag_07" },
    { 0x83A9, "shadow_tag_08" },
    { 0x83AA, "shadow_tag_09" },
    { 0x83AB, "shadow_tag_11" },
    { 0x83AC, "shaft_descent_end" },
    { 0x83AD, "shaft_descent_speed_update" },
    { 0x83AE, "shaft_descent_start" },
    { 0x83AF, "shaft_descent_state_change" },
    { 0x83B0, "shake_dist_threshold_" },
    { 0x83B1, "shake_duration" },
    { 0x83B2, "shake_durration_" },
    { 0x83B3, "shake_envelope_" },
    { 0x83B4, "shake_in_progress" },
    { 0x83B5, "shallow_water_weapon" },
    { 0x83B6, "shared_portable_turrets" },
    { 0x83B7, "shared_turrets" },
    { 0x83B8, "sharedevent" },
    { 0x83B9, "shark_functions" },
    { 0x83BA, "shelf" },
    { 0x83BB, "shell_fx" },
    { 0x83BC, "shell_sound" },
    { 0x83BD, "shell_sound_enabled" },
    { 0x83BE, "shellshock_audio_disabled" },
    { 0x83BF, "shellshock_time" },
    { 0x83C0, "shellshocked" },
    { 0x83C1, "shellshockondamage" },
    { 0x83C2, "shg_exploder_tendrils" },
    { 0x83C3, "shg_spawn_tendrils" },
    { 0x83C4, "shieldbroken" },
    { 0x83C5, "shieldbulletblockcount" },
    { 0x83C6, "shieldbulletblocklimit" },
    { 0x83C7, "shieldbulletblocktime" },
    { 0x83C8, "shieldbullethits" },
    { 0x83C9, "shielddamage" },
    { 0x83CA, "shieldmodelvariant" },
    { 0x83CB, "shift_car" },
    { 0x83CC, "ship" },
    { 0x83CD, "ship_explosion_rumble" },
    { 0x83CE, "ship_explosion_screenblur" },
    { 0x83CF, "ship_pos_wait_delay" },
    { 0x83D0, "shit_blocked_upstairs" },
    { 0x83D1, "shitloc" },
    { 0x83D2, "shock_distance" },
    { 0x83D3, "shock_ondeath" },
    { 0x83D4, "shocking_target" },
    { 0x83D5, "shockthink" },
    { 0x83D6, "shockwave_begin" },
    { 0x83D7, "shoot_at_ambulance" },
    { 0x83D8, "shoot_at_chopper" },
    { 0x83D9, "shoot_at_sentinel_agents" },
    { 0x83DA, "shoot_at_spots" },
    { 0x83DB, "shoot_at_these_targets" },
    { 0x83DC, "shoot_charge_bar" },
    { 0x83DD, "shoot_drone_at_ally" },
    { 0x83DE, "shoot_dude_through_window" },
    { 0x83DF, "shoot_enemy_until_he_hides_then_shoot_wall" },
    { 0x83E0, "shoot_mg42_script_targets" },
    { 0x83E1, "shoot_out_exo_windows_scaffolding_think" },
    { 0x83E2, "shoot_out_windows" },
    { 0x83E3, "shoot_player_if_facing" },
    { 0x83E4, "shoot_point_array" },
    { 0x83E5, "shoot_sam_missile" },
    { 0x83E6, "shoot_sam_missiles" },
    { 0x83E7, "shoot_tag" },
    { 0x83E8, "shoot_target_till_dead" },
    { 0x83E9, "shoot_while_driving_thread" },
    { 0x83EA, "shoot_while_moving_thread" },
    { 0x83EB, "shoot_while_ziplining" },
    { 0x83EC, "shootanimtime" },
    { 0x83ED, "shootastold" },
    { 0x83EE, "shootatshootentorpos" },
    { 0x83EF, "shootblankthread" },
    { 0x83F0, "shootcineturrets" },
    { 0x83F1, "shootdowncarepackage" },
    { 0x83F2, "shootenemy" },
    { 0x83F3, "shootenemytarget_bullets" },
    { 0x83F4, "shootenemytarget_bullets_debugline" },
    { 0x83F5, "shootenemywrapper" },
    { 0x83F6, "shootenemywrapper_func" },
    { 0x83F7, "shootenemywrapper_normal" },
    { 0x83F8, "shootenemywrapper_shootnotify" },
    { 0x83F9, "shootent" },
    { 0x83FA, "shootentvelocity" },
    { 0x83FB, "shootguy" },
    { 0x83FC, "shootguytargetmustdie" },
    { 0x83FD, "shooting_head_sway" },
    { 0x83FE, "shooting_range_enemy_shot" },
    { 0x83FF, "shooting_range_enemy_spawn" },
    { 0x8400, "shooting_range_floor_panels_off" },
    { 0x8401, "shooting_range_floor_panels_on" },
    { 0x8402, "shooting_range_friendly_shot" },
    { 0x8403, "shooting_range_friendly_spawn" },
    { 0x8404, "shooting_range_overdrive_watcher" },
    { 0x8405, "shooting_range_panels_down" },
    { 0x8406, "shooting_range_panels_up" },
    { 0x8407, "shooting_range_ramp_down_lighting" },
    { 0x8408, "shooting_range_ramp_up_lighting" },
    { 0x8409, "shooting_range_target_despawn" },
    { 0x840A, "shooting_range_transition1" },
    { 0x840B, "shooting_range_transition2" },
    { 0x840C, "shooting_range_transition3" },
    { 0x840D, "shootingrangeleaderboard" },
    { 0x840E, "shootkva" },
    { 0x840F, "shootkva_enemyindexer" },
    { 0x8410, "shootnotetrack" },
    { 0x8411, "shootobjective" },
    { 0x8412, "shootpos" },
    { 0x8413, "shootposoutsidelegalyawrange" },
    { 0x8414, "shootposoverride" },
    { 0x8415, "shootposwrapper" },
    { 0x8416, "shootposwrapper_func" },
    { 0x8417, "shootrateoverride" },
    { 0x8418, "shootstyle" },
    { 0x8419, "shootuntilneedtoturn" },
    { 0x841A, "shootuntilshootbehaviorchange" },
    { 0x841B, "shootuntilshootbehaviorchange_corner" },
    { 0x841C, "shootuntilshootbehaviorchange_coverwall" },
    { 0x841D, "shootuntilshootbehaviorchangefortime" },
    { 0x841E, "shootwhilemoving" },
    { 0x841F, "shootwhileturning" },
    { 0x8420, "shoping_district_ambientfx_aa_explosion" },
    { 0x8421, "shoping_district_ambientfx_midair_explosion" },
    { 0x8422, "shoping_district_ambientfx_windowglass_explosion" },
    { 0x8423, "shopping_district_glass_hit_after_smashed" },
    { 0x8424, "shopping_district_glass_smashed" },
    { 0x8425, "shopping_district_main" },
    { 0x8426, "shopping_district_objectives" },
    { 0x8427, "shopping_district_panel_smashed" },
    { 0x8428, "shopping_district_panel_swing" },
    { 0x8429, "shopping_district_turret_truck" },
    { 0x842A, "shore_ajani_run_in" },
    { 0x842B, "shore_ajani_walks_away" },
    { 0x842C, "shore_ending" },
    { 0x842D, "shore_gideon_grab_plr" },
    { 0x842E, "shore_gideon_moneys_worth" },
    { 0x842F, "shore_gideon_nudge" },
    { 0x8430, "shore_gideon_pickup_wpn" },
    { 0x8431, "shore_gideon_slap_plr" },
    { 0x8432, "shore_gideon_stand" },
    { 0x8433, "shore_gideon_turn" },
    { 0x8434, "shore_joker_helps_with_hostage" },
    { 0x8435, "shore_joker_nudges_hostage" },
    { 0x8436, "shore_joker_run_in" },
    { 0x8437, "shore_pcap" },
    { 0x8438, "shore_pcap_notetrack_setup" },
    { 0x8439, "shore_plr_grab_wpn" },
    { 0x843A, "shore_plr_slapped" },
    { 0x843B, "shore_plr_tries_to_get_up" },
    { 0x843C, "shortencolor" },
    { 0x843D, "shot_at_player" },
    { 0x843E, "shot_delay" },
    { 0x843F, "shot_endangers_any_player" },
    { 0x8440, "shot_endangers_player" },
    { 0x8441, "shotcount" },
    { 0x8442, "shotfired" },
    { 0x8443, "shotfiredphysicssphere" },
    { 0x8444, "shotgunabortdefendgoalonflag" },
    { 0x8445, "shotgunfirerate" },
    { 0x8446, "shotgunpumpsound" },
    { 0x8447, "shotgunswitchfinish" },
    { 0x8448, "shotgunswitchstandruninternal" },
    { 0x8449, "shots_fired" },
    { 0x844A, "shots_fired_recorder" },
    { 0x844B, "shots_hit" },
    { 0x844C, "shotsafterplayerbecomesinvul" },
    { 0x844D, "shotsatzerospeed" },
    { 0x844E, "shotsfired" },
    { 0x844F, "shotshit" },
    { 0x8450, "should_abort" },
    { 0x8451, "should_be_vehicle" },
    { 0x8452, "should_break_boost_jump_hint" },
    { 0x8453, "should_break_crouch_hint" },
    { 0x8454, "should_break_disable_nvg_print" },
    { 0x8455, "should_break_dont_leave" },
    { 0x8456, "should_break_dont_leave_squad" },
    { 0x8457, "should_break_end_jump_hint" },
    { 0x8458, "should_break_leave_mission_hint" },
    { 0x8459, "should_break_move_hint" },
    { 0x845A, "should_break_on_throw" },
    { 0x845B, "should_break_recover_hint" },
    { 0x845C, "should_break_recover_hint_command" },
    { 0x845D, "should_break_recover_hint_movement" },
    { 0x845E, "should_break_release_mt_missiles" },
    { 0x845F, "should_break_swim_hint" },
    { 0x8460, "should_break_tappy_hint" },
    { 0x8461, "should_break_threat_hint" },
    { 0x8462, "should_break_use_mt_fire" },
    { 0x8463, "should_break_use_mt_missiles" },
    { 0x8464, "should_delay_flag_decision" },
    { 0x8465, "should_display_melee_hint" },
    { 0x8466, "should_do_car_alarm" },
    { 0x8467, "should_end_align_hint" },
    { 0x8468, "should_end_fastzip_fire_hint" },
    { 0x8469, "should_end_fastzip_hint" },
    { 0x846A, "should_end_laser_hint" },
    { 0x846B, "should_end_pdrone_fail_hint" },
    { 0x846C, "should_end_pdrone_hint" },
    { 0x846D, "should_end_sonar_hint" },
    { 0x846E, "should_give_orghealth" },
    { 0x846F, "should_growl" },
    { 0x8470, "should_hide_bullet_immunity_hint" },
    { 0x8471, "should_hide_melee_hint" },
    { 0x8472, "should_hide_missiles_hint" },
    { 0x8473, "should_hide_turret_hint" },
    { 0x8474, "should_pause_yaw_anim" },
    { 0x8475, "should_play_animations" },
    { 0x8476, "should_record_final_score_cam" },
    { 0x8477, "should_register_kills_for_vehicle_occupants" },
    { 0x8478, "should_reverse_controls" },
    { 0x8479, "should_select_new_ambush_point" },
    { 0x847A, "should_show_cover_warning" },
    { 0x847B, "should_show_hud_element" },
    { 0x847C, "should_show_prompt" },
    { 0x847D, "should_squelch" },
    { 0x847E, "should_start_cautious_approach_default" },
    { 0x847F, "should_start_cautious_approach_dom" },
    { 0x8480, "should_start_cautious_approach_hp" },
    { 0x8481, "should_start_cautious_approach_sd" },
    { 0x8482, "should_stop_seeking_weapon" },
    { 0x8483, "should_take_selfie" },
    { 0x8484, "should_topoff_breach_weapon" },
    { 0x8485, "shouldaffectclaymore" },
    { 0x8486, "shouldattackidle" },
    { 0x8487, "shouldattemptstumblingpain" },
    { 0x8488, "shouldaveragetotal" },
    { 0x8489, "shouldbeajerk" },
    { 0x848A, "shouldbreaknvghintprint" },
    { 0x848B, "shouldchangestanceforfun" },
    { 0x848C, "shouldconserveammotime" },
    { 0x848D, "shouldcoveridle" },
    { 0x848E, "shouldcqb" },
    { 0x848F, "shoulddamagerocket" },
    { 0x8490, "shoulddoarrivals" },
    { 0x8491, "shoulddodirectedenergydeath" },
    { 0x8492, "shoulddoextendedkill" },
    { 0x8493, "shoulddorunningforwarddeath" },
    { 0x8494, "shoulddosemiforvariety" },
    { 0x8495, "shoulddosharpturns" },
    { 0x8496, "shoulddostrongbulletdamage" },
    { 0x8497, "shoulddostrongmeleedamage" },
    { 0x8498, "shoulddroprocketlauncher" },
    { 0x8499, "shouldfacenodedir" },
    { 0x849A, "shouldfade" },
    { 0x849B, "shouldfireattarget" },
    { 0x849C, "shouldfirewhilechangingpose" },
    { 0x849D, "shouldforcedisablelaser" },
    { 0x849E, "shouldforcesnipermissshot" },
    { 0x849F, "shouldhelpadvancingteammate" },
    { 0x84A0, "shouldkeepcrawling" },
    { 0x84A1, "shouldlean" },
    { 0x84A2, "shouldloopdamagefeedback" },
    { 0x84A3, "shouldnt_spawn_because_of_script_difficulty" },
    { 0x84A4, "shouldpingobject" },
//  { 0x84A5, "" },
//  { 0x84A6, "" },
    { 0x84A7, "shouldplaysplash" },
    { 0x84A8, "shouldpreventearlyuse" },
    { 0x84A9, "shouldresetgiveuponsuppressiontimer" },
    { 0x84AA, "shouldreturntocover" },
    { 0x84AB, "shouldrunserversideeffects" },
    { 0x84AC, "shouldshootenemyent" },
    { 0x84AD, "shouldshowcompassduetoradar" },
    { 0x84AE, "shouldsighttracewait" },
    { 0x84AF, "shouldsniff" },
    { 0x84B0, "shouldsortscoresinascendingorder" },
    { 0x84B1, "shouldspawnbots" },
    { 0x84B2, "shouldspawntags" },
    { 0x84B3, "shouldsplash" },
    { 0x84B4, "shouldsprint" },
    { 0x84B5, "shouldsprintforvariation" },
    { 0x84B6, "shouldstayalive" },
    { 0x84B7, "shouldstopambushing" },
    { 0x84B8, "shouldstopproximityalarm" },
    { 0x84B9, "shouldsuppress" },
    { 0x84BA, "shouldswapshotgun" },
    { 0x84BB, "shouldswitchweaponafterraiseanimation" },
    { 0x84BC, "shouldswitchweaponpostkillstreak" },
    { 0x84BD, "shouldupdateluadisplay" },
    { 0x84BE, "shoulduseteamstartspawn" },
    { 0x84BF, "shouldwaitincombatidle" },
    { 0x84C0, "shouldweaponfeedback" },
    { 0x84C1, "show_attached_clone_model" },
    { 0x84C2, "show_avatar" },
    { 0x84C3, "show_avatars" },
    { 0x84C4, "show_bad_path" },
    { 0x84C5, "show_blurry_rotors" },
    { 0x84C6, "show_brake_hint" },
    { 0x84C7, "show_city_vista" },
    { 0x84C8, "show_cloaked_warbird" },
    { 0x84C9, "show_crash_traffic" },
    { 0x84CA, "show_decloaking_warbird" },
    { 0x84CB, "show_detailed_cloak_enemy_state" },
    { 0x84CC, "show_down_arrow" },
    { 0x84CD, "show_entity" },
    { 0x84CE, "show_ents_by_targetname" },
    { 0x84CF, "show_exec_title_credits" },
    { 0x84D0, "show_exo_cloak_hint" },
    { 0x84D1, "show_exploder_models" },
    { 0x84D2, "show_exploder_models_proc" },
    { 0x84D3, "show_fail_range_hint_1" },
    { 0x84D4, "show_fail_range_hint_2" },
    { 0x84D5, "show_fallen_bridge" },
    { 0x84D6, "show_far_bridge" },
    { 0x84D7, "show_finale_jet" },
    { 0x84D8, "show_glowy_handles" },
    { 0x84D9, "show_grenade_hint" },
    { 0x84DA, "show_help" },
    { 0x84DB, "show_hidden_rail" },
    { 0x84DC, "show_hide_plant_vista" },
    { 0x84DD, "show_hide_plant_vista_intro" },
    { 0x84DE, "show_hint" },
    { 0x84DF, "show_hologram" },
    { 0x84E0, "show_hologram_reveal" },
    { 0x84E1, "show_icon" },
    { 0x84E2, "show_land_assist_help" },
    { 0x84E3, "show_left_arrow" },
    { 0x84E4, "show_me_now" },
    { 0x84E5, "show_mech_screen" },
    { 0x84E6, "show_middle_civs_now" },
    { 0x84E7, "show_navy_boats" },
    { 0x84E8, "show_non_owner_avatars" },
    { 0x84E9, "show_normal_handles" },
    { 0x84EA, "show_plant_vista_intro" },
    { 0x84EB, "show_plant_vista_via_trigger" },
    { 0x84EC, "show_player_hud" },
    { 0x84ED, "show_primer_fx" },
    { 0x84EE, "show_reverse_tutorial" },
    { 0x84EF, "show_reverse_tutorial_check" },
    { 0x84F0, "show_right_arrow" },
    { 0x84F1, "show_shg_title_credits" },
    { 0x84F2, "show_solid" },
    { 0x84F3, "show_static_rotors" },
    { 0x84F4, "show_stuck_fanfare" },
    { 0x84F5, "show_subtitles" },
    { 0x84F6, "show_throw_hint_close_to_turret" },
    { 0x84F7, "show_turret" },
    { 0x84F8, "show_up_arrow" },
    { 0x84F9, "show_uplink" },
    { 0x84FA, "show_video_on_driverside" },
    { 0x84FB, "show_water_final" },
    { 0x84FC, "show_water_intro" },
    { 0x84FD, "show_weaponhud" },
    { 0x84FE, "showaerialmarker" },
    { 0x84FF, "showakimbodelayed" },
    { 0x8500, "showammocount" },
    { 0x8501, "showapart" },
    { 0x8502, "showattachmentsaftercloak" },
    { 0x8503, "showblockedhud" },
    { 0x8504, "showboatshadows" },
    { 0x8505, "showclaimed" },
    { 0x8506, "showdebugline" },
    { 0x8507, "showdebugproc" },
    { 0x8508, "showdebugradius" },
    { 0x8509, "showdebugtoggle" },
    { 0x850A, "showdebugtrace" },
    { 0x850B, "showdroppodbadspawnoverlay" },
    { 0x850C, "showdroppodfx" },
    { 0x850D, "showelem" },
    { 0x850E, "showentnotetrack" },
    { 0x850F, "showfirehideaimidle" },
    { 0x8510, "showfriendicon" },
    { 0x8511, "showfxtoteam" },
    { 0x8512, "showgascloud" },
    { 0x8513, "showgenericmenuonmatchstart" },
    { 0x8514, "showgeo" },
    { 0x8515, "showheadicon" },
    { 0x8516, "showhint" },
    { 0x8517, "showhintprint_struct" },
    { 0x8518, "showing_damage" },
    { 0x8519, "showingfinalkillcam" },
    { 0x851A, "showintermissiontimer" },
    { 0x851B, "showlastenemysightpos" },
    { 0x851C, "showline" },
    { 0x851D, "showlines" },
    { 0x851E, "showlist" },
    { 0x851F, "showloadoutmenu" },
    { 0x8520, "showmainmenuforteam" },
    { 0x8521, "showmodels" },
    { 0x8522, "shownextroundmessage" },
    { 0x8523, "showninfected" },
    { 0x8524, "shownotifymessage" },
    { 0x8525, "showorbitalstrikehud" },
    { 0x8526, "showoverlaystoplayer" },
    { 0x8527, "showplacedmodel" },
    { 0x8528, "showplayericons" },
    { 0x8529, "showpoddroppingfxtoplayer" },
    { 0x852A, "showpodgroundfxtoplayer" },
    { 0x852B, "showprimarydelayed" },
    { 0x852C, "showreticletoenemies" },
    { 0x852D, "showroundmeshmesh" },
    { 0x852E, "showsetbacksplash" },
    { 0x852F, "showspawnnotifies" },
    { 0x8530, "showstart" },
    { 0x8531, "showstate" },
    { 0x8532, "showstatic" },
    { 0x8533, "showteamsplashhorde" },
    { 0x8534, "showthreat" },
    { 0x8535, "showthreathintagainifplayerisbeingdumb" },
    { 0x8536, "showthreatmarker" },
    { 0x8537, "showtimer" },
    { 0x8538, "showtoteam" },
    { 0x8539, "showtransition" },
    { 0x853A, "showtransition_cg" },
    { 0x853B, "showtransitionrev" },
    { 0x853C, "shrike_contact" },
    { 0x853D, "shrike_flyby" },
    { 0x853E, "shrike_flyby_03" },
    { 0x853F, "shrike_flyby_pair_01" },
    { 0x8540, "shrike_flyby_pair_02" },
    { 0x8541, "shrike_flyby_pair_04" },
    { 0x8542, "shrike_hanger_flyby" },
    { 0x8543, "shrike_railgun_flyby_01" },
    { 0x8544, "shrike_railgun_flyby_02" },
    { 0x8545, "shrike_railgun_flyby_03" },
    { 0x8546, "shrike_takeoff" },
    { 0x8547, "shrike_takeoff_cg" },
    { 0x8548, "shufflekillstreaksdown" },
    { 0x8549, "shufflekillstreaksup" },
    { 0x854A, "shufflemove" },
    { 0x854B, "shufflemoveinterrupted" },
    { 0x854C, "shufflenode" },
    { 0x854D, "shufflezones" },
    { 0x854E, "shutdown_battlechatter" },
    { 0x854F, "shutdown_fx_enemy" },
    { 0x8550, "shutdown_fx_friendly" },
    { 0x8551, "shutdown_squadbattlechatter" },
    { 0x8552, "shutdowncontact" },
    { 0x8553, "shutdownround" },
    { 0x8554, "shutoffallplayersexobuffs" },
    { 0x8555, "shutoffamplifyobjectvfx" },
    { 0x8556, "shutoffexobuffs" },
    { 0x8557, "shutofffx" },
    { 0x8558, "shutoffhealth" },
    { 0x8559, "shutoffplayerhudoutline" },
    { 0x855A, "shutoffslam" },
    { 0x855B, "shutoffspeed" },
    { 0x855C, "shutterwanderleft" },
    { 0x855D, "shutterwanderright" },
    { 0x855E, "side_arm_array" },
    { 0x855F, "side_b_visionset_reset" },
    { 0x8560, "sidearm" },
    { 0x8561, "sideisleftright" },
    { 0x8562, "sidesteprate" },
    { 0x8563, "sidewinder_explode_impact" },
    { 0x8564, "sidewinder_missile" },
    { 0x8565, "sight_check" },
    { 0x8566, "sight_distsqrd" },
    { 0x8567, "sight_ignore" },
    { 0x8568, "sight_lost_time" },
    { 0x8569, "sighting_think" },
    { 0x856A, "sightpos" },
    { 0x856B, "sightposleft" },
    { 0x856C, "sightpostime" },
    { 0x856D, "sighttime" },
    { 0x856E, "sighttracepoint" },
    { 0x856F, "sigmoid" },
    { 0x8570, "sign" },
    { 0x8571, "sign_explosion_flash_damage" },
    { 0x8572, "sign_flash_damage" },
    { 0x8573, "signal_turn_guy" },
    { 0x8574, "signed_distance_to_plane" },
    { 0x8575, "silentplant" },
    { 0x8576, "silo_approach_logic" },
    { 0x8577, "silo_autosaves" },
    { 0x8578, "silo_autosaves_safety" },
    { 0x8579, "silo_catwalk_clip" },
    { 0x857A, "silo_catwalks" },
    { 0x857B, "silo_catwalks_open" },
    { 0x857C, "silo_collapse_plr_stunned" },
    { 0x857D, "silo_door_kick" },
    { 0x857E, "silo_door_kick_logic" },
    { 0x857F, "silo_exhaust_entrance_logic" },
    { 0x8580, "silo_floor_03_logic" },
    { 0x8581, "silo_lobby_logic" },
    { 0x8582, "silo_p1" },
    { 0x8583, "silo_rocket_blowup" },
    { 0x8584, "silo_sky_bridge_logic" },
    { 0x8585, "simcurrentgendynamicexpossure" },
    { 0x8586, "simple_and_lazy_flank_check" },
    { 0x8587, "simple_anim_at_struct" },
    { 0x8588, "simple_drone_health" },
    { 0x8589, "simple_player_rumble_heavy" },
    { 0x858A, "simple_player_rumble_light" },
    { 0x858B, "simple_player_rumble_medium" },
    { 0x858C, "single_ally_heli" },
    { 0x858D, "single_heli_tower" },
    { 0x858E, "single_loop_handle_index" },
    { 0x858F, "single_loops" },
    { 0x8590, "single_zone_spawns" },
    { 0x8591, "singleanimation" },
    { 0x8592, "singlebreacher" },
    { 0x8593, "sinkhole_ambientfx_aa_explosions" },
    { 0x8594, "sinkhole_ambientfx_midair_explosions" },
    { 0x8595, "sinkhole_ambientfx_windowglass_explosions" },
    { 0x8596, "sinkhole_civ_vicitim_group" },
    { 0x8597, "sinkhole_crashed_truck_rotation" },
    { 0x8598, "sinkhole_drone_intro" },
    { 0x8599, "sinkhole_drones" },
    { 0x859A, "sinkhole_drones_attack_civilians" },
    { 0x859B, "sinkhole_drones_group2" },
    { 0x859C, "sinkhole_drones_group4_spawn" },
    { 0x859D, "sinkhole_drones_start" },
    { 0x859E, "sinkhole_fracture" },
    { 0x859F, "sinkhole_jets" },
    { 0x85A0, "sinkhole_make_piece_break" },
    { 0x85A1, "sinkhole_make_piece_break_and_sink" },
    { 0x85A2, "sinkhole_make_piece_fall" },
    { 0x85A3, "sinkhole_section" },
    { 0x85A4, "sinkhole_smoke_ambush_enemy_think" },
    { 0x85A5, "sinkhole_smoke_ambush_event" },
    { 0x85A6, "sinkhole_smoke_grenade_loop" },
    { 0x85A7, "sinkhole_spawn_attack_drones" },
    { 0x85A8, "sinkhole_subway_vo_think" },
    { 0x85A9, "sinkhole_threat_hint" },
    { 0x85AA, "sinkhole_truck_explode" },
    { 0x85AB, "sinkhole_truck_fall" },
    { 0x85AC, "sinkhole_truck_fall_badly" },
    { 0x85AD, "sinkhole_weapon_platform" },
    { 0x85AE, "sinkhole_weapons_platform_scene" },
    { 0x85AF, "siren_distant" },
    { 0x85B0, "sirentag" },
    { 0x85B1, "sittag" },
    { 0x85B2, "sittag_offset" },
    { 0x85B3, "sittag_on_turret" },
    { 0x85B4, "skip_breach" },
    { 0x85B5, "skip_foam_corridor" },
    { 0x85B6, "skip_helicopter_death_logic" },
    { 0x85B7, "skip_juggernaut_intro_sound" },
    { 0x85B8, "skip_moves" },
    { 0x85B9, "skip_pilot_kill_count" },
    { 0x85BA, "skip_start_transition" },
    { 0x85BB, "skipanimbaseddeath" },
    { 0x85BC, "skipbloodpool" },
    { 0x85BD, "skipdeathanim" },
    { 0x85BE, "skipendingidle" },
    { 0x85BF, "skiplivesxpscalar" },
    { 0x85C0, "skipmodelswapdeath" },
    { 0x85C1, "skipoceanspawns" },
    { 0x85C2, "skippedkillcam" },
    { 0x85C3, "skippointdisplayxp" },
    { 0x85C4, "skiprocketemp" },
    { 0x85C5, "skipssuccess" },
    { 0x85C6, "skipstartmove" },
    { 0x85C7, "skr_distant_pull_up_and_scan" },
    { 0x85C8, "sky_booms" },
    { 0x85C9, "sky_bridge_dof" },
    { 0x85CA, "sky_nodes" },
    { 0x85CB, "skybox_manager" },
    { 0x85CC, "skybridge" },
    { 0x85CD, "skybridge_ambient_aa_explosions" },
    { 0x85CE, "skybridge_ambient_explosions" },
    { 0x85CF, "skycolor" },
    { 0x85D0, "skyfogintensity" },
    { 0x85D1, "skyfogmaxangle" },
    { 0x85D2, "skyfogminangle" },
    { 0x85D3, "skyintensityscaleev" },
    { 0x85D4, "skyj_intro_black" },
    { 0x85D5, "skyj_part_1" },
    { 0x85D6, "skyj_part_2" },
    { 0x85D7, "skyj_part_3" },
    { 0x85D8, "skyj_part_4" },
    { 0x85D9, "skyjack_animnode" },
    { 0x85DA, "skyjack_atlas_jet_fx" },
    { 0x85DB, "skyjack_charge_activate" },
    { 0x85DC, "skyjack_charge_fx" },
    { 0x85DD, "skyjack_charge_impact" },
    { 0x85DE, "skyjack_charge_laser_guide" },
    { 0x85DF, "skyjack_charge_laser_turn" },
    { 0x85E0, "skyjack_charge_legs" },
    { 0x85E1, "skyjack_charge_opens" },
    { 0x85E2, "skyjack_charges" },
    { 0x85E3, "skyjack_charges_nag_vo" },
    { 0x85E4, "skyjack_cormack" },
    { 0x85E5, "skyjack_cormack_impact_plane" },
    { 0x85E6, "skyjack_cormack_jetpack_boost" },
    { 0x85E7, "skyjack_cormack_jetpack_off" },
    { 0x85E8, "skyjack_cormack_jetpack_on" },
    { 0x85E9, "skyjack_cormack_land_on_plane" },
    { 0x85EA, "skyjack_cormack_left_knee" },
    { 0x85EB, "skyjack_cormack_mag_hand_left" },
    { 0x85EC, "skyjack_cormack_mag_hand_right" },
    { 0x85ED, "skyjack_cormack_push_off_plane" },
    { 0x85EE, "skyjack_cormack_right_knee" },
    { 0x85EF, "skyjack_dialogue" },
    { 0x85F0, "skyjack_drone_chutes" },
    { 0x85F1, "skyjack_drone_fx" },
    { 0x85F2, "skyjack_drone_jets_off" },
    { 0x85F3, "skyjack_drone_jets_on" },
    { 0x85F4, "skyjack_drone_pod" },
    { 0x85F5, "skyjack_expl_start" },
    { 0x85F6, "skyjack_gloveoff" },
    { 0x85F7, "skyjack_gloveon" },
    { 0x85F8, "skyjack_objective" },
    { 0x85F9, "skyjack_plane" },
    { 0x85FA, "skyjack_plane_contrails" },
    { 0x85FB, "skyjack_plane_cut" },
    { 0x85FC, "skyjack_plane_debris" },
    { 0x85FD, "skyjack_plane_explosion" },
    { 0x85FE, "skyjack_player" },
    { 0x85FF, "skyjack_player_activate_charge" },
    { 0x8600, "skyjack_player_charge_planted" },
    { 0x8601, "skyjack_player_fall" },
    { 0x8602, "skyjack_player_hand_on_charge" },
    { 0x8603, "skyjack_player_impact_plane" },
    { 0x8604, "skyjack_player_open_charge" },
    { 0x8605, "skyjack_player_push_off_plane" },
    { 0x8606, "skyjack_player_set_charge" },
    { 0x8607, "skyjack_player_wrist" },
    { 0x8608, "skyjack_wing_explosion" },
    { 0x8609, "skylight" },
    { 0x860A, "skylighthdr" },
    { 0x860B, "slam_hint_breakout" },
    { 0x860C, "slam_ragdoll_vel" },
    { 0x860D, "slate_fin_gideon_bar_break" },
    { 0x860E, "slate_fin_gideon_hatch_grab" },
    { 0x860F, "slate_fin_gideon_hatch_open" },
    { 0x8610, "slate_fin_gideon_hatch_push" },
    { 0x8611, "slate_fin_piston_l_break" },
    { 0x8612, "slate_fin_piston_r_break" },
    { 0x8613, "slate_fin_vm_bar_break" },
    { 0x8614, "slate_fin_vm_hatch_grab" },
    { 0x8615, "slate_fin_vm_hatch_pull" },
    { 0x8616, "slate_fin_vm_hatch_pull_loop" },
    { 0x8617, "slate_fin_vm_pull_relax" },
    { 0x8618, "slate_finale_gideon_hatch_pull_1" },
    { 0x8619, "slate_finale_gideon_hatch_pull_2" },
    { 0x861A, "slate_finale_gideon_hatch_pull_3" },
    { 0x861B, "slate_finale_gideon_hatch_regrip_1" },
    { 0x861C, "slate_finale_gideon_hatch_regrip_2" },
    { 0x861D, "slate_finale_gideon_hatch_regrip_3" },
    { 0x861E, "slate_gideon_wave_hand_plant" },
    { 0x861F, "slate_gideon_wave_hand_raise" },
    { 0x8620, "slate_gideon_wave_hand_regrip" },
    { 0x8621, "sleepingguardcustombloodspray" },
    { 0x8622, "slide_across_car_dog" },
    { 0x8623, "slide_across_car_human" },
    { 0x8624, "slide_dampening" },
    { 0x8625, "slide_gate_destroyed" },
    { 0x8626, "slide_gate_left" },
    { 0x8627, "slide_gate_right" },
    { 0x8628, "slidefortime" },
    { 0x8629, "slidemodel" },
    { 0x862A, "slidetriggerplayerthink" },
    { 0x862B, "sliding_door" },
    { 0x862C, "sliding_door_state" },
    { 0x862D, "slomo_breach_vision_change" },
    { 0x862E, "slomo_difficulty_dvars" },
    { 0x862F, "slomo_sound_scale_setup" },
    { 0x8630, "slomobasevision" },
    { 0x8631, "slomobreachduration" },
    { 0x8632, "slomobreachplayerspeed" },
    { 0x8633, "sloppy_kill_vo" },
    { 0x8634, "slot" },
    { 0x8635, "slow_allies_while_videolog_plays" },
    { 0x8636, "slow_plane_controls" },
    { 0x8637, "slow_player_inside" },
    { 0x8638, "slow_player_scaler" },
    { 0x8639, "slow_trig" },
    { 0x863A, "slowmo" },
    { 0x863B, "slowmo_begins" },
    { 0x863C, "slowmo_breach_damage_trigger_think" },
    { 0x863D, "slowmo_breach_disable_stancemod" },
    { 0x863E, "slowmo_breach_init" },
    { 0x863F, "slowmo_breach_start_delay" },
    { 0x8640, "slowmo_breach_think" },
    { 0x8641, "slowmo_end" },
    { 0x8642, "slowmo_in_wait_function" },
    { 0x8643, "slowmo_lerp_in" },
    { 0x8644, "slowmo_lerp_out" },
    { 0x8645, "slowmo_player_cleanup" },
    { 0x8646, "slowmo_setlerptime_in" },
    { 0x8647, "slowmo_setlerptime_out" },
    { 0x8648, "slowmo_setspeed_norm" },
    { 0x8649, "slowmo_setspeed_slow" },
    { 0x864A, "slowmo_speed" },
    { 0x864B, "slowmo_start" },
    { 0x864C, "slowmo_system_defaults" },
    { 0x864D, "slowmo_system_init" },
    { 0x864E, "slowmo_viewhands" },
    { 0x864F, "slowmodelay" },
    { 0x8650, "slowmodelta" },
    { 0x8651, "slowmospeed" },
    { 0x8652, "slowmostop" },
    { 0x8653, "slowmotiontowerdestruction" },
    { 0x8654, "sm_get_current_ambience_name" },
    { 0x8655, "sm_get_current_music_name" },
    { 0x8656, "sm_init" },
    { 0x8657, "sm_mix_ambience" },
    { 0x8658, "sm_start_music" },
    { 0x8659, "sm_start_preset" },
    { 0x865A, "sm_stop_ambience" },
    { 0x865B, "sm_stop_ambient_alias" },
    { 0x865C, "sm_stop_music" },
    { 0x865D, "sm_stop_music_alias" },
    { 0x865E, "smallesthole" },
    { 0x865F, "smallestoccluder" },
    { 0x8660, "smart_dialogue" },
    { 0x8661, "smart_dialogue_generic" },
    { 0x8662, "smart_drone_think" },
    { 0x8663, "smart_grenade_detonate" },
    { 0x8664, "smart_grenade_target_expire" },
    { 0x8665, "smart_grenade_target_flip" },
    { 0x8666, "smart_grenade_target_flip_down" },
    { 0x8667, "smart_grenade_target_hit" },
    { 0x8668, "smart_grenade_target_move" },
    { 0x8669, "smart_grenade_target_move_back" },
    { 0x866A, "smart_grenade_target_shot" },
    { 0x866B, "smart_grenade_training" },
    { 0x866C, "smart_hint" },
    { 0x866D, "smart_hint_breakout" },
    { 0x866E, "smart_hint_think" },
    { 0x866F, "smart_radio_dialogue" },
    { 0x8670, "smart_radio_dialogue_interrupt" },
    { 0x8671, "smart_radio_dialogue_mb" },
    { 0x8672, "smart_radio_dialogue_overlap" },
    { 0x8673, "smartlasersystem" },
    { 0x8674, "smartstance" },
    { 0x8675, "smash_obj" },
    { 0x8676, "smash_spot" },
    { 0x8677, "smash_surface_float" },
    { 0x8678, "smash_throw" },
    { 0x8679, "smash_throw_2" },
    { 0x867A, "smash_throw_active" },
    { 0x867B, "smash_throw_solo" },
    { 0x867C, "smashed" },
    { 0x867D, "smaw_laser_think" },
    { 0x867E, "smaw_location" },
    { 0x867F, "smeansofdeath" },
    { 0x8680, "smoke_ambush_enemies" },
    { 0x8681, "smoke_clear_basement_bones" },
    { 0x8682, "smoke_detect" },
    { 0x8683, "smoke_exhale" },
    { 0x8684, "smoke_grenade_death" },
    { 0x8685, "smoke_puff" },
    { 0x8686, "smoke_thrown" },
    { 0x8687, "smokegrenades" },
    { 0x8688, "smokepillar1" },
    { 0x8689, "smokepillar2" },
    { 0x868A, "smokepillar3" },
    { 0x868B, "smokescreenemitterfx" },
    { 0x868C, "smokethrown" },
    { 0x868D, "smoking_civ" },
    { 0x868E, "smoking_civ_panic" },
    { 0x868F, "smooth_down" },
    { 0x8690, "smooth_limit" },
    { 0x8691, "smooth_player_link" },
    { 0x8692, "smooth_target_position" },
    { 0x8693, "smooth_target_velocity" },
    { 0x8694, "smooth_up" },
    { 0x8695, "smooth_veh_play" },
    { 0x8696, "smooth_vehicle_animation_play" },
    { 0x8697, "smooth_vehicle_animation_wait" },
    { 0x8698, "smoothed_input" },
    { 0x8699, "smoothness" },
    { 0x869A, "smx_clear_struct" },
    { 0x869B, "smx_create_struct" },
    { 0x869C, "smx_set_values_for_struct" },
    { 0x869D, "snake_cheap_death" },
    { 0x869E, "snake_choose_next_point" },
    { 0x869F, "snake_cloud" },
    { 0x86A0, "snake_cloud_get_target_boids" },
    { 0x86A1, "snake_cloud_goto_points" },
    { 0x86A2, "snake_cloud_pester_helicopter" },
    { 0x86A3, "snake_cloud_resume_dynamic_control" },
    { 0x86A4, "snake_cloud_set_boid_settings" },
    { 0x86A5, "snake_cloud_stop_dynamic_control" },
    { 0x86A6, "snake_cloud_teleport_to_point" },
    { 0x86A7, "snake_crash_into_player" },
    { 0x86A8, "snake_crash_into_player_after_timeout" },
    { 0x86A9, "snake_dyanamic_control" },
    { 0x86AA, "snake_fight_before_turret" },
    { 0x86AB, "snake_fight_walker_tank" },
    { 0x86AC, "snake_follow_player" },
    { 0x86AD, "snake_gameplay_for_turret" },
    { 0x86AE, "snake_goal_origin" },
    { 0x86AF, "snake_kamikaze_control" },
    { 0x86B0, "snake_pester_helicopter" },
    { 0x86B1, "snake_pick_intro_path" },
    { 0x86B2, "snake_points" },
    { 0x86B3, "snake_points_center" },
    { 0x86B4, "snake_set_boid_settings" },
    { 0x86B5, "snake_set_points" },
    { 0x86B6, "snake_shoot_allies" },
    { 0x86B7, "snake_shoot_ambient" },
    { 0x86B8, "snake_speed_override" },
    { 0x86B9, "snake_strafe_player_gets_cardoor" },
    { 0x86BA, "snake_swarm_attack_vehicle" },
    { 0x86BB, "snake_swarm_speed_scale" },
    { 0x86BC, "snakeisinfrontofplayer" },
    { 0x86BD, "snakes" },
    { 0x86BE, "snakes_attacking_turret" },
    { 0x86BF, "snap_lock_turret_onto_target" },
    { 0x86C0, "snap2normal" },
    { 0x86C1, "snap90deg" },
    { 0x86C2, "snd_advanced_flyby_system" },
    { 0x86C3, "snd_air_vehicle_smart_flyby" },
    { 0x86C4, "snd_ambient_explosion" },
    { 0x86C5, "snd_clear_filter" },
    { 0x86C6, "snd_cloak_init" },
    { 0x86C7, "snd_common_init" },
    { 0x86C8, "snd_cover_drone_constructor" },
    { 0x86C9, "snd_debug_init" },
    { 0x86CA, "snd_debug_timer" },
    { 0x86CB, "snd_debug_value_add" },
    { 0x86CC, "snd_debug_value_delete" },
    { 0x86CD, "snd_debug_value_update" },
    { 0x86CE, "snd_disable_occlusion" },
    { 0x86CF, "snd_disable_occlusion_threaded" },
    { 0x86D0, "snd_disable_soundcontextoverride" },
    { 0x86D1, "snd_disable_vehicle_system" },
    { 0x86D2, "snd_disable_zone_filters" },
    { 0x86D3, "snd_disable_zone_occlusion_and_filtering" },
    { 0x86D4, "snd_dpad_functions" },
    { 0x86D5, "snd_enable_occlusion" },
    { 0x86D6, "snd_enable_soundcontextoverride" },
    { 0x86D7, "snd_enable_zone_filters" },
    { 0x86D8, "snd_enable_zone_occlusion_and_filtering" },
    { 0x86D9, "snd_end_01" },
    { 0x86DA, "snd_enemies_can_see_player" },
    { 0x86DB, "snd_ent" },
    { 0x86DC, "snd_ents" },
    { 0x86DD, "snd_fade_and_stop_sound" },
    { 0x86DE, "snd_fade_in_filter" },
    { 0x86DF, "snd_fade_out_filter" },
    { 0x86E0, "snd_filters_init" },
    { 0x86E1, "snd_final_music_think" },
    { 0x86E2, "snd_flash_white" },
    { 0x86E3, "snd_foley_init" },
    { 0x86E4, "snd_gaz_dshk_constructor" },
    { 0x86E5, "snd_get_current_filter_lerp" },
    { 0x86E6, "snd_get_current_filter_name" },
    { 0x86E7, "snd_get_current_occlusion_name" },
    { 0x86E8, "snd_get_current_timescale_preset_name" },
    { 0x86E9, "snd_get_dsp_buses" },
    { 0x86EA, "snd_get_dsp_filename" },
    { 0x86EB, "snd_get_filter_preset" },
    { 0x86EC, "snd_get_num_enemies_aware" },
    { 0x86ED, "snd_get_occlusion_preset" },
    { 0x86EE, "snd_get_secs" },
    { 0x86EF, "snd_get_soundtable_name" },
    { 0x86F0, "snd_get_tagarg" },
    { 0x86F1, "snd_get_throttler" },
    { 0x86F2, "snd_get_timescale_preset" },
    { 0x86F3, "snd_get_zone_filters_enabled" },
    { 0x86F4, "snd_guid" },
    { 0x86F5, "snd_hud_init" },
    { 0x86F6, "snd_impact" },
    { 0x86F7, "snd_init" },
    { 0x86F8, "snd_init_cover_drone" },
    { 0x86F9, "snd_init_current_filters" },
    { 0x86FA, "snd_init_current_occlusion" },
    { 0x86FB, "snd_init_done" },
    { 0x86FC, "snd_init_gaz" },
    { 0x86FD, "snd_init_mi17" },
    { 0x86FE, "snd_init_x4_walker_wheels" },
    { 0x86FF, "snd_init_x4_walker_wheels_turret" },
    { 0x8700, "snd_init_x4_walker_wheels_turret_closed" },
    { 0x8701, "snd_instance" },
    { 0x8702, "snd_is_dsp_bus" },
    { 0x8703, "snd_is_first_frame" },
    { 0x8704, "snd_is_loop" },
    { 0x8705, "snd_is_one_shot" },
    { 0x8706, "snd_is_valid_surface" },
    { 0x8707, "snd_load_dsp_buses" },
    { 0x8708, "snd_load_filter_presets" },
    { 0x8709, "snd_load_occlusion_presets" },
    { 0x870A, "snd_load_timescale_presets" },
    { 0x870B, "snd_map" },
    { 0x870C, "snd_mech_add_rocketpack_lower" },
    { 0x870D, "snd_mech_add_rocketpack_raise" },
    { 0x870E, "snd_mech_emp_restart" },
    { 0x870F, "snd_message" },
    { 0x8710, "snd_message_init" },
    { 0x8711, "snd_mi17_constructor" },
    { 0x8712, "snd_monitor_about_to_stop" },
    { 0x8713, "snd_monitor_about_to_unload" },
    { 0x8714, "snd_monitor_new_path" },
    { 0x8715, "snd_mp_mix_init" },
    { 0x8716, "snd_mp_mix_post_event" },
    { 0x8717, "snd_mp_player_join" },
    { 0x8718, "snd_music_handler" },
    { 0x8719, "snd_music_message" },
    { 0x871A, "snd_mute_device" },
    { 0x871B, "snd_new_guid" },
    { 0x871C, "snd_notify_within_radius" },
    { 0x871D, "snd_parse_preset_header" },
    { 0x871E, "snd_parse_soundtables" },
    { 0x871F, "snd_pcap_add_notetrack_mapping" },
    { 0x8720, "snd_pcap_play_radio_vo" },
    { 0x8721, "snd_pcap_play_radio_vo_30fps" },
    { 0x8722, "snd_pcap_play_radio_vo_60fps" },
    { 0x8723, "snd_pcap_play_vo" },
    { 0x8724, "snd_pcap_play_vo_20fps" },
    { 0x8725, "snd_pcap_play_vo_30fps" },
    { 0x8726, "snd_pdrone_atlas_constructor" },
    { 0x8727, "snd_pdrone_atlas_large_constructor" },
    { 0x8728, "snd_pdrone_constructor" },
    { 0x8729, "snd_pdrone_player_constructor" },
    { 0x872A, "snd_pdrone_security_constructor" },
    { 0x872B, "snd_pdrone_swarm_constructor" },
    { 0x872C, "snd_pitbull_constructor" },
    { 0x872D, "snd_play" },
    { 0x872E, "snd_play_2d" },
    { 0x872F, "snd_play_2d_sound" },
    { 0x8730, "snd_play_amb_loop" },
    { 0x8731, "snd_play_at" },
    { 0x8732, "snd_play_delayed_2d" },
    { 0x8733, "snd_play_delayed_at" },
    { 0x8734, "snd_play_delayed_linked" },
    { 0x8735, "snd_play_delayed_linked_nocull" },
    { 0x8736, "snd_play_delayed_loop_2d" },
    { 0x8737, "snd_play_delayed_loop_at" },
    { 0x8738, "snd_play_delayed_loop_linked" },
    { 0x8739, "snd_play_in_space" },
    { 0x873A, "snd_play_in_space_delayed" },
    { 0x873B, "snd_play_linked" },
    { 0x873C, "snd_play_linked_firingrange" },
    { 0x873D, "snd_play_linked_loop" },
    { 0x873E, "snd_play_linked_notify_ent" },
    { 0x873F, "snd_play_linked_notify_on_ent" },
    { 0x8740, "snd_play_linked_notify_on_ent_thread" },
    { 0x8741, "snd_play_loop" },
    { 0x8742, "snd_play_loop_2d" },
    { 0x8743, "snd_play_loop_at" },
    { 0x8744, "snd_play_loop_in_space" },
    { 0x8745, "snd_play_loop_linked" },
    { 0x8746, "snd_play_on_notetrack" },
    { 0x8747, "snd_play_on_notetrack_timer" },
    { 0x8748, "snd_play_set_cleanup_msg" },
    { 0x8749, "snd_play_team_splash" },
    { 0x874A, "snd_play_vehicle_collision" },
    { 0x874B, "snd_player_drone_deploy" },
    { 0x874C, "snd_player_drone_enter_drone_pov" },
    { 0x874D, "snd_player_drone_wrist_panel" },
    { 0x874E, "snd_println" },
    { 0x874F, "snd_printlnbold" },
    { 0x8750, "snd_register_message" },
    { 0x8751, "snd_register_vehicle" },
    { 0x8752, "snd_scalevo_flame_logic" },
    { 0x8753, "snd_script_timer" },
    { 0x8754, "snd_set_current_filter_name" },
    { 0x8755, "snd_set_current_occlusion_name" },
    { 0x8756, "snd_set_current_timescale_preset_name" },
    { 0x8757, "snd_set_filter" },
    { 0x8758, "snd_set_filter_lerp" },
    { 0x8759, "snd_set_filter_threaded" },
    { 0x875A, "snd_set_occlusion" },
    { 0x875B, "snd_set_occlusion_threaded" },
    { 0x875C, "snd_set_soundtable_name" },
    { 0x875D, "snd_set_timescale" },
    { 0x875E, "snd_set_timescale_all" },
    { 0x875F, "snd_set_timescale_all_threaded" },
    { 0x8760, "snd_set_timescale_array_to_value" },
    { 0x8761, "snd_set_timescale_array_to_value_threaded" },
    { 0x8762, "snd_set_timescale_threaded" },
    { 0x8763, "snd_slate" },
    { 0x8764, "snd_sniper_drone_constructor" },
    { 0x8765, "snd_start_approachdna" },
    { 0x8766, "snd_start_barracks" },
    { 0x8767, "snd_start_canyon" },
    { 0x8768, "snd_start_canyon_dam" },
    { 0x8769, "snd_start_canyon_exit" },
    { 0x876A, "snd_start_canyon_intro" },
    { 0x876B, "snd_start_canyon2" },
    { 0x876C, "snd_start_canyon3" },
    { 0x876D, "snd_start_dnabomb" },
    { 0x876E, "snd_start_gaz" },
    { 0x876F, "snd_start_intro" },
    { 0x8770, "snd_start_mi17" },
    { 0x8771, "snd_start_post_tower" },
    { 0x8772, "snd_start_snipers" },
    { 0x8773, "snd_start_tank" },
    { 0x8774, "snd_start_vehicle" },
    { 0x8775, "snd_start_x4_walker_wheels" },
    { 0x8776, "snd_start_x4_walker_wheels_turret" },
    { 0x8777, "snd_start_x4_walker_wheels_turret_closed" },
    { 0x8778, "snd_stop_cover_drone" },
    { 0x8779, "snd_stop_gaz" },
    { 0x877A, "snd_stop_mi17" },
    { 0x877B, "snd_stop_sound" },
    { 0x877C, "snd_stop_vehicle" },
    { 0x877D, "snd_throttle_wait" },
    { 0x877E, "snd_throttler_reset" },
    { 0x877F, "snd_timescale_init" },
    { 0x8780, "snd_trench_fire_off" },
    { 0x8781, "snd_veh_play_loops" },
    { 0x8782, "snd_vehicle_mp" },
    { 0x8783, "snd_wait_for_enemies_aware" },
    { 0x8784, "snd_wait_for_enemies_see_player" },
    { 0x8785, "snd_waittill_within_radius" },
    { 0x8786, "snd_x4walker_wheels_constructor" },
    { 0x8787, "snd_x4walker_wheels_turret_constructor" },
    { 0x8788, "snd_zone_handler" },
    { 0x8789, "sndx_advanced_flyby_cleanup" },
    { 0x878A, "sndx_advanced_flyby_construct_alias" },
    { 0x878B, "sndx_advanced_flyby_deathspin" },
    { 0x878C, "sndx_advanced_flyby_destruct" },
    { 0x878D, "sndx_advanced_flyby_dist_check" },
    { 0x878E, "sndx_advanced_flyby_playsound" },
    { 0x878F, "sndx_advanced_flyby_retrigger_wait" },
    { 0x8790, "sndx_advanced_flyby_spawn_sound" },
    { 0x8791, "sndx_air_vehicle_smart_flyby_deathspin" },
    { 0x8792, "sndx_air_vehicle_smart_flyby_sounddone" },
    { 0x8793, "sndx_ambient_explosion_args_validation" },
    { 0x8794, "sndx_ambient_explosion_internal" },
    { 0x8795, "sndx_boost_land_get_impact_size" },
    { 0x8796, "sndx_boost_land_get_impact_vol" },
    { 0x8797, "sndx_debug_value_add" },
    { 0x8798, "sndx_debug_value_destroy" },
    { 0x8799, "sndx_debug_value_reorder" },
    { 0x879A, "sndx_dpad_function_watch" },
    { 0x879B, "sndx_fade_and_stop_sound" },
    { 0x879C, "sndx_fade_in_filter_lerp" },
    { 0x879D, "sndx_fade_out_filter_lerp" },
    { 0x879E, "sndx_get_dsp_filter_setting" },
    { 0x879F, "sndx_mute_device_bubble_fx" },
    { 0x87A0, "sndx_mute_device_bubble_off_fx" },
    { 0x87A1, "sndx_mute_device_debug_timer" },
    { 0x87A2, "sndx_mute_device_delay_notify" },
    { 0x87A3, "sndx_mute_device_kill" },
    { 0x87A4, "sndx_mute_device_stop" },
    { 0x87A5, "sndx_mute_device_stopper" },
    { 0x87A6, "sndx_mute_device_wait_to_play" },
    { 0x87A7, "sndx_notify_within_radius" },
    { 0x87A8, "sndx_pcap_find_anime_and_animname" },
    { 0x87A9, "sndx_pcap_play_radio_vo_thread" },
    { 0x87AA, "sndx_pcap_play_vo_fade_delete" },
    { 0x87AB, "sndx_pcap_play_vo_monitor_stopnotify" },
    { 0x87AC, "sndx_pcap_play_vo_thread" },
    { 0x87AD, "sndx_pcap_wait" },
    { 0x87AE, "sndx_play_2d_sound" },
    { 0x87AF, "sndx_play_alias" },
    { 0x87B0, "sndx_play_alias_fade_delete" },
    { 0x87B1, "sndx_play_alias_monitor_linkdeath" },
    { 0x87B2, "sndx_play_alias_monitor_sounddone" },
    { 0x87B3, "sndx_play_alias_monitor_stopnotify" },
    { 0x87B4, "sndx_play_alias_thread" },
    { 0x87B5, "sndx_play_in_space_delayed_internal" },
    { 0x87B6, "sndx_play_in_space_internal" },
    { 0x87B7, "sndx_play_linked_internal" },
    { 0x87B8, "sndx_play_linked_loop_internal" },
    { 0x87B9, "sndx_play_loop_in_space_internal" },
    { 0x87BA, "sndx_play_on_notetrack_internal" },
    { 0x87BB, "sndx_play_vehicle_collision_internal" },
    { 0x87BC, "sndx_vehicle_collision_args_setup" },
    { 0x87BD, "sndx_vehicle_collision_dpad_down" },
    { 0x87BE, "sndx_vehicle_collision_dpad_left" },
    { 0x87BF, "sndx_vehicle_collision_dpad_right" },
    { 0x87C0, "sndx_vehicle_collision_dpad_up" },
    { 0x87C1, "sndx_vehicle_collision_get_impact_size" },
    { 0x87C2, "sndx_vehicle_collision_get_impact_vol" },
    { 0x87C3, "sndx_vehicle_collision_print_impact" },
    { 0x87C4, "sndx_vehicle_collision_print_stats" },
    { 0x87C5, "sndx_vehicle_collision_scrape" },
    { 0x87C6, "sndx_vehicle_collision_scrape_timer" },
    { 0x87C7, "sndx_vehicle_collision_stop_scrapes" },
    { 0x87C8, "sndxt_fastzip_fire" },
    { 0x87C9, "sneaky_reload" },
    { 0x87CA, "sniped" },
    { 0x87CB, "sniper" },
    { 0x87CC, "sniper_combat_setup" },
    { 0x87CD, "sniper_drone_callback_look" },
    { 0x87CE, "sniper_drone_condition_callback_to_state_flying" },
    { 0x87CF, "sniper_drone_condition_callback_to_state_hover" },
    { 0x87D0, "sniper_drone_condition_callback_to_state_idle" },
    { 0x87D1, "sniper_drone_condition_callback_to_state_looking" },
    { 0x87D2, "sniper_drone_dmg_fire" },
    { 0x87D3, "sniper_drone_dry_fire" },
    { 0x87D4, "sniper_drone_init" },
    { 0x87D5, "sniper_dvar" },
    { 0x87D6, "sniper_finale" },
    { 0x87D7, "sniper_fx_base" },
    { 0x87D8, "sniper_glint_behavior" },
    { 0x87D9, "sniper_interior_trigger_think" },
    { 0x87DA, "sniper_kva_dead_body" },
    { 0x87DB, "sniper_marked_cars" },
    { 0x87DC, "sniper_objectives" },
    { 0x87DD, "sniper_reinforce" },
    { 0x87DE, "sniper_rifle_objective_logic" },
    { 0x87DF, "sniper_scramble_data" },
    { 0x87E0, "sniper_suppression_hit_alert" },
    { 0x87E1, "sniper_target_location" },
    { 0x87E2, "sniper_turret1" },
    { 0x87E3, "sniper_turret2" },
    { 0x87E4, "sniper_turret3" },
    { 0x87E5, "sniper_zoom_hint_hud" },
    { 0x87E6, "sniperalltargets" },
    { 0x87E7, "sniperbloodsprayexitwoundtrace" },
    { 0x87E8, "snipercafewallburstfx" },
    { 0x87E9, "sniperdashburstfx1" },
    { 0x87EA, "sniperdashburstfx2" },
    { 0x87EB, "sniperdashburstfx3" },
    { 0x87EC, "sniperdashburstfx4" },
    { 0x87ED, "sniperdashburstfx5" },
    { 0x87EE, "sniperdashburstfx6" },
    { 0x87EF, "sniperdeath" },
    { 0x87F0, "sniperdeathinternal" },
    { 0x87F1, "sniperdestroyglass" },
    { 0x87F2, "sniperdoorhitfx1" },
    { 0x87F3, "sniperdoorhitfx2" },
    { 0x87F4, "sniperdronebadfire" },
    { 0x87F5, "sniperdronecloak" },
    { 0x87F6, "sniperdronedata" },
    { 0x87F7, "sniperdronedeathshowstatic" },
    { 0x87F8, "sniperdronedeathwatch" },
    { 0x87F9, "sniperdronedryfire" },
    { 0x87FA, "sniperdronedryfiremsg" },
    { 0x87FB, "sniperdroneflyin" },
    { 0x87FC, "sniperdroneflyintogglezoomnotetrack" },
    { 0x87FD, "sniperdronelaunchanims" },
    { 0x87FE, "sniperdronelensdamaged" },
    { 0x87FF, "sniperdronelink" },
    { 0x8800, "sniperdronemissilewarnmsg" },
    { 0x8801, "sniperdroneoverlays" },
    { 0x8802, "sniperdroneprep" },
    { 0x8803, "sniperdustwatcher" },
    { 0x8804, "snipergettargetpos" },
    { 0x8805, "snipergroup" },
    { 0x8806, "sniperhitcount" },
    { 0x8807, "sniperhoteltargetilanafirst" },
    { 0x8808, "sniperhoteltargetplayerfirst" },
    { 0x8809, "sniperintro" },
    { 0x880A, "sniperissuppressed" },
    { 0x880B, "snipernearshotshake" },
    { 0x880C, "sniperpos" },
    { 0x880D, "snipers_defenders" },
    { 0x880E, "snipers_drone_spawners" },
    { 0x880F, "snipers_drones" },
    { 0x8810, "sniperscramblebegin" },
    { 0x8811, "sniperscrambledronesdialogue" },
    { 0x8812, "sniperscrambleexittruckanimations" },
    { 0x8813, "sniperscramblefinaledialogue" },
    { 0x8814, "sniperscramblefishanimations" },
    { 0x8815, "sniperscrambleflaginit" },
    { 0x8816, "sniperscramblegameskillmultiplier" },
    { 0x8817, "sniperscrambleglobalsetup" },
    { 0x8818, "sniperscrambleglobalvars" },
    { 0x8819, "sniperscramblegondolaanimations" },
    { 0x881A, "sniperscramblehoteldialogue" },
    { 0x881B, "sniperscrambleinit" },
    { 0x881C, "sniperscrambleintrodialogue" },
    { 0x881D, "sniperscrambleintrodooranimations" },
    { 0x881E, "sniperscrambleobjectivesetup" },
    { 0x881F, "sniperscrambleprecache" },
    { 0x8820, "sniperscrambleragdollkill" },
    { 0x8821, "sniperscramblesetcompletedobjflags" },
    { 0x8822, "sniperscramblestartpoints" },
    { 0x8823, "sniperscramblewindmilldestructionanimations" },
    { 0x8824, "snipersettargetent" },
    { 0x8825, "snipersetupglass" },
    { 0x8826, "snipershoot" },
    { 0x8827, "snipershootcafejump" },
    { 0x8828, "snipershootcafewall" },
    { 0x8829, "snipershootfirstcivilian" },
    { 0x882A, "snipershootgapjump" },
    { 0x882B, "snipershoothoteljump" },
    { 0x882C, "snipershoothothall" },
    { 0x882D, "snipershootilana" },
    { 0x882E, "snipershootintrodoor" },
    { 0x882F, "snipershootnearhotelciv" },
    { 0x8830, "snipershootrestaurantfishtank" },
    { 0x8831, "snipershootstingerpot" },
    { 0x8832, "snipershootwoundedsoldier" },
    { 0x8833, "snipershot" },
    { 0x8834, "snipershot_multi" },
    { 0x8835, "snipershotcount" },
    { 0x8836, "snipershotphysicsimpulse" },
    { 0x8837, "snipertargetent" },
    { 0x8838, "snipertargetgettagpos" },
    { 0x8839, "snipertowerexplosionfx" },
    { 0x883A, "snipertowerresidualfx" },
    { 0x883B, "snipervisibletargets" },
    { 0x883C, "snowmobile_collide_death" },
    { 0x883D, "snowmobile_death_launchslide" },
    { 0x883E, "snowmobile_decide_shoot" },
    { 0x883F, "snowmobile_decide_shoot_internal" },
    { 0x8840, "snowmobile_do_event" },
    { 0x8841, "snowmobile_get_death_anim" },
    { 0x8842, "snowmobile_getoff" },
    { 0x8843, "snowmobile_geton" },
    { 0x8844, "snowmobile_handle_events" },
    { 0x8845, "snowmobile_loop_driver" },
    { 0x8846, "snowmobile_loop_driver_shooting" },
    { 0x8847, "snowmobile_loop_passenger" },
    { 0x8848, "snowmobile_loop_passenger_shooting" },
    { 0x8849, "snowmobile_mount_anims" },
    { 0x884A, "snowmobile_normal_death" },
    { 0x884B, "snowmobile_reload" },
    { 0x884C, "snowmobile_reload_internal" },
    { 0x884D, "snowmobile_setanim_common" },
    { 0x884E, "snowmobile_setanim_driver" },
    { 0x884F, "snowmobile_setanim_passenger" },
    { 0x8850, "snowmobile_shoot" },
    { 0x8851, "snowmobile_start_shooting" },
    { 0x8852, "snowmobile_stop_shooting" },
    { 0x8853, "snowmobile_trackshootentorpos_driver" },
    { 0x8854, "snowmobile_trackshootentorpos_passenger" },
    { 0x8855, "snowmobile_waitfor_end" },
    { 0x8856, "snowmobile_waitfor_start_aim" },
    { 0x8857, "snowmobile_waitfor_start_lean" },
    { 0x8858, "snowmobileshootbehavior" },
    { 0x8859, "so_can_player_see_dog" },
    { 0x885A, "so_dog_death_quote" },
    { 0x885B, "so_msg_handler" },
    { 0x885C, "soda_array" },
    { 0x885D, "soda_can_drop" },
    { 0x885E, "soda_can_eject" },
    { 0x885F, "soda_count" },
    { 0x8860, "soda_slot" },
    { 0x8861, "soften_player_damage" },
    { 0x8862, "softlanding" },
    { 0x8863, "softlandingtriggers" },
    { 0x8864, "softlandingwaiter" },
    { 0x8865, "softsighttest" },
    { 0x8866, "solar_fire_fx" },
    { 0x8867, "solar_killstreak_duration" },
    { 0x8868, "solar_reflector_cam_tag" },
    { 0x8869, "solar_reflector_player" },
    { 0x886A, "solar_reflector_sfx" },
    { 0x886B, "solar_reflector_target_sfx" },
    { 0x886C, "solarcustomkillstreakfunc" },
    { 0x886D, "solarimmunefire" },
    { 0x886E, "solarpaladinoverrides" },
    { 0x886F, "solarrelectortimer" },
    { 0x8870, "soldiers_go_through_tunnel" },
    { 0x8871, "solid" },
    { 0x8872, "solid_ents_by_targetname" },
    { 0x8873, "solidify_on_player_decon" },
    { 0x8874, "solo_fires" },
    { 0x8875, "solo_firing" },
    { 0x8876, "solo_player_in_coop_gameskill_settings" },
    { 0x8877, "solo_player_in_special_ops" },
    { 0x8878, "some_wheels_slipping" },
    { 0x8879, "sonar_hint" },
    { 0x887A, "sonar_hint_2" },
    { 0x887B, "sonar_off" },
    { 0x887C, "sonar_on" },
    { 0x887D, "sonar_reset_dvars" },
    { 0x887E, "sonar_save_and_set_dvars" },
    { 0x887F, "sonar_vision" },
    { 0x8880, "sonar_vision_off" },
    { 0x8881, "sonar_vision_on" },
    { 0x8882, "sonarvisionsaveddvars" },
    { 0x8883, "sonic_aoe_thread" },
    { 0x8884, "sonic_blast" },
    { 0x8885, "sonic_blast_aftershock" },
    { 0x8886, "sonic_blast_done" },
    { 0x8887, "sonic_blast_started" },
    { 0x8888, "sonic_destruct" },
    { 0x8889, "sonic_stop_scripted_anim" },
    { 0x888A, "sonicaoeactive" },
    { 0x888B, "sonicaoeready" },
    { 0x888C, "sonics_hint" },
    { 0x888D, "sonics_use_hint" },
    { 0x888E, "sonics_use_monitor" },
    { 0x888F, "sort_breachers" },
    { 0x8890, "sort_buttons_by_angle" },
    { 0x8891, "sort_by_startingpos" },
    { 0x8892, "sort_destructible_frame_queue" },
    { 0x8893, "sort_drone_attacks" },
    { 0x8894, "sort_drone_moves" },
    { 0x8895, "sort_reactive_ents" },
    { 0x8896, "sortbydistanceauto" },
    { 0x8897, "sortdroplocations" },
    { 0x8898, "sortinstinctdogspawnpoints" },
    { 0x8899, "sortlowermessages" },
    { 0x889A, "sortnodetransitionangles" },
    { 0x889B, "sortplayersandgivepowers" },
    { 0x889C, "sound" },
    { 0x889D, "sound_col" },
    { 0x889E, "sound_csv_include" },
    { 0x889F, "sound_effect" },
    { 0x88A0, "sound_effect_play" },
    { 0x88A1, "sound_explode" },
    { 0x88A2, "sound_launch" },
    { 0x88A3, "sound_lock" },
    { 0x88A4, "sound_offset" },
    { 0x88A5, "sound_org" },
    { 0x88A6, "sound_played" },
    { 0x88A7, "sound_prefix" },
    { 0x88A8, "sound_reset_time" },
    { 0x88A9, "sound_suffix" },
    { 0x88AA, "sound_tag" },
    { 0x88AB, "sound_tag_dupe" },
    { 0x88AC, "soundaliases" },
    { 0x88AD, "sounddone" },
    { 0x88AE, "soundents" },
    { 0x88AF, "soundfx" },
    { 0x88B0, "soundfxdelete" },
    { 0x88B1, "soundonly" },
    { 0x88B2, "soundstate" },
    { 0x88B3, "soundtable" },
    { 0x88B4, "soundwatcher" },
    { 0x88B5, "sp_stat_tracking_func" },
    { 0x88B6, "space_arrival_turnrate_delay" },
    { 0x88B7, "space_getdefaultturnrate" },
    { 0x88B8, "space_getorientturnrate" },
    { 0x88B9, "spacing" },
    { 0x88BA, "spam_group_hudelems" },
    { 0x88BB, "spam_model_current_group" },
    { 0x88BC, "spamdelay" },
    { 0x88BD, "sparkgreenloop" },
    { 0x88BE, "sparks" },
    { 0x88BF, "sparks1" },
    { 0x88C0, "spawn" },
    { 0x88C1, "spawn_a_backline_guy" },
    { 0x88C2, "spawn_a_guy" },
    { 0x88C3, "spawn_a_school_train" },
    { 0x88C4, "spawn_a_second_line_guy" },
    { 0x88C5, "spawn_agent_player" },
    { 0x88C6, "spawn_ai" },
    { 0x88C7, "spawn_ai_flashlight" },
    { 0x88C8, "spawn_ai_from_targetname" },
    { 0x88C9, "spawn_ai_from_targetname_single" },
    { 0x88CA, "spawn_allies" },
    { 0x88CB, "spawn_allies_for_swarm_turret_segment" },
    { 0x88CC, "spawn_ally" },
    { 0x88CD, "spawn_ally_at_struct" },
    { 0x88CE, "spawn_ally_ground_vehicles" },
    { 0x88CF, "spawn_ally_walker_02" },
    { 0x88D0, "spawn_ambient_warbird" },
    { 0x88D1, "spawn_an_avatar" },
    { 0x88D2, "spawn_and_handle_looping_helicopters" },
    { 0x88D3, "spawn_angles" },
    { 0x88D4, "spawn_anim_model" },
    { 0x88D5, "spawn_array" },
    { 0x88D6, "spawn_atlas_intercept" },
    { 0x88D7, "spawn_attack_drone" },
    { 0x88D8, "spawn_back_left_scaffold_guys" },
    { 0x88D9, "spawn_bikes" },
    { 0x88DA, "spawn_bot_latent" },
    { 0x88DB, "spawn_bots" },
    { 0x88DC, "spawn_burke_common" },
    { 0x88DD, "spawn_button_released" },
    { 0x88DE, "spawn_cargo_crater" },
    { 0x88DF, "spawn_cbdr_missile" },
    { 0x88E0, "spawn_chance_override" },
    { 0x88E1, "spawn_civ_loop" },
    { 0x88E2, "spawn_controllable_drone_cloud" },
    { 0x88E3, "spawn_core_snipers_guys" },
    { 0x88E4, "spawn_cormack_common" },
    { 0x88E5, "spawn_correct_player_rig" },
    { 0x88E6, "spawn_crashing_pods" },
    { 0x88E7, "spawn_doctor" },
    { 0x88E8, "spawn_dog" },
    { 0x88E9, "spawn_driving_police_car" },
    { 0x88EA, "spawn_drone_physics" },
    { 0x88EB, "spawn_drone_street_allies_and_reinforce" },
    { 0x88EC, "spawn_drone_street_ally" },
    { 0x88ED, "spawn_ending_pcap_warbird" },
    { 0x88EE, "spawn_enemy_array_at_structs" },
    { 0x88EF, "spawn_enemy_group" },
    { 0x88F0, "spawn_enemy_jets" },
    { 0x88F1, "spawn_exfil_enemies" },
    { 0x88F2, "spawn_exit_jetbike" },
    { 0x88F3, "spawn_exp_tendril" },
    { 0x88F4, "spawn_failed" },
    { 0x88F5, "spawn_few_nightclub_guys" },
    { 0x88F6, "spawn_flag_projector" },
    { 0x88F7, "spawn_fly_in_missile" },
    { 0x88F8, "spawn_fly_in_missile_00" },
    { 0x88F9, "spawn_fly_in_missile_01" },
    { 0x88FA, "spawn_fly_in_missile_02" },
    { 0x88FB, "spawn_fly_in_missile_03" },
    { 0x88FC, "spawn_fly_in_missile_04" },
    { 0x88FD, "spawn_fly_in_missile_05" },
    { 0x88FE, "spawn_fly_in_missile_06" },
    { 0x88FF, "spawn_friendlies" },
    { 0x8900, "spawn_func_respawn_on_death" },
    { 0x8901, "spawn_funcs" },
    { 0x8902, "spawn_function" },
    { 0x8903, "spawn_functions" },
    { 0x8904, "spawn_fx" },
    { 0x8905, "spawn_gideon" },
    { 0x8906, "spawn_gideon_mech" },
    { 0x8907, "spawn_grenade" },
    { 0x8908, "spawn_grenade_bag" },
    { 0x8909, "spawn_group" },
    { 0x890A, "spawn_groups" },
    { 0x890B, "spawn_guy_and_firstframe" },
    { 0x890C, "spawn_guy_loopers" },
    { 0x890D, "spawn_guys_until_death_or_no_count" },
    { 0x890E, "spawn_hidden_reinforcement" },
    { 0x890F, "spawn_hospital_roof_guys" },
    { 0x8910, "spawn_initial_forces_tanks" },
    { 0x8911, "spawn_initial_forces_warbirds" },
    { 0x8912, "spawn_intro_heroes" },
    { 0x8913, "spawn_intro_pilots" },
    { 0x8914, "spawn_knox_common" },
    { 0x8915, "spawn_kva_downstairs" },
    { 0x8916, "spawn_last_two_guys" },
    { 0x8917, "spawn_left_building_scaffolding_guy" },
    { 0x8918, "spawn_left_hospital_train" },
    { 0x8919, "spawn_looping_ambient_vehicle_single" },
    { 0x891A, "spawn_looping_ambient_vehicles" },
    { 0x891B, "spawn_looping_jets" },
    { 0x891C, "spawn_looping_street_jets" },
    { 0x891D, "spawn_mech_baghdad" },
    { 0x891E, "spawn_mech_rig" },
    { 0x891F, "spawn_metrics_death_count" },
    { 0x8920, "spawn_metrics_death_watcher" },
    { 0x8921, "spawn_metrics_init" },
    { 0x8922, "spawn_metrics_init_for_noteworthy" },
    { 0x8923, "spawn_metrics_number_alive" },
    { 0x8924, "spawn_metrics_number_died" },
    { 0x8925, "spawn_metrics_number_spawned" },
    { 0x8926, "spawn_metrics_spawn_count" },
    { 0x8927, "spawn_metrics_spawn_func" },
    { 0x8928, "spawn_metrics_waittill_count_reaches" },
    { 0x8929, "spawn_metrics_waittill_deaths_reach" },
    { 0x892A, "spawn_model_from_struct" },
    { 0x892B, "spawn_more_allies" },
    { 0x892C, "spawn_name" },
    { 0x892D, "spawn_new_ally" },
    { 0x892E, "spawn_new_traffic_entity_at_node" },
    { 0x892F, "spawn_new_traffic_entity_at_node_override" },
    { 0x8930, "spawn_new_traffic_model" },
    { 0x8931, "spawn_new_traffic_vehicle" },
    { 0x8932, "spawn_next_zone" },
    { 0x8933, "spawn_npc_and_use_scripted_zipline" },
    { 0x8934, "spawn_parked_police_car" },
    { 0x8935, "spawn_patroller_guide_floor2" },
    { 0x8936, "spawn_pdrone" },
    { 0x8937, "spawn_placed_alleyway_guys" },
    { 0x8938, "spawn_player_anim_rig" },
    { 0x8939, "spawn_player_checkpoint" },
    { 0x893A, "spawn_player_drone_think" },
    { 0x893B, "spawn_player_prisoner_hands" },
    { 0x893C, "spawn_player_rig" },
    { 0x893D, "spawn_player_rig_for_carshield" },
    { 0x893E, "spawn_police_drone" },
    { 0x893F, "spawn_police_drone_with_anim" },
    { 0x8940, "spawn_pool_copy_function" },
    { 0x8941, "spawn_pool_enabled" },
    { 0x8942, "spawn_preplaced_guys" },
    { 0x8943, "spawn_president" },
    { 0x8944, "spawn_president_s2" },
    { 0x8945, "spawn_prethink" },
    { 0x8946, "spawn_queen_drone_and_drive" },
    { 0x8947, "spawn_reinforcement" },
    { 0x8948, "spawn_reverse_school_train" },
    { 0x8949, "spawn_reverse_street_train" },
    { 0x894A, "spawn_right_hospital_train" },
    { 0x894B, "spawn_route_full_with_traffic_at" },
    { 0x894C, "spawn_scaffolding_to_floor_right" },
    { 0x894D, "spawn_script_model_turret" },
    { 0x894E, "spawn_script_noteworthy" },
    { 0x894F, "spawn_security_drones" },
    { 0x8950, "spawn_setcharacter" },
    { 0x8951, "spawn_single_vehicle_for_lane" },
    { 0x8952, "spawn_snake" },
    { 0x8953, "spawn_snake_cloud" },
    { 0x8954, "spawn_snake_no_drones" },
    { 0x8955, "spawn_snake_queen" },
    { 0x8956, "spawn_sniper_guy" },
    { 0x8957, "spawn_soda" },
    { 0x8958, "spawn_squad" },
    { 0x8959, "spawn_squad_member" },
    { 0x895A, "spawn_street_train" },
    { 0x895B, "spawn_struct_array" },
    { 0x895C, "spawn_tag_origin" },
    { 0x895D, "spawn_tag_origin_monitor" },
    { 0x895E, "spawn_takedown_01_guys" },
    { 0x895F, "spawn_tank_column" },
    { 0x8960, "spawn_targetname" },
    { 0x8961, "spawn_targetname_at_struct_targetname" },
    { 0x8962, "spawn_team_allies" },
    { 0x8963, "spawn_team_axis" },
    { 0x8964, "spawn_team_neutral" },
    { 0x8965, "spawn_team_team3" },
    { 0x8966, "spawn_tendril" },
    { 0x8967, "spawn_the_rest" },
    { 0x8968, "spawn_think" },
    { 0x8969, "spawn_think_action" },
    { 0x896A, "spawn_think_game_skill_related" },
    { 0x896B, "spawn_think_script_inits" },
    { 0x896C, "spawn_third_floor_guy_for_assistance" },
    { 0x896D, "spawn_time" },
    { 0x896E, "spawn_traffic_helicopter" },
    { 0x896F, "spawn_trains_track1" },
    { 0x8970, "spawn_trains_track2" },
    { 0x8971, "spawn_tram_turret" },
    { 0x8972, "spawn_transport_flying_01" },
    { 0x8973, "spawn_transport_flying_02" },
    { 0x8974, "spawn_turbine_enemies_tidal_wave" },
    { 0x8975, "spawn_turret_model" },
    { 0x8976, "spawn_unload_group" },
    { 0x8977, "spawn_veh" },
    { 0x8978, "spawn_vehicle" },
    { 0x8979, "spawn_vehicle_and_attach_to_free_path" },
    { 0x897A, "spawn_vehicle_and_gopath" },
    { 0x897B, "spawn_vehicle_from_targetname" },
    { 0x897C, "spawn_vehicle_from_targetname_and_drive" },
    { 0x897D, "spawn_vehicle_from_targetname_and_setup_jump_targets" },
    { 0x897E, "spawn_vehicle_lane" },
    { 0x897F, "spawn_vehicles_from_targetname" },
    { 0x8980, "spawn_vehicles_from_targetname_and_drive" },
    { 0x8981, "spawn_vehicles_from_targetname_newstyle" },
    { 0x8982, "spawn_version" },
    { 0x8983, "spawn_vista_vehicle" },
    { 0x8984, "spawn_walker_mobile_turret_deploy" },
    { 0x8985, "spawn_warbird_spotlight_gag" },
    { 0x8986, "spawn_warbird_turret" },
    { 0x8987, "spawn_was_good" },
    { 0x8988, "spawn_wave_stagger" },
    { 0x8989, "spawn_wave_upkeep_and_block" },
    { 0x898A, "spawn_wave_upkeep_and_flag" },
    { 0x898B, "spawn_wave1b" },
    { 0x898C, "spawn_zipline_turret" },
    { 0x898D, "spawnaddwalker" },
    { 0x898E, "spawnaddwalkers" },
    { 0x898F, "spawnairstrikeplane" },
    { 0x8990, "spawnallyinfiltrators" },
    { 0x8991, "spawnandinitnamedally" },
    { 0x8992, "spawnangle" },
    { 0x8993, "spawnanglemax" },
    { 0x8994, "spawnanglemin" },
    { 0x8995, "spawnattachment" },
    { 0x8996, "spawnattachmenteffect" },
    { 0x8997, "spawnbreachhostiles" },
    { 0x8998, "spawncivilians" },
    { 0x8999, "spawncivilians_flank_alley" },
    { 0x899A, "spawncivilians_roundabout" },
    { 0x899B, "spawnclient" },
    { 0x899C, "spawnclusterchildren" },
    { 0x899D, "spawnconfcenterai" },
    { 0x899E, "spawncopter" },
    { 0x899F, "spawncrane" },
    { 0x89A0, "spawndecoycivilians" },
    { 0x89A1, "spawndogtags" },
    { 0x89A2, "spawned_avatar" },
    { 0x89A3, "spawned_bike_rider" },
    { 0x89A4, "spawned_boats" },
    { 0x89A5, "spawned_count" },
    { 0x89A6, "spawned_kamikaze_drones" },
    { 0x89A7, "spawned_turret" },
    { 0x89A8, "spawnedfoamglobs" },
    { 0x89A9, "spawnedkillcamcleanup" },
    { 0x89AA, "spawnedwarbirds" },
    { 0x89AB, "spawneffectonplayerview" },
    { 0x89AC, "spawnendingenemies" },
    { 0x89AD, "spawnendingenemies01" },
    { 0x89AE, "spawnendingenemies01flood" },
    { 0x89AF, "spawnendingenemies02" },
    { 0x89B0, "spawnendingenemies02flood" },
    { 0x89B1, "spawnendingenemies03" },
    { 0x89B2, "spawnendingenemies04" },
    { 0x89B3, "spawnendingenemies04flood" },
    { 0x89B4, "spawnendingenemies05" },
    { 0x89B5, "spawnendingenemies06" },
    { 0x89B6, "spawnendingheli" },
    { 0x89B7, "spawnendingshotguna" },
    { 0x89B8, "spawnendingshotgunb" },
    { 0x89B9, "spawnendofgame" },
    { 0x89BA, "spawnenemiesambusherseast" },
    { 0x89BB, "spawnenemiesambusherssouth" },
    { 0x89BC, "spawnenemiesextra" },
    { 0x89BD, "spawnenemiespatrollersa" },
    { 0x89BE, "spawnenemiespatrollersb" },
    { 0x89BF, "spawnenemiespatrollersc" },
    { 0x89C0, "spawnenemyambushvehicle" },
    { 0x89C1, "spawnenemyreinforcementsvehicles" },
    { 0x89C2, "spawnenemystruggle" },
    { 0x89C3, "spawner_deathflag" },
    { 0x89C4, "spawner_dronespawn" },
    { 0x89C5, "spawner_fallbackers" },
    { 0x89C6, "spawner_force_laser_on" },
    { 0x89C7, "spawner_id" },
    { 0x89C8, "spawner_name" },
    { 0x89C9, "spawner_number" },
    { 0x89CA, "spawner_pool" },
    { 0x89CB, "spawner_swap_ai_to_drone" },
    { 0x89CC, "spawner_swap_drone_to_ai" },
    { 0x89CD, "spawner_vision_checker" },
    { 0x89CE, "spawnercallbackthread" },
    { 0x89CF, "spawnercount" },
    { 0x89D0, "spawners" },
    { 0x89D1, "spawnerwave" },
    { 0x89D2, "spawnfemalecivilians" },
    { 0x89D3, "spawnfemalecivilians_roundabout" },
    { 0x89D4, "spawnfire" },
    { 0x89D5, "spawnfunc_ally" },
    { 0x89D6, "spawnfunc_mb" },
    { 0x89D7, "spawnfunc_mb_civilians" },
    { 0x89D8, "spawnfunc_mb_drone" },
    { 0x89D9, "spawnfunc_mb_enemies" },
    { 0x89DA, "spawnfunc_mb1_tower" },
    { 0x89DB, "spawnfunc_mb1_vrap" },
    { 0x89DC, "spawnfunc_mb2_final" },
    { 0x89DD, "spawnfunc_mb2_mech" },
    { 0x89DE, "spawnfunc_mb2_vrap" },
    { 0x89DF, "spawnfunc_mech_crush" },
    { 0x89E0, "spawnfxshowtoteam" },
    { 0x89E1, "spawnglow" },
    { 0x89E2, "spawnglowmodel" },
    { 0x89E3, "spawnhadesescapevehicle" },
    { 0x89E4, "spawnhangardoors" },
    { 0x89E5, "spawnheight" },
    { 0x89E6, "spawnhostile" },
    { 0x89E7, "spawninfo" },
    { 0x89E8, "spawningafterremotedeath" },
    { 0x89E9, "spawningclientthisframereset" },
    { 0x89EA, "spawninstinctdogs" },
    { 0x89EB, "spawnintelpickup" },
    { 0x89EC, "spawnintermission" },
    { 0x89ED, "spawnkvafollowtarget" },
    { 0x89EE, "spawnkvasafehouseguards" },
    { 0x89EF, "spawnlinkedfxshowtoteam" },
    { 0x89F0, "spawnlogicteam" },
    { 0x89F1, "spawnlogictraceheight" },
    { 0x89F2, "spawnlogictracehieght" },
    { 0x89F3, "spawnmalecivilians" },
    { 0x89F4, "spawnmalecivilians_roundabout" },
    { 0x89F5, "spawnmalecivilianswithface" },
    { 0x89F6, "spawnmaxs" },
    { 0x89F7, "spawnmgturret" },
    { 0x89F8, "spawnmine" },
    { 0x89F9, "spawnmins" },
    { 0x89FA, "spawnorbitalsupportturret" },
    { 0x89FB, "spawnorigin" },
    { 0x89FC, "spawnperk" },
    { 0x89FD, "spawnpickup" },
    { 0x89FE, "spawnplayer" },
    { 0x89FF, "spawnplayerinorbital" },
    { 0x8A00, "spawnpoint" },
    { 0x8A01, "spawnpointarray" },
    { 0x8A02, "spawnpointdistanceupdate" },
    { 0x8A03, "spawnpointinit" },
    { 0x8A04, "spawnpoints" },
    { 0x8A05, "spawnpointsightupdate" },
    { 0x8A06, "spawnpointupdate" },
    { 0x8A07, "spawnposttakedowncivilians" },
    { 0x8A08, "spawnpotentialtargets" },
    { 0x8A09, "spawnradius" },
    { 0x8A0A, "spawnrestaurantfishswimming" },
    { 0x8A0B, "spawnriotshieldcollision" },
    { 0x8A0C, "spawnriotshieldcover" },
    { 0x8A0D, "spawnsafehousepatroller" },
    { 0x8A0E, "spawnscore" },
    { 0x8A0F, "spawnsetup" },
    { 0x8A10, "spawnshieldlights" },
    { 0x8A11, "spawnspectator" },
    { 0x8A12, "spawnsquadfunc" },
    { 0x8A13, "spawntarget" },
    { 0x8A14, "spawntempcivilians" },
    { 0x8A15, "spawntimedecisecondsfrommatchstart" },
    { 0x8A16, "spawntracelocation" },
    { 0x8A17, "spawnwalkingcivilians" },
    { 0x8A18, "spawnwalkingcivilians_roundabout" },
    { 0x8A19, "spawnwavestoptrigger" },
    { 0x8A1A, "spawnwaypointfriendlies" },
    { 0x8A1B, "speaker_distance" },
    { 0x8A1C, "speakers" },
    { 0x8A1D, "special" },
    { 0x8A1E, "special_array_remove" },
    { 0x8A1F, "special_autosavecondition" },
    { 0x8A20, "special_death_anim" },
    { 0x8A21, "special_death_hint" },
    { 0x8A22, "special_death_proc" },
    { 0x8A23, "special_flyby_jet" },
    { 0x8A24, "special_gulag_adjustment" },
    { 0x8A25, "special_kva" },
    { 0x8A26, "special_loopingidleanimation" },
    { 0x8A27, "special_weapon_dof_funcs" },
    { 0x8A28, "specialaicount" },
    { 0x8A29, "specialaistats" },
    { 0x8A2A, "specialaitypes" },
    { 0x8A2B, "specialcheck" },
    { 0x8A2C, "specialcleanupfunc" },
    { 0x8A2D, "specialdamage" },
    { 0x8A2E, "specialdeath" },
    { 0x8A2F, "specialdeathfunc" },
    { 0x8A30, "specialflashedfunc" },
    { 0x8A31, "specialgametypescript" },
    { 0x8A32, "specialidleanim" },
    { 0x8A33, "specialidleloop" },
    { 0x8A34, "specialmelee_standard" },
    { 0x8A35, "specialmeleechooseaction" },
    { 0x8A36, "specialpain" },
    { 0x8A37, "specialpainblocker" },
    { 0x8A38, "specialreloadanimfunc" },
    { 0x8A39, "specialshootbehavior" },
    { 0x8A3A, "specialstruct" },
    { 0x8A3B, "specialty_blackbox_bonus" },
    { 0x8A3C, "specialty_blastshield_bonus" },
    { 0x8A3D, "specialty_c4_death_icon" },
    { 0x8A3E, "specialty_compassping_revenge_icon" },
    { 0x8A3F, "specialty_finalstand_icon" },
    { 0x8A40, "specialty_juiced_icon" },
    { 0x8A41, "specialty_paint_time" },
    { 0x8A42, "specialty_unwrapper_care_bonus" },
    { 0x8A43, "species" },
    { 0x8A44, "specific_combat" },
    { 0x8A45, "specific_warbird_deathflag" },
    { 0x8A46, "specific_warbird_deathflag1" },
    { 0x8A47, "specific_warbird_deathflag2" },
    { 0x8A48, "specific_warbird_deathflag3" },
    { 0x8A49, "specops" },
    { 0x8A4A, "specops_dmg" },
    { 0x8A4B, "specops_reward_gameskill" },
    { 0x8A4C, "specops_think" },
    { 0x8A4D, "spectateoverride" },
    { 0x8A4E, "spectating_actively" },
    { 0x8A4F, "spectatorviewloadout" },
    { 0x8A50, "specular_default" },
    { 0x8A51, "speechcommands" },
    { 0x8A52, "speed_calc" },
    { 0x8A53, "speed_control_pathnodes" },
    { 0x8A54, "speed_control_pathnodes_dist" },
    { 0x8A55, "speed_display" },
    { 0x8A56, "speed_norm" },
    { 0x8A57, "speed_of_sound_" },
    { 0x8A58, "speed_scale" },
    { 0x8A59, "speed_slow" },
    { 0x8A5A, "speed_to_anim_rate" },
    { 0x8A5B, "speed_up_building_jump_anim" },
    { 0x8A5C, "speed_up_gideon_when_u_cant_see_him" },
    { 0x8A5D, "speed_up_missile_load" },
    { 0x8A5E, "spider_tank_deaths" },
    { 0x8A5F, "spikelist" },
    { 0x8A60, "spikelistindex" },
    { 0x8A61, "spinalarmsstart" },
    { 0x8A62, "spinalarmsstop" },
    { 0x8A63, "spinnerarray" },
    { 0x8A64, "spinsoundshortly" },
    { 0x8A65, "spinthelasers" },
    { 0x8A66, "spinuptime" },
    { 0x8A67, "splash_pos_for_speed" },
    { 0x8A68, "splashattachmentname" },
    { 0x8A69, "splashing_water" },
    { 0x8A6A, "splashname" },
    { 0x8A6B, "splashnotify" },
    { 0x8A6C, "splashnotifydelayed" },
    { 0x8A6D, "splashnotifyurgent" },
    { 0x8A6E, "splashqueue" },
    { 0x8A6F, "splashref" },
    { 0x8A70, "splashusedname" },
    { 0x8A71, "splashweakenedname" },
    { 0x8A72, "spline_accel" },
    { 0x8A73, "spline_decel" },
    { 0x8A74, "spline_fast_decel" },
    { 0x8A75, "spline_speed" },
    { 0x8A76, "split_lane" },
    { 0x8A77, "split_lane_extra_handling" },
    { 0x8A78, "split_rocket" },
    { 0x8A79, "split_rocket_hellfire" },
    { 0x8A7A, "split_rocket_spiral" },
    { 0x8A7B, "splitarrivalsleft" },
    { 0x8A7C, "splitarrivalsright" },
    { 0x8A7D, "splitexitsleft" },
    { 0x8A7E, "splitexitsright" },
    { 0x8A7F, "splitscreen" },
    { 0x8A80, "spot" },
    { 0x8A81, "spot_exhaust_fail_angles" },
    { 0x8A82, "spot_exhaust_fail_orig" },
    { 0x8A83, "spot_main" },
    { 0x8A84, "spot_tag" },
    { 0x8A85, "spot_tag2" },
    { 0x8A86, "spot_tag3" },
    { 0x8A87, "spot_tag4" },
    { 0x8A88, "spotlight" },
    { 0x8A89, "spotlight_aim_ents" },
    { 0x8A8A, "spotlight_fizzles_out" },
    { 0x8A8B, "spotlight_light_motion" },
    { 0x8A8C, "spotlight_owner" },
    { 0x8A8D, "spotlight_tag" },
    { 0x8A8E, "spotlight_tag_origin_cleanup" },
    { 0x8A8F, "spotlight_target" },
    { 0x8A90, "spotlight_think" },
    { 0x8A91, "spotlights" },
    { 0x8A92, "spotlimit" },
    { 0x8A93, "spottarget" },
    { 0x8A94, "spotted_an_enemy" },
    { 0x8A95, "spotted_enemy" },
    { 0x8A96, "spotted_list" },
    { 0x8A97, "spottedorigin" },
    { 0x8A98, "spottedstance" },
    { 0x8A99, "spottedvisibledistance" },
    { 0x8A9A, "spotter" },
    { 0x8A9B, "spotterangles" },
    { 0x8A9C, "spotterfov" },
    { 0x8A9D, "spotterviewpoint" },
    { 0x8A9E, "spraycans" },
    { 0x8A9F, "sprayerdrip" },
    { 0x8AA0, "sprayerdriparray" },
    { 0x8AA1, "spraymachine" },
    { 0x8AA2, "spraymachinedrips" },
    { 0x8AA3, "spraypaint_chaser" },
    { 0x8AA4, "spraypaint_gag" },
    { 0x8AA5, "spraypaint_runner" },
    { 0x8AA6, "spraysheetstate" },
    { 0x8AA7, "spread_width" },
    { 0x8AA8, "sprimaryweapon" },
    { 0x8AA9, "sprinkler_origin" },
    { 0x8AAA, "sprinkler_sound_proximity_toggle" },
    { 0x8AAB, "sprint" },
    { 0x8AAC, "sprint_hint_reminder" },
    { 0x8AAD, "sprint_speed" },
    { 0x8AAE, "sprintdistthissprint" },
    { 0x8AAF, "sprintslidekillevent" },
    { 0x8AB0, "sprinttracking" },
    { 0x8AB1, "spupdatetotal" },
    { 0x8AB2, "spwan_vehicle_loopers" },
    { 0x8AB3, "squad" },
    { 0x8AB4, "squad_becomes_aware_after_intro" },
    { 0x8AB5, "squad_careful_all_start" },
    { 0x8AB6, "squad_careful_all_stop" },
    { 0x8AB7, "squad_exo_door_goto" },
    { 0x8AB8, "squad_gestures_burke" },
    { 0x8AB9, "squad_gestures_idle_count" },
    { 0x8ABA, "squad_gestures_joker" },
    { 0x8ABB, "squad_gestures_wait_count" },
    { 0x8ABC, "squad_heli_zip" },
    { 0x8ABD, "squad_ignore_all_start" },
    { 0x8ABE, "squad_ignore_all_stop" },
    { 0x8ABF, "squad_intro_anim_ajani" },
    { 0x8AC0, "squad_intro_anim_burke" },
    { 0x8AC1, "squad_intro_anim_joker" },
    { 0x8AC2, "squad_intro_fov_shift_off" },
    { 0x8AC3, "squad_intro_fov_shift_on" },
    { 0x8AC4, "squad_intro_walkway_goto" },
    { 0x8AC5, "squad_move_interior" },
    { 0x8AC6, "squad_move_out_dialogue" },
    { 0x8AC7, "squad_opening" },
    { 0x8AC8, "squad_opening_names" },
    { 0x8AC9, "squad_opening_warbird" },
    { 0x8ACA, "squadcanburst" },
    { 0x8ACB, "squadchange" },
    { 0x8ACC, "squadcreatefuncs" },
    { 0x8ACD, "squadcreatestrings" },
    { 0x8ACE, "squadflavorbursttransmissions" },
    { 0x8ACF, "squadhasofficer" },
    { 0x8AD0, "squadid" },
    { 0x8AD1, "squadindex" },
    { 0x8AD2, "squadinitialized" },
    { 0x8AD3, "squadlist" },
    { 0x8AD4, "squadmate_agent_think" },
    { 0x8AD5, "squadnum" },
    { 0x8AD6, "squadofficerwaiter" },
    { 0x8AD7, "squadrand" },
    { 0x8AD8, "squads" },
    { 0x8AD9, "squadstates" },
    { 0x8ADA, "squadthreatwaiter" },
    { 0x8ADB, "squadtracker" },
    { 0x8ADC, "squadupdatefuncs" },
    { 0x8ADD, "squadupdatestrings" },
    { 0x8ADE, "sr_ally_near_tag" },
    { 0x8ADF, "sr_camp_tag" },
    { 0x8AE0, "sr_pick_up_tag" },
    { 0x8AE1, "sr_respawn" },
    { 0x8AE2, "ssao_set_target_over_time_internal" },
    { 0x8AE3, "sscr_goaltime" },
    { 0x8AE4, "st_driving" },
    { 0x8AE5, "stable_unlink" },
    { 0x8AE6, "stabs" },
    { 0x8AE7, "stack" },
    { 0x8AE8, "stack_make" },
    { 0x8AE9, "stack_peek" },
    { 0x8AEA, "stack_pop" },
    { 0x8AEB, "stack_push" },
    { 0x8AEC, "stage_guy" },
    { 0x8AED, "stage1_ambush" },
    { 0x8AEE, "stage2_ambush" },
    { 0x8AEF, "stagger_env_fx" },
    { 0x8AF0, "stair_state_loop" },
    { 0x8AF1, "stair_wait" },
    { 0x8AF2, "stairwell_doors" },
    { 0x8AF3, "stalactite_fall" },
    { 0x8AF4, "stalemate" },
    { 0x8AF5, "stance" },
    { 0x8AF6, "stance_carry" },
    { 0x8AF7, "stance_carry_icon_disable" },
    { 0x8AF8, "stance_carry_icon_enable" },
    { 0x8AF9, "stance_change" },
    { 0x8AFA, "stance_change_time" },
    { 0x8AFB, "stance_handler" },
    { 0x8AFC, "stance_num" },
    { 0x8AFD, "stance_up" },
    { 0x8AFE, "stancecrouchmovement" },
    { 0x8AFF, "stancerecoiladjuster" },
    { 0x8B00, "stancestatelistener" },
    { 0x8B01, "stand_to_run_overrideanim" },
    { 0x8B02, "stand_up_if_necessary" },
    { 0x8B03, "standard_plane_controls" },
    { 0x8B04, "standard_siren_01" },
    { 0x8B05, "standard_siren_setup" },
    { 0x8B06, "standard_text_list" },
    { 0x8B07, "standardmaxhealth" },
    { 0x8B08, "standattack" },
    { 0x8B09, "standdown" },
    { 0x8B0A, "standidle" },
    { 0x8B0B, "standifmakesenemyvisible" },
    { 0x8B0C, "standing" },
    { 0x8B0D, "standing_actor_01" },
    { 0x8B0E, "standingaimblendtime" },
    { 0x8B0F, "standingaimlimits" },
    { 0x8B10, "standingmechblendtime" },
    { 0x8B11, "standingturnrate" },
    { 0x8B12, "standrun_begin" },
    { 0x8B13, "standrun_checkchangeweapon" },
    { 0x8B14, "standrun_checkreload" },
    { 0x8B15, "standrun_combatnormal" },
    { 0x8B16, "standrun_noncombatnormal" },
    { 0x8B17, "standrun_reloadinternal" },
    { 0x8B18, "standruntocrouch" },
    { 0x8B19, "standruntostand" },
    { 0x8B1A, "standstop_begin" },
    { 0x8B1B, "standtocrouch" },
    { 0x8B1C, "standtoprone" },
    { 0x8B1D, "standtopronerun" },
    { 0x8B1E, "standtopronewalk" },
    { 0x8B1F, "standwalk_begin" },
    { 0x8B20, "standwalktocrouch" },
    { 0x8B21, "standwalktostand" },
    { 0x8B22, "star" },
    { 0x8B23, "start" },
    { 0x8B24, "start_after_crash_traffic" },
    { 0x8B25, "start_airlock_anim_notetracks" },
    { 0x8B26, "start_alarm_post_reactor" },
    { 0x8B27, "start_alias_data" },
    { 0x8B28, "start_alley1" },
    { 0x8B29, "start_alley2" },
    { 0x8B2A, "start_alleys_checkpoint" },
    { 0x8B2B, "start_alleys_combat_music" },
    { 0x8B2C, "start_alleys_music" },
    { 0x8B2D, "start_alleys_transition_checkpoint" },
    { 0x8B2E, "start_alleyway" },
    { 0x8B2F, "start_ambient_event" },
    { 0x8B30, "start_ambient_jet" },
    { 0x8B31, "start_ambient_pair_kick" },
    { 0x8B32, "start_ams" },
    { 0x8B33, "start_ams_thread" },
    { 0x8B34, "start_angle" },
    { 0x8B35, "start_angles" },
    { 0x8B36, "start_anim" },
    { 0x8B37, "start_arrays" },
    { 0x8B38, "start_atrium_breach_music" },
    { 0x8B39, "start_atrium_fight" },
    { 0x8B3A, "start_attack_heli" },
    { 0x8B3B, "start_autopsy" },
    { 0x8B3C, "start_autopsy_alarm" },
    { 0x8B3D, "start_autopsy_halls" },
    { 0x8B3E, "start_avalanche" },
    { 0x8B3F, "start_battle_to_heli" },
    { 0x8B40, "start_bedroom" },
    { 0x8B41, "start_big_cave" },
    { 0x8B42, "start_billboard_ads" },
    { 0x8B43, "start_blocking_police" },
    { 0x8B44, "start_boat" },
    { 0x8B45, "start_boatcrash" },
    { 0x8B46, "start_boatjump" },
    { 0x8B47, "start_boatmall" },
    { 0x8B48, "start_boatwarbird" },
    { 0x8B49, "start_bobbing" },
    { 0x8B4A, "start_bobbing_single" },
    { 0x8B4B, "start_boost" },
    { 0x8B4C, "start_bridge" },
    { 0x8B4D, "start_bridge_after_loop" },
    { 0x8B4E, "start_bridge_capture" },
    { 0x8B4F, "start_bridge_end_foley" },
    { 0x8B50, "start_bridge_heli" },
    { 0x8B51, "start_bridge_helis" },
    { 0x8B52, "start_bridge_overwatch_heli" },
    { 0x8B53, "start_briefing" },
    { 0x8B54, "start_burke_ambush_slomo" },
    { 0x8B55, "start_burke_boost_kick" },
    { 0x8B56, "start_burke_elevator_slide" },
    { 0x8B57, "start_burke_foley" },
    { 0x8B58, "start_bus_moving_before_anim_ends" },
    { 0x8B59, "start_cafe_cam_mvmnt_loops" },
    { 0x8B5A, "start_camera_static" },
    { 0x8B5B, "start_canal" },
    { 0x8B5C, "start_cao_anims" },
    { 0x8B5D, "start_car_alarm" },
    { 0x8B5E, "start_cave_entry" },
    { 0x8B5F, "start_cave_hallway" },
    { 0x8B60, "start_cc_open_combat" },
    { 0x8B61, "start_circling_heli" },
    { 0x8B62, "start_civilian_group" },
    { 0x8B63, "start_civilian_loop_anims" },
    { 0x8B64, "start_cliff_rappel" },
    { 0x8B65, "start_climb" },
    { 0x8B66, "start_climbcrates" },
    { 0x8B67, "start_climbroof" },
    { 0x8B68, "start_climbskybridge" },
    { 0x8B69, "start_color" },
    { 0x8B6A, "start_combat_cave" },
    { 0x8B6B, "start_conf_center_combat_checkpoint" },
    { 0x8B6C, "start_conf_center_intro_checkpoint" },
    { 0x8B6D, "start_conf_center_kill_checkpoint" },
    { 0x8B6E, "start_conf_center_outro_checkpoint" },
    { 0x8B6F, "start_conf_center_support1_checkpoint" },
    { 0x8B70, "start_conf_center_support2_checkpoint" },
    { 0x8B71, "start_conf_center_support3_checkpoint" },
    { 0x8B72, "start_confrontation" },
    { 0x8B73, "start_confrontation_qte" },
    { 0x8B74, "start_construction_heli" },
    { 0x8B75, "start_control_room" },
    { 0x8B76, "start_control_room_alarms" },
    { 0x8B77, "start_control_room_entrance" },
    { 0x8B78, "start_control_room_exit" },
    { 0x8B79, "start_control_room_explo" },
    { 0x8B7A, "start_cooling_tower" },
    { 0x8B7B, "start_courtyard" },
    { 0x8B7C, "start_courtyard_alarms" },
    { 0x8B7D, "start_courtyard_jammer" },
    { 0x8B7E, "start_cqb_when_near" },
    { 0x8B7F, "start_crash" },
    { 0x8B80, "start_crash_bus" },
    { 0x8B81, "start_crash_site" },
    { 0x8B82, "start_crash_suvs" },
    { 0x8B83, "start_dead_guy_foley" },
    { 0x8B84, "start_deck" },
    { 0x8B85, "start_demo_with_itiot" },
    { 0x8B86, "start_description" },
    { 0x8B87, "start_det_catch_guy_01" },
    { 0x8B88, "start_det_catch_guy_02" },
    { 0x8B89, "start_dialogue_threads" },
    { 0x8B8A, "start_display_cleanup" },
    { 0x8B8B, "start_dist" },
    { 0x8B8C, "start_docks" },
    { 0x8B8D, "start_door_kick" },
    { 0x8B8E, "start_drive_in" },
    { 0x8B8F, "start_drone_barrage_submix" },
    { 0x8B90, "start_drone_death_static" },
    { 0x8B91, "start_drone_deploy_anim" },
    { 0x8B92, "start_drone_spawns" },
    { 0x8B93, "start_elevator_zone_audio" },
    { 0x8B94, "start_end_escape" },
    { 0x8B95, "start_end_takedown_highway_path_player_side" },
    { 0x8B96, "start_end_takedown_traffic_done" },
    { 0x8B97, "start_ending_ambush_checkpoint" },
    { 0x8B98, "start_ending_fight_checkpoint" },
    { 0x8B99, "start_ending_hades_checkpoint" },
    { 0x8B9A, "start_enemy_callout_vo" },
    { 0x8B9B, "start_ent_count" },
    { 0x8B9C, "start_ents" },
    { 0x8B9D, "start_escape" },
    { 0x8B9E, "start_exfil" },
    { 0x8B9F, "start_exit_drive" },
    { 0x8BA0, "start_exo_mute" },
    { 0x8BA1, "start_exo_ping" },
    { 0x8BA2, "start_exo_sonic_attack_fail" },
    { 0x8BA3, "start_exopush" },
    { 0x8BA4, "start_facility_breach" },
    { 0x8BA5, "start_fardist" },
    { 0x8BA6, "start_finale_fight_music" },
    { 0x8BA7, "start_finale_h2h_music" },
    { 0x8BA8, "start_finale_suv_damage" },
    { 0x8BA9, "start_finale_transition_music" },
    { 0x8BAA, "start_fire_steam_loops" },
    { 0x8BAB, "start_fire_suppression_group" },
    { 0x8BAC, "start_firing" },
    { 0x8BAD, "start_fixed_scanner_audio" },
    { 0x8BAE, "start_flank" },
    { 0x8BAF, "start_flank_alley" },
    { 0x8BB0, "start_fly" },
    { 0x8BB1, "start_flying_attack_drone" },
    { 0x8BB2, "start_flying_attack_drones" },
    { 0x8BB3, "start_foam_room" },
    { 0x8BB4, "start_forest" },
    { 0x8BB5, "start_forest_takedown" },
    { 0x8BB6, "start_freeway_music" },
    { 0x8BB7, "start_frogger" },
    { 0x8BB8, "start_functions" },
    { 0x8BB9, "start_funeral" },
    { 0x8BBA, "start_fuorescent_light_hum" },
    { 0x8BBB, "start_fx_by_view" },
    { 0x8BBC, "start_fx_by_view_failsafe" },
    { 0x8BBD, "start_gate_breach_music" },
    { 0x8BBE, "start_gatedoor" },
    { 0x8BBF, "start_gaz_02_retreat" },
    { 0x8BC0, "start_gaz_03_retreat" },
    { 0x8BC1, "start_glow" },
    { 0x8BC2, "start_government_building" },
    { 0x8BC3, "start_government_courtyard" },
    { 0x8BC4, "start_grapple" },
    { 0x8BC5, "start_hack_security" },
    { 0x8BC6, "start_hades_breach" },
    { 0x8BC7, "start_hades_breach_door" },
    { 0x8BC8, "start_hades_breach_guard" },
    { 0x8BC9, "start_hades_breach_npc" },
    { 0x8BCA, "start_hades_breach_npc1" },
    { 0x8BCB, "start_hades_breach_npc2" },
    { 0x8BCC, "start_hades_double_stinger" },
    { 0x8BCD, "start_hades_flashbang" },
    { 0x8BCE, "start_hades_kill_interact_fail" },
    { 0x8BCF, "start_hades_suv_extraction" },
    { 0x8BD0, "start_hades_transition" },
    { 0x8BD1, "start_halls_to_autopsy" },
    { 0x8BD2, "start_hangar" },
    { 0x8BD3, "start_hdrcolorintensity" },
    { 0x8BD4, "start_hdrsuncolorintensity" },
    { 0x8BD5, "start_heli_custom_aim" },
    { 0x8BD6, "start_heliride" },
    { 0x8BD7, "start_hologram_audio" },
    { 0x8BD8, "start_hospital" },
    { 0x8BD9, "start_hospital_capture_animation" },
    { 0x8BDA, "start_ice_bridge" },
    { 0x8BDB, "start_idle_shooting" },
    { 0x8BDC, "start_ied_convoy_ambush_expl" },
    { 0x8BDD, "start_ied_convoy_slomo_end" },
    { 0x8BDE, "start_incinerator" },
    { 0x8BDF, "start_infil" },
    { 0x8BE0, "start_information_center" },
    { 0x8BE1, "start_intel" },
    { 0x8BE2, "start_interior" },
    { 0x8BE3, "start_interior_alarms" },
    { 0x8BE4, "start_intro" },
    { 0x8BE5, "start_intro_ambience" },
    { 0x8BE6, "start_intro_drive" },
    { 0x8BE7, "start_intro_drone" },
    { 0x8BE8, "start_intro_fly_in" },
    { 0x8BE9, "start_intro_fly_in_part2" },
    { 0x8BEA, "start_intro_npc_foley" },
    { 0x8BEB, "start_intro_skip" },
    { 0x8BEC, "start_intro_squad" },
    { 0x8BED, "start_introdrive" },
    { 0x8BEE, "start_irons_chase" },
    { 0x8BEF, "start_jerk_driver" },
    { 0x8BF0, "start_jerk_driver_car" },
    { 0x8BF1, "start_jump_grapple" },
    { 0x8BF2, "start_kdrone_launch" },
    { 0x8BF3, "start_kdrone_loop" },
    { 0x8BF4, "start_knocked_to_oncoming" },
    { 0x8BF5, "start_kva_assault_music" },
    { 0x8BF6, "start_kva_follow_music" },
    { 0x8BF7, "start_lab" },
    { 0x8BF8, "start_lab_alarms" },
    { 0x8BF9, "start_lake" },
    { 0x8BFA, "start_lake_cinema" },
    { 0x8BFB, "start_list_menu" },
    { 0x8BFC, "start_list_settext" },
    { 0x8BFD, "start_loading_bay_alarms" },
    { 0x8BFE, "start_lobby" },
    { 0x8BFF, "start_lobby_anims" },
    { 0x8C00, "start_logging_road" },
    { 0x8C01, "start_look" },
    { 0x8C02, "start_looping_intro_alarm_sounds" },
    { 0x8C03, "start_looping_outro_alarm_sounds" },
    { 0x8C04, "start_mb1" },
    { 0x8C05, "start_mb1_intro" },
    { 0x8C06, "start_mb1_jump" },
    { 0x8C07, "start_mb1_mech" },
    { 0x8C08, "start_mb2" },
    { 0x8C09, "start_mb2_gatesmash" },
    { 0x8C0A, "start_mech" },
    { 0x8C0B, "start_mech_march" },
    { 0x8C0C, "start_meet_cormack_pt2" },
    { 0x8C0D, "start_menu" },
    { 0x8C0E, "start_menu_update" },
    { 0x8C0F, "start_middle_takedown" },
    { 0x8C10, "start_middle_takedown_highway_path_player_side" },
    { 0x8C11, "start_mocap_ar" },
    { 0x8C12, "start_monitor_escape_artist" },
    { 0x8C13, "start_monitor_microwave_grenades" },
    { 0x8C14, "start_movie_capture" },
    { 0x8C15, "start_moving" },
    { 0x8C16, "start_moving_with_bob" },
    { 0x8C17, "start_narrow_cave" },
    { 0x8C18, "start_neardist" },
    { 0x8C19, "start_nogame" },
    { 0x8C1A, "start_notetrack_wait" },
    { 0x8C1B, "start_off_running" },
    { 0x8C1C, "start_office" },
    { 0x8C1D, "start_oldtown" },
    { 0x8C1E, "start_oncoming" },
    { 0x8C1F, "start_oncoming_alley" },
    { 0x8C20, "start_oncoming_downhill" },
    { 0x8C21, "start_one_handed_gunplay" },
    { 0x8C22, "start_opacity" },
    { 0x8C23, "start_origin" },
    { 0x8C24, "start_outro" },
    { 0x8C25, "start_outside_alarm" },
    { 0x8C26, "start_overlay" },
    { 0x8C27, "start_overlook" },
    { 0x8C28, "start_pa_airlockclosing" },
    { 0x8C29, "start_pa_codered" },
    { 0x8C2A, "start_pa_emergency_exit" },
    { 0x8C2B, "start_pa_emergency_turbine" },
    { 0x8C2C, "start_parked_police_car_radio" },
    { 0x8C2D, "start_penthouse" },
    { 0x8C2E, "start_pitbull" },
    { 0x8C2F, "start_pitbull_skirmish" },
    { 0x8C30, "start_pitch" },
    { 0x8C31, "start_plant_tracker" },
    { 0x8C32, "start_player_diveboat_ride" },
    { 0x8C33, "start_player_elevator_jump" },
    { 0x8C34, "start_player_elevator_slide" },
    { 0x8C35, "start_player_office_scene_walk_sway" },
    { 0x8C36, "start_player_pdrone_audio" },
    { 0x8C37, "start_player_walk_sway" },
    { 0x8C38, "start_pod_sequence" },
    { 0x8C39, "start_point" },
    { 0x8C3A, "start_point_check" },
    { 0x8C3B, "start_point_grapple" },
    { 0x8C3C, "start_point_intro" },
    { 0x8C3D, "start_point_is_after" },
    { 0x8C3E, "start_point_is_before" },
    { 0x8C3F, "start_point_is_between" },
    { 0x8C40, "start_point_scripted" },
    { 0x8C41, "start_point_source_dambs" },
    { 0x8C42, "start_police" },
    { 0x8C43, "start_police_standoff" },
    { 0x8C44, "start_pos" },
    { 0x8C45, "start_position" },
    { 0x8C46, "start_post_courtyard_ext_alarms" },
    { 0x8C47, "start_post_courtyard_ext_alarms_2" },
    { 0x8C48, "start_post_courtyard_interior_alarms" },
    { 0x8C49, "start_post_h_breach" },
    { 0x8C4A, "start_post_middle_takedown" },
    { 0x8C4B, "start_pre_h_breach" },
    { 0x8C4C, "start_pre_loading_bay" },
    { 0x8C4D, "start_pre_reactor_alarms" },
    { 0x8C4E, "start_prelobby_anims" },
    { 0x8C4F, "start_railgun_hud" },
    { 0x8C50, "start_reactor" },
    { 0x8C51, "start_reactor_airlock_open" },
    { 0x8C52, "start_reactor_burke_attack" },
    { 0x8C53, "start_reactor_exit" },
    { 0x8C54, "start_reactor_zone_audio" },
    { 0x8C55, "start_recon" },
    { 0x8C56, "start_refugee_camp" },
    { 0x8C57, "start_repulsor" },
    { 0x8C58, "start_research_facility_bridge" },
    { 0x8C59, "start_reverse_hint" },
    { 0x8C5A, "start_roof" },
    { 0x8C5B, "start_rooftop_combat" },
    { 0x8C5C, "start_rough_tide" },
    { 0x8C5D, "start_roundabout" },
    { 0x8C5E, "start_run_to_heli" },
    { 0x8C5F, "start_s1_elevator" },
    { 0x8C60, "start_s1elevator" },
    { 0x8C61, "start_s2_elevator" },
    { 0x8C62, "start_s2_walk" },
    { 0x8C63, "start_s2elevator" },
    { 0x8C64, "start_s2walk" },
    { 0x8C65, "start_s3escape" },
    { 0x8C66, "start_s3interrogate" },
    { 0x8C67, "start_s3trolley" },
    { 0x8C68, "start_safehouse_clear_checkpoint" },
    { 0x8C69, "start_safehouse_exit_checkpoint" },
    { 0x8C6A, "start_safehouse_exo_trans_music" },
    { 0x8C6B, "start_safehouse_follow_checkpoint" },
    { 0x8C6C, "start_safehouse_guard_03_music" },
    { 0x8C6D, "start_safehouse_intro_checkpoint" },
    { 0x8C6E, "start_safehouse_stairs_music" },
    { 0x8C6F, "start_safehouse_stealth_music" },
    { 0x8C70, "start_safehouse_transition_checkpoint" },
    { 0x8C71, "start_safehouse_xslice_checkpoint" },
    { 0x8C72, "start_school" },
    { 0x8C73, "start_school_basement" },
    { 0x8C74, "start_school_before_fall" },
    { 0x8C75, "start_school_interior" },
    { 0x8C76, "start_school_wall_grab" },
    { 0x8C77, "start_search_drone_behavior_when_pdrone_follower_spawned" },
    { 0x8C78, "start_security_center" },
    { 0x8C79, "start_security_room" },
    { 0x8C7A, "start_seeker_audio" },
    { 0x8C7B, "start_sentinel_reveal" },
    { 0x8C7C, "start_seoul_building_jump_sequence" },
    { 0x8C7D, "start_seoul_canal_combat_pt2" },
    { 0x8C7E, "start_seoul_canal_combat_start" },
    { 0x8C7F, "start_seoul_canal_intro" },
    { 0x8C80, "start_seoul_cover_art" },
    { 0x8C81, "start_seoul_drone_swarm_intro" },
    { 0x8C82, "start_seoul_e3_presentation" },
    { 0x8C83, "start_seoul_enemy_encounter_01" },
    { 0x8C84, "start_seoul_finale_scene_start" },
    { 0x8C85, "start_seoul_first_land_assist" },
    { 0x8C86, "start_seoul_forward_operating_base" },
    { 0x8C87, "start_seoul_hotel_entrance" },
    { 0x8C88, "start_seoul_intro" },
    { 0x8C89, "start_seoul_missle_evade_sequence" },
    { 0x8C8A, "start_seoul_shopping_district_flee_swarm" },
    { 0x8C8B, "start_seoul_shopping_district_start" },
    { 0x8C8C, "start_seoul_sinkhole_start" },
    { 0x8C8D, "start_seoul_subway_start" },
    { 0x8C8E, "start_seoul_truck_push" },
    { 0x8C8F, "start_server_room" },
    { 0x8C90, "start_sewer" },
    { 0x8C91, "start_shooting_rail" },
    { 0x8C92, "start_shore_pcap" },
    { 0x8C93, "start_silo_approach" },
    { 0x8C94, "start_silo_exhaust_entrance" },
    { 0x8C95, "start_silo_floor_03" },
    { 0x8C96, "start_sky_bridge" },
    { 0x8C97, "start_skyfogintensity" },
    { 0x8C98, "start_skyfogmaxangle" },
    { 0x8C99, "start_skyfogminangle" },
    { 0x8C9A, "start_slow_mo" },
    { 0x8C9B, "start_smoke_pillar_black_large_fast_fx" },
    { 0x8C9C, "start_smoke_pillar_black_large_slow_fx" },
    { 0x8C9D, "start_smoke_pillar_gray_large_fast_fx" },
    { 0x8C9E, "start_sniper_drone" },
    { 0x8C9F, "start_sniper_drone_audio" },
    { 0x8CA0, "start_sniper_drone_death" },
    { 0x8CA1, "start_sniper_drone_deploy" },
    { 0x8CA2, "start_sniper_drone_loops" },
    { 0x8CA3, "start_sniper_drone_zoom" },
    { 0x8CA4, "start_sniper_scramble_drones_checkpoint" },
    { 0x8CA5, "start_sniper_scramble_finale_checkpoint" },
    { 0x8CA6, "start_sniper_scramble_hotel_checkpoint" },
    { 0x8CA7, "start_sniper_scramble_intro_checkpoint" },
    { 0x8CA8, "start_sniper_scramble_music" },
    { 0x8CA9, "start_sonic_attack_mix" },
    { 0x8CAA, "start_spawn_allies" },
    { 0x8CAB, "start_spawn_axis" },
    { 0x8CAC, "start_spawn_prefix" },
    { 0x8CAD, "start_spawns_near_attackers" },
    { 0x8CAE, "start_squad_member_at_start" },
    { 0x8CAF, "start_stage_dialog" },
    { 0x8CB0, "start_stealth_music" },
    { 0x8CB1, "start_street" },
    { 0x8CB2, "start_street_heli" },
    { 0x8CB3, "start_struct" },
    { 0x8CB4, "start_sunbeginfadeangle" },
    { 0x8CB5, "start_suncolor" },
    { 0x8CB6, "start_sundir" },
    { 0x8CB7, "start_sunendfadeangle" },
    { 0x8CB8, "start_sunfogscale" },
    { 0x8CB9, "start_swarm_drones_context" },
    { 0x8CBA, "start_sweep_mode_func" },
    { 0x8CBB, "start_swim" },
    { 0x8CBC, "start_tank_board" },
    { 0x8CBD, "start_tank_field" },
    { 0x8CBE, "start_tank_hangar" },
    { 0x8CBF, "start_tank_road" },
    { 0x8CC0, "start_tanker_explosion" },
    { 0x8CC1, "start_tanker_fire" },
    { 0x8CC2, "start_tanker_on_ramp_traffic" },
    { 0x8CC3, "start_teleport" },
    { 0x8CC4, "start_tennis_court_alert" },
    { 0x8CC5, "start_test_chamber" },
    { 0x8CC6, "start_thread" },
    { 0x8CC7, "start_threat_grenade_mixer" },
    { 0x8CC8, "start_time" },
    { 0x8CC9, "start_tour_augmented_reality" },
    { 0x8CCA, "start_tour_end" },
    { 0x8CCB, "start_tour_exo" },
    { 0x8CCC, "start_tour_exo_exit" },
    { 0x8CCD, "start_tour_firing_range" },
    { 0x8CCE, "start_tour_ride" },
    { 0x8CCF, "start_tower_bells" },
    { 0x8CD0, "start_track_irons" },
    { 0x8CD1, "start_traffic_frogger" },
    { 0x8CD2, "start_traffic_lane" },
    { 0x8CD3, "start_traffic_traverse" },
    { 0x8CD4, "start_training_01" },
    { 0x8CD5, "start_training_01_end" },
    { 0x8CD6, "start_training_01_golf_course" },
    { 0x8CD7, "start_training_01_lodge" },
    { 0x8CD8, "start_training_01_lodge_breach" },
    { 0x8CD9, "start_training_01_lodge_exit" },
    { 0x8CDA, "start_training_02" },
    { 0x8CDB, "start_training_02_end" },
    { 0x8CDC, "start_training_02_golf_course" },
    { 0x8CDD, "start_training_02_lodge" },
    { 0x8CDE, "start_training_02_lodge_breach" },
    { 0x8CDF, "start_training_02_lodge_exit" },
    { 0x8CE0, "start_trans_to_alleys_panic" },
    { 0x8CE1, "start_transients" },
    { 0x8CE2, "start_traverse" },
    { 0x8CE3, "start_trolley" },
    { 0x8CE4, "start_tunnel" },
    { 0x8CE5, "start_turbine_door_breach" },
    { 0x8CE6, "start_turbine_door_impt" },
    { 0x8CE7, "start_turbine_elevator" },
    { 0x8CE8, "start_turbine_elevator_alarm" },
    { 0x8CE9, "start_turbine_loop" },
    { 0x8CEA, "start_turbine_room" },
    { 0x8CEB, "start_van" },
    { 0x8CEC, "start_van_takedown" },
    { 0x8CED, "start_van_takedown_underwater" },
    { 0x8CEE, "start_veh_moving_truck" },
    { 0x8CEF, "start_vehicle_traffic" },
    { 0x8CF0, "start_vehicle_traffic_highway_traverse" },
    { 0x8CF1, "start_vehicle_traffic_highway_traverse_player_side" },
    { 0x8CF2, "start_vehicle_traffic_roundabout_straightways" },
    { 0x8CF3, "start_videochat_screen_turn_off" },
    { 0x8CF4, "start_videochat_screen_turn_on" },
    { 0x8CF5, "start_vtol_crash" },
    { 0x8CF6, "start_vtol_takedown" },
    { 0x8CF7, "start_wasp_death_explo" },
    { 0x8CF8, "start_wasp_flicker" },
    { 0x8CF9, "start_wasp_missile_warning" },
    { 0x8CFA, "start_water_breach" },
    { 0x8CFB, "start_wave_mist_fx" },
    { 0x8CFC, "start_will_room" },
    { 0x8CFD, "start_x" },
    { 0x8CFE, "startadrenaline" },
    { 0x8CFF, "startaiming" },
    { 0x8D00, "startalleysdialoguethreads" },
    { 0x8D01, "startamplifyobjectvfx" },
    { 0x8D02, "startangles" },
    { 0x8D03, "startcanisterfx" },
    { 0x8D04, "startclientspawnpointtraces" },
    { 0x8D05, "startcloakingbinksequence" },
    { 0x8D06, "startcloakingbinksequence_debug" },
    { 0x8D07, "startcombat" },
    { 0x8D08, "startconfcenterdialoguethreads" },
    { 0x8D09, "startcoverapproach" },
    { 0x8D0A, "startdialoguethreads" },
    { 0x8D0B, "startdist" },
    { 0x8D0C, "startdnadronelights" },
    { 0x8D0D, "startdot_group" },
    { 0x8D0E, "startdot_player" },
    { 0x8D0F, "startdrivenmovement" },
    { 0x8D10, "startdronecontrol" },
    { 0x8D11, "startdyingcrawlbackaimsoon" },
    { 0x8D12, "started_bank" },
    { 0x8D13, "started_moving" },
    { 0x8D14, "started_to_grapple_to_vtol_but_aborted_watcher" },
    { 0x8D15, "startexorecoverykillstreak" },
    { 0x8D16, "startexplosivedrone" },
    { 0x8D17, "startexteriordnadrones" },
    { 0x8D18, "startextrahealth" },
    { 0x8D19, "startfastheal" },
    { 0x8D1A, "startfireandaimidlethread" },
    { 0x8D1B, "startflashing" },
    { 0x8D1C, "startgame" },
    { 0x8D1D, "startgrenadelightfx" },
    { 0x8D1E, "startharmonicbreach" },
    { 0x8D1F, "startheavylifterfx" },
    { 0x8D20, "startheligroundfx" },
    { 0x8D21, "starthighlightingplayer" },
    { 0x8D22, "starthighlightingplayerexplosive" },
    { 0x8D23, "startidletransitionanim" },
    { 0x8D24, "starting_bridge_collapse" },
    { 0x8D25, "starting_fire_01" },
    { 0x8D26, "starting_origin" },
    { 0x8D27, "starting_side_fx" },
    { 0x8D28, "starting_speed" },
    { 0x8D29, "startingorigin" },
    { 0x8D2A, "startinteriordnadrones" },
    { 0x8D2B, "startlaserlights" },
    { 0x8D2C, "startlasersounds" },
    { 0x8D2D, "startmanhandling" },
    { 0x8D2E, "startmonitoringflash" },
    { 0x8D2F, "startmove" },
    { 0x8D30, "startmove_updateangle" },
    { 0x8D31, "startmovetransition" },
    { 0x8D32, "startmovetransitionanim" },
    { 0x8D33, "startmutebomb" },
    { 0x8D34, "startnoncombat" },
    { 0x8D35, "startnotelisten" },
    { 0x8D36, "startorigin" },
    { 0x8D37, "startospbuddyexitcommand" },
    { 0x8D38, "startpath_with_currentnode_update" },
    { 0x8D39, "startpoint1" },
    { 0x8D3A, "startpoint2" },
    { 0x8D3B, "startpos" },
    { 0x8D3C, "startposoffset" },
    { 0x8D3D, "startriotshielddeploy" },
    { 0x8D3E, "startriotsuppressionsystem" },
    { 0x8D3F, "startround" },
    { 0x8D40, "startspawnpoints" },
    { 0x8D41, "startspectatemode" },
    { 0x8D42, "startstreaksupportprompt" },
    { 0x8D43, "startthreadstorunwhilemoving" },
    { 0x8D44, "starttime" },
    { 0x8D45, "starttimepassed" },
    { 0x8D46, "starttotargetcornerangles" },
    { 0x8D47, "starttrackingdrone" },
    { 0x8D48, "startturntoangle" },
    { 0x8D49, "startusingreconvehicle" },
    { 0x8D4A, "startusingremoteturret" },
    { 0x8D4B, "startwarbirdbuddyexitcommand" },
    { 0x8D4C, "startwave" },
    { 0x8D4D, "startyaw" },
    { 0x8D4E, "stat_notify" },
    { 0x8D4F, "stat_notify_func" },
    { 0x8D50, "stat_notify_register_func" },
    { 0x8D51, "stat_track_damage_func" },
    { 0x8D52, "stat_track_kill_func" },
    { 0x8D53, "statadd" },
    { 0x8D54, "stataddbuffered" },
    { 0x8D55, "stataddbufferedwithmax" },
    { 0x8D56, "stataddchild" },
    { 0x8D57, "stataddchildbuffered" },
    { 0x8D58, "stataddchildbufferedwithmax" },
    { 0x8D59, "state" },
    { 0x8D5A, "state_chaingun_pump" },
    { 0x8D5B, "state_change" },
    { 0x8D5C, "state_data" },
    { 0x8D5D, "state_group_list" },
    { 0x8D5E, "state_groups" },
    { 0x8D5F, "state_last" },
    { 0x8D60, "state_loop" },
    { 0x8D61, "state_main_pump" },
    { 0x8D62, "state_num" },
    { 0x8D63, "state_print_priority" },
    { 0x8D64, "state_rocket_pump" },
    { 0x8D65, "state_swarm_pump" },
    { 0x8D66, "state_timer" },
    { 0x8D67, "state_under_construction" },
    { 0x8D68, "statefns" },
    { 0x8D69, "statements" },
    { 0x8D6A, "states" },
    { 0x8D6B, "statget" },
    { 0x8D6C, "statgetbuffered" },
    { 0x8D6D, "statgetchild" },
    { 0x8D6E, "statgetchildbuffered" },
    { 0x8D6F, "static" },
    { 0x8D70, "static_length" },
    { 0x8D71, "static_origin" },
    { 0x8D72, "static_overlay" },
    { 0x8D73, "static_sight_blocker" },
    { 0x8D74, "static_sphere_center" },
    { 0x8D75, "static_sphere_radius" },
    { 0x8D76, "staticlevel" },
    { 0x8D77, "staticlevelwaittime" },
    { 0x8D78, "stationary" },
    { 0x8D79, "stationary_anim_pose" },
    { 0x8D7A, "stats" },
    { 0x8D7B, "statset" },
    { 0x8D7C, "statsetbuffered" },
    { 0x8D7D, "statsetchild" },
    { 0x8D7E, "statsetchildbuffered" },
    { 0x8D7F, "status" },
    { 0x8D80, "statusdialog" },
    { 0x8D81, "statvaluechanged" },
    { 0x8D82, "stay_low_nags" },
    { 0x8D83, "stay_on_mission" },
    { 0x8D84, "stayontag" },
    { 0x8D85, "stealth_accuracy_friendly_main" },
    { 0x8D86, "stealth_accuracy_state_custom" },
    { 0x8D87, "stealth_accuracy_state_default" },
    { 0x8D88, "stealth_ai_clear_custom_idle_and_react" },
    { 0x8D89, "stealth_ai_clear_custom_react" },
    { 0x8D8A, "stealth_ai_event_dist_custom" },
    { 0x8D8B, "stealth_ai_event_dist_default" },
    { 0x8D8C, "stealth_ai_idle_and_react" },
    { 0x8D8D, "stealth_ai_idle_and_react_custom" },
    { 0x8D8E, "stealth_ai_reach_and_arrive_idle_and_react" },
    { 0x8D8F, "stealth_ai_reach_and_arrive_idle_and_react_proc" },
    { 0x8D90, "stealth_ai_reach_idle_and_react" },
    { 0x8D91, "stealth_ai_reach_idle_and_react_proc" },
    { 0x8D92, "stealth_ai_react" },
    { 0x8D93, "stealth_alert_level_duration" },
    { 0x8D94, "stealth_alerted_drone_monitor" },
    { 0x8D95, "stealth_anim" },
    { 0x8D96, "stealth_anim_custom_animmode" },
    { 0x8D97, "stealth_basic_states_custom" },
    { 0x8D98, "stealth_basic_states_default" },
    { 0x8D99, "stealth_behavior_enemy_main" },
    { 0x8D9A, "stealth_behavior_friendly_main" },
    { 0x8D9B, "stealth_behavior_system_init" },
    { 0x8D9C, "stealth_behavior_system_main" },
    { 0x8D9D, "stealth_broken_dialogue" },
    { 0x8D9E, "stealth_can_be_seen" },
    { 0x8D9F, "stealth_color_friendly_main" },
    { 0x8DA0, "stealth_color_state_custom" },
    { 0x8DA1, "stealth_color_state_default" },
    { 0x8DA2, "stealth_corpse_behavior_custom" },
    { 0x8DA3, "stealth_corpse_behavior_default" },
    { 0x8DA4, "stealth_corpse_collect_func" },
    { 0x8DA5, "stealth_corpse_default_collect_func" },
    { 0x8DA6, "stealth_corpse_default_distances" },
    { 0x8DA7, "stealth_corpse_default_forget_time" },
    { 0x8DA8, "stealth_corpse_default_reset_time" },
    { 0x8DA9, "stealth_corpse_enemy_main" },
    { 0x8DAA, "stealth_corpse_forget_time_custom" },
    { 0x8DAB, "stealth_corpse_forget_time_default" },
    { 0x8DAC, "stealth_corpse_ranges_custom" },
    { 0x8DAD, "stealth_corpse_ranges_default" },
    { 0x8DAE, "stealth_corpse_reset_collect_func" },
    { 0x8DAF, "stealth_corpse_reset_time_custom" },
    { 0x8DB0, "stealth_corpse_reset_time_default" },
    { 0x8DB1, "stealth_corpse_set_collect_func" },
    { 0x8DB2, "stealth_corpse_set_distances" },
    { 0x8DB3, "stealth_corpse_set_forget_time" },
    { 0x8DB4, "stealth_corpse_set_reset_time" },
    { 0x8DB5, "stealth_corpse_system_init" },
    { 0x8DB6, "stealth_corpse_system_main" },
    { 0x8DB7, "stealth_debug_print" },
    { 0x8DB8, "stealth_default" },
    { 0x8DB9, "stealth_default_func" },
    { 0x8DBA, "stealth_delete_at_goal" },
    { 0x8DBB, "stealth_detect_ranges_default" },
    { 0x8DBC, "stealth_detect_ranges_set" },
    { 0x8DBD, "stealth_disable_seek_player_on_spotted" },
    { 0x8DBE, "stealth_disabled" },
    { 0x8DBF, "stealth_display" },
    { 0x8DC0, "stealth_display_active" },
    { 0x8DC1, "stealth_display_count" },
    { 0x8DC2, "stealth_display_hint" },
    { 0x8DC3, "stealth_display_max" },
    { 0x8DC4, "stealth_display_off" },
    { 0x8DC5, "stealth_display_on" },
    { 0x8DC6, "stealth_display_seed" },
    { 0x8DC7, "stealth_display_seed_angle" },
    { 0x8DC8, "stealth_display_thread" },
    { 0x8DC9, "stealth_display_tutorial" },
    { 0x8DCA, "stealth_display_tutorial_spawner_setup" },
    { 0x8DCB, "stealth_enable_seek_player_on_spotted" },
    { 0x8DCC, "stealth_enemy_debug_monitor" },
    { 0x8DCD, "stealth_enemy_endon_alert" },
    { 0x8DCE, "stealth_enemy_minimal_debug_monitor" },
    { 0x8DCF, "stealth_enemy_waittill_alert" },
    { 0x8DD0, "stealth_event_anim_defaults" },
    { 0x8DD1, "stealth_event_defaults" },
    { 0x8DD2, "stealth_event_enemy_main" },
    { 0x8DD3, "stealth_event_handler" },
    { 0x8DD4, "stealth_event_listener_defaults" },
    { 0x8DD5, "stealth_event_mod" },
    { 0x8DD6, "stealth_event_mod_all" },
    { 0x8DD7, "stealth_event_validate" },
    { 0x8DD8, "stealth_fail_fast" },
    { 0x8DD9, "stealth_first_alert_new_patrol_path" },
    { 0x8DDA, "stealth_flag_debug_print" },
    { 0x8DDB, "stealth_friendly_movespeed_scale_default" },
    { 0x8DDC, "stealth_friendly_movespeed_scale_set" },
    { 0x8DDD, "stealth_friendly_stance_handler_distances_default" },
    { 0x8DDE, "stealth_friendly_stance_handler_distances_set" },
    { 0x8DDF, "stealth_get_group" },
    { 0x8DE0, "stealth_get_group_corpse_flag" },
    { 0x8DE1, "stealth_get_group_spotted_flag" },
    { 0x8DE2, "stealth_group_corpse_flag" },
    { 0x8DE3, "stealth_group_corpse_flag_wait" },
    { 0x8DE4, "stealth_group_corpse_flag_waitopen" },
    { 0x8DE5, "stealth_group_return_ai_with_corpse_flag" },
    { 0x8DE6, "stealth_group_return_ai_with_event_flag" },
    { 0x8DE7, "stealth_group_return_ai_with_spotted_flag" },
    { 0x8DE8, "stealth_group_return_groups_with_corpse_flag" },
    { 0x8DE9, "stealth_group_return_groups_with_event_flag" },
    { 0x8DEA, "stealth_group_return_groups_with_spotted_flag" },
    { 0x8DEB, "stealth_group_spotted_flag" },
    { 0x8DEC, "stealth_group_spotted_flag_wait" },
    { 0x8DED, "stealth_group_spotted_flag_waitopen" },
    { 0x8DEE, "stealth_guy_think" },
    { 0x8DEF, "stealth_guy_think_on_flag" },
    { 0x8DF0, "stealth_insure_enabled" },
    { 0x8DF1, "stealth_is_everything_normal" },
    { 0x8DF2, "stealth_last_alert" },
    { 0x8DF3, "stealth_music_control_p1" },
    { 0x8DF4, "stealth_music_control_p2" },
    { 0x8DF5, "stealth_plugin_accuracy" },
    { 0x8DF6, "stealth_plugin_aicolor" },
    { 0x8DF7, "stealth_plugin_basic" },
    { 0x8DF8, "stealth_plugin_corpse" },
    { 0x8DF9, "stealth_plugin_event_all" },
    { 0x8DFA, "stealth_plugin_event_custom" },
    { 0x8DFB, "stealth_plugin_event_explosion" },
    { 0x8DFC, "stealth_plugin_event_flashbang" },
    { 0x8DFD, "stealth_plugin_event_heard_scream" },
    { 0x8DFE, "stealth_plugin_event_main" },
    { 0x8DFF, "stealth_plugin_smart_stance" },
    { 0x8E00, "stealth_plugin_threat" },
    { 0x8E01, "stealth_pre_spotted_function_custom" },
    { 0x8E02, "stealth_pre_spotted_function_default" },
    { 0x8E03, "stealth_reset_awareness" },
    { 0x8E04, "stealth_set_default_stealth_function" },
    { 0x8E05, "stealth_set_group" },
    { 0x8E06, "stealth_set_group_default" },
    { 0x8E07, "stealth_set_group_proc" },
    { 0x8E08, "stealth_set_idle_anim" },
    { 0x8E09, "stealth_set_run_anim" },
    { 0x8E0A, "stealth_shadow_ai_in_volume" },
    { 0x8E0B, "stealth_shadow_volumes" },
    { 0x8E0C, "stealth_smartstance_friendly_main" },
    { 0x8E0D, "stealth_spawn_function" },
    { 0x8E0E, "stealth_spotted_drone_death_monitor" },
    { 0x8E0F, "stealth_spotted_drone_monitor" },
    { 0x8E10, "stealth_spotted_drones" },
    { 0x8E11, "stealth_threat_behavior_custom" },
    { 0x8E12, "stealth_threat_behavior_default" },
    { 0x8E13, "stealth_threat_behavior_default_no_warnings" },
    { 0x8E14, "stealth_threat_behavior_replace" },
    { 0x8E15, "stealth_threat_enemy_main" },
    { 0x8E16, "stealth_vis_threat" },
    { 0x8E17, "stealth_visibility_enemy_main" },
    { 0x8E18, "stealth_visibility_friendly_main" },
    { 0x8E19, "stealth_visibility_system_main" },
    { 0x8E1A, "stealthairstrike_earthquake" },
    { 0x8E1B, "stealthbomber_killcam" },
    { 0x8E1C, "stealthkillvictim" },
    { 0x8E1D, "stealthnewenemyreactanim" },
    { 0x8E1E, "steam_burst_function" },
    { 0x8E1F, "steam_burst_valve_started" },
    { 0x8E20, "steam_elevator_fx" },
    { 0x8E21, "steam_spray_custom_function" },
    { 0x8E22, "steam_vent_burst_fx" },
    { 0x8E23, "stecil_when_in_view" },
    { 0x8E24, "steering" },
    { 0x8E25, "steering_enable" },
    { 0x8E26, "steering_hack" },
    { 0x8E27, "steering_maxdelta" },
    { 0x8E28, "steering_maxroll" },
    { 0x8E29, "stencil_when_cardoor_in_range" },
    { 0x8E2A, "stepout" },
    { 0x8E2B, "stepoutandhidespeed" },
    { 0x8E2C, "stepoutandshootenemy" },
    { 0x8E2D, "stepoutyaw" },
    { 0x8E2E, "stepup_112" },
    { 0x8E2F, "stepup_112_over_32" },
    { 0x8E30, "stick_to_shadows" },
    { 0x8E31, "stickexplosivegel" },
    { 0x8E32, "stickhorizontalinputlength" },
    { 0x8E33, "stickinputindeadzone" },
    { 0x8E34, "sticky_fx" },
    { 0x8E35, "sticky_threat" },
    { 0x8E36, "sticky_timer" },
    { 0x8E37, "stickyhandlemovers" },
    { 0x8E38, "stickymovingplatformdetonate" },
    { 0x8E39, "still_pressing_use" },
    { 0x8E3A, "still_pressing_use_button" },
    { 0x8E3B, "stillvalidstingerlock" },
    { 0x8E3C, "stim_fx_l" },
    { 0x8E3D, "stim_fx_r" },
    { 0x8E3E, "stinger_add_hit" },
    { 0x8E3F, "stinger_delayed_lock" },
    { 0x8E40, "stinger_fire" },
    { 0x8E41, "stinger_ignore" },
    { 0x8E42, "stinger_no_ai" },
    { 0x8E43, "stinger_override_tags" },
    { 0x8E44, "stinger_targets" },
    { 0x8E45, "stinger_track_ent_cleanup" },
    { 0x8E46, "stinger_vo" },
    { 0x8E47, "stinger_weapon" },
    { 0x8E48, "stingerdebugdraw" },
    { 0x8E49, "stingerfxid" },
    { 0x8E4A, "stingerlockonentsfunc" },
    { 0x8E4B, "stingerlockstarttime" },
    { 0x8E4C, "stingerlostsightlinetime" },
    { 0x8E4D, "stingerm7_get_target_ignore" },
    { 0x8E4E, "stingerm7_get_target_offset" },
    { 0x8E4F, "stingerm7_get_target_pos" },
    { 0x8E50, "stingerm7_get_target_tag" },
    { 0x8E51, "stingerm7_info" },
    { 0x8E52, "stingerm7_lock_los" },
    { 0x8E53, "stingerm7_lock_range" },
    { 0x8E54, "stingerm7_monitor_fire" },
    { 0x8E55, "stingerm7_shoot_tower" },
    { 0x8E56, "stingerm7_targeting" },
    { 0x8E57, "stingerm7_targeting_contains" },
    { 0x8E58, "stingerm7_targeting_remove_dead" },
    { 0x8E59, "stingerm7_think" },
    { 0x8E5A, "stingerpronestatemonitor" },
    { 0x8E5B, "stingerproximitydetonate" },
    { 0x8E5C, "stingerstage" },
    { 0x8E5D, "stingertarget" },
    { 0x8E5E, "stingerusageloop" },
    { 0x8E5F, "stingeruseentered" },
    { 0x8E60, "stock_think" },
    { 0x8E61, "stockammo" },
    { 0x8E62, "stop_aiming_for_reload" },
    { 0x8E63, "stop_alias_data" },
    { 0x8E64, "stop_all_replace_on_death" },
    { 0x8E65, "stop_all_rumble_on_time" },
    { 0x8E66, "stop_alleys_emergency_audio" },
    { 0x8E67, "stop_ambient_flare_fx" },
    { 0x8E68, "stop_ams" },
    { 0x8E69, "stop_animating_player_rig_on_flag" },
    { 0x8E6A, "stop_animating_when_exopush_over" },
    { 0x8E6B, "stop_animating_when_kva2_dead" },
    { 0x8E6C, "stop_atrium_fight" },
    { 0x8E6D, "stop_audio_intro_fly_drone_idle" },
    { 0x8E6E, "stop_back_thruster_light_rz" },
    { 0x8E6F, "stop_blend" },
    { 0x8E70, "stop_bobbing" },
    { 0x8E71, "stop_burke_ambush_slomo" },
    { 0x8E72, "stop_cafe_market_damb" },
    { 0x8E73, "stop_camshake" },
    { 0x8E74, "stop_car_alarm" },
    { 0x8E75, "stop_civilian_conversation" },
    { 0x8E76, "stop_constant_quake" },
    { 0x8E77, "stop_crane_audio" },
    { 0x8E78, "stop_current_animations" },
    { 0x8E79, "stop_diveboat_threads" },
    { 0x8E7A, "stop_drone_death_static" },
    { 0x8E7B, "stop_dynamic_run_speed" },
    { 0x8E7C, "stop_dynamic_run_speed_wait" },
    { 0x8E7D, "stop_ent_count" },
    { 0x8E7E, "stop_ents" },
    { 0x8E7F, "stop_exo_mute" },
    { 0x8E80, "stop_exo_ping" },
    { 0x8E81, "stop_exploder" },
    { 0x8E82, "stop_exploder_proc" },
    { 0x8E83, "stop_fall_foley_audio" },
    { 0x8E84, "stop_falling_debris_by_player" },
    { 0x8E85, "stop_finale_fight_music" },
    { 0x8E86, "stop_finale_h2h_music" },
    { 0x8E87, "stop_firing" },
    { 0x8E88, "stop_firing_for_death_anim" },
    { 0x8E89, "stop_flickering_fire_light" },
    { 0x8E8A, "stop_flickering_hanger_light" },
    { 0x8E8B, "stop_flickering_info_hallway_light" },
    { 0x8E8C, "stop_flickering_info_light" },
    { 0x8E8D, "stop_flickering_interior_light" },
    { 0x8E8E, "stop_flickerlight" },
    { 0x8E8F, "stop_fly" },
    { 0x8E90, "stop_front_thruster_light_rz" },
    { 0x8E91, "stop_fx_looper" },
    { 0x8E92, "stop_fx_on_death" },
    { 0x8E93, "stop_generic_enemy_vo_chatter" },
    { 0x8E94, "stop_generic_vo_chatter" },
    { 0x8E95, "stop_hades_suv_extraction" },
    { 0x8E96, "stop_handling_moving_platforms" },
    { 0x8E97, "stop_hint" },
    { 0x8E98, "stop_hint_mission_fail" },
    { 0x8E99, "stop_hovering_on_player_death" },
    { 0x8E9A, "stop_hovering_on_unload" },
    { 0x8E9B, "stop_idle_back_thruster_rz" },
    { 0x8E9C, "stop_idle_front_thruster_rz" },
    { 0x8E9D, "stop_idle_tread_front_rz" },
    { 0x8E9E, "stop_ied_convoy_ambush_expl" },
    { 0x8E9F, "stop_jammer_movie" },
    { 0x8EA0, "stop_jetbike_handle_viewmodel_anims" },
    { 0x8EA1, "stop_load" },
    { 0x8EA2, "stop_look" },
    { 0x8EA3, "stop_loop_and_react" },
    { 0x8EA4, "stop_loop_sound_on_entity" },
    { 0x8EA5, "stop_looping_beep_on_player" },
    { 0x8EA6, "stop_loopsound" },
    { 0x8EA7, "stop_magic_bullet_shield" },
    { 0x8EA8, "stop_mg_behavior_if_flanked" },
    { 0x8EA9, "stop_monitor_cinematic" },
    { 0x8EAA, "stop_moving" },
    { 0x8EAB, "stop_notify" },
    { 0x8EAC, "stop_notify_string" },
    { 0x8EAD, "stop_player_climbing" },
    { 0x8EAE, "stop_player_mag_gloves" },
    { 0x8EAF, "stop_player_pushed_kill" },
    { 0x8EB0, "stop_player_scuba" },
    { 0x8EB1, "stop_player_underwater_breath" },
    { 0x8EB2, "stop_playerwatch_unresolved_collision" },
    { 0x8EB3, "stop_post_courtyard_ext_alarms_2" },
    { 0x8EB4, "stop_pulse_light" },
    { 0x8EB5, "stop_railgun_hud" },
    { 0x8EB6, "stop_reflector_effect" },
    { 0x8EB7, "stop_regular_back_thruster_rz" },
    { 0x8EB8, "stop_regular_front_thruster_rz" },
    { 0x8EB9, "stop_regular_tail_thruster_rz" },
    { 0x8EBA, "stop_regular_tread_back_rz" },
    { 0x8EBB, "stop_regular_tread_front_rz" },
    { 0x8EBC, "stop_replace_on_death" },
    { 0x8EBD, "stop_repulsor" },
    { 0x8EBE, "stop_reviving" },
    { 0x8EBF, "stop_rumble_on_notify" },
    { 0x8EC0, "stop_scramble_emergency_audio" },
    { 0x8EC1, "stop_scriptable_primary_light" },
    { 0x8EC2, "stop_scripted_move_and_attack" },
    { 0x8EC3, "stop_seeker_audio" },
    { 0x8EC4, "stop_shooting_ambulance_timer" },
    { 0x8EC5, "stop_shooting_timer" },
    { 0x8EC6, "stop_slow_mo" },
    { 0x8EC7, "stop_smoke_pillar_black_large_fast_fx" },
    { 0x8EC8, "stop_smoke_pillar_black_large_slow_fx" },
    { 0x8EC9, "stop_smoke_pillar_gray_large_fast_fx" },
    { 0x8ECA, "stop_sniper_drone" },
    { 0x8ECB, "stop_sniper_drone_zoom" },
    { 0x8ECC, "stop_sound" },
    { 0x8ECD, "stop_sparks" },
    { 0x8ECE, "stop_speaking" },
    { 0x8ECF, "stop_swarm_drones_context" },
    { 0x8ED0, "stop_the_fighting" },
    { 0x8ED1, "stop_trans_to_alleys_panic" },
    { 0x8ED2, "stop_turbine_elevator" },
    { 0x8ED3, "stop_turret_on_gunner_death" },
    { 0x8ED4, "stop_using_crate" },
    { 0x8ED5, "stop_vehicle_traffic_roundabout_straightways" },
    { 0x8ED6, "stop_videolog" },
    { 0x8ED7, "stop_vo_on_entity" },
    { 0x8ED8, "stop_vo_on_radio" },
    { 0x8ED9, "stop_wakefx" },
    { 0x8EDA, "stop_walk_and_clear_dialogue" },
    { 0x8EDB, "stop_wasp_missile_warning" },
    { 0x8EDC, "stop_water_warning" },
    { 0x8EDD, "stop_wave_mist_fx" },
    { 0x8EDE, "stop_zip_idle_anim" },
    { 0x8EDF, "stopadrenaline" },
    { 0x8EE0, "stopaiming" },
    { 0x8EE1, "stopbeameffects" },
    { 0x8EE2, "stopcontrail" },
    { 0x8EE3, "stopcranesound" },
    { 0x8EE4, "stopdamagefunc" },
    { 0x8EE5, "stopdnadronelights" },
    { 0x8EE6, "stopeffectonplayerview" },
    { 0x8EE7, "stopextrahealth" },
    { 0x8EE8, "stopfireeffects" },
    { 0x8EE9, "stopflashing" },
    { 0x8EEA, "stopfx_fordrop" },
    { 0x8EEB, "stopfxonattachment" },
    { 0x8EEC, "stopfxonnotify" },
    { 0x8EED, "stopfxontag_functionhack" },
    { 0x8EEE, "stopfxontagdelay" },
    { 0x8EEF, "stopglow" },
    { 0x8EF0, "stopheligroundfx" },
    { 0x8EF1, "stophighlightingplayer" },
    { 0x8EF2, "stophighlightingplayerexplosive" },
    { 0x8EF3, "stopidlesound" },
    { 0x8EF4, "stoplasercontainmentend" },
    { 0x8EF5, "stoplasercontainmentswap" },
    { 0x8EF6, "stoplasercoreevent" },
    { 0x8EF7, "stoplaserlights" },
    { 0x8EF8, "stoplasersounds" },
    { 0x8EF9, "stoplocationselection" },
    { 0x8EFA, "stoplookatidle" },
    { 0x8EFB, "stopmissileboostsounds" },
    { 0x8EFC, "stopmonitordamage" },
    { 0x8EFD, "stopmonitoringflash" },
    { 0x8EFE, "stopmovementsparks" },
    { 0x8EFF, "stopmovesound" },
    { 0x8F00, "stoponback" },
    { 0x8F01, "stopped" },
    { 0x8F02, "stoppromptforstreaksupport" },
    { 0x8F03, "stoprunngun" },
    { 0x8F04, "stopscriptedanimations" },
    { 0x8F05, "stopshortly" },
    { 0x8F06, "stopshotgunpumpaftertime" },
    { 0x8F07, "stopsounds_on_death" },
    { 0x8F08, "stopthreateventtype" },
    { 0x8F09, "stoptickingsound" },
    { 0x8F0A, "stopturret" },
    { 0x8F0B, "stopusingremoteturret" },
    { 0x8F0C, "stopusingturretwhennodelost" },
    { 0x8F0D, "stopwarbirdenginefx" },
    { 0x8F0E, "stopwarmupeffects" },
    { 0x8F0F, "stopwarmupsounds" },
    { 0x8F10, "stopwatch" },
    { 0x8F11, "storage_vo" },
    { 0x8F12, "store_offsets_for_link" },
    { 0x8F13, "store_players_weapons" },
    { 0x8F14, "store_speed" },
    { 0x8F15, "storecameratargets" },
    { 0x8F16, "stored_clipsize" },
    { 0x8F17, "stored_ents" },
    { 0x8F18, "stored_stock" },
    { 0x8F19, "stored_variable_grenade" },
    { 0x8F1A, "stored_variable_grenade_ui_type" },
    { 0x8F1B, "stored_weapon" },
    { 0x8F1C, "stored_weapons" },
    { 0x8F1D, "storedangley" },
    { 0x8F1E, "storedrightsticky" },
    { 0x8F1F, "storependingreinforcement" },
    { 0x8F20, "str" },
    { 0x8F21, "strafeblendtimes" },
    { 0x8F22, "strafing_run_airstrike" },
    { 0x8F23, "straighten_ship" },
    { 0x8F24, "strain_accel_last_trigger" },
    { 0x8F25, "strain_accel_time_since_trigger" },
    { 0x8F26, "strategy_level" },
    { 0x8F27, "streak_trams" },
    { 0x8F28, "streakcustomization" },
    { 0x8F29, "streakname" },
    { 0x8F2A, "streaknotifytracker" },
    { 0x8F2B, "streakplayer" },
    { 0x8F2C, "streakref" },
    { 0x8F2D, "streakselectdowntracker" },
    { 0x8F2E, "streakselectuptracker" },
    { 0x8F2F, "streaksuppordisabledcount" },
    { 0x8F30, "streaksupportqueueallies" },
    { 0x8F31, "streaksupportqueueaxis" },
    { 0x8F32, "stream" },
    { 0x8F33, "streamclassweapons" },
    { 0x8F34, "streamprimaryweapons" },
    { 0x8F35, "streamweapons" },
    { 0x8F36, "street_battle_dialogue" },
    { 0x8F37, "street_civilian_clean_up" },
    { 0x8F38, "street_cleanup" },
    { 0x8F39, "street_enemy_blown_building_think" },
    { 0x8F3A, "street_enemy_building_east_think" },
    { 0x8F3B, "street_enemy_building_west_think" },
    { 0x8F3C, "street_enemy_movement" },
    { 0x8F3D, "street_enemy_tank_battle_think" },
    { 0x8F3E, "street_enemy_tank_damaged_think" },
    { 0x8F3F, "street_enemy_think" },
    { 0x8F40, "street_fight_after_snipe" },
    { 0x8F41, "street_fighter_check_function" },
    { 0x8F42, "street_fighters_gone_yet" },
    { 0x8F43, "street_hanging_pipes_anim" },
    { 0x8F44, "street_mechs" },
    { 0x8F45, "street_mobile_cover_guys" },
    { 0x8F46, "street_set_volume_from_pair" },
    { 0x8F47, "street_train_function" },
    { 0x8F48, "street_update_my_volume_think" },
    { 0x8F49, "street_volume_manager" },
    { 0x8F4A, "street_wall_1_explode" },
    { 0x8F4B, "street1_ingame" },
    { 0x8F4C, "street1_teleportplayer" },
    { 0x8F4D, "streetfighters_notify" },
    { 0x8F4E, "streetmechs" },
    { 0x8F4F, "streets_dialogue_manager" },
    { 0x8F50, "streets_main" },
    { 0x8F51, "strikegastrackingoverlay" },
    { 0x8F52, "strikerocketstoredangles" },
    { 0x8F53, "strikerocketstoredposition" },
    { 0x8F54, "strikespawnpoint" },
    { 0x8F55, "strikewhitefade" },
    { 0x8F56, "string" },
    { 0x8F57, "string_explosive_bullet_shield" },
    { 0x8F58, "string_find" },
    { 0x8F59, "string_is_single_digit_integer" },
    { 0x8F5A, "string_starts_with" },
    { 0x8F5B, "strings" },
    { 0x8F5C, "stringtables" },
    { 0x8F5D, "stringtofloat" },
    { 0x8F5E, "strip_prefix" },
    { 0x8F5F, "strip_suffix" },
    { 0x8F60, "strips" },
    { 0x8F61, "strips_disabled" },
    { 0x8F62, "strobelight" },
    { 0x8F63, "struct" },
    { 0x8F64, "struct_array_index" },
    { 0x8F65, "struct_arrayspawn" },
    { 0x8F66, "struct_class_init" },
    { 0x8F67, "struct_class_names" },
    { 0x8F68, "structarray_add" },
    { 0x8F69, "structarray_remove" },
    { 0x8F6A, "structarray_remove_index" },
    { 0x8F6B, "structarray_remove_undefined" },
    { 0x8F6C, "structarray_shuffle" },
    { 0x8F6D, "structarray_swap" },
    { 0x8F6E, "structarray_swaptolast" },
    { 0x8F6F, "stuckenemyentity" },
    { 0x8F70, "stuckmesh" },
    { 0x8F71, "stumbleonfirefx" },
    { 0x8F72, "stumblingpain" },
    { 0x8F73, "stumblingpainanimseq" },
    { 0x8F74, "stumblingpainnotetrackhandler" },
    { 0x8F75, "stun_drone" },
    { 0x8F76, "stun_duration" },
    { 0x8F77, "stunned" },
    { 0x8F78, "stunnedanimnumber" },
    { 0x8F79, "stunnedtime" },
    { 0x8F7A, "stunscaler" },
    { 0x8F7B, "style" },
    { 0x8F7C, "stylized_center_text" },
    { 0x8F7D, "stylized_fadeout" },
    { 0x8F7E, "stylized_line" },
    { 0x8F7F, "sub_line" },
    { 0x8F80, "subclass" },
    { 0x8F81, "subclass_elite" },
    { 0x8F82, "subclass_juggernaut" },
    { 0x8F83, "subclass_mech" },
    { 0x8F84, "subclass_regular" },
    { 0x8F85, "subclass_riotshield" },
    { 0x8F86, "subclass_spawn_functions" },
    { 0x8F87, "subtitle_entry_num" },
    { 0x8F88, "subtitles" },
    { 0x8F89, "subway_atlas_ceiling_breach" },
    { 0x8F8A, "subway_atlas_cleanup" },
    { 0x8F8B, "subway_atlas_post_scene" },
    { 0x8F8C, "subway_auto_doors_init" },
    { 0x8F8D, "subway_bomb_shake" },
    { 0x8F8E, "subway_bombshakes" },
    { 0x8F8F, "subway_civ_speaking_groups_setup" },
    { 0x8F90, "subway_civ_speaking_groups_setup_cg" },
    { 0x8F91, "subway_civilian_attach_props" },
    { 0x8F92, "subway_civilian_detach_props" },
    { 0x8F93, "subway_civilian_init_props" },
    { 0x8F94, "subway_civilians" },
    { 0x8F95, "subway_close_all_doors" },
    { 0x8F96, "subway_doors_closing" },
    { 0x8F97, "subway_doors_opening" },
    { 0x8F98, "subway_enter_spawn_civilians" },
    { 0x8F99, "subway_execution_scene" },
    { 0x8F9A, "subway_execution_scene_cg" },
    { 0x8F9B, "subway_exit_delete_civilians" },
    { 0x8F9C, "subway_exit_lights" },
    { 0x8F9D, "subway_gate_atlas_meetup_close" },
    { 0x8F9E, "subway_gate_triggered" },
    { 0x8F9F, "subway_handle_open_gate" },
    { 0x8FA0, "subway_handle_player_weapon_in_scene" },
    { 0x8FA1, "subway_meet_atlas_fov_shift_off" },
    { 0x8FA2, "subway_meet_atlas_fov_shift_on" },
    { 0x8FA3, "subway_meet_atlas_show_hole_geo" },
    { 0x8FA4, "subway_open_all_cg_doors" },
    { 0x8FA5, "subway_open_all_doors" },
    { 0x8FA6, "subway_open_door" },
    { 0x8FA7, "subway_pa_message" },
    { 0x8FA8, "subway_roof_breach_end_slomo" },
    { 0x8FA9, "subway_roof_breach_start_slowmo" },
    { 0x8FAA, "subway_rotating_automatic_doors" },
    { 0x8FAB, "subway_section" },
    { 0x8FAC, "subway_setup_civilians" },
    { 0x8FAD, "subway_setup_civilians_cg" },
    { 0x8FAE, "subway_setup_dead_civilians_cg" },
    { 0x8FAF, "success" },
    { 0x8FB0, "successdetonateambushinteract" },
    { 0x8FB1, "successsetupambushtimer" },
    { 0x8FB2, "suicides" },
    { 0x8FB3, "suit" },
    { 0x8FB4, "sulfur_door_fx" },
    { 0x8FB5, "sulfursmokefx" },
    { 0x8FB6, "sun_flare" },
    { 0x8FB7, "sun_flare_funeral" },
    { 0x8FB8, "sun_flare_position" },
    { 0x8FB9, "sun_light_fade" },
    { 0x8FBA, "sun_light_reset" },
    { 0x8FBB, "sun_shad_cooling_tower_area" },
    { 0x8FBC, "sun_shad_cooling_tower_start" },
    { 0x8FBD, "sun_shad_exposure_control_room" },
    { 0x8FBE, "sun_shad_vision_fly_in" },
    { 0x8FBF, "sun_shadow_trigger" },
    { 0x8FC0, "sunbeginfadeangle" },
    { 0x8FC1, "sunbeginfadeangle_start" },
    { 0x8FC2, "sunblue" },
    { 0x8FC3, "sunblue_start" },
    { 0x8FC4, "sunbouncehdr" },
    { 0x8FC5, "sundark_call" },
    { 0x8FC6, "sundark_manage" },
    { 0x8FC7, "sundark_touched" },
    { 0x8FC8, "sundark_volume" },
    { 0x8FC9, "sundir" },
    { 0x8FCA, "sundir_start" },
    { 0x8FCB, "sunenable" },
    { 0x8FCC, "sunendfadeangle" },
    { 0x8FCD, "sunendfadeangle_start" },
    { 0x8FCE, "sunendfageangle" },
    { 0x8FCF, "sunflare" },
    { 0x8FD0, "sunflare_changes" },
    { 0x8FD1, "sunflare_settings" },
    { 0x8FD2, "sunflareswap" },
    { 0x8FD3, "sunfog_enabled" },
    { 0x8FD4, "sunfogenabled" },
    { 0x8FD5, "sungreen" },
    { 0x8FD6, "sungreen_start" },
    { 0x8FD7, "sunisprimary" },
    { 0x8FD8, "sunisprimarylight" },
    { 0x8FD9, "sunlighthdr" },
    { 0x8FDA, "sunradiosity" },
    { 0x8FDB, "sunradiosityhdr" },
    { 0x8FDC, "sunred" },
    { 0x8FDD, "sunred_start" },
    { 0x8FDE, "sunsamplesizenear" },
    { 0x8FDF, "sunshadowscale" },
    { 0x8FE0, "superexosettings" },
    { 0x8FE1, "superstarchallenge" },
    { 0x8FE2, "support_01_checkpoint" },
    { 0x8FE3, "supportbarsize" },
    { 0x8FE4, "supportbuddyspawn" },
    { 0x8FE5, "supportintel" },
    { 0x8FE6, "suppresionfire" },
    { 0x8FE7, "suppressed" },
    { 0x8FE8, "suppressed_exo_hover_vfx" },
    { 0x8FE9, "suppressedbehavior" },
    { 0x8FEA, "suppressedtime" },
    { 0x8FEB, "suppressingenemy" },
    { 0x8FEC, "suppressingfiretracking" },
    { 0x8FED, "suppression_time" },
    { 0x8FEE, "suppressionstart" },
    { 0x8FEF, "suppressionthreshold" },
    { 0x8FF0, "suppressionwait_old" },
    { 0x8FF1, "suppresstimeout" },
    { 0x8FF2, "suppresswaiter" },
    { 0x8FF3, "surface" },
    { 0x8FF4, "surface_state" },
    { 0x8FF5, "surfaces" },
    { 0x8FF6, "surprise_ambush_kva_team" },
    { 0x8FF7, "surprise_attack" },
    { 0x8FF8, "surprise_enemy" },
    { 0x8FF9, "surveillance_post_anims" },
    { 0x8FFA, "survivalistchallenge" },
    { 0x8FFB, "survivalstarttime" },
    { 0x8FFC, "survive" },
    { 0x8FFD, "surviveanimallowed" },
    { 0x8FFE, "surviveanimname" },
    { 0x8FFF, "survivorevent" },
    { 0x9000, "suspend_drive_anims" },
    { 0x9001, "suspend_driveanims" },
    { 0x9002, "suspend_sd_role" },
    { 0x9003, "suspensemusic" },
    { 0x9004, "swap" },
    { 0x9005, "swap_ai_to_drone" },
    { 0x9006, "swap_bike_to_static" },
    { 0x9007, "swap_brigde_anim_to_real" },
    { 0x9008, "swap_brigde_anim_to_real_far" },
    { 0x9009, "swap_cockpit_model" },
    { 0x900A, "swap_drone_to_ai" },
    { 0x900B, "swap_drones_attack_player" },
    { 0x900C, "swap_head_model" },
    { 0x900D, "swap_num" },
    { 0x900E, "swap_to_climbing_weapon" },
    { 0x900F, "swap_to_real_weapon" },
    { 0x9010, "swap_tree" },
    { 0x9011, "swap_world_model" },
    { 0x9012, "swapanim" },
    { 0x9013, "swapfogandfx" },
    { 0x9014, "swapfx" },
    { 0x9015, "swaptolastweapon" },
    { 0x9016, "swapwalldelayed" },
    { 0x9017, "swarm" },
    { 0x9018, "swarm_dot_override" },
    { 0x9019, "swarm_drone_hud_change" },
    { 0x901A, "swarm_drone_hud_off" },
    { 0x901B, "swarm_drone_hud_on" },
    { 0x901C, "swarm_last_player_pos" },
    { 0x901D, "swarm_los_body_behind_cover" },
    { 0x901E, "swarm_los_lock_duration_endtime" },
    { 0x901F, "swarm_los_overhead_blocked" },
    { 0x9020, "swarm_repulsor_body" },
    { 0x9021, "swarm_repulsor_foot" },
    { 0x9022, "swarm_repulsor_head" },
    { 0x9023, "swarm_scantime_override" },
    { 0x9024, "swarm_shoot_random_drone_at_ent" },
    { 0x9025, "swarm_spawned" },
    { 0x9026, "swarm_target_list" },
    { 0x9027, "sweapon" },
    { 0x9028, "sweep_range" },
    { 0x9029, "swim" },
    { 0x902A, "swim_anim_drown" },
    { 0x902B, "swim_anim_idle_loop" },
    { 0x902C, "swim_anim_loop" },
    { 0x902D, "swim_anim_loop_into" },
    { 0x902E, "swim_anim_offscreen" },
    { 0x902F, "swim_approachnode" },
    { 0x9030, "swim_approachpos" },
    { 0x9031, "swim_arms_model" },
    { 0x9032, "swim_begin" },
    { 0x9033, "swim_bounds_fail" },
    { 0x9034, "swim_cancelcurrentapproach" },
    { 0x9035, "swim_choosestart" },
    { 0x9036, "swim_cleanupturnanim" },
    { 0x9037, "swim_clearleananims" },
    { 0x9038, "swim_coverarrival_main" },
    { 0x9039, "swim_determineapproachanim" },
    { 0x903A, "swim_determineapproachanim3d" },
    { 0x903B, "swim_dofinalarrival" },
    { 0x903C, "swim_doposarrival" },
    { 0x903D, "swim_dostrafe" },
    { 0x903E, "swim_end" },
    { 0x903F, "swim_end_hide_viewarms" },
    { 0x9040, "swim_getangleindex" },
    { 0x9041, "swim_getanimstartpos" },
    { 0x9042, "swim_getapproachtype" },
    { 0x9043, "swim_getmaxanimdist" },
    { 0x9044, "swim_getstrafeblendtime" },
    { 0x9045, "swim_handlestartcoveraim" },
    { 0x9046, "swim_isapproachablenode" },
    { 0x9047, "swim_maymovefrompointtopoint" },
    { 0x9048, "swim_movebegin" },
    { 0x9049, "swim_moveend" },
    { 0x904A, "swim_null" },
    { 0x904B, "swim_path_targetname" },
    { 0x904C, "swim_pathchange_getturnanim" },
    { 0x904D, "swim_restartapproachlistener" },
    { 0x904E, "swim_scene_boat_sink" },
    { 0x904F, "swim_scene_boat_sink_bob" },
    { 0x9050, "swim_scene_boats" },
    { 0x9051, "swim_scene_chase_littlebird_patrol" },
    { 0x9052, "swim_scene_cleanup" },
    { 0x9053, "swim_scene_climb_out_water" },
    { 0x9054, "swim_scene_dock_destroy" },
    { 0x9055, "swim_scene_dock_guard_goal" },
    { 0x9056, "swim_scene_dock_guard_removal" },
    { 0x9057, "swim_scene_dock_guards" },
    { 0x9058, "swim_scene_handle_current" },
    { 0x9059, "swim_scene_handle_player_containment" },
    { 0x905A, "swim_scene_ilana_swim_on_path_behavior" },
    { 0x905B, "swim_scene_master_handler" },
    { 0x905C, "swim_scene_pre_setup" },
    { 0x905D, "swim_scene_scripted_destroyed_dock_hide" },
    { 0x905E, "swim_scene_setup" },
    { 0x905F, "swim_scene_swarm_kamikaze_attack" },
    { 0x9060, "swim_scene_swarm_movement" },
    { 0x9061, "swim_scene_swarm_setup" },
    { 0x9062, "swim_scene_warbird_fire_at_target_for_duration" },
    { 0x9063, "swim_setleananims" },
    { 0x9064, "swim_setstrafeaimset" },
    { 0x9065, "swim_setstrafeaimweights" },
    { 0x9066, "swim_setstrafeweights" },
    { 0x9067, "swim_setupapproach" },
    { 0x9068, "swim_shoulddonodeexit" },
    { 0x9069, "swim_startcoveraim" },
    { 0x906A, "swim_time_fail" },
    { 0x906B, "swim_track_forward_enter" },
    { 0x906C, "swim_track_forward_exit" },
    { 0x906D, "swim_track_set" },
    { 0x906E, "swim_track_strafe_enter" },
    { 0x906F, "swim_track_strafe_exit" },
    { 0x9070, "swim_updateleananim" },
    { 0x9071, "swim_updatestrafeaimanim" },
    { 0x9072, "swim_updatestrafeanim" },
    { 0x9073, "swim_waitforapproachpos" },
    { 0x9074, "swim_warbird" },
    { 0x9075, "swimming" },
    { 0x9076, "swimming_arms" },
    { 0x9077, "swimming_depth" },
    { 0x9078, "swimming_gravity_vel" },
    { 0x9079, "switch_back_to_player_weapon" },
    { 0x907A, "switch_node_now" },
    { 0x907B, "switch_path" },
    { 0x907C, "switch_rpg_weapon" },
    { 0x907D, "switch_to_last_weapon" },
    { 0x907E, "switch_to_melee" },
    { 0x907F, "switch_to_previous_weapon" },
    { 0x9080, "switchedweapons" },
    { 0x9081, "switching_teams" },
    { 0x9082, "switchtocloaked" },
    { 0x9083, "switchtolastweapon" },
    { 0x9084, "switchtosidearm" },
    { 0x9085, "switchtovisible" },
    { 0x9086, "switchweaponafterraiseanimation" },
    { 0x9087, "sync_anim_times_with_carrier" },
    { 0x9088, "sync_entity_damage" },
    { 0x9089, "sync_transients_after_time" },
    { 0x908A, "syncedmeleetarget2" },
    { 0x908B, "syncnotetrackent" },
    { 0x908C, "syncxpstat" },
    { 0x908D, "system_default_detect_ranges" },
    { 0x908E, "system_default_event_distances" },
    { 0x908F, "system_event_change" },
    { 0x9090, "system_handle_clipbrush" },
    { 0x9091, "system_init" },
    { 0x9092, "system_init_shadows" },
    { 0x9093, "system_message_loop" },
    { 0x9094, "system_save_processes" },
    { 0x9095, "system_set_detect_ranges" },
    { 0x9096, "system_set_event_distances" },
    { 0x9097, "system_state_check_no_enemy" },
    { 0x9098, "system_state_spotted" },
//  { 0x9099, "" },
//  { 0x909A, "" },
//  { 0x909B, "" },
//  { 0x909C, "" },
//  { 0x909D, "" },
    { 0x909E, "table_combine" },
    { 0x909F, "table_getequipment" },
    { 0x90A0, "table_getequipmentextra" },
    { 0x90A1, "table_getkillstreak" },
    { 0x90A2, "table_getkillstreakmodule" },
    { 0x90A3, "table_getoffhand" },
    { 0x90A4, "table_getoffhandextra" },
    { 0x90A5, "table_getperk" },
    { 0x90A6, "table_getteamperk" },
    { 0x90A7, "table_getweapon" },
    { 0x90A8, "table_getweaponattachment" },
    { 0x90A9, "table_getweaponbuff" },
    { 0x90AA, "table_getweaponcamo" },
    { 0x90AB, "table_getweaponreticle" },
    { 0x90AC, "table_getwildcard" },
    { 0x90AD, "table_origins" },
    { 0x90AE, "table_pulldown" },
    { 0x90AF, "table_pulldown_distance_check" },
    { 0x90B0, "tablelookupweaponoffsets" },
    { 0x90B1, "tackle_handle_hint_display" },
    { 0x90B2, "tactical_goals" },
    { 0x90B3, "tactical_location" },
    { 0x90B4, "tactical_move_to_goal_pos" },
    { 0x90B5, "tactical_picker_enabled" },
    { 0x90B6, "tactics_model" },
    { 0x90B7, "tactics_objectives" },
    { 0x90B8, "tactics_objects" },
    { 0x90B9, "tactics_tools" },
    { 0x90BA, "tactics_type" },
    { 0x90BB, "tag_array" },
    { 0x90BC, "tag_bar_end_early" },
    { 0x90BD, "tag_current" },
    { 0x90BE, "tag_driver" },
    { 0x90BF, "tag_enemy" },
    { 0x90C0, "tag_ent" },
    { 0x90C1, "tag_getting" },
    { 0x90C2, "tag_idx" },
    { 0x90C3, "tag_left_foot" },
    { 0x90C4, "tag_left_hand" },
    { 0x90C5, "tag_monitor" },
    { 0x90C6, "tag_name" },
    { 0x90C7, "tag_offset" },
    { 0x90C8, "tag_outline_enemy" },
    { 0x90C9, "tag_player_view" },
    { 0x90CA, "tag_progress_bar" },
    { 0x90CB, "tag_project" },
    { 0x90CC, "tag_project_player" },
    { 0x90CD, "tag_right_foot" },
    { 0x90CE, "tag_right_hand" },
    { 0x90CF, "tag_scan_update" },
    { 0x90D0, "tag_screen_load" },
    { 0x90D1, "tag_screen_off" },
    { 0x90D2, "tag_screen_on" },
    { 0x90D3, "tag_shutdown_hp_threshold_array" },
    { 0x90D4, "tag_shutdown_order_array" },
    { 0x90D5, "tag_sound" },
    { 0x90D6, "tag_stowed_hip" },
    { 0x90D7, "tag_targ" },
    { 0x90D8, "tag_threat_detection" },
    { 0x90D9, "tag_trace_pulse" },
    { 0x90DA, "tag_trace_sound" },
    { 0x90DB, "tag_trace_state" },
    { 0x90DC, "tag_trace_track" },
    { 0x90DD, "tag_trace_update" },
    { 0x90DE, "tag_update_enemy_in_sights" },
    { 0x90DF, "tag_watcher" },
    { 0x90E0, "tag1" },
    { 0x90E1, "tag2" },
    { 0x90E2, "tagavailable" },
    { 0x90E3, "tagcollectorevent" },
    { 0x90E4, "tagcollectortotal" },
    { 0x90E5, "tagged" },
    { 0x90E6, "tagged_enemy_death_cleanup" },
    { 0x90E7, "tagged_enemy_update" },
    { 0x90E8, "tagged_status_hide" },
    { 0x90E9, "tagged_status_show" },
    { 0x90EA, "tagged_status_update" },
    { 0x90EB, "tagging" },
    { 0x90EC, "tagging_color" },
    { 0x90ED, "tagging_create_hud" },
    { 0x90EE, "tagging_create_hud_crosshair" },
    { 0x90EF, "tagging_enemy_list" },
    { 0x90F0, "tagging_highlight_hud_effect_apply" },
    { 0x90F1, "tagging_highlight_hud_effect_remove" },
    { 0x90F2, "tagging_hud_show_all" },
    { 0x90F3, "tagging_hud_show_minimal" },
    { 0x90F4, "tagging_hud_show_none" },
    { 0x90F5, "tagging_hud_shutdown" },
    { 0x90F6, "tagging_init_player" },
    { 0x90F7, "tagging_mode_begin" },
    { 0x90F8, "tagging_mode_end" },
    { 0x90F9, "tagging_mode_watcher" },
    { 0x90FA, "tagging_set_binocs_enabled" },
    { 0x90FB, "tagging_set_enabled" },
    { 0x90FC, "tagging_set_forced_mode" },
    { 0x90FD, "tagging_set_hint" },
    { 0x90FE, "tagging_set_hud_outline_style" },
    { 0x90FF, "tagging_set_marking_enabled" },
    { 0x9100, "tagging_shutdown_player" },
    { 0x9101, "tagging_sight_trace_passed" },
    { 0x9102, "tagging_sight_trace_queue" },
    { 0x9103, "tagging_sight_traced_queued" },
    { 0x9104, "tagging_think" },
    { 0x9105, "tagging_zoom_monitor" },
    { 0x9106, "tagging_zoom_sound" },
    { 0x9107, "tagging_zoom_transition" },
    { 0x9108, "tagmarkedby" },
    { 0x9109, "tags" },
    { 0x910A, "tags_seen" },
    { 0x910B, "tags_seen_by_owner" },
    { 0x910C, "tagtarget" },
    { 0x910D, "tagteamupdater" },
    { 0x910E, "take_car_door_shields" },
    { 0x910F, "take_color_node" },
    { 0x9110, "take_color_node_until_death" },
    { 0x9111, "take_cover_warning" },
    { 0x9112, "take_cover_warning_loop" },
    { 0x9113, "take_cover_warnings_enabled" },
    { 0x9114, "take_every_grenade_now" },
    { 0x9115, "take_exo_cloak" },
    { 0x9116, "take_exo_health" },
    { 0x9117, "take_exo_hover" },
    { 0x9118, "take_exo_mute" },
    { 0x9119, "take_exo_overclock" },
    { 0x911A, "take_exo_ping" },
    { 0x911B, "take_exo_repulsor" },
    { 0x911C, "take_exo_shield" },
    { 0x911D, "take_knife_when_done" },
    { 0x911E, "take_prebreach_weapons" },
    { 0x911F, "take_selfie" },
    { 0x9120, "take_water_weapon" },
    { 0x9121, "take_weapon_delayed" },
    { 0x9122, "takeandkillevent" },
    { 0x9123, "takedown_01_complete" },
    { 0x9124, "takedown_01_complete_dialogue" },
    { 0x9125, "takedown_01_dialogue" },
    { 0x9126, "takedown_button" },
    { 0x9127, "takedown_door" },
    { 0x9128, "takedown_hint_off" },
    { 0x9129, "takedown_qte" },
    { 0x912A, "takedown_qte_middle" },
    { 0x912B, "takedown_truck_lights_off" },
    { 0x912C, "takedown_trunk" },
    { 0x912D, "takedown_underwater_portion" },
    { 0x912E, "takedownenemy1" },
    { 0x912F, "takekillstreakweaponifnodupe" },
    { 0x9130, "takekillstreakweapons" },
    { 0x9131, "takeobject" },
    { 0x9132, "takeoffhand" },
    { 0x9133, "takeover_warbird_turret_buddy" },
    { 0x9134, "takeuseweapon" },
    { 0x9135, "talk_for_time" },
    { 0x9136, "talker" },
    { 0x9137, "talker_is_talking_currently" },
    { 0x9138, "talker_origin" },
    { 0x9139, "tangent" },
    { 0x913A, "tank" },
    { 0x913B, "tank_ascent" },
    { 0x913C, "tank_ascent_dialogue" },
    { 0x913D, "tank_ascent_logic" },
    { 0x913E, "tank_attack" },
    { 0x913F, "tank_battle_rpg_enemy_think" },
    { 0x9140, "tank_board" },
    { 0x9141, "tank_board_dialogue" },
    { 0x9142, "tank_board_enter" },
    { 0x9143, "tank_board_enter_top_lights" },
    { 0x9144, "tank_board_logic" },
    { 0x9145, "tank_checkpoint_engine" },
    { 0x9146, "tank_clearing_dialogue" },
    { 0x9147, "tank_clearing2_littlebird" },
    { 0x9148, "tank_clearing3_littlebird" },
    { 0x9149, "tank_combat_littlebird_damage_function" },
    { 0x914A, "tank_combat_littlebird_think" },
    { 0x914B, "tank_combat_vehicle_damage_feedback" },
    { 0x914C, "tank_combat_vrap" },
    { 0x914D, "tank_combat_vrap_deactivate_on_unload" },
    { 0x914E, "tank_combat_warbird_damage_function" },
    { 0x914F, "tank_combat_warbird_kill_is_crew_killed" },
    { 0x9150, "tank_combat_warbird_liftoff_think" },
    { 0x9151, "tank_combat_warbird_orient_to_open_fire" },
    { 0x9152, "tank_combat_warbird_think" },
    { 0x9153, "tank_count" },
    { 0x9154, "tank_courtyard_dialogue" },
    { 0x9155, "tank_courtyard_gate_dialogue" },
    { 0x9156, "tank_damage_detection" },
    { 0x9157, "tank_disabled" },
    { 0x9158, "tank_end" },
    { 0x9159, "tank_exfil_charges_going_off" },
    { 0x915A, "tank_exfil_detonate" },
    { 0x915B, "tank_exit" },
    { 0x915C, "tank_exit_dialogue" },
    { 0x915D, "tank_exit_dof_reset" },
    { 0x915E, "tank_field" },
    { 0x915F, "tank_field_choppers_dialogue" },
    { 0x9160, "tank_field_dialogue" },
    { 0x9161, "tank_field_lft_frk" },
    { 0x9162, "tank_field_logic" },
    { 0x9163, "tank_field_nightvision" },
    { 0x9164, "tank_field_rgt_frk" },
    { 0x9165, "tank_field_vraps_dialogue" },
    { 0x9166, "tank_fire_missile" },
    { 0x9167, "tank_hangar" },
    { 0x9168, "tank_hangar_dialogue" },
    { 0x9169, "tank_hangar_door_close" },
    { 0x916A, "tank_hangar_door_open" },
    { 0x916B, "tank_hangar_logic" },
    { 0x916C, "tank_hangar_pas_dialogue" },
    { 0x916D, "tank_hide_icon" },
    { 0x916E, "tank_idle" },
    { 0x916F, "tank_missile_react" },
    { 0x9170, "tank_missile_set_target" },
    { 0x9171, "tank_no_target_time" },
    { 0x9172, "tank_queue" },
    { 0x9173, "tank_reloading_dialogue" },
    { 0x9174, "tank_reveal_lighting" },
    { 0x9175, "tank_reveal_models" },
    { 0x9176, "tank_reveal_models_start_point" },
    { 0x9177, "tank_road" },
    { 0x9178, "tank_road_dialogue" },
    { 0x9179, "tank_road_enemy_tank_dialogue" },
    { 0x917A, "tank_road_enemy_think" },
    { 0x917B, "tank_road_littlebird" },
    { 0x917C, "tank_road_logic" },
    { 0x917D, "tank_road_tank_killed_dialogue" },
    { 0x917E, "tank_run" },
    { 0x917F, "tank_screens_boot_up" },
    { 0x9180, "tank_section_vehicles_spawned" },
    { 0x9181, "tank_shack_destruct" },
    { 0x9182, "tank_shoot_generic" },
    { 0x9183, "tank_shoot_time" },
    { 0x9184, "tank_show_icon" },
    { 0x9185, "tank_status_dialogue" },
    { 0x9186, "tank_systems_dialogue" },
    { 0x9187, "tank_trail" },
    { 0x9188, "tank_turrent_reflection" },
    { 0x9189, "tank_wait_flag_time" },
    { 0x918A, "tanker_crash" },
    { 0x918B, "tanker_drone_flood" },
    { 0x918C, "tanker_exploded" },
    { 0x918D, "tanker_fire_hurt_trigger" },
    { 0x918E, "tanker_fireball" },
    { 0x918F, "tanker_mountain_crash" },
    { 0x9190, "tanker_mountain_crash2" },
    { 0x9191, "tanker_roll_explosion" },
    { 0x9192, "tanker_skid_impacts" },
    { 0x9193, "tankgetout" },
    { 0x9194, "tankkilled" },
    { 0x9195, "tanks" },
    { 0x9196, "tanksquish" },
    { 0x9197, "tanksquish_damage_check" },
    { 0x9198, "tanktrail" },
    { 0x9199, "tappackagethink" },
    { 0x919A, "targent" },
    { 0x919B, "target_air_space" },
    { 0x919C, "target_array" },
    { 0x919D, "target_blink_out" },
    { 0x919E, "target_center_off" },
    { 0x919F, "target_confirm" },
    { 0x91A0, "target_cycleshader" },
    { 0x91A1, "target_drone_damager" },
    { 0x91A2, "target_enhancer_think" },
    { 0x91A3, "target_ent" },
    { 0x91A4, "target_ent_cleanup" },
    { 0x91A5, "target_entity" },
    { 0x91A6, "target_fov" },
    { 0x91A7, "target_from_avatar" },
    { 0x91A8, "target_handle_death" },
    { 0x91A9, "target_handle_stop" },
    { 0x91AA, "target_handler" },
    { 0x91AB, "target_is_in_front" },
    { 0x91AC, "target_lifetime" },
    { 0x91AD, "target_list" },
    { 0x91AE, "target_lock_change_func" },
    { 0x91AF, "target_lock_targets" },
    { 0x91B0, "target_logic" },
    { 0x91B1, "target_marked" },
    { 0x91B2, "target_min_range" },
    { 0x91B3, "target_move_dist" },
    { 0x91B4, "target_name" },
    { 0x91B5, "target_org" },
    { 0x91B6, "target_position" },
    { 0x91B7, "target_radius" },
    { 0x91B8, "target_reset" },
    { 0x91B9, "target_score" },
    { 0x91BA, "target_setsafe" },
    { 0x91BB, "target_setshadersafe" },
    { 0x91BC, "target_spawn_in" },
    { 0x91BD, "target_spawn_out" },
    { 0x91BE, "target_stencil" },
    { 0x91BF, "target_still_valid" },
    { 0x91C0, "target_swarm" },
    { 0x91C1, "target_track" },
    { 0x91C2, "target_units_per_second" },
    { 0x91C3, "target_valid_targets" },
    { 0x91C4, "targetangularacceleration" },
    { 0x91C5, "targetattacker" },
    { 0x91C6, "targetavatar" },
    { 0x91C7, "targetdefault" },
    { 0x91C8, "targetdest" },
    { 0x91C9, "targetdot" },
    { 0x91CA, "targetedent" },
    { 0x91CB, "targetenemy" },
    { 0x91CC, "targetent" },
    { 0x91CD, "targetentpos" },
    { 0x91CE, "targetgetdist" },
    { 0x91CF, "targeting_delay" },
    { 0x91D0, "targeting_hud_destroy" },
    { 0x91D1, "targeting_hud_init" },
    { 0x91D2, "targeting_hud_think" },
    { 0x91D3, "targetinsafevolume" },
    { 0x91D4, "targetisclose" },
    { 0x91D5, "targetisinfront" },
    { 0x91D6, "targetlist" },
    { 0x91D7, "targetmarked" },
    { 0x91D8, "targetmonitor" },
    { 0x91D9, "targetplaydeath" },
    { 0x91DA, "targetplayer" },
    { 0x91DB, "targetpos" },
    { 0x91DC, "targets" },
    { 0x91DD, "targets_and_uses_turret" },
    { 0x91DE, "targetspreadshooting" },
    { 0x91DF, "targetzoff" },
    { 0x91E0, "tc_ai_clip_blocker" },
    { 0x91E1, "tc_door_to_stairs_closer" },
    { 0x91E2, "tc_manticore_ally_traverse" },
    { 0x91E3, "tc_setup_door" },
    { 0x91E4, "tc_side_door_movement" },
    { 0x91E5, "tc_uv_rumble" },
    { 0x91E6, "tcah_doors" },
    { 0x91E7, "tcah_node" },
    { 0x91E8, "team_move_hospital" },
    { 0x91E9, "team_specific_spawn_functions" },
    { 0x91EA, "team1" },
    { 0x91EB, "team2" },
    { 0x91EC, "teambalance" },
    { 0x91ED, "teambase" },
    { 0x91EE, "teambased" },
    { 0x91EF, "teamchangedthisframe" },
    { 0x91F0, "teamcount" },
    { 0x91F1, "teamemped" },
    { 0x91F2, "teamflags" },
    { 0x91F3, "teamflashbangimmune" },
    { 0x91F4, "teamflashbangimmunity" },
    { 0x91F5, "teamkilldelay" },
    { 0x91F6, "teamkillsthisround" },
    { 0x91F7, "teamlimit" },
    { 0x91F8, "teamlist" },
    { 0x91F9, "teamname" },
    { 0x91FA, "teamnamelist" },
    { 0x91FB, "teamnukeemped" },
    { 0x91FC, "teamoutcomenotify" },
    { 0x91FD, "teamplayercardsplash" },
    { 0x91FE, "teamprogressbarfontsize" },
    { 0x91FF, "teamprogressbarheight" },
    { 0x9200, "teamprogressbartexty" },
    { 0x9201, "teamprogressbarwidth" },
    { 0x9202, "teamprogressbary" },
    { 0x9203, "teams" },
    { 0x9204, "teamspawnpoints" },
    { 0x9205, "teamsplash" },
    { 0x9206, "teamswap" },
    { 0x9207, "teamthreatcalloutlimittimeout" },
    { 0x9208, "teamtweaks" },
    { 0x9209, "teamusetexts" },
    { 0x920A, "teamusetimes" },
    { 0x920B, "technical_pain" },
    { 0x920C, "tele_orgs" },
    { 0x920D, "telefrag_behavior" },
    { 0x920E, "teleport_add_delta" },
    { 0x920F, "teleport_add_delta_targets" },
    { 0x9210, "teleport_ahead" },
    { 0x9211, "teleport_ai" },
    { 0x9212, "teleport_ai_rooftop" },
    { 0x9213, "teleport_allowed" },
    { 0x9214, "teleport_bones_and_joker" },
    { 0x9215, "teleport_building_jump" },
    { 0x9216, "teleport_burke_to_alley" },
    { 0x9217, "teleport_change_targetname" },
    { 0x9218, "teleport_closest_zone" },
    { 0x9219, "teleport_delta_this_frame" },
    { 0x921A, "teleport_dom_finished_initializing" },
    { 0x921B, "teleport_dom_post_bot_cleanup" },
    { 0x921C, "teleport_ent" },
    { 0x921D, "teleport_filter_spawn_point" },
    { 0x921E, "teleport_gamemode_disable_teleport" },
    { 0x921F, "teleport_gamemode_func" },
    { 0x9220, "teleport_get_active_nodes" },
    { 0x9221, "teleport_get_active_pathnode_zones" },
    { 0x9222, "teleport_get_care_packages" },
    { 0x9223, "teleport_get_deployable_boxes" },
    { 0x9224, "teleport_get_matching_dom_flag" },
    { 0x9225, "teleport_get_safe_node_near" },
    { 0x9226, "teleport_include_killsteaks" },
    { 0x9227, "teleport_include_killstreaks" },
    { 0x9228, "teleport_include_players" },
    { 0x9229, "teleport_init" },
    { 0x922A, "teleport_init_spawn_info" },
    { 0x922B, "teleport_is_valid_zone" },
    { 0x922C, "teleport_minimaps" },
    { 0x922D, "teleport_nodes_in_zone" },
    { 0x922E, "teleport_notify_death" },
    { 0x922F, "teleport_onstartgameball" },
    { 0x9230, "teleport_onstartgameconf" },
    { 0x9231, "teleport_onstartgamectf" },
    { 0x9232, "teleport_onstartgamedom" },
    { 0x9233, "teleport_onstartgamehorde" },
    { 0x9234, "teleport_onstartgamehp" },
    { 0x9235, "teleport_onstartgametype" },
    { 0x9236, "teleport_onteleportball" },
    { 0x9237, "teleport_onteleportconf" },
    { 0x9238, "teleport_onteleportctf" },
    { 0x9239, "teleport_onteleportdom" },
    { 0x923A, "teleport_onteleporthp" },
    { 0x923B, "teleport_origin_use_nodes" },
    { 0x923C, "teleport_origin_use_offset" },
    { 0x923D, "teleport_origins" },
    { 0x923E, "teleport_parse_zone_targets" },
    { 0x923F, "teleport_pathnode_zones" },
    { 0x9240, "teleport_place_on_ground" },
    { 0x9241, "teleport_player" },
    { 0x9242, "teleport_players" },
    { 0x9243, "teleport_post_funcs" },
    { 0x9244, "teleport_pre_funcs" },
    { 0x9245, "teleport_pre_onstartgamesd" },
    { 0x9246, "teleport_pre_onstartgamesd_and_sr" },
    { 0x9247, "teleport_pre_onstartgamesr" },
    { 0x9248, "teleport_restore_targetname" },
    { 0x9249, "teleport_self_add_delta" },
    { 0x924A, "teleport_self_add_delta_targets" },
    { 0x924B, "teleport_set_current_zone" },
    { 0x924C, "teleport_set_minimap_for_zone" },
    { 0x924D, "teleport_set_post_func" },
    { 0x924E, "teleport_set_pre_func" },
    { 0x924F, "teleport_spawn_info" },
    { 0x9250, "teleport_to_ent_tag" },
    { 0x9251, "teleport_to_nodes" },
    { 0x9252, "teleport_to_offset" },
    { 0x9253, "teleport_to_scriptstruct" },
    { 0x9254, "teleport_to_struct" },
    { 0x9255, "teleport_to_zone" },
    { 0x9256, "teleport_to_zone_agents" },
    { 0x9257, "teleport_to_zone_character" },
    { 0x9258, "teleport_to_zone_killstreaks" },
    { 0x9259, "teleport_to_zone_players" },
    { 0x925A, "teleport_validate_success" },
    { 0x925B, "teleport_zone" },
    { 0x925C, "teleport_zone_current" },
    { 0x925D, "teleport_zones" },
    { 0x925E, "teleported_to_path_section" },
    { 0x925F, "teleportgetactivenodesfunc" },
    { 0x9260, "teleportgetactivepathnodezonesfunc" },
    { 0x9261, "teleportthread" },
    { 0x9262, "teleportthreadex" },
    { 0x9263, "television" },
    { 0x9264, "temp_bink_stuff" },
    { 0x9265, "temp_clip_delete" },
    { 0x9266, "temp_cloak_gauge" },
    { 0x9267, "temp_dialogue" },
    { 0x9268, "temp_dialogue_fade" },
    { 0x9269, "temp_diveboat_weapon_gauge" },
    { 0x926A, "temp_dog_bark" },
    { 0x926B, "temp_dog_sfx" },
    { 0x926C, "temp_exoclimb_hud" },
    { 0x926D, "temp_exoclimb_hud_check_array" },
    { 0x926E, "temp_exoclimb_hud_hide" },
    { 0x926F, "temp_exoclimb_hud_init" },
    { 0x9270, "temp_exoclimb_hud_precache" },
    { 0x9271, "temp_exoclimb_hud_thread" },
    { 0x9272, "temp_friendly_squad_casual_walk" },
    { 0x9273, "temp_handle_fob_anim_scene" },
    { 0x9274, "temp_noise" },
    { 0x9275, "temp_subtitle" },
    { 0x9276, "temp_tag" },
    { 0x9277, "temp_think" },
    { 0x9278, "temperature_deep_caves" },
    { 0x9279, "temperature_high_alt" },
    { 0x927A, "temperature_high_alt_wind" },
    { 0x927B, "temperature_indoor" },
    { 0x927C, "temperature_outdoor" },
    { 0x927D, "temperature_water" },
    { 0x927E, "template_level" },
    { 0x927F, "template_script" },
    { 0x9280, "template_so_level" },
    { 0x9281, "templates" },
    { 0x9282, "temporary_disable_pain" },
    { 0x9283, "temporary_sentinel_reveal_timing" },
    { 0x9284, "temptarget" },
    { 0x9285, "tennis_court" },
    { 0x9286, "tennis_court_alert_vo" },
    { 0x9287, "tennis_court_ball_cleanup" },
    { 0x9288, "tennis_court_ball_launcher" },
    { 0x9289, "tennis_court_ball_launcher_logic" },
    { 0x928A, "tennis_court_computer_line_done" },
    { 0x928B, "tennis_court_computer_talking" },
    { 0x928C, "tennis_court_floor" },
    { 0x928D, "tennis_court_lights_dimmed" },
    { 0x928E, "tennis_court_lights_intial" },
    { 0x928F, "tennis_court_lights_on" },
    { 0x9290, "tennis_court_nags" },
    { 0x9291, "tennis_court_origin" },
    { 0x9292, "tennis_court_player_brackets" },
    { 0x9293, "tennis_court_player_brackets_internal" },
    { 0x9294, "tennis_court_trigger" },
    { 0x9295, "tent_scene_civilians_01" },
    { 0x9296, "tent_scene_civilians_02" },
    { 0x9297, "ter_op" },
    { 0x9298, "terminal_hum_01" },
    { 0x9299, "terminal_hum_02" },
    { 0x929A, "terrace_turret_fx" },
    { 0x929B, "terracecustomkillstreakfunc" },
    { 0x929C, "terracecustomospfunc" },
    { 0x929D, "tess" },
    { 0x929E, "tess_init" },
    { 0x929F, "tess_set_goal" },
    { 0x92A0, "tess_update" },
    { 0x92A1, "test" },
    { 0x92A2, "test_chamber_body_pushes" },
    { 0x92A3, "test_chamber_exit_door" },
    { 0x92A4, "test_chamber_exit_door_notetrack" },
    { 0x92A5, "test_chamber_stairs_up_door" },
    { 0x92A6, "test_chamber_stairs_up_door_notetrack" },
    { 0x92A7, "test_chamber_stairs_up_door_swipe_sfx_notetrack" },
    { 0x92A8, "test_col_points_in_segment" },
    { 0x92A9, "test_lines" },
    { 0x92AA, "test_look_b" },
    { 0x92AB, "test_look_c" },
    { 0x92AC, "test_pathing" },
    { 0x92AD, "test_sun_flare" },
    { 0x92AE, "test_tag" },
    { 0x92AF, "test_trace" },
    { 0x92B0, "test_trace_tag" },
    { 0x92B1, "test_zipline" },
    { 0x92B2, "testfx" },
    { 0x92B3, "testmenu" },
    { 0x92B4, "testshock" },
    { 0x92B5, "text" },
    { 0x92B6, "text_glow_adjust" },
    { 0x92B7, "text_incoming" },
    { 0x92B8, "text_incoming_x" },
    { 0x92B9, "text_incoming_y" },
    { 0x92BA, "text_list" },
    { 0x92BB, "text_x" },
    { 0x92BC, "text_y" },
    { 0x92BD, "text2label" },
    { 0x92BE, "textalpha" },
    { 0x92BF, "textglowcolor" },
    { 0x92C0, "textid" },
    { 0x92C1, "textisstring" },
    { 0x92C2, "textlabel" },
    { 0x92C3, "textoffline" },
    { 0x92C4, "textscale" },
    { 0x92C5, "textstring" },
    { 0x92C6, "tff_ally_check" },
    { 0x92C7, "tff_blocker_caves" },
    { 0x92C8, "tff_blocker_incinerator" },
    { 0x92C9, "tff_blocker_incinerator_to_helipad" },
    { 0x92CA, "tff_blockers" },
    { 0x92CB, "tff_cleanup_canal_boats" },
    { 0x92CC, "tff_cleanup_tour_ride_ambient_vehicles" },
    { 0x92CD, "tff_cleanup_vehicle" },
    { 0x92CE, "tff_get_zone_cleanup_notify" },
    { 0x92CF, "tff_get_zone_unload_notify" },
    { 0x92D0, "tff_setup_blocker_hangar_backtrack" },
    { 0x92D1, "tff_setup_blocker_hangar_load" },
    { 0x92D2, "tff_setup_blockers" },
    { 0x92D3, "tff_setup_start_points" },
    { 0x92D4, "tff_setup_transitions" },
    { 0x92D5, "tff_setups" },
    { 0x92D6, "tff_spawn_vehicles_conf_center" },
    { 0x92D7, "tff_start_points" },
    { 0x92D8, "tff_sync" },
    { 0x92D9, "tff_sync_notetrack" },
    { 0x92DA, "tff_sync_setup" },
    { 0x92DB, "tff_trans_ally_check_active" },
    { 0x92DC, "tff_trans_ally_check_count" },
    { 0x92DD, "tff_trans_ally_check_touching" },
    { 0x92DE, "tff_trans_atlas_building_to_old_town" },
    { 0x92DF, "tff_trans_autopsy_halls_to_autopsy" },
    { 0x92E0, "tff_trans_briefing_to_cliffs" },
    { 0x92E1, "tff_trans_canals_to_finale" },
    { 0x92E2, "tff_trans_caves_to_lake" },
    { 0x92E3, "tff_trans_cliffs_to_lower" },
    { 0x92E4, "tff_trans_escape_to_test_chamber" },
    { 0x92E5, "tff_trans_incinerator_to_helipad" },
    { 0x92E6, "tff_trans_intro_drive_to_s2walk" },
    { 0x92E7, "tff_trans_intro_to_middle" },
    { 0x92E8, "tff_trans_load_autopsy_halls" },
    { 0x92E9, "tff_trans_load_bigm" },
    { 0x92EA, "tff_trans_load_escape" },
    { 0x92EB, "tff_trans_lower_to_upper" },
    { 0x92EC, "tff_trans_middle_to_outro" },
    { 0x92ED, "tff_trans_middle_to_outro_ally_check" },
    { 0x92EE, "tff_trans_middle_to_outro_ally_touching" },
    { 0x92EF, "tff_trans_old_town_to_canals" },
    { 0x92F0, "tff_trans_s2walk_to_interrogate" },
    { 0x92F1, "tff_trans_site_to_caves" },
    { 0x92F2, "tff_trans_tour_augmented_reality_to_training" },
    { 0x92F3, "tff_trans_tour_exo_to_tour_firing_range" },
    { 0x92F4, "tff_trans_tour_firing_range_to_tour_augmented_reality" },
    { 0x92F5, "tff_trans_tour_ride_to_tour_exo" },
    { 0x92F6, "tff_trans_training_to_tour_ride" },
    { 0x92F7, "tff_trans_unload_interrogate" },
    { 0x92F8, "tff_trans_unload_test_chamber" },
    { 0x92F9, "tff_trans_upper_to_lower_cliffs" },
    { 0x92FA, "tff_transitions" },
    { 0x92FB, "tff_vehicles" },
    { 0x92FC, "tgt_camoffset_ratio" },
    { 0x92FD, "tgt_values" },
    { 0x92FE, "tgtdangle" },
    { 0x92FF, "tgtdelta" },
    { 0x9300, "theres_the_convoy_vo" },
    { 0x9301, "thermal_effectsoff" },
    { 0x9302, "thermal_effectson" },
    { 0x9303, "thermal_tracker" },
    { 0x9304, "thermal_with_nvg" },
    { 0x9305, "thermaldrawenabledrone" },
    { 0x9306, "thermaloff_vianotify" },
    { 0x9307, "thermalvision" },
    { 0x9308, "thermite_grenade_1_fx" },
    { 0x9309, "thermite_grenade_2_fx" },
    { 0x930A, "thermite_grenade_3_fx" },
    { 0x930B, "thermite_servers_explosion" },
    { 0x930C, "thin_out_navy_guys" },
    { 0x930D, "thin_the_herd" },
    { 0x930E, "thing" },
    { 0x930F, "think" },
    { 0x9310, "think_player_blast_walk_anims" },
    { 0x9311, "thinkallyinfiltrator" },
    { 0x9312, "thinkambushenemy" },
    { 0x9313, "thinkfastevent" },
    { 0x9314, "thinkmeetingcivilian" },
    { 0x9315, "thinkpatrolenemy" },
    { 0x9316, "thread_delay_s" },
    { 0x9317, "threaded_anim_roundabout_rappel" },
    { 0x9318, "threadedsetweaponstatbyname" },
    { 0x9319, "threads" },
    { 0x931A, "threat" },
    { 0x931B, "threat_attack" },
    { 0x931C, "threat_bias_canal_think" },
    { 0x931D, "threat_bias_remove_delay" },
    { 0x931E, "threat_bias_silo_think" },
    { 0x931F, "threat_detection_style" },
    { 0x9320, "threat_grenade_response_is_on" },
    { 0x9321, "threat_init" },
    { 0x9322, "threat_level" },
    { 0x9323, "threat_list" },
    { 0x9324, "threat_paint_highlight_hud_effect" },
    { 0x9325, "threat_paint_hud_effect" },
    { 0x9326, "threat_scan" },
    { 0x9327, "threat_stance" },
    { 0x9328, "threat_visible_time" },
    { 0x9329, "threatbiasgroupname" },
    { 0x932A, "threatcallouts" },
    { 0x932B, "threatcallouttracking" },
    { 0x932C, "threatdog" },
    { 0x932D, "threatent" },
    { 0x932E, "threatinfantry" },
    { 0x932F, "threatinfantry_docalloutlocation" },
    { 0x9330, "threatinfantryexposed" },
    { 0x9331, "threatinfantryrpg" },
    { 0x9332, "threatisviable" },
    { 0x9333, "threatnotificationoverlayflash" },
    { 0x9334, "threats" },
    { 0x9335, "threatsightdelay" },
    { 0x9336, "threattype" },
    { 0x9337, "threatwasalreadycalledout" },
    { 0x9338, "threecaptime" },
    { 0x9339, "threw_ninebang" },
    { 0x933A, "threwback" },
    { 0x933B, "throttle_input" },
    { 0x933C, "throwbackkillevent" },
    { 0x933D, "throwdownweapon" },
    { 0x933E, "throwgrenadeatplayerasap" },
    { 0x933F, "throwgrenadeatplayerasap_combat_utility" },
    { 0x9340, "throwgun" },
    { 0x9341, "throwinggrenade" },
    { 0x9342, "thrown_semtex_grenades" },
    { 0x9343, "thrusters_angle_current" },
    { 0x9344, "thrusters_angle_goal" },
    { 0x9345, "thrusters_fx_amount" },
    { 0x9346, "thunder" },
    { 0x9347, "ti_spawn" },
    { 0x9348, "tickingobject" },
    { 0x9349, "ticks" },
    { 0x934A, "tidal_wave_notetracks" },
    { 0x934B, "tigger_hurt_rotor" },
    { 0x934C, "tilt_boat" },
    { 0x934D, "time_accel" },
    { 0x934E, "time_and_distance_of_closest_approach" },
    { 0x934F, "time_array" },
    { 0x9350, "time_before_attack" },
    { 0x9351, "time_before_move" },
    { 0x9352, "time_between_attacks" },
    { 0x9353, "time_breaking" },
    { 0x9354, "time_constant" },
    { 0x9355, "time_display_array" },
    { 0x9356, "time_last_turret_accel" },
    { 0x9357, "time_of_hovertank_fire" },
    { 0x9358, "time_passed" },
    { 0x9359, "time_pitching_hard" },
    { 0x935A, "time_remaining" },
    { 0x935B, "time_spent_hiding" },
    { 0x935C, "time_turret_accel_started" },
    { 0x935D, "time_turret_accelerating" },
    { 0x935E, "time_turret_rotating" },
    { 0x935F, "time_turret_started_rotating" },
    { 0x9360, "timebetweenshots" },
    { 0x9361, "timebomb" },
    { 0x9362, "timebombparticle" },
    { 0x9363, "timed_charges_vo" },
    { 0x9364, "timed_out" },
    { 0x9365, "timednotify" },
    { 0x9366, "timehack" },
    { 0x9367, "timelimitclock" },
    { 0x9368, "timelimitclock_intermission" },
    { 0x9369, "timelimitoverride" },
    { 0x936A, "timelimitthread" },
    { 0x936B, "timeoflastdamage" },
    { 0x936C, "timeofmaincqbupdate" },
    { 0x936D, "timeofnextsound" },
    { 0x936E, "timeout" },
    { 0x936F, "timeout_and_flag" },
    { 0x9370, "timeout_reset" },
    { 0x9371, "timeoutent" },
    { 0x9372, "timeoutstarted" },
    { 0x9373, "timepaused" },
    { 0x9374, "timepercentagecutoff" },
    { 0x9375, "timeplayed" },
    { 0x9376, "timer" },
    { 0x9377, "timer_cancel" },
    { 0x9378, "timer_fail" },
    { 0x9379, "timer_number" },
    { 0x937A, "timer_run" },
    { 0x937B, "timername" },
    { 0x937C, "timeromnvars" },
    { 0x937D, "timerpausetime" },
    { 0x937E, "timerstopped" },
    { 0x937F, "timerstoppedforgamemode" },
    { 0x9380, "timescale" },
    { 0x9381, "timestartedtowait" },
    { 0x9382, "timetoadd" },
    { 0x9383, "timetodelete" },
    { 0x9384, "timeuntilroundend" },
    { 0x9385, "timeuntilspawn" },
    { 0x9386, "timeuntilwavespawn" },
    { 0x9387, "timing_offset_finale_cine_lighting" },
    { 0x9388, "tireskidprobability" },
    { 0x9389, "tispawndelay" },
    { 0x938A, "tispawnposition" },
    { 0x938B, "titan_camera_shake" },
    { 0x938C, "titan_death" },
    { 0x938D, "titan_engine" },
    { 0x938E, "titan_enter" },
    { 0x938F, "titan_fire_wait" },
    { 0x9390, "titan_footstep_front_left" },
    { 0x9391, "titan_footstep_front_right" },
    { 0x9392, "titan_footstep_rear_left" },
    { 0x9393, "titan_footstep_rear_right" },
    { 0x9394, "titan_gate_tread_fx" },
    { 0x9395, "titan_impact_fx_fl" },
    { 0x9396, "titan_impact_fx_fr" },
    { 0x9397, "titan_impact_fx_rl" },
    { 0x9398, "titan_impact_fx_rr" },
    { 0x9399, "titan_init" },
    { 0x939A, "titan_missile" },
    { 0x939B, "titan_take_damage_from_smaw" },
    { 0x939C, "titan_tank_tread" },
    { 0x939D, "titan_walker_explo" },
    { 0x939E, "titan_walker_explosions" },
    { 0x939F, "titan_walker_weapon_fire" },
    { 0x93A0, "title" },
    { 0x93A1, "title_line" },
    { 0x93A2, "titleisstring" },
    { 0x93A3, "titlelabel" },
    { 0x93A4, "titlemap" },
    { 0x93A5, "titletext" },
    { 0x93A6, "tivalidationcheck" },
    { 0x93A7, "tmodel" },
    { 0x93A8, "tmp_subtitle" },
    { 0x93A9, "to_ball_pitch_idle" },
    { 0x93AA, "to_ball_pitch_moving" },
    { 0x93AB, "to_ball_pitch_start_move" },
    { 0x93AC, "to_ball_pitch_stop_move" },
    { 0x93AD, "to_ball_roll_idle" },
    { 0x93AE, "to_ball_roll_moving" },
    { 0x93AF, "to_ball_roll_start_move" },
    { 0x93B0, "to_ball_roll_stop_move" },
    { 0x93B1, "to_refugee_camp" },
    { 0x93B2, "to_school1" },
    { 0x93B3, "to_school2" },
    { 0x93B4, "to_school3" },
    { 0x93B5, "to_second_land_assist_idles" },
    { 0x93B6, "to_second_land_assist_idles_cormack" },
    { 0x93B7, "to_vehicle_off" },
    { 0x93B8, "to_vehicle_on" },
    { 0x93B9, "to_vehicle_shutdown" },
    { 0x93BA, "to_vehicle_startup" },
    { 0x93BB, "to_wheel_left_idle" },
    { 0x93BC, "to_wheel_left_moving" },
    { 0x93BD, "to_wheel_left_start_move" },
    { 0x93BE, "to_wheel_left_stop_move" },
    { 0x93BF, "to_wheel_right_idle" },
    { 0x93C0, "to_wheel_right_moving" },
    { 0x93C1, "to_wheel_right_start_move" },
    { 0x93C2, "to_wheel_right_stop_move" },
    { 0x93C3, "toggle" },
    { 0x93C4, "toggle_all_boats_off" },
    { 0x93C5, "toggle_all_boats_on" },
    { 0x93C6, "toggle_all_boats_on_trigger" },
    { 0x93C7, "toggle_axismode" },
    { 0x93C8, "toggle_battle_chatter" },
    { 0x93C9, "toggle_boat_visibility" },
    { 0x93CA, "toggle_boat_visibility_group" },
    { 0x93CB, "toggle_chase_cam" },
    { 0x93CC, "toggle_createfx_drawing" },
    { 0x93CD, "toggle_entity_selection" },
    { 0x93CE, "toggle_exo_ping" },
    { 0x93CF, "toggle_fov" },
    { 0x93D0, "toggle_grenade_range_settings" },
    { 0x93D1, "toggle_has_trackrounds" },
    { 0x93D2, "toggle_hide" },
    { 0x93D3, "toggle_hide_guy" },
    { 0x93D4, "toggle_lighting_spot01_lightning" },
    { 0x93D5, "toggle_lighting_spot01_on" },
    { 0x93D6, "toggle_lighting_spot01_on_checkpoint" },
    { 0x93D7, "toggle_localrot" },
    { 0x93D8, "toggle_mount_mag_trigger_off" },
    { 0x93D9, "toggle_mount_mag_trigger_on" },
    { 0x93DA, "toggle_off_real_mob" },
    { 0x93DB, "toggle_on_real_mob" },
    { 0x93DC, "toggle_register_kills_for_vehicle_occupants" },
    { 0x93DD, "toggle_school_exterior_light_off" },
    { 0x93DE, "toggle_school_exterior_light_on" },
    { 0x93DF, "toggle_snap2normal" },
    { 0x93E0, "toggle_snap90deg" },
    { 0x93E1, "toggle_tactical_picker" },
    { 0x93E2, "togglebreachslomo" },
    { 0x93E3, "tolerance" },
    { 0x93E4, "tonemapkey_call" },
    { 0x93E5, "tonemapkey_call_control_room" },
    { 0x93E6, "tonemapkey_control_room_volume" },
    { 0x93E7, "tonemapkey_cooling_towers_volume" },
    { 0x93E8, "too_close_distance" },
    { 0x93E9, "too_close_to_leader" },
    { 0x93EA, "toogle_burke_fall_light" },
    { 0x93EB, "tookweaponfrom" },
    { 0x93EC, "tool_hud" },
    { 0x93ED, "tool_hud_visible" },
    { 0x93EE, "tool_hudelems" },
    { 0x93EF, "top_guy_spawn" },
    { 0x93F0, "top_level_kva_guys" },
    { 0x93F1, "torch" },
    { 0x93F2, "torresblood" },
    { 0x93F3, "toss_security_drone" },
    { 0x93F4, "tostr" },
    { 0x93F5, "tostring" },
    { 0x93F6, "total" },
    { 0x93F7, "total_dist" },
    { 0x93F8, "total_time" },
    { 0x93F9, "totalallweaponvariants" },
    { 0x93FA, "totalchemcanhealth" },
    { 0x93FB, "totaldamage" },
    { 0x93FC, "totalfriends" },
    { 0x93FD, "totalheavyclasstime" },
    { 0x93FE, "totallifetime" },
    { 0x93FF, "totallightclasstime" },
    { 0x9400, "totally_fake_drone_death" },
    { 0x9401, "totalplayers" },
    { 0x9402, "totalpossiblescore" },
    { 0x9403, "totalscore" },
    { 0x9404, "totalspawned" },
    { 0x9405, "totalspecialistclasstime" },
    { 0x9406, "totaltime" },
    { 0x9407, "touchdownevent" },
    { 0x9408, "touched" },
    { 0x9409, "touched_trigger_runs_func" },
    { 0x940A, "touching_border" },
    { 0x940B, "touching_trigger_ent" },
    { 0x940C, "touchingbadtrigger" },
    { 0x940D, "touchingplatformvalid" },
    { 0x940E, "touchingplayers" },
    { 0x940F, "touchingwatertriggers" },
    { 0x9410, "touchlist" },
    { 0x9411, "touchtest" },
    { 0x9412, "touchtriggers" },
    { 0x9413, "tour_ambient_00" },
    { 0x9414, "tour_ambient_01" },
    { 0x9415, "tour_ambient_02" },
    { 0x9416, "tour_ambient_choppers" },
    { 0x9417, "tour_ambient_drone_lifetime" },
    { 0x9418, "tour_ambient_people" },
    { 0x9419, "tour_augmented_reality" },
    { 0x941A, "tour_base_ambient_vehicle_01" },
    { 0x941B, "tour_base_ambient_vehicle_02" },
    { 0x941C, "tour_boost_jumper_lifetime" },
    { 0x941D, "tour_boost_jumpers_initial" },
    { 0x941E, "tour_boost_jumpers_overhead" },
    { 0x941F, "tour_brave_warrior_01" },
    { 0x9420, "tour_brave_warrior_03" },
    { 0x9421, "tour_cleanup_01" },
    { 0x9422, "tour_doors" },
    { 0x9423, "tour_drone_control" },
    { 0x9424, "tour_drone_interact_clear" },
    { 0x9425, "tour_drone_range_interact_manager" },
    { 0x9426, "tour_drone_range_target_lifetime" },
    { 0x9427, "tour_drone_range_targets" },
    { 0x9428, "tour_drone_range_timer" },
    { 0x9429, "tour_drone_range_use_triggers" },
    { 0x942A, "tour_drones_advanced_warfare" },
    { 0x942B, "tour_drones_fly_by" },
    { 0x942C, "tour_end" },
    { 0x942D, "tour_end_gate" },
    { 0x942E, "tour_exo_arm_repair_test_seq" },
    { 0x942F, "tour_exo_arm_repair_test_seq_internal" },
    { 0x9430, "tour_exo_begin" },
    { 0x9431, "tour_exo_boost" },
    { 0x9432, "tour_exo_boost_lifetime_ccw" },
    { 0x9433, "tour_exo_boost_lifetime_cw" },
    { 0x9434, "tour_exo_climb" },
    { 0x9435, "tour_exo_demo_gideon" },
    { 0x9436, "tour_exo_exit" },
    { 0x9437, "tour_exo_observe" },
    { 0x9438, "tour_exo_push" },
    { 0x9439, "tour_exo_push_motion_tracker" },
    { 0x943A, "tour_exo_repair_desk" },
    { 0x943B, "tour_exo_repair_player" },
    { 0x943C, "tour_exo_repair_tech_1" },
    { 0x943D, "tour_exo_repair_tech_1_branch" },
    { 0x943E, "tour_exo_repair_tech_2" },
    { 0x943F, "tour_exo_shield" },
    { 0x9440, "tour_exo_shield_model_swap" },
    { 0x9441, "tour_exo_shield_turret" },
    { 0x9442, "tour_exo_spar" },
    { 0x9443, "tour_fans" },
    { 0x9444, "tour_firing_range" },
    { 0x9445, "tour_giant_doors" },
    { 0x9446, "tour_gideon_movement_manager_exo_spar" },
    { 0x9447, "tour_glass_door_01" },
    { 0x9448, "tour_glass_door_02" },
    { 0x9449, "tour_glass_door_03" },
    { 0x944A, "tour_glass_door_04" },
    { 0x944B, "tour_glass_door_04_lighting" },
    { 0x944C, "tour_glass_door_05" },
    { 0x944D, "tour_grenade_range_drone_lifetime" },
    { 0x944E, "tour_grenade_range_drone_lifetime_minigame" },
    { 0x944F, "tour_grenade_range_drone_lifetime_tutorial" },
    { 0x9450, "tour_grenade_range_drone_spawn_with_spawner" },
    { 0x9451, "tour_grenade_range_gideon" },
    { 0x9452, "tour_grenade_range_interact_manager" },
    { 0x9453, "tour_grenade_range_minigame_drone_spawn_with_spawner" },
    { 0x9454, "tour_grenade_range_minigame_sequence" },
    { 0x9455, "tour_grenade_range_refills_highlight" },
    { 0x9456, "tour_grenade_range_score_feedback" },
    { 0x9457, "tour_grenade_range_score_manager" },
    { 0x9458, "tour_grenade_range_score_reset" },
    { 0x9459, "tour_grenade_range_screen_info_update" },
    { 0x945A, "tour_grenade_range_screen_toggle" },
    { 0x945B, "tour_grenade_range_tutorial_drone_spawn_with_spawner" },
    { 0x945C, "tour_grenade_range_use_triggers" },
    { 0x945D, "tour_hangar_ambient_people" },
    { 0x945E, "tour_hangar_door_01" },
    { 0x945F, "tour_hangar_drone_lifetime" },
    { 0x9460, "tour_hangar_drones" },
    { 0x9461, "tour_jeep_startup" },
    { 0x9462, "tour_jeep_tread" },
    { 0x9463, "tour_jets" },
    { 0x9464, "tour_lander_01" },
    { 0x9465, "tour_littlebird_ambient" },
    { 0x9466, "tour_littlebird_lander" },
    { 0x9467, "tour_military_ambient_people" },
    { 0x9468, "tour_range_door_01" },
    { 0x9469, "tour_range_door_02" },
    { 0x946A, "tour_ready_room_techs" },
    { 0x946B, "tour_ride" },
    { 0x946C, "tour_ride_begin" },
    { 0x946D, "tour_ride_gideon" },
    { 0x946E, "tour_ride_look_anims" },
    { 0x946F, "tour_ride_passengers" },
    { 0x9470, "tour_ride_player" },
    { 0x9471, "tour_shooting_range" },
    { 0x9472, "tour_shooting_range_gideon" },
    { 0x9473, "tour_shooting_range_ilona" },
    { 0x9474, "tour_shooting_range_interact_manager" },
    { 0x9475, "tour_shooting_range_screen_info_update_handler" },
    { 0x9476, "tour_shooting_range_screen_toggle" },
    { 0x9477, "tour_shooting_range_sequence" },
    { 0x9478, "tour_shooting_range_use_triggers" },
    { 0x9479, "tour_solid_door_01" },
    { 0x947A, "tour_solid_door_02" },
    { 0x947B, "tour_spawn_vtol" },
    { 0x947C, "tour_titan_01" },
    { 0x947D, "tour_titan_02" },
    { 0x947E, "tour_variable_grenade_auto_fill" },
    { 0x947F, "tour_variable_grenade_initial_acquisition" },
    { 0x9480, "tour_variable_grenade_refill_manager" },
    { 0x9481, "tour_windsock" },
    { 0x9482, "tour_yellow_door_01" },
    { 0x9483, "tour_yellow_door_02" },
    { 0x9484, "tour_yellow_door_03" },
    { 0x9485, "tower_collapse_dialog" },
    { 0x9486, "tower_collapse_knockback_disable_sonar" },
    { 0x9487, "tower_collapse_player_knockback" },
    { 0x9488, "tower_collapse_player_stumble" },
    { 0x9489, "tower_collapse_prep" },
    { 0x948A, "tower_collapse_start" },
    { 0x948B, "tower_combat_wave3" },
    { 0x948C, "tower_combat_wave4" },
    { 0x948D, "tower_vo" },
    { 0x948E, "toy_chicken_common" },
    { 0x948F, "toy_model" },
    { 0x9490, "tprintln" },
    { 0x9491, "trace" },
    { 0x9492, "trace_distance" },
    { 0x9493, "trace_end_position" },
    { 0x9494, "trace_fx" },
    { 0x9495, "trace_part_for_efx" },
    { 0x9496, "trace_part_for_efx_cancel" },
    { 0x9497, "trace_to_enemy" },
    { 0x9498, "trace2d" },
    { 0x9499, "tracecollisionwarn" },
    { 0x949A, "tracedonerecently" },
    { 0x949B, "tracefx" },
    { 0x949C, "tracefx_on_tag" },
    { 0x949D, "tracelocation" },
    { 0x949E, "traceshow" },
    { 0x949F, "tracestart" },
    { 0x94A0, "tracevalidation" },
    { 0x94A1, "track" },
    { 0x94A2, "track_bone_origins" },
    { 0x94A3, "track_bridge_drone_deaths" },
    { 0x94A4, "track_concussion_grenade" },
    { 0x94A5, "track_damage_info" },
    { 0x94A6, "track_end" },
    { 0x94A7, "track_entered_vehicle" },
    { 0x94A8, "track_health_damage_function" },
    { 0x94A9, "track_inner" },
    { 0x94AA, "track_irons_begin" },
    { 0x94AB, "track_irons_main" },
    { 0x94AC, "track_irons_start" },
    { 0x94AD, "track_kills_over_time" },
    { 0x94AE, "track_loud_enough_achievement" },
    { 0x94AF, "track_outer" },
    { 0x94B0, "track_player" },
    { 0x94B1, "track_player_height" },
    { 0x94B2, "track_player_movement" },
    { 0x94B3, "track_player_velocity" },
    { 0x94B4, "track_reinforcement_location" },
    { 0x94B5, "track_semtex_grenade" },
    { 0x94B6, "track_smaw" },
    { 0x94B7, "track_start" },
    { 0x94B8, "trackailifespawn" },
    { 0x94B9, "trackattackerleaderboarddeathstats" },
    { 0x94BA, "trackcarepackages" },
    { 0x94BB, "trackcarrier" },
    { 0x94BC, "tracked" },
    { 0x94BD, "tracked_ent" },
    { 0x94BE, "tracked_ents" },
    { 0x94BF, "trackedbyplayer" },
    { 0x94C0, "trackedplayer" },
    { 0x94C1, "trackent" },
    { 0x94C2, "trackfreeplayedtime" },
    { 0x94C3, "trackgrenades" },
    { 0x94C4, "trackhostmigrationend" },
    { 0x94C5, "tracking" },
    { 0x94C6, "tracking_device" },
    { 0x94C7, "tracking_device_waits" },
    { 0x94C8, "tracking_grenade_beep" },
    { 0x94C9, "tracking_grenade_detonate" },
    { 0x94CA, "tracking_grenade_dud" },
    { 0x94CB, "tracking_grenade_get_target" },
    { 0x94CC, "tracking_grenade_handle_autosave" },
    { 0x94CD, "tracking_grenade_handle_damage" },
    { 0x94CE, "tracking_grenade_hover" },
    { 0x94CF, "tracking_grenade_jump" },
    { 0x94D0, "tracking_grenade_pickup" },
    { 0x94D1, "tracking_grenade_scare_enemies" },
    { 0x94D2, "tracking_grenade_strike" },
    { 0x94D3, "tracking_grenade_think" },
    { 0x94D4, "tracking_grenade_thrust_effect" },
    { 0x94D5, "tracking_init" },
    { 0x94D6, "trackingdrone" },
    { 0x94D7, "trackingdrone_changeowner" },
    { 0x94D8, "trackingdrone_enemy_lightfx" },
    { 0x94D9, "trackingdrone_followtarget" },
    { 0x94DA, "trackingdrone_friendly_lightfx" },
    { 0x94DB, "trackingdrone_highlighttarget" },
    { 0x94DC, "trackingdrone_leave" },
    { 0x94DD, "trackingdrone_lightfx" },
    { 0x94DE, "trackingdrone_movetoplayer" },
    { 0x94DF, "trackingdrone_stopmovement" },
    { 0x94E0, "trackingdrone_stunbegin" },
    { 0x94E1, "trackingdrone_stunend" },
    { 0x94E2, "trackingdrone_stunned" },
    { 0x94E3, "trackingdrone_watchdeath" },
    { 0x94E4, "trackingdrone_watchdisable" },
    { 0x94E5, "trackingdrone_watchforgoal" },
    { 0x94E6, "trackingdrone_watchhostmigration" },
    { 0x94E7, "trackingdrone_watchownerdeath" },
    { 0x94E8, "trackingdrone_watchownerloss" },
    { 0x94E9, "trackingdrone_watchroundend" },
    { 0x94EA, "trackingdrone_watchtargetdisconnect" },
    { 0x94EB, "trackingdrone_watchtimeout" },
    { 0x94EC, "trackingdronearray" },
    { 0x94ED, "trackingdronedebugposition" },
    { 0x94EE, "trackingdronedebugpositionforward" },
    { 0x94EF, "trackingdronedebugpositionheight" },
    { 0x94F0, "trackingdronedestroyed" },
    { 0x94F1, "trackingdroneexplode" },
    { 0x94F2, "trackingdroneinit" },
    { 0x94F3, "trackingdronemaxperplayer" },
    { 0x94F4, "trackingdrones" },
    { 0x94F5, "trackingdronesettings" },
    { 0x94F6, "trackingdronestartangles" },
    { 0x94F7, "trackingdronestartposition" },
    { 0x94F8, "trackingdronetimeout" },
    { 0x94F9, "trackingweapondeaths" },
    { 0x94FA, "trackingweaponheadshots" },
    { 0x94FB, "trackingweaponhipfirekills" },
    { 0x94FC, "trackingweaponhits" },
    { 0x94FD, "trackingweaponkills" },
    { 0x94FE, "trackingweaponname" },
    { 0x94FF, "trackingweaponshots" },
    { 0x9500, "trackingweaponusetime" },
    { 0x9501, "trackintelkills" },
    { 0x9502, "trackkillordelete" },
    { 0x9503, "tracklaststandchanges" },
    { 0x9504, "trackleaderboarddeathstats" },
    { 0x9505, "trackloop" },
    { 0x9506, "trackloop_anglesfornoshootpos" },
    { 0x9507, "trackloop_clampangles" },
    { 0x9508, "trackloop_cqbshootpos" },
    { 0x9509, "trackloop_getdesiredangles" },
    { 0x950A, "trackloop_setanimweights" },
    { 0x950B, "trackmissiles" },
    { 0x950C, "tracknoneditfx" },
    { 0x950D, "trackobject" },
    { 0x950E, "trackplayedtime" },
    { 0x950F, "trackriotshield" },
    { 0x9510, "trackrocket" },
    { 0x9511, "trackrounds" },
    { 0x9512, "trackrounds_death" },
    { 0x9513, "trackrounds_mark_till_death" },
    { 0x9514, "trackrounds_think" },
    { 0x9515, "trackshootentorpos" },
    { 0x9516, "trackstate" },
    { 0x9517, "trackteamchanges" },
    { 0x9518, "traffic_anim_bus_1" },
    { 0x9519, "traffic_burke_jump_bus_2" },
    { 0x951A, "traffic_burke_jump_bus_3" },
    { 0x951B, "traffic_burke_jump_bus_4" },
    { 0x951C, "traffic_burke_jump_bus_5" },
    { 0x951D, "traffic_burke_jump_settings" },
    { 0x951E, "traffic_burke_miss_failsafe" },
    { 0x951F, "traffic_burke_recover_failed_jump" },
    { 0x9520, "traffic_bus_3_flag_check" },
    { 0x9521, "traffic_bus_start_check_old" },
    { 0x9522, "traffic_camera_shake_after_middle_td" },
    { 0x9523, "traffic_camera_shake_before_middle_td" },
    { 0x9524, "traffic_cars" },
    { 0x9525, "traffic_cars_scriptmodel_only_count" },
    { 0x9526, "traffic_change_lane" },
    { 0x9527, "traffic_change_lane_speed" },
    { 0x9528, "traffic_collision_fx_func" },
    { 0x9529, "traffic_collision_hit_func" },
    { 0x952A, "traffic_crashed_vehicles" },
    { 0x952B, "traffic_damage_part_watcher" },
    { 0x952C, "traffic_drive_vehicle" },
    { 0x952D, "traffic_follower" },
    { 0x952E, "traffic_force_script_models_only" },
    { 0x952F, "traffic_fx_init" },
    { 0x9530, "traffic_handle_messages" },
    { 0x9531, "traffic_head_veh" },
    { 0x9532, "traffic_helicopter" },
    { 0x9533, "traffic_helicopter_magic_bullet_fire" },
    { 0x9534, "traffic_init" },
    { 0x9535, "traffic_lanes" },
    { 0x9536, "traffic_leader" },
    { 0x9537, "traffic_leader_pending" },
    { 0x9538, "traffic_leader_pending_check" },
    { 0x9539, "traffic_ledge_burke_loop_wait" },
    { 0x953A, "traffic_ledge_jump_trigger_use" },
    { 0x953B, "traffic_link_luggage" },
    { 0x953C, "traffic_locked" },
    { 0x953D, "traffic_manager" },
    { 0x953E, "traffic_old_speed" },
    { 0x953F, "traffic_path_all_cars_helper" },
    { 0x9540, "traffic_path_all_cars_set_command_single_lane" },
    { 0x9541, "traffic_path_all_cars_set_force_stop" },
    { 0x9542, "traffic_path_all_cars_set_script_brush" },
    { 0x9543, "traffic_path_head_car_random_stops" },
    { 0x9544, "traffic_path_head_car_set_force_script_model" },
    { 0x9545, "traffic_path_head_car_set_force_stop" },
    { 0x9546, "traffic_path_head_car_traffic_jam" },
    { 0x9547, "traffic_path_head_car_traffic_jam_end_thread" },
    { 0x9548, "traffic_path_remove_cars_at_node" },
    { 0x9549, "traffic_path_set_cars_at_node_ai_path_blocker" },
    { 0x954A, "traffic_player_hostage_truck_jump_passed" },
    { 0x954B, "traffic_pre_merge_follower" },
    { 0x954C, "traffic_rooftop_traverse" },
    { 0x954D, "traffic_set_traffic_tuning" },
    { 0x954E, "traffic_set_traffic_tuning_lagos_highway" },
    { 0x954F, "traffic_spawn_mode" },
    { 0x9550, "traffic_spawner" },
    { 0x9551, "traffic_spawners" },
    { 0x9552, "traffic_speed" },
    { 0x9553, "traffic_speed_override" },
    { 0x9554, "traffic_speed_status" },
    { 0x9555, "traffic_speed_status_prev" },
    { 0x9556, "traffic_start_camera_shake" },
    { 0x9557, "traffic_stop_waittime" },
    { 0x9558, "traffic_suv_group_a" },
    { 0x9559, "traffic_suv_group_b" },
    { 0x955A, "traffic_suv_group_c" },
    { 0x955B, "traffic_suv_group_d" },
    { 0x955C, "traffic_suv_group_e" },
    { 0x955D, "traffic_suv_takedown" },
    { 0x955E, "traffic_tail" },
    { 0x955F, "traffic_takedown" },
    { 0x9560, "traffic_traverse_fail_check" },
    { 0x9561, "traffic_traverse_fence_rip" },
    { 0x9562, "traffic_traverse_final_takedown_burke_start" },
    { 0x9563, "traffic_traverse_final_takedown_start_player_input" },
    { 0x9564, "traffic_traverse_final_takedown_start_player_validation" },
    { 0x9565, "traffic_traverse_final_takedown_truck_start" },
    { 0x9566, "traffic_traverse_ledge_player_input" },
    { 0x9567, "traffic_traverse_ledge_player_validation" },
    { 0x9568, "traffic_traverse_start" },
    { 0x9569, "traffic_traverse_start_player_input" },
    { 0x956A, "traffic_traverse_start_player_validation" },
    { 0x956B, "traffic_tune_extreme_near_car_dist" },
    { 0x956C, "traffic_tune_extreme_near_car_dist_sq" },
    { 0x956D, "traffic_tune_fill_spawn_dist_between_cars" },
    { 0x956E, "traffic_tune_fill_spawn_dist_between_cars_sq" },
    { 0x956F, "traffic_tune_follow_speed_scale" },
    { 0x9570, "traffic_tune_lane_change_angle" },
    { 0x9571, "traffic_tune_lane_change_cosangle" },
    { 0x9572, "traffic_tune_min_follow_dist" },
    { 0x9573, "traffic_tune_min_follow_dist_sq" },
    { 0x9574, "traffic_tune_min_speedup_dist" },
    { 0x9575, "traffic_tune_min_speedup_dist_sq" },
    { 0x9576, "traffic_tune_min_stop_dist" },
    { 0x9577, "traffic_tune_min_stop_dist_sq" },
    { 0x9578, "traffic_tune_no_spawn" },
    { 0x9579, "traffic_tune_single_spawn_dist_between_cars" },
    { 0x957A, "traffic_tune_single_spawn_dist_between_cars_sq" },
    { 0x957B, "traffic_tune_speedup_speed_scale" },
    { 0x957C, "traffic_tune_start_spawn_rand_chance" },
    { 0x957D, "traffic_type_swap" },
    { 0x957E, "traffic_vehicle_lights_off" },
    { 0x957F, "traffic_vehicle_lights_on" },
    { 0x9580, "traffic_vehicle_start_check" },
    { 0x9581, "trailing_jets_move_up_on_airbrake" },
    { 0x9582, "train_bridge_light_on" },
    { 0x9583, "train_gopath" },
    { 0x9584, "train_lighting" },
    { 0x9585, "train_radiosity" },
    { 0x9586, "train_rumble" },
    { 0x9587, "train_scare" },
    { 0x9588, "train_spotlight_lerp" },
    { 0x9589, "training_01_end_driver_gear_shift" },
    { 0x958A, "training_01_end_driver_seat_movement" },
    { 0x958B, "training_01_end_gideon_enter_jeep" },
    { 0x958C, "training_01_end_gideon_grabs_arm" },
    { 0x958D, "training_01_end_gideon_gun_away" },
    { 0x958E, "training_01_end_gideon_helps_up_plr" },
    { 0x958F, "training_01_end_gideon_idles" },
    { 0x9590, "training_01_end_gideon_mask" },
    { 0x9591, "training_01_end_gideon_pulls_gun" },
    { 0x9592, "training_01_end_gideon_punch" },
    { 0x9593, "training_01_end_gideon_shoots_potus" },
    { 0x9594, "training_01_end_gideon_to_player" },
    { 0x9595, "training_01_end_gideon_walk" },
    { 0x9596, "training_01_end_gideon_walks_away" },
    { 0x9597, "training_01_end_irons_enter_jeep" },
    { 0x9598, "training_01_end_irons_exit_jeep" },
    { 0x9599, "training_01_end_irons_hand_on_shoulder" },
    { 0x959A, "training_01_end_irons_walk_away" },
    { 0x959B, "training_01_end_player_arm_malfunction" },
    { 0x959C, "training_01_end_player_arm_up" },
    { 0x959D, "training_01_end_player_enters_jeep" },
    { 0x959E, "training_01_end_player_helped_up" },
    { 0x959F, "training_01_end_player_moves_to_seat" },
    { 0x95A0, "training_01_end_player_punched" },
    { 0x95A1, "training_01_end_player_sits" },
    { 0x95A2, "training_01_end_potus_gets_up" },
    { 0x95A3, "training_01_end_potus_shot" },
    { 0x95A4, "training_01_end_potus_threatened" },
    { 0x95A5, "training_2_begin" },
    { 0x95A6, "training_2_end" },
    { 0x95A7, "training_2_golf_course" },
    { 0x95A8, "training_2_irons_ending" },
    { 0x95A9, "training_2_lodge_begin" },
    { 0x95AA, "training_2_lodge_breach" },
    { 0x95AB, "training_2_lodge_exit" },
    { 0x95AC, "training_begin" },
    { 0x95AD, "training_door_cover_cloak_think" },
    { 0x95AE, "training_end" },
    { 0x95AF, "training_escape_gideon_punch" },
    { 0x95B0, "training_escape_vehicle_1_fx" },
    { 0x95B1, "training_escape_vehicle_2_fx" },
    { 0x95B2, "training_golf_course" },
    { 0x95B3, "training_lodge_begin" },
    { 0x95B4, "training_lodge_breach" },
    { 0x95B5, "training_lodge_exit" },
    { 0x95B6, "training_prone_hint_monitor" },
    { 0x95B7, "training_prone_hint_text" },
    { 0x95B8, "training_reset_stealth_settings" },
    { 0x95B9, "training_s1_alert" },
    { 0x95BA, "training_s1_alert_check" },
    { 0x95BB, "training_s1_alert_drones" },
    { 0x95BC, "training_s1_allies_advance" },
    { 0x95BD, "training_s1_allies_setup" },
    { 0x95BE, "training_s1_ambush_vehicles_think" },
    { 0x95BF, "training_s1_anim_gun_examine" },
    { 0x95C0, "training_s1_bathroom_breach_door" },
    { 0x95C1, "training_s1_bathroom_door_breach_anim" },
    { 0x95C2, "training_s1_bathroom_enemy_dialog" },
    { 0x95C3, "training_s1_bathroom_enemy_flag_death" },
    { 0x95C4, "training_s1_bathroom_enemy_monitor_death" },
    { 0x95C5, "training_s1_bathroom_enemy_think" },
    { 0x95C6, "training_s1_bathroom_force_death" },
    { 0x95C7, "training_s1_bedroom_spawners_think" },
    { 0x95C8, "training_s1_breach_encounter" },
    { 0x95C9, "training_s1_breach_enemy_death_check" },
    { 0x95CA, "training_s1_breach_enemy_monitor_death" },
    { 0x95CB, "training_s1_breach_enemy_stop_death_check" },
    { 0x95CC, "training_s1_breach_enemy_think" },
    { 0x95CD, "training_s1_breach_gun_up" },
    { 0x95CE, "training_s1_breach_kva_think" },
    { 0x95CF, "training_s1_breach_save" },
    { 0x95D0, "training_s1_breach_slomo_end" },
    { 0x95D1, "training_s1_breach_slowmo_start" },
    { 0x95D2, "training_s1_breack_tv_screen" },
    { 0x95D3, "training_s1_check_snipers" },
    { 0x95D4, "training_s1_cleanup" },
    { 0x95D5, "training_s1_clear_bedrooms" },
    { 0x95D6, "training_s1_door_breach_anim" },
    { 0x95D7, "training_s1_door_cover" },
    { 0x95D8, "training_s1_drone_ambush_scene" },
    { 0x95D9, "training_s1_drone_attack" },
    { 0x95DA, "training_s1_drone_attack_think" },
    { 0x95DB, "training_s1_drone_blinds_destroy_think" },
    { 0x95DC, "training_s1_drone_search" },
    { 0x95DD, "training_s1_end_breach_logic" },
    { 0x95DE, "training_s1_end_fov_end" },
    { 0x95DF, "training_s1_end_fov_start" },
    { 0x95E0, "training_s1_ending" },
    { 0x95E1, "training_s1_enemies_ambush_think" },
    { 0x95E2, "training_s1_enemies_living_room_think" },
    { 0x95E3, "training_s1_escape_vehicle" },
    { 0x95E4, "training_s1_escape_vehicle_driver" },
    { 0x95E5, "training_s1_escape_vehicle_think" },
    { 0x95E6, "training_s1_exo_breach_monitor_enemy_group_death" },
    { 0x95E7, "training_s1_flash_death_check" },
    { 0x95E8, "training_s1_flash_door" },
    { 0x95E9, "training_s1_flash_enemies_think" },
    { 0x95EA, "training_s1_flash_monitor" },
    { 0x95EB, "training_s1_golf_course_alert" },
    { 0x95EC, "training_s1_golf_course_custom_stealth" },
    { 0x95ED, "training_s1_golf_course_encounter" },
    { 0x95EE, "training_s1_golf_course_encounter_track_deaths" },
    { 0x95EF, "training_s1_golf_course_vehicles" },
    { 0x95F0, "training_s1_guard_house_doors" },
    { 0x95F1, "training_s1_handle_tour_cart" },
    { 0x95F2, "training_s1_head_shot1" },
    { 0x95F3, "training_s1_head_shot2" },
    { 0x95F4, "training_s1_hide_from_patrols" },
    { 0x95F5, "training_s1_intro_gun_up" },
    { 0x95F6, "training_s1_joker_move" },
    { 0x95F7, "training_s1_joker_mute_breach_start" },
    { 0x95F8, "training_s1_kill_surprise_enemy" },
    { 0x95F9, "training_s1_kill_threat_enemies" },
    { 0x95FA, "training_s1_kva_ambush1_think" },
    { 0x95FB, "training_s1_kva_ambush2_think" },
    { 0x95FC, "training_s1_kva_dead" },
    { 0x95FD, "training_s1_kva_shot" },
    { 0x95FE, "training_s1_living_room_check" },
    { 0x95FF, "training_s1_living_room_scene" },
    { 0x9600, "training_s1_living_room_scene_joker_open_door" },
    { 0x9601, "training_s1_living_room_timer" },
    { 0x9602, "training_s1_livingroom_ambush" },
    { 0x9603, "training_s1_monitor_surprise_enemy_death" },
    { 0x9604, "training_s1_opening" },
    { 0x9605, "training_s1_opening_guy_think" },
    { 0x9606, "training_s1_patio_door_breach" },
    { 0x9607, "training_s1_patio_door_breach_monitor" },
    { 0x9608, "training_s1_patio_door_clip" },
    { 0x9609, "training_s1_patio_doors" },
    { 0x960A, "training_s1_patio_enemies" },
    { 0x960B, "training_s1_patio_enemies_alert" },
    { 0x960C, "training_s1_patio_enemies_alert_check" },
    { 0x960D, "training_s1_patio_enemies_clear" },
    { 0x960E, "training_s1_patio_enemies_think" },
    { 0x960F, "training_s1_patio_joker_loc_check" },
    { 0x9610, "training_s1_patio_spawn_reinforcements" },
    { 0x9611, "training_s1_player_breach" },
    { 0x9612, "training_s1_pool_house_doors" },
    { 0x9613, "training_s1_popping_smoke" },
    { 0x9614, "training_s1_prep_breach_room" },
    { 0x9615, "training_s1_prepare_to_breach" },
    { 0x9616, "training_s1_president_blood" },
    { 0x9617, "training_s1_president_breach_monitor_death" },
    { 0x9618, "training_s1_president_breach_setup" },
    { 0x9619, "training_s1_president_dead" },
    { 0x961A, "training_s1_president_setup" },
    { 0x961B, "training_s1_president_shot" },
    { 0x961C, "training_s1_refill_threat_grenades" },
    { 0x961D, "training_s1_remove_player_weapons" },
    { 0x961E, "training_s1_runner_enemy_found_corpse" },
    { 0x961F, "training_s1_runner_enemy_think" },
    { 0x9620, "training_s1_runner_enemy_think_cleanup" },
    { 0x9621, "training_s1_search_drones_cleanup" },
    { 0x9622, "training_s1_search_drones_damage_check" },
    { 0x9623, "training_s1_search_drones_death_check" },
    { 0x9624, "training_s1_search_drones_play_ainm" },
    { 0x9625, "training_s1_set_sqaud_cqb_disable" },
    { 0x9626, "training_s1_set_sqaud_cqb_enable" },
    { 0x9627, "training_s1_set_squad_active_and_target" },
    { 0x9628, "training_s1_set_squad_passive_and_ignore" },
    { 0x9629, "training_s1_set_up_search_drones" },
    { 0x962A, "training_s1_setup_breach_marker" },
    { 0x962B, "training_s1_setup_cart" },
    { 0x962C, "training_s1_setup_driver" },
    { 0x962D, "training_s1_setup_gideon" },
    { 0x962E, "training_s1_setup_irons" },
    { 0x962F, "training_s1_setup_president" },
    { 0x9630, "training_s1_shoot_monitor" },
    { 0x9631, "training_s1_show_threat_text" },
    { 0x9632, "training_s1_show_threat_text_ender" },
    { 0x9633, "training_s1_sniper_enemies_think" },
    { 0x9634, "training_s1_snipers" },
    { 0x9635, "training_s1_squad_allow_run" },
    { 0x9636, "training_s1_start_stealth_watch" },
    { 0x9637, "training_s1_starting_enemies" },
    { 0x9638, "training_s1_starting_enemies_alerted" },
    { 0x9639, "training_s1_starting_enemies_charge" },
    { 0x963A, "training_s1_starting_enemies_think" },
    { 0x963B, "training_s1_startpoint_guy_think" },
    { 0x963C, "training_s1_surprise_enemy_alert" },
    { 0x963D, "training_s1_surprise_enemy_go" },
    { 0x963E, "training_s1_surprise_enemy_think" },
    { 0x963F, "training_s1_terrace_enemies_think" },
    { 0x9640, "training_s1_terrace_vehicles" },
    { 0x9641, "training_s1_terrace_vehicles_cleanup" },
    { 0x9642, "training_s1_terrace_vehicles_riders_cleanup" },
    { 0x9643, "training_s1_terrace_vehicles_riders_think" },
    { 0x9644, "training_s1_terrace_vehicles_think" },
    { 0x9645, "training_s1_threat_death_check" },
    { 0x9646, "training_s1_threat_door" },
    { 0x9647, "training_s1_threat_enemies" },
    { 0x9648, "training_s1_threat_enemies_react" },
    { 0x9649, "training_s1_tour_jeep_board_fail" },
    { 0x964A, "training_s1_tour_jeep_board_warn" },
    { 0x964B, "training_s1_unload1_think" },
    { 0x964C, "training_s1_windy_trees" },
    { 0x964D, "training_s1_windy_trees_think" },
    { 0x964E, "training_s2_allies_setup" },
    { 0x964F, "training_s2_ambush_vehicles_think" },
    { 0x9650, "training_s2_bedroom_1_door_scene" },
    { 0x9651, "training_s2_bedroom_2_scene" },
    { 0x9652, "training_s2_breach_encounter" },
    { 0x9653, "training_s2_breach_enemies_monitor" },
    { 0x9654, "training_s2_breach_enemy_death_check" },
    { 0x9655, "training_s2_breach_enemy_monitor_death" },
    { 0x9656, "training_s2_breach_enemy_stop_death_check" },
    { 0x9657, "training_s2_breach_enemy_think" },
    { 0x9658, "training_s2_breach_kva_think" },
    { 0x9659, "training_s2_breach_president_setup" },
    { 0x965A, "training_s2_breach_slowmo_start" },
    { 0x965B, "training_s2_door_breach_anim" },
    { 0x965C, "training_s2_drone_ambush_attack" },
    { 0x965D, "training_s2_drone_ambush_attack_think" },
    { 0x965E, "training_s2_drone_attack" },
    { 0x965F, "training_s2_drone_attack_death" },
    { 0x9660, "training_s2_drone_attack_think" },
    { 0x9661, "training_s2_drone_attack_vehicles_think" },
    { 0x9662, "training_s2_drone_blinds_destroy_think" },
    { 0x9663, "training_s2_drone_damaged" },
    { 0x9664, "training_s2_drone_end_think" },
    { 0x9665, "training_s2_drone_manager" },
    { 0x9666, "training_s2_ending" },
    { 0x9667, "training_s2_enemies_ambush_think" },
    { 0x9668, "training_s2_enemies_hall_think" },
    { 0x9669, "training_s2_enemies_living_room_think" },
    { 0x966A, "training_s2_enemies_patio_think" },
    { 0x966B, "training_s2_enemies_patrol_think" },
    { 0x966C, "training_s2_enemies_patrol_think_alerted" },
    { 0x966D, "training_s2_enemies_start_think" },
    { 0x966E, "training_s2_enemies_start_think_alerted" },
    { 0x966F, "training_s2_enemies_start2_think" },
    { 0x9670, "training_s2_enemies_start2_think_alerted" },
    { 0x9671, "training_s2_enemy_notify" },
    { 0x9672, "training_s2_escape_vehicle" },
    { 0x9673, "training_s2_exo_breach_knife" },
    { 0x9674, "training_s2_flash_monitor" },
    { 0x9675, "training_s2_gideon_mitchell_over_nag" },
    { 0x9676, "training_s2_golf_course_hide" },
    { 0x9677, "training_s2_golf_course_vehicles" },
    { 0x9678, "training_s2_guard_house_doors" },
    { 0x9679, "training_s2_helicopter_gideon" },
    { 0x967A, "training_s2_helicopter_irons" },
    { 0x967B, "training_s2_helicopter_player" },
    { 0x967C, "training_s2_kill_threat_enemies" },
    { 0x967D, "training_s2_kva_ambush1_think" },
    { 0x967E, "training_s2_kva_dead" },
    { 0x967F, "training_s2_kva_shot" },
    { 0x9680, "training_s2_living_room_check" },
    { 0x9681, "training_s2_living_room_scene" },
    { 0x9682, "training_s2_living_room_timer" },
    { 0x9683, "training_s2_open_bedroom_door_2" },
    { 0x9684, "training_s2_open_patio_door" },
    { 0x9685, "training_s2_opening" },
    { 0x9686, "training_s2_opening_guy_think" },
    { 0x9687, "training_s2_patio_combat" },
    { 0x9688, "training_s2_patio_doors" },
    { 0x9689, "training_s2_patio_enemies_alert_check" },
    { 0x968A, "training_s2_patio_enemies_alert_think" },
    { 0x968B, "training_s2_patio_enemies_damaged" },
    { 0x968C, "training_s2_player_breach" },
    { 0x968D, "training_s2_player_drone" },
    { 0x968E, "training_s2_player_drone_control" },
    { 0x968F, "training_s2_player_drone_delete" },
    { 0x9690, "training_s2_player_sniper" },
    { 0x9691, "training_s2_prep_breach_room" },
    { 0x9692, "training_s2_president_breach_monitor_death" },
    { 0x9693, "training_s2_president_breach_ready" },
    { 0x9694, "training_s2_president_dead" },
    { 0x9695, "training_s2_president_setup" },
    { 0x9696, "training_s2_president_shot" },
    { 0x9697, "training_s2_scriptables_reset" },
    { 0x9698, "training_s2_set_squad_active_and_target" },
    { 0x9699, "training_s2_set_squad_passive_and_ignore" },
    { 0x969A, "training_s2_setup_president" },
    { 0x969B, "training_s2_shield_tutorial" },
    { 0x969C, "training_s2_show_drone_text" },
    { 0x969D, "training_s2_spawn_search_vehicle" },
    { 0x969E, "training_s2_squad_allow_run" },
    { 0x969F, "training_s2_start_set_up_player" },
    { 0x96A0, "training_s2_start_squad_attack" },
    { 0x96A1, "training_s2_starting_enemies" },
    { 0x96A2, "training_s2_starting_enemy_charge" },
    { 0x96A3, "training_s2_startpoint_guy_think" },
    { 0x96A4, "training_s2_threat_death_check" },
    { 0x96A5, "training_s2_threat_door" },
    { 0x96A6, "training_s2_unload_drone_attack_think" },
    { 0x96A7, "training_s2_unload1_think" },
    { 0x96A8, "training_s2_wait_for_bedrooms_dead" },
    { 0x96A9, "training_s2_wait_for_hallway_dead" },
    { 0x96AA, "training_s2_wait_for_living_room_dead" },
    { 0x96AB, "training_s2_wait_for_suprise_dead" },
    { 0x96AC, "training_set_up_player" },
    { 0x96AD, "training_stealth_spotted" },
    { 0x96AE, "training_surprise_enemy_move_to_patio" },
    { 0x96AF, "training_surprise_enemy_think" },
    { 0x96B0, "training_unlock_doors" },
    { 0x96B1, "trajectory_kill" },
    { 0x96B2, "tram_animate" },
    { 0x96B3, "tram_hide_icon" },
    { 0x96B4, "tram_init" },
    { 0x96B5, "tram_killstreak_cancel_watch" },
    { 0x96B6, "tram_killstreak_exit_watch" },
    { 0x96B7, "tram_killstreak_init" },
    { 0x96B8, "tram_killstreak_match_ended" },
    { 0x96B9, "tram_killstreak_move" },
    { 0x96BA, "tram_killstreak_team_change_watch" },
    { 0x96BB, "tram_move" },
    { 0x96BC, "tram_node_notify" },
    { 0x96BD, "tram_reset" },
    { 0x96BE, "tram_set_forward" },
    { 0x96BF, "tram_set_reverse" },
    { 0x96C0, "tram_show_icon" },
    { 0x96C1, "tram_spline_debug" },
    { 0x96C2, "tram_spline_leave" },
    { 0x96C3, "tram_spline_move" },
    { 0x96C4, "tram_spline_stay_in_playspace" },
    { 0x96C5, "tram_spline_vehicle_spawn" },
    { 0x96C6, "tram_start_player_control" },
    { 0x96C7, "tram_stinger_target_pos" },
    { 0x96C8, "tram_stop_player_control" },
    { 0x96C9, "tram_update_player_spline_control" },
    { 0x96CA, "tram_update_shooting_location" },
    { 0x96CB, "tramby_id" },
    { 0x96CC, "tramlockonentsforteam" },
    { 0x96CD, "tramondeath" },
    { 0x96CE, "trams" },
    { 0x96CF, "trans_alleys_corner" },
    { 0x96D0, "trans_alleys_corner_shot" },
    { 0x96D1, "trans_alleys_end_alley_trigger" },
    { 0x96D2, "trans_alleys_end_corner_trigger" },
    { 0x96D3, "trans_alleys_end_scripted_enemy_gunshots" },
    { 0x96D4, "trans_alleys_female_scream" },
    { 0x96D5, "trans_alleys_scripted_female_scream" },
    { 0x96D6, "trans_civ_01_flee_kva" },
    { 0x96D7, "trans_civ_03_flee_kva" },
    { 0x96D8, "trans_time" },
    { 0x96D9, "trans2alleysbackdoorciv" },
    { 0x96DA, "trans2alleysbegin" },
    { 0x96DB, "trans2alleysbridgecivilians" },
    { 0x96DC, "trans2alleyscafecivilians" },
    { 0x96DD, "trans2alleyscivcafe" },
    { 0x96DE, "trans2alleyscivdying" },
    { 0x96DF, "trans2alleyscivilians" },
    { 0x96E0, "trans2alleysciviliansvskva" },
    { 0x96E1, "trans2alleyscivrunner" },
    { 0x96E2, "trans2alleyscivvictim" },
    { 0x96E3, "trans2alleyscivwindowpeek" },
    { 0x96E4, "trans2alleyscombat" },
    { 0x96E5, "trans2alleysdoorpeek" },
    { 0x96E6, "trans2alleysdoorrunin" },
    { 0x96E7, "trans2alleysexecutioner" },
    { 0x96E8, "trans2alleysilanagatebash" },
    { 0x96E9, "trans2alleysmagicdisappearingworldevent" },
    { 0x96EA, "trans2alleysobjectivesetup" },
    { 0x96EB, "trans2alleyssitsmoke" },
    { 0x96EC, "trans2alleysslowplayer" },
    { 0x96ED, "trans2alleysstandupcivcafe" },
    { 0x96EE, "trans2alleystunnelrunners" },
    { 0x96EF, "trans2alleysunblockplayer" },
    { 0x96F0, "transfer_grenade_ownership" },
    { 0x96F1, "transfer_primer_to_corpse" },
    { 0x96F2, "transformpoint" },
    { 0x96F3, "transformpointbyentity" },
    { 0x96F4, "transient_add_gatetrans_entry" },
    { 0x96F5, "transient_cleanup" },
    { 0x96F6, "transient_hide_intro_vista_buildings" },
    { 0x96F7, "transient_init" },
    { 0x96F8, "transient_intro_to_middle" },
    { 0x96F9, "transient_intro_to_middle_begin" },
    { 0x96FA, "transient_load" },
    { 0x96FB, "transient_middle_add_hospital_interior_begin" },
    { 0x96FC, "transient_middle_add_nighclub_interior_begin" },
    { 0x96FD, "transient_middle_add_school_interior_begin" },
    { 0x96FE, "transient_middle_remove_hospital_interior_begin" },
    { 0x96FF, "transient_middle_remove_nightclub_interior_begin" },
    { 0x9700, "transient_middle_remove_school_interior_begin" },
    { 0x9701, "transient_notetracks_bigm" },
    { 0x9702, "transient_notetracks_intro" },
    { 0x9703, "transient_notetracks_outro" },
    { 0x9704, "transient_switch" },
    { 0x9705, "transient_transition_alley_to_outro" },
    { 0x9706, "transient_transition_intro_to_middle" },
    { 0x9707, "transient_transition_load_alley" },
    { 0x9708, "transient_transition_middle_to_outro" },
    { 0x9709, "transient_transition_unload_lobby" },
    { 0x970A, "transient_transition_unload_middle" },
    { 0x970B, "transient_transitions" },
    { 0x970C, "transient_unload" },
    { 0x970D, "transient_unloadall_and_load" },
    { 0x970E, "transient_zone" },
    { 0x970F, "transindex" },
    { 0x9710, "transition_has_inverse" },
    { 0x9711, "transition_off" },
    { 0x9712, "transition_on" },
    { 0x9713, "transition_to_hovertank_fov" },
    { 0x9714, "transition_unload_then_load_safely" },
    { 0x9715, "transitionfadein" },
    { 0x9716, "transitionfadeout" },
    { 0x9717, "transitioning" },
    { 0x9718, "transitionmeshes" },
    { 0x9719, "transitionmeshesrev" },
    { 0x971A, "transitionpulsefxin" },
    { 0x971B, "transitionreset" },
    { 0x971C, "transitions" },
    { 0x971D, "transitionslidein" },
    { 0x971E, "transitionslideout" },
    { 0x971F, "transitiontime" },
    { 0x9720, "transitionto" },
    { 0x9721, "transitiontocombat" },
    { 0x9722, "transitiontoidle" },
    { 0x9723, "transitiontostance" },
    { 0x9724, "transitionzoomin" },
    { 0x9725, "transitionzoomout" },
    { 0x9726, "translate_local" },
    { 0x9727, "translate_local_on_ent" },
    { 0x9728, "translateenttosliders" },
    { 0x9729, "trap_createbombsquadmodel" },
    { 0x972A, "trapkillcament" },
    { 0x972B, "travel_time" },
    { 0x972C, "travel_view_fx" },
    { 0x972D, "traverse_height" },
    { 0x972E, "traverse_height_delta" },
    { 0x972F, "traverse_start_damn_no_clear_shot" },
    { 0x9730, "traverse_start_fuck_it" },
    { 0x9731, "traverse_start_i_see_it" },
    { 0x9732, "traverse_start_jump_end_prompt" },
    { 0x9733, "traverse_start_jump_end_slowmo" },
    { 0x9734, "traverse_start_jump_player_looking" },
    { 0x9735, "traverse_start_jump_start_prompt" },
    { 0x9736, "traverse_start_jump_start_slowmo" },
    { 0x9737, "traverse_start_you_should_have_eyes" },
    { 0x9738, "traverseanim" },
    { 0x9739, "traverseanimroot" },
    { 0x973A, "traversedata" },
    { 0x973B, "traversedeath" },
    { 0x973C, "traversedeathanim" },
    { 0x973D, "traversedeathindex" },
    { 0x973E, "traverseendnode" },
    { 0x973F, "traversefall" },
    { 0x9740, "traverseheight" },
    { 0x9741, "traverseinfo" },
    { 0x9742, "traversestartnode" },
    { 0x9743, "traversestartz" },
    { 0x9744, "traversethink" },
    { 0x9745, "tread" },
    { 0x9746, "tread_override_thread" },
    { 0x9747, "tread_wait" },
    { 0x9748, "treadfx_ai_boats_taxi" },
    { 0x9749, "treadfx_ai_boats_taxi_vista" },
    { 0x974A, "treadfx_ai_boats_yacht" },
    { 0x974B, "treadfx_ai_boats_yacht_vista" },
    { 0x974C, "treadfx_freq_scale" },
    { 0x974D, "treadfx_maxheight" },
    { 0x974E, "treadfx_of_logging_road" },
    { 0x974F, "treadfx_override" },
    { 0x9750, "tree_head_impact" },
    { 0x9751, "tree_roots_lighting" },
    { 0x9752, "tricklebridgecivilians" },
    { 0x9753, "tridroneammo" },
    { 0x9754, "tridroneammoinit" },
    { 0x9755, "tridronedeployed" },
    { 0x9756, "tridronesettings" },
    { 0x9757, "trig" },
    { 0x9758, "trigarraywait" },
    { 0x9759, "trigarraywait2" },
    { 0x975A, "trigger_alarm_on_street_combat_started" },
    { 0x975B, "trigger_autosave" },
    { 0x975C, "trigger_autosave_immediate" },
    { 0x975D, "trigger_autosave_stealth" },
    { 0x975E, "trigger_autosave_tactical" },
    { 0x975F, "trigger_battlechatter" },
    { 0x9760, "trigger_bomb_shake" },
    { 0x9761, "trigger_bridge_small" },
    { 0x9762, "trigger_bus_traverse_5_flag_in" },
    { 0x9763, "trigger_bus_traverse_5_looking" },
    { 0x9764, "trigger_bus_traverse_5_threaded" },
    { 0x9765, "trigger_canal_p1" },
    { 0x9766, "trigger_canal_p2" },
    { 0x9767, "trigger_cansee" },
    { 0x9768, "trigger_chopper_spotlight_follow" },
    { 0x9769, "trigger_chopper_spotlight_straight" },
    { 0x976A, "trigger_control_room_gas_leak" },
    { 0x976B, "trigger_courtyard_point_sounds" },
    { 0x976C, "trigger_createart_transient" },
    { 0x976D, "trigger_damage_player_flag_set" },
    { 0x976E, "trigger_darkness" },
    { 0x976F, "trigger_delete_link_chain" },
    { 0x9770, "trigger_delete_on_touch" },
    { 0x9771, "trigger_delete_target_chain" },
    { 0x9772, "trigger_door" },
    { 0x9773, "trigger_dooropen" },
    { 0x9774, "trigger_ending" },
    { 0x9775, "trigger_ending2" },
    { 0x9776, "trigger_enemy_respawn" },
    { 0x9777, "trigger_enemy_stop_respawn" },
    { 0x9778, "trigger_enter_canal" },
    { 0x9779, "trigger_enter_finale_low_burn" },
    { 0x977A, "trigger_enter_finale_silo_blue" },
    { 0x977B, "trigger_enter_finale_silo_center" },
    { 0x977C, "trigger_enter_finale_silo_orange" },
    { 0x977D, "trigger_enter_finale_silo_orange_approach" },
    { 0x977E, "trigger_enter_finale_silo_round_tunnel" },
    { 0x977F, "trigger_enter_hotel" },
    { 0x9780, "trigger_enter_hotel_lobby" },
    { 0x9781, "trigger_enter_hotel_lrg" },
    { 0x9782, "trigger_enter_jb1_s_flicker" },
    { 0x9783, "trigger_enter_jb2_s_flicker" },
    { 0x9784, "trigger_enter_lensflare_subway_int_off" },
    { 0x9785, "trigger_enter_lensflare_subway_int_on" },
    { 0x9786, "trigger_enter_sinkhole" },
    { 0x9787, "trigger_enter_sinkhole_s_flicker" },
    { 0x9788, "trigger_enter_subway" },
    { 0x9789, "trigger_enter_vision_light_fog_normal" },
    { 0x978A, "trigger_exit_hotel" },
    { 0x978B, "trigger_exit_tunnel" },
    { 0x978C, "trigger_exterior_fog" },
    { 0x978D, "trigger_fall_to_hotel_lobby" },
    { 0x978E, "trigger_fallingwatervolume_think" },
    { 0x978F, "trigger_flag_clear" },
    { 0x9790, "trigger_flag_on_cleared" },
    { 0x9791, "trigger_flag_set" },
    { 0x9792, "trigger_flag_set_coop" },
    { 0x9793, "trigger_flag_set_player" },
    { 0x9794, "trigger_flag_set_specialops" },
    { 0x9795, "trigger_flag_set_specialops_clear" },
    { 0x9796, "trigger_flag_set_touching" },
    { 0x9797, "trigger_flags" },
    { 0x9798, "trigger_flashlight_off" },
    { 0x9799, "trigger_fob_dof_autofocus_disable" },
    { 0x979A, "trigger_fob_dof_autofocus_enable" },
    { 0x979B, "trigger_fob_dof_moment" },
    { 0x979C, "trigger_fog" },
    { 0x979D, "trigger_force_shadow_off_subcarback_firespot" },
    { 0x979E, "trigger_force_shadow_on_subcarback_firespot" },
    { 0x979F, "trigger_friendly_respawn" },
    { 0x97A0, "trigger_friendly_stop_respawn" },
    { 0x97A1, "trigger_func" },
    { 0x97A2, "trigger_function_keys" },
    { 0x97A3, "trigger_functions" },
    { 0x97A4, "trigger_glass_break" },
    { 0x97A5, "trigger_group" },
    { 0x97A6, "trigger_group_remove" },
    { 0x97A7, "trigger_handle_jump_mount" },
    { 0x97A8, "trigger_handle_mag_mount" },
    { 0x97A9, "trigger_hint" },
    { 0x97AA, "trigger_hint_func" },
    { 0x97AB, "trigger_hint_string" },
    { 0x97AC, "trigger_hotel_fall" },
    { 0x97AD, "trigger_ignore" },
    { 0x97AE, "trigger_interior_fog" },
    { 0x97AF, "trigger_issues_orders" },
    { 0x97B0, "trigger_kill_jb_s_flicker" },
    { 0x97B1, "trigger_kill_player" },
    { 0x97B2, "trigger_kill_sh_s_flicker" },
    { 0x97B3, "trigger_lookat" },
    { 0x97B4, "trigger_lookat_think" },
    { 0x97B5, "trigger_looking" },
    { 0x97B6, "trigger_multiple_audio_blend" },
    { 0x97B7, "trigger_multiple_audio_get_target_ent_origin" },
    { 0x97B8, "trigger_multiple_audio_get_target_ent_target" },
    { 0x97B9, "trigger_multiple_audio_get_target_ent_target_ent" },
    { 0x97BA, "trigger_multiple_audio_get_target_ent_target_ent_origin" },
    { 0x97BB, "trigger_multiple_audio_get_zone_from" },
    { 0x97BC, "trigger_multiple_audio_get_zone_to" },
    { 0x97BD, "trigger_multiple_audio_progress" },
    { 0x97BE, "trigger_multiple_audio_progress_point" },
    { 0x97BF, "trigger_multiple_audio_register_callback" },
    { 0x97C0, "trigger_multiple_audio_trigger" },
    { 0x97C1, "trigger_multiple_compass" },
    { 0x97C2, "trigger_multiple_depthoffield" },
    { 0x97C3, "trigger_multiple_fx_trigger_off_think" },
    { 0x97C4, "trigger_multiple_fx_trigger_on_think" },
    { 0x97C5, "trigger_multiple_fx_volume" },
    { 0x97C6, "trigger_multiple_fx_watersheeting" },
    { 0x97C7, "trigger_multiple_interval" },
    { 0x97C8, "trigger_multiple_sunflare" },
    { 0x97C9, "trigger_multiple_tessellationcutoff" },
    { 0x97CA, "trigger_multiple_visionset" },
    { 0x97CB, "trigger_mwp_sinkhole_forceshadows" },
    { 0x97CC, "trigger_no_crouch_or_prone" },
    { 0x97CD, "trigger_no_prone" },
    { 0x97CE, "trigger_nobloodpool" },
    { 0x97CF, "trigger_off" },
    { 0x97D0, "trigger_off_proc" },
    { 0x97D1, "trigger_on" },
    { 0x97D2, "trigger_on_proc" },
    { 0x97D3, "trigger_origin" },
    { 0x97D4, "trigger_pacifist" },
    { 0x97D5, "trigger_physics" },
    { 0x97D6, "trigger_playerseek" },
    { 0x97D7, "trigger_pool_spawners" },
    { 0x97D8, "trigger_process" },
    { 0x97D9, "trigger_process_optimized" },
    { 0x97DA, "trigger_process_set" },
    { 0x97DB, "trigger_radio" },
    { 0x97DC, "trigger_reinforcement_get_reinforcement_spawner" },
    { 0x97DD, "trigger_reinforcement_spawn_guys" },
    { 0x97DE, "trigger_requires_player" },
    { 0x97DF, "trigger_runs_function_on_touch" },
    { 0x97E0, "trigger_s_flicker_fluo_jump2_shadow_on" },
    { 0x97E1, "trigger_science_room" },
    { 0x97E2, "trigger_script_flag_false" },
    { 0x97E3, "trigger_script_flag_true" },
    { 0x97E4, "trigger_seoul_art_center_atrium" },
    { 0x97E5, "trigger_seoul_building_jump" },
    { 0x97E6, "trigger_seoul_exterior" },
    { 0x97E7, "trigger_seoul_finale_cinematic_lighting" },
    { 0x97E8, "trigger_seoul_hotel_hallway_cg" },
    { 0x97E9, "trigger_seoul_shopping" },
    { 0x97EA, "trigger_seoul_streets_02" },
    { 0x97EB, "trigger_seoul_streets_02_xx" },
    { 0x97EC, "trigger_seoul_vista" },
    { 0x97ED, "trigger_set_and_clear_flag_think" },
    { 0x97EE, "trigger_setup" },
    { 0x97EF, "trigger_setup_bar2_enter" },
    { 0x97F0, "trigger_setup_bar2_exit" },
    { 0x97F1, "trigger_setup_shopping_restaraunt_interior_enter" },
    { 0x97F2, "trigger_setup_shopping_restaraunt_interior_exit" },
    { 0x97F3, "trigger_setup_shopping_walkway_enter" },
    { 0x97F4, "trigger_setup_shopping_walkway_exit" },
    { 0x97F5, "trigger_setup_shopping_walkway_pre_enter" },
    { 0x97F6, "trigger_silo_centroid_switch_floor3" },
    { 0x97F7, "trigger_silo_centroid_switch_top" },
    { 0x97F8, "trigger_silo_p1" },
    { 0x97F9, "trigger_slide" },
    { 0x97FA, "trigger_spawn" },
    { 0x97FB, "trigger_spawn_and_set_flag_think" },
    { 0x97FC, "trigger_spawner" },
    { 0x97FD, "trigger_spawner_reinforcement" },
    { 0x97FE, "trigger_spawner_spawns_guys" },
    { 0x97FF, "trigger_spawngroup" },
    { 0x9800, "trigger_sprinklervolume_setup" },
    { 0x9801, "trigger_sprinklervolume_think" },
    { 0x9802, "trigger_stats" },
    { 0x9803, "trigger_store_drive_sequence" },
    { 0x9804, "trigger_string" },
    { 0x9805, "trigger_sun_off" },
    { 0x9806, "trigger_sun_on" },
    { 0x9807, "trigger_throw_grenade_at_player" },
    { 0x9808, "trigger_to_flag" },
    { 0x9809, "trigger_to_notify" },
    { 0x980A, "trigger_turns_off" },
    { 0x980B, "trigger_unlock" },
    { 0x980C, "trigger_unlock_death" },
    { 0x980D, "trigger_vehicle_getin_spawn" },
    { 0x980E, "trigger_vehicle_spawn" },
    { 0x980F, "trigger_vehicle_spline_spawn" },
    { 0x9810, "trigger_wait" },
    { 0x9811, "trigger_wait_targetname" },
    { 0x9812, "trigger_wakevolume_think" },
    { 0x9813, "triggeractivate" },
    { 0x9814, "triggered_time" },
    { 0x9815, "triggerhintstring" },
    { 0x9816, "triggerhurtlower" },
    { 0x9817, "triggerhurtupper" },
    { 0x9818, "triggerkillvehiclesbuilding" },
    { 0x9819, "triggerkillvehiclesbuildingoffset" },
    { 0x981A, "triggerkillvehiclesheli" },
    { 0x981B, "triggerkillvehicleshelioffset" },
    { 0x981C, "triggerlowerorigin" },
    { 0x981D, "triggermultiplevisionlightsetinternal" },
    { 0x981E, "triggersenable" },
    { 0x981F, "triggertouchthink" },
    { 0x9820, "triggertype" },
    { 0x9821, "triggerunlocked" },
    { 0x9822, "triggerupperorigin" },
    { 0x9823, "trigorigin" },
    { 0x9824, "trigs" },
    { 0x9825, "trigunderwater" },
    { 0x9826, "trigwait" },
    { 0x9827, "triplekillcount" },
    { 0x9828, "trolley_doors_function" },
    { 0x9829, "troop_cache" },
    { 0x982A, "troop_cache_update_next" },
    { 0x982B, "trophies" },
    { 0x982C, "trophy_ammo_counter" },
    { 0x982D, "trophy_cost" },
    { 0x982E, "trophy_count" },
    { 0x982F, "trophy_reload" },
    { 0x9830, "trophy_reload_bar" },
    { 0x9831, "trophy_system" },
    { 0x9832, "trophy_system_backup" },
    { 0x9833, "trophy_system_explosion" },
    { 0x9834, "trophy0" },
    { 0x9835, "trophy60" },
    { 0x9836, "trophy80" },
    { 0x9837, "trophyactive" },
    { 0x9838, "trophyaddlaser" },
    { 0x9839, "trophyammo" },
    { 0x983A, "trophyammomax" },
    { 0x983B, "trophyangleoffset" },
    { 0x983C, "trophyarray" },
    { 0x983D, "trophybreak" },
    { 0x983E, "trophychangeowner" },
    { 0x983F, "trophydamage" },
    { 0x9840, "trophydisconnectwaiter" },
    { 0x9841, "trophyfx_enemy" },
    { 0x9842, "trophyfx_friendly" },
    { 0x9843, "trophyfx_ground_enemy" },
    { 0x9844, "trophyfx_ground_friendly" },
    { 0x9845, "trophyhandlelaser" },
    { 0x9846, "trophymovestunent" },
    { 0x9847, "trophyplayerspawnwaiter" },
    { 0x9848, "trophyremainingammo" },
    { 0x9849, "trophysetmindot" },
    { 0x984A, "trophystunbegin" },
    { 0x984B, "trophystunend" },
    { 0x984C, "trophytags" },
    { 0x984D, "trophyupdatelaser" },
    { 0x984E, "trophyuselistener" },
    { 0x984F, "trophywithinmindot" },
    { 0x9850, "truck" },
    { 0x9851, "truck_cargo_door_open" },
    { 0x9852, "truck_distance_to_end" },
    { 0x9853, "truck_dodge_qte" },
    { 0x9854, "truck_dust_trail" },
    { 0x9855, "truck_headlights_on" },
    { 0x9856, "truck_headon_collision" },
    { 0x9857, "truck_jump_slowmo" },
    { 0x9858, "truck_latch_open_trail" },
    { 0x9859, "truck_latch_rumble" },
    { 0x985A, "truck_middle_dodge_slowmo_end" },
    { 0x985B, "truck_middle_jump_slowmo_end" },
    { 0x985C, "truck_middle_jump2_slowmo_end" },
    { 0x985D, "truck_middle_punch_slowmo_end" },
    { 0x985E, "truck_middle_takedown_failure" },
    { 0x985F, "truck_middle_takedown_gameover" },
    { 0x9860, "truck_middle_takedown_middle_player_free_aim" },
    { 0x9861, "truck_middle_takedown_player_dodge_check" },
    { 0x9862, "truck_middle_takedown_player_jump" },
    { 0x9863, "truck_middle_takedown_player_jump2" },
    { 0x9864, "truck_middle_takedown_player_pull_windshield" },
    { 0x9865, "truck_middle_takedown_player_shot_enemy_check" },
    { 0x9866, "truck_middle_takedown_player_shot_timer" },
    { 0x9867, "truck_middle_takedown_set_normal_time_if_gun_fired" },
    { 0x9868, "truck_org_cords" },
    { 0x9869, "truck_punch_slowmo" },
    { 0x986A, "truck_rail_impact" },
    { 0x986B, "truck_rearview_mirror_snap" },
    { 0x986C, "truck_swap" },
    { 0x986D, "truck_swim_latch_open_player_validation" },
    { 0x986E, "truck_takedown" },
    { 0x986F, "truck_takedown_burke" },
    { 0x9870, "truck_takedown_player_fall" },
    { 0x9871, "truck_takedown_player_hold_check" },
    { 0x9872, "truck_takedown_player_hold_fail" },
    { 0x9873, "truck_takedown_player_pry_open" },
    { 0x9874, "truck_takedown_player_shot_enemy_check" },
    { 0x9875, "truck_takedown_radio" },
    { 0x9876, "truck_to_bus_slowmo" },
    { 0x9877, "truck_to_s1elevator_scene" },
    { 0x9878, "truck_treadfx_skid" },
    { 0x9879, "truck_treadfx_turn" },
    { 0x987A, "truck_treadfx_wheels" },
    { 0x987B, "truck_turret_flank_alley" },
    { 0x987C, "truck_turret_flank_alley_drive_away" },
    { 0x987D, "truck_turret_listener" },
    { 0x987E, "truck_water_impact" },
    { 0x987F, "truck_whipeout_anim_begin" },
    { 0x9880, "truckaudio" },
    { 0x9881, "truckblood" },
    { 0x9882, "truckbodystashanimations" },
    { 0x9883, "truckbrakelights" },
    { 0x9884, "truckdrivein" },
    { 0x9885, "truckjunk" },
    { 0x9886, "truckjunk_dyn" },
    { 0x9887, "truckmovetruck" },
    { 0x9888, "truckstartwalknotetrack" },
    { 0x9889, "truckstashweaponswap" },
    { 0x988A, "truecount" },
    { 0x988B, "truncate_time_ms" },
    { 0x988C, "try_balcony_death" },
    { 0x988D, "try_clear_hide_goal" },
    { 0x988E, "try_forever_spawn" },
    { 0x988F, "try_place_global_badplace" },
    { 0x9890, "try_raise_shield" },
    { 0x9891, "try_respawn_death" },
    { 0x9892, "try_to_autosave_now" },
    { 0x9893, "try_to_dogfight" },
    { 0x9894, "try_to_draw_line_to_node" },
    { 0x9895, "try_to_lock_on" },
    { 0x9896, "try_use_exo_mute" },
    { 0x9897, "tryadddeathanim" },
    { 0x9898, "tryaddfiringdeathanim" },
    { 0x9899, "tryautosave" },
    { 0x989A, "trycornerrightgrenadedeath" },
    { 0x989B, "trydive" },
    { 0x989C, "trydodgewithanim" },
    { 0x989D, "tryexposedreacquire" },
    { 0x989E, "tryexposedthrowgrenade" },
    { 0x989F, "trygivehordeweapon" },
    { 0x98A0, "trygrenade" },
    { 0x98A1, "trygrenadeposproc" },
    { 0x98A2, "trygrenadethrow" },
    { 0x98A3, "tryingtouseks" },
    { 0x98A4, "trymelee" },
    { 0x98A5, "tryorderto" },
    { 0x98A6, "tryreload" },
    { 0x98A7, "tryrunningtoenemy" },
    { 0x98A8, "trythrowinggrenade" },
    { 0x98A9, "trythrowinggrenadestayhidden" },
    { 0x98AA, "trytogetoutofdangeroussituation" },
    { 0x98AB, "trytorepelmissile" },
    { 0x98AC, "tryuseadrenaline" },
    { 0x98AD, "tryuseairstrike" },
    { 0x98AE, "tryuseassaultdrone" },
    { 0x98AF, "tryuseautosentry" },
    { 0x98B0, "tryusedefaultorbitalcarepackage" },
    { 0x98B1, "tryusedog" },
    { 0x98B2, "tryuseexplosivedrone" },
    { 0x98B3, "tryuseexplosivegel" },
    { 0x98B4, "tryuseextrahealth" },
    { 0x98B5, "tryusefastheal" },
    { 0x98B6, "tryuseheavyexosuit" },
    { 0x98B7, "tryusekillstreak" },
    { 0x98B8, "tryusemissilestrike" },
    { 0x98B9, "tryusempinstinct" },
    { 0x98BA, "tryusemplaser" },
    { 0x98BB, "tryusempprison" },
    { 0x98BC, "tryusemprecovery" },
    { 0x98BD, "tryusemprefraction" },
    { 0x98BE, "tryusemutebomb" },
    { 0x98BF, "tryusenuke" },
    { 0x98C0, "tryuseorbitalcarepackage" },
    { 0x98C1, "tryuseorbitaljuggernautexosuit" },
    { 0x98C2, "tryuseorbitalstrike" },
    { 0x98C3, "tryuseorbitalsupport" },
    { 0x98C4, "tryuserecondrone" },
    { 0x98C5, "tryusereconsquadmate" },
    { 0x98C6, "tryusereinforcementcommon" },
    { 0x98C7, "tryusereinforcementpractice" },
    { 0x98C8, "tryusereinforcementrare" },
    { 0x98C9, "tryusereinforcementuncommon" },
    { 0x98CA, "tryuseremotemgsentryturret" },
    { 0x98CB, "tryuseremotemgturret" },
    { 0x98CC, "tryuseremoteturret" },
    { 0x98CD, "tryuserepulsor" },
    { 0x98CE, "tryuserippedturret" },
    { 0x98CF, "tryuserippedturretinternal" },
    { 0x98D0, "tryusesam" },
    { 0x98D1, "tryusesolarreflector" },
    { 0x98D2, "tryusesquadmate" },
    { 0x98D3, "tryusestrafingrunairstrike" },
    { 0x98D4, "tryuseteamammorefill" },
    { 0x98D5, "tryusetrackingdrone" },
    { 0x98D6, "tryusetridrone" },
    { 0x98D7, "tryuseuav" },
    { 0x98D8, "tryusewarbird" },
    { 0x98D9, "tryusingsidearm" },
    { 0x98DA, "tsunami_alarm" },
    { 0x98DB, "tsunami_vo_ext" },
    { 0x98DC, "tsunami_vo_int" },
    { 0x98DD, "tunnel_runner_walla" },
    { 0x98DE, "tunnel_sequence_dof" },
    { 0x98DF, "turbine_combat_mid_checkpoint_1" },
    { 0x98E0, "turbine_enemy_elevator_removal" },
    { 0x98E1, "turbine_explo" },
    { 0x98E2, "turbine_fan_think" },
    { 0x98E3, "turbine_pre_explo" },
    { 0x98E4, "turbine_room" },
    { 0x98E5, "turbine_room_atmosphere" },
    { 0x98E6, "turbine_room_combat" },
    { 0x98E7, "turbine_room_combat_initial" },
    { 0x98E8, "turbine_room_combat_seek_player" },
    { 0x98E9, "turbine_room_elevator" },
    { 0x98EA, "turbine_room_elevator_ascent_time" },
    { 0x98EB, "turbine_room_elevator_button" },
    { 0x98EC, "turbine_room_elevator_button_pressed_anim" },
    { 0x98ED, "turbine_room_elevator_think" },
    { 0x98EE, "turbine_room_enemy_think" },
    { 0x98EF, "turbine_room_entrance_steam" },
    { 0x98F0, "turbine_room_explosion" },
    { 0x98F1, "turbine_room_explosion_flying_blades" },
    { 0x98F2, "turbine_room_explosion_launch_blade" },
    { 0x98F3, "turbine_room_goal_volume" },
    { 0x98F4, "turbine_room_goal_volume_trigger_think" },
    { 0x98F5, "turbine_room_pre_explosion" },
    { 0x98F6, "turbine_room_squibs" },
    { 0x98F7, "turbine_room_steam_player" },
    { 0x98F8, "turbine_room_turbines" },
    { 0x98F9, "turbine_spin" },
    { 0x98FA, "turkey_anim_nag" },
    { 0x98FB, "turkey_boost_assist" },
    { 0x98FC, "turkey_boost_logic" },
    { 0x98FD, "turkey_complain" },
    { 0x98FE, "turkey_drone" },
    { 0x98FF, "turkey_drone_logic" },
    { 0x9900, "turkey_enemy_anim" },
    { 0x9901, "turkey_enemy_anim_loop" },
    { 0x9902, "turkey_listen" },
    { 0x9903, "turkey_patrol_logic" },
    { 0x9904, "turkey_shoot" },
    { 0x9905, "turkey_shoot_anim" },
    { 0x9906, "turkey_shoot_dialog" },
    { 0x9907, "turkey_shoot_drone" },
    { 0x9908, "turkey_shoot_enemies" },
    { 0x9909, "turkey_shoot_enemy_dialog" },
    { 0x990A, "turkey_shoot_open_fire" },
    { 0x990B, "turkey_shoot_patrol" },
    { 0x990C, "turkey_timer" },
    { 0x990D, "turn_180_move_start_func" },
    { 0x990E, "turn_left" },
    { 0x990F, "turn_off_car_alarm" },
    { 0x9910, "turn_off_exploders" },
    { 0x9911, "turn_off_flares" },
    { 0x9912, "turn_off_gold_light" },
    { 0x9913, "turn_off_highlight" },
    { 0x9914, "turn_off_jammer_triggers" },
    { 0x9915, "turn_off_jeep_light" },
    { 0x9916, "turn_off_light" },
    { 0x9917, "turn_off_light_bright" },
    { 0x9918, "turn_off_lighting_fx_post_mini_games" },
    { 0x9919, "turn_off_the_cloak_effect" },
    { 0x991A, "turn_off_the_cloak_effect_when_able" },
    { 0x991B, "turn_off_top_tank_lights" },
    { 0x991C, "turn_on_cheap_flashlight" },
    { 0x991D, "turn_on_helmet_light" },
    { 0x991E, "turn_on_helmet_light_bright" },
    { 0x991F, "turn_on_highlight" },
    { 0x9920, "turn_on_lab_lights" },
    { 0x9921, "turn_on_lab_lights_scriptable" },
    { 0x9922, "turn_on_laser" },
    { 0x9923, "turn_on_laser_group_and_scan" },
    { 0x9924, "turn_on_the_cloak_effect" },
    { 0x9925, "turn_on_the_cloak_effect_wallclimb" },
    { 0x9926, "turn_on_the_cloak_effect_when_able" },
    { 0x9927, "turn_on_weapon_light" },
    { 0x9928, "turn_right" },
    { 0x9929, "turn_self_into_level_notify" },
    { 0x992A, "turn_signal_off" },
    { 0x992B, "turn_signal_on" },
    { 0x992C, "turn_thermal_off" },
    { 0x992D, "turn_thermal_on" },
    { 0x992E, "turn_trig_active_on_flag" },
    { 0x992F, "turn_unloading_drones_to_ai" },
    { 0x9930, "turnanim" },
    { 0x9931, "turnbackon" },
    { 0x9932, "turningaimingoff" },
    { 0x9933, "turningaimingon" },
    { 0x9934, "turnlastresort" },
    { 0x9935, "turnoff" },
    { 0x9936, "turnoffvariablescopehud" },
    { 0x9937, "turnonandhideorbitalhud" },
    { 0x9938, "turnondangerlights" },
    { 0x9939, "turnondangerlightsexplosive" },
    { 0x993A, "turnonplayerhudoutline" },
    { 0x993B, "turnonsuperfx" },
    { 0x993C, "turnonvariablescopehud" },
    { 0x993D, "turnthreshold" },
    { 0x993E, "turntime" },
    { 0x993F, "turntoangle" },
    { 0x9940, "turntofacerelativeyaw" },
    { 0x9941, "turntomatchnode" },
    { 0x9942, "turntomatchnodedirection" },
    { 0x9943, "turret" },
    { 0x9944, "turret_ai" },
    { 0x9945, "turret_aim_restore" },
    { 0x9946, "turret_aim_straight" },
    { 0x9947, "turret_aiming_near_target" },
    { 0x9948, "turret_animate" },
    { 0x9949, "turret_animfirstframe" },
    { 0x994A, "turret_blinky_light" },
    { 0x994B, "turret_can_see_target" },
    { 0x994C, "turret_choose_targets" },
    { 0x994D, "turret_cleanup" },
    { 0x994E, "turret_cleanup_on_unload" },
    { 0x994F, "turret_clearpickuphints" },
    { 0x9950, "turret_coolmonitor" },
    { 0x9951, "turret_createantiintrusionkillcament" },
    { 0x9952, "turret_damage_max" },
    { 0x9953, "turret_damage_min" },
    { 0x9954, "turret_damage_range" },
    { 0x9955, "turret_dead_vo" },
    { 0x9956, "turret_deathsounds" },
    { 0x9957, "turret_default_fire" },
    { 0x9958, "turret_deleteme" },
    { 0x9959, "turret_emp_ready" },
    { 0x995A, "turret_exploding_debug" },
    { 0x995B, "turret_find_user" },
    { 0x995C, "turret_fire_tag" },
    { 0x995D, "turret_firerocket" },
    { 0x995E, "turret_firerockets" },
    { 0x995F, "turret_function" },
    { 0x9960, "turret_gameend" },
    { 0x9961, "turret_get_angle_to_target" },
    { 0x9962, "turret_gunner_custom_anim" },
    { 0x9963, "turret_handledeath" },
    { 0x9964, "turret_handlelaser" },
    { 0x9965, "turret_handleownerdisconnect" },
    { 0x9966, "turret_handlepickup" },
    { 0x9967, "turret_handlepitch" },
    { 0x9968, "turret_handleuse" },
    { 0x9969, "turret_heatmonitor" },
    { 0x996A, "turret_hordeshootdrone" },
    { 0x996B, "turret_hud_clear" },
    { 0x996C, "turret_hud_elem_fadeout" },
    { 0x996D, "turret_hud_elem_init" },
    { 0x996E, "turret_hud_elem_init_nofade" },
    { 0x996F, "turret_hud_init" },
    { 0x9970, "turret_incrementdamagefade" },
    { 0x9971, "turret_is_mine" },
    { 0x9972, "turret_isstunned" },
    { 0x9973, "turret_minigun_fire" },
    { 0x9974, "turret_minigun_target_track" },
    { 0x9975, "turret_models" },
    { 0x9976, "turret_modifydamage" },
    { 0x9977, "turret_monitoruse" },
    { 0x9978, "turret_movedown" },
    { 0x9979, "turret_movement_sound" },
    { 0x997A, "turret_movement2_sound" },
    { 0x997B, "turret_movement3_sound" },
    { 0x997C, "turret_moveup" },
    { 0x997D, "turret_oncarrierchangedteam" },
    { 0x997E, "turret_oncarrierdeath" },
    { 0x997F, "turret_oncarrierdisconnect" },
    { 0x9980, "turret_ongameended" },
    { 0x9981, "turret_overheat_bar" },
    { 0x9982, "turret_player_init" },
    { 0x9983, "turret_playerthread" },
    { 0x9984, "turret_quickdeath" },
    { 0x9985, "turret_recenter" },
    { 0x9986, "turret_rotate_accel" },
    { 0x9987, "turret_rotate_timeout" },
    { 0x9988, "turret_set_default_on_mode" },
    { 0x9989, "turret_setactive" },
    { 0x998A, "turret_setcancelled" },
    { 0x998B, "turret_setcarried" },
    { 0x998C, "turret_setinactive" },
    { 0x998D, "turret_setpickuphints" },
    { 0x998E, "turret_setplaced" },
    { 0x998F, "turret_setup" },
    { 0x9990, "turret_shell_fx" },
    { 0x9991, "turret_shell_sound" },
    { 0x9992, "turret_shoot_missile" },
    { 0x9993, "turret_shoot_vtols" },
    { 0x9994, "turret_shotmonitor" },
    { 0x9995, "turret_startshooting" },
    { 0x9996, "turret_stoprockets" },
    { 0x9997, "turret_stopshooting" },
    { 0x9998, "turret_target_override" },
    { 0x9999, "turret_target_updater" },
    { 0x999A, "turret_target_validate" },
    { 0x999B, "turret_targeting" },
    { 0x999C, "turret_think" },
    { 0x999D, "turret_timeout" },
    { 0x999E, "turret_to_missile_index" },
    { 0x999F, "turret_track_rotatedirection" },
    { 0x99A0, "turret_turnleft" },
    { 0x99A1, "turret_update_rotatedirection" },
    { 0x99A2, "turret_use_time" },
    { 0x99A3, "turret_user_moves" },
    { 0x99A4, "turret_watchdisabled" },
    { 0x99A5, "turret_watchemp" },
    { 0x99A6, "turret1spawns" },
    { 0x99A7, "turret2passenger_anime" },
    { 0x99A8, "turret2spawns" },
    { 0x99A9, "turret3spawns" },
    { 0x99AA, "turretaccmaxs" },
    { 0x99AB, "turretaccmins" },
    { 0x99AC, "turretdeathanim" },
    { 0x99AD, "turretdeathanimroot" },
    { 0x99AE, "turretdeathdetacher" },
    { 0x99AF, "turretdeletesoundents" },
    { 0x99B0, "turretdetacher" },
    { 0x99B1, "turretdoaimanims" },
    { 0x99B2, "turretdoshoot" },
    { 0x99B3, "turretdoshootanims" },
    { 0x99B4, "turretfiretimer" },
    { 0x99B5, "turretflashbangedanim" },
    { 0x99B6, "turretinfo" },
    { 0x99B7, "turretinit" },
    { 0x99B8, "turretmodel" },
    { 0x99B9, "turretonvistarg" },
    { 0x99BA, "turretonvistarg_failed" },
    { 0x99BB, "turretpainanims" },
    { 0x99BC, "turretpitch" },
    { 0x99BD, "turretreloadanim" },
    { 0x99BE, "turrets" },
    { 0x99BF, "turretsettings" },
    { 0x99C0, "turretshoot" },
    { 0x99C1, "turretshootblank" },
    { 0x99C2, "turretspawnsoundents" },
    { 0x99C3, "turretspecialanims" },
    { 0x99C4, "turretspecialanimsroot" },
    { 0x99C5, "turretstate" },
    { 0x99C6, "turrettimer" },
    { 0x99C7, "turrettrackingoverlay" },
    { 0x99C8, "turrettype" },
    { 0x99C9, "tutorial_anim_struct" },
    { 0x99CA, "tutorial_enemy_1" },
    { 0x99CB, "tutorial_enemy_2" },
    { 0x99CC, "tutorial_enemy_3" },
    { 0x99CD, "tutorial_guards_vo" },
    { 0x99CE, "tutorial_vo" },
    { 0x99CF, "tv_broadcast_lp" },
    { 0x99D0, "tv_changes_color" },
    { 0x99D1, "tv_changes_intensity" },
    { 0x99D2, "tv_damage" },
    { 0x99D3, "tv_dest_lp" },
    { 0x99D4, "tv_destroyed" },
    { 0x99D5, "tv_lite_array" },
    { 0x99D6, "tv_logic" },
    { 0x99D7, "tv_movie" },
    { 0x99D8, "tv_movie2" },
    { 0x99D9, "tv_off" },
    { 0x99DA, "twar_dist" },
    { 0x99DB, "twar_spawn_dist" },
    { 0x99DC, "twar_spawn_dot" },
    { 0x99DD, "twar_team_momentum" },
    { 0x99DE, "twar_team_multiplier" },
    { 0x99DF, "twar_use_obj" },
    { 0x99E0, "twar_zone" },
    { 0x99E1, "twar_zones" },
    { 0x99E2, "tweak_enemy_hp" },
    { 0x99E3, "tweakablesinitialized" },
    { 0x99E4, "tweakart" },
    { 0x99E5, "tweakfile" },
    { 0x99E6, "tweaklightset" },
    { 0x99E7, "two_mech_hunt" },
    { 0x99E8, "two_stage_spawner_think" },
    { 0x99E9, "typeid" },
    { 0x99EA, "typelimited" },
    { 0x99EB, "uav_paint_effect" },
    { 0x99EC, "uavmodels" },
    { 0x99ED, "uavondeath" },
    { 0x99EE, "uavrig" },
    { 0x99EF, "uavtracker" },
    { 0x99F0, "uavtype" },
    { 0x99F1, "ugvmarkedarrays" },
    { 0x99F2, "ugvs" },
    { 0x99F3, "ui_action_slot_force_active_off" },
    { 0x99F4, "ui_action_slot_force_active_on" },
    { 0x99F5, "ui_action_slot_force_active_one_time" },
    { 0x99F6, "ui_dog_grenade_logic" },
    { 0x99F7, "uiparent" },
    { 0x99F8, "umbra" },
    { 0x99F9, "umbra_accuracy_tweaks" },
    { 0x99FA, "umbra_accuracy_tweaks_tank_field" },
    { 0x99FB, "umbra_override_tunnel" },
    { 0x99FC, "umbra_tweak_1024" },
    { 0x99FD, "umbra_tweak_128" },
    { 0x99FE, "unarmed" },
    { 0x99FF, "unblockarea" },
    { 0x9A00, "unblockentsinarea" },
    { 0x9A01, "uncloak_ambient_warbird" },
    { 0x9A02, "uncloak_model" },
    { 0x9A03, "uncloak_warbird" },
    { 0x9A04, "under_water_set" },
    { 0x9A05, "underground_pipe_explosion_pickup_truck_vfx" },
    { 0x9A06, "underground_pipe_explosion_utility_truck_vfx" },
    { 0x9A07, "underwater" },
    { 0x9A08, "underwater_ambient_fx" },
    { 0x9A09, "underwater_blood" },
    { 0x9A0A, "underwater_boat_visionset_change" },
    { 0x9A0B, "underwater_bullets" },
    { 0x9A0C, "underwater_bullets_4100" },
    { 0x9A0D, "underwater_bullets_4200" },
    { 0x9A0E, "underwater_bullets_4300" },
    { 0x9A0F, "underwater_bullets_500" },
    { 0x9A10, "underwater_bullets_530" },
    { 0x9A11, "underwater_bullets_540" },
    { 0x9A12, "underwater_bullets_vm" },
    { 0x9A13, "underwater_cloudy" },
    { 0x9A14, "underwater_hud_enable" },
    { 0x9A15, "underwater_lightset" },
    { 0x9A16, "underwater_mech_footsteps" },
    { 0x9A17, "underwater_objective_hack" },
    { 0x9A18, "underwater_reflection" },
    { 0x9A19, "underwater_rescue" },
    { 0x9A1A, "underwater_sequence" },
    { 0x9A1B, "underwater_sound_ent" },
    { 0x9A1C, "underwater_sunrays" },
    { 0x9A1D, "underwater_triggers" },
    { 0x9A1E, "underwater_visionset_callback" },
    { 0x9A1F, "underwater_visionset_change" },
    { 0x9A20, "underwater_visionset_change_cleanup" },
    { 0x9A21, "underwater_walk" },
    { 0x9A22, "underwaterbubbles" },
    { 0x9A23, "underwatercloudy" },
    { 0x9A24, "underwatermotiontype" },
    { 0x9A25, "underwatertriggers" },
    { 0x9A26, "undo" },
    { 0x9A27, "unearned_icon_col" },
    { 0x9A28, "unflash_flag" },
    { 0x9A29, "unfreezecontrolsdelay" },
    { 0x9A2A, "unhide_me_on_flag" },
    { 0x9A2B, "unignore_everything" },
    { 0x9A2C, "unique_id" },
    { 0x9A2D, "units2yards" },
    { 0x9A2E, "unlimit_player_view" },
    { 0x9A2F, "unlimited_ammo" },
    { 0x9A30, "unlimited_mech_ammo" },
    { 0x9A31, "unlink_failsafe" },
    { 0x9A32, "unlink_failsafe_running" },
    { 0x9A33, "unlink_from_zip" },
    { 0x9A34, "unlink_player_from_drone" },
    { 0x9A35, "unlink_player_from_mob_turret" },
    { 0x9A36, "unlink_trigger" },
    { 0x9A37, "unlinkanddelete" },
    { 0x9A38, "unlinknextframe" },
    { 0x9A39, "unlinkplayer" },
    { 0x9A3A, "unlinkto_with_world_offset" },
    { 0x9A3B, "unlit_model" },
    { 0x9A3C, "unlit_models" },
    { 0x9A3D, "unload_anim_height" },
    { 0x9A3E, "unload_delay" },
    { 0x9A3F, "unload_group" },
    { 0x9A40, "unload_groups" },
    { 0x9A41, "unload_intro_cinematic_assets" },
    { 0x9A42, "unload_load_transients" },
    { 0x9A43, "unload_model" },
    { 0x9A44, "unload_model_unload_anim" },
    { 0x9A45, "unload_node" },
    { 0x9A46, "unload_ondeath" },
    { 0x9A47, "unloadque" },
    { 0x9A48, "unlock" },
    { 0x9A49, "unlock_frogger_traffic_spawner" },
    { 0x9A4A, "unlock_on_death" },
    { 0x9A4B, "unlock_thread" },
    { 0x9A4C, "unlock_traffic_spawner" },
    { 0x9A4D, "unlock_wait" },
    { 0x9A4E, "unmake_hero" },
    { 0x9A4F, "unmark_enemy" },
    { 0x9A50, "unmark_guy" },
    { 0x9A51, "unmark_guy_fx" },
    { 0x9A52, "unmark_stencil" },
    { 0x9A53, "unmark_swarm_target" },
    { 0x9A54, "unmarkallies" },
    { 0x9A55, "unmarkandremoveoutline" },
    { 0x9A56, "unmarkdronetarget" },
    { 0x9A57, "unmatched_death_rig_light_waits_for_lights_off" },
    { 0x9A58, "unmute_wasp_oneshots" },
    { 0x9A59, "unpause_flickerlight" },
    { 0x9A5A, "unregister_moving_collision_on_nodes" },
    { 0x9A5B, "unresolved_collision_count" },
    { 0x9A5C, "unresolved_collision_damage" },
    { 0x9A5D, "unresolved_collision_func" },
    { 0x9A5E, "unresolved_collision_kill" },
    { 0x9A5F, "unresolved_collision_nearest_node" },
    { 0x9A60, "unresolved_collision_nodes" },
    { 0x9A61, "unresolved_collision_notify_min" },
    { 0x9A62, "unresolved_collision_owner_damage" },
    { 0x9A63, "unresolved_collision_void" },
    { 0x9A64, "unset_forcegoal" },
    { 0x9A65, "unsetautospot" },
    { 0x9A66, "unsetblackbox" },
    { 0x9A67, "unsetblastshield" },
    { 0x9A68, "unsetboostdash" },
    { 0x9A69, "unsetcarepackage" },
    { 0x9A6A, "unsetcrouchmovement" },
    { 0x9A6B, "unsetdelaymine" },
    { 0x9A6C, "unsetdoubleload" },
    { 0x9A6D, "unsetempimmune" },
    { 0x9A6E, "unsetendgame" },
    { 0x9A6F, "unsetenemydetection" },
    { 0x9A70, "unsetexomelee" },
    { 0x9A71, "unsetexoslam" },
    { 0x9A72, "unsetexoslide" },
    { 0x9A73, "unsetfinalstand" },
    { 0x9A74, "unsetfootstepeffect" },
    { 0x9A75, "unsetfootstepeffectsmall" },
    { 0x9A76, "unsetfreefall" },
    { 0x9A77, "unsetfriendlydetection" },
    { 0x9A78, "unsetfriendlyspawn" },
    { 0x9A79, "unsethighjump" },
    { 0x9A7A, "unsetintelmode" },
    { 0x9A7B, "unsetjuiced" },
    { 0x9A7C, "unsetjuicedondeath" },
    { 0x9A7D, "unsetjuicedonride" },
    { 0x9A7E, "unsetjumpincrease" },
    { 0x9A7F, "unsetlightarmor" },
    { 0x9A80, "unsetlightweight" },
    { 0x9A81, "unsetlocaljammer" },
    { 0x9A82, "unsetmarksman" },
    { 0x9A83, "unsetmovespeedincrease" },
    { 0x9A84, "unsetonemanarmy" },
    { 0x9A85, "unsetoverdrive" },
    { 0x9A86, "unsetoverkillpro" },
    { 0x9A87, "unsetpainted" },
    { 0x9A88, "unsetpersonaluav" },
    { 0x9A89, "unsetrearview" },
    { 0x9A8A, "unsetrefractionturretplayer" },
    { 0x9A8B, "unsetregenspeed" },
    { 0x9A8C, "unsetsaboteur" },
    { 0x9A8D, "unsetsharpfocus" },
    { 0x9A8E, "unsetshield" },
    { 0x9A8F, "unsetshowgrenades" },
    { 0x9A90, "unsetsiege" },
    { 0x9A91, "unsetsonicblast" },
    { 0x9A92, "unsetsteadyaimpro" },
    { 0x9A93, "unsetsteelnerves" },
    { 0x9A94, "unsetstim" },
    { 0x9A95, "unsetstoppingpower" },
    { 0x9A96, "unsetstunresistance" },
    { 0x9A97, "unsetthermal" },
    { 0x9A98, "unsetuav" },
    { 0x9A99, "unstoppable_friendly_fire_shield" },
    { 0x9A9A, "unstorable_weapons" },
    { 0x9A9B, "unsynchappened" },
    { 0x9A9C, "up_arrow" },
    { 0x9A9D, "up_position" },
    { 0x9A9E, "update_actor_damage" },
    { 0x9A9F, "update_aim_offset" },
    { 0x9AA0, "update_aiming" },
    { 0x9AA1, "update_anim_weight" },
    { 0x9AA2, "update_avatars" },
    { 0x9AA3, "update_battery_ability_icons" },
    { 0x9AA4, "update_battlechatter_hud" },
    { 0x9AA5, "update_bcs_locations" },
    { 0x9AA6, "update_boid_settings" },
    { 0x9AA7, "update_bumper_think" },
    { 0x9AA8, "update_button_buffers" },
    { 0x9AA9, "update_calculations" },
    { 0x9AAA, "update_camera_angles_on_path" },
    { 0x9AAB, "update_camera_on_path" },
    { 0x9AAC, "update_camera_params_ratio" },
    { 0x9AAD, "update_camera_position_on_path" },
    { 0x9AAE, "update_cave_drill_anim" },
    { 0x9AAF, "update_cave_drill_anim_inside" },
    { 0x9AB0, "update_deathflag" },
    { 0x9AB1, "update_debug_element_data" },
    { 0x9AB2, "update_debug_friendlycolor" },
    { 0x9AB3, "update_debug_friendlycolor_on_death" },
    { 0x9AB4, "update_dismount" },
    { 0x9AB5, "update_dodge" },
    { 0x9AB6, "update_drone_attacks" },
    { 0x9AB7, "update_drone_moves" },
    { 0x9AB8, "update_drone_tactical_movement" },
    { 0x9AB9, "update_dummy_target_position" },
    { 0x9ABA, "update_em1_heat_omnvar" },
    { 0x9ABB, "update_enemy_target_pos_while_running" },
    { 0x9ABC, "update_exo_battery_hud" },
    { 0x9ABD, "update_exo_shield_icon" },
    { 0x9ABE, "update_flag_outline" },
    { 0x9ABF, "update_flock" },
    { 0x9AC0, "update_flock_goal_positions" },
    { 0x9AC1, "update_flying_attack_drone_goal_pos" },
    { 0x9AC2, "update_func" },
    { 0x9AC3, "update_gamer_profile" },
    { 0x9AC4, "update_grenade_dodger" },
    { 0x9AC5, "update_health_bar" },
    { 0x9AC6, "update_hud_text" },
    { 0x9AC7, "update_local_class" },
    { 0x9AC8, "update_lua_hud" },
    { 0x9AC9, "update_max_players_from_team_agents" },
    { 0x9ACA, "update_minion_hud_outlines" },
    { 0x9ACB, "update_missile_hud" },
    { 0x9ACC, "update_move_anim_type" },
    { 0x9ACD, "update_move_front_bias" },
    { 0x9ACE, "update_moving_collision_on_node" },
    { 0x9ACF, "update_moving_object_volume" },
    { 0x9AD0, "update_nozzle_opening" },
    { 0x9AD1, "update_outlines" },
    { 0x9AD2, "update_overdrive_icon" },
    { 0x9AD3, "update_path_speed" },
    { 0x9AD4, "update_personality_camper" },
    { 0x9AD5, "update_personality_default" },
    { 0x9AD6, "update_player_attacker_accuracy" },
    { 0x9AD7, "update_player_damage" },
    { 0x9AD8, "update_rate" },
    { 0x9AD9, "update_reloading_progress_bar" },
    { 0x9ADA, "update_river_drill_anim" },
    { 0x9ADB, "update_rumble_intensity" },
    { 0x9ADC, "update_scanner_direction_in_track_player_mode" },
    { 0x9ADD, "update_scanner_yaw_in_sweep_mode" },
    { 0x9ADE, "update_scanner_yaw_returning_to_sweep_mode" },
    { 0x9ADF, "update_selected_entities" },
    { 0x9AE0, "update_sonic_aoe_icon" },
    { 0x9AE1, "update_stealth_debug_hud" },
    { 0x9AE2, "update_steering" },
    { 0x9AE3, "update_sun_flare_position" },
    { 0x9AE4, "update_tactical" },
    { 0x9AE5, "update_tactical_picker" },
    { 0x9AE6, "update_target_hud" },
    { 0x9AE7, "update_target_time" },
    { 0x9AE8, "update_thruster_angle" },
    { 0x9AE9, "update_thrusters" },
    { 0x9AEA, "update_time" },
    { 0x9AEB, "update_trigger_based_on_flags" },
    { 0x9AEC, "update_trigger_pos" },
    { 0x9AED, "update_trophy_reload_progress_bar" },
    { 0x9AEE, "update_ui_timers" },
    { 0x9AEF, "update_vehicle_status" },
    { 0x9AF0, "update_vfx_tags" },
    { 0x9AF1, "update_weapon_tag_visibility" },
    { 0x9AF2, "updateachievements" },
    { 0x9AF3, "updateaerialkillstreakmarker" },
    { 0x9AF4, "updateall" },
    { 0x9AF5, "updatealldifficulty" },
    { 0x9AF6, "updateammo" },
    { 0x9AF7, "updateangle" },
    { 0x9AF8, "updateanimpose" },
    { 0x9AF9, "updateattachedweaponmodels" },
    { 0x9AFA, "updatebar" },
    { 0x9AFB, "updatebarscale" },
    { 0x9AFC, "updatebodyroll" },
    { 0x9AFD, "updatebufferedstats" },
    { 0x9AFE, "updatecapsperminute" },
    { 0x9AFF, "updatecaptues" },
    { 0x9B00, "updatecarryobjectorigin" },
    { 0x9B01, "updatechallenges" },
    { 0x9B02, "updatechatter" },
    { 0x9B03, "updatecheckforceragdoll" },
    { 0x9B04, "updatechildren" },
    { 0x9B05, "updatecombat" },
    { 0x9B06, "updatecombatrecord" },
    { 0x9B07, "updatecombatrecordcommondata" },
    { 0x9B08, "updatecombatrecordforplayer" },
    { 0x9B09, "updatecombatrecordforplayergamemodes" },
    { 0x9B0A, "updatecombatrecordforplayertrends" },
    { 0x9B0B, "updatecompassicon" },
    { 0x9B0C, "updatecompassicons" },
    { 0x9B0D, "updatecontact" },
    { 0x9B0E, "updatecpm" },
    { 0x9B0F, "updatedamagefeedback" },
    { 0x9B10, "updatedamagefeedbackhud" },
    { 0x9B11, "updatedamagefeedbacksnd" },
    { 0x9B12, "updateddmscores" },
    { 0x9B13, "updatedeathiconsenabled" },
    { 0x9B14, "updatedefends" },
    { 0x9B15, "updatedomscores" },
    { 0x9B16, "updatedronesattackspeedmultiplier" },
    { 0x9B17, "updateendreasontext" },
    { 0x9B18, "updateenemy" },
    { 0x9B19, "updateenemyuse" },
    { 0x9B1A, "updateentityheadicon" },
    { 0x9B1B, "updateentityheadiconorigin" },
    { 0x9B1C, "updateflyinscopeoverlay" },
    { 0x9B1D, "updatefreeplayedtime" },
    { 0x9B1E, "updatefreeplayertimes" },
    { 0x9B1F, "updatefriendicons" },
    { 0x9B20, "updatefriendiconsettings" },
    { 0x9B21, "updatefrontandbackshields" },
    { 0x9B22, "updategameevents" },
    { 0x9B23, "updategameobjecthudindex" },
    { 0x9B24, "updategameskill" },
    { 0x9B25, "updategametypedvars" },
    { 0x9B26, "updategiveuponsuppressiontimer" },
    { 0x9B27, "updateheadiconorigin" },
    { 0x9B28, "updateheading" },
    { 0x9B29, "updatehordesettings" },
    { 0x9B2A, "updatehorizontalvelocity" },
    { 0x9B2B, "updatehoveridle" },
    { 0x9B2C, "updatehoverspeed" },
    { 0x9B2D, "updateidle" },
    { 0x9B2E, "updateisincombattimer" },
    { 0x9B2F, "updatekillstreaks" },
    { 0x9B30, "updatelaserstatus" },
    { 0x9B31, "updatelerppos" },
    { 0x9B32, "updateloadouts" },
    { 0x9B33, "updatelossstats" },
    { 0x9B34, "updatelowermessage" },
    { 0x9B35, "updatemagshots" },
    { 0x9B36, "updatemainmenu" },
    { 0x9B37, "updatematchbonusscores" },
    { 0x9B38, "updatemelee" },
    { 0x9B39, "updatememberstates" },
    { 0x9B3A, "updateminimapsetting" },
    { 0x9B3B, "updateminions" },
    { 0x9B3C, "updatemlgobjectives" },
    { 0x9B3D, "updatemove" },
    { 0x9B3E, "updatemoveanimweights" },
    { 0x9B3F, "updatemovemode" },
    { 0x9B40, "updatemovespeedscale" },
    { 0x9B41, "updatemovestate" },
    { 0x9B42, "updatenamedally" },
    { 0x9B43, "updateobjectivehintmessage" },
    { 0x9B44, "updateobjectivehintmessages" },
    { 0x9B45, "updateobjectivetext" },
    { 0x9B46, "updateobjectiveui" },
    { 0x9B47, "updateorigin" },
    { 0x9B48, "updateoutlines" },
    { 0x9B49, "updatepaintoutline" },
    { 0x9B4A, "updatepersratio" },
    { 0x9B4B, "updatepersratiobuffered" },
    { 0x9B4C, "updateplacement" },
    { 0x9B4D, "updateplayedtime" },
    { 0x9B4E, "updateplayerradarblocked" },
    { 0x9B4F, "updateplayersuavstatus" },
    { 0x9B50, "updateplayertimes" },
    { 0x9B51, "updateprogressbar" },
    { 0x9B52, "updatepronethread" },
    { 0x9B53, "updatepronewrapper" },
    { 0x9B54, "updateproxbar" },
    { 0x9B55, "updaterank" },
    { 0x9B56, "updaterankannouncehud" },
    { 0x9B57, "updaterate" },
    { 0x9B58, "updaterecentkills" },
    { 0x9B59, "updaterecoiloffset" },
    { 0x9B5A, "updatereflectionprobe" },
    { 0x9B5B, "updaterespawnsplash" },
    { 0x9B5C, "updatereturns" },
    { 0x9B5D, "updateriotshieldattachfornewweapon" },
    { 0x9B5E, "updateroundswon" },
    { 0x9B5F, "updaterumble" },
    { 0x9B60, "updaterunweightsonce" },
    { 0x9B61, "updatesavedlastweapon" },
    { 0x9B62, "updatescanbar" },
    { 0x9B63, "updatescopeglintwarning" },
    { 0x9B64, "updatescopeoverlay" },
    { 0x9B65, "updatescopeoverlayalpha" },
    { 0x9B66, "updatescoreboardctf" },
    { 0x9B67, "updatescoreboarddom" },
    { 0x9B68, "updatescorestatsffa" },
    { 0x9B69, "updateselectedbutton" },
    { 0x9B6A, "updatesentryplacement" },
    { 0x9B6B, "updateserversettings" },
    { 0x9B6C, "updatesessionstate" },
    { 0x9B6D, "updateshootinglocation" },
    { 0x9B6E, "updatesnipershooting" },
    { 0x9B6F, "updatesnipersuppression" },
    { 0x9B70, "updatesnipertargetentitylocation" },
    { 0x9B71, "updatesnipertargeting" },
    { 0x9B72, "updatesnipertargetlocation" },
    { 0x9B73, "updatespectatedloadout" },
    { 0x9B74, "updatespectatedloadoutweapon" },
    { 0x9B75, "updatespectatesettings" },
    { 0x9B76, "updatesppercent" },
    { 0x9B77, "updatesquadlist" },
    { 0x9B78, "updatestairsstate" },
    { 0x9B79, "updatestate" },
    { 0x9B7A, "updatestates" },
    { 0x9B7B, "updatestreakcount" },
    { 0x9B7C, "updatestreakslots" },
    { 0x9B7D, "updatesunshadowcenter" },
    { 0x9B7E, "updatesuppressionduration" },
    { 0x9B7F, "updatesuppressionfeedback" },
    { 0x9B80, "updatetargetangularacceleration" },
    { 0x9B81, "updatetargetdetails" },
    { 0x9B82, "updateteambalance" },
    { 0x9B83, "updateteambalancedvar" },
    { 0x9B84, "updateteampaintoutline" },
    { 0x9B85, "updateteamplacement" },
    { 0x9B86, "updateteamradarblocked" },
    { 0x9B87, "updateteamscore" },
    { 0x9B88, "updateteamscores" },
    { 0x9B89, "updateteamtime" },
    { 0x9B8A, "updateteamuavstatus" },
    { 0x9B8B, "updateteamuavtype" },
    { 0x9B8C, "updatetiestats" },
    { 0x9B8D, "updatetimer" },
    { 0x9B8E, "updatetimeromnvars" },
    { 0x9B8F, "updatetimerpausedness" },
    { 0x9B90, "updatetispawnposition" },
    { 0x9B91, "updatetraceentity" },
    { 0x9B92, "updatetrigger" },
    { 0x9B93, "updatetriggerposition" },
    { 0x9B94, "updateturretplacement" },
    { 0x9B95, "updateuavmodelvisibility" },
    { 0x9B96, "updateuiflagomnvars" },
    { 0x9B97, "updateuiprogress" },
    { 0x9B98, "updateuiscorelimit" },
    { 0x9B99, "updateusablebyteam" },
    { 0x9B9A, "updateuserate" },
    { 0x9B9B, "updateuserate_internal" },
    { 0x9B9C, "updatevelocity" },
    { 0x9B9D, "updateverticalvelocity" },
    { 0x9B9E, "updateviewmodelacceleration" },
    { 0x9B9F, "updateviewmodellookoffset" },
    { 0x9BA0, "updateviewmodelpitchoffset" },
    { 0x9BA1, "updateviewmodelvisibility" },
    { 0x9BA2, "updatevisibilityaccordingtoradar" },
    { 0x9BA3, "updatevisualmarker" },
    { 0x9BA4, "updatevisuals" },
    { 0x9BA5, "updatewaiter" },
    { 0x9BA6, "updatewatcheddvars" },
    { 0x9BA7, "updateweaponbufferedstats" },
    { 0x9BA8, "updateweaponusagestats" },
    { 0x9BA9, "updatewinlossstats" },
    { 0x9BAA, "updatewinstats" },
    { 0x9BAB, "updateworldicon" },
    { 0x9BAC, "updateworldicons" },
    { 0x9BAD, "updatinglootweapon" },
    { 0x9BAE, "upgrade_chal_complete_messages" },
    { 0x9BAF, "upgrade_chal_goal" },
    { 0x9BB0, "upgrade_chal_index" },
    { 0x9BB1, "upgrade_chal_points_trackers" },
    { 0x9BB2, "upgrade_chal_stat_map" },
    { 0x9BB3, "upgrade_challenge_complete" },
    { 0x9BB4, "upgrade_challenge_complete_for_intel" },
    { 0x9BB5, "upgrade_change_monitor" },
    { 0x9BB6, "upgrade_give_perk" },
    { 0x9BB7, "upgrade_init_perks_player" },
    { 0x9BB8, "upgrade_init_perks_players" },
    { 0x9BB9, "upgrade_init_perks_tables" },
    { 0x9BBA, "upgrade_init_player" },
    { 0x9BBB, "upgrade_init_tables" },
    { 0x9BBC, "upgrade_is_purchased" },
    { 0x9BBD, "upgrade_notify_stat" },
    { 0x9BBE, "upgrade_perk_active" },
    { 0x9BBF, "upgrade_perk_active_code" },
    { 0x9BC0, "upgrade_perk_code" },
    { 0x9BC1, "upgrade_perk_code_2" },
    { 0x9BC2, "upgrade_perk_dvar" },
    { 0x9BC3, "upgrade_perk_dvar_2" },
    { 0x9BC4, "upgrade_perk_dvar_newval" },
    { 0x9BC5, "upgrade_perk_dvar_newval_2" },
    { 0x9BC6, "upgrade_perk_dvar_origval" },
    { 0x9BC7, "upgrade_perk_dvar_origval_2" },
    { 0x9BC8, "upgrade_perk_script_code" },
    { 0x9BC9, "upgrade_ref" },
    { 0x9BCA, "upgrade_ref_index" },
    { 0x9BCB, "upgrade_take_perk" },
    { 0x9BCC, "upload_hold" },
    { 0x9BCD, "uploadglobalstatcounters" },
    { 0x9BCE, "ups_to_mph" },
    { 0x9BCF, "upsspeed" },
    { 0x9BD0, "upvec" },
    { 0x9BD1, "usable_turret_trigger" },
    { 0x9BD2, "usableent" },
    { 0x9BD3, "use_a_turret" },
    { 0x9BD4, "use_animstate" },
    { 0x9BD5, "use_big_goal_until_goal_is_safe" },
    { 0x9BD6, "use_boost_jump_dialogue" },
    { 0x9BD7, "use_box" },
    { 0x9BD8, "use_button_stopped_notify" },
    { 0x9BD9, "use_container_death" },
    { 0x9BDA, "use_crate" },
    { 0x9BDB, "use_eq_settings" },
    { 0x9BDC, "use_exo_shield_check" },
    { 0x9BDD, "use_hint" },
    { 0x9BDE, "use_hint_active" },
    { 0x9BDF, "use_hint_blinks" },
    { 0x9BE0, "use_hovertank_chromatic_aberration" },
    { 0x9BE1, "use_level_audio_zones" },
    { 0x9BE2, "use_lookahead" },
    { 0x9BE3, "use_m_turret_dialogue" },
    { 0x9BE4, "use_mobile_cover_dialogue" },
    { 0x9BE5, "use_old_battlechatter" },
    { 0x9BE6, "use_old_dog_attack" },
    { 0x9BE7, "use_pressed" },
    { 0x9BE8, "use_randomized_personality" },
    { 0x9BE9, "use_reverb_settings" },
    { 0x9BEA, "use_string_table_presets" },
    { 0x9BEB, "use_the_turret" },
    { 0x9BEC, "use_time" },
    { 0x9BED, "use_toggle" },
    { 0x9BEE, "use_trigger" },
    { 0x9BEF, "use_triggers" },
    { 0x9BF0, "use_turn_signal" },
    { 0x9BF1, "use_two_stage_swarm" },
    { 0x9BF2, "use_use_trigger" },
    { 0x9BF3, "usebreachapproach" },
    { 0x9BF4, "usebuttonrepressed" },
    { 0x9BF5, "useclip" },
    { 0x9BF6, "usecovernodeifpossible" },
    { 0x9BF7, "used" },
    { 0x9BF8, "used_an_mg42" },
    { 0x9BF9, "used_credits" },
    { 0x9BFA, "used_credits_data1" },
    { 0x9BFB, "used_credits_data2" },
    { 0x9BFC, "usedids" },
    { 0x9BFD, "usedkillstreak" },
    { 0x9BFE, "usednodes" },
    { 0x9BFF, "usedog" },
    { 0x9C00, "usedpositions" },
    { 0x9C01, "useent" },
    { 0x9C02, "usefacialanims" },
    { 0x9C03, "usegoliathupdater" },
    { 0x9C04, "usehardpoint" },
    { 0x9C05, "useholdthink" },
    { 0x9C06, "useholdthinkcleanuponplayerdeath" },
    { 0x9C07, "useholdthinkloop" },
    { 0x9C08, "useholdthinkplayerreset" },
    { 0x9C09, "uselaststandparams" },
    { 0x9C0A, "usemuzzleforaim" },
    { 0x9C0B, "usemuzzlesideoffset" },
    { 0x9C0C, "useobj" },
    { 0x9C0D, "useobject" },
    { 0x9C0E, "useobjectproxthink" },
    { 0x9C0F, "useobjectusethink" },
    { 0x9C10, "usepostjuggernautupdater" },
    { 0x9C11, "user_controlled_plane" },
    { 0x9C12, "user_data" },
    { 0x9C13, "userate" },
    { 0x9C14, "usereadystand" },
    { 0x9C15, "useselfplacedturret" },
    { 0x9C16, "usesquadmate" },
    { 0x9C17, "usestartspawns" },
    { 0x9C18, "usestationaryturret" },
    { 0x9C19, "useteam" },
    { 0x9C1A, "usetest" },
    { 0x9C1B, "usetext" },
    { 0x9C1C, "usetime" },
    { 0x9C1D, "usetrig" },
    { 0x9C1E, "useuav" },
    { 0x9C1F, "useweapon" },
    { 0x9C20, "useweaponinfo" },
    { 0x9C21, "using_a_turret" },
    { 0x9C22, "using_ammo_cache" },
    { 0x9C23, "using_entity" },
    { 0x9C24, "using_hdr_fog" },
    { 0x9C25, "using_illegal_breach_weapon" },
    { 0x9C26, "using_oneshots_or_loops" },
    { 0x9C27, "using_overrides" },
    { 0x9C28, "using_remote_tank" },
    { 0x9C29, "using_remote_turret" },
    { 0x9C2A, "using_remote_turret_when_died" },
    { 0x9C2B, "using_string_tables" },
    { 0x9C2C, "using_uav" },
    { 0x9C2D, "using_variable_grenade" },
    { 0x9C2E, "usingantiairweapon" },
    { 0x9C2F, "usingautomaticweapon" },
    { 0x9C30, "usingboltactionweapon" },
    { 0x9C31, "usingmg" },
    { 0x9C32, "usingnvfx" },
    { 0x9C33, "usingonlinedataoffline" },
    { 0x9C34, "usingpistol" },
    { 0x9C35, "usingplayergrenadetimer" },
    { 0x9C36, "usingprimary" },
    { 0x9C37, "usingremote" },
    { 0x9C38, "usingriflelikeweapon" },
    { 0x9C39, "usingrocketlauncher" },
    { 0x9C3A, "usingsecondary" },
    { 0x9C3B, "usingsemiautoweapon" },
    { 0x9C3C, "usingshotgun" },
    { 0x9C3D, "usingsidearm" },
    { 0x9C3E, "usingsmg" },
    { 0x9C3F, "usingturret" },
    { 0x9C40, "util_evaluateknownenemylocation" },
    { 0x9C41, "util_ignorecurrentsightpos" },
    { 0x9C42, "util_physicspush_watcher" },
    { 0x9C43, "uts19shock" },
    { 0x9C44, "utsshockqueuedtime" },
    { 0x9C45, "v" },
    { 0x9C46, "valid" },
    { 0x9C47, "valid_ball_pickup_weapon" },
    { 0x9C48, "valid_tp_node" },
    { 0x9C49, "validate_drone_test_points" },
    { 0x9C4A, "validate_max_value" },
    { 0x9C4B, "validate_min_value" },
    { 0x9C4C, "validate_target_pos" },
    { 0x9C4D, "validate_tp_orgs" },
    { 0x9C4E, "validateaccuratetouching" },
    { 0x9C4F, "validateflightlocationanddirection" },
    { 0x9C50, "validateopenconditions" },
    { 0x9C51, "validateperk" },
    { 0x9C52, "validateusestreak" },
    { 0x9C53, "validator" },
    { 0x9C54, "validcostume" },
    { 0x9C55, "validplayers" },
    { 0x9C56, "value" },
    { 0x9C57, "value_hudelem" },
    { 0x9C58, "value_last" },
    { 0x9C59, "valueiswithin" },
    { 0x9C5A, "values" },
    { 0x9C5B, "valve_stop_animating" },
    { 0x9C5C, "van_cuts_off_player" },
    { 0x9C5D, "van_knockback_blur" },
    { 0x9C5E, "van_open_bridge_collapse_dof" },
    { 0x9C5F, "van_scene_axis" },
    { 0x9C60, "var1" },
    { 0x9C61, "var2" },
    { 0x9C62, "variable_grenade" },
    { 0x9C63, "variable_grenade_type_switch" },
    { 0x9C64, "variable_grenade_ui_enabled" },
    { 0x9C65, "variable_grenade_ui_type" },
    { 0x9C66, "variable_scope_shadow_center" },
    { 0x9C67, "variable_scope_weapons" },
    { 0x9C68, "variance" },
    { 0x9C69, "variant_limit" },
    { 0x9C6A, "vb_anim_org" },
    { 0x9C6B, "vdir" },
    { 0x9C6C, "vec" },
    { 0x9C6D, "vec_acceleration" },
    { 0x9C6E, "vec_velocity" },
    { 0x9C6F, "vec2dot" },
    { 0x9C70, "vec3_mult_matrix33" },
    { 0x9C71, "vecscale" },
    { 0x9C72, "vector" },
    { 0x9C73, "vector_clamp" },
    { 0x9C74, "vector2d" },
    { 0x9C75, "vectors_are_equal_2d" },
    { 0x9C76, "vegnette" },
    { 0x9C77, "veh" },
    { 0x9C78, "veh_aliases" },
    { 0x9C79, "veh_debug_monitor_3d" },
    { 0x9C7A, "veh_debug_monitor_3d_callback" },
    { 0x9C7B, "veh_ent" },
    { 0x9C7C, "veh_mix_ents" },
    { 0x9C7D, "veh_moving_truck_chkpt" },
    { 0x9C7E, "veh_moving_truck_support_01_chkpt" },
    { 0x9C7F, "vehhelicoptercontrolsaltitude" },
    { 0x9C80, "vehhelicoptercontrolsystem" },
    { 0x9C81, "vehicle" },
    { 0x9C82, "vehicle_ai_event" },
    { 0x9C83, "vehicle_ai_settings" },
    { 0x9C84, "vehicle_aianimcheck" },
    { 0x9C85, "vehicle_aianims" },
    { 0x9C86, "vehicle_aianimthread" },
    { 0x9C87, "vehicle_aim_turret_at_angle" },
    { 0x9C88, "vehicle_allows_driver_death" },
    { 0x9C89, "vehicle_allows_rider_death" },
    { 0x9C8A, "vehicle_anim_array" },
    { 0x9C8B, "vehicle_animate" },
    { 0x9C8C, "vehicle_animpos_get_tag_angles" },
    { 0x9C8D, "vehicle_animpos_get_tag_origin" },
    { 0x9C8E, "vehicle_anims" },
    { 0x9C8F, "vehicle_anims_toload" },
    { 0x9C90, "vehicle_attachedmodels" },
    { 0x9C91, "vehicle_attacker" },
    { 0x9C92, "vehicle_badplace" },
    { 0x9C93, "vehicle_becomes_crashable" },
    { 0x9C94, "vehicle_blocked_check" },
    { 0x9C95, "vehicle_bulletshield" },
    { 0x9C96, "vehicle_chase_target" },
    { 0x9C97, "vehicle_collision_enabled" },
    { 0x9C98, "vehicle_controlling" },
    { 0x9C99, "vehicle_crash_detection" },
    { 0x9C9A, "vehicle_crash_now" },
    { 0x9C9B, "vehicle_crash_on_death" },
    { 0x9C9C, "vehicle_crash_when_blocked" },
    { 0x9C9D, "vehicle_crash_when_driver_dies" },
    { 0x9C9E, "vehicle_crashing_now" },
    { 0x9C9F, "vehicle_crashpaths" },
    { 0x9CA0, "vehicle_crazy_steering" },
    { 0x9CA1, "vehicle_crazy_steering_frogger" },
    { 0x9CA2, "vehicle_crazy_steering_frogger_fail_check" },
    { 0x9CA3, "vehicle_csv_export" },
    { 0x9CA4, "vehicle_death" },
    { 0x9CA5, "vehicle_death_add" },
    { 0x9CA6, "vehicle_death_add_remove_carcass" },
    { 0x9CA7, "vehicle_death_anim" },
    { 0x9CA8, "vehicle_death_badplace" },
    { 0x9CA9, "vehicle_death_earthquake" },
    { 0x9CAA, "vehicle_death_fx" },
    { 0x9CAB, "vehicle_death_fx_override" },
    { 0x9CAC, "vehicle_death_jolt" },
    { 0x9CAD, "vehicle_death_radiusdamage" },
    { 0x9CAE, "vehicle_death_thread" },
    { 0x9CAF, "vehicle_death_watcher" },
    { 0x9CB0, "vehicle_deathflag" },
    { 0x9CB1, "vehicle_deathmodel" },
    { 0x9CB2, "vehicle_deathmodel_delay" },
    { 0x9CB3, "vehicle_deathswitch" },
    { 0x9CB4, "vehicle_deckdust" },
    { 0x9CB5, "vehicle_deletegroup" },
    { 0x9CB6, "vehicle_detachfrompath" },
    { 0x9CB7, "vehicle_detect_crash" },
    { 0x9CB8, "vehicle_detourpaths" },
    { 0x9CB9, "vehicle_do_crash" },
    { 0x9CBA, "vehicle_draw_thermal" },
    { 0x9CBB, "vehicle_driveidle" },
    { 0x9CBC, "vehicle_driveidle_animrate" },
    { 0x9CBD, "vehicle_driveidle_normal_speed" },
    { 0x9CBE, "vehicle_driveidle_r" },
    { 0x9CBF, "vehicle_driver" },
    { 0x9CC0, "vehicle_drives_free_path" },
    { 0x9CC1, "vehicle_duck_once" },
    { 0x9CC2, "vehicle_dynamicpath" },
    { 0x9CC3, "vehicle_easy_crash_die" },
    { 0x9CC4, "vehicle_exhaust" },
    { 0x9CC5, "vehicle_explosions_for_drone_swarm" },
    { 0x9CC6, "vehicle_finish_death" },
    { 0x9CC7, "vehicle_fired_from" },
    { 0x9CC8, "vehicle_firing" },
    { 0x9CC9, "vehicle_free_path" },
    { 0x9CCA, "vehicle_frontarmor" },
    { 0x9CCB, "vehicle_gatetrigger" },
    { 0x9CCC, "vehicle_get_crash_struct" },
    { 0x9CCD, "vehicle_get_driver" },
    { 0x9CCE, "vehicle_get_path_array" },
    { 0x9CCF, "vehicle_get_riders" },
    { 0x9CD0, "vehicle_get_riders_by_group" },
    { 0x9CD1, "vehicle_getanimstart" },
    { 0x9CD2, "vehicle_getcurrentnode_a" },
    { 0x9CD3, "vehicle_getinanim" },
    { 0x9CD4, "vehicle_getinanim_clear" },
    { 0x9CD5, "vehicle_getinsound" },
    { 0x9CD6, "vehicle_getinsoundtag" },
    { 0x9CD7, "vehicle_getinstart" },
    { 0x9CD8, "vehicle_getoutanim" },
    { 0x9CD9, "vehicle_getoutanim_clear" },
    { 0x9CDA, "vehicle_getoutsound" },
    { 0x9CDB, "vehicle_getoutsoundtag" },
    { 0x9CDC, "vehicle_getspeed_a" },
    { 0x9CDD, "vehicle_go_to_end_and_delete" },
    { 0x9CDE, "vehicle_grenadeshield" },
    { 0x9CDF, "vehicle_handle_debugfly" },
    { 0x9CE0, "vehicle_handleunloadevent" },
    { 0x9CE1, "vehicle_has_rocket_death" },
    { 0x9CE2, "vehicle_hasavailablespots" },
    { 0x9CE3, "vehicle_hasmainturret" },
    { 0x9CE4, "vehicle_hasname" },
    { 0x9CE5, "vehicle_heli_default_path_speeds" },
    { 0x9CE6, "vehicle_hide_list" },
    { 0x9CE7, "vehicle_idle" },
    { 0x9CE8, "vehicle_idle_override" },
    { 0x9CE9, "vehicle_idleanim" },
    { 0x9CEA, "vehicle_idling" },
    { 0x9CEB, "vehicle_impact_rumble" },
    { 0x9CEC, "vehicle_in_front_of_node" },
    { 0x9CED, "vehicle_init" },
    { 0x9CEE, "vehicle_is_crashing" },
    { 0x9CEF, "vehicle_isstationary" },
    { 0x9CF0, "vehicle_keeps_going_after_driver_dies" },
    { 0x9CF1, "vehicle_kill" },
    { 0x9CF2, "vehicle_kill_badplace_forever" },
    { 0x9CF3, "vehicle_kill_common" },
    { 0x9CF4, "vehicle_kill_rumble_forever" },
    { 0x9CF5, "vehicle_kill_treads_forever" },
    { 0x9CF6, "vehicle_kill_triggers" },
    { 0x9CF7, "vehicle_killspawn_groups" },
    { 0x9CF8, "vehicle_land" },
    { 0x9CF9, "vehicle_land_beneath_node" },
    { 0x9CFA, "vehicle_landvehicle" },
    { 0x9CFB, "vehicle_levelstuff" },
    { 0x9CFC, "vehicle_life" },
    { 0x9CFD, "vehicle_life_range_high" },
    { 0x9CFE, "vehicle_life_range_low" },
    { 0x9CFF, "vehicle_liftoff" },
    { 0x9D00, "vehicle_liftoffvehicle" },
    { 0x9D01, "vehicle_lights" },
    { 0x9D02, "vehicle_lights_group" },
    { 0x9D03, "vehicle_lights_group_override" },
    { 0x9D04, "vehicle_lights_off" },
    { 0x9D05, "vehicle_lights_on" },
    { 0x9D06, "vehicle_link" },
    { 0x9D07, "vehicle_linked_entities_think" },
    { 0x9D08, "vehicle_load_ai" },
    { 0x9D09, "vehicle_load_ai_single" },
    { 0x9D0A, "vehicle_loaded_if_full" },
    { 0x9D0B, "vehicle_loaded_notify_size" },
    { 0x9D0C, "vehicle_luxurysedan" },
    { 0x9D0D, "vehicle_mainturrets" },
    { 0x9D0E, "vehicle_matchspeed" },
    { 0x9D0F, "vehicle_mgturret" },
    { 0x9D10, "vehicle_missile_launcher" },
    { 0x9D11, "vehicle_missile_launcher_count" },
    { 0x9D12, "vehicle_mute_charge_cleanup" },
    { 0x9D13, "vehicle_mute_charge_failed" },
    { 0x9D14, "vehicle_nodrivers" },
    { 0x9D15, "vehicle_notsolid" },
    { 0x9D16, "vehicle_oscillate_location" },
    { 0x9D17, "vehicle_passenger_2_turret" },
    { 0x9D18, "vehicle_path_name" },
    { 0x9D19, "vehicle_pathdetach" },
    { 0x9D1A, "vehicle_paths" },
    { 0x9D1B, "vehicle_paths_helicopter" },
    { 0x9D1C, "vehicle_paths_non_heli" },
    { 0x9D1D, "vehicle_pos" },
    { 0x9D1E, "vehicle_position" },
    { 0x9D1F, "vehicle_processtriggers" },
    { 0x9D20, "vehicle_reload" },
    { 0x9D21, "vehicle_resume_named" },
    { 0x9D22, "vehicle_resumepath" },
    { 0x9D23, "vehicle_resumepathvehicle" },
    { 0x9D24, "vehicle_ride" },
    { 0x9D25, "vehicle_rideai" },
    { 0x9D26, "vehicle_rider_death_detection" },
    { 0x9D27, "vehicle_rider_death_func" },
    { 0x9D28, "vehicle_ridespawners" },
    { 0x9D29, "vehicle_rubberband" },
    { 0x9D2A, "vehicle_rubberband_set_desired_range" },
    { 0x9D2B, "vehicle_rubberband_set_fail_range" },
    { 0x9D2C, "vehicle_rubberband_set_min_speed" },
    { 0x9D2D, "vehicle_rubberband_stop" },
    { 0x9D2E, "vehicle_rubberband_think" },
    { 0x9D2F, "vehicle_rumble" },
    { 0x9D30, "vehicle_rumble_override" },
    { 0x9D31, "vehicle_rumble_unique" },
    { 0x9D32, "vehicle_script_forcecolor_riders" },
    { 0x9D33, "vehicle_selfremove" },
    { 0x9D34, "vehicle_set_fake_speed" },
    { 0x9D35, "vehicle_set_firing_disabled" },
    { 0x9D36, "vehicle_set_forced_target" },
    { 0x9D37, "vehicle_set_health" },
    { 0x9D38, "vehicle_set_target_tracking_disabled" },
    { 0x9D39, "vehicle_set_threat_grenade_response" },
    { 0x9D3A, "vehicle_setteam" },
    { 0x9D3B, "vehicle_setup_levelvars" },
    { 0x9D3C, "vehicle_shoot_shock" },
    { 0x9D3D, "vehicle_should_do_rocket_death" },
    { 0x9D3E, "vehicle_should_regenerate" },
    { 0x9D3F, "vehicle_should_unload" },
    { 0x9D40, "vehicle_sights_radius" },
    { 0x9D41, "vehicle_single_light_off" },
    { 0x9D42, "vehicle_single_light_on" },
    { 0x9D43, "vehicle_single_tread_list" },
    { 0x9D44, "vehicle_spawn" },
    { 0x9D45, "vehicle_spawn_functions_enable" },
    { 0x9D46, "vehicle_spawn_think" },
    { 0x9D47, "vehicle_spawned_thisframe" },
    { 0x9D48, "vehicle_spawner" },
    { 0x9D49, "vehicle_spawner_deathflag" },
    { 0x9D4A, "vehicle_splash_water" },
    { 0x9D4B, "vehicle_standattack" },
    { 0x9D4C, "vehicle_startmovegroup" },
    { 0x9D4D, "vehicle_startnodes" },
    { 0x9D4E, "vehicle_stays_alive" },
    { 0x9D4F, "vehicle_stop_named" },
    { 0x9D50, "vehicle_switch_paths" },
    { 0x9D51, "vehicle_takedown_01_complete" },
    { 0x9D52, "vehicle_takedown_01_dialogue" },
    { 0x9D53, "vehicle_takedown_01_dof" },
    { 0x9D54, "vehicle_takedown_01_nag_dialogue" },
    { 0x9D55, "vehicle_takedown_rumbles" },
    { 0x9D56, "vehicle_targeting" },
    { 0x9D57, "vehicle_targets" },
    { 0x9D58, "vehicle_team" },
    { 0x9D59, "vehicle_to_crash_struct" },
    { 0x9D5A, "vehicle_to_crash_struct_dir" },
    { 0x9D5B, "vehicle_to_dummy" },
    { 0x9D5C, "vehicle_to_swap" },
    { 0x9D5D, "vehicle_treads" },
    { 0x9D5E, "vehicle_treads_script_model" },
    { 0x9D5F, "vehicle_turn_left" },
    { 0x9D60, "vehicle_turn_right" },
    { 0x9D61, "vehicle_turret_default_ai" },
    { 0x9D62, "vehicle_turret_fire" },
    { 0x9D63, "vehicle_turret_requiresrider" },
    { 0x9D64, "vehicle_turret_scan_off" },
    { 0x9D65, "vehicle_turret_scan_on" },
    { 0x9D66, "vehicle_turret_settings_shoot" },
    { 0x9D67, "vehicle_turret_settings_target" },
    { 0x9D68, "vehicle_types" },
    { 0x9D69, "vehicle_under_construction" },
    { 0x9D6A, "vehicle_unload" },
    { 0x9D6B, "vehicle_unload_how_at_end" },
    { 0x9D6C, "vehicle_unloadgroups" },
    { 0x9D6D, "vehicle_unloadwhenattacked" },
    { 0x9D6E, "vehicle_wait_for_crash" },
    { 0x9D6F, "vehicle_weave" },
    { 0x9D70, "vehicle_wheels_backward" },
    { 0x9D71, "vehicle_wheels_forward" },
    { 0x9D72, "vehicle_would_exceed_limit" },
    { 0x9D73, "vehicleendinganimations" },
    { 0x9D74, "vehicleexplodeondeath" },
    { 0x9D75, "vehiclefireanim" },
    { 0x9D76, "vehiclefireanim_settle" },
    { 0x9D77, "vehicleid" },
    { 0x9D78, "vehicleinfo" },
    { 0x9D79, "vehicleinitthread" },
    { 0x9D7A, "vehicleiscloaked" },
    { 0x9D7B, "vehiclekilled" },
    { 0x9D7C, "vehiclemodifyflarevector" },
    { 0x9D7D, "vehicles" },
    { 0x9D7E, "vehicles_anims" },
//  { 0x9D7F, "" },
    { 0x9D80, "vehiclespawncallbackthread" },
    { 0x9D81, "vehicletouchinganytrigger" },
    { 0x9D82, "vehname" },
    { 0x9D83, "vel" },
    { 0x9D84, "velocity_calc" },
    { 0x9D85, "velocity_scripted" },
    { 0x9D86, "velocity_smoothing" },
    { 0x9D87, "vending_machine" },
    { 0x9D88, "vending_machine_damage_monitor" },
    { 0x9D89, "venuscustomospfunc" },
    { 0x9D8A, "verify_effects_assignment" },
    { 0x9D8B, "verify_effects_assignment_print" },
    { 0x9D8C, "verify_jump_mount_points" },
    { 0x9D8D, "verify_mag_mount_points" },
    { 0x9D8E, "verifydedicatedconfiguration" },
    { 0x9D8F, "vert" },
    { 0x9D90, "vertexlit" },
    { 0x9D91, "vertical_cone_range" },
    { 0x9D92, "verticaloffsetlook" },
    { 0x9D93, "verticaloffsetstrafe" },
    { 0x9D94, "very_first_tank" },
    { 0x9D95, "very_first_tank_close" },
    { 0x9D96, "veteran_achievement" },
    { 0x9D97, "vfx_arm_piece_fall" },
    { 0x9D98, "vfx_balcony_break_through" },
    { 0x9D99, "vfx_bridge_chunk_f_piece5_fall" },
    { 0x9D9A, "vfx_bridge_crack_start" },
    { 0x9D9B, "vfx_bridge_fog_on" },
    { 0x9D9C, "vfx_bridge_seagulls_on" },
    { 0x9D9D, "vfx_bridge_shake_left" },
    { 0x9D9E, "vfx_bridge_shake_right" },
    { 0x9D9F, "vfx_bridge_snap" },
    { 0x9DA0, "vfx_bridge_traffic_intro" },
    { 0x9DA1, "vfx_burst_left_close" },
    { 0x9DA2, "vfx_burst_right_close" },
    { 0x9DA3, "vfx_bus_slide_spark" },
    { 0x9DA4, "vfx_cable_break" },
    { 0x9DA5, "vfx_cable_spark_hero" },
    { 0x9DA6, "vfx_car_radial_damage" },
    { 0x9DA7, "vfx_catwalk_lowering" },
    { 0x9DA8, "vfx_control_room_explo" },
    { 0x9DA9, "vfx_copcar_left_hitspark1" },
    { 0x9DAA, "vfx_copcar01_hitspark1" },
    { 0x9DAB, "vfx_copcar02_hitspark" },
    { 0x9DAC, "vfx_cutter_ignite" },
    { 0x9DAD, "vfx_cutter_spark" },
    { 0x9DAE, "vfx_dam_burst" },
    { 0x9DAF, "vfx_dam_setup" },
    { 0x9DB0, "vfx_dna_bomb_chain_explosion" },
    { 0x9DB1, "vfx_dna_bomb_drone_activate" },
    { 0x9DB2, "vfx_dna_bomb_drone_explode" },
    { 0x9DB3, "vfx_dna_bomb_drone_setup" },
    { 0x9DB4, "vfx_dna_bomb_drone_swarm_setup" },
    { 0x9DB5, "vfx_dna_bomb_flyby_papers" },
    { 0x9DB6, "vfx_dna_bomb_humvee_lights" },
    { 0x9DB7, "vfx_dna_bomb_mech_reveal" },
    { 0x9DB8, "vfx_drone_explo" },
    { 0x9DB9, "vfx_drone_explo_regularfx" },
    { 0x9DBA, "vfx_drone_fan_start" },
    { 0x9DBB, "vfx_drone_large_fan_start" },
    { 0x9DBC, "vfx_explosion_rumble_dust" },
    { 0x9DBD, "vfx_falling_debris_start" },
    { 0x9DBE, "vfx_foam_room" },
    { 0x9DBF, "vfx_gate_crash_open" },
    { 0x9DC0, "vfx_gideon_land_roof" },
    { 0x9DC1, "vfx_gideon_mech_rolls_over" },
    { 0x9DC2, "vfx_gideon_mech_sparks" },
    { 0x9DC3, "vfx_gushing_smk" },
    { 0x9DC4, "vfx_guy04_shot_blood" },
    { 0x9DC5, "vfx_handle_disintegrating_jet" },
    { 0x9DC6, "vfx_heli_drop_off_intro_on" },
    { 0x9DC7, "vfx_htank_disengage_grnd_smk" },
    { 0x9DC8, "vfx_htank_exhaust_electricity_powerup" },
    { 0x9DC9, "vfx_htank_exhaust_smk_burst" },
    { 0x9DCA, "vfx_htank_explosion" },
    { 0x9DCB, "vfx_htank_fake_treadfx_regular" },
    { 0x9DCC, "vfx_htank_fake_treadfx_strong" },
    { 0x9DCD, "vfx_htank_reveal" },
    { 0x9DCE, "vfx_htank_thruster_light_flicker" },
    { 0x9DCF, "vfx_htank_thruster_light_flicker_off" },
    { 0x9DD0, "vfx_htank_thruster_regular" },
    { 0x9DD1, "vfx_htank_thruster_start" },
    { 0x9DD2, "vfx_ilana_land_roof" },
    { 0x9DD3, "vfx_irons_fail_fall" },
    { 0x9DD4, "vfx_irons_fall_death" },
    { 0x9DD5, "vfx_irons_reveal_scene" },
    { 0x9DD6, "vfx_irons_tackle" },
    { 0x9DD7, "vfx_joker_land_roof" },
    { 0x9DD8, "vfx_landing_dust_npc" },
    { 0x9DD9, "vfx_mech_grapple_fx" },
    { 0x9DDA, "vfx_mech_grapple_strain_fx" },
    { 0x9DDB, "vfx_missile_docking_end" },
    { 0x9DDC, "vfx_missile_loading" },
    { 0x9DDD, "vfx_open_vent" },
    { 0x9DDE, "vfx_pitbull_atlas_impact" },
    { 0x9DDF, "vfx_pitbull_crash_jump_start" },
    { 0x9DE0, "vfx_pitbull_mud_spray" },
    { 0x9DE1, "vfx_pitbull_roof_impact" },
    { 0x9DE2, "vfx_pitbull_slide_sparks_start" },
    { 0x9DE3, "vfx_pitbull_slide_sparks_stop" },
    { 0x9DE4, "vfx_player_hit_windshield" },
    { 0x9DE5, "vfx_player_rolling_pebbles" },
    { 0x9DE6, "vfx_push_over_ledge" },
    { 0x9DE7, "vfx_raindrop" },
    { 0x9DE8, "vfx_razorback_jets_off" },
    { 0x9DE9, "vfx_razorback_jets_on" },
    { 0x9DEA, "vfx_rb_thruster_back_off" },
    { 0x9DEB, "vfx_rb_thruster_back_on" },
    { 0x9DEC, "vfx_rb_thruster_front_light_off" },
    { 0x9DED, "vfx_rb_thruster_front_light_on" },
    { 0x9DEE, "vfx_rb_thruster_front_off" },
    { 0x9DEF, "vfx_rb_thruster_front_on" },
    { 0x9DF0, "vfx_reactivate_radius_damage" },
    { 0x9DF1, "vfx_red_lights_on" },
    { 0x9DF2, "vfx_shore_outro_start" },
    { 0x9DF3, "vfx_silo_corridor_lowering" },
    { 0x9DF4, "vfx_start_boost_fx" },
    { 0x9DF5, "vfx_stop_boost_fx" },
    { 0x9DF6, "vfx_sunflare" },
    { 0x9DF7, "vfx_van_back_door_open" },
    { 0x9DF8, "vfx_van_explosion_start" },
    { 0x9DF9, "vfx_van_passenger_door_open" },
    { 0x9DFA, "vfx_vm_arm_sever" },
    { 0x9DFB, "vfx_vm_arm_stab" },
    { 0x9DFC, "vfx_vm_exit_pod_start" },
    { 0x9DFD, "vfx_vm_land_crane_edge" },
    { 0x9DFE, "vfx_vm_land_roof" },
    { 0x9DFF, "vfx_vm_land_roof_hands" },
    { 0x9E00, "vfx_vm_mech_dmg_sparks" },
    { 0x9E01, "vfx_vm_mech_dmg_stop" },
    { 0x9E02, "vfx_vm_mech_sparks" },
    { 0x9E03, "vfx_vm_mech_stop_effects" },
    { 0x9E04, "vfx_vtol_grapple" },
    { 0x9E05, "vfx_warbird_dust_roof" },
    { 0x9E06, "vfx_zipgun_fire" },
    { 0x9E07, "vfxholoedge" },
    { 0x9E08, "vfxtargetspawn" },
    { 0x9E09, "vfxtargetspawnout" },
    { 0x9E0A, "victim" },
    { 0x9E0B, "victimonground" },
    { 0x9E0C, "victimpoolkill" },
    { 0x9E0D, "victimteam" },
    { 0x9E0E, "video_cab_count" },
    { 0x9E0F, "video_chrome_ab" },
    { 0x9E10, "video_idle" },
    { 0x9E11, "video_warn_count" },
    { 0x9E12, "videochatpostscreenhide" },
    { 0x9E13, "view_clamping_unlock" },
    { 0x9E14, "view_goal_pos" },
    { 0x9E15, "view_org" },
    { 0x9E16, "view_path_setup" },
    { 0x9E17, "view_paths" },
    { 0x9E18, "view_tag" },
    { 0x9E19, "viewfx" },
    { 0x9E1A, "viewhands" },
    { 0x9E1B, "viewmodel_blend" },
    { 0x9E1C, "viewmodel_dof_end" },
    { 0x9E1D, "viewmodel_dof_start" },
    { 0x9E1E, "viewmodel_hidden" },
    { 0x9E1F, "viewmodel_swim_animations" },
    { 0x9E20, "viewmodel_swim_animations_loop" },
    { 0x9E21, "viewmodel_swim_handle_notetracks" },
    { 0x9E22, "viewmodelanimupdate" },
    { 0x9E23, "viewtag" },
    { 0x9E24, "vig_ally_injured_cpr" },
    { 0x9E25, "vig_ally_injured_drag" },
    { 0x9E26, "vig_bike_rider_cyclist" },
    { 0x9E27, "vig_bike_rider_init" },
    { 0x9E28, "vig_bike_rider_maintainer" },
    { 0x9E29, "vig_bike_rider_nav" },
    { 0x9E2A, "vig_bike_rider_removal" },
    { 0x9E2B, "vig_bike_rider_scooter" },
    { 0x9E2C, "vig_bike_rider_set_speed" },
    { 0x9E2D, "vig_civ_fail_on_damage" },
    { 0x9E2E, "vig_civ_model_randomizer" },
    { 0x9E2F, "vig_civ_removal" },
    { 0x9E30, "vig_civ_streetarray" },
    { 0x9E31, "vig_civ_traffic_balcony_setup" },
    { 0x9E32, "vig_civ_traffic_init" },
    { 0x9E33, "vig_civ_traffic_spawn_idle_drones" },
    { 0x9E34, "vig_civ_traffic_spawn_walker_drones" },
    { 0x9E35, "vig_civ_traffic_street_setup" },
    { 0x9E36, "vig_civ_traffic_walker_setup" },
    { 0x9E37, "vig_civ_walker_maintainer" },
    { 0x9E38, "vig_civ_walker_removal" },
    { 0x9E39, "vig_intro_civ_populate" },
    { 0x9E3A, "vig_mil_balc_setup" },
    { 0x9E3B, "vig_tram_setup" },
    { 0x9E3C, "vig_tram_setup_car" },
    { 0x9E3D, "vig_tram_setup_car_fx" },
    { 0x9E3E, "vig_tram_setup_car_shaker" },
    { 0x9E3F, "vig_tram_setup_intro" },
    { 0x9E40, "vig_tram_setup_movement" },
    { 0x9E41, "vig_vehicle_fail_on_death" },
    { 0x9E42, "vig_vehicle_removal" },
    { 0x9E43, "vig_vehicle_traffic_init" },
    { 0x9E44, "vig_vehicle_traffic_jammer" },
    { 0x9E45, "vig_vehicle_traffic_removal" },
    { 0x9E46, "vig_vehicle_traffic_scripted_left" },
    { 0x9E47, "vig_vehicle_traffic_scripted_right" },
    { 0x9E48, "vig_vehicle_traffic_straight_mover_movement" },
    { 0x9E49, "vig_vehicle_traffic_turn_mover_movement" },
    { 0x9E4A, "vig_walker_streetarray" },
    { 0x9E4B, "vign_ai_check_for_death" },
    { 0x9E4C, "vignette_actor_delete" },
    { 0x9E4D, "vignette_actor_ignore_everything" },
    { 0x9E4E, "vignette_actor_kill" },
    { 0x9E4F, "vignette_actor_spawn" },
    { 0x9E50, "vignette_actor_spawn_func" },
    { 0x9E51, "vignette_drone_spawn" },
    { 0x9E52, "vignette_register" },
    { 0x9E53, "vignette_register_wait" },
    { 0x9E54, "vignette_vehicle_delete" },
    { 0x9E55, "vignette_vehicle_spawn" },
    { 0x9E56, "vinette_overlay" },
    { 0x9E57, "vip1" },
    { 0x9E58, "virtual_lobby_set_class" },
    { 0x9E59, "virtuallobbyactive" },
    { 0x9E5A, "virus1_preset_constructor" },
    { 0x9E5B, "visibility_distance" },
    { 0x9E5C, "visibility_range_version" },
    { 0x9E5D, "visible" },
    { 0x9E5E, "visibleteam" },
    { 0x9E5F, "vision_cheat_enabled" },
    { 0x9E60, "vision_default" },
    { 0x9E61, "vision_enter_canal" },
    { 0x9E62, "vision_seoul_art_center_atrium" },
    { 0x9E63, "vision_seoul_building_jump" },
    { 0x9E64, "vision_seoul_exterior" },
    { 0x9E65, "vision_seoul_hotel_hallway_cg" },
    { 0x9E66, "vision_seoul_hotel_interior" },
    { 0x9E67, "vision_seoul_hotel_interior_lrg" },
    { 0x9E68, "vision_seoul_shopping" },
    { 0x9E69, "vision_seoul_sinkhole" },
    { 0x9E6A, "vision_seoul_streets_02" },
    { 0x9E6B, "vision_seoul_streets_02_xx" },
    { 0x9E6C, "vision_seoul_subway_interior" },
    { 0x9E6D, "vision_seoul_vista" },
    { 0x9E6E, "vision_set" },
    { 0x9E6F, "vision_set_changes" },
    { 0x9E70, "vision_set_fog" },
    { 0x9E71, "vision_set_fog_changes" },
    { 0x9E72, "vision_set_fog_progress" },
    { 0x9E73, "vision_set_override" },
    { 0x9E74, "vision_set_sanfran" },
    { 0x9E75, "vision_set_transition_ent" },
    { 0x9E76, "vision_set_vision" },
    { 0x9E77, "vision_spidertank_moment_off" },
    { 0x9E78, "vision_spidertank_moment_on" },
    { 0x9E79, "vision_zone_manager" },
    { 0x9E7A, "vision_zone_watcher" },
    { 0x9E7B, "vision_zone_watcherb" },
    { 0x9E7C, "visionset_betrayal_swim_tube" },
    { 0x9E7D, "visionset_default" },
    { 0x9E7E, "visionset_diff" },
    { 0x9E7F, "visionset_underwater" },
    { 0x9E80, "visionthermaldefault" },
    { 0x9E81, "visited" },
    { 0x9E82, "visitfxent" },
    { 0x9E83, "visithideallmarkers" },
    { 0x9E84, "visiting_player_from_node" },
    { 0x9E85, "visitorcentergatebashfx" },
    { 0x9E86, "visitorhideall" },
    { 0x9E87, "visitorrelink" },
    { 0x9E88, "visitorretriggerfx" },
    { 0x9E89, "visitorshowtoplayer" },
    { 0x9E8A, "visitorupdatelosmarker" },
    { 0x9E8B, "visitorupdatemarkerpos" },
    { 0x9E8C, "vista_ambientfx_aa_explosion" },
    { 0x9E8D, "vista_ambientfx_double_layer_missile_hit" },
    { 0x9E8E, "vista_ambientfx_double_layer_missile_hit_loop" },
    { 0x9E8F, "vista_ambientfx_midair_explosion" },
    { 0x9E90, "vista_ent" },
    { 0x9E91, "vista_ents" },
    { 0x9E92, "vista_jet_array" },
    { 0x9E93, "vista_jets_reflection_override" },
    { 0x9E94, "vista_pigeons_alley1_market" },
    { 0x9E95, "vista_police_drones" },
    { 0x9E96, "vista_police_group_drones" },
    { 0x9E97, "vista_rockets" },
    { 0x9E98, "vista_rockets_first_impact" },
    { 0x9E99, "vista_rockets_pod_door_view_01" },
    { 0x9E9A, "vista_rockets_pod_door_view_02" },
    { 0x9E9B, "vista_warbird_fx" },
    { 0x9E9C, "vistime" },
    { 0x9E9D, "visual_origin" },
    { 0x9E9E, "visualgroundoffset" },
    { 0x9E9F, "visuals" },
    { 0x9EA0, "vl_avatar_costume" },
    { 0x9EA1, "vl_avatar_loadout" },
    { 0x9EA2, "vl_cao_focus" },
    { 0x9EA3, "vl_clanprofile_focus" },
    { 0x9EA4, "vl_dof_based_on_focus" },
    { 0x9EA5, "vl_focus" },
    { 0x9EA6, "vl_give_weapons" },
    { 0x9EA7, "vl_ground_setup" },
    { 0x9EA8, "vl_handle_mode_change" },
    { 0x9EA9, "vl_init" },
    { 0x9EAA, "vl_lighting_setup" },
    { 0x9EAB, "vl_local_focus" },
    { 0x9EAC, "vl_main" },
    { 0x9EAD, "vl_onspawnplayer" },
    { 0x9EAE, "vlavatars" },
    { 0x9EAF, "vlcamera" },
    { 0x9EB0, "vlength" },
    { 0x9EB1, "vlobby_dof_based_on_focus" },
    { 0x9EB2, "vlobby_handle_mode_change" },
    { 0x9EB3, "vlobby_lighting_setup" },
    { 0x9EB4, "vlobby_player" },
    { 0x9EB5, "vlobby_vegnette" },
    { 0x9EB6, "vm" },
    { 0x9EB7, "vm_aud_air_vehicle_flyby" },
    { 0x9EB8, "vm_boat_crash_se_fx_start" },
    { 0x9EB9, "vm_boat_crash_se_whiteout" },
    { 0x9EBA, "vm_boat_emerge_fx" },
    { 0x9EBB, "vm_boat_submerge_fx" },
    { 0x9EBC, "vm_boat_wake" },
    { 0x9EBD, "vm_crash_transition" },
    { 0x9EBE, "vm_damaged_model" },
    { 0x9EBF, "vm_disablethrottleupdate" },
    { 0x9EC0, "vm_enablethrottleupdate" },
    { 0x9EC1, "vm_fx_loc" },
    { 0x9EC2, "vm_glass_impact" },
    { 0x9EC3, "vm_ground_vehicle_start" },
    { 0x9EC4, "vm_hand_sparks" },
    { 0x9EC5, "vm_init" },
    { 0x9EC6, "vm_is_proxy" },
    { 0x9EC7, "vm_launch_from" },
    { 0x9EC8, "vm_launch_to" },
    { 0x9EC9, "vm_linkto_new_entity" },
    { 0x9ECA, "vm_normal" },
    { 0x9ECB, "vm_normal_model" },
    { 0x9ECC, "vm_register_custom_callback" },
    { 0x9ECD, "vm_set_range" },
    { 0x9ECE, "vm_set_speed_callback" },
    { 0x9ECF, "vm_set_start_stop_callback" },
    { 0x9ED0, "vm_set_throttle_callback" },
    { 0x9ED1, "vm_soda_model" },
    { 0x9ED2, "vm_soda_start_angle" },
    { 0x9ED3, "vm_soda_start_pos" },
    { 0x9ED4, "vm_soda_stop_angle" },
    { 0x9ED5, "vm_soda_stop_pos" },
    { 0x9ED6, "vm_start_preset" },
    { 0x9ED7, "vm_stop" },
    { 0x9ED8, "vm_stop_preset_instance" },
    { 0x9ED9, "vm_water_impact" },
    { 0x9EDA, "vm2_get_instance_name" },
    { 0x9EDB, "vm2_get_vehicle_instance_count" },
    { 0x9EDC, "vm2_get_vehicle_snd_instance" },
    { 0x9EDD, "vm2x_delete_vehicle_sound_ents" },
    { 0x9EDE, "vm2x_fade_sound_obj" },
    { 0x9EDF, "vm2x_fadeout_vehicle" },
    { 0x9EE0, "vm2x_init_param_io_struct" },
    { 0x9EE1, "vm2x_remove_preset" },
    { 0x9EE2, "vmknifeblockfx" },
    { 0x9EE3, "vmlandingimpact" },
    { 0x9EE4, "vmodelbarrel" },
    { 0x9EE5, "vmodelouter" },
    { 0x9EE6, "vmstabbedfacefx" },
    { 0x9EE7, "vmx_aud_ent_fade_in" },
    { 0x9EE8, "vmx_aud_ent_fade_out" },
    { 0x9EE9, "vmx_callback" },
    { 0x9EEA, "vmx_cleanup_ents" },
    { 0x9EEB, "vmx_do_start_stop_callback" },
    { 0x9EEC, "vmx_get_altitude" },
    { 0x9EED, "vmx_get_need_to_duck" },
    { 0x9EEE, "vmx_get_roll" },
    { 0x9EEF, "vmx_get_speed" },
    { 0x9EF0, "vmx_get_start_sound_playing" },
    { 0x9EF1, "vmx_get_stop_sound_playing" },
    { 0x9EF2, "vmx_get_throttle" },
    { 0x9EF3, "vmx_get_tilt" },
    { 0x9EF4, "vmx_get_yaw" },
    { 0x9EF5, "vmx_ground_speed_watch" },
    { 0x9EF6, "vmx_ground_vehicle_monitor_death" },
    { 0x9EF7, "vmx_init_oneshot_ents" },
    { 0x9EF8, "vmx_monitor_explosion" },
    { 0x9EF9, "vmx_monitor_start_ent" },
    { 0x9EFA, "vmx_monitor_stop_ent" },
    { 0x9EFB, "vmx_play_start_sound" },
    { 0x9EFC, "vmx_play_stop_sound" },
    { 0x9EFD, "vmx_scale_start_sound_pitch" },
    { 0x9EFE, "vmx_scale_start_sound_volume" },
    { 0x9EFF, "vmx_scale_stop_sound_pitch" },
    { 0x9F00, "vmx_scale_stop_sound_volume" },
    { 0x9F01, "vmx_stop_start_ent" },
    { 0x9F02, "vmx_stop_stop_ent" },
    { 0x9F03, "vmx_update_sound" },
    { 0x9F04, "vmx_vehicle_engine" },
    { 0x9F05, "vmx_waittill_deathspin" },
    { 0x9F06, "vmx_waittill_sounddone" },
    { 0x9F07, "vnum" },
    { 0x9F08, "vo" },
    { 0x9F09, "vo_canal" },
    { 0x9F0A, "vo_canal_e3" },
    { 0x9F0B, "vo_canal_finale" },
    { 0x9F0C, "vo_canal_plant_explosives" },
    { 0x9F0D, "vo_canal_razorback" },
    { 0x9F0E, "vo_chatter_death" },
    { 0x9F0F, "vo_cutoff_subway_vo_early_check" },
    { 0x9F10, "vo_duck_active" },
    { 0x9F11, "vo_elevator_descent_nag" },
    { 0x9F12, "vo_fob_meetup" },
    { 0x9F13, "vo_fus_silo_collapse_burke" },
    { 0x9F14, "vo_interior_control_room" },
    { 0x9F15, "vo_interior_control_room_explosion" },
    { 0x9F16, "vo_interior_control_room_nag" },
    { 0x9F17, "vo_interior_lab" },
    { 0x9F18, "vo_interior_reactor" },
    { 0x9F19, "vo_interior_security_room" },
    { 0x9F1A, "vo_interior_turbine_elevator" },
    { 0x9F1B, "vo_interior_turbine_elevator_nag" },
    { 0x9F1C, "vo_interior_turbine_room" },
    { 0x9F1D, "vo_jump_training" },
    { 0x9F1E, "vo_meet_atlas_dialogue" },
    { 0x9F1F, "vo_nag_get_warbirds" },
    { 0x9F20, "vo_nk_first_contact" },
    { 0x9F21, "vo_post_building_jump" },
    { 0x9F22, "vo_priority" },
    { 0x9F23, "vo_push_through_hotel" },
    { 0x9F24, "vo_sd_demo_team_call" },
    { 0x9F25, "vo_sd_drone_swarm_dialogue" },
    { 0x9F26, "vo_shopping_district" },
    { 0x9F27, "vo_sinkhole" },
    { 0x9F28, "vo_subway" },
    { 0x9F29, "vo_subway_car" },
    { 0x9F2A, "vo_subway_civ_convo1" },
    { 0x9F2B, "vo_subway_civ_convo2" },
    { 0x9F2C, "vo_subway_civ_convo3" },
    { 0x9F2D, "vo_subway_civ_convo4" },
    { 0x9F2E, "vo_subway_pa_announcements" },
    { 0x9F2F, "vo_subway_threat_grenade_moment" },
    { 0x9F30, "vo_test" },
    { 0x9F31, "vo_tower_debris_radio_chatter" },
    { 0x9F32, "vo_turbine_room_clear" },
    { 0x9F33, "vo_zipliners_hotel" },
    { 0x9F34, "vodestroyed" },
    { 0x9F35, "voice" },
    { 0x9F36, "voice_count" },
    { 0x9F37, "voice_is_british_based" },
    { 0x9F38, "voicecanburst" },
    { 0x9F39, "void" },
    { 0x9F3A, "vol" },
    { 0x9F3B, "vol_auto_disable" },
    { 0x9F3C, "vol_map_name" },
    { 0x9F3D, "volcanostarteruption" },
    { 0x9F3E, "vols" },
    { 0x9F3F, "volume" },
    { 0x9F40, "volume_array" },
    { 0x9F41, "volume_fallingwaterfx" },
    { 0x9F42, "volume_map_name" },
    { 0x9F43, "volume_wakefx" },
    { 0x9F44, "volumes_targetname" },
    { 0x9F45, "vooffline" },
    { 0x9F46, "vopower" },
    { 0x9F47, "vpoint" },
    { 0x9F48, "vrap_explode" },
    { 0x9F49, "vrap_mute_obj" },
    { 0x9F4A, "vrap_mute_trig" },
    { 0x9F4B, "vrap_sonic_blast_immunity_toggle" },
    { 0x9F4C, "vrap_spawn" },
    { 0x9F4D, "vrap_takedown_lights_off" },
    { 0x9F4E, "vrap_takedown_lights_on" },
    { 0x9F4F, "vrapcount" },
    { 0x9F50, "vrs1_condition_to_adaptive" },
    { 0x9F51, "vrs1_condition_to_mix1" },
    { 0x9F52, "vrs1_condition_to_mix2" },
    { 0x9F53, "vrs1_enter_adaptive" },
    { 0x9F54, "vrs1_enter_mix1" },
    { 0x9F55, "vrs1_enter_mix2" },
    { 0x9F56, "vrs1_instance_init" },
    { 0x9F57, "vtclassname" },
    { 0x9F58, "vteam" },
    { 0x9F59, "vtmodel" },
    { 0x9F5A, "vtol" },
    { 0x9F5B, "vtol_animnode" },
    { 0x9F5C, "vtol_battle_redux" },
    { 0x9F5D, "vtol_damage_monitor" },
    { 0x9F5E, "vtol_death_if_pilot_shot" },
    { 0x9F5F, "vtol_delayed_stinger_ignore" },
    { 0x9F60, "vtol_exhaust" },
    { 0x9F61, "vtol_fight" },
    { 0x9F62, "vtol_fire_late_rpgs" },
    { 0x9F63, "vtol_flyin" },
    { 0x9F64, "vtol_flyover" },
    { 0x9F65, "vtol_fx_land" },
    { 0x9F66, "vtol_lights" },
    { 0x9F67, "vtol_obj_marker_monitor" },
    { 0x9F68, "vtol_player_fired" },
    { 0x9F69, "vtol_reset_player_orientations" },
    { 0x9F6A, "vtol_rocket_death" },
    { 0x9F6B, "vtol_sequence" },
    { 0x9F6C, "vtol_takedown_cargo_and_cables" },
    { 0x9F6D, "vtol_takedown_chopper" },
    { 0x9F6E, "vtol_takedown_cormack" },
    { 0x9F6F, "vtol_takedown_cormack_stinger" },
    { 0x9F70, "vtol_takedown_dialogue" },
    { 0x9F71, "vtol_takedown_failure" },
    { 0x9F72, "vtol_takedown_gideon" },
    { 0x9F73, "vtol_takedown_gideon_slide_fx" },
    { 0x9F74, "vtol_takedown_gun_pickup" },
    { 0x9F75, "vtol_takedown_hide_check" },
    { 0x9F76, "vtol_takedown_ilona" },
    { 0x9F77, "vtol_takedown_player_grabs_cargo" },
    { 0x9F78, "vtol_takedown_shoot_monitor" },
    { 0x9F79, "vtol_takedown_terrain" },
    { 0x9F7A, "vtol_takedown_vtol" },
    { 0x9F7B, "vtol_takedown_vtol_slide_fx" },
    { 0x9F7C, "vtolfx" },
    { 0x9F7D, "vtoverride" },
    { 0x9F7E, "vttype" },
    { 0x9F7F, "vulcanlightset" },
    { 0x9F80, "vulcanvisionset" },
    { 0x9F81, "wading_adjust_angles" },
    { 0x9F82, "wading_footsteps" },
    { 0x9F83, "wading_footsteps_ends" },
    { 0x9F84, "wait_and_delete" },
    { 0x9F85, "wait_and_fire" },
    { 0x9F86, "wait_any_func_array" },
    { 0x9F87, "wait_current_zone_finish" },
    { 0x9F88, "wait_endon" },
    { 0x9F89, "wait_for_all_deck_warbirds_to_unload" },
    { 0x9F8A, "wait_for_an_unlocked_trigger" },
    { 0x9F8B, "wait_for_anim" },
    { 0x9F8C, "wait_for_anim_start" },
    { 0x9F8D, "wait_for_any_trigger_hit" },
    { 0x9F8E, "wait_for_breach_or_deletion" },
    { 0x9F8F, "wait_for_buffer_time_to_pass" },
    { 0x9F90, "wait_for_cleanup" },
    { 0x9F91, "wait_for_considerable_left_stick_interact" },
    { 0x9F92, "wait_for_crash_at_end" },
    { 0x9F93, "wait_for_damage" },
    { 0x9F94, "wait_for_death" },
    { 0x9F95, "wait_for_drone_finished" },
    { 0x9F96, "wait_for_drone_message_or_death" },
    { 0x9F97, "wait_for_either_trigger" },
    { 0x9F98, "wait_for_exit_message" },
    { 0x9F99, "wait_for_exocloak_cancel" },
    { 0x9F9A, "wait_for_exocloak_pressed" },
    { 0x9F9B, "wait_for_false" },
    { 0x9F9C, "wait_for_false2" },
    { 0x9F9D, "wait_for_false3" },
    { 0x9F9E, "wait_for_false4" },
    { 0x9F9F, "wait_for_false5" },
    { 0x9FA0, "wait_for_false6" },
    { 0x9FA1, "wait_for_flag_or_player_command" },
    { 0x9FA2, "wait_for_flag_or_player_command_aux" },
    { 0x9FA3, "wait_for_flag_or_time_elapses" },
    { 0x9FA4, "wait_for_flag_or_timeout" },
    { 0x9FA5, "wait_for_formation" },
    { 0x9FA6, "wait_for_formation_break" },
    { 0x9FA7, "wait_for_game_end" },
    { 0x9FA8, "wait_for_guy_to_die_or_get_in_position" },
    { 0x9FA9, "wait_for_hit_reaction" },
    { 0x9FAA, "wait_for_interrupted" },
    { 0x9FAB, "wait_for_laser_end" },
    { 0x9FAC, "wait_for_level_notify_or_timeout" },
    { 0x9FAD, "wait_for_mech_distance" },
    { 0x9FAE, "wait_for_missile" },
    { 0x9FAF, "wait_for_mission_fail" },
    { 0x9FB0, "wait_for_mob_turret_targets_to_be_destroyed" },
    { 0x9FB1, "wait_for_no_trigger_and_ai_group" },
    { 0x9FB2, "wait_for_no_trigger_and_ai_single" },
    { 0x9FB3, "wait_for_no_trigger_just_ai_group" },
    { 0x9FB4, "wait_for_no_trigger_just_ai_single" },
    { 0x9FB5, "wait_for_not_using_remote" },
    { 0x9FB6, "wait_for_notify_or_timeout" },
    { 0x9FB7, "wait_for_number_enemies_alive" },
    { 0x9FB8, "wait_for_pickup" },
    { 0x9FB9, "wait_for_player_death" },
    { 0x9FBA, "wait_for_player_release" },
    { 0x9FBB, "wait_for_player_switch_to_turret" },
    { 0x9FBC, "wait_for_player_to_complete_reloading" },
    { 0x9FBD, "wait_for_primary_weapon_pickup" },
    { 0x9FBE, "wait_for_script_noteworthy_trigger" },
    { 0x9FBF, "wait_for_sounddone_det_gdn_mitchellonme" },
    { 0x9FC0, "wait_for_sounddone_or_death" },
    { 0x9FC1, "wait_for_stick_press" },
    { 0x9FC2, "wait_for_success_press" },
    { 0x9FC3, "wait_for_targetname_trigger" },
    { 0x9FC4, "wait_for_threat_grenade" },
    { 0x9FC5, "wait_for_thrown_grenade" },
    { 0x9FC6, "wait_for_trigger" },
    { 0x9FC7, "wait_for_trigger_and_ai_group" },
    { 0x9FC8, "wait_for_trigger_and_ai_single" },
    { 0x9FC9, "wait_for_trigger_just_ai_group" },
    { 0x9FCA, "wait_for_trigger_just_ai_single" },
    { 0x9FCB, "wait_for_trigger_or_timeout" },
    { 0x9FCC, "wait_for_trigger_set_flag" },
    { 0x9FCD, "wait_for_trigger_think" },
    { 0x9FCE, "wait_for_trigger_with_group_not_touching" },
    { 0x9FCF, "wait_for_trigger_with_group_touching" },
    { 0x9FD0, "wait_for_true" },
    { 0x9FD1, "wait_for_true2" },
    { 0x9FD2, "wait_for_true3" },
    { 0x9FD3, "wait_for_true4" },
    { 0x9FD4, "wait_for_true5" },
    { 0x9FD5, "wait_for_turn_signal_off" },
    { 0x9FD6, "wait_for_turret_reset" },
    { 0x9FD7, "wait_for_vehicle_dismount" },
    { 0x9FD8, "wait_for_vehicle_mount" },
    { 0x9FD9, "wait_for_walker_to_be_hit_by_smaw" },
    { 0x9FDA, "wait_for_warbird_fire_target_done" },
    { 0x9FDB, "wait_heli_uncloak" },
    { 0x9FDC, "wait_in_current_air_space" },
    { 0x9FDD, "wait_kill_me" },
    { 0x9FDE, "wait_load_costume" },
    { 0x9FDF, "wait_load_costume_show" },
    { 0x9FE0, "wait_load_costume_timeout" },
    { 0x9FE1, "wait_ref_count" },
    { 0x9FE2, "wait_resume_path" },
    { 0x9FE3, "wait_spreader_allotment" },
    { 0x9FE4, "wait_spreaders" },
    { 0x9FE5, "wait_start_firingrange" },
    { 0x9FE6, "wait_then_movetogoalvol" },
    { 0x9FE7, "wait_til_node_wait_triggered" },
    { 0x9FE8, "wait_til_pdrone_launched" },
    { 0x9FE9, "wait_till_agent_funcs_defined" },
    { 0x9FEA, "wait_till_death_try_respawn_death" },
    { 0x9FEB, "wait_till_every_thing_stealth_normal_for" },
    { 0x9FEC, "wait_till_on_ship" },
    { 0x9FED, "wait_till_should_stop_drawing" },
    { 0x9FEE, "wait_till_snakes_nearby" },
    { 0x9FEF, "wait_time" },
    { 0x9FF0, "wait_to_clean_car" },
    { 0x9FF1, "wait_to_decloak_helicopter" },
    { 0x9FF2, "wait_to_destroy_nvg_overlay" },
    { 0x9FF3, "wait_to_fire_rope" },
    { 0x9FF4, "wait_to_give_boost_to_player" },
    { 0x9FF5, "wait_to_go" },
    { 0x9FF6, "wait_to_kill_aim_cursor" },
    { 0x9FF7, "wait_to_kill_path" },
    { 0x9FF8, "wait_to_remove_target" },
    { 0x9FF9, "wait_to_stop_firing" },
    { 0x9FFA, "wait_until_an_enemy_is_in_safe_area" },
    { 0x9FFB, "wait_until_anim_finishes" },
    { 0x9FFC, "wait_until_both_swings_pressed" },
    { 0x9FFD, "wait_until_done_speaking" },
    { 0x9FFE, "wait_until_left_swing_pressed" },
    { 0x9FFF, "wait_until_new_target" },
    { 0xA000, "wait_until_next_left_swing" },
    { 0xA001, "wait_until_next_right_swing" },
    { 0xA002, "wait_until_path_safe" },
    { 0xA003, "wait_until_right_swing_pressed" },
    { 0xA004, "wait_until_unloaded" },
    { 0xA005, "wait_until_vision_check_satisfied_or_disabled" },
    { 0xA006, "waitabit" },
    { 0xA007, "waitaftershot" },
    { 0xA008, "waitanddelete" },
    { 0xA009, "waitanddetonate" },
    { 0xA00A, "waitandprocessplayerkilledcallback" },
    { 0xA00B, "waitandspawnclient" },
    { 0xA00C, "waitattachflag" },
    { 0xA00D, "waitattachmentcooldown" },
    { 0xA00E, "waitcarryobjects" },
    { 0xA00F, "waitcopycatkillcambutton" },
    { 0xA010, "waitdelay" },
    { 0xA011, "waitdelayminetime" },
    { 0xA012, "waitdisableshadows" },
    { 0xA013, "waitforairstrikecancel" },
    { 0xA014, "waitforbadpath" },
    { 0xA015, "waitforbadpathhorde" },
    { 0xA016, "waitforbark" },
    { 0xA017, "waitforblockedwhilestopping" },
    { 0xA018, "waitforbuddyspawntimer" },
    { 0xA019, "waitforc4detonation" },
    { 0xA01A, "waitforchangeteam" },
    { 0xA01B, "waitforclassselect" },
    { 0xA01C, "waitforcleanup" },
    { 0xA01D, "waitfordeath" },
    { 0xA01E, "waitfordrivenchange" },
    { 0xA01F, "waitforfacesound" },
    { 0xA020, "waitforfacialanim" },
    { 0xA021, "waitforfollowspeed" },
    { 0xA022, "waitforgasdamage" },
    { 0xA023, "waitforhoodoodamage" },
    { 0xA024, "waitforhoodooflag" },
    { 0xA025, "waitforkillstreakweaponchange" },
    { 0xA026, "waitforkillstreakweaponswitchinvalid" },
    { 0xA027, "waitforkillstreakweaponswitchstarted" },
    { 0xA028, "waitforlaserdeath" },
    { 0xA029, "waitforpathgoalpos" },
    { 0xA02A, "waitforpathset" },
    { 0xA02B, "waitforpathsetwhilestopping" },
    { 0xA02C, "waitforplayerbulletwhizby" },
    { 0xA02D, "waitforplayerrespawnchoice" },
    { 0xA02E, "waitforplayers" },
    { 0xA02F, "waitforragdoll" },
    { 0xA030, "waitforratechange" },
    { 0xA031, "waitforreaderdelete" },
    { 0xA032, "waitforreinforcementoftype" },
    { 0xA033, "waitforrocketdeath" },
    { 0xA034, "waitforrocketimpact" },
    { 0xA035, "waitforrunwalkchange" },
    { 0xA036, "waitforrunwalkslopechange" },
    { 0xA037, "waitforscramblejump" },
    { 0xA038, "waitforsharpturn" },
    { 0xA039, "waitforsharpturnduringsharpturn" },
    { 0xA03A, "waitforsharpturnwhilestopping" },
    { 0xA03B, "waitforspawnfinished" },
    { 0xA03C, "waitforstancechange" },
    { 0xA03D, "waitforstatechange" },
    { 0xA03E, "waitforstop" },
    { 0xA03F, "waitforstopearly" },
    { 0xA040, "waitfortimeornotifies" },
    { 0xA041, "waitfortimeornotify" },
    { 0xA042, "waitfortimeout" },
    { 0xA043, "waitforwalkerdelete" },
    { 0xA044, "waitillairstrikeoverbombingarea" },
    { 0xA045, "waitillcanspawnclient" },
    { 0xA046, "waiting_for_queue" },
    { 0xA047, "waiting_mechs" },
    { 0xA048, "waiting_on_left_swing" },
    { 0xA049, "waiting_on_right_swing" },
    { 0xA04A, "waitingforgate" },
    { 0xA04B, "waitingforplayers" },
    { 0xA04C, "waitingforspawnduringstreak" },
    { 0xA04D, "waitingtodeactivate" },
    { 0xA04E, "waitingtodie" },
    { 0xA04F, "waitingtoselectclass" },
    { 0xA050, "waitingtospawn" },
    { 0xA051, "waitingtospawnamortize" },
    { 0xA052, "waitingtospawndrone" },
    { 0xA053, "waitloadoutdone" },
    { 0xA054, "waitlongdurationwithgameendtimeupdate" },
    { 0xA055, "waitlongdurationwithhostmigrationpause" },
    { 0xA056, "waitplayerstuckoncarepackagereturn" },
    { 0xA057, "waitrequirevisibility" },
    { 0xA058, "waitrespawnbutton" },
    { 0xA059, "waitrestoreperks" },
    { 0xA05A, "waitsetstates" },
    { 0xA05B, "waitsetstatic" },
    { 0xA05C, "waitsetstop" },
    { 0xA05D, "waitsetthermal" },
    { 0xA05E, "waitskipkillcambutton" },
    { 0xA05F, "waitsmoketime" },
    { 0xA060, "waitspawnrandombutton" },
    { 0xA061, "waitspread_code" },
    { 0xA062, "waitspread_insert" },
    { 0xA063, "waitsuppresstimeout" },
    { 0xA064, "waittakekillstreakweapon" },
    { 0xA065, "waitteamspawnbutton" },
    { 0xA066, "waitthenflashhudtimer" },
    { 0xA067, "waittill_abort_func_ends" },
    { 0xA068, "waittill_aerial_pathnodes_calculated" },
    { 0xA069, "waittill_aigroupcleared" },
    { 0xA06A, "waittill_aigroupcount" },
    { 0xA06B, "waittill_aigroupcount_or_flag" },
    { 0xA06C, "waittill_any" },
    { 0xA06D, "waittill_any_ents" },
    { 0xA06E, "waittill_any_in_array_or_timeout" },
    { 0xA06F, "waittill_any_in_array_or_timeout_no_endon_death" },
    { 0xA070, "waittill_any_in_array_return" },
    { 0xA071, "waittill_any_in_array_return_no_endon_death" },
    { 0xA072, "waittill_any_or_timeout" },
    { 0xA073, "waittill_any_return" },
    { 0xA074, "waittill_any_return_no_endon_death" },
    { 0xA075, "waittill_any_return_parms" },
    { 0xA076, "waittill_any_timeout" },
    { 0xA077, "waittill_any_timeout_no_endon_death" },
    { 0xA078, "waittill_any_timeout_pause_on_death_and_prematch" },
    { 0xA079, "waittill_any_trigger" },
    { 0xA07A, "waittill_attack_and_launch_drones" },
    { 0xA07B, "waittill_combat" },
    { 0xA07C, "waittill_combat_wait" },
    { 0xA07D, "waittill_copier_copies" },
    { 0xA07E, "waittill_crate_activated" },
    { 0xA07F, "waittill_dash_button_pressed" },
    { 0xA080, "waittill_dash_button_released" },
    { 0xA081, "waittill_dead" },
    { 0xA082, "waittill_dead_or_dying" },
    { 0xA083, "waittill_dead_or_dying_thread" },
    { 0xA084, "waittill_dead_thread" },
    { 0xA085, "waittill_dead_timeout" },
    { 0xA086, "waittill_death" },
    { 0xA087, "waittill_dmg_timeout" },
    { 0xA088, "waittill_drones_dead" },
    { 0xA089, "waittill_dropoff_height" },
    { 0xA08A, "waittill_either" },
    { 0xA08B, "waittill_either_differnt_senders" },
    { 0xA08C, "waittill_either_function" },
    { 0xA08D, "waittill_either_function_internal" },
    { 0xA08E, "waittill_enemy_group_size_is" },
    { 0xA08F, "waittill_entity_activate_looking_at" },
    { 0xA090, "waittill_entity_in_range" },
    { 0xA091, "waittill_entity_in_range_or_timeout" },
    { 0xA092, "waittill_entity_out_of_range" },
    { 0xA093, "waittill_finish_moving" },
    { 0xA094, "waittill_func_ends" },
    { 0xA095, "waittill_glass_break" },
    { 0xA096, "waittill_grenade_damage" },
    { 0xA097, "waittill_has_reached_hill_idle" },
    { 0xA098, "waittill_in_range" },
    { 0xA099, "waittill_land_assist_ended" },
    { 0xA09A, "waittill_marker_passed" },
    { 0xA09B, "waittill_match_or_timeout" },
    { 0xA09C, "waittill_msg" },
    { 0xA09D, "waittill_multiple" },
    { 0xA09E, "waittill_multiple_ents" },
    { 0xA09F, "waittill_notetrack_or_damage" },
    { 0xA0A0, "waittill_notify_func" },
    { 0xA0A1, "waittill_notify_func_ent" },
    { 0xA0A2, "waittill_notify_or_flag" },
    { 0xA0A3, "waittill_notify_or_timeout" },
    { 0xA0A4, "waittill_notify_or_timeout_hostmigration_pause" },
    { 0xA0A5, "waittill_notify_or_timeout_return" },
    { 0xA0A6, "waittill_nt" },
    { 0xA0A7, "waittill_objective_event" },
    { 0xA0A8, "waittill_objective_event_notrigger" },
    { 0xA0A9, "waittill_objective_event_proc" },
    { 0xA0AA, "waittill_or_timeout" },
    { 0xA0AB, "waittill_player_exo_climbing" },
    { 0xA0AC, "waittill_player_fall" },
    { 0xA0AD, "waittill_player_hits_a" },
    { 0xA0AE, "waittill_player_in_range" },
    { 0xA0AF, "waittill_player_lookat" },
    { 0xA0B0, "waittill_player_lookat_for_time" },
    { 0xA0B1, "waittill_player_not_exo_climbing" },
    { 0xA0B2, "waittill_player_presses_triggers" },
    { 0xA0B3, "waittill_player_tries_to_advance" },
    { 0xA0B4, "waittill_player_uses_land_assist" },
    { 0xA0B5, "waittill_player_uses_land_assist_or_is_a_jerk" },
    { 0xA0B6, "waittill_player_uses_truck_latch" },
    { 0xA0B7, "waittill_pushed_by" },
    { 0xA0B8, "waittill_s2_drone_ambush_done" },
    { 0xA0B9, "waittill_shot_then_die" },
    { 0xA0BA, "waittill_spawn_waterfall_fight" },
    { 0xA0BB, "waittill_stable" },
    { 0xA0BC, "waittill_string" },
    { 0xA0BD, "waittill_string_no_endon_death" },
    { 0xA0BE, "waittill_string_parms" },
    { 0xA0BF, "waittill_tag_calculated_on_path_grid" },
    { 0xA0C0, "waittill_targetname_volume_dead_then_set_flag" },
    { 0xA0C1, "waittill_till_timeout_or_boost" },
    { 0xA0C2, "waittill_time_or_msg" },
    { 0xA0C3, "waittill_touching_entity" },
    { 0xA0C4, "waittill_trigger_activate_looking_at" },
    { 0xA0C5, "waittill_trigger_with_name" },
    { 0xA0C6, "waittill_triggered_current" },
    { 0xA0C7, "waittill_true_goal" },
    { 0xA0C8, "waittill_turret_is_released" },
    { 0xA0C9, "waittill_vehicles_dead" },
    { 0xA0CA, "waittill_volume_dead" },
    { 0xA0CB, "waittill_volume_dead_or_dying" },
    { 0xA0CC, "waittill_volume_dead_then_set_flag" },
    { 0xA0CD, "waittill_weapon_placed" },
    { 0xA0CE, "waittill_weaponhud_canshow" },
    { 0xA0CF, "waittillaiarraydeadoralerted" },
    { 0xA0D0, "waittillaiarrayneargoal" },
    { 0xA0D1, "waittillaineargoal" },
    { 0xA0D2, "waittillattachmentdone" },
    { 0xA0D3, "waittillbcsdone" },
    { 0xA0D4, "waittillbuddyjoinedairstrike" },
    { 0xA0D5, "waittillbuddyjoinedstreak" },
    { 0xA0D6, "waittilldeadoralertedthread" },
    { 0xA0D7, "waittilldeathorempty" },
    { 0xA0D8, "waittilldeathorleavesquad" },
    { 0xA0D9, "waittilldeathorpaindeath" },
    { 0xA0DA, "waittilldeletedordeath" },
    { 0xA0DB, "waittillenabled" },
    { 0xA0DC, "waittillenemiesreducedto" },
    { 0xA0DD, "waittillfinalkillcamdone" },
    { 0xA0DE, "waittillfiremissile" },
    { 0xA0DF, "waittillgrenadedrops" },
    { 0xA0E0, "waittillhostmigrationdone" },
    { 0xA0E1, "waittillhostmigrationstarts" },
    { 0xA0E2, "waittillkillcamover" },
    { 0xA0E3, "waittillleftplayspace" },
    { 0xA0E4, "waittillneargoal" },
    { 0xA0E5, "waittilloverplayspace" },
    { 0xA0E6, "waittillplayercanbebuddy" },
    { 0xA0E7, "waittillplayerfireortime" },
    { 0xA0E8, "waittillplayerishitagain" },
    { 0xA0E9, "waittillplayeristouchinganytrigger" },
    { 0xA0EA, "waittillplayerlookatescapevehicle" },
    { 0xA0EB, "waittillplayerlookattarget" },
    { 0xA0EC, "waittillplayerlookattargetintrigger" },
    { 0xA0ED, "waittillplayersignalatriumbreach" },
    { 0xA0EE, "waittillpromptactivated" },
    { 0xA0EF, "waittillpromptcomplete" },
    { 0xA0F0, "waittillrecoveredhealth" },
    { 0xA0F1, "waittillreloadfinished" },
    { 0xA0F2, "waittillremoteturretleavereturn" },
    { 0xA0F3, "waittillremoteturretusedreturn" },
    { 0xA0F4, "waittillrestartordistance" },
    { 0xA0F5, "waittillrocketdeath" },
    { 0xA0F6, "waittillrocketsexploded" },
    { 0xA0F7, "waittillslowprocessallowed" },
    { 0xA0F8, "waittillthread" },
    { 0xA0F9, "waittillthread_proc" },
    { 0xA0FA, "waittillturretfired" },
    { 0xA0FB, "waittillturretstuncomplete" },
    { 0xA0FC, "waittillunmarkplayerasrockettarget" },
    { 0xA0FD, "waittimeifplayerishit" },
    { 0xA0FE, "waittimeoruntilturretstatechange" },
    { 0xA0FF, "waittimerforspawn" },
    { 0xA100, "waituntil_stop_time_or_posreached" },
    { 0xA101, "waituntilmatchstart" },
    { 0xA102, "waituntilmovereturnnode" },
    { 0xA103, "waituntilnotetrack" },
    { 0xA104, "waituntilwaverelease" },
    { 0xA105, "wake_me_up_if_still_alive" },
    { 0xA106, "wake_nearby_drones" },
    { 0xA107, "wakeup_physics_sphere_on_ent" },
    { 0xA108, "walk_accuracy" },
    { 0xA109, "walk_node" },
    { 0xA10A, "walk_override_weights" },
    { 0xA10B, "walk_overrideanim" },
    { 0xA10C, "walk_speed" },
    { 0xA10D, "walk_to_school" },
    { 0xA10E, "walkdist_force_walk" },
    { 0xA10F, "walkdist_reset" },
    { 0xA110, "walkdist_zero" },
    { 0xA111, "walker" },
    { 0xA112, "walker_ammo_crate_nag" },
    { 0xA113, "walker_anims" },
    { 0xA114, "walker_badplace" },
    { 0xA115, "walker_damage_fx" },
    { 0xA116, "walker_death_courtyard_kva_cleanup" },
    { 0xA117, "walker_death_courtyard_kva_cleanup_cg" },
    { 0xA118, "walker_drone_fight" },
    { 0xA119, "walker_dying_fx" },
    { 0xA11A, "walker_esc_node_locations" },
    { 0xA11B, "walker_explode" },
    { 0xA11C, "walker_for_swarm" },
    { 0xA11D, "walker_guy_death" },
    { 0xA11E, "walker_jet_flyby" },
    { 0xA11F, "walker_missile_barrage" },
    { 0xA120, "walker_mobile_turret_dropoff" },
    { 0xA121, "walker_play_death_anim" },
    { 0xA122, "walker_step_over" },
    { 0xA123, "walker_tank" },
    { 0xA124, "walker_tank_death_vo" },
    { 0xA125, "walker_tank_dialgue" },
    { 0xA126, "walker_tank_footstep_left" },
    { 0xA127, "walker_tank_footstep_left_rear" },
    { 0xA128, "walker_tank_footstep_right" },
    { 0xA129, "walker_tank_footstep_right_rear" },
    { 0xA12A, "walker_tank_fx" },
    { 0xA12B, "walker_tank_handle_target" },
    { 0xA12C, "walker_tank_missile_fire" },
    { 0xA12D, "walker_tank_reload_ok" },
    { 0xA12E, "walker_tank_success_vo" },
    { 0xA12F, "walker_tank_turret_fire_at_player" },
    { 0xA130, "walker_tank_turret_fire_at_player_clear" },
    { 0xA131, "walker_tank_turret_fire_at_player_think" },
    { 0xA132, "walker_tank_turret_think" },
    { 0xA133, "walker_track_pos" },
    { 0xA134, "walker_trophy_system" },
    { 0xA135, "walker_trophy_system_dialogue" },
    { 0xA136, "walker2" },
    { 0xA137, "walker2_logic" },
    { 0xA138, "walkernode" },
    { 0xA139, "walkers" },
    { 0xA13A, "walkertank" },
    { 0xA13B, "walking_awareness" },
    { 0xA13C, "walking_civilian_react" },
    { 0xA13D, "walkingaimblendtime" },
    { 0xA13E, "walkingaimlimits" },
    { 0xA13F, "walkingmechblendtime" },
    { 0xA140, "walkingturnrate" },
    { 0xA141, "walkwayguarddialogue" },
    { 0xA142, "walkwayguardstoptalking" },
    { 0xA143, "walkwayplayerkilldialogue" },
    { 0xA144, "walkwaystruggleanimations" },
    { 0xA145, "wall_canal_breach" },
    { 0xA146, "wall_climb_cloak_activate" },
    { 0xA147, "wall_climb_dust_fx" },
    { 0xA148, "wall_climb_force_dismount" },
    { 0xA149, "wall_climb_last_jump" },
    { 0xA14A, "wall_explosion_01" },
    { 0xA14B, "wall_hop_human" },
    { 0xA14C, "wall_notetrack_listener" },
    { 0xA14D, "wall_pull_animation" },
    { 0xA14E, "wall_pull_animation_begin" },
    { 0xA14F, "wall_pull_animation_dialogue" },
    { 0xA150, "wall_pull_slowmo" },
    { 0xA151, "wall_pullup_burke_anim_start" },
    { 0xA152, "walla_bridge_runners" },
    { 0xA153, "wallclimb_roots" },
    { 0xA154, "wants_to_fire" },
    { 0xA155, "wantsafespawn" },
    { 0xA156, "wantsbattlebuddy" },
    { 0xA157, "wantshotgun" },
    { 0xA158, "wantstogrowlattarget" },
    { 0xA159, "wanttoattacktargetbutcant" },
    { 0xA15A, "warbird" },
    { 0xA15B, "warbird_a" },
    { 0xA15C, "warbird_anims" },
    { 0xA15D, "warbird_audio" },
    { 0xA15E, "warbird_b_crash_tower" },
    { 0xA15F, "warbird_buddy_exit" },
    { 0xA160, "warbird_carrying_walker" },
    { 0xA161, "warbird_circling_perimeter" },
    { 0xA162, "warbird_crash_site" },
    { 0xA163, "warbird_crush_player" },
    { 0xA164, "warbird_death_function" },
    { 0xA165, "warbird_deathspin" },
    { 0xA166, "warbird_dropoff_01" },
    { 0xA167, "warbird_dropoff_02" },
    { 0xA168, "warbird_dropoff_03" },
    { 0xA169, "warbird_dropoff_04" },
    { 0xA16A, "warbird_dropping_mobile_tuerret_camshake" },
    { 0xA16B, "warbird_emp_crash_movement" },
    { 0xA16C, "warbird_emp_damage_function" },
    { 0xA16D, "warbird_emp_death" },
    { 0xA16E, "warbird_falling_rocks_loop" },
    { 0xA16F, "warbird_fire" },
    { 0xA170, "warbird_fire_init" },
    { 0xA171, "warbird_fire_init_monitor" },
    { 0xA172, "warbird_fire_monitor" },
    { 0xA173, "warbird_flyover_shootdown" },
    { 0xA174, "warbird_get_passengers" },
    { 0xA175, "warbird_ground_fire_init" },
    { 0xA176, "warbird_ground_fire_no_enemy_init" },
    { 0xA177, "warbird_handle_unload" },
    { 0xA178, "warbird_hanger_dropoff" },
    { 0xA179, "warbird_health" },
    { 0xA17A, "warbird_heavy_fire" },
    { 0xA17B, "warbird_heavy_fire_monitor" },
    { 0xA17C, "warbird_heavy_shooting_think" },
    { 0xA17D, "warbird_hide_blury_rotors" },
    { 0xA17E, "warbird_hoverdust" },
    { 0xA17F, "warbird_ignore_until_unloaded" },
    { 0xA180, "warbird_intro_lighting" },
    { 0xA181, "warbird_land_fov_change" },
    { 0xA182, "warbird_mobile_turret_dropoff" },
    { 0xA183, "warbird_recover_fail" },
    { 0xA184, "warbird_shooting_think" },
    { 0xA185, "warbird_start_shooting" },
    { 0xA186, "warbird_strafe_01" },
    { 0xA187, "warbird_strafe_run" },
    { 0xA188, "warbird_toggle_turret_off_after_deploy" },
    { 0xA189, "warbird_turret_off_after_deploy" },
    { 0xA18A, "warbird_unload_listener" },
    { 0xA18B, "warbird_wait_for_fire_target_done" },
    { 0xA18C, "warbird_wait_for_unload" },
    { 0xA18D, "warbird_wait_until_unloaded" },
    { 0xA18E, "warbirdaiattack" },
    { 0xA18F, "warbirdairocketreload" },
    { 0xA190, "warbirdbuddyturret" },
    { 0xA191, "warbirdcleanup" },
    { 0xA192, "warbirdfire" },
    { 0xA193, "warbirdflightpathnodes" },
    { 0xA194, "warbirdinit" },
    { 0xA195, "warbirdinuse" },
    { 0xA196, "warbirdkilled" },
    { 0xA197, "warbirdlightfx" },
    { 0xA198, "warbirdlightset" },
    { 0xA199, "warbirdlookatenemy" },
    { 0xA19A, "warbirdmakevehiclesolidcapsule" },
    { 0xA19B, "warbirdmovetoattackpoint" },
    { 0xA19C, "warbirdondeath" },
    { 0xA19D, "warbirdoverheatbarcolormonitor" },
    { 0xA19E, "warbirdrocketdamageindicator" },
    { 0xA19F, "warbirdrockethudupdate" },
    { 0xA1A0, "warbirdrocketreloadsound" },
    { 0xA1A1, "warbirdsetting" },
    { 0xA1A2, "warbirdturret" },
    { 0xA1A3, "warbirdvisionset" },
    { 0xA1A4, "warehouse_car_shots" },
    { 0xA1A5, "warehouse_chase_vehicle_02" },
    { 0xA1A6, "warehouse_chase_vehicle_03" },
    { 0xA1A7, "warehouse_chase_vehicle_04" },
    { 0xA1A8, "warehouse_one_shots_glass" },
    { 0xA1A9, "warehouse_one_shots_rock" },
    { 0xA1AA, "waribird_intro_vfx" },
    { 0xA1AB, "warn_facial_dialogue_too_many" },
    { 0xA1AC, "warn_facial_dialogue_unspoken" },
    { 0xA1AD, "warning" },
    { 0xA1AE, "warning_box_functions" },
    { 0xA1AF, "warning_fade" },
    { 0xA1B0, "warning_lines" },
    { 0xA1B1, "warning_pulse" },
    { 0xA1B2, "warning_sign_hide_fx" },
    { 0xA1B3, "warning_sign_show_fx" },
    { 0xA1B4, "warning_time" },
    { 0xA1B5, "warning_update_text" },
    { 0xA1B6, "warningelement" },
    { 0xA1B7, "warningradiussq" },
    { 0xA1B8, "warningzheight" },
    { 0xA1B9, "warp_allies" },
    { 0xA1BA, "warp_allies_forward_sinkhole" },
    { 0xA1BB, "warp_to_start" },
    { 0xA1BC, "was_ever_visible" },
    { 0xA1BD, "was_headshot" },
    { 0xA1BE, "was_in_exposed_group" },
    { 0xA1BF, "was_on" },
    { 0xA1C0, "was_walking" },
    { 0xA1C1, "wasaliveatmatchstart" },
    { 0xA1C2, "wasallowingpain" },
    { 0xA1C3, "waschained" },
    { 0xA1C4, "wascontested" },
    { 0xA1C5, "wascooked" },
    { 0xA1C6, "wasdamaged" },
    { 0xA1C7, "wasdamagedbyexplosive" },
    { 0xA1C8, "wasdamagedfrombulletpenetration" },
    { 0xA1C9, "waselminatedbyenemy" },
    { 0xA1CA, "wasemp" },
    { 0xA1CB, "wasfacingmotion" },
    { 0xA1CC, "wasflashbangimmune" },
    { 0xA1CD, "waslastround" },
    { 0xA1CE, "wasleftunoccupied" },
    { 0xA1CF, "wasonlyround" },
    { 0xA1D0, "wasp_cloak_off" },
    { 0xA1D1, "wasp_cloak_on" },
    { 0xA1D2, "waspreviouslyincover" },
    { 0xA1D3, "wasrecall" },
    { 0xA1D4, "wasswitchingteamsforonplayerkilled" },
    { 0xA1D5, "wasti" },
    { 0xA1D6, "wasunderwater" },
    { 0xA1D7, "waswinning" },
    { 0xA1D8, "watch_ally_alert" },
    { 0xA1D9, "watch_ball_pickup_and_loss" },
    { 0xA1DA, "watch_bloodplosion" },
    { 0xA1DB, "watch_bot_died_during_crate" },
    { 0xA1DC, "watch_bot_died_during_revive" },
    { 0xA1DD, "watch_death_endon" },
    { 0xA1DE, "watch_distance_on_tutorial_spawner" },
    { 0xA1DF, "watch_follow_objective" },
    { 0xA1E0, "watch_for_alert" },
    { 0xA1E1, "watch_for_death" },
    { 0xA1E2, "watch_for_deaths" },
    { 0xA1E3, "watch_for_joined_team" },
    { 0xA1E4, "watch_for_player_to_reach_overlook" },
    { 0xA1E5, "watch_for_tutorial_enemy_death" },
    { 0xA1E6, "watch_for_underwater" },
    { 0xA1E7, "watch_goal_aborted" },
    { 0xA1E8, "watch_hide_pack_notetracks" },
    { 0xA1E9, "watch_jump_flag" },
    { 0xA1EA, "watch_jumper" },
    { 0xA1EB, "watch_mech_firing" },
    { 0xA1EC, "watch_node_chance" },
    { 0xA1ED, "watch_nodes" },
    { 0xA1EE, "watch_nodes_aborted" },
    { 0xA1EF, "watch_nodes_stop" },
    { 0xA1F0, "watch_out_of_ammo" },
    { 0xA1F1, "watch_player_braking" },
    { 0xA1F2, "watch_player_grapple" },
    { 0xA1F3, "watch_player_shot_me" },
    { 0xA1F4, "watch_players_connecting" },
    { 0xA1F5, "watch_rider_death" },
    { 0xA1F6, "watch_show_pack_notetracks" },
    { 0xA1F7, "watch_stinger_nags" },
    { 0xA1F8, "watch_tag_destination" },
    { 0xA1F9, "watch_tappy_progress" },
    { 0xA1FA, "watch_to_delete" },
    { 0xA1FB, "watch_tower_nags" },
    { 0xA1FC, "watch_turn_off_mbs" },
    { 0xA1FD, "watch_turret_hit_heli" },
    { 0xA1FE, "watchadrenalineusage" },
    { 0xA1FF, "watchagentspawn" },
    { 0xA200, "watchaienterwater" },
    { 0xA201, "watchallplayerdeath" },
    { 0xA202, "watchattackstate" },
    { 0xA203, "watchattackstatefunc" },
    { 0xA204, "watchbackbuttonpress" },
    { 0xA205, "watchbarking" },
    { 0xA206, "watchc4" },
    { 0xA207, "watchc4altdetonate" },
    { 0xA208, "watchc4altdetonation" },
    { 0xA209, "watchc4detonation" },
    { 0xA20A, "watchc4stuck" },
    { 0xA20B, "watchc4usage" },
    { 0xA20C, "watchcarryobjects" },
    { 0xA20D, "watchclaymores" },
    { 0xA20E, "watchconnectedplayfx" },
    { 0xA20F, "watchconnectedplayfxexplosive" },
    { 0xA210, "watchcranenotetrack" },
    { 0xA211, "watchdamagechemical" },
    { 0xA212, "watchdeath" },
    { 0xA213, "watchdeployedriotshielddamage" },
    { 0xA214, "watchdeployedriotshieldents" },
    { 0xA215, "watchdistortdisconnectdeath" },
    { 0xA216, "watchdrop" },
    { 0xA217, "watchdvars" },
    { 0xA218, "watchenemyvelocity" },
    { 0xA219, "watchenterandexit" },
    { 0xA21A, "watchenterandexitinput" },
    { 0xA21B, "watchexplosivedroneusage" },
    { 0xA21C, "watchexplosivegelaltdetonate" },
    { 0xA21D, "watchexplosivegelusage" },
    { 0xA21E, "watchextrahealthusage" },
    { 0xA21F, "watchfasthealusage" },
    { 0xA220, "watchfavoriteenemydeath" },
    { 0xA221, "watchforclasschange" },
    { 0xA222, "watchforclustersplit" },
    { 0xA223, "watchfordeath" },
    { 0xA224, "watchforextramissilefire" },
    { 0xA225, "watchforhostmigrationsetround" },
    { 0xA226, "watchforincomingfire" },
    { 0xA227, "watchforjoin" },
    { 0xA228, "watchforlasermovement" },
    { 0xA229, "watchforleavegame" },
    { 0xA22A, "watchforneedtoturnortimeout" },
    { 0xA22B, "watchforpickup" },
    { 0xA22C, "watchforrandomspawnbutton" },
    { 0xA22D, "watchforstick" },
    { 0xA22E, "watchforteamchange" },
    { 0xA22F, "watchforthrowbacks" },
    { 0xA230, "watchgoalchanged" },
    { 0xA231, "watchgrenadegraceperiod" },
    { 0xA232, "watchgrenadetowardsplayer" },
    { 0xA233, "watchgrenadetowardsplayerinternal" },
    { 0xA234, "watchgrenadetowardsplayertimeout" },
    { 0xA235, "watchgrenadeusage" },
    { 0xA236, "watchhasdonecombat" },
    { 0xA237, "watchhitbymissile" },
    { 0xA238, "watchhostmigration" },
    { 0xA239, "watchjoinedteamplayfx" },
    { 0xA23A, "watchjoinedteamplayfxexplosive" },
    { 0xA23B, "watchmanualdetonationbydoubletap" },
    { 0xA23C, "watchmanualdetonationbyemptythrow" },
    { 0xA23D, "watchmanuallydetonatedfordoubletap" },
    { 0xA23E, "watchmanuallydetonatedusage" },
    { 0xA23F, "watchmgfireuncloak" },
    { 0xA240, "watchmineusage" },
    { 0xA241, "watchminimap" },
    { 0xA242, "watchmissileproximity" },
    { 0xA243, "watchmissileusage" },
    { 0xA244, "watchmutebombusage" },
    { 0xA245, "watchoffhandcancel" },
    { 0xA246, "watchownerdamage" },
    { 0xA247, "watchownerdeath" },
    { 0xA248, "watchownermessageondeath" },
    { 0xA249, "watchownerteamchange" },
    { 0xA24A, "watchpainteddeath" },
    { 0xA24B, "watchpaintgrenade" },
    { 0xA24C, "watchpickup" },
    { 0xA24D, "watchplayerconnected" },
    { 0xA24E, "watchplayerdeathdisconnect" },
    { 0xA24F, "watchplayerdeathdisconnectexplosive" },
    { 0xA250, "watchplayerenterlasercore" },
    { 0xA251, "watchplayerenterwater" },
    { 0xA252, "watchrangerusage" },
    { 0xA253, "watchreloading" },
    { 0xA254, "watchriotshielddeploy" },
    { 0xA255, "watchriotshieldpickup" },
    { 0xA256, "watchriotshieldstuckentitydeath" },
    { 0xA257, "watchriotshielduse" },
    { 0xA258, "watchrobotarmnotetrack" },
    { 0xA259, "watchselectbuttonpress" },
    { 0xA25A, "watchsentryusage" },
    { 0xA25B, "watchshootentvelocity" },
    { 0xA25C, "watchshotgunswitchnotetracks" },
    { 0xA25D, "watchslide" },
    { 0xA25E, "watchsmokeexplode" },
    { 0xA25F, "watchstartweaponchange" },
    { 0xA260, "watchstingerusage" },
    { 0xA261, "watchstoppingpowerkill" },
    { 0xA262, "watchsuppression" },
    { 0xA263, "watchtrackingdroneusage" },
    { 0xA264, "watchtridroneusage" },
    { 0xA265, "watchtrophyusage" },
    { 0xA266, "watchweaponchange" },
    { 0xA267, "watchweaponreload" },
    { 0xA268, "watchweaponusage" },
    { 0xA269, "water" },
    { 0xA26A, "water_allow_jump" },
    { 0xA26B, "water_allow_prone" },
    { 0xA26C, "water_allow_sprint" },
    { 0xA26D, "water_barrell_splash_screen_fx" },
    { 0xA26E, "water_bubbles_transition_player_view" },
    { 0xA26F, "water_bubbles_truck_door" },
    { 0xA270, "water_crash_jeep_1" },
    { 0xA271, "water_crash_jeep_2" },
    { 0xA272, "water_current" },
    { 0xA273, "water_default_vision_set_enabled" },
    { 0xA274, "water_depth" },
    { 0xA275, "water_depth_below" },
    { 0xA276, "water_depth_state" },
    { 0xA277, "water_exp_audio" },
    { 0xA278, "water_explosions" },
    { 0xA279, "water_explosions_far" },
    { 0xA27A, "water_explosions_near" },
    { 0xA27B, "water_foley_type" },
    { 0xA27C, "water_ground_ref_ent" },
    { 0xA27D, "water_impacts" },
    { 0xA27E, "water_last_weapon" },
    { 0xA27F, "water_lastemerge" },
    { 0xA280, "water_level_z" },
    { 0xA281, "water_rising_01" },
    { 0xA282, "water_rising_02" },
    { 0xA283, "water_rising_03" },
    { 0xA284, "water_set_control_options" },
    { 0xA285, "water_set_depth" },
    { 0xA286, "water_sheeting" },
    { 0xA287, "water_sheeting_think" },
    { 0xA288, "water_splash" },
    { 0xA289, "water_splash_function" },
    { 0xA28A, "water_splash_info" },
    { 0xA28B, "water_splash_reset_function" },
    { 0xA28C, "water_step" },
    { 0xA28D, "water_touching" },
    { 0xA28E, "water_trigger_current" },
    { 0xA28F, "water_trigger_register" },
    { 0xA290, "water_triggers" },
    { 0xA291, "water_vision_set_enabled" },
    { 0xA292, "water_wading_move_speed" },
    { 0xA293, "water_wading_move_speed_target" },
    { 0xA294, "water_wading_waterdepthtype" },
    { 0xA295, "water_wading_wobble" },
    { 0xA296, "water_wading_wobble_target" },
    { 0xA297, "water_wake_speed" },
    { 0xA298, "water_warning" },
    { 0xA299, "waterbadtrigger" },
    { 0xA29A, "waterdeletez" },
    { 0xA29B, "waterfall_save" },
    { 0xA29C, "waterfx" },
    { 0xA29D, "waterline_ents" },
    { 0xA29E, "waterline_offset" },
    { 0xA29F, "waterthink" },
    { 0xA2A0, "waterthink_rampspeed" },
    { 0xA2A1, "wave_1_5_ally_move" },
    { 0xA2A2, "wave_1_5_retreat" },
    { 0xA2A3, "wave_1_ally_move" },
    { 0xA2A4, "wave_1_enemy_logic" },
    { 0xA2A5, "wave_1_logic" },
    { 0xA2A6, "wave_1_zippers" },
    { 0xA2A7, "wave_2_special_start" },
    { 0xA2A8, "wave_3_ally_move_left" },
    { 0xA2A9, "wave_3_ally_move_right" },
    { 0xA2AA, "wave_3_retreat" },
    { 0xA2AB, "wave_3_retreat_vol" },
    { 0xA2AC, "wave_3_zippers" },
    { 0xA2AD, "wave1" },
    { 0xA2AE, "wavedelay" },
    { 0xA2AF, "wavefirstspawn" },
    { 0xA2B0, "waveplayerspawnindex" },
    { 0xA2B1, "waves" },
    { 0xA2B2, "wavespawnindex" },
    { 0xA2B3, "wavespawntimer" },
    { 0xA2B4, "waypoint" },
    { 0xA2B5, "weap_has_thermal" },
    { 0xA2B6, "weap_is_em1" },
    { 0xA2B7, "weap_is_hbra3" },
    { 0xA2B8, "weap_is_himar" },
    { 0xA2B9, "weapon_ammo" },
    { 0xA2BA, "weapon_ammo_bar" },
    { 0xA2BB, "weapon_ammo_bar_color" },
    { 0xA2BC, "weapon_ammo_bar_reload" },
    { 0xA2BD, "weapon_ammo_bar_value" },
    { 0xA2BE, "weapon_ammo_count" },
    { 0xA2BF, "weapon_ammo_max" },
    { 0xA2C0, "weapon_col" },
    { 0xA2C1, "weapon_cooldown_active" },
    { 0xA2C2, "weapon_cooldown_time" },
    { 0xA2C3, "weapon_drop_cleanup" },
    { 0xA2C4, "weapon_fire" },
    { 0xA2C5, "weapon_fire_notify" },
    { 0xA2C6, "weapon_fire_sound" },
    { 0xA2C7, "weapon_input_cooldown_active" },
    { 0xA2C8, "weapon_list_debug" },
    { 0xA2C9, "weapon_name" },
    { 0xA2CA, "weapon_names" },
    { 0xA2CB, "weapon_notify_loop" },
    { 0xA2CC, "weapon_out" },
    { 0xA2CD, "weapon_pickups_disable" },
    { 0xA2CE, "weapon_platform_fire_1" },
    { 0xA2CF, "weapon_platform_fire_2" },
    { 0xA2D0, "weapon_platform_fire_3" },
    { 0xA2D1, "weapon_platform_rigged" },
    { 0xA2D2, "weapon_pump_action_shotgun" },
    { 0xA2D3, "weapon_ready_to_fire" },
    { 0xA2D4, "weapon_reload" },
    { 0xA2D5, "weapon_reload_time" },
    { 0xA2D6, "weaponattachments" },
    { 0xA2D7, "weaponcamoorder" },
    { 0xA2D8, "weaponclass" },
    { 0xA2D9, "weapondamagetracepassed" },
    { 0xA2DA, "weapondmgmod" },
    { 0xA2DB, "weapondropfunction" },
    { 0xA2DC, "weaponfire" },
    { 0xA2DD, "weaponisriotshield" },
    { 0xA2DE, "weaponisshockplantriotshield" },
    { 0xA2DF, "weaponlinker" },
    { 0xA2E0, "weaponlist" },
    { 0xA2E1, "weaponlistenforstopfire" },
    { 0xA2E2, "weaponname" },
    { 0xA2E3, "weaponnamefull" },
    { 0xA2E4, "weaponplf_flyby_dustfx_sinkhole" },
    { 0xA2E5, "weaponpos" },
    { 0xA2E6, "weaponposdropping" },
    { 0xA2E7, "weaponproficiency" },
    { 0xA2E8, "weaponrefs" },
    { 0xA2E9, "weapons" },
    { 0xA2EA, "weapons_with_ir" },
    { 0xA2EB, "weaponsetup" },
    { 0xA2EC, "weaponslot" },
    { 0xA2ED, "weaponsound" },
    { 0xA2EE, "weaponspeed" },
    { 0xA2EF, "weaponstate" },
    { 0xA2F0, "weaponstorestore" },
    { 0xA2F1, "weapontag01" },
    { 0xA2F2, "weapontag02" },
    { 0xA2F3, "weapontag03" },
    { 0xA2F4, "weapontag04" },
    { 0xA2F5, "weapontweaks" },
    { 0xA2F6, "weapontype" },
    { 0xA2F7, "weaponusagename" },
    { 0xA2F8, "weaponusagestarttime" },
    { 0xA2F9, "weather_report" },
    { 0xA2FA, "weave" },
    { 0xA2FB, "welder" },
    { 0xA2FC, "went_thither" },
    { 0xA2FD, "went_thither_time" },
    { 0xA2FE, "wetlevel" },
    { 0xA2FF, "wheel_for_hostage_car" },
    { 0xA300, "wheel_speed_modifier" },
    { 0xA301, "wheeldir" },
    { 0xA302, "wheeldirectionchange" },
    { 0xA303, "wheelman_success" },
    { 0xA304, "wheels_bump_impact" },
    { 0xA305, "when_am_i_near_player" },
    { 0xA306, "whisper" },
    { 0xA307, "whistle" },
    { 0xA308, "whistle_count" },
    { 0xA309, "whistle_hint_used" },
    { 0xA30A, "whistle_no_relay" },
    { 0xA30B, "whistle_tutorial_enemy" },
    { 0xA30C, "white_hoodoo_fx" },
    { 0xA30D, "white_hoodoos" },
    { 0xA30E, "white_out" },
    { 0xA30F, "white_overlay" },
    { 0xA310, "whiz" },
    { 0xA311, "whiz_init" },
    { 0xA312, "whiz_set_offset" },
    { 0xA313, "whiz_set_preset" },
    { 0xA314, "whiz_set_probabilities" },
    { 0xA315, "whiz_set_radii" },
    { 0xA316, "whiz_set_spreads" },
    { 0xA317, "whiz_use_string_table" },
    { 0xA318, "whizby_settings" },
    { 0xA319, "whizbyenemy" },
    { 0xA31A, "whizx_get_mix_preset_from_stringtable_internal" },
    { 0xA31B, "whizx_get_stringtable_preset" },
    { 0xA31C, "widebeam" },
    { 0xA31D, "widen_player_view" },
    { 0xA31E, "wildcards" },
    { 0xA31F, "wildcardsowned" },
    { 0xA320, "will_be_manhandled" },
    { 0xA321, "will_boid_clip_camera" },
    { 0xA322, "will_doorshield_debris" },
    { 0xA323, "will_doorshield_foley" },
    { 0xA324, "will_doorshield_grabs" },
    { 0xA325, "will_doorshield_rip" },
    { 0xA326, "will_doorshield_tension" },
    { 0xA327, "will_irons" },
    { 0xA328, "will_irons_intro" },
    { 0xA329, "will_perarts_jump_explosions" },
    { 0xA32A, "will_reveal_fov_default" },
    { 0xA32B, "will_room_door_exit" },
    { 0xA32C, "will_room_logic" },
    { 0xA32D, "will_room_speech_end" },
    { 0xA32E, "winbycaptures" },
    { 0xA32F, "wind" },
    { 0xA330, "wind_dir" },
    { 0xA331, "wind_gate_open" },
    { 0xA332, "wind_gust" },
    { 0xA333, "wind_lp" },
    { 0xA334, "wind_over_trees" },
    { 0xA335, "wind_warning" },
    { 0xA336, "windcontroller" },
    { 0xA337, "windmill_sniper_shot" },
    { 0xA338, "windmill_sniper_shot_multi" },
    { 0xA339, "windmill_sniper_shot_whizby" },
    { 0xA33A, "window_destroy" },
    { 0xA33B, "window_down_height" },
    { 0xA33C, "window_explosion_wait_think" },
    { 0xA33D, "window_guy" },
    { 0xA33E, "window_hint" },
    { 0xA33F, "window_position" },
    { 0xA340, "windowgapjumpglassshatter" },
    { 0xA341, "windowhoteljumpglassshatter" },
    { 0xA342, "wingman" },
    { 0xA343, "wingman_getgoalpos" },
    { 0xA344, "wingman_think" },
    { 0xA345, "winner" },
    { 0xA346, "wipeout" },
    { 0xA347, "wirewander" },
    { 0xA348, "within_angle" },
    { 0xA349, "within_attack_range" },
    { 0xA34A, "within_fov" },
    { 0xA34B, "within_fov_2d" },
    { 0xA34C, "within_fov_of_players" },
    { 0xA34D, "within_player_fov" },
    { 0xA34E, "witness_kill_valid" },
    { 0xA34F, "wood_debris" },
    { 0xA350, "worker_spawn_func" },
    { 0xA351, "world_body" },
    { 0xA352, "world_x" },
    { 0xA353, "worldicons" },
    { 0xA354, "worldtolocalcoords" },
    { 0xA355, "worlduseicons" },
    { 0xA356, "worthydamageratio" },
    { 0xA357, "woundedsoldierdeath" },
    { 0xA358, "wpn_deam160_aud_charges" },
    { 0xA359, "wpn_deam160_charge" },
    { 0xA35A, "wpn_deam160_charge_dots_increase" },
    { 0xA35B, "wpn_deam160_full_charge" },
    { 0xA35C, "wpn_deam160_init" },
    { 0xA35D, "wpn_deam160_is_chargeable" },
    { 0xA35E, "wpn_deam160_play_charge_loop_sfx" },
    { 0xA35F, "wpn_deam160_shot" },
    { 0xA360, "wpn_deam160_watch_weapon_change" },
    { 0xA361, "write_entity" },
    { 0xA362, "write_log" },
    { 0xA363, "writebufferedstats" },
    { 0xA364, "writesegmentdata" },
    { 0xA365, "x_on_closest_cardoor" },
    { 0xA366, "x4_walker_controls_hints_shown" },
    { 0xA367, "x4_walker_fire_missile" },
    { 0xA368, "x4_walker_hud_missile_launched" },
    { 0xA369, "x4_walker_hud_target_aquired" },
    { 0xA36A, "x4walker_player_invulnerability" },
    { 0xA36B, "x4walker_spawn_player_rig" },
    { 0xA36C, "x4walker_wheels_fusion_turret" },
    { 0xA36D, "x4walker_wheels_seoul_turret" },
    { 0xA36E, "x4ww_condition_callback_to_state_breaking" },
    { 0xA36F, "x4ww_condition_callback_to_state_destruct" },
    { 0xA370, "x4ww_condition_callback_to_state_enter_vehicle" },
    { 0xA371, "x4ww_condition_callback_to_state_exit_vehicle" },
    { 0xA372, "x4ww_condition_callback_to_state_idle" },
    { 0xA373, "x4ww_condition_callback_to_state_moving" },
    { 0xA374, "x4ww_condition_callback_to_state_off" },
    { 0xA375, "x4ww_condition_callback_to_state_shutoff" },
    { 0xA376, "x4ww_condition_callback_to_state_start_move" },
    { 0xA377, "x4ww_condition_callback_to_state_startup" },
    { 0xA378, "x4ww_condition_callback_to_state_stopped" },
    { 0xA379, "x4ww_condition_callback_to_state_turret_elevate" },
    { 0xA37A, "x4ww_condition_callback_to_state_turret_rotate" },
    { 0xA37B, "x4ww_condition_callback_to_state_turret_rotate_accel" },
    { 0xA37C, "x4ww_condition_callback_to_state_turret_rotate_decel" },
    { 0xA37D, "x4ww_condition_callback_to_state_turret_stopped" },
    { 0xA37E, "x4ww_condition_callback_to_state_wheels_bump_impact" },
    { 0xA37F, "x4ww_condition_callback_to_state_wheels_neutral" },
    { 0xA380, "x4ww_input_callback_gun_pitch_rate" },
    { 0xA381, "x4ww_input_callback_gun_yaw_rate" },
    { 0xA382, "x4ww_input_callback_player_driver" },
    { 0xA383, "x4ww_input_callback_wheel_zvelocity" },
    { 0xA384, "x4ww_input_callback_wheel_zvelocity_front_left" },
    { 0xA385, "x4ww_input_callback_wheel_zvelocity_front_right" },
    { 0xA386, "x4ww_input_callback_wheel_zvelocity_rear_left" },
    { 0xA387, "x4ww_input_callback_wheel_zvelocity_rear_right" },
    { 0xA388, "x4wwt_condition_callback_to_state_breaking" },
    { 0xA389, "x4wwt_condition_callback_to_state_destruct" },
    { 0xA38A, "x4wwt_condition_callback_to_state_enter_vehicle" },
    { 0xA38B, "x4wwt_condition_callback_to_state_exit_vehicle" },
    { 0xA38C, "x4wwt_condition_callback_to_state_idle" },
    { 0xA38D, "x4wwt_condition_callback_to_state_moving" },
    { 0xA38E, "x4wwt_condition_callback_to_state_off" },
    { 0xA38F, "x4wwt_condition_callback_to_state_shutoff" },
    { 0xA390, "x4wwt_condition_callback_to_state_start_move" },
    { 0xA391, "x4wwt_condition_callback_to_state_startup" },
    { 0xA392, "x4wwt_condition_callback_to_state_stopped" },
    { 0xA393, "x4wwt_condition_callback_to_state_turret_elevate" },
    { 0xA394, "x4wwt_condition_callback_to_state_turret_rotate" },
    { 0xA395, "x4wwt_condition_callback_to_state_turret_rotate_accel" },
    { 0xA396, "x4wwt_condition_callback_to_state_turret_rotate_decel" },
    { 0xA397, "x4wwt_condition_callback_to_state_turret_stopped" },
    { 0xA398, "x4wwt_condition_callback_to_state_wheels_bump_impact" },
    { 0xA399, "x4wwt_condition_callback_to_state_wheels_neutral" },
    { 0xA39A, "x4wwt_input_callback_gun_pitch_rate" },
    { 0xA39B, "x4wwt_input_callback_gun_yaw_rate" },
    { 0xA39C, "x4wwt_input_callback_player_driver" },
    { 0xA39D, "x4wwt_input_callback_wheel_zvelocity" },
    { 0xA39E, "x4wwt_input_callback_wheel_zvelocity_front_left" },
    { 0xA39F, "x4wwt_input_callback_wheel_zvelocity_front_right" },
    { 0xA3A0, "x4wwt_input_callback_wheel_zvelocity_rear_left" },
    { 0xA3A1, "x4wwt_input_callback_wheel_zvelocity_rear_right" },
    { 0xA3A2, "xoffset" },
    { 0xA3A3, "xp_ai_func" },
    { 0xA3A4, "xp_enable" },
    { 0xA3A5, "xp_give_func" },
    { 0xA3A6, "xpadding" },
    { 0xA3A7, "xpatlifestart" },
    { 0xA3A8, "xpeventinfo" },
    { 0xA3A9, "xppointspopup" },
    { 0xA3AA, "xppopup" },
    { 0xA3AB, "xprompt_on_brick" },
    { 0xA3AC, "xpscalar" },
    { 0xA3AD, "xpscale" },
    { 0xA3AE, "xpupdatetotal" },
    { 0xA3AF, "xraywall_on" },
    { 0xA3B0, "xraywall_static" },
    { 0xA3B1, "xslicefade" },
    { 0xA3B2, "xslicestartdialogue" },
    { 0xA3B3, "xuid2ownerid" },
    { 0xA3B4, "xy" },
    { 0xA3B5, "yards2dist" },
    { 0xA3B6, "yards2units" },
    { 0xA3B7, "yaw" },
    { 0xA3B8, "yaw_per_sec_calc" },
    { 0xA3B9, "yaw_rate" },
    { 0xA3BA, "yaw_scale" },
    { 0xA3BB, "yaw_tilt_to_direction_vector" },
    { 0xA3BC, "yawdiff" },
    { 0xA3BD, "yoffset" },
    { 0xA3BE, "youre_dead_functon" },
    { 0xA3BF, "youre_spoted_functon" },
    { 0xA3C0, "ypadding" },
    { 0xA3C1, "zap_local_drones" },
    { 0xA3C2, "zip" },
    { 0xA3C3, "zip_debris_anim" },
    { 0xA3C4, "zip_rooftop_dialogue" },
    { 0xA3C5, "zip_team_two_deployed_dialogue" },
    { 0xA3C6, "zipline_animname" },
    { 0xA3C7, "zipline_end_org" },
    { 0xA3C8, "zipline_gun_model" },
    { 0xA3C9, "zipline_gunner_tag" },
    { 0xA3CA, "zipline_guy_laser_think" },
    { 0xA3CB, "zipline_guy_shoot_think" },
    { 0xA3CC, "zipline_land_anims" },
    { 0xA3CD, "zippers_spawner" },
    { 0xA3CE, "zoffset" },
    { 0xA3CF, "zombiedialog" },
    { 0xA3D0, "zombieextractiongates" },
    { 0xA3D1, "zombiegivemaxammo" },
    { 0xA3D2, "zombieincreasewavecount" },
    { 0xA3D3, "zombiemovinggates" },
    { 0xA3D4, "zombiepreloadweapons" },
    { 0xA3D5, "zombierotatinggates" },
    { 0xA3D6, "zombiescompleted" },
    { 0xA3D7, "zombiesdead" },
    { 0xA3D8, "zombiesdestroykillstreaks" },
    { 0xA3D9, "zombiesdisablearmories" },
    { 0xA3DA, "zombiesetspeedscale" },
    { 0xA3DB, "zombiesmusic" },
    { 0xA3DC, "zombiesstarted" },
    { 0xA3DD, "zombiewavesequence" },
    { 0xA3DE, "zombieweaponpickup" },
    { 0xA3DF, "zombieweapons" },
    { 0xA3E0, "zone" },
    { 0xA3E1, "zone_boarder_effect" },
    { 0xA3E2, "zone_boarder_effect_stop" },
    { 0xA3E3, "zone_bounds" },
    { 0xA3E4, "zone_filters_enabled" },
    { 0xA3E5, "zone_flag_effect" },
    { 0xA3E6, "zone_flag_effect_stop" },
    { 0xA3E7, "zone_from_name" },
    { 0xA3E8, "zone_get_node_nearest_2d_bounds" },
    { 0xA3E9, "zone_handler" },
    { 0xA3EA, "zone_handler_snipers" },
    { 0xA3EB, "zone_height" },
    { 0xA3EC, "zone_mgr" },
    { 0xA3ED, "zone_radius" },
    { 0xA3EE, "zone_set_neutral" },
    { 0xA3EF, "zone_set_team" },
    { 0xA3F0, "zone_set_waiting" },
    { 0xA3F1, "zone_to_name" },
    { 0xA3F2, "zonecount" },
    { 0xA3F3, "zonedestroyedbytimer" },
    { 0xA3F4, "zonedestroyedinenemystr" },
    { 0xA3F5, "zoneduration" },
    { 0xA3F6, "zonemix" },
    { 0xA3F7, "zonemovetime" },
    { 0xA3F8, "zonerevealtime" },
    { 0xA3F9, "zones" },
    { 0xA3FA, "zonespawninginstr" },
    { 0xA3FB, "zonespawnqueue" },
    { 0xA3FC, "zoom" },
    { 0xA3FD, "zoom_to_radial_menu" },
    { 0xA3FE, "zoomin" },
    { 0xA3FF, "zoominsound" },
    { 0xA400, "zoomout" },
    { 0xA401, "zoomslam" },
//  { 0xA402, "" },
//  { 0xA403, "" },
//  { 0xA404, "" },
//  { 0xA405, "" },
//  { 0xA406, "" },
//  { 0xA407, "" },
//  { 0xA408, "" },
//  { 0xA409, "" },
//  { 0xA40A, "" },
//  { 0xA40B, "" },
//  { 0xA40C, "" },
//  { 0xA40D, "" },
//  { 0xA40E, "" },
//  { 0xA40F, "" },
//  { 0xA410, "" },
//  { 0xA411, "" },
//  { 0xA412, "" },
//  { 0xA413, "" },
//  { 0xA414, "" },
//  { 0xA415, "" },
//  { 0xA416, "" },
//  { 0xA417, "" },
//  { 0xA418, "" },
//  { 0xA419, "" },
//  { 0xA41A, "" },
//  { 0xA41B, "" },
//  { 0xA41C, "" },
//  { 0xA41D, "" },
//  { 0xA41E, "" },
//  { 0xA41F, "" },
//  { 0xA420, "" },
//  { 0xA421, "" },
//  { 0xA422, "" },
//  { 0xA423, "" },
//  { 0xA424, "" },
//  { 0xA425, "" },
//  { 0xA426, "" },
//  { 0xA427, "" },
//  { 0xA428, "" },
//  { 0xA429, "" },
//  { 0xA42A, "" },
//  { 0xA42B, "" },
//  { 0xA42C, "" },
//  { 0xA42D, "" },
//  { 0xA42E, "" },
//  { 0xA42F, "" },
//  { 0xA430, "" },
//  { 0xA431, "" },
//  { 0xA432, "" },
//  { 0xA433, "" },
//  { 0xA434, "" },
//  { 0xA435, "" },
//  { 0xA436, "" },
//  { 0xA437, "" },
//  { 0xA438, "" },
//  { 0xA439, "" },
//  { 0xA43A, "" },
//  { 0xA43B, "" },
//  { 0xA43C, "" },
//  { 0xA43D, "" },
//  { 0xA43E, "" },
//  { 0xA43F, "" },
//  { 0xA440, "" },
//  { 0xA441, "" },
//  { 0xA442, "" },
//  { 0xA443, "" },
//  { 0xA444, "" },
//  { 0xA445, "" },
//  { 0xA446, "" },
//  { 0xA447, "" },
//  { 0xA448, "" },
//  { 0xA449, "" },
//  { 0xA44A, "" },
//  { 0xA44B, "" },
//  { 0xA44C, "" },
//  { 0xA44D, "" },
//  { 0xA44E, "" },
//  { 0xA44F, "" },
//  { 0xA450, "" },
//  { 0xA451, "" },
//  { 0xA452, "" },
//  { 0xA453, "" },
//  { 0xA454, "" },
//  { 0xA455, "" },
//  { 0xA456, "" },
//  { 0xA457, "" },
//  { 0xA458, "" },
//  { 0xA459, "" },
//  { 0xA45A, "" },
//  { 0xA45B, "" },
//  { 0xA45C, "" },
//  { 0xA45D, "" },
//  { 0xA45E, "" },
//  { 0xA45F, "" },
//  { 0xA460, "" },
//  { 0xA461, "" },
//  { 0xA462, "" },
//  { 0xA463, "" },
//  { 0xA464, "" },
//  { 0xA465, "" },
//  { 0xA466, "" },
//  { 0xA467, "" },
//  { 0xA468, "" },
//  { 0xA469, "" },
//  { 0xA46A, "" },
//  { 0xA46B, "" },
//  { 0xA46C, "" },
//  { 0xA46D, "" },
//  { 0xA46E, "" },
//  { 0xA46F, "" },
//  { 0xA470, "" },
//  { 0xA471, "" },
//  { 0xA472, "" },
//  { 0xA473, "" },
//  { 0xA474, "" },
//  { 0xA475, "" },
//  { 0xA476, "" },
//  { 0xA477, "" },
//  { 0xA478, "" },
//  { 0xA479, "" },
//  { 0xA47A, "" },
//  { 0xA47B, "" },
//  { 0xA47C, "" },
//  { 0xA47D, "" },
//  { 0xA47E, "" },
//  { 0xA47F, "" },
//  { 0xA480, "" },
//  { 0xA481, "" },
//  { 0xA482, "" },
//  { 0xA483, "" },
//  { 0xA484, "" },
//  { 0xA485, "" },
//  { 0xA486, "" },
//  { 0xA487, "" },
//  { 0xA488, "" },
//  { 0xA489, "" },
//  { 0xA48A, "" },
//  { 0xA48B, "" },
//  { 0xA48C, "" },
//  { 0xA48D, "" },
//  { 0xA48E, "" },
//  { 0xA48F, "" },
//  { 0xA490, "" },
//  { 0xA491, "" },
//  { 0xA492, "" },
//  { 0xA493, "" },
//  { 0xA494, "" },
//  { 0xA495, "" },
//  { 0xA496, "" },
//  { 0xA497, "" },
//  { 0xA498, "" },
//  { 0xA499, "" },
//  { 0xA49A, "" },
//  { 0xA49B, "" },
//  { 0xA49C, "" },
//  { 0xA49D, "" },
//  { 0xA49E, "" },
//  { 0xA49F, "" },
//  { 0xA4A0, "" },
//  { 0xA4A1, "" },
//  { 0xA4A2, "" },
//  { 0xA4A3, "" },
//  { 0xA4A4, "" },
//  { 0xA4A5, "" },
//  { 0xA4A6, "" },
//  { 0xA4A7, "" },
//  { 0xA4A8, "" },
//  { 0xA4A9, "" },
//  { 0xA4AA, "" },
//  { 0xA4AB, "" },
//  { 0xA4AC, "" },
//  { 0xA4AD, "" },
//  { 0xA4AE, "" },
//  { 0xA4AF, "" },
//  { 0xA4B0, "" },
//  { 0xA4B1, "" },
//  { 0xA4B2, "" },
//  { 0xA4B3, "" },
//  { 0xA4B4, "" },
//  { 0xA4B5, "" },
//  { 0xA4B6, "" },
//  { 0xA4B7, "" },
//  { 0xA4B8, "" },
//  { 0xA4B9, "" },
//  { 0xA4BA, "" },
//  { 0xA4BB, "" },
//  { 0xA4BC, "" },
//  { 0xA4BD, "" },
//  { 0xA4BE, "" },
//  { 0xA4BF, "" },
//  { 0xA4C0, "" },
//  { 0xA4C1, "" },
//  { 0xA4C2, "" },
//  { 0xA4C3, "" },
//  { 0xA4C4, "" },
//  { 0xA4C5, "" },
//  { 0xA4C6, "" },
//  { 0xA4C7, "" },
//  { 0xA4C8, "" },
//  { 0xA4C9, "" },
//  { 0xA4CA, "" },
//  { 0xA4CB, "" },
//  { 0xA4CC, "" },
//  { 0xA4CD, "" },
//  { 0xA4CE, "" },
//  { 0xA4CF, "" },
//  { 0xA4D0, "" },
//  { 0xA4D1, "" },
//  { 0xA4D2, "" },
//  { 0xA4D3, "" },
//  { 0xA4D4, "" },
//  { 0xA4D5, "" },
//  { 0xA4D6, "" },
//  { 0xA4D7, "" },
//  { 0xA4D8, "" },
    { 0xA4D9, "character/character_sp_usmc_at4" },
    { 0xA4DA, "character/character_sp_usmc_james" },
    { 0xA4DB, "character/character_sp_usmc_ryan" },
    { 0xA4DC, "character/character_sp_usmc_sami" },
    { 0xA4DD, "character/character_sp_usmc_sami_goggles" },
    { 0xA4DE, "character/character_sp_usmc_zach" },
    { 0xA4DF, "character/character_sp_usmc_zach_goggles" },
    { 0xA4E0, "character/character_us_marine_ar" },
    { 0xA4E1, "character/character_us_marine_ar_lowlod" },
    { 0xA4E2, "character/character_us_marine_dress" },
    { 0xA4E3, "character/character_us_marine_dress_a" },
    { 0xA4E4, "character/character_us_marine_dress_b" },
    { 0xA4E5, "character/character_us_marine_dress_c" },
    { 0xA4E6, "character/character_us_marine_dress_d" },
    { 0xA4E7, "character/character_us_marine_dress_e" },
    { 0xA4E8, "character/character_us_marine_dress_f" },
    { 0xA4E9, "character/character_us_marine_dress_lowlod" },
    { 0xA4EA, "character/character_us_marine_seofob_ar" },
    { 0xA4EB, "character/character_us_marine_shotgun_lowlod" },
    { 0xA4EC, "character/character_us_marine_smg" },
    { 0xA4ED, "character/character_us_marine_smg_lowlod" },
    { 0xA4EE, "character/character_us_marine_smg_seo" },
    { 0xA4EF, "character/character_us_marine_smg_seointro" },
    { 0xA4F0, "character/mp_character_cloak_test" },
    { 0xA4F1, "character/mp_character_sentinel" },
    { 0xA4F2, "codescripts/character" },
    { 0xA4F3, "common_scripts/_artcommon" },
    { 0xA4F4, "common_scripts/_bcs_location_trigs" },
    { 0xA4F5, "common_scripts/_createfx" },
    { 0xA4F6, "common_scripts/_createfxmenu" },
    { 0xA4F7, "common_scripts/_destructible" },
    { 0xA4F8, "common_scripts/_dynamic_world" },
    { 0xA4F9, "common_scripts/_elevator" },
    { 0xA4FA, "common_scripts/_exploder" },
    { 0xA4FB, "common_scripts/_fx" },
    { 0xA4FC, "common_scripts/_pipes" },
    { 0xA4FD, "common_scripts/utility" },
    { 0xA4FE, "destructible_scripts/computer_01_destp" },
    { 0xA4FF, "destructible_scripts/container_plastic_72x56x48_01_destp" },
    { 0xA500, "destructible_scripts/container_plastic_beige_med_01_destp" },
    { 0xA501, "destructible_scripts/greece_spinning_displays" },
    { 0xA502, "destructible_scripts/powerbox_112x64_01_green_destp" },
    { 0xA503, "destructible_scripts/security_camera_scanner_destp" },
    { 0xA504, "destructible_scripts/toy_chicken" },
    { 0xA505, "destructible_scripts/toy_chicken_common" },
    { 0xA506, "destructible_scripts/toy_electricbox4" },
    { 0xA507, "destructible_scripts/toy_generator" },
    { 0xA508, "destructible_scripts/toy_generator_on" },
    { 0xA509, "destructible_scripts/toy_locker_double" },
    { 0xA50A, "destructible_scripts/vehicle_civ_domestic_sedan_01_glass" },
    { 0xA50B, "destructible_scripts/vehicle_civ_domestic_sedan_police_destpv" },
    { 0xA50C, "destructible_scripts/vehicle_civ_domestic_sedan_taxi_glass" },
    { 0xA50D, "destructible_scripts/vehicle_civ_smartcar_destpv" },
    { 0xA50E, "destructible_scripts/vehicle_luxurysedan" },
    { 0xA50F, "destructible_scripts/vehicle_luxurysedan_2008" },
    { 0xA510, "destructible_scripts/vehicle_pickup" },
    { 0xA511, "destructible_scripts/vehicle_suv_atlas_destpv" },
    { 0xA512, "destructible_scripts/wall_firebox_destp" },
    { 0xA513, "maps/_anim" },
    { 0xA514, "maps/_animatedmodels" },
    { 0xA515, "maps/_ar_view" },
    { 0xA516, "maps/_art" },
    { 0xA517, "maps/_autosave" },
    { 0xA518, "maps/_bobbing_boats" },
    { 0xA519, "maps/_breach" },
    { 0xA51A, "maps/_car_door_shield" },
    { 0xA51B, "maps/_cg_encounter_perf_monitor" },
    { 0xA51C, "maps/_chargeable_weapon" },
    { 0xA51D, "maps/_cloak" },
    { 0xA51E, "maps/_cloak_enemy_behavior" },
    { 0xA51F, "maps/_colors" },
    { 0xA520, "maps/_compass" },
    { 0xA521, "maps/_controlled_orbiting_drone" },
    { 0xA522, "maps/_controlled_sniperdrone" },
    { 0xA523, "maps/_coop" },
    { 0xA524, "maps/_createfx" },
    { 0xA525, "maps/_credits" },
    { 0xA526, "maps/_credits_autogen" },
    { 0xA527, "maps/_damagefeedback" },
    { 0xA528, "maps/_dds" },
    { 0xA529, "maps/_debug" },
    { 0xA52A, "maps/_deployablecoverai" },
    { 0xA52B, "maps/_detonategrenades" },
    { 0xA52C, "maps/_dog_control" },
    { 0xA52D, "maps/_dog_kinect" },
    { 0xA52E, "maps/_drone" },
    { 0xA52F, "maps/_drone_ai" },
    { 0xA530, "maps/_drone_base" },
    { 0xA531, "maps/_drone_civilian" },
    { 0xA532, "maps/_dshk_player" },
    { 0xA533, "maps/_endmission" },
    { 0xA534, "maps/_exo_climb" },
    { 0xA535, "maps/_exo_punch_door" },
    { 0xA536, "maps/_exo_shield_sp" },
    { 0xA537, "maps/_flashlight_cheap" },
    { 0xA538, "maps/_foam_bomb" },
    { 0xA539, "maps/_friendlyfire" },
    { 0xA53A, "maps/_gameskill" },
    { 0xA53B, "maps/_global_fx" },
    { 0xA53C, "maps/_global_fx_code" },
    { 0xA53D, "maps/_grapple" },
    { 0xA53E, "maps/_grapple_anim" },
    { 0xA53F, "maps/_grapple_traverse" },
    { 0xA540, "maps/_hand_signals" },
    { 0xA541, "maps/_helicopter_ai" },
    { 0xA542, "maps/_helicopter_globals" },
    { 0xA543, "maps/_high_speed_clouds" },
    { 0xA544, "maps/_hms_ai_utility" },
    { 0xA545, "maps/_hms_door_interact" },
    { 0xA546, "maps/_hms_greece_civilian" },
    { 0xA547, "maps/_hms_utility" },
    { 0xA548, "maps/_hud" },
    { 0xA549, "maps/_hud_util" },
    { 0xA54A, "maps/_idle" },
    { 0xA54B, "maps/_idle_phone" },
    { 0xA54C, "maps/_idle_smoke" },
    { 0xA54D, "maps/_intelligence" },
    { 0xA54E, "maps/_introscreen" },
    { 0xA54F, "maps/_inventory" },
    { 0xA550, "maps/_juggernaut" },
    { 0xA551, "maps/_lighting" },
    { 0xA552, "maps/_lights" },
    { 0xA553, "maps/_load" },
    { 0xA554, "maps/_loadout" },
    { 0xA555, "maps/_loadout_code" },
    { 0xA556, "maps/_mark_and_execute" },
    { 0xA557, "maps/_mech" },
    { 0xA558, "maps/_mech_aud" },
    { 0xA559, "maps/_mech_grapple" },
    { 0xA55A, "maps/_mg_penetration" },
    { 0xA55B, "maps/_mgturret" },
    { 0xA55C, "maps/_mgturret_auto_nonai" },
    { 0xA55D, "maps/_microdronelauncher" },
    { 0xA55E, "maps/_microwave_grenade" },
    { 0xA55F, "maps/_mocap_ar" },
    { 0xA560, "maps/_names" },
    { 0xA561, "maps/_nightvision" },
    { 0xA562, "maps/_patrol" },
    { 0xA563, "maps/_patrol_anims" },
    { 0xA564, "maps/_patrol_anims_active" },
    { 0xA565, "maps/_patrol_anims_casualkiller" },
    { 0xA566, "maps/_patrol_anims_creepwalk" },
    { 0xA567, "maps/_patrol_anims_patroljog" },
    { 0xA568, "maps/_patrol_cold_anims" },
    { 0xA569, "maps/_patrol_extended" },
    { 0xA56A, "maps/_player_boost_dash" },
    { 0xA56B, "maps/_player_boost_jump_anims" },
    { 0xA56C, "maps/_player_boost_jump_aud" },
    { 0xA56D, "maps/_player_death" },
    { 0xA56E, "maps/_player_exo" },
    { 0xA56F, "maps/_player_fastzip" },
    { 0xA570, "maps/_player_high_jump" },
    { 0xA571, "maps/_player_land_assist" },
    { 0xA572, "maps/_player_stats" },
    { 0xA573, "maps/_playermech_code" },
    { 0xA574, "maps/_pmove" },
    { 0xA575, "maps/_president" },
    { 0xA576, "maps/_props" },
    { 0xA577, "maps/_rambo" },
    { 0xA578, "maps/_riotshield" },
    { 0xA579, "maps/_sarray" },
    { 0xA57A, "maps/_shg_anim" },
    { 0xA57B, "maps/_shg_debug" },
    { 0xA57C, "maps/_shg_design_tools" },
    { 0xA57D, "maps/_shg_fx" },
    { 0xA57E, "maps/_shg_utility" },
    { 0xA57F, "maps/_slowmo_breach" },
    { 0xA580, "maps/_sniper_glint" },
    { 0xA581, "maps/_sniper_setup_ai" },
    { 0xA582, "maps/_sonicaoe" },
    { 0xA583, "maps/_sp_matchdata" },
    { 0xA584, "maps/_spawner" },
    { 0xA585, "maps/_stealth" },
    { 0xA586, "maps/_stealth_accuracy_friendly" },
    { 0xA587, "maps/_stealth_animation_funcs" },
    { 0xA588, "maps/_stealth_anims" },
    { 0xA589, "maps/_stealth_behavior_enemy" },
    { 0xA58A, "maps/_stealth_behavior_friendly" },
    { 0xA58B, "maps/_stealth_behavior_system" },
    { 0xA58C, "maps/_stealth_color_friendly" },
    { 0xA58D, "maps/_stealth_corpse_enemy" },
    { 0xA58E, "maps/_stealth_corpse_system" },
    { 0xA58F, "maps/_stealth_debug" },
    { 0xA590, "maps/_stealth_display" },
    { 0xA591, "maps/_stealth_event_enemy" },
    { 0xA592, "maps/_stealth_shared_utilities" },
    { 0xA593, "maps/_stealth_smartstance_friendly" },
    { 0xA594, "maps/_stealth_threat_enemy" },
    { 0xA595, "maps/_stealth_utility" },
    { 0xA596, "maps/_stealth_visibility_enemy" },
    { 0xA597, "maps/_stealth_visibility_friendly" },
    { 0xA598, "maps/_stealth_visibility_system" },
    { 0xA599, "maps/_stingerm7" },
    { 0xA59A, "maps/_stingerm7_greece" },
    { 0xA59B, "maps/_swim_ai" },
    { 0xA59C, "maps/_swim_ai_common" },
    { 0xA59D, "maps/_swim_player" },
    { 0xA59E, "maps/_tagging" },
    { 0xA59F, "maps/_target_lock" },
    { 0xA5A0, "maps/_treadfx" },
    { 0xA5A1, "maps/_trigger" },
    { 0xA5A2, "maps/_underwater" },
    { 0xA5A3, "maps/_upgrade_challenge" },
    { 0xA5A4, "maps/_upgrade_perks" },
    { 0xA5A5, "maps/_upgrade_system" },
    { 0xA5A6, "maps/_urgent_walk" },
    { 0xA5A7, "maps/_utility" },
    { 0xA5A8, "maps/_utility_code" },
    { 0xA5A9, "maps/_utility_dogs" },
    { 0xA5AA, "maps/_variable_grenade" },
    { 0xA5AB, "maps/_vehicle" },
    { 0xA5AC, "maps/_vehicle_aianim" },
    { 0xA5AD, "maps/_vehicle_code" },
    { 0xA5AE, "maps/_vehicle_free_drive" },
    { 0xA5AF, "maps/_vehicle_missile" },
    { 0xA5B0, "maps/_vehicle_shg" },
    { 0xA5B1, "maps/_vehicle_traffic" },
    { 0xA5B2, "maps/_vignette_util" },
    { 0xA5B3, "maps/_warzone_tactics" },
    { 0xA5B4, "maps/_water" },
    { 0xA5B5, "maps/_weapon_pdrone" },
    { 0xA5B6, "maps/_weather" },
    { 0xA5B7, "maps/betrayal_fx" },
    { 0xA5B8, "maps/betrayal_precache" },
    { 0xA5B9, "maps/captured_fx" },
    { 0xA5BA, "maps/captured_precache" },
    { 0xA5BB, "maps/crash_fx" },
    { 0xA5BC, "maps/crash_precache" },
    { 0xA5BD, "maps/credits_s1_fx" },
    { 0xA5BE, "maps/credits_s1_precache" },
    { 0xA5BF, "maps/detroit_fx" },
    { 0xA5C0, "maps/detroit_precache" },
    { 0xA5C1, "maps/df_baghdad_fx" },
    { 0xA5C2, "maps/df_baghdad_precache" },
    { 0xA5C3, "maps/df_fly_fx" },
    { 0xA5C4, "maps/df_fly_precache" },
    { 0xA5C5, "maps/finale_fx" },
    { 0xA5C6, "maps/finale_precache" },
    { 0xA5C7, "maps/fusion_fx" },
    { 0xA5C8, "maps/fusion_precache" },
    { 0xA5C9, "maps/greece_conf_center_fx" },
    { 0xA5CA, "maps/greece_ending_fx" },
    { 0xA5CB, "maps/greece_fx" },
    { 0xA5CC, "maps/greece_precache" },
    { 0xA5CD, "maps/greece_safehouse_fx" },
    { 0xA5CE, "maps/greece_sniper_scramble_fx" },
    { 0xA5CF, "maps/irons_estate_fx" },
    { 0xA5D0, "maps/irons_estate_precache" },
    { 0xA5D1, "maps/lab_fx" },
    { 0xA5D2, "maps/lab_precache" },
    { 0xA5D3, "maps/lagos_fx" },
    { 0xA5D4, "maps/lagos_precache" },
    { 0xA5D5, "maps/recovery_fx" },
    { 0xA5D6, "maps/recovery_precache" },
    { 0xA5D7, "maps/sanfran_b_fx" },
    { 0xA5D8, "maps/sanfran_b_precache" },
    { 0xA5D9, "maps/sanfran_fx" },
    { 0xA5DA, "maps/sanfran_precache" },
    { 0xA5DB, "maps/seoul_fx" },
    { 0xA5DC, "maps/seoul_precache" },
    { 0xA5DD, "mptype/mptype_cloak_test" },
    { 0xA5DE, "soundscripts/_ambient" },
    { 0xA5DF, "soundscripts/_audio" },
    { 0xA5E0, "soundscripts/_audio_dynamic_ambi" },
    { 0xA5E1, "soundscripts/_audio_mix_manager" },
    { 0xA5E2, "soundscripts/_audio_music" },
    { 0xA5E3, "soundscripts/_audio_presets_music" },
    { 0xA5E4, "soundscripts/_audio_presets_vehicles" },
    { 0xA5E5, "soundscripts/_audio_reverb" },
    { 0xA5E6, "soundscripts/_audio_stream_manager" },
    { 0xA5E7, "soundscripts/_audio_vehicle_manager" },
    { 0xA5E8, "soundscripts/_audio_vehicles" },
    { 0xA5E9, "soundscripts/_audio_whizby" },
    { 0xA5EA, "soundscripts/_audio_zone_manager" },
    { 0xA5EB, "soundscripts/_snd" },
    { 0xA5EC, "soundscripts/_snd_common" },
    { 0xA5ED, "soundscripts/_snd_debug_bayless" },
    { 0xA5EE, "soundscripts/_snd_debug_bina" },
    { 0xA5EF, "soundscripts/_snd_debug_blondin" },
    { 0xA5F0, "soundscripts/_snd_debug_caisley" },
    { 0xA5F1, "soundscripts/_snd_debug_gavazza" },
    { 0xA5F2, "soundscripts/_snd_debug_kilborn" },
    { 0xA5F3, "soundscripts/_snd_debug_loperfido" },
    { 0xA5F4, "soundscripts/_snd_debug_mcsweeney" },
    { 0xA5F5, "soundscripts/_snd_debug_mika" },
    { 0xA5F6, "soundscripts/_snd_debug_naas" },
    { 0xA5F7, "soundscripts/_snd_debug_nuniyants" },
    { 0xA5F8, "soundscripts/_snd_debug_swenson" },
    { 0xA5F9, "soundscripts/_snd_debug_veca" },
    { 0xA5FA, "soundscripts/_snd_filters" },
    { 0xA5FB, "soundscripts/_snd_foley" },
    { 0xA5FC, "soundscripts/_snd_hud" },
    { 0xA5FD, "soundscripts/_snd_pcap" },
    { 0xA5FE, "soundscripts/_snd_playsound" },
    { 0xA5FF, "soundscripts/_snd_timescale" },
    { 0xA600, "soundscripts/so_aud" },
    { 0xA601, "vehicle_scripts/_atlas_jet" },
    { 0xA602, "vehicle_scripts/_atlas_piranha" },
    { 0xA603, "vehicle_scripts/_atlas_suv" },
    { 0xA604, "vehicle_scripts/_atlas_van" },
    { 0xA605, "vehicle_scripts/_attack_drone" },
    { 0xA606, "vehicle_scripts/_attack_drone_aud" },
    { 0xA607, "vehicle_scripts/_attack_drone_common" },
    { 0xA608, "vehicle_scripts/_attack_drone_controllable" },
    { 0xA609, "vehicle_scripts/_attack_drone_individual" },
    { 0xA60A, "vehicle_scripts/_attack_drone_kamikaze" },
    { 0xA60B, "vehicle_scripts/_attack_drone_queen" },
    { 0xA60C, "vehicle_scripts/_attack_heli" },
    { 0xA60D, "vehicle_scripts/_chinese_brave_warrior" },
    { 0xA60E, "vehicle_scripts/_civ_boat" },
    { 0xA60F, "vehicle_scripts/_civ_boxtruck_ai" },
    { 0xA610, "vehicle_scripts/_civ_domestic_bus" },
    { 0xA611, "vehicle_scripts/_civ_domestic_economy_ai" },
    { 0xA612, "vehicle_scripts/_civ_domestic_minivan" },
    { 0xA613, "vehicle_scripts/_civ_domestic_sedan_01" },
    { 0xA614, "vehicle_scripts/_civ_domestic_sedan_police" },
    { 0xA615, "vehicle_scripts/_civ_domestic_sedan_taxi_01" },
    { 0xA616, "vehicle_scripts/_civ_domestic_sportscar_01" },
    { 0xA617, "vehicle_scripts/_civ_domestic_suv" },
    { 0xA618, "vehicle_scripts/_civ_domestic_truck" },
    { 0xA619, "vehicle_scripts/_civ_full_size_pickup_01_ai" },
    { 0xA61A, "vehicle_scripts/_civ_full_size_technical" },
    { 0xA61B, "vehicle_scripts/_civ_pickup_truck_01" },
    { 0xA61C, "vehicle_scripts/_civ_smartcar" },
    { 0xA61D, "vehicle_scripts/_civ_workvan" },
    { 0xA61E, "vehicle_scripts/_cover_drone" },
    { 0xA61F, "vehicle_scripts/_cover_drone_aud" },
    { 0xA620, "vehicle_scripts/_diveboat" },
    { 0xA621, "vehicle_scripts/_diveboat_aud" },
    { 0xA622, "vehicle_scripts/_empty" },
    { 0xA623, "vehicle_scripts/_ft101_tank" },
    { 0xA624, "vehicle_scripts/_gaz" },
    { 0xA625, "vehicle_scripts/_gaz_dshk" },
    { 0xA626, "vehicle_scripts/_gaz_dshk_aud" },
    { 0xA627, "vehicle_scripts/_generic_script_model_lagos" },
    { 0xA628, "vehicle_scripts/_havoc_missile_scripted" },
    { 0xA629, "vehicle_scripts/_hovertank" },
    { 0xA62A, "vehicle_scripts/_hovertank_aud" },
    { 0xA62B, "vehicle_scripts/_ind_semi_truck_fuel_tanker" },
    { 0xA62C, "vehicle_scripts/_jetbike" },
    { 0xA62D, "vehicle_scripts/_jetbike_aud" },
    { 0xA62E, "vehicle_scripts/_littlebird" },
    { 0xA62F, "vehicle_scripts/_littlebird_aud" },
    { 0xA630, "vehicle_scripts/_littlebird_landing" },
    { 0xA631, "vehicle_scripts/_littlebird_player" },
    { 0xA632, "vehicle_scripts/_mi17" },
    { 0xA633, "vehicle_scripts/_mi17_aud" },
    { 0xA634, "vehicle_scripts/_mi17_noai" },
    { 0xA635, "vehicle_scripts/_mig29" },
    { 0xA636, "vehicle_scripts/_mig29_controllable" },
    { 0xA637, "vehicle_scripts/_mil_cargo_truck" },
    { 0xA638, "vehicle_scripts/_pdrone" },
    { 0xA639, "vehicle_scripts/_pdrone_aud" },
    { 0xA63A, "vehicle_scripts/_pdrone_player" },
    { 0xA63B, "vehicle_scripts/_pdrone_player_aud" },
    { 0xA63C, "vehicle_scripts/_pdrone_security" },
    { 0xA63D, "vehicle_scripts/_pdrone_security_aud" },
    { 0xA63E, "vehicle_scripts/_pdrone_tactical_picker" },
    { 0xA63F, "vehicle_scripts/_pdrone_threat_sensor" },
    { 0xA640, "vehicle_scripts/_pitbull" },
    { 0xA641, "vehicle_scripts/_pitbull_aud" },
    { 0xA642, "vehicle_scripts/_razorback" },
    { 0xA643, "vehicle_scripts/_razorback_fx" },
    { 0xA644, "vehicle_scripts/_s19" },
    { 0xA645, "vehicle_scripts/_sentinel_survey_drone_hud" },
    { 0xA646, "vehicle_scripts/_shrike" },
    { 0xA647, "vehicle_scripts/_sidewinder_scripted" },
    { 0xA648, "vehicle_scripts/_slamraam" },
    { 0xA649, "vehicle_scripts/_sniper_drone" },
    { 0xA64A, "vehicle_scripts/_sniper_drone_aud" },
    { 0xA64B, "vehicle_scripts/_uk_delivery_truck" },
    { 0xA64C, "vehicle_scripts/_vehicle_missile_launcher_ai" },
    { 0xA64D, "vehicle_scripts/_vehicle_multiweapon_util" },
    { 0xA64E, "vehicle_scripts/_vehicle_turret_ai" },
    { 0xA64F, "vehicle_scripts/_vrap" },
    { 0xA650, "vehicle_scripts/_walker_tank" },
    { 0xA651, "vehicle_scripts/_x4walker_wheels" },
    { 0xA652, "vehicle_scripts/_x4walker_wheels_aud" },
    { 0xA653, "vehicle_scripts/_x4walker_wheels_turret" },
    { 0xA654, "vehicle_scripts/_x4walker_wheels_turret_aud" },
    { 0xA655, "vehicle_scripts/_x4walker_wheels_turret_closed" },
    { 0xA656, "vehicle_scripts/_x4walker_wheels_turret_closed_aud" },
    { 0xA657, "vehicle_scripts/_xh9_warbird" },
//  { 0xA658, "" },
//  { 0xA659, "" },
//  { 0xA65A, "" },
//  { 0xA65B, "" },
//  { 0xA65C, "" },
//  { 0xA65D, "" },
//  { 0xA65E, "" },
//  { 0xA65F, "" },
//  { 0xA660, "" },
//  { 0xA661, "" },
//  { 0xA662, "" },
//  { 0xA663, "" },
//  { 0xA664, "" },
//  { 0xA665, "" },
//  { 0xA666, "" },
//  { 0xA667, "" },
//  { 0xA668, "" },
//  { 0xA669, "" },
//  { 0xA66A, "" },
//  { 0xA66B, "" },
//  { 0xA66C, "" },
//  { 0xA66D, "" },
//  { 0xA66E, "" },
//  { 0xA66F, "" },
//  { 0xA670, "" },
//  { 0xA671, "" },
//  { 0xA672, "" },
//  { 0xA673, "" },
//  { 0xA674, "" },
//  { 0xA675, "" },
//  { 0xA676, "" },
//  { 0xA677, "" },
//  { 0xA678, "" },
//  { 0xA679, "" },
//  { 0xA67A, "" },
//  { 0xA67B, "" },
//  { 0xA67C, "" },
//  { 0xA67D, "" },
//  { 0xA67E, "" },
//  { 0xA67F, "" },
//  { 0xA680, "" },
//  { 0xA681, "" },
//  { 0xA682, "" },
//  { 0xA683, "" },
//  { 0xA684, "" },
//  { 0xA685, "" },
//  { 0xA686, "" },
//  { 0xA687, "" },
//  { 0xA688, "" },
//  { 0xA689, "" },
//  { 0xA68A, "" },
//  { 0xA68B, "" },
//  { 0xA68C, "" },
//  { 0xA68D, "" },
//  { 0xA68E, "" },
//  { 0xA68F, "" },
//  { 0xA690, "" },
//  { 0xA691, "" },
//  { 0xA692, "" },
//  { 0xA693, "" },
//  { 0xA694, "" },
//  { 0xA695, "" },
//  { 0xA696, "" },
//  { 0xA697, "" },
//  { 0xA698, "" },
//  { 0xA699, "" },
//  { 0xA69A, "" },
//  { 0xA69B, "" },
//  { 0xA69C, "" },
//  { 0xA69D, "" },
//  { 0xA69E, "" },
//  { 0xA69F, "" },
//  { 0xA6A0, "" },
//  { 0xA6A1, "" },
//  { 0xA6A2, "" },
//  { 0xA6A3, "" },
//  { 0xA6A4, "" },
//  { 0xA6A5, "" },
//  { 0xA6A6, "" },
//  { 0xA6A7, "" },
//  { 0xA6A8, "" },
//  { 0xA6A9, "" },
//  { 0xA6AA, "" },
//  { 0xA6AB, "" },
//  { 0xA6AC, "" },
//  { 0xA6AD, "" },
//  { 0xA6AE, "" },
//  { 0xA6AF, "" },
//  { 0xA6B0, "" },
//  { 0xA6B1, "" },
//  { 0xA6B2, "" },
//  { 0xA6B3, "" },
//  { 0xA6B4, "" },
//  { 0xA6B5, "" },
//  { 0xA6B6, "" },
//  { 0xA6B7, "" },
//  { 0xA6B8, "" },
//  { 0xA6B9, "" },
//  { 0xA6BA, "" },
//  { 0xA6BB, "" },
//  { 0xA6BC, "" },
//  { 0xA6BD, "" },
//  { 0xA6BE, "" },
//  { 0xA6BF, "" },
//  { 0xA6C0, "" },
//  { 0xA6C1, "" },
//  { 0xA6C2, "" },
//  { 0xA6C3, "" },
//  { 0xA6C4, "" },
//  { 0xA6C5, "" },
//  { 0xA6C6, "" },
//  { 0xA6C7, "" },
//  { 0xA6C8, "" },
//  { 0xA6C9, "" },
//  { 0xA6CA, "" },
//  { 0xA6CB, "" },
//  { 0xA6CC, "" },
//  { 0xA6CD, "" },
//  { 0xA6CE, "" },
//  { 0xA6CF, "" },
//  { 0xA6D0, "" },
//  { 0xA6D1, "" },
//  { 0xA6D2, "" },
//  { 0xA6D3, "" },
//  { 0xA6D4, "" },
//  { 0xA6D5, "" },
//  { 0xA6D6, "" },
//  { 0xA6D7, "" },
//  { 0xA6D8, "" },
//  { 0xA6D9, "" },
//  { 0xA6DA, "" },
//  { 0xA6DB, "" },
//  { 0xA6DC, "" },
//  { 0xA6DD, "" },
//  { 0xA6DE, "" },
//  { 0xA6DF, "" },
//  { 0xA6E0, "" },
//  { 0xA6E1, "" },
//  { 0xA6E2, "" },
//  { 0xA6E3, "" },
//  { 0xA6E4, "" },
//  { 0xA6E5, "" },
//  { 0xA6E6, "" },
//  { 0xA6E7, "" },
//  { 0xA6E8, "" },
//  { 0xA6E9, "" },
//  { 0xA6EA, "" },
//  { 0xA6EB, "" },
//  { 0xA6EC, "" },
//  { 0xA6ED, "" },
//  { 0xA6EE, "" },
//  { 0xA6EF, "" },
//  { 0xA6F0, "" },
//  { 0xA6F1, "" },
//  { 0xA6F2, "" },
//  { 0xA6F3, "" },
//  { 0xA6F4, "" },
//  { 0xA6F5, "" },
//  { 0xA6F6, "" },
//  { 0xA6F7, "" },
//  { 0xA6F8, "" },
//  { 0xA6F9, "" },
//  { 0xA6FA, "" },
//  { 0xA6FB, "" },
    { 0xA6FC, "maps/createart/mp_vlobby_room_art" },
    { 0xA6FD, "maps/createart/mp_vlobby_room_fog" },
    { 0xA6FE, "maps/createart/mp_vlobby_room_fog_hdr" },
//  { 0xA6FF, "" },
//  { 0xA700, "" },
//  { 0xA701, "" },
//  { 0xA702, "" },
//  { 0xA703, "" },
//  { 0xA704, "" },
//  { 0xA705, "" },
//  { 0xA706, "" },
//  { 0xA707, "" },
//  { 0xA708, "" },
//  { 0xA709, "" },
//  { 0xA70A, "" },
//  { 0xA70B, "" },
//  { 0xA70C, "" },
//  { 0xA70D, "" },
//  { 0xA70E, "" },
//  { 0xA70F, "" },
//  { 0xA710, "" },
//  { 0xA711, "" },
//  { 0xA712, "" },
//  { 0xA713, "" },
//  { 0xA714, "" },
//  { 0xA715, "" },
//  { 0xA716, "" },
//  { 0xA717, "" },
//  { 0xA718, "" },
//  { 0xA719, "" },
//  { 0xA71A, "" },
//  { 0xA71B, "" },
//  { 0xA71C, "" },
//  { 0xA71D, "" },
//  { 0xA71E, "" },
//  { 0xA71F, "" },
//  { 0xA720, "" },
//  { 0xA721, "" },
//  { 0xA722, "" },
    { 0xA723, "maps/mp/_adrenaline" },
//  { 0xA724, "" },
//  { 0xA725, "" },
//  { 0xA726, "" },
//  { 0xA727, "" },
//  { 0xA728, "" },
//  { 0xA729, "" },
//  { 0xA72A, "" },
//  { 0xA72B, "" },
//  { 0xA72C, "" },
    { 0xA72D, "maps/mp/_aerial_pathnodes" },
    { 0xA72E, "maps/mp/_animatedmodels" },
    { 0xA72F, "maps/mp/_areas" },
    { 0xA730, "maps/mp/_art" },
    { 0xA731, "maps/mp/_audio" },
    { 0xA732, "maps/mp/_awards" },
    { 0xA733, "maps/mp/_braggingrights" },
    { 0xA734, "maps/mp/_compass" },
    { 0xA735, "maps/mp/_createfx" },
    { 0xA736, "maps/mp/_crib" },
    { 0xA737, "maps/mp/_destructables" },
    { 0xA738, "maps/mp/_dynamic_events" },
    { 0xA739, "maps/mp/_empgrenade" },
    { 0xA73A, "maps/mp/_entityheadicons" },
    { 0xA73B, "maps/mp/_events" },
    { 0xA73C, "maps/mp/_exo_battery" },
    { 0xA73D, "maps/mp/_exo_cloak" },
    { 0xA73E, "maps/mp/_exo_hover" },
    { 0xA73F, "maps/mp/_exo_mute" },
    { 0xA740, "maps/mp/_exo_ping" },
    { 0xA741, "maps/mp/_exo_repulsor" },
    { 0xA742, "maps/mp/_exo_shield" },
    { 0xA743, "maps/mp/_exo_suit" },
    { 0xA744, "maps/mp/_exocrossbow" },
    { 0xA745, "maps/mp/_exoknife" },
    { 0xA746, "maps/mp/_explosive_drone" },
    { 0xA747, "maps/mp/_explosive_gel" },
    { 0xA748, "maps/mp/_extrahealth" },
    { 0xA749, "maps/mp/_fastheal" },
    { 0xA74A, "maps/mp/_flashgrenades" },
    { 0xA74B, "maps/mp/_fx" },
    { 0xA74C, "maps/mp/_global_fx" },
    { 0xA74D, "maps/mp/_global_fx_code" },
    { 0xA74E, "maps/mp/_lasersight" },
    { 0xA74F, "maps/mp/_load" },
    { 0xA750, "maps/mp/_lsrmissileguidance" },
    { 0xA751, "maps/mp/_matchdata" },
    { 0xA752, "maps/mp/_menus" },
    { 0xA753, "maps/mp/_microdronelauncher" },
    { 0xA754, "maps/mp/_movers" },
    { 0xA755, "maps/mp/_mp_lights" },
    { 0xA756, "maps/mp/_mutebomb" },
    { 0xA757, "maps/mp/_na45" },
    { 0xA758, "maps/mp/_opticsthermal" },
    { 0xA759, "maps/mp/_reinforcements" },
    { 0xA75A, "maps/mp/_riotshield" },
    { 0xA75B, "maps/mp/_scoreboard" },
    { 0xA75C, "maps/mp/_shutter" },
    { 0xA75D, "maps/mp/_snd_common_mp" },
    { 0xA75E, "maps/mp/_stinger" },
    { 0xA75F, "maps/mp/_stingerm7" },
    { 0xA760, "maps/mp/_stock" },
    { 0xA761, "maps/mp/_target_enhancer" },
    { 0xA762, "maps/mp/_teleport" },
    { 0xA763, "maps/mp/_threatdetection" },
    { 0xA764, "maps/mp/_tracking_drone" },
    { 0xA765, "maps/mp/_trackrounds" },
    { 0xA766, "maps/mp/_tridrone" },
    { 0xA767, "maps/mp/_utility" },
    { 0xA768, "maps/mp/_vl_base" },
    { 0xA769, "maps/mp/_vl_camera" },
    { 0xA76A, "maps/mp/_vl_firingrange" },
    { 0xA76B, "maps/mp/_vl_selfiebooth" },
    { 0xA76C, "maps/mp/_water" },
    { 0xA76D, "maps/mp/_zipline" },
    { 0xA76E, "maps/mp/mp_comeback_fx" },
    { 0xA76F, "maps/mp/mp_comeback_precache" },
    { 0xA770, "maps/mp/mp_detroit_fx" },
    { 0xA771, "maps/mp/mp_detroit_precache" },
//  { 0xA772, "" },
    { 0xA773, "maps/mp/mp_greenband_precache" },
    { 0xA774, "maps/mp/mp_instinct_fx" },
    { 0xA775, "maps/mp/mp_instinct_precache" },
    { 0xA776, "maps/mp/mp_lab2_fx" },
    { 0xA777, "maps/mp/mp_lab2_precache" },
    { 0xA778, "maps/mp/mp_laser2_fx" },
    { 0xA779, "maps/mp/mp_laser2_precache" },
    { 0xA77A, "maps/mp/mp_levity_fx" },
    { 0xA77B, "maps/mp/mp_levity_precache" },
    { 0xA77C, "maps/mp/mp_prison_fx" },
    { 0xA77D, "maps/mp/mp_prison_precache" },
    { 0xA77E, "maps/mp/mp_prison_z_fx" },
    { 0xA77F, "maps/mp/mp_prison_z_precache" },
    { 0xA780, "maps/mp/mp_recovery_fx" },
    { 0xA781, "maps/mp/mp_recovery_precache" },
    { 0xA782, "maps/mp/mp_refraction_fx" },
    { 0xA783, "maps/mp/mp_refraction_precache" },
    { 0xA784, "maps/mp/mp_solar_fx" },
    { 0xA785, "maps/mp/mp_solar_precache" },
    { 0xA786, "maps/mp/mp_terrace_fx" },
    { 0xA787, "maps/mp/mp_terrace_precache" },
    { 0xA788, "maps/mp/mp_venus_fx" },
    { 0xA789, "maps/mp/mp_venus_precache" },
    { 0xA78A, "maps/mp/mp_vlobby_room_fx" },
    { 0xA78B, "maps/mp/mp_vlobby_room_precache" },
    { 0xA78C, "maps/mp/gametypes/_battlebuddy" },
    { 0xA78D, "maps/mp/gametypes/_battlechatter_mp" },
    { 0xA78E, "maps/mp/gametypes/_class" },
    { 0xA78F, "maps/mp/gametypes/_clientids" },
    { 0xA790, "maps/mp/gametypes/_damage" },
    { 0xA791, "maps/mp/gametypes/_damagefeedback" },
    { 0xA792, "maps/mp/gametypes/_deathicons" },
    { 0xA793, "maps/mp/gametypes/_dev" },
    { 0xA794, "maps/mp/gametypes/_equipment" },
    { 0xA795, "maps/mp/gametypes/_friendicons" },
    { 0xA796, "maps/mp/gametypes/_gamelogic" },
    { 0xA797, "maps/mp/gametypes/_gameobjects" },
    { 0xA798, "maps/mp/gametypes/_gamescores" },
    { 0xA799, "maps/mp/gametypes/_globalentities" },
    { 0xA79A, "maps/mp/gametypes/_globallogic" },
    { 0xA79B, "maps/mp/gametypes/_hardpoints" },
    { 0xA79C, "maps/mp/gametypes/_healthoverlay" },
    { 0xA79D, "maps/mp/gametypes/_high_jump_mp" },
    { 0xA79E, "maps/mp/gametypes/_horde_armory" },
    { 0xA79F, "maps/mp/gametypes/_horde_crates" },
    { 0xA7A0, "maps/mp/gametypes/_horde_dialog" },
    { 0xA7A1, "maps/mp/gametypes/_horde_drones" },
    { 0xA7A2, "maps/mp/gametypes/_horde_laststand" },
    { 0xA7A3, "maps/mp/gametypes/_horde_sentry" },
    { 0xA7A4, "maps/mp/gametypes/_horde_smart_grenade" },
    { 0xA7A5, "maps/mp/gametypes/_horde_util" },
    { 0xA7A6, "maps/mp/gametypes/_horde_zombies" },
    { 0xA7A7, "maps/mp/gametypes/_hostmigration" },
    { 0xA7A8, "maps/mp/gametypes/_hud" },
    { 0xA7A9, "maps/mp/gametypes/_hud_message" },
    { 0xA7AA, "maps/mp/gametypes/_hud_util" },
    { 0xA7AB, "maps/mp/gametypes/_killcam" },
    { 0xA7AC, "maps/mp/gametypes/_menus" },
    { 0xA7AD, "maps/mp/gametypes/_misions" },
    { 0xA7AE, "maps/mp/gametypes/_music_and_dialog" },
    { 0xA7AF, "maps/mp/gametypes/_objpoints" },
    { 0xA7B0, "maps/mp/gametypes/_orbital" },
    { 0xA7B1, "maps/mp/gametypes/_persistence" },
    { 0xA7B2, "maps/mp/gametypes/_player_boost_jump_mp" },
    { 0xA7B3, "maps/mp/gametypes/_playercards" },
    { 0xA7B4, "maps/mp/gametypes/_playerlogic" },
    { 0xA7B5, "maps/mp/gametypes/_portable_radar" },
    { 0xA7B6, "maps/mp/gametypes/_quickmessages" },
    { 0xA7B7, "maps/mp/gametypes/_rank" },
    { 0xA7B8, "maps/mp/gametypes/_scrambler" },
    { 0xA7B9, "maps/mp/gametypes/_serversettings" },
    { 0xA7BA, "maps/mp/gametypes/_shellshock" },
    { 0xA7BB, "maps/mp/gametypes/_spawnfactor" },
    { 0xA7BC, "maps/mp/gametypes/_spawnlogic" },
    { 0xA7BD, "maps/mp/gametypes/_spawnscoring" },
    { 0xA7BE, "maps/mp/gametypes/_spectating" },
    { 0xA7BF, "maps/mp/gametypes/_teams" },
    { 0xA7C0, "maps/mp/gametypes/_tweakables" },
    { 0xA7C1, "maps/mp/gametypes/_weapons" },
    { 0xA7C2, "maps/mp/killstreaks/_aerial_utility" },
    { 0xA7C3, "maps/mp/killstreaks/_agent_killstreak" },
    { 0xA7C4, "maps/mp/killstreaks/_airdrop" },
    { 0xA7C5, "maps/mp/killstreaks/_airstrike" },
    { 0xA7C6, "maps/mp/killstreaks/_assaultdrone_ai" },
    { 0xA7C7, "maps/mp/killstreaks/_autosentry" },
    { 0xA7C8, "maps/mp/killstreaks/_coop_util" },
    { 0xA7C9, "maps/mp/killstreaks/_dog_killstreak" },
    { 0xA7CA, "maps/mp/killstreaks/_drone_assault" },
    { 0xA7CB, "maps/mp/killstreaks/_drone_carepackage" },
    { 0xA7CC, "maps/mp/killstreaks/_drone_common" },
    { 0xA7CD, "maps/mp/killstreaks/_drone_recon" },
    { 0xA7CE, "maps/mp/killstreaks/_emp" },
    { 0xA7CF, "maps/mp/killstreaks/_juggernaut" },
    { 0xA7D0, "maps/mp/killstreaks/_killstreaks" },
    { 0xA7D1, "maps/mp/killstreaks/_killstreaks_init" },
    { 0xA7D2, "maps/mp/killstreaks/_marking_util" },
    { 0xA7D3, "maps/mp/killstreaks/_missile_strike" },
    { 0xA7D4, "maps/mp/killstreaks/_nuke" },
    { 0xA7D5, "maps/mp/killstreaks/_orbital_carepackage" },
    { 0xA7D6, "maps/mp/killstreaks/_orbital_strike" },
    { 0xA7D7, "maps/mp/killstreaks/_orbital_util" },
    { 0xA7D8, "maps/mp/killstreaks/_orbitalsupport" },
    { 0xA7D9, "maps/mp/killstreaks/_placeable" },
    { 0xA7DA, "maps/mp/killstreaks/_remoteturret" },
    { 0xA7DB, "maps/mp/killstreaks/_rippedturret" },
    { 0xA7DC, "maps/mp/killstreaks/_teamammorefill" },
    { 0xA7DD, "maps/mp/killstreaks/_uav" },
    { 0xA7DE, "maps/mp/killstreaks/_warbird" },
    { 0xA7DF, "maps/mp/killstreaks/streak_mp_comeback" },
    { 0xA7E0, "maps/mp/killstreaks/streak_mp_detroit" },
    { 0xA7E1, "maps/mp/killstreaks/streak_mp_instinct" },
    { 0xA7E2, "maps/mp/killstreaks/streak_mp_laser2" },
    { 0xA7E3, "maps/mp/killstreaks/streak_mp_prison" },
    { 0xA7E4, "maps/mp/killstreaks/streak_mp_recovery" },
    { 0xA7E5, "maps/mp/killstreaks/streak_mp_refraction" },
    { 0xA7E6, "maps/mp/killstreaks/streak_mp_solar" },
    { 0xA7E7, "maps/mp/killstreaks/streak_mp_terrace" },
    { 0xA7E8, "maps/mp/perks/_perkfunctions" },
    { 0xA7E9, "maps/mp/perks/_perks" },
}};

} // namespace xsk::gsc::h2
